/* automatically generated by rust-bindgen 0.71.1 */

#[repr(C)]
#[derive(Copy, Clone, Debug, Default, Eq, Hash, Ord, PartialEq, PartialOrd)]
pub struct __BindgenBitfieldUnit<Storage> {
    storage: Storage,
}
impl<Storage> __BindgenBitfieldUnit<Storage> {
    #[inline]
    pub const fn new(storage: Storage) -> Self {
        Self { storage }
    }
}
impl<Storage> __BindgenBitfieldUnit<Storage>
where
    Storage: AsRef<[u8]> + AsMut<[u8]>,
{
    #[inline]
    fn extract_bit(byte: u8, index: usize) -> bool {
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        byte & mask == mask
    }
    #[inline]
    pub fn get_bit(&self, index: usize) -> bool {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = self.storage.as_ref()[byte_index];
        Self::extract_bit(byte, index)
    }
    #[inline]
    pub unsafe fn raw_get_bit(this: *const Self, index: usize) -> bool {
        debug_assert!(index / 8 < core::mem::size_of::<Storage>());
        let byte_index = index / 8;
        let byte = *(core::ptr::addr_of!((*this).storage) as *const u8).offset(byte_index as isize);
        Self::extract_bit(byte, index)
    }
    #[inline]
    fn change_bit(byte: u8, index: usize, val: bool) -> u8 {
        let bit_index = if cfg!(target_endian = "big") {
            7 - (index % 8)
        } else {
            index % 8
        };
        let mask = 1 << bit_index;
        if val {
            byte | mask
        } else {
            byte & !mask
        }
    }
    #[inline]
    pub fn set_bit(&mut self, index: usize, val: bool) {
        debug_assert!(index / 8 < self.storage.as_ref().len());
        let byte_index = index / 8;
        let byte = &mut self.storage.as_mut()[byte_index];
        *byte = Self::change_bit(*byte, index, val);
    }
    #[inline]
    pub unsafe fn raw_set_bit(this: *mut Self, index: usize, val: bool) {
        debug_assert!(index / 8 < core::mem::size_of::<Storage>());
        let byte_index = index / 8;
        let byte =
            (core::ptr::addr_of_mut!((*this).storage) as *mut u8).offset(byte_index as isize);
        *byte = Self::change_bit(*byte, index, val);
    }
    #[inline]
    pub fn get(&self, bit_offset: usize, bit_width: u8) -> u64 {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        let mut val = 0;
        for i in 0..(bit_width as usize) {
            if self.get_bit(i + bit_offset) {
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                val |= 1 << index;
            }
        }
        val
    }
    #[inline]
    pub unsafe fn raw_get(this: *const Self, bit_offset: usize, bit_width: u8) -> u64 {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < core::mem::size_of::<Storage>());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= core::mem::size_of::<Storage>());
        let mut val = 0;
        for i in 0..(bit_width as usize) {
            if Self::raw_get_bit(this, i + bit_offset) {
                let index = if cfg!(target_endian = "big") {
                    bit_width as usize - 1 - i
                } else {
                    i
                };
                val |= 1 << index;
            }
        }
        val
    }
    #[inline]
    pub fn set(&mut self, bit_offset: usize, bit_width: u8, val: u64) {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < self.storage.as_ref().len());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= self.storage.as_ref().len());
        for i in 0..(bit_width as usize) {
            let mask = 1 << i;
            let val_bit_is_set = val & mask == mask;
            let index = if cfg!(target_endian = "big") {
                bit_width as usize - 1 - i
            } else {
                i
            };
            self.set_bit(index + bit_offset, val_bit_is_set);
        }
    }
    #[inline]
    pub unsafe fn raw_set(this: *mut Self, bit_offset: usize, bit_width: u8, val: u64) {
        debug_assert!(bit_width <= 64);
        debug_assert!(bit_offset / 8 < core::mem::size_of::<Storage>());
        debug_assert!((bit_offset + (bit_width as usize)) / 8 <= core::mem::size_of::<Storage>());
        for i in 0..(bit_width as usize) {
            let mask = 1 << i;
            let val_bit_is_set = val & mask == mask;
            let index = if cfg!(target_endian = "big") {
                bit_width as usize - 1 - i
            } else {
                i
            };
            Self::raw_set_bit(this, index + bit_offset, val_bit_is_set);
        }
    }
}
#[repr(C)]
#[derive(Default)]
pub struct __IncompleteArrayField<T>(::std::marker::PhantomData<T>, [T; 0]);
impl<T> __IncompleteArrayField<T> {
    #[inline]
    pub const fn new() -> Self {
        __IncompleteArrayField(::std::marker::PhantomData, [])
    }
    #[inline]
    pub fn as_ptr(&self) -> *const T {
        self as *const _ as *const T
    }
    #[inline]
    pub fn as_mut_ptr(&mut self) -> *mut T {
        self as *mut _ as *mut T
    }
    #[inline]
    pub unsafe fn as_slice(&self, len: usize) -> &[T] {
        ::std::slice::from_raw_parts(self.as_ptr(), len)
    }
    #[inline]
    pub unsafe fn as_mut_slice(&mut self, len: usize) -> &mut [T] {
        ::std::slice::from_raw_parts_mut(self.as_mut_ptr(), len)
    }
}
impl<T> ::std::fmt::Debug for __IncompleteArrayField<T> {
    fn fmt(&self, fmt: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        fmt.write_str("__IncompleteArrayField")
    }
}
#[repr(C)]
pub struct __BindgenUnionField<T>(::std::marker::PhantomData<T>);
impl<T> __BindgenUnionField<T> {
    #[inline]
    pub const fn new() -> Self {
        __BindgenUnionField(::std::marker::PhantomData)
    }
    #[inline]
    pub unsafe fn as_ref(&self) -> &T {
        ::std::mem::transmute(self)
    }
    #[inline]
    pub unsafe fn as_mut(&mut self) -> &mut T {
        ::std::mem::transmute(self)
    }
}
impl<T> ::std::default::Default for __BindgenUnionField<T> {
    #[inline]
    fn default() -> Self {
        Self::new()
    }
}
impl<T> ::std::clone::Clone for __BindgenUnionField<T> {
    #[inline]
    fn clone(&self) -> Self {
        *self
    }
}
impl<T> ::std::marker::Copy for __BindgenUnionField<T> {}
impl<T> ::std::fmt::Debug for __BindgenUnionField<T> {
    fn fmt(&self, fmt: &mut ::std::fmt::Formatter<'_>) -> ::std::fmt::Result {
        fmt.write_str("__BindgenUnionField")
    }
}
impl<T> ::std::hash::Hash for __BindgenUnionField<T> {
    fn hash<H: ::std::hash::Hasher>(&self, _state: &mut H) {}
}
impl<T> ::std::cmp::PartialEq for __BindgenUnionField<T> {
    fn eq(&self, _other: &__BindgenUnionField<T>) -> bool {
        true
    }
}
impl<T> ::std::cmp::Eq for __BindgenUnionField<T> {}
pub const WINAPI_FAMILY_PC_APP: u32 = 2;
pub const WINAPI_FAMILY_PHONE_APP: u32 = 3;
pub const WINAPI_FAMILY_SYSTEM: u32 = 4;
pub const WINAPI_FAMILY_SERVER: u32 = 5;
pub const WINAPI_FAMILY_GAMES: u32 = 6;
pub const WINAPI_FAMILY_DESKTOP_APP: u32 = 100;
pub const WINAPI_FAMILY_APP: u32 = 2;
pub const WINAPI_FAMILY: u32 = 100;
pub const _WIN32_WINNT_NT4: u32 = 1024;
pub const _WIN32_WINNT_WIN2K: u32 = 1280;
pub const _WIN32_WINNT_WINXP: u32 = 1281;
pub const _WIN32_WINNT_WS03: u32 = 1282;
pub const _WIN32_WINNT_WIN6: u32 = 1536;
pub const _WIN32_WINNT_VISTA: u32 = 1536;
pub const _WIN32_WINNT_WS08: u32 = 1536;
pub const _WIN32_WINNT_LONGHORN: u32 = 1536;
pub const _WIN32_WINNT_WIN7: u32 = 1537;
pub const _WIN32_WINNT_WIN8: u32 = 1538;
pub const _WIN32_WINNT_WINBLUE: u32 = 1539;
pub const _WIN32_WINNT_WINTHRESHOLD: u32 = 2560;
pub const _WIN32_WINNT_WIN10: u32 = 2560;
pub const _WIN32_IE_IE20: u32 = 512;
pub const _WIN32_IE_IE30: u32 = 768;
pub const _WIN32_IE_IE302: u32 = 770;
pub const _WIN32_IE_IE40: u32 = 1024;
pub const _WIN32_IE_IE401: u32 = 1025;
pub const _WIN32_IE_IE50: u32 = 1280;
pub const _WIN32_IE_IE501: u32 = 1281;
pub const _WIN32_IE_IE55: u32 = 1360;
pub const _WIN32_IE_IE60: u32 = 1536;
pub const _WIN32_IE_IE60SP1: u32 = 1537;
pub const _WIN32_IE_IE60SP2: u32 = 1539;
pub const _WIN32_IE_IE70: u32 = 1792;
pub const _WIN32_IE_IE80: u32 = 2048;
pub const _WIN32_IE_IE90: u32 = 2304;
pub const _WIN32_IE_IE100: u32 = 2560;
pub const _WIN32_IE_IE110: u32 = 2560;
pub const _WIN32_IE_NT4: u32 = 512;
pub const _WIN32_IE_NT4SP1: u32 = 512;
pub const _WIN32_IE_NT4SP2: u32 = 512;
pub const _WIN32_IE_NT4SP3: u32 = 770;
pub const _WIN32_IE_NT4SP4: u32 = 1025;
pub const _WIN32_IE_NT4SP5: u32 = 1025;
pub const _WIN32_IE_NT4SP6: u32 = 1280;
pub const _WIN32_IE_WIN98: u32 = 1025;
pub const _WIN32_IE_WIN98SE: u32 = 1280;
pub const _WIN32_IE_WINME: u32 = 1360;
pub const _WIN32_IE_WIN2K: u32 = 1281;
pub const _WIN32_IE_WIN2KSP1: u32 = 1281;
pub const _WIN32_IE_WIN2KSP2: u32 = 1281;
pub const _WIN32_IE_WIN2KSP3: u32 = 1281;
pub const _WIN32_IE_WIN2KSP4: u32 = 1281;
pub const _WIN32_IE_XP: u32 = 1536;
pub const _WIN32_IE_XPSP1: u32 = 1537;
pub const _WIN32_IE_XPSP2: u32 = 1539;
pub const _WIN32_IE_WS03: u32 = 1538;
pub const _WIN32_IE_WS03SP1: u32 = 1539;
pub const _WIN32_IE_WIN6: u32 = 1792;
pub const _WIN32_IE_LONGHORN: u32 = 1792;
pub const _WIN32_IE_WIN7: u32 = 2048;
pub const _WIN32_IE_WIN8: u32 = 2560;
pub const _WIN32_IE_WINBLUE: u32 = 2560;
pub const _WIN32_IE_WINTHRESHOLD: u32 = 2560;
pub const _WIN32_IE_WIN10: u32 = 2560;
pub const NTDDI_WIN4: u32 = 67108864;
pub const NTDDI_WIN2K: u32 = 83886080;
pub const NTDDI_WIN2KSP1: u32 = 83886336;
pub const NTDDI_WIN2KSP2: u32 = 83886592;
pub const NTDDI_WIN2KSP3: u32 = 83886848;
pub const NTDDI_WIN2KSP4: u32 = 83887104;
pub const NTDDI_WINXP: u32 = 83951616;
pub const NTDDI_WINXPSP1: u32 = 83951872;
pub const NTDDI_WINXPSP2: u32 = 83952128;
pub const NTDDI_WINXPSP3: u32 = 83952384;
pub const NTDDI_WINXPSP4: u32 = 83952640;
pub const NTDDI_WS03: u32 = 84017152;
pub const NTDDI_WS03SP1: u32 = 84017408;
pub const NTDDI_WS03SP2: u32 = 84017664;
pub const NTDDI_WS03SP3: u32 = 84017920;
pub const NTDDI_WS03SP4: u32 = 84018176;
pub const NTDDI_WIN6: u32 = 100663296;
pub const NTDDI_WIN6SP1: u32 = 100663552;
pub const NTDDI_WIN6SP2: u32 = 100663808;
pub const NTDDI_WIN6SP3: u32 = 100664064;
pub const NTDDI_WIN6SP4: u32 = 100664320;
pub const NTDDI_VISTA: u32 = 100663296;
pub const NTDDI_VISTASP1: u32 = 100663552;
pub const NTDDI_VISTASP2: u32 = 100663808;
pub const NTDDI_VISTASP3: u32 = 100664064;
pub const NTDDI_VISTASP4: u32 = 100664320;
pub const NTDDI_LONGHORN: u32 = 100663296;
pub const NTDDI_WS08: u32 = 100663552;
pub const NTDDI_WS08SP2: u32 = 100663808;
pub const NTDDI_WS08SP3: u32 = 100664064;
pub const NTDDI_WS08SP4: u32 = 100664320;
pub const NTDDI_WIN7: u32 = 100728832;
pub const NTDDI_WIN8: u32 = 100794368;
pub const NTDDI_WINBLUE: u32 = 100859904;
pub const NTDDI_WINTHRESHOLD: u32 = 167772160;
pub const NTDDI_WIN10: u32 = 167772160;
pub const NTDDI_WIN10_TH2: u32 = 167772161;
pub const NTDDI_WIN10_RS1: u32 = 167772162;
pub const NTDDI_WIN10_RS2: u32 = 167772163;
pub const NTDDI_WIN10_RS3: u32 = 167772164;
pub const NTDDI_WIN10_RS4: u32 = 167772165;
pub const NTDDI_WIN10_RS5: u32 = 167772166;
pub const NTDDI_WIN10_19H1: u32 = 167772167;
pub const NTDDI_WIN10_VB: u32 = 167772168;
pub const NTDDI_WIN10_MN: u32 = 167772169;
pub const NTDDI_WIN10_FE: u32 = 167772170;
pub const NTDDI_WIN10_CO: u32 = 167772171;
pub const WDK_NTDDI_VERSION: u32 = 167772171;
pub const OSVERSION_MASK: u32 = 4294901760;
pub const SPVERSION_MASK: u32 = 65280;
pub const SUBVERSION_MASK: u32 = 255;
pub const _WIN32_WINNT: u32 = 2560;
pub const NTDDI_VERSION: u32 = 167772171;
pub const WINVER: u32 = 2560;
pub const _WIN32_IE: u32 = 2560;
pub const _VCRT_COMPILER_PREPROCESSOR: u32 = 1;
pub const _SAL_VERSION: u32 = 20;
pub const __SAL_H_VERSION: u32 = 180000000;
pub const _USE_DECLSPECS_FOR_SAL: u32 = 0;
pub const _USE_ATTRIBUTES_FOR_SAL: u32 = 0;
pub const _CRT_PACKING: u32 = 8;
pub const _HAS_EXCEPTIONS: u32 = 1;
pub const _STL_LANG: u32 = 0;
pub const _HAS_CXX17: u32 = 0;
pub const _HAS_CXX20: u32 = 0;
pub const _HAS_CXX23: u32 = 0;
pub const _HAS_CXX26: u32 = 0;
pub const _HAS_NODISCARD: u32 = 0;
pub const EXCEPTION_EXECUTE_HANDLER: u32 = 1;
pub const EXCEPTION_CONTINUE_SEARCH: u32 = 0;
pub const EXCEPTION_CONTINUE_EXECUTION: i32 = -1;
pub const __SAL_H_FULL_VER: u32 = 140050727;
pub const __SPECSTRINGS_STRICT_LEVEL: u32 = 1;
pub const __drv_typeConst: u32 = 0;
pub const __drv_typeCond: u32 = 1;
pub const __drv_typeBitset: u32 = 2;
pub const __drv_typeExpr: u32 = 3;
pub const STRICT: u32 = 1;
pub const MAX_PATH: u32 = 260;
pub const FALSE: u32 = 0;
pub const TRUE: u32 = 1;
pub const _ARM_WINAPI_PARTITION_DESKTOP_SDK_AVAILABLE: u32 = 1;
pub const _CRT_BUILD_DESKTOP_APP: u32 = 1;
pub const _ARGMAX: u32 = 100;
pub const _CRT_INT_MAX: u32 = 2147483647;
pub const _CRT_FUNCTIONS_REQUIRED: u32 = 1;
pub const _CRT_HAS_CXX17: u32 = 0;
pub const _CRT_HAS_C11: u32 = 1;
pub const _CRT_INTERNAL_NONSTDC_NAMES: u32 = 1;
pub const __STDC_SECURE_LIB__: u32 = 200411;
pub const __GOT_SECURE_LIB__: u32 = 200411;
pub const __STDC_WANT_SECURE_LIB__: u32 = 1;
pub const _SECURECRT_FILL_BUFFER_PATTERN: u32 = 254;
pub const _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES: u32 = 0;
pub const _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES_COUNT: u32 = 0;
pub const _CRT_SECURE_CPP_OVERLOAD_SECURE_NAMES: u32 = 1;
pub const _CRT_SECURE_CPP_OVERLOAD_STANDARD_NAMES_MEMORY: u32 = 0;
pub const _CRT_SECURE_CPP_OVERLOAD_SECURE_NAMES_MEMORY: u32 = 0;
pub const _UPPER: u32 = 1;
pub const _LOWER: u32 = 2;
pub const _DIGIT: u32 = 4;
pub const _SPACE: u32 = 8;
pub const _PUNCT: u32 = 16;
pub const _CONTROL: u32 = 32;
pub const _BLANK: u32 = 64;
pub const _HEX: u32 = 128;
pub const _LEADBYTE: u32 = 32768;
pub const _ALPHA: u32 = 259;
pub const ANYSIZE_ARRAY: u32 = 1;
pub const DISPATCH_LEVEL: u32 = 2;
pub const APC_LEVEL: u32 = 1;
pub const PASSIVE_LEVEL: u32 = 0;
pub const HIGH_LEVEL: u32 = 15;
pub const MEMORY_ALLOCATION_ALIGNMENT: u32 = 16;
pub const X86_CACHE_ALIGNMENT_SIZE: u32 = 64;
pub const ARM_CACHE_ALIGNMENT_SIZE: u32 = 128;
pub const SYSTEM_CACHE_ALIGNMENT_SIZE: u32 = 64;
pub const PRAGMA_DEPRECATED_DDK: u32 = 0;
pub const UCSCHAR_INVALID_CHARACTER: u32 = 4294967295;
pub const MIN_UCSCHAR: u32 = 0;
pub const MAX_UCSCHAR: u32 = 1114111;
pub const ALL_PROCESSOR_GROUPS: u32 = 65535;
pub const MAXIMUM_PROC_PER_GROUP: u32 = 64;
pub const MAXIMUM_PROCESSORS: u32 = 64;
pub const APPLICATION_ERROR_MASK: u32 = 536870912;
pub const ERROR_SEVERITY_SUCCESS: u32 = 0;
pub const ERROR_SEVERITY_INFORMATIONAL: u32 = 1073741824;
pub const ERROR_SEVERITY_WARNING: u32 = 2147483648;
pub const ERROR_SEVERITY_ERROR: u32 = 3221225472;
pub const MAXLONGLONG: u64 = 9223372036854775807;
pub const UNICODE_STRING_MAX_CHARS: u32 = 32767;
pub const EPERM: u32 = 1;
pub const ENOENT: u32 = 2;
pub const ESRCH: u32 = 3;
pub const EINTR: u32 = 4;
pub const EIO: u32 = 5;
pub const ENXIO: u32 = 6;
pub const E2BIG: u32 = 7;
pub const ENOEXEC: u32 = 8;
pub const EBADF: u32 = 9;
pub const ECHILD: u32 = 10;
pub const EAGAIN: u32 = 11;
pub const ENOMEM: u32 = 12;
pub const EACCES: u32 = 13;
pub const EFAULT: u32 = 14;
pub const EBUSY: u32 = 16;
pub const EEXIST: u32 = 17;
pub const EXDEV: u32 = 18;
pub const ENODEV: u32 = 19;
pub const ENOTDIR: u32 = 20;
pub const EISDIR: u32 = 21;
pub const ENFILE: u32 = 23;
pub const EMFILE: u32 = 24;
pub const ENOTTY: u32 = 25;
pub const EFBIG: u32 = 27;
pub const ENOSPC: u32 = 28;
pub const ESPIPE: u32 = 29;
pub const EROFS: u32 = 30;
pub const EMLINK: u32 = 31;
pub const EPIPE: u32 = 32;
pub const EDOM: u32 = 33;
pub const EDEADLK: u32 = 36;
pub const ENAMETOOLONG: u32 = 38;
pub const ENOLCK: u32 = 39;
pub const ENOSYS: u32 = 40;
pub const ENOTEMPTY: u32 = 41;
pub const EINVAL: u32 = 22;
pub const ERANGE: u32 = 34;
pub const EILSEQ: u32 = 42;
pub const STRUNCATE: u32 = 80;
pub const EDEADLOCK: u32 = 36;
pub const EADDRINUSE: u32 = 100;
pub const EADDRNOTAVAIL: u32 = 101;
pub const EAFNOSUPPORT: u32 = 102;
pub const EALREADY: u32 = 103;
pub const EBADMSG: u32 = 104;
pub const ECANCELED: u32 = 105;
pub const ECONNABORTED: u32 = 106;
pub const ECONNREFUSED: u32 = 107;
pub const ECONNRESET: u32 = 108;
pub const EDESTADDRREQ: u32 = 109;
pub const EHOSTUNREACH: u32 = 110;
pub const EIDRM: u32 = 111;
pub const EINPROGRESS: u32 = 112;
pub const EISCONN: u32 = 113;
pub const ELOOP: u32 = 114;
pub const EMSGSIZE: u32 = 115;
pub const ENETDOWN: u32 = 116;
pub const ENETRESET: u32 = 117;
pub const ENETUNREACH: u32 = 118;
pub const ENOBUFS: u32 = 119;
pub const ENODATA: u32 = 120;
pub const ENOLINK: u32 = 121;
pub const ENOMSG: u32 = 122;
pub const ENOPROTOOPT: u32 = 123;
pub const ENOSR: u32 = 124;
pub const ENOSTR: u32 = 125;
pub const ENOTCONN: u32 = 126;
pub const ENOTRECOVERABLE: u32 = 127;
pub const ENOTSOCK: u32 = 128;
pub const ENOTSUP: u32 = 129;
pub const EOPNOTSUPP: u32 = 130;
pub const EOTHER: u32 = 131;
pub const EOVERFLOW: u32 = 132;
pub const EOWNERDEAD: u32 = 133;
pub const EPROTO: u32 = 134;
pub const EPROTONOSUPPORT: u32 = 135;
pub const EPROTOTYPE: u32 = 136;
pub const ETIME: u32 = 137;
pub const ETIMEDOUT: u32 = 138;
pub const ETXTBSY: u32 = 139;
pub const EWOULDBLOCK: u32 = 140;
pub const _NLSCMPERROR: u32 = 2147483647;
pub const MINCHAR: u32 = 128;
pub const MAXCHAR: u32 = 127;
pub const MINSHORT: u32 = 32768;
pub const MAXSHORT: u32 = 32767;
pub const MINLONG: u32 = 2147483648;
pub const MAXLONG: u32 = 2147483647;
pub const MAXBYTE: u32 = 255;
pub const MAXWORD: u32 = 65535;
pub const MAXDWORD: u32 = 4294967295;
pub const ENCLAVE_SHORT_ID_LENGTH: u32 = 16;
pub const ENCLAVE_LONG_ID_LENGTH: u32 = 32;
pub const VER_SERVER_NT: u32 = 2147483648;
pub const VER_WORKSTATION_NT: u32 = 1073741824;
pub const VER_SUITE_SMALLBUSINESS: u32 = 1;
pub const VER_SUITE_ENTERPRISE: u32 = 2;
pub const VER_SUITE_BACKOFFICE: u32 = 4;
pub const VER_SUITE_COMMUNICATIONS: u32 = 8;
pub const VER_SUITE_TERMINAL: u32 = 16;
pub const VER_SUITE_SMALLBUSINESS_RESTRICTED: u32 = 32;
pub const VER_SUITE_EMBEDDEDNT: u32 = 64;
pub const VER_SUITE_DATACENTER: u32 = 128;
pub const VER_SUITE_SINGLEUSERTS: u32 = 256;
pub const VER_SUITE_PERSONAL: u32 = 512;
pub const VER_SUITE_BLADE: u32 = 1024;
pub const VER_SUITE_EMBEDDED_RESTRICTED: u32 = 2048;
pub const VER_SUITE_SECURITY_APPLIANCE: u32 = 4096;
pub const VER_SUITE_STORAGE_SERVER: u32 = 8192;
pub const VER_SUITE_COMPUTE_SERVER: u32 = 16384;
pub const VER_SUITE_WH_SERVER: u32 = 32768;
pub const VER_SUITE_MULTIUSERTS: u32 = 131072;
pub const PRODUCT_UNDEFINED: u32 = 0;
pub const PRODUCT_ULTIMATE: u32 = 1;
pub const PRODUCT_HOME_BASIC: u32 = 2;
pub const PRODUCT_HOME_PREMIUM: u32 = 3;
pub const PRODUCT_ENTERPRISE: u32 = 4;
pub const PRODUCT_HOME_BASIC_N: u32 = 5;
pub const PRODUCT_BUSINESS: u32 = 6;
pub const PRODUCT_STANDARD_SERVER: u32 = 7;
pub const PRODUCT_DATACENTER_SERVER: u32 = 8;
pub const PRODUCT_SMALLBUSINESS_SERVER: u32 = 9;
pub const PRODUCT_ENTERPRISE_SERVER: u32 = 10;
pub const PRODUCT_STARTER: u32 = 11;
pub const PRODUCT_DATACENTER_SERVER_CORE: u32 = 12;
pub const PRODUCT_STANDARD_SERVER_CORE: u32 = 13;
pub const PRODUCT_ENTERPRISE_SERVER_CORE: u32 = 14;
pub const PRODUCT_ENTERPRISE_SERVER_IA64: u32 = 15;
pub const PRODUCT_BUSINESS_N: u32 = 16;
pub const PRODUCT_WEB_SERVER: u32 = 17;
pub const PRODUCT_CLUSTER_SERVER: u32 = 18;
pub const PRODUCT_HOME_SERVER: u32 = 19;
pub const PRODUCT_STORAGE_EXPRESS_SERVER: u32 = 20;
pub const PRODUCT_STORAGE_STANDARD_SERVER: u32 = 21;
pub const PRODUCT_STORAGE_WORKGROUP_SERVER: u32 = 22;
pub const PRODUCT_STORAGE_ENTERPRISE_SERVER: u32 = 23;
pub const PRODUCT_SERVER_FOR_SMALLBUSINESS: u32 = 24;
pub const PRODUCT_SMALLBUSINESS_SERVER_PREMIUM: u32 = 25;
pub const PRODUCT_HOME_PREMIUM_N: u32 = 26;
pub const PRODUCT_ENTERPRISE_N: u32 = 27;
pub const PRODUCT_ULTIMATE_N: u32 = 28;
pub const PRODUCT_WEB_SERVER_CORE: u32 = 29;
pub const PRODUCT_MEDIUMBUSINESS_SERVER_MANAGEMENT: u32 = 30;
pub const PRODUCT_MEDIUMBUSINESS_SERVER_SECURITY: u32 = 31;
pub const PRODUCT_MEDIUMBUSINESS_SERVER_MESSAGING: u32 = 32;
pub const PRODUCT_SERVER_FOUNDATION: u32 = 33;
pub const PRODUCT_HOME_PREMIUM_SERVER: u32 = 34;
pub const PRODUCT_SERVER_FOR_SMALLBUSINESS_V: u32 = 35;
pub const PRODUCT_STANDARD_SERVER_V: u32 = 36;
pub const PRODUCT_DATACENTER_SERVER_V: u32 = 37;
pub const PRODUCT_ENTERPRISE_SERVER_V: u32 = 38;
pub const PRODUCT_DATACENTER_SERVER_CORE_V: u32 = 39;
pub const PRODUCT_STANDARD_SERVER_CORE_V: u32 = 40;
pub const PRODUCT_ENTERPRISE_SERVER_CORE_V: u32 = 41;
pub const PRODUCT_HYPERV: u32 = 42;
pub const PRODUCT_STORAGE_EXPRESS_SERVER_CORE: u32 = 43;
pub const PRODUCT_STORAGE_STANDARD_SERVER_CORE: u32 = 44;
pub const PRODUCT_STORAGE_WORKGROUP_SERVER_CORE: u32 = 45;
pub const PRODUCT_STORAGE_ENTERPRISE_SERVER_CORE: u32 = 46;
pub const PRODUCT_STARTER_N: u32 = 47;
pub const PRODUCT_PROFESSIONAL: u32 = 48;
pub const PRODUCT_PROFESSIONAL_N: u32 = 49;
pub const PRODUCT_SB_SOLUTION_SERVER: u32 = 50;
pub const PRODUCT_SERVER_FOR_SB_SOLUTIONS: u32 = 51;
pub const PRODUCT_STANDARD_SERVER_SOLUTIONS: u32 = 52;
pub const PRODUCT_STANDARD_SERVER_SOLUTIONS_CORE: u32 = 53;
pub const PRODUCT_SB_SOLUTION_SERVER_EM: u32 = 54;
pub const PRODUCT_SERVER_FOR_SB_SOLUTIONS_EM: u32 = 55;
pub const PRODUCT_SOLUTION_EMBEDDEDSERVER: u32 = 56;
pub const PRODUCT_SOLUTION_EMBEDDEDSERVER_CORE: u32 = 57;
pub const PRODUCT_PROFESSIONAL_EMBEDDED: u32 = 58;
pub const PRODUCT_ESSENTIALBUSINESS_SERVER_MGMT: u32 = 59;
pub const PRODUCT_ESSENTIALBUSINESS_SERVER_ADDL: u32 = 60;
pub const PRODUCT_ESSENTIALBUSINESS_SERVER_MGMTSVC: u32 = 61;
pub const PRODUCT_ESSENTIALBUSINESS_SERVER_ADDLSVC: u32 = 62;
pub const PRODUCT_SMALLBUSINESS_SERVER_PREMIUM_CORE: u32 = 63;
pub const PRODUCT_CLUSTER_SERVER_V: u32 = 64;
pub const PRODUCT_EMBEDDED: u32 = 65;
pub const PRODUCT_STARTER_E: u32 = 66;
pub const PRODUCT_HOME_BASIC_E: u32 = 67;
pub const PRODUCT_HOME_PREMIUM_E: u32 = 68;
pub const PRODUCT_PROFESSIONAL_E: u32 = 69;
pub const PRODUCT_ENTERPRISE_E: u32 = 70;
pub const PRODUCT_ULTIMATE_E: u32 = 71;
pub const PRODUCT_ENTERPRISE_EVALUATION: u32 = 72;
pub const PRODUCT_MULTIPOINT_STANDARD_SERVER: u32 = 76;
pub const PRODUCT_MULTIPOINT_PREMIUM_SERVER: u32 = 77;
pub const PRODUCT_STANDARD_EVALUATION_SERVER: u32 = 79;
pub const PRODUCT_DATACENTER_EVALUATION_SERVER: u32 = 80;
pub const PRODUCT_ENTERPRISE_N_EVALUATION: u32 = 84;
pub const PRODUCT_EMBEDDED_AUTOMOTIVE: u32 = 85;
pub const PRODUCT_EMBEDDED_INDUSTRY_A: u32 = 86;
pub const PRODUCT_THINPC: u32 = 87;
pub const PRODUCT_EMBEDDED_A: u32 = 88;
pub const PRODUCT_EMBEDDED_INDUSTRY: u32 = 89;
pub const PRODUCT_EMBEDDED_E: u32 = 90;
pub const PRODUCT_EMBEDDED_INDUSTRY_E: u32 = 91;
pub const PRODUCT_EMBEDDED_INDUSTRY_A_E: u32 = 92;
pub const PRODUCT_STORAGE_WORKGROUP_EVALUATION_SERVER: u32 = 95;
pub const PRODUCT_STORAGE_STANDARD_EVALUATION_SERVER: u32 = 96;
pub const PRODUCT_CORE_ARM: u32 = 97;
pub const PRODUCT_CORE_N: u32 = 98;
pub const PRODUCT_CORE_COUNTRYSPECIFIC: u32 = 99;
pub const PRODUCT_CORE_SINGLELANGUAGE: u32 = 100;
pub const PRODUCT_CORE: u32 = 101;
pub const PRODUCT_PROFESSIONAL_WMC: u32 = 103;
pub const PRODUCT_EMBEDDED_INDUSTRY_EVAL: u32 = 105;
pub const PRODUCT_EMBEDDED_INDUSTRY_E_EVAL: u32 = 106;
pub const PRODUCT_EMBEDDED_EVAL: u32 = 107;
pub const PRODUCT_EMBEDDED_E_EVAL: u32 = 108;
pub const PRODUCT_NANO_SERVER: u32 = 109;
pub const PRODUCT_CLOUD_STORAGE_SERVER: u32 = 110;
pub const PRODUCT_CORE_CONNECTED: u32 = 111;
pub const PRODUCT_PROFESSIONAL_STUDENT: u32 = 112;
pub const PRODUCT_CORE_CONNECTED_N: u32 = 113;
pub const PRODUCT_PROFESSIONAL_STUDENT_N: u32 = 114;
pub const PRODUCT_CORE_CONNECTED_SINGLELANGUAGE: u32 = 115;
pub const PRODUCT_CORE_CONNECTED_COUNTRYSPECIFIC: u32 = 116;
pub const PRODUCT_CONNECTED_CAR: u32 = 117;
pub const PRODUCT_INDUSTRY_HANDHELD: u32 = 118;
pub const PRODUCT_PPI_PRO: u32 = 119;
pub const PRODUCT_ARM64_SERVER: u32 = 120;
pub const PRODUCT_EDUCATION: u32 = 121;
pub const PRODUCT_EDUCATION_N: u32 = 122;
pub const PRODUCT_IOTUAP: u32 = 123;
pub const PRODUCT_CLOUD_HOST_INFRASTRUCTURE_SERVER: u32 = 124;
pub const PRODUCT_ENTERPRISE_S: u32 = 125;
pub const PRODUCT_ENTERPRISE_S_N: u32 = 126;
pub const PRODUCT_PROFESSIONAL_S: u32 = 127;
pub const PRODUCT_PROFESSIONAL_S_N: u32 = 128;
pub const PRODUCT_ENTERPRISE_S_EVALUATION: u32 = 129;
pub const PRODUCT_ENTERPRISE_S_N_EVALUATION: u32 = 130;
pub const PRODUCT_HOLOGRAPHIC: u32 = 135;
pub const PRODUCT_HOLOGRAPHIC_BUSINESS: u32 = 136;
pub const PRODUCT_PRO_SINGLE_LANGUAGE: u32 = 138;
pub const PRODUCT_PRO_CHINA: u32 = 139;
pub const PRODUCT_ENTERPRISE_SUBSCRIPTION: u32 = 140;
pub const PRODUCT_ENTERPRISE_SUBSCRIPTION_N: u32 = 141;
pub const PRODUCT_DATACENTER_NANO_SERVER: u32 = 143;
pub const PRODUCT_STANDARD_NANO_SERVER: u32 = 144;
pub const PRODUCT_DATACENTER_A_SERVER_CORE: u32 = 145;
pub const PRODUCT_STANDARD_A_SERVER_CORE: u32 = 146;
pub const PRODUCT_DATACENTER_WS_SERVER_CORE: u32 = 147;
pub const PRODUCT_STANDARD_WS_SERVER_CORE: u32 = 148;
pub const PRODUCT_UTILITY_VM: u32 = 149;
pub const PRODUCT_DATACENTER_EVALUATION_SERVER_CORE: u32 = 159;
pub const PRODUCT_STANDARD_EVALUATION_SERVER_CORE: u32 = 160;
pub const PRODUCT_PRO_WORKSTATION: u32 = 161;
pub const PRODUCT_PRO_WORKSTATION_N: u32 = 162;
pub const PRODUCT_PRO_FOR_EDUCATION: u32 = 164;
pub const PRODUCT_PRO_FOR_EDUCATION_N: u32 = 165;
pub const PRODUCT_AZURE_SERVER_CORE: u32 = 168;
pub const PRODUCT_AZURE_NANO_SERVER: u32 = 169;
pub const PRODUCT_ENTERPRISEG: u32 = 171;
pub const PRODUCT_ENTERPRISEGN: u32 = 172;
pub const PRODUCT_SERVERRDSH: u32 = 175;
pub const PRODUCT_CLOUD: u32 = 178;
pub const PRODUCT_CLOUDN: u32 = 179;
pub const PRODUCT_HUBOS: u32 = 180;
pub const PRODUCT_ONECOREUPDATEOS: u32 = 182;
pub const PRODUCT_CLOUDE: u32 = 183;
pub const PRODUCT_IOTOS: u32 = 185;
pub const PRODUCT_CLOUDEN: u32 = 186;
pub const PRODUCT_IOTEDGEOS: u32 = 187;
pub const PRODUCT_IOTENTERPRISE: u32 = 188;
pub const PRODUCT_LITE: u32 = 189;
pub const PRODUCT_IOTENTERPRISES: u32 = 191;
pub const PRODUCT_XBOX_SYSTEMOS: u32 = 192;
pub const PRODUCT_XBOX_NATIVEOS: u32 = 193;
pub const PRODUCT_XBOX_GAMEOS: u32 = 194;
pub const PRODUCT_XBOX_ERAOS: u32 = 195;
pub const PRODUCT_XBOX_DURANGOHOSTOS: u32 = 196;
pub const PRODUCT_XBOX_SCARLETTHOSTOS: u32 = 197;
pub const PRODUCT_AZURE_SERVER_CLOUDHOST: u32 = 199;
pub const PRODUCT_AZURE_SERVER_CLOUDMOS: u32 = 200;
pub const PRODUCT_CLOUDEDITIONN: u32 = 202;
pub const PRODUCT_CLOUDEDITION: u32 = 203;
pub const PRODUCT_AZURESTACKHCI_SERVER_CORE: u32 = 406;
pub const PRODUCT_DATACENTER_SERVER_AZURE_EDITION: u32 = 407;
pub const PRODUCT_DATACENTER_SERVER_CORE_AZURE_EDITION: u32 = 408;
pub const PRODUCT_UNLICENSED: u32 = 2882382797;
pub const LANG_NEUTRAL: u32 = 0;
pub const LANG_INVARIANT: u32 = 127;
pub const LANG_AFRIKAANS: u32 = 54;
pub const LANG_ALBANIAN: u32 = 28;
pub const LANG_ALSATIAN: u32 = 132;
pub const LANG_AMHARIC: u32 = 94;
pub const LANG_ARABIC: u32 = 1;
pub const LANG_ARMENIAN: u32 = 43;
pub const LANG_ASSAMESE: u32 = 77;
pub const LANG_AZERI: u32 = 44;
pub const LANG_AZERBAIJANI: u32 = 44;
pub const LANG_BANGLA: u32 = 69;
pub const LANG_BASHKIR: u32 = 109;
pub const LANG_BASQUE: u32 = 45;
pub const LANG_BELARUSIAN: u32 = 35;
pub const LANG_BENGALI: u32 = 69;
pub const LANG_BRETON: u32 = 126;
pub const LANG_BOSNIAN: u32 = 26;
pub const LANG_BOSNIAN_NEUTRAL: u32 = 30746;
pub const LANG_BULGARIAN: u32 = 2;
pub const LANG_CATALAN: u32 = 3;
pub const LANG_CENTRAL_KURDISH: u32 = 146;
pub const LANG_CHEROKEE: u32 = 92;
pub const LANG_CHINESE: u32 = 4;
pub const LANG_CHINESE_SIMPLIFIED: u32 = 4;
pub const LANG_CHINESE_TRADITIONAL: u32 = 31748;
pub const LANG_CORSICAN: u32 = 131;
pub const LANG_CROATIAN: u32 = 26;
pub const LANG_CZECH: u32 = 5;
pub const LANG_DANISH: u32 = 6;
pub const LANG_DARI: u32 = 140;
pub const LANG_DIVEHI: u32 = 101;
pub const LANG_DUTCH: u32 = 19;
pub const LANG_ENGLISH: u32 = 9;
pub const LANG_ESTONIAN: u32 = 37;
pub const LANG_FAEROESE: u32 = 56;
pub const LANG_FARSI: u32 = 41;
pub const LANG_FILIPINO: u32 = 100;
pub const LANG_FINNISH: u32 = 11;
pub const LANG_FRENCH: u32 = 12;
pub const LANG_FRISIAN: u32 = 98;
pub const LANG_FULAH: u32 = 103;
pub const LANG_GALICIAN: u32 = 86;
pub const LANG_GEORGIAN: u32 = 55;
pub const LANG_GERMAN: u32 = 7;
pub const LANG_GREEK: u32 = 8;
pub const LANG_GREENLANDIC: u32 = 111;
pub const LANG_GUJARATI: u32 = 71;
pub const LANG_HAUSA: u32 = 104;
pub const LANG_HAWAIIAN: u32 = 117;
pub const LANG_HEBREW: u32 = 13;
pub const LANG_HINDI: u32 = 57;
pub const LANG_HUNGARIAN: u32 = 14;
pub const LANG_ICELANDIC: u32 = 15;
pub const LANG_IGBO: u32 = 112;
pub const LANG_INDONESIAN: u32 = 33;
pub const LANG_INUKTITUT: u32 = 93;
pub const LANG_IRISH: u32 = 60;
pub const LANG_ITALIAN: u32 = 16;
pub const LANG_JAPANESE: u32 = 17;
pub const LANG_KANNADA: u32 = 75;
pub const LANG_KASHMIRI: u32 = 96;
pub const LANG_KAZAK: u32 = 63;
pub const LANG_KHMER: u32 = 83;
pub const LANG_KICHE: u32 = 134;
pub const LANG_KINYARWANDA: u32 = 135;
pub const LANG_KONKANI: u32 = 87;
pub const LANG_KOREAN: u32 = 18;
pub const LANG_KYRGYZ: u32 = 64;
pub const LANG_LAO: u32 = 84;
pub const LANG_LATVIAN: u32 = 38;
pub const LANG_LITHUANIAN: u32 = 39;
pub const LANG_LOWER_SORBIAN: u32 = 46;
pub const LANG_LUXEMBOURGISH: u32 = 110;
pub const LANG_MACEDONIAN: u32 = 47;
pub const LANG_MALAY: u32 = 62;
pub const LANG_MALAYALAM: u32 = 76;
pub const LANG_MALTESE: u32 = 58;
pub const LANG_MANIPURI: u32 = 88;
pub const LANG_MAORI: u32 = 129;
pub const LANG_MAPUDUNGUN: u32 = 122;
pub const LANG_MARATHI: u32 = 78;
pub const LANG_MOHAWK: u32 = 124;
pub const LANG_MONGOLIAN: u32 = 80;
pub const LANG_NEPALI: u32 = 97;
pub const LANG_NORWEGIAN: u32 = 20;
pub const LANG_OCCITAN: u32 = 130;
pub const LANG_ODIA: u32 = 72;
pub const LANG_ORIYA: u32 = 72;
pub const LANG_PASHTO: u32 = 99;
pub const LANG_PERSIAN: u32 = 41;
pub const LANG_POLISH: u32 = 21;
pub const LANG_PORTUGUESE: u32 = 22;
pub const LANG_PULAR: u32 = 103;
pub const LANG_PUNJABI: u32 = 70;
pub const LANG_QUECHUA: u32 = 107;
pub const LANG_ROMANIAN: u32 = 24;
pub const LANG_ROMANSH: u32 = 23;
pub const LANG_RUSSIAN: u32 = 25;
pub const LANG_SAKHA: u32 = 133;
pub const LANG_SAMI: u32 = 59;
pub const LANG_SANSKRIT: u32 = 79;
pub const LANG_SCOTTISH_GAELIC: u32 = 145;
pub const LANG_SERBIAN: u32 = 26;
pub const LANG_SERBIAN_NEUTRAL: u32 = 31770;
pub const LANG_SINDHI: u32 = 89;
pub const LANG_SINHALESE: u32 = 91;
pub const LANG_SLOVAK: u32 = 27;
pub const LANG_SLOVENIAN: u32 = 36;
pub const LANG_SOTHO: u32 = 108;
pub const LANG_SPANISH: u32 = 10;
pub const LANG_SWAHILI: u32 = 65;
pub const LANG_SWEDISH: u32 = 29;
pub const LANG_SYRIAC: u32 = 90;
pub const LANG_TAJIK: u32 = 40;
pub const LANG_TAMAZIGHT: u32 = 95;
pub const LANG_TAMIL: u32 = 73;
pub const LANG_TATAR: u32 = 68;
pub const LANG_TELUGU: u32 = 74;
pub const LANG_THAI: u32 = 30;
pub const LANG_TIBETAN: u32 = 81;
pub const LANG_TIGRIGNA: u32 = 115;
pub const LANG_TIGRINYA: u32 = 115;
pub const LANG_TSWANA: u32 = 50;
pub const LANG_TURKISH: u32 = 31;
pub const LANG_TURKMEN: u32 = 66;
pub const LANG_UIGHUR: u32 = 128;
pub const LANG_UKRAINIAN: u32 = 34;
pub const LANG_UPPER_SORBIAN: u32 = 46;
pub const LANG_URDU: u32 = 32;
pub const LANG_UZBEK: u32 = 67;
pub const LANG_VALENCIAN: u32 = 3;
pub const LANG_VIETNAMESE: u32 = 42;
pub const LANG_WELSH: u32 = 82;
pub const LANG_WOLOF: u32 = 136;
pub const LANG_XHOSA: u32 = 52;
pub const LANG_YAKUT: u32 = 133;
pub const LANG_YI: u32 = 120;
pub const LANG_YORUBA: u32 = 106;
pub const LANG_ZULU: u32 = 53;
pub const SUBLANG_NEUTRAL: u32 = 0;
pub const SUBLANG_DEFAULT: u32 = 1;
pub const SUBLANG_SYS_DEFAULT: u32 = 2;
pub const SUBLANG_CUSTOM_DEFAULT: u32 = 3;
pub const SUBLANG_CUSTOM_UNSPECIFIED: u32 = 4;
pub const SUBLANG_UI_CUSTOM_DEFAULT: u32 = 5;
pub const SUBLANG_AFRIKAANS_SOUTH_AFRICA: u32 = 1;
pub const SUBLANG_ALBANIAN_ALBANIA: u32 = 1;
pub const SUBLANG_ALSATIAN_FRANCE: u32 = 1;
pub const SUBLANG_AMHARIC_ETHIOPIA: u32 = 1;
pub const SUBLANG_ARABIC_SAUDI_ARABIA: u32 = 1;
pub const SUBLANG_ARABIC_IRAQ: u32 = 2;
pub const SUBLANG_ARABIC_EGYPT: u32 = 3;
pub const SUBLANG_ARABIC_LIBYA: u32 = 4;
pub const SUBLANG_ARABIC_ALGERIA: u32 = 5;
pub const SUBLANG_ARABIC_MOROCCO: u32 = 6;
pub const SUBLANG_ARABIC_TUNISIA: u32 = 7;
pub const SUBLANG_ARABIC_OMAN: u32 = 8;
pub const SUBLANG_ARABIC_YEMEN: u32 = 9;
pub const SUBLANG_ARABIC_SYRIA: u32 = 10;
pub const SUBLANG_ARABIC_JORDAN: u32 = 11;
pub const SUBLANG_ARABIC_LEBANON: u32 = 12;
pub const SUBLANG_ARABIC_KUWAIT: u32 = 13;
pub const SUBLANG_ARABIC_UAE: u32 = 14;
pub const SUBLANG_ARABIC_BAHRAIN: u32 = 15;
pub const SUBLANG_ARABIC_QATAR: u32 = 16;
pub const SUBLANG_ARMENIAN_ARMENIA: u32 = 1;
pub const SUBLANG_ASSAMESE_INDIA: u32 = 1;
pub const SUBLANG_AZERI_LATIN: u32 = 1;
pub const SUBLANG_AZERI_CYRILLIC: u32 = 2;
pub const SUBLANG_AZERBAIJANI_AZERBAIJAN_LATIN: u32 = 1;
pub const SUBLANG_AZERBAIJANI_AZERBAIJAN_CYRILLIC: u32 = 2;
pub const SUBLANG_BANGLA_INDIA: u32 = 1;
pub const SUBLANG_BANGLA_BANGLADESH: u32 = 2;
pub const SUBLANG_BASHKIR_RUSSIA: u32 = 1;
pub const SUBLANG_BASQUE_BASQUE: u32 = 1;
pub const SUBLANG_BELARUSIAN_BELARUS: u32 = 1;
pub const SUBLANG_BENGALI_INDIA: u32 = 1;
pub const SUBLANG_BENGALI_BANGLADESH: u32 = 2;
pub const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_LATIN: u32 = 5;
pub const SUBLANG_BOSNIAN_BOSNIA_HERZEGOVINA_CYRILLIC: u32 = 8;
pub const SUBLANG_BRETON_FRANCE: u32 = 1;
pub const SUBLANG_BULGARIAN_BULGARIA: u32 = 1;
pub const SUBLANG_CATALAN_CATALAN: u32 = 1;
pub const SUBLANG_CENTRAL_KURDISH_IRAQ: u32 = 1;
pub const SUBLANG_CHEROKEE_CHEROKEE: u32 = 1;
pub const SUBLANG_CHINESE_TRADITIONAL: u32 = 1;
pub const SUBLANG_CHINESE_SIMPLIFIED: u32 = 2;
pub const SUBLANG_CHINESE_HONGKONG: u32 = 3;
pub const SUBLANG_CHINESE_SINGAPORE: u32 = 4;
pub const SUBLANG_CHINESE_MACAU: u32 = 5;
pub const SUBLANG_CORSICAN_FRANCE: u32 = 1;
pub const SUBLANG_CZECH_CZECH_REPUBLIC: u32 = 1;
pub const SUBLANG_CROATIAN_CROATIA: u32 = 1;
pub const SUBLANG_CROATIAN_BOSNIA_HERZEGOVINA_LATIN: u32 = 4;
pub const SUBLANG_DANISH_DENMARK: u32 = 1;
pub const SUBLANG_DARI_AFGHANISTAN: u32 = 1;
pub const SUBLANG_DIVEHI_MALDIVES: u32 = 1;
pub const SUBLANG_DUTCH: u32 = 1;
pub const SUBLANG_DUTCH_BELGIAN: u32 = 2;
pub const SUBLANG_ENGLISH_US: u32 = 1;
pub const SUBLANG_ENGLISH_UK: u32 = 2;
pub const SUBLANG_ENGLISH_AUS: u32 = 3;
pub const SUBLANG_ENGLISH_CAN: u32 = 4;
pub const SUBLANG_ENGLISH_NZ: u32 = 5;
pub const SUBLANG_ENGLISH_EIRE: u32 = 6;
pub const SUBLANG_ENGLISH_SOUTH_AFRICA: u32 = 7;
pub const SUBLANG_ENGLISH_JAMAICA: u32 = 8;
pub const SUBLANG_ENGLISH_CARIBBEAN: u32 = 9;
pub const SUBLANG_ENGLISH_BELIZE: u32 = 10;
pub const SUBLANG_ENGLISH_TRINIDAD: u32 = 11;
pub const SUBLANG_ENGLISH_ZIMBABWE: u32 = 12;
pub const SUBLANG_ENGLISH_PHILIPPINES: u32 = 13;
pub const SUBLANG_ENGLISH_INDIA: u32 = 16;
pub const SUBLANG_ENGLISH_MALAYSIA: u32 = 17;
pub const SUBLANG_ENGLISH_SINGAPORE: u32 = 18;
pub const SUBLANG_ESTONIAN_ESTONIA: u32 = 1;
pub const SUBLANG_FAEROESE_FAROE_ISLANDS: u32 = 1;
pub const SUBLANG_FILIPINO_PHILIPPINES: u32 = 1;
pub const SUBLANG_FINNISH_FINLAND: u32 = 1;
pub const SUBLANG_FRENCH: u32 = 1;
pub const SUBLANG_FRENCH_BELGIAN: u32 = 2;
pub const SUBLANG_FRENCH_CANADIAN: u32 = 3;
pub const SUBLANG_FRENCH_SWISS: u32 = 4;
pub const SUBLANG_FRENCH_LUXEMBOURG: u32 = 5;
pub const SUBLANG_FRENCH_MONACO: u32 = 6;
pub const SUBLANG_FRISIAN_NETHERLANDS: u32 = 1;
pub const SUBLANG_FULAH_SENEGAL: u32 = 2;
pub const SUBLANG_GALICIAN_GALICIAN: u32 = 1;
pub const SUBLANG_GEORGIAN_GEORGIA: u32 = 1;
pub const SUBLANG_GERMAN: u32 = 1;
pub const SUBLANG_GERMAN_SWISS: u32 = 2;
pub const SUBLANG_GERMAN_AUSTRIAN: u32 = 3;
pub const SUBLANG_GERMAN_LUXEMBOURG: u32 = 4;
pub const SUBLANG_GERMAN_LIECHTENSTEIN: u32 = 5;
pub const SUBLANG_GREEK_GREECE: u32 = 1;
pub const SUBLANG_GREENLANDIC_GREENLAND: u32 = 1;
pub const SUBLANG_GUJARATI_INDIA: u32 = 1;
pub const SUBLANG_HAUSA_NIGERIA_LATIN: u32 = 1;
pub const SUBLANG_HAWAIIAN_US: u32 = 1;
pub const SUBLANG_HEBREW_ISRAEL: u32 = 1;
pub const SUBLANG_HINDI_INDIA: u32 = 1;
pub const SUBLANG_HUNGARIAN_HUNGARY: u32 = 1;
pub const SUBLANG_ICELANDIC_ICELAND: u32 = 1;
pub const SUBLANG_IGBO_NIGERIA: u32 = 1;
pub const SUBLANG_INDONESIAN_INDONESIA: u32 = 1;
pub const SUBLANG_INUKTITUT_CANADA: u32 = 1;
pub const SUBLANG_INUKTITUT_CANADA_LATIN: u32 = 2;
pub const SUBLANG_IRISH_IRELAND: u32 = 2;
pub const SUBLANG_ITALIAN: u32 = 1;
pub const SUBLANG_ITALIAN_SWISS: u32 = 2;
pub const SUBLANG_JAPANESE_JAPAN: u32 = 1;
pub const SUBLANG_KANNADA_INDIA: u32 = 1;
pub const SUBLANG_KASHMIRI_SASIA: u32 = 2;
pub const SUBLANG_KASHMIRI_INDIA: u32 = 2;
pub const SUBLANG_KAZAK_KAZAKHSTAN: u32 = 1;
pub const SUBLANG_KHMER_CAMBODIA: u32 = 1;
pub const SUBLANG_KICHE_GUATEMALA: u32 = 1;
pub const SUBLANG_KINYARWANDA_RWANDA: u32 = 1;
pub const SUBLANG_KONKANI_INDIA: u32 = 1;
pub const SUBLANG_KOREAN: u32 = 1;
pub const SUBLANG_KYRGYZ_KYRGYZSTAN: u32 = 1;
pub const SUBLANG_LAO_LAO: u32 = 1;
pub const SUBLANG_LATVIAN_LATVIA: u32 = 1;
pub const SUBLANG_LITHUANIAN: u32 = 1;
pub const SUBLANG_LOWER_SORBIAN_GERMANY: u32 = 2;
pub const SUBLANG_LUXEMBOURGISH_LUXEMBOURG: u32 = 1;
pub const SUBLANG_MACEDONIAN_MACEDONIA: u32 = 1;
pub const SUBLANG_MALAY_MALAYSIA: u32 = 1;
pub const SUBLANG_MALAY_BRUNEI_DARUSSALAM: u32 = 2;
pub const SUBLANG_MALAYALAM_INDIA: u32 = 1;
pub const SUBLANG_MALTESE_MALTA: u32 = 1;
pub const SUBLANG_MAORI_NEW_ZEALAND: u32 = 1;
pub const SUBLANG_MAPUDUNGUN_CHILE: u32 = 1;
pub const SUBLANG_MARATHI_INDIA: u32 = 1;
pub const SUBLANG_MOHAWK_MOHAWK: u32 = 1;
pub const SUBLANG_MONGOLIAN_CYRILLIC_MONGOLIA: u32 = 1;
pub const SUBLANG_MONGOLIAN_PRC: u32 = 2;
pub const SUBLANG_NEPALI_INDIA: u32 = 2;
pub const SUBLANG_NEPALI_NEPAL: u32 = 1;
pub const SUBLANG_NORWEGIAN_BOKMAL: u32 = 1;
pub const SUBLANG_NORWEGIAN_NYNORSK: u32 = 2;
pub const SUBLANG_OCCITAN_FRANCE: u32 = 1;
pub const SUBLANG_ODIA_INDIA: u32 = 1;
pub const SUBLANG_ORIYA_INDIA: u32 = 1;
pub const SUBLANG_PASHTO_AFGHANISTAN: u32 = 1;
pub const SUBLANG_PERSIAN_IRAN: u32 = 1;
pub const SUBLANG_POLISH_POLAND: u32 = 1;
pub const SUBLANG_PORTUGUESE: u32 = 2;
pub const SUBLANG_PORTUGUESE_BRAZILIAN: u32 = 1;
pub const SUBLANG_PULAR_SENEGAL: u32 = 2;
pub const SUBLANG_PUNJABI_INDIA: u32 = 1;
pub const SUBLANG_PUNJABI_PAKISTAN: u32 = 2;
pub const SUBLANG_QUECHUA_BOLIVIA: u32 = 1;
pub const SUBLANG_QUECHUA_ECUADOR: u32 = 2;
pub const SUBLANG_QUECHUA_PERU: u32 = 3;
pub const SUBLANG_ROMANIAN_ROMANIA: u32 = 1;
pub const SUBLANG_ROMANSH_SWITZERLAND: u32 = 1;
pub const SUBLANG_RUSSIAN_RUSSIA: u32 = 1;
pub const SUBLANG_SAKHA_RUSSIA: u32 = 1;
pub const SUBLANG_SAMI_NORTHERN_NORWAY: u32 = 1;
pub const SUBLANG_SAMI_NORTHERN_SWEDEN: u32 = 2;
pub const SUBLANG_SAMI_NORTHERN_FINLAND: u32 = 3;
pub const SUBLANG_SAMI_LULE_NORWAY: u32 = 4;
pub const SUBLANG_SAMI_LULE_SWEDEN: u32 = 5;
pub const SUBLANG_SAMI_SOUTHERN_NORWAY: u32 = 6;
pub const SUBLANG_SAMI_SOUTHERN_SWEDEN: u32 = 7;
pub const SUBLANG_SAMI_SKOLT_FINLAND: u32 = 8;
pub const SUBLANG_SAMI_INARI_FINLAND: u32 = 9;
pub const SUBLANG_SANSKRIT_INDIA: u32 = 1;
pub const SUBLANG_SCOTTISH_GAELIC: u32 = 1;
pub const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_LATIN: u32 = 6;
pub const SUBLANG_SERBIAN_BOSNIA_HERZEGOVINA_CYRILLIC: u32 = 7;
pub const SUBLANG_SERBIAN_MONTENEGRO_LATIN: u32 = 11;
pub const SUBLANG_SERBIAN_MONTENEGRO_CYRILLIC: u32 = 12;
pub const SUBLANG_SERBIAN_SERBIA_LATIN: u32 = 9;
pub const SUBLANG_SERBIAN_SERBIA_CYRILLIC: u32 = 10;
pub const SUBLANG_SERBIAN_CROATIA: u32 = 1;
pub const SUBLANG_SERBIAN_LATIN: u32 = 2;
pub const SUBLANG_SERBIAN_CYRILLIC: u32 = 3;
pub const SUBLANG_SINDHI_INDIA: u32 = 1;
pub const SUBLANG_SINDHI_PAKISTAN: u32 = 2;
pub const SUBLANG_SINDHI_AFGHANISTAN: u32 = 2;
pub const SUBLANG_SINHALESE_SRI_LANKA: u32 = 1;
pub const SUBLANG_SOTHO_NORTHERN_SOUTH_AFRICA: u32 = 1;
pub const SUBLANG_SLOVAK_SLOVAKIA: u32 = 1;
pub const SUBLANG_SLOVENIAN_SLOVENIA: u32 = 1;
pub const SUBLANG_SPANISH: u32 = 1;
pub const SUBLANG_SPANISH_MEXICAN: u32 = 2;
pub const SUBLANG_SPANISH_MODERN: u32 = 3;
pub const SUBLANG_SPANISH_GUATEMALA: u32 = 4;
pub const SUBLANG_SPANISH_COSTA_RICA: u32 = 5;
pub const SUBLANG_SPANISH_PANAMA: u32 = 6;
pub const SUBLANG_SPANISH_DOMINICAN_REPUBLIC: u32 = 7;
pub const SUBLANG_SPANISH_VENEZUELA: u32 = 8;
pub const SUBLANG_SPANISH_COLOMBIA: u32 = 9;
pub const SUBLANG_SPANISH_PERU: u32 = 10;
pub const SUBLANG_SPANISH_ARGENTINA: u32 = 11;
pub const SUBLANG_SPANISH_ECUADOR: u32 = 12;
pub const SUBLANG_SPANISH_CHILE: u32 = 13;
pub const SUBLANG_SPANISH_URUGUAY: u32 = 14;
pub const SUBLANG_SPANISH_PARAGUAY: u32 = 15;
pub const SUBLANG_SPANISH_BOLIVIA: u32 = 16;
pub const SUBLANG_SPANISH_EL_SALVADOR: u32 = 17;
pub const SUBLANG_SPANISH_HONDURAS: u32 = 18;
pub const SUBLANG_SPANISH_NICARAGUA: u32 = 19;
pub const SUBLANG_SPANISH_PUERTO_RICO: u32 = 20;
pub const SUBLANG_SPANISH_US: u32 = 21;
pub const SUBLANG_SWAHILI_KENYA: u32 = 1;
pub const SUBLANG_SWEDISH: u32 = 1;
pub const SUBLANG_SWEDISH_FINLAND: u32 = 2;
pub const SUBLANG_SYRIAC_SYRIA: u32 = 1;
pub const SUBLANG_TAJIK_TAJIKISTAN: u32 = 1;
pub const SUBLANG_TAMAZIGHT_ALGERIA_LATIN: u32 = 2;
pub const SUBLANG_TAMAZIGHT_MOROCCO_TIFINAGH: u32 = 4;
pub const SUBLANG_TAMIL_INDIA: u32 = 1;
pub const SUBLANG_TAMIL_SRI_LANKA: u32 = 2;
pub const SUBLANG_TATAR_RUSSIA: u32 = 1;
pub const SUBLANG_TELUGU_INDIA: u32 = 1;
pub const SUBLANG_THAI_THAILAND: u32 = 1;
pub const SUBLANG_TIBETAN_PRC: u32 = 1;
pub const SUBLANG_TIGRIGNA_ERITREA: u32 = 2;
pub const SUBLANG_TIGRINYA_ERITREA: u32 = 2;
pub const SUBLANG_TIGRINYA_ETHIOPIA: u32 = 1;
pub const SUBLANG_TSWANA_BOTSWANA: u32 = 2;
pub const SUBLANG_TSWANA_SOUTH_AFRICA: u32 = 1;
pub const SUBLANG_TURKISH_TURKEY: u32 = 1;
pub const SUBLANG_TURKMEN_TURKMENISTAN: u32 = 1;
pub const SUBLANG_UIGHUR_PRC: u32 = 1;
pub const SUBLANG_UKRAINIAN_UKRAINE: u32 = 1;
pub const SUBLANG_UPPER_SORBIAN_GERMANY: u32 = 1;
pub const SUBLANG_URDU_PAKISTAN: u32 = 1;
pub const SUBLANG_URDU_INDIA: u32 = 2;
pub const SUBLANG_UZBEK_LATIN: u32 = 1;
pub const SUBLANG_UZBEK_CYRILLIC: u32 = 2;
pub const SUBLANG_VALENCIAN_VALENCIA: u32 = 2;
pub const SUBLANG_VIETNAMESE_VIETNAM: u32 = 1;
pub const SUBLANG_WELSH_UNITED_KINGDOM: u32 = 1;
pub const SUBLANG_WOLOF_SENEGAL: u32 = 1;
pub const SUBLANG_XHOSA_SOUTH_AFRICA: u32 = 1;
pub const SUBLANG_YAKUT_RUSSIA: u32 = 1;
pub const SUBLANG_YI_PRC: u32 = 1;
pub const SUBLANG_YORUBA_NIGERIA: u32 = 1;
pub const SUBLANG_ZULU_SOUTH_AFRICA: u32 = 1;
pub const SORT_DEFAULT: u32 = 0;
pub const SORT_INVARIANT_MATH: u32 = 1;
pub const SORT_JAPANESE_XJIS: u32 = 0;
pub const SORT_JAPANESE_UNICODE: u32 = 1;
pub const SORT_JAPANESE_RADICALSTROKE: u32 = 4;
pub const SORT_CHINESE_BIG5: u32 = 0;
pub const SORT_CHINESE_PRCP: u32 = 0;
pub const SORT_CHINESE_UNICODE: u32 = 1;
pub const SORT_CHINESE_PRC: u32 = 2;
pub const SORT_CHINESE_BOPOMOFO: u32 = 3;
pub const SORT_CHINESE_RADICALSTROKE: u32 = 4;
pub const SORT_KOREAN_KSC: u32 = 0;
pub const SORT_KOREAN_UNICODE: u32 = 1;
pub const SORT_GERMAN_PHONE_BOOK: u32 = 1;
pub const SORT_HUNGARIAN_DEFAULT: u32 = 0;
pub const SORT_HUNGARIAN_TECHNICAL: u32 = 1;
pub const SORT_GEORGIAN_TRADITIONAL: u32 = 0;
pub const SORT_GEORGIAN_MODERN: u32 = 1;
pub const NLS_VALID_LOCALE_MASK: u32 = 1048575;
pub const LOCALE_NAME_MAX_LENGTH: u32 = 85;
pub const LOCALE_TRANSIENT_KEYBOARD1: u32 = 8192;
pub const LOCALE_TRANSIENT_KEYBOARD2: u32 = 9216;
pub const LOCALE_TRANSIENT_KEYBOARD3: u32 = 10240;
pub const LOCALE_TRANSIENT_KEYBOARD4: u32 = 11264;
pub const MAXIMUM_WAIT_OBJECTS: u32 = 64;
pub const MAXIMUM_SUSPEND_COUNT: u32 = 127;
pub const _MM_HINT_T0: u32 = 1;
pub const _MM_HINT_T1: u32 = 2;
pub const _MM_HINT_T2: u32 = 3;
pub const _MM_HINT_NTA: u32 = 0;
pub const PF_TEMPORAL_LEVEL_1: u32 = 1;
pub const PF_TEMPORAL_LEVEL_2: u32 = 2;
pub const PF_TEMPORAL_LEVEL_3: u32 = 3;
pub const PF_NON_TEMPORAL_LEVEL_ALL: u32 = 0;
pub const EXCEPTION_READ_FAULT: u32 = 0;
pub const EXCEPTION_WRITE_FAULT: u32 = 1;
pub const EXCEPTION_EXECUTE_FAULT: u32 = 8;
pub const CONTEXT_AMD64: u32 = 1048576;
pub const CONTEXT_CONTROL: u32 = 1048577;
pub const CONTEXT_INTEGER: u32 = 1048578;
pub const CONTEXT_SEGMENTS: u32 = 1048580;
pub const CONTEXT_FLOATING_POINT: u32 = 1048584;
pub const CONTEXT_DEBUG_REGISTERS: u32 = 1048592;
pub const CONTEXT_FULL: u32 = 1048587;
pub const CONTEXT_ALL: u32 = 1048607;
pub const CONTEXT_XSTATE: u32 = 1048640;
pub const CONTEXT_KERNEL_CET: u32 = 1048704;
pub const CONTEXT_EXCEPTION_ACTIVE: u32 = 134217728;
pub const CONTEXT_SERVICE_ACTIVE: u32 = 268435456;
pub const CONTEXT_EXCEPTION_REQUEST: u32 = 1073741824;
pub const CONTEXT_EXCEPTION_REPORTING: u32 = 2147483648;
pub const CONTEXT_UNWOUND_TO_CALL: u32 = 536870912;
pub const INITIAL_MXCSR: u32 = 8064;
pub const INITIAL_FPCSR: u32 = 639;
pub const RUNTIME_FUNCTION_INDIRECT: u32 = 1;
pub const UNW_FLAG_NHANDLER: u32 = 0;
pub const UNW_FLAG_EHANDLER: u32 = 1;
pub const UNW_FLAG_UHANDLER: u32 = 2;
pub const UNW_FLAG_CHAININFO: u32 = 4;
pub const UNW_FLAG_NO_EPILOGUE: u32 = 2147483648;
pub const UNWIND_CHAIN_LIMIT: u32 = 32;
pub const OUT_OF_PROCESS_FUNCTION_TABLE_CALLBACK_EXPORT_NAME: &[u8; 34] =
    b"OutOfProcessFunctionTableCallback\0";
pub const CONTEXT_ARM64: u32 = 4194304;
pub const CONTEXT_ARM64_CONTROL: u32 = 4194305;
pub const CONTEXT_ARM64_INTEGER: u32 = 4194306;
pub const CONTEXT_ARM64_FLOATING_POINT: u32 = 4194308;
pub const CONTEXT_ARM64_DEBUG_REGISTERS: u32 = 4194312;
pub const CONTEXT_ARM64_X18: u32 = 4194320;
pub const CONTEXT_ARM64_FULL: u32 = 4194311;
pub const CONTEXT_ARM64_ALL: u32 = 4194335;
pub const CONTEXT_ARM64_UNWOUND_TO_CALL: u32 = 536870912;
pub const CONTEXT_ARM64_RET_TO_GUEST: u32 = 67108864;
pub const ARM64_MAX_BREAKPOINTS: u32 = 8;
pub const ARM64_MAX_WATCHPOINTS: u32 = 2;
pub const NONVOL_INT_NUMREG_ARM64: u32 = 11;
pub const NONVOL_FP_NUMREG_ARM64: u32 = 8;
pub const WOW64_CONTEXT_i386: u32 = 65536;
pub const WOW64_CONTEXT_i486: u32 = 65536;
pub const WOW64_CONTEXT_CONTROL: u32 = 65537;
pub const WOW64_CONTEXT_INTEGER: u32 = 65538;
pub const WOW64_CONTEXT_SEGMENTS: u32 = 65540;
pub const WOW64_CONTEXT_FLOATING_POINT: u32 = 65544;
pub const WOW64_CONTEXT_DEBUG_REGISTERS: u32 = 65552;
pub const WOW64_CONTEXT_EXTENDED_REGISTERS: u32 = 65568;
pub const WOW64_CONTEXT_FULL: u32 = 65543;
pub const WOW64_CONTEXT_ALL: u32 = 65599;
pub const WOW64_CONTEXT_XSTATE: u32 = 65600;
pub const WOW64_CONTEXT_EXCEPTION_ACTIVE: u32 = 134217728;
pub const WOW64_CONTEXT_SERVICE_ACTIVE: u32 = 268435456;
pub const WOW64_CONTEXT_EXCEPTION_REQUEST: u32 = 1073741824;
pub const WOW64_CONTEXT_EXCEPTION_REPORTING: u32 = 2147483648;
pub const WOW64_SIZE_OF_80387_REGISTERS: u32 = 80;
pub const WOW64_MAXIMUM_SUPPORTED_EXTENSION: u32 = 512;
pub const EXCEPTION_NONCONTINUABLE: u32 = 1;
pub const EXCEPTION_UNWINDING: u32 = 2;
pub const EXCEPTION_EXIT_UNWIND: u32 = 4;
pub const EXCEPTION_STACK_INVALID: u32 = 8;
pub const EXCEPTION_NESTED_CALL: u32 = 16;
pub const EXCEPTION_TARGET_UNWIND: u32 = 32;
pub const EXCEPTION_COLLIDED_UNWIND: u32 = 64;
pub const EXCEPTION_SOFTWARE_ORIGINATE: u32 = 128;
pub const EXCEPTION_UNWIND: u32 = 102;
pub const EXCEPTION_MAXIMUM_PARAMETERS: u32 = 15;
pub const DELETE: u32 = 65536;
pub const READ_CONTROL: u32 = 131072;
pub const WRITE_DAC: u32 = 262144;
pub const WRITE_OWNER: u32 = 524288;
pub const SYNCHRONIZE: u32 = 1048576;
pub const STANDARD_RIGHTS_REQUIRED: u32 = 983040;
pub const STANDARD_RIGHTS_READ: u32 = 131072;
pub const STANDARD_RIGHTS_WRITE: u32 = 131072;
pub const STANDARD_RIGHTS_EXECUTE: u32 = 131072;
pub const STANDARD_RIGHTS_ALL: u32 = 2031616;
pub const SPECIFIC_RIGHTS_ALL: u32 = 65535;
pub const ACCESS_SYSTEM_SECURITY: u32 = 16777216;
pub const MAXIMUM_ALLOWED: u32 = 33554432;
pub const GENERIC_READ: u32 = 2147483648;
pub const GENERIC_WRITE: u32 = 1073741824;
pub const GENERIC_EXECUTE: u32 = 536870912;
pub const GENERIC_ALL: u32 = 268435456;
pub const SID_REVISION: u32 = 1;
pub const SID_MAX_SUB_AUTHORITIES: u32 = 15;
pub const SID_RECOMMENDED_SUB_AUTHORITIES: u32 = 1;
pub const SECURITY_MAX_SID_STRING_CHARACTERS: u32 = 187;
pub const SID_HASH_SIZE: u32 = 32;
pub const SECURITY_NULL_RID: u32 = 0;
pub const SECURITY_WORLD_RID: u32 = 0;
pub const SECURITY_LOCAL_RID: u32 = 0;
pub const SECURITY_LOCAL_LOGON_RID: u32 = 1;
pub const SECURITY_CREATOR_OWNER_RID: u32 = 0;
pub const SECURITY_CREATOR_GROUP_RID: u32 = 1;
pub const SECURITY_CREATOR_OWNER_SERVER_RID: u32 = 2;
pub const SECURITY_CREATOR_GROUP_SERVER_RID: u32 = 3;
pub const SECURITY_CREATOR_OWNER_RIGHTS_RID: u32 = 4;
pub const SECURITY_DIALUP_RID: u32 = 1;
pub const SECURITY_NETWORK_RID: u32 = 2;
pub const SECURITY_BATCH_RID: u32 = 3;
pub const SECURITY_INTERACTIVE_RID: u32 = 4;
pub const SECURITY_LOGON_IDS_RID: u32 = 5;
pub const SECURITY_LOGON_IDS_RID_COUNT: u32 = 3;
pub const SECURITY_SERVICE_RID: u32 = 6;
pub const SECURITY_ANONYMOUS_LOGON_RID: u32 = 7;
pub const SECURITY_PROXY_RID: u32 = 8;
pub const SECURITY_ENTERPRISE_CONTROLLERS_RID: u32 = 9;
pub const SECURITY_SERVER_LOGON_RID: u32 = 9;
pub const SECURITY_PRINCIPAL_SELF_RID: u32 = 10;
pub const SECURITY_AUTHENTICATED_USER_RID: u32 = 11;
pub const SECURITY_RESTRICTED_CODE_RID: u32 = 12;
pub const SECURITY_TERMINAL_SERVER_RID: u32 = 13;
pub const SECURITY_REMOTE_LOGON_RID: u32 = 14;
pub const SECURITY_THIS_ORGANIZATION_RID: u32 = 15;
pub const SECURITY_IUSER_RID: u32 = 17;
pub const SECURITY_LOCAL_SYSTEM_RID: u32 = 18;
pub const SECURITY_LOCAL_SERVICE_RID: u32 = 19;
pub const SECURITY_NETWORK_SERVICE_RID: u32 = 20;
pub const SECURITY_NT_NON_UNIQUE: u32 = 21;
pub const SECURITY_NT_NON_UNIQUE_SUB_AUTH_COUNT: u32 = 3;
pub const SECURITY_ENTERPRISE_READONLY_CONTROLLERS_RID: u32 = 22;
pub const SECURITY_BUILTIN_DOMAIN_RID: u32 = 32;
pub const SECURITY_WRITE_RESTRICTED_CODE_RID: u32 = 33;
pub const SECURITY_PACKAGE_BASE_RID: u32 = 64;
pub const SECURITY_PACKAGE_RID_COUNT: u32 = 2;
pub const SECURITY_PACKAGE_NTLM_RID: u32 = 10;
pub const SECURITY_PACKAGE_SCHANNEL_RID: u32 = 14;
pub const SECURITY_PACKAGE_DIGEST_RID: u32 = 21;
pub const SECURITY_CRED_TYPE_BASE_RID: u32 = 65;
pub const SECURITY_CRED_TYPE_RID_COUNT: u32 = 2;
pub const SECURITY_CRED_TYPE_THIS_ORG_CERT_RID: u32 = 1;
pub const SECURITY_MIN_BASE_RID: u32 = 80;
pub const SECURITY_SERVICE_ID_BASE_RID: u32 = 80;
pub const SECURITY_SERVICE_ID_RID_COUNT: u32 = 6;
pub const SECURITY_RESERVED_ID_BASE_RID: u32 = 81;
pub const SECURITY_APPPOOL_ID_BASE_RID: u32 = 82;
pub const SECURITY_APPPOOL_ID_RID_COUNT: u32 = 6;
pub const SECURITY_VIRTUALSERVER_ID_BASE_RID: u32 = 83;
pub const SECURITY_VIRTUALSERVER_ID_RID_COUNT: u32 = 6;
pub const SECURITY_USERMODEDRIVERHOST_ID_BASE_RID: u32 = 84;
pub const SECURITY_USERMODEDRIVERHOST_ID_RID_COUNT: u32 = 6;
pub const SECURITY_CLOUD_INFRASTRUCTURE_SERVICES_ID_BASE_RID: u32 = 85;
pub const SECURITY_CLOUD_INFRASTRUCTURE_SERVICES_ID_RID_COUNT: u32 = 6;
pub const SECURITY_WMIHOST_ID_BASE_RID: u32 = 86;
pub const SECURITY_WMIHOST_ID_RID_COUNT: u32 = 6;
pub const SECURITY_TASK_ID_BASE_RID: u32 = 87;
pub const SECURITY_NFS_ID_BASE_RID: u32 = 88;
pub const SECURITY_COM_ID_BASE_RID: u32 = 89;
pub const SECURITY_WINDOW_MANAGER_BASE_RID: u32 = 90;
pub const SECURITY_RDV_GFX_BASE_RID: u32 = 91;
pub const SECURITY_DASHOST_ID_BASE_RID: u32 = 92;
pub const SECURITY_DASHOST_ID_RID_COUNT: u32 = 6;
pub const SECURITY_USERMANAGER_ID_BASE_RID: u32 = 93;
pub const SECURITY_USERMANAGER_ID_RID_COUNT: u32 = 6;
pub const SECURITY_WINRM_ID_BASE_RID: u32 = 94;
pub const SECURITY_WINRM_ID_RID_COUNT: u32 = 6;
pub const SECURITY_CCG_ID_BASE_RID: u32 = 95;
pub const SECURITY_UMFD_BASE_RID: u32 = 96;
pub const SECURITY_VIRTUALACCOUNT_ID_RID_COUNT: u32 = 6;
pub const SECURITY_MAX_BASE_RID: u32 = 111;
pub const SECURITY_MAX_ALWAYS_FILTERED: u32 = 999;
pub const SECURITY_MIN_NEVER_FILTERED: u32 = 1000;
pub const SECURITY_OTHER_ORGANIZATION_RID: u32 = 1000;
pub const SECURITY_WINDOWSMOBILE_ID_BASE_RID: u32 = 112;
pub const SECURITY_INSTALLER_GROUP_CAPABILITY_BASE: u32 = 32;
pub const SECURITY_INSTALLER_GROUP_CAPABILITY_RID_COUNT: u32 = 9;
pub const SECURITY_INSTALLER_CAPABILITY_RID_COUNT: u32 = 10;
pub const SECURITY_LOCAL_ACCOUNT_RID: u32 = 113;
pub const SECURITY_LOCAL_ACCOUNT_AND_ADMIN_RID: u32 = 114;
pub const DOMAIN_GROUP_RID_AUTHORIZATION_DATA_IS_COMPOUNDED: u32 = 496;
pub const DOMAIN_GROUP_RID_AUTHORIZATION_DATA_CONTAINS_CLAIMS: u32 = 497;
pub const DOMAIN_GROUP_RID_ENTERPRISE_READONLY_DOMAIN_CONTROLLERS: u32 = 498;
pub const FOREST_USER_RID_MAX: u32 = 499;
pub const DOMAIN_USER_RID_ADMIN: u32 = 500;
pub const DOMAIN_USER_RID_GUEST: u32 = 501;
pub const DOMAIN_USER_RID_KRBTGT: u32 = 502;
pub const DOMAIN_USER_RID_DEFAULT_ACCOUNT: u32 = 503;
pub const DOMAIN_USER_RID_WDAG_ACCOUNT: u32 = 504;
pub const DOMAIN_USER_RID_MAX: u32 = 999;
pub const DOMAIN_GROUP_RID_ADMINS: u32 = 512;
pub const DOMAIN_GROUP_RID_USERS: u32 = 513;
pub const DOMAIN_GROUP_RID_GUESTS: u32 = 514;
pub const DOMAIN_GROUP_RID_COMPUTERS: u32 = 515;
pub const DOMAIN_GROUP_RID_CONTROLLERS: u32 = 516;
pub const DOMAIN_GROUP_RID_CERT_ADMINS: u32 = 517;
pub const DOMAIN_GROUP_RID_SCHEMA_ADMINS: u32 = 518;
pub const DOMAIN_GROUP_RID_ENTERPRISE_ADMINS: u32 = 519;
pub const DOMAIN_GROUP_RID_POLICY_ADMINS: u32 = 520;
pub const DOMAIN_GROUP_RID_READONLY_CONTROLLERS: u32 = 521;
pub const DOMAIN_GROUP_RID_CLONEABLE_CONTROLLERS: u32 = 522;
pub const DOMAIN_GROUP_RID_CDC_RESERVED: u32 = 524;
pub const DOMAIN_GROUP_RID_PROTECTED_USERS: u32 = 525;
pub const DOMAIN_GROUP_RID_KEY_ADMINS: u32 = 526;
pub const DOMAIN_GROUP_RID_ENTERPRISE_KEY_ADMINS: u32 = 527;
pub const DOMAIN_ALIAS_RID_ADMINS: u32 = 544;
pub const DOMAIN_ALIAS_RID_USERS: u32 = 545;
pub const DOMAIN_ALIAS_RID_GUESTS: u32 = 546;
pub const DOMAIN_ALIAS_RID_POWER_USERS: u32 = 547;
pub const DOMAIN_ALIAS_RID_ACCOUNT_OPS: u32 = 548;
pub const DOMAIN_ALIAS_RID_SYSTEM_OPS: u32 = 549;
pub const DOMAIN_ALIAS_RID_PRINT_OPS: u32 = 550;
pub const DOMAIN_ALIAS_RID_BACKUP_OPS: u32 = 551;
pub const DOMAIN_ALIAS_RID_REPLICATOR: u32 = 552;
pub const DOMAIN_ALIAS_RID_RAS_SERVERS: u32 = 553;
pub const DOMAIN_ALIAS_RID_PREW2KCOMPACCESS: u32 = 554;
pub const DOMAIN_ALIAS_RID_REMOTE_DESKTOP_USERS: u32 = 555;
pub const DOMAIN_ALIAS_RID_NETWORK_CONFIGURATION_OPS: u32 = 556;
pub const DOMAIN_ALIAS_RID_INCOMING_FOREST_TRUST_BUILDERS: u32 = 557;
pub const DOMAIN_ALIAS_RID_MONITORING_USERS: u32 = 558;
pub const DOMAIN_ALIAS_RID_LOGGING_USERS: u32 = 559;
pub const DOMAIN_ALIAS_RID_AUTHORIZATIONACCESS: u32 = 560;
pub const DOMAIN_ALIAS_RID_TS_LICENSE_SERVERS: u32 = 561;
pub const DOMAIN_ALIAS_RID_DCOM_USERS: u32 = 562;
pub const DOMAIN_ALIAS_RID_IUSERS: u32 = 568;
pub const DOMAIN_ALIAS_RID_CRYPTO_OPERATORS: u32 = 569;
pub const DOMAIN_ALIAS_RID_CACHEABLE_PRINCIPALS_GROUP: u32 = 571;
pub const DOMAIN_ALIAS_RID_NON_CACHEABLE_PRINCIPALS_GROUP: u32 = 572;
pub const DOMAIN_ALIAS_RID_EVENT_LOG_READERS_GROUP: u32 = 573;
pub const DOMAIN_ALIAS_RID_CERTSVC_DCOM_ACCESS_GROUP: u32 = 574;
pub const DOMAIN_ALIAS_RID_RDS_REMOTE_ACCESS_SERVERS: u32 = 575;
pub const DOMAIN_ALIAS_RID_RDS_ENDPOINT_SERVERS: u32 = 576;
pub const DOMAIN_ALIAS_RID_RDS_MANAGEMENT_SERVERS: u32 = 577;
pub const DOMAIN_ALIAS_RID_HYPER_V_ADMINS: u32 = 578;
pub const DOMAIN_ALIAS_RID_ACCESS_CONTROL_ASSISTANCE_OPS: u32 = 579;
pub const DOMAIN_ALIAS_RID_REMOTE_MANAGEMENT_USERS: u32 = 580;
pub const DOMAIN_ALIAS_RID_DEFAULT_ACCOUNT: u32 = 581;
pub const DOMAIN_ALIAS_RID_STORAGE_REPLICA_ADMINS: u32 = 582;
pub const DOMAIN_ALIAS_RID_DEVICE_OWNERS: u32 = 583;
pub const SECURITY_APP_PACKAGE_BASE_RID: u32 = 2;
pub const SECURITY_BUILTIN_APP_PACKAGE_RID_COUNT: u32 = 2;
pub const SECURITY_APP_PACKAGE_RID_COUNT: u32 = 8;
pub const SECURITY_CAPABILITY_BASE_RID: u32 = 3;
pub const SECURITY_CAPABILITY_APP_RID: u32 = 1024;
pub const SECURITY_BUILTIN_CAPABILITY_RID_COUNT: u32 = 2;
pub const SECURITY_CAPABILITY_RID_COUNT: u32 = 5;
pub const SECURITY_PARENT_PACKAGE_RID_COUNT: u32 = 8;
pub const SECURITY_CHILD_PACKAGE_RID_COUNT: u32 = 12;
pub const SECURITY_BUILTIN_PACKAGE_ANY_PACKAGE: u32 = 1;
pub const SECURITY_BUILTIN_PACKAGE_ANY_RESTRICTED_PACKAGE: u32 = 2;
pub const SECURITY_CAPABILITY_INTERNET_CLIENT: u32 = 1;
pub const SECURITY_CAPABILITY_INTERNET_CLIENT_SERVER: u32 = 2;
pub const SECURITY_CAPABILITY_PRIVATE_NETWORK_CLIENT_SERVER: u32 = 3;
pub const SECURITY_CAPABILITY_PICTURES_LIBRARY: u32 = 4;
pub const SECURITY_CAPABILITY_VIDEOS_LIBRARY: u32 = 5;
pub const SECURITY_CAPABILITY_MUSIC_LIBRARY: u32 = 6;
pub const SECURITY_CAPABILITY_DOCUMENTS_LIBRARY: u32 = 7;
pub const SECURITY_CAPABILITY_ENTERPRISE_AUTHENTICATION: u32 = 8;
pub const SECURITY_CAPABILITY_SHARED_USER_CERTIFICATES: u32 = 9;
pub const SECURITY_CAPABILITY_REMOVABLE_STORAGE: u32 = 10;
pub const SECURITY_CAPABILITY_APPOINTMENTS: u32 = 11;
pub const SECURITY_CAPABILITY_CONTACTS: u32 = 12;
pub const SECURITY_CAPABILITY_INTERNET_EXPLORER: u32 = 4096;
pub const SECURITY_MANDATORY_UNTRUSTED_RID: u32 = 0;
pub const SECURITY_MANDATORY_LOW_RID: u32 = 4096;
pub const SECURITY_MANDATORY_MEDIUM_RID: u32 = 8192;
pub const SECURITY_MANDATORY_MEDIUM_PLUS_RID: u32 = 8448;
pub const SECURITY_MANDATORY_HIGH_RID: u32 = 12288;
pub const SECURITY_MANDATORY_SYSTEM_RID: u32 = 16384;
pub const SECURITY_MANDATORY_PROTECTED_PROCESS_RID: u32 = 20480;
pub const SECURITY_MANDATORY_MAXIMUM_USER_RID: u32 = 16384;
pub const SECURITY_AUTHENTICATION_AUTHORITY_RID_COUNT: u32 = 1;
pub const SECURITY_AUTHENTICATION_AUTHORITY_ASSERTED_RID: u32 = 1;
pub const SECURITY_AUTHENTICATION_SERVICE_ASSERTED_RID: u32 = 2;
pub const SECURITY_AUTHENTICATION_FRESH_KEY_AUTH_RID: u32 = 3;
pub const SECURITY_AUTHENTICATION_KEY_TRUST_RID: u32 = 4;
pub const SECURITY_AUTHENTICATION_KEY_PROPERTY_MFA_RID: u32 = 5;
pub const SECURITY_AUTHENTICATION_KEY_PROPERTY_ATTESTATION_RID: u32 = 6;
pub const SECURITY_PROCESS_TRUST_AUTHORITY_RID_COUNT: u32 = 2;
pub const SECURITY_PROCESS_PROTECTION_TYPE_FULL_RID: u32 = 1024;
pub const SECURITY_PROCESS_PROTECTION_TYPE_LITE_RID: u32 = 512;
pub const SECURITY_PROCESS_PROTECTION_TYPE_NONE_RID: u32 = 0;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_WINTCB_RID: u32 = 8192;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_WINDOWS_RID: u32 = 4096;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_APP_RID: u32 = 2048;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_ANTIMALWARE_RID: u32 = 1536;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_AUTHENTICODE_RID: u32 = 1024;
pub const SECURITY_PROCESS_PROTECTION_LEVEL_NONE_RID: u32 = 0;
pub const SECURITY_TRUSTED_INSTALLER_RID1: u32 = 956008885;
pub const SECURITY_TRUSTED_INSTALLER_RID2: u32 = 3418522649;
pub const SECURITY_TRUSTED_INSTALLER_RID3: u32 = 1831038044;
pub const SECURITY_TRUSTED_INSTALLER_RID4: u32 = 1853292631;
pub const SECURITY_TRUSTED_INSTALLER_RID5: u32 = 2271478464;
pub const SE_GROUP_MANDATORY: u32 = 1;
pub const SE_GROUP_ENABLED_BY_DEFAULT: u32 = 2;
pub const SE_GROUP_ENABLED: u32 = 4;
pub const SE_GROUP_OWNER: u32 = 8;
pub const SE_GROUP_USE_FOR_DENY_ONLY: u32 = 16;
pub const SE_GROUP_INTEGRITY: u32 = 32;
pub const SE_GROUP_INTEGRITY_ENABLED: u32 = 64;
pub const SE_GROUP_LOGON_ID: u32 = 3221225472;
pub const SE_GROUP_RESOURCE: u32 = 536870912;
pub const SE_GROUP_VALID_ATTRIBUTES: u32 = 3758096511;
pub const ACL_REVISION: u32 = 2;
pub const ACL_REVISION_DS: u32 = 4;
pub const ACL_REVISION1: u32 = 1;
pub const ACL_REVISION2: u32 = 2;
pub const ACL_REVISION3: u32 = 3;
pub const ACL_REVISION4: u32 = 4;
pub const MAX_ACL_REVISION: u32 = 4;
pub const ACCESS_MIN_MS_ACE_TYPE: u32 = 0;
pub const ACCESS_ALLOWED_ACE_TYPE: u32 = 0;
pub const ACCESS_DENIED_ACE_TYPE: u32 = 1;
pub const SYSTEM_AUDIT_ACE_TYPE: u32 = 2;
pub const SYSTEM_ALARM_ACE_TYPE: u32 = 3;
pub const ACCESS_MAX_MS_V2_ACE_TYPE: u32 = 3;
pub const ACCESS_ALLOWED_COMPOUND_ACE_TYPE: u32 = 4;
pub const ACCESS_MAX_MS_V3_ACE_TYPE: u32 = 4;
pub const ACCESS_MIN_MS_OBJECT_ACE_TYPE: u32 = 5;
pub const ACCESS_ALLOWED_OBJECT_ACE_TYPE: u32 = 5;
pub const ACCESS_DENIED_OBJECT_ACE_TYPE: u32 = 6;
pub const SYSTEM_AUDIT_OBJECT_ACE_TYPE: u32 = 7;
pub const SYSTEM_ALARM_OBJECT_ACE_TYPE: u32 = 8;
pub const ACCESS_MAX_MS_OBJECT_ACE_TYPE: u32 = 8;
pub const ACCESS_MAX_MS_V4_ACE_TYPE: u32 = 8;
pub const ACCESS_MAX_MS_ACE_TYPE: u32 = 8;
pub const ACCESS_ALLOWED_CALLBACK_ACE_TYPE: u32 = 9;
pub const ACCESS_DENIED_CALLBACK_ACE_TYPE: u32 = 10;
pub const ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE: u32 = 11;
pub const ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE: u32 = 12;
pub const SYSTEM_AUDIT_CALLBACK_ACE_TYPE: u32 = 13;
pub const SYSTEM_ALARM_CALLBACK_ACE_TYPE: u32 = 14;
pub const SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE: u32 = 15;
pub const SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE: u32 = 16;
pub const SYSTEM_MANDATORY_LABEL_ACE_TYPE: u32 = 17;
pub const SYSTEM_RESOURCE_ATTRIBUTE_ACE_TYPE: u32 = 18;
pub const SYSTEM_SCOPED_POLICY_ID_ACE_TYPE: u32 = 19;
pub const SYSTEM_PROCESS_TRUST_LABEL_ACE_TYPE: u32 = 20;
pub const SYSTEM_ACCESS_FILTER_ACE_TYPE: u32 = 21;
pub const ACCESS_MAX_MS_V5_ACE_TYPE: u32 = 21;
pub const OBJECT_INHERIT_ACE: u32 = 1;
pub const CONTAINER_INHERIT_ACE: u32 = 2;
pub const NO_PROPAGATE_INHERIT_ACE: u32 = 4;
pub const INHERIT_ONLY_ACE: u32 = 8;
pub const INHERITED_ACE: u32 = 16;
pub const VALID_INHERIT_FLAGS: u32 = 31;
pub const CRITICAL_ACE_FLAG: u32 = 32;
pub const SUCCESSFUL_ACCESS_ACE_FLAG: u32 = 64;
pub const FAILED_ACCESS_ACE_FLAG: u32 = 128;
pub const TRUST_PROTECTED_FILTER_ACE_FLAG: u32 = 64;
pub const SYSTEM_MANDATORY_LABEL_NO_WRITE_UP: u32 = 1;
pub const SYSTEM_MANDATORY_LABEL_NO_READ_UP: u32 = 2;
pub const SYSTEM_MANDATORY_LABEL_NO_EXECUTE_UP: u32 = 4;
pub const SYSTEM_MANDATORY_LABEL_VALID_MASK: u32 = 7;
pub const SYSTEM_PROCESS_TRUST_LABEL_VALID_MASK: u32 = 16777215;
pub const SYSTEM_PROCESS_TRUST_NOCONSTRAINT_MASK: u32 = 4294967295;
pub const SYSTEM_ACCESS_FILTER_VALID_MASK: u32 = 16777215;
pub const SYSTEM_ACCESS_FILTER_NOCONSTRAINT_MASK: u32 = 4294967295;
pub const ACE_OBJECT_TYPE_PRESENT: u32 = 1;
pub const ACE_INHERITED_OBJECT_TYPE_PRESENT: u32 = 2;
pub const SECURITY_DESCRIPTOR_REVISION: u32 = 1;
pub const SECURITY_DESCRIPTOR_REVISION1: u32 = 1;
pub const SE_OWNER_DEFAULTED: u32 = 1;
pub const SE_GROUP_DEFAULTED: u32 = 2;
pub const SE_DACL_PRESENT: u32 = 4;
pub const SE_DACL_DEFAULTED: u32 = 8;
pub const SE_SACL_PRESENT: u32 = 16;
pub const SE_SACL_DEFAULTED: u32 = 32;
pub const SE_DACL_AUTO_INHERIT_REQ: u32 = 256;
pub const SE_SACL_AUTO_INHERIT_REQ: u32 = 512;
pub const SE_DACL_AUTO_INHERITED: u32 = 1024;
pub const SE_SACL_AUTO_INHERITED: u32 = 2048;
pub const SE_DACL_PROTECTED: u32 = 4096;
pub const SE_SACL_PROTECTED: u32 = 8192;
pub const SE_RM_CONTROL_VALID: u32 = 16384;
pub const SE_SELF_RELATIVE: u32 = 32768;
pub const ACCESS_OBJECT_GUID: u32 = 0;
pub const ACCESS_PROPERTY_SET_GUID: u32 = 1;
pub const ACCESS_PROPERTY_GUID: u32 = 2;
pub const ACCESS_MAX_LEVEL: u32 = 4;
pub const AUDIT_ALLOW_NO_PRIVILEGE: u32 = 1;
pub const ACCESS_DS_SOURCE_A: &[u8; 3] = b"DS\0";
pub const ACCESS_DS_SOURCE_W: &[u8; 3] = b"DS\0";
pub const ACCESS_DS_OBJECT_TYPE_NAME_A: &[u8; 25] = b"Directory Service Object\0";
pub const ACCESS_DS_OBJECT_TYPE_NAME_W: &[u8; 25] = b"Directory Service Object\0";
pub const SE_PRIVILEGE_ENABLED_BY_DEFAULT: u32 = 1;
pub const SE_PRIVILEGE_ENABLED: u32 = 2;
pub const SE_PRIVILEGE_REMOVED: u32 = 4;
pub const SE_PRIVILEGE_USED_FOR_ACCESS: u32 = 2147483648;
pub const SE_PRIVILEGE_VALID_ATTRIBUTES: u32 = 2147483655;
pub const PRIVILEGE_SET_ALL_NECESSARY: u32 = 1;
pub const ACCESS_REASON_TYPE_MASK: u32 = 16711680;
pub const ACCESS_REASON_DATA_MASK: u32 = 65535;
pub const ACCESS_REASON_STAGING_MASK: u32 = 2147483648;
pub const ACCESS_REASON_EXDATA_MASK: u32 = 2130706432;
pub const SE_SECURITY_DESCRIPTOR_FLAG_NO_OWNER_ACE: u32 = 1;
pub const SE_SECURITY_DESCRIPTOR_FLAG_NO_LABEL_ACE: u32 = 2;
pub const SE_SECURITY_DESCRIPTOR_FLAG_NO_ACCESS_FILTER_ACE: u32 = 4;
pub const SE_SECURITY_DESCRIPTOR_VALID_FLAGS: u32 = 7;
pub const SE_ACCESS_CHECK_FLAG_NO_LEARNING_MODE_LOGGING: u32 = 8;
pub const SE_ACCESS_CHECK_VALID_FLAGS: u32 = 8;
pub const SE_ACTIVATE_AS_USER_CAPABILITY: &[u8; 15] = b"activateAsUser\0";
pub const SE_CONSTRAINED_IMPERSONATION_CAPABILITY: &[u8; 25] = b"constrainedImpersonation\0";
pub const SE_SESSION_IMPERSONATION_CAPABILITY: &[u8; 21] = b"sessionImpersonation\0";
pub const SE_MUMA_CAPABILITY: &[u8; 5] = b"muma\0";
pub const SE_DEVELOPMENT_MODE_NETWORK_CAPABILITY: &[u8; 23] = b"developmentModeNetwork\0";
pub const SE_PERMISSIVE_LEARNING_MODE_CAPABILITY: &[u8; 23] = b"permissiveLearningMode\0";
pub const TOKEN_ASSIGN_PRIMARY: u32 = 1;
pub const TOKEN_DUPLICATE: u32 = 2;
pub const TOKEN_IMPERSONATE: u32 = 4;
pub const TOKEN_QUERY: u32 = 8;
pub const TOKEN_QUERY_SOURCE: u32 = 16;
pub const TOKEN_ADJUST_PRIVILEGES: u32 = 32;
pub const TOKEN_ADJUST_GROUPS: u32 = 64;
pub const TOKEN_ADJUST_DEFAULT: u32 = 128;
pub const TOKEN_ADJUST_SESSIONID: u32 = 256;
pub const TOKEN_ALL_ACCESS_P: u32 = 983295;
pub const TOKEN_ALL_ACCESS: u32 = 983551;
pub const TOKEN_READ: u32 = 131080;
pub const TOKEN_WRITE: u32 = 131296;
pub const TOKEN_EXECUTE: u32 = 131072;
pub const TOKEN_TRUST_CONSTRAINT_MASK: u32 = 131096;
pub const TOKEN_ACCESS_PSEUDO_HANDLE_WIN8: u32 = 24;
pub const TOKEN_ACCESS_PSEUDO_HANDLE: u32 = 24;
pub const TOKEN_MANDATORY_POLICY_OFF: u32 = 0;
pub const TOKEN_MANDATORY_POLICY_NO_WRITE_UP: u32 = 1;
pub const TOKEN_MANDATORY_POLICY_NEW_PROCESS_MIN: u32 = 2;
pub const TOKEN_MANDATORY_POLICY_VALID_MASK: u32 = 3;
pub const POLICY_AUDIT_SUBCATEGORY_COUNT: u32 = 59;
pub const TOKEN_SOURCE_LENGTH: u32 = 8;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_INVALID: u32 = 0;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_INT64: u32 = 1;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_UINT64: u32 = 2;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_STRING: u32 = 3;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_FQBN: u32 = 4;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_SID: u32 = 5;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_BOOLEAN: u32 = 6;
pub const CLAIM_SECURITY_ATTRIBUTE_TYPE_OCTET_STRING: u32 = 16;
pub const CLAIM_SECURITY_ATTRIBUTE_NON_INHERITABLE: u32 = 1;
pub const CLAIM_SECURITY_ATTRIBUTE_VALUE_CASE_SENSITIVE: u32 = 2;
pub const CLAIM_SECURITY_ATTRIBUTE_USE_FOR_DENY_ONLY: u32 = 4;
pub const CLAIM_SECURITY_ATTRIBUTE_DISABLED_BY_DEFAULT: u32 = 8;
pub const CLAIM_SECURITY_ATTRIBUTE_DISABLED: u32 = 16;
pub const CLAIM_SECURITY_ATTRIBUTE_MANDATORY: u32 = 32;
pub const CLAIM_SECURITY_ATTRIBUTE_VALID_FLAGS: u32 = 63;
pub const CLAIM_SECURITY_ATTRIBUTE_CUSTOM_FLAGS: u32 = 4294901760;
pub const CLAIM_SECURITY_ATTRIBUTES_INFORMATION_VERSION_V1: u32 = 1;
pub const CLAIM_SECURITY_ATTRIBUTES_INFORMATION_VERSION: u32 = 1;
pub const SECURITY_DYNAMIC_TRACKING: u32 = 1;
pub const SECURITY_STATIC_TRACKING: u32 = 0;
pub const DISABLE_MAX_PRIVILEGE: u32 = 1;
pub const SANDBOX_INERT: u32 = 2;
pub const LUA_TOKEN: u32 = 4;
pub const WRITE_RESTRICTED: u32 = 8;
pub const OWNER_SECURITY_INFORMATION: u32 = 1;
pub const GROUP_SECURITY_INFORMATION: u32 = 2;
pub const DACL_SECURITY_INFORMATION: u32 = 4;
pub const SACL_SECURITY_INFORMATION: u32 = 8;
pub const LABEL_SECURITY_INFORMATION: u32 = 16;
pub const ATTRIBUTE_SECURITY_INFORMATION: u32 = 32;
pub const SCOPE_SECURITY_INFORMATION: u32 = 64;
pub const PROCESS_TRUST_LABEL_SECURITY_INFORMATION: u32 = 128;
pub const ACCESS_FILTER_SECURITY_INFORMATION: u32 = 256;
pub const BACKUP_SECURITY_INFORMATION: u32 = 65536;
pub const PROTECTED_DACL_SECURITY_INFORMATION: u32 = 2147483648;
pub const PROTECTED_SACL_SECURITY_INFORMATION: u32 = 1073741824;
pub const UNPROTECTED_DACL_SECURITY_INFORMATION: u32 = 536870912;
pub const UNPROTECTED_SACL_SECURITY_INFORMATION: u32 = 268435456;
pub const SE_SIGNING_LEVEL_UNCHECKED: u32 = 0;
pub const SE_SIGNING_LEVEL_UNSIGNED: u32 = 1;
pub const SE_SIGNING_LEVEL_ENTERPRISE: u32 = 2;
pub const SE_SIGNING_LEVEL_CUSTOM_1: u32 = 3;
pub const SE_SIGNING_LEVEL_DEVELOPER: u32 = 3;
pub const SE_SIGNING_LEVEL_AUTHENTICODE: u32 = 4;
pub const SE_SIGNING_LEVEL_CUSTOM_2: u32 = 5;
pub const SE_SIGNING_LEVEL_STORE: u32 = 6;
pub const SE_SIGNING_LEVEL_CUSTOM_3: u32 = 7;
pub const SE_SIGNING_LEVEL_ANTIMALWARE: u32 = 7;
pub const SE_SIGNING_LEVEL_MICROSOFT: u32 = 8;
pub const SE_SIGNING_LEVEL_CUSTOM_4: u32 = 9;
pub const SE_SIGNING_LEVEL_CUSTOM_5: u32 = 10;
pub const SE_SIGNING_LEVEL_DYNAMIC_CODEGEN: u32 = 11;
pub const SE_SIGNING_LEVEL_WINDOWS: u32 = 12;
pub const SE_SIGNING_LEVEL_CUSTOM_7: u32 = 13;
pub const SE_SIGNING_LEVEL_WINDOWS_TCB: u32 = 14;
pub const SE_SIGNING_LEVEL_CUSTOM_6: u32 = 15;
pub const SE_LEARNING_MODE_FLAG_PERMISSIVE: u32 = 1;
pub const PROCESS_TERMINATE: u32 = 1;
pub const PROCESS_CREATE_THREAD: u32 = 2;
pub const PROCESS_SET_SESSIONID: u32 = 4;
pub const PROCESS_VM_OPERATION: u32 = 8;
pub const PROCESS_VM_READ: u32 = 16;
pub const PROCESS_VM_WRITE: u32 = 32;
pub const PROCESS_DUP_HANDLE: u32 = 64;
pub const PROCESS_CREATE_PROCESS: u32 = 128;
pub const PROCESS_SET_QUOTA: u32 = 256;
pub const PROCESS_SET_INFORMATION: u32 = 512;
pub const PROCESS_QUERY_INFORMATION: u32 = 1024;
pub const PROCESS_SUSPEND_RESUME: u32 = 2048;
pub const PROCESS_QUERY_LIMITED_INFORMATION: u32 = 4096;
pub const PROCESS_SET_LIMITED_INFORMATION: u32 = 8192;
pub const PROCESS_ALL_ACCESS: u32 = 2097151;
pub const THREAD_TERMINATE: u32 = 1;
pub const THREAD_SUSPEND_RESUME: u32 = 2;
pub const THREAD_GET_CONTEXT: u32 = 8;
pub const THREAD_SET_CONTEXT: u32 = 16;
pub const THREAD_QUERY_INFORMATION: u32 = 64;
pub const THREAD_SET_INFORMATION: u32 = 32;
pub const THREAD_SET_THREAD_TOKEN: u32 = 128;
pub const THREAD_IMPERSONATE: u32 = 256;
pub const THREAD_DIRECT_IMPERSONATION: u32 = 512;
pub const THREAD_SET_LIMITED_INFORMATION: u32 = 1024;
pub const THREAD_QUERY_LIMITED_INFORMATION: u32 = 2048;
pub const THREAD_RESUME: u32 = 4096;
pub const THREAD_ALL_ACCESS: u32 = 2097151;
pub const JOB_OBJECT_ASSIGN_PROCESS: u32 = 1;
pub const JOB_OBJECT_SET_ATTRIBUTES: u32 = 2;
pub const JOB_OBJECT_QUERY: u32 = 4;
pub const JOB_OBJECT_TERMINATE: u32 = 8;
pub const JOB_OBJECT_SET_SECURITY_ATTRIBUTES: u32 = 16;
pub const JOB_OBJECT_IMPERSONATE: u32 = 32;
pub const JOB_OBJECT_ALL_ACCESS: u32 = 2031679;
pub const FLS_MAXIMUM_AVAILABLE: u32 = 4080;
pub const TLS_MINIMUM_AVAILABLE: u32 = 64;
pub const THREAD_DYNAMIC_CODE_ALLOW: u32 = 1;
pub const THREAD_BASE_PRIORITY_LOWRT: u32 = 15;
pub const THREAD_BASE_PRIORITY_MAX: u32 = 2;
pub const THREAD_BASE_PRIORITY_MIN: i32 = -2;
pub const THREAD_BASE_PRIORITY_IDLE: i32 = -15;
pub const COMPONENT_KTM: u32 = 1;
pub const COMPONENT_VALID_FLAGS: u32 = 1;
pub const MEMORY_PRIORITY_LOWEST: u32 = 0;
pub const MEMORY_PRIORITY_VERY_LOW: u32 = 1;
pub const MEMORY_PRIORITY_LOW: u32 = 2;
pub const MEMORY_PRIORITY_MEDIUM: u32 = 3;
pub const MEMORY_PRIORITY_BELOW_NORMAL: u32 = 4;
pub const MEMORY_PRIORITY_NORMAL: u32 = 5;
pub const DYNAMIC_EH_CONTINUATION_TARGET_ADD: u32 = 1;
pub const DYNAMIC_EH_CONTINUATION_TARGET_PROCESSED: u32 = 2;
pub const DYNAMIC_ENFORCED_ADDRESS_RANGE_ADD: u32 = 1;
pub const DYNAMIC_ENFORCED_ADDRESS_RANGE_PROCESSED: u32 = 2;
pub const QUOTA_LIMITS_HARDWS_MIN_ENABLE: u32 = 1;
pub const QUOTA_LIMITS_HARDWS_MIN_DISABLE: u32 = 2;
pub const QUOTA_LIMITS_HARDWS_MAX_ENABLE: u32 = 4;
pub const QUOTA_LIMITS_HARDWS_MAX_DISABLE: u32 = 8;
pub const QUOTA_LIMITS_USE_DEFAULT_LIMITS: u32 = 16;
pub const MAX_HW_COUNTERS: u32 = 16;
pub const THREAD_PROFILING_FLAG_DISPATCH: u32 = 1;
pub const JOB_OBJECT_NET_RATE_CONTROL_MAX_DSCP_TAG: u32 = 64;
pub const JOB_OBJECT_TERMINATE_AT_END_OF_JOB: u32 = 0;
pub const JOB_OBJECT_POST_AT_END_OF_JOB: u32 = 1;
pub const JOB_OBJECT_MSG_END_OF_JOB_TIME: u32 = 1;
pub const JOB_OBJECT_MSG_END_OF_PROCESS_TIME: u32 = 2;
pub const JOB_OBJECT_MSG_ACTIVE_PROCESS_LIMIT: u32 = 3;
pub const JOB_OBJECT_MSG_ACTIVE_PROCESS_ZERO: u32 = 4;
pub const JOB_OBJECT_MSG_NEW_PROCESS: u32 = 6;
pub const JOB_OBJECT_MSG_EXIT_PROCESS: u32 = 7;
pub const JOB_OBJECT_MSG_ABNORMAL_EXIT_PROCESS: u32 = 8;
pub const JOB_OBJECT_MSG_PROCESS_MEMORY_LIMIT: u32 = 9;
pub const JOB_OBJECT_MSG_JOB_MEMORY_LIMIT: u32 = 10;
pub const JOB_OBJECT_MSG_NOTIFICATION_LIMIT: u32 = 11;
pub const JOB_OBJECT_MSG_JOB_CYCLE_TIME_LIMIT: u32 = 12;
pub const JOB_OBJECT_MSG_SILO_TERMINATED: u32 = 13;
pub const JOB_OBJECT_MSG_MINIMUM: u32 = 1;
pub const JOB_OBJECT_MSG_MAXIMUM: u32 = 13;
pub const JOB_OBJECT_VALID_COMPLETION_FILTER: u32 = 16382;
pub const JOB_OBJECT_LIMIT_WORKINGSET: u32 = 1;
pub const JOB_OBJECT_LIMIT_PROCESS_TIME: u32 = 2;
pub const JOB_OBJECT_LIMIT_JOB_TIME: u32 = 4;
pub const JOB_OBJECT_LIMIT_ACTIVE_PROCESS: u32 = 8;
pub const JOB_OBJECT_LIMIT_AFFINITY: u32 = 16;
pub const JOB_OBJECT_LIMIT_PRIORITY_CLASS: u32 = 32;
pub const JOB_OBJECT_LIMIT_PRESERVE_JOB_TIME: u32 = 64;
pub const JOB_OBJECT_LIMIT_SCHEDULING_CLASS: u32 = 128;
pub const JOB_OBJECT_LIMIT_PROCESS_MEMORY: u32 = 256;
pub const JOB_OBJECT_LIMIT_JOB_MEMORY: u32 = 512;
pub const JOB_OBJECT_LIMIT_JOB_MEMORY_HIGH: u32 = 512;
pub const JOB_OBJECT_LIMIT_DIE_ON_UNHANDLED_EXCEPTION: u32 = 1024;
pub const JOB_OBJECT_LIMIT_BREAKAWAY_OK: u32 = 2048;
pub const JOB_OBJECT_LIMIT_SILENT_BREAKAWAY_OK: u32 = 4096;
pub const JOB_OBJECT_LIMIT_KILL_ON_JOB_CLOSE: u32 = 8192;
pub const JOB_OBJECT_LIMIT_SUBSET_AFFINITY: u32 = 16384;
pub const JOB_OBJECT_LIMIT_JOB_MEMORY_LOW: u32 = 32768;
pub const JOB_OBJECT_LIMIT_JOB_READ_BYTES: u32 = 65536;
pub const JOB_OBJECT_LIMIT_JOB_WRITE_BYTES: u32 = 131072;
pub const JOB_OBJECT_LIMIT_RATE_CONTROL: u32 = 262144;
pub const JOB_OBJECT_LIMIT_CPU_RATE_CONTROL: u32 = 262144;
pub const JOB_OBJECT_LIMIT_IO_RATE_CONTROL: u32 = 524288;
pub const JOB_OBJECT_LIMIT_NET_RATE_CONTROL: u32 = 1048576;
pub const JOB_OBJECT_LIMIT_VALID_FLAGS: u32 = 524287;
pub const JOB_OBJECT_BASIC_LIMIT_VALID_FLAGS: u32 = 255;
pub const JOB_OBJECT_EXTENDED_LIMIT_VALID_FLAGS: u32 = 32767;
pub const JOB_OBJECT_NOTIFICATION_LIMIT_VALID_FLAGS: u32 = 2064900;
pub const JOB_OBJECT_UILIMIT_NONE: u32 = 0;
pub const JOB_OBJECT_UILIMIT_HANDLES: u32 = 1;
pub const JOB_OBJECT_UILIMIT_READCLIPBOARD: u32 = 2;
pub const JOB_OBJECT_UILIMIT_WRITECLIPBOARD: u32 = 4;
pub const JOB_OBJECT_UILIMIT_SYSTEMPARAMETERS: u32 = 8;
pub const JOB_OBJECT_UILIMIT_DISPLAYSETTINGS: u32 = 16;
pub const JOB_OBJECT_UILIMIT_GLOBALATOMS: u32 = 32;
pub const JOB_OBJECT_UILIMIT_DESKTOP: u32 = 64;
pub const JOB_OBJECT_UILIMIT_EXITWINDOWS: u32 = 128;
pub const JOB_OBJECT_UILIMIT_ALL: u32 = 255;
pub const JOB_OBJECT_UI_VALID_FLAGS: u32 = 255;
pub const JOB_OBJECT_SECURITY_NO_ADMIN: u32 = 1;
pub const JOB_OBJECT_SECURITY_RESTRICTED_TOKEN: u32 = 2;
pub const JOB_OBJECT_SECURITY_ONLY_TOKEN: u32 = 4;
pub const JOB_OBJECT_SECURITY_FILTER_TOKENS: u32 = 8;
pub const JOB_OBJECT_SECURITY_VALID_FLAGS: u32 = 15;
pub const JOB_OBJECT_CPU_RATE_CONTROL_ENABLE: u32 = 1;
pub const JOB_OBJECT_CPU_RATE_CONTROL_WEIGHT_BASED: u32 = 2;
pub const JOB_OBJECT_CPU_RATE_CONTROL_HARD_CAP: u32 = 4;
pub const JOB_OBJECT_CPU_RATE_CONTROL_NOTIFY: u32 = 8;
pub const JOB_OBJECT_CPU_RATE_CONTROL_MIN_MAX_RATE: u32 = 16;
pub const JOB_OBJECT_CPU_RATE_CONTROL_VALID_FLAGS: u32 = 31;
pub const MEMORY_PARTITION_QUERY_ACCESS: u32 = 1;
pub const MEMORY_PARTITION_MODIFY_ACCESS: u32 = 2;
pub const MEMORY_PARTITION_ALL_ACCESS: u32 = 2031619;
pub const EVENT_MODIFY_STATE: u32 = 2;
pub const EVENT_ALL_ACCESS: u32 = 2031619;
pub const MUTANT_QUERY_STATE: u32 = 1;
pub const MUTANT_ALL_ACCESS: u32 = 2031617;
pub const SEMAPHORE_MODIFY_STATE: u32 = 2;
pub const SEMAPHORE_ALL_ACCESS: u32 = 2031619;
pub const TIMER_QUERY_STATE: u32 = 1;
pub const TIMER_MODIFY_STATE: u32 = 2;
pub const TIMER_ALL_ACCESS: u32 = 2031619;
pub const TIME_ZONE_ID_UNKNOWN: u32 = 0;
pub const TIME_ZONE_ID_STANDARD: u32 = 1;
pub const TIME_ZONE_ID_DAYLIGHT: u32 = 2;
pub const LTP_PC_SMT: u32 = 1;
pub const CACHE_FULLY_ASSOCIATIVE: u32 = 255;
pub const SYSTEM_CPU_SET_INFORMATION_PARKED: u32 = 1;
pub const SYSTEM_CPU_SET_INFORMATION_ALLOCATED: u32 = 2;
pub const SYSTEM_CPU_SET_INFORMATION_ALLOCATED_TO_TARGET_PROCESS: u32 = 4;
pub const SYSTEM_CPU_SET_INFORMATION_REALTIME: u32 = 8;
pub const PROCESSOR_INTEL_386: u32 = 386;
pub const PROCESSOR_INTEL_486: u32 = 486;
pub const PROCESSOR_INTEL_PENTIUM: u32 = 586;
pub const PROCESSOR_INTEL_IA64: u32 = 2200;
pub const PROCESSOR_AMD_X8664: u32 = 8664;
pub const PROCESSOR_MIPS_R4000: u32 = 4000;
pub const PROCESSOR_ALPHA_21064: u32 = 21064;
pub const PROCESSOR_PPC_601: u32 = 601;
pub const PROCESSOR_PPC_603: u32 = 603;
pub const PROCESSOR_PPC_604: u32 = 604;
pub const PROCESSOR_PPC_620: u32 = 620;
pub const PROCESSOR_HITACHI_SH3: u32 = 10003;
pub const PROCESSOR_HITACHI_SH3E: u32 = 10004;
pub const PROCESSOR_HITACHI_SH4: u32 = 10005;
pub const PROCESSOR_MOTOROLA_821: u32 = 821;
pub const PROCESSOR_SHx_SH3: u32 = 103;
pub const PROCESSOR_SHx_SH4: u32 = 104;
pub const PROCESSOR_STRONGARM: u32 = 2577;
pub const PROCESSOR_ARM720: u32 = 1824;
pub const PROCESSOR_ARM820: u32 = 2080;
pub const PROCESSOR_ARM920: u32 = 2336;
pub const PROCESSOR_ARM_7TDMI: u32 = 70001;
pub const PROCESSOR_OPTIL: u32 = 18767;
pub const PROCESSOR_ARCHITECTURE_INTEL: u32 = 0;
pub const PROCESSOR_ARCHITECTURE_MIPS: u32 = 1;
pub const PROCESSOR_ARCHITECTURE_ALPHA: u32 = 2;
pub const PROCESSOR_ARCHITECTURE_PPC: u32 = 3;
pub const PROCESSOR_ARCHITECTURE_SHX: u32 = 4;
pub const PROCESSOR_ARCHITECTURE_ARM: u32 = 5;
pub const PROCESSOR_ARCHITECTURE_IA64: u32 = 6;
pub const PROCESSOR_ARCHITECTURE_ALPHA64: u32 = 7;
pub const PROCESSOR_ARCHITECTURE_MSIL: u32 = 8;
pub const PROCESSOR_ARCHITECTURE_AMD64: u32 = 9;
pub const PROCESSOR_ARCHITECTURE_IA32_ON_WIN64: u32 = 10;
pub const PROCESSOR_ARCHITECTURE_NEUTRAL: u32 = 11;
pub const PROCESSOR_ARCHITECTURE_ARM64: u32 = 12;
pub const PROCESSOR_ARCHITECTURE_ARM32_ON_WIN64: u32 = 13;
pub const PROCESSOR_ARCHITECTURE_IA32_ON_ARM64: u32 = 14;
pub const PROCESSOR_ARCHITECTURE_UNKNOWN: u32 = 65535;
pub const PF_FLOATING_POINT_PRECISION_ERRATA: u32 = 0;
pub const PF_FLOATING_POINT_EMULATED: u32 = 1;
pub const PF_COMPARE_EXCHANGE_DOUBLE: u32 = 2;
pub const PF_MMX_INSTRUCTIONS_AVAILABLE: u32 = 3;
pub const PF_PPC_MOVEMEM_64BIT_OK: u32 = 4;
pub const PF_ALPHA_BYTE_INSTRUCTIONS: u32 = 5;
pub const PF_XMMI_INSTRUCTIONS_AVAILABLE: u32 = 6;
pub const PF_3DNOW_INSTRUCTIONS_AVAILABLE: u32 = 7;
pub const PF_RDTSC_INSTRUCTION_AVAILABLE: u32 = 8;
pub const PF_PAE_ENABLED: u32 = 9;
pub const PF_XMMI64_INSTRUCTIONS_AVAILABLE: u32 = 10;
pub const PF_SSE_DAZ_MODE_AVAILABLE: u32 = 11;
pub const PF_NX_ENABLED: u32 = 12;
pub const PF_SSE3_INSTRUCTIONS_AVAILABLE: u32 = 13;
pub const PF_COMPARE_EXCHANGE128: u32 = 14;
pub const PF_COMPARE64_EXCHANGE128: u32 = 15;
pub const PF_CHANNELS_ENABLED: u32 = 16;
pub const PF_XSAVE_ENABLED: u32 = 17;
pub const PF_ARM_VFP_32_REGISTERS_AVAILABLE: u32 = 18;
pub const PF_ARM_NEON_INSTRUCTIONS_AVAILABLE: u32 = 19;
pub const PF_SECOND_LEVEL_ADDRESS_TRANSLATION: u32 = 20;
pub const PF_VIRT_FIRMWARE_ENABLED: u32 = 21;
pub const PF_RDWRFSGSBASE_AVAILABLE: u32 = 22;
pub const PF_FASTFAIL_AVAILABLE: u32 = 23;
pub const PF_ARM_DIVIDE_INSTRUCTION_AVAILABLE: u32 = 24;
pub const PF_ARM_64BIT_LOADSTORE_ATOMIC: u32 = 25;
pub const PF_ARM_EXTERNAL_CACHE_AVAILABLE: u32 = 26;
pub const PF_ARM_FMAC_INSTRUCTIONS_AVAILABLE: u32 = 27;
pub const PF_RDRAND_INSTRUCTION_AVAILABLE: u32 = 28;
pub const PF_ARM_V8_INSTRUCTIONS_AVAILABLE: u32 = 29;
pub const PF_ARM_V8_CRYPTO_INSTRUCTIONS_AVAILABLE: u32 = 30;
pub const PF_ARM_V8_CRC32_INSTRUCTIONS_AVAILABLE: u32 = 31;
pub const PF_RDTSCP_INSTRUCTION_AVAILABLE: u32 = 32;
pub const PF_RDPID_INSTRUCTION_AVAILABLE: u32 = 33;
pub const PF_ARM_V81_ATOMIC_INSTRUCTIONS_AVAILABLE: u32 = 34;
pub const PF_MONITORX_INSTRUCTION_AVAILABLE: u32 = 35;
pub const PF_SSSE3_INSTRUCTIONS_AVAILABLE: u32 = 36;
pub const PF_SSE4_1_INSTRUCTIONS_AVAILABLE: u32 = 37;
pub const PF_SSE4_2_INSTRUCTIONS_AVAILABLE: u32 = 38;
pub const PF_AVX_INSTRUCTIONS_AVAILABLE: u32 = 39;
pub const PF_AVX2_INSTRUCTIONS_AVAILABLE: u32 = 40;
pub const PF_AVX512F_INSTRUCTIONS_AVAILABLE: u32 = 41;
pub const PF_ERMS_AVAILABLE: u32 = 42;
pub const PF_ARM_V82_DP_INSTRUCTIONS_AVAILABLE: u32 = 43;
pub const PF_ARM_V83_JSCVT_INSTRUCTIONS_AVAILABLE: u32 = 44;
pub const XSTATE_LEGACY_FLOATING_POINT: u32 = 0;
pub const XSTATE_LEGACY_SSE: u32 = 1;
pub const XSTATE_GSSE: u32 = 2;
pub const XSTATE_AVX: u32 = 2;
pub const XSTATE_MPX_BNDREGS: u32 = 3;
pub const XSTATE_MPX_BNDCSR: u32 = 4;
pub const XSTATE_AVX512_KMASK: u32 = 5;
pub const XSTATE_AVX512_ZMM_H: u32 = 6;
pub const XSTATE_AVX512_ZMM: u32 = 7;
pub const XSTATE_IPT: u32 = 8;
pub const XSTATE_PASID: u32 = 10;
pub const XSTATE_CET_U: u32 = 11;
pub const XSTATE_CET_S: u32 = 12;
pub const XSTATE_AMX_TILE_CONFIG: u32 = 17;
pub const XSTATE_AMX_TILE_DATA: u32 = 18;
pub const XSTATE_LWP: u32 = 62;
pub const MAXIMUM_XSTATE_FEATURES: u32 = 64;
pub const XSTATE_COMPACTION_ENABLE: u32 = 63;
pub const XSTATE_ALIGN_BIT: u32 = 1;
pub const XSTATE_XFD_BIT: u32 = 2;
pub const XSTATE_CONTROLFLAG_XSAVEOPT_MASK: u32 = 1;
pub const XSTATE_CONTROLFLAG_XSAVEC_MASK: u32 = 2;
pub const XSTATE_CONTROLFLAG_XFD_MASK: u32 = 4;
pub const XSTATE_CONTROLFLAG_VALID_MASK: u32 = 7;
pub const CFG_CALL_TARGET_VALID: u32 = 1;
pub const CFG_CALL_TARGET_PROCESSED: u32 = 2;
pub const CFG_CALL_TARGET_CONVERT_EXPORT_SUPPRESSED_TO_VALID: u32 = 4;
pub const CFG_CALL_TARGET_VALID_XFG: u32 = 8;
pub const CFG_CALL_TARGET_CONVERT_XFG_TO_CFG: u32 = 16;
pub const SECTION_QUERY: u32 = 1;
pub const SECTION_MAP_WRITE: u32 = 2;
pub const SECTION_MAP_READ: u32 = 4;
pub const SECTION_MAP_EXECUTE: u32 = 8;
pub const SECTION_EXTEND_SIZE: u32 = 16;
pub const SECTION_MAP_EXECUTE_EXPLICIT: u32 = 32;
pub const SECTION_ALL_ACCESS: u32 = 983071;
pub const SESSION_QUERY_ACCESS: u32 = 1;
pub const SESSION_MODIFY_ACCESS: u32 = 2;
pub const SESSION_ALL_ACCESS: u32 = 983043;
pub const PAGE_NOACCESS: u32 = 1;
pub const PAGE_READONLY: u32 = 2;
pub const PAGE_READWRITE: u32 = 4;
pub const PAGE_WRITECOPY: u32 = 8;
pub const PAGE_EXECUTE: u32 = 16;
pub const PAGE_EXECUTE_READ: u32 = 32;
pub const PAGE_EXECUTE_READWRITE: u32 = 64;
pub const PAGE_EXECUTE_WRITECOPY: u32 = 128;
pub const PAGE_GUARD: u32 = 256;
pub const PAGE_NOCACHE: u32 = 512;
pub const PAGE_WRITECOMBINE: u32 = 1024;
pub const PAGE_GRAPHICS_NOACCESS: u32 = 2048;
pub const PAGE_GRAPHICS_READONLY: u32 = 4096;
pub const PAGE_GRAPHICS_READWRITE: u32 = 8192;
pub const PAGE_GRAPHICS_EXECUTE: u32 = 16384;
pub const PAGE_GRAPHICS_EXECUTE_READ: u32 = 32768;
pub const PAGE_GRAPHICS_EXECUTE_READWRITE: u32 = 65536;
pub const PAGE_GRAPHICS_COHERENT: u32 = 131072;
pub const PAGE_GRAPHICS_NOCACHE: u32 = 262144;
pub const PAGE_ENCLAVE_THREAD_CONTROL: u32 = 2147483648;
pub const PAGE_REVERT_TO_FILE_MAP: u32 = 2147483648;
pub const PAGE_TARGETS_NO_UPDATE: u32 = 1073741824;
pub const PAGE_TARGETS_INVALID: u32 = 1073741824;
pub const PAGE_ENCLAVE_UNVALIDATED: u32 = 536870912;
pub const PAGE_ENCLAVE_MASK: u32 = 268435456;
pub const PAGE_ENCLAVE_DECOMMIT: u32 = 268435456;
pub const PAGE_ENCLAVE_SS_FIRST: u32 = 268435457;
pub const PAGE_ENCLAVE_SS_REST: u32 = 268435458;
pub const MEM_COMMIT: u32 = 4096;
pub const MEM_RESERVE: u32 = 8192;
pub const MEM_REPLACE_PLACEHOLDER: u32 = 16384;
pub const MEM_RESERVE_PLACEHOLDER: u32 = 262144;
pub const MEM_RESET: u32 = 524288;
pub const MEM_TOP_DOWN: u32 = 1048576;
pub const MEM_WRITE_WATCH: u32 = 2097152;
pub const MEM_PHYSICAL: u32 = 4194304;
pub const MEM_ROTATE: u32 = 8388608;
pub const MEM_DIFFERENT_IMAGE_BASE_OK: u32 = 8388608;
pub const MEM_RESET_UNDO: u32 = 16777216;
pub const MEM_LARGE_PAGES: u32 = 536870912;
pub const MEM_4MB_PAGES: u32 = 2147483648;
pub const MEM_64K_PAGES: u32 = 541065216;
pub const MEM_UNMAP_WITH_TRANSIENT_BOOST: u32 = 1;
pub const MEM_COALESCE_PLACEHOLDERS: u32 = 1;
pub const MEM_PRESERVE_PLACEHOLDER: u32 = 2;
pub const MEM_DECOMMIT: u32 = 16384;
pub const MEM_RELEASE: u32 = 32768;
pub const MEM_FREE: u32 = 65536;
pub const MEM_EXTENDED_PARAMETER_GRAPHICS: u32 = 1;
pub const MEM_EXTENDED_PARAMETER_NONPAGED: u32 = 2;
pub const MEM_EXTENDED_PARAMETER_ZERO_PAGES_OPTIONAL: u32 = 4;
pub const MEM_EXTENDED_PARAMETER_NONPAGED_LARGE: u32 = 8;
pub const MEM_EXTENDED_PARAMETER_NONPAGED_HUGE: u32 = 16;
pub const MEM_EXTENDED_PARAMETER_SOFT_FAULT_PAGES: u32 = 32;
pub const MEM_EXTENDED_PARAMETER_EC_CODE: u32 = 64;
pub const MEM_EXTENDED_PARAMETER_TYPE_BITS: u32 = 8;
pub const SEC_HUGE_PAGES: u32 = 131072;
pub const SEC_PARTITION_OWNER_HANDLE: u32 = 262144;
pub const SEC_64K_PAGES: u32 = 524288;
pub const SEC_FILE: u32 = 8388608;
pub const SEC_IMAGE: u32 = 16777216;
pub const SEC_PROTECTED_IMAGE: u32 = 33554432;
pub const SEC_RESERVE: u32 = 67108864;
pub const SEC_COMMIT: u32 = 134217728;
pub const SEC_NOCACHE: u32 = 268435456;
pub const SEC_WRITECOMBINE: u32 = 1073741824;
pub const SEC_LARGE_PAGES: u32 = 2147483648;
pub const SEC_IMAGE_NO_EXECUTE: u32 = 285212672;
pub const MEM_PRIVATE: u32 = 131072;
pub const MEM_MAPPED: u32 = 262144;
pub const MEM_IMAGE: u32 = 16777216;
pub const WRITE_WATCH_FLAG_RESET: u32 = 1;
pub const ENCLAVE_TYPE_SGX: u32 = 1;
pub const ENCLAVE_TYPE_SGX2: u32 = 2;
pub const ENCLAVE_TYPE_VBS: u32 = 16;
pub const ENCLAVE_VBS_FLAG_DEBUG: u32 = 1;
pub const ENCLAVE_TYPE_VBS_BASIC: u32 = 17;
pub const VBS_BASIC_PAGE_MEASURED_DATA: u32 = 1;
pub const VBS_BASIC_PAGE_UNMEASURED_DATA: u32 = 2;
pub const VBS_BASIC_PAGE_ZERO_FILL: u32 = 3;
pub const VBS_BASIC_PAGE_THREAD_DESCRIPTOR: u32 = 4;
pub const VBS_BASIC_PAGE_SYSTEM_CALL: u32 = 5;
pub const DEDICATED_MEMORY_CACHE_ELIGIBLE: u32 = 1;
pub const FILE_READ_DATA: u32 = 1;
pub const FILE_LIST_DIRECTORY: u32 = 1;
pub const FILE_WRITE_DATA: u32 = 2;
pub const FILE_ADD_FILE: u32 = 2;
pub const FILE_APPEND_DATA: u32 = 4;
pub const FILE_ADD_SUBDIRECTORY: u32 = 4;
pub const FILE_CREATE_PIPE_INSTANCE: u32 = 4;
pub const FILE_READ_EA: u32 = 8;
pub const FILE_WRITE_EA: u32 = 16;
pub const FILE_EXECUTE: u32 = 32;
pub const FILE_TRAVERSE: u32 = 32;
pub const FILE_DELETE_CHILD: u32 = 64;
pub const FILE_READ_ATTRIBUTES: u32 = 128;
pub const FILE_WRITE_ATTRIBUTES: u32 = 256;
pub const FILE_ALL_ACCESS: u32 = 2032127;
pub const FILE_GENERIC_READ: u32 = 1179785;
pub const FILE_GENERIC_WRITE: u32 = 1179926;
pub const FILE_GENERIC_EXECUTE: u32 = 1179808;
pub const FILE_SHARE_READ: u32 = 1;
pub const FILE_SHARE_WRITE: u32 = 2;
pub const FILE_SHARE_DELETE: u32 = 4;
pub const FILE_ATTRIBUTE_READONLY: u32 = 1;
pub const FILE_ATTRIBUTE_HIDDEN: u32 = 2;
pub const FILE_ATTRIBUTE_SYSTEM: u32 = 4;
pub const FILE_ATTRIBUTE_DIRECTORY: u32 = 16;
pub const FILE_ATTRIBUTE_ARCHIVE: u32 = 32;
pub const FILE_ATTRIBUTE_DEVICE: u32 = 64;
pub const FILE_ATTRIBUTE_NORMAL: u32 = 128;
pub const FILE_ATTRIBUTE_TEMPORARY: u32 = 256;
pub const FILE_ATTRIBUTE_SPARSE_FILE: u32 = 512;
pub const FILE_ATTRIBUTE_REPARSE_POINT: u32 = 1024;
pub const FILE_ATTRIBUTE_COMPRESSED: u32 = 2048;
pub const FILE_ATTRIBUTE_OFFLINE: u32 = 4096;
pub const FILE_ATTRIBUTE_NOT_CONTENT_INDEXED: u32 = 8192;
pub const FILE_ATTRIBUTE_ENCRYPTED: u32 = 16384;
pub const FILE_ATTRIBUTE_INTEGRITY_STREAM: u32 = 32768;
pub const FILE_ATTRIBUTE_VIRTUAL: u32 = 65536;
pub const FILE_ATTRIBUTE_NO_SCRUB_DATA: u32 = 131072;
pub const FILE_ATTRIBUTE_EA: u32 = 262144;
pub const FILE_ATTRIBUTE_PINNED: u32 = 524288;
pub const FILE_ATTRIBUTE_UNPINNED: u32 = 1048576;
pub const FILE_ATTRIBUTE_RECALL_ON_OPEN: u32 = 262144;
pub const FILE_ATTRIBUTE_RECALL_ON_DATA_ACCESS: u32 = 4194304;
pub const TREE_CONNECT_ATTRIBUTE_PRIVACY: u32 = 16384;
pub const TREE_CONNECT_ATTRIBUTE_INTEGRITY: u32 = 32768;
pub const TREE_CONNECT_ATTRIBUTE_GLOBAL: u32 = 4;
pub const TREE_CONNECT_ATTRIBUTE_PINNED: u32 = 2;
pub const FILE_ATTRIBUTE_STRICTLY_SEQUENTIAL: u32 = 536870912;
pub const FILE_NOTIFY_CHANGE_FILE_NAME: u32 = 1;
pub const FILE_NOTIFY_CHANGE_DIR_NAME: u32 = 2;
pub const FILE_NOTIFY_CHANGE_ATTRIBUTES: u32 = 4;
pub const FILE_NOTIFY_CHANGE_SIZE: u32 = 8;
pub const FILE_NOTIFY_CHANGE_LAST_WRITE: u32 = 16;
pub const FILE_NOTIFY_CHANGE_LAST_ACCESS: u32 = 32;
pub const FILE_NOTIFY_CHANGE_CREATION: u32 = 64;
pub const FILE_NOTIFY_CHANGE_SECURITY: u32 = 256;
pub const FILE_ACTION_ADDED: u32 = 1;
pub const FILE_ACTION_REMOVED: u32 = 2;
pub const FILE_ACTION_MODIFIED: u32 = 3;
pub const FILE_ACTION_RENAMED_OLD_NAME: u32 = 4;
pub const FILE_ACTION_RENAMED_NEW_NAME: u32 = 5;
pub const FILE_CASE_SENSITIVE_SEARCH: u32 = 1;
pub const FILE_CASE_PRESERVED_NAMES: u32 = 2;
pub const FILE_UNICODE_ON_DISK: u32 = 4;
pub const FILE_PERSISTENT_ACLS: u32 = 8;
pub const FILE_FILE_COMPRESSION: u32 = 16;
pub const FILE_VOLUME_QUOTAS: u32 = 32;
pub const FILE_SUPPORTS_SPARSE_FILES: u32 = 64;
pub const FILE_SUPPORTS_REPARSE_POINTS: u32 = 128;
pub const FILE_SUPPORTS_REMOTE_STORAGE: u32 = 256;
pub const FILE_RETURNS_CLEANUP_RESULT_INFO: u32 = 512;
pub const FILE_SUPPORTS_POSIX_UNLINK_RENAME: u32 = 1024;
pub const FILE_SUPPORTS_BYPASS_IO: u32 = 2048;
pub const FILE_VOLUME_IS_COMPRESSED: u32 = 32768;
pub const FILE_SUPPORTS_OBJECT_IDS: u32 = 65536;
pub const FILE_SUPPORTS_ENCRYPTION: u32 = 131072;
pub const FILE_NAMED_STREAMS: u32 = 262144;
pub const FILE_READ_ONLY_VOLUME: u32 = 524288;
pub const FILE_SEQUENTIAL_WRITE_ONCE: u32 = 1048576;
pub const FILE_SUPPORTS_TRANSACTIONS: u32 = 2097152;
pub const FILE_SUPPORTS_HARD_LINKS: u32 = 4194304;
pub const FILE_SUPPORTS_EXTENDED_ATTRIBUTES: u32 = 8388608;
pub const FILE_SUPPORTS_OPEN_BY_FILE_ID: u32 = 16777216;
pub const FILE_SUPPORTS_USN_JOURNAL: u32 = 33554432;
pub const FILE_SUPPORTS_INTEGRITY_STREAMS: u32 = 67108864;
pub const FILE_SUPPORTS_BLOCK_REFCOUNTING: u32 = 134217728;
pub const FILE_SUPPORTS_SPARSE_VDL: u32 = 268435456;
pub const FILE_DAX_VOLUME: u32 = 536870912;
pub const FILE_SUPPORTS_GHOSTING: u32 = 1073741824;
pub const FILE_CS_FLAG_CASE_SENSITIVE_DIR: u32 = 1;
pub const FLUSH_FLAGS_FILE_DATA_ONLY: u32 = 1;
pub const FLUSH_FLAGS_NO_SYNC: u32 = 2;
pub const FLUSH_FLAGS_FILE_DATA_SYNC_ONLY: u32 = 4;
pub const MAXIMUM_REPARSE_DATA_BUFFER_SIZE: u32 = 16384;
pub const IO_REPARSE_TAG_RESERVED_ZERO: u32 = 0;
pub const IO_REPARSE_TAG_RESERVED_ONE: u32 = 1;
pub const IO_REPARSE_TAG_RESERVED_TWO: u32 = 2;
pub const IO_REPARSE_TAG_RESERVED_RANGE: u32 = 2;
pub const IO_REPARSE_TAG_MOUNT_POINT: u32 = 2684354563;
pub const IO_REPARSE_TAG_HSM: u32 = 3221225476;
pub const IO_REPARSE_TAG_HSM2: u32 = 2147483654;
pub const IO_REPARSE_TAG_SIS: u32 = 2147483655;
pub const IO_REPARSE_TAG_WIM: u32 = 2147483656;
pub const IO_REPARSE_TAG_CSV: u32 = 2147483657;
pub const IO_REPARSE_TAG_DFS: u32 = 2147483658;
pub const IO_REPARSE_TAG_SYMLINK: u32 = 2684354572;
pub const IO_REPARSE_TAG_DFSR: u32 = 2147483666;
pub const IO_REPARSE_TAG_DEDUP: u32 = 2147483667;
pub const IO_REPARSE_TAG_NFS: u32 = 2147483668;
pub const IO_REPARSE_TAG_FILE_PLACEHOLDER: u32 = 2147483669;
pub const IO_REPARSE_TAG_WOF: u32 = 2147483671;
pub const IO_REPARSE_TAG_WCI: u32 = 2147483672;
pub const IO_REPARSE_TAG_WCI_1: u32 = 2415923224;
pub const IO_REPARSE_TAG_GLOBAL_REPARSE: u32 = 2684354585;
pub const IO_REPARSE_TAG_CLOUD: u32 = 2415919130;
pub const IO_REPARSE_TAG_CLOUD_1: u32 = 2415923226;
pub const IO_REPARSE_TAG_CLOUD_2: u32 = 2415927322;
pub const IO_REPARSE_TAG_CLOUD_3: u32 = 2415931418;
pub const IO_REPARSE_TAG_CLOUD_4: u32 = 2415935514;
pub const IO_REPARSE_TAG_CLOUD_5: u32 = 2415939610;
pub const IO_REPARSE_TAG_CLOUD_6: u32 = 2415943706;
pub const IO_REPARSE_TAG_CLOUD_7: u32 = 2415947802;
pub const IO_REPARSE_TAG_CLOUD_8: u32 = 2415951898;
pub const IO_REPARSE_TAG_CLOUD_9: u32 = 2415955994;
pub const IO_REPARSE_TAG_CLOUD_A: u32 = 2415960090;
pub const IO_REPARSE_TAG_CLOUD_B: u32 = 2415964186;
pub const IO_REPARSE_TAG_CLOUD_C: u32 = 2415968282;
pub const IO_REPARSE_TAG_CLOUD_D: u32 = 2415972378;
pub const IO_REPARSE_TAG_CLOUD_E: u32 = 2415976474;
pub const IO_REPARSE_TAG_CLOUD_F: u32 = 2415980570;
pub const IO_REPARSE_TAG_CLOUD_MASK: u32 = 61440;
pub const IO_REPARSE_TAG_APPEXECLINK: u32 = 2147483675;
pub const IO_REPARSE_TAG_PROJFS: u32 = 2415919132;
pub const IO_REPARSE_TAG_STORAGE_SYNC: u32 = 2147483678;
pub const IO_REPARSE_TAG_WCI_TOMBSTONE: u32 = 2684354591;
pub const IO_REPARSE_TAG_UNHANDLED: u32 = 2147483680;
pub const IO_REPARSE_TAG_ONEDRIVE: u32 = 2147483681;
pub const IO_REPARSE_TAG_PROJFS_TOMBSTONE: u32 = 2684354594;
pub const IO_REPARSE_TAG_AF_UNIX: u32 = 2147483683;
pub const IO_REPARSE_TAG_WCI_LINK: u32 = 2684354599;
pub const IO_REPARSE_TAG_WCI_LINK_1: u32 = 2684358695;
pub const IO_REPARSE_TAG_DATALESS_CIM: u32 = 2684354600;
pub const SCRUB_DATA_INPUT_FLAG_RESUME: u32 = 1;
pub const SCRUB_DATA_INPUT_FLAG_SKIP_IN_SYNC: u32 = 2;
pub const SCRUB_DATA_INPUT_FLAG_SKIP_NON_INTEGRITY_DATA: u32 = 4;
pub const SCRUB_DATA_INPUT_FLAG_IGNORE_REDUNDANCY: u32 = 8;
pub const SCRUB_DATA_INPUT_FLAG_SKIP_DATA: u32 = 16;
pub const SCRUB_DATA_INPUT_FLAG_SCRUB_BY_OBJECT_ID: u32 = 32;
pub const SCRUB_DATA_INPUT_FLAG_OPLOCK_NOT_ACQUIRED: u32 = 64;
pub const SCRUB_DATA_OUTPUT_FLAG_INCOMPLETE: u32 = 1;
pub const SCRUB_DATA_OUTPUT_FLAG_NON_USER_DATA_RANGE: u32 = 65536;
pub const SCRUB_DATA_OUTPUT_FLAG_PARITY_EXTENT_DATA_RETURNED: u32 = 131072;
pub const SCRUB_DATA_OUTPUT_FLAG_RESUME_CONTEXT_LENGTH_SPECIFIED: u32 = 262144;
pub const SHUFFLE_FILE_FLAG_SKIP_INITIALIZING_NEW_CLUSTERS: u32 = 1;
pub const IO_COMPLETION_MODIFY_STATE: u32 = 2;
pub const IO_COMPLETION_ALL_ACCESS: u32 = 2031619;
pub const IO_QOS_MAX_RESERVATION: u32 = 1000000000;
pub const SMB_CCF_APP_INSTANCE_EA_NAME: &[u8; 29] = b"ClusteredApplicationInstance\0";
pub const NETWORK_APP_INSTANCE_CSV_FLAGS_VALID_ONLY_IF_CSV_COORDINATOR: u32 = 1;
pub const DUPLICATE_CLOSE_SOURCE: u32 = 1;
pub const DUPLICATE_SAME_ACCESS: u32 = 2;
pub const POWERBUTTON_ACTION_INDEX_NOTHING: u32 = 0;
pub const POWERBUTTON_ACTION_INDEX_SLEEP: u32 = 1;
pub const POWERBUTTON_ACTION_INDEX_HIBERNATE: u32 = 2;
pub const POWERBUTTON_ACTION_INDEX_SHUTDOWN: u32 = 3;
pub const POWERBUTTON_ACTION_INDEX_TURN_OFF_THE_DISPLAY: u32 = 4;
pub const POWERBUTTON_ACTION_VALUE_NOTHING: u32 = 0;
pub const POWERBUTTON_ACTION_VALUE_SLEEP: u32 = 2;
pub const POWERBUTTON_ACTION_VALUE_HIBERNATE: u32 = 3;
pub const POWERBUTTON_ACTION_VALUE_SHUTDOWN: u32 = 6;
pub const POWERBUTTON_ACTION_VALUE_TURN_OFF_THE_DISPLAY: u32 = 8;
pub const PERFSTATE_POLICY_CHANGE_IDEAL: u32 = 0;
pub const PERFSTATE_POLICY_CHANGE_SINGLE: u32 = 1;
pub const PERFSTATE_POLICY_CHANGE_ROCKET: u32 = 2;
pub const PERFSTATE_POLICY_CHANGE_IDEAL_AGGRESSIVE: u32 = 3;
pub const PERFSTATE_POLICY_CHANGE_DECREASE_MAX: u32 = 2;
pub const PERFSTATE_POLICY_CHANGE_INCREASE_MAX: u32 = 3;
pub const PROCESSOR_THROTTLE_DISABLED: u32 = 0;
pub const PROCESSOR_THROTTLE_ENABLED: u32 = 1;
pub const PROCESSOR_THROTTLE_AUTOMATIC: u32 = 2;
pub const PROCESSOR_PERF_BOOST_POLICY_DISABLED: u32 = 0;
pub const PROCESSOR_PERF_BOOST_POLICY_MAX: u32 = 100;
pub const PROCESSOR_PERF_BOOST_MODE_DISABLED: u32 = 0;
pub const PROCESSOR_PERF_BOOST_MODE_ENABLED: u32 = 1;
pub const PROCESSOR_PERF_BOOST_MODE_AGGRESSIVE: u32 = 2;
pub const PROCESSOR_PERF_BOOST_MODE_EFFICIENT_ENABLED: u32 = 3;
pub const PROCESSOR_PERF_BOOST_MODE_EFFICIENT_AGGRESSIVE: u32 = 4;
pub const PROCESSOR_PERF_BOOST_MODE_AGGRESSIVE_AT_GUARANTEED: u32 = 5;
pub const PROCESSOR_PERF_BOOST_MODE_EFFICIENT_AGGRESSIVE_AT_GUARANTEED: u32 = 6;
pub const PROCESSOR_PERF_BOOST_MODE_MAX: u32 = 6;
pub const PROCESSOR_PERF_AUTONOMOUS_MODE_DISABLED: u32 = 0;
pub const PROCESSOR_PERF_AUTONOMOUS_MODE_ENABLED: u32 = 1;
pub const PROCESSOR_PERF_PERFORMANCE_PREFERENCE: u32 = 255;
pub const PROCESSOR_PERF_ENERGY_PREFERENCE: u32 = 0;
pub const PROCESSOR_PERF_MINIMUM_ACTIVITY_WINDOW: u32 = 0;
pub const PROCESSOR_PERF_MAXIMUM_ACTIVITY_WINDOW: u32 = 1270000000;
pub const PROCESSOR_DUTY_CYCLING_DISABLED: u32 = 0;
pub const PROCESSOR_DUTY_CYCLING_ENABLED: u32 = 1;
pub const CORE_PARKING_POLICY_CHANGE_IDEAL: u32 = 0;
pub const CORE_PARKING_POLICY_CHANGE_SINGLE: u32 = 1;
pub const CORE_PARKING_POLICY_CHANGE_ROCKET: u32 = 2;
pub const CORE_PARKING_POLICY_CHANGE_MULTISTEP: u32 = 3;
pub const CORE_PARKING_POLICY_CHANGE_MAX: u32 = 3;
pub const POWER_DEVICE_IDLE_POLICY_PERFORMANCE: u32 = 0;
pub const POWER_DEVICE_IDLE_POLICY_CONSERVATIVE: u32 = 1;
pub const POWER_CONNECTIVITY_IN_STANDBY_DISABLED: u32 = 0;
pub const POWER_CONNECTIVITY_IN_STANDBY_ENABLED: u32 = 1;
pub const POWER_CONNECTIVITY_IN_STANDBY_SYSTEM_MANAGED: u32 = 2;
pub const POWER_DISCONNECTED_STANDBY_MODE_NORMAL: u32 = 0;
pub const POWER_DISCONNECTED_STANDBY_MODE_AGGRESSIVE: u32 = 1;
pub const POWER_SYSTEM_MAXIMUM: u32 = 7;
pub const DIAGNOSTIC_REASON_VERSION: u32 = 0;
pub const DIAGNOSTIC_REASON_SIMPLE_STRING: u32 = 1;
pub const DIAGNOSTIC_REASON_DETAILED_STRING: u32 = 2;
pub const DIAGNOSTIC_REASON_NOT_SPECIFIED: u32 = 2147483648;
pub const DIAGNOSTIC_REASON_INVALID_FLAGS: i64 = -2147483656;
pub const POWER_REQUEST_CONTEXT_VERSION: u32 = 0;
pub const POWER_REQUEST_CONTEXT_SIMPLE_STRING: u32 = 1;
pub const POWER_REQUEST_CONTEXT_DETAILED_STRING: u32 = 2;
pub const PDCAP_D0_SUPPORTED: u32 = 1;
pub const PDCAP_D1_SUPPORTED: u32 = 2;
pub const PDCAP_D2_SUPPORTED: u32 = 4;
pub const PDCAP_D3_SUPPORTED: u32 = 8;
pub const PDCAP_WAKE_FROM_D0_SUPPORTED: u32 = 16;
pub const PDCAP_WAKE_FROM_D1_SUPPORTED: u32 = 32;
pub const PDCAP_WAKE_FROM_D2_SUPPORTED: u32 = 64;
pub const PDCAP_WAKE_FROM_D3_SUPPORTED: u32 = 128;
pub const PDCAP_WARM_EJECT_SUPPORTED: u32 = 256;
pub const POWER_SETTING_VALUE_VERSION: u32 = 1;
pub const POWER_PLATFORM_ROLE_V1: u32 = 1;
pub const POWER_PLATFORM_ROLE_V2: u32 = 2;
pub const POWER_PLATFORM_ROLE_VERSION: u32 = 2;
pub const PROC_IDLE_BUCKET_COUNT: u32 = 6;
pub const PROC_IDLE_BUCKET_COUNT_EX: u32 = 16;
pub const ACPI_PPM_SOFTWARE_ALL: u32 = 252;
pub const ACPI_PPM_SOFTWARE_ANY: u32 = 253;
pub const ACPI_PPM_HARDWARE_ALL: u32 = 254;
pub const MS_PPM_SOFTWARE_ALL: u32 = 1;
pub const PPM_FIRMWARE_ACPI1C2: u32 = 1;
pub const PPM_FIRMWARE_ACPI1C3: u32 = 2;
pub const PPM_FIRMWARE_ACPI1TSTATES: u32 = 4;
pub const PPM_FIRMWARE_CST: u32 = 8;
pub const PPM_FIRMWARE_CSD: u32 = 16;
pub const PPM_FIRMWARE_PCT: u32 = 32;
pub const PPM_FIRMWARE_PSS: u32 = 64;
pub const PPM_FIRMWARE_XPSS: u32 = 128;
pub const PPM_FIRMWARE_PPC: u32 = 256;
pub const PPM_FIRMWARE_PSD: u32 = 512;
pub const PPM_FIRMWARE_PTC: u32 = 1024;
pub const PPM_FIRMWARE_TSS: u32 = 2048;
pub const PPM_FIRMWARE_TPC: u32 = 4096;
pub const PPM_FIRMWARE_TSD: u32 = 8192;
pub const PPM_FIRMWARE_PCCH: u32 = 16384;
pub const PPM_FIRMWARE_PCCP: u32 = 32768;
pub const PPM_FIRMWARE_OSC: u32 = 65536;
pub const PPM_FIRMWARE_PDC: u32 = 131072;
pub const PPM_FIRMWARE_CPC: u32 = 262144;
pub const PPM_FIRMWARE_LPI: u32 = 524288;
pub const PPM_PERFORMANCE_IMPLEMENTATION_NONE: u32 = 0;
pub const PPM_PERFORMANCE_IMPLEMENTATION_PSTATES: u32 = 1;
pub const PPM_PERFORMANCE_IMPLEMENTATION_PCCV1: u32 = 2;
pub const PPM_PERFORMANCE_IMPLEMENTATION_CPPC: u32 = 3;
pub const PPM_PERFORMANCE_IMPLEMENTATION_PEP: u32 = 4;
pub const PPM_IDLE_IMPLEMENTATION_NONE: u32 = 0;
pub const PPM_IDLE_IMPLEMENTATION_CSTATES: u32 = 1;
pub const PPM_IDLE_IMPLEMENTATION_PEP: u32 = 2;
pub const PPM_IDLE_IMPLEMENTATION_MICROPEP: u32 = 3;
pub const PPM_IDLE_IMPLEMENTATION_LPISTATES: u32 = 4;
pub const POWER_ACTION_QUERY_ALLOWED: u32 = 1;
pub const POWER_ACTION_UI_ALLOWED: u32 = 2;
pub const POWER_ACTION_OVERRIDE_APPS: u32 = 4;
pub const POWER_ACTION_HIBERBOOT: u32 = 8;
pub const POWER_ACTION_USER_NOTIFY: u32 = 16;
pub const POWER_ACTION_DOZE_TO_HIBERNATE: u32 = 32;
pub const POWER_ACTION_ACPI_CRITICAL: u32 = 16777216;
pub const POWER_ACTION_ACPI_USER_NOTIFY: u32 = 33554432;
pub const POWER_ACTION_DIRECTED_DRIPS: u32 = 67108864;
pub const POWER_ACTION_PSEUDO_TRANSITION: u32 = 134217728;
pub const POWER_ACTION_LIGHTEST_FIRST: u32 = 268435456;
pub const POWER_ACTION_LOCK_CONSOLE: u32 = 536870912;
pub const POWER_ACTION_DISABLE_WAKES: u32 = 1073741824;
pub const POWER_ACTION_CRITICAL: u32 = 2147483648;
pub const POWER_LEVEL_USER_NOTIFY_TEXT: u32 = 1;
pub const POWER_LEVEL_USER_NOTIFY_SOUND: u32 = 2;
pub const POWER_LEVEL_USER_NOTIFY_EXEC: u32 = 4;
pub const POWER_USER_NOTIFY_BUTTON: u32 = 8;
pub const POWER_USER_NOTIFY_SHUTDOWN: u32 = 16;
pub const POWER_USER_NOTIFY_FORCED_SHUTDOWN: u32 = 32;
pub const POWER_FORCE_TRIGGER_RESET: u32 = 2147483648;
pub const BATTERY_DISCHARGE_FLAGS_EVENTCODE_MASK: u32 = 7;
pub const BATTERY_DISCHARGE_FLAGS_ENABLE: u32 = 2147483648;
pub const NUM_DISCHARGE_POLICIES: u32 = 4;
pub const DISCHARGE_POLICY_CRITICAL: u32 = 0;
pub const DISCHARGE_POLICY_LOW: u32 = 1;
pub const PROCESSOR_IDLESTATE_POLICY_COUNT: u32 = 3;
pub const PO_THROTTLE_NONE: u32 = 0;
pub const PO_THROTTLE_CONSTANT: u32 = 1;
pub const PO_THROTTLE_DEGRADE: u32 = 2;
pub const PO_THROTTLE_ADAPTIVE: u32 = 3;
pub const PO_THROTTLE_MAXIMUM: u32 = 4;
pub const HIBERFILE_TYPE_NONE: u32 = 0;
pub const HIBERFILE_TYPE_REDUCED: u32 = 1;
pub const HIBERFILE_TYPE_FULL: u32 = 2;
pub const HIBERFILE_TYPE_MAX: u32 = 3;
pub const IMAGE_DOS_SIGNATURE: u32 = 23117;
pub const IMAGE_OS2_SIGNATURE: u32 = 17742;
pub const IMAGE_OS2_SIGNATURE_LE: u32 = 17740;
pub const IMAGE_VXD_SIGNATURE: u32 = 17740;
pub const IMAGE_NT_SIGNATURE: u32 = 17744;
pub const IMAGE_SIZEOF_FILE_HEADER: u32 = 20;
pub const IMAGE_FILE_RELOCS_STRIPPED: u32 = 1;
pub const IMAGE_FILE_EXECUTABLE_IMAGE: u32 = 2;
pub const IMAGE_FILE_LINE_NUMS_STRIPPED: u32 = 4;
pub const IMAGE_FILE_LOCAL_SYMS_STRIPPED: u32 = 8;
pub const IMAGE_FILE_AGGRESIVE_WS_TRIM: u32 = 16;
pub const IMAGE_FILE_LARGE_ADDRESS_AWARE: u32 = 32;
pub const IMAGE_FILE_BYTES_REVERSED_LO: u32 = 128;
pub const IMAGE_FILE_32BIT_MACHINE: u32 = 256;
pub const IMAGE_FILE_DEBUG_STRIPPED: u32 = 512;
pub const IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP: u32 = 1024;
pub const IMAGE_FILE_NET_RUN_FROM_SWAP: u32 = 2048;
pub const IMAGE_FILE_SYSTEM: u32 = 4096;
pub const IMAGE_FILE_DLL: u32 = 8192;
pub const IMAGE_FILE_UP_SYSTEM_ONLY: u32 = 16384;
pub const IMAGE_FILE_BYTES_REVERSED_HI: u32 = 32768;
pub const IMAGE_FILE_MACHINE_UNKNOWN: u32 = 0;
pub const IMAGE_FILE_MACHINE_TARGET_HOST: u32 = 1;
pub const IMAGE_FILE_MACHINE_I386: u32 = 332;
pub const IMAGE_FILE_MACHINE_R3000: u32 = 354;
pub const IMAGE_FILE_MACHINE_R4000: u32 = 358;
pub const IMAGE_FILE_MACHINE_R10000: u32 = 360;
pub const IMAGE_FILE_MACHINE_WCEMIPSV2: u32 = 361;
pub const IMAGE_FILE_MACHINE_ALPHA: u32 = 388;
pub const IMAGE_FILE_MACHINE_SH3: u32 = 418;
pub const IMAGE_FILE_MACHINE_SH3DSP: u32 = 419;
pub const IMAGE_FILE_MACHINE_SH3E: u32 = 420;
pub const IMAGE_FILE_MACHINE_SH4: u32 = 422;
pub const IMAGE_FILE_MACHINE_SH5: u32 = 424;
pub const IMAGE_FILE_MACHINE_ARM: u32 = 448;
pub const IMAGE_FILE_MACHINE_THUMB: u32 = 450;
pub const IMAGE_FILE_MACHINE_ARMNT: u32 = 452;
pub const IMAGE_FILE_MACHINE_AM33: u32 = 467;
pub const IMAGE_FILE_MACHINE_POWERPC: u32 = 496;
pub const IMAGE_FILE_MACHINE_POWERPCFP: u32 = 497;
pub const IMAGE_FILE_MACHINE_IA64: u32 = 512;
pub const IMAGE_FILE_MACHINE_MIPS16: u32 = 614;
pub const IMAGE_FILE_MACHINE_ALPHA64: u32 = 644;
pub const IMAGE_FILE_MACHINE_MIPSFPU: u32 = 870;
pub const IMAGE_FILE_MACHINE_MIPSFPU16: u32 = 1126;
pub const IMAGE_FILE_MACHINE_AXP64: u32 = 644;
pub const IMAGE_FILE_MACHINE_TRICORE: u32 = 1312;
pub const IMAGE_FILE_MACHINE_CEF: u32 = 3311;
pub const IMAGE_FILE_MACHINE_EBC: u32 = 3772;
pub const IMAGE_FILE_MACHINE_AMD64: u32 = 34404;
pub const IMAGE_FILE_MACHINE_M32R: u32 = 36929;
pub const IMAGE_FILE_MACHINE_ARM64: u32 = 43620;
pub const IMAGE_FILE_MACHINE_CEE: u32 = 49390;
pub const IMAGE_NUMBEROF_DIRECTORY_ENTRIES: u32 = 16;
pub const IMAGE_NT_OPTIONAL_HDR32_MAGIC: u32 = 267;
pub const IMAGE_NT_OPTIONAL_HDR64_MAGIC: u32 = 523;
pub const IMAGE_ROM_OPTIONAL_HDR_MAGIC: u32 = 263;
pub const IMAGE_NT_OPTIONAL_HDR_MAGIC: u32 = 523;
pub const IMAGE_SUBSYSTEM_UNKNOWN: u32 = 0;
pub const IMAGE_SUBSYSTEM_NATIVE: u32 = 1;
pub const IMAGE_SUBSYSTEM_WINDOWS_GUI: u32 = 2;
pub const IMAGE_SUBSYSTEM_WINDOWS_CUI: u32 = 3;
pub const IMAGE_SUBSYSTEM_OS2_CUI: u32 = 5;
pub const IMAGE_SUBSYSTEM_POSIX_CUI: u32 = 7;
pub const IMAGE_SUBSYSTEM_NATIVE_WINDOWS: u32 = 8;
pub const IMAGE_SUBSYSTEM_WINDOWS_CE_GUI: u32 = 9;
pub const IMAGE_SUBSYSTEM_EFI_APPLICATION: u32 = 10;
pub const IMAGE_SUBSYSTEM_EFI_BOOT_SERVICE_DRIVER: u32 = 11;
pub const IMAGE_SUBSYSTEM_EFI_RUNTIME_DRIVER: u32 = 12;
pub const IMAGE_SUBSYSTEM_EFI_ROM: u32 = 13;
pub const IMAGE_SUBSYSTEM_XBOX: u32 = 14;
pub const IMAGE_SUBSYSTEM_WINDOWS_BOOT_APPLICATION: u32 = 16;
pub const IMAGE_SUBSYSTEM_XBOX_CODE_CATALOG: u32 = 17;
pub const IMAGE_DLLCHARACTERISTICS_HIGH_ENTROPY_VA: u32 = 32;
pub const IMAGE_DLLCHARACTERISTICS_DYNAMIC_BASE: u32 = 64;
pub const IMAGE_DLLCHARACTERISTICS_FORCE_INTEGRITY: u32 = 128;
pub const IMAGE_DLLCHARACTERISTICS_NX_COMPAT: u32 = 256;
pub const IMAGE_DLLCHARACTERISTICS_NO_ISOLATION: u32 = 512;
pub const IMAGE_DLLCHARACTERISTICS_NO_SEH: u32 = 1024;
pub const IMAGE_DLLCHARACTERISTICS_NO_BIND: u32 = 2048;
pub const IMAGE_DLLCHARACTERISTICS_APPCONTAINER: u32 = 4096;
pub const IMAGE_DLLCHARACTERISTICS_WDM_DRIVER: u32 = 8192;
pub const IMAGE_DLLCHARACTERISTICS_GUARD_CF: u32 = 16384;
pub const IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE: u32 = 32768;
pub const IMAGE_DIRECTORY_ENTRY_EXPORT: u32 = 0;
pub const IMAGE_DIRECTORY_ENTRY_IMPORT: u32 = 1;
pub const IMAGE_DIRECTORY_ENTRY_RESOURCE: u32 = 2;
pub const IMAGE_DIRECTORY_ENTRY_EXCEPTION: u32 = 3;
pub const IMAGE_DIRECTORY_ENTRY_SECURITY: u32 = 4;
pub const IMAGE_DIRECTORY_ENTRY_BASERELOC: u32 = 5;
pub const IMAGE_DIRECTORY_ENTRY_DEBUG: u32 = 6;
pub const IMAGE_DIRECTORY_ENTRY_ARCHITECTURE: u32 = 7;
pub const IMAGE_DIRECTORY_ENTRY_GLOBALPTR: u32 = 8;
pub const IMAGE_DIRECTORY_ENTRY_TLS: u32 = 9;
pub const IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG: u32 = 10;
pub const IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT: u32 = 11;
pub const IMAGE_DIRECTORY_ENTRY_IAT: u32 = 12;
pub const IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT: u32 = 13;
pub const IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR: u32 = 14;
pub const IMAGE_SIZEOF_SHORT_NAME: u32 = 8;
pub const IMAGE_SIZEOF_SECTION_HEADER: u32 = 40;
pub const IMAGE_SCN_TYPE_NO_PAD: u32 = 8;
pub const IMAGE_SCN_CNT_CODE: u32 = 32;
pub const IMAGE_SCN_CNT_INITIALIZED_DATA: u32 = 64;
pub const IMAGE_SCN_CNT_UNINITIALIZED_DATA: u32 = 128;
pub const IMAGE_SCN_LNK_OTHER: u32 = 256;
pub const IMAGE_SCN_LNK_INFO: u32 = 512;
pub const IMAGE_SCN_LNK_REMOVE: u32 = 2048;
pub const IMAGE_SCN_LNK_COMDAT: u32 = 4096;
pub const IMAGE_SCN_NO_DEFER_SPEC_EXC: u32 = 16384;
pub const IMAGE_SCN_GPREL: u32 = 32768;
pub const IMAGE_SCN_MEM_FARDATA: u32 = 32768;
pub const IMAGE_SCN_MEM_PURGEABLE: u32 = 131072;
pub const IMAGE_SCN_MEM_16BIT: u32 = 131072;
pub const IMAGE_SCN_MEM_LOCKED: u32 = 262144;
pub const IMAGE_SCN_MEM_PRELOAD: u32 = 524288;
pub const IMAGE_SCN_ALIGN_1BYTES: u32 = 1048576;
pub const IMAGE_SCN_ALIGN_2BYTES: u32 = 2097152;
pub const IMAGE_SCN_ALIGN_4BYTES: u32 = 3145728;
pub const IMAGE_SCN_ALIGN_8BYTES: u32 = 4194304;
pub const IMAGE_SCN_ALIGN_16BYTES: u32 = 5242880;
pub const IMAGE_SCN_ALIGN_32BYTES: u32 = 6291456;
pub const IMAGE_SCN_ALIGN_64BYTES: u32 = 7340032;
pub const IMAGE_SCN_ALIGN_128BYTES: u32 = 8388608;
pub const IMAGE_SCN_ALIGN_256BYTES: u32 = 9437184;
pub const IMAGE_SCN_ALIGN_512BYTES: u32 = 10485760;
pub const IMAGE_SCN_ALIGN_1024BYTES: u32 = 11534336;
pub const IMAGE_SCN_ALIGN_2048BYTES: u32 = 12582912;
pub const IMAGE_SCN_ALIGN_4096BYTES: u32 = 13631488;
pub const IMAGE_SCN_ALIGN_8192BYTES: u32 = 14680064;
pub const IMAGE_SCN_ALIGN_MASK: u32 = 15728640;
pub const IMAGE_SCN_LNK_NRELOC_OVFL: u32 = 16777216;
pub const IMAGE_SCN_MEM_DISCARDABLE: u32 = 33554432;
pub const IMAGE_SCN_MEM_NOT_CACHED: u32 = 67108864;
pub const IMAGE_SCN_MEM_NOT_PAGED: u32 = 134217728;
pub const IMAGE_SCN_MEM_SHARED: u32 = 268435456;
pub const IMAGE_SCN_MEM_EXECUTE: u32 = 536870912;
pub const IMAGE_SCN_MEM_READ: u32 = 1073741824;
pub const IMAGE_SCN_MEM_WRITE: u32 = 2147483648;
pub const IMAGE_SCN_SCALE_INDEX: u32 = 1;
pub const IMAGE_SIZEOF_SYMBOL: u32 = 18;
pub const IMAGE_SYM_SECTION_MAX: u32 = 65279;
pub const IMAGE_SYM_SECTION_MAX_EX: u32 = 2147483647;
pub const IMAGE_SYM_TYPE_NULL: u32 = 0;
pub const IMAGE_SYM_TYPE_VOID: u32 = 1;
pub const IMAGE_SYM_TYPE_CHAR: u32 = 2;
pub const IMAGE_SYM_TYPE_SHORT: u32 = 3;
pub const IMAGE_SYM_TYPE_INT: u32 = 4;
pub const IMAGE_SYM_TYPE_LONG: u32 = 5;
pub const IMAGE_SYM_TYPE_FLOAT: u32 = 6;
pub const IMAGE_SYM_TYPE_DOUBLE: u32 = 7;
pub const IMAGE_SYM_TYPE_STRUCT: u32 = 8;
pub const IMAGE_SYM_TYPE_UNION: u32 = 9;
pub const IMAGE_SYM_TYPE_ENUM: u32 = 10;
pub const IMAGE_SYM_TYPE_MOE: u32 = 11;
pub const IMAGE_SYM_TYPE_BYTE: u32 = 12;
pub const IMAGE_SYM_TYPE_WORD: u32 = 13;
pub const IMAGE_SYM_TYPE_UINT: u32 = 14;
pub const IMAGE_SYM_TYPE_DWORD: u32 = 15;
pub const IMAGE_SYM_TYPE_PCODE: u32 = 32768;
pub const IMAGE_SYM_DTYPE_NULL: u32 = 0;
pub const IMAGE_SYM_DTYPE_POINTER: u32 = 1;
pub const IMAGE_SYM_DTYPE_FUNCTION: u32 = 2;
pub const IMAGE_SYM_DTYPE_ARRAY: u32 = 3;
pub const IMAGE_SYM_CLASS_NULL: u32 = 0;
pub const IMAGE_SYM_CLASS_AUTOMATIC: u32 = 1;
pub const IMAGE_SYM_CLASS_EXTERNAL: u32 = 2;
pub const IMAGE_SYM_CLASS_STATIC: u32 = 3;
pub const IMAGE_SYM_CLASS_REGISTER: u32 = 4;
pub const IMAGE_SYM_CLASS_EXTERNAL_DEF: u32 = 5;
pub const IMAGE_SYM_CLASS_LABEL: u32 = 6;
pub const IMAGE_SYM_CLASS_UNDEFINED_LABEL: u32 = 7;
pub const IMAGE_SYM_CLASS_MEMBER_OF_STRUCT: u32 = 8;
pub const IMAGE_SYM_CLASS_ARGUMENT: u32 = 9;
pub const IMAGE_SYM_CLASS_STRUCT_TAG: u32 = 10;
pub const IMAGE_SYM_CLASS_MEMBER_OF_UNION: u32 = 11;
pub const IMAGE_SYM_CLASS_UNION_TAG: u32 = 12;
pub const IMAGE_SYM_CLASS_TYPE_DEFINITION: u32 = 13;
pub const IMAGE_SYM_CLASS_UNDEFINED_STATIC: u32 = 14;
pub const IMAGE_SYM_CLASS_ENUM_TAG: u32 = 15;
pub const IMAGE_SYM_CLASS_MEMBER_OF_ENUM: u32 = 16;
pub const IMAGE_SYM_CLASS_REGISTER_PARAM: u32 = 17;
pub const IMAGE_SYM_CLASS_BIT_FIELD: u32 = 18;
pub const IMAGE_SYM_CLASS_FAR_EXTERNAL: u32 = 68;
pub const IMAGE_SYM_CLASS_BLOCK: u32 = 100;
pub const IMAGE_SYM_CLASS_FUNCTION: u32 = 101;
pub const IMAGE_SYM_CLASS_END_OF_STRUCT: u32 = 102;
pub const IMAGE_SYM_CLASS_FILE: u32 = 103;
pub const IMAGE_SYM_CLASS_SECTION: u32 = 104;
pub const IMAGE_SYM_CLASS_WEAK_EXTERNAL: u32 = 105;
pub const IMAGE_SYM_CLASS_CLR_TOKEN: u32 = 107;
pub const N_BTMASK: u32 = 15;
pub const N_TMASK: u32 = 48;
pub const N_TMASK1: u32 = 192;
pub const N_TMASK2: u32 = 240;
pub const N_BTSHFT: u32 = 4;
pub const N_TSHIFT: u32 = 2;
pub const IMAGE_COMDAT_SELECT_NODUPLICATES: u32 = 1;
pub const IMAGE_COMDAT_SELECT_ANY: u32 = 2;
pub const IMAGE_COMDAT_SELECT_SAME_SIZE: u32 = 3;
pub const IMAGE_COMDAT_SELECT_EXACT_MATCH: u32 = 4;
pub const IMAGE_COMDAT_SELECT_ASSOCIATIVE: u32 = 5;
pub const IMAGE_COMDAT_SELECT_LARGEST: u32 = 6;
pub const IMAGE_COMDAT_SELECT_NEWEST: u32 = 7;
pub const IMAGE_WEAK_EXTERN_SEARCH_NOLIBRARY: u32 = 1;
pub const IMAGE_WEAK_EXTERN_SEARCH_LIBRARY: u32 = 2;
pub const IMAGE_WEAK_EXTERN_SEARCH_ALIAS: u32 = 3;
pub const IMAGE_WEAK_EXTERN_ANTI_DEPENDENCY: u32 = 4;
pub const IMAGE_REL_I386_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_I386_DIR16: u32 = 1;
pub const IMAGE_REL_I386_REL16: u32 = 2;
pub const IMAGE_REL_I386_DIR32: u32 = 6;
pub const IMAGE_REL_I386_DIR32NB: u32 = 7;
pub const IMAGE_REL_I386_SEG12: u32 = 9;
pub const IMAGE_REL_I386_SECTION: u32 = 10;
pub const IMAGE_REL_I386_SECREL: u32 = 11;
pub const IMAGE_REL_I386_TOKEN: u32 = 12;
pub const IMAGE_REL_I386_SECREL7: u32 = 13;
pub const IMAGE_REL_I386_REL32: u32 = 20;
pub const IMAGE_REL_MIPS_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_MIPS_REFHALF: u32 = 1;
pub const IMAGE_REL_MIPS_REFWORD: u32 = 2;
pub const IMAGE_REL_MIPS_JMPADDR: u32 = 3;
pub const IMAGE_REL_MIPS_REFHI: u32 = 4;
pub const IMAGE_REL_MIPS_REFLO: u32 = 5;
pub const IMAGE_REL_MIPS_GPREL: u32 = 6;
pub const IMAGE_REL_MIPS_LITERAL: u32 = 7;
pub const IMAGE_REL_MIPS_SECTION: u32 = 10;
pub const IMAGE_REL_MIPS_SECREL: u32 = 11;
pub const IMAGE_REL_MIPS_SECRELLO: u32 = 12;
pub const IMAGE_REL_MIPS_SECRELHI: u32 = 13;
pub const IMAGE_REL_MIPS_TOKEN: u32 = 14;
pub const IMAGE_REL_MIPS_JMPADDR16: u32 = 16;
pub const IMAGE_REL_MIPS_REFWORDNB: u32 = 34;
pub const IMAGE_REL_MIPS_PAIR: u32 = 37;
pub const IMAGE_REL_ALPHA_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_ALPHA_REFLONG: u32 = 1;
pub const IMAGE_REL_ALPHA_REFQUAD: u32 = 2;
pub const IMAGE_REL_ALPHA_GPREL32: u32 = 3;
pub const IMAGE_REL_ALPHA_LITERAL: u32 = 4;
pub const IMAGE_REL_ALPHA_LITUSE: u32 = 5;
pub const IMAGE_REL_ALPHA_GPDISP: u32 = 6;
pub const IMAGE_REL_ALPHA_BRADDR: u32 = 7;
pub const IMAGE_REL_ALPHA_HINT: u32 = 8;
pub const IMAGE_REL_ALPHA_INLINE_REFLONG: u32 = 9;
pub const IMAGE_REL_ALPHA_REFHI: u32 = 10;
pub const IMAGE_REL_ALPHA_REFLO: u32 = 11;
pub const IMAGE_REL_ALPHA_PAIR: u32 = 12;
pub const IMAGE_REL_ALPHA_MATCH: u32 = 13;
pub const IMAGE_REL_ALPHA_SECTION: u32 = 14;
pub const IMAGE_REL_ALPHA_SECREL: u32 = 15;
pub const IMAGE_REL_ALPHA_REFLONGNB: u32 = 16;
pub const IMAGE_REL_ALPHA_SECRELLO: u32 = 17;
pub const IMAGE_REL_ALPHA_SECRELHI: u32 = 18;
pub const IMAGE_REL_ALPHA_REFQ3: u32 = 19;
pub const IMAGE_REL_ALPHA_REFQ2: u32 = 20;
pub const IMAGE_REL_ALPHA_REFQ1: u32 = 21;
pub const IMAGE_REL_ALPHA_GPRELLO: u32 = 22;
pub const IMAGE_REL_ALPHA_GPRELHI: u32 = 23;
pub const IMAGE_REL_PPC_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_PPC_ADDR64: u32 = 1;
pub const IMAGE_REL_PPC_ADDR32: u32 = 2;
pub const IMAGE_REL_PPC_ADDR24: u32 = 3;
pub const IMAGE_REL_PPC_ADDR16: u32 = 4;
pub const IMAGE_REL_PPC_ADDR14: u32 = 5;
pub const IMAGE_REL_PPC_REL24: u32 = 6;
pub const IMAGE_REL_PPC_REL14: u32 = 7;
pub const IMAGE_REL_PPC_TOCREL16: u32 = 8;
pub const IMAGE_REL_PPC_TOCREL14: u32 = 9;
pub const IMAGE_REL_PPC_ADDR32NB: u32 = 10;
pub const IMAGE_REL_PPC_SECREL: u32 = 11;
pub const IMAGE_REL_PPC_SECTION: u32 = 12;
pub const IMAGE_REL_PPC_IFGLUE: u32 = 13;
pub const IMAGE_REL_PPC_IMGLUE: u32 = 14;
pub const IMAGE_REL_PPC_SECREL16: u32 = 15;
pub const IMAGE_REL_PPC_REFHI: u32 = 16;
pub const IMAGE_REL_PPC_REFLO: u32 = 17;
pub const IMAGE_REL_PPC_PAIR: u32 = 18;
pub const IMAGE_REL_PPC_SECRELLO: u32 = 19;
pub const IMAGE_REL_PPC_SECRELHI: u32 = 20;
pub const IMAGE_REL_PPC_GPREL: u32 = 21;
pub const IMAGE_REL_PPC_TOKEN: u32 = 22;
pub const IMAGE_REL_PPC_TYPEMASK: u32 = 255;
pub const IMAGE_REL_PPC_NEG: u32 = 256;
pub const IMAGE_REL_PPC_BRTAKEN: u32 = 512;
pub const IMAGE_REL_PPC_BRNTAKEN: u32 = 1024;
pub const IMAGE_REL_PPC_TOCDEFN: u32 = 2048;
pub const IMAGE_REL_SH3_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_SH3_DIRECT16: u32 = 1;
pub const IMAGE_REL_SH3_DIRECT32: u32 = 2;
pub const IMAGE_REL_SH3_DIRECT8: u32 = 3;
pub const IMAGE_REL_SH3_DIRECT8_WORD: u32 = 4;
pub const IMAGE_REL_SH3_DIRECT8_LONG: u32 = 5;
pub const IMAGE_REL_SH3_DIRECT4: u32 = 6;
pub const IMAGE_REL_SH3_DIRECT4_WORD: u32 = 7;
pub const IMAGE_REL_SH3_DIRECT4_LONG: u32 = 8;
pub const IMAGE_REL_SH3_PCREL8_WORD: u32 = 9;
pub const IMAGE_REL_SH3_PCREL8_LONG: u32 = 10;
pub const IMAGE_REL_SH3_PCREL12_WORD: u32 = 11;
pub const IMAGE_REL_SH3_STARTOF_SECTION: u32 = 12;
pub const IMAGE_REL_SH3_SIZEOF_SECTION: u32 = 13;
pub const IMAGE_REL_SH3_SECTION: u32 = 14;
pub const IMAGE_REL_SH3_SECREL: u32 = 15;
pub const IMAGE_REL_SH3_DIRECT32_NB: u32 = 16;
pub const IMAGE_REL_SH3_GPREL4_LONG: u32 = 17;
pub const IMAGE_REL_SH3_TOKEN: u32 = 18;
pub const IMAGE_REL_SHM_PCRELPT: u32 = 19;
pub const IMAGE_REL_SHM_REFLO: u32 = 20;
pub const IMAGE_REL_SHM_REFHALF: u32 = 21;
pub const IMAGE_REL_SHM_RELLO: u32 = 22;
pub const IMAGE_REL_SHM_RELHALF: u32 = 23;
pub const IMAGE_REL_SHM_PAIR: u32 = 24;
pub const IMAGE_REL_SH_NOMODE: u32 = 32768;
pub const IMAGE_REL_ARM_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_ARM_ADDR32: u32 = 1;
pub const IMAGE_REL_ARM_ADDR32NB: u32 = 2;
pub const IMAGE_REL_ARM_BRANCH24: u32 = 3;
pub const IMAGE_REL_ARM_BRANCH11: u32 = 4;
pub const IMAGE_REL_ARM_TOKEN: u32 = 5;
pub const IMAGE_REL_ARM_GPREL12: u32 = 6;
pub const IMAGE_REL_ARM_GPREL7: u32 = 7;
pub const IMAGE_REL_ARM_BLX24: u32 = 8;
pub const IMAGE_REL_ARM_BLX11: u32 = 9;
pub const IMAGE_REL_ARM_SECTION: u32 = 14;
pub const IMAGE_REL_ARM_SECREL: u32 = 15;
pub const IMAGE_REL_ARM_MOV32A: u32 = 16;
pub const IMAGE_REL_ARM_MOV32: u32 = 16;
pub const IMAGE_REL_ARM_MOV32T: u32 = 17;
pub const IMAGE_REL_THUMB_MOV32: u32 = 17;
pub const IMAGE_REL_ARM_BRANCH20T: u32 = 18;
pub const IMAGE_REL_THUMB_BRANCH20: u32 = 18;
pub const IMAGE_REL_ARM_BRANCH24T: u32 = 20;
pub const IMAGE_REL_THUMB_BRANCH24: u32 = 20;
pub const IMAGE_REL_ARM_BLX23T: u32 = 21;
pub const IMAGE_REL_THUMB_BLX23: u32 = 21;
pub const IMAGE_REL_AM_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_AM_ADDR32: u32 = 1;
pub const IMAGE_REL_AM_ADDR32NB: u32 = 2;
pub const IMAGE_REL_AM_CALL32: u32 = 3;
pub const IMAGE_REL_AM_FUNCINFO: u32 = 4;
pub const IMAGE_REL_AM_REL32_1: u32 = 5;
pub const IMAGE_REL_AM_REL32_2: u32 = 6;
pub const IMAGE_REL_AM_SECREL: u32 = 7;
pub const IMAGE_REL_AM_SECTION: u32 = 8;
pub const IMAGE_REL_AM_TOKEN: u32 = 9;
pub const IMAGE_REL_ARM64_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_ARM64_ADDR32: u32 = 1;
pub const IMAGE_REL_ARM64_ADDR32NB: u32 = 2;
pub const IMAGE_REL_ARM64_BRANCH26: u32 = 3;
pub const IMAGE_REL_ARM64_PAGEBASE_REL21: u32 = 4;
pub const IMAGE_REL_ARM64_REL21: u32 = 5;
pub const IMAGE_REL_ARM64_PAGEOFFSET_12A: u32 = 6;
pub const IMAGE_REL_ARM64_PAGEOFFSET_12L: u32 = 7;
pub const IMAGE_REL_ARM64_SECREL: u32 = 8;
pub const IMAGE_REL_ARM64_SECREL_LOW12A: u32 = 9;
pub const IMAGE_REL_ARM64_SECREL_HIGH12A: u32 = 10;
pub const IMAGE_REL_ARM64_SECREL_LOW12L: u32 = 11;
pub const IMAGE_REL_ARM64_TOKEN: u32 = 12;
pub const IMAGE_REL_ARM64_SECTION: u32 = 13;
pub const IMAGE_REL_ARM64_ADDR64: u32 = 14;
pub const IMAGE_REL_ARM64_BRANCH19: u32 = 15;
pub const IMAGE_REL_AMD64_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_AMD64_ADDR64: u32 = 1;
pub const IMAGE_REL_AMD64_ADDR32: u32 = 2;
pub const IMAGE_REL_AMD64_ADDR32NB: u32 = 3;
pub const IMAGE_REL_AMD64_REL32: u32 = 4;
pub const IMAGE_REL_AMD64_REL32_1: u32 = 5;
pub const IMAGE_REL_AMD64_REL32_2: u32 = 6;
pub const IMAGE_REL_AMD64_REL32_3: u32 = 7;
pub const IMAGE_REL_AMD64_REL32_4: u32 = 8;
pub const IMAGE_REL_AMD64_REL32_5: u32 = 9;
pub const IMAGE_REL_AMD64_SECTION: u32 = 10;
pub const IMAGE_REL_AMD64_SECREL: u32 = 11;
pub const IMAGE_REL_AMD64_SECREL7: u32 = 12;
pub const IMAGE_REL_AMD64_TOKEN: u32 = 13;
pub const IMAGE_REL_AMD64_SREL32: u32 = 14;
pub const IMAGE_REL_AMD64_PAIR: u32 = 15;
pub const IMAGE_REL_AMD64_SSPAN32: u32 = 16;
pub const IMAGE_REL_AMD64_EHANDLER: u32 = 17;
pub const IMAGE_REL_AMD64_IMPORT_BR: u32 = 18;
pub const IMAGE_REL_AMD64_IMPORT_CALL: u32 = 19;
pub const IMAGE_REL_AMD64_CFG_BR: u32 = 20;
pub const IMAGE_REL_AMD64_CFG_BR_REX: u32 = 21;
pub const IMAGE_REL_AMD64_CFG_CALL: u32 = 22;
pub const IMAGE_REL_AMD64_INDIR_BR: u32 = 23;
pub const IMAGE_REL_AMD64_INDIR_BR_REX: u32 = 24;
pub const IMAGE_REL_AMD64_INDIR_CALL: u32 = 25;
pub const IMAGE_REL_AMD64_INDIR_BR_SWITCHTABLE_FIRST: u32 = 32;
pub const IMAGE_REL_AMD64_INDIR_BR_SWITCHTABLE_LAST: u32 = 47;
pub const IMAGE_REL_IA64_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_IA64_IMM14: u32 = 1;
pub const IMAGE_REL_IA64_IMM22: u32 = 2;
pub const IMAGE_REL_IA64_IMM64: u32 = 3;
pub const IMAGE_REL_IA64_DIR32: u32 = 4;
pub const IMAGE_REL_IA64_DIR64: u32 = 5;
pub const IMAGE_REL_IA64_PCREL21B: u32 = 6;
pub const IMAGE_REL_IA64_PCREL21M: u32 = 7;
pub const IMAGE_REL_IA64_PCREL21F: u32 = 8;
pub const IMAGE_REL_IA64_GPREL22: u32 = 9;
pub const IMAGE_REL_IA64_LTOFF22: u32 = 10;
pub const IMAGE_REL_IA64_SECTION: u32 = 11;
pub const IMAGE_REL_IA64_SECREL22: u32 = 12;
pub const IMAGE_REL_IA64_SECREL64I: u32 = 13;
pub const IMAGE_REL_IA64_SECREL32: u32 = 14;
pub const IMAGE_REL_IA64_DIR32NB: u32 = 16;
pub const IMAGE_REL_IA64_SREL14: u32 = 17;
pub const IMAGE_REL_IA64_SREL22: u32 = 18;
pub const IMAGE_REL_IA64_SREL32: u32 = 19;
pub const IMAGE_REL_IA64_UREL32: u32 = 20;
pub const IMAGE_REL_IA64_PCREL60X: u32 = 21;
pub const IMAGE_REL_IA64_PCREL60B: u32 = 22;
pub const IMAGE_REL_IA64_PCREL60F: u32 = 23;
pub const IMAGE_REL_IA64_PCREL60I: u32 = 24;
pub const IMAGE_REL_IA64_PCREL60M: u32 = 25;
pub const IMAGE_REL_IA64_IMMGPREL64: u32 = 26;
pub const IMAGE_REL_IA64_TOKEN: u32 = 27;
pub const IMAGE_REL_IA64_GPREL32: u32 = 28;
pub const IMAGE_REL_IA64_ADDEND: u32 = 31;
pub const IMAGE_REL_CEF_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_CEF_ADDR32: u32 = 1;
pub const IMAGE_REL_CEF_ADDR64: u32 = 2;
pub const IMAGE_REL_CEF_ADDR32NB: u32 = 3;
pub const IMAGE_REL_CEF_SECTION: u32 = 4;
pub const IMAGE_REL_CEF_SECREL: u32 = 5;
pub const IMAGE_REL_CEF_TOKEN: u32 = 6;
pub const IMAGE_REL_CEE_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_CEE_ADDR32: u32 = 1;
pub const IMAGE_REL_CEE_ADDR64: u32 = 2;
pub const IMAGE_REL_CEE_ADDR32NB: u32 = 3;
pub const IMAGE_REL_CEE_SECTION: u32 = 4;
pub const IMAGE_REL_CEE_SECREL: u32 = 5;
pub const IMAGE_REL_CEE_TOKEN: u32 = 6;
pub const IMAGE_REL_M32R_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_M32R_ADDR32: u32 = 1;
pub const IMAGE_REL_M32R_ADDR32NB: u32 = 2;
pub const IMAGE_REL_M32R_ADDR24: u32 = 3;
pub const IMAGE_REL_M32R_GPREL16: u32 = 4;
pub const IMAGE_REL_M32R_PCREL24: u32 = 5;
pub const IMAGE_REL_M32R_PCREL16: u32 = 6;
pub const IMAGE_REL_M32R_PCREL8: u32 = 7;
pub const IMAGE_REL_M32R_REFHALF: u32 = 8;
pub const IMAGE_REL_M32R_REFHI: u32 = 9;
pub const IMAGE_REL_M32R_REFLO: u32 = 10;
pub const IMAGE_REL_M32R_PAIR: u32 = 11;
pub const IMAGE_REL_M32R_SECTION: u32 = 12;
pub const IMAGE_REL_M32R_SECREL32: u32 = 13;
pub const IMAGE_REL_M32R_TOKEN: u32 = 14;
pub const IMAGE_REL_EBC_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_EBC_ADDR32NB: u32 = 1;
pub const IMAGE_REL_EBC_REL32: u32 = 2;
pub const IMAGE_REL_EBC_SECTION: u32 = 3;
pub const IMAGE_REL_EBC_SECREL: u32 = 4;
pub const EMARCH_ENC_I17_IMM7B_INST_WORD_X: u32 = 3;
pub const EMARCH_ENC_I17_IMM7B_SIZE_X: u32 = 7;
pub const EMARCH_ENC_I17_IMM7B_INST_WORD_POS_X: u32 = 4;
pub const EMARCH_ENC_I17_IMM7B_VAL_POS_X: u32 = 0;
pub const EMARCH_ENC_I17_IMM9D_INST_WORD_X: u32 = 3;
pub const EMARCH_ENC_I17_IMM9D_SIZE_X: u32 = 9;
pub const EMARCH_ENC_I17_IMM9D_INST_WORD_POS_X: u32 = 18;
pub const EMARCH_ENC_I17_IMM9D_VAL_POS_X: u32 = 7;
pub const EMARCH_ENC_I17_IMM5C_INST_WORD_X: u32 = 3;
pub const EMARCH_ENC_I17_IMM5C_SIZE_X: u32 = 5;
pub const EMARCH_ENC_I17_IMM5C_INST_WORD_POS_X: u32 = 13;
pub const EMARCH_ENC_I17_IMM5C_VAL_POS_X: u32 = 16;
pub const EMARCH_ENC_I17_IC_INST_WORD_X: u32 = 3;
pub const EMARCH_ENC_I17_IC_SIZE_X: u32 = 1;
pub const EMARCH_ENC_I17_IC_INST_WORD_POS_X: u32 = 12;
pub const EMARCH_ENC_I17_IC_VAL_POS_X: u32 = 21;
pub const EMARCH_ENC_I17_IMM41a_INST_WORD_X: u32 = 1;
pub const EMARCH_ENC_I17_IMM41a_SIZE_X: u32 = 10;
pub const EMARCH_ENC_I17_IMM41a_INST_WORD_POS_X: u32 = 14;
pub const EMARCH_ENC_I17_IMM41a_VAL_POS_X: u32 = 22;
pub const EMARCH_ENC_I17_IMM41b_INST_WORD_X: u32 = 1;
pub const EMARCH_ENC_I17_IMM41b_SIZE_X: u32 = 8;
pub const EMARCH_ENC_I17_IMM41b_INST_WORD_POS_X: u32 = 24;
pub const EMARCH_ENC_I17_IMM41b_VAL_POS_X: u32 = 32;
pub const EMARCH_ENC_I17_IMM41c_INST_WORD_X: u32 = 2;
pub const EMARCH_ENC_I17_IMM41c_SIZE_X: u32 = 23;
pub const EMARCH_ENC_I17_IMM41c_INST_WORD_POS_X: u32 = 0;
pub const EMARCH_ENC_I17_IMM41c_VAL_POS_X: u32 = 40;
pub const EMARCH_ENC_I17_SIGN_INST_WORD_X: u32 = 3;
pub const EMARCH_ENC_I17_SIGN_SIZE_X: u32 = 1;
pub const EMARCH_ENC_I17_SIGN_INST_WORD_POS_X: u32 = 27;
pub const EMARCH_ENC_I17_SIGN_VAL_POS_X: u32 = 63;
pub const X3_OPCODE_INST_WORD_X: u32 = 3;
pub const X3_OPCODE_SIZE_X: u32 = 4;
pub const X3_OPCODE_INST_WORD_POS_X: u32 = 28;
pub const X3_OPCODE_SIGN_VAL_POS_X: u32 = 0;
pub const X3_I_INST_WORD_X: u32 = 3;
pub const X3_I_SIZE_X: u32 = 1;
pub const X3_I_INST_WORD_POS_X: u32 = 27;
pub const X3_I_SIGN_VAL_POS_X: u32 = 59;
pub const X3_D_WH_INST_WORD_X: u32 = 3;
pub const X3_D_WH_SIZE_X: u32 = 3;
pub const X3_D_WH_INST_WORD_POS_X: u32 = 24;
pub const X3_D_WH_SIGN_VAL_POS_X: u32 = 0;
pub const X3_IMM20_INST_WORD_X: u32 = 3;
pub const X3_IMM20_SIZE_X: u32 = 20;
pub const X3_IMM20_INST_WORD_POS_X: u32 = 4;
pub const X3_IMM20_SIGN_VAL_POS_X: u32 = 0;
pub const X3_IMM39_1_INST_WORD_X: u32 = 2;
pub const X3_IMM39_1_SIZE_X: u32 = 23;
pub const X3_IMM39_1_INST_WORD_POS_X: u32 = 0;
pub const X3_IMM39_1_SIGN_VAL_POS_X: u32 = 36;
pub const X3_IMM39_2_INST_WORD_X: u32 = 1;
pub const X3_IMM39_2_SIZE_X: u32 = 16;
pub const X3_IMM39_2_INST_WORD_POS_X: u32 = 16;
pub const X3_IMM39_2_SIGN_VAL_POS_X: u32 = 20;
pub const X3_P_INST_WORD_X: u32 = 3;
pub const X3_P_SIZE_X: u32 = 4;
pub const X3_P_INST_WORD_POS_X: u32 = 0;
pub const X3_P_SIGN_VAL_POS_X: u32 = 0;
pub const X3_TMPLT_INST_WORD_X: u32 = 0;
pub const X3_TMPLT_SIZE_X: u32 = 4;
pub const X3_TMPLT_INST_WORD_POS_X: u32 = 0;
pub const X3_TMPLT_SIGN_VAL_POS_X: u32 = 0;
pub const X3_BTYPE_QP_INST_WORD_X: u32 = 2;
pub const X3_BTYPE_QP_SIZE_X: u32 = 9;
pub const X3_BTYPE_QP_INST_WORD_POS_X: u32 = 23;
pub const X3_BTYPE_QP_INST_VAL_POS_X: u32 = 0;
pub const X3_EMPTY_INST_WORD_X: u32 = 1;
pub const X3_EMPTY_SIZE_X: u32 = 2;
pub const X3_EMPTY_INST_WORD_POS_X: u32 = 14;
pub const X3_EMPTY_INST_VAL_POS_X: u32 = 0;
pub const IMAGE_REL_BASED_ABSOLUTE: u32 = 0;
pub const IMAGE_REL_BASED_HIGH: u32 = 1;
pub const IMAGE_REL_BASED_LOW: u32 = 2;
pub const IMAGE_REL_BASED_HIGHLOW: u32 = 3;
pub const IMAGE_REL_BASED_HIGHADJ: u32 = 4;
pub const IMAGE_REL_BASED_MACHINE_SPECIFIC_5: u32 = 5;
pub const IMAGE_REL_BASED_RESERVED: u32 = 6;
pub const IMAGE_REL_BASED_MACHINE_SPECIFIC_7: u32 = 7;
pub const IMAGE_REL_BASED_MACHINE_SPECIFIC_8: u32 = 8;
pub const IMAGE_REL_BASED_MACHINE_SPECIFIC_9: u32 = 9;
pub const IMAGE_REL_BASED_DIR64: u32 = 10;
pub const IMAGE_REL_BASED_IA64_IMM64: u32 = 9;
pub const IMAGE_REL_BASED_MIPS_JMPADDR: u32 = 5;
pub const IMAGE_REL_BASED_MIPS_JMPADDR16: u32 = 9;
pub const IMAGE_REL_BASED_ARM_MOV32: u32 = 5;
pub const IMAGE_REL_BASED_THUMB_MOV32: u32 = 7;
pub const IMAGE_ARCHIVE_START_SIZE: u32 = 8;
pub const IMAGE_ARCHIVE_START: &[u8; 9] = b"!<arch>\n\0";
pub const IMAGE_ARCHIVE_END: &[u8; 3] = b"`\n\0";
pub const IMAGE_ARCHIVE_PAD: &[u8; 2] = b"\n\0";
pub const IMAGE_ARCHIVE_LINKER_MEMBER: &[u8; 17] = b"/               \0";
pub const IMAGE_ARCHIVE_LONGNAMES_MEMBER: &[u8; 17] = b"//              \0";
pub const IMAGE_ARCHIVE_HYBRIDMAP_MEMBER: &[u8; 17] = b"/<HYBRIDMAP>/   \0";
pub const IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR: u32 = 60;
pub const IMAGE_ORDINAL_FLAG64: i64 = -9223372036854775808;
pub const IMAGE_ORDINAL_FLAG32: u32 = 2147483648;
pub const IMAGE_ORDINAL_FLAG: i64 = -9223372036854775808;
pub const IMAGE_RESOURCE_NAME_IS_STRING: u32 = 2147483648;
pub const IMAGE_RESOURCE_DATA_IS_DIRECTORY: u32 = 2147483648;
pub const IMAGE_DYNAMIC_RELOCATION_GUARD_RF_PROLOGUE: u32 = 1;
pub const IMAGE_DYNAMIC_RELOCATION_GUARD_RF_EPILOGUE: u32 = 2;
pub const IMAGE_DYNAMIC_RELOCATION_GUARD_IMPORT_CONTROL_TRANSFER: u32 = 3;
pub const IMAGE_DYNAMIC_RELOCATION_GUARD_INDIR_CONTROL_TRANSFER: u32 = 4;
pub const IMAGE_DYNAMIC_RELOCATION_GUARD_SWITCHTABLE_BRANCH: u32 = 5;
pub const IMAGE_HOT_PATCH_BASE_OBLIGATORY: u32 = 1;
pub const IMAGE_HOT_PATCH_BASE_CAN_ROLL_BACK: u32 = 2;
pub const IMAGE_HOT_PATCH_CHUNK_INVERSE: u32 = 2147483648;
pub const IMAGE_HOT_PATCH_CHUNK_OBLIGATORY: u32 = 1073741824;
pub const IMAGE_HOT_PATCH_CHUNK_RESERVED: u32 = 1072705536;
pub const IMAGE_HOT_PATCH_CHUNK_TYPE: u32 = 1032192;
pub const IMAGE_HOT_PATCH_CHUNK_SOURCE_RVA: u32 = 32768;
pub const IMAGE_HOT_PATCH_CHUNK_TARGET_RVA: u32 = 16384;
pub const IMAGE_HOT_PATCH_CHUNK_SIZE: u32 = 4095;
pub const IMAGE_HOT_PATCH_NONE: u32 = 0;
pub const IMAGE_HOT_PATCH_FUNCTION: u32 = 114688;
pub const IMAGE_HOT_PATCH_ABSOLUTE: u32 = 180224;
pub const IMAGE_HOT_PATCH_REL32: u32 = 245760;
pub const IMAGE_HOT_PATCH_CALL_TARGET: u32 = 278528;
pub const IMAGE_HOT_PATCH_INDIRECT: u32 = 376832;
pub const IMAGE_HOT_PATCH_NO_CALL_TARGET: u32 = 409600;
pub const IMAGE_HOT_PATCH_DYNAMIC_VALUE: u32 = 491520;
pub const IMAGE_GUARD_CF_INSTRUMENTED: u32 = 256;
pub const IMAGE_GUARD_CFW_INSTRUMENTED: u32 = 512;
pub const IMAGE_GUARD_CF_FUNCTION_TABLE_PRESENT: u32 = 1024;
pub const IMAGE_GUARD_SECURITY_COOKIE_UNUSED: u32 = 2048;
pub const IMAGE_GUARD_PROTECT_DELAYLOAD_IAT: u32 = 4096;
pub const IMAGE_GUARD_DELAYLOAD_IAT_IN_ITS_OWN_SECTION: u32 = 8192;
pub const IMAGE_GUARD_CF_EXPORT_SUPPRESSION_INFO_PRESENT: u32 = 16384;
pub const IMAGE_GUARD_CF_ENABLE_EXPORT_SUPPRESSION: u32 = 32768;
pub const IMAGE_GUARD_CF_LONGJUMP_TABLE_PRESENT: u32 = 65536;
pub const IMAGE_GUARD_RF_INSTRUMENTED: u32 = 131072;
pub const IMAGE_GUARD_RF_ENABLE: u32 = 262144;
pub const IMAGE_GUARD_RF_STRICT: u32 = 524288;
pub const IMAGE_GUARD_RETPOLINE_PRESENT: u32 = 1048576;
pub const IMAGE_GUARD_EH_CONTINUATION_TABLE_PRESENT: u32 = 4194304;
pub const IMAGE_GUARD_XFG_ENABLED: u32 = 8388608;
pub const IMAGE_GUARD_CF_FUNCTION_TABLE_SIZE_MASK: u32 = 4026531840;
pub const IMAGE_GUARD_CF_FUNCTION_TABLE_SIZE_SHIFT: u32 = 28;
pub const IMAGE_GUARD_FLAG_FID_SUPPRESSED: u32 = 1;
pub const IMAGE_GUARD_FLAG_EXPORT_SUPPRESSED: u32 = 2;
pub const IMAGE_GUARD_FLAG_FID_LANGEXCPTHANDLER: u32 = 4;
pub const IMAGE_GUARD_FLAG_FID_XFG: u32 = 8;
pub const IMAGE_ENCLAVE_LONG_ID_LENGTH: u32 = 32;
pub const IMAGE_ENCLAVE_SHORT_ID_LENGTH: u32 = 16;
pub const IMAGE_ENCLAVE_POLICY_DEBUGGABLE: u32 = 1;
pub const IMAGE_ENCLAVE_FLAG_PRIMARY_IMAGE: u32 = 1;
pub const IMAGE_ENCLAVE_IMPORT_MATCH_NONE: u32 = 0;
pub const IMAGE_ENCLAVE_IMPORT_MATCH_UNIQUE_ID: u32 = 1;
pub const IMAGE_ENCLAVE_IMPORT_MATCH_AUTHOR_ID: u32 = 2;
pub const IMAGE_ENCLAVE_IMPORT_MATCH_FAMILY_ID: u32 = 3;
pub const IMAGE_ENCLAVE_IMPORT_MATCH_IMAGE_ID: u32 = 4;
pub const IMAGE_DEBUG_TYPE_UNKNOWN: u32 = 0;
pub const IMAGE_DEBUG_TYPE_COFF: u32 = 1;
pub const IMAGE_DEBUG_TYPE_CODEVIEW: u32 = 2;
pub const IMAGE_DEBUG_TYPE_FPO: u32 = 3;
pub const IMAGE_DEBUG_TYPE_MISC: u32 = 4;
pub const IMAGE_DEBUG_TYPE_EXCEPTION: u32 = 5;
pub const IMAGE_DEBUG_TYPE_FIXUP: u32 = 6;
pub const IMAGE_DEBUG_TYPE_OMAP_TO_SRC: u32 = 7;
pub const IMAGE_DEBUG_TYPE_OMAP_FROM_SRC: u32 = 8;
pub const IMAGE_DEBUG_TYPE_BORLAND: u32 = 9;
pub const IMAGE_DEBUG_TYPE_RESERVED10: u32 = 10;
pub const IMAGE_DEBUG_TYPE_CLSID: u32 = 11;
pub const IMAGE_DEBUG_TYPE_VC_FEATURE: u32 = 12;
pub const IMAGE_DEBUG_TYPE_POGO: u32 = 13;
pub const IMAGE_DEBUG_TYPE_ILTCG: u32 = 14;
pub const IMAGE_DEBUG_TYPE_MPX: u32 = 15;
pub const IMAGE_DEBUG_TYPE_REPRO: u32 = 16;
pub const IMAGE_DEBUG_TYPE_EX_DLLCHARACTERISTICS: u32 = 20;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_COMPAT: u32 = 1;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_COMPAT_STRICT_MODE: u32 = 2;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_SET_CONTEXT_IP_VALIDATION_RELAXED_MODE: u32 = 4;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_DYNAMIC_APIS_ALLOW_IN_PROC: u32 = 8;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_RESERVED_1: u32 = 16;
pub const IMAGE_DLLCHARACTERISTICS_EX_CET_RESERVED_2: u32 = 32;
pub const FRAME_FPO: u32 = 0;
pub const FRAME_TRAP: u32 = 1;
pub const FRAME_TSS: u32 = 2;
pub const FRAME_NONFPO: u32 = 3;
pub const SIZEOF_RFPO_DATA: u32 = 16;
pub const IMAGE_DEBUG_MISC_EXENAME: u32 = 1;
pub const IMAGE_SEPARATE_DEBUG_SIGNATURE: u32 = 18756;
pub const NON_PAGED_DEBUG_SIGNATURE: u32 = 18766;
pub const IMAGE_SEPARATE_DEBUG_FLAGS_MASK: u32 = 32768;
pub const IMAGE_SEPARATE_DEBUG_MISMATCH: u32 = 32768;
pub const IMPORT_OBJECT_HDR_SIG2: u32 = 65535;
pub const UNWIND_HISTORY_TABLE_SIZE: u32 = 12;
pub const RTL_RUN_ONCE_CHECK_ONLY: u32 = 1;
pub const RTL_RUN_ONCE_ASYNC: u32 = 2;
pub const RTL_RUN_ONCE_INIT_FAILED: u32 = 4;
pub const RTL_RUN_ONCE_CTX_RESERVED_BITS: u32 = 2;
pub const FAST_FAIL_LEGACY_GS_VIOLATION: u32 = 0;
pub const FAST_FAIL_VTGUARD_CHECK_FAILURE: u32 = 1;
pub const FAST_FAIL_STACK_COOKIE_CHECK_FAILURE: u32 = 2;
pub const FAST_FAIL_CORRUPT_LIST_ENTRY: u32 = 3;
pub const FAST_FAIL_INCORRECT_STACK: u32 = 4;
pub const FAST_FAIL_INVALID_ARG: u32 = 5;
pub const FAST_FAIL_GS_COOKIE_INIT: u32 = 6;
pub const FAST_FAIL_FATAL_APP_EXIT: u32 = 7;
pub const FAST_FAIL_RANGE_CHECK_FAILURE: u32 = 8;
pub const FAST_FAIL_UNSAFE_REGISTRY_ACCESS: u32 = 9;
pub const FAST_FAIL_GUARD_ICALL_CHECK_FAILURE: u32 = 10;
pub const FAST_FAIL_GUARD_WRITE_CHECK_FAILURE: u32 = 11;
pub const FAST_FAIL_INVALID_FIBER_SWITCH: u32 = 12;
pub const FAST_FAIL_INVALID_SET_OF_CONTEXT: u32 = 13;
pub const FAST_FAIL_INVALID_REFERENCE_COUNT: u32 = 14;
pub const FAST_FAIL_INVALID_JUMP_BUFFER: u32 = 18;
pub const FAST_FAIL_MRDATA_MODIFIED: u32 = 19;
pub const FAST_FAIL_CERTIFICATION_FAILURE: u32 = 20;
pub const FAST_FAIL_INVALID_EXCEPTION_CHAIN: u32 = 21;
pub const FAST_FAIL_CRYPTO_LIBRARY: u32 = 22;
pub const FAST_FAIL_INVALID_CALL_IN_DLL_CALLOUT: u32 = 23;
pub const FAST_FAIL_INVALID_IMAGE_BASE: u32 = 24;
pub const FAST_FAIL_DLOAD_PROTECTION_FAILURE: u32 = 25;
pub const FAST_FAIL_UNSAFE_EXTENSION_CALL: u32 = 26;
pub const FAST_FAIL_DEPRECATED_SERVICE_INVOKED: u32 = 27;
pub const FAST_FAIL_INVALID_BUFFER_ACCESS: u32 = 28;
pub const FAST_FAIL_INVALID_BALANCED_TREE: u32 = 29;
pub const FAST_FAIL_INVALID_NEXT_THREAD: u32 = 30;
pub const FAST_FAIL_GUARD_ICALL_CHECK_SUPPRESSED: u32 = 31;
pub const FAST_FAIL_APCS_DISABLED: u32 = 32;
pub const FAST_FAIL_INVALID_IDLE_STATE: u32 = 33;
pub const FAST_FAIL_MRDATA_PROTECTION_FAILURE: u32 = 34;
pub const FAST_FAIL_UNEXPECTED_HEAP_EXCEPTION: u32 = 35;
pub const FAST_FAIL_INVALID_LOCK_STATE: u32 = 36;
pub const FAST_FAIL_GUARD_JUMPTABLE: u32 = 37;
pub const FAST_FAIL_INVALID_LONGJUMP_TARGET: u32 = 38;
pub const FAST_FAIL_INVALID_DISPATCH_CONTEXT: u32 = 39;
pub const FAST_FAIL_INVALID_THREAD: u32 = 40;
pub const FAST_FAIL_INVALID_SYSCALL_NUMBER: u32 = 41;
pub const FAST_FAIL_INVALID_FILE_OPERATION: u32 = 42;
pub const FAST_FAIL_LPAC_ACCESS_DENIED: u32 = 43;
pub const FAST_FAIL_GUARD_SS_FAILURE: u32 = 44;
pub const FAST_FAIL_LOADER_CONTINUITY_FAILURE: u32 = 45;
pub const FAST_FAIL_GUARD_EXPORT_SUPPRESSION_FAILURE: u32 = 46;
pub const FAST_FAIL_INVALID_CONTROL_STACK: u32 = 47;
pub const FAST_FAIL_SET_CONTEXT_DENIED: u32 = 48;
pub const FAST_FAIL_INVALID_IAT: u32 = 49;
pub const FAST_FAIL_HEAP_METADATA_CORRUPTION: u32 = 50;
pub const FAST_FAIL_PAYLOAD_RESTRICTION_VIOLATION: u32 = 51;
pub const FAST_FAIL_LOW_LABEL_ACCESS_DENIED: u32 = 52;
pub const FAST_FAIL_ENCLAVE_CALL_FAILURE: u32 = 53;
pub const FAST_FAIL_UNHANDLED_LSS_EXCEPTON: u32 = 54;
pub const FAST_FAIL_ADMINLESS_ACCESS_DENIED: u32 = 55;
pub const FAST_FAIL_UNEXPECTED_CALL: u32 = 56;
pub const FAST_FAIL_CONTROL_INVALID_RETURN_ADDRESS: u32 = 57;
pub const FAST_FAIL_UNEXPECTED_HOST_BEHAVIOR: u32 = 58;
pub const FAST_FAIL_FLAGS_CORRUPTION: u32 = 59;
pub const FAST_FAIL_VEH_CORRUPTION: u32 = 60;
pub const FAST_FAIL_ETW_CORRUPTION: u32 = 61;
pub const FAST_FAIL_RIO_ABORT: u32 = 62;
pub const FAST_FAIL_INVALID_PFN: u32 = 63;
pub const FAST_FAIL_GUARD_ICALL_CHECK_FAILURE_XFG: u32 = 64;
pub const FAST_FAIL_CAST_GUARD: u32 = 65;
pub const FAST_FAIL_HOST_VISIBILITY_CHANGE: u32 = 66;
pub const FAST_FAIL_KERNEL_CET_SHADOW_STACK_ASSIST: u32 = 67;
pub const FAST_FAIL_PATCH_CALLBACK_FAILED: u32 = 68;
pub const FAST_FAIL_NTDLL_PATCH_FAILED: u32 = 69;
pub const FAST_FAIL_INVALID_FLS_DATA: u32 = 70;
pub const FAST_FAIL_INVALID_FAST_FAIL_CODE: u32 = 4294967295;
pub const HEAP_NO_SERIALIZE: u32 = 1;
pub const HEAP_GROWABLE: u32 = 2;
pub const HEAP_GENERATE_EXCEPTIONS: u32 = 4;
pub const HEAP_ZERO_MEMORY: u32 = 8;
pub const HEAP_REALLOC_IN_PLACE_ONLY: u32 = 16;
pub const HEAP_TAIL_CHECKING_ENABLED: u32 = 32;
pub const HEAP_FREE_CHECKING_ENABLED: u32 = 64;
pub const HEAP_DISABLE_COALESCE_ON_FREE: u32 = 128;
pub const HEAP_CREATE_ALIGN_16: u32 = 65536;
pub const HEAP_CREATE_ENABLE_TRACING: u32 = 131072;
pub const HEAP_CREATE_ENABLE_EXECUTE: u32 = 262144;
pub const HEAP_MAXIMUM_TAG: u32 = 4095;
pub const HEAP_PSEUDO_TAG_FLAG: u32 = 32768;
pub const HEAP_TAG_SHIFT: u32 = 18;
pub const HEAP_CREATE_SEGMENT_HEAP: u32 = 256;
pub const HEAP_CREATE_HARDENED: u32 = 512;
pub const IS_TEXT_UNICODE_ASCII16: u32 = 1;
pub const IS_TEXT_UNICODE_REVERSE_ASCII16: u32 = 16;
pub const IS_TEXT_UNICODE_STATISTICS: u32 = 2;
pub const IS_TEXT_UNICODE_REVERSE_STATISTICS: u32 = 32;
pub const IS_TEXT_UNICODE_CONTROLS: u32 = 4;
pub const IS_TEXT_UNICODE_REVERSE_CONTROLS: u32 = 64;
pub const IS_TEXT_UNICODE_SIGNATURE: u32 = 8;
pub const IS_TEXT_UNICODE_REVERSE_SIGNATURE: u32 = 128;
pub const IS_TEXT_UNICODE_ILLEGAL_CHARS: u32 = 256;
pub const IS_TEXT_UNICODE_ODD_LENGTH: u32 = 512;
pub const IS_TEXT_UNICODE_DBCS_LEADBYTE: u32 = 1024;
pub const IS_TEXT_UNICODE_UTF8: u32 = 2048;
pub const IS_TEXT_UNICODE_NULL_BYTES: u32 = 4096;
pub const IS_TEXT_UNICODE_UNICODE_MASK: u32 = 15;
pub const IS_TEXT_UNICODE_REVERSE_MASK: u32 = 240;
pub const IS_TEXT_UNICODE_NOT_UNICODE_MASK: u32 = 3840;
pub const IS_TEXT_UNICODE_NOT_ASCII_MASK: u32 = 61440;
pub const COMPRESSION_FORMAT_NONE: u32 = 0;
pub const COMPRESSION_FORMAT_DEFAULT: u32 = 1;
pub const COMPRESSION_FORMAT_LZNT1: u32 = 2;
pub const COMPRESSION_FORMAT_XPRESS: u32 = 3;
pub const COMPRESSION_FORMAT_XPRESS_HUFF: u32 = 4;
pub const COMPRESSION_FORMAT_XP10: u32 = 5;
pub const COMPRESSION_ENGINE_STANDARD: u32 = 0;
pub const COMPRESSION_ENGINE_MAXIMUM: u32 = 256;
pub const COMPRESSION_ENGINE_HIBER: u32 = 512;
pub const SEF_DACL_AUTO_INHERIT: u32 = 1;
pub const SEF_SACL_AUTO_INHERIT: u32 = 2;
pub const SEF_DEFAULT_DESCRIPTOR_FOR_OBJECT: u32 = 4;
pub const SEF_AVOID_PRIVILEGE_CHECK: u32 = 8;
pub const SEF_AVOID_OWNER_CHECK: u32 = 16;
pub const SEF_DEFAULT_OWNER_FROM_PARENT: u32 = 32;
pub const SEF_DEFAULT_GROUP_FROM_PARENT: u32 = 64;
pub const SEF_MACL_NO_WRITE_UP: u32 = 256;
pub const SEF_MACL_NO_READ_UP: u32 = 512;
pub const SEF_MACL_NO_EXECUTE_UP: u32 = 1024;
pub const SEF_AI_USE_EXTRA_PARAMS: u32 = 2048;
pub const SEF_AVOID_OWNER_RESTRICTION: u32 = 4096;
pub const SEF_FORCE_USER_MODE: u32 = 8192;
pub const SEF_MACL_VALID_FLAGS: u32 = 1792;
pub const MESSAGE_RESOURCE_UNICODE: u32 = 1;
pub const MESSAGE_RESOURCE_UTF8: u32 = 2;
pub const VER_EQUAL: u32 = 1;
pub const VER_GREATER: u32 = 2;
pub const VER_GREATER_EQUAL: u32 = 3;
pub const VER_LESS: u32 = 4;
pub const VER_LESS_EQUAL: u32 = 5;
pub const VER_AND: u32 = 6;
pub const VER_OR: u32 = 7;
pub const VER_CONDITION_MASK: u32 = 7;
pub const VER_NUM_BITS_PER_CONDITION_MASK: u32 = 3;
pub const VER_MINORVERSION: u32 = 1;
pub const VER_MAJORVERSION: u32 = 2;
pub const VER_BUILDNUMBER: u32 = 4;
pub const VER_PLATFORMID: u32 = 8;
pub const VER_SERVICEPACKMINOR: u32 = 16;
pub const VER_SERVICEPACKMAJOR: u32 = 32;
pub const VER_SUITENAME: u32 = 64;
pub const VER_PRODUCT_TYPE: u32 = 128;
pub const VER_NT_WORKSTATION: u32 = 1;
pub const VER_NT_DOMAIN_CONTROLLER: u32 = 2;
pub const VER_NT_SERVER: u32 = 3;
pub const VER_PLATFORM_WIN32s: u32 = 0;
pub const VER_PLATFORM_WIN32_WINDOWS: u32 = 1;
pub const VER_PLATFORM_WIN32_NT: u32 = 2;
pub const RTL_UMS_VERSION: u32 = 256;
pub const VRL_PREDEFINED_CLASS_BEGIN: u32 = 1;
pub const VRL_CUSTOM_CLASS_BEGIN: u32 = 256;
pub const VRL_CLASS_CONSISTENCY: u32 = 1;
pub const VRL_ENABLE_KERNEL_BREAKS: u32 = 2147483648;
pub const CTMF_INCLUDE_APPCONTAINER: u32 = 1;
pub const CTMF_INCLUDE_LPAC: u32 = 2;
pub const CTMF_VALID_FLAGS: u32 = 3;
pub const FLUSH_NV_MEMORY_IN_FLAG_NO_DRAIN: u32 = 1;
pub const WRITE_NV_MEMORY_FLAG_FLUSH: u32 = 1;
pub const WRITE_NV_MEMORY_FLAG_NON_TEMPORAL: u32 = 2;
pub const WRITE_NV_MEMORY_FLAG_PERSIST: u32 = 3;
pub const WRITE_NV_MEMORY_FLAG_NO_DRAIN: u32 = 256;
pub const FILL_NV_MEMORY_FLAG_FLUSH: u32 = 1;
pub const FILL_NV_MEMORY_FLAG_NON_TEMPORAL: u32 = 2;
pub const FILL_NV_MEMORY_FLAG_PERSIST: u32 = 3;
pub const FILL_NV_MEMORY_FLAG_NO_DRAIN: u32 = 256;
pub const RTL_CORRELATION_VECTOR_STRING_LENGTH: u32 = 129;
pub const RTL_CORRELATION_VECTOR_V1_PREFIX_LENGTH: u32 = 16;
pub const RTL_CORRELATION_VECTOR_V1_LENGTH: u32 = 64;
pub const RTL_CORRELATION_VECTOR_V2_PREFIX_LENGTH: u32 = 22;
pub const RTL_CORRELATION_VECTOR_V2_LENGTH: u32 = 128;
pub const IMAGE_POLICY_METADATA_VERSION: u32 = 1;
pub const IMAGE_POLICY_SECTION_NAME: &[u8; 9] = b".tPolicy\0";
pub const RTL_VIRTUAL_UNWIND2_VALIDATE_PAC: u32 = 1;
pub const RTL_CRITICAL_SECTION_FLAG_NO_DEBUG_INFO: u32 = 16777216;
pub const RTL_CRITICAL_SECTION_FLAG_DYNAMIC_SPIN: u32 = 33554432;
pub const RTL_CRITICAL_SECTION_FLAG_STATIC_INIT: u32 = 67108864;
pub const RTL_CRITICAL_SECTION_FLAG_RESOURCE_TYPE: u32 = 134217728;
pub const RTL_CRITICAL_SECTION_FLAG_FORCE_DEBUG_INFO: u32 = 268435456;
pub const RTL_CRITICAL_SECTION_ALL_FLAG_BITS: u32 = 4278190080;
pub const RTL_CRITICAL_SECTION_FLAG_RESERVED: u32 = 3758096384;
pub const RTL_CRITICAL_SECTION_DEBUG_FLAG_STATIC_INIT: u32 = 1;
pub const RTL_CONDITION_VARIABLE_LOCKMODE_SHARED: u32 = 1;
pub const HEAP_OPTIMIZE_RESOURCES_CURRENT_VERSION: u32 = 1;
pub const WT_EXECUTEDEFAULT: u32 = 0;
pub const WT_EXECUTEINIOTHREAD: u32 = 1;
pub const WT_EXECUTEINUITHREAD: u32 = 2;
pub const WT_EXECUTEINWAITTHREAD: u32 = 4;
pub const WT_EXECUTEONLYONCE: u32 = 8;
pub const WT_EXECUTEINTIMERTHREAD: u32 = 32;
pub const WT_EXECUTELONGFUNCTION: u32 = 16;
pub const WT_EXECUTEINPERSISTENTIOTHREAD: u32 = 64;
pub const WT_EXECUTEINPERSISTENTTHREAD: u32 = 128;
pub const WT_TRANSFER_IMPERSONATION: u32 = 256;
pub const WT_EXECUTEINLONGTHREAD: u32 = 16;
pub const WT_EXECUTEDELETEWAIT: u32 = 8;
pub const ACTIVATION_CONTEXT_PATH_TYPE_NONE: u32 = 1;
pub const ACTIVATION_CONTEXT_PATH_TYPE_WIN32_FILE: u32 = 2;
pub const ACTIVATION_CONTEXT_PATH_TYPE_URL: u32 = 3;
pub const ACTIVATION_CONTEXT_PATH_TYPE_ASSEMBLYREF: u32 = 4;
pub const CREATE_BOUNDARY_DESCRIPTOR_ADD_APPCONTAINER_SID: u32 = 1;
pub const PERFORMANCE_DATA_VERSION: u32 = 1;
pub const READ_THREAD_PROFILING_FLAG_DISPATCHING: u32 = 1;
pub const READ_THREAD_PROFILING_FLAG_HARDWARE_COUNTERS: u32 = 2;
pub const UNIFIEDBUILDREVISION_KEY: &[u8; 63] =
    b"\\Registry\\Machine\\Software\\Microsoft\\Windows NT\\CurrentVersion\0";
pub const UNIFIEDBUILDREVISION_VALUE: &[u8; 4] = b"UBR\0";
pub const UNIFIEDBUILDREVISION_MIN: u32 = 0;
pub const DEVICEFAMILYDEVICEFORM_KEY: &[u8; 67] =
    b"\\Registry\\Machine\\Software\\Microsoft\\Windows NT\\CurrentVersion\\OEM\0";
pub const DEVICEFAMILYDEVICEFORM_VALUE: &[u8; 11] = b"DeviceForm\0";
pub const DEVICEFAMILYINFOENUM_UAP: u32 = 0;
pub const DEVICEFAMILYINFOENUM_WINDOWS_8X: u32 = 1;
pub const DEVICEFAMILYINFOENUM_WINDOWS_PHONE_8X: u32 = 2;
pub const DEVICEFAMILYINFOENUM_DESKTOP: u32 = 3;
pub const DEVICEFAMILYINFOENUM_MOBILE: u32 = 4;
pub const DEVICEFAMILYINFOENUM_XBOX: u32 = 5;
pub const DEVICEFAMILYINFOENUM_TEAM: u32 = 6;
pub const DEVICEFAMILYINFOENUM_IOT: u32 = 7;
pub const DEVICEFAMILYINFOENUM_IOT_HEADLESS: u32 = 8;
pub const DEVICEFAMILYINFOENUM_SERVER: u32 = 9;
pub const DEVICEFAMILYINFOENUM_HOLOGRAPHIC: u32 = 10;
pub const DEVICEFAMILYINFOENUM_XBOXSRA: u32 = 11;
pub const DEVICEFAMILYINFOENUM_XBOXERA: u32 = 12;
pub const DEVICEFAMILYINFOENUM_SERVER_NANO: u32 = 13;
pub const DEVICEFAMILYINFOENUM_8828080: u32 = 14;
pub const DEVICEFAMILYINFOENUM_7067329: u32 = 15;
pub const DEVICEFAMILYINFOENUM_WINDOWS_CORE: u32 = 16;
pub const DEVICEFAMILYINFOENUM_WINDOWS_CORE_HEADLESS: u32 = 17;
pub const DEVICEFAMILYINFOENUM_MAX: u32 = 17;
pub const DEVICEFAMILYDEVICEFORM_UNKNOWN: u32 = 0;
pub const DEVICEFAMILYDEVICEFORM_PHONE: u32 = 1;
pub const DEVICEFAMILYDEVICEFORM_TABLET: u32 = 2;
pub const DEVICEFAMILYDEVICEFORM_DESKTOP: u32 = 3;
pub const DEVICEFAMILYDEVICEFORM_NOTEBOOK: u32 = 4;
pub const DEVICEFAMILYDEVICEFORM_CONVERTIBLE: u32 = 5;
pub const DEVICEFAMILYDEVICEFORM_DETACHABLE: u32 = 6;
pub const DEVICEFAMILYDEVICEFORM_ALLINONE: u32 = 7;
pub const DEVICEFAMILYDEVICEFORM_STICKPC: u32 = 8;
pub const DEVICEFAMILYDEVICEFORM_PUCK: u32 = 9;
pub const DEVICEFAMILYDEVICEFORM_LARGESCREEN: u32 = 10;
pub const DEVICEFAMILYDEVICEFORM_HMD: u32 = 11;
pub const DEVICEFAMILYDEVICEFORM_INDUSTRY_HANDHELD: u32 = 12;
pub const DEVICEFAMILYDEVICEFORM_INDUSTRY_TABLET: u32 = 13;
pub const DEVICEFAMILYDEVICEFORM_BANKING: u32 = 14;
pub const DEVICEFAMILYDEVICEFORM_BUILDING_AUTOMATION: u32 = 15;
pub const DEVICEFAMILYDEVICEFORM_DIGITAL_SIGNAGE: u32 = 16;
pub const DEVICEFAMILYDEVICEFORM_GAMING: u32 = 17;
pub const DEVICEFAMILYDEVICEFORM_HOME_AUTOMATION: u32 = 18;
pub const DEVICEFAMILYDEVICEFORM_INDUSTRIAL_AUTOMATION: u32 = 19;
pub const DEVICEFAMILYDEVICEFORM_KIOSK: u32 = 20;
pub const DEVICEFAMILYDEVICEFORM_MAKER_BOARD: u32 = 21;
pub const DEVICEFAMILYDEVICEFORM_MEDICAL: u32 = 22;
pub const DEVICEFAMILYDEVICEFORM_NETWORKING: u32 = 23;
pub const DEVICEFAMILYDEVICEFORM_POINT_OF_SERVICE: u32 = 24;
pub const DEVICEFAMILYDEVICEFORM_PRINTING: u32 = 25;
pub const DEVICEFAMILYDEVICEFORM_THIN_CLIENT: u32 = 26;
pub const DEVICEFAMILYDEVICEFORM_TOY: u32 = 27;
pub const DEVICEFAMILYDEVICEFORM_VENDING: u32 = 28;
pub const DEVICEFAMILYDEVICEFORM_INDUSTRY_OTHER: u32 = 29;
pub const DEVICEFAMILYDEVICEFORM_XBOX_ONE: u32 = 30;
pub const DEVICEFAMILYDEVICEFORM_XBOX_ONE_S: u32 = 31;
pub const DEVICEFAMILYDEVICEFORM_XBOX_ONE_X: u32 = 32;
pub const DEVICEFAMILYDEVICEFORM_XBOX_ONE_X_DEVKIT: u32 = 33;
pub const DEVICEFAMILYDEVICEFORM_XBOX_SERIES_X: u32 = 34;
pub const DEVICEFAMILYDEVICEFORM_XBOX_SERIES_X_DEVKIT: u32 = 35;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_00: u32 = 36;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_01: u32 = 37;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_02: u32 = 38;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_03: u32 = 39;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_04: u32 = 40;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_05: u32 = 41;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_06: u32 = 42;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_07: u32 = 43;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_08: u32 = 44;
pub const DEVICEFAMILYDEVICEFORM_XBOX_RESERVED_09: u32 = 45;
pub const DEVICEFAMILYDEVICEFORM_MAX: u32 = 45;
pub const DLL_PROCESS_ATTACH: u32 = 1;
pub const DLL_THREAD_ATTACH: u32 = 2;
pub const DLL_THREAD_DETACH: u32 = 3;
pub const DLL_PROCESS_DETACH: u32 = 0;
pub const EVENTLOG_SEQUENTIAL_READ: u32 = 1;
pub const EVENTLOG_SEEK_READ: u32 = 2;
pub const EVENTLOG_FORWARDS_READ: u32 = 4;
pub const EVENTLOG_BACKWARDS_READ: u32 = 8;
pub const EVENTLOG_SUCCESS: u32 = 0;
pub const EVENTLOG_ERROR_TYPE: u32 = 1;
pub const EVENTLOG_WARNING_TYPE: u32 = 2;
pub const EVENTLOG_INFORMATION_TYPE: u32 = 4;
pub const EVENTLOG_AUDIT_SUCCESS: u32 = 8;
pub const EVENTLOG_AUDIT_FAILURE: u32 = 16;
pub const EVENTLOG_START_PAIRED_EVENT: u32 = 1;
pub const EVENTLOG_END_PAIRED_EVENT: u32 = 2;
pub const EVENTLOG_END_ALL_PAIRED_EVENTS: u32 = 4;
pub const EVENTLOG_PAIRED_EVENT_ACTIVE: u32 = 8;
pub const EVENTLOG_PAIRED_EVENT_INACTIVE: u32 = 16;
pub const MAXLOGICALLOGNAMESIZE: u32 = 256;
pub const KEY_QUERY_VALUE: u32 = 1;
pub const KEY_SET_VALUE: u32 = 2;
pub const KEY_CREATE_SUB_KEY: u32 = 4;
pub const KEY_ENUMERATE_SUB_KEYS: u32 = 8;
pub const KEY_NOTIFY: u32 = 16;
pub const KEY_CREATE_LINK: u32 = 32;
pub const KEY_WOW64_32KEY: u32 = 512;
pub const KEY_WOW64_64KEY: u32 = 256;
pub const KEY_WOW64_RES: u32 = 768;
pub const KEY_READ: u32 = 131097;
pub const KEY_WRITE: u32 = 131078;
pub const KEY_EXECUTE: u32 = 131097;
pub const KEY_ALL_ACCESS: u32 = 983103;
pub const REG_OPTION_RESERVED: u32 = 0;
pub const REG_OPTION_NON_VOLATILE: u32 = 0;
pub const REG_OPTION_VOLATILE: u32 = 1;
pub const REG_OPTION_CREATE_LINK: u32 = 2;
pub const REG_OPTION_BACKUP_RESTORE: u32 = 4;
pub const REG_OPTION_OPEN_LINK: u32 = 8;
pub const REG_OPTION_DONT_VIRTUALIZE: u32 = 16;
pub const REG_LEGAL_OPTION: u32 = 31;
pub const REG_OPEN_LEGAL_OPTION: u32 = 28;
pub const REG_CREATED_NEW_KEY: u32 = 1;
pub const REG_OPENED_EXISTING_KEY: u32 = 2;
pub const REG_STANDARD_FORMAT: u32 = 1;
pub const REG_LATEST_FORMAT: u32 = 2;
pub const REG_NO_COMPRESSION: u32 = 4;
pub const REG_WHOLE_HIVE_VOLATILE: u32 = 1;
pub const REG_REFRESH_HIVE: u32 = 2;
pub const REG_NO_LAZY_FLUSH: u32 = 4;
pub const REG_FORCE_RESTORE: u32 = 8;
pub const REG_APP_HIVE: u32 = 16;
pub const REG_PROCESS_PRIVATE: u32 = 32;
pub const REG_START_JOURNAL: u32 = 64;
pub const REG_HIVE_EXACT_FILE_GROWTH: u32 = 128;
pub const REG_HIVE_NO_RM: u32 = 256;
pub const REG_HIVE_SINGLE_LOG: u32 = 512;
pub const REG_BOOT_HIVE: u32 = 1024;
pub const REG_LOAD_HIVE_OPEN_HANDLE: u32 = 2048;
pub const REG_FLUSH_HIVE_FILE_GROWTH: u32 = 4096;
pub const REG_OPEN_READ_ONLY: u32 = 8192;
pub const REG_IMMUTABLE: u32 = 16384;
pub const REG_NO_IMPERSONATION_FALLBACK: u32 = 32768;
pub const REG_APP_HIVE_OPEN_READ_ONLY: u32 = 8192;
pub const REG_FORCE_UNLOAD: u32 = 1;
pub const REG_UNLOAD_LEGAL_FLAGS: u32 = 1;
pub const REG_NOTIFY_CHANGE_NAME: u32 = 1;
pub const REG_NOTIFY_CHANGE_ATTRIBUTES: u32 = 2;
pub const REG_NOTIFY_CHANGE_LAST_SET: u32 = 4;
pub const REG_NOTIFY_CHANGE_SECURITY: u32 = 8;
pub const REG_NOTIFY_THREAD_AGNOSTIC: u32 = 268435456;
pub const REG_LEGAL_CHANGE_FILTER: u32 = 268435471;
pub const REG_NONE: u32 = 0;
pub const REG_SZ: u32 = 1;
pub const REG_EXPAND_SZ: u32 = 2;
pub const REG_BINARY: u32 = 3;
pub const REG_DWORD: u32 = 4;
pub const REG_DWORD_LITTLE_ENDIAN: u32 = 4;
pub const REG_DWORD_BIG_ENDIAN: u32 = 5;
pub const REG_LINK: u32 = 6;
pub const REG_MULTI_SZ: u32 = 7;
pub const REG_RESOURCE_LIST: u32 = 8;
pub const REG_FULL_RESOURCE_DESCRIPTOR: u32 = 9;
pub const REG_RESOURCE_REQUIREMENTS_LIST: u32 = 10;
pub const REG_QWORD: u32 = 11;
pub const REG_QWORD_LITTLE_ENDIAN: u32 = 11;
pub const SERVICE_KERNEL_DRIVER: u32 = 1;
pub const SERVICE_FILE_SYSTEM_DRIVER: u32 = 2;
pub const SERVICE_ADAPTER: u32 = 4;
pub const SERVICE_RECOGNIZER_DRIVER: u32 = 8;
pub const SERVICE_DRIVER: u32 = 11;
pub const SERVICE_WIN32_OWN_PROCESS: u32 = 16;
pub const SERVICE_WIN32_SHARE_PROCESS: u32 = 32;
pub const SERVICE_WIN32: u32 = 48;
pub const SERVICE_USER_SERVICE: u32 = 64;
pub const SERVICE_USERSERVICE_INSTANCE: u32 = 128;
pub const SERVICE_USER_SHARE_PROCESS: u32 = 96;
pub const SERVICE_USER_OWN_PROCESS: u32 = 80;
pub const SERVICE_INTERACTIVE_PROCESS: u32 = 256;
pub const SERVICE_PKG_SERVICE: u32 = 512;
pub const SERVICE_TYPE_ALL: u32 = 1023;
pub const SERVICE_BOOT_START: u32 = 0;
pub const SERVICE_SYSTEM_START: u32 = 1;
pub const SERVICE_AUTO_START: u32 = 2;
pub const SERVICE_DEMAND_START: u32 = 3;
pub const SERVICE_DISABLED: u32 = 4;
pub const SERVICE_ERROR_IGNORE: u32 = 0;
pub const SERVICE_ERROR_NORMAL: u32 = 1;
pub const SERVICE_ERROR_SEVERE: u32 = 2;
pub const SERVICE_ERROR_CRITICAL: u32 = 3;
pub const CM_SERVICE_NETWORK_BOOT_LOAD: u32 = 1;
pub const CM_SERVICE_VIRTUAL_DISK_BOOT_LOAD: u32 = 2;
pub const CM_SERVICE_USB_DISK_BOOT_LOAD: u32 = 4;
pub const CM_SERVICE_SD_DISK_BOOT_LOAD: u32 = 8;
pub const CM_SERVICE_USB3_DISK_BOOT_LOAD: u32 = 16;
pub const CM_SERVICE_MEASURED_BOOT_LOAD: u32 = 32;
pub const CM_SERVICE_VERIFIER_BOOT_LOAD: u32 = 64;
pub const CM_SERVICE_WINPE_BOOT_LOAD: u32 = 128;
pub const CM_SERVICE_RAM_DISK_BOOT_LOAD: u32 = 256;
pub const CM_SERVICE_VALID_PROMOTION_MASK: u32 = 511;
pub const TAPE_ERASE_SHORT: u32 = 0;
pub const TAPE_ERASE_LONG: u32 = 1;
pub const TAPE_LOAD: u32 = 0;
pub const TAPE_UNLOAD: u32 = 1;
pub const TAPE_TENSION: u32 = 2;
pub const TAPE_LOCK: u32 = 3;
pub const TAPE_UNLOCK: u32 = 4;
pub const TAPE_FORMAT: u32 = 5;
pub const TAPE_SETMARKS: u32 = 0;
pub const TAPE_FILEMARKS: u32 = 1;
pub const TAPE_SHORT_FILEMARKS: u32 = 2;
pub const TAPE_LONG_FILEMARKS: u32 = 3;
pub const TAPE_ABSOLUTE_POSITION: u32 = 0;
pub const TAPE_LOGICAL_POSITION: u32 = 1;
pub const TAPE_PSEUDO_LOGICAL_POSITION: u32 = 2;
pub const TAPE_REWIND: u32 = 0;
pub const TAPE_ABSOLUTE_BLOCK: u32 = 1;
pub const TAPE_LOGICAL_BLOCK: u32 = 2;
pub const TAPE_PSEUDO_LOGICAL_BLOCK: u32 = 3;
pub const TAPE_SPACE_END_OF_DATA: u32 = 4;
pub const TAPE_SPACE_RELATIVE_BLOCKS: u32 = 5;
pub const TAPE_SPACE_FILEMARKS: u32 = 6;
pub const TAPE_SPACE_SEQUENTIAL_FMKS: u32 = 7;
pub const TAPE_SPACE_SETMARKS: u32 = 8;
pub const TAPE_SPACE_SEQUENTIAL_SMKS: u32 = 9;
pub const TAPE_DRIVE_FIXED: u32 = 1;
pub const TAPE_DRIVE_SELECT: u32 = 2;
pub const TAPE_DRIVE_INITIATOR: u32 = 4;
pub const TAPE_DRIVE_ERASE_SHORT: u32 = 16;
pub const TAPE_DRIVE_ERASE_LONG: u32 = 32;
pub const TAPE_DRIVE_ERASE_BOP_ONLY: u32 = 64;
pub const TAPE_DRIVE_ERASE_IMMEDIATE: u32 = 128;
pub const TAPE_DRIVE_TAPE_CAPACITY: u32 = 256;
pub const TAPE_DRIVE_TAPE_REMAINING: u32 = 512;
pub const TAPE_DRIVE_FIXED_BLOCK: u32 = 1024;
pub const TAPE_DRIVE_VARIABLE_BLOCK: u32 = 2048;
pub const TAPE_DRIVE_WRITE_PROTECT: u32 = 4096;
pub const TAPE_DRIVE_EOT_WZ_SIZE: u32 = 8192;
pub const TAPE_DRIVE_ECC: u32 = 65536;
pub const TAPE_DRIVE_COMPRESSION: u32 = 131072;
pub const TAPE_DRIVE_PADDING: u32 = 262144;
pub const TAPE_DRIVE_REPORT_SMKS: u32 = 524288;
pub const TAPE_DRIVE_GET_ABSOLUTE_BLK: u32 = 1048576;
pub const TAPE_DRIVE_GET_LOGICAL_BLK: u32 = 2097152;
pub const TAPE_DRIVE_SET_EOT_WZ_SIZE: u32 = 4194304;
pub const TAPE_DRIVE_EJECT_MEDIA: u32 = 16777216;
pub const TAPE_DRIVE_CLEAN_REQUESTS: u32 = 33554432;
pub const TAPE_DRIVE_SET_CMP_BOP_ONLY: u32 = 67108864;
pub const TAPE_DRIVE_RESERVED_BIT: u32 = 2147483648;
pub const TAPE_DRIVE_LOAD_UNLOAD: u32 = 2147483649;
pub const TAPE_DRIVE_TENSION: u32 = 2147483650;
pub const TAPE_DRIVE_LOCK_UNLOCK: u32 = 2147483652;
pub const TAPE_DRIVE_REWIND_IMMEDIATE: u32 = 2147483656;
pub const TAPE_DRIVE_SET_BLOCK_SIZE: u32 = 2147483664;
pub const TAPE_DRIVE_LOAD_UNLD_IMMED: u32 = 2147483680;
pub const TAPE_DRIVE_TENSION_IMMED: u32 = 2147483712;
pub const TAPE_DRIVE_LOCK_UNLK_IMMED: u32 = 2147483776;
pub const TAPE_DRIVE_SET_ECC: u32 = 2147483904;
pub const TAPE_DRIVE_SET_COMPRESSION: u32 = 2147484160;
pub const TAPE_DRIVE_SET_PADDING: u32 = 2147484672;
pub const TAPE_DRIVE_SET_REPORT_SMKS: u32 = 2147485696;
pub const TAPE_DRIVE_ABSOLUTE_BLK: u32 = 2147487744;
pub const TAPE_DRIVE_ABS_BLK_IMMED: u32 = 2147491840;
pub const TAPE_DRIVE_LOGICAL_BLK: u32 = 2147500032;
pub const TAPE_DRIVE_LOG_BLK_IMMED: u32 = 2147516416;
pub const TAPE_DRIVE_END_OF_DATA: u32 = 2147549184;
pub const TAPE_DRIVE_RELATIVE_BLKS: u32 = 2147614720;
pub const TAPE_DRIVE_FILEMARKS: u32 = 2147745792;
pub const TAPE_DRIVE_SEQUENTIAL_FMKS: u32 = 2148007936;
pub const TAPE_DRIVE_SETMARKS: u32 = 2148532224;
pub const TAPE_DRIVE_SEQUENTIAL_SMKS: u32 = 2149580800;
pub const TAPE_DRIVE_REVERSE_POSITION: u32 = 2151677952;
pub const TAPE_DRIVE_SPACE_IMMEDIATE: u32 = 2155872256;
pub const TAPE_DRIVE_WRITE_SETMARKS: u32 = 2164260864;
pub const TAPE_DRIVE_WRITE_FILEMARKS: u32 = 2181038080;
pub const TAPE_DRIVE_WRITE_SHORT_FMKS: u32 = 2214592512;
pub const TAPE_DRIVE_WRITE_LONG_FMKS: u32 = 2281701376;
pub const TAPE_DRIVE_WRITE_MARK_IMMED: u32 = 2415919104;
pub const TAPE_DRIVE_FORMAT: u32 = 2684354560;
pub const TAPE_DRIVE_FORMAT_IMMEDIATE: u32 = 3221225472;
pub const TAPE_DRIVE_HIGH_FEATURES: u32 = 2147483648;
pub const TAPE_FIXED_PARTITIONS: u32 = 0;
pub const TAPE_SELECT_PARTITIONS: u32 = 1;
pub const TAPE_INITIATOR_PARTITIONS: u32 = 2;
pub const TAPE_QUERY_DRIVE_PARAMETERS: u32 = 0;
pub const TAPE_QUERY_MEDIA_CAPACITY: u32 = 1;
pub const TAPE_CHECK_FOR_DRIVE_PROBLEM: u32 = 2;
pub const TAPE_QUERY_IO_ERROR_DATA: u32 = 3;
pub const TAPE_QUERY_DEVICE_ERROR_DATA: u32 = 4;
pub const TRANSACTION_MANAGER_VOLATILE: u32 = 1;
pub const TRANSACTION_MANAGER_COMMIT_DEFAULT: u32 = 0;
pub const TRANSACTION_MANAGER_COMMIT_SYSTEM_VOLUME: u32 = 2;
pub const TRANSACTION_MANAGER_COMMIT_SYSTEM_HIVES: u32 = 4;
pub const TRANSACTION_MANAGER_COMMIT_LOWEST: u32 = 8;
pub const TRANSACTION_MANAGER_CORRUPT_FOR_RECOVERY: u32 = 16;
pub const TRANSACTION_MANAGER_CORRUPT_FOR_PROGRESS: u32 = 32;
pub const TRANSACTION_MANAGER_MAXIMUM_OPTION: u32 = 63;
pub const TRANSACTION_DO_NOT_PROMOTE: u32 = 1;
pub const TRANSACTION_MAXIMUM_OPTION: u32 = 1;
pub const RESOURCE_MANAGER_VOLATILE: u32 = 1;
pub const RESOURCE_MANAGER_COMMUNICATION: u32 = 2;
pub const RESOURCE_MANAGER_MAXIMUM_OPTION: u32 = 3;
pub const CRM_PROTOCOL_EXPLICIT_MARSHAL_ONLY: u32 = 1;
pub const CRM_PROTOCOL_DYNAMIC_MARSHAL_INFO: u32 = 2;
pub const CRM_PROTOCOL_MAXIMUM_OPTION: u32 = 3;
pub const ENLISTMENT_SUPERIOR: u32 = 1;
pub const ENLISTMENT_MAXIMUM_OPTION: u32 = 1;
pub const TRANSACTION_NOTIFY_MASK: u32 = 1073741823;
pub const TRANSACTION_NOTIFY_PREPREPARE: u32 = 1;
pub const TRANSACTION_NOTIFY_PREPARE: u32 = 2;
pub const TRANSACTION_NOTIFY_COMMIT: u32 = 4;
pub const TRANSACTION_NOTIFY_ROLLBACK: u32 = 8;
pub const TRANSACTION_NOTIFY_PREPREPARE_COMPLETE: u32 = 16;
pub const TRANSACTION_NOTIFY_PREPARE_COMPLETE: u32 = 32;
pub const TRANSACTION_NOTIFY_COMMIT_COMPLETE: u32 = 64;
pub const TRANSACTION_NOTIFY_ROLLBACK_COMPLETE: u32 = 128;
pub const TRANSACTION_NOTIFY_RECOVER: u32 = 256;
pub const TRANSACTION_NOTIFY_SINGLE_PHASE_COMMIT: u32 = 512;
pub const TRANSACTION_NOTIFY_DELEGATE_COMMIT: u32 = 1024;
pub const TRANSACTION_NOTIFY_RECOVER_QUERY: u32 = 2048;
pub const TRANSACTION_NOTIFY_ENLIST_PREPREPARE: u32 = 4096;
pub const TRANSACTION_NOTIFY_LAST_RECOVER: u32 = 8192;
pub const TRANSACTION_NOTIFY_INDOUBT: u32 = 16384;
pub const TRANSACTION_NOTIFY_PROPAGATE_PULL: u32 = 32768;
pub const TRANSACTION_NOTIFY_PROPAGATE_PUSH: u32 = 65536;
pub const TRANSACTION_NOTIFY_MARSHAL: u32 = 131072;
pub const TRANSACTION_NOTIFY_ENLIST_MASK: u32 = 262144;
pub const TRANSACTION_NOTIFY_RM_DISCONNECTED: u32 = 16777216;
pub const TRANSACTION_NOTIFY_TM_ONLINE: u32 = 33554432;
pub const TRANSACTION_NOTIFY_COMMIT_REQUEST: u32 = 67108864;
pub const TRANSACTION_NOTIFY_PROMOTE: u32 = 134217728;
pub const TRANSACTION_NOTIFY_PROMOTE_NEW: u32 = 268435456;
pub const TRANSACTION_NOTIFY_REQUEST_OUTCOME: u32 = 536870912;
pub const TRANSACTION_NOTIFY_COMMIT_FINALIZE: u32 = 1073741824;
pub const TRANSACTIONMANAGER_OBJECT_PATH: &[u8; 21] = b"\\TransactionManager\\\0";
pub const TRANSACTION_OBJECT_PATH: &[u8; 14] = b"\\Transaction\\\0";
pub const ENLISTMENT_OBJECT_PATH: &[u8; 13] = b"\\Enlistment\\\0";
pub const RESOURCE_MANAGER_OBJECT_PATH: &[u8; 18] = b"\\ResourceManager\\\0";
pub const TRANSACTION_NOTIFICATION_TM_ONLINE_FLAG_IS_CLUSTERED: u32 = 1;
pub const KTM_MARSHAL_BLOB_VERSION_MAJOR: u32 = 1;
pub const KTM_MARSHAL_BLOB_VERSION_MINOR: u32 = 1;
pub const MAX_TRANSACTION_DESCRIPTION_LENGTH: u32 = 64;
pub const MAX_RESOURCEMANAGER_DESCRIPTION_LENGTH: u32 = 64;
pub const TRANSACTIONMANAGER_QUERY_INFORMATION: u32 = 1;
pub const TRANSACTIONMANAGER_SET_INFORMATION: u32 = 2;
pub const TRANSACTIONMANAGER_RECOVER: u32 = 4;
pub const TRANSACTIONMANAGER_RENAME: u32 = 8;
pub const TRANSACTIONMANAGER_CREATE_RM: u32 = 16;
pub const TRANSACTIONMANAGER_BIND_TRANSACTION: u32 = 32;
pub const TRANSACTIONMANAGER_GENERIC_READ: u32 = 131073;
pub const TRANSACTIONMANAGER_GENERIC_WRITE: u32 = 131102;
pub const TRANSACTIONMANAGER_GENERIC_EXECUTE: u32 = 131072;
pub const TRANSACTIONMANAGER_ALL_ACCESS: u32 = 983103;
pub const TRANSACTION_QUERY_INFORMATION: u32 = 1;
pub const TRANSACTION_SET_INFORMATION: u32 = 2;
pub const TRANSACTION_ENLIST: u32 = 4;
pub const TRANSACTION_COMMIT: u32 = 8;
pub const TRANSACTION_ROLLBACK: u32 = 16;
pub const TRANSACTION_PROPAGATE: u32 = 32;
pub const TRANSACTION_RIGHT_RESERVED1: u32 = 64;
pub const TRANSACTION_GENERIC_READ: u32 = 1179649;
pub const TRANSACTION_GENERIC_WRITE: u32 = 1179710;
pub const TRANSACTION_GENERIC_EXECUTE: u32 = 1179672;
pub const TRANSACTION_ALL_ACCESS: u32 = 2031679;
pub const TRANSACTION_RESOURCE_MANAGER_RIGHTS: u32 = 1179703;
pub const RESOURCEMANAGER_QUERY_INFORMATION: u32 = 1;
pub const RESOURCEMANAGER_SET_INFORMATION: u32 = 2;
pub const RESOURCEMANAGER_RECOVER: u32 = 4;
pub const RESOURCEMANAGER_ENLIST: u32 = 8;
pub const RESOURCEMANAGER_GET_NOTIFICATION: u32 = 16;
pub const RESOURCEMANAGER_REGISTER_PROTOCOL: u32 = 32;
pub const RESOURCEMANAGER_COMPLETE_PROPAGATION: u32 = 64;
pub const RESOURCEMANAGER_GENERIC_READ: u32 = 1179649;
pub const RESOURCEMANAGER_GENERIC_WRITE: u32 = 1179774;
pub const RESOURCEMANAGER_GENERIC_EXECUTE: u32 = 1179740;
pub const RESOURCEMANAGER_ALL_ACCESS: u32 = 2031743;
pub const ENLISTMENT_QUERY_INFORMATION: u32 = 1;
pub const ENLISTMENT_SET_INFORMATION: u32 = 2;
pub const ENLISTMENT_RECOVER: u32 = 4;
pub const ENLISTMENT_SUBORDINATE_RIGHTS: u32 = 8;
pub const ENLISTMENT_SUPERIOR_RIGHTS: u32 = 16;
pub const ENLISTMENT_GENERIC_READ: u32 = 131073;
pub const ENLISTMENT_GENERIC_WRITE: u32 = 131102;
pub const ENLISTMENT_GENERIC_EXECUTE: u32 = 131100;
pub const ENLISTMENT_ALL_ACCESS: u32 = 983071;
pub const ACTIVATION_CONTEXT_SECTION_ASSEMBLY_INFORMATION: u32 = 1;
pub const ACTIVATION_CONTEXT_SECTION_DLL_REDIRECTION: u32 = 2;
pub const ACTIVATION_CONTEXT_SECTION_WINDOW_CLASS_REDIRECTION: u32 = 3;
pub const ACTIVATION_CONTEXT_SECTION_COM_SERVER_REDIRECTION: u32 = 4;
pub const ACTIVATION_CONTEXT_SECTION_COM_INTERFACE_REDIRECTION: u32 = 5;
pub const ACTIVATION_CONTEXT_SECTION_COM_TYPE_LIBRARY_REDIRECTION: u32 = 6;
pub const ACTIVATION_CONTEXT_SECTION_COM_PROGID_REDIRECTION: u32 = 7;
pub const ACTIVATION_CONTEXT_SECTION_GLOBAL_OBJECT_RENAME_TABLE: u32 = 8;
pub const ACTIVATION_CONTEXT_SECTION_CLR_SURROGATES: u32 = 9;
pub const ACTIVATION_CONTEXT_SECTION_APPLICATION_SETTINGS: u32 = 10;
pub const ACTIVATION_CONTEXT_SECTION_COMPATIBILITY_INFO: u32 = 11;
pub const ACTIVATION_CONTEXT_SECTION_WINRT_ACTIVATABLE_CLASSES: u32 = 12;
pub const APP_LOCAL_DEVICE_ID_SIZE: u32 = 32;
pub const DM_UPDATE: u32 = 1;
pub const DM_COPY: u32 = 2;
pub const DM_PROMPT: u32 = 4;
pub const DM_MODIFY: u32 = 8;
pub const DM_IN_BUFFER: u32 = 8;
pub const DM_IN_PROMPT: u32 = 4;
pub const DM_OUT_BUFFER: u32 = 2;
pub const DM_OUT_DEFAULT: u32 = 1;
pub const DC_FIELDS: u32 = 1;
pub const DC_PAPERS: u32 = 2;
pub const DC_PAPERSIZE: u32 = 3;
pub const DC_MINEXTENT: u32 = 4;
pub const DC_MAXEXTENT: u32 = 5;
pub const DC_BINS: u32 = 6;
pub const DC_DUPLEX: u32 = 7;
pub const DC_SIZE: u32 = 8;
pub const DC_EXTRA: u32 = 9;
pub const DC_VERSION: u32 = 10;
pub const DC_DRIVER: u32 = 11;
pub const DC_BINNAMES: u32 = 12;
pub const DC_ENUMRESOLUTIONS: u32 = 13;
pub const DC_FILEDEPENDENCIES: u32 = 14;
pub const DC_TRUETYPE: u32 = 15;
pub const DC_PAPERNAMES: u32 = 16;
pub const DC_ORIENTATION: u32 = 17;
pub const DC_COPIES: u32 = 18;
pub const FIND_FIRST_EX_CASE_SENSITIVE: u32 = 1;
pub const FIND_FIRST_EX_LARGE_FETCH: u32 = 2;
pub const FIND_FIRST_EX_ON_DISK_ENTRIES_ONLY: u32 = 4;
pub const LOCKFILE_FAIL_IMMEDIATELY: u32 = 1;
pub const LOCKFILE_EXCLUSIVE_LOCK: u32 = 2;
pub const PROCESS_HEAP_REGION: u32 = 1;
pub const PROCESS_HEAP_UNCOMMITTED_RANGE: u32 = 2;
pub const PROCESS_HEAP_ENTRY_BUSY: u32 = 4;
pub const PROCESS_HEAP_SEG_ALLOC: u32 = 8;
pub const PROCESS_HEAP_ENTRY_MOVEABLE: u32 = 16;
pub const PROCESS_HEAP_ENTRY_DDESHARE: u32 = 32;
pub const EXCEPTION_DEBUG_EVENT: u32 = 1;
pub const CREATE_THREAD_DEBUG_EVENT: u32 = 2;
pub const CREATE_PROCESS_DEBUG_EVENT: u32 = 3;
pub const EXIT_THREAD_DEBUG_EVENT: u32 = 4;
pub const EXIT_PROCESS_DEBUG_EVENT: u32 = 5;
pub const LOAD_DLL_DEBUG_EVENT: u32 = 6;
pub const UNLOAD_DLL_DEBUG_EVENT: u32 = 7;
pub const OUTPUT_DEBUG_STRING_EVENT: u32 = 8;
pub const RIP_EVENT: u32 = 9;
pub const LMEM_FIXED: u32 = 0;
pub const LMEM_MOVEABLE: u32 = 2;
pub const LMEM_NOCOMPACT: u32 = 16;
pub const LMEM_NODISCARD: u32 = 32;
pub const LMEM_ZEROINIT: u32 = 64;
pub const LMEM_MODIFY: u32 = 128;
pub const LMEM_DISCARDABLE: u32 = 3840;
pub const LMEM_VALID_FLAGS: u32 = 3954;
pub const LMEM_INVALID_HANDLE: u32 = 32768;
pub const LHND: u32 = 66;
pub const LPTR: u32 = 64;
pub const NONZEROLHND: u32 = 2;
pub const NONZEROLPTR: u32 = 0;
pub const LMEM_DISCARDED: u32 = 16384;
pub const LMEM_LOCKCOUNT: u32 = 255;
pub const CREATE_NEW: u32 = 1;
pub const CREATE_ALWAYS: u32 = 2;
pub const OPEN_EXISTING: u32 = 3;
pub const OPEN_ALWAYS: u32 = 4;
pub const TRUNCATE_EXISTING: u32 = 5;
pub const INIT_ONCE_CHECK_ONLY: u32 = 1;
pub const INIT_ONCE_ASYNC: u32 = 2;
pub const INIT_ONCE_INIT_FAILED: u32 = 4;
pub const INIT_ONCE_CTX_RESERVED_BITS: u32 = 2;
pub const CONDITION_VARIABLE_LOCKMODE_SHARED: u32 = 1;
pub const MUTEX_MODIFY_STATE: u32 = 1;
pub const MUTEX_ALL_ACCESS: u32 = 2031617;
pub const CREATE_MUTEX_INITIAL_OWNER: u32 = 1;
pub const CREATE_EVENT_MANUAL_RESET: u32 = 1;
pub const CREATE_EVENT_INITIAL_SET: u32 = 2;
pub const CREATE_WAITABLE_TIMER_MANUAL_RESET: u32 = 1;
pub const CREATE_WAITABLE_TIMER_HIGH_RESOLUTION: u32 = 2;
pub const SYNCHRONIZATION_BARRIER_FLAGS_SPIN_ONLY: u32 = 1;
pub const SYNCHRONIZATION_BARRIER_FLAGS_BLOCK_ONLY: u32 = 2;
pub const SYNCHRONIZATION_BARRIER_FLAGS_NO_DELETE: u32 = 4;
pub const PROC_THREAD_ATTRIBUTE_REPLACE_VALUE: u32 = 1;
pub const PROCESS_AFFINITY_ENABLE_AUTO_UPDATE: u32 = 1;
pub const THREAD_POWER_THROTTLING_CURRENT_VERSION: u32 = 1;
pub const THREAD_POWER_THROTTLING_EXECUTION_SPEED: u32 = 1;
pub const THREAD_POWER_THROTTLING_VALID_FLAGS: u32 = 1;
pub const PME_CURRENT_VERSION: u32 = 1;
pub const PME_FAILFAST_ON_COMMIT_FAIL_DISABLE: u32 = 0;
pub const PME_FAILFAST_ON_COMMIT_FAIL_ENABLE: u32 = 1;
pub const PROCESS_POWER_THROTTLING_CURRENT_VERSION: u32 = 1;
pub const PROCESS_POWER_THROTTLING_EXECUTION_SPEED: u32 = 1;
pub const PROCESS_POWER_THROTTLING_IGNORE_TIMER_RESOLUTION: u32 = 4;
pub const PROCESS_POWER_THROTTLING_VALID_FLAGS: u32 = 5;
pub const PROCESS_LEAP_SECOND_INFO_FLAG_ENABLE_SIXTY_SECOND: u32 = 1;
pub const PROCESS_LEAP_SECOND_INFO_VALID_FLAGS: u32 = 1;
pub const USER_CET_ENVIRONMENT_WIN32_PROCESS: u32 = 0;
pub const USER_CET_ENVIRONMENT_SGX2_ENCLAVE: u32 = 2;
pub const USER_CET_ENVIRONMENT_VBS_ENCLAVE: u32 = 16;
pub const USER_CET_ENVIRONMENT_VBS_BASIC_ENCLAVE: u32 = 17;
pub const SCEX2_ALT_NETBIOS_NAME: u32 = 1;
pub const FILE_MAP_WRITE: u32 = 2;
pub const FILE_MAP_READ: u32 = 4;
pub const FILE_MAP_ALL_ACCESS: u32 = 983071;
pub const FILE_MAP_EXECUTE: u32 = 32;
pub const FILE_MAP_COPY: u32 = 1;
pub const FILE_MAP_RESERVE: u32 = 2147483648;
pub const FILE_MAP_TARGETS_INVALID: u32 = 1073741824;
pub const FILE_MAP_LARGE_PAGES: u32 = 536870912;
pub const FILE_CACHE_MAX_HARD_ENABLE: u32 = 1;
pub const FILE_CACHE_MAX_HARD_DISABLE: u32 = 2;
pub const FILE_CACHE_MIN_HARD_ENABLE: u32 = 4;
pub const FILE_CACHE_MIN_HARD_DISABLE: u32 = 8;
pub const MEHC_PATROL_SCRUBBER_PRESENT: u32 = 1;
pub const FIND_RESOURCE_DIRECTORY_TYPES: u32 = 256;
pub const FIND_RESOURCE_DIRECTORY_NAMES: u32 = 512;
pub const FIND_RESOURCE_DIRECTORY_LANGUAGES: u32 = 1024;
pub const RESOURCE_ENUM_LN: u32 = 1;
pub const RESOURCE_ENUM_MUI: u32 = 2;
pub const RESOURCE_ENUM_MUI_SYSTEM: u32 = 4;
pub const RESOURCE_ENUM_VALIDATE: u32 = 8;
pub const RESOURCE_ENUM_MODULE_EXACT: u32 = 16;
pub const SUPPORT_LANG_NUMBER: u32 = 32;
pub const GET_MODULE_HANDLE_EX_FLAG_PIN: u32 = 1;
pub const GET_MODULE_HANDLE_EX_FLAG_UNCHANGED_REFCOUNT: u32 = 2;
pub const GET_MODULE_HANDLE_EX_FLAG_FROM_ADDRESS: u32 = 4;
pub const CURRENT_IMPORT_REDIRECTION_VERSION: u32 = 1;
pub const DONT_RESOLVE_DLL_REFERENCES: u32 = 1;
pub const LOAD_LIBRARY_AS_DATAFILE: u32 = 2;
pub const LOAD_WITH_ALTERED_SEARCH_PATH: u32 = 8;
pub const LOAD_IGNORE_CODE_AUTHZ_LEVEL: u32 = 16;
pub const LOAD_LIBRARY_AS_IMAGE_RESOURCE: u32 = 32;
pub const LOAD_LIBRARY_AS_DATAFILE_EXCLUSIVE: u32 = 64;
pub const LOAD_LIBRARY_REQUIRE_SIGNED_TARGET: u32 = 128;
pub const LOAD_LIBRARY_SEARCH_DLL_LOAD_DIR: u32 = 256;
pub const LOAD_LIBRARY_SEARCH_APPLICATION_DIR: u32 = 512;
pub const LOAD_LIBRARY_SEARCH_USER_DIRS: u32 = 1024;
pub const LOAD_LIBRARY_SEARCH_SYSTEM32: u32 = 2048;
pub const LOAD_LIBRARY_SEARCH_DEFAULT_DIRS: u32 = 4096;
pub const LOAD_LIBRARY_SAFE_CURRENT_DIRS: u32 = 8192;
pub const LOAD_LIBRARY_SEARCH_SYSTEM32_NO_FORWARDER: u32 = 16384;
pub const LOAD_LIBRARY_OS_INTEGRITY_CONTINUITY: u32 = 32768;
pub const PRIVATE_NAMESPACE_FLAG_DESTROY: u32 = 1;
pub const FILE_BEGIN: u32 = 0;
pub const FILE_CURRENT: u32 = 1;
pub const FILE_END: u32 = 2;
pub const FILE_FLAG_WRITE_THROUGH: u32 = 2147483648;
pub const FILE_FLAG_OVERLAPPED: u32 = 1073741824;
pub const FILE_FLAG_NO_BUFFERING: u32 = 536870912;
pub const FILE_FLAG_RANDOM_ACCESS: u32 = 268435456;
pub const FILE_FLAG_SEQUENTIAL_SCAN: u32 = 134217728;
pub const FILE_FLAG_DELETE_ON_CLOSE: u32 = 67108864;
pub const FILE_FLAG_BACKUP_SEMANTICS: u32 = 33554432;
pub const FILE_FLAG_POSIX_SEMANTICS: u32 = 16777216;
pub const FILE_FLAG_SESSION_AWARE: u32 = 8388608;
pub const FILE_FLAG_OPEN_REPARSE_POINT: u32 = 2097152;
pub const FILE_FLAG_OPEN_NO_RECALL: u32 = 1048576;
pub const FILE_FLAG_FIRST_PIPE_INSTANCE: u32 = 524288;
pub const FILE_FLAG_OPEN_REQUIRING_OPLOCK: u32 = 262144;
pub const PROGRESS_CONTINUE: u32 = 0;
pub const PROGRESS_CANCEL: u32 = 1;
pub const PROGRESS_STOP: u32 = 2;
pub const PROGRESS_QUIET: u32 = 3;
pub const CALLBACK_CHUNK_FINISHED: u32 = 0;
pub const CALLBACK_STREAM_SWITCH: u32 = 1;
pub const COPY_FILE_FAIL_IF_EXISTS: u32 = 1;
pub const COPY_FILE_RESTARTABLE: u32 = 2;
pub const COPY_FILE_OPEN_SOURCE_FOR_WRITE: u32 = 4;
pub const COPY_FILE_ALLOW_DECRYPTED_DESTINATION: u32 = 8;
pub const COPY_FILE_COPY_SYMLINK: u32 = 2048;
pub const COPY_FILE_NO_BUFFERING: u32 = 4096;
pub const COPY_FILE_REQUEST_SECURITY_PRIVILEGES: u32 = 8192;
pub const COPY_FILE_RESUME_FROM_PAUSE: u32 = 16384;
pub const COPY_FILE_NO_OFFLOAD: u32 = 262144;
pub const COPY_FILE_IGNORE_EDP_BLOCK: u32 = 4194304;
pub const COPY_FILE_IGNORE_SOURCE_ENCRYPTION: u32 = 8388608;
pub const COPY_FILE_DONT_REQUEST_DEST_WRITE_DAC: u32 = 33554432;
pub const COPY_FILE_REQUEST_COMPRESSED_TRAFFIC: u32 = 268435456;
pub const COPY_FILE_OPEN_AND_COPY_REPARSE_POINT: u32 = 2097152;
pub const COPY_FILE_DIRECTORY: u32 = 128;
pub const COPY_FILE_SKIP_ALTERNATE_STREAMS: u32 = 32768;
pub const COPY_FILE_DISABLE_PRE_ALLOCATION: u32 = 67108864;
pub const COPY_FILE_ENABLE_LOW_FREE_SPACE_MODE: u32 = 134217728;
pub const REPLACEFILE_WRITE_THROUGH: u32 = 1;
pub const REPLACEFILE_IGNORE_MERGE_ERRORS: u32 = 2;
pub const REPLACEFILE_IGNORE_ACL_ERRORS: u32 = 4;
pub const PIPE_ACCESS_INBOUND: u32 = 1;
pub const PIPE_ACCESS_OUTBOUND: u32 = 2;
pub const PIPE_ACCESS_DUPLEX: u32 = 3;
pub const PIPE_CLIENT_END: u32 = 0;
pub const PIPE_SERVER_END: u32 = 1;
pub const PIPE_WAIT: u32 = 0;
pub const PIPE_NOWAIT: u32 = 1;
pub const PIPE_READMODE_BYTE: u32 = 0;
pub const PIPE_READMODE_MESSAGE: u32 = 2;
pub const PIPE_TYPE_BYTE: u32 = 0;
pub const PIPE_TYPE_MESSAGE: u32 = 4;
pub const PIPE_ACCEPT_REMOTE_CLIENTS: u32 = 0;
pub const PIPE_REJECT_REMOTE_CLIENTS: u32 = 8;
pub const PIPE_UNLIMITED_INSTANCES: u32 = 255;
pub const SECURITY_CONTEXT_TRACKING: u32 = 262144;
pub const SECURITY_EFFECTIVE_ONLY: u32 = 524288;
pub const SECURITY_SQOS_PRESENT: u32 = 1048576;
pub const SECURITY_VALID_SQOS_FLAGS: u32 = 2031616;
pub const FAIL_FAST_GENERATE_EXCEPTION_ADDRESS: u32 = 1;
pub const FAIL_FAST_NO_HARD_ERROR_DLG: u32 = 2;
pub const DTR_CONTROL_DISABLE: u32 = 0;
pub const DTR_CONTROL_ENABLE: u32 = 1;
pub const DTR_CONTROL_HANDSHAKE: u32 = 2;
pub const RTS_CONTROL_DISABLE: u32 = 0;
pub const RTS_CONTROL_ENABLE: u32 = 1;
pub const RTS_CONTROL_HANDSHAKE: u32 = 2;
pub const RTS_CONTROL_TOGGLE: u32 = 3;
pub const GMEM_FIXED: u32 = 0;
pub const GMEM_MOVEABLE: u32 = 2;
pub const GMEM_NOCOMPACT: u32 = 16;
pub const GMEM_NODISCARD: u32 = 32;
pub const GMEM_ZEROINIT: u32 = 64;
pub const GMEM_MODIFY: u32 = 128;
pub const GMEM_DISCARDABLE: u32 = 256;
pub const GMEM_NOT_BANKED: u32 = 4096;
pub const GMEM_SHARE: u32 = 8192;
pub const GMEM_DDESHARE: u32 = 8192;
pub const GMEM_NOTIFY: u32 = 16384;
pub const GMEM_LOWER: u32 = 4096;
pub const GMEM_VALID_FLAGS: u32 = 32626;
pub const GMEM_INVALID_HANDLE: u32 = 32768;
pub const GHND: u32 = 66;
pub const GPTR: u32 = 64;
pub const GMEM_DISCARDED: u32 = 16384;
pub const GMEM_LOCKCOUNT: u32 = 255;
pub const DEBUG_PROCESS: u32 = 1;
pub const DEBUG_ONLY_THIS_PROCESS: u32 = 2;
pub const CREATE_SUSPENDED: u32 = 4;
pub const DETACHED_PROCESS: u32 = 8;
pub const CREATE_NEW_CONSOLE: u32 = 16;
pub const NORMAL_PRIORITY_CLASS: u32 = 32;
pub const IDLE_PRIORITY_CLASS: u32 = 64;
pub const HIGH_PRIORITY_CLASS: u32 = 128;
pub const REALTIME_PRIORITY_CLASS: u32 = 256;
pub const CREATE_NEW_PROCESS_GROUP: u32 = 512;
pub const CREATE_UNICODE_ENVIRONMENT: u32 = 1024;
pub const CREATE_SEPARATE_WOW_VDM: u32 = 2048;
pub const CREATE_SHARED_WOW_VDM: u32 = 4096;
pub const CREATE_FORCEDOS: u32 = 8192;
pub const BELOW_NORMAL_PRIORITY_CLASS: u32 = 16384;
pub const ABOVE_NORMAL_PRIORITY_CLASS: u32 = 32768;
pub const INHERIT_PARENT_AFFINITY: u32 = 65536;
pub const INHERIT_CALLER_PRIORITY: u32 = 131072;
pub const CREATE_PROTECTED_PROCESS: u32 = 262144;
pub const EXTENDED_STARTUPINFO_PRESENT: u32 = 524288;
pub const PROCESS_MODE_BACKGROUND_BEGIN: u32 = 1048576;
pub const PROCESS_MODE_BACKGROUND_END: u32 = 2097152;
pub const CREATE_SECURE_PROCESS: u32 = 4194304;
pub const CREATE_BREAKAWAY_FROM_JOB: u32 = 16777216;
pub const CREATE_PRESERVE_CODE_AUTHZ_LEVEL: u32 = 33554432;
pub const CREATE_DEFAULT_ERROR_MODE: u32 = 67108864;
pub const CREATE_NO_WINDOW: u32 = 134217728;
pub const PROFILE_USER: u32 = 268435456;
pub const PROFILE_KERNEL: u32 = 536870912;
pub const PROFILE_SERVER: u32 = 1073741824;
pub const CREATE_IGNORE_SYSTEM_DEFAULT: u32 = 2147483648;
pub const STACK_SIZE_PARAM_IS_A_RESERVATION: u32 = 65536;
pub const THREAD_PRIORITY_LOWEST: i32 = -2;
pub const THREAD_PRIORITY_BELOW_NORMAL: i32 = -1;
pub const THREAD_PRIORITY_NORMAL: u32 = 0;
pub const THREAD_PRIORITY_HIGHEST: u32 = 2;
pub const THREAD_PRIORITY_ABOVE_NORMAL: u32 = 1;
pub const THREAD_PRIORITY_ERROR_RETURN: u32 = 2147483647;
pub const THREAD_PRIORITY_TIME_CRITICAL: u32 = 15;
pub const THREAD_PRIORITY_IDLE: i32 = -15;
pub const THREAD_MODE_BACKGROUND_BEGIN: u32 = 65536;
pub const THREAD_MODE_BACKGROUND_END: u32 = 131072;
pub const VOLUME_NAME_DOS: u32 = 0;
pub const VOLUME_NAME_GUID: u32 = 1;
pub const VOLUME_NAME_NT: u32 = 2;
pub const VOLUME_NAME_NONE: u32 = 4;
pub const FILE_NAME_NORMALIZED: u32 = 0;
pub const FILE_NAME_OPENED: u32 = 8;
pub const DRIVE_UNKNOWN: u32 = 0;
pub const DRIVE_NO_ROOT_DIR: u32 = 1;
pub const DRIVE_REMOVABLE: u32 = 2;
pub const DRIVE_FIXED: u32 = 3;
pub const DRIVE_REMOTE: u32 = 4;
pub const DRIVE_CDROM: u32 = 5;
pub const DRIVE_RAMDISK: u32 = 6;
pub const FILE_TYPE_UNKNOWN: u32 = 0;
pub const FILE_TYPE_DISK: u32 = 1;
pub const FILE_TYPE_CHAR: u32 = 2;
pub const FILE_TYPE_PIPE: u32 = 3;
pub const FILE_TYPE_REMOTE: u32 = 32768;
pub const NOPARITY: u32 = 0;
pub const ODDPARITY: u32 = 1;
pub const EVENPARITY: u32 = 2;
pub const MARKPARITY: u32 = 3;
pub const SPACEPARITY: u32 = 4;
pub const ONESTOPBIT: u32 = 0;
pub const ONE5STOPBITS: u32 = 1;
pub const TWOSTOPBITS: u32 = 2;
pub const IGNORE: u32 = 0;
pub const INFINITE: u32 = 4294967295;
pub const CBR_110: u32 = 110;
pub const CBR_300: u32 = 300;
pub const CBR_600: u32 = 600;
pub const CBR_1200: u32 = 1200;
pub const CBR_2400: u32 = 2400;
pub const CBR_4800: u32 = 4800;
pub const CBR_9600: u32 = 9600;
pub const CBR_14400: u32 = 14400;
pub const CBR_19200: u32 = 19200;
pub const CBR_38400: u32 = 38400;
pub const CBR_56000: u32 = 56000;
pub const CBR_57600: u32 = 57600;
pub const CBR_115200: u32 = 115200;
pub const CBR_128000: u32 = 128000;
pub const CBR_256000: u32 = 256000;
pub const CE_RXOVER: u32 = 1;
pub const CE_OVERRUN: u32 = 2;
pub const CE_RXPARITY: u32 = 4;
pub const CE_FRAME: u32 = 8;
pub const CE_BREAK: u32 = 16;
pub const CE_TXFULL: u32 = 256;
pub const CE_PTO: u32 = 512;
pub const CE_IOE: u32 = 1024;
pub const CE_DNS: u32 = 2048;
pub const CE_OOP: u32 = 4096;
pub const CE_MODE: u32 = 32768;
pub const IE_BADID: i32 = -1;
pub const IE_OPEN: i32 = -2;
pub const IE_NOPEN: i32 = -3;
pub const IE_MEMORY: i32 = -4;
pub const IE_DEFAULT: i32 = -5;
pub const IE_HARDWARE: i32 = -10;
pub const IE_BYTESIZE: i32 = -11;
pub const IE_BAUDRATE: i32 = -12;
pub const EV_RXCHAR: u32 = 1;
pub const EV_RXFLAG: u32 = 2;
pub const EV_TXEMPTY: u32 = 4;
pub const EV_CTS: u32 = 8;
pub const EV_DSR: u32 = 16;
pub const EV_RLSD: u32 = 32;
pub const EV_BREAK: u32 = 64;
pub const EV_ERR: u32 = 128;
pub const EV_RING: u32 = 256;
pub const EV_PERR: u32 = 512;
pub const EV_RX80FULL: u32 = 1024;
pub const EV_EVENT1: u32 = 2048;
pub const EV_EVENT2: u32 = 4096;
pub const SETXOFF: u32 = 1;
pub const SETXON: u32 = 2;
pub const SETRTS: u32 = 3;
pub const CLRRTS: u32 = 4;
pub const SETDTR: u32 = 5;
pub const CLRDTR: u32 = 6;
pub const RESETDEV: u32 = 7;
pub const SETBREAK: u32 = 8;
pub const CLRBREAK: u32 = 9;
pub const PURGE_TXABORT: u32 = 1;
pub const PURGE_RXABORT: u32 = 2;
pub const PURGE_TXCLEAR: u32 = 4;
pub const PURGE_RXCLEAR: u32 = 8;
pub const LPTx: u32 = 128;
pub const S_QUEUEEMPTY: u32 = 0;
pub const S_THRESHOLD: u32 = 1;
pub const S_ALLTHRESHOLD: u32 = 2;
pub const S_NORMAL: u32 = 0;
pub const S_LEGATO: u32 = 1;
pub const S_STACCATO: u32 = 2;
pub const S_PERIOD512: u32 = 0;
pub const S_PERIOD1024: u32 = 1;
pub const S_PERIOD2048: u32 = 2;
pub const S_PERIODVOICE: u32 = 3;
pub const S_WHITE512: u32 = 4;
pub const S_WHITE1024: u32 = 5;
pub const S_WHITE2048: u32 = 6;
pub const S_WHITEVOICE: u32 = 7;
pub const S_SERDVNA: i32 = -1;
pub const S_SEROFM: i32 = -2;
pub const S_SERMACT: i32 = -3;
pub const S_SERQFUL: i32 = -4;
pub const S_SERBDNT: i32 = -5;
pub const S_SERDLN: i32 = -6;
pub const S_SERDCC: i32 = -7;
pub const S_SERDTP: i32 = -8;
pub const S_SERDVL: i32 = -9;
pub const S_SERDMD: i32 = -10;
pub const S_SERDSH: i32 = -11;
pub const S_SERDPT: i32 = -12;
pub const S_SERDFQ: i32 = -13;
pub const S_SERDDR: i32 = -14;
pub const S_SERDSR: i32 = -15;
pub const S_SERDST: i32 = -16;
pub const NMPWAIT_WAIT_FOREVER: u32 = 4294967295;
pub const NMPWAIT_NOWAIT: u32 = 1;
pub const NMPWAIT_USE_DEFAULT_WAIT: u32 = 0;
pub const FS_CASE_IS_PRESERVED: u32 = 2;
pub const FS_CASE_SENSITIVE: u32 = 1;
pub const FS_UNICODE_STORED_ON_DISK: u32 = 4;
pub const FS_PERSISTENT_ACLS: u32 = 8;
pub const FS_VOL_IS_COMPRESSED: u32 = 32768;
pub const FS_FILE_COMPRESSION: u32 = 16;
pub const FS_FILE_ENCRYPTION: u32 = 131072;
pub const OF_READ: u32 = 0;
pub const OF_WRITE: u32 = 1;
pub const OF_READWRITE: u32 = 2;
pub const OF_SHARE_COMPAT: u32 = 0;
pub const OF_SHARE_EXCLUSIVE: u32 = 16;
pub const OF_SHARE_DENY_WRITE: u32 = 32;
pub const OF_SHARE_DENY_READ: u32 = 48;
pub const OF_SHARE_DENY_NONE: u32 = 64;
pub const OF_PARSE: u32 = 256;
pub const OF_DELETE: u32 = 512;
pub const OF_VERIFY: u32 = 1024;
pub const OF_CANCEL: u32 = 2048;
pub const OF_CREATE: u32 = 4096;
pub const OF_PROMPT: u32 = 8192;
pub const OF_EXIST: u32 = 16384;
pub const OF_REOPEN: u32 = 32768;
pub const OFS_MAXPATHNAME: u32 = 128;
pub const MAXINTATOM: u32 = 49152;
pub const SCS_32BIT_BINARY: u32 = 0;
pub const SCS_DOS_BINARY: u32 = 1;
pub const SCS_WOW_BINARY: u32 = 2;
pub const SCS_PIF_BINARY: u32 = 3;
pub const SCS_POSIX_BINARY: u32 = 4;
pub const SCS_OS216_BINARY: u32 = 5;
pub const SCS_64BIT_BINARY: u32 = 6;
pub const SCS_THIS_PLATFORM_BINARY: u32 = 6;
pub const FIBER_FLAG_FLOAT_SWITCH: u32 = 1;
pub const UMS_VERSION: u32 = 256;
pub const PROCESS_DEP_ENABLE: u32 = 1;
pub const PROCESS_DEP_DISABLE_ATL_THUNK_EMULATION: u32 = 2;
pub const FILE_SKIP_COMPLETION_PORT_ON_SUCCESS: u32 = 1;
pub const FILE_SKIP_SET_EVENT_ON_HANDLE: u32 = 2;
pub const SEM_FAILCRITICALERRORS: u32 = 1;
pub const SEM_NOGPFAULTERRORBOX: u32 = 2;
pub const SEM_NOALIGNMENTFAULTEXCEPT: u32 = 4;
pub const SEM_NOOPENFILEERRORBOX: u32 = 32768;
pub const CRITICAL_SECTION_NO_DEBUG_INFO: u32 = 16777216;
pub const HANDLE_FLAG_INHERIT: u32 = 1;
pub const HANDLE_FLAG_PROTECT_FROM_CLOSE: u32 = 2;
pub const HINSTANCE_ERROR: u32 = 32;
pub const GET_TAPE_MEDIA_INFORMATION: u32 = 0;
pub const GET_TAPE_DRIVE_INFORMATION: u32 = 1;
pub const SET_TAPE_MEDIA_INFORMATION: u32 = 0;
pub const SET_TAPE_DRIVE_INFORMATION: u32 = 1;
pub const FORMAT_MESSAGE_ALLOCATE_BUFFER: u32 = 256;
pub const FORMAT_MESSAGE_IGNORE_INSERTS: u32 = 512;
pub const FORMAT_MESSAGE_FROM_STRING: u32 = 1024;
pub const FORMAT_MESSAGE_FROM_HMODULE: u32 = 2048;
pub const FORMAT_MESSAGE_FROM_SYSTEM: u32 = 4096;
pub const FORMAT_MESSAGE_ARGUMENT_ARRAY: u32 = 8192;
pub const FORMAT_MESSAGE_MAX_WIDTH_MASK: u32 = 255;
pub const FILE_ENCRYPTABLE: u32 = 0;
pub const FILE_IS_ENCRYPTED: u32 = 1;
pub const FILE_SYSTEM_ATTR: u32 = 2;
pub const FILE_ROOT_DIR: u32 = 3;
pub const FILE_SYSTEM_DIR: u32 = 4;
pub const FILE_UNKNOWN: u32 = 5;
pub const FILE_SYSTEM_NOT_SUPPORT: u32 = 6;
pub const FILE_USER_DISALLOWED: u32 = 7;
pub const FILE_READ_ONLY: u32 = 8;
pub const FILE_DIR_DISALLOWED: u32 = 9;
pub const EFS_USE_RECOVERY_KEYS: u32 = 1;
pub const CREATE_FOR_IMPORT: u32 = 1;
pub const CREATE_FOR_DIR: u32 = 2;
pub const OVERWRITE_HIDDEN: u32 = 4;
pub const EFSRPC_SECURE_ONLY: u32 = 8;
pub const EFS_DROP_ALTERNATE_STREAMS: u32 = 16;
pub const BACKUP_INVALID: u32 = 0;
pub const BACKUP_DATA: u32 = 1;
pub const BACKUP_EA_DATA: u32 = 2;
pub const BACKUP_SECURITY_DATA: u32 = 3;
pub const BACKUP_ALTERNATE_DATA: u32 = 4;
pub const BACKUP_LINK: u32 = 5;
pub const BACKUP_PROPERTY_DATA: u32 = 6;
pub const BACKUP_OBJECT_ID: u32 = 7;
pub const BACKUP_REPARSE_DATA: u32 = 8;
pub const BACKUP_SPARSE_BLOCK: u32 = 9;
pub const BACKUP_TXFS_DATA: u32 = 10;
pub const BACKUP_GHOSTED_FILE_EXTENTS: u32 = 11;
pub const STREAM_NORMAL_ATTRIBUTE: u32 = 0;
pub const STREAM_MODIFIED_WHEN_READ: u32 = 1;
pub const STREAM_CONTAINS_SECURITY: u32 = 2;
pub const STREAM_CONTAINS_PROPERTIES: u32 = 4;
pub const STREAM_SPARSE_ATTRIBUTE: u32 = 8;
pub const STREAM_CONTAINS_GHOSTED_FILE_EXTENTS: u32 = 16;
pub const STARTF_USESHOWWINDOW: u32 = 1;
pub const STARTF_USESIZE: u32 = 2;
pub const STARTF_USEPOSITION: u32 = 4;
pub const STARTF_USECOUNTCHARS: u32 = 8;
pub const STARTF_USEFILLATTRIBUTE: u32 = 16;
pub const STARTF_RUNFULLSCREEN: u32 = 32;
pub const STARTF_FORCEONFEEDBACK: u32 = 64;
pub const STARTF_FORCEOFFFEEDBACK: u32 = 128;
pub const STARTF_USESTDHANDLES: u32 = 256;
pub const STARTF_USEHOTKEY: u32 = 512;
pub const STARTF_TITLEISLINKNAME: u32 = 2048;
pub const STARTF_TITLEISAPPID: u32 = 4096;
pub const STARTF_PREVENTPINNING: u32 = 8192;
pub const STARTF_UNTRUSTEDSOURCE: u32 = 32768;
pub const STARTF_HOLOGRAPHIC: u32 = 262144;
pub const SHUTDOWN_NORETRY: u32 = 1;
pub const PROTECTION_LEVEL_WINTCB_LIGHT: u32 = 0;
pub const PROTECTION_LEVEL_WINDOWS: u32 = 1;
pub const PROTECTION_LEVEL_WINDOWS_LIGHT: u32 = 2;
pub const PROTECTION_LEVEL_ANTIMALWARE_LIGHT: u32 = 3;
pub const PROTECTION_LEVEL_LSA_LIGHT: u32 = 4;
pub const PROTECTION_LEVEL_WINTCB: u32 = 5;
pub const PROTECTION_LEVEL_CODEGEN_LIGHT: u32 = 6;
pub const PROTECTION_LEVEL_AUTHENTICODE: u32 = 7;
pub const PROTECTION_LEVEL_PPL_APP: u32 = 8;
pub const PROTECTION_LEVEL_SAME: u32 = 4294967295;
pub const PROTECTION_LEVEL_NONE: u32 = 4294967294;
pub const PROCESS_NAME_NATIVE: u32 = 1;
pub const PROC_THREAD_ATTRIBUTE_NUMBER: u32 = 65535;
pub const PROC_THREAD_ATTRIBUTE_THREAD: u32 = 65536;
pub const PROC_THREAD_ATTRIBUTE_INPUT: u32 = 131072;
pub const PROC_THREAD_ATTRIBUTE_ADDITIVE: u32 = 262144;
pub const PROCESS_CREATION_MITIGATION_POLICY_DEP_ENABLE: u32 = 1;
pub const PROCESS_CREATION_MITIGATION_POLICY_DEP_ATL_THUNK_ENABLE: u32 = 2;
pub const PROCESS_CREATION_MITIGATION_POLICY_SEHOP_ENABLE: u32 = 4;
pub const PROCESS_CREATION_MITIGATION_POLICY_FORCE_RELOCATE_IMAGES_MASK: u32 = 768;
pub const PROCESS_CREATION_MITIGATION_POLICY_FORCE_RELOCATE_IMAGES_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_FORCE_RELOCATE_IMAGES_ALWAYS_ON: u32 = 256;
pub const PROCESS_CREATION_MITIGATION_POLICY_FORCE_RELOCATE_IMAGES_ALWAYS_OFF: u32 = 512;
pub const PROCESS_CREATION_MITIGATION_POLICY_FORCE_RELOCATE_IMAGES_ALWAYS_ON_REQ_RELOCS: u32 = 768;
pub const PROCESS_CREATION_MITIGATION_POLICY_HEAP_TERMINATE_MASK: u32 = 12288;
pub const PROCESS_CREATION_MITIGATION_POLICY_HEAP_TERMINATE_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_HEAP_TERMINATE_ALWAYS_ON: u32 = 4096;
pub const PROCESS_CREATION_MITIGATION_POLICY_HEAP_TERMINATE_ALWAYS_OFF: u32 = 8192;
pub const PROCESS_CREATION_MITIGATION_POLICY_HEAP_TERMINATE_RESERVED: u32 = 12288;
pub const PROCESS_CREATION_MITIGATION_POLICY_BOTTOM_UP_ASLR_MASK: u32 = 196608;
pub const PROCESS_CREATION_MITIGATION_POLICY_BOTTOM_UP_ASLR_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_BOTTOM_UP_ASLR_ALWAYS_ON: u32 = 65536;
pub const PROCESS_CREATION_MITIGATION_POLICY_BOTTOM_UP_ASLR_ALWAYS_OFF: u32 = 131072;
pub const PROCESS_CREATION_MITIGATION_POLICY_BOTTOM_UP_ASLR_RESERVED: u32 = 196608;
pub const PROCESS_CREATION_MITIGATION_POLICY_HIGH_ENTROPY_ASLR_MASK: u32 = 3145728;
pub const PROCESS_CREATION_MITIGATION_POLICY_HIGH_ENTROPY_ASLR_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_HIGH_ENTROPY_ASLR_ALWAYS_ON: u32 = 1048576;
pub const PROCESS_CREATION_MITIGATION_POLICY_HIGH_ENTROPY_ASLR_ALWAYS_OFF: u32 = 2097152;
pub const PROCESS_CREATION_MITIGATION_POLICY_HIGH_ENTROPY_ASLR_RESERVED: u32 = 3145728;
pub const PROCESS_CREATION_MITIGATION_POLICY_STRICT_HANDLE_CHECKS_MASK: u32 = 50331648;
pub const PROCESS_CREATION_MITIGATION_POLICY_STRICT_HANDLE_CHECKS_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_STRICT_HANDLE_CHECKS_ALWAYS_ON: u32 = 16777216;
pub const PROCESS_CREATION_MITIGATION_POLICY_STRICT_HANDLE_CHECKS_ALWAYS_OFF: u32 = 33554432;
pub const PROCESS_CREATION_MITIGATION_POLICY_STRICT_HANDLE_CHECKS_RESERVED: u32 = 50331648;
pub const PROCESS_CREATION_MITIGATION_POLICY_WIN32K_SYSTEM_CALL_DISABLE_MASK: u32 = 805306368;
pub const PROCESS_CREATION_MITIGATION_POLICY_WIN32K_SYSTEM_CALL_DISABLE_DEFER: u32 = 0;
pub const PROCESS_CREATION_MITIGATION_POLICY_WIN32K_SYSTEM_CALL_DISABLE_ALWAYS_ON: u32 = 268435456;
pub const PROCESS_CREATION_MITIGATION_POLICY_WIN32K_SYSTEM_CALL_DISABLE_ALWAYS_OFF: u32 = 536870912;
pub const PROCESS_CREATION_MITIGATION_POLICY_WIN32K_SYSTEM_CALL_DISABLE_RESERVED: u32 = 805306368;
pub const PROCESS_CREATION_CHILD_PROCESS_RESTRICTED: u32 = 1;
pub const PROCESS_CREATION_CHILD_PROCESS_OVERRIDE: u32 = 2;
pub const PROCESS_CREATION_CHILD_PROCESS_RESTRICTED_UNLESS_SECURE: u32 = 4;
pub const PROCESS_CREATION_ALL_APPLICATION_PACKAGES_OPT_OUT: u32 = 1;
pub const PROCESS_CREATION_DESKTOP_APP_BREAKAWAY_ENABLE_PROCESS_TREE: u32 = 1;
pub const PROCESS_CREATION_DESKTOP_APP_BREAKAWAY_DISABLE_PROCESS_TREE: u32 = 2;
pub const PROCESS_CREATION_DESKTOP_APP_BREAKAWAY_OVERRIDE: u32 = 4;
pub const ATOM_FLAG_GLOBAL: u32 = 2;
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_A_A: &[u8; 25] = b"GetSystemWow64DirectoryA\0";
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_A_W: &[u8; 25] = b"GetSystemWow64DirectoryA\0";
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_W_A: &[u8; 25] = b"GetSystemWow64DirectoryW\0";
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_W_W: &[u8; 25] = b"GetSystemWow64DirectoryW\0";
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_T_A: &[u8; 25] = b"GetSystemWow64DirectoryA\0";
pub const GET_SYSTEM_WOW64_DIRECTORY_NAME_T_W: &[u8; 25] = b"GetSystemWow64DirectoryA\0";
pub const BASE_SEARCH_PATH_ENABLE_SAFE_SEARCHMODE: u32 = 1;
pub const BASE_SEARCH_PATH_DISABLE_SAFE_SEARCHMODE: u32 = 65536;
pub const BASE_SEARCH_PATH_PERMANENT: u32 = 32768;
pub const BASE_SEARCH_PATH_INVALID_FLAGS: i32 = -98306;
pub const DDD_RAW_TARGET_PATH: u32 = 1;
pub const DDD_REMOVE_DEFINITION: u32 = 2;
pub const DDD_EXACT_MATCH_ON_REMOVE: u32 = 4;
pub const DDD_NO_BROADCAST_SYSTEM: u32 = 8;
pub const DDD_LUID_BROADCAST_DRIVE: u32 = 16;
pub const COPYFILE2_MESSAGE_COPY_OFFLOAD: u32 = 1;
pub const COPYFILE2_IO_CYCLE_SIZE_MIN: u32 = 4096;
pub const COPYFILE2_IO_CYCLE_SIZE_MAX: u32 = 1073741824;
pub const COPYFILE2_IO_RATE_MIN: u32 = 512;
pub const MOVEFILE_REPLACE_EXISTING: u32 = 1;
pub const MOVEFILE_COPY_ALLOWED: u32 = 2;
pub const MOVEFILE_DELAY_UNTIL_REBOOT: u32 = 4;
pub const MOVEFILE_WRITE_THROUGH: u32 = 8;
pub const MOVEFILE_CREATE_HARDLINK: u32 = 16;
pub const MOVEFILE_FAIL_IF_NOT_TRACKABLE: u32 = 32;
pub const EVENTLOG_FULL_INFO: u32 = 0;
pub const OPERATION_API_VERSION: u32 = 1;
pub const OPERATION_START_TRACE_CURRENT_THREAD: u32 = 1;
pub const OPERATION_END_DISCARD: u32 = 1;
pub const MAX_COMPUTERNAME_LENGTH: u32 = 15;
pub const LOGON32_LOGON_INTERACTIVE: u32 = 2;
pub const LOGON32_LOGON_NETWORK: u32 = 3;
pub const LOGON32_LOGON_BATCH: u32 = 4;
pub const LOGON32_LOGON_SERVICE: u32 = 5;
pub const LOGON32_LOGON_UNLOCK: u32 = 7;
pub const LOGON32_LOGON_NETWORK_CLEARTEXT: u32 = 8;
pub const LOGON32_LOGON_NEW_CREDENTIALS: u32 = 9;
pub const LOGON32_PROVIDER_DEFAULT: u32 = 0;
pub const LOGON32_PROVIDER_WINNT35: u32 = 1;
pub const LOGON32_PROVIDER_WINNT40: u32 = 2;
pub const LOGON32_PROVIDER_WINNT50: u32 = 3;
pub const LOGON32_PROVIDER_VIRTUAL: u32 = 4;
pub const LOGON_WITH_PROFILE: u32 = 1;
pub const LOGON_NETCREDENTIALS_ONLY: u32 = 2;
pub const LOGON_ZERO_PASSWORD_BUFFER: u32 = 2147483648;
pub const HW_PROFILE_GUIDLEN: u32 = 39;
pub const MAX_PROFILE_LEN: u32 = 80;
pub const DOCKINFO_UNDOCKED: u32 = 1;
pub const DOCKINFO_DOCKED: u32 = 2;
pub const DOCKINFO_USER_SUPPLIED: u32 = 4;
pub const DOCKINFO_USER_UNDOCKED: u32 = 5;
pub const DOCKINFO_USER_DOCKED: u32 = 6;
pub const FACILITY_NULL: u32 = 0;
pub const FACILITY_RPC: u32 = 1;
pub const FACILITY_DISPATCH: u32 = 2;
pub const FACILITY_STORAGE: u32 = 3;
pub const FACILITY_ITF: u32 = 4;
pub const FACILITY_WIN32: u32 = 7;
pub const FACILITY_WINDOWS: u32 = 8;
pub const FACILITY_SSPI: u32 = 9;
pub const FACILITY_SECURITY: u32 = 9;
pub const FACILITY_CONTROL: u32 = 10;
pub const FACILITY_CERT: u32 = 11;
pub const FACILITY_INTERNET: u32 = 12;
pub const FACILITY_MEDIASERVER: u32 = 13;
pub const FACILITY_MSMQ: u32 = 14;
pub const FACILITY_SETUPAPI: u32 = 15;
pub const FACILITY_SCARD: u32 = 16;
pub const FACILITY_COMPLUS: u32 = 17;
pub const FACILITY_AAF: u32 = 18;
pub const FACILITY_URT: u32 = 19;
pub const FACILITY_ACS: u32 = 20;
pub const FACILITY_DPLAY: u32 = 21;
pub const FACILITY_UMI: u32 = 22;
pub const FACILITY_SXS: u32 = 23;
pub const FACILITY_WINDOWS_CE: u32 = 24;
pub const FACILITY_HTTP: u32 = 25;
pub const FACILITY_USERMODE_COMMONLOG: u32 = 26;
pub const FACILITY_WER: u32 = 27;
pub const FACILITY_USERMODE_FILTER_MANAGER: u32 = 31;
pub const FACILITY_BACKGROUNDCOPY: u32 = 32;
pub const FACILITY_CONFIGURATION: u32 = 33;
pub const FACILITY_WIA: u32 = 33;
pub const FACILITY_STATE_MANAGEMENT: u32 = 34;
pub const FACILITY_METADIRECTORY: u32 = 35;
pub const FACILITY_WINDOWSUPDATE: u32 = 36;
pub const FACILITY_DIRECTORYSERVICE: u32 = 37;
pub const FACILITY_GRAPHICS: u32 = 38;
pub const FACILITY_SHELL: u32 = 39;
pub const FACILITY_NAP: u32 = 39;
pub const FACILITY_TPM_SERVICES: u32 = 40;
pub const FACILITY_TPM_SOFTWARE: u32 = 41;
pub const FACILITY_UI: u32 = 42;
pub const FACILITY_XAML: u32 = 43;
pub const FACILITY_ACTION_QUEUE: u32 = 44;
pub const FACILITY_PLA: u32 = 48;
pub const FACILITY_WINDOWS_SETUP: u32 = 48;
pub const FACILITY_FVE: u32 = 49;
pub const FACILITY_FWP: u32 = 50;
pub const FACILITY_WINRM: u32 = 51;
pub const FACILITY_NDIS: u32 = 52;
pub const FACILITY_USERMODE_HYPERVISOR: u32 = 53;
pub const FACILITY_CMI: u32 = 54;
pub const FACILITY_USERMODE_VIRTUALIZATION: u32 = 55;
pub const FACILITY_USERMODE_VOLMGR: u32 = 56;
pub const FACILITY_BCD: u32 = 57;
pub const FACILITY_USERMODE_VHD: u32 = 58;
pub const FACILITY_USERMODE_HNS: u32 = 59;
pub const FACILITY_SDIAG: u32 = 60;
pub const FACILITY_WEBSERVICES: u32 = 61;
pub const FACILITY_WINPE: u32 = 61;
pub const FACILITY_WPN: u32 = 62;
pub const FACILITY_WINDOWS_STORE: u32 = 63;
pub const FACILITY_INPUT: u32 = 64;
pub const FACILITY_QUIC: u32 = 65;
pub const FACILITY_EAP: u32 = 66;
pub const FACILITY_IORING: u32 = 70;
pub const FACILITY_WINDOWS_DEFENDER: u32 = 80;
pub const FACILITY_OPC: u32 = 81;
pub const FACILITY_XPS: u32 = 82;
pub const FACILITY_MBN: u32 = 84;
pub const FACILITY_POWERSHELL: u32 = 84;
pub const FACILITY_RAS: u32 = 83;
pub const FACILITY_P2P_INT: u32 = 98;
pub const FACILITY_P2P: u32 = 99;
pub const FACILITY_DAF: u32 = 100;
pub const FACILITY_BLUETOOTH_ATT: u32 = 101;
pub const FACILITY_AUDIO: u32 = 102;
pub const FACILITY_STATEREPOSITORY: u32 = 103;
pub const FACILITY_VISUALCPP: u32 = 109;
pub const FACILITY_SCRIPT: u32 = 112;
pub const FACILITY_PARSE: u32 = 113;
pub const FACILITY_BLB: u32 = 120;
pub const FACILITY_BLB_CLI: u32 = 121;
pub const FACILITY_WSBAPP: u32 = 122;
pub const FACILITY_BLBUI: u32 = 128;
pub const FACILITY_USN: u32 = 129;
pub const FACILITY_USERMODE_VOLSNAP: u32 = 130;
pub const FACILITY_TIERING: u32 = 131;
pub const FACILITY_WSB_ONLINE: u32 = 133;
pub const FACILITY_ONLINE_ID: u32 = 134;
pub const FACILITY_DEVICE_UPDATE_AGENT: u32 = 135;
pub const FACILITY_DRVSERVICING: u32 = 136;
pub const FACILITY_DLS: u32 = 153;
pub const FACILITY_DELIVERY_OPTIMIZATION: u32 = 208;
pub const FACILITY_USERMODE_SPACES: u32 = 231;
pub const FACILITY_USER_MODE_SECURITY_CORE: u32 = 232;
pub const FACILITY_USERMODE_LICENSING: u32 = 234;
pub const FACILITY_SOS: u32 = 160;
pub const FACILITY_OCP_UPDATE_AGENT: u32 = 173;
pub const FACILITY_DEBUGGERS: u32 = 176;
pub const FACILITY_SPP: u32 = 256;
pub const FACILITY_RESTORE: u32 = 256;
pub const FACILITY_DMSERVER: u32 = 256;
pub const FACILITY_DEPLOYMENT_SERVICES_SERVER: u32 = 257;
pub const FACILITY_DEPLOYMENT_SERVICES_IMAGING: u32 = 258;
pub const FACILITY_DEPLOYMENT_SERVICES_MANAGEMENT: u32 = 259;
pub const FACILITY_DEPLOYMENT_SERVICES_UTIL: u32 = 260;
pub const FACILITY_DEPLOYMENT_SERVICES_BINLSVC: u32 = 261;
pub const FACILITY_DEPLOYMENT_SERVICES_PXE: u32 = 263;
pub const FACILITY_DEPLOYMENT_SERVICES_TFTP: u32 = 264;
pub const FACILITY_DEPLOYMENT_SERVICES_TRANSPORT_MANAGEMENT: u32 = 272;
pub const FACILITY_DEPLOYMENT_SERVICES_DRIVER_PROVISIONING: u32 = 278;
pub const FACILITY_DEPLOYMENT_SERVICES_MULTICAST_SERVER: u32 = 289;
pub const FACILITY_DEPLOYMENT_SERVICES_MULTICAST_CLIENT: u32 = 290;
pub const FACILITY_DEPLOYMENT_SERVICES_CONTENT_PROVIDER: u32 = 293;
pub const FACILITY_HSP_SERVICES: u32 = 296;
pub const FACILITY_HSP_SOFTWARE: u32 = 297;
pub const FACILITY_LINGUISTIC_SERVICES: u32 = 305;
pub const FACILITY_AUDIOSTREAMING: u32 = 1094;
pub const FACILITY_TTD: u32 = 1490;
pub const FACILITY_ACCELERATOR: u32 = 1536;
pub const FACILITY_WMAAECMA: u32 = 1996;
pub const FACILITY_DIRECTMUSIC: u32 = 2168;
pub const FACILITY_DIRECT3D10: u32 = 2169;
pub const FACILITY_DXGI: u32 = 2170;
pub const FACILITY_DXGI_DDI: u32 = 2171;
pub const FACILITY_DIRECT3D11: u32 = 2172;
pub const FACILITY_DIRECT3D11_DEBUG: u32 = 2173;
pub const FACILITY_DIRECT3D12: u32 = 2174;
pub const FACILITY_DIRECT3D12_DEBUG: u32 = 2175;
pub const FACILITY_DXCORE: u32 = 2176;
pub const FACILITY_PRESENTATION: u32 = 2177;
pub const FACILITY_LEAP: u32 = 2184;
pub const FACILITY_AUDCLNT: u32 = 2185;
pub const FACILITY_WINCODEC_DWRITE_DWM: u32 = 2200;
pub const FACILITY_WINML: u32 = 2192;
pub const FACILITY_DIRECT2D: u32 = 2201;
pub const FACILITY_DEFRAG: u32 = 2304;
pub const FACILITY_USERMODE_SDBUS: u32 = 2305;
pub const FACILITY_JSCRIPT: u32 = 2306;
pub const FACILITY_PIDGENX: u32 = 2561;
pub const FACILITY_EAS: u32 = 85;
pub const FACILITY_WEB: u32 = 885;
pub const FACILITY_WEB_SOCKET: u32 = 886;
pub const FACILITY_MOBILE: u32 = 1793;
pub const FACILITY_SQLITE: u32 = 1967;
pub const FACILITY_SERVICE_FABRIC: u32 = 1968;
pub const FACILITY_UTC: u32 = 1989;
pub const FACILITY_WEP: u32 = 2049;
pub const FACILITY_SYNCENGINE: u32 = 2050;
pub const FACILITY_XBOX: u32 = 2339;
pub const FACILITY_GAME: u32 = 2340;
pub const FACILITY_PIX: u32 = 2748;
pub const ERROR_SUCCESS: u32 = 0;
pub const NO_ERROR: u32 = 0;
pub const ERROR_INVALID_FUNCTION: u32 = 1;
pub const ERROR_FILE_NOT_FOUND: u32 = 2;
pub const ERROR_PATH_NOT_FOUND: u32 = 3;
pub const ERROR_TOO_MANY_OPEN_FILES: u32 = 4;
pub const ERROR_ACCESS_DENIED: u32 = 5;
pub const ERROR_INVALID_HANDLE: u32 = 6;
pub const ERROR_ARENA_TRASHED: u32 = 7;
pub const ERROR_NOT_ENOUGH_MEMORY: u32 = 8;
pub const ERROR_INVALID_BLOCK: u32 = 9;
pub const ERROR_BAD_ENVIRONMENT: u32 = 10;
pub const ERROR_BAD_FORMAT: u32 = 11;
pub const ERROR_INVALID_ACCESS: u32 = 12;
pub const ERROR_INVALID_DATA: u32 = 13;
pub const ERROR_OUTOFMEMORY: u32 = 14;
pub const ERROR_INVALID_DRIVE: u32 = 15;
pub const ERROR_CURRENT_DIRECTORY: u32 = 16;
pub const ERROR_NOT_SAME_DEVICE: u32 = 17;
pub const ERROR_NO_MORE_FILES: u32 = 18;
pub const ERROR_WRITE_PROTECT: u32 = 19;
pub const ERROR_BAD_UNIT: u32 = 20;
pub const ERROR_NOT_READY: u32 = 21;
pub const ERROR_BAD_COMMAND: u32 = 22;
pub const ERROR_CRC: u32 = 23;
pub const ERROR_BAD_LENGTH: u32 = 24;
pub const ERROR_SEEK: u32 = 25;
pub const ERROR_NOT_DOS_DISK: u32 = 26;
pub const ERROR_SECTOR_NOT_FOUND: u32 = 27;
pub const ERROR_OUT_OF_PAPER: u32 = 28;
pub const ERROR_WRITE_FAULT: u32 = 29;
pub const ERROR_READ_FAULT: u32 = 30;
pub const ERROR_GEN_FAILURE: u32 = 31;
pub const ERROR_SHARING_VIOLATION: u32 = 32;
pub const ERROR_LOCK_VIOLATION: u32 = 33;
pub const ERROR_WRONG_DISK: u32 = 34;
pub const ERROR_SHARING_BUFFER_EXCEEDED: u32 = 36;
pub const ERROR_HANDLE_EOF: u32 = 38;
pub const ERROR_HANDLE_DISK_FULL: u32 = 39;
pub const ERROR_NOT_SUPPORTED: u32 = 50;
pub const ERROR_REM_NOT_LIST: u32 = 51;
pub const ERROR_DUP_NAME: u32 = 52;
pub const ERROR_BAD_NETPATH: u32 = 53;
pub const ERROR_NETWORK_BUSY: u32 = 54;
pub const ERROR_DEV_NOT_EXIST: u32 = 55;
pub const ERROR_TOO_MANY_CMDS: u32 = 56;
pub const ERROR_ADAP_HDW_ERR: u32 = 57;
pub const ERROR_BAD_NET_RESP: u32 = 58;
pub const ERROR_UNEXP_NET_ERR: u32 = 59;
pub const ERROR_BAD_REM_ADAP: u32 = 60;
pub const ERROR_PRINTQ_FULL: u32 = 61;
pub const ERROR_NO_SPOOL_SPACE: u32 = 62;
pub const ERROR_PRINT_CANCELLED: u32 = 63;
pub const ERROR_NETNAME_DELETED: u32 = 64;
pub const ERROR_NETWORK_ACCESS_DENIED: u32 = 65;
pub const ERROR_BAD_DEV_TYPE: u32 = 66;
pub const ERROR_BAD_NET_NAME: u32 = 67;
pub const ERROR_TOO_MANY_NAMES: u32 = 68;
pub const ERROR_TOO_MANY_SESS: u32 = 69;
pub const ERROR_SHARING_PAUSED: u32 = 70;
pub const ERROR_REQ_NOT_ACCEP: u32 = 71;
pub const ERROR_REDIR_PAUSED: u32 = 72;
pub const ERROR_FILE_EXISTS: u32 = 80;
pub const ERROR_CANNOT_MAKE: u32 = 82;
pub const ERROR_FAIL_I24: u32 = 83;
pub const ERROR_OUT_OF_STRUCTURES: u32 = 84;
pub const ERROR_ALREADY_ASSIGNED: u32 = 85;
pub const ERROR_INVALID_PASSWORD: u32 = 86;
pub const ERROR_INVALID_PARAMETER: u32 = 87;
pub const ERROR_NET_WRITE_FAULT: u32 = 88;
pub const ERROR_NO_PROC_SLOTS: u32 = 89;
pub const ERROR_TOO_MANY_SEMAPHORES: u32 = 100;
pub const ERROR_EXCL_SEM_ALREADY_OWNED: u32 = 101;
pub const ERROR_SEM_IS_SET: u32 = 102;
pub const ERROR_TOO_MANY_SEM_REQUESTS: u32 = 103;
pub const ERROR_INVALID_AT_INTERRUPT_TIME: u32 = 104;
pub const ERROR_SEM_OWNER_DIED: u32 = 105;
pub const ERROR_SEM_USER_LIMIT: u32 = 106;
pub const ERROR_DISK_CHANGE: u32 = 107;
pub const ERROR_DRIVE_LOCKED: u32 = 108;
pub const ERROR_BROKEN_PIPE: u32 = 109;
pub const ERROR_OPEN_FAILED: u32 = 110;
pub const ERROR_BUFFER_OVERFLOW: u32 = 111;
pub const ERROR_DISK_FULL: u32 = 112;
pub const ERROR_NO_MORE_SEARCH_HANDLES: u32 = 113;
pub const ERROR_INVALID_TARGET_HANDLE: u32 = 114;
pub const ERROR_INVALID_CATEGORY: u32 = 117;
pub const ERROR_INVALID_VERIFY_SWITCH: u32 = 118;
pub const ERROR_BAD_DRIVER_LEVEL: u32 = 119;
pub const ERROR_CALL_NOT_IMPLEMENTED: u32 = 120;
pub const ERROR_SEM_TIMEOUT: u32 = 121;
pub const ERROR_INSUFFICIENT_BUFFER: u32 = 122;
pub const ERROR_INVALID_NAME: u32 = 123;
pub const ERROR_INVALID_LEVEL: u32 = 124;
pub const ERROR_NO_VOLUME_LABEL: u32 = 125;
pub const ERROR_MOD_NOT_FOUND: u32 = 126;
pub const ERROR_PROC_NOT_FOUND: u32 = 127;
pub const ERROR_WAIT_NO_CHILDREN: u32 = 128;
pub const ERROR_CHILD_NOT_COMPLETE: u32 = 129;
pub const ERROR_DIRECT_ACCESS_HANDLE: u32 = 130;
pub const ERROR_NEGATIVE_SEEK: u32 = 131;
pub const ERROR_SEEK_ON_DEVICE: u32 = 132;
pub const ERROR_IS_JOIN_TARGET: u32 = 133;
pub const ERROR_IS_JOINED: u32 = 134;
pub const ERROR_IS_SUBSTED: u32 = 135;
pub const ERROR_NOT_JOINED: u32 = 136;
pub const ERROR_NOT_SUBSTED: u32 = 137;
pub const ERROR_JOIN_TO_JOIN: u32 = 138;
pub const ERROR_SUBST_TO_SUBST: u32 = 139;
pub const ERROR_JOIN_TO_SUBST: u32 = 140;
pub const ERROR_SUBST_TO_JOIN: u32 = 141;
pub const ERROR_BUSY_DRIVE: u32 = 142;
pub const ERROR_SAME_DRIVE: u32 = 143;
pub const ERROR_DIR_NOT_ROOT: u32 = 144;
pub const ERROR_DIR_NOT_EMPTY: u32 = 145;
pub const ERROR_IS_SUBST_PATH: u32 = 146;
pub const ERROR_IS_JOIN_PATH: u32 = 147;
pub const ERROR_PATH_BUSY: u32 = 148;
pub const ERROR_IS_SUBST_TARGET: u32 = 149;
pub const ERROR_SYSTEM_TRACE: u32 = 150;
pub const ERROR_INVALID_EVENT_COUNT: u32 = 151;
pub const ERROR_TOO_MANY_MUXWAITERS: u32 = 152;
pub const ERROR_INVALID_LIST_FORMAT: u32 = 153;
pub const ERROR_LABEL_TOO_LONG: u32 = 154;
pub const ERROR_TOO_MANY_TCBS: u32 = 155;
pub const ERROR_SIGNAL_REFUSED: u32 = 156;
pub const ERROR_DISCARDED: u32 = 157;
pub const ERROR_NOT_LOCKED: u32 = 158;
pub const ERROR_BAD_THREADID_ADDR: u32 = 159;
pub const ERROR_BAD_ARGUMENTS: u32 = 160;
pub const ERROR_BAD_PATHNAME: u32 = 161;
pub const ERROR_SIGNAL_PENDING: u32 = 162;
pub const ERROR_MAX_THRDS_REACHED: u32 = 164;
pub const ERROR_LOCK_FAILED: u32 = 167;
pub const ERROR_BUSY: u32 = 170;
pub const ERROR_DEVICE_SUPPORT_IN_PROGRESS: u32 = 171;
pub const ERROR_CANCEL_VIOLATION: u32 = 173;
pub const ERROR_ATOMIC_LOCKS_NOT_SUPPORTED: u32 = 174;
pub const ERROR_INVALID_SEGMENT_NUMBER: u32 = 180;
pub const ERROR_INVALID_ORDINAL: u32 = 182;
pub const ERROR_ALREADY_EXISTS: u32 = 183;
pub const ERROR_INVALID_FLAG_NUMBER: u32 = 186;
pub const ERROR_SEM_NOT_FOUND: u32 = 187;
pub const ERROR_INVALID_STARTING_CODESEG: u32 = 188;
pub const ERROR_INVALID_STACKSEG: u32 = 189;
pub const ERROR_INVALID_MODULETYPE: u32 = 190;
pub const ERROR_INVALID_EXE_SIGNATURE: u32 = 191;
pub const ERROR_EXE_MARKED_INVALID: u32 = 192;
pub const ERROR_BAD_EXE_FORMAT: u32 = 193;
pub const ERROR_ITERATED_DATA_EXCEEDS_64k: u32 = 194;
pub const ERROR_INVALID_MINALLOCSIZE: u32 = 195;
pub const ERROR_DYNLINK_FROM_INVALID_RING: u32 = 196;
pub const ERROR_IOPL_NOT_ENABLED: u32 = 197;
pub const ERROR_INVALID_SEGDPL: u32 = 198;
pub const ERROR_AUTODATASEG_EXCEEDS_64k: u32 = 199;
pub const ERROR_RING2SEG_MUST_BE_MOVABLE: u32 = 200;
pub const ERROR_RELOC_CHAIN_XEEDS_SEGLIM: u32 = 201;
pub const ERROR_INFLOOP_IN_RELOC_CHAIN: u32 = 202;
pub const ERROR_ENVVAR_NOT_FOUND: u32 = 203;
pub const ERROR_NO_SIGNAL_SENT: u32 = 205;
pub const ERROR_FILENAME_EXCED_RANGE: u32 = 206;
pub const ERROR_RING2_STACK_IN_USE: u32 = 207;
pub const ERROR_META_EXPANSION_TOO_LONG: u32 = 208;
pub const ERROR_INVALID_SIGNAL_NUMBER: u32 = 209;
pub const ERROR_THREAD_1_INACTIVE: u32 = 210;
pub const ERROR_LOCKED: u32 = 212;
pub const ERROR_TOO_MANY_MODULES: u32 = 214;
pub const ERROR_NESTING_NOT_ALLOWED: u32 = 215;
pub const ERROR_EXE_MACHINE_TYPE_MISMATCH: u32 = 216;
pub const ERROR_EXE_CANNOT_MODIFY_SIGNED_BINARY: u32 = 217;
pub const ERROR_EXE_CANNOT_MODIFY_STRONG_SIGNED_BINARY: u32 = 218;
pub const ERROR_FILE_CHECKED_OUT: u32 = 220;
pub const ERROR_CHECKOUT_REQUIRED: u32 = 221;
pub const ERROR_BAD_FILE_TYPE: u32 = 222;
pub const ERROR_FILE_TOO_LARGE: u32 = 223;
pub const ERROR_FORMS_AUTH_REQUIRED: u32 = 224;
pub const ERROR_VIRUS_INFECTED: u32 = 225;
pub const ERROR_VIRUS_DELETED: u32 = 226;
pub const ERROR_PIPE_LOCAL: u32 = 229;
pub const ERROR_BAD_PIPE: u32 = 230;
pub const ERROR_PIPE_BUSY: u32 = 231;
pub const ERROR_NO_DATA: u32 = 232;
pub const ERROR_PIPE_NOT_CONNECTED: u32 = 233;
pub const ERROR_MORE_DATA: u32 = 234;
pub const ERROR_NO_WORK_DONE: u32 = 235;
pub const ERROR_VC_DISCONNECTED: u32 = 240;
pub const ERROR_INVALID_EA_NAME: u32 = 254;
pub const ERROR_EA_LIST_INCONSISTENT: u32 = 255;
pub const WAIT_TIMEOUT: u32 = 258;
pub const ERROR_NO_MORE_ITEMS: u32 = 259;
pub const ERROR_CANNOT_COPY: u32 = 266;
pub const ERROR_DIRECTORY: u32 = 267;
pub const ERROR_EAS_DIDNT_FIT: u32 = 275;
pub const ERROR_EA_FILE_CORRUPT: u32 = 276;
pub const ERROR_EA_TABLE_FULL: u32 = 277;
pub const ERROR_INVALID_EA_HANDLE: u32 = 278;
pub const ERROR_EAS_NOT_SUPPORTED: u32 = 282;
pub const ERROR_NOT_OWNER: u32 = 288;
pub const ERROR_TOO_MANY_POSTS: u32 = 298;
pub const ERROR_PARTIAL_COPY: u32 = 299;
pub const ERROR_OPLOCK_NOT_GRANTED: u32 = 300;
pub const ERROR_INVALID_OPLOCK_PROTOCOL: u32 = 301;
pub const ERROR_DISK_TOO_FRAGMENTED: u32 = 302;
pub const ERROR_DELETE_PENDING: u32 = 303;
pub const ERROR_INCOMPATIBLE_WITH_GLOBAL_SHORT_NAME_REGISTRY_SETTING: u32 = 304;
pub const ERROR_SHORT_NAMES_NOT_ENABLED_ON_VOLUME: u32 = 305;
pub const ERROR_SECURITY_STREAM_IS_INCONSISTENT: u32 = 306;
pub const ERROR_INVALID_LOCK_RANGE: u32 = 307;
pub const ERROR_IMAGE_SUBSYSTEM_NOT_PRESENT: u32 = 308;
pub const ERROR_NOTIFICATION_GUID_ALREADY_DEFINED: u32 = 309;
pub const ERROR_INVALID_EXCEPTION_HANDLER: u32 = 310;
pub const ERROR_DUPLICATE_PRIVILEGES: u32 = 311;
pub const ERROR_NO_RANGES_PROCESSED: u32 = 312;
pub const ERROR_NOT_ALLOWED_ON_SYSTEM_FILE: u32 = 313;
pub const ERROR_DISK_RESOURCES_EXHAUSTED: u32 = 314;
pub const ERROR_INVALID_TOKEN: u32 = 315;
pub const ERROR_DEVICE_FEATURE_NOT_SUPPORTED: u32 = 316;
pub const ERROR_MR_MID_NOT_FOUND: u32 = 317;
pub const ERROR_SCOPE_NOT_FOUND: u32 = 318;
pub const ERROR_UNDEFINED_SCOPE: u32 = 319;
pub const ERROR_INVALID_CAP: u32 = 320;
pub const ERROR_DEVICE_UNREACHABLE: u32 = 321;
pub const ERROR_DEVICE_NO_RESOURCES: u32 = 322;
pub const ERROR_DATA_CHECKSUM_ERROR: u32 = 323;
pub const ERROR_INTERMIXED_KERNEL_EA_OPERATION: u32 = 324;
pub const ERROR_FILE_LEVEL_TRIM_NOT_SUPPORTED: u32 = 326;
pub const ERROR_OFFSET_ALIGNMENT_VIOLATION: u32 = 327;
pub const ERROR_INVALID_FIELD_IN_PARAMETER_LIST: u32 = 328;
pub const ERROR_OPERATION_IN_PROGRESS: u32 = 329;
pub const ERROR_BAD_DEVICE_PATH: u32 = 330;
pub const ERROR_TOO_MANY_DESCRIPTORS: u32 = 331;
pub const ERROR_SCRUB_DATA_DISABLED: u32 = 332;
pub const ERROR_NOT_REDUNDANT_STORAGE: u32 = 333;
pub const ERROR_RESIDENT_FILE_NOT_SUPPORTED: u32 = 334;
pub const ERROR_COMPRESSED_FILE_NOT_SUPPORTED: u32 = 335;
pub const ERROR_DIRECTORY_NOT_SUPPORTED: u32 = 336;
pub const ERROR_NOT_READ_FROM_COPY: u32 = 337;
pub const ERROR_FT_WRITE_FAILURE: u32 = 338;
pub const ERROR_FT_DI_SCAN_REQUIRED: u32 = 339;
pub const ERROR_INVALID_KERNEL_INFO_VERSION: u32 = 340;
pub const ERROR_INVALID_PEP_INFO_VERSION: u32 = 341;
pub const ERROR_OBJECT_NOT_EXTERNALLY_BACKED: u32 = 342;
pub const ERROR_EXTERNAL_BACKING_PROVIDER_UNKNOWN: u32 = 343;
pub const ERROR_COMPRESSION_NOT_BENEFICIAL: u32 = 344;
pub const ERROR_STORAGE_TOPOLOGY_ID_MISMATCH: u32 = 345;
pub const ERROR_BLOCKED_BY_PARENTAL_CONTROLS: u32 = 346;
pub const ERROR_BLOCK_TOO_MANY_REFERENCES: u32 = 347;
pub const ERROR_MARKED_TO_DISALLOW_WRITES: u32 = 348;
pub const ERROR_ENCLAVE_FAILURE: u32 = 349;
pub const ERROR_FAIL_NOACTION_REBOOT: u32 = 350;
pub const ERROR_FAIL_SHUTDOWN: u32 = 351;
pub const ERROR_FAIL_RESTART: u32 = 352;
pub const ERROR_MAX_SESSIONS_REACHED: u32 = 353;
pub const ERROR_NETWORK_ACCESS_DENIED_EDP: u32 = 354;
pub const ERROR_DEVICE_HINT_NAME_BUFFER_TOO_SMALL: u32 = 355;
pub const ERROR_EDP_POLICY_DENIES_OPERATION: u32 = 356;
pub const ERROR_EDP_DPL_POLICY_CANT_BE_SATISFIED: u32 = 357;
pub const ERROR_CLOUD_FILE_SYNC_ROOT_METADATA_CORRUPT: u32 = 358;
pub const ERROR_DEVICE_IN_MAINTENANCE: u32 = 359;
pub const ERROR_NOT_SUPPORTED_ON_DAX: u32 = 360;
pub const ERROR_DAX_MAPPING_EXISTS: u32 = 361;
pub const ERROR_CLOUD_FILE_PROVIDER_NOT_RUNNING: u32 = 362;
pub const ERROR_CLOUD_FILE_METADATA_CORRUPT: u32 = 363;
pub const ERROR_CLOUD_FILE_METADATA_TOO_LARGE: u32 = 364;
pub const ERROR_CLOUD_FILE_PROPERTY_BLOB_TOO_LARGE: u32 = 365;
pub const ERROR_CLOUD_FILE_PROPERTY_BLOB_CHECKSUM_MISMATCH: u32 = 366;
pub const ERROR_CHILD_PROCESS_BLOCKED: u32 = 367;
pub const ERROR_STORAGE_LOST_DATA_PERSISTENCE: u32 = 368;
pub const ERROR_FILE_SYSTEM_VIRTUALIZATION_UNAVAILABLE: u32 = 369;
pub const ERROR_FILE_SYSTEM_VIRTUALIZATION_METADATA_CORRUPT: u32 = 370;
pub const ERROR_FILE_SYSTEM_VIRTUALIZATION_BUSY: u32 = 371;
pub const ERROR_FILE_SYSTEM_VIRTUALIZATION_PROVIDER_UNKNOWN: u32 = 372;
pub const ERROR_GDI_HANDLE_LEAK: u32 = 373;
pub const ERROR_CLOUD_FILE_TOO_MANY_PROPERTY_BLOBS: u32 = 374;
pub const ERROR_CLOUD_FILE_PROPERTY_VERSION_NOT_SUPPORTED: u32 = 375;
pub const ERROR_NOT_A_CLOUD_FILE: u32 = 376;
pub const ERROR_CLOUD_FILE_NOT_IN_SYNC: u32 = 377;
pub const ERROR_CLOUD_FILE_ALREADY_CONNECTED: u32 = 378;
pub const ERROR_CLOUD_FILE_NOT_SUPPORTED: u32 = 379;
pub const ERROR_CLOUD_FILE_INVALID_REQUEST: u32 = 380;
pub const ERROR_CLOUD_FILE_READ_ONLY_VOLUME: u32 = 381;
pub const ERROR_CLOUD_FILE_CONNECTED_PROVIDER_ONLY: u32 = 382;
pub const ERROR_CLOUD_FILE_VALIDATION_FAILED: u32 = 383;
pub const ERROR_SMB1_NOT_AVAILABLE: u32 = 384;
pub const ERROR_FILE_SYSTEM_VIRTUALIZATION_INVALID_OPERATION: u32 = 385;
pub const ERROR_CLOUD_FILE_AUTHENTICATION_FAILED: u32 = 386;
pub const ERROR_CLOUD_FILE_INSUFFICIENT_RESOURCES: u32 = 387;
pub const ERROR_CLOUD_FILE_NETWORK_UNAVAILABLE: u32 = 388;
pub const ERROR_CLOUD_FILE_UNSUCCESSFUL: u32 = 389;
pub const ERROR_CLOUD_FILE_NOT_UNDER_SYNC_ROOT: u32 = 390;
pub const ERROR_CLOUD_FILE_IN_USE: u32 = 391;
pub const ERROR_CLOUD_FILE_PINNED: u32 = 392;
pub const ERROR_CLOUD_FILE_REQUEST_ABORTED: u32 = 393;
pub const ERROR_CLOUD_FILE_PROPERTY_CORRUPT: u32 = 394;
pub const ERROR_CLOUD_FILE_ACCESS_DENIED: u32 = 395;
pub const ERROR_CLOUD_FILE_INCOMPATIBLE_HARDLINKS: u32 = 396;
pub const ERROR_CLOUD_FILE_PROPERTY_LOCK_CONFLICT: u32 = 397;
pub const ERROR_CLOUD_FILE_REQUEST_CANCELED: u32 = 398;
pub const ERROR_EXTERNAL_SYSKEY_NOT_SUPPORTED: u32 = 399;
pub const ERROR_THREAD_MODE_ALREADY_BACKGROUND: u32 = 400;
pub const ERROR_THREAD_MODE_NOT_BACKGROUND: u32 = 401;
pub const ERROR_PROCESS_MODE_ALREADY_BACKGROUND: u32 = 402;
pub const ERROR_PROCESS_MODE_NOT_BACKGROUND: u32 = 403;
pub const ERROR_CLOUD_FILE_PROVIDER_TERMINATED: u32 = 404;
pub const ERROR_NOT_A_CLOUD_SYNC_ROOT: u32 = 405;
pub const ERROR_FILE_PROTECTED_UNDER_DPL: u32 = 406;
pub const ERROR_VOLUME_NOT_CLUSTER_ALIGNED: u32 = 407;
pub const ERROR_NO_PHYSICALLY_ALIGNED_FREE_SPACE_FOUND: u32 = 408;
pub const ERROR_APPX_FILE_NOT_ENCRYPTED: u32 = 409;
pub const ERROR_RWRAW_ENCRYPTED_FILE_NOT_ENCRYPTED: u32 = 410;
pub const ERROR_RWRAW_ENCRYPTED_INVALID_EDATAINFO_FILEOFFSET: u32 = 411;
pub const ERROR_RWRAW_ENCRYPTED_INVALID_EDATAINFO_FILERANGE: u32 = 412;
pub const ERROR_RWRAW_ENCRYPTED_INVALID_EDATAINFO_PARAMETER: u32 = 413;
pub const ERROR_LINUX_SUBSYSTEM_NOT_PRESENT: u32 = 414;
pub const ERROR_FT_READ_FAILURE: u32 = 415;
pub const ERROR_STORAGE_RESERVE_ID_INVALID: u32 = 416;
pub const ERROR_STORAGE_RESERVE_DOES_NOT_EXIST: u32 = 417;
pub const ERROR_STORAGE_RESERVE_ALREADY_EXISTS: u32 = 418;
pub const ERROR_STORAGE_RESERVE_NOT_EMPTY: u32 = 419;
pub const ERROR_NOT_A_DAX_VOLUME: u32 = 420;
pub const ERROR_NOT_DAX_MAPPABLE: u32 = 421;
pub const ERROR_TIME_SENSITIVE_THREAD: u32 = 422;
pub const ERROR_DPL_NOT_SUPPORTED_FOR_USER: u32 = 423;
pub const ERROR_CASE_DIFFERING_NAMES_IN_DIR: u32 = 424;
pub const ERROR_FILE_NOT_SUPPORTED: u32 = 425;
pub const ERROR_CLOUD_FILE_REQUEST_TIMEOUT: u32 = 426;
pub const ERROR_NO_TASK_QUEUE: u32 = 427;
pub const ERROR_SRC_SRV_DLL_LOAD_FAILED: u32 = 428;
pub const ERROR_NOT_SUPPORTED_WITH_BTT: u32 = 429;
pub const ERROR_ENCRYPTION_DISABLED: u32 = 430;
pub const ERROR_ENCRYPTING_METADATA_DISALLOWED: u32 = 431;
pub const ERROR_CANT_CLEAR_ENCRYPTION_FLAG: u32 = 432;
pub const ERROR_NO_SUCH_DEVICE: u32 = 433;
pub const ERROR_CLOUD_FILE_DEHYDRATION_DISALLOWED: u32 = 434;
pub const ERROR_FILE_SNAP_IN_PROGRESS: u32 = 435;
pub const ERROR_FILE_SNAP_USER_SECTION_NOT_SUPPORTED: u32 = 436;
pub const ERROR_FILE_SNAP_MODIFY_NOT_SUPPORTED: u32 = 437;
pub const ERROR_FILE_SNAP_IO_NOT_COORDINATED: u32 = 438;
pub const ERROR_FILE_SNAP_UNEXPECTED_ERROR: u32 = 439;
pub const ERROR_FILE_SNAP_INVALID_PARAMETER: u32 = 440;
pub const ERROR_UNSATISFIED_DEPENDENCIES: u32 = 441;
pub const ERROR_CASE_SENSITIVE_PATH: u32 = 442;
pub const ERROR_UNEXPECTED_NTCACHEMANAGER_ERROR: u32 = 443;
pub const ERROR_LINUX_SUBSYSTEM_UPDATE_REQUIRED: u32 = 444;
pub const ERROR_DLP_POLICY_WARNS_AGAINST_OPERATION: u32 = 445;
pub const ERROR_DLP_POLICY_DENIES_OPERATION: u32 = 446;
pub const ERROR_SECURITY_DENIES_OPERATION: u32 = 447;
pub const ERROR_UNTRUSTED_MOUNT_POINT: u32 = 448;
pub const ERROR_DLP_POLICY_SILENTLY_FAIL: u32 = 449;
pub const ERROR_CAPAUTHZ_NOT_DEVUNLOCKED: u32 = 450;
pub const ERROR_CAPAUTHZ_CHANGE_TYPE: u32 = 451;
pub const ERROR_CAPAUTHZ_NOT_PROVISIONED: u32 = 452;
pub const ERROR_CAPAUTHZ_NOT_AUTHORIZED: u32 = 453;
pub const ERROR_CAPAUTHZ_NO_POLICY: u32 = 454;
pub const ERROR_CAPAUTHZ_DB_CORRUPTED: u32 = 455;
pub const ERROR_CAPAUTHZ_SCCD_INVALID_CATALOG: u32 = 456;
pub const ERROR_CAPAUTHZ_SCCD_NO_AUTH_ENTITY: u32 = 457;
pub const ERROR_CAPAUTHZ_SCCD_PARSE_ERROR: u32 = 458;
pub const ERROR_CAPAUTHZ_SCCD_DEV_MODE_REQUIRED: u32 = 459;
pub const ERROR_CAPAUTHZ_SCCD_NO_CAPABILITY_MATCH: u32 = 460;
pub const ERROR_CIMFS_IMAGE_CORRUPT: u32 = 470;
pub const ERROR_CIMFS_IMAGE_VERSION_NOT_SUPPORTED: u32 = 471;
pub const ERROR_STORAGE_STACK_ACCESS_DENIED: u32 = 472;
pub const ERROR_INSUFFICIENT_VIRTUAL_ADDR_RESOURCES: u32 = 473;
pub const ERROR_INDEX_OUT_OF_BOUNDS: u32 = 474;
pub const ERROR_CLOUD_FILE_US_MESSAGE_TIMEOUT: u32 = 475;
pub const ERROR_PNP_QUERY_REMOVE_DEVICE_TIMEOUT: u32 = 480;
pub const ERROR_PNP_QUERY_REMOVE_RELATED_DEVICE_TIMEOUT: u32 = 481;
pub const ERROR_PNP_QUERY_REMOVE_UNRELATED_DEVICE_TIMEOUT: u32 = 482;
pub const ERROR_DEVICE_HARDWARE_ERROR: u32 = 483;
pub const ERROR_INVALID_ADDRESS: u32 = 487;
pub const ERROR_HAS_SYSTEM_CRITICAL_FILES: u32 = 488;
pub const ERROR_ENCRYPTED_FILE_NOT_SUPPORTED: u32 = 489;
pub const ERROR_SPARSE_FILE_NOT_SUPPORTED: u32 = 490;
pub const ERROR_PAGEFILE_NOT_SUPPORTED: u32 = 491;
pub const ERROR_VOLUME_NOT_SUPPORTED: u32 = 492;
pub const ERROR_NOT_SUPPORTED_WITH_BYPASSIO: u32 = 493;
pub const ERROR_NO_BYPASSIO_DRIVER_SUPPORT: u32 = 494;
pub const ERROR_NOT_SUPPORTED_WITH_ENCRYPTION: u32 = 495;
pub const ERROR_NOT_SUPPORTED_WITH_COMPRESSION: u32 = 496;
pub const ERROR_NOT_SUPPORTED_WITH_REPLICATION: u32 = 497;
pub const ERROR_NOT_SUPPORTED_WITH_DEDUPLICATION: u32 = 498;
pub const ERROR_NOT_SUPPORTED_WITH_AUDITING: u32 = 499;
pub const ERROR_USER_PROFILE_LOAD: u32 = 500;
pub const ERROR_SESSION_KEY_TOO_SHORT: u32 = 501;
pub const ERROR_ACCESS_DENIED_APPDATA: u32 = 502;
pub const ERROR_NOT_SUPPORTED_WITH_MONITORING: u32 = 503;
pub const ERROR_NOT_SUPPORTED_WITH_SNAPSHOT: u32 = 504;
pub const ERROR_NOT_SUPPORTED_WITH_VIRTUALIZATION: u32 = 505;
pub const ERROR_BYPASSIO_FLT_NOT_SUPPORTED: u32 = 506;
pub const ERROR_DEVICE_RESET_REQUIRED: u32 = 507;
pub const ERROR_VOLUME_WRITE_ACCESS_DENIED: u32 = 508;
pub const ERROR_NOT_SUPPORTED_WITH_CACHED_HANDLE: u32 = 509;
pub const ERROR_FS_METADATA_INCONSISTENT: u32 = 510;
pub const ERROR_ARITHMETIC_OVERFLOW: u32 = 534;
pub const ERROR_PIPE_CONNECTED: u32 = 535;
pub const ERROR_PIPE_LISTENING: u32 = 536;
pub const ERROR_VERIFIER_STOP: u32 = 537;
pub const ERROR_ABIOS_ERROR: u32 = 538;
pub const ERROR_WX86_WARNING: u32 = 539;
pub const ERROR_WX86_ERROR: u32 = 540;
pub const ERROR_TIMER_NOT_CANCELED: u32 = 541;
pub const ERROR_UNWIND: u32 = 542;
pub const ERROR_BAD_STACK: u32 = 543;
pub const ERROR_INVALID_UNWIND_TARGET: u32 = 544;
pub const ERROR_INVALID_PORT_ATTRIBUTES: u32 = 545;
pub const ERROR_PORT_MESSAGE_TOO_LONG: u32 = 546;
pub const ERROR_INVALID_QUOTA_LOWER: u32 = 547;
pub const ERROR_DEVICE_ALREADY_ATTACHED: u32 = 548;
pub const ERROR_INSTRUCTION_MISALIGNMENT: u32 = 549;
pub const ERROR_PROFILING_NOT_STARTED: u32 = 550;
pub const ERROR_PROFILING_NOT_STOPPED: u32 = 551;
pub const ERROR_COULD_NOT_INTERPRET: u32 = 552;
pub const ERROR_PROFILING_AT_LIMIT: u32 = 553;
pub const ERROR_CANT_WAIT: u32 = 554;
pub const ERROR_CANT_TERMINATE_SELF: u32 = 555;
pub const ERROR_UNEXPECTED_MM_CREATE_ERR: u32 = 556;
pub const ERROR_UNEXPECTED_MM_MAP_ERROR: u32 = 557;
pub const ERROR_UNEXPECTED_MM_EXTEND_ERR: u32 = 558;
pub const ERROR_BAD_FUNCTION_TABLE: u32 = 559;
pub const ERROR_NO_GUID_TRANSLATION: u32 = 560;
pub const ERROR_INVALID_LDT_SIZE: u32 = 561;
pub const ERROR_INVALID_LDT_OFFSET: u32 = 563;
pub const ERROR_INVALID_LDT_DESCRIPTOR: u32 = 564;
pub const ERROR_TOO_MANY_THREADS: u32 = 565;
pub const ERROR_THREAD_NOT_IN_PROCESS: u32 = 566;
pub const ERROR_PAGEFILE_QUOTA_EXCEEDED: u32 = 567;
pub const ERROR_LOGON_SERVER_CONFLICT: u32 = 568;
pub const ERROR_SYNCHRONIZATION_REQUIRED: u32 = 569;
pub const ERROR_NET_OPEN_FAILED: u32 = 570;
pub const ERROR_IO_PRIVILEGE_FAILED: u32 = 571;
pub const ERROR_CONTROL_C_EXIT: u32 = 572;
pub const ERROR_MISSING_SYSTEMFILE: u32 = 573;
pub const ERROR_UNHANDLED_EXCEPTION: u32 = 574;
pub const ERROR_APP_INIT_FAILURE: u32 = 575;
pub const ERROR_PAGEFILE_CREATE_FAILED: u32 = 576;
pub const ERROR_INVALID_IMAGE_HASH: u32 = 577;
pub const ERROR_NO_PAGEFILE: u32 = 578;
pub const ERROR_ILLEGAL_FLOAT_CONTEXT: u32 = 579;
pub const ERROR_NO_EVENT_PAIR: u32 = 580;
pub const ERROR_DOMAIN_CTRLR_CONFIG_ERROR: u32 = 581;
pub const ERROR_ILLEGAL_CHARACTER: u32 = 582;
pub const ERROR_UNDEFINED_CHARACTER: u32 = 583;
pub const ERROR_FLOPPY_VOLUME: u32 = 584;
pub const ERROR_BIOS_FAILED_TO_CONNECT_INTERRUPT: u32 = 585;
pub const ERROR_BACKUP_CONTROLLER: u32 = 586;
pub const ERROR_MUTANT_LIMIT_EXCEEDED: u32 = 587;
pub const ERROR_FS_DRIVER_REQUIRED: u32 = 588;
pub const ERROR_CANNOT_LOAD_REGISTRY_FILE: u32 = 589;
pub const ERROR_DEBUG_ATTACH_FAILED: u32 = 590;
pub const ERROR_SYSTEM_PROCESS_TERMINATED: u32 = 591;
pub const ERROR_DATA_NOT_ACCEPTED: u32 = 592;
pub const ERROR_VDM_HARD_ERROR: u32 = 593;
pub const ERROR_DRIVER_CANCEL_TIMEOUT: u32 = 594;
pub const ERROR_REPLY_MESSAGE_MISMATCH: u32 = 595;
pub const ERROR_LOST_WRITEBEHIND_DATA: u32 = 596;
pub const ERROR_CLIENT_SERVER_PARAMETERS_INVALID: u32 = 597;
pub const ERROR_NOT_TINY_STREAM: u32 = 598;
pub const ERROR_STACK_OVERFLOW_READ: u32 = 599;
pub const ERROR_CONVERT_TO_LARGE: u32 = 600;
pub const ERROR_FOUND_OUT_OF_SCOPE: u32 = 601;
pub const ERROR_ALLOCATE_BUCKET: u32 = 602;
pub const ERROR_MARSHALL_OVERFLOW: u32 = 603;
pub const ERROR_INVALID_VARIANT: u32 = 604;
pub const ERROR_BAD_COMPRESSION_BUFFER: u32 = 605;
pub const ERROR_AUDIT_FAILED: u32 = 606;
pub const ERROR_TIMER_RESOLUTION_NOT_SET: u32 = 607;
pub const ERROR_INSUFFICIENT_LOGON_INFO: u32 = 608;
pub const ERROR_BAD_DLL_ENTRYPOINT: u32 = 609;
pub const ERROR_BAD_SERVICE_ENTRYPOINT: u32 = 610;
pub const ERROR_IP_ADDRESS_CONFLICT1: u32 = 611;
pub const ERROR_IP_ADDRESS_CONFLICT2: u32 = 612;
pub const ERROR_REGISTRY_QUOTA_LIMIT: u32 = 613;
pub const ERROR_NO_CALLBACK_ACTIVE: u32 = 614;
pub const ERROR_PWD_TOO_SHORT: u32 = 615;
pub const ERROR_PWD_TOO_RECENT: u32 = 616;
pub const ERROR_PWD_HISTORY_CONFLICT: u32 = 617;
pub const ERROR_UNSUPPORTED_COMPRESSION: u32 = 618;
pub const ERROR_INVALID_HW_PROFILE: u32 = 619;
pub const ERROR_INVALID_PLUGPLAY_DEVICE_PATH: u32 = 620;
pub const ERROR_QUOTA_LIST_INCONSISTENT: u32 = 621;
pub const ERROR_EVALUATION_EXPIRATION: u32 = 622;
pub const ERROR_ILLEGAL_DLL_RELOCATION: u32 = 623;
pub const ERROR_DLL_INIT_FAILED_LOGOFF: u32 = 624;
pub const ERROR_VALIDATE_CONTINUE: u32 = 625;
pub const ERROR_NO_MORE_MATCHES: u32 = 626;
pub const ERROR_RANGE_LIST_CONFLICT: u32 = 627;
pub const ERROR_SERVER_SID_MISMATCH: u32 = 628;
pub const ERROR_CANT_ENABLE_DENY_ONLY: u32 = 629;
pub const ERROR_FLOAT_MULTIPLE_FAULTS: u32 = 630;
pub const ERROR_FLOAT_MULTIPLE_TRAPS: u32 = 631;
pub const ERROR_NOINTERFACE: u32 = 632;
pub const ERROR_DRIVER_FAILED_SLEEP: u32 = 633;
pub const ERROR_CORRUPT_SYSTEM_FILE: u32 = 634;
pub const ERROR_COMMITMENT_MINIMUM: u32 = 635;
pub const ERROR_PNP_RESTART_ENUMERATION: u32 = 636;
pub const ERROR_SYSTEM_IMAGE_BAD_SIGNATURE: u32 = 637;
pub const ERROR_PNP_REBOOT_REQUIRED: u32 = 638;
pub const ERROR_INSUFFICIENT_POWER: u32 = 639;
pub const ERROR_MULTIPLE_FAULT_VIOLATION: u32 = 640;
pub const ERROR_SYSTEM_SHUTDOWN: u32 = 641;
pub const ERROR_PORT_NOT_SET: u32 = 642;
pub const ERROR_DS_VERSION_CHECK_FAILURE: u32 = 643;
pub const ERROR_RANGE_NOT_FOUND: u32 = 644;
pub const ERROR_NOT_SAFE_MODE_DRIVER: u32 = 646;
pub const ERROR_FAILED_DRIVER_ENTRY: u32 = 647;
pub const ERROR_DEVICE_ENUMERATION_ERROR: u32 = 648;
pub const ERROR_MOUNT_POINT_NOT_RESOLVED: u32 = 649;
pub const ERROR_INVALID_DEVICE_OBJECT_PARAMETER: u32 = 650;
pub const ERROR_MCA_OCCURED: u32 = 651;
pub const ERROR_DRIVER_DATABASE_ERROR: u32 = 652;
pub const ERROR_SYSTEM_HIVE_TOO_LARGE: u32 = 653;
pub const ERROR_DRIVER_FAILED_PRIOR_UNLOAD: u32 = 654;
pub const ERROR_VOLSNAP_PREPARE_HIBERNATE: u32 = 655;
pub const ERROR_HIBERNATION_FAILURE: u32 = 656;
pub const ERROR_PWD_TOO_LONG: u32 = 657;
pub const ERROR_FILE_SYSTEM_LIMITATION: u32 = 665;
pub const ERROR_ASSERTION_FAILURE: u32 = 668;
pub const ERROR_ACPI_ERROR: u32 = 669;
pub const ERROR_WOW_ASSERTION: u32 = 670;
pub const ERROR_PNP_BAD_MPS_TABLE: u32 = 671;
pub const ERROR_PNP_TRANSLATION_FAILED: u32 = 672;
pub const ERROR_PNP_IRQ_TRANSLATION_FAILED: u32 = 673;
pub const ERROR_PNP_INVALID_ID: u32 = 674;
pub const ERROR_WAKE_SYSTEM_DEBUGGER: u32 = 675;
pub const ERROR_HANDLES_CLOSED: u32 = 676;
pub const ERROR_EXTRANEOUS_INFORMATION: u32 = 677;
pub const ERROR_RXACT_COMMIT_NECESSARY: u32 = 678;
pub const ERROR_MEDIA_CHECK: u32 = 679;
pub const ERROR_GUID_SUBSTITUTION_MADE: u32 = 680;
pub const ERROR_STOPPED_ON_SYMLINK: u32 = 681;
pub const ERROR_LONGJUMP: u32 = 682;
pub const ERROR_PLUGPLAY_QUERY_VETOED: u32 = 683;
pub const ERROR_UNWIND_CONSOLIDATE: u32 = 684;
pub const ERROR_REGISTRY_HIVE_RECOVERED: u32 = 685;
pub const ERROR_DLL_MIGHT_BE_INSECURE: u32 = 686;
pub const ERROR_DLL_MIGHT_BE_INCOMPATIBLE: u32 = 687;
pub const ERROR_DBG_EXCEPTION_NOT_HANDLED: u32 = 688;
pub const ERROR_DBG_REPLY_LATER: u32 = 689;
pub const ERROR_DBG_UNABLE_TO_PROVIDE_HANDLE: u32 = 690;
pub const ERROR_DBG_TERMINATE_THREAD: u32 = 691;
pub const ERROR_DBG_TERMINATE_PROCESS: u32 = 692;
pub const ERROR_DBG_CONTROL_C: u32 = 693;
pub const ERROR_DBG_PRINTEXCEPTION_C: u32 = 694;
pub const ERROR_DBG_RIPEXCEPTION: u32 = 695;
pub const ERROR_DBG_CONTROL_BREAK: u32 = 696;
pub const ERROR_DBG_COMMAND_EXCEPTION: u32 = 697;
pub const ERROR_OBJECT_NAME_EXISTS: u32 = 698;
pub const ERROR_THREAD_WAS_SUSPENDED: u32 = 699;
pub const ERROR_IMAGE_NOT_AT_BASE: u32 = 700;
pub const ERROR_RXACT_STATE_CREATED: u32 = 701;
pub const ERROR_SEGMENT_NOTIFICATION: u32 = 702;
pub const ERROR_BAD_CURRENT_DIRECTORY: u32 = 703;
pub const ERROR_FT_READ_RECOVERY_FROM_BACKUP: u32 = 704;
pub const ERROR_FT_WRITE_RECOVERY: u32 = 705;
pub const ERROR_IMAGE_MACHINE_TYPE_MISMATCH: u32 = 706;
pub const ERROR_RECEIVE_PARTIAL: u32 = 707;
pub const ERROR_RECEIVE_EXPEDITED: u32 = 708;
pub const ERROR_RECEIVE_PARTIAL_EXPEDITED: u32 = 709;
pub const ERROR_EVENT_DONE: u32 = 710;
pub const ERROR_EVENT_PENDING: u32 = 711;
pub const ERROR_CHECKING_FILE_SYSTEM: u32 = 712;
pub const ERROR_FATAL_APP_EXIT: u32 = 713;
pub const ERROR_PREDEFINED_HANDLE: u32 = 714;
pub const ERROR_WAS_UNLOCKED: u32 = 715;
pub const ERROR_SERVICE_NOTIFICATION: u32 = 716;
pub const ERROR_WAS_LOCKED: u32 = 717;
pub const ERROR_LOG_HARD_ERROR: u32 = 718;
pub const ERROR_ALREADY_WIN32: u32 = 719;
pub const ERROR_IMAGE_MACHINE_TYPE_MISMATCH_EXE: u32 = 720;
pub const ERROR_NO_YIELD_PERFORMED: u32 = 721;
pub const ERROR_TIMER_RESUME_IGNORED: u32 = 722;
pub const ERROR_ARBITRATION_UNHANDLED: u32 = 723;
pub const ERROR_CARDBUS_NOT_SUPPORTED: u32 = 724;
pub const ERROR_MP_PROCESSOR_MISMATCH: u32 = 725;
pub const ERROR_HIBERNATED: u32 = 726;
pub const ERROR_RESUME_HIBERNATION: u32 = 727;
pub const ERROR_FIRMWARE_UPDATED: u32 = 728;
pub const ERROR_DRIVERS_LEAKING_LOCKED_PAGES: u32 = 729;
pub const ERROR_WAKE_SYSTEM: u32 = 730;
pub const ERROR_WAIT_1: u32 = 731;
pub const ERROR_WAIT_2: u32 = 732;
pub const ERROR_WAIT_3: u32 = 733;
pub const ERROR_WAIT_63: u32 = 734;
pub const ERROR_ABANDONED_WAIT_0: u32 = 735;
pub const ERROR_ABANDONED_WAIT_63: u32 = 736;
pub const ERROR_USER_APC: u32 = 737;
pub const ERROR_KERNEL_APC: u32 = 738;
pub const ERROR_ALERTED: u32 = 739;
pub const ERROR_ELEVATION_REQUIRED: u32 = 740;
pub const ERROR_REPARSE: u32 = 741;
pub const ERROR_OPLOCK_BREAK_IN_PROGRESS: u32 = 742;
pub const ERROR_VOLUME_MOUNTED: u32 = 743;
pub const ERROR_RXACT_COMMITTED: u32 = 744;
pub const ERROR_NOTIFY_CLEANUP: u32 = 745;
pub const ERROR_PRIMARY_TRANSPORT_CONNECT_FAILED: u32 = 746;
pub const ERROR_PAGE_FAULT_TRANSITION: u32 = 747;
pub const ERROR_PAGE_FAULT_DEMAND_ZERO: u32 = 748;
pub const ERROR_PAGE_FAULT_COPY_ON_WRITE: u32 = 749;
pub const ERROR_PAGE_FAULT_GUARD_PAGE: u32 = 750;
pub const ERROR_PAGE_FAULT_PAGING_FILE: u32 = 751;
pub const ERROR_CACHE_PAGE_LOCKED: u32 = 752;
pub const ERROR_CRASH_DUMP: u32 = 753;
pub const ERROR_BUFFER_ALL_ZEROS: u32 = 754;
pub const ERROR_REPARSE_OBJECT: u32 = 755;
pub const ERROR_RESOURCE_REQUIREMENTS_CHANGED: u32 = 756;
pub const ERROR_TRANSLATION_COMPLETE: u32 = 757;
pub const ERROR_NOTHING_TO_TERMINATE: u32 = 758;
pub const ERROR_PROCESS_NOT_IN_JOB: u32 = 759;
pub const ERROR_PROCESS_IN_JOB: u32 = 760;
pub const ERROR_VOLSNAP_HIBERNATE_READY: u32 = 761;
pub const ERROR_FSFILTER_OP_COMPLETED_SUCCESSFULLY: u32 = 762;
pub const ERROR_INTERRUPT_VECTOR_ALREADY_CONNECTED: u32 = 763;
pub const ERROR_INTERRUPT_STILL_CONNECTED: u32 = 764;
pub const ERROR_WAIT_FOR_OPLOCK: u32 = 765;
pub const ERROR_DBG_EXCEPTION_HANDLED: u32 = 766;
pub const ERROR_DBG_CONTINUE: u32 = 767;
pub const ERROR_CALLBACK_POP_STACK: u32 = 768;
pub const ERROR_COMPRESSION_DISABLED: u32 = 769;
pub const ERROR_CANTFETCHBACKWARDS: u32 = 770;
pub const ERROR_CANTSCROLLBACKWARDS: u32 = 771;
pub const ERROR_ROWSNOTRELEASED: u32 = 772;
pub const ERROR_BAD_ACCESSOR_FLAGS: u32 = 773;
pub const ERROR_ERRORS_ENCOUNTERED: u32 = 774;
pub const ERROR_NOT_CAPABLE: u32 = 775;
pub const ERROR_REQUEST_OUT_OF_SEQUENCE: u32 = 776;
pub const ERROR_VERSION_PARSE_ERROR: u32 = 777;
pub const ERROR_BADSTARTPOSITION: u32 = 778;
pub const ERROR_MEMORY_HARDWARE: u32 = 779;
pub const ERROR_DISK_REPAIR_DISABLED: u32 = 780;
pub const ERROR_INSUFFICIENT_RESOURCE_FOR_SPECIFIED_SHARED_SECTION_SIZE: u32 = 781;
pub const ERROR_SYSTEM_POWERSTATE_TRANSITION: u32 = 782;
pub const ERROR_SYSTEM_POWERSTATE_COMPLEX_TRANSITION: u32 = 783;
pub const ERROR_MCA_EXCEPTION: u32 = 784;
pub const ERROR_ACCESS_AUDIT_BY_POLICY: u32 = 785;
pub const ERROR_ACCESS_DISABLED_NO_SAFER_UI_BY_POLICY: u32 = 786;
pub const ERROR_ABANDON_HIBERFILE: u32 = 787;
pub const ERROR_LOST_WRITEBEHIND_DATA_NETWORK_DISCONNECTED: u32 = 788;
pub const ERROR_LOST_WRITEBEHIND_DATA_NETWORK_SERVER_ERROR: u32 = 789;
pub const ERROR_LOST_WRITEBEHIND_DATA_LOCAL_DISK_ERROR: u32 = 790;
pub const ERROR_BAD_MCFG_TABLE: u32 = 791;
pub const ERROR_DISK_REPAIR_REDIRECTED: u32 = 792;
pub const ERROR_DISK_REPAIR_UNSUCCESSFUL: u32 = 793;
pub const ERROR_CORRUPT_LOG_OVERFULL: u32 = 794;
pub const ERROR_CORRUPT_LOG_CORRUPTED: u32 = 795;
pub const ERROR_CORRUPT_LOG_UNAVAILABLE: u32 = 796;
pub const ERROR_CORRUPT_LOG_DELETED_FULL: u32 = 797;
pub const ERROR_CORRUPT_LOG_CLEARED: u32 = 798;
pub const ERROR_ORPHAN_NAME_EXHAUSTED: u32 = 799;
pub const ERROR_OPLOCK_SWITCHED_TO_NEW_HANDLE: u32 = 800;
pub const ERROR_CANNOT_GRANT_REQUESTED_OPLOCK: u32 = 801;
pub const ERROR_CANNOT_BREAK_OPLOCK: u32 = 802;
pub const ERROR_OPLOCK_HANDLE_CLOSED: u32 = 803;
pub const ERROR_NO_ACE_CONDITION: u32 = 804;
pub const ERROR_INVALID_ACE_CONDITION: u32 = 805;
pub const ERROR_FILE_HANDLE_REVOKED: u32 = 806;
pub const ERROR_IMAGE_AT_DIFFERENT_BASE: u32 = 807;
pub const ERROR_ENCRYPTED_IO_NOT_POSSIBLE: u32 = 808;
pub const ERROR_FILE_METADATA_OPTIMIZATION_IN_PROGRESS: u32 = 809;
pub const ERROR_QUOTA_ACTIVITY: u32 = 810;
pub const ERROR_HANDLE_REVOKED: u32 = 811;
pub const ERROR_CALLBACK_INVOKE_INLINE: u32 = 812;
pub const ERROR_CPU_SET_INVALID: u32 = 813;
pub const ERROR_ENCLAVE_NOT_TERMINATED: u32 = 814;
pub const ERROR_ENCLAVE_VIOLATION: u32 = 815;
pub const ERROR_SERVER_TRANSPORT_CONFLICT: u32 = 816;
pub const ERROR_CERTIFICATE_VALIDATION_PREFERENCE_CONFLICT: u32 = 817;
pub const ERROR_FT_READ_FROM_COPY_FAILURE: u32 = 818;
pub const ERROR_SECTION_DIRECT_MAP_ONLY: u32 = 819;
pub const ERROR_EA_ACCESS_DENIED: u32 = 994;
pub const ERROR_OPERATION_ABORTED: u32 = 995;
pub const ERROR_IO_INCOMPLETE: u32 = 996;
pub const ERROR_IO_PENDING: u32 = 997;
pub const ERROR_NOACCESS: u32 = 998;
pub const ERROR_SWAPERROR: u32 = 999;
pub const ERROR_STACK_OVERFLOW: u32 = 1001;
pub const ERROR_INVALID_MESSAGE: u32 = 1002;
pub const ERROR_CAN_NOT_COMPLETE: u32 = 1003;
pub const ERROR_INVALID_FLAGS: u32 = 1004;
pub const ERROR_UNRECOGNIZED_VOLUME: u32 = 1005;
pub const ERROR_FILE_INVALID: u32 = 1006;
pub const ERROR_FULLSCREEN_MODE: u32 = 1007;
pub const ERROR_NO_TOKEN: u32 = 1008;
pub const ERROR_BADDB: u32 = 1009;
pub const ERROR_BADKEY: u32 = 1010;
pub const ERROR_CANTOPEN: u32 = 1011;
pub const ERROR_CANTREAD: u32 = 1012;
pub const ERROR_CANTWRITE: u32 = 1013;
pub const ERROR_REGISTRY_RECOVERED: u32 = 1014;
pub const ERROR_REGISTRY_CORRUPT: u32 = 1015;
pub const ERROR_REGISTRY_IO_FAILED: u32 = 1016;
pub const ERROR_NOT_REGISTRY_FILE: u32 = 1017;
pub const ERROR_KEY_DELETED: u32 = 1018;
pub const ERROR_NO_LOG_SPACE: u32 = 1019;
pub const ERROR_KEY_HAS_CHILDREN: u32 = 1020;
pub const ERROR_CHILD_MUST_BE_VOLATILE: u32 = 1021;
pub const ERROR_NOTIFY_ENUM_DIR: u32 = 1022;
pub const ERROR_DEPENDENT_SERVICES_RUNNING: u32 = 1051;
pub const ERROR_INVALID_SERVICE_CONTROL: u32 = 1052;
pub const ERROR_SERVICE_REQUEST_TIMEOUT: u32 = 1053;
pub const ERROR_SERVICE_NO_THREAD: u32 = 1054;
pub const ERROR_SERVICE_DATABASE_LOCKED: u32 = 1055;
pub const ERROR_SERVICE_ALREADY_RUNNING: u32 = 1056;
pub const ERROR_INVALID_SERVICE_ACCOUNT: u32 = 1057;
pub const ERROR_SERVICE_DISABLED: u32 = 1058;
pub const ERROR_CIRCULAR_DEPENDENCY: u32 = 1059;
pub const ERROR_SERVICE_DOES_NOT_EXIST: u32 = 1060;
pub const ERROR_SERVICE_CANNOT_ACCEPT_CTRL: u32 = 1061;
pub const ERROR_SERVICE_NOT_ACTIVE: u32 = 1062;
pub const ERROR_FAILED_SERVICE_CONTROLLER_CONNECT: u32 = 1063;
pub const ERROR_EXCEPTION_IN_SERVICE: u32 = 1064;
pub const ERROR_DATABASE_DOES_NOT_EXIST: u32 = 1065;
pub const ERROR_SERVICE_SPECIFIC_ERROR: u32 = 1066;
pub const ERROR_PROCESS_ABORTED: u32 = 1067;
pub const ERROR_SERVICE_DEPENDENCY_FAIL: u32 = 1068;
pub const ERROR_SERVICE_LOGON_FAILED: u32 = 1069;
pub const ERROR_SERVICE_START_HANG: u32 = 1070;
pub const ERROR_INVALID_SERVICE_LOCK: u32 = 1071;
pub const ERROR_SERVICE_MARKED_FOR_DELETE: u32 = 1072;
pub const ERROR_SERVICE_EXISTS: u32 = 1073;
pub const ERROR_ALREADY_RUNNING_LKG: u32 = 1074;
pub const ERROR_SERVICE_DEPENDENCY_DELETED: u32 = 1075;
pub const ERROR_BOOT_ALREADY_ACCEPTED: u32 = 1076;
pub const ERROR_SERVICE_NEVER_STARTED: u32 = 1077;
pub const ERROR_DUPLICATE_SERVICE_NAME: u32 = 1078;
pub const ERROR_DIFFERENT_SERVICE_ACCOUNT: u32 = 1079;
pub const ERROR_CANNOT_DETECT_DRIVER_FAILURE: u32 = 1080;
pub const ERROR_CANNOT_DETECT_PROCESS_ABORT: u32 = 1081;
pub const ERROR_NO_RECOVERY_PROGRAM: u32 = 1082;
pub const ERROR_SERVICE_NOT_IN_EXE: u32 = 1083;
pub const ERROR_NOT_SAFEBOOT_SERVICE: u32 = 1084;
pub const ERROR_END_OF_MEDIA: u32 = 1100;
pub const ERROR_FILEMARK_DETECTED: u32 = 1101;
pub const ERROR_BEGINNING_OF_MEDIA: u32 = 1102;
pub const ERROR_SETMARK_DETECTED: u32 = 1103;
pub const ERROR_NO_DATA_DETECTED: u32 = 1104;
pub const ERROR_PARTITION_FAILURE: u32 = 1105;
pub const ERROR_INVALID_BLOCK_LENGTH: u32 = 1106;
pub const ERROR_DEVICE_NOT_PARTITIONED: u32 = 1107;
pub const ERROR_UNABLE_TO_LOCK_MEDIA: u32 = 1108;
pub const ERROR_UNABLE_TO_UNLOAD_MEDIA: u32 = 1109;
pub const ERROR_MEDIA_CHANGED: u32 = 1110;
pub const ERROR_BUS_RESET: u32 = 1111;
pub const ERROR_NO_MEDIA_IN_DRIVE: u32 = 1112;
pub const ERROR_NO_UNICODE_TRANSLATION: u32 = 1113;
pub const ERROR_DLL_INIT_FAILED: u32 = 1114;
pub const ERROR_SHUTDOWN_IN_PROGRESS: u32 = 1115;
pub const ERROR_NO_SHUTDOWN_IN_PROGRESS: u32 = 1116;
pub const ERROR_IO_DEVICE: u32 = 1117;
pub const ERROR_SERIAL_NO_DEVICE: u32 = 1118;
pub const ERROR_IRQ_BUSY: u32 = 1119;
pub const ERROR_MORE_WRITES: u32 = 1120;
pub const ERROR_COUNTER_TIMEOUT: u32 = 1121;
pub const ERROR_FLOPPY_ID_MARK_NOT_FOUND: u32 = 1122;
pub const ERROR_FLOPPY_WRONG_CYLINDER: u32 = 1123;
pub const ERROR_FLOPPY_UNKNOWN_ERROR: u32 = 1124;
pub const ERROR_FLOPPY_BAD_REGISTERS: u32 = 1125;
pub const ERROR_DISK_RECALIBRATE_FAILED: u32 = 1126;
pub const ERROR_DISK_OPERATION_FAILED: u32 = 1127;
pub const ERROR_DISK_RESET_FAILED: u32 = 1128;
pub const ERROR_EOM_OVERFLOW: u32 = 1129;
pub const ERROR_NOT_ENOUGH_SERVER_MEMORY: u32 = 1130;
pub const ERROR_POSSIBLE_DEADLOCK: u32 = 1131;
pub const ERROR_MAPPED_ALIGNMENT: u32 = 1132;
pub const ERROR_SET_POWER_STATE_VETOED: u32 = 1140;
pub const ERROR_SET_POWER_STATE_FAILED: u32 = 1141;
pub const ERROR_TOO_MANY_LINKS: u32 = 1142;
pub const ERROR_OLD_WIN_VERSION: u32 = 1150;
pub const ERROR_APP_WRONG_OS: u32 = 1151;
pub const ERROR_SINGLE_INSTANCE_APP: u32 = 1152;
pub const ERROR_RMODE_APP: u32 = 1153;
pub const ERROR_INVALID_DLL: u32 = 1154;
pub const ERROR_NO_ASSOCIATION: u32 = 1155;
pub const ERROR_DDE_FAIL: u32 = 1156;
pub const ERROR_DLL_NOT_FOUND: u32 = 1157;
pub const ERROR_NO_MORE_USER_HANDLES: u32 = 1158;
pub const ERROR_MESSAGE_SYNC_ONLY: u32 = 1159;
pub const ERROR_SOURCE_ELEMENT_EMPTY: u32 = 1160;
pub const ERROR_DESTINATION_ELEMENT_FULL: u32 = 1161;
pub const ERROR_ILLEGAL_ELEMENT_ADDRESS: u32 = 1162;
pub const ERROR_MAGAZINE_NOT_PRESENT: u32 = 1163;
pub const ERROR_DEVICE_REINITIALIZATION_NEEDED: u32 = 1164;
pub const ERROR_DEVICE_REQUIRES_CLEANING: u32 = 1165;
pub const ERROR_DEVICE_DOOR_OPEN: u32 = 1166;
pub const ERROR_DEVICE_NOT_CONNECTED: u32 = 1167;
pub const ERROR_NOT_FOUND: u32 = 1168;
pub const ERROR_NO_MATCH: u32 = 1169;
pub const ERROR_SET_NOT_FOUND: u32 = 1170;
pub const ERROR_POINT_NOT_FOUND: u32 = 1171;
pub const ERROR_NO_TRACKING_SERVICE: u32 = 1172;
pub const ERROR_NO_VOLUME_ID: u32 = 1173;
pub const ERROR_UNABLE_TO_REMOVE_REPLACED: u32 = 1175;
pub const ERROR_UNABLE_TO_MOVE_REPLACEMENT: u32 = 1176;
pub const ERROR_UNABLE_TO_MOVE_REPLACEMENT_2: u32 = 1177;
pub const ERROR_JOURNAL_DELETE_IN_PROGRESS: u32 = 1178;
pub const ERROR_JOURNAL_NOT_ACTIVE: u32 = 1179;
pub const ERROR_POTENTIAL_FILE_FOUND: u32 = 1180;
pub const ERROR_JOURNAL_ENTRY_DELETED: u32 = 1181;
pub const ERROR_PARTITION_TERMINATING: u32 = 1184;
pub const ERROR_SHUTDOWN_IS_SCHEDULED: u32 = 1190;
pub const ERROR_SHUTDOWN_USERS_LOGGED_ON: u32 = 1191;
pub const ERROR_SHUTDOWN_DISKS_NOT_IN_MAINTENANCE_MODE: u32 = 1192;
pub const ERROR_BAD_DEVICE: u32 = 1200;
pub const ERROR_CONNECTION_UNAVAIL: u32 = 1201;
pub const ERROR_DEVICE_ALREADY_REMEMBERED: u32 = 1202;
pub const ERROR_NO_NET_OR_BAD_PATH: u32 = 1203;
pub const ERROR_BAD_PROVIDER: u32 = 1204;
pub const ERROR_CANNOT_OPEN_PROFILE: u32 = 1205;
pub const ERROR_BAD_PROFILE: u32 = 1206;
pub const ERROR_NOT_CONTAINER: u32 = 1207;
pub const ERROR_EXTENDED_ERROR: u32 = 1208;
pub const ERROR_INVALID_GROUPNAME: u32 = 1209;
pub const ERROR_INVALID_COMPUTERNAME: u32 = 1210;
pub const ERROR_INVALID_EVENTNAME: u32 = 1211;
pub const ERROR_INVALID_DOMAINNAME: u32 = 1212;
pub const ERROR_INVALID_SERVICENAME: u32 = 1213;
pub const ERROR_INVALID_NETNAME: u32 = 1214;
pub const ERROR_INVALID_SHARENAME: u32 = 1215;
pub const ERROR_INVALID_PASSWORDNAME: u32 = 1216;
pub const ERROR_INVALID_MESSAGENAME: u32 = 1217;
pub const ERROR_INVALID_MESSAGEDEST: u32 = 1218;
pub const ERROR_SESSION_CREDENTIAL_CONFLICT: u32 = 1219;
pub const ERROR_REMOTE_SESSION_LIMIT_EXCEEDED: u32 = 1220;
pub const ERROR_DUP_DOMAINNAME: u32 = 1221;
pub const ERROR_NO_NETWORK: u32 = 1222;
pub const ERROR_CANCELLED: u32 = 1223;
pub const ERROR_USER_MAPPED_FILE: u32 = 1224;
pub const ERROR_CONNECTION_REFUSED: u32 = 1225;
pub const ERROR_GRACEFUL_DISCONNECT: u32 = 1226;
pub const ERROR_ADDRESS_ALREADY_ASSOCIATED: u32 = 1227;
pub const ERROR_ADDRESS_NOT_ASSOCIATED: u32 = 1228;
pub const ERROR_CONNECTION_INVALID: u32 = 1229;
pub const ERROR_CONNECTION_ACTIVE: u32 = 1230;
pub const ERROR_NETWORK_UNREACHABLE: u32 = 1231;
pub const ERROR_HOST_UNREACHABLE: u32 = 1232;
pub const ERROR_PROTOCOL_UNREACHABLE: u32 = 1233;
pub const ERROR_PORT_UNREACHABLE: u32 = 1234;
pub const ERROR_REQUEST_ABORTED: u32 = 1235;
pub const ERROR_CONNECTION_ABORTED: u32 = 1236;
pub const ERROR_RETRY: u32 = 1237;
pub const ERROR_CONNECTION_COUNT_LIMIT: u32 = 1238;
pub const ERROR_LOGIN_TIME_RESTRICTION: u32 = 1239;
pub const ERROR_LOGIN_WKSTA_RESTRICTION: u32 = 1240;
pub const ERROR_INCORRECT_ADDRESS: u32 = 1241;
pub const ERROR_ALREADY_REGISTERED: u32 = 1242;
pub const ERROR_SERVICE_NOT_FOUND: u32 = 1243;
pub const ERROR_NOT_AUTHENTICATED: u32 = 1244;
pub const ERROR_NOT_LOGGED_ON: u32 = 1245;
pub const ERROR_CONTINUE: u32 = 1246;
pub const ERROR_ALREADY_INITIALIZED: u32 = 1247;
pub const ERROR_NO_MORE_DEVICES: u32 = 1248;
pub const ERROR_NO_SUCH_SITE: u32 = 1249;
pub const ERROR_DOMAIN_CONTROLLER_EXISTS: u32 = 1250;
pub const ERROR_ONLY_IF_CONNECTED: u32 = 1251;
pub const ERROR_OVERRIDE_NOCHANGES: u32 = 1252;
pub const ERROR_BAD_USER_PROFILE: u32 = 1253;
pub const ERROR_NOT_SUPPORTED_ON_SBS: u32 = 1254;
pub const ERROR_SERVER_SHUTDOWN_IN_PROGRESS: u32 = 1255;
pub const ERROR_HOST_DOWN: u32 = 1256;
pub const ERROR_NON_ACCOUNT_SID: u32 = 1257;
pub const ERROR_NON_DOMAIN_SID: u32 = 1258;
pub const ERROR_APPHELP_BLOCK: u32 = 1259;
pub const ERROR_ACCESS_DISABLED_BY_POLICY: u32 = 1260;
pub const ERROR_REG_NAT_CONSUMPTION: u32 = 1261;
pub const ERROR_CSCSHARE_OFFLINE: u32 = 1262;
pub const ERROR_PKINIT_FAILURE: u32 = 1263;
pub const ERROR_SMARTCARD_SUBSYSTEM_FAILURE: u32 = 1264;
pub const ERROR_DOWNGRADE_DETECTED: u32 = 1265;
pub const ERROR_MACHINE_LOCKED: u32 = 1271;
pub const ERROR_SMB_GUEST_LOGON_BLOCKED: u32 = 1272;
pub const ERROR_CALLBACK_SUPPLIED_INVALID_DATA: u32 = 1273;
pub const ERROR_SYNC_FOREGROUND_REFRESH_REQUIRED: u32 = 1274;
pub const ERROR_DRIVER_BLOCKED: u32 = 1275;
pub const ERROR_INVALID_IMPORT_OF_NON_DLL: u32 = 1276;
pub const ERROR_ACCESS_DISABLED_WEBBLADE: u32 = 1277;
pub const ERROR_ACCESS_DISABLED_WEBBLADE_TAMPER: u32 = 1278;
pub const ERROR_RECOVERY_FAILURE: u32 = 1279;
pub const ERROR_ALREADY_FIBER: u32 = 1280;
pub const ERROR_ALREADY_THREAD: u32 = 1281;
pub const ERROR_STACK_BUFFER_OVERRUN: u32 = 1282;
pub const ERROR_PARAMETER_QUOTA_EXCEEDED: u32 = 1283;
pub const ERROR_DEBUGGER_INACTIVE: u32 = 1284;
pub const ERROR_DELAY_LOAD_FAILED: u32 = 1285;
pub const ERROR_VDM_DISALLOWED: u32 = 1286;
pub const ERROR_UNIDENTIFIED_ERROR: u32 = 1287;
pub const ERROR_INVALID_CRUNTIME_PARAMETER: u32 = 1288;
pub const ERROR_BEYOND_VDL: u32 = 1289;
pub const ERROR_INCOMPATIBLE_SERVICE_SID_TYPE: u32 = 1290;
pub const ERROR_DRIVER_PROCESS_TERMINATED: u32 = 1291;
pub const ERROR_IMPLEMENTATION_LIMIT: u32 = 1292;
pub const ERROR_PROCESS_IS_PROTECTED: u32 = 1293;
pub const ERROR_SERVICE_NOTIFY_CLIENT_LAGGING: u32 = 1294;
pub const ERROR_DISK_QUOTA_EXCEEDED: u32 = 1295;
pub const ERROR_CONTENT_BLOCKED: u32 = 1296;
pub const ERROR_INCOMPATIBLE_SERVICE_PRIVILEGE: u32 = 1297;
pub const ERROR_APP_HANG: u32 = 1298;
pub const ERROR_INVALID_LABEL: u32 = 1299;
pub const ERROR_NOT_ALL_ASSIGNED: u32 = 1300;
pub const ERROR_SOME_NOT_MAPPED: u32 = 1301;
pub const ERROR_NO_QUOTAS_FOR_ACCOUNT: u32 = 1302;
pub const ERROR_LOCAL_USER_SESSION_KEY: u32 = 1303;
pub const ERROR_NULL_LM_PASSWORD: u32 = 1304;
pub const ERROR_UNKNOWN_REVISION: u32 = 1305;
pub const ERROR_REVISION_MISMATCH: u32 = 1306;
pub const ERROR_INVALID_OWNER: u32 = 1307;
pub const ERROR_INVALID_PRIMARY_GROUP: u32 = 1308;
pub const ERROR_NO_IMPERSONATION_TOKEN: u32 = 1309;
pub const ERROR_CANT_DISABLE_MANDATORY: u32 = 1310;
pub const ERROR_NO_LOGON_SERVERS: u32 = 1311;
pub const ERROR_NO_SUCH_LOGON_SESSION: u32 = 1312;
pub const ERROR_NO_SUCH_PRIVILEGE: u32 = 1313;
pub const ERROR_PRIVILEGE_NOT_HELD: u32 = 1314;
pub const ERROR_INVALID_ACCOUNT_NAME: u32 = 1315;
pub const ERROR_USER_EXISTS: u32 = 1316;
pub const ERROR_NO_SUCH_USER: u32 = 1317;
pub const ERROR_GROUP_EXISTS: u32 = 1318;
pub const ERROR_NO_SUCH_GROUP: u32 = 1319;
pub const ERROR_MEMBER_IN_GROUP: u32 = 1320;
pub const ERROR_MEMBER_NOT_IN_GROUP: u32 = 1321;
pub const ERROR_LAST_ADMIN: u32 = 1322;
pub const ERROR_WRONG_PASSWORD: u32 = 1323;
pub const ERROR_ILL_FORMED_PASSWORD: u32 = 1324;
pub const ERROR_PASSWORD_RESTRICTION: u32 = 1325;
pub const ERROR_LOGON_FAILURE: u32 = 1326;
pub const ERROR_ACCOUNT_RESTRICTION: u32 = 1327;
pub const ERROR_INVALID_LOGON_HOURS: u32 = 1328;
pub const ERROR_INVALID_WORKSTATION: u32 = 1329;
pub const ERROR_PASSWORD_EXPIRED: u32 = 1330;
pub const ERROR_ACCOUNT_DISABLED: u32 = 1331;
pub const ERROR_NONE_MAPPED: u32 = 1332;
pub const ERROR_TOO_MANY_LUIDS_REQUESTED: u32 = 1333;
pub const ERROR_LUIDS_EXHAUSTED: u32 = 1334;
pub const ERROR_INVALID_SUB_AUTHORITY: u32 = 1335;
pub const ERROR_INVALID_ACL: u32 = 1336;
pub const ERROR_INVALID_SID: u32 = 1337;
pub const ERROR_INVALID_SECURITY_DESCR: u32 = 1338;
pub const ERROR_BAD_INHERITANCE_ACL: u32 = 1340;
pub const ERROR_SERVER_DISABLED: u32 = 1341;
pub const ERROR_SERVER_NOT_DISABLED: u32 = 1342;
pub const ERROR_INVALID_ID_AUTHORITY: u32 = 1343;
pub const ERROR_ALLOTTED_SPACE_EXCEEDED: u32 = 1344;
pub const ERROR_INVALID_GROUP_ATTRIBUTES: u32 = 1345;
pub const ERROR_BAD_IMPERSONATION_LEVEL: u32 = 1346;
pub const ERROR_CANT_OPEN_ANONYMOUS: u32 = 1347;
pub const ERROR_BAD_VALIDATION_CLASS: u32 = 1348;
pub const ERROR_BAD_TOKEN_TYPE: u32 = 1349;
pub const ERROR_NO_SECURITY_ON_OBJECT: u32 = 1350;
pub const ERROR_CANT_ACCESS_DOMAIN_INFO: u32 = 1351;
pub const ERROR_INVALID_SERVER_STATE: u32 = 1352;
pub const ERROR_INVALID_DOMAIN_STATE: u32 = 1353;
pub const ERROR_INVALID_DOMAIN_ROLE: u32 = 1354;
pub const ERROR_NO_SUCH_DOMAIN: u32 = 1355;
pub const ERROR_DOMAIN_EXISTS: u32 = 1356;
pub const ERROR_DOMAIN_LIMIT_EXCEEDED: u32 = 1357;
pub const ERROR_INTERNAL_DB_CORRUPTION: u32 = 1358;
pub const ERROR_INTERNAL_ERROR: u32 = 1359;
pub const ERROR_GENERIC_NOT_MAPPED: u32 = 1360;
pub const ERROR_BAD_DESCRIPTOR_FORMAT: u32 = 1361;
pub const ERROR_NOT_LOGON_PROCESS: u32 = 1362;
pub const ERROR_LOGON_SESSION_EXISTS: u32 = 1363;
pub const ERROR_NO_SUCH_PACKAGE: u32 = 1364;
pub const ERROR_BAD_LOGON_SESSION_STATE: u32 = 1365;
pub const ERROR_LOGON_SESSION_COLLISION: u32 = 1366;
pub const ERROR_INVALID_LOGON_TYPE: u32 = 1367;
pub const ERROR_CANNOT_IMPERSONATE: u32 = 1368;
pub const ERROR_RXACT_INVALID_STATE: u32 = 1369;
pub const ERROR_RXACT_COMMIT_FAILURE: u32 = 1370;
pub const ERROR_SPECIAL_ACCOUNT: u32 = 1371;
pub const ERROR_SPECIAL_GROUP: u32 = 1372;
pub const ERROR_SPECIAL_USER: u32 = 1373;
pub const ERROR_MEMBERS_PRIMARY_GROUP: u32 = 1374;
pub const ERROR_TOKEN_ALREADY_IN_USE: u32 = 1375;
pub const ERROR_NO_SUCH_ALIAS: u32 = 1376;
pub const ERROR_MEMBER_NOT_IN_ALIAS: u32 = 1377;
pub const ERROR_MEMBER_IN_ALIAS: u32 = 1378;
pub const ERROR_ALIAS_EXISTS: u32 = 1379;
pub const ERROR_LOGON_NOT_GRANTED: u32 = 1380;
pub const ERROR_TOO_MANY_SECRETS: u32 = 1381;
pub const ERROR_SECRET_TOO_LONG: u32 = 1382;
pub const ERROR_INTERNAL_DB_ERROR: u32 = 1383;
pub const ERROR_TOO_MANY_CONTEXT_IDS: u32 = 1384;
pub const ERROR_LOGON_TYPE_NOT_GRANTED: u32 = 1385;
pub const ERROR_NT_CROSS_ENCRYPTION_REQUIRED: u32 = 1386;
pub const ERROR_NO_SUCH_MEMBER: u32 = 1387;
pub const ERROR_INVALID_MEMBER: u32 = 1388;
pub const ERROR_TOO_MANY_SIDS: u32 = 1389;
pub const ERROR_LM_CROSS_ENCRYPTION_REQUIRED: u32 = 1390;
pub const ERROR_NO_INHERITANCE: u32 = 1391;
pub const ERROR_FILE_CORRUPT: u32 = 1392;
pub const ERROR_DISK_CORRUPT: u32 = 1393;
pub const ERROR_NO_USER_SESSION_KEY: u32 = 1394;
pub const ERROR_LICENSE_QUOTA_EXCEEDED: u32 = 1395;
pub const ERROR_WRONG_TARGET_NAME: u32 = 1396;
pub const ERROR_MUTUAL_AUTH_FAILED: u32 = 1397;
pub const ERROR_TIME_SKEW: u32 = 1398;
pub const ERROR_CURRENT_DOMAIN_NOT_ALLOWED: u32 = 1399;
pub const ERROR_INVALID_WINDOW_HANDLE: u32 = 1400;
pub const ERROR_INVALID_MENU_HANDLE: u32 = 1401;
pub const ERROR_INVALID_CURSOR_HANDLE: u32 = 1402;
pub const ERROR_INVALID_ACCEL_HANDLE: u32 = 1403;
pub const ERROR_INVALID_HOOK_HANDLE: u32 = 1404;
pub const ERROR_INVALID_DWP_HANDLE: u32 = 1405;
pub const ERROR_TLW_WITH_WSCHILD: u32 = 1406;
pub const ERROR_CANNOT_FIND_WND_CLASS: u32 = 1407;
pub const ERROR_WINDOW_OF_OTHER_THREAD: u32 = 1408;
pub const ERROR_HOTKEY_ALREADY_REGISTERED: u32 = 1409;
pub const ERROR_CLASS_ALREADY_EXISTS: u32 = 1410;
pub const ERROR_CLASS_DOES_NOT_EXIST: u32 = 1411;
pub const ERROR_CLASS_HAS_WINDOWS: u32 = 1412;
pub const ERROR_INVALID_INDEX: u32 = 1413;
pub const ERROR_INVALID_ICON_HANDLE: u32 = 1414;
pub const ERROR_PRIVATE_DIALOG_INDEX: u32 = 1415;
pub const ERROR_LISTBOX_ID_NOT_FOUND: u32 = 1416;
pub const ERROR_NO_WILDCARD_CHARACTERS: u32 = 1417;
pub const ERROR_CLIPBOARD_NOT_OPEN: u32 = 1418;
pub const ERROR_HOTKEY_NOT_REGISTERED: u32 = 1419;
pub const ERROR_WINDOW_NOT_DIALOG: u32 = 1420;
pub const ERROR_CONTROL_ID_NOT_FOUND: u32 = 1421;
pub const ERROR_INVALID_COMBOBOX_MESSAGE: u32 = 1422;
pub const ERROR_WINDOW_NOT_COMBOBOX: u32 = 1423;
pub const ERROR_INVALID_EDIT_HEIGHT: u32 = 1424;
pub const ERROR_DC_NOT_FOUND: u32 = 1425;
pub const ERROR_INVALID_HOOK_FILTER: u32 = 1426;
pub const ERROR_INVALID_FILTER_PROC: u32 = 1427;
pub const ERROR_HOOK_NEEDS_HMOD: u32 = 1428;
pub const ERROR_GLOBAL_ONLY_HOOK: u32 = 1429;
pub const ERROR_JOURNAL_HOOK_SET: u32 = 1430;
pub const ERROR_HOOK_NOT_INSTALLED: u32 = 1431;
pub const ERROR_INVALID_LB_MESSAGE: u32 = 1432;
pub const ERROR_SETCOUNT_ON_BAD_LB: u32 = 1433;
pub const ERROR_LB_WITHOUT_TABSTOPS: u32 = 1434;
pub const ERROR_DESTROY_OBJECT_OF_OTHER_THREAD: u32 = 1435;
pub const ERROR_CHILD_WINDOW_MENU: u32 = 1436;
pub const ERROR_NO_SYSTEM_MENU: u32 = 1437;
pub const ERROR_INVALID_MSGBOX_STYLE: u32 = 1438;
pub const ERROR_INVALID_SPI_VALUE: u32 = 1439;
pub const ERROR_SCREEN_ALREADY_LOCKED: u32 = 1440;
pub const ERROR_HWNDS_HAVE_DIFF_PARENT: u32 = 1441;
pub const ERROR_NOT_CHILD_WINDOW: u32 = 1442;
pub const ERROR_INVALID_GW_COMMAND: u32 = 1443;
pub const ERROR_INVALID_THREAD_ID: u32 = 1444;
pub const ERROR_NON_MDICHILD_WINDOW: u32 = 1445;
pub const ERROR_POPUP_ALREADY_ACTIVE: u32 = 1446;
pub const ERROR_NO_SCROLLBARS: u32 = 1447;
pub const ERROR_INVALID_SCROLLBAR_RANGE: u32 = 1448;
pub const ERROR_INVALID_SHOWWIN_COMMAND: u32 = 1449;
pub const ERROR_NO_SYSTEM_RESOURCES: u32 = 1450;
pub const ERROR_NONPAGED_SYSTEM_RESOURCES: u32 = 1451;
pub const ERROR_PAGED_SYSTEM_RESOURCES: u32 = 1452;
pub const ERROR_WORKING_SET_QUOTA: u32 = 1453;
pub const ERROR_PAGEFILE_QUOTA: u32 = 1454;
pub const ERROR_COMMITMENT_LIMIT: u32 = 1455;
pub const ERROR_MENU_ITEM_NOT_FOUND: u32 = 1456;
pub const ERROR_INVALID_KEYBOARD_HANDLE: u32 = 1457;
pub const ERROR_HOOK_TYPE_NOT_ALLOWED: u32 = 1458;
pub const ERROR_REQUIRES_INTERACTIVE_WINDOWSTATION: u32 = 1459;
pub const ERROR_TIMEOUT: u32 = 1460;
pub const ERROR_INVALID_MONITOR_HANDLE: u32 = 1461;
pub const ERROR_INCORRECT_SIZE: u32 = 1462;
pub const ERROR_SYMLINK_CLASS_DISABLED: u32 = 1463;
pub const ERROR_SYMLINK_NOT_SUPPORTED: u32 = 1464;
pub const ERROR_XML_PARSE_ERROR: u32 = 1465;
pub const ERROR_XMLDSIG_ERROR: u32 = 1466;
pub const ERROR_RESTART_APPLICATION: u32 = 1467;
pub const ERROR_WRONG_COMPARTMENT: u32 = 1468;
pub const ERROR_AUTHIP_FAILURE: u32 = 1469;
pub const ERROR_NO_NVRAM_RESOURCES: u32 = 1470;
pub const ERROR_NOT_GUI_PROCESS: u32 = 1471;
pub const ERROR_EVENTLOG_FILE_CORRUPT: u32 = 1500;
pub const ERROR_EVENTLOG_CANT_START: u32 = 1501;
pub const ERROR_LOG_FILE_FULL: u32 = 1502;
pub const ERROR_EVENTLOG_FILE_CHANGED: u32 = 1503;
pub const ERROR_CONTAINER_ASSIGNED: u32 = 1504;
pub const ERROR_JOB_NO_CONTAINER: u32 = 1505;
pub const ERROR_INVALID_TASK_NAME: u32 = 1550;
pub const ERROR_INVALID_TASK_INDEX: u32 = 1551;
pub const ERROR_THREAD_ALREADY_IN_TASK: u32 = 1552;
pub const ERROR_INSTALL_SERVICE_FAILURE: u32 = 1601;
pub const ERROR_INSTALL_USEREXIT: u32 = 1602;
pub const ERROR_INSTALL_FAILURE: u32 = 1603;
pub const ERROR_INSTALL_SUSPEND: u32 = 1604;
pub const ERROR_UNKNOWN_PRODUCT: u32 = 1605;
pub const ERROR_UNKNOWN_FEATURE: u32 = 1606;
pub const ERROR_UNKNOWN_COMPONENT: u32 = 1607;
pub const ERROR_UNKNOWN_PROPERTY: u32 = 1608;
pub const ERROR_INVALID_HANDLE_STATE: u32 = 1609;
pub const ERROR_BAD_CONFIGURATION: u32 = 1610;
pub const ERROR_INDEX_ABSENT: u32 = 1611;
pub const ERROR_INSTALL_SOURCE_ABSENT: u32 = 1612;
pub const ERROR_INSTALL_PACKAGE_VERSION: u32 = 1613;
pub const ERROR_PRODUCT_UNINSTALLED: u32 = 1614;
pub const ERROR_BAD_QUERY_SYNTAX: u32 = 1615;
pub const ERROR_INVALID_FIELD: u32 = 1616;
pub const ERROR_DEVICE_REMOVED: u32 = 1617;
pub const ERROR_INSTALL_ALREADY_RUNNING: u32 = 1618;
pub const ERROR_INSTALL_PACKAGE_OPEN_FAILED: u32 = 1619;
pub const ERROR_INSTALL_PACKAGE_INVALID: u32 = 1620;
pub const ERROR_INSTALL_UI_FAILURE: u32 = 1621;
pub const ERROR_INSTALL_LOG_FAILURE: u32 = 1622;
pub const ERROR_INSTALL_LANGUAGE_UNSUPPORTED: u32 = 1623;
pub const ERROR_INSTALL_TRANSFORM_FAILURE: u32 = 1624;
pub const ERROR_INSTALL_PACKAGE_REJECTED: u32 = 1625;
pub const ERROR_FUNCTION_NOT_CALLED: u32 = 1626;
pub const ERROR_FUNCTION_FAILED: u32 = 1627;
pub const ERROR_INVALID_TABLE: u32 = 1628;
pub const ERROR_DATATYPE_MISMATCH: u32 = 1629;
pub const ERROR_UNSUPPORTED_TYPE: u32 = 1630;
pub const ERROR_CREATE_FAILED: u32 = 1631;
pub const ERROR_INSTALL_TEMP_UNWRITABLE: u32 = 1632;
pub const ERROR_INSTALL_PLATFORM_UNSUPPORTED: u32 = 1633;
pub const ERROR_INSTALL_NOTUSED: u32 = 1634;
pub const ERROR_PATCH_PACKAGE_OPEN_FAILED: u32 = 1635;
pub const ERROR_PATCH_PACKAGE_INVALID: u32 = 1636;
pub const ERROR_PATCH_PACKAGE_UNSUPPORTED: u32 = 1637;
pub const ERROR_PRODUCT_VERSION: u32 = 1638;
pub const ERROR_INVALID_COMMAND_LINE: u32 = 1639;
pub const ERROR_INSTALL_REMOTE_DISALLOWED: u32 = 1640;
pub const ERROR_SUCCESS_REBOOT_INITIATED: u32 = 1641;
pub const ERROR_PATCH_TARGET_NOT_FOUND: u32 = 1642;
pub const ERROR_PATCH_PACKAGE_REJECTED: u32 = 1643;
pub const ERROR_INSTALL_TRANSFORM_REJECTED: u32 = 1644;
pub const ERROR_INSTALL_REMOTE_PROHIBITED: u32 = 1645;
pub const ERROR_PATCH_REMOVAL_UNSUPPORTED: u32 = 1646;
pub const ERROR_UNKNOWN_PATCH: u32 = 1647;
pub const ERROR_PATCH_NO_SEQUENCE: u32 = 1648;
pub const ERROR_PATCH_REMOVAL_DISALLOWED: u32 = 1649;
pub const ERROR_INVALID_PATCH_XML: u32 = 1650;
pub const ERROR_PATCH_MANAGED_ADVERTISED_PRODUCT: u32 = 1651;
pub const ERROR_INSTALL_SERVICE_SAFEBOOT: u32 = 1652;
pub const ERROR_FAIL_FAST_EXCEPTION: u32 = 1653;
pub const ERROR_INSTALL_REJECTED: u32 = 1654;
pub const ERROR_DYNAMIC_CODE_BLOCKED: u32 = 1655;
pub const ERROR_NOT_SAME_OBJECT: u32 = 1656;
pub const ERROR_STRICT_CFG_VIOLATION: u32 = 1657;
pub const ERROR_SET_CONTEXT_DENIED: u32 = 1660;
pub const ERROR_CROSS_PARTITION_VIOLATION: u32 = 1661;
pub const ERROR_RETURN_ADDRESS_HIJACK_ATTEMPT: u32 = 1662;
pub const RPC_S_INVALID_STRING_BINDING: u32 = 1700;
pub const RPC_S_WRONG_KIND_OF_BINDING: u32 = 1701;
pub const RPC_S_INVALID_BINDING: u32 = 1702;
pub const RPC_S_PROTSEQ_NOT_SUPPORTED: u32 = 1703;
pub const RPC_S_INVALID_RPC_PROTSEQ: u32 = 1704;
pub const RPC_S_INVALID_STRING_UUID: u32 = 1705;
pub const RPC_S_INVALID_ENDPOINT_FORMAT: u32 = 1706;
pub const RPC_S_INVALID_NET_ADDR: u32 = 1707;
pub const RPC_S_NO_ENDPOINT_FOUND: u32 = 1708;
pub const RPC_S_INVALID_TIMEOUT: u32 = 1709;
pub const RPC_S_OBJECT_NOT_FOUND: u32 = 1710;
pub const RPC_S_ALREADY_REGISTERED: u32 = 1711;
pub const RPC_S_TYPE_ALREADY_REGISTERED: u32 = 1712;
pub const RPC_S_ALREADY_LISTENING: u32 = 1713;
pub const RPC_S_NO_PROTSEQS_REGISTERED: u32 = 1714;
pub const RPC_S_NOT_LISTENING: u32 = 1715;
pub const RPC_S_UNKNOWN_MGR_TYPE: u32 = 1716;
pub const RPC_S_UNKNOWN_IF: u32 = 1717;
pub const RPC_S_NO_BINDINGS: u32 = 1718;
pub const RPC_S_NO_PROTSEQS: u32 = 1719;
pub const RPC_S_CANT_CREATE_ENDPOINT: u32 = 1720;
pub const RPC_S_OUT_OF_RESOURCES: u32 = 1721;
pub const RPC_S_SERVER_UNAVAILABLE: u32 = 1722;
pub const RPC_S_SERVER_TOO_BUSY: u32 = 1723;
pub const RPC_S_INVALID_NETWORK_OPTIONS: u32 = 1724;
pub const RPC_S_NO_CALL_ACTIVE: u32 = 1725;
pub const RPC_S_CALL_FAILED: u32 = 1726;
pub const RPC_S_CALL_FAILED_DNE: u32 = 1727;
pub const RPC_S_PROTOCOL_ERROR: u32 = 1728;
pub const RPC_S_PROXY_ACCESS_DENIED: u32 = 1729;
pub const RPC_S_UNSUPPORTED_TRANS_SYN: u32 = 1730;
pub const RPC_S_UNSUPPORTED_TYPE: u32 = 1732;
pub const RPC_S_INVALID_TAG: u32 = 1733;
pub const RPC_S_INVALID_BOUND: u32 = 1734;
pub const RPC_S_NO_ENTRY_NAME: u32 = 1735;
pub const RPC_S_INVALID_NAME_SYNTAX: u32 = 1736;
pub const RPC_S_UNSUPPORTED_NAME_SYNTAX: u32 = 1737;
pub const RPC_S_UUID_NO_ADDRESS: u32 = 1739;
pub const RPC_S_DUPLICATE_ENDPOINT: u32 = 1740;
pub const RPC_S_UNKNOWN_AUTHN_TYPE: u32 = 1741;
pub const RPC_S_MAX_CALLS_TOO_SMALL: u32 = 1742;
pub const RPC_S_STRING_TOO_LONG: u32 = 1743;
pub const RPC_S_PROTSEQ_NOT_FOUND: u32 = 1744;
pub const RPC_S_PROCNUM_OUT_OF_RANGE: u32 = 1745;
pub const RPC_S_BINDING_HAS_NO_AUTH: u32 = 1746;
pub const RPC_S_UNKNOWN_AUTHN_SERVICE: u32 = 1747;
pub const RPC_S_UNKNOWN_AUTHN_LEVEL: u32 = 1748;
pub const RPC_S_INVALID_AUTH_IDENTITY: u32 = 1749;
pub const RPC_S_UNKNOWN_AUTHZ_SERVICE: u32 = 1750;
pub const EPT_S_INVALID_ENTRY: u32 = 1751;
pub const EPT_S_CANT_PERFORM_OP: u32 = 1752;
pub const EPT_S_NOT_REGISTERED: u32 = 1753;
pub const RPC_S_NOTHING_TO_EXPORT: u32 = 1754;
pub const RPC_S_INCOMPLETE_NAME: u32 = 1755;
pub const RPC_S_INVALID_VERS_OPTION: u32 = 1756;
pub const RPC_S_NO_MORE_MEMBERS: u32 = 1757;
pub const RPC_S_NOT_ALL_OBJS_UNEXPORTED: u32 = 1758;
pub const RPC_S_INTERFACE_NOT_FOUND: u32 = 1759;
pub const RPC_S_ENTRY_ALREADY_EXISTS: u32 = 1760;
pub const RPC_S_ENTRY_NOT_FOUND: u32 = 1761;
pub const RPC_S_NAME_SERVICE_UNAVAILABLE: u32 = 1762;
pub const RPC_S_INVALID_NAF_ID: u32 = 1763;
pub const RPC_S_CANNOT_SUPPORT: u32 = 1764;
pub const RPC_S_NO_CONTEXT_AVAILABLE: u32 = 1765;
pub const RPC_S_INTERNAL_ERROR: u32 = 1766;
pub const RPC_S_ZERO_DIVIDE: u32 = 1767;
pub const RPC_S_ADDRESS_ERROR: u32 = 1768;
pub const RPC_S_FP_DIV_ZERO: u32 = 1769;
pub const RPC_S_FP_UNDERFLOW: u32 = 1770;
pub const RPC_S_FP_OVERFLOW: u32 = 1771;
pub const RPC_X_NO_MORE_ENTRIES: u32 = 1772;
pub const RPC_X_SS_CHAR_TRANS_OPEN_FAIL: u32 = 1773;
pub const RPC_X_SS_CHAR_TRANS_SHORT_FILE: u32 = 1774;
pub const RPC_X_SS_IN_NULL_CONTEXT: u32 = 1775;
pub const RPC_X_SS_CONTEXT_DAMAGED: u32 = 1777;
pub const RPC_X_SS_HANDLES_MISMATCH: u32 = 1778;
pub const RPC_X_SS_CANNOT_GET_CALL_HANDLE: u32 = 1779;
pub const RPC_X_NULL_REF_POINTER: u32 = 1780;
pub const RPC_X_ENUM_VALUE_OUT_OF_RANGE: u32 = 1781;
pub const RPC_X_BYTE_COUNT_TOO_SMALL: u32 = 1782;
pub const RPC_X_BAD_STUB_DATA: u32 = 1783;
pub const ERROR_INVALID_USER_BUFFER: u32 = 1784;
pub const ERROR_UNRECOGNIZED_MEDIA: u32 = 1785;
pub const ERROR_NO_TRUST_LSA_SECRET: u32 = 1786;
pub const ERROR_NO_TRUST_SAM_ACCOUNT: u32 = 1787;
pub const ERROR_TRUSTED_DOMAIN_FAILURE: u32 = 1788;
pub const ERROR_TRUSTED_RELATIONSHIP_FAILURE: u32 = 1789;
pub const ERROR_TRUST_FAILURE: u32 = 1790;
pub const RPC_S_CALL_IN_PROGRESS: u32 = 1791;
pub const ERROR_NETLOGON_NOT_STARTED: u32 = 1792;
pub const ERROR_ACCOUNT_EXPIRED: u32 = 1793;
pub const ERROR_REDIRECTOR_HAS_OPEN_HANDLES: u32 = 1794;
pub const ERROR_PRINTER_DRIVER_ALREADY_INSTALLED: u32 = 1795;
pub const ERROR_UNKNOWN_PORT: u32 = 1796;
pub const ERROR_UNKNOWN_PRINTER_DRIVER: u32 = 1797;
pub const ERROR_UNKNOWN_PRINTPROCESSOR: u32 = 1798;
pub const ERROR_INVALID_SEPARATOR_FILE: u32 = 1799;
pub const ERROR_INVALID_PRIORITY: u32 = 1800;
pub const ERROR_INVALID_PRINTER_NAME: u32 = 1801;
pub const ERROR_PRINTER_ALREADY_EXISTS: u32 = 1802;
pub const ERROR_INVALID_PRINTER_COMMAND: u32 = 1803;
pub const ERROR_INVALID_DATATYPE: u32 = 1804;
pub const ERROR_INVALID_ENVIRONMENT: u32 = 1805;
pub const RPC_S_NO_MORE_BINDINGS: u32 = 1806;
pub const ERROR_NOLOGON_INTERDOMAIN_TRUST_ACCOUNT: u32 = 1807;
pub const ERROR_NOLOGON_WORKSTATION_TRUST_ACCOUNT: u32 = 1808;
pub const ERROR_NOLOGON_SERVER_TRUST_ACCOUNT: u32 = 1809;
pub const ERROR_DOMAIN_TRUST_INCONSISTENT: u32 = 1810;
pub const ERROR_SERVER_HAS_OPEN_HANDLES: u32 = 1811;
pub const ERROR_RESOURCE_DATA_NOT_FOUND: u32 = 1812;
pub const ERROR_RESOURCE_TYPE_NOT_FOUND: u32 = 1813;
pub const ERROR_RESOURCE_NAME_NOT_FOUND: u32 = 1814;
pub const ERROR_RESOURCE_LANG_NOT_FOUND: u32 = 1815;
pub const ERROR_NOT_ENOUGH_QUOTA: u32 = 1816;
pub const RPC_S_NO_INTERFACES: u32 = 1817;
pub const RPC_S_CALL_CANCELLED: u32 = 1818;
pub const RPC_S_BINDING_INCOMPLETE: u32 = 1819;
pub const RPC_S_COMM_FAILURE: u32 = 1820;
pub const RPC_S_UNSUPPORTED_AUTHN_LEVEL: u32 = 1821;
pub const RPC_S_NO_PRINC_NAME: u32 = 1822;
pub const RPC_S_NOT_RPC_ERROR: u32 = 1823;
pub const RPC_S_UUID_LOCAL_ONLY: u32 = 1824;
pub const RPC_S_SEC_PKG_ERROR: u32 = 1825;
pub const RPC_S_NOT_CANCELLED: u32 = 1826;
pub const RPC_X_INVALID_ES_ACTION: u32 = 1827;
pub const RPC_X_WRONG_ES_VERSION: u32 = 1828;
pub const RPC_X_WRONG_STUB_VERSION: u32 = 1829;
pub const RPC_X_INVALID_PIPE_OBJECT: u32 = 1830;
pub const RPC_X_WRONG_PIPE_ORDER: u32 = 1831;
pub const RPC_X_WRONG_PIPE_VERSION: u32 = 1832;
pub const RPC_S_COOKIE_AUTH_FAILED: u32 = 1833;
pub const RPC_S_DO_NOT_DISTURB: u32 = 1834;
pub const RPC_S_SYSTEM_HANDLE_COUNT_EXCEEDED: u32 = 1835;
pub const RPC_S_SYSTEM_HANDLE_TYPE_MISMATCH: u32 = 1836;
pub const RPC_S_GROUP_MEMBER_NOT_FOUND: u32 = 1898;
pub const EPT_S_CANT_CREATE: u32 = 1899;
pub const RPC_S_INVALID_OBJECT: u32 = 1900;
pub const ERROR_INVALID_TIME: u32 = 1901;
pub const ERROR_INVALID_FORM_NAME: u32 = 1902;
pub const ERROR_INVALID_FORM_SIZE: u32 = 1903;
pub const ERROR_ALREADY_WAITING: u32 = 1904;
pub const ERROR_PRINTER_DELETED: u32 = 1905;
pub const ERROR_INVALID_PRINTER_STATE: u32 = 1906;
pub const ERROR_PASSWORD_MUST_CHANGE: u32 = 1907;
pub const ERROR_DOMAIN_CONTROLLER_NOT_FOUND: u32 = 1908;
pub const ERROR_ACCOUNT_LOCKED_OUT: u32 = 1909;
pub const OR_INVALID_OXID: u32 = 1910;
pub const OR_INVALID_OID: u32 = 1911;
pub const OR_INVALID_SET: u32 = 1912;
pub const RPC_S_SEND_INCOMPLETE: u32 = 1913;
pub const RPC_S_INVALID_ASYNC_HANDLE: u32 = 1914;
pub const RPC_S_INVALID_ASYNC_CALL: u32 = 1915;
pub const RPC_X_PIPE_CLOSED: u32 = 1916;
pub const RPC_X_PIPE_DISCIPLINE_ERROR: u32 = 1917;
pub const RPC_X_PIPE_EMPTY: u32 = 1918;
pub const ERROR_NO_SITENAME: u32 = 1919;
pub const ERROR_CANT_ACCESS_FILE: u32 = 1920;
pub const ERROR_CANT_RESOLVE_FILENAME: u32 = 1921;
pub const RPC_S_ENTRY_TYPE_MISMATCH: u32 = 1922;
pub const RPC_S_NOT_ALL_OBJS_EXPORTED: u32 = 1923;
pub const RPC_S_INTERFACE_NOT_EXPORTED: u32 = 1924;
pub const RPC_S_PROFILE_NOT_ADDED: u32 = 1925;
pub const RPC_S_PRF_ELT_NOT_ADDED: u32 = 1926;
pub const RPC_S_PRF_ELT_NOT_REMOVED: u32 = 1927;
pub const RPC_S_GRP_ELT_NOT_ADDED: u32 = 1928;
pub const RPC_S_GRP_ELT_NOT_REMOVED: u32 = 1929;
pub const ERROR_KM_DRIVER_BLOCKED: u32 = 1930;
pub const ERROR_CONTEXT_EXPIRED: u32 = 1931;
pub const ERROR_PER_USER_TRUST_QUOTA_EXCEEDED: u32 = 1932;
pub const ERROR_ALL_USER_TRUST_QUOTA_EXCEEDED: u32 = 1933;
pub const ERROR_USER_DELETE_TRUST_QUOTA_EXCEEDED: u32 = 1934;
pub const ERROR_AUTHENTICATION_FIREWALL_FAILED: u32 = 1935;
pub const ERROR_REMOTE_PRINT_CONNECTIONS_BLOCKED: u32 = 1936;
pub const ERROR_NTLM_BLOCKED: u32 = 1937;
pub const ERROR_PASSWORD_CHANGE_REQUIRED: u32 = 1938;
pub const ERROR_LOST_MODE_LOGON_RESTRICTION: u32 = 1939;
pub const ERROR_INVALID_PIXEL_FORMAT: u32 = 2000;
pub const ERROR_BAD_DRIVER: u32 = 2001;
pub const ERROR_INVALID_WINDOW_STYLE: u32 = 2002;
pub const ERROR_METAFILE_NOT_SUPPORTED: u32 = 2003;
pub const ERROR_TRANSFORM_NOT_SUPPORTED: u32 = 2004;
pub const ERROR_CLIPPING_NOT_SUPPORTED: u32 = 2005;
pub const ERROR_INVALID_CMM: u32 = 2010;
pub const ERROR_INVALID_PROFILE: u32 = 2011;
pub const ERROR_TAG_NOT_FOUND: u32 = 2012;
pub const ERROR_TAG_NOT_PRESENT: u32 = 2013;
pub const ERROR_DUPLICATE_TAG: u32 = 2014;
pub const ERROR_PROFILE_NOT_ASSOCIATED_WITH_DEVICE: u32 = 2015;
pub const ERROR_PROFILE_NOT_FOUND: u32 = 2016;
pub const ERROR_INVALID_COLORSPACE: u32 = 2017;
pub const ERROR_ICM_NOT_ENABLED: u32 = 2018;
pub const ERROR_DELETING_ICM_XFORM: u32 = 2019;
pub const ERROR_INVALID_TRANSFORM: u32 = 2020;
pub const ERROR_COLORSPACE_MISMATCH: u32 = 2021;
pub const ERROR_INVALID_COLORINDEX: u32 = 2022;
pub const ERROR_PROFILE_DOES_NOT_MATCH_DEVICE: u32 = 2023;
pub const ERROR_CONNECTED_OTHER_PASSWORD: u32 = 2108;
pub const ERROR_CONNECTED_OTHER_PASSWORD_DEFAULT: u32 = 2109;
pub const ERROR_BAD_USERNAME: u32 = 2202;
pub const ERROR_NOT_CONNECTED: u32 = 2250;
pub const ERROR_OPEN_FILES: u32 = 2401;
pub const ERROR_ACTIVE_CONNECTIONS: u32 = 2402;
pub const ERROR_DEVICE_IN_USE: u32 = 2404;
pub const ERROR_UNKNOWN_PRINT_MONITOR: u32 = 3000;
pub const ERROR_PRINTER_DRIVER_IN_USE: u32 = 3001;
pub const ERROR_SPOOL_FILE_NOT_FOUND: u32 = 3002;
pub const ERROR_SPL_NO_STARTDOC: u32 = 3003;
pub const ERROR_SPL_NO_ADDJOB: u32 = 3004;
pub const ERROR_PRINT_PROCESSOR_ALREADY_INSTALLED: u32 = 3005;
pub const ERROR_PRINT_MONITOR_ALREADY_INSTALLED: u32 = 3006;
pub const ERROR_INVALID_PRINT_MONITOR: u32 = 3007;
pub const ERROR_PRINT_MONITOR_IN_USE: u32 = 3008;
pub const ERROR_PRINTER_HAS_JOBS_QUEUED: u32 = 3009;
pub const ERROR_SUCCESS_REBOOT_REQUIRED: u32 = 3010;
pub const ERROR_SUCCESS_RESTART_REQUIRED: u32 = 3011;
pub const ERROR_PRINTER_NOT_FOUND: u32 = 3012;
pub const ERROR_PRINTER_DRIVER_WARNED: u32 = 3013;
pub const ERROR_PRINTER_DRIVER_BLOCKED: u32 = 3014;
pub const ERROR_PRINTER_DRIVER_PACKAGE_IN_USE: u32 = 3015;
pub const ERROR_CORE_DRIVER_PACKAGE_NOT_FOUND: u32 = 3016;
pub const ERROR_FAIL_REBOOT_REQUIRED: u32 = 3017;
pub const ERROR_FAIL_REBOOT_INITIATED: u32 = 3018;
pub const ERROR_PRINTER_DRIVER_DOWNLOAD_NEEDED: u32 = 3019;
pub const ERROR_PRINT_JOB_RESTART_REQUIRED: u32 = 3020;
pub const ERROR_INVALID_PRINTER_DRIVER_MANIFEST: u32 = 3021;
pub const ERROR_PRINTER_NOT_SHAREABLE: u32 = 3022;
pub const ERROR_REQUEST_PAUSED: u32 = 3050;
pub const ERROR_APPEXEC_CONDITION_NOT_SATISFIED: u32 = 3060;
pub const ERROR_APPEXEC_HANDLE_INVALIDATED: u32 = 3061;
pub const ERROR_APPEXEC_INVALID_HOST_GENERATION: u32 = 3062;
pub const ERROR_APPEXEC_UNEXPECTED_PROCESS_REGISTRATION: u32 = 3063;
pub const ERROR_APPEXEC_INVALID_HOST_STATE: u32 = 3064;
pub const ERROR_APPEXEC_NO_DONOR: u32 = 3065;
pub const ERROR_APPEXEC_HOST_ID_MISMATCH: u32 = 3066;
pub const ERROR_APPEXEC_UNKNOWN_USER: u32 = 3067;
pub const ERROR_APPEXEC_APP_COMPAT_BLOCK: u32 = 3068;
pub const ERROR_APPEXEC_CALLER_WAIT_TIMEOUT: u32 = 3069;
pub const ERROR_APPEXEC_CALLER_WAIT_TIMEOUT_TERMINATION: u32 = 3070;
pub const ERROR_APPEXEC_CALLER_WAIT_TIMEOUT_LICENSING: u32 = 3071;
pub const ERROR_APPEXEC_CALLER_WAIT_TIMEOUT_RESOURCES: u32 = 3072;
pub const ERROR_VRF_VOLATILE_CFG_AND_IO_ENABLED: u32 = 3080;
pub const ERROR_VRF_VOLATILE_NOT_STOPPABLE: u32 = 3081;
pub const ERROR_VRF_VOLATILE_SAFE_MODE: u32 = 3082;
pub const ERROR_VRF_VOLATILE_NOT_RUNNABLE_SYSTEM: u32 = 3083;
pub const ERROR_VRF_VOLATILE_NOT_SUPPORTED_RULECLASS: u32 = 3084;
pub const ERROR_VRF_VOLATILE_PROTECTED_DRIVER: u32 = 3085;
pub const ERROR_VRF_VOLATILE_NMI_REGISTERED: u32 = 3086;
pub const ERROR_VRF_VOLATILE_SETTINGS_CONFLICT: u32 = 3087;
pub const ERROR_DIF_IOCALLBACK_NOT_REPLACED: u32 = 3190;
pub const ERROR_DIF_LIVEDUMP_LIMIT_EXCEEDED: u32 = 3191;
pub const ERROR_DIF_VOLATILE_SECTION_NOT_LOCKED: u32 = 3192;
pub const ERROR_DIF_VOLATILE_DRIVER_HOTPATCHED: u32 = 3193;
pub const ERROR_DIF_VOLATILE_INVALID_INFO: u32 = 3194;
pub const ERROR_DIF_VOLATILE_DRIVER_IS_NOT_RUNNING: u32 = 3195;
pub const ERROR_DIF_VOLATILE_PLUGIN_IS_NOT_RUNNING: u32 = 3196;
pub const ERROR_DIF_VOLATILE_PLUGIN_CHANGE_NOT_ALLOWED: u32 = 3197;
pub const ERROR_DIF_VOLATILE_NOT_ALLOWED: u32 = 3198;
pub const ERROR_DIF_BINDING_API_NOT_FOUND: u32 = 3199;
pub const ERROR_IO_REISSUE_AS_CACHED: u32 = 3950;
pub const ERROR_WINS_INTERNAL: u32 = 4000;
pub const ERROR_CAN_NOT_DEL_LOCAL_WINS: u32 = 4001;
pub const ERROR_STATIC_INIT: u32 = 4002;
pub const ERROR_INC_BACKUP: u32 = 4003;
pub const ERROR_FULL_BACKUP: u32 = 4004;
pub const ERROR_REC_NON_EXISTENT: u32 = 4005;
pub const ERROR_RPL_NOT_ALLOWED: u32 = 4006;
pub const PEERDIST_ERROR_CONTENTINFO_VERSION_UNSUPPORTED: u32 = 4050;
pub const PEERDIST_ERROR_CANNOT_PARSE_CONTENTINFO: u32 = 4051;
pub const PEERDIST_ERROR_MISSING_DATA: u32 = 4052;
pub const PEERDIST_ERROR_NO_MORE: u32 = 4053;
pub const PEERDIST_ERROR_NOT_INITIALIZED: u32 = 4054;
pub const PEERDIST_ERROR_ALREADY_INITIALIZED: u32 = 4055;
pub const PEERDIST_ERROR_SHUTDOWN_IN_PROGRESS: u32 = 4056;
pub const PEERDIST_ERROR_INVALIDATED: u32 = 4057;
pub const PEERDIST_ERROR_ALREADY_EXISTS: u32 = 4058;
pub const PEERDIST_ERROR_OPERATION_NOTFOUND: u32 = 4059;
pub const PEERDIST_ERROR_ALREADY_COMPLETED: u32 = 4060;
pub const PEERDIST_ERROR_OUT_OF_BOUNDS: u32 = 4061;
pub const PEERDIST_ERROR_VERSION_UNSUPPORTED: u32 = 4062;
pub const PEERDIST_ERROR_INVALID_CONFIGURATION: u32 = 4063;
pub const PEERDIST_ERROR_NOT_LICENSED: u32 = 4064;
pub const PEERDIST_ERROR_SERVICE_UNAVAILABLE: u32 = 4065;
pub const PEERDIST_ERROR_TRUST_FAILURE: u32 = 4066;
pub const ERROR_DHCP_ADDRESS_CONFLICT: u32 = 4100;
pub const ERROR_WMI_GUID_NOT_FOUND: u32 = 4200;
pub const ERROR_WMI_INSTANCE_NOT_FOUND: u32 = 4201;
pub const ERROR_WMI_ITEMID_NOT_FOUND: u32 = 4202;
pub const ERROR_WMI_TRY_AGAIN: u32 = 4203;
pub const ERROR_WMI_DP_NOT_FOUND: u32 = 4204;
pub const ERROR_WMI_UNRESOLVED_INSTANCE_REF: u32 = 4205;
pub const ERROR_WMI_ALREADY_ENABLED: u32 = 4206;
pub const ERROR_WMI_GUID_DISCONNECTED: u32 = 4207;
pub const ERROR_WMI_SERVER_UNAVAILABLE: u32 = 4208;
pub const ERROR_WMI_DP_FAILED: u32 = 4209;
pub const ERROR_WMI_INVALID_MOF: u32 = 4210;
pub const ERROR_WMI_INVALID_REGINFO: u32 = 4211;
pub const ERROR_WMI_ALREADY_DISABLED: u32 = 4212;
pub const ERROR_WMI_READ_ONLY: u32 = 4213;
pub const ERROR_WMI_SET_FAILURE: u32 = 4214;
pub const ERROR_NOT_APPCONTAINER: u32 = 4250;
pub const ERROR_APPCONTAINER_REQUIRED: u32 = 4251;
pub const ERROR_NOT_SUPPORTED_IN_APPCONTAINER: u32 = 4252;
pub const ERROR_INVALID_PACKAGE_SID_LENGTH: u32 = 4253;
pub const ERROR_INVALID_MEDIA: u32 = 4300;
pub const ERROR_INVALID_LIBRARY: u32 = 4301;
pub const ERROR_INVALID_MEDIA_POOL: u32 = 4302;
pub const ERROR_DRIVE_MEDIA_MISMATCH: u32 = 4303;
pub const ERROR_MEDIA_OFFLINE: u32 = 4304;
pub const ERROR_LIBRARY_OFFLINE: u32 = 4305;
pub const ERROR_EMPTY: u32 = 4306;
pub const ERROR_NOT_EMPTY: u32 = 4307;
pub const ERROR_MEDIA_UNAVAILABLE: u32 = 4308;
pub const ERROR_RESOURCE_DISABLED: u32 = 4309;
pub const ERROR_INVALID_CLEANER: u32 = 4310;
pub const ERROR_UNABLE_TO_CLEAN: u32 = 4311;
pub const ERROR_OBJECT_NOT_FOUND: u32 = 4312;
pub const ERROR_DATABASE_FAILURE: u32 = 4313;
pub const ERROR_DATABASE_FULL: u32 = 4314;
pub const ERROR_MEDIA_INCOMPATIBLE: u32 = 4315;
pub const ERROR_RESOURCE_NOT_PRESENT: u32 = 4316;
pub const ERROR_INVALID_OPERATION: u32 = 4317;
pub const ERROR_MEDIA_NOT_AVAILABLE: u32 = 4318;
pub const ERROR_DEVICE_NOT_AVAILABLE: u32 = 4319;
pub const ERROR_REQUEST_REFUSED: u32 = 4320;
pub const ERROR_INVALID_DRIVE_OBJECT: u32 = 4321;
pub const ERROR_LIBRARY_FULL: u32 = 4322;
pub const ERROR_MEDIUM_NOT_ACCESSIBLE: u32 = 4323;
pub const ERROR_UNABLE_TO_LOAD_MEDIUM: u32 = 4324;
pub const ERROR_UNABLE_TO_INVENTORY_DRIVE: u32 = 4325;
pub const ERROR_UNABLE_TO_INVENTORY_SLOT: u32 = 4326;
pub const ERROR_UNABLE_TO_INVENTORY_TRANSPORT: u32 = 4327;
pub const ERROR_TRANSPORT_FULL: u32 = 4328;
pub const ERROR_CONTROLLING_IEPORT: u32 = 4329;
pub const ERROR_UNABLE_TO_EJECT_MOUNTED_MEDIA: u32 = 4330;
pub const ERROR_CLEANER_SLOT_SET: u32 = 4331;
pub const ERROR_CLEANER_SLOT_NOT_SET: u32 = 4332;
pub const ERROR_CLEANER_CARTRIDGE_SPENT: u32 = 4333;
pub const ERROR_UNEXPECTED_OMID: u32 = 4334;
pub const ERROR_CANT_DELETE_LAST_ITEM: u32 = 4335;
pub const ERROR_MESSAGE_EXCEEDS_MAX_SIZE: u32 = 4336;
pub const ERROR_VOLUME_CONTAINS_SYS_FILES: u32 = 4337;
pub const ERROR_INDIGENOUS_TYPE: u32 = 4338;
pub const ERROR_NO_SUPPORTING_DRIVES: u32 = 4339;
pub const ERROR_CLEANER_CARTRIDGE_INSTALLED: u32 = 4340;
pub const ERROR_IEPORT_FULL: u32 = 4341;
pub const ERROR_FILE_OFFLINE: u32 = 4350;
pub const ERROR_REMOTE_STORAGE_NOT_ACTIVE: u32 = 4351;
pub const ERROR_REMOTE_STORAGE_MEDIA_ERROR: u32 = 4352;
pub const ERROR_NOT_A_REPARSE_POINT: u32 = 4390;
pub const ERROR_REPARSE_ATTRIBUTE_CONFLICT: u32 = 4391;
pub const ERROR_INVALID_REPARSE_DATA: u32 = 4392;
pub const ERROR_REPARSE_TAG_INVALID: u32 = 4393;
pub const ERROR_REPARSE_TAG_MISMATCH: u32 = 4394;
pub const ERROR_REPARSE_POINT_ENCOUNTERED: u32 = 4395;
pub const ERROR_APP_DATA_NOT_FOUND: u32 = 4400;
pub const ERROR_APP_DATA_EXPIRED: u32 = 4401;
pub const ERROR_APP_DATA_CORRUPT: u32 = 4402;
pub const ERROR_APP_DATA_LIMIT_EXCEEDED: u32 = 4403;
pub const ERROR_APP_DATA_REBOOT_REQUIRED: u32 = 4404;
pub const ERROR_SECUREBOOT_ROLLBACK_DETECTED: u32 = 4420;
pub const ERROR_SECUREBOOT_POLICY_VIOLATION: u32 = 4421;
pub const ERROR_SECUREBOOT_INVALID_POLICY: u32 = 4422;
pub const ERROR_SECUREBOOT_POLICY_PUBLISHER_NOT_FOUND: u32 = 4423;
pub const ERROR_SECUREBOOT_POLICY_NOT_SIGNED: u32 = 4424;
pub const ERROR_SECUREBOOT_NOT_ENABLED: u32 = 4425;
pub const ERROR_SECUREBOOT_FILE_REPLACED: u32 = 4426;
pub const ERROR_SECUREBOOT_POLICY_NOT_AUTHORIZED: u32 = 4427;
pub const ERROR_SECUREBOOT_POLICY_UNKNOWN: u32 = 4428;
pub const ERROR_SECUREBOOT_POLICY_MISSING_ANTIROLLBACKVERSION: u32 = 4429;
pub const ERROR_SECUREBOOT_PLATFORM_ID_MISMATCH: u32 = 4430;
pub const ERROR_SECUREBOOT_POLICY_ROLLBACK_DETECTED: u32 = 4431;
pub const ERROR_SECUREBOOT_POLICY_UPGRADE_MISMATCH: u32 = 4432;
pub const ERROR_SECUREBOOT_REQUIRED_POLICY_FILE_MISSING: u32 = 4433;
pub const ERROR_SECUREBOOT_NOT_BASE_POLICY: u32 = 4434;
pub const ERROR_SECUREBOOT_NOT_SUPPLEMENTAL_POLICY: u32 = 4435;
pub const ERROR_OFFLOAD_READ_FLT_NOT_SUPPORTED: u32 = 4440;
pub const ERROR_OFFLOAD_WRITE_FLT_NOT_SUPPORTED: u32 = 4441;
pub const ERROR_OFFLOAD_READ_FILE_NOT_SUPPORTED: u32 = 4442;
pub const ERROR_OFFLOAD_WRITE_FILE_NOT_SUPPORTED: u32 = 4443;
pub const ERROR_ALREADY_HAS_STREAM_ID: u32 = 4444;
pub const ERROR_SMR_GARBAGE_COLLECTION_REQUIRED: u32 = 4445;
pub const ERROR_WOF_WIM_HEADER_CORRUPT: u32 = 4446;
pub const ERROR_WOF_WIM_RESOURCE_TABLE_CORRUPT: u32 = 4447;
pub const ERROR_WOF_FILE_RESOURCE_TABLE_CORRUPT: u32 = 4448;
pub const ERROR_OBJECT_IS_IMMUTABLE: u32 = 4449;
pub const ERROR_VOLUME_NOT_SIS_ENABLED: u32 = 4500;
pub const ERROR_SYSTEM_INTEGRITY_ROLLBACK_DETECTED: u32 = 4550;
pub const ERROR_SYSTEM_INTEGRITY_POLICY_VIOLATION: u32 = 4551;
pub const ERROR_SYSTEM_INTEGRITY_INVALID_POLICY: u32 = 4552;
pub const ERROR_SYSTEM_INTEGRITY_POLICY_NOT_SIGNED: u32 = 4553;
pub const ERROR_SYSTEM_INTEGRITY_TOO_MANY_POLICIES: u32 = 4554;
pub const ERROR_SYSTEM_INTEGRITY_SUPPLEMENTAL_POLICY_NOT_AUTHORIZED: u32 = 4555;
pub const ERROR_SYSTEM_INTEGRITY_REPUTATION_MALICIOUS: u32 = 4556;
pub const ERROR_SYSTEM_INTEGRITY_REPUTATION_PUA: u32 = 4557;
pub const ERROR_SYSTEM_INTEGRITY_REPUTATION_DANGEROUS_EXT: u32 = 4558;
pub const ERROR_SYSTEM_INTEGRITY_REPUTATION_OFFLINE: u32 = 4559;
pub const ERROR_VSM_NOT_INITIALIZED: u32 = 4560;
pub const ERROR_VSM_DMA_PROTECTION_NOT_IN_USE: u32 = 4561;
pub const ERROR_PLATFORM_MANIFEST_NOT_AUTHORIZED: u32 = 4570;
pub const ERROR_PLATFORM_MANIFEST_INVALID: u32 = 4571;
pub const ERROR_PLATFORM_MANIFEST_FILE_NOT_AUTHORIZED: u32 = 4572;
pub const ERROR_PLATFORM_MANIFEST_CATALOG_NOT_AUTHORIZED: u32 = 4573;
pub const ERROR_PLATFORM_MANIFEST_BINARY_ID_NOT_FOUND: u32 = 4574;
pub const ERROR_PLATFORM_MANIFEST_NOT_ACTIVE: u32 = 4575;
pub const ERROR_PLATFORM_MANIFEST_NOT_SIGNED: u32 = 4576;
pub const ERROR_DEPENDENT_RESOURCE_EXISTS: u32 = 5001;
pub const ERROR_DEPENDENCY_NOT_FOUND: u32 = 5002;
pub const ERROR_DEPENDENCY_ALREADY_EXISTS: u32 = 5003;
pub const ERROR_RESOURCE_NOT_ONLINE: u32 = 5004;
pub const ERROR_HOST_NODE_NOT_AVAILABLE: u32 = 5005;
pub const ERROR_RESOURCE_NOT_AVAILABLE: u32 = 5006;
pub const ERROR_RESOURCE_NOT_FOUND: u32 = 5007;
pub const ERROR_SHUTDOWN_CLUSTER: u32 = 5008;
pub const ERROR_CANT_EVICT_ACTIVE_NODE: u32 = 5009;
pub const ERROR_OBJECT_ALREADY_EXISTS: u32 = 5010;
pub const ERROR_OBJECT_IN_LIST: u32 = 5011;
pub const ERROR_GROUP_NOT_AVAILABLE: u32 = 5012;
pub const ERROR_GROUP_NOT_FOUND: u32 = 5013;
pub const ERROR_GROUP_NOT_ONLINE: u32 = 5014;
pub const ERROR_HOST_NODE_NOT_RESOURCE_OWNER: u32 = 5015;
pub const ERROR_HOST_NODE_NOT_GROUP_OWNER: u32 = 5016;
pub const ERROR_RESMON_CREATE_FAILED: u32 = 5017;
pub const ERROR_RESMON_ONLINE_FAILED: u32 = 5018;
pub const ERROR_RESOURCE_ONLINE: u32 = 5019;
pub const ERROR_QUORUM_RESOURCE: u32 = 5020;
pub const ERROR_NOT_QUORUM_CAPABLE: u32 = 5021;
pub const ERROR_CLUSTER_SHUTTING_DOWN: u32 = 5022;
pub const ERROR_INVALID_STATE: u32 = 5023;
pub const ERROR_RESOURCE_PROPERTIES_STORED: u32 = 5024;
pub const ERROR_NOT_QUORUM_CLASS: u32 = 5025;
pub const ERROR_CORE_RESOURCE: u32 = 5026;
pub const ERROR_QUORUM_RESOURCE_ONLINE_FAILED: u32 = 5027;
pub const ERROR_QUORUMLOG_OPEN_FAILED: u32 = 5028;
pub const ERROR_CLUSTERLOG_CORRUPT: u32 = 5029;
pub const ERROR_CLUSTERLOG_RECORD_EXCEEDS_MAXSIZE: u32 = 5030;
pub const ERROR_CLUSTERLOG_EXCEEDS_MAXSIZE: u32 = 5031;
pub const ERROR_CLUSTERLOG_CHKPOINT_NOT_FOUND: u32 = 5032;
pub const ERROR_CLUSTERLOG_NOT_ENOUGH_SPACE: u32 = 5033;
pub const ERROR_QUORUM_OWNER_ALIVE: u32 = 5034;
pub const ERROR_NETWORK_NOT_AVAILABLE: u32 = 5035;
pub const ERROR_NODE_NOT_AVAILABLE: u32 = 5036;
pub const ERROR_ALL_NODES_NOT_AVAILABLE: u32 = 5037;
pub const ERROR_RESOURCE_FAILED: u32 = 5038;
pub const ERROR_CLUSTER_INVALID_NODE: u32 = 5039;
pub const ERROR_CLUSTER_NODE_EXISTS: u32 = 5040;
pub const ERROR_CLUSTER_JOIN_IN_PROGRESS: u32 = 5041;
pub const ERROR_CLUSTER_NODE_NOT_FOUND: u32 = 5042;
pub const ERROR_CLUSTER_LOCAL_NODE_NOT_FOUND: u32 = 5043;
pub const ERROR_CLUSTER_NETWORK_EXISTS: u32 = 5044;
pub const ERROR_CLUSTER_NETWORK_NOT_FOUND: u32 = 5045;
pub const ERROR_CLUSTER_NETINTERFACE_EXISTS: u32 = 5046;
pub const ERROR_CLUSTER_NETINTERFACE_NOT_FOUND: u32 = 5047;
pub const ERROR_CLUSTER_INVALID_REQUEST: u32 = 5048;
pub const ERROR_CLUSTER_INVALID_NETWORK_PROVIDER: u32 = 5049;
pub const ERROR_CLUSTER_NODE_DOWN: u32 = 5050;
pub const ERROR_CLUSTER_NODE_UNREACHABLE: u32 = 5051;
pub const ERROR_CLUSTER_NODE_NOT_MEMBER: u32 = 5052;
pub const ERROR_CLUSTER_JOIN_NOT_IN_PROGRESS: u32 = 5053;
pub const ERROR_CLUSTER_INVALID_NETWORK: u32 = 5054;
pub const ERROR_CLUSTER_NODE_UP: u32 = 5056;
pub const ERROR_CLUSTER_IPADDR_IN_USE: u32 = 5057;
pub const ERROR_CLUSTER_NODE_NOT_PAUSED: u32 = 5058;
pub const ERROR_CLUSTER_NO_SECURITY_CONTEXT: u32 = 5059;
pub const ERROR_CLUSTER_NETWORK_NOT_INTERNAL: u32 = 5060;
pub const ERROR_CLUSTER_NODE_ALREADY_UP: u32 = 5061;
pub const ERROR_CLUSTER_NODE_ALREADY_DOWN: u32 = 5062;
pub const ERROR_CLUSTER_NETWORK_ALREADY_ONLINE: u32 = 5063;
pub const ERROR_CLUSTER_NETWORK_ALREADY_OFFLINE: u32 = 5064;
pub const ERROR_CLUSTER_NODE_ALREADY_MEMBER: u32 = 5065;
pub const ERROR_CLUSTER_LAST_INTERNAL_NETWORK: u32 = 5066;
pub const ERROR_CLUSTER_NETWORK_HAS_DEPENDENTS: u32 = 5067;
pub const ERROR_INVALID_OPERATION_ON_QUORUM: u32 = 5068;
pub const ERROR_DEPENDENCY_NOT_ALLOWED: u32 = 5069;
pub const ERROR_CLUSTER_NODE_PAUSED: u32 = 5070;
pub const ERROR_NODE_CANT_HOST_RESOURCE: u32 = 5071;
pub const ERROR_CLUSTER_NODE_NOT_READY: u32 = 5072;
pub const ERROR_CLUSTER_NODE_SHUTTING_DOWN: u32 = 5073;
pub const ERROR_CLUSTER_JOIN_ABORTED: u32 = 5074;
pub const ERROR_CLUSTER_INCOMPATIBLE_VERSIONS: u32 = 5075;
pub const ERROR_CLUSTER_MAXNUM_OF_RESOURCES_EXCEEDED: u32 = 5076;
pub const ERROR_CLUSTER_SYSTEM_CONFIG_CHANGED: u32 = 5077;
pub const ERROR_CLUSTER_RESOURCE_TYPE_NOT_FOUND: u32 = 5078;
pub const ERROR_CLUSTER_RESTYPE_NOT_SUPPORTED: u32 = 5079;
pub const ERROR_CLUSTER_RESNAME_NOT_FOUND: u32 = 5080;
pub const ERROR_CLUSTER_NO_RPC_PACKAGES_REGISTERED: u32 = 5081;
pub const ERROR_CLUSTER_OWNER_NOT_IN_PREFLIST: u32 = 5082;
pub const ERROR_CLUSTER_DATABASE_SEQMISMATCH: u32 = 5083;
pub const ERROR_RESMON_INVALID_STATE: u32 = 5084;
pub const ERROR_CLUSTER_GUM_NOT_LOCKER: u32 = 5085;
pub const ERROR_QUORUM_DISK_NOT_FOUND: u32 = 5086;
pub const ERROR_DATABASE_BACKUP_CORRUPT: u32 = 5087;
pub const ERROR_CLUSTER_NODE_ALREADY_HAS_DFS_ROOT: u32 = 5088;
pub const ERROR_RESOURCE_PROPERTY_UNCHANGEABLE: u32 = 5089;
pub const ERROR_NO_ADMIN_ACCESS_POINT: u32 = 5090;
pub const ERROR_CLUSTER_MEMBERSHIP_INVALID_STATE: u32 = 5890;
pub const ERROR_CLUSTER_QUORUMLOG_NOT_FOUND: u32 = 5891;
pub const ERROR_CLUSTER_MEMBERSHIP_HALT: u32 = 5892;
pub const ERROR_CLUSTER_INSTANCE_ID_MISMATCH: u32 = 5893;
pub const ERROR_CLUSTER_NETWORK_NOT_FOUND_FOR_IP: u32 = 5894;
pub const ERROR_CLUSTER_PROPERTY_DATA_TYPE_MISMATCH: u32 = 5895;
pub const ERROR_CLUSTER_EVICT_WITHOUT_CLEANUP: u32 = 5896;
pub const ERROR_CLUSTER_PARAMETER_MISMATCH: u32 = 5897;
pub const ERROR_NODE_CANNOT_BE_CLUSTERED: u32 = 5898;
pub const ERROR_CLUSTER_WRONG_OS_VERSION: u32 = 5899;
pub const ERROR_CLUSTER_CANT_CREATE_DUP_CLUSTER_NAME: u32 = 5900;
pub const ERROR_CLUSCFG_ALREADY_COMMITTED: u32 = 5901;
pub const ERROR_CLUSCFG_ROLLBACK_FAILED: u32 = 5902;
pub const ERROR_CLUSCFG_SYSTEM_DISK_DRIVE_LETTER_CONFLICT: u32 = 5903;
pub const ERROR_CLUSTER_OLD_VERSION: u32 = 5904;
pub const ERROR_CLUSTER_MISMATCHED_COMPUTER_ACCT_NAME: u32 = 5905;
pub const ERROR_CLUSTER_NO_NET_ADAPTERS: u32 = 5906;
pub const ERROR_CLUSTER_POISONED: u32 = 5907;
pub const ERROR_CLUSTER_GROUP_MOVING: u32 = 5908;
pub const ERROR_CLUSTER_RESOURCE_TYPE_BUSY: u32 = 5909;
pub const ERROR_RESOURCE_CALL_TIMED_OUT: u32 = 5910;
pub const ERROR_INVALID_CLUSTER_IPV6_ADDRESS: u32 = 5911;
pub const ERROR_CLUSTER_INTERNAL_INVALID_FUNCTION: u32 = 5912;
pub const ERROR_CLUSTER_PARAMETER_OUT_OF_BOUNDS: u32 = 5913;
pub const ERROR_CLUSTER_PARTIAL_SEND: u32 = 5914;
pub const ERROR_CLUSTER_REGISTRY_INVALID_FUNCTION: u32 = 5915;
pub const ERROR_CLUSTER_INVALID_STRING_TERMINATION: u32 = 5916;
pub const ERROR_CLUSTER_INVALID_STRING_FORMAT: u32 = 5917;
pub const ERROR_CLUSTER_DATABASE_TRANSACTION_IN_PROGRESS: u32 = 5918;
pub const ERROR_CLUSTER_DATABASE_TRANSACTION_NOT_IN_PROGRESS: u32 = 5919;
pub const ERROR_CLUSTER_NULL_DATA: u32 = 5920;
pub const ERROR_CLUSTER_PARTIAL_READ: u32 = 5921;
pub const ERROR_CLUSTER_PARTIAL_WRITE: u32 = 5922;
pub const ERROR_CLUSTER_CANT_DESERIALIZE_DATA: u32 = 5923;
pub const ERROR_DEPENDENT_RESOURCE_PROPERTY_CONFLICT: u32 = 5924;
pub const ERROR_CLUSTER_NO_QUORUM: u32 = 5925;
pub const ERROR_CLUSTER_INVALID_IPV6_NETWORK: u32 = 5926;
pub const ERROR_CLUSTER_INVALID_IPV6_TUNNEL_NETWORK: u32 = 5927;
pub const ERROR_QUORUM_NOT_ALLOWED_IN_THIS_GROUP: u32 = 5928;
pub const ERROR_DEPENDENCY_TREE_TOO_COMPLEX: u32 = 5929;
pub const ERROR_EXCEPTION_IN_RESOURCE_CALL: u32 = 5930;
pub const ERROR_CLUSTER_RHS_FAILED_INITIALIZATION: u32 = 5931;
pub const ERROR_CLUSTER_NOT_INSTALLED: u32 = 5932;
pub const ERROR_CLUSTER_RESOURCES_MUST_BE_ONLINE_ON_THE_SAME_NODE: u32 = 5933;
pub const ERROR_CLUSTER_MAX_NODES_IN_CLUSTER: u32 = 5934;
pub const ERROR_CLUSTER_TOO_MANY_NODES: u32 = 5935;
pub const ERROR_CLUSTER_OBJECT_ALREADY_USED: u32 = 5936;
pub const ERROR_NONCORE_GROUPS_FOUND: u32 = 5937;
pub const ERROR_FILE_SHARE_RESOURCE_CONFLICT: u32 = 5938;
pub const ERROR_CLUSTER_EVICT_INVALID_REQUEST: u32 = 5939;
pub const ERROR_CLUSTER_SINGLETON_RESOURCE: u32 = 5940;
pub const ERROR_CLUSTER_GROUP_SINGLETON_RESOURCE: u32 = 5941;
pub const ERROR_CLUSTER_RESOURCE_PROVIDER_FAILED: u32 = 5942;
pub const ERROR_CLUSTER_RESOURCE_CONFIGURATION_ERROR: u32 = 5943;
pub const ERROR_CLUSTER_GROUP_BUSY: u32 = 5944;
pub const ERROR_CLUSTER_NOT_SHARED_VOLUME: u32 = 5945;
pub const ERROR_CLUSTER_INVALID_SECURITY_DESCRIPTOR: u32 = 5946;
pub const ERROR_CLUSTER_SHARED_VOLUMES_IN_USE: u32 = 5947;
pub const ERROR_CLUSTER_USE_SHARED_VOLUMES_API: u32 = 5948;
pub const ERROR_CLUSTER_BACKUP_IN_PROGRESS: u32 = 5949;
pub const ERROR_NON_CSV_PATH: u32 = 5950;
pub const ERROR_CSV_VOLUME_NOT_LOCAL: u32 = 5951;
pub const ERROR_CLUSTER_WATCHDOG_TERMINATING: u32 = 5952;
pub const ERROR_CLUSTER_RESOURCE_VETOED_MOVE_INCOMPATIBLE_NODES: u32 = 5953;
pub const ERROR_CLUSTER_INVALID_NODE_WEIGHT: u32 = 5954;
pub const ERROR_CLUSTER_RESOURCE_VETOED_CALL: u32 = 5955;
pub const ERROR_RESMON_SYSTEM_RESOURCES_LACKING: u32 = 5956;
pub const ERROR_CLUSTER_RESOURCE_VETOED_MOVE_NOT_ENOUGH_RESOURCES_ON_DESTINATION: u32 = 5957;
pub const ERROR_CLUSTER_RESOURCE_VETOED_MOVE_NOT_ENOUGH_RESOURCES_ON_SOURCE: u32 = 5958;
pub const ERROR_CLUSTER_GROUP_QUEUED: u32 = 5959;
pub const ERROR_CLUSTER_RESOURCE_LOCKED_STATUS: u32 = 5960;
pub const ERROR_CLUSTER_SHARED_VOLUME_FAILOVER_NOT_ALLOWED: u32 = 5961;
pub const ERROR_CLUSTER_NODE_DRAIN_IN_PROGRESS: u32 = 5962;
pub const ERROR_CLUSTER_DISK_NOT_CONNECTED: u32 = 5963;
pub const ERROR_DISK_NOT_CSV_CAPABLE: u32 = 5964;
pub const ERROR_RESOURCE_NOT_IN_AVAILABLE_STORAGE: u32 = 5965;
pub const ERROR_CLUSTER_SHARED_VOLUME_REDIRECTED: u32 = 5966;
pub const ERROR_CLUSTER_SHARED_VOLUME_NOT_REDIRECTED: u32 = 5967;
pub const ERROR_CLUSTER_CANNOT_RETURN_PROPERTIES: u32 = 5968;
pub const ERROR_CLUSTER_RESOURCE_CONTAINS_UNSUPPORTED_DIFF_AREA_FOR_SHARED_VOLUMES: u32 = 5969;
pub const ERROR_CLUSTER_RESOURCE_IS_IN_MAINTENANCE_MODE: u32 = 5970;
pub const ERROR_CLUSTER_AFFINITY_CONFLICT: u32 = 5971;
pub const ERROR_CLUSTER_RESOURCE_IS_REPLICA_VIRTUAL_MACHINE: u32 = 5972;
pub const ERROR_CLUSTER_UPGRADE_INCOMPATIBLE_VERSIONS: u32 = 5973;
pub const ERROR_CLUSTER_UPGRADE_FIX_QUORUM_NOT_SUPPORTED: u32 = 5974;
pub const ERROR_CLUSTER_UPGRADE_RESTART_REQUIRED: u32 = 5975;
pub const ERROR_CLUSTER_UPGRADE_IN_PROGRESS: u32 = 5976;
pub const ERROR_CLUSTER_UPGRADE_INCOMPLETE: u32 = 5977;
pub const ERROR_CLUSTER_NODE_IN_GRACE_PERIOD: u32 = 5978;
pub const ERROR_CLUSTER_CSV_IO_PAUSE_TIMEOUT: u32 = 5979;
pub const ERROR_NODE_NOT_ACTIVE_CLUSTER_MEMBER: u32 = 5980;
pub const ERROR_CLUSTER_RESOURCE_NOT_MONITORED: u32 = 5981;
pub const ERROR_CLUSTER_RESOURCE_DOES_NOT_SUPPORT_UNMONITORED: u32 = 5982;
pub const ERROR_CLUSTER_RESOURCE_IS_REPLICATED: u32 = 5983;
pub const ERROR_CLUSTER_NODE_ISOLATED: u32 = 5984;
pub const ERROR_CLUSTER_NODE_QUARANTINED: u32 = 5985;
pub const ERROR_CLUSTER_DATABASE_UPDATE_CONDITION_FAILED: u32 = 5986;
pub const ERROR_CLUSTER_SPACE_DEGRADED: u32 = 5987;
pub const ERROR_CLUSTER_TOKEN_DELEGATION_NOT_SUPPORTED: u32 = 5988;
pub const ERROR_CLUSTER_CSV_INVALID_HANDLE: u32 = 5989;
pub const ERROR_CLUSTER_CSV_SUPPORTED_ONLY_ON_COORDINATOR: u32 = 5990;
pub const ERROR_GROUPSET_NOT_AVAILABLE: u32 = 5991;
pub const ERROR_GROUPSET_NOT_FOUND: u32 = 5992;
pub const ERROR_GROUPSET_CANT_PROVIDE: u32 = 5993;
pub const ERROR_CLUSTER_FAULT_DOMAIN_PARENT_NOT_FOUND: u32 = 5994;
pub const ERROR_CLUSTER_FAULT_DOMAIN_INVALID_HIERARCHY: u32 = 5995;
pub const ERROR_CLUSTER_FAULT_DOMAIN_FAILED_S2D_VALIDATION: u32 = 5996;
pub const ERROR_CLUSTER_FAULT_DOMAIN_S2D_CONNECTIVITY_LOSS: u32 = 5997;
pub const ERROR_CLUSTER_INVALID_INFRASTRUCTURE_FILESERVER_NAME: u32 = 5998;
pub const ERROR_CLUSTERSET_MANAGEMENT_CLUSTER_UNREACHABLE: u32 = 5999;
pub const ERROR_ENCRYPTION_FAILED: u32 = 6000;
pub const ERROR_DECRYPTION_FAILED: u32 = 6001;
pub const ERROR_FILE_ENCRYPTED: u32 = 6002;
pub const ERROR_NO_RECOVERY_POLICY: u32 = 6003;
pub const ERROR_NO_EFS: u32 = 6004;
pub const ERROR_WRONG_EFS: u32 = 6005;
pub const ERROR_NO_USER_KEYS: u32 = 6006;
pub const ERROR_FILE_NOT_ENCRYPTED: u32 = 6007;
pub const ERROR_NOT_EXPORT_FORMAT: u32 = 6008;
pub const ERROR_FILE_READ_ONLY: u32 = 6009;
pub const ERROR_DIR_EFS_DISALLOWED: u32 = 6010;
pub const ERROR_EFS_SERVER_NOT_TRUSTED: u32 = 6011;
pub const ERROR_BAD_RECOVERY_POLICY: u32 = 6012;
pub const ERROR_EFS_ALG_BLOB_TOO_BIG: u32 = 6013;
pub const ERROR_VOLUME_NOT_SUPPORT_EFS: u32 = 6014;
pub const ERROR_EFS_DISABLED: u32 = 6015;
pub const ERROR_EFS_VERSION_NOT_SUPPORT: u32 = 6016;
pub const ERROR_CS_ENCRYPTION_INVALID_SERVER_RESPONSE: u32 = 6017;
pub const ERROR_CS_ENCRYPTION_UNSUPPORTED_SERVER: u32 = 6018;
pub const ERROR_CS_ENCRYPTION_EXISTING_ENCRYPTED_FILE: u32 = 6019;
pub const ERROR_CS_ENCRYPTION_NEW_ENCRYPTED_FILE: u32 = 6020;
pub const ERROR_CS_ENCRYPTION_FILE_NOT_CSE: u32 = 6021;
pub const ERROR_ENCRYPTION_POLICY_DENIES_OPERATION: u32 = 6022;
pub const ERROR_WIP_ENCRYPTION_FAILED: u32 = 6023;
pub const ERROR_NO_BROWSER_SERVERS_FOUND: u32 = 6118;
pub const SCHED_E_SERVICE_NOT_LOCALSYSTEM: u32 = 6200;
pub const ERROR_CLUSTER_OBJECT_IS_CLUSTER_SET_VM: u32 = 6250;
pub const ERROR_LOG_SECTOR_INVALID: u32 = 6600;
pub const ERROR_LOG_SECTOR_PARITY_INVALID: u32 = 6601;
pub const ERROR_LOG_SECTOR_REMAPPED: u32 = 6602;
pub const ERROR_LOG_BLOCK_INCOMPLETE: u32 = 6603;
pub const ERROR_LOG_INVALID_RANGE: u32 = 6604;
pub const ERROR_LOG_BLOCKS_EXHAUSTED: u32 = 6605;
pub const ERROR_LOG_READ_CONTEXT_INVALID: u32 = 6606;
pub const ERROR_LOG_RESTART_INVALID: u32 = 6607;
pub const ERROR_LOG_BLOCK_VERSION: u32 = 6608;
pub const ERROR_LOG_BLOCK_INVALID: u32 = 6609;
pub const ERROR_LOG_READ_MODE_INVALID: u32 = 6610;
pub const ERROR_LOG_NO_RESTART: u32 = 6611;
pub const ERROR_LOG_METADATA_CORRUPT: u32 = 6612;
pub const ERROR_LOG_METADATA_INVALID: u32 = 6613;
pub const ERROR_LOG_METADATA_INCONSISTENT: u32 = 6614;
pub const ERROR_LOG_RESERVATION_INVALID: u32 = 6615;
pub const ERROR_LOG_CANT_DELETE: u32 = 6616;
pub const ERROR_LOG_CONTAINER_LIMIT_EXCEEDED: u32 = 6617;
pub const ERROR_LOG_START_OF_LOG: u32 = 6618;
pub const ERROR_LOG_POLICY_ALREADY_INSTALLED: u32 = 6619;
pub const ERROR_LOG_POLICY_NOT_INSTALLED: u32 = 6620;
pub const ERROR_LOG_POLICY_INVALID: u32 = 6621;
pub const ERROR_LOG_POLICY_CONFLICT: u32 = 6622;
pub const ERROR_LOG_PINNED_ARCHIVE_TAIL: u32 = 6623;
pub const ERROR_LOG_RECORD_NONEXISTENT: u32 = 6624;
pub const ERROR_LOG_RECORDS_RESERVED_INVALID: u32 = 6625;
pub const ERROR_LOG_SPACE_RESERVED_INVALID: u32 = 6626;
pub const ERROR_LOG_TAIL_INVALID: u32 = 6627;
pub const ERROR_LOG_FULL: u32 = 6628;
pub const ERROR_COULD_NOT_RESIZE_LOG: u32 = 6629;
pub const ERROR_LOG_MULTIPLEXED: u32 = 6630;
pub const ERROR_LOG_DEDICATED: u32 = 6631;
pub const ERROR_LOG_ARCHIVE_NOT_IN_PROGRESS: u32 = 6632;
pub const ERROR_LOG_ARCHIVE_IN_PROGRESS: u32 = 6633;
pub const ERROR_LOG_EPHEMERAL: u32 = 6634;
pub const ERROR_LOG_NOT_ENOUGH_CONTAINERS: u32 = 6635;
pub const ERROR_LOG_CLIENT_ALREADY_REGISTERED: u32 = 6636;
pub const ERROR_LOG_CLIENT_NOT_REGISTERED: u32 = 6637;
pub const ERROR_LOG_FULL_HANDLER_IN_PROGRESS: u32 = 6638;
pub const ERROR_LOG_CONTAINER_READ_FAILED: u32 = 6639;
pub const ERROR_LOG_CONTAINER_WRITE_FAILED: u32 = 6640;
pub const ERROR_LOG_CONTAINER_OPEN_FAILED: u32 = 6641;
pub const ERROR_LOG_CONTAINER_STATE_INVALID: u32 = 6642;
pub const ERROR_LOG_STATE_INVALID: u32 = 6643;
pub const ERROR_LOG_PINNED: u32 = 6644;
pub const ERROR_LOG_METADATA_FLUSH_FAILED: u32 = 6645;
pub const ERROR_LOG_INCONSISTENT_SECURITY: u32 = 6646;
pub const ERROR_LOG_APPENDED_FLUSH_FAILED: u32 = 6647;
pub const ERROR_LOG_PINNED_RESERVATION: u32 = 6648;
pub const ERROR_INVALID_TRANSACTION: u32 = 6700;
pub const ERROR_TRANSACTION_NOT_ACTIVE: u32 = 6701;
pub const ERROR_TRANSACTION_REQUEST_NOT_VALID: u32 = 6702;
pub const ERROR_TRANSACTION_NOT_REQUESTED: u32 = 6703;
pub const ERROR_TRANSACTION_ALREADY_ABORTED: u32 = 6704;
pub const ERROR_TRANSACTION_ALREADY_COMMITTED: u32 = 6705;
pub const ERROR_TM_INITIALIZATION_FAILED: u32 = 6706;
pub const ERROR_RESOURCEMANAGER_READ_ONLY: u32 = 6707;
pub const ERROR_TRANSACTION_NOT_JOINED: u32 = 6708;
pub const ERROR_TRANSACTION_SUPERIOR_EXISTS: u32 = 6709;
pub const ERROR_CRM_PROTOCOL_ALREADY_EXISTS: u32 = 6710;
pub const ERROR_TRANSACTION_PROPAGATION_FAILED: u32 = 6711;
pub const ERROR_CRM_PROTOCOL_NOT_FOUND: u32 = 6712;
pub const ERROR_TRANSACTION_INVALID_MARSHALL_BUFFER: u32 = 6713;
pub const ERROR_CURRENT_TRANSACTION_NOT_VALID: u32 = 6714;
pub const ERROR_TRANSACTION_NOT_FOUND: u32 = 6715;
pub const ERROR_RESOURCEMANAGER_NOT_FOUND: u32 = 6716;
pub const ERROR_ENLISTMENT_NOT_FOUND: u32 = 6717;
pub const ERROR_TRANSACTIONMANAGER_NOT_FOUND: u32 = 6718;
pub const ERROR_TRANSACTIONMANAGER_NOT_ONLINE: u32 = 6719;
pub const ERROR_TRANSACTIONMANAGER_RECOVERY_NAME_COLLISION: u32 = 6720;
pub const ERROR_TRANSACTION_NOT_ROOT: u32 = 6721;
pub const ERROR_TRANSACTION_OBJECT_EXPIRED: u32 = 6722;
pub const ERROR_TRANSACTION_RESPONSE_NOT_ENLISTED: u32 = 6723;
pub const ERROR_TRANSACTION_RECORD_TOO_LONG: u32 = 6724;
pub const ERROR_IMPLICIT_TRANSACTION_NOT_SUPPORTED: u32 = 6725;
pub const ERROR_TRANSACTION_INTEGRITY_VIOLATED: u32 = 6726;
pub const ERROR_TRANSACTIONMANAGER_IDENTITY_MISMATCH: u32 = 6727;
pub const ERROR_RM_CANNOT_BE_FROZEN_FOR_SNAPSHOT: u32 = 6728;
pub const ERROR_TRANSACTION_MUST_WRITETHROUGH: u32 = 6729;
pub const ERROR_TRANSACTION_NO_SUPERIOR: u32 = 6730;
pub const ERROR_HEURISTIC_DAMAGE_POSSIBLE: u32 = 6731;
pub const ERROR_TRANSACTIONAL_CONFLICT: u32 = 6800;
pub const ERROR_RM_NOT_ACTIVE: u32 = 6801;
pub const ERROR_RM_METADATA_CORRUPT: u32 = 6802;
pub const ERROR_DIRECTORY_NOT_RM: u32 = 6803;
pub const ERROR_TRANSACTIONS_UNSUPPORTED_REMOTE: u32 = 6805;
pub const ERROR_LOG_RESIZE_INVALID_SIZE: u32 = 6806;
pub const ERROR_OBJECT_NO_LONGER_EXISTS: u32 = 6807;
pub const ERROR_STREAM_MINIVERSION_NOT_FOUND: u32 = 6808;
pub const ERROR_STREAM_MINIVERSION_NOT_VALID: u32 = 6809;
pub const ERROR_MINIVERSION_INACCESSIBLE_FROM_SPECIFIED_TRANSACTION: u32 = 6810;
pub const ERROR_CANT_OPEN_MINIVERSION_WITH_MODIFY_INTENT: u32 = 6811;
pub const ERROR_CANT_CREATE_MORE_STREAM_MINIVERSIONS: u32 = 6812;
pub const ERROR_REMOTE_FILE_VERSION_MISMATCH: u32 = 6814;
pub const ERROR_HANDLE_NO_LONGER_VALID: u32 = 6815;
pub const ERROR_NO_TXF_METADATA: u32 = 6816;
pub const ERROR_LOG_CORRUPTION_DETECTED: u32 = 6817;
pub const ERROR_CANT_RECOVER_WITH_HANDLE_OPEN: u32 = 6818;
pub const ERROR_RM_DISCONNECTED: u32 = 6819;
pub const ERROR_ENLISTMENT_NOT_SUPERIOR: u32 = 6820;
pub const ERROR_RECOVERY_NOT_NEEDED: u32 = 6821;
pub const ERROR_RM_ALREADY_STARTED: u32 = 6822;
pub const ERROR_FILE_IDENTITY_NOT_PERSISTENT: u32 = 6823;
pub const ERROR_CANT_BREAK_TRANSACTIONAL_DEPENDENCY: u32 = 6824;
pub const ERROR_CANT_CROSS_RM_BOUNDARY: u32 = 6825;
pub const ERROR_TXF_DIR_NOT_EMPTY: u32 = 6826;
pub const ERROR_INDOUBT_TRANSACTIONS_EXIST: u32 = 6827;
pub const ERROR_TM_VOLATILE: u32 = 6828;
pub const ERROR_ROLLBACK_TIMER_EXPIRED: u32 = 6829;
pub const ERROR_TXF_ATTRIBUTE_CORRUPT: u32 = 6830;
pub const ERROR_EFS_NOT_ALLOWED_IN_TRANSACTION: u32 = 6831;
pub const ERROR_TRANSACTIONAL_OPEN_NOT_ALLOWED: u32 = 6832;
pub const ERROR_LOG_GROWTH_FAILED: u32 = 6833;
pub const ERROR_TRANSACTED_MAPPING_UNSUPPORTED_REMOTE: u32 = 6834;
pub const ERROR_TXF_METADATA_ALREADY_PRESENT: u32 = 6835;
pub const ERROR_TRANSACTION_SCOPE_CALLBACKS_NOT_SET: u32 = 6836;
pub const ERROR_TRANSACTION_REQUIRED_PROMOTION: u32 = 6837;
pub const ERROR_CANNOT_EXECUTE_FILE_IN_TRANSACTION: u32 = 6838;
pub const ERROR_TRANSACTIONS_NOT_FROZEN: u32 = 6839;
pub const ERROR_TRANSACTION_FREEZE_IN_PROGRESS: u32 = 6840;
pub const ERROR_NOT_SNAPSHOT_VOLUME: u32 = 6841;
pub const ERROR_NO_SAVEPOINT_WITH_OPEN_FILES: u32 = 6842;
pub const ERROR_DATA_LOST_REPAIR: u32 = 6843;
pub const ERROR_SPARSE_NOT_ALLOWED_IN_TRANSACTION: u32 = 6844;
pub const ERROR_TM_IDENTITY_MISMATCH: u32 = 6845;
pub const ERROR_FLOATED_SECTION: u32 = 6846;
pub const ERROR_CANNOT_ACCEPT_TRANSACTED_WORK: u32 = 6847;
pub const ERROR_CANNOT_ABORT_TRANSACTIONS: u32 = 6848;
pub const ERROR_BAD_CLUSTERS: u32 = 6849;
pub const ERROR_COMPRESSION_NOT_ALLOWED_IN_TRANSACTION: u32 = 6850;
pub const ERROR_VOLUME_DIRTY: u32 = 6851;
pub const ERROR_NO_LINK_TRACKING_IN_TRANSACTION: u32 = 6852;
pub const ERROR_OPERATION_NOT_SUPPORTED_IN_TRANSACTION: u32 = 6853;
pub const ERROR_EXPIRED_HANDLE: u32 = 6854;
pub const ERROR_TRANSACTION_NOT_ENLISTED: u32 = 6855;
pub const ERROR_CTX_WINSTATION_NAME_INVALID: u32 = 7001;
pub const ERROR_CTX_INVALID_PD: u32 = 7002;
pub const ERROR_CTX_PD_NOT_FOUND: u32 = 7003;
pub const ERROR_CTX_WD_NOT_FOUND: u32 = 7004;
pub const ERROR_CTX_CANNOT_MAKE_EVENTLOG_ENTRY: u32 = 7005;
pub const ERROR_CTX_SERVICE_NAME_COLLISION: u32 = 7006;
pub const ERROR_CTX_CLOSE_PENDING: u32 = 7007;
pub const ERROR_CTX_NO_OUTBUF: u32 = 7008;
pub const ERROR_CTX_MODEM_INF_NOT_FOUND: u32 = 7009;
pub const ERROR_CTX_INVALID_MODEMNAME: u32 = 7010;
pub const ERROR_CTX_MODEM_RESPONSE_ERROR: u32 = 7011;
pub const ERROR_CTX_MODEM_RESPONSE_TIMEOUT: u32 = 7012;
pub const ERROR_CTX_MODEM_RESPONSE_NO_CARRIER: u32 = 7013;
pub const ERROR_CTX_MODEM_RESPONSE_NO_DIALTONE: u32 = 7014;
pub const ERROR_CTX_MODEM_RESPONSE_BUSY: u32 = 7015;
pub const ERROR_CTX_MODEM_RESPONSE_VOICE: u32 = 7016;
pub const ERROR_CTX_TD_ERROR: u32 = 7017;
pub const ERROR_CTX_WINSTATION_NOT_FOUND: u32 = 7022;
pub const ERROR_CTX_WINSTATION_ALREADY_EXISTS: u32 = 7023;
pub const ERROR_CTX_WINSTATION_BUSY: u32 = 7024;
pub const ERROR_CTX_BAD_VIDEO_MODE: u32 = 7025;
pub const ERROR_CTX_GRAPHICS_INVALID: u32 = 7035;
pub const ERROR_CTX_LOGON_DISABLED: u32 = 7037;
pub const ERROR_CTX_NOT_CONSOLE: u32 = 7038;
pub const ERROR_CTX_CLIENT_QUERY_TIMEOUT: u32 = 7040;
pub const ERROR_CTX_CONSOLE_DISCONNECT: u32 = 7041;
pub const ERROR_CTX_CONSOLE_CONNECT: u32 = 7042;
pub const ERROR_CTX_SHADOW_DENIED: u32 = 7044;
pub const ERROR_CTX_WINSTATION_ACCESS_DENIED: u32 = 7045;
pub const ERROR_CTX_INVALID_WD: u32 = 7049;
pub const ERROR_CTX_SHADOW_INVALID: u32 = 7050;
pub const ERROR_CTX_SHADOW_DISABLED: u32 = 7051;
pub const ERROR_CTX_CLIENT_LICENSE_IN_USE: u32 = 7052;
pub const ERROR_CTX_CLIENT_LICENSE_NOT_SET: u32 = 7053;
pub const ERROR_CTX_LICENSE_NOT_AVAILABLE: u32 = 7054;
pub const ERROR_CTX_LICENSE_CLIENT_INVALID: u32 = 7055;
pub const ERROR_CTX_LICENSE_EXPIRED: u32 = 7056;
pub const ERROR_CTX_SHADOW_NOT_RUNNING: u32 = 7057;
pub const ERROR_CTX_SHADOW_ENDED_BY_MODE_CHANGE: u32 = 7058;
pub const ERROR_ACTIVATION_COUNT_EXCEEDED: u32 = 7059;
pub const ERROR_CTX_WINSTATIONS_DISABLED: u32 = 7060;
pub const ERROR_CTX_ENCRYPTION_LEVEL_REQUIRED: u32 = 7061;
pub const ERROR_CTX_SESSION_IN_USE: u32 = 7062;
pub const ERROR_CTX_NO_FORCE_LOGOFF: u32 = 7063;
pub const ERROR_CTX_ACCOUNT_RESTRICTION: u32 = 7064;
pub const ERROR_RDP_PROTOCOL_ERROR: u32 = 7065;
pub const ERROR_CTX_CDM_CONNECT: u32 = 7066;
pub const ERROR_CTX_CDM_DISCONNECT: u32 = 7067;
pub const ERROR_CTX_SECURITY_LAYER_ERROR: u32 = 7068;
pub const ERROR_TS_INCOMPATIBLE_SESSIONS: u32 = 7069;
pub const ERROR_TS_VIDEO_SUBSYSTEM_ERROR: u32 = 7070;
pub const FRS_ERR_INVALID_API_SEQUENCE: u32 = 8001;
pub const FRS_ERR_STARTING_SERVICE: u32 = 8002;
pub const FRS_ERR_STOPPING_SERVICE: u32 = 8003;
pub const FRS_ERR_INTERNAL_API: u32 = 8004;
pub const FRS_ERR_INTERNAL: u32 = 8005;
pub const FRS_ERR_SERVICE_COMM: u32 = 8006;
pub const FRS_ERR_INSUFFICIENT_PRIV: u32 = 8007;
pub const FRS_ERR_AUTHENTICATION: u32 = 8008;
pub const FRS_ERR_PARENT_INSUFFICIENT_PRIV: u32 = 8009;
pub const FRS_ERR_PARENT_AUTHENTICATION: u32 = 8010;
pub const FRS_ERR_CHILD_TO_PARENT_COMM: u32 = 8011;
pub const FRS_ERR_PARENT_TO_CHILD_COMM: u32 = 8012;
pub const FRS_ERR_SYSVOL_POPULATE: u32 = 8013;
pub const FRS_ERR_SYSVOL_POPULATE_TIMEOUT: u32 = 8014;
pub const FRS_ERR_SYSVOL_IS_BUSY: u32 = 8015;
pub const FRS_ERR_SYSVOL_DEMOTE: u32 = 8016;
pub const FRS_ERR_INVALID_SERVICE_PARAMETER: u32 = 8017;
pub const DS_S_SUCCESS: u32 = 0;
pub const ERROR_DS_NOT_INSTALLED: u32 = 8200;
pub const ERROR_DS_MEMBERSHIP_EVALUATED_LOCALLY: u32 = 8201;
pub const ERROR_DS_NO_ATTRIBUTE_OR_VALUE: u32 = 8202;
pub const ERROR_DS_INVALID_ATTRIBUTE_SYNTAX: u32 = 8203;
pub const ERROR_DS_ATTRIBUTE_TYPE_UNDEFINED: u32 = 8204;
pub const ERROR_DS_ATTRIBUTE_OR_VALUE_EXISTS: u32 = 8205;
pub const ERROR_DS_BUSY: u32 = 8206;
pub const ERROR_DS_UNAVAILABLE: u32 = 8207;
pub const ERROR_DS_NO_RIDS_ALLOCATED: u32 = 8208;
pub const ERROR_DS_NO_MORE_RIDS: u32 = 8209;
pub const ERROR_DS_INCORRECT_ROLE_OWNER: u32 = 8210;
pub const ERROR_DS_RIDMGR_INIT_ERROR: u32 = 8211;
pub const ERROR_DS_OBJ_CLASS_VIOLATION: u32 = 8212;
pub const ERROR_DS_CANT_ON_NON_LEAF: u32 = 8213;
pub const ERROR_DS_CANT_ON_RDN: u32 = 8214;
pub const ERROR_DS_CANT_MOD_OBJ_CLASS: u32 = 8215;
pub const ERROR_DS_CROSS_DOM_MOVE_ERROR: u32 = 8216;
pub const ERROR_DS_GC_NOT_AVAILABLE: u32 = 8217;
pub const ERROR_SHARED_POLICY: u32 = 8218;
pub const ERROR_POLICY_OBJECT_NOT_FOUND: u32 = 8219;
pub const ERROR_POLICY_ONLY_IN_DS: u32 = 8220;
pub const ERROR_PROMOTION_ACTIVE: u32 = 8221;
pub const ERROR_NO_PROMOTION_ACTIVE: u32 = 8222;
pub const ERROR_DS_OPERATIONS_ERROR: u32 = 8224;
pub const ERROR_DS_PROTOCOL_ERROR: u32 = 8225;
pub const ERROR_DS_TIMELIMIT_EXCEEDED: u32 = 8226;
pub const ERROR_DS_SIZELIMIT_EXCEEDED: u32 = 8227;
pub const ERROR_DS_ADMIN_LIMIT_EXCEEDED: u32 = 8228;
pub const ERROR_DS_COMPARE_FALSE: u32 = 8229;
pub const ERROR_DS_COMPARE_TRUE: u32 = 8230;
pub const ERROR_DS_AUTH_METHOD_NOT_SUPPORTED: u32 = 8231;
pub const ERROR_DS_STRONG_AUTH_REQUIRED: u32 = 8232;
pub const ERROR_DS_INAPPROPRIATE_AUTH: u32 = 8233;
pub const ERROR_DS_AUTH_UNKNOWN: u32 = 8234;
pub const ERROR_DS_REFERRAL: u32 = 8235;
pub const ERROR_DS_UNAVAILABLE_CRIT_EXTENSION: u32 = 8236;
pub const ERROR_DS_CONFIDENTIALITY_REQUIRED: u32 = 8237;
pub const ERROR_DS_INAPPROPRIATE_MATCHING: u32 = 8238;
pub const ERROR_DS_CONSTRAINT_VIOLATION: u32 = 8239;
pub const ERROR_DS_NO_SUCH_OBJECT: u32 = 8240;
pub const ERROR_DS_ALIAS_PROBLEM: u32 = 8241;
pub const ERROR_DS_INVALID_DN_SYNTAX: u32 = 8242;
pub const ERROR_DS_IS_LEAF: u32 = 8243;
pub const ERROR_DS_ALIAS_DEREF_PROBLEM: u32 = 8244;
pub const ERROR_DS_UNWILLING_TO_PERFORM: u32 = 8245;
pub const ERROR_DS_LOOP_DETECT: u32 = 8246;
pub const ERROR_DS_NAMING_VIOLATION: u32 = 8247;
pub const ERROR_DS_OBJECT_RESULTS_TOO_LARGE: u32 = 8248;
pub const ERROR_DS_AFFECTS_MULTIPLE_DSAS: u32 = 8249;
pub const ERROR_DS_SERVER_DOWN: u32 = 8250;
pub const ERROR_DS_LOCAL_ERROR: u32 = 8251;
pub const ERROR_DS_ENCODING_ERROR: u32 = 8252;
pub const ERROR_DS_DECODING_ERROR: u32 = 8253;
pub const ERROR_DS_FILTER_UNKNOWN: u32 = 8254;
pub const ERROR_DS_PARAM_ERROR: u32 = 8255;
pub const ERROR_DS_NOT_SUPPORTED: u32 = 8256;
pub const ERROR_DS_NO_RESULTS_RETURNED: u32 = 8257;
pub const ERROR_DS_CONTROL_NOT_FOUND: u32 = 8258;
pub const ERROR_DS_CLIENT_LOOP: u32 = 8259;
pub const ERROR_DS_REFERRAL_LIMIT_EXCEEDED: u32 = 8260;
pub const ERROR_DS_SORT_CONTROL_MISSING: u32 = 8261;
pub const ERROR_DS_OFFSET_RANGE_ERROR: u32 = 8262;
pub const ERROR_DS_RIDMGR_DISABLED: u32 = 8263;
pub const ERROR_DS_ROOT_MUST_BE_NC: u32 = 8301;
pub const ERROR_DS_ADD_REPLICA_INHIBITED: u32 = 8302;
pub const ERROR_DS_ATT_NOT_DEF_IN_SCHEMA: u32 = 8303;
pub const ERROR_DS_MAX_OBJ_SIZE_EXCEEDED: u32 = 8304;
pub const ERROR_DS_OBJ_STRING_NAME_EXISTS: u32 = 8305;
pub const ERROR_DS_NO_RDN_DEFINED_IN_SCHEMA: u32 = 8306;
pub const ERROR_DS_RDN_DOESNT_MATCH_SCHEMA: u32 = 8307;
pub const ERROR_DS_NO_REQUESTED_ATTS_FOUND: u32 = 8308;
pub const ERROR_DS_USER_BUFFER_TO_SMALL: u32 = 8309;
pub const ERROR_DS_ATT_IS_NOT_ON_OBJ: u32 = 8310;
pub const ERROR_DS_ILLEGAL_MOD_OPERATION: u32 = 8311;
pub const ERROR_DS_OBJ_TOO_LARGE: u32 = 8312;
pub const ERROR_DS_BAD_INSTANCE_TYPE: u32 = 8313;
pub const ERROR_DS_MASTERDSA_REQUIRED: u32 = 8314;
pub const ERROR_DS_OBJECT_CLASS_REQUIRED: u32 = 8315;
pub const ERROR_DS_MISSING_REQUIRED_ATT: u32 = 8316;
pub const ERROR_DS_ATT_NOT_DEF_FOR_CLASS: u32 = 8317;
pub const ERROR_DS_ATT_ALREADY_EXISTS: u32 = 8318;
pub const ERROR_DS_CANT_ADD_ATT_VALUES: u32 = 8320;
pub const ERROR_DS_SINGLE_VALUE_CONSTRAINT: u32 = 8321;
pub const ERROR_DS_RANGE_CONSTRAINT: u32 = 8322;
pub const ERROR_DS_ATT_VAL_ALREADY_EXISTS: u32 = 8323;
pub const ERROR_DS_CANT_REM_MISSING_ATT: u32 = 8324;
pub const ERROR_DS_CANT_REM_MISSING_ATT_VAL: u32 = 8325;
pub const ERROR_DS_ROOT_CANT_BE_SUBREF: u32 = 8326;
pub const ERROR_DS_NO_CHAINING: u32 = 8327;
pub const ERROR_DS_NO_CHAINED_EVAL: u32 = 8328;
pub const ERROR_DS_NO_PARENT_OBJECT: u32 = 8329;
pub const ERROR_DS_PARENT_IS_AN_ALIAS: u32 = 8330;
pub const ERROR_DS_CANT_MIX_MASTER_AND_REPS: u32 = 8331;
pub const ERROR_DS_CHILDREN_EXIST: u32 = 8332;
pub const ERROR_DS_OBJ_NOT_FOUND: u32 = 8333;
pub const ERROR_DS_ALIASED_OBJ_MISSING: u32 = 8334;
pub const ERROR_DS_BAD_NAME_SYNTAX: u32 = 8335;
pub const ERROR_DS_ALIAS_POINTS_TO_ALIAS: u32 = 8336;
pub const ERROR_DS_CANT_DEREF_ALIAS: u32 = 8337;
pub const ERROR_DS_OUT_OF_SCOPE: u32 = 8338;
pub const ERROR_DS_OBJECT_BEING_REMOVED: u32 = 8339;
pub const ERROR_DS_CANT_DELETE_DSA_OBJ: u32 = 8340;
pub const ERROR_DS_GENERIC_ERROR: u32 = 8341;
pub const ERROR_DS_DSA_MUST_BE_INT_MASTER: u32 = 8342;
pub const ERROR_DS_CLASS_NOT_DSA: u32 = 8343;
pub const ERROR_DS_INSUFF_ACCESS_RIGHTS: u32 = 8344;
pub const ERROR_DS_ILLEGAL_SUPERIOR: u32 = 8345;
pub const ERROR_DS_ATTRIBUTE_OWNED_BY_SAM: u32 = 8346;
pub const ERROR_DS_NAME_TOO_MANY_PARTS: u32 = 8347;
pub const ERROR_DS_NAME_TOO_LONG: u32 = 8348;
pub const ERROR_DS_NAME_VALUE_TOO_LONG: u32 = 8349;
pub const ERROR_DS_NAME_UNPARSEABLE: u32 = 8350;
pub const ERROR_DS_NAME_TYPE_UNKNOWN: u32 = 8351;
pub const ERROR_DS_NOT_AN_OBJECT: u32 = 8352;
pub const ERROR_DS_SEC_DESC_TOO_SHORT: u32 = 8353;
pub const ERROR_DS_SEC_DESC_INVALID: u32 = 8354;
pub const ERROR_DS_NO_DELETED_NAME: u32 = 8355;
pub const ERROR_DS_SUBREF_MUST_HAVE_PARENT: u32 = 8356;
pub const ERROR_DS_NCNAME_MUST_BE_NC: u32 = 8357;
pub const ERROR_DS_CANT_ADD_SYSTEM_ONLY: u32 = 8358;
pub const ERROR_DS_CLASS_MUST_BE_CONCRETE: u32 = 8359;
pub const ERROR_DS_INVALID_DMD: u32 = 8360;
pub const ERROR_DS_OBJ_GUID_EXISTS: u32 = 8361;
pub const ERROR_DS_NOT_ON_BACKLINK: u32 = 8362;
pub const ERROR_DS_NO_CROSSREF_FOR_NC: u32 = 8363;
pub const ERROR_DS_SHUTTING_DOWN: u32 = 8364;
pub const ERROR_DS_UNKNOWN_OPERATION: u32 = 8365;
pub const ERROR_DS_INVALID_ROLE_OWNER: u32 = 8366;
pub const ERROR_DS_COULDNT_CONTACT_FSMO: u32 = 8367;
pub const ERROR_DS_CROSS_NC_DN_RENAME: u32 = 8368;
pub const ERROR_DS_CANT_MOD_SYSTEM_ONLY: u32 = 8369;
pub const ERROR_DS_REPLICATOR_ONLY: u32 = 8370;
pub const ERROR_DS_OBJ_CLASS_NOT_DEFINED: u32 = 8371;
pub const ERROR_DS_OBJ_CLASS_NOT_SUBCLASS: u32 = 8372;
pub const ERROR_DS_NAME_REFERENCE_INVALID: u32 = 8373;
pub const ERROR_DS_CROSS_REF_EXISTS: u32 = 8374;
pub const ERROR_DS_CANT_DEL_MASTER_CROSSREF: u32 = 8375;
pub const ERROR_DS_SUBTREE_NOTIFY_NOT_NC_HEAD: u32 = 8376;
pub const ERROR_DS_NOTIFY_FILTER_TOO_COMPLEX: u32 = 8377;
pub const ERROR_DS_DUP_RDN: u32 = 8378;
pub const ERROR_DS_DUP_OID: u32 = 8379;
pub const ERROR_DS_DUP_MAPI_ID: u32 = 8380;
pub const ERROR_DS_DUP_SCHEMA_ID_GUID: u32 = 8381;
pub const ERROR_DS_DUP_LDAP_DISPLAY_NAME: u32 = 8382;
pub const ERROR_DS_SEMANTIC_ATT_TEST: u32 = 8383;
pub const ERROR_DS_SYNTAX_MISMATCH: u32 = 8384;
pub const ERROR_DS_EXISTS_IN_MUST_HAVE: u32 = 8385;
pub const ERROR_DS_EXISTS_IN_MAY_HAVE: u32 = 8386;
pub const ERROR_DS_NONEXISTENT_MAY_HAVE: u32 = 8387;
pub const ERROR_DS_NONEXISTENT_MUST_HAVE: u32 = 8388;
pub const ERROR_DS_AUX_CLS_TEST_FAIL: u32 = 8389;
pub const ERROR_DS_NONEXISTENT_POSS_SUP: u32 = 8390;
pub const ERROR_DS_SUB_CLS_TEST_FAIL: u32 = 8391;
pub const ERROR_DS_BAD_RDN_ATT_ID_SYNTAX: u32 = 8392;
pub const ERROR_DS_EXISTS_IN_AUX_CLS: u32 = 8393;
pub const ERROR_DS_EXISTS_IN_SUB_CLS: u32 = 8394;
pub const ERROR_DS_EXISTS_IN_POSS_SUP: u32 = 8395;
pub const ERROR_DS_RECALCSCHEMA_FAILED: u32 = 8396;
pub const ERROR_DS_TREE_DELETE_NOT_FINISHED: u32 = 8397;
pub const ERROR_DS_CANT_DELETE: u32 = 8398;
pub const ERROR_DS_ATT_SCHEMA_REQ_ID: u32 = 8399;
pub const ERROR_DS_BAD_ATT_SCHEMA_SYNTAX: u32 = 8400;
pub const ERROR_DS_CANT_CACHE_ATT: u32 = 8401;
pub const ERROR_DS_CANT_CACHE_CLASS: u32 = 8402;
pub const ERROR_DS_CANT_REMOVE_ATT_CACHE: u32 = 8403;
pub const ERROR_DS_CANT_REMOVE_CLASS_CACHE: u32 = 8404;
pub const ERROR_DS_CANT_RETRIEVE_DN: u32 = 8405;
pub const ERROR_DS_MISSING_SUPREF: u32 = 8406;
pub const ERROR_DS_CANT_RETRIEVE_INSTANCE: u32 = 8407;
pub const ERROR_DS_CODE_INCONSISTENCY: u32 = 8408;
pub const ERROR_DS_DATABASE_ERROR: u32 = 8409;
pub const ERROR_DS_GOVERNSID_MISSING: u32 = 8410;
pub const ERROR_DS_MISSING_EXPECTED_ATT: u32 = 8411;
pub const ERROR_DS_NCNAME_MISSING_CR_REF: u32 = 8412;
pub const ERROR_DS_SECURITY_CHECKING_ERROR: u32 = 8413;
pub const ERROR_DS_SCHEMA_NOT_LOADED: u32 = 8414;
pub const ERROR_DS_SCHEMA_ALLOC_FAILED: u32 = 8415;
pub const ERROR_DS_ATT_SCHEMA_REQ_SYNTAX: u32 = 8416;
pub const ERROR_DS_GCVERIFY_ERROR: u32 = 8417;
pub const ERROR_DS_DRA_SCHEMA_MISMATCH: u32 = 8418;
pub const ERROR_DS_CANT_FIND_DSA_OBJ: u32 = 8419;
pub const ERROR_DS_CANT_FIND_EXPECTED_NC: u32 = 8420;
pub const ERROR_DS_CANT_FIND_NC_IN_CACHE: u32 = 8421;
pub const ERROR_DS_CANT_RETRIEVE_CHILD: u32 = 8422;
pub const ERROR_DS_SECURITY_ILLEGAL_MODIFY: u32 = 8423;
pub const ERROR_DS_CANT_REPLACE_HIDDEN_REC: u32 = 8424;
pub const ERROR_DS_BAD_HIERARCHY_FILE: u32 = 8425;
pub const ERROR_DS_BUILD_HIERARCHY_TABLE_FAILED: u32 = 8426;
pub const ERROR_DS_CONFIG_PARAM_MISSING: u32 = 8427;
pub const ERROR_DS_COUNTING_AB_INDICES_FAILED: u32 = 8428;
pub const ERROR_DS_HIERARCHY_TABLE_MALLOC_FAILED: u32 = 8429;
pub const ERROR_DS_INTERNAL_FAILURE: u32 = 8430;
pub const ERROR_DS_UNKNOWN_ERROR: u32 = 8431;
pub const ERROR_DS_ROOT_REQUIRES_CLASS_TOP: u32 = 8432;
pub const ERROR_DS_REFUSING_FSMO_ROLES: u32 = 8433;
pub const ERROR_DS_MISSING_FSMO_SETTINGS: u32 = 8434;
pub const ERROR_DS_UNABLE_TO_SURRENDER_ROLES: u32 = 8435;
pub const ERROR_DS_DRA_GENERIC: u32 = 8436;
pub const ERROR_DS_DRA_INVALID_PARAMETER: u32 = 8437;
pub const ERROR_DS_DRA_BUSY: u32 = 8438;
pub const ERROR_DS_DRA_BAD_DN: u32 = 8439;
pub const ERROR_DS_DRA_BAD_NC: u32 = 8440;
pub const ERROR_DS_DRA_DN_EXISTS: u32 = 8441;
pub const ERROR_DS_DRA_INTERNAL_ERROR: u32 = 8442;
pub const ERROR_DS_DRA_INCONSISTENT_DIT: u32 = 8443;
pub const ERROR_DS_DRA_CONNECTION_FAILED: u32 = 8444;
pub const ERROR_DS_DRA_BAD_INSTANCE_TYPE: u32 = 8445;
pub const ERROR_DS_DRA_OUT_OF_MEM: u32 = 8446;
pub const ERROR_DS_DRA_MAIL_PROBLEM: u32 = 8447;
pub const ERROR_DS_DRA_REF_ALREADY_EXISTS: u32 = 8448;
pub const ERROR_DS_DRA_REF_NOT_FOUND: u32 = 8449;
pub const ERROR_DS_DRA_OBJ_IS_REP_SOURCE: u32 = 8450;
pub const ERROR_DS_DRA_DB_ERROR: u32 = 8451;
pub const ERROR_DS_DRA_NO_REPLICA: u32 = 8452;
pub const ERROR_DS_DRA_ACCESS_DENIED: u32 = 8453;
pub const ERROR_DS_DRA_NOT_SUPPORTED: u32 = 8454;
pub const ERROR_DS_DRA_RPC_CANCELLED: u32 = 8455;
pub const ERROR_DS_DRA_SOURCE_DISABLED: u32 = 8456;
pub const ERROR_DS_DRA_SINK_DISABLED: u32 = 8457;
pub const ERROR_DS_DRA_NAME_COLLISION: u32 = 8458;
pub const ERROR_DS_DRA_SOURCE_REINSTALLED: u32 = 8459;
pub const ERROR_DS_DRA_MISSING_PARENT: u32 = 8460;
pub const ERROR_DS_DRA_PREEMPTED: u32 = 8461;
pub const ERROR_DS_DRA_ABANDON_SYNC: u32 = 8462;
pub const ERROR_DS_DRA_SHUTDOWN: u32 = 8463;
pub const ERROR_DS_DRA_INCOMPATIBLE_PARTIAL_SET: u32 = 8464;
pub const ERROR_DS_DRA_SOURCE_IS_PARTIAL_REPLICA: u32 = 8465;
pub const ERROR_DS_DRA_EXTN_CONNECTION_FAILED: u32 = 8466;
pub const ERROR_DS_INSTALL_SCHEMA_MISMATCH: u32 = 8467;
pub const ERROR_DS_DUP_LINK_ID: u32 = 8468;
pub const ERROR_DS_NAME_ERROR_RESOLVING: u32 = 8469;
pub const ERROR_DS_NAME_ERROR_NOT_FOUND: u32 = 8470;
pub const ERROR_DS_NAME_ERROR_NOT_UNIQUE: u32 = 8471;
pub const ERROR_DS_NAME_ERROR_NO_MAPPING: u32 = 8472;
pub const ERROR_DS_NAME_ERROR_DOMAIN_ONLY: u32 = 8473;
pub const ERROR_DS_NAME_ERROR_NO_SYNTACTICAL_MAPPING: u32 = 8474;
pub const ERROR_DS_CONSTRUCTED_ATT_MOD: u32 = 8475;
pub const ERROR_DS_WRONG_OM_OBJ_CLASS: u32 = 8476;
pub const ERROR_DS_DRA_REPL_PENDING: u32 = 8477;
pub const ERROR_DS_DS_REQUIRED: u32 = 8478;
pub const ERROR_DS_INVALID_LDAP_DISPLAY_NAME: u32 = 8479;
pub const ERROR_DS_NON_BASE_SEARCH: u32 = 8480;
pub const ERROR_DS_CANT_RETRIEVE_ATTS: u32 = 8481;
pub const ERROR_DS_BACKLINK_WITHOUT_LINK: u32 = 8482;
pub const ERROR_DS_EPOCH_MISMATCH: u32 = 8483;
pub const ERROR_DS_SRC_NAME_MISMATCH: u32 = 8484;
pub const ERROR_DS_SRC_AND_DST_NC_IDENTICAL: u32 = 8485;
pub const ERROR_DS_DST_NC_MISMATCH: u32 = 8486;
pub const ERROR_DS_NOT_AUTHORITIVE_FOR_DST_NC: u32 = 8487;
pub const ERROR_DS_SRC_GUID_MISMATCH: u32 = 8488;
pub const ERROR_DS_CANT_MOVE_DELETED_OBJECT: u32 = 8489;
pub const ERROR_DS_PDC_OPERATION_IN_PROGRESS: u32 = 8490;
pub const ERROR_DS_CROSS_DOMAIN_CLEANUP_REQD: u32 = 8491;
pub const ERROR_DS_ILLEGAL_XDOM_MOVE_OPERATION: u32 = 8492;
pub const ERROR_DS_CANT_WITH_ACCT_GROUP_MEMBERSHPS: u32 = 8493;
pub const ERROR_DS_NC_MUST_HAVE_NC_PARENT: u32 = 8494;
pub const ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE: u32 = 8495;
pub const ERROR_DS_DST_DOMAIN_NOT_NATIVE: u32 = 8496;
pub const ERROR_DS_MISSING_INFRASTRUCTURE_CONTAINER: u32 = 8497;
pub const ERROR_DS_CANT_MOVE_ACCOUNT_GROUP: u32 = 8498;
pub const ERROR_DS_CANT_MOVE_RESOURCE_GROUP: u32 = 8499;
pub const ERROR_DS_INVALID_SEARCH_FLAG: u32 = 8500;
pub const ERROR_DS_NO_TREE_DELETE_ABOVE_NC: u32 = 8501;
pub const ERROR_DS_COULDNT_LOCK_TREE_FOR_DELETE: u32 = 8502;
pub const ERROR_DS_COULDNT_IDENTIFY_OBJECTS_FOR_TREE_DELETE: u32 = 8503;
pub const ERROR_DS_SAM_INIT_FAILURE: u32 = 8504;
pub const ERROR_DS_SENSITIVE_GROUP_VIOLATION: u32 = 8505;
pub const ERROR_DS_CANT_MOD_PRIMARYGROUPID: u32 = 8506;
pub const ERROR_DS_ILLEGAL_BASE_SCHEMA_MOD: u32 = 8507;
pub const ERROR_DS_NONSAFE_SCHEMA_CHANGE: u32 = 8508;
pub const ERROR_DS_SCHEMA_UPDATE_DISALLOWED: u32 = 8509;
pub const ERROR_DS_CANT_CREATE_UNDER_SCHEMA: u32 = 8510;
pub const ERROR_DS_INSTALL_NO_SRC_SCH_VERSION: u32 = 8511;
pub const ERROR_DS_INSTALL_NO_SCH_VERSION_IN_INIFILE: u32 = 8512;
pub const ERROR_DS_INVALID_GROUP_TYPE: u32 = 8513;
pub const ERROR_DS_NO_NEST_GLOBALGROUP_IN_MIXEDDOMAIN: u32 = 8514;
pub const ERROR_DS_NO_NEST_LOCALGROUP_IN_MIXEDDOMAIN: u32 = 8515;
pub const ERROR_DS_GLOBAL_CANT_HAVE_LOCAL_MEMBER: u32 = 8516;
pub const ERROR_DS_GLOBAL_CANT_HAVE_UNIVERSAL_MEMBER: u32 = 8517;
pub const ERROR_DS_UNIVERSAL_CANT_HAVE_LOCAL_MEMBER: u32 = 8518;
pub const ERROR_DS_GLOBAL_CANT_HAVE_CROSSDOMAIN_MEMBER: u32 = 8519;
pub const ERROR_DS_LOCAL_CANT_HAVE_CROSSDOMAIN_LOCAL_MEMBER: u32 = 8520;
pub const ERROR_DS_HAVE_PRIMARY_MEMBERS: u32 = 8521;
pub const ERROR_DS_STRING_SD_CONVERSION_FAILED: u32 = 8522;
pub const ERROR_DS_NAMING_MASTER_GC: u32 = 8523;
pub const ERROR_DS_DNS_LOOKUP_FAILURE: u32 = 8524;
pub const ERROR_DS_COULDNT_UPDATE_SPNS: u32 = 8525;
pub const ERROR_DS_CANT_RETRIEVE_SD: u32 = 8526;
pub const ERROR_DS_KEY_NOT_UNIQUE: u32 = 8527;
pub const ERROR_DS_WRONG_LINKED_ATT_SYNTAX: u32 = 8528;
pub const ERROR_DS_SAM_NEED_BOOTKEY_PASSWORD: u32 = 8529;
pub const ERROR_DS_SAM_NEED_BOOTKEY_FLOPPY: u32 = 8530;
pub const ERROR_DS_CANT_START: u32 = 8531;
pub const ERROR_DS_INIT_FAILURE: u32 = 8532;
pub const ERROR_DS_NO_PKT_PRIVACY_ON_CONNECTION: u32 = 8533;
pub const ERROR_DS_SOURCE_DOMAIN_IN_FOREST: u32 = 8534;
pub const ERROR_DS_DESTINATION_DOMAIN_NOT_IN_FOREST: u32 = 8535;
pub const ERROR_DS_DESTINATION_AUDITING_NOT_ENABLED: u32 = 8536;
pub const ERROR_DS_CANT_FIND_DC_FOR_SRC_DOMAIN: u32 = 8537;
pub const ERROR_DS_SRC_OBJ_NOT_GROUP_OR_USER: u32 = 8538;
pub const ERROR_DS_SRC_SID_EXISTS_IN_FOREST: u32 = 8539;
pub const ERROR_DS_SRC_AND_DST_OBJECT_CLASS_MISMATCH: u32 = 8540;
pub const ERROR_SAM_INIT_FAILURE: u32 = 8541;
pub const ERROR_DS_DRA_SCHEMA_INFO_SHIP: u32 = 8542;
pub const ERROR_DS_DRA_SCHEMA_CONFLICT: u32 = 8543;
pub const ERROR_DS_DRA_EARLIER_SCHEMA_CONFLICT: u32 = 8544;
pub const ERROR_DS_DRA_OBJ_NC_MISMATCH: u32 = 8545;
pub const ERROR_DS_NC_STILL_HAS_DSAS: u32 = 8546;
pub const ERROR_DS_GC_REQUIRED: u32 = 8547;
pub const ERROR_DS_LOCAL_MEMBER_OF_LOCAL_ONLY: u32 = 8548;
pub const ERROR_DS_NO_FPO_IN_UNIVERSAL_GROUPS: u32 = 8549;
pub const ERROR_DS_CANT_ADD_TO_GC: u32 = 8550;
pub const ERROR_DS_NO_CHECKPOINT_WITH_PDC: u32 = 8551;
pub const ERROR_DS_SOURCE_AUDITING_NOT_ENABLED: u32 = 8552;
pub const ERROR_DS_CANT_CREATE_IN_NONDOMAIN_NC: u32 = 8553;
pub const ERROR_DS_INVALID_NAME_FOR_SPN: u32 = 8554;
pub const ERROR_DS_FILTER_USES_CONTRUCTED_ATTRS: u32 = 8555;
pub const ERROR_DS_UNICODEPWD_NOT_IN_QUOTES: u32 = 8556;
pub const ERROR_DS_MACHINE_ACCOUNT_QUOTA_EXCEEDED: u32 = 8557;
pub const ERROR_DS_MUST_BE_RUN_ON_DST_DC: u32 = 8558;
pub const ERROR_DS_SRC_DC_MUST_BE_SP4_OR_GREATER: u32 = 8559;
pub const ERROR_DS_CANT_TREE_DELETE_CRITICAL_OBJ: u32 = 8560;
pub const ERROR_DS_INIT_FAILURE_CONSOLE: u32 = 8561;
pub const ERROR_DS_SAM_INIT_FAILURE_CONSOLE: u32 = 8562;
pub const ERROR_DS_FOREST_VERSION_TOO_HIGH: u32 = 8563;
pub const ERROR_DS_DOMAIN_VERSION_TOO_HIGH: u32 = 8564;
pub const ERROR_DS_FOREST_VERSION_TOO_LOW: u32 = 8565;
pub const ERROR_DS_DOMAIN_VERSION_TOO_LOW: u32 = 8566;
pub const ERROR_DS_INCOMPATIBLE_VERSION: u32 = 8567;
pub const ERROR_DS_LOW_DSA_VERSION: u32 = 8568;
pub const ERROR_DS_NO_BEHAVIOR_VERSION_IN_MIXEDDOMAIN: u32 = 8569;
pub const ERROR_DS_NOT_SUPPORTED_SORT_ORDER: u32 = 8570;
pub const ERROR_DS_NAME_NOT_UNIQUE: u32 = 8571;
pub const ERROR_DS_MACHINE_ACCOUNT_CREATED_PRENT4: u32 = 8572;
pub const ERROR_DS_OUT_OF_VERSION_STORE: u32 = 8573;
pub const ERROR_DS_INCOMPATIBLE_CONTROLS_USED: u32 = 8574;
pub const ERROR_DS_NO_REF_DOMAIN: u32 = 8575;
pub const ERROR_DS_RESERVED_LINK_ID: u32 = 8576;
pub const ERROR_DS_LINK_ID_NOT_AVAILABLE: u32 = 8577;
pub const ERROR_DS_AG_CANT_HAVE_UNIVERSAL_MEMBER: u32 = 8578;
pub const ERROR_DS_MODIFYDN_DISALLOWED_BY_INSTANCE_TYPE: u32 = 8579;
pub const ERROR_DS_NO_OBJECT_MOVE_IN_SCHEMA_NC: u32 = 8580;
pub const ERROR_DS_MODIFYDN_DISALLOWED_BY_FLAG: u32 = 8581;
pub const ERROR_DS_MODIFYDN_WRONG_GRANDPARENT: u32 = 8582;
pub const ERROR_DS_NAME_ERROR_TRUST_REFERRAL: u32 = 8583;
pub const ERROR_NOT_SUPPORTED_ON_STANDARD_SERVER: u32 = 8584;
pub const ERROR_DS_CANT_ACCESS_REMOTE_PART_OF_AD: u32 = 8585;
pub const ERROR_DS_CR_IMPOSSIBLE_TO_VALIDATE_V2: u32 = 8586;
pub const ERROR_DS_THREAD_LIMIT_EXCEEDED: u32 = 8587;
pub const ERROR_DS_NOT_CLOSEST: u32 = 8588;
pub const ERROR_DS_CANT_DERIVE_SPN_WITHOUT_SERVER_REF: u32 = 8589;
pub const ERROR_DS_SINGLE_USER_MODE_FAILED: u32 = 8590;
pub const ERROR_DS_NTDSCRIPT_SYNTAX_ERROR: u32 = 8591;
pub const ERROR_DS_NTDSCRIPT_PROCESS_ERROR: u32 = 8592;
pub const ERROR_DS_DIFFERENT_REPL_EPOCHS: u32 = 8593;
pub const ERROR_DS_DRS_EXTENSIONS_CHANGED: u32 = 8594;
pub const ERROR_DS_REPLICA_SET_CHANGE_NOT_ALLOWED_ON_DISABLED_CR: u32 = 8595;
pub const ERROR_DS_NO_MSDS_INTID: u32 = 8596;
pub const ERROR_DS_DUP_MSDS_INTID: u32 = 8597;
pub const ERROR_DS_EXISTS_IN_RDNATTID: u32 = 8598;
pub const ERROR_DS_AUTHORIZATION_FAILED: u32 = 8599;
pub const ERROR_DS_INVALID_SCRIPT: u32 = 8600;
pub const ERROR_DS_REMOTE_CROSSREF_OP_FAILED: u32 = 8601;
pub const ERROR_DS_CROSS_REF_BUSY: u32 = 8602;
pub const ERROR_DS_CANT_DERIVE_SPN_FOR_DELETED_DOMAIN: u32 = 8603;
pub const ERROR_DS_CANT_DEMOTE_WITH_WRITEABLE_NC: u32 = 8604;
pub const ERROR_DS_DUPLICATE_ID_FOUND: u32 = 8605;
pub const ERROR_DS_INSUFFICIENT_ATTR_TO_CREATE_OBJECT: u32 = 8606;
pub const ERROR_DS_GROUP_CONVERSION_ERROR: u32 = 8607;
pub const ERROR_DS_CANT_MOVE_APP_BASIC_GROUP: u32 = 8608;
pub const ERROR_DS_CANT_MOVE_APP_QUERY_GROUP: u32 = 8609;
pub const ERROR_DS_ROLE_NOT_VERIFIED: u32 = 8610;
pub const ERROR_DS_WKO_CONTAINER_CANNOT_BE_SPECIAL: u32 = 8611;
pub const ERROR_DS_DOMAIN_RENAME_IN_PROGRESS: u32 = 8612;
pub const ERROR_DS_EXISTING_AD_CHILD_NC: u32 = 8613;
pub const ERROR_DS_REPL_LIFETIME_EXCEEDED: u32 = 8614;
pub const ERROR_DS_DISALLOWED_IN_SYSTEM_CONTAINER: u32 = 8615;
pub const ERROR_DS_LDAP_SEND_QUEUE_FULL: u32 = 8616;
pub const ERROR_DS_DRA_OUT_SCHEDULE_WINDOW: u32 = 8617;
pub const ERROR_DS_POLICY_NOT_KNOWN: u32 = 8618;
pub const ERROR_NO_SITE_SETTINGS_OBJECT: u32 = 8619;
pub const ERROR_NO_SECRETS: u32 = 8620;
pub const ERROR_NO_WRITABLE_DC_FOUND: u32 = 8621;
pub const ERROR_DS_NO_SERVER_OBJECT: u32 = 8622;
pub const ERROR_DS_NO_NTDSA_OBJECT: u32 = 8623;
pub const ERROR_DS_NON_ASQ_SEARCH: u32 = 8624;
pub const ERROR_DS_AUDIT_FAILURE: u32 = 8625;
pub const ERROR_DS_INVALID_SEARCH_FLAG_SUBTREE: u32 = 8626;
pub const ERROR_DS_INVALID_SEARCH_FLAG_TUPLE: u32 = 8627;
pub const ERROR_DS_HIERARCHY_TABLE_TOO_DEEP: u32 = 8628;
pub const ERROR_DS_DRA_CORRUPT_UTD_VECTOR: u32 = 8629;
pub const ERROR_DS_DRA_SECRETS_DENIED: u32 = 8630;
pub const ERROR_DS_RESERVED_MAPI_ID: u32 = 8631;
pub const ERROR_DS_MAPI_ID_NOT_AVAILABLE: u32 = 8632;
pub const ERROR_DS_DRA_MISSING_KRBTGT_SECRET: u32 = 8633;
pub const ERROR_DS_DOMAIN_NAME_EXISTS_IN_FOREST: u32 = 8634;
pub const ERROR_DS_FLAT_NAME_EXISTS_IN_FOREST: u32 = 8635;
pub const ERROR_INVALID_USER_PRINCIPAL_NAME: u32 = 8636;
pub const ERROR_DS_OID_MAPPED_GROUP_CANT_HAVE_MEMBERS: u32 = 8637;
pub const ERROR_DS_OID_NOT_FOUND: u32 = 8638;
pub const ERROR_DS_DRA_RECYCLED_TARGET: u32 = 8639;
pub const ERROR_DS_DISALLOWED_NC_REDIRECT: u32 = 8640;
pub const ERROR_DS_HIGH_ADLDS_FFL: u32 = 8641;
pub const ERROR_DS_HIGH_DSA_VERSION: u32 = 8642;
pub const ERROR_DS_LOW_ADLDS_FFL: u32 = 8643;
pub const ERROR_DOMAIN_SID_SAME_AS_LOCAL_WORKSTATION: u32 = 8644;
pub const ERROR_DS_UNDELETE_SAM_VALIDATION_FAILED: u32 = 8645;
pub const ERROR_INCORRECT_ACCOUNT_TYPE: u32 = 8646;
pub const ERROR_DS_SPN_VALUE_NOT_UNIQUE_IN_FOREST: u32 = 8647;
pub const ERROR_DS_UPN_VALUE_NOT_UNIQUE_IN_FOREST: u32 = 8648;
pub const ERROR_DS_MISSING_FOREST_TRUST: u32 = 8649;
pub const ERROR_DS_VALUE_KEY_NOT_UNIQUE: u32 = 8650;
pub const ERROR_WEAK_WHFBKEY_BLOCKED: u32 = 8651;
pub const ERROR_DS_PER_ATTRIBUTE_AUTHZ_FAILED_DURING_ADD: u32 = 8652;
pub const ERROR_LOCAL_POLICY_MODIFICATION_NOT_SUPPORTED: u32 = 8653;
pub const DNS_ERROR_RESPONSE_CODES_BASE: u32 = 9000;
pub const DNS_ERROR_RCODE_NO_ERROR: u32 = 0;
pub const DNS_ERROR_MASK: u32 = 9000;
pub const DNS_ERROR_RCODE_FORMAT_ERROR: u32 = 9001;
pub const DNS_ERROR_RCODE_SERVER_FAILURE: u32 = 9002;
pub const DNS_ERROR_RCODE_NAME_ERROR: u32 = 9003;
pub const DNS_ERROR_RCODE_NOT_IMPLEMENTED: u32 = 9004;
pub const DNS_ERROR_RCODE_REFUSED: u32 = 9005;
pub const DNS_ERROR_RCODE_YXDOMAIN: u32 = 9006;
pub const DNS_ERROR_RCODE_YXRRSET: u32 = 9007;
pub const DNS_ERROR_RCODE_NXRRSET: u32 = 9008;
pub const DNS_ERROR_RCODE_NOTAUTH: u32 = 9009;
pub const DNS_ERROR_RCODE_NOTZONE: u32 = 9010;
pub const DNS_ERROR_RCODE_BADSIG: u32 = 9016;
pub const DNS_ERROR_RCODE_BADKEY: u32 = 9017;
pub const DNS_ERROR_RCODE_BADTIME: u32 = 9018;
pub const DNS_ERROR_RCODE_LAST: u32 = 9018;
pub const DNS_ERROR_DNSSEC_BASE: u32 = 9100;
pub const DNS_ERROR_KEYMASTER_REQUIRED: u32 = 9101;
pub const DNS_ERROR_NOT_ALLOWED_ON_SIGNED_ZONE: u32 = 9102;
pub const DNS_ERROR_NSEC3_INCOMPATIBLE_WITH_RSA_SHA1: u32 = 9103;
pub const DNS_ERROR_NOT_ENOUGH_SIGNING_KEY_DESCRIPTORS: u32 = 9104;
pub const DNS_ERROR_UNSUPPORTED_ALGORITHM: u32 = 9105;
pub const DNS_ERROR_INVALID_KEY_SIZE: u32 = 9106;
pub const DNS_ERROR_SIGNING_KEY_NOT_ACCESSIBLE: u32 = 9107;
pub const DNS_ERROR_KSP_DOES_NOT_SUPPORT_PROTECTION: u32 = 9108;
pub const DNS_ERROR_UNEXPECTED_DATA_PROTECTION_ERROR: u32 = 9109;
pub const DNS_ERROR_UNEXPECTED_CNG_ERROR: u32 = 9110;
pub const DNS_ERROR_UNKNOWN_SIGNING_PARAMETER_VERSION: u32 = 9111;
pub const DNS_ERROR_KSP_NOT_ACCESSIBLE: u32 = 9112;
pub const DNS_ERROR_TOO_MANY_SKDS: u32 = 9113;
pub const DNS_ERROR_INVALID_ROLLOVER_PERIOD: u32 = 9114;
pub const DNS_ERROR_INVALID_INITIAL_ROLLOVER_OFFSET: u32 = 9115;
pub const DNS_ERROR_ROLLOVER_IN_PROGRESS: u32 = 9116;
pub const DNS_ERROR_STANDBY_KEY_NOT_PRESENT: u32 = 9117;
pub const DNS_ERROR_NOT_ALLOWED_ON_ZSK: u32 = 9118;
pub const DNS_ERROR_NOT_ALLOWED_ON_ACTIVE_SKD: u32 = 9119;
pub const DNS_ERROR_ROLLOVER_ALREADY_QUEUED: u32 = 9120;
pub const DNS_ERROR_NOT_ALLOWED_ON_UNSIGNED_ZONE: u32 = 9121;
pub const DNS_ERROR_BAD_KEYMASTER: u32 = 9122;
pub const DNS_ERROR_INVALID_SIGNATURE_VALIDITY_PERIOD: u32 = 9123;
pub const DNS_ERROR_INVALID_NSEC3_ITERATION_COUNT: u32 = 9124;
pub const DNS_ERROR_DNSSEC_IS_DISABLED: u32 = 9125;
pub const DNS_ERROR_INVALID_XML: u32 = 9126;
pub const DNS_ERROR_NO_VALID_TRUST_ANCHORS: u32 = 9127;
pub const DNS_ERROR_ROLLOVER_NOT_POKEABLE: u32 = 9128;
pub const DNS_ERROR_NSEC3_NAME_COLLISION: u32 = 9129;
pub const DNS_ERROR_NSEC_INCOMPATIBLE_WITH_NSEC3_RSA_SHA1: u32 = 9130;
pub const DNS_ERROR_PACKET_FMT_BASE: u32 = 9500;
pub const DNS_INFO_NO_RECORDS: u32 = 9501;
pub const DNS_ERROR_BAD_PACKET: u32 = 9502;
pub const DNS_ERROR_NO_PACKET: u32 = 9503;
pub const DNS_ERROR_RCODE: u32 = 9504;
pub const DNS_ERROR_UNSECURE_PACKET: u32 = 9505;
pub const DNS_STATUS_PACKET_UNSECURE: u32 = 9505;
pub const DNS_REQUEST_PENDING: u32 = 9506;
pub const DNS_ERROR_NO_MEMORY: u32 = 14;
pub const DNS_ERROR_INVALID_NAME: u32 = 123;
pub const DNS_ERROR_INVALID_DATA: u32 = 13;
pub const DNS_ERROR_GENERAL_API_BASE: u32 = 9550;
pub const DNS_ERROR_INVALID_TYPE: u32 = 9551;
pub const DNS_ERROR_INVALID_IP_ADDRESS: u32 = 9552;
pub const DNS_ERROR_INVALID_PROPERTY: u32 = 9553;
pub const DNS_ERROR_TRY_AGAIN_LATER: u32 = 9554;
pub const DNS_ERROR_NOT_UNIQUE: u32 = 9555;
pub const DNS_ERROR_NON_RFC_NAME: u32 = 9556;
pub const DNS_STATUS_FQDN: u32 = 9557;
pub const DNS_STATUS_DOTTED_NAME: u32 = 9558;
pub const DNS_STATUS_SINGLE_PART_NAME: u32 = 9559;
pub const DNS_ERROR_INVALID_NAME_CHAR: u32 = 9560;
pub const DNS_ERROR_NUMERIC_NAME: u32 = 9561;
pub const DNS_ERROR_NOT_ALLOWED_ON_ROOT_SERVER: u32 = 9562;
pub const DNS_ERROR_NOT_ALLOWED_UNDER_DELEGATION: u32 = 9563;
pub const DNS_ERROR_CANNOT_FIND_ROOT_HINTS: u32 = 9564;
pub const DNS_ERROR_INCONSISTENT_ROOT_HINTS: u32 = 9565;
pub const DNS_ERROR_DWORD_VALUE_TOO_SMALL: u32 = 9566;
pub const DNS_ERROR_DWORD_VALUE_TOO_LARGE: u32 = 9567;
pub const DNS_ERROR_BACKGROUND_LOADING: u32 = 9568;
pub const DNS_ERROR_NOT_ALLOWED_ON_RODC: u32 = 9569;
pub const DNS_ERROR_NOT_ALLOWED_UNDER_DNAME: u32 = 9570;
pub const DNS_ERROR_DELEGATION_REQUIRED: u32 = 9571;
pub const DNS_ERROR_INVALID_POLICY_TABLE: u32 = 9572;
pub const DNS_ERROR_ADDRESS_REQUIRED: u32 = 9573;
pub const DNS_ERROR_ZONE_BASE: u32 = 9600;
pub const DNS_ERROR_ZONE_DOES_NOT_EXIST: u32 = 9601;
pub const DNS_ERROR_NO_ZONE_INFO: u32 = 9602;
pub const DNS_ERROR_INVALID_ZONE_OPERATION: u32 = 9603;
pub const DNS_ERROR_ZONE_CONFIGURATION_ERROR: u32 = 9604;
pub const DNS_ERROR_ZONE_HAS_NO_SOA_RECORD: u32 = 9605;
pub const DNS_ERROR_ZONE_HAS_NO_NS_RECORDS: u32 = 9606;
pub const DNS_ERROR_ZONE_LOCKED: u32 = 9607;
pub const DNS_ERROR_ZONE_CREATION_FAILED: u32 = 9608;
pub const DNS_ERROR_ZONE_ALREADY_EXISTS: u32 = 9609;
pub const DNS_ERROR_AUTOZONE_ALREADY_EXISTS: u32 = 9610;
pub const DNS_ERROR_INVALID_ZONE_TYPE: u32 = 9611;
pub const DNS_ERROR_SECONDARY_REQUIRES_MASTER_IP: u32 = 9612;
pub const DNS_ERROR_ZONE_NOT_SECONDARY: u32 = 9613;
pub const DNS_ERROR_NEED_SECONDARY_ADDRESSES: u32 = 9614;
pub const DNS_ERROR_WINS_INIT_FAILED: u32 = 9615;
pub const DNS_ERROR_NEED_WINS_SERVERS: u32 = 9616;
pub const DNS_ERROR_NBSTAT_INIT_FAILED: u32 = 9617;
pub const DNS_ERROR_SOA_DELETE_INVALID: u32 = 9618;
pub const DNS_ERROR_FORWARDER_ALREADY_EXISTS: u32 = 9619;
pub const DNS_ERROR_ZONE_REQUIRES_MASTER_IP: u32 = 9620;
pub const DNS_ERROR_ZONE_IS_SHUTDOWN: u32 = 9621;
pub const DNS_ERROR_ZONE_LOCKED_FOR_SIGNING: u32 = 9622;
pub const DNS_ERROR_DATAFILE_BASE: u32 = 9650;
pub const DNS_ERROR_PRIMARY_REQUIRES_DATAFILE: u32 = 9651;
pub const DNS_ERROR_INVALID_DATAFILE_NAME: u32 = 9652;
pub const DNS_ERROR_DATAFILE_OPEN_FAILURE: u32 = 9653;
pub const DNS_ERROR_FILE_WRITEBACK_FAILED: u32 = 9654;
pub const DNS_ERROR_DATAFILE_PARSING: u32 = 9655;
pub const DNS_ERROR_DATABASE_BASE: u32 = 9700;
pub const DNS_ERROR_RECORD_DOES_NOT_EXIST: u32 = 9701;
pub const DNS_ERROR_RECORD_FORMAT: u32 = 9702;
pub const DNS_ERROR_NODE_CREATION_FAILED: u32 = 9703;
pub const DNS_ERROR_UNKNOWN_RECORD_TYPE: u32 = 9704;
pub const DNS_ERROR_RECORD_TIMED_OUT: u32 = 9705;
pub const DNS_ERROR_NAME_NOT_IN_ZONE: u32 = 9706;
pub const DNS_ERROR_CNAME_LOOP: u32 = 9707;
pub const DNS_ERROR_NODE_IS_CNAME: u32 = 9708;
pub const DNS_ERROR_CNAME_COLLISION: u32 = 9709;
pub const DNS_ERROR_RECORD_ONLY_AT_ZONE_ROOT: u32 = 9710;
pub const DNS_ERROR_RECORD_ALREADY_EXISTS: u32 = 9711;
pub const DNS_ERROR_SECONDARY_DATA: u32 = 9712;
pub const DNS_ERROR_NO_CREATE_CACHE_DATA: u32 = 9713;
pub const DNS_ERROR_NAME_DOES_NOT_EXIST: u32 = 9714;
pub const DNS_WARNING_PTR_CREATE_FAILED: u32 = 9715;
pub const DNS_WARNING_DOMAIN_UNDELETED: u32 = 9716;
pub const DNS_ERROR_DS_UNAVAILABLE: u32 = 9717;
pub const DNS_ERROR_DS_ZONE_ALREADY_EXISTS: u32 = 9718;
pub const DNS_ERROR_NO_BOOTFILE_IF_DS_ZONE: u32 = 9719;
pub const DNS_ERROR_NODE_IS_DNAME: u32 = 9720;
pub const DNS_ERROR_DNAME_COLLISION: u32 = 9721;
pub const DNS_ERROR_ALIAS_LOOP: u32 = 9722;
pub const DNS_ERROR_OPERATION_BASE: u32 = 9750;
pub const DNS_INFO_AXFR_COMPLETE: u32 = 9751;
pub const DNS_ERROR_AXFR: u32 = 9752;
pub const DNS_INFO_ADDED_LOCAL_WINS: u32 = 9753;
pub const DNS_ERROR_SECURE_BASE: u32 = 9800;
pub const DNS_STATUS_CONTINUE_NEEDED: u32 = 9801;
pub const DNS_ERROR_SETUP_BASE: u32 = 9850;
pub const DNS_ERROR_NO_TCPIP: u32 = 9851;
pub const DNS_ERROR_NO_DNS_SERVERS: u32 = 9852;
pub const DNS_ERROR_DP_BASE: u32 = 9900;
pub const DNS_ERROR_DP_DOES_NOT_EXIST: u32 = 9901;
pub const DNS_ERROR_DP_ALREADY_EXISTS: u32 = 9902;
pub const DNS_ERROR_DP_NOT_ENLISTED: u32 = 9903;
pub const DNS_ERROR_DP_ALREADY_ENLISTED: u32 = 9904;
pub const DNS_ERROR_DP_NOT_AVAILABLE: u32 = 9905;
pub const DNS_ERROR_DP_FSMO_ERROR: u32 = 9906;
pub const DNS_ERROR_RRL_NOT_ENABLED: u32 = 9911;
pub const DNS_ERROR_RRL_INVALID_WINDOW_SIZE: u32 = 9912;
pub const DNS_ERROR_RRL_INVALID_IPV4_PREFIX: u32 = 9913;
pub const DNS_ERROR_RRL_INVALID_IPV6_PREFIX: u32 = 9914;
pub const DNS_ERROR_RRL_INVALID_TC_RATE: u32 = 9915;
pub const DNS_ERROR_RRL_INVALID_LEAK_RATE: u32 = 9916;
pub const DNS_ERROR_RRL_LEAK_RATE_LESSTHAN_TC_RATE: u32 = 9917;
pub const DNS_ERROR_VIRTUALIZATION_INSTANCE_ALREADY_EXISTS: u32 = 9921;
pub const DNS_ERROR_VIRTUALIZATION_INSTANCE_DOES_NOT_EXIST: u32 = 9922;
pub const DNS_ERROR_VIRTUALIZATION_TREE_LOCKED: u32 = 9923;
pub const DNS_ERROR_INVAILD_VIRTUALIZATION_INSTANCE_NAME: u32 = 9924;
pub const DNS_ERROR_DEFAULT_VIRTUALIZATION_INSTANCE: u32 = 9925;
pub const DNS_ERROR_ZONESCOPE_ALREADY_EXISTS: u32 = 9951;
pub const DNS_ERROR_ZONESCOPE_DOES_NOT_EXIST: u32 = 9952;
pub const DNS_ERROR_DEFAULT_ZONESCOPE: u32 = 9953;
pub const DNS_ERROR_INVALID_ZONESCOPE_NAME: u32 = 9954;
pub const DNS_ERROR_NOT_ALLOWED_WITH_ZONESCOPES: u32 = 9955;
pub const DNS_ERROR_LOAD_ZONESCOPE_FAILED: u32 = 9956;
pub const DNS_ERROR_ZONESCOPE_FILE_WRITEBACK_FAILED: u32 = 9957;
pub const DNS_ERROR_INVALID_SCOPE_NAME: u32 = 9958;
pub const DNS_ERROR_SCOPE_DOES_NOT_EXIST: u32 = 9959;
pub const DNS_ERROR_DEFAULT_SCOPE: u32 = 9960;
pub const DNS_ERROR_INVALID_SCOPE_OPERATION: u32 = 9961;
pub const DNS_ERROR_SCOPE_LOCKED: u32 = 9962;
pub const DNS_ERROR_SCOPE_ALREADY_EXISTS: u32 = 9963;
pub const DNS_ERROR_POLICY_ALREADY_EXISTS: u32 = 9971;
pub const DNS_ERROR_POLICY_DOES_NOT_EXIST: u32 = 9972;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA: u32 = 9973;
pub const DNS_ERROR_POLICY_INVALID_SETTINGS: u32 = 9974;
pub const DNS_ERROR_CLIENT_SUBNET_IS_ACCESSED: u32 = 9975;
pub const DNS_ERROR_CLIENT_SUBNET_DOES_NOT_EXIST: u32 = 9976;
pub const DNS_ERROR_CLIENT_SUBNET_ALREADY_EXISTS: u32 = 9977;
pub const DNS_ERROR_SUBNET_DOES_NOT_EXIST: u32 = 9978;
pub const DNS_ERROR_SUBNET_ALREADY_EXISTS: u32 = 9979;
pub const DNS_ERROR_POLICY_LOCKED: u32 = 9980;
pub const DNS_ERROR_POLICY_INVALID_WEIGHT: u32 = 9981;
pub const DNS_ERROR_POLICY_INVALID_NAME: u32 = 9982;
pub const DNS_ERROR_POLICY_MISSING_CRITERIA: u32 = 9983;
pub const DNS_ERROR_INVALID_CLIENT_SUBNET_NAME: u32 = 9984;
pub const DNS_ERROR_POLICY_PROCESSING_ORDER_INVALID: u32 = 9985;
pub const DNS_ERROR_POLICY_SCOPE_MISSING: u32 = 9986;
pub const DNS_ERROR_POLICY_SCOPE_NOT_ALLOWED: u32 = 9987;
pub const DNS_ERROR_SERVERSCOPE_IS_REFERENCED: u32 = 9988;
pub const DNS_ERROR_ZONESCOPE_IS_REFERENCED: u32 = 9989;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_CLIENT_SUBNET: u32 = 9990;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_TRANSPORT_PROTOCOL: u32 = 9991;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_NETWORK_PROTOCOL: u32 = 9992;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_INTERFACE: u32 = 9993;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_FQDN: u32 = 9994;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_QUERY_TYPE: u32 = 9995;
pub const DNS_ERROR_POLICY_INVALID_CRITERIA_TIME_OF_DAY: u32 = 9996;
pub const WSABASEERR: u32 = 10000;
pub const WSAEINTR: u32 = 10004;
pub const WSAEBADF: u32 = 10009;
pub const WSAEACCES: u32 = 10013;
pub const WSAEFAULT: u32 = 10014;
pub const WSAEINVAL: u32 = 10022;
pub const WSAEMFILE: u32 = 10024;
pub const WSAEWOULDBLOCK: u32 = 10035;
pub const WSAEINPROGRESS: u32 = 10036;
pub const WSAEALREADY: u32 = 10037;
pub const WSAENOTSOCK: u32 = 10038;
pub const WSAEDESTADDRREQ: u32 = 10039;
pub const WSAEMSGSIZE: u32 = 10040;
pub const WSAEPROTOTYPE: u32 = 10041;
pub const WSAENOPROTOOPT: u32 = 10042;
pub const WSAEPROTONOSUPPORT: u32 = 10043;
pub const WSAESOCKTNOSUPPORT: u32 = 10044;
pub const WSAEOPNOTSUPP: u32 = 10045;
pub const WSAEPFNOSUPPORT: u32 = 10046;
pub const WSAEAFNOSUPPORT: u32 = 10047;
pub const WSAEADDRINUSE: u32 = 10048;
pub const WSAEADDRNOTAVAIL: u32 = 10049;
pub const WSAENETDOWN: u32 = 10050;
pub const WSAENETUNREACH: u32 = 10051;
pub const WSAENETRESET: u32 = 10052;
pub const WSAECONNABORTED: u32 = 10053;
pub const WSAECONNRESET: u32 = 10054;
pub const WSAENOBUFS: u32 = 10055;
pub const WSAEISCONN: u32 = 10056;
pub const WSAENOTCONN: u32 = 10057;
pub const WSAESHUTDOWN: u32 = 10058;
pub const WSAETOOMANYREFS: u32 = 10059;
pub const WSAETIMEDOUT: u32 = 10060;
pub const WSAECONNREFUSED: u32 = 10061;
pub const WSAELOOP: u32 = 10062;
pub const WSAENAMETOOLONG: u32 = 10063;
pub const WSAEHOSTDOWN: u32 = 10064;
pub const WSAEHOSTUNREACH: u32 = 10065;
pub const WSAENOTEMPTY: u32 = 10066;
pub const WSAEPROCLIM: u32 = 10067;
pub const WSAEUSERS: u32 = 10068;
pub const WSAEDQUOT: u32 = 10069;
pub const WSAESTALE: u32 = 10070;
pub const WSAEREMOTE: u32 = 10071;
pub const WSASYSNOTREADY: u32 = 10091;
pub const WSAVERNOTSUPPORTED: u32 = 10092;
pub const WSANOTINITIALISED: u32 = 10093;
pub const WSAEDISCON: u32 = 10101;
pub const WSAENOMORE: u32 = 10102;
pub const WSAECANCELLED: u32 = 10103;
pub const WSAEINVALIDPROCTABLE: u32 = 10104;
pub const WSAEINVALIDPROVIDER: u32 = 10105;
pub const WSAEPROVIDERFAILEDINIT: u32 = 10106;
pub const WSASYSCALLFAILURE: u32 = 10107;
pub const WSASERVICE_NOT_FOUND: u32 = 10108;
pub const WSATYPE_NOT_FOUND: u32 = 10109;
pub const WSA_E_NO_MORE: u32 = 10110;
pub const WSA_E_CANCELLED: u32 = 10111;
pub const WSAEREFUSED: u32 = 10112;
pub const WSAHOST_NOT_FOUND: u32 = 11001;
pub const WSATRY_AGAIN: u32 = 11002;
pub const WSANO_RECOVERY: u32 = 11003;
pub const WSANO_DATA: u32 = 11004;
pub const WSA_QOS_RECEIVERS: u32 = 11005;
pub const WSA_QOS_SENDERS: u32 = 11006;
pub const WSA_QOS_NO_SENDERS: u32 = 11007;
pub const WSA_QOS_NO_RECEIVERS: u32 = 11008;
pub const WSA_QOS_REQUEST_CONFIRMED: u32 = 11009;
pub const WSA_QOS_ADMISSION_FAILURE: u32 = 11010;
pub const WSA_QOS_POLICY_FAILURE: u32 = 11011;
pub const WSA_QOS_BAD_STYLE: u32 = 11012;
pub const WSA_QOS_BAD_OBJECT: u32 = 11013;
pub const WSA_QOS_TRAFFIC_CTRL_ERROR: u32 = 11014;
pub const WSA_QOS_GENERIC_ERROR: u32 = 11015;
pub const WSA_QOS_ESERVICETYPE: u32 = 11016;
pub const WSA_QOS_EFLOWSPEC: u32 = 11017;
pub const WSA_QOS_EPROVSPECBUF: u32 = 11018;
pub const WSA_QOS_EFILTERSTYLE: u32 = 11019;
pub const WSA_QOS_EFILTERTYPE: u32 = 11020;
pub const WSA_QOS_EFILTERCOUNT: u32 = 11021;
pub const WSA_QOS_EOBJLENGTH: u32 = 11022;
pub const WSA_QOS_EFLOWCOUNT: u32 = 11023;
pub const WSA_QOS_EUNKOWNPSOBJ: u32 = 11024;
pub const WSA_QOS_EPOLICYOBJ: u32 = 11025;
pub const WSA_QOS_EFLOWDESC: u32 = 11026;
pub const WSA_QOS_EPSFLOWSPEC: u32 = 11027;
pub const WSA_QOS_EPSFILTERSPEC: u32 = 11028;
pub const WSA_QOS_ESDMODEOBJ: u32 = 11029;
pub const WSA_QOS_ESHAPERATEOBJ: u32 = 11030;
pub const WSA_QOS_RESERVED_PETYPE: u32 = 11031;
pub const WSA_SECURE_HOST_NOT_FOUND: u32 = 11032;
pub const WSA_IPSEC_NAME_POLICY_ERROR: u32 = 11033;
pub const ERROR_IPSEC_QM_POLICY_EXISTS: u32 = 13000;
pub const ERROR_IPSEC_QM_POLICY_NOT_FOUND: u32 = 13001;
pub const ERROR_IPSEC_QM_POLICY_IN_USE: u32 = 13002;
pub const ERROR_IPSEC_MM_POLICY_EXISTS: u32 = 13003;
pub const ERROR_IPSEC_MM_POLICY_NOT_FOUND: u32 = 13004;
pub const ERROR_IPSEC_MM_POLICY_IN_USE: u32 = 13005;
pub const ERROR_IPSEC_MM_FILTER_EXISTS: u32 = 13006;
pub const ERROR_IPSEC_MM_FILTER_NOT_FOUND: u32 = 13007;
pub const ERROR_IPSEC_TRANSPORT_FILTER_EXISTS: u32 = 13008;
pub const ERROR_IPSEC_TRANSPORT_FILTER_NOT_FOUND: u32 = 13009;
pub const ERROR_IPSEC_MM_AUTH_EXISTS: u32 = 13010;
pub const ERROR_IPSEC_MM_AUTH_NOT_FOUND: u32 = 13011;
pub const ERROR_IPSEC_MM_AUTH_IN_USE: u32 = 13012;
pub const ERROR_IPSEC_DEFAULT_MM_POLICY_NOT_FOUND: u32 = 13013;
pub const ERROR_IPSEC_DEFAULT_MM_AUTH_NOT_FOUND: u32 = 13014;
pub const ERROR_IPSEC_DEFAULT_QM_POLICY_NOT_FOUND: u32 = 13015;
pub const ERROR_IPSEC_TUNNEL_FILTER_EXISTS: u32 = 13016;
pub const ERROR_IPSEC_TUNNEL_FILTER_NOT_FOUND: u32 = 13017;
pub const ERROR_IPSEC_MM_FILTER_PENDING_DELETION: u32 = 13018;
pub const ERROR_IPSEC_TRANSPORT_FILTER_PENDING_DELETION: u32 = 13019;
pub const ERROR_IPSEC_TUNNEL_FILTER_PENDING_DELETION: u32 = 13020;
pub const ERROR_IPSEC_MM_POLICY_PENDING_DELETION: u32 = 13021;
pub const ERROR_IPSEC_MM_AUTH_PENDING_DELETION: u32 = 13022;
pub const ERROR_IPSEC_QM_POLICY_PENDING_DELETION: u32 = 13023;
pub const WARNING_IPSEC_MM_POLICY_PRUNED: u32 = 13024;
pub const WARNING_IPSEC_QM_POLICY_PRUNED: u32 = 13025;
pub const ERROR_IPSEC_IKE_NEG_STATUS_BEGIN: u32 = 13800;
pub const ERROR_IPSEC_IKE_AUTH_FAIL: u32 = 13801;
pub const ERROR_IPSEC_IKE_ATTRIB_FAIL: u32 = 13802;
pub const ERROR_IPSEC_IKE_NEGOTIATION_PENDING: u32 = 13803;
pub const ERROR_IPSEC_IKE_GENERAL_PROCESSING_ERROR: u32 = 13804;
pub const ERROR_IPSEC_IKE_TIMED_OUT: u32 = 13805;
pub const ERROR_IPSEC_IKE_NO_CERT: u32 = 13806;
pub const ERROR_IPSEC_IKE_SA_DELETED: u32 = 13807;
pub const ERROR_IPSEC_IKE_SA_REAPED: u32 = 13808;
pub const ERROR_IPSEC_IKE_MM_ACQUIRE_DROP: u32 = 13809;
pub const ERROR_IPSEC_IKE_QM_ACQUIRE_DROP: u32 = 13810;
pub const ERROR_IPSEC_IKE_QUEUE_DROP_MM: u32 = 13811;
pub const ERROR_IPSEC_IKE_QUEUE_DROP_NO_MM: u32 = 13812;
pub const ERROR_IPSEC_IKE_DROP_NO_RESPONSE: u32 = 13813;
pub const ERROR_IPSEC_IKE_MM_DELAY_DROP: u32 = 13814;
pub const ERROR_IPSEC_IKE_QM_DELAY_DROP: u32 = 13815;
pub const ERROR_IPSEC_IKE_ERROR: u32 = 13816;
pub const ERROR_IPSEC_IKE_CRL_FAILED: u32 = 13817;
pub const ERROR_IPSEC_IKE_INVALID_KEY_USAGE: u32 = 13818;
pub const ERROR_IPSEC_IKE_INVALID_CERT_TYPE: u32 = 13819;
pub const ERROR_IPSEC_IKE_NO_PRIVATE_KEY: u32 = 13820;
pub const ERROR_IPSEC_IKE_SIMULTANEOUS_REKEY: u32 = 13821;
pub const ERROR_IPSEC_IKE_DH_FAIL: u32 = 13822;
pub const ERROR_IPSEC_IKE_CRITICAL_PAYLOAD_NOT_RECOGNIZED: u32 = 13823;
pub const ERROR_IPSEC_IKE_INVALID_HEADER: u32 = 13824;
pub const ERROR_IPSEC_IKE_NO_POLICY: u32 = 13825;
pub const ERROR_IPSEC_IKE_INVALID_SIGNATURE: u32 = 13826;
pub const ERROR_IPSEC_IKE_KERBEROS_ERROR: u32 = 13827;
pub const ERROR_IPSEC_IKE_NO_PUBLIC_KEY: u32 = 13828;
pub const ERROR_IPSEC_IKE_PROCESS_ERR: u32 = 13829;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_SA: u32 = 13830;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_PROP: u32 = 13831;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_TRANS: u32 = 13832;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_KE: u32 = 13833;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_ID: u32 = 13834;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_CERT: u32 = 13835;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_CERT_REQ: u32 = 13836;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_HASH: u32 = 13837;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_SIG: u32 = 13838;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_NONCE: u32 = 13839;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_NOTIFY: u32 = 13840;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_DELETE: u32 = 13841;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_VENDOR: u32 = 13842;
pub const ERROR_IPSEC_IKE_INVALID_PAYLOAD: u32 = 13843;
pub const ERROR_IPSEC_IKE_LOAD_SOFT_SA: u32 = 13844;
pub const ERROR_IPSEC_IKE_SOFT_SA_TORN_DOWN: u32 = 13845;
pub const ERROR_IPSEC_IKE_INVALID_COOKIE: u32 = 13846;
pub const ERROR_IPSEC_IKE_NO_PEER_CERT: u32 = 13847;
pub const ERROR_IPSEC_IKE_PEER_CRL_FAILED: u32 = 13848;
pub const ERROR_IPSEC_IKE_POLICY_CHANGE: u32 = 13849;
pub const ERROR_IPSEC_IKE_NO_MM_POLICY: u32 = 13850;
pub const ERROR_IPSEC_IKE_NOTCBPRIV: u32 = 13851;
pub const ERROR_IPSEC_IKE_SECLOADFAIL: u32 = 13852;
pub const ERROR_IPSEC_IKE_FAILSSPINIT: u32 = 13853;
pub const ERROR_IPSEC_IKE_FAILQUERYSSP: u32 = 13854;
pub const ERROR_IPSEC_IKE_SRVACQFAIL: u32 = 13855;
pub const ERROR_IPSEC_IKE_SRVQUERYCRED: u32 = 13856;
pub const ERROR_IPSEC_IKE_GETSPIFAIL: u32 = 13857;
pub const ERROR_IPSEC_IKE_INVALID_FILTER: u32 = 13858;
pub const ERROR_IPSEC_IKE_OUT_OF_MEMORY: u32 = 13859;
pub const ERROR_IPSEC_IKE_ADD_UPDATE_KEY_FAILED: u32 = 13860;
pub const ERROR_IPSEC_IKE_INVALID_POLICY: u32 = 13861;
pub const ERROR_IPSEC_IKE_UNKNOWN_DOI: u32 = 13862;
pub const ERROR_IPSEC_IKE_INVALID_SITUATION: u32 = 13863;
pub const ERROR_IPSEC_IKE_DH_FAILURE: u32 = 13864;
pub const ERROR_IPSEC_IKE_INVALID_GROUP: u32 = 13865;
pub const ERROR_IPSEC_IKE_ENCRYPT: u32 = 13866;
pub const ERROR_IPSEC_IKE_DECRYPT: u32 = 13867;
pub const ERROR_IPSEC_IKE_POLICY_MATCH: u32 = 13868;
pub const ERROR_IPSEC_IKE_UNSUPPORTED_ID: u32 = 13869;
pub const ERROR_IPSEC_IKE_INVALID_HASH: u32 = 13870;
pub const ERROR_IPSEC_IKE_INVALID_HASH_ALG: u32 = 13871;
pub const ERROR_IPSEC_IKE_INVALID_HASH_SIZE: u32 = 13872;
pub const ERROR_IPSEC_IKE_INVALID_ENCRYPT_ALG: u32 = 13873;
pub const ERROR_IPSEC_IKE_INVALID_AUTH_ALG: u32 = 13874;
pub const ERROR_IPSEC_IKE_INVALID_SIG: u32 = 13875;
pub const ERROR_IPSEC_IKE_LOAD_FAILED: u32 = 13876;
pub const ERROR_IPSEC_IKE_RPC_DELETE: u32 = 13877;
pub const ERROR_IPSEC_IKE_BENIGN_REINIT: u32 = 13878;
pub const ERROR_IPSEC_IKE_INVALID_RESPONDER_LIFETIME_NOTIFY: u32 = 13879;
pub const ERROR_IPSEC_IKE_INVALID_MAJOR_VERSION: u32 = 13880;
pub const ERROR_IPSEC_IKE_INVALID_CERT_KEYLEN: u32 = 13881;
pub const ERROR_IPSEC_IKE_MM_LIMIT: u32 = 13882;
pub const ERROR_IPSEC_IKE_NEGOTIATION_DISABLED: u32 = 13883;
pub const ERROR_IPSEC_IKE_QM_LIMIT: u32 = 13884;
pub const ERROR_IPSEC_IKE_MM_EXPIRED: u32 = 13885;
pub const ERROR_IPSEC_IKE_PEER_MM_ASSUMED_INVALID: u32 = 13886;
pub const ERROR_IPSEC_IKE_CERT_CHAIN_POLICY_MISMATCH: u32 = 13887;
pub const ERROR_IPSEC_IKE_UNEXPECTED_MESSAGE_ID: u32 = 13888;
pub const ERROR_IPSEC_IKE_INVALID_AUTH_PAYLOAD: u32 = 13889;
pub const ERROR_IPSEC_IKE_DOS_COOKIE_SENT: u32 = 13890;
pub const ERROR_IPSEC_IKE_SHUTTING_DOWN: u32 = 13891;
pub const ERROR_IPSEC_IKE_CGA_AUTH_FAILED: u32 = 13892;
pub const ERROR_IPSEC_IKE_PROCESS_ERR_NATOA: u32 = 13893;
pub const ERROR_IPSEC_IKE_INVALID_MM_FOR_QM: u32 = 13894;
pub const ERROR_IPSEC_IKE_QM_EXPIRED: u32 = 13895;
pub const ERROR_IPSEC_IKE_TOO_MANY_FILTERS: u32 = 13896;
pub const ERROR_IPSEC_IKE_NEG_STATUS_END: u32 = 13897;
pub const ERROR_IPSEC_IKE_KILL_DUMMY_NAP_TUNNEL: u32 = 13898;
pub const ERROR_IPSEC_IKE_INNER_IP_ASSIGNMENT_FAILURE: u32 = 13899;
pub const ERROR_IPSEC_IKE_REQUIRE_CP_PAYLOAD_MISSING: u32 = 13900;
pub const ERROR_IPSEC_KEY_MODULE_IMPERSONATION_NEGOTIATION_PENDING: u32 = 13901;
pub const ERROR_IPSEC_IKE_COEXISTENCE_SUPPRESS: u32 = 13902;
pub const ERROR_IPSEC_IKE_RATELIMIT_DROP: u32 = 13903;
pub const ERROR_IPSEC_IKE_PEER_DOESNT_SUPPORT_MOBIKE: u32 = 13904;
pub const ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE: u32 = 13905;
pub const ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_FAILURE: u32 = 13906;
pub const ERROR_IPSEC_IKE_AUTHORIZATION_FAILURE_WITH_OPTIONAL_RETRY: u32 = 13907;
pub const ERROR_IPSEC_IKE_STRONG_CRED_AUTHORIZATION_AND_CERTMAP_FAILURE: u32 = 13908;
pub const ERROR_IPSEC_IKE_NEG_STATUS_EXTENDED_END: u32 = 13909;
pub const ERROR_IPSEC_BAD_SPI: u32 = 13910;
pub const ERROR_IPSEC_SA_LIFETIME_EXPIRED: u32 = 13911;
pub const ERROR_IPSEC_WRONG_SA: u32 = 13912;
pub const ERROR_IPSEC_REPLAY_CHECK_FAILED: u32 = 13913;
pub const ERROR_IPSEC_INVALID_PACKET: u32 = 13914;
pub const ERROR_IPSEC_INTEGRITY_CHECK_FAILED: u32 = 13915;
pub const ERROR_IPSEC_CLEAR_TEXT_DROP: u32 = 13916;
pub const ERROR_IPSEC_AUTH_FIREWALL_DROP: u32 = 13917;
pub const ERROR_IPSEC_THROTTLE_DROP: u32 = 13918;
pub const ERROR_IPSEC_DOSP_BLOCK: u32 = 13925;
pub const ERROR_IPSEC_DOSP_RECEIVED_MULTICAST: u32 = 13926;
pub const ERROR_IPSEC_DOSP_INVALID_PACKET: u32 = 13927;
pub const ERROR_IPSEC_DOSP_STATE_LOOKUP_FAILED: u32 = 13928;
pub const ERROR_IPSEC_DOSP_MAX_ENTRIES: u32 = 13929;
pub const ERROR_IPSEC_DOSP_KEYMOD_NOT_ALLOWED: u32 = 13930;
pub const ERROR_IPSEC_DOSP_NOT_INSTALLED: u32 = 13931;
pub const ERROR_IPSEC_DOSP_MAX_PER_IP_RATELIMIT_QUEUES: u32 = 13932;
pub const ERROR_SXS_SECTION_NOT_FOUND: u32 = 14000;
pub const ERROR_SXS_CANT_GEN_ACTCTX: u32 = 14001;
pub const ERROR_SXS_INVALID_ACTCTXDATA_FORMAT: u32 = 14002;
pub const ERROR_SXS_ASSEMBLY_NOT_FOUND: u32 = 14003;
pub const ERROR_SXS_MANIFEST_FORMAT_ERROR: u32 = 14004;
pub const ERROR_SXS_MANIFEST_PARSE_ERROR: u32 = 14005;
pub const ERROR_SXS_ACTIVATION_CONTEXT_DISABLED: u32 = 14006;
pub const ERROR_SXS_KEY_NOT_FOUND: u32 = 14007;
pub const ERROR_SXS_VERSION_CONFLICT: u32 = 14008;
pub const ERROR_SXS_WRONG_SECTION_TYPE: u32 = 14009;
pub const ERROR_SXS_THREAD_QUERIES_DISABLED: u32 = 14010;
pub const ERROR_SXS_PROCESS_DEFAULT_ALREADY_SET: u32 = 14011;
pub const ERROR_SXS_UNKNOWN_ENCODING_GROUP: u32 = 14012;
pub const ERROR_SXS_UNKNOWN_ENCODING: u32 = 14013;
pub const ERROR_SXS_INVALID_XML_NAMESPACE_URI: u32 = 14014;
pub const ERROR_SXS_ROOT_MANIFEST_DEPENDENCY_NOT_INSTALLED: u32 = 14015;
pub const ERROR_SXS_LEAF_MANIFEST_DEPENDENCY_NOT_INSTALLED: u32 = 14016;
pub const ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE: u32 = 14017;
pub const ERROR_SXS_MANIFEST_MISSING_REQUIRED_DEFAULT_NAMESPACE: u32 = 14018;
pub const ERROR_SXS_MANIFEST_INVALID_REQUIRED_DEFAULT_NAMESPACE: u32 = 14019;
pub const ERROR_SXS_PRIVATE_MANIFEST_CROSS_PATH_WITH_REPARSE_POINT: u32 = 14020;
pub const ERROR_SXS_DUPLICATE_DLL_NAME: u32 = 14021;
pub const ERROR_SXS_DUPLICATE_WINDOWCLASS_NAME: u32 = 14022;
pub const ERROR_SXS_DUPLICATE_CLSID: u32 = 14023;
pub const ERROR_SXS_DUPLICATE_IID: u32 = 14024;
pub const ERROR_SXS_DUPLICATE_TLBID: u32 = 14025;
pub const ERROR_SXS_DUPLICATE_PROGID: u32 = 14026;
pub const ERROR_SXS_DUPLICATE_ASSEMBLY_NAME: u32 = 14027;
pub const ERROR_SXS_FILE_HASH_MISMATCH: u32 = 14028;
pub const ERROR_SXS_POLICY_PARSE_ERROR: u32 = 14029;
pub const ERROR_SXS_XML_E_MISSINGQUOTE: u32 = 14030;
pub const ERROR_SXS_XML_E_COMMENTSYNTAX: u32 = 14031;
pub const ERROR_SXS_XML_E_BADSTARTNAMECHAR: u32 = 14032;
pub const ERROR_SXS_XML_E_BADNAMECHAR: u32 = 14033;
pub const ERROR_SXS_XML_E_BADCHARINSTRING: u32 = 14034;
pub const ERROR_SXS_XML_E_XMLDECLSYNTAX: u32 = 14035;
pub const ERROR_SXS_XML_E_BADCHARDATA: u32 = 14036;
pub const ERROR_SXS_XML_E_MISSINGWHITESPACE: u32 = 14037;
pub const ERROR_SXS_XML_E_EXPECTINGTAGEND: u32 = 14038;
pub const ERROR_SXS_XML_E_MISSINGSEMICOLON: u32 = 14039;
pub const ERROR_SXS_XML_E_UNBALANCEDPAREN: u32 = 14040;
pub const ERROR_SXS_XML_E_INTERNALERROR: u32 = 14041;
pub const ERROR_SXS_XML_E_UNEXPECTED_WHITESPACE: u32 = 14042;
pub const ERROR_SXS_XML_E_INCOMPLETE_ENCODING: u32 = 14043;
pub const ERROR_SXS_XML_E_MISSING_PAREN: u32 = 14044;
pub const ERROR_SXS_XML_E_EXPECTINGCLOSEQUOTE: u32 = 14045;
pub const ERROR_SXS_XML_E_MULTIPLE_COLONS: u32 = 14046;
pub const ERROR_SXS_XML_E_INVALID_DECIMAL: u32 = 14047;
pub const ERROR_SXS_XML_E_INVALID_HEXIDECIMAL: u32 = 14048;
pub const ERROR_SXS_XML_E_INVALID_UNICODE: u32 = 14049;
pub const ERROR_SXS_XML_E_WHITESPACEORQUESTIONMARK: u32 = 14050;
pub const ERROR_SXS_XML_E_UNEXPECTEDENDTAG: u32 = 14051;
pub const ERROR_SXS_XML_E_UNCLOSEDTAG: u32 = 14052;
pub const ERROR_SXS_XML_E_DUPLICATEATTRIBUTE: u32 = 14053;
pub const ERROR_SXS_XML_E_MULTIPLEROOTS: u32 = 14054;
pub const ERROR_SXS_XML_E_INVALIDATROOTLEVEL: u32 = 14055;
pub const ERROR_SXS_XML_E_BADXMLDECL: u32 = 14056;
pub const ERROR_SXS_XML_E_MISSINGROOT: u32 = 14057;
pub const ERROR_SXS_XML_E_UNEXPECTEDEOF: u32 = 14058;
pub const ERROR_SXS_XML_E_BADPEREFINSUBSET: u32 = 14059;
pub const ERROR_SXS_XML_E_UNCLOSEDSTARTTAG: u32 = 14060;
pub const ERROR_SXS_XML_E_UNCLOSEDENDTAG: u32 = 14061;
pub const ERROR_SXS_XML_E_UNCLOSEDSTRING: u32 = 14062;
pub const ERROR_SXS_XML_E_UNCLOSEDCOMMENT: u32 = 14063;
pub const ERROR_SXS_XML_E_UNCLOSEDDECL: u32 = 14064;
pub const ERROR_SXS_XML_E_UNCLOSEDCDATA: u32 = 14065;
pub const ERROR_SXS_XML_E_RESERVEDNAMESPACE: u32 = 14066;
pub const ERROR_SXS_XML_E_INVALIDENCODING: u32 = 14067;
pub const ERROR_SXS_XML_E_INVALIDSWITCH: u32 = 14068;
pub const ERROR_SXS_XML_E_BADXMLCASE: u32 = 14069;
pub const ERROR_SXS_XML_E_INVALID_STANDALONE: u32 = 14070;
pub const ERROR_SXS_XML_E_UNEXPECTED_STANDALONE: u32 = 14071;
pub const ERROR_SXS_XML_E_INVALID_VERSION: u32 = 14072;
pub const ERROR_SXS_XML_E_MISSINGEQUALS: u32 = 14073;
pub const ERROR_SXS_PROTECTION_RECOVERY_FAILED: u32 = 14074;
pub const ERROR_SXS_PROTECTION_PUBLIC_KEY_TOO_SHORT: u32 = 14075;
pub const ERROR_SXS_PROTECTION_CATALOG_NOT_VALID: u32 = 14076;
pub const ERROR_SXS_UNTRANSLATABLE_HRESULT: u32 = 14077;
pub const ERROR_SXS_PROTECTION_CATALOG_FILE_MISSING: u32 = 14078;
pub const ERROR_SXS_MISSING_ASSEMBLY_IDENTITY_ATTRIBUTE: u32 = 14079;
pub const ERROR_SXS_INVALID_ASSEMBLY_IDENTITY_ATTRIBUTE_NAME: u32 = 14080;
pub const ERROR_SXS_ASSEMBLY_MISSING: u32 = 14081;
pub const ERROR_SXS_CORRUPT_ACTIVATION_STACK: u32 = 14082;
pub const ERROR_SXS_CORRUPTION: u32 = 14083;
pub const ERROR_SXS_EARLY_DEACTIVATION: u32 = 14084;
pub const ERROR_SXS_INVALID_DEACTIVATION: u32 = 14085;
pub const ERROR_SXS_MULTIPLE_DEACTIVATION: u32 = 14086;
pub const ERROR_SXS_PROCESS_TERMINATION_REQUESTED: u32 = 14087;
pub const ERROR_SXS_RELEASE_ACTIVATION_CONTEXT: u32 = 14088;
pub const ERROR_SXS_SYSTEM_DEFAULT_ACTIVATION_CONTEXT_EMPTY: u32 = 14089;
pub const ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_VALUE: u32 = 14090;
pub const ERROR_SXS_INVALID_IDENTITY_ATTRIBUTE_NAME: u32 = 14091;
pub const ERROR_SXS_IDENTITY_DUPLICATE_ATTRIBUTE: u32 = 14092;
pub const ERROR_SXS_IDENTITY_PARSE_ERROR: u32 = 14093;
pub const ERROR_MALFORMED_SUBSTITUTION_STRING: u32 = 14094;
pub const ERROR_SXS_INCORRECT_PUBLIC_KEY_TOKEN: u32 = 14095;
pub const ERROR_UNMAPPED_SUBSTITUTION_STRING: u32 = 14096;
pub const ERROR_SXS_ASSEMBLY_NOT_LOCKED: u32 = 14097;
pub const ERROR_SXS_COMPONENT_STORE_CORRUPT: u32 = 14098;
pub const ERROR_ADVANCED_INSTALLER_FAILED: u32 = 14099;
pub const ERROR_XML_ENCODING_MISMATCH: u32 = 14100;
pub const ERROR_SXS_MANIFEST_IDENTITY_SAME_BUT_CONTENTS_DIFFERENT: u32 = 14101;
pub const ERROR_SXS_IDENTITIES_DIFFERENT: u32 = 14102;
pub const ERROR_SXS_ASSEMBLY_IS_NOT_A_DEPLOYMENT: u32 = 14103;
pub const ERROR_SXS_FILE_NOT_PART_OF_ASSEMBLY: u32 = 14104;
pub const ERROR_SXS_MANIFEST_TOO_BIG: u32 = 14105;
pub const ERROR_SXS_SETTING_NOT_REGISTERED: u32 = 14106;
pub const ERROR_SXS_TRANSACTION_CLOSURE_INCOMPLETE: u32 = 14107;
pub const ERROR_SMI_PRIMITIVE_INSTALLER_FAILED: u32 = 14108;
pub const ERROR_GENERIC_COMMAND_FAILED: u32 = 14109;
pub const ERROR_SXS_FILE_HASH_MISSING: u32 = 14110;
pub const ERROR_SXS_DUPLICATE_ACTIVATABLE_CLASS: u32 = 14111;
pub const ERROR_EVT_INVALID_CHANNEL_PATH: u32 = 15000;
pub const ERROR_EVT_INVALID_QUERY: u32 = 15001;
pub const ERROR_EVT_PUBLISHER_METADATA_NOT_FOUND: u32 = 15002;
pub const ERROR_EVT_EVENT_TEMPLATE_NOT_FOUND: u32 = 15003;
pub const ERROR_EVT_INVALID_PUBLISHER_NAME: u32 = 15004;
pub const ERROR_EVT_INVALID_EVENT_DATA: u32 = 15005;
pub const ERROR_EVT_CHANNEL_NOT_FOUND: u32 = 15007;
pub const ERROR_EVT_MALFORMED_XML_TEXT: u32 = 15008;
pub const ERROR_EVT_SUBSCRIPTION_TO_DIRECT_CHANNEL: u32 = 15009;
pub const ERROR_EVT_CONFIGURATION_ERROR: u32 = 15010;
pub const ERROR_EVT_QUERY_RESULT_STALE: u32 = 15011;
pub const ERROR_EVT_QUERY_RESULT_INVALID_POSITION: u32 = 15012;
pub const ERROR_EVT_NON_VALIDATING_MSXML: u32 = 15013;
pub const ERROR_EVT_FILTER_ALREADYSCOPED: u32 = 15014;
pub const ERROR_EVT_FILTER_NOTELTSET: u32 = 15015;
pub const ERROR_EVT_FILTER_INVARG: u32 = 15016;
pub const ERROR_EVT_FILTER_INVTEST: u32 = 15017;
pub const ERROR_EVT_FILTER_INVTYPE: u32 = 15018;
pub const ERROR_EVT_FILTER_PARSEERR: u32 = 15019;
pub const ERROR_EVT_FILTER_UNSUPPORTEDOP: u32 = 15020;
pub const ERROR_EVT_FILTER_UNEXPECTEDTOKEN: u32 = 15021;
pub const ERROR_EVT_INVALID_OPERATION_OVER_ENABLED_DIRECT_CHANNEL: u32 = 15022;
pub const ERROR_EVT_INVALID_CHANNEL_PROPERTY_VALUE: u32 = 15023;
pub const ERROR_EVT_INVALID_PUBLISHER_PROPERTY_VALUE: u32 = 15024;
pub const ERROR_EVT_CHANNEL_CANNOT_ACTIVATE: u32 = 15025;
pub const ERROR_EVT_FILTER_TOO_COMPLEX: u32 = 15026;
pub const ERROR_EVT_MESSAGE_NOT_FOUND: u32 = 15027;
pub const ERROR_EVT_MESSAGE_ID_NOT_FOUND: u32 = 15028;
pub const ERROR_EVT_UNRESOLVED_VALUE_INSERT: u32 = 15029;
pub const ERROR_EVT_UNRESOLVED_PARAMETER_INSERT: u32 = 15030;
pub const ERROR_EVT_MAX_INSERTS_REACHED: u32 = 15031;
pub const ERROR_EVT_EVENT_DEFINITION_NOT_FOUND: u32 = 15032;
pub const ERROR_EVT_MESSAGE_LOCALE_NOT_FOUND: u32 = 15033;
pub const ERROR_EVT_VERSION_TOO_OLD: u32 = 15034;
pub const ERROR_EVT_VERSION_TOO_NEW: u32 = 15035;
pub const ERROR_EVT_CANNOT_OPEN_CHANNEL_OF_QUERY: u32 = 15036;
pub const ERROR_EVT_PUBLISHER_DISABLED: u32 = 15037;
pub const ERROR_EVT_FILTER_OUT_OF_RANGE: u32 = 15038;
pub const ERROR_EC_SUBSCRIPTION_CANNOT_ACTIVATE: u32 = 15080;
pub const ERROR_EC_LOG_DISABLED: u32 = 15081;
pub const ERROR_EC_CIRCULAR_FORWARDING: u32 = 15082;
pub const ERROR_EC_CREDSTORE_FULL: u32 = 15083;
pub const ERROR_EC_CRED_NOT_FOUND: u32 = 15084;
pub const ERROR_EC_NO_ACTIVE_CHANNEL: u32 = 15085;
pub const ERROR_MUI_FILE_NOT_FOUND: u32 = 15100;
pub const ERROR_MUI_INVALID_FILE: u32 = 15101;
pub const ERROR_MUI_INVALID_RC_CONFIG: u32 = 15102;
pub const ERROR_MUI_INVALID_LOCALE_NAME: u32 = 15103;
pub const ERROR_MUI_INVALID_ULTIMATEFALLBACK_NAME: u32 = 15104;
pub const ERROR_MUI_FILE_NOT_LOADED: u32 = 15105;
pub const ERROR_RESOURCE_ENUM_USER_STOP: u32 = 15106;
pub const ERROR_MUI_INTLSETTINGS_UILANG_NOT_INSTALLED: u32 = 15107;
pub const ERROR_MUI_INTLSETTINGS_INVALID_LOCALE_NAME: u32 = 15108;
pub const ERROR_MRM_RUNTIME_NO_DEFAULT_OR_NEUTRAL_RESOURCE: u32 = 15110;
pub const ERROR_MRM_INVALID_PRICONFIG: u32 = 15111;
pub const ERROR_MRM_INVALID_FILE_TYPE: u32 = 15112;
pub const ERROR_MRM_UNKNOWN_QUALIFIER: u32 = 15113;
pub const ERROR_MRM_INVALID_QUALIFIER_VALUE: u32 = 15114;
pub const ERROR_MRM_NO_CANDIDATE: u32 = 15115;
pub const ERROR_MRM_NO_MATCH_OR_DEFAULT_CANDIDATE: u32 = 15116;
pub const ERROR_MRM_RESOURCE_TYPE_MISMATCH: u32 = 15117;
pub const ERROR_MRM_DUPLICATE_MAP_NAME: u32 = 15118;
pub const ERROR_MRM_DUPLICATE_ENTRY: u32 = 15119;
pub const ERROR_MRM_INVALID_RESOURCE_IDENTIFIER: u32 = 15120;
pub const ERROR_MRM_FILEPATH_TOO_LONG: u32 = 15121;
pub const ERROR_MRM_UNSUPPORTED_DIRECTORY_TYPE: u32 = 15122;
pub const ERROR_MRM_INVALID_PRI_FILE: u32 = 15126;
pub const ERROR_MRM_NAMED_RESOURCE_NOT_FOUND: u32 = 15127;
pub const ERROR_MRM_MAP_NOT_FOUND: u32 = 15135;
pub const ERROR_MRM_UNSUPPORTED_PROFILE_TYPE: u32 = 15136;
pub const ERROR_MRM_INVALID_QUALIFIER_OPERATOR: u32 = 15137;
pub const ERROR_MRM_INDETERMINATE_QUALIFIER_VALUE: u32 = 15138;
pub const ERROR_MRM_AUTOMERGE_ENABLED: u32 = 15139;
pub const ERROR_MRM_TOO_MANY_RESOURCES: u32 = 15140;
pub const ERROR_MRM_UNSUPPORTED_FILE_TYPE_FOR_MERGE: u32 = 15141;
pub const ERROR_MRM_UNSUPPORTED_FILE_TYPE_FOR_LOAD_UNLOAD_PRI_FILE: u32 = 15142;
pub const ERROR_MRM_NO_CURRENT_VIEW_ON_THREAD: u32 = 15143;
pub const ERROR_DIFFERENT_PROFILE_RESOURCE_MANAGER_EXIST: u32 = 15144;
pub const ERROR_OPERATION_NOT_ALLOWED_FROM_SYSTEM_COMPONENT: u32 = 15145;
pub const ERROR_MRM_DIRECT_REF_TO_NON_DEFAULT_RESOURCE: u32 = 15146;
pub const ERROR_MRM_GENERATION_COUNT_MISMATCH: u32 = 15147;
pub const ERROR_PRI_MERGE_VERSION_MISMATCH: u32 = 15148;
pub const ERROR_PRI_MERGE_MISSING_SCHEMA: u32 = 15149;
pub const ERROR_PRI_MERGE_LOAD_FILE_FAILED: u32 = 15150;
pub const ERROR_PRI_MERGE_ADD_FILE_FAILED: u32 = 15151;
pub const ERROR_PRI_MERGE_WRITE_FILE_FAILED: u32 = 15152;
pub const ERROR_PRI_MERGE_MULTIPLE_PACKAGE_FAMILIES_NOT_ALLOWED: u32 = 15153;
pub const ERROR_PRI_MERGE_MULTIPLE_MAIN_PACKAGES_NOT_ALLOWED: u32 = 15154;
pub const ERROR_PRI_MERGE_BUNDLE_PACKAGES_NOT_ALLOWED: u32 = 15155;
pub const ERROR_PRI_MERGE_MAIN_PACKAGE_REQUIRED: u32 = 15156;
pub const ERROR_PRI_MERGE_RESOURCE_PACKAGE_REQUIRED: u32 = 15157;
pub const ERROR_PRI_MERGE_INVALID_FILE_NAME: u32 = 15158;
pub const ERROR_MRM_PACKAGE_NOT_FOUND: u32 = 15159;
pub const ERROR_MRM_MISSING_DEFAULT_LANGUAGE: u32 = 15160;
pub const ERROR_MCA_INVALID_CAPABILITIES_STRING: u32 = 15200;
pub const ERROR_MCA_INVALID_VCP_VERSION: u32 = 15201;
pub const ERROR_MCA_MONITOR_VIOLATES_MCCS_SPECIFICATION: u32 = 15202;
pub const ERROR_MCA_MCCS_VERSION_MISMATCH: u32 = 15203;
pub const ERROR_MCA_UNSUPPORTED_MCCS_VERSION: u32 = 15204;
pub const ERROR_MCA_INTERNAL_ERROR: u32 = 15205;
pub const ERROR_MCA_INVALID_TECHNOLOGY_TYPE_RETURNED: u32 = 15206;
pub const ERROR_MCA_UNSUPPORTED_COLOR_TEMPERATURE: u32 = 15207;
pub const ERROR_AMBIGUOUS_SYSTEM_DEVICE: u32 = 15250;
pub const ERROR_SYSTEM_DEVICE_NOT_FOUND: u32 = 15299;
pub const ERROR_HASH_NOT_SUPPORTED: u32 = 15300;
pub const ERROR_HASH_NOT_PRESENT: u32 = 15301;
pub const ERROR_SECONDARY_IC_PROVIDER_NOT_REGISTERED: u32 = 15321;
pub const ERROR_GPIO_CLIENT_INFORMATION_INVALID: u32 = 15322;
pub const ERROR_GPIO_VERSION_NOT_SUPPORTED: u32 = 15323;
pub const ERROR_GPIO_INVALID_REGISTRATION_PACKET: u32 = 15324;
pub const ERROR_GPIO_OPERATION_DENIED: u32 = 15325;
pub const ERROR_GPIO_INCOMPATIBLE_CONNECT_MODE: u32 = 15326;
pub const ERROR_GPIO_INTERRUPT_ALREADY_UNMASKED: u32 = 15327;
pub const ERROR_CANNOT_SWITCH_RUNLEVEL: u32 = 15400;
pub const ERROR_INVALID_RUNLEVEL_SETTING: u32 = 15401;
pub const ERROR_RUNLEVEL_SWITCH_TIMEOUT: u32 = 15402;
pub const ERROR_RUNLEVEL_SWITCH_AGENT_TIMEOUT: u32 = 15403;
pub const ERROR_RUNLEVEL_SWITCH_IN_PROGRESS: u32 = 15404;
pub const ERROR_SERVICES_FAILED_AUTOSTART: u32 = 15405;
pub const ERROR_COM_TASK_STOP_PENDING: u32 = 15501;
pub const ERROR_INSTALL_OPEN_PACKAGE_FAILED: u32 = 15600;
pub const ERROR_INSTALL_PACKAGE_NOT_FOUND: u32 = 15601;
pub const ERROR_INSTALL_INVALID_PACKAGE: u32 = 15602;
pub const ERROR_INSTALL_RESOLVE_DEPENDENCY_FAILED: u32 = 15603;
pub const ERROR_INSTALL_OUT_OF_DISK_SPACE: u32 = 15604;
pub const ERROR_INSTALL_NETWORK_FAILURE: u32 = 15605;
pub const ERROR_INSTALL_REGISTRATION_FAILURE: u32 = 15606;
pub const ERROR_INSTALL_DEREGISTRATION_FAILURE: u32 = 15607;
pub const ERROR_INSTALL_CANCEL: u32 = 15608;
pub const ERROR_INSTALL_FAILED: u32 = 15609;
pub const ERROR_REMOVE_FAILED: u32 = 15610;
pub const ERROR_PACKAGE_ALREADY_EXISTS: u32 = 15611;
pub const ERROR_NEEDS_REMEDIATION: u32 = 15612;
pub const ERROR_INSTALL_PREREQUISITE_FAILED: u32 = 15613;
pub const ERROR_PACKAGE_REPOSITORY_CORRUPTED: u32 = 15614;
pub const ERROR_INSTALL_POLICY_FAILURE: u32 = 15615;
pub const ERROR_PACKAGE_UPDATING: u32 = 15616;
pub const ERROR_DEPLOYMENT_BLOCKED_BY_POLICY: u32 = 15617;
pub const ERROR_PACKAGES_IN_USE: u32 = 15618;
pub const ERROR_RECOVERY_FILE_CORRUPT: u32 = 15619;
pub const ERROR_INVALID_STAGED_SIGNATURE: u32 = 15620;
pub const ERROR_DELETING_EXISTING_APPLICATIONDATA_STORE_FAILED: u32 = 15621;
pub const ERROR_INSTALL_PACKAGE_DOWNGRADE: u32 = 15622;
pub const ERROR_SYSTEM_NEEDS_REMEDIATION: u32 = 15623;
pub const ERROR_APPX_INTEGRITY_FAILURE_CLR_NGEN: u32 = 15624;
pub const ERROR_RESILIENCY_FILE_CORRUPT: u32 = 15625;
pub const ERROR_INSTALL_FIREWALL_SERVICE_NOT_RUNNING: u32 = 15626;
pub const ERROR_PACKAGE_MOVE_FAILED: u32 = 15627;
pub const ERROR_INSTALL_VOLUME_NOT_EMPTY: u32 = 15628;
pub const ERROR_INSTALL_VOLUME_OFFLINE: u32 = 15629;
pub const ERROR_INSTALL_VOLUME_CORRUPT: u32 = 15630;
pub const ERROR_NEEDS_REGISTRATION: u32 = 15631;
pub const ERROR_INSTALL_WRONG_PROCESSOR_ARCHITECTURE: u32 = 15632;
pub const ERROR_DEV_SIDELOAD_LIMIT_EXCEEDED: u32 = 15633;
pub const ERROR_INSTALL_OPTIONAL_PACKAGE_REQUIRES_MAIN_PACKAGE: u32 = 15634;
pub const ERROR_PACKAGE_NOT_SUPPORTED_ON_FILESYSTEM: u32 = 15635;
pub const ERROR_PACKAGE_MOVE_BLOCKED_BY_STREAMING: u32 = 15636;
pub const ERROR_INSTALL_OPTIONAL_PACKAGE_APPLICATIONID_NOT_UNIQUE: u32 = 15637;
pub const ERROR_PACKAGE_STAGING_ONHOLD: u32 = 15638;
pub const ERROR_INSTALL_INVALID_RELATED_SET_UPDATE: u32 = 15639;
pub const ERROR_INSTALL_OPTIONAL_PACKAGE_REQUIRES_MAIN_PACKAGE_FULLTRUST_CAPABILITY: u32 = 15640;
pub const ERROR_DEPLOYMENT_BLOCKED_BY_USER_LOG_OFF: u32 = 15641;
pub const ERROR_PROVISION_OPTIONAL_PACKAGE_REQUIRES_MAIN_PACKAGE_PROVISIONED: u32 = 15642;
pub const ERROR_PACKAGES_REPUTATION_CHECK_FAILED: u32 = 15643;
pub const ERROR_PACKAGES_REPUTATION_CHECK_TIMEDOUT: u32 = 15644;
pub const ERROR_DEPLOYMENT_OPTION_NOT_SUPPORTED: u32 = 15645;
pub const ERROR_APPINSTALLER_ACTIVATION_BLOCKED: u32 = 15646;
pub const ERROR_REGISTRATION_FROM_REMOTE_DRIVE_NOT_SUPPORTED: u32 = 15647;
pub const ERROR_APPX_RAW_DATA_WRITE_FAILED: u32 = 15648;
pub const ERROR_DEPLOYMENT_BLOCKED_BY_VOLUME_POLICY_PACKAGE: u32 = 15649;
pub const ERROR_DEPLOYMENT_BLOCKED_BY_VOLUME_POLICY_MACHINE: u32 = 15650;
pub const ERROR_DEPLOYMENT_BLOCKED_BY_PROFILE_POLICY: u32 = 15651;
pub const ERROR_DEPLOYMENT_FAILED_CONFLICTING_MUTABLE_PACKAGE_DIRECTORY: u32 = 15652;
pub const ERROR_SINGLETON_RESOURCE_INSTALLED_IN_ACTIVE_USER: u32 = 15653;
pub const ERROR_DIFFERENT_VERSION_OF_PACKAGED_SERVICE_INSTALLED: u32 = 15654;
pub const ERROR_SERVICE_EXISTS_AS_NON_PACKAGED_SERVICE: u32 = 15655;
pub const ERROR_PACKAGED_SERVICE_REQUIRES_ADMIN_PRIVILEGES: u32 = 15656;
pub const ERROR_REDIRECTION_TO_DEFAULT_ACCOUNT_NOT_ALLOWED: u32 = 15657;
pub const ERROR_PACKAGE_LACKS_CAPABILITY_TO_DEPLOY_ON_HOST: u32 = 15658;
pub const ERROR_UNSIGNED_PACKAGE_INVALID_CONTENT: u32 = 15659;
pub const ERROR_UNSIGNED_PACKAGE_INVALID_PUBLISHER_NAMESPACE: u32 = 15660;
pub const ERROR_SIGNED_PACKAGE_INVALID_PUBLISHER_NAMESPACE: u32 = 15661;
pub const ERROR_PACKAGE_EXTERNAL_LOCATION_NOT_ALLOWED: u32 = 15662;
pub const ERROR_INSTALL_FULLTRUST_HOSTRUNTIME_REQUIRES_MAIN_PACKAGE_FULLTRUST_CAPABILITY: u32 =
    15663;
pub const ERROR_PACKAGE_LACKS_CAPABILITY_FOR_MANDATORY_STARTUPTASKS: u32 = 15664;
pub const ERROR_INSTALL_RESOLVE_HOSTRUNTIME_DEPENDENCY_FAILED: u32 = 15665;
pub const ERROR_MACHINE_SCOPE_NOT_ALLOWED: u32 = 15666;
pub const ERROR_CLASSIC_COMPAT_MODE_NOT_ALLOWED: u32 = 15667;
pub const ERROR_STAGEFROMUPDATEAGENT_PACKAGE_NOT_APPLICABLE: u32 = 15668;
pub const ERROR_PACKAGE_NOT_REGISTERED_FOR_USER: u32 = 15669;
pub const APPMODEL_ERROR_NO_PACKAGE: u32 = 15700;
pub const APPMODEL_ERROR_PACKAGE_RUNTIME_CORRUPT: u32 = 15701;
pub const APPMODEL_ERROR_PACKAGE_IDENTITY_CORRUPT: u32 = 15702;
pub const APPMODEL_ERROR_NO_APPLICATION: u32 = 15703;
pub const APPMODEL_ERROR_DYNAMIC_PROPERTY_READ_FAILED: u32 = 15704;
pub const APPMODEL_ERROR_DYNAMIC_PROPERTY_INVALID: u32 = 15705;
pub const APPMODEL_ERROR_PACKAGE_NOT_AVAILABLE: u32 = 15706;
pub const APPMODEL_ERROR_NO_MUTABLE_DIRECTORY: u32 = 15707;
pub const ERROR_STATE_LOAD_STORE_FAILED: u32 = 15800;
pub const ERROR_STATE_GET_VERSION_FAILED: u32 = 15801;
pub const ERROR_STATE_SET_VERSION_FAILED: u32 = 15802;
pub const ERROR_STATE_STRUCTURED_RESET_FAILED: u32 = 15803;
pub const ERROR_STATE_OPEN_CONTAINER_FAILED: u32 = 15804;
pub const ERROR_STATE_CREATE_CONTAINER_FAILED: u32 = 15805;
pub const ERROR_STATE_DELETE_CONTAINER_FAILED: u32 = 15806;
pub const ERROR_STATE_READ_SETTING_FAILED: u32 = 15807;
pub const ERROR_STATE_WRITE_SETTING_FAILED: u32 = 15808;
pub const ERROR_STATE_DELETE_SETTING_FAILED: u32 = 15809;
pub const ERROR_STATE_QUERY_SETTING_FAILED: u32 = 15810;
pub const ERROR_STATE_READ_COMPOSITE_SETTING_FAILED: u32 = 15811;
pub const ERROR_STATE_WRITE_COMPOSITE_SETTING_FAILED: u32 = 15812;
pub const ERROR_STATE_ENUMERATE_CONTAINER_FAILED: u32 = 15813;
pub const ERROR_STATE_ENUMERATE_SETTINGS_FAILED: u32 = 15814;
pub const ERROR_STATE_COMPOSITE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED: u32 = 15815;
pub const ERROR_STATE_SETTING_VALUE_SIZE_LIMIT_EXCEEDED: u32 = 15816;
pub const ERROR_STATE_SETTING_NAME_SIZE_LIMIT_EXCEEDED: u32 = 15817;
pub const ERROR_STATE_CONTAINER_NAME_SIZE_LIMIT_EXCEEDED: u32 = 15818;
pub const ERROR_API_UNAVAILABLE: u32 = 15841;
pub const STORE_ERROR_UNLICENSED: u32 = 15861;
pub const STORE_ERROR_UNLICENSED_USER: u32 = 15862;
pub const STORE_ERROR_PENDING_COM_TRANSACTION: u32 = 15863;
pub const STORE_ERROR_LICENSE_REVOKED: u32 = 15864;
pub const SEVERITY_SUCCESS: u32 = 0;
pub const SEVERITY_ERROR: u32 = 1;
pub const FACILITY_NT_BIT: u32 = 268435456;
pub const NOERROR: u32 = 0;
pub const DRAGDROP_E_FIRST: u32 = 2147746048;
pub const DRAGDROP_E_LAST: u32 = 2147746063;
pub const DRAGDROP_S_FIRST: u32 = 262400;
pub const DRAGDROP_S_LAST: u32 = 262415;
pub const CLASSFACTORY_E_FIRST: u32 = 2147746064;
pub const CLASSFACTORY_E_LAST: u32 = 2147746079;
pub const CLASSFACTORY_S_FIRST: u32 = 262416;
pub const CLASSFACTORY_S_LAST: u32 = 262431;
pub const MARSHAL_E_FIRST: u32 = 2147746080;
pub const MARSHAL_E_LAST: u32 = 2147746095;
pub const MARSHAL_S_FIRST: u32 = 262432;
pub const MARSHAL_S_LAST: u32 = 262447;
pub const DATA_E_FIRST: u32 = 2147746096;
pub const DATA_E_LAST: u32 = 2147746111;
pub const DATA_S_FIRST: u32 = 262448;
pub const DATA_S_LAST: u32 = 262463;
pub const VIEW_E_FIRST: u32 = 2147746112;
pub const VIEW_E_LAST: u32 = 2147746127;
pub const VIEW_S_FIRST: u32 = 262464;
pub const VIEW_S_LAST: u32 = 262479;
pub const REGDB_E_FIRST: u32 = 2147746128;
pub const REGDB_E_LAST: u32 = 2147746143;
pub const REGDB_S_FIRST: u32 = 262480;
pub const REGDB_S_LAST: u32 = 262495;
pub const CAT_E_FIRST: u32 = 2147746144;
pub const CAT_E_LAST: u32 = 2147746145;
pub const CS_E_FIRST: u32 = 2147746148;
pub const CS_E_LAST: u32 = 2147746159;
pub const CACHE_E_FIRST: u32 = 2147746160;
pub const CACHE_E_LAST: u32 = 2147746175;
pub const CACHE_S_FIRST: u32 = 262512;
pub const CACHE_S_LAST: u32 = 262527;
pub const OLEOBJ_E_FIRST: u32 = 2147746176;
pub const OLEOBJ_E_LAST: u32 = 2147746191;
pub const OLEOBJ_S_FIRST: u32 = 262528;
pub const OLEOBJ_S_LAST: u32 = 262543;
pub const CLIENTSITE_E_FIRST: u32 = 2147746192;
pub const CLIENTSITE_E_LAST: u32 = 2147746207;
pub const CLIENTSITE_S_FIRST: u32 = 262544;
pub const CLIENTSITE_S_LAST: u32 = 262559;
pub const INPLACE_E_FIRST: u32 = 2147746208;
pub const INPLACE_E_LAST: u32 = 2147746223;
pub const INPLACE_S_FIRST: u32 = 262560;
pub const INPLACE_S_LAST: u32 = 262575;
pub const ENUM_E_FIRST: u32 = 2147746224;
pub const ENUM_E_LAST: u32 = 2147746239;
pub const ENUM_S_FIRST: u32 = 262576;
pub const ENUM_S_LAST: u32 = 262591;
pub const CONVERT10_E_FIRST: u32 = 2147746240;
pub const CONVERT10_E_LAST: u32 = 2147746255;
pub const CONVERT10_S_FIRST: u32 = 262592;
pub const CONVERT10_S_LAST: u32 = 262607;
pub const CLIPBRD_E_FIRST: u32 = 2147746256;
pub const CLIPBRD_E_LAST: u32 = 2147746271;
pub const CLIPBRD_S_FIRST: u32 = 262608;
pub const CLIPBRD_S_LAST: u32 = 262623;
pub const MK_E_FIRST: u32 = 2147746272;
pub const MK_E_LAST: u32 = 2147746287;
pub const MK_S_FIRST: u32 = 262624;
pub const MK_S_LAST: u32 = 262639;
pub const CO_E_FIRST: u32 = 2147746288;
pub const CO_E_LAST: u32 = 2147746303;
pub const CO_S_FIRST: u32 = 262640;
pub const CO_S_LAST: u32 = 262655;
pub const EVENT_E_FIRST: u32 = 2147746304;
pub const EVENT_E_LAST: u32 = 2147746335;
pub const EVENT_S_FIRST: u32 = 262656;
pub const EVENT_S_LAST: u32 = 262687;
pub const XACT_E_FIRST: u32 = 2147799040;
pub const XACT_E_LAST: u32 = 2147799083;
pub const XACT_S_FIRST: u32 = 315392;
pub const XACT_S_LAST: u32 = 315408;
pub const CONTEXT_E_FIRST: u32 = 2147803136;
pub const CONTEXT_E_LAST: u32 = 2147803183;
pub const CONTEXT_S_FIRST: u32 = 319488;
pub const CONTEXT_S_LAST: u32 = 319535;
pub const NTE_OP_OK: u32 = 0;
pub const SCARD_S_SUCCESS: u32 = 0;
pub const TC_NORMAL: u32 = 0;
pub const TC_HARDERR: u32 = 1;
pub const TC_GP_TRAP: u32 = 2;
pub const TC_SIGNAL: u32 = 3;
pub const AC_LINE_OFFLINE: u32 = 0;
pub const AC_LINE_ONLINE: u32 = 1;
pub const AC_LINE_BACKUP_POWER: u32 = 2;
pub const AC_LINE_UNKNOWN: u32 = 255;
pub const BATTERY_FLAG_HIGH: u32 = 1;
pub const BATTERY_FLAG_LOW: u32 = 2;
pub const BATTERY_FLAG_CRITICAL: u32 = 4;
pub const BATTERY_FLAG_CHARGING: u32 = 8;
pub const BATTERY_FLAG_NO_BATTERY: u32 = 128;
pub const BATTERY_FLAG_UNKNOWN: u32 = 255;
pub const BATTERY_PERCENTAGE_UNKNOWN: u32 = 255;
pub const SYSTEM_STATUS_FLAG_POWER_SAVING_ON: u32 = 1;
pub const BATTERY_LIFE_UNKNOWN: u32 = 4294967295;
pub const ACTCTX_FLAG_PROCESSOR_ARCHITECTURE_VALID: u32 = 1;
pub const ACTCTX_FLAG_LANGID_VALID: u32 = 2;
pub const ACTCTX_FLAG_ASSEMBLY_DIRECTORY_VALID: u32 = 4;
pub const ACTCTX_FLAG_RESOURCE_NAME_VALID: u32 = 8;
pub const ACTCTX_FLAG_SET_PROCESS_DEFAULT: u32 = 16;
pub const ACTCTX_FLAG_APPLICATION_NAME_VALID: u32 = 32;
pub const ACTCTX_FLAG_SOURCE_IS_ASSEMBLYREF: u32 = 64;
pub const ACTCTX_FLAG_HMODULE_VALID: u32 = 128;
pub const DEACTIVATE_ACTCTX_FLAG_FORCE_EARLY_DEACTIVATION: u32 = 1;
pub const FIND_ACTCTX_SECTION_KEY_RETURN_HACTCTX: u32 = 1;
pub const FIND_ACTCTX_SECTION_KEY_RETURN_FLAGS: u32 = 2;
pub const FIND_ACTCTX_SECTION_KEY_RETURN_ASSEMBLY_METADATA: u32 = 4;
pub const ACTIVATION_CONTEXT_BASIC_INFORMATION_DEFINED: u32 = 1;
pub const QUERY_ACTCTX_FLAG_USE_ACTIVE_ACTCTX: u32 = 4;
pub const QUERY_ACTCTX_FLAG_ACTCTX_IS_HMODULE: u32 = 8;
pub const QUERY_ACTCTX_FLAG_ACTCTX_IS_ADDRESS: u32 = 16;
pub const QUERY_ACTCTX_FLAG_NO_ADDREF: u32 = 2147483648;
pub const RESTART_MAX_CMD_LINE: u32 = 1024;
pub const RESTART_NO_CRASH: u32 = 1;
pub const RESTART_NO_HANG: u32 = 2;
pub const RESTART_NO_PATCH: u32 = 4;
pub const RESTART_NO_REBOOT: u32 = 8;
pub const RECOVERY_DEFAULT_PING_INTERVAL: u32 = 5000;
pub const RECOVERY_MAX_PING_INTERVAL: u32 = 300000;
pub const FILE_RENAME_FLAG_REPLACE_IF_EXISTS: u32 = 1;
pub const FILE_RENAME_FLAG_POSIX_SEMANTICS: u32 = 2;
pub const FILE_RENAME_FLAG_SUPPRESS_PIN_STATE_INHERITANCE: u32 = 4;
pub const FILE_DISPOSITION_FLAG_DO_NOT_DELETE: u32 = 0;
pub const FILE_DISPOSITION_FLAG_DELETE: u32 = 1;
pub const FILE_DISPOSITION_FLAG_POSIX_SEMANTICS: u32 = 2;
pub const FILE_DISPOSITION_FLAG_FORCE_IMAGE_SECTION_CHECK: u32 = 4;
pub const FILE_DISPOSITION_FLAG_ON_CLOSE: u32 = 8;
pub const FILE_DISPOSITION_FLAG_IGNORE_READONLY_ATTRIBUTE: u32 = 16;
pub const STORAGE_INFO_FLAGS_ALIGNED_DEVICE: u32 = 1;
pub const STORAGE_INFO_FLAGS_PARTITION_ALIGNED_ON_DEVICE: u32 = 2;
pub const STORAGE_INFO_OFFSET_UNKNOWN: u32 = 4294967295;
pub const REMOTE_PROTOCOL_INFO_FLAG_LOOPBACK: u32 = 1;
pub const REMOTE_PROTOCOL_INFO_FLAG_OFFLINE: u32 = 2;
pub const REMOTE_PROTOCOL_INFO_FLAG_PERSISTENT_HANDLE: u32 = 4;
pub const RPI_FLAG_SMB2_SHARECAP_TIMEWARP: u32 = 2;
pub const RPI_FLAG_SMB2_SHARECAP_DFS: u32 = 8;
pub const RPI_FLAG_SMB2_SHARECAP_CONTINUOUS_AVAILABILITY: u32 = 16;
pub const RPI_FLAG_SMB2_SHARECAP_SCALEOUT: u32 = 32;
pub const RPI_FLAG_SMB2_SHARECAP_CLUSTER: u32 = 64;
pub const RPI_SMB2_SHAREFLAG_ENCRYPT_DATA: u32 = 1;
pub const RPI_SMB2_FLAG_SERVERCAP_DFS: u32 = 1;
pub const RPI_SMB2_FLAG_SERVERCAP_LEASING: u32 = 2;
pub const RPI_SMB2_FLAG_SERVERCAP_LARGEMTU: u32 = 4;
pub const RPI_SMB2_FLAG_SERVERCAP_MULTICHANNEL: u32 = 8;
pub const RPI_SMB2_FLAG_SERVERCAP_PERSISTENT_HANDLES: u32 = 16;
pub const RPI_SMB2_FLAG_SERVERCAP_DIRECTORY_LEASING: u32 = 32;
pub const SYMBOLIC_LINK_FLAG_DIRECTORY: u32 = 1;
pub const SYMBOLIC_LINK_FLAG_ALLOW_UNPRIVILEGED_CREATE: u32 = 2;
pub const MICROSOFT_WINDOWS_WINBASE_H_DEFINE_INTERLOCKED_CPLUSPLUS_OVERLOADS: u32 = 1;
pub const MICROSOFT_WINBASE_H_DEFINE_INTERLOCKED_CPLUSPLUS_OVERLOADS: u32 = 0;
pub const R2_BLACK: u32 = 1;
pub const R2_NOTMERGEPEN: u32 = 2;
pub const R2_MASKNOTPEN: u32 = 3;
pub const R2_NOTCOPYPEN: u32 = 4;
pub const R2_MASKPENNOT: u32 = 5;
pub const R2_NOT: u32 = 6;
pub const R2_XORPEN: u32 = 7;
pub const R2_NOTMASKPEN: u32 = 8;
pub const R2_MASKPEN: u32 = 9;
pub const R2_NOTXORPEN: u32 = 10;
pub const R2_NOP: u32 = 11;
pub const R2_MERGENOTPEN: u32 = 12;
pub const R2_COPYPEN: u32 = 13;
pub const R2_MERGEPENNOT: u32 = 14;
pub const R2_MERGEPEN: u32 = 15;
pub const R2_WHITE: u32 = 16;
pub const R2_LAST: u32 = 16;
pub const GDI_ERROR: u32 = 4294967295;
pub const ERROR: u32 = 0;
pub const NULLREGION: u32 = 1;
pub const SIMPLEREGION: u32 = 2;
pub const COMPLEXREGION: u32 = 3;
pub const RGN_ERROR: u32 = 0;
pub const RGN_AND: u32 = 1;
pub const RGN_OR: u32 = 2;
pub const RGN_XOR: u32 = 3;
pub const RGN_DIFF: u32 = 4;
pub const RGN_COPY: u32 = 5;
pub const RGN_MIN: u32 = 1;
pub const RGN_MAX: u32 = 5;
pub const BLACKONWHITE: u32 = 1;
pub const WHITEONBLACK: u32 = 2;
pub const COLORONCOLOR: u32 = 3;
pub const HALFTONE: u32 = 4;
pub const MAXSTRETCHBLTMODE: u32 = 4;
pub const STRETCH_ANDSCANS: u32 = 1;
pub const STRETCH_ORSCANS: u32 = 2;
pub const STRETCH_DELETESCANS: u32 = 3;
pub const STRETCH_HALFTONE: u32 = 4;
pub const ALTERNATE: u32 = 1;
pub const WINDING: u32 = 2;
pub const POLYFILL_LAST: u32 = 2;
pub const LAYOUT_RTL: u32 = 1;
pub const LAYOUT_BTT: u32 = 2;
pub const LAYOUT_VBH: u32 = 4;
pub const LAYOUT_ORIENTATIONMASK: u32 = 7;
pub const LAYOUT_BITMAPORIENTATIONPRESERVED: u32 = 8;
pub const TA_NOUPDATECP: u32 = 0;
pub const TA_UPDATECP: u32 = 1;
pub const TA_LEFT: u32 = 0;
pub const TA_RIGHT: u32 = 2;
pub const TA_CENTER: u32 = 6;
pub const TA_TOP: u32 = 0;
pub const TA_BOTTOM: u32 = 8;
pub const TA_BASELINE: u32 = 24;
pub const TA_RTLREADING: u32 = 256;
pub const TA_MASK: u32 = 287;
pub const VTA_BASELINE: u32 = 24;
pub const VTA_LEFT: u32 = 8;
pub const VTA_RIGHT: u32 = 0;
pub const VTA_CENTER: u32 = 6;
pub const VTA_BOTTOM: u32 = 2;
pub const VTA_TOP: u32 = 0;
pub const ETO_OPAQUE: u32 = 2;
pub const ETO_CLIPPED: u32 = 4;
pub const ETO_GLYPH_INDEX: u32 = 16;
pub const ETO_RTLREADING: u32 = 128;
pub const ETO_NUMERICSLOCAL: u32 = 1024;
pub const ETO_NUMERICSLATIN: u32 = 2048;
pub const ETO_IGNORELANGUAGE: u32 = 4096;
pub const ETO_PDY: u32 = 8192;
pub const ETO_REVERSE_INDEX_MAP: u32 = 65536;
pub const ASPECT_FILTERING: u32 = 1;
pub const DCB_RESET: u32 = 1;
pub const DCB_ACCUMULATE: u32 = 2;
pub const DCB_DIRTY: u32 = 2;
pub const DCB_SET: u32 = 3;
pub const DCB_ENABLE: u32 = 4;
pub const DCB_DISABLE: u32 = 8;
pub const META_SETBKCOLOR: u32 = 513;
pub const META_SETBKMODE: u32 = 258;
pub const META_SETMAPMODE: u32 = 259;
pub const META_SETROP2: u32 = 260;
pub const META_SETRELABS: u32 = 261;
pub const META_SETPOLYFILLMODE: u32 = 262;
pub const META_SETSTRETCHBLTMODE: u32 = 263;
pub const META_SETTEXTCHAREXTRA: u32 = 264;
pub const META_SETTEXTCOLOR: u32 = 521;
pub const META_SETTEXTJUSTIFICATION: u32 = 522;
pub const META_SETWINDOWORG: u32 = 523;
pub const META_SETWINDOWEXT: u32 = 524;
pub const META_SETVIEWPORTORG: u32 = 525;
pub const META_SETVIEWPORTEXT: u32 = 526;
pub const META_OFFSETWINDOWORG: u32 = 527;
pub const META_SCALEWINDOWEXT: u32 = 1040;
pub const META_OFFSETVIEWPORTORG: u32 = 529;
pub const META_SCALEVIEWPORTEXT: u32 = 1042;
pub const META_LINETO: u32 = 531;
pub const META_MOVETO: u32 = 532;
pub const META_EXCLUDECLIPRECT: u32 = 1045;
pub const META_INTERSECTCLIPRECT: u32 = 1046;
pub const META_ARC: u32 = 2071;
pub const META_ELLIPSE: u32 = 1048;
pub const META_FLOODFILL: u32 = 1049;
pub const META_PIE: u32 = 2074;
pub const META_RECTANGLE: u32 = 1051;
pub const META_ROUNDRECT: u32 = 1564;
pub const META_PATBLT: u32 = 1565;
pub const META_SAVEDC: u32 = 30;
pub const META_SETPIXEL: u32 = 1055;
pub const META_OFFSETCLIPRGN: u32 = 544;
pub const META_TEXTOUT: u32 = 1313;
pub const META_BITBLT: u32 = 2338;
pub const META_STRETCHBLT: u32 = 2851;
pub const META_POLYGON: u32 = 804;
pub const META_POLYLINE: u32 = 805;
pub const META_ESCAPE: u32 = 1574;
pub const META_RESTOREDC: u32 = 295;
pub const META_FILLREGION: u32 = 552;
pub const META_FRAMEREGION: u32 = 1065;
pub const META_INVERTREGION: u32 = 298;
pub const META_PAINTREGION: u32 = 299;
pub const META_SELECTCLIPREGION: u32 = 300;
pub const META_SELECTOBJECT: u32 = 301;
pub const META_SETTEXTALIGN: u32 = 302;
pub const META_CHORD: u32 = 2096;
pub const META_SETMAPPERFLAGS: u32 = 561;
pub const META_EXTTEXTOUT: u32 = 2610;
pub const META_SETDIBTODEV: u32 = 3379;
pub const META_SELECTPALETTE: u32 = 564;
pub const META_REALIZEPALETTE: u32 = 53;
pub const META_ANIMATEPALETTE: u32 = 1078;
pub const META_SETPALENTRIES: u32 = 55;
pub const META_POLYPOLYGON: u32 = 1336;
pub const META_RESIZEPALETTE: u32 = 313;
pub const META_DIBBITBLT: u32 = 2368;
pub const META_DIBSTRETCHBLT: u32 = 2881;
pub const META_DIBCREATEPATTERNBRUSH: u32 = 322;
pub const META_STRETCHDIB: u32 = 3907;
pub const META_EXTFLOODFILL: u32 = 1352;
pub const META_SETLAYOUT: u32 = 329;
pub const META_DELETEOBJECT: u32 = 496;
pub const META_CREATEPALETTE: u32 = 247;
pub const META_CREATEPATTERNBRUSH: u32 = 505;
pub const META_CREATEPENINDIRECT: u32 = 762;
pub const META_CREATEFONTINDIRECT: u32 = 763;
pub const META_CREATEBRUSHINDIRECT: u32 = 764;
pub const META_CREATEREGION: u32 = 1791;
pub const NEWFRAME: u32 = 1;
pub const ABORTDOC: u32 = 2;
pub const NEXTBAND: u32 = 3;
pub const SETCOLORTABLE: u32 = 4;
pub const GETCOLORTABLE: u32 = 5;
pub const FLUSHOUTPUT: u32 = 6;
pub const DRAFTMODE: u32 = 7;
pub const QUERYESCSUPPORT: u32 = 8;
pub const SETABORTPROC: u32 = 9;
pub const STARTDOC: u32 = 10;
pub const ENDDOC: u32 = 11;
pub const GETPHYSPAGESIZE: u32 = 12;
pub const GETPRINTINGOFFSET: u32 = 13;
pub const GETSCALINGFACTOR: u32 = 14;
pub const MFCOMMENT: u32 = 15;
pub const GETPENWIDTH: u32 = 16;
pub const SETCOPYCOUNT: u32 = 17;
pub const SELECTPAPERSOURCE: u32 = 18;
pub const DEVICEDATA: u32 = 19;
pub const PASSTHROUGH: u32 = 19;
pub const GETTECHNOLGY: u32 = 20;
pub const GETTECHNOLOGY: u32 = 20;
pub const SETLINECAP: u32 = 21;
pub const SETLINEJOIN: u32 = 22;
pub const SETMITERLIMIT: u32 = 23;
pub const BANDINFO: u32 = 24;
pub const DRAWPATTERNRECT: u32 = 25;
pub const GETVECTORPENSIZE: u32 = 26;
pub const GETVECTORBRUSHSIZE: u32 = 27;
pub const ENABLEDUPLEX: u32 = 28;
pub const GETSETPAPERBINS: u32 = 29;
pub const GETSETPRINTORIENT: u32 = 30;
pub const ENUMPAPERBINS: u32 = 31;
pub const SETDIBSCALING: u32 = 32;
pub const EPSPRINTING: u32 = 33;
pub const ENUMPAPERMETRICS: u32 = 34;
pub const GETSETPAPERMETRICS: u32 = 35;
pub const POSTSCRIPT_DATA: u32 = 37;
pub const POSTSCRIPT_IGNORE: u32 = 38;
pub const MOUSETRAILS: u32 = 39;
pub const GETDEVICEUNITS: u32 = 42;
pub const GETEXTENDEDTEXTMETRICS: u32 = 256;
pub const GETEXTENTTABLE: u32 = 257;
pub const GETPAIRKERNTABLE: u32 = 258;
pub const GETTRACKKERNTABLE: u32 = 259;
pub const EXTTEXTOUT: u32 = 512;
pub const GETFACENAME: u32 = 513;
pub const DOWNLOADFACE: u32 = 514;
pub const ENABLERELATIVEWIDTHS: u32 = 768;
pub const ENABLEPAIRKERNING: u32 = 769;
pub const SETKERNTRACK: u32 = 770;
pub const SETALLJUSTVALUES: u32 = 771;
pub const SETCHARSET: u32 = 772;
pub const STRETCHBLT: u32 = 2048;
pub const METAFILE_DRIVER: u32 = 2049;
pub const GETSETSCREENPARAMS: u32 = 3072;
pub const QUERYDIBSUPPORT: u32 = 3073;
pub const BEGIN_PATH: u32 = 4096;
pub const CLIP_TO_PATH: u32 = 4097;
pub const END_PATH: u32 = 4098;
pub const EXT_DEVICE_CAPS: u32 = 4099;
pub const RESTORE_CTM: u32 = 4100;
pub const SAVE_CTM: u32 = 4101;
pub const SET_ARC_DIRECTION: u32 = 4102;
pub const SET_BACKGROUND_COLOR: u32 = 4103;
pub const SET_POLY_MODE: u32 = 4104;
pub const SET_SCREEN_ANGLE: u32 = 4105;
pub const SET_SPREAD: u32 = 4106;
pub const TRANSFORM_CTM: u32 = 4107;
pub const SET_CLIP_BOX: u32 = 4108;
pub const SET_BOUNDS: u32 = 4109;
pub const SET_MIRROR_MODE: u32 = 4110;
pub const OPENCHANNEL: u32 = 4110;
pub const DOWNLOADHEADER: u32 = 4111;
pub const CLOSECHANNEL: u32 = 4112;
pub const POSTSCRIPT_PASSTHROUGH: u32 = 4115;
pub const ENCAPSULATED_POSTSCRIPT: u32 = 4116;
pub const POSTSCRIPT_IDENTIFY: u32 = 4117;
pub const POSTSCRIPT_INJECTION: u32 = 4118;
pub const CHECKJPEGFORMAT: u32 = 4119;
pub const CHECKPNGFORMAT: u32 = 4120;
pub const GET_PS_FEATURESETTING: u32 = 4121;
pub const GDIPLUS_TS_QUERYVER: u32 = 4122;
pub const GDIPLUS_TS_RECORD: u32 = 4123;
pub const MILCORE_TS_QUERYVER_RESULT_FALSE: u32 = 0;
pub const MILCORE_TS_QUERYVER_RESULT_TRUE: u32 = 2147483647;
pub const SPCLPASSTHROUGH2: u32 = 4568;
pub const PSIDENT_GDICENTRIC: u32 = 0;
pub const PSIDENT_PSCENTRIC: u32 = 1;
pub const PSINJECT_BEGINSTREAM: u32 = 1;
pub const PSINJECT_PSADOBE: u32 = 2;
pub const PSINJECT_PAGESATEND: u32 = 3;
pub const PSINJECT_PAGES: u32 = 4;
pub const PSINJECT_DOCNEEDEDRES: u32 = 5;
pub const PSINJECT_DOCSUPPLIEDRES: u32 = 6;
pub const PSINJECT_PAGEORDER: u32 = 7;
pub const PSINJECT_ORIENTATION: u32 = 8;
pub const PSINJECT_BOUNDINGBOX: u32 = 9;
pub const PSINJECT_DOCUMENTPROCESSCOLORS: u32 = 10;
pub const PSINJECT_COMMENTS: u32 = 11;
pub const PSINJECT_BEGINDEFAULTS: u32 = 12;
pub const PSINJECT_ENDDEFAULTS: u32 = 13;
pub const PSINJECT_BEGINPROLOG: u32 = 14;
pub const PSINJECT_ENDPROLOG: u32 = 15;
pub const PSINJECT_BEGINSETUP: u32 = 16;
pub const PSINJECT_ENDSETUP: u32 = 17;
pub const PSINJECT_TRAILER: u32 = 18;
pub const PSINJECT_EOF: u32 = 19;
pub const PSINJECT_ENDSTREAM: u32 = 20;
pub const PSINJECT_DOCUMENTPROCESSCOLORSATEND: u32 = 21;
pub const PSINJECT_PAGENUMBER: u32 = 100;
pub const PSINJECT_BEGINPAGESETUP: u32 = 101;
pub const PSINJECT_ENDPAGESETUP: u32 = 102;
pub const PSINJECT_PAGETRAILER: u32 = 103;
pub const PSINJECT_PLATECOLOR: u32 = 104;
pub const PSINJECT_SHOWPAGE: u32 = 105;
pub const PSINJECT_PAGEBBOX: u32 = 106;
pub const PSINJECT_ENDPAGECOMMENTS: u32 = 107;
pub const PSINJECT_VMSAVE: u32 = 200;
pub const PSINJECT_VMRESTORE: u32 = 201;
pub const PSINJECT_DLFONT: u32 = 3722304989;
pub const FEATURESETTING_NUP: u32 = 0;
pub const FEATURESETTING_OUTPUT: u32 = 1;
pub const FEATURESETTING_PSLEVEL: u32 = 2;
pub const FEATURESETTING_CUSTPAPER: u32 = 3;
pub const FEATURESETTING_MIRROR: u32 = 4;
pub const FEATURESETTING_NEGATIVE: u32 = 5;
pub const FEATURESETTING_PROTOCOL: u32 = 6;
pub const FEATURESETTING_PRIVATE_BEGIN: u32 = 4096;
pub const FEATURESETTING_PRIVATE_END: u32 = 8191;
pub const PSPROTOCOL_ASCII: u32 = 0;
pub const PSPROTOCOL_BCP: u32 = 1;
pub const PSPROTOCOL_TBCP: u32 = 2;
pub const PSPROTOCOL_BINARY: u32 = 3;
pub const QDI_SETDIBITS: u32 = 1;
pub const QDI_GETDIBITS: u32 = 2;
pub const QDI_DIBTOSCREEN: u32 = 4;
pub const QDI_STRETCHDIB: u32 = 8;
pub const SP_NOTREPORTED: u32 = 16384;
pub const SP_ERROR: i32 = -1;
pub const SP_APPABORT: i32 = -2;
pub const SP_USERABORT: i32 = -3;
pub const SP_OUTOFDISK: i32 = -4;
pub const SP_OUTOFMEMORY: i32 = -5;
pub const PR_JOBSTATUS: u32 = 0;
pub const OBJ_PEN: u32 = 1;
pub const OBJ_BRUSH: u32 = 2;
pub const OBJ_DC: u32 = 3;
pub const OBJ_METADC: u32 = 4;
pub const OBJ_PAL: u32 = 5;
pub const OBJ_FONT: u32 = 6;
pub const OBJ_BITMAP: u32 = 7;
pub const OBJ_REGION: u32 = 8;
pub const OBJ_METAFILE: u32 = 9;
pub const OBJ_MEMDC: u32 = 10;
pub const OBJ_EXTPEN: u32 = 11;
pub const OBJ_ENHMETADC: u32 = 12;
pub const OBJ_ENHMETAFILE: u32 = 13;
pub const OBJ_COLORSPACE: u32 = 14;
pub const GDI_OBJ_LAST: u32 = 14;
pub const GDI_MIN_OBJ_TYPE: u32 = 1;
pub const GDI_MAX_OBJ_TYPE: u32 = 14;
pub const MWT_IDENTITY: u32 = 1;
pub const MWT_LEFTMULTIPLY: u32 = 2;
pub const MWT_RIGHTMULTIPLY: u32 = 3;
pub const MWT_MIN: u32 = 1;
pub const MWT_MAX: u32 = 3;
pub const CS_ENABLE: u32 = 1;
pub const CS_DISABLE: u32 = 2;
pub const CS_DELETE_TRANSFORM: u32 = 3;
pub const LCS_CALIBRATED_RGB: u32 = 0;
pub const LCS_GM_BUSINESS: u32 = 1;
pub const LCS_GM_GRAPHICS: u32 = 2;
pub const LCS_GM_IMAGES: u32 = 4;
pub const LCS_GM_ABS_COLORIMETRIC: u32 = 8;
pub const CM_OUT_OF_GAMUT: u32 = 255;
pub const CM_IN_GAMUT: u32 = 0;
pub const ICM_ADDPROFILE: u32 = 1;
pub const ICM_DELETEPROFILE: u32 = 2;
pub const ICM_QUERYPROFILE: u32 = 3;
pub const ICM_SETDEFAULTPROFILE: u32 = 4;
pub const ICM_REGISTERICMATCHER: u32 = 5;
pub const ICM_UNREGISTERICMATCHER: u32 = 6;
pub const ICM_QUERYMATCH: u32 = 7;
pub const BI_RGB: u32 = 0;
pub const BI_RLE8: u32 = 1;
pub const BI_RLE4: u32 = 2;
pub const BI_BITFIELDS: u32 = 3;
pub const BI_JPEG: u32 = 4;
pub const BI_PNG: u32 = 5;
pub const TCI_SRCCHARSET: u32 = 1;
pub const TCI_SRCCODEPAGE: u32 = 2;
pub const TCI_SRCFONTSIG: u32 = 3;
pub const TCI_SRCLOCALE: u32 = 4096;
pub const TMPF_FIXED_PITCH: u32 = 1;
pub const TMPF_VECTOR: u32 = 2;
pub const TMPF_DEVICE: u32 = 8;
pub const TMPF_TRUETYPE: u32 = 4;
pub const NTM_REGULAR: u32 = 64;
pub const NTM_BOLD: u32 = 32;
pub const NTM_ITALIC: u32 = 1;
pub const NTM_NONNEGATIVE_AC: u32 = 65536;
pub const NTM_PS_OPENTYPE: u32 = 131072;
pub const NTM_TT_OPENTYPE: u32 = 262144;
pub const NTM_MULTIPLEMASTER: u32 = 524288;
pub const NTM_TYPE1: u32 = 1048576;
pub const NTM_DSIG: u32 = 2097152;
pub const LF_FACESIZE: u32 = 32;
pub const LF_FULLFACESIZE: u32 = 64;
pub const OUT_DEFAULT_PRECIS: u32 = 0;
pub const OUT_STRING_PRECIS: u32 = 1;
pub const OUT_CHARACTER_PRECIS: u32 = 2;
pub const OUT_STROKE_PRECIS: u32 = 3;
pub const OUT_TT_PRECIS: u32 = 4;
pub const OUT_DEVICE_PRECIS: u32 = 5;
pub const OUT_RASTER_PRECIS: u32 = 6;
pub const OUT_TT_ONLY_PRECIS: u32 = 7;
pub const OUT_OUTLINE_PRECIS: u32 = 8;
pub const OUT_SCREEN_OUTLINE_PRECIS: u32 = 9;
pub const OUT_PS_ONLY_PRECIS: u32 = 10;
pub const CLIP_DEFAULT_PRECIS: u32 = 0;
pub const CLIP_CHARACTER_PRECIS: u32 = 1;
pub const CLIP_STROKE_PRECIS: u32 = 2;
pub const CLIP_MASK: u32 = 15;
pub const CLIP_LH_ANGLES: u32 = 16;
pub const CLIP_TT_ALWAYS: u32 = 32;
pub const CLIP_DFA_DISABLE: u32 = 64;
pub const CLIP_EMBEDDED: u32 = 128;
pub const DEFAULT_QUALITY: u32 = 0;
pub const DRAFT_QUALITY: u32 = 1;
pub const PROOF_QUALITY: u32 = 2;
pub const NONANTIALIASED_QUALITY: u32 = 3;
pub const ANTIALIASED_QUALITY: u32 = 4;
pub const CLEARTYPE_QUALITY: u32 = 5;
pub const CLEARTYPE_NATURAL_QUALITY: u32 = 6;
pub const DEFAULT_PITCH: u32 = 0;
pub const FIXED_PITCH: u32 = 1;
pub const VARIABLE_PITCH: u32 = 2;
pub const MONO_FONT: u32 = 8;
pub const ANSI_CHARSET: u32 = 0;
pub const DEFAULT_CHARSET: u32 = 1;
pub const SYMBOL_CHARSET: u32 = 2;
pub const SHIFTJIS_CHARSET: u32 = 128;
pub const HANGEUL_CHARSET: u32 = 129;
pub const HANGUL_CHARSET: u32 = 129;
pub const GB2312_CHARSET: u32 = 134;
pub const CHINESEBIG5_CHARSET: u32 = 136;
pub const OEM_CHARSET: u32 = 255;
pub const JOHAB_CHARSET: u32 = 130;
pub const HEBREW_CHARSET: u32 = 177;
pub const ARABIC_CHARSET: u32 = 178;
pub const GREEK_CHARSET: u32 = 161;
pub const TURKISH_CHARSET: u32 = 162;
pub const VIETNAMESE_CHARSET: u32 = 163;
pub const THAI_CHARSET: u32 = 222;
pub const EASTEUROPE_CHARSET: u32 = 238;
pub const RUSSIAN_CHARSET: u32 = 204;
pub const MAC_CHARSET: u32 = 77;
pub const BALTIC_CHARSET: u32 = 186;
pub const FS_LATIN1: u32 = 1;
pub const FS_LATIN2: u32 = 2;
pub const FS_CYRILLIC: u32 = 4;
pub const FS_GREEK: u32 = 8;
pub const FS_TURKISH: u32 = 16;
pub const FS_HEBREW: u32 = 32;
pub const FS_ARABIC: u32 = 64;
pub const FS_BALTIC: u32 = 128;
pub const FS_VIETNAMESE: u32 = 256;
pub const FS_THAI: u32 = 65536;
pub const FS_JISJAPAN: u32 = 131072;
pub const FS_CHINESESIMP: u32 = 262144;
pub const FS_WANSUNG: u32 = 524288;
pub const FS_CHINESETRAD: u32 = 1048576;
pub const FS_JOHAB: u32 = 2097152;
pub const FS_SYMBOL: u32 = 2147483648;
pub const FF_DONTCARE: u32 = 0;
pub const FF_ROMAN: u32 = 16;
pub const FF_SWISS: u32 = 32;
pub const FF_MODERN: u32 = 48;
pub const FF_SCRIPT: u32 = 64;
pub const FF_DECORATIVE: u32 = 80;
pub const FW_DONTCARE: u32 = 0;
pub const FW_THIN: u32 = 100;
pub const FW_EXTRALIGHT: u32 = 200;
pub const FW_LIGHT: u32 = 300;
pub const FW_NORMAL: u32 = 400;
pub const FW_MEDIUM: u32 = 500;
pub const FW_SEMIBOLD: u32 = 600;
pub const FW_BOLD: u32 = 700;
pub const FW_EXTRABOLD: u32 = 800;
pub const FW_HEAVY: u32 = 900;
pub const FW_ULTRALIGHT: u32 = 200;
pub const FW_REGULAR: u32 = 400;
pub const FW_DEMIBOLD: u32 = 600;
pub const FW_ULTRABOLD: u32 = 800;
pub const FW_BLACK: u32 = 900;
pub const PANOSE_COUNT: u32 = 10;
pub const PAN_FAMILYTYPE_INDEX: u32 = 0;
pub const PAN_SERIFSTYLE_INDEX: u32 = 1;
pub const PAN_WEIGHT_INDEX: u32 = 2;
pub const PAN_PROPORTION_INDEX: u32 = 3;
pub const PAN_CONTRAST_INDEX: u32 = 4;
pub const PAN_STROKEVARIATION_INDEX: u32 = 5;
pub const PAN_ARMSTYLE_INDEX: u32 = 6;
pub const PAN_LETTERFORM_INDEX: u32 = 7;
pub const PAN_MIDLINE_INDEX: u32 = 8;
pub const PAN_XHEIGHT_INDEX: u32 = 9;
pub const PAN_CULTURE_LATIN: u32 = 0;
pub const PAN_ANY: u32 = 0;
pub const PAN_NO_FIT: u32 = 1;
pub const PAN_FAMILY_TEXT_DISPLAY: u32 = 2;
pub const PAN_FAMILY_SCRIPT: u32 = 3;
pub const PAN_FAMILY_DECORATIVE: u32 = 4;
pub const PAN_FAMILY_PICTORIAL: u32 = 5;
pub const PAN_SERIF_COVE: u32 = 2;
pub const PAN_SERIF_OBTUSE_COVE: u32 = 3;
pub const PAN_SERIF_SQUARE_COVE: u32 = 4;
pub const PAN_SERIF_OBTUSE_SQUARE_COVE: u32 = 5;
pub const PAN_SERIF_SQUARE: u32 = 6;
pub const PAN_SERIF_THIN: u32 = 7;
pub const PAN_SERIF_BONE: u32 = 8;
pub const PAN_SERIF_EXAGGERATED: u32 = 9;
pub const PAN_SERIF_TRIANGLE: u32 = 10;
pub const PAN_SERIF_NORMAL_SANS: u32 = 11;
pub const PAN_SERIF_OBTUSE_SANS: u32 = 12;
pub const PAN_SERIF_PERP_SANS: u32 = 13;
pub const PAN_SERIF_FLARED: u32 = 14;
pub const PAN_SERIF_ROUNDED: u32 = 15;
pub const PAN_WEIGHT_VERY_LIGHT: u32 = 2;
pub const PAN_WEIGHT_LIGHT: u32 = 3;
pub const PAN_WEIGHT_THIN: u32 = 4;
pub const PAN_WEIGHT_BOOK: u32 = 5;
pub const PAN_WEIGHT_MEDIUM: u32 = 6;
pub const PAN_WEIGHT_DEMI: u32 = 7;
pub const PAN_WEIGHT_BOLD: u32 = 8;
pub const PAN_WEIGHT_HEAVY: u32 = 9;
pub const PAN_WEIGHT_BLACK: u32 = 10;
pub const PAN_WEIGHT_NORD: u32 = 11;
pub const PAN_PROP_OLD_STYLE: u32 = 2;
pub const PAN_PROP_MODERN: u32 = 3;
pub const PAN_PROP_EVEN_WIDTH: u32 = 4;
pub const PAN_PROP_EXPANDED: u32 = 5;
pub const PAN_PROP_CONDENSED: u32 = 6;
pub const PAN_PROP_VERY_EXPANDED: u32 = 7;
pub const PAN_PROP_VERY_CONDENSED: u32 = 8;
pub const PAN_PROP_MONOSPACED: u32 = 9;
pub const PAN_CONTRAST_NONE: u32 = 2;
pub const PAN_CONTRAST_VERY_LOW: u32 = 3;
pub const PAN_CONTRAST_LOW: u32 = 4;
pub const PAN_CONTRAST_MEDIUM_LOW: u32 = 5;
pub const PAN_CONTRAST_MEDIUM: u32 = 6;
pub const PAN_CONTRAST_MEDIUM_HIGH: u32 = 7;
pub const PAN_CONTRAST_HIGH: u32 = 8;
pub const PAN_CONTRAST_VERY_HIGH: u32 = 9;
pub const PAN_STROKE_GRADUAL_DIAG: u32 = 2;
pub const PAN_STROKE_GRADUAL_TRAN: u32 = 3;
pub const PAN_STROKE_GRADUAL_VERT: u32 = 4;
pub const PAN_STROKE_GRADUAL_HORZ: u32 = 5;
pub const PAN_STROKE_RAPID_VERT: u32 = 6;
pub const PAN_STROKE_RAPID_HORZ: u32 = 7;
pub const PAN_STROKE_INSTANT_VERT: u32 = 8;
pub const PAN_STRAIGHT_ARMS_HORZ: u32 = 2;
pub const PAN_STRAIGHT_ARMS_WEDGE: u32 = 3;
pub const PAN_STRAIGHT_ARMS_VERT: u32 = 4;
pub const PAN_STRAIGHT_ARMS_SINGLE_SERIF: u32 = 5;
pub const PAN_STRAIGHT_ARMS_DOUBLE_SERIF: u32 = 6;
pub const PAN_BENT_ARMS_HORZ: u32 = 7;
pub const PAN_BENT_ARMS_WEDGE: u32 = 8;
pub const PAN_BENT_ARMS_VERT: u32 = 9;
pub const PAN_BENT_ARMS_SINGLE_SERIF: u32 = 10;
pub const PAN_BENT_ARMS_DOUBLE_SERIF: u32 = 11;
pub const PAN_LETT_NORMAL_CONTACT: u32 = 2;
pub const PAN_LETT_NORMAL_WEIGHTED: u32 = 3;
pub const PAN_LETT_NORMAL_BOXED: u32 = 4;
pub const PAN_LETT_NORMAL_FLATTENED: u32 = 5;
pub const PAN_LETT_NORMAL_ROUNDED: u32 = 6;
pub const PAN_LETT_NORMAL_OFF_CENTER: u32 = 7;
pub const PAN_LETT_NORMAL_SQUARE: u32 = 8;
pub const PAN_LETT_OBLIQUE_CONTACT: u32 = 9;
pub const PAN_LETT_OBLIQUE_WEIGHTED: u32 = 10;
pub const PAN_LETT_OBLIQUE_BOXED: u32 = 11;
pub const PAN_LETT_OBLIQUE_FLATTENED: u32 = 12;
pub const PAN_LETT_OBLIQUE_ROUNDED: u32 = 13;
pub const PAN_LETT_OBLIQUE_OFF_CENTER: u32 = 14;
pub const PAN_LETT_OBLIQUE_SQUARE: u32 = 15;
pub const PAN_MIDLINE_STANDARD_TRIMMED: u32 = 2;
pub const PAN_MIDLINE_STANDARD_POINTED: u32 = 3;
pub const PAN_MIDLINE_STANDARD_SERIFED: u32 = 4;
pub const PAN_MIDLINE_HIGH_TRIMMED: u32 = 5;
pub const PAN_MIDLINE_HIGH_POINTED: u32 = 6;
pub const PAN_MIDLINE_HIGH_SERIFED: u32 = 7;
pub const PAN_MIDLINE_CONSTANT_TRIMMED: u32 = 8;
pub const PAN_MIDLINE_CONSTANT_POINTED: u32 = 9;
pub const PAN_MIDLINE_CONSTANT_SERIFED: u32 = 10;
pub const PAN_MIDLINE_LOW_TRIMMED: u32 = 11;
pub const PAN_MIDLINE_LOW_POINTED: u32 = 12;
pub const PAN_MIDLINE_LOW_SERIFED: u32 = 13;
pub const PAN_XHEIGHT_CONSTANT_SMALL: u32 = 2;
pub const PAN_XHEIGHT_CONSTANT_STD: u32 = 3;
pub const PAN_XHEIGHT_CONSTANT_LARGE: u32 = 4;
pub const PAN_XHEIGHT_DUCKING_SMALL: u32 = 5;
pub const PAN_XHEIGHT_DUCKING_STD: u32 = 6;
pub const PAN_XHEIGHT_DUCKING_LARGE: u32 = 7;
pub const ELF_VENDOR_SIZE: u32 = 4;
pub const ELF_VERSION: u32 = 0;
pub const ELF_CULTURE_LATIN: u32 = 0;
pub const RASTER_FONTTYPE: u32 = 1;
pub const DEVICE_FONTTYPE: u32 = 2;
pub const TRUETYPE_FONTTYPE: u32 = 4;
pub const PC_RESERVED: u32 = 1;
pub const PC_EXPLICIT: u32 = 2;
pub const PC_NOCOLLAPSE: u32 = 4;
pub const TRANSPARENT: u32 = 1;
pub const OPAQUE: u32 = 2;
pub const BKMODE_LAST: u32 = 2;
pub const GM_COMPATIBLE: u32 = 1;
pub const GM_ADVANCED: u32 = 2;
pub const GM_LAST: u32 = 2;
pub const PT_CLOSEFIGURE: u32 = 1;
pub const PT_LINETO: u32 = 2;
pub const PT_BEZIERTO: u32 = 4;
pub const PT_MOVETO: u32 = 6;
pub const MM_TEXT: u32 = 1;
pub const MM_LOMETRIC: u32 = 2;
pub const MM_HIMETRIC: u32 = 3;
pub const MM_LOENGLISH: u32 = 4;
pub const MM_HIENGLISH: u32 = 5;
pub const MM_TWIPS: u32 = 6;
pub const MM_ISOTROPIC: u32 = 7;
pub const MM_ANISOTROPIC: u32 = 8;
pub const MM_MIN: u32 = 1;
pub const MM_MAX: u32 = 8;
pub const MM_MAX_FIXEDSCALE: u32 = 6;
pub const ABSOLUTE: u32 = 1;
pub const RELATIVE: u32 = 2;
pub const WHITE_BRUSH: u32 = 0;
pub const LTGRAY_BRUSH: u32 = 1;
pub const GRAY_BRUSH: u32 = 2;
pub const DKGRAY_BRUSH: u32 = 3;
pub const BLACK_BRUSH: u32 = 4;
pub const NULL_BRUSH: u32 = 5;
pub const HOLLOW_BRUSH: u32 = 5;
pub const WHITE_PEN: u32 = 6;
pub const BLACK_PEN: u32 = 7;
pub const NULL_PEN: u32 = 8;
pub const OEM_FIXED_FONT: u32 = 10;
pub const ANSI_FIXED_FONT: u32 = 11;
pub const ANSI_VAR_FONT: u32 = 12;
pub const SYSTEM_FONT: u32 = 13;
pub const DEVICE_DEFAULT_FONT: u32 = 14;
pub const DEFAULT_PALETTE: u32 = 15;
pub const SYSTEM_FIXED_FONT: u32 = 16;
pub const DEFAULT_GUI_FONT: u32 = 17;
pub const DC_BRUSH: u32 = 18;
pub const DC_PEN: u32 = 19;
pub const STOCK_LAST: u32 = 19;
pub const CLR_INVALID: u32 = 4294967295;
pub const BS_SOLID: u32 = 0;
pub const BS_NULL: u32 = 1;
pub const BS_HOLLOW: u32 = 1;
pub const BS_HATCHED: u32 = 2;
pub const BS_PATTERN: u32 = 3;
pub const BS_INDEXED: u32 = 4;
pub const BS_DIBPATTERN: u32 = 5;
pub const BS_DIBPATTERNPT: u32 = 6;
pub const BS_PATTERN8X8: u32 = 7;
pub const BS_DIBPATTERN8X8: u32 = 8;
pub const BS_MONOPATTERN: u32 = 9;
pub const HS_HORIZONTAL: u32 = 0;
pub const HS_VERTICAL: u32 = 1;
pub const HS_FDIAGONAL: u32 = 2;
pub const HS_BDIAGONAL: u32 = 3;
pub const HS_CROSS: u32 = 4;
pub const HS_DIAGCROSS: u32 = 5;
pub const HS_API_MAX: u32 = 12;
pub const PS_SOLID: u32 = 0;
pub const PS_DASH: u32 = 1;
pub const PS_DOT: u32 = 2;
pub const PS_DASHDOT: u32 = 3;
pub const PS_DASHDOTDOT: u32 = 4;
pub const PS_NULL: u32 = 5;
pub const PS_INSIDEFRAME: u32 = 6;
pub const PS_USERSTYLE: u32 = 7;
pub const PS_ALTERNATE: u32 = 8;
pub const PS_STYLE_MASK: u32 = 15;
pub const PS_ENDCAP_ROUND: u32 = 0;
pub const PS_ENDCAP_SQUARE: u32 = 256;
pub const PS_ENDCAP_FLAT: u32 = 512;
pub const PS_ENDCAP_MASK: u32 = 3840;
pub const PS_JOIN_ROUND: u32 = 0;
pub const PS_JOIN_BEVEL: u32 = 4096;
pub const PS_JOIN_MITER: u32 = 8192;
pub const PS_JOIN_MASK: u32 = 61440;
pub const PS_COSMETIC: u32 = 0;
pub const PS_GEOMETRIC: u32 = 65536;
pub const PS_TYPE_MASK: u32 = 983040;
pub const AD_COUNTERCLOCKWISE: u32 = 1;
pub const AD_CLOCKWISE: u32 = 2;
pub const DRIVERVERSION: u32 = 0;
pub const TECHNOLOGY: u32 = 2;
pub const HORZSIZE: u32 = 4;
pub const VERTSIZE: u32 = 6;
pub const HORZRES: u32 = 8;
pub const VERTRES: u32 = 10;
pub const BITSPIXEL: u32 = 12;
pub const PLANES: u32 = 14;
pub const NUMBRUSHES: u32 = 16;
pub const NUMPENS: u32 = 18;
pub const NUMMARKERS: u32 = 20;
pub const NUMFONTS: u32 = 22;
pub const NUMCOLORS: u32 = 24;
pub const PDEVICESIZE: u32 = 26;
pub const CURVECAPS: u32 = 28;
pub const LINECAPS: u32 = 30;
pub const POLYGONALCAPS: u32 = 32;
pub const TEXTCAPS: u32 = 34;
pub const CLIPCAPS: u32 = 36;
pub const RASTERCAPS: u32 = 38;
pub const ASPECTX: u32 = 40;
pub const ASPECTY: u32 = 42;
pub const ASPECTXY: u32 = 44;
pub const LOGPIXELSX: u32 = 88;
pub const LOGPIXELSY: u32 = 90;
pub const SIZEPALETTE: u32 = 104;
pub const NUMRESERVED: u32 = 106;
pub const COLORRES: u32 = 108;
pub const PHYSICALWIDTH: u32 = 110;
pub const PHYSICALHEIGHT: u32 = 111;
pub const PHYSICALOFFSETX: u32 = 112;
pub const PHYSICALOFFSETY: u32 = 113;
pub const SCALINGFACTORX: u32 = 114;
pub const SCALINGFACTORY: u32 = 115;
pub const VREFRESH: u32 = 116;
pub const DESKTOPVERTRES: u32 = 117;
pub const DESKTOPHORZRES: u32 = 118;
pub const BLTALIGNMENT: u32 = 119;
pub const SHADEBLENDCAPS: u32 = 120;
pub const COLORMGMTCAPS: u32 = 121;
pub const DT_PLOTTER: u32 = 0;
pub const DT_RASDISPLAY: u32 = 1;
pub const DT_RASPRINTER: u32 = 2;
pub const DT_RASCAMERA: u32 = 3;
pub const DT_CHARSTREAM: u32 = 4;
pub const DT_METAFILE: u32 = 5;
pub const DT_DISPFILE: u32 = 6;
pub const CC_NONE: u32 = 0;
pub const CC_CIRCLES: u32 = 1;
pub const CC_PIE: u32 = 2;
pub const CC_CHORD: u32 = 4;
pub const CC_ELLIPSES: u32 = 8;
pub const CC_WIDE: u32 = 16;
pub const CC_STYLED: u32 = 32;
pub const CC_WIDESTYLED: u32 = 64;
pub const CC_INTERIORS: u32 = 128;
pub const CC_ROUNDRECT: u32 = 256;
pub const LC_NONE: u32 = 0;
pub const LC_POLYLINE: u32 = 2;
pub const LC_MARKER: u32 = 4;
pub const LC_POLYMARKER: u32 = 8;
pub const LC_WIDE: u32 = 16;
pub const LC_STYLED: u32 = 32;
pub const LC_WIDESTYLED: u32 = 64;
pub const LC_INTERIORS: u32 = 128;
pub const PC_NONE: u32 = 0;
pub const PC_POLYGON: u32 = 1;
pub const PC_RECTANGLE: u32 = 2;
pub const PC_WINDPOLYGON: u32 = 4;
pub const PC_TRAPEZOID: u32 = 4;
pub const PC_SCANLINE: u32 = 8;
pub const PC_WIDE: u32 = 16;
pub const PC_STYLED: u32 = 32;
pub const PC_WIDESTYLED: u32 = 64;
pub const PC_INTERIORS: u32 = 128;
pub const PC_POLYPOLYGON: u32 = 256;
pub const PC_PATHS: u32 = 512;
pub const CP_NONE: u32 = 0;
pub const CP_RECTANGLE: u32 = 1;
pub const CP_REGION: u32 = 2;
pub const TC_OP_CHARACTER: u32 = 1;
pub const TC_OP_STROKE: u32 = 2;
pub const TC_CP_STROKE: u32 = 4;
pub const TC_CR_90: u32 = 8;
pub const TC_CR_ANY: u32 = 16;
pub const TC_SF_X_YINDEP: u32 = 32;
pub const TC_SA_DOUBLE: u32 = 64;
pub const TC_SA_INTEGER: u32 = 128;
pub const TC_SA_CONTIN: u32 = 256;
pub const TC_EA_DOUBLE: u32 = 512;
pub const TC_IA_ABLE: u32 = 1024;
pub const TC_UA_ABLE: u32 = 2048;
pub const TC_SO_ABLE: u32 = 4096;
pub const TC_RA_ABLE: u32 = 8192;
pub const TC_VA_ABLE: u32 = 16384;
pub const TC_RESERVED: u32 = 32768;
pub const TC_SCROLLBLT: u32 = 65536;
pub const RC_BITBLT: u32 = 1;
pub const RC_BANDING: u32 = 2;
pub const RC_SCALING: u32 = 4;
pub const RC_BITMAP64: u32 = 8;
pub const RC_GDI20_OUTPUT: u32 = 16;
pub const RC_GDI20_STATE: u32 = 32;
pub const RC_SAVEBITMAP: u32 = 64;
pub const RC_DI_BITMAP: u32 = 128;
pub const RC_PALETTE: u32 = 256;
pub const RC_DIBTODEV: u32 = 512;
pub const RC_BIGFONT: u32 = 1024;
pub const RC_STRETCHBLT: u32 = 2048;
pub const RC_FLOODFILL: u32 = 4096;
pub const RC_STRETCHDIB: u32 = 8192;
pub const RC_OP_DX_OUTPUT: u32 = 16384;
pub const RC_DEVBITS: u32 = 32768;
pub const SB_NONE: u32 = 0;
pub const SB_CONST_ALPHA: u32 = 1;
pub const SB_PIXEL_ALPHA: u32 = 2;
pub const SB_PREMULT_ALPHA: u32 = 4;
pub const SB_GRAD_RECT: u32 = 16;
pub const SB_GRAD_TRI: u32 = 32;
pub const CM_NONE: u32 = 0;
pub const CM_DEVICE_ICM: u32 = 1;
pub const CM_GAMMA_RAMP: u32 = 2;
pub const CM_CMYK_COLOR: u32 = 4;
pub const DIB_RGB_COLORS: u32 = 0;
pub const DIB_PAL_COLORS: u32 = 1;
pub const SYSPAL_ERROR: u32 = 0;
pub const SYSPAL_STATIC: u32 = 1;
pub const SYSPAL_NOSTATIC: u32 = 2;
pub const SYSPAL_NOSTATIC256: u32 = 3;
pub const CBM_INIT: u32 = 4;
pub const FLOODFILLBORDER: u32 = 0;
pub const FLOODFILLSURFACE: u32 = 1;
pub const CCHDEVICENAME: u32 = 32;
pub const CCHFORMNAME: u32 = 32;
pub const DM_SPECVERSION: u32 = 1025;
pub const DM_ORIENTATION: u32 = 1;
pub const DM_PAPERSIZE: u32 = 2;
pub const DM_PAPERLENGTH: u32 = 4;
pub const DM_PAPERWIDTH: u32 = 8;
pub const DM_SCALE: u32 = 16;
pub const DM_POSITION: u32 = 32;
pub const DM_NUP: u32 = 64;
pub const DM_DISPLAYORIENTATION: u32 = 128;
pub const DM_COPIES: u32 = 256;
pub const DM_DEFAULTSOURCE: u32 = 512;
pub const DM_PRINTQUALITY: u32 = 1024;
pub const DM_COLOR: u32 = 2048;
pub const DM_DUPLEX: u32 = 4096;
pub const DM_YRESOLUTION: u32 = 8192;
pub const DM_TTOPTION: u32 = 16384;
pub const DM_COLLATE: u32 = 32768;
pub const DM_FORMNAME: u32 = 65536;
pub const DM_LOGPIXELS: u32 = 131072;
pub const DM_BITSPERPEL: u32 = 262144;
pub const DM_PELSWIDTH: u32 = 524288;
pub const DM_PELSHEIGHT: u32 = 1048576;
pub const DM_DISPLAYFLAGS: u32 = 2097152;
pub const DM_DISPLAYFREQUENCY: u32 = 4194304;
pub const DM_ICMMETHOD: u32 = 8388608;
pub const DM_ICMINTENT: u32 = 16777216;
pub const DM_MEDIATYPE: u32 = 33554432;
pub const DM_DITHERTYPE: u32 = 67108864;
pub const DM_PANNINGWIDTH: u32 = 134217728;
pub const DM_PANNINGHEIGHT: u32 = 268435456;
pub const DM_DISPLAYFIXEDOUTPUT: u32 = 536870912;
pub const DMORIENT_PORTRAIT: u32 = 1;
pub const DMORIENT_LANDSCAPE: u32 = 2;
pub const DMPAPER_LETTER: u32 = 1;
pub const DMPAPER_LETTERSMALL: u32 = 2;
pub const DMPAPER_TABLOID: u32 = 3;
pub const DMPAPER_LEDGER: u32 = 4;
pub const DMPAPER_LEGAL: u32 = 5;
pub const DMPAPER_STATEMENT: u32 = 6;
pub const DMPAPER_EXECUTIVE: u32 = 7;
pub const DMPAPER_A3: u32 = 8;
pub const DMPAPER_A4: u32 = 9;
pub const DMPAPER_A4SMALL: u32 = 10;
pub const DMPAPER_A5: u32 = 11;
pub const DMPAPER_B4: u32 = 12;
pub const DMPAPER_B5: u32 = 13;
pub const DMPAPER_FOLIO: u32 = 14;
pub const DMPAPER_QUARTO: u32 = 15;
pub const DMPAPER_10X14: u32 = 16;
pub const DMPAPER_11X17: u32 = 17;
pub const DMPAPER_NOTE: u32 = 18;
pub const DMPAPER_ENV_9: u32 = 19;
pub const DMPAPER_ENV_10: u32 = 20;
pub const DMPAPER_ENV_11: u32 = 21;
pub const DMPAPER_ENV_12: u32 = 22;
pub const DMPAPER_ENV_14: u32 = 23;
pub const DMPAPER_CSHEET: u32 = 24;
pub const DMPAPER_DSHEET: u32 = 25;
pub const DMPAPER_ESHEET: u32 = 26;
pub const DMPAPER_ENV_DL: u32 = 27;
pub const DMPAPER_ENV_C5: u32 = 28;
pub const DMPAPER_ENV_C3: u32 = 29;
pub const DMPAPER_ENV_C4: u32 = 30;
pub const DMPAPER_ENV_C6: u32 = 31;
pub const DMPAPER_ENV_C65: u32 = 32;
pub const DMPAPER_ENV_B4: u32 = 33;
pub const DMPAPER_ENV_B5: u32 = 34;
pub const DMPAPER_ENV_B6: u32 = 35;
pub const DMPAPER_ENV_ITALY: u32 = 36;
pub const DMPAPER_ENV_MONARCH: u32 = 37;
pub const DMPAPER_ENV_PERSONAL: u32 = 38;
pub const DMPAPER_FANFOLD_US: u32 = 39;
pub const DMPAPER_FANFOLD_STD_GERMAN: u32 = 40;
pub const DMPAPER_FANFOLD_LGL_GERMAN: u32 = 41;
pub const DMPAPER_ISO_B4: u32 = 42;
pub const DMPAPER_JAPANESE_POSTCARD: u32 = 43;
pub const DMPAPER_9X11: u32 = 44;
pub const DMPAPER_10X11: u32 = 45;
pub const DMPAPER_15X11: u32 = 46;
pub const DMPAPER_ENV_INVITE: u32 = 47;
pub const DMPAPER_RESERVED_48: u32 = 48;
pub const DMPAPER_RESERVED_49: u32 = 49;
pub const DMPAPER_LETTER_EXTRA: u32 = 50;
pub const DMPAPER_LEGAL_EXTRA: u32 = 51;
pub const DMPAPER_TABLOID_EXTRA: u32 = 52;
pub const DMPAPER_A4_EXTRA: u32 = 53;
pub const DMPAPER_LETTER_TRANSVERSE: u32 = 54;
pub const DMPAPER_A4_TRANSVERSE: u32 = 55;
pub const DMPAPER_LETTER_EXTRA_TRANSVERSE: u32 = 56;
pub const DMPAPER_A_PLUS: u32 = 57;
pub const DMPAPER_B_PLUS: u32 = 58;
pub const DMPAPER_LETTER_PLUS: u32 = 59;
pub const DMPAPER_A4_PLUS: u32 = 60;
pub const DMPAPER_A5_TRANSVERSE: u32 = 61;
pub const DMPAPER_B5_TRANSVERSE: u32 = 62;
pub const DMPAPER_A3_EXTRA: u32 = 63;
pub const DMPAPER_A5_EXTRA: u32 = 64;
pub const DMPAPER_B5_EXTRA: u32 = 65;
pub const DMPAPER_A2: u32 = 66;
pub const DMPAPER_A3_TRANSVERSE: u32 = 67;
pub const DMPAPER_A3_EXTRA_TRANSVERSE: u32 = 68;
pub const DMPAPER_DBL_JAPANESE_POSTCARD: u32 = 69;
pub const DMPAPER_A6: u32 = 70;
pub const DMPAPER_JENV_KAKU2: u32 = 71;
pub const DMPAPER_JENV_KAKU3: u32 = 72;
pub const DMPAPER_JENV_CHOU3: u32 = 73;
pub const DMPAPER_JENV_CHOU4: u32 = 74;
pub const DMPAPER_LETTER_ROTATED: u32 = 75;
pub const DMPAPER_A3_ROTATED: u32 = 76;
pub const DMPAPER_A4_ROTATED: u32 = 77;
pub const DMPAPER_A5_ROTATED: u32 = 78;
pub const DMPAPER_B4_JIS_ROTATED: u32 = 79;
pub const DMPAPER_B5_JIS_ROTATED: u32 = 80;
pub const DMPAPER_JAPANESE_POSTCARD_ROTATED: u32 = 81;
pub const DMPAPER_DBL_JAPANESE_POSTCARD_ROTATED: u32 = 82;
pub const DMPAPER_A6_ROTATED: u32 = 83;
pub const DMPAPER_JENV_KAKU2_ROTATED: u32 = 84;
pub const DMPAPER_JENV_KAKU3_ROTATED: u32 = 85;
pub const DMPAPER_JENV_CHOU3_ROTATED: u32 = 86;
pub const DMPAPER_JENV_CHOU4_ROTATED: u32 = 87;
pub const DMPAPER_B6_JIS: u32 = 88;
pub const DMPAPER_B6_JIS_ROTATED: u32 = 89;
pub const DMPAPER_12X11: u32 = 90;
pub const DMPAPER_JENV_YOU4: u32 = 91;
pub const DMPAPER_JENV_YOU4_ROTATED: u32 = 92;
pub const DMPAPER_P16K: u32 = 93;
pub const DMPAPER_P32K: u32 = 94;
pub const DMPAPER_P32KBIG: u32 = 95;
pub const DMPAPER_PENV_1: u32 = 96;
pub const DMPAPER_PENV_2: u32 = 97;
pub const DMPAPER_PENV_3: u32 = 98;
pub const DMPAPER_PENV_4: u32 = 99;
pub const DMPAPER_PENV_5: u32 = 100;
pub const DMPAPER_PENV_6: u32 = 101;
pub const DMPAPER_PENV_7: u32 = 102;
pub const DMPAPER_PENV_8: u32 = 103;
pub const DMPAPER_PENV_9: u32 = 104;
pub const DMPAPER_PENV_10: u32 = 105;
pub const DMPAPER_P16K_ROTATED: u32 = 106;
pub const DMPAPER_P32K_ROTATED: u32 = 107;
pub const DMPAPER_P32KBIG_ROTATED: u32 = 108;
pub const DMPAPER_PENV_1_ROTATED: u32 = 109;
pub const DMPAPER_PENV_2_ROTATED: u32 = 110;
pub const DMPAPER_PENV_3_ROTATED: u32 = 111;
pub const DMPAPER_PENV_4_ROTATED: u32 = 112;
pub const DMPAPER_PENV_5_ROTATED: u32 = 113;
pub const DMPAPER_PENV_6_ROTATED: u32 = 114;
pub const DMPAPER_PENV_7_ROTATED: u32 = 115;
pub const DMPAPER_PENV_8_ROTATED: u32 = 116;
pub const DMPAPER_PENV_9_ROTATED: u32 = 117;
pub const DMPAPER_PENV_10_ROTATED: u32 = 118;
pub const DMPAPER_LAST: u32 = 118;
pub const DMPAPER_USER: u32 = 256;
pub const DMBIN_UPPER: u32 = 1;
pub const DMBIN_ONLYONE: u32 = 1;
pub const DMBIN_LOWER: u32 = 2;
pub const DMBIN_MIDDLE: u32 = 3;
pub const DMBIN_MANUAL: u32 = 4;
pub const DMBIN_ENVELOPE: u32 = 5;
pub const DMBIN_ENVMANUAL: u32 = 6;
pub const DMBIN_AUTO: u32 = 7;
pub const DMBIN_TRACTOR: u32 = 8;
pub const DMBIN_SMALLFMT: u32 = 9;
pub const DMBIN_LARGEFMT: u32 = 10;
pub const DMBIN_LARGECAPACITY: u32 = 11;
pub const DMBIN_CASSETTE: u32 = 14;
pub const DMBIN_FORMSOURCE: u32 = 15;
pub const DMBIN_LAST: u32 = 15;
pub const DMBIN_USER: u32 = 256;
pub const DMRES_DRAFT: i32 = -1;
pub const DMRES_LOW: i32 = -2;
pub const DMRES_MEDIUM: i32 = -3;
pub const DMRES_HIGH: i32 = -4;
pub const DMCOLOR_MONOCHROME: u32 = 1;
pub const DMCOLOR_COLOR: u32 = 2;
pub const DMDUP_SIMPLEX: u32 = 1;
pub const DMDUP_VERTICAL: u32 = 2;
pub const DMDUP_HORIZONTAL: u32 = 3;
pub const DMTT_BITMAP: u32 = 1;
pub const DMTT_DOWNLOAD: u32 = 2;
pub const DMTT_SUBDEV: u32 = 3;
pub const DMTT_DOWNLOAD_OUTLINE: u32 = 4;
pub const DMCOLLATE_FALSE: u32 = 0;
pub const DMCOLLATE_TRUE: u32 = 1;
pub const DMDO_DEFAULT: u32 = 0;
pub const DMDO_90: u32 = 1;
pub const DMDO_180: u32 = 2;
pub const DMDO_270: u32 = 3;
pub const DMDFO_DEFAULT: u32 = 0;
pub const DMDFO_STRETCH: u32 = 1;
pub const DMDFO_CENTER: u32 = 2;
pub const DM_INTERLACED: u32 = 2;
pub const DMDISPLAYFLAGS_TEXTMODE: u32 = 4;
pub const DMNUP_SYSTEM: u32 = 1;
pub const DMNUP_ONEUP: u32 = 2;
pub const DMICMMETHOD_NONE: u32 = 1;
pub const DMICMMETHOD_SYSTEM: u32 = 2;
pub const DMICMMETHOD_DRIVER: u32 = 3;
pub const DMICMMETHOD_DEVICE: u32 = 4;
pub const DMICMMETHOD_USER: u32 = 256;
pub const DMICM_SATURATE: u32 = 1;
pub const DMICM_CONTRAST: u32 = 2;
pub const DMICM_COLORIMETRIC: u32 = 3;
pub const DMICM_ABS_COLORIMETRIC: u32 = 4;
pub const DMICM_USER: u32 = 256;
pub const DMMEDIA_STANDARD: u32 = 1;
pub const DMMEDIA_TRANSPARENCY: u32 = 2;
pub const DMMEDIA_GLOSSY: u32 = 3;
pub const DMMEDIA_USER: u32 = 256;
pub const DMDITHER_NONE: u32 = 1;
pub const DMDITHER_COARSE: u32 = 2;
pub const DMDITHER_FINE: u32 = 3;
pub const DMDITHER_LINEART: u32 = 4;
pub const DMDITHER_ERRORDIFFUSION: u32 = 5;
pub const DMDITHER_RESERVED6: u32 = 6;
pub const DMDITHER_RESERVED7: u32 = 7;
pub const DMDITHER_RESERVED8: u32 = 8;
pub const DMDITHER_RESERVED9: u32 = 9;
pub const DMDITHER_GRAYSCALE: u32 = 10;
pub const DMDITHER_USER: u32 = 256;
pub const DISPLAY_DEVICE_ATTACHED_TO_DESKTOP: u32 = 1;
pub const DISPLAY_DEVICE_MULTI_DRIVER: u32 = 2;
pub const DISPLAY_DEVICE_PRIMARY_DEVICE: u32 = 4;
pub const DISPLAY_DEVICE_MIRRORING_DRIVER: u32 = 8;
pub const DISPLAY_DEVICE_VGA_COMPATIBLE: u32 = 16;
pub const DISPLAY_DEVICE_REMOVABLE: u32 = 32;
pub const DISPLAY_DEVICE_ACC_DRIVER: u32 = 64;
pub const DISPLAY_DEVICE_MODESPRUNED: u32 = 134217728;
pub const DISPLAY_DEVICE_RDPUDD: u32 = 16777216;
pub const DISPLAY_DEVICE_REMOTE: u32 = 67108864;
pub const DISPLAY_DEVICE_DISCONNECT: u32 = 33554432;
pub const DISPLAY_DEVICE_TS_COMPATIBLE: u32 = 2097152;
pub const DISPLAY_DEVICE_UNSAFE_MODES_ON: u32 = 524288;
pub const DISPLAY_DEVICE_ACTIVE: u32 = 1;
pub const DISPLAY_DEVICE_ATTACHED: u32 = 2;
pub const DISPLAYCONFIG_MAXPATH: u32 = 1024;
pub const DISPLAYCONFIG_PATH_MODE_IDX_INVALID: u32 = 4294967295;
pub const DISPLAYCONFIG_PATH_TARGET_MODE_IDX_INVALID: u32 = 65535;
pub const DISPLAYCONFIG_PATH_DESKTOP_IMAGE_IDX_INVALID: u32 = 65535;
pub const DISPLAYCONFIG_PATH_SOURCE_MODE_IDX_INVALID: u32 = 65535;
pub const DISPLAYCONFIG_PATH_CLONE_GROUP_INVALID: u32 = 65535;
pub const DISPLAYCONFIG_SOURCE_IN_USE: u32 = 1;
pub const DISPLAYCONFIG_TARGET_IN_USE: u32 = 1;
pub const DISPLAYCONFIG_TARGET_FORCIBLE: u32 = 2;
pub const DISPLAYCONFIG_TARGET_FORCED_AVAILABILITY_BOOT: u32 = 4;
pub const DISPLAYCONFIG_TARGET_FORCED_AVAILABILITY_PATH: u32 = 8;
pub const DISPLAYCONFIG_TARGET_FORCED_AVAILABILITY_SYSTEM: u32 = 16;
pub const DISPLAYCONFIG_TARGET_IS_HMD: u32 = 32;
pub const DISPLAYCONFIG_PATH_ACTIVE: u32 = 1;
pub const DISPLAYCONFIG_PATH_PREFERRED_UNSCALED: u32 = 4;
pub const DISPLAYCONFIG_PATH_SUPPORT_VIRTUAL_MODE: u32 = 8;
pub const DISPLAYCONFIG_PATH_VALID_FLAGS: u32 = 29;
pub const QDC_ALL_PATHS: u32 = 1;
pub const QDC_ONLY_ACTIVE_PATHS: u32 = 2;
pub const QDC_DATABASE_CURRENT: u32 = 4;
pub const QDC_VIRTUAL_MODE_AWARE: u32 = 16;
pub const QDC_INCLUDE_HMD: u32 = 32;
pub const QDC_VIRTUAL_REFRESH_RATE_AWARE: u32 = 64;
pub const SDC_TOPOLOGY_INTERNAL: u32 = 1;
pub const SDC_TOPOLOGY_CLONE: u32 = 2;
pub const SDC_TOPOLOGY_EXTEND: u32 = 4;
pub const SDC_TOPOLOGY_EXTERNAL: u32 = 8;
pub const SDC_TOPOLOGY_SUPPLIED: u32 = 16;
pub const SDC_USE_DATABASE_CURRENT: u32 = 15;
pub const SDC_USE_SUPPLIED_DISPLAY_CONFIG: u32 = 32;
pub const SDC_VALIDATE: u32 = 64;
pub const SDC_APPLY: u32 = 128;
pub const SDC_NO_OPTIMIZATION: u32 = 256;
pub const SDC_SAVE_TO_DATABASE: u32 = 512;
pub const SDC_ALLOW_CHANGES: u32 = 1024;
pub const SDC_PATH_PERSIST_IF_REQUIRED: u32 = 2048;
pub const SDC_FORCE_MODE_ENUMERATION: u32 = 4096;
pub const SDC_ALLOW_PATH_ORDER_CHANGES: u32 = 8192;
pub const SDC_VIRTUAL_MODE_AWARE: u32 = 32768;
pub const SDC_VIRTUAL_REFRESH_RATE_AWARE: u32 = 131072;
pub const RDH_RECTANGLES: u32 = 1;
pub const SYSRGN: u32 = 4;
pub const GGO_METRICS: u32 = 0;
pub const GGO_BITMAP: u32 = 1;
pub const GGO_NATIVE: u32 = 2;
pub const GGO_BEZIER: u32 = 3;
pub const GGO_GRAY2_BITMAP: u32 = 4;
pub const GGO_GRAY4_BITMAP: u32 = 5;
pub const GGO_GRAY8_BITMAP: u32 = 6;
pub const GGO_GLYPH_INDEX: u32 = 128;
pub const GGO_UNHINTED: u32 = 256;
pub const TT_POLYGON_TYPE: u32 = 24;
pub const TT_PRIM_LINE: u32 = 1;
pub const TT_PRIM_QSPLINE: u32 = 2;
pub const TT_PRIM_CSPLINE: u32 = 3;
pub const GCP_DBCS: u32 = 1;
pub const GCP_REORDER: u32 = 2;
pub const GCP_USEKERNING: u32 = 8;
pub const GCP_GLYPHSHAPE: u32 = 16;
pub const GCP_LIGATE: u32 = 32;
pub const GCP_DIACRITIC: u32 = 256;
pub const GCP_KASHIDA: u32 = 1024;
pub const GCP_ERROR: u32 = 32768;
pub const FLI_MASK: u32 = 4155;
pub const GCP_JUSTIFY: u32 = 65536;
pub const FLI_GLYPHS: u32 = 262144;
pub const GCP_CLASSIN: u32 = 524288;
pub const GCP_MAXEXTENT: u32 = 1048576;
pub const GCP_JUSTIFYIN: u32 = 2097152;
pub const GCP_DISPLAYZWG: u32 = 4194304;
pub const GCP_SYMSWAPOFF: u32 = 8388608;
pub const GCP_NUMERICOVERRIDE: u32 = 16777216;
pub const GCP_NEUTRALOVERRIDE: u32 = 33554432;
pub const GCP_NUMERICSLATIN: u32 = 67108864;
pub const GCP_NUMERICSLOCAL: u32 = 134217728;
pub const GCPCLASS_LATIN: u32 = 1;
pub const GCPCLASS_HEBREW: u32 = 2;
pub const GCPCLASS_ARABIC: u32 = 2;
pub const GCPCLASS_NEUTRAL: u32 = 3;
pub const GCPCLASS_LOCALNUMBER: u32 = 4;
pub const GCPCLASS_LATINNUMBER: u32 = 5;
pub const GCPCLASS_LATINNUMERICTERMINATOR: u32 = 6;
pub const GCPCLASS_LATINNUMERICSEPARATOR: u32 = 7;
pub const GCPCLASS_NUMERICSEPARATOR: u32 = 8;
pub const GCPCLASS_PREBOUNDLTR: u32 = 128;
pub const GCPCLASS_PREBOUNDRTL: u32 = 64;
pub const GCPCLASS_POSTBOUNDLTR: u32 = 32;
pub const GCPCLASS_POSTBOUNDRTL: u32 = 16;
pub const GCPGLYPH_LINKBEFORE: u32 = 32768;
pub const GCPGLYPH_LINKAFTER: u32 = 16384;
pub const TT_AVAILABLE: u32 = 1;
pub const TT_ENABLED: u32 = 2;
pub const PFD_TYPE_RGBA: u32 = 0;
pub const PFD_TYPE_COLORINDEX: u32 = 1;
pub const PFD_MAIN_PLANE: u32 = 0;
pub const PFD_OVERLAY_PLANE: u32 = 1;
pub const PFD_UNDERLAY_PLANE: i32 = -1;
pub const PFD_DOUBLEBUFFER: u32 = 1;
pub const PFD_STEREO: u32 = 2;
pub const PFD_DRAW_TO_WINDOW: u32 = 4;
pub const PFD_DRAW_TO_BITMAP: u32 = 8;
pub const PFD_SUPPORT_GDI: u32 = 16;
pub const PFD_SUPPORT_OPENGL: u32 = 32;
pub const PFD_GENERIC_FORMAT: u32 = 64;
pub const PFD_NEED_PALETTE: u32 = 128;
pub const PFD_NEED_SYSTEM_PALETTE: u32 = 256;
pub const PFD_SWAP_EXCHANGE: u32 = 512;
pub const PFD_SWAP_COPY: u32 = 1024;
pub const PFD_SWAP_LAYER_BUFFERS: u32 = 2048;
pub const PFD_GENERIC_ACCELERATED: u32 = 4096;
pub const PFD_SUPPORT_DIRECTDRAW: u32 = 8192;
pub const PFD_DIRECT3D_ACCELERATED: u32 = 16384;
pub const PFD_SUPPORT_COMPOSITION: u32 = 32768;
pub const PFD_DEPTH_DONTCARE: u32 = 536870912;
pub const PFD_DOUBLEBUFFER_DONTCARE: u32 = 1073741824;
pub const PFD_STEREO_DONTCARE: u32 = 2147483648;
pub const DC_BINADJUST: u32 = 19;
pub const DC_EMF_COMPLIANT: u32 = 20;
pub const DC_DATATYPE_PRODUCED: u32 = 21;
pub const DC_COLLATE: u32 = 22;
pub const DC_MANUFACTURER: u32 = 23;
pub const DC_MODEL: u32 = 24;
pub const DC_PERSONALITY: u32 = 25;
pub const DC_PRINTRATE: u32 = 26;
pub const DC_PRINTRATEUNIT: u32 = 27;
pub const PRINTRATEUNIT_PPM: u32 = 1;
pub const PRINTRATEUNIT_CPS: u32 = 2;
pub const PRINTRATEUNIT_LPM: u32 = 3;
pub const PRINTRATEUNIT_IPM: u32 = 4;
pub const DC_PRINTERMEM: u32 = 28;
pub const DC_MEDIAREADY: u32 = 29;
pub const DC_STAPLE: u32 = 30;
pub const DC_PRINTRATEPPM: u32 = 31;
pub const DC_COLORDEVICE: u32 = 32;
pub const DC_NUP: u32 = 33;
pub const DC_MEDIATYPENAMES: u32 = 34;
pub const DC_MEDIATYPES: u32 = 35;
pub const DCTT_BITMAP: u32 = 1;
pub const DCTT_DOWNLOAD: u32 = 2;
pub const DCTT_SUBDEV: u32 = 4;
pub const DCTT_DOWNLOAD_OUTLINE: u32 = 8;
pub const DCBA_FACEUPNONE: u32 = 0;
pub const DCBA_FACEUPCENTER: u32 = 1;
pub const DCBA_FACEUPLEFT: u32 = 2;
pub const DCBA_FACEUPRIGHT: u32 = 3;
pub const DCBA_FACEDOWNNONE: u32 = 256;
pub const DCBA_FACEDOWNCENTER: u32 = 257;
pub const DCBA_FACEDOWNLEFT: u32 = 258;
pub const DCBA_FACEDOWNRIGHT: u32 = 259;
pub const GS_8BIT_INDICES: u32 = 1;
pub const GGI_MARK_NONEXISTING_GLYPHS: u32 = 1;
pub const MM_MAX_NUMAXES: u32 = 16;
pub const FR_PRIVATE: u32 = 16;
pub const FR_NOT_ENUM: u32 = 32;
pub const MM_MAX_AXES_NAMELEN: u32 = 16;
pub const AC_SRC_OVER: u32 = 0;
pub const AC_SRC_ALPHA: u32 = 1;
pub const GRADIENT_FILL_RECT_H: u32 = 0;
pub const GRADIENT_FILL_RECT_V: u32 = 1;
pub const GRADIENT_FILL_TRIANGLE: u32 = 2;
pub const GRADIENT_FILL_OP_FLAG: u32 = 255;
pub const CA_NEGATIVE: u32 = 1;
pub const CA_LOG_FILTER: u32 = 2;
pub const ILLUMINANT_DEVICE_DEFAULT: u32 = 0;
pub const ILLUMINANT_A: u32 = 1;
pub const ILLUMINANT_B: u32 = 2;
pub const ILLUMINANT_C: u32 = 3;
pub const ILLUMINANT_D50: u32 = 4;
pub const ILLUMINANT_D55: u32 = 5;
pub const ILLUMINANT_D65: u32 = 6;
pub const ILLUMINANT_D75: u32 = 7;
pub const ILLUMINANT_F2: u32 = 8;
pub const ILLUMINANT_MAX_INDEX: u32 = 8;
pub const ILLUMINANT_TUNGSTEN: u32 = 1;
pub const ILLUMINANT_DAYLIGHT: u32 = 3;
pub const ILLUMINANT_FLUORESCENT: u32 = 8;
pub const ILLUMINANT_NTSC: u32 = 3;
pub const DI_APPBANDING: u32 = 1;
pub const DI_ROPS_READ_DESTINATION: u32 = 2;
pub const FONTMAPPER_MAX: u32 = 10;
pub const ICM_OFF: u32 = 1;
pub const ICM_ON: u32 = 2;
pub const ICM_QUERY: u32 = 3;
pub const ICM_DONE_OUTSIDEDC: u32 = 4;
pub const ENHMETA_SIGNATURE: u32 = 1179469088;
pub const ENHMETA_STOCK_OBJECT: u32 = 2147483648;
pub const EMR_HEADER: u32 = 1;
pub const EMR_POLYBEZIER: u32 = 2;
pub const EMR_POLYGON: u32 = 3;
pub const EMR_POLYLINE: u32 = 4;
pub const EMR_POLYBEZIERTO: u32 = 5;
pub const EMR_POLYLINETO: u32 = 6;
pub const EMR_POLYPOLYLINE: u32 = 7;
pub const EMR_POLYPOLYGON: u32 = 8;
pub const EMR_SETWINDOWEXTEX: u32 = 9;
pub const EMR_SETWINDOWORGEX: u32 = 10;
pub const EMR_SETVIEWPORTEXTEX: u32 = 11;
pub const EMR_SETVIEWPORTORGEX: u32 = 12;
pub const EMR_SETBRUSHORGEX: u32 = 13;
pub const EMR_EOF: u32 = 14;
pub const EMR_SETPIXELV: u32 = 15;
pub const EMR_SETMAPPERFLAGS: u32 = 16;
pub const EMR_SETMAPMODE: u32 = 17;
pub const EMR_SETBKMODE: u32 = 18;
pub const EMR_SETPOLYFILLMODE: u32 = 19;
pub const EMR_SETROP2: u32 = 20;
pub const EMR_SETSTRETCHBLTMODE: u32 = 21;
pub const EMR_SETTEXTALIGN: u32 = 22;
pub const EMR_SETCOLORADJUSTMENT: u32 = 23;
pub const EMR_SETTEXTCOLOR: u32 = 24;
pub const EMR_SETBKCOLOR: u32 = 25;
pub const EMR_OFFSETCLIPRGN: u32 = 26;
pub const EMR_MOVETOEX: u32 = 27;
pub const EMR_SETMETARGN: u32 = 28;
pub const EMR_EXCLUDECLIPRECT: u32 = 29;
pub const EMR_INTERSECTCLIPRECT: u32 = 30;
pub const EMR_SCALEVIEWPORTEXTEX: u32 = 31;
pub const EMR_SCALEWINDOWEXTEX: u32 = 32;
pub const EMR_SAVEDC: u32 = 33;
pub const EMR_RESTOREDC: u32 = 34;
pub const EMR_SETWORLDTRANSFORM: u32 = 35;
pub const EMR_MODIFYWORLDTRANSFORM: u32 = 36;
pub const EMR_SELECTOBJECT: u32 = 37;
pub const EMR_CREATEPEN: u32 = 38;
pub const EMR_CREATEBRUSHINDIRECT: u32 = 39;
pub const EMR_DELETEOBJECT: u32 = 40;
pub const EMR_ANGLEARC: u32 = 41;
pub const EMR_ELLIPSE: u32 = 42;
pub const EMR_RECTANGLE: u32 = 43;
pub const EMR_ROUNDRECT: u32 = 44;
pub const EMR_ARC: u32 = 45;
pub const EMR_CHORD: u32 = 46;
pub const EMR_PIE: u32 = 47;
pub const EMR_SELECTPALETTE: u32 = 48;
pub const EMR_CREATEPALETTE: u32 = 49;
pub const EMR_SETPALETTEENTRIES: u32 = 50;
pub const EMR_RESIZEPALETTE: u32 = 51;
pub const EMR_REALIZEPALETTE: u32 = 52;
pub const EMR_EXTFLOODFILL: u32 = 53;
pub const EMR_LINETO: u32 = 54;
pub const EMR_ARCTO: u32 = 55;
pub const EMR_POLYDRAW: u32 = 56;
pub const EMR_SETARCDIRECTION: u32 = 57;
pub const EMR_SETMITERLIMIT: u32 = 58;
pub const EMR_BEGINPATH: u32 = 59;
pub const EMR_ENDPATH: u32 = 60;
pub const EMR_CLOSEFIGURE: u32 = 61;
pub const EMR_FILLPATH: u32 = 62;
pub const EMR_STROKEANDFILLPATH: u32 = 63;
pub const EMR_STROKEPATH: u32 = 64;
pub const EMR_FLATTENPATH: u32 = 65;
pub const EMR_WIDENPATH: u32 = 66;
pub const EMR_SELECTCLIPPATH: u32 = 67;
pub const EMR_ABORTPATH: u32 = 68;
pub const EMR_GDICOMMENT: u32 = 70;
pub const EMR_FILLRGN: u32 = 71;
pub const EMR_FRAMERGN: u32 = 72;
pub const EMR_INVERTRGN: u32 = 73;
pub const EMR_PAINTRGN: u32 = 74;
pub const EMR_EXTSELECTCLIPRGN: u32 = 75;
pub const EMR_BITBLT: u32 = 76;
pub const EMR_STRETCHBLT: u32 = 77;
pub const EMR_MASKBLT: u32 = 78;
pub const EMR_PLGBLT: u32 = 79;
pub const EMR_SETDIBITSTODEVICE: u32 = 80;
pub const EMR_STRETCHDIBITS: u32 = 81;
pub const EMR_EXTCREATEFONTINDIRECTW: u32 = 82;
pub const EMR_EXTTEXTOUTA: u32 = 83;
pub const EMR_EXTTEXTOUTW: u32 = 84;
pub const EMR_POLYBEZIER16: u32 = 85;
pub const EMR_POLYGON16: u32 = 86;
pub const EMR_POLYLINE16: u32 = 87;
pub const EMR_POLYBEZIERTO16: u32 = 88;
pub const EMR_POLYLINETO16: u32 = 89;
pub const EMR_POLYPOLYLINE16: u32 = 90;
pub const EMR_POLYPOLYGON16: u32 = 91;
pub const EMR_POLYDRAW16: u32 = 92;
pub const EMR_CREATEMONOBRUSH: u32 = 93;
pub const EMR_CREATEDIBPATTERNBRUSHPT: u32 = 94;
pub const EMR_EXTCREATEPEN: u32 = 95;
pub const EMR_POLYTEXTOUTA: u32 = 96;
pub const EMR_POLYTEXTOUTW: u32 = 97;
pub const EMR_SETICMMODE: u32 = 98;
pub const EMR_CREATECOLORSPACE: u32 = 99;
pub const EMR_SETCOLORSPACE: u32 = 100;
pub const EMR_DELETECOLORSPACE: u32 = 101;
pub const EMR_GLSRECORD: u32 = 102;
pub const EMR_GLSBOUNDEDRECORD: u32 = 103;
pub const EMR_PIXELFORMAT: u32 = 104;
pub const EMR_RESERVED_105: u32 = 105;
pub const EMR_RESERVED_106: u32 = 106;
pub const EMR_RESERVED_107: u32 = 107;
pub const EMR_RESERVED_108: u32 = 108;
pub const EMR_RESERVED_109: u32 = 109;
pub const EMR_RESERVED_110: u32 = 110;
pub const EMR_COLORCORRECTPALETTE: u32 = 111;
pub const EMR_SETICMPROFILEA: u32 = 112;
pub const EMR_SETICMPROFILEW: u32 = 113;
pub const EMR_ALPHABLEND: u32 = 114;
pub const EMR_SETLAYOUT: u32 = 115;
pub const EMR_TRANSPARENTBLT: u32 = 116;
pub const EMR_RESERVED_117: u32 = 117;
pub const EMR_GRADIENTFILL: u32 = 118;
pub const EMR_RESERVED_119: u32 = 119;
pub const EMR_RESERVED_120: u32 = 120;
pub const EMR_COLORMATCHTOTARGETW: u32 = 121;
pub const EMR_CREATECOLORSPACEW: u32 = 122;
pub const EMR_MIN: u32 = 1;
pub const EMR_MAX: u32 = 122;
pub const SETICMPROFILE_EMBEDED: u32 = 1;
pub const CREATECOLORSPACE_EMBEDED: u32 = 1;
pub const COLORMATCHTOTARGET_EMBEDED: u32 = 1;
pub const GDICOMMENT_IDENTIFIER: u32 = 1128875079;
pub const GDICOMMENT_WINDOWS_METAFILE: u32 = 2147483649;
pub const GDICOMMENT_BEGINGROUP: u32 = 2;
pub const GDICOMMENT_ENDGROUP: u32 = 3;
pub const GDICOMMENT_MULTIFORMATS: u32 = 1073741828;
pub const EPS_SIGNATURE: u32 = 1179865157;
pub const GDICOMMENT_UNICODE_STRING: u32 = 64;
pub const GDICOMMENT_UNICODE_END: u32 = 128;
pub const WGL_FONT_LINES: u32 = 0;
pub const WGL_FONT_POLYGONS: u32 = 1;
pub const LPD_DOUBLEBUFFER: u32 = 1;
pub const LPD_STEREO: u32 = 2;
pub const LPD_SUPPORT_GDI: u32 = 16;
pub const LPD_SUPPORT_OPENGL: u32 = 32;
pub const LPD_SHARE_DEPTH: u32 = 64;
pub const LPD_SHARE_STENCIL: u32 = 128;
pub const LPD_SHARE_ACCUM: u32 = 256;
pub const LPD_SWAP_EXCHANGE: u32 = 512;
pub const LPD_SWAP_COPY: u32 = 1024;
pub const LPD_TRANSPARENT: u32 = 4096;
pub const LPD_TYPE_RGBA: u32 = 0;
pub const LPD_TYPE_COLORINDEX: u32 = 1;
pub const WGL_SWAP_MAIN_PLANE: u32 = 1;
pub const WGL_SWAP_OVERLAY1: u32 = 2;
pub const WGL_SWAP_OVERLAY2: u32 = 4;
pub const WGL_SWAP_OVERLAY3: u32 = 8;
pub const WGL_SWAP_OVERLAY4: u32 = 16;
pub const WGL_SWAP_OVERLAY5: u32 = 32;
pub const WGL_SWAP_OVERLAY6: u32 = 64;
pub const WGL_SWAP_OVERLAY7: u32 = 128;
pub const WGL_SWAP_OVERLAY8: u32 = 256;
pub const WGL_SWAP_OVERLAY9: u32 = 512;
pub const WGL_SWAP_OVERLAY10: u32 = 1024;
pub const WGL_SWAP_OVERLAY11: u32 = 2048;
pub const WGL_SWAP_OVERLAY12: u32 = 4096;
pub const WGL_SWAP_OVERLAY13: u32 = 8192;
pub const WGL_SWAP_OVERLAY14: u32 = 16384;
pub const WGL_SWAP_OVERLAY15: u32 = 32768;
pub const WGL_SWAP_UNDERLAY1: u32 = 65536;
pub const WGL_SWAP_UNDERLAY2: u32 = 131072;
pub const WGL_SWAP_UNDERLAY3: u32 = 262144;
pub const WGL_SWAP_UNDERLAY4: u32 = 524288;
pub const WGL_SWAP_UNDERLAY5: u32 = 1048576;
pub const WGL_SWAP_UNDERLAY6: u32 = 2097152;
pub const WGL_SWAP_UNDERLAY7: u32 = 4194304;
pub const WGL_SWAP_UNDERLAY8: u32 = 8388608;
pub const WGL_SWAP_UNDERLAY9: u32 = 16777216;
pub const WGL_SWAP_UNDERLAY10: u32 = 33554432;
pub const WGL_SWAP_UNDERLAY11: u32 = 67108864;
pub const WGL_SWAP_UNDERLAY12: u32 = 134217728;
pub const WGL_SWAP_UNDERLAY13: u32 = 268435456;
pub const WGL_SWAP_UNDERLAY14: u32 = 536870912;
pub const WGL_SWAP_UNDERLAY15: u32 = 1073741824;
pub const WGL_SWAPMULTIPLE_MAX: u32 = 16;
pub const DIFFERENCE: u32 = 11;
pub const SB_HORZ: u32 = 0;
pub const SB_VERT: u32 = 1;
pub const SB_CTL: u32 = 2;
pub const SB_BOTH: u32 = 3;
pub const SB_LINEUP: u32 = 0;
pub const SB_LINELEFT: u32 = 0;
pub const SB_LINEDOWN: u32 = 1;
pub const SB_LINERIGHT: u32 = 1;
pub const SB_PAGEUP: u32 = 2;
pub const SB_PAGELEFT: u32 = 2;
pub const SB_PAGEDOWN: u32 = 3;
pub const SB_PAGERIGHT: u32 = 3;
pub const SB_THUMBPOSITION: u32 = 4;
pub const SB_THUMBTRACK: u32 = 5;
pub const SB_TOP: u32 = 6;
pub const SB_LEFT: u32 = 6;
pub const SB_BOTTOM: u32 = 7;
pub const SB_RIGHT: u32 = 7;
pub const SB_ENDSCROLL: u32 = 8;
pub const SW_HIDE: u32 = 0;
pub const SW_SHOWNORMAL: u32 = 1;
pub const SW_NORMAL: u32 = 1;
pub const SW_SHOWMINIMIZED: u32 = 2;
pub const SW_SHOWMAXIMIZED: u32 = 3;
pub const SW_MAXIMIZE: u32 = 3;
pub const SW_SHOWNOACTIVATE: u32 = 4;
pub const SW_SHOW: u32 = 5;
pub const SW_MINIMIZE: u32 = 6;
pub const SW_SHOWMINNOACTIVE: u32 = 7;
pub const SW_SHOWNA: u32 = 8;
pub const SW_RESTORE: u32 = 9;
pub const SW_SHOWDEFAULT: u32 = 10;
pub const SW_FORCEMINIMIZE: u32 = 11;
pub const SW_MAX: u32 = 11;
pub const HIDE_WINDOW: u32 = 0;
pub const SHOW_OPENWINDOW: u32 = 1;
pub const SHOW_ICONWINDOW: u32 = 2;
pub const SHOW_FULLSCREEN: u32 = 3;
pub const SHOW_OPENNOACTIVATE: u32 = 4;
pub const SW_PARENTCLOSING: u32 = 1;
pub const SW_OTHERZOOM: u32 = 2;
pub const SW_PARENTOPENING: u32 = 3;
pub const SW_OTHERUNZOOM: u32 = 4;
pub const AW_HOR_POSITIVE: u32 = 1;
pub const AW_HOR_NEGATIVE: u32 = 2;
pub const AW_VER_POSITIVE: u32 = 4;
pub const AW_VER_NEGATIVE: u32 = 8;
pub const AW_CENTER: u32 = 16;
pub const AW_HIDE: u32 = 65536;
pub const AW_ACTIVATE: u32 = 131072;
pub const AW_SLIDE: u32 = 262144;
pub const AW_BLEND: u32 = 524288;
pub const KF_EXTENDED: u32 = 256;
pub const KF_DLGMODE: u32 = 2048;
pub const KF_MENUMODE: u32 = 4096;
pub const KF_ALTDOWN: u32 = 8192;
pub const KF_REPEAT: u32 = 16384;
pub const KF_UP: u32 = 32768;
pub const VK_LBUTTON: u32 = 1;
pub const VK_RBUTTON: u32 = 2;
pub const VK_CANCEL: u32 = 3;
pub const VK_MBUTTON: u32 = 4;
pub const VK_XBUTTON1: u32 = 5;
pub const VK_XBUTTON2: u32 = 6;
pub const VK_BACK: u32 = 8;
pub const VK_TAB: u32 = 9;
pub const VK_CLEAR: u32 = 12;
pub const VK_RETURN: u32 = 13;
pub const VK_SHIFT: u32 = 16;
pub const VK_CONTROL: u32 = 17;
pub const VK_MENU: u32 = 18;
pub const VK_PAUSE: u32 = 19;
pub const VK_CAPITAL: u32 = 20;
pub const VK_KANA: u32 = 21;
pub const VK_HANGEUL: u32 = 21;
pub const VK_HANGUL: u32 = 21;
pub const VK_IME_ON: u32 = 22;
pub const VK_JUNJA: u32 = 23;
pub const VK_FINAL: u32 = 24;
pub const VK_HANJA: u32 = 25;
pub const VK_KANJI: u32 = 25;
pub const VK_IME_OFF: u32 = 26;
pub const VK_ESCAPE: u32 = 27;
pub const VK_CONVERT: u32 = 28;
pub const VK_NONCONVERT: u32 = 29;
pub const VK_ACCEPT: u32 = 30;
pub const VK_MODECHANGE: u32 = 31;
pub const VK_SPACE: u32 = 32;
pub const VK_PRIOR: u32 = 33;
pub const VK_NEXT: u32 = 34;
pub const VK_END: u32 = 35;
pub const VK_HOME: u32 = 36;
pub const VK_LEFT: u32 = 37;
pub const VK_UP: u32 = 38;
pub const VK_RIGHT: u32 = 39;
pub const VK_DOWN: u32 = 40;
pub const VK_SELECT: u32 = 41;
pub const VK_PRINT: u32 = 42;
pub const VK_EXECUTE: u32 = 43;
pub const VK_SNAPSHOT: u32 = 44;
pub const VK_INSERT: u32 = 45;
pub const VK_DELETE: u32 = 46;
pub const VK_HELP: u32 = 47;
pub const VK_LWIN: u32 = 91;
pub const VK_RWIN: u32 = 92;
pub const VK_APPS: u32 = 93;
pub const VK_SLEEP: u32 = 95;
pub const VK_NUMPAD0: u32 = 96;
pub const VK_NUMPAD1: u32 = 97;
pub const VK_NUMPAD2: u32 = 98;
pub const VK_NUMPAD3: u32 = 99;
pub const VK_NUMPAD4: u32 = 100;
pub const VK_NUMPAD5: u32 = 101;
pub const VK_NUMPAD6: u32 = 102;
pub const VK_NUMPAD7: u32 = 103;
pub const VK_NUMPAD8: u32 = 104;
pub const VK_NUMPAD9: u32 = 105;
pub const VK_MULTIPLY: u32 = 106;
pub const VK_ADD: u32 = 107;
pub const VK_SEPARATOR: u32 = 108;
pub const VK_SUBTRACT: u32 = 109;
pub const VK_DECIMAL: u32 = 110;
pub const VK_DIVIDE: u32 = 111;
pub const VK_F1: u32 = 112;
pub const VK_F2: u32 = 113;
pub const VK_F3: u32 = 114;
pub const VK_F4: u32 = 115;
pub const VK_F5: u32 = 116;
pub const VK_F6: u32 = 117;
pub const VK_F7: u32 = 118;
pub const VK_F8: u32 = 119;
pub const VK_F9: u32 = 120;
pub const VK_F10: u32 = 121;
pub const VK_F11: u32 = 122;
pub const VK_F12: u32 = 123;
pub const VK_F13: u32 = 124;
pub const VK_F14: u32 = 125;
pub const VK_F15: u32 = 126;
pub const VK_F16: u32 = 127;
pub const VK_F17: u32 = 128;
pub const VK_F18: u32 = 129;
pub const VK_F19: u32 = 130;
pub const VK_F20: u32 = 131;
pub const VK_F21: u32 = 132;
pub const VK_F22: u32 = 133;
pub const VK_F23: u32 = 134;
pub const VK_F24: u32 = 135;
pub const VK_NAVIGATION_VIEW: u32 = 136;
pub const VK_NAVIGATION_MENU: u32 = 137;
pub const VK_NAVIGATION_UP: u32 = 138;
pub const VK_NAVIGATION_DOWN: u32 = 139;
pub const VK_NAVIGATION_LEFT: u32 = 140;
pub const VK_NAVIGATION_RIGHT: u32 = 141;
pub const VK_NAVIGATION_ACCEPT: u32 = 142;
pub const VK_NAVIGATION_CANCEL: u32 = 143;
pub const VK_NUMLOCK: u32 = 144;
pub const VK_SCROLL: u32 = 145;
pub const VK_OEM_NEC_EQUAL: u32 = 146;
pub const VK_OEM_FJ_JISHO: u32 = 146;
pub const VK_OEM_FJ_MASSHOU: u32 = 147;
pub const VK_OEM_FJ_TOUROKU: u32 = 148;
pub const VK_OEM_FJ_LOYA: u32 = 149;
pub const VK_OEM_FJ_ROYA: u32 = 150;
pub const VK_LSHIFT: u32 = 160;
pub const VK_RSHIFT: u32 = 161;
pub const VK_LCONTROL: u32 = 162;
pub const VK_RCONTROL: u32 = 163;
pub const VK_LMENU: u32 = 164;
pub const VK_RMENU: u32 = 165;
pub const VK_BROWSER_BACK: u32 = 166;
pub const VK_BROWSER_FORWARD: u32 = 167;
pub const VK_BROWSER_REFRESH: u32 = 168;
pub const VK_BROWSER_STOP: u32 = 169;
pub const VK_BROWSER_SEARCH: u32 = 170;
pub const VK_BROWSER_FAVORITES: u32 = 171;
pub const VK_BROWSER_HOME: u32 = 172;
pub const VK_VOLUME_MUTE: u32 = 173;
pub const VK_VOLUME_DOWN: u32 = 174;
pub const VK_VOLUME_UP: u32 = 175;
pub const VK_MEDIA_NEXT_TRACK: u32 = 176;
pub const VK_MEDIA_PREV_TRACK: u32 = 177;
pub const VK_MEDIA_STOP: u32 = 178;
pub const VK_MEDIA_PLAY_PAUSE: u32 = 179;
pub const VK_LAUNCH_MAIL: u32 = 180;
pub const VK_LAUNCH_MEDIA_SELECT: u32 = 181;
pub const VK_LAUNCH_APP1: u32 = 182;
pub const VK_LAUNCH_APP2: u32 = 183;
pub const VK_OEM_1: u32 = 186;
pub const VK_OEM_PLUS: u32 = 187;
pub const VK_OEM_COMMA: u32 = 188;
pub const VK_OEM_MINUS: u32 = 189;
pub const VK_OEM_PERIOD: u32 = 190;
pub const VK_OEM_2: u32 = 191;
pub const VK_OEM_3: u32 = 192;
pub const VK_GAMEPAD_A: u32 = 195;
pub const VK_GAMEPAD_B: u32 = 196;
pub const VK_GAMEPAD_X: u32 = 197;
pub const VK_GAMEPAD_Y: u32 = 198;
pub const VK_GAMEPAD_RIGHT_SHOULDER: u32 = 199;
pub const VK_GAMEPAD_LEFT_SHOULDER: u32 = 200;
pub const VK_GAMEPAD_LEFT_TRIGGER: u32 = 201;
pub const VK_GAMEPAD_RIGHT_TRIGGER: u32 = 202;
pub const VK_GAMEPAD_DPAD_UP: u32 = 203;
pub const VK_GAMEPAD_DPAD_DOWN: u32 = 204;
pub const VK_GAMEPAD_DPAD_LEFT: u32 = 205;
pub const VK_GAMEPAD_DPAD_RIGHT: u32 = 206;
pub const VK_GAMEPAD_MENU: u32 = 207;
pub const VK_GAMEPAD_VIEW: u32 = 208;
pub const VK_GAMEPAD_LEFT_THUMBSTICK_BUTTON: u32 = 209;
pub const VK_GAMEPAD_RIGHT_THUMBSTICK_BUTTON: u32 = 210;
pub const VK_GAMEPAD_LEFT_THUMBSTICK_UP: u32 = 211;
pub const VK_GAMEPAD_LEFT_THUMBSTICK_DOWN: u32 = 212;
pub const VK_GAMEPAD_LEFT_THUMBSTICK_RIGHT: u32 = 213;
pub const VK_GAMEPAD_LEFT_THUMBSTICK_LEFT: u32 = 214;
pub const VK_GAMEPAD_RIGHT_THUMBSTICK_UP: u32 = 215;
pub const VK_GAMEPAD_RIGHT_THUMBSTICK_DOWN: u32 = 216;
pub const VK_GAMEPAD_RIGHT_THUMBSTICK_RIGHT: u32 = 217;
pub const VK_GAMEPAD_RIGHT_THUMBSTICK_LEFT: u32 = 218;
pub const VK_OEM_4: u32 = 219;
pub const VK_OEM_5: u32 = 220;
pub const VK_OEM_6: u32 = 221;
pub const VK_OEM_7: u32 = 222;
pub const VK_OEM_8: u32 = 223;
pub const VK_OEM_AX: u32 = 225;
pub const VK_OEM_102: u32 = 226;
pub const VK_ICO_HELP: u32 = 227;
pub const VK_ICO_00: u32 = 228;
pub const VK_PROCESSKEY: u32 = 229;
pub const VK_ICO_CLEAR: u32 = 230;
pub const VK_PACKET: u32 = 231;
pub const VK_OEM_RESET: u32 = 233;
pub const VK_OEM_JUMP: u32 = 234;
pub const VK_OEM_PA1: u32 = 235;
pub const VK_OEM_PA2: u32 = 236;
pub const VK_OEM_PA3: u32 = 237;
pub const VK_OEM_WSCTRL: u32 = 238;
pub const VK_OEM_CUSEL: u32 = 239;
pub const VK_OEM_ATTN: u32 = 240;
pub const VK_OEM_FINISH: u32 = 241;
pub const VK_OEM_COPY: u32 = 242;
pub const VK_OEM_AUTO: u32 = 243;
pub const VK_OEM_ENLW: u32 = 244;
pub const VK_OEM_BACKTAB: u32 = 245;
pub const VK_ATTN: u32 = 246;
pub const VK_CRSEL: u32 = 247;
pub const VK_EXSEL: u32 = 248;
pub const VK_EREOF: u32 = 249;
pub const VK_PLAY: u32 = 250;
pub const VK_ZOOM: u32 = 251;
pub const VK_NONAME: u32 = 252;
pub const VK_PA1: u32 = 253;
pub const VK_OEM_CLEAR: u32 = 254;
pub const WH_MIN: i32 = -1;
pub const WH_MSGFILTER: i32 = -1;
pub const WH_JOURNALRECORD: u32 = 0;
pub const WH_JOURNALPLAYBACK: u32 = 1;
pub const WH_KEYBOARD: u32 = 2;
pub const WH_GETMESSAGE: u32 = 3;
pub const WH_CALLWNDPROC: u32 = 4;
pub const WH_CBT: u32 = 5;
pub const WH_SYSMSGFILTER: u32 = 6;
pub const WH_MOUSE: u32 = 7;
pub const WH_DEBUG: u32 = 9;
pub const WH_SHELL: u32 = 10;
pub const WH_FOREGROUNDIDLE: u32 = 11;
pub const WH_CALLWNDPROCRET: u32 = 12;
pub const WH_KEYBOARD_LL: u32 = 13;
pub const WH_MOUSE_LL: u32 = 14;
pub const WH_MAX: u32 = 14;
pub const WH_MINHOOK: i32 = -1;
pub const WH_MAXHOOK: u32 = 14;
pub const HC_ACTION: u32 = 0;
pub const HC_GETNEXT: u32 = 1;
pub const HC_SKIP: u32 = 2;
pub const HC_NOREMOVE: u32 = 3;
pub const HC_NOREM: u32 = 3;
pub const HC_SYSMODALON: u32 = 4;
pub const HC_SYSMODALOFF: u32 = 5;
pub const HCBT_MOVESIZE: u32 = 0;
pub const HCBT_MINMAX: u32 = 1;
pub const HCBT_QS: u32 = 2;
pub const HCBT_CREATEWND: u32 = 3;
pub const HCBT_DESTROYWND: u32 = 4;
pub const HCBT_ACTIVATE: u32 = 5;
pub const HCBT_CLICKSKIPPED: u32 = 6;
pub const HCBT_KEYSKIPPED: u32 = 7;
pub const HCBT_SYSCOMMAND: u32 = 8;
pub const HCBT_SETFOCUS: u32 = 9;
pub const WTS_CONSOLE_CONNECT: u32 = 1;
pub const WTS_CONSOLE_DISCONNECT: u32 = 2;
pub const WTS_REMOTE_CONNECT: u32 = 3;
pub const WTS_REMOTE_DISCONNECT: u32 = 4;
pub const WTS_SESSION_LOGON: u32 = 5;
pub const WTS_SESSION_LOGOFF: u32 = 6;
pub const WTS_SESSION_LOCK: u32 = 7;
pub const WTS_SESSION_UNLOCK: u32 = 8;
pub const WTS_SESSION_REMOTE_CONTROL: u32 = 9;
pub const WTS_SESSION_CREATE: u32 = 10;
pub const WTS_SESSION_TERMINATE: u32 = 11;
pub const MSGF_DIALOGBOX: u32 = 0;
pub const MSGF_MESSAGEBOX: u32 = 1;
pub const MSGF_MENU: u32 = 2;
pub const MSGF_SCROLLBAR: u32 = 5;
pub const MSGF_NEXTWINDOW: u32 = 6;
pub const MSGF_MAX: u32 = 8;
pub const MSGF_USER: u32 = 4096;
pub const HSHELL_WINDOWCREATED: u32 = 1;
pub const HSHELL_WINDOWDESTROYED: u32 = 2;
pub const HSHELL_ACTIVATESHELLWINDOW: u32 = 3;
pub const HSHELL_WINDOWACTIVATED: u32 = 4;
pub const HSHELL_GETMINRECT: u32 = 5;
pub const HSHELL_REDRAW: u32 = 6;
pub const HSHELL_TASKMAN: u32 = 7;
pub const HSHELL_LANGUAGE: u32 = 8;
pub const HSHELL_SYSMENU: u32 = 9;
pub const HSHELL_ENDTASK: u32 = 10;
pub const HSHELL_ACCESSIBILITYSTATE: u32 = 11;
pub const HSHELL_APPCOMMAND: u32 = 12;
pub const HSHELL_WINDOWREPLACED: u32 = 13;
pub const HSHELL_WINDOWREPLACING: u32 = 14;
pub const HSHELL_MONITORCHANGED: u32 = 16;
pub const HSHELL_HIGHBIT: u32 = 32768;
pub const HSHELL_FLASH: u32 = 32774;
pub const HSHELL_RUDEAPPACTIVATED: u32 = 32772;
pub const APPCOMMAND_BROWSER_BACKWARD: u32 = 1;
pub const APPCOMMAND_BROWSER_FORWARD: u32 = 2;
pub const APPCOMMAND_BROWSER_REFRESH: u32 = 3;
pub const APPCOMMAND_BROWSER_STOP: u32 = 4;
pub const APPCOMMAND_BROWSER_SEARCH: u32 = 5;
pub const APPCOMMAND_BROWSER_FAVORITES: u32 = 6;
pub const APPCOMMAND_BROWSER_HOME: u32 = 7;
pub const APPCOMMAND_VOLUME_MUTE: u32 = 8;
pub const APPCOMMAND_VOLUME_DOWN: u32 = 9;
pub const APPCOMMAND_VOLUME_UP: u32 = 10;
pub const APPCOMMAND_MEDIA_NEXTTRACK: u32 = 11;
pub const APPCOMMAND_MEDIA_PREVIOUSTRACK: u32 = 12;
pub const APPCOMMAND_MEDIA_STOP: u32 = 13;
pub const APPCOMMAND_MEDIA_PLAY_PAUSE: u32 = 14;
pub const APPCOMMAND_LAUNCH_MAIL: u32 = 15;
pub const APPCOMMAND_LAUNCH_MEDIA_SELECT: u32 = 16;
pub const APPCOMMAND_LAUNCH_APP1: u32 = 17;
pub const APPCOMMAND_LAUNCH_APP2: u32 = 18;
pub const APPCOMMAND_BASS_DOWN: u32 = 19;
pub const APPCOMMAND_BASS_BOOST: u32 = 20;
pub const APPCOMMAND_BASS_UP: u32 = 21;
pub const APPCOMMAND_TREBLE_DOWN: u32 = 22;
pub const APPCOMMAND_TREBLE_UP: u32 = 23;
pub const APPCOMMAND_MICROPHONE_VOLUME_MUTE: u32 = 24;
pub const APPCOMMAND_MICROPHONE_VOLUME_DOWN: u32 = 25;
pub const APPCOMMAND_MICROPHONE_VOLUME_UP: u32 = 26;
pub const APPCOMMAND_HELP: u32 = 27;
pub const APPCOMMAND_FIND: u32 = 28;
pub const APPCOMMAND_NEW: u32 = 29;
pub const APPCOMMAND_OPEN: u32 = 30;
pub const APPCOMMAND_CLOSE: u32 = 31;
pub const APPCOMMAND_SAVE: u32 = 32;
pub const APPCOMMAND_PRINT: u32 = 33;
pub const APPCOMMAND_UNDO: u32 = 34;
pub const APPCOMMAND_REDO: u32 = 35;
pub const APPCOMMAND_COPY: u32 = 36;
pub const APPCOMMAND_CUT: u32 = 37;
pub const APPCOMMAND_PASTE: u32 = 38;
pub const APPCOMMAND_REPLY_TO_MAIL: u32 = 39;
pub const APPCOMMAND_FORWARD_MAIL: u32 = 40;
pub const APPCOMMAND_SEND_MAIL: u32 = 41;
pub const APPCOMMAND_SPELL_CHECK: u32 = 42;
pub const APPCOMMAND_DICTATE_OR_COMMAND_CONTROL_TOGGLE: u32 = 43;
pub const APPCOMMAND_MIC_ON_OFF_TOGGLE: u32 = 44;
pub const APPCOMMAND_CORRECTION_LIST: u32 = 45;
pub const APPCOMMAND_MEDIA_PLAY: u32 = 46;
pub const APPCOMMAND_MEDIA_PAUSE: u32 = 47;
pub const APPCOMMAND_MEDIA_RECORD: u32 = 48;
pub const APPCOMMAND_MEDIA_FAST_FORWARD: u32 = 49;
pub const APPCOMMAND_MEDIA_REWIND: u32 = 50;
pub const APPCOMMAND_MEDIA_CHANNEL_UP: u32 = 51;
pub const APPCOMMAND_MEDIA_CHANNEL_DOWN: u32 = 52;
pub const APPCOMMAND_DELETE: u32 = 53;
pub const APPCOMMAND_DWM_FLIP3D: u32 = 54;
pub const FAPPCOMMAND_MOUSE: u32 = 32768;
pub const FAPPCOMMAND_KEY: u32 = 0;
pub const FAPPCOMMAND_OEM: u32 = 4096;
pub const FAPPCOMMAND_MASK: u32 = 61440;
pub const LLKHF_EXTENDED: u32 = 1;
pub const LLKHF_INJECTED: u32 = 16;
pub const LLKHF_ALTDOWN: u32 = 32;
pub const LLKHF_UP: u32 = 128;
pub const LLKHF_LOWER_IL_INJECTED: u32 = 2;
pub const LLMHF_INJECTED: u32 = 1;
pub const LLMHF_LOWER_IL_INJECTED: u32 = 2;
pub const HKL_PREV: u32 = 0;
pub const HKL_NEXT: u32 = 1;
pub const KLF_ACTIVATE: u32 = 1;
pub const KLF_SUBSTITUTE_OK: u32 = 2;
pub const KLF_REORDER: u32 = 8;
pub const KLF_REPLACELANG: u32 = 16;
pub const KLF_NOTELLSHELL: u32 = 128;
pub const KLF_SETFORPROCESS: u32 = 256;
pub const KLF_SHIFTLOCK: u32 = 65536;
pub const KLF_RESET: u32 = 1073741824;
pub const INPUTLANGCHANGE_SYSCHARSET: u32 = 1;
pub const INPUTLANGCHANGE_FORWARD: u32 = 2;
pub const INPUTLANGCHANGE_BACKWARD: u32 = 4;
pub const KL_NAMELENGTH: u32 = 9;
pub const GMMP_USE_DISPLAY_POINTS: u32 = 1;
pub const GMMP_USE_HIGH_RESOLUTION_POINTS: u32 = 2;
pub const DESKTOP_READOBJECTS: u32 = 1;
pub const DESKTOP_CREATEWINDOW: u32 = 2;
pub const DESKTOP_CREATEMENU: u32 = 4;
pub const DESKTOP_HOOKCONTROL: u32 = 8;
pub const DESKTOP_JOURNALRECORD: u32 = 16;
pub const DESKTOP_JOURNALPLAYBACK: u32 = 32;
pub const DESKTOP_ENUMERATE: u32 = 64;
pub const DESKTOP_WRITEOBJECTS: u32 = 128;
pub const DESKTOP_SWITCHDESKTOP: u32 = 256;
pub const DF_ALLOWOTHERACCOUNTHOOK: u32 = 1;
pub const WINSTA_ENUMDESKTOPS: u32 = 1;
pub const WINSTA_READATTRIBUTES: u32 = 2;
pub const WINSTA_ACCESSCLIPBOARD: u32 = 4;
pub const WINSTA_CREATEDESKTOP: u32 = 8;
pub const WINSTA_WRITEATTRIBUTES: u32 = 16;
pub const WINSTA_ACCESSGLOBALATOMS: u32 = 32;
pub const WINSTA_EXITWINDOWS: u32 = 64;
pub const WINSTA_ENUMERATE: u32 = 256;
pub const WINSTA_READSCREEN: u32 = 512;
pub const WINSTA_ALL_ACCESS: u32 = 895;
pub const CWF_CREATE_ONLY: u32 = 1;
pub const WSF_VISIBLE: u32 = 1;
pub const UOI_FLAGS: u32 = 1;
pub const UOI_NAME: u32 = 2;
pub const UOI_TYPE: u32 = 3;
pub const UOI_USER_SID: u32 = 4;
pub const UOI_HEAPSIZE: u32 = 5;
pub const UOI_IO: u32 = 6;
pub const UOI_TIMERPROC_EXCEPTION_SUPPRESSION: u32 = 7;
pub const GWL_WNDPROC: i32 = -4;
pub const GWL_HINSTANCE: i32 = -6;
pub const GWL_HWNDPARENT: i32 = -8;
pub const GWL_STYLE: i32 = -16;
pub const GWL_EXSTYLE: i32 = -20;
pub const GWL_USERDATA: i32 = -21;
pub const GWL_ID: i32 = -12;
pub const GWLP_WNDPROC: i32 = -4;
pub const GWLP_HINSTANCE: i32 = -6;
pub const GWLP_HWNDPARENT: i32 = -8;
pub const GWLP_USERDATA: i32 = -21;
pub const GWLP_ID: i32 = -12;
pub const GCL_MENUNAME: i32 = -8;
pub const GCL_HBRBACKGROUND: i32 = -10;
pub const GCL_HCURSOR: i32 = -12;
pub const GCL_HICON: i32 = -14;
pub const GCL_HMODULE: i32 = -16;
pub const GCL_CBWNDEXTRA: i32 = -18;
pub const GCL_CBCLSEXTRA: i32 = -20;
pub const GCL_WNDPROC: i32 = -24;
pub const GCL_STYLE: i32 = -26;
pub const GCW_ATOM: i32 = -32;
pub const GCL_HICONSM: i32 = -34;
pub const GCLP_MENUNAME: i32 = -8;
pub const GCLP_HBRBACKGROUND: i32 = -10;
pub const GCLP_HCURSOR: i32 = -12;
pub const GCLP_HICON: i32 = -14;
pub const GCLP_HMODULE: i32 = -16;
pub const GCLP_WNDPROC: i32 = -24;
pub const GCLP_HICONSM: i32 = -34;
pub const WM_NULL: u32 = 0;
pub const WM_CREATE: u32 = 1;
pub const WM_DESTROY: u32 = 2;
pub const WM_MOVE: u32 = 3;
pub const WM_SIZE: u32 = 5;
pub const WM_ACTIVATE: u32 = 6;
pub const WA_INACTIVE: u32 = 0;
pub const WA_ACTIVE: u32 = 1;
pub const WA_CLICKACTIVE: u32 = 2;
pub const WM_SETFOCUS: u32 = 7;
pub const WM_KILLFOCUS: u32 = 8;
pub const WM_ENABLE: u32 = 10;
pub const WM_SETREDRAW: u32 = 11;
pub const WM_SETTEXT: u32 = 12;
pub const WM_GETTEXT: u32 = 13;
pub const WM_GETTEXTLENGTH: u32 = 14;
pub const WM_PAINT: u32 = 15;
pub const WM_CLOSE: u32 = 16;
pub const WM_QUERYENDSESSION: u32 = 17;
pub const WM_QUERYOPEN: u32 = 19;
pub const WM_ENDSESSION: u32 = 22;
pub const WM_QUIT: u32 = 18;
pub const WM_ERASEBKGND: u32 = 20;
pub const WM_SYSCOLORCHANGE: u32 = 21;
pub const WM_SHOWWINDOW: u32 = 24;
pub const WM_WININICHANGE: u32 = 26;
pub const WM_SETTINGCHANGE: u32 = 26;
pub const WM_DEVMODECHANGE: u32 = 27;
pub const WM_ACTIVATEAPP: u32 = 28;
pub const WM_FONTCHANGE: u32 = 29;
pub const WM_TIMECHANGE: u32 = 30;
pub const WM_CANCELMODE: u32 = 31;
pub const WM_SETCURSOR: u32 = 32;
pub const WM_MOUSEACTIVATE: u32 = 33;
pub const WM_CHILDACTIVATE: u32 = 34;
pub const WM_QUEUESYNC: u32 = 35;
pub const WM_GETMINMAXINFO: u32 = 36;
pub const WM_PAINTICON: u32 = 38;
pub const WM_ICONERASEBKGND: u32 = 39;
pub const WM_NEXTDLGCTL: u32 = 40;
pub const WM_SPOOLERSTATUS: u32 = 42;
pub const WM_DRAWITEM: u32 = 43;
pub const WM_MEASUREITEM: u32 = 44;
pub const WM_DELETEITEM: u32 = 45;
pub const WM_VKEYTOITEM: u32 = 46;
pub const WM_CHARTOITEM: u32 = 47;
pub const WM_SETFONT: u32 = 48;
pub const WM_GETFONT: u32 = 49;
pub const WM_SETHOTKEY: u32 = 50;
pub const WM_GETHOTKEY: u32 = 51;
pub const WM_QUERYDRAGICON: u32 = 55;
pub const WM_COMPAREITEM: u32 = 57;
pub const WM_GETOBJECT: u32 = 61;
pub const WM_COMPACTING: u32 = 65;
pub const WM_COMMNOTIFY: u32 = 68;
pub const WM_WINDOWPOSCHANGING: u32 = 70;
pub const WM_WINDOWPOSCHANGED: u32 = 71;
pub const WM_POWER: u32 = 72;
pub const PWR_OK: u32 = 1;
pub const PWR_FAIL: i32 = -1;
pub const PWR_SUSPENDREQUEST: u32 = 1;
pub const PWR_SUSPENDRESUME: u32 = 2;
pub const PWR_CRITICALRESUME: u32 = 3;
pub const WM_COPYDATA: u32 = 74;
pub const WM_CANCELJOURNAL: u32 = 75;
pub const WM_NOTIFY: u32 = 78;
pub const WM_INPUTLANGCHANGEREQUEST: u32 = 80;
pub const WM_INPUTLANGCHANGE: u32 = 81;
pub const WM_TCARD: u32 = 82;
pub const WM_HELP: u32 = 83;
pub const WM_USERCHANGED: u32 = 84;
pub const WM_NOTIFYFORMAT: u32 = 85;
pub const NFR_ANSI: u32 = 1;
pub const NFR_UNICODE: u32 = 2;
pub const NF_QUERY: u32 = 3;
pub const NF_REQUERY: u32 = 4;
pub const WM_CONTEXTMENU: u32 = 123;
pub const WM_STYLECHANGING: u32 = 124;
pub const WM_STYLECHANGED: u32 = 125;
pub const WM_DISPLAYCHANGE: u32 = 126;
pub const WM_GETICON: u32 = 127;
pub const WM_SETICON: u32 = 128;
pub const WM_NCCREATE: u32 = 129;
pub const WM_NCDESTROY: u32 = 130;
pub const WM_NCCALCSIZE: u32 = 131;
pub const WM_NCHITTEST: u32 = 132;
pub const WM_NCPAINT: u32 = 133;
pub const WM_NCACTIVATE: u32 = 134;
pub const WM_GETDLGCODE: u32 = 135;
pub const WM_SYNCPAINT: u32 = 136;
pub const WM_NCMOUSEMOVE: u32 = 160;
pub const WM_NCLBUTTONDOWN: u32 = 161;
pub const WM_NCLBUTTONUP: u32 = 162;
pub const WM_NCLBUTTONDBLCLK: u32 = 163;
pub const WM_NCRBUTTONDOWN: u32 = 164;
pub const WM_NCRBUTTONUP: u32 = 165;
pub const WM_NCRBUTTONDBLCLK: u32 = 166;
pub const WM_NCMBUTTONDOWN: u32 = 167;
pub const WM_NCMBUTTONUP: u32 = 168;
pub const WM_NCMBUTTONDBLCLK: u32 = 169;
pub const WM_NCXBUTTONDOWN: u32 = 171;
pub const WM_NCXBUTTONUP: u32 = 172;
pub const WM_NCXBUTTONDBLCLK: u32 = 173;
pub const WM_INPUT_DEVICE_CHANGE: u32 = 254;
pub const WM_INPUT: u32 = 255;
pub const WM_KEYFIRST: u32 = 256;
pub const WM_KEYDOWN: u32 = 256;
pub const WM_KEYUP: u32 = 257;
pub const WM_CHAR: u32 = 258;
pub const WM_DEADCHAR: u32 = 259;
pub const WM_SYSKEYDOWN: u32 = 260;
pub const WM_SYSKEYUP: u32 = 261;
pub const WM_SYSCHAR: u32 = 262;
pub const WM_SYSDEADCHAR: u32 = 263;
pub const WM_UNICHAR: u32 = 265;
pub const WM_KEYLAST: u32 = 265;
pub const UNICODE_NOCHAR: u32 = 65535;
pub const WM_IME_STARTCOMPOSITION: u32 = 269;
pub const WM_IME_ENDCOMPOSITION: u32 = 270;
pub const WM_IME_COMPOSITION: u32 = 271;
pub const WM_IME_KEYLAST: u32 = 271;
pub const WM_INITDIALOG: u32 = 272;
pub const WM_COMMAND: u32 = 273;
pub const WM_SYSCOMMAND: u32 = 274;
pub const WM_TIMER: u32 = 275;
pub const WM_HSCROLL: u32 = 276;
pub const WM_VSCROLL: u32 = 277;
pub const WM_INITMENU: u32 = 278;
pub const WM_INITMENUPOPUP: u32 = 279;
pub const WM_GESTURE: u32 = 281;
pub const WM_GESTURENOTIFY: u32 = 282;
pub const WM_MENUSELECT: u32 = 287;
pub const WM_MENUCHAR: u32 = 288;
pub const WM_ENTERIDLE: u32 = 289;
pub const WM_MENURBUTTONUP: u32 = 290;
pub const WM_MENUDRAG: u32 = 291;
pub const WM_MENUGETOBJECT: u32 = 292;
pub const WM_UNINITMENUPOPUP: u32 = 293;
pub const WM_MENUCOMMAND: u32 = 294;
pub const WM_CHANGEUISTATE: u32 = 295;
pub const WM_UPDATEUISTATE: u32 = 296;
pub const WM_QUERYUISTATE: u32 = 297;
pub const UIS_SET: u32 = 1;
pub const UIS_CLEAR: u32 = 2;
pub const UIS_INITIALIZE: u32 = 3;
pub const UISF_HIDEFOCUS: u32 = 1;
pub const UISF_HIDEACCEL: u32 = 2;
pub const UISF_ACTIVE: u32 = 4;
pub const WM_CTLCOLORMSGBOX: u32 = 306;
pub const WM_CTLCOLOREDIT: u32 = 307;
pub const WM_CTLCOLORLISTBOX: u32 = 308;
pub const WM_CTLCOLORBTN: u32 = 309;
pub const WM_CTLCOLORDLG: u32 = 310;
pub const WM_CTLCOLORSCROLLBAR: u32 = 311;
pub const WM_CTLCOLORSTATIC: u32 = 312;
pub const MN_GETHMENU: u32 = 481;
pub const WM_MOUSEFIRST: u32 = 512;
pub const WM_MOUSEMOVE: u32 = 512;
pub const WM_LBUTTONDOWN: u32 = 513;
pub const WM_LBUTTONUP: u32 = 514;
pub const WM_LBUTTONDBLCLK: u32 = 515;
pub const WM_RBUTTONDOWN: u32 = 516;
pub const WM_RBUTTONUP: u32 = 517;
pub const WM_RBUTTONDBLCLK: u32 = 518;
pub const WM_MBUTTONDOWN: u32 = 519;
pub const WM_MBUTTONUP: u32 = 520;
pub const WM_MBUTTONDBLCLK: u32 = 521;
pub const WM_MOUSEWHEEL: u32 = 522;
pub const WM_XBUTTONDOWN: u32 = 523;
pub const WM_XBUTTONUP: u32 = 524;
pub const WM_XBUTTONDBLCLK: u32 = 525;
pub const WM_MOUSEHWHEEL: u32 = 526;
pub const WM_MOUSELAST: u32 = 526;
pub const WHEEL_DELTA: u32 = 120;
pub const XBUTTON1: u32 = 1;
pub const XBUTTON2: u32 = 2;
pub const WM_PARENTNOTIFY: u32 = 528;
pub const WM_ENTERMENULOOP: u32 = 529;
pub const WM_EXITMENULOOP: u32 = 530;
pub const WM_NEXTMENU: u32 = 531;
pub const WM_SIZING: u32 = 532;
pub const WM_CAPTURECHANGED: u32 = 533;
pub const WM_MOVING: u32 = 534;
pub const WM_POWERBROADCAST: u32 = 536;
pub const PBT_APMQUERYSUSPEND: u32 = 0;
pub const PBT_APMQUERYSTANDBY: u32 = 1;
pub const PBT_APMQUERYSUSPENDFAILED: u32 = 2;
pub const PBT_APMQUERYSTANDBYFAILED: u32 = 3;
pub const PBT_APMSUSPEND: u32 = 4;
pub const PBT_APMSTANDBY: u32 = 5;
pub const PBT_APMRESUMECRITICAL: u32 = 6;
pub const PBT_APMRESUMESUSPEND: u32 = 7;
pub const PBT_APMRESUMESTANDBY: u32 = 8;
pub const PBTF_APMRESUMEFROMFAILURE: u32 = 1;
pub const PBT_APMBATTERYLOW: u32 = 9;
pub const PBT_APMPOWERSTATUSCHANGE: u32 = 10;
pub const PBT_APMOEMEVENT: u32 = 11;
pub const PBT_APMRESUMEAUTOMATIC: u32 = 18;
pub const PBT_POWERSETTINGCHANGE: u32 = 32787;
pub const WM_DEVICECHANGE: u32 = 537;
pub const WM_MDICREATE: u32 = 544;
pub const WM_MDIDESTROY: u32 = 545;
pub const WM_MDIACTIVATE: u32 = 546;
pub const WM_MDIRESTORE: u32 = 547;
pub const WM_MDINEXT: u32 = 548;
pub const WM_MDIMAXIMIZE: u32 = 549;
pub const WM_MDITILE: u32 = 550;
pub const WM_MDICASCADE: u32 = 551;
pub const WM_MDIICONARRANGE: u32 = 552;
pub const WM_MDIGETACTIVE: u32 = 553;
pub const WM_MDISETMENU: u32 = 560;
pub const WM_ENTERSIZEMOVE: u32 = 561;
pub const WM_EXITSIZEMOVE: u32 = 562;
pub const WM_DROPFILES: u32 = 563;
pub const WM_MDIREFRESHMENU: u32 = 564;
pub const WM_POINTERDEVICECHANGE: u32 = 568;
pub const WM_POINTERDEVICEINRANGE: u32 = 569;
pub const WM_POINTERDEVICEOUTOFRANGE: u32 = 570;
pub const WM_TOUCH: u32 = 576;
pub const WM_NCPOINTERUPDATE: u32 = 577;
pub const WM_NCPOINTERDOWN: u32 = 578;
pub const WM_NCPOINTERUP: u32 = 579;
pub const WM_POINTERUPDATE: u32 = 581;
pub const WM_POINTERDOWN: u32 = 582;
pub const WM_POINTERUP: u32 = 583;
pub const WM_POINTERENTER: u32 = 585;
pub const WM_POINTERLEAVE: u32 = 586;
pub const WM_POINTERACTIVATE: u32 = 587;
pub const WM_POINTERCAPTURECHANGED: u32 = 588;
pub const WM_TOUCHHITTESTING: u32 = 589;
pub const WM_POINTERWHEEL: u32 = 590;
pub const WM_POINTERHWHEEL: u32 = 591;
pub const DM_POINTERHITTEST: u32 = 592;
pub const WM_POINTERROUTEDTO: u32 = 593;
pub const WM_POINTERROUTEDAWAY: u32 = 594;
pub const WM_POINTERROUTEDRELEASED: u32 = 595;
pub const WM_IME_SETCONTEXT: u32 = 641;
pub const WM_IME_NOTIFY: u32 = 642;
pub const WM_IME_CONTROL: u32 = 643;
pub const WM_IME_COMPOSITIONFULL: u32 = 644;
pub const WM_IME_SELECT: u32 = 645;
pub const WM_IME_CHAR: u32 = 646;
pub const WM_IME_REQUEST: u32 = 648;
pub const WM_IME_KEYDOWN: u32 = 656;
pub const WM_IME_KEYUP: u32 = 657;
pub const WM_MOUSEHOVER: u32 = 673;
pub const WM_MOUSELEAVE: u32 = 675;
pub const WM_NCMOUSEHOVER: u32 = 672;
pub const WM_NCMOUSELEAVE: u32 = 674;
pub const WM_WTSSESSION_CHANGE: u32 = 689;
pub const WM_TABLET_FIRST: u32 = 704;
pub const WM_TABLET_LAST: u32 = 735;
pub const WM_DPICHANGED: u32 = 736;
pub const WM_DPICHANGED_BEFOREPARENT: u32 = 738;
pub const WM_DPICHANGED_AFTERPARENT: u32 = 739;
pub const WM_GETDPISCALEDSIZE: u32 = 740;
pub const WM_CUT: u32 = 768;
pub const WM_COPY: u32 = 769;
pub const WM_PASTE: u32 = 770;
pub const WM_CLEAR: u32 = 771;
pub const WM_UNDO: u32 = 772;
pub const WM_RENDERFORMAT: u32 = 773;
pub const WM_RENDERALLFORMATS: u32 = 774;
pub const WM_DESTROYCLIPBOARD: u32 = 775;
pub const WM_DRAWCLIPBOARD: u32 = 776;
pub const WM_PAINTCLIPBOARD: u32 = 777;
pub const WM_VSCROLLCLIPBOARD: u32 = 778;
pub const WM_SIZECLIPBOARD: u32 = 779;
pub const WM_ASKCBFORMATNAME: u32 = 780;
pub const WM_CHANGECBCHAIN: u32 = 781;
pub const WM_HSCROLLCLIPBOARD: u32 = 782;
pub const WM_QUERYNEWPALETTE: u32 = 783;
pub const WM_PALETTEISCHANGING: u32 = 784;
pub const WM_PALETTECHANGED: u32 = 785;
pub const WM_HOTKEY: u32 = 786;
pub const WM_PRINT: u32 = 791;
pub const WM_PRINTCLIENT: u32 = 792;
pub const WM_APPCOMMAND: u32 = 793;
pub const WM_THEMECHANGED: u32 = 794;
pub const WM_CLIPBOARDUPDATE: u32 = 797;
pub const WM_DWMCOMPOSITIONCHANGED: u32 = 798;
pub const WM_DWMNCRENDERINGCHANGED: u32 = 799;
pub const WM_DWMCOLORIZATIONCOLORCHANGED: u32 = 800;
pub const WM_DWMWINDOWMAXIMIZEDCHANGE: u32 = 801;
pub const WM_DWMSENDICONICTHUMBNAIL: u32 = 803;
pub const WM_DWMSENDICONICLIVEPREVIEWBITMAP: u32 = 806;
pub const WM_GETTITLEBARINFOEX: u32 = 831;
pub const WM_HANDHELDFIRST: u32 = 856;
pub const WM_HANDHELDLAST: u32 = 863;
pub const WM_AFXFIRST: u32 = 864;
pub const WM_AFXLAST: u32 = 895;
pub const WM_PENWINFIRST: u32 = 896;
pub const WM_PENWINLAST: u32 = 911;
pub const WM_APP: u32 = 32768;
pub const WM_USER: u32 = 1024;
pub const WMSZ_LEFT: u32 = 1;
pub const WMSZ_RIGHT: u32 = 2;
pub const WMSZ_TOP: u32 = 3;
pub const WMSZ_TOPLEFT: u32 = 4;
pub const WMSZ_TOPRIGHT: u32 = 5;
pub const WMSZ_BOTTOM: u32 = 6;
pub const WMSZ_BOTTOMLEFT: u32 = 7;
pub const WMSZ_BOTTOMRIGHT: u32 = 8;
pub const HTERROR: i32 = -2;
pub const HTTRANSPARENT: i32 = -1;
pub const HTNOWHERE: u32 = 0;
pub const HTCLIENT: u32 = 1;
pub const HTCAPTION: u32 = 2;
pub const HTSYSMENU: u32 = 3;
pub const HTGROWBOX: u32 = 4;
pub const HTSIZE: u32 = 4;
pub const HTMENU: u32 = 5;
pub const HTHSCROLL: u32 = 6;
pub const HTVSCROLL: u32 = 7;
pub const HTMINBUTTON: u32 = 8;
pub const HTMAXBUTTON: u32 = 9;
pub const HTLEFT: u32 = 10;
pub const HTRIGHT: u32 = 11;
pub const HTTOP: u32 = 12;
pub const HTTOPLEFT: u32 = 13;
pub const HTTOPRIGHT: u32 = 14;
pub const HTBOTTOM: u32 = 15;
pub const HTBOTTOMLEFT: u32 = 16;
pub const HTBOTTOMRIGHT: u32 = 17;
pub const HTBORDER: u32 = 18;
pub const HTREDUCE: u32 = 8;
pub const HTZOOM: u32 = 9;
pub const HTSIZEFIRST: u32 = 10;
pub const HTSIZELAST: u32 = 17;
pub const HTOBJECT: u32 = 19;
pub const HTCLOSE: u32 = 20;
pub const HTHELP: u32 = 21;
pub const SMTO_NORMAL: u32 = 0;
pub const SMTO_BLOCK: u32 = 1;
pub const SMTO_ABORTIFHUNG: u32 = 2;
pub const SMTO_NOTIMEOUTIFNOTHUNG: u32 = 8;
pub const SMTO_ERRORONEXIT: u32 = 32;
pub const MA_ACTIVATE: u32 = 1;
pub const MA_ACTIVATEANDEAT: u32 = 2;
pub const MA_NOACTIVATE: u32 = 3;
pub const MA_NOACTIVATEANDEAT: u32 = 4;
pub const ICON_SMALL: u32 = 0;
pub const ICON_BIG: u32 = 1;
pub const ICON_SMALL2: u32 = 2;
pub const SIZE_RESTORED: u32 = 0;
pub const SIZE_MINIMIZED: u32 = 1;
pub const SIZE_MAXIMIZED: u32 = 2;
pub const SIZE_MAXSHOW: u32 = 3;
pub const SIZE_MAXHIDE: u32 = 4;
pub const SIZENORMAL: u32 = 0;
pub const SIZEICONIC: u32 = 1;
pub const SIZEFULLSCREEN: u32 = 2;
pub const SIZEZOOMSHOW: u32 = 3;
pub const SIZEZOOMHIDE: u32 = 4;
pub const WVR_ALIGNTOP: u32 = 16;
pub const WVR_ALIGNLEFT: u32 = 32;
pub const WVR_ALIGNBOTTOM: u32 = 64;
pub const WVR_ALIGNRIGHT: u32 = 128;
pub const WVR_HREDRAW: u32 = 256;
pub const WVR_VREDRAW: u32 = 512;
pub const WVR_REDRAW: u32 = 768;
pub const WVR_VALIDRECTS: u32 = 1024;
pub const MK_LBUTTON: u32 = 1;
pub const MK_RBUTTON: u32 = 2;
pub const MK_SHIFT: u32 = 4;
pub const MK_CONTROL: u32 = 8;
pub const MK_MBUTTON: u32 = 16;
pub const MK_XBUTTON1: u32 = 32;
pub const MK_XBUTTON2: u32 = 64;
pub const TME_HOVER: u32 = 1;
pub const TME_LEAVE: u32 = 2;
pub const TME_NONCLIENT: u32 = 16;
pub const TME_QUERY: u32 = 1073741824;
pub const TME_CANCEL: u32 = 2147483648;
pub const HOVER_DEFAULT: u32 = 4294967295;
pub const WS_OVERLAPPED: u32 = 0;
pub const WS_POPUP: u32 = 2147483648;
pub const WS_CHILD: u32 = 1073741824;
pub const WS_MINIMIZE: u32 = 536870912;
pub const WS_VISIBLE: u32 = 268435456;
pub const WS_DISABLED: u32 = 134217728;
pub const WS_CLIPSIBLINGS: u32 = 67108864;
pub const WS_CLIPCHILDREN: u32 = 33554432;
pub const WS_MAXIMIZE: u32 = 16777216;
pub const WS_CAPTION: u32 = 12582912;
pub const WS_BORDER: u32 = 8388608;
pub const WS_DLGFRAME: u32 = 4194304;
pub const WS_VSCROLL: u32 = 2097152;
pub const WS_HSCROLL: u32 = 1048576;
pub const WS_SYSMENU: u32 = 524288;
pub const WS_THICKFRAME: u32 = 262144;
pub const WS_GROUP: u32 = 131072;
pub const WS_TABSTOP: u32 = 65536;
pub const WS_MINIMIZEBOX: u32 = 131072;
pub const WS_MAXIMIZEBOX: u32 = 65536;
pub const WS_TILED: u32 = 0;
pub const WS_ICONIC: u32 = 536870912;
pub const WS_SIZEBOX: u32 = 262144;
pub const WS_OVERLAPPEDWINDOW: u32 = 13565952;
pub const WS_POPUPWINDOW: u32 = 2156396544;
pub const WS_CHILDWINDOW: u32 = 1073741824;
pub const WS_EX_DLGMODALFRAME: u32 = 1;
pub const WS_EX_NOPARENTNOTIFY: u32 = 4;
pub const WS_EX_TOPMOST: u32 = 8;
pub const WS_EX_ACCEPTFILES: u32 = 16;
pub const WS_EX_TRANSPARENT: u32 = 32;
pub const WS_EX_MDICHILD: u32 = 64;
pub const WS_EX_TOOLWINDOW: u32 = 128;
pub const WS_EX_WINDOWEDGE: u32 = 256;
pub const WS_EX_CLIENTEDGE: u32 = 512;
pub const WS_EX_CONTEXTHELP: u32 = 1024;
pub const WS_EX_RIGHT: u32 = 4096;
pub const WS_EX_LEFT: u32 = 0;
pub const WS_EX_RTLREADING: u32 = 8192;
pub const WS_EX_LTRREADING: u32 = 0;
pub const WS_EX_LEFTSCROLLBAR: u32 = 16384;
pub const WS_EX_RIGHTSCROLLBAR: u32 = 0;
pub const WS_EX_CONTROLPARENT: u32 = 65536;
pub const WS_EX_STATICEDGE: u32 = 131072;
pub const WS_EX_APPWINDOW: u32 = 262144;
pub const WS_EX_OVERLAPPEDWINDOW: u32 = 768;
pub const WS_EX_PALETTEWINDOW: u32 = 392;
pub const WS_EX_LAYERED: u32 = 524288;
pub const WS_EX_NOINHERITLAYOUT: u32 = 1048576;
pub const WS_EX_NOREDIRECTIONBITMAP: u32 = 2097152;
pub const WS_EX_LAYOUTRTL: u32 = 4194304;
pub const WS_EX_COMPOSITED: u32 = 33554432;
pub const WS_EX_NOACTIVATE: u32 = 134217728;
pub const CS_VREDRAW: u32 = 1;
pub const CS_HREDRAW: u32 = 2;
pub const CS_DBLCLKS: u32 = 8;
pub const CS_OWNDC: u32 = 32;
pub const CS_CLASSDC: u32 = 64;
pub const CS_PARENTDC: u32 = 128;
pub const CS_NOCLOSE: u32 = 512;
pub const CS_SAVEBITS: u32 = 2048;
pub const CS_BYTEALIGNCLIENT: u32 = 4096;
pub const CS_BYTEALIGNWINDOW: u32 = 8192;
pub const CS_GLOBALCLASS: u32 = 16384;
pub const CS_IME: u32 = 65536;
pub const CS_DROPSHADOW: u32 = 131072;
pub const PRF_CHECKVISIBLE: u32 = 1;
pub const PRF_NONCLIENT: u32 = 2;
pub const PRF_CLIENT: u32 = 4;
pub const PRF_ERASEBKGND: u32 = 8;
pub const PRF_CHILDREN: u32 = 16;
pub const PRF_OWNED: u32 = 32;
pub const BDR_RAISEDOUTER: u32 = 1;
pub const BDR_SUNKENOUTER: u32 = 2;
pub const BDR_RAISEDINNER: u32 = 4;
pub const BDR_SUNKENINNER: u32 = 8;
pub const BDR_OUTER: u32 = 3;
pub const BDR_INNER: u32 = 12;
pub const BDR_RAISED: u32 = 5;
pub const BDR_SUNKEN: u32 = 10;
pub const EDGE_RAISED: u32 = 5;
pub const EDGE_SUNKEN: u32 = 10;
pub const EDGE_ETCHED: u32 = 6;
pub const EDGE_BUMP: u32 = 9;
pub const BF_LEFT: u32 = 1;
pub const BF_TOP: u32 = 2;
pub const BF_RIGHT: u32 = 4;
pub const BF_BOTTOM: u32 = 8;
pub const BF_TOPLEFT: u32 = 3;
pub const BF_TOPRIGHT: u32 = 6;
pub const BF_BOTTOMLEFT: u32 = 9;
pub const BF_BOTTOMRIGHT: u32 = 12;
pub const BF_RECT: u32 = 15;
pub const BF_DIAGONAL: u32 = 16;
pub const BF_DIAGONAL_ENDTOPRIGHT: u32 = 22;
pub const BF_DIAGONAL_ENDTOPLEFT: u32 = 19;
pub const BF_DIAGONAL_ENDBOTTOMLEFT: u32 = 25;
pub const BF_DIAGONAL_ENDBOTTOMRIGHT: u32 = 28;
pub const BF_MIDDLE: u32 = 2048;
pub const BF_SOFT: u32 = 4096;
pub const BF_ADJUST: u32 = 8192;
pub const BF_FLAT: u32 = 16384;
pub const BF_MONO: u32 = 32768;
pub const DFC_CAPTION: u32 = 1;
pub const DFC_MENU: u32 = 2;
pub const DFC_SCROLL: u32 = 3;
pub const DFC_BUTTON: u32 = 4;
pub const DFC_POPUPMENU: u32 = 5;
pub const DFCS_CAPTIONCLOSE: u32 = 0;
pub const DFCS_CAPTIONMIN: u32 = 1;
pub const DFCS_CAPTIONMAX: u32 = 2;
pub const DFCS_CAPTIONRESTORE: u32 = 3;
pub const DFCS_CAPTIONHELP: u32 = 4;
pub const DFCS_MENUARROW: u32 = 0;
pub const DFCS_MENUCHECK: u32 = 1;
pub const DFCS_MENUBULLET: u32 = 2;
pub const DFCS_MENUARROWRIGHT: u32 = 4;
pub const DFCS_SCROLLUP: u32 = 0;
pub const DFCS_SCROLLDOWN: u32 = 1;
pub const DFCS_SCROLLLEFT: u32 = 2;
pub const DFCS_SCROLLRIGHT: u32 = 3;
pub const DFCS_SCROLLCOMBOBOX: u32 = 5;
pub const DFCS_SCROLLSIZEGRIP: u32 = 8;
pub const DFCS_SCROLLSIZEGRIPRIGHT: u32 = 16;
pub const DFCS_BUTTONCHECK: u32 = 0;
pub const DFCS_BUTTONRADIOIMAGE: u32 = 1;
pub const DFCS_BUTTONRADIOMASK: u32 = 2;
pub const DFCS_BUTTONRADIO: u32 = 4;
pub const DFCS_BUTTON3STATE: u32 = 8;
pub const DFCS_BUTTONPUSH: u32 = 16;
pub const DFCS_INACTIVE: u32 = 256;
pub const DFCS_PUSHED: u32 = 512;
pub const DFCS_CHECKED: u32 = 1024;
pub const DFCS_TRANSPARENT: u32 = 2048;
pub const DFCS_HOT: u32 = 4096;
pub const DFCS_ADJUSTRECT: u32 = 8192;
pub const DFCS_FLAT: u32 = 16384;
pub const DFCS_MONO: u32 = 32768;
pub const DC_ACTIVE: u32 = 1;
pub const DC_SMALLCAP: u32 = 2;
pub const DC_ICON: u32 = 4;
pub const DC_TEXT: u32 = 8;
pub const DC_INBUTTON: u32 = 16;
pub const DC_GRADIENT: u32 = 32;
pub const DC_BUTTONS: u32 = 4096;
pub const IDANI_OPEN: u32 = 1;
pub const IDANI_CAPTION: u32 = 3;
pub const CF_TEXT: u32 = 1;
pub const CF_BITMAP: u32 = 2;
pub const CF_METAFILEPICT: u32 = 3;
pub const CF_SYLK: u32 = 4;
pub const CF_DIF: u32 = 5;
pub const CF_TIFF: u32 = 6;
pub const CF_OEMTEXT: u32 = 7;
pub const CF_DIB: u32 = 8;
pub const CF_PALETTE: u32 = 9;
pub const CF_PENDATA: u32 = 10;
pub const CF_RIFF: u32 = 11;
pub const CF_WAVE: u32 = 12;
pub const CF_UNICODETEXT: u32 = 13;
pub const CF_ENHMETAFILE: u32 = 14;
pub const CF_HDROP: u32 = 15;
pub const CF_LOCALE: u32 = 16;
pub const CF_DIBV5: u32 = 17;
pub const CF_MAX: u32 = 18;
pub const CF_OWNERDISPLAY: u32 = 128;
pub const CF_DSPTEXT: u32 = 129;
pub const CF_DSPBITMAP: u32 = 130;
pub const CF_DSPMETAFILEPICT: u32 = 131;
pub const CF_DSPENHMETAFILE: u32 = 142;
pub const CF_PRIVATEFIRST: u32 = 512;
pub const CF_PRIVATELAST: u32 = 767;
pub const CF_GDIOBJFIRST: u32 = 768;
pub const CF_GDIOBJLAST: u32 = 1023;
pub const FVIRTKEY: u32 = 1;
pub const FNOINVERT: u32 = 2;
pub const FSHIFT: u32 = 4;
pub const FCONTROL: u32 = 8;
pub const FALT: u32 = 16;
pub const WPF_SETMINPOSITION: u32 = 1;
pub const WPF_RESTORETOMAXIMIZED: u32 = 2;
pub const WPF_ASYNCWINDOWPLACEMENT: u32 = 4;
pub const ODT_MENU: u32 = 1;
pub const ODT_LISTBOX: u32 = 2;
pub const ODT_COMBOBOX: u32 = 3;
pub const ODT_BUTTON: u32 = 4;
pub const ODT_STATIC: u32 = 5;
pub const ODA_DRAWENTIRE: u32 = 1;
pub const ODA_SELECT: u32 = 2;
pub const ODA_FOCUS: u32 = 4;
pub const ODS_SELECTED: u32 = 1;
pub const ODS_GRAYED: u32 = 2;
pub const ODS_DISABLED: u32 = 4;
pub const ODS_CHECKED: u32 = 8;
pub const ODS_FOCUS: u32 = 16;
pub const ODS_DEFAULT: u32 = 32;
pub const ODS_COMBOBOXEDIT: u32 = 4096;
pub const ODS_HOTLIGHT: u32 = 64;
pub const ODS_INACTIVE: u32 = 128;
pub const ODS_NOACCEL: u32 = 256;
pub const ODS_NOFOCUSRECT: u32 = 512;
pub const PM_NOREMOVE: u32 = 0;
pub const PM_REMOVE: u32 = 1;
pub const PM_NOYIELD: u32 = 2;
pub const MOD_ALT: u32 = 1;
pub const MOD_CONTROL: u32 = 2;
pub const MOD_SHIFT: u32 = 4;
pub const MOD_WIN: u32 = 8;
pub const MOD_NOREPEAT: u32 = 16384;
pub const IDHOT_SNAPWINDOW: i32 = -1;
pub const IDHOT_SNAPDESKTOP: i32 = -2;
pub const ENDSESSION_CLOSEAPP: u32 = 1;
pub const ENDSESSION_CRITICAL: u32 = 1073741824;
pub const ENDSESSION_LOGOFF: u32 = 2147483648;
pub const EWX_LOGOFF: u32 = 0;
pub const EWX_SHUTDOWN: u32 = 1;
pub const EWX_REBOOT: u32 = 2;
pub const EWX_FORCE: u32 = 4;
pub const EWX_POWEROFF: u32 = 8;
pub const EWX_FORCEIFHUNG: u32 = 16;
pub const EWX_QUICKRESOLVE: u32 = 32;
pub const EWX_RESTARTAPPS: u32 = 64;
pub const EWX_HYBRID_SHUTDOWN: u32 = 4194304;
pub const EWX_BOOTOPTIONS: u32 = 16777216;
pub const EWX_ARSO: u32 = 67108864;
pub const EWX_CHECK_SAFE_FOR_SERVER: u32 = 134217728;
pub const EWX_SYSTEM_INITIATED: u32 = 268435456;
pub const BSM_ALLCOMPONENTS: u32 = 0;
pub const BSM_VXDS: u32 = 1;
pub const BSM_NETDRIVER: u32 = 2;
pub const BSM_INSTALLABLEDRIVERS: u32 = 4;
pub const BSM_APPLICATIONS: u32 = 8;
pub const BSM_ALLDESKTOPS: u32 = 16;
pub const BSF_QUERY: u32 = 1;
pub const BSF_IGNORECURRENTTASK: u32 = 2;
pub const BSF_FLUSHDISK: u32 = 4;
pub const BSF_NOHANG: u32 = 8;
pub const BSF_POSTMESSAGE: u32 = 16;
pub const BSF_FORCEIFHUNG: u32 = 32;
pub const BSF_NOTIMEOUTIFNOTHUNG: u32 = 64;
pub const BSF_ALLOWSFW: u32 = 128;
pub const BSF_SENDNOTIFYMESSAGE: u32 = 256;
pub const BSF_RETURNHDESK: u32 = 512;
pub const BSF_LUID: u32 = 1024;
pub const BROADCAST_QUERY_DENY: u32 = 1112363332;
pub const DEVICE_NOTIFY_WINDOW_HANDLE: u32 = 0;
pub const DEVICE_NOTIFY_SERVICE_HANDLE: u32 = 1;
pub const DEVICE_NOTIFY_ALL_INTERFACE_CLASSES: u32 = 4;
pub const ISMEX_NOSEND: u32 = 0;
pub const ISMEX_SEND: u32 = 1;
pub const ISMEX_NOTIFY: u32 = 2;
pub const ISMEX_CALLBACK: u32 = 4;
pub const ISMEX_REPLIED: u32 = 8;
pub const PW_CLIENTONLY: u32 = 1;
pub const PW_RENDERFULLCONTENT: u32 = 2;
pub const LWA_COLORKEY: u32 = 1;
pub const LWA_ALPHA: u32 = 2;
pub const ULW_COLORKEY: u32 = 1;
pub const ULW_ALPHA: u32 = 2;
pub const ULW_OPAQUE: u32 = 4;
pub const ULW_EX_NORESIZE: u32 = 8;
pub const FLASHW_STOP: u32 = 0;
pub const FLASHW_CAPTION: u32 = 1;
pub const FLASHW_TRAY: u32 = 2;
pub const FLASHW_ALL: u32 = 3;
pub const FLASHW_TIMER: u32 = 4;
pub const FLASHW_TIMERNOFG: u32 = 12;
pub const WDA_NONE: u32 = 0;
pub const WDA_MONITOR: u32 = 1;
pub const WDA_EXCLUDEFROMCAPTURE: u32 = 17;
pub const SWP_NOSIZE: u32 = 1;
pub const SWP_NOMOVE: u32 = 2;
pub const SWP_NOZORDER: u32 = 4;
pub const SWP_NOREDRAW: u32 = 8;
pub const SWP_NOACTIVATE: u32 = 16;
pub const SWP_FRAMECHANGED: u32 = 32;
pub const SWP_SHOWWINDOW: u32 = 64;
pub const SWP_HIDEWINDOW: u32 = 128;
pub const SWP_NOCOPYBITS: u32 = 256;
pub const SWP_NOOWNERZORDER: u32 = 512;
pub const SWP_NOSENDCHANGING: u32 = 1024;
pub const SWP_DRAWFRAME: u32 = 32;
pub const SWP_NOREPOSITION: u32 = 512;
pub const SWP_DEFERERASE: u32 = 8192;
pub const SWP_ASYNCWINDOWPOS: u32 = 16384;
pub const DLGWINDOWEXTRA: u32 = 30;
pub const KEYEVENTF_EXTENDEDKEY: u32 = 1;
pub const KEYEVENTF_KEYUP: u32 = 2;
pub const KEYEVENTF_UNICODE: u32 = 4;
pub const KEYEVENTF_SCANCODE: u32 = 8;
pub const MOUSEEVENTF_MOVE: u32 = 1;
pub const MOUSEEVENTF_LEFTDOWN: u32 = 2;
pub const MOUSEEVENTF_LEFTUP: u32 = 4;
pub const MOUSEEVENTF_RIGHTDOWN: u32 = 8;
pub const MOUSEEVENTF_RIGHTUP: u32 = 16;
pub const MOUSEEVENTF_MIDDLEDOWN: u32 = 32;
pub const MOUSEEVENTF_MIDDLEUP: u32 = 64;
pub const MOUSEEVENTF_XDOWN: u32 = 128;
pub const MOUSEEVENTF_XUP: u32 = 256;
pub const MOUSEEVENTF_WHEEL: u32 = 2048;
pub const MOUSEEVENTF_HWHEEL: u32 = 4096;
pub const MOUSEEVENTF_MOVE_NOCOALESCE: u32 = 8192;
pub const MOUSEEVENTF_VIRTUALDESK: u32 = 16384;
pub const MOUSEEVENTF_ABSOLUTE: u32 = 32768;
pub const INPUT_MOUSE: u32 = 0;
pub const INPUT_KEYBOARD: u32 = 1;
pub const INPUT_HARDWARE: u32 = 2;
pub const TOUCHEVENTF_MOVE: u32 = 1;
pub const TOUCHEVENTF_DOWN: u32 = 2;
pub const TOUCHEVENTF_UP: u32 = 4;
pub const TOUCHEVENTF_INRANGE: u32 = 8;
pub const TOUCHEVENTF_PRIMARY: u32 = 16;
pub const TOUCHEVENTF_NOCOALESCE: u32 = 32;
pub const TOUCHEVENTF_PEN: u32 = 64;
pub const TOUCHEVENTF_PALM: u32 = 128;
pub const TOUCHINPUTMASKF_TIMEFROMSYSTEM: u32 = 1;
pub const TOUCHINPUTMASKF_EXTRAINFO: u32 = 2;
pub const TOUCHINPUTMASKF_CONTACTAREA: u32 = 4;
pub const TWF_FINETOUCH: u32 = 1;
pub const TWF_WANTPALM: u32 = 2;
pub const POINTER_FLAG_NONE: u32 = 0;
pub const POINTER_FLAG_NEW: u32 = 1;
pub const POINTER_FLAG_INRANGE: u32 = 2;
pub const POINTER_FLAG_INCONTACT: u32 = 4;
pub const POINTER_FLAG_FIRSTBUTTON: u32 = 16;
pub const POINTER_FLAG_SECONDBUTTON: u32 = 32;
pub const POINTER_FLAG_THIRDBUTTON: u32 = 64;
pub const POINTER_FLAG_FOURTHBUTTON: u32 = 128;
pub const POINTER_FLAG_FIFTHBUTTON: u32 = 256;
pub const POINTER_FLAG_PRIMARY: u32 = 8192;
pub const POINTER_FLAG_CONFIDENCE: u32 = 16384;
pub const POINTER_FLAG_CANCELED: u32 = 32768;
pub const POINTER_FLAG_DOWN: u32 = 65536;
pub const POINTER_FLAG_UPDATE: u32 = 131072;
pub const POINTER_FLAG_UP: u32 = 262144;
pub const POINTER_FLAG_WHEEL: u32 = 524288;
pub const POINTER_FLAG_HWHEEL: u32 = 1048576;
pub const POINTER_FLAG_CAPTURECHANGED: u32 = 2097152;
pub const POINTER_FLAG_HASTRANSFORM: u32 = 4194304;
pub const POINTER_MOD_SHIFT: u32 = 4;
pub const POINTER_MOD_CTRL: u32 = 8;
pub const TOUCH_FLAG_NONE: u32 = 0;
pub const TOUCH_MASK_NONE: u32 = 0;
pub const TOUCH_MASK_CONTACTAREA: u32 = 1;
pub const TOUCH_MASK_ORIENTATION: u32 = 2;
pub const TOUCH_MASK_PRESSURE: u32 = 4;
pub const PEN_FLAG_NONE: u32 = 0;
pub const PEN_FLAG_BARREL: u32 = 1;
pub const PEN_FLAG_INVERTED: u32 = 2;
pub const PEN_FLAG_ERASER: u32 = 4;
pub const PEN_MASK_NONE: u32 = 0;
pub const PEN_MASK_PRESSURE: u32 = 1;
pub const PEN_MASK_ROTATION: u32 = 2;
pub const PEN_MASK_TILT_X: u32 = 4;
pub const PEN_MASK_TILT_Y: u32 = 8;
pub const POINTER_MESSAGE_FLAG_NEW: u32 = 1;
pub const POINTER_MESSAGE_FLAG_INRANGE: u32 = 2;
pub const POINTER_MESSAGE_FLAG_INCONTACT: u32 = 4;
pub const POINTER_MESSAGE_FLAG_FIRSTBUTTON: u32 = 16;
pub const POINTER_MESSAGE_FLAG_SECONDBUTTON: u32 = 32;
pub const POINTER_MESSAGE_FLAG_THIRDBUTTON: u32 = 64;
pub const POINTER_MESSAGE_FLAG_FOURTHBUTTON: u32 = 128;
pub const POINTER_MESSAGE_FLAG_FIFTHBUTTON: u32 = 256;
pub const POINTER_MESSAGE_FLAG_PRIMARY: u32 = 8192;
pub const POINTER_MESSAGE_FLAG_CONFIDENCE: u32 = 16384;
pub const POINTER_MESSAGE_FLAG_CANCELED: u32 = 32768;
pub const PA_ACTIVATE: u32 = 1;
pub const PA_NOACTIVATE: u32 = 3;
pub const MAX_TOUCH_COUNT: u32 = 256;
pub const TOUCH_FEEDBACK_DEFAULT: u32 = 1;
pub const TOUCH_FEEDBACK_INDIRECT: u32 = 2;
pub const TOUCH_FEEDBACK_NONE: u32 = 3;
pub const TOUCH_HIT_TESTING_DEFAULT: u32 = 0;
pub const TOUCH_HIT_TESTING_CLIENT: u32 = 1;
pub const TOUCH_HIT_TESTING_NONE: u32 = 2;
pub const TOUCH_HIT_TESTING_PROXIMITY_CLOSEST: u32 = 0;
pub const TOUCH_HIT_TESTING_PROXIMITY_FARTHEST: u32 = 4095;
pub const GWFS_INCLUDE_ANCESTORS: u32 = 1;
pub const MAPVK_VK_TO_VSC: u32 = 0;
pub const MAPVK_VSC_TO_VK: u32 = 1;
pub const MAPVK_VK_TO_CHAR: u32 = 2;
pub const MAPVK_VSC_TO_VK_EX: u32 = 3;
pub const MAPVK_VK_TO_VSC_EX: u32 = 4;
pub const MWMO_WAITALL: u32 = 1;
pub const MWMO_ALERTABLE: u32 = 2;
pub const MWMO_INPUTAVAILABLE: u32 = 4;
pub const QS_KEY: u32 = 1;
pub const QS_MOUSEMOVE: u32 = 2;
pub const QS_MOUSEBUTTON: u32 = 4;
pub const QS_POSTMESSAGE: u32 = 8;
pub const QS_TIMER: u32 = 16;
pub const QS_PAINT: u32 = 32;
pub const QS_SENDMESSAGE: u32 = 64;
pub const QS_HOTKEY: u32 = 128;
pub const QS_ALLPOSTMESSAGE: u32 = 256;
pub const QS_RAWINPUT: u32 = 1024;
pub const QS_TOUCH: u32 = 2048;
pub const QS_POINTER: u32 = 4096;
pub const QS_MOUSE: u32 = 6;
pub const QS_INPUT: u32 = 7175;
pub const QS_ALLEVENTS: u32 = 7359;
pub const QS_ALLINPUT: u32 = 7423;
pub const USER_TIMER_MAXIMUM: u32 = 2147483647;
pub const USER_TIMER_MINIMUM: u32 = 10;
pub const TIMERV_DEFAULT_COALESCING: u32 = 0;
pub const TIMERV_NO_COALESCING: u32 = 4294967295;
pub const TIMERV_COALESCING_MIN: u32 = 1;
pub const TIMERV_COALESCING_MAX: u32 = 2147483637;
pub const SM_CXSCREEN: u32 = 0;
pub const SM_CYSCREEN: u32 = 1;
pub const SM_CXVSCROLL: u32 = 2;
pub const SM_CYHSCROLL: u32 = 3;
pub const SM_CYCAPTION: u32 = 4;
pub const SM_CXBORDER: u32 = 5;
pub const SM_CYBORDER: u32 = 6;
pub const SM_CXDLGFRAME: u32 = 7;
pub const SM_CYDLGFRAME: u32 = 8;
pub const SM_CYVTHUMB: u32 = 9;
pub const SM_CXHTHUMB: u32 = 10;
pub const SM_CXICON: u32 = 11;
pub const SM_CYICON: u32 = 12;
pub const SM_CXCURSOR: u32 = 13;
pub const SM_CYCURSOR: u32 = 14;
pub const SM_CYMENU: u32 = 15;
pub const SM_CXFULLSCREEN: u32 = 16;
pub const SM_CYFULLSCREEN: u32 = 17;
pub const SM_CYKANJIWINDOW: u32 = 18;
pub const SM_MOUSEPRESENT: u32 = 19;
pub const SM_CYVSCROLL: u32 = 20;
pub const SM_CXHSCROLL: u32 = 21;
pub const SM_DEBUG: u32 = 22;
pub const SM_SWAPBUTTON: u32 = 23;
pub const SM_RESERVED1: u32 = 24;
pub const SM_RESERVED2: u32 = 25;
pub const SM_RESERVED3: u32 = 26;
pub const SM_RESERVED4: u32 = 27;
pub const SM_CXMIN: u32 = 28;
pub const SM_CYMIN: u32 = 29;
pub const SM_CXSIZE: u32 = 30;
pub const SM_CYSIZE: u32 = 31;
pub const SM_CXFRAME: u32 = 32;
pub const SM_CYFRAME: u32 = 33;
pub const SM_CXMINTRACK: u32 = 34;
pub const SM_CYMINTRACK: u32 = 35;
pub const SM_CXDOUBLECLK: u32 = 36;
pub const SM_CYDOUBLECLK: u32 = 37;
pub const SM_CXICONSPACING: u32 = 38;
pub const SM_CYICONSPACING: u32 = 39;
pub const SM_MENUDROPALIGNMENT: u32 = 40;
pub const SM_PENWINDOWS: u32 = 41;
pub const SM_DBCSENABLED: u32 = 42;
pub const SM_CMOUSEBUTTONS: u32 = 43;
pub const SM_CXFIXEDFRAME: u32 = 7;
pub const SM_CYFIXEDFRAME: u32 = 8;
pub const SM_CXSIZEFRAME: u32 = 32;
pub const SM_CYSIZEFRAME: u32 = 33;
pub const SM_SECURE: u32 = 44;
pub const SM_CXEDGE: u32 = 45;
pub const SM_CYEDGE: u32 = 46;
pub const SM_CXMINSPACING: u32 = 47;
pub const SM_CYMINSPACING: u32 = 48;
pub const SM_CXSMICON: u32 = 49;
pub const SM_CYSMICON: u32 = 50;
pub const SM_CYSMCAPTION: u32 = 51;
pub const SM_CXSMSIZE: u32 = 52;
pub const SM_CYSMSIZE: u32 = 53;
pub const SM_CXMENUSIZE: u32 = 54;
pub const SM_CYMENUSIZE: u32 = 55;
pub const SM_ARRANGE: u32 = 56;
pub const SM_CXMINIMIZED: u32 = 57;
pub const SM_CYMINIMIZED: u32 = 58;
pub const SM_CXMAXTRACK: u32 = 59;
pub const SM_CYMAXTRACK: u32 = 60;
pub const SM_CXMAXIMIZED: u32 = 61;
pub const SM_CYMAXIMIZED: u32 = 62;
pub const SM_NETWORK: u32 = 63;
pub const SM_CLEANBOOT: u32 = 67;
pub const SM_CXDRAG: u32 = 68;
pub const SM_CYDRAG: u32 = 69;
pub const SM_SHOWSOUNDS: u32 = 70;
pub const SM_CXMENUCHECK: u32 = 71;
pub const SM_CYMENUCHECK: u32 = 72;
pub const SM_SLOWMACHINE: u32 = 73;
pub const SM_MIDEASTENABLED: u32 = 74;
pub const SM_MOUSEWHEELPRESENT: u32 = 75;
pub const SM_XVIRTUALSCREEN: u32 = 76;
pub const SM_YVIRTUALSCREEN: u32 = 77;
pub const SM_CXVIRTUALSCREEN: u32 = 78;
pub const SM_CYVIRTUALSCREEN: u32 = 79;
pub const SM_CMONITORS: u32 = 80;
pub const SM_SAMEDISPLAYFORMAT: u32 = 81;
pub const SM_IMMENABLED: u32 = 82;
pub const SM_CXFOCUSBORDER: u32 = 83;
pub const SM_CYFOCUSBORDER: u32 = 84;
pub const SM_TABLETPC: u32 = 86;
pub const SM_MEDIACENTER: u32 = 87;
pub const SM_STARTER: u32 = 88;
pub const SM_SERVERR2: u32 = 89;
pub const SM_MOUSEHORIZONTALWHEELPRESENT: u32 = 91;
pub const SM_CXPADDEDBORDER: u32 = 92;
pub const SM_DIGITIZER: u32 = 94;
pub const SM_MAXIMUMTOUCHES: u32 = 95;
pub const SM_CMETRICS: u32 = 97;
pub const SM_REMOTESESSION: u32 = 4096;
pub const SM_SHUTTINGDOWN: u32 = 8192;
pub const SM_REMOTECONTROL: u32 = 8193;
pub const SM_CARETBLINKINGENABLED: u32 = 8194;
pub const SM_CONVERTIBLESLATEMODE: u32 = 8195;
pub const SM_SYSTEMDOCKED: u32 = 8196;
pub const PMB_ACTIVE: u32 = 1;
pub const MNC_IGNORE: u32 = 0;
pub const MNC_CLOSE: u32 = 1;
pub const MNC_EXECUTE: u32 = 2;
pub const MNC_SELECT: u32 = 3;
pub const MNS_NOCHECK: u32 = 2147483648;
pub const MNS_MODELESS: u32 = 1073741824;
pub const MNS_DRAGDROP: u32 = 536870912;
pub const MNS_AUTODISMISS: u32 = 268435456;
pub const MNS_NOTIFYBYPOS: u32 = 134217728;
pub const MNS_CHECKORBMP: u32 = 67108864;
pub const MIM_MAXHEIGHT: u32 = 1;
pub const MIM_BACKGROUND: u32 = 2;
pub const MIM_HELPID: u32 = 4;
pub const MIM_MENUDATA: u32 = 8;
pub const MIM_STYLE: u32 = 16;
pub const MIM_APPLYTOSUBMENUS: u32 = 2147483648;
pub const MND_CONTINUE: u32 = 0;
pub const MND_ENDMENU: u32 = 1;
pub const MNGOF_TOPGAP: u32 = 1;
pub const MNGOF_BOTTOMGAP: u32 = 2;
pub const MNGO_NOINTERFACE: u32 = 0;
pub const MNGO_NOERROR: u32 = 1;
pub const MIIM_STATE: u32 = 1;
pub const MIIM_ID: u32 = 2;
pub const MIIM_SUBMENU: u32 = 4;
pub const MIIM_CHECKMARKS: u32 = 8;
pub const MIIM_TYPE: u32 = 16;
pub const MIIM_DATA: u32 = 32;
pub const MIIM_STRING: u32 = 64;
pub const MIIM_BITMAP: u32 = 128;
pub const MIIM_FTYPE: u32 = 256;
pub const GMDI_USEDISABLED: u32 = 1;
pub const GMDI_GOINTOPOPUPS: u32 = 2;
pub const TPM_LEFTBUTTON: u32 = 0;
pub const TPM_RIGHTBUTTON: u32 = 2;
pub const TPM_LEFTALIGN: u32 = 0;
pub const TPM_CENTERALIGN: u32 = 4;
pub const TPM_RIGHTALIGN: u32 = 8;
pub const TPM_TOPALIGN: u32 = 0;
pub const TPM_VCENTERALIGN: u32 = 16;
pub const TPM_BOTTOMALIGN: u32 = 32;
pub const TPM_HORIZONTAL: u32 = 0;
pub const TPM_VERTICAL: u32 = 64;
pub const TPM_NONOTIFY: u32 = 128;
pub const TPM_RETURNCMD: u32 = 256;
pub const TPM_RECURSE: u32 = 1;
pub const TPM_HORPOSANIMATION: u32 = 1024;
pub const TPM_HORNEGANIMATION: u32 = 2048;
pub const TPM_VERPOSANIMATION: u32 = 4096;
pub const TPM_VERNEGANIMATION: u32 = 8192;
pub const TPM_NOANIMATION: u32 = 16384;
pub const TPM_LAYOUTRTL: u32 = 32768;
pub const TPM_WORKAREA: u32 = 65536;
pub const DOF_EXECUTABLE: u32 = 32769;
pub const DOF_DOCUMENT: u32 = 32770;
pub const DOF_DIRECTORY: u32 = 32771;
pub const DOF_MULTIPLE: u32 = 32772;
pub const DOF_PROGMAN: u32 = 1;
pub const DOF_SHELLDATA: u32 = 2;
pub const DO_DROPFILE: u32 = 1162627398;
pub const DO_PRINTFILE: u32 = 1414419024;
pub const DT_TOP: u32 = 0;
pub const DT_LEFT: u32 = 0;
pub const DT_CENTER: u32 = 1;
pub const DT_RIGHT: u32 = 2;
pub const DT_VCENTER: u32 = 4;
pub const DT_BOTTOM: u32 = 8;
pub const DT_WORDBREAK: u32 = 16;
pub const DT_SINGLELINE: u32 = 32;
pub const DT_EXPANDTABS: u32 = 64;
pub const DT_TABSTOP: u32 = 128;
pub const DT_NOCLIP: u32 = 256;
pub const DT_EXTERNALLEADING: u32 = 512;
pub const DT_CALCRECT: u32 = 1024;
pub const DT_NOPREFIX: u32 = 2048;
pub const DT_INTERNAL: u32 = 4096;
pub const DT_EDITCONTROL: u32 = 8192;
pub const DT_PATH_ELLIPSIS: u32 = 16384;
pub const DT_END_ELLIPSIS: u32 = 32768;
pub const DT_MODIFYSTRING: u32 = 65536;
pub const DT_RTLREADING: u32 = 131072;
pub const DT_WORD_ELLIPSIS: u32 = 262144;
pub const DT_NOFULLWIDTHCHARBREAK: u32 = 524288;
pub const DT_HIDEPREFIX: u32 = 1048576;
pub const DT_PREFIXONLY: u32 = 2097152;
pub const DST_COMPLEX: u32 = 0;
pub const DST_TEXT: u32 = 1;
pub const DST_PREFIXTEXT: u32 = 2;
pub const DST_ICON: u32 = 3;
pub const DST_BITMAP: u32 = 4;
pub const DSS_NORMAL: u32 = 0;
pub const DSS_UNION: u32 = 16;
pub const DSS_DISABLED: u32 = 32;
pub const DSS_MONO: u32 = 128;
pub const DSS_HIDEPREFIX: u32 = 512;
pub const DSS_PREFIXONLY: u32 = 1024;
pub const DSS_RIGHT: u32 = 32768;
pub const LSFW_LOCK: u32 = 1;
pub const LSFW_UNLOCK: u32 = 2;
pub const DCX_WINDOW: u32 = 1;
pub const DCX_CACHE: u32 = 2;
pub const DCX_NORESETATTRS: u32 = 4;
pub const DCX_CLIPCHILDREN: u32 = 8;
pub const DCX_CLIPSIBLINGS: u32 = 16;
pub const DCX_PARENTCLIP: u32 = 32;
pub const DCX_EXCLUDERGN: u32 = 64;
pub const DCX_INTERSECTRGN: u32 = 128;
pub const DCX_EXCLUDEUPDATE: u32 = 256;
pub const DCX_INTERSECTUPDATE: u32 = 512;
pub const DCX_LOCKWINDOWUPDATE: u32 = 1024;
pub const DCX_VALIDATE: u32 = 2097152;
pub const RDW_INVALIDATE: u32 = 1;
pub const RDW_INTERNALPAINT: u32 = 2;
pub const RDW_ERASE: u32 = 4;
pub const RDW_VALIDATE: u32 = 8;
pub const RDW_NOINTERNALPAINT: u32 = 16;
pub const RDW_NOERASE: u32 = 32;
pub const RDW_NOCHILDREN: u32 = 64;
pub const RDW_ALLCHILDREN: u32 = 128;
pub const RDW_UPDATENOW: u32 = 256;
pub const RDW_ERASENOW: u32 = 512;
pub const RDW_FRAME: u32 = 1024;
pub const RDW_NOFRAME: u32 = 2048;
pub const SW_SCROLLCHILDREN: u32 = 1;
pub const SW_INVALIDATE: u32 = 2;
pub const SW_ERASE: u32 = 4;
pub const SW_SMOOTHSCROLL: u32 = 16;
pub const ESB_ENABLE_BOTH: u32 = 0;
pub const ESB_DISABLE_BOTH: u32 = 3;
pub const ESB_DISABLE_LEFT: u32 = 1;
pub const ESB_DISABLE_RIGHT: u32 = 2;
pub const ESB_DISABLE_UP: u32 = 1;
pub const ESB_DISABLE_DOWN: u32 = 2;
pub const ESB_DISABLE_LTUP: u32 = 1;
pub const ESB_DISABLE_RTDN: u32 = 2;
pub const HELPINFO_WINDOW: u32 = 1;
pub const HELPINFO_MENUITEM: u32 = 2;
pub const MB_OK: u32 = 0;
pub const MB_OKCANCEL: u32 = 1;
pub const MB_ABORTRETRYIGNORE: u32 = 2;
pub const MB_YESNOCANCEL: u32 = 3;
pub const MB_YESNO: u32 = 4;
pub const MB_RETRYCANCEL: u32 = 5;
pub const MB_CANCELTRYCONTINUE: u32 = 6;
pub const MB_ICONHAND: u32 = 16;
pub const MB_ICONQUESTION: u32 = 32;
pub const MB_ICONEXCLAMATION: u32 = 48;
pub const MB_ICONASTERISK: u32 = 64;
pub const MB_USERICON: u32 = 128;
pub const MB_ICONWARNING: u32 = 48;
pub const MB_ICONERROR: u32 = 16;
pub const MB_ICONINFORMATION: u32 = 64;
pub const MB_ICONSTOP: u32 = 16;
pub const MB_DEFBUTTON1: u32 = 0;
pub const MB_DEFBUTTON2: u32 = 256;
pub const MB_DEFBUTTON3: u32 = 512;
pub const MB_DEFBUTTON4: u32 = 768;
pub const MB_APPLMODAL: u32 = 0;
pub const MB_SYSTEMMODAL: u32 = 4096;
pub const MB_TASKMODAL: u32 = 8192;
pub const MB_HELP: u32 = 16384;
pub const MB_NOFOCUS: u32 = 32768;
pub const MB_SETFOREGROUND: u32 = 65536;
pub const MB_DEFAULT_DESKTOP_ONLY: u32 = 131072;
pub const MB_TOPMOST: u32 = 262144;
pub const MB_RIGHT: u32 = 524288;
pub const MB_RTLREADING: u32 = 1048576;
pub const MB_SERVICE_NOTIFICATION: u32 = 2097152;
pub const MB_SERVICE_NOTIFICATION_NT3X: u32 = 262144;
pub const MB_TYPEMASK: u32 = 15;
pub const MB_ICONMASK: u32 = 240;
pub const MB_DEFMASK: u32 = 3840;
pub const MB_MODEMASK: u32 = 12288;
pub const MB_MISCMASK: u32 = 49152;
pub const CWP_ALL: u32 = 0;
pub const CWP_SKIPINVISIBLE: u32 = 1;
pub const CWP_SKIPDISABLED: u32 = 2;
pub const CWP_SKIPTRANSPARENT: u32 = 4;
pub const CTLCOLOR_MSGBOX: u32 = 0;
pub const CTLCOLOR_EDIT: u32 = 1;
pub const CTLCOLOR_LISTBOX: u32 = 2;
pub const CTLCOLOR_BTN: u32 = 3;
pub const CTLCOLOR_DLG: u32 = 4;
pub const CTLCOLOR_SCROLLBAR: u32 = 5;
pub const CTLCOLOR_STATIC: u32 = 6;
pub const CTLCOLOR_MAX: u32 = 7;
pub const COLOR_SCROLLBAR: u32 = 0;
pub const COLOR_BACKGROUND: u32 = 1;
pub const COLOR_ACTIVECAPTION: u32 = 2;
pub const COLOR_INACTIVECAPTION: u32 = 3;
pub const COLOR_MENU: u32 = 4;
pub const COLOR_WINDOW: u32 = 5;
pub const COLOR_WINDOWFRAME: u32 = 6;
pub const COLOR_MENUTEXT: u32 = 7;
pub const COLOR_WINDOWTEXT: u32 = 8;
pub const COLOR_CAPTIONTEXT: u32 = 9;
pub const COLOR_ACTIVEBORDER: u32 = 10;
pub const COLOR_INACTIVEBORDER: u32 = 11;
pub const COLOR_APPWORKSPACE: u32 = 12;
pub const COLOR_HIGHLIGHT: u32 = 13;
pub const COLOR_HIGHLIGHTTEXT: u32 = 14;
pub const COLOR_BTNFACE: u32 = 15;
pub const COLOR_BTNSHADOW: u32 = 16;
pub const COLOR_GRAYTEXT: u32 = 17;
pub const COLOR_BTNTEXT: u32 = 18;
pub const COLOR_INACTIVECAPTIONTEXT: u32 = 19;
pub const COLOR_BTNHIGHLIGHT: u32 = 20;
pub const COLOR_3DDKSHADOW: u32 = 21;
pub const COLOR_3DLIGHT: u32 = 22;
pub const COLOR_INFOTEXT: u32 = 23;
pub const COLOR_INFOBK: u32 = 24;
pub const COLOR_HOTLIGHT: u32 = 26;
pub const COLOR_GRADIENTACTIVECAPTION: u32 = 27;
pub const COLOR_GRADIENTINACTIVECAPTION: u32 = 28;
pub const COLOR_MENUHILIGHT: u32 = 29;
pub const COLOR_MENUBAR: u32 = 30;
pub const COLOR_DESKTOP: u32 = 1;
pub const COLOR_3DFACE: u32 = 15;
pub const COLOR_3DSHADOW: u32 = 16;
pub const COLOR_3DHIGHLIGHT: u32 = 20;
pub const COLOR_3DHILIGHT: u32 = 20;
pub const COLOR_BTNHILIGHT: u32 = 20;
pub const GW_HWNDFIRST: u32 = 0;
pub const GW_HWNDLAST: u32 = 1;
pub const GW_HWNDNEXT: u32 = 2;
pub const GW_HWNDPREV: u32 = 3;
pub const GW_OWNER: u32 = 4;
pub const GW_CHILD: u32 = 5;
pub const GW_ENABLEDPOPUP: u32 = 6;
pub const GW_MAX: u32 = 6;
pub const MF_INSERT: u32 = 0;
pub const MF_CHANGE: u32 = 128;
pub const MF_APPEND: u32 = 256;
pub const MF_DELETE: u32 = 512;
pub const MF_REMOVE: u32 = 4096;
pub const MF_BYCOMMAND: u32 = 0;
pub const MF_BYPOSITION: u32 = 1024;
pub const MF_SEPARATOR: u32 = 2048;
pub const MF_ENABLED: u32 = 0;
pub const MF_GRAYED: u32 = 1;
pub const MF_DISABLED: u32 = 2;
pub const MF_UNCHECKED: u32 = 0;
pub const MF_CHECKED: u32 = 8;
pub const MF_USECHECKBITMAPS: u32 = 512;
pub const MF_STRING: u32 = 0;
pub const MF_BITMAP: u32 = 4;
pub const MF_OWNERDRAW: u32 = 256;
pub const MF_POPUP: u32 = 16;
pub const MF_MENUBARBREAK: u32 = 32;
pub const MF_MENUBREAK: u32 = 64;
pub const MF_UNHILITE: u32 = 0;
pub const MF_HILITE: u32 = 128;
pub const MF_DEFAULT: u32 = 4096;
pub const MF_SYSMENU: u32 = 8192;
pub const MF_HELP: u32 = 16384;
pub const MF_RIGHTJUSTIFY: u32 = 16384;
pub const MF_MOUSESELECT: u32 = 32768;
pub const MF_END: u32 = 128;
pub const MFT_STRING: u32 = 0;
pub const MFT_BITMAP: u32 = 4;
pub const MFT_MENUBARBREAK: u32 = 32;
pub const MFT_MENUBREAK: u32 = 64;
pub const MFT_OWNERDRAW: u32 = 256;
pub const MFT_RADIOCHECK: u32 = 512;
pub const MFT_SEPARATOR: u32 = 2048;
pub const MFT_RIGHTORDER: u32 = 8192;
pub const MFT_RIGHTJUSTIFY: u32 = 16384;
pub const MFS_GRAYED: u32 = 3;
pub const MFS_DISABLED: u32 = 3;
pub const MFS_CHECKED: u32 = 8;
pub const MFS_HILITE: u32 = 128;
pub const MFS_ENABLED: u32 = 0;
pub const MFS_UNCHECKED: u32 = 0;
pub const MFS_UNHILITE: u32 = 0;
pub const MFS_DEFAULT: u32 = 4096;
pub const SC_SIZE: u32 = 61440;
pub const SC_MOVE: u32 = 61456;
pub const SC_MINIMIZE: u32 = 61472;
pub const SC_MAXIMIZE: u32 = 61488;
pub const SC_NEXTWINDOW: u32 = 61504;
pub const SC_PREVWINDOW: u32 = 61520;
pub const SC_CLOSE: u32 = 61536;
pub const SC_VSCROLL: u32 = 61552;
pub const SC_HSCROLL: u32 = 61568;
pub const SC_MOUSEMENU: u32 = 61584;
pub const SC_KEYMENU: u32 = 61696;
pub const SC_ARRANGE: u32 = 61712;
pub const SC_RESTORE: u32 = 61728;
pub const SC_TASKLIST: u32 = 61744;
pub const SC_SCREENSAVE: u32 = 61760;
pub const SC_HOTKEY: u32 = 61776;
pub const SC_DEFAULT: u32 = 61792;
pub const SC_MONITORPOWER: u32 = 61808;
pub const SC_CONTEXTHELP: u32 = 61824;
pub const SC_SEPARATOR: u32 = 61455;
pub const SCF_ISSECURE: u32 = 1;
pub const SC_ICON: u32 = 61472;
pub const SC_ZOOM: u32 = 61488;
pub const CURSOR_CREATION_SCALING_NONE: u32 = 1;
pub const CURSOR_CREATION_SCALING_DEFAULT: u32 = 2;
pub const IMAGE_BITMAP: u32 = 0;
pub const IMAGE_ICON: u32 = 1;
pub const IMAGE_CURSOR: u32 = 2;
pub const IMAGE_ENHMETAFILE: u32 = 3;
pub const LR_DEFAULTCOLOR: u32 = 0;
pub const LR_MONOCHROME: u32 = 1;
pub const LR_COLOR: u32 = 2;
pub const LR_COPYRETURNORG: u32 = 4;
pub const LR_COPYDELETEORG: u32 = 8;
pub const LR_LOADFROMFILE: u32 = 16;
pub const LR_LOADTRANSPARENT: u32 = 32;
pub const LR_DEFAULTSIZE: u32 = 64;
pub const LR_VGACOLOR: u32 = 128;
pub const LR_LOADMAP3DCOLORS: u32 = 4096;
pub const LR_CREATEDIBSECTION: u32 = 8192;
pub const LR_COPYFROMRESOURCE: u32 = 16384;
pub const LR_SHARED: u32 = 32768;
pub const DI_MASK: u32 = 1;
pub const DI_IMAGE: u32 = 2;
pub const DI_NORMAL: u32 = 3;
pub const DI_COMPAT: u32 = 4;
pub const DI_DEFAULTSIZE: u32 = 8;
pub const DI_NOMIRROR: u32 = 16;
pub const RES_ICON: u32 = 1;
pub const RES_CURSOR: u32 = 2;
pub const ORD_LANGDRIVER: u32 = 1;
pub const IDOK: u32 = 1;
pub const IDCANCEL: u32 = 2;
pub const IDABORT: u32 = 3;
pub const IDRETRY: u32 = 4;
pub const IDIGNORE: u32 = 5;
pub const IDYES: u32 = 6;
pub const IDNO: u32 = 7;
pub const IDCLOSE: u32 = 8;
pub const IDHELP: u32 = 9;
pub const IDTRYAGAIN: u32 = 10;
pub const IDCONTINUE: u32 = 11;
pub const IDTIMEOUT: u32 = 32000;
pub const ES_LEFT: u32 = 0;
pub const ES_CENTER: u32 = 1;
pub const ES_RIGHT: u32 = 2;
pub const ES_MULTILINE: u32 = 4;
pub const ES_UPPERCASE: u32 = 8;
pub const ES_LOWERCASE: u32 = 16;
pub const ES_PASSWORD: u32 = 32;
pub const ES_AUTOVSCROLL: u32 = 64;
pub const ES_AUTOHSCROLL: u32 = 128;
pub const ES_NOHIDESEL: u32 = 256;
pub const ES_OEMCONVERT: u32 = 1024;
pub const ES_READONLY: u32 = 2048;
pub const ES_WANTRETURN: u32 = 4096;
pub const ES_NUMBER: u32 = 8192;
pub const EN_SETFOCUS: u32 = 256;
pub const EN_KILLFOCUS: u32 = 512;
pub const EN_CHANGE: u32 = 768;
pub const EN_UPDATE: u32 = 1024;
pub const EN_ERRSPACE: u32 = 1280;
pub const EN_MAXTEXT: u32 = 1281;
pub const EN_HSCROLL: u32 = 1537;
pub const EN_VSCROLL: u32 = 1538;
pub const EN_ALIGN_LTR_EC: u32 = 1792;
pub const EN_ALIGN_RTL_EC: u32 = 1793;
pub const EN_BEFORE_PASTE: u32 = 2048;
pub const EN_AFTER_PASTE: u32 = 2049;
pub const EC_LEFTMARGIN: u32 = 1;
pub const EC_RIGHTMARGIN: u32 = 2;
pub const EC_USEFONTINFO: u32 = 65535;
pub const EMSIS_COMPOSITIONSTRING: u32 = 1;
pub const EIMES_GETCOMPSTRATONCE: u32 = 1;
pub const EIMES_CANCELCOMPSTRINFOCUS: u32 = 2;
pub const EIMES_COMPLETECOMPSTRKILLFOCUS: u32 = 4;
pub const EM_GETSEL: u32 = 176;
pub const EM_SETSEL: u32 = 177;
pub const EM_GETRECT: u32 = 178;
pub const EM_SETRECT: u32 = 179;
pub const EM_SETRECTNP: u32 = 180;
pub const EM_SCROLL: u32 = 181;
pub const EM_LINESCROLL: u32 = 182;
pub const EM_SCROLLCARET: u32 = 183;
pub const EM_GETMODIFY: u32 = 184;
pub const EM_SETMODIFY: u32 = 185;
pub const EM_GETLINECOUNT: u32 = 186;
pub const EM_LINEINDEX: u32 = 187;
pub const EM_SETHANDLE: u32 = 188;
pub const EM_GETHANDLE: u32 = 189;
pub const EM_GETTHUMB: u32 = 190;
pub const EM_LINELENGTH: u32 = 193;
pub const EM_REPLACESEL: u32 = 194;
pub const EM_GETLINE: u32 = 196;
pub const EM_LIMITTEXT: u32 = 197;
pub const EM_CANUNDO: u32 = 198;
pub const EM_UNDO: u32 = 199;
pub const EM_FMTLINES: u32 = 200;
pub const EM_LINEFROMCHAR: u32 = 201;
pub const EM_SETTABSTOPS: u32 = 203;
pub const EM_SETPASSWORDCHAR: u32 = 204;
pub const EM_EMPTYUNDOBUFFER: u32 = 205;
pub const EM_GETFIRSTVISIBLELINE: u32 = 206;
pub const EM_SETREADONLY: u32 = 207;
pub const EM_SETWORDBREAKPROC: u32 = 208;
pub const EM_GETWORDBREAKPROC: u32 = 209;
pub const EM_GETPASSWORDCHAR: u32 = 210;
pub const EM_SETMARGINS: u32 = 211;
pub const EM_GETMARGINS: u32 = 212;
pub const EM_SETLIMITTEXT: u32 = 197;
pub const EM_GETLIMITTEXT: u32 = 213;
pub const EM_POSFROMCHAR: u32 = 214;
pub const EM_CHARFROMPOS: u32 = 215;
pub const EM_SETIMESTATUS: u32 = 216;
pub const EM_GETIMESTATUS: u32 = 217;
pub const EM_ENABLEFEATURE: u32 = 218;
pub const WB_LEFT: u32 = 0;
pub const WB_RIGHT: u32 = 1;
pub const WB_ISDELIMITER: u32 = 2;
pub const BS_PUSHBUTTON: u32 = 0;
pub const BS_DEFPUSHBUTTON: u32 = 1;
pub const BS_CHECKBOX: u32 = 2;
pub const BS_AUTOCHECKBOX: u32 = 3;
pub const BS_RADIOBUTTON: u32 = 4;
pub const BS_3STATE: u32 = 5;
pub const BS_AUTO3STATE: u32 = 6;
pub const BS_GROUPBOX: u32 = 7;
pub const BS_USERBUTTON: u32 = 8;
pub const BS_AUTORADIOBUTTON: u32 = 9;
pub const BS_PUSHBOX: u32 = 10;
pub const BS_OWNERDRAW: u32 = 11;
pub const BS_TYPEMASK: u32 = 15;
pub const BS_LEFTTEXT: u32 = 32;
pub const BS_TEXT: u32 = 0;
pub const BS_ICON: u32 = 64;
pub const BS_BITMAP: u32 = 128;
pub const BS_LEFT: u32 = 256;
pub const BS_RIGHT: u32 = 512;
pub const BS_CENTER: u32 = 768;
pub const BS_TOP: u32 = 1024;
pub const BS_BOTTOM: u32 = 2048;
pub const BS_VCENTER: u32 = 3072;
pub const BS_PUSHLIKE: u32 = 4096;
pub const BS_MULTILINE: u32 = 8192;
pub const BS_NOTIFY: u32 = 16384;
pub const BS_FLAT: u32 = 32768;
pub const BS_RIGHTBUTTON: u32 = 32;
pub const BN_CLICKED: u32 = 0;
pub const BN_PAINT: u32 = 1;
pub const BN_HILITE: u32 = 2;
pub const BN_UNHILITE: u32 = 3;
pub const BN_DISABLE: u32 = 4;
pub const BN_DOUBLECLICKED: u32 = 5;
pub const BN_PUSHED: u32 = 2;
pub const BN_UNPUSHED: u32 = 3;
pub const BN_DBLCLK: u32 = 5;
pub const BN_SETFOCUS: u32 = 6;
pub const BN_KILLFOCUS: u32 = 7;
pub const BM_GETCHECK: u32 = 240;
pub const BM_SETCHECK: u32 = 241;
pub const BM_GETSTATE: u32 = 242;
pub const BM_SETSTATE: u32 = 243;
pub const BM_SETSTYLE: u32 = 244;
pub const BM_CLICK: u32 = 245;
pub const BM_GETIMAGE: u32 = 246;
pub const BM_SETIMAGE: u32 = 247;
pub const BM_SETDONTCLICK: u32 = 248;
pub const BST_UNCHECKED: u32 = 0;
pub const BST_CHECKED: u32 = 1;
pub const BST_INDETERMINATE: u32 = 2;
pub const BST_PUSHED: u32 = 4;
pub const BST_FOCUS: u32 = 8;
pub const SS_LEFT: u32 = 0;
pub const SS_CENTER: u32 = 1;
pub const SS_RIGHT: u32 = 2;
pub const SS_ICON: u32 = 3;
pub const SS_BLACKRECT: u32 = 4;
pub const SS_GRAYRECT: u32 = 5;
pub const SS_WHITERECT: u32 = 6;
pub const SS_BLACKFRAME: u32 = 7;
pub const SS_GRAYFRAME: u32 = 8;
pub const SS_WHITEFRAME: u32 = 9;
pub const SS_USERITEM: u32 = 10;
pub const SS_SIMPLE: u32 = 11;
pub const SS_LEFTNOWORDWRAP: u32 = 12;
pub const SS_OWNERDRAW: u32 = 13;
pub const SS_BITMAP: u32 = 14;
pub const SS_ENHMETAFILE: u32 = 15;
pub const SS_ETCHEDHORZ: u32 = 16;
pub const SS_ETCHEDVERT: u32 = 17;
pub const SS_ETCHEDFRAME: u32 = 18;
pub const SS_TYPEMASK: u32 = 31;
pub const SS_REALSIZECONTROL: u32 = 64;
pub const SS_NOPREFIX: u32 = 128;
pub const SS_NOTIFY: u32 = 256;
pub const SS_CENTERIMAGE: u32 = 512;
pub const SS_RIGHTJUST: u32 = 1024;
pub const SS_REALSIZEIMAGE: u32 = 2048;
pub const SS_SUNKEN: u32 = 4096;
pub const SS_EDITCONTROL: u32 = 8192;
pub const SS_ENDELLIPSIS: u32 = 16384;
pub const SS_PATHELLIPSIS: u32 = 32768;
pub const SS_WORDELLIPSIS: u32 = 49152;
pub const SS_ELLIPSISMASK: u32 = 49152;
pub const STM_SETICON: u32 = 368;
pub const STM_GETICON: u32 = 369;
pub const STM_SETIMAGE: u32 = 370;
pub const STM_GETIMAGE: u32 = 371;
pub const STN_CLICKED: u32 = 0;
pub const STN_DBLCLK: u32 = 1;
pub const STN_ENABLE: u32 = 2;
pub const STN_DISABLE: u32 = 3;
pub const STM_MSGMAX: u32 = 372;
pub const DWL_MSGRESULT: u32 = 0;
pub const DWL_DLGPROC: u32 = 4;
pub const DWL_USER: u32 = 8;
pub const DWLP_MSGRESULT: u32 = 0;
pub const DDL_READWRITE: u32 = 0;
pub const DDL_READONLY: u32 = 1;
pub const DDL_HIDDEN: u32 = 2;
pub const DDL_SYSTEM: u32 = 4;
pub const DDL_DIRECTORY: u32 = 16;
pub const DDL_ARCHIVE: u32 = 32;
pub const DDL_POSTMSGS: u32 = 8192;
pub const DDL_DRIVES: u32 = 16384;
pub const DDL_EXCLUSIVE: u32 = 32768;
pub const DS_ABSALIGN: u32 = 1;
pub const DS_SYSMODAL: u32 = 2;
pub const DS_LOCALEDIT: u32 = 32;
pub const DS_SETFONT: u32 = 64;
pub const DS_MODALFRAME: u32 = 128;
pub const DS_NOIDLEMSG: u32 = 256;
pub const DS_SETFOREGROUND: u32 = 512;
pub const DS_3DLOOK: u32 = 4;
pub const DS_FIXEDSYS: u32 = 8;
pub const DS_NOFAILCREATE: u32 = 16;
pub const DS_CONTROL: u32 = 1024;
pub const DS_CENTER: u32 = 2048;
pub const DS_CENTERMOUSE: u32 = 4096;
pub const DS_CONTEXTHELP: u32 = 8192;
pub const DS_SHELLFONT: u32 = 72;
pub const DM_GETDEFID: u32 = 1024;
pub const DM_SETDEFID: u32 = 1025;
pub const DM_REPOSITION: u32 = 1026;
pub const DC_HASDEFID: u32 = 21323;
pub const DLGC_WANTARROWS: u32 = 1;
pub const DLGC_WANTTAB: u32 = 2;
pub const DLGC_WANTALLKEYS: u32 = 4;
pub const DLGC_WANTMESSAGE: u32 = 4;
pub const DLGC_HASSETSEL: u32 = 8;
pub const DLGC_DEFPUSHBUTTON: u32 = 16;
pub const DLGC_UNDEFPUSHBUTTON: u32 = 32;
pub const DLGC_RADIOBUTTON: u32 = 64;
pub const DLGC_WANTCHARS: u32 = 128;
pub const DLGC_STATIC: u32 = 256;
pub const DLGC_BUTTON: u32 = 8192;
pub const LB_CTLCODE: u32 = 0;
pub const LB_OKAY: u32 = 0;
pub const LB_ERR: i32 = -1;
pub const LB_ERRSPACE: i32 = -2;
pub const LBN_ERRSPACE: i32 = -2;
pub const LBN_SELCHANGE: u32 = 1;
pub const LBN_DBLCLK: u32 = 2;
pub const LBN_SELCANCEL: u32 = 3;
pub const LBN_SETFOCUS: u32 = 4;
pub const LBN_KILLFOCUS: u32 = 5;
pub const LB_ADDSTRING: u32 = 384;
pub const LB_INSERTSTRING: u32 = 385;
pub const LB_DELETESTRING: u32 = 386;
pub const LB_SELITEMRANGEEX: u32 = 387;
pub const LB_RESETCONTENT: u32 = 388;
pub const LB_SETSEL: u32 = 389;
pub const LB_SETCURSEL: u32 = 390;
pub const LB_GETSEL: u32 = 391;
pub const LB_GETCURSEL: u32 = 392;
pub const LB_GETTEXT: u32 = 393;
pub const LB_GETTEXTLEN: u32 = 394;
pub const LB_GETCOUNT: u32 = 395;
pub const LB_SELECTSTRING: u32 = 396;
pub const LB_DIR: u32 = 397;
pub const LB_GETTOPINDEX: u32 = 398;
pub const LB_FINDSTRING: u32 = 399;
pub const LB_GETSELCOUNT: u32 = 400;
pub const LB_GETSELITEMS: u32 = 401;
pub const LB_SETTABSTOPS: u32 = 402;
pub const LB_GETHORIZONTALEXTENT: u32 = 403;
pub const LB_SETHORIZONTALEXTENT: u32 = 404;
pub const LB_SETCOLUMNWIDTH: u32 = 405;
pub const LB_ADDFILE: u32 = 406;
pub const LB_SETTOPINDEX: u32 = 407;
pub const LB_GETITEMRECT: u32 = 408;
pub const LB_GETITEMDATA: u32 = 409;
pub const LB_SETITEMDATA: u32 = 410;
pub const LB_SELITEMRANGE: u32 = 411;
pub const LB_SETANCHORINDEX: u32 = 412;
pub const LB_GETANCHORINDEX: u32 = 413;
pub const LB_SETCARETINDEX: u32 = 414;
pub const LB_GETCARETINDEX: u32 = 415;
pub const LB_SETITEMHEIGHT: u32 = 416;
pub const LB_GETITEMHEIGHT: u32 = 417;
pub const LB_FINDSTRINGEXACT: u32 = 418;
pub const LB_SETLOCALE: u32 = 421;
pub const LB_GETLOCALE: u32 = 422;
pub const LB_SETCOUNT: u32 = 423;
pub const LB_INITSTORAGE: u32 = 424;
pub const LB_ITEMFROMPOINT: u32 = 425;
pub const LB_GETLISTBOXINFO: u32 = 434;
pub const LB_MSGMAX: u32 = 435;
pub const LBS_NOTIFY: u32 = 1;
pub const LBS_SORT: u32 = 2;
pub const LBS_NOREDRAW: u32 = 4;
pub const LBS_MULTIPLESEL: u32 = 8;
pub const LBS_OWNERDRAWFIXED: u32 = 16;
pub const LBS_OWNERDRAWVARIABLE: u32 = 32;
pub const LBS_HASSTRINGS: u32 = 64;
pub const LBS_USETABSTOPS: u32 = 128;
pub const LBS_NOINTEGRALHEIGHT: u32 = 256;
pub const LBS_MULTICOLUMN: u32 = 512;
pub const LBS_WANTKEYBOARDINPUT: u32 = 1024;
pub const LBS_EXTENDEDSEL: u32 = 2048;
pub const LBS_DISABLENOSCROLL: u32 = 4096;
pub const LBS_NODATA: u32 = 8192;
pub const LBS_NOSEL: u32 = 16384;
pub const LBS_COMBOBOX: u32 = 32768;
pub const LBS_STANDARD: u32 = 10485763;
pub const CB_OKAY: u32 = 0;
pub const CB_ERR: i32 = -1;
pub const CB_ERRSPACE: i32 = -2;
pub const CBN_ERRSPACE: i32 = -1;
pub const CBN_SELCHANGE: u32 = 1;
pub const CBN_DBLCLK: u32 = 2;
pub const CBN_SETFOCUS: u32 = 3;
pub const CBN_KILLFOCUS: u32 = 4;
pub const CBN_EDITCHANGE: u32 = 5;
pub const CBN_EDITUPDATE: u32 = 6;
pub const CBN_DROPDOWN: u32 = 7;
pub const CBN_CLOSEUP: u32 = 8;
pub const CBN_SELENDOK: u32 = 9;
pub const CBN_SELENDCANCEL: u32 = 10;
pub const CBS_SIMPLE: u32 = 1;
pub const CBS_DROPDOWN: u32 = 2;
pub const CBS_DROPDOWNLIST: u32 = 3;
pub const CBS_OWNERDRAWFIXED: u32 = 16;
pub const CBS_OWNERDRAWVARIABLE: u32 = 32;
pub const CBS_AUTOHSCROLL: u32 = 64;
pub const CBS_OEMCONVERT: u32 = 128;
pub const CBS_SORT: u32 = 256;
pub const CBS_HASSTRINGS: u32 = 512;
pub const CBS_NOINTEGRALHEIGHT: u32 = 1024;
pub const CBS_DISABLENOSCROLL: u32 = 2048;
pub const CBS_UPPERCASE: u32 = 8192;
pub const CBS_LOWERCASE: u32 = 16384;
pub const CB_GETEDITSEL: u32 = 320;
pub const CB_LIMITTEXT: u32 = 321;
pub const CB_SETEDITSEL: u32 = 322;
pub const CB_ADDSTRING: u32 = 323;
pub const CB_DELETESTRING: u32 = 324;
pub const CB_DIR: u32 = 325;
pub const CB_GETCOUNT: u32 = 326;
pub const CB_GETCURSEL: u32 = 327;
pub const CB_GETLBTEXT: u32 = 328;
pub const CB_GETLBTEXTLEN: u32 = 329;
pub const CB_INSERTSTRING: u32 = 330;
pub const CB_RESETCONTENT: u32 = 331;
pub const CB_FINDSTRING: u32 = 332;
pub const CB_SELECTSTRING: u32 = 333;
pub const CB_SETCURSEL: u32 = 334;
pub const CB_SHOWDROPDOWN: u32 = 335;
pub const CB_GETITEMDATA: u32 = 336;
pub const CB_SETITEMDATA: u32 = 337;
pub const CB_GETDROPPEDCONTROLRECT: u32 = 338;
pub const CB_SETITEMHEIGHT: u32 = 339;
pub const CB_GETITEMHEIGHT: u32 = 340;
pub const CB_SETEXTENDEDUI: u32 = 341;
pub const CB_GETEXTENDEDUI: u32 = 342;
pub const CB_GETDROPPEDSTATE: u32 = 343;
pub const CB_FINDSTRINGEXACT: u32 = 344;
pub const CB_SETLOCALE: u32 = 345;
pub const CB_GETLOCALE: u32 = 346;
pub const CB_GETTOPINDEX: u32 = 347;
pub const CB_SETTOPINDEX: u32 = 348;
pub const CB_GETHORIZONTALEXTENT: u32 = 349;
pub const CB_SETHORIZONTALEXTENT: u32 = 350;
pub const CB_GETDROPPEDWIDTH: u32 = 351;
pub const CB_SETDROPPEDWIDTH: u32 = 352;
pub const CB_INITSTORAGE: u32 = 353;
pub const CB_GETCOMBOBOXINFO: u32 = 356;
pub const CB_MSGMAX: u32 = 357;
pub const SBS_HORZ: u32 = 0;
pub const SBS_VERT: u32 = 1;
pub const SBS_TOPALIGN: u32 = 2;
pub const SBS_LEFTALIGN: u32 = 2;
pub const SBS_BOTTOMALIGN: u32 = 4;
pub const SBS_RIGHTALIGN: u32 = 4;
pub const SBS_SIZEBOXTOPLEFTALIGN: u32 = 2;
pub const SBS_SIZEBOXBOTTOMRIGHTALIGN: u32 = 4;
pub const SBS_SIZEBOX: u32 = 8;
pub const SBS_SIZEGRIP: u32 = 16;
pub const SBM_SETPOS: u32 = 224;
pub const SBM_GETPOS: u32 = 225;
pub const SBM_SETRANGE: u32 = 226;
pub const SBM_SETRANGEREDRAW: u32 = 230;
pub const SBM_GETRANGE: u32 = 227;
pub const SBM_ENABLE_ARROWS: u32 = 228;
pub const SBM_SETSCROLLINFO: u32 = 233;
pub const SBM_GETSCROLLINFO: u32 = 234;
pub const SBM_GETSCROLLBARINFO: u32 = 235;
pub const SIF_RANGE: u32 = 1;
pub const SIF_PAGE: u32 = 2;
pub const SIF_POS: u32 = 4;
pub const SIF_DISABLENOSCROLL: u32 = 8;
pub const SIF_TRACKPOS: u32 = 16;
pub const SIF_ALL: u32 = 23;
pub const MDIS_ALLCHILDSTYLES: u32 = 1;
pub const MDITILE_VERTICAL: u32 = 0;
pub const MDITILE_HORIZONTAL: u32 = 1;
pub const MDITILE_SKIPDISABLED: u32 = 2;
pub const MDITILE_ZORDER: u32 = 4;
pub const HELP_CONTEXT: u32 = 1;
pub const HELP_QUIT: u32 = 2;
pub const HELP_INDEX: u32 = 3;
pub const HELP_CONTENTS: u32 = 3;
pub const HELP_HELPONHELP: u32 = 4;
pub const HELP_SETINDEX: u32 = 5;
pub const HELP_SETCONTENTS: u32 = 5;
pub const HELP_CONTEXTPOPUP: u32 = 8;
pub const HELP_FORCEFILE: u32 = 9;
pub const HELP_KEY: u32 = 257;
pub const HELP_COMMAND: u32 = 258;
pub const HELP_PARTIALKEY: u32 = 261;
pub const HELP_MULTIKEY: u32 = 513;
pub const HELP_SETWINPOS: u32 = 515;
pub const HELP_CONTEXTMENU: u32 = 10;
pub const HELP_FINDER: u32 = 11;
pub const HELP_WM_HELP: u32 = 12;
pub const HELP_SETPOPUP_POS: u32 = 13;
pub const HELP_TCARD: u32 = 32768;
pub const HELP_TCARD_DATA: u32 = 16;
pub const HELP_TCARD_OTHER_CALLER: u32 = 17;
pub const IDH_NO_HELP: u32 = 28440;
pub const IDH_MISSING_CONTEXT: u32 = 28441;
pub const IDH_GENERIC_HELP_BUTTON: u32 = 28442;
pub const IDH_OK: u32 = 28443;
pub const IDH_CANCEL: u32 = 28444;
pub const IDH_HELP: u32 = 28445;
pub const GR_GDIOBJECTS: u32 = 0;
pub const GR_USEROBJECTS: u32 = 1;
pub const GR_GDIOBJECTS_PEAK: u32 = 2;
pub const GR_USEROBJECTS_PEAK: u32 = 4;
pub const SPI_GETBEEP: u32 = 1;
pub const SPI_SETBEEP: u32 = 2;
pub const SPI_GETMOUSE: u32 = 3;
pub const SPI_SETMOUSE: u32 = 4;
pub const SPI_GETBORDER: u32 = 5;
pub const SPI_SETBORDER: u32 = 6;
pub const SPI_GETKEYBOARDSPEED: u32 = 10;
pub const SPI_SETKEYBOARDSPEED: u32 = 11;
pub const SPI_LANGDRIVER: u32 = 12;
pub const SPI_ICONHORIZONTALSPACING: u32 = 13;
pub const SPI_GETSCREENSAVETIMEOUT: u32 = 14;
pub const SPI_SETSCREENSAVETIMEOUT: u32 = 15;
pub const SPI_GETSCREENSAVEACTIVE: u32 = 16;
pub const SPI_SETSCREENSAVEACTIVE: u32 = 17;
pub const SPI_GETGRIDGRANULARITY: u32 = 18;
pub const SPI_SETGRIDGRANULARITY: u32 = 19;
pub const SPI_SETDESKWALLPAPER: u32 = 20;
pub const SPI_SETDESKPATTERN: u32 = 21;
pub const SPI_GETKEYBOARDDELAY: u32 = 22;
pub const SPI_SETKEYBOARDDELAY: u32 = 23;
pub const SPI_ICONVERTICALSPACING: u32 = 24;
pub const SPI_GETICONTITLEWRAP: u32 = 25;
pub const SPI_SETICONTITLEWRAP: u32 = 26;
pub const SPI_GETMENUDROPALIGNMENT: u32 = 27;
pub const SPI_SETMENUDROPALIGNMENT: u32 = 28;
pub const SPI_SETDOUBLECLKWIDTH: u32 = 29;
pub const SPI_SETDOUBLECLKHEIGHT: u32 = 30;
pub const SPI_GETICONTITLELOGFONT: u32 = 31;
pub const SPI_SETDOUBLECLICKTIME: u32 = 32;
pub const SPI_SETMOUSEBUTTONSWAP: u32 = 33;
pub const SPI_SETICONTITLELOGFONT: u32 = 34;
pub const SPI_GETFASTTASKSWITCH: u32 = 35;
pub const SPI_SETFASTTASKSWITCH: u32 = 36;
pub const SPI_SETDRAGFULLWINDOWS: u32 = 37;
pub const SPI_GETDRAGFULLWINDOWS: u32 = 38;
pub const SPI_GETNONCLIENTMETRICS: u32 = 41;
pub const SPI_SETNONCLIENTMETRICS: u32 = 42;
pub const SPI_GETMINIMIZEDMETRICS: u32 = 43;
pub const SPI_SETMINIMIZEDMETRICS: u32 = 44;
pub const SPI_GETICONMETRICS: u32 = 45;
pub const SPI_SETICONMETRICS: u32 = 46;
pub const SPI_SETWORKAREA: u32 = 47;
pub const SPI_GETWORKAREA: u32 = 48;
pub const SPI_SETPENWINDOWS: u32 = 49;
pub const SPI_GETHIGHCONTRAST: u32 = 66;
pub const SPI_SETHIGHCONTRAST: u32 = 67;
pub const SPI_GETKEYBOARDPREF: u32 = 68;
pub const SPI_SETKEYBOARDPREF: u32 = 69;
pub const SPI_GETSCREENREADER: u32 = 70;
pub const SPI_SETSCREENREADER: u32 = 71;
pub const SPI_GETANIMATION: u32 = 72;
pub const SPI_SETANIMATION: u32 = 73;
pub const SPI_GETFONTSMOOTHING: u32 = 74;
pub const SPI_SETFONTSMOOTHING: u32 = 75;
pub const SPI_SETDRAGWIDTH: u32 = 76;
pub const SPI_SETDRAGHEIGHT: u32 = 77;
pub const SPI_SETHANDHELD: u32 = 78;
pub const SPI_GETLOWPOWERTIMEOUT: u32 = 79;
pub const SPI_GETPOWEROFFTIMEOUT: u32 = 80;
pub const SPI_SETLOWPOWERTIMEOUT: u32 = 81;
pub const SPI_SETPOWEROFFTIMEOUT: u32 = 82;
pub const SPI_GETLOWPOWERACTIVE: u32 = 83;
pub const SPI_GETPOWEROFFACTIVE: u32 = 84;
pub const SPI_SETLOWPOWERACTIVE: u32 = 85;
pub const SPI_SETPOWEROFFACTIVE: u32 = 86;
pub const SPI_SETCURSORS: u32 = 87;
pub const SPI_SETICONS: u32 = 88;
pub const SPI_GETDEFAULTINPUTLANG: u32 = 89;
pub const SPI_SETDEFAULTINPUTLANG: u32 = 90;
pub const SPI_SETLANGTOGGLE: u32 = 91;
pub const SPI_GETWINDOWSEXTENSION: u32 = 92;
pub const SPI_SETMOUSETRAILS: u32 = 93;
pub const SPI_GETMOUSETRAILS: u32 = 94;
pub const SPI_SETSCREENSAVERRUNNING: u32 = 97;
pub const SPI_SCREENSAVERRUNNING: u32 = 97;
pub const SPI_GETFILTERKEYS: u32 = 50;
pub const SPI_SETFILTERKEYS: u32 = 51;
pub const SPI_GETTOGGLEKEYS: u32 = 52;
pub const SPI_SETTOGGLEKEYS: u32 = 53;
pub const SPI_GETMOUSEKEYS: u32 = 54;
pub const SPI_SETMOUSEKEYS: u32 = 55;
pub const SPI_GETSHOWSOUNDS: u32 = 56;
pub const SPI_SETSHOWSOUNDS: u32 = 57;
pub const SPI_GETSTICKYKEYS: u32 = 58;
pub const SPI_SETSTICKYKEYS: u32 = 59;
pub const SPI_GETACCESSTIMEOUT: u32 = 60;
pub const SPI_SETACCESSTIMEOUT: u32 = 61;
pub const SPI_GETSERIALKEYS: u32 = 62;
pub const SPI_SETSERIALKEYS: u32 = 63;
pub const SPI_GETSOUNDSENTRY: u32 = 64;
pub const SPI_SETSOUNDSENTRY: u32 = 65;
pub const SPI_GETSNAPTODEFBUTTON: u32 = 95;
pub const SPI_SETSNAPTODEFBUTTON: u32 = 96;
pub const SPI_GETMOUSEHOVERWIDTH: u32 = 98;
pub const SPI_SETMOUSEHOVERWIDTH: u32 = 99;
pub const SPI_GETMOUSEHOVERHEIGHT: u32 = 100;
pub const SPI_SETMOUSEHOVERHEIGHT: u32 = 101;
pub const SPI_GETMOUSEHOVERTIME: u32 = 102;
pub const SPI_SETMOUSEHOVERTIME: u32 = 103;
pub const SPI_GETWHEELSCROLLLINES: u32 = 104;
pub const SPI_SETWHEELSCROLLLINES: u32 = 105;
pub const SPI_GETMENUSHOWDELAY: u32 = 106;
pub const SPI_SETMENUSHOWDELAY: u32 = 107;
pub const SPI_GETWHEELSCROLLCHARS: u32 = 108;
pub const SPI_SETWHEELSCROLLCHARS: u32 = 109;
pub const SPI_GETSHOWIMEUI: u32 = 110;
pub const SPI_SETSHOWIMEUI: u32 = 111;
pub const SPI_GETMOUSESPEED: u32 = 112;
pub const SPI_SETMOUSESPEED: u32 = 113;
pub const SPI_GETSCREENSAVERRUNNING: u32 = 114;
pub const SPI_GETDESKWALLPAPER: u32 = 115;
pub const SPI_GETAUDIODESCRIPTION: u32 = 116;
pub const SPI_SETAUDIODESCRIPTION: u32 = 117;
pub const SPI_GETSCREENSAVESECURE: u32 = 118;
pub const SPI_SETSCREENSAVESECURE: u32 = 119;
pub const SPI_GETHUNGAPPTIMEOUT: u32 = 120;
pub const SPI_SETHUNGAPPTIMEOUT: u32 = 121;
pub const SPI_GETWAITTOKILLTIMEOUT: u32 = 122;
pub const SPI_SETWAITTOKILLTIMEOUT: u32 = 123;
pub const SPI_GETWAITTOKILLSERVICETIMEOUT: u32 = 124;
pub const SPI_SETWAITTOKILLSERVICETIMEOUT: u32 = 125;
pub const SPI_GETMOUSEDOCKTHRESHOLD: u32 = 126;
pub const SPI_SETMOUSEDOCKTHRESHOLD: u32 = 127;
pub const SPI_GETPENDOCKTHRESHOLD: u32 = 128;
pub const SPI_SETPENDOCKTHRESHOLD: u32 = 129;
pub const SPI_GETWINARRANGING: u32 = 130;
pub const SPI_SETWINARRANGING: u32 = 131;
pub const SPI_GETMOUSEDRAGOUTTHRESHOLD: u32 = 132;
pub const SPI_SETMOUSEDRAGOUTTHRESHOLD: u32 = 133;
pub const SPI_GETPENDRAGOUTTHRESHOLD: u32 = 134;
pub const SPI_SETPENDRAGOUTTHRESHOLD: u32 = 135;
pub const SPI_GETMOUSESIDEMOVETHRESHOLD: u32 = 136;
pub const SPI_SETMOUSESIDEMOVETHRESHOLD: u32 = 137;
pub const SPI_GETPENSIDEMOVETHRESHOLD: u32 = 138;
pub const SPI_SETPENSIDEMOVETHRESHOLD: u32 = 139;
pub const SPI_GETDRAGFROMMAXIMIZE: u32 = 140;
pub const SPI_SETDRAGFROMMAXIMIZE: u32 = 141;
pub const SPI_GETSNAPSIZING: u32 = 142;
pub const SPI_SETSNAPSIZING: u32 = 143;
pub const SPI_GETDOCKMOVING: u32 = 144;
pub const SPI_SETDOCKMOVING: u32 = 145;
pub const MAX_TOUCH_PREDICTION_FILTER_TAPS: u32 = 3;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_LATENCY: u32 = 8;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_SAMPLETIME: u32 = 8;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_USE_HW_TIMESTAMP: u32 = 1;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_RLS_DELTA: f64 = 0.001;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_RLS_LAMBDA_MIN: f64 = 0.9;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_RLS_LAMBDA_MAX: f64 = 0.999;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_RLS_LAMBDA_LEARNING_RATE: f64 = 0.001;
pub const TOUCHPREDICTIONPARAMETERS_DEFAULT_RLS_EXPO_SMOOTH_ALPHA: f64 = 0.99;
pub const SPI_GETTOUCHPREDICTIONPARAMETERS: u32 = 156;
pub const SPI_SETTOUCHPREDICTIONPARAMETERS: u32 = 157;
pub const MAX_LOGICALDPIOVERRIDE: u32 = 2;
pub const MIN_LOGICALDPIOVERRIDE: i32 = -2;
pub const SPI_GETLOGICALDPIOVERRIDE: u32 = 158;
pub const SPI_SETLOGICALDPIOVERRIDE: u32 = 159;
pub const SPI_GETMENURECT: u32 = 162;
pub const SPI_SETMENURECT: u32 = 163;
pub const SPI_GETACTIVEWINDOWTRACKING: u32 = 4096;
pub const SPI_SETACTIVEWINDOWTRACKING: u32 = 4097;
pub const SPI_GETMENUANIMATION: u32 = 4098;
pub const SPI_SETMENUANIMATION: u32 = 4099;
pub const SPI_GETCOMBOBOXANIMATION: u32 = 4100;
pub const SPI_SETCOMBOBOXANIMATION: u32 = 4101;
pub const SPI_GETLISTBOXSMOOTHSCROLLING: u32 = 4102;
pub const SPI_SETLISTBOXSMOOTHSCROLLING: u32 = 4103;
pub const SPI_GETGRADIENTCAPTIONS: u32 = 4104;
pub const SPI_SETGRADIENTCAPTIONS: u32 = 4105;
pub const SPI_GETKEYBOARDCUES: u32 = 4106;
pub const SPI_SETKEYBOARDCUES: u32 = 4107;
pub const SPI_GETMENUUNDERLINES: u32 = 4106;
pub const SPI_SETMENUUNDERLINES: u32 = 4107;
pub const SPI_GETACTIVEWNDTRKZORDER: u32 = 4108;
pub const SPI_SETACTIVEWNDTRKZORDER: u32 = 4109;
pub const SPI_GETHOTTRACKING: u32 = 4110;
pub const SPI_SETHOTTRACKING: u32 = 4111;
pub const SPI_GETMENUFADE: u32 = 4114;
pub const SPI_SETMENUFADE: u32 = 4115;
pub const SPI_GETSELECTIONFADE: u32 = 4116;
pub const SPI_SETSELECTIONFADE: u32 = 4117;
pub const SPI_GETTOOLTIPANIMATION: u32 = 4118;
pub const SPI_SETTOOLTIPANIMATION: u32 = 4119;
pub const SPI_GETTOOLTIPFADE: u32 = 4120;
pub const SPI_SETTOOLTIPFADE: u32 = 4121;
pub const SPI_GETCURSORSHADOW: u32 = 4122;
pub const SPI_SETCURSORSHADOW: u32 = 4123;
pub const SPI_GETMOUSESONAR: u32 = 4124;
pub const SPI_SETMOUSESONAR: u32 = 4125;
pub const SPI_GETMOUSECLICKLOCK: u32 = 4126;
pub const SPI_SETMOUSECLICKLOCK: u32 = 4127;
pub const SPI_GETMOUSEVANISH: u32 = 4128;
pub const SPI_SETMOUSEVANISH: u32 = 4129;
pub const SPI_GETFLATMENU: u32 = 4130;
pub const SPI_SETFLATMENU: u32 = 4131;
pub const SPI_GETDROPSHADOW: u32 = 4132;
pub const SPI_SETDROPSHADOW: u32 = 4133;
pub const SPI_GETBLOCKSENDINPUTRESETS: u32 = 4134;
pub const SPI_SETBLOCKSENDINPUTRESETS: u32 = 4135;
pub const SPI_GETUIEFFECTS: u32 = 4158;
pub const SPI_SETUIEFFECTS: u32 = 4159;
pub const SPI_GETDISABLEOVERLAPPEDCONTENT: u32 = 4160;
pub const SPI_SETDISABLEOVERLAPPEDCONTENT: u32 = 4161;
pub const SPI_GETCLIENTAREAANIMATION: u32 = 4162;
pub const SPI_SETCLIENTAREAANIMATION: u32 = 4163;
pub const SPI_GETCLEARTYPE: u32 = 4168;
pub const SPI_SETCLEARTYPE: u32 = 4169;
pub const SPI_GETSPEECHRECOGNITION: u32 = 4170;
pub const SPI_SETSPEECHRECOGNITION: u32 = 4171;
pub const SPI_GETCARETBROWSING: u32 = 4172;
pub const SPI_SETCARETBROWSING: u32 = 4173;
pub const SPI_GETTHREADLOCALINPUTSETTINGS: u32 = 4174;
pub const SPI_SETTHREADLOCALINPUTSETTINGS: u32 = 4175;
pub const SPI_GETSYSTEMLANGUAGEBAR: u32 = 4176;
pub const SPI_SETSYSTEMLANGUAGEBAR: u32 = 4177;
pub const SPI_GETFOREGROUNDLOCKTIMEOUT: u32 = 8192;
pub const SPI_SETFOREGROUNDLOCKTIMEOUT: u32 = 8193;
pub const SPI_GETACTIVEWNDTRKTIMEOUT: u32 = 8194;
pub const SPI_SETACTIVEWNDTRKTIMEOUT: u32 = 8195;
pub const SPI_GETFOREGROUNDFLASHCOUNT: u32 = 8196;
pub const SPI_SETFOREGROUNDFLASHCOUNT: u32 = 8197;
pub const SPI_GETCARETWIDTH: u32 = 8198;
pub const SPI_SETCARETWIDTH: u32 = 8199;
pub const SPI_GETMOUSECLICKLOCKTIME: u32 = 8200;
pub const SPI_SETMOUSECLICKLOCKTIME: u32 = 8201;
pub const SPI_GETFONTSMOOTHINGTYPE: u32 = 8202;
pub const SPI_SETFONTSMOOTHINGTYPE: u32 = 8203;
pub const FE_FONTSMOOTHINGSTANDARD: u32 = 1;
pub const FE_FONTSMOOTHINGCLEARTYPE: u32 = 2;
pub const SPI_GETFONTSMOOTHINGCONTRAST: u32 = 8204;
pub const SPI_SETFONTSMOOTHINGCONTRAST: u32 = 8205;
pub const SPI_GETFOCUSBORDERWIDTH: u32 = 8206;
pub const SPI_SETFOCUSBORDERWIDTH: u32 = 8207;
pub const SPI_GETFOCUSBORDERHEIGHT: u32 = 8208;
pub const SPI_SETFOCUSBORDERHEIGHT: u32 = 8209;
pub const SPI_GETFONTSMOOTHINGORIENTATION: u32 = 8210;
pub const SPI_SETFONTSMOOTHINGORIENTATION: u32 = 8211;
pub const FE_FONTSMOOTHINGORIENTATIONBGR: u32 = 0;
pub const FE_FONTSMOOTHINGORIENTATIONRGB: u32 = 1;
pub const SPI_GETMINIMUMHITRADIUS: u32 = 8212;
pub const SPI_SETMINIMUMHITRADIUS: u32 = 8213;
pub const SPI_GETMESSAGEDURATION: u32 = 8214;
pub const SPI_SETMESSAGEDURATION: u32 = 8215;
pub const SPI_GETCONTACTVISUALIZATION: u32 = 8216;
pub const SPI_SETCONTACTVISUALIZATION: u32 = 8217;
pub const CONTACTVISUALIZATION_OFF: u32 = 0;
pub const CONTACTVISUALIZATION_ON: u32 = 1;
pub const CONTACTVISUALIZATION_PRESENTATIONMODE: u32 = 2;
pub const SPI_GETGESTUREVISUALIZATION: u32 = 8218;
pub const SPI_SETGESTUREVISUALIZATION: u32 = 8219;
pub const GESTUREVISUALIZATION_OFF: u32 = 0;
pub const GESTUREVISUALIZATION_ON: u32 = 31;
pub const GESTUREVISUALIZATION_TAP: u32 = 1;
pub const GESTUREVISUALIZATION_DOUBLETAP: u32 = 2;
pub const GESTUREVISUALIZATION_PRESSANDTAP: u32 = 4;
pub const GESTUREVISUALIZATION_PRESSANDHOLD: u32 = 8;
pub const GESTUREVISUALIZATION_RIGHTTAP: u32 = 16;
pub const SPI_GETMOUSEWHEELROUTING: u32 = 8220;
pub const SPI_SETMOUSEWHEELROUTING: u32 = 8221;
pub const MOUSEWHEEL_ROUTING_FOCUS: u32 = 0;
pub const MOUSEWHEEL_ROUTING_HYBRID: u32 = 1;
pub const MOUSEWHEEL_ROUTING_MOUSE_POS: u32 = 2;
pub const SPI_GETPENVISUALIZATION: u32 = 8222;
pub const SPI_SETPENVISUALIZATION: u32 = 8223;
pub const PENVISUALIZATION_ON: u32 = 35;
pub const PENVISUALIZATION_OFF: u32 = 0;
pub const PENVISUALIZATION_TAP: u32 = 1;
pub const PENVISUALIZATION_DOUBLETAP: u32 = 2;
pub const PENVISUALIZATION_CURSOR: u32 = 32;
pub const SPI_GETPENARBITRATIONTYPE: u32 = 8224;
pub const SPI_SETPENARBITRATIONTYPE: u32 = 8225;
pub const PENARBITRATIONTYPE_NONE: u32 = 0;
pub const PENARBITRATIONTYPE_WIN8: u32 = 1;
pub const PENARBITRATIONTYPE_FIS: u32 = 2;
pub const PENARBITRATIONTYPE_SPT: u32 = 3;
pub const PENARBITRATIONTYPE_MAX: u32 = 4;
pub const SPI_GETCARETTIMEOUT: u32 = 8226;
pub const SPI_SETCARETTIMEOUT: u32 = 8227;
pub const SPI_GETHANDEDNESS: u32 = 8228;
pub const SPI_SETHANDEDNESS: u32 = 8229;
pub const SPIF_UPDATEINIFILE: u32 = 1;
pub const SPIF_SENDWININICHANGE: u32 = 2;
pub const SPIF_SENDCHANGE: u32 = 2;
pub const METRICS_USEDEFAULT: i32 = -1;
pub const ARW_BOTTOMLEFT: u32 = 0;
pub const ARW_BOTTOMRIGHT: u32 = 1;
pub const ARW_TOPLEFT: u32 = 2;
pub const ARW_TOPRIGHT: u32 = 3;
pub const ARW_STARTMASK: u32 = 3;
pub const ARW_STARTRIGHT: u32 = 1;
pub const ARW_STARTTOP: u32 = 2;
pub const ARW_LEFT: u32 = 0;
pub const ARW_RIGHT: u32 = 0;
pub const ARW_UP: u32 = 4;
pub const ARW_DOWN: u32 = 4;
pub const ARW_HIDE: u32 = 8;
pub const SERKF_SERIALKEYSON: u32 = 1;
pub const SERKF_AVAILABLE: u32 = 2;
pub const SERKF_INDICATOR: u32 = 4;
pub const HCF_HIGHCONTRASTON: u32 = 1;
pub const HCF_AVAILABLE: u32 = 2;
pub const HCF_HOTKEYACTIVE: u32 = 4;
pub const HCF_CONFIRMHOTKEY: u32 = 8;
pub const HCF_HOTKEYSOUND: u32 = 16;
pub const HCF_INDICATOR: u32 = 32;
pub const HCF_HOTKEYAVAILABLE: u32 = 64;
pub const HCF_LOGONDESKTOP: u32 = 256;
pub const HCF_DEFAULTDESKTOP: u32 = 512;
pub const HCF_OPTION_NOTHEMECHANGE: u32 = 4096;
pub const CDS_UPDATEREGISTRY: u32 = 1;
pub const CDS_TEST: u32 = 2;
pub const CDS_FULLSCREEN: u32 = 4;
pub const CDS_GLOBAL: u32 = 8;
pub const CDS_SET_PRIMARY: u32 = 16;
pub const CDS_VIDEOPARAMETERS: u32 = 32;
pub const CDS_ENABLE_UNSAFE_MODES: u32 = 256;
pub const CDS_DISABLE_UNSAFE_MODES: u32 = 512;
pub const CDS_RESET: u32 = 1073741824;
pub const CDS_RESET_EX: u32 = 536870912;
pub const CDS_NORESET: u32 = 268435456;
pub const VP_COMMAND_GET: u32 = 1;
pub const VP_COMMAND_SET: u32 = 2;
pub const VP_FLAGS_TV_MODE: u32 = 1;
pub const VP_FLAGS_TV_STANDARD: u32 = 2;
pub const VP_FLAGS_FLICKER: u32 = 4;
pub const VP_FLAGS_OVERSCAN: u32 = 8;
pub const VP_FLAGS_MAX_UNSCALED: u32 = 16;
pub const VP_FLAGS_POSITION: u32 = 32;
pub const VP_FLAGS_BRIGHTNESS: u32 = 64;
pub const VP_FLAGS_CONTRAST: u32 = 128;
pub const VP_FLAGS_COPYPROTECT: u32 = 256;
pub const VP_MODE_WIN_GRAPHICS: u32 = 1;
pub const VP_MODE_TV_PLAYBACK: u32 = 2;
pub const VP_TV_STANDARD_NTSC_M: u32 = 1;
pub const VP_TV_STANDARD_NTSC_M_J: u32 = 2;
pub const VP_TV_STANDARD_PAL_B: u32 = 4;
pub const VP_TV_STANDARD_PAL_D: u32 = 8;
pub const VP_TV_STANDARD_PAL_H: u32 = 16;
pub const VP_TV_STANDARD_PAL_I: u32 = 32;
pub const VP_TV_STANDARD_PAL_M: u32 = 64;
pub const VP_TV_STANDARD_PAL_N: u32 = 128;
pub const VP_TV_STANDARD_SECAM_B: u32 = 256;
pub const VP_TV_STANDARD_SECAM_D: u32 = 512;
pub const VP_TV_STANDARD_SECAM_G: u32 = 1024;
pub const VP_TV_STANDARD_SECAM_H: u32 = 2048;
pub const VP_TV_STANDARD_SECAM_K: u32 = 4096;
pub const VP_TV_STANDARD_SECAM_K1: u32 = 8192;
pub const VP_TV_STANDARD_SECAM_L: u32 = 16384;
pub const VP_TV_STANDARD_WIN_VGA: u32 = 32768;
pub const VP_TV_STANDARD_NTSC_433: u32 = 65536;
pub const VP_TV_STANDARD_PAL_G: u32 = 131072;
pub const VP_TV_STANDARD_PAL_60: u32 = 262144;
pub const VP_TV_STANDARD_SECAM_L1: u32 = 524288;
pub const VP_CP_TYPE_APS_TRIGGER: u32 = 1;
pub const VP_CP_TYPE_MACROVISION: u32 = 2;
pub const VP_CP_CMD_ACTIVATE: u32 = 1;
pub const VP_CP_CMD_DEACTIVATE: u32 = 2;
pub const VP_CP_CMD_CHANGE: u32 = 4;
pub const DISP_CHANGE_SUCCESSFUL: u32 = 0;
pub const DISP_CHANGE_RESTART: u32 = 1;
pub const DISP_CHANGE_FAILED: i32 = -1;
pub const DISP_CHANGE_BADMODE: i32 = -2;
pub const DISP_CHANGE_NOTUPDATED: i32 = -3;
pub const DISP_CHANGE_BADFLAGS: i32 = -4;
pub const DISP_CHANGE_BADPARAM: i32 = -5;
pub const DISP_CHANGE_BADDUALVIEW: i32 = -6;
pub const EDS_RAWMODE: u32 = 2;
pub const EDS_ROTATEDMODE: u32 = 4;
pub const EDD_GET_DEVICE_INTERFACE_NAME: u32 = 1;
pub const FKF_FILTERKEYSON: u32 = 1;
pub const FKF_AVAILABLE: u32 = 2;
pub const FKF_HOTKEYACTIVE: u32 = 4;
pub const FKF_CONFIRMHOTKEY: u32 = 8;
pub const FKF_HOTKEYSOUND: u32 = 16;
pub const FKF_INDICATOR: u32 = 32;
pub const FKF_CLICKON: u32 = 64;
pub const SKF_STICKYKEYSON: u32 = 1;
pub const SKF_AVAILABLE: u32 = 2;
pub const SKF_HOTKEYACTIVE: u32 = 4;
pub const SKF_CONFIRMHOTKEY: u32 = 8;
pub const SKF_HOTKEYSOUND: u32 = 16;
pub const SKF_INDICATOR: u32 = 32;
pub const SKF_AUDIBLEFEEDBACK: u32 = 64;
pub const SKF_TRISTATE: u32 = 128;
pub const SKF_TWOKEYSOFF: u32 = 256;
pub const SKF_LALTLATCHED: u32 = 268435456;
pub const SKF_LCTLLATCHED: u32 = 67108864;
pub const SKF_LSHIFTLATCHED: u32 = 16777216;
pub const SKF_RALTLATCHED: u32 = 536870912;
pub const SKF_RCTLLATCHED: u32 = 134217728;
pub const SKF_RSHIFTLATCHED: u32 = 33554432;
pub const SKF_LWINLATCHED: u32 = 1073741824;
pub const SKF_RWINLATCHED: u32 = 2147483648;
pub const SKF_LALTLOCKED: u32 = 1048576;
pub const SKF_LCTLLOCKED: u32 = 262144;
pub const SKF_LSHIFTLOCKED: u32 = 65536;
pub const SKF_RALTLOCKED: u32 = 2097152;
pub const SKF_RCTLLOCKED: u32 = 524288;
pub const SKF_RSHIFTLOCKED: u32 = 131072;
pub const SKF_LWINLOCKED: u32 = 4194304;
pub const SKF_RWINLOCKED: u32 = 8388608;
pub const MKF_MOUSEKEYSON: u32 = 1;
pub const MKF_AVAILABLE: u32 = 2;
pub const MKF_HOTKEYACTIVE: u32 = 4;
pub const MKF_CONFIRMHOTKEY: u32 = 8;
pub const MKF_HOTKEYSOUND: u32 = 16;
pub const MKF_INDICATOR: u32 = 32;
pub const MKF_MODIFIERS: u32 = 64;
pub const MKF_REPLACENUMBERS: u32 = 128;
pub const MKF_LEFTBUTTONSEL: u32 = 268435456;
pub const MKF_RIGHTBUTTONSEL: u32 = 536870912;
pub const MKF_LEFTBUTTONDOWN: u32 = 16777216;
pub const MKF_RIGHTBUTTONDOWN: u32 = 33554432;
pub const MKF_MOUSEMODE: u32 = 2147483648;
pub const ATF_TIMEOUTON: u32 = 1;
pub const ATF_ONOFFFEEDBACK: u32 = 2;
pub const SSGF_NONE: u32 = 0;
pub const SSGF_DISPLAY: u32 = 3;
pub const SSTF_NONE: u32 = 0;
pub const SSTF_CHARS: u32 = 1;
pub const SSTF_BORDER: u32 = 2;
pub const SSTF_DISPLAY: u32 = 3;
pub const SSWF_NONE: u32 = 0;
pub const SSWF_TITLE: u32 = 1;
pub const SSWF_WINDOW: u32 = 2;
pub const SSWF_DISPLAY: u32 = 3;
pub const SSWF_CUSTOM: u32 = 4;
pub const SSF_SOUNDSENTRYON: u32 = 1;
pub const SSF_AVAILABLE: u32 = 2;
pub const SSF_INDICATOR: u32 = 4;
pub const TKF_TOGGLEKEYSON: u32 = 1;
pub const TKF_AVAILABLE: u32 = 2;
pub const TKF_HOTKEYACTIVE: u32 = 4;
pub const TKF_CONFIRMHOTKEY: u32 = 8;
pub const TKF_HOTKEYSOUND: u32 = 16;
pub const TKF_INDICATOR: u32 = 32;
pub const SLE_ERROR: u32 = 1;
pub const SLE_MINORERROR: u32 = 2;
pub const SLE_WARNING: u32 = 3;
pub const MONITOR_DEFAULTTONULL: u32 = 0;
pub const MONITOR_DEFAULTTOPRIMARY: u32 = 1;
pub const MONITOR_DEFAULTTONEAREST: u32 = 2;
pub const MONITORINFOF_PRIMARY: u32 = 1;
pub const WINEVENT_OUTOFCONTEXT: u32 = 0;
pub const WINEVENT_SKIPOWNTHREAD: u32 = 1;
pub const WINEVENT_SKIPOWNPROCESS: u32 = 2;
pub const WINEVENT_INCONTEXT: u32 = 4;
pub const CHILDID_SELF: u32 = 0;
pub const INDEXID_OBJECT: u32 = 0;
pub const INDEXID_CONTAINER: u32 = 0;
pub const EVENT_MIN: u32 = 1;
pub const EVENT_MAX: u32 = 2147483647;
pub const EVENT_SYSTEM_SOUND: u32 = 1;
pub const EVENT_SYSTEM_ALERT: u32 = 2;
pub const EVENT_SYSTEM_FOREGROUND: u32 = 3;
pub const EVENT_SYSTEM_MENUSTART: u32 = 4;
pub const EVENT_SYSTEM_MENUEND: u32 = 5;
pub const EVENT_SYSTEM_MENUPOPUPSTART: u32 = 6;
pub const EVENT_SYSTEM_MENUPOPUPEND: u32 = 7;
pub const EVENT_SYSTEM_CAPTURESTART: u32 = 8;
pub const EVENT_SYSTEM_CAPTUREEND: u32 = 9;
pub const EVENT_SYSTEM_MOVESIZESTART: u32 = 10;
pub const EVENT_SYSTEM_MOVESIZEEND: u32 = 11;
pub const EVENT_SYSTEM_CONTEXTHELPSTART: u32 = 12;
pub const EVENT_SYSTEM_CONTEXTHELPEND: u32 = 13;
pub const EVENT_SYSTEM_DRAGDROPSTART: u32 = 14;
pub const EVENT_SYSTEM_DRAGDROPEND: u32 = 15;
pub const EVENT_SYSTEM_DIALOGSTART: u32 = 16;
pub const EVENT_SYSTEM_DIALOGEND: u32 = 17;
pub const EVENT_SYSTEM_SCROLLINGSTART: u32 = 18;
pub const EVENT_SYSTEM_SCROLLINGEND: u32 = 19;
pub const EVENT_SYSTEM_SWITCHSTART: u32 = 20;
pub const EVENT_SYSTEM_SWITCHEND: u32 = 21;
pub const EVENT_SYSTEM_MINIMIZESTART: u32 = 22;
pub const EVENT_SYSTEM_MINIMIZEEND: u32 = 23;
pub const EVENT_SYSTEM_DESKTOPSWITCH: u32 = 32;
pub const EVENT_SYSTEM_SWITCHER_APPGRABBED: u32 = 36;
pub const EVENT_SYSTEM_SWITCHER_APPOVERTARGET: u32 = 37;
pub const EVENT_SYSTEM_SWITCHER_APPDROPPED: u32 = 38;
pub const EVENT_SYSTEM_SWITCHER_CANCELLED: u32 = 39;
pub const EVENT_SYSTEM_IME_KEY_NOTIFICATION: u32 = 41;
pub const EVENT_SYSTEM_END: u32 = 255;
pub const EVENT_OEM_DEFINED_START: u32 = 257;
pub const EVENT_OEM_DEFINED_END: u32 = 511;
pub const EVENT_UIA_EVENTID_START: u32 = 19968;
pub const EVENT_UIA_EVENTID_END: u32 = 20223;
pub const EVENT_UIA_PROPID_START: u32 = 29952;
pub const EVENT_UIA_PROPID_END: u32 = 30207;
pub const EVENT_CONSOLE_CARET: u32 = 16385;
pub const EVENT_CONSOLE_UPDATE_REGION: u32 = 16386;
pub const EVENT_CONSOLE_UPDATE_SIMPLE: u32 = 16387;
pub const EVENT_CONSOLE_UPDATE_SCROLL: u32 = 16388;
pub const EVENT_CONSOLE_LAYOUT: u32 = 16389;
pub const EVENT_CONSOLE_START_APPLICATION: u32 = 16390;
pub const EVENT_CONSOLE_END_APPLICATION: u32 = 16391;
pub const CONSOLE_APPLICATION_16BIT: u32 = 0;
pub const CONSOLE_CARET_SELECTION: u32 = 1;
pub const CONSOLE_CARET_VISIBLE: u32 = 2;
pub const EVENT_CONSOLE_END: u32 = 16639;
pub const EVENT_OBJECT_CREATE: u32 = 32768;
pub const EVENT_OBJECT_DESTROY: u32 = 32769;
pub const EVENT_OBJECT_SHOW: u32 = 32770;
pub const EVENT_OBJECT_HIDE: u32 = 32771;
pub const EVENT_OBJECT_REORDER: u32 = 32772;
pub const EVENT_OBJECT_FOCUS: u32 = 32773;
pub const EVENT_OBJECT_SELECTION: u32 = 32774;
pub const EVENT_OBJECT_SELECTIONADD: u32 = 32775;
pub const EVENT_OBJECT_SELECTIONREMOVE: u32 = 32776;
pub const EVENT_OBJECT_SELECTIONWITHIN: u32 = 32777;
pub const EVENT_OBJECT_STATECHANGE: u32 = 32778;
pub const EVENT_OBJECT_LOCATIONCHANGE: u32 = 32779;
pub const EVENT_OBJECT_NAMECHANGE: u32 = 32780;
pub const EVENT_OBJECT_DESCRIPTIONCHANGE: u32 = 32781;
pub const EVENT_OBJECT_VALUECHANGE: u32 = 32782;
pub const EVENT_OBJECT_PARENTCHANGE: u32 = 32783;
pub const EVENT_OBJECT_HELPCHANGE: u32 = 32784;
pub const EVENT_OBJECT_DEFACTIONCHANGE: u32 = 32785;
pub const EVENT_OBJECT_ACCELERATORCHANGE: u32 = 32786;
pub const EVENT_OBJECT_INVOKED: u32 = 32787;
pub const EVENT_OBJECT_TEXTSELECTIONCHANGED: u32 = 32788;
pub const EVENT_OBJECT_CONTENTSCROLLED: u32 = 32789;
pub const EVENT_SYSTEM_ARRANGMENTPREVIEW: u32 = 32790;
pub const EVENT_OBJECT_CLOAKED: u32 = 32791;
pub const EVENT_OBJECT_UNCLOAKED: u32 = 32792;
pub const EVENT_OBJECT_LIVEREGIONCHANGED: u32 = 32793;
pub const EVENT_OBJECT_HOSTEDOBJECTSINVALIDATED: u32 = 32800;
pub const EVENT_OBJECT_DRAGSTART: u32 = 32801;
pub const EVENT_OBJECT_DRAGCANCEL: u32 = 32802;
pub const EVENT_OBJECT_DRAGCOMPLETE: u32 = 32803;
pub const EVENT_OBJECT_DRAGENTER: u32 = 32804;
pub const EVENT_OBJECT_DRAGLEAVE: u32 = 32805;
pub const EVENT_OBJECT_DRAGDROPPED: u32 = 32806;
pub const EVENT_OBJECT_IME_SHOW: u32 = 32807;
pub const EVENT_OBJECT_IME_HIDE: u32 = 32808;
pub const EVENT_OBJECT_IME_CHANGE: u32 = 32809;
pub const EVENT_OBJECT_TEXTEDIT_CONVERSIONTARGETCHANGED: u32 = 32816;
pub const EVENT_OBJECT_END: u32 = 33023;
pub const EVENT_AIA_START: u32 = 40960;
pub const EVENT_AIA_END: u32 = 45055;
pub const SOUND_SYSTEM_STARTUP: u32 = 1;
pub const SOUND_SYSTEM_SHUTDOWN: u32 = 2;
pub const SOUND_SYSTEM_BEEP: u32 = 3;
pub const SOUND_SYSTEM_ERROR: u32 = 4;
pub const SOUND_SYSTEM_QUESTION: u32 = 5;
pub const SOUND_SYSTEM_WARNING: u32 = 6;
pub const SOUND_SYSTEM_INFORMATION: u32 = 7;
pub const SOUND_SYSTEM_MAXIMIZE: u32 = 8;
pub const SOUND_SYSTEM_MINIMIZE: u32 = 9;
pub const SOUND_SYSTEM_RESTOREUP: u32 = 10;
pub const SOUND_SYSTEM_RESTOREDOWN: u32 = 11;
pub const SOUND_SYSTEM_APPSTART: u32 = 12;
pub const SOUND_SYSTEM_FAULT: u32 = 13;
pub const SOUND_SYSTEM_APPEND: u32 = 14;
pub const SOUND_SYSTEM_MENUCOMMAND: u32 = 15;
pub const SOUND_SYSTEM_MENUPOPUP: u32 = 16;
pub const CSOUND_SYSTEM: u32 = 16;
pub const ALERT_SYSTEM_INFORMATIONAL: u32 = 1;
pub const ALERT_SYSTEM_WARNING: u32 = 2;
pub const ALERT_SYSTEM_ERROR: u32 = 3;
pub const ALERT_SYSTEM_QUERY: u32 = 4;
pub const ALERT_SYSTEM_CRITICAL: u32 = 5;
pub const CALERT_SYSTEM: u32 = 6;
pub const GUI_CARETBLINKING: u32 = 1;
pub const GUI_INMOVESIZE: u32 = 2;
pub const GUI_INMENUMODE: u32 = 4;
pub const GUI_SYSTEMMENUMODE: u32 = 8;
pub const GUI_POPUPMENUMODE: u32 = 16;
pub const GUI_16BITTASK: u32 = 0;
pub const USER_DEFAULT_SCREEN_DPI: u32 = 96;
pub const STATE_SYSTEM_UNAVAILABLE: u32 = 1;
pub const STATE_SYSTEM_SELECTED: u32 = 2;
pub const STATE_SYSTEM_FOCUSED: u32 = 4;
pub const STATE_SYSTEM_PRESSED: u32 = 8;
pub const STATE_SYSTEM_CHECKED: u32 = 16;
pub const STATE_SYSTEM_MIXED: u32 = 32;
pub const STATE_SYSTEM_INDETERMINATE: u32 = 32;
pub const STATE_SYSTEM_READONLY: u32 = 64;
pub const STATE_SYSTEM_HOTTRACKED: u32 = 128;
pub const STATE_SYSTEM_DEFAULT: u32 = 256;
pub const STATE_SYSTEM_EXPANDED: u32 = 512;
pub const STATE_SYSTEM_COLLAPSED: u32 = 1024;
pub const STATE_SYSTEM_BUSY: u32 = 2048;
pub const STATE_SYSTEM_FLOATING: u32 = 4096;
pub const STATE_SYSTEM_MARQUEED: u32 = 8192;
pub const STATE_SYSTEM_ANIMATED: u32 = 16384;
pub const STATE_SYSTEM_INVISIBLE: u32 = 32768;
pub const STATE_SYSTEM_OFFSCREEN: u32 = 65536;
pub const STATE_SYSTEM_SIZEABLE: u32 = 131072;
pub const STATE_SYSTEM_MOVEABLE: u32 = 262144;
pub const STATE_SYSTEM_SELFVOICING: u32 = 524288;
pub const STATE_SYSTEM_FOCUSABLE: u32 = 1048576;
pub const STATE_SYSTEM_SELECTABLE: u32 = 2097152;
pub const STATE_SYSTEM_LINKED: u32 = 4194304;
pub const STATE_SYSTEM_TRAVERSED: u32 = 8388608;
pub const STATE_SYSTEM_MULTISELECTABLE: u32 = 16777216;
pub const STATE_SYSTEM_EXTSELECTABLE: u32 = 33554432;
pub const STATE_SYSTEM_ALERT_LOW: u32 = 67108864;
pub const STATE_SYSTEM_ALERT_MEDIUM: u32 = 134217728;
pub const STATE_SYSTEM_ALERT_HIGH: u32 = 268435456;
pub const STATE_SYSTEM_PROTECTED: u32 = 536870912;
pub const STATE_SYSTEM_VALID: u32 = 1073741823;
pub const CCHILDREN_TITLEBAR: u32 = 5;
pub const CCHILDREN_SCROLLBAR: u32 = 5;
pub const CURSOR_SHOWING: u32 = 1;
pub const CURSOR_SUPPRESSED: u32 = 2;
pub const WS_ACTIVECAPTION: u32 = 1;
pub const GA_PARENT: u32 = 1;
pub const GA_ROOT: u32 = 2;
pub const GA_ROOTOWNER: u32 = 3;
pub const RIM_INPUT: u32 = 0;
pub const RIM_INPUTSINK: u32 = 1;
pub const RIM_TYPEMOUSE: u32 = 0;
pub const RIM_TYPEKEYBOARD: u32 = 1;
pub const RIM_TYPEHID: u32 = 2;
pub const RIM_TYPEMAX: u32 = 2;
pub const RI_MOUSE_LEFT_BUTTON_DOWN: u32 = 1;
pub const RI_MOUSE_LEFT_BUTTON_UP: u32 = 2;
pub const RI_MOUSE_RIGHT_BUTTON_DOWN: u32 = 4;
pub const RI_MOUSE_RIGHT_BUTTON_UP: u32 = 8;
pub const RI_MOUSE_MIDDLE_BUTTON_DOWN: u32 = 16;
pub const RI_MOUSE_MIDDLE_BUTTON_UP: u32 = 32;
pub const RI_MOUSE_BUTTON_1_DOWN: u32 = 1;
pub const RI_MOUSE_BUTTON_1_UP: u32 = 2;
pub const RI_MOUSE_BUTTON_2_DOWN: u32 = 4;
pub const RI_MOUSE_BUTTON_2_UP: u32 = 8;
pub const RI_MOUSE_BUTTON_3_DOWN: u32 = 16;
pub const RI_MOUSE_BUTTON_3_UP: u32 = 32;
pub const RI_MOUSE_BUTTON_4_DOWN: u32 = 64;
pub const RI_MOUSE_BUTTON_4_UP: u32 = 128;
pub const RI_MOUSE_BUTTON_5_DOWN: u32 = 256;
pub const RI_MOUSE_BUTTON_5_UP: u32 = 512;
pub const RI_MOUSE_WHEEL: u32 = 1024;
pub const RI_MOUSE_HWHEEL: u32 = 2048;
pub const MOUSE_MOVE_RELATIVE: u32 = 0;
pub const MOUSE_MOVE_ABSOLUTE: u32 = 1;
pub const MOUSE_VIRTUAL_DESKTOP: u32 = 2;
pub const MOUSE_ATTRIBUTES_CHANGED: u32 = 4;
pub const MOUSE_MOVE_NOCOALESCE: u32 = 8;
pub const KEYBOARD_OVERRUN_MAKE_CODE: u32 = 255;
pub const RI_KEY_MAKE: u32 = 0;
pub const RI_KEY_BREAK: u32 = 1;
pub const RI_KEY_E0: u32 = 2;
pub const RI_KEY_E1: u32 = 4;
pub const RI_KEY_TERMSRV_SET_LED: u32 = 8;
pub const RI_KEY_TERMSRV_SHADOW: u32 = 16;
pub const RID_INPUT: u32 = 268435459;
pub const RID_HEADER: u32 = 268435461;
pub const RIDI_PREPARSEDDATA: u32 = 536870917;
pub const RIDI_DEVICENAME: u32 = 536870919;
pub const RIDI_DEVICEINFO: u32 = 536870923;
pub const RIDEV_REMOVE: u32 = 1;
pub const RIDEV_EXCLUDE: u32 = 16;
pub const RIDEV_PAGEONLY: u32 = 32;
pub const RIDEV_NOLEGACY: u32 = 48;
pub const RIDEV_INPUTSINK: u32 = 256;
pub const RIDEV_CAPTUREMOUSE: u32 = 512;
pub const RIDEV_NOHOTKEYS: u32 = 512;
pub const RIDEV_APPKEYS: u32 = 1024;
pub const RIDEV_EXINPUTSINK: u32 = 4096;
pub const RIDEV_DEVNOTIFY: u32 = 8192;
pub const RIDEV_EXMODEMASK: u32 = 240;
pub const GIDC_ARRIVAL: u32 = 1;
pub const GIDC_REMOVAL: u32 = 2;
pub const POINTER_DEVICE_PRODUCT_STRING_MAX: u32 = 520;
pub const PDC_ARRIVAL: u32 = 1;
pub const PDC_REMOVAL: u32 = 2;
pub const PDC_ORIENTATION_0: u32 = 4;
pub const PDC_ORIENTATION_90: u32 = 8;
pub const PDC_ORIENTATION_180: u32 = 16;
pub const PDC_ORIENTATION_270: u32 = 32;
pub const PDC_MODE_DEFAULT: u32 = 64;
pub const PDC_MODE_CENTERED: u32 = 128;
pub const PDC_MAPPING_CHANGE: u32 = 256;
pub const PDC_RESOLUTION: u32 = 512;
pub const PDC_ORIGIN: u32 = 1024;
pub const PDC_MODE_ASPECTRATIOPRESERVED: u32 = 2048;
pub const MSGFLT_ADD: u32 = 1;
pub const MSGFLT_REMOVE: u32 = 2;
pub const MSGFLTINFO_NONE: u32 = 0;
pub const MSGFLTINFO_ALREADYALLOWED_FORWND: u32 = 1;
pub const MSGFLTINFO_ALREADYDISALLOWED_FORWND: u32 = 2;
pub const MSGFLTINFO_ALLOWED_HIGHER: u32 = 3;
pub const MSGFLT_RESET: u32 = 0;
pub const MSGFLT_ALLOW: u32 = 1;
pub const MSGFLT_DISALLOW: u32 = 2;
pub const GF_BEGIN: u32 = 1;
pub const GF_INERTIA: u32 = 2;
pub const GF_END: u32 = 4;
pub const GID_BEGIN: u32 = 1;
pub const GID_END: u32 = 2;
pub const GID_ZOOM: u32 = 3;
pub const GID_PAN: u32 = 4;
pub const GID_ROTATE: u32 = 5;
pub const GID_TWOFINGERTAP: u32 = 6;
pub const GID_PRESSANDTAP: u32 = 7;
pub const GID_ROLLOVER: u32 = 7;
pub const GC_ALLGESTURES: u32 = 1;
pub const GC_ZOOM: u32 = 1;
pub const GC_PAN: u32 = 1;
pub const GC_PAN_WITH_SINGLE_FINGER_VERTICALLY: u32 = 2;
pub const GC_PAN_WITH_SINGLE_FINGER_HORIZONTALLY: u32 = 4;
pub const GC_PAN_WITH_GUTTER: u32 = 8;
pub const GC_PAN_WITH_INERTIA: u32 = 16;
pub const GC_ROTATE: u32 = 1;
pub const GC_TWOFINGERTAP: u32 = 1;
pub const GC_PRESSANDTAP: u32 = 1;
pub const GC_ROLLOVER: u32 = 1;
pub const GESTURECONFIGMAXCOUNT: u32 = 256;
pub const GCF_INCLUDE_ANCESTORS: u32 = 1;
pub const NID_INTEGRATED_TOUCH: u32 = 1;
pub const NID_EXTERNAL_TOUCH: u32 = 2;
pub const NID_INTEGRATED_PEN: u32 = 4;
pub const NID_EXTERNAL_PEN: u32 = 8;
pub const NID_MULTI_INPUT: u32 = 64;
pub const NID_READY: u32 = 128;
pub const MAX_STR_BLOCKREASON: u32 = 256;
pub const MAX_LEADBYTES: u32 = 12;
pub const MAX_DEFAULTCHAR: u32 = 2;
pub const HIGH_SURROGATE_START: u32 = 55296;
pub const HIGH_SURROGATE_END: u32 = 56319;
pub const LOW_SURROGATE_START: u32 = 56320;
pub const LOW_SURROGATE_END: u32 = 57343;
pub const MB_PRECOMPOSED: u32 = 1;
pub const MB_COMPOSITE: u32 = 2;
pub const MB_USEGLYPHCHARS: u32 = 4;
pub const MB_ERR_INVALID_CHARS: u32 = 8;
pub const WC_COMPOSITECHECK: u32 = 512;
pub const WC_DISCARDNS: u32 = 16;
pub const WC_SEPCHARS: u32 = 32;
pub const WC_DEFAULTCHAR: u32 = 64;
pub const WC_ERR_INVALID_CHARS: u32 = 128;
pub const WC_NO_BEST_FIT_CHARS: u32 = 1024;
pub const CT_CTYPE1: u32 = 1;
pub const CT_CTYPE2: u32 = 2;
pub const CT_CTYPE3: u32 = 4;
pub const C1_UPPER: u32 = 1;
pub const C1_LOWER: u32 = 2;
pub const C1_DIGIT: u32 = 4;
pub const C1_SPACE: u32 = 8;
pub const C1_PUNCT: u32 = 16;
pub const C1_CNTRL: u32 = 32;
pub const C1_BLANK: u32 = 64;
pub const C1_XDIGIT: u32 = 128;
pub const C1_ALPHA: u32 = 256;
pub const C1_DEFINED: u32 = 512;
pub const C2_LEFTTORIGHT: u32 = 1;
pub const C2_RIGHTTOLEFT: u32 = 2;
pub const C2_EUROPENUMBER: u32 = 3;
pub const C2_EUROPESEPARATOR: u32 = 4;
pub const C2_EUROPETERMINATOR: u32 = 5;
pub const C2_ARABICNUMBER: u32 = 6;
pub const C2_COMMONSEPARATOR: u32 = 7;
pub const C2_BLOCKSEPARATOR: u32 = 8;
pub const C2_SEGMENTSEPARATOR: u32 = 9;
pub const C2_WHITESPACE: u32 = 10;
pub const C2_OTHERNEUTRAL: u32 = 11;
pub const C2_NOTAPPLICABLE: u32 = 0;
pub const C3_NONSPACING: u32 = 1;
pub const C3_DIACRITIC: u32 = 2;
pub const C3_VOWELMARK: u32 = 4;
pub const C3_SYMBOL: u32 = 8;
pub const C3_KATAKANA: u32 = 16;
pub const C3_HIRAGANA: u32 = 32;
pub const C3_HALFWIDTH: u32 = 64;
pub const C3_FULLWIDTH: u32 = 128;
pub const C3_IDEOGRAPH: u32 = 256;
pub const C3_KASHIDA: u32 = 512;
pub const C3_LEXICAL: u32 = 1024;
pub const C3_HIGHSURROGATE: u32 = 2048;
pub const C3_LOWSURROGATE: u32 = 4096;
pub const C3_ALPHA: u32 = 32768;
pub const C3_NOTAPPLICABLE: u32 = 0;
pub const NORM_IGNORECASE: u32 = 1;
pub const NORM_IGNORENONSPACE: u32 = 2;
pub const NORM_IGNORESYMBOLS: u32 = 4;
pub const LINGUISTIC_IGNORECASE: u32 = 16;
pub const LINGUISTIC_IGNOREDIACRITIC: u32 = 32;
pub const NORM_IGNOREKANATYPE: u32 = 65536;
pub const NORM_IGNOREWIDTH: u32 = 131072;
pub const NORM_LINGUISTIC_CASING: u32 = 134217728;
pub const MAP_FOLDCZONE: u32 = 16;
pub const MAP_PRECOMPOSED: u32 = 32;
pub const MAP_COMPOSITE: u32 = 64;
pub const MAP_FOLDDIGITS: u32 = 128;
pub const MAP_EXPAND_LIGATURES: u32 = 8192;
pub const LCMAP_LOWERCASE: u32 = 256;
pub const LCMAP_UPPERCASE: u32 = 512;
pub const LCMAP_TITLECASE: u32 = 768;
pub const LCMAP_SORTKEY: u32 = 1024;
pub const LCMAP_BYTEREV: u32 = 2048;
pub const LCMAP_HIRAGANA: u32 = 1048576;
pub const LCMAP_KATAKANA: u32 = 2097152;
pub const LCMAP_HALFWIDTH: u32 = 4194304;
pub const LCMAP_FULLWIDTH: u32 = 8388608;
pub const LCMAP_LINGUISTIC_CASING: u32 = 16777216;
pub const LCMAP_SIMPLIFIED_CHINESE: u32 = 33554432;
pub const LCMAP_TRADITIONAL_CHINESE: u32 = 67108864;
pub const LCMAP_SORTHANDLE: u32 = 536870912;
pub const LCMAP_HASH: u32 = 262144;
pub const FIND_STARTSWITH: u32 = 1048576;
pub const FIND_ENDSWITH: u32 = 2097152;
pub const FIND_FROMSTART: u32 = 4194304;
pub const FIND_FROMEND: u32 = 8388608;
pub const LGRPID_INSTALLED: u32 = 1;
pub const LGRPID_SUPPORTED: u32 = 2;
pub const LCID_INSTALLED: u32 = 1;
pub const LCID_SUPPORTED: u32 = 2;
pub const LCID_ALTERNATE_SORTS: u32 = 4;
pub const LOCALE_ALL: u32 = 0;
pub const LOCALE_WINDOWS: u32 = 1;
pub const LOCALE_SUPPLEMENTAL: u32 = 2;
pub const LOCALE_ALTERNATE_SORTS: u32 = 4;
pub const LOCALE_REPLACEMENT: u32 = 8;
pub const LOCALE_NEUTRALDATA: u32 = 16;
pub const LOCALE_SPECIFICDATA: u32 = 32;
pub const CP_INSTALLED: u32 = 1;
pub const CP_SUPPORTED: u32 = 2;
pub const SORT_STRINGSORT: u32 = 4096;
pub const SORT_DIGITSASNUMBERS: u32 = 8;
pub const CSTR_LESS_THAN: u32 = 1;
pub const CSTR_EQUAL: u32 = 2;
pub const CSTR_GREATER_THAN: u32 = 3;
pub const CP_ACP: u32 = 0;
pub const CP_OEMCP: u32 = 1;
pub const CP_MACCP: u32 = 2;
pub const CP_THREAD_ACP: u32 = 3;
pub const CP_SYMBOL: u32 = 42;
pub const CP_UTF7: u32 = 65000;
pub const CP_UTF8: u32 = 65001;
pub const CTRY_DEFAULT: u32 = 0;
pub const CTRY_ALBANIA: u32 = 355;
pub const CTRY_ALGERIA: u32 = 213;
pub const CTRY_ARGENTINA: u32 = 54;
pub const CTRY_ARMENIA: u32 = 374;
pub const CTRY_AUSTRALIA: u32 = 61;
pub const CTRY_AUSTRIA: u32 = 43;
pub const CTRY_AZERBAIJAN: u32 = 994;
pub const CTRY_BAHRAIN: u32 = 973;
pub const CTRY_BELARUS: u32 = 375;
pub const CTRY_BELGIUM: u32 = 32;
pub const CTRY_BELIZE: u32 = 501;
pub const CTRY_BOLIVIA: u32 = 591;
pub const CTRY_BRAZIL: u32 = 55;
pub const CTRY_BRUNEI_DARUSSALAM: u32 = 673;
pub const CTRY_BULGARIA: u32 = 359;
pub const CTRY_CANADA: u32 = 2;
pub const CTRY_CARIBBEAN: u32 = 1;
pub const CTRY_CHILE: u32 = 56;
pub const CTRY_COLOMBIA: u32 = 57;
pub const CTRY_COSTA_RICA: u32 = 506;
pub const CTRY_CROATIA: u32 = 385;
pub const CTRY_CZECH: u32 = 420;
pub const CTRY_DENMARK: u32 = 45;
pub const CTRY_DOMINICAN_REPUBLIC: u32 = 1;
pub const CTRY_ECUADOR: u32 = 593;
pub const CTRY_EGYPT: u32 = 20;
pub const CTRY_EL_SALVADOR: u32 = 503;
pub const CTRY_ESTONIA: u32 = 372;
pub const CTRY_FAEROE_ISLANDS: u32 = 298;
pub const CTRY_FINLAND: u32 = 358;
pub const CTRY_FRANCE: u32 = 33;
pub const CTRY_GEORGIA: u32 = 995;
pub const CTRY_GERMANY: u32 = 49;
pub const CTRY_GREECE: u32 = 30;
pub const CTRY_GUATEMALA: u32 = 502;
pub const CTRY_HONDURAS: u32 = 504;
pub const CTRY_HONG_KONG: u32 = 852;
pub const CTRY_HUNGARY: u32 = 36;
pub const CTRY_ICELAND: u32 = 354;
pub const CTRY_INDIA: u32 = 91;
pub const CTRY_INDONESIA: u32 = 62;
pub const CTRY_IRAN: u32 = 981;
pub const CTRY_IRAQ: u32 = 964;
pub const CTRY_IRELAND: u32 = 353;
pub const CTRY_ISRAEL: u32 = 972;
pub const CTRY_ITALY: u32 = 39;
pub const CTRY_JAMAICA: u32 = 1;
pub const CTRY_JAPAN: u32 = 81;
pub const CTRY_JORDAN: u32 = 962;
pub const CTRY_KAZAKSTAN: u32 = 7;
pub const CTRY_KENYA: u32 = 254;
pub const CTRY_KUWAIT: u32 = 965;
pub const CTRY_KYRGYZSTAN: u32 = 996;
pub const CTRY_LATVIA: u32 = 371;
pub const CTRY_LEBANON: u32 = 961;
pub const CTRY_LIBYA: u32 = 218;
pub const CTRY_LIECHTENSTEIN: u32 = 41;
pub const CTRY_LITHUANIA: u32 = 370;
pub const CTRY_LUXEMBOURG: u32 = 352;
pub const CTRY_MACAU: u32 = 853;
pub const CTRY_MACEDONIA: u32 = 389;
pub const CTRY_MALAYSIA: u32 = 60;
pub const CTRY_MALDIVES: u32 = 960;
pub const CTRY_MEXICO: u32 = 52;
pub const CTRY_MONACO: u32 = 33;
pub const CTRY_MONGOLIA: u32 = 976;
pub const CTRY_MOROCCO: u32 = 212;
pub const CTRY_NETHERLANDS: u32 = 31;
pub const CTRY_NEW_ZEALAND: u32 = 64;
pub const CTRY_NICARAGUA: u32 = 505;
pub const CTRY_NORWAY: u32 = 47;
pub const CTRY_OMAN: u32 = 968;
pub const CTRY_PAKISTAN: u32 = 92;
pub const CTRY_PANAMA: u32 = 507;
pub const CTRY_PARAGUAY: u32 = 595;
pub const CTRY_PERU: u32 = 51;
pub const CTRY_PHILIPPINES: u32 = 63;
pub const CTRY_POLAND: u32 = 48;
pub const CTRY_PORTUGAL: u32 = 351;
pub const CTRY_PRCHINA: u32 = 86;
pub const CTRY_PUERTO_RICO: u32 = 1;
pub const CTRY_QATAR: u32 = 974;
pub const CTRY_ROMANIA: u32 = 40;
pub const CTRY_RUSSIA: u32 = 7;
pub const CTRY_SAUDI_ARABIA: u32 = 966;
pub const CTRY_SERBIA: u32 = 381;
pub const CTRY_SINGAPORE: u32 = 65;
pub const CTRY_SLOVAK: u32 = 421;
pub const CTRY_SLOVENIA: u32 = 386;
pub const CTRY_SOUTH_AFRICA: u32 = 27;
pub const CTRY_SOUTH_KOREA: u32 = 82;
pub const CTRY_SPAIN: u32 = 34;
pub const CTRY_SWEDEN: u32 = 46;
pub const CTRY_SWITZERLAND: u32 = 41;
pub const CTRY_SYRIA: u32 = 963;
pub const CTRY_TAIWAN: u32 = 886;
pub const CTRY_TATARSTAN: u32 = 7;
pub const CTRY_THAILAND: u32 = 66;
pub const CTRY_TRINIDAD_Y_TOBAGO: u32 = 1;
pub const CTRY_TUNISIA: u32 = 216;
pub const CTRY_TURKEY: u32 = 90;
pub const CTRY_UAE: u32 = 971;
pub const CTRY_UKRAINE: u32 = 380;
pub const CTRY_UNITED_KINGDOM: u32 = 44;
pub const CTRY_UNITED_STATES: u32 = 1;
pub const CTRY_URUGUAY: u32 = 598;
pub const CTRY_UZBEKISTAN: u32 = 7;
pub const CTRY_VENEZUELA: u32 = 58;
pub const CTRY_VIET_NAM: u32 = 84;
pub const CTRY_YEMEN: u32 = 967;
pub const CTRY_ZIMBABWE: u32 = 263;
pub const LOCALE_NOUSEROVERRIDE: u32 = 2147483648;
pub const LOCALE_USE_CP_ACP: u32 = 1073741824;
pub const LOCALE_RETURN_NUMBER: u32 = 536870912;
pub const LOCALE_RETURN_GENITIVE_NAMES: u32 = 268435456;
pub const LOCALE_ALLOW_NEUTRAL_NAMES: u32 = 134217728;
pub const LOCALE_SLOCALIZEDDISPLAYNAME: u32 = 2;
pub const LOCALE_SENGLISHDISPLAYNAME: u32 = 114;
pub const LOCALE_SNATIVEDISPLAYNAME: u32 = 115;
pub const LOCALE_SLOCALIZEDLANGUAGENAME: u32 = 111;
pub const LOCALE_SENGLISHLANGUAGENAME: u32 = 4097;
pub const LOCALE_SNATIVELANGUAGENAME: u32 = 4;
pub const LOCALE_SLOCALIZEDCOUNTRYNAME: u32 = 6;
pub const LOCALE_SENGLISHCOUNTRYNAME: u32 = 4098;
pub const LOCALE_SNATIVECOUNTRYNAME: u32 = 8;
pub const LOCALE_IDIALINGCODE: u32 = 5;
pub const LOCALE_SLIST: u32 = 12;
pub const LOCALE_IMEASURE: u32 = 13;
pub const LOCALE_SDECIMAL: u32 = 14;
pub const LOCALE_STHOUSAND: u32 = 15;
pub const LOCALE_SGROUPING: u32 = 16;
pub const LOCALE_IDIGITS: u32 = 17;
pub const LOCALE_ILZERO: u32 = 18;
pub const LOCALE_INEGNUMBER: u32 = 4112;
pub const LOCALE_SNATIVEDIGITS: u32 = 19;
pub const LOCALE_SCURRENCY: u32 = 20;
pub const LOCALE_SINTLSYMBOL: u32 = 21;
pub const LOCALE_SMONDECIMALSEP: u32 = 22;
pub const LOCALE_SMONTHOUSANDSEP: u32 = 23;
pub const LOCALE_SMONGROUPING: u32 = 24;
pub const LOCALE_ICURRDIGITS: u32 = 25;
pub const LOCALE_ICURRENCY: u32 = 27;
pub const LOCALE_INEGCURR: u32 = 28;
pub const LOCALE_SSHORTDATE: u32 = 31;
pub const LOCALE_SLONGDATE: u32 = 32;
pub const LOCALE_STIMEFORMAT: u32 = 4099;
pub const LOCALE_SAM: u32 = 40;
pub const LOCALE_SPM: u32 = 41;
pub const LOCALE_ICALENDARTYPE: u32 = 4105;
pub const LOCALE_IOPTIONALCALENDAR: u32 = 4107;
pub const LOCALE_IFIRSTDAYOFWEEK: u32 = 4108;
pub const LOCALE_IFIRSTWEEKOFYEAR: u32 = 4109;
pub const LOCALE_SDAYNAME1: u32 = 42;
pub const LOCALE_SDAYNAME2: u32 = 43;
pub const LOCALE_SDAYNAME3: u32 = 44;
pub const LOCALE_SDAYNAME4: u32 = 45;
pub const LOCALE_SDAYNAME5: u32 = 46;
pub const LOCALE_SDAYNAME6: u32 = 47;
pub const LOCALE_SDAYNAME7: u32 = 48;
pub const LOCALE_SABBREVDAYNAME1: u32 = 49;
pub const LOCALE_SABBREVDAYNAME2: u32 = 50;
pub const LOCALE_SABBREVDAYNAME3: u32 = 51;
pub const LOCALE_SABBREVDAYNAME4: u32 = 52;
pub const LOCALE_SABBREVDAYNAME5: u32 = 53;
pub const LOCALE_SABBREVDAYNAME6: u32 = 54;
pub const LOCALE_SABBREVDAYNAME7: u32 = 55;
pub const LOCALE_SMONTHNAME1: u32 = 56;
pub const LOCALE_SMONTHNAME2: u32 = 57;
pub const LOCALE_SMONTHNAME3: u32 = 58;
pub const LOCALE_SMONTHNAME4: u32 = 59;
pub const LOCALE_SMONTHNAME5: u32 = 60;
pub const LOCALE_SMONTHNAME6: u32 = 61;
pub const LOCALE_SMONTHNAME7: u32 = 62;
pub const LOCALE_SMONTHNAME8: u32 = 63;
pub const LOCALE_SMONTHNAME9: u32 = 64;
pub const LOCALE_SMONTHNAME10: u32 = 65;
pub const LOCALE_SMONTHNAME11: u32 = 66;
pub const LOCALE_SMONTHNAME12: u32 = 67;
pub const LOCALE_SMONTHNAME13: u32 = 4110;
pub const LOCALE_SABBREVMONTHNAME1: u32 = 68;
pub const LOCALE_SABBREVMONTHNAME2: u32 = 69;
pub const LOCALE_SABBREVMONTHNAME3: u32 = 70;
pub const LOCALE_SABBREVMONTHNAME4: u32 = 71;
pub const LOCALE_SABBREVMONTHNAME5: u32 = 72;
pub const LOCALE_SABBREVMONTHNAME6: u32 = 73;
pub const LOCALE_SABBREVMONTHNAME7: u32 = 74;
pub const LOCALE_SABBREVMONTHNAME8: u32 = 75;
pub const LOCALE_SABBREVMONTHNAME9: u32 = 76;
pub const LOCALE_SABBREVMONTHNAME10: u32 = 77;
pub const LOCALE_SABBREVMONTHNAME11: u32 = 78;
pub const LOCALE_SABBREVMONTHNAME12: u32 = 79;
pub const LOCALE_SABBREVMONTHNAME13: u32 = 4111;
pub const LOCALE_SPOSITIVESIGN: u32 = 80;
pub const LOCALE_SNEGATIVESIGN: u32 = 81;
pub const LOCALE_IPOSSIGNPOSN: u32 = 82;
pub const LOCALE_INEGSIGNPOSN: u32 = 83;
pub const LOCALE_IPOSSYMPRECEDES: u32 = 84;
pub const LOCALE_IPOSSEPBYSPACE: u32 = 85;
pub const LOCALE_INEGSYMPRECEDES: u32 = 86;
pub const LOCALE_INEGSEPBYSPACE: u32 = 87;
pub const LOCALE_FONTSIGNATURE: u32 = 88;
pub const LOCALE_SISO639LANGNAME: u32 = 89;
pub const LOCALE_SISO3166CTRYNAME: u32 = 90;
pub const LOCALE_IPAPERSIZE: u32 = 4106;
pub const LOCALE_SENGCURRNAME: u32 = 4103;
pub const LOCALE_SNATIVECURRNAME: u32 = 4104;
pub const LOCALE_SYEARMONTH: u32 = 4102;
pub const LOCALE_SSORTNAME: u32 = 4115;
pub const LOCALE_IDIGITSUBSTITUTION: u32 = 4116;
pub const LOCALE_SNAME: u32 = 92;
pub const LOCALE_SDURATION: u32 = 93;
pub const LOCALE_SSHORTESTDAYNAME1: u32 = 96;
pub const LOCALE_SSHORTESTDAYNAME2: u32 = 97;
pub const LOCALE_SSHORTESTDAYNAME3: u32 = 98;
pub const LOCALE_SSHORTESTDAYNAME4: u32 = 99;
pub const LOCALE_SSHORTESTDAYNAME5: u32 = 100;
pub const LOCALE_SSHORTESTDAYNAME6: u32 = 101;
pub const LOCALE_SSHORTESTDAYNAME7: u32 = 102;
pub const LOCALE_SISO639LANGNAME2: u32 = 103;
pub const LOCALE_SISO3166CTRYNAME2: u32 = 104;
pub const LOCALE_SNAN: u32 = 105;
pub const LOCALE_SPOSINFINITY: u32 = 106;
pub const LOCALE_SNEGINFINITY: u32 = 107;
pub const LOCALE_SSCRIPTS: u32 = 108;
pub const LOCALE_SPARENT: u32 = 109;
pub const LOCALE_SCONSOLEFALLBACKNAME: u32 = 110;
pub const LOCALE_IREADINGLAYOUT: u32 = 112;
pub const LOCALE_INEUTRAL: u32 = 113;
pub const LOCALE_INEGATIVEPERCENT: u32 = 116;
pub const LOCALE_IPOSITIVEPERCENT: u32 = 117;
pub const LOCALE_SPERCENT: u32 = 118;
pub const LOCALE_SPERMILLE: u32 = 119;
pub const LOCALE_SMONTHDAY: u32 = 120;
pub const LOCALE_SSHORTTIME: u32 = 121;
pub const LOCALE_SOPENTYPELANGUAGETAG: u32 = 122;
pub const LOCALE_SSORTLOCALE: u32 = 123;
pub const LOCALE_SRELATIVELONGDATE: u32 = 124;
pub const LOCALE_ICONSTRUCTEDLOCALE: u32 = 125;
pub const LOCALE_SSHORTESTAM: u32 = 126;
pub const LOCALE_SSHORTESTPM: u32 = 127;
pub const LOCALE_IUSEUTF8LEGACYACP: u32 = 1638;
pub const LOCALE_IUSEUTF8LEGACYOEMCP: u32 = 2457;
pub const LOCALE_IDEFAULTCODEPAGE: u32 = 11;
pub const LOCALE_IDEFAULTANSICODEPAGE: u32 = 4100;
pub const LOCALE_IDEFAULTMACCODEPAGE: u32 = 4113;
pub const LOCALE_IDEFAULTEBCDICCODEPAGE: u32 = 4114;
pub const LOCALE_ILANGUAGE: u32 = 1;
pub const LOCALE_SABBREVLANGNAME: u32 = 3;
pub const LOCALE_SABBREVCTRYNAME: u32 = 7;
pub const LOCALE_IGEOID: u32 = 91;
pub const LOCALE_IDEFAULTLANGUAGE: u32 = 9;
pub const LOCALE_IDEFAULTCOUNTRY: u32 = 10;
pub const LOCALE_IINTLCURRDIGITS: u32 = 26;
pub const LOCALE_SDATE: u32 = 29;
pub const LOCALE_STIME: u32 = 30;
pub const LOCALE_IDATE: u32 = 33;
pub const LOCALE_ILDATE: u32 = 34;
pub const LOCALE_ITIME: u32 = 35;
pub const LOCALE_ITIMEMARKPOSN: u32 = 4101;
pub const LOCALE_ICENTURY: u32 = 36;
pub const LOCALE_ITLZERO: u32 = 37;
pub const LOCALE_IDAYLZERO: u32 = 38;
pub const LOCALE_IMONLZERO: u32 = 39;
pub const LOCALE_SKEYBOARDSTOINSTALL: u32 = 94;
pub const LOCALE_SLANGUAGE: u32 = 2;
pub const LOCALE_SLANGDISPLAYNAME: u32 = 111;
pub const LOCALE_SENGLANGUAGE: u32 = 4097;
pub const LOCALE_SNATIVELANGNAME: u32 = 4;
pub const LOCALE_SCOUNTRY: u32 = 6;
pub const LOCALE_SENGCOUNTRY: u32 = 4098;
pub const LOCALE_SNATIVECTRYNAME: u32 = 8;
pub const LOCALE_ICOUNTRY: u32 = 5;
pub const LOCALE_S1159: u32 = 40;
pub const LOCALE_S2359: u32 = 41;
pub const TIME_NOMINUTESORSECONDS: u32 = 1;
pub const TIME_NOSECONDS: u32 = 2;
pub const TIME_NOTIMEMARKER: u32 = 4;
pub const TIME_FORCE24HOURFORMAT: u32 = 8;
pub const DATE_SHORTDATE: u32 = 1;
pub const DATE_LONGDATE: u32 = 2;
pub const DATE_USE_ALT_CALENDAR: u32 = 4;
pub const DATE_YEARMONTH: u32 = 8;
pub const DATE_LTRREADING: u32 = 16;
pub const DATE_RTLREADING: u32 = 32;
pub const DATE_AUTOLAYOUT: u32 = 64;
pub const DATE_MONTHDAY: u32 = 128;
pub const CAL_NOUSEROVERRIDE: u32 = 2147483648;
pub const CAL_USE_CP_ACP: u32 = 1073741824;
pub const CAL_RETURN_NUMBER: u32 = 536870912;
pub const CAL_RETURN_GENITIVE_NAMES: u32 = 268435456;
pub const CAL_ICALINTVALUE: u32 = 1;
pub const CAL_SCALNAME: u32 = 2;
pub const CAL_IYEAROFFSETRANGE: u32 = 3;
pub const CAL_SERASTRING: u32 = 4;
pub const CAL_SSHORTDATE: u32 = 5;
pub const CAL_SLONGDATE: u32 = 6;
pub const CAL_SDAYNAME1: u32 = 7;
pub const CAL_SDAYNAME2: u32 = 8;
pub const CAL_SDAYNAME3: u32 = 9;
pub const CAL_SDAYNAME4: u32 = 10;
pub const CAL_SDAYNAME5: u32 = 11;
pub const CAL_SDAYNAME6: u32 = 12;
pub const CAL_SDAYNAME7: u32 = 13;
pub const CAL_SABBREVDAYNAME1: u32 = 14;
pub const CAL_SABBREVDAYNAME2: u32 = 15;
pub const CAL_SABBREVDAYNAME3: u32 = 16;
pub const CAL_SABBREVDAYNAME4: u32 = 17;
pub const CAL_SABBREVDAYNAME5: u32 = 18;
pub const CAL_SABBREVDAYNAME6: u32 = 19;
pub const CAL_SABBREVDAYNAME7: u32 = 20;
pub const CAL_SMONTHNAME1: u32 = 21;
pub const CAL_SMONTHNAME2: u32 = 22;
pub const CAL_SMONTHNAME3: u32 = 23;
pub const CAL_SMONTHNAME4: u32 = 24;
pub const CAL_SMONTHNAME5: u32 = 25;
pub const CAL_SMONTHNAME6: u32 = 26;
pub const CAL_SMONTHNAME7: u32 = 27;
pub const CAL_SMONTHNAME8: u32 = 28;
pub const CAL_SMONTHNAME9: u32 = 29;
pub const CAL_SMONTHNAME10: u32 = 30;
pub const CAL_SMONTHNAME11: u32 = 31;
pub const CAL_SMONTHNAME12: u32 = 32;
pub const CAL_SMONTHNAME13: u32 = 33;
pub const CAL_SABBREVMONTHNAME1: u32 = 34;
pub const CAL_SABBREVMONTHNAME2: u32 = 35;
pub const CAL_SABBREVMONTHNAME3: u32 = 36;
pub const CAL_SABBREVMONTHNAME4: u32 = 37;
pub const CAL_SABBREVMONTHNAME5: u32 = 38;
pub const CAL_SABBREVMONTHNAME6: u32 = 39;
pub const CAL_SABBREVMONTHNAME7: u32 = 40;
pub const CAL_SABBREVMONTHNAME8: u32 = 41;
pub const CAL_SABBREVMONTHNAME9: u32 = 42;
pub const CAL_SABBREVMONTHNAME10: u32 = 43;
pub const CAL_SABBREVMONTHNAME11: u32 = 44;
pub const CAL_SABBREVMONTHNAME12: u32 = 45;
pub const CAL_SABBREVMONTHNAME13: u32 = 46;
pub const CAL_SYEARMONTH: u32 = 47;
pub const CAL_ITWODIGITYEARMAX: u32 = 48;
pub const CAL_SSHORTESTDAYNAME1: u32 = 49;
pub const CAL_SSHORTESTDAYNAME2: u32 = 50;
pub const CAL_SSHORTESTDAYNAME3: u32 = 51;
pub const CAL_SSHORTESTDAYNAME4: u32 = 52;
pub const CAL_SSHORTESTDAYNAME5: u32 = 53;
pub const CAL_SSHORTESTDAYNAME6: u32 = 54;
pub const CAL_SSHORTESTDAYNAME7: u32 = 55;
pub const CAL_SMONTHDAY: u32 = 56;
pub const CAL_SABBREVERASTRING: u32 = 57;
pub const CAL_SRELATIVELONGDATE: u32 = 58;
pub const CAL_SENGLISHERANAME: u32 = 59;
pub const CAL_SENGLISHABBREVERANAME: u32 = 60;
pub const CAL_SJAPANESEERAFIRSTYEAR: u32 = 61;
pub const ENUM_ALL_CALENDARS: u32 = 4294967295;
pub const CAL_GREGORIAN: u32 = 1;
pub const CAL_GREGORIAN_US: u32 = 2;
pub const CAL_JAPAN: u32 = 3;
pub const CAL_TAIWAN: u32 = 4;
pub const CAL_KOREA: u32 = 5;
pub const CAL_HIJRI: u32 = 6;
pub const CAL_THAI: u32 = 7;
pub const CAL_HEBREW: u32 = 8;
pub const CAL_GREGORIAN_ME_FRENCH: u32 = 9;
pub const CAL_GREGORIAN_ARABIC: u32 = 10;
pub const CAL_GREGORIAN_XLIT_ENGLISH: u32 = 11;
pub const CAL_GREGORIAN_XLIT_FRENCH: u32 = 12;
pub const CAL_PERSIAN: u32 = 22;
pub const CAL_UMALQURA: u32 = 23;
pub const LGRPID_WESTERN_EUROPE: u32 = 1;
pub const LGRPID_CENTRAL_EUROPE: u32 = 2;
pub const LGRPID_BALTIC: u32 = 3;
pub const LGRPID_GREEK: u32 = 4;
pub const LGRPID_CYRILLIC: u32 = 5;
pub const LGRPID_TURKIC: u32 = 6;
pub const LGRPID_TURKISH: u32 = 6;
pub const LGRPID_JAPANESE: u32 = 7;
pub const LGRPID_KOREAN: u32 = 8;
pub const LGRPID_TRADITIONAL_CHINESE: u32 = 9;
pub const LGRPID_SIMPLIFIED_CHINESE: u32 = 10;
pub const LGRPID_THAI: u32 = 11;
pub const LGRPID_HEBREW: u32 = 12;
pub const LGRPID_ARABIC: u32 = 13;
pub const LGRPID_VIETNAMESE: u32 = 14;
pub const LGRPID_INDIC: u32 = 15;
pub const LGRPID_GEORGIAN: u32 = 16;
pub const LGRPID_ARMENIAN: u32 = 17;
pub const MUI_LANGUAGE_ID: u32 = 4;
pub const MUI_LANGUAGE_NAME: u32 = 8;
pub const MUI_MERGE_SYSTEM_FALLBACK: u32 = 16;
pub const MUI_MERGE_USER_FALLBACK: u32 = 32;
pub const MUI_UI_FALLBACK: u32 = 48;
pub const MUI_THREAD_LANGUAGES: u32 = 64;
pub const MUI_CONSOLE_FILTER: u32 = 256;
pub const MUI_COMPLEX_SCRIPT_FILTER: u32 = 512;
pub const MUI_RESET_FILTERS: u32 = 1;
pub const MUI_USER_PREFERRED_UI_LANGUAGES: u32 = 16;
pub const MUI_USE_INSTALLED_LANGUAGES: u32 = 32;
pub const MUI_USE_SEARCH_ALL_LANGUAGES: u32 = 64;
pub const MUI_LANG_NEUTRAL_PE_FILE: u32 = 256;
pub const MUI_NON_LANG_NEUTRAL_FILE: u32 = 512;
pub const MUI_MACHINE_LANGUAGE_SETTINGS: u32 = 1024;
pub const MUI_FILETYPE_NOT_LANGUAGE_NEUTRAL: u32 = 1;
pub const MUI_FILETYPE_LANGUAGE_NEUTRAL_MAIN: u32 = 2;
pub const MUI_FILETYPE_LANGUAGE_NEUTRAL_MUI: u32 = 4;
pub const MUI_QUERY_TYPE: u32 = 1;
pub const MUI_QUERY_CHECKSUM: u32 = 2;
pub const MUI_QUERY_LANGUAGE_NAME: u32 = 4;
pub const MUI_QUERY_RESOURCE_TYPES: u32 = 8;
pub const MUI_FILEINFO_VERSION: u32 = 1;
pub const MUI_FULL_LANGUAGE: u32 = 1;
pub const MUI_PARTIAL_LANGUAGE: u32 = 2;
pub const MUI_LIP_LANGUAGE: u32 = 4;
pub const MUI_LANGUAGE_INSTALLED: u32 = 32;
pub const MUI_LANGUAGE_LICENSED: u32 = 64;
pub const GEOID_NOT_AVAILABLE: i32 = -1;
pub const SORTING_PARADIGM_NLS: u32 = 0;
pub const SORTING_PARADIGM_ICU: u32 = 16777216;
pub const IDN_ALLOW_UNASSIGNED: u32 = 1;
pub const IDN_USE_STD3_ASCII_RULES: u32 = 2;
pub const IDN_EMAIL_ADDRESS: u32 = 4;
pub const IDN_RAW_PUNYCODE: u32 = 8;
pub const VS_ALLOW_LATIN: u32 = 1;
pub const GSS_ALLOW_INHERITED_COMMON: u32 = 1;
pub const MUI_FORMAT_REG_COMPAT: u32 = 1;
pub const MUI_FORMAT_INF_COMPAT: u32 = 2;
pub const MUI_VERIFY_FILE_EXISTS: u32 = 4;
pub const MUI_SKIP_STRING_CACHE: u32 = 8;
pub const MUI_IMMUTABLE_LOOKUP: u32 = 16;
pub const LOCALE_NAME_INVARIANT: &[u8; 1] = b"\0";
pub const LOCALE_NAME_SYSTEM_DEFAULT: &[u8; 22] = b"!x-sys-default-locale\0";
pub const RIGHT_ALT_PRESSED: u32 = 1;
pub const LEFT_ALT_PRESSED: u32 = 2;
pub const RIGHT_CTRL_PRESSED: u32 = 4;
pub const LEFT_CTRL_PRESSED: u32 = 8;
pub const SHIFT_PRESSED: u32 = 16;
pub const NUMLOCK_ON: u32 = 32;
pub const SCROLLLOCK_ON: u32 = 64;
pub const CAPSLOCK_ON: u32 = 128;
pub const ENHANCED_KEY: u32 = 256;
pub const NLS_DBCSCHAR: u32 = 65536;
pub const NLS_ALPHANUMERIC: u32 = 0;
pub const NLS_KATAKANA: u32 = 131072;
pub const NLS_HIRAGANA: u32 = 262144;
pub const NLS_ROMAN: u32 = 4194304;
pub const NLS_IME_CONVERSION: u32 = 8388608;
pub const ALTNUMPAD_BIT: u32 = 67108864;
pub const NLS_IME_DISABLE: u32 = 536870912;
pub const FROM_LEFT_1ST_BUTTON_PRESSED: u32 = 1;
pub const RIGHTMOST_BUTTON_PRESSED: u32 = 2;
pub const FROM_LEFT_2ND_BUTTON_PRESSED: u32 = 4;
pub const FROM_LEFT_3RD_BUTTON_PRESSED: u32 = 8;
pub const FROM_LEFT_4TH_BUTTON_PRESSED: u32 = 16;
pub const MOUSE_MOVED: u32 = 1;
pub const DOUBLE_CLICK: u32 = 2;
pub const MOUSE_WHEELED: u32 = 4;
pub const MOUSE_HWHEELED: u32 = 8;
pub const KEY_EVENT: u32 = 1;
pub const MOUSE_EVENT: u32 = 2;
pub const WINDOW_BUFFER_SIZE_EVENT: u32 = 4;
pub const MENU_EVENT: u32 = 8;
pub const FOCUS_EVENT: u32 = 16;
pub const ENABLE_PROCESSED_INPUT: u32 = 1;
pub const ENABLE_LINE_INPUT: u32 = 2;
pub const ENABLE_ECHO_INPUT: u32 = 4;
pub const ENABLE_WINDOW_INPUT: u32 = 8;
pub const ENABLE_MOUSE_INPUT: u32 = 16;
pub const ENABLE_INSERT_MODE: u32 = 32;
pub const ENABLE_QUICK_EDIT_MODE: u32 = 64;
pub const ENABLE_EXTENDED_FLAGS: u32 = 128;
pub const ENABLE_AUTO_POSITION: u32 = 256;
pub const ENABLE_VIRTUAL_TERMINAL_INPUT: u32 = 512;
pub const ENABLE_PROCESSED_OUTPUT: u32 = 1;
pub const ENABLE_WRAP_AT_EOL_OUTPUT: u32 = 2;
pub const ENABLE_VIRTUAL_TERMINAL_PROCESSING: u32 = 4;
pub const DISABLE_NEWLINE_AUTO_RETURN: u32 = 8;
pub const ENABLE_LVB_GRID_WORLDWIDE: u32 = 16;
pub const CTRL_C_EVENT: u32 = 0;
pub const CTRL_BREAK_EVENT: u32 = 1;
pub const CTRL_CLOSE_EVENT: u32 = 2;
pub const CTRL_LOGOFF_EVENT: u32 = 5;
pub const CTRL_SHUTDOWN_EVENT: u32 = 6;
pub const PSEUDOCONSOLE_INHERIT_CURSOR: u32 = 1;
pub const FOREGROUND_BLUE: u32 = 1;
pub const FOREGROUND_GREEN: u32 = 2;
pub const FOREGROUND_RED: u32 = 4;
pub const FOREGROUND_INTENSITY: u32 = 8;
pub const BACKGROUND_BLUE: u32 = 16;
pub const BACKGROUND_GREEN: u32 = 32;
pub const BACKGROUND_RED: u32 = 64;
pub const BACKGROUND_INTENSITY: u32 = 128;
pub const COMMON_LVB_LEADING_BYTE: u32 = 256;
pub const COMMON_LVB_TRAILING_BYTE: u32 = 512;
pub const COMMON_LVB_GRID_HORIZONTAL: u32 = 1024;
pub const COMMON_LVB_GRID_LVERTICAL: u32 = 2048;
pub const COMMON_LVB_GRID_RVERTICAL: u32 = 4096;
pub const COMMON_LVB_REVERSE_VIDEO: u32 = 16384;
pub const COMMON_LVB_UNDERSCORE: u32 = 32768;
pub const COMMON_LVB_SBCSDBCS: u32 = 768;
pub const CONSOLE_NO_SELECTION: u32 = 0;
pub const CONSOLE_SELECTION_IN_PROGRESS: u32 = 1;
pub const CONSOLE_SELECTION_NOT_EMPTY: u32 = 2;
pub const CONSOLE_MOUSE_SELECTION: u32 = 4;
pub const CONSOLE_MOUSE_DOWN: u32 = 8;
pub const HISTORY_NO_DUP_FLAG: u32 = 1;
pub const CONSOLE_FULLSCREEN: u32 = 1;
pub const CONSOLE_FULLSCREEN_HARDWARE: u32 = 2;
pub const CONSOLE_FULLSCREEN_MODE: u32 = 1;
pub const CONSOLE_WINDOWED_MODE: u32 = 2;
pub const CONSOLE_TEXTMODE_BUFFER: u32 = 1;
pub const VS_VERSION_INFO: u32 = 1;
pub const VS_USER_DEFINED: u32 = 100;
pub const VS_FFI_SIGNATURE: u32 = 4277077181;
pub const VS_FFI_STRUCVERSION: u32 = 65536;
pub const VS_FFI_FILEFLAGSMASK: u32 = 63;
pub const VS_FF_DEBUG: u32 = 1;
pub const VS_FF_PRERELEASE: u32 = 2;
pub const VS_FF_PATCHED: u32 = 4;
pub const VS_FF_PRIVATEBUILD: u32 = 8;
pub const VS_FF_INFOINFERRED: u32 = 16;
pub const VS_FF_SPECIALBUILD: u32 = 32;
pub const VOS_UNKNOWN: u32 = 0;
pub const VOS_DOS: u32 = 65536;
pub const VOS_OS216: u32 = 131072;
pub const VOS_OS232: u32 = 196608;
pub const VOS_NT: u32 = 262144;
pub const VOS_WINCE: u32 = 327680;
pub const VOS__BASE: u32 = 0;
pub const VOS__WINDOWS16: u32 = 1;
pub const VOS__PM16: u32 = 2;
pub const VOS__PM32: u32 = 3;
pub const VOS__WINDOWS32: u32 = 4;
pub const VOS_DOS_WINDOWS16: u32 = 65537;
pub const VOS_DOS_WINDOWS32: u32 = 65540;
pub const VOS_OS216_PM16: u32 = 131074;
pub const VOS_OS232_PM32: u32 = 196611;
pub const VOS_NT_WINDOWS32: u32 = 262148;
pub const VFT_UNKNOWN: u32 = 0;
pub const VFT_APP: u32 = 1;
pub const VFT_DLL: u32 = 2;
pub const VFT_DRV: u32 = 3;
pub const VFT_FONT: u32 = 4;
pub const VFT_VXD: u32 = 5;
pub const VFT_STATIC_LIB: u32 = 7;
pub const VFT2_UNKNOWN: u32 = 0;
pub const VFT2_DRV_PRINTER: u32 = 1;
pub const VFT2_DRV_KEYBOARD: u32 = 2;
pub const VFT2_DRV_LANGUAGE: u32 = 3;
pub const VFT2_DRV_DISPLAY: u32 = 4;
pub const VFT2_DRV_MOUSE: u32 = 5;
pub const VFT2_DRV_NETWORK: u32 = 6;
pub const VFT2_DRV_SYSTEM: u32 = 7;
pub const VFT2_DRV_INSTALLABLE: u32 = 8;
pub const VFT2_DRV_SOUND: u32 = 9;
pub const VFT2_DRV_COMM: u32 = 10;
pub const VFT2_DRV_INPUTMETHOD: u32 = 11;
pub const VFT2_DRV_VERSIONED_PRINTER: u32 = 12;
pub const VFT2_FONT_RASTER: u32 = 1;
pub const VFT2_FONT_VECTOR: u32 = 2;
pub const VFT2_FONT_TRUETYPE: u32 = 3;
pub const VFFF_ISSHAREDFILE: u32 = 1;
pub const VFF_CURNEDEST: u32 = 1;
pub const VFF_FILEINUSE: u32 = 2;
pub const VFF_BUFFTOOSMALL: u32 = 4;
pub const VIFF_FORCEINSTALL: u32 = 1;
pub const VIFF_DONTDELETEOLD: u32 = 2;
pub const VIF_TEMPFILE: u32 = 1;
pub const VIF_MISMATCH: u32 = 2;
pub const VIF_SRCOLD: u32 = 4;
pub const VIF_DIFFLANG: u32 = 8;
pub const VIF_DIFFCODEPG: u32 = 16;
pub const VIF_DIFFTYPE: u32 = 32;
pub const VIF_WRITEPROT: u32 = 64;
pub const VIF_FILEINUSE: u32 = 128;
pub const VIF_OUTOFSPACE: u32 = 256;
pub const VIF_ACCESSVIOLATION: u32 = 512;
pub const VIF_SHARINGVIOLATION: u32 = 1024;
pub const VIF_CANNOTCREATE: u32 = 2048;
pub const VIF_CANNOTDELETE: u32 = 4096;
pub const VIF_CANNOTRENAME: u32 = 8192;
pub const VIF_CANNOTDELETECUR: u32 = 16384;
pub const VIF_OUTOFMEMORY: u32 = 32768;
pub const VIF_CANNOTREADSRC: u32 = 65536;
pub const VIF_CANNOTREADDST: u32 = 131072;
pub const VIF_BUFFTOOSMALL: u32 = 262144;
pub const VIF_CANNOTLOADLZ32: u32 = 524288;
pub const VIF_CANNOTLOADCABINET: u32 = 1048576;
pub const FILE_VER_GET_LOCALISED: u32 = 1;
pub const FILE_VER_GET_NEUTRAL: u32 = 2;
pub const FILE_VER_GET_PREFETCHED: u32 = 4;
pub const RRF_RT_REG_NONE: u32 = 1;
pub const RRF_RT_REG_SZ: u32 = 2;
pub const RRF_RT_REG_EXPAND_SZ: u32 = 4;
pub const RRF_RT_REG_BINARY: u32 = 8;
pub const RRF_RT_REG_DWORD: u32 = 16;
pub const RRF_RT_REG_MULTI_SZ: u32 = 32;
pub const RRF_RT_REG_QWORD: u32 = 64;
pub const RRF_RT_DWORD: u32 = 24;
pub const RRF_RT_QWORD: u32 = 72;
pub const RRF_RT_ANY: u32 = 65535;
pub const RRF_SUBKEY_WOW6464KEY: u32 = 65536;
pub const RRF_SUBKEY_WOW6432KEY: u32 = 131072;
pub const RRF_WOW64_MASK: u32 = 196608;
pub const RRF_NOEXPAND: u32 = 268435456;
pub const RRF_ZEROONFAILURE: u32 = 536870912;
pub const REG_PROCESS_APPKEY: u32 = 1;
pub const REG_USE_CURRENT_SECURITY_CONTEXT: u32 = 2;
pub const PROVIDER_KEEPS_VALUE_LENGTH: u32 = 1;
pub const REG_MUI_STRING_TRUNCATE: u32 = 1;
pub const REG_SECURE_CONNECTION: u32 = 1;
pub const SHTDN_REASON_FLAG_COMMENT_REQUIRED: u32 = 16777216;
pub const SHTDN_REASON_FLAG_DIRTY_PROBLEM_ID_REQUIRED: u32 = 33554432;
pub const SHTDN_REASON_FLAG_CLEAN_UI: u32 = 67108864;
pub const SHTDN_REASON_FLAG_DIRTY_UI: u32 = 134217728;
pub const SHTDN_REASON_FLAG_MOBILE_UI_RESERVED: u32 = 268435456;
pub const SHTDN_REASON_FLAG_USER_DEFINED: u32 = 1073741824;
pub const SHTDN_REASON_FLAG_PLANNED: u32 = 2147483648;
pub const SHTDN_REASON_MAJOR_OTHER: u32 = 0;
pub const SHTDN_REASON_MAJOR_NONE: u32 = 0;
pub const SHTDN_REASON_MAJOR_HARDWARE: u32 = 65536;
pub const SHTDN_REASON_MAJOR_OPERATINGSYSTEM: u32 = 131072;
pub const SHTDN_REASON_MAJOR_SOFTWARE: u32 = 196608;
pub const SHTDN_REASON_MAJOR_APPLICATION: u32 = 262144;
pub const SHTDN_REASON_MAJOR_SYSTEM: u32 = 327680;
pub const SHTDN_REASON_MAJOR_POWER: u32 = 393216;
pub const SHTDN_REASON_MAJOR_LEGACY_API: u32 = 458752;
pub const SHTDN_REASON_MINOR_OTHER: u32 = 0;
pub const SHTDN_REASON_MINOR_NONE: u32 = 255;
pub const SHTDN_REASON_MINOR_MAINTENANCE: u32 = 1;
pub const SHTDN_REASON_MINOR_INSTALLATION: u32 = 2;
pub const SHTDN_REASON_MINOR_UPGRADE: u32 = 3;
pub const SHTDN_REASON_MINOR_RECONFIG: u32 = 4;
pub const SHTDN_REASON_MINOR_HUNG: u32 = 5;
pub const SHTDN_REASON_MINOR_UNSTABLE: u32 = 6;
pub const SHTDN_REASON_MINOR_DISK: u32 = 7;
pub const SHTDN_REASON_MINOR_PROCESSOR: u32 = 8;
pub const SHTDN_REASON_MINOR_NETWORKCARD: u32 = 9;
pub const SHTDN_REASON_MINOR_POWER_SUPPLY: u32 = 10;
pub const SHTDN_REASON_MINOR_CORDUNPLUGGED: u32 = 11;
pub const SHTDN_REASON_MINOR_ENVIRONMENT: u32 = 12;
pub const SHTDN_REASON_MINOR_HARDWARE_DRIVER: u32 = 13;
pub const SHTDN_REASON_MINOR_OTHERDRIVER: u32 = 14;
pub const SHTDN_REASON_MINOR_BLUESCREEN: u32 = 15;
pub const SHTDN_REASON_MINOR_SERVICEPACK: u32 = 16;
pub const SHTDN_REASON_MINOR_HOTFIX: u32 = 17;
pub const SHTDN_REASON_MINOR_SECURITYFIX: u32 = 18;
pub const SHTDN_REASON_MINOR_SECURITY: u32 = 19;
pub const SHTDN_REASON_MINOR_NETWORK_CONNECTIVITY: u32 = 20;
pub const SHTDN_REASON_MINOR_WMI: u32 = 21;
pub const SHTDN_REASON_MINOR_SERVICEPACK_UNINSTALL: u32 = 22;
pub const SHTDN_REASON_MINOR_HOTFIX_UNINSTALL: u32 = 23;
pub const SHTDN_REASON_MINOR_SECURITYFIX_UNINSTALL: u32 = 24;
pub const SHTDN_REASON_MINOR_MMC: u32 = 25;
pub const SHTDN_REASON_MINOR_SYSTEMRESTORE: u32 = 26;
pub const SHTDN_REASON_MINOR_TERMSRV: u32 = 32;
pub const SHTDN_REASON_MINOR_DC_PROMOTION: u32 = 33;
pub const SHTDN_REASON_MINOR_DC_DEMOTION: u32 = 34;
pub const SHTDN_REASON_UNKNOWN: u32 = 255;
pub const SHTDN_REASON_LEGACY_API: u32 = 2147942400;
pub const SHTDN_REASON_VALID_BIT_MASK: u32 = 3238002687;
pub const PCLEANUI: u32 = 2214592512;
pub const UCLEANUI: u32 = 67108864;
pub const PDIRTYUI: u32 = 2281701376;
pub const UDIRTYUI: u32 = 134217728;
pub const MAX_REASON_NAME_LEN: u32 = 64;
pub const MAX_REASON_DESC_LEN: u32 = 256;
pub const MAX_REASON_BUGID_LEN: u32 = 32;
pub const MAX_REASON_COMMENT_LEN: u32 = 512;
pub const SHUTDOWN_TYPE_LEN: u32 = 32;
pub const POLICY_SHOWREASONUI_NEVER: u32 = 0;
pub const POLICY_SHOWREASONUI_ALWAYS: u32 = 1;
pub const POLICY_SHOWREASONUI_WORKSTATIONONLY: u32 = 2;
pub const POLICY_SHOWREASONUI_SERVERONLY: u32 = 3;
pub const SNAPSHOT_POLICY_NEVER: u32 = 0;
pub const SNAPSHOT_POLICY_ALWAYS: u32 = 1;
pub const SNAPSHOT_POLICY_UNPLANNED: u32 = 2;
pub const MAX_NUM_REASONS: u32 = 256;
pub const REASON_SWINSTALL: u32 = 196610;
pub const REASON_HWINSTALL: u32 = 65538;
pub const REASON_SERVICEHANG: u32 = 196613;
pub const REASON_UNSTABLE: u32 = 327686;
pub const REASON_SWHWRECONF: u32 = 196612;
pub const REASON_OTHER: u32 = 0;
pub const REASON_UNKNOWN: u32 = 255;
pub const REASON_LEGACY_API: u32 = 2147942400;
pub const REASON_PLANNED_FLAG: u32 = 2147483648;
pub const MAX_SHUTDOWN_TIMEOUT: u32 = 315360000;
pub const SHUTDOWN_FORCE_OTHERS: u32 = 1;
pub const SHUTDOWN_FORCE_SELF: u32 = 2;
pub const SHUTDOWN_RESTART: u32 = 4;
pub const SHUTDOWN_POWEROFF: u32 = 8;
pub const SHUTDOWN_NOREBOOT: u32 = 16;
pub const SHUTDOWN_GRACE_OVERRIDE: u32 = 32;
pub const SHUTDOWN_INSTALL_UPDATES: u32 = 64;
pub const SHUTDOWN_RESTARTAPPS: u32 = 128;
pub const SHUTDOWN_SKIP_SVC_PRESHUTDOWN: u32 = 256;
pub const SHUTDOWN_HYBRID: u32 = 512;
pub const SHUTDOWN_RESTART_BOOTOPTIONS: u32 = 1024;
pub const SHUTDOWN_SOFT_REBOOT: u32 = 2048;
pub const SHUTDOWN_MOBILE_UI: u32 = 4096;
pub const SHUTDOWN_ARSO: u32 = 8192;
pub const SHUTDOWN_CHECK_SAFE_FOR_SERVER: u32 = 16384;
pub const SHUTDOWN_VAIL_CONTAINER: u32 = 32768;
pub const SHUTDOWN_SYSTEM_INITIATED: u32 = 65536;
pub const WNNC_NET_MSNET: u32 = 65536;
pub const WNNC_NET_SMB: u32 = 131072;
pub const WNNC_NET_NETWARE: u32 = 196608;
pub const WNNC_NET_VINES: u32 = 262144;
pub const WNNC_NET_10NET: u32 = 327680;
pub const WNNC_NET_LOCUS: u32 = 393216;
pub const WNNC_NET_SUN_PC_NFS: u32 = 458752;
pub const WNNC_NET_LANSTEP: u32 = 524288;
pub const WNNC_NET_9TILES: u32 = 589824;
pub const WNNC_NET_LANTASTIC: u32 = 655360;
pub const WNNC_NET_AS400: u32 = 720896;
pub const WNNC_NET_FTP_NFS: u32 = 786432;
pub const WNNC_NET_PATHWORKS: u32 = 851968;
pub const WNNC_NET_LIFENET: u32 = 917504;
pub const WNNC_NET_POWERLAN: u32 = 983040;
pub const WNNC_NET_BWNFS: u32 = 1048576;
pub const WNNC_NET_COGENT: u32 = 1114112;
pub const WNNC_NET_FARALLON: u32 = 1179648;
pub const WNNC_NET_APPLETALK: u32 = 1245184;
pub const WNNC_NET_INTERGRAPH: u32 = 1310720;
pub const WNNC_NET_SYMFONET: u32 = 1376256;
pub const WNNC_NET_CLEARCASE: u32 = 1441792;
pub const WNNC_NET_FRONTIER: u32 = 1507328;
pub const WNNC_NET_BMC: u32 = 1572864;
pub const WNNC_NET_DCE: u32 = 1638400;
pub const WNNC_NET_AVID: u32 = 1703936;
pub const WNNC_NET_DOCUSPACE: u32 = 1769472;
pub const WNNC_NET_MANGOSOFT: u32 = 1835008;
pub const WNNC_NET_SERNET: u32 = 1900544;
pub const WNNC_NET_RIVERFRONT1: u32 = 1966080;
pub const WNNC_NET_RIVERFRONT2: u32 = 2031616;
pub const WNNC_NET_DECORB: u32 = 2097152;
pub const WNNC_NET_PROTSTOR: u32 = 2162688;
pub const WNNC_NET_FJ_REDIR: u32 = 2228224;
pub const WNNC_NET_DISTINCT: u32 = 2293760;
pub const WNNC_NET_TWINS: u32 = 2359296;
pub const WNNC_NET_RDR2SAMPLE: u32 = 2424832;
pub const WNNC_NET_CSC: u32 = 2490368;
pub const WNNC_NET_3IN1: u32 = 2555904;
pub const WNNC_NET_EXTENDNET: u32 = 2686976;
pub const WNNC_NET_STAC: u32 = 2752512;
pub const WNNC_NET_FOXBAT: u32 = 2818048;
pub const WNNC_NET_YAHOO: u32 = 2883584;
pub const WNNC_NET_EXIFS: u32 = 2949120;
pub const WNNC_NET_DAV: u32 = 3014656;
pub const WNNC_NET_KNOWARE: u32 = 3080192;
pub const WNNC_NET_OBJECT_DIRE: u32 = 3145728;
pub const WNNC_NET_MASFAX: u32 = 3211264;
pub const WNNC_NET_HOB_NFS: u32 = 3276800;
pub const WNNC_NET_SHIVA: u32 = 3342336;
pub const WNNC_NET_IBMAL: u32 = 3407872;
pub const WNNC_NET_LOCK: u32 = 3473408;
pub const WNNC_NET_TERMSRV: u32 = 3538944;
pub const WNNC_NET_SRT: u32 = 3604480;
pub const WNNC_NET_QUINCY: u32 = 3670016;
pub const WNNC_NET_OPENAFS: u32 = 3735552;
pub const WNNC_NET_AVID1: u32 = 3801088;
pub const WNNC_NET_DFS: u32 = 3866624;
pub const WNNC_NET_KWNP: u32 = 3932160;
pub const WNNC_NET_ZENWORKS: u32 = 3997696;
pub const WNNC_NET_DRIVEONWEB: u32 = 4063232;
pub const WNNC_NET_VMWARE: u32 = 4128768;
pub const WNNC_NET_RSFX: u32 = 4194304;
pub const WNNC_NET_MFILES: u32 = 4259840;
pub const WNNC_NET_MS_NFS: u32 = 4325376;
pub const WNNC_NET_GOOGLE: u32 = 4390912;
pub const WNNC_NET_NDFS: u32 = 4456448;
pub const WNNC_NET_DOCUSHARE: u32 = 4521984;
pub const WNNC_NET_AURISTOR_FS: u32 = 4587520;
pub const WNNC_NET_SECUREAGENT: u32 = 4653056;
pub const WNNC_NET_9P: u32 = 4718592;
pub const WNNC_CRED_MANAGER: u32 = 4294901760;
pub const WNNC_NET_LANMAN: u32 = 131072;
pub const RESOURCE_CONNECTED: u32 = 1;
pub const RESOURCE_GLOBALNET: u32 = 2;
pub const RESOURCE_REMEMBERED: u32 = 3;
pub const RESOURCE_RECENT: u32 = 4;
pub const RESOURCE_CONTEXT: u32 = 5;
pub const RESOURCETYPE_ANY: u32 = 0;
pub const RESOURCETYPE_DISK: u32 = 1;
pub const RESOURCETYPE_PRINT: u32 = 2;
pub const RESOURCETYPE_RESERVED: u32 = 8;
pub const RESOURCETYPE_UNKNOWN: u32 = 4294967295;
pub const RESOURCEUSAGE_CONNECTABLE: u32 = 1;
pub const RESOURCEUSAGE_CONTAINER: u32 = 2;
pub const RESOURCEUSAGE_NOLOCALDEVICE: u32 = 4;
pub const RESOURCEUSAGE_SIBLING: u32 = 8;
pub const RESOURCEUSAGE_ATTACHED: u32 = 16;
pub const RESOURCEUSAGE_ALL: u32 = 19;
pub const RESOURCEUSAGE_RESERVED: u32 = 2147483648;
pub const RESOURCEDISPLAYTYPE_GENERIC: u32 = 0;
pub const RESOURCEDISPLAYTYPE_DOMAIN: u32 = 1;
pub const RESOURCEDISPLAYTYPE_SERVER: u32 = 2;
pub const RESOURCEDISPLAYTYPE_SHARE: u32 = 3;
pub const RESOURCEDISPLAYTYPE_FILE: u32 = 4;
pub const RESOURCEDISPLAYTYPE_GROUP: u32 = 5;
pub const RESOURCEDISPLAYTYPE_NETWORK: u32 = 6;
pub const RESOURCEDISPLAYTYPE_ROOT: u32 = 7;
pub const RESOURCEDISPLAYTYPE_SHAREADMIN: u32 = 8;
pub const RESOURCEDISPLAYTYPE_DIRECTORY: u32 = 9;
pub const RESOURCEDISPLAYTYPE_TREE: u32 = 10;
pub const RESOURCEDISPLAYTYPE_NDSCONTAINER: u32 = 11;
pub const NETPROPERTY_PERSISTENT: u32 = 1;
pub const CONNECT_UPDATE_PROFILE: u32 = 1;
pub const CONNECT_UPDATE_RECENT: u32 = 2;
pub const CONNECT_TEMPORARY: u32 = 4;
pub const CONNECT_INTERACTIVE: u32 = 8;
pub const CONNECT_PROMPT: u32 = 16;
pub const CONNECT_NEED_DRIVE: u32 = 32;
pub const CONNECT_REFCOUNT: u32 = 64;
pub const CONNECT_REDIRECT: u32 = 128;
pub const CONNECT_LOCALDRIVE: u32 = 256;
pub const CONNECT_CURRENT_MEDIA: u32 = 512;
pub const CONNECT_DEFERRED: u32 = 1024;
pub const CONNECT_RESERVED: u32 = 4278190080;
pub const CONNECT_COMMANDLINE: u32 = 2048;
pub const CONNECT_CMD_SAVECRED: u32 = 4096;
pub const CONNECT_CRED_RESET: u32 = 8192;
pub const CONNECT_REQUIRE_INTEGRITY: u32 = 16384;
pub const CONNECT_REQUIRE_PRIVACY: u32 = 32768;
pub const CONNECT_WRITE_THROUGH_SEMANTICS: u32 = 65536;
pub const CONNECT_GLOBAL_MAPPING: u32 = 262144;
pub const CONNDLG_RO_PATH: u32 = 1;
pub const CONNDLG_CONN_POINT: u32 = 2;
pub const CONNDLG_USE_MRU: u32 = 4;
pub const CONNDLG_HIDE_BOX: u32 = 8;
pub const CONNDLG_PERSIST: u32 = 16;
pub const CONNDLG_NOT_PERSIST: u32 = 32;
pub const DISC_UPDATE_PROFILE: u32 = 1;
pub const DISC_NO_FORCE: u32 = 64;
pub const UNIVERSAL_NAME_INFO_LEVEL: u32 = 1;
pub const REMOTE_NAME_INFO_LEVEL: u32 = 2;
pub const WNFMT_MULTILINE: u32 = 1;
pub const WNFMT_ABBREVIATED: u32 = 2;
pub const WNFMT_INENUM: u32 = 16;
pub const WNFMT_CONNECTION: u32 = 32;
pub const NETINFO_DLL16: u32 = 1;
pub const NETINFO_DISKRED: u32 = 4;
pub const NETINFO_PRINTERRED: u32 = 8;
pub const WN_SUCCESS: u32 = 0;
pub const WN_NO_ERROR: u32 = 0;
pub const WN_NOT_SUPPORTED: u32 = 50;
pub const WN_CANCEL: u32 = 1223;
pub const WN_RETRY: u32 = 1237;
pub const WN_NET_ERROR: u32 = 59;
pub const WN_MORE_DATA: u32 = 234;
pub const WN_BAD_POINTER: u32 = 487;
pub const WN_BAD_VALUE: u32 = 87;
pub const WN_BAD_USER: u32 = 2202;
pub const WN_BAD_PASSWORD: u32 = 86;
pub const WN_ACCESS_DENIED: u32 = 5;
pub const WN_FUNCTION_BUSY: u32 = 170;
pub const WN_WINDOWS_ERROR: u32 = 59;
pub const WN_OUT_OF_MEMORY: u32 = 8;
pub const WN_NO_NETWORK: u32 = 1222;
pub const WN_EXTENDED_ERROR: u32 = 1208;
pub const WN_BAD_LEVEL: u32 = 124;
pub const WN_BAD_HANDLE: u32 = 6;
pub const WN_NOT_INITIALIZING: u32 = 1247;
pub const WN_NO_MORE_DEVICES: u32 = 1248;
pub const WN_NOT_CONNECTED: u32 = 2250;
pub const WN_OPEN_FILES: u32 = 2401;
pub const WN_DEVICE_IN_USE: u32 = 2404;
pub const WN_BAD_NETNAME: u32 = 67;
pub const WN_BAD_LOCALNAME: u32 = 1200;
pub const WN_ALREADY_CONNECTED: u32 = 85;
pub const WN_DEVICE_ERROR: u32 = 31;
pub const WN_CONNECTION_CLOSED: u32 = 1201;
pub const WN_NO_NET_OR_BAD_PATH: u32 = 1203;
pub const WN_BAD_PROVIDER: u32 = 1204;
pub const WN_CANNOT_OPEN_PROFILE: u32 = 1205;
pub const WN_BAD_PROFILE: u32 = 1206;
pub const WN_BAD_DEV_TYPE: u32 = 66;
pub const WN_DEVICE_ALREADY_REMEMBERED: u32 = 1202;
pub const WN_CONNECTED_OTHER_PASSWORD: u32 = 2108;
pub const WN_CONNECTED_OTHER_PASSWORD_DEFAULT: u32 = 2109;
pub const WN_NO_MORE_ENTRIES: u32 = 259;
pub const WN_NOT_CONTAINER: u32 = 1207;
pub const WN_NOT_AUTHENTICATED: u32 = 1244;
pub const WN_NOT_LOGGED_ON: u32 = 1245;
pub const WN_NOT_VALIDATED: u32 = 1311;
pub const WNCON_FORNETCARD: u32 = 1;
pub const WNCON_NOTROUTED: u32 = 2;
pub const WNCON_SLOWLINK: u32 = 4;
pub const WNCON_DYNAMIC: u32 = 8;
pub const CDERR_DIALOGFAILURE: u32 = 65535;
pub const CDERR_GENERALCODES: u32 = 0;
pub const CDERR_STRUCTSIZE: u32 = 1;
pub const CDERR_INITIALIZATION: u32 = 2;
pub const CDERR_NOTEMPLATE: u32 = 3;
pub const CDERR_NOHINSTANCE: u32 = 4;
pub const CDERR_LOADSTRFAILURE: u32 = 5;
pub const CDERR_FINDRESFAILURE: u32 = 6;
pub const CDERR_LOADRESFAILURE: u32 = 7;
pub const CDERR_LOCKRESFAILURE: u32 = 8;
pub const CDERR_MEMALLOCFAILURE: u32 = 9;
pub const CDERR_MEMLOCKFAILURE: u32 = 10;
pub const CDERR_NOHOOK: u32 = 11;
pub const CDERR_REGISTERMSGFAIL: u32 = 12;
pub const PDERR_PRINTERCODES: u32 = 4096;
pub const PDERR_SETUPFAILURE: u32 = 4097;
pub const PDERR_PARSEFAILURE: u32 = 4098;
pub const PDERR_RETDEFFAILURE: u32 = 4099;
pub const PDERR_LOADDRVFAILURE: u32 = 4100;
pub const PDERR_GETDEVMODEFAIL: u32 = 4101;
pub const PDERR_INITFAILURE: u32 = 4102;
pub const PDERR_NODEVICES: u32 = 4103;
pub const PDERR_NODEFAULTPRN: u32 = 4104;
pub const PDERR_DNDMMISMATCH: u32 = 4105;
pub const PDERR_CREATEICFAILURE: u32 = 4106;
pub const PDERR_PRINTERNOTFOUND: u32 = 4107;
pub const PDERR_DEFAULTDIFFERENT: u32 = 4108;
pub const CFERR_CHOOSEFONTCODES: u32 = 8192;
pub const CFERR_NOFONTS: u32 = 8193;
pub const CFERR_MAXLESSTHANMIN: u32 = 8194;
pub const FNERR_FILENAMECODES: u32 = 12288;
pub const FNERR_SUBCLASSFAILURE: u32 = 12289;
pub const FNERR_INVALIDFILENAME: u32 = 12290;
pub const FNERR_BUFFERTOOSMALL: u32 = 12291;
pub const FRERR_FINDREPLACECODES: u32 = 16384;
pub const FRERR_BUFFERLENGTHZERO: u32 = 16385;
pub const CCERR_CHOOSECOLORCODES: u32 = 20480;
pub const WM_DDE_FIRST: u32 = 992;
pub const WM_DDE_INITIATE: u32 = 992;
pub const WM_DDE_TERMINATE: u32 = 993;
pub const WM_DDE_ADVISE: u32 = 994;
pub const WM_DDE_UNADVISE: u32 = 995;
pub const WM_DDE_ACK: u32 = 996;
pub const WM_DDE_DATA: u32 = 997;
pub const WM_DDE_REQUEST: u32 = 998;
pub const WM_DDE_POKE: u32 = 999;
pub const WM_DDE_EXECUTE: u32 = 1000;
pub const WM_DDE_LAST: u32 = 1000;
pub const XST_NULL: u32 = 0;
pub const XST_INCOMPLETE: u32 = 1;
pub const XST_CONNECTED: u32 = 2;
pub const XST_INIT1: u32 = 3;
pub const XST_INIT2: u32 = 4;
pub const XST_REQSENT: u32 = 5;
pub const XST_DATARCVD: u32 = 6;
pub const XST_POKESENT: u32 = 7;
pub const XST_POKEACKRCVD: u32 = 8;
pub const XST_EXECSENT: u32 = 9;
pub const XST_EXECACKRCVD: u32 = 10;
pub const XST_ADVSENT: u32 = 11;
pub const XST_UNADVSENT: u32 = 12;
pub const XST_ADVACKRCVD: u32 = 13;
pub const XST_UNADVACKRCVD: u32 = 14;
pub const XST_ADVDATASENT: u32 = 15;
pub const XST_ADVDATAACKRCVD: u32 = 16;
pub const CADV_LATEACK: u32 = 65535;
pub const ST_CONNECTED: u32 = 1;
pub const ST_ADVISE: u32 = 2;
pub const ST_ISLOCAL: u32 = 4;
pub const ST_BLOCKED: u32 = 8;
pub const ST_CLIENT: u32 = 16;
pub const ST_TERMINATED: u32 = 32;
pub const ST_INLIST: u32 = 64;
pub const ST_BLOCKNEXT: u32 = 128;
pub const ST_ISSELF: u32 = 256;
pub const DDE_FACK: u32 = 32768;
pub const DDE_FBUSY: u32 = 16384;
pub const DDE_FDEFERUPD: u32 = 16384;
pub const DDE_FACKREQ: u32 = 32768;
pub const DDE_FRELEASE: u32 = 8192;
pub const DDE_FREQUESTED: u32 = 4096;
pub const DDE_FAPPSTATUS: u32 = 255;
pub const DDE_FNOTPROCESSED: u32 = 0;
pub const DDE_FACKRESERVED: i32 = -49408;
pub const DDE_FADVRESERVED: i32 = -49153;
pub const DDE_FDATRESERVED: i32 = -45057;
pub const DDE_FPOKRESERVED: i32 = -8193;
pub const MSGF_DDEMGR: u32 = 32769;
pub const CP_WINANSI: u32 = 1004;
pub const CP_WINUNICODE: u32 = 1200;
pub const CP_WINNEUTRAL: u32 = 1004;
pub const XTYPF_NOBLOCK: u32 = 2;
pub const XTYPF_NODATA: u32 = 4;
pub const XTYPF_ACKREQ: u32 = 8;
pub const XCLASS_MASK: u32 = 64512;
pub const XCLASS_BOOL: u32 = 4096;
pub const XCLASS_DATA: u32 = 8192;
pub const XCLASS_FLAGS: u32 = 16384;
pub const XCLASS_NOTIFICATION: u32 = 32768;
pub const XTYP_ERROR: u32 = 32770;
pub const XTYP_ADVDATA: u32 = 16400;
pub const XTYP_ADVREQ: u32 = 8226;
pub const XTYP_ADVSTART: u32 = 4144;
pub const XTYP_ADVSTOP: u32 = 32832;
pub const XTYP_EXECUTE: u32 = 16464;
pub const XTYP_CONNECT: u32 = 4194;
pub const XTYP_CONNECT_CONFIRM: u32 = 32882;
pub const XTYP_XACT_COMPLETE: u32 = 32896;
pub const XTYP_POKE: u32 = 16528;
pub const XTYP_REGISTER: u32 = 32930;
pub const XTYP_REQUEST: u32 = 8368;
pub const XTYP_DISCONNECT: u32 = 32962;
pub const XTYP_UNREGISTER: u32 = 32978;
pub const XTYP_WILDCONNECT: u32 = 8418;
pub const XTYP_MASK: u32 = 240;
pub const XTYP_SHIFT: u32 = 4;
pub const TIMEOUT_ASYNC: u32 = 4294967295;
pub const QID_SYNC: u32 = 4294967295;
pub const SZDDESYS_TOPIC: &[u8; 7] = b"System\0";
pub const SZDDESYS_ITEM_TOPICS: &[u8; 7] = b"Topics\0";
pub const SZDDESYS_ITEM_SYSITEMS: &[u8; 9] = b"SysItems\0";
pub const SZDDESYS_ITEM_RTNMSG: &[u8; 14] = b"ReturnMessage\0";
pub const SZDDESYS_ITEM_STATUS: &[u8; 7] = b"Status\0";
pub const SZDDESYS_ITEM_FORMATS: &[u8; 8] = b"Formats\0";
pub const SZDDESYS_ITEM_HELP: &[u8; 5] = b"Help\0";
pub const SZDDE_ITEM_ITEMLIST: &[u8; 14] = b"TopicItemList\0";
pub const CBF_FAIL_SELFCONNECTIONS: u32 = 4096;
pub const CBF_FAIL_CONNECTIONS: u32 = 8192;
pub const CBF_FAIL_ADVISES: u32 = 16384;
pub const CBF_FAIL_EXECUTES: u32 = 32768;
pub const CBF_FAIL_POKES: u32 = 65536;
pub const CBF_FAIL_REQUESTS: u32 = 131072;
pub const CBF_FAIL_ALLSVRXACTIONS: u32 = 258048;
pub const CBF_SKIP_CONNECT_CONFIRMS: u32 = 262144;
pub const CBF_SKIP_REGISTRATIONS: u32 = 524288;
pub const CBF_SKIP_UNREGISTRATIONS: u32 = 1048576;
pub const CBF_SKIP_DISCONNECTS: u32 = 2097152;
pub const CBF_SKIP_ALLNOTIFICATIONS: u32 = 3932160;
pub const APPCMD_CLIENTONLY: u32 = 16;
pub const APPCMD_FILTERINITS: u32 = 32;
pub const APPCMD_MASK: u32 = 4080;
pub const APPCLASS_STANDARD: u32 = 0;
pub const APPCLASS_MASK: u32 = 15;
pub const EC_ENABLEALL: u32 = 0;
pub const EC_ENABLEONE: u32 = 128;
pub const EC_DISABLE: u32 = 8;
pub const EC_QUERYWAITING: u32 = 2;
pub const DNS_REGISTER: u32 = 1;
pub const DNS_UNREGISTER: u32 = 2;
pub const DNS_FILTERON: u32 = 4;
pub const DNS_FILTEROFF: u32 = 8;
pub const HDATA_APPOWNED: u32 = 1;
pub const DMLERR_NO_ERROR: u32 = 0;
pub const DMLERR_FIRST: u32 = 16384;
pub const DMLERR_ADVACKTIMEOUT: u32 = 16384;
pub const DMLERR_BUSY: u32 = 16385;
pub const DMLERR_DATAACKTIMEOUT: u32 = 16386;
pub const DMLERR_DLL_NOT_INITIALIZED: u32 = 16387;
pub const DMLERR_DLL_USAGE: u32 = 16388;
pub const DMLERR_EXECACKTIMEOUT: u32 = 16389;
pub const DMLERR_INVALIDPARAMETER: u32 = 16390;
pub const DMLERR_LOW_MEMORY: u32 = 16391;
pub const DMLERR_MEMORY_ERROR: u32 = 16392;
pub const DMLERR_NOTPROCESSED: u32 = 16393;
pub const DMLERR_NO_CONV_ESTABLISHED: u32 = 16394;
pub const DMLERR_POKEACKTIMEOUT: u32 = 16395;
pub const DMLERR_POSTMSG_FAILED: u32 = 16396;
pub const DMLERR_REENTRANCY: u32 = 16397;
pub const DMLERR_SERVER_DIED: u32 = 16398;
pub const DMLERR_SYS_ERROR: u32 = 16399;
pub const DMLERR_UNADVACKTIMEOUT: u32 = 16400;
pub const DMLERR_UNFOUND_QUEUE_ID: u32 = 16401;
pub const DMLERR_LAST: u32 = 16401;
pub const MH_CREATE: u32 = 1;
pub const MH_KEEP: u32 = 2;
pub const MH_DELETE: u32 = 3;
pub const MH_CLEANUP: u32 = 4;
pub const MAX_MONITORS: u32 = 4;
pub const APPCLASS_MONITOR: u32 = 1;
pub const XTYP_MONITOR: u32 = 33010;
pub const MF_HSZ_INFO: u32 = 16777216;
pub const MF_SENDMSGS: u32 = 33554432;
pub const MF_POSTMSGS: u32 = 67108864;
pub const MF_CALLBACKS: u32 = 134217728;
pub const MF_ERRORS: u32 = 268435456;
pub const MF_LINKS: u32 = 536870912;
pub const MF_CONV: u32 = 1073741824;
pub const MF_MASK: u32 = 4278190080;
pub const ctlFirst: u32 = 1024;
pub const ctlLast: u32 = 1279;
pub const psh1: u32 = 1024;
pub const psh2: u32 = 1025;
pub const psh3: u32 = 1026;
pub const psh4: u32 = 1027;
pub const psh5: u32 = 1028;
pub const psh6: u32 = 1029;
pub const psh7: u32 = 1030;
pub const psh8: u32 = 1031;
pub const psh9: u32 = 1032;
pub const psh10: u32 = 1033;
pub const psh11: u32 = 1034;
pub const psh12: u32 = 1035;
pub const psh13: u32 = 1036;
pub const psh14: u32 = 1037;
pub const psh15: u32 = 1038;
pub const pshHelp: u32 = 1038;
pub const psh16: u32 = 1039;
pub const chx1: u32 = 1040;
pub const chx2: u32 = 1041;
pub const chx3: u32 = 1042;
pub const chx4: u32 = 1043;
pub const chx5: u32 = 1044;
pub const chx6: u32 = 1045;
pub const chx7: u32 = 1046;
pub const chx8: u32 = 1047;
pub const chx9: u32 = 1048;
pub const chx10: u32 = 1049;
pub const chx11: u32 = 1050;
pub const chx12: u32 = 1051;
pub const chx13: u32 = 1052;
pub const chx14: u32 = 1053;
pub const chx15: u32 = 1054;
pub const chx16: u32 = 1055;
pub const rad1: u32 = 1056;
pub const rad2: u32 = 1057;
pub const rad3: u32 = 1058;
pub const rad4: u32 = 1059;
pub const rad5: u32 = 1060;
pub const rad6: u32 = 1061;
pub const rad7: u32 = 1062;
pub const rad8: u32 = 1063;
pub const rad9: u32 = 1064;
pub const rad10: u32 = 1065;
pub const rad11: u32 = 1066;
pub const rad12: u32 = 1067;
pub const rad13: u32 = 1068;
pub const rad14: u32 = 1069;
pub const rad15: u32 = 1070;
pub const rad16: u32 = 1071;
pub const grp1: u32 = 1072;
pub const grp2: u32 = 1073;
pub const grp3: u32 = 1074;
pub const grp4: u32 = 1075;
pub const frm1: u32 = 1076;
pub const frm2: u32 = 1077;
pub const frm3: u32 = 1078;
pub const frm4: u32 = 1079;
pub const rct1: u32 = 1080;
pub const rct2: u32 = 1081;
pub const rct3: u32 = 1082;
pub const rct4: u32 = 1083;
pub const ico1: u32 = 1084;
pub const ico2: u32 = 1085;
pub const ico3: u32 = 1086;
pub const ico4: u32 = 1087;
pub const stc1: u32 = 1088;
pub const stc2: u32 = 1089;
pub const stc3: u32 = 1090;
pub const stc4: u32 = 1091;
pub const stc5: u32 = 1092;
pub const stc6: u32 = 1093;
pub const stc7: u32 = 1094;
pub const stc8: u32 = 1095;
pub const stc9: u32 = 1096;
pub const stc10: u32 = 1097;
pub const stc11: u32 = 1098;
pub const stc12: u32 = 1099;
pub const stc13: u32 = 1100;
pub const stc14: u32 = 1101;
pub const stc15: u32 = 1102;
pub const stc16: u32 = 1103;
pub const stc17: u32 = 1104;
pub const stc18: u32 = 1105;
pub const stc19: u32 = 1106;
pub const stc20: u32 = 1107;
pub const stc21: u32 = 1108;
pub const stc22: u32 = 1109;
pub const stc23: u32 = 1110;
pub const stc24: u32 = 1111;
pub const stc25: u32 = 1112;
pub const stc26: u32 = 1113;
pub const stc27: u32 = 1114;
pub const stc28: u32 = 1115;
pub const stc29: u32 = 1116;
pub const stc30: u32 = 1117;
pub const stc31: u32 = 1118;
pub const stc32: u32 = 1119;
pub const lst1: u32 = 1120;
pub const lst2: u32 = 1121;
pub const lst3: u32 = 1122;
pub const lst4: u32 = 1123;
pub const lst5: u32 = 1124;
pub const lst6: u32 = 1125;
pub const lst7: u32 = 1126;
pub const lst8: u32 = 1127;
pub const lst9: u32 = 1128;
pub const lst10: u32 = 1129;
pub const lst11: u32 = 1130;
pub const lst12: u32 = 1131;
pub const lst13: u32 = 1132;
pub const lst14: u32 = 1133;
pub const lst15: u32 = 1134;
pub const lst16: u32 = 1135;
pub const cmb1: u32 = 1136;
pub const cmb2: u32 = 1137;
pub const cmb3: u32 = 1138;
pub const cmb4: u32 = 1139;
pub const cmb5: u32 = 1140;
pub const cmb6: u32 = 1141;
pub const cmb7: u32 = 1142;
pub const cmb8: u32 = 1143;
pub const cmb9: u32 = 1144;
pub const cmb10: u32 = 1145;
pub const cmb11: u32 = 1146;
pub const cmb12: u32 = 1147;
pub const cmb13: u32 = 1148;
pub const cmb14: u32 = 1149;
pub const cmb15: u32 = 1150;
pub const cmb16: u32 = 1151;
pub const edt1: u32 = 1152;
pub const edt2: u32 = 1153;
pub const edt3: u32 = 1154;
pub const edt4: u32 = 1155;
pub const edt5: u32 = 1156;
pub const edt6: u32 = 1157;
pub const edt7: u32 = 1158;
pub const edt8: u32 = 1159;
pub const edt9: u32 = 1160;
pub const edt10: u32 = 1161;
pub const edt11: u32 = 1162;
pub const edt12: u32 = 1163;
pub const edt13: u32 = 1164;
pub const edt14: u32 = 1165;
pub const edt15: u32 = 1166;
pub const edt16: u32 = 1167;
pub const scr1: u32 = 1168;
pub const scr2: u32 = 1169;
pub const scr3: u32 = 1170;
pub const scr4: u32 = 1171;
pub const scr5: u32 = 1172;
pub const scr6: u32 = 1173;
pub const scr7: u32 = 1174;
pub const scr8: u32 = 1175;
pub const ctl1: u32 = 1184;
pub const FILEOPENORD: u32 = 1536;
pub const MULTIFILEOPENORD: u32 = 1537;
pub const PRINTDLGORD: u32 = 1538;
pub const PRNSETUPDLGORD: u32 = 1539;
pub const FINDDLGORD: u32 = 1540;
pub const REPLACEDLGORD: u32 = 1541;
pub const FONTDLGORD: u32 = 1542;
pub const FORMATDLGORD31: u32 = 1543;
pub const FORMATDLGORD30: u32 = 1544;
pub const RUNDLGORD: u32 = 1545;
pub const PAGESETUPDLGORD: u32 = 1546;
pub const NEWFILEOPENORD: u32 = 1547;
pub const PRINTDLGEXORD: u32 = 1549;
pub const PAGESETUPDLGORDMOTIF: u32 = 1550;
pub const COLORMGMTDLGORD: u32 = 1551;
pub const NEWFILEOPENV2ORD: u32 = 1552;
pub const NEWFILEOPENV3ORD: u32 = 1553;
pub const NEWFORMATDLGWITHLINK: u32 = 1591;
pub const IDC_MANAGE_LINK: u32 = 1592;
pub const LZERROR_BADINHANDLE: i32 = -1;
pub const LZERROR_BADOUTHANDLE: i32 = -2;
pub const LZERROR_READ: i32 = -3;
pub const LZERROR_WRITE: i32 = -4;
pub const LZERROR_GLOBALLOC: i32 = -5;
pub const LZERROR_GLOBLOCK: i32 = -6;
pub const LZERROR_BADVALUE: i32 = -7;
pub const LZERROR_UNKNOWNALG: i32 = -8;
pub const MAXPNAMELEN: u32 = 32;
pub const MAXERRORLENGTH: u32 = 256;
pub const MAX_JOYSTICKOEMVXDNAME: u32 = 260;
pub const TIME_MS: u32 = 1;
pub const TIME_SAMPLES: u32 = 2;
pub const TIME_BYTES: u32 = 4;
pub const TIME_SMPTE: u32 = 8;
pub const TIME_MIDI: u32 = 16;
pub const TIME_TICKS: u32 = 32;
pub const MM_JOY1MOVE: u32 = 928;
pub const MM_JOY2MOVE: u32 = 929;
pub const MM_JOY1ZMOVE: u32 = 930;
pub const MM_JOY2ZMOVE: u32 = 931;
pub const MM_JOY1BUTTONDOWN: u32 = 949;
pub const MM_JOY2BUTTONDOWN: u32 = 950;
pub const MM_JOY1BUTTONUP: u32 = 951;
pub const MM_JOY2BUTTONUP: u32 = 952;
pub const MM_MCINOTIFY: u32 = 953;
pub const MM_WOM_OPEN: u32 = 955;
pub const MM_WOM_CLOSE: u32 = 956;
pub const MM_WOM_DONE: u32 = 957;
pub const MM_WIM_OPEN: u32 = 958;
pub const MM_WIM_CLOSE: u32 = 959;
pub const MM_WIM_DATA: u32 = 960;
pub const MM_MIM_OPEN: u32 = 961;
pub const MM_MIM_CLOSE: u32 = 962;
pub const MM_MIM_DATA: u32 = 963;
pub const MM_MIM_LONGDATA: u32 = 964;
pub const MM_MIM_ERROR: u32 = 965;
pub const MM_MIM_LONGERROR: u32 = 966;
pub const MM_MOM_OPEN: u32 = 967;
pub const MM_MOM_CLOSE: u32 = 968;
pub const MM_MOM_DONE: u32 = 969;
pub const MM_DRVM_OPEN: u32 = 976;
pub const MM_DRVM_CLOSE: u32 = 977;
pub const MM_DRVM_DATA: u32 = 978;
pub const MM_DRVM_ERROR: u32 = 979;
pub const MM_STREAM_OPEN: u32 = 980;
pub const MM_STREAM_CLOSE: u32 = 981;
pub const MM_STREAM_DONE: u32 = 982;
pub const MM_STREAM_ERROR: u32 = 983;
pub const MM_MOM_POSITIONCB: u32 = 970;
pub const MM_MCISIGNAL: u32 = 971;
pub const MM_MIM_MOREDATA: u32 = 972;
pub const MM_MIXM_LINE_CHANGE: u32 = 976;
pub const MM_MIXM_CONTROL_CHANGE: u32 = 977;
pub const MMSYSERR_BASE: u32 = 0;
pub const WAVERR_BASE: u32 = 32;
pub const MIDIERR_BASE: u32 = 64;
pub const TIMERR_BASE: u32 = 96;
pub const JOYERR_BASE: u32 = 160;
pub const MCIERR_BASE: u32 = 256;
pub const MIXERR_BASE: u32 = 1024;
pub const MCI_STRING_OFFSET: u32 = 512;
pub const MCI_VD_OFFSET: u32 = 1024;
pub const MCI_CD_OFFSET: u32 = 1088;
pub const MCI_WAVE_OFFSET: u32 = 1152;
pub const MCI_SEQ_OFFSET: u32 = 1216;
pub const MMSYSERR_NOERROR: u32 = 0;
pub const MMSYSERR_ERROR: u32 = 1;
pub const MMSYSERR_BADDEVICEID: u32 = 2;
pub const MMSYSERR_NOTENABLED: u32 = 3;
pub const MMSYSERR_ALLOCATED: u32 = 4;
pub const MMSYSERR_INVALHANDLE: u32 = 5;
pub const MMSYSERR_NODRIVER: u32 = 6;
pub const MMSYSERR_NOMEM: u32 = 7;
pub const MMSYSERR_NOTSUPPORTED: u32 = 8;
pub const MMSYSERR_BADERRNUM: u32 = 9;
pub const MMSYSERR_INVALFLAG: u32 = 10;
pub const MMSYSERR_INVALPARAM: u32 = 11;
pub const MMSYSERR_HANDLEBUSY: u32 = 12;
pub const MMSYSERR_INVALIDALIAS: u32 = 13;
pub const MMSYSERR_BADDB: u32 = 14;
pub const MMSYSERR_KEYNOTFOUND: u32 = 15;
pub const MMSYSERR_READERROR: u32 = 16;
pub const MMSYSERR_WRITEERROR: u32 = 17;
pub const MMSYSERR_DELETEERROR: u32 = 18;
pub const MMSYSERR_VALNOTFOUND: u32 = 19;
pub const MMSYSERR_NODRIVERCB: u32 = 20;
pub const MMSYSERR_MOREDATA: u32 = 21;
pub const MMSYSERR_LASTERROR: u32 = 21;
pub const CALLBACK_TYPEMASK: u32 = 458752;
pub const CALLBACK_NULL: u32 = 0;
pub const CALLBACK_WINDOW: u32 = 65536;
pub const CALLBACK_TASK: u32 = 131072;
pub const CALLBACK_FUNCTION: u32 = 196608;
pub const CALLBACK_THREAD: u32 = 131072;
pub const CALLBACK_EVENT: u32 = 327680;
pub const MCIERR_INVALID_DEVICE_ID: u32 = 257;
pub const MCIERR_UNRECOGNIZED_KEYWORD: u32 = 259;
pub const MCIERR_UNRECOGNIZED_COMMAND: u32 = 261;
pub const MCIERR_HARDWARE: u32 = 262;
pub const MCIERR_INVALID_DEVICE_NAME: u32 = 263;
pub const MCIERR_OUT_OF_MEMORY: u32 = 264;
pub const MCIERR_DEVICE_OPEN: u32 = 265;
pub const MCIERR_CANNOT_LOAD_DRIVER: u32 = 266;
pub const MCIERR_MISSING_COMMAND_STRING: u32 = 267;
pub const MCIERR_PARAM_OVERFLOW: u32 = 268;
pub const MCIERR_MISSING_STRING_ARGUMENT: u32 = 269;
pub const MCIERR_BAD_INTEGER: u32 = 270;
pub const MCIERR_PARSER_INTERNAL: u32 = 271;
pub const MCIERR_DRIVER_INTERNAL: u32 = 272;
pub const MCIERR_MISSING_PARAMETER: u32 = 273;
pub const MCIERR_UNSUPPORTED_FUNCTION: u32 = 274;
pub const MCIERR_FILE_NOT_FOUND: u32 = 275;
pub const MCIERR_DEVICE_NOT_READY: u32 = 276;
pub const MCIERR_INTERNAL: u32 = 277;
pub const MCIERR_DRIVER: u32 = 278;
pub const MCIERR_CANNOT_USE_ALL: u32 = 279;
pub const MCIERR_MULTIPLE: u32 = 280;
pub const MCIERR_EXTENSION_NOT_FOUND: u32 = 281;
pub const MCIERR_OUTOFRANGE: u32 = 282;
pub const MCIERR_FLAGS_NOT_COMPATIBLE: u32 = 284;
pub const MCIERR_FILE_NOT_SAVED: u32 = 286;
pub const MCIERR_DEVICE_TYPE_REQUIRED: u32 = 287;
pub const MCIERR_DEVICE_LOCKED: u32 = 288;
pub const MCIERR_DUPLICATE_ALIAS: u32 = 289;
pub const MCIERR_BAD_CONSTANT: u32 = 290;
pub const MCIERR_MUST_USE_SHAREABLE: u32 = 291;
pub const MCIERR_MISSING_DEVICE_NAME: u32 = 292;
pub const MCIERR_BAD_TIME_FORMAT: u32 = 293;
pub const MCIERR_NO_CLOSING_QUOTE: u32 = 294;
pub const MCIERR_DUPLICATE_FLAGS: u32 = 295;
pub const MCIERR_INVALID_FILE: u32 = 296;
pub const MCIERR_NULL_PARAMETER_BLOCK: u32 = 297;
pub const MCIERR_UNNAMED_RESOURCE: u32 = 298;
pub const MCIERR_NEW_REQUIRES_ALIAS: u32 = 299;
pub const MCIERR_NOTIFY_ON_AUTO_OPEN: u32 = 300;
pub const MCIERR_NO_ELEMENT_ALLOWED: u32 = 301;
pub const MCIERR_NONAPPLICABLE_FUNCTION: u32 = 302;
pub const MCIERR_ILLEGAL_FOR_AUTO_OPEN: u32 = 303;
pub const MCIERR_FILENAME_REQUIRED: u32 = 304;
pub const MCIERR_EXTRA_CHARACTERS: u32 = 305;
pub const MCIERR_DEVICE_NOT_INSTALLED: u32 = 306;
pub const MCIERR_GET_CD: u32 = 307;
pub const MCIERR_SET_CD: u32 = 308;
pub const MCIERR_SET_DRIVE: u32 = 309;
pub const MCIERR_DEVICE_LENGTH: u32 = 310;
pub const MCIERR_DEVICE_ORD_LENGTH: u32 = 311;
pub const MCIERR_NO_INTEGER: u32 = 312;
pub const MCIERR_WAVE_OUTPUTSINUSE: u32 = 320;
pub const MCIERR_WAVE_SETOUTPUTINUSE: u32 = 321;
pub const MCIERR_WAVE_INPUTSINUSE: u32 = 322;
pub const MCIERR_WAVE_SETINPUTINUSE: u32 = 323;
pub const MCIERR_WAVE_OUTPUTUNSPECIFIED: u32 = 324;
pub const MCIERR_WAVE_INPUTUNSPECIFIED: u32 = 325;
pub const MCIERR_WAVE_OUTPUTSUNSUITABLE: u32 = 326;
pub const MCIERR_WAVE_SETOUTPUTUNSUITABLE: u32 = 327;
pub const MCIERR_WAVE_INPUTSUNSUITABLE: u32 = 328;
pub const MCIERR_WAVE_SETINPUTUNSUITABLE: u32 = 329;
pub const MCIERR_SEQ_DIV_INCOMPATIBLE: u32 = 336;
pub const MCIERR_SEQ_PORT_INUSE: u32 = 337;
pub const MCIERR_SEQ_PORT_NONEXISTENT: u32 = 338;
pub const MCIERR_SEQ_PORT_MAPNODEVICE: u32 = 339;
pub const MCIERR_SEQ_PORT_MISCERROR: u32 = 340;
pub const MCIERR_SEQ_TIMER: u32 = 341;
pub const MCIERR_SEQ_PORTUNSPECIFIED: u32 = 342;
pub const MCIERR_SEQ_NOMIDIPRESENT: u32 = 343;
pub const MCIERR_NO_WINDOW: u32 = 346;
pub const MCIERR_CREATEWINDOW: u32 = 347;
pub const MCIERR_FILE_READ: u32 = 348;
pub const MCIERR_FILE_WRITE: u32 = 349;
pub const MCIERR_NO_IDENTITY: u32 = 350;
pub const MCIERR_CUSTOM_DRIVER_BASE: u32 = 512;
pub const MCI_OPEN: u32 = 2051;
pub const MCI_CLOSE: u32 = 2052;
pub const MCI_ESCAPE: u32 = 2053;
pub const MCI_PLAY: u32 = 2054;
pub const MCI_SEEK: u32 = 2055;
pub const MCI_STOP: u32 = 2056;
pub const MCI_PAUSE: u32 = 2057;
pub const MCI_INFO: u32 = 2058;
pub const MCI_GETDEVCAPS: u32 = 2059;
pub const MCI_SPIN: u32 = 2060;
pub const MCI_SET: u32 = 2061;
pub const MCI_STEP: u32 = 2062;
pub const MCI_RECORD: u32 = 2063;
pub const MCI_SYSINFO: u32 = 2064;
pub const MCI_BREAK: u32 = 2065;
pub const MCI_SAVE: u32 = 2067;
pub const MCI_STATUS: u32 = 2068;
pub const MCI_CUE: u32 = 2096;
pub const MCI_REALIZE: u32 = 2112;
pub const MCI_WINDOW: u32 = 2113;
pub const MCI_PUT: u32 = 2114;
pub const MCI_WHERE: u32 = 2115;
pub const MCI_FREEZE: u32 = 2116;
pub const MCI_UNFREEZE: u32 = 2117;
pub const MCI_LOAD: u32 = 2128;
pub const MCI_CUT: u32 = 2129;
pub const MCI_COPY: u32 = 2130;
pub const MCI_PASTE: u32 = 2131;
pub const MCI_UPDATE: u32 = 2132;
pub const MCI_RESUME: u32 = 2133;
pub const MCI_DELETE: u32 = 2134;
pub const MCI_LAST: u32 = 4095;
pub const MCI_DEVTYPE_VCR: u32 = 513;
pub const MCI_DEVTYPE_VIDEODISC: u32 = 514;
pub const MCI_DEVTYPE_OVERLAY: u32 = 515;
pub const MCI_DEVTYPE_CD_AUDIO: u32 = 516;
pub const MCI_DEVTYPE_DAT: u32 = 517;
pub const MCI_DEVTYPE_SCANNER: u32 = 518;
pub const MCI_DEVTYPE_ANIMATION: u32 = 519;
pub const MCI_DEVTYPE_DIGITAL_VIDEO: u32 = 520;
pub const MCI_DEVTYPE_OTHER: u32 = 521;
pub const MCI_DEVTYPE_WAVEFORM_AUDIO: u32 = 522;
pub const MCI_DEVTYPE_SEQUENCER: u32 = 523;
pub const MCI_DEVTYPE_FIRST: u32 = 513;
pub const MCI_DEVTYPE_LAST: u32 = 523;
pub const MCI_DEVTYPE_FIRST_USER: u32 = 4096;
pub const MCI_MODE_NOT_READY: u32 = 524;
pub const MCI_MODE_STOP: u32 = 525;
pub const MCI_MODE_PLAY: u32 = 526;
pub const MCI_MODE_RECORD: u32 = 527;
pub const MCI_MODE_SEEK: u32 = 528;
pub const MCI_MODE_PAUSE: u32 = 529;
pub const MCI_MODE_OPEN: u32 = 530;
pub const MCI_FORMAT_MILLISECONDS: u32 = 0;
pub const MCI_FORMAT_HMS: u32 = 1;
pub const MCI_FORMAT_MSF: u32 = 2;
pub const MCI_FORMAT_FRAMES: u32 = 3;
pub const MCI_FORMAT_SMPTE_24: u32 = 4;
pub const MCI_FORMAT_SMPTE_25: u32 = 5;
pub const MCI_FORMAT_SMPTE_30: u32 = 6;
pub const MCI_FORMAT_SMPTE_30DROP: u32 = 7;
pub const MCI_FORMAT_BYTES: u32 = 8;
pub const MCI_FORMAT_SAMPLES: u32 = 9;
pub const MCI_FORMAT_TMSF: u32 = 10;
pub const MCI_NOTIFY_SUCCESSFUL: u32 = 1;
pub const MCI_NOTIFY_SUPERSEDED: u32 = 2;
pub const MCI_NOTIFY_ABORTED: u32 = 4;
pub const MCI_NOTIFY_FAILURE: u32 = 8;
pub const MCI_NOTIFY: u32 = 1;
pub const MCI_WAIT: u32 = 2;
pub const MCI_FROM: u32 = 4;
pub const MCI_TO: u32 = 8;
pub const MCI_TRACK: u32 = 16;
pub const MCI_OPEN_SHAREABLE: u32 = 256;
pub const MCI_OPEN_ELEMENT: u32 = 512;
pub const MCI_OPEN_ALIAS: u32 = 1024;
pub const MCI_OPEN_ELEMENT_ID: u32 = 2048;
pub const MCI_OPEN_TYPE_ID: u32 = 4096;
pub const MCI_OPEN_TYPE: u32 = 8192;
pub const MCI_SEEK_TO_START: u32 = 256;
pub const MCI_SEEK_TO_END: u32 = 512;
pub const MCI_STATUS_ITEM: u32 = 256;
pub const MCI_STATUS_START: u32 = 512;
pub const MCI_STATUS_LENGTH: u32 = 1;
pub const MCI_STATUS_POSITION: u32 = 2;
pub const MCI_STATUS_NUMBER_OF_TRACKS: u32 = 3;
pub const MCI_STATUS_MODE: u32 = 4;
pub const MCI_STATUS_MEDIA_PRESENT: u32 = 5;
pub const MCI_STATUS_TIME_FORMAT: u32 = 6;
pub const MCI_STATUS_READY: u32 = 7;
pub const MCI_STATUS_CURRENT_TRACK: u32 = 8;
pub const MCI_INFO_PRODUCT: u32 = 256;
pub const MCI_INFO_FILE: u32 = 512;
pub const MCI_INFO_MEDIA_UPC: u32 = 1024;
pub const MCI_INFO_MEDIA_IDENTITY: u32 = 2048;
pub const MCI_INFO_NAME: u32 = 4096;
pub const MCI_INFO_COPYRIGHT: u32 = 8192;
pub const MCI_GETDEVCAPS_ITEM: u32 = 256;
pub const MCI_GETDEVCAPS_CAN_RECORD: u32 = 1;
pub const MCI_GETDEVCAPS_HAS_AUDIO: u32 = 2;
pub const MCI_GETDEVCAPS_HAS_VIDEO: u32 = 3;
pub const MCI_GETDEVCAPS_DEVICE_TYPE: u32 = 4;
pub const MCI_GETDEVCAPS_USES_FILES: u32 = 5;
pub const MCI_GETDEVCAPS_COMPOUND_DEVICE: u32 = 6;
pub const MCI_GETDEVCAPS_CAN_EJECT: u32 = 7;
pub const MCI_GETDEVCAPS_CAN_PLAY: u32 = 8;
pub const MCI_GETDEVCAPS_CAN_SAVE: u32 = 9;
pub const MCI_SYSINFO_QUANTITY: u32 = 256;
pub const MCI_SYSINFO_OPEN: u32 = 512;
pub const MCI_SYSINFO_NAME: u32 = 1024;
pub const MCI_SYSINFO_INSTALLNAME: u32 = 2048;
pub const MCI_SET_DOOR_OPEN: u32 = 256;
pub const MCI_SET_DOOR_CLOSED: u32 = 512;
pub const MCI_SET_TIME_FORMAT: u32 = 1024;
pub const MCI_SET_AUDIO: u32 = 2048;
pub const MCI_SET_VIDEO: u32 = 4096;
pub const MCI_SET_ON: u32 = 8192;
pub const MCI_SET_OFF: u32 = 16384;
pub const MCI_SET_AUDIO_ALL: u32 = 0;
pub const MCI_SET_AUDIO_LEFT: u32 = 1;
pub const MCI_SET_AUDIO_RIGHT: u32 = 2;
pub const MCI_BREAK_KEY: u32 = 256;
pub const MCI_BREAK_HWND: u32 = 512;
pub const MCI_BREAK_OFF: u32 = 1024;
pub const MCI_RECORD_INSERT: u32 = 256;
pub const MCI_RECORD_OVERWRITE: u32 = 512;
pub const MCI_SAVE_FILE: u32 = 256;
pub const MCI_LOAD_FILE: u32 = 256;
pub const MCI_VD_MODE_PARK: u32 = 1025;
pub const MCI_VD_MEDIA_CLV: u32 = 1026;
pub const MCI_VD_MEDIA_CAV: u32 = 1027;
pub const MCI_VD_MEDIA_OTHER: u32 = 1028;
pub const MCI_VD_FORMAT_TRACK: u32 = 16385;
pub const MCI_VD_PLAY_REVERSE: u32 = 65536;
pub const MCI_VD_PLAY_FAST: u32 = 131072;
pub const MCI_VD_PLAY_SPEED: u32 = 262144;
pub const MCI_VD_PLAY_SCAN: u32 = 524288;
pub const MCI_VD_PLAY_SLOW: u32 = 1048576;
pub const MCI_VD_SEEK_REVERSE: u32 = 65536;
pub const MCI_VD_STATUS_SPEED: u32 = 16386;
pub const MCI_VD_STATUS_FORWARD: u32 = 16387;
pub const MCI_VD_STATUS_MEDIA_TYPE: u32 = 16388;
pub const MCI_VD_STATUS_SIDE: u32 = 16389;
pub const MCI_VD_STATUS_DISC_SIZE: u32 = 16390;
pub const MCI_VD_GETDEVCAPS_CLV: u32 = 65536;
pub const MCI_VD_GETDEVCAPS_CAV: u32 = 131072;
pub const MCI_VD_SPIN_UP: u32 = 65536;
pub const MCI_VD_SPIN_DOWN: u32 = 131072;
pub const MCI_VD_GETDEVCAPS_CAN_REVERSE: u32 = 16386;
pub const MCI_VD_GETDEVCAPS_FAST_RATE: u32 = 16387;
pub const MCI_VD_GETDEVCAPS_SLOW_RATE: u32 = 16388;
pub const MCI_VD_GETDEVCAPS_NORMAL_RATE: u32 = 16389;
pub const MCI_VD_STEP_FRAMES: u32 = 65536;
pub const MCI_VD_STEP_REVERSE: u32 = 131072;
pub const MCI_VD_ESCAPE_STRING: u32 = 256;
pub const MCI_CDA_STATUS_TYPE_TRACK: u32 = 16385;
pub const MCI_CDA_TRACK_AUDIO: u32 = 1088;
pub const MCI_CDA_TRACK_OTHER: u32 = 1089;
pub const MCI_WAVE_PCM: u32 = 1152;
pub const MCI_WAVE_MAPPER: u32 = 1153;
pub const MCI_WAVE_OPEN_BUFFER: u32 = 65536;
pub const MCI_WAVE_SET_FORMATTAG: u32 = 65536;
pub const MCI_WAVE_SET_CHANNELS: u32 = 131072;
pub const MCI_WAVE_SET_SAMPLESPERSEC: u32 = 262144;
pub const MCI_WAVE_SET_AVGBYTESPERSEC: u32 = 524288;
pub const MCI_WAVE_SET_BLOCKALIGN: u32 = 1048576;
pub const MCI_WAVE_SET_BITSPERSAMPLE: u32 = 2097152;
pub const MCI_WAVE_INPUT: u32 = 4194304;
pub const MCI_WAVE_OUTPUT: u32 = 8388608;
pub const MCI_WAVE_STATUS_FORMATTAG: u32 = 16385;
pub const MCI_WAVE_STATUS_CHANNELS: u32 = 16386;
pub const MCI_WAVE_STATUS_SAMPLESPERSEC: u32 = 16387;
pub const MCI_WAVE_STATUS_AVGBYTESPERSEC: u32 = 16388;
pub const MCI_WAVE_STATUS_BLOCKALIGN: u32 = 16389;
pub const MCI_WAVE_STATUS_BITSPERSAMPLE: u32 = 16390;
pub const MCI_WAVE_STATUS_LEVEL: u32 = 16391;
pub const MCI_WAVE_SET_ANYINPUT: u32 = 67108864;
pub const MCI_WAVE_SET_ANYOUTPUT: u32 = 134217728;
pub const MCI_WAVE_GETDEVCAPS_INPUTS: u32 = 16385;
pub const MCI_WAVE_GETDEVCAPS_OUTPUTS: u32 = 16386;
pub const MCI_SEQ_DIV_PPQN: u32 = 1216;
pub const MCI_SEQ_DIV_SMPTE_24: u32 = 1217;
pub const MCI_SEQ_DIV_SMPTE_25: u32 = 1218;
pub const MCI_SEQ_DIV_SMPTE_30DROP: u32 = 1219;
pub const MCI_SEQ_DIV_SMPTE_30: u32 = 1220;
pub const MCI_SEQ_FORMAT_SONGPTR: u32 = 16385;
pub const MCI_SEQ_FILE: u32 = 16386;
pub const MCI_SEQ_MIDI: u32 = 16387;
pub const MCI_SEQ_SMPTE: u32 = 16388;
pub const MCI_SEQ_NONE: u32 = 65533;
pub const MCI_SEQ_MAPPER: u32 = 65535;
pub const MCI_SEQ_STATUS_TEMPO: u32 = 16386;
pub const MCI_SEQ_STATUS_PORT: u32 = 16387;
pub const MCI_SEQ_STATUS_SLAVE: u32 = 16391;
pub const MCI_SEQ_STATUS_MASTER: u32 = 16392;
pub const MCI_SEQ_STATUS_OFFSET: u32 = 16393;
pub const MCI_SEQ_STATUS_DIVTYPE: u32 = 16394;
pub const MCI_SEQ_STATUS_NAME: u32 = 16395;
pub const MCI_SEQ_STATUS_COPYRIGHT: u32 = 16396;
pub const MCI_SEQ_SET_TEMPO: u32 = 65536;
pub const MCI_SEQ_SET_PORT: u32 = 131072;
pub const MCI_SEQ_SET_SLAVE: u32 = 262144;
pub const MCI_SEQ_SET_MASTER: u32 = 524288;
pub const MCI_SEQ_SET_OFFSET: u32 = 16777216;
pub const MCI_ANIM_OPEN_WS: u32 = 65536;
pub const MCI_ANIM_OPEN_PARENT: u32 = 131072;
pub const MCI_ANIM_OPEN_NOSTATIC: u32 = 262144;
pub const MCI_ANIM_PLAY_SPEED: u32 = 65536;
pub const MCI_ANIM_PLAY_REVERSE: u32 = 131072;
pub const MCI_ANIM_PLAY_FAST: u32 = 262144;
pub const MCI_ANIM_PLAY_SLOW: u32 = 524288;
pub const MCI_ANIM_PLAY_SCAN: u32 = 1048576;
pub const MCI_ANIM_STEP_REVERSE: u32 = 65536;
pub const MCI_ANIM_STEP_FRAMES: u32 = 131072;
pub const MCI_ANIM_STATUS_SPEED: u32 = 16385;
pub const MCI_ANIM_STATUS_FORWARD: u32 = 16386;
pub const MCI_ANIM_STATUS_HWND: u32 = 16387;
pub const MCI_ANIM_STATUS_HPAL: u32 = 16388;
pub const MCI_ANIM_STATUS_STRETCH: u32 = 16389;
pub const MCI_ANIM_INFO_TEXT: u32 = 65536;
pub const MCI_ANIM_GETDEVCAPS_CAN_REVERSE: u32 = 16385;
pub const MCI_ANIM_GETDEVCAPS_FAST_RATE: u32 = 16386;
pub const MCI_ANIM_GETDEVCAPS_SLOW_RATE: u32 = 16387;
pub const MCI_ANIM_GETDEVCAPS_NORMAL_RATE: u32 = 16388;
pub const MCI_ANIM_GETDEVCAPS_PALETTES: u32 = 16390;
pub const MCI_ANIM_GETDEVCAPS_CAN_STRETCH: u32 = 16391;
pub const MCI_ANIM_GETDEVCAPS_MAX_WINDOWS: u32 = 16392;
pub const MCI_ANIM_REALIZE_NORM: u32 = 65536;
pub const MCI_ANIM_REALIZE_BKGD: u32 = 131072;
pub const MCI_ANIM_WINDOW_HWND: u32 = 65536;
pub const MCI_ANIM_WINDOW_STATE: u32 = 262144;
pub const MCI_ANIM_WINDOW_TEXT: u32 = 524288;
pub const MCI_ANIM_WINDOW_ENABLE_STRETCH: u32 = 1048576;
pub const MCI_ANIM_WINDOW_DISABLE_STRETCH: u32 = 2097152;
pub const MCI_ANIM_WINDOW_DEFAULT: u32 = 0;
pub const MCI_ANIM_RECT: u32 = 65536;
pub const MCI_ANIM_PUT_SOURCE: u32 = 131072;
pub const MCI_ANIM_PUT_DESTINATION: u32 = 262144;
pub const MCI_ANIM_WHERE_SOURCE: u32 = 131072;
pub const MCI_ANIM_WHERE_DESTINATION: u32 = 262144;
pub const MCI_ANIM_UPDATE_HDC: u32 = 131072;
pub const MCI_OVLY_OPEN_WS: u32 = 65536;
pub const MCI_OVLY_OPEN_PARENT: u32 = 131072;
pub const MCI_OVLY_STATUS_HWND: u32 = 16385;
pub const MCI_OVLY_STATUS_STRETCH: u32 = 16386;
pub const MCI_OVLY_INFO_TEXT: u32 = 65536;
pub const MCI_OVLY_GETDEVCAPS_CAN_STRETCH: u32 = 16385;
pub const MCI_OVLY_GETDEVCAPS_CAN_FREEZE: u32 = 16386;
pub const MCI_OVLY_GETDEVCAPS_MAX_WINDOWS: u32 = 16387;
pub const MCI_OVLY_WINDOW_HWND: u32 = 65536;
pub const MCI_OVLY_WINDOW_STATE: u32 = 262144;
pub const MCI_OVLY_WINDOW_TEXT: u32 = 524288;
pub const MCI_OVLY_WINDOW_ENABLE_STRETCH: u32 = 1048576;
pub const MCI_OVLY_WINDOW_DISABLE_STRETCH: u32 = 2097152;
pub const MCI_OVLY_WINDOW_DEFAULT: u32 = 0;
pub const MCI_OVLY_RECT: u32 = 65536;
pub const MCI_OVLY_PUT_SOURCE: u32 = 131072;
pub const MCI_OVLY_PUT_DESTINATION: u32 = 262144;
pub const MCI_OVLY_PUT_FRAME: u32 = 524288;
pub const MCI_OVLY_PUT_VIDEO: u32 = 1048576;
pub const MCI_OVLY_WHERE_SOURCE: u32 = 131072;
pub const MCI_OVLY_WHERE_DESTINATION: u32 = 262144;
pub const MCI_OVLY_WHERE_FRAME: u32 = 524288;
pub const MCI_OVLY_WHERE_VIDEO: u32 = 1048576;
pub const DRV_LOAD: u32 = 1;
pub const DRV_ENABLE: u32 = 2;
pub const DRV_OPEN: u32 = 3;
pub const DRV_CLOSE: u32 = 4;
pub const DRV_DISABLE: u32 = 5;
pub const DRV_FREE: u32 = 6;
pub const DRV_CONFIGURE: u32 = 7;
pub const DRV_QUERYCONFIGURE: u32 = 8;
pub const DRV_INSTALL: u32 = 9;
pub const DRV_REMOVE: u32 = 10;
pub const DRV_EXITSESSION: u32 = 11;
pub const DRV_POWER: u32 = 15;
pub const DRV_RESERVED: u32 = 2048;
pub const DRV_USER: u32 = 16384;
pub const DRVCNF_CANCEL: u32 = 0;
pub const DRVCNF_OK: u32 = 1;
pub const DRVCNF_RESTART: u32 = 2;
pub const DRV_CANCEL: u32 = 0;
pub const DRV_OK: u32 = 1;
pub const DRV_RESTART: u32 = 2;
pub const DRV_MCI_FIRST: u32 = 2048;
pub const DRV_MCI_LAST: u32 = 6143;
pub const MMIOERR_BASE: u32 = 256;
pub const MMIOERR_FILENOTFOUND: u32 = 257;
pub const MMIOERR_OUTOFMEMORY: u32 = 258;
pub const MMIOERR_CANNOTOPEN: u32 = 259;
pub const MMIOERR_CANNOTCLOSE: u32 = 260;
pub const MMIOERR_CANNOTREAD: u32 = 261;
pub const MMIOERR_CANNOTWRITE: u32 = 262;
pub const MMIOERR_CANNOTSEEK: u32 = 263;
pub const MMIOERR_CANNOTEXPAND: u32 = 264;
pub const MMIOERR_CHUNKNOTFOUND: u32 = 265;
pub const MMIOERR_UNBUFFERED: u32 = 266;
pub const MMIOERR_PATHNOTFOUND: u32 = 267;
pub const MMIOERR_ACCESSDENIED: u32 = 268;
pub const MMIOERR_SHARINGVIOLATION: u32 = 269;
pub const MMIOERR_NETWORKERROR: u32 = 270;
pub const MMIOERR_TOOMANYOPENFILES: u32 = 271;
pub const MMIOERR_INVALIDFILE: u32 = 272;
pub const CFSEPCHAR: u8 = 43u8;
pub const MMIO_RWMODE: u32 = 3;
pub const MMIO_SHAREMODE: u32 = 112;
pub const MMIO_CREATE: u32 = 4096;
pub const MMIO_PARSE: u32 = 256;
pub const MMIO_DELETE: u32 = 512;
pub const MMIO_EXIST: u32 = 16384;
pub const MMIO_ALLOCBUF: u32 = 65536;
pub const MMIO_GETTEMP: u32 = 131072;
pub const MMIO_DIRTY: u32 = 268435456;
pub const MMIO_READ: u32 = 0;
pub const MMIO_WRITE: u32 = 1;
pub const MMIO_READWRITE: u32 = 2;
pub const MMIO_COMPAT: u32 = 0;
pub const MMIO_EXCLUSIVE: u32 = 16;
pub const MMIO_DENYWRITE: u32 = 32;
pub const MMIO_DENYREAD: u32 = 48;
pub const MMIO_DENYNONE: u32 = 64;
pub const MMIO_FHOPEN: u32 = 16;
pub const MMIO_EMPTYBUF: u32 = 16;
pub const MMIO_TOUPPER: u32 = 16;
pub const MMIO_INSTALLPROC: u32 = 65536;
pub const MMIO_GLOBALPROC: u32 = 268435456;
pub const MMIO_REMOVEPROC: u32 = 131072;
pub const MMIO_UNICODEPROC: u32 = 16777216;
pub const MMIO_FINDPROC: u32 = 262144;
pub const MMIO_FINDCHUNK: u32 = 16;
pub const MMIO_FINDRIFF: u32 = 32;
pub const MMIO_FINDLIST: u32 = 64;
pub const MMIO_CREATERIFF: u32 = 32;
pub const MMIO_CREATELIST: u32 = 64;
pub const MMIOM_READ: u32 = 0;
pub const MMIOM_WRITE: u32 = 1;
pub const MMIOM_SEEK: u32 = 2;
pub const MMIOM_OPEN: u32 = 3;
pub const MMIOM_CLOSE: u32 = 4;
pub const MMIOM_WRITEFLUSH: u32 = 5;
pub const MMIOM_RENAME: u32 = 6;
pub const MMIOM_USER: u32 = 32768;
pub const SEEK_SET: u32 = 0;
pub const SEEK_CUR: u32 = 1;
pub const SEEK_END: u32 = 2;
pub const MMIO_DEFAULTBUFFER: u32 = 8192;
pub const TIME_ONESHOT: u32 = 0;
pub const TIME_PERIODIC: u32 = 1;
pub const TIME_CALLBACK_FUNCTION: u32 = 0;
pub const TIME_CALLBACK_EVENT_SET: u32 = 16;
pub const TIME_CALLBACK_EVENT_PULSE: u32 = 32;
pub const TIME_KILL_SYNCHRONOUS: u32 = 256;
pub const SND_SYNC: u32 = 0;
pub const SND_ASYNC: u32 = 1;
pub const SND_NODEFAULT: u32 = 2;
pub const SND_MEMORY: u32 = 4;
pub const SND_LOOP: u32 = 8;
pub const SND_NOSTOP: u32 = 16;
pub const SND_NOWAIT: u32 = 8192;
pub const SND_ALIAS: u32 = 65536;
pub const SND_ALIAS_ID: u32 = 1114112;
pub const SND_FILENAME: u32 = 131072;
pub const SND_RESOURCE: u32 = 262148;
pub const SND_PURGE: u32 = 64;
pub const SND_APPLICATION: u32 = 128;
pub const SND_SENTRY: u32 = 524288;
pub const SND_RING: u32 = 1048576;
pub const SND_SYSTEM: u32 = 2097152;
pub const SND_ALIAS_START: u32 = 0;
pub const WAVERR_BADFORMAT: u32 = 32;
pub const WAVERR_STILLPLAYING: u32 = 33;
pub const WAVERR_UNPREPARED: u32 = 34;
pub const WAVERR_SYNC: u32 = 35;
pub const WAVERR_LASTERROR: u32 = 35;
pub const WOM_OPEN: u32 = 955;
pub const WOM_CLOSE: u32 = 956;
pub const WOM_DONE: u32 = 957;
pub const WIM_OPEN: u32 = 958;
pub const WIM_CLOSE: u32 = 959;
pub const WIM_DATA: u32 = 960;
pub const WAVE_FORMAT_QUERY: u32 = 1;
pub const WAVE_ALLOWSYNC: u32 = 2;
pub const WAVE_MAPPED: u32 = 4;
pub const WAVE_FORMAT_DIRECT: u32 = 8;
pub const WAVE_FORMAT_DIRECT_QUERY: u32 = 9;
pub const WAVE_MAPPED_DEFAULT_COMMUNICATION_DEVICE: u32 = 16;
pub const WHDR_DONE: u32 = 1;
pub const WHDR_PREPARED: u32 = 2;
pub const WHDR_BEGINLOOP: u32 = 4;
pub const WHDR_ENDLOOP: u32 = 8;
pub const WHDR_INQUEUE: u32 = 16;
pub const WAVECAPS_PITCH: u32 = 1;
pub const WAVECAPS_PLAYBACKRATE: u32 = 2;
pub const WAVECAPS_VOLUME: u32 = 4;
pub const WAVECAPS_LRVOLUME: u32 = 8;
pub const WAVECAPS_SYNC: u32 = 16;
pub const WAVECAPS_SAMPLEACCURATE: u32 = 32;
pub const WAVE_INVALIDFORMAT: u32 = 0;
pub const WAVE_FORMAT_1M08: u32 = 1;
pub const WAVE_FORMAT_1S08: u32 = 2;
pub const WAVE_FORMAT_1M16: u32 = 4;
pub const WAVE_FORMAT_1S16: u32 = 8;
pub const WAVE_FORMAT_2M08: u32 = 16;
pub const WAVE_FORMAT_2S08: u32 = 32;
pub const WAVE_FORMAT_2M16: u32 = 64;
pub const WAVE_FORMAT_2S16: u32 = 128;
pub const WAVE_FORMAT_4M08: u32 = 256;
pub const WAVE_FORMAT_4S08: u32 = 512;
pub const WAVE_FORMAT_4M16: u32 = 1024;
pub const WAVE_FORMAT_4S16: u32 = 2048;
pub const WAVE_FORMAT_44M08: u32 = 256;
pub const WAVE_FORMAT_44S08: u32 = 512;
pub const WAVE_FORMAT_44M16: u32 = 1024;
pub const WAVE_FORMAT_44S16: u32 = 2048;
pub const WAVE_FORMAT_48M08: u32 = 4096;
pub const WAVE_FORMAT_48S08: u32 = 8192;
pub const WAVE_FORMAT_48M16: u32 = 16384;
pub const WAVE_FORMAT_48S16: u32 = 32768;
pub const WAVE_FORMAT_96M08: u32 = 65536;
pub const WAVE_FORMAT_96S08: u32 = 131072;
pub const WAVE_FORMAT_96M16: u32 = 262144;
pub const WAVE_FORMAT_96S16: u32 = 524288;
pub const WAVE_FORMAT_PCM: u32 = 1;
pub const MIDIERR_UNPREPARED: u32 = 64;
pub const MIDIERR_STILLPLAYING: u32 = 65;
pub const MIDIERR_NOMAP: u32 = 66;
pub const MIDIERR_NOTREADY: u32 = 67;
pub const MIDIERR_NODEVICE: u32 = 68;
pub const MIDIERR_INVALIDSETUP: u32 = 69;
pub const MIDIERR_BADOPENMODE: u32 = 70;
pub const MIDIERR_DONT_CONTINUE: u32 = 71;
pub const MIDIERR_LASTERROR: u32 = 71;
pub const MIDIPATCHSIZE: u32 = 128;
pub const MIM_OPEN: u32 = 961;
pub const MIM_CLOSE: u32 = 962;
pub const MIM_DATA: u32 = 963;
pub const MIM_LONGDATA: u32 = 964;
pub const MIM_ERROR: u32 = 965;
pub const MIM_LONGERROR: u32 = 966;
pub const MOM_OPEN: u32 = 967;
pub const MOM_CLOSE: u32 = 968;
pub const MOM_DONE: u32 = 969;
pub const MIM_MOREDATA: u32 = 972;
pub const MOM_POSITIONCB: u32 = 970;
pub const MIDI_IO_STATUS: u32 = 32;
pub const MIDI_CACHE_ALL: u32 = 1;
pub const MIDI_CACHE_BESTFIT: u32 = 2;
pub const MIDI_CACHE_QUERY: u32 = 3;
pub const MIDI_UNCACHE: u32 = 4;
pub const MOD_MIDIPORT: u32 = 1;
pub const MOD_SYNTH: u32 = 2;
pub const MOD_SQSYNTH: u32 = 3;
pub const MOD_FMSYNTH: u32 = 4;
pub const MOD_MAPPER: u32 = 5;
pub const MOD_WAVETABLE: u32 = 6;
pub const MOD_SWSYNTH: u32 = 7;
pub const MIDICAPS_VOLUME: u32 = 1;
pub const MIDICAPS_LRVOLUME: u32 = 2;
pub const MIDICAPS_CACHE: u32 = 4;
pub const MIDICAPS_STREAM: u32 = 8;
pub const MHDR_DONE: u32 = 1;
pub const MHDR_PREPARED: u32 = 2;
pub const MHDR_INQUEUE: u32 = 4;
pub const MHDR_ISSTRM: u32 = 8;
pub const MEVT_F_SHORT: u32 = 0;
pub const MEVT_F_LONG: u32 = 2147483648;
pub const MEVT_F_CALLBACK: u32 = 1073741824;
pub const MIDISTRM_ERROR: i32 = -2;
pub const MIDIPROP_SET: u32 = 2147483648;
pub const MIDIPROP_GET: u32 = 1073741824;
pub const MIDIPROP_TIMEDIV: u32 = 1;
pub const MIDIPROP_TEMPO: u32 = 2;
pub const AUXCAPS_CDAUDIO: u32 = 1;
pub const AUXCAPS_AUXIN: u32 = 2;
pub const AUXCAPS_VOLUME: u32 = 1;
pub const AUXCAPS_LRVOLUME: u32 = 2;
pub const MIXER_SHORT_NAME_CHARS: u32 = 16;
pub const MIXER_LONG_NAME_CHARS: u32 = 64;
pub const MIXERR_INVALLINE: u32 = 1024;
pub const MIXERR_INVALCONTROL: u32 = 1025;
pub const MIXERR_INVALVALUE: u32 = 1026;
pub const MIXERR_LASTERROR: u32 = 1026;
pub const MIXER_OBJECTF_HANDLE: u32 = 2147483648;
pub const MIXER_OBJECTF_MIXER: u32 = 0;
pub const MIXER_OBJECTF_HMIXER: u32 = 2147483648;
pub const MIXER_OBJECTF_WAVEOUT: u32 = 268435456;
pub const MIXER_OBJECTF_HWAVEOUT: u32 = 2415919104;
pub const MIXER_OBJECTF_WAVEIN: u32 = 536870912;
pub const MIXER_OBJECTF_HWAVEIN: u32 = 2684354560;
pub const MIXER_OBJECTF_MIDIOUT: u32 = 805306368;
pub const MIXER_OBJECTF_HMIDIOUT: u32 = 2952790016;
pub const MIXER_OBJECTF_MIDIIN: u32 = 1073741824;
pub const MIXER_OBJECTF_HMIDIIN: u32 = 3221225472;
pub const MIXER_OBJECTF_AUX: u32 = 1342177280;
pub const MIXERLINE_LINEF_ACTIVE: u32 = 1;
pub const MIXERLINE_LINEF_DISCONNECTED: u32 = 32768;
pub const MIXERLINE_LINEF_SOURCE: u32 = 2147483648;
pub const MIXERLINE_COMPONENTTYPE_DST_FIRST: u32 = 0;
pub const MIXERLINE_COMPONENTTYPE_DST_UNDEFINED: u32 = 0;
pub const MIXERLINE_COMPONENTTYPE_DST_DIGITAL: u32 = 1;
pub const MIXERLINE_COMPONENTTYPE_DST_LINE: u32 = 2;
pub const MIXERLINE_COMPONENTTYPE_DST_MONITOR: u32 = 3;
pub const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS: u32 = 4;
pub const MIXERLINE_COMPONENTTYPE_DST_HEADPHONES: u32 = 5;
pub const MIXERLINE_COMPONENTTYPE_DST_TELEPHONE: u32 = 6;
pub const MIXERLINE_COMPONENTTYPE_DST_WAVEIN: u32 = 7;
pub const MIXERLINE_COMPONENTTYPE_DST_VOICEIN: u32 = 8;
pub const MIXERLINE_COMPONENTTYPE_DST_LAST: u32 = 8;
pub const MIXERLINE_COMPONENTTYPE_SRC_FIRST: u32 = 4096;
pub const MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED: u32 = 4096;
pub const MIXERLINE_COMPONENTTYPE_SRC_DIGITAL: u32 = 4097;
pub const MIXERLINE_COMPONENTTYPE_SRC_LINE: u32 = 4098;
pub const MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE: u32 = 4099;
pub const MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER: u32 = 4100;
pub const MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC: u32 = 4101;
pub const MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE: u32 = 4102;
pub const MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER: u32 = 4103;
pub const MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT: u32 = 4104;
pub const MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY: u32 = 4105;
pub const MIXERLINE_COMPONENTTYPE_SRC_ANALOG: u32 = 4106;
pub const MIXERLINE_COMPONENTTYPE_SRC_LAST: u32 = 4106;
pub const MIXERLINE_TARGETTYPE_UNDEFINED: u32 = 0;
pub const MIXERLINE_TARGETTYPE_WAVEOUT: u32 = 1;
pub const MIXERLINE_TARGETTYPE_WAVEIN: u32 = 2;
pub const MIXERLINE_TARGETTYPE_MIDIOUT: u32 = 3;
pub const MIXERLINE_TARGETTYPE_MIDIIN: u32 = 4;
pub const MIXERLINE_TARGETTYPE_AUX: u32 = 5;
pub const MIXER_GETLINEINFOF_DESTINATION: u32 = 0;
pub const MIXER_GETLINEINFOF_SOURCE: u32 = 1;
pub const MIXER_GETLINEINFOF_LINEID: u32 = 2;
pub const MIXER_GETLINEINFOF_COMPONENTTYPE: u32 = 3;
pub const MIXER_GETLINEINFOF_TARGETTYPE: u32 = 4;
pub const MIXER_GETLINEINFOF_QUERYMASK: u32 = 15;
pub const MIXERCONTROL_CONTROLF_UNIFORM: u32 = 1;
pub const MIXERCONTROL_CONTROLF_MULTIPLE: u32 = 2;
pub const MIXERCONTROL_CONTROLF_DISABLED: u32 = 2147483648;
pub const MIXERCONTROL_CT_CLASS_MASK: u32 = 4026531840;
pub const MIXERCONTROL_CT_CLASS_CUSTOM: u32 = 0;
pub const MIXERCONTROL_CT_CLASS_METER: u32 = 268435456;
pub const MIXERCONTROL_CT_CLASS_SWITCH: u32 = 536870912;
pub const MIXERCONTROL_CT_CLASS_NUMBER: u32 = 805306368;
pub const MIXERCONTROL_CT_CLASS_SLIDER: u32 = 1073741824;
pub const MIXERCONTROL_CT_CLASS_FADER: u32 = 1342177280;
pub const MIXERCONTROL_CT_CLASS_TIME: u32 = 1610612736;
pub const MIXERCONTROL_CT_CLASS_LIST: u32 = 1879048192;
pub const MIXERCONTROL_CT_SUBCLASS_MASK: u32 = 251658240;
pub const MIXERCONTROL_CT_SC_SWITCH_BOOLEAN: u32 = 0;
pub const MIXERCONTROL_CT_SC_SWITCH_BUTTON: u32 = 16777216;
pub const MIXERCONTROL_CT_SC_METER_POLLED: u32 = 0;
pub const MIXERCONTROL_CT_SC_TIME_MICROSECS: u32 = 0;
pub const MIXERCONTROL_CT_SC_TIME_MILLISECS: u32 = 16777216;
pub const MIXERCONTROL_CT_SC_LIST_SINGLE: u32 = 0;
pub const MIXERCONTROL_CT_SC_LIST_MULTIPLE: u32 = 16777216;
pub const MIXERCONTROL_CT_UNITS_MASK: u32 = 16711680;
pub const MIXERCONTROL_CT_UNITS_CUSTOM: u32 = 0;
pub const MIXERCONTROL_CT_UNITS_BOOLEAN: u32 = 65536;
pub const MIXERCONTROL_CT_UNITS_SIGNED: u32 = 131072;
pub const MIXERCONTROL_CT_UNITS_UNSIGNED: u32 = 196608;
pub const MIXERCONTROL_CT_UNITS_DECIBELS: u32 = 262144;
pub const MIXERCONTROL_CT_UNITS_PERCENT: u32 = 327680;
pub const MIXERCONTROL_CONTROLTYPE_CUSTOM: u32 = 0;
pub const MIXERCONTROL_CONTROLTYPE_BOOLEANMETER: u32 = 268500992;
pub const MIXERCONTROL_CONTROLTYPE_SIGNEDMETER: u32 = 268566528;
pub const MIXERCONTROL_CONTROLTYPE_PEAKMETER: u32 = 268566529;
pub const MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER: u32 = 268632064;
pub const MIXERCONTROL_CONTROLTYPE_BOOLEAN: u32 = 536936448;
pub const MIXERCONTROL_CONTROLTYPE_ONOFF: u32 = 536936449;
pub const MIXERCONTROL_CONTROLTYPE_MUTE: u32 = 536936450;
pub const MIXERCONTROL_CONTROLTYPE_MONO: u32 = 536936451;
pub const MIXERCONTROL_CONTROLTYPE_LOUDNESS: u32 = 536936452;
pub const MIXERCONTROL_CONTROLTYPE_STEREOENH: u32 = 536936453;
pub const MIXERCONTROL_CONTROLTYPE_BASS_BOOST: u32 = 536945271;
pub const MIXERCONTROL_CONTROLTYPE_BUTTON: u32 = 553713664;
pub const MIXERCONTROL_CONTROLTYPE_DECIBELS: u32 = 805568512;
pub const MIXERCONTROL_CONTROLTYPE_SIGNED: u32 = 805437440;
pub const MIXERCONTROL_CONTROLTYPE_UNSIGNED: u32 = 805502976;
pub const MIXERCONTROL_CONTROLTYPE_PERCENT: u32 = 805634048;
pub const MIXERCONTROL_CONTROLTYPE_SLIDER: u32 = 1073872896;
pub const MIXERCONTROL_CONTROLTYPE_PAN: u32 = 1073872897;
pub const MIXERCONTROL_CONTROLTYPE_QSOUNDPAN: u32 = 1073872898;
pub const MIXERCONTROL_CONTROLTYPE_FADER: u32 = 1342373888;
pub const MIXERCONTROL_CONTROLTYPE_VOLUME: u32 = 1342373889;
pub const MIXERCONTROL_CONTROLTYPE_BASS: u32 = 1342373890;
pub const MIXERCONTROL_CONTROLTYPE_TREBLE: u32 = 1342373891;
pub const MIXERCONTROL_CONTROLTYPE_EQUALIZER: u32 = 1342373892;
pub const MIXERCONTROL_CONTROLTYPE_SINGLESELECT: u32 = 1879113728;
pub const MIXERCONTROL_CONTROLTYPE_MUX: u32 = 1879113729;
pub const MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT: u32 = 1895890944;
pub const MIXERCONTROL_CONTROLTYPE_MIXER: u32 = 1895890945;
pub const MIXERCONTROL_CONTROLTYPE_MICROTIME: u32 = 1610809344;
pub const MIXERCONTROL_CONTROLTYPE_MILLITIME: u32 = 1627586560;
pub const MIXER_GETLINECONTROLSF_ALL: u32 = 0;
pub const MIXER_GETLINECONTROLSF_ONEBYID: u32 = 1;
pub const MIXER_GETLINECONTROLSF_ONEBYTYPE: u32 = 2;
pub const MIXER_GETLINECONTROLSF_QUERYMASK: u32 = 15;
pub const MIXER_GETCONTROLDETAILSF_VALUE: u32 = 0;
pub const MIXER_GETCONTROLDETAILSF_LISTTEXT: u32 = 1;
pub const MIXER_GETCONTROLDETAILSF_QUERYMASK: u32 = 15;
pub const MIXER_SETCONTROLDETAILSF_VALUE: u32 = 0;
pub const MIXER_SETCONTROLDETAILSF_CUSTOM: u32 = 1;
pub const MIXER_SETCONTROLDETAILSF_QUERYMASK: u32 = 15;
pub const TIMERR_NOERROR: u32 = 0;
pub const TIMERR_NOCANDO: u32 = 97;
pub const TIMERR_STRUCT: u32 = 129;
pub const JOYERR_NOERROR: u32 = 0;
pub const JOYERR_PARMS: u32 = 165;
pub const JOYERR_NOCANDO: u32 = 166;
pub const JOYERR_UNPLUGGED: u32 = 167;
pub const JOY_BUTTON1: u32 = 1;
pub const JOY_BUTTON2: u32 = 2;
pub const JOY_BUTTON3: u32 = 4;
pub const JOY_BUTTON4: u32 = 8;
pub const JOY_BUTTON1CHG: u32 = 256;
pub const JOY_BUTTON2CHG: u32 = 512;
pub const JOY_BUTTON3CHG: u32 = 1024;
pub const JOY_BUTTON4CHG: u32 = 2048;
pub const JOY_BUTTON5: u32 = 16;
pub const JOY_BUTTON6: u32 = 32;
pub const JOY_BUTTON7: u32 = 64;
pub const JOY_BUTTON8: u32 = 128;
pub const JOY_BUTTON9: u32 = 256;
pub const JOY_BUTTON10: u32 = 512;
pub const JOY_BUTTON11: u32 = 1024;
pub const JOY_BUTTON12: u32 = 2048;
pub const JOY_BUTTON13: u32 = 4096;
pub const JOY_BUTTON14: u32 = 8192;
pub const JOY_BUTTON15: u32 = 16384;
pub const JOY_BUTTON16: u32 = 32768;
pub const JOY_BUTTON17: u32 = 65536;
pub const JOY_BUTTON18: u32 = 131072;
pub const JOY_BUTTON19: u32 = 262144;
pub const JOY_BUTTON20: u32 = 524288;
pub const JOY_BUTTON21: u32 = 1048576;
pub const JOY_BUTTON22: u32 = 2097152;
pub const JOY_BUTTON23: u32 = 4194304;
pub const JOY_BUTTON24: u32 = 8388608;
pub const JOY_BUTTON25: u32 = 16777216;
pub const JOY_BUTTON26: u32 = 33554432;
pub const JOY_BUTTON27: u32 = 67108864;
pub const JOY_BUTTON28: u32 = 134217728;
pub const JOY_BUTTON29: u32 = 268435456;
pub const JOY_BUTTON30: u32 = 536870912;
pub const JOY_BUTTON31: u32 = 1073741824;
pub const JOY_BUTTON32: u32 = 2147483648;
pub const JOY_POVFORWARD: u32 = 0;
pub const JOY_POVRIGHT: u32 = 9000;
pub const JOY_POVBACKWARD: u32 = 18000;
pub const JOY_POVLEFT: u32 = 27000;
pub const JOY_RETURNX: u32 = 1;
pub const JOY_RETURNY: u32 = 2;
pub const JOY_RETURNZ: u32 = 4;
pub const JOY_RETURNR: u32 = 8;
pub const JOY_RETURNU: u32 = 16;
pub const JOY_RETURNV: u32 = 32;
pub const JOY_RETURNPOV: u32 = 64;
pub const JOY_RETURNBUTTONS: u32 = 128;
pub const JOY_RETURNRAWDATA: u32 = 256;
pub const JOY_RETURNPOVCTS: u32 = 512;
pub const JOY_RETURNCENTERED: u32 = 1024;
pub const JOY_USEDEADZONE: u32 = 2048;
pub const JOY_RETURNALL: u32 = 255;
pub const JOY_CAL_READALWAYS: u32 = 65536;
pub const JOY_CAL_READXYONLY: u32 = 131072;
pub const JOY_CAL_READ3: u32 = 262144;
pub const JOY_CAL_READ4: u32 = 524288;
pub const JOY_CAL_READXONLY: u32 = 1048576;
pub const JOY_CAL_READYONLY: u32 = 2097152;
pub const JOY_CAL_READ5: u32 = 4194304;
pub const JOY_CAL_READ6: u32 = 8388608;
pub const JOY_CAL_READZONLY: u32 = 16777216;
pub const JOY_CAL_READRONLY: u32 = 33554432;
pub const JOY_CAL_READUONLY: u32 = 67108864;
pub const JOY_CAL_READVONLY: u32 = 134217728;
pub const JOYSTICKID1: u32 = 0;
pub const JOYSTICKID2: u32 = 1;
pub const JOYCAPS_HASZ: u32 = 1;
pub const JOYCAPS_HASR: u32 = 2;
pub const JOYCAPS_HASU: u32 = 4;
pub const JOYCAPS_HASV: u32 = 8;
pub const JOYCAPS_HASPOV: u32 = 16;
pub const JOYCAPS_POV4DIR: u32 = 32;
pub const JOYCAPS_POVCTS: u32 = 64;
pub const NEWTRANSPARENT: u32 = 3;
pub const QUERYROPSUPPORT: u32 = 40;
pub const SELECTDIB: u32 = 41;
pub const NCBNAMSZ: u32 = 16;
pub const MAX_LANA: u32 = 254;
pub const NAME_FLAGS_MASK: u32 = 135;
pub const GROUP_NAME: u32 = 128;
pub const UNIQUE_NAME: u32 = 0;
pub const REGISTERING: u32 = 0;
pub const REGISTERED: u32 = 4;
pub const DEREGISTERED: u32 = 5;
pub const DUPLICATE: u32 = 6;
pub const DUPLICATE_DEREG: u32 = 7;
pub const LISTEN_OUTSTANDING: u32 = 1;
pub const CALL_PENDING: u32 = 2;
pub const SESSION_ESTABLISHED: u32 = 3;
pub const HANGUP_PENDING: u32 = 4;
pub const HANGUP_COMPLETE: u32 = 5;
pub const SESSION_ABORTED: u32 = 6;
pub const ALL_TRANSPORTS: &[u8; 5] = b"M\0\0\0\0";
pub const MS_NBF: &[u8; 5] = b"MNBF\0";
pub const NCBCALL: u32 = 16;
pub const NCBLISTEN: u32 = 17;
pub const NCBHANGUP: u32 = 18;
pub const NCBSEND: u32 = 20;
pub const NCBRECV: u32 = 21;
pub const NCBRECVANY: u32 = 22;
pub const NCBCHAINSEND: u32 = 23;
pub const NCBDGSEND: u32 = 32;
pub const NCBDGRECV: u32 = 33;
pub const NCBDGSENDBC: u32 = 34;
pub const NCBDGRECVBC: u32 = 35;
pub const NCBADDNAME: u32 = 48;
pub const NCBDELNAME: u32 = 49;
pub const NCBRESET: u32 = 50;
pub const NCBASTAT: u32 = 51;
pub const NCBSSTAT: u32 = 52;
pub const NCBCANCEL: u32 = 53;
pub const NCBADDGRNAME: u32 = 54;
pub const NCBENUM: u32 = 55;
pub const NCBUNLINK: u32 = 112;
pub const NCBSENDNA: u32 = 113;
pub const NCBCHAINSENDNA: u32 = 114;
pub const NCBLANSTALERT: u32 = 115;
pub const NCBACTION: u32 = 119;
pub const NCBFINDNAME: u32 = 120;
pub const NCBTRACE: u32 = 121;
pub const ASYNCH: u32 = 128;
pub const NRC_GOODRET: u32 = 0;
pub const NRC_BUFLEN: u32 = 1;
pub const NRC_ILLCMD: u32 = 3;
pub const NRC_CMDTMO: u32 = 5;
pub const NRC_INCOMP: u32 = 6;
pub const NRC_BADDR: u32 = 7;
pub const NRC_SNUMOUT: u32 = 8;
pub const NRC_NORES: u32 = 9;
pub const NRC_SCLOSED: u32 = 10;
pub const NRC_CMDCAN: u32 = 11;
pub const NRC_DUPNAME: u32 = 13;
pub const NRC_NAMTFUL: u32 = 14;
pub const NRC_ACTSES: u32 = 15;
pub const NRC_LOCTFUL: u32 = 17;
pub const NRC_REMTFUL: u32 = 18;
pub const NRC_ILLNN: u32 = 19;
pub const NRC_NOCALL: u32 = 20;
pub const NRC_NOWILD: u32 = 21;
pub const NRC_INUSE: u32 = 22;
pub const NRC_NAMERR: u32 = 23;
pub const NRC_SABORT: u32 = 24;
pub const NRC_NAMCONF: u32 = 25;
pub const NRC_IFBUSY: u32 = 33;
pub const NRC_TOOMANY: u32 = 34;
pub const NRC_BRIDGE: u32 = 35;
pub const NRC_CANOCCR: u32 = 36;
pub const NRC_CANCEL: u32 = 38;
pub const NRC_DUPENV: u32 = 48;
pub const NRC_ENVNOTDEF: u32 = 52;
pub const NRC_OSRESNOTAV: u32 = 53;
pub const NRC_MAXAPPS: u32 = 54;
pub const NRC_NOSAPS: u32 = 55;
pub const NRC_NORESOURCES: u32 = 56;
pub const NRC_INVADDRESS: u32 = 57;
pub const NRC_INVDDID: u32 = 59;
pub const NRC_LOCKFAIL: u32 = 60;
pub const NRC_OPENERR: u32 = 63;
pub const NRC_SYSTEM: u32 = 64;
pub const NRC_PENDING: u32 = 255;
pub const RPC_C_BINDING_INFINITE_TIMEOUT: u32 = 10;
pub const RPC_C_BINDING_MIN_TIMEOUT: u32 = 0;
pub const RPC_C_BINDING_DEFAULT_TIMEOUT: u32 = 5;
pub const RPC_C_BINDING_MAX_TIMEOUT: u32 = 9;
pub const RPC_C_CANCEL_INFINITE_TIMEOUT: i32 = -1;
pub const RPC_C_LISTEN_MAX_CALLS_DEFAULT: u32 = 1234;
pub const RPC_C_PROTSEQ_MAX_REQS_DEFAULT: u32 = 10;
pub const RPC_C_BIND_TO_ALL_NICS: u32 = 1;
pub const RPC_C_USE_INTERNET_PORT: u32 = 1;
pub const RPC_C_USE_INTRANET_PORT: u32 = 2;
pub const RPC_C_DONT_FAIL: u32 = 4;
pub const RPC_C_RPCHTTP_USE_LOAD_BALANCE: u32 = 8;
pub const RPC_C_TRY_ENFORCE_MAX_CALLS: u32 = 16;
pub const RPC_C_OPT_BINDING_NONCAUSAL: u32 = 9;
pub const RPC_C_OPT_SECURITY_CALLBACK: u32 = 10;
pub const RPC_C_OPT_UNIQUE_BINDING: u32 = 11;
pub const RPC_C_OPT_TRANS_SEND_BUFFER_SIZE: u32 = 5;
pub const RPC_C_OPT_CALL_TIMEOUT: u32 = 12;
pub const RPC_C_OPT_DONT_LINGER: u32 = 13;
pub const RPC_C_OPT_TRUST_PEER: u32 = 14;
pub const RPC_C_OPT_ASYNC_BLOCK: u32 = 15;
pub const RPC_C_OPT_OPTIMIZE_TIME: u32 = 16;
pub const RPC_C_OPT_MAX_OPTIONS: u32 = 17;
pub const RPC_C_FULL_CERT_CHAIN: u32 = 1;
pub const RPC_C_STATS_CALLS_IN: u32 = 0;
pub const RPC_C_STATS_CALLS_OUT: u32 = 1;
pub const RPC_C_STATS_PKTS_IN: u32 = 2;
pub const RPC_C_STATS_PKTS_OUT: u32 = 3;
pub const RPC_C_AUTHN_LEVEL_DEFAULT: u32 = 0;
pub const RPC_C_AUTHN_LEVEL_NONE: u32 = 1;
pub const RPC_C_AUTHN_LEVEL_CONNECT: u32 = 2;
pub const RPC_C_AUTHN_LEVEL_CALL: u32 = 3;
pub const RPC_C_AUTHN_LEVEL_PKT: u32 = 4;
pub const RPC_C_AUTHN_LEVEL_PKT_INTEGRITY: u32 = 5;
pub const RPC_C_AUTHN_LEVEL_PKT_PRIVACY: u32 = 6;
pub const RPC_C_IMP_LEVEL_DEFAULT: u32 = 0;
pub const RPC_C_IMP_LEVEL_ANONYMOUS: u32 = 1;
pub const RPC_C_IMP_LEVEL_IDENTIFY: u32 = 2;
pub const RPC_C_IMP_LEVEL_IMPERSONATE: u32 = 3;
pub const RPC_C_IMP_LEVEL_DELEGATE: u32 = 4;
pub const RPC_C_QOS_IDENTITY_STATIC: u32 = 0;
pub const RPC_C_QOS_IDENTITY_DYNAMIC: u32 = 1;
pub const RPC_C_QOS_CAPABILITIES_DEFAULT: u32 = 0;
pub const RPC_C_QOS_CAPABILITIES_MUTUAL_AUTH: u32 = 1;
pub const RPC_C_QOS_CAPABILITIES_MAKE_FULLSIC: u32 = 2;
pub const RPC_C_QOS_CAPABILITIES_ANY_AUTHORITY: u32 = 4;
pub const RPC_C_QOS_CAPABILITIES_IGNORE_DELEGATE_FAILURE: u32 = 8;
pub const RPC_C_QOS_CAPABILITIES_LOCAL_MA_HINT: u32 = 16;
pub const RPC_C_QOS_CAPABILITIES_SCHANNEL_FULL_AUTH_IDENTITY: u32 = 32;
pub const RPC_C_PROTECT_LEVEL_DEFAULT: u32 = 0;
pub const RPC_C_PROTECT_LEVEL_NONE: u32 = 1;
pub const RPC_C_PROTECT_LEVEL_CONNECT: u32 = 2;
pub const RPC_C_PROTECT_LEVEL_CALL: u32 = 3;
pub const RPC_C_PROTECT_LEVEL_PKT: u32 = 4;
pub const RPC_C_PROTECT_LEVEL_PKT_INTEGRITY: u32 = 5;
pub const RPC_C_PROTECT_LEVEL_PKT_PRIVACY: u32 = 6;
pub const RPC_C_AUTHN_NONE: u32 = 0;
pub const RPC_C_AUTHN_DCE_PRIVATE: u32 = 1;
pub const RPC_C_AUTHN_DCE_PUBLIC: u32 = 2;
pub const RPC_C_AUTHN_DEC_PUBLIC: u32 = 4;
pub const RPC_C_AUTHN_GSS_NEGOTIATE: u32 = 9;
pub const RPC_C_AUTHN_WINNT: u32 = 10;
pub const RPC_C_AUTHN_GSS_SCHANNEL: u32 = 14;
pub const RPC_C_AUTHN_GSS_KERBEROS: u32 = 16;
pub const RPC_C_AUTHN_DPA: u32 = 17;
pub const RPC_C_AUTHN_MSN: u32 = 18;
pub const RPC_C_AUTHN_DIGEST: u32 = 21;
pub const RPC_C_AUTHN_KERNEL: u32 = 20;
pub const RPC_C_AUTHN_NEGO_EXTENDER: u32 = 30;
pub const RPC_C_AUTHN_PKU2U: u32 = 31;
pub const RPC_C_AUTHN_LIVE_SSP: u32 = 32;
pub const RPC_C_AUTHN_LIVEXP_SSP: u32 = 35;
pub const RPC_C_AUTHN_CLOUD_AP: u32 = 36;
pub const RPC_C_AUTHN_MSONLINE: u32 = 82;
pub const RPC_C_AUTHN_MQ: u32 = 100;
pub const RPC_C_AUTHN_DEFAULT: u32 = 4294967295;
pub const RPC_C_SECURITY_QOS_VERSION: u32 = 1;
pub const RPC_C_SECURITY_QOS_VERSION_1: u32 = 1;
pub const SEC_WINNT_AUTH_IDENTITY_ANSI: u32 = 1;
pub const SEC_WINNT_AUTH_IDENTITY_UNICODE: u32 = 2;
pub const RPC_C_SECURITY_QOS_VERSION_2: u32 = 2;
pub const RPC_C_AUTHN_INFO_TYPE_HTTP: u32 = 1;
pub const RPC_C_HTTP_AUTHN_TARGET_SERVER: u32 = 1;
pub const RPC_C_HTTP_AUTHN_TARGET_PROXY: u32 = 2;
pub const RPC_C_HTTP_AUTHN_SCHEME_BASIC: u32 = 1;
pub const RPC_C_HTTP_AUTHN_SCHEME_NTLM: u32 = 2;
pub const RPC_C_HTTP_AUTHN_SCHEME_PASSPORT: u32 = 4;
pub const RPC_C_HTTP_AUTHN_SCHEME_DIGEST: u32 = 8;
pub const RPC_C_HTTP_AUTHN_SCHEME_NEGOTIATE: u32 = 16;
pub const RPC_C_HTTP_AUTHN_SCHEME_CERT: u32 = 65536;
pub const RPC_C_HTTP_FLAG_USE_SSL: u32 = 1;
pub const RPC_C_HTTP_FLAG_USE_FIRST_AUTH_SCHEME: u32 = 2;
pub const RPC_C_HTTP_FLAG_IGNORE_CERT_CN_INVALID: u32 = 8;
pub const RPC_C_HTTP_FLAG_ENABLE_CERT_REVOCATION_CHECK: u32 = 16;
pub const RPC_C_SECURITY_QOS_VERSION_3: u32 = 3;
pub const RPC_C_SECURITY_QOS_VERSION_4: u32 = 4;
pub const RPC_C_SECURITY_QOS_VERSION_5: u32 = 5;
pub const RPC_PROTSEQ_TCP: u32 = 1;
pub const RPC_PROTSEQ_NMP: u32 = 2;
pub const RPC_PROTSEQ_LRPC: u32 = 3;
pub const RPC_PROTSEQ_HTTP: u32 = 4;
pub const RPC_BHT_OBJECT_UUID_VALID: u32 = 1;
pub const RPC_BHO_NONCAUSAL: u32 = 1;
pub const RPC_BHO_DONTLINGER: u32 = 2;
pub const RPC_BHO_EXCLUSIVE_AND_GUARANTEED: u32 = 4;
pub const RPC_C_AUTHZ_NONE: u32 = 0;
pub const RPC_C_AUTHZ_NAME: u32 = 1;
pub const RPC_C_AUTHZ_DCE: u32 = 2;
pub const RPC_C_AUTHZ_DEFAULT: u32 = 4294967295;
pub const DCE_C_ERROR_STRING_LEN: u32 = 256;
pub const RPC_C_EP_ALL_ELTS: u32 = 0;
pub const RPC_C_EP_MATCH_BY_IF: u32 = 1;
pub const RPC_C_EP_MATCH_BY_OBJ: u32 = 2;
pub const RPC_C_EP_MATCH_BY_BOTH: u32 = 3;
pub const RPC_C_VERS_ALL: u32 = 1;
pub const RPC_C_VERS_COMPATIBLE: u32 = 2;
pub const RPC_C_VERS_EXACT: u32 = 3;
pub const RPC_C_VERS_MAJOR_ONLY: u32 = 4;
pub const RPC_C_VERS_UPTO: u32 = 5;
pub const RPC_C_MGMT_INQ_IF_IDS: u32 = 0;
pub const RPC_C_MGMT_INQ_PRINC_NAME: u32 = 1;
pub const RPC_C_MGMT_INQ_STATS: u32 = 2;
pub const RPC_C_MGMT_IS_SERVER_LISTEN: u32 = 3;
pub const RPC_C_MGMT_STOP_SERVER_LISTEN: u32 = 4;
pub const RPC_C_PARM_MAX_PACKET_LENGTH: u32 = 1;
pub const RPC_C_PARM_BUFFER_LENGTH: u32 = 2;
pub const RPC_IF_AUTOLISTEN: u32 = 1;
pub const RPC_IF_OLE: u32 = 2;
pub const RPC_IF_ALLOW_UNKNOWN_AUTHORITY: u32 = 4;
pub const RPC_IF_ALLOW_SECURE_ONLY: u32 = 8;
pub const RPC_IF_ALLOW_CALLBACKS_WITH_NO_AUTH: u32 = 16;
pub const RPC_IF_ALLOW_LOCAL_ONLY: u32 = 32;
pub const RPC_IF_SEC_NO_CACHE: u32 = 64;
pub const RPC_IF_SEC_CACHE_PER_PROC: u32 = 128;
pub const RPC_IF_ASYNC_CALLBACK: u32 = 256;
pub const RPC_FW_IF_FLAG_DCOM: u32 = 1;
pub const RPC_CONTEXT_HANDLE_DEFAULT_FLAGS: u32 = 0;
pub const RPC_CONTEXT_HANDLE_FLAGS: u32 = 805306368;
pub const RPC_CONTEXT_HANDLE_SERIALIZE: u32 = 268435456;
pub const RPC_CONTEXT_HANDLE_DONT_SERIALIZE: u32 = 536870912;
pub const RPC_TYPE_STRICT_CONTEXT_HANDLE: u32 = 1073741824;
pub const RPC_TYPE_DISCONNECT_EVENT_CONTEXT_HANDLE: u32 = 2147483648;
pub const RPC_NCA_FLAGS_DEFAULT: u32 = 0;
pub const RPC_NCA_FLAGS_IDEMPOTENT: u32 = 1;
pub const RPC_NCA_FLAGS_BROADCAST: u32 = 2;
pub const RPC_NCA_FLAGS_MAYBE: u32 = 4;
pub const RPCFLG_HAS_GUARANTEE: u32 = 16;
pub const RPCFLG_WINRT_REMOTE_ASYNC: u32 = 32;
pub const RPC_BUFFER_COMPLETE: u32 = 4096;
pub const RPC_BUFFER_PARTIAL: u32 = 8192;
pub const RPC_BUFFER_EXTRA: u32 = 16384;
pub const RPC_BUFFER_ASYNC: u32 = 32768;
pub const RPC_BUFFER_NONOTIFY: u32 = 65536;
pub const RPCFLG_MESSAGE: u32 = 16777216;
pub const RPCFLG_AUTO_COMPLETE: u32 = 134217728;
pub const RPCFLG_LOCAL_CALL: u32 = 268435456;
pub const RPCFLG_INPUT_SYNCHRONOUS: u32 = 536870912;
pub const RPCFLG_ASYNCHRONOUS: u32 = 1073741824;
pub const RPCFLG_NON_NDR: u32 = 2147483648;
pub const RPCFLG_HAS_MULTI_SYNTAXES: u32 = 33554432;
pub const RPCFLG_HAS_CALLBACK: u32 = 67108864;
pub const RPCFLG_ACCESSIBILITY_BIT1: u32 = 1048576;
pub const RPCFLG_ACCESSIBILITY_BIT2: u32 = 2097152;
pub const RPCFLG_ACCESS_LOCAL: u32 = 4194304;
pub const NDR_CUSTOM_OR_DEFAULT_ALLOCATOR: u32 = 268435456;
pub const NDR_DEFAULT_ALLOCATOR: u32 = 536870912;
pub const RPCFLG_NDR64_CONTAINS_ARM_LAYOUT: u32 = 67108864;
pub const RPCFLG_SENDER_WAITING_FOR_REPLY: u32 = 8388608;
pub const RPC_FLAGS_VALID_BIT: u32 = 32768;
pub const NT351_INTERFACE_SIZE: u32 = 64;
pub const RPC_INTERFACE_HAS_PIPES: u32 = 1;
pub const RPC_SYSTEM_HANDLE_FREE_UNRETRIEVED: u32 = 1;
pub const RPC_SYSTEM_HANDLE_FREE_RETRIEVED: u32 = 2;
pub const RPC_SYSTEM_HANDLE_FREE_ALL: u32 = 3;
pub const RPC_SYSTEM_HANDLE_FREE_ERROR_ON_CLOSE: u32 = 4;
pub const TRANSPORT_TYPE_CN: u32 = 1;
pub const TRANSPORT_TYPE_DG: u32 = 2;
pub const TRANSPORT_TYPE_LPC: u32 = 4;
pub const TRANSPORT_TYPE_WMSG: u32 = 8;
pub const RPC_P_ADDR_FORMAT_TCP_IPV4: u32 = 1;
pub const RPC_P_ADDR_FORMAT_TCP_IPV6: u32 = 2;
pub const RPC_C_OPT_SESSION_ID: u32 = 6;
pub const RPC_C_OPT_COOKIE_AUTH: u32 = 7;
pub const RPC_C_OPT_RESOURCE_TYPE_UUID: u32 = 8;
pub const RPC_PROXY_CONNECTION_TYPE_IN_PROXY: u32 = 0;
pub const RPC_PROXY_CONNECTION_TYPE_OUT_PROXY: u32 = 1;
pub const RPC_C_OPT_PRIVATE_SUPPRESS_WAKE: u32 = 1;
pub const RPC_C_OPT_PRIVATE_DO_NOT_DISTURB: u32 = 2;
pub const RPC_C_OPT_PRIVATE_BREAK_ON_SUSPEND: u32 = 3;
pub const RPC_C_NS_SYNTAX_DEFAULT: u32 = 0;
pub const RPC_C_NS_SYNTAX_DCE: u32 = 3;
pub const RPC_C_PROFILE_DEFAULT_ELT: u32 = 0;
pub const RPC_C_PROFILE_ALL_ELT: u32 = 1;
pub const RPC_C_PROFILE_ALL_ELTS: u32 = 1;
pub const RPC_C_PROFILE_MATCH_BY_IF: u32 = 2;
pub const RPC_C_PROFILE_MATCH_BY_MBR: u32 = 3;
pub const RPC_C_PROFILE_MATCH_BY_BOTH: u32 = 4;
pub const RPC_C_NS_DEFAULT_EXP_AGE: i32 = -1;
pub const RPC_S_OK: u32 = 0;
pub const RPC_S_INVALID_ARG: u32 = 87;
pub const RPC_S_OUT_OF_MEMORY: u32 = 14;
pub const RPC_S_OUT_OF_THREADS: u32 = 164;
pub const RPC_S_INVALID_LEVEL: u32 = 87;
pub const RPC_S_BUFFER_TOO_SMALL: u32 = 122;
pub const RPC_S_INVALID_SECURITY_DESC: u32 = 1338;
pub const RPC_S_ACCESS_DENIED: u32 = 5;
pub const RPC_S_SERVER_OUT_OF_MEMORY: u32 = 1130;
pub const RPC_S_ASYNC_CALL_PENDING: u32 = 997;
pub const RPC_S_UNKNOWN_PRINCIPAL: u32 = 1332;
pub const RPC_S_TIMEOUT: u32 = 1460;
pub const RPC_S_NOT_ENOUGH_QUOTA: u32 = 1816;
pub const RPC_X_NO_MEMORY: u32 = 14;
pub const RPC_X_INVALID_BOUND: u32 = 1734;
pub const RPC_X_INVALID_TAG: u32 = 1733;
pub const RPC_X_ENUM_VALUE_TOO_LARGE: u32 = 1781;
pub const RPC_X_SS_CONTEXT_MISMATCH: u32 = 6;
pub const RPC_X_INVALID_BUFFER: u32 = 1784;
pub const RPC_X_PIPE_APP_MEMORY: u32 = 14;
pub const RPC_X_INVALID_PIPE_OPERATION: u32 = 1831;
pub const RPC_C_NOTIFY_ON_SEND_COMPLETE: u32 = 1;
pub const RPC_C_INFINITE_TIMEOUT: u32 = 4294967295;
pub const MaxNumberOfEEInfoParams: u32 = 4;
pub const RPC_EEINFO_VERSION: u32 = 1;
pub const EEInfoPreviousRecordsMissing: u32 = 1;
pub const EEInfoNextRecordsMissing: u32 = 2;
pub const EEInfoUseFileTime: u32 = 4;
pub const EEInfoGCCOM: u32 = 11;
pub const EEInfoGCFRS: u32 = 12;
pub const RPC_QUERY_SERVER_PRINCIPAL_NAME: u32 = 2;
pub const RPC_QUERY_CLIENT_PRINCIPAL_NAME: u32 = 4;
pub const RPC_QUERY_CALL_LOCAL_ADDRESS: u32 = 8;
pub const RPC_QUERY_CLIENT_PID: u32 = 16;
pub const RPC_QUERY_IS_CLIENT_LOCAL: u32 = 32;
pub const RPC_QUERY_NO_AUTH_REQUIRED: u32 = 64;
pub const RPC_CALL_ATTRIBUTES_VERSION: u32 = 3;
pub const RPC_QUERY_CLIENT_ID: u32 = 128;
pub const RPC_CALL_STATUS_CANCELLED: u32 = 1;
pub const RPC_CALL_STATUS_DISCONNECTED: u32 = 2;
pub const ABM_NEW: u32 = 0;
pub const ABM_REMOVE: u32 = 1;
pub const ABM_QUERYPOS: u32 = 2;
pub const ABM_SETPOS: u32 = 3;
pub const ABM_GETSTATE: u32 = 4;
pub const ABM_GETTASKBARPOS: u32 = 5;
pub const ABM_ACTIVATE: u32 = 6;
pub const ABM_GETAUTOHIDEBAR: u32 = 7;
pub const ABM_SETAUTOHIDEBAR: u32 = 8;
pub const ABM_WINDOWPOSCHANGED: u32 = 9;
pub const ABM_SETSTATE: u32 = 10;
pub const ABM_GETAUTOHIDEBAREX: u32 = 11;
pub const ABM_SETAUTOHIDEBAREX: u32 = 12;
pub const ABN_STATECHANGE: u32 = 0;
pub const ABN_POSCHANGED: u32 = 1;
pub const ABN_FULLSCREENAPP: u32 = 2;
pub const ABN_WINDOWARRANGE: u32 = 3;
pub const ABS_AUTOHIDE: u32 = 1;
pub const ABS_ALWAYSONTOP: u32 = 2;
pub const ABE_LEFT: u32 = 0;
pub const ABE_TOP: u32 = 1;
pub const ABE_RIGHT: u32 = 2;
pub const ABE_BOTTOM: u32 = 3;
pub const FO_MOVE: u32 = 1;
pub const FO_COPY: u32 = 2;
pub const FO_DELETE: u32 = 3;
pub const FO_RENAME: u32 = 4;
pub const FOF_MULTIDESTFILES: u32 = 1;
pub const FOF_CONFIRMMOUSE: u32 = 2;
pub const FOF_SILENT: u32 = 4;
pub const FOF_RENAMEONCOLLISION: u32 = 8;
pub const FOF_NOCONFIRMATION: u32 = 16;
pub const FOF_WANTMAPPINGHANDLE: u32 = 32;
pub const FOF_ALLOWUNDO: u32 = 64;
pub const FOF_FILESONLY: u32 = 128;
pub const FOF_SIMPLEPROGRESS: u32 = 256;
pub const FOF_NOCONFIRMMKDIR: u32 = 512;
pub const FOF_NOERRORUI: u32 = 1024;
pub const FOF_NOCOPYSECURITYATTRIBS: u32 = 2048;
pub const FOF_NORECURSION: u32 = 4096;
pub const FOF_NO_CONNECTED_ELEMENTS: u32 = 8192;
pub const FOF_WANTNUKEWARNING: u32 = 16384;
pub const FOF_NORECURSEREPARSE: u32 = 32768;
pub const FOF_NO_UI: u32 = 1556;
pub const PO_DELETE: u32 = 19;
pub const PO_RENAME: u32 = 20;
pub const PO_PORTCHANGE: u32 = 32;
pub const PO_REN_PORT: u32 = 52;
pub const SE_ERR_FNF: u32 = 2;
pub const SE_ERR_PNF: u32 = 3;
pub const SE_ERR_ACCESSDENIED: u32 = 5;
pub const SE_ERR_OOM: u32 = 8;
pub const SE_ERR_DLLNOTFOUND: u32 = 32;
pub const SE_ERR_SHARE: u32 = 26;
pub const SE_ERR_ASSOCINCOMPLETE: u32 = 27;
pub const SE_ERR_DDETIMEOUT: u32 = 28;
pub const SE_ERR_DDEFAIL: u32 = 29;
pub const SE_ERR_DDEBUSY: u32 = 30;
pub const SE_ERR_NOASSOC: u32 = 31;
pub const SEE_MASK_DEFAULT: u32 = 0;
pub const SEE_MASK_CLASSNAME: u32 = 1;
pub const SEE_MASK_CLASSKEY: u32 = 3;
pub const SEE_MASK_IDLIST: u32 = 4;
pub const SEE_MASK_INVOKEIDLIST: u32 = 12;
pub const SEE_MASK_HOTKEY: u32 = 32;
pub const SEE_MASK_NOCLOSEPROCESS: u32 = 64;
pub const SEE_MASK_CONNECTNETDRV: u32 = 128;
pub const SEE_MASK_NOASYNC: u32 = 256;
pub const SEE_MASK_FLAG_DDEWAIT: u32 = 256;
pub const SEE_MASK_DOENVSUBST: u32 = 512;
pub const SEE_MASK_FLAG_NO_UI: u32 = 1024;
pub const SEE_MASK_UNICODE: u32 = 16384;
pub const SEE_MASK_NO_CONSOLE: u32 = 32768;
pub const SEE_MASK_ASYNCOK: u32 = 1048576;
pub const SEE_MASK_HMONITOR: u32 = 2097152;
pub const SEE_MASK_NOZONECHECKS: u32 = 8388608;
pub const SEE_MASK_NOQUERYCLASSSTORE: u32 = 16777216;
pub const SEE_MASK_WAITFORINPUTIDLE: u32 = 33554432;
pub const SEE_MASK_FLAG_LOG_USAGE: u32 = 67108864;
pub const SEE_MASK_FLAG_HINST_IS_SITE: u32 = 134217728;
pub const SHERB_NOCONFIRMATION: u32 = 1;
pub const SHERB_NOPROGRESSUI: u32 = 2;
pub const SHERB_NOSOUND: u32 = 4;
pub const NIN_SELECT: u32 = 1024;
pub const NINF_KEY: u32 = 1;
pub const NIN_KEYSELECT: u32 = 1025;
pub const NIN_BALLOONSHOW: u32 = 1026;
pub const NIN_BALLOONHIDE: u32 = 1027;
pub const NIN_BALLOONTIMEOUT: u32 = 1028;
pub const NIN_BALLOONUSERCLICK: u32 = 1029;
pub const NIN_POPUPOPEN: u32 = 1030;
pub const NIN_POPUPCLOSE: u32 = 1031;
pub const NIM_ADD: u32 = 0;
pub const NIM_MODIFY: u32 = 1;
pub const NIM_DELETE: u32 = 2;
pub const NIM_SETFOCUS: u32 = 3;
pub const NIM_SETVERSION: u32 = 4;
pub const NOTIFYICON_VERSION: u32 = 3;
pub const NOTIFYICON_VERSION_4: u32 = 4;
pub const NIF_MESSAGE: u32 = 1;
pub const NIF_ICON: u32 = 2;
pub const NIF_TIP: u32 = 4;
pub const NIF_STATE: u32 = 8;
pub const NIF_INFO: u32 = 16;
pub const NIF_GUID: u32 = 32;
pub const NIF_REALTIME: u32 = 64;
pub const NIF_SHOWTIP: u32 = 128;
pub const NIS_HIDDEN: u32 = 1;
pub const NIS_SHAREDICON: u32 = 2;
pub const NIIF_NONE: u32 = 0;
pub const NIIF_INFO: u32 = 1;
pub const NIIF_WARNING: u32 = 2;
pub const NIIF_ERROR: u32 = 3;
pub const NIIF_USER: u32 = 4;
pub const NIIF_ICON_MASK: u32 = 15;
pub const NIIF_NOSOUND: u32 = 16;
pub const NIIF_LARGE_ICON: u32 = 32;
pub const NIIF_RESPECT_QUIET_TIME: u32 = 128;
pub const SHGFI_ICON: u32 = 256;
pub const SHGFI_DISPLAYNAME: u32 = 512;
pub const SHGFI_TYPENAME: u32 = 1024;
pub const SHGFI_ATTRIBUTES: u32 = 2048;
pub const SHGFI_ICONLOCATION: u32 = 4096;
pub const SHGFI_EXETYPE: u32 = 8192;
pub const SHGFI_SYSICONINDEX: u32 = 16384;
pub const SHGFI_LINKOVERLAY: u32 = 32768;
pub const SHGFI_SELECTED: u32 = 65536;
pub const SHGFI_ATTR_SPECIFIED: u32 = 131072;
pub const SHGFI_LARGEICON: u32 = 0;
pub const SHGFI_SMALLICON: u32 = 1;
pub const SHGFI_OPENICON: u32 = 2;
pub const SHGFI_SHELLICONSIZE: u32 = 4;
pub const SHGFI_PIDL: u32 = 8;
pub const SHGFI_USEFILEATTRIBUTES: u32 = 16;
pub const SHGFI_ADDOVERLAYS: u32 = 32;
pub const SHGFI_OVERLAYINDEX: u32 = 64;
pub const SHGSI_ICONLOCATION: u32 = 0;
pub const SHGSI_ICON: u32 = 256;
pub const SHGSI_SYSICONINDEX: u32 = 16384;
pub const SHGSI_LINKOVERLAY: u32 = 32768;
pub const SHGSI_SELECTED: u32 = 65536;
pub const SHGSI_LARGEICON: u32 = 0;
pub const SHGSI_SMALLICON: u32 = 1;
pub const SHGSI_SHELLICONSIZE: u32 = 4;
pub const SHGNLI_PIDL: u32 = 1;
pub const SHGNLI_PREFIXNAME: u32 = 2;
pub const SHGNLI_NOUNIQUE: u32 = 4;
pub const SHGNLI_NOLNK: u32 = 8;
pub const SHGNLI_NOLOCNAME: u32 = 16;
pub const SHGNLI_USEURLEXT: u32 = 32;
pub const PRINTACTION_OPEN: u32 = 0;
pub const PRINTACTION_PROPERTIES: u32 = 1;
pub const PRINTACTION_NETINSTALL: u32 = 2;
pub const PRINTACTION_NETINSTALLLINK: u32 = 3;
pub const PRINTACTION_TESTPAGE: u32 = 4;
pub const PRINTACTION_OPENNETPRN: u32 = 5;
pub const PRINTACTION_DOCUMENTDEFAULTS: u32 = 6;
pub const PRINTACTION_SERVERPROPERTIES: u32 = 7;
pub const PRINT_PROP_FORCE_NAME: u32 = 1;
pub const OFFLINE_STATUS_LOCAL: u32 = 1;
pub const OFFLINE_STATUS_REMOTE: u32 = 2;
pub const OFFLINE_STATUS_INCOMPLETE: u32 = 4;
pub const SHIL_LARGE: u32 = 0;
pub const SHIL_SMALL: u32 = 1;
pub const SHIL_EXTRALARGE: u32 = 2;
pub const SHIL_SYSSMALL: u32 = 3;
pub const SHIL_JUMBO: u32 = 4;
pub const SHIL_LAST: u32 = 4;
pub const WC_NETADDRESS: &[u8; 18] = b"msctls_netaddress\0";
pub const NCM_GETADDRESS: u32 = 1025;
pub const NCM_SETALLOWTYPE: u32 = 1026;
pub const NCM_GETALLOWTYPE: u32 = 1027;
pub const NCM_DISPLAYERRORTIP: u32 = 1028;
pub const PERF_DATA_VERSION: u32 = 1;
pub const PERF_DATA_REVISION: u32 = 1;
pub const PERF_NO_INSTANCES: i32 = -1;
pub const PERF_METADATA_MULTIPLE_INSTANCES: i32 = -2;
pub const PERF_METADATA_NO_INSTANCES: i32 = -3;
pub const PERF_SIZE_DWORD: u32 = 0;
pub const PERF_SIZE_LARGE: u32 = 256;
pub const PERF_SIZE_ZERO: u32 = 512;
pub const PERF_SIZE_VARIABLE_LEN: u32 = 768;
pub const PERF_TYPE_NUMBER: u32 = 0;
pub const PERF_TYPE_COUNTER: u32 = 1024;
pub const PERF_TYPE_TEXT: u32 = 2048;
pub const PERF_TYPE_ZERO: u32 = 3072;
pub const PERF_NUMBER_HEX: u32 = 0;
pub const PERF_NUMBER_DECIMAL: u32 = 65536;
pub const PERF_NUMBER_DEC_1000: u32 = 131072;
pub const PERF_COUNTER_VALUE: u32 = 0;
pub const PERF_COUNTER_RATE: u32 = 65536;
pub const PERF_COUNTER_FRACTION: u32 = 131072;
pub const PERF_COUNTER_BASE: u32 = 196608;
pub const PERF_COUNTER_ELAPSED: u32 = 262144;
pub const PERF_COUNTER_QUEUELEN: u32 = 327680;
pub const PERF_COUNTER_HISTOGRAM: u32 = 393216;
pub const PERF_COUNTER_PRECISION: u32 = 458752;
pub const PERF_TEXT_UNICODE: u32 = 0;
pub const PERF_TEXT_ASCII: u32 = 65536;
pub const PERF_TIMER_TICK: u32 = 0;
pub const PERF_TIMER_100NS: u32 = 1048576;
pub const PERF_OBJECT_TIMER: u32 = 2097152;
pub const PERF_DELTA_COUNTER: u32 = 4194304;
pub const PERF_DELTA_BASE: u32 = 8388608;
pub const PERF_INVERSE_COUNTER: u32 = 16777216;
pub const PERF_MULTI_COUNTER: u32 = 33554432;
pub const PERF_DISPLAY_NO_SUFFIX: u32 = 0;
pub const PERF_DISPLAY_PER_SEC: u32 = 268435456;
pub const PERF_DISPLAY_PERCENT: u32 = 536870912;
pub const PERF_DISPLAY_SECONDS: u32 = 805306368;
pub const PERF_DISPLAY_NOSHOW: u32 = 1073741824;
pub const PERF_COUNTER_COUNTER: u32 = 272696320;
pub const PERF_COUNTER_TIMER: u32 = 541132032;
pub const PERF_COUNTER_QUEUELEN_TYPE: u32 = 4523008;
pub const PERF_COUNTER_LARGE_QUEUELEN_TYPE: u32 = 4523264;
pub const PERF_COUNTER_100NS_QUEUELEN_TYPE: u32 = 5571840;
pub const PERF_COUNTER_OBJ_TIME_QUEUELEN_TYPE: u32 = 6620416;
pub const PERF_COUNTER_BULK_COUNT: u32 = 272696576;
pub const PERF_COUNTER_TEXT: u32 = 2816;
pub const PERF_COUNTER_RAWCOUNT: u32 = 65536;
pub const PERF_COUNTER_LARGE_RAWCOUNT: u32 = 65792;
pub const PERF_COUNTER_RAWCOUNT_HEX: u32 = 0;
pub const PERF_COUNTER_LARGE_RAWCOUNT_HEX: u32 = 256;
pub const PERF_SAMPLE_FRACTION: u32 = 549585920;
pub const PERF_SAMPLE_COUNTER: u32 = 4260864;
pub const PERF_COUNTER_NODATA: u32 = 1073742336;
pub const PERF_COUNTER_TIMER_INV: u32 = 557909248;
pub const PERF_SAMPLE_BASE: u32 = 1073939457;
pub const PERF_AVERAGE_TIMER: u32 = 805438464;
pub const PERF_AVERAGE_BASE: u32 = 1073939458;
pub const PERF_AVERAGE_BULK: u32 = 1073874176;
pub const PERF_OBJ_TIME_TIMER: u32 = 543229184;
pub const PERF_100NSEC_TIMER: u32 = 542180608;
pub const PERF_100NSEC_TIMER_INV: u32 = 558957824;
pub const PERF_COUNTER_MULTI_TIMER: u32 = 574686464;
pub const PERF_COUNTER_MULTI_TIMER_INV: u32 = 591463680;
pub const PERF_COUNTER_MULTI_BASE: u32 = 1107494144;
pub const PERF_100NSEC_MULTI_TIMER: u32 = 575735040;
pub const PERF_100NSEC_MULTI_TIMER_INV: u32 = 592512256;
pub const PERF_RAW_FRACTION: u32 = 537003008;
pub const PERF_LARGE_RAW_FRACTION: u32 = 537003264;
pub const PERF_RAW_BASE: u32 = 1073939459;
pub const PERF_LARGE_RAW_BASE: u32 = 1073939712;
pub const PERF_ELAPSED_TIME: u32 = 807666944;
pub const PERF_COUNTER_HISTOGRAM_TYPE: u32 = 2147483648;
pub const PERF_COUNTER_DELTA: u32 = 4195328;
pub const PERF_COUNTER_LARGE_DELTA: u32 = 4195584;
pub const PERF_PRECISION_SYSTEM_TIMER: u32 = 541525248;
pub const PERF_PRECISION_100NS_TIMER: u32 = 542573824;
pub const PERF_PRECISION_OBJECT_TIMER: u32 = 543622400;
pub const PERF_PRECISION_TIMESTAMP: u32 = 1073939712;
pub const PERF_DETAIL_NOVICE: u32 = 100;
pub const PERF_DETAIL_ADVANCED: u32 = 200;
pub const PERF_DETAIL_EXPERT: u32 = 300;
pub const PERF_DETAIL_WIZARD: u32 = 400;
pub const PERF_NO_UNIQUE_ID: i32 = -1;
pub const MAX_PERF_OBJECTS_IN_QUERY_FUNCTION: u32 = 64;
pub const WINPERF_LOG_NONE: u32 = 0;
pub const WINPERF_LOG_USER: u32 = 1;
pub const WINPERF_LOG_DEBUG: u32 = 2;
pub const WINPERF_LOG_VERBOSE: u32 = 3;
pub const FD_SETSIZE: u32 = 64;
pub const IOCPARM_MASK: u32 = 127;
pub const IOC_VOID: u32 = 536870912;
pub const IOC_OUT: u32 = 1073741824;
pub const IOC_IN: u32 = 2147483648;
pub const IOC_INOUT: u32 = 3221225472;
pub const IPPROTO_IP: u32 = 0;
pub const IPPROTO_ICMP: u32 = 1;
pub const IPPROTO_IGMP: u32 = 2;
pub const IPPROTO_GGP: u32 = 3;
pub const IPPROTO_TCP: u32 = 6;
pub const IPPROTO_PUP: u32 = 12;
pub const IPPROTO_UDP: u32 = 17;
pub const IPPROTO_IDP: u32 = 22;
pub const IPPROTO_ND: u32 = 77;
pub const IPPROTO_RAW: u32 = 255;
pub const IPPROTO_MAX: u32 = 256;
pub const IPPORT_ECHO: u32 = 7;
pub const IPPORT_DISCARD: u32 = 9;
pub const IPPORT_SYSTAT: u32 = 11;
pub const IPPORT_DAYTIME: u32 = 13;
pub const IPPORT_NETSTAT: u32 = 15;
pub const IPPORT_FTP: u32 = 21;
pub const IPPORT_TELNET: u32 = 23;
pub const IPPORT_SMTP: u32 = 25;
pub const IPPORT_TIMESERVER: u32 = 37;
pub const IPPORT_NAMESERVER: u32 = 42;
pub const IPPORT_WHOIS: u32 = 43;
pub const IPPORT_MTP: u32 = 57;
pub const IPPORT_TFTP: u32 = 69;
pub const IPPORT_RJE: u32 = 77;
pub const IPPORT_FINGER: u32 = 79;
pub const IPPORT_TTYLINK: u32 = 87;
pub const IPPORT_SUPDUP: u32 = 95;
pub const IPPORT_EXECSERVER: u32 = 512;
pub const IPPORT_LOGINSERVER: u32 = 513;
pub const IPPORT_CMDSERVER: u32 = 514;
pub const IPPORT_EFSSERVER: u32 = 520;
pub const IPPORT_BIFFUDP: u32 = 512;
pub const IPPORT_WHOSERVER: u32 = 513;
pub const IPPORT_ROUTESERVER: u32 = 520;
pub const IPPORT_RESERVED: u32 = 1024;
pub const IMPLINK_IP: u32 = 155;
pub const IMPLINK_LOWEXPER: u32 = 156;
pub const IMPLINK_HIGHEXPER: u32 = 158;
pub const IN_CLASSA_NET: u32 = 4278190080;
pub const IN_CLASSA_NSHIFT: u32 = 24;
pub const IN_CLASSA_HOST: u32 = 16777215;
pub const IN_CLASSA_MAX: u32 = 128;
pub const IN_CLASSB_NET: u32 = 4294901760;
pub const IN_CLASSB_NSHIFT: u32 = 16;
pub const IN_CLASSB_HOST: u32 = 65535;
pub const IN_CLASSB_MAX: u32 = 65536;
pub const IN_CLASSC_NET: u32 = 4294967040;
pub const IN_CLASSC_NSHIFT: u32 = 8;
pub const IN_CLASSC_HOST: u32 = 255;
pub const INADDR_LOOPBACK: u32 = 2130706433;
pub const INADDR_NONE: u32 = 4294967295;
pub const WSADESCRIPTION_LEN: u32 = 256;
pub const WSASYS_STATUS_LEN: u32 = 128;
pub const IP_OPTIONS: u32 = 1;
pub const IP_MULTICAST_IF: u32 = 2;
pub const IP_MULTICAST_TTL: u32 = 3;
pub const IP_MULTICAST_LOOP: u32 = 4;
pub const IP_ADD_MEMBERSHIP: u32 = 5;
pub const IP_DROP_MEMBERSHIP: u32 = 6;
pub const IP_TTL: u32 = 7;
pub const IP_TOS: u32 = 8;
pub const IP_DONTFRAGMENT: u32 = 9;
pub const IP_DEFAULT_MULTICAST_TTL: u32 = 1;
pub const IP_DEFAULT_MULTICAST_LOOP: u32 = 1;
pub const IP_MAX_MEMBERSHIPS: u32 = 20;
pub const SOCKET_ERROR: i32 = -1;
pub const SOCK_STREAM: u32 = 1;
pub const SOCK_DGRAM: u32 = 2;
pub const SOCK_RAW: u32 = 3;
pub const SOCK_RDM: u32 = 4;
pub const SOCK_SEQPACKET: u32 = 5;
pub const SO_DEBUG: u32 = 1;
pub const SO_ACCEPTCONN: u32 = 2;
pub const SO_REUSEADDR: u32 = 4;
pub const SO_KEEPALIVE: u32 = 8;
pub const SO_DONTROUTE: u32 = 16;
pub const SO_BROADCAST: u32 = 32;
pub const SO_USELOOPBACK: u32 = 64;
pub const SO_LINGER: u32 = 128;
pub const SO_OOBINLINE: u32 = 256;
pub const SO_SNDBUF: u32 = 4097;
pub const SO_RCVBUF: u32 = 4098;
pub const SO_SNDLOWAT: u32 = 4099;
pub const SO_RCVLOWAT: u32 = 4100;
pub const SO_SNDTIMEO: u32 = 4101;
pub const SO_RCVTIMEO: u32 = 4102;
pub const SO_ERROR: u32 = 4103;
pub const SO_TYPE: u32 = 4104;
pub const SO_CONNDATA: u32 = 28672;
pub const SO_CONNOPT: u32 = 28673;
pub const SO_DISCDATA: u32 = 28674;
pub const SO_DISCOPT: u32 = 28675;
pub const SO_CONNDATALEN: u32 = 28676;
pub const SO_CONNOPTLEN: u32 = 28677;
pub const SO_DISCDATALEN: u32 = 28678;
pub const SO_DISCOPTLEN: u32 = 28679;
pub const SO_OPENTYPE: u32 = 28680;
pub const SO_SYNCHRONOUS_ALERT: u32 = 16;
pub const SO_SYNCHRONOUS_NONALERT: u32 = 32;
pub const SO_MAXDG: u32 = 28681;
pub const SO_MAXPATHDG: u32 = 28682;
pub const SO_UPDATE_ACCEPT_CONTEXT: u32 = 28683;
pub const SO_CONNECT_TIME: u32 = 28684;
pub const TCP_NODELAY: u32 = 1;
pub const TCP_BSDURGENT: u32 = 28672;
pub const AF_UNSPEC: u32 = 0;
pub const AF_UNIX: u32 = 1;
pub const AF_INET: u32 = 2;
pub const AF_IMPLINK: u32 = 3;
pub const AF_PUP: u32 = 4;
pub const AF_CHAOS: u32 = 5;
pub const AF_IPX: u32 = 6;
pub const AF_NS: u32 = 6;
pub const AF_ISO: u32 = 7;
pub const AF_OSI: u32 = 7;
pub const AF_ECMA: u32 = 8;
pub const AF_DATAKIT: u32 = 9;
pub const AF_CCITT: u32 = 10;
pub const AF_SNA: u32 = 11;
pub const AF_DECnet: u32 = 12;
pub const AF_DLI: u32 = 13;
pub const AF_LAT: u32 = 14;
pub const AF_HYLINK: u32 = 15;
pub const AF_APPLETALK: u32 = 16;
pub const AF_NETBIOS: u32 = 17;
pub const AF_VOICEVIEW: u32 = 18;
pub const AF_FIREFOX: u32 = 19;
pub const AF_UNKNOWN1: u32 = 20;
pub const AF_BAN: u32 = 21;
pub const AF_MAX: u32 = 22;
pub const PF_UNSPEC: u32 = 0;
pub const PF_UNIX: u32 = 1;
pub const PF_INET: u32 = 2;
pub const PF_IMPLINK: u32 = 3;
pub const PF_PUP: u32 = 4;
pub const PF_CHAOS: u32 = 5;
pub const PF_NS: u32 = 6;
pub const PF_IPX: u32 = 6;
pub const PF_ISO: u32 = 7;
pub const PF_OSI: u32 = 7;
pub const PF_ECMA: u32 = 8;
pub const PF_DATAKIT: u32 = 9;
pub const PF_CCITT: u32 = 10;
pub const PF_SNA: u32 = 11;
pub const PF_DECnet: u32 = 12;
pub const PF_DLI: u32 = 13;
pub const PF_LAT: u32 = 14;
pub const PF_HYLINK: u32 = 15;
pub const PF_APPLETALK: u32 = 16;
pub const PF_VOICEVIEW: u32 = 18;
pub const PF_FIREFOX: u32 = 19;
pub const PF_UNKNOWN1: u32 = 20;
pub const PF_BAN: u32 = 21;
pub const PF_MAX: u32 = 22;
pub const SOL_SOCKET: u32 = 65535;
pub const SOMAXCONN: u32 = 5;
pub const MSG_OOB: u32 = 1;
pub const MSG_PEEK: u32 = 2;
pub const MSG_DONTROUTE: u32 = 4;
pub const MSG_MAXIOVLEN: u32 = 16;
pub const MSG_PARTIAL: u32 = 32768;
pub const MAXGETHOSTSTRUCT: u32 = 1024;
pub const FD_READ: u32 = 1;
pub const FD_WRITE: u32 = 2;
pub const FD_OOB: u32 = 4;
pub const FD_ACCEPT: u32 = 8;
pub const FD_CONNECT: u32 = 16;
pub const FD_CLOSE: u32 = 32;
pub const HOST_NOT_FOUND: u32 = 11001;
pub const TRY_AGAIN: u32 = 11002;
pub const NO_RECOVERY: u32 = 11003;
pub const NO_DATA: u32 = 11004;
pub const WSANO_ADDRESS: u32 = 11004;
pub const NO_ADDRESS: u32 = 11004;
pub const TF_DISCONNECT: u32 = 1;
pub const TF_REUSE_SOCKET: u32 = 2;
pub const TF_WRITE_BEHIND: u32 = 4;
pub const ALG_CLASS_ANY: u32 = 0;
pub const ALG_CLASS_SIGNATURE: u32 = 8192;
pub const ALG_CLASS_MSG_ENCRYPT: u32 = 16384;
pub const ALG_CLASS_DATA_ENCRYPT: u32 = 24576;
pub const ALG_CLASS_HASH: u32 = 32768;
pub const ALG_CLASS_KEY_EXCHANGE: u32 = 40960;
pub const ALG_CLASS_ALL: u32 = 57344;
pub const ALG_TYPE_ANY: u32 = 0;
pub const ALG_TYPE_DSS: u32 = 512;
pub const ALG_TYPE_RSA: u32 = 1024;
pub const ALG_TYPE_BLOCK: u32 = 1536;
pub const ALG_TYPE_STREAM: u32 = 2048;
pub const ALG_TYPE_DH: u32 = 2560;
pub const ALG_TYPE_SECURECHANNEL: u32 = 3072;
pub const ALG_TYPE_ECDH: u32 = 3584;
pub const ALG_TYPE_THIRDPARTY: u32 = 4096;
pub const ALG_SID_ANY: u32 = 0;
pub const ALG_SID_THIRDPARTY_ANY: u32 = 0;
pub const ALG_SID_RSA_ANY: u32 = 0;
pub const ALG_SID_RSA_PKCS: u32 = 1;
pub const ALG_SID_RSA_MSATWORK: u32 = 2;
pub const ALG_SID_RSA_ENTRUST: u32 = 3;
pub const ALG_SID_RSA_PGP: u32 = 4;
pub const ALG_SID_DSS_ANY: u32 = 0;
pub const ALG_SID_DSS_PKCS: u32 = 1;
pub const ALG_SID_DSS_DMS: u32 = 2;
pub const ALG_SID_ECDSA: u32 = 3;
pub const ALG_SID_DES: u32 = 1;
pub const ALG_SID_3DES: u32 = 3;
pub const ALG_SID_DESX: u32 = 4;
pub const ALG_SID_IDEA: u32 = 5;
pub const ALG_SID_CAST: u32 = 6;
pub const ALG_SID_SAFERSK64: u32 = 7;
pub const ALG_SID_SAFERSK128: u32 = 8;
pub const ALG_SID_3DES_112: u32 = 9;
pub const ALG_SID_CYLINK_MEK: u32 = 12;
pub const ALG_SID_RC5: u32 = 13;
pub const ALG_SID_AES_128: u32 = 14;
pub const ALG_SID_AES_192: u32 = 15;
pub const ALG_SID_AES_256: u32 = 16;
pub const ALG_SID_AES: u32 = 17;
pub const ALG_SID_SKIPJACK: u32 = 10;
pub const ALG_SID_TEK: u32 = 11;
pub const CRYPT_MODE_CBCI: u32 = 6;
pub const CRYPT_MODE_CFBP: u32 = 7;
pub const CRYPT_MODE_OFBP: u32 = 8;
pub const CRYPT_MODE_CBCOFM: u32 = 9;
pub const CRYPT_MODE_CBCOFMI: u32 = 10;
pub const ALG_SID_RC2: u32 = 2;
pub const ALG_SID_RC4: u32 = 1;
pub const ALG_SID_SEAL: u32 = 2;
pub const ALG_SID_DH_SANDF: u32 = 1;
pub const ALG_SID_DH_EPHEM: u32 = 2;
pub const ALG_SID_AGREED_KEY_ANY: u32 = 3;
pub const ALG_SID_KEA: u32 = 4;
pub const ALG_SID_ECDH: u32 = 5;
pub const ALG_SID_ECDH_EPHEM: u32 = 6;
pub const ALG_SID_MD2: u32 = 1;
pub const ALG_SID_MD4: u32 = 2;
pub const ALG_SID_MD5: u32 = 3;
pub const ALG_SID_SHA: u32 = 4;
pub const ALG_SID_SHA1: u32 = 4;
pub const ALG_SID_MAC: u32 = 5;
pub const ALG_SID_RIPEMD: u32 = 6;
pub const ALG_SID_RIPEMD160: u32 = 7;
pub const ALG_SID_SSL3SHAMD5: u32 = 8;
pub const ALG_SID_HMAC: u32 = 9;
pub const ALG_SID_TLS1PRF: u32 = 10;
pub const ALG_SID_HASH_REPLACE_OWF: u32 = 11;
pub const ALG_SID_SHA_256: u32 = 12;
pub const ALG_SID_SHA_384: u32 = 13;
pub const ALG_SID_SHA_512: u32 = 14;
pub const ALG_SID_SSL3_MASTER: u32 = 1;
pub const ALG_SID_SCHANNEL_MASTER_HASH: u32 = 2;
pub const ALG_SID_SCHANNEL_MAC_KEY: u32 = 3;
pub const ALG_SID_PCT1_MASTER: u32 = 4;
pub const ALG_SID_SSL2_MASTER: u32 = 5;
pub const ALG_SID_TLS1_MASTER: u32 = 6;
pub const ALG_SID_SCHANNEL_ENC_KEY: u32 = 7;
pub const ALG_SID_ECMQV: u32 = 1;
pub const ALG_SID_EXAMPLE: u32 = 80;
pub const CALG_MD2: u32 = 32769;
pub const CALG_MD4: u32 = 32770;
pub const CALG_MD5: u32 = 32771;
pub const CALG_SHA: u32 = 32772;
pub const CALG_SHA1: u32 = 32772;
pub const CALG_MAC: u32 = 32773;
pub const CALG_RSA_SIGN: u32 = 9216;
pub const CALG_DSS_SIGN: u32 = 8704;
pub const CALG_NO_SIGN: u32 = 8192;
pub const CALG_RSA_KEYX: u32 = 41984;
pub const CALG_DES: u32 = 26113;
pub const CALG_3DES_112: u32 = 26121;
pub const CALG_3DES: u32 = 26115;
pub const CALG_DESX: u32 = 26116;
pub const CALG_RC2: u32 = 26114;
pub const CALG_RC4: u32 = 26625;
pub const CALG_SEAL: u32 = 26626;
pub const CALG_DH_SF: u32 = 43521;
pub const CALG_DH_EPHEM: u32 = 43522;
pub const CALG_AGREEDKEY_ANY: u32 = 43523;
pub const CALG_KEA_KEYX: u32 = 43524;
pub const CALG_HUGHES_MD5: u32 = 40963;
pub const CALG_SKIPJACK: u32 = 26122;
pub const CALG_TEK: u32 = 26123;
pub const CALG_CYLINK_MEK: u32 = 26124;
pub const CALG_SSL3_SHAMD5: u32 = 32776;
pub const CALG_SSL3_MASTER: u32 = 19457;
pub const CALG_SCHANNEL_MASTER_HASH: u32 = 19458;
pub const CALG_SCHANNEL_MAC_KEY: u32 = 19459;
pub const CALG_SCHANNEL_ENC_KEY: u32 = 19463;
pub const CALG_PCT1_MASTER: u32 = 19460;
pub const CALG_SSL2_MASTER: u32 = 19461;
pub const CALG_TLS1_MASTER: u32 = 19462;
pub const CALG_RC5: u32 = 26125;
pub const CALG_HMAC: u32 = 32777;
pub const CALG_TLS1PRF: u32 = 32778;
pub const CALG_HASH_REPLACE_OWF: u32 = 32779;
pub const CALG_AES_128: u32 = 26126;
pub const CALG_AES_192: u32 = 26127;
pub const CALG_AES_256: u32 = 26128;
pub const CALG_AES: u32 = 26129;
pub const CALG_SHA_256: u32 = 32780;
pub const CALG_SHA_384: u32 = 32781;
pub const CALG_SHA_512: u32 = 32782;
pub const CALG_ECDH: u32 = 43525;
pub const CALG_ECDH_EPHEM: u32 = 44550;
pub const CALG_ECMQV: u32 = 40961;
pub const CALG_ECDSA: u32 = 8707;
pub const CALG_NULLCIPHER: u32 = 24576;
pub const CALG_THIRDPARTY_KEY_EXCHANGE: u32 = 45056;
pub const CALG_THIRDPARTY_SIGNATURE: u32 = 12288;
pub const CALG_THIRDPARTY_CIPHER: u32 = 28672;
pub const CALG_THIRDPARTY_HASH: u32 = 36864;
pub const CRYPT_VERIFYCONTEXT: u32 = 4026531840;
pub const CRYPT_NEWKEYSET: u32 = 8;
pub const CRYPT_DELETEKEYSET: u32 = 16;
pub const CRYPT_MACHINE_KEYSET: u32 = 32;
pub const CRYPT_SILENT: u32 = 64;
pub const CRYPT_DEFAULT_CONTAINER_OPTIONAL: u32 = 128;
pub const CRYPT_EXPORTABLE: u32 = 1;
pub const CRYPT_USER_PROTECTED: u32 = 2;
pub const CRYPT_CREATE_SALT: u32 = 4;
pub const CRYPT_UPDATE_KEY: u32 = 8;
pub const CRYPT_NO_SALT: u32 = 16;
pub const CRYPT_PREGEN: u32 = 64;
pub const CRYPT_RECIPIENT: u32 = 16;
pub const CRYPT_INITIATOR: u32 = 64;
pub const CRYPT_ONLINE: u32 = 128;
pub const CRYPT_SF: u32 = 256;
pub const CRYPT_CREATE_IV: u32 = 512;
pub const CRYPT_KEK: u32 = 1024;
pub const CRYPT_DATA_KEY: u32 = 2048;
pub const CRYPT_VOLATILE: u32 = 4096;
pub const CRYPT_SGCKEY: u32 = 8192;
pub const CRYPT_USER_PROTECTED_STRONG: u32 = 1048576;
pub const CRYPT_ARCHIVABLE: u32 = 16384;
pub const CRYPT_FORCE_KEY_PROTECTION_HIGH: u32 = 32768;
pub const RSA1024BIT_KEY: u32 = 67108864;
pub const CRYPT_SERVER: u32 = 1024;
pub const KEY_LENGTH_MASK: u32 = 4294901760;
pub const CRYPT_Y_ONLY: u32 = 1;
pub const CRYPT_SSL2_FALLBACK: u32 = 2;
pub const CRYPT_DESTROYKEY: u32 = 4;
pub const CRYPT_OAEP: u32 = 64;
pub const CRYPT_BLOB_VER3: u32 = 128;
pub const CRYPT_IPSEC_HMAC_KEY: u32 = 256;
pub const CRYPT_DECRYPT_RSA_NO_PADDING_CHECK: u32 = 32;
pub const CRYPT_SECRETDIGEST: u32 = 1;
pub const CRYPT_OWF_REPL_LM_HASH: u32 = 1;
pub const CRYPT_LITTLE_ENDIAN: u32 = 1;
pub const CRYPT_NOHASHOID: u32 = 1;
pub const CRYPT_TYPE2_FORMAT: u32 = 2;
pub const CRYPT_X931_FORMAT: u32 = 4;
pub const CRYPT_MACHINE_DEFAULT: u32 = 1;
pub const CRYPT_USER_DEFAULT: u32 = 2;
pub const CRYPT_DELETE_DEFAULT: u32 = 4;
pub const SIMPLEBLOB: u32 = 1;
pub const PUBLICKEYBLOB: u32 = 6;
pub const PRIVATEKEYBLOB: u32 = 7;
pub const PLAINTEXTKEYBLOB: u32 = 8;
pub const OPAQUEKEYBLOB: u32 = 9;
pub const PUBLICKEYBLOBEX: u32 = 10;
pub const SYMMETRICWRAPKEYBLOB: u32 = 11;
pub const KEYSTATEBLOB: u32 = 12;
pub const AT_KEYEXCHANGE: u32 = 1;
pub const AT_SIGNATURE: u32 = 2;
pub const CRYPT_USERDATA: u32 = 1;
pub const KP_IV: u32 = 1;
pub const KP_SALT: u32 = 2;
pub const KP_PADDING: u32 = 3;
pub const KP_MODE: u32 = 4;
pub const KP_MODE_BITS: u32 = 5;
pub const KP_PERMISSIONS: u32 = 6;
pub const KP_ALGID: u32 = 7;
pub const KP_BLOCKLEN: u32 = 8;
pub const KP_KEYLEN: u32 = 9;
pub const KP_SALT_EX: u32 = 10;
pub const KP_P: u32 = 11;
pub const KP_G: u32 = 12;
pub const KP_Q: u32 = 13;
pub const KP_X: u32 = 14;
pub const KP_Y: u32 = 15;
pub const KP_RA: u32 = 16;
pub const KP_RB: u32 = 17;
pub const KP_INFO: u32 = 18;
pub const KP_EFFECTIVE_KEYLEN: u32 = 19;
pub const KP_SCHANNEL_ALG: u32 = 20;
pub const KP_CLIENT_RANDOM: u32 = 21;
pub const KP_SERVER_RANDOM: u32 = 22;
pub const KP_RP: u32 = 23;
pub const KP_PRECOMP_MD5: u32 = 24;
pub const KP_PRECOMP_SHA: u32 = 25;
pub const KP_CERTIFICATE: u32 = 26;
pub const KP_CLEAR_KEY: u32 = 27;
pub const KP_PUB_EX_LEN: u32 = 28;
pub const KP_PUB_EX_VAL: u32 = 29;
pub const KP_KEYVAL: u32 = 30;
pub const KP_ADMIN_PIN: u32 = 31;
pub const KP_KEYEXCHANGE_PIN: u32 = 32;
pub const KP_SIGNATURE_PIN: u32 = 33;
pub const KP_PREHASH: u32 = 34;
pub const KP_ROUNDS: u32 = 35;
pub const KP_OAEP_PARAMS: u32 = 36;
pub const KP_CMS_KEY_INFO: u32 = 37;
pub const KP_CMS_DH_KEY_INFO: u32 = 38;
pub const KP_PUB_PARAMS: u32 = 39;
pub const KP_VERIFY_PARAMS: u32 = 40;
pub const KP_HIGHEST_VERSION: u32 = 41;
pub const KP_GET_USE_COUNT: u32 = 42;
pub const KP_PIN_ID: u32 = 43;
pub const KP_PIN_INFO: u32 = 44;
pub const PKCS5_PADDING: u32 = 1;
pub const RANDOM_PADDING: u32 = 2;
pub const ZERO_PADDING: u32 = 3;
pub const CRYPT_MODE_CBC: u32 = 1;
pub const CRYPT_MODE_ECB: u32 = 2;
pub const CRYPT_MODE_OFB: u32 = 3;
pub const CRYPT_MODE_CFB: u32 = 4;
pub const CRYPT_MODE_CTS: u32 = 5;
pub const CRYPT_ENCRYPT: u32 = 1;
pub const CRYPT_DECRYPT: u32 = 2;
pub const CRYPT_EXPORT: u32 = 4;
pub const CRYPT_READ: u32 = 8;
pub const CRYPT_WRITE: u32 = 16;
pub const CRYPT_MAC: u32 = 32;
pub const CRYPT_EXPORT_KEY: u32 = 64;
pub const CRYPT_IMPORT_KEY: u32 = 128;
pub const CRYPT_ARCHIVE: u32 = 256;
pub const HP_ALGID: u32 = 1;
pub const HP_HASHVAL: u32 = 2;
pub const HP_HASHSIZE: u32 = 4;
pub const HP_HMAC_INFO: u32 = 5;
pub const HP_TLS1PRF_LABEL: u32 = 6;
pub const HP_TLS1PRF_SEED: u32 = 7;
pub const CRYPT_FAILED: u32 = 0;
pub const CRYPT_SUCCEED: u32 = 1;
pub const PP_ENUMALGS: u32 = 1;
pub const PP_ENUMCONTAINERS: u32 = 2;
pub const PP_IMPTYPE: u32 = 3;
pub const PP_NAME: u32 = 4;
pub const PP_VERSION: u32 = 5;
pub const PP_CONTAINER: u32 = 6;
pub const PP_CHANGE_PASSWORD: u32 = 7;
pub const PP_KEYSET_SEC_DESCR: u32 = 8;
pub const PP_CERTCHAIN: u32 = 9;
pub const PP_KEY_TYPE_SUBTYPE: u32 = 10;
pub const PP_PROVTYPE: u32 = 16;
pub const PP_KEYSTORAGE: u32 = 17;
pub const PP_APPLI_CERT: u32 = 18;
pub const PP_SYM_KEYSIZE: u32 = 19;
pub const PP_SESSION_KEYSIZE: u32 = 20;
pub const PP_UI_PROMPT: u32 = 21;
pub const PP_ENUMALGS_EX: u32 = 22;
pub const PP_ENUMMANDROOTS: u32 = 25;
pub const PP_ENUMELECTROOTS: u32 = 26;
pub const PP_KEYSET_TYPE: u32 = 27;
pub const PP_ADMIN_PIN: u32 = 31;
pub const PP_KEYEXCHANGE_PIN: u32 = 32;
pub const PP_SIGNATURE_PIN: u32 = 33;
pub const PP_SIG_KEYSIZE_INC: u32 = 34;
pub const PP_KEYX_KEYSIZE_INC: u32 = 35;
pub const PP_UNIQUE_CONTAINER: u32 = 36;
pub const PP_SGC_INFO: u32 = 37;
pub const PP_USE_HARDWARE_RNG: u32 = 38;
pub const PP_KEYSPEC: u32 = 39;
pub const PP_ENUMEX_SIGNING_PROT: u32 = 40;
pub const PP_CRYPT_COUNT_KEY_USE: u32 = 41;
pub const PP_USER_CERTSTORE: u32 = 42;
pub const PP_SMARTCARD_READER: u32 = 43;
pub const PP_SMARTCARD_GUID: u32 = 45;
pub const PP_ROOT_CERTSTORE: u32 = 46;
pub const PP_SMARTCARD_READER_ICON: u32 = 47;
pub const CRYPT_FIRST: u32 = 1;
pub const CRYPT_NEXT: u32 = 2;
pub const CRYPT_SGC_ENUM: u32 = 4;
pub const CRYPT_IMPL_HARDWARE: u32 = 1;
pub const CRYPT_IMPL_SOFTWARE: u32 = 2;
pub const CRYPT_IMPL_MIXED: u32 = 3;
pub const CRYPT_IMPL_UNKNOWN: u32 = 4;
pub const CRYPT_IMPL_REMOVABLE: u32 = 8;
pub const CRYPT_SEC_DESCR: u32 = 1;
pub const CRYPT_PSTORE: u32 = 2;
pub const CRYPT_UI_PROMPT: u32 = 4;
pub const CRYPT_FLAG_PCT1: u32 = 1;
pub const CRYPT_FLAG_SSL2: u32 = 2;
pub const CRYPT_FLAG_SSL3: u32 = 4;
pub const CRYPT_FLAG_TLS1: u32 = 8;
pub const CRYPT_FLAG_IPSEC: u32 = 16;
pub const CRYPT_FLAG_SIGNING: u32 = 32;
pub const CRYPT_SGC: u32 = 1;
pub const CRYPT_FASTSGC: u32 = 2;
pub const PP_CLIENT_HWND: u32 = 1;
pub const PP_CONTEXT_INFO: u32 = 11;
pub const PP_KEYEXCHANGE_KEYSIZE: u32 = 12;
pub const PP_SIGNATURE_KEYSIZE: u32 = 13;
pub const PP_KEYEXCHANGE_ALG: u32 = 14;
pub const PP_SIGNATURE_ALG: u32 = 15;
pub const PP_DELETEKEY: u32 = 24;
pub const PP_PIN_PROMPT_STRING: u32 = 44;
pub const PP_SECURE_KEYEXCHANGE_PIN: u32 = 47;
pub const PP_SECURE_SIGNATURE_PIN: u32 = 48;
pub const PP_DISMISS_PIN_UI_SEC: u32 = 49;
pub const PROV_RSA_FULL: u32 = 1;
pub const PROV_RSA_SIG: u32 = 2;
pub const PROV_DSS: u32 = 3;
pub const PROV_FORTEZZA: u32 = 4;
pub const PROV_MS_EXCHANGE: u32 = 5;
pub const PROV_SSL: u32 = 6;
pub const PROV_RSA_SCHANNEL: u32 = 12;
pub const PROV_DSS_DH: u32 = 13;
pub const PROV_EC_ECDSA_SIG: u32 = 14;
pub const PROV_EC_ECNRA_SIG: u32 = 15;
pub const PROV_EC_ECDSA_FULL: u32 = 16;
pub const PROV_EC_ECNRA_FULL: u32 = 17;
pub const PROV_DH_SCHANNEL: u32 = 18;
pub const PROV_SPYRUS_LYNKS: u32 = 20;
pub const PROV_RNG: u32 = 21;
pub const PROV_INTEL_SEC: u32 = 22;
pub const PROV_REPLACE_OWF: u32 = 23;
pub const PROV_RSA_AES: u32 = 24;
pub const MS_DEF_PROV_A: &[u8; 43] = b"Microsoft Base Cryptographic Provider v1.0\0";
pub const MS_DEF_PROV_W: &[u8; 43] = b"Microsoft Base Cryptographic Provider v1.0\0";
pub const MS_DEF_PROV: &[u8; 43] = b"Microsoft Base Cryptographic Provider v1.0\0";
pub const MS_ENHANCED_PROV_A: &[u8; 47] = b"Microsoft Enhanced Cryptographic Provider v1.0\0";
pub const MS_ENHANCED_PROV_W: &[u8; 47] = b"Microsoft Enhanced Cryptographic Provider v1.0\0";
pub const MS_ENHANCED_PROV: &[u8; 47] = b"Microsoft Enhanced Cryptographic Provider v1.0\0";
pub const MS_STRONG_PROV_A: &[u8; 40] = b"Microsoft Strong Cryptographic Provider\0";
pub const MS_STRONG_PROV_W: &[u8; 40] = b"Microsoft Strong Cryptographic Provider\0";
pub const MS_STRONG_PROV: &[u8; 40] = b"Microsoft Strong Cryptographic Provider\0";
pub const MS_DEF_RSA_SIG_PROV_A: &[u8; 47] = b"Microsoft RSA Signature Cryptographic Provider\0";
pub const MS_DEF_RSA_SIG_PROV_W: &[u8; 47] = b"Microsoft RSA Signature Cryptographic Provider\0";
pub const MS_DEF_RSA_SIG_PROV: &[u8; 47] = b"Microsoft RSA Signature Cryptographic Provider\0";
pub const MS_DEF_RSA_SCHANNEL_PROV_A: &[u8; 46] =
    b"Microsoft RSA SChannel Cryptographic Provider\0";
pub const MS_DEF_RSA_SCHANNEL_PROV_W: &[u8; 46] =
    b"Microsoft RSA SChannel Cryptographic Provider\0";
pub const MS_DEF_RSA_SCHANNEL_PROV: &[u8; 46] = b"Microsoft RSA SChannel Cryptographic Provider\0";
pub const MS_DEF_DSS_PROV_A: &[u8; 42] = b"Microsoft Base DSS Cryptographic Provider\0";
pub const MS_DEF_DSS_PROV_W: &[u8; 42] = b"Microsoft Base DSS Cryptographic Provider\0";
pub const MS_DEF_DSS_PROV: &[u8; 42] = b"Microsoft Base DSS Cryptographic Provider\0";
pub const MS_DEF_DSS_DH_PROV_A: &[u8; 61] =
    b"Microsoft Base DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_DEF_DSS_DH_PROV_W: &[u8; 61] =
    b"Microsoft Base DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_DEF_DSS_DH_PROV: &[u8; 61] =
    b"Microsoft Base DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_ENH_DSS_DH_PROV_A: &[u8; 65] =
    b"Microsoft Enhanced DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_ENH_DSS_DH_PROV_W: &[u8; 65] =
    b"Microsoft Enhanced DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_ENH_DSS_DH_PROV: &[u8; 65] =
    b"Microsoft Enhanced DSS and Diffie-Hellman Cryptographic Provider\0";
pub const MS_DEF_DH_SCHANNEL_PROV_A: &[u8; 45] = b"Microsoft DH SChannel Cryptographic Provider\0";
pub const MS_DEF_DH_SCHANNEL_PROV_W: &[u8; 45] = b"Microsoft DH SChannel Cryptographic Provider\0";
pub const MS_DEF_DH_SCHANNEL_PROV: &[u8; 45] = b"Microsoft DH SChannel Cryptographic Provider\0";
pub const MS_SCARD_PROV_A: &[u8; 42] = b"Microsoft Base Smart Card Crypto Provider\0";
pub const MS_SCARD_PROV_W: &[u8; 42] = b"Microsoft Base Smart Card Crypto Provider\0";
pub const MS_SCARD_PROV: &[u8; 42] = b"Microsoft Base Smart Card Crypto Provider\0";
pub const MS_ENH_RSA_AES_PROV_A: &[u8; 54] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider\0";
pub const MS_ENH_RSA_AES_PROV_W: &[u8; 54] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider\0";
pub const MS_ENH_RSA_AES_PROV_XP_A: &[u8; 66] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider (Prototype)\0";
pub const MS_ENH_RSA_AES_PROV_XP_W: &[u8; 66] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider (Prototype)\0";
pub const MS_ENH_RSA_AES_PROV_XP: &[u8; 66] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider (Prototype)\0";
pub const MS_ENH_RSA_AES_PROV: &[u8; 54] =
    b"Microsoft Enhanced RSA and AES Cryptographic Provider\0";
pub const MAXUIDLEN: u32 = 64;
pub const EXPO_OFFLOAD_REG_VALUE: &[u8; 12] = b"ExpoOffload\0";
pub const EXPO_OFFLOAD_FUNC_NAME: &[u8; 15] = b"OffloadModExpo\0";
pub const szKEY_CRYPTOAPI_PRIVATE_KEY_OPTIONS: &[u8; 41] =
    b"Software\\Policies\\Microsoft\\Cryptography\0";
pub const szKEY_CACHE_ENABLED: &[u8; 17] = b"CachePrivateKeys\0";
pub const szKEY_CACHE_SECONDS: &[u8; 26] = b"PrivateKeyLifetimeSeconds\0";
pub const szPRIV_KEY_CACHE_MAX_ITEMS: &[u8; 21] = b"PrivKeyCacheMaxItems\0";
pub const cPRIV_KEY_CACHE_MAX_ITEMS_DEFAULT: u32 = 20;
pub const szPRIV_KEY_CACHE_PURGE_INTERVAL_SECONDS: &[u8; 33] =
    b"PrivKeyCachePurgeIntervalSeconds\0";
pub const cPRIV_KEY_CACHE_PURGE_INTERVAL_SECONDS_DEFAULT: u32 = 86400;
pub const CUR_BLOB_VERSION: u32 = 2;
pub const SCHANNEL_MAC_KEY: u32 = 0;
pub const SCHANNEL_ENC_KEY: u32 = 1;
pub const INTERNATIONAL_USAGE: u32 = 1;
pub const BCRYPT_OBJECT_ALIGNMENT: u32 = 16;
pub const BCRYPT_KDF_HASH: &[u8; 5] = b"HASH\0";
pub const BCRYPT_KDF_HMAC: &[u8; 5] = b"HMAC\0";
pub const BCRYPT_KDF_TLS_PRF: &[u8; 8] = b"TLS_PRF\0";
pub const BCRYPT_KDF_SP80056A_CONCAT: &[u8; 17] = b"SP800_56A_CONCAT\0";
pub const BCRYPT_KDF_RAW_SECRET: &[u8; 9] = b"TRUNCATE\0";
pub const BCRYPT_KDF_HKDF: &[u8; 5] = b"HKDF\0";
pub const KDF_HASH_ALGORITHM: u32 = 0;
pub const KDF_SECRET_PREPEND: u32 = 1;
pub const KDF_SECRET_APPEND: u32 = 2;
pub const KDF_HMAC_KEY: u32 = 3;
pub const KDF_TLS_PRF_LABEL: u32 = 4;
pub const KDF_TLS_PRF_SEED: u32 = 5;
pub const KDF_SECRET_HANDLE: u32 = 6;
pub const KDF_TLS_PRF_PROTOCOL: u32 = 7;
pub const KDF_ALGORITHMID: u32 = 8;
pub const KDF_PARTYUINFO: u32 = 9;
pub const KDF_PARTYVINFO: u32 = 10;
pub const KDF_SUPPPUBINFO: u32 = 11;
pub const KDF_SUPPPRIVINFO: u32 = 12;
pub const KDF_LABEL: u32 = 13;
pub const KDF_CONTEXT: u32 = 14;
pub const KDF_SALT: u32 = 15;
pub const KDF_ITERATION_COUNT: u32 = 16;
pub const KDF_GENERIC_PARAMETER: u32 = 17;
pub const KDF_KEYBITLENGTH: u32 = 18;
pub const KDF_HKDF_SALT: u32 = 19;
pub const KDF_HKDF_INFO: u32 = 20;
pub const KDF_USE_SECRET_AS_HMAC_KEY_FLAG: u32 = 1;
pub const BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO_VERSION: u32 = 1;
pub const BCRYPT_AUTH_MODE_CHAIN_CALLS_FLAG: u32 = 1;
pub const BCRYPT_AUTH_MODE_IN_PROGRESS_FLAG: u32 = 2;
pub const BCRYPT_OPAQUE_KEY_BLOB: &[u8; 14] = b"OpaqueKeyBlob\0";
pub const BCRYPT_KEY_DATA_BLOB: &[u8; 12] = b"KeyDataBlob\0";
pub const BCRYPT_AES_WRAP_KEY_BLOB: &[u8; 19] = b"Rfc3565KeyWrapBlob\0";
pub const BCRYPT_OBJECT_LENGTH: &[u8; 13] = b"ObjectLength\0";
pub const BCRYPT_ALGORITHM_NAME: &[u8; 14] = b"AlgorithmName\0";
pub const BCRYPT_PROVIDER_HANDLE: &[u8; 15] = b"ProviderHandle\0";
pub const BCRYPT_CHAINING_MODE: &[u8; 13] = b"ChainingMode\0";
pub const BCRYPT_BLOCK_LENGTH: &[u8; 12] = b"BlockLength\0";
pub const BCRYPT_KEY_LENGTH: &[u8; 10] = b"KeyLength\0";
pub const BCRYPT_KEY_OBJECT_LENGTH: &[u8; 16] = b"KeyObjectLength\0";
pub const BCRYPT_KEY_STRENGTH: &[u8; 12] = b"KeyStrength\0";
pub const BCRYPT_KEY_LENGTHS: &[u8; 11] = b"KeyLengths\0";
pub const BCRYPT_BLOCK_SIZE_LIST: &[u8; 14] = b"BlockSizeList\0";
pub const BCRYPT_EFFECTIVE_KEY_LENGTH: &[u8; 19] = b"EffectiveKeyLength\0";
pub const BCRYPT_HASH_LENGTH: &[u8; 17] = b"HashDigestLength\0";
pub const BCRYPT_HASH_OID_LIST: &[u8; 12] = b"HashOIDList\0";
pub const BCRYPT_PADDING_SCHEMES: &[u8; 15] = b"PaddingSchemes\0";
pub const BCRYPT_SIGNATURE_LENGTH: &[u8; 16] = b"SignatureLength\0";
pub const BCRYPT_HASH_BLOCK_LENGTH: &[u8; 16] = b"HashBlockLength\0";
pub const BCRYPT_AUTH_TAG_LENGTH: &[u8; 14] = b"AuthTagLength\0";
pub const BCRYPT_PRIMITIVE_TYPE: &[u8; 14] = b"PrimitiveType\0";
pub const BCRYPT_IS_KEYED_HASH: &[u8; 12] = b"IsKeyedHash\0";
pub const BCRYPT_IS_REUSABLE_HASH: &[u8; 15] = b"IsReusableHash\0";
pub const BCRYPT_MESSAGE_BLOCK_LENGTH: &[u8; 19] = b"MessageBlockLength\0";
pub const BCRYPT_PUBLIC_KEY_LENGTH: &[u8; 16] = b"PublicKeyLength\0";
pub const BCRYPT_PCP_PLATFORM_TYPE_PROPERTY: &[u8; 18] = b"PCP_PLATFORM_TYPE\0";
pub const BCRYPT_PCP_PROVIDER_VERSION_PROPERTY: &[u8; 21] = b"PCP_PROVIDER_VERSION\0";
pub const BCRYPT_MULTI_OBJECT_LENGTH: &[u8; 18] = b"MultiObjectLength\0";
pub const BCRYPT_IS_IFX_TPM_WEAK_KEY: &[u8; 16] = b"IsIfxTpmWeakKey\0";
pub const BCRYPT_HKDF_HASH_ALGORITHM: &[u8; 18] = b"HkdfHashAlgorithm\0";
pub const BCRYPT_HKDF_SALT_AND_FINALIZE: &[u8; 20] = b"HkdfSaltAndFinalize\0";
pub const BCRYPT_HKDF_PRK_AND_FINALIZE: &[u8; 19] = b"HkdfPrkAndFinalize\0";
pub const BCRYPT_INITIALIZATION_VECTOR: &[u8; 3] = b"IV\0";
pub const BCRYPT_CHAIN_MODE_NA: &[u8; 16] = b"ChainingModeN/A\0";
pub const BCRYPT_CHAIN_MODE_CBC: &[u8; 16] = b"ChainingModeCBC\0";
pub const BCRYPT_CHAIN_MODE_ECB: &[u8; 16] = b"ChainingModeECB\0";
pub const BCRYPT_CHAIN_MODE_CFB: &[u8; 16] = b"ChainingModeCFB\0";
pub const BCRYPT_CHAIN_MODE_CCM: &[u8; 16] = b"ChainingModeCCM\0";
pub const BCRYPT_CHAIN_MODE_GCM: &[u8; 16] = b"ChainingModeGCM\0";
pub const BCRYPT_SUPPORTED_PAD_ROUTER: u32 = 1;
pub const BCRYPT_SUPPORTED_PAD_PKCS1_ENC: u32 = 2;
pub const BCRYPT_SUPPORTED_PAD_PKCS1_SIG: u32 = 4;
pub const BCRYPT_SUPPORTED_PAD_OAEP: u32 = 8;
pub const BCRYPT_SUPPORTED_PAD_PSS: u32 = 16;
pub const BCRYPT_PROV_DISPATCH: u32 = 1;
pub const BCRYPT_BLOCK_PADDING: u32 = 1;
pub const BCRYPT_GENERATE_IV: u32 = 32;
pub const BCRYPT_PAD_NONE: u32 = 1;
pub const BCRYPT_PAD_PKCS1: u32 = 2;
pub const BCRYPT_PAD_OAEP: u32 = 4;
pub const BCRYPT_PAD_PSS: u32 = 8;
pub const BCRYPT_PAD_PKCS1_OPTIONAL_HASH_OID: u32 = 16;
pub const BCRYPTBUFFER_VERSION: u32 = 0;
pub const BCRYPT_PUBLIC_KEY_BLOB: &[u8; 11] = b"PUBLICBLOB\0";
pub const BCRYPT_PRIVATE_KEY_BLOB: &[u8; 12] = b"PRIVATEBLOB\0";
pub const BCRYPT_RSAPUBLIC_BLOB: &[u8; 14] = b"RSAPUBLICBLOB\0";
pub const BCRYPT_RSAPRIVATE_BLOB: &[u8; 15] = b"RSAPRIVATEBLOB\0";
pub const LEGACY_RSAPUBLIC_BLOB: &[u8; 15] = b"CAPIPUBLICBLOB\0";
pub const LEGACY_RSAPRIVATE_BLOB: &[u8; 16] = b"CAPIPRIVATEBLOB\0";
pub const BCRYPT_RSAPUBLIC_MAGIC: u32 = 826364754;
pub const BCRYPT_RSAPRIVATE_MAGIC: u32 = 843141970;
pub const BCRYPT_RSAFULLPRIVATE_BLOB: &[u8; 19] = b"RSAFULLPRIVATEBLOB\0";
pub const BCRYPT_RSAFULLPRIVATE_MAGIC: u32 = 859919186;
pub const BCRYPT_GLOBAL_PARAMETERS: &[u8; 21] = b"SecretAgreementParam\0";
pub const BCRYPT_PRIVATE_KEY: &[u8; 11] = b"PrivKeyVal\0";
pub const BCRYPT_ECCPUBLIC_BLOB: &[u8; 14] = b"ECCPUBLICBLOB\0";
pub const BCRYPT_ECCPRIVATE_BLOB: &[u8; 15] = b"ECCPRIVATEBLOB\0";
pub const BCRYPT_ECCFULLPUBLIC_BLOB: &[u8; 18] = b"ECCFULLPUBLICBLOB\0";
pub const BCRYPT_ECCFULLPRIVATE_BLOB: &[u8; 19] = b"ECCFULLPRIVATEBLOB\0";
pub const SSL_ECCPUBLIC_BLOB: &[u8; 17] = b"SSLECCPUBLICBLOB\0";
pub const BCRYPT_ECDH_PUBLIC_P256_MAGIC: u32 = 827016005;
pub const BCRYPT_ECDH_PRIVATE_P256_MAGIC: u32 = 843793221;
pub const BCRYPT_ECDH_PUBLIC_P384_MAGIC: u32 = 860570437;
pub const BCRYPT_ECDH_PRIVATE_P384_MAGIC: u32 = 877347653;
pub const BCRYPT_ECDH_PUBLIC_P521_MAGIC: u32 = 894124869;
pub const BCRYPT_ECDH_PRIVATE_P521_MAGIC: u32 = 910902085;
pub const BCRYPT_ECDH_PUBLIC_GENERIC_MAGIC: u32 = 1347109701;
pub const BCRYPT_ECDH_PRIVATE_GENERIC_MAGIC: u32 = 1447772997;
pub const BCRYPT_ECDSA_PUBLIC_P256_MAGIC: u32 = 827540293;
pub const BCRYPT_ECDSA_PRIVATE_P256_MAGIC: u32 = 844317509;
pub const BCRYPT_ECDSA_PUBLIC_P384_MAGIC: u32 = 861094725;
pub const BCRYPT_ECDSA_PRIVATE_P384_MAGIC: u32 = 877871941;
pub const BCRYPT_ECDSA_PUBLIC_P521_MAGIC: u32 = 894649157;
pub const BCRYPT_ECDSA_PRIVATE_P521_MAGIC: u32 = 911426373;
pub const BCRYPT_ECDSA_PUBLIC_GENERIC_MAGIC: u32 = 1346650949;
pub const BCRYPT_ECDSA_PRIVATE_GENERIC_MAGIC: u32 = 1447314245;
pub const BCRYPT_ECC_FULLKEY_BLOB_V1: u32 = 1;
pub const BCRYPT_DH_PUBLIC_BLOB: &[u8; 13] = b"DHPUBLICBLOB\0";
pub const BCRYPT_DH_PRIVATE_BLOB: &[u8; 14] = b"DHPRIVATEBLOB\0";
pub const LEGACY_DH_PUBLIC_BLOB: &[u8; 17] = b"CAPIDHPUBLICBLOB\0";
pub const LEGACY_DH_PRIVATE_BLOB: &[u8; 18] = b"CAPIDHPRIVATEBLOB\0";
pub const BCRYPT_DH_PUBLIC_MAGIC: u32 = 1112557636;
pub const BCRYPT_DH_PRIVATE_MAGIC: u32 = 1448101956;
pub const BCRYPT_DH_PARAMETERS: &[u8; 13] = b"DHParameters\0";
pub const BCRYPT_DH_PARAMETERS_MAGIC: u32 = 1297107012;
pub const BCRYPT_DSA_PUBLIC_BLOB: &[u8; 14] = b"DSAPUBLICBLOB\0";
pub const BCRYPT_DSA_PRIVATE_BLOB: &[u8; 15] = b"DSAPRIVATEBLOB\0";
pub const LEGACY_DSA_PUBLIC_BLOB: &[u8; 18] = b"CAPIDSAPUBLICBLOB\0";
pub const LEGACY_DSA_PRIVATE_BLOB: &[u8; 19] = b"CAPIDSAPRIVATEBLOB\0";
pub const LEGACY_DSA_V2_PUBLIC_BLOB: &[u8; 20] = b"V2CAPIDSAPUBLICBLOB\0";
pub const LEGACY_DSA_V2_PRIVATE_BLOB: &[u8; 21] = b"V2CAPIDSAPRIVATEBLOB\0";
pub const BCRYPT_DSA_PUBLIC_MAGIC: u32 = 1112560452;
pub const BCRYPT_DSA_PRIVATE_MAGIC: u32 = 1448104772;
pub const BCRYPT_DSA_PUBLIC_MAGIC_V2: u32 = 843206724;
pub const BCRYPT_DSA_PRIVATE_MAGIC_V2: u32 = 844517444;
pub const BCRYPT_KEY_DATA_BLOB_MAGIC: u32 = 1296188491;
pub const BCRYPT_KEY_DATA_BLOB_VERSION1: u32 = 1;
pub const BCRYPT_DSA_PARAMETERS: &[u8; 14] = b"DSAParameters\0";
pub const BCRYPT_DSA_PARAMETERS_MAGIC: u32 = 1297109828;
pub const BCRYPT_DSA_PARAMETERS_MAGIC_V2: u32 = 843927620;
pub const BCRYPT_ECC_PARAMETERS: &[u8; 14] = b"ECCParameters\0";
pub const BCRYPT_ECC_CURVE_NAME: &[u8; 13] = b"ECCCurveName\0";
pub const BCRYPT_ECC_CURVE_NAME_LIST: &[u8; 17] = b"ECCCurveNameList\0";
pub const BCRYPT_ECC_PARAMETERS_MAGIC: u32 = 1346585413;
pub const BCRYPT_ECC_CURVE_BRAINPOOLP160R1: &[u8; 16] = b"brainpoolP160r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP160T1: &[u8; 16] = b"brainpoolP160t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP192R1: &[u8; 16] = b"brainpoolP192r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP192T1: &[u8; 16] = b"brainpoolP192t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP224R1: &[u8; 16] = b"brainpoolP224r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP224T1: &[u8; 16] = b"brainpoolP224t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP256R1: &[u8; 16] = b"brainpoolP256r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP256T1: &[u8; 16] = b"brainpoolP256t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP320R1: &[u8; 16] = b"brainpoolP320r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP320T1: &[u8; 16] = b"brainpoolP320t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP384R1: &[u8; 16] = b"brainpoolP384r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP384T1: &[u8; 16] = b"brainpoolP384t1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP512R1: &[u8; 16] = b"brainpoolP512r1\0";
pub const BCRYPT_ECC_CURVE_BRAINPOOLP512T1: &[u8; 16] = b"brainpoolP512t1\0";
pub const BCRYPT_ECC_CURVE_25519: &[u8; 11] = b"curve25519\0";
pub const BCRYPT_ECC_CURVE_EC192WAPI: &[u8; 10] = b"ec192wapi\0";
pub const BCRYPT_ECC_CURVE_NISTP192: &[u8; 9] = b"nistP192\0";
pub const BCRYPT_ECC_CURVE_NISTP224: &[u8; 9] = b"nistP224\0";
pub const BCRYPT_ECC_CURVE_NISTP256: &[u8; 9] = b"nistP256\0";
pub const BCRYPT_ECC_CURVE_NISTP384: &[u8; 9] = b"nistP384\0";
pub const BCRYPT_ECC_CURVE_NISTP521: &[u8; 9] = b"nistP521\0";
pub const BCRYPT_ECC_CURVE_NUMSP256T1: &[u8; 11] = b"numsP256t1\0";
pub const BCRYPT_ECC_CURVE_NUMSP384T1: &[u8; 11] = b"numsP384t1\0";
pub const BCRYPT_ECC_CURVE_NUMSP512T1: &[u8; 11] = b"numsP512t1\0";
pub const BCRYPT_ECC_CURVE_SECP160K1: &[u8; 10] = b"secP160k1\0";
pub const BCRYPT_ECC_CURVE_SECP160R1: &[u8; 10] = b"secP160r1\0";
pub const BCRYPT_ECC_CURVE_SECP160R2: &[u8; 10] = b"secP160r2\0";
pub const BCRYPT_ECC_CURVE_SECP192K1: &[u8; 10] = b"secP192k1\0";
pub const BCRYPT_ECC_CURVE_SECP192R1: &[u8; 10] = b"secP192r1\0";
pub const BCRYPT_ECC_CURVE_SECP224K1: &[u8; 10] = b"secP224k1\0";
pub const BCRYPT_ECC_CURVE_SECP224R1: &[u8; 10] = b"secP224r1\0";
pub const BCRYPT_ECC_CURVE_SECP256K1: &[u8; 10] = b"secP256k1\0";
pub const BCRYPT_ECC_CURVE_SECP256R1: &[u8; 10] = b"secP256r1\0";
pub const BCRYPT_ECC_CURVE_SECP384R1: &[u8; 10] = b"secP384r1\0";
pub const BCRYPT_ECC_CURVE_SECP521R1: &[u8; 10] = b"secP521r1\0";
pub const BCRYPT_ECC_CURVE_WTLS7: &[u8; 6] = b"wtls7\0";
pub const BCRYPT_ECC_CURVE_WTLS9: &[u8; 6] = b"wtls9\0";
pub const BCRYPT_ECC_CURVE_WTLS12: &[u8; 7] = b"wtls12\0";
pub const BCRYPT_ECC_CURVE_X962P192V1: &[u8; 11] = b"x962P192v1\0";
pub const BCRYPT_ECC_CURVE_X962P192V2: &[u8; 11] = b"x962P192v2\0";
pub const BCRYPT_ECC_CURVE_X962P192V3: &[u8; 11] = b"x962P192v3\0";
pub const BCRYPT_ECC_CURVE_X962P239V1: &[u8; 11] = b"x962P239v1\0";
pub const BCRYPT_ECC_CURVE_X962P239V2: &[u8; 11] = b"x962P239v2\0";
pub const BCRYPT_ECC_CURVE_X962P239V3: &[u8; 11] = b"x962P239v3\0";
pub const BCRYPT_ECC_CURVE_X962P256V1: &[u8; 11] = b"x962P256v1\0";
pub const MS_PRIMITIVE_PROVIDER: &[u8; 29] = b"Microsoft Primitive Provider\0";
pub const MS_PLATFORM_CRYPTO_PROVIDER: &[u8; 35] = b"Microsoft Platform Crypto Provider\0";
pub const BCRYPT_RSA_ALGORITHM: &[u8; 4] = b"RSA\0";
pub const BCRYPT_RSA_SIGN_ALGORITHM: &[u8; 9] = b"RSA_SIGN\0";
pub const BCRYPT_DH_ALGORITHM: &[u8; 3] = b"DH\0";
pub const BCRYPT_DSA_ALGORITHM: &[u8; 4] = b"DSA\0";
pub const BCRYPT_RC2_ALGORITHM: &[u8; 4] = b"RC2\0";
pub const BCRYPT_RC4_ALGORITHM: &[u8; 4] = b"RC4\0";
pub const BCRYPT_AES_ALGORITHM: &[u8; 4] = b"AES\0";
pub const BCRYPT_DES_ALGORITHM: &[u8; 4] = b"DES\0";
pub const BCRYPT_DESX_ALGORITHM: &[u8; 5] = b"DESX\0";
pub const BCRYPT_3DES_ALGORITHM: &[u8; 5] = b"3DES\0";
pub const BCRYPT_3DES_112_ALGORITHM: &[u8; 9] = b"3DES_112\0";
pub const BCRYPT_MD2_ALGORITHM: &[u8; 4] = b"MD2\0";
pub const BCRYPT_MD4_ALGORITHM: &[u8; 4] = b"MD4\0";
pub const BCRYPT_MD5_ALGORITHM: &[u8; 4] = b"MD5\0";
pub const BCRYPT_SHA1_ALGORITHM: &[u8; 5] = b"SHA1\0";
pub const BCRYPT_SHA256_ALGORITHM: &[u8; 7] = b"SHA256\0";
pub const BCRYPT_SHA384_ALGORITHM: &[u8; 7] = b"SHA384\0";
pub const BCRYPT_SHA512_ALGORITHM: &[u8; 7] = b"SHA512\0";
pub const BCRYPT_AES_GMAC_ALGORITHM: &[u8; 9] = b"AES-GMAC\0";
pub const BCRYPT_AES_CMAC_ALGORITHM: &[u8; 9] = b"AES-CMAC\0";
pub const BCRYPT_ECDSA_P256_ALGORITHM: &[u8; 11] = b"ECDSA_P256\0";
pub const BCRYPT_ECDSA_P384_ALGORITHM: &[u8; 11] = b"ECDSA_P384\0";
pub const BCRYPT_ECDSA_P521_ALGORITHM: &[u8; 11] = b"ECDSA_P521\0";
pub const BCRYPT_ECDH_P256_ALGORITHM: &[u8; 10] = b"ECDH_P256\0";
pub const BCRYPT_ECDH_P384_ALGORITHM: &[u8; 10] = b"ECDH_P384\0";
pub const BCRYPT_ECDH_P521_ALGORITHM: &[u8; 10] = b"ECDH_P521\0";
pub const BCRYPT_RNG_ALGORITHM: &[u8; 4] = b"RNG\0";
pub const BCRYPT_RNG_FIPS186_DSA_ALGORITHM: &[u8; 14] = b"FIPS186DSARNG\0";
pub const BCRYPT_RNG_DUAL_EC_ALGORITHM: &[u8; 10] = b"DUALECRNG\0";
pub const BCRYPT_SP800108_CTR_HMAC_ALGORITHM: &[u8; 19] = b"SP800_108_CTR_HMAC\0";
pub const BCRYPT_SP80056A_CONCAT_ALGORITHM: &[u8; 17] = b"SP800_56A_CONCAT\0";
pub const BCRYPT_PBKDF2_ALGORITHM: &[u8; 7] = b"PBKDF2\0";
pub const BCRYPT_CAPI_KDF_ALGORITHM: &[u8; 9] = b"CAPI_KDF\0";
pub const BCRYPT_TLS1_1_KDF_ALGORITHM: &[u8; 11] = b"TLS1_1_KDF\0";
pub const BCRYPT_TLS1_2_KDF_ALGORITHM: &[u8; 11] = b"TLS1_2_KDF\0";
pub const BCRYPT_ECDSA_ALGORITHM: &[u8; 6] = b"ECDSA\0";
pub const BCRYPT_ECDH_ALGORITHM: &[u8; 5] = b"ECDH\0";
pub const BCRYPT_XTS_AES_ALGORITHM: &[u8; 8] = b"XTS-AES\0";
pub const BCRYPT_HKDF_ALGORITHM: &[u8; 5] = b"HKDF\0";
pub const BCRYPT_CHACHA20_POLY1305_ALGORITHM: &[u8; 18] = b"CHACHA20_POLY1305\0";
pub const BCRYPT_CIPHER_INTERFACE: u32 = 1;
pub const BCRYPT_HASH_INTERFACE: u32 = 2;
pub const BCRYPT_ASYMMETRIC_ENCRYPTION_INTERFACE: u32 = 3;
pub const BCRYPT_SECRET_AGREEMENT_INTERFACE: u32 = 4;
pub const BCRYPT_SIGNATURE_INTERFACE: u32 = 5;
pub const BCRYPT_RNG_INTERFACE: u32 = 6;
pub const BCRYPT_KEY_DERIVATION_INTERFACE: u32 = 7;
pub const BCRYPT_ALG_HANDLE_HMAC_FLAG: u32 = 8;
pub const BCRYPT_HASH_REUSABLE_FLAG: u32 = 32;
pub const BCRYPT_CAPI_AES_FLAG: u32 = 16;
pub const BCRYPT_MULTI_FLAG: u32 = 64;
pub const BCRYPT_TLS_CBC_HMAC_VERIFY_FLAG: u32 = 4;
pub const BCRYPT_BUFFERS_LOCKED_FLAG: u32 = 64;
pub const BCRYPT_EXTENDED_KEYSIZE: u32 = 128;
pub const BCRYPT_ENABLE_INCOMPATIBLE_FIPS_CHECKS: u32 = 256;
pub const BCRYPT_CIPHER_OPERATION: u32 = 1;
pub const BCRYPT_HASH_OPERATION: u32 = 2;
pub const BCRYPT_ASYMMETRIC_ENCRYPTION_OPERATION: u32 = 4;
pub const BCRYPT_SECRET_AGREEMENT_OPERATION: u32 = 8;
pub const BCRYPT_SIGNATURE_OPERATION: u32 = 16;
pub const BCRYPT_RNG_OPERATION: u32 = 32;
pub const BCRYPT_KEY_DERIVATION_OPERATION: u32 = 64;
pub const BCRYPT_PUBLIC_KEY_FLAG: u32 = 1;
pub const BCRYPT_PRIVATE_KEY_FLAG: u32 = 2;
pub const BCRYPT_NO_KEY_VALIDATION: u32 = 8;
pub const BCRYPT_KEY_VALIDATION_RANGE: u32 = 16;
pub const BCRYPT_KEY_VALIDATION_RANGE_AND_ORDER: u32 = 24;
pub const BCRYPT_KEY_VALIDATION_REGENERATE: u32 = 32;
pub const BCRYPT_RNG_USE_ENTROPY_IN_BUFFER: u32 = 1;
pub const BCRYPT_USE_SYSTEM_PREFERRED_RNG: u32 = 2;
pub const BCRYPT_HASH_INTERFACE_MAJORVERSION_2: u32 = 2;
pub const CRYPT_MIN_DEPENDENCIES: u32 = 1;
pub const CRYPT_PROCESS_ISOLATE: u32 = 65536;
pub const CRYPT_UM: u32 = 1;
pub const CRYPT_KM: u32 = 2;
pub const CRYPT_MM: u32 = 3;
pub const CRYPT_ANY: u32 = 4;
pub const CRYPT_OVERWRITE: u32 = 1;
pub const CRYPT_LOCAL: u32 = 1;
pub const CRYPT_DOMAIN: u32 = 2;
pub const CRYPT_EXCLUSIVE: u32 = 1;
pub const CRYPT_OVERRIDE: u32 = 65536;
pub const CRYPT_ALL_FUNCTIONS: u32 = 1;
pub const CRYPT_ALL_PROVIDERS: u32 = 2;
pub const CRYPT_PRIORITY_TOP: u32 = 0;
pub const CRYPT_PRIORITY_BOTTOM: u32 = 4294967295;
pub const CRYPT_DEFAULT_CONTEXT: &[u8; 8] = b"Default\0";
pub const NCRYPT_MAX_KEY_NAME_LENGTH: u32 = 512;
pub const NCRYPT_MAX_ALG_ID_LENGTH: u32 = 512;
pub const MS_KEY_STORAGE_PROVIDER: &[u8; 40] = b"Microsoft Software Key Storage Provider\0";
pub const MS_SMART_CARD_KEY_STORAGE_PROVIDER: &[u8; 42] =
    b"Microsoft Smart Card Key Storage Provider\0";
pub const MS_PLATFORM_KEY_STORAGE_PROVIDER: &[u8; 35] = b"Microsoft Platform Crypto Provider\0";
pub const MS_NGC_KEY_STORAGE_PROVIDER: &[u8; 40] = b"Microsoft Passport Key Storage Provider\0";
pub const TPM_RSA_SRK_SEAL_KEY: &[u8; 68] =
    b"MICROSOFT_PCP_KSP_RSA_SEAL_KEY_3BD1C4BF-004E-4E2F-8A4D-0BF633DCB074\0";
pub const NCRYPT_RSA_ALGORITHM: &[u8; 4] = b"RSA\0";
pub const NCRYPT_RSA_SIGN_ALGORITHM: &[u8; 9] = b"RSA_SIGN\0";
pub const NCRYPT_DH_ALGORITHM: &[u8; 3] = b"DH\0";
pub const NCRYPT_DSA_ALGORITHM: &[u8; 4] = b"DSA\0";
pub const NCRYPT_MD2_ALGORITHM: &[u8; 4] = b"MD2\0";
pub const NCRYPT_MD4_ALGORITHM: &[u8; 4] = b"MD4\0";
pub const NCRYPT_MD5_ALGORITHM: &[u8; 4] = b"MD5\0";
pub const NCRYPT_SHA1_ALGORITHM: &[u8; 5] = b"SHA1\0";
pub const NCRYPT_SHA256_ALGORITHM: &[u8; 7] = b"SHA256\0";
pub const NCRYPT_SHA384_ALGORITHM: &[u8; 7] = b"SHA384\0";
pub const NCRYPT_SHA512_ALGORITHM: &[u8; 7] = b"SHA512\0";
pub const NCRYPT_ECDSA_P256_ALGORITHM: &[u8; 11] = b"ECDSA_P256\0";
pub const NCRYPT_ECDSA_P384_ALGORITHM: &[u8; 11] = b"ECDSA_P384\0";
pub const NCRYPT_ECDSA_P521_ALGORITHM: &[u8; 11] = b"ECDSA_P521\0";
pub const NCRYPT_ECDH_P256_ALGORITHM: &[u8; 10] = b"ECDH_P256\0";
pub const NCRYPT_ECDH_P384_ALGORITHM: &[u8; 10] = b"ECDH_P384\0";
pub const NCRYPT_ECDH_P521_ALGORITHM: &[u8; 10] = b"ECDH_P521\0";
pub const NCRYPT_AES_ALGORITHM: &[u8; 4] = b"AES\0";
pub const NCRYPT_RC2_ALGORITHM: &[u8; 4] = b"RC2\0";
pub const NCRYPT_3DES_ALGORITHM: &[u8; 5] = b"3DES\0";
pub const NCRYPT_DES_ALGORITHM: &[u8; 4] = b"DES\0";
pub const NCRYPT_DESX_ALGORITHM: &[u8; 5] = b"DESX\0";
pub const NCRYPT_3DES_112_ALGORITHM: &[u8; 9] = b"3DES_112\0";
pub const NCRYPT_SP800108_CTR_HMAC_ALGORITHM: &[u8; 19] = b"SP800_108_CTR_HMAC\0";
pub const NCRYPT_SP80056A_CONCAT_ALGORITHM: &[u8; 17] = b"SP800_56A_CONCAT\0";
pub const NCRYPT_PBKDF2_ALGORITHM: &[u8; 7] = b"PBKDF2\0";
pub const NCRYPT_CAPI_KDF_ALGORITHM: &[u8; 9] = b"CAPI_KDF\0";
pub const NCRYPT_ECDSA_ALGORITHM: &[u8; 6] = b"ECDSA\0";
pub const NCRYPT_ECDH_ALGORITHM: &[u8; 5] = b"ECDH\0";
pub const NCRYPT_KEY_STORAGE_ALGORITHM: &[u8; 12] = b"KEY_STORAGE\0";
pub const NCRYPT_HMAC_SHA256_ALGORITHM: &[u8; 12] = b"HMAC-SHA256\0";
pub const NCRYPT_CIPHER_INTERFACE: u32 = 1;
pub const NCRYPT_HASH_INTERFACE: u32 = 2;
pub const NCRYPT_ASYMMETRIC_ENCRYPTION_INTERFACE: u32 = 3;
pub const NCRYPT_SECRET_AGREEMENT_INTERFACE: u32 = 4;
pub const NCRYPT_SIGNATURE_INTERFACE: u32 = 5;
pub const NCRYPT_KEY_DERIVATION_INTERFACE: u32 = 7;
pub const NCRYPT_KEY_STORAGE_INTERFACE: u32 = 65537;
pub const NCRYPT_SCHANNEL_INTERFACE: u32 = 65538;
pub const NCRYPT_SCHANNEL_SIGNATURE_INTERFACE: u32 = 65539;
pub const NCRYPT_KEY_PROTECTION_INTERFACE: u32 = 65540;
pub const NCRYPT_RSA_ALGORITHM_GROUP: &[u8; 4] = b"RSA\0";
pub const NCRYPT_DH_ALGORITHM_GROUP: &[u8; 3] = b"DH\0";
pub const NCRYPT_DSA_ALGORITHM_GROUP: &[u8; 4] = b"DSA\0";
pub const NCRYPT_ECDSA_ALGORITHM_GROUP: &[u8; 6] = b"ECDSA\0";
pub const NCRYPT_ECDH_ALGORITHM_GROUP: &[u8; 5] = b"ECDH\0";
pub const NCRYPT_AES_ALGORITHM_GROUP: &[u8; 4] = b"AES\0";
pub const NCRYPT_RC2_ALGORITHM_GROUP: &[u8; 4] = b"RC2\0";
pub const NCRYPT_DES_ALGORITHM_GROUP: &[u8; 4] = b"DES\0";
pub const NCRYPT_KEY_DERIVATION_GROUP: &[u8; 15] = b"KEY_DERIVATION\0";
pub const NCRYPTBUFFER_VERSION: u32 = 0;
pub const NCRYPTBUFFER_EMPTY: u32 = 0;
pub const NCRYPTBUFFER_DATA: u32 = 1;
pub const NCRYPTBUFFER_PROTECTION_DESCRIPTOR_STRING: u32 = 3;
pub const NCRYPTBUFFER_PROTECTION_FLAGS: u32 = 4;
pub const NCRYPTBUFFER_SSL_CLIENT_RANDOM: u32 = 20;
pub const NCRYPTBUFFER_SSL_SERVER_RANDOM: u32 = 21;
pub const NCRYPTBUFFER_SSL_HIGHEST_VERSION: u32 = 22;
pub const NCRYPTBUFFER_SSL_CLEAR_KEY: u32 = 23;
pub const NCRYPTBUFFER_SSL_KEY_ARG_DATA: u32 = 24;
pub const NCRYPTBUFFER_SSL_SESSION_HASH: u32 = 25;
pub const NCRYPTBUFFER_PKCS_OID: u32 = 40;
pub const NCRYPTBUFFER_PKCS_ALG_OID: u32 = 41;
pub const NCRYPTBUFFER_PKCS_ALG_PARAM: u32 = 42;
pub const NCRYPTBUFFER_PKCS_ALG_ID: u32 = 43;
pub const NCRYPTBUFFER_PKCS_ATTRS: u32 = 44;
pub const NCRYPTBUFFER_PKCS_KEY_NAME: u32 = 45;
pub const NCRYPTBUFFER_PKCS_SECRET: u32 = 46;
pub const NCRYPTBUFFER_CERT_BLOB: u32 = 47;
pub const NCRYPTBUFFER_CLAIM_IDBINDING_NONCE: u32 = 48;
pub const NCRYPTBUFFER_CLAIM_KEYATTESTATION_NONCE: u32 = 49;
pub const NCRYPTBUFFER_KEY_PROPERTY_FLAGS: u32 = 50;
pub const NCRYPTBUFFER_ATTESTATIONSTATEMENT_BLOB: u32 = 51;
pub const NCRYPTBUFFER_ATTESTATION_CLAIM_TYPE: u32 = 52;
pub const NCRYPTBUFFER_ATTESTATION_CLAIM_CHALLENGE_REQUIRED: u32 = 53;
pub const NCRYPTBUFFER_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS: u32 = 54;
pub const NCRYPTBUFFER_ECC_CURVE_NAME: u32 = 60;
pub const NCRYPTBUFFER_ECC_PARAMETERS: u32 = 61;
pub const NCRYPTBUFFER_TPM_SEAL_PASSWORD: u32 = 70;
pub const NCRYPTBUFFER_TPM_SEAL_POLICYINFO: u32 = 71;
pub const NCRYPTBUFFER_TPM_SEAL_TICKET: u32 = 72;
pub const NCRYPTBUFFER_TPM_SEAL_NO_DA_PROTECTION: u32 = 73;
pub const NCRYPTBUFFER_TPM_PLATFORM_CLAIM_PCR_MASK: u32 = 80;
pub const NCRYPTBUFFER_TPM_PLATFORM_CLAIM_NONCE: u32 = 81;
pub const NCRYPTBUFFER_TPM_PLATFORM_CLAIM_STATIC_CREATE: u32 = 82;
pub const NCRYPT_CIPHER_NO_PADDING_FLAG: u32 = 0;
pub const NCRYPT_CIPHER_BLOCK_PADDING_FLAG: u32 = 1;
pub const NCRYPT_CIPHER_OTHER_PADDING_FLAG: u32 = 2;
pub const NCRYPT_PLATFORM_ATTEST_MAGIC: u32 = 1146110288;
pub const NCRYPT_KEY_ATTEST_MAGIC: u32 = 1146110283;
pub const NCRYPT_CLAIM_AUTHORITY_ONLY: u32 = 1;
pub const NCRYPT_CLAIM_SUBJECT_ONLY: u32 = 2;
pub const NCRYPT_CLAIM_WEB_AUTH_SUBJECT_ONLY: u32 = 258;
pub const NCRYPT_CLAIM_AUTHORITY_AND_SUBJECT: u32 = 3;
pub const NCRYPT_CLAIM_VSM_KEY_ATTESTATION_STATEMENT: u32 = 4;
pub const NCRYPT_CLAIM_UNKNOWN: u32 = 4096;
pub const NCRYPT_CLAIM_PLATFORM: u32 = 65536;
pub const NCRYPT_ISOLATED_KEY_FLAG_CREATED_IN_ISOLATION: u32 = 1;
pub const NCRYPT_ISOLATED_KEY_FLAG_IMPORT_ONLY: u32 = 2;
pub const NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES_V0: u32 = 0;
pub const NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES_CURRENT_VERSION: u32 = 0;
pub const NCRYPT_VSM_KEY_ATTESTATION_STATEMENT_V0: u32 = 0;
pub const NCRYPT_VSM_KEY_ATTESTATION_STATEMENT_CURRENT_VERSION: u32 = 0;
pub const NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS_V0: u32 = 0;
pub const NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS_CURRENT_VERSION: u32 = 0;
pub const NCRYPT_EXPORTED_ISOLATED_KEY_HEADER_V0: u32 = 0;
pub const NCRYPT_EXPORTED_ISOLATED_KEY_HEADER_CURRENT_VERSION: u32 = 0;
pub const NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT_V0: u32 = 0;
pub const NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT_CURRENT_VERSION: u32 = 0;
pub const NCRYPT_NO_PADDING_FLAG: u32 = 1;
pub const NCRYPT_PAD_PKCS1_FLAG: u32 = 2;
pub const NCRYPT_PAD_OAEP_FLAG: u32 = 4;
pub const NCRYPT_PAD_PSS_FLAG: u32 = 8;
pub const NCRYPT_PAD_CIPHER_FLAG: u32 = 16;
pub const NCRYPT_ATTESTATION_FLAG: u32 = 32;
pub const NCRYPT_SEALING_FLAG: u32 = 256;
pub const NCRYPT_REGISTER_NOTIFY_FLAG: u32 = 1;
pub const NCRYPT_UNREGISTER_NOTIFY_FLAG: u32 = 2;
pub const NCRYPT_NO_KEY_VALIDATION: u32 = 8;
pub const NCRYPT_MACHINE_KEY_FLAG: u32 = 32;
pub const NCRYPT_SILENT_FLAG: u32 = 64;
pub const NCRYPT_OVERWRITE_KEY_FLAG: u32 = 128;
pub const NCRYPT_WRITE_KEY_TO_LEGACY_STORE_FLAG: u32 = 512;
pub const NCRYPT_DO_NOT_FINALIZE_FLAG: u32 = 1024;
pub const NCRYPT_EXPORT_LEGACY_FLAG: u32 = 2048;
pub const NCRYPT_IGNORE_DEVICE_STATE_FLAG: u32 = 4096;
pub const NCRYPT_TREAT_NIST_AS_GENERIC_ECC_FLAG: u32 = 8192;
pub const NCRYPT_NO_CACHED_PASSWORD: u32 = 16384;
pub const NCRYPT_PROTECT_TO_LOCAL_SYSTEM: u32 = 32768;
pub const NCRYPT_PERSIST_ONLY_FLAG: u32 = 1073741824;
pub const NCRYPT_PERSIST_FLAG: u32 = 2147483648;
pub const NCRYPT_PREFER_VIRTUAL_ISOLATION_FLAG: u32 = 65536;
pub const NCRYPT_USE_VIRTUAL_ISOLATION_FLAG: u32 = 131072;
pub const NCRYPT_USE_PER_BOOT_KEY_FLAG: u32 = 262144;
pub const NCRYPT_CIPHER_OPERATION: u32 = 1;
pub const NCRYPT_HASH_OPERATION: u32 = 2;
pub const NCRYPT_ASYMMETRIC_ENCRYPTION_OPERATION: u32 = 4;
pub const NCRYPT_SECRET_AGREEMENT_OPERATION: u32 = 8;
pub const NCRYPT_SIGNATURE_OPERATION: u32 = 16;
pub const NCRYPT_RNG_OPERATION: u32 = 32;
pub const NCRYPT_KEY_DERIVATION_OPERATION: u32 = 64;
pub const NCRYPT_AUTHORITY_KEY_FLAG: u32 = 256;
pub const NCRYPT_NAME_PROPERTY: &[u8; 5] = b"Name\0";
pub const NCRYPT_UNIQUE_NAME_PROPERTY: &[u8; 12] = b"Unique Name\0";
pub const NCRYPT_ALGORITHM_PROPERTY: &[u8; 15] = b"Algorithm Name\0";
pub const NCRYPT_LENGTH_PROPERTY: &[u8; 7] = b"Length\0";
pub const NCRYPT_LENGTHS_PROPERTY: &[u8; 8] = b"Lengths\0";
pub const NCRYPT_BLOCK_LENGTH_PROPERTY: &[u8; 13] = b"Block Length\0";
pub const NCRYPT_PUBLIC_LENGTH_PROPERTY: &[u8; 16] = b"PublicKeyLength\0";
pub const NCRYPT_SIGNATURE_LENGTH_PROPERTY: &[u8; 16] = b"SignatureLength\0";
pub const NCRYPT_CHAINING_MODE_PROPERTY: &[u8; 14] = b"Chaining Mode\0";
pub const NCRYPT_AUTH_TAG_LENGTH: &[u8; 14] = b"AuthTagLength\0";
pub const NCRYPT_UI_POLICY_PROPERTY: &[u8; 10] = b"UI Policy\0";
pub const NCRYPT_EXPORT_POLICY_PROPERTY: &[u8; 14] = b"Export Policy\0";
pub const NCRYPT_WINDOW_HANDLE_PROPERTY: &[u8; 12] = b"HWND Handle\0";
pub const NCRYPT_USE_CONTEXT_PROPERTY: &[u8; 12] = b"Use Context\0";
pub const NCRYPT_IMPL_TYPE_PROPERTY: &[u8; 10] = b"Impl Type\0";
pub const NCRYPT_KEY_USAGE_PROPERTY: &[u8; 10] = b"Key Usage\0";
pub const NCRYPT_KEY_TYPE_PROPERTY: &[u8; 9] = b"Key Type\0";
pub const NCRYPT_VERSION_PROPERTY: &[u8; 8] = b"Version\0";
pub const NCRYPT_SECURITY_DESCR_SUPPORT_PROPERTY: &[u8; 23] = b"Security Descr Support\0";
pub const NCRYPT_SECURITY_DESCR_PROPERTY: &[u8; 15] = b"Security Descr\0";
pub const NCRYPT_USE_COUNT_ENABLED_PROPERTY: &[u8; 18] = b"Enabled Use Count\0";
pub const NCRYPT_USE_COUNT_PROPERTY: &[u8; 10] = b"Use Count\0";
pub const NCRYPT_LAST_MODIFIED_PROPERTY: &[u8; 9] = b"Modified\0";
pub const NCRYPT_MAX_NAME_LENGTH_PROPERTY: &[u8; 16] = b"Max Name Length\0";
pub const NCRYPT_ALGORITHM_GROUP_PROPERTY: &[u8; 16] = b"Algorithm Group\0";
pub const NCRYPT_DH_PARAMETERS_PROPERTY: &[u8; 13] = b"DHParameters\0";
pub const NCRYPT_ECC_PARAMETERS_PROPERTY: &[u8; 14] = b"ECCParameters\0";
pub const NCRYPT_ECC_CURVE_NAME_PROPERTY: &[u8; 13] = b"ECCCurveName\0";
pub const NCRYPT_ECC_CURVE_NAME_LIST_PROPERTY: &[u8; 17] = b"ECCCurveNameList\0";
pub const NCRYPT_USE_VIRTUAL_ISOLATION_PROPERTY: &[u8; 12] = b"Virtual Iso\0";
pub const NCRYPT_USE_PER_BOOT_KEY_PROPERTY: &[u8; 13] = b"Per Boot Key\0";
pub const NCRYPT_PROVIDER_HANDLE_PROPERTY: &[u8; 16] = b"Provider Handle\0";
pub const NCRYPT_PIN_PROPERTY: &[u8; 13] = b"SmartCardPin\0";
pub const NCRYPT_READER_PROPERTY: &[u8; 16] = b"SmartCardReader\0";
pub const NCRYPT_SMARTCARD_GUID_PROPERTY: &[u8; 14] = b"SmartCardGuid\0";
pub const NCRYPT_CERTIFICATE_PROPERTY: &[u8; 24] = b"SmartCardKeyCertificate\0";
pub const NCRYPT_PIN_PROMPT_PROPERTY: &[u8; 19] = b"SmartCardPinPrompt\0";
pub const NCRYPT_USER_CERTSTORE_PROPERTY: &[u8; 23] = b"SmartCardUserCertStore\0";
pub const NCRYPT_ROOT_CERTSTORE_PROPERTY: &[u8; 23] = b"SmartcardRootCertStore\0";
pub const NCRYPT_SECURE_PIN_PROPERTY: &[u8; 19] = b"SmartCardSecurePin\0";
pub const NCRYPT_ASSOCIATED_ECDH_KEY: &[u8; 27] = b"SmartCardAssociatedECDHKey\0";
pub const NCRYPT_SCARD_PIN_ID: &[u8; 15] = b"SmartCardPinId\0";
pub const NCRYPT_SCARD_PIN_INFO: &[u8; 17] = b"SmartCardPinInfo\0";
pub const NCRYPT_READER_ICON_PROPERTY: &[u8; 20] = b"SmartCardReaderIcon\0";
pub const NCRYPT_KDF_SECRET_VALUE: &[u8; 13] = b"KDFKeySecret\0";
pub const NCRYPT_DISMISS_UI_TIMEOUT_SEC_PROPERTY: &[u8; 33] = b"SmartCardDismissUITimeoutSeconds\0";
pub const NCRYPT_PCP_PLATFORM_TYPE_PROPERTY: &[u8; 18] = b"PCP_PLATFORM_TYPE\0";
pub const NCRYPT_PCP_PROVIDER_VERSION_PROPERTY: &[u8; 21] = b"PCP_PROVIDER_VERSION\0";
pub const NCRYPT_PCP_EKPUB_PROPERTY: &[u8; 10] = b"PCP_EKPUB\0";
pub const NCRYPT_PCP_EKCERT_PROPERTY: &[u8; 11] = b"PCP_EKCERT\0";
pub const NCRYPT_PCP_EKNVCERT_PROPERTY: &[u8; 13] = b"PCP_EKNVCERT\0";
pub const NCRYPT_PCP_RSA_EKPUB_PROPERTY: &[u8; 14] = b"PCP_RSA_EKPUB\0";
pub const NCRYPT_PCP_RSA_EKCERT_PROPERTY: &[u8; 15] = b"PCP_RSA_EKCERT\0";
pub const NCRYPT_PCP_RSA_EKNVCERT_PROPERTY: &[u8; 17] = b"PCP_RSA_EKNVCERT\0";
pub const NCRYPT_PCP_ECC_EKPUB_PROPERTY: &[u8; 14] = b"PCP_ECC_EKPUB\0";
pub const NCRYPT_PCP_ECC_EKCERT_PROPERTY: &[u8; 15] = b"PCP_ECC_EKCERT\0";
pub const NCRYPT_PCP_ECC_EKNVCERT_PROPERTY: &[u8; 17] = b"PCP_ECC_EKNVCERT\0";
pub const NCRYPT_PCP_SRKPUB_PROPERTY: &[u8; 11] = b"PCP_SRKPUB\0";
pub const NCRYPT_PCP_PCRTABLE_PROPERTY: &[u8; 13] = b"PCP_PCRTABLE\0";
pub const NCRYPT_PCP_CHANGEPASSWORD_PROPERTY: &[u8; 19] = b"PCP_CHANGEPASSWORD\0";
pub const NCRYPT_PCP_PASSWORD_REQUIRED_PROPERTY: &[u8; 22] = b"PCP_PASSWORD_REQUIRED\0";
pub const NCRYPT_PCP_USAGEAUTH_PROPERTY: &[u8; 14] = b"PCP_USAGEAUTH\0";
pub const NCRYPT_PCP_MIGRATIONPASSWORD_PROPERTY: &[u8; 22] = b"PCP_MIGRATIONPASSWORD\0";
pub const NCRYPT_PCP_EXPORT_ALLOWED_PROPERTY: &[u8; 19] = b"PCP_EXPORT_ALLOWED\0";
pub const NCRYPT_PCP_STORAGEPARENT_PROPERTY: &[u8; 18] = b"PCP_STORAGEPARENT\0";
pub const NCRYPT_PCP_PROVIDERHANDLE_PROPERTY: &[u8; 20] = b"PCP_PROVIDERMHANDLE\0";
pub const NCRYPT_PCP_PLATFORMHANDLE_PROPERTY: &[u8; 19] = b"PCP_PLATFORMHANDLE\0";
pub const NCRYPT_PCP_PLATFORM_BINDING_PCRMASK_PROPERTY: &[u8; 29] =
    b"PCP_PLATFORM_BINDING_PCRMASK\0";
pub const NCRYPT_PCP_PLATFORM_BINDING_PCRDIGESTLIST_PROPERTY: &[u8; 35] =
    b"PCP_PLATFORM_BINDING_PCRDIGESTLIST\0";
pub const NCRYPT_PCP_PLATFORM_BINDING_PCRDIGEST_PROPERTY: &[u8; 31] =
    b"PCP_PLATFORM_BINDING_PCRDIGEST\0";
pub const NCRYPT_PCP_KEY_USAGE_POLICY_PROPERTY: &[u8; 21] = b"PCP_KEY_USAGE_POLICY\0";
pub const NCRYPT_PCP_RSA_SCHEME_PROPERTY: &[u8; 15] = b"PCP_RSA_SCHEME\0";
pub const NCRYPT_PCP_TPM12_IDBINDING_PROPERTY: &[u8; 20] = b"PCP_TPM12_IDBINDING\0";
pub const NCRYPT_PCP_TPM12_IDBINDING_DYNAMIC_PROPERTY: &[u8; 28] = b"PCP_TPM12_IDBINDING_DYNAMIC\0";
pub const NCRYPT_PCP_TPM12_IDACTIVATION_PROPERTY: &[u8; 23] = b"PCP_TPM12_IDACTIVATION\0";
pub const NCRYPT_PCP_KEYATTESTATION_PROPERTY: &[u8; 25] = b"PCP_TPM12_KEYATTESTATION\0";
pub const NCRYPT_PCP_ALTERNATE_KEY_STORAGE_LOCATION_PROPERTY: &[u8; 35] =
    b"PCP_ALTERNATE_KEY_STORAGE_LOCATION\0";
pub const NCRYPT_PCP_PLATFORM_BINDING_PCRALGID_PROPERTY: &[u8; 30] =
    b"PCP_PLATFORM_BINDING_PCRALGID\0";
pub const NCRYPT_PCP_HMAC_AUTH_POLICYREF: &[u8; 24] = b"PCP_HMAC_AUTH_POLICYREF\0";
pub const NCRYPT_PCP_HMAC_AUTH_POLICYINFO: &[u8; 25] = b"PCP_HMAC_AUTH_POLICYINFO\0";
pub const NCRYPT_PCP_HMAC_AUTH_NONCE: &[u8; 20] = b"PCP_HMAC_AUTH_NONCE\0";
pub const NCRYPT_PCP_HMAC_AUTH_SIGNATURE: &[u8; 24] = b"PCP_HMAC_AUTH_SIGNATURE\0";
pub const NCRYPT_PCP_HMAC_AUTH_TICKET: &[u8; 21] = b"PCP_HMAC_AUTH_TICKET\0";
pub const NCRYPT_PCP_NO_DA_PROTECTION_PROPERTY: &[u8; 21] = b"PCP_NO_DA_PROTECTION\0";
pub const NCRYPT_PCP_TPM_MANUFACTURER_ID_PROPERTY: &[u8; 24] = b"PCP_TPM_MANUFACTURER_ID\0";
pub const NCRYPT_PCP_TPM_FW_VERSION_PROPERTY: &[u8; 19] = b"PCP_TPM_FW_VERSION\0";
pub const NCRYPT_PCP_TPM2BNAME_PROPERTY: &[u8; 14] = b"PCP_TPM2BNAME\0";
pub const NCRYPT_PCP_TPM_VERSION_PROPERTY: &[u8; 16] = b"PCP_TPM_VERSION\0";
pub const NCRYPT_PCP_RAW_POLICYDIGEST_PROPERTY: &[u8; 21] = b"PCP_RAW_POLICYDIGEST\0";
pub const NCRYPT_PCP_KEY_CREATIONHASH_PROPERTY: &[u8; 21] = b"PCP_KEY_CREATIONHASH\0";
pub const NCRYPT_PCP_KEY_CREATIONTICKET_PROPERTY: &[u8; 23] = b"PCP_KEY_CREATIONTICKET\0";
pub const NCRYPT_PCP_RSA_SCHEME_HASH_ALG_PROPERTY: &[u8; 24] = b"PCP_RSA_SCHEME_HASH_ALG\0";
pub const NCRYPT_PCP_TPM_IFX_RSA_KEYGEN_PROHIBITED_PROPERTY: &[u8; 34] =
    b"PCP_TPM_IFX_RSA_KEYGEN_PROHIBITED\0";
pub const NCRYPT_PCP_TPM_IFX_RSA_KEYGEN_VULNERABILITY_PROPERTY: &[u8; 37] =
    b"PCP_TPM_IFX_RSA_KEYGEN_VULNERABILITY\0";
pub const IFX_RSA_KEYGEN_VUL_NOT_AFFECTED: u32 = 0;
pub const IFX_RSA_KEYGEN_VUL_AFFECTED_LEVEL_1: u32 = 1;
pub const IFX_RSA_KEYGEN_VUL_AFFECTED_LEVEL_2: u32 = 2;
pub const NCRYPT_PCP_SESSIONID_PROPERTY: &[u8; 14] = b"PCP_SESSIONID\0";
pub const NCRYPT_PCP_PSS_SALT_SIZE_PROPERTY: &[u8; 14] = b"PSS Salt Size\0";
pub const NCRYPT_TPM_PSS_SALT_SIZE_UNKNOWN: u32 = 0;
pub const NCRYPT_TPM_PSS_SALT_SIZE_MAXIMUM: u32 = 1;
pub const NCRYPT_TPM_PSS_SALT_SIZE_HASHSIZE: u32 = 2;
pub const NCRYPT_PCP_INTERMEDIATE_CA_EKCERT_PROPERTY: &[u8; 27] = b"PCP_INTERMEDIATE_CA_EKCERT\0";
pub const NCRYPT_PCP_PCRTABLE_ALGORITHM_PROPERTY: &[u8; 23] = b"PCP_PCRTABLE_ALGORITHM\0";
pub const NCRYPT_PCP_SYMMETRIC_KEYBITS_PROPERTY: &[u8; 22] = b"PCP_SYMMETRIC_KEYBITS\0";
pub const NCRYPT_TPM_PAD_PSS_IGNORE_SALT: u32 = 32;
pub const NCRYPT_TPM12_PROVIDER: u32 = 65536;
pub const NCRYPT_PCP_SIGNATURE_KEY: u32 = 1;
pub const NCRYPT_PCP_ENCRYPTION_KEY: u32 = 2;
pub const NCRYPT_PCP_GENERIC_KEY: u32 = 3;
pub const NCRYPT_PCP_STORAGE_KEY: u32 = 4;
pub const NCRYPT_PCP_IDENTITY_KEY: u32 = 8;
pub const NCRYPT_PCP_HMACVERIFICATION_KEY: u32 = 16;
pub const NCRYPT_SCARD_NGC_KEY_NAME: &[u8; 20] = b"SmartCardNgcKeyName\0";
pub const NCRYPT_INITIALIZATION_VECTOR: &[u8; 3] = b"IV\0";
pub const NCRYPT_CHANGEPASSWORD_PROPERTY: &[u8; 19] = b"PCP_CHANGEPASSWORD\0";
pub const NCRYPT_ALTERNATE_KEY_STORAGE_LOCATION_PROPERTY: &[u8; 35] =
    b"PCP_ALTERNATE_KEY_STORAGE_LOCATION\0";
pub const NCRYPT_KEY_ACCESS_POLICY_PROPERTY: &[u8; 18] = b"Key Access Policy\0";
pub const NCRYPT_MAX_PROPERTY_NAME: u32 = 64;
pub const NCRYPT_MAX_PROPERTY_DATA: u32 = 1048576;
pub const NCRYPT_ALLOW_EXPORT_FLAG: u32 = 1;
pub const NCRYPT_ALLOW_PLAINTEXT_EXPORT_FLAG: u32 = 2;
pub const NCRYPT_ALLOW_ARCHIVING_FLAG: u32 = 4;
pub const NCRYPT_ALLOW_PLAINTEXT_ARCHIVING_FLAG: u32 = 8;
pub const NCRYPT_IMPL_HARDWARE_FLAG: u32 = 1;
pub const NCRYPT_IMPL_SOFTWARE_FLAG: u32 = 2;
pub const NCRYPT_IMPL_REMOVABLE_FLAG: u32 = 8;
pub const NCRYPT_IMPL_HARDWARE_RNG_FLAG: u32 = 16;
pub const NCRYPT_IMPL_VIRTUAL_ISOLATION_FLAG: u32 = 32;
pub const NCRYPT_ALLOW_DECRYPT_FLAG: u32 = 1;
pub const NCRYPT_ALLOW_SIGNING_FLAG: u32 = 2;
pub const NCRYPT_ALLOW_KEY_AGREEMENT_FLAG: u32 = 4;
pub const NCRYPT_ALLOW_KEY_IMPORT_FLAG: u32 = 8;
pub const NCRYPT_ALLOW_ALL_USAGES: u32 = 16777215;
pub const NCRYPT_UI_PROTECT_KEY_FLAG: u32 = 1;
pub const NCRYPT_UI_FORCE_HIGH_PROTECTION_FLAG: u32 = 2;
pub const NCRYPT_UI_FINGERPRINT_PROTECTION_FLAG: u32 = 4;
pub const NCRYPT_UI_APPCONTAINER_ACCESS_MEDIUM_FLAG: u32 = 8;
pub const NCRYPT_PIN_CACHE_FREE_APPLICATION_TICKET_PROPERTY: &[u8; 30] =
    b"PinCacheFreeApplicationTicket\0";
pub const NCRYPT_PIN_CACHE_FLAGS_PROPERTY: &[u8; 14] = b"PinCacheFlags\0";
pub const NCRYPT_PIN_CACHE_DISABLE_DPL_FLAG: u32 = 1;
pub const NCRYPT_PIN_CACHE_APPLICATION_TICKET_PROPERTY: &[u8; 26] = b"PinCacheApplicationTicket\0";
pub const NCRYPT_PIN_CACHE_APPLICATION_IMAGE_PROPERTY: &[u8; 25] = b"PinCacheApplicationImage\0";
pub const NCRYPT_PIN_CACHE_APPLICATION_STATUS_PROPERTY: &[u8; 26] = b"PinCacheApplicationStatus\0";
pub const NCRYPT_PIN_CACHE_PIN_PROPERTY: &[u8; 12] = b"PinCachePin\0";
pub const NCRYPT_PIN_CACHE_IS_GESTURE_REQUIRED_PROPERTY: &[u8; 26] = b"PinCacheIsGestureRequired\0";
pub const NCRYPT_PIN_CACHE_REQUIRE_GESTURE_FLAG: u32 = 1;
pub const NCRYPT_PIN_CACHE_PIN_BYTE_LENGTH: u32 = 90;
pub const NCRYPT_PIN_CACHE_APPLICATION_TICKET_BYTE_LENGTH: u32 = 90;
pub const NCRYPT_PIN_CACHE_CLEAR_PROPERTY: &[u8; 14] = b"PinCacheClear\0";
pub const NCRYPT_PIN_CACHE_CLEAR_FOR_CALLING_PROCESS_OPTION: u32 = 1;
pub const NCRYPT_KEY_ACCESS_POLICY_VERSION: u32 = 1;
pub const NCRYPT_ALLOW_SILENT_KEY_ACCESS: u32 = 1;
pub const NCRYPT_CIPHER_KEY_BLOB_MAGIC: u32 = 1380470851;
pub const NCRYPT_KDF_KEY_BLOB_MAGIC: u32 = 826688587;
pub const NCRYPT_PROTECTED_KEY_BLOB_MAGIC: u32 = 1263817296;
pub const NCRYPT_CIPHER_KEY_BLOB: &[u8; 14] = b"CipherKeyBlob\0";
pub const NCRYPT_KDF_KEY_BLOB: &[u8; 11] = b"KDFKeyBlob\0";
pub const NCRYPT_PROTECTED_KEY_BLOB: &[u8; 17] = b"ProtectedKeyBlob\0";
pub const NCRYPT_TPM_LOADABLE_KEY_BLOB: &[u8; 23] = b"PcpTpmProtectedKeyBlob\0";
pub const NCRYPT_TPM_LOADABLE_KEY_BLOB_MAGIC: u32 = 1297371211;
pub const NCRYPT_PKCS7_ENVELOPE_BLOB: &[u8; 15] = b"PKCS7_ENVELOPE\0";
pub const NCRYPT_PKCS8_PRIVATE_KEY_BLOB: &[u8; 17] = b"PKCS8_PRIVATEKEY\0";
pub const NCRYPT_OPAQUETRANSPORT_BLOB: &[u8; 16] = b"OpaqueTransport\0";
pub const NCRYPT_ISOLATED_KEY_ENVELOPE_BLOB: &[u8; 22] = b"ISOLATED_KEY_ENVELOPE\0";
pub const szOID_RSA: &[u8; 15] = b"1.2.840.113549\0";
pub const szOID_PKCS: &[u8; 17] = b"1.2.840.113549.1\0";
pub const szOID_RSA_HASH: &[u8; 17] = b"1.2.840.113549.2\0";
pub const szOID_RSA_ENCRYPT: &[u8; 17] = b"1.2.840.113549.3\0";
pub const szOID_PKCS_1: &[u8; 19] = b"1.2.840.113549.1.1\0";
pub const szOID_PKCS_2: &[u8; 19] = b"1.2.840.113549.1.2\0";
pub const szOID_PKCS_3: &[u8; 19] = b"1.2.840.113549.1.3\0";
pub const szOID_PKCS_4: &[u8; 19] = b"1.2.840.113549.1.4\0";
pub const szOID_PKCS_5: &[u8; 19] = b"1.2.840.113549.1.5\0";
pub const szOID_PKCS_6: &[u8; 19] = b"1.2.840.113549.1.6\0";
pub const szOID_PKCS_7: &[u8; 19] = b"1.2.840.113549.1.7\0";
pub const szOID_PKCS_8: &[u8; 19] = b"1.2.840.113549.1.8\0";
pub const szOID_PKCS_9: &[u8; 19] = b"1.2.840.113549.1.9\0";
pub const szOID_PKCS_10: &[u8; 20] = b"1.2.840.113549.1.10\0";
pub const szOID_PKCS_12: &[u8; 20] = b"1.2.840.113549.1.12\0";
pub const szOID_RSA_RSA: &[u8; 21] = b"1.2.840.113549.1.1.1\0";
pub const szOID_RSA_MD2RSA: &[u8; 21] = b"1.2.840.113549.1.1.2\0";
pub const szOID_RSA_MD4RSA: &[u8; 21] = b"1.2.840.113549.1.1.3\0";
pub const szOID_RSA_MD5RSA: &[u8; 21] = b"1.2.840.113549.1.1.4\0";
pub const szOID_RSA_SHA1RSA: &[u8; 21] = b"1.2.840.113549.1.1.5\0";
pub const szOID_RSA_SETOAEP_RSA: &[u8; 21] = b"1.2.840.113549.1.1.6\0";
pub const szOID_RSAES_OAEP: &[u8; 21] = b"1.2.840.113549.1.1.7\0";
pub const szOID_RSA_MGF1: &[u8; 21] = b"1.2.840.113549.1.1.8\0";
pub const szOID_RSA_PSPECIFIED: &[u8; 21] = b"1.2.840.113549.1.1.9\0";
pub const szOID_RSA_SSA_PSS: &[u8; 22] = b"1.2.840.113549.1.1.10\0";
pub const szOID_RSA_SHA256RSA: &[u8; 22] = b"1.2.840.113549.1.1.11\0";
pub const szOID_RSA_SHA384RSA: &[u8; 22] = b"1.2.840.113549.1.1.12\0";
pub const szOID_RSA_SHA512RSA: &[u8; 22] = b"1.2.840.113549.1.1.13\0";
pub const szOID_RSA_DH: &[u8; 21] = b"1.2.840.113549.1.3.1\0";
pub const szOID_RSA_data: &[u8; 21] = b"1.2.840.113549.1.7.1\0";
pub const szOID_RSA_signedData: &[u8; 21] = b"1.2.840.113549.1.7.2\0";
pub const szOID_RSA_envelopedData: &[u8; 21] = b"1.2.840.113549.1.7.3\0";
pub const szOID_RSA_signEnvData: &[u8; 21] = b"1.2.840.113549.1.7.4\0";
pub const szOID_RSA_digestedData: &[u8; 21] = b"1.2.840.113549.1.7.5\0";
pub const szOID_RSA_hashedData: &[u8; 21] = b"1.2.840.113549.1.7.5\0";
pub const szOID_RSA_encryptedData: &[u8; 21] = b"1.2.840.113549.1.7.6\0";
pub const szOID_RSA_emailAddr: &[u8; 21] = b"1.2.840.113549.1.9.1\0";
pub const szOID_RSA_unstructName: &[u8; 21] = b"1.2.840.113549.1.9.2\0";
pub const szOID_RSA_contentType: &[u8; 21] = b"1.2.840.113549.1.9.3\0";
pub const szOID_RSA_messageDigest: &[u8; 21] = b"1.2.840.113549.1.9.4\0";
pub const szOID_RSA_signingTime: &[u8; 21] = b"1.2.840.113549.1.9.5\0";
pub const szOID_RSA_counterSign: &[u8; 21] = b"1.2.840.113549.1.9.6\0";
pub const szOID_RSA_challengePwd: &[u8; 21] = b"1.2.840.113549.1.9.7\0";
pub const szOID_RSA_unstructAddr: &[u8; 21] = b"1.2.840.113549.1.9.8\0";
pub const szOID_RSA_extCertAttrs: &[u8; 21] = b"1.2.840.113549.1.9.9\0";
pub const szOID_RSA_certExtensions: &[u8; 22] = b"1.2.840.113549.1.9.14\0";
pub const szOID_RSA_SMIMECapabilities: &[u8; 22] = b"1.2.840.113549.1.9.15\0";
pub const szOID_RSA_preferSignedData: &[u8; 24] = b"1.2.840.113549.1.9.15.1\0";
pub const szOID_TIMESTAMP_TOKEN: &[u8; 26] = b"1.2.840.113549.1.9.16.1.4\0";
pub const szOID_RFC3161_counterSign: &[u8; 22] = b"1.3.6.1.4.1.311.3.3.1\0";
pub const szOID_RSA_SMIMEalg: &[u8; 24] = b"1.2.840.113549.1.9.16.3\0";
pub const szOID_RSA_SMIMEalgESDH: &[u8; 26] = b"1.2.840.113549.1.9.16.3.5\0";
pub const szOID_RSA_SMIMEalgCMS3DESwrap: &[u8; 26] = b"1.2.840.113549.1.9.16.3.6\0";
pub const szOID_RSA_SMIMEalgCMSRC2wrap: &[u8; 26] = b"1.2.840.113549.1.9.16.3.7\0";
pub const szOID_RSA_MD2: &[u8; 19] = b"1.2.840.113549.2.2\0";
pub const szOID_RSA_MD4: &[u8; 19] = b"1.2.840.113549.2.4\0";
pub const szOID_RSA_MD5: &[u8; 19] = b"1.2.840.113549.2.5\0";
pub const szOID_RSA_RC2CBC: &[u8; 19] = b"1.2.840.113549.3.2\0";
pub const szOID_RSA_RC4: &[u8; 19] = b"1.2.840.113549.3.4\0";
pub const szOID_RSA_DES_EDE3_CBC: &[u8; 19] = b"1.2.840.113549.3.7\0";
pub const szOID_RSA_RC5_CBCPad: &[u8; 19] = b"1.2.840.113549.3.9\0";
pub const szOID_ANSI_X942: &[u8; 14] = b"1.2.840.10046\0";
pub const szOID_ANSI_X942_DH: &[u8; 18] = b"1.2.840.10046.2.1\0";
pub const szOID_X957: &[u8; 14] = b"1.2.840.10040\0";
pub const szOID_X957_DSA: &[u8; 18] = b"1.2.840.10040.4.1\0";
pub const szOID_X957_SHA1DSA: &[u8; 18] = b"1.2.840.10040.4.3\0";
pub const szOID_ECC_PUBLIC_KEY: &[u8; 18] = b"1.2.840.10045.2.1\0";
pub const szOID_ECC_CURVE_P256: &[u8; 20] = b"1.2.840.10045.3.1.7\0";
pub const szOID_ECC_CURVE_P384: &[u8; 13] = b"1.3.132.0.34\0";
pub const szOID_ECC_CURVE_P521: &[u8; 13] = b"1.3.132.0.35\0";
pub const szOID_ECC_CURVE_BRAINPOOLP160R1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.1\0";
pub const szOID_ECC_CURVE_BRAINPOOLP160T1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.2\0";
pub const szOID_ECC_CURVE_BRAINPOOLP192R1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.3\0";
pub const szOID_ECC_CURVE_BRAINPOOLP192T1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.4\0";
pub const szOID_ECC_CURVE_BRAINPOOLP224R1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.5\0";
pub const szOID_ECC_CURVE_BRAINPOOLP224T1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.6\0";
pub const szOID_ECC_CURVE_BRAINPOOLP256R1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.7\0";
pub const szOID_ECC_CURVE_BRAINPOOLP256T1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.8\0";
pub const szOID_ECC_CURVE_BRAINPOOLP320R1: &[u8; 21] = b"1.3.36.3.3.2.8.1.1.9\0";
pub const szOID_ECC_CURVE_BRAINPOOLP320T1: &[u8; 22] = b"1.3.36.3.3.2.8.1.1.10\0";
pub const szOID_ECC_CURVE_BRAINPOOLP384R1: &[u8; 22] = b"1.3.36.3.3.2.8.1.1.11\0";
pub const szOID_ECC_CURVE_BRAINPOOLP384T1: &[u8; 22] = b"1.3.36.3.3.2.8.1.1.12\0";
pub const szOID_ECC_CURVE_BRAINPOOLP512R1: &[u8; 22] = b"1.3.36.3.3.2.8.1.1.13\0";
pub const szOID_ECC_CURVE_BRAINPOOLP512T1: &[u8; 22] = b"1.3.36.3.3.2.8.1.1.14\0";
pub const szOID_ECC_CURVE_EC192WAPI: &[u8; 22] = b"1.2.156.11235.1.1.2.1\0";
pub const szOID_CN_ECDSA_SHA256: &[u8; 20] = b"1.2.156.11235.1.1.1\0";
pub const szOID_ECC_CURVE_NISTP192: &[u8; 20] = b"1.2.840.10045.3.1.1\0";
pub const szOID_ECC_CURVE_NISTP224: &[u8; 13] = b"1.3.132.0.33\0";
pub const szOID_ECC_CURVE_NISTP256: &[u8; 20] = b"1.2.840.10045.3.1.7\0";
pub const szOID_ECC_CURVE_NISTP384: &[u8; 13] = b"1.3.132.0.34\0";
pub const szOID_ECC_CURVE_NISTP521: &[u8; 13] = b"1.3.132.0.35\0";
pub const szOID_ECC_CURVE_SECP160K1: &[u8; 12] = b"1.3.132.0.9\0";
pub const szOID_ECC_CURVE_SECP160R1: &[u8; 12] = b"1.3.132.0.8\0";
pub const szOID_ECC_CURVE_SECP160R2: &[u8; 13] = b"1.3.132.0.30\0";
pub const szOID_ECC_CURVE_SECP192K1: &[u8; 13] = b"1.3.132.0.31\0";
pub const szOID_ECC_CURVE_SECP192R1: &[u8; 20] = b"1.2.840.10045.3.1.1\0";
pub const szOID_ECC_CURVE_SECP224K1: &[u8; 13] = b"1.3.132.0.32\0";
pub const szOID_ECC_CURVE_SECP224R1: &[u8; 13] = b"1.3.132.0.33\0";
pub const szOID_ECC_CURVE_SECP256K1: &[u8; 13] = b"1.3.132.0.10\0";
pub const szOID_ECC_CURVE_SECP256R1: &[u8; 20] = b"1.2.840.10045.3.1.7\0";
pub const szOID_ECC_CURVE_SECP384R1: &[u8; 13] = b"1.3.132.0.34\0";
pub const szOID_ECC_CURVE_SECP521R1: &[u8; 13] = b"1.3.132.0.35\0";
pub const szOID_ECC_CURVE_WTLS7: &[u8; 13] = b"1.3.132.0.30\0";
pub const szOID_ECC_CURVE_WTLS9: &[u8; 14] = b"2.23.43.1.4.9\0";
pub const szOID_ECC_CURVE_WTLS12: &[u8; 13] = b"1.3.132.0.33\0";
pub const szOID_ECC_CURVE_X962P192V1: &[u8; 20] = b"1.2.840.10045.3.1.1\0";
pub const szOID_ECC_CURVE_X962P192V2: &[u8; 20] = b"1.2.840.10045.3.1.2\0";
pub const szOID_ECC_CURVE_X962P192V3: &[u8; 20] = b"1.2.840.10045.3.1.3\0";
pub const szOID_ECC_CURVE_X962P239V1: &[u8; 20] = b"1.2.840.10045.3.1.4\0";
pub const szOID_ECC_CURVE_X962P239V2: &[u8; 20] = b"1.2.840.10045.3.1.5\0";
pub const szOID_ECC_CURVE_X962P239V3: &[u8; 20] = b"1.2.840.10045.3.1.6\0";
pub const szOID_ECC_CURVE_X962P256V1: &[u8; 20] = b"1.2.840.10045.3.1.7\0";
pub const szOID_ECDSA_SHA1: &[u8; 18] = b"1.2.840.10045.4.1\0";
pub const szOID_ECDSA_SPECIFIED: &[u8; 18] = b"1.2.840.10045.4.3\0";
pub const szOID_ECDSA_SHA256: &[u8; 20] = b"1.2.840.10045.4.3.2\0";
pub const szOID_ECDSA_SHA384: &[u8; 20] = b"1.2.840.10045.4.3.3\0";
pub const szOID_ECDSA_SHA512: &[u8; 20] = b"1.2.840.10045.4.3.4\0";
pub const szOID_NIST_AES128_CBC: &[u8; 23] = b"2.16.840.1.101.3.4.1.2\0";
pub const szOID_NIST_AES192_CBC: &[u8; 24] = b"2.16.840.1.101.3.4.1.22\0";
pub const szOID_NIST_AES256_CBC: &[u8; 24] = b"2.16.840.1.101.3.4.1.42\0";
pub const szOID_NIST_AES128_WRAP: &[u8; 23] = b"2.16.840.1.101.3.4.1.5\0";
pub const szOID_NIST_AES192_WRAP: &[u8; 24] = b"2.16.840.1.101.3.4.1.25\0";
pub const szOID_NIST_AES256_WRAP: &[u8; 24] = b"2.16.840.1.101.3.4.1.45\0";
pub const szOID_DH_SINGLE_PASS_STDDH_SHA1_KDF: &[u8; 22] = b"1.3.133.16.840.63.0.2\0";
pub const szOID_DH_SINGLE_PASS_STDDH_SHA256_KDF: &[u8; 15] = b"1.3.132.1.11.1\0";
pub const szOID_DH_SINGLE_PASS_STDDH_SHA384_KDF: &[u8; 15] = b"1.3.132.1.11.2\0";
pub const szOID_DS: &[u8; 4] = b"2.5\0";
pub const szOID_DSALG: &[u8; 6] = b"2.5.8\0";
pub const szOID_DSALG_CRPT: &[u8; 8] = b"2.5.8.1\0";
pub const szOID_DSALG_HASH: &[u8; 8] = b"2.5.8.2\0";
pub const szOID_DSALG_SIGN: &[u8; 8] = b"2.5.8.3\0";
pub const szOID_DSALG_RSA: &[u8; 10] = b"2.5.8.1.1\0";
pub const szOID_OIW: &[u8; 7] = b"1.3.14\0";
pub const szOID_OIWSEC: &[u8; 11] = b"1.3.14.3.2\0";
pub const szOID_OIWSEC_md4RSA: &[u8; 13] = b"1.3.14.3.2.2\0";
pub const szOID_OIWSEC_md5RSA: &[u8; 13] = b"1.3.14.3.2.3\0";
pub const szOID_OIWSEC_md4RSA2: &[u8; 13] = b"1.3.14.3.2.4\0";
pub const szOID_OIWSEC_desECB: &[u8; 13] = b"1.3.14.3.2.6\0";
pub const szOID_OIWSEC_desCBC: &[u8; 13] = b"1.3.14.3.2.7\0";
pub const szOID_OIWSEC_desOFB: &[u8; 13] = b"1.3.14.3.2.8\0";
pub const szOID_OIWSEC_desCFB: &[u8; 13] = b"1.3.14.3.2.9\0";
pub const szOID_OIWSEC_desMAC: &[u8; 14] = b"1.3.14.3.2.10\0";
pub const szOID_OIWSEC_rsaSign: &[u8; 14] = b"1.3.14.3.2.11\0";
pub const szOID_OIWSEC_dsa: &[u8; 14] = b"1.3.14.3.2.12\0";
pub const szOID_OIWSEC_shaDSA: &[u8; 14] = b"1.3.14.3.2.13\0";
pub const szOID_OIWSEC_mdc2RSA: &[u8; 14] = b"1.3.14.3.2.14\0";
pub const szOID_OIWSEC_shaRSA: &[u8; 14] = b"1.3.14.3.2.15\0";
pub const szOID_OIWSEC_dhCommMod: &[u8; 14] = b"1.3.14.3.2.16\0";
pub const szOID_OIWSEC_desEDE: &[u8; 14] = b"1.3.14.3.2.17\0";
pub const szOID_OIWSEC_sha: &[u8; 14] = b"1.3.14.3.2.18\0";
pub const szOID_OIWSEC_mdc2: &[u8; 14] = b"1.3.14.3.2.19\0";
pub const szOID_OIWSEC_dsaComm: &[u8; 14] = b"1.3.14.3.2.20\0";
pub const szOID_OIWSEC_dsaCommSHA: &[u8; 14] = b"1.3.14.3.2.21\0";
pub const szOID_OIWSEC_rsaXchg: &[u8; 14] = b"1.3.14.3.2.22\0";
pub const szOID_OIWSEC_keyHashSeal: &[u8; 14] = b"1.3.14.3.2.23\0";
pub const szOID_OIWSEC_md2RSASign: &[u8; 14] = b"1.3.14.3.2.24\0";
pub const szOID_OIWSEC_md5RSASign: &[u8; 14] = b"1.3.14.3.2.25\0";
pub const szOID_OIWSEC_sha1: &[u8; 14] = b"1.3.14.3.2.26\0";
pub const szOID_OIWSEC_dsaSHA1: &[u8; 14] = b"1.3.14.3.2.27\0";
pub const szOID_OIWSEC_dsaCommSHA1: &[u8; 14] = b"1.3.14.3.2.28\0";
pub const szOID_OIWSEC_sha1RSASign: &[u8; 14] = b"1.3.14.3.2.29\0";
pub const szOID_OIWDIR: &[u8; 11] = b"1.3.14.7.2\0";
pub const szOID_OIWDIR_CRPT: &[u8; 13] = b"1.3.14.7.2.1\0";
pub const szOID_OIWDIR_HASH: &[u8; 13] = b"1.3.14.7.2.2\0";
pub const szOID_OIWDIR_SIGN: &[u8; 13] = b"1.3.14.7.2.3\0";
pub const szOID_OIWDIR_md2: &[u8; 15] = b"1.3.14.7.2.2.1\0";
pub const szOID_OIWDIR_md2RSA: &[u8; 15] = b"1.3.14.7.2.3.1\0";
pub const szOID_INFOSEC: &[u8; 19] = b"2.16.840.1.101.2.1\0";
pub const szOID_INFOSEC_sdnsSignature: &[u8; 23] = b"2.16.840.1.101.2.1.1.1\0";
pub const szOID_INFOSEC_mosaicSignature: &[u8; 23] = b"2.16.840.1.101.2.1.1.2\0";
pub const szOID_INFOSEC_sdnsConfidentiality: &[u8; 23] = b"2.16.840.1.101.2.1.1.3\0";
pub const szOID_INFOSEC_mosaicConfidentiality: &[u8; 23] = b"2.16.840.1.101.2.1.1.4\0";
pub const szOID_INFOSEC_sdnsIntegrity: &[u8; 23] = b"2.16.840.1.101.2.1.1.5\0";
pub const szOID_INFOSEC_mosaicIntegrity: &[u8; 23] = b"2.16.840.1.101.2.1.1.6\0";
pub const szOID_INFOSEC_sdnsTokenProtection: &[u8; 23] = b"2.16.840.1.101.2.1.1.7\0";
pub const szOID_INFOSEC_mosaicTokenProtection: &[u8; 23] = b"2.16.840.1.101.2.1.1.8\0";
pub const szOID_INFOSEC_sdnsKeyManagement: &[u8; 23] = b"2.16.840.1.101.2.1.1.9\0";
pub const szOID_INFOSEC_mosaicKeyManagement: &[u8; 24] = b"2.16.840.1.101.2.1.1.10\0";
pub const szOID_INFOSEC_sdnsKMandSig: &[u8; 24] = b"2.16.840.1.101.2.1.1.11\0";
pub const szOID_INFOSEC_mosaicKMandSig: &[u8; 24] = b"2.16.840.1.101.2.1.1.12\0";
pub const szOID_INFOSEC_SuiteASignature: &[u8; 24] = b"2.16.840.1.101.2.1.1.13\0";
pub const szOID_INFOSEC_SuiteAConfidentiality: &[u8; 24] = b"2.16.840.1.101.2.1.1.14\0";
pub const szOID_INFOSEC_SuiteAIntegrity: &[u8; 24] = b"2.16.840.1.101.2.1.1.15\0";
pub const szOID_INFOSEC_SuiteATokenProtection: &[u8; 24] = b"2.16.840.1.101.2.1.1.16\0";
pub const szOID_INFOSEC_SuiteAKeyManagement: &[u8; 24] = b"2.16.840.1.101.2.1.1.17\0";
pub const szOID_INFOSEC_SuiteAKMandSig: &[u8; 24] = b"2.16.840.1.101.2.1.1.18\0";
pub const szOID_INFOSEC_mosaicUpdatedSig: &[u8; 24] = b"2.16.840.1.101.2.1.1.19\0";
pub const szOID_INFOSEC_mosaicKMandUpdSig: &[u8; 24] = b"2.16.840.1.101.2.1.1.20\0";
pub const szOID_INFOSEC_mosaicUpdatedInteg: &[u8; 24] = b"2.16.840.1.101.2.1.1.21\0";
pub const szOID_NIST_sha256: &[u8; 23] = b"2.16.840.1.101.3.4.2.1\0";
pub const szOID_NIST_sha384: &[u8; 23] = b"2.16.840.1.101.3.4.2.2\0";
pub const szOID_NIST_sha512: &[u8; 23] = b"2.16.840.1.101.3.4.2.3\0";
pub const szOID_COMMON_NAME: &[u8; 8] = b"2.5.4.3\0";
pub const szOID_SUR_NAME: &[u8; 8] = b"2.5.4.4\0";
pub const szOID_DEVICE_SERIAL_NUMBER: &[u8; 8] = b"2.5.4.5\0";
pub const szOID_COUNTRY_NAME: &[u8; 8] = b"2.5.4.6\0";
pub const szOID_LOCALITY_NAME: &[u8; 8] = b"2.5.4.7\0";
pub const szOID_STATE_OR_PROVINCE_NAME: &[u8; 8] = b"2.5.4.8\0";
pub const szOID_STREET_ADDRESS: &[u8; 8] = b"2.5.4.9\0";
pub const szOID_ORGANIZATION_NAME: &[u8; 9] = b"2.5.4.10\0";
pub const szOID_ORGANIZATIONAL_UNIT_NAME: &[u8; 9] = b"2.5.4.11\0";
pub const szOID_TITLE: &[u8; 9] = b"2.5.4.12\0";
pub const szOID_DESCRIPTION: &[u8; 9] = b"2.5.4.13\0";
pub const szOID_SEARCH_GUIDE: &[u8; 9] = b"2.5.4.14\0";
pub const szOID_BUSINESS_CATEGORY: &[u8; 9] = b"2.5.4.15\0";
pub const szOID_POSTAL_ADDRESS: &[u8; 9] = b"2.5.4.16\0";
pub const szOID_POSTAL_CODE: &[u8; 9] = b"2.5.4.17\0";
pub const szOID_POST_OFFICE_BOX: &[u8; 9] = b"2.5.4.18\0";
pub const szOID_PHYSICAL_DELIVERY_OFFICE_NAME: &[u8; 9] = b"2.5.4.19\0";
pub const szOID_TELEPHONE_NUMBER: &[u8; 9] = b"2.5.4.20\0";
pub const szOID_TELEX_NUMBER: &[u8; 9] = b"2.5.4.21\0";
pub const szOID_TELETEXT_TERMINAL_IDENTIFIER: &[u8; 9] = b"2.5.4.22\0";
pub const szOID_FACSIMILE_TELEPHONE_NUMBER: &[u8; 9] = b"2.5.4.23\0";
pub const szOID_X21_ADDRESS: &[u8; 9] = b"2.5.4.24\0";
pub const szOID_INTERNATIONAL_ISDN_NUMBER: &[u8; 9] = b"2.5.4.25\0";
pub const szOID_REGISTERED_ADDRESS: &[u8; 9] = b"2.5.4.26\0";
pub const szOID_DESTINATION_INDICATOR: &[u8; 9] = b"2.5.4.27\0";
pub const szOID_PREFERRED_DELIVERY_METHOD: &[u8; 9] = b"2.5.4.28\0";
pub const szOID_PRESENTATION_ADDRESS: &[u8; 9] = b"2.5.4.29\0";
pub const szOID_SUPPORTED_APPLICATION_CONTEXT: &[u8; 9] = b"2.5.4.30\0";
pub const szOID_MEMBER: &[u8; 9] = b"2.5.4.31\0";
pub const szOID_OWNER: &[u8; 9] = b"2.5.4.32\0";
pub const szOID_ROLE_OCCUPANT: &[u8; 9] = b"2.5.4.33\0";
pub const szOID_SEE_ALSO: &[u8; 9] = b"2.5.4.34\0";
pub const szOID_USER_PASSWORD: &[u8; 9] = b"2.5.4.35\0";
pub const szOID_USER_CERTIFICATE: &[u8; 9] = b"2.5.4.36\0";
pub const szOID_CA_CERTIFICATE: &[u8; 9] = b"2.5.4.37\0";
pub const szOID_AUTHORITY_REVOCATION_LIST: &[u8; 9] = b"2.5.4.38\0";
pub const szOID_CERTIFICATE_REVOCATION_LIST: &[u8; 9] = b"2.5.4.39\0";
pub const szOID_CROSS_CERTIFICATE_PAIR: &[u8; 9] = b"2.5.4.40\0";
pub const szOID_GIVEN_NAME: &[u8; 9] = b"2.5.4.42\0";
pub const szOID_INITIALS: &[u8; 9] = b"2.5.4.43\0";
pub const szOID_DN_QUALIFIER: &[u8; 9] = b"2.5.4.46\0";
pub const szOID_DOMAIN_COMPONENT: &[u8; 27] = b"0.9.2342.19200300.100.1.25\0";
pub const szOID_PKCS_12_FRIENDLY_NAME_ATTR: &[u8; 22] = b"1.2.840.113549.1.9.20\0";
pub const szOID_PKCS_12_LOCAL_KEY_ID: &[u8; 22] = b"1.2.840.113549.1.9.21\0";
pub const szOID_PKCS_12_KEY_PROVIDER_NAME_ATTR: &[u8; 21] = b"1.3.6.1.4.1.311.17.1\0";
pub const szOID_LOCAL_MACHINE_KEYSET: &[u8; 21] = b"1.3.6.1.4.1.311.17.2\0";
pub const szOID_PKCS_12_EXTENDED_ATTRIBUTES: &[u8; 21] = b"1.3.6.1.4.1.311.17.3\0";
pub const szOID_PKCS_12_PROTECTED_PASSWORD_SECRET_BAG_TYPE_ID: &[u8; 21] =
    b"1.3.6.1.4.1.311.17.4\0";
pub const szOID_KEYID_RDN: &[u8; 23] = b"1.3.6.1.4.1.311.10.7.1\0";
pub const szOID_EV_RDN_LOCALE: &[u8; 25] = b"1.3.6.1.4.1.311.60.2.1.1\0";
pub const szOID_EV_RDN_STATE_OR_PROVINCE: &[u8; 25] = b"1.3.6.1.4.1.311.60.2.1.2\0";
pub const szOID_EV_RDN_COUNTRY: &[u8; 25] = b"1.3.6.1.4.1.311.60.2.1.3\0";
pub const CERT_RDN_ANY_TYPE: u32 = 0;
pub const CERT_RDN_ENCODED_BLOB: u32 = 1;
pub const CERT_RDN_OCTET_STRING: u32 = 2;
pub const CERT_RDN_NUMERIC_STRING: u32 = 3;
pub const CERT_RDN_PRINTABLE_STRING: u32 = 4;
pub const CERT_RDN_TELETEX_STRING: u32 = 5;
pub const CERT_RDN_T61_STRING: u32 = 5;
pub const CERT_RDN_VIDEOTEX_STRING: u32 = 6;
pub const CERT_RDN_IA5_STRING: u32 = 7;
pub const CERT_RDN_GRAPHIC_STRING: u32 = 8;
pub const CERT_RDN_VISIBLE_STRING: u32 = 9;
pub const CERT_RDN_ISO646_STRING: u32 = 9;
pub const CERT_RDN_GENERAL_STRING: u32 = 10;
pub const CERT_RDN_UNIVERSAL_STRING: u32 = 11;
pub const CERT_RDN_INT4_STRING: u32 = 11;
pub const CERT_RDN_BMP_STRING: u32 = 12;
pub const CERT_RDN_UNICODE_STRING: u32 = 12;
pub const CERT_RDN_UTF8_STRING: u32 = 13;
pub const CERT_RDN_TYPE_MASK: u32 = 255;
pub const CERT_RDN_FLAGS_MASK: u32 = 4278190080;
pub const CERT_RDN_ENABLE_T61_UNICODE_FLAG: u32 = 2147483648;
pub const CERT_RDN_ENABLE_UTF8_UNICODE_FLAG: u32 = 536870912;
pub const CERT_RDN_FORCE_UTF8_UNICODE_FLAG: u32 = 268435456;
pub const CERT_RDN_DISABLE_CHECK_TYPE_FLAG: u32 = 1073741824;
pub const CERT_RDN_DISABLE_IE4_UTF8_FLAG: u32 = 16777216;
pub const CERT_RDN_ENABLE_PUNYCODE_FLAG: u32 = 33554432;
pub const CERT_RSA_PUBLIC_KEY_OBJID: &[u8; 21] = b"1.2.840.113549.1.1.1\0";
pub const CERT_DEFAULT_OID_PUBLIC_KEY_SIGN: &[u8; 21] = b"1.2.840.113549.1.1.1\0";
pub const CERT_DEFAULT_OID_PUBLIC_KEY_XCHG: &[u8; 21] = b"1.2.840.113549.1.1.1\0";
pub const CRYPT_ECC_PRIVATE_KEY_INFO_v1: u32 = 1;
pub const CERT_V1: u32 = 0;
pub const CERT_V2: u32 = 1;
pub const CERT_V3: u32 = 2;
pub const CERT_INFO_VERSION_FLAG: u32 = 1;
pub const CERT_INFO_SERIAL_NUMBER_FLAG: u32 = 2;
pub const CERT_INFO_SIGNATURE_ALGORITHM_FLAG: u32 = 3;
pub const CERT_INFO_ISSUER_FLAG: u32 = 4;
pub const CERT_INFO_NOT_BEFORE_FLAG: u32 = 5;
pub const CERT_INFO_NOT_AFTER_FLAG: u32 = 6;
pub const CERT_INFO_SUBJECT_FLAG: u32 = 7;
pub const CERT_INFO_SUBJECT_PUBLIC_KEY_INFO_FLAG: u32 = 8;
pub const CERT_INFO_ISSUER_UNIQUE_ID_FLAG: u32 = 9;
pub const CERT_INFO_SUBJECT_UNIQUE_ID_FLAG: u32 = 10;
pub const CERT_INFO_EXTENSION_FLAG: u32 = 11;
pub const CRL_V1: u32 = 0;
pub const CRL_V2: u32 = 1;
pub const CERT_BUNDLE_CERTIFICATE: u32 = 0;
pub const CERT_BUNDLE_CRL: u32 = 1;
pub const CERT_REQUEST_V1: u32 = 0;
pub const CERT_KEYGEN_REQUEST_V1: u32 = 0;
pub const CTL_V1: u32 = 0;
pub const CERT_ENCODING_TYPE_MASK: u32 = 65535;
pub const CMSG_ENCODING_TYPE_MASK: u32 = 4294901760;
pub const CRYPT_ASN_ENCODING: u32 = 1;
pub const CRYPT_NDR_ENCODING: u32 = 2;
pub const X509_ASN_ENCODING: u32 = 1;
pub const X509_NDR_ENCODING: u32 = 2;
pub const PKCS_7_ASN_ENCODING: u32 = 65536;
pub const PKCS_7_NDR_ENCODING: u32 = 131072;
pub const CRYPT_FORMAT_STR_MULTI_LINE: u32 = 1;
pub const CRYPT_FORMAT_STR_NO_HEX: u32 = 16;
pub const CRYPT_FORMAT_SIMPLE: u32 = 1;
pub const CRYPT_FORMAT_X509: u32 = 2;
pub const CRYPT_FORMAT_OID: u32 = 4;
pub const CRYPT_FORMAT_RDN_SEMICOLON: u32 = 256;
pub const CRYPT_FORMAT_RDN_CRLF: u32 = 512;
pub const CRYPT_FORMAT_RDN_UNQUOTE: u32 = 1024;
pub const CRYPT_FORMAT_RDN_REVERSE: u32 = 2048;
pub const CRYPT_FORMAT_COMMA: u32 = 4096;
pub const CRYPT_FORMAT_SEMICOLON: u32 = 256;
pub const CRYPT_FORMAT_CRLF: u32 = 512;
pub const CRYPT_ENCODE_NO_SIGNATURE_BYTE_REVERSAL_FLAG: u32 = 8;
pub const CRYPT_ENCODE_ALLOC_FLAG: u32 = 32768;
pub const CRYPT_UNICODE_NAME_ENCODE_ENABLE_T61_UNICODE_FLAG: u32 = 2147483648;
pub const CRYPT_UNICODE_NAME_ENCODE_ENABLE_UTF8_UNICODE_FLAG: u32 = 536870912;
pub const CRYPT_UNICODE_NAME_ENCODE_FORCE_UTF8_UNICODE_FLAG: u32 = 268435456;
pub const CRYPT_UNICODE_NAME_ENCODE_DISABLE_CHECK_TYPE_FLAG: u32 = 1073741824;
pub const CRYPT_SORTED_CTL_ENCODE_HASHED_SUBJECT_IDENTIFIER_FLAG: u32 = 65536;
pub const CRYPT_ENCODE_ENABLE_PUNYCODE_FLAG: u32 = 131072;
pub const CRYPT_ENCODE_ENABLE_UTF8PERCENT_FLAG: u32 = 262144;
pub const CRYPT_ENCODE_ENABLE_IA5CONVERSION_FLAG: u32 = 393216;
pub const CRYPT_DECODE_NOCOPY_FLAG: u32 = 1;
pub const CRYPT_DECODE_TO_BE_SIGNED_FLAG: u32 = 2;
pub const CRYPT_DECODE_SHARE_OID_STRING_FLAG: u32 = 4;
pub const CRYPT_DECODE_NO_SIGNATURE_BYTE_REVERSAL_FLAG: u32 = 8;
pub const CRYPT_DECODE_ALLOC_FLAG: u32 = 32768;
pub const CRYPT_UNICODE_NAME_DECODE_DISABLE_IE4_UTF8_FLAG: u32 = 16777216;
pub const CRYPT_DECODE_ENABLE_PUNYCODE_FLAG: u32 = 33554432;
pub const CRYPT_DECODE_ENABLE_UTF8PERCENT_FLAG: u32 = 67108864;
pub const CRYPT_DECODE_ENABLE_IA5CONVERSION_FLAG: u32 = 100663296;
pub const CRYPT_ENCODE_DECODE_NONE: u32 = 0;
pub const szOID_AUTHORITY_KEY_IDENTIFIER: &[u8; 9] = b"2.5.29.1\0";
pub const szOID_KEY_ATTRIBUTES: &[u8; 9] = b"2.5.29.2\0";
pub const szOID_CERT_POLICIES_95: &[u8; 9] = b"2.5.29.3\0";
pub const szOID_KEY_USAGE_RESTRICTION: &[u8; 9] = b"2.5.29.4\0";
pub const szOID_SUBJECT_ALT_NAME: &[u8; 9] = b"2.5.29.7\0";
pub const szOID_ISSUER_ALT_NAME: &[u8; 9] = b"2.5.29.8\0";
pub const szOID_BASIC_CONSTRAINTS: &[u8; 10] = b"2.5.29.10\0";
pub const szOID_KEY_USAGE: &[u8; 10] = b"2.5.29.15\0";
pub const szOID_PRIVATEKEY_USAGE_PERIOD: &[u8; 10] = b"2.5.29.16\0";
pub const szOID_BASIC_CONSTRAINTS2: &[u8; 10] = b"2.5.29.19\0";
pub const szOID_CERT_POLICIES: &[u8; 10] = b"2.5.29.32\0";
pub const szOID_ANY_CERT_POLICY: &[u8; 12] = b"2.5.29.32.0\0";
pub const szOID_INHIBIT_ANY_POLICY: &[u8; 10] = b"2.5.29.54\0";
pub const szOID_AUTHORITY_KEY_IDENTIFIER2: &[u8; 10] = b"2.5.29.35\0";
pub const szOID_SUBJECT_KEY_IDENTIFIER: &[u8; 10] = b"2.5.29.14\0";
pub const szOID_SUBJECT_ALT_NAME2: &[u8; 10] = b"2.5.29.17\0";
pub const szOID_ISSUER_ALT_NAME2: &[u8; 10] = b"2.5.29.18\0";
pub const szOID_CRL_REASON_CODE: &[u8; 10] = b"2.5.29.21\0";
pub const szOID_REASON_CODE_HOLD: &[u8; 10] = b"2.5.29.23\0";
pub const szOID_CRL_DIST_POINTS: &[u8; 10] = b"2.5.29.31\0";
pub const szOID_ENHANCED_KEY_USAGE: &[u8; 10] = b"2.5.29.37\0";
pub const szOID_ANY_ENHANCED_KEY_USAGE: &[u8; 12] = b"2.5.29.37.0\0";
pub const szOID_CRL_NUMBER: &[u8; 10] = b"2.5.29.20\0";
pub const szOID_DELTA_CRL_INDICATOR: &[u8; 10] = b"2.5.29.27\0";
pub const szOID_ISSUING_DIST_POINT: &[u8; 10] = b"2.5.29.28\0";
pub const szOID_FRESHEST_CRL: &[u8; 10] = b"2.5.29.46\0";
pub const szOID_NAME_CONSTRAINTS: &[u8; 10] = b"2.5.29.30\0";
pub const szOID_POLICY_MAPPINGS: &[u8; 10] = b"2.5.29.33\0";
pub const szOID_LEGACY_POLICY_MAPPINGS: &[u8; 9] = b"2.5.29.5\0";
pub const szOID_POLICY_CONSTRAINTS: &[u8; 10] = b"2.5.29.36\0";
pub const szOID_RENEWAL_CERTIFICATE: &[u8; 21] = b"1.3.6.1.4.1.311.13.1\0";
pub const szOID_ENROLLMENT_NAME_VALUE_PAIR: &[u8; 23] = b"1.3.6.1.4.1.311.13.2.1\0";
pub const szOID_ENROLLMENT_CSP_PROVIDER: &[u8; 23] = b"1.3.6.1.4.1.311.13.2.2\0";
pub const szOID_OS_VERSION: &[u8; 23] = b"1.3.6.1.4.1.311.13.2.3\0";
pub const szOID_ENROLLMENT_AGENT: &[u8; 23] = b"1.3.6.1.4.1.311.20.2.1\0";
pub const szOID_PKIX: &[u8; 14] = b"1.3.6.1.5.5.7\0";
pub const szOID_PKIX_PE: &[u8; 16] = b"1.3.6.1.5.5.7.1\0";
pub const szOID_AUTHORITY_INFO_ACCESS: &[u8; 18] = b"1.3.6.1.5.5.7.1.1\0";
pub const szOID_SUBJECT_INFO_ACCESS: &[u8; 19] = b"1.3.6.1.5.5.7.1.11\0";
pub const szOID_BIOMETRIC_EXT: &[u8; 18] = b"1.3.6.1.5.5.7.1.2\0";
pub const szOID_QC_STATEMENTS_EXT: &[u8; 18] = b"1.3.6.1.5.5.7.1.3\0";
pub const szOID_LOGOTYPE_EXT: &[u8; 19] = b"1.3.6.1.5.5.7.1.12\0";
pub const szOID_TLS_FEATURES_EXT: &[u8; 19] = b"1.3.6.1.5.5.7.1.24\0";
pub const szOID_CERT_EXTENSIONS: &[u8; 23] = b"1.3.6.1.4.1.311.2.1.14\0";
pub const szOID_NEXT_UPDATE_LOCATION: &[u8; 21] = b"1.3.6.1.4.1.311.10.2\0";
pub const szOID_REMOVE_CERTIFICATE: &[u8; 23] = b"1.3.6.1.4.1.311.10.8.1\0";
pub const szOID_CROSS_CERT_DIST_POINTS: &[u8; 23] = b"1.3.6.1.4.1.311.10.9.1\0";
pub const szOID_CTL: &[u8; 21] = b"1.3.6.1.4.1.311.10.1\0";
pub const szOID_SORTED_CTL: &[u8; 23] = b"1.3.6.1.4.1.311.10.1.1\0";
pub const szOID_SERIALIZED: &[u8; 25] = b"1.3.6.1.4.1.311.10.3.3.1\0";
pub const szOID_NT_PRINCIPAL_NAME: &[u8; 23] = b"1.3.6.1.4.1.311.20.2.3\0";
pub const szOID_INTERNATIONALIZED_EMAIL_ADDRESS: &[u8; 23] = b"1.3.6.1.4.1.311.20.2.4\0";
pub const szOID_PRODUCT_UPDATE: &[u8; 21] = b"1.3.6.1.4.1.311.31.1\0";
pub const szOID_ANY_APPLICATION_POLICY: &[u8; 24] = b"1.3.6.1.4.1.311.10.12.1\0";
pub const szOID_AUTO_ENROLL_CTL_USAGE: &[u8; 21] = b"1.3.6.1.4.1.311.20.1\0";
pub const szOID_ENROLL_CERTTYPE_EXTENSION: &[u8; 21] = b"1.3.6.1.4.1.311.20.2\0";
pub const szOID_CERT_MANIFOLD: &[u8; 21] = b"1.3.6.1.4.1.311.20.3\0";
pub const szOID_CERTSRV_CA_VERSION: &[u8; 21] = b"1.3.6.1.4.1.311.21.1\0";
pub const szOID_CERTSRV_PREVIOUS_CERT_HASH: &[u8; 21] = b"1.3.6.1.4.1.311.21.2\0";
pub const szOID_CRL_VIRTUAL_BASE: &[u8; 21] = b"1.3.6.1.4.1.311.21.3\0";
pub const szOID_CRL_NEXT_PUBLISH: &[u8; 21] = b"1.3.6.1.4.1.311.21.4\0";
pub const szOID_KP_CA_EXCHANGE: &[u8; 21] = b"1.3.6.1.4.1.311.21.5\0";
pub const szOID_KP_PRIVACY_CA: &[u8; 22] = b"1.3.6.1.4.1.311.21.36\0";
pub const szOID_KP_KEY_RECOVERY_AGENT: &[u8; 21] = b"1.3.6.1.4.1.311.21.6\0";
pub const szOID_CERTIFICATE_TEMPLATE: &[u8; 21] = b"1.3.6.1.4.1.311.21.7\0";
pub const szOID_ENTERPRISE_OID_ROOT: &[u8; 21] = b"1.3.6.1.4.1.311.21.8\0";
pub const szOID_RDN_DUMMY_SIGNER: &[u8; 21] = b"1.3.6.1.4.1.311.21.9\0";
pub const szOID_APPLICATION_CERT_POLICIES: &[u8; 22] = b"1.3.6.1.4.1.311.21.10\0";
pub const szOID_APPLICATION_POLICY_MAPPINGS: &[u8; 22] = b"1.3.6.1.4.1.311.21.11\0";
pub const szOID_APPLICATION_POLICY_CONSTRAINTS: &[u8; 22] = b"1.3.6.1.4.1.311.21.12\0";
pub const szOID_ARCHIVED_KEY_ATTR: &[u8; 22] = b"1.3.6.1.4.1.311.21.13\0";
pub const szOID_CRL_SELF_CDP: &[u8; 22] = b"1.3.6.1.4.1.311.21.14\0";
pub const szOID_REQUIRE_CERT_CHAIN_POLICY: &[u8; 22] = b"1.3.6.1.4.1.311.21.15\0";
pub const szOID_ARCHIVED_KEY_CERT_HASH: &[u8; 22] = b"1.3.6.1.4.1.311.21.16\0";
pub const szOID_ISSUED_CERT_HASH: &[u8; 22] = b"1.3.6.1.4.1.311.21.17\0";
pub const szOID_DS_EMAIL_REPLICATION: &[u8; 22] = b"1.3.6.1.4.1.311.21.19\0";
pub const szOID_REQUEST_CLIENT_INFO: &[u8; 22] = b"1.3.6.1.4.1.311.21.20\0";
pub const szOID_ENCRYPTED_KEY_HASH: &[u8; 22] = b"1.3.6.1.4.1.311.21.21\0";
pub const szOID_CERTSRV_CROSSCA_VERSION: &[u8; 22] = b"1.3.6.1.4.1.311.21.22\0";
pub const szOID_NTDS_REPLICATION: &[u8; 21] = b"1.3.6.1.4.1.311.25.1\0";
pub const szOID_NTDS_CA_SECURITY_EXT: &[u8; 21] = b"1.3.6.1.4.1.311.25.2\0";
pub const szOID_NTDS_OBJECTSID: &[u8; 23] = b"1.3.6.1.4.1.311.25.2.1\0";
pub const szOID_SUBJECT_DIR_ATTRS: &[u8; 9] = b"2.5.29.9\0";
pub const szOID_PKIX_KP: &[u8; 16] = b"1.3.6.1.5.5.7.3\0";
pub const szOID_PKIX_KP_SERVER_AUTH: &[u8; 18] = b"1.3.6.1.5.5.7.3.1\0";
pub const szOID_PKIX_KP_CLIENT_AUTH: &[u8; 18] = b"1.3.6.1.5.5.7.3.2\0";
pub const szOID_PKIX_KP_CODE_SIGNING: &[u8; 18] = b"1.3.6.1.5.5.7.3.3\0";
pub const szOID_PKIX_KP_EMAIL_PROTECTION: &[u8; 18] = b"1.3.6.1.5.5.7.3.4\0";
pub const szOID_PKIX_KP_IPSEC_END_SYSTEM: &[u8; 18] = b"1.3.6.1.5.5.7.3.5\0";
pub const szOID_PKIX_KP_IPSEC_TUNNEL: &[u8; 18] = b"1.3.6.1.5.5.7.3.6\0";
pub const szOID_PKIX_KP_IPSEC_USER: &[u8; 18] = b"1.3.6.1.5.5.7.3.7\0";
pub const szOID_PKIX_KP_TIMESTAMP_SIGNING: &[u8; 18] = b"1.3.6.1.5.5.7.3.8\0";
pub const szOID_PKIX_KP_OCSP_SIGNING: &[u8; 18] = b"1.3.6.1.5.5.7.3.9\0";
pub const szOID_PKIX_OCSP_NOCHECK: &[u8; 21] = b"1.3.6.1.5.5.7.48.1.5\0";
pub const szOID_PKIX_OCSP_NONCE: &[u8; 21] = b"1.3.6.1.5.5.7.48.1.2\0";
pub const szOID_IPSEC_KP_IKE_INTERMEDIATE: &[u8; 18] = b"1.3.6.1.5.5.8.2.2\0";
pub const szOID_PKINIT_KP_KDC: &[u8; 16] = b"1.3.6.1.5.2.3.5\0";
pub const szOID_KP_CTL_USAGE_SIGNING: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.1\0";
pub const szOID_KP_TIME_STAMP_SIGNING: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.2\0";
pub const szOID_SERVER_GATED_CRYPTO: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.3\0";
pub const szOID_SGC_NETSCAPE: &[u8; 22] = b"2.16.840.1.113730.4.1\0";
pub const szOID_KP_EFS: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.4\0";
pub const szOID_EFS_RECOVERY: &[u8; 25] = b"1.3.6.1.4.1.311.10.3.4.1\0";
pub const szOID_WHQL_CRYPTO: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.5\0";
pub const szOID_ATTEST_WHQL_CRYPTO: &[u8; 25] = b"1.3.6.1.4.1.311.10.3.5.1\0";
pub const szOID_NT5_CRYPTO: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.6\0";
pub const szOID_OEM_WHQL_CRYPTO: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.7\0";
pub const szOID_EMBEDDED_NT_CRYPTO: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.8\0";
pub const szOID_ROOT_LIST_SIGNER: &[u8; 23] = b"1.3.6.1.4.1.311.10.3.9\0";
pub const szOID_KP_QUALIFIED_SUBORDINATION: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.10\0";
pub const szOID_KP_KEY_RECOVERY: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.11\0";
pub const szOID_KP_DOCUMENT_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.12\0";
pub const szOID_KP_LIFETIME_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.13\0";
pub const szOID_KP_MOBILE_DEVICE_SOFTWARE: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.14\0";
pub const szOID_KP_SMART_DISPLAY: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.15\0";
pub const szOID_KP_CSP_SIGNATURE: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.16\0";
pub const szOID_KP_FLIGHT_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.27\0";
pub const szOID_PLATFORM_MANIFEST_BINARY_ID: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.28\0";
pub const szOID_DRM: &[u8; 23] = b"1.3.6.1.4.1.311.10.5.1\0";
pub const szOID_DRM_INDIVIDUALIZATION: &[u8; 23] = b"1.3.6.1.4.1.311.10.5.2\0";
pub const szOID_LICENSES: &[u8; 23] = b"1.3.6.1.4.1.311.10.6.1\0";
pub const szOID_LICENSE_SERVER: &[u8; 23] = b"1.3.6.1.4.1.311.10.6.2\0";
pub const szOID_KP_SMARTCARD_LOGON: &[u8; 23] = b"1.3.6.1.4.1.311.20.2.2\0";
pub const szOID_KP_KERNEL_MODE_CODE_SIGNING: &[u8; 23] = b"1.3.6.1.4.1.311.61.1.1\0";
pub const szOID_KP_KERNEL_MODE_TRUSTED_BOOT_SIGNING: &[u8; 23] = b"1.3.6.1.4.1.311.61.4.1\0";
pub const szOID_REVOKED_LIST_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.19\0";
pub const szOID_WINDOWS_KITS_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.20\0";
pub const szOID_WINDOWS_RT_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.21\0";
pub const szOID_PROTECTED_PROCESS_LIGHT_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.22\0";
pub const szOID_WINDOWS_TCB_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.23\0";
pub const szOID_PROTECTED_PROCESS_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.24\0";
pub const szOID_WINDOWS_THIRD_PARTY_COMPONENT_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.25\0";
pub const szOID_WINDOWS_SOFTWARE_EXTENSION_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.26\0";
pub const szOID_DISALLOWED_LIST: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.30\0";
pub const szOID_PIN_RULES_SIGNER: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.31\0";
pub const szOID_PIN_RULES_CTL: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.32\0";
pub const szOID_PIN_RULES_EXT: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.33\0";
pub const szOID_PIN_RULES_DOMAIN_NAME: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.34\0";
pub const szOID_PIN_RULES_LOG_END_DATE_EXT: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.35\0";
pub const szOID_IUM_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.37\0";
pub const szOID_EV_WHQL_CRYPTO: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.39\0";
pub const szOID_BIOMETRIC_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.41\0";
pub const szOID_ENCLAVE_SIGNING: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.42\0";
pub const szOID_SYNC_ROOT_CTL_EXT: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.50\0";
pub const szOID_HPKP_DOMAIN_NAME_CTL: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.60\0";
pub const szOID_HPKP_HEADER_VALUE_CTL: &[u8; 24] = b"1.3.6.1.4.1.311.10.3.61\0";
pub const szOID_KP_KERNEL_MODE_HAL_EXTENSION_SIGNING: &[u8; 23] = b"1.3.6.1.4.1.311.61.5.1\0";
pub const szOID_WINDOWS_STORE_SIGNER: &[u8; 23] = b"1.3.6.1.4.1.311.76.3.1\0";
pub const szOID_DYNAMIC_CODE_GEN_SIGNER: &[u8; 23] = b"1.3.6.1.4.1.311.76.5.1\0";
pub const szOID_MICROSOFT_PUBLISHER_SIGNER: &[u8; 23] = b"1.3.6.1.4.1.311.76.8.1\0";
pub const szOID_YESNO_TRUST_ATTR: &[u8; 23] = b"1.3.6.1.4.1.311.10.4.1\0";
pub const szOID_SITE_PIN_RULES_INDEX_ATTR: &[u8; 23] = b"1.3.6.1.4.1.311.10.4.2\0";
pub const szOID_SITE_PIN_RULES_FLAGS_ATTR: &[u8; 23] = b"1.3.6.1.4.1.311.10.4.3\0";
pub const SITE_PIN_RULES_ALL_SUBDOMAINS_FLAG: u32 = 1;
pub const szOID_PKIX_POLICY_QUALIFIER_CPS: &[u8; 18] = b"1.3.6.1.5.5.7.2.1\0";
pub const szOID_PKIX_POLICY_QUALIFIER_USERNOTICE: &[u8; 18] = b"1.3.6.1.5.5.7.2.2\0";
pub const szOID_ROOT_PROGRAM_FLAGS: &[u8; 23] = b"1.3.6.1.4.1.311.60.1.1\0";
pub const CERT_ROOT_PROGRAM_FLAG_ORG: u32 = 128;
pub const CERT_ROOT_PROGRAM_FLAG_LSC: u32 = 64;
pub const CERT_ROOT_PROGRAM_FLAG_SUBJECT_LOGO: u32 = 32;
pub const CERT_ROOT_PROGRAM_FLAG_OU: u32 = 16;
pub const CERT_ROOT_PROGRAM_FLAG_ADDRESS: u32 = 8;
pub const szOID_CERT_POLICIES_95_QUALIFIER1: &[u8; 26] = b"2.16.840.1.113733.1.7.1.1\0";
pub const szOID_RDN_TPM_MANUFACTURER: &[u8; 13] = b"2.23.133.2.1\0";
pub const szOID_RDN_TPM_MODEL: &[u8; 13] = b"2.23.133.2.2\0";
pub const szOID_RDN_TPM_VERSION: &[u8; 13] = b"2.23.133.2.3\0";
pub const szOID_RDN_TCG_PLATFORM_MANUFACTURER: &[u8; 13] = b"2.23.133.2.4\0";
pub const szOID_RDN_TCG_PLATFORM_MODEL: &[u8; 13] = b"2.23.133.2.5\0";
pub const szOID_RDN_TCG_PLATFORM_VERSION: &[u8; 13] = b"2.23.133.2.6\0";
pub const szOID_CT_CERT_SCTLIST: &[u8; 24] = b"1.3.6.1.4.1.11129.2.4.2\0";
pub const szOID_ENROLL_EK_INFO: &[u8; 22] = b"1.3.6.1.4.1.311.21.23\0";
pub const szOID_ENROLL_AIK_INFO: &[u8; 22] = b"1.3.6.1.4.1.311.21.39\0";
pub const szOID_ENROLL_ATTESTATION_STATEMENT: &[u8; 22] = b"1.3.6.1.4.1.311.21.24\0";
pub const szOID_ENROLL_KSP_NAME: &[u8; 22] = b"1.3.6.1.4.1.311.21.25\0";
pub const szOID_ENROLL_EKPUB_CHALLENGE: &[u8; 22] = b"1.3.6.1.4.1.311.21.26\0";
pub const szOID_ENROLL_CAXCHGCERT_HASH: &[u8; 22] = b"1.3.6.1.4.1.311.21.27\0";
pub const szOID_ENROLL_ATTESTATION_CHALLENGE: &[u8; 22] = b"1.3.6.1.4.1.311.21.28\0";
pub const szOID_ENROLL_ENCRYPTION_ALGORITHM: &[u8; 22] = b"1.3.6.1.4.1.311.21.29\0";
pub const szOID_KP_TPM_EK_CERTIFICATE: &[u8; 13] = b"2.23.133.8.1\0";
pub const szOID_KP_TPM_PLATFORM_CERTIFICATE: &[u8; 13] = b"2.23.133.8.2\0";
pub const szOID_KP_TPM_AIK_CERTIFICATE: &[u8; 13] = b"2.23.133.8.3\0";
pub const szOID_ENROLL_EKVERIFYKEY: &[u8; 22] = b"1.3.6.1.4.1.311.21.30\0";
pub const szOID_ENROLL_EKVERIFYCERT: &[u8; 22] = b"1.3.6.1.4.1.311.21.31\0";
pub const szOID_ENROLL_EKVERIFYCREDS: &[u8; 22] = b"1.3.6.1.4.1.311.21.32\0";
pub const szOID_ENROLL_SCEP_ERROR: &[u8; 22] = b"1.3.6.1.4.1.311.21.33\0";
pub const szOID_ENROLL_SCEP_SERVER_STATE: &[u8; 22] = b"1.3.6.1.4.1.311.21.34\0";
pub const szOID_ENROLL_SCEP_CHALLENGE_ANSWER: &[u8; 22] = b"1.3.6.1.4.1.311.21.35\0";
pub const szOID_ENROLL_SCEP_CLIENT_REQUEST: &[u8; 22] = b"1.3.6.1.4.1.311.21.37\0";
pub const szOID_ENROLL_SCEP_SERVER_MESSAGE: &[u8; 22] = b"1.3.6.1.4.1.311.21.38\0";
pub const szOID_ENROLL_SCEP_SERVER_SECRET: &[u8; 22] = b"1.3.6.1.4.1.311.21.40\0";
pub const szOID_ENROLL_KEY_AFFINITY: &[u8; 22] = b"1.3.6.1.4.1.311.21.41\0";
pub const szOID_ENROLL_SCEP_SIGNER_HASH: &[u8; 22] = b"1.3.6.1.4.1.311.21.42\0";
pub const szOID_ENROLL_EK_CA_KEYID: &[u8; 22] = b"1.3.6.1.4.1.311.21.43\0";
pub const szOID_ATTR_SUPPORTED_ALGORITHMS: &[u8; 9] = b"2.5.4.52\0";
pub const szOID_ATTR_TPM_SPECIFICATION: &[u8; 14] = b"2.23.133.2.16\0";
pub const szOID_ATTR_PLATFORM_SPECIFICATION: &[u8; 14] = b"2.23.133.2.17\0";
pub const szOID_ATTR_TPM_SECURITY_ASSERTIONS: &[u8; 14] = b"2.23.133.2.18\0";
pub const CERT_UNICODE_RDN_ERR_INDEX_MASK: u32 = 1023;
pub const CERT_UNICODE_RDN_ERR_INDEX_SHIFT: u32 = 22;
pub const CERT_UNICODE_ATTR_ERR_INDEX_MASK: u32 = 63;
pub const CERT_UNICODE_ATTR_ERR_INDEX_SHIFT: u32 = 16;
pub const CERT_UNICODE_VALUE_ERR_INDEX_MASK: u32 = 65535;
pub const CERT_UNICODE_VALUE_ERR_INDEX_SHIFT: u32 = 0;
pub const CERT_DIGITAL_SIGNATURE_KEY_USAGE: u32 = 128;
pub const CERT_NON_REPUDIATION_KEY_USAGE: u32 = 64;
pub const CERT_KEY_ENCIPHERMENT_KEY_USAGE: u32 = 32;
pub const CERT_DATA_ENCIPHERMENT_KEY_USAGE: u32 = 16;
pub const CERT_KEY_AGREEMENT_KEY_USAGE: u32 = 8;
pub const CERT_KEY_CERT_SIGN_KEY_USAGE: u32 = 4;
pub const CERT_OFFLINE_CRL_SIGN_KEY_USAGE: u32 = 2;
pub const CERT_CRL_SIGN_KEY_USAGE: u32 = 2;
pub const CERT_ENCIPHER_ONLY_KEY_USAGE: u32 = 1;
pub const CERT_DECIPHER_ONLY_KEY_USAGE: u32 = 128;
pub const CERT_ALT_NAME_OTHER_NAME: u32 = 1;
pub const CERT_ALT_NAME_RFC822_NAME: u32 = 2;
pub const CERT_ALT_NAME_DNS_NAME: u32 = 3;
pub const CERT_ALT_NAME_X400_ADDRESS: u32 = 4;
pub const CERT_ALT_NAME_DIRECTORY_NAME: u32 = 5;
pub const CERT_ALT_NAME_EDI_PARTY_NAME: u32 = 6;
pub const CERT_ALT_NAME_URL: u32 = 7;
pub const CERT_ALT_NAME_IP_ADDRESS: u32 = 8;
pub const CERT_ALT_NAME_REGISTERED_ID: u32 = 9;
pub const CERT_ALT_NAME_ENTRY_ERR_INDEX_MASK: u32 = 255;
pub const CERT_ALT_NAME_ENTRY_ERR_INDEX_SHIFT: u32 = 16;
pub const CERT_ALT_NAME_VALUE_ERR_INDEX_MASK: u32 = 65535;
pub const CERT_ALT_NAME_VALUE_ERR_INDEX_SHIFT: u32 = 0;
pub const CERT_CA_SUBJECT_FLAG: u32 = 128;
pub const CERT_END_ENTITY_SUBJECT_FLAG: u32 = 64;
pub const szOID_PKIX_ACC_DESCR: &[u8; 17] = b"1.3.6.1.5.5.7.48\0";
pub const szOID_PKIX_OCSP: &[u8; 19] = b"1.3.6.1.5.5.7.48.1\0";
pub const szOID_PKIX_CA_ISSUERS: &[u8; 19] = b"1.3.6.1.5.5.7.48.2\0";
pub const szOID_PKIX_TIME_STAMPING: &[u8; 19] = b"1.3.6.1.5.5.7.48.3\0";
pub const szOID_PKIX_CA_REPOSITORY: &[u8; 19] = b"1.3.6.1.5.5.7.48.5\0";
pub const CRL_REASON_UNSPECIFIED: u32 = 0;
pub const CRL_REASON_KEY_COMPROMISE: u32 = 1;
pub const CRL_REASON_CA_COMPROMISE: u32 = 2;
pub const CRL_REASON_AFFILIATION_CHANGED: u32 = 3;
pub const CRL_REASON_SUPERSEDED: u32 = 4;
pub const CRL_REASON_CESSATION_OF_OPERATION: u32 = 5;
pub const CRL_REASON_CERTIFICATE_HOLD: u32 = 6;
pub const CRL_REASON_REMOVE_FROM_CRL: u32 = 8;
pub const CRL_REASON_PRIVILEGE_WITHDRAWN: u32 = 9;
pub const CRL_REASON_AA_COMPROMISE: u32 = 10;
pub const CRL_DIST_POINT_NO_NAME: u32 = 0;
pub const CRL_DIST_POINT_FULL_NAME: u32 = 1;
pub const CRL_DIST_POINT_ISSUER_RDN_NAME: u32 = 2;
pub const CRL_REASON_UNUSED_FLAG: u32 = 128;
pub const CRL_REASON_KEY_COMPROMISE_FLAG: u32 = 64;
pub const CRL_REASON_CA_COMPROMISE_FLAG: u32 = 32;
pub const CRL_REASON_AFFILIATION_CHANGED_FLAG: u32 = 16;
pub const CRL_REASON_SUPERSEDED_FLAG: u32 = 8;
pub const CRL_REASON_CESSATION_OF_OPERATION_FLAG: u32 = 4;
pub const CRL_REASON_CERTIFICATE_HOLD_FLAG: u32 = 2;
pub const CRL_REASON_PRIVILEGE_WITHDRAWN_FLAG: u32 = 1;
pub const CRL_REASON_AA_COMPROMISE_FLAG: u32 = 128;
pub const CRL_DIST_POINT_ERR_INDEX_MASK: u32 = 127;
pub const CRL_DIST_POINT_ERR_INDEX_SHIFT: u32 = 24;
pub const CRL_DIST_POINT_ERR_CRL_ISSUER_BIT: u32 = 2147483648;
pub const CROSS_CERT_DIST_POINT_ERR_INDEX_MASK: u32 = 255;
pub const CROSS_CERT_DIST_POINT_ERR_INDEX_SHIFT: u32 = 24;
pub const CERT_EXCLUDED_SUBTREE_BIT: u32 = 2147483648;
pub const SORTED_CTL_EXT_FLAGS_OFFSET: u32 = 0;
pub const SORTED_CTL_EXT_COUNT_OFFSET: u32 = 4;
pub const SORTED_CTL_EXT_MAX_COLLISION_OFFSET: u32 = 8;
pub const SORTED_CTL_EXT_HASH_BUCKET_OFFSET: u32 = 12;
pub const SORTED_CTL_EXT_HASHED_SUBJECT_IDENTIFIER_FLAG: u32 = 1;
pub const CERT_DSS_R_LEN: u32 = 20;
pub const CERT_DSS_S_LEN: u32 = 20;
pub const CERT_DSS_SIGNATURE_LEN: u32 = 40;
pub const CERT_MAX_ASN_ENCODED_DSS_SIGNATURE_LEN: u32 = 48;
pub const CRYPT_X942_COUNTER_BYTE_LENGTH: u32 = 4;
pub const CRYPT_X942_KEY_LENGTH_BYTE_LENGTH: u32 = 4;
pub const CRYPT_X942_PUB_INFO_BYTE_LENGTH: u32 = 64;
pub const CRYPT_ECC_CMS_SHARED_INFO_SUPPPUBINFO_BYTE_LENGTH: u32 = 4;
pub const CRYPT_RC2_40BIT_VERSION: u32 = 160;
pub const CRYPT_RC2_56BIT_VERSION: u32 = 52;
pub const CRYPT_RC2_64BIT_VERSION: u32 = 120;
pub const CRYPT_RC2_128BIT_VERSION: u32 = 58;
pub const szOID_QC_EU_COMPLIANCE: &[u8; 15] = b"0.4.0.1862.1.1\0";
pub const szOID_QC_SSCD: &[u8; 15] = b"0.4.0.1862.1.4\0";
pub const PKCS_RSA_SSA_PSS_TRAILER_FIELD_BC: u32 = 1;
pub const szOID_VERISIGN_PRIVATE_6_9: &[u8; 24] = b"2.16.840.1.113733.1.6.9\0";
pub const szOID_VERISIGN_ONSITE_JURISDICTION_HASH: &[u8; 25] = b"2.16.840.1.113733.1.6.11\0";
pub const szOID_VERISIGN_BITSTRING_6_13: &[u8; 25] = b"2.16.840.1.113733.1.6.13\0";
pub const szOID_VERISIGN_ISS_STRONG_CRYPTO: &[u8; 24] = b"2.16.840.1.113733.1.8.1\0";
pub const szOIDVerisign_MessageType: &[u8; 24] = b"2.16.840.1.113733.1.9.2\0";
pub const szOIDVerisign_PkiStatus: &[u8; 24] = b"2.16.840.1.113733.1.9.3\0";
pub const szOIDVerisign_FailInfo: &[u8; 24] = b"2.16.840.1.113733.1.9.4\0";
pub const szOIDVerisign_SenderNonce: &[u8; 24] = b"2.16.840.1.113733.1.9.5\0";
pub const szOIDVerisign_RecipientNonce: &[u8; 24] = b"2.16.840.1.113733.1.9.6\0";
pub const szOIDVerisign_TransactionID: &[u8; 24] = b"2.16.840.1.113733.1.9.7\0";
pub const szOID_NETSCAPE: &[u8; 18] = b"2.16.840.1.113730\0";
pub const szOID_NETSCAPE_CERT_EXTENSION: &[u8; 20] = b"2.16.840.1.113730.1\0";
pub const szOID_NETSCAPE_CERT_TYPE: &[u8; 22] = b"2.16.840.1.113730.1.1\0";
pub const szOID_NETSCAPE_BASE_URL: &[u8; 22] = b"2.16.840.1.113730.1.2\0";
pub const szOID_NETSCAPE_REVOCATION_URL: &[u8; 22] = b"2.16.840.1.113730.1.3\0";
pub const szOID_NETSCAPE_CA_REVOCATION_URL: &[u8; 22] = b"2.16.840.1.113730.1.4\0";
pub const szOID_NETSCAPE_CERT_RENEWAL_URL: &[u8; 22] = b"2.16.840.1.113730.1.7\0";
pub const szOID_NETSCAPE_CA_POLICY_URL: &[u8; 22] = b"2.16.840.1.113730.1.8\0";
pub const szOID_NETSCAPE_SSL_SERVER_NAME: &[u8; 23] = b"2.16.840.1.113730.1.12\0";
pub const szOID_NETSCAPE_COMMENT: &[u8; 23] = b"2.16.840.1.113730.1.13\0";
pub const szOID_NETSCAPE_DATA_TYPE: &[u8; 20] = b"2.16.840.1.113730.2\0";
pub const szOID_NETSCAPE_CERT_SEQUENCE: &[u8; 22] = b"2.16.840.1.113730.2.5\0";
pub const NETSCAPE_SSL_CLIENT_AUTH_CERT_TYPE: u32 = 128;
pub const NETSCAPE_SSL_SERVER_AUTH_CERT_TYPE: u32 = 64;
pub const NETSCAPE_SMIME_CERT_TYPE: u32 = 32;
pub const NETSCAPE_SIGN_CERT_TYPE: u32 = 16;
pub const NETSCAPE_SSL_CA_CERT_TYPE: u32 = 4;
pub const NETSCAPE_SMIME_CA_CERT_TYPE: u32 = 2;
pub const NETSCAPE_SIGN_CA_CERT_TYPE: u32 = 1;
pub const szOID_CT_PKI_DATA: &[u8; 19] = b"1.3.6.1.5.5.7.12.2\0";
pub const szOID_CT_PKI_RESPONSE: &[u8; 19] = b"1.3.6.1.5.5.7.12.3\0";
pub const szOID_PKIX_NO_SIGNATURE: &[u8; 18] = b"1.3.6.1.5.5.7.6.2\0";
pub const szOID_CMC: &[u8; 16] = b"1.3.6.1.5.5.7.7\0";
pub const szOID_CMC_STATUS_INFO: &[u8; 18] = b"1.3.6.1.5.5.7.7.1\0";
pub const szOID_CMC_IDENTIFICATION: &[u8; 18] = b"1.3.6.1.5.5.7.7.2\0";
pub const szOID_CMC_IDENTITY_PROOF: &[u8; 18] = b"1.3.6.1.5.5.7.7.3\0";
pub const szOID_CMC_DATA_RETURN: &[u8; 18] = b"1.3.6.1.5.5.7.7.4\0";
pub const szOID_CMC_TRANSACTION_ID: &[u8; 18] = b"1.3.6.1.5.5.7.7.5\0";
pub const szOID_CMC_SENDER_NONCE: &[u8; 18] = b"1.3.6.1.5.5.7.7.6\0";
pub const szOID_CMC_RECIPIENT_NONCE: &[u8; 18] = b"1.3.6.1.5.5.7.7.7\0";
pub const szOID_CMC_ADD_EXTENSIONS: &[u8; 18] = b"1.3.6.1.5.5.7.7.8\0";
pub const szOID_CMC_ENCRYPTED_POP: &[u8; 18] = b"1.3.6.1.5.5.7.7.9\0";
pub const szOID_CMC_DECRYPTED_POP: &[u8; 19] = b"1.3.6.1.5.5.7.7.10\0";
pub const szOID_CMC_LRA_POP_WITNESS: &[u8; 19] = b"1.3.6.1.5.5.7.7.11\0";
pub const szOID_CMC_GET_CERT: &[u8; 19] = b"1.3.6.1.5.5.7.7.15\0";
pub const szOID_CMC_GET_CRL: &[u8; 19] = b"1.3.6.1.5.5.7.7.16\0";
pub const szOID_CMC_REVOKE_REQUEST: &[u8; 19] = b"1.3.6.1.5.5.7.7.17\0";
pub const szOID_CMC_REG_INFO: &[u8; 19] = b"1.3.6.1.5.5.7.7.18\0";
pub const szOID_CMC_RESPONSE_INFO: &[u8; 19] = b"1.3.6.1.5.5.7.7.19\0";
pub const szOID_CMC_QUERY_PENDING: &[u8; 19] = b"1.3.6.1.5.5.7.7.21\0";
pub const szOID_CMC_ID_POP_LINK_RANDOM: &[u8; 19] = b"1.3.6.1.5.5.7.7.22\0";
pub const szOID_CMC_ID_POP_LINK_WITNESS: &[u8; 19] = b"1.3.6.1.5.5.7.7.23\0";
pub const szOID_CMC_ID_CONFIRM_CERT_ACCEPTANCE: &[u8; 19] = b"1.3.6.1.5.5.7.7.24\0";
pub const szOID_CMC_ADD_ATTRIBUTES: &[u8; 24] = b"1.3.6.1.4.1.311.10.10.1\0";
pub const CMC_TAGGED_CERT_REQUEST_CHOICE: u32 = 1;
pub const CMC_OTHER_INFO_NO_CHOICE: u32 = 0;
pub const CMC_OTHER_INFO_FAIL_CHOICE: u32 = 1;
pub const CMC_OTHER_INFO_PEND_CHOICE: u32 = 2;
pub const CMC_STATUS_SUCCESS: u32 = 0;
pub const CMC_STATUS_FAILED: u32 = 2;
pub const CMC_STATUS_PENDING: u32 = 3;
pub const CMC_STATUS_NO_SUPPORT: u32 = 4;
pub const CMC_STATUS_CONFIRM_REQUIRED: u32 = 5;
pub const CMC_FAIL_BAD_ALG: u32 = 0;
pub const CMC_FAIL_BAD_MESSAGE_CHECK: u32 = 1;
pub const CMC_FAIL_BAD_REQUEST: u32 = 2;
pub const CMC_FAIL_BAD_TIME: u32 = 3;
pub const CMC_FAIL_BAD_CERT_ID: u32 = 4;
pub const CMC_FAIL_UNSUPORTED_EXT: u32 = 5;
pub const CMC_FAIL_MUST_ARCHIVE_KEYS: u32 = 6;
pub const CMC_FAIL_BAD_IDENTITY: u32 = 7;
pub const CMC_FAIL_POP_REQUIRED: u32 = 8;
pub const CMC_FAIL_POP_FAILED: u32 = 9;
pub const CMC_FAIL_NO_KEY_REUSE: u32 = 10;
pub const CMC_FAIL_INTERNAL_CA_ERROR: u32 = 11;
pub const CMC_FAIL_TRY_LATER: u32 = 12;
pub const CERT_LOGOTYPE_GRAY_SCALE_IMAGE_INFO_CHOICE: u32 = 1;
pub const CERT_LOGOTYPE_COLOR_IMAGE_INFO_CHOICE: u32 = 2;
pub const CERT_LOGOTYPE_NO_IMAGE_RESOLUTION_CHOICE: u32 = 0;
pub const CERT_LOGOTYPE_BITS_IMAGE_RESOLUTION_CHOICE: u32 = 1;
pub const CERT_LOGOTYPE_TABLE_SIZE_IMAGE_RESOLUTION_CHOICE: u32 = 2;
pub const CERT_LOGOTYPE_DIRECT_INFO_CHOICE: u32 = 1;
pub const CERT_LOGOTYPE_INDIRECT_INFO_CHOICE: u32 = 2;
pub const szOID_LOYALTY_OTHER_LOGOTYPE: &[u8; 19] = b"1.3.6.1.5.5.7.20.1\0";
pub const szOID_BACKGROUND_OTHER_LOGOTYPE: &[u8; 19] = b"1.3.6.1.5.5.7.20.2\0";
pub const CERT_BIOMETRIC_PREDEFINED_DATA_CHOICE: u32 = 1;
pub const CERT_BIOMETRIC_OID_DATA_CHOICE: u32 = 2;
pub const CERT_BIOMETRIC_PICTURE_TYPE: u32 = 0;
pub const CERT_BIOMETRIC_SIGNATURE_TYPE: u32 = 1;
pub const OCSP_REQUEST_V1: u32 = 0;
pub const OCSP_SUCCESSFUL_RESPONSE: u32 = 0;
pub const OCSP_MALFORMED_REQUEST_RESPONSE: u32 = 1;
pub const OCSP_INTERNAL_ERROR_RESPONSE: u32 = 2;
pub const OCSP_TRY_LATER_RESPONSE: u32 = 3;
pub const OCSP_SIG_REQUIRED_RESPONSE: u32 = 5;
pub const OCSP_UNAUTHORIZED_RESPONSE: u32 = 6;
pub const szOID_PKIX_OCSP_BASIC_SIGNED_RESPONSE: &[u8; 21] = b"1.3.6.1.5.5.7.48.1.1\0";
pub const OCSP_BASIC_GOOD_CERT_STATUS: u32 = 0;
pub const OCSP_BASIC_REVOKED_CERT_STATUS: u32 = 1;
pub const OCSP_BASIC_UNKNOWN_CERT_STATUS: u32 = 2;
pub const OCSP_BASIC_RESPONSE_V1: u32 = 0;
pub const OCSP_BASIC_BY_NAME_RESPONDER_ID: u32 = 1;
pub const OCSP_BASIC_BY_KEY_RESPONDER_ID: u32 = 2;
pub const CRYPT_OID_ENCODE_OBJECT_FUNC: &[u8; 21] = b"CryptDllEncodeObject\0";
pub const CRYPT_OID_DECODE_OBJECT_FUNC: &[u8; 21] = b"CryptDllDecodeObject\0";
pub const CRYPT_OID_ENCODE_OBJECT_EX_FUNC: &[u8; 23] = b"CryptDllEncodeObjectEx\0";
pub const CRYPT_OID_DECODE_OBJECT_EX_FUNC: &[u8; 23] = b"CryptDllDecodeObjectEx\0";
pub const CRYPT_OID_CREATE_COM_OBJECT_FUNC: &[u8; 24] = b"CryptDllCreateCOMObject\0";
pub const CRYPT_OID_VERIFY_REVOCATION_FUNC: &[u8; 24] = b"CertDllVerifyRevocation\0";
pub const CRYPT_OID_VERIFY_CTL_USAGE_FUNC: &[u8; 22] = b"CertDllVerifyCTLUsage\0";
pub const CRYPT_OID_FORMAT_OBJECT_FUNC: &[u8; 21] = b"CryptDllFormatObject\0";
pub const CRYPT_OID_FIND_OID_INFO_FUNC: &[u8; 20] = b"CryptDllFindOIDInfo\0";
pub const CRYPT_OID_FIND_LOCALIZED_NAME_FUNC: &[u8; 26] = b"CryptDllFindLocalizedName\0";
pub const CRYPT_OID_REGPATH: &[u8; 36] = b"Software\\Microsoft\\Cryptography\\OID\0";
pub const CRYPT_OID_REG_ENCODING_TYPE_PREFIX: &[u8; 14] = b"EncodingType \0";
pub const CRYPT_OID_REG_DLL_VALUE_NAME: &[u8; 4] = b"Dll\0";
pub const CRYPT_OID_REG_FUNC_NAME_VALUE_NAME: &[u8; 9] = b"FuncName\0";
pub const CRYPT_OID_REG_FUNC_NAME_VALUE_NAME_A: &[u8; 9] = b"FuncName\0";
pub const CRYPT_OID_REG_FLAGS_VALUE_NAME: &[u8; 11] = b"CryptFlags\0";
pub const CRYPT_DEFAULT_OID: &[u8; 8] = b"DEFAULT\0";
pub const CRYPT_INSTALL_OID_FUNC_BEFORE_FLAG: u32 = 1;
pub const CRYPT_GET_INSTALLED_OID_FUNC_FLAG: u32 = 1;
pub const CRYPT_REGISTER_FIRST_INDEX: u32 = 0;
pub const CRYPT_REGISTER_LAST_INDEX: u32 = 4294967295;
pub const CRYPT_MATCH_ANY_ENCODING_TYPE: u32 = 4294967295;
pub const CALG_OID_INFO_CNG_ONLY: u32 = 4294967295;
pub const CALG_OID_INFO_PARAMETERS: u32 = 4294967294;
pub const CRYPT_OID_INFO_HASH_PARAMETERS_ALGORITHM: &[u8; 27] = b"CryptOIDInfoHashParameters\0";
pub const CRYPT_OID_INFO_ECC_PARAMETERS_ALGORITHM: &[u8; 26] = b"CryptOIDInfoECCParameters\0";
pub const CRYPT_OID_INFO_MGF1_PARAMETERS_ALGORITHM: &[u8; 27] = b"CryptOIDInfoMgf1Parameters\0";
pub const CRYPT_OID_INFO_NO_SIGN_ALGORITHM: &[u8; 19] = b"CryptOIDInfoNoSign\0";
pub const CRYPT_OID_INFO_OAEP_PARAMETERS_ALGORITHM: &[u8; 27] = b"CryptOIDInfoOAEPParameters\0";
pub const CRYPT_OID_INFO_ECC_WRAP_PARAMETERS_ALGORITHM: &[u8; 30] =
    b"CryptOIDInfoECCWrapParameters\0";
pub const CRYPT_OID_INFO_NO_PARAMETERS_ALGORITHM: &[u8; 25] = b"CryptOIDInfoNoParameters\0";
pub const CRYPT_HASH_ALG_OID_GROUP_ID: u32 = 1;
pub const CRYPT_ENCRYPT_ALG_OID_GROUP_ID: u32 = 2;
pub const CRYPT_PUBKEY_ALG_OID_GROUP_ID: u32 = 3;
pub const CRYPT_SIGN_ALG_OID_GROUP_ID: u32 = 4;
pub const CRYPT_RDN_ATTR_OID_GROUP_ID: u32 = 5;
pub const CRYPT_EXT_OR_ATTR_OID_GROUP_ID: u32 = 6;
pub const CRYPT_ENHKEY_USAGE_OID_GROUP_ID: u32 = 7;
pub const CRYPT_POLICY_OID_GROUP_ID: u32 = 8;
pub const CRYPT_TEMPLATE_OID_GROUP_ID: u32 = 9;
pub const CRYPT_KDF_OID_GROUP_ID: u32 = 10;
pub const CRYPT_LAST_OID_GROUP_ID: u32 = 10;
pub const CRYPT_FIRST_ALG_OID_GROUP_ID: u32 = 1;
pub const CRYPT_LAST_ALG_OID_GROUP_ID: u32 = 4;
pub const CRYPT_OID_INHIBIT_SIGNATURE_FORMAT_FLAG: u32 = 1;
pub const CRYPT_OID_USE_PUBKEY_PARA_FOR_PKCS7_FLAG: u32 = 2;
pub const CRYPT_OID_NO_NULL_ALGORITHM_PARA_FLAG: u32 = 4;
pub const CRYPT_OID_PUBKEY_SIGN_ONLY_FLAG: u32 = 2147483648;
pub const CRYPT_OID_PUBKEY_ENCRYPT_ONLY_FLAG: u32 = 1073741824;
pub const CRYPT_OID_USE_CURVE_NAME_FOR_ENCODE_FLAG: u32 = 536870912;
pub const CRYPT_OID_USE_CURVE_PARAMETERS_FOR_ENCODE_FLAG: u32 = 268435456;
pub const CRYPT_OID_INFO_OID_KEY: u32 = 1;
pub const CRYPT_OID_INFO_NAME_KEY: u32 = 2;
pub const CRYPT_OID_INFO_ALGID_KEY: u32 = 3;
pub const CRYPT_OID_INFO_SIGN_KEY: u32 = 4;
pub const CRYPT_OID_INFO_CNG_ALGID_KEY: u32 = 5;
pub const CRYPT_OID_INFO_CNG_SIGN_KEY: u32 = 6;
pub const CRYPT_OID_INFO_OID_KEY_FLAGS_MASK: u32 = 4294901760;
pub const CRYPT_OID_INFO_PUBKEY_SIGN_KEY_FLAG: u32 = 2147483648;
pub const CRYPT_OID_INFO_PUBKEY_ENCRYPT_KEY_FLAG: u32 = 1073741824;
pub const CRYPT_OID_DISABLE_SEARCH_DS_FLAG: u32 = 2147483648;
pub const CRYPT_OID_INFO_OID_GROUP_BIT_LEN_MASK: u32 = 268369920;
pub const CRYPT_OID_INFO_OID_GROUP_BIT_LEN_SHIFT: u32 = 16;
pub const CRYPT_INSTALL_OID_INFO_BEFORE_FLAG: u32 = 1;
pub const CRYPT_LOCALIZED_NAME_ENCODING_TYPE: u32 = 0;
pub const CRYPT_LOCALIZED_NAME_OID: &[u8; 15] = b"LocalizedNames\0";
pub const CERT_STRONG_SIGN_ECDSA_ALGORITHM: &[u8; 6] = b"ECDSA\0";
pub const CERT_STRONG_SIGN_SERIALIZED_INFO_CHOICE: u32 = 1;
pub const CERT_STRONG_SIGN_OID_INFO_CHOICE: u32 = 2;
pub const CERT_STRONG_SIGN_ENABLE_CRL_CHECK: u32 = 1;
pub const CERT_STRONG_SIGN_ENABLE_OCSP_CHECK: u32 = 2;
pub const szOID_CERT_STRONG_SIGN_OS_PREFIX: &[u8; 22] = b"1.3.6.1.4.1.311.72.1.\0";
pub const szOID_CERT_STRONG_SIGN_OS_1: &[u8; 23] = b"1.3.6.1.4.1.311.72.1.1\0";
pub const szOID_CERT_STRONG_SIGN_OS_CURRENT: &[u8; 23] = b"1.3.6.1.4.1.311.72.1.1\0";
pub const szOID_CERT_STRONG_KEY_OS_PREFIX: &[u8; 22] = b"1.3.6.1.4.1.311.72.2.\0";
pub const szOID_CERT_STRONG_KEY_OS_1: &[u8; 23] = b"1.3.6.1.4.1.311.72.2.1\0";
pub const szOID_CERT_STRONG_KEY_OS_CURRENT: &[u8; 23] = b"1.3.6.1.4.1.311.72.2.1\0";
pub const szOID_PKCS_7_DATA: &[u8; 21] = b"1.2.840.113549.1.7.1\0";
pub const szOID_PKCS_7_SIGNED: &[u8; 21] = b"1.2.840.113549.1.7.2\0";
pub const szOID_PKCS_7_ENVELOPED: &[u8; 21] = b"1.2.840.113549.1.7.3\0";
pub const szOID_PKCS_7_SIGNEDANDENVELOPED: &[u8; 21] = b"1.2.840.113549.1.7.4\0";
pub const szOID_PKCS_7_DIGESTED: &[u8; 21] = b"1.2.840.113549.1.7.5\0";
pub const szOID_PKCS_7_ENCRYPTED: &[u8; 21] = b"1.2.840.113549.1.7.6\0";
pub const szOID_PKCS_9_CONTENT_TYPE: &[u8; 21] = b"1.2.840.113549.1.9.3\0";
pub const szOID_PKCS_9_MESSAGE_DIGEST: &[u8; 21] = b"1.2.840.113549.1.9.4\0";
pub const CMSG_DATA: u32 = 1;
pub const CMSG_SIGNED: u32 = 2;
pub const CMSG_ENVELOPED: u32 = 3;
pub const CMSG_SIGNED_AND_ENVELOPED: u32 = 4;
pub const CMSG_HASHED: u32 = 5;
pub const CMSG_ENCRYPTED: u32 = 6;
pub const CMSG_ALL_FLAGS: i32 = -1;
pub const CMSG_DATA_FLAG: u32 = 2;
pub const CMSG_SIGNED_FLAG: u32 = 4;
pub const CMSG_ENVELOPED_FLAG: u32 = 8;
pub const CMSG_SIGNED_AND_ENVELOPED_FLAG: u32 = 16;
pub const CMSG_HASHED_FLAG: u32 = 32;
pub const CMSG_ENCRYPTED_FLAG: u32 = 64;
pub const CERT_ID_ISSUER_SERIAL_NUMBER: u32 = 1;
pub const CERT_ID_KEY_IDENTIFIER: u32 = 2;
pub const CERT_ID_SHA1_HASH: u32 = 3;
pub const CMSG_KEY_AGREE_EPHEMERAL_KEY_CHOICE: u32 = 1;
pub const CMSG_KEY_AGREE_STATIC_KEY_CHOICE: u32 = 2;
pub const CMSG_MAIL_LIST_HANDLE_KEY_CHOICE: u32 = 1;
pub const CMSG_KEY_TRANS_RECIPIENT: u32 = 1;
pub const CMSG_KEY_AGREE_RECIPIENT: u32 = 2;
pub const CMSG_MAIL_LIST_RECIPIENT: u32 = 3;
pub const CMSG_SP3_COMPATIBLE_ENCRYPT_FLAG: u32 = 2147483648;
pub const CMSG_RC4_NO_SALT_FLAG: u32 = 1073741824;
pub const CMSG_INDEFINITE_LENGTH: u32 = 4294967295;
pub const CMSG_BARE_CONTENT_FLAG: u32 = 1;
pub const CMSG_LENGTH_ONLY_FLAG: u32 = 2;
pub const CMSG_DETACHED_FLAG: u32 = 4;
pub const CMSG_AUTHENTICATED_ATTRIBUTES_FLAG: u32 = 8;
pub const CMSG_CONTENTS_OCTETS_FLAG: u32 = 16;
pub const CMSG_MAX_LENGTH_FLAG: u32 = 32;
pub const CMSG_CMS_ENCAPSULATED_CONTENT_FLAG: u32 = 64;
pub const CMSG_SIGNED_DATA_NO_SIGN_FLAG: u32 = 128;
pub const CMSG_CRYPT_RELEASE_CONTEXT_FLAG: u32 = 32768;
pub const CMSG_TYPE_PARAM: u32 = 1;
pub const CMSG_CONTENT_PARAM: u32 = 2;
pub const CMSG_BARE_CONTENT_PARAM: u32 = 3;
pub const CMSG_INNER_CONTENT_TYPE_PARAM: u32 = 4;
pub const CMSG_SIGNER_COUNT_PARAM: u32 = 5;
pub const CMSG_SIGNER_INFO_PARAM: u32 = 6;
pub const CMSG_SIGNER_CERT_INFO_PARAM: u32 = 7;
pub const CMSG_SIGNER_HASH_ALGORITHM_PARAM: u32 = 8;
pub const CMSG_SIGNER_AUTH_ATTR_PARAM: u32 = 9;
pub const CMSG_SIGNER_UNAUTH_ATTR_PARAM: u32 = 10;
pub const CMSG_CERT_COUNT_PARAM: u32 = 11;
pub const CMSG_CERT_PARAM: u32 = 12;
pub const CMSG_CRL_COUNT_PARAM: u32 = 13;
pub const CMSG_CRL_PARAM: u32 = 14;
pub const CMSG_ENVELOPE_ALGORITHM_PARAM: u32 = 15;
pub const CMSG_RECIPIENT_COUNT_PARAM: u32 = 17;
pub const CMSG_RECIPIENT_INDEX_PARAM: u32 = 18;
pub const CMSG_RECIPIENT_INFO_PARAM: u32 = 19;
pub const CMSG_HASH_ALGORITHM_PARAM: u32 = 20;
pub const CMSG_HASH_DATA_PARAM: u32 = 21;
pub const CMSG_COMPUTED_HASH_PARAM: u32 = 22;
pub const CMSG_ENCRYPT_PARAM: u32 = 26;
pub const CMSG_ENCRYPTED_DIGEST: u32 = 27;
pub const CMSG_ENCODED_SIGNER: u32 = 28;
pub const CMSG_ENCODED_MESSAGE: u32 = 29;
pub const CMSG_VERSION_PARAM: u32 = 30;
pub const CMSG_ATTR_CERT_COUNT_PARAM: u32 = 31;
pub const CMSG_ATTR_CERT_PARAM: u32 = 32;
pub const CMSG_CMS_RECIPIENT_COUNT_PARAM: u32 = 33;
pub const CMSG_CMS_RECIPIENT_INDEX_PARAM: u32 = 34;
pub const CMSG_CMS_RECIPIENT_ENCRYPTED_KEY_INDEX_PARAM: u32 = 35;
pub const CMSG_CMS_RECIPIENT_INFO_PARAM: u32 = 36;
pub const CMSG_UNPROTECTED_ATTR_PARAM: u32 = 37;
pub const CMSG_SIGNER_CERT_ID_PARAM: u32 = 38;
pub const CMSG_CMS_SIGNER_INFO_PARAM: u32 = 39;
pub const CMSG_SIGNED_DATA_V1: u32 = 1;
pub const CMSG_SIGNED_DATA_V3: u32 = 3;
pub const CMSG_SIGNED_DATA_PKCS_1_5_VERSION: u32 = 1;
pub const CMSG_SIGNED_DATA_CMS_VERSION: u32 = 3;
pub const CMSG_SIGNER_INFO_V1: u32 = 1;
pub const CMSG_SIGNER_INFO_V3: u32 = 3;
pub const CMSG_SIGNER_INFO_PKCS_1_5_VERSION: u32 = 1;
pub const CMSG_SIGNER_INFO_CMS_VERSION: u32 = 3;
pub const CMSG_HASHED_DATA_V0: u32 = 0;
pub const CMSG_HASHED_DATA_V2: u32 = 2;
pub const CMSG_HASHED_DATA_PKCS_1_5_VERSION: u32 = 0;
pub const CMSG_HASHED_DATA_CMS_VERSION: u32 = 2;
pub const CMSG_ENVELOPED_DATA_V0: u32 = 0;
pub const CMSG_ENVELOPED_DATA_V2: u32 = 2;
pub const CMSG_ENVELOPED_DATA_PKCS_1_5_VERSION: u32 = 0;
pub const CMSG_ENVELOPED_DATA_CMS_VERSION: u32 = 2;
pub const CMSG_KEY_AGREE_ORIGINATOR_CERT: u32 = 1;
pub const CMSG_KEY_AGREE_ORIGINATOR_PUBLIC_KEY: u32 = 2;
pub const CMSG_ENVELOPED_RECIPIENT_V0: u32 = 0;
pub const CMSG_ENVELOPED_RECIPIENT_V2: u32 = 2;
pub const CMSG_ENVELOPED_RECIPIENT_V3: u32 = 3;
pub const CMSG_ENVELOPED_RECIPIENT_V4: u32 = 4;
pub const CMSG_KEY_TRANS_PKCS_1_5_VERSION: u32 = 0;
pub const CMSG_KEY_TRANS_CMS_VERSION: u32 = 2;
pub const CMSG_KEY_AGREE_VERSION: u32 = 3;
pub const CMSG_MAIL_LIST_VERSION: u32 = 4;
pub const CMSG_CTRL_VERIFY_SIGNATURE: u32 = 1;
pub const CMSG_CTRL_DECRYPT: u32 = 2;
pub const CMSG_CTRL_VERIFY_HASH: u32 = 5;
pub const CMSG_CTRL_ADD_SIGNER: u32 = 6;
pub const CMSG_CTRL_DEL_SIGNER: u32 = 7;
pub const CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR: u32 = 8;
pub const CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR: u32 = 9;
pub const CMSG_CTRL_ADD_CERT: u32 = 10;
pub const CMSG_CTRL_DEL_CERT: u32 = 11;
pub const CMSG_CTRL_ADD_CRL: u32 = 12;
pub const CMSG_CTRL_DEL_CRL: u32 = 13;
pub const CMSG_CTRL_ADD_ATTR_CERT: u32 = 14;
pub const CMSG_CTRL_DEL_ATTR_CERT: u32 = 15;
pub const CMSG_CTRL_KEY_TRANS_DECRYPT: u32 = 16;
pub const CMSG_CTRL_KEY_AGREE_DECRYPT: u32 = 17;
pub const CMSG_CTRL_MAIL_LIST_DECRYPT: u32 = 18;
pub const CMSG_CTRL_VERIFY_SIGNATURE_EX: u32 = 19;
pub const CMSG_CTRL_ADD_CMS_SIGNER_INFO: u32 = 20;
pub const CMSG_CTRL_ENABLE_STRONG_SIGNATURE: u32 = 21;
pub const CMSG_VERIFY_SIGNER_PUBKEY: u32 = 1;
pub const CMSG_VERIFY_SIGNER_CERT: u32 = 2;
pub const CMSG_VERIFY_SIGNER_CHAIN: u32 = 3;
pub const CMSG_VERIFY_SIGNER_NULL: u32 = 4;
pub const CMSG_VERIFY_COUNTER_SIGN_ENABLE_STRONG_FLAG: u32 = 1;
pub const CMSG_OID_GEN_ENCRYPT_KEY_FUNC: &[u8; 25] = b"CryptMsgDllGenEncryptKey\0";
pub const CMSG_OID_EXPORT_ENCRYPT_KEY_FUNC: &[u8; 28] = b"CryptMsgDllExportEncryptKey\0";
pub const CMSG_OID_IMPORT_ENCRYPT_KEY_FUNC: &[u8; 28] = b"CryptMsgDllImportEncryptKey\0";
pub const CMSG_CONTENT_ENCRYPT_PAD_ENCODED_LEN_FLAG: u32 = 1;
pub const CMSG_CONTENT_ENCRYPT_FREE_PARA_FLAG: u32 = 1;
pub const CMSG_CONTENT_ENCRYPT_FREE_OBJID_FLAG: u32 = 2;
pub const CMSG_CONTENT_ENCRYPT_RELEASE_CONTEXT_FLAG: u32 = 32768;
pub const CMSG_OID_GEN_CONTENT_ENCRYPT_KEY_FUNC: &[u8; 32] = b"CryptMsgDllGenContentEncryptKey\0";
pub const CMSG_OID_CAPI1_GEN_CONTENT_ENCRYPT_KEY_FUNC: &[u8; 32] =
    b"CryptMsgDllGenContentEncryptKey\0";
pub const CMSG_OID_CNG_GEN_CONTENT_ENCRYPT_KEY_FUNC: &[u8; 35] =
    b"CryptMsgDllCNGGenContentEncryptKey\0";
pub const CMSG_KEY_TRANS_ENCRYPT_FREE_PARA_FLAG: u32 = 1;
pub const CMSG_KEY_TRANS_ENCRYPT_FREE_OBJID_FLAG: u32 = 2;
pub const CMSG_OID_EXPORT_KEY_TRANS_FUNC: &[u8; 26] = b"CryptMsgDllExportKeyTrans\0";
pub const CMSG_OID_CAPI1_EXPORT_KEY_TRANS_FUNC: &[u8; 26] = b"CryptMsgDllExportKeyTrans\0";
pub const CMSG_OID_CNG_EXPORT_KEY_TRANS_FUNC: &[u8; 29] = b"CryptMsgDllCNGExportKeyTrans\0";
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_PARA_FLAG: u32 = 1;
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_MATERIAL_FLAG: u32 = 2;
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_ALG_FLAG: u32 = 4;
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_PARA_FLAG: u32 = 8;
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_PUBKEY_BITS_FLAG: u32 = 16;
pub const CMSG_KEY_AGREE_ENCRYPT_FREE_OBJID_FLAG: u32 = 32;
pub const CMSG_OID_EXPORT_KEY_AGREE_FUNC: &[u8; 26] = b"CryptMsgDllExportKeyAgree\0";
pub const CMSG_OID_CAPI1_EXPORT_KEY_AGREE_FUNC: &[u8; 26] = b"CryptMsgDllExportKeyAgree\0";
pub const CMSG_OID_CNG_EXPORT_KEY_AGREE_FUNC: &[u8; 29] = b"CryptMsgDllCNGExportKeyAgree\0";
pub const CMSG_MAIL_LIST_ENCRYPT_FREE_PARA_FLAG: u32 = 1;
pub const CMSG_MAIL_LIST_ENCRYPT_FREE_OBJID_FLAG: u32 = 2;
pub const CMSG_OID_EXPORT_MAIL_LIST_FUNC: &[u8; 26] = b"CryptMsgDllExportMailList\0";
pub const CMSG_OID_CAPI1_EXPORT_MAIL_LIST_FUNC: &[u8; 26] = b"CryptMsgDllExportMailList\0";
pub const CMSG_OID_IMPORT_KEY_TRANS_FUNC: &[u8; 26] = b"CryptMsgDllImportKeyTrans\0";
pub const CMSG_OID_CAPI1_IMPORT_KEY_TRANS_FUNC: &[u8; 26] = b"CryptMsgDllImportKeyTrans\0";
pub const CMSG_OID_IMPORT_KEY_AGREE_FUNC: &[u8; 26] = b"CryptMsgDllImportKeyAgree\0";
pub const CMSG_OID_CAPI1_IMPORT_KEY_AGREE_FUNC: &[u8; 26] = b"CryptMsgDllImportKeyAgree\0";
pub const CMSG_OID_IMPORT_MAIL_LIST_FUNC: &[u8; 26] = b"CryptMsgDllImportMailList\0";
pub const CMSG_OID_CAPI1_IMPORT_MAIL_LIST_FUNC: &[u8; 26] = b"CryptMsgDllImportMailList\0";
pub const CMSG_OID_CNG_IMPORT_KEY_TRANS_FUNC: &[u8; 29] = b"CryptMsgDllCNGImportKeyTrans\0";
pub const CMSG_OID_CNG_IMPORT_KEY_AGREE_FUNC: &[u8; 29] = b"CryptMsgDllCNGImportKeyAgree\0";
pub const CMSG_OID_CNG_IMPORT_CONTENT_ENCRYPT_KEY_FUNC: &[u8; 38] =
    b"CryptMsgDllCNGImportContentEncryptKey\0";
pub const CERT_KEY_PROV_HANDLE_PROP_ID: u32 = 1;
pub const CERT_KEY_PROV_INFO_PROP_ID: u32 = 2;
pub const CERT_SHA1_HASH_PROP_ID: u32 = 3;
pub const CERT_MD5_HASH_PROP_ID: u32 = 4;
pub const CERT_HASH_PROP_ID: u32 = 3;
pub const CERT_KEY_CONTEXT_PROP_ID: u32 = 5;
pub const CERT_KEY_SPEC_PROP_ID: u32 = 6;
pub const CERT_IE30_RESERVED_PROP_ID: u32 = 7;
pub const CERT_PUBKEY_HASH_RESERVED_PROP_ID: u32 = 8;
pub const CERT_ENHKEY_USAGE_PROP_ID: u32 = 9;
pub const CERT_CTL_USAGE_PROP_ID: u32 = 9;
pub const CERT_NEXT_UPDATE_LOCATION_PROP_ID: u32 = 10;
pub const CERT_FRIENDLY_NAME_PROP_ID: u32 = 11;
pub const CERT_PVK_FILE_PROP_ID: u32 = 12;
pub const CERT_DESCRIPTION_PROP_ID: u32 = 13;
pub const CERT_ACCESS_STATE_PROP_ID: u32 = 14;
pub const CERT_SIGNATURE_HASH_PROP_ID: u32 = 15;
pub const CERT_SMART_CARD_DATA_PROP_ID: u32 = 16;
pub const CERT_EFS_PROP_ID: u32 = 17;
pub const CERT_FORTEZZA_DATA_PROP_ID: u32 = 18;
pub const CERT_ARCHIVED_PROP_ID: u32 = 19;
pub const CERT_KEY_IDENTIFIER_PROP_ID: u32 = 20;
pub const CERT_AUTO_ENROLL_PROP_ID: u32 = 21;
pub const CERT_PUBKEY_ALG_PARA_PROP_ID: u32 = 22;
pub const CERT_CROSS_CERT_DIST_POINTS_PROP_ID: u32 = 23;
pub const CERT_ISSUER_PUBLIC_KEY_MD5_HASH_PROP_ID: u32 = 24;
pub const CERT_SUBJECT_PUBLIC_KEY_MD5_HASH_PROP_ID: u32 = 25;
pub const CERT_ENROLLMENT_PROP_ID: u32 = 26;
pub const CERT_DATE_STAMP_PROP_ID: u32 = 27;
pub const CERT_ISSUER_SERIAL_NUMBER_MD5_HASH_PROP_ID: u32 = 28;
pub const CERT_SUBJECT_NAME_MD5_HASH_PROP_ID: u32 = 29;
pub const CERT_EXTENDED_ERROR_INFO_PROP_ID: u32 = 30;
pub const CERT_RENEWAL_PROP_ID: u32 = 64;
pub const CERT_ARCHIVED_KEY_HASH_PROP_ID: u32 = 65;
pub const CERT_AUTO_ENROLL_RETRY_PROP_ID: u32 = 66;
pub const CERT_AIA_URL_RETRIEVED_PROP_ID: u32 = 67;
pub const CERT_AUTHORITY_INFO_ACCESS_PROP_ID: u32 = 68;
pub const CERT_BACKED_UP_PROP_ID: u32 = 69;
pub const CERT_OCSP_RESPONSE_PROP_ID: u32 = 70;
pub const CERT_REQUEST_ORIGINATOR_PROP_ID: u32 = 71;
pub const CERT_SOURCE_LOCATION_PROP_ID: u32 = 72;
pub const CERT_SOURCE_URL_PROP_ID: u32 = 73;
pub const CERT_NEW_KEY_PROP_ID: u32 = 74;
pub const CERT_OCSP_CACHE_PREFIX_PROP_ID: u32 = 75;
pub const CERT_SMART_CARD_ROOT_INFO_PROP_ID: u32 = 76;
pub const CERT_NO_AUTO_EXPIRE_CHECK_PROP_ID: u32 = 77;
pub const CERT_NCRYPT_KEY_HANDLE_PROP_ID: u32 = 78;
pub const CERT_HCRYPTPROV_OR_NCRYPT_KEY_HANDLE_PROP_ID: u32 = 79;
pub const CERT_SUBJECT_INFO_ACCESS_PROP_ID: u32 = 80;
pub const CERT_CA_OCSP_AUTHORITY_INFO_ACCESS_PROP_ID: u32 = 81;
pub const CERT_CA_DISABLE_CRL_PROP_ID: u32 = 82;
pub const CERT_ROOT_PROGRAM_CERT_POLICIES_PROP_ID: u32 = 83;
pub const CERT_ROOT_PROGRAM_NAME_CONSTRAINTS_PROP_ID: u32 = 84;
pub const CERT_SUBJECT_OCSP_AUTHORITY_INFO_ACCESS_PROP_ID: u32 = 85;
pub const CERT_SUBJECT_DISABLE_CRL_PROP_ID: u32 = 86;
pub const CERT_CEP_PROP_ID: u32 = 87;
pub const CERT_SIGN_HASH_CNG_ALG_PROP_ID: u32 = 89;
pub const CERT_SCARD_PIN_ID_PROP_ID: u32 = 90;
pub const CERT_SCARD_PIN_INFO_PROP_ID: u32 = 91;
pub const CERT_SUBJECT_PUB_KEY_BIT_LENGTH_PROP_ID: u32 = 92;
pub const CERT_PUB_KEY_CNG_ALG_BIT_LENGTH_PROP_ID: u32 = 93;
pub const CERT_ISSUER_PUB_KEY_BIT_LENGTH_PROP_ID: u32 = 94;
pub const CERT_ISSUER_CHAIN_SIGN_HASH_CNG_ALG_PROP_ID: u32 = 95;
pub const CERT_ISSUER_CHAIN_PUB_KEY_CNG_ALG_BIT_LENGTH_PROP_ID: u32 = 96;
pub const CERT_NO_EXPIRE_NOTIFICATION_PROP_ID: u32 = 97;
pub const CERT_AUTH_ROOT_SHA256_HASH_PROP_ID: u32 = 98;
pub const CERT_NCRYPT_KEY_HANDLE_TRANSFER_PROP_ID: u32 = 99;
pub const CERT_HCRYPTPROV_TRANSFER_PROP_ID: u32 = 100;
pub const CERT_SMART_CARD_READER_PROP_ID: u32 = 101;
pub const CERT_SEND_AS_TRUSTED_ISSUER_PROP_ID: u32 = 102;
pub const CERT_KEY_REPAIR_ATTEMPTED_PROP_ID: u32 = 103;
pub const CERT_DISALLOWED_FILETIME_PROP_ID: u32 = 104;
pub const CERT_ROOT_PROGRAM_CHAIN_POLICIES_PROP_ID: u32 = 105;
pub const CERT_SMART_CARD_READER_NON_REMOVABLE_PROP_ID: u32 = 106;
pub const CERT_SHA256_HASH_PROP_ID: u32 = 107;
pub const CERT_SCEP_SERVER_CERTS_PROP_ID: u32 = 108;
pub const CERT_SCEP_RA_SIGNATURE_CERT_PROP_ID: u32 = 109;
pub const CERT_SCEP_RA_ENCRYPTION_CERT_PROP_ID: u32 = 110;
pub const CERT_SCEP_CA_CERT_PROP_ID: u32 = 111;
pub const CERT_SCEP_SIGNER_CERT_PROP_ID: u32 = 112;
pub const CERT_SCEP_NONCE_PROP_ID: u32 = 113;
pub const CERT_SCEP_ENCRYPT_HASH_CNG_ALG_PROP_ID: u32 = 114;
pub const CERT_SCEP_FLAGS_PROP_ID: u32 = 115;
pub const CERT_SCEP_GUID_PROP_ID: u32 = 116;
pub const CERT_SERIALIZABLE_KEY_CONTEXT_PROP_ID: u32 = 117;
pub const CERT_ISOLATED_KEY_PROP_ID: u32 = 118;
pub const CERT_SERIAL_CHAIN_PROP_ID: u32 = 119;
pub const CERT_KEY_CLASSIFICATION_PROP_ID: u32 = 120;
pub const CERT_OCSP_MUST_STAPLE_PROP_ID: u32 = 121;
pub const CERT_DISALLOWED_ENHKEY_USAGE_PROP_ID: u32 = 122;
pub const CERT_NONCOMPLIANT_ROOT_URL_PROP_ID: u32 = 123;
pub const CERT_PIN_SHA256_HASH_PROP_ID: u32 = 124;
pub const CERT_CLR_DELETE_KEY_PROP_ID: u32 = 125;
pub const CERT_NOT_BEFORE_FILETIME_PROP_ID: u32 = 126;
pub const CERT_NOT_BEFORE_ENHKEY_USAGE_PROP_ID: u32 = 127;
pub const CERT_FIRST_RESERVED_PROP_ID: u32 = 128;
pub const CERT_LAST_RESERVED_PROP_ID: u32 = 32767;
pub const CERT_FIRST_USER_PROP_ID: u32 = 32768;
pub const CERT_LAST_USER_PROP_ID: u32 = 65535;
pub const szOID_CERT_PROP_ID_PREFIX: &[u8; 23] = b"1.3.6.1.4.1.311.10.11.\0";
pub const szOID_CERT_KEY_IDENTIFIER_PROP_ID: &[u8; 25] = b"1.3.6.1.4.1.311.10.11.20\0";
pub const szOID_CERT_ISSUER_SERIAL_NUMBER_MD5_HASH_PROP_ID: &[u8; 25] =
    b"1.3.6.1.4.1.311.10.11.28\0";
pub const szOID_CERT_SUBJECT_NAME_MD5_HASH_PROP_ID: &[u8; 25] = b"1.3.6.1.4.1.311.10.11.29\0";
pub const szOID_CERT_MD5_HASH_PROP_ID: &[u8; 24] = b"1.3.6.1.4.1.311.10.11.4\0";
pub const szOID_CERT_SIGNATURE_HASH_PROP_ID: &[u8; 25] = b"1.3.6.1.4.1.311.10.11.15\0";
pub const szOID_DISALLOWED_HASH: &[u8; 25] = b"1.3.6.1.4.1.311.10.11.15\0";
pub const szOID_CERT_DISALLOWED_FILETIME_PROP_ID: &[u8; 26] = b"1.3.6.1.4.1.311.10.11.104\0";
pub const CERT_ACCESS_STATE_WRITE_PERSIST_FLAG: u32 = 1;
pub const CERT_ACCESS_STATE_SYSTEM_STORE_FLAG: u32 = 2;
pub const CERT_ACCESS_STATE_LM_SYSTEM_STORE_FLAG: u32 = 4;
pub const CERT_ACCESS_STATE_GP_SYSTEM_STORE_FLAG: u32 = 8;
pub const CERT_ACCESS_STATE_SHARED_USER_FLAG: u32 = 16;
pub const szOID_ROOT_PROGRAM_AUTO_UPDATE_CA_REVOCATION: &[u8; 23] = b"1.3.6.1.4.1.311.60.3.1\0";
pub const szOID_ROOT_PROGRAM_AUTO_UPDATE_END_REVOCATION: &[u8; 23] = b"1.3.6.1.4.1.311.60.3.2\0";
pub const szOID_ROOT_PROGRAM_NO_OCSP_FAILOVER_TO_CRL: &[u8; 23] = b"1.3.6.1.4.1.311.60.3.3\0";
pub const CERT_SET_KEY_PROV_HANDLE_PROP_ID: u32 = 1;
pub const CERT_SET_KEY_CONTEXT_PROP_ID: u32 = 1;
pub const CERT_NCRYPT_KEY_SPEC: u32 = 4294967295;
pub const sz_CERT_STORE_PROV_MEMORY: &[u8; 7] = b"Memory\0";
pub const sz_CERT_STORE_PROV_FILENAME_W: &[u8; 5] = b"File\0";
pub const sz_CERT_STORE_PROV_FILENAME: &[u8; 5] = b"File\0";
pub const sz_CERT_STORE_PROV_SYSTEM_W: &[u8; 7] = b"System\0";
pub const sz_CERT_STORE_PROV_SYSTEM: &[u8; 7] = b"System\0";
pub const sz_CERT_STORE_PROV_PKCS7: &[u8; 6] = b"PKCS7\0";
pub const sz_CERT_STORE_PROV_PKCS12: &[u8; 7] = b"PKCS12\0";
pub const sz_CERT_STORE_PROV_SERIALIZED: &[u8; 11] = b"Serialized\0";
pub const sz_CERT_STORE_PROV_COLLECTION: &[u8; 11] = b"Collection\0";
pub const sz_CERT_STORE_PROV_SYSTEM_REGISTRY_W: &[u8; 15] = b"SystemRegistry\0";
pub const sz_CERT_STORE_PROV_SYSTEM_REGISTRY: &[u8; 15] = b"SystemRegistry\0";
pub const sz_CERT_STORE_PROV_PHYSICAL_W: &[u8; 9] = b"Physical\0";
pub const sz_CERT_STORE_PROV_PHYSICAL: &[u8; 9] = b"Physical\0";
pub const sz_CERT_STORE_PROV_SMART_CARD_W: &[u8; 10] = b"SmartCard\0";
pub const sz_CERT_STORE_PROV_SMART_CARD: &[u8; 10] = b"SmartCard\0";
pub const sz_CERT_STORE_PROV_LDAP_W: &[u8; 5] = b"Ldap\0";
pub const sz_CERT_STORE_PROV_LDAP: &[u8; 5] = b"Ldap\0";
pub const CERT_STORE_SIGNATURE_FLAG: u32 = 1;
pub const CERT_STORE_TIME_VALIDITY_FLAG: u32 = 2;
pub const CERT_STORE_REVOCATION_FLAG: u32 = 4;
pub const CERT_STORE_NO_CRL_FLAG: u32 = 65536;
pub const CERT_STORE_NO_ISSUER_FLAG: u32 = 131072;
pub const CERT_STORE_BASE_CRL_FLAG: u32 = 256;
pub const CERT_STORE_DELTA_CRL_FLAG: u32 = 512;
pub const CERT_STORE_NO_CRYPT_RELEASE_FLAG: u32 = 1;
pub const CERT_STORE_SET_LOCALIZED_NAME_FLAG: u32 = 2;
pub const CERT_STORE_DEFER_CLOSE_UNTIL_LAST_FREE_FLAG: u32 = 4;
pub const CERT_STORE_DELETE_FLAG: u32 = 16;
pub const CERT_STORE_UNSAFE_PHYSICAL_FLAG: u32 = 32;
pub const CERT_STORE_SHARE_STORE_FLAG: u32 = 64;
pub const CERT_STORE_SHARE_CONTEXT_FLAG: u32 = 128;
pub const CERT_STORE_MANIFOLD_FLAG: u32 = 256;
pub const CERT_STORE_ENUM_ARCHIVED_FLAG: u32 = 512;
pub const CERT_STORE_UPDATE_KEYID_FLAG: u32 = 1024;
pub const CERT_STORE_BACKUP_RESTORE_FLAG: u32 = 2048;
pub const CERT_STORE_READONLY_FLAG: u32 = 32768;
pub const CERT_STORE_OPEN_EXISTING_FLAG: u32 = 16384;
pub const CERT_STORE_CREATE_NEW_FLAG: u32 = 8192;
pub const CERT_STORE_MAXIMUM_ALLOWED_FLAG: u32 = 4096;
pub const CERT_SYSTEM_STORE_MASK: u32 = 4294901760;
pub const CERT_SYSTEM_STORE_RELOCATE_FLAG: u32 = 2147483648;
pub const CERT_SYSTEM_STORE_UNPROTECTED_FLAG: u32 = 1073741824;
pub const CERT_SYSTEM_STORE_DEFER_READ_FLAG: u32 = 536870912;
pub const CERT_SYSTEM_STORE_LOCATION_MASK: u32 = 16711680;
pub const CERT_SYSTEM_STORE_LOCATION_SHIFT: u32 = 16;
pub const CERT_SYSTEM_STORE_CURRENT_USER_ID: u32 = 1;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_ID: u32 = 2;
pub const CERT_SYSTEM_STORE_CURRENT_SERVICE_ID: u32 = 4;
pub const CERT_SYSTEM_STORE_SERVICES_ID: u32 = 5;
pub const CERT_SYSTEM_STORE_USERS_ID: u32 = 6;
pub const CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY_ID: u32 = 7;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY_ID: u32 = 8;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE_ID: u32 = 9;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_WCOS_ID: u32 = 10;
pub const CERT_SYSTEM_STORE_CURRENT_USER: u32 = 65536;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE: u32 = 131072;
pub const CERT_SYSTEM_STORE_CURRENT_SERVICE: u32 = 262144;
pub const CERT_SYSTEM_STORE_SERVICES: u32 = 327680;
pub const CERT_SYSTEM_STORE_USERS: u32 = 393216;
pub const CERT_SYSTEM_STORE_CURRENT_USER_GROUP_POLICY: u32 = 458752;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_GROUP_POLICY: u32 = 524288;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_ENTERPRISE: u32 = 589824;
pub const CERT_SYSTEM_STORE_LOCAL_MACHINE_WCOS: u32 = 655360;
pub const CERT_GROUP_POLICY_SYSTEM_STORE_REGPATH: &[u8; 47] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\0";
pub const CERT_EFSBLOB_REGPATH: &[u8; 51] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\\EFS\0";
pub const CERT_EFSBLOB_VALUE_NAME: &[u8; 8] = b"EFSBlob\0";
pub const CERT_PROT_ROOT_FLAGS_REGPATH: &[u8; 67] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\\Root\\ProtectedRoots\0";
pub const CERT_PROT_ROOT_FLAGS_VALUE_NAME: &[u8; 6] = b"Flags\0";
pub const CERT_PROT_ROOT_DISABLE_CURRENT_USER_FLAG: u32 = 1;
pub const CERT_PROT_ROOT_INHIBIT_ADD_AT_INIT_FLAG: u32 = 2;
pub const CERT_PROT_ROOT_INHIBIT_PURGE_LM_FLAG: u32 = 4;
pub const CERT_PROT_ROOT_DISABLE_LM_AUTH_FLAG: u32 = 8;
pub const CERT_PROT_ROOT_ONLY_LM_GPT_FLAG: u32 = 8;
pub const CERT_PROT_ROOT_DISABLE_NT_AUTH_REQUIRED_FLAG: u32 = 16;
pub const CERT_PROT_ROOT_DISABLE_NOT_DEFINED_NAME_CONSTRAINT_FLAG: u32 = 32;
pub const CERT_PROT_ROOT_DISABLE_PEER_TRUST: u32 = 65536;
pub const CERT_PROT_ROOT_PEER_USAGES_VALUE_NAME: &[u8; 11] = b"PeerUsages\0";
pub const CERT_PROT_ROOT_PEER_USAGES_VALUE_NAME_A: &[u8; 11] = b"PeerUsages\0";
pub const CERT_PROT_ROOT_PEER_USAGES_DEFAULT_A: &[u8; 60] =
    b"1.3.6.1.5.5.7.3.2\x001.3.6.1.5.5.7.3.4\x001.3.6.1.4.1.311.10.3.4\0\0";
pub const CERT_TRUST_PUB_SAFER_GROUP_POLICY_REGPATH: &[u8; 70] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\\TrustedPublisher\\Safer\0";
pub const CERT_LOCAL_MACHINE_SYSTEM_STORE_REGPATH: &[u8; 38] =
    b"Software\\Microsoft\\SystemCertificates\0";
pub const CERT_TRUST_PUB_SAFER_LOCAL_MACHINE_REGPATH: &[u8; 61] =
    b"Software\\Microsoft\\SystemCertificates\\TrustedPublisher\\Safer\0";
pub const CERT_TRUST_PUB_AUTHENTICODE_FLAGS_VALUE_NAME: &[u8; 18] = b"AuthenticodeFlags\0";
pub const CERT_TRUST_PUB_ALLOW_TRUST_MASK: u32 = 3;
pub const CERT_TRUST_PUB_ALLOW_END_USER_TRUST: u32 = 0;
pub const CERT_TRUST_PUB_ALLOW_MACHINE_ADMIN_TRUST: u32 = 1;
pub const CERT_TRUST_PUB_ALLOW_ENTERPRISE_ADMIN_TRUST: u32 = 2;
pub const CERT_TRUST_PUB_CHECK_PUBLISHER_REV_FLAG: u32 = 256;
pub const CERT_TRUST_PUB_CHECK_TIMESTAMP_REV_FLAG: u32 = 512;
pub const CERT_OCM_SUBCOMPONENTS_LOCAL_MACHINE_REGPATH: &[u8; 73] =
    b"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Setup\\OC Manager\\Subcomponents\0";
pub const CERT_OCM_SUBCOMPONENTS_ROOT_AUTO_UPDATE_VALUE_NAME: &[u8; 15] = b"RootAutoUpdate\0";
pub const CERT_DISABLE_ROOT_AUTO_UPDATE_REGPATH: &[u8; 56] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\\AuthRoot\0";
pub const CERT_DISABLE_ROOT_AUTO_UPDATE_VALUE_NAME: &[u8; 22] = b"DisableRootAutoUpdate\0";
pub const CERT_ENABLE_DISALLOWED_CERT_AUTO_UPDATE_VALUE_NAME: &[u8; 31] =
    b"EnableDisallowedCertAutoUpdate\0";
pub const CERT_DISABLE_PIN_RULES_AUTO_UPDATE_VALUE_NAME: &[u8; 26] = b"DisablePinRulesAutoUpdate\0";
pub const CERT_AUTO_UPDATE_LOCAL_MACHINE_REGPATH: &[u8; 58] =
    b"Software\\Microsoft\\SystemCertificates\\AuthRoot\\AutoUpdate\0";
pub const CERT_AUTO_UPDATE_ROOT_DIR_URL_VALUE_NAME: &[u8; 11] = b"RootDirUrl\0";
pub const CERT_AUTO_UPDATE_SYNC_FROM_DIR_URL_VALUE_NAME: &[u8; 15] = b"SyncFromDirUrl\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_LOCAL_MACHINE_REGPATH: &[u8; 58] =
    b"Software\\Microsoft\\SystemCertificates\\AuthRoot\\AutoUpdate\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_ROOT_DIR_URL_VALUE_NAME: &[u8; 11] = b"RootDirUrl\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_SYNC_DELTA_TIME_VALUE_NAME: &[u8; 14] = b"SyncDeltaTime\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_FLAGS_VALUE_NAME: &[u8; 6] = b"Flags\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_DISABLE_UNTRUSTED_ROOT_LOGGING_FLAG: u32 = 1;
pub const CERT_AUTH_ROOT_AUTO_UPDATE_DISABLE_PARTIAL_CHAIN_LOGGING_FLAG: u32 = 2;
pub const CERT_AUTO_UPDATE_DISABLE_RANDOM_QUERY_STRING_FLAG: u32 = 4;
pub const CERT_AUTH_ROOT_AUTO_UPDATE_LAST_SYNC_TIME_VALUE_NAME: &[u8; 13] = b"LastSyncTime\0";
pub const CERT_AUTH_ROOT_AUTO_UPDATE_ENCODED_CTL_VALUE_NAME: &[u8; 11] = b"EncodedCtl\0";
pub const CERT_AUTH_ROOT_CTL_FILENAME: &[u8; 13] = b"authroot.stl\0";
pub const CERT_AUTH_ROOT_CTL_FILENAME_A: &[u8; 13] = b"authroot.stl\0";
pub const CERT_AUTH_ROOT_CAB_FILENAME: &[u8; 16] = b"authrootstl.cab\0";
pub const CERT_AUTH_ROOT_SEQ_FILENAME: &[u8; 16] = b"authrootseq.txt\0";
pub const CERT_AUTH_ROOT_CERT_EXT: &[u8; 5] = b".crt\0";
pub const CERT_DISALLOWED_CERT_AUTO_UPDATE_SYNC_DELTA_TIME_VALUE_NAME: &[u8; 28] =
    b"DisallowedCertSyncDeltaTime\0";
pub const CERT_DISALLOWED_CERT_AUTO_UPDATE_LAST_SYNC_TIME_VALUE_NAME: &[u8; 27] =
    b"DisallowedCertLastSyncTime\0";
pub const CERT_DISALLOWED_CERT_AUTO_UPDATE_ENCODED_CTL_VALUE_NAME: &[u8; 25] =
    b"DisallowedCertEncodedCtl\0";
pub const CERT_DISALLOWED_CERT_CTL_FILENAME: &[u8; 19] = b"disallowedcert.stl\0";
pub const CERT_DISALLOWED_CERT_CTL_FILENAME_A: &[u8; 19] = b"disallowedcert.stl\0";
pub const CERT_DISALLOWED_CERT_CAB_FILENAME: &[u8; 22] = b"disallowedcertstl.cab\0";
pub const CERT_DISALLOWED_CERT_AUTO_UPDATE_LIST_IDENTIFIER: &[u8; 28] =
    b"DisallowedCert_AutoUpdate_1\0";
pub const CERT_PIN_RULES_AUTO_UPDATE_SYNC_DELTA_TIME_VALUE_NAME: &[u8; 22] =
    b"PinRulesSyncDeltaTime\0";
pub const CERT_PIN_RULES_AUTO_UPDATE_LAST_SYNC_TIME_VALUE_NAME: &[u8; 21] =
    b"PinRulesLastSyncTime\0";
pub const CERT_PIN_RULES_AUTO_UPDATE_ENCODED_CTL_VALUE_NAME: &[u8; 19] = b"PinRulesEncodedCtl\0";
pub const CERT_PIN_RULES_CTL_FILENAME: &[u8; 13] = b"pinrules.stl\0";
pub const CERT_PIN_RULES_CTL_FILENAME_A: &[u8; 13] = b"pinrules.stl\0";
pub const CERT_PIN_RULES_CAB_FILENAME: &[u8; 16] = b"pinrulesstl.cab\0";
pub const CERT_PIN_RULES_AUTO_UPDATE_LIST_IDENTIFIER: &[u8; 22] = b"PinRules_AutoUpdate_1\0";
pub const CERT_REGISTRY_STORE_REMOTE_FLAG: u32 = 65536;
pub const CERT_REGISTRY_STORE_SERIALIZED_FLAG: u32 = 131072;
pub const CERT_REGISTRY_STORE_CLIENT_GPT_FLAG: u32 = 2147483648;
pub const CERT_REGISTRY_STORE_LM_GPT_FLAG: u32 = 16777216;
pub const CERT_REGISTRY_STORE_ROAMING_FLAG: u32 = 262144;
pub const CERT_REGISTRY_STORE_MY_IE_DIRTY_FLAG: u32 = 524288;
pub const CERT_REGISTRY_STORE_EXTERNAL_FLAG: u32 = 1048576;
pub const CERT_IE_DIRTY_FLAGS_REGPATH: &[u8; 45] =
    b"Software\\Microsoft\\Cryptography\\IEDirtyFlags\0";
pub const CERT_FILE_STORE_COMMIT_ENABLE_FLAG: u32 = 65536;
pub const CERT_LDAP_STORE_SIGN_FLAG: u32 = 65536;
pub const CERT_LDAP_STORE_AREC_EXCLUSIVE_FLAG: u32 = 131072;
pub const CERT_LDAP_STORE_OPENED_FLAG: u32 = 262144;
pub const CERT_LDAP_STORE_UNBIND_FLAG: u32 = 524288;
pub const CRYPT_OID_OPEN_STORE_PROV_FUNC: &[u8; 21] = b"CertDllOpenStoreProv\0";
pub const CERT_STORE_PROV_EXTERNAL_FLAG: u32 = 1;
pub const CERT_STORE_PROV_DELETED_FLAG: u32 = 2;
pub const CERT_STORE_PROV_NO_PERSIST_FLAG: u32 = 4;
pub const CERT_STORE_PROV_SYSTEM_STORE_FLAG: u32 = 8;
pub const CERT_STORE_PROV_LM_SYSTEM_STORE_FLAG: u32 = 16;
pub const CERT_STORE_PROV_GP_SYSTEM_STORE_FLAG: u32 = 32;
pub const CERT_STORE_PROV_SHARED_USER_FLAG: u32 = 64;
pub const CERT_STORE_PROV_CLOSE_FUNC: u32 = 0;
pub const CERT_STORE_PROV_READ_CERT_FUNC: u32 = 1;
pub const CERT_STORE_PROV_WRITE_CERT_FUNC: u32 = 2;
pub const CERT_STORE_PROV_DELETE_CERT_FUNC: u32 = 3;
pub const CERT_STORE_PROV_SET_CERT_PROPERTY_FUNC: u32 = 4;
pub const CERT_STORE_PROV_READ_CRL_FUNC: u32 = 5;
pub const CERT_STORE_PROV_WRITE_CRL_FUNC: u32 = 6;
pub const CERT_STORE_PROV_DELETE_CRL_FUNC: u32 = 7;
pub const CERT_STORE_PROV_SET_CRL_PROPERTY_FUNC: u32 = 8;
pub const CERT_STORE_PROV_READ_CTL_FUNC: u32 = 9;
pub const CERT_STORE_PROV_WRITE_CTL_FUNC: u32 = 10;
pub const CERT_STORE_PROV_DELETE_CTL_FUNC: u32 = 11;
pub const CERT_STORE_PROV_SET_CTL_PROPERTY_FUNC: u32 = 12;
pub const CERT_STORE_PROV_CONTROL_FUNC: u32 = 13;
pub const CERT_STORE_PROV_FIND_CERT_FUNC: u32 = 14;
pub const CERT_STORE_PROV_FREE_FIND_CERT_FUNC: u32 = 15;
pub const CERT_STORE_PROV_GET_CERT_PROPERTY_FUNC: u32 = 16;
pub const CERT_STORE_PROV_FIND_CRL_FUNC: u32 = 17;
pub const CERT_STORE_PROV_FREE_FIND_CRL_FUNC: u32 = 18;
pub const CERT_STORE_PROV_GET_CRL_PROPERTY_FUNC: u32 = 19;
pub const CERT_STORE_PROV_FIND_CTL_FUNC: u32 = 20;
pub const CERT_STORE_PROV_FREE_FIND_CTL_FUNC: u32 = 21;
pub const CERT_STORE_PROV_GET_CTL_PROPERTY_FUNC: u32 = 22;
pub const CERT_STORE_PROV_WRITE_ADD_FLAG: u32 = 1;
pub const CERT_STORE_SAVE_AS_STORE: u32 = 1;
pub const CERT_STORE_SAVE_AS_PKCS7: u32 = 2;
pub const CERT_STORE_SAVE_AS_PKCS12: u32 = 3;
pub const CERT_STORE_SAVE_TO_FILE: u32 = 1;
pub const CERT_STORE_SAVE_TO_MEMORY: u32 = 2;
pub const CERT_STORE_SAVE_TO_FILENAME_A: u32 = 3;
pub const CERT_STORE_SAVE_TO_FILENAME_W: u32 = 4;
pub const CERT_STORE_SAVE_TO_FILENAME: u32 = 4;
pub const CERT_CLOSE_STORE_FORCE_FLAG: u32 = 1;
pub const CERT_CLOSE_STORE_CHECK_FLAG: u32 = 2;
pub const CERT_COMPARE_MASK: u32 = 65535;
pub const CERT_COMPARE_SHIFT: u32 = 16;
pub const CERT_COMPARE_ANY: u32 = 0;
pub const CERT_COMPARE_SHA1_HASH: u32 = 1;
pub const CERT_COMPARE_NAME: u32 = 2;
pub const CERT_COMPARE_ATTR: u32 = 3;
pub const CERT_COMPARE_MD5_HASH: u32 = 4;
pub const CERT_COMPARE_PROPERTY: u32 = 5;
pub const CERT_COMPARE_PUBLIC_KEY: u32 = 6;
pub const CERT_COMPARE_HASH: u32 = 1;
pub const CERT_COMPARE_NAME_STR_A: u32 = 7;
pub const CERT_COMPARE_NAME_STR_W: u32 = 8;
pub const CERT_COMPARE_KEY_SPEC: u32 = 9;
pub const CERT_COMPARE_ENHKEY_USAGE: u32 = 10;
pub const CERT_COMPARE_CTL_USAGE: u32 = 10;
pub const CERT_COMPARE_SUBJECT_CERT: u32 = 11;
pub const CERT_COMPARE_ISSUER_OF: u32 = 12;
pub const CERT_COMPARE_EXISTING: u32 = 13;
pub const CERT_COMPARE_SIGNATURE_HASH: u32 = 14;
pub const CERT_COMPARE_KEY_IDENTIFIER: u32 = 15;
pub const CERT_COMPARE_CERT_ID: u32 = 16;
pub const CERT_COMPARE_CROSS_CERT_DIST_POINTS: u32 = 17;
pub const CERT_COMPARE_PUBKEY_MD5_HASH: u32 = 18;
pub const CERT_COMPARE_SUBJECT_INFO_ACCESS: u32 = 19;
pub const CERT_COMPARE_HASH_STR: u32 = 20;
pub const CERT_COMPARE_HAS_PRIVATE_KEY: u32 = 21;
pub const CERT_FIND_ANY: u32 = 0;
pub const CERT_FIND_SHA1_HASH: u32 = 65536;
pub const CERT_FIND_MD5_HASH: u32 = 262144;
pub const CERT_FIND_SIGNATURE_HASH: u32 = 917504;
pub const CERT_FIND_KEY_IDENTIFIER: u32 = 983040;
pub const CERT_FIND_HASH: u32 = 65536;
pub const CERT_FIND_PROPERTY: u32 = 327680;
pub const CERT_FIND_PUBLIC_KEY: u32 = 393216;
pub const CERT_FIND_SUBJECT_NAME: u32 = 131079;
pub const CERT_FIND_SUBJECT_ATTR: u32 = 196615;
pub const CERT_FIND_ISSUER_NAME: u32 = 131076;
pub const CERT_FIND_ISSUER_ATTR: u32 = 196612;
pub const CERT_FIND_SUBJECT_STR_A: u32 = 458759;
pub const CERT_FIND_SUBJECT_STR_W: u32 = 524295;
pub const CERT_FIND_SUBJECT_STR: u32 = 524295;
pub const CERT_FIND_ISSUER_STR_A: u32 = 458756;
pub const CERT_FIND_ISSUER_STR_W: u32 = 524292;
pub const CERT_FIND_ISSUER_STR: u32 = 524292;
pub const CERT_FIND_KEY_SPEC: u32 = 589824;
pub const CERT_FIND_ENHKEY_USAGE: u32 = 655360;
pub const CERT_FIND_CTL_USAGE: u32 = 655360;
pub const CERT_FIND_SUBJECT_CERT: u32 = 720896;
pub const CERT_FIND_ISSUER_OF: u32 = 786432;
pub const CERT_FIND_EXISTING: u32 = 851968;
pub const CERT_FIND_CERT_ID: u32 = 1048576;
pub const CERT_FIND_CROSS_CERT_DIST_POINTS: u32 = 1114112;
pub const CERT_FIND_PUBKEY_MD5_HASH: u32 = 1179648;
pub const CERT_FIND_SUBJECT_INFO_ACCESS: u32 = 1245184;
pub const CERT_FIND_HASH_STR: u32 = 1310720;
pub const CERT_FIND_HAS_PRIVATE_KEY: u32 = 1376256;
pub const CERT_FIND_OPTIONAL_ENHKEY_USAGE_FLAG: u32 = 1;
pub const CERT_FIND_EXT_ONLY_ENHKEY_USAGE_FLAG: u32 = 2;
pub const CERT_FIND_PROP_ONLY_ENHKEY_USAGE_FLAG: u32 = 4;
pub const CERT_FIND_NO_ENHKEY_USAGE_FLAG: u32 = 8;
pub const CERT_FIND_OR_ENHKEY_USAGE_FLAG: u32 = 16;
pub const CERT_FIND_VALID_ENHKEY_USAGE_FLAG: u32 = 32;
pub const CERT_FIND_OPTIONAL_CTL_USAGE_FLAG: u32 = 1;
pub const CERT_FIND_EXT_ONLY_CTL_USAGE_FLAG: u32 = 2;
pub const CERT_FIND_PROP_ONLY_CTL_USAGE_FLAG: u32 = 4;
pub const CERT_FIND_NO_CTL_USAGE_FLAG: u32 = 8;
pub const CERT_FIND_OR_CTL_USAGE_FLAG: u32 = 16;
pub const CERT_FIND_VALID_CTL_USAGE_FLAG: u32 = 32;
pub const CERT_SET_PROPERTY_IGNORE_PERSIST_ERROR_FLAG: u32 = 2147483648;
pub const CERT_SET_PROPERTY_INHIBIT_PERSIST_FLAG: u32 = 1073741824;
pub const CTL_ENTRY_FROM_PROP_CHAIN_FLAG: u32 = 1;
pub const CRL_FIND_ANY: u32 = 0;
pub const CRL_FIND_ISSUED_BY: u32 = 1;
pub const CRL_FIND_EXISTING: u32 = 2;
pub const CRL_FIND_ISSUED_FOR: u32 = 3;
pub const CRL_FIND_ISSUED_BY_AKI_FLAG: u32 = 1;
pub const CRL_FIND_ISSUED_BY_SIGNATURE_FLAG: u32 = 2;
pub const CRL_FIND_ISSUED_BY_DELTA_FLAG: u32 = 4;
pub const CRL_FIND_ISSUED_BY_BASE_FLAG: u32 = 8;
pub const CRL_FIND_ISSUED_FOR_SET_STRONG_PROPERTIES_FLAG: u32 = 16;
pub const CERT_STORE_ADD_NEW: u32 = 1;
pub const CERT_STORE_ADD_USE_EXISTING: u32 = 2;
pub const CERT_STORE_ADD_REPLACE_EXISTING: u32 = 3;
pub const CERT_STORE_ADD_ALWAYS: u32 = 4;
pub const CERT_STORE_ADD_REPLACE_EXISTING_INHERIT_PROPERTIES: u32 = 5;
pub const CERT_STORE_ADD_NEWER: u32 = 6;
pub const CERT_STORE_ADD_NEWER_INHERIT_PROPERTIES: u32 = 7;
pub const CERT_STORE_CERTIFICATE_CONTEXT: u32 = 1;
pub const CERT_STORE_CRL_CONTEXT: u32 = 2;
pub const CERT_STORE_CTL_CONTEXT: u32 = 3;
pub const CERT_STORE_ALL_CONTEXT_FLAG: i32 = -1;
pub const CERT_STORE_CERTIFICATE_CONTEXT_FLAG: u32 = 2;
pub const CERT_STORE_CRL_CONTEXT_FLAG: u32 = 4;
pub const CERT_STORE_CTL_CONTEXT_FLAG: u32 = 8;
pub const CTL_ANY_SUBJECT_TYPE: u32 = 1;
pub const CTL_CERT_SUBJECT_TYPE: u32 = 2;
pub const CTL_FIND_ANY: u32 = 0;
pub const CTL_FIND_SHA1_HASH: u32 = 1;
pub const CTL_FIND_MD5_HASH: u32 = 2;
pub const CTL_FIND_USAGE: u32 = 3;
pub const CTL_FIND_SUBJECT: u32 = 4;
pub const CTL_FIND_EXISTING: u32 = 5;
pub const CTL_FIND_NO_LIST_ID_CBDATA: u32 = 4294967295;
pub const CTL_FIND_SAME_USAGE_FLAG: u32 = 1;
pub const CERT_STORE_CTRL_RESYNC: u32 = 1;
pub const CERT_STORE_CTRL_NOTIFY_CHANGE: u32 = 2;
pub const CERT_STORE_CTRL_COMMIT: u32 = 3;
pub const CERT_STORE_CTRL_AUTO_RESYNC: u32 = 4;
pub const CERT_STORE_CTRL_CANCEL_NOTIFY: u32 = 5;
pub const CERT_STORE_CTRL_INHIBIT_DUPLICATE_HANDLE_FLAG: u32 = 1;
pub const CERT_STORE_CTRL_COMMIT_FORCE_FLAG: u32 = 1;
pub const CERT_STORE_CTRL_COMMIT_CLEAR_FLAG: u32 = 2;
pub const CERT_STORE_LOCALIZED_NAME_PROP_ID: u32 = 4096;
pub const CERT_CREATE_CONTEXT_NOCOPY_FLAG: u32 = 1;
pub const CERT_CREATE_CONTEXT_SORTED_FLAG: u32 = 2;
pub const CERT_CREATE_CONTEXT_NO_HCRYPTMSG_FLAG: u32 = 4;
pub const CERT_CREATE_CONTEXT_NO_ENTRY_FLAG: u32 = 8;
pub const CERT_PHYSICAL_STORE_ADD_ENABLE_FLAG: u32 = 1;
pub const CERT_PHYSICAL_STORE_OPEN_DISABLE_FLAG: u32 = 2;
pub const CERT_PHYSICAL_STORE_REMOTE_OPEN_DISABLE_FLAG: u32 = 4;
pub const CERT_PHYSICAL_STORE_INSERT_COMPUTER_NAME_ENABLE_FLAG: u32 = 8;
pub const CERT_PHYSICAL_STORE_PREDEFINED_ENUM_FLAG: u32 = 1;
pub const CERT_PHYSICAL_STORE_DEFAULT_NAME: &[u8; 9] = b".Default\0";
pub const CERT_PHYSICAL_STORE_GROUP_POLICY_NAME: &[u8; 13] = b".GroupPolicy\0";
pub const CERT_PHYSICAL_STORE_LOCAL_MACHINE_NAME: &[u8; 14] = b".LocalMachine\0";
pub const CERT_PHYSICAL_STORE_DS_USER_CERTIFICATE_NAME: &[u8; 17] = b".UserCertificate\0";
pub const CERT_PHYSICAL_STORE_LOCAL_MACHINE_GROUP_POLICY_NAME: &[u8; 25] =
    b".LocalMachineGroupPolicy\0";
pub const CERT_PHYSICAL_STORE_ENTERPRISE_NAME: &[u8; 12] = b".Enterprise\0";
pub const CERT_PHYSICAL_STORE_AUTH_ROOT_NAME: &[u8; 10] = b".AuthRoot\0";
pub const CERT_PHYSICAL_STORE_SMART_CARD_NAME: &[u8; 11] = b".SmartCard\0";
pub const CRYPT_OID_OPEN_SYSTEM_STORE_PROV_FUNC: &[u8; 27] = b"CertDllOpenSystemStoreProv\0";
pub const CRYPT_OID_REGISTER_SYSTEM_STORE_FUNC: &[u8; 27] = b"CertDllRegisterSystemStore\0";
pub const CRYPT_OID_UNREGISTER_SYSTEM_STORE_FUNC: &[u8; 29] = b"CertDllUnregisterSystemStore\0";
pub const CRYPT_OID_ENUM_SYSTEM_STORE_FUNC: &[u8; 23] = b"CertDllEnumSystemStore\0";
pub const CRYPT_OID_REGISTER_PHYSICAL_STORE_FUNC: &[u8; 29] = b"CertDllRegisterPhysicalStore\0";
pub const CRYPT_OID_UNREGISTER_PHYSICAL_STORE_FUNC: &[u8; 31] = b"CertDllUnregisterPhysicalStore\0";
pub const CRYPT_OID_ENUM_PHYSICAL_STORE_FUNC: &[u8; 25] = b"CertDllEnumPhysicalStore\0";
pub const CRYPT_OID_SYSTEM_STORE_LOCATION_VALUE_NAME: &[u8; 20] = b"SystemStoreLocation\0";
pub const CMSG_TRUSTED_SIGNER_FLAG: u32 = 1;
pub const CMSG_SIGNER_ONLY_FLAG: u32 = 2;
pub const CMSG_USE_SIGNER_INDEX_FLAG: u32 = 4;
pub const CMSG_CMS_ENCAPSULATED_CTL_FLAG: u32 = 32768;
pub const CMSG_ENCODE_SORTED_CTL_FLAG: u32 = 1;
pub const CMSG_ENCODE_HASHED_SUBJECT_IDENTIFIER_FLAG: u32 = 2;
pub const CERT_VERIFY_INHIBIT_CTL_UPDATE_FLAG: u32 = 1;
pub const CERT_VERIFY_TRUSTED_SIGNERS_FLAG: u32 = 2;
pub const CERT_VERIFY_NO_TIME_CHECK_FLAG: u32 = 4;
pub const CERT_VERIFY_ALLOW_MORE_USAGE_FLAG: u32 = 8;
pub const CERT_VERIFY_UPDATED_CTL_FLAG: u32 = 1;
pub const CERT_CONTEXT_REVOCATION_TYPE: u32 = 1;
pub const CERT_VERIFY_REV_CHAIN_FLAG: u32 = 1;
pub const CERT_VERIFY_CACHE_ONLY_BASED_REVOCATION: u32 = 2;
pub const CERT_VERIFY_REV_ACCUMULATIVE_TIMEOUT_FLAG: u32 = 4;
pub const CERT_VERIFY_REV_SERVER_OCSP_FLAG: u32 = 8;
pub const CERT_VERIFY_REV_NO_OCSP_FAILOVER_TO_CRL_FLAG: u32 = 16;
pub const CERT_VERIFY_REV_SERVER_OCSP_WIRE_ONLY_FLAG: u32 = 32;
pub const CERT_UNICODE_IS_RDN_ATTRS_FLAG: u32 = 1;
pub const CERT_CASE_INSENSITIVE_IS_RDN_ATTRS_FLAG: u32 = 2;
pub const CRYPT_VERIFY_CERT_SIGN_SUBJECT_BLOB: u32 = 1;
pub const CRYPT_VERIFY_CERT_SIGN_SUBJECT_CERT: u32 = 2;
pub const CRYPT_VERIFY_CERT_SIGN_SUBJECT_CRL: u32 = 3;
pub const CRYPT_VERIFY_CERT_SIGN_SUBJECT_OCSP_BASIC_SIGNED_RESPONSE: u32 = 4;
pub const CRYPT_VERIFY_CERT_SIGN_ISSUER_PUBKEY: u32 = 1;
pub const CRYPT_VERIFY_CERT_SIGN_ISSUER_CERT: u32 = 2;
pub const CRYPT_VERIFY_CERT_SIGN_ISSUER_CHAIN: u32 = 3;
pub const CRYPT_VERIFY_CERT_SIGN_ISSUER_NULL: u32 = 4;
pub const CRYPT_VERIFY_CERT_SIGN_DISABLE_MD2_MD4_FLAG: u32 = 1;
pub const CRYPT_VERIFY_CERT_SIGN_SET_STRONG_PROPERTIES_FLAG: u32 = 2;
pub const CRYPT_VERIFY_CERT_SIGN_RETURN_STRONG_PROPERTIES_FLAG: u32 = 4;
pub const CRYPT_VERIFY_CERT_SIGN_CHECK_WEAK_HASH_FLAG: u32 = 8;
pub const CRYPT_OID_EXTRACT_ENCODED_SIGNATURE_PARAMETERS_FUNC: &[u8; 42] =
    b"CryptDllExtractEncodedSignatureParameters\0";
pub const CRYPT_OID_SIGN_AND_ENCODE_HASH_FUNC: &[u8; 26] = b"CryptDllSignAndEncodeHash\0";
pub const CRYPT_OID_VERIFY_ENCODED_SIGNATURE_FUNC: &[u8; 31] = b"CryptDllVerifyEncodedSignature\0";
pub const CRYPT_DEFAULT_CONTEXT_AUTO_RELEASE_FLAG: u32 = 1;
pub const CRYPT_DEFAULT_CONTEXT_PROCESS_FLAG: u32 = 2;
pub const CRYPT_DEFAULT_CONTEXT_CERT_SIGN_OID: u32 = 1;
pub const CRYPT_DEFAULT_CONTEXT_MULTI_CERT_SIGN_OID: u32 = 2;
pub const CRYPT_OID_EXPORT_PUBLIC_KEY_INFO_FUNC: &[u8; 30] = b"CryptDllExportPublicKeyInfoEx\0";
pub const CRYPT_OID_EXPORT_PUBLIC_KEY_INFO_EX2_FUNC: &[u8; 31] =
    b"CryptDllExportPublicKeyInfoEx2\0";
pub const CRYPT_OID_EXPORT_PUBLIC_KEY_INFO_FROM_BCRYPT_HANDLE_FUNC: &[u8; 47] =
    b"CryptDllExportPublicKeyInfoFromBCryptKeyHandle\0";
pub const CRYPT_OID_IMPORT_PUBLIC_KEY_INFO_FUNC: &[u8; 30] = b"CryptDllImportPublicKeyInfoEx\0";
pub const CRYPT_OID_IMPORT_PUBLIC_KEY_INFO_EX2_FUNC: &[u8; 31] =
    b"CryptDllImportPublicKeyInfoEx2\0";
pub const CRYPT_ACQUIRE_CACHE_FLAG: u32 = 1;
pub const CRYPT_ACQUIRE_USE_PROV_INFO_FLAG: u32 = 2;
pub const CRYPT_ACQUIRE_COMPARE_KEY_FLAG: u32 = 4;
pub const CRYPT_ACQUIRE_NO_HEALING: u32 = 8;
pub const CRYPT_ACQUIRE_SILENT_FLAG: u32 = 64;
pub const CRYPT_ACQUIRE_WINDOW_HANDLE_FLAG: u32 = 128;
pub const CRYPT_ACQUIRE_NCRYPT_KEY_FLAGS_MASK: u32 = 458752;
pub const CRYPT_ACQUIRE_ALLOW_NCRYPT_KEY_FLAG: u32 = 65536;
pub const CRYPT_ACQUIRE_PREFER_NCRYPT_KEY_FLAG: u32 = 131072;
pub const CRYPT_ACQUIRE_ONLY_NCRYPT_KEY_FLAG: u32 = 262144;
pub const CRYPT_FIND_USER_KEYSET_FLAG: u32 = 1;
pub const CRYPT_FIND_MACHINE_KEYSET_FLAG: u32 = 2;
pub const CRYPT_FIND_SILENT_KEYSET_FLAG: u32 = 64;
pub const CRYPT_OID_IMPORT_PRIVATE_KEY_INFO_FUNC: &[u8; 31] = b"CryptDllImportPrivateKeyInfoEx\0";
pub const CRYPT_OID_EXPORT_PRIVATE_KEY_INFO_FUNC: &[u8; 31] = b"CryptDllExportPrivateKeyInfoEx\0";
pub const CRYPT_DELETE_KEYSET: u32 = 16;
pub const CERT_SIMPLE_NAME_STR: u32 = 1;
pub const CERT_OID_NAME_STR: u32 = 2;
pub const CERT_X500_NAME_STR: u32 = 3;
pub const CERT_XML_NAME_STR: u32 = 4;
pub const CERT_NAME_STR_SEMICOLON_FLAG: u32 = 1073741824;
pub const CERT_NAME_STR_NO_PLUS_FLAG: u32 = 536870912;
pub const CERT_NAME_STR_NO_QUOTING_FLAG: u32 = 268435456;
pub const CERT_NAME_STR_CRLF_FLAG: u32 = 134217728;
pub const CERT_NAME_STR_COMMA_FLAG: u32 = 67108864;
pub const CERT_NAME_STR_REVERSE_FLAG: u32 = 33554432;
pub const CERT_NAME_STR_FORWARD_FLAG: u32 = 16777216;
pub const CERT_NAME_STR_DISABLE_IE4_UTF8_FLAG: u32 = 65536;
pub const CERT_NAME_STR_ENABLE_T61_UNICODE_FLAG: u32 = 131072;
pub const CERT_NAME_STR_ENABLE_UTF8_UNICODE_FLAG: u32 = 262144;
pub const CERT_NAME_STR_FORCE_UTF8_DIR_STR_FLAG: u32 = 524288;
pub const CERT_NAME_STR_DISABLE_UTF8_DIR_STR_FLAG: u32 = 1048576;
pub const CERT_NAME_STR_ENABLE_PUNYCODE_FLAG: u32 = 2097152;
pub const CERT_NAME_EMAIL_TYPE: u32 = 1;
pub const CERT_NAME_RDN_TYPE: u32 = 2;
pub const CERT_NAME_ATTR_TYPE: u32 = 3;
pub const CERT_NAME_SIMPLE_DISPLAY_TYPE: u32 = 4;
pub const CERT_NAME_FRIENDLY_DISPLAY_TYPE: u32 = 5;
pub const CERT_NAME_DNS_TYPE: u32 = 6;
pub const CERT_NAME_URL_TYPE: u32 = 7;
pub const CERT_NAME_UPN_TYPE: u32 = 8;
pub const CERT_NAME_ISSUER_FLAG: u32 = 1;
pub const CERT_NAME_DISABLE_IE4_UTF8_FLAG: u32 = 65536;
pub const CERT_NAME_SEARCH_ALL_NAMES_FLAG: u32 = 2;
pub const CRYPT_MESSAGE_BARE_CONTENT_OUT_FLAG: u32 = 1;
pub const CRYPT_MESSAGE_ENCAPSULATED_CONTENT_OUT_FLAG: u32 = 2;
pub const CRYPT_MESSAGE_KEYID_SIGNER_FLAG: u32 = 4;
pub const CRYPT_MESSAGE_SILENT_KEYSET_FLAG: u32 = 64;
pub const CRYPT_MESSAGE_KEYID_RECIPIENT_FLAG: u32 = 4;
pub const CERT_QUERY_OBJECT_FILE: u32 = 1;
pub const CERT_QUERY_OBJECT_BLOB: u32 = 2;
pub const CERT_QUERY_CONTENT_CERT: u32 = 1;
pub const CERT_QUERY_CONTENT_CTL: u32 = 2;
pub const CERT_QUERY_CONTENT_CRL: u32 = 3;
pub const CERT_QUERY_CONTENT_SERIALIZED_STORE: u32 = 4;
pub const CERT_QUERY_CONTENT_SERIALIZED_CERT: u32 = 5;
pub const CERT_QUERY_CONTENT_SERIALIZED_CTL: u32 = 6;
pub const CERT_QUERY_CONTENT_SERIALIZED_CRL: u32 = 7;
pub const CERT_QUERY_CONTENT_PKCS7_SIGNED: u32 = 8;
pub const CERT_QUERY_CONTENT_PKCS7_UNSIGNED: u32 = 9;
pub const CERT_QUERY_CONTENT_PKCS7_SIGNED_EMBED: u32 = 10;
pub const CERT_QUERY_CONTENT_PKCS10: u32 = 11;
pub const CERT_QUERY_CONTENT_PFX: u32 = 12;
pub const CERT_QUERY_CONTENT_CERT_PAIR: u32 = 13;
pub const CERT_QUERY_CONTENT_PFX_AND_LOAD: u32 = 14;
pub const CERT_QUERY_CONTENT_FLAG_CERT: u32 = 2;
pub const CERT_QUERY_CONTENT_FLAG_CTL: u32 = 4;
pub const CERT_QUERY_CONTENT_FLAG_CRL: u32 = 8;
pub const CERT_QUERY_CONTENT_FLAG_SERIALIZED_STORE: u32 = 16;
pub const CERT_QUERY_CONTENT_FLAG_SERIALIZED_CERT: u32 = 32;
pub const CERT_QUERY_CONTENT_FLAG_SERIALIZED_CTL: u32 = 64;
pub const CERT_QUERY_CONTENT_FLAG_SERIALIZED_CRL: u32 = 128;
pub const CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED: u32 = 256;
pub const CERT_QUERY_CONTENT_FLAG_PKCS7_UNSIGNED: u32 = 512;
pub const CERT_QUERY_CONTENT_FLAG_PKCS7_SIGNED_EMBED: u32 = 1024;
pub const CERT_QUERY_CONTENT_FLAG_PKCS10: u32 = 2048;
pub const CERT_QUERY_CONTENT_FLAG_PFX: u32 = 4096;
pub const CERT_QUERY_CONTENT_FLAG_CERT_PAIR: u32 = 8192;
pub const CERT_QUERY_CONTENT_FLAG_PFX_AND_LOAD: u32 = 16384;
pub const CERT_QUERY_CONTENT_FLAG_ALL: u32 = 16382;
pub const CERT_QUERY_CONTENT_FLAG_ALL_ISSUER_CERT: u32 = 818;
pub const CERT_QUERY_FORMAT_BINARY: u32 = 1;
pub const CERT_QUERY_FORMAT_BASE64_ENCODED: u32 = 2;
pub const CERT_QUERY_FORMAT_ASN_ASCII_HEX_ENCODED: u32 = 3;
pub const CERT_QUERY_FORMAT_FLAG_BINARY: u32 = 2;
pub const CERT_QUERY_FORMAT_FLAG_BASE64_ENCODED: u32 = 4;
pub const CERT_QUERY_FORMAT_FLAG_ASN_ASCII_HEX_ENCODED: u32 = 8;
pub const CERT_QUERY_FORMAT_FLAG_ALL: u32 = 14;
pub const SCHEME_OID_RETRIEVE_ENCODED_OBJECT_FUNC: &[u8; 31] = b"SchemeDllRetrieveEncodedObject\0";
pub const SCHEME_OID_RETRIEVE_ENCODED_OBJECTW_FUNC: &[u8; 32] =
    b"SchemeDllRetrieveEncodedObjectW\0";
pub const CONTEXT_OID_CREATE_OBJECT_CONTEXT_FUNC: &[u8; 30] = b"ContextDllCreateObjectContext\0";
pub const CRYPT_RETRIEVE_MULTIPLE_OBJECTS: u32 = 1;
pub const CRYPT_CACHE_ONLY_RETRIEVAL: u32 = 2;
pub const CRYPT_WIRE_ONLY_RETRIEVAL: u32 = 4;
pub const CRYPT_DONT_CACHE_RESULT: u32 = 8;
pub const CRYPT_ASYNC_RETRIEVAL: u32 = 16;
pub const CRYPT_STICKY_CACHE_RETRIEVAL: u32 = 4096;
pub const CRYPT_LDAP_SCOPE_BASE_ONLY_RETRIEVAL: u32 = 8192;
pub const CRYPT_OFFLINE_CHECK_RETRIEVAL: u32 = 16384;
pub const CRYPT_LDAP_INSERT_ENTRY_ATTRIBUTE: u32 = 32768;
pub const CRYPT_LDAP_SIGN_RETRIEVAL: u32 = 65536;
pub const CRYPT_NO_AUTH_RETRIEVAL: u32 = 131072;
pub const CRYPT_LDAP_AREC_EXCLUSIVE_RETRIEVAL: u32 = 262144;
pub const CRYPT_AIA_RETRIEVAL: u32 = 524288;
pub const CRYPT_HTTP_POST_RETRIEVAL: u32 = 1048576;
pub const CRYPT_PROXY_CACHE_RETRIEVAL: u32 = 2097152;
pub const CRYPT_NOT_MODIFIED_RETRIEVAL: u32 = 4194304;
pub const CRYPT_ENABLE_SSL_REVOCATION_RETRIEVAL: u32 = 8388608;
pub const CRYPT_RANDOM_QUERY_STRING_RETRIEVAL: u32 = 67108864;
pub const CRYPT_ENABLE_FILE_RETRIEVAL: u32 = 134217728;
pub const CRYPT_CREATE_NEW_FLUSH_ENTRY: u32 = 268435456;
pub const CRYPT_VERIFY_CONTEXT_SIGNATURE: u32 = 32;
pub const CRYPT_VERIFY_DATA_HASH: u32 = 64;
pub const CRYPT_KEEP_TIME_VALID: u32 = 128;
pub const CRYPT_DONT_VERIFY_SIGNATURE: u32 = 256;
pub const CRYPT_DONT_CHECK_TIME_VALIDITY: u32 = 512;
pub const CRYPT_CHECK_FRESHNESS_TIME_VALIDITY: u32 = 1024;
pub const CRYPT_ACCUMULATIVE_TIMEOUT: u32 = 2048;
pub const CRYPT_OCSP_ONLY_RETRIEVAL: u32 = 16777216;
pub const CRYPT_NO_OCSP_FAILOVER_TO_CRL_RETRIEVAL: u32 = 33554432;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_NONE: u32 = 0;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_BLOB: u32 = 1;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_CRL: u32 = 2;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_OCSP: u32 = 3;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_AUTOROOT_CAB: u32 = 5;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_DISALLOWED_CERT_CAB: u32 = 6;
pub const CRYPTNET_URL_CACHE_PRE_FETCH_PIN_RULES_CAB: u32 = 7;
pub const CRYPTNET_URL_CACHE_DEFAULT_FLUSH: u32 = 0;
pub const CRYPTNET_URL_CACHE_DISABLE_FLUSH: u32 = 4294967295;
pub const CRYPTNET_URL_CACHE_RESPONSE_NONE: u32 = 0;
pub const CRYPTNET_URL_CACHE_RESPONSE_HTTP: u32 = 1;
pub const CRYPTNET_URL_CACHE_RESPONSE_VALIDATED: u32 = 32768;
pub const CRYPT_RETRIEVE_MAX_ERROR_CONTENT_LENGTH: u32 = 4096;
pub const CRYPT_GET_URL_FROM_PROPERTY: u32 = 1;
pub const CRYPT_GET_URL_FROM_EXTENSION: u32 = 2;
pub const CRYPT_GET_URL_FROM_UNAUTH_ATTRIBUTE: u32 = 4;
pub const CRYPT_GET_URL_FROM_AUTH_ATTRIBUTE: u32 = 8;
pub const URL_OID_GET_OBJECT_URL_FUNC: &[u8; 19] = b"UrlDllGetObjectUrl\0";
pub const TIME_VALID_OID_GET_OBJECT_FUNC: &[u8; 22] = b"TimeValidDllGetObject\0";
pub const TIME_VALID_OID_FLUSH_OBJECT_FUNC: &[u8; 24] = b"TimeValidDllFlushObject\0";
pub const CERT_CREATE_SELFSIGN_NO_SIGN: u32 = 1;
pub const CERT_CREATE_SELFSIGN_NO_KEY_INFO: u32 = 2;
pub const CRYPT_KEYID_MACHINE_FLAG: u32 = 32;
pub const CRYPT_KEYID_ALLOC_FLAG: u32 = 32768;
pub const CRYPT_KEYID_DELETE_FLAG: u32 = 16;
pub const CRYPT_KEYID_SET_NEW_FLAG: u32 = 8192;
pub const CERT_CHAIN_CONFIG_REGPATH : & [u8 ; 94] = b"Software\\Microsoft\\Cryptography\\OID\\EncodingType 0\\CertDllCreateCertificateChainEngine\\Config\0" ;
pub const CERT_CHAIN_MAX_URL_RETRIEVAL_BYTE_COUNT_VALUE_NAME: &[u8; 25] =
    b"MaxUrlRetrievalByteCount\0";
pub const CERT_CHAIN_MAX_URL_RETRIEVAL_BYTE_COUNT_DEFAULT: u32 = 104857600;
pub const CERT_CHAIN_CACHE_RESYNC_FILETIME_VALUE_NAME: &[u8; 25] = b"ChainCacheResyncFiletime\0";
pub const CERT_CHAIN_DISABLE_MANDATORY_BASIC_CONSTRAINTS_VALUE_NAME: &[u8; 33] =
    b"DisableMandatoryBasicConstraints\0";
pub const CERT_CHAIN_DISABLE_CA_NAME_CONSTRAINTS_VALUE_NAME: &[u8; 25] =
    b"DisableCANameConstraints\0";
pub const CERT_CHAIN_DISABLE_UNSUPPORTED_CRITICAL_EXTENSIONS_VALUE_NAME: &[u8; 37] =
    b"DisableUnsupportedCriticalExtensions\0";
pub const CERT_CHAIN_MAX_AIA_URL_COUNT_IN_CERT_VALUE_NAME: &[u8; 21] = b"MaxAIAUrlCountInCert\0";
pub const CERT_CHAIN_MAX_AIA_URL_COUNT_IN_CERT_DEFAULT: u32 = 5;
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_COUNT_PER_CHAIN_VALUE_NAME: &[u8; 32] =
    b"MaxAIAUrlRetrievalCountPerChain\0";
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_COUNT_PER_CHAIN_DEFAULT: u32 = 3;
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_BYTE_COUNT_VALUE_NAME: &[u8; 28] =
    b"MaxAIAUrlRetrievalByteCount\0";
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_BYTE_COUNT_DEFAULT: u32 = 100000;
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_CERT_COUNT_VALUE_NAME: &[u8; 28] =
    b"MaxAIAUrlRetrievalCertCount\0";
pub const CERT_CHAIN_MAX_AIA_URL_RETRIEVAL_CERT_COUNT_DEFAULT: u32 = 10;
pub const CERT_CHAIN_OCSP_VALIDITY_SECONDS_VALUE_NAME: &[u8; 20] = b"OcspValiditySeconds\0";
pub const CERT_CHAIN_OCSP_VALIDITY_SECONDS_DEFAULT: u32 = 43200;
pub const CERT_CHAIN_DISABLE_SERIAL_CHAIN_VALUE_NAME: &[u8; 19] = b"DisableSerialChain\0";
pub const CERT_CHAIN_SERIAL_CHAIN_LOG_FILE_NAME_VALUE_NAME: &[u8; 23] = b"SerialChainLogFileName\0";
pub const CERT_CHAIN_DISABLE_SYNC_WITH_SSL_TIME_VALUE_NAME: &[u8; 23] = b"DisableSyncWithSslTime\0";
pub const CERT_CHAIN_MAX_SSL_TIME_UPDATED_EVENT_COUNT_VALUE_NAME: &[u8; 28] =
    b"MaxSslTimeUpdatedEventCount\0";
pub const CERT_CHAIN_MAX_SSL_TIME_UPDATED_EVENT_COUNT_DEFAULT: u32 = 5;
pub const CERT_CHAIN_MAX_SSL_TIME_UPDATED_EVENT_COUNT_DISABLE: u32 = 4294967295;
pub const CERT_CHAIN_SSL_HANDSHAKE_LOG_FILE_NAME_VALUE_NAME: &[u8; 24] =
    b"SslHandshakeLogFileName\0";
pub const CERT_CHAIN_ENABLE_WEAK_SIGNATURE_FLAGS_VALUE_NAME: &[u8; 25] =
    b"EnableWeakSignatureFlags\0";
pub const CERT_CHAIN_ENABLE_MD2_MD4_FLAG: u32 = 1;
pub const CERT_CHAIN_ENABLE_WEAK_RSA_ROOT_FLAG: u32 = 2;
pub const CERT_CHAIN_ENABLE_WEAK_LOGGING_FLAG: u32 = 4;
pub const CERT_CHAIN_ENABLE_ONLY_WEAK_LOGGING_FLAG: u32 = 8;
pub const CERT_CHAIN_MIN_RSA_PUB_KEY_BIT_LENGTH_VALUE_NAME: &[u8; 22] = b"MinRsaPubKeyBitLength\0";
pub const CERT_CHAIN_MIN_RSA_PUB_KEY_BIT_LENGTH_DEFAULT: u32 = 1023;
pub const CERT_CHAIN_MIN_RSA_PUB_KEY_BIT_LENGTH_DISABLE: u32 = 4294967295;
pub const CERT_CHAIN_WEAK_RSA_PUB_KEY_TIME_VALUE_NAME: &[u8; 18] = b"WeakRsaPubKeyTime\0";
pub const CERT_CHAIN_WEAK_SIGNATURE_LOG_DIR_VALUE_NAME: &[u8; 20] = b"WeakSignatureLogDir\0";
pub const CERT_CHAIN_DEFAULT_CONFIG_SUBDIR: &[u8; 8] = b"Default\0";
pub const CERT_CHAIN_WEAK_PREFIX_NAME: &[u8; 5] = b"Weak\0";
pub const CERT_CHAIN_WEAK_THIRD_PARTY_CONFIG_NAME: &[u8; 11] = b"ThirdParty\0";
pub const CERT_CHAIN_WEAK_ALL_CONFIG_NAME: &[u8; 4] = b"All\0";
pub const CERT_CHAIN_WEAK_FLAGS_NAME: &[u8; 6] = b"Flags\0";
pub const CERT_CHAIN_WEAK_HYGIENE_NAME: &[u8; 8] = b"Hygiene\0";
pub const CERT_CHAIN_WEAK_AFTER_TIME_NAME: &[u8; 10] = b"AfterTime\0";
pub const CERT_CHAIN_WEAK_FILE_HASH_AFTER_TIME_NAME: &[u8; 18] = b"FileHashAfterTime\0";
pub const CERT_CHAIN_WEAK_TIMESTAMP_HASH_AFTER_TIME_NAME: &[u8; 23] = b"TimestampHashAfterTime\0";
pub const CERT_CHAIN_WEAK_MIN_BIT_LENGTH_NAME: &[u8; 13] = b"MinBitLength\0";
pub const CERT_CHAIN_WEAK_SHA256_ALLOW_NAME: &[u8; 12] = b"Sha256Allow\0";
pub const CERT_CHAIN_MIN_PUB_KEY_BIT_LENGTH_DISABLE: u32 = 4294967295;
pub const CERT_CHAIN_ENABLE_WEAK_SETTINGS_FLAG: u32 = 2147483648;
pub const CERT_CHAIN_DISABLE_ECC_PARA_FLAG: u32 = 16;
pub const CERT_CHAIN_DISABLE_ALL_EKU_WEAK_FLAG: u32 = 65536;
pub const CERT_CHAIN_ENABLE_ALL_EKU_HYGIENE_FLAG: u32 = 131072;
pub const CERT_CHAIN_DISABLE_OPT_IN_SERVER_AUTH_WEAK_FLAG: u32 = 262144;
pub const CERT_CHAIN_DISABLE_SERVER_AUTH_WEAK_FLAG: u32 = 1048576;
pub const CERT_CHAIN_ENABLE_SERVER_AUTH_HYGIENE_FLAG: u32 = 2097152;
pub const CERT_CHAIN_DISABLE_CODE_SIGNING_WEAK_FLAG: u32 = 4194304;
pub const CERT_CHAIN_DISABLE_MOTW_CODE_SIGNING_WEAK_FLAG: u32 = 8388608;
pub const CERT_CHAIN_ENABLE_CODE_SIGNING_HYGIENE_FLAG: u32 = 16777216;
pub const CERT_CHAIN_ENABLE_MOTW_CODE_SIGNING_HYGIENE_FLAG: u32 = 33554432;
pub const CERT_CHAIN_DISABLE_TIMESTAMP_WEAK_FLAG: u32 = 67108864;
pub const CERT_CHAIN_DISABLE_MOTW_TIMESTAMP_WEAK_FLAG: u32 = 134217728;
pub const CERT_CHAIN_ENABLE_TIMESTAMP_HYGIENE_FLAG: u32 = 268435456;
pub const CERT_CHAIN_ENABLE_MOTW_TIMESTAMP_HYGIENE_FLAG: u32 = 536870912;
pub const CERT_CHAIN_MOTW_IGNORE_AFTER_TIME_WEAK_FLAG: u32 = 1073741824;
pub const CERT_CHAIN_DISABLE_FILE_HASH_WEAK_FLAG: u32 = 4096;
pub const CERT_CHAIN_DISABLE_MOTW_FILE_HASH_WEAK_FLAG: u32 = 8192;
pub const CERT_CHAIN_DISABLE_TIMESTAMP_HASH_WEAK_FLAG: u32 = 16384;
pub const CERT_CHAIN_DISABLE_MOTW_TIMESTAMP_HASH_WEAK_FLAG: u32 = 32768;
pub const CERT_CHAIN_DISABLE_WEAK_FLAGS: u32 = 215285776;
pub const CERT_CHAIN_DISABLE_FILE_HASH_WEAK_FLAGS: u32 = 12288;
pub const CERT_CHAIN_DISABLE_TIMESTAMP_HASH_WEAK_FLAGS: u32 = 49152;
pub const CERT_CHAIN_ENABLE_HYGIENE_FLAGS: u32 = 857866240;
pub const CERT_CHAIN_MOTW_WEAK_FLAGS: u32 = 1786773504;
pub const CERT_CHAIN_OPT_IN_WEAK_FLAGS: u32 = 262144;
pub const CERT_CHAIN_AUTO_CURRENT_USER: u32 = 1;
pub const CERT_CHAIN_AUTO_LOCAL_MACHINE: u32 = 2;
pub const CERT_CHAIN_AUTO_IMPERSONATED: u32 = 3;
pub const CERT_CHAIN_AUTO_PROCESS_INFO: u32 = 4;
pub const CERT_CHAIN_AUTO_PINRULE_INFO: u32 = 5;
pub const CERT_CHAIN_AUTO_NETWORK_INFO: u32 = 6;
pub const CERT_CHAIN_AUTO_SERIAL_LOCAL_MACHINE: u32 = 7;
pub const CERT_CHAIN_AUTO_HPKP_RULE_INFO: u32 = 8;
pub const CERT_CHAIN_AUTO_FLAGS_VALUE_NAME: &[u8; 10] = b"AutoFlags\0";
pub const CERT_CHAIN_AUTO_FLUSH_DISABLE_FLAG: u32 = 1;
pub const CERT_CHAIN_AUTO_LOG_CREATE_FLAG: u32 = 2;
pub const CERT_CHAIN_AUTO_LOG_FREE_FLAG: u32 = 4;
pub const CERT_CHAIN_AUTO_LOG_FLUSH_FLAG: u32 = 8;
pub const CERT_CHAIN_AUTO_LOG_FLAGS: u32 = 14;
pub const CERT_CHAIN_AUTO_FLUSH_FIRST_DELTA_SECONDS_VALUE_NAME: &[u8; 27] =
    b"AutoFlushFirstDeltaSeconds\0";
pub const CERT_CHAIN_AUTO_FLUSH_FIRST_DELTA_SECONDS_DEFAULT: u32 = 300;
pub const CERT_CHAIN_AUTO_FLUSH_NEXT_DELTA_SECONDS_VALUE_NAME: &[u8; 26] =
    b"AutoFlushNextDeltaSeconds\0";
pub const CERT_CHAIN_AUTO_FLUSH_NEXT_DELTA_SECONDS_DEFAULT: u32 = 1800;
pub const CERT_CHAIN_AUTO_LOG_FILE_NAME_VALUE_NAME: &[u8; 16] = b"AutoLogFileName\0";
pub const CERT_CHAIN_DISABLE_AUTO_FLUSH_PROCESS_NAME_LIST_VALUE_NAME: &[u8; 32] =
    b"DisableAutoFlushProcessNameList\0";
pub const CERT_SRV_OCSP_RESP_MIN_VALIDITY_SECONDS_VALUE_NAME: &[u8; 30] =
    b"SrvOcspRespMinValiditySeconds\0";
pub const CERT_SRV_OCSP_RESP_MIN_VALIDITY_SECONDS_DEFAULT: u32 = 600;
pub const CERT_SRV_OCSP_RESP_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_VALUE_NAME: &[u8; 43] =
    b"SrvOcspRespUrlRetrievalTimeoutMilliseconds\0";
pub const CERT_SRV_OCSP_RESP_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_DEFAULT: u32 = 15000;
pub const CERT_SRV_OCSP_RESP_MAX_BEFORE_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 38] =
    b"SrvOcspRespMaxBeforeNextUpdateSeconds\0";
pub const CERT_SRV_OCSP_RESP_MAX_BEFORE_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 14400;
pub const CERT_SRV_OCSP_RESP_MIN_BEFORE_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 38] =
    b"SrvOcspRespMinBeforeNextUpdateSeconds\0";
pub const CERT_SRV_OCSP_RESP_MIN_BEFORE_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 120;
pub const CERT_SRV_OCSP_RESP_MIN_AFTER_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 37] =
    b"SrvOcspRespMinAfterNextUpdateSeconds\0";
pub const CERT_SRV_OCSP_RESP_MIN_AFTER_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 60;
pub const CERT_SRV_OCSP_RESP_MIN_SYNC_CERT_FILE_SECONDS_VALUE_NAME: &[u8; 34] =
    b"SrvOcspRespMinSyncCertFileSeconds\0";
pub const CERT_SRV_OCSP_RESP_MIN_SYNC_CERT_FILE_SECONDS_DEFAULT: u32 = 5;
pub const CERT_SRV_OCSP_RESP_MAX_SYNC_CERT_FILE_SECONDS_VALUE_NAME: &[u8; 34] =
    b"SrvOcspRespMaxSyncCertFileSeconds\0";
pub const CERT_SRV_OCSP_RESP_MAX_SYNC_CERT_FILE_SECONDS_DEFAULT: u32 = 3600;
pub const CRYPTNET_MAX_CACHED_OCSP_PER_CRL_COUNT_VALUE_NAME: &[u8; 33] =
    b"CryptnetMaxCachedOcspPerCrlCount\0";
pub const CRYPTNET_MAX_CACHED_OCSP_PER_CRL_COUNT_DEFAULT: u32 = 500;
pub const CRYPTNET_OCSP_AFTER_CRL_DISABLE: u32 = 4294967295;
pub const CRYPTNET_URL_CACHE_DEFAULT_FLUSH_EXEMPT_SECONDS_VALUE_NAME: &[u8; 34] =
    b"CryptnetDefaultFlushExemptSeconds\0";
pub const CRYPTNET_URL_CACHE_DEFAULT_FLUSH_EXEMPT_SECONDS_DEFAULT: u32 = 2419200;
pub const CRYPTNET_PRE_FETCH_MIN_MAX_AGE_SECONDS_VALUE_NAME: &[u8; 33] =
    b"CryptnetPreFetchMinMaxAgeSeconds\0";
pub const CRYPTNET_PRE_FETCH_MIN_MAX_AGE_SECONDS_DEFAULT: u32 = 3600;
pub const CRYPTNET_PRE_FETCH_MAX_MAX_AGE_SECONDS_VALUE_NAME: &[u8; 33] =
    b"CryptnetPreFetchMaxMaxAgeSeconds\0";
pub const CRYPTNET_PRE_FETCH_MAX_MAX_AGE_SECONDS_DEFAULT: u32 = 1209600;
pub const CRYPTNET_PRE_FETCH_MIN_OCSP_VALIDITY_PERIOD_SECONDS_VALUE_NAME: &[u8; 45] =
    b"CryptnetPreFetchMinOcspValidityPeriodSeconds\0";
pub const CRYPTNET_PRE_FETCH_MIN_OCSP_VALIDITY_PERIOD_SECONDS_DEFAULT: u32 = 1209600;
pub const CRYPTNET_PRE_FETCH_AFTER_PUBLISH_PRE_FETCH_DIVISOR_VALUE_NAME: &[u8; 44] =
    b"CryptnetPreFetchAfterPublishPreFetchDivisor\0";
pub const CRYPTNET_PRE_FETCH_AFTER_PUBLISH_PRE_FETCH_DIVISOR_DEFAULT: u32 = 10;
pub const CRYPTNET_PRE_FETCH_BEFORE_NEXT_UPDATE_PRE_FETCH_DIVISOR_VALUE_NAME: &[u8; 48] =
    b"CryptnetPreFetchBeforeNextUpdatePreFetchDivisor\0";
pub const CRYPTNET_PRE_FETCH_BEFORE_NEXT_UPDATE_PRE_FETCH_DIVISOR_DEFAULT: u32 = 20;
pub const CRYPTNET_PRE_FETCH_MIN_BEFORE_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_VALUE_NAME: &[u8; 51] =
    b"CryptnetPreFetchMinBeforeNextUpdatePreFetchSeconds\0";
pub const CRYPTNET_PRE_FETCH_MIN_BEFORE_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_DEFAULT: u32 = 3600;
pub const CRYPTNET_PRE_FETCH_VALIDITY_PERIOD_AFTER_NEXT_UPDATE_PRE_FETCH_DIVISOR_VALUE_NAME:
    &[u8; 61] = b"CryptnetPreFetchValidityPeriodAfterNextUpdatePreFetchDivisor\0";
pub const CRYPTNET_PRE_FETCH_VALIDITY_PERIOD_AFTER_NEXT_UPDATE_PRE_FETCH_DIVISOR_DEFAULT: u32 = 10;
pub const CRYPTNET_PRE_FETCH_MAX_AFTER_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_VALUE_NAME: &[u8; 56] =
    b"CryptnetPreFetchMaxAfterNextUpdatePreFetchPeriodSeconds\0";
pub const CRYPTNET_PRE_FETCH_MAX_AFTER_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_DEFAULT: u32 = 14400;
pub const CRYPTNET_PRE_FETCH_MIN_AFTER_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_VALUE_NAME: &[u8; 56] =
    b"CryptnetPreFetchMinAfterNextUpdatePreFetchPeriodSeconds\0";
pub const CRYPTNET_PRE_FETCH_MIN_AFTER_NEXT_UPDATE_PRE_FETCH_PERIOD_SECONDS_DEFAULT: u32 = 1800;
pub const CRYPTNET_PRE_FETCH_AFTER_CURRENT_TIME_PRE_FETCH_PERIOD_SECONDS_VALUE_NAME: &[u8; 54] =
    b"CryptnetPreFetchAfterCurrentTimePreFetchPeriodSeconds\0";
pub const CRYPTNET_PRE_FETCH_AFTER_CURRENT_TIME_PRE_FETCH_PERIOD_SECONDS_DEFAULT: u32 = 1800;
pub const CRYPTNET_PRE_FETCH_TRIGGER_PERIOD_SECONDS_VALUE_NAME: &[u8; 37] =
    b"CryptnetPreFetchTriggerPeriodSeconds\0";
pub const CRYPTNET_PRE_FETCH_TRIGGER_PERIOD_SECONDS_DEFAULT: u32 = 600;
pub const CRYPTNET_PRE_FETCH_TRIGGER_DISABLE: u32 = 4294967295;
pub const CRYPTNET_PRE_FETCH_SCAN_AFTER_TRIGGER_DELAY_SECONDS_VALUE_NAME: &[u8; 45] =
    b"CryptnetPreFetchScanAfterTriggerDelaySeconds\0";
pub const CRYPTNET_PRE_FETCH_SCAN_AFTER_TRIGGER_DELAY_SECONDS_DEFAULT: u32 = 60;
pub const CRYPTNET_PRE_FETCH_RETRIEVAL_TIMEOUT_SECONDS_VALUE_NAME: &[u8; 40] =
    b"CryptnetPreFetchRetrievalTimeoutSeconds\0";
pub const CRYPTNET_PRE_FETCH_RETRIEVAL_TIMEOUT_SECONDS_DEFAULT: u32 = 300;
pub const CRYPTNET_CRL_PRE_FETCH_CONFIG_REGPATH : & [u8 ; 106] = b"Software\\Microsoft\\Cryptography\\OID\\EncodingType 0\\CertDllCreateCertificateChainEngine\\Config\\CrlPreFetch\0" ;
pub const CRYPTNET_CRL_PRE_FETCH_PROCESS_NAME_LIST_VALUE_NAME: &[u8; 16] = b"ProcessNameList\0";
pub const CRYPTNET_CRL_PRE_FETCH_URL_LIST_VALUE_NAME: &[u8; 16] = b"PreFetchUrlList\0";
pub const CRYPTNET_CRL_PRE_FETCH_DISABLE_INFORMATION_EVENTS_VALUE_NAME: &[u8; 25] =
    b"DisableInformationEvents\0";
pub const CRYPTNET_CRL_PRE_FETCH_LOG_FILE_NAME_VALUE_NAME: &[u8; 12] = b"LogFileName\0";
pub const CRYPTNET_CRL_PRE_FETCH_TIMEOUT_SECONDS_VALUE_NAME: &[u8; 15] = b"TimeoutSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_TIMEOUT_SECONDS_DEFAULT: u32 = 300;
pub const CRYPTNET_CRL_PRE_FETCH_MAX_AGE_SECONDS_VALUE_NAME: &[u8; 14] = b"MaxAgeSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_MAX_AGE_SECONDS_DEFAULT: u32 = 7200;
pub const CRYPTNET_CRL_PRE_FETCH_MAX_AGE_SECONDS_MIN: u32 = 300;
pub const CRYPTNET_CRL_PRE_FETCH_PUBLISH_BEFORE_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 31] =
    b"PublishBeforeNextUpdateSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_PUBLISH_BEFORE_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 3600;
pub const CRYPTNET_CRL_PRE_FETCH_PUBLISH_RANDOM_INTERVAL_SECONDS_VALUE_NAME: &[u8; 29] =
    b"PublishRandomIntervalSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_PUBLISH_RANDOM_INTERVAL_SECONDS_DEFAULT: u32 = 300;
pub const CRYPTNET_CRL_PRE_FETCH_MIN_BEFORE_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 27] =
    b"MinBeforeNextUpdateSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_MIN_BEFORE_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 300;
pub const CRYPTNET_CRL_PRE_FETCH_MIN_AFTER_NEXT_UPDATE_SECONDS_VALUE_NAME: &[u8; 26] =
    b"MinAfterNextUpdateSeconds\0";
pub const CRYPTNET_CRL_PRE_FETCH_MIN_AFTER_NEXT_UPDATE_SECONDS_DEFAULT: u32 = 300;
pub const CERT_GROUP_POLICY_CHAIN_CONFIG_REGPATH: &[u8; 66] =
    b"Software\\Policies\\Microsoft\\SystemCertificates\\ChainEngine\\Config\0";
pub const CERT_CHAIN_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_VALUE_NAME: &[u8; 37] =
    b"ChainUrlRetrievalTimeoutMilliseconds\0";
pub const CERT_CHAIN_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_DEFAULT: u32 = 15000;
pub const CERT_CHAIN_REV_ACCUMULATIVE_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_VALUE_NAME: &[u8; 52] =
    b"ChainRevAccumulativeUrlRetrievalTimeoutMilliseconds\0";
pub const CERT_CHAIN_REV_ACCUMULATIVE_URL_RETRIEVAL_TIMEOUT_MILLISECONDS_DEFAULT: u32 = 20000;
pub const CERT_RETR_BEHAVIOR_INET_AUTH_VALUE_NAME: &[u8; 22] = b"EnableInetUnknownAuth\0";
pub const CERT_RETR_BEHAVIOR_INET_STATUS_VALUE_NAME: &[u8; 16] = b"EnableInetLocal\0";
pub const CERT_RETR_BEHAVIOR_FILE_VALUE_NAME: &[u8; 19] = b"AllowFileUrlScheme\0";
pub const CERT_RETR_BEHAVIOR_LDAP_VALUE_NAME: &[u8; 26] = b"DisableLDAPSignAndEncrypt\0";
pub const CRYPTNET_CACHED_OCSP_SWITCH_TO_CRL_COUNT_VALUE_NAME: &[u8; 35] =
    b"CryptnetCachedOcspSwitchToCrlCount\0";
pub const CRYPTNET_CACHED_OCSP_SWITCH_TO_CRL_COUNT_DEFAULT: u32 = 50;
pub const CRYPTNET_CRL_BEFORE_OCSP_ENABLE: u32 = 4294967295;
pub const CERT_CHAIN_DISABLE_AIA_URL_RETRIEVAL_VALUE_NAME: &[u8; 23] = b"DisableAIAUrlRetrieval\0";
pub const CERT_CHAIN_OPTIONS_VALUE_NAME: &[u8; 8] = b"Options\0";
pub const CERT_CHAIN_OPTION_DISABLE_AIA_URL_RETRIEVAL: u32 = 2;
pub const CERT_CHAIN_OPTION_ENABLE_SIA_URL_RETRIEVAL: u32 = 4;
pub const CERT_CHAIN_CROSS_CERT_DOWNLOAD_INTERVAL_HOURS_VALUE_NAME: &[u8; 31] =
    b"CrossCertDownloadIntervalHours\0";
pub const CERT_CHAIN_CROSS_CERT_DOWNLOAD_INTERVAL_HOURS_DEFAULT: u32 = 168;
pub const CERT_CHAIN_CRL_VALIDITY_EXT_PERIOD_HOURS_VALUE_NAME: &[u8; 27] =
    b"CRLValidityExtensionPeriod\0";
pub const CERT_CHAIN_CRL_VALIDITY_EXT_PERIOD_HOURS_DEFAULT: u32 = 12;
pub const CERT_CHAIN_CACHE_END_CERT: u32 = 1;
pub const CERT_CHAIN_THREAD_STORE_SYNC: u32 = 2;
pub const CERT_CHAIN_CACHE_ONLY_URL_RETRIEVAL: u32 = 4;
pub const CERT_CHAIN_USE_LOCAL_MACHINE_STORE: u32 = 8;
pub const CERT_CHAIN_ENABLE_CACHE_AUTO_UPDATE: u32 = 16;
pub const CERT_CHAIN_ENABLE_SHARE_STORE: u32 = 32;
pub const CERT_CHAIN_EXCLUSIVE_ENABLE_CA_FLAG: u32 = 1;
pub const CERT_TRUST_NO_ERROR: u32 = 0;
pub const CERT_TRUST_IS_NOT_TIME_VALID: u32 = 1;
pub const CERT_TRUST_IS_NOT_TIME_NESTED: u32 = 2;
pub const CERT_TRUST_IS_REVOKED: u32 = 4;
pub const CERT_TRUST_IS_NOT_SIGNATURE_VALID: u32 = 8;
pub const CERT_TRUST_IS_NOT_VALID_FOR_USAGE: u32 = 16;
pub const CERT_TRUST_IS_UNTRUSTED_ROOT: u32 = 32;
pub const CERT_TRUST_REVOCATION_STATUS_UNKNOWN: u32 = 64;
pub const CERT_TRUST_IS_CYCLIC: u32 = 128;
pub const CERT_TRUST_INVALID_EXTENSION: u32 = 256;
pub const CERT_TRUST_INVALID_POLICY_CONSTRAINTS: u32 = 512;
pub const CERT_TRUST_INVALID_BASIC_CONSTRAINTS: u32 = 1024;
pub const CERT_TRUST_INVALID_NAME_CONSTRAINTS: u32 = 2048;
pub const CERT_TRUST_HAS_NOT_SUPPORTED_NAME_CONSTRAINT: u32 = 4096;
pub const CERT_TRUST_HAS_NOT_DEFINED_NAME_CONSTRAINT: u32 = 8192;
pub const CERT_TRUST_HAS_NOT_PERMITTED_NAME_CONSTRAINT: u32 = 16384;
pub const CERT_TRUST_HAS_EXCLUDED_NAME_CONSTRAINT: u32 = 32768;
pub const CERT_TRUST_IS_OFFLINE_REVOCATION: u32 = 16777216;
pub const CERT_TRUST_NO_ISSUANCE_CHAIN_POLICY: u32 = 33554432;
pub const CERT_TRUST_IS_EXPLICIT_DISTRUST: u32 = 67108864;
pub const CERT_TRUST_HAS_NOT_SUPPORTED_CRITICAL_EXT: u32 = 134217728;
pub const CERT_TRUST_HAS_WEAK_SIGNATURE: u32 = 1048576;
pub const CERT_TRUST_HAS_WEAK_HYGIENE: u32 = 2097152;
pub const CERT_TRUST_IS_PARTIAL_CHAIN: u32 = 65536;
pub const CERT_TRUST_CTL_IS_NOT_TIME_VALID: u32 = 131072;
pub const CERT_TRUST_CTL_IS_NOT_SIGNATURE_VALID: u32 = 262144;
pub const CERT_TRUST_CTL_IS_NOT_VALID_FOR_USAGE: u32 = 524288;
pub const CERT_TRUST_HAS_EXACT_MATCH_ISSUER: u32 = 1;
pub const CERT_TRUST_HAS_KEY_MATCH_ISSUER: u32 = 2;
pub const CERT_TRUST_HAS_NAME_MATCH_ISSUER: u32 = 4;
pub const CERT_TRUST_IS_SELF_SIGNED: u32 = 8;
pub const CERT_TRUST_AUTO_UPDATE_CA_REVOCATION: u32 = 16;
pub const CERT_TRUST_AUTO_UPDATE_END_REVOCATION: u32 = 32;
pub const CERT_TRUST_NO_OCSP_FAILOVER_TO_CRL: u32 = 64;
pub const CERT_TRUST_IS_KEY_ROLLOVER: u32 = 128;
pub const CERT_TRUST_SSL_HANDSHAKE_OCSP: u32 = 262144;
pub const CERT_TRUST_SSL_TIME_VALID_OCSP: u32 = 524288;
pub const CERT_TRUST_SSL_RECONNECT_OCSP: u32 = 1048576;
pub const CERT_TRUST_HAS_PREFERRED_ISSUER: u32 = 256;
pub const CERT_TRUST_HAS_ISSUANCE_CHAIN_POLICY: u32 = 512;
pub const CERT_TRUST_HAS_VALID_NAME_CONSTRAINTS: u32 = 1024;
pub const CERT_TRUST_IS_PEER_TRUSTED: u32 = 2048;
pub const CERT_TRUST_HAS_CRL_VALIDITY_EXTENDED: u32 = 4096;
pub const CERT_TRUST_IS_FROM_EXCLUSIVE_TRUST_STORE: u32 = 8192;
pub const CERT_TRUST_IS_CA_TRUSTED: u32 = 16384;
pub const CERT_TRUST_HAS_AUTO_UPDATE_WEAK_SIGNATURE: u32 = 32768;
pub const CERT_TRUST_HAS_ALLOW_WEAK_SIGNATURE: u32 = 131072;
pub const CERT_TRUST_IS_COMPLEX_CHAIN: u32 = 65536;
pub const CERT_TRUST_SSL_TIME_VALID: u32 = 16777216;
pub const CERT_TRUST_NO_TIME_CHECK: u32 = 33554432;
pub const USAGE_MATCH_TYPE_AND: u32 = 0;
pub const USAGE_MATCH_TYPE_OR: u32 = 1;
pub const CERT_CHAIN_STRONG_SIGN_DISABLE_END_CHECK_FLAG: u32 = 1;
pub const CERT_CHAIN_REVOCATION_CHECK_END_CERT: u32 = 268435456;
pub const CERT_CHAIN_REVOCATION_CHECK_CHAIN: u32 = 536870912;
pub const CERT_CHAIN_REVOCATION_CHECK_CHAIN_EXCLUDE_ROOT: u32 = 1073741824;
pub const CERT_CHAIN_REVOCATION_CHECK_CACHE_ONLY: u32 = 2147483648;
pub const CERT_CHAIN_REVOCATION_ACCUMULATIVE_TIMEOUT: u32 = 134217728;
pub const CERT_CHAIN_REVOCATION_CHECK_OCSP_CERT: u32 = 67108864;
pub const CERT_CHAIN_DISABLE_PASS1_QUALITY_FILTERING: u32 = 64;
pub const CERT_CHAIN_RETURN_LOWER_QUALITY_CONTEXTS: u32 = 128;
pub const CERT_CHAIN_DISABLE_AUTH_ROOT_AUTO_UPDATE: u32 = 256;
pub const CERT_CHAIN_TIMESTAMP_TIME: u32 = 512;
pub const CERT_CHAIN_ENABLE_PEER_TRUST: u32 = 1024;
pub const CERT_CHAIN_DISABLE_MY_PEER_TRUST: u32 = 2048;
pub const CERT_CHAIN_DISABLE_MD2_MD4: u32 = 4096;
pub const CERT_CHAIN_DISABLE_AIA: u32 = 8192;
pub const CERT_CHAIN_HAS_MOTW: u32 = 16384;
pub const CERT_CHAIN_ONLY_ADDITIONAL_AND_AUTH_ROOT: u32 = 32768;
pub const CERT_CHAIN_OPT_IN_WEAK_SIGNATURE: u32 = 65536;
pub const CERT_CHAIN_FIND_BY_ISSUER: u32 = 1;
pub const CERT_CHAIN_FIND_BY_ISSUER_COMPARE_KEY_FLAG: u32 = 1;
pub const CERT_CHAIN_FIND_BY_ISSUER_COMPLEX_CHAIN_FLAG: u32 = 2;
pub const CERT_CHAIN_FIND_BY_ISSUER_CACHE_ONLY_URL_FLAG: u32 = 4;
pub const CERT_CHAIN_FIND_BY_ISSUER_LOCAL_MACHINE_FLAG: u32 = 8;
pub const CERT_CHAIN_FIND_BY_ISSUER_NO_KEY_FLAG: u32 = 16384;
pub const CERT_CHAIN_FIND_BY_ISSUER_CACHE_ONLY_FLAG: u32 = 32768;
pub const CERT_CHAIN_POLICY_IGNORE_NOT_TIME_VALID_FLAG: u32 = 1;
pub const CERT_CHAIN_POLICY_IGNORE_CTL_NOT_TIME_VALID_FLAG: u32 = 2;
pub const CERT_CHAIN_POLICY_IGNORE_NOT_TIME_NESTED_FLAG: u32 = 4;
pub const CERT_CHAIN_POLICY_IGNORE_INVALID_BASIC_CONSTRAINTS_FLAG: u32 = 8;
pub const CERT_CHAIN_POLICY_IGNORE_ALL_NOT_TIME_VALID_FLAGS: u32 = 7;
pub const CERT_CHAIN_POLICY_ALLOW_UNKNOWN_CA_FLAG: u32 = 16;
pub const CERT_CHAIN_POLICY_IGNORE_WRONG_USAGE_FLAG: u32 = 32;
pub const CERT_CHAIN_POLICY_IGNORE_INVALID_NAME_FLAG: u32 = 64;
pub const CERT_CHAIN_POLICY_IGNORE_INVALID_POLICY_FLAG: u32 = 128;
pub const CERT_CHAIN_POLICY_IGNORE_END_REV_UNKNOWN_FLAG: u32 = 256;
pub const CERT_CHAIN_POLICY_IGNORE_CTL_SIGNER_REV_UNKNOWN_FLAG: u32 = 512;
pub const CERT_CHAIN_POLICY_IGNORE_CA_REV_UNKNOWN_FLAG: u32 = 1024;
pub const CERT_CHAIN_POLICY_IGNORE_ROOT_REV_UNKNOWN_FLAG: u32 = 2048;
pub const CERT_CHAIN_POLICY_IGNORE_ALL_REV_UNKNOWN_FLAGS: u32 = 3840;
pub const CERT_CHAIN_POLICY_ALLOW_TESTROOT_FLAG: u32 = 32768;
pub const CERT_CHAIN_POLICY_TRUST_TESTROOT_FLAG: u32 = 16384;
pub const CERT_CHAIN_POLICY_IGNORE_NOT_SUPPORTED_CRITICAL_EXT_FLAG: u32 = 8192;
pub const CERT_CHAIN_POLICY_IGNORE_PEER_TRUST_FLAG: u32 = 4096;
pub const CERT_CHAIN_POLICY_IGNORE_WEAK_SIGNATURE_FLAG: u32 = 134217728;
pub const CRYPT_OID_VERIFY_CERTIFICATE_CHAIN_POLICY_FUNC: &[u8; 36] =
    b"CertDllVerifyCertificateChainPolicy\0";
pub const AUTHTYPE_CLIENT: u32 = 1;
pub const AUTHTYPE_SERVER: u32 = 2;
pub const BASIC_CONSTRAINTS_CERT_CHAIN_POLICY_CA_FLAG: u32 = 2147483648;
pub const BASIC_CONSTRAINTS_CERT_CHAIN_POLICY_END_ENTITY_FLAG: u32 = 1073741824;
pub const MICROSOFT_ROOT_CERT_CHAIN_POLICY_ENABLE_TEST_ROOT_FLAG: u32 = 65536;
pub const MICROSOFT_ROOT_CERT_CHAIN_POLICY_CHECK_APPLICATION_ROOT_FLAG: u32 = 131072;
pub const MICROSOFT_ROOT_CERT_CHAIN_POLICY_DISABLE_FLIGHT_ROOT_FLAG: u32 = 262144;
pub const SSL_F12_ERROR_TEXT_LENGTH: u32 = 256;
pub const CERT_CHAIN_POLICY_SSL_F12_SUCCESS_LEVEL: u32 = 0;
pub const CERT_CHAIN_POLICY_SSL_F12_WARNING_LEVEL: u32 = 1;
pub const CERT_CHAIN_POLICY_SSL_F12_ERROR_LEVEL: u32 = 2;
pub const CERT_CHAIN_POLICY_SSL_F12_NONE_CATEGORY: u32 = 0;
pub const CERT_CHAIN_POLICY_SSL_F12_WEAK_CRYPTO_CATEGORY: u32 = 1;
pub const CERT_CHAIN_POLICY_SSL_F12_ROOT_PROGRAM_CATEGORY: u32 = 2;
pub const SSL_HPKP_PKP_HEADER_INDEX: u32 = 0;
pub const SSL_HPKP_PKP_RO_HEADER_INDEX: u32 = 1;
pub const SSL_HPKP_HEADER_COUNT: u32 = 2;
pub const SSL_KEY_PIN_ERROR_TEXT_LENGTH: u32 = 512;
pub const CERT_CHAIN_POLICY_SSL_KEY_PIN_MISMATCH_ERROR: i32 = -2;
pub const CERT_CHAIN_POLICY_SSL_KEY_PIN_MITM_ERROR: i32 = -1;
pub const CERT_CHAIN_POLICY_SSL_KEY_PIN_SUCCESS: u32 = 0;
pub const CERT_CHAIN_POLICY_SSL_KEY_PIN_MITM_WARNING: u32 = 1;
pub const CERT_CHAIN_POLICY_SSL_KEY_PIN_MISMATCH_WARNING: u32 = 2;
pub const CRYPT_STRING_BASE64HEADER: u32 = 0;
pub const CRYPT_STRING_BASE64: u32 = 1;
pub const CRYPT_STRING_BINARY: u32 = 2;
pub const CRYPT_STRING_BASE64REQUESTHEADER: u32 = 3;
pub const CRYPT_STRING_HEX: u32 = 4;
pub const CRYPT_STRING_HEXASCII: u32 = 5;
pub const CRYPT_STRING_BASE64_ANY: u32 = 6;
pub const CRYPT_STRING_ANY: u32 = 7;
pub const CRYPT_STRING_HEX_ANY: u32 = 8;
pub const CRYPT_STRING_BASE64X509CRLHEADER: u32 = 9;
pub const CRYPT_STRING_HEXADDR: u32 = 10;
pub const CRYPT_STRING_HEXASCIIADDR: u32 = 11;
pub const CRYPT_STRING_HEXRAW: u32 = 12;
pub const CRYPT_STRING_BASE64URI: u32 = 13;
pub const CRYPT_STRING_ENCODEMASK: u32 = 255;
pub const CRYPT_STRING_RESERVED100: u32 = 256;
pub const CRYPT_STRING_RESERVED200: u32 = 512;
pub const CRYPT_STRING_PERCENTESCAPE: u32 = 134217728;
pub const CRYPT_STRING_HASHDATA: u32 = 268435456;
pub const CRYPT_STRING_STRICT: u32 = 536870912;
pub const CRYPT_STRING_NOCRLF: u32 = 1073741824;
pub const CRYPT_STRING_NOCR: u32 = 2147483648;
pub const szOID_PKCS_12_PbeIds: &[u8; 22] = b"1.2.840.113549.1.12.1\0";
pub const szOID_PKCS_12_pbeWithSHA1And128BitRC4: &[u8; 24] = b"1.2.840.113549.1.12.1.1\0";
pub const szOID_PKCS_12_pbeWithSHA1And40BitRC4: &[u8; 24] = b"1.2.840.113549.1.12.1.2\0";
pub const szOID_PKCS_12_pbeWithSHA1And3KeyTripleDES: &[u8; 24] = b"1.2.840.113549.1.12.1.3\0";
pub const szOID_PKCS_12_pbeWithSHA1And2KeyTripleDES: &[u8; 24] = b"1.2.840.113549.1.12.1.4\0";
pub const szOID_PKCS_12_pbeWithSHA1And128BitRC2: &[u8; 24] = b"1.2.840.113549.1.12.1.5\0";
pub const szOID_PKCS_12_pbeWithSHA1And40BitRC2: &[u8; 24] = b"1.2.840.113549.1.12.1.6\0";
pub const szOID_PKCS_5_PBKDF2: &[u8; 22] = b"1.2.840.113549.1.5.12\0";
pub const szOID_PKCS_5_PBES2: &[u8; 22] = b"1.2.840.113549.1.5.13\0";
pub const PKCS12_IMPORT_SILENT: u32 = 64;
pub const CRYPT_USER_KEYSET: u32 = 4096;
pub const PKCS12_PREFER_CNG_KSP: u32 = 256;
pub const PKCS12_ALWAYS_CNG_KSP: u32 = 512;
pub const PKCS12_ONLY_CERTIFICATES: u32 = 1024;
pub const PKCS12_ONLY_NOT_ENCRYPTED_CERTIFICATES: u32 = 2048;
pub const PKCS12_ALLOW_OVERWRITE_KEY: u32 = 16384;
pub const PKCS12_NO_PERSIST_KEY: u32 = 32768;
pub const PKCS12_VIRTUAL_ISOLATION_KEY: u32 = 65536;
pub const PKCS12_IMPORT_RESERVED_MASK: u32 = 4294901760;
pub const PKCS12_ONLY_CERTIFICATES_PROVIDER_TYPE: u32 = 0;
pub const PKCS12_ONLY_CERTIFICATES_PROVIDER_NAME: &[u8; 12] = b"PfxProvider\0";
pub const PKCS12_ONLY_CERTIFICATES_CONTAINER_NAME: &[u8; 13] = b"PfxContainer\0";
pub const REPORT_NO_PRIVATE_KEY: u32 = 1;
pub const REPORT_NOT_ABLE_TO_EXPORT_PRIVATE_KEY: u32 = 2;
pub const EXPORT_PRIVATE_KEYS: u32 = 4;
pub const PKCS12_INCLUDE_EXTENDED_PROPERTIES: u32 = 16;
pub const PKCS12_PROTECT_TO_DOMAIN_SIDS: u32 = 32;
pub const PKCS12_EXPORT_SILENT: u32 = 64;
pub const PKCS12_EXPORT_PBES2_PARAMS: u32 = 128;
pub const PKCS12_DISABLE_ENCRYPT_CERTIFICATES: u32 = 256;
pub const PKCS12_ENCRYPT_CERTIFICATES: u32 = 512;
pub const PKCS12_EXPORT_ECC_CURVE_PARAMETERS: u32 = 4096;
pub const PKCS12_EXPORT_ECC_CURVE_OID: u32 = 8192;
pub const PKCS12_EXPORT_RESERVED_MASK: u32 = 4294901760;
pub const PKCS12_PBKDF2_ID_HMAC_SHA1: &[u8; 19] = b"1.2.840.113549.2.7\0";
pub const PKCS12_PBKDF2_ID_HMAC_SHA256: &[u8; 19] = b"1.2.840.113549.2.9\0";
pub const PKCS12_PBKDF2_ID_HMAC_SHA384: &[u8; 20] = b"1.2.840.113549.2.10\0";
pub const PKCS12_PBKDF2_ID_HMAC_SHA512: &[u8; 20] = b"1.2.840.113549.2.11\0";
pub const PKCS12_PBES2_ALG_AES256_SHA256: &[u8; 14] = b"AES256-SHA256\0";
pub const PKCS12_CONFIG_REGPATH: &[u8; 46] = b"Software\\Microsoft\\Windows\\CurrentVersion\\PFX\0";
pub const PKCS12_ENCRYPT_CERTIFICATES_VALUE_NAME: &[u8; 20] = b"EncryptCertificates\0";
pub const CERT_SERVER_OCSP_RESPONSE_OPEN_PARA_READ_FLAG: u32 = 1;
pub const CERT_SERVER_OCSP_RESPONSE_OPEN_PARA_WRITE_FLAG: u32 = 2;
pub const CERT_SERVER_OCSP_RESPONSE_ASYNC_FLAG: u32 = 1;
pub const CERT_SELECT_MAX_PARA: u32 = 500;
pub const CERT_SELECT_BY_ENHKEY_USAGE: u32 = 1;
pub const CERT_SELECT_BY_KEY_USAGE: u32 = 2;
pub const CERT_SELECT_BY_POLICY_OID: u32 = 3;
pub const CERT_SELECT_BY_PROV_NAME: u32 = 4;
pub const CERT_SELECT_BY_EXTENSION: u32 = 5;
pub const CERT_SELECT_BY_SUBJECT_HOST_NAME: u32 = 6;
pub const CERT_SELECT_BY_ISSUER_ATTR: u32 = 7;
pub const CERT_SELECT_BY_SUBJECT_ATTR: u32 = 8;
pub const CERT_SELECT_BY_ISSUER_NAME: u32 = 9;
pub const CERT_SELECT_BY_PUBLIC_KEY: u32 = 10;
pub const CERT_SELECT_BY_TLS_SIGNATURES: u32 = 11;
pub const CERT_SELECT_BY_ISSUER_DISPLAYNAME: u32 = 12;
pub const CERT_SELECT_BY_FRIENDLYNAME: u32 = 13;
pub const CERT_SELECT_BY_THUMBPRINT: u32 = 14;
pub const CERT_SELECT_LAST: u32 = 11;
pub const CERT_SELECT_MAX: u32 = 33;
pub const CERT_SELECT_ALLOW_EXPIRED: u32 = 1;
pub const CERT_SELECT_TRUSTED_ROOT: u32 = 2;
pub const CERT_SELECT_DISALLOW_SELFSIGNED: u32 = 4;
pub const CERT_SELECT_HAS_PRIVATE_KEY: u32 = 8;
pub const CERT_SELECT_HAS_KEY_FOR_SIGNATURE: u32 = 16;
pub const CERT_SELECT_HAS_KEY_FOR_KEY_EXCHANGE: u32 = 32;
pub const CERT_SELECT_HARDWARE_ONLY: u32 = 64;
pub const CERT_SELECT_ALLOW_DUPLICATES: u32 = 128;
pub const CERT_SELECT_IGNORE_AUTOSELECT: u32 = 256;
pub const TIMESTAMP_VERSION: u32 = 1;
pub const TIMESTAMP_STATUS_GRANTED: u32 = 0;
pub const TIMESTAMP_STATUS_GRANTED_WITH_MODS: u32 = 1;
pub const TIMESTAMP_STATUS_REJECTED: u32 = 2;
pub const TIMESTAMP_STATUS_WAITING: u32 = 3;
pub const TIMESTAMP_STATUS_REVOCATION_WARNING: u32 = 4;
pub const TIMESTAMP_STATUS_REVOKED: u32 = 5;
pub const TIMESTAMP_FAILURE_BAD_ALG: u32 = 0;
pub const TIMESTAMP_FAILURE_BAD_REQUEST: u32 = 2;
pub const TIMESTAMP_FAILURE_BAD_FORMAT: u32 = 5;
pub const TIMESTAMP_FAILURE_TIME_NOT_AVAILABLE: u32 = 14;
pub const TIMESTAMP_FAILURE_POLICY_NOT_SUPPORTED: u32 = 15;
pub const TIMESTAMP_FAILURE_EXTENSION_NOT_SUPPORTED: u32 = 16;
pub const TIMESTAMP_FAILURE_INFO_NOT_AVAILABLE: u32 = 17;
pub const TIMESTAMP_FAILURE_SYSTEM_FAILURE: u32 = 25;
pub const TIMESTAMP_DONT_HASH_DATA: u32 = 1;
pub const TIMESTAMP_VERIFY_CONTEXT_SIGNATURE: u32 = 32;
pub const TIMESTAMP_NO_AUTH_RETRIEVAL: u32 = 131072;
pub const CRYPT_OBJECT_LOCATOR_SPN_NAME_TYPE: u32 = 1;
pub const CRYPT_OBJECT_LOCATOR_LAST_RESERVED_NAME_TYPE: u32 = 32;
pub const CRYPT_OBJECT_LOCATOR_FIRST_RESERVED_USER_NAME_TYPE: u32 = 33;
pub const CRYPT_OBJECT_LOCATOR_LAST_RESERVED_USER_NAME_TYPE: u32 = 65535;
pub const SSL_OBJECT_LOCATOR_PFX_FUNC: &[u8; 30] = b"SslObjectLocatorInitializePfx\0";
pub const SSL_OBJECT_LOCATOR_ISSUER_LIST_FUNC: &[u8; 37] =
    b"SslObjectLocatorInitializeIssuerList\0";
pub const SSL_OBJECT_LOCATOR_CERT_VALIDATION_CONFIG_FUNC: &[u8; 47] =
    b"SslObjectLocatorInitializeCertValidationConfig\0";
pub const CRYPT_OBJECT_LOCATOR_RELEASE_SYSTEM_SHUTDOWN: u32 = 1;
pub const CRYPT_OBJECT_LOCATOR_RELEASE_SERVICE_STOP: u32 = 2;
pub const CRYPT_OBJECT_LOCATOR_RELEASE_PROCESS_EXIT: u32 = 3;
pub const CRYPT_OBJECT_LOCATOR_RELEASE_DLL_UNLOAD: u32 = 4;
pub const CERT_FILE_HASH_USE_TYPE: u32 = 1;
pub const CERT_TIMESTAMP_HASH_USE_TYPE: u32 = 2;
pub const szFORCE_KEY_PROTECTION: &[u8; 19] = b"ForceKeyProtection\0";
pub const dwFORCE_KEY_PROTECTION_DISABLED: u32 = 0;
pub const dwFORCE_KEY_PROTECTION_USER_SELECT: u32 = 1;
pub const dwFORCE_KEY_PROTECTION_HIGH: u32 = 2;
pub const CRYPTPROTECT_PROMPT_ON_UNPROTECT: u32 = 1;
pub const CRYPTPROTECT_PROMPT_ON_PROTECT: u32 = 2;
pub const CRYPTPROTECT_PROMPT_RESERVED: u32 = 4;
pub const CRYPTPROTECT_PROMPT_STRONG: u32 = 8;
pub const CRYPTPROTECT_PROMPT_REQUIRE_STRONG: u32 = 16;
pub const CRYPTPROTECT_UI_FORBIDDEN: u32 = 1;
pub const CRYPTPROTECT_LOCAL_MACHINE: u32 = 4;
pub const CRYPTPROTECT_CRED_SYNC: u32 = 8;
pub const CRYPTPROTECT_AUDIT: u32 = 16;
pub const CRYPTPROTECT_NO_RECOVERY: u32 = 32;
pub const CRYPTPROTECT_VERIFY_PROTECTION: u32 = 64;
pub const CRYPTPROTECT_CRED_REGENERATE: u32 = 128;
pub const CRYPTPROTECT_FIRST_RESERVED_FLAGVAL: u32 = 268435455;
pub const CRYPTPROTECT_LAST_RESERVED_FLAGVAL: u32 = 4294967295;
pub const CRYPTPROTECTMEMORY_BLOCK_SIZE: u32 = 16;
pub const CRYPTPROTECTMEMORY_SAME_PROCESS: u32 = 0;
pub const CRYPTPROTECTMEMORY_CROSS_PROCESS: u32 = 1;
pub const CRYPTPROTECTMEMORY_SAME_LOGON: u32 = 2;
pub const WINEFS_SETUSERKEY_SET_CAPABILITIES: u32 = 1;
pub const EFS_COMPATIBILITY_VERSION_NCRYPT_PROTECTOR: u32 = 5;
pub const EFS_COMPATIBILITY_VERSION_PFILE_PROTECTOR: u32 = 6;
pub const EFS_SUBVER_UNKNOWN: u32 = 0;
pub const EFS_EFS_SUBVER_EFS_CERT: u32 = 1;
pub const EFS_PFILE_SUBVER_RMS: u32 = 2;
pub const EFS_PFILE_SUBVER_APPX: u32 = 3;
pub const MAX_SID_SIZE: u32 = 256;
pub const EFS_METADATA_ADD_USER: u32 = 1;
pub const EFS_METADATA_REMOVE_USER: u32 = 2;
pub const EFS_METADATA_REPLACE_USER: u32 = 4;
pub const EFS_METADATA_GENERAL_OP: u32 = 8;
pub const __REQUIRED_RPCNDR_H_VERSION__: u32 = 500;
pub const __REQUIRED_RPCSAL_H_VERSION__: u32 = 100;
pub const __RPCNDR_H_VERSION__: u32 = 500;
pub const __RPCSAL_H_VERSION__: u32 = 100;
pub const TARGET_IS_NT100_OR_LATER: u32 = 1;
pub const TARGET_IS_NT63_OR_LATER: u32 = 1;
pub const TARGET_IS_NT62_OR_LATER: u32 = 1;
pub const TARGET_IS_NT61_OR_LATER: u32 = 1;
pub const TARGET_IS_NT60_OR_LATER: u32 = 1;
pub const TARGET_IS_NT51_OR_LATER: u32 = 1;
pub const TARGET_IS_NT50_OR_LATER: u32 = 1;
pub const TARGET_IS_NT40_OR_LATER: u32 = 1;
pub const TARGET_IS_NT351_OR_WIN95_OR_LATER: u32 = 1;
pub const cbNDRContext: u32 = 20;
pub const USER_CALL_IS_ASYNC: u32 = 256;
pub const USER_CALL_NEW_CORRELATION_DESC: u32 = 512;
pub const USER_MARSHAL_FC_BYTE: u32 = 1;
pub const USER_MARSHAL_FC_CHAR: u32 = 2;
pub const USER_MARSHAL_FC_SMALL: u32 = 3;
pub const USER_MARSHAL_FC_USMALL: u32 = 4;
pub const USER_MARSHAL_FC_WCHAR: u32 = 5;
pub const USER_MARSHAL_FC_SHORT: u32 = 6;
pub const USER_MARSHAL_FC_USHORT: u32 = 7;
pub const USER_MARSHAL_FC_LONG: u32 = 8;
pub const USER_MARSHAL_FC_ULONG: u32 = 9;
pub const USER_MARSHAL_FC_FLOAT: u32 = 10;
pub const USER_MARSHAL_FC_HYPER: u32 = 11;
pub const USER_MARSHAL_FC_DOUBLE: u32 = 12;
pub const ROTREGFLAGS_ALLOWANYCLIENT: u32 = 1;
pub const APPIDREGFLAGS_ACTIVATE_IUSERVER_INDESKTOP: u32 = 1;
pub const APPIDREGFLAGS_SECURE_SERVER_PROCESS_SD_AND_BIND: u32 = 2;
pub const APPIDREGFLAGS_ISSUE_ACTIVATION_RPC_AT_IDENTIFY: u32 = 4;
pub const APPIDREGFLAGS_IUSERVER_UNMODIFIED_LOGON_TOKEN: u32 = 8;
pub const APPIDREGFLAGS_IUSERVER_SELF_SID_IN_LAUNCH_PERMISSION: u32 = 16;
pub const APPIDREGFLAGS_IUSERVER_ACTIVATE_IN_CLIENT_SESSION_ONLY: u32 = 32;
pub const APPIDREGFLAGS_RESERVED1: u32 = 64;
pub const APPIDREGFLAGS_RESERVED2: u32 = 128;
pub const APPIDREGFLAGS_RESERVED3: u32 = 256;
pub const APPIDREGFLAGS_RESERVED4: u32 = 512;
pub const APPIDREGFLAGS_RESERVED5: u32 = 1024;
pub const APPIDREGFLAGS_AAA_NO_IMPLICIT_ACTIVATE_AS_IU: u32 = 2048;
pub const APPIDREGFLAGS_RESERVED7: u32 = 4096;
pub const APPIDREGFLAGS_RESERVED8: u32 = 8192;
pub const APPIDREGFLAGS_RESERVED9: u32 = 16384;
pub const DCOMSCM_ACTIVATION_USE_ALL_AUTHNSERVICES: u32 = 1;
pub const DCOMSCM_ACTIVATION_DISALLOW_UNSECURE_CALL: u32 = 2;
pub const DCOMSCM_RESOLVE_USE_ALL_AUTHNSERVICES: u32 = 4;
pub const DCOMSCM_RESOLVE_DISALLOW_UNSECURE_CALL: u32 = 8;
pub const DCOMSCM_PING_USE_MID_AUTHNSERVICE: u32 = 16;
pub const DCOMSCM_PING_DISALLOW_UNSECURE_CALL: u32 = 32;
pub const ROTFLAGS_REGISTRATIONKEEPSALIVE: u32 = 1;
pub const ROTFLAGS_ALLOWANYCLIENT: u32 = 2;
pub const ROT_COMPARE_MAX: u32 = 2048;
pub const WDT_INPROC_CALL: u32 = 1215587415;
pub const WDT_REMOTE_CALL: u32 = 1383359575;
pub const WDT_INPROC64_CALL: u32 = 1349805143;
pub const FILE_DEVICE_BEEP: u32 = 1;
pub const FILE_DEVICE_CD_ROM: u32 = 2;
pub const FILE_DEVICE_CD_ROM_FILE_SYSTEM: u32 = 3;
pub const FILE_DEVICE_CONTROLLER: u32 = 4;
pub const FILE_DEVICE_DATALINK: u32 = 5;
pub const FILE_DEVICE_DFS: u32 = 6;
pub const FILE_DEVICE_DISK: u32 = 7;
pub const FILE_DEVICE_DISK_FILE_SYSTEM: u32 = 8;
pub const FILE_DEVICE_FILE_SYSTEM: u32 = 9;
pub const FILE_DEVICE_INPORT_PORT: u32 = 10;
pub const FILE_DEVICE_KEYBOARD: u32 = 11;
pub const FILE_DEVICE_MAILSLOT: u32 = 12;
pub const FILE_DEVICE_MIDI_IN: u32 = 13;
pub const FILE_DEVICE_MIDI_OUT: u32 = 14;
pub const FILE_DEVICE_MOUSE: u32 = 15;
pub const FILE_DEVICE_MULTI_UNC_PROVIDER: u32 = 16;
pub const FILE_DEVICE_NAMED_PIPE: u32 = 17;
pub const FILE_DEVICE_NETWORK: u32 = 18;
pub const FILE_DEVICE_NETWORK_BROWSER: u32 = 19;
pub const FILE_DEVICE_NETWORK_FILE_SYSTEM: u32 = 20;
pub const FILE_DEVICE_NULL: u32 = 21;
pub const FILE_DEVICE_PARALLEL_PORT: u32 = 22;
pub const FILE_DEVICE_PHYSICAL_NETCARD: u32 = 23;
pub const FILE_DEVICE_PRINTER: u32 = 24;
pub const FILE_DEVICE_SCANNER: u32 = 25;
pub const FILE_DEVICE_SERIAL_MOUSE_PORT: u32 = 26;
pub const FILE_DEVICE_SERIAL_PORT: u32 = 27;
pub const FILE_DEVICE_SCREEN: u32 = 28;
pub const FILE_DEVICE_SOUND: u32 = 29;
pub const FILE_DEVICE_STREAMS: u32 = 30;
pub const FILE_DEVICE_TAPE: u32 = 31;
pub const FILE_DEVICE_TAPE_FILE_SYSTEM: u32 = 32;
pub const FILE_DEVICE_TRANSPORT: u32 = 33;
pub const FILE_DEVICE_UNKNOWN: u32 = 34;
pub const FILE_DEVICE_VIDEO: u32 = 35;
pub const FILE_DEVICE_VIRTUAL_DISK: u32 = 36;
pub const FILE_DEVICE_WAVE_IN: u32 = 37;
pub const FILE_DEVICE_WAVE_OUT: u32 = 38;
pub const FILE_DEVICE_8042_PORT: u32 = 39;
pub const FILE_DEVICE_NETWORK_REDIRECTOR: u32 = 40;
pub const FILE_DEVICE_BATTERY: u32 = 41;
pub const FILE_DEVICE_BUS_EXTENDER: u32 = 42;
pub const FILE_DEVICE_MODEM: u32 = 43;
pub const FILE_DEVICE_VDM: u32 = 44;
pub const FILE_DEVICE_MASS_STORAGE: u32 = 45;
pub const FILE_DEVICE_SMB: u32 = 46;
pub const FILE_DEVICE_KS: u32 = 47;
pub const FILE_DEVICE_CHANGER: u32 = 48;
pub const FILE_DEVICE_SMARTCARD: u32 = 49;
pub const FILE_DEVICE_ACPI: u32 = 50;
pub const FILE_DEVICE_DVD: u32 = 51;
pub const FILE_DEVICE_FULLSCREEN_VIDEO: u32 = 52;
pub const FILE_DEVICE_DFS_FILE_SYSTEM: u32 = 53;
pub const FILE_DEVICE_DFS_VOLUME: u32 = 54;
pub const FILE_DEVICE_SERENUM: u32 = 55;
pub const FILE_DEVICE_TERMSRV: u32 = 56;
pub const FILE_DEVICE_KSEC: u32 = 57;
pub const FILE_DEVICE_FIPS: u32 = 58;
pub const FILE_DEVICE_INFINIBAND: u32 = 59;
pub const FILE_DEVICE_VMBUS: u32 = 62;
pub const FILE_DEVICE_CRYPT_PROVIDER: u32 = 63;
pub const FILE_DEVICE_WPD: u32 = 64;
pub const FILE_DEVICE_BLUETOOTH: u32 = 65;
pub const FILE_DEVICE_MT_COMPOSITE: u32 = 66;
pub const FILE_DEVICE_MT_TRANSPORT: u32 = 67;
pub const FILE_DEVICE_BIOMETRIC: u32 = 68;
pub const FILE_DEVICE_PMI: u32 = 69;
pub const FILE_DEVICE_EHSTOR: u32 = 70;
pub const FILE_DEVICE_DEVAPI: u32 = 71;
pub const FILE_DEVICE_GPIO: u32 = 72;
pub const FILE_DEVICE_USBEX: u32 = 73;
pub const FILE_DEVICE_CONSOLE: u32 = 80;
pub const FILE_DEVICE_NFP: u32 = 81;
pub const FILE_DEVICE_SYSENV: u32 = 82;
pub const FILE_DEVICE_VIRTUAL_BLOCK: u32 = 83;
pub const FILE_DEVICE_POINT_OF_SERVICE: u32 = 84;
pub const FILE_DEVICE_STORAGE_REPLICATION: u32 = 85;
pub const FILE_DEVICE_TRUST_ENV: u32 = 86;
pub const FILE_DEVICE_UCM: u32 = 87;
pub const FILE_DEVICE_UCMTCPCI: u32 = 88;
pub const FILE_DEVICE_PERSISTENT_MEMORY: u32 = 89;
pub const FILE_DEVICE_NVDIMM: u32 = 90;
pub const FILE_DEVICE_HOLOGRAPHIC: u32 = 91;
pub const FILE_DEVICE_SDFXHCI: u32 = 92;
pub const FILE_DEVICE_UCMUCSI: u32 = 93;
pub const FILE_DEVICE_PRM: u32 = 94;
pub const FILE_DEVICE_EVENT_COLLECTOR: u32 = 95;
pub const FILE_DEVICE_USB4: u32 = 96;
pub const FILE_DEVICE_SOUNDWIRE: u32 = 97;
pub const METHOD_BUFFERED: u32 = 0;
pub const METHOD_IN_DIRECT: u32 = 1;
pub const METHOD_OUT_DIRECT: u32 = 2;
pub const METHOD_NEITHER: u32 = 3;
pub const METHOD_DIRECT_TO_HARDWARE: u32 = 1;
pub const METHOD_DIRECT_FROM_HARDWARE: u32 = 2;
pub const FILE_ANY_ACCESS: u32 = 0;
pub const FILE_SPECIAL_ACCESS: u32 = 0;
pub const FILE_READ_ACCESS: u32 = 1;
pub const FILE_WRITE_ACCESS: u32 = 2;
pub const IOCTL_STORAGE_BASE: u32 = 45;
pub const STORAGE_DEVICE_FLAGS_RANDOM_DEVICEGUID_REASON_CONFLICT: u32 = 1;
pub const STORAGE_DEVICE_FLAGS_RANDOM_DEVICEGUID_REASON_NOHWID: u32 = 2;
pub const STORAGE_DEVICE_FLAGS_PAGE_83_DEVICEGUID: u32 = 4;
pub const RECOVERED_WRITES_VALID: u32 = 1;
pub const UNRECOVERED_WRITES_VALID: u32 = 2;
pub const RECOVERED_READS_VALID: u32 = 4;
pub const UNRECOVERED_READS_VALID: u32 = 8;
pub const WRITE_COMPRESSION_INFO_VALID: u32 = 16;
pub const READ_COMPRESSION_INFO_VALID: u32 = 32;
pub const TAPE_RETURN_STATISTICS: u32 = 0;
pub const TAPE_RETURN_ENV_INFO: u32 = 1;
pub const TAPE_RESET_STATISTICS: u32 = 2;
pub const MEDIA_ERASEABLE: u32 = 1;
pub const MEDIA_WRITE_ONCE: u32 = 2;
pub const MEDIA_READ_ONLY: u32 = 4;
pub const MEDIA_READ_WRITE: u32 = 8;
pub const MEDIA_WRITE_PROTECTED: u32 = 256;
pub const MEDIA_CURRENTLY_MOUNTED: u32 = 2147483648;
pub const STORAGE_FAILURE_PREDICTION_CONFIG_V1: u32 = 1;
pub const SRB_TYPE_SCSI_REQUEST_BLOCK: u32 = 0;
pub const SRB_TYPE_STORAGE_REQUEST_BLOCK: u32 = 1;
pub const STORAGE_ADDRESS_TYPE_BTL8: u32 = 0;
pub const STORAGE_RPMB_DESCRIPTOR_VERSION_1: u32 = 1;
pub const STORAGE_RPMB_MINIMUM_RELIABLE_WRITE_SIZE: u32 = 512;
pub const STORAGE_CRYPTO_CAPABILITY_VERSION_1: u32 = 1;
pub const STORAGE_CRYPTO_DESCRIPTOR_VERSION_1: u32 = 1;
pub const STORAGE_TIER_NAME_LENGTH: u32 = 256;
pub const STORAGE_TIER_DESCRIPTION_LENGTH: u32 = 512;
pub const STORAGE_TIER_FLAG_NO_SEEK_PENALTY: u32 = 131072;
pub const STORAGE_TIER_FLAG_WRITE_BACK_CACHE: u32 = 2097152;
pub const STORAGE_TIER_FLAG_READ_CACHE: u32 = 4194304;
pub const STORAGE_TIER_FLAG_PARITY: u32 = 8388608;
pub const STORAGE_TIER_FLAG_SMR: u32 = 16777216;
pub const STORAGE_TEMPERATURE_VALUE_NOT_REPORTED: u32 = 32768;
pub const STORAGE_TEMPERATURE_THRESHOLD_FLAG_ADAPTER_REQUEST: u32 = 1;
pub const STORAGE_COMPONENT_ROLE_CACHE: u32 = 1;
pub const STORAGE_COMPONENT_ROLE_TIERING: u32 = 2;
pub const STORAGE_COMPONENT_ROLE_DATA: u32 = 4;
pub const STORAGE_ATTRIBUTE_BYTE_ADDRESSABLE_IO: u32 = 1;
pub const STORAGE_ATTRIBUTE_BLOCK_IO: u32 = 2;
pub const STORAGE_ATTRIBUTE_DYNAMIC_PERSISTENCE: u32 = 4;
pub const STORAGE_ATTRIBUTE_VOLATILE: u32 = 8;
pub const STORAGE_ATTRIBUTE_ASYNC_EVENT_NOTIFICATION: u32 = 16;
pub const STORAGE_ATTRIBUTE_PERF_SIZE_INDEPENDENT: u32 = 32;
pub const STORAGE_DEVICE_MAX_OPERATIONAL_STATUS: u32 = 16;
pub const STORAGE_ADAPTER_SERIAL_NUMBER_V1_MAX_LENGTH: u32 = 128;
pub const STORAGE_DEVICE_NUMA_NODE_UNKNOWN: u32 = 4294967295;
pub const DeviceDsmActionFlag_NonDestructive: u32 = 2147483648;
pub const DeviceDsmAction_None: u32 = 0;
pub const DeviceDsmAction_Trim: u32 = 1;
pub const DeviceDsmAction_Notification: u32 = 2147483650;
pub const DeviceDsmAction_OffloadRead: u32 = 2147483651;
pub const DeviceDsmAction_OffloadWrite: u32 = 4;
pub const DeviceDsmAction_Allocation: u32 = 2147483653;
pub const DeviceDsmAction_Repair: u32 = 2147483654;
pub const DeviceDsmAction_Scrub: u32 = 2147483655;
pub const DeviceDsmAction_DrtQuery: u32 = 2147483656;
pub const DeviceDsmAction_DrtClear: u32 = 2147483657;
pub const DeviceDsmAction_DrtDisable: u32 = 2147483658;
pub const DeviceDsmAction_TieringQuery: u32 = 2147483659;
pub const DeviceDsmAction_Map: u32 = 2147483660;
pub const DeviceDsmAction_RegenerateParity: u32 = 2147483661;
pub const DeviceDsmAction_NvCache_Change_Priority: u32 = 2147483662;
pub const DeviceDsmAction_NvCache_Evict: u32 = 2147483663;
pub const DeviceDsmAction_TopologyIdQuery: u32 = 2147483664;
pub const DeviceDsmAction_GetPhysicalAddresses: u32 = 2147483665;
pub const DeviceDsmAction_ScopeRegen: u32 = 2147483666;
pub const DeviceDsmAction_ReportZones: u32 = 2147483667;
pub const DeviceDsmAction_OpenZone: u32 = 2147483668;
pub const DeviceDsmAction_FinishZone: u32 = 2147483669;
pub const DeviceDsmAction_CloseZone: u32 = 2147483670;
pub const DeviceDsmAction_ResetWritePointer: u32 = 23;
pub const DeviceDsmAction_GetRangeErrorInfo: u32 = 2147483672;
pub const DeviceDsmAction_WriteZeroes: u32 = 25;
pub const DeviceDsmAction_LostQuery: u32 = 2147483674;
pub const DeviceDsmAction_GetFreeSpace: u32 = 2147483675;
pub const DeviceDsmAction_ConversionQuery: u32 = 2147483676;
pub const DeviceDsmAction_VdtSet: u32 = 29;
pub const DEVICE_DSM_FLAG_ENTIRE_DATA_SET_RANGE: u32 = 1;
pub const DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED: u32 = 2147483648;
pub const DEVICE_DSM_FLAG_TRIM_BYPASS_RZAT: u32 = 1073741824;
pub const DEVICE_DSM_NOTIFY_FLAG_BEGIN: u32 = 1;
pub const DEVICE_DSM_NOTIFY_FLAG_END: u32 = 2;
pub const STORAGE_OFFLOAD_MAX_TOKEN_LENGTH: u32 = 512;
pub const STORAGE_OFFLOAD_TOKEN_ID_LENGTH: u32 = 504;
pub const STORAGE_OFFLOAD_TOKEN_TYPE_ZERO_DATA: u32 = 4294901761;
pub const STORAGE_OFFLOAD_READ_RANGE_TRUNCATED: u32 = 1;
pub const STORAGE_OFFLOAD_WRITE_RANGE_TRUNCATED: u32 = 1;
pub const STORAGE_OFFLOAD_TOKEN_INVALID: u32 = 2;
pub const DEVICE_DSM_FLAG_ALLOCATION_CONSOLIDATEABLE_ONLY: u32 = 1073741824;
pub const DEVICE_DSM_PARAMETERS_V1: u32 = 1;
pub const DEVICE_DATA_SET_LBP_STATE_PARAMETERS_VERSION_V1: u32 = 1;
pub const DEVICE_DSM_FLAG_REPAIR_INPUT_TOPOLOGY_ID_PRESENT: u32 = 1073741824;
pub const DEVICE_DSM_FLAG_REPAIR_OUTPUT_PARITY_EXTENT: u32 = 536870912;
pub const DEVICE_DSM_FLAG_SCRUB_SKIP_IN_SYNC: u32 = 268435456;
pub const DEVICE_DSM_FLAG_SCRUB_OUTPUT_PARITY_EXTENT: u32 = 536870912;
pub const DEVICE_DSM_FLAG_PHYSICAL_ADDRESSES_OMIT_TOTAL_RANGES: u32 = 268435456;
pub const DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT_V1: u32 = 1;
pub const DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT_VERSION_V1: u32 = 1;
pub const DEVICE_STORAGE_NO_ERRORS: u32 = 1;
pub const DEVICE_DSM_RANGE_ERROR_OUTPUT_V1: u32 = 1;
pub const DEVICE_DSM_RANGE_ERROR_INFO_VERSION_V1: u32 = 1;
pub const IOCTL_STORAGE_BC_VERSION: u32 = 1;
pub const STORAGE_PRIORITY_HINT_SUPPORTED: u32 = 1;
pub const STORAGE_DIAGNOSTIC_FLAG_ADAPTER_REQUEST: u32 = 1;
pub const ERROR_HISTORY_DIRECTORY_ENTRY_DEFAULT_COUNT: u32 = 8;
pub const DEVICEDUMP_STRUCTURE_VERSION_V1: u32 = 1;
pub const DEVICEDUMP_MAX_IDSTRING: u32 = 32;
pub const MAX_FW_BUCKET_ID_LENGTH: u32 = 132;
pub const STORAGE_CRASH_TELEMETRY_REGKEY: &[u8; 81] =
    b"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\CrashControl\\StorageTelemetry\0";
pub const STORAGE_DEVICE_TELEMETRY_REGKEY: &[u8; 76] =
    b"\\Registry\\Machine\\System\\CurrentControlSet\\Control\\Storage\\StorageTelemetry\0";
pub const DDUMP_FLAG_DATA_READ_FROM_DEVICE: u32 = 1;
pub const FW_ISSUEID_NO_ISSUE: u32 = 0;
pub const FW_ISSUEID_UNKNOWN: u32 = 4294967295;
pub const TC_PUBLIC_DEVICEDUMP_CONTENT_SMART: u32 = 1;
pub const TC_PUBLIC_DEVICEDUMP_CONTENT_GPLOG: u32 = 2;
pub const TC_PUBLIC_DEVICEDUMP_CONTENT_GPLOG_MAX: u32 = 16;
pub const TC_DEVICEDUMP_SUBSECTION_DESC_LENGTH: u32 = 16;
pub const TC_PUBLIC_DATA_TYPE_ATAGP: &[u8; 14] = b"ATAGPLogPages\0";
pub const TC_PUBLIC_DATA_TYPE_ATASMART: &[u8; 14] = b"ATASMARTPages\0";
pub const CDB_SIZE: u32 = 16;
pub const TELEMETRY_COMMAND_SIZE: u32 = 16;
pub const DEVICEDUMP_CAP_PRIVATE_SECTION: u32 = 1;
pub const DEVICEDUMP_CAP_RESTRICTED_SECTION: u32 = 2;
pub const STORAGE_IDLE_POWERUP_REASON_VERSION_V1: u32 = 1;
pub const STORAGE_DEVICE_POWER_CAP_VERSION_V1: u32 = 1;
pub const STORAGE_EVENT_NOTIFICATION_VERSION_V1: u32 = 1;
pub const STORAGE_EVENT_MEDIA_STATUS: u32 = 1;
pub const STORAGE_EVENT_DEVICE_STATUS: u32 = 2;
pub const STORAGE_EVENT_DEVICE_OPERATION: u32 = 4;
pub const STORAGE_EVENT_ALL: u32 = 7;
pub const READ_COPY_NUMBER_KEY: u32 = 1380142592;
pub const READ_COPY_NUMBER_BYPASS_CACHE_FLAG: u32 = 256;
pub const STORAGE_HW_FIRMWARE_REQUEST_FLAG_CONTROLLER: u32 = 1;
pub const STORAGE_HW_FIRMWARE_REQUEST_FLAG_LAST_SEGMENT: u32 = 2;
pub const STORAGE_HW_FIRMWARE_REQUEST_FLAG_FIRST_SEGMENT: u32 = 4;
pub const STORAGE_HW_FIRMWARE_REQUEST_FLAG_SWITCH_TO_EXISTING_FIRMWARE: u32 = 2147483648;
pub const STORAGE_HW_FIRMWARE_INVALID_SLOT: u32 = 255;
pub const STORAGE_HW_FIRMWARE_REVISION_LENGTH: u32 = 16;
pub const STORAGE_PROTOCOL_STRUCTURE_VERSION: u32 = 1;
pub const STORAGE_PROTOCOL_COMMAND_FLAG_ADAPTER_REQUEST: u32 = 2147483648;
pub const STORAGE_PROTOCOL_STATUS_PENDING: u32 = 0;
pub const STORAGE_PROTOCOL_STATUS_SUCCESS: u32 = 1;
pub const STORAGE_PROTOCOL_STATUS_ERROR: u32 = 2;
pub const STORAGE_PROTOCOL_STATUS_INVALID_REQUEST: u32 = 3;
pub const STORAGE_PROTOCOL_STATUS_NO_DEVICE: u32 = 4;
pub const STORAGE_PROTOCOL_STATUS_BUSY: u32 = 5;
pub const STORAGE_PROTOCOL_STATUS_DATA_OVERRUN: u32 = 6;
pub const STORAGE_PROTOCOL_STATUS_INSUFFICIENT_RESOURCES: u32 = 7;
pub const STORAGE_PROTOCOL_STATUS_THROTTLED_REQUEST: u32 = 8;
pub const STORAGE_PROTOCOL_STATUS_NOT_SUPPORTED: u32 = 255;
pub const STORAGE_PROTOCOL_COMMAND_LENGTH_NVME: u32 = 64;
pub const STORAGE_PROTOCOL_SPECIFIC_NVME_ADMIN_COMMAND: u32 = 1;
pub const STORAGE_PROTOCOL_SPECIFIC_NVME_NVM_COMMAND: u32 = 2;
pub const STORATTRIBUTE_NONE: u32 = 0;
pub const STORATTRIBUTE_MANAGEMENT_STATE: u32 = 1;
pub const IOCTL_SCMBUS_BASE: u32 = 89;
pub const IOCTL_SCMBUS_DEVICE_FUNCTION_BASE: u32 = 0;
pub const IOCTL_SCM_LOGICAL_DEVICE_FUNCTION_BASE: u32 = 768;
pub const IOCTL_SCM_PHYSICAL_DEVICE_FUNCTION_BASE: u32 = 1536;
pub const SCM_MAX_SYMLINK_LEN_IN_CHARS: u32 = 256;
pub const MAX_INTERFACE_CODES: u32 = 8;
pub const SCM_PD_FIRMWARE_REVISION_LENGTH_BYTES: u32 = 32;
pub const SCM_PD_PROPERTY_NAME_LENGTH_IN_CHARS: u32 = 128;
pub const SCM_PD_MAX_OPERATIONAL_STATUS: u32 = 16;
pub const SCM_PD_FIRMWARE_LAST_DOWNLOAD: u32 = 1;
pub const IOCTL_DISK_BASE: u32 = 7;
pub const PARTITION_ENTRY_UNUSED: u32 = 0;
pub const PARTITION_FAT_12: u32 = 1;
pub const PARTITION_XENIX_1: u32 = 2;
pub const PARTITION_XENIX_2: u32 = 3;
pub const PARTITION_FAT_16: u32 = 4;
pub const PARTITION_EXTENDED: u32 = 5;
pub const PARTITION_HUGE: u32 = 6;
pub const PARTITION_IFS: u32 = 7;
pub const PARTITION_OS2BOOTMGR: u32 = 10;
pub const PARTITION_FAT32: u32 = 11;
pub const PARTITION_FAT32_XINT13: u32 = 12;
pub const PARTITION_XINT13: u32 = 14;
pub const PARTITION_XINT13_EXTENDED: u32 = 15;
pub const PARTITION_MSFT_RECOVERY: u32 = 39;
pub const PARTITION_MAIN_OS: u32 = 40;
pub const PARTIITON_OS_DATA: u32 = 41;
pub const PARTITION_PRE_INSTALLED: u32 = 42;
pub const PARTITION_BSP: u32 = 43;
pub const PARTITION_DPP: u32 = 44;
pub const PARTITION_WINDOWS_SYSTEM: u32 = 45;
pub const PARTITION_PREP: u32 = 65;
pub const PARTITION_LDM: u32 = 66;
pub const PARTITION_DM: u32 = 84;
pub const PARTITION_EZDRIVE: u32 = 85;
pub const PARTITION_UNIX: u32 = 99;
pub const PARTITION_SPACES_DATA: u32 = 215;
pub const PARTITION_SPACES: u32 = 231;
pub const PARTITION_GPT: u32 = 238;
pub const PARTITION_SYSTEM: u32 = 239;
pub const VALID_NTFT: u32 = 192;
pub const PARTITION_NTFT: u32 = 128;
pub const GPT_ATTRIBUTE_PLATFORM_REQUIRED: u32 = 1;
pub const GPT_ATTRIBUTE_NO_BLOCK_IO_PROTOCOL: u32 = 2;
pub const GPT_ATTRIBUTE_LEGACY_BIOS_BOOTABLE: u32 = 4;
pub const GPT_BASIC_DATA_ATTRIBUTE_NO_DRIVE_LETTER: i64 = -9223372036854775808;
pub const GPT_BASIC_DATA_ATTRIBUTE_HIDDEN: u64 = 4611686018427387904;
pub const GPT_BASIC_DATA_ATTRIBUTE_SHADOW_COPY: u64 = 2305843009213693952;
pub const GPT_BASIC_DATA_ATTRIBUTE_READ_ONLY: u64 = 1152921504606846976;
pub const GPT_BASIC_DATA_ATTRIBUTE_OFFLINE: u64 = 576460752303423488;
pub const GPT_BASIC_DATA_ATTRIBUTE_DAX: u64 = 288230376151711744;
pub const GPT_BASIC_DATA_ATTRIBUTE_SERVICE: u64 = 144115188075855872;
pub const GPT_SPACES_ATTRIBUTE_NO_METADATA: i64 = -9223372036854775808;
pub const HIST_NO_OF_BUCKETS: u32 = 24;
pub const DISK_LOGGING_START: u32 = 0;
pub const DISK_LOGGING_STOP: u32 = 1;
pub const DISK_LOGGING_DUMP: u32 = 2;
pub const DISK_BINNING: u32 = 3;
pub const CAP_ATA_ID_CMD: u32 = 1;
pub const CAP_ATAPI_ID_CMD: u32 = 2;
pub const CAP_SMART_CMD: u32 = 4;
pub const ATAPI_ID_CMD: u32 = 161;
pub const ID_CMD: u32 = 236;
pub const SMART_CMD: u32 = 176;
pub const SMART_CYL_LOW: u32 = 79;
pub const SMART_CYL_HI: u32 = 194;
pub const SMART_NO_ERROR: u32 = 0;
pub const SMART_IDE_ERROR: u32 = 1;
pub const SMART_INVALID_FLAG: u32 = 2;
pub const SMART_INVALID_COMMAND: u32 = 3;
pub const SMART_INVALID_BUFFER: u32 = 4;
pub const SMART_INVALID_DRIVE: u32 = 5;
pub const SMART_INVALID_IOCTL: u32 = 6;
pub const SMART_ERROR_NO_MEM: u32 = 7;
pub const SMART_INVALID_REGISTER: u32 = 8;
pub const SMART_NOT_SUPPORTED: u32 = 9;
pub const SMART_NO_IDE_DEVICE: u32 = 10;
pub const SMART_OFFLINE_ROUTINE_OFFLINE: u32 = 0;
pub const SMART_SHORT_SELFTEST_OFFLINE: u32 = 1;
pub const SMART_EXTENDED_SELFTEST_OFFLINE: u32 = 2;
pub const SMART_ABORT_OFFLINE_SELFTEST: u32 = 127;
pub const SMART_SHORT_SELFTEST_CAPTIVE: u32 = 129;
pub const SMART_EXTENDED_SELFTEST_CAPTIVE: u32 = 130;
pub const READ_ATTRIBUTE_BUFFER_SIZE: u32 = 512;
pub const IDENTIFY_BUFFER_SIZE: u32 = 512;
pub const READ_THRESHOLD_BUFFER_SIZE: u32 = 512;
pub const SMART_LOG_SECTOR_SIZE: u32 = 512;
pub const READ_ATTRIBUTES: u32 = 208;
pub const READ_THRESHOLDS: u32 = 209;
pub const ENABLE_DISABLE_AUTOSAVE: u32 = 210;
pub const SAVE_ATTRIBUTE_VALUES: u32 = 211;
pub const EXECUTE_OFFLINE_DIAGS: u32 = 212;
pub const SMART_READ_LOG: u32 = 213;
pub const SMART_WRITE_LOG: u32 = 214;
pub const ENABLE_SMART: u32 = 216;
pub const DISABLE_SMART: u32 = 217;
pub const RETURN_SMART_STATUS: u32 = 218;
pub const ENABLE_DISABLE_AUTO_OFFLINE: u32 = 219;
pub const DISK_ATTRIBUTE_OFFLINE: u32 = 1;
pub const DISK_ATTRIBUTE_READ_ONLY: u32 = 2;
pub const IOCTL_CHANGER_BASE: u32 = 48;
pub const MAX_VOLUME_ID_SIZE: u32 = 36;
pub const MAX_VOLUME_TEMPLATE_SIZE: u32 = 40;
pub const VENDOR_ID_LENGTH: u32 = 8;
pub const PRODUCT_ID_LENGTH: u32 = 16;
pub const REVISION_LENGTH: u32 = 4;
pub const SERIAL_NUMBER_LENGTH: u32 = 32;
pub const CHANGER_BAR_CODE_SCANNER_INSTALLED: u32 = 1;
pub const CHANGER_INIT_ELEM_STAT_WITH_RANGE: u32 = 2;
pub const CHANGER_CLOSE_IEPORT: u32 = 4;
pub const CHANGER_OPEN_IEPORT: u32 = 8;
pub const CHANGER_STATUS_NON_VOLATILE: u32 = 16;
pub const CHANGER_EXCHANGE_MEDIA: u32 = 32;
pub const CHANGER_CLEANER_SLOT: u32 = 64;
pub const CHANGER_LOCK_UNLOCK: u32 = 128;
pub const CHANGER_CARTRIDGE_MAGAZINE: u32 = 256;
pub const CHANGER_MEDIUM_FLIP: u32 = 512;
pub const CHANGER_POSITION_TO_ELEMENT: u32 = 1024;
pub const CHANGER_REPORT_IEPORT_STATE: u32 = 2048;
pub const CHANGER_STORAGE_DRIVE: u32 = 4096;
pub const CHANGER_STORAGE_IEPORT: u32 = 8192;
pub const CHANGER_STORAGE_SLOT: u32 = 16384;
pub const CHANGER_STORAGE_TRANSPORT: u32 = 32768;
pub const CHANGER_DRIVE_CLEANING_REQUIRED: u32 = 65536;
pub const CHANGER_PREDISMOUNT_EJECT_REQUIRED: u32 = 131072;
pub const CHANGER_CLEANER_ACCESS_NOT_VALID: u32 = 262144;
pub const CHANGER_PREMOUNT_EJECT_REQUIRED: u32 = 524288;
pub const CHANGER_VOLUME_IDENTIFICATION: u32 = 1048576;
pub const CHANGER_VOLUME_SEARCH: u32 = 2097152;
pub const CHANGER_VOLUME_ASSERT: u32 = 4194304;
pub const CHANGER_VOLUME_REPLACE: u32 = 8388608;
pub const CHANGER_VOLUME_UNDEFINE: u32 = 16777216;
pub const CHANGER_SERIAL_NUMBER_VALID: u32 = 67108864;
pub const CHANGER_DEVICE_REINITIALIZE_CAPABLE: u32 = 134217728;
pub const CHANGER_KEYPAD_ENABLE_DISABLE: u32 = 268435456;
pub const CHANGER_DRIVE_EMPTY_ON_DOOR_ACCESS: u32 = 536870912;
pub const CHANGER_RESERVED_BIT: u32 = 2147483648;
pub const CHANGER_PREDISMOUNT_ALIGN_TO_SLOT: u32 = 2147483649;
pub const CHANGER_PREDISMOUNT_ALIGN_TO_DRIVE: u32 = 2147483650;
pub const CHANGER_CLEANER_AUTODISMOUNT: u32 = 2147483652;
pub const CHANGER_TRUE_EXCHANGE_CAPABLE: u32 = 2147483656;
pub const CHANGER_SLOTS_USE_TRAYS: u32 = 2147483664;
pub const CHANGER_RTN_MEDIA_TO_ORIGINAL_ADDR: u32 = 2147483680;
pub const CHANGER_CLEANER_OPS_NOT_SUPPORTED: u32 = 2147483712;
pub const CHANGER_IEPORT_USER_CONTROL_OPEN: u32 = 2147483776;
pub const CHANGER_IEPORT_USER_CONTROL_CLOSE: u32 = 2147483904;
pub const CHANGER_MOVE_EXTENDS_IEPORT: u32 = 2147484160;
pub const CHANGER_MOVE_RETRACTS_IEPORT: u32 = 2147484672;
pub const CHANGER_TO_TRANSPORT: u32 = 1;
pub const CHANGER_TO_SLOT: u32 = 2;
pub const CHANGER_TO_IEPORT: u32 = 4;
pub const CHANGER_TO_DRIVE: u32 = 8;
pub const LOCK_UNLOCK_IEPORT: u32 = 1;
pub const LOCK_UNLOCK_DOOR: u32 = 2;
pub const LOCK_UNLOCK_KEYPAD: u32 = 4;
pub const LOCK_ELEMENT: u32 = 0;
pub const UNLOCK_ELEMENT: u32 = 1;
pub const EXTEND_IEPORT: u32 = 2;
pub const RETRACT_IEPORT: u32 = 3;
pub const ELEMENT_STATUS_FULL: u32 = 1;
pub const ELEMENT_STATUS_IMPEXP: u32 = 2;
pub const ELEMENT_STATUS_EXCEPT: u32 = 4;
pub const ELEMENT_STATUS_ACCESS: u32 = 8;
pub const ELEMENT_STATUS_EXENAB: u32 = 16;
pub const ELEMENT_STATUS_INENAB: u32 = 32;
pub const ELEMENT_STATUS_PRODUCT_DATA: u32 = 64;
pub const ELEMENT_STATUS_LUN_VALID: u32 = 4096;
pub const ELEMENT_STATUS_ID_VALID: u32 = 8192;
pub const ELEMENT_STATUS_NOT_BUS: u32 = 32768;
pub const ELEMENT_STATUS_INVERT: u32 = 4194304;
pub const ELEMENT_STATUS_SVALID: u32 = 8388608;
pub const ELEMENT_STATUS_PVOLTAG: u32 = 268435456;
pub const ELEMENT_STATUS_AVOLTAG: u32 = 536870912;
pub const ERROR_LABEL_UNREADABLE: u32 = 1;
pub const ERROR_LABEL_QUESTIONABLE: u32 = 2;
pub const ERROR_SLOT_NOT_PRESENT: u32 = 4;
pub const ERROR_DRIVE_NOT_INSTALLED: u32 = 8;
pub const ERROR_TRAY_MALFUNCTION: u32 = 16;
pub const ERROR_INIT_STATUS_NEEDED: u32 = 17;
pub const ERROR_UNHANDLED_ERROR: u32 = 4294967295;
pub const SEARCH_ALL: u32 = 0;
pub const SEARCH_PRIMARY: u32 = 1;
pub const SEARCH_ALTERNATE: u32 = 2;
pub const SEARCH_ALL_NO_SEQ: u32 = 4;
pub const SEARCH_PRI_NO_SEQ: u32 = 5;
pub const SEARCH_ALT_NO_SEQ: u32 = 6;
pub const ASSERT_PRIMARY: u32 = 8;
pub const ASSERT_ALTERNATE: u32 = 9;
pub const REPLACE_PRIMARY: u32 = 10;
pub const REPLACE_ALTERNATE: u32 = 11;
pub const UNDEFINE_PRIMARY: u32 = 12;
pub const UNDEFINE_ALTERNATE: u32 = 13;
pub const GET_VOLUME_BITMAP_FLAG_MASK_METADATA: u32 = 1;
pub const FLAG_USN_TRACK_MODIFIED_RANGES_ENABLE: u32 = 1;
pub const USN_PAGE_SIZE: u32 = 4096;
pub const USN_REASON_DATA_OVERWRITE: u32 = 1;
pub const USN_REASON_DATA_EXTEND: u32 = 2;
pub const USN_REASON_DATA_TRUNCATION: u32 = 4;
pub const USN_REASON_NAMED_DATA_OVERWRITE: u32 = 16;
pub const USN_REASON_NAMED_DATA_EXTEND: u32 = 32;
pub const USN_REASON_NAMED_DATA_TRUNCATION: u32 = 64;
pub const USN_REASON_FILE_CREATE: u32 = 256;
pub const USN_REASON_FILE_DELETE: u32 = 512;
pub const USN_REASON_EA_CHANGE: u32 = 1024;
pub const USN_REASON_SECURITY_CHANGE: u32 = 2048;
pub const USN_REASON_RENAME_OLD_NAME: u32 = 4096;
pub const USN_REASON_RENAME_NEW_NAME: u32 = 8192;
pub const USN_REASON_INDEXABLE_CHANGE: u32 = 16384;
pub const USN_REASON_BASIC_INFO_CHANGE: u32 = 32768;
pub const USN_REASON_HARD_LINK_CHANGE: u32 = 65536;
pub const USN_REASON_COMPRESSION_CHANGE: u32 = 131072;
pub const USN_REASON_ENCRYPTION_CHANGE: u32 = 262144;
pub const USN_REASON_OBJECT_ID_CHANGE: u32 = 524288;
pub const USN_REASON_REPARSE_POINT_CHANGE: u32 = 1048576;
pub const USN_REASON_STREAM_CHANGE: u32 = 2097152;
pub const USN_REASON_TRANSACTED_CHANGE: u32 = 4194304;
pub const USN_REASON_INTEGRITY_CHANGE: u32 = 8388608;
pub const USN_REASON_DESIRED_STORAGE_CLASS_CHANGE: u32 = 16777216;
pub const USN_REASON_CLOSE: u32 = 2147483648;
pub const USN_DELETE_FLAG_DELETE: u32 = 1;
pub const USN_DELETE_FLAG_NOTIFY: u32 = 2;
pub const USN_DELETE_VALID_FLAGS: u32 = 3;
pub const USN_SOURCE_DATA_MANAGEMENT: u32 = 1;
pub const USN_SOURCE_AUXILIARY_DATA: u32 = 2;
pub const USN_SOURCE_REPLICATION_MANAGEMENT: u32 = 4;
pub const USN_SOURCE_CLIENT_REPLICATION_MANAGEMENT: u32 = 8;
pub const USN_SOURCE_VALID_FLAGS: u32 = 15;
pub const MARK_HANDLE_PROTECT_CLUSTERS: u32 = 1;
pub const MARK_HANDLE_TXF_SYSTEM_LOG: u32 = 4;
pub const MARK_HANDLE_NOT_TXF_SYSTEM_LOG: u32 = 8;
pub const MARK_HANDLE_REALTIME: u32 = 32;
pub const MARK_HANDLE_NOT_REALTIME: u32 = 64;
pub const MARK_HANDLE_CLOUD_SYNC: u32 = 2048;
pub const MARK_HANDLE_READ_COPY: u32 = 128;
pub const MARK_HANDLE_NOT_READ_COPY: u32 = 256;
pub const MARK_HANDLE_FILTER_METADATA: u32 = 512;
pub const MARK_HANDLE_RETURN_PURGE_FAILURE: u32 = 1024;
pub const MARK_HANDLE_DISABLE_FILE_METADATA_OPTIMIZATION: u32 = 4096;
pub const MARK_HANDLE_ENABLE_USN_SOURCE_ON_PAGING_IO: u32 = 8192;
pub const MARK_HANDLE_SKIP_COHERENCY_SYNC_DISALLOW_WRITES: u32 = 16384;
pub const MARK_HANDLE_SUPPRESS_VOLUME_OPEN_FLUSH: u32 = 32768;
pub const MARK_HANDLE_ENABLE_CPU_CACHE: u32 = 268435456;
pub const VOLUME_IS_DIRTY: u32 = 1;
pub const VOLUME_UPGRADE_SCHEDULED: u32 = 2;
pub const VOLUME_SESSION_OPEN: u32 = 4;
pub const FILE_PREFETCH_TYPE_FOR_CREATE: u32 = 1;
pub const FILE_PREFETCH_TYPE_FOR_DIRENUM: u32 = 2;
pub const FILE_PREFETCH_TYPE_FOR_CREATE_EX: u32 = 3;
pub const FILE_PREFETCH_TYPE_FOR_DIRENUM_EX: u32 = 4;
pub const FILE_PREFETCH_TYPE_MAX: u32 = 4;
pub const FILESYSTEM_STATISTICS_TYPE_NTFS: u32 = 1;
pub const FILESYSTEM_STATISTICS_TYPE_FAT: u32 = 2;
pub const FILESYSTEM_STATISTICS_TYPE_EXFAT: u32 = 3;
pub const FILESYSTEM_STATISTICS_TYPE_REFS: u32 = 4;
pub const FILE_ZERO_DATA_INFORMATION_FLAG_PRESERVE_CACHED_DATA: u32 = 1;
pub const FILE_SET_ENCRYPTION: u32 = 1;
pub const FILE_CLEAR_ENCRYPTION: u32 = 2;
pub const STREAM_SET_ENCRYPTION: u32 = 3;
pub const STREAM_CLEAR_ENCRYPTION: u32 = 4;
pub const MAXIMUM_ENCRYPTION_VALUE: u32 = 4;
pub const ENCRYPTION_FORMAT_DEFAULT: u32 = 1;
pub const ENCRYPTED_DATA_INFO_SPARSE_FILE: u32 = 1;
pub const COPYFILE_SIS_LINK: u32 = 1;
pub const COPYFILE_SIS_REPLACE: u32 = 2;
pub const COPYFILE_SIS_FLAGS: u32 = 3;
pub const SET_REPAIR_ENABLED: u32 = 1;
pub const SET_REPAIR_WARN_ABOUT_DATA_LOSS: u32 = 8;
pub const SET_REPAIR_DISABLED_AND_BUGCHECK_ON_CORRUPT: u32 = 16;
pub const SET_REPAIR_VALID_MASK: u32 = 25;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_NOT_IN_USE: u32 = 1;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_REUSED: u32 = 2;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_NOT_EXIST: u32 = 4;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_NOT_BASE_RECORD: u32 = 8;
pub const FILE_INITIATE_REPAIR_HINT1_SYSTEM_FILE: u32 = 16;
pub const FILE_INITIATE_REPAIR_HINT1_NOT_IMPLEMENTED: u32 = 32;
pub const FILE_INITIATE_REPAIR_HINT1_UNABLE_TO_REPAIR: u32 = 64;
pub const FILE_INITIATE_REPAIR_HINT1_REPAIR_DISABLED: u32 = 128;
pub const FILE_INITIATE_REPAIR_HINT1_RECURSIVELY_CORRUPTED: u32 = 256;
pub const FILE_INITIATE_REPAIR_HINT1_ORPHAN_GENERATED: u32 = 512;
pub const FILE_INITIATE_REPAIR_HINT1_REPAIRED: u32 = 1024;
pub const FILE_INITIATE_REPAIR_HINT1_NOTHING_WRONG: u32 = 2048;
pub const FILE_INITIATE_REPAIR_HINT1_ATTRIBUTE_NOT_FOUND: u32 = 4096;
pub const FILE_INITIATE_REPAIR_HINT1_POTENTIAL_CROSSLINK: u32 = 8192;
pub const FILE_INITIATE_REPAIR_HINT1_STALE_INFORMATION: u32 = 16384;
pub const FILE_INITIATE_REPAIR_HINT1_CLUSTERS_ALREADY_IN_USE: u32 = 32768;
pub const FILE_INITIATE_REPAIR_HINT1_LCN_NOT_EXIST: u32 = 65536;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_RUN_LENGTH: u32 = 131072;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_NOT_ORPHAN: u32 = 262144;
pub const FILE_INITIATE_REPAIR_HINT1_FILE_RECORD_IS_BASE_RECORD: u32 = 524288;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_ARRAY_LENGTH_COUNT: u32 = 1048576;
pub const FILE_INITIATE_REPAIR_HINT1_SID_VALID: u32 = 2097152;
pub const FILE_INITIATE_REPAIR_HINT1_SID_MISMATCH: u32 = 4194304;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_PARENT: u32 = 8388608;
pub const FILE_INITIATE_REPAIR_HINT1_PARENT_FILE_RECORD_NOT_IN_USE: u32 = 16777216;
pub const FILE_INITIATE_REPAIR_HINT1_PARENT_FILE_RECORD_REUSED: u32 = 33554432;
pub const FILE_INITIATE_REPAIR_HINT1_PARENT_FILE_RECORD_NOT_EXIST: u32 = 67108864;
pub const FILE_INITIATE_REPAIR_HINT1_PARENT_FILE_RECORD_NOT_BASE_RECORD: u32 = 134217728;
pub const FILE_INITIATE_REPAIR_HINT1_PARENT_FILE_RECORD_NOT_INDEX: u32 = 268435456;
pub const FILE_INITIATE_REPAIR_HINT1_VALID_INDEX_ENTRY: u32 = 536870912;
pub const FILE_INITIATE_REPAIR_HINT1_OUT_OF_GENERIC_NAMES: u32 = 1073741824;
pub const FILE_INITIATE_REPAIR_HINT1_OUT_OF_RESOURCE: u32 = 2147483648;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_LCN: u64 = 4294967296;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_VCN: u64 = 8589934592;
pub const FILE_INITIATE_REPAIR_HINT1_NAME_CONFLICT: u64 = 17179869184;
pub const FILE_INITIATE_REPAIR_HINT1_ORPHAN: u64 = 34359738368;
pub const FILE_INITIATE_REPAIR_HINT1_ATTRIBUTE_TOO_SMALL: u64 = 68719476736;
pub const FILE_INITIATE_REPAIR_HINT1_ATTRIBUTE_NON_RESIDENT: u64 = 137438953472;
pub const FILE_INITIATE_REPAIR_HINT1_DENY_DEFRAG: u64 = 274877906944;
pub const FILE_INITIATE_REPAIR_HINT1_PREVIOUS_PARENT_STILL_VALID: u64 = 549755813888;
pub const FILE_INITIATE_REPAIR_HINT1_INDEX_ENTRY_MISMATCH: u64 = 1099511627776;
pub const FILE_INITIATE_REPAIR_HINT1_INVALID_ORPHAN_RECOVERY_NAME: u64 = 2199023255552;
pub const FILE_INITIATE_REPAIR_HINT1_MULTIPLE_FILE_NAME_ATTRIBUTES: u64 = 4398046511104;
pub const TXFS_RM_FLAG_LOGGING_MODE: u32 = 1;
pub const TXFS_RM_FLAG_RENAME_RM: u32 = 2;
pub const TXFS_RM_FLAG_LOG_CONTAINER_COUNT_MAX: u32 = 4;
pub const TXFS_RM_FLAG_LOG_CONTAINER_COUNT_MIN: u32 = 8;
pub const TXFS_RM_FLAG_LOG_GROWTH_INCREMENT_NUM_CONTAINERS: u32 = 16;
pub const TXFS_RM_FLAG_LOG_GROWTH_INCREMENT_PERCENT: u32 = 32;
pub const TXFS_RM_FLAG_LOG_AUTO_SHRINK_PERCENTAGE: u32 = 64;
pub const TXFS_RM_FLAG_LOG_NO_CONTAINER_COUNT_MAX: u32 = 128;
pub const TXFS_RM_FLAG_LOG_NO_CONTAINER_COUNT_MIN: u32 = 256;
pub const TXFS_RM_FLAG_GROW_LOG: u32 = 1024;
pub const TXFS_RM_FLAG_SHRINK_LOG: u32 = 2048;
pub const TXFS_RM_FLAG_ENFORCE_MINIMUM_SIZE: u32 = 4096;
pub const TXFS_RM_FLAG_PRESERVE_CHANGES: u32 = 8192;
pub const TXFS_RM_FLAG_RESET_RM_AT_NEXT_START: u32 = 16384;
pub const TXFS_RM_FLAG_DO_NOT_RESET_RM_AT_NEXT_START: u32 = 32768;
pub const TXFS_RM_FLAG_PREFER_CONSISTENCY: u32 = 65536;
pub const TXFS_RM_FLAG_PREFER_AVAILABILITY: u32 = 131072;
pub const TXFS_LOGGING_MODE_SIMPLE: u32 = 1;
pub const TXFS_LOGGING_MODE_FULL: u32 = 2;
pub const TXFS_TRANSACTION_STATE_NONE: u32 = 0;
pub const TXFS_TRANSACTION_STATE_ACTIVE: u32 = 1;
pub const TXFS_TRANSACTION_STATE_PREPARED: u32 = 2;
pub const TXFS_TRANSACTION_STATE_NOTACTIVE: u32 = 3;
pub const TXFS_MODIFY_RM_VALID_FLAGS: u32 = 261631;
pub const TXFS_RM_STATE_NOT_STARTED: u32 = 0;
pub const TXFS_RM_STATE_STARTING: u32 = 1;
pub const TXFS_RM_STATE_ACTIVE: u32 = 2;
pub const TXFS_RM_STATE_SHUTTING_DOWN: u32 = 3;
pub const TXFS_QUERY_RM_INFORMATION_VALID_FLAGS: u32 = 246192;
pub const TXFS_ROLLFORWARD_REDO_FLAG_USE_LAST_REDO_LSN: u32 = 1;
pub const TXFS_ROLLFORWARD_REDO_FLAG_USE_LAST_VIRTUAL_CLOCK: u32 = 2;
pub const TXFS_ROLLFORWARD_REDO_VALID_FLAGS: u32 = 3;
pub const TXFS_START_RM_FLAG_LOG_CONTAINER_COUNT_MAX: u32 = 1;
pub const TXFS_START_RM_FLAG_LOG_CONTAINER_COUNT_MIN: u32 = 2;
pub const TXFS_START_RM_FLAG_LOG_CONTAINER_SIZE: u32 = 4;
pub const TXFS_START_RM_FLAG_LOG_GROWTH_INCREMENT_NUM_CONTAINERS: u32 = 8;
pub const TXFS_START_RM_FLAG_LOG_GROWTH_INCREMENT_PERCENT: u32 = 16;
pub const TXFS_START_RM_FLAG_LOG_AUTO_SHRINK_PERCENTAGE: u32 = 32;
pub const TXFS_START_RM_FLAG_LOG_NO_CONTAINER_COUNT_MAX: u32 = 64;
pub const TXFS_START_RM_FLAG_LOG_NO_CONTAINER_COUNT_MIN: u32 = 128;
pub const TXFS_START_RM_FLAG_RECOVER_BEST_EFFORT: u32 = 512;
pub const TXFS_START_RM_FLAG_LOGGING_MODE: u32 = 1024;
pub const TXFS_START_RM_FLAG_PRESERVE_CHANGES: u32 = 2048;
pub const TXFS_START_RM_FLAG_PREFER_CONSISTENCY: u32 = 4096;
pub const TXFS_START_RM_FLAG_PREFER_AVAILABILITY: u32 = 8192;
pub const TXFS_START_RM_VALID_FLAGS: u32 = 15999;
pub const TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY_FLAG_CREATED: u32 = 1;
pub const TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY_FLAG_DELETED: u32 = 2;
pub const TXFS_TRANSACTED_VERSION_NONTRANSACTED: u32 = 4294967294;
pub const TXFS_TRANSACTED_VERSION_UNCOMMITTED: u32 = 4294967295;
pub const TXFS_SAVEPOINT_SET: u32 = 1;
pub const TXFS_SAVEPOINT_ROLLBACK: u32 = 2;
pub const TXFS_SAVEPOINT_CLEAR: u32 = 4;
pub const TXFS_SAVEPOINT_CLEAR_ALL: u32 = 16;
pub const PERSISTENT_VOLUME_STATE_SHORT_NAME_CREATION_DISABLED: u32 = 1;
pub const PERSISTENT_VOLUME_STATE_VOLUME_SCRUB_DISABLED: u32 = 2;
pub const PERSISTENT_VOLUME_STATE_GLOBAL_METADATA_NO_SEEK_PENALTY: u32 = 4;
pub const PERSISTENT_VOLUME_STATE_LOCAL_METADATA_NO_SEEK_PENALTY: u32 = 8;
pub const PERSISTENT_VOLUME_STATE_NO_HEAT_GATHERING: u32 = 16;
pub const PERSISTENT_VOLUME_STATE_CONTAINS_BACKING_WIM: u32 = 32;
pub const PERSISTENT_VOLUME_STATE_BACKED_BY_WIM: u32 = 64;
pub const PERSISTENT_VOLUME_STATE_NO_WRITE_AUTO_TIERING: u32 = 128;
pub const PERSISTENT_VOLUME_STATE_TXF_DISABLED: u32 = 256;
pub const PERSISTENT_VOLUME_STATE_REALLOCATE_ALL_DATA_WRITES: u32 = 512;
pub const PERSISTENT_VOLUME_STATE_CHKDSK_RAN_ONCE: u32 = 1024;
pub const PERSISTENT_VOLUME_STATE_MODIFIED_BY_CHKDSK: u32 = 2048;
pub const PERSISTENT_VOLUME_STATE_DAX_FORMATTED: u32 = 4096;
pub const OPLOCK_LEVEL_CACHE_READ: u32 = 1;
pub const OPLOCK_LEVEL_CACHE_HANDLE: u32 = 2;
pub const OPLOCK_LEVEL_CACHE_WRITE: u32 = 4;
pub const REQUEST_OPLOCK_INPUT_FLAG_REQUEST: u32 = 1;
pub const REQUEST_OPLOCK_INPUT_FLAG_ACK: u32 = 2;
pub const REQUEST_OPLOCK_INPUT_FLAG_COMPLETE_ACK_ON_CLOSE: u32 = 4;
pub const REQUEST_OPLOCK_CURRENT_VERSION: u32 = 1;
pub const REQUEST_OPLOCK_OUTPUT_FLAG_ACK_REQUIRED: u32 = 1;
pub const REQUEST_OPLOCK_OUTPUT_FLAG_MODES_PROVIDED: u32 = 2;
pub const QUERY_DEPENDENT_VOLUME_REQUEST_FLAG_HOST_VOLUMES: u32 = 1;
pub const QUERY_DEPENDENT_VOLUME_REQUEST_FLAG_GUEST_VOLUMES: u32 = 2;
pub const SD_GLOBAL_CHANGE_TYPE_MACHINE_SID: u32 = 1;
pub const SD_GLOBAL_CHANGE_TYPE_QUERY_STATS: u32 = 65536;
pub const SD_GLOBAL_CHANGE_TYPE_ENUM_SDS: u32 = 131072;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_FLAG_PAGE_FILE: u32 = 1;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_FLAG_DENY_DEFRAG_SET: u32 = 2;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_FLAG_FS_SYSTEM_FILE: u32 = 4;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_FLAG_TXF_SYSTEM_FILE: u32 = 8;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_ATTRIBUTE_MASK: u32 = 4278190080;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_ATTRIBUTE_DATA: u32 = 16777216;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_ATTRIBUTE_INDEX: u32 = 33554432;
pub const LOOKUP_STREAM_FROM_CLUSTER_ENTRY_ATTRIBUTE_SYSTEM: u32 = 50331648;
pub const FILE_TYPE_NOTIFICATION_FLAG_USAGE_BEGIN: u32 = 1;
pub const FILE_TYPE_NOTIFICATION_FLAG_USAGE_END: u32 = 2;
pub const CSV_MGMTLOCK_CHECK_VOLUME_REDIRECTED: u32 = 1;
pub const CSV_INVALID_DEVICE_NUMBER: u32 = 4294967295;
pub const CSV_QUERY_MDS_PATH_V2_VERSION_1: u32 = 1;
pub const CSV_QUERY_MDS_PATH_FLAG_STORAGE_ON_THIS_NODE_IS_CONNECTED: u32 = 1;
pub const CSV_QUERY_MDS_PATH_FLAG_CSV_DIRECT_IO_ENABLED: u32 = 2;
pub const CSV_QUERY_MDS_PATH_FLAG_SMB_BYPASS_CSV_ENABLED: u32 = 4;
pub const QUERY_FILE_LAYOUT_RESTART: u32 = 1;
pub const QUERY_FILE_LAYOUT_INCLUDE_NAMES: u32 = 2;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAMS: u32 = 4;
pub const QUERY_FILE_LAYOUT_INCLUDE_EXTENTS: u32 = 8;
pub const QUERY_FILE_LAYOUT_INCLUDE_EXTRA_INFO: u32 = 16;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAMS_WITH_NO_CLUSTERS_ALLOCATED: u32 = 32;
pub const QUERY_FILE_LAYOUT_INCLUDE_FULL_PATH_IN_NAMES: u32 = 64;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION: u32 = 128;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_DSC_ATTRIBUTE: u32 = 256;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_TXF_ATTRIBUTE: u32 = 512;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_EFS_ATTRIBUTE: u32 = 1024;
pub const QUERY_FILE_LAYOUT_INCLUDE_ONLY_FILES_WITH_SPECIFIC_ATTRIBUTES: u32 = 2048;
pub const QUERY_FILE_LAYOUT_INCLUDE_FILES_WITH_DSC_ATTRIBUTE: u32 = 4096;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_DATA_ATTRIBUTE: u32 = 8192;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_REPARSE_ATTRIBUTE: u32 = 16384;
pub const QUERY_FILE_LAYOUT_INCLUDE_STREAM_INFORMATION_FOR_EA_ATTRIBUTE: u32 = 32768;
pub const QUERY_FILE_LAYOUT_SINGLE_INSTANCED: u32 = 1;
pub const FILE_LAYOUT_NAME_ENTRY_PRIMARY: u32 = 1;
pub const FILE_LAYOUT_NAME_ENTRY_DOS: u32 = 2;
pub const STREAM_LAYOUT_ENTRY_IMMOVABLE: u32 = 1;
pub const STREAM_LAYOUT_ENTRY_PINNED: u32 = 2;
pub const STREAM_LAYOUT_ENTRY_RESIDENT: u32 = 4;
pub const STREAM_LAYOUT_ENTRY_NO_CLUSTERS_ALLOCATED: u32 = 8;
pub const STREAM_LAYOUT_ENTRY_HAS_INFORMATION: u32 = 16;
pub const STREAM_EXTENT_ENTRY_AS_RETRIEVAL_POINTERS: u32 = 1;
pub const STREAM_EXTENT_ENTRY_ALL_EXTENTS: u32 = 2;
pub const CHECKSUM_TYPE_UNCHANGED: i32 = -1;
pub const CHECKSUM_TYPE_NONE: u32 = 0;
pub const CHECKSUM_TYPE_CRC32: u32 = 1;
pub const CHECKSUM_TYPE_CRC64: u32 = 2;
pub const CHECKSUM_TYPE_ECC: u32 = 3;
pub const CHECKSUM_TYPE_FIRST_UNUSED_TYPE: u32 = 4;
pub const FSCTL_INTEGRITY_FLAG_CHECKSUM_ENFORCEMENT_OFF: u32 = 1;
pub const OFFLOAD_READ_FLAG_ALL_ZERO_BEYOND_CURRENT_RANGE: u32 = 1;
pub const SET_PURGE_FAILURE_MODE_ENABLED: u32 = 1;
pub const SET_PURGE_FAILURE_MODE_DISABLED: u32 = 2;
pub const FILE_REGION_USAGE_VALID_CACHED_DATA: u32 = 1;
pub const FILE_REGION_USAGE_VALID_NONCACHED_DATA: u32 = 2;
pub const FILE_REGION_USAGE_OTHER_PAGE_ALIGNMENT: u32 = 4;
pub const FILE_REGION_USAGE_LARGE_PAGE_ALIGNMENT: u32 = 8;
pub const FILE_REGION_USAGE_HUGE_PAGE_ALIGNMENT: u32 = 16;
pub const FILE_REGION_USAGE_QUERY_ALIGNMENT: u32 = 24;
pub const VALID_WRITE_USN_REASON_MASK: u32 = 2147483649;
pub const FILE_STORAGE_TIER_NAME_LENGTH: u32 = 256;
pub const FILE_STORAGE_TIER_DESCRIPTION_LENGTH: u32 = 512;
pub const FILE_STORAGE_TIER_FLAG_NO_SEEK_PENALTY: u32 = 131072;
pub const FILE_STORAGE_TIER_FLAG_WRITE_BACK_CACHE: u32 = 2097152;
pub const FILE_STORAGE_TIER_FLAG_READ_CACHE: u32 = 4194304;
pub const FILE_STORAGE_TIER_FLAG_PARITY: u32 = 8388608;
pub const FILE_STORAGE_TIER_FLAG_SMR: u32 = 16777216;
pub const QUERY_STORAGE_CLASSES_FLAGS_MEASURE_WRITE: u32 = 2147483648;
pub const QUERY_STORAGE_CLASSES_FLAGS_MEASURE_READ: u32 = 1073741824;
pub const QUERY_STORAGE_CLASSES_FLAGS_NO_DEFRAG_VOLUME: u32 = 536870912;
pub const QUERY_FILE_LAYOUT_REPARSE_DATA_INVALID: u32 = 1;
pub const QUERY_FILE_LAYOUT_REPARSE_TAG_INVALID: u32 = 2;
pub const DUPLICATE_EXTENTS_DATA_EX_SOURCE_ATOMIC: u32 = 1;
pub const DUPLICATE_EXTENTS_DATA_EX_ASYNC: u32 = 2;
pub const REFS_SMR_VOLUME_INFO_OUTPUT_VERSION_V0: u32 = 0;
pub const REFS_SMR_VOLUME_INFO_OUTPUT_VERSION_V1: u32 = 1;
pub const REFS_SMR_VOLUME_GC_PARAMETERS_VERSION_V1: u32 = 1;
pub const STREAMS_INVALID_ID: u32 = 0;
pub const STREAMS_MAX_ID: u32 = 65535;
pub const STREAMS_ASSOCIATE_ID_CLEAR: u32 = 1;
pub const STREAMS_ASSOCIATE_ID_SET: u32 = 2;
pub const DAX_ALLOC_ALIGNMENT_FLAG_MANDATORY: u32 = 1;
pub const DAX_ALLOC_ALIGNMENT_FLAG_FALLBACK_SPECIFIED: u32 = 2;
pub const WOF_CURRENT_VERSION: u32 = 1;
pub const WOF_PROVIDER_WIM: u32 = 1;
pub const WOF_PROVIDER_FILE: u32 = 2;
pub const WOF_PROVIDER_CLOUD: u32 = 3;
pub const WIM_PROVIDER_HASH_SIZE: u32 = 20;
pub const WIM_PROVIDER_CURRENT_VERSION: u32 = 1;
pub const WIM_PROVIDER_EXTERNAL_FLAG_NOT_ACTIVE: u32 = 1;
pub const WIM_PROVIDER_EXTERNAL_FLAG_SUSPENDED: u32 = 2;
pub const WIM_BOOT_OS_WIM: u32 = 1;
pub const WIM_BOOT_NOT_OS_WIM: u32 = 0;
pub const FILE_PROVIDER_CURRENT_VERSION: u32 = 1;
pub const FILE_PROVIDER_SINGLE_FILE: u32 = 1;
pub const FILE_PROVIDER_COMPRESSION_XPRESS4K: u32 = 0;
pub const FILE_PROVIDER_COMPRESSION_LZX: u32 = 1;
pub const FILE_PROVIDER_COMPRESSION_XPRESS8K: u32 = 2;
pub const FILE_PROVIDER_COMPRESSION_XPRESS16K: u32 = 3;
pub const FILE_PROVIDER_COMPRESSION_MAXIMUM: u32 = 4;
pub const FILE_PROVIDER_FLAG_COMPRESS_ON_WRITE: u32 = 1;
pub const CONTAINER_VOLUME_STATE_HOSTING_CONTAINER: u32 = 1;
pub const CONTAINER_ROOT_INFO_FLAG_SCRATCH_ROOT: u32 = 1;
pub const CONTAINER_ROOT_INFO_FLAG_LAYER_ROOT: u32 = 2;
pub const CONTAINER_ROOT_INFO_FLAG_VIRTUALIZATION_ROOT: u32 = 4;
pub const CONTAINER_ROOT_INFO_FLAG_VIRTUALIZATION_TARGET_ROOT: u32 = 8;
pub const CONTAINER_ROOT_INFO_FLAG_VIRTUALIZATION_EXCEPTION_ROOT: u32 = 16;
pub const CONTAINER_ROOT_INFO_FLAG_BIND_ROOT: u32 = 32;
pub const CONTAINER_ROOT_INFO_FLAG_BIND_TARGET_ROOT: u32 = 64;
pub const CONTAINER_ROOT_INFO_FLAG_BIND_EXCEPTION_ROOT: u32 = 128;
pub const CONTAINER_ROOT_INFO_FLAG_BIND_DO_NOT_MAP_NAME: u32 = 256;
pub const CONTAINER_ROOT_INFO_FLAG_UNION_LAYER_ROOT: u32 = 512;
pub const CONTAINER_ROOT_INFO_VALID_FLAGS: u32 = 1023;
pub const PROJFS_PROTOCOL_VERSION: u32 = 3;
pub const IOCTL_VOLUME_BASE: u32 = 86;
pub const EFS_TRACKED_OFFSET_HEADER_FLAG: u32 = 1;
pub const SPACES_TRACKED_OFFSET_HEADER_FLAG: u32 = 2;
pub const SCARD_ATR_LENGTH: u32 = 33;
pub const SCARD_PROTOCOL_UNDEFINED: u32 = 0;
pub const SCARD_PROTOCOL_T0: u32 = 1;
pub const SCARD_PROTOCOL_T1: u32 = 2;
pub const SCARD_PROTOCOL_RAW: u32 = 65536;
pub const SCARD_PROTOCOL_Tx: u32 = 3;
pub const SCARD_PROTOCOL_DEFAULT: u32 = 2147483648;
pub const SCARD_PROTOCOL_OPTIMAL: u32 = 0;
pub const SCARD_POWER_DOWN: u32 = 0;
pub const SCARD_COLD_RESET: u32 = 1;
pub const SCARD_WARM_RESET: u32 = 2;
pub const MAXIMUM_ATTR_STRING_LENGTH: u32 = 32;
pub const MAXIMUM_SMARTCARD_READERS: u32 = 10;
pub const SCARD_CLASS_VENDOR_INFO: u32 = 1;
pub const SCARD_CLASS_COMMUNICATIONS: u32 = 2;
pub const SCARD_CLASS_PROTOCOL: u32 = 3;
pub const SCARD_CLASS_POWER_MGMT: u32 = 4;
pub const SCARD_CLASS_SECURITY: u32 = 5;
pub const SCARD_CLASS_MECHANICAL: u32 = 6;
pub const SCARD_CLASS_VENDOR_DEFINED: u32 = 7;
pub const SCARD_CLASS_IFD_PROTOCOL: u32 = 8;
pub const SCARD_CLASS_ICC_STATE: u32 = 9;
pub const SCARD_CLASS_PERF: u32 = 32766;
pub const SCARD_CLASS_SYSTEM: u32 = 32767;
pub const SCARD_T0_HEADER_LENGTH: u32 = 7;
pub const SCARD_T0_CMD_LENGTH: u32 = 5;
pub const SCARD_T1_PROLOGUE_LENGTH: u32 = 3;
pub const SCARD_T1_EPILOGUE_LENGTH: u32 = 2;
pub const SCARD_T1_EPILOGUE_LENGTH_LRC: u32 = 1;
pub const SCARD_T1_MAX_IFS: u32 = 254;
pub const SCARD_UNKNOWN: u32 = 0;
pub const SCARD_ABSENT: u32 = 1;
pub const SCARD_PRESENT: u32 = 2;
pub const SCARD_SWALLOWED: u32 = 3;
pub const SCARD_POWERED: u32 = 4;
pub const SCARD_NEGOTIABLE: u32 = 5;
pub const SCARD_SPECIFIC: u32 = 6;
pub const SCARD_READER_SWALLOWS: u32 = 1;
pub const SCARD_READER_EJECTS: u32 = 2;
pub const SCARD_READER_CONFISCATES: u32 = 4;
pub const SCARD_READER_CONTACTLESS: u32 = 8;
pub const SCARD_READER_TYPE_SERIAL: u32 = 1;
pub const SCARD_READER_TYPE_PARALELL: u32 = 2;
pub const SCARD_READER_TYPE_KEYBOARD: u32 = 4;
pub const SCARD_READER_TYPE_SCSI: u32 = 8;
pub const SCARD_READER_TYPE_IDE: u32 = 16;
pub const SCARD_READER_TYPE_USB: u32 = 32;
pub const SCARD_READER_TYPE_PCMCIA: u32 = 64;
pub const SCARD_READER_TYPE_TPM: u32 = 128;
pub const SCARD_READER_TYPE_NFC: u32 = 256;
pub const SCARD_READER_TYPE_UICC: u32 = 512;
pub const SCARD_READER_TYPE_NGC: u32 = 1024;
pub const SCARD_READER_TYPE_EMBEDDEDSE: u32 = 2048;
pub const SCARD_READER_TYPE_VENDOR: u32 = 240;
pub const SCARD_SCOPE_USER: u32 = 0;
pub const SCARD_SCOPE_TERMINAL: u32 = 1;
pub const SCARD_SCOPE_SYSTEM: u32 = 2;
pub const SCARD_PROVIDER_PRIMARY: u32 = 1;
pub const SCARD_PROVIDER_CSP: u32 = 2;
pub const SCARD_PROVIDER_KSP: u32 = 3;
pub const SCARD_STATE_UNAWARE: u32 = 0;
pub const SCARD_STATE_IGNORE: u32 = 1;
pub const SCARD_STATE_CHANGED: u32 = 2;
pub const SCARD_STATE_UNKNOWN: u32 = 4;
pub const SCARD_STATE_UNAVAILABLE: u32 = 8;
pub const SCARD_STATE_EMPTY: u32 = 16;
pub const SCARD_STATE_PRESENT: u32 = 32;
pub const SCARD_STATE_ATRMATCH: u32 = 64;
pub const SCARD_STATE_EXCLUSIVE: u32 = 128;
pub const SCARD_STATE_INUSE: u32 = 256;
pub const SCARD_STATE_MUTE: u32 = 512;
pub const SCARD_STATE_UNPOWERED: u32 = 1024;
pub const SCARD_SHARE_EXCLUSIVE: u32 = 1;
pub const SCARD_SHARE_SHARED: u32 = 2;
pub const SCARD_SHARE_DIRECT: u32 = 3;
pub const SCARD_LEAVE_CARD: u32 = 0;
pub const SCARD_RESET_CARD: u32 = 1;
pub const SCARD_UNPOWER_CARD: u32 = 2;
pub const SCARD_EJECT_CARD: u32 = 3;
pub const SC_DLG_MINIMAL_UI: u32 = 1;
pub const SC_DLG_NO_UI: u32 = 2;
pub const SC_DLG_FORCE_UI: u32 = 4;
pub const SCERR_NOCARDNAME: u32 = 16384;
pub const SCERR_NOGUIDS: u32 = 32768;
pub const SCARD_AUDIT_CHV_FAILURE: u32 = 0;
pub const SCARD_AUDIT_CHV_SUCCESS: u32 = 1;
pub const MAXPROPPAGES: u32 = 100;
pub const PSP_DEFAULT: u32 = 0;
pub const PSP_DLGINDIRECT: u32 = 1;
pub const PSP_USEHICON: u32 = 2;
pub const PSP_USEICONID: u32 = 4;
pub const PSP_USETITLE: u32 = 8;
pub const PSP_RTLREADING: u32 = 16;
pub const PSP_HASHELP: u32 = 32;
pub const PSP_USEREFPARENT: u32 = 64;
pub const PSP_USECALLBACK: u32 = 128;
pub const PSP_PREMATURE: u32 = 1024;
pub const PSP_HIDEHEADER: u32 = 2048;
pub const PSP_USEHEADERTITLE: u32 = 4096;
pub const PSP_USEHEADERSUBTITLE: u32 = 8192;
pub const PSP_USEFUSIONCONTEXT: u32 = 16384;
pub const PSPCB_ADDREF: u32 = 0;
pub const PSPCB_RELEASE: u32 = 1;
pub const PSPCB_CREATE: u32 = 2;
pub const PSH_DEFAULT: u32 = 0;
pub const PSH_PROPTITLE: u32 = 1;
pub const PSH_USEHICON: u32 = 2;
pub const PSH_USEICONID: u32 = 4;
pub const PSH_PROPSHEETPAGE: u32 = 8;
pub const PSH_WIZARDHASFINISH: u32 = 16;
pub const PSH_WIZARD: u32 = 32;
pub const PSH_USEPSTARTPAGE: u32 = 64;
pub const PSH_NOAPPLYNOW: u32 = 128;
pub const PSH_USECALLBACK: u32 = 256;
pub const PSH_HASHELP: u32 = 512;
pub const PSH_MODELESS: u32 = 1024;
pub const PSH_RTLREADING: u32 = 2048;
pub const PSH_WIZARDCONTEXTHELP: u32 = 4096;
pub const PSH_WIZARD97: u32 = 16777216;
pub const PSH_WATERMARK: u32 = 32768;
pub const PSH_USEHBMWATERMARK: u32 = 65536;
pub const PSH_USEHPLWATERMARK: u32 = 131072;
pub const PSH_STRETCHWATERMARK: u32 = 262144;
pub const PSH_HEADER: u32 = 524288;
pub const PSH_USEHBMHEADER: u32 = 1048576;
pub const PSH_USEPAGELANG: u32 = 2097152;
pub const PSH_WIZARD_LITE: u32 = 4194304;
pub const PSH_NOCONTEXTHELP: u32 = 33554432;
pub const PSH_AEROWIZARD: u32 = 16384;
pub const PSH_RESIZABLE: u32 = 67108864;
pub const PSH_HEADERBITMAP: u32 = 134217728;
pub const PSH_NOMARGIN: u32 = 268435456;
pub const PSCB_INITIALIZED: u32 = 1;
pub const PSCB_PRECREATE: u32 = 2;
pub const PSCB_BUTTONPRESSED: u32 = 3;
pub const PSN_FIRST: i32 = -200;
pub const PSN_LAST: i32 = -299;
pub const PSN_SETACTIVE: i32 = -200;
pub const PSN_KILLACTIVE: i32 = -201;
pub const PSN_APPLY: i32 = -202;
pub const PSN_RESET: i32 = -203;
pub const PSN_HELP: i32 = -205;
pub const PSN_WIZBACK: i32 = -206;
pub const PSN_WIZNEXT: i32 = -207;
pub const PSN_WIZFINISH: i32 = -208;
pub const PSN_QUERYCANCEL: i32 = -209;
pub const PSN_GETOBJECT: i32 = -210;
pub const PSN_TRANSLATEACCELERATOR: i32 = -212;
pub const PSN_QUERYINITIALFOCUS: i32 = -213;
pub const PSNRET_NOERROR: u32 = 0;
pub const PSNRET_INVALID: u32 = 1;
pub const PSNRET_INVALID_NOCHANGEPAGE: u32 = 2;
pub const PSNRET_MESSAGEHANDLED: u32 = 3;
pub const PSM_SETCURSEL: u32 = 1125;
pub const PSM_REMOVEPAGE: u32 = 1126;
pub const PSM_ADDPAGE: u32 = 1127;
pub const PSM_CHANGED: u32 = 1128;
pub const PSM_RESTARTWINDOWS: u32 = 1129;
pub const PSM_REBOOTSYSTEM: u32 = 1130;
pub const PSM_CANCELTOCLOSE: u32 = 1131;
pub const PSM_QUERYSIBLINGS: u32 = 1132;
pub const PSM_UNCHANGED: u32 = 1133;
pub const PSM_APPLY: u32 = 1134;
pub const PSM_SETTITLEA: u32 = 1135;
pub const PSM_SETTITLEW: u32 = 1144;
pub const PSM_SETTITLE: u32 = 1135;
pub const PSM_SETWIZBUTTONS: u32 = 1136;
pub const PSWIZB_BACK: u32 = 1;
pub const PSWIZB_NEXT: u32 = 2;
pub const PSWIZB_FINISH: u32 = 4;
pub const PSWIZB_DISABLEDFINISH: u32 = 8;
pub const PSWIZBF_ELEVATIONREQUIRED: u32 = 1;
pub const PSWIZB_CANCEL: u32 = 16;
pub const PSM_PRESSBUTTON: u32 = 1137;
pub const PSBTN_BACK: u32 = 0;
pub const PSBTN_NEXT: u32 = 1;
pub const PSBTN_FINISH: u32 = 2;
pub const PSBTN_OK: u32 = 3;
pub const PSBTN_APPLYNOW: u32 = 4;
pub const PSBTN_CANCEL: u32 = 5;
pub const PSBTN_HELP: u32 = 6;
pub const PSBTN_MAX: u32 = 6;
pub const PSM_SETCURSELID: u32 = 1138;
pub const PSM_SETFINISHTEXTA: u32 = 1139;
pub const PSM_SETFINISHTEXTW: u32 = 1145;
pub const PSM_SETFINISHTEXT: u32 = 1139;
pub const PSM_GETTABCONTROL: u32 = 1140;
pub const PSM_ISDIALOGMESSAGE: u32 = 1141;
pub const PSM_GETCURRENTPAGEHWND: u32 = 1142;
pub const PSM_INSERTPAGE: u32 = 1143;
pub const PSM_SETHEADERTITLEA: u32 = 1149;
pub const PSM_SETHEADERTITLEW: u32 = 1150;
pub const PSM_SETHEADERTITLE: u32 = 1149;
pub const PSM_SETHEADERSUBTITLEA: u32 = 1151;
pub const PSM_SETHEADERSUBTITLEW: u32 = 1152;
pub const PSM_SETHEADERSUBTITLE: u32 = 1151;
pub const PSM_HWNDTOINDEX: u32 = 1153;
pub const PSM_INDEXTOHWND: u32 = 1154;
pub const PSM_PAGETOINDEX: u32 = 1155;
pub const PSM_INDEXTOPAGE: u32 = 1156;
pub const PSM_IDTOINDEX: u32 = 1157;
pub const PSM_INDEXTOID: u32 = 1158;
pub const PSM_GETRESULT: u32 = 1159;
pub const PSM_RECALCPAGESIZES: u32 = 1160;
pub const PSM_SETNEXTTEXTW: u32 = 1161;
pub const PSM_SETNEXTTEXT: u32 = 1161;
pub const PSWIZB_SHOW: u32 = 0;
pub const PSWIZB_RESTORE: u32 = 1;
pub const PSM_SHOWWIZBUTTONS: u32 = 1162;
pub const PSM_ENABLEWIZBUTTONS: u32 = 1163;
pub const PSM_SETBUTTONTEXTW: u32 = 1164;
pub const PSM_SETBUTTONTEXT: u32 = 1164;
pub const ID_PSRESTARTWINDOWS: u32 = 2;
pub const ID_PSREBOOTSYSTEM: u32 = 3;
pub const WIZ_CXDLG: u32 = 276;
pub const WIZ_CYDLG: u32 = 140;
pub const WIZ_CXBMP: u32 = 80;
pub const WIZ_BODYX: u32 = 92;
pub const WIZ_BODYCX: u32 = 184;
pub const PROP_SM_CXDLG: u32 = 212;
pub const PROP_SM_CYDLG: u32 = 188;
pub const PROP_MED_CXDLG: u32 = 227;
pub const PROP_MED_CYDLG: u32 = 215;
pub const PROP_LG_CXDLG: u32 = 252;
pub const PROP_LG_CYDLG: u32 = 218;
pub const DSPRINT_PUBLISH: u32 = 1;
pub const DSPRINT_UPDATE: u32 = 2;
pub const DSPRINT_UNPUBLISH: u32 = 4;
pub const DSPRINT_REPUBLISH: u32 = 8;
pub const DSPRINT_PENDING: u32 = 2147483648;
pub const PRINTER_CONTROL_PAUSE: u32 = 1;
pub const PRINTER_CONTROL_RESUME: u32 = 2;
pub const PRINTER_CONTROL_PURGE: u32 = 3;
pub const PRINTER_CONTROL_SET_STATUS: u32 = 4;
pub const PRINTER_STATUS_PAUSED: u32 = 1;
pub const PRINTER_STATUS_ERROR: u32 = 2;
pub const PRINTER_STATUS_PENDING_DELETION: u32 = 4;
pub const PRINTER_STATUS_PAPER_JAM: u32 = 8;
pub const PRINTER_STATUS_PAPER_OUT: u32 = 16;
pub const PRINTER_STATUS_MANUAL_FEED: u32 = 32;
pub const PRINTER_STATUS_PAPER_PROBLEM: u32 = 64;
pub const PRINTER_STATUS_OFFLINE: u32 = 128;
pub const PRINTER_STATUS_IO_ACTIVE: u32 = 256;
pub const PRINTER_STATUS_BUSY: u32 = 512;
pub const PRINTER_STATUS_PRINTING: u32 = 1024;
pub const PRINTER_STATUS_OUTPUT_BIN_FULL: u32 = 2048;
pub const PRINTER_STATUS_NOT_AVAILABLE: u32 = 4096;
pub const PRINTER_STATUS_WAITING: u32 = 8192;
pub const PRINTER_STATUS_PROCESSING: u32 = 16384;
pub const PRINTER_STATUS_INITIALIZING: u32 = 32768;
pub const PRINTER_STATUS_WARMING_UP: u32 = 65536;
pub const PRINTER_STATUS_TONER_LOW: u32 = 131072;
pub const PRINTER_STATUS_NO_TONER: u32 = 262144;
pub const PRINTER_STATUS_PAGE_PUNT: u32 = 524288;
pub const PRINTER_STATUS_USER_INTERVENTION: u32 = 1048576;
pub const PRINTER_STATUS_OUT_OF_MEMORY: u32 = 2097152;
pub const PRINTER_STATUS_DOOR_OPEN: u32 = 4194304;
pub const PRINTER_STATUS_SERVER_UNKNOWN: u32 = 8388608;
pub const PRINTER_STATUS_POWER_SAVE: u32 = 16777216;
pub const PRINTER_STATUS_SERVER_OFFLINE: u32 = 33554432;
pub const PRINTER_STATUS_DRIVER_UPDATE_NEEDED: u32 = 67108864;
pub const PRINTER_ATTRIBUTE_QUEUED: u32 = 1;
pub const PRINTER_ATTRIBUTE_DIRECT: u32 = 2;
pub const PRINTER_ATTRIBUTE_DEFAULT: u32 = 4;
pub const PRINTER_ATTRIBUTE_SHARED: u32 = 8;
pub const PRINTER_ATTRIBUTE_NETWORK: u32 = 16;
pub const PRINTER_ATTRIBUTE_HIDDEN: u32 = 32;
pub const PRINTER_ATTRIBUTE_LOCAL: u32 = 64;
pub const PRINTER_ATTRIBUTE_ENABLE_DEVQ: u32 = 128;
pub const PRINTER_ATTRIBUTE_KEEPPRINTEDJOBS: u32 = 256;
pub const PRINTER_ATTRIBUTE_DO_COMPLETE_FIRST: u32 = 512;
pub const PRINTER_ATTRIBUTE_WORK_OFFLINE: u32 = 1024;
pub const PRINTER_ATTRIBUTE_ENABLE_BIDI: u32 = 2048;
pub const PRINTER_ATTRIBUTE_RAW_ONLY: u32 = 4096;
pub const PRINTER_ATTRIBUTE_PUBLISHED: u32 = 8192;
pub const PRINTER_ATTRIBUTE_FAX: u32 = 16384;
pub const PRINTER_ATTRIBUTE_TS: u32 = 32768;
pub const PRINTER_ATTRIBUTE_PUSHED_USER: u32 = 131072;
pub const PRINTER_ATTRIBUTE_PUSHED_MACHINE: u32 = 262144;
pub const PRINTER_ATTRIBUTE_MACHINE: u32 = 524288;
pub const PRINTER_ATTRIBUTE_FRIENDLY_NAME: u32 = 1048576;
pub const PRINTER_ATTRIBUTE_TS_GENERIC_DRIVER: u32 = 2097152;
pub const PRINTER_ATTRIBUTE_PER_USER: u32 = 4194304;
pub const PRINTER_ATTRIBUTE_ENTERPRISE_CLOUD: u32 = 8388608;
pub const NO_PRIORITY: u32 = 0;
pub const MAX_PRIORITY: u32 = 99;
pub const MIN_PRIORITY: u32 = 1;
pub const DEF_PRIORITY: u32 = 1;
pub const JOB_CONTROL_PAUSE: u32 = 1;
pub const JOB_CONTROL_RESUME: u32 = 2;
pub const JOB_CONTROL_CANCEL: u32 = 3;
pub const JOB_CONTROL_RESTART: u32 = 4;
pub const JOB_CONTROL_DELETE: u32 = 5;
pub const JOB_CONTROL_SENT_TO_PRINTER: u32 = 6;
pub const JOB_CONTROL_LAST_PAGE_EJECTED: u32 = 7;
pub const JOB_CONTROL_RETAIN: u32 = 8;
pub const JOB_CONTROL_RELEASE: u32 = 9;
pub const JOB_STATUS_PAUSED: u32 = 1;
pub const JOB_STATUS_ERROR: u32 = 2;
pub const JOB_STATUS_DELETING: u32 = 4;
pub const JOB_STATUS_SPOOLING: u32 = 8;
pub const JOB_STATUS_PRINTING: u32 = 16;
pub const JOB_STATUS_OFFLINE: u32 = 32;
pub const JOB_STATUS_PAPEROUT: u32 = 64;
pub const JOB_STATUS_PRINTED: u32 = 128;
pub const JOB_STATUS_DELETED: u32 = 256;
pub const JOB_STATUS_BLOCKED_DEVQ: u32 = 512;
pub const JOB_STATUS_USER_INTERVENTION: u32 = 1024;
pub const JOB_STATUS_RESTART: u32 = 2048;
pub const JOB_STATUS_COMPLETE: u32 = 4096;
pub const JOB_STATUS_RETAINED: u32 = 8192;
pub const JOB_STATUS_RENDERING_LOCALLY: u32 = 16384;
pub const JOB_POSITION_UNSPECIFIED: u32 = 0;
pub const PRINTER_DRIVER_PACKAGE_AWARE: u32 = 1;
pub const PRINTER_DRIVER_XPS: u32 = 2;
pub const PRINTER_DRIVER_SANDBOX_ENABLED: u32 = 4;
pub const PRINTER_DRIVER_CLASS: u32 = 8;
pub const PRINTER_DRIVER_DERIVED: u32 = 16;
pub const PRINTER_DRIVER_NOT_SHAREABLE: u32 = 32;
pub const PRINTER_DRIVER_CATEGORY_FAX: u32 = 64;
pub const PRINTER_DRIVER_CATEGORY_FILE: u32 = 128;
pub const PRINTER_DRIVER_CATEGORY_VIRTUAL: u32 = 256;
pub const PRINTER_DRIVER_CATEGORY_SERVICE: u32 = 512;
pub const PRINTER_DRIVER_SOFT_RESET_REQUIRED: u32 = 1024;
pub const PRINTER_DRIVER_SANDBOX_DISABLED: u32 = 2048;
pub const PRINTER_DRIVER_CATEGORY_3D: u32 = 4096;
pub const PRINTER_DRIVER_CATEGORY_CLOUD: u32 = 8192;
pub const DRIVER_KERNELMODE: u32 = 1;
pub const DRIVER_USERMODE: u32 = 2;
pub const DPD_DELETE_UNUSED_FILES: u32 = 1;
pub const DPD_DELETE_SPECIFIC_VERSION: u32 = 2;
pub const DPD_DELETE_ALL_FILES: u32 = 4;
pub const APD_STRICT_UPGRADE: u32 = 1;
pub const APD_STRICT_DOWNGRADE: u32 = 2;
pub const APD_COPY_ALL_FILES: u32 = 4;
pub const APD_COPY_NEW_FILES: u32 = 8;
pub const APD_COPY_FROM_DIRECTORY: u32 = 16;
pub const STRING_NONE: u32 = 1;
pub const STRING_MUIDLL: u32 = 2;
pub const STRING_LANGPAIR: u32 = 4;
pub const MAX_FORM_KEYWORD_LENGTH: u32 = 64;
pub const DI_CHANNEL: u32 = 1;
pub const DI_READ_SPOOL_JOB: u32 = 3;
pub const DI_MEMORYMAP_WRITE: u32 = 1;
pub const FORM_USER: u32 = 0;
pub const FORM_BUILTIN: u32 = 1;
pub const FORM_PRINTER: u32 = 2;
pub const NORMAL_PRINT: u32 = 0;
pub const REVERSE_PRINT: u32 = 1;
pub const PPCAPS_RIGHT_THEN_DOWN: u32 = 1;
pub const PPCAPS_DOWN_THEN_RIGHT: u32 = 2;
pub const PPCAPS_LEFT_THEN_DOWN: u32 = 4;
pub const PPCAPS_DOWN_THEN_LEFT: u32 = 8;
pub const PPCAPS_BORDER_PRINT: u32 = 1;
pub const PPCAPS_BOOKLET_EDGE: u32 = 1;
pub const PPCAPS_REVERSE_PAGES_FOR_REVERSE_DUPLEX: u32 = 1;
pub const PPCAPS_DONT_SEND_EXTRA_PAGES_FOR_DUPLEX: u32 = 2;
pub const PPCAPS_SQUARE_SCALING: u32 = 1;
pub const PORT_TYPE_WRITE: u32 = 1;
pub const PORT_TYPE_READ: u32 = 2;
pub const PORT_TYPE_REDIRECTED: u32 = 4;
pub const PORT_TYPE_NET_ATTACHED: u32 = 8;
pub const PORT_STATUS_TYPE_ERROR: u32 = 1;
pub const PORT_STATUS_TYPE_WARNING: u32 = 2;
pub const PORT_STATUS_TYPE_INFO: u32 = 3;
pub const PORT_STATUS_OFFLINE: u32 = 1;
pub const PORT_STATUS_PAPER_JAM: u32 = 2;
pub const PORT_STATUS_PAPER_OUT: u32 = 3;
pub const PORT_STATUS_OUTPUT_BIN_FULL: u32 = 4;
pub const PORT_STATUS_PAPER_PROBLEM: u32 = 5;
pub const PORT_STATUS_NO_TONER: u32 = 6;
pub const PORT_STATUS_DOOR_OPEN: u32 = 7;
pub const PORT_STATUS_USER_INTERVENTION: u32 = 8;
pub const PORT_STATUS_OUT_OF_MEMORY: u32 = 9;
pub const PORT_STATUS_TONER_LOW: u32 = 10;
pub const PORT_STATUS_WARMING_UP: u32 = 11;
pub const PORT_STATUS_POWER_SAVE: u32 = 12;
pub const PRINTER_ENUM_DEFAULT: u32 = 1;
pub const PRINTER_ENUM_LOCAL: u32 = 2;
pub const PRINTER_ENUM_CONNECTIONS: u32 = 4;
pub const PRINTER_ENUM_FAVORITE: u32 = 4;
pub const PRINTER_ENUM_NAME: u32 = 8;
pub const PRINTER_ENUM_REMOTE: u32 = 16;
pub const PRINTER_ENUM_SHARED: u32 = 32;
pub const PRINTER_ENUM_NETWORK: u32 = 64;
pub const PRINTER_ENUM_EXPAND: u32 = 16384;
pub const PRINTER_ENUM_CONTAINER: u32 = 32768;
pub const PRINTER_ENUM_ICONMASK: u32 = 16711680;
pub const PRINTER_ENUM_ICON1: u32 = 65536;
pub const PRINTER_ENUM_ICON2: u32 = 131072;
pub const PRINTER_ENUM_ICON3: u32 = 262144;
pub const PRINTER_ENUM_ICON4: u32 = 524288;
pub const PRINTER_ENUM_ICON5: u32 = 1048576;
pub const PRINTER_ENUM_ICON6: u32 = 2097152;
pub const PRINTER_ENUM_ICON7: u32 = 4194304;
pub const PRINTER_ENUM_ICON8: u32 = 8388608;
pub const PRINTER_ENUM_HIDE: u32 = 16777216;
pub const PRINTER_ENUM_CATEGORY_ALL: u32 = 33554432;
pub const PRINTER_ENUM_CATEGORY_3D: u32 = 67108864;
pub const SPOOL_FILE_PERSISTENT: u32 = 1;
pub const SPOOL_FILE_TEMPORARY: u32 = 2;
pub const PRINTER_NOTIFY_TYPE: u32 = 0;
pub const JOB_NOTIFY_TYPE: u32 = 1;
pub const SERVER_NOTIFY_TYPE: u32 = 2;
pub const PRINTER_NOTIFY_FIELD_SERVER_NAME: u32 = 0;
pub const PRINTER_NOTIFY_FIELD_PRINTER_NAME: u32 = 1;
pub const PRINTER_NOTIFY_FIELD_SHARE_NAME: u32 = 2;
pub const PRINTER_NOTIFY_FIELD_PORT_NAME: u32 = 3;
pub const PRINTER_NOTIFY_FIELD_DRIVER_NAME: u32 = 4;
pub const PRINTER_NOTIFY_FIELD_COMMENT: u32 = 5;
pub const PRINTER_NOTIFY_FIELD_LOCATION: u32 = 6;
pub const PRINTER_NOTIFY_FIELD_DEVMODE: u32 = 7;
pub const PRINTER_NOTIFY_FIELD_SEPFILE: u32 = 8;
pub const PRINTER_NOTIFY_FIELD_PRINT_PROCESSOR: u32 = 9;
pub const PRINTER_NOTIFY_FIELD_PARAMETERS: u32 = 10;
pub const PRINTER_NOTIFY_FIELD_DATATYPE: u32 = 11;
pub const PRINTER_NOTIFY_FIELD_SECURITY_DESCRIPTOR: u32 = 12;
pub const PRINTER_NOTIFY_FIELD_ATTRIBUTES: u32 = 13;
pub const PRINTER_NOTIFY_FIELD_PRIORITY: u32 = 14;
pub const PRINTER_NOTIFY_FIELD_DEFAULT_PRIORITY: u32 = 15;
pub const PRINTER_NOTIFY_FIELD_START_TIME: u32 = 16;
pub const PRINTER_NOTIFY_FIELD_UNTIL_TIME: u32 = 17;
pub const PRINTER_NOTIFY_FIELD_STATUS: u32 = 18;
pub const PRINTER_NOTIFY_FIELD_STATUS_STRING: u32 = 19;
pub const PRINTER_NOTIFY_FIELD_CJOBS: u32 = 20;
pub const PRINTER_NOTIFY_FIELD_AVERAGE_PPM: u32 = 21;
pub const PRINTER_NOTIFY_FIELD_TOTAL_PAGES: u32 = 22;
pub const PRINTER_NOTIFY_FIELD_PAGES_PRINTED: u32 = 23;
pub const PRINTER_NOTIFY_FIELD_TOTAL_BYTES: u32 = 24;
pub const PRINTER_NOTIFY_FIELD_BYTES_PRINTED: u32 = 25;
pub const PRINTER_NOTIFY_FIELD_OBJECT_GUID: u32 = 26;
pub const PRINTER_NOTIFY_FIELD_FRIENDLY_NAME: u32 = 27;
pub const PRINTER_NOTIFY_FIELD_BRANCH_OFFICE_PRINTING: u32 = 28;
pub const JOB_NOTIFY_FIELD_PRINTER_NAME: u32 = 0;
pub const JOB_NOTIFY_FIELD_MACHINE_NAME: u32 = 1;
pub const JOB_NOTIFY_FIELD_PORT_NAME: u32 = 2;
pub const JOB_NOTIFY_FIELD_USER_NAME: u32 = 3;
pub const JOB_NOTIFY_FIELD_NOTIFY_NAME: u32 = 4;
pub const JOB_NOTIFY_FIELD_DATATYPE: u32 = 5;
pub const JOB_NOTIFY_FIELD_PRINT_PROCESSOR: u32 = 6;
pub const JOB_NOTIFY_FIELD_PARAMETERS: u32 = 7;
pub const JOB_NOTIFY_FIELD_DRIVER_NAME: u32 = 8;
pub const JOB_NOTIFY_FIELD_DEVMODE: u32 = 9;
pub const JOB_NOTIFY_FIELD_STATUS: u32 = 10;
pub const JOB_NOTIFY_FIELD_STATUS_STRING: u32 = 11;
pub const JOB_NOTIFY_FIELD_SECURITY_DESCRIPTOR: u32 = 12;
pub const JOB_NOTIFY_FIELD_DOCUMENT: u32 = 13;
pub const JOB_NOTIFY_FIELD_PRIORITY: u32 = 14;
pub const JOB_NOTIFY_FIELD_POSITION: u32 = 15;
pub const JOB_NOTIFY_FIELD_SUBMITTED: u32 = 16;
pub const JOB_NOTIFY_FIELD_START_TIME: u32 = 17;
pub const JOB_NOTIFY_FIELD_UNTIL_TIME: u32 = 18;
pub const JOB_NOTIFY_FIELD_TIME: u32 = 19;
pub const JOB_NOTIFY_FIELD_TOTAL_PAGES: u32 = 20;
pub const JOB_NOTIFY_FIELD_PAGES_PRINTED: u32 = 21;
pub const JOB_NOTIFY_FIELD_TOTAL_BYTES: u32 = 22;
pub const JOB_NOTIFY_FIELD_BYTES_PRINTED: u32 = 23;
pub const JOB_NOTIFY_FIELD_REMOTE_JOB_ID: u32 = 24;
pub const SERVER_NOTIFY_FIELD_PRINT_DRIVER_ISOLATION_GROUP: u32 = 0;
pub const PRINTER_NOTIFY_CATEGORY_ALL: u32 = 4096;
pub const PRINTER_NOTIFY_CATEGORY_3D: u32 = 8192;
pub const PRINTER_NOTIFY_OPTIONS_REFRESH: u32 = 1;
pub const PRINTER_NOTIFY_INFO_DISCARDED: u32 = 1;
pub const BIDI_ACTION_ENUM_SCHEMA: &[u8; 11] = b"EnumSchema\0";
pub const BIDI_ACTION_GET: &[u8; 4] = b"Get\0";
pub const BIDI_ACTION_SET: &[u8; 4] = b"Set\0";
pub const BIDI_ACTION_GET_ALL: &[u8; 7] = b"GetAll\0";
pub const BIDI_ACTION_GET_WITH_ARGUMENT: &[u8; 16] = b"GetWithArgument\0";
pub const BIDI_ACCESS_ADMINISTRATOR: u32 = 1;
pub const BIDI_ACCESS_USER: u32 = 2;
pub const ERROR_BIDI_STATUS_OK: u32 = 0;
pub const ERROR_BIDI_NOT_SUPPORTED: u32 = 50;
pub const ERROR_BIDI_ERROR_BASE: u32 = 13000;
pub const ERROR_BIDI_STATUS_WARNING: u32 = 13001;
pub const ERROR_BIDI_SCHEMA_READ_ONLY: u32 = 13002;
pub const ERROR_BIDI_SERVER_OFFLINE: u32 = 13003;
pub const ERROR_BIDI_DEVICE_OFFLINE: u32 = 13004;
pub const ERROR_BIDI_SCHEMA_NOT_SUPPORTED: u32 = 13005;
pub const ERROR_BIDI_SET_DIFFERENT_TYPE: u32 = 13006;
pub const ERROR_BIDI_SET_MULTIPLE_SCHEMAPATH: u32 = 13007;
pub const ERROR_BIDI_SET_INVALID_SCHEMAPATH: u32 = 13008;
pub const ERROR_BIDI_SET_UNKNOWN_FAILURE: u32 = 13009;
pub const ERROR_BIDI_SCHEMA_WRITE_ONLY: u32 = 13010;
pub const ERROR_BIDI_GET_REQUIRES_ARGUMENT: u32 = 13011;
pub const ERROR_BIDI_GET_ARGUMENT_NOT_SUPPORTED: u32 = 13012;
pub const ERROR_BIDI_GET_MISSING_ARGUMENT: u32 = 13013;
pub const ERROR_BIDI_DEVICE_CONFIG_UNCHANGED: u32 = 13014;
pub const ERROR_BIDI_NO_LOCALIZED_RESOURCES: u32 = 13015;
pub const ERROR_BIDI_NO_BIDI_SCHEMA_EXTENSIONS: u32 = 13016;
pub const ERROR_BIDI_UNSUPPORTED_CLIENT_LANGUAGE: u32 = 13017;
pub const ERROR_BIDI_UNSUPPORTED_RESOURCE_FORMAT: u32 = 13018;
pub const PRINTER_CHANGE_ADD_PRINTER: u32 = 1;
pub const PRINTER_CHANGE_SET_PRINTER: u32 = 2;
pub const PRINTER_CHANGE_DELETE_PRINTER: u32 = 4;
pub const PRINTER_CHANGE_FAILED_CONNECTION_PRINTER: u32 = 8;
pub const PRINTER_CHANGE_PRINTER: u32 = 255;
pub const PRINTER_CHANGE_ADD_JOB: u32 = 256;
pub const PRINTER_CHANGE_SET_JOB: u32 = 512;
pub const PRINTER_CHANGE_DELETE_JOB: u32 = 1024;
pub const PRINTER_CHANGE_WRITE_JOB: u32 = 2048;
pub const PRINTER_CHANGE_JOB: u32 = 65280;
pub const PRINTER_CHANGE_ADD_FORM: u32 = 65536;
pub const PRINTER_CHANGE_SET_FORM: u32 = 131072;
pub const PRINTER_CHANGE_DELETE_FORM: u32 = 262144;
pub const PRINTER_CHANGE_FORM: u32 = 458752;
pub const PRINTER_CHANGE_ADD_PORT: u32 = 1048576;
pub const PRINTER_CHANGE_CONFIGURE_PORT: u32 = 2097152;
pub const PRINTER_CHANGE_DELETE_PORT: u32 = 4194304;
pub const PRINTER_CHANGE_PORT: u32 = 7340032;
pub const PRINTER_CHANGE_ADD_PRINT_PROCESSOR: u32 = 16777216;
pub const PRINTER_CHANGE_DELETE_PRINT_PROCESSOR: u32 = 67108864;
pub const PRINTER_CHANGE_PRINT_PROCESSOR: u32 = 117440512;
pub const PRINTER_CHANGE_SERVER: u32 = 134217728;
pub const PRINTER_CHANGE_ADD_PRINTER_DRIVER: u32 = 268435456;
pub const PRINTER_CHANGE_SET_PRINTER_DRIVER: u32 = 536870912;
pub const PRINTER_CHANGE_DELETE_PRINTER_DRIVER: u32 = 1073741824;
pub const PRINTER_CHANGE_PRINTER_DRIVER: u32 = 1879048192;
pub const PRINTER_CHANGE_TIMEOUT: u32 = 2147483648;
pub const PRINTER_CHANGE_ALL: u32 = 2138570751;
pub const PRINTER_ERROR_INFORMATION: u32 = 2147483648;
pub const PRINTER_ERROR_WARNING: u32 = 1073741824;
pub const PRINTER_ERROR_SEVERE: u32 = 536870912;
pub const PRINTER_ERROR_OUTOFPAPER: u32 = 1;
pub const PRINTER_ERROR_JAM: u32 = 2;
pub const PRINTER_ERROR_OUTOFTONER: u32 = 4;
pub const SPLREG_PRINT_DRIVER_ISOLATION_GROUPS_SEPARATOR: u8 = 92u8;
pub const SERVER_ACCESS_ADMINISTER: u32 = 1;
pub const SERVER_ACCESS_ENUMERATE: u32 = 2;
pub const PRINTER_ACCESS_ADMINISTER: u32 = 4;
pub const PRINTER_ACCESS_USE: u32 = 8;
pub const JOB_ACCESS_ADMINISTER: u32 = 16;
pub const JOB_ACCESS_READ: u32 = 32;
pub const PRINTER_ACCESS_MANAGE_LIMITED: u32 = 64;
pub const SERVER_ALL_ACCESS: u32 = 983043;
pub const SERVER_READ: u32 = 131074;
pub const SERVER_WRITE: u32 = 131075;
pub const SERVER_EXECUTE: u32 = 131074;
pub const PRINTER_ALL_ACCESS: u32 = 983052;
pub const PRINTER_READ: u32 = 131080;
pub const PRINTER_WRITE: u32 = 131080;
pub const PRINTER_EXECUTE: u32 = 131080;
pub const JOB_ALL_ACCESS: u32 = 983088;
pub const JOB_READ: u32 = 131104;
pub const JOB_WRITE: u32 = 131088;
pub const JOB_EXECUTE: u32 = 131088;
pub const PRINTER_CONNECTION_MISMATCH: u32 = 32;
pub const PRINTER_CONNECTION_NO_UI: u32 = 64;
pub const IPDFP_COPY_ALL_FILES: u32 = 1;
pub const UPDP_SILENT_UPLOAD: u32 = 1;
pub const UPDP_UPLOAD_ALWAYS: u32 = 2;
pub const UPDP_CHECK_DRIVERSTORE: u32 = 4;
pub const MS_PRINT_JOB_OUTPUT_FILE: &[u8; 21] = b"MsPrintJobOutputFile\0";
pub const _MAX_ITOSTR_BASE16_COUNT: u32 = 9;
pub const _MAX_ITOSTR_BASE10_COUNT: u32 = 12;
pub const _MAX_ITOSTR_BASE8_COUNT: u32 = 12;
pub const _MAX_ITOSTR_BASE2_COUNT: u32 = 33;
pub const _MAX_LTOSTR_BASE16_COUNT: u32 = 9;
pub const _MAX_LTOSTR_BASE10_COUNT: u32 = 12;
pub const _MAX_LTOSTR_BASE8_COUNT: u32 = 12;
pub const _MAX_LTOSTR_BASE2_COUNT: u32 = 33;
pub const _MAX_ULTOSTR_BASE16_COUNT: u32 = 9;
pub const _MAX_ULTOSTR_BASE10_COUNT: u32 = 11;
pub const _MAX_ULTOSTR_BASE8_COUNT: u32 = 12;
pub const _MAX_ULTOSTR_BASE2_COUNT: u32 = 33;
pub const _MAX_I64TOSTR_BASE16_COUNT: u32 = 17;
pub const _MAX_I64TOSTR_BASE10_COUNT: u32 = 21;
pub const _MAX_I64TOSTR_BASE8_COUNT: u32 = 23;
pub const _MAX_I64TOSTR_BASE2_COUNT: u32 = 65;
pub const _MAX_U64TOSTR_BASE16_COUNT: u32 = 17;
pub const _MAX_U64TOSTR_BASE10_COUNT: u32 = 21;
pub const _MAX_U64TOSTR_BASE8_COUNT: u32 = 23;
pub const _MAX_U64TOSTR_BASE2_COUNT: u32 = 65;
pub const CHAR_BIT: u32 = 8;
pub const SCHAR_MIN: i32 = -128;
pub const SCHAR_MAX: u32 = 127;
pub const UCHAR_MAX: u32 = 255;
pub const CHAR_MIN: i32 = -128;
pub const CHAR_MAX: u32 = 127;
pub const MB_LEN_MAX: u32 = 5;
pub const SHRT_MIN: i32 = -32768;
pub const SHRT_MAX: u32 = 32767;
pub const USHRT_MAX: u32 = 65535;
pub const INT_MIN: i32 = -2147483648;
pub const INT_MAX: u32 = 2147483647;
pub const UINT_MAX: u32 = 4294967295;
pub const LONG_MIN: i32 = -2147483648;
pub const LONG_MAX: u32 = 2147483647;
pub const ULONG_MAX: u32 = 4294967295;
pub const EXIT_SUCCESS: u32 = 0;
pub const EXIT_FAILURE: u32 = 1;
pub const _WRITE_ABORT_MSG: u32 = 1;
pub const _CALL_REPORTFAULT: u32 = 2;
pub const _OUT_TO_DEFAULT: u32 = 0;
pub const _OUT_TO_STDERR: u32 = 1;
pub const _OUT_TO_MSGBOX: u32 = 2;
pub const _REPORT_ERRMODE: u32 = 3;
pub const RAND_MAX: u32 = 32767;
pub const _CVTBUFSIZE: u32 = 349;
pub const _MAX_PATH: u32 = 260;
pub const _MAX_DRIVE: u32 = 3;
pub const _MAX_DIR: u32 = 256;
pub const _MAX_FNAME: u32 = 256;
pub const _MAX_EXT: u32 = 256;
pub const _MAX_ENV: u32 = 32767;
pub const _CRT_INTERNAL_COMBASE_SYMBOL_PREFIX: &[u8; 1] = b"\0";
pub const COM_RIGHTS_EXECUTE: u32 = 1;
pub const COM_RIGHTS_EXECUTE_LOCAL: u32 = 2;
pub const COM_RIGHTS_EXECUTE_REMOTE: u32 = 4;
pub const COM_RIGHTS_ACTIVATE_LOCAL: u32 = 8;
pub const COM_RIGHTS_ACTIVATE_REMOTE: u32 = 16;
pub const COM_RIGHTS_RESERVED1: u32 = 32;
pub const COM_RIGHTS_RESERVED2: u32 = 64;
pub const CWMO_MAX_HANDLES: u32 = 56;
pub const FADF_AUTO: u32 = 1;
pub const FADF_STATIC: u32 = 2;
pub const FADF_EMBEDDED: u32 = 4;
pub const FADF_FIXEDSIZE: u32 = 16;
pub const FADF_RECORD: u32 = 32;
pub const FADF_HAVEIID: u32 = 64;
pub const FADF_HAVEVARTYPE: u32 = 128;
pub const FADF_BSTR: u32 = 256;
pub const FADF_UNKNOWN: u32 = 512;
pub const FADF_DISPATCH: u32 = 1024;
pub const FADF_VARIANT: u32 = 2048;
pub const FADF_RESERVED: u32 = 61448;
pub const PARAMFLAG_NONE: u32 = 0;
pub const PARAMFLAG_FIN: u32 = 1;
pub const PARAMFLAG_FOUT: u32 = 2;
pub const PARAMFLAG_FLCID: u32 = 4;
pub const PARAMFLAG_FRETVAL: u32 = 8;
pub const PARAMFLAG_FOPT: u32 = 16;
pub const PARAMFLAG_FHASDEFAULT: u32 = 32;
pub const PARAMFLAG_FHASCUSTDATA: u32 = 64;
pub const IDLFLAG_NONE: u32 = 0;
pub const IDLFLAG_FIN: u32 = 1;
pub const IDLFLAG_FOUT: u32 = 2;
pub const IDLFLAG_FLCID: u32 = 4;
pub const IDLFLAG_FRETVAL: u32 = 8;
pub const IMPLTYPEFLAG_FDEFAULT: u32 = 1;
pub const IMPLTYPEFLAG_FSOURCE: u32 = 2;
pub const IMPLTYPEFLAG_FRESTRICTED: u32 = 4;
pub const IMPLTYPEFLAG_FDEFAULTVTABLE: u32 = 8;
pub const DISPID_UNKNOWN: i32 = -1;
pub const DISPID_VALUE: u32 = 0;
pub const DISPID_PROPERTYPUT: i32 = -3;
pub const DISPID_NEWENUM: i32 = -4;
pub const DISPID_EVALUATE: i32 = -5;
pub const DISPID_CONSTRUCTOR: i32 = -6;
pub const DISPID_DESTRUCTOR: i32 = -7;
pub const DISPID_COLLECT: i32 = -8;
pub const PROPSETFLAG_DEFAULT: u32 = 0;
pub const PROPSETFLAG_NONSIMPLE: u32 = 1;
pub const PROPSETFLAG_ANSI: u32 = 2;
pub const PROPSETFLAG_UNBUFFERED: u32 = 4;
pub const PROPSETFLAG_CASE_SENSITIVE: u32 = 8;
pub const PROPSET_BEHAVIOR_CASE_SENSITIVE: u32 = 1;
pub const PID_DICTIONARY: u32 = 0;
pub const PID_CODEPAGE: u32 = 1;
pub const PID_FIRST_USABLE: u32 = 2;
pub const PID_FIRST_NAME_DEFAULT: u32 = 4095;
pub const PID_LOCALE: u32 = 2147483648;
pub const PID_MODIFY_TIME: u32 = 2147483649;
pub const PID_SECURITY: u32 = 2147483650;
pub const PID_BEHAVIOR: u32 = 2147483651;
pub const PID_ILLEGAL: u32 = 4294967295;
pub const PID_MIN_READONLY: u32 = 2147483648;
pub const PID_MAX_READONLY: u32 = 3221225471;
pub const PRSPEC_INVALID: u32 = 4294967295;
pub const PRSPEC_LPWSTR: u32 = 0;
pub const PRSPEC_PROPID: u32 = 1;
pub const PROPSETHDR_OSVERSION_UNKNOWN: u32 = 4294967295;
pub const CWCSTORAGENAME: u32 = 32;
pub const STGM_DIRECT: u32 = 0;
pub const STGM_TRANSACTED: u32 = 65536;
pub const STGM_SIMPLE: u32 = 134217728;
pub const STGM_READ: u32 = 0;
pub const STGM_WRITE: u32 = 1;
pub const STGM_READWRITE: u32 = 2;
pub const STGM_SHARE_DENY_NONE: u32 = 64;
pub const STGM_SHARE_DENY_READ: u32 = 48;
pub const STGM_SHARE_DENY_WRITE: u32 = 32;
pub const STGM_SHARE_EXCLUSIVE: u32 = 16;
pub const STGM_PRIORITY: u32 = 262144;
pub const STGM_DELETEONRELEASE: u32 = 67108864;
pub const STGM_NOSCRATCH: u32 = 1048576;
pub const STGM_CREATE: u32 = 4096;
pub const STGM_CONVERT: u32 = 131072;
pub const STGM_FAILIFTHERE: u32 = 0;
pub const STGM_NOSNAPSHOT: u32 = 2097152;
pub const STGM_DIRECT_SWMR: u32 = 4194304;
pub const STGFMT_STORAGE: u32 = 0;
pub const STGFMT_NATIVE: u32 = 1;
pub const STGFMT_FILE: u32 = 3;
pub const STGFMT_ANY: u32 = 4;
pub const STGFMT_DOCFILE: u32 = 5;
pub const STGFMT_DOCUMENT: u32 = 0;
pub const STGOPTIONS_VERSION: u32 = 2;
pub const CCH_MAX_PROPSTG_NAME: u32 = 31;
pub const MARSHALINTERFACE_MIN: u32 = 500;
pub const ASYNC_MODE_COMPATIBILITY: u32 = 1;
pub const ASYNC_MODE_DEFAULT: u32 = 0;
pub const STGTY_REPEAT: u32 = 256;
pub const STG_TOEND: u32 = 4294967295;
pub const STG_LAYOUT_SEQUENTIAL: u32 = 0;
pub const STG_LAYOUT_INTERLEAVED: u32 = 1;
pub const UPDFCACHE_NODATACACHE: u32 = 1;
pub const UPDFCACHE_ONSAVECACHE: u32 = 2;
pub const UPDFCACHE_ONSTOPCACHE: u32 = 4;
pub const UPDFCACHE_NORMALCACHE: u32 = 8;
pub const UPDFCACHE_IFBLANK: u32 = 16;
pub const UPDFCACHE_ONLYIFBLANK: u32 = 2147483648;
pub const UPDFCACHE_IFBLANKORONSAVECACHE: u32 = 18;
pub const MK_ALT: u32 = 32;
pub const DROPEFFECT_NONE: u32 = 0;
pub const DROPEFFECT_COPY: u32 = 1;
pub const DROPEFFECT_MOVE: u32 = 2;
pub const DROPEFFECT_LINK: u32 = 4;
pub const DROPEFFECT_SCROLL: u32 = 2147483648;
pub const DD_DEFSCROLLINSET: u32 = 11;
pub const DD_DEFSCROLLDELAY: u32 = 50;
pub const DD_DEFSCROLLINTERVAL: u32 = 50;
pub const DD_DEFDRAGDELAY: u32 = 200;
pub const DD_DEFDRAGMINDIST: u32 = 2;
pub const MKSYS_URLMONIKER: u32 = 6;
pub const URL_MK_LEGACY: u32 = 0;
pub const URL_MK_UNIFORM: u32 = 1;
pub const URL_MK_NO_CANONICALIZE: u32 = 2;
pub const FIEF_FLAG_FORCE_JITUI: u32 = 1;
pub const FIEF_FLAG_PEEK: u32 = 2;
pub const FIEF_FLAG_SKIP_INSTALLED_VERSION_CHECK: u32 = 4;
pub const FIEF_FLAG_RESERVED_0: u32 = 8;
pub const FMFD_DEFAULT: u32 = 0;
pub const FMFD_URLASFILENAME: u32 = 1;
pub const FMFD_ENABLEMIMESNIFFING: u32 = 2;
pub const FMFD_IGNOREMIMETEXTPLAIN: u32 = 4;
pub const FMFD_SERVERMIME: u32 = 8;
pub const FMFD_RESPECTTEXTPLAIN: u32 = 16;
pub const FMFD_RETURNUPDATEDIMGMIMES: u32 = 32;
pub const FMFD_RESERVED_1: u32 = 64;
pub const FMFD_RESERVED_2: u32 = 128;
pub const UAS_EXACTLEGACY: u32 = 4096;
pub const URLMON_OPTION_USERAGENT: u32 = 268435457;
pub const URLMON_OPTION_USERAGENT_REFRESH: u32 = 268435458;
pub const URLMON_OPTION_URL_ENCODING: u32 = 268435460;
pub const URLMON_OPTION_USE_BINDSTRINGCREDS: u32 = 268435464;
pub const URLMON_OPTION_USE_BROWSERAPPSDOCUMENTS: u32 = 268435472;
pub const CF_NULL: u32 = 0;
pub const Uri_CREATE_ALLOW_RELATIVE: u32 = 1;
pub const Uri_CREATE_ALLOW_IMPLICIT_WILDCARD_SCHEME: u32 = 2;
pub const Uri_CREATE_ALLOW_IMPLICIT_FILE_SCHEME: u32 = 4;
pub const Uri_CREATE_NOFRAG: u32 = 8;
pub const Uri_CREATE_NO_CANONICALIZE: u32 = 16;
pub const Uri_CREATE_CANONICALIZE: u32 = 256;
pub const Uri_CREATE_FILE_USE_DOS_PATH: u32 = 32;
pub const Uri_CREATE_DECODE_EXTRA_INFO: u32 = 64;
pub const Uri_CREATE_NO_DECODE_EXTRA_INFO: u32 = 128;
pub const Uri_CREATE_CRACK_UNKNOWN_SCHEMES: u32 = 512;
pub const Uri_CREATE_NO_CRACK_UNKNOWN_SCHEMES: u32 = 1024;
pub const Uri_CREATE_PRE_PROCESS_HTML_URI: u32 = 2048;
pub const Uri_CREATE_NO_PRE_PROCESS_HTML_URI: u32 = 4096;
pub const Uri_CREATE_IE_SETTINGS: u32 = 8192;
pub const Uri_CREATE_NO_IE_SETTINGS: u32 = 16384;
pub const Uri_CREATE_NO_ENCODE_FORBIDDEN_CHARACTERS: u32 = 32768;
pub const Uri_CREATE_NORMALIZE_INTL_CHARACTERS: u32 = 65536;
pub const Uri_CREATE_CANONICALIZE_ABSOLUTE: u32 = 131072;
pub const Uri_DISPLAY_NO_FRAGMENT: u32 = 1;
pub const Uri_PUNYCODE_IDN_HOST: u32 = 2;
pub const Uri_DISPLAY_IDN_HOST: u32 = 4;
pub const Uri_DISPLAY_NO_PUNYCODE: u32 = 8;
pub const Uri_ENCODING_USER_INFO_AND_PATH_IS_PERCENT_ENCODED_UTF8: u32 = 1;
pub const Uri_ENCODING_USER_INFO_AND_PATH_IS_CP: u32 = 2;
pub const Uri_ENCODING_HOST_IS_IDN: u32 = 4;
pub const Uri_ENCODING_HOST_IS_PERCENT_ENCODED_UTF8: u32 = 8;
pub const Uri_ENCODING_HOST_IS_PERCENT_ENCODED_CP: u32 = 16;
pub const Uri_ENCODING_QUERY_AND_FRAGMENT_IS_PERCENT_ENCODED_UTF8: u32 = 32;
pub const Uri_ENCODING_QUERY_AND_FRAGMENT_IS_CP: u32 = 64;
pub const Uri_ENCODING_RFC: u32 = 41;
pub const UriBuilder_USE_ORIGINAL_FLAGS: u32 = 1;
pub const WININETINFO_OPTION_LOCK_HANDLE: u32 = 65534;
pub const URLOSTRM_USECACHEDCOPY_ONLY: u32 = 1;
pub const URLOSTRM_USECACHEDCOPY: u32 = 2;
pub const URLOSTRM_GETNEWESTVERSION: u32 = 3;
pub const SET_FEATURE_ON_THREAD: u32 = 1;
pub const SET_FEATURE_ON_PROCESS: u32 = 2;
pub const SET_FEATURE_IN_REGISTRY: u32 = 4;
pub const SET_FEATURE_ON_THREAD_LOCALMACHINE: u32 = 8;
pub const SET_FEATURE_ON_THREAD_INTRANET: u32 = 16;
pub const SET_FEATURE_ON_THREAD_TRUSTED: u32 = 32;
pub const SET_FEATURE_ON_THREAD_INTERNET: u32 = 64;
pub const SET_FEATURE_ON_THREAD_RESTRICTED: u32 = 128;
pub const GET_FEATURE_FROM_THREAD: u32 = 1;
pub const GET_FEATURE_FROM_PROCESS: u32 = 2;
pub const GET_FEATURE_FROM_REGISTRY: u32 = 4;
pub const GET_FEATURE_FROM_THREAD_LOCALMACHINE: u32 = 8;
pub const GET_FEATURE_FROM_THREAD_INTRANET: u32 = 16;
pub const GET_FEATURE_FROM_THREAD_TRUSTED: u32 = 32;
pub const GET_FEATURE_FROM_THREAD_INTERNET: u32 = 64;
pub const GET_FEATURE_FROM_THREAD_RESTRICTED: u32 = 128;
pub const PROTOCOLFLAG_NO_PICS_CHECK: u32 = 1;
pub const MUTZ_NOSAVEDFILECHECK: u32 = 1;
pub const MUTZ_ISFILE: u32 = 2;
pub const MUTZ_ACCEPT_WILDCARD_SCHEME: u32 = 128;
pub const MUTZ_ENFORCERESTRICTED: u32 = 256;
pub const MUTZ_RESERVED: u32 = 512;
pub const MUTZ_REQUIRESAVEDFILECHECK: u32 = 1024;
pub const MUTZ_DONT_UNESCAPE: u32 = 2048;
pub const MUTZ_DONT_USE_CACHE: u32 = 4096;
pub const MUTZ_FORCE_INTRANET_FLAGS: u32 = 8192;
pub const MUTZ_IGNORE_ZONE_MAPPINGS: u32 = 16384;
pub const MAX_SIZE_SECURITY_ID: u32 = 512;
pub const URLACTION_MIN: u32 = 4096;
pub const URLACTION_DOWNLOAD_MIN: u32 = 4096;
pub const URLACTION_DOWNLOAD_SIGNED_ACTIVEX: u32 = 4097;
pub const URLACTION_DOWNLOAD_UNSIGNED_ACTIVEX: u32 = 4100;
pub const URLACTION_DOWNLOAD_CURR_MAX: u32 = 4100;
pub const URLACTION_DOWNLOAD_MAX: u32 = 4607;
pub const URLACTION_ACTIVEX_MIN: u32 = 4608;
pub const URLACTION_ACTIVEX_RUN: u32 = 4608;
pub const URLPOLICY_ACTIVEX_CHECK_LIST: u32 = 65536;
pub const URLACTION_ACTIVEX_OVERRIDE_OBJECT_SAFETY: u32 = 4609;
pub const URLACTION_ACTIVEX_OVERRIDE_DATA_SAFETY: u32 = 4610;
pub const URLACTION_ACTIVEX_OVERRIDE_SCRIPT_SAFETY: u32 = 4611;
pub const URLACTION_SCRIPT_OVERRIDE_SAFETY: u32 = 5121;
pub const URLACTION_ACTIVEX_CONFIRM_NOOBJECTSAFETY: u32 = 4612;
pub const URLACTION_ACTIVEX_TREATASUNTRUSTED: u32 = 4613;
pub const URLACTION_ACTIVEX_NO_WEBOC_SCRIPT: u32 = 4614;
pub const URLACTION_ACTIVEX_OVERRIDE_REPURPOSEDETECTION: u32 = 4615;
pub const URLACTION_ACTIVEX_OVERRIDE_OPTIN: u32 = 4616;
pub const URLACTION_ACTIVEX_SCRIPTLET_RUN: u32 = 4617;
pub const URLACTION_ACTIVEX_DYNSRC_VIDEO_AND_ANIMATION: u32 = 4618;
pub const URLACTION_ACTIVEX_OVERRIDE_DOMAINLIST: u32 = 4619;
pub const URLACTION_ACTIVEX_ALLOW_TDC: u32 = 4620;
pub const URLACTION_ACTIVEX_CURR_MAX: u32 = 4620;
pub const URLACTION_ACTIVEX_MAX: u32 = 5119;
pub const URLACTION_SCRIPT_MIN: u32 = 5120;
pub const URLACTION_SCRIPT_RUN: u32 = 5120;
pub const URLACTION_SCRIPT_JAVA_USE: u32 = 5122;
pub const URLACTION_SCRIPT_SAFE_ACTIVEX: u32 = 5125;
pub const URLACTION_CROSS_DOMAIN_DATA: u32 = 5126;
pub const URLACTION_SCRIPT_PASTE: u32 = 5127;
pub const URLACTION_ALLOW_XDOMAIN_SUBFRAME_RESIZE: u32 = 5128;
pub const URLACTION_SCRIPT_XSSFILTER: u32 = 5129;
pub const URLACTION_SCRIPT_NAVIGATE: u32 = 5130;
pub const URLACTION_PLUGGABLE_PROTOCOL_XHR: u32 = 5131;
pub const URLACTION_ALLOW_VBSCRIPT_IE: u32 = 5132;
pub const URLACTION_ALLOW_JSCRIPT_IE: u32 = 5133;
pub const URLACTION_SCRIPT_CURR_MAX: u32 = 5133;
pub const URLACTION_SCRIPT_MAX: u32 = 5631;
pub const URLACTION_HTML_MIN: u32 = 5632;
pub const URLACTION_HTML_SUBMIT_FORMS: u32 = 5633;
pub const URLACTION_HTML_SUBMIT_FORMS_FROM: u32 = 5634;
pub const URLACTION_HTML_SUBMIT_FORMS_TO: u32 = 5635;
pub const URLACTION_HTML_FONT_DOWNLOAD: u32 = 5636;
pub const URLACTION_HTML_JAVA_RUN: u32 = 5637;
pub const URLACTION_HTML_USERDATA_SAVE: u32 = 5638;
pub const URLACTION_HTML_SUBFRAME_NAVIGATE: u32 = 5639;
pub const URLACTION_HTML_META_REFRESH: u32 = 5640;
pub const URLACTION_HTML_MIXED_CONTENT: u32 = 5641;
pub const URLACTION_HTML_INCLUDE_FILE_PATH: u32 = 5642;
pub const URLACTION_HTML_ALLOW_INJECTED_DYNAMIC_HTML: u32 = 5643;
pub const URLACTION_HTML_REQUIRE_UTF8_DOCUMENT_CODEPAGE: u32 = 5644;
pub const URLACTION_HTML_ALLOW_CROSS_DOMAIN_CANVAS: u32 = 5645;
pub const URLACTION_HTML_ALLOW_WINDOW_CLOSE: u32 = 5646;
pub const URLACTION_HTML_ALLOW_CROSS_DOMAIN_WEBWORKER: u32 = 5647;
pub const URLACTION_HTML_ALLOW_CROSS_DOMAIN_TEXTTRACK: u32 = 5648;
pub const URLACTION_HTML_ALLOW_INDEXEDDB: u32 = 5649;
pub const URLACTION_HTML_MAX: u32 = 6143;
pub const URLACTION_SHELL_MIN: u32 = 6144;
pub const URLACTION_SHELL_INSTALL_DTITEMS: u32 = 6144;
pub const URLACTION_SHELL_MOVE_OR_COPY: u32 = 6146;
pub const URLACTION_SHELL_FILE_DOWNLOAD: u32 = 6147;
pub const URLACTION_SHELL_VERB: u32 = 6148;
pub const URLACTION_SHELL_WEBVIEW_VERB: u32 = 6149;
pub const URLACTION_SHELL_SHELLEXECUTE: u32 = 6150;
pub const URLACTION_SHELL_EXECUTE_HIGHRISK: u32 = 6150;
pub const URLACTION_SHELL_EXECUTE_MODRISK: u32 = 6151;
pub const URLACTION_SHELL_EXECUTE_LOWRISK: u32 = 6152;
pub const URLACTION_SHELL_POPUPMGR: u32 = 6153;
pub const URLACTION_SHELL_RTF_OBJECTS_LOAD: u32 = 6154;
pub const URLACTION_SHELL_ENHANCED_DRAGDROP_SECURITY: u32 = 6155;
pub const URLACTION_SHELL_EXTENSIONSECURITY: u32 = 6156;
pub const URLACTION_SHELL_SECURE_DRAGSOURCE: u32 = 6157;
pub const URLACTION_SHELL_REMOTEQUERY: u32 = 6158;
pub const URLACTION_SHELL_PREVIEW: u32 = 6159;
pub const URLACTION_SHELL_SHARE: u32 = 6160;
pub const URLACTION_SHELL_ALLOW_CROSS_SITE_SHARE: u32 = 6161;
pub const URLACTION_SHELL_TOCTOU_RISK: u32 = 6162;
pub const URLACTION_SHELL_CURR_MAX: u32 = 6162;
pub const URLACTION_SHELL_MAX: u32 = 6655;
pub const URLACTION_NETWORK_MIN: u32 = 6656;
pub const URLACTION_CREDENTIALS_USE: u32 = 6656;
pub const URLPOLICY_CREDENTIALS_SILENT_LOGON_OK: u32 = 0;
pub const URLPOLICY_CREDENTIALS_MUST_PROMPT_USER: u32 = 65536;
pub const URLPOLICY_CREDENTIALS_CONDITIONAL_PROMPT: u32 = 131072;
pub const URLPOLICY_CREDENTIALS_ANONYMOUS_ONLY: u32 = 196608;
pub const URLACTION_AUTHENTICATE_CLIENT: u32 = 6657;
pub const URLPOLICY_AUTHENTICATE_CLEARTEXT_OK: u32 = 0;
pub const URLPOLICY_AUTHENTICATE_CHALLENGE_RESPONSE: u32 = 65536;
pub const URLPOLICY_AUTHENTICATE_MUTUAL_ONLY: u32 = 196608;
pub const URLACTION_COOKIES: u32 = 6658;
pub const URLACTION_COOKIES_SESSION: u32 = 6659;
pub const URLACTION_CLIENT_CERT_PROMPT: u32 = 6660;
pub const URLACTION_COOKIES_THIRD_PARTY: u32 = 6661;
pub const URLACTION_COOKIES_SESSION_THIRD_PARTY: u32 = 6662;
pub const URLACTION_COOKIES_ENABLED: u32 = 6672;
pub const URLACTION_NETWORK_CURR_MAX: u32 = 6672;
pub const URLACTION_NETWORK_MAX: u32 = 7167;
pub const URLACTION_JAVA_MIN: u32 = 7168;
pub const URLACTION_JAVA_PERMISSIONS: u32 = 7168;
pub const URLPOLICY_JAVA_PROHIBIT: u32 = 0;
pub const URLPOLICY_JAVA_HIGH: u32 = 65536;
pub const URLPOLICY_JAVA_MEDIUM: u32 = 131072;
pub const URLPOLICY_JAVA_LOW: u32 = 196608;
pub const URLPOLICY_JAVA_CUSTOM: u32 = 8388608;
pub const URLACTION_JAVA_CURR_MAX: u32 = 7168;
pub const URLACTION_JAVA_MAX: u32 = 7423;
pub const URLACTION_INFODELIVERY_MIN: u32 = 7424;
pub const URLACTION_INFODELIVERY_NO_ADDING_CHANNELS: u32 = 7424;
pub const URLACTION_INFODELIVERY_NO_EDITING_CHANNELS: u32 = 7425;
pub const URLACTION_INFODELIVERY_NO_REMOVING_CHANNELS: u32 = 7426;
pub const URLACTION_INFODELIVERY_NO_ADDING_SUBSCRIPTIONS: u32 = 7427;
pub const URLACTION_INFODELIVERY_NO_EDITING_SUBSCRIPTIONS: u32 = 7428;
pub const URLACTION_INFODELIVERY_NO_REMOVING_SUBSCRIPTIONS: u32 = 7429;
pub const URLACTION_INFODELIVERY_NO_CHANNEL_LOGGING: u32 = 7430;
pub const URLACTION_INFODELIVERY_CURR_MAX: u32 = 7430;
pub const URLACTION_INFODELIVERY_MAX: u32 = 7679;
pub const URLACTION_CHANNEL_SOFTDIST_MIN: u32 = 7680;
pub const URLACTION_CHANNEL_SOFTDIST_PERMISSIONS: u32 = 7685;
pub const URLPOLICY_CHANNEL_SOFTDIST_PROHIBIT: u32 = 65536;
pub const URLPOLICY_CHANNEL_SOFTDIST_PRECACHE: u32 = 131072;
pub const URLPOLICY_CHANNEL_SOFTDIST_AUTOINSTALL: u32 = 196608;
pub const URLACTION_CHANNEL_SOFTDIST_MAX: u32 = 7935;
pub const URLACTION_DOTNET_USERCONTROLS: u32 = 8197;
pub const URLACTION_BEHAVIOR_MIN: u32 = 8192;
pub const URLACTION_BEHAVIOR_RUN: u32 = 8192;
pub const URLPOLICY_BEHAVIOR_CHECK_LIST: u32 = 65536;
pub const URLACTION_FEATURE_MIN: u32 = 8448;
pub const URLACTION_FEATURE_MIME_SNIFFING: u32 = 8448;
pub const URLACTION_FEATURE_ZONE_ELEVATION: u32 = 8449;
pub const URLACTION_FEATURE_WINDOW_RESTRICTIONS: u32 = 8450;
pub const URLACTION_FEATURE_SCRIPT_STATUS_BAR: u32 = 8451;
pub const URLACTION_FEATURE_FORCE_ADDR_AND_STATUS: u32 = 8452;
pub const URLACTION_FEATURE_BLOCK_INPUT_PROMPTS: u32 = 8453;
pub const URLACTION_FEATURE_DATA_BINDING: u32 = 8454;
pub const URLACTION_FEATURE_CROSSDOMAIN_FOCUS_CHANGE: u32 = 8455;
pub const URLACTION_AUTOMATIC_DOWNLOAD_UI_MIN: u32 = 8704;
pub const URLACTION_AUTOMATIC_DOWNLOAD_UI: u32 = 8704;
pub const URLACTION_AUTOMATIC_ACTIVEX_UI: u32 = 8705;
pub const URLACTION_ALLOW_RESTRICTEDPROTOCOLS: u32 = 8960;
pub const URLACTION_ALLOW_APEVALUATION: u32 = 8961;
pub const URLACTION_ALLOW_XHR_EVALUATION: u32 = 8962;
pub const URLACTION_WINDOWS_BROWSER_APPLICATIONS: u32 = 9216;
pub const URLACTION_XPS_DOCUMENTS: u32 = 9217;
pub const URLACTION_LOOSE_XAML: u32 = 9218;
pub const URLACTION_LOWRIGHTS: u32 = 9472;
pub const URLACTION_WINFX_SETUP: u32 = 9728;
pub const URLACTION_INPRIVATE_BLOCKING: u32 = 9984;
pub const URLACTION_ALLOW_AUDIO_VIDEO: u32 = 9985;
pub const URLACTION_ALLOW_ACTIVEX_FILTERING: u32 = 9986;
pub const URLACTION_ALLOW_STRUCTURED_STORAGE_SNIFFING: u32 = 9987;
pub const URLACTION_ALLOW_AUDIO_VIDEO_PLUGINS: u32 = 9988;
pub const URLACTION_ALLOW_ZONE_ELEVATION_VIA_OPT_OUT: u32 = 9989;
pub const URLACTION_ALLOW_ZONE_ELEVATION_OPT_OUT_ADDITION: u32 = 9990;
pub const URLACTION_ALLOW_CROSSDOMAIN_DROP_WITHIN_WINDOW: u32 = 9992;
pub const URLACTION_ALLOW_CROSSDOMAIN_DROP_ACROSS_WINDOWS: u32 = 9993;
pub const URLACTION_ALLOW_CROSSDOMAIN_APPCACHE_MANIFEST: u32 = 9994;
pub const URLACTION_ALLOW_RENDER_LEGACY_DXTFILTERS: u32 = 9995;
pub const URLACTION_ALLOW_ANTIMALWARE_SCANNING_OF_ACTIVEX: u32 = 9996;
pub const URLACTION_ALLOW_CSS_EXPRESSIONS: u32 = 9997;
pub const URLPOLICY_ALLOW: u32 = 0;
pub const URLPOLICY_QUERY: u32 = 1;
pub const URLPOLICY_DISALLOW: u32 = 3;
pub const URLPOLICY_NOTIFY_ON_ALLOW: u32 = 16;
pub const URLPOLICY_NOTIFY_ON_DISALLOW: u32 = 32;
pub const URLPOLICY_LOG_ON_ALLOW: u32 = 64;
pub const URLPOLICY_LOG_ON_DISALLOW: u32 = 128;
pub const URLPOLICY_MASK_PERMISSIONS: u32 = 15;
pub const URLPOLICY_DONTCHECKDLGBOX: u32 = 256;
pub const URLZONE_ESC_FLAG: u32 = 256;
pub const SECURITY_IE_STATE_GREEN: u32 = 0;
pub const SECURITY_IE_STATE_RED: u32 = 1;
pub const SOFTDIST_FLAG_USAGE_EMAIL: u32 = 1;
pub const SOFTDIST_FLAG_USAGE_PRECACHE: u32 = 2;
pub const SOFTDIST_FLAG_USAGE_AUTOINSTALL: u32 = 4;
pub const SOFTDIST_FLAG_DELETE_SUBSCRIPTION: u32 = 8;
pub const SOFTDIST_ADSTATE_NONE: u32 = 0;
pub const SOFTDIST_ADSTATE_AVAILABLE: u32 = 1;
pub const SOFTDIST_ADSTATE_DOWNLOADED: u32 = 2;
pub const SOFTDIST_ADSTATE_INSTALLED: u32 = 3;
pub const CONFIRMSAFETYACTION_LOADOBJECT: u32 = 1;
pub const PIDDI_THUMBNAIL: u32 = 2;
pub const PIDSI_TITLE: u32 = 2;
pub const PIDSI_SUBJECT: u32 = 3;
pub const PIDSI_AUTHOR: u32 = 4;
pub const PIDSI_KEYWORDS: u32 = 5;
pub const PIDSI_COMMENTS: u32 = 6;
pub const PIDSI_TEMPLATE: u32 = 7;
pub const PIDSI_LASTAUTHOR: u32 = 8;
pub const PIDSI_REVNUMBER: u32 = 9;
pub const PIDSI_EDITTIME: u32 = 10;
pub const PIDSI_LASTPRINTED: u32 = 11;
pub const PIDSI_CREATE_DTM: u32 = 12;
pub const PIDSI_LASTSAVE_DTM: u32 = 13;
pub const PIDSI_PAGECOUNT: u32 = 14;
pub const PIDSI_WORDCOUNT: u32 = 15;
pub const PIDSI_CHARCOUNT: u32 = 16;
pub const PIDSI_THUMBNAIL: u32 = 17;
pub const PIDSI_APPNAME: u32 = 18;
pub const PIDSI_DOC_SECURITY: u32 = 19;
pub const PIDDSI_CATEGORY: u32 = 2;
pub const PIDDSI_PRESFORMAT: u32 = 3;
pub const PIDDSI_BYTECOUNT: u32 = 4;
pub const PIDDSI_LINECOUNT: u32 = 5;
pub const PIDDSI_PARCOUNT: u32 = 6;
pub const PIDDSI_SLIDECOUNT: u32 = 7;
pub const PIDDSI_NOTECOUNT: u32 = 8;
pub const PIDDSI_HIDDENCOUNT: u32 = 9;
pub const PIDDSI_MMCLIPCOUNT: u32 = 10;
pub const PIDDSI_SCALE: u32 = 11;
pub const PIDDSI_HEADINGPAIR: u32 = 12;
pub const PIDDSI_DOCPARTS: u32 = 13;
pub const PIDDSI_MANAGER: u32 = 14;
pub const PIDDSI_COMPANY: u32 = 15;
pub const PIDDSI_LINKSDIRTY: u32 = 16;
pub const PIDMSI_EDITOR: u32 = 2;
pub const PIDMSI_SUPPLIER: u32 = 3;
pub const PIDMSI_SOURCE: u32 = 4;
pub const PIDMSI_SEQUENCE_NO: u32 = 5;
pub const PIDMSI_PROJECT: u32 = 6;
pub const PIDMSI_STATUS: u32 = 7;
pub const PIDMSI_OWNER: u32 = 8;
pub const PIDMSI_RATING: u32 = 9;
pub const PIDMSI_PRODUCTION: u32 = 10;
pub const PIDMSI_COPYRIGHT: u32 = 11;
pub const STDOLE_MAJORVERNUM: u32 = 1;
pub const STDOLE_MINORVERNUM: u32 = 0;
pub const STDOLE_LCID: u32 = 0;
pub const STDOLE2_MAJORVERNUM: u32 = 2;
pub const STDOLE2_MINORVERNUM: u32 = 0;
pub const STDOLE2_LCID: u32 = 0;
pub const VARIANT_NOVALUEPROP: u32 = 1;
pub const VARIANT_ALPHABOOL: u32 = 2;
pub const VARIANT_NOUSEROVERRIDE: u32 = 4;
pub const VARIANT_CALENDAR_HIJRI: u32 = 8;
pub const VARIANT_LOCALBOOL: u32 = 16;
pub const VARIANT_CALENDAR_THAI: u32 = 32;
pub const VARIANT_CALENDAR_GREGORIAN: u32 = 64;
pub const VARIANT_USE_NLS: u32 = 128;
pub const LOCALE_USE_NLS: u32 = 268435456;
pub const VTDATEGRE_MAX: u32 = 2958465;
pub const VTDATEGRE_MIN: i32 = -657434;
pub const NUMPRS_LEADING_WHITE: u32 = 1;
pub const NUMPRS_TRAILING_WHITE: u32 = 2;
pub const NUMPRS_LEADING_PLUS: u32 = 4;
pub const NUMPRS_TRAILING_PLUS: u32 = 8;
pub const NUMPRS_LEADING_MINUS: u32 = 16;
pub const NUMPRS_TRAILING_MINUS: u32 = 32;
pub const NUMPRS_HEX_OCT: u32 = 64;
pub const NUMPRS_PARENS: u32 = 128;
pub const NUMPRS_DECIMAL: u32 = 256;
pub const NUMPRS_THOUSANDS: u32 = 512;
pub const NUMPRS_CURRENCY: u32 = 1024;
pub const NUMPRS_EXPONENT: u32 = 2048;
pub const NUMPRS_USE_ALL: u32 = 4096;
pub const NUMPRS_STD: u32 = 8191;
pub const NUMPRS_NEG: u32 = 65536;
pub const NUMPRS_INEXACT: u32 = 131072;
pub const VARCMP_LT: u32 = 0;
pub const VARCMP_EQ: u32 = 1;
pub const VARCMP_GT: u32 = 2;
pub const VARCMP_NULL: u32 = 3;
pub const MEMBERID_NIL: i32 = -1;
pub const ID_DEFAULTINST: i32 = -2;
pub const DISPATCH_METHOD: u32 = 1;
pub const DISPATCH_PROPERTYGET: u32 = 2;
pub const DISPATCH_PROPERTYPUT: u32 = 4;
pub const DISPATCH_PROPERTYPUTREF: u32 = 8;
pub const LOAD_TLB_AS_32BIT: u32 = 32;
pub const LOAD_TLB_AS_64BIT: u32 = 64;
pub const MASK_TO_RESET_TLB_BITS: i32 = -97;
pub const ACTIVEOBJECT_STRONG: u32 = 0;
pub const ACTIVEOBJECT_WEAK: u32 = 1;
pub const OLEIVERB_PRIMARY: u32 = 0;
pub const OLEIVERB_SHOW: i32 = -1;
pub const OLEIVERB_OPEN: i32 = -2;
pub const OLEIVERB_HIDE: i32 = -3;
pub const OLEIVERB_UIACTIVATE: i32 = -4;
pub const OLEIVERB_INPLACEACTIVATE: i32 = -5;
pub const OLEIVERB_DISCARDUNDOSTATE: i32 = -6;
pub const EMBDHLP_INPROC_HANDLER: u32 = 0;
pub const EMBDHLP_INPROC_SERVER: u32 = 1;
pub const EMBDHLP_CREATENOW: u32 = 0;
pub const EMBDHLP_DELAYCREATE: u32 = 65536;
pub const OLECREATE_LEAVERUNNING: u32 = 1;
pub const OFN_READONLY: u32 = 1;
pub const OFN_OVERWRITEPROMPT: u32 = 2;
pub const OFN_HIDEREADONLY: u32 = 4;
pub const OFN_NOCHANGEDIR: u32 = 8;
pub const OFN_SHOWHELP: u32 = 16;
pub const OFN_ENABLEHOOK: u32 = 32;
pub const OFN_ENABLETEMPLATE: u32 = 64;
pub const OFN_ENABLETEMPLATEHANDLE: u32 = 128;
pub const OFN_NOVALIDATE: u32 = 256;
pub const OFN_ALLOWMULTISELECT: u32 = 512;
pub const OFN_EXTENSIONDIFFERENT: u32 = 1024;
pub const OFN_PATHMUSTEXIST: u32 = 2048;
pub const OFN_FILEMUSTEXIST: u32 = 4096;
pub const OFN_CREATEPROMPT: u32 = 8192;
pub const OFN_SHAREAWARE: u32 = 16384;
pub const OFN_NOREADONLYRETURN: u32 = 32768;
pub const OFN_NOTESTFILECREATE: u32 = 65536;
pub const OFN_NONETWORKBUTTON: u32 = 131072;
pub const OFN_NOLONGNAMES: u32 = 262144;
pub const OFN_EXPLORER: u32 = 524288;
pub const OFN_NODEREFERENCELINKS: u32 = 1048576;
pub const OFN_LONGNAMES: u32 = 2097152;
pub const OFN_ENABLEINCLUDENOTIFY: u32 = 4194304;
pub const OFN_ENABLESIZING: u32 = 8388608;
pub const OFN_DONTADDTORECENT: u32 = 33554432;
pub const OFN_FORCESHOWHIDDEN: u32 = 268435456;
pub const OFN_EX_NOPLACESBAR: u32 = 1;
pub const OFN_SHAREFALLTHROUGH: u32 = 2;
pub const OFN_SHARENOWARN: u32 = 1;
pub const OFN_SHAREWARN: u32 = 0;
pub const CDN_FIRST: i32 = -601;
pub const CDN_LAST: i32 = -699;
pub const CDN_INITDONE: i32 = -601;
pub const CDN_SELCHANGE: i32 = -602;
pub const CDN_FOLDERCHANGE: i32 = -603;
pub const CDN_SHAREVIOLATION: i32 = -604;
pub const CDN_HELP: i32 = -605;
pub const CDN_FILEOK: i32 = -606;
pub const CDN_TYPECHANGE: i32 = -607;
pub const CDN_INCLUDEITEM: i32 = -608;
pub const CDM_FIRST: u32 = 1124;
pub const CDM_LAST: u32 = 1224;
pub const CDM_GETSPEC: u32 = 1124;
pub const CDM_GETFILEPATH: u32 = 1125;
pub const CDM_GETFOLDERPATH: u32 = 1126;
pub const CDM_GETFOLDERIDLIST: u32 = 1127;
pub const CDM_SETCONTROLTEXT: u32 = 1128;
pub const CDM_HIDECONTROL: u32 = 1129;
pub const CDM_SETDEFEXT: u32 = 1130;
pub const CC_RGBINIT: u32 = 1;
pub const CC_FULLOPEN: u32 = 2;
pub const CC_PREVENTFULLOPEN: u32 = 4;
pub const CC_SHOWHELP: u32 = 8;
pub const CC_ENABLEHOOK: u32 = 16;
pub const CC_ENABLETEMPLATE: u32 = 32;
pub const CC_ENABLETEMPLATEHANDLE: u32 = 64;
pub const CC_SOLIDCOLOR: u32 = 128;
pub const CC_ANYCOLOR: u32 = 256;
pub const FR_DOWN: u32 = 1;
pub const FR_WHOLEWORD: u32 = 2;
pub const FR_MATCHCASE: u32 = 4;
pub const FR_FINDNEXT: u32 = 8;
pub const FR_REPLACE: u32 = 16;
pub const FR_REPLACEALL: u32 = 32;
pub const FR_DIALOGTERM: u32 = 64;
pub const FR_SHOWHELP: u32 = 128;
pub const FR_ENABLEHOOK: u32 = 256;
pub const FR_ENABLETEMPLATE: u32 = 512;
pub const FR_NOUPDOWN: u32 = 1024;
pub const FR_NOMATCHCASE: u32 = 2048;
pub const FR_NOWHOLEWORD: u32 = 4096;
pub const FR_ENABLETEMPLATEHANDLE: u32 = 8192;
pub const FR_HIDEUPDOWN: u32 = 16384;
pub const FR_HIDEMATCHCASE: u32 = 32768;
pub const FR_HIDEWHOLEWORD: u32 = 65536;
pub const FR_RAW: u32 = 131072;
pub const FR_SHOWWRAPAROUND: u32 = 262144;
pub const FR_NOWRAPAROUND: u32 = 524288;
pub const FR_WRAPAROUND: u32 = 1048576;
pub const FR_MATCHDIAC: u32 = 536870912;
pub const FR_MATCHKASHIDA: u32 = 1073741824;
pub const FR_MATCHALEFHAMZA: u32 = 2147483648;
pub const FRM_FIRST: u32 = 1124;
pub const FRM_LAST: u32 = 1224;
pub const FRM_SETOPERATIONRESULT: u32 = 1124;
pub const FRM_SETOPERATIONRESULTTEXT: u32 = 1125;
pub const CF_SCREENFONTS: u32 = 1;
pub const CF_PRINTERFONTS: u32 = 2;
pub const CF_BOTH: u32 = 3;
pub const CF_SHOWHELP: u32 = 4;
pub const CF_ENABLEHOOK: u32 = 8;
pub const CF_ENABLETEMPLATE: u32 = 16;
pub const CF_ENABLETEMPLATEHANDLE: u32 = 32;
pub const CF_INITTOLOGFONTSTRUCT: u32 = 64;
pub const CF_USESTYLE: u32 = 128;
pub const CF_EFFECTS: u32 = 256;
pub const CF_APPLY: u32 = 512;
pub const CF_ANSIONLY: u32 = 1024;
pub const CF_SCRIPTSONLY: u32 = 1024;
pub const CF_NOVECTORFONTS: u32 = 2048;
pub const CF_NOOEMFONTS: u32 = 2048;
pub const CF_NOSIMULATIONS: u32 = 4096;
pub const CF_LIMITSIZE: u32 = 8192;
pub const CF_FIXEDPITCHONLY: u32 = 16384;
pub const CF_WYSIWYG: u32 = 32768;
pub const CF_FORCEFONTEXIST: u32 = 65536;
pub const CF_SCALABLEONLY: u32 = 131072;
pub const CF_TTONLY: u32 = 262144;
pub const CF_NOFACESEL: u32 = 524288;
pub const CF_NOSTYLESEL: u32 = 1048576;
pub const CF_NOSIZESEL: u32 = 2097152;
pub const CF_SELECTSCRIPT: u32 = 4194304;
pub const CF_NOSCRIPTSEL: u32 = 8388608;
pub const CF_NOVERTFONTS: u32 = 16777216;
pub const CF_INACTIVEFONTS: u32 = 33554432;
pub const SIMULATED_FONTTYPE: u32 = 32768;
pub const PRINTER_FONTTYPE: u32 = 16384;
pub const SCREEN_FONTTYPE: u32 = 8192;
pub const BOLD_FONTTYPE: u32 = 256;
pub const ITALIC_FONTTYPE: u32 = 512;
pub const REGULAR_FONTTYPE: u32 = 1024;
pub const PS_OPENTYPE_FONTTYPE: u32 = 65536;
pub const TT_OPENTYPE_FONTTYPE: u32 = 131072;
pub const TYPE1_FONTTYPE: u32 = 262144;
pub const SYMBOL_FONTTYPE: u32 = 524288;
pub const WM_CHOOSEFONT_GETLOGFONT: u32 = 1025;
pub const WM_CHOOSEFONT_SETLOGFONT: u32 = 1125;
pub const WM_CHOOSEFONT_SETFLAGS: u32 = 1126;
pub const LBSELCHSTRINGA: &[u8; 27] = b"commdlg_LBSelChangedNotify\0";
pub const SHAREVISTRINGA: &[u8; 23] = b"commdlg_ShareViolation\0";
pub const FILEOKSTRINGA: &[u8; 19] = b"commdlg_FileNameOK\0";
pub const COLOROKSTRINGA: &[u8; 16] = b"commdlg_ColorOK\0";
pub const SETRGBSTRINGA: &[u8; 20] = b"commdlg_SetRGBColor\0";
pub const HELPMSGSTRINGA: &[u8; 13] = b"commdlg_help\0";
pub const FINDMSGSTRINGA: &[u8; 20] = b"commdlg_FindReplace\0";
pub const LBSELCHSTRINGW: &[u8; 27] = b"commdlg_LBSelChangedNotify\0";
pub const SHAREVISTRINGW: &[u8; 23] = b"commdlg_ShareViolation\0";
pub const FILEOKSTRINGW: &[u8; 19] = b"commdlg_FileNameOK\0";
pub const COLOROKSTRINGW: &[u8; 16] = b"commdlg_ColorOK\0";
pub const SETRGBSTRINGW: &[u8; 20] = b"commdlg_SetRGBColor\0";
pub const HELPMSGSTRINGW: &[u8; 13] = b"commdlg_help\0";
pub const FINDMSGSTRINGW: &[u8; 20] = b"commdlg_FindReplace\0";
pub const LBSELCHSTRING: &[u8; 27] = b"commdlg_LBSelChangedNotify\0";
pub const SHAREVISTRING: &[u8; 23] = b"commdlg_ShareViolation\0";
pub const FILEOKSTRING: &[u8; 19] = b"commdlg_FileNameOK\0";
pub const COLOROKSTRING: &[u8; 16] = b"commdlg_ColorOK\0";
pub const SETRGBSTRING: &[u8; 20] = b"commdlg_SetRGBColor\0";
pub const HELPMSGSTRING: &[u8; 13] = b"commdlg_help\0";
pub const FINDMSGSTRING: &[u8; 20] = b"commdlg_FindReplace\0";
pub const CD_LBSELNOITEMS: i32 = -1;
pub const CD_LBSELCHANGE: u32 = 0;
pub const CD_LBSELSUB: u32 = 1;
pub const CD_LBSELADD: u32 = 2;
pub const PD_ALLPAGES: u32 = 0;
pub const PD_SELECTION: u32 = 1;
pub const PD_PAGENUMS: u32 = 2;
pub const PD_NOSELECTION: u32 = 4;
pub const PD_NOPAGENUMS: u32 = 8;
pub const PD_COLLATE: u32 = 16;
pub const PD_PRINTTOFILE: u32 = 32;
pub const PD_PRINTSETUP: u32 = 64;
pub const PD_NOWARNING: u32 = 128;
pub const PD_RETURNDC: u32 = 256;
pub const PD_RETURNIC: u32 = 512;
pub const PD_RETURNDEFAULT: u32 = 1024;
pub const PD_SHOWHELP: u32 = 2048;
pub const PD_ENABLEPRINTHOOK: u32 = 4096;
pub const PD_ENABLESETUPHOOK: u32 = 8192;
pub const PD_ENABLEPRINTTEMPLATE: u32 = 16384;
pub const PD_ENABLESETUPTEMPLATE: u32 = 32768;
pub const PD_ENABLEPRINTTEMPLATEHANDLE: u32 = 65536;
pub const PD_ENABLESETUPTEMPLATEHANDLE: u32 = 131072;
pub const PD_USEDEVMODECOPIES: u32 = 262144;
pub const PD_USEDEVMODECOPIESANDCOLLATE: u32 = 262144;
pub const PD_DISABLEPRINTTOFILE: u32 = 524288;
pub const PD_HIDEPRINTTOFILE: u32 = 1048576;
pub const PD_NONETWORKBUTTON: u32 = 2097152;
pub const PD_CURRENTPAGE: u32 = 4194304;
pub const PD_NOCURRENTPAGE: u32 = 8388608;
pub const PD_EXCLUSIONFLAGS: u32 = 16777216;
pub const PD_USELARGETEMPLATE: u32 = 268435456;
pub const PD_EXCL_COPIESANDCOLLATE: u32 = 33024;
pub const START_PAGE_GENERAL: u32 = 4294967295;
pub const PD_RESULT_CANCEL: u32 = 0;
pub const PD_RESULT_PRINT: u32 = 1;
pub const PD_RESULT_APPLY: u32 = 2;
pub const DN_DEFAULTPRN: u32 = 1;
pub const WM_PSD_PAGESETUPDLG: u32 = 1024;
pub const WM_PSD_FULLPAGERECT: u32 = 1025;
pub const WM_PSD_MINMARGINRECT: u32 = 1026;
pub const WM_PSD_MARGINRECT: u32 = 1027;
pub const WM_PSD_GREEKTEXTRECT: u32 = 1028;
pub const WM_PSD_ENVSTAMPRECT: u32 = 1029;
pub const WM_PSD_YAFULLPAGERECT: u32 = 1030;
pub const PSD_DEFAULTMINMARGINS: u32 = 0;
pub const PSD_INWININIINTLMEASURE: u32 = 0;
pub const PSD_MINMARGINS: u32 = 1;
pub const PSD_MARGINS: u32 = 2;
pub const PSD_INTHOUSANDTHSOFINCHES: u32 = 4;
pub const PSD_INHUNDREDTHSOFMILLIMETERS: u32 = 8;
pub const PSD_DISABLEMARGINS: u32 = 16;
pub const PSD_DISABLEPRINTER: u32 = 32;
pub const PSD_NOWARNING: u32 = 128;
pub const PSD_DISABLEORIENTATION: u32 = 256;
pub const PSD_RETURNDEFAULT: u32 = 1024;
pub const PSD_DISABLEPAPER: u32 = 512;
pub const PSD_SHOWHELP: u32 = 2048;
pub const PSD_ENABLEPAGESETUPHOOK: u32 = 8192;
pub const PSD_ENABLEPAGESETUPTEMPLATE: u32 = 32768;
pub const PSD_ENABLEPAGESETUPTEMPLATEHANDLE: u32 = 131072;
pub const PSD_ENABLEPAGEPAINTHOOK: u32 = 262144;
pub const PSD_DISABLEPAGEPAINTING: u32 = 524288;
pub const PSD_NONETWORKBUTTON: u32 = 2097152;
pub const _STRALIGN_USE_SECURE_CRT: u32 = 1;
pub const SERVICES_ACTIVE_DATABASEW: &[u8; 15] = b"ServicesActive\0";
pub const SERVICES_FAILED_DATABASEW: &[u8; 15] = b"ServicesFailed\0";
pub const SERVICES_ACTIVE_DATABASEA: &[u8; 15] = b"ServicesActive\0";
pub const SERVICES_FAILED_DATABASEA: &[u8; 15] = b"ServicesFailed\0";
pub const SC_GROUP_IDENTIFIERW: u8 = 43u8;
pub const SC_GROUP_IDENTIFIERA: u8 = 43u8;
pub const SERVICES_ACTIVE_DATABASE: &[u8; 15] = b"ServicesActive\0";
pub const SERVICES_FAILED_DATABASE: &[u8; 15] = b"ServicesFailed\0";
pub const SC_GROUP_IDENTIFIER: u8 = 43u8;
pub const SERVICE_NO_CHANGE: u32 = 4294967295;
pub const SERVICE_ACTIVE: u32 = 1;
pub const SERVICE_INACTIVE: u32 = 2;
pub const SERVICE_STATE_ALL: u32 = 3;
pub const SERVICE_CONTROL_STOP: u32 = 1;
pub const SERVICE_CONTROL_PAUSE: u32 = 2;
pub const SERVICE_CONTROL_CONTINUE: u32 = 3;
pub const SERVICE_CONTROL_INTERROGATE: u32 = 4;
pub const SERVICE_CONTROL_SHUTDOWN: u32 = 5;
pub const SERVICE_CONTROL_PARAMCHANGE: u32 = 6;
pub const SERVICE_CONTROL_NETBINDADD: u32 = 7;
pub const SERVICE_CONTROL_NETBINDREMOVE: u32 = 8;
pub const SERVICE_CONTROL_NETBINDENABLE: u32 = 9;
pub const SERVICE_CONTROL_NETBINDDISABLE: u32 = 10;
pub const SERVICE_CONTROL_DEVICEEVENT: u32 = 11;
pub const SERVICE_CONTROL_HARDWAREPROFILECHANGE: u32 = 12;
pub const SERVICE_CONTROL_POWEREVENT: u32 = 13;
pub const SERVICE_CONTROL_SESSIONCHANGE: u32 = 14;
pub const SERVICE_CONTROL_PRESHUTDOWN: u32 = 15;
pub const SERVICE_CONTROL_TIMECHANGE: u32 = 16;
pub const SERVICE_CONTROL_TRIGGEREVENT: u32 = 32;
pub const SERVICE_CONTROL_LOWRESOURCES: u32 = 96;
pub const SERVICE_CONTROL_SYSTEMLOWRESOURCES: u32 = 97;
pub const SERVICE_STOPPED: u32 = 1;
pub const SERVICE_START_PENDING: u32 = 2;
pub const SERVICE_STOP_PENDING: u32 = 3;
pub const SERVICE_RUNNING: u32 = 4;
pub const SERVICE_CONTINUE_PENDING: u32 = 5;
pub const SERVICE_PAUSE_PENDING: u32 = 6;
pub const SERVICE_PAUSED: u32 = 7;
pub const SERVICE_ACCEPT_STOP: u32 = 1;
pub const SERVICE_ACCEPT_PAUSE_CONTINUE: u32 = 2;
pub const SERVICE_ACCEPT_SHUTDOWN: u32 = 4;
pub const SERVICE_ACCEPT_PARAMCHANGE: u32 = 8;
pub const SERVICE_ACCEPT_NETBINDCHANGE: u32 = 16;
pub const SERVICE_ACCEPT_HARDWAREPROFILECHANGE: u32 = 32;
pub const SERVICE_ACCEPT_POWEREVENT: u32 = 64;
pub const SERVICE_ACCEPT_SESSIONCHANGE: u32 = 128;
pub const SERVICE_ACCEPT_PRESHUTDOWN: u32 = 256;
pub const SERVICE_ACCEPT_TIMECHANGE: u32 = 512;
pub const SERVICE_ACCEPT_TRIGGEREVENT: u32 = 1024;
pub const SERVICE_ACCEPT_USER_LOGOFF: u32 = 2048;
pub const SERVICE_ACCEPT_LOWRESOURCES: u32 = 8192;
pub const SERVICE_ACCEPT_SYSTEMLOWRESOURCES: u32 = 16384;
pub const SC_MANAGER_CONNECT: u32 = 1;
pub const SC_MANAGER_CREATE_SERVICE: u32 = 2;
pub const SC_MANAGER_ENUMERATE_SERVICE: u32 = 4;
pub const SC_MANAGER_LOCK: u32 = 8;
pub const SC_MANAGER_QUERY_LOCK_STATUS: u32 = 16;
pub const SC_MANAGER_MODIFY_BOOT_CONFIG: u32 = 32;
pub const SC_MANAGER_ALL_ACCESS: u32 = 983103;
pub const SERVICE_QUERY_CONFIG: u32 = 1;
pub const SERVICE_CHANGE_CONFIG: u32 = 2;
pub const SERVICE_QUERY_STATUS: u32 = 4;
pub const SERVICE_ENUMERATE_DEPENDENTS: u32 = 8;
pub const SERVICE_START: u32 = 16;
pub const SERVICE_STOP: u32 = 32;
pub const SERVICE_PAUSE_CONTINUE: u32 = 64;
pub const SERVICE_INTERROGATE: u32 = 128;
pub const SERVICE_USER_DEFINED_CONTROL: u32 = 256;
pub const SERVICE_ALL_ACCESS: u32 = 983551;
pub const SERVICE_RUNS_IN_SYSTEM_PROCESS: u32 = 1;
pub const SERVICE_CONFIG_DESCRIPTION: u32 = 1;
pub const SERVICE_CONFIG_FAILURE_ACTIONS: u32 = 2;
pub const SERVICE_CONFIG_DELAYED_AUTO_START_INFO: u32 = 3;
pub const SERVICE_CONFIG_FAILURE_ACTIONS_FLAG: u32 = 4;
pub const SERVICE_CONFIG_SERVICE_SID_INFO: u32 = 5;
pub const SERVICE_CONFIG_REQUIRED_PRIVILEGES_INFO: u32 = 6;
pub const SERVICE_CONFIG_PRESHUTDOWN_INFO: u32 = 7;
pub const SERVICE_CONFIG_TRIGGER_INFO: u32 = 8;
pub const SERVICE_CONFIG_PREFERRED_NODE: u32 = 9;
pub const SERVICE_CONFIG_LAUNCH_PROTECTED: u32 = 12;
pub const SERVICE_NOTIFY_STATUS_CHANGE_1: u32 = 1;
pub const SERVICE_NOTIFY_STATUS_CHANGE_2: u32 = 2;
pub const SERVICE_NOTIFY_STATUS_CHANGE: u32 = 2;
pub const SERVICE_NOTIFY_STOPPED: u32 = 1;
pub const SERVICE_NOTIFY_START_PENDING: u32 = 2;
pub const SERVICE_NOTIFY_STOP_PENDING: u32 = 4;
pub const SERVICE_NOTIFY_RUNNING: u32 = 8;
pub const SERVICE_NOTIFY_CONTINUE_PENDING: u32 = 16;
pub const SERVICE_NOTIFY_PAUSE_PENDING: u32 = 32;
pub const SERVICE_NOTIFY_PAUSED: u32 = 64;
pub const SERVICE_NOTIFY_CREATED: u32 = 128;
pub const SERVICE_NOTIFY_DELETED: u32 = 256;
pub const SERVICE_NOTIFY_DELETE_PENDING: u32 = 512;
pub const SERVICE_STOP_REASON_FLAG_MIN: u32 = 0;
pub const SERVICE_STOP_REASON_FLAG_UNPLANNED: u32 = 268435456;
pub const SERVICE_STOP_REASON_FLAG_CUSTOM: u32 = 536870912;
pub const SERVICE_STOP_REASON_FLAG_PLANNED: u32 = 1073741824;
pub const SERVICE_STOP_REASON_FLAG_MAX: u32 = 2147483648;
pub const SERVICE_STOP_REASON_MAJOR_MIN: u32 = 0;
pub const SERVICE_STOP_REASON_MAJOR_OTHER: u32 = 65536;
pub const SERVICE_STOP_REASON_MAJOR_HARDWARE: u32 = 131072;
pub const SERVICE_STOP_REASON_MAJOR_OPERATINGSYSTEM: u32 = 196608;
pub const SERVICE_STOP_REASON_MAJOR_SOFTWARE: u32 = 262144;
pub const SERVICE_STOP_REASON_MAJOR_APPLICATION: u32 = 327680;
pub const SERVICE_STOP_REASON_MAJOR_NONE: u32 = 393216;
pub const SERVICE_STOP_REASON_MAJOR_MAX: u32 = 458752;
pub const SERVICE_STOP_REASON_MAJOR_MIN_CUSTOM: u32 = 4194304;
pub const SERVICE_STOP_REASON_MAJOR_MAX_CUSTOM: u32 = 16711680;
pub const SERVICE_STOP_REASON_MINOR_MIN: u32 = 0;
pub const SERVICE_STOP_REASON_MINOR_OTHER: u32 = 1;
pub const SERVICE_STOP_REASON_MINOR_MAINTENANCE: u32 = 2;
pub const SERVICE_STOP_REASON_MINOR_INSTALLATION: u32 = 3;
pub const SERVICE_STOP_REASON_MINOR_UPGRADE: u32 = 4;
pub const SERVICE_STOP_REASON_MINOR_RECONFIG: u32 = 5;
pub const SERVICE_STOP_REASON_MINOR_HUNG: u32 = 6;
pub const SERVICE_STOP_REASON_MINOR_UNSTABLE: u32 = 7;
pub const SERVICE_STOP_REASON_MINOR_DISK: u32 = 8;
pub const SERVICE_STOP_REASON_MINOR_NETWORKCARD: u32 = 9;
pub const SERVICE_STOP_REASON_MINOR_ENVIRONMENT: u32 = 10;
pub const SERVICE_STOP_REASON_MINOR_HARDWARE_DRIVER: u32 = 11;
pub const SERVICE_STOP_REASON_MINOR_OTHERDRIVER: u32 = 12;
pub const SERVICE_STOP_REASON_MINOR_SERVICEPACK: u32 = 13;
pub const SERVICE_STOP_REASON_MINOR_SOFTWARE_UPDATE: u32 = 14;
pub const SERVICE_STOP_REASON_MINOR_SECURITYFIX: u32 = 15;
pub const SERVICE_STOP_REASON_MINOR_SECURITY: u32 = 16;
pub const SERVICE_STOP_REASON_MINOR_NETWORK_CONNECTIVITY: u32 = 17;
pub const SERVICE_STOP_REASON_MINOR_WMI: u32 = 18;
pub const SERVICE_STOP_REASON_MINOR_SERVICEPACK_UNINSTALL: u32 = 19;
pub const SERVICE_STOP_REASON_MINOR_SOFTWARE_UPDATE_UNINSTALL: u32 = 20;
pub const SERVICE_STOP_REASON_MINOR_SECURITYFIX_UNINSTALL: u32 = 21;
pub const SERVICE_STOP_REASON_MINOR_MMC: u32 = 22;
pub const SERVICE_STOP_REASON_MINOR_NONE: u32 = 23;
pub const SERVICE_STOP_REASON_MINOR_MEMOTYLIMIT: u32 = 24;
pub const SERVICE_STOP_REASON_MINOR_MAX: u32 = 25;
pub const SERVICE_STOP_REASON_MINOR_MIN_CUSTOM: u32 = 256;
pub const SERVICE_STOP_REASON_MINOR_MAX_CUSTOM: u32 = 65535;
pub const SERVICE_CONTROL_STATUS_REASON_INFO: u32 = 1;
pub const SERVICE_SID_TYPE_NONE: u32 = 0;
pub const SERVICE_SID_TYPE_UNRESTRICTED: u32 = 1;
pub const SERVICE_SID_TYPE_RESTRICTED: u32 = 3;
pub const SERVICE_TRIGGER_TYPE_DEVICE_INTERFACE_ARRIVAL: u32 = 1;
pub const SERVICE_TRIGGER_TYPE_IP_ADDRESS_AVAILABILITY: u32 = 2;
pub const SERVICE_TRIGGER_TYPE_DOMAIN_JOIN: u32 = 3;
pub const SERVICE_TRIGGER_TYPE_FIREWALL_PORT_EVENT: u32 = 4;
pub const SERVICE_TRIGGER_TYPE_GROUP_POLICY: u32 = 5;
pub const SERVICE_TRIGGER_TYPE_NETWORK_ENDPOINT: u32 = 6;
pub const SERVICE_TRIGGER_TYPE_CUSTOM_SYSTEM_STATE_CHANGE: u32 = 7;
pub const SERVICE_TRIGGER_TYPE_CUSTOM: u32 = 20;
pub const SERVICE_TRIGGER_TYPE_AGGREGATE: u32 = 30;
pub const SERVICE_TRIGGER_DATA_TYPE_BINARY: u32 = 1;
pub const SERVICE_TRIGGER_DATA_TYPE_STRING: u32 = 2;
pub const SERVICE_TRIGGER_DATA_TYPE_LEVEL: u32 = 3;
pub const SERVICE_TRIGGER_DATA_TYPE_KEYWORD_ANY: u32 = 4;
pub const SERVICE_TRIGGER_DATA_TYPE_KEYWORD_ALL: u32 = 5;
pub const SERVICE_START_REASON_DEMAND: u32 = 1;
pub const SERVICE_START_REASON_AUTO: u32 = 2;
pub const SERVICE_START_REASON_TRIGGER: u32 = 4;
pub const SERVICE_START_REASON_RESTART_ON_FAILURE: u32 = 8;
pub const SERVICE_START_REASON_DELAYEDAUTO: u32 = 16;
pub const SERVICE_DYNAMIC_INFORMATION_LEVEL_START_REASON: u32 = 1;
pub const SERVICE_LAUNCH_PROTECTED_NONE: u32 = 0;
pub const SERVICE_LAUNCH_PROTECTED_WINDOWS: u32 = 1;
pub const SERVICE_LAUNCH_PROTECTED_WINDOWS_LIGHT: u32 = 2;
pub const SERVICE_LAUNCH_PROTECTED_ANTIMALWARE_LIGHT: u32 = 3;
pub const SERVICE_TRIGGER_ACTION_SERVICE_START: u32 = 1;
pub const SERVICE_TRIGGER_ACTION_SERVICE_STOP: u32 = 2;
pub const SERVICE_TRIGGER_STARTED_ARGUMENT: &[u8; 15] = b"TriggerStarted\0";
pub const SC_AGGREGATE_STORAGE_KEY: &[u8; 57] =
    b"System\\CurrentControlSet\\Control\\ServiceAggregatedEvents\0";
pub const DIALOPTION_BILLING: u32 = 64;
pub const DIALOPTION_QUIET: u32 = 128;
pub const DIALOPTION_DIALTONE: u32 = 256;
pub const MDMVOLFLAG_LOW: u32 = 1;
pub const MDMVOLFLAG_MEDIUM: u32 = 2;
pub const MDMVOLFLAG_HIGH: u32 = 4;
pub const MDMVOL_LOW: u32 = 0;
pub const MDMVOL_MEDIUM: u32 = 1;
pub const MDMVOL_HIGH: u32 = 2;
pub const MDMSPKRFLAG_OFF: u32 = 1;
pub const MDMSPKRFLAG_DIAL: u32 = 2;
pub const MDMSPKRFLAG_ON: u32 = 4;
pub const MDMSPKRFLAG_CALLSETUP: u32 = 8;
pub const MDMSPKR_OFF: u32 = 0;
pub const MDMSPKR_DIAL: u32 = 1;
pub const MDMSPKR_ON: u32 = 2;
pub const MDMSPKR_CALLSETUP: u32 = 3;
pub const MDM_COMPRESSION: u32 = 1;
pub const MDM_ERROR_CONTROL: u32 = 2;
pub const MDM_FORCED_EC: u32 = 4;
pub const MDM_CELLULAR: u32 = 8;
pub const MDM_FLOWCONTROL_HARD: u32 = 16;
pub const MDM_FLOWCONTROL_SOFT: u32 = 32;
pub const MDM_CCITT_OVERRIDE: u32 = 64;
pub const MDM_SPEED_ADJUST: u32 = 128;
pub const MDM_TONE_DIAL: u32 = 256;
pub const MDM_BLIND_DIAL: u32 = 512;
pub const MDM_V23_OVERRIDE: u32 = 1024;
pub const MDM_DIAGNOSTICS: u32 = 2048;
pub const MDM_MASK_BEARERMODE: u32 = 61440;
pub const MDM_SHIFT_BEARERMODE: u32 = 12;
pub const MDM_MASK_PROTOCOLID: u32 = 983040;
pub const MDM_SHIFT_PROTOCOLID: u32 = 16;
pub const MDM_MASK_PROTOCOLDATA: u32 = 267386880;
pub const MDM_SHIFT_PROTOCOLDATA: u32 = 20;
pub const MDM_MASK_PROTOCOLINFO: u32 = 268369920;
pub const MDM_SHIFT_PROTOCOLINFO: u32 = 16;
pub const MDM_MASK_EXTENDEDINFO: u32 = 268431360;
pub const MDM_SHIFT_EXTENDEDINFO: u32 = 12;
pub const MDM_BEARERMODE_ANALOG: u32 = 0;
pub const MDM_BEARERMODE_ISDN: u32 = 1;
pub const MDM_BEARERMODE_GSM: u32 = 2;
pub const MDM_PROTOCOLID_DEFAULT: u32 = 0;
pub const MDM_PROTOCOLID_HDLCPPP: u32 = 1;
pub const MDM_PROTOCOLID_V128: u32 = 2;
pub const MDM_PROTOCOLID_X75: u32 = 3;
pub const MDM_PROTOCOLID_V110: u32 = 4;
pub const MDM_PROTOCOLID_V120: u32 = 5;
pub const MDM_PROTOCOLID_AUTO: u32 = 6;
pub const MDM_PROTOCOLID_ANALOG: u32 = 7;
pub const MDM_PROTOCOLID_GPRS: u32 = 8;
pub const MDM_PROTOCOLID_PIAFS: u32 = 9;
pub const MDM_SHIFT_HDLCPPP_SPEED: u32 = 0;
pub const MDM_MASK_HDLCPPP_SPEED: u32 = 7;
pub const MDM_HDLCPPP_SPEED_DEFAULT: u32 = 0;
pub const MDM_HDLCPPP_SPEED_64K: u32 = 1;
pub const MDM_HDLCPPP_SPEED_56K: u32 = 2;
pub const MDM_SHIFT_HDLCPPP_AUTH: u32 = 3;
pub const MDM_MASK_HDLCPPP_AUTH: u32 = 56;
pub const MDM_HDLCPPP_AUTH_DEFAULT: u32 = 0;
pub const MDM_HDLCPPP_AUTH_NONE: u32 = 1;
pub const MDM_HDLCPPP_AUTH_PAP: u32 = 2;
pub const MDM_HDLCPPP_AUTH_CHAP: u32 = 3;
pub const MDM_HDLCPPP_AUTH_MSCHAP: u32 = 4;
pub const MDM_SHIFT_HDLCPPP_ML: u32 = 6;
pub const MDM_MASK_HDLCPPP_ML: u32 = 192;
pub const MDM_HDLCPPP_ML_DEFAULT: u32 = 0;
pub const MDM_HDLCPPP_ML_NONE: u32 = 1;
pub const MDM_HDLCPPP_ML_2: u32 = 2;
pub const MDM_SHIFT_V120_SPEED: u32 = 0;
pub const MDM_MASK_V120_SPEED: u32 = 7;
pub const MDM_V120_SPEED_DEFAULT: u32 = 0;
pub const MDM_V120_SPEED_64K: u32 = 1;
pub const MDM_V120_SPEED_56K: u32 = 2;
pub const MDM_SHIFT_V120_ML: u32 = 6;
pub const MDM_MASK_V120_ML: u32 = 192;
pub const MDM_V120_ML_DEFAULT: u32 = 0;
pub const MDM_V120_ML_NONE: u32 = 1;
pub const MDM_V120_ML_2: u32 = 2;
pub const MDM_SHIFT_X75_DATA: u32 = 0;
pub const MDM_MASK_X75_DATA: u32 = 7;
pub const MDM_X75_DATA_DEFAULT: u32 = 0;
pub const MDM_X75_DATA_64K: u32 = 1;
pub const MDM_X75_DATA_128K: u32 = 2;
pub const MDM_X75_DATA_T_70: u32 = 3;
pub const MDM_X75_DATA_BTX: u32 = 4;
pub const MDM_SHIFT_V110_SPEED: u32 = 0;
pub const MDM_MASK_V110_SPEED: u32 = 15;
pub const MDM_V110_SPEED_DEFAULT: u32 = 0;
pub const MDM_V110_SPEED_1DOT2K: u32 = 1;
pub const MDM_V110_SPEED_2DOT4K: u32 = 2;
pub const MDM_V110_SPEED_4DOT8K: u32 = 3;
pub const MDM_V110_SPEED_9DOT6K: u32 = 4;
pub const MDM_V110_SPEED_12DOT0K: u32 = 5;
pub const MDM_V110_SPEED_14DOT4K: u32 = 6;
pub const MDM_V110_SPEED_19DOT2K: u32 = 7;
pub const MDM_V110_SPEED_28DOT8K: u32 = 8;
pub const MDM_V110_SPEED_38DOT4K: u32 = 9;
pub const MDM_V110_SPEED_57DOT6K: u32 = 10;
pub const MDM_SHIFT_AUTO_SPEED: u32 = 0;
pub const MDM_MASK_AUTO_SPEED: u32 = 7;
pub const MDM_AUTO_SPEED_DEFAULT: u32 = 0;
pub const MDM_SHIFT_AUTO_ML: u32 = 6;
pub const MDM_MASK_AUTO_ML: u32 = 192;
pub const MDM_AUTO_ML_DEFAULT: u32 = 0;
pub const MDM_AUTO_ML_NONE: u32 = 1;
pub const MDM_AUTO_ML_2: u32 = 2;
pub const MDM_ANALOG_RLP_ON: u32 = 0;
pub const MDM_ANALOG_RLP_OFF: u32 = 1;
pub const MDM_ANALOG_V34: u32 = 2;
pub const MDM_PIAFS_INCOMING: u32 = 0;
pub const MDM_PIAFS_OUTGOING: u32 = 1;
pub const STYLE_DESCRIPTION_SIZE: u32 = 32;
pub const IMEMENUITEM_STRING_SIZE: u32 = 80;
pub const IMC_GETCANDIDATEPOS: u32 = 7;
pub const IMC_SETCANDIDATEPOS: u32 = 8;
pub const IMC_GETCOMPOSITIONFONT: u32 = 9;
pub const IMC_SETCOMPOSITIONFONT: u32 = 10;
pub const IMC_GETCOMPOSITIONWINDOW: u32 = 11;
pub const IMC_SETCOMPOSITIONWINDOW: u32 = 12;
pub const IMC_GETSTATUSWINDOWPOS: u32 = 15;
pub const IMC_SETSTATUSWINDOWPOS: u32 = 16;
pub const IMC_CLOSESTATUSWINDOW: u32 = 33;
pub const IMC_OPENSTATUSWINDOW: u32 = 34;
pub const NI_OPENCANDIDATE: u32 = 16;
pub const NI_CLOSECANDIDATE: u32 = 17;
pub const NI_SELECTCANDIDATESTR: u32 = 18;
pub const NI_CHANGECANDIDATELIST: u32 = 19;
pub const NI_FINALIZECONVERSIONRESULT: u32 = 20;
pub const NI_COMPOSITIONSTR: u32 = 21;
pub const NI_SETCANDIDATE_PAGESTART: u32 = 22;
pub const NI_SETCANDIDATE_PAGESIZE: u32 = 23;
pub const NI_IMEMENUSELECTED: u32 = 24;
pub const ISC_SHOWUICANDIDATEWINDOW: u32 = 1;
pub const ISC_SHOWUICOMPOSITIONWINDOW: u32 = 2147483648;
pub const ISC_SHOWUIGUIDELINE: u32 = 1073741824;
pub const ISC_SHOWUIALLCANDIDATEWINDOW: u32 = 15;
pub const ISC_SHOWUIALL: u32 = 3221225487;
pub const CPS_COMPLETE: u32 = 1;
pub const CPS_CONVERT: u32 = 2;
pub const CPS_REVERT: u32 = 3;
pub const CPS_CANCEL: u32 = 4;
pub const MOD_LEFT: u32 = 32768;
pub const MOD_RIGHT: u32 = 16384;
pub const MOD_ON_KEYUP: u32 = 2048;
pub const MOD_IGNORE_ALL_MODIFIER: u32 = 1024;
pub const IME_CHOTKEY_IME_NONIME_TOGGLE: u32 = 16;
pub const IME_CHOTKEY_SHAPE_TOGGLE: u32 = 17;
pub const IME_CHOTKEY_SYMBOL_TOGGLE: u32 = 18;
pub const IME_JHOTKEY_CLOSE_OPEN: u32 = 48;
pub const IME_KHOTKEY_SHAPE_TOGGLE: u32 = 80;
pub const IME_KHOTKEY_HANJACONVERT: u32 = 81;
pub const IME_KHOTKEY_ENGLISH: u32 = 82;
pub const IME_THOTKEY_IME_NONIME_TOGGLE: u32 = 112;
pub const IME_THOTKEY_SHAPE_TOGGLE: u32 = 113;
pub const IME_THOTKEY_SYMBOL_TOGGLE: u32 = 114;
pub const IME_HOTKEY_DSWITCH_FIRST: u32 = 256;
pub const IME_HOTKEY_DSWITCH_LAST: u32 = 287;
pub const IME_HOTKEY_PRIVATE_FIRST: u32 = 512;
pub const IME_ITHOTKEY_RESEND_RESULTSTR: u32 = 512;
pub const IME_ITHOTKEY_PREVIOUS_COMPOSITION: u32 = 513;
pub const IME_ITHOTKEY_UISTYLE_TOGGLE: u32 = 514;
pub const IME_ITHOTKEY_RECONVERTSTRING: u32 = 515;
pub const IME_HOTKEY_PRIVATE_LAST: u32 = 543;
pub const GCS_COMPREADSTR: u32 = 1;
pub const GCS_COMPREADATTR: u32 = 2;
pub const GCS_COMPREADCLAUSE: u32 = 4;
pub const GCS_COMPSTR: u32 = 8;
pub const GCS_COMPATTR: u32 = 16;
pub const GCS_COMPCLAUSE: u32 = 32;
pub const GCS_CURSORPOS: u32 = 128;
pub const GCS_DELTASTART: u32 = 256;
pub const GCS_RESULTREADSTR: u32 = 512;
pub const GCS_RESULTREADCLAUSE: u32 = 1024;
pub const GCS_RESULTSTR: u32 = 2048;
pub const GCS_RESULTCLAUSE: u32 = 4096;
pub const CS_INSERTCHAR: u32 = 8192;
pub const CS_NOMOVECARET: u32 = 16384;
pub const IMEVER_0310: u32 = 196618;
pub const IMEVER_0400: u32 = 262144;
pub const IME_PROP_AT_CARET: u32 = 65536;
pub const IME_PROP_SPECIAL_UI: u32 = 131072;
pub const IME_PROP_CANDLIST_START_FROM_1: u32 = 262144;
pub const IME_PROP_UNICODE: u32 = 524288;
pub const IME_PROP_COMPLETE_ON_UNSELECT: u32 = 1048576;
pub const UI_CAP_2700: u32 = 1;
pub const UI_CAP_ROT90: u32 = 2;
pub const UI_CAP_ROTANY: u32 = 4;
pub const SCS_CAP_COMPSTR: u32 = 1;
pub const SCS_CAP_MAKEREAD: u32 = 2;
pub const SCS_CAP_SETRECONVERTSTRING: u32 = 4;
pub const SELECT_CAP_CONVERSION: u32 = 1;
pub const SELECT_CAP_SENTENCE: u32 = 2;
pub const GGL_LEVEL: u32 = 1;
pub const GGL_INDEX: u32 = 2;
pub const GGL_STRING: u32 = 3;
pub const GGL_PRIVATE: u32 = 4;
pub const GL_LEVEL_NOGUIDELINE: u32 = 0;
pub const GL_LEVEL_FATAL: u32 = 1;
pub const GL_LEVEL_ERROR: u32 = 2;
pub const GL_LEVEL_WARNING: u32 = 3;
pub const GL_LEVEL_INFORMATION: u32 = 4;
pub const GL_ID_UNKNOWN: u32 = 0;
pub const GL_ID_NOMODULE: u32 = 1;
pub const GL_ID_NODICTIONARY: u32 = 16;
pub const GL_ID_CANNOTSAVE: u32 = 17;
pub const GL_ID_NOCONVERT: u32 = 32;
pub const GL_ID_TYPINGERROR: u32 = 33;
pub const GL_ID_TOOMANYSTROKE: u32 = 34;
pub const GL_ID_READINGCONFLICT: u32 = 35;
pub const GL_ID_INPUTREADING: u32 = 36;
pub const GL_ID_INPUTRADICAL: u32 = 37;
pub const GL_ID_INPUTCODE: u32 = 38;
pub const GL_ID_INPUTSYMBOL: u32 = 39;
pub const GL_ID_CHOOSECANDIDATE: u32 = 40;
pub const GL_ID_REVERSECONVERSION: u32 = 41;
pub const GL_ID_PRIVATE_FIRST: u32 = 32768;
pub const GL_ID_PRIVATE_LAST: u32 = 65535;
pub const IGP_PROPERTY: u32 = 4;
pub const IGP_CONVERSION: u32 = 8;
pub const IGP_SENTENCE: u32 = 12;
pub const IGP_UI: u32 = 16;
pub const IGP_SETCOMPSTR: u32 = 20;
pub const IGP_SELECT: u32 = 24;
pub const SCS_SETSTR: u32 = 9;
pub const SCS_CHANGEATTR: u32 = 18;
pub const SCS_CHANGECLAUSE: u32 = 36;
pub const SCS_SETRECONVERTSTRING: u32 = 65536;
pub const SCS_QUERYRECONVERTSTRING: u32 = 131072;
pub const ATTR_INPUT: u32 = 0;
pub const ATTR_TARGET_CONVERTED: u32 = 1;
pub const ATTR_CONVERTED: u32 = 2;
pub const ATTR_TARGET_NOTCONVERTED: u32 = 3;
pub const ATTR_INPUT_ERROR: u32 = 4;
pub const ATTR_FIXEDCONVERTED: u32 = 5;
pub const CFS_DEFAULT: u32 = 0;
pub const CFS_RECT: u32 = 1;
pub const CFS_POINT: u32 = 2;
pub const CFS_FORCE_POSITION: u32 = 32;
pub const CFS_CANDIDATEPOS: u32 = 64;
pub const CFS_EXCLUDE: u32 = 128;
pub const GCL_CONVERSION: u32 = 1;
pub const GCL_REVERSECONVERSION: u32 = 2;
pub const GCL_REVERSE_LENGTH: u32 = 3;
pub const IME_CMODE_ALPHANUMERIC: u32 = 0;
pub const IME_CMODE_NATIVE: u32 = 1;
pub const IME_CMODE_CHINESE: u32 = 1;
pub const IME_CMODE_HANGUL: u32 = 1;
pub const IME_CMODE_JAPANESE: u32 = 1;
pub const IME_CMODE_KATAKANA: u32 = 2;
pub const IME_CMODE_LANGUAGE: u32 = 3;
pub const IME_CMODE_FULLSHAPE: u32 = 8;
pub const IME_CMODE_ROMAN: u32 = 16;
pub const IME_CMODE_CHARCODE: u32 = 32;
pub const IME_CMODE_HANJACONVERT: u32 = 64;
pub const IME_CMODE_NATIVESYMBOL: u32 = 128;
pub const IME_CMODE_HANGEUL: u32 = 1;
pub const IME_CMODE_SOFTKBD: u32 = 128;
pub const IME_CMODE_NOCONVERSION: u32 = 256;
pub const IME_CMODE_EUDC: u32 = 512;
pub const IME_CMODE_SYMBOL: u32 = 1024;
pub const IME_CMODE_FIXED: u32 = 2048;
pub const IME_CMODE_RESERVED: u32 = 4026531840;
pub const IME_SMODE_NONE: u32 = 0;
pub const IME_SMODE_PLAURALCLAUSE: u32 = 1;
pub const IME_SMODE_SINGLECONVERT: u32 = 2;
pub const IME_SMODE_AUTOMATIC: u32 = 4;
pub const IME_SMODE_PHRASEPREDICT: u32 = 8;
pub const IME_SMODE_CONVERSATION: u32 = 16;
pub const IME_SMODE_RESERVED: u32 = 61440;
pub const IME_CAND_UNKNOWN: u32 = 0;
pub const IME_CAND_READ: u32 = 1;
pub const IME_CAND_CODE: u32 = 2;
pub const IME_CAND_MEANING: u32 = 3;
pub const IME_CAND_RADICAL: u32 = 4;
pub const IME_CAND_STROKE: u32 = 5;
pub const IMN_CLOSESTATUSWINDOW: u32 = 1;
pub const IMN_OPENSTATUSWINDOW: u32 = 2;
pub const IMN_CHANGECANDIDATE: u32 = 3;
pub const IMN_CLOSECANDIDATE: u32 = 4;
pub const IMN_OPENCANDIDATE: u32 = 5;
pub const IMN_SETCONVERSIONMODE: u32 = 6;
pub const IMN_SETSENTENCEMODE: u32 = 7;
pub const IMN_SETOPENSTATUS: u32 = 8;
pub const IMN_SETCANDIDATEPOS: u32 = 9;
pub const IMN_SETCOMPOSITIONFONT: u32 = 10;
pub const IMN_SETCOMPOSITIONWINDOW: u32 = 11;
pub const IMN_SETSTATUSWINDOWPOS: u32 = 12;
pub const IMN_GUIDELINE: u32 = 13;
pub const IMN_PRIVATE: u32 = 14;
pub const IMR_COMPOSITIONWINDOW: u32 = 1;
pub const IMR_CANDIDATEWINDOW: u32 = 2;
pub const IMR_COMPOSITIONFONT: u32 = 3;
pub const IMR_RECONVERTSTRING: u32 = 4;
pub const IMR_CONFIRMRECONVERTSTRING: u32 = 5;
pub const IMR_QUERYCHARPOSITION: u32 = 6;
pub const IMR_DOCUMENTFEED: u32 = 7;
pub const IMM_ERROR_NODATA: i32 = -1;
pub const IMM_ERROR_GENERAL: i32 = -2;
pub const IME_CONFIG_GENERAL: u32 = 1;
pub const IME_CONFIG_REGISTERWORD: u32 = 2;
pub const IME_CONFIG_SELECTDICTIONARY: u32 = 3;
pub const IME_ESC_QUERY_SUPPORT: u32 = 3;
pub const IME_ESC_RESERVED_FIRST: u32 = 4;
pub const IME_ESC_RESERVED_LAST: u32 = 2047;
pub const IME_ESC_PRIVATE_FIRST: u32 = 2048;
pub const IME_ESC_PRIVATE_LAST: u32 = 4095;
pub const IME_ESC_SEQUENCE_TO_INTERNAL: u32 = 4097;
pub const IME_ESC_GET_EUDC_DICTIONARY: u32 = 4099;
pub const IME_ESC_SET_EUDC_DICTIONARY: u32 = 4100;
pub const IME_ESC_MAX_KEY: u32 = 4101;
pub const IME_ESC_IME_NAME: u32 = 4102;
pub const IME_ESC_SYNC_HOTKEY: u32 = 4103;
pub const IME_ESC_HANJA_MODE: u32 = 4104;
pub const IME_ESC_AUTOMATA: u32 = 4105;
pub const IME_ESC_PRIVATE_HOTKEY: u32 = 4106;
pub const IME_ESC_GETHELPFILENAME: u32 = 4107;
pub const IME_REGWORD_STYLE_EUDC: u32 = 1;
pub const IME_REGWORD_STYLE_USER_FIRST: u32 = 2147483648;
pub const IME_REGWORD_STYLE_USER_LAST: u32 = 4294967295;
pub const IACE_CHILDREN: u32 = 1;
pub const IACE_DEFAULT: u32 = 16;
pub const IACE_IGNORENOCONTEXT: u32 = 32;
pub const IGIMIF_RIGHTMENU: u32 = 1;
pub const IGIMII_CMODE: u32 = 1;
pub const IGIMII_SMODE: u32 = 2;
pub const IGIMII_CONFIGURE: u32 = 4;
pub const IGIMII_TOOLS: u32 = 8;
pub const IGIMII_HELP: u32 = 16;
pub const IGIMII_OTHER: u32 = 32;
pub const IGIMII_INPUTTOOLS: u32 = 64;
pub const IMFT_RADIOCHECK: u32 = 1;
pub const IMFT_SEPARATOR: u32 = 2;
pub const IMFT_SUBMENU: u32 = 4;
pub const IMFS_GRAYED: u32 = 3;
pub const IMFS_DISABLED: u32 = 3;
pub const IMFS_CHECKED: u32 = 8;
pub const IMFS_HILITE: u32 = 128;
pub const IMFS_ENABLED: u32 = 0;
pub const IMFS_UNCHECKED: u32 = 0;
pub const IMFS_UNHILITE: u32 = 0;
pub const IMFS_DEFAULT: u32 = 4096;
pub const SOFTKEYBOARD_TYPE_T1: u32 = 1;
pub const SOFTKEYBOARD_TYPE_C1: u32 = 2;
pub const LC_CONFIG_VERSION: u32 = 3237806082;
pub const LC_CONFIG_ERRORINFO_VERSION: u32 = 3237871618;
pub const LC_CONFIG_PRINTF_ENABLED: u32 = 1;
pub const LC_CONFIG_PRINTF_V: u32 = 2;
pub const LC_CONFIG_PRINTF_VV: u32 = 4;
pub const LC_CONFIG_PRINTF_VVV: u32 = 8;
pub const MEM_SCATTER_VERSION: u32 = 3237871618;
pub const MEM_SCATTER_STACK_SIZE: u32 = 12;
pub const LC_OPT_CORE_PRINTF_ENABLE: u64 = 4611686022722355200;
pub const LC_OPT_CORE_VERBOSE: u64 = 4611686027017322496;
pub const LC_OPT_CORE_VERBOSE_EXTRA: u64 = 4611686031312289792;
pub const LC_OPT_CORE_VERBOSE_EXTRA_TLP: u64 = 4611686035607257088;
pub const LC_OPT_CORE_VERSION_MAJOR: u64 = 4611686039902224384;
pub const LC_OPT_CORE_VERSION_MINOR: u64 = 4611686044197191680;
pub const LC_OPT_CORE_VERSION_REVISION: u64 = 4611686048492158976;
pub const LC_OPT_CORE_ADDR_MAX: u64 = 1152921538966585344;
pub const LC_OPT_CORE_STATISTICS_CALL_COUNT: u64 = 4611686057082093568;
pub const LC_OPT_CORE_STATISTICS_CALL_TIME: u64 = 4611686061377060864;
pub const LC_OPT_CORE_VOLATILE: u64 = 1152921551851487232;
pub const LC_OPT_CORE_READONLY: u64 = 1152921556146454528;
pub const LC_OPT_MEMORYINFO_VALID: u64 = 144115192370823168;
pub const LC_OPT_MEMORYINFO_FLAG_32BIT: u64 = 144115200960757760;
pub const LC_OPT_MEMORYINFO_FLAG_PAE: u64 = 144115205255725056;
pub const LC_OPT_MEMORYINFO_ARCH: u64 = 144115265385267200;
pub const LC_OPT_MEMORYINFO_OS_VERSION_MINOR: u64 = 144115209550692352;
pub const LC_OPT_MEMORYINFO_OS_VERSION_MAJOR: u64 = 144115213845659648;
pub const LC_OPT_MEMORYINFO_OS_DTB: u64 = 144115218140626944;
pub const LC_OPT_MEMORYINFO_OS_PFN: u64 = 144115222435594240;
pub const LC_OPT_MEMORYINFO_OS_PsLoadedModuleList: u64 = 144115226730561536;
pub const LC_OPT_MEMORYINFO_OS_PsActiveProcessHead: u64 = 144115231025528832;
pub const LC_OPT_MEMORYINFO_OS_MACHINE_IMAGE_TP: u64 = 144115235320496128;
pub const LC_OPT_MEMORYINFO_OS_NUM_PROCESSORS: u64 = 144115239615463424;
pub const LC_OPT_MEMORYINFO_OS_SYSTEMTIME: u64 = 144115243910430720;
pub const LC_OPT_MEMORYINFO_OS_UPTIME: u64 = 144115248205398016;
pub const LC_OPT_MEMORYINFO_OS_KERNELBASE: u64 = 144115252500365312;
pub const LC_OPT_MEMORYINFO_OS_KERNELHINT: u64 = 144115256795332608;
pub const LC_OPT_MEMORYINFO_OS_KdDebuggerDataBlock: u64 = 144115261090299904;
pub const LC_OPT_FPGA_PROBE_MAXPAGES: u64 = 216172786408751104;
pub const LC_OPT_FPGA_MAX_SIZE_RX: u64 = 216172794998685696;
pub const LC_OPT_FPGA_MAX_SIZE_TX: u64 = 216172799293652992;
pub const LC_OPT_FPGA_DELAY_PROBE_READ: u64 = 216172803588620288;
pub const LC_OPT_FPGA_DELAY_PROBE_WRITE: u64 = 216172807883587584;
pub const LC_OPT_FPGA_DELAY_WRITE: u64 = 216172812178554880;
pub const LC_OPT_FPGA_DELAY_READ: u64 = 216172816473522176;
pub const LC_OPT_FPGA_RETRY_ON_ERROR: u64 = 216172820768489472;
pub const LC_OPT_FPGA_DEVICE_ID: u64 = 216173331869597696;
pub const LC_OPT_FPGA_FPGA_ID: u64 = 216173336164564992;
pub const LC_OPT_FPGA_VERSION_MAJOR: u64 = 216173340459532288;
pub const LC_OPT_FPGA_VERSION_MINOR: u64 = 216173344754499584;
pub const LC_OPT_FPGA_ALGO_TINY: u64 = 216173349049466880;
pub const LC_OPT_FPGA_ALGO_SYNCHRONOUS: u64 = 216173353344434176;
pub const LC_OPT_FPGA_CFGSPACE_XILINX: u64 = 216173357639401472;
pub const LC_OPT_FPGA_TLP_READ_CB_WITHINFO: u64 = 216173400589074432;
pub const LC_OPT_FPGA_TLP_READ_CB_FILTERCPL: u64 = 216173404884041728;
pub const LC_CMD_FPGA_PCIECFGSPACE: u64 = 1112396529664;
pub const LC_CMD_FPGA_CFGREGPCIE: u64 = 1116691496960;
pub const LC_CMD_FPGA_CFGREGCFG: u64 = 1120986464256;
pub const LC_CMD_FPGA_CFGREGDRP: u64 = 1125281431552;
pub const LC_CMD_FPGA_CFGREGCFG_MARKWR: u64 = 1129576398848;
pub const LC_CMD_FPGA_CFGREGPCIE_MARKWR: u64 = 1133871366144;
pub const LC_CMD_FPGA_CFGREG_DEBUGPRINT: u64 = 1142461300736;
pub const LC_CMD_FPGA_PROBE: u64 = 1146756268032;
pub const LC_CMD_FPGA_CFGSPACE_SHADOW_RD: u64 = 1151051235328;
pub const LC_CMD_FPGA_CFGSPACE_SHADOW_WR: u64 = 1155346202624;
pub const LC_CMD_FPGA_TLP_WRITE_SINGLE: u64 = 1168231104512;
pub const LC_CMD_FPGA_TLP_WRITE_MULTIPLE: u64 = 1172526071808;
pub const LC_CMD_FPGA_TLP_TOSTRING: u64 = 1176821039104;
pub const LC_CMD_FPGA_TLP_CONTEXT: u64 = 2305844194624667648;
pub const LC_CMD_FPGA_TLP_CONTEXT_RD: u64 = 2305844224689438720;
pub const LC_CMD_FPGA_TLP_FUNCTION_CALLBACK: u64 = 2305844198919634944;
pub const LC_CMD_FPGA_TLP_FUNCTION_CALLBACK_RD: u64 = 2305844228984406016;
pub const LC_CMD_FPGA_BAR_CONTEXT: u64 = 2305844246164275200;
pub const LC_CMD_FPGA_BAR_CONTEXT_RD: u64 = 2305844250459242496;
pub const LC_CMD_FPGA_BAR_FUNCTION_CALLBACK: u64 = 2305844254754209792;
pub const LC_CMD_FPGA_BAR_FUNCTION_CALLBACK_RD: u64 = 2305844259049177088;
pub const LC_CMD_FPGA_BAR_INFO: u64 = 1254130450432;
pub const LC_CMD_FILE_DUMPHEADER_GET: u64 = 2203318222848;
pub const LC_CMD_STATISTICS_GET: u64 = 4611687117939015680;
pub const LC_CMD_MEMMAP_GET: u64 = 4611688217450643456;
pub const LC_CMD_MEMMAP_SET: u64 = 4611689316962271232;
pub const LC_CMD_MEMMAP_GET_STRUCT: u64 = 4611690416473899008;
pub const LC_CMD_MEMMAP_SET_STRUCT: u64 = 4611691515985526784;
pub const LC_CMD_AGENT_EXEC_PYTHON: i64 = -9223372032559808512;
pub const LC_CMD_AGENT_EXIT_PROCESS: i64 = -9223372028264841216;
pub const LC_CMD_AGENT_VFS_LIST: i64 = -9223372023969873920;
pub const LC_CMD_AGENT_VFS_READ: i64 = -9223372019674906624;
pub const LC_CMD_AGENT_VFS_WRITE: i64 = -9223372015379939328;
pub const LC_CMD_AGENT_VFS_OPT_GET: i64 = -9223372011084972032;
pub const LC_CMD_AGENT_VFS_OPT_SET: i64 = -9223372006790004736;
pub const LC_CMD_AGENT_VFS_INITIALIZE: i64 = -9223372002495037440;
pub const LC_CMD_AGENT_VFS_CONSOLE: i64 = -9223371998200070144;
pub const LC_CMD_AGENT_VFS_REQ_VERSION: u32 = 4276944897;
pub const LC_CMD_AGENT_VFS_RSP_VERSION: u32 = 4277010433;
pub const LC_STATISTICS_VERSION: u32 = 3785424898;
pub const LC_STATISTICS_ID_OPEN: u32 = 0;
pub const LC_STATISTICS_ID_READ: u32 = 1;
pub const LC_STATISTICS_ID_READSCATTER: u32 = 2;
pub const LC_STATISTICS_ID_WRITE: u32 = 3;
pub const LC_STATISTICS_ID_WRITESCATTER: u32 = 4;
pub const LC_STATISTICS_ID_GETOPTION: u32 = 5;
pub const LC_STATISTICS_ID_SETOPTION: u32 = 6;
pub const LC_STATISTICS_ID_COMMAND: u32 = 7;
pub const LC_STATISTICS_ID_MAX: u32 = 7;
pub const LC_VMM_VERSION: u32 = 518979585;
pub type va_list = *mut ::std::os::raw::c_char;
unsafe extern "C" {
    pub fn __va_start(arg1: *mut *mut ::std::os::raw::c_char, ...);
}
pub type __vcrt_bool = bool;
pub type wchar_t = ::std::os::raw::c_ushort;
unsafe extern "C" {
    pub fn __security_init_cookie();
}
unsafe extern "C" {
    pub fn __security_check_cookie(_StackCookie: usize);
}
unsafe extern "C" {
    pub fn __report_gsfailure(_StackCookie: usize) -> !;
}
unsafe extern "C" {
    pub static mut __security_cookie: usize;
}
pub const _EXCEPTION_DISPOSITION_ExceptionContinueExecution: _EXCEPTION_DISPOSITION = 0;
pub const _EXCEPTION_DISPOSITION_ExceptionContinueSearch: _EXCEPTION_DISPOSITION = 1;
pub const _EXCEPTION_DISPOSITION_ExceptionNestedException: _EXCEPTION_DISPOSITION = 2;
pub const _EXCEPTION_DISPOSITION_ExceptionCollidedUnwind: _EXCEPTION_DISPOSITION = 3;
pub type _EXCEPTION_DISPOSITION = ::std::os::raw::c_int;
pub use self::_EXCEPTION_DISPOSITION as EXCEPTION_DISPOSITION;
unsafe extern "C" {
    pub fn __C_specific_handler(
        ExceptionRecord: *mut _EXCEPTION_RECORD,
        EstablisherFrame: *mut ::std::os::raw::c_void,
        ContextRecord: *mut _CONTEXT,
        DispatcherContext: *mut _DISPATCHER_CONTEXT,
    ) -> EXCEPTION_DISPOSITION;
}
unsafe extern "C" {
    pub fn _exception_code() -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _exception_info() -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _abnormal_termination() -> ::std::os::raw::c_int;
}
pub type __gnuc_va_list = __builtin_va_list;
pub type ULONG = ::std::os::raw::c_ulong;
pub type PULONG = *mut ULONG;
pub type USHORT = ::std::os::raw::c_ushort;
pub type PUSHORT = *mut USHORT;
pub type UCHAR = ::std::os::raw::c_uchar;
pub type PUCHAR = *mut UCHAR;
pub type PSZ = *mut ::std::os::raw::c_char;
pub type DWORD = ::std::os::raw::c_ulong;
pub type BOOL = ::std::os::raw::c_int;
pub type BYTE = ::std::os::raw::c_uchar;
pub type WORD = ::std::os::raw::c_ushort;
pub type FLOAT = f32;
pub type PFLOAT = *mut FLOAT;
pub type PBOOL = *mut BOOL;
pub type LPBOOL = *mut BOOL;
pub type PBYTE = *mut BYTE;
pub type LPBYTE = *mut BYTE;
pub type PINT = *mut ::std::os::raw::c_int;
pub type LPINT = *mut ::std::os::raw::c_int;
pub type PWORD = *mut WORD;
pub type LPWORD = *mut WORD;
pub type LPLONG = *mut ::std::os::raw::c_long;
pub type PDWORD = *mut DWORD;
pub type LPDWORD = *mut DWORD;
pub type LPVOID = *mut ::std::os::raw::c_void;
pub type LPCVOID = *const ::std::os::raw::c_void;
pub type INT = ::std::os::raw::c_int;
pub type UINT = ::std::os::raw::c_uint;
pub type PUINT = *mut ::std::os::raw::c_uint;
pub type __crt_bool = bool;
unsafe extern "C" {
    pub fn _invalid_parameter_noinfo();
}
unsafe extern "C" {
    pub fn _invalid_parameter_noinfo_noreturn() -> !;
}
unsafe extern "C" {
    pub fn _invoke_watson(
        _Expression: *const wchar_t,
        _FunctionName: *const wchar_t,
        _FileName: *const wchar_t,
        _LineNo: ::std::os::raw::c_uint,
        _Reserved: usize,
    ) -> !;
}
pub type errno_t = ::std::os::raw::c_int;
pub type wint_t = ::std::os::raw::c_ushort;
pub type wctype_t = ::std::os::raw::c_ushort;
pub type __time32_t = ::std::os::raw::c_long;
pub type __time64_t = ::std::os::raw::c_longlong;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __crt_locale_data_public {
    pub _locale_pctype: *const ::std::os::raw::c_ushort,
    pub _locale_mb_cur_max: ::std::os::raw::c_int,
    pub _locale_lc_codepage: ::std::os::raw::c_uint,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __crt_locale_data_public"]
        [::std::mem::size_of::<__crt_locale_data_public>() - 16usize];
    ["Alignment of __crt_locale_data_public"]
        [::std::mem::align_of::<__crt_locale_data_public>() - 8usize];
    ["Offset of field: __crt_locale_data_public::_locale_pctype"]
        [::std::mem::offset_of!(__crt_locale_data_public, _locale_pctype) - 0usize];
    ["Offset of field: __crt_locale_data_public::_locale_mb_cur_max"]
        [::std::mem::offset_of!(__crt_locale_data_public, _locale_mb_cur_max) - 8usize];
    ["Offset of field: __crt_locale_data_public::_locale_lc_codepage"]
        [::std::mem::offset_of!(__crt_locale_data_public, _locale_lc_codepage) - 12usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __crt_locale_pointers {
    pub locinfo: *mut __crt_locale_data,
    pub mbcinfo: *mut __crt_multibyte_data,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __crt_locale_pointers"][::std::mem::size_of::<__crt_locale_pointers>() - 16usize];
    ["Alignment of __crt_locale_pointers"]
        [::std::mem::align_of::<__crt_locale_pointers>() - 8usize];
    ["Offset of field: __crt_locale_pointers::locinfo"]
        [::std::mem::offset_of!(__crt_locale_pointers, locinfo) - 0usize];
    ["Offset of field: __crt_locale_pointers::mbcinfo"]
        [::std::mem::offset_of!(__crt_locale_pointers, mbcinfo) - 8usize];
};
pub type _locale_t = *mut __crt_locale_pointers;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _Mbstatet {
    pub _Wchar: ::std::os::raw::c_ulong,
    pub _Byte: ::std::os::raw::c_ushort,
    pub _State: ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _Mbstatet"][::std::mem::size_of::<_Mbstatet>() - 8usize];
    ["Alignment of _Mbstatet"][::std::mem::align_of::<_Mbstatet>() - 4usize];
    ["Offset of field: _Mbstatet::_Wchar"][::std::mem::offset_of!(_Mbstatet, _Wchar) - 0usize];
    ["Offset of field: _Mbstatet::_Byte"][::std::mem::offset_of!(_Mbstatet, _Byte) - 4usize];
    ["Offset of field: _Mbstatet::_State"][::std::mem::offset_of!(_Mbstatet, _State) - 6usize];
};
pub type mbstate_t = _Mbstatet;
pub type time_t = __time64_t;
pub type rsize_t = usize;
unsafe extern "C" {
    pub fn __pctype_func() -> *const ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn __pwctype_func() -> *const wctype_t;
}
unsafe extern "C" {
    pub fn iswalnum(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswalpha(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswascii(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswblank(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswcntrl(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswdigit(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswgraph(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswlower(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswprint(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswpunct(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswspace(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswupper(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iswxdigit(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __iswcsymf(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __iswcsym(_C: wint_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswalnum_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswalpha_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswblank_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswcntrl_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswdigit_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswgraph_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswlower_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswprint_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswpunct_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswspace_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswupper_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswxdigit_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswcsymf_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iswcsym_l(_C: wint_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn towupper(_C: wint_t) -> wint_t;
}
unsafe extern "C" {
    pub fn towlower(_C: wint_t) -> wint_t;
}
unsafe extern "C" {
    pub fn iswctype(_C: wint_t, _Type: wctype_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _towupper_l(_C: wint_t, _Locale: _locale_t) -> wint_t;
}
unsafe extern "C" {
    pub fn _towlower_l(_C: wint_t, _Locale: _locale_t) -> wint_t;
}
unsafe extern "C" {
    pub fn _iswctype_l(_C: wint_t, _Type: wctype_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isleadbyte(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isleadbyte_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn is_wctype(_C: wint_t, _Type: wctype_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isctype(
        _C: ::std::os::raw::c_int,
        _Type: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isctype_l(
        _C: ::std::os::raw::c_int,
        _Type: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isalpha(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isalpha_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isupper(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isupper_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn islower(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _islower_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isdigit(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isdigit_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isxdigit(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isxdigit_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isspace(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isspace_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ispunct(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _ispunct_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isblank(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isblank_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isalnum(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isalnum_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isprint(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isprint_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn isgraph(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _isgraph_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn iscntrl(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _iscntrl_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn toupper(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn tolower(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _tolower(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _tolower_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _toupper(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _toupper_l(_C: ::std::os::raw::c_int, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __isascii(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __toascii(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __iscsymf(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __iscsym(_C: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ___mb_cur_max_func() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ___mb_cur_max_l_func(_Locale: _locale_t) -> ::std::os::raw::c_int;
}
pub type POINTER_64_INT = ::std::os::raw::c_ulonglong;
pub type INT8 = ::std::os::raw::c_schar;
pub type PINT8 = *mut ::std::os::raw::c_schar;
pub type INT16 = ::std::os::raw::c_short;
pub type PINT16 = *mut ::std::os::raw::c_short;
pub type INT32 = ::std::os::raw::c_int;
pub type PINT32 = *mut ::std::os::raw::c_int;
pub type INT64 = ::std::os::raw::c_longlong;
pub type PINT64 = *mut ::std::os::raw::c_longlong;
pub type UINT8 = ::std::os::raw::c_uchar;
pub type PUINT8 = *mut ::std::os::raw::c_uchar;
pub type UINT16 = ::std::os::raw::c_ushort;
pub type PUINT16 = *mut ::std::os::raw::c_ushort;
pub type UINT32 = ::std::os::raw::c_uint;
pub type PUINT32 = *mut ::std::os::raw::c_uint;
pub type UINT64 = ::std::os::raw::c_ulonglong;
pub type PUINT64 = *mut ::std::os::raw::c_ulonglong;
pub type LONG32 = ::std::os::raw::c_int;
pub type PLONG32 = *mut ::std::os::raw::c_int;
pub type ULONG32 = ::std::os::raw::c_uint;
pub type PULONG32 = *mut ::std::os::raw::c_uint;
pub type DWORD32 = ::std::os::raw::c_uint;
pub type PDWORD32 = *mut ::std::os::raw::c_uint;
pub type INT_PTR = ::std::os::raw::c_longlong;
pub type PINT_PTR = *mut ::std::os::raw::c_longlong;
pub type UINT_PTR = ::std::os::raw::c_ulonglong;
pub type PUINT_PTR = *mut ::std::os::raw::c_ulonglong;
pub type LONG_PTR = ::std::os::raw::c_longlong;
pub type PLONG_PTR = *mut ::std::os::raw::c_longlong;
pub type ULONG_PTR = ::std::os::raw::c_ulonglong;
pub type PULONG_PTR = *mut ::std::os::raw::c_ulonglong;
pub type PHANDLE64 = *mut *mut ::std::os::raw::c_void;
pub type SHANDLE_PTR = ::std::os::raw::c_longlong;
pub type HANDLE_PTR = ::std::os::raw::c_ulonglong;
pub type UHALF_PTR = ::std::os::raw::c_uint;
pub type PUHALF_PTR = *mut ::std::os::raw::c_uint;
pub type HALF_PTR = ::std::os::raw::c_int;
pub type PHALF_PTR = *mut ::std::os::raw::c_int;
pub type SIZE_T = ULONG_PTR;
pub type PSIZE_T = *mut ULONG_PTR;
pub type SSIZE_T = LONG_PTR;
pub type PSSIZE_T = *mut LONG_PTR;
pub type DWORD_PTR = ULONG_PTR;
pub type PDWORD_PTR = *mut ULONG_PTR;
pub type LONG64 = ::std::os::raw::c_longlong;
pub type PLONG64 = *mut ::std::os::raw::c_longlong;
pub type ULONG64 = ::std::os::raw::c_ulonglong;
pub type PULONG64 = *mut ::std::os::raw::c_ulonglong;
pub type DWORD64 = ::std::os::raw::c_ulonglong;
pub type PDWORD64 = *mut ::std::os::raw::c_ulonglong;
pub type KAFFINITY = ULONG_PTR;
pub type PKAFFINITY = *mut KAFFINITY;
pub type PVOID = *mut ::std::os::raw::c_void;
pub type CHAR = ::std::os::raw::c_char;
pub type SHORT = ::std::os::raw::c_short;
pub type LONG = ::std::os::raw::c_long;
pub type WCHAR = wchar_t;
pub type PWCHAR = *mut WCHAR;
pub type LPWCH = *mut WCHAR;
pub type PWCH = *mut WCHAR;
pub type LPCWCH = *const WCHAR;
pub type PCWCH = *const WCHAR;
pub type NWPSTR = *mut WCHAR;
pub type LPWSTR = *mut WCHAR;
pub type PWSTR = *mut WCHAR;
pub type PZPWSTR = *mut PWSTR;
pub type PCZPWSTR = *const PWSTR;
pub type LPUWSTR = *mut WCHAR;
pub type PUWSTR = *mut WCHAR;
pub type LPCWSTR = *const WCHAR;
pub type PCWSTR = *const WCHAR;
pub type PZPCWSTR = *mut PCWSTR;
pub type PCZPCWSTR = *const PCWSTR;
pub type LPCUWSTR = *const WCHAR;
pub type PCUWSTR = *const WCHAR;
pub type PZZWSTR = *mut WCHAR;
pub type PCZZWSTR = *const WCHAR;
pub type PUZZWSTR = *mut WCHAR;
pub type PCUZZWSTR = *const WCHAR;
pub type PNZWCH = *mut WCHAR;
pub type PCNZWCH = *const WCHAR;
pub type PUNZWCH = *mut WCHAR;
pub type PCUNZWCH = *const WCHAR;
pub type LPCWCHAR = *const WCHAR;
pub type PCWCHAR = *const WCHAR;
pub type LPCUWCHAR = *const WCHAR;
pub type PCUWCHAR = *const WCHAR;
pub type UCSCHAR = ::std::os::raw::c_ulong;
pub type PUCSCHAR = *mut UCSCHAR;
pub type PCUCSCHAR = *const UCSCHAR;
pub type PUCSSTR = *mut UCSCHAR;
pub type PUUCSSTR = *mut UCSCHAR;
pub type PCUCSSTR = *const UCSCHAR;
pub type PCUUCSSTR = *const UCSCHAR;
pub type PUUCSCHAR = *mut UCSCHAR;
pub type PCUUCSCHAR = *const UCSCHAR;
pub type PCHAR = *mut CHAR;
pub type LPCH = *mut CHAR;
pub type PCH = *mut CHAR;
pub type LPCCH = *const CHAR;
pub type PCCH = *const CHAR;
pub type NPSTR = *mut CHAR;
pub type LPSTR = *mut CHAR;
pub type PSTR = *mut CHAR;
pub type PZPSTR = *mut PSTR;
pub type PCZPSTR = *const PSTR;
pub type LPCSTR = *const CHAR;
pub type PCSTR = *const CHAR;
pub type PZPCSTR = *mut PCSTR;
pub type PCZPCSTR = *const PCSTR;
pub type PZZSTR = *mut CHAR;
pub type PCZZSTR = *const CHAR;
pub type PNZCH = *mut CHAR;
pub type PCNZCH = *const CHAR;
pub type TCHAR = ::std::os::raw::c_char;
pub type PTCHAR = *mut ::std::os::raw::c_char;
pub type TBYTE = ::std::os::raw::c_uchar;
pub type PTBYTE = *mut ::std::os::raw::c_uchar;
pub type LPTCH = LPCH;
pub type PTCH = LPCH;
pub type LPCTCH = LPCCH;
pub type PCTCH = LPCCH;
pub type PTSTR = LPSTR;
pub type LPTSTR = LPSTR;
pub type PUTSTR = LPSTR;
pub type LPUTSTR = LPSTR;
pub type PCTSTR = LPCSTR;
pub type LPCTSTR = LPCSTR;
pub type PCUTSTR = LPCSTR;
pub type LPCUTSTR = LPCSTR;
pub type PZZTSTR = PZZSTR;
pub type PUZZTSTR = PZZSTR;
pub type PCZZTSTR = PCZZSTR;
pub type PCUZZTSTR = PCZZSTR;
pub type PZPTSTR = PZPSTR;
pub type PNZTCH = PNZCH;
pub type PUNZTCH = PNZCH;
pub type PCNZTCH = PCNZCH;
pub type PCUNZTCH = PCNZCH;
pub type PSHORT = *mut SHORT;
pub type PLONG = *mut LONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESSOR_NUMBER {
    pub Group: WORD,
    pub Number: BYTE,
    pub Reserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESSOR_NUMBER"][::std::mem::size_of::<_PROCESSOR_NUMBER>() - 4usize];
    ["Alignment of _PROCESSOR_NUMBER"][::std::mem::align_of::<_PROCESSOR_NUMBER>() - 2usize];
    ["Offset of field: _PROCESSOR_NUMBER::Group"]
        [::std::mem::offset_of!(_PROCESSOR_NUMBER, Group) - 0usize];
    ["Offset of field: _PROCESSOR_NUMBER::Number"]
        [::std::mem::offset_of!(_PROCESSOR_NUMBER, Number) - 2usize];
    ["Offset of field: _PROCESSOR_NUMBER::Reserved"]
        [::std::mem::offset_of!(_PROCESSOR_NUMBER, Reserved) - 3usize];
};
pub type PROCESSOR_NUMBER = _PROCESSOR_NUMBER;
pub type PPROCESSOR_NUMBER = *mut _PROCESSOR_NUMBER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GROUP_AFFINITY {
    pub Mask: KAFFINITY,
    pub Group: WORD,
    pub Reserved: [WORD; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GROUP_AFFINITY"][::std::mem::size_of::<_GROUP_AFFINITY>() - 16usize];
    ["Alignment of _GROUP_AFFINITY"][::std::mem::align_of::<_GROUP_AFFINITY>() - 8usize];
    ["Offset of field: _GROUP_AFFINITY::Mask"]
        [::std::mem::offset_of!(_GROUP_AFFINITY, Mask) - 0usize];
    ["Offset of field: _GROUP_AFFINITY::Group"]
        [::std::mem::offset_of!(_GROUP_AFFINITY, Group) - 8usize];
    ["Offset of field: _GROUP_AFFINITY::Reserved"]
        [::std::mem::offset_of!(_GROUP_AFFINITY, Reserved) - 10usize];
};
pub type GROUP_AFFINITY = _GROUP_AFFINITY;
pub type PGROUP_AFFINITY = *mut _GROUP_AFFINITY;
pub type HANDLE = *mut ::std::os::raw::c_void;
pub type PHANDLE = *mut HANDLE;
pub type FCHAR = BYTE;
pub type FSHORT = WORD;
pub type FLONG = DWORD;
pub type HRESULT = ::std::os::raw::c_long;
pub type CCHAR = ::std::os::raw::c_char;
pub type LCID = DWORD;
pub type PLCID = PDWORD;
pub type LANGID = WORD;
pub const COMPARTMENT_ID_UNSPECIFIED_COMPARTMENT_ID: COMPARTMENT_ID = 0;
pub const COMPARTMENT_ID_DEFAULT_COMPARTMENT_ID: COMPARTMENT_ID = 1;
pub type COMPARTMENT_ID = ::std::os::raw::c_int;
pub type PCOMPARTMENT_ID = *mut COMPARTMENT_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FLOAT128 {
    pub LowPart: ::std::os::raw::c_longlong,
    pub HighPart: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FLOAT128"][::std::mem::size_of::<_FLOAT128>() - 16usize];
    ["Alignment of _FLOAT128"][::std::mem::align_of::<_FLOAT128>() - 8usize];
    ["Offset of field: _FLOAT128::LowPart"][::std::mem::offset_of!(_FLOAT128, LowPart) - 0usize];
    ["Offset of field: _FLOAT128::HighPart"][::std::mem::offset_of!(_FLOAT128, HighPart) - 8usize];
};
pub type FLOAT128 = _FLOAT128;
pub type PFLOAT128 = *mut FLOAT128;
pub type LONGLONG = ::std::os::raw::c_longlong;
pub type ULONGLONG = ::std::os::raw::c_ulonglong;
pub type PLONGLONG = *mut LONGLONG;
pub type PULONGLONG = *mut ULONGLONG;
pub type USN = LONGLONG;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _LARGE_INTEGER {
    pub __bindgen_anon_1: _LARGE_INTEGER__bindgen_ty_1,
    pub u: _LARGE_INTEGER__bindgen_ty_2,
    pub QuadPart: LONGLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LARGE_INTEGER__bindgen_ty_1 {
    pub LowPart: DWORD,
    pub HighPart: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LARGE_INTEGER__bindgen_ty_1"]
        [::std::mem::size_of::<_LARGE_INTEGER__bindgen_ty_1>() - 8usize];
    ["Alignment of _LARGE_INTEGER__bindgen_ty_1"]
        [::std::mem::align_of::<_LARGE_INTEGER__bindgen_ty_1>() - 4usize];
    ["Offset of field: _LARGE_INTEGER__bindgen_ty_1::LowPart"]
        [::std::mem::offset_of!(_LARGE_INTEGER__bindgen_ty_1, LowPart) - 0usize];
    ["Offset of field: _LARGE_INTEGER__bindgen_ty_1::HighPart"]
        [::std::mem::offset_of!(_LARGE_INTEGER__bindgen_ty_1, HighPart) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LARGE_INTEGER__bindgen_ty_2 {
    pub LowPart: DWORD,
    pub HighPart: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LARGE_INTEGER__bindgen_ty_2"]
        [::std::mem::size_of::<_LARGE_INTEGER__bindgen_ty_2>() - 8usize];
    ["Alignment of _LARGE_INTEGER__bindgen_ty_2"]
        [::std::mem::align_of::<_LARGE_INTEGER__bindgen_ty_2>() - 4usize];
    ["Offset of field: _LARGE_INTEGER__bindgen_ty_2::LowPart"]
        [::std::mem::offset_of!(_LARGE_INTEGER__bindgen_ty_2, LowPart) - 0usize];
    ["Offset of field: _LARGE_INTEGER__bindgen_ty_2::HighPart"]
        [::std::mem::offset_of!(_LARGE_INTEGER__bindgen_ty_2, HighPart) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LARGE_INTEGER"][::std::mem::size_of::<_LARGE_INTEGER>() - 8usize];
    ["Alignment of _LARGE_INTEGER"][::std::mem::align_of::<_LARGE_INTEGER>() - 8usize];
    ["Offset of field: _LARGE_INTEGER::u"][::std::mem::offset_of!(_LARGE_INTEGER, u) - 0usize];
    ["Offset of field: _LARGE_INTEGER::QuadPart"]
        [::std::mem::offset_of!(_LARGE_INTEGER, QuadPart) - 0usize];
};
pub type LARGE_INTEGER = _LARGE_INTEGER;
pub type PLARGE_INTEGER = *mut LARGE_INTEGER;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ULARGE_INTEGER {
    pub __bindgen_anon_1: _ULARGE_INTEGER__bindgen_ty_1,
    pub u: _ULARGE_INTEGER__bindgen_ty_2,
    pub QuadPart: ULONGLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ULARGE_INTEGER__bindgen_ty_1 {
    pub LowPart: DWORD,
    pub HighPart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ULARGE_INTEGER__bindgen_ty_1"]
        [::std::mem::size_of::<_ULARGE_INTEGER__bindgen_ty_1>() - 8usize];
    ["Alignment of _ULARGE_INTEGER__bindgen_ty_1"]
        [::std::mem::align_of::<_ULARGE_INTEGER__bindgen_ty_1>() - 4usize];
    ["Offset of field: _ULARGE_INTEGER__bindgen_ty_1::LowPart"]
        [::std::mem::offset_of!(_ULARGE_INTEGER__bindgen_ty_1, LowPart) - 0usize];
    ["Offset of field: _ULARGE_INTEGER__bindgen_ty_1::HighPart"]
        [::std::mem::offset_of!(_ULARGE_INTEGER__bindgen_ty_1, HighPart) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ULARGE_INTEGER__bindgen_ty_2 {
    pub LowPart: DWORD,
    pub HighPart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ULARGE_INTEGER__bindgen_ty_2"]
        [::std::mem::size_of::<_ULARGE_INTEGER__bindgen_ty_2>() - 8usize];
    ["Alignment of _ULARGE_INTEGER__bindgen_ty_2"]
        [::std::mem::align_of::<_ULARGE_INTEGER__bindgen_ty_2>() - 4usize];
    ["Offset of field: _ULARGE_INTEGER__bindgen_ty_2::LowPart"]
        [::std::mem::offset_of!(_ULARGE_INTEGER__bindgen_ty_2, LowPart) - 0usize];
    ["Offset of field: _ULARGE_INTEGER__bindgen_ty_2::HighPart"]
        [::std::mem::offset_of!(_ULARGE_INTEGER__bindgen_ty_2, HighPart) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ULARGE_INTEGER"][::std::mem::size_of::<_ULARGE_INTEGER>() - 8usize];
    ["Alignment of _ULARGE_INTEGER"][::std::mem::align_of::<_ULARGE_INTEGER>() - 8usize];
    ["Offset of field: _ULARGE_INTEGER::u"][::std::mem::offset_of!(_ULARGE_INTEGER, u) - 0usize];
    ["Offset of field: _ULARGE_INTEGER::QuadPart"]
        [::std::mem::offset_of!(_ULARGE_INTEGER, QuadPart) - 0usize];
};
pub type ULARGE_INTEGER = _ULARGE_INTEGER;
pub type PULARGE_INTEGER = *mut ULARGE_INTEGER;
pub type RTL_REFERENCE_COUNT = LONG_PTR;
pub type PRTL_REFERENCE_COUNT = *mut LONG_PTR;
pub type RTL_REFERENCE_COUNT32 = LONG;
pub type PRTL_REFERENCE_COUNT32 = *mut LONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LUID {
    pub LowPart: DWORD,
    pub HighPart: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LUID"][::std::mem::size_of::<_LUID>() - 8usize];
    ["Alignment of _LUID"][::std::mem::align_of::<_LUID>() - 4usize];
    ["Offset of field: _LUID::LowPart"][::std::mem::offset_of!(_LUID, LowPart) - 0usize];
    ["Offset of field: _LUID::HighPart"][::std::mem::offset_of!(_LUID, HighPart) - 4usize];
};
pub type LUID = _LUID;
pub type PLUID = *mut _LUID;
pub type DWORDLONG = ULONGLONG;
pub type PDWORDLONG = *mut DWORDLONG;
unsafe extern "C" {
    pub fn _rotl8(
        Value: ::std::os::raw::c_uchar,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _rotl16(
        Value: ::std::os::raw::c_ushort,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn _rotr8(
        Value: ::std::os::raw::c_uchar,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _rotr16(
        Value: ::std::os::raw::c_ushort,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn _rotl(
        Value: ::std::os::raw::c_uint,
        Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_uint;
}
unsafe extern "C" {
    pub fn _rotl64(
        Value: ::std::os::raw::c_ulonglong,
        Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _rotr(
        Value: ::std::os::raw::c_uint,
        Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_uint;
}
unsafe extern "C" {
    pub fn _rotr64(
        Value: ::std::os::raw::c_ulonglong,
        Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
pub type BOOLEAN = BYTE;
pub type PBOOLEAN = *mut BOOLEAN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LIST_ENTRY {
    pub Flink: *mut _LIST_ENTRY,
    pub Blink: *mut _LIST_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LIST_ENTRY"][::std::mem::size_of::<_LIST_ENTRY>() - 16usize];
    ["Alignment of _LIST_ENTRY"][::std::mem::align_of::<_LIST_ENTRY>() - 8usize];
    ["Offset of field: _LIST_ENTRY::Flink"][::std::mem::offset_of!(_LIST_ENTRY, Flink) - 0usize];
    ["Offset of field: _LIST_ENTRY::Blink"][::std::mem::offset_of!(_LIST_ENTRY, Blink) - 8usize];
};
pub type LIST_ENTRY = _LIST_ENTRY;
pub type PLIST_ENTRY = *mut _LIST_ENTRY;
pub type PRLIST_ENTRY = *mut _LIST_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SINGLE_LIST_ENTRY {
    pub Next: *mut _SINGLE_LIST_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SINGLE_LIST_ENTRY"][::std::mem::size_of::<_SINGLE_LIST_ENTRY>() - 8usize];
    ["Alignment of _SINGLE_LIST_ENTRY"][::std::mem::align_of::<_SINGLE_LIST_ENTRY>() - 8usize];
    ["Offset of field: _SINGLE_LIST_ENTRY::Next"]
        [::std::mem::offset_of!(_SINGLE_LIST_ENTRY, Next) - 0usize];
};
pub type SINGLE_LIST_ENTRY = _SINGLE_LIST_ENTRY;
pub type PSINGLE_LIST_ENTRY = *mut _SINGLE_LIST_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct LIST_ENTRY32 {
    pub Flink: DWORD,
    pub Blink: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of LIST_ENTRY32"][::std::mem::size_of::<LIST_ENTRY32>() - 8usize];
    ["Alignment of LIST_ENTRY32"][::std::mem::align_of::<LIST_ENTRY32>() - 4usize];
    ["Offset of field: LIST_ENTRY32::Flink"][::std::mem::offset_of!(LIST_ENTRY32, Flink) - 0usize];
    ["Offset of field: LIST_ENTRY32::Blink"][::std::mem::offset_of!(LIST_ENTRY32, Blink) - 4usize];
};
pub type PLIST_ENTRY32 = *mut LIST_ENTRY32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct LIST_ENTRY64 {
    pub Flink: ULONGLONG,
    pub Blink: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of LIST_ENTRY64"][::std::mem::size_of::<LIST_ENTRY64>() - 16usize];
    ["Alignment of LIST_ENTRY64"][::std::mem::align_of::<LIST_ENTRY64>() - 8usize];
    ["Offset of field: LIST_ENTRY64::Flink"][::std::mem::offset_of!(LIST_ENTRY64, Flink) - 0usize];
    ["Offset of field: LIST_ENTRY64::Blink"][::std::mem::offset_of!(LIST_ENTRY64, Blink) - 8usize];
};
pub type PLIST_ENTRY64 = *mut LIST_ENTRY64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GUID {
    pub Data1: ::std::os::raw::c_ulong,
    pub Data2: ::std::os::raw::c_ushort,
    pub Data3: ::std::os::raw::c_ushort,
    pub Data4: [::std::os::raw::c_uchar; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GUID"][::std::mem::size_of::<_GUID>() - 16usize];
    ["Alignment of _GUID"][::std::mem::align_of::<_GUID>() - 4usize];
    ["Offset of field: _GUID::Data1"][::std::mem::offset_of!(_GUID, Data1) - 0usize];
    ["Offset of field: _GUID::Data2"][::std::mem::offset_of!(_GUID, Data2) - 4usize];
    ["Offset of field: _GUID::Data3"][::std::mem::offset_of!(_GUID, Data3) - 6usize];
    ["Offset of field: _GUID::Data4"][::std::mem::offset_of!(_GUID, Data4) - 8usize];
};
pub type GUID = _GUID;
pub type LPGUID = *mut GUID;
pub type LPCGUID = *const GUID;
pub type IID = GUID;
pub type LPIID = *mut IID;
pub type CLSID = GUID;
pub type LPCLSID = *mut CLSID;
pub type FMTID = GUID;
pub type LPFMTID = *mut FMTID;
unsafe extern "C" {
    pub fn _errno() -> *mut ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _set_errno(_Value: ::std::os::raw::c_int) -> errno_t;
}
unsafe extern "C" {
    pub fn _get_errno(_Value: *mut ::std::os::raw::c_int) -> errno_t;
}
unsafe extern "C" {
    pub fn __doserrno() -> *mut ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _set_doserrno(_Value: ::std::os::raw::c_ulong) -> errno_t;
}
unsafe extern "C" {
    pub fn _get_doserrno(_Value: *mut ::std::os::raw::c_ulong) -> errno_t;
}
unsafe extern "C" {
    pub fn memchr(
        _Buf: *const ::std::os::raw::c_void,
        _Val: ::std::os::raw::c_int,
        _MaxCount: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn memcmp(
        _Buf1: *const ::std::os::raw::c_void,
        _Buf2: *const ::std::os::raw::c_void,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn memcpy(
        _Dst: *mut ::std::os::raw::c_void,
        _Src: *const ::std::os::raw::c_void,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn memmove(
        _Dst: *mut ::std::os::raw::c_void,
        _Src: *const ::std::os::raw::c_void,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn memset(
        _Dst: *mut ::std::os::raw::c_void,
        _Val: ::std::os::raw::c_int,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn strchr(
        _Str: *const ::std::os::raw::c_char,
        _Val: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strrchr(
        _Str: *const ::std::os::raw::c_char,
        _Ch: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strstr(
        _Str: *const ::std::os::raw::c_char,
        _SubStr: *const ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn wcschr(
        _Str: *const ::std::os::raw::c_ushort,
        _Ch: ::std::os::raw::c_ushort,
    ) -> *mut ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn wcsrchr(_Str: *const wchar_t, _Ch: wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsstr(_Str: *const wchar_t, _SubStr: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _memicmp(
        _Buf1: *const ::std::os::raw::c_void,
        _Buf2: *const ::std::os::raw::c_void,
        _Size: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _memicmp_l(
        _Buf1: *const ::std::os::raw::c_void,
        _Buf2: *const ::std::os::raw::c_void,
        _Size: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn memccpy(
        _Dst: *mut ::std::os::raw::c_void,
        _Src: *const ::std::os::raw::c_void,
        _Val: ::std::os::raw::c_int,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn memicmp(
        _Buf1: *const ::std::os::raw::c_void,
        _Buf2: *const ::std::os::raw::c_void,
        _Size: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcscat_s(
        _Destination: *mut wchar_t,
        _SizeInWords: rsize_t,
        _Source: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcscpy_s(
        _Destination: *mut wchar_t,
        _SizeInWords: rsize_t,
        _Source: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcsncat_s(
        _Destination: *mut wchar_t,
        _SizeInWords: rsize_t,
        _Source: *const wchar_t,
        _MaxCount: rsize_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcsncpy_s(
        _Destination: *mut wchar_t,
        _SizeInWords: rsize_t,
        _Source: *const wchar_t,
        _MaxCount: rsize_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcstok_s(
        _String: *mut wchar_t,
        _Delimiter: *const wchar_t,
        _Context: *mut *mut wchar_t,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcsdup(_String: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcscat(_Destination: *mut wchar_t, _Source: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcscmp(
        _String1: *const ::std::os::raw::c_ushort,
        _String2: *const ::std::os::raw::c_ushort,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcscpy(_Destination: *mut wchar_t, _Source: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcscspn(_String: *const wchar_t, _Control: *const wchar_t) -> usize;
}
unsafe extern "C" {
    pub fn wcslen(_String: *const ::std::os::raw::c_ushort) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn wcsnlen(_Source: *const wchar_t, _MaxCount: usize) -> usize;
}
unsafe extern "C" {
    pub fn wcsncat(
        _Destination: *mut wchar_t,
        _Source: *const wchar_t,
        _Count: usize,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsncmp(
        _String1: *const ::std::os::raw::c_ushort,
        _String2: *const ::std::os::raw::c_ushort,
        _MaxCount: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcsncpy(
        _Destination: *mut wchar_t,
        _Source: *const wchar_t,
        _Count: usize,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcspbrk(_String: *const wchar_t, _Control: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsspn(_String: *const wchar_t, _Control: *const wchar_t) -> usize;
}
unsafe extern "C" {
    pub fn wcstok(
        _String: *mut wchar_t,
        _Delimiter: *const wchar_t,
        _Context: *mut *mut wchar_t,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcserror(_ErrorNumber: ::std::os::raw::c_int) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcserror_s(
        _Buffer: *mut wchar_t,
        _SizeInWords: usize,
        _ErrorNumber: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn __wcserror(_String: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn __wcserror_s(
        _Buffer: *mut wchar_t,
        _SizeInWords: usize,
        _ErrorMessage: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcsicmp(_String1: *const wchar_t, _String2: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsicmp_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsnicmp(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsnicmp_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsnset_s(
        _Destination: *mut wchar_t,
        _SizeInWords: usize,
        _Value: wchar_t,
        _MaxCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcsnset(_String: *mut wchar_t, _Value: wchar_t, _MaxCount: usize) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcsrev(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcsset_s(_Destination: *mut wchar_t, _SizeInWords: usize, _Value: wchar_t) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcsset(_String: *mut wchar_t, _Value: wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcslwr_s(_String: *mut wchar_t, _SizeInWords: usize) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcslwr(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcslwr_s_l(_String: *mut wchar_t, _SizeInWords: usize, _Locale: _locale_t) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcslwr_l(_String: *mut wchar_t, _Locale: _locale_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcsupr_s(_String: *mut wchar_t, _Size: usize) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcsupr(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wcsupr_s_l(_String: *mut wchar_t, _Size: usize, _Locale: _locale_t) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcsupr_l(_String: *mut wchar_t, _Locale: _locale_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsxfrm(_Destination: *mut wchar_t, _Source: *const wchar_t, _MaxCount: usize) -> usize;
}
unsafe extern "C" {
    pub fn _wcsxfrm_l(
        _Destination: *mut wchar_t,
        _Source: *const wchar_t,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> usize;
}
unsafe extern "C" {
    pub fn wcscoll(_String1: *const wchar_t, _String2: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcscoll_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsicoll(_String1: *const wchar_t, _String2: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsicoll_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsncoll(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsncoll_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsnicoll(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wcsnicoll_l(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcsdup(_String: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsicmp(_String1: *const wchar_t, _String2: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcsnicmp(
        _String1: *const wchar_t,
        _String2: *const wchar_t,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wcsnset(_String: *mut wchar_t, _Value: wchar_t, _MaxCount: usize) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsrev(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsset(_String: *mut wchar_t, _Value: wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcslwr(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsupr(_String: *mut wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcsicoll(_String1: *const wchar_t, _String2: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strcpy_s(
        _Destination: *mut ::std::os::raw::c_char,
        _SizeInBytes: rsize_t,
        _Source: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strcat_s(
        _Destination: *mut ::std::os::raw::c_char,
        _SizeInBytes: rsize_t,
        _Source: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strerror_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _SizeInBytes: usize,
        _ErrorNumber: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strncat_s(
        _Destination: *mut ::std::os::raw::c_char,
        _SizeInBytes: rsize_t,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: rsize_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strncpy_s(
        _Destination: *mut ::std::os::raw::c_char,
        _SizeInBytes: rsize_t,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: rsize_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strtok_s(
        _String: *mut ::std::os::raw::c_char,
        _Delimiter: *const ::std::os::raw::c_char,
        _Context: *mut *mut ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _memccpy(
        _Dst: *mut ::std::os::raw::c_void,
        _Src: *const ::std::os::raw::c_void,
        _Val: ::std::os::raw::c_int,
        _MaxCount: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn strcat(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strcmp(
        _Str1: *const ::std::os::raw::c_char,
        _Str2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strcmpi(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strcoll(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strcoll_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strcpy(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strcspn(
        _Str: *const ::std::os::raw::c_char,
        _Control: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strdup(_Source: *const ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strerror(_ErrorMessage: *const ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strerror_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _SizeInBytes: usize,
        _ErrorMessage: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn strerror(_ErrorMessage: ::std::os::raw::c_int) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _stricmp(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _stricoll(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _stricoll_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _stricmp_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strlen(_Str: *const ::std::os::raw::c_char) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strlwr_s(_String: *mut ::std::os::raw::c_char, _Size: usize) -> errno_t;
}
unsafe extern "C" {
    pub fn _strlwr(_String: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strlwr_s_l(
        _String: *mut ::std::os::raw::c_char,
        _Size: usize,
        _Locale: _locale_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _strlwr_l(
        _String: *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strncat(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
        _Count: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strncmp(
        _Str1: *const ::std::os::raw::c_char,
        _Str2: *const ::std::os::raw::c_char,
        _MaxCount: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strnicmp(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strnicmp_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strnicoll(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strnicoll_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strncoll(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _strncoll_l(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __strncnt(_String: *const ::std::os::raw::c_char, _Count: usize) -> usize;
}
unsafe extern "C" {
    pub fn strncpy(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
        _Count: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strnlen(_String: *const ::std::os::raw::c_char, _MaxCount: usize) -> usize;
}
unsafe extern "C" {
    pub fn _strnset_s(
        _String: *mut ::std::os::raw::c_char,
        _SizeInBytes: usize,
        _Value: ::std::os::raw::c_int,
        _MaxCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _strnset(
        _Destination: *mut ::std::os::raw::c_char,
        _Value: ::std::os::raw::c_int,
        _Count: usize,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strpbrk(
        _Str: *const ::std::os::raw::c_char,
        _Control: *const ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strrev(_Str: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strset_s(
        _Destination: *mut ::std::os::raw::c_char,
        _DestinationSize: usize,
        _Value: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _strset(
        _Destination: *mut ::std::os::raw::c_char,
        _Value: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strspn(
        _Str: *const ::std::os::raw::c_char,
        _Control: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn strtok(
        _String: *mut ::std::os::raw::c_char,
        _Delimiter: *const ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strupr_s(_String: *mut ::std::os::raw::c_char, _Size: usize) -> errno_t;
}
unsafe extern "C" {
    pub fn _strupr(_String: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _strupr_s_l(
        _String: *mut ::std::os::raw::c_char,
        _Size: usize,
        _Locale: _locale_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _strupr_l(
        _String: *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strxfrm(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strxfrm_l(
        _Destination: *mut ::std::os::raw::c_char,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> usize;
}
unsafe extern "C" {
    pub fn strdup(_String: *const ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strcmpi(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn stricmp(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strlwr(_String: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strnicmp(
        _String1: *const ::std::os::raw::c_char,
        _String2: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strnset(
        _String: *mut ::std::os::raw::c_char,
        _Value: ::std::os::raw::c_int,
        _MaxCount: usize,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strrev(_String: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strset(
        _String: *mut ::std::os::raw::c_char,
        _Value: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn strupr(_String: *mut ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OBJECTID {
    pub Lineage: GUID,
    pub Uniquifier: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OBJECTID"][::std::mem::size_of::<_OBJECTID>() - 20usize];
    ["Alignment of _OBJECTID"][::std::mem::align_of::<_OBJECTID>() - 4usize];
    ["Offset of field: _OBJECTID::Lineage"][::std::mem::offset_of!(_OBJECTID, Lineage) - 0usize];
    ["Offset of field: _OBJECTID::Uniquifier"]
        [::std::mem::offset_of!(_OBJECTID, Uniquifier) - 16usize];
};
pub type OBJECTID = _OBJECTID;
pub type PEXCEPTION_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut _EXCEPTION_RECORD,
        arg2: PVOID,
        arg3: *mut _CONTEXT,
        arg4: PVOID,
    ) -> EXCEPTION_DISPOSITION,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _bindgen_ty_1 {
    pub x: ::std::os::raw::c_char,
    pub test: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _bindgen_ty_1"][::std::mem::size_of::<_bindgen_ty_1>() - 16usize];
    ["Alignment of _bindgen_ty_1"][::std::mem::align_of::<_bindgen_ty_1>() - 8usize];
    ["Offset of field: _bindgen_ty_1::x"][::std::mem::offset_of!(_bindgen_ty_1, x) - 0usize];
    ["Offset of field: _bindgen_ty_1::test"][::std::mem::offset_of!(_bindgen_ty_1, test) - 8usize];
};
pub type __C_ASSERT__ = [::std::os::raw::c_char; 1usize];
pub type KSPIN_LOCK = ULONG_PTR;
pub type PKSPIN_LOCK = *mut KSPIN_LOCK;
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _M128A {
    pub Low: ULONGLONG,
    pub High: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _M128A"][::std::mem::size_of::<_M128A>() - 16usize];
    ["Alignment of _M128A"][::std::mem::align_of::<_M128A>() - 16usize];
    ["Offset of field: _M128A::Low"][::std::mem::offset_of!(_M128A, Low) - 0usize];
    ["Offset of field: _M128A::High"][::std::mem::offset_of!(_M128A, High) - 8usize];
};
pub type M128A = _M128A;
pub type PM128A = *mut _M128A;
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _XSAVE_FORMAT {
    pub ControlWord: WORD,
    pub StatusWord: WORD,
    pub TagWord: BYTE,
    pub Reserved1: BYTE,
    pub ErrorOpcode: WORD,
    pub ErrorOffset: DWORD,
    pub ErrorSelector: WORD,
    pub Reserved2: WORD,
    pub DataOffset: DWORD,
    pub DataSelector: WORD,
    pub Reserved3: WORD,
    pub MxCsr: DWORD,
    pub MxCsr_Mask: DWORD,
    pub FloatRegisters: [M128A; 8usize],
    pub XmmRegisters: [M128A; 16usize],
    pub Reserved4: [BYTE; 96usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSAVE_FORMAT"][::std::mem::size_of::<_XSAVE_FORMAT>() - 512usize];
    ["Alignment of _XSAVE_FORMAT"][::std::mem::align_of::<_XSAVE_FORMAT>() - 16usize];
    ["Offset of field: _XSAVE_FORMAT::ControlWord"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, ControlWord) - 0usize];
    ["Offset of field: _XSAVE_FORMAT::StatusWord"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, StatusWord) - 2usize];
    ["Offset of field: _XSAVE_FORMAT::TagWord"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, TagWord) - 4usize];
    ["Offset of field: _XSAVE_FORMAT::Reserved1"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, Reserved1) - 5usize];
    ["Offset of field: _XSAVE_FORMAT::ErrorOpcode"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, ErrorOpcode) - 6usize];
    ["Offset of field: _XSAVE_FORMAT::ErrorOffset"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, ErrorOffset) - 8usize];
    ["Offset of field: _XSAVE_FORMAT::ErrorSelector"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, ErrorSelector) - 12usize];
    ["Offset of field: _XSAVE_FORMAT::Reserved2"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, Reserved2) - 14usize];
    ["Offset of field: _XSAVE_FORMAT::DataOffset"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, DataOffset) - 16usize];
    ["Offset of field: _XSAVE_FORMAT::DataSelector"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, DataSelector) - 20usize];
    ["Offset of field: _XSAVE_FORMAT::Reserved3"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, Reserved3) - 22usize];
    ["Offset of field: _XSAVE_FORMAT::MxCsr"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, MxCsr) - 24usize];
    ["Offset of field: _XSAVE_FORMAT::MxCsr_Mask"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, MxCsr_Mask) - 28usize];
    ["Offset of field: _XSAVE_FORMAT::FloatRegisters"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, FloatRegisters) - 32usize];
    ["Offset of field: _XSAVE_FORMAT::XmmRegisters"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, XmmRegisters) - 160usize];
    ["Offset of field: _XSAVE_FORMAT::Reserved4"]
        [::std::mem::offset_of!(_XSAVE_FORMAT, Reserved4) - 416usize];
};
pub type XSAVE_FORMAT = _XSAVE_FORMAT;
pub type PXSAVE_FORMAT = *mut _XSAVE_FORMAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _XSAVE_CET_U_FORMAT {
    pub Ia32CetUMsr: DWORD64,
    pub Ia32Pl3SspMsr: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSAVE_CET_U_FORMAT"][::std::mem::size_of::<_XSAVE_CET_U_FORMAT>() - 16usize];
    ["Alignment of _XSAVE_CET_U_FORMAT"][::std::mem::align_of::<_XSAVE_CET_U_FORMAT>() - 8usize];
    ["Offset of field: _XSAVE_CET_U_FORMAT::Ia32CetUMsr"]
        [::std::mem::offset_of!(_XSAVE_CET_U_FORMAT, Ia32CetUMsr) - 0usize];
    ["Offset of field: _XSAVE_CET_U_FORMAT::Ia32Pl3SspMsr"]
        [::std::mem::offset_of!(_XSAVE_CET_U_FORMAT, Ia32Pl3SspMsr) - 8usize];
};
pub type XSAVE_CET_U_FORMAT = _XSAVE_CET_U_FORMAT;
pub type PXSAVE_CET_U_FORMAT = *mut _XSAVE_CET_U_FORMAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _XSAVE_AREA_HEADER {
    pub Mask: DWORD64,
    pub CompactionMask: DWORD64,
    pub Reserved2: [DWORD64; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSAVE_AREA_HEADER"][::std::mem::size_of::<_XSAVE_AREA_HEADER>() - 64usize];
    ["Alignment of _XSAVE_AREA_HEADER"][::std::mem::align_of::<_XSAVE_AREA_HEADER>() - 8usize];
    ["Offset of field: _XSAVE_AREA_HEADER::Mask"]
        [::std::mem::offset_of!(_XSAVE_AREA_HEADER, Mask) - 0usize];
    ["Offset of field: _XSAVE_AREA_HEADER::CompactionMask"]
        [::std::mem::offset_of!(_XSAVE_AREA_HEADER, CompactionMask) - 8usize];
    ["Offset of field: _XSAVE_AREA_HEADER::Reserved2"]
        [::std::mem::offset_of!(_XSAVE_AREA_HEADER, Reserved2) - 16usize];
};
pub type XSAVE_AREA_HEADER = _XSAVE_AREA_HEADER;
pub type PXSAVE_AREA_HEADER = *mut _XSAVE_AREA_HEADER;
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _XSAVE_AREA {
    pub LegacyState: XSAVE_FORMAT,
    pub Header: XSAVE_AREA_HEADER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSAVE_AREA"][::std::mem::size_of::<_XSAVE_AREA>() - 576usize];
    ["Alignment of _XSAVE_AREA"][::std::mem::align_of::<_XSAVE_AREA>() - 16usize];
    ["Offset of field: _XSAVE_AREA::LegacyState"]
        [::std::mem::offset_of!(_XSAVE_AREA, LegacyState) - 0usize];
    ["Offset of field: _XSAVE_AREA::Header"]
        [::std::mem::offset_of!(_XSAVE_AREA, Header) - 512usize];
};
pub type XSAVE_AREA = _XSAVE_AREA;
pub type PXSAVE_AREA = *mut _XSAVE_AREA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _XSTATE_CONTEXT {
    pub Mask: DWORD64,
    pub Length: DWORD,
    pub Reserved1: DWORD,
    pub Area: PXSAVE_AREA,
    pub Buffer: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSTATE_CONTEXT"][::std::mem::size_of::<_XSTATE_CONTEXT>() - 32usize];
    ["Alignment of _XSTATE_CONTEXT"][::std::mem::align_of::<_XSTATE_CONTEXT>() - 8usize];
    ["Offset of field: _XSTATE_CONTEXT::Mask"]
        [::std::mem::offset_of!(_XSTATE_CONTEXT, Mask) - 0usize];
    ["Offset of field: _XSTATE_CONTEXT::Length"]
        [::std::mem::offset_of!(_XSTATE_CONTEXT, Length) - 8usize];
    ["Offset of field: _XSTATE_CONTEXT::Reserved1"]
        [::std::mem::offset_of!(_XSTATE_CONTEXT, Reserved1) - 12usize];
    ["Offset of field: _XSTATE_CONTEXT::Area"]
        [::std::mem::offset_of!(_XSTATE_CONTEXT, Area) - 16usize];
    ["Offset of field: _XSTATE_CONTEXT::Buffer"]
        [::std::mem::offset_of!(_XSTATE_CONTEXT, Buffer) - 24usize];
};
pub type XSTATE_CONTEXT = _XSTATE_CONTEXT;
pub type PXSTATE_CONTEXT = *mut _XSTATE_CONTEXT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _KERNEL_CET_CONTEXT {
    pub Ssp: DWORD64,
    pub Rip: DWORD64,
    pub SegCs: WORD,
    pub __bindgen_anon_1: _KERNEL_CET_CONTEXT__bindgen_ty_1,
    pub Fill: [WORD; 2usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _KERNEL_CET_CONTEXT__bindgen_ty_1 {
    pub AllFlags: WORD,
    pub __bindgen_anon_1: _KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Alignment of _KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 2usize];
};
impl _KERNEL_CET_CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn UseWrss(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_UseWrss(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn UseWrss_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_UseWrss_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn PopShadowStackOne(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_PopShadowStackOne(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PopShadowStackOne_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_PopShadowStackOne_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Unused(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 14u8) as u16) }
    }
    #[inline]
    pub fn set_Unused(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 14u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Unused_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                14u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Unused_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                14u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        UseWrss: WORD,
        PopShadowStackOne: WORD,
        Unused: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let UseWrss: u16 = unsafe { ::std::mem::transmute(UseWrss) };
            UseWrss as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let PopShadowStackOne: u16 = unsafe { ::std::mem::transmute(PopShadowStackOne) };
            PopShadowStackOne as u64
        });
        __bindgen_bitfield_unit.set(2usize, 14u8, {
            let Unused: u16 = unsafe { ::std::mem::transmute(Unused) };
            Unused as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KERNEL_CET_CONTEXT__bindgen_ty_1"]
        [::std::mem::size_of::<_KERNEL_CET_CONTEXT__bindgen_ty_1>() - 2usize];
    ["Alignment of _KERNEL_CET_CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_KERNEL_CET_CONTEXT__bindgen_ty_1>() - 2usize];
    ["Offset of field: _KERNEL_CET_CONTEXT__bindgen_ty_1::AllFlags"]
        [::std::mem::offset_of!(_KERNEL_CET_CONTEXT__bindgen_ty_1, AllFlags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KERNEL_CET_CONTEXT"][::std::mem::size_of::<_KERNEL_CET_CONTEXT>() - 24usize];
    ["Alignment of _KERNEL_CET_CONTEXT"][::std::mem::align_of::<_KERNEL_CET_CONTEXT>() - 8usize];
    ["Offset of field: _KERNEL_CET_CONTEXT::Ssp"]
        [::std::mem::offset_of!(_KERNEL_CET_CONTEXT, Ssp) - 0usize];
    ["Offset of field: _KERNEL_CET_CONTEXT::Rip"]
        [::std::mem::offset_of!(_KERNEL_CET_CONTEXT, Rip) - 8usize];
    ["Offset of field: _KERNEL_CET_CONTEXT::SegCs"]
        [::std::mem::offset_of!(_KERNEL_CET_CONTEXT, SegCs) - 16usize];
    ["Offset of field: _KERNEL_CET_CONTEXT::Fill"]
        [::std::mem::offset_of!(_KERNEL_CET_CONTEXT, Fill) - 20usize];
};
pub type KERNEL_CET_CONTEXT = _KERNEL_CET_CONTEXT;
pub type PKERNEL_CET_CONTEXT = *mut _KERNEL_CET_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_AMD64 {
    pub Count: DWORD,
    pub ScopeRecord: [_SCOPE_TABLE_AMD64__bindgen_ty_1; 1usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_AMD64__bindgen_ty_1 {
    pub BeginAddress: DWORD,
    pub EndAddress: DWORD,
    pub HandlerAddress: DWORD,
    pub JumpTarget: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_AMD64__bindgen_ty_1"]
        [::std::mem::size_of::<_SCOPE_TABLE_AMD64__bindgen_ty_1>() - 16usize];
    ["Alignment of _SCOPE_TABLE_AMD64__bindgen_ty_1"]
        [::std::mem::align_of::<_SCOPE_TABLE_AMD64__bindgen_ty_1>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_AMD64__bindgen_ty_1::BeginAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64__bindgen_ty_1, BeginAddress) - 0usize];
    ["Offset of field: _SCOPE_TABLE_AMD64__bindgen_ty_1::EndAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64__bindgen_ty_1, EndAddress) - 4usize];
    ["Offset of field: _SCOPE_TABLE_AMD64__bindgen_ty_1::HandlerAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64__bindgen_ty_1, HandlerAddress) - 8usize];
    ["Offset of field: _SCOPE_TABLE_AMD64__bindgen_ty_1::JumpTarget"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64__bindgen_ty_1, JumpTarget) - 12usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_AMD64"][::std::mem::size_of::<_SCOPE_TABLE_AMD64>() - 20usize];
    ["Alignment of _SCOPE_TABLE_AMD64"][::std::mem::align_of::<_SCOPE_TABLE_AMD64>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_AMD64::Count"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64, Count) - 0usize];
    ["Offset of field: _SCOPE_TABLE_AMD64::ScopeRecord"]
        [::std::mem::offset_of!(_SCOPE_TABLE_AMD64, ScopeRecord) - 4usize];
};
pub type SCOPE_TABLE_AMD64 = _SCOPE_TABLE_AMD64;
pub type PSCOPE_TABLE_AMD64 = *mut _SCOPE_TABLE_AMD64;
unsafe extern "C" {
    pub fn _bittest(
        Base: *const ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandcomplement(
        Base: *mut ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandset(
        Base: *mut ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandreset(
        Base: *mut ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _interlockedbittestandset(
        Base: *mut ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _interlockedbittestandreset(
        Base: *mut ::std::os::raw::c_long,
        Offset: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittest64(
        Base: *const ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandcomplement64(
        Base: *mut ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandset64(
        Base: *mut ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _bittestandreset64(
        Base: *mut ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _interlockedbittestandset64(
        Base: *mut ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _interlockedbittestandreset64(
        Base: *mut ::std::os::raw::c_longlong,
        Offset: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _BitScanForward(
        Index: *mut ::std::os::raw::c_ulong,
        Mask: ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _BitScanReverse(
        Index: *mut ::std::os::raw::c_ulong,
        Mask: ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _BitScanForward64(
        Index: *mut ::std::os::raw::c_ulong,
        Mask: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _BitScanReverse64(
        Index: *mut ::std::os::raw::c_ulong,
        Mask: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _InterlockedIncrement16(Addend: *mut ::std::os::raw::c_short)
        -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedDecrement16(Addend: *mut ::std::os::raw::c_short)
        -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedCompareExchange16(
        Destination: *mut ::std::os::raw::c_short,
        ExChange: ::std::os::raw::c_short,
        Comperand: ::std::os::raw::c_short,
    ) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedAnd(
        Destination: *mut ::std::os::raw::c_long,
        Value: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedOr(
        Destination: *mut ::std::os::raw::c_long,
        Value: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedXor(
        Destination: *mut ::std::os::raw::c_long,
        Value: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedAnd64(
        Destination: *mut ::std::os::raw::c_longlong,
        Value: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedOr64(
        Destination: *mut ::std::os::raw::c_longlong,
        Value: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedXor64(
        Destination: *mut ::std::os::raw::c_longlong,
        Value: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedIncrement(Addend: *mut ::std::os::raw::c_long) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedDecrement(Addend: *mut ::std::os::raw::c_long) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedExchange(
        Target: *mut ::std::os::raw::c_long,
        Value: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedExchangeAdd(
        Addend: *mut ::std::os::raw::c_long,
        Value: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedCompareExchange(
        Destination: *mut ::std::os::raw::c_long,
        ExChange: ::std::os::raw::c_long,
        Comperand: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _InterlockedIncrement64(
        Addend: *mut ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedDecrement64(
        Addend: *mut ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedExchange64(
        Target: *mut ::std::os::raw::c_longlong,
        Value: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedExchangeAdd64(
        Addend: *mut ::std::os::raw::c_longlong,
        Value: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedCompareExchange64(
        Destination: *mut ::std::os::raw::c_longlong,
        ExChange: ::std::os::raw::c_longlong,
        Comperand: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _InterlockedCompareExchange128(
        Destination: *mut ::std::os::raw::c_longlong,
        ExchangeHigh: ::std::os::raw::c_longlong,
        ExchangeLow: ::std::os::raw::c_longlong,
        ComparandResult: *mut ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn _InterlockedCompareExchangePointer(
        Destination: *mut *mut ::std::os::raw::c_void,
        Exchange: *mut ::std::os::raw::c_void,
        Comperand: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _InterlockedExchangePointer(
        Target: *mut *mut ::std::os::raw::c_void,
        Value: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _InterlockedExchange8(
        Target: *mut ::std::os::raw::c_char,
        Value: ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _InterlockedExchange16(
        Destination: *mut ::std::os::raw::c_short,
        ExChange: ::std::os::raw::c_short,
    ) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedExchangeAdd8(
        _Addend: *mut ::std::os::raw::c_char,
        _Value: ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _InterlockedAnd8(
        Destination: *mut ::std::os::raw::c_char,
        Value: ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _InterlockedOr8(
        Destination: *mut ::std::os::raw::c_char,
        Value: ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _InterlockedXor8(
        Destination: *mut ::std::os::raw::c_char,
        Value: ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _InterlockedAnd16(
        Destination: *mut ::std::os::raw::c_short,
        Value: ::std::os::raw::c_short,
    ) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedOr16(
        Destination: *mut ::std::os::raw::c_short,
        Value: ::std::os::raw::c_short,
    ) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn _InterlockedXor16(
        Destination: *mut ::std::os::raw::c_short,
        Value: ::std::os::raw::c_short,
    ) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn __cpuidex(
        CPUInfo: *mut ::std::os::raw::c_int,
        Function: ::std::os::raw::c_int,
        SubLeaf: ::std::os::raw::c_int,
    );
}
unsafe extern "C" {
    pub fn _mm_clflush(Address: *const ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn _ReadWriteBarrier();
}
unsafe extern "C" {
    pub fn __faststorefence();
}
unsafe extern "C" {
    pub fn _mm_lfence();
}
unsafe extern "C" {
    pub fn _mm_mfence();
}
unsafe extern "C" {
    pub fn _mm_sfence();
}
unsafe extern "C" {
    pub fn _mm_pause();
}
unsafe extern "C" {
    pub fn _mm_prefetch(a: *const ::std::os::raw::c_char, sel: ::std::os::raw::c_int);
}
unsafe extern "C" {
    pub fn _m_prefetchw(Source: *const ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn _mm_getcsr() -> ::std::os::raw::c_uint;
}
unsafe extern "C" {
    pub fn _mm_setcsr(MxCsr: ::std::os::raw::c_uint);
}
unsafe extern "C" {
    pub fn __getcallerseflags() -> ::std::os::raw::c_uint;
}
unsafe extern "C" {
    pub fn __segmentlimit(Selector: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn __readpmc(Counter: DWORD) -> DWORD64;
}
unsafe extern "C" {
    pub fn __rdtsc() -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __movsb(Destination: PBYTE, Source: *const BYTE, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __movsw(Destination: PWORD, Source: *const WORD, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __movsd(Destination: PDWORD, Source: *const DWORD, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __movsq(Destination: PDWORD64, Source: *const DWORD64, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __stosb(
        Destination: *mut ::std::os::raw::c_uchar,
        Value: ::std::os::raw::c_uchar,
        Count: ::std::os::raw::c_ulonglong,
    );
}
unsafe extern "C" {
    pub fn __stosw(Destination: PWORD, Value: WORD, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __stosd(Destination: PDWORD, Value: DWORD, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __stosq(Destination: PDWORD64, Value: DWORD64, Count: SIZE_T);
}
unsafe extern "C" {
    pub fn __mulh(
        Multiplier: ::std::os::raw::c_longlong,
        Multiplicand: ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn __umulh(
        Multiplier: ::std::os::raw::c_ulonglong,
        Multiplicand: ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __popcnt64(operand: ::std::os::raw::c_ulonglong) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __shiftleft128(
        LowPart: ::std::os::raw::c_ulonglong,
        HighPart: ::std::os::raw::c_ulonglong,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __shiftright128(
        LowPart: ::std::os::raw::c_ulonglong,
        HighPart: ::std::os::raw::c_ulonglong,
        Shift: ::std::os::raw::c_uchar,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _mul128(
        Multiplier: ::std::os::raw::c_longlong,
        Multiplicand: ::std::os::raw::c_longlong,
        HighProduct: *mut ::std::os::raw::c_longlong,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn UnsignedMultiply128(
        Multiplier: DWORD64,
        Multiplicand: DWORD64,
        HighProduct: *mut DWORD64,
    ) -> DWORD64;
}
unsafe extern "C" {
    pub fn _umul128(
        Multiplier: ::std::os::raw::c_ulonglong,
        Multiplicand: ::std::os::raw::c_ulonglong,
        HighProduct: *mut ::std::os::raw::c_ulonglong,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __readgsbyte(Offset: ::std::os::raw::c_ulong) -> ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn __readgsword(Offset: ::std::os::raw::c_ulong) -> ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn __readgsdword(Offset: ::std::os::raw::c_ulong) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn __readgsqword(Offset: ::std::os::raw::c_ulong) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn __writegsbyte(Offset: DWORD, Data: BYTE);
}
unsafe extern "C" {
    pub fn __writegsword(Offset: DWORD, Data: WORD);
}
unsafe extern "C" {
    pub fn __writegsdword(Offset: DWORD, Data: DWORD);
}
unsafe extern "C" {
    pub fn __writegsqword(Offset: DWORD, Data: DWORD64);
}
unsafe extern "C" {
    pub fn __incgsbyte(Offset: DWORD);
}
unsafe extern "C" {
    pub fn __addgsbyte(Offset: DWORD, Value: BYTE);
}
unsafe extern "C" {
    pub fn __incgsword(Offset: DWORD);
}
unsafe extern "C" {
    pub fn __addgsword(Offset: DWORD, Value: WORD);
}
unsafe extern "C" {
    pub fn __incgsdword(Offset: DWORD);
}
unsafe extern "C" {
    pub fn __addgsdword(Offset: DWORD, Value: DWORD);
}
unsafe extern "C" {
    pub fn __incgsqword(Offset: DWORD);
}
unsafe extern "C" {
    pub fn __addgsqword(Offset: DWORD, Value: DWORD64);
}
pub type XMM_SAVE_AREA32 = XSAVE_FORMAT;
pub type PXMM_SAVE_AREA32 = *mut XSAVE_FORMAT;
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct _CONTEXT {
    pub P1Home: DWORD64,
    pub P2Home: DWORD64,
    pub P3Home: DWORD64,
    pub P4Home: DWORD64,
    pub P5Home: DWORD64,
    pub P6Home: DWORD64,
    pub ContextFlags: DWORD,
    pub MxCsr: DWORD,
    pub SegCs: WORD,
    pub SegDs: WORD,
    pub SegEs: WORD,
    pub SegFs: WORD,
    pub SegGs: WORD,
    pub SegSs: WORD,
    pub EFlags: DWORD,
    pub Dr0: DWORD64,
    pub Dr1: DWORD64,
    pub Dr2: DWORD64,
    pub Dr3: DWORD64,
    pub Dr6: DWORD64,
    pub Dr7: DWORD64,
    pub Rax: DWORD64,
    pub Rcx: DWORD64,
    pub Rdx: DWORD64,
    pub Rbx: DWORD64,
    pub Rsp: DWORD64,
    pub Rbp: DWORD64,
    pub Rsi: DWORD64,
    pub Rdi: DWORD64,
    pub R8: DWORD64,
    pub R9: DWORD64,
    pub R10: DWORD64,
    pub R11: DWORD64,
    pub R12: DWORD64,
    pub R13: DWORD64,
    pub R14: DWORD64,
    pub R15: DWORD64,
    pub Rip: DWORD64,
    pub __bindgen_anon_1: _CONTEXT__bindgen_ty_1,
    pub VectorRegister: [M128A; 26usize],
    pub VectorControl: DWORD64,
    pub DebugControl: DWORD64,
    pub LastBranchToRip: DWORD64,
    pub LastBranchFromRip: DWORD64,
    pub LastExceptionToRip: DWORD64,
    pub LastExceptionFromRip: DWORD64,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union _CONTEXT__bindgen_ty_1 {
    pub FltSave: XMM_SAVE_AREA32,
    pub __bindgen_anon_1: _CONTEXT__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    pub Header: [M128A; 2usize],
    pub Legacy: [M128A; 8usize],
    pub Xmm0: M128A,
    pub Xmm1: M128A,
    pub Xmm2: M128A,
    pub Xmm3: M128A,
    pub Xmm4: M128A,
    pub Xmm5: M128A,
    pub Xmm6: M128A,
    pub Xmm7: M128A,
    pub Xmm8: M128A,
    pub Xmm9: M128A,
    pub Xmm10: M128A,
    pub Xmm11: M128A,
    pub Xmm12: M128A,
    pub Xmm13: M128A,
    pub Xmm14: M128A,
    pub Xmm15: M128A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 416usize];
    ["Alignment of _CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Header"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Header) - 0usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Legacy"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Legacy) - 32usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm0"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm0) - 160usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm1"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm1) - 176usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm2"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm2) - 192usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm3"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm3) - 208usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm4"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm4) - 224usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm5"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm5) - 240usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm6"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm6) - 256usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm7"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm7) - 272usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm8"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm8) - 288usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm9"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm9) - 304usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm10"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm10) - 320usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm11"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm11) - 336usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm12"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm12) - 352usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm13"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm13) - 368usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm14"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm14) - 384usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1__bindgen_ty_1::Xmm15"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1__bindgen_ty_1, Xmm15) - 400usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTEXT__bindgen_ty_1"][::std::mem::size_of::<_CONTEXT__bindgen_ty_1>() - 512usize];
    ["Alignment of _CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_CONTEXT__bindgen_ty_1>() - 16usize];
    ["Offset of field: _CONTEXT__bindgen_ty_1::FltSave"]
        [::std::mem::offset_of!(_CONTEXT__bindgen_ty_1, FltSave) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTEXT"][::std::mem::size_of::<_CONTEXT>() - 1232usize];
    ["Alignment of _CONTEXT"][::std::mem::align_of::<_CONTEXT>() - 16usize];
    ["Offset of field: _CONTEXT::P1Home"][::std::mem::offset_of!(_CONTEXT, P1Home) - 0usize];
    ["Offset of field: _CONTEXT::P2Home"][::std::mem::offset_of!(_CONTEXT, P2Home) - 8usize];
    ["Offset of field: _CONTEXT::P3Home"][::std::mem::offset_of!(_CONTEXT, P3Home) - 16usize];
    ["Offset of field: _CONTEXT::P4Home"][::std::mem::offset_of!(_CONTEXT, P4Home) - 24usize];
    ["Offset of field: _CONTEXT::P5Home"][::std::mem::offset_of!(_CONTEXT, P5Home) - 32usize];
    ["Offset of field: _CONTEXT::P6Home"][::std::mem::offset_of!(_CONTEXT, P6Home) - 40usize];
    ["Offset of field: _CONTEXT::ContextFlags"]
        [::std::mem::offset_of!(_CONTEXT, ContextFlags) - 48usize];
    ["Offset of field: _CONTEXT::MxCsr"][::std::mem::offset_of!(_CONTEXT, MxCsr) - 52usize];
    ["Offset of field: _CONTEXT::SegCs"][::std::mem::offset_of!(_CONTEXT, SegCs) - 56usize];
    ["Offset of field: _CONTEXT::SegDs"][::std::mem::offset_of!(_CONTEXT, SegDs) - 58usize];
    ["Offset of field: _CONTEXT::SegEs"][::std::mem::offset_of!(_CONTEXT, SegEs) - 60usize];
    ["Offset of field: _CONTEXT::SegFs"][::std::mem::offset_of!(_CONTEXT, SegFs) - 62usize];
    ["Offset of field: _CONTEXT::SegGs"][::std::mem::offset_of!(_CONTEXT, SegGs) - 64usize];
    ["Offset of field: _CONTEXT::SegSs"][::std::mem::offset_of!(_CONTEXT, SegSs) - 66usize];
    ["Offset of field: _CONTEXT::EFlags"][::std::mem::offset_of!(_CONTEXT, EFlags) - 68usize];
    ["Offset of field: _CONTEXT::Dr0"][::std::mem::offset_of!(_CONTEXT, Dr0) - 72usize];
    ["Offset of field: _CONTEXT::Dr1"][::std::mem::offset_of!(_CONTEXT, Dr1) - 80usize];
    ["Offset of field: _CONTEXT::Dr2"][::std::mem::offset_of!(_CONTEXT, Dr2) - 88usize];
    ["Offset of field: _CONTEXT::Dr3"][::std::mem::offset_of!(_CONTEXT, Dr3) - 96usize];
    ["Offset of field: _CONTEXT::Dr6"][::std::mem::offset_of!(_CONTEXT, Dr6) - 104usize];
    ["Offset of field: _CONTEXT::Dr7"][::std::mem::offset_of!(_CONTEXT, Dr7) - 112usize];
    ["Offset of field: _CONTEXT::Rax"][::std::mem::offset_of!(_CONTEXT, Rax) - 120usize];
    ["Offset of field: _CONTEXT::Rcx"][::std::mem::offset_of!(_CONTEXT, Rcx) - 128usize];
    ["Offset of field: _CONTEXT::Rdx"][::std::mem::offset_of!(_CONTEXT, Rdx) - 136usize];
    ["Offset of field: _CONTEXT::Rbx"][::std::mem::offset_of!(_CONTEXT, Rbx) - 144usize];
    ["Offset of field: _CONTEXT::Rsp"][::std::mem::offset_of!(_CONTEXT, Rsp) - 152usize];
    ["Offset of field: _CONTEXT::Rbp"][::std::mem::offset_of!(_CONTEXT, Rbp) - 160usize];
    ["Offset of field: _CONTEXT::Rsi"][::std::mem::offset_of!(_CONTEXT, Rsi) - 168usize];
    ["Offset of field: _CONTEXT::Rdi"][::std::mem::offset_of!(_CONTEXT, Rdi) - 176usize];
    ["Offset of field: _CONTEXT::R8"][::std::mem::offset_of!(_CONTEXT, R8) - 184usize];
    ["Offset of field: _CONTEXT::R9"][::std::mem::offset_of!(_CONTEXT, R9) - 192usize];
    ["Offset of field: _CONTEXT::R10"][::std::mem::offset_of!(_CONTEXT, R10) - 200usize];
    ["Offset of field: _CONTEXT::R11"][::std::mem::offset_of!(_CONTEXT, R11) - 208usize];
    ["Offset of field: _CONTEXT::R12"][::std::mem::offset_of!(_CONTEXT, R12) - 216usize];
    ["Offset of field: _CONTEXT::R13"][::std::mem::offset_of!(_CONTEXT, R13) - 224usize];
    ["Offset of field: _CONTEXT::R14"][::std::mem::offset_of!(_CONTEXT, R14) - 232usize];
    ["Offset of field: _CONTEXT::R15"][::std::mem::offset_of!(_CONTEXT, R15) - 240usize];
    ["Offset of field: _CONTEXT::Rip"][::std::mem::offset_of!(_CONTEXT, Rip) - 248usize];
    ["Offset of field: _CONTEXT::VectorRegister"]
        [::std::mem::offset_of!(_CONTEXT, VectorRegister) - 768usize];
    ["Offset of field: _CONTEXT::VectorControl"]
        [::std::mem::offset_of!(_CONTEXT, VectorControl) - 1184usize];
    ["Offset of field: _CONTEXT::DebugControl"]
        [::std::mem::offset_of!(_CONTEXT, DebugControl) - 1192usize];
    ["Offset of field: _CONTEXT::LastBranchToRip"]
        [::std::mem::offset_of!(_CONTEXT, LastBranchToRip) - 1200usize];
    ["Offset of field: _CONTEXT::LastBranchFromRip"]
        [::std::mem::offset_of!(_CONTEXT, LastBranchFromRip) - 1208usize];
    ["Offset of field: _CONTEXT::LastExceptionToRip"]
        [::std::mem::offset_of!(_CONTEXT, LastExceptionToRip) - 1216usize];
    ["Offset of field: _CONTEXT::LastExceptionFromRip"]
        [::std::mem::offset_of!(_CONTEXT, LastExceptionFromRip) - 1224usize];
};
pub type CONTEXT = _CONTEXT;
pub type PCONTEXT = *mut _CONTEXT;
pub type RUNTIME_FUNCTION = _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type PRUNTIME_FUNCTION = *mut _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type SCOPE_TABLE = SCOPE_TABLE_AMD64;
pub type PSCOPE_TABLE = *mut SCOPE_TABLE_AMD64;
pub type GET_RUNTIME_FUNCTION_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(ControlPc: DWORD64, Context: PVOID) -> PRUNTIME_FUNCTION,
>;
pub type PGET_RUNTIME_FUNCTION_CALLBACK = GET_RUNTIME_FUNCTION_CALLBACK;
pub type OUT_OF_PROCESS_FUNCTION_TABLE_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        Process: HANDLE,
        TableAddress: PVOID,
        Entries: PDWORD,
        Functions: *mut PRUNTIME_FUNCTION,
    ) -> DWORD,
>;
pub type POUT_OF_PROCESS_FUNCTION_TABLE_CALLBACK = OUT_OF_PROCESS_FUNCTION_TABLE_CALLBACK;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPATCHER_CONTEXT {
    pub ControlPc: DWORD64,
    pub ImageBase: DWORD64,
    pub FunctionEntry: PRUNTIME_FUNCTION,
    pub EstablisherFrame: DWORD64,
    pub TargetIp: DWORD64,
    pub ContextRecord: PCONTEXT,
    pub LanguageHandler: PEXCEPTION_ROUTINE,
    pub HandlerData: PVOID,
    pub HistoryTable: *mut _UNWIND_HISTORY_TABLE,
    pub ScopeIndex: DWORD,
    pub Fill0: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPATCHER_CONTEXT"][::std::mem::size_of::<_DISPATCHER_CONTEXT>() - 80usize];
    ["Alignment of _DISPATCHER_CONTEXT"][::std::mem::align_of::<_DISPATCHER_CONTEXT>() - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT::ControlPc"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, ControlPc) - 0usize];
    ["Offset of field: _DISPATCHER_CONTEXT::ImageBase"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, ImageBase) - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT::FunctionEntry"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, FunctionEntry) - 16usize];
    ["Offset of field: _DISPATCHER_CONTEXT::EstablisherFrame"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, EstablisherFrame) - 24usize];
    ["Offset of field: _DISPATCHER_CONTEXT::TargetIp"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, TargetIp) - 32usize];
    ["Offset of field: _DISPATCHER_CONTEXT::ContextRecord"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, ContextRecord) - 40usize];
    ["Offset of field: _DISPATCHER_CONTEXT::LanguageHandler"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, LanguageHandler) - 48usize];
    ["Offset of field: _DISPATCHER_CONTEXT::HandlerData"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, HandlerData) - 56usize];
    ["Offset of field: _DISPATCHER_CONTEXT::HistoryTable"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, HistoryTable) - 64usize];
    ["Offset of field: _DISPATCHER_CONTEXT::ScopeIndex"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, ScopeIndex) - 72usize];
    ["Offset of field: _DISPATCHER_CONTEXT::Fill0"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT, Fill0) - 76usize];
};
pub type DISPATCHER_CONTEXT = _DISPATCHER_CONTEXT;
pub type PDISPATCHER_CONTEXT = *mut _DISPATCHER_CONTEXT;
pub type PEXCEPTION_FILTER = ::std::option::Option<
    unsafe extern "C" fn(
        ExceptionPointers: *mut _EXCEPTION_POINTERS,
        EstablisherFrame: PVOID,
    ) -> LONG,
>;
pub type PTERMINATION_HANDLER = ::std::option::Option<
    unsafe extern "C" fn(_abnormal_termination: BOOLEAN, EstablisherFrame: PVOID),
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _KNONVOLATILE_CONTEXT_POINTERS {
    pub __bindgen_anon_1: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1,
    pub __bindgen_anon_2: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1 {
    pub FloatingContext: [PM128A; 16usize],
    pub __bindgen_anon_1: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1 {
    pub Xmm0: PM128A,
    pub Xmm1: PM128A,
    pub Xmm2: PM128A,
    pub Xmm3: PM128A,
    pub Xmm4: PM128A,
    pub Xmm5: PM128A,
    pub Xmm6: PM128A,
    pub Xmm7: PM128A,
    pub Xmm8: PM128A,
    pub Xmm9: PM128A,
    pub Xmm10: PM128A,
    pub Xmm11: PM128A,
    pub Xmm12: PM128A,
    pub Xmm13: PM128A,
    pub Xmm14: PM128A,
    pub Xmm15: PM128A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
    >() - 128usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
    >() - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm0"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm0
    )
        - 0usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm1"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm1
    )
        - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm2"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm2
    )
        - 16usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm3"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm3
    )
        - 24usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm4"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm4
    )
        - 32usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm5"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm5
    )
        - 40usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm6"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm6
    )
        - 48usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm7"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm7
    )
        - 56usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm8"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm8
    )
        - 64usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm9"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm9
    )
        - 72usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm10"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm10
    )
        - 80usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm11"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm11
    )
        - 88usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm12"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm12
    )
        - 96usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm13"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm13
    )
        - 104usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm14"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm14
    )
        - 112usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1::Xmm15"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1__bindgen_ty_1,
        Xmm15
    )
        - 120usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1"]
        [::std::mem::size_of::<_KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1>() - 128usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1"]
        [::std::mem::align_of::<_KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1>() - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1::FloatingContext"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_1,
        FloatingContext
    ) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2 {
    pub IntegerContext: [PDWORD64; 16usize],
    pub __bindgen_anon_1: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1 {
    pub Rax: PDWORD64,
    pub Rcx: PDWORD64,
    pub Rdx: PDWORD64,
    pub Rbx: PDWORD64,
    pub Rsp: PDWORD64,
    pub Rbp: PDWORD64,
    pub Rsi: PDWORD64,
    pub Rdi: PDWORD64,
    pub R8: PDWORD64,
    pub R9: PDWORD64,
    pub R10: PDWORD64,
    pub R11: PDWORD64,
    pub R12: PDWORD64,
    pub R13: PDWORD64,
    pub R14: PDWORD64,
    pub R15: PDWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1"][::std::mem::size_of::<
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
    >() - 128usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1"][::std::mem::align_of::<
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
    >() - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rax"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rax
    )
        - 0usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rcx"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rcx
    )
        - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rdx"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rdx
    )
        - 16usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rbx"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rbx
    )
        - 24usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rsp"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rsp
    )
        - 32usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rbp"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rbp
    )
        - 40usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rsi"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rsi
    )
        - 48usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::Rdi"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        Rdi
    )
        - 56usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R8"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R8
    )
        - 64usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R9"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R9
    )
        - 72usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R10"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R10
    )
        - 80usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R11"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R11
    )
        - 88usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R12"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R12
    )
        - 96usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R13"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R13
    )
        - 104usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R14"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R14
    )
        - 112usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1::R15"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2__bindgen_ty_1,
        R15
    )
        - 120usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2"]
        [::std::mem::size_of::<_KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2>() - 128usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2"]
        [::std::mem::align_of::<_KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2>() - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2::IntegerContext"][::std::mem::offset_of!(
        _KNONVOLATILE_CONTEXT_POINTERS__bindgen_ty_2,
        IntegerContext
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS"]
        [::std::mem::size_of::<_KNONVOLATILE_CONTEXT_POINTERS>() - 256usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS"]
        [::std::mem::align_of::<_KNONVOLATILE_CONTEXT_POINTERS>() - 8usize];
};
pub type KNONVOLATILE_CONTEXT_POINTERS = _KNONVOLATILE_CONTEXT_POINTERS;
pub type PKNONVOLATILE_CONTEXT_POINTERS = *mut _KNONVOLATILE_CONTEXT_POINTERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_ARM {
    pub Count: DWORD,
    pub ScopeRecord: [_SCOPE_TABLE_ARM__bindgen_ty_1; 1usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_ARM__bindgen_ty_1 {
    pub BeginAddress: DWORD,
    pub EndAddress: DWORD,
    pub HandlerAddress: DWORD,
    pub JumpTarget: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_ARM__bindgen_ty_1"]
        [::std::mem::size_of::<_SCOPE_TABLE_ARM__bindgen_ty_1>() - 16usize];
    ["Alignment of _SCOPE_TABLE_ARM__bindgen_ty_1"]
        [::std::mem::align_of::<_SCOPE_TABLE_ARM__bindgen_ty_1>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM__bindgen_ty_1::BeginAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM__bindgen_ty_1, BeginAddress) - 0usize];
    ["Offset of field: _SCOPE_TABLE_ARM__bindgen_ty_1::EndAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM__bindgen_ty_1, EndAddress) - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM__bindgen_ty_1::HandlerAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM__bindgen_ty_1, HandlerAddress) - 8usize];
    ["Offset of field: _SCOPE_TABLE_ARM__bindgen_ty_1::JumpTarget"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM__bindgen_ty_1, JumpTarget) - 12usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_ARM"][::std::mem::size_of::<_SCOPE_TABLE_ARM>() - 20usize];
    ["Alignment of _SCOPE_TABLE_ARM"][::std::mem::align_of::<_SCOPE_TABLE_ARM>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM::Count"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM, Count) - 0usize];
    ["Offset of field: _SCOPE_TABLE_ARM::ScopeRecord"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM, ScopeRecord) - 4usize];
};
pub type SCOPE_TABLE_ARM = _SCOPE_TABLE_ARM;
pub type PSCOPE_TABLE_ARM = *mut _SCOPE_TABLE_ARM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_ARM64 {
    pub Count: DWORD,
    pub ScopeRecord: [_SCOPE_TABLE_ARM64__bindgen_ty_1; 1usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCOPE_TABLE_ARM64__bindgen_ty_1 {
    pub BeginAddress: DWORD,
    pub EndAddress: DWORD,
    pub HandlerAddress: DWORD,
    pub JumpTarget: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_ARM64__bindgen_ty_1"]
        [::std::mem::size_of::<_SCOPE_TABLE_ARM64__bindgen_ty_1>() - 16usize];
    ["Alignment of _SCOPE_TABLE_ARM64__bindgen_ty_1"]
        [::std::mem::align_of::<_SCOPE_TABLE_ARM64__bindgen_ty_1>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM64__bindgen_ty_1::BeginAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64__bindgen_ty_1, BeginAddress) - 0usize];
    ["Offset of field: _SCOPE_TABLE_ARM64__bindgen_ty_1::EndAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64__bindgen_ty_1, EndAddress) - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM64__bindgen_ty_1::HandlerAddress"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64__bindgen_ty_1, HandlerAddress) - 8usize];
    ["Offset of field: _SCOPE_TABLE_ARM64__bindgen_ty_1::JumpTarget"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64__bindgen_ty_1, JumpTarget) - 12usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCOPE_TABLE_ARM64"][::std::mem::size_of::<_SCOPE_TABLE_ARM64>() - 20usize];
    ["Alignment of _SCOPE_TABLE_ARM64"][::std::mem::align_of::<_SCOPE_TABLE_ARM64>() - 4usize];
    ["Offset of field: _SCOPE_TABLE_ARM64::Count"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64, Count) - 0usize];
    ["Offset of field: _SCOPE_TABLE_ARM64::ScopeRecord"]
        [::std::mem::offset_of!(_SCOPE_TABLE_ARM64, ScopeRecord) - 4usize];
};
pub type SCOPE_TABLE_ARM64 = _SCOPE_TABLE_ARM64;
pub type PSCOPE_TABLE_ARM64 = *mut _SCOPE_TABLE_ARM64;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ARM64_NT_NEON128 {
    pub __bindgen_anon_1: _ARM64_NT_NEON128__bindgen_ty_1,
    pub D: [f64; 2usize],
    pub S: [f32; 4usize],
    pub H: [WORD; 8usize],
    pub B: [BYTE; 16usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ARM64_NT_NEON128__bindgen_ty_1 {
    pub Low: ULONGLONG,
    pub High: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64_NT_NEON128__bindgen_ty_1"]
        [::std::mem::size_of::<_ARM64_NT_NEON128__bindgen_ty_1>() - 16usize];
    ["Alignment of _ARM64_NT_NEON128__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64_NT_NEON128__bindgen_ty_1>() - 8usize];
    ["Offset of field: _ARM64_NT_NEON128__bindgen_ty_1::Low"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128__bindgen_ty_1, Low) - 0usize];
    ["Offset of field: _ARM64_NT_NEON128__bindgen_ty_1::High"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128__bindgen_ty_1, High) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64_NT_NEON128"][::std::mem::size_of::<_ARM64_NT_NEON128>() - 16usize];
    ["Alignment of _ARM64_NT_NEON128"][::std::mem::align_of::<_ARM64_NT_NEON128>() - 8usize];
    ["Offset of field: _ARM64_NT_NEON128::D"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128, D) - 0usize];
    ["Offset of field: _ARM64_NT_NEON128::S"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128, S) - 0usize];
    ["Offset of field: _ARM64_NT_NEON128::H"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128, H) - 0usize];
    ["Offset of field: _ARM64_NT_NEON128::B"]
        [::std::mem::offset_of!(_ARM64_NT_NEON128, B) - 0usize];
};
pub type ARM64_NT_NEON128 = _ARM64_NT_NEON128;
pub type PARM64_NT_NEON128 = *mut _ARM64_NT_NEON128;
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct _ARM64_NT_CONTEXT {
    pub ContextFlags: DWORD,
    pub Cpsr: DWORD,
    pub __bindgen_anon_1: _ARM64_NT_CONTEXT__bindgen_ty_1,
    pub Sp: DWORD64,
    pub Pc: DWORD64,
    pub V: [ARM64_NT_NEON128; 32usize],
    pub Fpcr: DWORD,
    pub Fpsr: DWORD,
    pub Bcr: [DWORD; 8usize],
    pub Bvr: [DWORD64; 8usize],
    pub Wcr: [DWORD; 2usize],
    pub Wvr: [DWORD64; 2usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ARM64_NT_CONTEXT__bindgen_ty_1 {
    pub __bindgen_anon_1: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
    pub X: [DWORD64; 31usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    pub X0: DWORD64,
    pub X1: DWORD64,
    pub X2: DWORD64,
    pub X3: DWORD64,
    pub X4: DWORD64,
    pub X5: DWORD64,
    pub X6: DWORD64,
    pub X7: DWORD64,
    pub X8: DWORD64,
    pub X9: DWORD64,
    pub X10: DWORD64,
    pub X11: DWORD64,
    pub X12: DWORD64,
    pub X13: DWORD64,
    pub X14: DWORD64,
    pub X15: DWORD64,
    pub X16: DWORD64,
    pub X17: DWORD64,
    pub X18: DWORD64,
    pub X19: DWORD64,
    pub X20: DWORD64,
    pub X21: DWORD64,
    pub X22: DWORD64,
    pub X23: DWORD64,
    pub X24: DWORD64,
    pub X25: DWORD64,
    pub X26: DWORD64,
    pub X27: DWORD64,
    pub X28: DWORD64,
    pub Fp: DWORD64,
    pub Lr: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 248usize];
    ["Alignment of _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X0"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X0) - 0usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X1"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X1) - 8usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X2"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X2) - 16usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X3"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X3) - 24usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X4"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X4) - 32usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X5"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X5) - 40usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X6"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X6) - 48usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X7"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X7) - 56usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X8"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X8) - 64usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X9"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X9) - 72usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X10"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X10) - 80usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X11"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X11) - 88usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X12"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X12) - 96usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X13"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X13) - 104usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X14"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X14) - 112usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X15"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X15) - 120usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X16"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X16) - 128usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X17"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X17) - 136usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X18"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X18) - 144usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X19"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X19) - 152usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X20"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X20) - 160usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X21"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X21) - 168usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X22"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X22) - 176usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X23"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X23) - 184usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X24"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X24) - 192usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X25"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X25) - 200usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X26"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X26) - 208usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X27"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X27) - 216usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X28"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X28) - 224usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::Fp"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, Fp) - 232usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::Lr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, Lr) - 240usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64_NT_CONTEXT__bindgen_ty_1"]
        [::std::mem::size_of::<_ARM64_NT_CONTEXT__bindgen_ty_1>() - 248usize];
    ["Alignment of _ARM64_NT_CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64_NT_CONTEXT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _ARM64_NT_CONTEXT__bindgen_ty_1::X"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT__bindgen_ty_1, X) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64_NT_CONTEXT"][::std::mem::size_of::<_ARM64_NT_CONTEXT>() - 912usize];
    ["Alignment of _ARM64_NT_CONTEXT"][::std::mem::align_of::<_ARM64_NT_CONTEXT>() - 16usize];
    ["Offset of field: _ARM64_NT_CONTEXT::ContextFlags"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, ContextFlags) - 0usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Cpsr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Cpsr) - 4usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Sp"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Sp) - 256usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Pc"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Pc) - 264usize];
    ["Offset of field: _ARM64_NT_CONTEXT::V"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, V) - 272usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Fpcr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Fpcr) - 784usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Fpsr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Fpsr) - 788usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Bcr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Bcr) - 792usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Bvr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Bvr) - 824usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Wcr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Wcr) - 888usize];
    ["Offset of field: _ARM64_NT_CONTEXT::Wvr"]
        [::std::mem::offset_of!(_ARM64_NT_CONTEXT, Wvr) - 896usize];
};
pub type ARM64_NT_CONTEXT = _ARM64_NT_CONTEXT;
pub type PARM64_NT_CONTEXT = *mut _ARM64_NT_CONTEXT;
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub struct _ARM64EC_NT_CONTEXT {
    pub __bindgen_anon_1: _ARM64EC_NT_CONTEXT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ARM64EC_NT_CONTEXT__bindgen_ty_1 {
    pub __bindgen_anon_1: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    pub AMD64_P1Home: DWORD64,
    pub AMD64_P2Home: DWORD64,
    pub AMD64_P3Home: DWORD64,
    pub AMD64_P4Home: DWORD64,
    pub AMD64_P5Home: DWORD64,
    pub AMD64_P6Home: DWORD64,
    pub ContextFlags: DWORD,
    pub AMD64_MxCsr_copy: DWORD,
    pub AMD64_SegCs: WORD,
    pub AMD64_SegDs: WORD,
    pub AMD64_SegEs: WORD,
    pub AMD64_SegFs: WORD,
    pub AMD64_SegGs: WORD,
    pub AMD64_SegSs: WORD,
    pub AMD64_EFlags: DWORD,
    pub AMD64_Dr0: DWORD64,
    pub AMD64_Dr1: DWORD64,
    pub AMD64_Dr2: DWORD64,
    pub AMD64_Dr3: DWORD64,
    pub AMD64_Dr6: DWORD64,
    pub AMD64_Dr7: DWORD64,
    pub X8: DWORD64,
    pub X0: DWORD64,
    pub X1: DWORD64,
    pub X27: DWORD64,
    pub Sp: DWORD64,
    pub Fp: DWORD64,
    pub X25: DWORD64,
    pub X26: DWORD64,
    pub X2: DWORD64,
    pub X3: DWORD64,
    pub X4: DWORD64,
    pub X5: DWORD64,
    pub X19: DWORD64,
    pub X20: DWORD64,
    pub X21: DWORD64,
    pub X22: DWORD64,
    pub Pc: DWORD64,
    pub __bindgen_anon_1: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub AMD64_VectorRegister: [ARM64_NT_NEON128; 26usize],
    pub AMD64_VectorControl: DWORD64,
    pub AMD64_DebugControl: DWORD64,
    pub AMD64_LastBranchToRip: DWORD64,
    pub AMD64_LastBranchFromRip: DWORD64,
    pub AMD64_LastExceptionToRip: DWORD64,
    pub AMD64_LastExceptionFromRip: DWORD64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub AMD64_ControlWord: WORD,
    pub AMD64_StatusWord: WORD,
    pub AMD64_TagWord: BYTE,
    pub AMD64_Reserved1: BYTE,
    pub AMD64_ErrorOpcode: WORD,
    pub AMD64_ErrorOffset: DWORD,
    pub AMD64_ErrorSelector: WORD,
    pub AMD64_Reserved2: WORD,
    pub AMD64_DataOffset: DWORD,
    pub AMD64_DataSelector: WORD,
    pub AMD64_Reserved3: WORD,
    pub AMD64_MxCsr: DWORD,
    pub AMD64_MxCsr_Mask: DWORD,
    pub Lr: DWORD64,
    pub X16_0: WORD,
    pub AMD64_St0_Reserved1: WORD,
    pub AMD64_St0_Reserved2: DWORD,
    pub X6: DWORD64,
    pub X16_1: WORD,
    pub AMD64_St1_Reserved1: WORD,
    pub AMD64_St1_Reserved2: DWORD,
    pub X7: DWORD64,
    pub X16_2: WORD,
    pub AMD64_St2_Reserved1: WORD,
    pub AMD64_St2_Reserved2: DWORD,
    pub X9: DWORD64,
    pub X16_3: WORD,
    pub AMD64_St3_Reserved1: WORD,
    pub AMD64_St3_Reserved2: DWORD,
    pub X10: DWORD64,
    pub X17_0: WORD,
    pub AMD64_St4_Reserved1: WORD,
    pub AMD64_St4_Reserved2: DWORD,
    pub X11: DWORD64,
    pub X17_1: WORD,
    pub AMD64_St5_Reserved1: WORD,
    pub AMD64_St5_Reserved2: DWORD,
    pub X12: DWORD64,
    pub X17_2: WORD,
    pub AMD64_St6_Reserved1: WORD,
    pub AMD64_St6_Reserved2: DWORD,
    pub X15: DWORD64,
    pub X17_3: WORD,
    pub AMD64_St7_Reserved1: WORD,
    pub AMD64_St7_Reserved2: DWORD,
    pub V: [ARM64_NT_NEON128; 16usize],
    pub AMD64_XSAVE_FORMAT_Reserved4: [BYTE; 96usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    >() - 512usize];
    ["Alignment of _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()
            - 8usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_ControlWord"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_ControlWord) - 0usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_StatusWord"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_StatusWord) - 2usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_TagWord"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_TagWord) - 4usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_Reserved1) - 5usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_ErrorOpcode"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_ErrorOpcode) - 6usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_ErrorOffset"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_ErrorOffset) - 8usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_ErrorSelector"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_ErrorSelector) - 12usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_Reserved2) - 14usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_DataOffset"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_DataOffset) - 16usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_DataSelector"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_DataSelector) - 20usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_Reserved3"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_Reserved3) - 22usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_MxCsr"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_MxCsr) - 24usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_MxCsr_Mask"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_MxCsr_Mask) - 28usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::Lr"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        Lr
    )
        - 32usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X16_0"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X16_0
    )
        - 40usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St0_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St0_Reserved1) - 42usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St0_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St0_Reserved2) - 44usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X6"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X6
    )
        - 48usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X16_1"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X16_1
    )
        - 56usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St1_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St1_Reserved1) - 58usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St1_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St1_Reserved2) - 60usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X7"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X7
    )
        - 64usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X16_2"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X16_2
    )
        - 72usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St2_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St2_Reserved1) - 74usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St2_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St2_Reserved2) - 76usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X9"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X9
    )
        - 80usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X16_3"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X16_3
    )
        - 88usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St3_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St3_Reserved1) - 90usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St3_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St3_Reserved2) - 92usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X10"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X10
    )
        - 96usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X17_0"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X17_0
    )
        - 104usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St4_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St4_Reserved1) - 106usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St4_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St4_Reserved2) - 108usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X11"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X11
    )
        - 112usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X17_1"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X17_1
    )
        - 120usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St5_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St5_Reserved1) - 122usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St5_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St5_Reserved2) - 124usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X12"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X12
    )
        - 128usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X17_2"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X17_2
    )
        - 136usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St6_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St6_Reserved1) - 138usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St6_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St6_Reserved2) - 140usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X15"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X15
    )
        - 144usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::X17_3"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        X17_3
    )
        - 152usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St7_Reserved1"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St7_Reserved1) - 154usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_St7_Reserved2"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_St7_Reserved2) - 156usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::V"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        V
    )
        - 160usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AMD64_XSAVE_FORMAT_Reserved4"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AMD64_XSAVE_FORMAT_Reserved4) - 416usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 1232usize];
    ["Alignment of _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P1Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P1Home
    ) - 0usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P2Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P2Home
    ) - 8usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P3Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P3Home
    ) - 16usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P4Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P4Home
    ) - 24usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P5Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P5Home
    ) - 32usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_P6Home"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_P6Home
    ) - 40usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::ContextFlags"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        ContextFlags
    ) - 48usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_MxCsr_copy"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_MxCsr_copy
    )
        - 52usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegCs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegCs
    ) - 56usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegDs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegDs
    ) - 58usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegEs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegEs
    ) - 60usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegFs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegFs
    ) - 62usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegGs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegGs
    ) - 64usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_SegSs"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_SegSs
    ) - 66usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_EFlags"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_EFlags
    ) - 68usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr0"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr0
    ) - 72usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr1"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr1
    ) - 80usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr2"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr2
    ) - 88usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr3"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr3
    ) - 96usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr6"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr6
    ) - 104usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_Dr7"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_Dr7
    ) - 112usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X8"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X8) - 120usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X0"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X0) - 128usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X1"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X1) - 136usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X27"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X27) - 144usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::Sp"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, Sp) - 152usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::Fp"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, Fp) - 160usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X25"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X25) - 168usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X26"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X26) - 176usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X2"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X2) - 184usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X3"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X3) - 192usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X4"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X4) - 200usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X5"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X5) - 208usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X19"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X19) - 216usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X20"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X20) - 224usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X21"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X21) - 232usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::X22"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, X22) - 240usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::Pc"]
        [::std::mem::offset_of!(_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1, Pc) - 248usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_VectorRegister"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_VectorRegister
    )
        - 768usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_VectorControl"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_VectorControl
    )
        - 1184usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_DebugControl"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_DebugControl
    )
        - 1192usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_LastBranchToRip"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_LastBranchToRip
    )
        - 1200usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_LastBranchFromRip"][::std::mem::offset_of!(
        _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        AMD64_LastBranchFromRip
    )
        - 1208usize];
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_LastExceptionToRip"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1 , AMD64_LastExceptionToRip) - 1216usize] ;
    ["Offset of field: _ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1::AMD64_LastExceptionFromRip"] [:: std :: mem :: offset_of ! (_ARM64EC_NT_CONTEXT__bindgen_ty_1__bindgen_ty_1 , AMD64_LastExceptionFromRip) - 1224usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64EC_NT_CONTEXT__bindgen_ty_1"]
        [::std::mem::size_of::<_ARM64EC_NT_CONTEXT__bindgen_ty_1>() - 1232usize];
    ["Alignment of _ARM64EC_NT_CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_ARM64EC_NT_CONTEXT__bindgen_ty_1>() - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ARM64EC_NT_CONTEXT"][::std::mem::size_of::<_ARM64EC_NT_CONTEXT>() - 1232usize];
    ["Alignment of _ARM64EC_NT_CONTEXT"][::std::mem::align_of::<_ARM64EC_NT_CONTEXT>() - 16usize];
};
pub type ARM64EC_NT_CONTEXT = _ARM64EC_NT_CONTEXT;
pub type PARM64EC_NT_CONTEXT = *mut _ARM64EC_NT_CONTEXT;
pub type ARM64_RUNTIME_FUNCTION = _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY;
pub type PARM64_RUNTIME_FUNCTION = *mut _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISPATCHER_CONTEXT_NONVOLREG_ARM64 {
    pub Buffer: [BYTE; 152usize],
    pub __bindgen_anon_1: _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1 {
    pub GpNvRegs: [DWORD64; 11usize],
    pub FpNvRegs: [f64; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1>() - 152usize];
    ["Alignment of _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1"]
        [::std::mem::align_of::<_DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1::GpNvRegs"][::std::mem::offset_of!(
        _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1,
        GpNvRegs
    ) - 0usize];
    ["Offset of field: _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1::FpNvRegs"][::std::mem::offset_of!(
        _DISPATCHER_CONTEXT_NONVOLREG_ARM64__bindgen_ty_1,
        FpNvRegs
    ) - 88usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPATCHER_CONTEXT_NONVOLREG_ARM64"]
        [::std::mem::size_of::<_DISPATCHER_CONTEXT_NONVOLREG_ARM64>() - 152usize];
    ["Alignment of _DISPATCHER_CONTEXT_NONVOLREG_ARM64"]
        [::std::mem::align_of::<_DISPATCHER_CONTEXT_NONVOLREG_ARM64>() - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT_NONVOLREG_ARM64::Buffer"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_NONVOLREG_ARM64, Buffer) - 0usize];
};
pub type DISPATCHER_CONTEXT_NONVOLREG_ARM64 = _DISPATCHER_CONTEXT_NONVOLREG_ARM64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPATCHER_CONTEXT_ARM64 {
    pub ControlPc: ULONG_PTR,
    pub ImageBase: ULONG_PTR,
    pub FunctionEntry: PARM64_RUNTIME_FUNCTION,
    pub EstablisherFrame: ULONG_PTR,
    pub TargetPc: ULONG_PTR,
    pub ContextRecord: PARM64_NT_CONTEXT,
    pub LanguageHandler: PEXCEPTION_ROUTINE,
    pub HandlerData: PVOID,
    pub HistoryTable: *mut _UNWIND_HISTORY_TABLE,
    pub ScopeIndex: DWORD,
    pub ControlPcIsUnwound: BOOLEAN,
    pub NonVolatileRegisters: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPATCHER_CONTEXT_ARM64"]
        [::std::mem::size_of::<_DISPATCHER_CONTEXT_ARM64>() - 88usize];
    ["Alignment of _DISPATCHER_CONTEXT_ARM64"]
        [::std::mem::align_of::<_DISPATCHER_CONTEXT_ARM64>() - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::ControlPc"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, ControlPc) - 0usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::ImageBase"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, ImageBase) - 8usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::FunctionEntry"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, FunctionEntry) - 16usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::EstablisherFrame"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, EstablisherFrame) - 24usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::TargetPc"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, TargetPc) - 32usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::ContextRecord"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, ContextRecord) - 40usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::LanguageHandler"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, LanguageHandler) - 48usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::HandlerData"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, HandlerData) - 56usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::HistoryTable"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, HistoryTable) - 64usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::ScopeIndex"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, ScopeIndex) - 72usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::ControlPcIsUnwound"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, ControlPcIsUnwound) - 76usize];
    ["Offset of field: _DISPATCHER_CONTEXT_ARM64::NonVolatileRegisters"]
        [::std::mem::offset_of!(_DISPATCHER_CONTEXT_ARM64, NonVolatileRegisters) - 80usize];
};
pub type DISPATCHER_CONTEXT_ARM64 = _DISPATCHER_CONTEXT_ARM64;
pub type PDISPATCHER_CONTEXT_ARM64 = *mut _DISPATCHER_CONTEXT_ARM64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KNONVOLATILE_CONTEXT_POINTERS_ARM64 {
    pub X19: PDWORD64,
    pub X20: PDWORD64,
    pub X21: PDWORD64,
    pub X22: PDWORD64,
    pub X23: PDWORD64,
    pub X24: PDWORD64,
    pub X25: PDWORD64,
    pub X26: PDWORD64,
    pub X27: PDWORD64,
    pub X28: PDWORD64,
    pub Fp: PDWORD64,
    pub Lr: PDWORD64,
    pub D8: PDWORD64,
    pub D9: PDWORD64,
    pub D10: PDWORD64,
    pub D11: PDWORD64,
    pub D12: PDWORD64,
    pub D13: PDWORD64,
    pub D14: PDWORD64,
    pub D15: PDWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KNONVOLATILE_CONTEXT_POINTERS_ARM64"]
        [::std::mem::size_of::<_KNONVOLATILE_CONTEXT_POINTERS_ARM64>() - 160usize];
    ["Alignment of _KNONVOLATILE_CONTEXT_POINTERS_ARM64"]
        [::std::mem::align_of::<_KNONVOLATILE_CONTEXT_POINTERS_ARM64>() - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X19"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X19) - 0usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X20"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X20) - 8usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X21"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X21) - 16usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X22"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X22) - 24usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X23"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X23) - 32usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X24"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X24) - 40usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X25"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X25) - 48usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X26"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X26) - 56usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X27"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X27) - 64usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::X28"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, X28) - 72usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::Fp"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, Fp) - 80usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::Lr"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, Lr) - 88usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D8"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D8) - 96usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D9"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D9) - 104usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D10"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D10) - 112usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D11"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D11) - 120usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D12"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D12) - 128usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D13"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D13) - 136usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D14"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D14) - 144usize];
    ["Offset of field: _KNONVOLATILE_CONTEXT_POINTERS_ARM64::D15"]
        [::std::mem::offset_of!(_KNONVOLATILE_CONTEXT_POINTERS_ARM64, D15) - 152usize];
};
pub type KNONVOLATILE_CONTEXT_POINTERS_ARM64 = _KNONVOLATILE_CONTEXT_POINTERS_ARM64;
pub type PKNONVOLATILE_CONTEXT_POINTERS_ARM64 = *mut _KNONVOLATILE_CONTEXT_POINTERS_ARM64;
unsafe extern "C" {
    pub fn __int2c() -> !;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _LDT_ENTRY {
    pub LimitLow: WORD,
    pub BaseLow: WORD,
    pub HighWord: _LDT_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _LDT_ENTRY__bindgen_ty_1 {
    pub Bytes: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1,
    pub Bits: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub BaseMid: BYTE,
    pub Flags1: BYTE,
    pub Flags2: BYTE,
    pub BaseHi: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::BaseMid"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, BaseMid) - 0usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::Flags1"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, Flags1) - 1usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::Flags2"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, Flags2) - 2usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::BaseHi"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, BaseHi) - 3usize];
};
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _LDT_ENTRY__bindgen_ty_1__bindgen_ty_2 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDT_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of _LDT_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 4usize];
};
impl _LDT_ENTRY__bindgen_ty_1__bindgen_ty_2 {
    #[inline]
    pub fn BaseMid(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_BaseMid(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BaseMid_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BaseMid_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Type(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_Type(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Type_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Type_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Dpl(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Dpl(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Dpl_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Dpl_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Pres(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Pres(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Pres_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Pres_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn LimitHi(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_LimitHi(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn LimitHi_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_LimitHi_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Sys(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Sys(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Sys_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Sys_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved_0(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved_0(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_0_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_0_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Default_Big(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Default_Big(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(22usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Default_Big_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                22usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Default_Big_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                22usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Granularity(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Granularity(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(23usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Granularity_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                23usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Granularity_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                23usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn BaseHi(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_BaseHi(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(24usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BaseHi_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                24usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BaseHi_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                24usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        BaseMid: DWORD,
        Type: DWORD,
        Dpl: DWORD,
        Pres: DWORD,
        LimitHi: DWORD,
        Sys: DWORD,
        Reserved_0: DWORD,
        Default_Big: DWORD,
        Granularity: DWORD,
        BaseHi: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let BaseMid: u32 = unsafe { ::std::mem::transmute(BaseMid) };
            BaseMid as u64
        });
        __bindgen_bitfield_unit.set(8usize, 5u8, {
            let Type: u32 = unsafe { ::std::mem::transmute(Type) };
            Type as u64
        });
        __bindgen_bitfield_unit.set(13usize, 2u8, {
            let Dpl: u32 = unsafe { ::std::mem::transmute(Dpl) };
            Dpl as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let Pres: u32 = unsafe { ::std::mem::transmute(Pres) };
            Pres as u64
        });
        __bindgen_bitfield_unit.set(16usize, 4u8, {
            let LimitHi: u32 = unsafe { ::std::mem::transmute(LimitHi) };
            LimitHi as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let Sys: u32 = unsafe { ::std::mem::transmute(Sys) };
            Sys as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let Reserved_0: u32 = unsafe { ::std::mem::transmute(Reserved_0) };
            Reserved_0 as u64
        });
        __bindgen_bitfield_unit.set(22usize, 1u8, {
            let Default_Big: u32 = unsafe { ::std::mem::transmute(Default_Big) };
            Default_Big as u64
        });
        __bindgen_bitfield_unit.set(23usize, 1u8, {
            let Granularity: u32 = unsafe { ::std::mem::transmute(Granularity) };
            Granularity as u64
        });
        __bindgen_bitfield_unit.set(24usize, 8u8, {
            let BaseHi: u32 = unsafe { ::std::mem::transmute(BaseHi) };
            BaseHi as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDT_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_LDT_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _LDT_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_LDT_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1::Bytes"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1, Bytes) - 0usize];
    ["Offset of field: _LDT_ENTRY__bindgen_ty_1::Bits"]
        [::std::mem::offset_of!(_LDT_ENTRY__bindgen_ty_1, Bits) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDT_ENTRY"][::std::mem::size_of::<_LDT_ENTRY>() - 8usize];
    ["Alignment of _LDT_ENTRY"][::std::mem::align_of::<_LDT_ENTRY>() - 4usize];
    ["Offset of field: _LDT_ENTRY::LimitLow"]
        [::std::mem::offset_of!(_LDT_ENTRY, LimitLow) - 0usize];
    ["Offset of field: _LDT_ENTRY::BaseLow"][::std::mem::offset_of!(_LDT_ENTRY, BaseLow) - 2usize];
    ["Offset of field: _LDT_ENTRY::HighWord"]
        [::std::mem::offset_of!(_LDT_ENTRY, HighWord) - 4usize];
};
pub type LDT_ENTRY = _LDT_ENTRY;
pub type PLDT_ENTRY = *mut _LDT_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOW64_FLOATING_SAVE_AREA {
    pub ControlWord: DWORD,
    pub StatusWord: DWORD,
    pub TagWord: DWORD,
    pub ErrorOffset: DWORD,
    pub ErrorSelector: DWORD,
    pub DataOffset: DWORD,
    pub DataSelector: DWORD,
    pub RegisterArea: [BYTE; 80usize],
    pub Cr0NpxState: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_FLOATING_SAVE_AREA"]
        [::std::mem::size_of::<_WOW64_FLOATING_SAVE_AREA>() - 112usize];
    ["Alignment of _WOW64_FLOATING_SAVE_AREA"]
        [::std::mem::align_of::<_WOW64_FLOATING_SAVE_AREA>() - 4usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::ControlWord"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, ControlWord) - 0usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::StatusWord"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, StatusWord) - 4usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::TagWord"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, TagWord) - 8usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::ErrorOffset"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, ErrorOffset) - 12usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::ErrorSelector"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, ErrorSelector) - 16usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::DataOffset"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, DataOffset) - 20usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::DataSelector"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, DataSelector) - 24usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::RegisterArea"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, RegisterArea) - 28usize];
    ["Offset of field: _WOW64_FLOATING_SAVE_AREA::Cr0NpxState"]
        [::std::mem::offset_of!(_WOW64_FLOATING_SAVE_AREA, Cr0NpxState) - 108usize];
};
pub type WOW64_FLOATING_SAVE_AREA = _WOW64_FLOATING_SAVE_AREA;
pub type PWOW64_FLOATING_SAVE_AREA = *mut WOW64_FLOATING_SAVE_AREA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOW64_CONTEXT {
    pub ContextFlags: DWORD,
    pub Dr0: DWORD,
    pub Dr1: DWORD,
    pub Dr2: DWORD,
    pub Dr3: DWORD,
    pub Dr6: DWORD,
    pub Dr7: DWORD,
    pub FloatSave: WOW64_FLOATING_SAVE_AREA,
    pub SegGs: DWORD,
    pub SegFs: DWORD,
    pub SegEs: DWORD,
    pub SegDs: DWORD,
    pub Edi: DWORD,
    pub Esi: DWORD,
    pub Ebx: DWORD,
    pub Edx: DWORD,
    pub Ecx: DWORD,
    pub Eax: DWORD,
    pub Ebp: DWORD,
    pub Eip: DWORD,
    pub SegCs: DWORD,
    pub EFlags: DWORD,
    pub Esp: DWORD,
    pub SegSs: DWORD,
    pub ExtendedRegisters: [BYTE; 512usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_CONTEXT"][::std::mem::size_of::<_WOW64_CONTEXT>() - 716usize];
    ["Alignment of _WOW64_CONTEXT"][::std::mem::align_of::<_WOW64_CONTEXT>() - 4usize];
    ["Offset of field: _WOW64_CONTEXT::ContextFlags"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, ContextFlags) - 0usize];
    ["Offset of field: _WOW64_CONTEXT::Dr0"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr0) - 4usize];
    ["Offset of field: _WOW64_CONTEXT::Dr1"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr1) - 8usize];
    ["Offset of field: _WOW64_CONTEXT::Dr2"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr2) - 12usize];
    ["Offset of field: _WOW64_CONTEXT::Dr3"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr3) - 16usize];
    ["Offset of field: _WOW64_CONTEXT::Dr6"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr6) - 20usize];
    ["Offset of field: _WOW64_CONTEXT::Dr7"][::std::mem::offset_of!(_WOW64_CONTEXT, Dr7) - 24usize];
    ["Offset of field: _WOW64_CONTEXT::FloatSave"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, FloatSave) - 28usize];
    ["Offset of field: _WOW64_CONTEXT::SegGs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegGs) - 140usize];
    ["Offset of field: _WOW64_CONTEXT::SegFs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegFs) - 144usize];
    ["Offset of field: _WOW64_CONTEXT::SegEs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegEs) - 148usize];
    ["Offset of field: _WOW64_CONTEXT::SegDs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegDs) - 152usize];
    ["Offset of field: _WOW64_CONTEXT::Edi"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Edi) - 156usize];
    ["Offset of field: _WOW64_CONTEXT::Esi"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Esi) - 160usize];
    ["Offset of field: _WOW64_CONTEXT::Ebx"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Ebx) - 164usize];
    ["Offset of field: _WOW64_CONTEXT::Edx"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Edx) - 168usize];
    ["Offset of field: _WOW64_CONTEXT::Ecx"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Ecx) - 172usize];
    ["Offset of field: _WOW64_CONTEXT::Eax"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Eax) - 176usize];
    ["Offset of field: _WOW64_CONTEXT::Ebp"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Ebp) - 180usize];
    ["Offset of field: _WOW64_CONTEXT::Eip"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Eip) - 184usize];
    ["Offset of field: _WOW64_CONTEXT::SegCs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegCs) - 188usize];
    ["Offset of field: _WOW64_CONTEXT::EFlags"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, EFlags) - 192usize];
    ["Offset of field: _WOW64_CONTEXT::Esp"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, Esp) - 196usize];
    ["Offset of field: _WOW64_CONTEXT::SegSs"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, SegSs) - 200usize];
    ["Offset of field: _WOW64_CONTEXT::ExtendedRegisters"]
        [::std::mem::offset_of!(_WOW64_CONTEXT, ExtendedRegisters) - 204usize];
};
pub type WOW64_CONTEXT = _WOW64_CONTEXT;
pub type PWOW64_CONTEXT = *mut WOW64_CONTEXT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WOW64_LDT_ENTRY {
    pub LimitLow: WORD,
    pub BaseLow: WORD,
    pub HighWord: _WOW64_LDT_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _WOW64_LDT_ENTRY__bindgen_ty_1 {
    pub Bytes: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1,
    pub Bits: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub BaseMid: BYTE,
    pub Flags1: BYTE,
    pub Flags2: BYTE,
    pub BaseHi: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::BaseMid"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, BaseMid) - 0usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::Flags1"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, Flags1) - 1usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::Flags2"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, Flags2) - 2usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1::BaseHi"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_1, BaseHi) - 3usize];
};
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 4usize];
};
impl _WOW64_LDT_ENTRY__bindgen_ty_1__bindgen_ty_2 {
    #[inline]
    pub fn BaseMid(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_BaseMid(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BaseMid_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BaseMid_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Type(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_Type(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Type_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Type_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Dpl(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Dpl(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Dpl_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Dpl_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Pres(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Pres(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Pres_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Pres_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn LimitHi(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_LimitHi(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn LimitHi_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_LimitHi_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Sys(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Sys(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Sys_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Sys_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved_0(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved_0(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_0_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_0_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Default_Big(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Default_Big(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(22usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Default_Big_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                22usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Default_Big_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                22usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Granularity(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Granularity(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(23usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Granularity_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                23usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Granularity_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                23usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn BaseHi(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(24usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_BaseHi(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(24usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BaseHi_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                24usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BaseHi_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                24usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        BaseMid: DWORD,
        Type: DWORD,
        Dpl: DWORD,
        Pres: DWORD,
        LimitHi: DWORD,
        Sys: DWORD,
        Reserved_0: DWORD,
        Default_Big: DWORD,
        Granularity: DWORD,
        BaseHi: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let BaseMid: u32 = unsafe { ::std::mem::transmute(BaseMid) };
            BaseMid as u64
        });
        __bindgen_bitfield_unit.set(8usize, 5u8, {
            let Type: u32 = unsafe { ::std::mem::transmute(Type) };
            Type as u64
        });
        __bindgen_bitfield_unit.set(13usize, 2u8, {
            let Dpl: u32 = unsafe { ::std::mem::transmute(Dpl) };
            Dpl as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let Pres: u32 = unsafe { ::std::mem::transmute(Pres) };
            Pres as u64
        });
        __bindgen_bitfield_unit.set(16usize, 4u8, {
            let LimitHi: u32 = unsafe { ::std::mem::transmute(LimitHi) };
            LimitHi as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let Sys: u32 = unsafe { ::std::mem::transmute(Sys) };
            Sys as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let Reserved_0: u32 = unsafe { ::std::mem::transmute(Reserved_0) };
            Reserved_0 as u64
        });
        __bindgen_bitfield_unit.set(22usize, 1u8, {
            let Default_Big: u32 = unsafe { ::std::mem::transmute(Default_Big) };
            Default_Big as u64
        });
        __bindgen_bitfield_unit.set(23usize, 1u8, {
            let Granularity: u32 = unsafe { ::std::mem::transmute(Granularity) };
            Granularity as u64
        });
        __bindgen_bitfield_unit.set(24usize, 8u8, {
            let BaseHi: u32 = unsafe { ::std::mem::transmute(BaseHi) };
            BaseHi as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_LDT_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_WOW64_LDT_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _WOW64_LDT_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_WOW64_LDT_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1::Bytes"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1, Bytes) - 0usize];
    ["Offset of field: _WOW64_LDT_ENTRY__bindgen_ty_1::Bits"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY__bindgen_ty_1, Bits) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_LDT_ENTRY"][::std::mem::size_of::<_WOW64_LDT_ENTRY>() - 8usize];
    ["Alignment of _WOW64_LDT_ENTRY"][::std::mem::align_of::<_WOW64_LDT_ENTRY>() - 4usize];
    ["Offset of field: _WOW64_LDT_ENTRY::LimitLow"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY, LimitLow) - 0usize];
    ["Offset of field: _WOW64_LDT_ENTRY::BaseLow"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY, BaseLow) - 2usize];
    ["Offset of field: _WOW64_LDT_ENTRY::HighWord"]
        [::std::mem::offset_of!(_WOW64_LDT_ENTRY, HighWord) - 4usize];
};
pub type WOW64_LDT_ENTRY = _WOW64_LDT_ENTRY;
pub type PWOW64_LDT_ENTRY = *mut _WOW64_LDT_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WOW64_DESCRIPTOR_TABLE_ENTRY {
    pub Selector: DWORD,
    pub Descriptor: WOW64_LDT_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOW64_DESCRIPTOR_TABLE_ENTRY"]
        [::std::mem::size_of::<_WOW64_DESCRIPTOR_TABLE_ENTRY>() - 12usize];
    ["Alignment of _WOW64_DESCRIPTOR_TABLE_ENTRY"]
        [::std::mem::align_of::<_WOW64_DESCRIPTOR_TABLE_ENTRY>() - 4usize];
    ["Offset of field: _WOW64_DESCRIPTOR_TABLE_ENTRY::Selector"]
        [::std::mem::offset_of!(_WOW64_DESCRIPTOR_TABLE_ENTRY, Selector) - 0usize];
    ["Offset of field: _WOW64_DESCRIPTOR_TABLE_ENTRY::Descriptor"]
        [::std::mem::offset_of!(_WOW64_DESCRIPTOR_TABLE_ENTRY, Descriptor) - 4usize];
};
pub type WOW64_DESCRIPTOR_TABLE_ENTRY = _WOW64_DESCRIPTOR_TABLE_ENTRY;
pub type PWOW64_DESCRIPTOR_TABLE_ENTRY = *mut _WOW64_DESCRIPTOR_TABLE_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_RECORD {
    pub ExceptionCode: DWORD,
    pub ExceptionFlags: DWORD,
    pub ExceptionRecord: *mut _EXCEPTION_RECORD,
    pub ExceptionAddress: PVOID,
    pub NumberParameters: DWORD,
    pub ExceptionInformation: [ULONG_PTR; 15usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_RECORD"][::std::mem::size_of::<_EXCEPTION_RECORD>() - 152usize];
    ["Alignment of _EXCEPTION_RECORD"][::std::mem::align_of::<_EXCEPTION_RECORD>() - 8usize];
    ["Offset of field: _EXCEPTION_RECORD::ExceptionCode"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, ExceptionCode) - 0usize];
    ["Offset of field: _EXCEPTION_RECORD::ExceptionFlags"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, ExceptionFlags) - 4usize];
    ["Offset of field: _EXCEPTION_RECORD::ExceptionRecord"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, ExceptionRecord) - 8usize];
    ["Offset of field: _EXCEPTION_RECORD::ExceptionAddress"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, ExceptionAddress) - 16usize];
    ["Offset of field: _EXCEPTION_RECORD::NumberParameters"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, NumberParameters) - 24usize];
    ["Offset of field: _EXCEPTION_RECORD::ExceptionInformation"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD, ExceptionInformation) - 32usize];
};
pub type EXCEPTION_RECORD = _EXCEPTION_RECORD;
pub type PEXCEPTION_RECORD = *mut EXCEPTION_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_RECORD32 {
    pub ExceptionCode: DWORD,
    pub ExceptionFlags: DWORD,
    pub ExceptionRecord: DWORD,
    pub ExceptionAddress: DWORD,
    pub NumberParameters: DWORD,
    pub ExceptionInformation: [DWORD; 15usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_RECORD32"][::std::mem::size_of::<_EXCEPTION_RECORD32>() - 80usize];
    ["Alignment of _EXCEPTION_RECORD32"][::std::mem::align_of::<_EXCEPTION_RECORD32>() - 4usize];
    ["Offset of field: _EXCEPTION_RECORD32::ExceptionCode"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, ExceptionCode) - 0usize];
    ["Offset of field: _EXCEPTION_RECORD32::ExceptionFlags"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, ExceptionFlags) - 4usize];
    ["Offset of field: _EXCEPTION_RECORD32::ExceptionRecord"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, ExceptionRecord) - 8usize];
    ["Offset of field: _EXCEPTION_RECORD32::ExceptionAddress"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, ExceptionAddress) - 12usize];
    ["Offset of field: _EXCEPTION_RECORD32::NumberParameters"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, NumberParameters) - 16usize];
    ["Offset of field: _EXCEPTION_RECORD32::ExceptionInformation"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD32, ExceptionInformation) - 20usize];
};
pub type EXCEPTION_RECORD32 = _EXCEPTION_RECORD32;
pub type PEXCEPTION_RECORD32 = *mut _EXCEPTION_RECORD32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_RECORD64 {
    pub ExceptionCode: DWORD,
    pub ExceptionFlags: DWORD,
    pub ExceptionRecord: DWORD64,
    pub ExceptionAddress: DWORD64,
    pub NumberParameters: DWORD,
    pub __unusedAlignment: DWORD,
    pub ExceptionInformation: [DWORD64; 15usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_RECORD64"][::std::mem::size_of::<_EXCEPTION_RECORD64>() - 152usize];
    ["Alignment of _EXCEPTION_RECORD64"][::std::mem::align_of::<_EXCEPTION_RECORD64>() - 8usize];
    ["Offset of field: _EXCEPTION_RECORD64::ExceptionCode"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, ExceptionCode) - 0usize];
    ["Offset of field: _EXCEPTION_RECORD64::ExceptionFlags"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, ExceptionFlags) - 4usize];
    ["Offset of field: _EXCEPTION_RECORD64::ExceptionRecord"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, ExceptionRecord) - 8usize];
    ["Offset of field: _EXCEPTION_RECORD64::ExceptionAddress"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, ExceptionAddress) - 16usize];
    ["Offset of field: _EXCEPTION_RECORD64::NumberParameters"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, NumberParameters) - 24usize];
    ["Offset of field: _EXCEPTION_RECORD64::__unusedAlignment"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, __unusedAlignment) - 28usize];
    ["Offset of field: _EXCEPTION_RECORD64::ExceptionInformation"]
        [::std::mem::offset_of!(_EXCEPTION_RECORD64, ExceptionInformation) - 32usize];
};
pub type EXCEPTION_RECORD64 = _EXCEPTION_RECORD64;
pub type PEXCEPTION_RECORD64 = *mut _EXCEPTION_RECORD64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_POINTERS {
    pub ExceptionRecord: PEXCEPTION_RECORD,
    pub ContextRecord: PCONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_POINTERS"][::std::mem::size_of::<_EXCEPTION_POINTERS>() - 16usize];
    ["Alignment of _EXCEPTION_POINTERS"][::std::mem::align_of::<_EXCEPTION_POINTERS>() - 8usize];
    ["Offset of field: _EXCEPTION_POINTERS::ExceptionRecord"]
        [::std::mem::offset_of!(_EXCEPTION_POINTERS, ExceptionRecord) - 0usize];
    ["Offset of field: _EXCEPTION_POINTERS::ContextRecord"]
        [::std::mem::offset_of!(_EXCEPTION_POINTERS, ContextRecord) - 8usize];
};
pub type EXCEPTION_POINTERS = _EXCEPTION_POINTERS;
pub type PEXCEPTION_POINTERS = *mut _EXCEPTION_POINTERS;
pub type PACCESS_TOKEN = PVOID;
pub type PSECURITY_DESCRIPTOR = PVOID;
pub type PSID = PVOID;
pub type PCLAIMS_BLOB = PVOID;
pub type ACCESS_MASK = DWORD;
pub type PACCESS_MASK = *mut ACCESS_MASK;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GENERIC_MAPPING {
    pub GenericRead: ACCESS_MASK,
    pub GenericWrite: ACCESS_MASK,
    pub GenericExecute: ACCESS_MASK,
    pub GenericAll: ACCESS_MASK,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GENERIC_MAPPING"][::std::mem::size_of::<_GENERIC_MAPPING>() - 16usize];
    ["Alignment of _GENERIC_MAPPING"][::std::mem::align_of::<_GENERIC_MAPPING>() - 4usize];
    ["Offset of field: _GENERIC_MAPPING::GenericRead"]
        [::std::mem::offset_of!(_GENERIC_MAPPING, GenericRead) - 0usize];
    ["Offset of field: _GENERIC_MAPPING::GenericWrite"]
        [::std::mem::offset_of!(_GENERIC_MAPPING, GenericWrite) - 4usize];
    ["Offset of field: _GENERIC_MAPPING::GenericExecute"]
        [::std::mem::offset_of!(_GENERIC_MAPPING, GenericExecute) - 8usize];
    ["Offset of field: _GENERIC_MAPPING::GenericAll"]
        [::std::mem::offset_of!(_GENERIC_MAPPING, GenericAll) - 12usize];
};
pub type GENERIC_MAPPING = _GENERIC_MAPPING;
pub type PGENERIC_MAPPING = *mut GENERIC_MAPPING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LUID_AND_ATTRIBUTES {
    pub Luid: LUID,
    pub Attributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LUID_AND_ATTRIBUTES"][::std::mem::size_of::<_LUID_AND_ATTRIBUTES>() - 12usize];
    ["Alignment of _LUID_AND_ATTRIBUTES"][::std::mem::align_of::<_LUID_AND_ATTRIBUTES>() - 4usize];
    ["Offset of field: _LUID_AND_ATTRIBUTES::Luid"]
        [::std::mem::offset_of!(_LUID_AND_ATTRIBUTES, Luid) - 0usize];
    ["Offset of field: _LUID_AND_ATTRIBUTES::Attributes"]
        [::std::mem::offset_of!(_LUID_AND_ATTRIBUTES, Attributes) - 8usize];
};
pub type LUID_AND_ATTRIBUTES = _LUID_AND_ATTRIBUTES;
pub type PLUID_AND_ATTRIBUTES = *mut _LUID_AND_ATTRIBUTES;
pub type LUID_AND_ATTRIBUTES_ARRAY = [LUID_AND_ATTRIBUTES; 1usize];
pub type PLUID_AND_ATTRIBUTES_ARRAY = *mut LUID_AND_ATTRIBUTES_ARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SID_IDENTIFIER_AUTHORITY {
    pub Value: [BYTE; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SID_IDENTIFIER_AUTHORITY"]
        [::std::mem::size_of::<_SID_IDENTIFIER_AUTHORITY>() - 6usize];
    ["Alignment of _SID_IDENTIFIER_AUTHORITY"]
        [::std::mem::align_of::<_SID_IDENTIFIER_AUTHORITY>() - 1usize];
    ["Offset of field: _SID_IDENTIFIER_AUTHORITY::Value"]
        [::std::mem::offset_of!(_SID_IDENTIFIER_AUTHORITY, Value) - 0usize];
};
pub type SID_IDENTIFIER_AUTHORITY = _SID_IDENTIFIER_AUTHORITY;
pub type PSID_IDENTIFIER_AUTHORITY = *mut _SID_IDENTIFIER_AUTHORITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SID {
    pub Revision: BYTE,
    pub SubAuthorityCount: BYTE,
    pub IdentifierAuthority: SID_IDENTIFIER_AUTHORITY,
    pub SubAuthority: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SID"][::std::mem::size_of::<_SID>() - 12usize];
    ["Alignment of _SID"][::std::mem::align_of::<_SID>() - 4usize];
    ["Offset of field: _SID::Revision"][::std::mem::offset_of!(_SID, Revision) - 0usize];
    ["Offset of field: _SID::SubAuthorityCount"]
        [::std::mem::offset_of!(_SID, SubAuthorityCount) - 1usize];
    ["Offset of field: _SID::IdentifierAuthority"]
        [::std::mem::offset_of!(_SID, IdentifierAuthority) - 2usize];
    ["Offset of field: _SID::SubAuthority"][::std::mem::offset_of!(_SID, SubAuthority) - 8usize];
};
pub type SID = _SID;
pub type PISID = *mut _SID;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SE_SID {
    pub Sid: SID,
    pub Buffer: [BYTE; 68usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_SID"][::std::mem::size_of::<_SE_SID>() - 68usize];
    ["Alignment of _SE_SID"][::std::mem::align_of::<_SE_SID>() - 4usize];
    ["Offset of field: _SE_SID::Sid"][::std::mem::offset_of!(_SE_SID, Sid) - 0usize];
    ["Offset of field: _SE_SID::Buffer"][::std::mem::offset_of!(_SE_SID, Buffer) - 0usize];
};
pub type SE_SID = _SE_SID;
pub type PSE_SID = *mut _SE_SID;
pub const _SID_NAME_USE_SidTypeUser: _SID_NAME_USE = 1;
pub const _SID_NAME_USE_SidTypeGroup: _SID_NAME_USE = 2;
pub const _SID_NAME_USE_SidTypeDomain: _SID_NAME_USE = 3;
pub const _SID_NAME_USE_SidTypeAlias: _SID_NAME_USE = 4;
pub const _SID_NAME_USE_SidTypeWellKnownGroup: _SID_NAME_USE = 5;
pub const _SID_NAME_USE_SidTypeDeletedAccount: _SID_NAME_USE = 6;
pub const _SID_NAME_USE_SidTypeInvalid: _SID_NAME_USE = 7;
pub const _SID_NAME_USE_SidTypeUnknown: _SID_NAME_USE = 8;
pub const _SID_NAME_USE_SidTypeComputer: _SID_NAME_USE = 9;
pub const _SID_NAME_USE_SidTypeLabel: _SID_NAME_USE = 10;
pub const _SID_NAME_USE_SidTypeLogonSession: _SID_NAME_USE = 11;
pub type _SID_NAME_USE = ::std::os::raw::c_int;
pub use self::_SID_NAME_USE as SID_NAME_USE;
pub type PSID_NAME_USE = *mut _SID_NAME_USE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SID_AND_ATTRIBUTES {
    pub Sid: PSID,
    pub Attributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SID_AND_ATTRIBUTES"][::std::mem::size_of::<_SID_AND_ATTRIBUTES>() - 16usize];
    ["Alignment of _SID_AND_ATTRIBUTES"][::std::mem::align_of::<_SID_AND_ATTRIBUTES>() - 8usize];
    ["Offset of field: _SID_AND_ATTRIBUTES::Sid"]
        [::std::mem::offset_of!(_SID_AND_ATTRIBUTES, Sid) - 0usize];
    ["Offset of field: _SID_AND_ATTRIBUTES::Attributes"]
        [::std::mem::offset_of!(_SID_AND_ATTRIBUTES, Attributes) - 8usize];
};
pub type SID_AND_ATTRIBUTES = _SID_AND_ATTRIBUTES;
pub type PSID_AND_ATTRIBUTES = *mut _SID_AND_ATTRIBUTES;
pub type SID_AND_ATTRIBUTES_ARRAY = [SID_AND_ATTRIBUTES; 1usize];
pub type PSID_AND_ATTRIBUTES_ARRAY = *mut SID_AND_ATTRIBUTES_ARRAY;
pub type SID_HASH_ENTRY = ULONG_PTR;
pub type PSID_HASH_ENTRY = *mut ULONG_PTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SID_AND_ATTRIBUTES_HASH {
    pub SidCount: DWORD,
    pub SidAttr: PSID_AND_ATTRIBUTES,
    pub Hash: [SID_HASH_ENTRY; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SID_AND_ATTRIBUTES_HASH"]
        [::std::mem::size_of::<_SID_AND_ATTRIBUTES_HASH>() - 272usize];
    ["Alignment of _SID_AND_ATTRIBUTES_HASH"]
        [::std::mem::align_of::<_SID_AND_ATTRIBUTES_HASH>() - 8usize];
    ["Offset of field: _SID_AND_ATTRIBUTES_HASH::SidCount"]
        [::std::mem::offset_of!(_SID_AND_ATTRIBUTES_HASH, SidCount) - 0usize];
    ["Offset of field: _SID_AND_ATTRIBUTES_HASH::SidAttr"]
        [::std::mem::offset_of!(_SID_AND_ATTRIBUTES_HASH, SidAttr) - 8usize];
    ["Offset of field: _SID_AND_ATTRIBUTES_HASH::Hash"]
        [::std::mem::offset_of!(_SID_AND_ATTRIBUTES_HASH, Hash) - 16usize];
};
pub type SID_AND_ATTRIBUTES_HASH = _SID_AND_ATTRIBUTES_HASH;
pub type PSID_AND_ATTRIBUTES_HASH = *mut _SID_AND_ATTRIBUTES_HASH;
pub const WELL_KNOWN_SID_TYPE_WinNullSid: WELL_KNOWN_SID_TYPE = 0;
pub const WELL_KNOWN_SID_TYPE_WinWorldSid: WELL_KNOWN_SID_TYPE = 1;
pub const WELL_KNOWN_SID_TYPE_WinLocalSid: WELL_KNOWN_SID_TYPE = 2;
pub const WELL_KNOWN_SID_TYPE_WinCreatorOwnerSid: WELL_KNOWN_SID_TYPE = 3;
pub const WELL_KNOWN_SID_TYPE_WinCreatorGroupSid: WELL_KNOWN_SID_TYPE = 4;
pub const WELL_KNOWN_SID_TYPE_WinCreatorOwnerServerSid: WELL_KNOWN_SID_TYPE = 5;
pub const WELL_KNOWN_SID_TYPE_WinCreatorGroupServerSid: WELL_KNOWN_SID_TYPE = 6;
pub const WELL_KNOWN_SID_TYPE_WinNtAuthoritySid: WELL_KNOWN_SID_TYPE = 7;
pub const WELL_KNOWN_SID_TYPE_WinDialupSid: WELL_KNOWN_SID_TYPE = 8;
pub const WELL_KNOWN_SID_TYPE_WinNetworkSid: WELL_KNOWN_SID_TYPE = 9;
pub const WELL_KNOWN_SID_TYPE_WinBatchSid: WELL_KNOWN_SID_TYPE = 10;
pub const WELL_KNOWN_SID_TYPE_WinInteractiveSid: WELL_KNOWN_SID_TYPE = 11;
pub const WELL_KNOWN_SID_TYPE_WinServiceSid: WELL_KNOWN_SID_TYPE = 12;
pub const WELL_KNOWN_SID_TYPE_WinAnonymousSid: WELL_KNOWN_SID_TYPE = 13;
pub const WELL_KNOWN_SID_TYPE_WinProxySid: WELL_KNOWN_SID_TYPE = 14;
pub const WELL_KNOWN_SID_TYPE_WinEnterpriseControllersSid: WELL_KNOWN_SID_TYPE = 15;
pub const WELL_KNOWN_SID_TYPE_WinSelfSid: WELL_KNOWN_SID_TYPE = 16;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticatedUserSid: WELL_KNOWN_SID_TYPE = 17;
pub const WELL_KNOWN_SID_TYPE_WinRestrictedCodeSid: WELL_KNOWN_SID_TYPE = 18;
pub const WELL_KNOWN_SID_TYPE_WinTerminalServerSid: WELL_KNOWN_SID_TYPE = 19;
pub const WELL_KNOWN_SID_TYPE_WinRemoteLogonIdSid: WELL_KNOWN_SID_TYPE = 20;
pub const WELL_KNOWN_SID_TYPE_WinLogonIdsSid: WELL_KNOWN_SID_TYPE = 21;
pub const WELL_KNOWN_SID_TYPE_WinLocalSystemSid: WELL_KNOWN_SID_TYPE = 22;
pub const WELL_KNOWN_SID_TYPE_WinLocalServiceSid: WELL_KNOWN_SID_TYPE = 23;
pub const WELL_KNOWN_SID_TYPE_WinNetworkServiceSid: WELL_KNOWN_SID_TYPE = 24;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinDomainSid: WELL_KNOWN_SID_TYPE = 25;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinAdministratorsSid: WELL_KNOWN_SID_TYPE = 26;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinUsersSid: WELL_KNOWN_SID_TYPE = 27;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinGuestsSid: WELL_KNOWN_SID_TYPE = 28;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinPowerUsersSid: WELL_KNOWN_SID_TYPE = 29;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinAccountOperatorsSid: WELL_KNOWN_SID_TYPE = 30;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinSystemOperatorsSid: WELL_KNOWN_SID_TYPE = 31;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinPrintOperatorsSid: WELL_KNOWN_SID_TYPE = 32;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinBackupOperatorsSid: WELL_KNOWN_SID_TYPE = 33;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinReplicatorSid: WELL_KNOWN_SID_TYPE = 34;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinPreWindows2000CompatibleAccessSid: WELL_KNOWN_SID_TYPE = 35;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinRemoteDesktopUsersSid: WELL_KNOWN_SID_TYPE = 36;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinNetworkConfigurationOperatorsSid: WELL_KNOWN_SID_TYPE = 37;
pub const WELL_KNOWN_SID_TYPE_WinAccountAdministratorSid: WELL_KNOWN_SID_TYPE = 38;
pub const WELL_KNOWN_SID_TYPE_WinAccountGuestSid: WELL_KNOWN_SID_TYPE = 39;
pub const WELL_KNOWN_SID_TYPE_WinAccountKrbtgtSid: WELL_KNOWN_SID_TYPE = 40;
pub const WELL_KNOWN_SID_TYPE_WinAccountDomainAdminsSid: WELL_KNOWN_SID_TYPE = 41;
pub const WELL_KNOWN_SID_TYPE_WinAccountDomainUsersSid: WELL_KNOWN_SID_TYPE = 42;
pub const WELL_KNOWN_SID_TYPE_WinAccountDomainGuestsSid: WELL_KNOWN_SID_TYPE = 43;
pub const WELL_KNOWN_SID_TYPE_WinAccountComputersSid: WELL_KNOWN_SID_TYPE = 44;
pub const WELL_KNOWN_SID_TYPE_WinAccountControllersSid: WELL_KNOWN_SID_TYPE = 45;
pub const WELL_KNOWN_SID_TYPE_WinAccountCertAdminsSid: WELL_KNOWN_SID_TYPE = 46;
pub const WELL_KNOWN_SID_TYPE_WinAccountSchemaAdminsSid: WELL_KNOWN_SID_TYPE = 47;
pub const WELL_KNOWN_SID_TYPE_WinAccountEnterpriseAdminsSid: WELL_KNOWN_SID_TYPE = 48;
pub const WELL_KNOWN_SID_TYPE_WinAccountPolicyAdminsSid: WELL_KNOWN_SID_TYPE = 49;
pub const WELL_KNOWN_SID_TYPE_WinAccountRasAndIasServersSid: WELL_KNOWN_SID_TYPE = 50;
pub const WELL_KNOWN_SID_TYPE_WinNTLMAuthenticationSid: WELL_KNOWN_SID_TYPE = 51;
pub const WELL_KNOWN_SID_TYPE_WinDigestAuthenticationSid: WELL_KNOWN_SID_TYPE = 52;
pub const WELL_KNOWN_SID_TYPE_WinSChannelAuthenticationSid: WELL_KNOWN_SID_TYPE = 53;
pub const WELL_KNOWN_SID_TYPE_WinThisOrganizationSid: WELL_KNOWN_SID_TYPE = 54;
pub const WELL_KNOWN_SID_TYPE_WinOtherOrganizationSid: WELL_KNOWN_SID_TYPE = 55;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinIncomingForestTrustBuildersSid: WELL_KNOWN_SID_TYPE = 56;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinPerfMonitoringUsersSid: WELL_KNOWN_SID_TYPE = 57;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinPerfLoggingUsersSid: WELL_KNOWN_SID_TYPE = 58;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinAuthorizationAccessSid: WELL_KNOWN_SID_TYPE = 59;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinTerminalServerLicenseServersSid: WELL_KNOWN_SID_TYPE = 60;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinDCOMUsersSid: WELL_KNOWN_SID_TYPE = 61;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinIUsersSid: WELL_KNOWN_SID_TYPE = 62;
pub const WELL_KNOWN_SID_TYPE_WinIUserSid: WELL_KNOWN_SID_TYPE = 63;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinCryptoOperatorsSid: WELL_KNOWN_SID_TYPE = 64;
pub const WELL_KNOWN_SID_TYPE_WinUntrustedLabelSid: WELL_KNOWN_SID_TYPE = 65;
pub const WELL_KNOWN_SID_TYPE_WinLowLabelSid: WELL_KNOWN_SID_TYPE = 66;
pub const WELL_KNOWN_SID_TYPE_WinMediumLabelSid: WELL_KNOWN_SID_TYPE = 67;
pub const WELL_KNOWN_SID_TYPE_WinHighLabelSid: WELL_KNOWN_SID_TYPE = 68;
pub const WELL_KNOWN_SID_TYPE_WinSystemLabelSid: WELL_KNOWN_SID_TYPE = 69;
pub const WELL_KNOWN_SID_TYPE_WinWriteRestrictedCodeSid: WELL_KNOWN_SID_TYPE = 70;
pub const WELL_KNOWN_SID_TYPE_WinCreatorOwnerRightsSid: WELL_KNOWN_SID_TYPE = 71;
pub const WELL_KNOWN_SID_TYPE_WinCacheablePrincipalsGroupSid: WELL_KNOWN_SID_TYPE = 72;
pub const WELL_KNOWN_SID_TYPE_WinNonCacheablePrincipalsGroupSid: WELL_KNOWN_SID_TYPE = 73;
pub const WELL_KNOWN_SID_TYPE_WinEnterpriseReadonlyControllersSid: WELL_KNOWN_SID_TYPE = 74;
pub const WELL_KNOWN_SID_TYPE_WinAccountReadonlyControllersSid: WELL_KNOWN_SID_TYPE = 75;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinEventLogReadersGroup: WELL_KNOWN_SID_TYPE = 76;
pub const WELL_KNOWN_SID_TYPE_WinNewEnterpriseReadonlyControllersSid: WELL_KNOWN_SID_TYPE = 77;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinCertSvcDComAccessGroup: WELL_KNOWN_SID_TYPE = 78;
pub const WELL_KNOWN_SID_TYPE_WinMediumPlusLabelSid: WELL_KNOWN_SID_TYPE = 79;
pub const WELL_KNOWN_SID_TYPE_WinLocalLogonSid: WELL_KNOWN_SID_TYPE = 80;
pub const WELL_KNOWN_SID_TYPE_WinConsoleLogonSid: WELL_KNOWN_SID_TYPE = 81;
pub const WELL_KNOWN_SID_TYPE_WinThisOrganizationCertificateSid: WELL_KNOWN_SID_TYPE = 82;
pub const WELL_KNOWN_SID_TYPE_WinApplicationPackageAuthoritySid: WELL_KNOWN_SID_TYPE = 83;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinAnyPackageSid: WELL_KNOWN_SID_TYPE = 84;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityInternetClientSid: WELL_KNOWN_SID_TYPE = 85;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityInternetClientServerSid: WELL_KNOWN_SID_TYPE = 86;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityPrivateNetworkClientServerSid: WELL_KNOWN_SID_TYPE = 87;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityPicturesLibrarySid: WELL_KNOWN_SID_TYPE = 88;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityVideosLibrarySid: WELL_KNOWN_SID_TYPE = 89;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityMusicLibrarySid: WELL_KNOWN_SID_TYPE = 90;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityDocumentsLibrarySid: WELL_KNOWN_SID_TYPE = 91;
pub const WELL_KNOWN_SID_TYPE_WinCapabilitySharedUserCertificatesSid: WELL_KNOWN_SID_TYPE = 92;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityEnterpriseAuthenticationSid: WELL_KNOWN_SID_TYPE = 93;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityRemovableStorageSid: WELL_KNOWN_SID_TYPE = 94;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinRDSRemoteAccessServersSid: WELL_KNOWN_SID_TYPE = 95;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinRDSEndpointServersSid: WELL_KNOWN_SID_TYPE = 96;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinRDSManagementServersSid: WELL_KNOWN_SID_TYPE = 97;
pub const WELL_KNOWN_SID_TYPE_WinUserModeDriversSid: WELL_KNOWN_SID_TYPE = 98;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinHyperVAdminsSid: WELL_KNOWN_SID_TYPE = 99;
pub const WELL_KNOWN_SID_TYPE_WinAccountCloneableControllersSid: WELL_KNOWN_SID_TYPE = 100;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinAccessControlAssistanceOperatorsSid: WELL_KNOWN_SID_TYPE =
    101;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinRemoteManagementUsersSid: WELL_KNOWN_SID_TYPE = 102;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationAuthorityAssertedSid: WELL_KNOWN_SID_TYPE = 103;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationServiceAssertedSid: WELL_KNOWN_SID_TYPE = 104;
pub const WELL_KNOWN_SID_TYPE_WinLocalAccountSid: WELL_KNOWN_SID_TYPE = 105;
pub const WELL_KNOWN_SID_TYPE_WinLocalAccountAndAdministratorSid: WELL_KNOWN_SID_TYPE = 106;
pub const WELL_KNOWN_SID_TYPE_WinAccountProtectedUsersSid: WELL_KNOWN_SID_TYPE = 107;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityAppointmentsSid: WELL_KNOWN_SID_TYPE = 108;
pub const WELL_KNOWN_SID_TYPE_WinCapabilityContactsSid: WELL_KNOWN_SID_TYPE = 109;
pub const WELL_KNOWN_SID_TYPE_WinAccountDefaultSystemManagedSid: WELL_KNOWN_SID_TYPE = 110;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinDefaultSystemManagedGroupSid: WELL_KNOWN_SID_TYPE = 111;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinStorageReplicaAdminsSid: WELL_KNOWN_SID_TYPE = 112;
pub const WELL_KNOWN_SID_TYPE_WinAccountKeyAdminsSid: WELL_KNOWN_SID_TYPE = 113;
pub const WELL_KNOWN_SID_TYPE_WinAccountEnterpriseKeyAdminsSid: WELL_KNOWN_SID_TYPE = 114;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationKeyTrustSid: WELL_KNOWN_SID_TYPE = 115;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationKeyPropertyMFASid: WELL_KNOWN_SID_TYPE = 116;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationKeyPropertyAttestationSid: WELL_KNOWN_SID_TYPE = 117;
pub const WELL_KNOWN_SID_TYPE_WinAuthenticationFreshKeyAuthSid: WELL_KNOWN_SID_TYPE = 118;
pub const WELL_KNOWN_SID_TYPE_WinBuiltinDeviceOwnersSid: WELL_KNOWN_SID_TYPE = 119;
pub type WELL_KNOWN_SID_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACL {
    pub AclRevision: BYTE,
    pub Sbz1: BYTE,
    pub AclSize: WORD,
    pub AceCount: WORD,
    pub Sbz2: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACL"][::std::mem::size_of::<_ACL>() - 8usize];
    ["Alignment of _ACL"][::std::mem::align_of::<_ACL>() - 2usize];
    ["Offset of field: _ACL::AclRevision"][::std::mem::offset_of!(_ACL, AclRevision) - 0usize];
    ["Offset of field: _ACL::Sbz1"][::std::mem::offset_of!(_ACL, Sbz1) - 1usize];
    ["Offset of field: _ACL::AclSize"][::std::mem::offset_of!(_ACL, AclSize) - 2usize];
    ["Offset of field: _ACL::AceCount"][::std::mem::offset_of!(_ACL, AceCount) - 4usize];
    ["Offset of field: _ACL::Sbz2"][::std::mem::offset_of!(_ACL, Sbz2) - 6usize];
};
pub type ACL = _ACL;
pub type PACL = *mut ACL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACE_HEADER {
    pub AceType: BYTE,
    pub AceFlags: BYTE,
    pub AceSize: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACE_HEADER"][::std::mem::size_of::<_ACE_HEADER>() - 4usize];
    ["Alignment of _ACE_HEADER"][::std::mem::align_of::<_ACE_HEADER>() - 2usize];
    ["Offset of field: _ACE_HEADER::AceType"]
        [::std::mem::offset_of!(_ACE_HEADER, AceType) - 0usize];
    ["Offset of field: _ACE_HEADER::AceFlags"]
        [::std::mem::offset_of!(_ACE_HEADER, AceFlags) - 1usize];
    ["Offset of field: _ACE_HEADER::AceSize"]
        [::std::mem::offset_of!(_ACE_HEADER, AceSize) - 2usize];
};
pub type ACE_HEADER = _ACE_HEADER;
pub type PACE_HEADER = *mut ACE_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_ALLOWED_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_ALLOWED_ACE"][::std::mem::size_of::<_ACCESS_ALLOWED_ACE>() - 12usize];
    ["Alignment of _ACCESS_ALLOWED_ACE"][::std::mem::align_of::<_ACCESS_ALLOWED_ACE>() - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_ALLOWED_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_ACE, SidStart) - 8usize];
};
pub type ACCESS_ALLOWED_ACE = _ACCESS_ALLOWED_ACE;
pub type PACCESS_ALLOWED_ACE = *mut ACCESS_ALLOWED_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_DENIED_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_DENIED_ACE"][::std::mem::size_of::<_ACCESS_DENIED_ACE>() - 12usize];
    ["Alignment of _ACCESS_DENIED_ACE"][::std::mem::align_of::<_ACCESS_DENIED_ACE>() - 4usize];
    ["Offset of field: _ACCESS_DENIED_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_DENIED_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_DENIED_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_DENIED_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_DENIED_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_DENIED_ACE, SidStart) - 8usize];
};
pub type ACCESS_DENIED_ACE = _ACCESS_DENIED_ACE;
pub type PACCESS_DENIED_ACE = *mut ACCESS_DENIED_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_AUDIT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_AUDIT_ACE"][::std::mem::size_of::<_SYSTEM_AUDIT_ACE>() - 12usize];
    ["Alignment of _SYSTEM_AUDIT_ACE"][::std::mem::align_of::<_SYSTEM_AUDIT_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_AUDIT_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_ACE, SidStart) - 8usize];
};
pub type SYSTEM_AUDIT_ACE = _SYSTEM_AUDIT_ACE;
pub type PSYSTEM_AUDIT_ACE = *mut SYSTEM_AUDIT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_ALARM_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_ALARM_ACE"][::std::mem::size_of::<_SYSTEM_ALARM_ACE>() - 12usize];
    ["Alignment of _SYSTEM_ALARM_ACE"][::std::mem::align_of::<_SYSTEM_ALARM_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_ALARM_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_ALARM_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_ALARM_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_ACE, SidStart) - 8usize];
};
pub type SYSTEM_ALARM_ACE = _SYSTEM_ALARM_ACE;
pub type PSYSTEM_ALARM_ACE = *mut SYSTEM_ALARM_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_RESOURCE_ATTRIBUTE_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_RESOURCE_ATTRIBUTE_ACE"]
        [::std::mem::size_of::<_SYSTEM_RESOURCE_ATTRIBUTE_ACE>() - 12usize];
    ["Alignment of _SYSTEM_RESOURCE_ATTRIBUTE_ACE"]
        [::std::mem::align_of::<_SYSTEM_RESOURCE_ATTRIBUTE_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_RESOURCE_ATTRIBUTE_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_RESOURCE_ATTRIBUTE_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_RESOURCE_ATTRIBUTE_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_RESOURCE_ATTRIBUTE_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_RESOURCE_ATTRIBUTE_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_RESOURCE_ATTRIBUTE_ACE, SidStart) - 8usize];
};
pub type SYSTEM_RESOURCE_ATTRIBUTE_ACE = _SYSTEM_RESOURCE_ATTRIBUTE_ACE;
pub type PSYSTEM_RESOURCE_ATTRIBUTE_ACE = *mut _SYSTEM_RESOURCE_ATTRIBUTE_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_SCOPED_POLICY_ID_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_SCOPED_POLICY_ID_ACE"]
        [::std::mem::size_of::<_SYSTEM_SCOPED_POLICY_ID_ACE>() - 12usize];
    ["Alignment of _SYSTEM_SCOPED_POLICY_ID_ACE"]
        [::std::mem::align_of::<_SYSTEM_SCOPED_POLICY_ID_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_SCOPED_POLICY_ID_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_SCOPED_POLICY_ID_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_SCOPED_POLICY_ID_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_SCOPED_POLICY_ID_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_SCOPED_POLICY_ID_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_SCOPED_POLICY_ID_ACE, SidStart) - 8usize];
};
pub type SYSTEM_SCOPED_POLICY_ID_ACE = _SYSTEM_SCOPED_POLICY_ID_ACE;
pub type PSYSTEM_SCOPED_POLICY_ID_ACE = *mut _SYSTEM_SCOPED_POLICY_ID_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_MANDATORY_LABEL_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_MANDATORY_LABEL_ACE"]
        [::std::mem::size_of::<_SYSTEM_MANDATORY_LABEL_ACE>() - 12usize];
    ["Alignment of _SYSTEM_MANDATORY_LABEL_ACE"]
        [::std::mem::align_of::<_SYSTEM_MANDATORY_LABEL_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_MANDATORY_LABEL_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_MANDATORY_LABEL_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_MANDATORY_LABEL_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_MANDATORY_LABEL_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_MANDATORY_LABEL_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_MANDATORY_LABEL_ACE, SidStart) - 8usize];
};
pub type SYSTEM_MANDATORY_LABEL_ACE = _SYSTEM_MANDATORY_LABEL_ACE;
pub type PSYSTEM_MANDATORY_LABEL_ACE = *mut _SYSTEM_MANDATORY_LABEL_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_PROCESS_TRUST_LABEL_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_PROCESS_TRUST_LABEL_ACE"]
        [::std::mem::size_of::<_SYSTEM_PROCESS_TRUST_LABEL_ACE>() - 12usize];
    ["Alignment of _SYSTEM_PROCESS_TRUST_LABEL_ACE"]
        [::std::mem::align_of::<_SYSTEM_PROCESS_TRUST_LABEL_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_PROCESS_TRUST_LABEL_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_PROCESS_TRUST_LABEL_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_PROCESS_TRUST_LABEL_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_PROCESS_TRUST_LABEL_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_PROCESS_TRUST_LABEL_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_PROCESS_TRUST_LABEL_ACE, SidStart) - 8usize];
};
pub type SYSTEM_PROCESS_TRUST_LABEL_ACE = _SYSTEM_PROCESS_TRUST_LABEL_ACE;
pub type PSYSTEM_PROCESS_TRUST_LABEL_ACE = *mut _SYSTEM_PROCESS_TRUST_LABEL_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_ACCESS_FILTER_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_ACCESS_FILTER_ACE"]
        [::std::mem::size_of::<_SYSTEM_ACCESS_FILTER_ACE>() - 12usize];
    ["Alignment of _SYSTEM_ACCESS_FILTER_ACE"]
        [::std::mem::align_of::<_SYSTEM_ACCESS_FILTER_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_ACCESS_FILTER_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_ACCESS_FILTER_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_ACCESS_FILTER_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_ACCESS_FILTER_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_ACCESS_FILTER_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_ACCESS_FILTER_ACE, SidStart) - 8usize];
};
pub type SYSTEM_ACCESS_FILTER_ACE = _SYSTEM_ACCESS_FILTER_ACE;
pub type PSYSTEM_ACCESS_FILTER_ACE = *mut _SYSTEM_ACCESS_FILTER_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_ALLOWED_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_ALLOWED_OBJECT_ACE"]
        [::std::mem::size_of::<_ACCESS_ALLOWED_OBJECT_ACE>() - 48usize];
    ["Alignment of _ACCESS_ALLOWED_OBJECT_ACE"]
        [::std::mem::align_of::<_ACCESS_ALLOWED_OBJECT_ACE>() - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _ACCESS_ALLOWED_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_OBJECT_ACE, SidStart) - 44usize];
};
pub type ACCESS_ALLOWED_OBJECT_ACE = _ACCESS_ALLOWED_OBJECT_ACE;
pub type PACCESS_ALLOWED_OBJECT_ACE = *mut _ACCESS_ALLOWED_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_DENIED_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_DENIED_OBJECT_ACE"]
        [::std::mem::size_of::<_ACCESS_DENIED_OBJECT_ACE>() - 48usize];
    ["Alignment of _ACCESS_DENIED_OBJECT_ACE"]
        [::std::mem::align_of::<_ACCESS_DENIED_OBJECT_ACE>() - 4usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _ACCESS_DENIED_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_DENIED_OBJECT_ACE, SidStart) - 44usize];
};
pub type ACCESS_DENIED_OBJECT_ACE = _ACCESS_DENIED_OBJECT_ACE;
pub type PACCESS_DENIED_OBJECT_ACE = *mut _ACCESS_DENIED_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_AUDIT_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_AUDIT_OBJECT_ACE"]
        [::std::mem::size_of::<_SYSTEM_AUDIT_OBJECT_ACE>() - 48usize];
    ["Alignment of _SYSTEM_AUDIT_OBJECT_ACE"]
        [::std::mem::align_of::<_SYSTEM_AUDIT_OBJECT_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _SYSTEM_AUDIT_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_OBJECT_ACE, SidStart) - 44usize];
};
pub type SYSTEM_AUDIT_OBJECT_ACE = _SYSTEM_AUDIT_OBJECT_ACE;
pub type PSYSTEM_AUDIT_OBJECT_ACE = *mut _SYSTEM_AUDIT_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_ALARM_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_ALARM_OBJECT_ACE"]
        [::std::mem::size_of::<_SYSTEM_ALARM_OBJECT_ACE>() - 48usize];
    ["Alignment of _SYSTEM_ALARM_OBJECT_ACE"]
        [::std::mem::align_of::<_SYSTEM_ALARM_OBJECT_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _SYSTEM_ALARM_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_OBJECT_ACE, SidStart) - 44usize];
};
pub type SYSTEM_ALARM_OBJECT_ACE = _SYSTEM_ALARM_OBJECT_ACE;
pub type PSYSTEM_ALARM_OBJECT_ACE = *mut _SYSTEM_ALARM_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_ALLOWED_CALLBACK_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_ALLOWED_CALLBACK_ACE"]
        [::std::mem::size_of::<_ACCESS_ALLOWED_CALLBACK_ACE>() - 12usize];
    ["Alignment of _ACCESS_ALLOWED_CALLBACK_ACE"]
        [::std::mem::align_of::<_ACCESS_ALLOWED_CALLBACK_ACE>() - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_ACE, SidStart) - 8usize];
};
pub type ACCESS_ALLOWED_CALLBACK_ACE = _ACCESS_ALLOWED_CALLBACK_ACE;
pub type PACCESS_ALLOWED_CALLBACK_ACE = *mut _ACCESS_ALLOWED_CALLBACK_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_DENIED_CALLBACK_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_DENIED_CALLBACK_ACE"]
        [::std::mem::size_of::<_ACCESS_DENIED_CALLBACK_ACE>() - 12usize];
    ["Alignment of _ACCESS_DENIED_CALLBACK_ACE"]
        [::std::mem::align_of::<_ACCESS_DENIED_CALLBACK_ACE>() - 4usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_ACE, SidStart) - 8usize];
};
pub type ACCESS_DENIED_CALLBACK_ACE = _ACCESS_DENIED_CALLBACK_ACE;
pub type PACCESS_DENIED_CALLBACK_ACE = *mut _ACCESS_DENIED_CALLBACK_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_AUDIT_CALLBACK_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_AUDIT_CALLBACK_ACE"]
        [::std::mem::size_of::<_SYSTEM_AUDIT_CALLBACK_ACE>() - 12usize];
    ["Alignment of _SYSTEM_AUDIT_CALLBACK_ACE"]
        [::std::mem::align_of::<_SYSTEM_AUDIT_CALLBACK_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_ACE, SidStart) - 8usize];
};
pub type SYSTEM_AUDIT_CALLBACK_ACE = _SYSTEM_AUDIT_CALLBACK_ACE;
pub type PSYSTEM_AUDIT_CALLBACK_ACE = *mut _SYSTEM_AUDIT_CALLBACK_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_ALARM_CALLBACK_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_ALARM_CALLBACK_ACE"]
        [::std::mem::size_of::<_SYSTEM_ALARM_CALLBACK_ACE>() - 12usize];
    ["Alignment of _SYSTEM_ALARM_CALLBACK_ACE"]
        [::std::mem::align_of::<_SYSTEM_ALARM_CALLBACK_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_ACE, SidStart) - 8usize];
};
pub type SYSTEM_ALARM_CALLBACK_ACE = _SYSTEM_ALARM_CALLBACK_ACE;
pub type PSYSTEM_ALARM_CALLBACK_ACE = *mut _SYSTEM_ALARM_CALLBACK_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE"]
        [::std::mem::size_of::<_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE>() - 48usize];
    ["Alignment of _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE"]
        [::std::mem::align_of::<_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE>() - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::InheritedObjectType"][::std::mem::offset_of!(
        _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE,
        InheritedObjectType
    ) - 28usize];
    ["Offset of field: _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_ALLOWED_CALLBACK_OBJECT_ACE, SidStart) - 44usize];
};
pub type ACCESS_ALLOWED_CALLBACK_OBJECT_ACE = _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE;
pub type PACCESS_ALLOWED_CALLBACK_OBJECT_ACE = *mut _ACCESS_ALLOWED_CALLBACK_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_DENIED_CALLBACK_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_DENIED_CALLBACK_OBJECT_ACE"]
        [::std::mem::size_of::<_ACCESS_DENIED_CALLBACK_OBJECT_ACE>() - 48usize];
    ["Alignment of _ACCESS_DENIED_CALLBACK_OBJECT_ACE"]
        [::std::mem::align_of::<_ACCESS_DENIED_CALLBACK_OBJECT_ACE>() - 4usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _ACCESS_DENIED_CALLBACK_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_ACCESS_DENIED_CALLBACK_OBJECT_ACE, SidStart) - 44usize];
};
pub type ACCESS_DENIED_CALLBACK_OBJECT_ACE = _ACCESS_DENIED_CALLBACK_OBJECT_ACE;
pub type PACCESS_DENIED_CALLBACK_OBJECT_ACE = *mut _ACCESS_DENIED_CALLBACK_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE"]
        [::std::mem::size_of::<_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE>() - 48usize];
    ["Alignment of _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE"]
        [::std::mem::align_of::<_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_AUDIT_CALLBACK_OBJECT_ACE, SidStart) - 44usize];
};
pub type SYSTEM_AUDIT_CALLBACK_OBJECT_ACE = _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE;
pub type PSYSTEM_AUDIT_CALLBACK_OBJECT_ACE = *mut _SYSTEM_AUDIT_CALLBACK_OBJECT_ACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_ALARM_CALLBACK_OBJECT_ACE {
    pub Header: ACE_HEADER,
    pub Mask: ACCESS_MASK,
    pub Flags: DWORD,
    pub ObjectType: GUID,
    pub InheritedObjectType: GUID,
    pub SidStart: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_ALARM_CALLBACK_OBJECT_ACE"]
        [::std::mem::size_of::<_SYSTEM_ALARM_CALLBACK_OBJECT_ACE>() - 48usize];
    ["Alignment of _SYSTEM_ALARM_CALLBACK_OBJECT_ACE"]
        [::std::mem::align_of::<_SYSTEM_ALARM_CALLBACK_OBJECT_ACE>() - 4usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::Header"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, Header) - 0usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::Mask"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, Mask) - 4usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::Flags"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, Flags) - 8usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::ObjectType"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, ObjectType) - 12usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::InheritedObjectType"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, InheritedObjectType) - 28usize];
    ["Offset of field: _SYSTEM_ALARM_CALLBACK_OBJECT_ACE::SidStart"]
        [::std::mem::offset_of!(_SYSTEM_ALARM_CALLBACK_OBJECT_ACE, SidStart) - 44usize];
};
pub type SYSTEM_ALARM_CALLBACK_OBJECT_ACE = _SYSTEM_ALARM_CALLBACK_OBJECT_ACE;
pub type PSYSTEM_ALARM_CALLBACK_OBJECT_ACE = *mut _SYSTEM_ALARM_CALLBACK_OBJECT_ACE;
pub const _ACL_INFORMATION_CLASS_AclRevisionInformation: _ACL_INFORMATION_CLASS = 1;
pub const _ACL_INFORMATION_CLASS_AclSizeInformation: _ACL_INFORMATION_CLASS = 2;
pub type _ACL_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_ACL_INFORMATION_CLASS as ACL_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACL_REVISION_INFORMATION {
    pub AclRevision: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACL_REVISION_INFORMATION"]
        [::std::mem::size_of::<_ACL_REVISION_INFORMATION>() - 4usize];
    ["Alignment of _ACL_REVISION_INFORMATION"]
        [::std::mem::align_of::<_ACL_REVISION_INFORMATION>() - 4usize];
    ["Offset of field: _ACL_REVISION_INFORMATION::AclRevision"]
        [::std::mem::offset_of!(_ACL_REVISION_INFORMATION, AclRevision) - 0usize];
};
pub type ACL_REVISION_INFORMATION = _ACL_REVISION_INFORMATION;
pub type PACL_REVISION_INFORMATION = *mut ACL_REVISION_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACL_SIZE_INFORMATION {
    pub AceCount: DWORD,
    pub AclBytesInUse: DWORD,
    pub AclBytesFree: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACL_SIZE_INFORMATION"][::std::mem::size_of::<_ACL_SIZE_INFORMATION>() - 12usize];
    ["Alignment of _ACL_SIZE_INFORMATION"]
        [::std::mem::align_of::<_ACL_SIZE_INFORMATION>() - 4usize];
    ["Offset of field: _ACL_SIZE_INFORMATION::AceCount"]
        [::std::mem::offset_of!(_ACL_SIZE_INFORMATION, AceCount) - 0usize];
    ["Offset of field: _ACL_SIZE_INFORMATION::AclBytesInUse"]
        [::std::mem::offset_of!(_ACL_SIZE_INFORMATION, AclBytesInUse) - 4usize];
    ["Offset of field: _ACL_SIZE_INFORMATION::AclBytesFree"]
        [::std::mem::offset_of!(_ACL_SIZE_INFORMATION, AclBytesFree) - 8usize];
};
pub type ACL_SIZE_INFORMATION = _ACL_SIZE_INFORMATION;
pub type PACL_SIZE_INFORMATION = *mut ACL_SIZE_INFORMATION;
pub type SECURITY_DESCRIPTOR_CONTROL = WORD;
pub type PSECURITY_DESCRIPTOR_CONTROL = *mut WORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_DESCRIPTOR_RELATIVE {
    pub Revision: BYTE,
    pub Sbz1: BYTE,
    pub Control: SECURITY_DESCRIPTOR_CONTROL,
    pub Owner: DWORD,
    pub Group: DWORD,
    pub Sacl: DWORD,
    pub Dacl: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_DESCRIPTOR_RELATIVE"]
        [::std::mem::size_of::<_SECURITY_DESCRIPTOR_RELATIVE>() - 20usize];
    ["Alignment of _SECURITY_DESCRIPTOR_RELATIVE"]
        [::std::mem::align_of::<_SECURITY_DESCRIPTOR_RELATIVE>() - 4usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Revision"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Revision) - 0usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Sbz1"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Sbz1) - 1usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Control"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Control) - 2usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Owner"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Owner) - 4usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Group"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Group) - 8usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Sacl"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Sacl) - 12usize];
    ["Offset of field: _SECURITY_DESCRIPTOR_RELATIVE::Dacl"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR_RELATIVE, Dacl) - 16usize];
};
pub type SECURITY_DESCRIPTOR_RELATIVE = _SECURITY_DESCRIPTOR_RELATIVE;
pub type PISECURITY_DESCRIPTOR_RELATIVE = *mut _SECURITY_DESCRIPTOR_RELATIVE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_DESCRIPTOR {
    pub Revision: BYTE,
    pub Sbz1: BYTE,
    pub Control: SECURITY_DESCRIPTOR_CONTROL,
    pub Owner: PSID,
    pub Group: PSID,
    pub Sacl: PACL,
    pub Dacl: PACL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_DESCRIPTOR"][::std::mem::size_of::<_SECURITY_DESCRIPTOR>() - 40usize];
    ["Alignment of _SECURITY_DESCRIPTOR"][::std::mem::align_of::<_SECURITY_DESCRIPTOR>() - 8usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Revision"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Revision) - 0usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Sbz1"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Sbz1) - 1usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Control"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Control) - 2usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Owner"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Owner) - 8usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Group"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Group) - 16usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Sacl"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Sacl) - 24usize];
    ["Offset of field: _SECURITY_DESCRIPTOR::Dacl"]
        [::std::mem::offset_of!(_SECURITY_DESCRIPTOR, Dacl) - 32usize];
};
pub type SECURITY_DESCRIPTOR = _SECURITY_DESCRIPTOR;
pub type PISECURITY_DESCRIPTOR = *mut _SECURITY_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_OBJECT_AI_PARAMS {
    pub Size: DWORD,
    pub ConstraintMask: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_OBJECT_AI_PARAMS"]
        [::std::mem::size_of::<_SECURITY_OBJECT_AI_PARAMS>() - 8usize];
    ["Alignment of _SECURITY_OBJECT_AI_PARAMS"]
        [::std::mem::align_of::<_SECURITY_OBJECT_AI_PARAMS>() - 4usize];
    ["Offset of field: _SECURITY_OBJECT_AI_PARAMS::Size"]
        [::std::mem::offset_of!(_SECURITY_OBJECT_AI_PARAMS, Size) - 0usize];
    ["Offset of field: _SECURITY_OBJECT_AI_PARAMS::ConstraintMask"]
        [::std::mem::offset_of!(_SECURITY_OBJECT_AI_PARAMS, ConstraintMask) - 4usize];
};
pub type SECURITY_OBJECT_AI_PARAMS = _SECURITY_OBJECT_AI_PARAMS;
pub type PSECURITY_OBJECT_AI_PARAMS = *mut _SECURITY_OBJECT_AI_PARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OBJECT_TYPE_LIST {
    pub Level: WORD,
    pub Sbz: WORD,
    pub ObjectType: *mut GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OBJECT_TYPE_LIST"][::std::mem::size_of::<_OBJECT_TYPE_LIST>() - 16usize];
    ["Alignment of _OBJECT_TYPE_LIST"][::std::mem::align_of::<_OBJECT_TYPE_LIST>() - 8usize];
    ["Offset of field: _OBJECT_TYPE_LIST::Level"]
        [::std::mem::offset_of!(_OBJECT_TYPE_LIST, Level) - 0usize];
    ["Offset of field: _OBJECT_TYPE_LIST::Sbz"]
        [::std::mem::offset_of!(_OBJECT_TYPE_LIST, Sbz) - 2usize];
    ["Offset of field: _OBJECT_TYPE_LIST::ObjectType"]
        [::std::mem::offset_of!(_OBJECT_TYPE_LIST, ObjectType) - 8usize];
};
pub type OBJECT_TYPE_LIST = _OBJECT_TYPE_LIST;
pub type POBJECT_TYPE_LIST = *mut _OBJECT_TYPE_LIST;
pub const _AUDIT_EVENT_TYPE_AuditEventObjectAccess: _AUDIT_EVENT_TYPE = 0;
pub const _AUDIT_EVENT_TYPE_AuditEventDirectoryServiceAccess: _AUDIT_EVENT_TYPE = 1;
pub type _AUDIT_EVENT_TYPE = ::std::os::raw::c_int;
pub use self::_AUDIT_EVENT_TYPE as AUDIT_EVENT_TYPE;
pub type PAUDIT_EVENT_TYPE = *mut _AUDIT_EVENT_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRIVILEGE_SET {
    pub PrivilegeCount: DWORD,
    pub Control: DWORD,
    pub Privilege: [LUID_AND_ATTRIBUTES; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRIVILEGE_SET"][::std::mem::size_of::<_PRIVILEGE_SET>() - 20usize];
    ["Alignment of _PRIVILEGE_SET"][::std::mem::align_of::<_PRIVILEGE_SET>() - 4usize];
    ["Offset of field: _PRIVILEGE_SET::PrivilegeCount"]
        [::std::mem::offset_of!(_PRIVILEGE_SET, PrivilegeCount) - 0usize];
    ["Offset of field: _PRIVILEGE_SET::Control"]
        [::std::mem::offset_of!(_PRIVILEGE_SET, Control) - 4usize];
    ["Offset of field: _PRIVILEGE_SET::Privilege"]
        [::std::mem::offset_of!(_PRIVILEGE_SET, Privilege) - 8usize];
};
pub type PRIVILEGE_SET = _PRIVILEGE_SET;
pub type PPRIVILEGE_SET = *mut _PRIVILEGE_SET;
pub const _ACCESS_REASON_TYPE_AccessReasonNone: _ACCESS_REASON_TYPE = 0;
pub const _ACCESS_REASON_TYPE_AccessReasonAllowedAce: _ACCESS_REASON_TYPE = 65536;
pub const _ACCESS_REASON_TYPE_AccessReasonDeniedAce: _ACCESS_REASON_TYPE = 131072;
pub const _ACCESS_REASON_TYPE_AccessReasonAllowedParentAce: _ACCESS_REASON_TYPE = 196608;
pub const _ACCESS_REASON_TYPE_AccessReasonDeniedParentAce: _ACCESS_REASON_TYPE = 262144;
pub const _ACCESS_REASON_TYPE_AccessReasonNotGrantedByCape: _ACCESS_REASON_TYPE = 327680;
pub const _ACCESS_REASON_TYPE_AccessReasonNotGrantedByParentCape: _ACCESS_REASON_TYPE = 393216;
pub const _ACCESS_REASON_TYPE_AccessReasonNotGrantedToAppContainer: _ACCESS_REASON_TYPE = 458752;
pub const _ACCESS_REASON_TYPE_AccessReasonMissingPrivilege: _ACCESS_REASON_TYPE = 1048576;
pub const _ACCESS_REASON_TYPE_AccessReasonFromPrivilege: _ACCESS_REASON_TYPE = 2097152;
pub const _ACCESS_REASON_TYPE_AccessReasonIntegrityLevel: _ACCESS_REASON_TYPE = 3145728;
pub const _ACCESS_REASON_TYPE_AccessReasonOwnership: _ACCESS_REASON_TYPE = 4194304;
pub const _ACCESS_REASON_TYPE_AccessReasonNullDacl: _ACCESS_REASON_TYPE = 5242880;
pub const _ACCESS_REASON_TYPE_AccessReasonEmptyDacl: _ACCESS_REASON_TYPE = 6291456;
pub const _ACCESS_REASON_TYPE_AccessReasonNoSD: _ACCESS_REASON_TYPE = 7340032;
pub const _ACCESS_REASON_TYPE_AccessReasonNoGrant: _ACCESS_REASON_TYPE = 8388608;
pub const _ACCESS_REASON_TYPE_AccessReasonTrustLabel: _ACCESS_REASON_TYPE = 9437184;
pub const _ACCESS_REASON_TYPE_AccessReasonFilterAce: _ACCESS_REASON_TYPE = 10485760;
pub type _ACCESS_REASON_TYPE = ::std::os::raw::c_int;
pub use self::_ACCESS_REASON_TYPE as ACCESS_REASON_TYPE;
pub type ACCESS_REASON = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACCESS_REASONS {
    pub Data: [ACCESS_REASON; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACCESS_REASONS"][::std::mem::size_of::<_ACCESS_REASONS>() - 128usize];
    ["Alignment of _ACCESS_REASONS"][::std::mem::align_of::<_ACCESS_REASONS>() - 4usize];
    ["Offset of field: _ACCESS_REASONS::Data"]
        [::std::mem::offset_of!(_ACCESS_REASONS, Data) - 0usize];
};
pub type ACCESS_REASONS = _ACCESS_REASONS;
pub type PACCESS_REASONS = *mut _ACCESS_REASONS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SE_SECURITY_DESCRIPTOR {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub SecurityDescriptor: PSECURITY_DESCRIPTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_SECURITY_DESCRIPTOR"][::std::mem::size_of::<_SE_SECURITY_DESCRIPTOR>() - 16usize];
    ["Alignment of _SE_SECURITY_DESCRIPTOR"]
        [::std::mem::align_of::<_SE_SECURITY_DESCRIPTOR>() - 8usize];
    ["Offset of field: _SE_SECURITY_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_SE_SECURITY_DESCRIPTOR, Size) - 0usize];
    ["Offset of field: _SE_SECURITY_DESCRIPTOR::Flags"]
        [::std::mem::offset_of!(_SE_SECURITY_DESCRIPTOR, Flags) - 4usize];
    ["Offset of field: _SE_SECURITY_DESCRIPTOR::SecurityDescriptor"]
        [::std::mem::offset_of!(_SE_SECURITY_DESCRIPTOR, SecurityDescriptor) - 8usize];
};
pub type SE_SECURITY_DESCRIPTOR = _SE_SECURITY_DESCRIPTOR;
pub type PSE_SECURITY_DESCRIPTOR = *mut _SE_SECURITY_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SE_ACCESS_REQUEST {
    pub Size: DWORD,
    pub SeSecurityDescriptor: PSE_SECURITY_DESCRIPTOR,
    pub DesiredAccess: ACCESS_MASK,
    pub PreviouslyGrantedAccess: ACCESS_MASK,
    pub PrincipalSelfSid: PSID,
    pub GenericMapping: PGENERIC_MAPPING,
    pub ObjectTypeListCount: DWORD,
    pub ObjectTypeList: POBJECT_TYPE_LIST,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_ACCESS_REQUEST"][::std::mem::size_of::<_SE_ACCESS_REQUEST>() - 56usize];
    ["Alignment of _SE_ACCESS_REQUEST"][::std::mem::align_of::<_SE_ACCESS_REQUEST>() - 8usize];
    ["Offset of field: _SE_ACCESS_REQUEST::Size"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, Size) - 0usize];
    ["Offset of field: _SE_ACCESS_REQUEST::SeSecurityDescriptor"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, SeSecurityDescriptor) - 8usize];
    ["Offset of field: _SE_ACCESS_REQUEST::DesiredAccess"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, DesiredAccess) - 16usize];
    ["Offset of field: _SE_ACCESS_REQUEST::PreviouslyGrantedAccess"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, PreviouslyGrantedAccess) - 20usize];
    ["Offset of field: _SE_ACCESS_REQUEST::PrincipalSelfSid"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, PrincipalSelfSid) - 24usize];
    ["Offset of field: _SE_ACCESS_REQUEST::GenericMapping"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, GenericMapping) - 32usize];
    ["Offset of field: _SE_ACCESS_REQUEST::ObjectTypeListCount"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, ObjectTypeListCount) - 40usize];
    ["Offset of field: _SE_ACCESS_REQUEST::ObjectTypeList"]
        [::std::mem::offset_of!(_SE_ACCESS_REQUEST, ObjectTypeList) - 48usize];
};
pub type SE_ACCESS_REQUEST = _SE_ACCESS_REQUEST;
pub type PSE_ACCESS_REQUEST = *mut _SE_ACCESS_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SE_ACCESS_REPLY {
    pub Size: DWORD,
    pub ResultListCount: DWORD,
    pub GrantedAccess: PACCESS_MASK,
    pub AccessStatus: PDWORD,
    pub AccessReason: PACCESS_REASONS,
    pub Privileges: *mut PPRIVILEGE_SET,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_ACCESS_REPLY"][::std::mem::size_of::<_SE_ACCESS_REPLY>() - 40usize];
    ["Alignment of _SE_ACCESS_REPLY"][::std::mem::align_of::<_SE_ACCESS_REPLY>() - 8usize];
    ["Offset of field: _SE_ACCESS_REPLY::Size"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, Size) - 0usize];
    ["Offset of field: _SE_ACCESS_REPLY::ResultListCount"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, ResultListCount) - 4usize];
    ["Offset of field: _SE_ACCESS_REPLY::GrantedAccess"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, GrantedAccess) - 8usize];
    ["Offset of field: _SE_ACCESS_REPLY::AccessStatus"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, AccessStatus) - 16usize];
    ["Offset of field: _SE_ACCESS_REPLY::AccessReason"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, AccessReason) - 24usize];
    ["Offset of field: _SE_ACCESS_REPLY::Privileges"]
        [::std::mem::offset_of!(_SE_ACCESS_REPLY, Privileges) - 32usize];
};
pub type SE_ACCESS_REPLY = _SE_ACCESS_REPLY;
pub type PSE_ACCESS_REPLY = *mut _SE_ACCESS_REPLY;
pub const _SECURITY_IMPERSONATION_LEVEL_SecurityAnonymous: _SECURITY_IMPERSONATION_LEVEL = 0;
pub const _SECURITY_IMPERSONATION_LEVEL_SecurityIdentification: _SECURITY_IMPERSONATION_LEVEL = 1;
pub const _SECURITY_IMPERSONATION_LEVEL_SecurityImpersonation: _SECURITY_IMPERSONATION_LEVEL = 2;
pub const _SECURITY_IMPERSONATION_LEVEL_SecurityDelegation: _SECURITY_IMPERSONATION_LEVEL = 3;
pub type _SECURITY_IMPERSONATION_LEVEL = ::std::os::raw::c_int;
pub use self::_SECURITY_IMPERSONATION_LEVEL as SECURITY_IMPERSONATION_LEVEL;
pub type PSECURITY_IMPERSONATION_LEVEL = *mut _SECURITY_IMPERSONATION_LEVEL;
pub const _TOKEN_TYPE_TokenPrimary: _TOKEN_TYPE = 1;
pub const _TOKEN_TYPE_TokenImpersonation: _TOKEN_TYPE = 2;
pub type _TOKEN_TYPE = ::std::os::raw::c_int;
pub use self::_TOKEN_TYPE as TOKEN_TYPE;
pub type PTOKEN_TYPE = *mut TOKEN_TYPE;
pub const _TOKEN_ELEVATION_TYPE_TokenElevationTypeDefault: _TOKEN_ELEVATION_TYPE = 1;
pub const _TOKEN_ELEVATION_TYPE_TokenElevationTypeFull: _TOKEN_ELEVATION_TYPE = 2;
pub const _TOKEN_ELEVATION_TYPE_TokenElevationTypeLimited: _TOKEN_ELEVATION_TYPE = 3;
pub type _TOKEN_ELEVATION_TYPE = ::std::os::raw::c_int;
pub use self::_TOKEN_ELEVATION_TYPE as TOKEN_ELEVATION_TYPE;
pub type PTOKEN_ELEVATION_TYPE = *mut _TOKEN_ELEVATION_TYPE;
pub const _TOKEN_INFORMATION_CLASS_TokenUser: _TOKEN_INFORMATION_CLASS = 1;
pub const _TOKEN_INFORMATION_CLASS_TokenGroups: _TOKEN_INFORMATION_CLASS = 2;
pub const _TOKEN_INFORMATION_CLASS_TokenPrivileges: _TOKEN_INFORMATION_CLASS = 3;
pub const _TOKEN_INFORMATION_CLASS_TokenOwner: _TOKEN_INFORMATION_CLASS = 4;
pub const _TOKEN_INFORMATION_CLASS_TokenPrimaryGroup: _TOKEN_INFORMATION_CLASS = 5;
pub const _TOKEN_INFORMATION_CLASS_TokenDefaultDacl: _TOKEN_INFORMATION_CLASS = 6;
pub const _TOKEN_INFORMATION_CLASS_TokenSource: _TOKEN_INFORMATION_CLASS = 7;
pub const _TOKEN_INFORMATION_CLASS_TokenType: _TOKEN_INFORMATION_CLASS = 8;
pub const _TOKEN_INFORMATION_CLASS_TokenImpersonationLevel: _TOKEN_INFORMATION_CLASS = 9;
pub const _TOKEN_INFORMATION_CLASS_TokenStatistics: _TOKEN_INFORMATION_CLASS = 10;
pub const _TOKEN_INFORMATION_CLASS_TokenRestrictedSids: _TOKEN_INFORMATION_CLASS = 11;
pub const _TOKEN_INFORMATION_CLASS_TokenSessionId: _TOKEN_INFORMATION_CLASS = 12;
pub const _TOKEN_INFORMATION_CLASS_TokenGroupsAndPrivileges: _TOKEN_INFORMATION_CLASS = 13;
pub const _TOKEN_INFORMATION_CLASS_TokenSessionReference: _TOKEN_INFORMATION_CLASS = 14;
pub const _TOKEN_INFORMATION_CLASS_TokenSandBoxInert: _TOKEN_INFORMATION_CLASS = 15;
pub const _TOKEN_INFORMATION_CLASS_TokenAuditPolicy: _TOKEN_INFORMATION_CLASS = 16;
pub const _TOKEN_INFORMATION_CLASS_TokenOrigin: _TOKEN_INFORMATION_CLASS = 17;
pub const _TOKEN_INFORMATION_CLASS_TokenElevationType: _TOKEN_INFORMATION_CLASS = 18;
pub const _TOKEN_INFORMATION_CLASS_TokenLinkedToken: _TOKEN_INFORMATION_CLASS = 19;
pub const _TOKEN_INFORMATION_CLASS_TokenElevation: _TOKEN_INFORMATION_CLASS = 20;
pub const _TOKEN_INFORMATION_CLASS_TokenHasRestrictions: _TOKEN_INFORMATION_CLASS = 21;
pub const _TOKEN_INFORMATION_CLASS_TokenAccessInformation: _TOKEN_INFORMATION_CLASS = 22;
pub const _TOKEN_INFORMATION_CLASS_TokenVirtualizationAllowed: _TOKEN_INFORMATION_CLASS = 23;
pub const _TOKEN_INFORMATION_CLASS_TokenVirtualizationEnabled: _TOKEN_INFORMATION_CLASS = 24;
pub const _TOKEN_INFORMATION_CLASS_TokenIntegrityLevel: _TOKEN_INFORMATION_CLASS = 25;
pub const _TOKEN_INFORMATION_CLASS_TokenUIAccess: _TOKEN_INFORMATION_CLASS = 26;
pub const _TOKEN_INFORMATION_CLASS_TokenMandatoryPolicy: _TOKEN_INFORMATION_CLASS = 27;
pub const _TOKEN_INFORMATION_CLASS_TokenLogonSid: _TOKEN_INFORMATION_CLASS = 28;
pub const _TOKEN_INFORMATION_CLASS_TokenIsAppContainer: _TOKEN_INFORMATION_CLASS = 29;
pub const _TOKEN_INFORMATION_CLASS_TokenCapabilities: _TOKEN_INFORMATION_CLASS = 30;
pub const _TOKEN_INFORMATION_CLASS_TokenAppContainerSid: _TOKEN_INFORMATION_CLASS = 31;
pub const _TOKEN_INFORMATION_CLASS_TokenAppContainerNumber: _TOKEN_INFORMATION_CLASS = 32;
pub const _TOKEN_INFORMATION_CLASS_TokenUserClaimAttributes: _TOKEN_INFORMATION_CLASS = 33;
pub const _TOKEN_INFORMATION_CLASS_TokenDeviceClaimAttributes: _TOKEN_INFORMATION_CLASS = 34;
pub const _TOKEN_INFORMATION_CLASS_TokenRestrictedUserClaimAttributes: _TOKEN_INFORMATION_CLASS =
    35;
pub const _TOKEN_INFORMATION_CLASS_TokenRestrictedDeviceClaimAttributes: _TOKEN_INFORMATION_CLASS =
    36;
pub const _TOKEN_INFORMATION_CLASS_TokenDeviceGroups: _TOKEN_INFORMATION_CLASS = 37;
pub const _TOKEN_INFORMATION_CLASS_TokenRestrictedDeviceGroups: _TOKEN_INFORMATION_CLASS = 38;
pub const _TOKEN_INFORMATION_CLASS_TokenSecurityAttributes: _TOKEN_INFORMATION_CLASS = 39;
pub const _TOKEN_INFORMATION_CLASS_TokenIsRestricted: _TOKEN_INFORMATION_CLASS = 40;
pub const _TOKEN_INFORMATION_CLASS_TokenProcessTrustLevel: _TOKEN_INFORMATION_CLASS = 41;
pub const _TOKEN_INFORMATION_CLASS_TokenPrivateNameSpace: _TOKEN_INFORMATION_CLASS = 42;
pub const _TOKEN_INFORMATION_CLASS_TokenSingletonAttributes: _TOKEN_INFORMATION_CLASS = 43;
pub const _TOKEN_INFORMATION_CLASS_TokenBnoIsolation: _TOKEN_INFORMATION_CLASS = 44;
pub const _TOKEN_INFORMATION_CLASS_TokenChildProcessFlags: _TOKEN_INFORMATION_CLASS = 45;
pub const _TOKEN_INFORMATION_CLASS_TokenIsLessPrivilegedAppContainer: _TOKEN_INFORMATION_CLASS = 46;
pub const _TOKEN_INFORMATION_CLASS_TokenIsSandboxed: _TOKEN_INFORMATION_CLASS = 47;
pub const _TOKEN_INFORMATION_CLASS_MaxTokenInfoClass: _TOKEN_INFORMATION_CLASS = 48;
pub type _TOKEN_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_TOKEN_INFORMATION_CLASS as TOKEN_INFORMATION_CLASS;
pub type PTOKEN_INFORMATION_CLASS = *mut _TOKEN_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_USER {
    pub User: SID_AND_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_USER"][::std::mem::size_of::<_TOKEN_USER>() - 16usize];
    ["Alignment of _TOKEN_USER"][::std::mem::align_of::<_TOKEN_USER>() - 8usize];
    ["Offset of field: _TOKEN_USER::User"][::std::mem::offset_of!(_TOKEN_USER, User) - 0usize];
};
pub type TOKEN_USER = _TOKEN_USER;
pub type PTOKEN_USER = *mut _TOKEN_USER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SE_TOKEN_USER {
    pub __bindgen_anon_1: _SE_TOKEN_USER__bindgen_ty_1,
    pub __bindgen_anon_2: _SE_TOKEN_USER__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SE_TOKEN_USER__bindgen_ty_1 {
    pub TokenUser: TOKEN_USER,
    pub User: SID_AND_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_TOKEN_USER__bindgen_ty_1"]
        [::std::mem::size_of::<_SE_TOKEN_USER__bindgen_ty_1>() - 16usize];
    ["Alignment of _SE_TOKEN_USER__bindgen_ty_1"]
        [::std::mem::align_of::<_SE_TOKEN_USER__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SE_TOKEN_USER__bindgen_ty_1::TokenUser"]
        [::std::mem::offset_of!(_SE_TOKEN_USER__bindgen_ty_1, TokenUser) - 0usize];
    ["Offset of field: _SE_TOKEN_USER__bindgen_ty_1::User"]
        [::std::mem::offset_of!(_SE_TOKEN_USER__bindgen_ty_1, User) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SE_TOKEN_USER__bindgen_ty_2 {
    pub Sid: SID,
    pub Buffer: [BYTE; 68usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_TOKEN_USER__bindgen_ty_2"]
        [::std::mem::size_of::<_SE_TOKEN_USER__bindgen_ty_2>() - 68usize];
    ["Alignment of _SE_TOKEN_USER__bindgen_ty_2"]
        [::std::mem::align_of::<_SE_TOKEN_USER__bindgen_ty_2>() - 4usize];
    ["Offset of field: _SE_TOKEN_USER__bindgen_ty_2::Sid"]
        [::std::mem::offset_of!(_SE_TOKEN_USER__bindgen_ty_2, Sid) - 0usize];
    ["Offset of field: _SE_TOKEN_USER__bindgen_ty_2::Buffer"]
        [::std::mem::offset_of!(_SE_TOKEN_USER__bindgen_ty_2, Buffer) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_TOKEN_USER"][::std::mem::size_of::<_SE_TOKEN_USER>() - 88usize];
    ["Alignment of _SE_TOKEN_USER"][::std::mem::align_of::<_SE_TOKEN_USER>() - 8usize];
};
pub type SE_TOKEN_USER = _SE_TOKEN_USER;
pub type PSE_TOKEN_USER = _SE_TOKEN_USER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_GROUPS {
    pub GroupCount: DWORD,
    pub Groups: [SID_AND_ATTRIBUTES; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_GROUPS"][::std::mem::size_of::<_TOKEN_GROUPS>() - 24usize];
    ["Alignment of _TOKEN_GROUPS"][::std::mem::align_of::<_TOKEN_GROUPS>() - 8usize];
    ["Offset of field: _TOKEN_GROUPS::GroupCount"]
        [::std::mem::offset_of!(_TOKEN_GROUPS, GroupCount) - 0usize];
    ["Offset of field: _TOKEN_GROUPS::Groups"]
        [::std::mem::offset_of!(_TOKEN_GROUPS, Groups) - 8usize];
};
pub type TOKEN_GROUPS = _TOKEN_GROUPS;
pub type PTOKEN_GROUPS = *mut _TOKEN_GROUPS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_PRIVILEGES {
    pub PrivilegeCount: DWORD,
    pub Privileges: [LUID_AND_ATTRIBUTES; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_PRIVILEGES"][::std::mem::size_of::<_TOKEN_PRIVILEGES>() - 16usize];
    ["Alignment of _TOKEN_PRIVILEGES"][::std::mem::align_of::<_TOKEN_PRIVILEGES>() - 4usize];
    ["Offset of field: _TOKEN_PRIVILEGES::PrivilegeCount"]
        [::std::mem::offset_of!(_TOKEN_PRIVILEGES, PrivilegeCount) - 0usize];
    ["Offset of field: _TOKEN_PRIVILEGES::Privileges"]
        [::std::mem::offset_of!(_TOKEN_PRIVILEGES, Privileges) - 4usize];
};
pub type TOKEN_PRIVILEGES = _TOKEN_PRIVILEGES;
pub type PTOKEN_PRIVILEGES = *mut _TOKEN_PRIVILEGES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_OWNER {
    pub Owner: PSID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_OWNER"][::std::mem::size_of::<_TOKEN_OWNER>() - 8usize];
    ["Alignment of _TOKEN_OWNER"][::std::mem::align_of::<_TOKEN_OWNER>() - 8usize];
    ["Offset of field: _TOKEN_OWNER::Owner"][::std::mem::offset_of!(_TOKEN_OWNER, Owner) - 0usize];
};
pub type TOKEN_OWNER = _TOKEN_OWNER;
pub type PTOKEN_OWNER = *mut _TOKEN_OWNER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_PRIMARY_GROUP {
    pub PrimaryGroup: PSID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_PRIMARY_GROUP"][::std::mem::size_of::<_TOKEN_PRIMARY_GROUP>() - 8usize];
    ["Alignment of _TOKEN_PRIMARY_GROUP"][::std::mem::align_of::<_TOKEN_PRIMARY_GROUP>() - 8usize];
    ["Offset of field: _TOKEN_PRIMARY_GROUP::PrimaryGroup"]
        [::std::mem::offset_of!(_TOKEN_PRIMARY_GROUP, PrimaryGroup) - 0usize];
};
pub type TOKEN_PRIMARY_GROUP = _TOKEN_PRIMARY_GROUP;
pub type PTOKEN_PRIMARY_GROUP = *mut _TOKEN_PRIMARY_GROUP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_DEFAULT_DACL {
    pub DefaultDacl: PACL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_DEFAULT_DACL"][::std::mem::size_of::<_TOKEN_DEFAULT_DACL>() - 8usize];
    ["Alignment of _TOKEN_DEFAULT_DACL"][::std::mem::align_of::<_TOKEN_DEFAULT_DACL>() - 8usize];
    ["Offset of field: _TOKEN_DEFAULT_DACL::DefaultDacl"]
        [::std::mem::offset_of!(_TOKEN_DEFAULT_DACL, DefaultDacl) - 0usize];
};
pub type TOKEN_DEFAULT_DACL = _TOKEN_DEFAULT_DACL;
pub type PTOKEN_DEFAULT_DACL = *mut _TOKEN_DEFAULT_DACL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_USER_CLAIMS {
    pub UserClaims: PCLAIMS_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_USER_CLAIMS"][::std::mem::size_of::<_TOKEN_USER_CLAIMS>() - 8usize];
    ["Alignment of _TOKEN_USER_CLAIMS"][::std::mem::align_of::<_TOKEN_USER_CLAIMS>() - 8usize];
    ["Offset of field: _TOKEN_USER_CLAIMS::UserClaims"]
        [::std::mem::offset_of!(_TOKEN_USER_CLAIMS, UserClaims) - 0usize];
};
pub type TOKEN_USER_CLAIMS = _TOKEN_USER_CLAIMS;
pub type PTOKEN_USER_CLAIMS = *mut _TOKEN_USER_CLAIMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_DEVICE_CLAIMS {
    pub DeviceClaims: PCLAIMS_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_DEVICE_CLAIMS"][::std::mem::size_of::<_TOKEN_DEVICE_CLAIMS>() - 8usize];
    ["Alignment of _TOKEN_DEVICE_CLAIMS"][::std::mem::align_of::<_TOKEN_DEVICE_CLAIMS>() - 8usize];
    ["Offset of field: _TOKEN_DEVICE_CLAIMS::DeviceClaims"]
        [::std::mem::offset_of!(_TOKEN_DEVICE_CLAIMS, DeviceClaims) - 0usize];
};
pub type TOKEN_DEVICE_CLAIMS = _TOKEN_DEVICE_CLAIMS;
pub type PTOKEN_DEVICE_CLAIMS = *mut _TOKEN_DEVICE_CLAIMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_GROUPS_AND_PRIVILEGES {
    pub SidCount: DWORD,
    pub SidLength: DWORD,
    pub Sids: PSID_AND_ATTRIBUTES,
    pub RestrictedSidCount: DWORD,
    pub RestrictedSidLength: DWORD,
    pub RestrictedSids: PSID_AND_ATTRIBUTES,
    pub PrivilegeCount: DWORD,
    pub PrivilegeLength: DWORD,
    pub Privileges: PLUID_AND_ATTRIBUTES,
    pub AuthenticationId: LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_GROUPS_AND_PRIVILEGES"]
        [::std::mem::size_of::<_TOKEN_GROUPS_AND_PRIVILEGES>() - 56usize];
    ["Alignment of _TOKEN_GROUPS_AND_PRIVILEGES"]
        [::std::mem::align_of::<_TOKEN_GROUPS_AND_PRIVILEGES>() - 8usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::SidCount"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, SidCount) - 0usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::SidLength"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, SidLength) - 4usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::Sids"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, Sids) - 8usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::RestrictedSidCount"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, RestrictedSidCount) - 16usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::RestrictedSidLength"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, RestrictedSidLength) - 20usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::RestrictedSids"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, RestrictedSids) - 24usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::PrivilegeCount"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, PrivilegeCount) - 32usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::PrivilegeLength"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, PrivilegeLength) - 36usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::Privileges"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, Privileges) - 40usize];
    ["Offset of field: _TOKEN_GROUPS_AND_PRIVILEGES::AuthenticationId"]
        [::std::mem::offset_of!(_TOKEN_GROUPS_AND_PRIVILEGES, AuthenticationId) - 48usize];
};
pub type TOKEN_GROUPS_AND_PRIVILEGES = _TOKEN_GROUPS_AND_PRIVILEGES;
pub type PTOKEN_GROUPS_AND_PRIVILEGES = *mut _TOKEN_GROUPS_AND_PRIVILEGES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_LINKED_TOKEN {
    pub LinkedToken: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_LINKED_TOKEN"][::std::mem::size_of::<_TOKEN_LINKED_TOKEN>() - 8usize];
    ["Alignment of _TOKEN_LINKED_TOKEN"][::std::mem::align_of::<_TOKEN_LINKED_TOKEN>() - 8usize];
    ["Offset of field: _TOKEN_LINKED_TOKEN::LinkedToken"]
        [::std::mem::offset_of!(_TOKEN_LINKED_TOKEN, LinkedToken) - 0usize];
};
pub type TOKEN_LINKED_TOKEN = _TOKEN_LINKED_TOKEN;
pub type PTOKEN_LINKED_TOKEN = *mut _TOKEN_LINKED_TOKEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_ELEVATION {
    pub TokenIsElevated: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_ELEVATION"][::std::mem::size_of::<_TOKEN_ELEVATION>() - 4usize];
    ["Alignment of _TOKEN_ELEVATION"][::std::mem::align_of::<_TOKEN_ELEVATION>() - 4usize];
    ["Offset of field: _TOKEN_ELEVATION::TokenIsElevated"]
        [::std::mem::offset_of!(_TOKEN_ELEVATION, TokenIsElevated) - 0usize];
};
pub type TOKEN_ELEVATION = _TOKEN_ELEVATION;
pub type PTOKEN_ELEVATION = *mut _TOKEN_ELEVATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_MANDATORY_LABEL {
    pub Label: SID_AND_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_MANDATORY_LABEL"][::std::mem::size_of::<_TOKEN_MANDATORY_LABEL>() - 16usize];
    ["Alignment of _TOKEN_MANDATORY_LABEL"]
        [::std::mem::align_of::<_TOKEN_MANDATORY_LABEL>() - 8usize];
    ["Offset of field: _TOKEN_MANDATORY_LABEL::Label"]
        [::std::mem::offset_of!(_TOKEN_MANDATORY_LABEL, Label) - 0usize];
};
pub type TOKEN_MANDATORY_LABEL = _TOKEN_MANDATORY_LABEL;
pub type PTOKEN_MANDATORY_LABEL = *mut _TOKEN_MANDATORY_LABEL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_MANDATORY_POLICY {
    pub Policy: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_MANDATORY_POLICY"][::std::mem::size_of::<_TOKEN_MANDATORY_POLICY>() - 4usize];
    ["Alignment of _TOKEN_MANDATORY_POLICY"]
        [::std::mem::align_of::<_TOKEN_MANDATORY_POLICY>() - 4usize];
    ["Offset of field: _TOKEN_MANDATORY_POLICY::Policy"]
        [::std::mem::offset_of!(_TOKEN_MANDATORY_POLICY, Policy) - 0usize];
};
pub type TOKEN_MANDATORY_POLICY = _TOKEN_MANDATORY_POLICY;
pub type PTOKEN_MANDATORY_POLICY = *mut _TOKEN_MANDATORY_POLICY;
pub type PSECURITY_ATTRIBUTES_OPAQUE = PVOID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_ACCESS_INFORMATION {
    pub SidHash: PSID_AND_ATTRIBUTES_HASH,
    pub RestrictedSidHash: PSID_AND_ATTRIBUTES_HASH,
    pub Privileges: PTOKEN_PRIVILEGES,
    pub AuthenticationId: LUID,
    pub TokenType: TOKEN_TYPE,
    pub ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL,
    pub MandatoryPolicy: TOKEN_MANDATORY_POLICY,
    pub Flags: DWORD,
    pub AppContainerNumber: DWORD,
    pub PackageSid: PSID,
    pub CapabilitiesHash: PSID_AND_ATTRIBUTES_HASH,
    pub TrustLevelSid: PSID,
    pub SecurityAttributes: PSECURITY_ATTRIBUTES_OPAQUE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_ACCESS_INFORMATION"]
        [::std::mem::size_of::<_TOKEN_ACCESS_INFORMATION>() - 88usize];
    ["Alignment of _TOKEN_ACCESS_INFORMATION"]
        [::std::mem::align_of::<_TOKEN_ACCESS_INFORMATION>() - 8usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::SidHash"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, SidHash) - 0usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::RestrictedSidHash"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, RestrictedSidHash) - 8usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::Privileges"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, Privileges) - 16usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::AuthenticationId"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, AuthenticationId) - 24usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::TokenType"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, TokenType) - 32usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::ImpersonationLevel"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, ImpersonationLevel) - 36usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::MandatoryPolicy"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, MandatoryPolicy) - 40usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::Flags"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, Flags) - 44usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::AppContainerNumber"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, AppContainerNumber) - 48usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::PackageSid"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, PackageSid) - 56usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::CapabilitiesHash"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, CapabilitiesHash) - 64usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::TrustLevelSid"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, TrustLevelSid) - 72usize];
    ["Offset of field: _TOKEN_ACCESS_INFORMATION::SecurityAttributes"]
        [::std::mem::offset_of!(_TOKEN_ACCESS_INFORMATION, SecurityAttributes) - 80usize];
};
pub type TOKEN_ACCESS_INFORMATION = _TOKEN_ACCESS_INFORMATION;
pub type PTOKEN_ACCESS_INFORMATION = *mut _TOKEN_ACCESS_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_AUDIT_POLICY {
    pub PerUserPolicy: [BYTE; 30usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_AUDIT_POLICY"][::std::mem::size_of::<_TOKEN_AUDIT_POLICY>() - 30usize];
    ["Alignment of _TOKEN_AUDIT_POLICY"][::std::mem::align_of::<_TOKEN_AUDIT_POLICY>() - 1usize];
    ["Offset of field: _TOKEN_AUDIT_POLICY::PerUserPolicy"]
        [::std::mem::offset_of!(_TOKEN_AUDIT_POLICY, PerUserPolicy) - 0usize];
};
pub type TOKEN_AUDIT_POLICY = _TOKEN_AUDIT_POLICY;
pub type PTOKEN_AUDIT_POLICY = *mut _TOKEN_AUDIT_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_SOURCE {
    pub SourceName: [CHAR; 8usize],
    pub SourceIdentifier: LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_SOURCE"][::std::mem::size_of::<_TOKEN_SOURCE>() - 16usize];
    ["Alignment of _TOKEN_SOURCE"][::std::mem::align_of::<_TOKEN_SOURCE>() - 4usize];
    ["Offset of field: _TOKEN_SOURCE::SourceName"]
        [::std::mem::offset_of!(_TOKEN_SOURCE, SourceName) - 0usize];
    ["Offset of field: _TOKEN_SOURCE::SourceIdentifier"]
        [::std::mem::offset_of!(_TOKEN_SOURCE, SourceIdentifier) - 8usize];
};
pub type TOKEN_SOURCE = _TOKEN_SOURCE;
pub type PTOKEN_SOURCE = *mut _TOKEN_SOURCE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TOKEN_STATISTICS {
    pub TokenId: LUID,
    pub AuthenticationId: LUID,
    pub ExpirationTime: LARGE_INTEGER,
    pub TokenType: TOKEN_TYPE,
    pub ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL,
    pub DynamicCharged: DWORD,
    pub DynamicAvailable: DWORD,
    pub GroupCount: DWORD,
    pub PrivilegeCount: DWORD,
    pub ModifiedId: LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_STATISTICS"][::std::mem::size_of::<_TOKEN_STATISTICS>() - 56usize];
    ["Alignment of _TOKEN_STATISTICS"][::std::mem::align_of::<_TOKEN_STATISTICS>() - 8usize];
    ["Offset of field: _TOKEN_STATISTICS::TokenId"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, TokenId) - 0usize];
    ["Offset of field: _TOKEN_STATISTICS::AuthenticationId"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, AuthenticationId) - 8usize];
    ["Offset of field: _TOKEN_STATISTICS::ExpirationTime"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, ExpirationTime) - 16usize];
    ["Offset of field: _TOKEN_STATISTICS::TokenType"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, TokenType) - 24usize];
    ["Offset of field: _TOKEN_STATISTICS::ImpersonationLevel"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, ImpersonationLevel) - 28usize];
    ["Offset of field: _TOKEN_STATISTICS::DynamicCharged"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, DynamicCharged) - 32usize];
    ["Offset of field: _TOKEN_STATISTICS::DynamicAvailable"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, DynamicAvailable) - 36usize];
    ["Offset of field: _TOKEN_STATISTICS::GroupCount"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, GroupCount) - 40usize];
    ["Offset of field: _TOKEN_STATISTICS::PrivilegeCount"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, PrivilegeCount) - 44usize];
    ["Offset of field: _TOKEN_STATISTICS::ModifiedId"]
        [::std::mem::offset_of!(_TOKEN_STATISTICS, ModifiedId) - 48usize];
};
pub type TOKEN_STATISTICS = _TOKEN_STATISTICS;
pub type PTOKEN_STATISTICS = *mut _TOKEN_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_CONTROL {
    pub TokenId: LUID,
    pub AuthenticationId: LUID,
    pub ModifiedId: LUID,
    pub TokenSource: TOKEN_SOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_CONTROL"][::std::mem::size_of::<_TOKEN_CONTROL>() - 40usize];
    ["Alignment of _TOKEN_CONTROL"][::std::mem::align_of::<_TOKEN_CONTROL>() - 4usize];
    ["Offset of field: _TOKEN_CONTROL::TokenId"]
        [::std::mem::offset_of!(_TOKEN_CONTROL, TokenId) - 0usize];
    ["Offset of field: _TOKEN_CONTROL::AuthenticationId"]
        [::std::mem::offset_of!(_TOKEN_CONTROL, AuthenticationId) - 8usize];
    ["Offset of field: _TOKEN_CONTROL::ModifiedId"]
        [::std::mem::offset_of!(_TOKEN_CONTROL, ModifiedId) - 16usize];
    ["Offset of field: _TOKEN_CONTROL::TokenSource"]
        [::std::mem::offset_of!(_TOKEN_CONTROL, TokenSource) - 24usize];
};
pub type TOKEN_CONTROL = _TOKEN_CONTROL;
pub type PTOKEN_CONTROL = *mut _TOKEN_CONTROL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_ORIGIN {
    pub OriginatingLogonSession: LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_ORIGIN"][::std::mem::size_of::<_TOKEN_ORIGIN>() - 8usize];
    ["Alignment of _TOKEN_ORIGIN"][::std::mem::align_of::<_TOKEN_ORIGIN>() - 4usize];
    ["Offset of field: _TOKEN_ORIGIN::OriginatingLogonSession"]
        [::std::mem::offset_of!(_TOKEN_ORIGIN, OriginatingLogonSession) - 0usize];
};
pub type TOKEN_ORIGIN = _TOKEN_ORIGIN;
pub type PTOKEN_ORIGIN = *mut _TOKEN_ORIGIN;
pub const _MANDATORY_LEVEL_MandatoryLevelUntrusted: _MANDATORY_LEVEL = 0;
pub const _MANDATORY_LEVEL_MandatoryLevelLow: _MANDATORY_LEVEL = 1;
pub const _MANDATORY_LEVEL_MandatoryLevelMedium: _MANDATORY_LEVEL = 2;
pub const _MANDATORY_LEVEL_MandatoryLevelHigh: _MANDATORY_LEVEL = 3;
pub const _MANDATORY_LEVEL_MandatoryLevelSystem: _MANDATORY_LEVEL = 4;
pub const _MANDATORY_LEVEL_MandatoryLevelSecureProcess: _MANDATORY_LEVEL = 5;
pub const _MANDATORY_LEVEL_MandatoryLevelCount: _MANDATORY_LEVEL = 6;
pub type _MANDATORY_LEVEL = ::std::os::raw::c_int;
pub use self::_MANDATORY_LEVEL as MANDATORY_LEVEL;
pub type PMANDATORY_LEVEL = *mut _MANDATORY_LEVEL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_APPCONTAINER_INFORMATION {
    pub TokenAppContainer: PSID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_APPCONTAINER_INFORMATION"]
        [::std::mem::size_of::<_TOKEN_APPCONTAINER_INFORMATION>() - 8usize];
    ["Alignment of _TOKEN_APPCONTAINER_INFORMATION"]
        [::std::mem::align_of::<_TOKEN_APPCONTAINER_INFORMATION>() - 8usize];
    ["Offset of field: _TOKEN_APPCONTAINER_INFORMATION::TokenAppContainer"]
        [::std::mem::offset_of!(_TOKEN_APPCONTAINER_INFORMATION, TokenAppContainer) - 0usize];
};
pub type TOKEN_APPCONTAINER_INFORMATION = _TOKEN_APPCONTAINER_INFORMATION;
pub type PTOKEN_APPCONTAINER_INFORMATION = *mut _TOKEN_APPCONTAINER_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_SID_INFORMATION {
    pub Sid: PSID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_SID_INFORMATION"][::std::mem::size_of::<_TOKEN_SID_INFORMATION>() - 8usize];
    ["Alignment of _TOKEN_SID_INFORMATION"]
        [::std::mem::align_of::<_TOKEN_SID_INFORMATION>() - 8usize];
    ["Offset of field: _TOKEN_SID_INFORMATION::Sid"]
        [::std::mem::offset_of!(_TOKEN_SID_INFORMATION, Sid) - 0usize];
};
pub type TOKEN_SID_INFORMATION = _TOKEN_SID_INFORMATION;
pub type PTOKEN_SID_INFORMATION = *mut _TOKEN_SID_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TOKEN_BNO_ISOLATION_INFORMATION {
    pub IsolationPrefix: PWSTR,
    pub IsolationEnabled: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TOKEN_BNO_ISOLATION_INFORMATION"]
        [::std::mem::size_of::<_TOKEN_BNO_ISOLATION_INFORMATION>() - 16usize];
    ["Alignment of _TOKEN_BNO_ISOLATION_INFORMATION"]
        [::std::mem::align_of::<_TOKEN_BNO_ISOLATION_INFORMATION>() - 8usize];
    ["Offset of field: _TOKEN_BNO_ISOLATION_INFORMATION::IsolationPrefix"]
        [::std::mem::offset_of!(_TOKEN_BNO_ISOLATION_INFORMATION, IsolationPrefix) - 0usize];
    ["Offset of field: _TOKEN_BNO_ISOLATION_INFORMATION::IsolationEnabled"]
        [::std::mem::offset_of!(_TOKEN_BNO_ISOLATION_INFORMATION, IsolationEnabled) - 8usize];
};
pub type TOKEN_BNO_ISOLATION_INFORMATION = _TOKEN_BNO_ISOLATION_INFORMATION;
pub type PTOKEN_BNO_ISOLATION_INFORMATION = *mut _TOKEN_BNO_ISOLATION_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE {
    pub Version: DWORD64,
    pub Name: PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE>() - 16usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE::Version"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE, Version) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE::Name"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE, Name) - 8usize];
};
pub type CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE = _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE;
pub type PCLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE = *mut _CLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE {
    pub pValue: PVOID,
    pub ValueLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE>() - 16usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE::pValue"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE, pValue) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE::ValueLength"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE,
        ValueLength
    ) - 8usize];
};
pub type CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE = _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE;
pub type PCLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE =
    *mut _CLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CLAIM_SECURITY_ATTRIBUTE_V1 {
    pub Name: PWSTR,
    pub ValueType: WORD,
    pub Reserved: WORD,
    pub Flags: DWORD,
    pub ValueCount: DWORD,
    pub Values: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1 {
    pub pInt64: PLONG64,
    pub pUint64: PDWORD64,
    pub ppString: *mut PWSTR,
    pub pFqbn: PCLAIM_SECURITY_ATTRIBUTE_FQBN_VALUE,
    pub pOctetString: PCLAIM_SECURITY_ATTRIBUTE_OCTET_STRING_VALUE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1>() - 8usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1::pInt64"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1, pInt64) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1::pUint64"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1, pUint64) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1::ppString"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1, ppString) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1::pFqbn"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1, pFqbn) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1::pOctetString"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1__bindgen_ty_1, pOctetString) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_V1"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_V1>() - 32usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_V1"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_V1>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::Name"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, Name) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::ValueType"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, ValueType) - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::Reserved"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, Reserved) - 10usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::Flags"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, Flags) - 12usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::ValueCount"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, ValueCount) - 16usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_V1::Values"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_V1, Values) - 24usize];
};
pub type CLAIM_SECURITY_ATTRIBUTE_V1 = _CLAIM_SECURITY_ATTRIBUTE_V1;
pub type PCLAIM_SECURITY_ATTRIBUTE_V1 = *mut _CLAIM_SECURITY_ATTRIBUTE_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1 {
    pub Name: DWORD,
    pub ValueType: WORD,
    pub Reserved: WORD,
    pub Flags: DWORD,
    pub ValueCount: DWORD,
    pub Values: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1 {
    pub pInt64: [DWORD; 1usize],
    pub pUint64: [DWORD; 1usize],
    pub ppString: [DWORD; 1usize],
    pub pFqbn: [DWORD; 1usize],
    pub pOctetString: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1>() - 4usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1>() - 4usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1::pInt64"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
        pInt64
    ) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1::pUint64"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
        pUint64
    ) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1::ppString"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
        ppString
    ) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1::pFqbn"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
        pFqbn
    ) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1::pOctetString"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1__bindgen_ty_1,
        pOctetString
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1>() - 20usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1>() - 4usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::Name"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, Name) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::ValueType"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, ValueType) - 4usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::Reserved"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, Reserved) - 6usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::Flags"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, Flags) - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::ValueCount"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, ValueCount) - 12usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1::Values"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1, Values) - 16usize];
};
pub type CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1 = _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1;
pub type PCLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1 = *mut _CLAIM_SECURITY_ATTRIBUTE_RELATIVE_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CLAIM_SECURITY_ATTRIBUTES_INFORMATION {
    pub Version: WORD,
    pub Reserved: WORD,
    pub AttributeCount: DWORD,
    pub Attribute: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1 {
    pub pAttributeV1: PCLAIM_SECURITY_ATTRIBUTE_V1,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1>() - 8usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1::pAttributeV1"][::std::mem::offset_of!(
        _CLAIM_SECURITY_ATTRIBUTES_INFORMATION__bindgen_ty_1,
        pAttributeV1
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLAIM_SECURITY_ATTRIBUTES_INFORMATION"]
        [::std::mem::size_of::<_CLAIM_SECURITY_ATTRIBUTES_INFORMATION>() - 16usize];
    ["Alignment of _CLAIM_SECURITY_ATTRIBUTES_INFORMATION"]
        [::std::mem::align_of::<_CLAIM_SECURITY_ATTRIBUTES_INFORMATION>() - 8usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION::Version"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTES_INFORMATION, Version) - 0usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION::Reserved"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTES_INFORMATION, Reserved) - 2usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION::AttributeCount"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTES_INFORMATION, AttributeCount) - 4usize];
    ["Offset of field: _CLAIM_SECURITY_ATTRIBUTES_INFORMATION::Attribute"]
        [::std::mem::offset_of!(_CLAIM_SECURITY_ATTRIBUTES_INFORMATION, Attribute) - 8usize];
};
pub type CLAIM_SECURITY_ATTRIBUTES_INFORMATION = _CLAIM_SECURITY_ATTRIBUTES_INFORMATION;
pub type PCLAIM_SECURITY_ATTRIBUTES_INFORMATION = *mut _CLAIM_SECURITY_ATTRIBUTES_INFORMATION;
pub type SECURITY_CONTEXT_TRACKING_MODE = BOOLEAN;
pub type PSECURITY_CONTEXT_TRACKING_MODE = *mut BOOLEAN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_QUALITY_OF_SERVICE {
    pub Length: DWORD,
    pub ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL,
    pub ContextTrackingMode: SECURITY_CONTEXT_TRACKING_MODE,
    pub EffectiveOnly: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_QUALITY_OF_SERVICE"]
        [::std::mem::size_of::<_SECURITY_QUALITY_OF_SERVICE>() - 12usize];
    ["Alignment of _SECURITY_QUALITY_OF_SERVICE"]
        [::std::mem::align_of::<_SECURITY_QUALITY_OF_SERVICE>() - 4usize];
    ["Offset of field: _SECURITY_QUALITY_OF_SERVICE::Length"]
        [::std::mem::offset_of!(_SECURITY_QUALITY_OF_SERVICE, Length) - 0usize];
    ["Offset of field: _SECURITY_QUALITY_OF_SERVICE::ImpersonationLevel"]
        [::std::mem::offset_of!(_SECURITY_QUALITY_OF_SERVICE, ImpersonationLevel) - 4usize];
    ["Offset of field: _SECURITY_QUALITY_OF_SERVICE::ContextTrackingMode"]
        [::std::mem::offset_of!(_SECURITY_QUALITY_OF_SERVICE, ContextTrackingMode) - 8usize];
    ["Offset of field: _SECURITY_QUALITY_OF_SERVICE::EffectiveOnly"]
        [::std::mem::offset_of!(_SECURITY_QUALITY_OF_SERVICE, EffectiveOnly) - 9usize];
};
pub type SECURITY_QUALITY_OF_SERVICE = _SECURITY_QUALITY_OF_SERVICE;
pub type PSECURITY_QUALITY_OF_SERVICE = *mut _SECURITY_QUALITY_OF_SERVICE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SE_IMPERSONATION_STATE {
    pub Token: PACCESS_TOKEN,
    pub CopyOnOpen: BOOLEAN,
    pub EffectiveOnly: BOOLEAN,
    pub Level: SECURITY_IMPERSONATION_LEVEL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SE_IMPERSONATION_STATE"][::std::mem::size_of::<_SE_IMPERSONATION_STATE>() - 16usize];
    ["Alignment of _SE_IMPERSONATION_STATE"]
        [::std::mem::align_of::<_SE_IMPERSONATION_STATE>() - 8usize];
    ["Offset of field: _SE_IMPERSONATION_STATE::Token"]
        [::std::mem::offset_of!(_SE_IMPERSONATION_STATE, Token) - 0usize];
    ["Offset of field: _SE_IMPERSONATION_STATE::CopyOnOpen"]
        [::std::mem::offset_of!(_SE_IMPERSONATION_STATE, CopyOnOpen) - 8usize];
    ["Offset of field: _SE_IMPERSONATION_STATE::EffectiveOnly"]
        [::std::mem::offset_of!(_SE_IMPERSONATION_STATE, EffectiveOnly) - 9usize];
    ["Offset of field: _SE_IMPERSONATION_STATE::Level"]
        [::std::mem::offset_of!(_SE_IMPERSONATION_STATE, Level) - 12usize];
};
pub type SE_IMPERSONATION_STATE = _SE_IMPERSONATION_STATE;
pub type PSE_IMPERSONATION_STATE = *mut _SE_IMPERSONATION_STATE;
pub type SECURITY_INFORMATION = DWORD;
pub type PSECURITY_INFORMATION = *mut DWORD;
pub type SE_SIGNING_LEVEL = BYTE;
pub type PSE_SIGNING_LEVEL = *mut BYTE;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureNone: _SE_IMAGE_SIGNATURE_TYPE = 0;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureEmbedded: _SE_IMAGE_SIGNATURE_TYPE = 1;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureCache: _SE_IMAGE_SIGNATURE_TYPE = 2;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureCatalogCached: _SE_IMAGE_SIGNATURE_TYPE = 3;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureCatalogNotCached: _SE_IMAGE_SIGNATURE_TYPE = 4;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignatureCatalogHint: _SE_IMAGE_SIGNATURE_TYPE = 5;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignaturePackageCatalog: _SE_IMAGE_SIGNATURE_TYPE = 6;
pub const _SE_IMAGE_SIGNATURE_TYPE_SeImageSignaturePplMitigated: _SE_IMAGE_SIGNATURE_TYPE = 7;
pub type _SE_IMAGE_SIGNATURE_TYPE = ::std::os::raw::c_int;
pub use self::_SE_IMAGE_SIGNATURE_TYPE as SE_IMAGE_SIGNATURE_TYPE;
pub type PSE_IMAGE_SIGNATURE_TYPE = *mut _SE_IMAGE_SIGNATURE_TYPE;
pub const _SE_LEARNING_MODE_DATA_TYPE_SeLearningModeInvalidType: _SE_LEARNING_MODE_DATA_TYPE = 0;
pub const _SE_LEARNING_MODE_DATA_TYPE_SeLearningModeSettings: _SE_LEARNING_MODE_DATA_TYPE = 1;
pub const _SE_LEARNING_MODE_DATA_TYPE_SeLearningModeMax: _SE_LEARNING_MODE_DATA_TYPE = 2;
pub type _SE_LEARNING_MODE_DATA_TYPE = ::std::os::raw::c_int;
pub use self::_SE_LEARNING_MODE_DATA_TYPE as SE_LEARNING_MODE_DATA_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_CAPABILITIES {
    pub AppContainerSid: PSID,
    pub Capabilities: PSID_AND_ATTRIBUTES,
    pub CapabilityCount: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_CAPABILITIES"][::std::mem::size_of::<_SECURITY_CAPABILITIES>() - 24usize];
    ["Alignment of _SECURITY_CAPABILITIES"]
        [::std::mem::align_of::<_SECURITY_CAPABILITIES>() - 8usize];
    ["Offset of field: _SECURITY_CAPABILITIES::AppContainerSid"]
        [::std::mem::offset_of!(_SECURITY_CAPABILITIES, AppContainerSid) - 0usize];
    ["Offset of field: _SECURITY_CAPABILITIES::Capabilities"]
        [::std::mem::offset_of!(_SECURITY_CAPABILITIES, Capabilities) - 8usize];
    ["Offset of field: _SECURITY_CAPABILITIES::CapabilityCount"]
        [::std::mem::offset_of!(_SECURITY_CAPABILITIES, CapabilityCount) - 16usize];
    ["Offset of field: _SECURITY_CAPABILITIES::Reserved"]
        [::std::mem::offset_of!(_SECURITY_CAPABILITIES, Reserved) - 20usize];
};
pub type SECURITY_CAPABILITIES = _SECURITY_CAPABILITIES;
pub type PSECURITY_CAPABILITIES = *mut _SECURITY_CAPABILITIES;
pub type LPSECURITY_CAPABILITIES = *mut _SECURITY_CAPABILITIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_SET_ARRAY {
    pub JobHandle: HANDLE,
    pub MemberLevel: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_SET_ARRAY"][::std::mem::size_of::<_JOB_SET_ARRAY>() - 16usize];
    ["Alignment of _JOB_SET_ARRAY"][::std::mem::align_of::<_JOB_SET_ARRAY>() - 8usize];
    ["Offset of field: _JOB_SET_ARRAY::JobHandle"]
        [::std::mem::offset_of!(_JOB_SET_ARRAY, JobHandle) - 0usize];
    ["Offset of field: _JOB_SET_ARRAY::MemberLevel"]
        [::std::mem::offset_of!(_JOB_SET_ARRAY, MemberLevel) - 8usize];
    ["Offset of field: _JOB_SET_ARRAY::Flags"]
        [::std::mem::offset_of!(_JOB_SET_ARRAY, Flags) - 12usize];
};
pub type JOB_SET_ARRAY = _JOB_SET_ARRAY;
pub type PJOB_SET_ARRAY = *mut _JOB_SET_ARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_REGISTRATION_RECORD {
    pub Next: *mut _EXCEPTION_REGISTRATION_RECORD,
    pub Handler: PEXCEPTION_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_REGISTRATION_RECORD"]
        [::std::mem::size_of::<_EXCEPTION_REGISTRATION_RECORD>() - 16usize];
    ["Alignment of _EXCEPTION_REGISTRATION_RECORD"]
        [::std::mem::align_of::<_EXCEPTION_REGISTRATION_RECORD>() - 8usize];
    ["Offset of field: _EXCEPTION_REGISTRATION_RECORD::Next"]
        [::std::mem::offset_of!(_EXCEPTION_REGISTRATION_RECORD, Next) - 0usize];
    ["Offset of field: _EXCEPTION_REGISTRATION_RECORD::Handler"]
        [::std::mem::offset_of!(_EXCEPTION_REGISTRATION_RECORD, Handler) - 8usize];
};
pub type EXCEPTION_REGISTRATION_RECORD = _EXCEPTION_REGISTRATION_RECORD;
pub type PEXCEPTION_REGISTRATION_RECORD = *mut EXCEPTION_REGISTRATION_RECORD;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NT_TIB {
    pub ExceptionList: *mut _EXCEPTION_REGISTRATION_RECORD,
    pub StackBase: PVOID,
    pub StackLimit: PVOID,
    pub SubSystemTib: PVOID,
    pub __bindgen_anon_1: _NT_TIB__bindgen_ty_1,
    pub ArbitraryUserPointer: PVOID,
    pub Self_: *mut _NT_TIB,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NT_TIB__bindgen_ty_1 {
    pub FiberData: PVOID,
    pub Version: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB__bindgen_ty_1"][::std::mem::size_of::<_NT_TIB__bindgen_ty_1>() - 8usize];
    ["Alignment of _NT_TIB__bindgen_ty_1"]
        [::std::mem::align_of::<_NT_TIB__bindgen_ty_1>() - 8usize];
    ["Offset of field: _NT_TIB__bindgen_ty_1::FiberData"]
        [::std::mem::offset_of!(_NT_TIB__bindgen_ty_1, FiberData) - 0usize];
    ["Offset of field: _NT_TIB__bindgen_ty_1::Version"]
        [::std::mem::offset_of!(_NT_TIB__bindgen_ty_1, Version) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB"][::std::mem::size_of::<_NT_TIB>() - 56usize];
    ["Alignment of _NT_TIB"][::std::mem::align_of::<_NT_TIB>() - 8usize];
    ["Offset of field: _NT_TIB::ExceptionList"]
        [::std::mem::offset_of!(_NT_TIB, ExceptionList) - 0usize];
    ["Offset of field: _NT_TIB::StackBase"][::std::mem::offset_of!(_NT_TIB, StackBase) - 8usize];
    ["Offset of field: _NT_TIB::StackLimit"][::std::mem::offset_of!(_NT_TIB, StackLimit) - 16usize];
    ["Offset of field: _NT_TIB::SubSystemTib"]
        [::std::mem::offset_of!(_NT_TIB, SubSystemTib) - 24usize];
    ["Offset of field: _NT_TIB::ArbitraryUserPointer"]
        [::std::mem::offset_of!(_NT_TIB, ArbitraryUserPointer) - 40usize];
    ["Offset of field: _NT_TIB::Self_"][::std::mem::offset_of!(_NT_TIB, Self_) - 48usize];
};
pub type NT_TIB = _NT_TIB;
pub type PNT_TIB = *mut NT_TIB;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NT_TIB32 {
    pub ExceptionList: DWORD,
    pub StackBase: DWORD,
    pub StackLimit: DWORD,
    pub SubSystemTib: DWORD,
    pub __bindgen_anon_1: _NT_TIB32__bindgen_ty_1,
    pub ArbitraryUserPointer: DWORD,
    pub Self_: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NT_TIB32__bindgen_ty_1 {
    pub FiberData: DWORD,
    pub Version: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB32__bindgen_ty_1"][::std::mem::size_of::<_NT_TIB32__bindgen_ty_1>() - 4usize];
    ["Alignment of _NT_TIB32__bindgen_ty_1"]
        [::std::mem::align_of::<_NT_TIB32__bindgen_ty_1>() - 4usize];
    ["Offset of field: _NT_TIB32__bindgen_ty_1::FiberData"]
        [::std::mem::offset_of!(_NT_TIB32__bindgen_ty_1, FiberData) - 0usize];
    ["Offset of field: _NT_TIB32__bindgen_ty_1::Version"]
        [::std::mem::offset_of!(_NT_TIB32__bindgen_ty_1, Version) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB32"][::std::mem::size_of::<_NT_TIB32>() - 28usize];
    ["Alignment of _NT_TIB32"][::std::mem::align_of::<_NT_TIB32>() - 4usize];
    ["Offset of field: _NT_TIB32::ExceptionList"]
        [::std::mem::offset_of!(_NT_TIB32, ExceptionList) - 0usize];
    ["Offset of field: _NT_TIB32::StackBase"]
        [::std::mem::offset_of!(_NT_TIB32, StackBase) - 4usize];
    ["Offset of field: _NT_TIB32::StackLimit"]
        [::std::mem::offset_of!(_NT_TIB32, StackLimit) - 8usize];
    ["Offset of field: _NT_TIB32::SubSystemTib"]
        [::std::mem::offset_of!(_NT_TIB32, SubSystemTib) - 12usize];
    ["Offset of field: _NT_TIB32::ArbitraryUserPointer"]
        [::std::mem::offset_of!(_NT_TIB32, ArbitraryUserPointer) - 20usize];
    ["Offset of field: _NT_TIB32::Self_"][::std::mem::offset_of!(_NT_TIB32, Self_) - 24usize];
};
pub type NT_TIB32 = _NT_TIB32;
pub type PNT_TIB32 = *mut _NT_TIB32;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NT_TIB64 {
    pub ExceptionList: DWORD64,
    pub StackBase: DWORD64,
    pub StackLimit: DWORD64,
    pub SubSystemTib: DWORD64,
    pub __bindgen_anon_1: _NT_TIB64__bindgen_ty_1,
    pub ArbitraryUserPointer: DWORD64,
    pub Self_: DWORD64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NT_TIB64__bindgen_ty_1 {
    pub FiberData: DWORD64,
    pub Version: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB64__bindgen_ty_1"][::std::mem::size_of::<_NT_TIB64__bindgen_ty_1>() - 8usize];
    ["Alignment of _NT_TIB64__bindgen_ty_1"]
        [::std::mem::align_of::<_NT_TIB64__bindgen_ty_1>() - 8usize];
    ["Offset of field: _NT_TIB64__bindgen_ty_1::FiberData"]
        [::std::mem::offset_of!(_NT_TIB64__bindgen_ty_1, FiberData) - 0usize];
    ["Offset of field: _NT_TIB64__bindgen_ty_1::Version"]
        [::std::mem::offset_of!(_NT_TIB64__bindgen_ty_1, Version) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NT_TIB64"][::std::mem::size_of::<_NT_TIB64>() - 56usize];
    ["Alignment of _NT_TIB64"][::std::mem::align_of::<_NT_TIB64>() - 8usize];
    ["Offset of field: _NT_TIB64::ExceptionList"]
        [::std::mem::offset_of!(_NT_TIB64, ExceptionList) - 0usize];
    ["Offset of field: _NT_TIB64::StackBase"]
        [::std::mem::offset_of!(_NT_TIB64, StackBase) - 8usize];
    ["Offset of field: _NT_TIB64::StackLimit"]
        [::std::mem::offset_of!(_NT_TIB64, StackLimit) - 16usize];
    ["Offset of field: _NT_TIB64::SubSystemTib"]
        [::std::mem::offset_of!(_NT_TIB64, SubSystemTib) - 24usize];
    ["Offset of field: _NT_TIB64::ArbitraryUserPointer"]
        [::std::mem::offset_of!(_NT_TIB64, ArbitraryUserPointer) - 40usize];
    ["Offset of field: _NT_TIB64::Self_"][::std::mem::offset_of!(_NT_TIB64, Self_) - 48usize];
};
pub type NT_TIB64 = _NT_TIB64;
pub type PNT_TIB64 = *mut _NT_TIB64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UMS_CREATE_THREAD_ATTRIBUTES {
    pub UmsVersion: DWORD,
    pub UmsContext: PVOID,
    pub UmsCompletionList: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UMS_CREATE_THREAD_ATTRIBUTES"]
        [::std::mem::size_of::<_UMS_CREATE_THREAD_ATTRIBUTES>() - 24usize];
    ["Alignment of _UMS_CREATE_THREAD_ATTRIBUTES"]
        [::std::mem::align_of::<_UMS_CREATE_THREAD_ATTRIBUTES>() - 8usize];
    ["Offset of field: _UMS_CREATE_THREAD_ATTRIBUTES::UmsVersion"]
        [::std::mem::offset_of!(_UMS_CREATE_THREAD_ATTRIBUTES, UmsVersion) - 0usize];
    ["Offset of field: _UMS_CREATE_THREAD_ATTRIBUTES::UmsContext"]
        [::std::mem::offset_of!(_UMS_CREATE_THREAD_ATTRIBUTES, UmsContext) - 8usize];
    ["Offset of field: _UMS_CREATE_THREAD_ATTRIBUTES::UmsCompletionList"]
        [::std::mem::offset_of!(_UMS_CREATE_THREAD_ATTRIBUTES, UmsCompletionList) - 16usize];
};
pub type UMS_CREATE_THREAD_ATTRIBUTES = _UMS_CREATE_THREAD_ATTRIBUTES;
pub type PUMS_CREATE_THREAD_ATTRIBUTES = *mut _UMS_CREATE_THREAD_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMPONENT_FILTER {
    pub ComponentFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMPONENT_FILTER"][::std::mem::size_of::<_COMPONENT_FILTER>() - 4usize];
    ["Alignment of _COMPONENT_FILTER"][::std::mem::align_of::<_COMPONENT_FILTER>() - 4usize];
    ["Offset of field: _COMPONENT_FILTER::ComponentFlags"]
        [::std::mem::offset_of!(_COMPONENT_FILTER, ComponentFlags) - 0usize];
};
pub type COMPONENT_FILTER = _COMPONENT_FILTER;
pub type PCOMPONENT_FILTER = *mut _COMPONENT_FILTER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET {
    pub TargetAddress: ULONG_PTR,
    pub Flags: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET"]
        [::std::mem::size_of::<_PROCESS_DYNAMIC_EH_CONTINUATION_TARGET>() - 16usize];
    ["Alignment of _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET"]
        [::std::mem::align_of::<_PROCESS_DYNAMIC_EH_CONTINUATION_TARGET>() - 8usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET::TargetAddress"]
        [::std::mem::offset_of!(_PROCESS_DYNAMIC_EH_CONTINUATION_TARGET, TargetAddress) - 0usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET::Flags"]
        [::std::mem::offset_of!(_PROCESS_DYNAMIC_EH_CONTINUATION_TARGET, Flags) - 8usize];
};
pub type PROCESS_DYNAMIC_EH_CONTINUATION_TARGET = _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET;
pub type PPROCESS_DYNAMIC_EH_CONTINUATION_TARGET = *mut _PROCESS_DYNAMIC_EH_CONTINUATION_TARGET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION {
    pub NumberOfTargets: WORD,
    pub Reserved: WORD,
    pub Reserved2: DWORD,
    pub Targets: PPROCESS_DYNAMIC_EH_CONTINUATION_TARGET,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION"]
        [::std::mem::size_of::<_PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION>() - 16usize];
    ["Alignment of _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION"]
        [::std::mem::align_of::<_PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION>() - 8usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION::NumberOfTargets"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION,
        NumberOfTargets
    )
        - 0usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION::Reserved"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION,
        Reserved
    ) - 2usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION::Reserved2"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION,
        Reserved2
    )
        - 4usize];
    ["Offset of field: _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION::Targets"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION,
        Targets
    ) - 8usize];
};
pub type PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION =
    _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION;
pub type PPROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION =
    *mut _PROCESS_DYNAMIC_EH_CONTINUATION_TARGETS_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE {
    pub BaseAddress: ULONG_PTR,
    pub Size: SIZE_T,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE"]
        [::std::mem::size_of::<_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE>() - 24usize];
    ["Alignment of _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE"]
        [::std::mem::align_of::<_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE>() - 8usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE::BaseAddress"]
        [::std::mem::offset_of!(_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE, BaseAddress) - 0usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE::Size"]
        [::std::mem::offset_of!(_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE, Size) - 8usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE::Flags"]
        [::std::mem::offset_of!(_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE, Flags) - 16usize];
};
pub type PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE = _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE;
pub type PPROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE = *mut _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION {
    pub NumberOfRanges: WORD,
    pub Reserved: WORD,
    pub Reserved2: DWORD,
    pub Ranges: PPROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION"]
        [::std::mem::size_of::<_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION>() - 16usize];
    ["Alignment of _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION"]
        [::std::mem::align_of::<_PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION>() - 8usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION::NumberOfRanges"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION,
        NumberOfRanges
    )
        - 0usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION::Reserved"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION,
        Reserved
    ) - 2usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION::Reserved2"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION,
        Reserved2
    )
        - 4usize];
    ["Offset of field: _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION::Ranges"][::std::mem::offset_of!(
        _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION,
        Ranges
    ) - 8usize];
};
pub type PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION =
    _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION;
pub type PPROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION =
    *mut _PROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGES_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _QUOTA_LIMITS {
    pub PagedPoolLimit: SIZE_T,
    pub NonPagedPoolLimit: SIZE_T,
    pub MinimumWorkingSetSize: SIZE_T,
    pub MaximumWorkingSetSize: SIZE_T,
    pub PagefileLimit: SIZE_T,
    pub TimeLimit: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUOTA_LIMITS"][::std::mem::size_of::<_QUOTA_LIMITS>() - 48usize];
    ["Alignment of _QUOTA_LIMITS"][::std::mem::align_of::<_QUOTA_LIMITS>() - 8usize];
    ["Offset of field: _QUOTA_LIMITS::PagedPoolLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, PagedPoolLimit) - 0usize];
    ["Offset of field: _QUOTA_LIMITS::NonPagedPoolLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, NonPagedPoolLimit) - 8usize];
    ["Offset of field: _QUOTA_LIMITS::MinimumWorkingSetSize"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, MinimumWorkingSetSize) - 16usize];
    ["Offset of field: _QUOTA_LIMITS::MaximumWorkingSetSize"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, MaximumWorkingSetSize) - 24usize];
    ["Offset of field: _QUOTA_LIMITS::PagefileLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, PagefileLimit) - 32usize];
    ["Offset of field: _QUOTA_LIMITS::TimeLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS, TimeLimit) - 40usize];
};
pub type QUOTA_LIMITS = _QUOTA_LIMITS;
pub type PQUOTA_LIMITS = *mut _QUOTA_LIMITS;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RATE_QUOTA_LIMIT {
    pub RateData: DWORD,
    pub __bindgen_anon_1: _RATE_QUOTA_LIMIT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RATE_QUOTA_LIMIT__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RATE_QUOTA_LIMIT__bindgen_ty_1"]
        [::std::mem::size_of::<_RATE_QUOTA_LIMIT__bindgen_ty_1>() - 4usize];
    ["Alignment of _RATE_QUOTA_LIMIT__bindgen_ty_1"]
        [::std::mem::align_of::<_RATE_QUOTA_LIMIT__bindgen_ty_1>() - 4usize];
};
impl _RATE_QUOTA_LIMIT__bindgen_ty_1 {
    #[inline]
    pub fn RatePercent(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 7u8) as u32) }
    }
    #[inline]
    pub fn set_RatePercent(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RatePercent_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                7u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RatePercent_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved0(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 25u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved0(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 25u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved0_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                25u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved0_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                25u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        RatePercent: DWORD,
        Reserved0: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 7u8, {
            let RatePercent: u32 = unsafe { ::std::mem::transmute(RatePercent) };
            RatePercent as u64
        });
        __bindgen_bitfield_unit.set(7usize, 25u8, {
            let Reserved0: u32 = unsafe { ::std::mem::transmute(Reserved0) };
            Reserved0 as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RATE_QUOTA_LIMIT"][::std::mem::size_of::<_RATE_QUOTA_LIMIT>() - 4usize];
    ["Alignment of _RATE_QUOTA_LIMIT"][::std::mem::align_of::<_RATE_QUOTA_LIMIT>() - 4usize];
    ["Offset of field: _RATE_QUOTA_LIMIT::RateData"]
        [::std::mem::offset_of!(_RATE_QUOTA_LIMIT, RateData) - 0usize];
};
pub type RATE_QUOTA_LIMIT = _RATE_QUOTA_LIMIT;
pub type PRATE_QUOTA_LIMIT = *mut _RATE_QUOTA_LIMIT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _QUOTA_LIMITS_EX {
    pub PagedPoolLimit: SIZE_T,
    pub NonPagedPoolLimit: SIZE_T,
    pub MinimumWorkingSetSize: SIZE_T,
    pub MaximumWorkingSetSize: SIZE_T,
    pub PagefileLimit: SIZE_T,
    pub TimeLimit: LARGE_INTEGER,
    pub WorkingSetLimit: SIZE_T,
    pub Reserved2: SIZE_T,
    pub Reserved3: SIZE_T,
    pub Reserved4: SIZE_T,
    pub Flags: DWORD,
    pub CpuRateLimit: RATE_QUOTA_LIMIT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUOTA_LIMITS_EX"][::std::mem::size_of::<_QUOTA_LIMITS_EX>() - 88usize];
    ["Alignment of _QUOTA_LIMITS_EX"][::std::mem::align_of::<_QUOTA_LIMITS_EX>() - 8usize];
    ["Offset of field: _QUOTA_LIMITS_EX::PagedPoolLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, PagedPoolLimit) - 0usize];
    ["Offset of field: _QUOTA_LIMITS_EX::NonPagedPoolLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, NonPagedPoolLimit) - 8usize];
    ["Offset of field: _QUOTA_LIMITS_EX::MinimumWorkingSetSize"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, MinimumWorkingSetSize) - 16usize];
    ["Offset of field: _QUOTA_LIMITS_EX::MaximumWorkingSetSize"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, MaximumWorkingSetSize) - 24usize];
    ["Offset of field: _QUOTA_LIMITS_EX::PagefileLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, PagefileLimit) - 32usize];
    ["Offset of field: _QUOTA_LIMITS_EX::TimeLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, TimeLimit) - 40usize];
    ["Offset of field: _QUOTA_LIMITS_EX::WorkingSetLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, WorkingSetLimit) - 48usize];
    ["Offset of field: _QUOTA_LIMITS_EX::Reserved2"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, Reserved2) - 56usize];
    ["Offset of field: _QUOTA_LIMITS_EX::Reserved3"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, Reserved3) - 64usize];
    ["Offset of field: _QUOTA_LIMITS_EX::Reserved4"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, Reserved4) - 72usize];
    ["Offset of field: _QUOTA_LIMITS_EX::Flags"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, Flags) - 80usize];
    ["Offset of field: _QUOTA_LIMITS_EX::CpuRateLimit"]
        [::std::mem::offset_of!(_QUOTA_LIMITS_EX, CpuRateLimit) - 84usize];
};
pub type QUOTA_LIMITS_EX = _QUOTA_LIMITS_EX;
pub type PQUOTA_LIMITS_EX = *mut _QUOTA_LIMITS_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IO_COUNTERS {
    pub ReadOperationCount: ULONGLONG,
    pub WriteOperationCount: ULONGLONG,
    pub OtherOperationCount: ULONGLONG,
    pub ReadTransferCount: ULONGLONG,
    pub WriteTransferCount: ULONGLONG,
    pub OtherTransferCount: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IO_COUNTERS"][::std::mem::size_of::<_IO_COUNTERS>() - 48usize];
    ["Alignment of _IO_COUNTERS"][::std::mem::align_of::<_IO_COUNTERS>() - 8usize];
    ["Offset of field: _IO_COUNTERS::ReadOperationCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, ReadOperationCount) - 0usize];
    ["Offset of field: _IO_COUNTERS::WriteOperationCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, WriteOperationCount) - 8usize];
    ["Offset of field: _IO_COUNTERS::OtherOperationCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, OtherOperationCount) - 16usize];
    ["Offset of field: _IO_COUNTERS::ReadTransferCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, ReadTransferCount) - 24usize];
    ["Offset of field: _IO_COUNTERS::WriteTransferCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, WriteTransferCount) - 32usize];
    ["Offset of field: _IO_COUNTERS::OtherTransferCount"]
        [::std::mem::offset_of!(_IO_COUNTERS, OtherTransferCount) - 40usize];
};
pub type IO_COUNTERS = _IO_COUNTERS;
pub type PIO_COUNTERS = *mut IO_COUNTERS;
pub const _HARDWARE_COUNTER_TYPE_PMCCounter: _HARDWARE_COUNTER_TYPE = 0;
pub const _HARDWARE_COUNTER_TYPE_MaxHardwareCounterType: _HARDWARE_COUNTER_TYPE = 1;
pub type _HARDWARE_COUNTER_TYPE = ::std::os::raw::c_int;
pub use self::_HARDWARE_COUNTER_TYPE as HARDWARE_COUNTER_TYPE;
pub type PHARDWARE_COUNTER_TYPE = *mut _HARDWARE_COUNTER_TYPE;
pub const _PROCESS_MITIGATION_POLICY_ProcessDEPPolicy: _PROCESS_MITIGATION_POLICY = 0;
pub const _PROCESS_MITIGATION_POLICY_ProcessASLRPolicy: _PROCESS_MITIGATION_POLICY = 1;
pub const _PROCESS_MITIGATION_POLICY_ProcessDynamicCodePolicy: _PROCESS_MITIGATION_POLICY = 2;
pub const _PROCESS_MITIGATION_POLICY_ProcessStrictHandleCheckPolicy: _PROCESS_MITIGATION_POLICY = 3;
pub const _PROCESS_MITIGATION_POLICY_ProcessSystemCallDisablePolicy: _PROCESS_MITIGATION_POLICY = 4;
pub const _PROCESS_MITIGATION_POLICY_ProcessMitigationOptionsMask: _PROCESS_MITIGATION_POLICY = 5;
pub const _PROCESS_MITIGATION_POLICY_ProcessExtensionPointDisablePolicy:
    _PROCESS_MITIGATION_POLICY = 6;
pub const _PROCESS_MITIGATION_POLICY_ProcessControlFlowGuardPolicy: _PROCESS_MITIGATION_POLICY = 7;
pub const _PROCESS_MITIGATION_POLICY_ProcessSignaturePolicy: _PROCESS_MITIGATION_POLICY = 8;
pub const _PROCESS_MITIGATION_POLICY_ProcessFontDisablePolicy: _PROCESS_MITIGATION_POLICY = 9;
pub const _PROCESS_MITIGATION_POLICY_ProcessImageLoadPolicy: _PROCESS_MITIGATION_POLICY = 10;
pub const _PROCESS_MITIGATION_POLICY_ProcessSystemCallFilterPolicy: _PROCESS_MITIGATION_POLICY = 11;
pub const _PROCESS_MITIGATION_POLICY_ProcessPayloadRestrictionPolicy: _PROCESS_MITIGATION_POLICY =
    12;
pub const _PROCESS_MITIGATION_POLICY_ProcessChildProcessPolicy: _PROCESS_MITIGATION_POLICY = 13;
pub const _PROCESS_MITIGATION_POLICY_ProcessSideChannelIsolationPolicy: _PROCESS_MITIGATION_POLICY =
    14;
pub const _PROCESS_MITIGATION_POLICY_ProcessUserShadowStackPolicy: _PROCESS_MITIGATION_POLICY = 15;
pub const _PROCESS_MITIGATION_POLICY_ProcessRedirectionTrustPolicy: _PROCESS_MITIGATION_POLICY = 16;
pub const _PROCESS_MITIGATION_POLICY_MaxProcessMitigationPolicy: _PROCESS_MITIGATION_POLICY = 17;
pub type _PROCESS_MITIGATION_POLICY = ::std::os::raw::c_int;
pub use self::_PROCESS_MITIGATION_POLICY as PROCESS_MITIGATION_POLICY;
pub type PPROCESS_MITIGATION_POLICY = *mut _PROCESS_MITIGATION_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_ASLR_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn EnableBottomUpRandomization(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableBottomUpRandomization(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableBottomUpRandomization_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableBottomUpRandomization_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableForceRelocateImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableForceRelocateImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableForceRelocateImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableForceRelocateImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableHighEntropy(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableHighEntropy(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableHighEntropy_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableHighEntropy_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DisallowStrippedImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisallowStrippedImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisallowStrippedImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisallowStrippedImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 28u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                28u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                28u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        EnableBottomUpRandomization: DWORD,
        EnableForceRelocateImages: DWORD,
        EnableHighEntropy: DWORD,
        DisallowStrippedImages: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let EnableBottomUpRandomization: u32 =
                unsafe { ::std::mem::transmute(EnableBottomUpRandomization) };
            EnableBottomUpRandomization as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let EnableForceRelocateImages: u32 =
                unsafe { ::std::mem::transmute(EnableForceRelocateImages) };
            EnableForceRelocateImages as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let EnableHighEntropy: u32 = unsafe { ::std::mem::transmute(EnableHighEntropy) };
            EnableHighEntropy as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let DisallowStrippedImages: u32 =
                unsafe { ::std::mem::transmute(DisallowStrippedImages) };
            DisallowStrippedImages as u64
        });
        __bindgen_bitfield_unit.set(4usize, 28u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(_PROCESS_MITIGATION_ASLR_POLICY__bindgen_ty_1, Flags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_ASLR_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_ASLR_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_ASLR_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_ASLR_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_ASLR_POLICY = _PROCESS_MITIGATION_ASLR_POLICY;
pub type PPROCESS_MITIGATION_ASLR_POLICY = *mut _PROCESS_MITIGATION_ASLR_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_DEP_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1,
    pub Permanent: BOOLEAN,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
};
impl _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn Enable(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Enable(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Enable_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Enable_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DisableAtlThunkEmulation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisableAtlThunkEmulation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisableAtlThunkEmulation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisableAtlThunkEmulation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Enable: DWORD,
        DisableAtlThunkEmulation: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let Enable: u32 = unsafe { ::std::mem::transmute(Enable) };
            Enable as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let DisableAtlThunkEmulation: u32 =
                unsafe { ::std::mem::transmute(DisableAtlThunkEmulation) };
            DisableAtlThunkEmulation as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(_PROCESS_MITIGATION_DEP_POLICY__bindgen_ty_1, Flags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DEP_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_DEP_POLICY>() - 8usize];
    ["Alignment of _PROCESS_MITIGATION_DEP_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_DEP_POLICY>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_DEP_POLICY::Permanent"]
        [::std::mem::offset_of!(_PROCESS_MITIGATION_DEP_POLICY, Permanent) - 4usize];
};
pub type PROCESS_MITIGATION_DEP_POLICY = _PROCESS_MITIGATION_DEP_POLICY;
pub type PPROCESS_MITIGATION_DEP_POLICY = *mut _PROCESS_MITIGATION_DEP_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1:
        _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn RaiseExceptionOnInvalidHandleReference(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_RaiseExceptionOnInvalidHandleReference(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RaiseExceptionOnInvalidHandleReference_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RaiseExceptionOnInvalidHandleReference_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn HandleExceptionsPermanentlyEnabled(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_HandleExceptionsPermanentlyEnabled(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn HandleExceptionsPermanentlyEnabled_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_HandleExceptionsPermanentlyEnabled_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        RaiseExceptionOnInvalidHandleReference: DWORD,
        HandleExceptionsPermanentlyEnabled: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let RaiseExceptionOnInvalidHandleReference: u32 =
                unsafe { ::std::mem::transmute(RaiseExceptionOnInvalidHandleReference) };
            RaiseExceptionOnInvalidHandleReference as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let HandleExceptionsPermanentlyEnabled: u32 =
                unsafe { ::std::mem::transmute(HandleExceptionsPermanentlyEnabled) };
            HandleExceptionsPermanentlyEnabled as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY =
    _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY;
pub type PPROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY =
    *mut _PROCESS_MITIGATION_STRICT_HANDLE_CHECK_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1:
        _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn DisallowWin32kSystemCalls(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisallowWin32kSystemCalls(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisallowWin32kSystemCalls_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisallowWin32kSystemCalls_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditDisallowWin32kSystemCalls(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditDisallowWin32kSystemCalls(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditDisallowWin32kSystemCalls_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditDisallowWin32kSystemCalls_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        DisallowWin32kSystemCalls: DWORD,
        AuditDisallowWin32kSystemCalls: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let DisallowWin32kSystemCalls: u32 =
                unsafe { ::std::mem::transmute(DisallowWin32kSystemCalls) };
            DisallowWin32kSystemCalls as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditDisallowWin32kSystemCalls: u32 =
                unsafe { ::std::mem::transmute(AuditDisallowWin32kSystemCalls) };
            AuditDisallowWin32kSystemCalls as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY =
    _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY;
pub type PPROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY =
    *mut _PROCESS_MITIGATION_SYSTEM_CALL_DISABLE_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1:
        _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"] [:: std :: mem :: align_of :: < _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 > () - 4usize] ;
};
impl _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn DisableExtensionPoints(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisableExtensionPoints(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisableExtensionPoints_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisableExtensionPoints_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        DisableExtensionPoints: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let DisableExtensionPoints: u32 =
                unsafe { ::std::mem::transmute(DisableExtensionPoints) };
            DisableExtensionPoints as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1>(
        ) - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY =
    _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY;
pub type PPROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY =
    *mut _PROCESS_MITIGATION_EXTENSION_POINT_DISABLE_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn ProhibitDynamicCode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ProhibitDynamicCode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ProhibitDynamicCode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ProhibitDynamicCode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AllowThreadOptOut(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowThreadOptOut(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowThreadOptOut_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowThreadOptOut_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AllowRemoteDowngrade(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowRemoteDowngrade(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowRemoteDowngrade_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowRemoteDowngrade_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditProhibitDynamicCode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditProhibitDynamicCode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditProhibitDynamicCode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditProhibitDynamicCode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 28u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                28u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                28u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ProhibitDynamicCode: DWORD,
        AllowThreadOptOut: DWORD,
        AllowRemoteDowngrade: DWORD,
        AuditProhibitDynamicCode: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ProhibitDynamicCode: u32 = unsafe { ::std::mem::transmute(ProhibitDynamicCode) };
            ProhibitDynamicCode as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AllowThreadOptOut: u32 = unsafe { ::std::mem::transmute(AllowThreadOptOut) };
            AllowThreadOptOut as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let AllowRemoteDowngrade: u32 = unsafe { ::std::mem::transmute(AllowRemoteDowngrade) };
            AllowRemoteDowngrade as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let AuditProhibitDynamicCode: u32 =
                unsafe { ::std::mem::transmute(AuditProhibitDynamicCode) };
            AuditProhibitDynamicCode as u64
        });
        __bindgen_bitfield_unit.set(4usize, 28u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY__bindgen_ty_1,
        Flags
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_DYNAMIC_CODE_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_DYNAMIC_CODE_POLICY = _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY;
pub type PPROCESS_MITIGATION_DYNAMIC_CODE_POLICY = *mut _PROCESS_MITIGATION_DYNAMIC_CODE_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn EnableControlFlowGuard(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableControlFlowGuard(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableControlFlowGuard_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableControlFlowGuard_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableExportSuppression(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableExportSuppression(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableExportSuppression_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableExportSuppression_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn StrictMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_StrictMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn StrictMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_StrictMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableXfg(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableXfg(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableXfg_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableXfg_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableXfgAuditMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableXfgAuditMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableXfgAuditMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableXfgAuditMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 27u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 27u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                27u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                27u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        EnableControlFlowGuard: DWORD,
        EnableExportSuppression: DWORD,
        StrictMode: DWORD,
        EnableXfg: DWORD,
        EnableXfgAuditMode: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let EnableControlFlowGuard: u32 =
                unsafe { ::std::mem::transmute(EnableControlFlowGuard) };
            EnableControlFlowGuard as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let EnableExportSuppression: u32 =
                unsafe { ::std::mem::transmute(EnableExportSuppression) };
            EnableExportSuppression as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let StrictMode: u32 = unsafe { ::std::mem::transmute(StrictMode) };
            StrictMode as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let EnableXfg: u32 = unsafe { ::std::mem::transmute(EnableXfg) };
            EnableXfg as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let EnableXfgAuditMode: u32 = unsafe { ::std::mem::transmute(EnableXfgAuditMode) };
            EnableXfgAuditMode as u64
        });
        __bindgen_bitfield_unit.set(5usize, 27u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY =
    _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY;
pub type PPROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY =
    *mut _PROCESS_MITIGATION_CONTROL_FLOW_GUARD_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn MicrosoftSignedOnly(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MicrosoftSignedOnly(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MicrosoftSignedOnly_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MicrosoftSignedOnly_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn StoreSignedOnly(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_StoreSignedOnly(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn StoreSignedOnly_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_StoreSignedOnly_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MitigationOptIn(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MitigationOptIn(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MitigationOptIn_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MitigationOptIn_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditMicrosoftSignedOnly(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditMicrosoftSignedOnly(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditMicrosoftSignedOnly_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditMicrosoftSignedOnly_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditStoreSignedOnly(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditStoreSignedOnly(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditStoreSignedOnly_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditStoreSignedOnly_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 27u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 27u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                27u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                27u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        MicrosoftSignedOnly: DWORD,
        StoreSignedOnly: DWORD,
        MitigationOptIn: DWORD,
        AuditMicrosoftSignedOnly: DWORD,
        AuditStoreSignedOnly: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let MicrosoftSignedOnly: u32 = unsafe { ::std::mem::transmute(MicrosoftSignedOnly) };
            MicrosoftSignedOnly as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let StoreSignedOnly: u32 = unsafe { ::std::mem::transmute(StoreSignedOnly) };
            StoreSignedOnly as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let MitigationOptIn: u32 = unsafe { ::std::mem::transmute(MitigationOptIn) };
            MitigationOptIn as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let AuditMicrosoftSignedOnly: u32 =
                unsafe { ::std::mem::transmute(AuditMicrosoftSignedOnly) };
            AuditMicrosoftSignedOnly as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let AuditStoreSignedOnly: u32 = unsafe { ::std::mem::transmute(AuditStoreSignedOnly) };
            AuditStoreSignedOnly as u64
        });
        __bindgen_bitfield_unit.set(5usize, 27u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1"][::std::mem::align_of::<
        _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY = _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY;
pub type PPROCESS_MITIGATION_BINARY_SIGNATURE_POLICY =
    *mut _PROCESS_MITIGATION_BINARY_SIGNATURE_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_FONT_DISABLE_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn DisableNonSystemFonts(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisableNonSystemFonts(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisableNonSystemFonts_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisableNonSystemFonts_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditNonSystemFontLoading(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditNonSystemFontLoading(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditNonSystemFontLoading_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditNonSystemFontLoading_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        DisableNonSystemFonts: DWORD,
        AuditNonSystemFontLoading: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let DisableNonSystemFonts: u32 =
                unsafe { ::std::mem::transmute(DisableNonSystemFonts) };
            DisableNonSystemFonts as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditNonSystemFontLoading: u32 =
                unsafe { ::std::mem::transmute(AuditNonSystemFontLoading) };
            AuditNonSystemFontLoading as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_FONT_DISABLE_POLICY__bindgen_ty_1,
        Flags
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_FONT_DISABLE_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_FONT_DISABLE_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_FONT_DISABLE_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_FONT_DISABLE_POLICY = _PROCESS_MITIGATION_FONT_DISABLE_POLICY;
pub type PPROCESS_MITIGATION_FONT_DISABLE_POLICY = *mut _PROCESS_MITIGATION_FONT_DISABLE_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_IMAGE_LOAD_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn NoRemoteImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_NoRemoteImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NoRemoteImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_NoRemoteImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn NoLowMandatoryLabelImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_NoLowMandatoryLabelImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NoLowMandatoryLabelImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_NoLowMandatoryLabelImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn PreferSystem32Images(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_PreferSystem32Images(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PreferSystem32Images_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_PreferSystem32Images_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditNoRemoteImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditNoRemoteImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditNoRemoteImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditNoRemoteImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditNoLowMandatoryLabelImages(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditNoLowMandatoryLabelImages(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditNoLowMandatoryLabelImages_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditNoLowMandatoryLabelImages_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 27u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 27u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                27u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                27u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        NoRemoteImages: DWORD,
        NoLowMandatoryLabelImages: DWORD,
        PreferSystem32Images: DWORD,
        AuditNoRemoteImages: DWORD,
        AuditNoLowMandatoryLabelImages: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let NoRemoteImages: u32 = unsafe { ::std::mem::transmute(NoRemoteImages) };
            NoRemoteImages as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let NoLowMandatoryLabelImages: u32 =
                unsafe { ::std::mem::transmute(NoLowMandatoryLabelImages) };
            NoLowMandatoryLabelImages as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let PreferSystem32Images: u32 = unsafe { ::std::mem::transmute(PreferSystem32Images) };
            PreferSystem32Images as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let AuditNoRemoteImages: u32 = unsafe { ::std::mem::transmute(AuditNoRemoteImages) };
            AuditNoRemoteImages as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let AuditNoLowMandatoryLabelImages: u32 =
                unsafe { ::std::mem::transmute(AuditNoLowMandatoryLabelImages) };
            AuditNoLowMandatoryLabelImages as u64
        });
        __bindgen_bitfield_unit.set(5usize, 27u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_IMAGE_LOAD_POLICY__bindgen_ty_1,
        Flags
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_IMAGE_LOAD_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_IMAGE_LOAD_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_IMAGE_LOAD_POLICY = _PROCESS_MITIGATION_IMAGE_LOAD_POLICY;
pub type PPROCESS_MITIGATION_IMAGE_LOAD_POLICY = *mut _PROCESS_MITIGATION_IMAGE_LOAD_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn FilterId(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_FilterId(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FilterId_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FilterId_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 28u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                28u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                28u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        FilterId: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 4u8, {
            let FilterId: u32 = unsafe { ::std::mem::transmute(FilterId) };
            FilterId as u64
        });
        __bindgen_bitfield_unit.set(4usize, 28u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY =
    _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY;
pub type PPROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY =
    *mut _PROCESS_MITIGATION_SYSTEM_CALL_FILTER_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1:
        _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn EnableExportAddressFilter(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableExportAddressFilter(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableExportAddressFilter_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableExportAddressFilter_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditExportAddressFilter(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditExportAddressFilter(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditExportAddressFilter_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditExportAddressFilter_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableExportAddressFilterPlus(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableExportAddressFilterPlus(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableExportAddressFilterPlus_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableExportAddressFilterPlus_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditExportAddressFilterPlus(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditExportAddressFilterPlus(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditExportAddressFilterPlus_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditExportAddressFilterPlus_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableImportAddressFilter(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableImportAddressFilter(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableImportAddressFilter_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableImportAddressFilter_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditImportAddressFilter(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditImportAddressFilter(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditImportAddressFilter_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditImportAddressFilter_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableRopStackPivot(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableRopStackPivot(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableRopStackPivot_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableRopStackPivot_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditRopStackPivot(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditRopStackPivot(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditRopStackPivot_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditRopStackPivot_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableRopCallerCheck(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableRopCallerCheck(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableRopCallerCheck_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableRopCallerCheck_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditRopCallerCheck(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditRopCallerCheck(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditRopCallerCheck_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditRopCallerCheck_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableRopSimExec(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableRopSimExec(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableRopSimExec_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableRopSimExec_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditRopSimExec(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditRopSimExec(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditRopSimExec_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditRopSimExec_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 20u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 20u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                20u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                20u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        EnableExportAddressFilter: DWORD,
        AuditExportAddressFilter: DWORD,
        EnableExportAddressFilterPlus: DWORD,
        AuditExportAddressFilterPlus: DWORD,
        EnableImportAddressFilter: DWORD,
        AuditImportAddressFilter: DWORD,
        EnableRopStackPivot: DWORD,
        AuditRopStackPivot: DWORD,
        EnableRopCallerCheck: DWORD,
        AuditRopCallerCheck: DWORD,
        EnableRopSimExec: DWORD,
        AuditRopSimExec: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let EnableExportAddressFilter: u32 =
                unsafe { ::std::mem::transmute(EnableExportAddressFilter) };
            EnableExportAddressFilter as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditExportAddressFilter: u32 =
                unsafe { ::std::mem::transmute(AuditExportAddressFilter) };
            AuditExportAddressFilter as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let EnableExportAddressFilterPlus: u32 =
                unsafe { ::std::mem::transmute(EnableExportAddressFilterPlus) };
            EnableExportAddressFilterPlus as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let AuditExportAddressFilterPlus: u32 =
                unsafe { ::std::mem::transmute(AuditExportAddressFilterPlus) };
            AuditExportAddressFilterPlus as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let EnableImportAddressFilter: u32 =
                unsafe { ::std::mem::transmute(EnableImportAddressFilter) };
            EnableImportAddressFilter as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let AuditImportAddressFilter: u32 =
                unsafe { ::std::mem::transmute(AuditImportAddressFilter) };
            AuditImportAddressFilter as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let EnableRopStackPivot: u32 = unsafe { ::std::mem::transmute(EnableRopStackPivot) };
            EnableRopStackPivot as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let AuditRopStackPivot: u32 = unsafe { ::std::mem::transmute(AuditRopStackPivot) };
            AuditRopStackPivot as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let EnableRopCallerCheck: u32 = unsafe { ::std::mem::transmute(EnableRopCallerCheck) };
            EnableRopCallerCheck as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let AuditRopCallerCheck: u32 = unsafe { ::std::mem::transmute(AuditRopCallerCheck) };
            AuditRopCallerCheck as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let EnableRopSimExec: u32 = unsafe { ::std::mem::transmute(EnableRopSimExec) };
            EnableRopSimExec as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let AuditRopSimExec: u32 = unsafe { ::std::mem::transmute(AuditRopSimExec) };
            AuditRopSimExec as u64
        });
        __bindgen_bitfield_unit.set(12usize, 20u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY =
    _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY;
pub type PPROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY =
    *mut _PROCESS_MITIGATION_PAYLOAD_RESTRICTION_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_CHILD_PROCESS_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn NoChildProcessCreation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_NoChildProcessCreation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NoChildProcessCreation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_NoChildProcessCreation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditNoChildProcessCreation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditNoChildProcessCreation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditNoChildProcessCreation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditNoChildProcessCreation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AllowSecureProcessCreation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowSecureProcessCreation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowSecureProcessCreation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowSecureProcessCreation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 29u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 29u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                29u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                29u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        NoChildProcessCreation: DWORD,
        AuditNoChildProcessCreation: DWORD,
        AllowSecureProcessCreation: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let NoChildProcessCreation: u32 =
                unsafe { ::std::mem::transmute(NoChildProcessCreation) };
            NoChildProcessCreation as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditNoChildProcessCreation: u32 =
                unsafe { ::std::mem::transmute(AuditNoChildProcessCreation) };
            AuditNoChildProcessCreation as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let AllowSecureProcessCreation: u32 =
                unsafe { ::std::mem::transmute(AllowSecureProcessCreation) };
            AllowSecureProcessCreation as u64
        });
        __bindgen_bitfield_unit.set(3usize, 29u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_CHILD_PROCESS_POLICY__bindgen_ty_1,
        Flags
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_CHILD_PROCESS_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_CHILD_PROCESS_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_CHILD_PROCESS_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_CHILD_PROCESS_POLICY = _PROCESS_MITIGATION_CHILD_PROCESS_POLICY;
pub type PPROCESS_MITIGATION_CHILD_PROCESS_POLICY = *mut _PROCESS_MITIGATION_CHILD_PROCESS_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1:
        _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1"] [:: std :: mem :: align_of :: < _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1 > () - 4usize] ;
};
impl _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn SmtBranchTargetIsolation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_SmtBranchTargetIsolation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SmtBranchTargetIsolation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_SmtBranchTargetIsolation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IsolateSecurityDomain(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_IsolateSecurityDomain(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IsolateSecurityDomain_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IsolateSecurityDomain_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DisablePageCombine(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisablePageCombine(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisablePageCombine_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisablePageCombine_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn SpeculativeStoreBypassDisable(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_SpeculativeStoreBypassDisable(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SpeculativeStoreBypassDisable_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_SpeculativeStoreBypassDisable_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 28u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                28u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                28u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        SmtBranchTargetIsolation: DWORD,
        IsolateSecurityDomain: DWORD,
        DisablePageCombine: DWORD,
        SpeculativeStoreBypassDisable: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let SmtBranchTargetIsolation: u32 =
                unsafe { ::std::mem::transmute(SmtBranchTargetIsolation) };
            SmtBranchTargetIsolation as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let IsolateSecurityDomain: u32 =
                unsafe { ::std::mem::transmute(IsolateSecurityDomain) };
            IsolateSecurityDomain as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let DisablePageCombine: u32 = unsafe { ::std::mem::transmute(DisablePageCombine) };
            DisablePageCombine as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let SpeculativeStoreBypassDisable: u32 =
                unsafe { ::std::mem::transmute(SpeculativeStoreBypassDisable) };
            SpeculativeStoreBypassDisable as u64
        });
        __bindgen_bitfield_unit.set(4usize, 28u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY =
    _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY;
pub type PPROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY =
    *mut _PROCESS_MITIGATION_SIDE_CHANNEL_ISOLATION_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn EnableUserShadowStack(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableUserShadowStack(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableUserShadowStack_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableUserShadowStack_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditUserShadowStack(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditUserShadowStack(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditUserShadowStack_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditUserShadowStack_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn SetContextIpValidation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_SetContextIpValidation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SetContextIpValidation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_SetContextIpValidation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditSetContextIpValidation(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditSetContextIpValidation(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditSetContextIpValidation_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditSetContextIpValidation_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EnableUserShadowStackStrictMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnableUserShadowStackStrictMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnableUserShadowStackStrictMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnableUserShadowStackStrictMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn BlockNonCetBinaries(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_BlockNonCetBinaries(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BlockNonCetBinaries_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BlockNonCetBinaries_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn BlockNonCetBinariesNonEhcont(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_BlockNonCetBinariesNonEhcont(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn BlockNonCetBinariesNonEhcont_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_BlockNonCetBinariesNonEhcont_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditBlockNonCetBinaries(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditBlockNonCetBinaries(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditBlockNonCetBinaries_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditBlockNonCetBinaries_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn CetDynamicApisOutOfProcOnly(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_CetDynamicApisOutOfProcOnly(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn CetDynamicApisOutOfProcOnly_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_CetDynamicApisOutOfProcOnly_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn SetContextIpValidationRelaxedMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_SetContextIpValidationRelaxedMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SetContextIpValidationRelaxedMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_SetContextIpValidationRelaxedMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 22u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(10usize, 22u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                22u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                22u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        EnableUserShadowStack: DWORD,
        AuditUserShadowStack: DWORD,
        SetContextIpValidation: DWORD,
        AuditSetContextIpValidation: DWORD,
        EnableUserShadowStackStrictMode: DWORD,
        BlockNonCetBinaries: DWORD,
        BlockNonCetBinariesNonEhcont: DWORD,
        AuditBlockNonCetBinaries: DWORD,
        CetDynamicApisOutOfProcOnly: DWORD,
        SetContextIpValidationRelaxedMode: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let EnableUserShadowStack: u32 =
                unsafe { ::std::mem::transmute(EnableUserShadowStack) };
            EnableUserShadowStack as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditUserShadowStack: u32 = unsafe { ::std::mem::transmute(AuditUserShadowStack) };
            AuditUserShadowStack as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let SetContextIpValidation: u32 =
                unsafe { ::std::mem::transmute(SetContextIpValidation) };
            SetContextIpValidation as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let AuditSetContextIpValidation: u32 =
                unsafe { ::std::mem::transmute(AuditSetContextIpValidation) };
            AuditSetContextIpValidation as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let EnableUserShadowStackStrictMode: u32 =
                unsafe { ::std::mem::transmute(EnableUserShadowStackStrictMode) };
            EnableUserShadowStackStrictMode as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let BlockNonCetBinaries: u32 = unsafe { ::std::mem::transmute(BlockNonCetBinaries) };
            BlockNonCetBinaries as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let BlockNonCetBinariesNonEhcont: u32 =
                unsafe { ::std::mem::transmute(BlockNonCetBinariesNonEhcont) };
            BlockNonCetBinariesNonEhcont as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let AuditBlockNonCetBinaries: u32 =
                unsafe { ::std::mem::transmute(AuditBlockNonCetBinaries) };
            AuditBlockNonCetBinaries as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let CetDynamicApisOutOfProcOnly: u32 =
                unsafe { ::std::mem::transmute(CetDynamicApisOutOfProcOnly) };
            CetDynamicApisOutOfProcOnly as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let SetContextIpValidationRelaxedMode: u32 =
                unsafe { ::std::mem::transmute(SetContextIpValidationRelaxedMode) };
            SetContextIpValidationRelaxedMode as u64
        });
        __bindgen_bitfield_unit.set(10usize, 22u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1"][::std::mem::align_of::<
        _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY = _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY;
pub type PPROCESS_MITIGATION_USER_SHADOW_STACK_POLICY =
    *mut _PROCESS_MITIGATION_USER_SHADOW_STACK_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY {
    pub __bindgen_anon_1: _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1 {
    pub Flags: DWORD,
    pub __bindgen_anon_1: _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn EnforceRedirectionTrust(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EnforceRedirectionTrust(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EnforceRedirectionTrust_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EnforceRedirectionTrust_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AuditRedirectionTrust(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AuditRedirectionTrust(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AuditRedirectionTrust_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AuditRedirectionTrust_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        EnforceRedirectionTrust: DWORD,
        AuditRedirectionTrust: DWORD,
        ReservedFlags: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let EnforceRedirectionTrust: u32 =
                unsafe { ::std::mem::transmute(EnforceRedirectionTrust) };
            EnforceRedirectionTrust as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AuditRedirectionTrust: u32 =
                unsafe { ::std::mem::transmute(AuditRedirectionTrust) };
            AuditRedirectionTrust as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let ReservedFlags: u32 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1"][::std::mem::size_of::<
        _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1"][::std::mem::align_of::<
        _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1,
    >() - 4usize];
    ["Offset of field: _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY"]
        [::std::mem::size_of::<_PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY>() - 4usize];
    ["Alignment of _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY"]
        [::std::mem::align_of::<_PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY>() - 4usize];
};
pub type PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY = _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY;
pub type PPROCESS_MITIGATION_REDIRECTION_TRUST_POLICY =
    *mut _PROCESS_MITIGATION_REDIRECTION_TRUST_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION {
    pub TotalUserTime: LARGE_INTEGER,
    pub TotalKernelTime: LARGE_INTEGER,
    pub ThisPeriodTotalUserTime: LARGE_INTEGER,
    pub ThisPeriodTotalKernelTime: LARGE_INTEGER,
    pub TotalPageFaultCount: DWORD,
    pub TotalProcesses: DWORD,
    pub ActiveProcesses: DWORD,
    pub TotalTerminatedProcesses: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_BASIC_ACCOUNTING_INFORMATION>() - 48usize];
    ["Alignment of _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_BASIC_ACCOUNTING_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::TotalUserTime"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_ACCOUNTING_INFORMATION, TotalUserTime) - 0usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::TotalKernelTime"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_ACCOUNTING_INFORMATION, TotalKernelTime) - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::ThisPeriodTotalUserTime"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
        ThisPeriodTotalUserTime
    )
        - 16usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::ThisPeriodTotalKernelTime"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
        ThisPeriodTotalKernelTime
    )
        - 24usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::TotalPageFaultCount"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
        TotalPageFaultCount
    ) - 32usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::TotalProcesses"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_ACCOUNTING_INFORMATION, TotalProcesses) - 36usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::ActiveProcesses"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
        ActiveProcesses
    ) - 40usize];
    ["Offset of field: _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION::TotalTerminatedProcesses"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
        TotalTerminatedProcesses
    )
        - 44usize];
};
pub type JOBOBJECT_BASIC_ACCOUNTING_INFORMATION = _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION;
pub type PJOBOBJECT_BASIC_ACCOUNTING_INFORMATION = *mut _JOBOBJECT_BASIC_ACCOUNTING_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_BASIC_LIMIT_INFORMATION {
    pub PerProcessUserTimeLimit: LARGE_INTEGER,
    pub PerJobUserTimeLimit: LARGE_INTEGER,
    pub LimitFlags: DWORD,
    pub MinimumWorkingSetSize: SIZE_T,
    pub MaximumWorkingSetSize: SIZE_T,
    pub ActiveProcessLimit: DWORD,
    pub Affinity: ULONG_PTR,
    pub PriorityClass: DWORD,
    pub SchedulingClass: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_BASIC_LIMIT_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_BASIC_LIMIT_INFORMATION>() - 64usize];
    ["Alignment of _JOBOBJECT_BASIC_LIMIT_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_BASIC_LIMIT_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::PerProcessUserTimeLimit"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_LIMIT_INFORMATION,
        PerProcessUserTimeLimit
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::PerJobUserTimeLimit"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, PerJobUserTimeLimit) - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::LimitFlags"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, LimitFlags) - 16usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::MinimumWorkingSetSize"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_LIMIT_INFORMATION,
        MinimumWorkingSetSize
    ) - 24usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::MaximumWorkingSetSize"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_LIMIT_INFORMATION,
        MaximumWorkingSetSize
    ) - 32usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::ActiveProcessLimit"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, ActiveProcessLimit) - 40usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::Affinity"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, Affinity) - 48usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::PriorityClass"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, PriorityClass) - 56usize];
    ["Offset of field: _JOBOBJECT_BASIC_LIMIT_INFORMATION::SchedulingClass"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_LIMIT_INFORMATION, SchedulingClass) - 60usize];
};
pub type JOBOBJECT_BASIC_LIMIT_INFORMATION = _JOBOBJECT_BASIC_LIMIT_INFORMATION;
pub type PJOBOBJECT_BASIC_LIMIT_INFORMATION = *mut _JOBOBJECT_BASIC_LIMIT_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_EXTENDED_LIMIT_INFORMATION {
    pub BasicLimitInformation: JOBOBJECT_BASIC_LIMIT_INFORMATION,
    pub IoInfo: IO_COUNTERS,
    pub ProcessMemoryLimit: SIZE_T,
    pub JobMemoryLimit: SIZE_T,
    pub PeakProcessMemoryUsed: SIZE_T,
    pub PeakJobMemoryUsed: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_EXTENDED_LIMIT_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_EXTENDED_LIMIT_INFORMATION>() - 144usize];
    ["Alignment of _JOBOBJECT_EXTENDED_LIMIT_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_EXTENDED_LIMIT_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::BasicLimitInformation"][::std::mem::offset_of!(
        _JOBOBJECT_EXTENDED_LIMIT_INFORMATION,
        BasicLimitInformation
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::IoInfo"]
        [::std::mem::offset_of!(_JOBOBJECT_EXTENDED_LIMIT_INFORMATION, IoInfo) - 64usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::ProcessMemoryLimit"][::std::mem::offset_of!(
        _JOBOBJECT_EXTENDED_LIMIT_INFORMATION,
        ProcessMemoryLimit
    ) - 112usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::JobMemoryLimit"]
        [::std::mem::offset_of!(_JOBOBJECT_EXTENDED_LIMIT_INFORMATION, JobMemoryLimit) - 120usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::PeakProcessMemoryUsed"][::std::mem::offset_of!(
        _JOBOBJECT_EXTENDED_LIMIT_INFORMATION,
        PeakProcessMemoryUsed
    ) - 128usize];
    ["Offset of field: _JOBOBJECT_EXTENDED_LIMIT_INFORMATION::PeakJobMemoryUsed"][::std::mem::offset_of!(
        _JOBOBJECT_EXTENDED_LIMIT_INFORMATION,
        PeakJobMemoryUsed
    ) - 136usize];
};
pub type JOBOBJECT_EXTENDED_LIMIT_INFORMATION = _JOBOBJECT_EXTENDED_LIMIT_INFORMATION;
pub type PJOBOBJECT_EXTENDED_LIMIT_INFORMATION = *mut _JOBOBJECT_EXTENDED_LIMIT_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_BASIC_PROCESS_ID_LIST {
    pub NumberOfAssignedProcesses: DWORD,
    pub NumberOfProcessIdsInList: DWORD,
    pub ProcessIdList: [ULONG_PTR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_BASIC_PROCESS_ID_LIST"]
        [::std::mem::size_of::<_JOBOBJECT_BASIC_PROCESS_ID_LIST>() - 16usize];
    ["Alignment of _JOBOBJECT_BASIC_PROCESS_ID_LIST"]
        [::std::mem::align_of::<_JOBOBJECT_BASIC_PROCESS_ID_LIST>() - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_PROCESS_ID_LIST::NumberOfAssignedProcesses"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_PROCESS_ID_LIST,
        NumberOfAssignedProcesses
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_BASIC_PROCESS_ID_LIST::NumberOfProcessIdsInList"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_PROCESS_ID_LIST,
        NumberOfProcessIdsInList
    ) - 4usize];
    ["Offset of field: _JOBOBJECT_BASIC_PROCESS_ID_LIST::ProcessIdList"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_PROCESS_ID_LIST, ProcessIdList) - 8usize];
};
pub type JOBOBJECT_BASIC_PROCESS_ID_LIST = _JOBOBJECT_BASIC_PROCESS_ID_LIST;
pub type PJOBOBJECT_BASIC_PROCESS_ID_LIST = *mut _JOBOBJECT_BASIC_PROCESS_ID_LIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_BASIC_UI_RESTRICTIONS {
    pub UIRestrictionsClass: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_BASIC_UI_RESTRICTIONS"]
        [::std::mem::size_of::<_JOBOBJECT_BASIC_UI_RESTRICTIONS>() - 4usize];
    ["Alignment of _JOBOBJECT_BASIC_UI_RESTRICTIONS"]
        [::std::mem::align_of::<_JOBOBJECT_BASIC_UI_RESTRICTIONS>() - 4usize];
    ["Offset of field: _JOBOBJECT_BASIC_UI_RESTRICTIONS::UIRestrictionsClass"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_UI_RESTRICTIONS, UIRestrictionsClass) - 0usize];
};
pub type JOBOBJECT_BASIC_UI_RESTRICTIONS = _JOBOBJECT_BASIC_UI_RESTRICTIONS;
pub type PJOBOBJECT_BASIC_UI_RESTRICTIONS = *mut _JOBOBJECT_BASIC_UI_RESTRICTIONS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_SECURITY_LIMIT_INFORMATION {
    pub SecurityLimitFlags: DWORD,
    pub JobToken: HANDLE,
    pub SidsToDisable: PTOKEN_GROUPS,
    pub PrivilegesToDelete: PTOKEN_PRIVILEGES,
    pub RestrictedSids: PTOKEN_GROUPS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_SECURITY_LIMIT_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_SECURITY_LIMIT_INFORMATION>() - 40usize];
    ["Alignment of _JOBOBJECT_SECURITY_LIMIT_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_SECURITY_LIMIT_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_SECURITY_LIMIT_INFORMATION::SecurityLimitFlags"][::std::mem::offset_of!(
        _JOBOBJECT_SECURITY_LIMIT_INFORMATION,
        SecurityLimitFlags
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_SECURITY_LIMIT_INFORMATION::JobToken"]
        [::std::mem::offset_of!(_JOBOBJECT_SECURITY_LIMIT_INFORMATION, JobToken) - 8usize];
    ["Offset of field: _JOBOBJECT_SECURITY_LIMIT_INFORMATION::SidsToDisable"]
        [::std::mem::offset_of!(_JOBOBJECT_SECURITY_LIMIT_INFORMATION, SidsToDisable) - 16usize];
    ["Offset of field: _JOBOBJECT_SECURITY_LIMIT_INFORMATION::PrivilegesToDelete"][::std::mem::offset_of!(
        _JOBOBJECT_SECURITY_LIMIT_INFORMATION,
        PrivilegesToDelete
    ) - 24usize];
    ["Offset of field: _JOBOBJECT_SECURITY_LIMIT_INFORMATION::RestrictedSids"]
        [::std::mem::offset_of!(_JOBOBJECT_SECURITY_LIMIT_INFORMATION, RestrictedSids) - 32usize];
};
pub type JOBOBJECT_SECURITY_LIMIT_INFORMATION = _JOBOBJECT_SECURITY_LIMIT_INFORMATION;
pub type PJOBOBJECT_SECURITY_LIMIT_INFORMATION = *mut _JOBOBJECT_SECURITY_LIMIT_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_END_OF_JOB_TIME_INFORMATION {
    pub EndOfJobTimeAction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_END_OF_JOB_TIME_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_END_OF_JOB_TIME_INFORMATION>() - 4usize];
    ["Alignment of _JOBOBJECT_END_OF_JOB_TIME_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_END_OF_JOB_TIME_INFORMATION>() - 4usize];
    ["Offset of field: _JOBOBJECT_END_OF_JOB_TIME_INFORMATION::EndOfJobTimeAction"][::std::mem::offset_of!(
        _JOBOBJECT_END_OF_JOB_TIME_INFORMATION,
        EndOfJobTimeAction
    ) - 0usize];
};
pub type JOBOBJECT_END_OF_JOB_TIME_INFORMATION = _JOBOBJECT_END_OF_JOB_TIME_INFORMATION;
pub type PJOBOBJECT_END_OF_JOB_TIME_INFORMATION = *mut _JOBOBJECT_END_OF_JOB_TIME_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_ASSOCIATE_COMPLETION_PORT {
    pub CompletionKey: PVOID,
    pub CompletionPort: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_ASSOCIATE_COMPLETION_PORT"]
        [::std::mem::size_of::<_JOBOBJECT_ASSOCIATE_COMPLETION_PORT>() - 16usize];
    ["Alignment of _JOBOBJECT_ASSOCIATE_COMPLETION_PORT"]
        [::std::mem::align_of::<_JOBOBJECT_ASSOCIATE_COMPLETION_PORT>() - 8usize];
    ["Offset of field: _JOBOBJECT_ASSOCIATE_COMPLETION_PORT::CompletionKey"]
        [::std::mem::offset_of!(_JOBOBJECT_ASSOCIATE_COMPLETION_PORT, CompletionKey) - 0usize];
    ["Offset of field: _JOBOBJECT_ASSOCIATE_COMPLETION_PORT::CompletionPort"]
        [::std::mem::offset_of!(_JOBOBJECT_ASSOCIATE_COMPLETION_PORT, CompletionPort) - 8usize];
};
pub type JOBOBJECT_ASSOCIATE_COMPLETION_PORT = _JOBOBJECT_ASSOCIATE_COMPLETION_PORT;
pub type PJOBOBJECT_ASSOCIATE_COMPLETION_PORT = *mut _JOBOBJECT_ASSOCIATE_COMPLETION_PORT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION {
    pub BasicInfo: JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
    pub IoInfo: IO_COUNTERS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION>() - 96usize];
    ["Alignment of _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION::BasicInfo"][::std::mem::offset_of!(
        _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION,
        BasicInfo
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION::IoInfo"]
        [::std::mem::offset_of!(_JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION, IoInfo) - 48usize];
};
pub type JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION =
    _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION;
pub type PJOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION =
    *mut _JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_JOBSET_INFORMATION {
    pub MemberLevel: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_JOBSET_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_JOBSET_INFORMATION>() - 4usize];
    ["Alignment of _JOBOBJECT_JOBSET_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_JOBSET_INFORMATION>() - 4usize];
    ["Offset of field: _JOBOBJECT_JOBSET_INFORMATION::MemberLevel"]
        [::std::mem::offset_of!(_JOBOBJECT_JOBSET_INFORMATION, MemberLevel) - 0usize];
};
pub type JOBOBJECT_JOBSET_INFORMATION = _JOBOBJECT_JOBSET_INFORMATION;
pub type PJOBOBJECT_JOBSET_INFORMATION = *mut _JOBOBJECT_JOBSET_INFORMATION;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_ToleranceLow: _JOBOBJECT_RATE_CONTROL_TOLERANCE = 1;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_ToleranceMedium: _JOBOBJECT_RATE_CONTROL_TOLERANCE = 2;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_ToleranceHigh: _JOBOBJECT_RATE_CONTROL_TOLERANCE = 3;
pub type _JOBOBJECT_RATE_CONTROL_TOLERANCE = ::std::os::raw::c_int;
pub use self::_JOBOBJECT_RATE_CONTROL_TOLERANCE as JOBOBJECT_RATE_CONTROL_TOLERANCE;
pub type PJOBOBJECT_RATE_CONTROL_TOLERANCE = *mut _JOBOBJECT_RATE_CONTROL_TOLERANCE;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL_ToleranceIntervalShort:
    _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL = 1;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL_ToleranceIntervalMedium:
    _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL = 2;
pub const _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL_ToleranceIntervalLong:
    _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL = 3;
pub type _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL = ::std::os::raw::c_int;
pub use self::_JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL as JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL;
pub type PJOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL =
    *mut _JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION {
    pub IoReadBytesLimit: DWORD64,
    pub IoWriteBytesLimit: DWORD64,
    pub PerJobUserTimeLimit: LARGE_INTEGER,
    pub JobMemoryLimit: DWORD64,
    pub RateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub RateControlToleranceInterval: JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL,
    pub LimitFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION>() - 48usize];
    ["Alignment of _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::IoReadBytesLimit"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        IoReadBytesLimit
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::IoWriteBytesLimit"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        IoWriteBytesLimit
    ) - 8usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::PerJobUserTimeLimit"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        PerJobUserTimeLimit
    )
        - 16usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::JobMemoryLimit"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        JobMemoryLimit
    ) - 24usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::RateControlTolerance"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        RateControlTolerance
    )
        - 32usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::RateControlToleranceInterval"][::std::mem::offset_of!(
        _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION,
        RateControlToleranceInterval
    )
        - 36usize];
    ["Offset of field: _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION::LimitFlags"]
        [::std::mem::offset_of!(_JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION, LimitFlags) - 40usize];
};
pub type JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION = _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION;
pub type PJOBOBJECT_NOTIFICATION_LIMIT_INFORMATION = *mut _JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2 {
    pub IoReadBytesLimit: DWORD64,
    pub IoWriteBytesLimit: DWORD64,
    pub PerJobUserTimeLimit: LARGE_INTEGER,
    pub __bindgen_anon_1: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1,
    pub __bindgen_anon_2: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2,
    pub __bindgen_anon_3: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3,
    pub LimitFlags: DWORD,
    pub IoRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub JobLowMemoryLimit: DWORD64,
    pub IoRateControlToleranceInterval: JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL,
    pub NetRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub NetRateControlToleranceInterval: JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1 {
    pub JobHighMemoryLimit: DWORD64,
    pub JobMemoryLimit: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1"][::std::mem::size_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1,
    >() - 8usize];
    ["Alignment of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1"][::std::mem::align_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1,
    >() - 8usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1::JobHighMemoryLimit"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1 , JobHighMemoryLimit) - 0usize] ;
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1::JobMemoryLimit"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_1,
        JobMemoryLimit
    )
        - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2 {
    pub RateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub CpuRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2"][::std::mem::size_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2,
    >() - 4usize];
    ["Alignment of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2"][::std::mem::align_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2,
    >() - 4usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2::RateControlTolerance"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2 , RateControlTolerance) - 0usize] ;
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2::CpuRateControlTolerance"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_2 , CpuRateControlTolerance) - 0usize] ;
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3 {
    pub RateControlToleranceInterval: JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL,
    pub CpuRateControlToleranceInterval: JOBOBJECT_RATE_CONTROL_TOLERANCE_INTERVAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3"][::std::mem::size_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3,
    >() - 4usize];
    ["Alignment of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3"][::std::mem::align_of::<
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3,
    >() - 4usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3::RateControlToleranceInterval"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3 , RateControlToleranceInterval) - 0usize] ;
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3::CpuRateControlToleranceInterval"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2__bindgen_ty_3 , CpuRateControlToleranceInterval) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2"]
        [::std::mem::size_of::<JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2>() - 72usize];
    ["Alignment of JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2"]
        [::std::mem::align_of::<JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2>() - 8usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::IoReadBytesLimit"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        IoReadBytesLimit
    ) - 0usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::IoWriteBytesLimit"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        IoWriteBytesLimit
    ) - 8usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::PerJobUserTimeLimit"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        PerJobUserTimeLimit
    )
        - 16usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::LimitFlags"]
        [::std::mem::offset_of!(JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2, LimitFlags) - 40usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::IoRateControlTolerance"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        IoRateControlTolerance
    )
        - 44usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::JobLowMemoryLimit"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        JobLowMemoryLimit
    ) - 48usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::IoRateControlToleranceInterval"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2 , IoRateControlToleranceInterval) - 56usize] ;
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::NetRateControlTolerance"][::std::mem::offset_of!(
        JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2,
        NetRateControlTolerance
    )
        - 60usize];
    ["Offset of field: JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2::NetRateControlToleranceInterval"] [:: std :: mem :: offset_of ! (JOBOBJECT_NOTIFICATION_LIMIT_INFORMATION_2 , NetRateControlToleranceInterval) - 64usize] ;
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_LIMIT_VIOLATION_INFORMATION {
    pub LimitFlags: DWORD,
    pub ViolationLimitFlags: DWORD,
    pub IoReadBytes: DWORD64,
    pub IoReadBytesLimit: DWORD64,
    pub IoWriteBytes: DWORD64,
    pub IoWriteBytesLimit: DWORD64,
    pub PerJobUserTime: LARGE_INTEGER,
    pub PerJobUserTimeLimit: LARGE_INTEGER,
    pub JobMemory: DWORD64,
    pub JobMemoryLimit: DWORD64,
    pub RateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub RateControlToleranceLimit: JOBOBJECT_RATE_CONTROL_TOLERANCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_LIMIT_VIOLATION_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_LIMIT_VIOLATION_INFORMATION>() - 80usize];
    ["Alignment of _JOBOBJECT_LIMIT_VIOLATION_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_LIMIT_VIOLATION_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::LimitFlags"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, LimitFlags) - 0usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::ViolationLimitFlags"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        ViolationLimitFlags
    ) - 4usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::IoReadBytes"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, IoReadBytes) - 8usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::IoReadBytesLimit"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        IoReadBytesLimit
    ) - 16usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::IoWriteBytes"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, IoWriteBytes) - 24usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::IoWriteBytesLimit"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        IoWriteBytesLimit
    ) - 32usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::PerJobUserTime"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, PerJobUserTime) - 40usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::PerJobUserTimeLimit"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        PerJobUserTimeLimit
    ) - 48usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::JobMemory"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, JobMemory) - 56usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::JobMemoryLimit"]
        [::std::mem::offset_of!(_JOBOBJECT_LIMIT_VIOLATION_INFORMATION, JobMemoryLimit) - 64usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::RateControlTolerance"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        RateControlTolerance
    ) - 72usize];
    ["Offset of field: _JOBOBJECT_LIMIT_VIOLATION_INFORMATION::RateControlToleranceLimit"][::std::mem::offset_of!(
        _JOBOBJECT_LIMIT_VIOLATION_INFORMATION,
        RateControlToleranceLimit
    )
        - 76usize];
};
pub type JOBOBJECT_LIMIT_VIOLATION_INFORMATION = _JOBOBJECT_LIMIT_VIOLATION_INFORMATION;
pub type PJOBOBJECT_LIMIT_VIOLATION_INFORMATION = *mut _JOBOBJECT_LIMIT_VIOLATION_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2 {
    pub LimitFlags: DWORD,
    pub ViolationLimitFlags: DWORD,
    pub IoReadBytes: DWORD64,
    pub IoReadBytesLimit: DWORD64,
    pub IoWriteBytes: DWORD64,
    pub IoWriteBytesLimit: DWORD64,
    pub PerJobUserTime: LARGE_INTEGER,
    pub PerJobUserTimeLimit: LARGE_INTEGER,
    pub JobMemory: DWORD64,
    pub __bindgen_anon_1: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1,
    pub __bindgen_anon_2: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2,
    pub __bindgen_anon_3: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3,
    pub JobLowMemoryLimit: DWORD64,
    pub IoRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub IoRateControlToleranceLimit: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub NetRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub NetRateControlToleranceLimit: JOBOBJECT_RATE_CONTROL_TOLERANCE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1 {
    pub JobHighMemoryLimit: DWORD64,
    pub JobMemoryLimit: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1"]
        [::std::mem::size_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1>() - 8usize];
    ["Alignment of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1"]
        [::std::mem::align_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1>() - 8usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1::JobHighMemoryLimit"] [:: std :: mem :: offset_of ! (JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1 , JobHighMemoryLimit) - 0usize] ;
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1::JobMemoryLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_1,
        JobMemoryLimit
    )
        - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2 {
    pub RateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub CpuRateControlTolerance: JOBOBJECT_RATE_CONTROL_TOLERANCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2"]
        [::std::mem::size_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2>() - 4usize];
    ["Alignment of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2"]
        [::std::mem::align_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2>() - 4usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2::RateControlTolerance"] [:: std :: mem :: offset_of ! (JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2 , RateControlTolerance) - 0usize] ;
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2::CpuRateControlTolerance"] [:: std :: mem :: offset_of ! (JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_2 , CpuRateControlTolerance) - 0usize] ;
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3 {
    pub RateControlToleranceLimit: JOBOBJECT_RATE_CONTROL_TOLERANCE,
    pub CpuRateControlToleranceLimit: JOBOBJECT_RATE_CONTROL_TOLERANCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3"]
        [::std::mem::size_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3>() - 4usize];
    ["Alignment of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3"]
        [::std::mem::align_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3>() - 4usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3::RateControlToleranceLimit"] [:: std :: mem :: offset_of ! (JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3 , RateControlToleranceLimit) - 0usize] ;
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3::CpuRateControlToleranceLimit"] [:: std :: mem :: offset_of ! (JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2__bindgen_ty_3 , CpuRateControlToleranceLimit) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2"]
        [::std::mem::size_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2>() - 104usize];
    ["Alignment of JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2"]
        [::std::mem::align_of::<JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2>() - 8usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::LimitFlags"]
        [::std::mem::offset_of!(JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2, LimitFlags) - 0usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::ViolationLimitFlags"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        ViolationLimitFlags
    ) - 4usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoReadBytes"]
        [::std::mem::offset_of!(JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2, IoReadBytes) - 8usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoReadBytesLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        IoReadBytesLimit
    ) - 16usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoWriteBytes"]
        [::std::mem::offset_of!(JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2, IoWriteBytes) - 24usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoWriteBytesLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        IoWriteBytesLimit
    ) - 32usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::PerJobUserTime"]
        [::std::mem::offset_of!(JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2, PerJobUserTime) - 40usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::PerJobUserTimeLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        PerJobUserTimeLimit
    ) - 48usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::JobMemory"]
        [::std::mem::offset_of!(JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2, JobMemory) - 56usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::JobLowMemoryLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        JobLowMemoryLimit
    ) - 80usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoRateControlTolerance"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        IoRateControlTolerance
    )
        - 88usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::IoRateControlToleranceLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        IoRateControlToleranceLimit
    )
        - 92usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::NetRateControlTolerance"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        NetRateControlTolerance
    )
        - 96usize];
    ["Offset of field: JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2::NetRateControlToleranceLimit"][::std::mem::offset_of!(
        JOBOBJECT_LIMIT_VIOLATION_INFORMATION_2,
        NetRateControlToleranceLimit
    )
        - 100usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION {
    pub ControlFlags: DWORD,
    pub __bindgen_anon_1: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1 {
    pub CpuRate: DWORD,
    pub Weight: DWORD,
    pub __bindgen_anon_1: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub MinRate: WORD,
    pub MaxRate: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1>(
        ) - 2usize];
    ["Offset of field: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1::MinRate"] [:: std :: mem :: offset_of ! (_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1 , MinRate) - 0usize] ;
    ["Offset of field: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1::MaxRate"] [:: std :: mem :: offset_of ! (_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1__bindgen_ty_1 , MaxRate) - 2usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Offset of field: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1::CpuRate"][::std::mem::offset_of!(
        _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1,
        CpuRate
    ) - 0usize];
    ["Offset of field: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1::Weight"][::std::mem::offset_of!(
        _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION__bindgen_ty_1,
        Weight
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION>() - 8usize];
    ["Alignment of _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION>() - 4usize];
    ["Offset of field: _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION::ControlFlags"]
        [::std::mem::offset_of!(_JOBOBJECT_CPU_RATE_CONTROL_INFORMATION, ControlFlags) - 0usize];
};
pub type JOBOBJECT_CPU_RATE_CONTROL_INFORMATION = _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION;
pub type PJOBOBJECT_CPU_RATE_CONTROL_INFORMATION = *mut _JOBOBJECT_CPU_RATE_CONTROL_INFORMATION;
pub const JOB_OBJECT_NET_RATE_CONTROL_FLAGS_JOB_OBJECT_NET_RATE_CONTROL_ENABLE:
    JOB_OBJECT_NET_RATE_CONTROL_FLAGS = 1;
pub const JOB_OBJECT_NET_RATE_CONTROL_FLAGS_JOB_OBJECT_NET_RATE_CONTROL_MAX_BANDWIDTH:
    JOB_OBJECT_NET_RATE_CONTROL_FLAGS = 2;
pub const JOB_OBJECT_NET_RATE_CONTROL_FLAGS_JOB_OBJECT_NET_RATE_CONTROL_DSCP_TAG:
    JOB_OBJECT_NET_RATE_CONTROL_FLAGS = 4;
pub const JOB_OBJECT_NET_RATE_CONTROL_FLAGS_JOB_OBJECT_NET_RATE_CONTROL_VALID_FLAGS:
    JOB_OBJECT_NET_RATE_CONTROL_FLAGS = 7;
pub type JOB_OBJECT_NET_RATE_CONTROL_FLAGS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct JOBOBJECT_NET_RATE_CONTROL_INFORMATION {
    pub MaxBandwidth: DWORD64,
    pub ControlFlags: JOB_OBJECT_NET_RATE_CONTROL_FLAGS,
    pub DscpTag: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_NET_RATE_CONTROL_INFORMATION"]
        [::std::mem::size_of::<JOBOBJECT_NET_RATE_CONTROL_INFORMATION>() - 16usize];
    ["Alignment of JOBOBJECT_NET_RATE_CONTROL_INFORMATION"]
        [::std::mem::align_of::<JOBOBJECT_NET_RATE_CONTROL_INFORMATION>() - 8usize];
    ["Offset of field: JOBOBJECT_NET_RATE_CONTROL_INFORMATION::MaxBandwidth"]
        [::std::mem::offset_of!(JOBOBJECT_NET_RATE_CONTROL_INFORMATION, MaxBandwidth) - 0usize];
    ["Offset of field: JOBOBJECT_NET_RATE_CONTROL_INFORMATION::ControlFlags"]
        [::std::mem::offset_of!(JOBOBJECT_NET_RATE_CONTROL_INFORMATION, ControlFlags) - 8usize];
    ["Offset of field: JOBOBJECT_NET_RATE_CONTROL_INFORMATION::DscpTag"]
        [::std::mem::offset_of!(JOBOBJECT_NET_RATE_CONTROL_INFORMATION, DscpTag) - 12usize];
};
pub const JOB_OBJECT_IO_RATE_CONTROL_FLAGS_JOB_OBJECT_IO_RATE_CONTROL_ENABLE:
    JOB_OBJECT_IO_RATE_CONTROL_FLAGS = 1;
pub const JOB_OBJECT_IO_RATE_CONTROL_FLAGS_JOB_OBJECT_IO_RATE_CONTROL_STANDALONE_VOLUME:
    JOB_OBJECT_IO_RATE_CONTROL_FLAGS = 2;
pub const JOB_OBJECT_IO_RATE_CONTROL_FLAGS_JOB_OBJECT_IO_RATE_CONTROL_FORCE_UNIT_ACCESS_ALL:
    JOB_OBJECT_IO_RATE_CONTROL_FLAGS = 4;
pub const JOB_OBJECT_IO_RATE_CONTROL_FLAGS_JOB_OBJECT_IO_RATE_CONTROL_FORCE_UNIT_ACCESS_ON_SOFT_CAP : JOB_OBJECT_IO_RATE_CONTROL_FLAGS = 8 ;
pub const JOB_OBJECT_IO_RATE_CONTROL_FLAGS_JOB_OBJECT_IO_RATE_CONTROL_VALID_FLAGS:
    JOB_OBJECT_IO_RATE_CONTROL_FLAGS = 15;
pub type JOB_OBJECT_IO_RATE_CONTROL_FLAGS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE {
    pub MaxIops: LONG64,
    pub MaxBandwidth: LONG64,
    pub ReservationIops: LONG64,
    pub VolumeName: PWSTR,
    pub BaseIoSize: DWORD,
    pub ControlFlags: JOB_OBJECT_IO_RATE_CONTROL_FLAGS,
    pub VolumeNameLength: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE"]
        [::std::mem::size_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE>() - 48usize];
    ["Alignment of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE"]
        [::std::mem::align_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE>() - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::MaxIops"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE, MaxIops) - 0usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::MaxBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        MaxBandwidth
    ) - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::ReservationIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        ReservationIops
    ) - 16usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::VolumeName"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        VolumeName
    ) - 24usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::BaseIoSize"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        BaseIoSize
    ) - 32usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::ControlFlags"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        ControlFlags
    ) - 36usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE::VolumeNameLength"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE,
        VolumeNameLength
    )
        - 40usize];
};
pub type JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V1 =
    JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2 {
    pub MaxIops: LONG64,
    pub MaxBandwidth: LONG64,
    pub ReservationIops: LONG64,
    pub VolumeName: PWSTR,
    pub BaseIoSize: DWORD,
    pub ControlFlags: JOB_OBJECT_IO_RATE_CONTROL_FLAGS,
    pub VolumeNameLength: WORD,
    pub CriticalReservationIops: LONG64,
    pub ReservationBandwidth: LONG64,
    pub CriticalReservationBandwidth: LONG64,
    pub MaxTimePercent: LONG64,
    pub ReservationTimePercent: LONG64,
    pub CriticalReservationTimePercent: LONG64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2"]
        [::std::mem::size_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2>() - 96usize];
    ["Alignment of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2"]
        [::std::mem::align_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2>() - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::MaxIops"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2, MaxIops) - 0usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::MaxBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        MaxBandwidth
    ) - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::ReservationIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        ReservationIops
    )
        - 16usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::VolumeName"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        VolumeName
    ) - 24usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::BaseIoSize"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        BaseIoSize
    ) - 32usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::ControlFlags"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        ControlFlags
    ) - 36usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::VolumeNameLength"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        VolumeNameLength
    )
        - 40usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::CriticalReservationIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        CriticalReservationIops
    )
        - 48usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::ReservationBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        ReservationBandwidth
    )
        - 56usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::CriticalReservationBandwidth"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2 , CriticalReservationBandwidth) - 64usize] ;
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::MaxTimePercent"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        MaxTimePercent
    )
        - 72usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::ReservationTimePercent"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2,
        ReservationTimePercent
    )
        - 80usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2::CriticalReservationTimePercent"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V2 , CriticalReservationTimePercent) - 88usize] ;
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3 {
    pub MaxIops: LONG64,
    pub MaxBandwidth: LONG64,
    pub ReservationIops: LONG64,
    pub VolumeName: PWSTR,
    pub BaseIoSize: DWORD,
    pub ControlFlags: JOB_OBJECT_IO_RATE_CONTROL_FLAGS,
    pub VolumeNameLength: WORD,
    pub CriticalReservationIops: LONG64,
    pub ReservationBandwidth: LONG64,
    pub CriticalReservationBandwidth: LONG64,
    pub MaxTimePercent: LONG64,
    pub ReservationTimePercent: LONG64,
    pub CriticalReservationTimePercent: LONG64,
    pub SoftMaxIops: LONG64,
    pub SoftMaxBandwidth: LONG64,
    pub SoftMaxTimePercent: LONG64,
    pub LimitExcessNotifyIops: LONG64,
    pub LimitExcessNotifyBandwidth: LONG64,
    pub LimitExcessNotifyTimePercent: LONG64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3"]
        [::std::mem::size_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3>() - 144usize];
    ["Alignment of JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3"]
        [::std::mem::align_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3>() - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::MaxIops"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3, MaxIops) - 0usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::MaxBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        MaxBandwidth
    ) - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::ReservationIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        ReservationIops
    )
        - 16usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::VolumeName"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        VolumeName
    ) - 24usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::BaseIoSize"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        BaseIoSize
    ) - 32usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::ControlFlags"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        ControlFlags
    ) - 36usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::VolumeNameLength"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        VolumeNameLength
    )
        - 40usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::CriticalReservationIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        CriticalReservationIops
    )
        - 48usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::ReservationBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        ReservationBandwidth
    )
        - 56usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::CriticalReservationBandwidth"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3 , CriticalReservationBandwidth) - 64usize] ;
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::MaxTimePercent"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        MaxTimePercent
    )
        - 72usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::ReservationTimePercent"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        ReservationTimePercent
    )
        - 80usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::CriticalReservationTimePercent"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3 , CriticalReservationTimePercent) - 88usize] ;
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::SoftMaxIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        SoftMaxIops
    ) - 96usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::SoftMaxBandwidth"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        SoftMaxBandwidth
    )
        - 104usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::SoftMaxTimePercent"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        SoftMaxTimePercent
    )
        - 112usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::LimitExcessNotifyIops"][::std::mem::offset_of!(
        JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3,
        LimitExcessNotifyIops
    )
        - 120usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::LimitExcessNotifyBandwidth"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3 , LimitExcessNotifyBandwidth) - 128usize] ;
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3::LimitExcessNotifyTimePercent"] [:: std :: mem :: offset_of ! (JOBOBJECT_IO_RATE_CONTROL_INFORMATION_NATIVE_V3 , LimitExcessNotifyTimePercent) - 136usize] ;
};
pub const JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS_JOBOBJECT_IO_ATTRIBUTION_CONTROL_ENABLE:
    JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS = 1;
pub const JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS_JOBOBJECT_IO_ATTRIBUTION_CONTROL_DISABLE:
    JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS = 2;
pub const JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS_JOBOBJECT_IO_ATTRIBUTION_CONTROL_VALID_FLAGS:
    JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS = 3;
pub type JOBOBJECT_IO_ATTRIBUTION_CONTROL_FLAGS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_IO_ATTRIBUTION_STATS {
    pub IoCount: ULONG_PTR,
    pub TotalNonOverlappedQueueTime: ULONGLONG,
    pub TotalNonOverlappedServiceTime: ULONGLONG,
    pub TotalSize: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_IO_ATTRIBUTION_STATS"]
        [::std::mem::size_of::<_JOBOBJECT_IO_ATTRIBUTION_STATS>() - 32usize];
    ["Alignment of _JOBOBJECT_IO_ATTRIBUTION_STATS"]
        [::std::mem::align_of::<_JOBOBJECT_IO_ATTRIBUTION_STATS>() - 8usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_STATS::IoCount"]
        [::std::mem::offset_of!(_JOBOBJECT_IO_ATTRIBUTION_STATS, IoCount) - 0usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_STATS::TotalNonOverlappedQueueTime"][::std::mem::offset_of!(
        _JOBOBJECT_IO_ATTRIBUTION_STATS,
        TotalNonOverlappedQueueTime
    ) - 8usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_STATS::TotalNonOverlappedServiceTime"][::std::mem::offset_of!(
        _JOBOBJECT_IO_ATTRIBUTION_STATS,
        TotalNonOverlappedServiceTime
    )
        - 16usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_STATS::TotalSize"]
        [::std::mem::offset_of!(_JOBOBJECT_IO_ATTRIBUTION_STATS, TotalSize) - 24usize];
};
pub type JOBOBJECT_IO_ATTRIBUTION_STATS = _JOBOBJECT_IO_ATTRIBUTION_STATS;
pub type PJOBOBJECT_IO_ATTRIBUTION_STATS = *mut _JOBOBJECT_IO_ATTRIBUTION_STATS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOBOBJECT_IO_ATTRIBUTION_INFORMATION {
    pub ControlFlags: DWORD,
    pub ReadStats: JOBOBJECT_IO_ATTRIBUTION_STATS,
    pub WriteStats: JOBOBJECT_IO_ATTRIBUTION_STATS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOBOBJECT_IO_ATTRIBUTION_INFORMATION"]
        [::std::mem::size_of::<_JOBOBJECT_IO_ATTRIBUTION_INFORMATION>() - 72usize];
    ["Alignment of _JOBOBJECT_IO_ATTRIBUTION_INFORMATION"]
        [::std::mem::align_of::<_JOBOBJECT_IO_ATTRIBUTION_INFORMATION>() - 8usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_INFORMATION::ControlFlags"]
        [::std::mem::offset_of!(_JOBOBJECT_IO_ATTRIBUTION_INFORMATION, ControlFlags) - 0usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_INFORMATION::ReadStats"]
        [::std::mem::offset_of!(_JOBOBJECT_IO_ATTRIBUTION_INFORMATION, ReadStats) - 8usize];
    ["Offset of field: _JOBOBJECT_IO_ATTRIBUTION_INFORMATION::WriteStats"]
        [::std::mem::offset_of!(_JOBOBJECT_IO_ATTRIBUTION_INFORMATION, WriteStats) - 40usize];
};
pub type JOBOBJECT_IO_ATTRIBUTION_INFORMATION = _JOBOBJECT_IO_ATTRIBUTION_INFORMATION;
pub type PJOBOBJECT_IO_ATTRIBUTION_INFORMATION = *mut _JOBOBJECT_IO_ATTRIBUTION_INFORMATION;
pub const _JOBOBJECTINFOCLASS_JobObjectBasicAccountingInformation: _JOBOBJECTINFOCLASS = 1;
pub const _JOBOBJECTINFOCLASS_JobObjectBasicLimitInformation: _JOBOBJECTINFOCLASS = 2;
pub const _JOBOBJECTINFOCLASS_JobObjectBasicProcessIdList: _JOBOBJECTINFOCLASS = 3;
pub const _JOBOBJECTINFOCLASS_JobObjectBasicUIRestrictions: _JOBOBJECTINFOCLASS = 4;
pub const _JOBOBJECTINFOCLASS_JobObjectSecurityLimitInformation: _JOBOBJECTINFOCLASS = 5;
pub const _JOBOBJECTINFOCLASS_JobObjectEndOfJobTimeInformation: _JOBOBJECTINFOCLASS = 6;
pub const _JOBOBJECTINFOCLASS_JobObjectAssociateCompletionPortInformation: _JOBOBJECTINFOCLASS = 7;
pub const _JOBOBJECTINFOCLASS_JobObjectBasicAndIoAccountingInformation: _JOBOBJECTINFOCLASS = 8;
pub const _JOBOBJECTINFOCLASS_JobObjectExtendedLimitInformation: _JOBOBJECTINFOCLASS = 9;
pub const _JOBOBJECTINFOCLASS_JobObjectJobSetInformation: _JOBOBJECTINFOCLASS = 10;
pub const _JOBOBJECTINFOCLASS_JobObjectGroupInformation: _JOBOBJECTINFOCLASS = 11;
pub const _JOBOBJECTINFOCLASS_JobObjectNotificationLimitInformation: _JOBOBJECTINFOCLASS = 12;
pub const _JOBOBJECTINFOCLASS_JobObjectLimitViolationInformation: _JOBOBJECTINFOCLASS = 13;
pub const _JOBOBJECTINFOCLASS_JobObjectGroupInformationEx: _JOBOBJECTINFOCLASS = 14;
pub const _JOBOBJECTINFOCLASS_JobObjectCpuRateControlInformation: _JOBOBJECTINFOCLASS = 15;
pub const _JOBOBJECTINFOCLASS_JobObjectCompletionFilter: _JOBOBJECTINFOCLASS = 16;
pub const _JOBOBJECTINFOCLASS_JobObjectCompletionCounter: _JOBOBJECTINFOCLASS = 17;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved1Information: _JOBOBJECTINFOCLASS = 18;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved2Information: _JOBOBJECTINFOCLASS = 19;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved3Information: _JOBOBJECTINFOCLASS = 20;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved4Information: _JOBOBJECTINFOCLASS = 21;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved5Information: _JOBOBJECTINFOCLASS = 22;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved6Information: _JOBOBJECTINFOCLASS = 23;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved7Information: _JOBOBJECTINFOCLASS = 24;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved8Information: _JOBOBJECTINFOCLASS = 25;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved9Information: _JOBOBJECTINFOCLASS = 26;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved10Information: _JOBOBJECTINFOCLASS = 27;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved11Information: _JOBOBJECTINFOCLASS = 28;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved12Information: _JOBOBJECTINFOCLASS = 29;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved13Information: _JOBOBJECTINFOCLASS = 30;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved14Information: _JOBOBJECTINFOCLASS = 31;
pub const _JOBOBJECTINFOCLASS_JobObjectNetRateControlInformation: _JOBOBJECTINFOCLASS = 32;
pub const _JOBOBJECTINFOCLASS_JobObjectNotificationLimitInformation2: _JOBOBJECTINFOCLASS = 33;
pub const _JOBOBJECTINFOCLASS_JobObjectLimitViolationInformation2: _JOBOBJECTINFOCLASS = 34;
pub const _JOBOBJECTINFOCLASS_JobObjectCreateSilo: _JOBOBJECTINFOCLASS = 35;
pub const _JOBOBJECTINFOCLASS_JobObjectSiloBasicInformation: _JOBOBJECTINFOCLASS = 36;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved15Information: _JOBOBJECTINFOCLASS = 37;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved16Information: _JOBOBJECTINFOCLASS = 38;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved17Information: _JOBOBJECTINFOCLASS = 39;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved18Information: _JOBOBJECTINFOCLASS = 40;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved19Information: _JOBOBJECTINFOCLASS = 41;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved20Information: _JOBOBJECTINFOCLASS = 42;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved21Information: _JOBOBJECTINFOCLASS = 43;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved22Information: _JOBOBJECTINFOCLASS = 44;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved23Information: _JOBOBJECTINFOCLASS = 45;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved24Information: _JOBOBJECTINFOCLASS = 46;
pub const _JOBOBJECTINFOCLASS_JobObjectReserved25Information: _JOBOBJECTINFOCLASS = 47;
pub const _JOBOBJECTINFOCLASS_MaxJobObjectInfoClass: _JOBOBJECTINFOCLASS = 48;
pub type _JOBOBJECTINFOCLASS = ::std::os::raw::c_int;
pub use self::_JOBOBJECTINFOCLASS as JOBOBJECTINFOCLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SILOOBJECT_BASIC_INFORMATION {
    pub SiloId: DWORD,
    pub SiloParentId: DWORD,
    pub NumberOfProcesses: DWORD,
    pub IsInServerSilo: BOOLEAN,
    pub Reserved: [BYTE; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SILOOBJECT_BASIC_INFORMATION"]
        [::std::mem::size_of::<_SILOOBJECT_BASIC_INFORMATION>() - 16usize];
    ["Alignment of _SILOOBJECT_BASIC_INFORMATION"]
        [::std::mem::align_of::<_SILOOBJECT_BASIC_INFORMATION>() - 4usize];
    ["Offset of field: _SILOOBJECT_BASIC_INFORMATION::SiloId"]
        [::std::mem::offset_of!(_SILOOBJECT_BASIC_INFORMATION, SiloId) - 0usize];
    ["Offset of field: _SILOOBJECT_BASIC_INFORMATION::SiloParentId"]
        [::std::mem::offset_of!(_SILOOBJECT_BASIC_INFORMATION, SiloParentId) - 4usize];
    ["Offset of field: _SILOOBJECT_BASIC_INFORMATION::NumberOfProcesses"]
        [::std::mem::offset_of!(_SILOOBJECT_BASIC_INFORMATION, NumberOfProcesses) - 8usize];
    ["Offset of field: _SILOOBJECT_BASIC_INFORMATION::IsInServerSilo"]
        [::std::mem::offset_of!(_SILOOBJECT_BASIC_INFORMATION, IsInServerSilo) - 12usize];
    ["Offset of field: _SILOOBJECT_BASIC_INFORMATION::Reserved"]
        [::std::mem::offset_of!(_SILOOBJECT_BASIC_INFORMATION, Reserved) - 13usize];
};
pub type SILOOBJECT_BASIC_INFORMATION = _SILOOBJECT_BASIC_INFORMATION;
pub type PSILOOBJECT_BASIC_INFORMATION = *mut _SILOOBJECT_BASIC_INFORMATION;
pub const _SERVERSILO_STATE_SERVERSILO_INITING: _SERVERSILO_STATE = 0;
pub const _SERVERSILO_STATE_SERVERSILO_STARTED: _SERVERSILO_STATE = 1;
pub const _SERVERSILO_STATE_SERVERSILO_SHUTTING_DOWN: _SERVERSILO_STATE = 2;
pub const _SERVERSILO_STATE_SERVERSILO_TERMINATING: _SERVERSILO_STATE = 3;
pub const _SERVERSILO_STATE_SERVERSILO_TERMINATED: _SERVERSILO_STATE = 4;
pub type _SERVERSILO_STATE = ::std::os::raw::c_int;
pub use self::_SERVERSILO_STATE as SERVERSILO_STATE;
pub type PSERVERSILO_STATE = *mut _SERVERSILO_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVERSILO_BASIC_INFORMATION {
    pub ServiceSessionId: DWORD,
    pub State: SERVERSILO_STATE,
    pub ExitStatus: DWORD,
    pub IsDownlevelContainer: BOOLEAN,
    pub ApiSetSchema: PVOID,
    pub HostApiSetSchema: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVERSILO_BASIC_INFORMATION"]
        [::std::mem::size_of::<_SERVERSILO_BASIC_INFORMATION>() - 32usize];
    ["Alignment of _SERVERSILO_BASIC_INFORMATION"]
        [::std::mem::align_of::<_SERVERSILO_BASIC_INFORMATION>() - 8usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::ServiceSessionId"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, ServiceSessionId) - 0usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::State"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, State) - 4usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::ExitStatus"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, ExitStatus) - 8usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::IsDownlevelContainer"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, IsDownlevelContainer) - 12usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::ApiSetSchema"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, ApiSetSchema) - 16usize];
    ["Offset of field: _SERVERSILO_BASIC_INFORMATION::HostApiSetSchema"]
        [::std::mem::offset_of!(_SERVERSILO_BASIC_INFORMATION, HostApiSetSchema) - 24usize];
};
pub type SERVERSILO_BASIC_INFORMATION = _SERVERSILO_BASIC_INFORMATION;
pub type PSERVERSILO_BASIC_INFORMATION = *mut _SERVERSILO_BASIC_INFORMATION;
pub const _FIRMWARE_TYPE_FirmwareTypeUnknown: _FIRMWARE_TYPE = 0;
pub const _FIRMWARE_TYPE_FirmwareTypeBios: _FIRMWARE_TYPE = 1;
pub const _FIRMWARE_TYPE_FirmwareTypeUefi: _FIRMWARE_TYPE = 2;
pub const _FIRMWARE_TYPE_FirmwareTypeMax: _FIRMWARE_TYPE = 3;
pub type _FIRMWARE_TYPE = ::std::os::raw::c_int;
pub use self::_FIRMWARE_TYPE as FIRMWARE_TYPE;
pub type PFIRMWARE_TYPE = *mut _FIRMWARE_TYPE;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationProcessorCore: _LOGICAL_PROCESSOR_RELATIONSHIP =
    0;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationNumaNode: _LOGICAL_PROCESSOR_RELATIONSHIP = 1;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationCache: _LOGICAL_PROCESSOR_RELATIONSHIP = 2;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationProcessorPackage:
    _LOGICAL_PROCESSOR_RELATIONSHIP = 3;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationGroup: _LOGICAL_PROCESSOR_RELATIONSHIP = 4;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationProcessorDie: _LOGICAL_PROCESSOR_RELATIONSHIP = 5;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationNumaNodeEx: _LOGICAL_PROCESSOR_RELATIONSHIP = 6;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationProcessorModule: _LOGICAL_PROCESSOR_RELATIONSHIP =
    7;
pub const _LOGICAL_PROCESSOR_RELATIONSHIP_RelationAll: _LOGICAL_PROCESSOR_RELATIONSHIP = 65535;
pub type _LOGICAL_PROCESSOR_RELATIONSHIP = ::std::os::raw::c_int;
pub use self::_LOGICAL_PROCESSOR_RELATIONSHIP as LOGICAL_PROCESSOR_RELATIONSHIP;
pub const _PROCESSOR_CACHE_TYPE_CacheUnified: _PROCESSOR_CACHE_TYPE = 0;
pub const _PROCESSOR_CACHE_TYPE_CacheInstruction: _PROCESSOR_CACHE_TYPE = 1;
pub const _PROCESSOR_CACHE_TYPE_CacheData: _PROCESSOR_CACHE_TYPE = 2;
pub const _PROCESSOR_CACHE_TYPE_CacheTrace: _PROCESSOR_CACHE_TYPE = 3;
pub type _PROCESSOR_CACHE_TYPE = ::std::os::raw::c_int;
pub use self::_PROCESSOR_CACHE_TYPE as PROCESSOR_CACHE_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CACHE_DESCRIPTOR {
    pub Level: BYTE,
    pub Associativity: BYTE,
    pub LineSize: WORD,
    pub Size: DWORD,
    pub Type: PROCESSOR_CACHE_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CACHE_DESCRIPTOR"][::std::mem::size_of::<_CACHE_DESCRIPTOR>() - 12usize];
    ["Alignment of _CACHE_DESCRIPTOR"][::std::mem::align_of::<_CACHE_DESCRIPTOR>() - 4usize];
    ["Offset of field: _CACHE_DESCRIPTOR::Level"]
        [::std::mem::offset_of!(_CACHE_DESCRIPTOR, Level) - 0usize];
    ["Offset of field: _CACHE_DESCRIPTOR::Associativity"]
        [::std::mem::offset_of!(_CACHE_DESCRIPTOR, Associativity) - 1usize];
    ["Offset of field: _CACHE_DESCRIPTOR::LineSize"]
        [::std::mem::offset_of!(_CACHE_DESCRIPTOR, LineSize) - 2usize];
    ["Offset of field: _CACHE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_CACHE_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _CACHE_DESCRIPTOR::Type"]
        [::std::mem::offset_of!(_CACHE_DESCRIPTOR, Type) - 8usize];
};
pub type CACHE_DESCRIPTOR = _CACHE_DESCRIPTOR;
pub type PCACHE_DESCRIPTOR = *mut _CACHE_DESCRIPTOR;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SYSTEM_LOGICAL_PROCESSOR_INFORMATION {
    pub ProcessorMask: ULONG_PTR,
    pub Relationship: LOGICAL_PROCESSOR_RELATIONSHIP,
    pub __bindgen_anon_1: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1 {
    pub ProcessorCore: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    pub NumaNode: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2,
    pub Cache: CACHE_DESCRIPTOR,
    pub Reserved: [ULONGLONG; 2usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub Flags: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1>(
        ) - 1usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1>(
        ) - 1usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1::Flags"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        Flags
    )
        - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2 {
    pub NodeNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2>(
        ) - 4usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2>(
        ) - 4usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2::NodeNumber"] [:: std :: mem :: offset_of ! (_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1__bindgen_ty_2 , NodeNumber) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1>() - 16usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1::ProcessorCore"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1,
        ProcessorCore
    )
        - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1::NumaNode"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1,
        NumaNode
    ) - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1::Cache"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1,
        Cache
    ) - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1::Reserved"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION__bindgen_ty_1,
        Reserved
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION>() - 32usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION>() - 8usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION::ProcessorMask"]
        [::std::mem::offset_of!(_SYSTEM_LOGICAL_PROCESSOR_INFORMATION, ProcessorMask) - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION::Relationship"]
        [::std::mem::offset_of!(_SYSTEM_LOGICAL_PROCESSOR_INFORMATION, Relationship) - 8usize];
};
pub type SYSTEM_LOGICAL_PROCESSOR_INFORMATION = _SYSTEM_LOGICAL_PROCESSOR_INFORMATION;
pub type PSYSTEM_LOGICAL_PROCESSOR_INFORMATION = *mut _SYSTEM_LOGICAL_PROCESSOR_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESSOR_RELATIONSHIP {
    pub Flags: BYTE,
    pub EfficiencyClass: BYTE,
    pub Reserved: [BYTE; 20usize],
    pub GroupCount: WORD,
    pub GroupMask: [GROUP_AFFINITY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESSOR_RELATIONSHIP"][::std::mem::size_of::<_PROCESSOR_RELATIONSHIP>() - 40usize];
    ["Alignment of _PROCESSOR_RELATIONSHIP"]
        [::std::mem::align_of::<_PROCESSOR_RELATIONSHIP>() - 8usize];
    ["Offset of field: _PROCESSOR_RELATIONSHIP::Flags"]
        [::std::mem::offset_of!(_PROCESSOR_RELATIONSHIP, Flags) - 0usize];
    ["Offset of field: _PROCESSOR_RELATIONSHIP::EfficiencyClass"]
        [::std::mem::offset_of!(_PROCESSOR_RELATIONSHIP, EfficiencyClass) - 1usize];
    ["Offset of field: _PROCESSOR_RELATIONSHIP::Reserved"]
        [::std::mem::offset_of!(_PROCESSOR_RELATIONSHIP, Reserved) - 2usize];
    ["Offset of field: _PROCESSOR_RELATIONSHIP::GroupCount"]
        [::std::mem::offset_of!(_PROCESSOR_RELATIONSHIP, GroupCount) - 22usize];
    ["Offset of field: _PROCESSOR_RELATIONSHIP::GroupMask"]
        [::std::mem::offset_of!(_PROCESSOR_RELATIONSHIP, GroupMask) - 24usize];
};
pub type PROCESSOR_RELATIONSHIP = _PROCESSOR_RELATIONSHIP;
pub type PPROCESSOR_RELATIONSHIP = *mut _PROCESSOR_RELATIONSHIP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NUMA_NODE_RELATIONSHIP {
    pub NodeNumber: DWORD,
    pub Reserved: [BYTE; 18usize],
    pub GroupCount: WORD,
    pub __bindgen_anon_1: _NUMA_NODE_RELATIONSHIP__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NUMA_NODE_RELATIONSHIP__bindgen_ty_1 {
    pub GroupMask: GROUP_AFFINITY,
    pub GroupMasks: [GROUP_AFFINITY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NUMA_NODE_RELATIONSHIP__bindgen_ty_1"]
        [::std::mem::size_of::<_NUMA_NODE_RELATIONSHIP__bindgen_ty_1>() - 16usize];
    ["Alignment of _NUMA_NODE_RELATIONSHIP__bindgen_ty_1"]
        [::std::mem::align_of::<_NUMA_NODE_RELATIONSHIP__bindgen_ty_1>() - 8usize];
    ["Offset of field: _NUMA_NODE_RELATIONSHIP__bindgen_ty_1::GroupMask"]
        [::std::mem::offset_of!(_NUMA_NODE_RELATIONSHIP__bindgen_ty_1, GroupMask) - 0usize];
    ["Offset of field: _NUMA_NODE_RELATIONSHIP__bindgen_ty_1::GroupMasks"]
        [::std::mem::offset_of!(_NUMA_NODE_RELATIONSHIP__bindgen_ty_1, GroupMasks) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NUMA_NODE_RELATIONSHIP"][::std::mem::size_of::<_NUMA_NODE_RELATIONSHIP>() - 40usize];
    ["Alignment of _NUMA_NODE_RELATIONSHIP"]
        [::std::mem::align_of::<_NUMA_NODE_RELATIONSHIP>() - 8usize];
    ["Offset of field: _NUMA_NODE_RELATIONSHIP::NodeNumber"]
        [::std::mem::offset_of!(_NUMA_NODE_RELATIONSHIP, NodeNumber) - 0usize];
    ["Offset of field: _NUMA_NODE_RELATIONSHIP::Reserved"]
        [::std::mem::offset_of!(_NUMA_NODE_RELATIONSHIP, Reserved) - 4usize];
    ["Offset of field: _NUMA_NODE_RELATIONSHIP::GroupCount"]
        [::std::mem::offset_of!(_NUMA_NODE_RELATIONSHIP, GroupCount) - 22usize];
};
pub type NUMA_NODE_RELATIONSHIP = _NUMA_NODE_RELATIONSHIP;
pub type PNUMA_NODE_RELATIONSHIP = *mut _NUMA_NODE_RELATIONSHIP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CACHE_RELATIONSHIP {
    pub Level: BYTE,
    pub Associativity: BYTE,
    pub LineSize: WORD,
    pub CacheSize: DWORD,
    pub Type: PROCESSOR_CACHE_TYPE,
    pub Reserved: [BYTE; 18usize],
    pub GroupCount: WORD,
    pub __bindgen_anon_1: _CACHE_RELATIONSHIP__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CACHE_RELATIONSHIP__bindgen_ty_1 {
    pub GroupMask: GROUP_AFFINITY,
    pub GroupMasks: [GROUP_AFFINITY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CACHE_RELATIONSHIP__bindgen_ty_1"]
        [::std::mem::size_of::<_CACHE_RELATIONSHIP__bindgen_ty_1>() - 16usize];
    ["Alignment of _CACHE_RELATIONSHIP__bindgen_ty_1"]
        [::std::mem::align_of::<_CACHE_RELATIONSHIP__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CACHE_RELATIONSHIP__bindgen_ty_1::GroupMask"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP__bindgen_ty_1, GroupMask) - 0usize];
    ["Offset of field: _CACHE_RELATIONSHIP__bindgen_ty_1::GroupMasks"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP__bindgen_ty_1, GroupMasks) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CACHE_RELATIONSHIP"][::std::mem::size_of::<_CACHE_RELATIONSHIP>() - 48usize];
    ["Alignment of _CACHE_RELATIONSHIP"][::std::mem::align_of::<_CACHE_RELATIONSHIP>() - 8usize];
    ["Offset of field: _CACHE_RELATIONSHIP::Level"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, Level) - 0usize];
    ["Offset of field: _CACHE_RELATIONSHIP::Associativity"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, Associativity) - 1usize];
    ["Offset of field: _CACHE_RELATIONSHIP::LineSize"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, LineSize) - 2usize];
    ["Offset of field: _CACHE_RELATIONSHIP::CacheSize"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, CacheSize) - 4usize];
    ["Offset of field: _CACHE_RELATIONSHIP::Type"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, Type) - 8usize];
    ["Offset of field: _CACHE_RELATIONSHIP::Reserved"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, Reserved) - 12usize];
    ["Offset of field: _CACHE_RELATIONSHIP::GroupCount"]
        [::std::mem::offset_of!(_CACHE_RELATIONSHIP, GroupCount) - 30usize];
};
pub type CACHE_RELATIONSHIP = _CACHE_RELATIONSHIP;
pub type PCACHE_RELATIONSHIP = *mut _CACHE_RELATIONSHIP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESSOR_GROUP_INFO {
    pub MaximumProcessorCount: BYTE,
    pub ActiveProcessorCount: BYTE,
    pub Reserved: [BYTE; 38usize],
    pub ActiveProcessorMask: KAFFINITY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESSOR_GROUP_INFO"][::std::mem::size_of::<_PROCESSOR_GROUP_INFO>() - 48usize];
    ["Alignment of _PROCESSOR_GROUP_INFO"]
        [::std::mem::align_of::<_PROCESSOR_GROUP_INFO>() - 8usize];
    ["Offset of field: _PROCESSOR_GROUP_INFO::MaximumProcessorCount"]
        [::std::mem::offset_of!(_PROCESSOR_GROUP_INFO, MaximumProcessorCount) - 0usize];
    ["Offset of field: _PROCESSOR_GROUP_INFO::ActiveProcessorCount"]
        [::std::mem::offset_of!(_PROCESSOR_GROUP_INFO, ActiveProcessorCount) - 1usize];
    ["Offset of field: _PROCESSOR_GROUP_INFO::Reserved"]
        [::std::mem::offset_of!(_PROCESSOR_GROUP_INFO, Reserved) - 2usize];
    ["Offset of field: _PROCESSOR_GROUP_INFO::ActiveProcessorMask"]
        [::std::mem::offset_of!(_PROCESSOR_GROUP_INFO, ActiveProcessorMask) - 40usize];
};
pub type PROCESSOR_GROUP_INFO = _PROCESSOR_GROUP_INFO;
pub type PPROCESSOR_GROUP_INFO = *mut _PROCESSOR_GROUP_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GROUP_RELATIONSHIP {
    pub MaximumGroupCount: WORD,
    pub ActiveGroupCount: WORD,
    pub Reserved: [BYTE; 20usize],
    pub GroupInfo: [PROCESSOR_GROUP_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GROUP_RELATIONSHIP"][::std::mem::size_of::<_GROUP_RELATIONSHIP>() - 72usize];
    ["Alignment of _GROUP_RELATIONSHIP"][::std::mem::align_of::<_GROUP_RELATIONSHIP>() - 8usize];
    ["Offset of field: _GROUP_RELATIONSHIP::MaximumGroupCount"]
        [::std::mem::offset_of!(_GROUP_RELATIONSHIP, MaximumGroupCount) - 0usize];
    ["Offset of field: _GROUP_RELATIONSHIP::ActiveGroupCount"]
        [::std::mem::offset_of!(_GROUP_RELATIONSHIP, ActiveGroupCount) - 2usize];
    ["Offset of field: _GROUP_RELATIONSHIP::Reserved"]
        [::std::mem::offset_of!(_GROUP_RELATIONSHIP, Reserved) - 4usize];
    ["Offset of field: _GROUP_RELATIONSHIP::GroupInfo"]
        [::std::mem::offset_of!(_GROUP_RELATIONSHIP, GroupInfo) - 24usize];
};
pub type GROUP_RELATIONSHIP = _GROUP_RELATIONSHIP;
pub type PGROUP_RELATIONSHIP = *mut _GROUP_RELATIONSHIP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX {
    pub Relationship: LOGICAL_PROCESSOR_RELATIONSHIP,
    pub Size: DWORD,
    pub __bindgen_anon_1: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1 {
    pub Processor: PROCESSOR_RELATIONSHIP,
    pub NumaNode: NUMA_NODE_RELATIONSHIP,
    pub Cache: CACHE_RELATIONSHIP,
    pub Group: GROUP_RELATIONSHIP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1>() - 72usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1::Processor"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1,
        Processor
    )
        - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1::NumaNode"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1,
        NumaNode
    )
        - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1::Cache"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1,
        Cache
    ) - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1::Group"][::std::mem::offset_of!(
        _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX__bindgen_ty_1,
        Group
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX"]
        [::std::mem::size_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX>() - 80usize];
    ["Alignment of _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX"]
        [::std::mem::align_of::<_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX>() - 8usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX::Relationship"]
        [::std::mem::offset_of!(_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX, Relationship) - 0usize];
    ["Offset of field: _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX::Size"]
        [::std::mem::offset_of!(_SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX, Size) - 4usize];
};
pub type SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX = _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX;
pub type PSYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX = *mut _SYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX;
pub const _CPU_SET_INFORMATION_TYPE_CpuSetInformation: _CPU_SET_INFORMATION_TYPE = 0;
pub type _CPU_SET_INFORMATION_TYPE = ::std::os::raw::c_int;
pub use self::_CPU_SET_INFORMATION_TYPE as CPU_SET_INFORMATION_TYPE;
pub type PCPU_SET_INFORMATION_TYPE = *mut _CPU_SET_INFORMATION_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SYSTEM_CPU_SET_INFORMATION {
    pub Size: DWORD,
    pub Type: CPU_SET_INFORMATION_TYPE,
    pub __bindgen_anon_1: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1 {
    pub CpuSet: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub Id: DWORD,
    pub Group: WORD,
    pub LogicalProcessorIndex: BYTE,
    pub CoreIndex: BYTE,
    pub LastLevelCacheIndex: BYTE,
    pub NumaNodeIndex: BYTE,
    pub EfficiencyClass: BYTE,
    pub __bindgen_anon_1: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
    pub AllocationTag: DWORD64,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub AllFlags: BYTE,
    pub __bindgen_anon_1:
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"] [:: std :: mem :: size_of :: < _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 > () - 1usize] ;
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"] [:: std :: mem :: align_of :: < _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 > () - 1usize] ;
};
impl _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn Parked(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_Parked(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Parked_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Parked_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Allocated(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_Allocated(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Allocated_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Allocated_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AllocatedToTargetProcess(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_AllocatedToTargetProcess(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllocatedToTargetProcess_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_AllocatedToTargetProcess_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn RealTime(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_RealTime(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RealTime_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_RealTime_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedFlags(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_ReservedFlags(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedFlags_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedFlags_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Parked: BYTE,
        Allocated: BYTE,
        AllocatedToTargetProcess: BYTE,
        RealTime: BYTE,
        ReservedFlags: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let Parked: u8 = unsafe { ::std::mem::transmute(Parked) };
            Parked as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let Allocated: u8 = unsafe { ::std::mem::transmute(Allocated) };
            Allocated as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let AllocatedToTargetProcess: u8 =
                unsafe { ::std::mem::transmute(AllocatedToTargetProcess) };
            AllocatedToTargetProcess as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let RealTime: u8 = unsafe { ::std::mem::transmute(RealTime) };
            RealTime as u64
        });
        __bindgen_bitfield_unit.set(4usize, 4u8, {
            let ReservedFlags: u8 = unsafe { ::std::mem::transmute(ReservedFlags) };
            ReservedFlags as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        >() - 1usize];
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        >() - 1usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::AllFlags"] [:: std :: mem :: offset_of ! (_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , AllFlags) - 0usize] ;
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 {
    pub Reserved: DWORD,
    pub SchedulingClass: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<
            _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
        >() - 4usize];
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<
            _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2,
        >() - 4usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2::Reserved"] [:: std :: mem :: offset_of ! (_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 , Reserved) - 0usize] ;
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2::SchedulingClass"] [:: std :: mem :: offset_of ! (_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_2 , SchedulingClass) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    >() - 24usize];
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    >() - 8usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::Id"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        Id
    ) - 0usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::Group"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        Group
    ) - 4usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::LogicalProcessorIndex"] [:: std :: mem :: offset_of ! (_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1 , LogicalProcessorIndex) - 6usize] ;
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::CoreIndex"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        CoreIndex
    )
        - 7usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::LastLevelCacheIndex"] [:: std :: mem :: offset_of ! (_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1 , LastLevelCacheIndex) - 8usize] ;
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::NumaNodeIndex"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        NumaNodeIndex
    )
        - 9usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::EfficiencyClass"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        EfficiencyClass
    )
        - 10usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1::AllocationTag"][::std::mem::offset_of!(
        _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        AllocationTag
    )
        - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1>() - 24usize];
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1::CpuSet"]
        [::std::mem::offset_of!(_SYSTEM_CPU_SET_INFORMATION__bindgen_ty_1, CpuSet) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_CPU_SET_INFORMATION"]
        [::std::mem::size_of::<_SYSTEM_CPU_SET_INFORMATION>() - 32usize];
    ["Alignment of _SYSTEM_CPU_SET_INFORMATION"]
        [::std::mem::align_of::<_SYSTEM_CPU_SET_INFORMATION>() - 8usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION::Size"]
        [::std::mem::offset_of!(_SYSTEM_CPU_SET_INFORMATION, Size) - 0usize];
    ["Offset of field: _SYSTEM_CPU_SET_INFORMATION::Type"]
        [::std::mem::offset_of!(_SYSTEM_CPU_SET_INFORMATION, Type) - 4usize];
};
pub type SYSTEM_CPU_SET_INFORMATION = _SYSTEM_CPU_SET_INFORMATION;
pub type PSYSTEM_CPU_SET_INFORMATION = *mut _SYSTEM_CPU_SET_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_POOL_ZEROING_INFORMATION {
    pub PoolZeroingSupportPresent: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_POOL_ZEROING_INFORMATION"]
        [::std::mem::size_of::<_SYSTEM_POOL_ZEROING_INFORMATION>() - 1usize];
    ["Alignment of _SYSTEM_POOL_ZEROING_INFORMATION"]
        [::std::mem::align_of::<_SYSTEM_POOL_ZEROING_INFORMATION>() - 1usize];
    ["Offset of field: _SYSTEM_POOL_ZEROING_INFORMATION::PoolZeroingSupportPresent"][::std::mem::offset_of!(
        _SYSTEM_POOL_ZEROING_INFORMATION,
        PoolZeroingSupportPresent
    ) - 0usize];
};
pub type SYSTEM_POOL_ZEROING_INFORMATION = _SYSTEM_POOL_ZEROING_INFORMATION;
pub type PSYSTEM_POOL_ZEROING_INFORMATION = *mut _SYSTEM_POOL_ZEROING_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION {
    pub CycleTime: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION"]
        [::std::mem::size_of::<_SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION>() - 8usize];
    ["Alignment of _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION"]
        [::std::mem::align_of::<_SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION>() - 8usize];
    ["Offset of field: _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION::CycleTime"]
        [::std::mem::offset_of!(_SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION, CycleTime) - 0usize];
};
pub type SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION = _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION;
pub type PSYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION = *mut _SYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION;
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION"]
        [::std::mem::size_of::<_SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION>() - 4usize];
    ["Alignment of _SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION"]
        [::std::mem::align_of::<_SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION>() - 4usize];
};
impl _SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION {
    #[inline]
    pub fn Machine(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_Machine(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Machine_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Machine_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn KernelMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_KernelMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn KernelMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_KernelMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn UserMode(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(17usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_UserMode(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(17usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn UserMode_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                17usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_UserMode_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                17usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Native(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Native(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(18usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Native_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                18usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Native_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                18usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Process(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Process(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Process_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                19usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Process_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn WoW64Container(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_WoW64Container(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn WoW64Container_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_WoW64Container_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedZero0(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 11u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedZero0(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 11u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedZero0_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                11u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedZero0_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                11u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Machine: DWORD,
        KernelMode: DWORD,
        UserMode: DWORD,
        Native: DWORD,
        Process: DWORD,
        WoW64Container: DWORD,
        ReservedZero0: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 16u8, {
            let Machine: u32 = unsafe { ::std::mem::transmute(Machine) };
            Machine as u64
        });
        __bindgen_bitfield_unit.set(16usize, 1u8, {
            let KernelMode: u32 = unsafe { ::std::mem::transmute(KernelMode) };
            KernelMode as u64
        });
        __bindgen_bitfield_unit.set(17usize, 1u8, {
            let UserMode: u32 = unsafe { ::std::mem::transmute(UserMode) };
            UserMode as u64
        });
        __bindgen_bitfield_unit.set(18usize, 1u8, {
            let Native: u32 = unsafe { ::std::mem::transmute(Native) };
            Native as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let Process: u32 = unsafe { ::std::mem::transmute(Process) };
            Process as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let WoW64Container: u32 = unsafe { ::std::mem::transmute(WoW64Container) };
            WoW64Container as u64
        });
        __bindgen_bitfield_unit.set(21usize, 11u8, {
            let ReservedZero0: u32 = unsafe { ::std::mem::transmute(ReservedZero0) };
            ReservedZero0 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION =
    _SYSTEM_SUPPORTED_PROCESSOR_ARCHITECTURES_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _XSTATE_FEATURE {
    pub Offset: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSTATE_FEATURE"][::std::mem::size_of::<_XSTATE_FEATURE>() - 8usize];
    ["Alignment of _XSTATE_FEATURE"][::std::mem::align_of::<_XSTATE_FEATURE>() - 4usize];
    ["Offset of field: _XSTATE_FEATURE::Offset"]
        [::std::mem::offset_of!(_XSTATE_FEATURE, Offset) - 0usize];
    ["Offset of field: _XSTATE_FEATURE::Size"]
        [::std::mem::offset_of!(_XSTATE_FEATURE, Size) - 4usize];
};
pub type XSTATE_FEATURE = _XSTATE_FEATURE;
pub type PXSTATE_FEATURE = *mut _XSTATE_FEATURE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _XSTATE_CONFIGURATION {
    pub EnabledFeatures: DWORD64,
    pub EnabledVolatileFeatures: DWORD64,
    pub Size: DWORD,
    pub __bindgen_anon_1: _XSTATE_CONFIGURATION__bindgen_ty_1,
    pub Features: [XSTATE_FEATURE; 64usize],
    pub EnabledSupervisorFeatures: DWORD64,
    pub AlignedFeatures: DWORD64,
    pub AllFeatureSize: DWORD,
    pub AllFeatures: [DWORD; 64usize],
    pub EnabledUserVisibleSupervisorFeatures: DWORD64,
    pub ExtendedFeatureDisableFeatures: DWORD64,
    pub AllNonLargeFeatureSize: DWORD,
    pub Spare: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _XSTATE_CONFIGURATION__bindgen_ty_1 {
    pub ControlFlags: DWORD,
    pub __bindgen_anon_1: _XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1>() - 4usize];
};
impl _XSTATE_CONFIGURATION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn OptimizedSave(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_OptimizedSave(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn OptimizedSave_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_OptimizedSave_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn CompactionEnabled(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_CompactionEnabled(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn CompactionEnabled_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_CompactionEnabled_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ExtendedFeatureDisable(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ExtendedFeatureDisable(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ExtendedFeatureDisable_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ExtendedFeatureDisable_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        OptimizedSave: DWORD,
        CompactionEnabled: DWORD,
        ExtendedFeatureDisable: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let OptimizedSave: u32 = unsafe { ::std::mem::transmute(OptimizedSave) };
            OptimizedSave as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let CompactionEnabled: u32 = unsafe { ::std::mem::transmute(CompactionEnabled) };
            CompactionEnabled as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let ExtendedFeatureDisable: u32 =
                unsafe { ::std::mem::transmute(ExtendedFeatureDisable) };
            ExtendedFeatureDisable as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSTATE_CONFIGURATION__bindgen_ty_1"]
        [::std::mem::size_of::<_XSTATE_CONFIGURATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _XSTATE_CONFIGURATION__bindgen_ty_1"]
        [::std::mem::align_of::<_XSTATE_CONFIGURATION__bindgen_ty_1>() - 4usize];
    ["Offset of field: _XSTATE_CONFIGURATION__bindgen_ty_1::ControlFlags"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION__bindgen_ty_1, ControlFlags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XSTATE_CONFIGURATION"][::std::mem::size_of::<_XSTATE_CONFIGURATION>() - 840usize];
    ["Alignment of _XSTATE_CONFIGURATION"]
        [::std::mem::align_of::<_XSTATE_CONFIGURATION>() - 8usize];
    ["Offset of field: _XSTATE_CONFIGURATION::EnabledFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, EnabledFeatures) - 0usize];
    ["Offset of field: _XSTATE_CONFIGURATION::EnabledVolatileFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, EnabledVolatileFeatures) - 8usize];
    ["Offset of field: _XSTATE_CONFIGURATION::Size"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, Size) - 16usize];
    ["Offset of field: _XSTATE_CONFIGURATION::Features"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, Features) - 24usize];
    ["Offset of field: _XSTATE_CONFIGURATION::EnabledSupervisorFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, EnabledSupervisorFeatures) - 536usize];
    ["Offset of field: _XSTATE_CONFIGURATION::AlignedFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, AlignedFeatures) - 544usize];
    ["Offset of field: _XSTATE_CONFIGURATION::AllFeatureSize"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, AllFeatureSize) - 552usize];
    ["Offset of field: _XSTATE_CONFIGURATION::AllFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, AllFeatures) - 556usize];
    ["Offset of field: _XSTATE_CONFIGURATION::EnabledUserVisibleSupervisorFeatures"][::std::mem::offset_of!(
        _XSTATE_CONFIGURATION,
        EnabledUserVisibleSupervisorFeatures
    ) - 816usize];
    ["Offset of field: _XSTATE_CONFIGURATION::ExtendedFeatureDisableFeatures"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, ExtendedFeatureDisableFeatures) - 824usize];
    ["Offset of field: _XSTATE_CONFIGURATION::AllNonLargeFeatureSize"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, AllNonLargeFeatureSize) - 832usize];
    ["Offset of field: _XSTATE_CONFIGURATION::Spare"]
        [::std::mem::offset_of!(_XSTATE_CONFIGURATION, Spare) - 836usize];
};
pub type XSTATE_CONFIGURATION = _XSTATE_CONFIGURATION;
pub type PXSTATE_CONFIGURATION = *mut _XSTATE_CONFIGURATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_BASIC_INFORMATION {
    pub BaseAddress: PVOID,
    pub AllocationBase: PVOID,
    pub AllocationProtect: DWORD,
    pub PartitionId: WORD,
    pub RegionSize: SIZE_T,
    pub State: DWORD,
    pub Protect: DWORD,
    pub Type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_BASIC_INFORMATION"]
        [::std::mem::size_of::<_MEMORY_BASIC_INFORMATION>() - 48usize];
    ["Alignment of _MEMORY_BASIC_INFORMATION"]
        [::std::mem::align_of::<_MEMORY_BASIC_INFORMATION>() - 8usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::BaseAddress"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, BaseAddress) - 0usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::AllocationBase"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, AllocationBase) - 8usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::AllocationProtect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, AllocationProtect) - 16usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::PartitionId"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, PartitionId) - 20usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::RegionSize"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, RegionSize) - 24usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::State"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, State) - 32usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::Protect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, Protect) - 36usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION::Type"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION, Type) - 40usize];
};
pub type MEMORY_BASIC_INFORMATION = _MEMORY_BASIC_INFORMATION;
pub type PMEMORY_BASIC_INFORMATION = *mut _MEMORY_BASIC_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_BASIC_INFORMATION32 {
    pub BaseAddress: DWORD,
    pub AllocationBase: DWORD,
    pub AllocationProtect: DWORD,
    pub RegionSize: DWORD,
    pub State: DWORD,
    pub Protect: DWORD,
    pub Type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_BASIC_INFORMATION32"]
        [::std::mem::size_of::<_MEMORY_BASIC_INFORMATION32>() - 28usize];
    ["Alignment of _MEMORY_BASIC_INFORMATION32"]
        [::std::mem::align_of::<_MEMORY_BASIC_INFORMATION32>() - 4usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::BaseAddress"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, BaseAddress) - 0usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::AllocationBase"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, AllocationBase) - 4usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::AllocationProtect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, AllocationProtect) - 8usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::RegionSize"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, RegionSize) - 12usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::State"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, State) - 16usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::Protect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, Protect) - 20usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION32::Type"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION32, Type) - 24usize];
};
pub type MEMORY_BASIC_INFORMATION32 = _MEMORY_BASIC_INFORMATION32;
pub type PMEMORY_BASIC_INFORMATION32 = *mut _MEMORY_BASIC_INFORMATION32;
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_BASIC_INFORMATION64 {
    pub BaseAddress: ULONGLONG,
    pub AllocationBase: ULONGLONG,
    pub AllocationProtect: DWORD,
    pub __alignment1: DWORD,
    pub RegionSize: ULONGLONG,
    pub State: DWORD,
    pub Protect: DWORD,
    pub Type: DWORD,
    pub __alignment2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_BASIC_INFORMATION64"]
        [::std::mem::size_of::<_MEMORY_BASIC_INFORMATION64>() - 48usize];
    ["Alignment of _MEMORY_BASIC_INFORMATION64"]
        [::std::mem::align_of::<_MEMORY_BASIC_INFORMATION64>() - 16usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::BaseAddress"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, BaseAddress) - 0usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::AllocationBase"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, AllocationBase) - 8usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::AllocationProtect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, AllocationProtect) - 16usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::__alignment1"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, __alignment1) - 20usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::RegionSize"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, RegionSize) - 24usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::State"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, State) - 32usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::Protect"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, Protect) - 36usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::Type"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, Type) - 40usize];
    ["Offset of field: _MEMORY_BASIC_INFORMATION64::__alignment2"]
        [::std::mem::offset_of!(_MEMORY_BASIC_INFORMATION64, __alignment2) - 44usize];
};
pub type MEMORY_BASIC_INFORMATION64 = _MEMORY_BASIC_INFORMATION64;
pub type PMEMORY_BASIC_INFORMATION64 = *mut _MEMORY_BASIC_INFORMATION64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CFG_CALL_TARGET_INFO {
    pub Offset: ULONG_PTR,
    pub Flags: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CFG_CALL_TARGET_INFO"][::std::mem::size_of::<_CFG_CALL_TARGET_INFO>() - 16usize];
    ["Alignment of _CFG_CALL_TARGET_INFO"]
        [::std::mem::align_of::<_CFG_CALL_TARGET_INFO>() - 8usize];
    ["Offset of field: _CFG_CALL_TARGET_INFO::Offset"]
        [::std::mem::offset_of!(_CFG_CALL_TARGET_INFO, Offset) - 0usize];
    ["Offset of field: _CFG_CALL_TARGET_INFO::Flags"]
        [::std::mem::offset_of!(_CFG_CALL_TARGET_INFO, Flags) - 8usize];
};
pub type CFG_CALL_TARGET_INFO = _CFG_CALL_TARGET_INFO;
pub type PCFG_CALL_TARGET_INFO = *mut _CFG_CALL_TARGET_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEM_ADDRESS_REQUIREMENTS {
    pub LowestStartingAddress: PVOID,
    pub HighestEndingAddress: PVOID,
    pub Alignment: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEM_ADDRESS_REQUIREMENTS"]
        [::std::mem::size_of::<_MEM_ADDRESS_REQUIREMENTS>() - 24usize];
    ["Alignment of _MEM_ADDRESS_REQUIREMENTS"]
        [::std::mem::align_of::<_MEM_ADDRESS_REQUIREMENTS>() - 8usize];
    ["Offset of field: _MEM_ADDRESS_REQUIREMENTS::LowestStartingAddress"]
        [::std::mem::offset_of!(_MEM_ADDRESS_REQUIREMENTS, LowestStartingAddress) - 0usize];
    ["Offset of field: _MEM_ADDRESS_REQUIREMENTS::HighestEndingAddress"]
        [::std::mem::offset_of!(_MEM_ADDRESS_REQUIREMENTS, HighestEndingAddress) - 8usize];
    ["Offset of field: _MEM_ADDRESS_REQUIREMENTS::Alignment"]
        [::std::mem::offset_of!(_MEM_ADDRESS_REQUIREMENTS, Alignment) - 16usize];
};
pub type MEM_ADDRESS_REQUIREMENTS = _MEM_ADDRESS_REQUIREMENTS;
pub type PMEM_ADDRESS_REQUIREMENTS = *mut _MEM_ADDRESS_REQUIREMENTS;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterInvalidType: MEM_EXTENDED_PARAMETER_TYPE =
    0;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterAddressRequirements:
    MEM_EXTENDED_PARAMETER_TYPE = 1;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterNumaNode: MEM_EXTENDED_PARAMETER_TYPE = 2;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterPartitionHandle:
    MEM_EXTENDED_PARAMETER_TYPE = 3;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterUserPhysicalHandle:
    MEM_EXTENDED_PARAMETER_TYPE = 4;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterAttributeFlags:
    MEM_EXTENDED_PARAMETER_TYPE = 5;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterImageMachine:
    MEM_EXTENDED_PARAMETER_TYPE = 6;
pub const MEM_EXTENDED_PARAMETER_TYPE_MemExtendedParameterMax: MEM_EXTENDED_PARAMETER_TYPE = 7;
pub type MEM_EXTENDED_PARAMETER_TYPE = ::std::os::raw::c_int;
pub type PMEM_EXTENDED_PARAMETER_TYPE = *mut MEM_EXTENDED_PARAMETER_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct MEM_EXTENDED_PARAMETER {
    pub __bindgen_anon_1: MEM_EXTENDED_PARAMETER__bindgen_ty_1,
    pub __bindgen_anon_2: MEM_EXTENDED_PARAMETER__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MEM_EXTENDED_PARAMETER__bindgen_ty_1 {
    pub _bitfield_align_1: [u64; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 8usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MEM_EXTENDED_PARAMETER__bindgen_ty_1"]
        [::std::mem::size_of::<MEM_EXTENDED_PARAMETER__bindgen_ty_1>() - 8usize];
    ["Alignment of MEM_EXTENDED_PARAMETER__bindgen_ty_1"]
        [::std::mem::align_of::<MEM_EXTENDED_PARAMETER__bindgen_ty_1>() - 8usize];
};
impl MEM_EXTENDED_PARAMETER__bindgen_ty_1 {
    #[inline]
    pub fn Type(&self) -> DWORD64 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u64) }
    }
    #[inline]
    pub fn set_Type(&mut self, val: DWORD64) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Type_raw(this: *const Self) -> DWORD64 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 8usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_Type_raw(this: *mut Self, val: DWORD64) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 8usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD64 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 56u8) as u64) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD64) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 56u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD64 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 8usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                56u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD64) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 8usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                56u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(Type: DWORD64, Reserved: DWORD64) -> __BindgenBitfieldUnit<[u8; 8usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 8usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let Type: u64 = unsafe { ::std::mem::transmute(Type) };
            Type as u64
        });
        __bindgen_bitfield_unit.set(8usize, 56u8, {
            let Reserved: u64 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union MEM_EXTENDED_PARAMETER__bindgen_ty_2 {
    pub ULong64: DWORD64,
    pub Pointer: PVOID,
    pub Size: SIZE_T,
    pub Handle: HANDLE,
    pub ULong: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MEM_EXTENDED_PARAMETER__bindgen_ty_2"]
        [::std::mem::size_of::<MEM_EXTENDED_PARAMETER__bindgen_ty_2>() - 8usize];
    ["Alignment of MEM_EXTENDED_PARAMETER__bindgen_ty_2"]
        [::std::mem::align_of::<MEM_EXTENDED_PARAMETER__bindgen_ty_2>() - 8usize];
    ["Offset of field: MEM_EXTENDED_PARAMETER__bindgen_ty_2::ULong64"]
        [::std::mem::offset_of!(MEM_EXTENDED_PARAMETER__bindgen_ty_2, ULong64) - 0usize];
    ["Offset of field: MEM_EXTENDED_PARAMETER__bindgen_ty_2::Pointer"]
        [::std::mem::offset_of!(MEM_EXTENDED_PARAMETER__bindgen_ty_2, Pointer) - 0usize];
    ["Offset of field: MEM_EXTENDED_PARAMETER__bindgen_ty_2::Size"]
        [::std::mem::offset_of!(MEM_EXTENDED_PARAMETER__bindgen_ty_2, Size) - 0usize];
    ["Offset of field: MEM_EXTENDED_PARAMETER__bindgen_ty_2::Handle"]
        [::std::mem::offset_of!(MEM_EXTENDED_PARAMETER__bindgen_ty_2, Handle) - 0usize];
    ["Offset of field: MEM_EXTENDED_PARAMETER__bindgen_ty_2::ULong"]
        [::std::mem::offset_of!(MEM_EXTENDED_PARAMETER__bindgen_ty_2, ULong) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MEM_EXTENDED_PARAMETER"][::std::mem::size_of::<MEM_EXTENDED_PARAMETER>() - 16usize];
    ["Alignment of MEM_EXTENDED_PARAMETER"]
        [::std::mem::align_of::<MEM_EXTENDED_PARAMETER>() - 8usize];
};
pub type PMEM_EXTENDED_PARAMETER = *mut MEM_EXTENDED_PARAMETER;
pub const _MEM_DEDICATED_ATTRIBUTE_TYPE_MemDedicatedAttributeReadBandwidth:
    _MEM_DEDICATED_ATTRIBUTE_TYPE = 0;
pub const _MEM_DEDICATED_ATTRIBUTE_TYPE_MemDedicatedAttributeReadLatency:
    _MEM_DEDICATED_ATTRIBUTE_TYPE = 1;
pub const _MEM_DEDICATED_ATTRIBUTE_TYPE_MemDedicatedAttributeWriteBandwidth:
    _MEM_DEDICATED_ATTRIBUTE_TYPE = 2;
pub const _MEM_DEDICATED_ATTRIBUTE_TYPE_MemDedicatedAttributeWriteLatency:
    _MEM_DEDICATED_ATTRIBUTE_TYPE = 3;
pub const _MEM_DEDICATED_ATTRIBUTE_TYPE_MemDedicatedAttributeMax: _MEM_DEDICATED_ATTRIBUTE_TYPE = 4;
pub type _MEM_DEDICATED_ATTRIBUTE_TYPE = ::std::os::raw::c_int;
pub use self::_MEM_DEDICATED_ATTRIBUTE_TYPE as MEM_DEDICATED_ATTRIBUTE_TYPE;
pub type PMEM_DEDICATED_ATTRIBUTE_TYPE = *mut _MEM_DEDICATED_ATTRIBUTE_TYPE;
pub const MEM_SECTION_EXTENDED_PARAMETER_TYPE_MemSectionExtendedParameterInvalidType:
    MEM_SECTION_EXTENDED_PARAMETER_TYPE = 0;
pub const MEM_SECTION_EXTENDED_PARAMETER_TYPE_MemSectionExtendedParameterUserPhysicalFlags:
    MEM_SECTION_EXTENDED_PARAMETER_TYPE = 1;
pub const MEM_SECTION_EXTENDED_PARAMETER_TYPE_MemSectionExtendedParameterNumaNode:
    MEM_SECTION_EXTENDED_PARAMETER_TYPE = 2;
pub const MEM_SECTION_EXTENDED_PARAMETER_TYPE_MemSectionExtendedParameterSigningLevel:
    MEM_SECTION_EXTENDED_PARAMETER_TYPE = 3;
pub const MEM_SECTION_EXTENDED_PARAMETER_TYPE_MemSectionExtendedParameterMax:
    MEM_SECTION_EXTENDED_PARAMETER_TYPE = 4;
pub type MEM_SECTION_EXTENDED_PARAMETER_TYPE = ::std::os::raw::c_int;
pub type PMEM_SECTION_EXTENDED_PARAMETER_TYPE = *mut MEM_SECTION_EXTENDED_PARAMETER_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_CREATE_INFO_SGX {
    pub Secs: [BYTE; 4096usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_CREATE_INFO_SGX"]
        [::std::mem::size_of::<_ENCLAVE_CREATE_INFO_SGX>() - 4096usize];
    ["Alignment of _ENCLAVE_CREATE_INFO_SGX"]
        [::std::mem::align_of::<_ENCLAVE_CREATE_INFO_SGX>() - 1usize];
    ["Offset of field: _ENCLAVE_CREATE_INFO_SGX::Secs"]
        [::std::mem::offset_of!(_ENCLAVE_CREATE_INFO_SGX, Secs) - 0usize];
};
pub type ENCLAVE_CREATE_INFO_SGX = _ENCLAVE_CREATE_INFO_SGX;
pub type PENCLAVE_CREATE_INFO_SGX = *mut _ENCLAVE_CREATE_INFO_SGX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_INIT_INFO_SGX {
    pub SigStruct: [BYTE; 1808usize],
    pub Reserved1: [BYTE; 240usize],
    pub EInitToken: [BYTE; 304usize],
    pub Reserved2: [BYTE; 1744usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_INIT_INFO_SGX"][::std::mem::size_of::<_ENCLAVE_INIT_INFO_SGX>() - 4096usize];
    ["Alignment of _ENCLAVE_INIT_INFO_SGX"]
        [::std::mem::align_of::<_ENCLAVE_INIT_INFO_SGX>() - 1usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_SGX::SigStruct"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_SGX, SigStruct) - 0usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_SGX::Reserved1"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_SGX, Reserved1) - 1808usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_SGX::EInitToken"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_SGX, EInitToken) - 2048usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_SGX::Reserved2"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_SGX, Reserved2) - 2352usize];
};
pub type ENCLAVE_INIT_INFO_SGX = _ENCLAVE_INIT_INFO_SGX;
pub type PENCLAVE_INIT_INFO_SGX = *mut _ENCLAVE_INIT_INFO_SGX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_CREATE_INFO_VBS {
    pub Flags: DWORD,
    pub OwnerID: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_CREATE_INFO_VBS"]
        [::std::mem::size_of::<_ENCLAVE_CREATE_INFO_VBS>() - 36usize];
    ["Alignment of _ENCLAVE_CREATE_INFO_VBS"]
        [::std::mem::align_of::<_ENCLAVE_CREATE_INFO_VBS>() - 4usize];
    ["Offset of field: _ENCLAVE_CREATE_INFO_VBS::Flags"]
        [::std::mem::offset_of!(_ENCLAVE_CREATE_INFO_VBS, Flags) - 0usize];
    ["Offset of field: _ENCLAVE_CREATE_INFO_VBS::OwnerID"]
        [::std::mem::offset_of!(_ENCLAVE_CREATE_INFO_VBS, OwnerID) - 4usize];
};
pub type ENCLAVE_CREATE_INFO_VBS = _ENCLAVE_CREATE_INFO_VBS;
pub type PENCLAVE_CREATE_INFO_VBS = *mut _ENCLAVE_CREATE_INFO_VBS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_CREATE_INFO_VBS_BASIC {
    pub Flags: DWORD,
    pub OwnerID: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_CREATE_INFO_VBS_BASIC"]
        [::std::mem::size_of::<_ENCLAVE_CREATE_INFO_VBS_BASIC>() - 36usize];
    ["Alignment of _ENCLAVE_CREATE_INFO_VBS_BASIC"]
        [::std::mem::align_of::<_ENCLAVE_CREATE_INFO_VBS_BASIC>() - 4usize];
    ["Offset of field: _ENCLAVE_CREATE_INFO_VBS_BASIC::Flags"]
        [::std::mem::offset_of!(_ENCLAVE_CREATE_INFO_VBS_BASIC, Flags) - 0usize];
    ["Offset of field: _ENCLAVE_CREATE_INFO_VBS_BASIC::OwnerID"]
        [::std::mem::offset_of!(_ENCLAVE_CREATE_INFO_VBS_BASIC, OwnerID) - 4usize];
};
pub type ENCLAVE_CREATE_INFO_VBS_BASIC = _ENCLAVE_CREATE_INFO_VBS_BASIC;
pub type PENCLAVE_CREATE_INFO_VBS_BASIC = *mut _ENCLAVE_CREATE_INFO_VBS_BASIC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_LOAD_DATA_VBS_BASIC {
    pub PageType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_LOAD_DATA_VBS_BASIC"]
        [::std::mem::size_of::<_ENCLAVE_LOAD_DATA_VBS_BASIC>() - 4usize];
    ["Alignment of _ENCLAVE_LOAD_DATA_VBS_BASIC"]
        [::std::mem::align_of::<_ENCLAVE_LOAD_DATA_VBS_BASIC>() - 4usize];
    ["Offset of field: _ENCLAVE_LOAD_DATA_VBS_BASIC::PageType"]
        [::std::mem::offset_of!(_ENCLAVE_LOAD_DATA_VBS_BASIC, PageType) - 0usize];
};
pub type ENCLAVE_LOAD_DATA_VBS_BASIC = _ENCLAVE_LOAD_DATA_VBS_BASIC;
pub type PENCLAVE_LOAD_DATA_VBS_BASIC = *mut _ENCLAVE_LOAD_DATA_VBS_BASIC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ENCLAVE_INIT_INFO_VBS_BASIC {
    pub FamilyId: [BYTE; 16usize],
    pub ImageId: [BYTE; 16usize],
    pub EnclaveSize: ULONGLONG,
    pub EnclaveSvn: DWORD,
    pub Reserved: DWORD,
    pub __bindgen_anon_1: _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1 {
    pub SignatureInfoHandle: HANDLE,
    pub Unused: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1"]
        [::std::mem::size_of::<_ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1>() - 8usize];
    ["Alignment of _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1"]
        [::std::mem::align_of::<_ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1>() - 8usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1::SignatureInfoHandle"][::std::mem::offset_of!(
        _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1,
        SignatureInfoHandle
    )
        - 0usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1::Unused"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC__bindgen_ty_1, Unused) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_INIT_INFO_VBS_BASIC"]
        [::std::mem::size_of::<_ENCLAVE_INIT_INFO_VBS_BASIC>() - 56usize];
    ["Alignment of _ENCLAVE_INIT_INFO_VBS_BASIC"]
        [::std::mem::align_of::<_ENCLAVE_INIT_INFO_VBS_BASIC>() - 8usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC::FamilyId"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC, FamilyId) - 0usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC::ImageId"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC, ImageId) - 16usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC::EnclaveSize"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC, EnclaveSize) - 32usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC::EnclaveSvn"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC, EnclaveSvn) - 40usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS_BASIC::Reserved"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS_BASIC, Reserved) - 44usize];
};
pub type ENCLAVE_INIT_INFO_VBS_BASIC = _ENCLAVE_INIT_INFO_VBS_BASIC;
pub type PENCLAVE_INIT_INFO_VBS_BASIC = *mut _ENCLAVE_INIT_INFO_VBS_BASIC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCLAVE_INIT_INFO_VBS {
    pub Length: DWORD,
    pub ThreadCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCLAVE_INIT_INFO_VBS"][::std::mem::size_of::<_ENCLAVE_INIT_INFO_VBS>() - 8usize];
    ["Alignment of _ENCLAVE_INIT_INFO_VBS"]
        [::std::mem::align_of::<_ENCLAVE_INIT_INFO_VBS>() - 4usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS::Length"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS, Length) - 0usize];
    ["Offset of field: _ENCLAVE_INIT_INFO_VBS::ThreadCount"]
        [::std::mem::offset_of!(_ENCLAVE_INIT_INFO_VBS, ThreadCount) - 4usize];
};
pub type ENCLAVE_INIT_INFO_VBS = _ENCLAVE_INIT_INFO_VBS;
pub type PENCLAVE_INIT_INFO_VBS = *mut _ENCLAVE_INIT_INFO_VBS;
pub type ENCLAVE_TARGET_FUNCTION =
    ::std::option::Option<unsafe extern "C" fn(arg1: PVOID) -> PVOID>;
pub type PENCLAVE_TARGET_FUNCTION = ENCLAVE_TARGET_FUNCTION;
pub type LPENCLAVE_TARGET_FUNCTION = PENCLAVE_TARGET_FUNCTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE {
    pub Type: MEM_DEDICATED_ATTRIBUTE_TYPE,
    pub Reserved: DWORD,
    pub Value: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE"]
        [::std::mem::size_of::<_MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE>() - 16usize];
    ["Alignment of _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE"]
        [::std::mem::align_of::<_MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE>() - 8usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE::Type"]
        [::std::mem::offset_of!(_MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE, Type) - 0usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE::Reserved"]
        [::std::mem::offset_of!(_MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE, Reserved) - 4usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE::Value"]
        [::std::mem::offset_of!(_MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE, Value) - 8usize];
};
pub type MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE = _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE;
pub type PMEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE =
    *mut _MEMORY_PARTITION_DEDICATED_MEMORY_ATTRIBUTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION {
    pub NextEntryOffset: DWORD,
    pub SizeOfInformation: DWORD,
    pub Flags: DWORD,
    pub AttributesOffset: DWORD,
    pub AttributeCount: DWORD,
    pub Reserved: DWORD,
    pub TypeId: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION"]
        [::std::mem::size_of::<_MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION>() - 32usize];
    ["Alignment of _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION"]
        [::std::mem::align_of::<_MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION>() - 8usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::NextEntryOffset"][::std::mem::offset_of!(
        _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION,
        NextEntryOffset
    )
        - 0usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::SizeOfInformation"][::std::mem::offset_of!(
        _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION,
        SizeOfInformation
    )
        - 4usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::Flags"]
        [::std::mem::offset_of!(_MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION, Flags) - 8usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::AttributesOffset"][::std::mem::offset_of!(
        _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION,
        AttributesOffset
    )
        - 12usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::AttributeCount"][::std::mem::offset_of!(
        _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION,
        AttributeCount
    )
        - 16usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::Reserved"][::std::mem::offset_of!(
        _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION,
        Reserved
    ) - 20usize];
    ["Offset of field: _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION::TypeId"]
        [::std::mem::offset_of!(_MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION, TypeId) - 24usize];
};
pub type MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION =
    _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION;
pub type PMEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION =
    *mut _MEMORY_PARTITION_DEDICATED_MEMORY_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_ID_128 {
    pub Identifier: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ID_128"][::std::mem::size_of::<_FILE_ID_128>() - 16usize];
    ["Alignment of _FILE_ID_128"][::std::mem::align_of::<_FILE_ID_128>() - 1usize];
    ["Offset of field: _FILE_ID_128::Identifier"]
        [::std::mem::offset_of!(_FILE_ID_128, Identifier) - 0usize];
};
pub type FILE_ID_128 = _FILE_ID_128;
pub type PFILE_ID_128 = *mut _FILE_ID_128;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_NOTIFY_INFORMATION {
    pub NextEntryOffset: DWORD,
    pub Action: DWORD,
    pub FileNameLength: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_NOTIFY_INFORMATION"]
        [::std::mem::size_of::<_FILE_NOTIFY_INFORMATION>() - 16usize];
    ["Alignment of _FILE_NOTIFY_INFORMATION"]
        [::std::mem::align_of::<_FILE_NOTIFY_INFORMATION>() - 4usize];
    ["Offset of field: _FILE_NOTIFY_INFORMATION::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_NOTIFY_INFORMATION, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_NOTIFY_INFORMATION::Action"]
        [::std::mem::offset_of!(_FILE_NOTIFY_INFORMATION, Action) - 4usize];
    ["Offset of field: _FILE_NOTIFY_INFORMATION::FileNameLength"]
        [::std::mem::offset_of!(_FILE_NOTIFY_INFORMATION, FileNameLength) - 8usize];
    ["Offset of field: _FILE_NOTIFY_INFORMATION::FileName"]
        [::std::mem::offset_of!(_FILE_NOTIFY_INFORMATION, FileName) - 12usize];
};
pub type FILE_NOTIFY_INFORMATION = _FILE_NOTIFY_INFORMATION;
pub type PFILE_NOTIFY_INFORMATION = *mut _FILE_NOTIFY_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_NOTIFY_EXTENDED_INFORMATION {
    pub NextEntryOffset: DWORD,
    pub Action: DWORD,
    pub CreationTime: LARGE_INTEGER,
    pub LastModificationTime: LARGE_INTEGER,
    pub LastChangeTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub AllocatedLength: LARGE_INTEGER,
    pub FileSize: LARGE_INTEGER,
    pub FileAttributes: DWORD,
    pub ReparsePointTag: DWORD,
    pub FileId: LARGE_INTEGER,
    pub ParentFileId: LARGE_INTEGER,
    pub FileNameLength: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_NOTIFY_EXTENDED_INFORMATION"]
        [::std::mem::size_of::<_FILE_NOTIFY_EXTENDED_INFORMATION>() - 88usize];
    ["Alignment of _FILE_NOTIFY_EXTENDED_INFORMATION"]
        [::std::mem::align_of::<_FILE_NOTIFY_EXTENDED_INFORMATION>() - 8usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::Action"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, Action) - 4usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::CreationTime"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, CreationTime) - 8usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::LastModificationTime"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, LastModificationTime) - 16usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::LastChangeTime"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, LastChangeTime) - 24usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, LastAccessTime) - 32usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::AllocatedLength"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, AllocatedLength) - 40usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::FileSize"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, FileSize) - 48usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::FileAttributes"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, FileAttributes) - 56usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::ReparsePointTag"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, ReparsePointTag) - 60usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::FileId"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, FileId) - 64usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::ParentFileId"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, ParentFileId) - 72usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::FileNameLength"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, FileNameLength) - 80usize];
    ["Offset of field: _FILE_NOTIFY_EXTENDED_INFORMATION::FileName"]
        [::std::mem::offset_of!(_FILE_NOTIFY_EXTENDED_INFORMATION, FileName) - 84usize];
};
pub type FILE_NOTIFY_EXTENDED_INFORMATION = _FILE_NOTIFY_EXTENDED_INFORMATION;
pub type PFILE_NOTIFY_EXTENDED_INFORMATION = *mut _FILE_NOTIFY_EXTENDED_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _FILE_SEGMENT_ELEMENT {
    pub Buffer: *mut ::std::os::raw::c_void,
    pub Alignment: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_SEGMENT_ELEMENT"][::std::mem::size_of::<_FILE_SEGMENT_ELEMENT>() - 8usize];
    ["Alignment of _FILE_SEGMENT_ELEMENT"]
        [::std::mem::align_of::<_FILE_SEGMENT_ELEMENT>() - 8usize];
    ["Offset of field: _FILE_SEGMENT_ELEMENT::Buffer"]
        [::std::mem::offset_of!(_FILE_SEGMENT_ELEMENT, Buffer) - 0usize];
    ["Offset of field: _FILE_SEGMENT_ELEMENT::Alignment"]
        [::std::mem::offset_of!(_FILE_SEGMENT_ELEMENT, Alignment) - 0usize];
};
pub type FILE_SEGMENT_ELEMENT = _FILE_SEGMENT_ELEMENT;
pub type PFILE_SEGMENT_ELEMENT = *mut _FILE_SEGMENT_ELEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REPARSE_GUID_DATA_BUFFER {
    pub ReparseTag: DWORD,
    pub ReparseDataLength: WORD,
    pub Reserved: WORD,
    pub ReparseGuid: GUID,
    pub GenericReparseBuffer: _REPARSE_GUID_DATA_BUFFER__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REPARSE_GUID_DATA_BUFFER__bindgen_ty_1 {
    pub DataBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REPARSE_GUID_DATA_BUFFER__bindgen_ty_1"]
        [::std::mem::size_of::<_REPARSE_GUID_DATA_BUFFER__bindgen_ty_1>() - 1usize];
    ["Alignment of _REPARSE_GUID_DATA_BUFFER__bindgen_ty_1"]
        [::std::mem::align_of::<_REPARSE_GUID_DATA_BUFFER__bindgen_ty_1>() - 1usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER__bindgen_ty_1::DataBuffer"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER__bindgen_ty_1, DataBuffer) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REPARSE_GUID_DATA_BUFFER"]
        [::std::mem::size_of::<_REPARSE_GUID_DATA_BUFFER>() - 28usize];
    ["Alignment of _REPARSE_GUID_DATA_BUFFER"]
        [::std::mem::align_of::<_REPARSE_GUID_DATA_BUFFER>() - 4usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER::ReparseTag"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER, ReparseTag) - 0usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER::ReparseDataLength"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER, ReparseDataLength) - 4usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER::Reserved"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER, Reserved) - 6usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER::ReparseGuid"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER, ReparseGuid) - 8usize];
    ["Offset of field: _REPARSE_GUID_DATA_BUFFER::GenericReparseBuffer"]
        [::std::mem::offset_of!(_REPARSE_GUID_DATA_BUFFER, GenericReparseBuffer) - 24usize];
};
pub type REPARSE_GUID_DATA_BUFFER = _REPARSE_GUID_DATA_BUFFER;
pub type PREPARSE_GUID_DATA_BUFFER = *mut _REPARSE_GUID_DATA_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCRUB_DATA_INPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub MaximumIos: DWORD,
    pub ObjectId: [DWORD; 4usize],
    pub Reserved: [DWORD; 41usize],
    pub ResumeContext: [BYTE; 1040usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCRUB_DATA_INPUT"][::std::mem::size_of::<_SCRUB_DATA_INPUT>() - 1232usize];
    ["Alignment of _SCRUB_DATA_INPUT"][::std::mem::align_of::<_SCRUB_DATA_INPUT>() - 4usize];
    ["Offset of field: _SCRUB_DATA_INPUT::Size"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, Size) - 0usize];
    ["Offset of field: _SCRUB_DATA_INPUT::Flags"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, Flags) - 4usize];
    ["Offset of field: _SCRUB_DATA_INPUT::MaximumIos"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, MaximumIos) - 8usize];
    ["Offset of field: _SCRUB_DATA_INPUT::ObjectId"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, ObjectId) - 12usize];
    ["Offset of field: _SCRUB_DATA_INPUT::Reserved"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, Reserved) - 28usize];
    ["Offset of field: _SCRUB_DATA_INPUT::ResumeContext"]
        [::std::mem::offset_of!(_SCRUB_DATA_INPUT, ResumeContext) - 192usize];
};
pub type SCRUB_DATA_INPUT = _SCRUB_DATA_INPUT;
pub type PSCRUB_DATA_INPUT = *mut _SCRUB_DATA_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCRUB_PARITY_EXTENT {
    pub Offset: LONGLONG,
    pub Length: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCRUB_PARITY_EXTENT"][::std::mem::size_of::<_SCRUB_PARITY_EXTENT>() - 16usize];
    ["Alignment of _SCRUB_PARITY_EXTENT"][::std::mem::align_of::<_SCRUB_PARITY_EXTENT>() - 8usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT::Offset"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT, Offset) - 0usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT::Length"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT, Length) - 8usize];
};
pub type SCRUB_PARITY_EXTENT = _SCRUB_PARITY_EXTENT;
pub type PSCRUB_PARITY_EXTENT = *mut _SCRUB_PARITY_EXTENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCRUB_PARITY_EXTENT_DATA {
    pub Size: WORD,
    pub Flags: WORD,
    pub NumberOfParityExtents: WORD,
    pub MaximumNumberOfParityExtents: WORD,
    pub ParityExtents: [SCRUB_PARITY_EXTENT; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCRUB_PARITY_EXTENT_DATA"]
        [::std::mem::size_of::<_SCRUB_PARITY_EXTENT_DATA>() - 24usize];
    ["Alignment of _SCRUB_PARITY_EXTENT_DATA"]
        [::std::mem::align_of::<_SCRUB_PARITY_EXTENT_DATA>() - 8usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT_DATA::Size"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT_DATA, Size) - 0usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT_DATA::Flags"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT_DATA, Flags) - 2usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT_DATA::NumberOfParityExtents"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT_DATA, NumberOfParityExtents) - 4usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT_DATA::MaximumNumberOfParityExtents"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT_DATA, MaximumNumberOfParityExtents) - 6usize];
    ["Offset of field: _SCRUB_PARITY_EXTENT_DATA::ParityExtents"]
        [::std::mem::offset_of!(_SCRUB_PARITY_EXTENT_DATA, ParityExtents) - 8usize];
};
pub type SCRUB_PARITY_EXTENT_DATA = _SCRUB_PARITY_EXTENT_DATA;
pub type PSCRUB_PARITY_EXTENT_DATA = *mut _SCRUB_PARITY_EXTENT_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCRUB_DATA_OUTPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Status: DWORD,
    pub ErrorFileOffset: ULONGLONG,
    pub ErrorLength: ULONGLONG,
    pub NumberOfBytesRepaired: ULONGLONG,
    pub NumberOfBytesFailed: ULONGLONG,
    pub InternalFileReference: ULONGLONG,
    pub ResumeContextLength: WORD,
    pub ParityExtentDataOffset: WORD,
    pub Reserved: [DWORD; 9usize],
    pub NumberOfMetadataBytesProcessed: ULONGLONG,
    pub NumberOfDataBytesProcessed: ULONGLONG,
    pub TotalNumberOfMetadataBytesInUse: ULONGLONG,
    pub TotalNumberOfDataBytesInUse: ULONGLONG,
    pub DataBytesSkippedDueToNoAllocation: ULONGLONG,
    pub DataBytesSkippedDueToInvalidRun: ULONGLONG,
    pub DataBytesSkippedDueToIntegrityStream: ULONGLONG,
    pub DataBytesSkippedDueToRegionBeingClean: ULONGLONG,
    pub DataBytesSkippedDueToLockConflict: ULONGLONG,
    pub DataBytesSkippedDueToNoScrubDataFlag: ULONGLONG,
    pub DataBytesSkippedDueToNoScrubNonIntegrityStreamFlag: ULONGLONG,
    pub DataBytesScrubbed: ULONGLONG,
    pub ResumeContext: [BYTE; 1040usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCRUB_DATA_OUTPUT"][::std::mem::size_of::<_SCRUB_DATA_OUTPUT>() - 1232usize];
    ["Alignment of _SCRUB_DATA_OUTPUT"][::std::mem::align_of::<_SCRUB_DATA_OUTPUT>() - 8usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::Size"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, Size) - 0usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::Flags"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, Flags) - 4usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::Status"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, Status) - 8usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::ErrorFileOffset"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, ErrorFileOffset) - 16usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::ErrorLength"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, ErrorLength) - 24usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::NumberOfBytesRepaired"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, NumberOfBytesRepaired) - 32usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::NumberOfBytesFailed"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, NumberOfBytesFailed) - 40usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::InternalFileReference"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, InternalFileReference) - 48usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::ResumeContextLength"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, ResumeContextLength) - 56usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::ParityExtentDataOffset"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, ParityExtentDataOffset) - 58usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, Reserved) - 60usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::NumberOfMetadataBytesProcessed"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, NumberOfMetadataBytesProcessed) - 96usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::NumberOfDataBytesProcessed"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, NumberOfDataBytesProcessed) - 104usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::TotalNumberOfMetadataBytesInUse"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, TotalNumberOfMetadataBytesInUse) - 112usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::TotalNumberOfDataBytesInUse"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, TotalNumberOfDataBytesInUse) - 120usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToNoAllocation"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, DataBytesSkippedDueToNoAllocation) - 128usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToInvalidRun"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, DataBytesSkippedDueToInvalidRun) - 136usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToIntegrityStream"][::std::mem::offset_of!(
        _SCRUB_DATA_OUTPUT,
        DataBytesSkippedDueToIntegrityStream
    ) - 144usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToRegionBeingClean"][::std::mem::offset_of!(
        _SCRUB_DATA_OUTPUT,
        DataBytesSkippedDueToRegionBeingClean
    ) - 152usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToLockConflict"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, DataBytesSkippedDueToLockConflict) - 160usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToNoScrubDataFlag"][::std::mem::offset_of!(
        _SCRUB_DATA_OUTPUT,
        DataBytesSkippedDueToNoScrubDataFlag
    ) - 168usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesSkippedDueToNoScrubNonIntegrityStreamFlag"][::std::mem::offset_of!(
        _SCRUB_DATA_OUTPUT,
        DataBytesSkippedDueToNoScrubNonIntegrityStreamFlag
    )
        - 176usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::DataBytesScrubbed"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, DataBytesScrubbed) - 184usize];
    ["Offset of field: _SCRUB_DATA_OUTPUT::ResumeContext"]
        [::std::mem::offset_of!(_SCRUB_DATA_OUTPUT, ResumeContext) - 192usize];
};
pub type SCRUB_DATA_OUTPUT = _SCRUB_DATA_OUTPUT;
pub type PSCRUB_DATA_OUTPUT = *mut _SCRUB_DATA_OUTPUT;
pub const _SharedVirtualDiskSupportType_SharedVirtualDisksUnsupported:
    _SharedVirtualDiskSupportType = 0;
pub const _SharedVirtualDiskSupportType_SharedVirtualDisksSupported: _SharedVirtualDiskSupportType =
    1;
pub const _SharedVirtualDiskSupportType_SharedVirtualDiskSnapshotsSupported:
    _SharedVirtualDiskSupportType = 3;
pub const _SharedVirtualDiskSupportType_SharedVirtualDiskCDPSnapshotsSupported:
    _SharedVirtualDiskSupportType = 7;
pub type _SharedVirtualDiskSupportType = ::std::os::raw::c_int;
pub use self::_SharedVirtualDiskSupportType as SharedVirtualDiskSupportType;
pub const _SharedVirtualDiskHandleState_SharedVirtualDiskHandleStateNone:
    _SharedVirtualDiskHandleState = 0;
pub const _SharedVirtualDiskHandleState_SharedVirtualDiskHandleStateFileShared:
    _SharedVirtualDiskHandleState = 1;
pub const _SharedVirtualDiskHandleState_SharedVirtualDiskHandleStateHandleShared:
    _SharedVirtualDiskHandleState = 3;
pub type _SharedVirtualDiskHandleState = ::std::os::raw::c_int;
pub use self::_SharedVirtualDiskHandleState as SharedVirtualDiskHandleState;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHARED_VIRTUAL_DISK_SUPPORT {
    pub SharedVirtualDiskSupport: SharedVirtualDiskSupportType,
    pub HandleState: SharedVirtualDiskHandleState,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHARED_VIRTUAL_DISK_SUPPORT"]
        [::std::mem::size_of::<_SHARED_VIRTUAL_DISK_SUPPORT>() - 8usize];
    ["Alignment of _SHARED_VIRTUAL_DISK_SUPPORT"]
        [::std::mem::align_of::<_SHARED_VIRTUAL_DISK_SUPPORT>() - 4usize];
    ["Offset of field: _SHARED_VIRTUAL_DISK_SUPPORT::SharedVirtualDiskSupport"]
        [::std::mem::offset_of!(_SHARED_VIRTUAL_DISK_SUPPORT, SharedVirtualDiskSupport) - 0usize];
    ["Offset of field: _SHARED_VIRTUAL_DISK_SUPPORT::HandleState"]
        [::std::mem::offset_of!(_SHARED_VIRTUAL_DISK_SUPPORT, HandleState) - 4usize];
};
pub type SHARED_VIRTUAL_DISK_SUPPORT = _SHARED_VIRTUAL_DISK_SUPPORT;
pub type PSHARED_VIRTUAL_DISK_SUPPORT = *mut _SHARED_VIRTUAL_DISK_SUPPORT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REARRANGE_FILE_DATA {
    pub SourceStartingOffset: ULONGLONG,
    pub TargetOffset: ULONGLONG,
    pub SourceFileHandle: HANDLE,
    pub Length: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REARRANGE_FILE_DATA"][::std::mem::size_of::<_REARRANGE_FILE_DATA>() - 32usize];
    ["Alignment of _REARRANGE_FILE_DATA"][::std::mem::align_of::<_REARRANGE_FILE_DATA>() - 8usize];
    ["Offset of field: _REARRANGE_FILE_DATA::SourceStartingOffset"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA, SourceStartingOffset) - 0usize];
    ["Offset of field: _REARRANGE_FILE_DATA::TargetOffset"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA, TargetOffset) - 8usize];
    ["Offset of field: _REARRANGE_FILE_DATA::SourceFileHandle"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA, SourceFileHandle) - 16usize];
    ["Offset of field: _REARRANGE_FILE_DATA::Length"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA, Length) - 24usize];
    ["Offset of field: _REARRANGE_FILE_DATA::Flags"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA, Flags) - 28usize];
};
pub type REARRANGE_FILE_DATA = _REARRANGE_FILE_DATA;
pub type PREARRANGE_FILE_DATA = *mut _REARRANGE_FILE_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REARRANGE_FILE_DATA32 {
    pub SourceStartingOffset: ULONGLONG,
    pub TargetOffset: ULONGLONG,
    pub SourceFileHandle: UINT32,
    pub Length: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REARRANGE_FILE_DATA32"][::std::mem::size_of::<_REARRANGE_FILE_DATA32>() - 32usize];
    ["Alignment of _REARRANGE_FILE_DATA32"]
        [::std::mem::align_of::<_REARRANGE_FILE_DATA32>() - 8usize];
    ["Offset of field: _REARRANGE_FILE_DATA32::SourceStartingOffset"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA32, SourceStartingOffset) - 0usize];
    ["Offset of field: _REARRANGE_FILE_DATA32::TargetOffset"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA32, TargetOffset) - 8usize];
    ["Offset of field: _REARRANGE_FILE_DATA32::SourceFileHandle"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA32, SourceFileHandle) - 16usize];
    ["Offset of field: _REARRANGE_FILE_DATA32::Length"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA32, Length) - 20usize];
    ["Offset of field: _REARRANGE_FILE_DATA32::Flags"]
        [::std::mem::offset_of!(_REARRANGE_FILE_DATA32, Flags) - 24usize];
};
pub type REARRANGE_FILE_DATA32 = _REARRANGE_FILE_DATA32;
pub type PREARRANGE_FILE_DATA32 = *mut _REARRANGE_FILE_DATA32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHUFFLE_FILE_DATA {
    pub StartingOffset: LONGLONG,
    pub Length: LONGLONG,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHUFFLE_FILE_DATA"][::std::mem::size_of::<_SHUFFLE_FILE_DATA>() - 24usize];
    ["Alignment of _SHUFFLE_FILE_DATA"][::std::mem::align_of::<_SHUFFLE_FILE_DATA>() - 8usize];
    ["Offset of field: _SHUFFLE_FILE_DATA::StartingOffset"]
        [::std::mem::offset_of!(_SHUFFLE_FILE_DATA, StartingOffset) - 0usize];
    ["Offset of field: _SHUFFLE_FILE_DATA::Length"]
        [::std::mem::offset_of!(_SHUFFLE_FILE_DATA, Length) - 8usize];
    ["Offset of field: _SHUFFLE_FILE_DATA::Flags"]
        [::std::mem::offset_of!(_SHUFFLE_FILE_DATA, Flags) - 16usize];
};
pub type SHUFFLE_FILE_DATA = _SHUFFLE_FILE_DATA;
pub type PSHUFFLE_FILE_DATA = *mut _SHUFFLE_FILE_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NETWORK_APP_INSTANCE_EA {
    pub AppInstanceID: GUID,
    pub CsvFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NETWORK_APP_INSTANCE_EA"]
        [::std::mem::size_of::<_NETWORK_APP_INSTANCE_EA>() - 20usize];
    ["Alignment of _NETWORK_APP_INSTANCE_EA"]
        [::std::mem::align_of::<_NETWORK_APP_INSTANCE_EA>() - 4usize];
    ["Offset of field: _NETWORK_APP_INSTANCE_EA::AppInstanceID"]
        [::std::mem::offset_of!(_NETWORK_APP_INSTANCE_EA, AppInstanceID) - 0usize];
    ["Offset of field: _NETWORK_APP_INSTANCE_EA::CsvFlags"]
        [::std::mem::offset_of!(_NETWORK_APP_INSTANCE_EA, CsvFlags) - 16usize];
};
pub type NETWORK_APP_INSTANCE_EA = _NETWORK_APP_INSTANCE_EA;
pub type PNETWORK_APP_INSTANCE_EA = *mut _NETWORK_APP_INSTANCE_EA;
unsafe extern "C" {
    pub static GUID_MAX_POWER_SAVINGS: GUID;
}
unsafe extern "C" {
    pub static GUID_MIN_POWER_SAVINGS: GUID;
}
unsafe extern "C" {
    pub static GUID_TYPICAL_POWER_SAVINGS: GUID;
}
unsafe extern "C" {
    pub static NO_SUBGROUP_GUID: GUID;
}
unsafe extern "C" {
    pub static ALL_POWERSCHEMES_GUID: GUID;
}
unsafe extern "C" {
    pub static GUID_POWERSCHEME_PERSONALITY: GUID;
}
unsafe extern "C" {
    pub static GUID_ACTIVE_POWERSCHEME: GUID;
}
unsafe extern "C" {
    pub static GUID_IDLE_RESILIENCY_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_IDLE_RESILIENCY_PERIOD: GUID;
}
unsafe extern "C" {
    pub static GUID_DEEP_SLEEP_ENABLED: GUID;
}
unsafe extern "C" {
    pub static GUID_DEEP_SLEEP_PLATFORM_STATE: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_COALESCING_POWERDOWN_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_EXECUTION_REQUIRED_REQUEST_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_POWERDOWN_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_ANNOYANCE_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_ADAPTIVE_PERCENT_INCREASE: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_DIM_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_ADAPTIVE_POWERDOWN: GUID;
}
unsafe extern "C" {
    pub static GUID_MONITOR_POWER_ON: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVICE_POWER_POLICY_VIDEO_BRIGHTNESS: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVICE_POWER_POLICY_VIDEO_DIM_BRIGHTNESS: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_CURRENT_MONITOR_BRIGHTNESS: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_ADAPTIVE_DISPLAY_BRIGHTNESS: GUID;
}
unsafe extern "C" {
    pub static GUID_CONSOLE_DISPLAY_STATE: GUID;
}
unsafe extern "C" {
    pub static GUID_ALLOW_DISPLAY_REQUIRED: GUID;
}
unsafe extern "C" {
    pub static GUID_VIDEO_CONSOLE_LOCK_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_ADVANCED_COLOR_QUALITY_BIAS: GUID;
}
unsafe extern "C" {
    pub static GUID_ADAPTIVE_POWER_BEHAVIOR_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_NON_ADAPTIVE_INPUT_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_ADAPTIVE_INPUT_CONTROLLER_STATE: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_MAX_POWER: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_POWERDOWN_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_IDLE_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_BURST_IGNORE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_ADAPTIVE_POWERDOWN: GUID;
}
unsafe extern "C" {
    pub static GUID_DISK_NVME_NOPPME: GUID;
}
unsafe extern "C" {
    pub static GUID_SLEEP_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_SLEEP_IDLE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_UNATTEND_SLEEP_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_HIBERNATE_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_HIBERNATE_FASTS4_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_CRITICAL_POWER_TRANSITION: GUID;
}
unsafe extern "C" {
    pub static GUID_SYSTEM_AWAYMODE: GUID;
}
unsafe extern "C" {
    pub static GUID_ALLOW_AWAYMODE: GUID;
}
unsafe extern "C" {
    pub static GUID_USER_PRESENCE_PREDICTION: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_BUDGET_GRACE_PERIOD: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_BUDGET_PERCENT: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_RESERVE_GRACE_PERIOD: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_RESERVE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_STANDBY_RESET_PERCENT: GUID;
}
unsafe extern "C" {
    pub static GUID_HUPR_ADAPTIVE_DISPLAY_TIMEOUT: GUID;
}
unsafe extern "C" {
    pub static GUID_ALLOW_STANDBY_STATES: GUID;
}
unsafe extern "C" {
    pub static GUID_ALLOW_RTC_WAKE: GUID;
}
unsafe extern "C" {
    pub static GUID_LEGACY_RTC_MITIGATION: GUID;
}
unsafe extern "C" {
    pub static GUID_ALLOW_SYSTEM_REQUIRED: GUID;
}
unsafe extern "C" {
    pub static GUID_POWER_SAVING_STATUS: GUID;
}
unsafe extern "C" {
    pub static GUID_ENERGY_SAVER_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_ENERGY_SAVER_BATTERY_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_ENERGY_SAVER_BRIGHTNESS: GUID;
}
unsafe extern "C" {
    pub static GUID_ENERGY_SAVER_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_SYSTEM_BUTTON_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_POWERBUTTON_ACTION: GUID;
}
unsafe extern "C" {
    pub static GUID_SLEEPBUTTON_ACTION: GUID;
}
unsafe extern "C" {
    pub static GUID_USERINTERFACEBUTTON_ACTION: GUID;
}
unsafe extern "C" {
    pub static GUID_LIDCLOSE_ACTION: GUID;
}
unsafe extern "C" {
    pub static GUID_LIDOPEN_POWERSTATE: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_ACTION_0: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_LEVEL_0: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_FLAGS_0: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_ACTION_1: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_LEVEL_1: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_FLAGS_1: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_ACTION_2: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_LEVEL_2: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_FLAGS_2: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_ACTION_3: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_LEVEL_3: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_DISCHARGE_FLAGS_3: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_SETTINGS_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THROTTLE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THROTTLE_MAXIMUM: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THROTTLE_MAXIMUM_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THROTTLE_MINIMUM: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THROTTLE_MINIMUM_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_FREQUENCY_LIMIT: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_FREQUENCY_LIMIT_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_ALLOW_THROTTLING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLESTATE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERFSTATE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_THRESHOLD_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_THRESHOLD_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_POLICY_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_POLICY_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_TIME_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_TIME_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_TIME_CHECK: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_BOOST_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_BOOST_MODE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_AUTONOMOUS_MODE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_ENERGY_PERFORMANCE_PREFERENCE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_ENERGY_PERFORMANCE_PREFERENCE_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_AUTONOMOUS_ACTIVITY_WINDOW: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_DUTY_CYCLING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_ALLOW_SCALING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_DISABLE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_STATE_MAXIMUM: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_TIME_CHECK: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_DEMOTE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_IDLE_PROMOTE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_INCREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_DECREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_INCREASE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_DECREASE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_MAX_CORES: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_MAX_CORES_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_MIN_CORES: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_MIN_CORES_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_INCREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_DECREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_AFFINITY_HISTORY_DECREASE_FACTOR: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_AFFINITY_HISTORY_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_AFFINITY_WEIGHTING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_OVER_UTILIZATION_HISTORY_DECREASE_FACTOR: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_OVER_UTILIZATION_HISTORY_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_OVER_UTILIZATION_WEIGHTING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CORE_PARKING_OVER_UTILIZATION_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_CORE_OVERRIDE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_PERF_STATE: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_PERF_STATE_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_CONCURRENCY_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_HEADROOM_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PARKING_DISTRIBUTION_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_SOFT_PARKING_LATENCY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_HISTORY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_HISTORY_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_INCREASE_HISTORY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_DECREASE_HISTORY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_CORE_PARKING_HISTORY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_LATENCY_HINT: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_LATENCY_HINT_PERF: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_PERF_LATENCY_HINT_PERF_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_LATENCY_HINT_MIN_UNPARK: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_LATENCY_HINT_MIN_UNPARK_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_DISTRIBUTE_UTILITY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_HETEROGENEOUS_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_HETERO_DECREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_HETERO_INCREASE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_HETERO_DECREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_HETERO_INCREASE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CLASS0_FLOOR_PERF: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_CLASS1_INITIAL_PERF: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_THREAD_SCHEDULING_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_SHORT_THREAD_SCHEDULING_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_SHORT_THREAD_RUNTIME_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_SYSTEM_COOLING_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_DISABLE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_DISABLE_THRESHOLD_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_ENABLE_THRESHOLD: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_ENABLE_THRESHOLD_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_DISABLE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_DISABLE_TIME_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_ENABLE_TIME: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_ENABLE_TIME_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_EPP_CEILING: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_EPP_CEILING_1: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_PERF_FLOOR: GUID;
}
unsafe extern "C" {
    pub static GUID_PROCESSOR_RESPONSIVENESS_PERF_FLOOR_1: GUID;
}
unsafe extern "C" {
    pub static GUID_LOCK_CONSOLE_ON_WAKE: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVICE_IDLE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_CONNECTIVITY_IN_STANDBY: GUID;
}
unsafe extern "C" {
    pub static GUID_DISCONNECTED_STANDBY_MODE: GUID;
}
unsafe extern "C" {
    pub static GUID_ACDC_POWER_SOURCE: GUID;
}
unsafe extern "C" {
    pub static GUID_LIDSWITCH_STATE_CHANGE: GUID;
}
unsafe extern "C" {
    pub static GUID_LIDSWITCH_STATE_RELIABILITY: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_PERCENTAGE_REMAINING: GUID;
}
unsafe extern "C" {
    pub static GUID_BATTERY_COUNT: GUID;
}
unsafe extern "C" {
    pub static GUID_GLOBAL_USER_PRESENCE: GUID;
}
unsafe extern "C" {
    pub static GUID_SESSION_DISPLAY_STATUS: GUID;
}
unsafe extern "C" {
    pub static GUID_SESSION_USER_PRESENCE: GUID;
}
unsafe extern "C" {
    pub static GUID_IDLE_BACKGROUND_TASK: GUID;
}
unsafe extern "C" {
    pub static GUID_BACKGROUND_TASK_NOTIFICATION: GUID;
}
unsafe extern "C" {
    pub static GUID_APPLAUNCH_BUTTON: GUID;
}
unsafe extern "C" {
    pub static GUID_PCIEXPRESS_SETTINGS_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_PCIEXPRESS_ASPM_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_ENABLE_SWITCH_FORCED_SHUTDOWN: GUID;
}
unsafe extern "C" {
    pub static GUID_INTSTEER_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_INTSTEER_MODE: GUID;
}
unsafe extern "C" {
    pub static GUID_INTSTEER_LOAD_PER_PROC_TRIGGER: GUID;
}
unsafe extern "C" {
    pub static GUID_INTSTEER_TIME_UNPARK_TRIGGER: GUID;
}
unsafe extern "C" {
    pub static GUID_GRAPHICS_SUBGROUP: GUID;
}
unsafe extern "C" {
    pub static GUID_GPU_PREFERENCE_POLICY: GUID;
}
unsafe extern "C" {
    pub static GUID_MIXED_REALITY_MODE: GUID;
}
unsafe extern "C" {
    pub static GUID_SPR_ACTIVE_SESSION_CHANGE: GUID;
}
pub const _SYSTEM_POWER_STATE_PowerSystemUnspecified: _SYSTEM_POWER_STATE = 0;
pub const _SYSTEM_POWER_STATE_PowerSystemWorking: _SYSTEM_POWER_STATE = 1;
pub const _SYSTEM_POWER_STATE_PowerSystemSleeping1: _SYSTEM_POWER_STATE = 2;
pub const _SYSTEM_POWER_STATE_PowerSystemSleeping2: _SYSTEM_POWER_STATE = 3;
pub const _SYSTEM_POWER_STATE_PowerSystemSleeping3: _SYSTEM_POWER_STATE = 4;
pub const _SYSTEM_POWER_STATE_PowerSystemHibernate: _SYSTEM_POWER_STATE = 5;
pub const _SYSTEM_POWER_STATE_PowerSystemShutdown: _SYSTEM_POWER_STATE = 6;
pub const _SYSTEM_POWER_STATE_PowerSystemMaximum: _SYSTEM_POWER_STATE = 7;
pub type _SYSTEM_POWER_STATE = ::std::os::raw::c_int;
pub use self::_SYSTEM_POWER_STATE as SYSTEM_POWER_STATE;
pub type PSYSTEM_POWER_STATE = *mut _SYSTEM_POWER_STATE;
pub const POWER_ACTION_PowerActionNone: POWER_ACTION = 0;
pub const POWER_ACTION_PowerActionReserved: POWER_ACTION = 1;
pub const POWER_ACTION_PowerActionSleep: POWER_ACTION = 2;
pub const POWER_ACTION_PowerActionHibernate: POWER_ACTION = 3;
pub const POWER_ACTION_PowerActionShutdown: POWER_ACTION = 4;
pub const POWER_ACTION_PowerActionShutdownReset: POWER_ACTION = 5;
pub const POWER_ACTION_PowerActionShutdownOff: POWER_ACTION = 6;
pub const POWER_ACTION_PowerActionWarmEject: POWER_ACTION = 7;
pub const POWER_ACTION_PowerActionDisplayOff: POWER_ACTION = 8;
pub type POWER_ACTION = ::std::os::raw::c_int;
pub type PPOWER_ACTION = *mut POWER_ACTION;
pub const _DEVICE_POWER_STATE_PowerDeviceUnspecified: _DEVICE_POWER_STATE = 0;
pub const _DEVICE_POWER_STATE_PowerDeviceD0: _DEVICE_POWER_STATE = 1;
pub const _DEVICE_POWER_STATE_PowerDeviceD1: _DEVICE_POWER_STATE = 2;
pub const _DEVICE_POWER_STATE_PowerDeviceD2: _DEVICE_POWER_STATE = 3;
pub const _DEVICE_POWER_STATE_PowerDeviceD3: _DEVICE_POWER_STATE = 4;
pub const _DEVICE_POWER_STATE_PowerDeviceMaximum: _DEVICE_POWER_STATE = 5;
pub type _DEVICE_POWER_STATE = ::std::os::raw::c_int;
pub use self::_DEVICE_POWER_STATE as DEVICE_POWER_STATE;
pub type PDEVICE_POWER_STATE = *mut _DEVICE_POWER_STATE;
pub const _MONITOR_DISPLAY_STATE_PowerMonitorOff: _MONITOR_DISPLAY_STATE = 0;
pub const _MONITOR_DISPLAY_STATE_PowerMonitorOn: _MONITOR_DISPLAY_STATE = 1;
pub const _MONITOR_DISPLAY_STATE_PowerMonitorDim: _MONITOR_DISPLAY_STATE = 2;
pub type _MONITOR_DISPLAY_STATE = ::std::os::raw::c_int;
pub use self::_MONITOR_DISPLAY_STATE as MONITOR_DISPLAY_STATE;
pub type PMONITOR_DISPLAY_STATE = *mut _MONITOR_DISPLAY_STATE;
pub const _USER_ACTIVITY_PRESENCE_PowerUserPresent: _USER_ACTIVITY_PRESENCE = 0;
pub const _USER_ACTIVITY_PRESENCE_PowerUserNotPresent: _USER_ACTIVITY_PRESENCE = 1;
pub const _USER_ACTIVITY_PRESENCE_PowerUserInactive: _USER_ACTIVITY_PRESENCE = 2;
pub const _USER_ACTIVITY_PRESENCE_PowerUserMaximum: _USER_ACTIVITY_PRESENCE = 3;
pub const _USER_ACTIVITY_PRESENCE_PowerUserInvalid: _USER_ACTIVITY_PRESENCE = 3;
pub type _USER_ACTIVITY_PRESENCE = ::std::os::raw::c_int;
pub use self::_USER_ACTIVITY_PRESENCE as USER_ACTIVITY_PRESENCE;
pub type PUSER_ACTIVITY_PRESENCE = *mut _USER_ACTIVITY_PRESENCE;
pub type EXECUTION_STATE = DWORD;
pub type PEXECUTION_STATE = *mut DWORD;
pub const LATENCY_TIME_LT_DONT_CARE: LATENCY_TIME = 0;
pub const LATENCY_TIME_LT_LOWEST_LATENCY: LATENCY_TIME = 1;
pub type LATENCY_TIME = ::std::os::raw::c_int;
pub const _POWER_REQUEST_TYPE_PowerRequestDisplayRequired: _POWER_REQUEST_TYPE = 0;
pub const _POWER_REQUEST_TYPE_PowerRequestSystemRequired: _POWER_REQUEST_TYPE = 1;
pub const _POWER_REQUEST_TYPE_PowerRequestAwayModeRequired: _POWER_REQUEST_TYPE = 2;
pub const _POWER_REQUEST_TYPE_PowerRequestExecutionRequired: _POWER_REQUEST_TYPE = 3;
pub type _POWER_REQUEST_TYPE = ::std::os::raw::c_int;
pub use self::_POWER_REQUEST_TYPE as POWER_REQUEST_TYPE;
pub type PPOWER_REQUEST_TYPE = *mut _POWER_REQUEST_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CM_Power_Data_s {
    pub PD_Size: DWORD,
    pub PD_MostRecentPowerState: DEVICE_POWER_STATE,
    pub PD_Capabilities: DWORD,
    pub PD_D1Latency: DWORD,
    pub PD_D2Latency: DWORD,
    pub PD_D3Latency: DWORD,
    pub PD_PowerStateMapping: [DEVICE_POWER_STATE; 7usize],
    pub PD_DeepestSystemWake: SYSTEM_POWER_STATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CM_Power_Data_s"][::std::mem::size_of::<CM_Power_Data_s>() - 56usize];
    ["Alignment of CM_Power_Data_s"][::std::mem::align_of::<CM_Power_Data_s>() - 4usize];
    ["Offset of field: CM_Power_Data_s::PD_Size"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_Size) - 0usize];
    ["Offset of field: CM_Power_Data_s::PD_MostRecentPowerState"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_MostRecentPowerState) - 4usize];
    ["Offset of field: CM_Power_Data_s::PD_Capabilities"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_Capabilities) - 8usize];
    ["Offset of field: CM_Power_Data_s::PD_D1Latency"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_D1Latency) - 12usize];
    ["Offset of field: CM_Power_Data_s::PD_D2Latency"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_D2Latency) - 16usize];
    ["Offset of field: CM_Power_Data_s::PD_D3Latency"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_D3Latency) - 20usize];
    ["Offset of field: CM_Power_Data_s::PD_PowerStateMapping"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_PowerStateMapping) - 24usize];
    ["Offset of field: CM_Power_Data_s::PD_DeepestSystemWake"]
        [::std::mem::offset_of!(CM_Power_Data_s, PD_DeepestSystemWake) - 52usize];
};
pub type CM_POWER_DATA = CM_Power_Data_s;
pub type PCM_POWER_DATA = *mut CM_Power_Data_s;
pub const POWER_INFORMATION_LEVEL_SystemPowerPolicyAc: POWER_INFORMATION_LEVEL = 0;
pub const POWER_INFORMATION_LEVEL_SystemPowerPolicyDc: POWER_INFORMATION_LEVEL = 1;
pub const POWER_INFORMATION_LEVEL_VerifySystemPolicyAc: POWER_INFORMATION_LEVEL = 2;
pub const POWER_INFORMATION_LEVEL_VerifySystemPolicyDc: POWER_INFORMATION_LEVEL = 3;
pub const POWER_INFORMATION_LEVEL_SystemPowerCapabilities: POWER_INFORMATION_LEVEL = 4;
pub const POWER_INFORMATION_LEVEL_SystemBatteryState: POWER_INFORMATION_LEVEL = 5;
pub const POWER_INFORMATION_LEVEL_SystemPowerStateHandler: POWER_INFORMATION_LEVEL = 6;
pub const POWER_INFORMATION_LEVEL_ProcessorStateHandler: POWER_INFORMATION_LEVEL = 7;
pub const POWER_INFORMATION_LEVEL_SystemPowerPolicyCurrent: POWER_INFORMATION_LEVEL = 8;
pub const POWER_INFORMATION_LEVEL_AdministratorPowerPolicy: POWER_INFORMATION_LEVEL = 9;
pub const POWER_INFORMATION_LEVEL_SystemReserveHiberFile: POWER_INFORMATION_LEVEL = 10;
pub const POWER_INFORMATION_LEVEL_ProcessorInformation: POWER_INFORMATION_LEVEL = 11;
pub const POWER_INFORMATION_LEVEL_SystemPowerInformation: POWER_INFORMATION_LEVEL = 12;
pub const POWER_INFORMATION_LEVEL_ProcessorStateHandler2: POWER_INFORMATION_LEVEL = 13;
pub const POWER_INFORMATION_LEVEL_LastWakeTime: POWER_INFORMATION_LEVEL = 14;
pub const POWER_INFORMATION_LEVEL_LastSleepTime: POWER_INFORMATION_LEVEL = 15;
pub const POWER_INFORMATION_LEVEL_SystemExecutionState: POWER_INFORMATION_LEVEL = 16;
pub const POWER_INFORMATION_LEVEL_SystemPowerStateNotifyHandler: POWER_INFORMATION_LEVEL = 17;
pub const POWER_INFORMATION_LEVEL_ProcessorPowerPolicyAc: POWER_INFORMATION_LEVEL = 18;
pub const POWER_INFORMATION_LEVEL_ProcessorPowerPolicyDc: POWER_INFORMATION_LEVEL = 19;
pub const POWER_INFORMATION_LEVEL_VerifyProcessorPowerPolicyAc: POWER_INFORMATION_LEVEL = 20;
pub const POWER_INFORMATION_LEVEL_VerifyProcessorPowerPolicyDc: POWER_INFORMATION_LEVEL = 21;
pub const POWER_INFORMATION_LEVEL_ProcessorPowerPolicyCurrent: POWER_INFORMATION_LEVEL = 22;
pub const POWER_INFORMATION_LEVEL_SystemPowerStateLogging: POWER_INFORMATION_LEVEL = 23;
pub const POWER_INFORMATION_LEVEL_SystemPowerLoggingEntry: POWER_INFORMATION_LEVEL = 24;
pub const POWER_INFORMATION_LEVEL_SetPowerSettingValue: POWER_INFORMATION_LEVEL = 25;
pub const POWER_INFORMATION_LEVEL_NotifyUserPowerSetting: POWER_INFORMATION_LEVEL = 26;
pub const POWER_INFORMATION_LEVEL_PowerInformationLevelUnused0: POWER_INFORMATION_LEVEL = 27;
pub const POWER_INFORMATION_LEVEL_SystemMonitorHiberBootPowerOff: POWER_INFORMATION_LEVEL = 28;
pub const POWER_INFORMATION_LEVEL_SystemVideoState: POWER_INFORMATION_LEVEL = 29;
pub const POWER_INFORMATION_LEVEL_TraceApplicationPowerMessage: POWER_INFORMATION_LEVEL = 30;
pub const POWER_INFORMATION_LEVEL_TraceApplicationPowerMessageEnd: POWER_INFORMATION_LEVEL = 31;
pub const POWER_INFORMATION_LEVEL_ProcessorPerfStates: POWER_INFORMATION_LEVEL = 32;
pub const POWER_INFORMATION_LEVEL_ProcessorIdleStates: POWER_INFORMATION_LEVEL = 33;
pub const POWER_INFORMATION_LEVEL_ProcessorCap: POWER_INFORMATION_LEVEL = 34;
pub const POWER_INFORMATION_LEVEL_SystemWakeSource: POWER_INFORMATION_LEVEL = 35;
pub const POWER_INFORMATION_LEVEL_SystemHiberFileInformation: POWER_INFORMATION_LEVEL = 36;
pub const POWER_INFORMATION_LEVEL_TraceServicePowerMessage: POWER_INFORMATION_LEVEL = 37;
pub const POWER_INFORMATION_LEVEL_ProcessorLoad: POWER_INFORMATION_LEVEL = 38;
pub const POWER_INFORMATION_LEVEL_PowerShutdownNotification: POWER_INFORMATION_LEVEL = 39;
pub const POWER_INFORMATION_LEVEL_MonitorCapabilities: POWER_INFORMATION_LEVEL = 40;
pub const POWER_INFORMATION_LEVEL_SessionPowerInit: POWER_INFORMATION_LEVEL = 41;
pub const POWER_INFORMATION_LEVEL_SessionDisplayState: POWER_INFORMATION_LEVEL = 42;
pub const POWER_INFORMATION_LEVEL_PowerRequestCreate: POWER_INFORMATION_LEVEL = 43;
pub const POWER_INFORMATION_LEVEL_PowerRequestAction: POWER_INFORMATION_LEVEL = 44;
pub const POWER_INFORMATION_LEVEL_GetPowerRequestList: POWER_INFORMATION_LEVEL = 45;
pub const POWER_INFORMATION_LEVEL_ProcessorInformationEx: POWER_INFORMATION_LEVEL = 46;
pub const POWER_INFORMATION_LEVEL_NotifyUserModeLegacyPowerEvent: POWER_INFORMATION_LEVEL = 47;
pub const POWER_INFORMATION_LEVEL_GroupPark: POWER_INFORMATION_LEVEL = 48;
pub const POWER_INFORMATION_LEVEL_ProcessorIdleDomains: POWER_INFORMATION_LEVEL = 49;
pub const POWER_INFORMATION_LEVEL_WakeTimerList: POWER_INFORMATION_LEVEL = 50;
pub const POWER_INFORMATION_LEVEL_SystemHiberFileSize: POWER_INFORMATION_LEVEL = 51;
pub const POWER_INFORMATION_LEVEL_ProcessorIdleStatesHv: POWER_INFORMATION_LEVEL = 52;
pub const POWER_INFORMATION_LEVEL_ProcessorPerfStatesHv: POWER_INFORMATION_LEVEL = 53;
pub const POWER_INFORMATION_LEVEL_ProcessorPerfCapHv: POWER_INFORMATION_LEVEL = 54;
pub const POWER_INFORMATION_LEVEL_ProcessorSetIdle: POWER_INFORMATION_LEVEL = 55;
pub const POWER_INFORMATION_LEVEL_LogicalProcessorIdling: POWER_INFORMATION_LEVEL = 56;
pub const POWER_INFORMATION_LEVEL_UserPresence: POWER_INFORMATION_LEVEL = 57;
pub const POWER_INFORMATION_LEVEL_PowerSettingNotificationName: POWER_INFORMATION_LEVEL = 58;
pub const POWER_INFORMATION_LEVEL_GetPowerSettingValue: POWER_INFORMATION_LEVEL = 59;
pub const POWER_INFORMATION_LEVEL_IdleResiliency: POWER_INFORMATION_LEVEL = 60;
pub const POWER_INFORMATION_LEVEL_SessionRITState: POWER_INFORMATION_LEVEL = 61;
pub const POWER_INFORMATION_LEVEL_SessionConnectNotification: POWER_INFORMATION_LEVEL = 62;
pub const POWER_INFORMATION_LEVEL_SessionPowerCleanup: POWER_INFORMATION_LEVEL = 63;
pub const POWER_INFORMATION_LEVEL_SessionLockState: POWER_INFORMATION_LEVEL = 64;
pub const POWER_INFORMATION_LEVEL_SystemHiberbootState: POWER_INFORMATION_LEVEL = 65;
pub const POWER_INFORMATION_LEVEL_PlatformInformation: POWER_INFORMATION_LEVEL = 66;
pub const POWER_INFORMATION_LEVEL_PdcInvocation: POWER_INFORMATION_LEVEL = 67;
pub const POWER_INFORMATION_LEVEL_MonitorInvocation: POWER_INFORMATION_LEVEL = 68;
pub const POWER_INFORMATION_LEVEL_FirmwareTableInformationRegistered: POWER_INFORMATION_LEVEL = 69;
pub const POWER_INFORMATION_LEVEL_SetShutdownSelectedTime: POWER_INFORMATION_LEVEL = 70;
pub const POWER_INFORMATION_LEVEL_SuspendResumeInvocation: POWER_INFORMATION_LEVEL = 71;
pub const POWER_INFORMATION_LEVEL_PlmPowerRequestCreate: POWER_INFORMATION_LEVEL = 72;
pub const POWER_INFORMATION_LEVEL_ScreenOff: POWER_INFORMATION_LEVEL = 73;
pub const POWER_INFORMATION_LEVEL_CsDeviceNotification: POWER_INFORMATION_LEVEL = 74;
pub const POWER_INFORMATION_LEVEL_PlatformRole: POWER_INFORMATION_LEVEL = 75;
pub const POWER_INFORMATION_LEVEL_LastResumePerformance: POWER_INFORMATION_LEVEL = 76;
pub const POWER_INFORMATION_LEVEL_DisplayBurst: POWER_INFORMATION_LEVEL = 77;
pub const POWER_INFORMATION_LEVEL_ExitLatencySamplingPercentage: POWER_INFORMATION_LEVEL = 78;
pub const POWER_INFORMATION_LEVEL_RegisterSpmPowerSettings: POWER_INFORMATION_LEVEL = 79;
pub const POWER_INFORMATION_LEVEL_PlatformIdleStates: POWER_INFORMATION_LEVEL = 80;
pub const POWER_INFORMATION_LEVEL_ProcessorIdleVeto: POWER_INFORMATION_LEVEL = 81;
pub const POWER_INFORMATION_LEVEL_PlatformIdleVeto: POWER_INFORMATION_LEVEL = 82;
pub const POWER_INFORMATION_LEVEL_SystemBatteryStatePrecise: POWER_INFORMATION_LEVEL = 83;
pub const POWER_INFORMATION_LEVEL_ThermalEvent: POWER_INFORMATION_LEVEL = 84;
pub const POWER_INFORMATION_LEVEL_PowerRequestActionInternal: POWER_INFORMATION_LEVEL = 85;
pub const POWER_INFORMATION_LEVEL_BatteryDeviceState: POWER_INFORMATION_LEVEL = 86;
pub const POWER_INFORMATION_LEVEL_PowerInformationInternal: POWER_INFORMATION_LEVEL = 87;
pub const POWER_INFORMATION_LEVEL_ThermalStandby: POWER_INFORMATION_LEVEL = 88;
pub const POWER_INFORMATION_LEVEL_SystemHiberFileType: POWER_INFORMATION_LEVEL = 89;
pub const POWER_INFORMATION_LEVEL_PhysicalPowerButtonPress: POWER_INFORMATION_LEVEL = 90;
pub const POWER_INFORMATION_LEVEL_QueryPotentialDripsConstraint: POWER_INFORMATION_LEVEL = 91;
pub const POWER_INFORMATION_LEVEL_EnergyTrackerCreate: POWER_INFORMATION_LEVEL = 92;
pub const POWER_INFORMATION_LEVEL_EnergyTrackerQuery: POWER_INFORMATION_LEVEL = 93;
pub const POWER_INFORMATION_LEVEL_UpdateBlackBoxRecorder: POWER_INFORMATION_LEVEL = 94;
pub const POWER_INFORMATION_LEVEL_SessionAllowExternalDmaDevices: POWER_INFORMATION_LEVEL = 95;
pub const POWER_INFORMATION_LEVEL_SendSuspendResumeNotification: POWER_INFORMATION_LEVEL = 96;
pub const POWER_INFORMATION_LEVEL_PowerInformationLevelMaximum: POWER_INFORMATION_LEVEL = 97;
pub type POWER_INFORMATION_LEVEL = ::std::os::raw::c_int;
pub const POWER_USER_PRESENCE_TYPE_UserNotPresent: POWER_USER_PRESENCE_TYPE = 0;
pub const POWER_USER_PRESENCE_TYPE_UserPresent: POWER_USER_PRESENCE_TYPE = 1;
pub const POWER_USER_PRESENCE_TYPE_UserUnknown: POWER_USER_PRESENCE_TYPE = 255;
pub type POWER_USER_PRESENCE_TYPE = ::std::os::raw::c_int;
pub type PPOWER_USER_PRESENCE_TYPE = *mut POWER_USER_PRESENCE_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_USER_PRESENCE {
    pub UserPresence: POWER_USER_PRESENCE_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_USER_PRESENCE"][::std::mem::size_of::<_POWER_USER_PRESENCE>() - 4usize];
    ["Alignment of _POWER_USER_PRESENCE"][::std::mem::align_of::<_POWER_USER_PRESENCE>() - 4usize];
    ["Offset of field: _POWER_USER_PRESENCE::UserPresence"]
        [::std::mem::offset_of!(_POWER_USER_PRESENCE, UserPresence) - 0usize];
};
pub type POWER_USER_PRESENCE = _POWER_USER_PRESENCE;
pub type PPOWER_USER_PRESENCE = *mut _POWER_USER_PRESENCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_SESSION_CONNECT {
    pub Connected: BOOLEAN,
    pub Console: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_SESSION_CONNECT"][::std::mem::size_of::<_POWER_SESSION_CONNECT>() - 2usize];
    ["Alignment of _POWER_SESSION_CONNECT"]
        [::std::mem::align_of::<_POWER_SESSION_CONNECT>() - 1usize];
    ["Offset of field: _POWER_SESSION_CONNECT::Connected"]
        [::std::mem::offset_of!(_POWER_SESSION_CONNECT, Connected) - 0usize];
    ["Offset of field: _POWER_SESSION_CONNECT::Console"]
        [::std::mem::offset_of!(_POWER_SESSION_CONNECT, Console) - 1usize];
};
pub type POWER_SESSION_CONNECT = _POWER_SESSION_CONNECT;
pub type PPOWER_SESSION_CONNECT = *mut _POWER_SESSION_CONNECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_SESSION_TIMEOUTS {
    pub InputTimeout: DWORD,
    pub DisplayTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_SESSION_TIMEOUTS"][::std::mem::size_of::<_POWER_SESSION_TIMEOUTS>() - 8usize];
    ["Alignment of _POWER_SESSION_TIMEOUTS"]
        [::std::mem::align_of::<_POWER_SESSION_TIMEOUTS>() - 4usize];
    ["Offset of field: _POWER_SESSION_TIMEOUTS::InputTimeout"]
        [::std::mem::offset_of!(_POWER_SESSION_TIMEOUTS, InputTimeout) - 0usize];
    ["Offset of field: _POWER_SESSION_TIMEOUTS::DisplayTimeout"]
        [::std::mem::offset_of!(_POWER_SESSION_TIMEOUTS, DisplayTimeout) - 4usize];
};
pub type POWER_SESSION_TIMEOUTS = _POWER_SESSION_TIMEOUTS;
pub type PPOWER_SESSION_TIMEOUTS = *mut _POWER_SESSION_TIMEOUTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_SESSION_RIT_STATE {
    pub Active: BOOLEAN,
    pub LastInputTime: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_SESSION_RIT_STATE"]
        [::std::mem::size_of::<_POWER_SESSION_RIT_STATE>() - 16usize];
    ["Alignment of _POWER_SESSION_RIT_STATE"]
        [::std::mem::align_of::<_POWER_SESSION_RIT_STATE>() - 8usize];
    ["Offset of field: _POWER_SESSION_RIT_STATE::Active"]
        [::std::mem::offset_of!(_POWER_SESSION_RIT_STATE, Active) - 0usize];
    ["Offset of field: _POWER_SESSION_RIT_STATE::LastInputTime"]
        [::std::mem::offset_of!(_POWER_SESSION_RIT_STATE, LastInputTime) - 8usize];
};
pub type POWER_SESSION_RIT_STATE = _POWER_SESSION_RIT_STATE;
pub type PPOWER_SESSION_RIT_STATE = *mut _POWER_SESSION_RIT_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_SESSION_WINLOGON {
    pub SessionId: DWORD,
    pub Console: BOOLEAN,
    pub Locked: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_SESSION_WINLOGON"][::std::mem::size_of::<_POWER_SESSION_WINLOGON>() - 8usize];
    ["Alignment of _POWER_SESSION_WINLOGON"]
        [::std::mem::align_of::<_POWER_SESSION_WINLOGON>() - 4usize];
    ["Offset of field: _POWER_SESSION_WINLOGON::SessionId"]
        [::std::mem::offset_of!(_POWER_SESSION_WINLOGON, SessionId) - 0usize];
    ["Offset of field: _POWER_SESSION_WINLOGON::Console"]
        [::std::mem::offset_of!(_POWER_SESSION_WINLOGON, Console) - 4usize];
    ["Offset of field: _POWER_SESSION_WINLOGON::Locked"]
        [::std::mem::offset_of!(_POWER_SESSION_WINLOGON, Locked) - 5usize];
};
pub type POWER_SESSION_WINLOGON = _POWER_SESSION_WINLOGON;
pub type PPOWER_SESSION_WINLOGON = *mut _POWER_SESSION_WINLOGON;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES {
    pub IsAllowed: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES"]
        [::std::mem::size_of::<_POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES>() - 1usize];
    ["Alignment of _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES"]
        [::std::mem::align_of::<_POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES>() - 1usize];
    ["Offset of field: _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES::IsAllowed"]
        [::std::mem::offset_of!(_POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES, IsAllowed) - 0usize];
};
pub type POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES = _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES;
pub type PPOWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES = *mut _POWER_SESSION_ALLOW_EXTERNAL_DMA_DEVICES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_IDLE_RESILIENCY {
    pub CoalescingTimeout: DWORD,
    pub IdleResiliencyPeriod: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_IDLE_RESILIENCY"][::std::mem::size_of::<_POWER_IDLE_RESILIENCY>() - 8usize];
    ["Alignment of _POWER_IDLE_RESILIENCY"]
        [::std::mem::align_of::<_POWER_IDLE_RESILIENCY>() - 4usize];
    ["Offset of field: _POWER_IDLE_RESILIENCY::CoalescingTimeout"]
        [::std::mem::offset_of!(_POWER_IDLE_RESILIENCY, CoalescingTimeout) - 0usize];
    ["Offset of field: _POWER_IDLE_RESILIENCY::IdleResiliencyPeriod"]
        [::std::mem::offset_of!(_POWER_IDLE_RESILIENCY, IdleResiliencyPeriod) - 4usize];
};
pub type POWER_IDLE_RESILIENCY = _POWER_IDLE_RESILIENCY;
pub type PPOWER_IDLE_RESILIENCY = *mut _POWER_IDLE_RESILIENCY;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUnknown: POWER_MONITOR_REQUEST_REASON =
    0;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPowerButton:
    POWER_MONITOR_REQUEST_REASON = 1;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonRemoteConnection:
    POWER_MONITOR_REQUEST_REASON = 2;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonScMonitorpower:
    POWER_MONITOR_REQUEST_REASON = 3;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInput: POWER_MONITOR_REQUEST_REASON =
    4;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonAcDcDisplayBurst:
    POWER_MONITOR_REQUEST_REASON = 5;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserDisplayBurst:
    POWER_MONITOR_REQUEST_REASON = 6;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPoSetSystemState:
    POWER_MONITOR_REQUEST_REASON = 7;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSetThreadExecutionState:
    POWER_MONITOR_REQUEST_REASON = 8;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonFullWake: POWER_MONITOR_REQUEST_REASON =
    9;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSessionUnlock:
    POWER_MONITOR_REQUEST_REASON = 10;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonScreenOffRequest:
    POWER_MONITOR_REQUEST_REASON = 11;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonIdleTimeout:
    POWER_MONITOR_REQUEST_REASON = 12;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPolicyChange:
    POWER_MONITOR_REQUEST_REASON = 13;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSleepButton:
    POWER_MONITOR_REQUEST_REASON = 14;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonLid: POWER_MONITOR_REQUEST_REASON = 15;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonBatteryCountChange:
    POWER_MONITOR_REQUEST_REASON = 16;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonGracePeriod:
    POWER_MONITOR_REQUEST_REASON = 17;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPnP: POWER_MONITOR_REQUEST_REASON = 18;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonDP: POWER_MONITOR_REQUEST_REASON = 19;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSxTransition:
    POWER_MONITOR_REQUEST_REASON = 20;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSystemIdle:
    POWER_MONITOR_REQUEST_REASON = 21;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonNearProximity:
    POWER_MONITOR_REQUEST_REASON = 22;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonThermalStandby:
    POWER_MONITOR_REQUEST_REASON = 23;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonResumePdc: POWER_MONITOR_REQUEST_REASON =
    24;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonResumeS4: POWER_MONITOR_REQUEST_REASON =
    25;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonTerminal: POWER_MONITOR_REQUEST_REASON =
    26;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignal: POWER_MONITOR_REQUEST_REASON =
    27;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonAcDcDisplayBurstSuppressed:
    POWER_MONITOR_REQUEST_REASON = 28;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonSystemStateEntered:
    POWER_MONITOR_REQUEST_REASON = 29;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonWinrt: POWER_MONITOR_REQUEST_REASON = 30;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputKeyboard:
    POWER_MONITOR_REQUEST_REASON = 31;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputMouse:
    POWER_MONITOR_REQUEST_REASON = 32;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputTouchpad:
    POWER_MONITOR_REQUEST_REASON = 33;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputPen:
    POWER_MONITOR_REQUEST_REASON = 34;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputAccelerometer:
    POWER_MONITOR_REQUEST_REASON = 35;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputHid:
    POWER_MONITOR_REQUEST_REASON = 36;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputPoUserPresent:
    POWER_MONITOR_REQUEST_REASON = 37;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputSessionSwitch:
    POWER_MONITOR_REQUEST_REASON = 38;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputInitialization:
    POWER_MONITOR_REQUEST_REASON = 39;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalWindowsMobilePwrNotif:
    POWER_MONITOR_REQUEST_REASON = 40;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalWindowsMobileShell:
    POWER_MONITOR_REQUEST_REASON = 41;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalHeyCortana:
    POWER_MONITOR_REQUEST_REASON = 42;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalHolographicShell:
    POWER_MONITOR_REQUEST_REASON = 43;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalFingerprint:
    POWER_MONITOR_REQUEST_REASON = 44;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonDirectedDrips:
    POWER_MONITOR_REQUEST_REASON = 45;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonDim: POWER_MONITOR_REQUEST_REASON = 46;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonBuiltinPanel:
    POWER_MONITOR_REQUEST_REASON = 47;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonDisplayRequiredUnDim:
    POWER_MONITOR_REQUEST_REASON = 48;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonBatteryCountChangeSuppressed:
    POWER_MONITOR_REQUEST_REASON = 49;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonResumeModernStandby:
    POWER_MONITOR_REQUEST_REASON = 50;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonTerminalInit:
    POWER_MONITOR_REQUEST_REASON = 51;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonPdcSignalSensorsHumanPresence:
    POWER_MONITOR_REQUEST_REASON = 52;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonBatteryPreCritical:
    POWER_MONITOR_REQUEST_REASON = 53;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonUserInputTouch:
    POWER_MONITOR_REQUEST_REASON = 54;
pub const POWER_MONITOR_REQUEST_REASON_MonitorRequestReasonMax: POWER_MONITOR_REQUEST_REASON = 55;
pub type POWER_MONITOR_REQUEST_REASON = ::std::os::raw::c_int;
pub const _POWER_MONITOR_REQUEST_TYPE_MonitorRequestTypeOff: _POWER_MONITOR_REQUEST_TYPE = 0;
pub const _POWER_MONITOR_REQUEST_TYPE_MonitorRequestTypeOnAndPresent: _POWER_MONITOR_REQUEST_TYPE =
    1;
pub const _POWER_MONITOR_REQUEST_TYPE_MonitorRequestTypeToggleOn: _POWER_MONITOR_REQUEST_TYPE = 2;
pub type _POWER_MONITOR_REQUEST_TYPE = ::std::os::raw::c_int;
pub use self::_POWER_MONITOR_REQUEST_TYPE as POWER_MONITOR_REQUEST_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_MONITOR_INVOCATION {
    pub Console: BOOLEAN,
    pub RequestReason: POWER_MONITOR_REQUEST_REASON,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_MONITOR_INVOCATION"]
        [::std::mem::size_of::<_POWER_MONITOR_INVOCATION>() - 8usize];
    ["Alignment of _POWER_MONITOR_INVOCATION"]
        [::std::mem::align_of::<_POWER_MONITOR_INVOCATION>() - 4usize];
    ["Offset of field: _POWER_MONITOR_INVOCATION::Console"]
        [::std::mem::offset_of!(_POWER_MONITOR_INVOCATION, Console) - 0usize];
    ["Offset of field: _POWER_MONITOR_INVOCATION::RequestReason"]
        [::std::mem::offset_of!(_POWER_MONITOR_INVOCATION, RequestReason) - 4usize];
};
pub type POWER_MONITOR_INVOCATION = _POWER_MONITOR_INVOCATION;
pub type PPOWER_MONITOR_INVOCATION = *mut _POWER_MONITOR_INVOCATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RESUME_PERFORMANCE {
    pub PostTimeMs: DWORD,
    pub TotalResumeTimeMs: ULONGLONG,
    pub ResumeCompleteTimestamp: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RESUME_PERFORMANCE"][::std::mem::size_of::<_RESUME_PERFORMANCE>() - 24usize];
    ["Alignment of _RESUME_PERFORMANCE"][::std::mem::align_of::<_RESUME_PERFORMANCE>() - 8usize];
    ["Offset of field: _RESUME_PERFORMANCE::PostTimeMs"]
        [::std::mem::offset_of!(_RESUME_PERFORMANCE, PostTimeMs) - 0usize];
    ["Offset of field: _RESUME_PERFORMANCE::TotalResumeTimeMs"]
        [::std::mem::offset_of!(_RESUME_PERFORMANCE, TotalResumeTimeMs) - 8usize];
    ["Offset of field: _RESUME_PERFORMANCE::ResumeCompleteTimestamp"]
        [::std::mem::offset_of!(_RESUME_PERFORMANCE, ResumeCompleteTimestamp) - 16usize];
};
pub type RESUME_PERFORMANCE = _RESUME_PERFORMANCE;
pub type PRESUME_PERFORMANCE = *mut _RESUME_PERFORMANCE;
pub const SYSTEM_POWER_CONDITION_PoAc: SYSTEM_POWER_CONDITION = 0;
pub const SYSTEM_POWER_CONDITION_PoDc: SYSTEM_POWER_CONDITION = 1;
pub const SYSTEM_POWER_CONDITION_PoHot: SYSTEM_POWER_CONDITION = 2;
pub const SYSTEM_POWER_CONDITION_PoConditionMaximum: SYSTEM_POWER_CONDITION = 3;
pub type SYSTEM_POWER_CONDITION = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SET_POWER_SETTING_VALUE {
    pub Version: DWORD,
    pub Guid: GUID,
    pub PowerCondition: SYSTEM_POWER_CONDITION,
    pub DataLength: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SET_POWER_SETTING_VALUE"][::std::mem::size_of::<SET_POWER_SETTING_VALUE>() - 32usize];
    ["Alignment of SET_POWER_SETTING_VALUE"]
        [::std::mem::align_of::<SET_POWER_SETTING_VALUE>() - 4usize];
    ["Offset of field: SET_POWER_SETTING_VALUE::Version"]
        [::std::mem::offset_of!(SET_POWER_SETTING_VALUE, Version) - 0usize];
    ["Offset of field: SET_POWER_SETTING_VALUE::Guid"]
        [::std::mem::offset_of!(SET_POWER_SETTING_VALUE, Guid) - 4usize];
    ["Offset of field: SET_POWER_SETTING_VALUE::PowerCondition"]
        [::std::mem::offset_of!(SET_POWER_SETTING_VALUE, PowerCondition) - 20usize];
    ["Offset of field: SET_POWER_SETTING_VALUE::DataLength"]
        [::std::mem::offset_of!(SET_POWER_SETTING_VALUE, DataLength) - 24usize];
    ["Offset of field: SET_POWER_SETTING_VALUE::Data"]
        [::std::mem::offset_of!(SET_POWER_SETTING_VALUE, Data) - 28usize];
};
pub type PSET_POWER_SETTING_VALUE = *mut SET_POWER_SETTING_VALUE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NOTIFY_USER_POWER_SETTING {
    pub Guid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NOTIFY_USER_POWER_SETTING"]
        [::std::mem::size_of::<NOTIFY_USER_POWER_SETTING>() - 16usize];
    ["Alignment of NOTIFY_USER_POWER_SETTING"]
        [::std::mem::align_of::<NOTIFY_USER_POWER_SETTING>() - 4usize];
    ["Offset of field: NOTIFY_USER_POWER_SETTING::Guid"]
        [::std::mem::offset_of!(NOTIFY_USER_POWER_SETTING, Guid) - 0usize];
};
pub type PNOTIFY_USER_POWER_SETTING = *mut NOTIFY_USER_POWER_SETTING;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _APPLICATIONLAUNCH_SETTING_VALUE {
    pub ActivationTime: LARGE_INTEGER,
    pub Flags: DWORD,
    pub ButtonInstanceID: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _APPLICATIONLAUNCH_SETTING_VALUE"]
        [::std::mem::size_of::<_APPLICATIONLAUNCH_SETTING_VALUE>() - 16usize];
    ["Alignment of _APPLICATIONLAUNCH_SETTING_VALUE"]
        [::std::mem::align_of::<_APPLICATIONLAUNCH_SETTING_VALUE>() - 8usize];
    ["Offset of field: _APPLICATIONLAUNCH_SETTING_VALUE::ActivationTime"]
        [::std::mem::offset_of!(_APPLICATIONLAUNCH_SETTING_VALUE, ActivationTime) - 0usize];
    ["Offset of field: _APPLICATIONLAUNCH_SETTING_VALUE::Flags"]
        [::std::mem::offset_of!(_APPLICATIONLAUNCH_SETTING_VALUE, Flags) - 8usize];
    ["Offset of field: _APPLICATIONLAUNCH_SETTING_VALUE::ButtonInstanceID"]
        [::std::mem::offset_of!(_APPLICATIONLAUNCH_SETTING_VALUE, ButtonInstanceID) - 12usize];
};
pub type APPLICATIONLAUNCH_SETTING_VALUE = _APPLICATIONLAUNCH_SETTING_VALUE;
pub type PAPPLICATIONLAUNCH_SETTING_VALUE = *mut _APPLICATIONLAUNCH_SETTING_VALUE;
pub const _POWER_PLATFORM_ROLE_PlatformRoleUnspecified: _POWER_PLATFORM_ROLE = 0;
pub const _POWER_PLATFORM_ROLE_PlatformRoleDesktop: _POWER_PLATFORM_ROLE = 1;
pub const _POWER_PLATFORM_ROLE_PlatformRoleMobile: _POWER_PLATFORM_ROLE = 2;
pub const _POWER_PLATFORM_ROLE_PlatformRoleWorkstation: _POWER_PLATFORM_ROLE = 3;
pub const _POWER_PLATFORM_ROLE_PlatformRoleEnterpriseServer: _POWER_PLATFORM_ROLE = 4;
pub const _POWER_PLATFORM_ROLE_PlatformRoleSOHOServer: _POWER_PLATFORM_ROLE = 5;
pub const _POWER_PLATFORM_ROLE_PlatformRoleAppliancePC: _POWER_PLATFORM_ROLE = 6;
pub const _POWER_PLATFORM_ROLE_PlatformRolePerformanceServer: _POWER_PLATFORM_ROLE = 7;
pub const _POWER_PLATFORM_ROLE_PlatformRoleSlate: _POWER_PLATFORM_ROLE = 8;
pub const _POWER_PLATFORM_ROLE_PlatformRoleMaximum: _POWER_PLATFORM_ROLE = 9;
pub type _POWER_PLATFORM_ROLE = ::std::os::raw::c_int;
pub use self::_POWER_PLATFORM_ROLE as POWER_PLATFORM_ROLE;
pub type PPOWER_PLATFORM_ROLE = *mut _POWER_PLATFORM_ROLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POWER_PLATFORM_INFORMATION {
    pub AoAc: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POWER_PLATFORM_INFORMATION"]
        [::std::mem::size_of::<_POWER_PLATFORM_INFORMATION>() - 1usize];
    ["Alignment of _POWER_PLATFORM_INFORMATION"]
        [::std::mem::align_of::<_POWER_PLATFORM_INFORMATION>() - 1usize];
    ["Offset of field: _POWER_PLATFORM_INFORMATION::AoAc"]
        [::std::mem::offset_of!(_POWER_PLATFORM_INFORMATION, AoAc) - 0usize];
};
pub type POWER_PLATFORM_INFORMATION = _POWER_PLATFORM_INFORMATION;
pub type PPOWER_PLATFORM_INFORMATION = *mut _POWER_PLATFORM_INFORMATION;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_GROUP_POLICY: POWER_SETTING_ALTITUDE = 0;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_USER: POWER_SETTING_ALTITUDE = 1;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_RUNTIME_OVERRIDE: POWER_SETTING_ALTITUDE = 2;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_PROVISIONING: POWER_SETTING_ALTITUDE = 3;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_OEM_CUSTOMIZATION: POWER_SETTING_ALTITUDE = 4;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_INTERNAL_OVERRIDE: POWER_SETTING_ALTITUDE = 5;
pub const POWER_SETTING_ALTITUDE_ALTITUDE_OS_DEFAULT: POWER_SETTING_ALTITUDE = 6;
pub type POWER_SETTING_ALTITUDE = ::std::os::raw::c_int;
pub type PPOWER_SETTING_ALTITUDE = *mut POWER_SETTING_ALTITUDE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct BATTERY_REPORTING_SCALE {
    pub Granularity: DWORD,
    pub Capacity: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of BATTERY_REPORTING_SCALE"][::std::mem::size_of::<BATTERY_REPORTING_SCALE>() - 8usize];
    ["Alignment of BATTERY_REPORTING_SCALE"]
        [::std::mem::align_of::<BATTERY_REPORTING_SCALE>() - 4usize];
    ["Offset of field: BATTERY_REPORTING_SCALE::Granularity"]
        [::std::mem::offset_of!(BATTERY_REPORTING_SCALE, Granularity) - 0usize];
    ["Offset of field: BATTERY_REPORTING_SCALE::Capacity"]
        [::std::mem::offset_of!(BATTERY_REPORTING_SCALE, Capacity) - 4usize];
};
pub type PBATTERY_REPORTING_SCALE = *mut BATTERY_REPORTING_SCALE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_LEGACY_PERFSTATE {
    pub Frequency: DWORD,
    pub Flags: DWORD,
    pub PercentFrequency: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_LEGACY_PERFSTATE"]
        [::std::mem::size_of::<PPM_WMI_LEGACY_PERFSTATE>() - 12usize];
    ["Alignment of PPM_WMI_LEGACY_PERFSTATE"]
        [::std::mem::align_of::<PPM_WMI_LEGACY_PERFSTATE>() - 4usize];
    ["Offset of field: PPM_WMI_LEGACY_PERFSTATE::Frequency"]
        [::std::mem::offset_of!(PPM_WMI_LEGACY_PERFSTATE, Frequency) - 0usize];
    ["Offset of field: PPM_WMI_LEGACY_PERFSTATE::Flags"]
        [::std::mem::offset_of!(PPM_WMI_LEGACY_PERFSTATE, Flags) - 4usize];
    ["Offset of field: PPM_WMI_LEGACY_PERFSTATE::PercentFrequency"]
        [::std::mem::offset_of!(PPM_WMI_LEGACY_PERFSTATE, PercentFrequency) - 8usize];
};
pub type PPPM_WMI_LEGACY_PERFSTATE = *mut PPM_WMI_LEGACY_PERFSTATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_IDLE_STATE {
    pub Latency: DWORD,
    pub Power: DWORD,
    pub TimeCheck: DWORD,
    pub PromotePercent: BYTE,
    pub DemotePercent: BYTE,
    pub StateType: BYTE,
    pub Reserved: BYTE,
    pub StateFlags: DWORD,
    pub Context: DWORD,
    pub IdleHandler: DWORD,
    pub Reserved1: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_IDLE_STATE"][::std::mem::size_of::<PPM_WMI_IDLE_STATE>() - 32usize];
    ["Alignment of PPM_WMI_IDLE_STATE"][::std::mem::align_of::<PPM_WMI_IDLE_STATE>() - 4usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::Latency"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, Latency) - 0usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::Power"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, Power) - 4usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::TimeCheck"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, TimeCheck) - 8usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::PromotePercent"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, PromotePercent) - 12usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::DemotePercent"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, DemotePercent) - 13usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::StateType"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, StateType) - 14usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::Reserved"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, Reserved) - 15usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::StateFlags"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, StateFlags) - 16usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::Context"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, Context) - 20usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::IdleHandler"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, IdleHandler) - 24usize];
    ["Offset of field: PPM_WMI_IDLE_STATE::Reserved1"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATE, Reserved1) - 28usize];
};
pub type PPPM_WMI_IDLE_STATE = *mut PPM_WMI_IDLE_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_IDLE_STATES {
    pub Type: DWORD,
    pub Count: DWORD,
    pub TargetState: DWORD,
    pub OldState: DWORD,
    pub TargetProcessors: DWORD64,
    pub State: [PPM_WMI_IDLE_STATE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_IDLE_STATES"][::std::mem::size_of::<PPM_WMI_IDLE_STATES>() - 56usize];
    ["Alignment of PPM_WMI_IDLE_STATES"][::std::mem::align_of::<PPM_WMI_IDLE_STATES>() - 8usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::Type"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, Type) - 0usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::Count"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, Count) - 4usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::TargetState"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, TargetState) - 8usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::OldState"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, OldState) - 12usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::TargetProcessors"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, TargetProcessors) - 16usize];
    ["Offset of field: PPM_WMI_IDLE_STATES::State"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES, State) - 24usize];
};
pub type PPPM_WMI_IDLE_STATES = *mut PPM_WMI_IDLE_STATES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_IDLE_STATES_EX {
    pub Type: DWORD,
    pub Count: DWORD,
    pub TargetState: DWORD,
    pub OldState: DWORD,
    pub TargetProcessors: PVOID,
    pub State: [PPM_WMI_IDLE_STATE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_IDLE_STATES_EX"][::std::mem::size_of::<PPM_WMI_IDLE_STATES_EX>() - 56usize];
    ["Alignment of PPM_WMI_IDLE_STATES_EX"]
        [::std::mem::align_of::<PPM_WMI_IDLE_STATES_EX>() - 8usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::Type"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, Type) - 0usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::Count"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, Count) - 4usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::TargetState"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, TargetState) - 8usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::OldState"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, OldState) - 12usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::TargetProcessors"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, TargetProcessors) - 16usize];
    ["Offset of field: PPM_WMI_IDLE_STATES_EX::State"]
        [::std::mem::offset_of!(PPM_WMI_IDLE_STATES_EX, State) - 24usize];
};
pub type PPPM_WMI_IDLE_STATES_EX = *mut PPM_WMI_IDLE_STATES_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_PERF_STATE {
    pub Frequency: DWORD,
    pub Power: DWORD,
    pub PercentFrequency: BYTE,
    pub IncreaseLevel: BYTE,
    pub DecreaseLevel: BYTE,
    pub Type: BYTE,
    pub IncreaseTime: DWORD,
    pub DecreaseTime: DWORD,
    pub Control: DWORD64,
    pub Status: DWORD64,
    pub HitCount: DWORD,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD64,
    pub Reserved3: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_PERF_STATE"][::std::mem::size_of::<PPM_WMI_PERF_STATE>() - 64usize];
    ["Alignment of PPM_WMI_PERF_STATE"][::std::mem::align_of::<PPM_WMI_PERF_STATE>() - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Frequency"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Frequency) - 0usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Power"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Power) - 4usize];
    ["Offset of field: PPM_WMI_PERF_STATE::PercentFrequency"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, PercentFrequency) - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATE::IncreaseLevel"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, IncreaseLevel) - 9usize];
    ["Offset of field: PPM_WMI_PERF_STATE::DecreaseLevel"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, DecreaseLevel) - 10usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Type"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Type) - 11usize];
    ["Offset of field: PPM_WMI_PERF_STATE::IncreaseTime"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, IncreaseTime) - 12usize];
    ["Offset of field: PPM_WMI_PERF_STATE::DecreaseTime"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, DecreaseTime) - 16usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Control"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Control) - 24usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Status"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Status) - 32usize];
    ["Offset of field: PPM_WMI_PERF_STATE::HitCount"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, HitCount) - 40usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Reserved1"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Reserved1) - 44usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Reserved2"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Reserved2) - 48usize];
    ["Offset of field: PPM_WMI_PERF_STATE::Reserved3"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATE, Reserved3) - 56usize];
};
pub type PPPM_WMI_PERF_STATE = *mut PPM_WMI_PERF_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_PERF_STATES {
    pub Count: DWORD,
    pub MaxFrequency: DWORD,
    pub CurrentState: DWORD,
    pub MaxPerfState: DWORD,
    pub MinPerfState: DWORD,
    pub LowestPerfState: DWORD,
    pub ThermalConstraint: DWORD,
    pub BusyAdjThreshold: BYTE,
    pub PolicyType: BYTE,
    pub Type: BYTE,
    pub Reserved: BYTE,
    pub TimerInterval: DWORD,
    pub TargetProcessors: DWORD64,
    pub PStateHandler: DWORD,
    pub PStateContext: DWORD,
    pub TStateHandler: DWORD,
    pub TStateContext: DWORD,
    pub FeedbackHandler: DWORD,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD64,
    pub State: [PPM_WMI_PERF_STATE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_PERF_STATES"][::std::mem::size_of::<PPM_WMI_PERF_STATES>() - 144usize];
    ["Alignment of PPM_WMI_PERF_STATES"][::std::mem::align_of::<PPM_WMI_PERF_STATES>() - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATES::Count"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, Count) - 0usize];
    ["Offset of field: PPM_WMI_PERF_STATES::MaxFrequency"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, MaxFrequency) - 4usize];
    ["Offset of field: PPM_WMI_PERF_STATES::CurrentState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, CurrentState) - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATES::MaxPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, MaxPerfState) - 12usize];
    ["Offset of field: PPM_WMI_PERF_STATES::MinPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, MinPerfState) - 16usize];
    ["Offset of field: PPM_WMI_PERF_STATES::LowestPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, LowestPerfState) - 20usize];
    ["Offset of field: PPM_WMI_PERF_STATES::ThermalConstraint"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, ThermalConstraint) - 24usize];
    ["Offset of field: PPM_WMI_PERF_STATES::BusyAdjThreshold"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, BusyAdjThreshold) - 28usize];
    ["Offset of field: PPM_WMI_PERF_STATES::PolicyType"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, PolicyType) - 29usize];
    ["Offset of field: PPM_WMI_PERF_STATES::Type"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, Type) - 30usize];
    ["Offset of field: PPM_WMI_PERF_STATES::Reserved"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, Reserved) - 31usize];
    ["Offset of field: PPM_WMI_PERF_STATES::TimerInterval"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, TimerInterval) - 32usize];
    ["Offset of field: PPM_WMI_PERF_STATES::TargetProcessors"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, TargetProcessors) - 40usize];
    ["Offset of field: PPM_WMI_PERF_STATES::PStateHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, PStateHandler) - 48usize];
    ["Offset of field: PPM_WMI_PERF_STATES::PStateContext"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, PStateContext) - 52usize];
    ["Offset of field: PPM_WMI_PERF_STATES::TStateHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, TStateHandler) - 56usize];
    ["Offset of field: PPM_WMI_PERF_STATES::TStateContext"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, TStateContext) - 60usize];
    ["Offset of field: PPM_WMI_PERF_STATES::FeedbackHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, FeedbackHandler) - 64usize];
    ["Offset of field: PPM_WMI_PERF_STATES::Reserved1"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, Reserved1) - 68usize];
    ["Offset of field: PPM_WMI_PERF_STATES::Reserved2"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, Reserved2) - 72usize];
    ["Offset of field: PPM_WMI_PERF_STATES::State"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES, State) - 80usize];
};
pub type PPPM_WMI_PERF_STATES = *mut PPM_WMI_PERF_STATES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_WMI_PERF_STATES_EX {
    pub Count: DWORD,
    pub MaxFrequency: DWORD,
    pub CurrentState: DWORD,
    pub MaxPerfState: DWORD,
    pub MinPerfState: DWORD,
    pub LowestPerfState: DWORD,
    pub ThermalConstraint: DWORD,
    pub BusyAdjThreshold: BYTE,
    pub PolicyType: BYTE,
    pub Type: BYTE,
    pub Reserved: BYTE,
    pub TimerInterval: DWORD,
    pub TargetProcessors: PVOID,
    pub PStateHandler: DWORD,
    pub PStateContext: DWORD,
    pub TStateHandler: DWORD,
    pub TStateContext: DWORD,
    pub FeedbackHandler: DWORD,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD64,
    pub State: [PPM_WMI_PERF_STATE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_WMI_PERF_STATES_EX"][::std::mem::size_of::<PPM_WMI_PERF_STATES_EX>() - 144usize];
    ["Alignment of PPM_WMI_PERF_STATES_EX"]
        [::std::mem::align_of::<PPM_WMI_PERF_STATES_EX>() - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::Count"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, Count) - 0usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::MaxFrequency"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, MaxFrequency) - 4usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::CurrentState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, CurrentState) - 8usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::MaxPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, MaxPerfState) - 12usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::MinPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, MinPerfState) - 16usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::LowestPerfState"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, LowestPerfState) - 20usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::ThermalConstraint"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, ThermalConstraint) - 24usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::BusyAdjThreshold"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, BusyAdjThreshold) - 28usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::PolicyType"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, PolicyType) - 29usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::Type"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, Type) - 30usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::Reserved"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, Reserved) - 31usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::TimerInterval"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, TimerInterval) - 32usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::TargetProcessors"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, TargetProcessors) - 40usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::PStateHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, PStateHandler) - 48usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::PStateContext"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, PStateContext) - 52usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::TStateHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, TStateHandler) - 56usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::TStateContext"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, TStateContext) - 60usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::FeedbackHandler"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, FeedbackHandler) - 64usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::Reserved1"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, Reserved1) - 68usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::Reserved2"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, Reserved2) - 72usize];
    ["Offset of field: PPM_WMI_PERF_STATES_EX::State"]
        [::std::mem::offset_of!(PPM_WMI_PERF_STATES_EX, State) - 80usize];
};
pub type PPPM_WMI_PERF_STATES_EX = *mut PPM_WMI_PERF_STATES_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLE_STATE_ACCOUNTING {
    pub IdleTransitions: DWORD,
    pub FailedTransitions: DWORD,
    pub InvalidBucketIndex: DWORD,
    pub TotalTime: DWORD64,
    pub IdleTimeBuckets: [DWORD; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLE_STATE_ACCOUNTING"]
        [::std::mem::size_of::<PPM_IDLE_STATE_ACCOUNTING>() - 48usize];
    ["Alignment of PPM_IDLE_STATE_ACCOUNTING"]
        [::std::mem::align_of::<PPM_IDLE_STATE_ACCOUNTING>() - 8usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING::IdleTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING, IdleTransitions) - 0usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING::FailedTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING, FailedTransitions) - 4usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING::InvalidBucketIndex"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING, InvalidBucketIndex) - 8usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING::TotalTime"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING, TotalTime) - 16usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING::IdleTimeBuckets"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING, IdleTimeBuckets) - 24usize];
};
pub type PPPM_IDLE_STATE_ACCOUNTING = *mut PPM_IDLE_STATE_ACCOUNTING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLE_ACCOUNTING {
    pub StateCount: DWORD,
    pub TotalTransitions: DWORD,
    pub ResetCount: DWORD,
    pub StartTime: DWORD64,
    pub State: [PPM_IDLE_STATE_ACCOUNTING; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLE_ACCOUNTING"][::std::mem::size_of::<PPM_IDLE_ACCOUNTING>() - 72usize];
    ["Alignment of PPM_IDLE_ACCOUNTING"][::std::mem::align_of::<PPM_IDLE_ACCOUNTING>() - 8usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING::StateCount"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING, StateCount) - 0usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING::TotalTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING, TotalTransitions) - 4usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING::ResetCount"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING, ResetCount) - 8usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING::StartTime"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING, StartTime) - 16usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING::State"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING, State) - 24usize];
};
pub type PPPM_IDLE_ACCOUNTING = *mut PPM_IDLE_ACCOUNTING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLE_STATE_BUCKET_EX {
    pub TotalTimeUs: DWORD64,
    pub MinTimeUs: DWORD,
    pub MaxTimeUs: DWORD,
    pub Count: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLE_STATE_BUCKET_EX"]
        [::std::mem::size_of::<PPM_IDLE_STATE_BUCKET_EX>() - 24usize];
    ["Alignment of PPM_IDLE_STATE_BUCKET_EX"]
        [::std::mem::align_of::<PPM_IDLE_STATE_BUCKET_EX>() - 8usize];
    ["Offset of field: PPM_IDLE_STATE_BUCKET_EX::TotalTimeUs"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_BUCKET_EX, TotalTimeUs) - 0usize];
    ["Offset of field: PPM_IDLE_STATE_BUCKET_EX::MinTimeUs"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_BUCKET_EX, MinTimeUs) - 8usize];
    ["Offset of field: PPM_IDLE_STATE_BUCKET_EX::MaxTimeUs"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_BUCKET_EX, MaxTimeUs) - 12usize];
    ["Offset of field: PPM_IDLE_STATE_BUCKET_EX::Count"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_BUCKET_EX, Count) - 16usize];
};
pub type PPPM_IDLE_STATE_BUCKET_EX = *mut PPM_IDLE_STATE_BUCKET_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLE_STATE_ACCOUNTING_EX {
    pub TotalTime: DWORD64,
    pub IdleTransitions: DWORD,
    pub FailedTransitions: DWORD,
    pub InvalidBucketIndex: DWORD,
    pub MinTimeUs: DWORD,
    pub MaxTimeUs: DWORD,
    pub CancelledTransitions: DWORD,
    pub IdleTimeBuckets: [PPM_IDLE_STATE_BUCKET_EX; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLE_STATE_ACCOUNTING_EX"]
        [::std::mem::size_of::<PPM_IDLE_STATE_ACCOUNTING_EX>() - 416usize];
    ["Alignment of PPM_IDLE_STATE_ACCOUNTING_EX"]
        [::std::mem::align_of::<PPM_IDLE_STATE_ACCOUNTING_EX>() - 8usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::TotalTime"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, TotalTime) - 0usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::IdleTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, IdleTransitions) - 8usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::FailedTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, FailedTransitions) - 12usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::InvalidBucketIndex"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, InvalidBucketIndex) - 16usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::MinTimeUs"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, MinTimeUs) - 20usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::MaxTimeUs"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, MaxTimeUs) - 24usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::CancelledTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, CancelledTransitions) - 28usize];
    ["Offset of field: PPM_IDLE_STATE_ACCOUNTING_EX::IdleTimeBuckets"]
        [::std::mem::offset_of!(PPM_IDLE_STATE_ACCOUNTING_EX, IdleTimeBuckets) - 32usize];
};
pub type PPPM_IDLE_STATE_ACCOUNTING_EX = *mut PPM_IDLE_STATE_ACCOUNTING_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLE_ACCOUNTING_EX {
    pub StateCount: DWORD,
    pub TotalTransitions: DWORD,
    pub ResetCount: DWORD,
    pub AbortCount: DWORD,
    pub StartTime: DWORD64,
    pub State: [PPM_IDLE_STATE_ACCOUNTING_EX; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLE_ACCOUNTING_EX"][::std::mem::size_of::<PPM_IDLE_ACCOUNTING_EX>() - 440usize];
    ["Alignment of PPM_IDLE_ACCOUNTING_EX"]
        [::std::mem::align_of::<PPM_IDLE_ACCOUNTING_EX>() - 8usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::StateCount"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, StateCount) - 0usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::TotalTransitions"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, TotalTransitions) - 4usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::ResetCount"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, ResetCount) - 8usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::AbortCount"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, AbortCount) - 12usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::StartTime"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, StartTime) - 16usize];
    ["Offset of field: PPM_IDLE_ACCOUNTING_EX::State"]
        [::std::mem::offset_of!(PPM_IDLE_ACCOUNTING_EX, State) - 24usize];
};
pub type PPPM_IDLE_ACCOUNTING_EX = *mut PPM_IDLE_ACCOUNTING_EX;
unsafe extern "C" {
    pub static PPM_PERFSTATE_CHANGE_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_PERFSTATE_DOMAIN_CHANGE_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_IDLESTATE_CHANGE_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_PERFSTATES_DATA_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_IDLESTATES_DATA_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_IDLE_ACCOUNTING_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_IDLE_ACCOUNTING_EX_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_THERMALCONSTRAINT_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_PERFMON_PERFSTATE_GUID: GUID;
}
unsafe extern "C" {
    pub static PPM_THERMAL_POLICY_CHANGE_GUID: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_PERFSTATE_EVENT {
    pub State: DWORD,
    pub Status: DWORD,
    pub Latency: DWORD,
    pub Speed: DWORD,
    pub Processor: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_PERFSTATE_EVENT"][::std::mem::size_of::<PPM_PERFSTATE_EVENT>() - 20usize];
    ["Alignment of PPM_PERFSTATE_EVENT"][::std::mem::align_of::<PPM_PERFSTATE_EVENT>() - 4usize];
    ["Offset of field: PPM_PERFSTATE_EVENT::State"]
        [::std::mem::offset_of!(PPM_PERFSTATE_EVENT, State) - 0usize];
    ["Offset of field: PPM_PERFSTATE_EVENT::Status"]
        [::std::mem::offset_of!(PPM_PERFSTATE_EVENT, Status) - 4usize];
    ["Offset of field: PPM_PERFSTATE_EVENT::Latency"]
        [::std::mem::offset_of!(PPM_PERFSTATE_EVENT, Latency) - 8usize];
    ["Offset of field: PPM_PERFSTATE_EVENT::Speed"]
        [::std::mem::offset_of!(PPM_PERFSTATE_EVENT, Speed) - 12usize];
    ["Offset of field: PPM_PERFSTATE_EVENT::Processor"]
        [::std::mem::offset_of!(PPM_PERFSTATE_EVENT, Processor) - 16usize];
};
pub type PPPM_PERFSTATE_EVENT = *mut PPM_PERFSTATE_EVENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_PERFSTATE_DOMAIN_EVENT {
    pub State: DWORD,
    pub Latency: DWORD,
    pub Speed: DWORD,
    pub Processors: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_PERFSTATE_DOMAIN_EVENT"]
        [::std::mem::size_of::<PPM_PERFSTATE_DOMAIN_EVENT>() - 24usize];
    ["Alignment of PPM_PERFSTATE_DOMAIN_EVENT"]
        [::std::mem::align_of::<PPM_PERFSTATE_DOMAIN_EVENT>() - 8usize];
    ["Offset of field: PPM_PERFSTATE_DOMAIN_EVENT::State"]
        [::std::mem::offset_of!(PPM_PERFSTATE_DOMAIN_EVENT, State) - 0usize];
    ["Offset of field: PPM_PERFSTATE_DOMAIN_EVENT::Latency"]
        [::std::mem::offset_of!(PPM_PERFSTATE_DOMAIN_EVENT, Latency) - 4usize];
    ["Offset of field: PPM_PERFSTATE_DOMAIN_EVENT::Speed"]
        [::std::mem::offset_of!(PPM_PERFSTATE_DOMAIN_EVENT, Speed) - 8usize];
    ["Offset of field: PPM_PERFSTATE_DOMAIN_EVENT::Processors"]
        [::std::mem::offset_of!(PPM_PERFSTATE_DOMAIN_EVENT, Processors) - 16usize];
};
pub type PPPM_PERFSTATE_DOMAIN_EVENT = *mut PPM_PERFSTATE_DOMAIN_EVENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_IDLESTATE_EVENT {
    pub NewState: DWORD,
    pub OldState: DWORD,
    pub Processors: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_IDLESTATE_EVENT"][::std::mem::size_of::<PPM_IDLESTATE_EVENT>() - 16usize];
    ["Alignment of PPM_IDLESTATE_EVENT"][::std::mem::align_of::<PPM_IDLESTATE_EVENT>() - 8usize];
    ["Offset of field: PPM_IDLESTATE_EVENT::NewState"]
        [::std::mem::offset_of!(PPM_IDLESTATE_EVENT, NewState) - 0usize];
    ["Offset of field: PPM_IDLESTATE_EVENT::OldState"]
        [::std::mem::offset_of!(PPM_IDLESTATE_EVENT, OldState) - 4usize];
    ["Offset of field: PPM_IDLESTATE_EVENT::Processors"]
        [::std::mem::offset_of!(PPM_IDLESTATE_EVENT, Processors) - 8usize];
};
pub type PPPM_IDLESTATE_EVENT = *mut PPM_IDLESTATE_EVENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_THERMALCHANGE_EVENT {
    pub ThermalConstraint: DWORD,
    pub Processors: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_THERMALCHANGE_EVENT"][::std::mem::size_of::<PPM_THERMALCHANGE_EVENT>() - 16usize];
    ["Alignment of PPM_THERMALCHANGE_EVENT"]
        [::std::mem::align_of::<PPM_THERMALCHANGE_EVENT>() - 8usize];
    ["Offset of field: PPM_THERMALCHANGE_EVENT::ThermalConstraint"]
        [::std::mem::offset_of!(PPM_THERMALCHANGE_EVENT, ThermalConstraint) - 0usize];
    ["Offset of field: PPM_THERMALCHANGE_EVENT::Processors"]
        [::std::mem::offset_of!(PPM_THERMALCHANGE_EVENT, Processors) - 8usize];
};
pub type PPPM_THERMALCHANGE_EVENT = *mut PPM_THERMALCHANGE_EVENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PPM_THERMAL_POLICY_EVENT {
    pub Mode: BYTE,
    pub Processors: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PPM_THERMAL_POLICY_EVENT"]
        [::std::mem::size_of::<PPM_THERMAL_POLICY_EVENT>() - 16usize];
    ["Alignment of PPM_THERMAL_POLICY_EVENT"]
        [::std::mem::align_of::<PPM_THERMAL_POLICY_EVENT>() - 8usize];
    ["Offset of field: PPM_THERMAL_POLICY_EVENT::Mode"]
        [::std::mem::offset_of!(PPM_THERMAL_POLICY_EVENT, Mode) - 0usize];
    ["Offset of field: PPM_THERMAL_POLICY_EVENT::Processors"]
        [::std::mem::offset_of!(PPM_THERMAL_POLICY_EVENT, Processors) - 8usize];
};
pub type PPPM_THERMAL_POLICY_EVENT = *mut PPM_THERMAL_POLICY_EVENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct POWER_ACTION_POLICY {
    pub Action: POWER_ACTION,
    pub Flags: DWORD,
    pub EventCode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of POWER_ACTION_POLICY"][::std::mem::size_of::<POWER_ACTION_POLICY>() - 12usize];
    ["Alignment of POWER_ACTION_POLICY"][::std::mem::align_of::<POWER_ACTION_POLICY>() - 4usize];
    ["Offset of field: POWER_ACTION_POLICY::Action"]
        [::std::mem::offset_of!(POWER_ACTION_POLICY, Action) - 0usize];
    ["Offset of field: POWER_ACTION_POLICY::Flags"]
        [::std::mem::offset_of!(POWER_ACTION_POLICY, Flags) - 4usize];
    ["Offset of field: POWER_ACTION_POLICY::EventCode"]
        [::std::mem::offset_of!(POWER_ACTION_POLICY, EventCode) - 8usize];
};
pub type PPOWER_ACTION_POLICY = *mut POWER_ACTION_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SYSTEM_POWER_LEVEL {
    pub Enable: BOOLEAN,
    pub Spare: [BYTE; 3usize],
    pub BatteryLevel: DWORD,
    pub PowerPolicy: POWER_ACTION_POLICY,
    pub MinSystemState: SYSTEM_POWER_STATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SYSTEM_POWER_LEVEL"][::std::mem::size_of::<SYSTEM_POWER_LEVEL>() - 24usize];
    ["Alignment of SYSTEM_POWER_LEVEL"][::std::mem::align_of::<SYSTEM_POWER_LEVEL>() - 4usize];
    ["Offset of field: SYSTEM_POWER_LEVEL::Enable"]
        [::std::mem::offset_of!(SYSTEM_POWER_LEVEL, Enable) - 0usize];
    ["Offset of field: SYSTEM_POWER_LEVEL::Spare"]
        [::std::mem::offset_of!(SYSTEM_POWER_LEVEL, Spare) - 1usize];
    ["Offset of field: SYSTEM_POWER_LEVEL::BatteryLevel"]
        [::std::mem::offset_of!(SYSTEM_POWER_LEVEL, BatteryLevel) - 4usize];
    ["Offset of field: SYSTEM_POWER_LEVEL::PowerPolicy"]
        [::std::mem::offset_of!(SYSTEM_POWER_LEVEL, PowerPolicy) - 8usize];
    ["Offset of field: SYSTEM_POWER_LEVEL::MinSystemState"]
        [::std::mem::offset_of!(SYSTEM_POWER_LEVEL, MinSystemState) - 20usize];
};
pub type PSYSTEM_POWER_LEVEL = *mut SYSTEM_POWER_LEVEL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_POWER_POLICY {
    pub Revision: DWORD,
    pub PowerButton: POWER_ACTION_POLICY,
    pub SleepButton: POWER_ACTION_POLICY,
    pub LidClose: POWER_ACTION_POLICY,
    pub LidOpenWake: SYSTEM_POWER_STATE,
    pub Reserved: DWORD,
    pub Idle: POWER_ACTION_POLICY,
    pub IdleTimeout: DWORD,
    pub IdleSensitivity: BYTE,
    pub DynamicThrottle: BYTE,
    pub Spare2: [BYTE; 2usize],
    pub MinSleep: SYSTEM_POWER_STATE,
    pub MaxSleep: SYSTEM_POWER_STATE,
    pub ReducedLatencySleep: SYSTEM_POWER_STATE,
    pub WinLogonFlags: DWORD,
    pub Spare3: DWORD,
    pub DozeS4Timeout: DWORD,
    pub BroadcastCapacityResolution: DWORD,
    pub DischargePolicy: [SYSTEM_POWER_LEVEL; 4usize],
    pub VideoTimeout: DWORD,
    pub VideoDimDisplay: BOOLEAN,
    pub VideoReserved: [DWORD; 3usize],
    pub SpindownTimeout: DWORD,
    pub OptimizeForPower: BOOLEAN,
    pub FanThrottleTolerance: BYTE,
    pub ForcedThrottle: BYTE,
    pub MinThrottle: BYTE,
    pub OverThrottled: POWER_ACTION_POLICY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_POWER_POLICY"][::std::mem::size_of::<_SYSTEM_POWER_POLICY>() - 232usize];
    ["Alignment of _SYSTEM_POWER_POLICY"][::std::mem::align_of::<_SYSTEM_POWER_POLICY>() - 4usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::Revision"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, Revision) - 0usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::PowerButton"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, PowerButton) - 4usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::SleepButton"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, SleepButton) - 16usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::LidClose"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, LidClose) - 28usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::LidOpenWake"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, LidOpenWake) - 40usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::Reserved"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, Reserved) - 44usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::Idle"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, Idle) - 48usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::IdleTimeout"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, IdleTimeout) - 60usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::IdleSensitivity"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, IdleSensitivity) - 64usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::DynamicThrottle"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, DynamicThrottle) - 65usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::Spare2"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, Spare2) - 66usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::MinSleep"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, MinSleep) - 68usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::MaxSleep"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, MaxSleep) - 72usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::ReducedLatencySleep"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, ReducedLatencySleep) - 76usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::WinLogonFlags"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, WinLogonFlags) - 80usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::Spare3"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, Spare3) - 84usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::DozeS4Timeout"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, DozeS4Timeout) - 88usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::BroadcastCapacityResolution"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, BroadcastCapacityResolution) - 92usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::DischargePolicy"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, DischargePolicy) - 96usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::VideoTimeout"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, VideoTimeout) - 192usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::VideoDimDisplay"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, VideoDimDisplay) - 196usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::VideoReserved"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, VideoReserved) - 200usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::SpindownTimeout"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, SpindownTimeout) - 212usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::OptimizeForPower"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, OptimizeForPower) - 216usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::FanThrottleTolerance"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, FanThrottleTolerance) - 217usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::ForcedThrottle"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, ForcedThrottle) - 218usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::MinThrottle"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, MinThrottle) - 219usize];
    ["Offset of field: _SYSTEM_POWER_POLICY::OverThrottled"]
        [::std::mem::offset_of!(_SYSTEM_POWER_POLICY, OverThrottled) - 220usize];
};
pub type SYSTEM_POWER_POLICY = _SYSTEM_POWER_POLICY;
pub type PSYSTEM_POWER_POLICY = *mut _SYSTEM_POWER_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PROCESSOR_IDLESTATE_INFO {
    pub TimeCheck: DWORD,
    pub DemotePercent: BYTE,
    pub PromotePercent: BYTE,
    pub Spare: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_IDLESTATE_INFO"]
        [::std::mem::size_of::<PROCESSOR_IDLESTATE_INFO>() - 8usize];
    ["Alignment of PROCESSOR_IDLESTATE_INFO"]
        [::std::mem::align_of::<PROCESSOR_IDLESTATE_INFO>() - 4usize];
    ["Offset of field: PROCESSOR_IDLESTATE_INFO::TimeCheck"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_INFO, TimeCheck) - 0usize];
    ["Offset of field: PROCESSOR_IDLESTATE_INFO::DemotePercent"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_INFO, DemotePercent) - 4usize];
    ["Offset of field: PROCESSOR_IDLESTATE_INFO::PromotePercent"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_INFO, PromotePercent) - 5usize];
    ["Offset of field: PROCESSOR_IDLESTATE_INFO::Spare"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_INFO, Spare) - 6usize];
};
pub type PPROCESSOR_IDLESTATE_INFO = *mut PROCESSOR_IDLESTATE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct PROCESSOR_IDLESTATE_POLICY {
    pub Revision: WORD,
    pub Flags: PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1,
    pub PolicyCount: DWORD,
    pub Policy: [PROCESSOR_IDLESTATE_INFO; 3usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1 {
    pub AsWORD: WORD,
    pub __bindgen_anon_1: PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Alignment of PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1>() - 2usize];
};
impl PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn AllowScaling(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_AllowScaling(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowScaling_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_AllowScaling_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Disabled(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_Disabled(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Disabled_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Disabled_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 14u8) as u16) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 14u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                14u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                14u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        AllowScaling: WORD,
        Disabled: WORD,
        Reserved: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let AllowScaling: u16 = unsafe { ::std::mem::transmute(AllowScaling) };
            AllowScaling as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let Disabled: u16 = unsafe { ::std::mem::transmute(Disabled) };
            Disabled as u64
        });
        __bindgen_bitfield_unit.set(2usize, 14u8, {
            let Reserved: u16 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1>() - 2usize];
    ["Alignment of PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1>() - 2usize];
    ["Offset of field: PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1::AsWORD"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_POLICY__bindgen_ty_1, AsWORD) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_IDLESTATE_POLICY"]
        [::std::mem::size_of::<PROCESSOR_IDLESTATE_POLICY>() - 32usize];
    ["Alignment of PROCESSOR_IDLESTATE_POLICY"]
        [::std::mem::align_of::<PROCESSOR_IDLESTATE_POLICY>() - 4usize];
    ["Offset of field: PROCESSOR_IDLESTATE_POLICY::Revision"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_POLICY, Revision) - 0usize];
    ["Offset of field: PROCESSOR_IDLESTATE_POLICY::Flags"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_POLICY, Flags) - 2usize];
    ["Offset of field: PROCESSOR_IDLESTATE_POLICY::PolicyCount"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_POLICY, PolicyCount) - 4usize];
    ["Offset of field: PROCESSOR_IDLESTATE_POLICY::Policy"]
        [::std::mem::offset_of!(PROCESSOR_IDLESTATE_POLICY, Policy) - 8usize];
};
pub type PPROCESSOR_IDLESTATE_POLICY = *mut PROCESSOR_IDLESTATE_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESSOR_POWER_POLICY_INFO {
    pub TimeCheck: DWORD,
    pub DemoteLimit: DWORD,
    pub PromoteLimit: DWORD,
    pub DemotePercent: BYTE,
    pub PromotePercent: BYTE,
    pub Spare: [BYTE; 2usize],
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESSOR_POWER_POLICY_INFO"]
        [::std::mem::size_of::<_PROCESSOR_POWER_POLICY_INFO>() - 20usize];
    ["Alignment of _PROCESSOR_POWER_POLICY_INFO"]
        [::std::mem::align_of::<_PROCESSOR_POWER_POLICY_INFO>() - 4usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::TimeCheck"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, TimeCheck) - 0usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::DemoteLimit"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, DemoteLimit) - 4usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::PromoteLimit"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, PromoteLimit) - 8usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::DemotePercent"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, DemotePercent) - 12usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::PromotePercent"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, PromotePercent) - 13usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY_INFO::Spare"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY_INFO, Spare) - 14usize];
};
impl _PROCESSOR_POWER_POLICY_INFO {
    #[inline]
    pub fn AllowDemotion(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowDemotion(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowDemotion_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowDemotion_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AllowPromotion(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowPromotion(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowPromotion_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowPromotion_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        AllowDemotion: DWORD,
        AllowPromotion: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let AllowDemotion: u32 = unsafe { ::std::mem::transmute(AllowDemotion) };
            AllowDemotion as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let AllowPromotion: u32 = unsafe { ::std::mem::transmute(AllowPromotion) };
            AllowPromotion as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type PROCESSOR_POWER_POLICY_INFO = _PROCESSOR_POWER_POLICY_INFO;
pub type PPROCESSOR_POWER_POLICY_INFO = *mut _PROCESSOR_POWER_POLICY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESSOR_POWER_POLICY {
    pub Revision: DWORD,
    pub DynamicThrottle: BYTE,
    pub Spare: [BYTE; 3usize],
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub PolicyCount: DWORD,
    pub Policy: [PROCESSOR_POWER_POLICY_INFO; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESSOR_POWER_POLICY"][::std::mem::size_of::<_PROCESSOR_POWER_POLICY>() - 76usize];
    ["Alignment of _PROCESSOR_POWER_POLICY"]
        [::std::mem::align_of::<_PROCESSOR_POWER_POLICY>() - 4usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY::Revision"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY, Revision) - 0usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY::DynamicThrottle"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY, DynamicThrottle) - 4usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY::Spare"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY, Spare) - 5usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY::PolicyCount"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY, PolicyCount) - 12usize];
    ["Offset of field: _PROCESSOR_POWER_POLICY::Policy"]
        [::std::mem::offset_of!(_PROCESSOR_POWER_POLICY, Policy) - 16usize];
};
impl _PROCESSOR_POWER_POLICY {
    #[inline]
    pub fn DisableCStates(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisableCStates(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisableCStates_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisableCStates_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        DisableCStates: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let DisableCStates: u32 = unsafe { ::std::mem::transmute(DisableCStates) };
            DisableCStates as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type PROCESSOR_POWER_POLICY = _PROCESSOR_POWER_POLICY;
pub type PPROCESSOR_POWER_POLICY = *mut _PROCESSOR_POWER_POLICY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct PROCESSOR_PERFSTATE_POLICY {
    pub Revision: DWORD,
    pub MaxThrottle: BYTE,
    pub MinThrottle: BYTE,
    pub BusyAdjThreshold: BYTE,
    pub __bindgen_anon_1: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1,
    pub TimeCheck: DWORD,
    pub IncreaseTime: DWORD,
    pub DecreaseTime: DWORD,
    pub IncreasePercent: DWORD,
    pub DecreasePercent: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1 {
    pub Spare: BYTE,
    pub Flags: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1 {
    pub AsBYTE: BYTE,
    pub __bindgen_anon_1: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>(
        ) - 1usize];
    ["Alignment of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        >() - 1usize];
};
impl PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn NoDomainAccounting(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_NoDomainAccounting(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NoDomainAccounting_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_NoDomainAccounting_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IncreasePolicy(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_IncreasePolicy(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IncreasePolicy_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_IncreasePolicy_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DecreasePolicy(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_DecreasePolicy(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DecreasePolicy_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_DecreasePolicy_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        NoDomainAccounting: BYTE,
        IncreasePolicy: BYTE,
        DecreasePolicy: BYTE,
        Reserved: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let NoDomainAccounting: u8 = unsafe { ::std::mem::transmute(NoDomainAccounting) };
            NoDomainAccounting as u64
        });
        __bindgen_bitfield_unit.set(1usize, 2u8, {
            let IncreasePolicy: u8 = unsafe { ::std::mem::transmute(IncreasePolicy) };
            IncreasePolicy as u64
        });
        __bindgen_bitfield_unit.set(3usize, 2u8, {
            let DecreasePolicy: u8 = unsafe { ::std::mem::transmute(DecreasePolicy) };
            DecreasePolicy as u64
        });
        __bindgen_bitfield_unit.set(5usize, 3u8, {
            let Reserved: u8 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Alignment of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1::AsBYTE"][::std::mem::offset_of!(
        PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1__bindgen_ty_1,
        AsBYTE
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1"]
        [::std::mem::size_of::<PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1>() - 1usize];
    ["Alignment of PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1"]
        [::std::mem::align_of::<PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1>() - 1usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1::Spare"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1, Spare) - 0usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY__bindgen_ty_1, Flags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESSOR_PERFSTATE_POLICY"]
        [::std::mem::size_of::<PROCESSOR_PERFSTATE_POLICY>() - 28usize];
    ["Alignment of PROCESSOR_PERFSTATE_POLICY"]
        [::std::mem::align_of::<PROCESSOR_PERFSTATE_POLICY>() - 4usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::Revision"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, Revision) - 0usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::MaxThrottle"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, MaxThrottle) - 4usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::MinThrottle"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, MinThrottle) - 5usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::BusyAdjThreshold"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, BusyAdjThreshold) - 6usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::TimeCheck"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, TimeCheck) - 8usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::IncreaseTime"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, IncreaseTime) - 12usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::DecreaseTime"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, DecreaseTime) - 16usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::IncreasePercent"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, IncreasePercent) - 20usize];
    ["Offset of field: PROCESSOR_PERFSTATE_POLICY::DecreasePercent"]
        [::std::mem::offset_of!(PROCESSOR_PERFSTATE_POLICY, DecreasePercent) - 24usize];
};
pub type PPROCESSOR_PERFSTATE_POLICY = *mut PROCESSOR_PERFSTATE_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ADMINISTRATOR_POWER_POLICY {
    pub MinSleep: SYSTEM_POWER_STATE,
    pub MaxSleep: SYSTEM_POWER_STATE,
    pub MinVideoTimeout: DWORD,
    pub MaxVideoTimeout: DWORD,
    pub MinSpindownTimeout: DWORD,
    pub MaxSpindownTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ADMINISTRATOR_POWER_POLICY"]
        [::std::mem::size_of::<_ADMINISTRATOR_POWER_POLICY>() - 24usize];
    ["Alignment of _ADMINISTRATOR_POWER_POLICY"]
        [::std::mem::align_of::<_ADMINISTRATOR_POWER_POLICY>() - 4usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MinSleep"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MinSleep) - 0usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MaxSleep"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MaxSleep) - 4usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MinVideoTimeout"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MinVideoTimeout) - 8usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MaxVideoTimeout"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MaxVideoTimeout) - 12usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MinSpindownTimeout"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MinSpindownTimeout) - 16usize];
    ["Offset of field: _ADMINISTRATOR_POWER_POLICY::MaxSpindownTimeout"]
        [::std::mem::offset_of!(_ADMINISTRATOR_POWER_POLICY, MaxSpindownTimeout) - 20usize];
};
pub type ADMINISTRATOR_POWER_POLICY = _ADMINISTRATOR_POWER_POLICY;
pub type PADMINISTRATOR_POWER_POLICY = *mut _ADMINISTRATOR_POWER_POLICY;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket1GB: _HIBERFILE_BUCKET_SIZE = 0;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket2GB: _HIBERFILE_BUCKET_SIZE = 1;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket4GB: _HIBERFILE_BUCKET_SIZE = 2;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket8GB: _HIBERFILE_BUCKET_SIZE = 3;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket16GB: _HIBERFILE_BUCKET_SIZE = 4;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucket32GB: _HIBERFILE_BUCKET_SIZE = 5;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucketUnlimited: _HIBERFILE_BUCKET_SIZE = 6;
pub const _HIBERFILE_BUCKET_SIZE_HiberFileBucketMax: _HIBERFILE_BUCKET_SIZE = 7;
pub type _HIBERFILE_BUCKET_SIZE = ::std::os::raw::c_int;
pub use self::_HIBERFILE_BUCKET_SIZE as HIBERFILE_BUCKET_SIZE;
pub type PHIBERFILE_BUCKET_SIZE = *mut _HIBERFILE_BUCKET_SIZE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HIBERFILE_BUCKET {
    pub MaxPhysicalMemory: DWORD64,
    pub PhysicalMemoryPercent: [DWORD; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HIBERFILE_BUCKET"][::std::mem::size_of::<_HIBERFILE_BUCKET>() - 24usize];
    ["Alignment of _HIBERFILE_BUCKET"][::std::mem::align_of::<_HIBERFILE_BUCKET>() - 8usize];
    ["Offset of field: _HIBERFILE_BUCKET::MaxPhysicalMemory"]
        [::std::mem::offset_of!(_HIBERFILE_BUCKET, MaxPhysicalMemory) - 0usize];
    ["Offset of field: _HIBERFILE_BUCKET::PhysicalMemoryPercent"]
        [::std::mem::offset_of!(_HIBERFILE_BUCKET, PhysicalMemoryPercent) - 8usize];
};
pub type HIBERFILE_BUCKET = _HIBERFILE_BUCKET;
pub type PHIBERFILE_BUCKET = *mut _HIBERFILE_BUCKET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SYSTEM_POWER_CAPABILITIES {
    pub PowerButtonPresent: BOOLEAN,
    pub SleepButtonPresent: BOOLEAN,
    pub LidPresent: BOOLEAN,
    pub SystemS1: BOOLEAN,
    pub SystemS2: BOOLEAN,
    pub SystemS3: BOOLEAN,
    pub SystemS4: BOOLEAN,
    pub SystemS5: BOOLEAN,
    pub HiberFilePresent: BOOLEAN,
    pub FullWake: BOOLEAN,
    pub VideoDimPresent: BOOLEAN,
    pub ApmPresent: BOOLEAN,
    pub UpsPresent: BOOLEAN,
    pub ThermalControl: BOOLEAN,
    pub ProcessorThrottle: BOOLEAN,
    pub ProcessorMinThrottle: BYTE,
    pub ProcessorMaxThrottle: BYTE,
    pub FastSystemS4: BOOLEAN,
    pub Hiberboot: BOOLEAN,
    pub WakeAlarmPresent: BOOLEAN,
    pub AoAc: BOOLEAN,
    pub DiskSpinDown: BOOLEAN,
    pub HiberFileType: BYTE,
    pub AoAcConnectivitySupported: BOOLEAN,
    pub spare3: [BYTE; 6usize],
    pub SystemBatteriesPresent: BOOLEAN,
    pub BatteriesAreShortTerm: BOOLEAN,
    pub BatteryScale: [BATTERY_REPORTING_SCALE; 3usize],
    pub AcOnLineWake: SYSTEM_POWER_STATE,
    pub SoftLidWake: SYSTEM_POWER_STATE,
    pub RtcWake: SYSTEM_POWER_STATE,
    pub MinDeviceWakeState: SYSTEM_POWER_STATE,
    pub DefaultLowLatencyWake: SYSTEM_POWER_STATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SYSTEM_POWER_CAPABILITIES"]
        [::std::mem::size_of::<SYSTEM_POWER_CAPABILITIES>() - 76usize];
    ["Alignment of SYSTEM_POWER_CAPABILITIES"]
        [::std::mem::align_of::<SYSTEM_POWER_CAPABILITIES>() - 4usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::PowerButtonPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, PowerButtonPresent) - 0usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SleepButtonPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SleepButtonPresent) - 1usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::LidPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, LidPresent) - 2usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemS1"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemS1) - 3usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemS2"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemS2) - 4usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemS3"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemS3) - 5usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemS4"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemS4) - 6usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemS5"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemS5) - 7usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::HiberFilePresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, HiberFilePresent) - 8usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::FullWake"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, FullWake) - 9usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::VideoDimPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, VideoDimPresent) - 10usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::ApmPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, ApmPresent) - 11usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::UpsPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, UpsPresent) - 12usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::ThermalControl"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, ThermalControl) - 13usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::ProcessorThrottle"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, ProcessorThrottle) - 14usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::ProcessorMinThrottle"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, ProcessorMinThrottle) - 15usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::ProcessorMaxThrottle"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, ProcessorMaxThrottle) - 16usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::FastSystemS4"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, FastSystemS4) - 17usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::Hiberboot"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, Hiberboot) - 18usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::WakeAlarmPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, WakeAlarmPresent) - 19usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::AoAc"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, AoAc) - 20usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::DiskSpinDown"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, DiskSpinDown) - 21usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::HiberFileType"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, HiberFileType) - 22usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::AoAcConnectivitySupported"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, AoAcConnectivitySupported) - 23usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::spare3"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, spare3) - 24usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SystemBatteriesPresent"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SystemBatteriesPresent) - 30usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::BatteriesAreShortTerm"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, BatteriesAreShortTerm) - 31usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::BatteryScale"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, BatteryScale) - 32usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::AcOnLineWake"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, AcOnLineWake) - 56usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::SoftLidWake"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, SoftLidWake) - 60usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::RtcWake"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, RtcWake) - 64usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::MinDeviceWakeState"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, MinDeviceWakeState) - 68usize];
    ["Offset of field: SYSTEM_POWER_CAPABILITIES::DefaultLowLatencyWake"]
        [::std::mem::offset_of!(SYSTEM_POWER_CAPABILITIES, DefaultLowLatencyWake) - 72usize];
};
pub type PSYSTEM_POWER_CAPABILITIES = *mut SYSTEM_POWER_CAPABILITIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SYSTEM_BATTERY_STATE {
    pub AcOnLine: BOOLEAN,
    pub BatteryPresent: BOOLEAN,
    pub Charging: BOOLEAN,
    pub Discharging: BOOLEAN,
    pub Spare1: [BOOLEAN; 3usize],
    pub Tag: BYTE,
    pub MaxCapacity: DWORD,
    pub RemainingCapacity: DWORD,
    pub Rate: DWORD,
    pub EstimatedTime: DWORD,
    pub DefaultAlert1: DWORD,
    pub DefaultAlert2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SYSTEM_BATTERY_STATE"][::std::mem::size_of::<SYSTEM_BATTERY_STATE>() - 32usize];
    ["Alignment of SYSTEM_BATTERY_STATE"][::std::mem::align_of::<SYSTEM_BATTERY_STATE>() - 4usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::AcOnLine"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, AcOnLine) - 0usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::BatteryPresent"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, BatteryPresent) - 1usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::Charging"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, Charging) - 2usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::Discharging"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, Discharging) - 3usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::Spare1"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, Spare1) - 4usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::Tag"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, Tag) - 7usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::MaxCapacity"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, MaxCapacity) - 8usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::RemainingCapacity"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, RemainingCapacity) - 12usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::Rate"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, Rate) - 16usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::EstimatedTime"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, EstimatedTime) - 20usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::DefaultAlert1"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, DefaultAlert1) - 24usize];
    ["Offset of field: SYSTEM_BATTERY_STATE::DefaultAlert2"]
        [::std::mem::offset_of!(SYSTEM_BATTERY_STATE, DefaultAlert2) - 28usize];
};
pub type PSYSTEM_BATTERY_STATE = *mut SYSTEM_BATTERY_STATE;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DOS_HEADER {
    pub e_magic: WORD,
    pub e_cblp: WORD,
    pub e_cp: WORD,
    pub e_crlc: WORD,
    pub e_cparhdr: WORD,
    pub e_minalloc: WORD,
    pub e_maxalloc: WORD,
    pub e_ss: WORD,
    pub e_sp: WORD,
    pub e_csum: WORD,
    pub e_ip: WORD,
    pub e_cs: WORD,
    pub e_lfarlc: WORD,
    pub e_ovno: WORD,
    pub e_res: [WORD; 4usize],
    pub e_oemid: WORD,
    pub e_oeminfo: WORD,
    pub e_res2: [WORD; 10usize],
    pub e_lfanew: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DOS_HEADER"][::std::mem::size_of::<_IMAGE_DOS_HEADER>() - 64usize];
    ["Alignment of _IMAGE_DOS_HEADER"][::std::mem::align_of::<_IMAGE_DOS_HEADER>() - 2usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_magic"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_magic) - 0usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_cblp"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_cblp) - 2usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_cp"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_cp) - 4usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_crlc"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_crlc) - 6usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_cparhdr"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_cparhdr) - 8usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_minalloc"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_minalloc) - 10usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_maxalloc"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_maxalloc) - 12usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_ss"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_ss) - 14usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_sp"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_sp) - 16usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_csum"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_csum) - 18usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_ip"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_ip) - 20usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_cs"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_cs) - 22usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_lfarlc"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_lfarlc) - 24usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_ovno"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_ovno) - 26usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_res"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_res) - 28usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_oemid"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_oemid) - 36usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_oeminfo"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_oeminfo) - 38usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_res2"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_res2) - 40usize];
    ["Offset of field: _IMAGE_DOS_HEADER::e_lfanew"]
        [::std::mem::offset_of!(_IMAGE_DOS_HEADER, e_lfanew) - 60usize];
};
pub type IMAGE_DOS_HEADER = _IMAGE_DOS_HEADER;
pub type PIMAGE_DOS_HEADER = *mut _IMAGE_DOS_HEADER;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_OS2_HEADER {
    pub ne_magic: WORD,
    pub ne_ver: CHAR,
    pub ne_rev: CHAR,
    pub ne_enttab: WORD,
    pub ne_cbenttab: WORD,
    pub ne_crc: LONG,
    pub ne_flags: WORD,
    pub ne_autodata: WORD,
    pub ne_heap: WORD,
    pub ne_stack: WORD,
    pub ne_csip: LONG,
    pub ne_sssp: LONG,
    pub ne_cseg: WORD,
    pub ne_cmod: WORD,
    pub ne_cbnrestab: WORD,
    pub ne_segtab: WORD,
    pub ne_rsrctab: WORD,
    pub ne_restab: WORD,
    pub ne_modtab: WORD,
    pub ne_imptab: WORD,
    pub ne_nrestab: LONG,
    pub ne_cmovent: WORD,
    pub ne_align: WORD,
    pub ne_cres: WORD,
    pub ne_exetyp: BYTE,
    pub ne_flagsothers: BYTE,
    pub ne_pretthunks: WORD,
    pub ne_psegrefbytes: WORD,
    pub ne_swaparea: WORD,
    pub ne_expver: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_OS2_HEADER"][::std::mem::size_of::<_IMAGE_OS2_HEADER>() - 64usize];
    ["Alignment of _IMAGE_OS2_HEADER"][::std::mem::align_of::<_IMAGE_OS2_HEADER>() - 2usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_magic"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_magic) - 0usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_ver"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_ver) - 2usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_rev"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_rev) - 3usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_enttab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_enttab) - 4usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cbenttab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cbenttab) - 6usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_crc"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_crc) - 8usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_flags"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_flags) - 12usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_autodata"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_autodata) - 14usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_heap"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_heap) - 16usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_stack"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_stack) - 18usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_csip"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_csip) - 20usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_sssp"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_sssp) - 24usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cseg"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cseg) - 28usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cmod"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cmod) - 30usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cbnrestab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cbnrestab) - 32usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_segtab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_segtab) - 34usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_rsrctab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_rsrctab) - 36usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_restab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_restab) - 38usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_modtab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_modtab) - 40usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_imptab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_imptab) - 42usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_nrestab"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_nrestab) - 44usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cmovent"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cmovent) - 48usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_align"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_align) - 50usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_cres"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_cres) - 52usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_exetyp"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_exetyp) - 54usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_flagsothers"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_flagsothers) - 55usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_pretthunks"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_pretthunks) - 56usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_psegrefbytes"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_psegrefbytes) - 58usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_swaparea"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_swaparea) - 60usize];
    ["Offset of field: _IMAGE_OS2_HEADER::ne_expver"]
        [::std::mem::offset_of!(_IMAGE_OS2_HEADER, ne_expver) - 62usize];
};
pub type IMAGE_OS2_HEADER = _IMAGE_OS2_HEADER;
pub type PIMAGE_OS2_HEADER = *mut _IMAGE_OS2_HEADER;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_VXD_HEADER {
    pub e32_magic: WORD,
    pub e32_border: BYTE,
    pub e32_worder: BYTE,
    pub e32_level: DWORD,
    pub e32_cpu: WORD,
    pub e32_os: WORD,
    pub e32_ver: DWORD,
    pub e32_mflags: DWORD,
    pub e32_mpages: DWORD,
    pub e32_startobj: DWORD,
    pub e32_eip: DWORD,
    pub e32_stackobj: DWORD,
    pub e32_esp: DWORD,
    pub e32_pagesize: DWORD,
    pub e32_lastpagesize: DWORD,
    pub e32_fixupsize: DWORD,
    pub e32_fixupsum: DWORD,
    pub e32_ldrsize: DWORD,
    pub e32_ldrsum: DWORD,
    pub e32_objtab: DWORD,
    pub e32_objcnt: DWORD,
    pub e32_objmap: DWORD,
    pub e32_itermap: DWORD,
    pub e32_rsrctab: DWORD,
    pub e32_rsrccnt: DWORD,
    pub e32_restab: DWORD,
    pub e32_enttab: DWORD,
    pub e32_dirtab: DWORD,
    pub e32_dircnt: DWORD,
    pub e32_fpagetab: DWORD,
    pub e32_frectab: DWORD,
    pub e32_impmod: DWORD,
    pub e32_impmodcnt: DWORD,
    pub e32_impproc: DWORD,
    pub e32_pagesum: DWORD,
    pub e32_datapage: DWORD,
    pub e32_preload: DWORD,
    pub e32_nrestab: DWORD,
    pub e32_cbnrestab: DWORD,
    pub e32_nressum: DWORD,
    pub e32_autodata: DWORD,
    pub e32_debuginfo: DWORD,
    pub e32_debuglen: DWORD,
    pub e32_instpreload: DWORD,
    pub e32_instdemand: DWORD,
    pub e32_heapsize: DWORD,
    pub e32_res3: [BYTE; 12usize],
    pub e32_winresoff: DWORD,
    pub e32_winreslen: DWORD,
    pub e32_devid: WORD,
    pub e32_ddkver: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_VXD_HEADER"][::std::mem::size_of::<_IMAGE_VXD_HEADER>() - 196usize];
    ["Alignment of _IMAGE_VXD_HEADER"][::std::mem::align_of::<_IMAGE_VXD_HEADER>() - 2usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_magic"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_magic) - 0usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_border"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_border) - 2usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_worder"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_worder) - 3usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_level"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_level) - 4usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_cpu"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_cpu) - 8usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_os"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_os) - 10usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_ver"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_ver) - 12usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_mflags"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_mflags) - 16usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_mpages"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_mpages) - 20usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_startobj"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_startobj) - 24usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_eip"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_eip) - 28usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_stackobj"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_stackobj) - 32usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_esp"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_esp) - 36usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_pagesize"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_pagesize) - 40usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_lastpagesize"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_lastpagesize) - 44usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_fixupsize"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_fixupsize) - 48usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_fixupsum"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_fixupsum) - 52usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_ldrsize"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_ldrsize) - 56usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_ldrsum"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_ldrsum) - 60usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_objtab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_objtab) - 64usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_objcnt"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_objcnt) - 68usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_objmap"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_objmap) - 72usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_itermap"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_itermap) - 76usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_rsrctab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_rsrctab) - 80usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_rsrccnt"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_rsrccnt) - 84usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_restab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_restab) - 88usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_enttab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_enttab) - 92usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_dirtab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_dirtab) - 96usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_dircnt"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_dircnt) - 100usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_fpagetab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_fpagetab) - 104usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_frectab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_frectab) - 108usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_impmod"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_impmod) - 112usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_impmodcnt"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_impmodcnt) - 116usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_impproc"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_impproc) - 120usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_pagesum"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_pagesum) - 124usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_datapage"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_datapage) - 128usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_preload"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_preload) - 132usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_nrestab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_nrestab) - 136usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_cbnrestab"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_cbnrestab) - 140usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_nressum"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_nressum) - 144usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_autodata"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_autodata) - 148usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_debuginfo"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_debuginfo) - 152usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_debuglen"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_debuglen) - 156usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_instpreload"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_instpreload) - 160usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_instdemand"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_instdemand) - 164usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_heapsize"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_heapsize) - 168usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_res3"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_res3) - 172usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_winresoff"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_winresoff) - 184usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_winreslen"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_winreslen) - 188usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_devid"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_devid) - 192usize];
    ["Offset of field: _IMAGE_VXD_HEADER::e32_ddkver"]
        [::std::mem::offset_of!(_IMAGE_VXD_HEADER, e32_ddkver) - 194usize];
};
pub type IMAGE_VXD_HEADER = _IMAGE_VXD_HEADER;
pub type PIMAGE_VXD_HEADER = *mut _IMAGE_VXD_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_FILE_HEADER {
    pub Machine: WORD,
    pub NumberOfSections: WORD,
    pub TimeDateStamp: DWORD,
    pub PointerToSymbolTable: DWORD,
    pub NumberOfSymbols: DWORD,
    pub SizeOfOptionalHeader: WORD,
    pub Characteristics: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_FILE_HEADER"][::std::mem::size_of::<_IMAGE_FILE_HEADER>() - 20usize];
    ["Alignment of _IMAGE_FILE_HEADER"][::std::mem::align_of::<_IMAGE_FILE_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_FILE_HEADER::Machine"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, Machine) - 0usize];
    ["Offset of field: _IMAGE_FILE_HEADER::NumberOfSections"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, NumberOfSections) - 2usize];
    ["Offset of field: _IMAGE_FILE_HEADER::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_FILE_HEADER::PointerToSymbolTable"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, PointerToSymbolTable) - 8usize];
    ["Offset of field: _IMAGE_FILE_HEADER::NumberOfSymbols"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, NumberOfSymbols) - 12usize];
    ["Offset of field: _IMAGE_FILE_HEADER::SizeOfOptionalHeader"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, SizeOfOptionalHeader) - 16usize];
    ["Offset of field: _IMAGE_FILE_HEADER::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_FILE_HEADER, Characteristics) - 18usize];
};
pub type IMAGE_FILE_HEADER = _IMAGE_FILE_HEADER;
pub type PIMAGE_FILE_HEADER = *mut _IMAGE_FILE_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DATA_DIRECTORY {
    pub VirtualAddress: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DATA_DIRECTORY"][::std::mem::size_of::<_IMAGE_DATA_DIRECTORY>() - 8usize];
    ["Alignment of _IMAGE_DATA_DIRECTORY"]
        [::std::mem::align_of::<_IMAGE_DATA_DIRECTORY>() - 4usize];
    ["Offset of field: _IMAGE_DATA_DIRECTORY::VirtualAddress"]
        [::std::mem::offset_of!(_IMAGE_DATA_DIRECTORY, VirtualAddress) - 0usize];
    ["Offset of field: _IMAGE_DATA_DIRECTORY::Size"]
        [::std::mem::offset_of!(_IMAGE_DATA_DIRECTORY, Size) - 4usize];
};
pub type IMAGE_DATA_DIRECTORY = _IMAGE_DATA_DIRECTORY;
pub type PIMAGE_DATA_DIRECTORY = *mut _IMAGE_DATA_DIRECTORY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_OPTIONAL_HEADER {
    pub Magic: WORD,
    pub MajorLinkerVersion: BYTE,
    pub MinorLinkerVersion: BYTE,
    pub SizeOfCode: DWORD,
    pub SizeOfInitializedData: DWORD,
    pub SizeOfUninitializedData: DWORD,
    pub AddressOfEntryPoint: DWORD,
    pub BaseOfCode: DWORD,
    pub BaseOfData: DWORD,
    pub ImageBase: DWORD,
    pub SectionAlignment: DWORD,
    pub FileAlignment: DWORD,
    pub MajorOperatingSystemVersion: WORD,
    pub MinorOperatingSystemVersion: WORD,
    pub MajorImageVersion: WORD,
    pub MinorImageVersion: WORD,
    pub MajorSubsystemVersion: WORD,
    pub MinorSubsystemVersion: WORD,
    pub Win32VersionValue: DWORD,
    pub SizeOfImage: DWORD,
    pub SizeOfHeaders: DWORD,
    pub CheckSum: DWORD,
    pub Subsystem: WORD,
    pub DllCharacteristics: WORD,
    pub SizeOfStackReserve: DWORD,
    pub SizeOfStackCommit: DWORD,
    pub SizeOfHeapReserve: DWORD,
    pub SizeOfHeapCommit: DWORD,
    pub LoaderFlags: DWORD,
    pub NumberOfRvaAndSizes: DWORD,
    pub DataDirectory: [IMAGE_DATA_DIRECTORY; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_OPTIONAL_HEADER"][::std::mem::size_of::<_IMAGE_OPTIONAL_HEADER>() - 224usize];
    ["Alignment of _IMAGE_OPTIONAL_HEADER"]
        [::std::mem::align_of::<_IMAGE_OPTIONAL_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::Magic"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, Magic) - 0usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MajorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MajorLinkerVersion) - 2usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MinorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MinorLinkerVersion) - 3usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfCode"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfCode) - 4usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfInitializedData"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfInitializedData) - 8usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfUninitializedData"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfUninitializedData) - 12usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::AddressOfEntryPoint"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, AddressOfEntryPoint) - 16usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::BaseOfCode"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, BaseOfCode) - 20usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::BaseOfData"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, BaseOfData) - 24usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::ImageBase"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, ImageBase) - 28usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SectionAlignment"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SectionAlignment) - 32usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::FileAlignment"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, FileAlignment) - 36usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MajorOperatingSystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MajorOperatingSystemVersion) - 40usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MinorOperatingSystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MinorOperatingSystemVersion) - 42usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MajorImageVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MajorImageVersion) - 44usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MinorImageVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MinorImageVersion) - 46usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MajorSubsystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MajorSubsystemVersion) - 48usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::MinorSubsystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, MinorSubsystemVersion) - 50usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::Win32VersionValue"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, Win32VersionValue) - 52usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfImage"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfImage) - 56usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfHeaders"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfHeaders) - 60usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::CheckSum"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, CheckSum) - 64usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::Subsystem"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, Subsystem) - 68usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::DllCharacteristics"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, DllCharacteristics) - 70usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfStackReserve"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfStackReserve) - 72usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfStackCommit"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfStackCommit) - 76usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfHeapReserve"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfHeapReserve) - 80usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::SizeOfHeapCommit"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, SizeOfHeapCommit) - 84usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::LoaderFlags"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, LoaderFlags) - 88usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::NumberOfRvaAndSizes"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, NumberOfRvaAndSizes) - 92usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER::DataDirectory"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER, DataDirectory) - 96usize];
};
pub type IMAGE_OPTIONAL_HEADER32 = _IMAGE_OPTIONAL_HEADER;
pub type PIMAGE_OPTIONAL_HEADER32 = *mut _IMAGE_OPTIONAL_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ROM_OPTIONAL_HEADER {
    pub Magic: WORD,
    pub MajorLinkerVersion: BYTE,
    pub MinorLinkerVersion: BYTE,
    pub SizeOfCode: DWORD,
    pub SizeOfInitializedData: DWORD,
    pub SizeOfUninitializedData: DWORD,
    pub AddressOfEntryPoint: DWORD,
    pub BaseOfCode: DWORD,
    pub BaseOfData: DWORD,
    pub BaseOfBss: DWORD,
    pub GprMask: DWORD,
    pub CprMask: [DWORD; 4usize],
    pub GpValue: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ROM_OPTIONAL_HEADER"]
        [::std::mem::size_of::<_IMAGE_ROM_OPTIONAL_HEADER>() - 56usize];
    ["Alignment of _IMAGE_ROM_OPTIONAL_HEADER"]
        [::std::mem::align_of::<_IMAGE_ROM_OPTIONAL_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::Magic"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, Magic) - 0usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::MajorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, MajorLinkerVersion) - 2usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::MinorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, MinorLinkerVersion) - 3usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::SizeOfCode"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, SizeOfCode) - 4usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::SizeOfInitializedData"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, SizeOfInitializedData) - 8usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::SizeOfUninitializedData"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, SizeOfUninitializedData) - 12usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::AddressOfEntryPoint"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, AddressOfEntryPoint) - 16usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::BaseOfCode"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, BaseOfCode) - 20usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::BaseOfData"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, BaseOfData) - 24usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::BaseOfBss"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, BaseOfBss) - 28usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::GprMask"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, GprMask) - 32usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::CprMask"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, CprMask) - 36usize];
    ["Offset of field: _IMAGE_ROM_OPTIONAL_HEADER::GpValue"]
        [::std::mem::offset_of!(_IMAGE_ROM_OPTIONAL_HEADER, GpValue) - 52usize];
};
pub type IMAGE_ROM_OPTIONAL_HEADER = _IMAGE_ROM_OPTIONAL_HEADER;
pub type PIMAGE_ROM_OPTIONAL_HEADER = *mut _IMAGE_ROM_OPTIONAL_HEADER;
#[repr(C, packed(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_OPTIONAL_HEADER64 {
    pub Magic: WORD,
    pub MajorLinkerVersion: BYTE,
    pub MinorLinkerVersion: BYTE,
    pub SizeOfCode: DWORD,
    pub SizeOfInitializedData: DWORD,
    pub SizeOfUninitializedData: DWORD,
    pub AddressOfEntryPoint: DWORD,
    pub BaseOfCode: DWORD,
    pub ImageBase: ULONGLONG,
    pub SectionAlignment: DWORD,
    pub FileAlignment: DWORD,
    pub MajorOperatingSystemVersion: WORD,
    pub MinorOperatingSystemVersion: WORD,
    pub MajorImageVersion: WORD,
    pub MinorImageVersion: WORD,
    pub MajorSubsystemVersion: WORD,
    pub MinorSubsystemVersion: WORD,
    pub Win32VersionValue: DWORD,
    pub SizeOfImage: DWORD,
    pub SizeOfHeaders: DWORD,
    pub CheckSum: DWORD,
    pub Subsystem: WORD,
    pub DllCharacteristics: WORD,
    pub SizeOfStackReserve: ULONGLONG,
    pub SizeOfStackCommit: ULONGLONG,
    pub SizeOfHeapReserve: ULONGLONG,
    pub SizeOfHeapCommit: ULONGLONG,
    pub LoaderFlags: DWORD,
    pub NumberOfRvaAndSizes: DWORD,
    pub DataDirectory: [IMAGE_DATA_DIRECTORY; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_OPTIONAL_HEADER64"]
        [::std::mem::size_of::<_IMAGE_OPTIONAL_HEADER64>() - 240usize];
    ["Alignment of _IMAGE_OPTIONAL_HEADER64"]
        [::std::mem::align_of::<_IMAGE_OPTIONAL_HEADER64>() - 4usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::Magic"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, Magic) - 0usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MajorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MajorLinkerVersion) - 2usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MinorLinkerVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MinorLinkerVersion) - 3usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfCode"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfCode) - 4usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfInitializedData"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfInitializedData) - 8usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfUninitializedData"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfUninitializedData) - 12usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::AddressOfEntryPoint"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, AddressOfEntryPoint) - 16usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::BaseOfCode"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, BaseOfCode) - 20usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::ImageBase"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, ImageBase) - 24usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SectionAlignment"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SectionAlignment) - 32usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::FileAlignment"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, FileAlignment) - 36usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MajorOperatingSystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MajorOperatingSystemVersion) - 40usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MinorOperatingSystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MinorOperatingSystemVersion) - 42usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MajorImageVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MajorImageVersion) - 44usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MinorImageVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MinorImageVersion) - 46usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MajorSubsystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MajorSubsystemVersion) - 48usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::MinorSubsystemVersion"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, MinorSubsystemVersion) - 50usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::Win32VersionValue"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, Win32VersionValue) - 52usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfImage"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfImage) - 56usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfHeaders"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfHeaders) - 60usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::CheckSum"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, CheckSum) - 64usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::Subsystem"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, Subsystem) - 68usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::DllCharacteristics"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, DllCharacteristics) - 70usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfStackReserve"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfStackReserve) - 72usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfStackCommit"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfStackCommit) - 80usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfHeapReserve"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfHeapReserve) - 88usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::SizeOfHeapCommit"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, SizeOfHeapCommit) - 96usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::LoaderFlags"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, LoaderFlags) - 104usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::NumberOfRvaAndSizes"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, NumberOfRvaAndSizes) - 108usize];
    ["Offset of field: _IMAGE_OPTIONAL_HEADER64::DataDirectory"]
        [::std::mem::offset_of!(_IMAGE_OPTIONAL_HEADER64, DataDirectory) - 112usize];
};
pub type IMAGE_OPTIONAL_HEADER64 = _IMAGE_OPTIONAL_HEADER64;
pub type PIMAGE_OPTIONAL_HEADER64 = *mut _IMAGE_OPTIONAL_HEADER64;
pub type IMAGE_OPTIONAL_HEADER = IMAGE_OPTIONAL_HEADER64;
pub type PIMAGE_OPTIONAL_HEADER = PIMAGE_OPTIONAL_HEADER64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_NT_HEADERS64 {
    pub Signature: DWORD,
    pub FileHeader: IMAGE_FILE_HEADER,
    pub OptionalHeader: IMAGE_OPTIONAL_HEADER64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_NT_HEADERS64"][::std::mem::size_of::<_IMAGE_NT_HEADERS64>() - 264usize];
    ["Alignment of _IMAGE_NT_HEADERS64"][::std::mem::align_of::<_IMAGE_NT_HEADERS64>() - 4usize];
    ["Offset of field: _IMAGE_NT_HEADERS64::Signature"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS64, Signature) - 0usize];
    ["Offset of field: _IMAGE_NT_HEADERS64::FileHeader"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS64, FileHeader) - 4usize];
    ["Offset of field: _IMAGE_NT_HEADERS64::OptionalHeader"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS64, OptionalHeader) - 24usize];
};
pub type IMAGE_NT_HEADERS64 = _IMAGE_NT_HEADERS64;
pub type PIMAGE_NT_HEADERS64 = *mut _IMAGE_NT_HEADERS64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_NT_HEADERS {
    pub Signature: DWORD,
    pub FileHeader: IMAGE_FILE_HEADER,
    pub OptionalHeader: IMAGE_OPTIONAL_HEADER32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_NT_HEADERS"][::std::mem::size_of::<_IMAGE_NT_HEADERS>() - 248usize];
    ["Alignment of _IMAGE_NT_HEADERS"][::std::mem::align_of::<_IMAGE_NT_HEADERS>() - 4usize];
    ["Offset of field: _IMAGE_NT_HEADERS::Signature"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS, Signature) - 0usize];
    ["Offset of field: _IMAGE_NT_HEADERS::FileHeader"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS, FileHeader) - 4usize];
    ["Offset of field: _IMAGE_NT_HEADERS::OptionalHeader"]
        [::std::mem::offset_of!(_IMAGE_NT_HEADERS, OptionalHeader) - 24usize];
};
pub type IMAGE_NT_HEADERS32 = _IMAGE_NT_HEADERS;
pub type PIMAGE_NT_HEADERS32 = *mut _IMAGE_NT_HEADERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ROM_HEADERS {
    pub FileHeader: IMAGE_FILE_HEADER,
    pub OptionalHeader: IMAGE_ROM_OPTIONAL_HEADER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ROM_HEADERS"][::std::mem::size_of::<_IMAGE_ROM_HEADERS>() - 76usize];
    ["Alignment of _IMAGE_ROM_HEADERS"][::std::mem::align_of::<_IMAGE_ROM_HEADERS>() - 4usize];
    ["Offset of field: _IMAGE_ROM_HEADERS::FileHeader"]
        [::std::mem::offset_of!(_IMAGE_ROM_HEADERS, FileHeader) - 0usize];
    ["Offset of field: _IMAGE_ROM_HEADERS::OptionalHeader"]
        [::std::mem::offset_of!(_IMAGE_ROM_HEADERS, OptionalHeader) - 20usize];
};
pub type IMAGE_ROM_HEADERS = _IMAGE_ROM_HEADERS;
pub type PIMAGE_ROM_HEADERS = *mut _IMAGE_ROM_HEADERS;
pub type IMAGE_NT_HEADERS = IMAGE_NT_HEADERS64;
pub type PIMAGE_NT_HEADERS = PIMAGE_NT_HEADERS64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ANON_OBJECT_HEADER {
    pub Sig1: WORD,
    pub Sig2: WORD,
    pub Version: WORD,
    pub Machine: WORD,
    pub TimeDateStamp: DWORD,
    pub ClassID: CLSID,
    pub SizeOfData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ANON_OBJECT_HEADER"][::std::mem::size_of::<ANON_OBJECT_HEADER>() - 32usize];
    ["Alignment of ANON_OBJECT_HEADER"][::std::mem::align_of::<ANON_OBJECT_HEADER>() - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER::Sig1"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, Sig1) - 0usize];
    ["Offset of field: ANON_OBJECT_HEADER::Sig2"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, Sig2) - 2usize];
    ["Offset of field: ANON_OBJECT_HEADER::Version"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, Version) - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER::Machine"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, Machine) - 6usize];
    ["Offset of field: ANON_OBJECT_HEADER::TimeDateStamp"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, TimeDateStamp) - 8usize];
    ["Offset of field: ANON_OBJECT_HEADER::ClassID"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, ClassID) - 12usize];
    ["Offset of field: ANON_OBJECT_HEADER::SizeOfData"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER, SizeOfData) - 28usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ANON_OBJECT_HEADER_V2 {
    pub Sig1: WORD,
    pub Sig2: WORD,
    pub Version: WORD,
    pub Machine: WORD,
    pub TimeDateStamp: DWORD,
    pub ClassID: CLSID,
    pub SizeOfData: DWORD,
    pub Flags: DWORD,
    pub MetaDataSize: DWORD,
    pub MetaDataOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ANON_OBJECT_HEADER_V2"][::std::mem::size_of::<ANON_OBJECT_HEADER_V2>() - 44usize];
    ["Alignment of ANON_OBJECT_HEADER_V2"]
        [::std::mem::align_of::<ANON_OBJECT_HEADER_V2>() - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::Sig1"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, Sig1) - 0usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::Sig2"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, Sig2) - 2usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::Version"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, Version) - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::Machine"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, Machine) - 6usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::TimeDateStamp"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, TimeDateStamp) - 8usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::ClassID"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, ClassID) - 12usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::SizeOfData"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, SizeOfData) - 28usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::Flags"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, Flags) - 32usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::MetaDataSize"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, MetaDataSize) - 36usize];
    ["Offset of field: ANON_OBJECT_HEADER_V2::MetaDataOffset"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_V2, MetaDataOffset) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ANON_OBJECT_HEADER_BIGOBJ {
    pub Sig1: WORD,
    pub Sig2: WORD,
    pub Version: WORD,
    pub Machine: WORD,
    pub TimeDateStamp: DWORD,
    pub ClassID: CLSID,
    pub SizeOfData: DWORD,
    pub Flags: DWORD,
    pub MetaDataSize: DWORD,
    pub MetaDataOffset: DWORD,
    pub NumberOfSections: DWORD,
    pub PointerToSymbolTable: DWORD,
    pub NumberOfSymbols: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ANON_OBJECT_HEADER_BIGOBJ"]
        [::std::mem::size_of::<ANON_OBJECT_HEADER_BIGOBJ>() - 56usize];
    ["Alignment of ANON_OBJECT_HEADER_BIGOBJ"]
        [::std::mem::align_of::<ANON_OBJECT_HEADER_BIGOBJ>() - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::Sig1"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, Sig1) - 0usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::Sig2"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, Sig2) - 2usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::Version"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, Version) - 4usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::Machine"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, Machine) - 6usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::TimeDateStamp"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, TimeDateStamp) - 8usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::ClassID"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, ClassID) - 12usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::SizeOfData"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, SizeOfData) - 28usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::Flags"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, Flags) - 32usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::MetaDataSize"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, MetaDataSize) - 36usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::MetaDataOffset"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, MetaDataOffset) - 40usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::NumberOfSections"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, NumberOfSections) - 44usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::PointerToSymbolTable"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, PointerToSymbolTable) - 48usize];
    ["Offset of field: ANON_OBJECT_HEADER_BIGOBJ::NumberOfSymbols"]
        [::std::mem::offset_of!(ANON_OBJECT_HEADER_BIGOBJ, NumberOfSymbols) - 52usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_SECTION_HEADER {
    pub Name: [BYTE; 8usize],
    pub Misc: _IMAGE_SECTION_HEADER__bindgen_ty_1,
    pub VirtualAddress: DWORD,
    pub SizeOfRawData: DWORD,
    pub PointerToRawData: DWORD,
    pub PointerToRelocations: DWORD,
    pub PointerToLinenumbers: DWORD,
    pub NumberOfRelocations: WORD,
    pub NumberOfLinenumbers: WORD,
    pub Characteristics: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_SECTION_HEADER__bindgen_ty_1 {
    pub PhysicalAddress: DWORD,
    pub VirtualSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SECTION_HEADER__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_SECTION_HEADER__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_SECTION_HEADER__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_SECTION_HEADER__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_SECTION_HEADER__bindgen_ty_1::PhysicalAddress"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER__bindgen_ty_1, PhysicalAddress) - 0usize];
    ["Offset of field: _IMAGE_SECTION_HEADER__bindgen_ty_1::VirtualSize"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER__bindgen_ty_1, VirtualSize) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SECTION_HEADER"][::std::mem::size_of::<_IMAGE_SECTION_HEADER>() - 40usize];
    ["Alignment of _IMAGE_SECTION_HEADER"]
        [::std::mem::align_of::<_IMAGE_SECTION_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::Name"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, Name) - 0usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::Misc"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, Misc) - 8usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::VirtualAddress"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, VirtualAddress) - 12usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::SizeOfRawData"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, SizeOfRawData) - 16usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::PointerToRawData"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, PointerToRawData) - 20usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::PointerToRelocations"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, PointerToRelocations) - 24usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::PointerToLinenumbers"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, PointerToLinenumbers) - 28usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::NumberOfRelocations"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, NumberOfRelocations) - 32usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::NumberOfLinenumbers"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, NumberOfLinenumbers) - 34usize];
    ["Offset of field: _IMAGE_SECTION_HEADER::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_SECTION_HEADER, Characteristics) - 36usize];
};
pub type IMAGE_SECTION_HEADER = _IMAGE_SECTION_HEADER;
pub type PIMAGE_SECTION_HEADER = *mut _IMAGE_SECTION_HEADER;
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub struct _IMAGE_SYMBOL {
    pub N: _IMAGE_SYMBOL__bindgen_ty_1,
    pub Value: DWORD,
    pub SectionNumber: SHORT,
    pub Type: WORD,
    pub StorageClass: BYTE,
    pub NumberOfAuxSymbols: BYTE,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union _IMAGE_SYMBOL__bindgen_ty_1 {
    pub ShortName: [BYTE; 8usize],
    pub Name: _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1,
    pub LongName: [DWORD; 2usize],
}
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1 {
    pub Short: DWORD,
    pub Long: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1::Short"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1, Short) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1::Long"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL__bindgen_ty_1__bindgen_ty_1, Long) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_SYMBOL__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_SYMBOL__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_SYMBOL__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL__bindgen_ty_1::ShortName"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL__bindgen_ty_1, ShortName) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL__bindgen_ty_1::Name"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL__bindgen_ty_1, Name) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL__bindgen_ty_1::LongName"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL__bindgen_ty_1, LongName) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL"][::std::mem::size_of::<_IMAGE_SYMBOL>() - 18usize];
    ["Alignment of _IMAGE_SYMBOL"][::std::mem::align_of::<_IMAGE_SYMBOL>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL::N"][::std::mem::offset_of!(_IMAGE_SYMBOL, N) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL::Value"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL, Value) - 8usize];
    ["Offset of field: _IMAGE_SYMBOL::SectionNumber"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL, SectionNumber) - 12usize];
    ["Offset of field: _IMAGE_SYMBOL::Type"][::std::mem::offset_of!(_IMAGE_SYMBOL, Type) - 14usize];
    ["Offset of field: _IMAGE_SYMBOL::StorageClass"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL, StorageClass) - 16usize];
    ["Offset of field: _IMAGE_SYMBOL::NumberOfAuxSymbols"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL, NumberOfAuxSymbols) - 17usize];
};
pub type IMAGE_SYMBOL = _IMAGE_SYMBOL;
pub type PIMAGE_SYMBOL = *mut IMAGE_SYMBOL;
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub struct _IMAGE_SYMBOL_EX {
    pub N: _IMAGE_SYMBOL_EX__bindgen_ty_1,
    pub Value: DWORD,
    pub SectionNumber: LONG,
    pub Type: WORD,
    pub StorageClass: BYTE,
    pub NumberOfAuxSymbols: BYTE,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union _IMAGE_SYMBOL_EX__bindgen_ty_1 {
    pub ShortName: [BYTE; 8usize],
    pub Name: _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1,
    pub LongName: [DWORD; 2usize],
}
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1 {
    pub Short: DWORD,
    pub Long: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1::Short"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1, Short) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1::Long"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX__bindgen_ty_1__bindgen_ty_1, Long) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_SYMBOL_EX__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_SYMBOL_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_SYMBOL_EX__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL_EX__bindgen_ty_1::ShortName"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX__bindgen_ty_1, ShortName) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL_EX__bindgen_ty_1::Name"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX__bindgen_ty_1, Name) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL_EX__bindgen_ty_1::LongName"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX__bindgen_ty_1, LongName) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SYMBOL_EX"][::std::mem::size_of::<_IMAGE_SYMBOL_EX>() - 20usize];
    ["Alignment of _IMAGE_SYMBOL_EX"][::std::mem::align_of::<_IMAGE_SYMBOL_EX>() - 2usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::N"][::std::mem::offset_of!(_IMAGE_SYMBOL_EX, N) - 0usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::Value"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX, Value) - 8usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::SectionNumber"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX, SectionNumber) - 12usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::Type"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX, Type) - 16usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::StorageClass"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX, StorageClass) - 18usize];
    ["Offset of field: _IMAGE_SYMBOL_EX::NumberOfAuxSymbols"]
        [::std::mem::offset_of!(_IMAGE_SYMBOL_EX, NumberOfAuxSymbols) - 19usize];
};
pub type IMAGE_SYMBOL_EX = _IMAGE_SYMBOL_EX;
pub type PIMAGE_SYMBOL_EX = *mut IMAGE_SYMBOL_EX;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct IMAGE_AUX_SYMBOL_TOKEN_DEF {
    pub bAuxType: BYTE,
    pub bReserved: BYTE,
    pub SymbolTableIndex: DWORD,
    pub rgbReserved: [BYTE; 12usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMAGE_AUX_SYMBOL_TOKEN_DEF"]
        [::std::mem::size_of::<IMAGE_AUX_SYMBOL_TOKEN_DEF>() - 18usize];
    ["Alignment of IMAGE_AUX_SYMBOL_TOKEN_DEF"]
        [::std::mem::align_of::<IMAGE_AUX_SYMBOL_TOKEN_DEF>() - 2usize];
    ["Offset of field: IMAGE_AUX_SYMBOL_TOKEN_DEF::bAuxType"]
        [::std::mem::offset_of!(IMAGE_AUX_SYMBOL_TOKEN_DEF, bAuxType) - 0usize];
    ["Offset of field: IMAGE_AUX_SYMBOL_TOKEN_DEF::bReserved"]
        [::std::mem::offset_of!(IMAGE_AUX_SYMBOL_TOKEN_DEF, bReserved) - 1usize];
    ["Offset of field: IMAGE_AUX_SYMBOL_TOKEN_DEF::SymbolTableIndex"]
        [::std::mem::offset_of!(IMAGE_AUX_SYMBOL_TOKEN_DEF, SymbolTableIndex) - 2usize];
    ["Offset of field: IMAGE_AUX_SYMBOL_TOKEN_DEF::rgbReserved"]
        [::std::mem::offset_of!(IMAGE_AUX_SYMBOL_TOKEN_DEF, rgbReserved) - 6usize];
};
pub type PIMAGE_AUX_SYMBOL_TOKEN_DEF = *mut IMAGE_AUX_SYMBOL_TOKEN_DEF;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_AUX_SYMBOL {
    pub Sym: _IMAGE_AUX_SYMBOL__bindgen_ty_1,
    pub File: _IMAGE_AUX_SYMBOL__bindgen_ty_2,
    pub Section: _IMAGE_AUX_SYMBOL__bindgen_ty_3,
    pub TokenDef: IMAGE_AUX_SYMBOL_TOKEN_DEF,
    pub CRC: _IMAGE_AUX_SYMBOL__bindgen_ty_4,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_1 {
    pub TagIndex: DWORD,
    pub Misc: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1,
    pub FcnAry: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2,
    pub TvIndex: WORD,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1 {
    pub LnSz: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub TotalSize: DWORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub Linenumber: WORD,
    pub Size: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()
            - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::Linenumber"][::std::mem::offset_of!(
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        Linenumber
    )
        - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::Size"][::std::mem::offset_of!(
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        Size
    )
        - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1::LnSz"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1, LnSz) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1::TotalSize"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_1, TotalSize) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2 {
    pub Function: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
    pub Array: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2,
}
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 {
    pub PointerToLinenumber: DWORD,
    pub PointerToNextFunction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1,
    >() - 8usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1>()
            - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1::PointerToLinenumber"] [:: std :: mem :: offset_of ! (_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 , PointerToLinenumber) - 0usize] ;
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1::PointerToNextFunction"] [:: std :: mem :: offset_of ! (_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_1 , PointerToNextFunction) - 4usize] ;
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2 {
    pub Dimension: [WORD; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2"][::std::mem::size_of::<
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2,
    >() - 8usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2>()
            - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2::Dimension"][::std::mem::offset_of!(
        _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2__bindgen_ty_2,
        Dimension
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2::Function"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2, Function) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2::Array"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1__bindgen_ty_2, Array) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1>() - 18usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1::TagIndex"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1, TagIndex) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1::Misc"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1, Misc) - 4usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1::FcnAry"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1, FcnAry) - 8usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_1::TvIndex"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_1, TvIndex) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_2 {
    pub Name: [BYTE; 18usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_2"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_2>() - 18usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_2"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_2>() - 1usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_2::Name"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_2, Name) - 0usize];
};
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_3 {
    pub Length: DWORD,
    pub NumberOfRelocations: WORD,
    pub NumberOfLinenumbers: WORD,
    pub CheckSum: DWORD,
    pub Number: SHORT,
    pub Selection: BYTE,
    pub bReserved: BYTE,
    pub HighNumber: SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_3"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_3>() - 18usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_3"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_3>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::Length"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, Length) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::NumberOfRelocations"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, NumberOfRelocations) - 4usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::NumberOfLinenumbers"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, NumberOfLinenumbers) - 6usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::CheckSum"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, CheckSum) - 8usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::Number"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, Number) - 12usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::Selection"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, Selection) - 14usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::bReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, bReserved) - 15usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_3::HighNumber"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_3, HighNumber) - 16usize];
};
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL__bindgen_ty_4 {
    pub crc: DWORD,
    pub rgbReserved: [BYTE; 14usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL__bindgen_ty_4"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_4>() - 18usize];
    ["Alignment of _IMAGE_AUX_SYMBOL__bindgen_ty_4"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL__bindgen_ty_4>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_4::crc"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_4, crc) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL__bindgen_ty_4::rgbReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL__bindgen_ty_4, rgbReserved) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL"][::std::mem::size_of::<_IMAGE_AUX_SYMBOL>() - 18usize];
    ["Alignment of _IMAGE_AUX_SYMBOL"][::std::mem::align_of::<_IMAGE_AUX_SYMBOL>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL::Sym"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL, Sym) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL::File"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL, File) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL::Section"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL, Section) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL::TokenDef"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL, TokenDef) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL::CRC"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL, CRC) - 0usize];
};
pub type IMAGE_AUX_SYMBOL = _IMAGE_AUX_SYMBOL;
pub type PIMAGE_AUX_SYMBOL = *mut IMAGE_AUX_SYMBOL;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_AUX_SYMBOL_EX {
    pub Sym: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1,
    pub File: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_2,
    pub Section: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3,
    pub __bindgen_anon_1: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4,
    pub CRC: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5,
}
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1 {
    pub WeakDefaultSymIndex: DWORD,
    pub WeakSearchType: DWORD,
    pub rgbReserved: [BYTE; 12usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_1>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1::WeakDefaultSymIndex"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_1, WeakDefaultSymIndex) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1::WeakSearchType"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_1, WeakSearchType) - 4usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_1::rgbReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_1, rgbReserved) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL_EX__bindgen_ty_2 {
    pub Name: [BYTE; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_2"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_2>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_2"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_2>() - 1usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_2::Name"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_2, Name) - 0usize];
};
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3 {
    pub Length: DWORD,
    pub NumberOfRelocations: WORD,
    pub NumberOfLinenumbers: WORD,
    pub CheckSum: DWORD,
    pub Number: SHORT,
    pub Selection: BYTE,
    pub bReserved: BYTE,
    pub HighNumber: SHORT,
    pub rgbReserved: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::Length"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, Length) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::NumberOfRelocations"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, NumberOfRelocations) - 4usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::NumberOfLinenumbers"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, NumberOfLinenumbers) - 6usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::CheckSum"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, CheckSum) - 8usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::Number"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, Number) - 12usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::Selection"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, Selection) - 14usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::bReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, bReserved) - 15usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::HighNumber"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, HighNumber) - 16usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_3::rgbReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_3, rgbReserved) - 18usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4 {
    pub TokenDef: IMAGE_AUX_SYMBOL_TOKEN_DEF,
    pub rgbReserved: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_4>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_4>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4::TokenDef"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_4, TokenDef) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_4::rgbReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_4, rgbReserved) - 18usize];
};
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5 {
    pub crc: DWORD,
    pub rgbReserved: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5"]
        [::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_5>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5"]
        [::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX__bindgen_ty_5>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5::crc"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_5, crc) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX__bindgen_ty_5::rgbReserved"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX__bindgen_ty_5, rgbReserved) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_AUX_SYMBOL_EX"][::std::mem::size_of::<_IMAGE_AUX_SYMBOL_EX>() - 20usize];
    ["Alignment of _IMAGE_AUX_SYMBOL_EX"][::std::mem::align_of::<_IMAGE_AUX_SYMBOL_EX>() - 2usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX::Sym"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX, Sym) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX::File"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX, File) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX::Section"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX, Section) - 0usize];
    ["Offset of field: _IMAGE_AUX_SYMBOL_EX::CRC"]
        [::std::mem::offset_of!(_IMAGE_AUX_SYMBOL_EX, CRC) - 0usize];
};
pub type IMAGE_AUX_SYMBOL_EX = _IMAGE_AUX_SYMBOL_EX;
pub type PIMAGE_AUX_SYMBOL_EX = *mut IMAGE_AUX_SYMBOL_EX;
pub const IMAGE_AUX_SYMBOL_TYPE_IMAGE_AUX_SYMBOL_TYPE_TOKEN_DEF: IMAGE_AUX_SYMBOL_TYPE = 1;
pub type IMAGE_AUX_SYMBOL_TYPE = ::std::os::raw::c_int;
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub struct _IMAGE_RELOCATION {
    pub __bindgen_anon_1: _IMAGE_RELOCATION__bindgen_ty_1,
    pub SymbolTableIndex: DWORD,
    pub Type: WORD,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union _IMAGE_RELOCATION__bindgen_ty_1 {
    pub VirtualAddress: DWORD,
    pub RelocCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RELOCATION__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_RELOCATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_RELOCATION__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_RELOCATION__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_RELOCATION__bindgen_ty_1::VirtualAddress"]
        [::std::mem::offset_of!(_IMAGE_RELOCATION__bindgen_ty_1, VirtualAddress) - 0usize];
    ["Offset of field: _IMAGE_RELOCATION__bindgen_ty_1::RelocCount"]
        [::std::mem::offset_of!(_IMAGE_RELOCATION__bindgen_ty_1, RelocCount) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RELOCATION"][::std::mem::size_of::<_IMAGE_RELOCATION>() - 10usize];
    ["Alignment of _IMAGE_RELOCATION"][::std::mem::align_of::<_IMAGE_RELOCATION>() - 2usize];
    ["Offset of field: _IMAGE_RELOCATION::SymbolTableIndex"]
        [::std::mem::offset_of!(_IMAGE_RELOCATION, SymbolTableIndex) - 4usize];
    ["Offset of field: _IMAGE_RELOCATION::Type"]
        [::std::mem::offset_of!(_IMAGE_RELOCATION, Type) - 8usize];
};
pub type IMAGE_RELOCATION = _IMAGE_RELOCATION;
pub type PIMAGE_RELOCATION = *mut IMAGE_RELOCATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_LINENUMBER {
    pub Type: _IMAGE_LINENUMBER__bindgen_ty_1,
    pub Linenumber: WORD,
}
#[repr(C, packed(2))]
#[derive(Copy, Clone)]
pub union _IMAGE_LINENUMBER__bindgen_ty_1 {
    pub SymbolTableIndex: DWORD,
    pub VirtualAddress: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_LINENUMBER__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_LINENUMBER__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_LINENUMBER__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_LINENUMBER__bindgen_ty_1>() - 2usize];
    ["Offset of field: _IMAGE_LINENUMBER__bindgen_ty_1::SymbolTableIndex"]
        [::std::mem::offset_of!(_IMAGE_LINENUMBER__bindgen_ty_1, SymbolTableIndex) - 0usize];
    ["Offset of field: _IMAGE_LINENUMBER__bindgen_ty_1::VirtualAddress"]
        [::std::mem::offset_of!(_IMAGE_LINENUMBER__bindgen_ty_1, VirtualAddress) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_LINENUMBER"][::std::mem::size_of::<_IMAGE_LINENUMBER>() - 6usize];
    ["Alignment of _IMAGE_LINENUMBER"][::std::mem::align_of::<_IMAGE_LINENUMBER>() - 2usize];
    ["Offset of field: _IMAGE_LINENUMBER::Type"]
        [::std::mem::offset_of!(_IMAGE_LINENUMBER, Type) - 0usize];
    ["Offset of field: _IMAGE_LINENUMBER::Linenumber"]
        [::std::mem::offset_of!(_IMAGE_LINENUMBER, Linenumber) - 4usize];
};
pub type IMAGE_LINENUMBER = _IMAGE_LINENUMBER;
pub type PIMAGE_LINENUMBER = *mut IMAGE_LINENUMBER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_BASE_RELOCATION {
    pub VirtualAddress: DWORD,
    pub SizeOfBlock: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_BASE_RELOCATION"][::std::mem::size_of::<_IMAGE_BASE_RELOCATION>() - 8usize];
    ["Alignment of _IMAGE_BASE_RELOCATION"]
        [::std::mem::align_of::<_IMAGE_BASE_RELOCATION>() - 4usize];
    ["Offset of field: _IMAGE_BASE_RELOCATION::VirtualAddress"]
        [::std::mem::offset_of!(_IMAGE_BASE_RELOCATION, VirtualAddress) - 0usize];
    ["Offset of field: _IMAGE_BASE_RELOCATION::SizeOfBlock"]
        [::std::mem::offset_of!(_IMAGE_BASE_RELOCATION, SizeOfBlock) - 4usize];
};
pub type IMAGE_BASE_RELOCATION = _IMAGE_BASE_RELOCATION;
pub type PIMAGE_BASE_RELOCATION = *mut IMAGE_BASE_RELOCATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ARCHIVE_MEMBER_HEADER {
    pub Name: [BYTE; 16usize],
    pub Date: [BYTE; 12usize],
    pub UserID: [BYTE; 6usize],
    pub GroupID: [BYTE; 6usize],
    pub Mode: [BYTE; 8usize],
    pub Size: [BYTE; 10usize],
    pub EndHeader: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARCHIVE_MEMBER_HEADER"]
        [::std::mem::size_of::<_IMAGE_ARCHIVE_MEMBER_HEADER>() - 60usize];
    ["Alignment of _IMAGE_ARCHIVE_MEMBER_HEADER"]
        [::std::mem::align_of::<_IMAGE_ARCHIVE_MEMBER_HEADER>() - 1usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::Name"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, Name) - 0usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::Date"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, Date) - 16usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::UserID"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, UserID) - 28usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::GroupID"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, GroupID) - 34usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::Mode"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, Mode) - 40usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::Size"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, Size) - 48usize];
    ["Offset of field: _IMAGE_ARCHIVE_MEMBER_HEADER::EndHeader"]
        [::std::mem::offset_of!(_IMAGE_ARCHIVE_MEMBER_HEADER, EndHeader) - 58usize];
};
pub type IMAGE_ARCHIVE_MEMBER_HEADER = _IMAGE_ARCHIVE_MEMBER_HEADER;
pub type PIMAGE_ARCHIVE_MEMBER_HEADER = *mut _IMAGE_ARCHIVE_MEMBER_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_EXPORT_DIRECTORY {
    pub Characteristics: DWORD,
    pub TimeDateStamp: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub Name: DWORD,
    pub Base: DWORD,
    pub NumberOfFunctions: DWORD,
    pub NumberOfNames: DWORD,
    pub AddressOfFunctions: DWORD,
    pub AddressOfNames: DWORD,
    pub AddressOfNameOrdinals: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_EXPORT_DIRECTORY"][::std::mem::size_of::<_IMAGE_EXPORT_DIRECTORY>() - 40usize];
    ["Alignment of _IMAGE_EXPORT_DIRECTORY"]
        [::std::mem::align_of::<_IMAGE_EXPORT_DIRECTORY>() - 4usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, Characteristics) - 0usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::MajorVersion"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, MajorVersion) - 8usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::MinorVersion"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, MinorVersion) - 10usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::Name"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, Name) - 12usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::Base"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, Base) - 16usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::NumberOfFunctions"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, NumberOfFunctions) - 20usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::NumberOfNames"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, NumberOfNames) - 24usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::AddressOfFunctions"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, AddressOfFunctions) - 28usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::AddressOfNames"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, AddressOfNames) - 32usize];
    ["Offset of field: _IMAGE_EXPORT_DIRECTORY::AddressOfNameOrdinals"]
        [::std::mem::offset_of!(_IMAGE_EXPORT_DIRECTORY, AddressOfNameOrdinals) - 36usize];
};
pub type IMAGE_EXPORT_DIRECTORY = _IMAGE_EXPORT_DIRECTORY;
pub type PIMAGE_EXPORT_DIRECTORY = *mut _IMAGE_EXPORT_DIRECTORY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_IMPORT_BY_NAME {
    pub Hint: WORD,
    pub Name: [CHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_IMPORT_BY_NAME"][::std::mem::size_of::<_IMAGE_IMPORT_BY_NAME>() - 4usize];
    ["Alignment of _IMAGE_IMPORT_BY_NAME"]
        [::std::mem::align_of::<_IMAGE_IMPORT_BY_NAME>() - 2usize];
    ["Offset of field: _IMAGE_IMPORT_BY_NAME::Hint"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_BY_NAME, Hint) - 0usize];
    ["Offset of field: _IMAGE_IMPORT_BY_NAME::Name"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_BY_NAME, Name) - 2usize];
};
pub type IMAGE_IMPORT_BY_NAME = _IMAGE_IMPORT_BY_NAME;
pub type PIMAGE_IMPORT_BY_NAME = *mut _IMAGE_IMPORT_BY_NAME;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_THUNK_DATA64 {
    pub u1: _IMAGE_THUNK_DATA64__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_THUNK_DATA64__bindgen_ty_1 {
    pub ForwarderString: ULONGLONG,
    pub Function: ULONGLONG,
    pub Ordinal: ULONGLONG,
    pub AddressOfData: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_THUNK_DATA64__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_THUNK_DATA64__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_THUNK_DATA64__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_THUNK_DATA64__bindgen_ty_1>() - 8usize];
    ["Offset of field: _IMAGE_THUNK_DATA64__bindgen_ty_1::ForwarderString"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA64__bindgen_ty_1, ForwarderString) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA64__bindgen_ty_1::Function"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA64__bindgen_ty_1, Function) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA64__bindgen_ty_1::Ordinal"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA64__bindgen_ty_1, Ordinal) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA64__bindgen_ty_1::AddressOfData"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA64__bindgen_ty_1, AddressOfData) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_THUNK_DATA64"][::std::mem::size_of::<_IMAGE_THUNK_DATA64>() - 8usize];
    ["Alignment of _IMAGE_THUNK_DATA64"][::std::mem::align_of::<_IMAGE_THUNK_DATA64>() - 8usize];
    ["Offset of field: _IMAGE_THUNK_DATA64::u1"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA64, u1) - 0usize];
};
pub type IMAGE_THUNK_DATA64 = _IMAGE_THUNK_DATA64;
pub type PIMAGE_THUNK_DATA64 = *mut IMAGE_THUNK_DATA64;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_THUNK_DATA32 {
    pub u1: _IMAGE_THUNK_DATA32__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_THUNK_DATA32__bindgen_ty_1 {
    pub ForwarderString: DWORD,
    pub Function: DWORD,
    pub Ordinal: DWORD,
    pub AddressOfData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_THUNK_DATA32__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_THUNK_DATA32__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_THUNK_DATA32__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_THUNK_DATA32__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_THUNK_DATA32__bindgen_ty_1::ForwarderString"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA32__bindgen_ty_1, ForwarderString) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA32__bindgen_ty_1::Function"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA32__bindgen_ty_1, Function) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA32__bindgen_ty_1::Ordinal"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA32__bindgen_ty_1, Ordinal) - 0usize];
    ["Offset of field: _IMAGE_THUNK_DATA32__bindgen_ty_1::AddressOfData"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA32__bindgen_ty_1, AddressOfData) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_THUNK_DATA32"][::std::mem::size_of::<_IMAGE_THUNK_DATA32>() - 4usize];
    ["Alignment of _IMAGE_THUNK_DATA32"][::std::mem::align_of::<_IMAGE_THUNK_DATA32>() - 4usize];
    ["Offset of field: _IMAGE_THUNK_DATA32::u1"]
        [::std::mem::offset_of!(_IMAGE_THUNK_DATA32, u1) - 0usize];
};
pub type IMAGE_THUNK_DATA32 = _IMAGE_THUNK_DATA32;
pub type PIMAGE_THUNK_DATA32 = *mut IMAGE_THUNK_DATA32;
pub type PIMAGE_TLS_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(DllHandle: PVOID, Reason: DWORD, Reserved: PVOID)>;
pub type IMAGE_THUNK_DATA = IMAGE_THUNK_DATA64;
pub type PIMAGE_THUNK_DATA = PIMAGE_THUNK_DATA64;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_IMPORT_DESCRIPTOR {
    pub __bindgen_anon_1: _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1,
    pub TimeDateStamp: DWORD,
    pub ForwarderChain: DWORD,
    pub Name: DWORD,
    pub FirstThunk: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1 {
    pub Characteristics: DWORD,
    pub OriginalFirstThunk: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1, Characteristics) - 0usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1::OriginalFirstThunk"][::std::mem::offset_of!(
        _IMAGE_IMPORT_DESCRIPTOR__bindgen_ty_1,
        OriginalFirstThunk
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_IMPORT_DESCRIPTOR"]
        [::std::mem::size_of::<_IMAGE_IMPORT_DESCRIPTOR>() - 20usize];
    ["Alignment of _IMAGE_IMPORT_DESCRIPTOR"]
        [::std::mem::align_of::<_IMAGE_IMPORT_DESCRIPTOR>() - 4usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_DESCRIPTOR, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR::ForwarderChain"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_DESCRIPTOR, ForwarderChain) - 8usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR::Name"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_DESCRIPTOR, Name) - 12usize];
    ["Offset of field: _IMAGE_IMPORT_DESCRIPTOR::FirstThunk"]
        [::std::mem::offset_of!(_IMAGE_IMPORT_DESCRIPTOR, FirstThunk) - 16usize];
};
pub type IMAGE_IMPORT_DESCRIPTOR = _IMAGE_IMPORT_DESCRIPTOR;
pub type PIMAGE_IMPORT_DESCRIPTOR = *mut IMAGE_IMPORT_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_BOUND_IMPORT_DESCRIPTOR {
    pub TimeDateStamp: DWORD,
    pub OffsetModuleName: WORD,
    pub NumberOfModuleForwarderRefs: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_BOUND_IMPORT_DESCRIPTOR"]
        [::std::mem::size_of::<_IMAGE_BOUND_IMPORT_DESCRIPTOR>() - 8usize];
    ["Alignment of _IMAGE_BOUND_IMPORT_DESCRIPTOR"]
        [::std::mem::align_of::<_IMAGE_BOUND_IMPORT_DESCRIPTOR>() - 4usize];
    ["Offset of field: _IMAGE_BOUND_IMPORT_DESCRIPTOR::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_BOUND_IMPORT_DESCRIPTOR, TimeDateStamp) - 0usize];
    ["Offset of field: _IMAGE_BOUND_IMPORT_DESCRIPTOR::OffsetModuleName"]
        [::std::mem::offset_of!(_IMAGE_BOUND_IMPORT_DESCRIPTOR, OffsetModuleName) - 4usize];
    ["Offset of field: _IMAGE_BOUND_IMPORT_DESCRIPTOR::NumberOfModuleForwarderRefs"][::std::mem::offset_of!(
        _IMAGE_BOUND_IMPORT_DESCRIPTOR,
        NumberOfModuleForwarderRefs
    ) - 6usize];
};
pub type IMAGE_BOUND_IMPORT_DESCRIPTOR = _IMAGE_BOUND_IMPORT_DESCRIPTOR;
pub type PIMAGE_BOUND_IMPORT_DESCRIPTOR = *mut _IMAGE_BOUND_IMPORT_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_BOUND_FORWARDER_REF {
    pub TimeDateStamp: DWORD,
    pub OffsetModuleName: WORD,
    pub Reserved: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_BOUND_FORWARDER_REF"]
        [::std::mem::size_of::<_IMAGE_BOUND_FORWARDER_REF>() - 8usize];
    ["Alignment of _IMAGE_BOUND_FORWARDER_REF"]
        [::std::mem::align_of::<_IMAGE_BOUND_FORWARDER_REF>() - 4usize];
    ["Offset of field: _IMAGE_BOUND_FORWARDER_REF::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_BOUND_FORWARDER_REF, TimeDateStamp) - 0usize];
    ["Offset of field: _IMAGE_BOUND_FORWARDER_REF::OffsetModuleName"]
        [::std::mem::offset_of!(_IMAGE_BOUND_FORWARDER_REF, OffsetModuleName) - 4usize];
    ["Offset of field: _IMAGE_BOUND_FORWARDER_REF::Reserved"]
        [::std::mem::offset_of!(_IMAGE_BOUND_FORWARDER_REF, Reserved) - 6usize];
};
pub type IMAGE_BOUND_FORWARDER_REF = _IMAGE_BOUND_FORWARDER_REF;
pub type PIMAGE_BOUND_FORWARDER_REF = *mut _IMAGE_BOUND_FORWARDER_REF;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_DELAYLOAD_DESCRIPTOR {
    pub Attributes: _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1,
    pub DllNameRVA: DWORD,
    pub ModuleHandleRVA: DWORD,
    pub ImportAddressTableRVA: DWORD,
    pub ImportNameTableRVA: DWORD,
    pub BoundImportAddressTableRVA: DWORD,
    pub UnloadInformationTableRVA: DWORD,
    pub TimeDateStamp: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1 {
    pub AllAttributes: DWORD,
    pub __bindgen_anon_1: _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
};
impl _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn RvaBased(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_RvaBased(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RvaBased_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RvaBased_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ReservedAttributes(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_ReservedAttributes(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReservedAttributes_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ReservedAttributes_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        RvaBased: DWORD,
        ReservedAttributes: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let RvaBased: u32 = unsafe { ::std::mem::transmute(RvaBased) };
            RvaBased as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let ReservedAttributes: u32 = unsafe { ::std::mem::transmute(ReservedAttributes) };
            ReservedAttributes as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1::AllAttributes"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR__bindgen_ty_1, AllAttributes) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DELAYLOAD_DESCRIPTOR"]
        [::std::mem::size_of::<_IMAGE_DELAYLOAD_DESCRIPTOR>() - 32usize];
    ["Alignment of _IMAGE_DELAYLOAD_DESCRIPTOR"]
        [::std::mem::align_of::<_IMAGE_DELAYLOAD_DESCRIPTOR>() - 4usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::Attributes"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, Attributes) - 0usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::DllNameRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, DllNameRVA) - 4usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::ModuleHandleRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, ModuleHandleRVA) - 8usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::ImportAddressTableRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, ImportAddressTableRVA) - 12usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::ImportNameTableRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, ImportNameTableRVA) - 16usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::BoundImportAddressTableRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, BoundImportAddressTableRVA) - 20usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::UnloadInformationTableRVA"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, UnloadInformationTableRVA) - 24usize];
    ["Offset of field: _IMAGE_DELAYLOAD_DESCRIPTOR::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_DELAYLOAD_DESCRIPTOR, TimeDateStamp) - 28usize];
};
pub type IMAGE_DELAYLOAD_DESCRIPTOR = _IMAGE_DELAYLOAD_DESCRIPTOR;
pub type PIMAGE_DELAYLOAD_DESCRIPTOR = *mut _IMAGE_DELAYLOAD_DESCRIPTOR;
pub type PCIMAGE_DELAYLOAD_DESCRIPTOR = *const IMAGE_DELAYLOAD_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIRECTORY {
    pub Characteristics: DWORD,
    pub TimeDateStamp: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub NumberOfNamedEntries: WORD,
    pub NumberOfIdEntries: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIRECTORY>() - 16usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY>() - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, Characteristics) - 0usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::MajorVersion"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, MajorVersion) - 8usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::MinorVersion"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, MinorVersion) - 10usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::NumberOfNamedEntries"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, NumberOfNamedEntries) - 12usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY::NumberOfIdEntries"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY, NumberOfIdEntries) - 14usize];
};
pub type IMAGE_RESOURCE_DIRECTORY = _IMAGE_RESOURCE_DIRECTORY;
pub type PIMAGE_RESOURCE_DIRECTORY = *mut _IMAGE_RESOURCE_DIRECTORY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIRECTORY_ENTRY {
    pub __bindgen_anon_1: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1,
    pub __bindgen_anon_2: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1 {
    pub __bindgen_anon_1: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1,
    pub Name: DWORD,
    pub Id: WORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn NameOffset(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_NameOffset(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NameOffset_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_NameOffset_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn NameIsString(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_NameIsString(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(31usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NameIsString_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                31usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_NameIsString_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                31usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        NameOffset: DWORD,
        NameIsString: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 31u8, {
            let NameOffset: u32 = unsafe { ::std::mem::transmute(NameOffset) };
            NameOffset as u64
        });
        __bindgen_bitfield_unit.set(31usize, 1u8, {
            let NameIsString: u32 = unsafe { ::std::mem::transmute(NameIsString) };
            NameIsString as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1::Name"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1, Name) - 0usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1::Id"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_1, Id) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2 {
    pub OffsetToData: DWORD,
    pub __bindgen_anon_1: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1>()
            - 4usize];
};
impl _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2__bindgen_ty_1 {
    #[inline]
    pub fn OffsetToDirectory(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_OffsetToDirectory(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn OffsetToDirectory_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_OffsetToDirectory_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DataIsDirectory(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DataIsDirectory(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(31usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DataIsDirectory_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                31usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DataIsDirectory_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                31usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        OffsetToDirectory: DWORD,
        DataIsDirectory: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 31u8, {
            let OffsetToDirectory: u32 = unsafe { ::std::mem::transmute(OffsetToDirectory) };
            OffsetToDirectory as u64
        });
        __bindgen_bitfield_unit.set(31usize, 1u8, {
            let DataIsDirectory: u32 = unsafe { ::std::mem::transmute(DataIsDirectory) };
            DataIsDirectory as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2>() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2>() - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2::OffsetToData"][::std::mem::offset_of!(
        _IMAGE_RESOURCE_DIRECTORY_ENTRY__bindgen_ty_2,
        OffsetToData
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_ENTRY"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY>() - 8usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_ENTRY"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_ENTRY>() - 4usize];
};
pub type IMAGE_RESOURCE_DIRECTORY_ENTRY = _IMAGE_RESOURCE_DIRECTORY_ENTRY;
pub type PIMAGE_RESOURCE_DIRECTORY_ENTRY = *mut _IMAGE_RESOURCE_DIRECTORY_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIRECTORY_STRING {
    pub Length: WORD,
    pub NameString: [CHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIRECTORY_STRING"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIRECTORY_STRING>() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIRECTORY_STRING"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIRECTORY_STRING>() - 2usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY_STRING::Length"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY_STRING, Length) - 0usize];
    ["Offset of field: _IMAGE_RESOURCE_DIRECTORY_STRING::NameString"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIRECTORY_STRING, NameString) - 2usize];
};
pub type IMAGE_RESOURCE_DIRECTORY_STRING = _IMAGE_RESOURCE_DIRECTORY_STRING;
pub type PIMAGE_RESOURCE_DIRECTORY_STRING = *mut _IMAGE_RESOURCE_DIRECTORY_STRING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DIR_STRING_U {
    pub Length: WORD,
    pub NameString: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DIR_STRING_U"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DIR_STRING_U>() - 4usize];
    ["Alignment of _IMAGE_RESOURCE_DIR_STRING_U"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DIR_STRING_U>() - 2usize];
    ["Offset of field: _IMAGE_RESOURCE_DIR_STRING_U::Length"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIR_STRING_U, Length) - 0usize];
    ["Offset of field: _IMAGE_RESOURCE_DIR_STRING_U::NameString"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DIR_STRING_U, NameString) - 2usize];
};
pub type IMAGE_RESOURCE_DIR_STRING_U = _IMAGE_RESOURCE_DIR_STRING_U;
pub type PIMAGE_RESOURCE_DIR_STRING_U = *mut _IMAGE_RESOURCE_DIR_STRING_U;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_RESOURCE_DATA_ENTRY {
    pub OffsetToData: DWORD,
    pub Size: DWORD,
    pub CodePage: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RESOURCE_DATA_ENTRY"]
        [::std::mem::size_of::<_IMAGE_RESOURCE_DATA_ENTRY>() - 16usize];
    ["Alignment of _IMAGE_RESOURCE_DATA_ENTRY"]
        [::std::mem::align_of::<_IMAGE_RESOURCE_DATA_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DATA_ENTRY::OffsetToData"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DATA_ENTRY, OffsetToData) - 0usize];
    ["Offset of field: _IMAGE_RESOURCE_DATA_ENTRY::Size"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DATA_ENTRY, Size) - 4usize];
    ["Offset of field: _IMAGE_RESOURCE_DATA_ENTRY::CodePage"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DATA_ENTRY, CodePage) - 8usize];
    ["Offset of field: _IMAGE_RESOURCE_DATA_ENTRY::Reserved"]
        [::std::mem::offset_of!(_IMAGE_RESOURCE_DATA_ENTRY, Reserved) - 12usize];
};
pub type IMAGE_RESOURCE_DATA_ENTRY = _IMAGE_RESOURCE_DATA_ENTRY;
pub type PIMAGE_RESOURCE_DATA_ENTRY = *mut _IMAGE_RESOURCE_DATA_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_LOAD_CONFIG_CODE_INTEGRITY {
    pub Flags: WORD,
    pub Catalog: WORD,
    pub CatalogOffset: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_LOAD_CONFIG_CODE_INTEGRITY"]
        [::std::mem::size_of::<_IMAGE_LOAD_CONFIG_CODE_INTEGRITY>() - 12usize];
    ["Alignment of _IMAGE_LOAD_CONFIG_CODE_INTEGRITY"]
        [::std::mem::align_of::<_IMAGE_LOAD_CONFIG_CODE_INTEGRITY>() - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_CODE_INTEGRITY::Flags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_CODE_INTEGRITY, Flags) - 0usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_CODE_INTEGRITY::Catalog"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_CODE_INTEGRITY, Catalog) - 2usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_CODE_INTEGRITY::CatalogOffset"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_CODE_INTEGRITY, CatalogOffset) - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_CODE_INTEGRITY::Reserved"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_CODE_INTEGRITY, Reserved) - 8usize];
};
pub type IMAGE_LOAD_CONFIG_CODE_INTEGRITY = _IMAGE_LOAD_CONFIG_CODE_INTEGRITY;
pub type PIMAGE_LOAD_CONFIG_CODE_INTEGRITY = *mut _IMAGE_LOAD_CONFIG_CODE_INTEGRITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DYNAMIC_RELOCATION_TABLE {
    pub Version: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DYNAMIC_RELOCATION_TABLE"]
        [::std::mem::size_of::<_IMAGE_DYNAMIC_RELOCATION_TABLE>() - 8usize];
    ["Alignment of _IMAGE_DYNAMIC_RELOCATION_TABLE"]
        [::std::mem::align_of::<_IMAGE_DYNAMIC_RELOCATION_TABLE>() - 4usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION_TABLE::Version"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION_TABLE, Version) - 0usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION_TABLE::Size"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION_TABLE, Size) - 4usize];
};
pub type IMAGE_DYNAMIC_RELOCATION_TABLE = _IMAGE_DYNAMIC_RELOCATION_TABLE;
pub type PIMAGE_DYNAMIC_RELOCATION_TABLE = *mut _IMAGE_DYNAMIC_RELOCATION_TABLE;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DYNAMIC_RELOCATION32 {
    pub Symbol: DWORD,
    pub BaseRelocSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DYNAMIC_RELOCATION32"]
        [::std::mem::size_of::<_IMAGE_DYNAMIC_RELOCATION32>() - 8usize];
    ["Alignment of _IMAGE_DYNAMIC_RELOCATION32"]
        [::std::mem::align_of::<_IMAGE_DYNAMIC_RELOCATION32>() - 1usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32::Symbol"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32, Symbol) - 0usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32::BaseRelocSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32, BaseRelocSize) - 4usize];
};
pub type IMAGE_DYNAMIC_RELOCATION32 = _IMAGE_DYNAMIC_RELOCATION32;
pub type PIMAGE_DYNAMIC_RELOCATION32 = *mut _IMAGE_DYNAMIC_RELOCATION32;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DYNAMIC_RELOCATION64 {
    pub Symbol: ULONGLONG,
    pub BaseRelocSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DYNAMIC_RELOCATION64"]
        [::std::mem::size_of::<_IMAGE_DYNAMIC_RELOCATION64>() - 12usize];
    ["Alignment of _IMAGE_DYNAMIC_RELOCATION64"]
        [::std::mem::align_of::<_IMAGE_DYNAMIC_RELOCATION64>() - 1usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64::Symbol"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64, Symbol) - 0usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64::BaseRelocSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64, BaseRelocSize) - 8usize];
};
pub type IMAGE_DYNAMIC_RELOCATION64 = _IMAGE_DYNAMIC_RELOCATION64;
pub type PIMAGE_DYNAMIC_RELOCATION64 = *mut _IMAGE_DYNAMIC_RELOCATION64;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DYNAMIC_RELOCATION32_V2 {
    pub HeaderSize: DWORD,
    pub FixupInfoSize: DWORD,
    pub Symbol: DWORD,
    pub SymbolGroup: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DYNAMIC_RELOCATION32_V2"]
        [::std::mem::size_of::<_IMAGE_DYNAMIC_RELOCATION32_V2>() - 20usize];
    ["Alignment of _IMAGE_DYNAMIC_RELOCATION32_V2"]
        [::std::mem::align_of::<_IMAGE_DYNAMIC_RELOCATION32_V2>() - 1usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32_V2::HeaderSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32_V2, HeaderSize) - 0usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32_V2::FixupInfoSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32_V2, FixupInfoSize) - 4usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32_V2::Symbol"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32_V2, Symbol) - 8usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32_V2::SymbolGroup"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32_V2, SymbolGroup) - 12usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION32_V2::Flags"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION32_V2, Flags) - 16usize];
};
pub type IMAGE_DYNAMIC_RELOCATION32_V2 = _IMAGE_DYNAMIC_RELOCATION32_V2;
pub type PIMAGE_DYNAMIC_RELOCATION32_V2 = *mut _IMAGE_DYNAMIC_RELOCATION32_V2;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DYNAMIC_RELOCATION64_V2 {
    pub HeaderSize: DWORD,
    pub FixupInfoSize: DWORD,
    pub Symbol: ULONGLONG,
    pub SymbolGroup: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DYNAMIC_RELOCATION64_V2"]
        [::std::mem::size_of::<_IMAGE_DYNAMIC_RELOCATION64_V2>() - 24usize];
    ["Alignment of _IMAGE_DYNAMIC_RELOCATION64_V2"]
        [::std::mem::align_of::<_IMAGE_DYNAMIC_RELOCATION64_V2>() - 1usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64_V2::HeaderSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64_V2, HeaderSize) - 0usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64_V2::FixupInfoSize"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64_V2, FixupInfoSize) - 4usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64_V2::Symbol"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64_V2, Symbol) - 8usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64_V2::SymbolGroup"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64_V2, SymbolGroup) - 16usize];
    ["Offset of field: _IMAGE_DYNAMIC_RELOCATION64_V2::Flags"]
        [::std::mem::offset_of!(_IMAGE_DYNAMIC_RELOCATION64_V2, Flags) - 20usize];
};
pub type IMAGE_DYNAMIC_RELOCATION64_V2 = _IMAGE_DYNAMIC_RELOCATION64_V2;
pub type PIMAGE_DYNAMIC_RELOCATION64_V2 = *mut _IMAGE_DYNAMIC_RELOCATION64_V2;
pub type IMAGE_DYNAMIC_RELOCATION = IMAGE_DYNAMIC_RELOCATION64;
pub type PIMAGE_DYNAMIC_RELOCATION = PIMAGE_DYNAMIC_RELOCATION64;
pub type IMAGE_DYNAMIC_RELOCATION_V2 = IMAGE_DYNAMIC_RELOCATION64_V2;
pub type PIMAGE_DYNAMIC_RELOCATION_V2 = PIMAGE_DYNAMIC_RELOCATION64_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER {
    pub PrologueByteCount: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER"]
        [::std::mem::size_of::<_IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER>() - 1usize];
    ["Alignment of _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER"]
        [::std::mem::align_of::<_IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER>() - 1usize];
    ["Offset of field: _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER::PrologueByteCount"][::std::mem::offset_of!(
        _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER,
        PrologueByteCount
    ) - 0usize];
};
pub type IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER = _IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER;
pub type PIMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER = *mut IMAGE_PROLOGUE_DYNAMIC_RELOCATION_HEADER;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER {
    pub EpilogueCount: DWORD,
    pub EpilogueByteCount: BYTE,
    pub BranchDescriptorElementSize: BYTE,
    pub BranchDescriptorCount: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER"]
        [::std::mem::size_of::<_IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER>() - 8usize];
    ["Alignment of _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER"]
        [::std::mem::align_of::<_IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER>() - 1usize];
    ["Offset of field: _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER::EpilogueCount"]
        [::std::mem::offset_of!(_IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER, EpilogueCount) - 0usize];
    ["Offset of field: _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER::EpilogueByteCount"][::std::mem::offset_of!(
        _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER,
        EpilogueByteCount
    ) - 4usize];
    ["Offset of field: _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER::BranchDescriptorElementSize"][::std::mem::offset_of!(
        _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER,
        BranchDescriptorElementSize
    )
        - 5usize];
    ["Offset of field: _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER::BranchDescriptorCount"][::std::mem::offset_of!(
        _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER,
        BranchDescriptorCount
    )
        - 6usize];
};
pub type IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER = _IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER;
pub type PIMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER = *mut IMAGE_EPILOGUE_DYNAMIC_RELOCATION_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION"]
        [::std::mem::size_of::<_IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION>() - 4usize];
    ["Alignment of _IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION"]
        [::std::mem::align_of::<_IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION>() - 1usize];
};
impl _IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION {
    #[inline]
    pub fn PageRelativeOffset(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u32) }
    }
    #[inline]
    pub fn set_PageRelativeOffset(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PageRelativeOffset_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_PageRelativeOffset_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IndirectCall(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_IndirectCall(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IndirectCall_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IndirectCall_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IATIndex(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 19u8) as u32) }
    }
    #[inline]
    pub fn set_IATIndex(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 19u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IATIndex_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                19u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IATIndex_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                19u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        PageRelativeOffset: DWORD,
        IndirectCall: DWORD,
        IATIndex: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let PageRelativeOffset: u32 = unsafe { ::std::mem::transmute(PageRelativeOffset) };
            PageRelativeOffset as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let IndirectCall: u32 = unsafe { ::std::mem::transmute(IndirectCall) };
            IndirectCall as u64
        });
        __bindgen_bitfield_unit.set(13usize, 19u8, {
            let IATIndex: u32 = unsafe { ::std::mem::transmute(IATIndex) };
            IATIndex as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION =
    _IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION;
pub type PIMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION =
    *mut IMAGE_IMPORT_CONTROL_TRANSFER_DYNAMIC_RELOCATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION"]
        [::std::mem::size_of::<_IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION>() - 2usize];
    ["Alignment of _IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION"]
        [::std::mem::align_of::<_IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION>() - 1usize];
};
impl _IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION {
    #[inline]
    pub fn PageRelativeOffset(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn set_PageRelativeOffset(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PageRelativeOffset_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_PageRelativeOffset_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IndirectCall(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_IndirectCall(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IndirectCall_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_IndirectCall_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn RexWPrefix(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_RexWPrefix(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RexWPrefix_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_RexWPrefix_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn CfgCheck(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_CfgCheck(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn CfgCheck_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_CfgCheck_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        PageRelativeOffset: WORD,
        IndirectCall: WORD,
        RexWPrefix: WORD,
        CfgCheck: WORD,
        Reserved: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let PageRelativeOffset: u16 = unsafe { ::std::mem::transmute(PageRelativeOffset) };
            PageRelativeOffset as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let IndirectCall: u16 = unsafe { ::std::mem::transmute(IndirectCall) };
            IndirectCall as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let RexWPrefix: u16 = unsafe { ::std::mem::transmute(RexWPrefix) };
            RexWPrefix as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let CfgCheck: u16 = unsafe { ::std::mem::transmute(CfgCheck) };
            CfgCheck as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let Reserved: u16 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION =
    _IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION;
pub type PIMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION =
    *mut IMAGE_INDIR_CONTROL_TRANSFER_DYNAMIC_RELOCATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION"]
        [::std::mem::size_of::<_IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION>() - 2usize];
    ["Alignment of _IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION"]
        [::std::mem::align_of::<_IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION>() - 1usize];
};
impl _IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION {
    #[inline]
    pub fn PageRelativeOffset(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn set_PageRelativeOffset(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PageRelativeOffset_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_PageRelativeOffset_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn RegisterNumber(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 4u8) as u16) }
    }
    #[inline]
    pub fn set_RegisterNumber(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RegisterNumber_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                4u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_RegisterNumber_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        PageRelativeOffset: WORD,
        RegisterNumber: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let PageRelativeOffset: u16 = unsafe { ::std::mem::transmute(PageRelativeOffset) };
            PageRelativeOffset as u64
        });
        __bindgen_bitfield_unit.set(12usize, 4u8, {
            let RegisterNumber: u16 = unsafe { ::std::mem::transmute(RegisterNumber) };
            RegisterNumber as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION = _IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION;
pub type PIMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION =
    *mut IMAGE_SWITCHTABLE_BRANCH_DYNAMIC_RELOCATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_LOAD_CONFIG_DIRECTORY32 {
    pub Size: DWORD,
    pub TimeDateStamp: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub GlobalFlagsClear: DWORD,
    pub GlobalFlagsSet: DWORD,
    pub CriticalSectionDefaultTimeout: DWORD,
    pub DeCommitFreeBlockThreshold: DWORD,
    pub DeCommitTotalFreeThreshold: DWORD,
    pub LockPrefixTable: DWORD,
    pub MaximumAllocationSize: DWORD,
    pub VirtualMemoryThreshold: DWORD,
    pub ProcessHeapFlags: DWORD,
    pub ProcessAffinityMask: DWORD,
    pub CSDVersion: WORD,
    pub DependentLoadFlags: WORD,
    pub EditList: DWORD,
    pub SecurityCookie: DWORD,
    pub SEHandlerTable: DWORD,
    pub SEHandlerCount: DWORD,
    pub GuardCFCheckFunctionPointer: DWORD,
    pub GuardCFDispatchFunctionPointer: DWORD,
    pub GuardCFFunctionTable: DWORD,
    pub GuardCFFunctionCount: DWORD,
    pub GuardFlags: DWORD,
    pub CodeIntegrity: IMAGE_LOAD_CONFIG_CODE_INTEGRITY,
    pub GuardAddressTakenIatEntryTable: DWORD,
    pub GuardAddressTakenIatEntryCount: DWORD,
    pub GuardLongJumpTargetTable: DWORD,
    pub GuardLongJumpTargetCount: DWORD,
    pub DynamicValueRelocTable: DWORD,
    pub CHPEMetadataPointer: DWORD,
    pub GuardRFFailureRoutine: DWORD,
    pub GuardRFFailureRoutineFunctionPointer: DWORD,
    pub DynamicValueRelocTableOffset: DWORD,
    pub DynamicValueRelocTableSection: WORD,
    pub Reserved2: WORD,
    pub GuardRFVerifyStackPointerFunctionPointer: DWORD,
    pub HotPatchTableOffset: DWORD,
    pub Reserved3: DWORD,
    pub EnclaveConfigurationPointer: DWORD,
    pub VolatileMetadataPointer: DWORD,
    pub GuardEHContinuationTable: DWORD,
    pub GuardEHContinuationCount: DWORD,
    pub GuardXFGCheckFunctionPointer: DWORD,
    pub GuardXFGDispatchFunctionPointer: DWORD,
    pub GuardXFGTableDispatchFunctionPointer: DWORD,
    pub CastGuardOsDeterminedFailureMode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_LOAD_CONFIG_DIRECTORY32"]
        [::std::mem::size_of::<_IMAGE_LOAD_CONFIG_DIRECTORY32>() - 188usize];
    ["Alignment of _IMAGE_LOAD_CONFIG_DIRECTORY32"]
        [::std::mem::align_of::<_IMAGE_LOAD_CONFIG_DIRECTORY32>() - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::Size"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, Size) - 0usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::MajorVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, MajorVersion) - 8usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::MinorVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, MinorVersion) - 10usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GlobalFlagsClear"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GlobalFlagsClear) - 12usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GlobalFlagsSet"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GlobalFlagsSet) - 16usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::CriticalSectionDefaultTimeout"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        CriticalSectionDefaultTimeout
    ) - 20usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DeCommitFreeBlockThreshold"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        DeCommitFreeBlockThreshold
    ) - 24usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DeCommitTotalFreeThreshold"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        DeCommitTotalFreeThreshold
    ) - 28usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::LockPrefixTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, LockPrefixTable) - 32usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::MaximumAllocationSize"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, MaximumAllocationSize) - 36usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::VirtualMemoryThreshold"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, VirtualMemoryThreshold) - 40usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::ProcessHeapFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, ProcessHeapFlags) - 44usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::ProcessAffinityMask"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, ProcessAffinityMask) - 48usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::CSDVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, CSDVersion) - 52usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DependentLoadFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, DependentLoadFlags) - 54usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::EditList"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, EditList) - 56usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::SecurityCookie"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, SecurityCookie) - 60usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::SEHandlerTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, SEHandlerTable) - 64usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::SEHandlerCount"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, SEHandlerCount) - 68usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardCFCheckFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardCFCheckFunctionPointer
    ) - 72usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardCFDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardCFDispatchFunctionPointer
    )
        - 76usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardCFFunctionTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GuardCFFunctionTable) - 80usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardCFFunctionCount"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GuardCFFunctionCount) - 84usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GuardFlags) - 88usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::CodeIntegrity"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, CodeIntegrity) - 92usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardAddressTakenIatEntryTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardAddressTakenIatEntryTable
    )
        - 104usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardAddressTakenIatEntryCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardAddressTakenIatEntryCount
    )
        - 108usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardLongJumpTargetTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardLongJumpTargetTable
    ) - 112usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardLongJumpTargetCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardLongJumpTargetCount
    ) - 116usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DynamicValueRelocTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, DynamicValueRelocTable) - 120usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::CHPEMetadataPointer"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, CHPEMetadataPointer) - 124usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardRFFailureRoutine"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, GuardRFFailureRoutine) - 128usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardRFFailureRoutineFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardRFFailureRoutineFunctionPointer
    )
        - 132usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DynamicValueRelocTableOffset"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        DynamicValueRelocTableOffset
    ) - 136usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::DynamicValueRelocTableSection"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        DynamicValueRelocTableSection
    )
        - 140usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::Reserved2"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, Reserved2) - 142usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardRFVerifyStackPointerFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardRFVerifyStackPointerFunctionPointer
    )
        - 144usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::HotPatchTableOffset"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, HotPatchTableOffset) - 148usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::Reserved3"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY32, Reserved3) - 152usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::EnclaveConfigurationPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        EnclaveConfigurationPointer
    ) - 156usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::VolatileMetadataPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        VolatileMetadataPointer
    ) - 160usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardEHContinuationTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardEHContinuationTable
    ) - 164usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardEHContinuationCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardEHContinuationCount
    ) - 168usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardXFGCheckFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardXFGCheckFunctionPointer
    ) - 172usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardXFGDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardXFGDispatchFunctionPointer
    )
        - 176usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::GuardXFGTableDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        GuardXFGTableDispatchFunctionPointer
    )
        - 180usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY32::CastGuardOsDeterminedFailureMode"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY32,
        CastGuardOsDeterminedFailureMode
    )
        - 184usize];
};
pub type IMAGE_LOAD_CONFIG_DIRECTORY32 = _IMAGE_LOAD_CONFIG_DIRECTORY32;
pub type PIMAGE_LOAD_CONFIG_DIRECTORY32 = *mut _IMAGE_LOAD_CONFIG_DIRECTORY32;
#[repr(C, packed(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_LOAD_CONFIG_DIRECTORY64 {
    pub Size: DWORD,
    pub TimeDateStamp: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub GlobalFlagsClear: DWORD,
    pub GlobalFlagsSet: DWORD,
    pub CriticalSectionDefaultTimeout: DWORD,
    pub DeCommitFreeBlockThreshold: ULONGLONG,
    pub DeCommitTotalFreeThreshold: ULONGLONG,
    pub LockPrefixTable: ULONGLONG,
    pub MaximumAllocationSize: ULONGLONG,
    pub VirtualMemoryThreshold: ULONGLONG,
    pub ProcessAffinityMask: ULONGLONG,
    pub ProcessHeapFlags: DWORD,
    pub CSDVersion: WORD,
    pub DependentLoadFlags: WORD,
    pub EditList: ULONGLONG,
    pub SecurityCookie: ULONGLONG,
    pub SEHandlerTable: ULONGLONG,
    pub SEHandlerCount: ULONGLONG,
    pub GuardCFCheckFunctionPointer: ULONGLONG,
    pub GuardCFDispatchFunctionPointer: ULONGLONG,
    pub GuardCFFunctionTable: ULONGLONG,
    pub GuardCFFunctionCount: ULONGLONG,
    pub GuardFlags: DWORD,
    pub CodeIntegrity: IMAGE_LOAD_CONFIG_CODE_INTEGRITY,
    pub GuardAddressTakenIatEntryTable: ULONGLONG,
    pub GuardAddressTakenIatEntryCount: ULONGLONG,
    pub GuardLongJumpTargetTable: ULONGLONG,
    pub GuardLongJumpTargetCount: ULONGLONG,
    pub DynamicValueRelocTable: ULONGLONG,
    pub CHPEMetadataPointer: ULONGLONG,
    pub GuardRFFailureRoutine: ULONGLONG,
    pub GuardRFFailureRoutineFunctionPointer: ULONGLONG,
    pub DynamicValueRelocTableOffset: DWORD,
    pub DynamicValueRelocTableSection: WORD,
    pub Reserved2: WORD,
    pub GuardRFVerifyStackPointerFunctionPointer: ULONGLONG,
    pub HotPatchTableOffset: DWORD,
    pub Reserved3: DWORD,
    pub EnclaveConfigurationPointer: ULONGLONG,
    pub VolatileMetadataPointer: ULONGLONG,
    pub GuardEHContinuationTable: ULONGLONG,
    pub GuardEHContinuationCount: ULONGLONG,
    pub GuardXFGCheckFunctionPointer: ULONGLONG,
    pub GuardXFGDispatchFunctionPointer: ULONGLONG,
    pub GuardXFGTableDispatchFunctionPointer: ULONGLONG,
    pub CastGuardOsDeterminedFailureMode: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_LOAD_CONFIG_DIRECTORY64"]
        [::std::mem::size_of::<_IMAGE_LOAD_CONFIG_DIRECTORY64>() - 312usize];
    ["Alignment of _IMAGE_LOAD_CONFIG_DIRECTORY64"]
        [::std::mem::align_of::<_IMAGE_LOAD_CONFIG_DIRECTORY64>() - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::Size"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, Size) - 0usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::MajorVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, MajorVersion) - 8usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::MinorVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, MinorVersion) - 10usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GlobalFlagsClear"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GlobalFlagsClear) - 12usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GlobalFlagsSet"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GlobalFlagsSet) - 16usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::CriticalSectionDefaultTimeout"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        CriticalSectionDefaultTimeout
    ) - 20usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DeCommitFreeBlockThreshold"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        DeCommitFreeBlockThreshold
    ) - 24usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DeCommitTotalFreeThreshold"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        DeCommitTotalFreeThreshold
    ) - 32usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::LockPrefixTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, LockPrefixTable) - 40usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::MaximumAllocationSize"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, MaximumAllocationSize) - 48usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::VirtualMemoryThreshold"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, VirtualMemoryThreshold) - 56usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::ProcessAffinityMask"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, ProcessAffinityMask) - 64usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::ProcessHeapFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, ProcessHeapFlags) - 72usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::CSDVersion"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, CSDVersion) - 76usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DependentLoadFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, DependentLoadFlags) - 78usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::EditList"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, EditList) - 80usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::SecurityCookie"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, SecurityCookie) - 88usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::SEHandlerTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, SEHandlerTable) - 96usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::SEHandlerCount"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, SEHandlerCount) - 104usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardCFCheckFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardCFCheckFunctionPointer
    ) - 112usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardCFDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardCFDispatchFunctionPointer
    )
        - 120usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardCFFunctionTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GuardCFFunctionTable) - 128usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardCFFunctionCount"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GuardCFFunctionCount) - 136usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardFlags"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GuardFlags) - 144usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::CodeIntegrity"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, CodeIntegrity) - 148usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardAddressTakenIatEntryTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardAddressTakenIatEntryTable
    )
        - 160usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardAddressTakenIatEntryCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardAddressTakenIatEntryCount
    )
        - 168usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardLongJumpTargetTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardLongJumpTargetTable
    ) - 176usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardLongJumpTargetCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardLongJumpTargetCount
    ) - 184usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DynamicValueRelocTable"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, DynamicValueRelocTable) - 192usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::CHPEMetadataPointer"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, CHPEMetadataPointer) - 200usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardRFFailureRoutine"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, GuardRFFailureRoutine) - 208usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardRFFailureRoutineFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardRFFailureRoutineFunctionPointer
    )
        - 216usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DynamicValueRelocTableOffset"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        DynamicValueRelocTableOffset
    ) - 224usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::DynamicValueRelocTableSection"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        DynamicValueRelocTableSection
    )
        - 228usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::Reserved2"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, Reserved2) - 230usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardRFVerifyStackPointerFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardRFVerifyStackPointerFunctionPointer
    )
        - 232usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::HotPatchTableOffset"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, HotPatchTableOffset) - 240usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::Reserved3"]
        [::std::mem::offset_of!(_IMAGE_LOAD_CONFIG_DIRECTORY64, Reserved3) - 244usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::EnclaveConfigurationPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        EnclaveConfigurationPointer
    ) - 248usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::VolatileMetadataPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        VolatileMetadataPointer
    ) - 256usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardEHContinuationTable"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardEHContinuationTable
    ) - 264usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardEHContinuationCount"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardEHContinuationCount
    ) - 272usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardXFGCheckFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardXFGCheckFunctionPointer
    ) - 280usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardXFGDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardXFGDispatchFunctionPointer
    )
        - 288usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::GuardXFGTableDispatchFunctionPointer"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        GuardXFGTableDispatchFunctionPointer
    )
        - 296usize];
    ["Offset of field: _IMAGE_LOAD_CONFIG_DIRECTORY64::CastGuardOsDeterminedFailureMode"][::std::mem::offset_of!(
        _IMAGE_LOAD_CONFIG_DIRECTORY64,
        CastGuardOsDeterminedFailureMode
    )
        - 304usize];
};
pub type IMAGE_LOAD_CONFIG_DIRECTORY64 = _IMAGE_LOAD_CONFIG_DIRECTORY64;
pub type PIMAGE_LOAD_CONFIG_DIRECTORY64 = *mut _IMAGE_LOAD_CONFIG_DIRECTORY64;
pub type IMAGE_LOAD_CONFIG_DIRECTORY = IMAGE_LOAD_CONFIG_DIRECTORY64;
pub type PIMAGE_LOAD_CONFIG_DIRECTORY = PIMAGE_LOAD_CONFIG_DIRECTORY64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_HOT_PATCH_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SequenceNumber: DWORD,
    pub BaseImageList: DWORD,
    pub BaseImageCount: DWORD,
    pub BufferOffset: DWORD,
    pub ExtraPatchSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_HOT_PATCH_INFO"][::std::mem::size_of::<_IMAGE_HOT_PATCH_INFO>() - 28usize];
    ["Alignment of _IMAGE_HOT_PATCH_INFO"]
        [::std::mem::align_of::<_IMAGE_HOT_PATCH_INFO>() - 4usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::Version"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, Version) - 0usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::Size"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, Size) - 4usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::SequenceNumber"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, SequenceNumber) - 8usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::BaseImageList"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, BaseImageList) - 12usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::BaseImageCount"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, BaseImageCount) - 16usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::BufferOffset"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, BufferOffset) - 20usize];
    ["Offset of field: _IMAGE_HOT_PATCH_INFO::ExtraPatchSize"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_INFO, ExtraPatchSize) - 24usize];
};
pub type IMAGE_HOT_PATCH_INFO = _IMAGE_HOT_PATCH_INFO;
pub type PIMAGE_HOT_PATCH_INFO = *mut _IMAGE_HOT_PATCH_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_HOT_PATCH_BASE {
    pub SequenceNumber: DWORD,
    pub Flags: DWORD,
    pub OriginalTimeDateStamp: DWORD,
    pub OriginalCheckSum: DWORD,
    pub CodeIntegrityInfo: DWORD,
    pub CodeIntegritySize: DWORD,
    pub PatchTable: DWORD,
    pub BufferOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_HOT_PATCH_BASE"][::std::mem::size_of::<_IMAGE_HOT_PATCH_BASE>() - 32usize];
    ["Alignment of _IMAGE_HOT_PATCH_BASE"]
        [::std::mem::align_of::<_IMAGE_HOT_PATCH_BASE>() - 4usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::SequenceNumber"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, SequenceNumber) - 0usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::Flags"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, Flags) - 4usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::OriginalTimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, OriginalTimeDateStamp) - 8usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::OriginalCheckSum"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, OriginalCheckSum) - 12usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::CodeIntegrityInfo"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, CodeIntegrityInfo) - 16usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::CodeIntegritySize"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, CodeIntegritySize) - 20usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::PatchTable"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, PatchTable) - 24usize];
    ["Offset of field: _IMAGE_HOT_PATCH_BASE::BufferOffset"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_BASE, BufferOffset) - 28usize];
};
pub type IMAGE_HOT_PATCH_BASE = _IMAGE_HOT_PATCH_BASE;
pub type PIMAGE_HOT_PATCH_BASE = *mut _IMAGE_HOT_PATCH_BASE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_HOT_PATCH_HASHES {
    pub SHA256: [BYTE; 32usize],
    pub SHA1: [BYTE; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_HOT_PATCH_HASHES"][::std::mem::size_of::<_IMAGE_HOT_PATCH_HASHES>() - 52usize];
    ["Alignment of _IMAGE_HOT_PATCH_HASHES"]
        [::std::mem::align_of::<_IMAGE_HOT_PATCH_HASHES>() - 1usize];
    ["Offset of field: _IMAGE_HOT_PATCH_HASHES::SHA256"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_HASHES, SHA256) - 0usize];
    ["Offset of field: _IMAGE_HOT_PATCH_HASHES::SHA1"]
        [::std::mem::offset_of!(_IMAGE_HOT_PATCH_HASHES, SHA1) - 32usize];
};
pub type IMAGE_HOT_PATCH_HASHES = _IMAGE_HOT_PATCH_HASHES;
pub type PIMAGE_HOT_PATCH_HASHES = *mut _IMAGE_HOT_PATCH_HASHES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_CE_RUNTIME_FUNCTION_ENTRY {
    pub FuncStart: DWORD,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_CE_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_CE_RUNTIME_FUNCTION_ENTRY>() - 8usize];
    ["Alignment of _IMAGE_CE_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_CE_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_CE_RUNTIME_FUNCTION_ENTRY::FuncStart"]
        [::std::mem::offset_of!(_IMAGE_CE_RUNTIME_FUNCTION_ENTRY, FuncStart) - 0usize];
};
impl _IMAGE_CE_RUNTIME_FUNCTION_ENTRY {
    #[inline]
    pub fn PrologLen(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_PrologLen(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PrologLen_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_PrologLen_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn FuncLen(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 22u8) as u32) }
    }
    #[inline]
    pub fn set_FuncLen(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 22u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FuncLen_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                22u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FuncLen_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                22u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ThirtyTwoBit(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(30usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ThirtyTwoBit(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(30usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ThirtyTwoBit_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                30usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ThirtyTwoBit_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                30usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ExceptionFlag(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(31usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ExceptionFlag(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(31usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ExceptionFlag_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                31usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ExceptionFlag_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                31usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        PrologLen: DWORD,
        FuncLen: DWORD,
        ThirtyTwoBit: DWORD,
        ExceptionFlag: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let PrologLen: u32 = unsafe { ::std::mem::transmute(PrologLen) };
            PrologLen as u64
        });
        __bindgen_bitfield_unit.set(8usize, 22u8, {
            let FuncLen: u32 = unsafe { ::std::mem::transmute(FuncLen) };
            FuncLen as u64
        });
        __bindgen_bitfield_unit.set(30usize, 1u8, {
            let ThirtyTwoBit: u32 = unsafe { ::std::mem::transmute(ThirtyTwoBit) };
            ThirtyTwoBit as u64
        });
        __bindgen_bitfield_unit.set(31usize, 1u8, {
            let ExceptionFlag: u32 = unsafe { ::std::mem::transmute(ExceptionFlag) };
            ExceptionFlag as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type IMAGE_CE_RUNTIME_FUNCTION_ENTRY = _IMAGE_CE_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_CE_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_CE_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY {
    pub BeginAddress: DWORD,
    pub __bindgen_anon_1: _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1 {
    pub UnwindData: DWORD,
    pub __bindgen_anon_1: _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn Flag(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Flag(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Flag_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Flag_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn FunctionLength(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 11u8) as u32) }
    }
    #[inline]
    pub fn set_FunctionLength(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 11u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FunctionLength_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                11u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FunctionLength_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                11u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Ret(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Ret(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Ret_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Ret_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn H(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_H(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn H_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_H_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reg(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_Reg(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reg_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reg_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn R(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(19usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_R(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(19usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn R_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                19usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_R_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                19usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn L(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_L(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn L_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_L_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn C(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_C(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn C_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_C_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn StackAdjust(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 10u8) as u32) }
    }
    #[inline]
    pub fn set_StackAdjust(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(22usize, 10u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn StackAdjust_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                22usize,
                10u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_StackAdjust_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                22usize,
                10u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Flag: DWORD,
        FunctionLength: DWORD,
        Ret: DWORD,
        H: DWORD,
        Reg: DWORD,
        R: DWORD,
        L: DWORD,
        C: DWORD,
        StackAdjust: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let Flag: u32 = unsafe { ::std::mem::transmute(Flag) };
            Flag as u64
        });
        __bindgen_bitfield_unit.set(2usize, 11u8, {
            let FunctionLength: u32 = unsafe { ::std::mem::transmute(FunctionLength) };
            FunctionLength as u64
        });
        __bindgen_bitfield_unit.set(13usize, 2u8, {
            let Ret: u32 = unsafe { ::std::mem::transmute(Ret) };
            Ret as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let H: u32 = unsafe { ::std::mem::transmute(H) };
            H as u64
        });
        __bindgen_bitfield_unit.set(16usize, 3u8, {
            let Reg: u32 = unsafe { ::std::mem::transmute(Reg) };
            Reg as u64
        });
        __bindgen_bitfield_unit.set(19usize, 1u8, {
            let R: u32 = unsafe { ::std::mem::transmute(R) };
            R as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let L: u32 = unsafe { ::std::mem::transmute(L) };
            L as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let C: u32 = unsafe { ::std::mem::transmute(C) };
            C as u64
        });
        __bindgen_bitfield_unit.set(22usize, 10u8, {
            let StackAdjust: u32 = unsafe { ::std::mem::transmute(StackAdjust) };
            StackAdjust as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1::UnwindData"][::std::mem::offset_of!(
        _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
        UnwindData
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY>() - 8usize];
    ["Alignment of _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY::BeginAddress"]
        [::std::mem::offset_of!(_IMAGE_ARM_RUNTIME_FUNCTION_ENTRY, BeginAddress) - 0usize];
};
pub type IMAGE_ARM_RUNTIME_FUNCTION_ENTRY = _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_ARM_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_ARM_RUNTIME_FUNCTION_ENTRY;
pub const ARM64_FNPDATA_FLAGS_PdataRefToFullXdata: ARM64_FNPDATA_FLAGS = 0;
pub const ARM64_FNPDATA_FLAGS_PdataPackedUnwindFunction: ARM64_FNPDATA_FLAGS = 1;
pub const ARM64_FNPDATA_FLAGS_PdataPackedUnwindFragment: ARM64_FNPDATA_FLAGS = 2;
pub type ARM64_FNPDATA_FLAGS = ::std::os::raw::c_int;
pub const ARM64_FNPDATA_CR_PdataCrUnchained: ARM64_FNPDATA_CR = 0;
pub const ARM64_FNPDATA_CR_PdataCrUnchainedSavedLr: ARM64_FNPDATA_CR = 1;
pub const ARM64_FNPDATA_CR_PdataCrChainedWithPac: ARM64_FNPDATA_CR = 2;
pub const ARM64_FNPDATA_CR_PdataCrChained: ARM64_FNPDATA_CR = 3;
pub type ARM64_FNPDATA_CR = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY {
    pub BeginAddress: DWORD,
    pub __bindgen_anon_1: _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1 {
    pub UnwindData: DWORD,
    pub __bindgen_anon_1: _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn Flag(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Flag(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Flag_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Flag_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn FunctionLength(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 11u8) as u32) }
    }
    #[inline]
    pub fn set_FunctionLength(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 11u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FunctionLength_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                11u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FunctionLength_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                11u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn RegF(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_RegF(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RegF_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RegF_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn RegI(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_RegI(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RegI_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RegI_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn H(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_H(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn H_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_H_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn CR(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_CR(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn CR_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_CR_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn FrameSize(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(23usize, 9u8) as u32) }
    }
    #[inline]
    pub fn set_FrameSize(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(23usize, 9u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FrameSize_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                23usize,
                9u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FrameSize_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                23usize,
                9u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Flag: DWORD,
        FunctionLength: DWORD,
        RegF: DWORD,
        RegI: DWORD,
        H: DWORD,
        CR: DWORD,
        FrameSize: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let Flag: u32 = unsafe { ::std::mem::transmute(Flag) };
            Flag as u64
        });
        __bindgen_bitfield_unit.set(2usize, 11u8, {
            let FunctionLength: u32 = unsafe { ::std::mem::transmute(FunctionLength) };
            FunctionLength as u64
        });
        __bindgen_bitfield_unit.set(13usize, 3u8, {
            let RegF: u32 = unsafe { ::std::mem::transmute(RegF) };
            RegF as u64
        });
        __bindgen_bitfield_unit.set(16usize, 4u8, {
            let RegI: u32 = unsafe { ::std::mem::transmute(RegI) };
            RegI as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let H: u32 = unsafe { ::std::mem::transmute(H) };
            H as u64
        });
        __bindgen_bitfield_unit.set(21usize, 2u8, {
            let CR: u32 = unsafe { ::std::mem::transmute(CR) };
            CR as u64
        });
        __bindgen_bitfield_unit.set(23usize, 9u8, {
            let FrameSize: u32 = unsafe { ::std::mem::transmute(FrameSize) };
            FrameSize as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1::UnwindData"][::std::mem::offset_of!(
        _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
        UnwindData
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY>() - 8usize];
    ["Alignment of _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY::BeginAddress"]
        [::std::mem::offset_of!(_IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY, BeginAddress) - 0usize];
};
pub type IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY = _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_ARM64_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub union IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA {
    pub HeaderData: DWORD,
    pub __bindgen_anon_1: IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1"]
        [::std::mem::size_of::<IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1>() - 4usize];
    ["Alignment of IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1"]
        [::std::mem::align_of::<IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1>() - 4usize];
};
impl IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA__bindgen_ty_1 {
    #[inline]
    pub fn FunctionLength(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 18u8) as u32) }
    }
    #[inline]
    pub fn set_FunctionLength(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 18u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FunctionLength_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                18u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FunctionLength_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                18u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Version(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(18usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_Version(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(18usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Version_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                18usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Version_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                18usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ExceptionDataPresent(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(20usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ExceptionDataPresent(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(20usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ExceptionDataPresent_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                20usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ExceptionDataPresent_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                20usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EpilogInHeader(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(21usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_EpilogInHeader(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(21usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EpilogInHeader_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                21usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EpilogInHeader_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                21usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn EpilogCount(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_EpilogCount(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(22usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn EpilogCount_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                22usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_EpilogCount_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                22usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn CodeWords(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(27usize, 5u8) as u32) }
    }
    #[inline]
    pub fn set_CodeWords(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(27usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn CodeWords_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                27usize,
                5u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_CodeWords_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                27usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        FunctionLength: DWORD,
        Version: DWORD,
        ExceptionDataPresent: DWORD,
        EpilogInHeader: DWORD,
        EpilogCount: DWORD,
        CodeWords: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 18u8, {
            let FunctionLength: u32 = unsafe { ::std::mem::transmute(FunctionLength) };
            FunctionLength as u64
        });
        __bindgen_bitfield_unit.set(18usize, 2u8, {
            let Version: u32 = unsafe { ::std::mem::transmute(Version) };
            Version as u64
        });
        __bindgen_bitfield_unit.set(20usize, 1u8, {
            let ExceptionDataPresent: u32 = unsafe { ::std::mem::transmute(ExceptionDataPresent) };
            ExceptionDataPresent as u64
        });
        __bindgen_bitfield_unit.set(21usize, 1u8, {
            let EpilogInHeader: u32 = unsafe { ::std::mem::transmute(EpilogInHeader) };
            EpilogInHeader as u64
        });
        __bindgen_bitfield_unit.set(22usize, 5u8, {
            let EpilogCount: u32 = unsafe { ::std::mem::transmute(EpilogCount) };
            EpilogCount as u64
        });
        __bindgen_bitfield_unit.set(27usize, 5u8, {
            let CodeWords: u32 = unsafe { ::std::mem::transmute(CodeWords) };
            CodeWords as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA"]
        [::std::mem::size_of::<IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA>() - 4usize];
    ["Alignment of IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA"]
        [::std::mem::align_of::<IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA>() - 4usize];
    ["Offset of field: IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA::HeaderData"]
        [::std::mem::offset_of!(IMAGE_ARM64_RUNTIME_FUNCTION_ENTRY_XDATA, HeaderData) - 0usize];
};
#[repr(C, packed(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY {
    pub BeginAddress: ULONGLONG,
    pub EndAddress: ULONGLONG,
    pub ExceptionHandler: ULONGLONG,
    pub HandlerData: ULONGLONG,
    pub PrologEndAddress: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY>() - 40usize];
    ["Alignment of _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY::BeginAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY, BeginAddress) - 0usize];
    ["Offset of field: _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY::EndAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY, EndAddress) - 8usize];
    ["Offset of field: _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY::ExceptionHandler"]
        [::std::mem::offset_of!(_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY, ExceptionHandler) - 16usize];
    ["Offset of field: _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY::HandlerData"]
        [::std::mem::offset_of!(_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY, HandlerData) - 24usize];
    ["Offset of field: _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY::PrologEndAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY, PrologEndAddress) - 32usize];
};
pub type IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY = _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY {
    pub BeginAddress: DWORD,
    pub EndAddress: DWORD,
    pub ExceptionHandler: DWORD,
    pub HandlerData: DWORD,
    pub PrologEndAddress: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY>() - 20usize];
    ["Alignment of _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY::BeginAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY, BeginAddress) - 0usize];
    ["Offset of field: _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY::EndAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY, EndAddress) - 4usize];
    ["Offset of field: _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY::ExceptionHandler"]
        [::std::mem::offset_of!(_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY, ExceptionHandler) - 8usize];
    ["Offset of field: _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY::HandlerData"]
        [::std::mem::offset_of!(_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY, HandlerData) - 12usize];
    ["Offset of field: _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY::PrologEndAddress"]
        [::std::mem::offset_of!(_IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY, PrologEndAddress) - 16usize];
};
pub type IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY = _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_RUNTIME_FUNCTION_ENTRY {
    pub BeginAddress: DWORD,
    pub EndAddress: DWORD,
    pub __bindgen_anon_1: _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1 {
    pub UnwindInfoAddress: DWORD,
    pub UnwindData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Alignment of _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1::UnwindInfoAddress"][::std::mem::offset_of!(
        _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1,
        UnwindInfoAddress
    ) - 0usize];
    ["Offset of field: _IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1::UnwindData"]
        [::std::mem::offset_of!(_IMAGE_RUNTIME_FUNCTION_ENTRY__bindgen_ty_1, UnwindData) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::size_of::<_IMAGE_RUNTIME_FUNCTION_ENTRY>() - 12usize];
    ["Alignment of _IMAGE_RUNTIME_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_RUNTIME_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_RUNTIME_FUNCTION_ENTRY::BeginAddress"]
        [::std::mem::offset_of!(_IMAGE_RUNTIME_FUNCTION_ENTRY, BeginAddress) - 0usize];
    ["Offset of field: _IMAGE_RUNTIME_FUNCTION_ENTRY::EndAddress"]
        [::std::mem::offset_of!(_IMAGE_RUNTIME_FUNCTION_ENTRY, EndAddress) - 4usize];
};
pub type _PIMAGE_RUNTIME_FUNCTION_ENTRY = *mut _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type IMAGE_IA64_RUNTIME_FUNCTION_ENTRY = _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_IA64_RUNTIME_FUNCTION_ENTRY = _PIMAGE_RUNTIME_FUNCTION_ENTRY;
pub type IMAGE_AMD64_RUNTIME_FUNCTION_ENTRY = _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_AMD64_RUNTIME_FUNCTION_ENTRY = _PIMAGE_RUNTIME_FUNCTION_ENTRY;
pub type IMAGE_RUNTIME_FUNCTION_ENTRY = _IMAGE_RUNTIME_FUNCTION_ENTRY;
pub type PIMAGE_RUNTIME_FUNCTION_ENTRY = _PIMAGE_RUNTIME_FUNCTION_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ENCLAVE_CONFIG32 {
    pub Size: DWORD,
    pub MinimumRequiredConfigSize: DWORD,
    pub PolicyFlags: DWORD,
    pub NumberOfImports: DWORD,
    pub ImportList: DWORD,
    pub ImportEntrySize: DWORD,
    pub FamilyID: [BYTE; 16usize],
    pub ImageID: [BYTE; 16usize],
    pub ImageVersion: DWORD,
    pub SecurityVersion: DWORD,
    pub EnclaveSize: DWORD,
    pub NumberOfThreads: DWORD,
    pub EnclaveFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ENCLAVE_CONFIG32"][::std::mem::size_of::<_IMAGE_ENCLAVE_CONFIG32>() - 76usize];
    ["Alignment of _IMAGE_ENCLAVE_CONFIG32"]
        [::std::mem::align_of::<_IMAGE_ENCLAVE_CONFIG32>() - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::Size"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, Size) - 0usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::MinimumRequiredConfigSize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, MinimumRequiredConfigSize) - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::PolicyFlags"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, PolicyFlags) - 8usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::NumberOfImports"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, NumberOfImports) - 12usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::ImportList"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, ImportList) - 16usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::ImportEntrySize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, ImportEntrySize) - 20usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::FamilyID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, FamilyID) - 24usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::ImageID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, ImageID) - 40usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::ImageVersion"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, ImageVersion) - 56usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::SecurityVersion"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, SecurityVersion) - 60usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::EnclaveSize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, EnclaveSize) - 64usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::NumberOfThreads"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, NumberOfThreads) - 68usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG32::EnclaveFlags"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG32, EnclaveFlags) - 72usize];
};
pub type IMAGE_ENCLAVE_CONFIG32 = _IMAGE_ENCLAVE_CONFIG32;
pub type PIMAGE_ENCLAVE_CONFIG32 = *mut _IMAGE_ENCLAVE_CONFIG32;
#[repr(C, packed(4))]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ENCLAVE_CONFIG64 {
    pub Size: DWORD,
    pub MinimumRequiredConfigSize: DWORD,
    pub PolicyFlags: DWORD,
    pub NumberOfImports: DWORD,
    pub ImportList: DWORD,
    pub ImportEntrySize: DWORD,
    pub FamilyID: [BYTE; 16usize],
    pub ImageID: [BYTE; 16usize],
    pub ImageVersion: DWORD,
    pub SecurityVersion: DWORD,
    pub EnclaveSize: ULONGLONG,
    pub NumberOfThreads: DWORD,
    pub EnclaveFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ENCLAVE_CONFIG64"][::std::mem::size_of::<_IMAGE_ENCLAVE_CONFIG64>() - 80usize];
    ["Alignment of _IMAGE_ENCLAVE_CONFIG64"]
        [::std::mem::align_of::<_IMAGE_ENCLAVE_CONFIG64>() - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::Size"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, Size) - 0usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::MinimumRequiredConfigSize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, MinimumRequiredConfigSize) - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::PolicyFlags"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, PolicyFlags) - 8usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::NumberOfImports"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, NumberOfImports) - 12usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::ImportList"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, ImportList) - 16usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::ImportEntrySize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, ImportEntrySize) - 20usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::FamilyID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, FamilyID) - 24usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::ImageID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, ImageID) - 40usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::ImageVersion"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, ImageVersion) - 56usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::SecurityVersion"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, SecurityVersion) - 60usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::EnclaveSize"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, EnclaveSize) - 64usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::NumberOfThreads"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, NumberOfThreads) - 72usize];
    ["Offset of field: _IMAGE_ENCLAVE_CONFIG64::EnclaveFlags"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_CONFIG64, EnclaveFlags) - 76usize];
};
pub type IMAGE_ENCLAVE_CONFIG64 = _IMAGE_ENCLAVE_CONFIG64;
pub type PIMAGE_ENCLAVE_CONFIG64 = *mut _IMAGE_ENCLAVE_CONFIG64;
pub type IMAGE_ENCLAVE_CONFIG = IMAGE_ENCLAVE_CONFIG64;
pub type PIMAGE_ENCLAVE_CONFIG = PIMAGE_ENCLAVE_CONFIG64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_ENCLAVE_IMPORT {
    pub MatchType: DWORD,
    pub MinimumSecurityVersion: DWORD,
    pub UniqueOrAuthorID: [BYTE; 32usize],
    pub FamilyID: [BYTE; 16usize],
    pub ImageID: [BYTE; 16usize],
    pub ImportName: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_ENCLAVE_IMPORT"][::std::mem::size_of::<_IMAGE_ENCLAVE_IMPORT>() - 80usize];
    ["Alignment of _IMAGE_ENCLAVE_IMPORT"]
        [::std::mem::align_of::<_IMAGE_ENCLAVE_IMPORT>() - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::MatchType"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, MatchType) - 0usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::MinimumSecurityVersion"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, MinimumSecurityVersion) - 4usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::UniqueOrAuthorID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, UniqueOrAuthorID) - 8usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::FamilyID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, FamilyID) - 40usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::ImageID"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, ImageID) - 56usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::ImportName"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, ImportName) - 72usize];
    ["Offset of field: _IMAGE_ENCLAVE_IMPORT::Reserved"]
        [::std::mem::offset_of!(_IMAGE_ENCLAVE_IMPORT, Reserved) - 76usize];
};
pub type IMAGE_ENCLAVE_IMPORT = _IMAGE_ENCLAVE_IMPORT;
pub type PIMAGE_ENCLAVE_IMPORT = *mut _IMAGE_ENCLAVE_IMPORT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DEBUG_DIRECTORY {
    pub Characteristics: DWORD,
    pub TimeDateStamp: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub Type: DWORD,
    pub SizeOfData: DWORD,
    pub AddressOfRawData: DWORD,
    pub PointerToRawData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DEBUG_DIRECTORY"][::std::mem::size_of::<_IMAGE_DEBUG_DIRECTORY>() - 28usize];
    ["Alignment of _IMAGE_DEBUG_DIRECTORY"]
        [::std::mem::align_of::<_IMAGE_DEBUG_DIRECTORY>() - 4usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, Characteristics) - 0usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, TimeDateStamp) - 4usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::MajorVersion"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, MajorVersion) - 8usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::MinorVersion"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, MinorVersion) - 10usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::Type"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, Type) - 12usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::SizeOfData"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, SizeOfData) - 16usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::AddressOfRawData"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, AddressOfRawData) - 20usize];
    ["Offset of field: _IMAGE_DEBUG_DIRECTORY::PointerToRawData"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_DIRECTORY, PointerToRawData) - 24usize];
};
pub type IMAGE_DEBUG_DIRECTORY = _IMAGE_DEBUG_DIRECTORY;
pub type PIMAGE_DEBUG_DIRECTORY = *mut _IMAGE_DEBUG_DIRECTORY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_COFF_SYMBOLS_HEADER {
    pub NumberOfSymbols: DWORD,
    pub LvaToFirstSymbol: DWORD,
    pub NumberOfLinenumbers: DWORD,
    pub LvaToFirstLinenumber: DWORD,
    pub RvaToFirstByteOfCode: DWORD,
    pub RvaToLastByteOfCode: DWORD,
    pub RvaToFirstByteOfData: DWORD,
    pub RvaToLastByteOfData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_COFF_SYMBOLS_HEADER"]
        [::std::mem::size_of::<_IMAGE_COFF_SYMBOLS_HEADER>() - 32usize];
    ["Alignment of _IMAGE_COFF_SYMBOLS_HEADER"]
        [::std::mem::align_of::<_IMAGE_COFF_SYMBOLS_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::NumberOfSymbols"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, NumberOfSymbols) - 0usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::LvaToFirstSymbol"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, LvaToFirstSymbol) - 4usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::NumberOfLinenumbers"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, NumberOfLinenumbers) - 8usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::LvaToFirstLinenumber"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, LvaToFirstLinenumber) - 12usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::RvaToFirstByteOfCode"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, RvaToFirstByteOfCode) - 16usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::RvaToLastByteOfCode"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, RvaToLastByteOfCode) - 20usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::RvaToFirstByteOfData"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, RvaToFirstByteOfData) - 24usize];
    ["Offset of field: _IMAGE_COFF_SYMBOLS_HEADER::RvaToLastByteOfData"]
        [::std::mem::offset_of!(_IMAGE_COFF_SYMBOLS_HEADER, RvaToLastByteOfData) - 28usize];
};
pub type IMAGE_COFF_SYMBOLS_HEADER = _IMAGE_COFF_SYMBOLS_HEADER;
pub type PIMAGE_COFF_SYMBOLS_HEADER = *mut _IMAGE_COFF_SYMBOLS_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FPO_DATA {
    pub ulOffStart: DWORD,
    pub cbProcSize: DWORD,
    pub cdwLocals: DWORD,
    pub cdwParams: WORD,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FPO_DATA"][::std::mem::size_of::<_FPO_DATA>() - 16usize];
    ["Alignment of _FPO_DATA"][::std::mem::align_of::<_FPO_DATA>() - 4usize];
    ["Offset of field: _FPO_DATA::ulOffStart"]
        [::std::mem::offset_of!(_FPO_DATA, ulOffStart) - 0usize];
    ["Offset of field: _FPO_DATA::cbProcSize"]
        [::std::mem::offset_of!(_FPO_DATA, cbProcSize) - 4usize];
    ["Offset of field: _FPO_DATA::cdwLocals"]
        [::std::mem::offset_of!(_FPO_DATA, cdwLocals) - 8usize];
    ["Offset of field: _FPO_DATA::cdwParams"]
        [::std::mem::offset_of!(_FPO_DATA, cdwParams) - 12usize];
};
impl _FPO_DATA {
    #[inline]
    pub fn cbProlog(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u16) }
    }
    #[inline]
    pub fn set_cbProlog(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cbProlog_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_cbProlog_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cbRegs(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 3u8) as u16) }
    }
    #[inline]
    pub fn set_cbRegs(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cbRegs_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                3u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_cbRegs_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fHasSEH(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fHasSEH(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fHasSEH_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fHasSEH_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fUseBP(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fUseBP(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fUseBP_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fUseBP_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn cbFrame(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 2u8) as u16) }
    }
    #[inline]
    pub fn set_cbFrame(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cbFrame_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                2u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_cbFrame_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        cbProlog: WORD,
        cbRegs: WORD,
        fHasSEH: WORD,
        fUseBP: WORD,
        reserved: WORD,
        cbFrame: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let cbProlog: u16 = unsafe { ::std::mem::transmute(cbProlog) };
            cbProlog as u64
        });
        __bindgen_bitfield_unit.set(8usize, 3u8, {
            let cbRegs: u16 = unsafe { ::std::mem::transmute(cbRegs) };
            cbRegs as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let fHasSEH: u16 = unsafe { ::std::mem::transmute(fHasSEH) };
            fHasSEH as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let fUseBP: u16 = unsafe { ::std::mem::transmute(fUseBP) };
            fUseBP as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let reserved: u16 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit.set(14usize, 2u8, {
            let cbFrame: u16 = unsafe { ::std::mem::transmute(cbFrame) };
            cbFrame as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type FPO_DATA = _FPO_DATA;
pub type PFPO_DATA = *mut _FPO_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_DEBUG_MISC {
    pub DataType: DWORD,
    pub Length: DWORD,
    pub Unicode: BOOLEAN,
    pub Reserved: [BYTE; 3usize],
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_DEBUG_MISC"][::std::mem::size_of::<_IMAGE_DEBUG_MISC>() - 16usize];
    ["Alignment of _IMAGE_DEBUG_MISC"][::std::mem::align_of::<_IMAGE_DEBUG_MISC>() - 4usize];
    ["Offset of field: _IMAGE_DEBUG_MISC::DataType"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_MISC, DataType) - 0usize];
    ["Offset of field: _IMAGE_DEBUG_MISC::Length"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_MISC, Length) - 4usize];
    ["Offset of field: _IMAGE_DEBUG_MISC::Unicode"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_MISC, Unicode) - 8usize];
    ["Offset of field: _IMAGE_DEBUG_MISC::Reserved"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_MISC, Reserved) - 9usize];
    ["Offset of field: _IMAGE_DEBUG_MISC::Data"]
        [::std::mem::offset_of!(_IMAGE_DEBUG_MISC, Data) - 12usize];
};
pub type IMAGE_DEBUG_MISC = _IMAGE_DEBUG_MISC;
pub type PIMAGE_DEBUG_MISC = *mut _IMAGE_DEBUG_MISC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_FUNCTION_ENTRY {
    pub StartingAddress: DWORD,
    pub EndingAddress: DWORD,
    pub EndOfPrologue: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_FUNCTION_ENTRY"][::std::mem::size_of::<_IMAGE_FUNCTION_ENTRY>() - 12usize];
    ["Alignment of _IMAGE_FUNCTION_ENTRY"]
        [::std::mem::align_of::<_IMAGE_FUNCTION_ENTRY>() - 4usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY::StartingAddress"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY, StartingAddress) - 0usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY::EndingAddress"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY, EndingAddress) - 4usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY::EndOfPrologue"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY, EndOfPrologue) - 8usize];
};
pub type IMAGE_FUNCTION_ENTRY = _IMAGE_FUNCTION_ENTRY;
pub type PIMAGE_FUNCTION_ENTRY = *mut _IMAGE_FUNCTION_ENTRY;
#[repr(C, packed(4))]
#[derive(Copy, Clone)]
pub struct _IMAGE_FUNCTION_ENTRY64 {
    pub StartingAddress: ULONGLONG,
    pub EndingAddress: ULONGLONG,
    pub __bindgen_anon_1: _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1,
}
#[repr(C, packed(4))]
#[derive(Copy, Clone)]
pub union _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1 {
    pub EndOfPrologue: ULONGLONG,
    pub UnwindInfoAddress: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_FUNCTION_ENTRY64__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_FUNCTION_ENTRY64__bindgen_ty_1>() - 4usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1::EndOfPrologue"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY64__bindgen_ty_1, EndOfPrologue) - 0usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY64__bindgen_ty_1::UnwindInfoAddress"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY64__bindgen_ty_1, UnwindInfoAddress) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_FUNCTION_ENTRY64"][::std::mem::size_of::<_IMAGE_FUNCTION_ENTRY64>() - 24usize];
    ["Alignment of _IMAGE_FUNCTION_ENTRY64"]
        [::std::mem::align_of::<_IMAGE_FUNCTION_ENTRY64>() - 4usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY64::StartingAddress"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY64, StartingAddress) - 0usize];
    ["Offset of field: _IMAGE_FUNCTION_ENTRY64::EndingAddress"]
        [::std::mem::offset_of!(_IMAGE_FUNCTION_ENTRY64, EndingAddress) - 8usize];
};
pub type IMAGE_FUNCTION_ENTRY64 = _IMAGE_FUNCTION_ENTRY64;
pub type PIMAGE_FUNCTION_ENTRY64 = *mut _IMAGE_FUNCTION_ENTRY64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IMAGE_SEPARATE_DEBUG_HEADER {
    pub Signature: WORD,
    pub Flags: WORD,
    pub Machine: WORD,
    pub Characteristics: WORD,
    pub TimeDateStamp: DWORD,
    pub CheckSum: DWORD,
    pub ImageBase: DWORD,
    pub SizeOfImage: DWORD,
    pub NumberOfSections: DWORD,
    pub ExportedNamesSize: DWORD,
    pub DebugDirectorySize: DWORD,
    pub SectionAlignment: DWORD,
    pub Reserved: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_SEPARATE_DEBUG_HEADER"]
        [::std::mem::size_of::<_IMAGE_SEPARATE_DEBUG_HEADER>() - 48usize];
    ["Alignment of _IMAGE_SEPARATE_DEBUG_HEADER"]
        [::std::mem::align_of::<_IMAGE_SEPARATE_DEBUG_HEADER>() - 4usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::Signature"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, Signature) - 0usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::Flags"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, Flags) - 2usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::Machine"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, Machine) - 4usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::Characteristics"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, Characteristics) - 6usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::TimeDateStamp"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, TimeDateStamp) - 8usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::CheckSum"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, CheckSum) - 12usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::ImageBase"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, ImageBase) - 16usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::SizeOfImage"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, SizeOfImage) - 20usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::NumberOfSections"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, NumberOfSections) - 24usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::ExportedNamesSize"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, ExportedNamesSize) - 28usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::DebugDirectorySize"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, DebugDirectorySize) - 32usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::SectionAlignment"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, SectionAlignment) - 36usize];
    ["Offset of field: _IMAGE_SEPARATE_DEBUG_HEADER::Reserved"]
        [::std::mem::offset_of!(_IMAGE_SEPARATE_DEBUG_HEADER, Reserved) - 40usize];
};
pub type IMAGE_SEPARATE_DEBUG_HEADER = _IMAGE_SEPARATE_DEBUG_HEADER;
pub type PIMAGE_SEPARATE_DEBUG_HEADER = *mut _IMAGE_SEPARATE_DEBUG_HEADER;
#[repr(C, packed(4))]
#[derive(Debug, Copy, Clone)]
pub struct _NON_PAGED_DEBUG_INFO {
    pub Signature: WORD,
    pub Flags: WORD,
    pub Size: DWORD,
    pub Machine: WORD,
    pub Characteristics: WORD,
    pub TimeDateStamp: DWORD,
    pub CheckSum: DWORD,
    pub SizeOfImage: DWORD,
    pub ImageBase: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NON_PAGED_DEBUG_INFO"][::std::mem::size_of::<_NON_PAGED_DEBUG_INFO>() - 32usize];
    ["Alignment of _NON_PAGED_DEBUG_INFO"]
        [::std::mem::align_of::<_NON_PAGED_DEBUG_INFO>() - 4usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::Signature"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, Signature) - 0usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::Flags"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, Flags) - 2usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::Size"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, Size) - 4usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::Machine"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, Machine) - 8usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::Characteristics"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, Characteristics) - 10usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::TimeDateStamp"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, TimeDateStamp) - 12usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::CheckSum"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, CheckSum) - 16usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::SizeOfImage"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, SizeOfImage) - 20usize];
    ["Offset of field: _NON_PAGED_DEBUG_INFO::ImageBase"]
        [::std::mem::offset_of!(_NON_PAGED_DEBUG_INFO, ImageBase) - 24usize];
};
pub type NON_PAGED_DEBUG_INFO = _NON_PAGED_DEBUG_INFO;
pub type PNON_PAGED_DEBUG_INFO = *mut _NON_PAGED_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ImageArchitectureHeader {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub FirstEntryRVA: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ImageArchitectureHeader"]
        [::std::mem::size_of::<_ImageArchitectureHeader>() - 8usize];
    ["Alignment of _ImageArchitectureHeader"]
        [::std::mem::align_of::<_ImageArchitectureHeader>() - 4usize];
    ["Offset of field: _ImageArchitectureHeader::FirstEntryRVA"]
        [::std::mem::offset_of!(_ImageArchitectureHeader, FirstEntryRVA) - 4usize];
};
impl _ImageArchitectureHeader {
    #[inline]
    pub fn AmaskValue(&self) -> ::std::os::raw::c_uint {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AmaskValue(&mut self, val: ::std::os::raw::c_uint) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AmaskValue_raw(this: *const Self) -> ::std::os::raw::c_uint {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AmaskValue_raw(this: *mut Self, val: ::std::os::raw::c_uint) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AmaskShift(&self) -> ::std::os::raw::c_uint {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 8u8) as u32) }
    }
    #[inline]
    pub fn set_AmaskShift(&mut self, val: ::std::os::raw::c_uint) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AmaskShift_raw(this: *const Self) -> ::std::os::raw::c_uint {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                8u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AmaskShift_raw(this: *mut Self, val: ::std::os::raw::c_uint) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        AmaskValue: ::std::os::raw::c_uint,
        AmaskShift: ::std::os::raw::c_uint,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let AmaskValue: u32 = unsafe { ::std::mem::transmute(AmaskValue) };
            AmaskValue as u64
        });
        __bindgen_bitfield_unit.set(8usize, 8u8, {
            let AmaskShift: u32 = unsafe { ::std::mem::transmute(AmaskShift) };
            AmaskShift as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type IMAGE_ARCHITECTURE_HEADER = _ImageArchitectureHeader;
pub type PIMAGE_ARCHITECTURE_HEADER = *mut _ImageArchitectureHeader;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ImageArchitectureEntry {
    pub FixupInstRVA: DWORD,
    pub NewInst: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ImageArchitectureEntry"][::std::mem::size_of::<_ImageArchitectureEntry>() - 8usize];
    ["Alignment of _ImageArchitectureEntry"]
        [::std::mem::align_of::<_ImageArchitectureEntry>() - 4usize];
    ["Offset of field: _ImageArchitectureEntry::FixupInstRVA"]
        [::std::mem::offset_of!(_ImageArchitectureEntry, FixupInstRVA) - 0usize];
    ["Offset of field: _ImageArchitectureEntry::NewInst"]
        [::std::mem::offset_of!(_ImageArchitectureEntry, NewInst) - 4usize];
};
pub type IMAGE_ARCHITECTURE_ENTRY = _ImageArchitectureEntry;
pub type PIMAGE_ARCHITECTURE_ENTRY = *mut _ImageArchitectureEntry;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct IMPORT_OBJECT_HEADER {
    pub Sig1: WORD,
    pub Sig2: WORD,
    pub Version: WORD,
    pub Machine: WORD,
    pub TimeDateStamp: DWORD,
    pub SizeOfData: DWORD,
    pub __bindgen_anon_1: IMPORT_OBJECT_HEADER__bindgen_ty_1,
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union IMPORT_OBJECT_HEADER__bindgen_ty_1 {
    pub Ordinal: WORD,
    pub Hint: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMPORT_OBJECT_HEADER__bindgen_ty_1"]
        [::std::mem::size_of::<IMPORT_OBJECT_HEADER__bindgen_ty_1>() - 2usize];
    ["Alignment of IMPORT_OBJECT_HEADER__bindgen_ty_1"]
        [::std::mem::align_of::<IMPORT_OBJECT_HEADER__bindgen_ty_1>() - 2usize];
    ["Offset of field: IMPORT_OBJECT_HEADER__bindgen_ty_1::Ordinal"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER__bindgen_ty_1, Ordinal) - 0usize];
    ["Offset of field: IMPORT_OBJECT_HEADER__bindgen_ty_1::Hint"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER__bindgen_ty_1, Hint) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMPORT_OBJECT_HEADER"][::std::mem::size_of::<IMPORT_OBJECT_HEADER>() - 20usize];
    ["Alignment of IMPORT_OBJECT_HEADER"][::std::mem::align_of::<IMPORT_OBJECT_HEADER>() - 4usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::Sig1"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, Sig1) - 0usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::Sig2"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, Sig2) - 2usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::Version"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, Version) - 4usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::Machine"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, Machine) - 6usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::TimeDateStamp"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, TimeDateStamp) - 8usize];
    ["Offset of field: IMPORT_OBJECT_HEADER::SizeOfData"]
        [::std::mem::offset_of!(IMPORT_OBJECT_HEADER, SizeOfData) - 12usize];
};
impl IMPORT_OBJECT_HEADER {
    #[inline]
    pub fn Type(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 2u8) as u16) }
    }
    #[inline]
    pub fn set_Type(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Type_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                2u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Type_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn NameType(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 3u8) as u16) }
    }
    #[inline]
    pub fn set_NameType(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NameType_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                3u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_NameType_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> WORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 11u8) as u16) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 11u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> WORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                11u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: WORD) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                11u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Type: WORD,
        NameType: WORD,
        Reserved: WORD,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let Type: u16 = unsafe { ::std::mem::transmute(Type) };
            Type as u64
        });
        __bindgen_bitfield_unit.set(2usize, 3u8, {
            let NameType: u16 = unsafe { ::std::mem::transmute(NameType) };
            NameType as u64
        });
        __bindgen_bitfield_unit.set(5usize, 11u8, {
            let Reserved: u16 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub const IMPORT_OBJECT_TYPE_IMPORT_OBJECT_CODE: IMPORT_OBJECT_TYPE = 0;
pub const IMPORT_OBJECT_TYPE_IMPORT_OBJECT_DATA: IMPORT_OBJECT_TYPE = 1;
pub const IMPORT_OBJECT_TYPE_IMPORT_OBJECT_CONST: IMPORT_OBJECT_TYPE = 2;
pub type IMPORT_OBJECT_TYPE = ::std::os::raw::c_int;
pub const IMPORT_OBJECT_NAME_TYPE_IMPORT_OBJECT_ORDINAL: IMPORT_OBJECT_NAME_TYPE = 0;
pub const IMPORT_OBJECT_NAME_TYPE_IMPORT_OBJECT_NAME: IMPORT_OBJECT_NAME_TYPE = 1;
pub const IMPORT_OBJECT_NAME_TYPE_IMPORT_OBJECT_NAME_NO_PREFIX: IMPORT_OBJECT_NAME_TYPE = 2;
pub const IMPORT_OBJECT_NAME_TYPE_IMPORT_OBJECT_NAME_UNDECORATE: IMPORT_OBJECT_NAME_TYPE = 3;
pub const IMPORT_OBJECT_NAME_TYPE_IMPORT_OBJECT_NAME_EXPORTAS: IMPORT_OBJECT_NAME_TYPE = 4;
pub type IMPORT_OBJECT_NAME_TYPE = ::std::os::raw::c_int;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_ILONLY: ReplacesCorHdrNumericDefines = 1;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_32BITREQUIRED: ReplacesCorHdrNumericDefines =
    2;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_IL_LIBRARY: ReplacesCorHdrNumericDefines = 4;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_STRONGNAMESIGNED:
    ReplacesCorHdrNumericDefines = 8;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_NATIVE_ENTRYPOINT:
    ReplacesCorHdrNumericDefines = 16;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_TRACKDEBUGDATA: ReplacesCorHdrNumericDefines =
    65536;
pub const ReplacesCorHdrNumericDefines_COMIMAGE_FLAGS_32BITPREFERRED: ReplacesCorHdrNumericDefines =
    131072;
pub const ReplacesCorHdrNumericDefines_COR_VERSION_MAJOR_V2: ReplacesCorHdrNumericDefines = 2;
pub const ReplacesCorHdrNumericDefines_COR_VERSION_MAJOR: ReplacesCorHdrNumericDefines = 2;
pub const ReplacesCorHdrNumericDefines_COR_VERSION_MINOR: ReplacesCorHdrNumericDefines = 5;
pub const ReplacesCorHdrNumericDefines_COR_DELETED_NAME_LENGTH: ReplacesCorHdrNumericDefines = 8;
pub const ReplacesCorHdrNumericDefines_COR_VTABLEGAP_NAME_LENGTH: ReplacesCorHdrNumericDefines = 8;
pub const ReplacesCorHdrNumericDefines_NATIVE_TYPE_MAX_CB: ReplacesCorHdrNumericDefines = 1;
pub const ReplacesCorHdrNumericDefines_COR_ILMETHOD_SECT_SMALL_MAX_DATASIZE:
    ReplacesCorHdrNumericDefines = 255;
pub const ReplacesCorHdrNumericDefines_IMAGE_COR_MIH_METHODRVA: ReplacesCorHdrNumericDefines = 1;
pub const ReplacesCorHdrNumericDefines_IMAGE_COR_MIH_EHRVA: ReplacesCorHdrNumericDefines = 2;
pub const ReplacesCorHdrNumericDefines_IMAGE_COR_MIH_BASICBLOCK: ReplacesCorHdrNumericDefines = 8;
pub const ReplacesCorHdrNumericDefines_COR_VTABLE_32BIT: ReplacesCorHdrNumericDefines = 1;
pub const ReplacesCorHdrNumericDefines_COR_VTABLE_64BIT: ReplacesCorHdrNumericDefines = 2;
pub const ReplacesCorHdrNumericDefines_COR_VTABLE_FROM_UNMANAGED: ReplacesCorHdrNumericDefines = 4;
pub const ReplacesCorHdrNumericDefines_COR_VTABLE_FROM_UNMANAGED_RETAIN_APPDOMAIN:
    ReplacesCorHdrNumericDefines = 8;
pub const ReplacesCorHdrNumericDefines_COR_VTABLE_CALL_MOST_DERIVED: ReplacesCorHdrNumericDefines =
    16;
pub const ReplacesCorHdrNumericDefines_IMAGE_COR_EATJ_THUNK_SIZE: ReplacesCorHdrNumericDefines = 32;
pub const ReplacesCorHdrNumericDefines_MAX_CLASS_NAME: ReplacesCorHdrNumericDefines = 1024;
pub const ReplacesCorHdrNumericDefines_MAX_PACKAGE_NAME: ReplacesCorHdrNumericDefines = 1024;
pub type ReplacesCorHdrNumericDefines = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct IMAGE_COR20_HEADER {
    pub cb: DWORD,
    pub MajorRuntimeVersion: WORD,
    pub MinorRuntimeVersion: WORD,
    pub MetaData: IMAGE_DATA_DIRECTORY,
    pub Flags: DWORD,
    pub __bindgen_anon_1: IMAGE_COR20_HEADER__bindgen_ty_1,
    pub Resources: IMAGE_DATA_DIRECTORY,
    pub StrongNameSignature: IMAGE_DATA_DIRECTORY,
    pub CodeManagerTable: IMAGE_DATA_DIRECTORY,
    pub VTableFixups: IMAGE_DATA_DIRECTORY,
    pub ExportAddressTableJumps: IMAGE_DATA_DIRECTORY,
    pub ManagedNativeHeader: IMAGE_DATA_DIRECTORY,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union IMAGE_COR20_HEADER__bindgen_ty_1 {
    pub EntryPointToken: DWORD,
    pub EntryPointRVA: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMAGE_COR20_HEADER__bindgen_ty_1"]
        [::std::mem::size_of::<IMAGE_COR20_HEADER__bindgen_ty_1>() - 4usize];
    ["Alignment of IMAGE_COR20_HEADER__bindgen_ty_1"]
        [::std::mem::align_of::<IMAGE_COR20_HEADER__bindgen_ty_1>() - 4usize];
    ["Offset of field: IMAGE_COR20_HEADER__bindgen_ty_1::EntryPointToken"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER__bindgen_ty_1, EntryPointToken) - 0usize];
    ["Offset of field: IMAGE_COR20_HEADER__bindgen_ty_1::EntryPointRVA"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER__bindgen_ty_1, EntryPointRVA) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMAGE_COR20_HEADER"][::std::mem::size_of::<IMAGE_COR20_HEADER>() - 72usize];
    ["Alignment of IMAGE_COR20_HEADER"][::std::mem::align_of::<IMAGE_COR20_HEADER>() - 4usize];
    ["Offset of field: IMAGE_COR20_HEADER::cb"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, cb) - 0usize];
    ["Offset of field: IMAGE_COR20_HEADER::MajorRuntimeVersion"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, MajorRuntimeVersion) - 4usize];
    ["Offset of field: IMAGE_COR20_HEADER::MinorRuntimeVersion"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, MinorRuntimeVersion) - 6usize];
    ["Offset of field: IMAGE_COR20_HEADER::MetaData"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, MetaData) - 8usize];
    ["Offset of field: IMAGE_COR20_HEADER::Flags"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, Flags) - 16usize];
    ["Offset of field: IMAGE_COR20_HEADER::Resources"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, Resources) - 24usize];
    ["Offset of field: IMAGE_COR20_HEADER::StrongNameSignature"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, StrongNameSignature) - 32usize];
    ["Offset of field: IMAGE_COR20_HEADER::CodeManagerTable"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, CodeManagerTable) - 40usize];
    ["Offset of field: IMAGE_COR20_HEADER::VTableFixups"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, VTableFixups) - 48usize];
    ["Offset of field: IMAGE_COR20_HEADER::ExportAddressTableJumps"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, ExportAddressTableJumps) - 56usize];
    ["Offset of field: IMAGE_COR20_HEADER::ManagedNativeHeader"]
        [::std::mem::offset_of!(IMAGE_COR20_HEADER, ManagedNativeHeader) - 64usize];
};
pub type PIMAGE_COR20_HEADER = *mut IMAGE_COR20_HEADER;
unsafe extern "C" {
    pub fn RtlCaptureStackBackTrace(
        FramesToSkip: DWORD,
        FramesToCapture: DWORD,
        BackTrace: *mut PVOID,
        BackTraceHash: PDWORD,
    ) -> WORD;
}
unsafe extern "C" {
    pub fn RtlCaptureContext(ContextRecord: PCONTEXT);
}
unsafe extern "C" {
    pub fn RtlCaptureContext2(ContextRecord: PCONTEXT);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UNWIND_HISTORY_TABLE_ENTRY {
    pub ImageBase: ULONG_PTR,
    pub FunctionEntry: PRUNTIME_FUNCTION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UNWIND_HISTORY_TABLE_ENTRY"]
        [::std::mem::size_of::<_UNWIND_HISTORY_TABLE_ENTRY>() - 16usize];
    ["Alignment of _UNWIND_HISTORY_TABLE_ENTRY"]
        [::std::mem::align_of::<_UNWIND_HISTORY_TABLE_ENTRY>() - 8usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE_ENTRY::ImageBase"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE_ENTRY, ImageBase) - 0usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE_ENTRY::FunctionEntry"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE_ENTRY, FunctionEntry) - 8usize];
};
pub type UNWIND_HISTORY_TABLE_ENTRY = _UNWIND_HISTORY_TABLE_ENTRY;
pub type PUNWIND_HISTORY_TABLE_ENTRY = *mut _UNWIND_HISTORY_TABLE_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UNWIND_HISTORY_TABLE {
    pub Count: DWORD,
    pub LocalHint: BYTE,
    pub GlobalHint: BYTE,
    pub Search: BYTE,
    pub Once: BYTE,
    pub LowAddress: ULONG_PTR,
    pub HighAddress: ULONG_PTR,
    pub Entry: [UNWIND_HISTORY_TABLE_ENTRY; 12usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UNWIND_HISTORY_TABLE"][::std::mem::size_of::<_UNWIND_HISTORY_TABLE>() - 216usize];
    ["Alignment of _UNWIND_HISTORY_TABLE"]
        [::std::mem::align_of::<_UNWIND_HISTORY_TABLE>() - 8usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::Count"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, Count) - 0usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::LocalHint"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, LocalHint) - 4usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::GlobalHint"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, GlobalHint) - 5usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::Search"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, Search) - 6usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::Once"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, Once) - 7usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::LowAddress"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, LowAddress) - 8usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::HighAddress"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, HighAddress) - 16usize];
    ["Offset of field: _UNWIND_HISTORY_TABLE::Entry"]
        [::std::mem::offset_of!(_UNWIND_HISTORY_TABLE, Entry) - 24usize];
};
pub type UNWIND_HISTORY_TABLE = _UNWIND_HISTORY_TABLE;
pub type PUNWIND_HISTORY_TABLE = *mut _UNWIND_HISTORY_TABLE;
unsafe extern "C" {
    pub fn RtlUnwind(
        TargetFrame: PVOID,
        TargetIp: PVOID,
        ExceptionRecord: PEXCEPTION_RECORD,
        ReturnValue: PVOID,
    );
}
unsafe extern "C" {
    pub fn RtlAddFunctionTable(
        FunctionTable: PRUNTIME_FUNCTION,
        EntryCount: DWORD,
        BaseAddress: DWORD64,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn RtlDeleteFunctionTable(FunctionTable: PRUNTIME_FUNCTION) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn RtlInstallFunctionTableCallback(
        TableIdentifier: DWORD64,
        BaseAddress: DWORD64,
        Length: DWORD,
        Callback: PGET_RUNTIME_FUNCTION_CALLBACK,
        Context: PVOID,
        OutOfProcessCallbackDll: PCWSTR,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn RtlAddGrowableFunctionTable(
        DynamicTable: *mut PVOID,
        FunctionTable: PRUNTIME_FUNCTION,
        EntryCount: DWORD,
        MaximumEntryCount: DWORD,
        RangeBase: ULONG_PTR,
        RangeEnd: ULONG_PTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlGrowFunctionTable(DynamicTable: PVOID, NewEntryCount: DWORD);
}
unsafe extern "C" {
    pub fn RtlDeleteGrowableFunctionTable(DynamicTable: PVOID);
}
unsafe extern "C" {
    pub fn RtlLookupFunctionEntry(
        ControlPc: DWORD64,
        ImageBase: PDWORD64,
        HistoryTable: PUNWIND_HISTORY_TABLE,
    ) -> PRUNTIME_FUNCTION;
}
unsafe extern "C" {
    pub fn RtlRestoreContext(ContextRecord: PCONTEXT, ExceptionRecord: *mut _EXCEPTION_RECORD);
}
unsafe extern "C" {
    pub fn RtlUnwindEx(
        TargetFrame: PVOID,
        TargetIp: PVOID,
        ExceptionRecord: PEXCEPTION_RECORD,
        ReturnValue: PVOID,
        ContextRecord: PCONTEXT,
        HistoryTable: PUNWIND_HISTORY_TABLE,
    );
}
unsafe extern "C" {
    pub fn RtlVirtualUnwind(
        HandlerType: DWORD,
        ImageBase: DWORD64,
        ControlPc: DWORD64,
        FunctionEntry: PRUNTIME_FUNCTION,
        ContextRecord: PCONTEXT,
        HandlerData: *mut PVOID,
        EstablisherFrame: PDWORD64,
        ContextPointers: PKNONVOLATILE_CONTEXT_POINTERS,
    ) -> PEXCEPTION_ROUTINE;
}
unsafe extern "C" {
    pub fn RtlRaiseException(ExceptionRecord: PEXCEPTION_RECORD);
}
unsafe extern "C" {
    pub fn RtlPcToFileHeader(PcValue: PVOID, BaseOfImage: *mut PVOID) -> PVOID;
}
unsafe extern "C" {
    pub fn RtlCompareMemory(
        Source1: *const ::std::os::raw::c_void,
        Source2: *const ::std::os::raw::c_void,
        Length: SIZE_T,
    ) -> SIZE_T;
}
#[repr(C)]
#[repr(align(16))]
#[derive(Debug, Copy, Clone)]
pub struct _SLIST_ENTRY {
    pub Next: *mut _SLIST_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SLIST_ENTRY"][::std::mem::size_of::<_SLIST_ENTRY>() - 16usize];
    ["Alignment of _SLIST_ENTRY"][::std::mem::align_of::<_SLIST_ENTRY>() - 16usize];
    ["Offset of field: _SLIST_ENTRY::Next"][::std::mem::offset_of!(_SLIST_ENTRY, Next) - 0usize];
};
pub type SLIST_ENTRY = _SLIST_ENTRY;
pub type PSLIST_ENTRY = *mut _SLIST_ENTRY;
#[repr(C)]
#[repr(align(16))]
#[derive(Copy, Clone)]
pub union _SLIST_HEADER {
    pub __bindgen_anon_1: _SLIST_HEADER__bindgen_ty_1,
    pub HeaderX64: _SLIST_HEADER__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SLIST_HEADER__bindgen_ty_1 {
    pub Alignment: ULONGLONG,
    pub Region: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SLIST_HEADER__bindgen_ty_1"]
        [::std::mem::size_of::<_SLIST_HEADER__bindgen_ty_1>() - 16usize];
    ["Alignment of _SLIST_HEADER__bindgen_ty_1"]
        [::std::mem::align_of::<_SLIST_HEADER__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SLIST_HEADER__bindgen_ty_1::Alignment"]
        [::std::mem::offset_of!(_SLIST_HEADER__bindgen_ty_1, Alignment) - 0usize];
    ["Offset of field: _SLIST_HEADER__bindgen_ty_1::Region"]
        [::std::mem::offset_of!(_SLIST_HEADER__bindgen_ty_1, Region) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SLIST_HEADER__bindgen_ty_2 {
    pub _bitfield_align_1: [u64; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 16usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SLIST_HEADER__bindgen_ty_2"]
        [::std::mem::size_of::<_SLIST_HEADER__bindgen_ty_2>() - 16usize];
    ["Alignment of _SLIST_HEADER__bindgen_ty_2"]
        [::std::mem::align_of::<_SLIST_HEADER__bindgen_ty_2>() - 8usize];
};
impl _SLIST_HEADER__bindgen_ty_2 {
    #[inline]
    pub fn Depth(&self) -> ULONGLONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 16u8) as u64) }
    }
    #[inline]
    pub fn set_Depth(&mut self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Depth_raw(this: *const Self) -> ULONGLONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 16usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                16u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_Depth_raw(this: *mut Self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 16usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Sequence(&self) -> ULONGLONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 48u8) as u64) }
    }
    #[inline]
    pub fn set_Sequence(&mut self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 48u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Sequence_raw(this: *const Self) -> ULONGLONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 16usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                48u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_Sequence_raw(this: *mut Self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 16usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                48u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> ULONGLONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(64usize, 4u8) as u64) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(64usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> ULONGLONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 16usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                64usize,
                4u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 16usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                64usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn NextEntry(&self) -> ULONGLONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(68usize, 60u8) as u64) }
    }
    #[inline]
    pub fn set_NextEntry(&mut self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            self._bitfield_1.set(68usize, 60u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn NextEntry_raw(this: *const Self) -> ULONGLONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 16usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                68usize,
                60u8,
            ) as u64)
        }
    }
    #[inline]
    pub unsafe fn set_NextEntry_raw(this: *mut Self, val: ULONGLONG) {
        unsafe {
            let val: u64 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 16usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                68usize,
                60u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Depth: ULONGLONG,
        Sequence: ULONGLONG,
        Reserved: ULONGLONG,
        NextEntry: ULONGLONG,
    ) -> __BindgenBitfieldUnit<[u8; 16usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 16usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 16u8, {
            let Depth: u64 = unsafe { ::std::mem::transmute(Depth) };
            Depth as u64
        });
        __bindgen_bitfield_unit.set(16usize, 48u8, {
            let Sequence: u64 = unsafe { ::std::mem::transmute(Sequence) };
            Sequence as u64
        });
        __bindgen_bitfield_unit.set(64usize, 4u8, {
            let Reserved: u64 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit.set(68usize, 60u8, {
            let NextEntry: u64 = unsafe { ::std::mem::transmute(NextEntry) };
            NextEntry as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SLIST_HEADER"][::std::mem::size_of::<_SLIST_HEADER>() - 16usize];
    ["Alignment of _SLIST_HEADER"][::std::mem::align_of::<_SLIST_HEADER>() - 16usize];
    ["Offset of field: _SLIST_HEADER::HeaderX64"]
        [::std::mem::offset_of!(_SLIST_HEADER, HeaderX64) - 0usize];
};
pub type SLIST_HEADER = _SLIST_HEADER;
pub type PSLIST_HEADER = *mut _SLIST_HEADER;
unsafe extern "C" {
    pub fn RtlInitializeSListHead(ListHead: PSLIST_HEADER);
}
unsafe extern "C" {
    pub fn RtlFirstEntrySList(ListHead: *const SLIST_HEADER) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn RtlInterlockedPopEntrySList(ListHead: PSLIST_HEADER) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn RtlInterlockedPushEntrySList(
        ListHead: PSLIST_HEADER,
        ListEntry: PSLIST_ENTRY,
    ) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn RtlInterlockedPushListSListEx(
        ListHead: PSLIST_HEADER,
        List: PSLIST_ENTRY,
        ListEnd: PSLIST_ENTRY,
        Count: DWORD,
    ) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn RtlInterlockedFlushSList(ListHead: PSLIST_HEADER) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn RtlQueryDepthSList(ListHead: PSLIST_HEADER) -> WORD;
}
unsafe extern "C" {
    pub fn RtlGetReturnAddressHijackTarget() -> ULONG_PTR;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RTL_RUN_ONCE {
    pub Ptr: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_RUN_ONCE"][::std::mem::size_of::<_RTL_RUN_ONCE>() - 8usize];
    ["Alignment of _RTL_RUN_ONCE"][::std::mem::align_of::<_RTL_RUN_ONCE>() - 8usize];
    ["Offset of field: _RTL_RUN_ONCE::Ptr"][::std::mem::offset_of!(_RTL_RUN_ONCE, Ptr) - 0usize];
};
pub type RTL_RUN_ONCE = _RTL_RUN_ONCE;
pub type PRTL_RUN_ONCE = *mut _RTL_RUN_ONCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RTL_BARRIER {
    pub Reserved1: DWORD,
    pub Reserved2: DWORD,
    pub Reserved3: [ULONG_PTR; 2usize],
    pub Reserved4: DWORD,
    pub Reserved5: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_BARRIER"][::std::mem::size_of::<_RTL_BARRIER>() - 32usize];
    ["Alignment of _RTL_BARRIER"][::std::mem::align_of::<_RTL_BARRIER>() - 8usize];
    ["Offset of field: _RTL_BARRIER::Reserved1"]
        [::std::mem::offset_of!(_RTL_BARRIER, Reserved1) - 0usize];
    ["Offset of field: _RTL_BARRIER::Reserved2"]
        [::std::mem::offset_of!(_RTL_BARRIER, Reserved2) - 4usize];
    ["Offset of field: _RTL_BARRIER::Reserved3"]
        [::std::mem::offset_of!(_RTL_BARRIER, Reserved3) - 8usize];
    ["Offset of field: _RTL_BARRIER::Reserved4"]
        [::std::mem::offset_of!(_RTL_BARRIER, Reserved4) - 24usize];
    ["Offset of field: _RTL_BARRIER::Reserved5"]
        [::std::mem::offset_of!(_RTL_BARRIER, Reserved5) - 28usize];
};
pub type RTL_BARRIER = _RTL_BARRIER;
pub type PRTL_BARRIER = *mut _RTL_BARRIER;
unsafe extern "C" {
    pub fn __fastfail(Code: ::std::os::raw::c_uint) -> !;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MESSAGE_RESOURCE_ENTRY {
    pub Length: WORD,
    pub Flags: WORD,
    pub Text: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MESSAGE_RESOURCE_ENTRY"][::std::mem::size_of::<_MESSAGE_RESOURCE_ENTRY>() - 6usize];
    ["Alignment of _MESSAGE_RESOURCE_ENTRY"]
        [::std::mem::align_of::<_MESSAGE_RESOURCE_ENTRY>() - 2usize];
    ["Offset of field: _MESSAGE_RESOURCE_ENTRY::Length"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_ENTRY, Length) - 0usize];
    ["Offset of field: _MESSAGE_RESOURCE_ENTRY::Flags"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_ENTRY, Flags) - 2usize];
    ["Offset of field: _MESSAGE_RESOURCE_ENTRY::Text"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_ENTRY, Text) - 4usize];
};
pub type MESSAGE_RESOURCE_ENTRY = _MESSAGE_RESOURCE_ENTRY;
pub type PMESSAGE_RESOURCE_ENTRY = *mut _MESSAGE_RESOURCE_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MESSAGE_RESOURCE_BLOCK {
    pub LowId: DWORD,
    pub HighId: DWORD,
    pub OffsetToEntries: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MESSAGE_RESOURCE_BLOCK"][::std::mem::size_of::<_MESSAGE_RESOURCE_BLOCK>() - 12usize];
    ["Alignment of _MESSAGE_RESOURCE_BLOCK"]
        [::std::mem::align_of::<_MESSAGE_RESOURCE_BLOCK>() - 4usize];
    ["Offset of field: _MESSAGE_RESOURCE_BLOCK::LowId"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_BLOCK, LowId) - 0usize];
    ["Offset of field: _MESSAGE_RESOURCE_BLOCK::HighId"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_BLOCK, HighId) - 4usize];
    ["Offset of field: _MESSAGE_RESOURCE_BLOCK::OffsetToEntries"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_BLOCK, OffsetToEntries) - 8usize];
};
pub type MESSAGE_RESOURCE_BLOCK = _MESSAGE_RESOURCE_BLOCK;
pub type PMESSAGE_RESOURCE_BLOCK = *mut _MESSAGE_RESOURCE_BLOCK;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MESSAGE_RESOURCE_DATA {
    pub NumberOfBlocks: DWORD,
    pub Blocks: [MESSAGE_RESOURCE_BLOCK; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MESSAGE_RESOURCE_DATA"][::std::mem::size_of::<_MESSAGE_RESOURCE_DATA>() - 16usize];
    ["Alignment of _MESSAGE_RESOURCE_DATA"]
        [::std::mem::align_of::<_MESSAGE_RESOURCE_DATA>() - 4usize];
    ["Offset of field: _MESSAGE_RESOURCE_DATA::NumberOfBlocks"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_DATA, NumberOfBlocks) - 0usize];
    ["Offset of field: _MESSAGE_RESOURCE_DATA::Blocks"]
        [::std::mem::offset_of!(_MESSAGE_RESOURCE_DATA, Blocks) - 4usize];
};
pub type MESSAGE_RESOURCE_DATA = _MESSAGE_RESOURCE_DATA;
pub type PMESSAGE_RESOURCE_DATA = *mut _MESSAGE_RESOURCE_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OSVERSIONINFOA {
    pub dwOSVersionInfoSize: DWORD,
    pub dwMajorVersion: DWORD,
    pub dwMinorVersion: DWORD,
    pub dwBuildNumber: DWORD,
    pub dwPlatformId: DWORD,
    pub szCSDVersion: [CHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OSVERSIONINFOA"][::std::mem::size_of::<_OSVERSIONINFOA>() - 148usize];
    ["Alignment of _OSVERSIONINFOA"][::std::mem::align_of::<_OSVERSIONINFOA>() - 4usize];
    ["Offset of field: _OSVERSIONINFOA::dwOSVersionInfoSize"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, dwOSVersionInfoSize) - 0usize];
    ["Offset of field: _OSVERSIONINFOA::dwMajorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, dwMajorVersion) - 4usize];
    ["Offset of field: _OSVERSIONINFOA::dwMinorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, dwMinorVersion) - 8usize];
    ["Offset of field: _OSVERSIONINFOA::dwBuildNumber"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, dwBuildNumber) - 12usize];
    ["Offset of field: _OSVERSIONINFOA::dwPlatformId"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, dwPlatformId) - 16usize];
    ["Offset of field: _OSVERSIONINFOA::szCSDVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOA, szCSDVersion) - 20usize];
};
pub type OSVERSIONINFOA = _OSVERSIONINFOA;
pub type POSVERSIONINFOA = *mut _OSVERSIONINFOA;
pub type LPOSVERSIONINFOA = *mut _OSVERSIONINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OSVERSIONINFOW {
    pub dwOSVersionInfoSize: DWORD,
    pub dwMajorVersion: DWORD,
    pub dwMinorVersion: DWORD,
    pub dwBuildNumber: DWORD,
    pub dwPlatformId: DWORD,
    pub szCSDVersion: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OSVERSIONINFOW"][::std::mem::size_of::<_OSVERSIONINFOW>() - 276usize];
    ["Alignment of _OSVERSIONINFOW"][::std::mem::align_of::<_OSVERSIONINFOW>() - 4usize];
    ["Offset of field: _OSVERSIONINFOW::dwOSVersionInfoSize"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, dwOSVersionInfoSize) - 0usize];
    ["Offset of field: _OSVERSIONINFOW::dwMajorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, dwMajorVersion) - 4usize];
    ["Offset of field: _OSVERSIONINFOW::dwMinorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, dwMinorVersion) - 8usize];
    ["Offset of field: _OSVERSIONINFOW::dwBuildNumber"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, dwBuildNumber) - 12usize];
    ["Offset of field: _OSVERSIONINFOW::dwPlatformId"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, dwPlatformId) - 16usize];
    ["Offset of field: _OSVERSIONINFOW::szCSDVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOW, szCSDVersion) - 20usize];
};
pub type OSVERSIONINFOW = _OSVERSIONINFOW;
pub type POSVERSIONINFOW = *mut _OSVERSIONINFOW;
pub type LPOSVERSIONINFOW = *mut _OSVERSIONINFOW;
pub type RTL_OSVERSIONINFOW = _OSVERSIONINFOW;
pub type PRTL_OSVERSIONINFOW = *mut _OSVERSIONINFOW;
pub type OSVERSIONINFO = OSVERSIONINFOA;
pub type POSVERSIONINFO = POSVERSIONINFOA;
pub type LPOSVERSIONINFO = LPOSVERSIONINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OSVERSIONINFOEXA {
    pub dwOSVersionInfoSize: DWORD,
    pub dwMajorVersion: DWORD,
    pub dwMinorVersion: DWORD,
    pub dwBuildNumber: DWORD,
    pub dwPlatformId: DWORD,
    pub szCSDVersion: [CHAR; 128usize],
    pub wServicePackMajor: WORD,
    pub wServicePackMinor: WORD,
    pub wSuiteMask: WORD,
    pub wProductType: BYTE,
    pub wReserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OSVERSIONINFOEXA"][::std::mem::size_of::<_OSVERSIONINFOEXA>() - 156usize];
    ["Alignment of _OSVERSIONINFOEXA"][::std::mem::align_of::<_OSVERSIONINFOEXA>() - 4usize];
    ["Offset of field: _OSVERSIONINFOEXA::dwOSVersionInfoSize"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, dwOSVersionInfoSize) - 0usize];
    ["Offset of field: _OSVERSIONINFOEXA::dwMajorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, dwMajorVersion) - 4usize];
    ["Offset of field: _OSVERSIONINFOEXA::dwMinorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, dwMinorVersion) - 8usize];
    ["Offset of field: _OSVERSIONINFOEXA::dwBuildNumber"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, dwBuildNumber) - 12usize];
    ["Offset of field: _OSVERSIONINFOEXA::dwPlatformId"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, dwPlatformId) - 16usize];
    ["Offset of field: _OSVERSIONINFOEXA::szCSDVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, szCSDVersion) - 20usize];
    ["Offset of field: _OSVERSIONINFOEXA::wServicePackMajor"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, wServicePackMajor) - 148usize];
    ["Offset of field: _OSVERSIONINFOEXA::wServicePackMinor"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, wServicePackMinor) - 150usize];
    ["Offset of field: _OSVERSIONINFOEXA::wSuiteMask"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, wSuiteMask) - 152usize];
    ["Offset of field: _OSVERSIONINFOEXA::wProductType"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, wProductType) - 154usize];
    ["Offset of field: _OSVERSIONINFOEXA::wReserved"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXA, wReserved) - 155usize];
};
pub type OSVERSIONINFOEXA = _OSVERSIONINFOEXA;
pub type POSVERSIONINFOEXA = *mut _OSVERSIONINFOEXA;
pub type LPOSVERSIONINFOEXA = *mut _OSVERSIONINFOEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OSVERSIONINFOEXW {
    pub dwOSVersionInfoSize: DWORD,
    pub dwMajorVersion: DWORD,
    pub dwMinorVersion: DWORD,
    pub dwBuildNumber: DWORD,
    pub dwPlatformId: DWORD,
    pub szCSDVersion: [WCHAR; 128usize],
    pub wServicePackMajor: WORD,
    pub wServicePackMinor: WORD,
    pub wSuiteMask: WORD,
    pub wProductType: BYTE,
    pub wReserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OSVERSIONINFOEXW"][::std::mem::size_of::<_OSVERSIONINFOEXW>() - 284usize];
    ["Alignment of _OSVERSIONINFOEXW"][::std::mem::align_of::<_OSVERSIONINFOEXW>() - 4usize];
    ["Offset of field: _OSVERSIONINFOEXW::dwOSVersionInfoSize"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, dwOSVersionInfoSize) - 0usize];
    ["Offset of field: _OSVERSIONINFOEXW::dwMajorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, dwMajorVersion) - 4usize];
    ["Offset of field: _OSVERSIONINFOEXW::dwMinorVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, dwMinorVersion) - 8usize];
    ["Offset of field: _OSVERSIONINFOEXW::dwBuildNumber"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, dwBuildNumber) - 12usize];
    ["Offset of field: _OSVERSIONINFOEXW::dwPlatformId"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, dwPlatformId) - 16usize];
    ["Offset of field: _OSVERSIONINFOEXW::szCSDVersion"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, szCSDVersion) - 20usize];
    ["Offset of field: _OSVERSIONINFOEXW::wServicePackMajor"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, wServicePackMajor) - 276usize];
    ["Offset of field: _OSVERSIONINFOEXW::wServicePackMinor"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, wServicePackMinor) - 278usize];
    ["Offset of field: _OSVERSIONINFOEXW::wSuiteMask"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, wSuiteMask) - 280usize];
    ["Offset of field: _OSVERSIONINFOEXW::wProductType"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, wProductType) - 282usize];
    ["Offset of field: _OSVERSIONINFOEXW::wReserved"]
        [::std::mem::offset_of!(_OSVERSIONINFOEXW, wReserved) - 283usize];
};
pub type OSVERSIONINFOEXW = _OSVERSIONINFOEXW;
pub type POSVERSIONINFOEXW = *mut _OSVERSIONINFOEXW;
pub type LPOSVERSIONINFOEXW = *mut _OSVERSIONINFOEXW;
pub type RTL_OSVERSIONINFOEXW = _OSVERSIONINFOEXW;
pub type PRTL_OSVERSIONINFOEXW = *mut _OSVERSIONINFOEXW;
pub type OSVERSIONINFOEX = OSVERSIONINFOEXA;
pub type POSVERSIONINFOEX = POSVERSIONINFOEXA;
pub type LPOSVERSIONINFOEX = LPOSVERSIONINFOEXA;
unsafe extern "C" {
    pub fn VerSetConditionMask(
        ConditionMask: ULONGLONG,
        TypeMask: DWORD,
        Condition: BYTE,
    ) -> ULONGLONG;
}
unsafe extern "C" {
    pub fn RtlGetProductInfo(
        OSMajorVersion: DWORD,
        OSMinorVersion: DWORD,
        SpMajorVersion: DWORD,
        SpMinorVersion: DWORD,
        ReturnedProductType: PDWORD,
    ) -> BOOLEAN;
}
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadInvalidInfoClass: _RTL_UMS_THREAD_INFO_CLASS = 0;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadUserContext: _RTL_UMS_THREAD_INFO_CLASS = 1;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadPriority: _RTL_UMS_THREAD_INFO_CLASS = 2;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadAffinity: _RTL_UMS_THREAD_INFO_CLASS = 3;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadTeb: _RTL_UMS_THREAD_INFO_CLASS = 4;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadIsSuspended: _RTL_UMS_THREAD_INFO_CLASS = 5;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadIsTerminated: _RTL_UMS_THREAD_INFO_CLASS = 6;
pub const _RTL_UMS_THREAD_INFO_CLASS_UmsThreadMaxInfoClass: _RTL_UMS_THREAD_INFO_CLASS = 7;
pub type _RTL_UMS_THREAD_INFO_CLASS = ::std::os::raw::c_int;
pub use self::_RTL_UMS_THREAD_INFO_CLASS as RTL_UMS_THREAD_INFO_CLASS;
pub type PRTL_UMS_THREAD_INFO_CLASS = *mut _RTL_UMS_THREAD_INFO_CLASS;
pub const _RTL_UMS_SCHEDULER_REASON_UmsSchedulerStartup: _RTL_UMS_SCHEDULER_REASON = 0;
pub const _RTL_UMS_SCHEDULER_REASON_UmsSchedulerThreadBlocked: _RTL_UMS_SCHEDULER_REASON = 1;
pub const _RTL_UMS_SCHEDULER_REASON_UmsSchedulerThreadYield: _RTL_UMS_SCHEDULER_REASON = 2;
pub type _RTL_UMS_SCHEDULER_REASON = ::std::os::raw::c_int;
pub use self::_RTL_UMS_SCHEDULER_REASON as RTL_UMS_SCHEDULER_REASON;
pub type PRTL_UMS_SCHEDULER_REASON = *mut _RTL_UMS_SCHEDULER_REASON;
pub type PRTL_UMS_SCHEDULER_ENTRY_POINT = ::std::option::Option<
    unsafe extern "C" fn(arg1: RTL_UMS_SCHEDULER_REASON, arg2: ULONG_PTR, arg3: PVOID),
>;
unsafe extern "C" {
    pub fn RtlCrc32(Buffer: *const ::std::os::raw::c_void, Size: usize, InitialCrc: DWORD)
        -> DWORD;
}
unsafe extern "C" {
    pub fn RtlCrc64(
        Buffer: *const ::std::os::raw::c_void,
        Size: usize,
        InitialCrc: ULONGLONG,
    ) -> ULONGLONG;
}
pub const _OS_DEPLOYEMENT_STATE_VALUES_OS_DEPLOYMENT_STANDARD: _OS_DEPLOYEMENT_STATE_VALUES = 1;
pub const _OS_DEPLOYEMENT_STATE_VALUES_OS_DEPLOYMENT_COMPACT: _OS_DEPLOYEMENT_STATE_VALUES = 2;
pub type _OS_DEPLOYEMENT_STATE_VALUES = ::std::os::raw::c_int;
pub use self::_OS_DEPLOYEMENT_STATE_VALUES as OS_DEPLOYEMENT_STATE_VALUES;
unsafe extern "C" {
    pub fn RtlOsDeploymentState(Flags: DWORD) -> OS_DEPLOYEMENT_STATE_VALUES;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NV_MEMORY_RANGE {
    pub BaseAddress: *mut ::std::os::raw::c_void,
    pub Length: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NV_MEMORY_RANGE"][::std::mem::size_of::<_NV_MEMORY_RANGE>() - 16usize];
    ["Alignment of _NV_MEMORY_RANGE"][::std::mem::align_of::<_NV_MEMORY_RANGE>() - 8usize];
    ["Offset of field: _NV_MEMORY_RANGE::BaseAddress"]
        [::std::mem::offset_of!(_NV_MEMORY_RANGE, BaseAddress) - 0usize];
    ["Offset of field: _NV_MEMORY_RANGE::Length"]
        [::std::mem::offset_of!(_NV_MEMORY_RANGE, Length) - 8usize];
};
pub type NV_MEMORY_RANGE = _NV_MEMORY_RANGE;
pub type PNV_MEMORY_RANGE = *mut _NV_MEMORY_RANGE;
unsafe extern "C" {
    pub fn RtlGetNonVolatileToken(NvBuffer: PVOID, Size: SIZE_T, NvToken: *mut PVOID) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlFreeNonVolatileToken(NvToken: PVOID) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlFlushNonVolatileMemory(
        NvToken: PVOID,
        NvBuffer: PVOID,
        Size: SIZE_T,
        Flags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlDrainNonVolatileFlush(NvToken: PVOID) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlWriteNonVolatileMemory(
        NvToken: PVOID,
        NvDestination: *mut ::std::os::raw::c_void,
        Source: *const ::std::os::raw::c_void,
        Size: SIZE_T,
        Flags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlFillNonVolatileMemory(
        NvToken: PVOID,
        NvDestination: *mut ::std::os::raw::c_void,
        Size: SIZE_T,
        Value: BYTE,
        Flags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlFlushNonVolatileMemoryRanges(
        NvToken: PVOID,
        NvRanges: PNV_MEMORY_RANGE,
        NumRanges: SIZE_T,
        Flags: DWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CORRELATION_VECTOR {
    pub Version: CHAR,
    pub Vector: [CHAR; 129usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CORRELATION_VECTOR"][::std::mem::size_of::<CORRELATION_VECTOR>() - 130usize];
    ["Alignment of CORRELATION_VECTOR"][::std::mem::align_of::<CORRELATION_VECTOR>() - 1usize];
    ["Offset of field: CORRELATION_VECTOR::Version"]
        [::std::mem::offset_of!(CORRELATION_VECTOR, Version) - 0usize];
    ["Offset of field: CORRELATION_VECTOR::Vector"]
        [::std::mem::offset_of!(CORRELATION_VECTOR, Vector) - 1usize];
};
pub type PCORRELATION_VECTOR = *mut CORRELATION_VECTOR;
unsafe extern "C" {
    pub fn RtlInitializeCorrelationVector(
        CorrelationVector: PCORRELATION_VECTOR,
        Version: ::std::os::raw::c_int,
        Guid: *const GUID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlIncrementCorrelationVector(CorrelationVector: PCORRELATION_VECTOR) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlExtendCorrelationVector(CorrelationVector: PCORRELATION_VECTOR) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlValidateCorrelationVector(Vector: PCORRELATION_VECTOR) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG {
    pub Size: DWORD,
    pub TriggerId: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG"]
        [::std::mem::size_of::<_CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG>() - 16usize];
    ["Alignment of _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG"]
        [::std::mem::align_of::<_CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG>() - 8usize];
    ["Offset of field: _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG::Size"]
        [::std::mem::offset_of!(_CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG, Size) - 0usize];
    ["Offset of field: _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG::TriggerId"]
        [::std::mem::offset_of!(_CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG, TriggerId) - 8usize];
};
pub type CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG = _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG;
pub type PCUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG = *mut _CUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG;
unsafe extern "C" {
    pub fn RtlRaiseCustomSystemEventTrigger(
        TriggerConfig: PCUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG,
    ) -> DWORD;
}
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeNone: _IMAGE_POLICY_ENTRY_TYPE = 0;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeBool: _IMAGE_POLICY_ENTRY_TYPE = 1;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeInt8: _IMAGE_POLICY_ENTRY_TYPE = 2;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeUInt8: _IMAGE_POLICY_ENTRY_TYPE = 3;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeInt16: _IMAGE_POLICY_ENTRY_TYPE = 4;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeUInt16: _IMAGE_POLICY_ENTRY_TYPE = 5;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeInt32: _IMAGE_POLICY_ENTRY_TYPE = 6;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeUInt32: _IMAGE_POLICY_ENTRY_TYPE = 7;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeInt64: _IMAGE_POLICY_ENTRY_TYPE = 8;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeUInt64: _IMAGE_POLICY_ENTRY_TYPE = 9;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeAnsiString: _IMAGE_POLICY_ENTRY_TYPE = 10;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeUnicodeString: _IMAGE_POLICY_ENTRY_TYPE = 11;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeOverride: _IMAGE_POLICY_ENTRY_TYPE = 12;
pub const _IMAGE_POLICY_ENTRY_TYPE_ImagePolicyEntryTypeMaximum: _IMAGE_POLICY_ENTRY_TYPE = 13;
pub type _IMAGE_POLICY_ENTRY_TYPE = ::std::os::raw::c_int;
pub use self::_IMAGE_POLICY_ENTRY_TYPE as IMAGE_POLICY_ENTRY_TYPE;
pub const _IMAGE_POLICY_ID_ImagePolicyIdNone: _IMAGE_POLICY_ID = 0;
pub const _IMAGE_POLICY_ID_ImagePolicyIdEtw: _IMAGE_POLICY_ID = 1;
pub const _IMAGE_POLICY_ID_ImagePolicyIdDebug: _IMAGE_POLICY_ID = 2;
pub const _IMAGE_POLICY_ID_ImagePolicyIdCrashDump: _IMAGE_POLICY_ID = 3;
pub const _IMAGE_POLICY_ID_ImagePolicyIdCrashDumpKey: _IMAGE_POLICY_ID = 4;
pub const _IMAGE_POLICY_ID_ImagePolicyIdCrashDumpKeyGuid: _IMAGE_POLICY_ID = 5;
pub const _IMAGE_POLICY_ID_ImagePolicyIdParentSd: _IMAGE_POLICY_ID = 6;
pub const _IMAGE_POLICY_ID_ImagePolicyIdParentSdRev: _IMAGE_POLICY_ID = 7;
pub const _IMAGE_POLICY_ID_ImagePolicyIdSvn: _IMAGE_POLICY_ID = 8;
pub const _IMAGE_POLICY_ID_ImagePolicyIdDeviceId: _IMAGE_POLICY_ID = 9;
pub const _IMAGE_POLICY_ID_ImagePolicyIdCapability: _IMAGE_POLICY_ID = 10;
pub const _IMAGE_POLICY_ID_ImagePolicyIdScenarioId: _IMAGE_POLICY_ID = 11;
pub const _IMAGE_POLICY_ID_ImagePolicyIdMaximum: _IMAGE_POLICY_ID = 12;
pub type _IMAGE_POLICY_ID = ::std::os::raw::c_int;
pub use self::_IMAGE_POLICY_ID as IMAGE_POLICY_ID;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _IMAGE_POLICY_ENTRY {
    pub Type: IMAGE_POLICY_ENTRY_TYPE,
    pub PolicyId: IMAGE_POLICY_ID,
    pub u: _IMAGE_POLICY_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _IMAGE_POLICY_ENTRY__bindgen_ty_1 {
    pub None: *const ::std::os::raw::c_void,
    pub BoolValue: BOOLEAN,
    pub Int8Value: INT8,
    pub UInt8Value: UINT8,
    pub Int16Value: INT16,
    pub UInt16Value: UINT16,
    pub Int32Value: INT32,
    pub UInt32Value: UINT32,
    pub Int64Value: INT64,
    pub UInt64Value: UINT64,
    pub AnsiStringValue: PCSTR,
    pub UnicodeStringValue: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_POLICY_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_IMAGE_POLICY_ENTRY__bindgen_ty_1>() - 8usize];
    ["Alignment of _IMAGE_POLICY_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_IMAGE_POLICY_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::None"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, None) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::BoolValue"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, BoolValue) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::Int8Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, Int8Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::UInt8Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, UInt8Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::Int16Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, Int16Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::UInt16Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, UInt16Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::Int32Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, Int32Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::UInt32Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, UInt32Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::Int64Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, Int64Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::UInt64Value"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, UInt64Value) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::AnsiStringValue"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, AnsiStringValue) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY__bindgen_ty_1::UnicodeStringValue"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY__bindgen_ty_1, UnicodeStringValue) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_POLICY_ENTRY"][::std::mem::size_of::<_IMAGE_POLICY_ENTRY>() - 16usize];
    ["Alignment of _IMAGE_POLICY_ENTRY"][::std::mem::align_of::<_IMAGE_POLICY_ENTRY>() - 8usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY::Type"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY, Type) - 0usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY::PolicyId"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY, PolicyId) - 4usize];
    ["Offset of field: _IMAGE_POLICY_ENTRY::u"]
        [::std::mem::offset_of!(_IMAGE_POLICY_ENTRY, u) - 8usize];
};
pub type IMAGE_POLICY_ENTRY = _IMAGE_POLICY_ENTRY;
pub type PCIMAGE_POLICY_ENTRY = *const IMAGE_POLICY_ENTRY;
#[repr(C)]
pub struct _IMAGE_POLICY_METADATA {
    pub Version: BYTE,
    pub Reserved0: [BYTE; 7usize],
    pub ApplicationId: ULONGLONG,
    pub Policies: __IncompleteArrayField<IMAGE_POLICY_ENTRY>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IMAGE_POLICY_METADATA"][::std::mem::size_of::<_IMAGE_POLICY_METADATA>() - 16usize];
    ["Alignment of _IMAGE_POLICY_METADATA"]
        [::std::mem::align_of::<_IMAGE_POLICY_METADATA>() - 8usize];
    ["Offset of field: _IMAGE_POLICY_METADATA::Version"]
        [::std::mem::offset_of!(_IMAGE_POLICY_METADATA, Version) - 0usize];
    ["Offset of field: _IMAGE_POLICY_METADATA::Reserved0"]
        [::std::mem::offset_of!(_IMAGE_POLICY_METADATA, Reserved0) - 1usize];
    ["Offset of field: _IMAGE_POLICY_METADATA::ApplicationId"]
        [::std::mem::offset_of!(_IMAGE_POLICY_METADATA, ApplicationId) - 8usize];
    ["Offset of field: _IMAGE_POLICY_METADATA::Policies"]
        [::std::mem::offset_of!(_IMAGE_POLICY_METADATA, Policies) - 16usize];
};
pub type IMAGE_POLICY_METADATA = _IMAGE_POLICY_METADATA;
pub type PCIMAGE_POLICY_METADATA = *const IMAGE_POLICY_METADATA;
unsafe extern "C" {
    pub fn RtlIsZeroMemory(Buffer: PVOID, Length: SIZE_T) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn RtlNormalizeSecurityDescriptor(
        SecurityDescriptor: *mut PSECURITY_DESCRIPTOR,
        SecurityDescriptorLength: DWORD,
        NewSecurityDescriptor: *mut PSECURITY_DESCRIPTOR,
        NewSecurityDescriptorLength: PDWORD,
        CheckOnly: BOOLEAN,
    ) -> BOOLEAN;
}
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdUnknown: _RTL_SYSTEM_GLOBAL_DATA_ID = 0;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdRngSeedVersion: _RTL_SYSTEM_GLOBAL_DATA_ID = 1;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdInterruptTime: _RTL_SYSTEM_GLOBAL_DATA_ID = 2;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdTimeZoneBias: _RTL_SYSTEM_GLOBAL_DATA_ID = 3;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdImageNumberLow: _RTL_SYSTEM_GLOBAL_DATA_ID = 4;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdImageNumberHigh: _RTL_SYSTEM_GLOBAL_DATA_ID = 5;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdTimeZoneId: _RTL_SYSTEM_GLOBAL_DATA_ID = 6;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdNtMajorVersion: _RTL_SYSTEM_GLOBAL_DATA_ID = 7;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdNtMinorVersion: _RTL_SYSTEM_GLOBAL_DATA_ID = 8;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdSystemExpirationDate: _RTL_SYSTEM_GLOBAL_DATA_ID =
    9;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdKdDebuggerEnabled: _RTL_SYSTEM_GLOBAL_DATA_ID = 10;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdCyclesPerYield: _RTL_SYSTEM_GLOBAL_DATA_ID = 11;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdSafeBootMode: _RTL_SYSTEM_GLOBAL_DATA_ID = 12;
pub const _RTL_SYSTEM_GLOBAL_DATA_ID_GlobalDataIdLastSystemRITEventTickCount:
    _RTL_SYSTEM_GLOBAL_DATA_ID = 13;
pub type _RTL_SYSTEM_GLOBAL_DATA_ID = ::std::os::raw::c_int;
pub use self::_RTL_SYSTEM_GLOBAL_DATA_ID as RTL_SYSTEM_GLOBAL_DATA_ID;
pub type PRTL_SYSTEM_GLOBAL_DATA_ID = *mut _RTL_SYSTEM_GLOBAL_DATA_ID;
unsafe extern "C" {
    pub fn RtlGetSystemGlobalData(
        DataId: RTL_SYSTEM_GLOBAL_DATA_ID,
        Buffer: PVOID,
        Size: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlSetSystemGlobalData(
        DataId: RTL_SYSTEM_GLOBAL_DATA_ID,
        Buffer: PVOID,
        Size: DWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RTL_CRITICAL_SECTION_DEBUG {
    pub Type: WORD,
    pub CreatorBackTraceIndex: WORD,
    pub CriticalSection: *mut _RTL_CRITICAL_SECTION,
    pub ProcessLocksList: LIST_ENTRY,
    pub EntryCount: DWORD,
    pub ContentionCount: DWORD,
    pub Flags: DWORD,
    pub CreatorBackTraceIndexHigh: WORD,
    pub SpareWORD: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_CRITICAL_SECTION_DEBUG"]
        [::std::mem::size_of::<_RTL_CRITICAL_SECTION_DEBUG>() - 48usize];
    ["Alignment of _RTL_CRITICAL_SECTION_DEBUG"]
        [::std::mem::align_of::<_RTL_CRITICAL_SECTION_DEBUG>() - 8usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::Type"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, Type) - 0usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::CreatorBackTraceIndex"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, CreatorBackTraceIndex) - 2usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::CriticalSection"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, CriticalSection) - 8usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::ProcessLocksList"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, ProcessLocksList) - 16usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::EntryCount"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, EntryCount) - 32usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::ContentionCount"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, ContentionCount) - 36usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::Flags"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, Flags) - 40usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::CreatorBackTraceIndexHigh"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, CreatorBackTraceIndexHigh) - 44usize];
    ["Offset of field: _RTL_CRITICAL_SECTION_DEBUG::SpareWORD"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION_DEBUG, SpareWORD) - 46usize];
};
pub type RTL_CRITICAL_SECTION_DEBUG = _RTL_CRITICAL_SECTION_DEBUG;
pub type PRTL_CRITICAL_SECTION_DEBUG = *mut _RTL_CRITICAL_SECTION_DEBUG;
pub type RTL_RESOURCE_DEBUG = _RTL_CRITICAL_SECTION_DEBUG;
pub type PRTL_RESOURCE_DEBUG = *mut _RTL_CRITICAL_SECTION_DEBUG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RTL_CRITICAL_SECTION {
    pub DebugInfo: PRTL_CRITICAL_SECTION_DEBUG,
    pub LockCount: LONG,
    pub RecursionCount: LONG,
    pub OwningThread: HANDLE,
    pub LockSemaphore: HANDLE,
    pub SpinCount: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_CRITICAL_SECTION"][::std::mem::size_of::<_RTL_CRITICAL_SECTION>() - 40usize];
    ["Alignment of _RTL_CRITICAL_SECTION"]
        [::std::mem::align_of::<_RTL_CRITICAL_SECTION>() - 8usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::DebugInfo"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, DebugInfo) - 0usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::LockCount"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, LockCount) - 8usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::RecursionCount"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, RecursionCount) - 12usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::OwningThread"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, OwningThread) - 16usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::LockSemaphore"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, LockSemaphore) - 24usize];
    ["Offset of field: _RTL_CRITICAL_SECTION::SpinCount"]
        [::std::mem::offset_of!(_RTL_CRITICAL_SECTION, SpinCount) - 32usize];
};
pub type RTL_CRITICAL_SECTION = _RTL_CRITICAL_SECTION;
pub type PRTL_CRITICAL_SECTION = *mut _RTL_CRITICAL_SECTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RTL_SRWLOCK {
    pub Ptr: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_SRWLOCK"][::std::mem::size_of::<_RTL_SRWLOCK>() - 8usize];
    ["Alignment of _RTL_SRWLOCK"][::std::mem::align_of::<_RTL_SRWLOCK>() - 8usize];
    ["Offset of field: _RTL_SRWLOCK::Ptr"][::std::mem::offset_of!(_RTL_SRWLOCK, Ptr) - 0usize];
};
pub type RTL_SRWLOCK = _RTL_SRWLOCK;
pub type PRTL_SRWLOCK = *mut _RTL_SRWLOCK;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RTL_CONDITION_VARIABLE {
    pub Ptr: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RTL_CONDITION_VARIABLE"][::std::mem::size_of::<_RTL_CONDITION_VARIABLE>() - 8usize];
    ["Alignment of _RTL_CONDITION_VARIABLE"]
        [::std::mem::align_of::<_RTL_CONDITION_VARIABLE>() - 8usize];
    ["Offset of field: _RTL_CONDITION_VARIABLE::Ptr"]
        [::std::mem::offset_of!(_RTL_CONDITION_VARIABLE, Ptr) - 0usize];
};
pub type RTL_CONDITION_VARIABLE = _RTL_CONDITION_VARIABLE;
pub type PRTL_CONDITION_VARIABLE = *mut _RTL_CONDITION_VARIABLE;
pub type PAPCFUNC = ::std::option::Option<unsafe extern "C" fn(Parameter: ULONG_PTR)>;
pub type PVECTORED_EXCEPTION_HANDLER =
    ::std::option::Option<unsafe extern "C" fn(ExceptionInfo: *mut _EXCEPTION_POINTERS) -> LONG>;
pub const _HEAP_INFORMATION_CLASS_HeapCompatibilityInformation: _HEAP_INFORMATION_CLASS = 0;
pub const _HEAP_INFORMATION_CLASS_HeapEnableTerminationOnCorruption: _HEAP_INFORMATION_CLASS = 1;
pub const _HEAP_INFORMATION_CLASS_HeapOptimizeResources: _HEAP_INFORMATION_CLASS = 3;
pub const _HEAP_INFORMATION_CLASS_HeapTag: _HEAP_INFORMATION_CLASS = 7;
pub type _HEAP_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_HEAP_INFORMATION_CLASS as HEAP_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HEAP_OPTIMIZE_RESOURCES_INFORMATION {
    pub Version: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HEAP_OPTIMIZE_RESOURCES_INFORMATION"]
        [::std::mem::size_of::<_HEAP_OPTIMIZE_RESOURCES_INFORMATION>() - 8usize];
    ["Alignment of _HEAP_OPTIMIZE_RESOURCES_INFORMATION"]
        [::std::mem::align_of::<_HEAP_OPTIMIZE_RESOURCES_INFORMATION>() - 4usize];
    ["Offset of field: _HEAP_OPTIMIZE_RESOURCES_INFORMATION::Version"]
        [::std::mem::offset_of!(_HEAP_OPTIMIZE_RESOURCES_INFORMATION, Version) - 0usize];
    ["Offset of field: _HEAP_OPTIMIZE_RESOURCES_INFORMATION::Flags"]
        [::std::mem::offset_of!(_HEAP_OPTIMIZE_RESOURCES_INFORMATION, Flags) - 4usize];
};
pub type HEAP_OPTIMIZE_RESOURCES_INFORMATION = _HEAP_OPTIMIZE_RESOURCES_INFORMATION;
pub type PHEAP_OPTIMIZE_RESOURCES_INFORMATION = *mut _HEAP_OPTIMIZE_RESOURCES_INFORMATION;
pub type WAITORTIMERCALLBACKFUNC =
    ::std::option::Option<unsafe extern "C" fn(arg1: PVOID, arg2: BOOLEAN)>;
pub type WORKERCALLBACKFUNC = ::std::option::Option<unsafe extern "C" fn(arg1: PVOID)>;
pub type APC_CALLBACK_FUNCTION =
    ::std::option::Option<unsafe extern "C" fn(arg1: DWORD, arg2: PVOID, arg3: PVOID)>;
pub type WAITORTIMERCALLBACK = WAITORTIMERCALLBACKFUNC;
pub type PFLS_CALLBACK_FUNCTION = ::std::option::Option<unsafe extern "C" fn(lpFlsData: PVOID)>;
pub type PSECURE_MEMORY_CACHE_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(Addr: PVOID, Range: SIZE_T) -> BOOLEAN>;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_ActivationContextBasicInformation:
    _ACTIVATION_CONTEXT_INFO_CLASS = 1;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_ActivationContextDetailedInformation:
    _ACTIVATION_CONTEXT_INFO_CLASS = 2;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_AssemblyDetailedInformationInActivationContext:
    _ACTIVATION_CONTEXT_INFO_CLASS = 3;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_FileInformationInAssemblyOfAssemblyInActivationContext:
    _ACTIVATION_CONTEXT_INFO_CLASS = 4;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_RunlevelInformationInActivationContext:
    _ACTIVATION_CONTEXT_INFO_CLASS = 5;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_CompatibilityInformationInActivationContext:
    _ACTIVATION_CONTEXT_INFO_CLASS = 6;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_ActivationContextManifestResourceName:
    _ACTIVATION_CONTEXT_INFO_CLASS = 7;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_MaxActivationContextInfoClass:
    _ACTIVATION_CONTEXT_INFO_CLASS = 8;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_AssemblyDetailedInformationInActivationContxt:
    _ACTIVATION_CONTEXT_INFO_CLASS = 3;
pub const _ACTIVATION_CONTEXT_INFO_CLASS_FileInformationInAssemblyOfAssemblyInActivationContxt:
    _ACTIVATION_CONTEXT_INFO_CLASS = 4;
pub type _ACTIVATION_CONTEXT_INFO_CLASS = ::std::os::raw::c_int;
pub use self::_ACTIVATION_CONTEXT_INFO_CLASS as ACTIVATION_CONTEXT_INFO_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTIVATION_CONTEXT_QUERY_INDEX {
    pub ulAssemblyIndex: DWORD,
    pub ulFileIndexInAssembly: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_QUERY_INDEX"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_QUERY_INDEX>() - 8usize];
    ["Alignment of _ACTIVATION_CONTEXT_QUERY_INDEX"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_QUERY_INDEX>() - 4usize];
    ["Offset of field: _ACTIVATION_CONTEXT_QUERY_INDEX::ulAssemblyIndex"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_QUERY_INDEX, ulAssemblyIndex) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_QUERY_INDEX::ulFileIndexInAssembly"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_QUERY_INDEX, ulFileIndexInAssembly) - 4usize];
};
pub type ACTIVATION_CONTEXT_QUERY_INDEX = _ACTIVATION_CONTEXT_QUERY_INDEX;
pub type PACTIVATION_CONTEXT_QUERY_INDEX = *mut _ACTIVATION_CONTEXT_QUERY_INDEX;
pub type PCACTIVATION_CONTEXT_QUERY_INDEX = *const _ACTIVATION_CONTEXT_QUERY_INDEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ASSEMBLY_FILE_DETAILED_INFORMATION {
    pub ulFlags: DWORD,
    pub ulFilenameLength: DWORD,
    pub ulPathLength: DWORD,
    pub lpFileName: PCWSTR,
    pub lpFilePath: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ASSEMBLY_FILE_DETAILED_INFORMATION"]
        [::std::mem::size_of::<_ASSEMBLY_FILE_DETAILED_INFORMATION>() - 32usize];
    ["Alignment of _ASSEMBLY_FILE_DETAILED_INFORMATION"]
        [::std::mem::align_of::<_ASSEMBLY_FILE_DETAILED_INFORMATION>() - 8usize];
    ["Offset of field: _ASSEMBLY_FILE_DETAILED_INFORMATION::ulFlags"]
        [::std::mem::offset_of!(_ASSEMBLY_FILE_DETAILED_INFORMATION, ulFlags) - 0usize];
    ["Offset of field: _ASSEMBLY_FILE_DETAILED_INFORMATION::ulFilenameLength"]
        [::std::mem::offset_of!(_ASSEMBLY_FILE_DETAILED_INFORMATION, ulFilenameLength) - 4usize];
    ["Offset of field: _ASSEMBLY_FILE_DETAILED_INFORMATION::ulPathLength"]
        [::std::mem::offset_of!(_ASSEMBLY_FILE_DETAILED_INFORMATION, ulPathLength) - 8usize];
    ["Offset of field: _ASSEMBLY_FILE_DETAILED_INFORMATION::lpFileName"]
        [::std::mem::offset_of!(_ASSEMBLY_FILE_DETAILED_INFORMATION, lpFileName) - 16usize];
    ["Offset of field: _ASSEMBLY_FILE_DETAILED_INFORMATION::lpFilePath"]
        [::std::mem::offset_of!(_ASSEMBLY_FILE_DETAILED_INFORMATION, lpFilePath) - 24usize];
};
pub type ASSEMBLY_FILE_DETAILED_INFORMATION = _ASSEMBLY_FILE_DETAILED_INFORMATION;
pub type PASSEMBLY_FILE_DETAILED_INFORMATION = *mut _ASSEMBLY_FILE_DETAILED_INFORMATION;
pub type PCASSEMBLY_FILE_DETAILED_INFORMATION = *const ASSEMBLY_FILE_DETAILED_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION {
    pub ulFlags: DWORD,
    pub ulEncodedAssemblyIdentityLength: DWORD,
    pub ulManifestPathType: DWORD,
    pub ulManifestPathLength: DWORD,
    pub liManifestLastWriteTime: LARGE_INTEGER,
    pub ulPolicyPathType: DWORD,
    pub ulPolicyPathLength: DWORD,
    pub liPolicyLastWriteTime: LARGE_INTEGER,
    pub ulMetadataSatelliteRosterIndex: DWORD,
    pub ulManifestVersionMajor: DWORD,
    pub ulManifestVersionMinor: DWORD,
    pub ulPolicyVersionMajor: DWORD,
    pub ulPolicyVersionMinor: DWORD,
    pub ulAssemblyDirectoryNameLength: DWORD,
    pub lpAssemblyEncodedAssemblyIdentity: PCWSTR,
    pub lpAssemblyManifestPath: PCWSTR,
    pub lpAssemblyPolicyPath: PCWSTR,
    pub lpAssemblyDirectoryName: PCWSTR,
    pub ulFileCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION>() - 104usize];
    ["Alignment of _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION>() - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulFlags"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulFlags
    ) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulEncodedAssemblyIdentityLength"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , ulEncodedAssemblyIdentityLength) - 4usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulManifestPathType"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulManifestPathType
    )
        - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulManifestPathLength"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulManifestPathLength
    )
        - 12usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::liManifestLastWriteTime"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , liManifestLastWriteTime) - 16usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulPolicyPathType"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulPolicyPathType
    )
        - 24usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulPolicyPathLength"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulPolicyPathLength
    )
        - 28usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::liPolicyLastWriteTime"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        liPolicyLastWriteTime
    )
        - 32usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulMetadataSatelliteRosterIndex"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , ulMetadataSatelliteRosterIndex) - 40usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulManifestVersionMajor"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , ulManifestVersionMajor) - 44usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulManifestVersionMinor"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , ulManifestVersionMinor) - 48usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulPolicyVersionMajor"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulPolicyVersionMajor
    )
        - 52usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulPolicyVersionMinor"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulPolicyVersionMinor
    )
        - 56usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulAssemblyDirectoryNameLength"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , ulAssemblyDirectoryNameLength) - 60usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::lpAssemblyEncodedAssemblyIdentity"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , lpAssemblyEncodedAssemblyIdentity) - 64usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::lpAssemblyManifestPath"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , lpAssemblyManifestPath) - 72usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::lpAssemblyPolicyPath"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        lpAssemblyPolicyPath
    )
        - 80usize];
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::lpAssemblyDirectoryName"] [:: std :: mem :: offset_of ! (_ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION , lpAssemblyDirectoryName) - 88usize] ;
    ["Offset of field: _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION::ulFileCount"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION,
        ulFileCount
    )
        - 96usize];
};
pub type ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION =
    _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION;
pub type PACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION =
    *mut _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION;
pub type PCACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION =
    *const _ACTIVATION_CONTEXT_ASSEMBLY_DETAILED_INFORMATION;
pub const ACTCTX_REQUESTED_RUN_LEVEL_ACTCTX_RUN_LEVEL_UNSPECIFIED: ACTCTX_REQUESTED_RUN_LEVEL = 0;
pub const ACTCTX_REQUESTED_RUN_LEVEL_ACTCTX_RUN_LEVEL_AS_INVOKER: ACTCTX_REQUESTED_RUN_LEVEL = 1;
pub const ACTCTX_REQUESTED_RUN_LEVEL_ACTCTX_RUN_LEVEL_HIGHEST_AVAILABLE:
    ACTCTX_REQUESTED_RUN_LEVEL = 2;
pub const ACTCTX_REQUESTED_RUN_LEVEL_ACTCTX_RUN_LEVEL_REQUIRE_ADMIN: ACTCTX_REQUESTED_RUN_LEVEL = 3;
pub const ACTCTX_REQUESTED_RUN_LEVEL_ACTCTX_RUN_LEVEL_NUMBERS: ACTCTX_REQUESTED_RUN_LEVEL = 4;
pub type ACTCTX_REQUESTED_RUN_LEVEL = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION {
    pub ulFlags: DWORD,
    pub RunLevel: ACTCTX_REQUESTED_RUN_LEVEL,
    pub UiAccess: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION>() - 12usize];
    ["Alignment of _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION>() - 4usize];
    ["Offset of field: _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION::ulFlags"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION, ulFlags) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION::RunLevel"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION, RunLevel) - 4usize];
    ["Offset of field: _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION::UiAccess"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION, UiAccess) - 8usize];
};
pub type ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION = _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION;
pub type PACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION = *mut _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION;
pub type PCACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION =
    *const _ACTIVATION_CONTEXT_RUN_LEVEL_INFORMATION;
pub const ACTCTX_COMPATIBILITY_ELEMENT_TYPE_ACTCTX_COMPATIBILITY_ELEMENT_TYPE_UNKNOWN:
    ACTCTX_COMPATIBILITY_ELEMENT_TYPE = 0;
pub const ACTCTX_COMPATIBILITY_ELEMENT_TYPE_ACTCTX_COMPATIBILITY_ELEMENT_TYPE_OS:
    ACTCTX_COMPATIBILITY_ELEMENT_TYPE = 1;
pub const ACTCTX_COMPATIBILITY_ELEMENT_TYPE_ACTCTX_COMPATIBILITY_ELEMENT_TYPE_MITIGATION:
    ACTCTX_COMPATIBILITY_ELEMENT_TYPE = 2;
pub const ACTCTX_COMPATIBILITY_ELEMENT_TYPE_ACTCTX_COMPATIBILITY_ELEMENT_TYPE_MAXVERSIONTESTED:
    ACTCTX_COMPATIBILITY_ELEMENT_TYPE = 3;
pub type ACTCTX_COMPATIBILITY_ELEMENT_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMPATIBILITY_CONTEXT_ELEMENT {
    pub Id: GUID,
    pub Type: ACTCTX_COMPATIBILITY_ELEMENT_TYPE,
    pub MaxVersionTested: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMPATIBILITY_CONTEXT_ELEMENT"]
        [::std::mem::size_of::<_COMPATIBILITY_CONTEXT_ELEMENT>() - 32usize];
    ["Alignment of _COMPATIBILITY_CONTEXT_ELEMENT"]
        [::std::mem::align_of::<_COMPATIBILITY_CONTEXT_ELEMENT>() - 8usize];
    ["Offset of field: _COMPATIBILITY_CONTEXT_ELEMENT::Id"]
        [::std::mem::offset_of!(_COMPATIBILITY_CONTEXT_ELEMENT, Id) - 0usize];
    ["Offset of field: _COMPATIBILITY_CONTEXT_ELEMENT::Type"]
        [::std::mem::offset_of!(_COMPATIBILITY_CONTEXT_ELEMENT, Type) - 16usize];
    ["Offset of field: _COMPATIBILITY_CONTEXT_ELEMENT::MaxVersionTested"]
        [::std::mem::offset_of!(_COMPATIBILITY_CONTEXT_ELEMENT, MaxVersionTested) - 24usize];
};
pub type COMPATIBILITY_CONTEXT_ELEMENT = _COMPATIBILITY_CONTEXT_ELEMENT;
pub type PCOMPATIBILITY_CONTEXT_ELEMENT = *mut _COMPATIBILITY_CONTEXT_ELEMENT;
pub type PCCOMPATIBILITY_CONTEXT_ELEMENT = *const _COMPATIBILITY_CONTEXT_ELEMENT;
#[repr(C)]
#[derive(Debug)]
pub struct _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION {
    pub ElementCount: DWORD,
    pub Elements: __IncompleteArrayField<COMPATIBILITY_CONTEXT_ELEMENT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION>() - 8usize];
    ["Alignment of _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION>() - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION::ElementCount"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION,
        ElementCount
    ) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION::Elements"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION, Elements) - 8usize];
};
pub type ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION =
    _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION;
pub type PACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION =
    *mut _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION;
pub type PCACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION =
    *const _ACTIVATION_CONTEXT_COMPATIBILITY_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SUPPORTED_OS_INFO {
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SUPPORTED_OS_INFO"][::std::mem::size_of::<_SUPPORTED_OS_INFO>() - 4usize];
    ["Alignment of _SUPPORTED_OS_INFO"][::std::mem::align_of::<_SUPPORTED_OS_INFO>() - 2usize];
    ["Offset of field: _SUPPORTED_OS_INFO::MajorVersion"]
        [::std::mem::offset_of!(_SUPPORTED_OS_INFO, MajorVersion) - 0usize];
    ["Offset of field: _SUPPORTED_OS_INFO::MinorVersion"]
        [::std::mem::offset_of!(_SUPPORTED_OS_INFO, MinorVersion) - 2usize];
};
pub type SUPPORTED_OS_INFO = _SUPPORTED_OS_INFO;
pub type PSUPPORTED_OS_INFO = *mut _SUPPORTED_OS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MAXVERSIONTESTED_INFO {
    pub MaxVersionTested: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MAXVERSIONTESTED_INFO"][::std::mem::size_of::<_MAXVERSIONTESTED_INFO>() - 8usize];
    ["Alignment of _MAXVERSIONTESTED_INFO"]
        [::std::mem::align_of::<_MAXVERSIONTESTED_INFO>() - 8usize];
    ["Offset of field: _MAXVERSIONTESTED_INFO::MaxVersionTested"]
        [::std::mem::offset_of!(_MAXVERSIONTESTED_INFO, MaxVersionTested) - 0usize];
};
pub type MAXVERSIONTESTED_INFO = _MAXVERSIONTESTED_INFO;
pub type PMAXVERSIONTESTED_INFO = *mut _MAXVERSIONTESTED_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTIVATION_CONTEXT_DETAILED_INFORMATION {
    pub dwFlags: DWORD,
    pub ulFormatVersion: DWORD,
    pub ulAssemblyCount: DWORD,
    pub ulRootManifestPathType: DWORD,
    pub ulRootManifestPathChars: DWORD,
    pub ulRootConfigurationPathType: DWORD,
    pub ulRootConfigurationPathChars: DWORD,
    pub ulAppDirPathType: DWORD,
    pub ulAppDirPathChars: DWORD,
    pub lpRootManifestPath: PCWSTR,
    pub lpRootConfigurationPath: PCWSTR,
    pub lpAppDirPath: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_DETAILED_INFORMATION"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_DETAILED_INFORMATION>() - 64usize];
    ["Alignment of _ACTIVATION_CONTEXT_DETAILED_INFORMATION"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_DETAILED_INFORMATION>() - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::dwFlags"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_DETAILED_INFORMATION, dwFlags) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulFormatVersion"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulFormatVersion
    ) - 4usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAssemblyCount"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulAssemblyCount
    ) - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulRootManifestPathType"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulRootManifestPathType
    )
        - 12usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulRootManifestPathChars"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulRootManifestPathChars
    )
        - 16usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulRootConfigurationPathType"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulRootConfigurationPathType
    )
        - 20usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulRootConfigurationPathChars"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulRootConfigurationPathChars
    )
        - 24usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAppDirPathType"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulAppDirPathType
    ) - 28usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::ulAppDirPathChars"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        ulAppDirPathChars
    ) - 32usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::lpRootManifestPath"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        lpRootManifestPath
    ) - 40usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::lpRootConfigurationPath"][::std::mem::offset_of!(
        _ACTIVATION_CONTEXT_DETAILED_INFORMATION,
        lpRootConfigurationPath
    )
        - 48usize];
    ["Offset of field: _ACTIVATION_CONTEXT_DETAILED_INFORMATION::lpAppDirPath"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_DETAILED_INFORMATION, lpAppDirPath) - 56usize];
};
pub type ACTIVATION_CONTEXT_DETAILED_INFORMATION = _ACTIVATION_CONTEXT_DETAILED_INFORMATION;
pub type PACTIVATION_CONTEXT_DETAILED_INFORMATION = *mut _ACTIVATION_CONTEXT_DETAILED_INFORMATION;
pub type PCACTIVATION_CONTEXT_DETAILED_INFORMATION =
    *const _ACTIVATION_CONTEXT_DETAILED_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HARDWARE_COUNTER_DATA {
    pub Type: HARDWARE_COUNTER_TYPE,
    pub Reserved: DWORD,
    pub Value: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HARDWARE_COUNTER_DATA"][::std::mem::size_of::<_HARDWARE_COUNTER_DATA>() - 16usize];
    ["Alignment of _HARDWARE_COUNTER_DATA"]
        [::std::mem::align_of::<_HARDWARE_COUNTER_DATA>() - 8usize];
    ["Offset of field: _HARDWARE_COUNTER_DATA::Type"]
        [::std::mem::offset_of!(_HARDWARE_COUNTER_DATA, Type) - 0usize];
    ["Offset of field: _HARDWARE_COUNTER_DATA::Reserved"]
        [::std::mem::offset_of!(_HARDWARE_COUNTER_DATA, Reserved) - 4usize];
    ["Offset of field: _HARDWARE_COUNTER_DATA::Value"]
        [::std::mem::offset_of!(_HARDWARE_COUNTER_DATA, Value) - 8usize];
};
pub type HARDWARE_COUNTER_DATA = _HARDWARE_COUNTER_DATA;
pub type PHARDWARE_COUNTER_DATA = *mut _HARDWARE_COUNTER_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PERFORMANCE_DATA {
    pub Size: WORD,
    pub Version: BYTE,
    pub HwCountersCount: BYTE,
    pub ContextSwitchCount: DWORD,
    pub WaitReasonBitMap: DWORD64,
    pub CycleTime: DWORD64,
    pub RetryCount: DWORD,
    pub Reserved: DWORD,
    pub HwCounters: [HARDWARE_COUNTER_DATA; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERFORMANCE_DATA"][::std::mem::size_of::<_PERFORMANCE_DATA>() - 288usize];
    ["Alignment of _PERFORMANCE_DATA"][::std::mem::align_of::<_PERFORMANCE_DATA>() - 8usize];
    ["Offset of field: _PERFORMANCE_DATA::Size"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, Size) - 0usize];
    ["Offset of field: _PERFORMANCE_DATA::Version"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, Version) - 2usize];
    ["Offset of field: _PERFORMANCE_DATA::HwCountersCount"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, HwCountersCount) - 3usize];
    ["Offset of field: _PERFORMANCE_DATA::ContextSwitchCount"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, ContextSwitchCount) - 4usize];
    ["Offset of field: _PERFORMANCE_DATA::WaitReasonBitMap"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, WaitReasonBitMap) - 8usize];
    ["Offset of field: _PERFORMANCE_DATA::CycleTime"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, CycleTime) - 16usize];
    ["Offset of field: _PERFORMANCE_DATA::RetryCount"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, RetryCount) - 24usize];
    ["Offset of field: _PERFORMANCE_DATA::Reserved"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, Reserved) - 28usize];
    ["Offset of field: _PERFORMANCE_DATA::HwCounters"]
        [::std::mem::offset_of!(_PERFORMANCE_DATA, HwCounters) - 32usize];
};
pub type PERFORMANCE_DATA = _PERFORMANCE_DATA;
pub type PPERFORMANCE_DATA = *mut _PERFORMANCE_DATA;
unsafe extern "C" {
    pub fn RtlGetDeviceFamilyInfoEnum(
        pullUAPInfo: *mut ULONGLONG,
        pulDeviceFamily: *mut DWORD,
        pulDeviceForm: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn RtlConvertDeviceFamilyInfoToString(
        pulDeviceFamilyBufferSize: PDWORD,
        pulDeviceFormBufferSize: PDWORD,
        DeviceFamily: PWSTR,
        DeviceForm: PWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RtlSwitchedVVI(
        VersionInfo: PRTL_OSVERSIONINFOEXW,
        TypeMask: DWORD,
        ConditionMask: ULONGLONG,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EVENTLOGRECORD {
    pub Length: DWORD,
    pub Reserved: DWORD,
    pub RecordNumber: DWORD,
    pub TimeGenerated: DWORD,
    pub TimeWritten: DWORD,
    pub EventID: DWORD,
    pub EventType: WORD,
    pub NumStrings: WORD,
    pub EventCategory: WORD,
    pub ReservedFlags: WORD,
    pub ClosingRecordNumber: DWORD,
    pub StringOffset: DWORD,
    pub UserSidLength: DWORD,
    pub UserSidOffset: DWORD,
    pub DataLength: DWORD,
    pub DataOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EVENTLOGRECORD"][::std::mem::size_of::<_EVENTLOGRECORD>() - 56usize];
    ["Alignment of _EVENTLOGRECORD"][::std::mem::align_of::<_EVENTLOGRECORD>() - 4usize];
    ["Offset of field: _EVENTLOGRECORD::Length"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, Length) - 0usize];
    ["Offset of field: _EVENTLOGRECORD::Reserved"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, Reserved) - 4usize];
    ["Offset of field: _EVENTLOGRECORD::RecordNumber"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, RecordNumber) - 8usize];
    ["Offset of field: _EVENTLOGRECORD::TimeGenerated"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, TimeGenerated) - 12usize];
    ["Offset of field: _EVENTLOGRECORD::TimeWritten"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, TimeWritten) - 16usize];
    ["Offset of field: _EVENTLOGRECORD::EventID"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, EventID) - 20usize];
    ["Offset of field: _EVENTLOGRECORD::EventType"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, EventType) - 24usize];
    ["Offset of field: _EVENTLOGRECORD::NumStrings"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, NumStrings) - 26usize];
    ["Offset of field: _EVENTLOGRECORD::EventCategory"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, EventCategory) - 28usize];
    ["Offset of field: _EVENTLOGRECORD::ReservedFlags"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, ReservedFlags) - 30usize];
    ["Offset of field: _EVENTLOGRECORD::ClosingRecordNumber"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, ClosingRecordNumber) - 32usize];
    ["Offset of field: _EVENTLOGRECORD::StringOffset"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, StringOffset) - 36usize];
    ["Offset of field: _EVENTLOGRECORD::UserSidLength"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, UserSidLength) - 40usize];
    ["Offset of field: _EVENTLOGRECORD::UserSidOffset"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, UserSidOffset) - 44usize];
    ["Offset of field: _EVENTLOGRECORD::DataLength"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, DataLength) - 48usize];
    ["Offset of field: _EVENTLOGRECORD::DataOffset"]
        [::std::mem::offset_of!(_EVENTLOGRECORD, DataOffset) - 52usize];
};
pub type EVENTLOGRECORD = _EVENTLOGRECORD;
pub type PEVENTLOGRECORD = *mut _EVENTLOGRECORD;
pub type EVENTSFORLOGFILE = _EVENTSFORLOGFILE;
pub type PEVENTSFORLOGFILE = *mut _EVENTSFORLOGFILE;
pub type PACKEDEVENTINFO = _PACKEDEVENTINFO;
pub type PPACKEDEVENTINFO = *mut _PACKEDEVENTINFO;
#[repr(C)]
#[derive(Debug)]
pub struct _EVENTSFORLOGFILE {
    pub ulSize: DWORD,
    pub szLogicalLogFile: [WCHAR; 256usize],
    pub ulNumRecords: DWORD,
    pub pEventLogRecords: __IncompleteArrayField<EVENTLOGRECORD>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EVENTSFORLOGFILE"][::std::mem::size_of::<_EVENTSFORLOGFILE>() - 520usize];
    ["Alignment of _EVENTSFORLOGFILE"][::std::mem::align_of::<_EVENTSFORLOGFILE>() - 4usize];
    ["Offset of field: _EVENTSFORLOGFILE::ulSize"]
        [::std::mem::offset_of!(_EVENTSFORLOGFILE, ulSize) - 0usize];
    ["Offset of field: _EVENTSFORLOGFILE::szLogicalLogFile"]
        [::std::mem::offset_of!(_EVENTSFORLOGFILE, szLogicalLogFile) - 4usize];
    ["Offset of field: _EVENTSFORLOGFILE::ulNumRecords"]
        [::std::mem::offset_of!(_EVENTSFORLOGFILE, ulNumRecords) - 516usize];
    ["Offset of field: _EVENTSFORLOGFILE::pEventLogRecords"]
        [::std::mem::offset_of!(_EVENTSFORLOGFILE, pEventLogRecords) - 520usize];
};
#[repr(C)]
#[derive(Debug)]
pub struct _PACKEDEVENTINFO {
    pub ulSize: DWORD,
    pub ulNumEventsForLogFile: DWORD,
    pub ulOffsets: __IncompleteArrayField<DWORD>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PACKEDEVENTINFO"][::std::mem::size_of::<_PACKEDEVENTINFO>() - 8usize];
    ["Alignment of _PACKEDEVENTINFO"][::std::mem::align_of::<_PACKEDEVENTINFO>() - 4usize];
    ["Offset of field: _PACKEDEVENTINFO::ulSize"]
        [::std::mem::offset_of!(_PACKEDEVENTINFO, ulSize) - 0usize];
    ["Offset of field: _PACKEDEVENTINFO::ulNumEventsForLogFile"]
        [::std::mem::offset_of!(_PACKEDEVENTINFO, ulNumEventsForLogFile) - 4usize];
    ["Offset of field: _PACKEDEVENTINFO::ulOffsets"]
        [::std::mem::offset_of!(_PACKEDEVENTINFO, ulOffsets) - 8usize];
};
pub const _CM_SERVICE_NODE_TYPE_DriverType: _CM_SERVICE_NODE_TYPE = 1;
pub const _CM_SERVICE_NODE_TYPE_FileSystemType: _CM_SERVICE_NODE_TYPE = 2;
pub const _CM_SERVICE_NODE_TYPE_Win32ServiceOwnProcess: _CM_SERVICE_NODE_TYPE = 16;
pub const _CM_SERVICE_NODE_TYPE_Win32ServiceShareProcess: _CM_SERVICE_NODE_TYPE = 32;
pub const _CM_SERVICE_NODE_TYPE_AdapterType: _CM_SERVICE_NODE_TYPE = 4;
pub const _CM_SERVICE_NODE_TYPE_RecognizerType: _CM_SERVICE_NODE_TYPE = 8;
pub type _CM_SERVICE_NODE_TYPE = ::std::os::raw::c_int;
pub use self::_CM_SERVICE_NODE_TYPE as SERVICE_NODE_TYPE;
pub const _CM_SERVICE_LOAD_TYPE_BootLoad: _CM_SERVICE_LOAD_TYPE = 0;
pub const _CM_SERVICE_LOAD_TYPE_SystemLoad: _CM_SERVICE_LOAD_TYPE = 1;
pub const _CM_SERVICE_LOAD_TYPE_AutoLoad: _CM_SERVICE_LOAD_TYPE = 2;
pub const _CM_SERVICE_LOAD_TYPE_DemandLoad: _CM_SERVICE_LOAD_TYPE = 3;
pub const _CM_SERVICE_LOAD_TYPE_DisableLoad: _CM_SERVICE_LOAD_TYPE = 4;
pub type _CM_SERVICE_LOAD_TYPE = ::std::os::raw::c_int;
pub use self::_CM_SERVICE_LOAD_TYPE as SERVICE_LOAD_TYPE;
pub const _CM_ERROR_CONTROL_TYPE_IgnoreError: _CM_ERROR_CONTROL_TYPE = 0;
pub const _CM_ERROR_CONTROL_TYPE_NormalError: _CM_ERROR_CONTROL_TYPE = 1;
pub const _CM_ERROR_CONTROL_TYPE_SevereError: _CM_ERROR_CONTROL_TYPE = 2;
pub const _CM_ERROR_CONTROL_TYPE_CriticalError: _CM_ERROR_CONTROL_TYPE = 3;
pub type _CM_ERROR_CONTROL_TYPE = ::std::os::raw::c_int;
pub use self::_CM_ERROR_CONTROL_TYPE as SERVICE_ERROR_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_ERASE {
    pub Type: DWORD,
    pub Immediate: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_ERASE"][::std::mem::size_of::<_TAPE_ERASE>() - 8usize];
    ["Alignment of _TAPE_ERASE"][::std::mem::align_of::<_TAPE_ERASE>() - 4usize];
    ["Offset of field: _TAPE_ERASE::Type"][::std::mem::offset_of!(_TAPE_ERASE, Type) - 0usize];
    ["Offset of field: _TAPE_ERASE::Immediate"]
        [::std::mem::offset_of!(_TAPE_ERASE, Immediate) - 4usize];
};
pub type TAPE_ERASE = _TAPE_ERASE;
pub type PTAPE_ERASE = *mut _TAPE_ERASE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_PREPARE {
    pub Operation: DWORD,
    pub Immediate: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_PREPARE"][::std::mem::size_of::<_TAPE_PREPARE>() - 8usize];
    ["Alignment of _TAPE_PREPARE"][::std::mem::align_of::<_TAPE_PREPARE>() - 4usize];
    ["Offset of field: _TAPE_PREPARE::Operation"]
        [::std::mem::offset_of!(_TAPE_PREPARE, Operation) - 0usize];
    ["Offset of field: _TAPE_PREPARE::Immediate"]
        [::std::mem::offset_of!(_TAPE_PREPARE, Immediate) - 4usize];
};
pub type TAPE_PREPARE = _TAPE_PREPARE;
pub type PTAPE_PREPARE = *mut _TAPE_PREPARE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_WRITE_MARKS {
    pub Type: DWORD,
    pub Count: DWORD,
    pub Immediate: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_WRITE_MARKS"][::std::mem::size_of::<_TAPE_WRITE_MARKS>() - 12usize];
    ["Alignment of _TAPE_WRITE_MARKS"][::std::mem::align_of::<_TAPE_WRITE_MARKS>() - 4usize];
    ["Offset of field: _TAPE_WRITE_MARKS::Type"]
        [::std::mem::offset_of!(_TAPE_WRITE_MARKS, Type) - 0usize];
    ["Offset of field: _TAPE_WRITE_MARKS::Count"]
        [::std::mem::offset_of!(_TAPE_WRITE_MARKS, Count) - 4usize];
    ["Offset of field: _TAPE_WRITE_MARKS::Immediate"]
        [::std::mem::offset_of!(_TAPE_WRITE_MARKS, Immediate) - 8usize];
};
pub type TAPE_WRITE_MARKS = _TAPE_WRITE_MARKS;
pub type PTAPE_WRITE_MARKS = *mut _TAPE_WRITE_MARKS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TAPE_GET_POSITION {
    pub Type: DWORD,
    pub Partition: DWORD,
    pub Offset: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_GET_POSITION"][::std::mem::size_of::<_TAPE_GET_POSITION>() - 16usize];
    ["Alignment of _TAPE_GET_POSITION"][::std::mem::align_of::<_TAPE_GET_POSITION>() - 8usize];
    ["Offset of field: _TAPE_GET_POSITION::Type"]
        [::std::mem::offset_of!(_TAPE_GET_POSITION, Type) - 0usize];
    ["Offset of field: _TAPE_GET_POSITION::Partition"]
        [::std::mem::offset_of!(_TAPE_GET_POSITION, Partition) - 4usize];
    ["Offset of field: _TAPE_GET_POSITION::Offset"]
        [::std::mem::offset_of!(_TAPE_GET_POSITION, Offset) - 8usize];
};
pub type TAPE_GET_POSITION = _TAPE_GET_POSITION;
pub type PTAPE_GET_POSITION = *mut _TAPE_GET_POSITION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TAPE_SET_POSITION {
    pub Method: DWORD,
    pub Partition: DWORD,
    pub Offset: LARGE_INTEGER,
    pub Immediate: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_SET_POSITION"][::std::mem::size_of::<_TAPE_SET_POSITION>() - 24usize];
    ["Alignment of _TAPE_SET_POSITION"][::std::mem::align_of::<_TAPE_SET_POSITION>() - 8usize];
    ["Offset of field: _TAPE_SET_POSITION::Method"]
        [::std::mem::offset_of!(_TAPE_SET_POSITION, Method) - 0usize];
    ["Offset of field: _TAPE_SET_POSITION::Partition"]
        [::std::mem::offset_of!(_TAPE_SET_POSITION, Partition) - 4usize];
    ["Offset of field: _TAPE_SET_POSITION::Offset"]
        [::std::mem::offset_of!(_TAPE_SET_POSITION, Offset) - 8usize];
    ["Offset of field: _TAPE_SET_POSITION::Immediate"]
        [::std::mem::offset_of!(_TAPE_SET_POSITION, Immediate) - 16usize];
};
pub type TAPE_SET_POSITION = _TAPE_SET_POSITION;
pub type PTAPE_SET_POSITION = *mut _TAPE_SET_POSITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_GET_DRIVE_PARAMETERS {
    pub ECC: BOOLEAN,
    pub Compression: BOOLEAN,
    pub DataPadding: BOOLEAN,
    pub ReportSetmarks: BOOLEAN,
    pub DefaultBlockSize: DWORD,
    pub MaximumBlockSize: DWORD,
    pub MinimumBlockSize: DWORD,
    pub MaximumPartitionCount: DWORD,
    pub FeaturesLow: DWORD,
    pub FeaturesHigh: DWORD,
    pub EOTWarningZoneSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_GET_DRIVE_PARAMETERS"]
        [::std::mem::size_of::<_TAPE_GET_DRIVE_PARAMETERS>() - 32usize];
    ["Alignment of _TAPE_GET_DRIVE_PARAMETERS"]
        [::std::mem::align_of::<_TAPE_GET_DRIVE_PARAMETERS>() - 4usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::ECC"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, ECC) - 0usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::Compression"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, Compression) - 1usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::DataPadding"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, DataPadding) - 2usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::ReportSetmarks"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, ReportSetmarks) - 3usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::DefaultBlockSize"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, DefaultBlockSize) - 4usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::MaximumBlockSize"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, MaximumBlockSize) - 8usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::MinimumBlockSize"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, MinimumBlockSize) - 12usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::MaximumPartitionCount"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, MaximumPartitionCount) - 16usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::FeaturesLow"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, FeaturesLow) - 20usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::FeaturesHigh"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, FeaturesHigh) - 24usize];
    ["Offset of field: _TAPE_GET_DRIVE_PARAMETERS::EOTWarningZoneSize"]
        [::std::mem::offset_of!(_TAPE_GET_DRIVE_PARAMETERS, EOTWarningZoneSize) - 28usize];
};
pub type TAPE_GET_DRIVE_PARAMETERS = _TAPE_GET_DRIVE_PARAMETERS;
pub type PTAPE_GET_DRIVE_PARAMETERS = *mut _TAPE_GET_DRIVE_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_SET_DRIVE_PARAMETERS {
    pub ECC: BOOLEAN,
    pub Compression: BOOLEAN,
    pub DataPadding: BOOLEAN,
    pub ReportSetmarks: BOOLEAN,
    pub EOTWarningZoneSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_SET_DRIVE_PARAMETERS"]
        [::std::mem::size_of::<_TAPE_SET_DRIVE_PARAMETERS>() - 8usize];
    ["Alignment of _TAPE_SET_DRIVE_PARAMETERS"]
        [::std::mem::align_of::<_TAPE_SET_DRIVE_PARAMETERS>() - 4usize];
    ["Offset of field: _TAPE_SET_DRIVE_PARAMETERS::ECC"]
        [::std::mem::offset_of!(_TAPE_SET_DRIVE_PARAMETERS, ECC) - 0usize];
    ["Offset of field: _TAPE_SET_DRIVE_PARAMETERS::Compression"]
        [::std::mem::offset_of!(_TAPE_SET_DRIVE_PARAMETERS, Compression) - 1usize];
    ["Offset of field: _TAPE_SET_DRIVE_PARAMETERS::DataPadding"]
        [::std::mem::offset_of!(_TAPE_SET_DRIVE_PARAMETERS, DataPadding) - 2usize];
    ["Offset of field: _TAPE_SET_DRIVE_PARAMETERS::ReportSetmarks"]
        [::std::mem::offset_of!(_TAPE_SET_DRIVE_PARAMETERS, ReportSetmarks) - 3usize];
    ["Offset of field: _TAPE_SET_DRIVE_PARAMETERS::EOTWarningZoneSize"]
        [::std::mem::offset_of!(_TAPE_SET_DRIVE_PARAMETERS, EOTWarningZoneSize) - 4usize];
};
pub type TAPE_SET_DRIVE_PARAMETERS = _TAPE_SET_DRIVE_PARAMETERS;
pub type PTAPE_SET_DRIVE_PARAMETERS = *mut _TAPE_SET_DRIVE_PARAMETERS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TAPE_GET_MEDIA_PARAMETERS {
    pub Capacity: LARGE_INTEGER,
    pub Remaining: LARGE_INTEGER,
    pub BlockSize: DWORD,
    pub PartitionCount: DWORD,
    pub WriteProtected: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_GET_MEDIA_PARAMETERS"]
        [::std::mem::size_of::<_TAPE_GET_MEDIA_PARAMETERS>() - 32usize];
    ["Alignment of _TAPE_GET_MEDIA_PARAMETERS"]
        [::std::mem::align_of::<_TAPE_GET_MEDIA_PARAMETERS>() - 8usize];
    ["Offset of field: _TAPE_GET_MEDIA_PARAMETERS::Capacity"]
        [::std::mem::offset_of!(_TAPE_GET_MEDIA_PARAMETERS, Capacity) - 0usize];
    ["Offset of field: _TAPE_GET_MEDIA_PARAMETERS::Remaining"]
        [::std::mem::offset_of!(_TAPE_GET_MEDIA_PARAMETERS, Remaining) - 8usize];
    ["Offset of field: _TAPE_GET_MEDIA_PARAMETERS::BlockSize"]
        [::std::mem::offset_of!(_TAPE_GET_MEDIA_PARAMETERS, BlockSize) - 16usize];
    ["Offset of field: _TAPE_GET_MEDIA_PARAMETERS::PartitionCount"]
        [::std::mem::offset_of!(_TAPE_GET_MEDIA_PARAMETERS, PartitionCount) - 20usize];
    ["Offset of field: _TAPE_GET_MEDIA_PARAMETERS::WriteProtected"]
        [::std::mem::offset_of!(_TAPE_GET_MEDIA_PARAMETERS, WriteProtected) - 24usize];
};
pub type TAPE_GET_MEDIA_PARAMETERS = _TAPE_GET_MEDIA_PARAMETERS;
pub type PTAPE_GET_MEDIA_PARAMETERS = *mut _TAPE_GET_MEDIA_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_SET_MEDIA_PARAMETERS {
    pub BlockSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_SET_MEDIA_PARAMETERS"]
        [::std::mem::size_of::<_TAPE_SET_MEDIA_PARAMETERS>() - 4usize];
    ["Alignment of _TAPE_SET_MEDIA_PARAMETERS"]
        [::std::mem::align_of::<_TAPE_SET_MEDIA_PARAMETERS>() - 4usize];
    ["Offset of field: _TAPE_SET_MEDIA_PARAMETERS::BlockSize"]
        [::std::mem::offset_of!(_TAPE_SET_MEDIA_PARAMETERS, BlockSize) - 0usize];
};
pub type TAPE_SET_MEDIA_PARAMETERS = _TAPE_SET_MEDIA_PARAMETERS;
pub type PTAPE_SET_MEDIA_PARAMETERS = *mut _TAPE_SET_MEDIA_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_CREATE_PARTITION {
    pub Method: DWORD,
    pub Count: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_CREATE_PARTITION"][::std::mem::size_of::<_TAPE_CREATE_PARTITION>() - 12usize];
    ["Alignment of _TAPE_CREATE_PARTITION"]
        [::std::mem::align_of::<_TAPE_CREATE_PARTITION>() - 4usize];
    ["Offset of field: _TAPE_CREATE_PARTITION::Method"]
        [::std::mem::offset_of!(_TAPE_CREATE_PARTITION, Method) - 0usize];
    ["Offset of field: _TAPE_CREATE_PARTITION::Count"]
        [::std::mem::offset_of!(_TAPE_CREATE_PARTITION, Count) - 4usize];
    ["Offset of field: _TAPE_CREATE_PARTITION::Size"]
        [::std::mem::offset_of!(_TAPE_CREATE_PARTITION, Size) - 8usize];
};
pub type TAPE_CREATE_PARTITION = _TAPE_CREATE_PARTITION;
pub type PTAPE_CREATE_PARTITION = *mut _TAPE_CREATE_PARTITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_WMI_OPERATIONS {
    pub Method: DWORD,
    pub DataBufferSize: DWORD,
    pub DataBuffer: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_WMI_OPERATIONS"][::std::mem::size_of::<_TAPE_WMI_OPERATIONS>() - 16usize];
    ["Alignment of _TAPE_WMI_OPERATIONS"][::std::mem::align_of::<_TAPE_WMI_OPERATIONS>() - 8usize];
    ["Offset of field: _TAPE_WMI_OPERATIONS::Method"]
        [::std::mem::offset_of!(_TAPE_WMI_OPERATIONS, Method) - 0usize];
    ["Offset of field: _TAPE_WMI_OPERATIONS::DataBufferSize"]
        [::std::mem::offset_of!(_TAPE_WMI_OPERATIONS, DataBufferSize) - 4usize];
    ["Offset of field: _TAPE_WMI_OPERATIONS::DataBuffer"]
        [::std::mem::offset_of!(_TAPE_WMI_OPERATIONS, DataBuffer) - 8usize];
};
pub type TAPE_WMI_OPERATIONS = _TAPE_WMI_OPERATIONS;
pub type PTAPE_WMI_OPERATIONS = *mut _TAPE_WMI_OPERATIONS;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveProblemNone: _TAPE_DRIVE_PROBLEM_TYPE = 0;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveReadWriteWarning: _TAPE_DRIVE_PROBLEM_TYPE = 1;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveReadWriteError: _TAPE_DRIVE_PROBLEM_TYPE = 2;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveReadWarning: _TAPE_DRIVE_PROBLEM_TYPE = 3;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveWriteWarning: _TAPE_DRIVE_PROBLEM_TYPE = 4;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveReadError: _TAPE_DRIVE_PROBLEM_TYPE = 5;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveWriteError: _TAPE_DRIVE_PROBLEM_TYPE = 6;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveHardwareError: _TAPE_DRIVE_PROBLEM_TYPE = 7;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveUnsupportedMedia: _TAPE_DRIVE_PROBLEM_TYPE = 8;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveScsiConnectionError: _TAPE_DRIVE_PROBLEM_TYPE = 9;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveTimetoClean: _TAPE_DRIVE_PROBLEM_TYPE = 10;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveCleanDriveNow: _TAPE_DRIVE_PROBLEM_TYPE = 11;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveMediaLifeExpired: _TAPE_DRIVE_PROBLEM_TYPE = 12;
pub const _TAPE_DRIVE_PROBLEM_TYPE_TapeDriveSnappedTape: _TAPE_DRIVE_PROBLEM_TYPE = 13;
pub type _TAPE_DRIVE_PROBLEM_TYPE = ::std::os::raw::c_int;
pub use self::_TAPE_DRIVE_PROBLEM_TYPE as TAPE_DRIVE_PROBLEM_TYPE;
pub type UOW = GUID;
pub type PUOW = *mut GUID;
pub type CRM_PROTOCOL_ID = GUID;
pub type PCRM_PROTOCOL_ID = *mut GUID;
pub type NOTIFICATION_MASK = ULONG;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION {
    pub TransactionKey: PVOID,
    pub TransactionNotification: ULONG,
    pub TmVirtualClock: LARGE_INTEGER,
    pub ArgumentLength: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION>() - 32usize];
    ["Alignment of _TRANSACTION_NOTIFICATION"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION>() - 8usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION::TransactionKey"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION, TransactionKey) - 0usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION::TransactionNotification"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION, TransactionNotification) - 8usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION::TmVirtualClock"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION, TmVirtualClock) - 16usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION::ArgumentLength"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION, ArgumentLength) - 24usize];
};
pub type TRANSACTION_NOTIFICATION = _TRANSACTION_NOTIFICATION;
pub type PTRANSACTION_NOTIFICATION = *mut _TRANSACTION_NOTIFICATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT {
    pub EnlistmentId: GUID,
    pub UOW: UOW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT>() - 32usize];
    ["Alignment of _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT>() - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT::EnlistmentId"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT,
        EnlistmentId
    ) - 0usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT::UOW"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT, UOW) - 16usize];
};
pub type TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT = _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT =
    *mut _TRANSACTION_NOTIFICATION_RECOVERY_ARGUMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT {
    pub TmIdentity: GUID,
    pub Flags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT>() - 20usize];
    ["Alignment of _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT>() - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT::TmIdentity"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT, TmIdentity) - 0usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT::Flags"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT, Flags) - 16usize];
};
pub type TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT = _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT =
    *mut _TRANSACTION_NOTIFICATION_TM_ONLINE_ARGUMENT;
pub type SAVEPOINT_ID = ULONG;
pub type PSAVEPOINT_ID = *mut ULONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT {
    pub SavepointId: SAVEPOINT_ID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT>() - 4usize];
    ["Alignment of _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT>() - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT::SavepointId"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT,
        SavepointId
    ) - 0usize];
};
pub type TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT = _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT =
    *mut _TRANSACTION_NOTIFICATION_SAVEPOINT_ARGUMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT {
    pub PropagationCookie: ULONG,
    pub UOW: GUID,
    pub TmIdentity: GUID,
    pub BufferLength: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT>() - 40usize];
    ["Alignment of _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT>() - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT::PropagationCookie"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT,
        PropagationCookie
    )
        - 0usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT::UOW"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT, UOW) - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT::TmIdentity"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT,
        TmIdentity
    ) - 20usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT::BufferLength"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT,
        BufferLength
    ) - 36usize];
};
pub type TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT = _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT =
    *mut _TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT {
    pub MarshalCookie: ULONG,
    pub UOW: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT"]
        [::std::mem::size_of::<_TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT>() - 20usize];
    ["Alignment of _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT"]
        [::std::mem::align_of::<_TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT>() - 4usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT::MarshalCookie"][::std::mem::offset_of!(
        _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT,
        MarshalCookie
    ) - 0usize];
    ["Offset of field: _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT::UOW"]
        [::std::mem::offset_of!(_TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT, UOW) - 4usize];
};
pub type TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT = _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT =
    *mut _TRANSACTION_NOTIFICATION_MARSHAL_ARGUMENT;
pub type TRANSACTION_NOTIFICATION_PROMOTE_ARGUMENT = TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT;
pub type PTRANSACTION_NOTIFICATION_PROMOTE_ARGUMENT =
    *mut TRANSACTION_NOTIFICATION_PROPAGATE_ARGUMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KCRM_MARSHAL_HEADER {
    pub VersionMajor: ULONG,
    pub VersionMinor: ULONG,
    pub NumProtocols: ULONG,
    pub Unused: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KCRM_MARSHAL_HEADER"][::std::mem::size_of::<_KCRM_MARSHAL_HEADER>() - 16usize];
    ["Alignment of _KCRM_MARSHAL_HEADER"][::std::mem::align_of::<_KCRM_MARSHAL_HEADER>() - 4usize];
    ["Offset of field: _KCRM_MARSHAL_HEADER::VersionMajor"]
        [::std::mem::offset_of!(_KCRM_MARSHAL_HEADER, VersionMajor) - 0usize];
    ["Offset of field: _KCRM_MARSHAL_HEADER::VersionMinor"]
        [::std::mem::offset_of!(_KCRM_MARSHAL_HEADER, VersionMinor) - 4usize];
    ["Offset of field: _KCRM_MARSHAL_HEADER::NumProtocols"]
        [::std::mem::offset_of!(_KCRM_MARSHAL_HEADER, NumProtocols) - 8usize];
    ["Offset of field: _KCRM_MARSHAL_HEADER::Unused"]
        [::std::mem::offset_of!(_KCRM_MARSHAL_HEADER, Unused) - 12usize];
};
pub type KCRM_MARSHAL_HEADER = _KCRM_MARSHAL_HEADER;
pub type PKCRM_MARSHAL_HEADER = *mut _KCRM_MARSHAL_HEADER;
pub type PRKCRM_MARSHAL_HEADER = *mut _KCRM_MARSHAL_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KCRM_TRANSACTION_BLOB {
    pub UOW: UOW,
    pub TmIdentity: GUID,
    pub IsolationLevel: ULONG,
    pub IsolationFlags: ULONG,
    pub Timeout: ULONG,
    pub Description: [WCHAR; 64usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KCRM_TRANSACTION_BLOB"][::std::mem::size_of::<_KCRM_TRANSACTION_BLOB>() - 172usize];
    ["Alignment of _KCRM_TRANSACTION_BLOB"]
        [::std::mem::align_of::<_KCRM_TRANSACTION_BLOB>() - 4usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::UOW"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, UOW) - 0usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::TmIdentity"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, TmIdentity) - 16usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::IsolationLevel"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, IsolationLevel) - 32usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::IsolationFlags"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, IsolationFlags) - 36usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::Timeout"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, Timeout) - 40usize];
    ["Offset of field: _KCRM_TRANSACTION_BLOB::Description"]
        [::std::mem::offset_of!(_KCRM_TRANSACTION_BLOB, Description) - 44usize];
};
pub type KCRM_TRANSACTION_BLOB = _KCRM_TRANSACTION_BLOB;
pub type PKCRM_TRANSACTION_BLOB = *mut _KCRM_TRANSACTION_BLOB;
pub type PRKCRM_TRANSACTION_BLOB = *mut _KCRM_TRANSACTION_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KCRM_PROTOCOL_BLOB {
    pub ProtocolId: CRM_PROTOCOL_ID,
    pub StaticInfoLength: ULONG,
    pub TransactionIdInfoLength: ULONG,
    pub Unused1: ULONG,
    pub Unused2: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KCRM_PROTOCOL_BLOB"][::std::mem::size_of::<_KCRM_PROTOCOL_BLOB>() - 32usize];
    ["Alignment of _KCRM_PROTOCOL_BLOB"][::std::mem::align_of::<_KCRM_PROTOCOL_BLOB>() - 4usize];
    ["Offset of field: _KCRM_PROTOCOL_BLOB::ProtocolId"]
        [::std::mem::offset_of!(_KCRM_PROTOCOL_BLOB, ProtocolId) - 0usize];
    ["Offset of field: _KCRM_PROTOCOL_BLOB::StaticInfoLength"]
        [::std::mem::offset_of!(_KCRM_PROTOCOL_BLOB, StaticInfoLength) - 16usize];
    ["Offset of field: _KCRM_PROTOCOL_BLOB::TransactionIdInfoLength"]
        [::std::mem::offset_of!(_KCRM_PROTOCOL_BLOB, TransactionIdInfoLength) - 20usize];
    ["Offset of field: _KCRM_PROTOCOL_BLOB::Unused1"]
        [::std::mem::offset_of!(_KCRM_PROTOCOL_BLOB, Unused1) - 24usize];
    ["Offset of field: _KCRM_PROTOCOL_BLOB::Unused2"]
        [::std::mem::offset_of!(_KCRM_PROTOCOL_BLOB, Unused2) - 28usize];
};
pub type KCRM_PROTOCOL_BLOB = _KCRM_PROTOCOL_BLOB;
pub type PKCRM_PROTOCOL_BLOB = *mut _KCRM_PROTOCOL_BLOB;
pub type PRKCRM_PROTOCOL_BLOB = *mut _KCRM_PROTOCOL_BLOB;
pub const _TRANSACTION_OUTCOME_TransactionOutcomeUndetermined: _TRANSACTION_OUTCOME = 1;
pub const _TRANSACTION_OUTCOME_TransactionOutcomeCommitted: _TRANSACTION_OUTCOME = 2;
pub const _TRANSACTION_OUTCOME_TransactionOutcomeAborted: _TRANSACTION_OUTCOME = 3;
pub type _TRANSACTION_OUTCOME = ::std::os::raw::c_int;
pub use self::_TRANSACTION_OUTCOME as TRANSACTION_OUTCOME;
pub const _TRANSACTION_STATE_TransactionStateNormal: _TRANSACTION_STATE = 1;
pub const _TRANSACTION_STATE_TransactionStateIndoubt: _TRANSACTION_STATE = 2;
pub const _TRANSACTION_STATE_TransactionStateCommittedNotify: _TRANSACTION_STATE = 3;
pub type _TRANSACTION_STATE = ::std::os::raw::c_int;
pub use self::_TRANSACTION_STATE as TRANSACTION_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_BASIC_INFORMATION {
    pub TransactionId: GUID,
    pub State: DWORD,
    pub Outcome: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_BASIC_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_BASIC_INFORMATION>() - 24usize];
    ["Alignment of _TRANSACTION_BASIC_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_BASIC_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTION_BASIC_INFORMATION::TransactionId"]
        [::std::mem::offset_of!(_TRANSACTION_BASIC_INFORMATION, TransactionId) - 0usize];
    ["Offset of field: _TRANSACTION_BASIC_INFORMATION::State"]
        [::std::mem::offset_of!(_TRANSACTION_BASIC_INFORMATION, State) - 16usize];
    ["Offset of field: _TRANSACTION_BASIC_INFORMATION::Outcome"]
        [::std::mem::offset_of!(_TRANSACTION_BASIC_INFORMATION, Outcome) - 20usize];
};
pub type TRANSACTION_BASIC_INFORMATION = _TRANSACTION_BASIC_INFORMATION;
pub type PTRANSACTION_BASIC_INFORMATION = *mut _TRANSACTION_BASIC_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TRANSACTIONMANAGER_BASIC_INFORMATION {
    pub TmIdentity: GUID,
    pub VirtualClock: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTIONMANAGER_BASIC_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTIONMANAGER_BASIC_INFORMATION>() - 24usize];
    ["Alignment of _TRANSACTIONMANAGER_BASIC_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTIONMANAGER_BASIC_INFORMATION>() - 8usize];
    ["Offset of field: _TRANSACTIONMANAGER_BASIC_INFORMATION::TmIdentity"]
        [::std::mem::offset_of!(_TRANSACTIONMANAGER_BASIC_INFORMATION, TmIdentity) - 0usize];
    ["Offset of field: _TRANSACTIONMANAGER_BASIC_INFORMATION::VirtualClock"]
        [::std::mem::offset_of!(_TRANSACTIONMANAGER_BASIC_INFORMATION, VirtualClock) - 16usize];
};
pub type TRANSACTIONMANAGER_BASIC_INFORMATION = _TRANSACTIONMANAGER_BASIC_INFORMATION;
pub type PTRANSACTIONMANAGER_BASIC_INFORMATION = *mut _TRANSACTIONMANAGER_BASIC_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTIONMANAGER_LOG_INFORMATION {
    pub LogIdentity: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTIONMANAGER_LOG_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTIONMANAGER_LOG_INFORMATION>() - 16usize];
    ["Alignment of _TRANSACTIONMANAGER_LOG_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTIONMANAGER_LOG_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTIONMANAGER_LOG_INFORMATION::LogIdentity"]
        [::std::mem::offset_of!(_TRANSACTIONMANAGER_LOG_INFORMATION, LogIdentity) - 0usize];
};
pub type TRANSACTIONMANAGER_LOG_INFORMATION = _TRANSACTIONMANAGER_LOG_INFORMATION;
pub type PTRANSACTIONMANAGER_LOG_INFORMATION = *mut _TRANSACTIONMANAGER_LOG_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTIONMANAGER_LOGPATH_INFORMATION {
    pub LogPathLength: DWORD,
    pub LogPath: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTIONMANAGER_LOGPATH_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTIONMANAGER_LOGPATH_INFORMATION>() - 8usize];
    ["Alignment of _TRANSACTIONMANAGER_LOGPATH_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTIONMANAGER_LOGPATH_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTIONMANAGER_LOGPATH_INFORMATION::LogPathLength"]
        [::std::mem::offset_of!(_TRANSACTIONMANAGER_LOGPATH_INFORMATION, LogPathLength) - 0usize];
    ["Offset of field: _TRANSACTIONMANAGER_LOGPATH_INFORMATION::LogPath"]
        [::std::mem::offset_of!(_TRANSACTIONMANAGER_LOGPATH_INFORMATION, LogPath) - 4usize];
};
pub type TRANSACTIONMANAGER_LOGPATH_INFORMATION = _TRANSACTIONMANAGER_LOGPATH_INFORMATION;
pub type PTRANSACTIONMANAGER_LOGPATH_INFORMATION = *mut _TRANSACTIONMANAGER_LOGPATH_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTIONMANAGER_RECOVERY_INFORMATION {
    pub LastRecoveredLsn: ULONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTIONMANAGER_RECOVERY_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTIONMANAGER_RECOVERY_INFORMATION>() - 8usize];
    ["Alignment of _TRANSACTIONMANAGER_RECOVERY_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTIONMANAGER_RECOVERY_INFORMATION>() - 8usize];
    ["Offset of field: _TRANSACTIONMANAGER_RECOVERY_INFORMATION::LastRecoveredLsn"][::std::mem::offset_of!(
        _TRANSACTIONMANAGER_RECOVERY_INFORMATION,
        LastRecoveredLsn
    ) - 0usize];
};
pub type TRANSACTIONMANAGER_RECOVERY_INFORMATION = _TRANSACTIONMANAGER_RECOVERY_INFORMATION;
pub type PTRANSACTIONMANAGER_RECOVERY_INFORMATION = *mut _TRANSACTIONMANAGER_RECOVERY_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTIONMANAGER_OLDEST_INFORMATION {
    pub OldestTransactionGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTIONMANAGER_OLDEST_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTIONMANAGER_OLDEST_INFORMATION>() - 16usize];
    ["Alignment of _TRANSACTIONMANAGER_OLDEST_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTIONMANAGER_OLDEST_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTIONMANAGER_OLDEST_INFORMATION::OldestTransactionGuid"][::std::mem::offset_of!(
        _TRANSACTIONMANAGER_OLDEST_INFORMATION,
        OldestTransactionGuid
    ) - 0usize];
};
pub type TRANSACTIONMANAGER_OLDEST_INFORMATION = _TRANSACTIONMANAGER_OLDEST_INFORMATION;
pub type PTRANSACTIONMANAGER_OLDEST_INFORMATION = *mut _TRANSACTIONMANAGER_OLDEST_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TRANSACTION_PROPERTIES_INFORMATION {
    pub IsolationLevel: DWORD,
    pub IsolationFlags: DWORD,
    pub Timeout: LARGE_INTEGER,
    pub Outcome: DWORD,
    pub DescriptionLength: DWORD,
    pub Description: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_PROPERTIES_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_PROPERTIES_INFORMATION>() - 32usize];
    ["Alignment of _TRANSACTION_PROPERTIES_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_PROPERTIES_INFORMATION>() - 8usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::IsolationLevel"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, IsolationLevel) - 0usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::IsolationFlags"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, IsolationFlags) - 4usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::Timeout"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, Timeout) - 8usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::Outcome"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, Outcome) - 16usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::DescriptionLength"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, DescriptionLength) - 20usize];
    ["Offset of field: _TRANSACTION_PROPERTIES_INFORMATION::Description"]
        [::std::mem::offset_of!(_TRANSACTION_PROPERTIES_INFORMATION, Description) - 24usize];
};
pub type TRANSACTION_PROPERTIES_INFORMATION = _TRANSACTION_PROPERTIES_INFORMATION;
pub type PTRANSACTION_PROPERTIES_INFORMATION = *mut _TRANSACTION_PROPERTIES_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_BIND_INFORMATION {
    pub TmHandle: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_BIND_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_BIND_INFORMATION>() - 8usize];
    ["Alignment of _TRANSACTION_BIND_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_BIND_INFORMATION>() - 8usize];
    ["Offset of field: _TRANSACTION_BIND_INFORMATION::TmHandle"]
        [::std::mem::offset_of!(_TRANSACTION_BIND_INFORMATION, TmHandle) - 0usize];
};
pub type TRANSACTION_BIND_INFORMATION = _TRANSACTION_BIND_INFORMATION;
pub type PTRANSACTION_BIND_INFORMATION = *mut _TRANSACTION_BIND_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_ENLISTMENT_PAIR {
    pub EnlistmentId: GUID,
    pub ResourceManagerId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_ENLISTMENT_PAIR"]
        [::std::mem::size_of::<_TRANSACTION_ENLISTMENT_PAIR>() - 32usize];
    ["Alignment of _TRANSACTION_ENLISTMENT_PAIR"]
        [::std::mem::align_of::<_TRANSACTION_ENLISTMENT_PAIR>() - 4usize];
    ["Offset of field: _TRANSACTION_ENLISTMENT_PAIR::EnlistmentId"]
        [::std::mem::offset_of!(_TRANSACTION_ENLISTMENT_PAIR, EnlistmentId) - 0usize];
    ["Offset of field: _TRANSACTION_ENLISTMENT_PAIR::ResourceManagerId"]
        [::std::mem::offset_of!(_TRANSACTION_ENLISTMENT_PAIR, ResourceManagerId) - 16usize];
};
pub type TRANSACTION_ENLISTMENT_PAIR = _TRANSACTION_ENLISTMENT_PAIR;
pub type PTRANSACTION_ENLISTMENT_PAIR = *mut _TRANSACTION_ENLISTMENT_PAIR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_ENLISTMENTS_INFORMATION {
    pub NumberOfEnlistments: DWORD,
    pub EnlistmentPair: [TRANSACTION_ENLISTMENT_PAIR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_ENLISTMENTS_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_ENLISTMENTS_INFORMATION>() - 36usize];
    ["Alignment of _TRANSACTION_ENLISTMENTS_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_ENLISTMENTS_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTION_ENLISTMENTS_INFORMATION::NumberOfEnlistments"][::std::mem::offset_of!(
        _TRANSACTION_ENLISTMENTS_INFORMATION,
        NumberOfEnlistments
    ) - 0usize];
    ["Offset of field: _TRANSACTION_ENLISTMENTS_INFORMATION::EnlistmentPair"]
        [::std::mem::offset_of!(_TRANSACTION_ENLISTMENTS_INFORMATION, EnlistmentPair) - 4usize];
};
pub type TRANSACTION_ENLISTMENTS_INFORMATION = _TRANSACTION_ENLISTMENTS_INFORMATION;
pub type PTRANSACTION_ENLISTMENTS_INFORMATION = *mut _TRANSACTION_ENLISTMENTS_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION {
    pub SuperiorEnlistmentPair: TRANSACTION_ENLISTMENT_PAIR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION>() - 32usize];
    ["Alignment of _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION::SuperiorEnlistmentPair"][::std::mem::offset_of!(
        _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION,
        SuperiorEnlistmentPair
    )
        - 0usize];
};
pub type TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION = _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION;
pub type PTRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION =
    *mut _TRANSACTION_SUPERIOR_ENLISTMENT_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RESOURCEMANAGER_BASIC_INFORMATION {
    pub ResourceManagerId: GUID,
    pub DescriptionLength: DWORD,
    pub Description: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RESOURCEMANAGER_BASIC_INFORMATION"]
        [::std::mem::size_of::<_RESOURCEMANAGER_BASIC_INFORMATION>() - 24usize];
    ["Alignment of _RESOURCEMANAGER_BASIC_INFORMATION"]
        [::std::mem::align_of::<_RESOURCEMANAGER_BASIC_INFORMATION>() - 4usize];
    ["Offset of field: _RESOURCEMANAGER_BASIC_INFORMATION::ResourceManagerId"]
        [::std::mem::offset_of!(_RESOURCEMANAGER_BASIC_INFORMATION, ResourceManagerId) - 0usize];
    ["Offset of field: _RESOURCEMANAGER_BASIC_INFORMATION::DescriptionLength"]
        [::std::mem::offset_of!(_RESOURCEMANAGER_BASIC_INFORMATION, DescriptionLength) - 16usize];
    ["Offset of field: _RESOURCEMANAGER_BASIC_INFORMATION::Description"]
        [::std::mem::offset_of!(_RESOURCEMANAGER_BASIC_INFORMATION, Description) - 20usize];
};
pub type RESOURCEMANAGER_BASIC_INFORMATION = _RESOURCEMANAGER_BASIC_INFORMATION;
pub type PRESOURCEMANAGER_BASIC_INFORMATION = *mut _RESOURCEMANAGER_BASIC_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RESOURCEMANAGER_COMPLETION_INFORMATION {
    pub IoCompletionPortHandle: HANDLE,
    pub CompletionKey: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RESOURCEMANAGER_COMPLETION_INFORMATION"]
        [::std::mem::size_of::<_RESOURCEMANAGER_COMPLETION_INFORMATION>() - 16usize];
    ["Alignment of _RESOURCEMANAGER_COMPLETION_INFORMATION"]
        [::std::mem::align_of::<_RESOURCEMANAGER_COMPLETION_INFORMATION>() - 8usize];
    ["Offset of field: _RESOURCEMANAGER_COMPLETION_INFORMATION::IoCompletionPortHandle"][::std::mem::offset_of!(
        _RESOURCEMANAGER_COMPLETION_INFORMATION,
        IoCompletionPortHandle
    )
        - 0usize];
    ["Offset of field: _RESOURCEMANAGER_COMPLETION_INFORMATION::CompletionKey"]
        [::std::mem::offset_of!(_RESOURCEMANAGER_COMPLETION_INFORMATION, CompletionKey) - 8usize];
};
pub type RESOURCEMANAGER_COMPLETION_INFORMATION = _RESOURCEMANAGER_COMPLETION_INFORMATION;
pub type PRESOURCEMANAGER_COMPLETION_INFORMATION = *mut _RESOURCEMANAGER_COMPLETION_INFORMATION;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionBasicInformation:
    _TRANSACTION_INFORMATION_CLASS = 0;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionPropertiesInformation:
    _TRANSACTION_INFORMATION_CLASS = 1;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionEnlistmentInformation:
    _TRANSACTION_INFORMATION_CLASS = 2;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionSuperiorEnlistmentInformation:
    _TRANSACTION_INFORMATION_CLASS = 3;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionBindInformation:
    _TRANSACTION_INFORMATION_CLASS = 4;
pub const _TRANSACTION_INFORMATION_CLASS_TransactionDTCPrivateInformation:
    _TRANSACTION_INFORMATION_CLASS = 5;
pub type _TRANSACTION_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_TRANSACTION_INFORMATION_CLASS as TRANSACTION_INFORMATION_CLASS;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerBasicInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 0;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerLogInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 1;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerLogPathInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 2;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerRecoveryInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 4;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerOnlineProbeInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 3;
pub const _TRANSACTIONMANAGER_INFORMATION_CLASS_TransactionManagerOldestTransactionInformation:
    _TRANSACTIONMANAGER_INFORMATION_CLASS = 5;
pub type _TRANSACTIONMANAGER_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_TRANSACTIONMANAGER_INFORMATION_CLASS as TRANSACTIONMANAGER_INFORMATION_CLASS;
pub const _RESOURCEMANAGER_INFORMATION_CLASS_ResourceManagerBasicInformation:
    _RESOURCEMANAGER_INFORMATION_CLASS = 0;
pub const _RESOURCEMANAGER_INFORMATION_CLASS_ResourceManagerCompletionInformation:
    _RESOURCEMANAGER_INFORMATION_CLASS = 1;
pub type _RESOURCEMANAGER_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_RESOURCEMANAGER_INFORMATION_CLASS as RESOURCEMANAGER_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENLISTMENT_BASIC_INFORMATION {
    pub EnlistmentId: GUID,
    pub TransactionId: GUID,
    pub ResourceManagerId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENLISTMENT_BASIC_INFORMATION"]
        [::std::mem::size_of::<_ENLISTMENT_BASIC_INFORMATION>() - 48usize];
    ["Alignment of _ENLISTMENT_BASIC_INFORMATION"]
        [::std::mem::align_of::<_ENLISTMENT_BASIC_INFORMATION>() - 4usize];
    ["Offset of field: _ENLISTMENT_BASIC_INFORMATION::EnlistmentId"]
        [::std::mem::offset_of!(_ENLISTMENT_BASIC_INFORMATION, EnlistmentId) - 0usize];
    ["Offset of field: _ENLISTMENT_BASIC_INFORMATION::TransactionId"]
        [::std::mem::offset_of!(_ENLISTMENT_BASIC_INFORMATION, TransactionId) - 16usize];
    ["Offset of field: _ENLISTMENT_BASIC_INFORMATION::ResourceManagerId"]
        [::std::mem::offset_of!(_ENLISTMENT_BASIC_INFORMATION, ResourceManagerId) - 32usize];
};
pub type ENLISTMENT_BASIC_INFORMATION = _ENLISTMENT_BASIC_INFORMATION;
pub type PENLISTMENT_BASIC_INFORMATION = *mut _ENLISTMENT_BASIC_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENLISTMENT_CRM_INFORMATION {
    pub CrmTransactionManagerId: GUID,
    pub CrmResourceManagerId: GUID,
    pub CrmEnlistmentId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENLISTMENT_CRM_INFORMATION"]
        [::std::mem::size_of::<_ENLISTMENT_CRM_INFORMATION>() - 48usize];
    ["Alignment of _ENLISTMENT_CRM_INFORMATION"]
        [::std::mem::align_of::<_ENLISTMENT_CRM_INFORMATION>() - 4usize];
    ["Offset of field: _ENLISTMENT_CRM_INFORMATION::CrmTransactionManagerId"]
        [::std::mem::offset_of!(_ENLISTMENT_CRM_INFORMATION, CrmTransactionManagerId) - 0usize];
    ["Offset of field: _ENLISTMENT_CRM_INFORMATION::CrmResourceManagerId"]
        [::std::mem::offset_of!(_ENLISTMENT_CRM_INFORMATION, CrmResourceManagerId) - 16usize];
    ["Offset of field: _ENLISTMENT_CRM_INFORMATION::CrmEnlistmentId"]
        [::std::mem::offset_of!(_ENLISTMENT_CRM_INFORMATION, CrmEnlistmentId) - 32usize];
};
pub type ENLISTMENT_CRM_INFORMATION = _ENLISTMENT_CRM_INFORMATION;
pub type PENLISTMENT_CRM_INFORMATION = *mut _ENLISTMENT_CRM_INFORMATION;
pub const _ENLISTMENT_INFORMATION_CLASS_EnlistmentBasicInformation: _ENLISTMENT_INFORMATION_CLASS =
    0;
pub const _ENLISTMENT_INFORMATION_CLASS_EnlistmentRecoveryInformation:
    _ENLISTMENT_INFORMATION_CLASS = 1;
pub const _ENLISTMENT_INFORMATION_CLASS_EnlistmentCrmInformation: _ENLISTMENT_INFORMATION_CLASS = 2;
pub type _ENLISTMENT_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_ENLISTMENT_INFORMATION_CLASS as ENLISTMENT_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_LIST_ENTRY {
    pub UOW: UOW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_LIST_ENTRY"][::std::mem::size_of::<_TRANSACTION_LIST_ENTRY>() - 16usize];
    ["Alignment of _TRANSACTION_LIST_ENTRY"]
        [::std::mem::align_of::<_TRANSACTION_LIST_ENTRY>() - 4usize];
    ["Offset of field: _TRANSACTION_LIST_ENTRY::UOW"]
        [::std::mem::offset_of!(_TRANSACTION_LIST_ENTRY, UOW) - 0usize];
};
pub type TRANSACTION_LIST_ENTRY = _TRANSACTION_LIST_ENTRY;
pub type PTRANSACTION_LIST_ENTRY = *mut _TRANSACTION_LIST_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSACTION_LIST_INFORMATION {
    pub NumberOfTransactions: DWORD,
    pub TransactionInformation: [TRANSACTION_LIST_ENTRY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSACTION_LIST_INFORMATION"]
        [::std::mem::size_of::<_TRANSACTION_LIST_INFORMATION>() - 20usize];
    ["Alignment of _TRANSACTION_LIST_INFORMATION"]
        [::std::mem::align_of::<_TRANSACTION_LIST_INFORMATION>() - 4usize];
    ["Offset of field: _TRANSACTION_LIST_INFORMATION::NumberOfTransactions"]
        [::std::mem::offset_of!(_TRANSACTION_LIST_INFORMATION, NumberOfTransactions) - 0usize];
    ["Offset of field: _TRANSACTION_LIST_INFORMATION::TransactionInformation"]
        [::std::mem::offset_of!(_TRANSACTION_LIST_INFORMATION, TransactionInformation) - 4usize];
};
pub type TRANSACTION_LIST_INFORMATION = _TRANSACTION_LIST_INFORMATION;
pub type PTRANSACTION_LIST_INFORMATION = *mut _TRANSACTION_LIST_INFORMATION;
pub const _KTMOBJECT_TYPE_KTMOBJECT_TRANSACTION: _KTMOBJECT_TYPE = 0;
pub const _KTMOBJECT_TYPE_KTMOBJECT_TRANSACTION_MANAGER: _KTMOBJECT_TYPE = 1;
pub const _KTMOBJECT_TYPE_KTMOBJECT_RESOURCE_MANAGER: _KTMOBJECT_TYPE = 2;
pub const _KTMOBJECT_TYPE_KTMOBJECT_ENLISTMENT: _KTMOBJECT_TYPE = 3;
pub const _KTMOBJECT_TYPE_KTMOBJECT_INVALID: _KTMOBJECT_TYPE = 4;
pub type _KTMOBJECT_TYPE = ::std::os::raw::c_int;
pub use self::_KTMOBJECT_TYPE as KTMOBJECT_TYPE;
pub type PKTMOBJECT_TYPE = *mut _KTMOBJECT_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KTMOBJECT_CURSOR {
    pub LastQuery: GUID,
    pub ObjectIdCount: DWORD,
    pub ObjectIds: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KTMOBJECT_CURSOR"][::std::mem::size_of::<_KTMOBJECT_CURSOR>() - 36usize];
    ["Alignment of _KTMOBJECT_CURSOR"][::std::mem::align_of::<_KTMOBJECT_CURSOR>() - 4usize];
    ["Offset of field: _KTMOBJECT_CURSOR::LastQuery"]
        [::std::mem::offset_of!(_KTMOBJECT_CURSOR, LastQuery) - 0usize];
    ["Offset of field: _KTMOBJECT_CURSOR::ObjectIdCount"]
        [::std::mem::offset_of!(_KTMOBJECT_CURSOR, ObjectIdCount) - 16usize];
    ["Offset of field: _KTMOBJECT_CURSOR::ObjectIds"]
        [::std::mem::offset_of!(_KTMOBJECT_CURSOR, ObjectIds) - 20usize];
};
pub type KTMOBJECT_CURSOR = _KTMOBJECT_CURSOR;
pub type PKTMOBJECT_CURSOR = *mut _KTMOBJECT_CURSOR;
pub type TP_VERSION = DWORD;
pub type PTP_VERSION = *mut DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_CALLBACK_INSTANCE {
    _unused: [u8; 0],
}
pub type TP_CALLBACK_INSTANCE = _TP_CALLBACK_INSTANCE;
pub type PTP_CALLBACK_INSTANCE = *mut _TP_CALLBACK_INSTANCE;
pub type PTP_SIMPLE_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(Instance: PTP_CALLBACK_INSTANCE, Context: PVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_POOL {
    _unused: [u8; 0],
}
pub type TP_POOL = _TP_POOL;
pub type PTP_POOL = *mut _TP_POOL;
pub const _TP_CALLBACK_PRIORITY_TP_CALLBACK_PRIORITY_HIGH: _TP_CALLBACK_PRIORITY = 0;
pub const _TP_CALLBACK_PRIORITY_TP_CALLBACK_PRIORITY_NORMAL: _TP_CALLBACK_PRIORITY = 1;
pub const _TP_CALLBACK_PRIORITY_TP_CALLBACK_PRIORITY_LOW: _TP_CALLBACK_PRIORITY = 2;
pub const _TP_CALLBACK_PRIORITY_TP_CALLBACK_PRIORITY_INVALID: _TP_CALLBACK_PRIORITY = 3;
pub const _TP_CALLBACK_PRIORITY_TP_CALLBACK_PRIORITY_COUNT: _TP_CALLBACK_PRIORITY = 3;
pub type _TP_CALLBACK_PRIORITY = ::std::os::raw::c_int;
pub use self::_TP_CALLBACK_PRIORITY as TP_CALLBACK_PRIORITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_POOL_STACK_INFORMATION {
    pub StackReserve: SIZE_T,
    pub StackCommit: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TP_POOL_STACK_INFORMATION"]
        [::std::mem::size_of::<_TP_POOL_STACK_INFORMATION>() - 16usize];
    ["Alignment of _TP_POOL_STACK_INFORMATION"]
        [::std::mem::align_of::<_TP_POOL_STACK_INFORMATION>() - 8usize];
    ["Offset of field: _TP_POOL_STACK_INFORMATION::StackReserve"]
        [::std::mem::offset_of!(_TP_POOL_STACK_INFORMATION, StackReserve) - 0usize];
    ["Offset of field: _TP_POOL_STACK_INFORMATION::StackCommit"]
        [::std::mem::offset_of!(_TP_POOL_STACK_INFORMATION, StackCommit) - 8usize];
};
pub type TP_POOL_STACK_INFORMATION = _TP_POOL_STACK_INFORMATION;
pub type PTP_POOL_STACK_INFORMATION = *mut _TP_POOL_STACK_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_CLEANUP_GROUP {
    _unused: [u8; 0],
}
pub type TP_CLEANUP_GROUP = _TP_CLEANUP_GROUP;
pub type PTP_CLEANUP_GROUP = *mut _TP_CLEANUP_GROUP;
pub type PTP_CLEANUP_GROUP_CANCEL_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(ObjectContext: PVOID, CleanupContext: PVOID)>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TP_CALLBACK_ENVIRON_V3 {
    pub Version: TP_VERSION,
    pub Pool: PTP_POOL,
    pub CleanupGroup: PTP_CLEANUP_GROUP,
    pub CleanupGroupCancelCallback: PTP_CLEANUP_GROUP_CANCEL_CALLBACK,
    pub RaceDll: PVOID,
    pub ActivationContext: *mut _ACTIVATION_CONTEXT,
    pub FinalizationCallback: PTP_SIMPLE_CALLBACK,
    pub u: _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1,
    pub CallbackPriority: TP_CALLBACK_PRIORITY,
    pub Size: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1 {
    pub Flags: DWORD,
    pub s: _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1>() - 4usize];
};
impl _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn LongFunction(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_LongFunction(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn LongFunction_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_LongFunction_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Persistent(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Persistent(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Persistent_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Persistent_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Private(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_Private(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Private_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Private_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        LongFunction: DWORD,
        Persistent: DWORD,
        Private: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let LongFunction: u32 = unsafe { ::std::mem::transmute(LongFunction) };
            LongFunction as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let Persistent: u32 = unsafe { ::std::mem::transmute(Persistent) };
            Persistent as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let Private: u32 = unsafe { ::std::mem::transmute(Private) };
            Private as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1"]
        [::std::mem::size_of::<_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1>() - 4usize];
    ["Alignment of _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1"]
        [::std::mem::align_of::<_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1>() - 4usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1, Flags) - 0usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3__bindgen_ty_1::s"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3__bindgen_ty_1, s) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TP_CALLBACK_ENVIRON_V3"][::std::mem::size_of::<_TP_CALLBACK_ENVIRON_V3>() - 72usize];
    ["Alignment of _TP_CALLBACK_ENVIRON_V3"]
        [::std::mem::align_of::<_TP_CALLBACK_ENVIRON_V3>() - 8usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::Version"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, Version) - 0usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::Pool"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, Pool) - 8usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::CleanupGroup"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, CleanupGroup) - 16usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::CleanupGroupCancelCallback"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, CleanupGroupCancelCallback) - 24usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::RaceDll"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, RaceDll) - 32usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::ActivationContext"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, ActivationContext) - 40usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::FinalizationCallback"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, FinalizationCallback) - 48usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::u"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, u) - 56usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::CallbackPriority"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, CallbackPriority) - 60usize];
    ["Offset of field: _TP_CALLBACK_ENVIRON_V3::Size"]
        [::std::mem::offset_of!(_TP_CALLBACK_ENVIRON_V3, Size) - 64usize];
};
pub type TP_CALLBACK_ENVIRON_V3 = _TP_CALLBACK_ENVIRON_V3;
pub type TP_CALLBACK_ENVIRON = TP_CALLBACK_ENVIRON_V3;
pub type PTP_CALLBACK_ENVIRON = *mut TP_CALLBACK_ENVIRON_V3;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_WORK {
    _unused: [u8; 0],
}
pub type TP_WORK = _TP_WORK;
pub type PTP_WORK = *mut _TP_WORK;
pub type PTP_WORK_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(Instance: PTP_CALLBACK_INSTANCE, Context: PVOID, Work: PTP_WORK),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_TIMER {
    _unused: [u8; 0],
}
pub type TP_TIMER = _TP_TIMER;
pub type PTP_TIMER = *mut _TP_TIMER;
pub type PTP_TIMER_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(Instance: PTP_CALLBACK_INSTANCE, Context: PVOID, Timer: PTP_TIMER),
>;
pub type TP_WAIT_RESULT = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_WAIT {
    _unused: [u8; 0],
}
pub type TP_WAIT = _TP_WAIT;
pub type PTP_WAIT = *mut _TP_WAIT;
pub type PTP_WAIT_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        Instance: PTP_CALLBACK_INSTANCE,
        Context: PVOID,
        Wait: PTP_WAIT,
        WaitResult: TP_WAIT_RESULT,
    ),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TP_IO {
    _unused: [u8; 0],
}
pub type TP_IO = _TP_IO;
pub type PTP_IO = *mut _TP_IO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TEB {
    _unused: [u8; 0],
}
pub type WPARAM = UINT_PTR;
pub type LPARAM = LONG_PTR;
pub type LRESULT = LONG_PTR;
pub type SPHANDLE = *mut HANDLE;
pub type LPHANDLE = *mut HANDLE;
pub type HGLOBAL = HANDLE;
pub type HLOCAL = HANDLE;
pub type GLOBALHANDLE = HANDLE;
pub type LOCALHANDLE = HANDLE;
pub type FARPROC = ::std::option::Option<unsafe extern "C" fn() -> INT_PTR>;
pub type NEARPROC = ::std::option::Option<unsafe extern "C" fn() -> INT_PTR>;
pub type PROC = ::std::option::Option<unsafe extern "C" fn() -> INT_PTR>;
pub type ATOM = WORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HKEY__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HKEY__"][::std::mem::size_of::<HKEY__>() - 4usize];
    ["Alignment of HKEY__"][::std::mem::align_of::<HKEY__>() - 4usize];
    ["Offset of field: HKEY__::unused"][::std::mem::offset_of!(HKEY__, unused) - 0usize];
};
pub type HKEY = *mut HKEY__;
pub type PHKEY = *mut HKEY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HMETAFILE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMETAFILE__"][::std::mem::size_of::<HMETAFILE__>() - 4usize];
    ["Alignment of HMETAFILE__"][::std::mem::align_of::<HMETAFILE__>() - 4usize];
    ["Offset of field: HMETAFILE__::unused"][::std::mem::offset_of!(HMETAFILE__, unused) - 0usize];
};
pub type HMETAFILE = *mut HMETAFILE__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HINSTANCE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HINSTANCE__"][::std::mem::size_of::<HINSTANCE__>() - 4usize];
    ["Alignment of HINSTANCE__"][::std::mem::align_of::<HINSTANCE__>() - 4usize];
    ["Offset of field: HINSTANCE__::unused"][::std::mem::offset_of!(HINSTANCE__, unused) - 0usize];
};
pub type HINSTANCE = *mut HINSTANCE__;
pub type HMODULE = HINSTANCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HRGN__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HRGN__"][::std::mem::size_of::<HRGN__>() - 4usize];
    ["Alignment of HRGN__"][::std::mem::align_of::<HRGN__>() - 4usize];
    ["Offset of field: HRGN__::unused"][::std::mem::offset_of!(HRGN__, unused) - 0usize];
};
pub type HRGN = *mut HRGN__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HRSRC__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HRSRC__"][::std::mem::size_of::<HRSRC__>() - 4usize];
    ["Alignment of HRSRC__"][::std::mem::align_of::<HRSRC__>() - 4usize];
    ["Offset of field: HRSRC__::unused"][::std::mem::offset_of!(HRSRC__, unused) - 0usize];
};
pub type HRSRC = *mut HRSRC__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HSPRITE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HSPRITE__"][::std::mem::size_of::<HSPRITE__>() - 4usize];
    ["Alignment of HSPRITE__"][::std::mem::align_of::<HSPRITE__>() - 4usize];
    ["Offset of field: HSPRITE__::unused"][::std::mem::offset_of!(HSPRITE__, unused) - 0usize];
};
pub type HSPRITE = *mut HSPRITE__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HLSURF__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HLSURF__"][::std::mem::size_of::<HLSURF__>() - 4usize];
    ["Alignment of HLSURF__"][::std::mem::align_of::<HLSURF__>() - 4usize];
    ["Offset of field: HLSURF__::unused"][::std::mem::offset_of!(HLSURF__, unused) - 0usize];
};
pub type HLSURF = *mut HLSURF__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HSTR__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HSTR__"][::std::mem::size_of::<HSTR__>() - 4usize];
    ["Alignment of HSTR__"][::std::mem::align_of::<HSTR__>() - 4usize];
    ["Offset of field: HSTR__::unused"][::std::mem::offset_of!(HSTR__, unused) - 0usize];
};
pub type HSTR = *mut HSTR__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HTASK__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HTASK__"][::std::mem::size_of::<HTASK__>() - 4usize];
    ["Alignment of HTASK__"][::std::mem::align_of::<HTASK__>() - 4usize];
    ["Offset of field: HTASK__::unused"][::std::mem::offset_of!(HTASK__, unused) - 0usize];
};
pub type HTASK = *mut HTASK__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HWINSTA__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWINSTA__"][::std::mem::size_of::<HWINSTA__>() - 4usize];
    ["Alignment of HWINSTA__"][::std::mem::align_of::<HWINSTA__>() - 4usize];
    ["Offset of field: HWINSTA__::unused"][::std::mem::offset_of!(HWINSTA__, unused) - 0usize];
};
pub type HWINSTA = *mut HWINSTA__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HKL__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HKL__"][::std::mem::size_of::<HKL__>() - 4usize];
    ["Alignment of HKL__"][::std::mem::align_of::<HKL__>() - 4usize];
    ["Offset of field: HKL__::unused"][::std::mem::offset_of!(HKL__, unused) - 0usize];
};
pub type HKL = *mut HKL__;
pub type HFILE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILETIME {
    pub dwLowDateTime: DWORD,
    pub dwHighDateTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILETIME"][::std::mem::size_of::<_FILETIME>() - 8usize];
    ["Alignment of _FILETIME"][::std::mem::align_of::<_FILETIME>() - 4usize];
    ["Offset of field: _FILETIME::dwLowDateTime"]
        [::std::mem::offset_of!(_FILETIME, dwLowDateTime) - 0usize];
    ["Offset of field: _FILETIME::dwHighDateTime"]
        [::std::mem::offset_of!(_FILETIME, dwHighDateTime) - 4usize];
};
pub type FILETIME = _FILETIME;
pub type PFILETIME = *mut _FILETIME;
pub type LPFILETIME = *mut _FILETIME;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HWND__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWND__"][::std::mem::size_of::<HWND__>() - 4usize];
    ["Alignment of HWND__"][::std::mem::align_of::<HWND__>() - 4usize];
    ["Offset of field: HWND__::unused"][::std::mem::offset_of!(HWND__, unused) - 0usize];
};
pub type HWND = *mut HWND__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HHOOK__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HHOOK__"][::std::mem::size_of::<HHOOK__>() - 4usize];
    ["Alignment of HHOOK__"][::std::mem::align_of::<HHOOK__>() - 4usize];
    ["Offset of field: HHOOK__::unused"][::std::mem::offset_of!(HHOOK__, unused) - 0usize];
};
pub type HHOOK = *mut HHOOK__;
pub type HGDIOBJ = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HACCEL__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HACCEL__"][::std::mem::size_of::<HACCEL__>() - 4usize];
    ["Alignment of HACCEL__"][::std::mem::align_of::<HACCEL__>() - 4usize];
    ["Offset of field: HACCEL__::unused"][::std::mem::offset_of!(HACCEL__, unused) - 0usize];
};
pub type HACCEL = *mut HACCEL__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HBITMAP__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HBITMAP__"][::std::mem::size_of::<HBITMAP__>() - 4usize];
    ["Alignment of HBITMAP__"][::std::mem::align_of::<HBITMAP__>() - 4usize];
    ["Offset of field: HBITMAP__::unused"][::std::mem::offset_of!(HBITMAP__, unused) - 0usize];
};
pub type HBITMAP = *mut HBITMAP__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HBRUSH__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HBRUSH__"][::std::mem::size_of::<HBRUSH__>() - 4usize];
    ["Alignment of HBRUSH__"][::std::mem::align_of::<HBRUSH__>() - 4usize];
    ["Offset of field: HBRUSH__::unused"][::std::mem::offset_of!(HBRUSH__, unused) - 0usize];
};
pub type HBRUSH = *mut HBRUSH__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HCOLORSPACE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HCOLORSPACE__"][::std::mem::size_of::<HCOLORSPACE__>() - 4usize];
    ["Alignment of HCOLORSPACE__"][::std::mem::align_of::<HCOLORSPACE__>() - 4usize];
    ["Offset of field: HCOLORSPACE__::unused"]
        [::std::mem::offset_of!(HCOLORSPACE__, unused) - 0usize];
};
pub type HCOLORSPACE = *mut HCOLORSPACE__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HDC__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HDC__"][::std::mem::size_of::<HDC__>() - 4usize];
    ["Alignment of HDC__"][::std::mem::align_of::<HDC__>() - 4usize];
    ["Offset of field: HDC__::unused"][::std::mem::offset_of!(HDC__, unused) - 0usize];
};
pub type HDC = *mut HDC__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HGLRC__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HGLRC__"][::std::mem::size_of::<HGLRC__>() - 4usize];
    ["Alignment of HGLRC__"][::std::mem::align_of::<HGLRC__>() - 4usize];
    ["Offset of field: HGLRC__::unused"][::std::mem::offset_of!(HGLRC__, unused) - 0usize];
};
pub type HGLRC = *mut HGLRC__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HDESK__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HDESK__"][::std::mem::size_of::<HDESK__>() - 4usize];
    ["Alignment of HDESK__"][::std::mem::align_of::<HDESK__>() - 4usize];
    ["Offset of field: HDESK__::unused"][::std::mem::offset_of!(HDESK__, unused) - 0usize];
};
pub type HDESK = *mut HDESK__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HENHMETAFILE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HENHMETAFILE__"][::std::mem::size_of::<HENHMETAFILE__>() - 4usize];
    ["Alignment of HENHMETAFILE__"][::std::mem::align_of::<HENHMETAFILE__>() - 4usize];
    ["Offset of field: HENHMETAFILE__::unused"]
        [::std::mem::offset_of!(HENHMETAFILE__, unused) - 0usize];
};
pub type HENHMETAFILE = *mut HENHMETAFILE__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HFONT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HFONT__"][::std::mem::size_of::<HFONT__>() - 4usize];
    ["Alignment of HFONT__"][::std::mem::align_of::<HFONT__>() - 4usize];
    ["Offset of field: HFONT__::unused"][::std::mem::offset_of!(HFONT__, unused) - 0usize];
};
pub type HFONT = *mut HFONT__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HICON__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HICON__"][::std::mem::size_of::<HICON__>() - 4usize];
    ["Alignment of HICON__"][::std::mem::align_of::<HICON__>() - 4usize];
    ["Offset of field: HICON__::unused"][::std::mem::offset_of!(HICON__, unused) - 0usize];
};
pub type HICON = *mut HICON__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HMENU__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMENU__"][::std::mem::size_of::<HMENU__>() - 4usize];
    ["Alignment of HMENU__"][::std::mem::align_of::<HMENU__>() - 4usize];
    ["Offset of field: HMENU__::unused"][::std::mem::offset_of!(HMENU__, unused) - 0usize];
};
pub type HMENU = *mut HMENU__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HPALETTE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HPALETTE__"][::std::mem::size_of::<HPALETTE__>() - 4usize];
    ["Alignment of HPALETTE__"][::std::mem::align_of::<HPALETTE__>() - 4usize];
    ["Offset of field: HPALETTE__::unused"][::std::mem::offset_of!(HPALETTE__, unused) - 0usize];
};
pub type HPALETTE = *mut HPALETTE__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HPEN__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HPEN__"][::std::mem::size_of::<HPEN__>() - 4usize];
    ["Alignment of HPEN__"][::std::mem::align_of::<HPEN__>() - 4usize];
    ["Offset of field: HPEN__::unused"][::std::mem::offset_of!(HPEN__, unused) - 0usize];
};
pub type HPEN = *mut HPEN__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HWINEVENTHOOK__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWINEVENTHOOK__"][::std::mem::size_of::<HWINEVENTHOOK__>() - 4usize];
    ["Alignment of HWINEVENTHOOK__"][::std::mem::align_of::<HWINEVENTHOOK__>() - 4usize];
    ["Offset of field: HWINEVENTHOOK__::unused"]
        [::std::mem::offset_of!(HWINEVENTHOOK__, unused) - 0usize];
};
pub type HWINEVENTHOOK = *mut HWINEVENTHOOK__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HMONITOR__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMONITOR__"][::std::mem::size_of::<HMONITOR__>() - 4usize];
    ["Alignment of HMONITOR__"][::std::mem::align_of::<HMONITOR__>() - 4usize];
    ["Offset of field: HMONITOR__::unused"][::std::mem::offset_of!(HMONITOR__, unused) - 0usize];
};
pub type HMONITOR = *mut HMONITOR__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HUMPD__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HUMPD__"][::std::mem::size_of::<HUMPD__>() - 4usize];
    ["Alignment of HUMPD__"][::std::mem::align_of::<HUMPD__>() - 4usize];
    ["Offset of field: HUMPD__::unused"][::std::mem::offset_of!(HUMPD__, unused) - 0usize];
};
pub type HUMPD = *mut HUMPD__;
pub type HCURSOR = HICON;
pub type COLORREF = DWORD;
pub type LPCOLORREF = *mut DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRECT {
    pub left: LONG,
    pub top: LONG,
    pub right: LONG,
    pub bottom: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRECT"][::std::mem::size_of::<tagRECT>() - 16usize];
    ["Alignment of tagRECT"][::std::mem::align_of::<tagRECT>() - 4usize];
    ["Offset of field: tagRECT::left"][::std::mem::offset_of!(tagRECT, left) - 0usize];
    ["Offset of field: tagRECT::top"][::std::mem::offset_of!(tagRECT, top) - 4usize];
    ["Offset of field: tagRECT::right"][::std::mem::offset_of!(tagRECT, right) - 8usize];
    ["Offset of field: tagRECT::bottom"][::std::mem::offset_of!(tagRECT, bottom) - 12usize];
};
pub type RECT = tagRECT;
pub type PRECT = *mut tagRECT;
pub type NPRECT = *mut tagRECT;
pub type LPRECT = *mut tagRECT;
pub type LPCRECT = *const RECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RECTL {
    pub left: LONG,
    pub top: LONG,
    pub right: LONG,
    pub bottom: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RECTL"][::std::mem::size_of::<_RECTL>() - 16usize];
    ["Alignment of _RECTL"][::std::mem::align_of::<_RECTL>() - 4usize];
    ["Offset of field: _RECTL::left"][::std::mem::offset_of!(_RECTL, left) - 0usize];
    ["Offset of field: _RECTL::top"][::std::mem::offset_of!(_RECTL, top) - 4usize];
    ["Offset of field: _RECTL::right"][::std::mem::offset_of!(_RECTL, right) - 8usize];
    ["Offset of field: _RECTL::bottom"][::std::mem::offset_of!(_RECTL, bottom) - 12usize];
};
pub type RECTL = _RECTL;
pub type PRECTL = *mut _RECTL;
pub type LPRECTL = *mut _RECTL;
pub type LPCRECTL = *const RECTL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINT {
    pub x: LONG,
    pub y: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINT"][::std::mem::size_of::<tagPOINT>() - 8usize];
    ["Alignment of tagPOINT"][::std::mem::align_of::<tagPOINT>() - 4usize];
    ["Offset of field: tagPOINT::x"][::std::mem::offset_of!(tagPOINT, x) - 0usize];
    ["Offset of field: tagPOINT::y"][::std::mem::offset_of!(tagPOINT, y) - 4usize];
};
pub type POINT = tagPOINT;
pub type PPOINT = *mut tagPOINT;
pub type NPPOINT = *mut tagPOINT;
pub type LPPOINT = *mut tagPOINT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POINTL {
    pub x: LONG,
    pub y: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POINTL"][::std::mem::size_of::<_POINTL>() - 8usize];
    ["Alignment of _POINTL"][::std::mem::align_of::<_POINTL>() - 4usize];
    ["Offset of field: _POINTL::x"][::std::mem::offset_of!(_POINTL, x) - 0usize];
    ["Offset of field: _POINTL::y"][::std::mem::offset_of!(_POINTL, y) - 4usize];
};
pub type POINTL = _POINTL;
pub type PPOINTL = *mut _POINTL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSIZE {
    pub cx: LONG,
    pub cy: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSIZE"][::std::mem::size_of::<tagSIZE>() - 8usize];
    ["Alignment of tagSIZE"][::std::mem::align_of::<tagSIZE>() - 4usize];
    ["Offset of field: tagSIZE::cx"][::std::mem::offset_of!(tagSIZE, cx) - 0usize];
    ["Offset of field: tagSIZE::cy"][::std::mem::offset_of!(tagSIZE, cy) - 4usize];
};
pub type SIZE = tagSIZE;
pub type PSIZE = *mut tagSIZE;
pub type LPSIZE = *mut tagSIZE;
pub type SIZEL = SIZE;
pub type PSIZEL = *mut SIZE;
pub type LPSIZEL = *mut SIZE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTS {
    pub x: SHORT,
    pub y: SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTS"][::std::mem::size_of::<tagPOINTS>() - 4usize];
    ["Alignment of tagPOINTS"][::std::mem::align_of::<tagPOINTS>() - 2usize];
    ["Offset of field: tagPOINTS::x"][::std::mem::offset_of!(tagPOINTS, x) - 0usize];
    ["Offset of field: tagPOINTS::y"][::std::mem::offset_of!(tagPOINTS, y) - 2usize];
};
pub type POINTS = tagPOINTS;
pub type PPOINTS = *mut tagPOINTS;
pub type LPPOINTS = *mut tagPOINTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct APP_LOCAL_DEVICE_ID {
    pub value: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of APP_LOCAL_DEVICE_ID"][::std::mem::size_of::<APP_LOCAL_DEVICE_ID>() - 32usize];
    ["Alignment of APP_LOCAL_DEVICE_ID"][::std::mem::align_of::<APP_LOCAL_DEVICE_ID>() - 1usize];
    ["Offset of field: APP_LOCAL_DEVICE_ID::value"]
        [::std::mem::offset_of!(APP_LOCAL_DEVICE_ID, value) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DPI_AWARENESS_CONTEXT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DPI_AWARENESS_CONTEXT__"][::std::mem::size_of::<DPI_AWARENESS_CONTEXT__>() - 4usize];
    ["Alignment of DPI_AWARENESS_CONTEXT__"]
        [::std::mem::align_of::<DPI_AWARENESS_CONTEXT__>() - 4usize];
    ["Offset of field: DPI_AWARENESS_CONTEXT__::unused"]
        [::std::mem::offset_of!(DPI_AWARENESS_CONTEXT__, unused) - 0usize];
};
pub type DPI_AWARENESS_CONTEXT = *mut DPI_AWARENESS_CONTEXT__;
pub const DPI_AWARENESS_DPI_AWARENESS_INVALID: DPI_AWARENESS = -1;
pub const DPI_AWARENESS_DPI_AWARENESS_UNAWARE: DPI_AWARENESS = 0;
pub const DPI_AWARENESS_DPI_AWARENESS_SYSTEM_AWARE: DPI_AWARENESS = 1;
pub const DPI_AWARENESS_DPI_AWARENESS_PER_MONITOR_AWARE: DPI_AWARENESS = 2;
pub type DPI_AWARENESS = ::std::os::raw::c_int;
pub const DPI_HOSTING_BEHAVIOR_DPI_HOSTING_BEHAVIOR_INVALID: DPI_HOSTING_BEHAVIOR = -1;
pub const DPI_HOSTING_BEHAVIOR_DPI_HOSTING_BEHAVIOR_DEFAULT: DPI_HOSTING_BEHAVIOR = 0;
pub const DPI_HOSTING_BEHAVIOR_DPI_HOSTING_BEHAVIOR_MIXED: DPI_HOSTING_BEHAVIOR = 1;
pub type DPI_HOSTING_BEHAVIOR = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SECURITY_ATTRIBUTES {
    pub nLength: DWORD,
    pub lpSecurityDescriptor: LPVOID,
    pub bInheritHandle: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SECURITY_ATTRIBUTES"][::std::mem::size_of::<_SECURITY_ATTRIBUTES>() - 24usize];
    ["Alignment of _SECURITY_ATTRIBUTES"][::std::mem::align_of::<_SECURITY_ATTRIBUTES>() - 8usize];
    ["Offset of field: _SECURITY_ATTRIBUTES::nLength"]
        [::std::mem::offset_of!(_SECURITY_ATTRIBUTES, nLength) - 0usize];
    ["Offset of field: _SECURITY_ATTRIBUTES::lpSecurityDescriptor"]
        [::std::mem::offset_of!(_SECURITY_ATTRIBUTES, lpSecurityDescriptor) - 8usize];
    ["Offset of field: _SECURITY_ATTRIBUTES::bInheritHandle"]
        [::std::mem::offset_of!(_SECURITY_ATTRIBUTES, bInheritHandle) - 16usize];
};
pub type SECURITY_ATTRIBUTES = _SECURITY_ATTRIBUTES;
pub type PSECURITY_ATTRIBUTES = *mut _SECURITY_ATTRIBUTES;
pub type LPSECURITY_ATTRIBUTES = *mut _SECURITY_ATTRIBUTES;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _OVERLAPPED {
    pub Internal: ULONG_PTR,
    pub InternalHigh: ULONG_PTR,
    pub __bindgen_anon_1: _OVERLAPPED__bindgen_ty_1,
    pub hEvent: HANDLE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _OVERLAPPED__bindgen_ty_1 {
    pub __bindgen_anon_1: _OVERLAPPED__bindgen_ty_1__bindgen_ty_1,
    pub Pointer: PVOID,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OVERLAPPED__bindgen_ty_1__bindgen_ty_1 {
    pub Offset: DWORD,
    pub OffsetHigh: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OVERLAPPED__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_OVERLAPPED__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _OVERLAPPED__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_OVERLAPPED__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: _OVERLAPPED__bindgen_ty_1__bindgen_ty_1::Offset"]
        [::std::mem::offset_of!(_OVERLAPPED__bindgen_ty_1__bindgen_ty_1, Offset) - 0usize];
    ["Offset of field: _OVERLAPPED__bindgen_ty_1__bindgen_ty_1::OffsetHigh"]
        [::std::mem::offset_of!(_OVERLAPPED__bindgen_ty_1__bindgen_ty_1, OffsetHigh) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OVERLAPPED__bindgen_ty_1"]
        [::std::mem::size_of::<_OVERLAPPED__bindgen_ty_1>() - 8usize];
    ["Alignment of _OVERLAPPED__bindgen_ty_1"]
        [::std::mem::align_of::<_OVERLAPPED__bindgen_ty_1>() - 8usize];
    ["Offset of field: _OVERLAPPED__bindgen_ty_1::Pointer"]
        [::std::mem::offset_of!(_OVERLAPPED__bindgen_ty_1, Pointer) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OVERLAPPED"][::std::mem::size_of::<_OVERLAPPED>() - 32usize];
    ["Alignment of _OVERLAPPED"][::std::mem::align_of::<_OVERLAPPED>() - 8usize];
    ["Offset of field: _OVERLAPPED::Internal"]
        [::std::mem::offset_of!(_OVERLAPPED, Internal) - 0usize];
    ["Offset of field: _OVERLAPPED::InternalHigh"]
        [::std::mem::offset_of!(_OVERLAPPED, InternalHigh) - 8usize];
    ["Offset of field: _OVERLAPPED::hEvent"][::std::mem::offset_of!(_OVERLAPPED, hEvent) - 24usize];
};
pub type OVERLAPPED = _OVERLAPPED;
pub type LPOVERLAPPED = *mut _OVERLAPPED;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OVERLAPPED_ENTRY {
    pub lpCompletionKey: ULONG_PTR,
    pub lpOverlapped: LPOVERLAPPED,
    pub Internal: ULONG_PTR,
    pub dwNumberOfBytesTransferred: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OVERLAPPED_ENTRY"][::std::mem::size_of::<_OVERLAPPED_ENTRY>() - 32usize];
    ["Alignment of _OVERLAPPED_ENTRY"][::std::mem::align_of::<_OVERLAPPED_ENTRY>() - 8usize];
    ["Offset of field: _OVERLAPPED_ENTRY::lpCompletionKey"]
        [::std::mem::offset_of!(_OVERLAPPED_ENTRY, lpCompletionKey) - 0usize];
    ["Offset of field: _OVERLAPPED_ENTRY::lpOverlapped"]
        [::std::mem::offset_of!(_OVERLAPPED_ENTRY, lpOverlapped) - 8usize];
    ["Offset of field: _OVERLAPPED_ENTRY::Internal"]
        [::std::mem::offset_of!(_OVERLAPPED_ENTRY, Internal) - 16usize];
    ["Offset of field: _OVERLAPPED_ENTRY::dwNumberOfBytesTransferred"]
        [::std::mem::offset_of!(_OVERLAPPED_ENTRY, dwNumberOfBytesTransferred) - 24usize];
};
pub type OVERLAPPED_ENTRY = _OVERLAPPED_ENTRY;
pub type LPOVERLAPPED_ENTRY = *mut _OVERLAPPED_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEMTIME {
    pub wYear: WORD,
    pub wMonth: WORD,
    pub wDayOfWeek: WORD,
    pub wDay: WORD,
    pub wHour: WORD,
    pub wMinute: WORD,
    pub wSecond: WORD,
    pub wMilliseconds: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEMTIME"][::std::mem::size_of::<_SYSTEMTIME>() - 16usize];
    ["Alignment of _SYSTEMTIME"][::std::mem::align_of::<_SYSTEMTIME>() - 2usize];
    ["Offset of field: _SYSTEMTIME::wYear"][::std::mem::offset_of!(_SYSTEMTIME, wYear) - 0usize];
    ["Offset of field: _SYSTEMTIME::wMonth"][::std::mem::offset_of!(_SYSTEMTIME, wMonth) - 2usize];
    ["Offset of field: _SYSTEMTIME::wDayOfWeek"]
        [::std::mem::offset_of!(_SYSTEMTIME, wDayOfWeek) - 4usize];
    ["Offset of field: _SYSTEMTIME::wDay"][::std::mem::offset_of!(_SYSTEMTIME, wDay) - 6usize];
    ["Offset of field: _SYSTEMTIME::wHour"][::std::mem::offset_of!(_SYSTEMTIME, wHour) - 8usize];
    ["Offset of field: _SYSTEMTIME::wMinute"]
        [::std::mem::offset_of!(_SYSTEMTIME, wMinute) - 10usize];
    ["Offset of field: _SYSTEMTIME::wSecond"]
        [::std::mem::offset_of!(_SYSTEMTIME, wSecond) - 12usize];
    ["Offset of field: _SYSTEMTIME::wMilliseconds"]
        [::std::mem::offset_of!(_SYSTEMTIME, wMilliseconds) - 14usize];
};
pub type SYSTEMTIME = _SYSTEMTIME;
pub type PSYSTEMTIME = *mut _SYSTEMTIME;
pub type LPSYSTEMTIME = *mut _SYSTEMTIME;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WIN32_FIND_DATAA {
    pub dwFileAttributes: DWORD,
    pub ftCreationTime: FILETIME,
    pub ftLastAccessTime: FILETIME,
    pub ftLastWriteTime: FILETIME,
    pub nFileSizeHigh: DWORD,
    pub nFileSizeLow: DWORD,
    pub dwReserved0: DWORD,
    pub dwReserved1: DWORD,
    pub cFileName: [CHAR; 260usize],
    pub cAlternateFileName: [CHAR; 14usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_FIND_DATAA"][::std::mem::size_of::<_WIN32_FIND_DATAA>() - 320usize];
    ["Alignment of _WIN32_FIND_DATAA"][::std::mem::align_of::<_WIN32_FIND_DATAA>() - 4usize];
    ["Offset of field: _WIN32_FIND_DATAA::dwFileAttributes"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, dwFileAttributes) - 0usize];
    ["Offset of field: _WIN32_FIND_DATAA::ftCreationTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, ftCreationTime) - 4usize];
    ["Offset of field: _WIN32_FIND_DATAA::ftLastAccessTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, ftLastAccessTime) - 12usize];
    ["Offset of field: _WIN32_FIND_DATAA::ftLastWriteTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, ftLastWriteTime) - 20usize];
    ["Offset of field: _WIN32_FIND_DATAA::nFileSizeHigh"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, nFileSizeHigh) - 28usize];
    ["Offset of field: _WIN32_FIND_DATAA::nFileSizeLow"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, nFileSizeLow) - 32usize];
    ["Offset of field: _WIN32_FIND_DATAA::dwReserved0"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, dwReserved0) - 36usize];
    ["Offset of field: _WIN32_FIND_DATAA::dwReserved1"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, dwReserved1) - 40usize];
    ["Offset of field: _WIN32_FIND_DATAA::cFileName"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, cFileName) - 44usize];
    ["Offset of field: _WIN32_FIND_DATAA::cAlternateFileName"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAA, cAlternateFileName) - 304usize];
};
pub type WIN32_FIND_DATAA = _WIN32_FIND_DATAA;
pub type PWIN32_FIND_DATAA = *mut _WIN32_FIND_DATAA;
pub type LPWIN32_FIND_DATAA = *mut _WIN32_FIND_DATAA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WIN32_FIND_DATAW {
    pub dwFileAttributes: DWORD,
    pub ftCreationTime: FILETIME,
    pub ftLastAccessTime: FILETIME,
    pub ftLastWriteTime: FILETIME,
    pub nFileSizeHigh: DWORD,
    pub nFileSizeLow: DWORD,
    pub dwReserved0: DWORD,
    pub dwReserved1: DWORD,
    pub cFileName: [WCHAR; 260usize],
    pub cAlternateFileName: [WCHAR; 14usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_FIND_DATAW"][::std::mem::size_of::<_WIN32_FIND_DATAW>() - 592usize];
    ["Alignment of _WIN32_FIND_DATAW"][::std::mem::align_of::<_WIN32_FIND_DATAW>() - 4usize];
    ["Offset of field: _WIN32_FIND_DATAW::dwFileAttributes"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, dwFileAttributes) - 0usize];
    ["Offset of field: _WIN32_FIND_DATAW::ftCreationTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, ftCreationTime) - 4usize];
    ["Offset of field: _WIN32_FIND_DATAW::ftLastAccessTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, ftLastAccessTime) - 12usize];
    ["Offset of field: _WIN32_FIND_DATAW::ftLastWriteTime"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, ftLastWriteTime) - 20usize];
    ["Offset of field: _WIN32_FIND_DATAW::nFileSizeHigh"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, nFileSizeHigh) - 28usize];
    ["Offset of field: _WIN32_FIND_DATAW::nFileSizeLow"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, nFileSizeLow) - 32usize];
    ["Offset of field: _WIN32_FIND_DATAW::dwReserved0"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, dwReserved0) - 36usize];
    ["Offset of field: _WIN32_FIND_DATAW::dwReserved1"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, dwReserved1) - 40usize];
    ["Offset of field: _WIN32_FIND_DATAW::cFileName"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, cFileName) - 44usize];
    ["Offset of field: _WIN32_FIND_DATAW::cAlternateFileName"]
        [::std::mem::offset_of!(_WIN32_FIND_DATAW, cAlternateFileName) - 564usize];
};
pub type WIN32_FIND_DATAW = _WIN32_FIND_DATAW;
pub type PWIN32_FIND_DATAW = *mut _WIN32_FIND_DATAW;
pub type LPWIN32_FIND_DATAW = *mut _WIN32_FIND_DATAW;
pub type WIN32_FIND_DATA = WIN32_FIND_DATAA;
pub type PWIN32_FIND_DATA = PWIN32_FIND_DATAA;
pub type LPWIN32_FIND_DATA = LPWIN32_FIND_DATAA;
pub const _FINDEX_INFO_LEVELS_FindExInfoStandard: _FINDEX_INFO_LEVELS = 0;
pub const _FINDEX_INFO_LEVELS_FindExInfoBasic: _FINDEX_INFO_LEVELS = 1;
pub const _FINDEX_INFO_LEVELS_FindExInfoMaxInfoLevel: _FINDEX_INFO_LEVELS = 2;
pub type _FINDEX_INFO_LEVELS = ::std::os::raw::c_int;
pub use self::_FINDEX_INFO_LEVELS as FINDEX_INFO_LEVELS;
pub const _FINDEX_SEARCH_OPS_FindExSearchNameMatch: _FINDEX_SEARCH_OPS = 0;
pub const _FINDEX_SEARCH_OPS_FindExSearchLimitToDirectories: _FINDEX_SEARCH_OPS = 1;
pub const _FINDEX_SEARCH_OPS_FindExSearchLimitToDevices: _FINDEX_SEARCH_OPS = 2;
pub const _FINDEX_SEARCH_OPS_FindExSearchMaxSearchOp: _FINDEX_SEARCH_OPS = 3;
pub type _FINDEX_SEARCH_OPS = ::std::os::raw::c_int;
pub use self::_FINDEX_SEARCH_OPS as FINDEX_SEARCH_OPS;
pub const _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS_ReadDirectoryNotifyInformation:
    _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS = 1;
pub const _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS_ReadDirectoryNotifyExtendedInformation:
    _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS = 2;
pub type _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_READ_DIRECTORY_NOTIFY_INFORMATION_CLASS as READ_DIRECTORY_NOTIFY_INFORMATION_CLASS;
pub type PREAD_DIRECTORY_NOTIFY_INFORMATION_CLASS = *mut _READ_DIRECTORY_NOTIFY_INFORMATION_CLASS;
pub const _GET_FILEEX_INFO_LEVELS_GetFileExInfoStandard: _GET_FILEEX_INFO_LEVELS = 0;
pub const _GET_FILEEX_INFO_LEVELS_GetFileExMaxInfoLevel: _GET_FILEEX_INFO_LEVELS = 1;
pub type _GET_FILEEX_INFO_LEVELS = ::std::os::raw::c_int;
pub use self::_GET_FILEEX_INFO_LEVELS as GET_FILEEX_INFO_LEVELS;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileBasicInfo: _FILE_INFO_BY_HANDLE_CLASS = 0;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileStandardInfo: _FILE_INFO_BY_HANDLE_CLASS = 1;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileNameInfo: _FILE_INFO_BY_HANDLE_CLASS = 2;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileRenameInfo: _FILE_INFO_BY_HANDLE_CLASS = 3;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileDispositionInfo: _FILE_INFO_BY_HANDLE_CLASS = 4;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileAllocationInfo: _FILE_INFO_BY_HANDLE_CLASS = 5;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileEndOfFileInfo: _FILE_INFO_BY_HANDLE_CLASS = 6;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileStreamInfo: _FILE_INFO_BY_HANDLE_CLASS = 7;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileCompressionInfo: _FILE_INFO_BY_HANDLE_CLASS = 8;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileAttributeTagInfo: _FILE_INFO_BY_HANDLE_CLASS = 9;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIdBothDirectoryInfo: _FILE_INFO_BY_HANDLE_CLASS = 10;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIdBothDirectoryRestartInfo: _FILE_INFO_BY_HANDLE_CLASS =
    11;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIoPriorityHintInfo: _FILE_INFO_BY_HANDLE_CLASS = 12;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileRemoteProtocolInfo: _FILE_INFO_BY_HANDLE_CLASS = 13;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileFullDirectoryInfo: _FILE_INFO_BY_HANDLE_CLASS = 14;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileFullDirectoryRestartInfo: _FILE_INFO_BY_HANDLE_CLASS = 15;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileStorageInfo: _FILE_INFO_BY_HANDLE_CLASS = 16;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileAlignmentInfo: _FILE_INFO_BY_HANDLE_CLASS = 17;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIdInfo: _FILE_INFO_BY_HANDLE_CLASS = 18;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIdExtdDirectoryInfo: _FILE_INFO_BY_HANDLE_CLASS = 19;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileIdExtdDirectoryRestartInfo: _FILE_INFO_BY_HANDLE_CLASS =
    20;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileDispositionInfoEx: _FILE_INFO_BY_HANDLE_CLASS = 21;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileRenameInfoEx: _FILE_INFO_BY_HANDLE_CLASS = 22;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileCaseSensitiveInfo: _FILE_INFO_BY_HANDLE_CLASS = 23;
pub const _FILE_INFO_BY_HANDLE_CLASS_FileNormalizedNameInfo: _FILE_INFO_BY_HANDLE_CLASS = 24;
pub const _FILE_INFO_BY_HANDLE_CLASS_MaximumFileInfoByHandleClass: _FILE_INFO_BY_HANDLE_CLASS = 25;
pub type _FILE_INFO_BY_HANDLE_CLASS = ::std::os::raw::c_int;
pub use self::_FILE_INFO_BY_HANDLE_CLASS as FILE_INFO_BY_HANDLE_CLASS;
pub type PFILE_INFO_BY_HANDLE_CLASS = *mut _FILE_INFO_BY_HANDLE_CLASS;
pub type CRITICAL_SECTION = RTL_CRITICAL_SECTION;
pub type PCRITICAL_SECTION = PRTL_CRITICAL_SECTION;
pub type LPCRITICAL_SECTION = PRTL_CRITICAL_SECTION;
pub type CRITICAL_SECTION_DEBUG = RTL_CRITICAL_SECTION_DEBUG;
pub type PCRITICAL_SECTION_DEBUG = PRTL_CRITICAL_SECTION_DEBUG;
pub type LPCRITICAL_SECTION_DEBUG = PRTL_CRITICAL_SECTION_DEBUG;
pub type LPOVERLAPPED_COMPLETION_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        dwErrorCode: DWORD,
        dwNumberOfBytesTransfered: DWORD,
        lpOverlapped: LPOVERLAPPED,
    ),
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROCESS_HEAP_ENTRY {
    pub lpData: PVOID,
    pub cbData: DWORD,
    pub cbOverhead: BYTE,
    pub iRegionIndex: BYTE,
    pub wFlags: WORD,
    pub __bindgen_anon_1: _PROCESS_HEAP_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROCESS_HEAP_ENTRY__bindgen_ty_1 {
    pub Block: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1,
    pub Region: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1 {
    pub hMem: HANDLE,
    pub dwReserved: [DWORD; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 24usize];
    ["Alignment of _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1::hMem"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1, hMem) - 0usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1::dwReserved"][::std::mem::offset_of!(
        _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_1,
        dwReserved
    ) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2 {
    pub dwCommittedSize: DWORD,
    pub dwUnCommittedSize: DWORD,
    pub lpFirstBlock: LPVOID,
    pub lpLastBlock: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 24usize];
    ["Alignment of _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2::dwCommittedSize"][::std::mem::offset_of!(
        _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2,
        dwCommittedSize
    )
        - 0usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2::dwUnCommittedSize"][::std::mem::offset_of!(
        _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2,
        dwUnCommittedSize
    )
        - 4usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2::lpFirstBlock"][::std::mem::offset_of!(
        _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2,
        lpFirstBlock
    ) - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2::lpLastBlock"][::std::mem::offset_of!(
        _PROCESS_HEAP_ENTRY__bindgen_ty_1__bindgen_ty_2,
        lpLastBlock
    ) - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_HEAP_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1>() - 24usize];
    ["Alignment of _PROCESS_HEAP_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_PROCESS_HEAP_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1::Block"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY__bindgen_ty_1, Block) - 0usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY__bindgen_ty_1::Region"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY__bindgen_ty_1, Region) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_HEAP_ENTRY"][::std::mem::size_of::<_PROCESS_HEAP_ENTRY>() - 40usize];
    ["Alignment of _PROCESS_HEAP_ENTRY"][::std::mem::align_of::<_PROCESS_HEAP_ENTRY>() - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY::lpData"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY, lpData) - 0usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY::cbData"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY, cbData) - 8usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY::cbOverhead"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY, cbOverhead) - 12usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY::iRegionIndex"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY, iRegionIndex) - 13usize];
    ["Offset of field: _PROCESS_HEAP_ENTRY::wFlags"]
        [::std::mem::offset_of!(_PROCESS_HEAP_ENTRY, wFlags) - 14usize];
};
pub type PROCESS_HEAP_ENTRY = _PROCESS_HEAP_ENTRY;
pub type LPPROCESS_HEAP_ENTRY = *mut _PROCESS_HEAP_ENTRY;
pub type PPROCESS_HEAP_ENTRY = *mut _PROCESS_HEAP_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _REASON_CONTEXT {
    pub Version: ULONG,
    pub Flags: DWORD,
    pub Reason: _REASON_CONTEXT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _REASON_CONTEXT__bindgen_ty_1 {
    pub Detailed: _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1,
    pub SimpleReasonString: LPWSTR,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1 {
    pub LocalizedReasonModule: HMODULE,
    pub LocalizedReasonId: ULONG,
    pub ReasonStringCount: ULONG,
    pub ReasonStrings: *mut LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 24usize];
    ["Alignment of _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1::LocalizedReasonModule"][::std::mem::offset_of!(
        _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        LocalizedReasonModule
    )
        - 0usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1::LocalizedReasonId"][::std::mem::offset_of!(
        _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        LocalizedReasonId
    ) - 8usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1::ReasonStringCount"][::std::mem::offset_of!(
        _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        ReasonStringCount
    )
        - 12usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1::ReasonStrings"][::std::mem::offset_of!(
        _REASON_CONTEXT__bindgen_ty_1__bindgen_ty_1,
        ReasonStrings
    ) - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REASON_CONTEXT__bindgen_ty_1"]
        [::std::mem::size_of::<_REASON_CONTEXT__bindgen_ty_1>() - 24usize];
    ["Alignment of _REASON_CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_REASON_CONTEXT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1::Detailed"]
        [::std::mem::offset_of!(_REASON_CONTEXT__bindgen_ty_1, Detailed) - 0usize];
    ["Offset of field: _REASON_CONTEXT__bindgen_ty_1::SimpleReasonString"]
        [::std::mem::offset_of!(_REASON_CONTEXT__bindgen_ty_1, SimpleReasonString) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REASON_CONTEXT"][::std::mem::size_of::<_REASON_CONTEXT>() - 32usize];
    ["Alignment of _REASON_CONTEXT"][::std::mem::align_of::<_REASON_CONTEXT>() - 8usize];
    ["Offset of field: _REASON_CONTEXT::Version"]
        [::std::mem::offset_of!(_REASON_CONTEXT, Version) - 0usize];
    ["Offset of field: _REASON_CONTEXT::Flags"]
        [::std::mem::offset_of!(_REASON_CONTEXT, Flags) - 4usize];
    ["Offset of field: _REASON_CONTEXT::Reason"]
        [::std::mem::offset_of!(_REASON_CONTEXT, Reason) - 8usize];
};
pub type REASON_CONTEXT = _REASON_CONTEXT;
pub type PREASON_CONTEXT = *mut _REASON_CONTEXT;
pub type PTHREAD_START_ROUTINE =
    ::std::option::Option<unsafe extern "C" fn(lpThreadParameter: LPVOID) -> DWORD>;
pub type LPTHREAD_START_ROUTINE = PTHREAD_START_ROUTINE;
pub type PENCLAVE_ROUTINE =
    ::std::option::Option<unsafe extern "C" fn(lpThreadParameter: LPVOID) -> LPVOID>;
pub type LPENCLAVE_ROUTINE = PENCLAVE_ROUTINE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXCEPTION_DEBUG_INFO {
    pub ExceptionRecord: EXCEPTION_RECORD,
    pub dwFirstChance: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXCEPTION_DEBUG_INFO"][::std::mem::size_of::<_EXCEPTION_DEBUG_INFO>() - 160usize];
    ["Alignment of _EXCEPTION_DEBUG_INFO"]
        [::std::mem::align_of::<_EXCEPTION_DEBUG_INFO>() - 8usize];
    ["Offset of field: _EXCEPTION_DEBUG_INFO::ExceptionRecord"]
        [::std::mem::offset_of!(_EXCEPTION_DEBUG_INFO, ExceptionRecord) - 0usize];
    ["Offset of field: _EXCEPTION_DEBUG_INFO::dwFirstChance"]
        [::std::mem::offset_of!(_EXCEPTION_DEBUG_INFO, dwFirstChance) - 152usize];
};
pub type EXCEPTION_DEBUG_INFO = _EXCEPTION_DEBUG_INFO;
pub type LPEXCEPTION_DEBUG_INFO = *mut _EXCEPTION_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CREATE_THREAD_DEBUG_INFO {
    pub hThread: HANDLE,
    pub lpThreadLocalBase: LPVOID,
    pub lpStartAddress: LPTHREAD_START_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_THREAD_DEBUG_INFO"]
        [::std::mem::size_of::<_CREATE_THREAD_DEBUG_INFO>() - 24usize];
    ["Alignment of _CREATE_THREAD_DEBUG_INFO"]
        [::std::mem::align_of::<_CREATE_THREAD_DEBUG_INFO>() - 8usize];
    ["Offset of field: _CREATE_THREAD_DEBUG_INFO::hThread"]
        [::std::mem::offset_of!(_CREATE_THREAD_DEBUG_INFO, hThread) - 0usize];
    ["Offset of field: _CREATE_THREAD_DEBUG_INFO::lpThreadLocalBase"]
        [::std::mem::offset_of!(_CREATE_THREAD_DEBUG_INFO, lpThreadLocalBase) - 8usize];
    ["Offset of field: _CREATE_THREAD_DEBUG_INFO::lpStartAddress"]
        [::std::mem::offset_of!(_CREATE_THREAD_DEBUG_INFO, lpStartAddress) - 16usize];
};
pub type CREATE_THREAD_DEBUG_INFO = _CREATE_THREAD_DEBUG_INFO;
pub type LPCREATE_THREAD_DEBUG_INFO = *mut _CREATE_THREAD_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CREATE_PROCESS_DEBUG_INFO {
    pub hFile: HANDLE,
    pub hProcess: HANDLE,
    pub hThread: HANDLE,
    pub lpBaseOfImage: LPVOID,
    pub dwDebugInfoFileOffset: DWORD,
    pub nDebugInfoSize: DWORD,
    pub lpThreadLocalBase: LPVOID,
    pub lpStartAddress: LPTHREAD_START_ROUTINE,
    pub lpImageName: LPVOID,
    pub fUnicode: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_PROCESS_DEBUG_INFO"]
        [::std::mem::size_of::<_CREATE_PROCESS_DEBUG_INFO>() - 72usize];
    ["Alignment of _CREATE_PROCESS_DEBUG_INFO"]
        [::std::mem::align_of::<_CREATE_PROCESS_DEBUG_INFO>() - 8usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::hFile"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, hFile) - 0usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::hProcess"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, hProcess) - 8usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::hThread"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, hThread) - 16usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::lpBaseOfImage"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, lpBaseOfImage) - 24usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::dwDebugInfoFileOffset"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, dwDebugInfoFileOffset) - 32usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::nDebugInfoSize"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, nDebugInfoSize) - 36usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::lpThreadLocalBase"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, lpThreadLocalBase) - 40usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::lpStartAddress"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, lpStartAddress) - 48usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::lpImageName"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, lpImageName) - 56usize];
    ["Offset of field: _CREATE_PROCESS_DEBUG_INFO::fUnicode"]
        [::std::mem::offset_of!(_CREATE_PROCESS_DEBUG_INFO, fUnicode) - 64usize];
};
pub type CREATE_PROCESS_DEBUG_INFO = _CREATE_PROCESS_DEBUG_INFO;
pub type LPCREATE_PROCESS_DEBUG_INFO = *mut _CREATE_PROCESS_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXIT_THREAD_DEBUG_INFO {
    pub dwExitCode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXIT_THREAD_DEBUG_INFO"][::std::mem::size_of::<_EXIT_THREAD_DEBUG_INFO>() - 4usize];
    ["Alignment of _EXIT_THREAD_DEBUG_INFO"]
        [::std::mem::align_of::<_EXIT_THREAD_DEBUG_INFO>() - 4usize];
    ["Offset of field: _EXIT_THREAD_DEBUG_INFO::dwExitCode"]
        [::std::mem::offset_of!(_EXIT_THREAD_DEBUG_INFO, dwExitCode) - 0usize];
};
pub type EXIT_THREAD_DEBUG_INFO = _EXIT_THREAD_DEBUG_INFO;
pub type LPEXIT_THREAD_DEBUG_INFO = *mut _EXIT_THREAD_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXIT_PROCESS_DEBUG_INFO {
    pub dwExitCode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXIT_PROCESS_DEBUG_INFO"]
        [::std::mem::size_of::<_EXIT_PROCESS_DEBUG_INFO>() - 4usize];
    ["Alignment of _EXIT_PROCESS_DEBUG_INFO"]
        [::std::mem::align_of::<_EXIT_PROCESS_DEBUG_INFO>() - 4usize];
    ["Offset of field: _EXIT_PROCESS_DEBUG_INFO::dwExitCode"]
        [::std::mem::offset_of!(_EXIT_PROCESS_DEBUG_INFO, dwExitCode) - 0usize];
};
pub type EXIT_PROCESS_DEBUG_INFO = _EXIT_PROCESS_DEBUG_INFO;
pub type LPEXIT_PROCESS_DEBUG_INFO = *mut _EXIT_PROCESS_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LOAD_DLL_DEBUG_INFO {
    pub hFile: HANDLE,
    pub lpBaseOfDll: LPVOID,
    pub dwDebugInfoFileOffset: DWORD,
    pub nDebugInfoSize: DWORD,
    pub lpImageName: LPVOID,
    pub fUnicode: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LOAD_DLL_DEBUG_INFO"][::std::mem::size_of::<_LOAD_DLL_DEBUG_INFO>() - 40usize];
    ["Alignment of _LOAD_DLL_DEBUG_INFO"][::std::mem::align_of::<_LOAD_DLL_DEBUG_INFO>() - 8usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::hFile"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, hFile) - 0usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::lpBaseOfDll"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, lpBaseOfDll) - 8usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::dwDebugInfoFileOffset"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, dwDebugInfoFileOffset) - 16usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::nDebugInfoSize"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, nDebugInfoSize) - 20usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::lpImageName"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, lpImageName) - 24usize];
    ["Offset of field: _LOAD_DLL_DEBUG_INFO::fUnicode"]
        [::std::mem::offset_of!(_LOAD_DLL_DEBUG_INFO, fUnicode) - 32usize];
};
pub type LOAD_DLL_DEBUG_INFO = _LOAD_DLL_DEBUG_INFO;
pub type LPLOAD_DLL_DEBUG_INFO = *mut _LOAD_DLL_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UNLOAD_DLL_DEBUG_INFO {
    pub lpBaseOfDll: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UNLOAD_DLL_DEBUG_INFO"][::std::mem::size_of::<_UNLOAD_DLL_DEBUG_INFO>() - 8usize];
    ["Alignment of _UNLOAD_DLL_DEBUG_INFO"]
        [::std::mem::align_of::<_UNLOAD_DLL_DEBUG_INFO>() - 8usize];
    ["Offset of field: _UNLOAD_DLL_DEBUG_INFO::lpBaseOfDll"]
        [::std::mem::offset_of!(_UNLOAD_DLL_DEBUG_INFO, lpBaseOfDll) - 0usize];
};
pub type UNLOAD_DLL_DEBUG_INFO = _UNLOAD_DLL_DEBUG_INFO;
pub type LPUNLOAD_DLL_DEBUG_INFO = *mut _UNLOAD_DLL_DEBUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OUTPUT_DEBUG_STRING_INFO {
    pub lpDebugStringData: LPSTR,
    pub fUnicode: WORD,
    pub nDebugStringLength: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OUTPUT_DEBUG_STRING_INFO"]
        [::std::mem::size_of::<_OUTPUT_DEBUG_STRING_INFO>() - 16usize];
    ["Alignment of _OUTPUT_DEBUG_STRING_INFO"]
        [::std::mem::align_of::<_OUTPUT_DEBUG_STRING_INFO>() - 8usize];
    ["Offset of field: _OUTPUT_DEBUG_STRING_INFO::lpDebugStringData"]
        [::std::mem::offset_of!(_OUTPUT_DEBUG_STRING_INFO, lpDebugStringData) - 0usize];
    ["Offset of field: _OUTPUT_DEBUG_STRING_INFO::fUnicode"]
        [::std::mem::offset_of!(_OUTPUT_DEBUG_STRING_INFO, fUnicode) - 8usize];
    ["Offset of field: _OUTPUT_DEBUG_STRING_INFO::nDebugStringLength"]
        [::std::mem::offset_of!(_OUTPUT_DEBUG_STRING_INFO, nDebugStringLength) - 10usize];
};
pub type OUTPUT_DEBUG_STRING_INFO = _OUTPUT_DEBUG_STRING_INFO;
pub type LPOUTPUT_DEBUG_STRING_INFO = *mut _OUTPUT_DEBUG_STRING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RIP_INFO {
    pub dwError: DWORD,
    pub dwType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RIP_INFO"][::std::mem::size_of::<_RIP_INFO>() - 8usize];
    ["Alignment of _RIP_INFO"][::std::mem::align_of::<_RIP_INFO>() - 4usize];
    ["Offset of field: _RIP_INFO::dwError"][::std::mem::offset_of!(_RIP_INFO, dwError) - 0usize];
    ["Offset of field: _RIP_INFO::dwType"][::std::mem::offset_of!(_RIP_INFO, dwType) - 4usize];
};
pub type RIP_INFO = _RIP_INFO;
pub type LPRIP_INFO = *mut _RIP_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEBUG_EVENT {
    pub dwDebugEventCode: DWORD,
    pub dwProcessId: DWORD,
    pub dwThreadId: DWORD,
    pub u: _DEBUG_EVENT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEBUG_EVENT__bindgen_ty_1 {
    pub Exception: EXCEPTION_DEBUG_INFO,
    pub CreateThread: CREATE_THREAD_DEBUG_INFO,
    pub CreateProcessInfo: CREATE_PROCESS_DEBUG_INFO,
    pub ExitThread: EXIT_THREAD_DEBUG_INFO,
    pub ExitProcess: EXIT_PROCESS_DEBUG_INFO,
    pub LoadDll: LOAD_DLL_DEBUG_INFO,
    pub UnloadDll: UNLOAD_DLL_DEBUG_INFO,
    pub DebugString: OUTPUT_DEBUG_STRING_INFO,
    pub RipInfo: RIP_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEBUG_EVENT__bindgen_ty_1"]
        [::std::mem::size_of::<_DEBUG_EVENT__bindgen_ty_1>() - 160usize];
    ["Alignment of _DEBUG_EVENT__bindgen_ty_1"]
        [::std::mem::align_of::<_DEBUG_EVENT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::Exception"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, Exception) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::CreateThread"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, CreateThread) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::CreateProcessInfo"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, CreateProcessInfo) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::ExitThread"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, ExitThread) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::ExitProcess"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, ExitProcess) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::LoadDll"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, LoadDll) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::UnloadDll"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, UnloadDll) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::DebugString"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, DebugString) - 0usize];
    ["Offset of field: _DEBUG_EVENT__bindgen_ty_1::RipInfo"]
        [::std::mem::offset_of!(_DEBUG_EVENT__bindgen_ty_1, RipInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEBUG_EVENT"][::std::mem::size_of::<_DEBUG_EVENT>() - 176usize];
    ["Alignment of _DEBUG_EVENT"][::std::mem::align_of::<_DEBUG_EVENT>() - 8usize];
    ["Offset of field: _DEBUG_EVENT::dwDebugEventCode"]
        [::std::mem::offset_of!(_DEBUG_EVENT, dwDebugEventCode) - 0usize];
    ["Offset of field: _DEBUG_EVENT::dwProcessId"]
        [::std::mem::offset_of!(_DEBUG_EVENT, dwProcessId) - 4usize];
    ["Offset of field: _DEBUG_EVENT::dwThreadId"]
        [::std::mem::offset_of!(_DEBUG_EVENT, dwThreadId) - 8usize];
    ["Offset of field: _DEBUG_EVENT::u"][::std::mem::offset_of!(_DEBUG_EVENT, u) - 16usize];
};
pub type DEBUG_EVENT = _DEBUG_EVENT;
pub type LPDEBUG_EVENT = *mut _DEBUG_EVENT;
pub type LPCONTEXT = PCONTEXT;
unsafe extern "C" {
    pub fn IsApiSetImplemented(Contract: PCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetEnvironmentStringsW(NewEnvironment: LPWCH) -> BOOL;
}
unsafe extern "C" {
    pub fn GetStdHandle(nStdHandle: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetStdHandle(nStdHandle: DWORD, hHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetStdHandleEx(nStdHandle: DWORD, hHandle: HANDLE, phPrevValue: PHANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommandLineA() -> LPSTR;
}
unsafe extern "C" {
    pub fn GetCommandLineW() -> LPWSTR;
}
unsafe extern "C" {
    pub fn GetEnvironmentStrings() -> LPCH;
}
unsafe extern "C" {
    pub fn GetEnvironmentStringsW() -> LPWCH;
}
unsafe extern "C" {
    pub fn FreeEnvironmentStringsA(penv: LPCH) -> BOOL;
}
unsafe extern "C" {
    pub fn FreeEnvironmentStringsW(penv: LPWCH) -> BOOL;
}
unsafe extern "C" {
    pub fn GetEnvironmentVariableA(lpName: LPCSTR, lpBuffer: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetEnvironmentVariableW(lpName: LPCWSTR, lpBuffer: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn SetEnvironmentVariableA(lpName: LPCSTR, lpValue: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetEnvironmentVariableW(lpName: LPCWSTR, lpValue: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ExpandEnvironmentStringsA(lpSrc: LPCSTR, lpDst: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ExpandEnvironmentStringsW(lpSrc: LPCWSTR, lpDst: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn SetCurrentDirectoryA(lpPathName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCurrentDirectoryW(lpPathName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentDirectoryA(nBufferLength: DWORD, lpBuffer: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCurrentDirectoryW(nBufferLength: DWORD, lpBuffer: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn SearchPathW(
        lpPath: LPCWSTR,
        lpFileName: LPCWSTR,
        lpExtension: LPCWSTR,
        nBufferLength: DWORD,
        lpBuffer: LPWSTR,
        lpFilePart: *mut LPWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SearchPathA(
        lpPath: LPCSTR,
        lpFileName: LPCSTR,
        lpExtension: LPCSTR,
        nBufferLength: DWORD,
        lpBuffer: LPSTR,
        lpFilePart: *mut LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn NeedCurrentDirectoryForExePathA(ExeName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn NeedCurrentDirectoryForExePathW(ExeName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn CompareFileTime(lpFileTime1: *const FILETIME, lpFileTime2: *const FILETIME) -> LONG;
}
unsafe extern "C" {
    pub fn CreateDirectoryA(
        lpPathName: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryW(
        lpPathName: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFileA(
        lpFileName: LPCSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwCreationDisposition: DWORD,
        dwFlagsAndAttributes: DWORD,
        hTemplateFile: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateFileW(
        lpFileName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwCreationDisposition: DWORD,
        dwFlagsAndAttributes: DWORD,
        hTemplateFile: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn DefineDosDeviceW(dwFlags: DWORD, lpDeviceName: LPCWSTR, lpTargetPath: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteFileA(lpFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteFileW(lpFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteVolumeMountPointW(lpszVolumeMountPoint: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn FileTimeToLocalFileTime(
        lpFileTime: *const FILETIME,
        lpLocalFileTime: LPFILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindClose(hFindFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn FindCloseChangeNotification(hChangeHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstChangeNotificationA(
        lpPathName: LPCSTR,
        bWatchSubtree: BOOL,
        dwNotifyFilter: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstChangeNotificationW(
        lpPathName: LPCWSTR,
        bWatchSubtree: BOOL,
        dwNotifyFilter: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileA(lpFileName: LPCSTR, lpFindFileData: LPWIN32_FIND_DATAA) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileW(lpFileName: LPCWSTR, lpFindFileData: LPWIN32_FIND_DATAW) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileExA(
        lpFileName: LPCSTR,
        fInfoLevelId: FINDEX_INFO_LEVELS,
        lpFindFileData: LPVOID,
        fSearchOp: FINDEX_SEARCH_OPS,
        lpSearchFilter: LPVOID,
        dwAdditionalFlags: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileExW(
        lpFileName: LPCWSTR,
        fInfoLevelId: FINDEX_INFO_LEVELS,
        lpFindFileData: LPVOID,
        fSearchOp: FINDEX_SEARCH_OPS,
        lpSearchFilter: LPVOID,
        dwAdditionalFlags: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstVolumeW(lpszVolumeName: LPWSTR, cchBufferLength: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextChangeNotification(hChangeHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn FindNextFileA(hFindFile: HANDLE, lpFindFileData: LPWIN32_FIND_DATAA) -> BOOL;
}
unsafe extern "C" {
    pub fn FindNextFileW(hFindFile: HANDLE, lpFindFileData: LPWIN32_FIND_DATAW) -> BOOL;
}
unsafe extern "C" {
    pub fn FindNextVolumeW(
        hFindVolume: HANDLE,
        lpszVolumeName: LPWSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindVolumeClose(hFindVolume: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn FlushFileBuffers(hFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDiskFreeSpaceA(
        lpRootPathName: LPCSTR,
        lpSectorsPerCluster: LPDWORD,
        lpBytesPerSector: LPDWORD,
        lpNumberOfFreeClusters: LPDWORD,
        lpTotalNumberOfClusters: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDiskFreeSpaceW(
        lpRootPathName: LPCWSTR,
        lpSectorsPerCluster: LPDWORD,
        lpBytesPerSector: LPDWORD,
        lpNumberOfFreeClusters: LPDWORD,
        lpTotalNumberOfClusters: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDiskFreeSpaceExA(
        lpDirectoryName: LPCSTR,
        lpFreeBytesAvailableToCaller: PULARGE_INTEGER,
        lpTotalNumberOfBytes: PULARGE_INTEGER,
        lpTotalNumberOfFreeBytes: PULARGE_INTEGER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDiskFreeSpaceExW(
        lpDirectoryName: LPCWSTR,
        lpFreeBytesAvailableToCaller: PULARGE_INTEGER,
        lpTotalNumberOfBytes: PULARGE_INTEGER,
        lpTotalNumberOfFreeBytes: PULARGE_INTEGER,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISK_SPACE_INFORMATION {
    pub ActualTotalAllocationUnits: ULONGLONG,
    pub ActualAvailableAllocationUnits: ULONGLONG,
    pub ActualPoolUnavailableAllocationUnits: ULONGLONG,
    pub CallerTotalAllocationUnits: ULONGLONG,
    pub CallerAvailableAllocationUnits: ULONGLONG,
    pub CallerPoolUnavailableAllocationUnits: ULONGLONG,
    pub UsedAllocationUnits: ULONGLONG,
    pub TotalReservedAllocationUnits: ULONGLONG,
    pub VolumeStorageReserveAllocationUnits: ULONGLONG,
    pub AvailableCommittedAllocationUnits: ULONGLONG,
    pub PoolAvailableAllocationUnits: ULONGLONG,
    pub SectorsPerAllocationUnit: DWORD,
    pub BytesPerSector: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISK_SPACE_INFORMATION"][::std::mem::size_of::<DISK_SPACE_INFORMATION>() - 96usize];
    ["Alignment of DISK_SPACE_INFORMATION"]
        [::std::mem::align_of::<DISK_SPACE_INFORMATION>() - 8usize];
    ["Offset of field: DISK_SPACE_INFORMATION::ActualTotalAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, ActualTotalAllocationUnits) - 0usize];
    ["Offset of field: DISK_SPACE_INFORMATION::ActualAvailableAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, ActualAvailableAllocationUnits) - 8usize];
    ["Offset of field: DISK_SPACE_INFORMATION::ActualPoolUnavailableAllocationUnits"][::std::mem::offset_of!(
        DISK_SPACE_INFORMATION,
        ActualPoolUnavailableAllocationUnits
    ) - 16usize];
    ["Offset of field: DISK_SPACE_INFORMATION::CallerTotalAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, CallerTotalAllocationUnits) - 24usize];
    ["Offset of field: DISK_SPACE_INFORMATION::CallerAvailableAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, CallerAvailableAllocationUnits) - 32usize];
    ["Offset of field: DISK_SPACE_INFORMATION::CallerPoolUnavailableAllocationUnits"][::std::mem::offset_of!(
        DISK_SPACE_INFORMATION,
        CallerPoolUnavailableAllocationUnits
    ) - 40usize];
    ["Offset of field: DISK_SPACE_INFORMATION::UsedAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, UsedAllocationUnits) - 48usize];
    ["Offset of field: DISK_SPACE_INFORMATION::TotalReservedAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, TotalReservedAllocationUnits) - 56usize];
    ["Offset of field: DISK_SPACE_INFORMATION::VolumeStorageReserveAllocationUnits"][::std::mem::offset_of!(
        DISK_SPACE_INFORMATION,
        VolumeStorageReserveAllocationUnits
    ) - 64usize];
    ["Offset of field: DISK_SPACE_INFORMATION::AvailableCommittedAllocationUnits"][::std::mem::offset_of!(
        DISK_SPACE_INFORMATION,
        AvailableCommittedAllocationUnits
    ) - 72usize];
    ["Offset of field: DISK_SPACE_INFORMATION::PoolAvailableAllocationUnits"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, PoolAvailableAllocationUnits) - 80usize];
    ["Offset of field: DISK_SPACE_INFORMATION::SectorsPerAllocationUnit"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, SectorsPerAllocationUnit) - 88usize];
    ["Offset of field: DISK_SPACE_INFORMATION::BytesPerSector"]
        [::std::mem::offset_of!(DISK_SPACE_INFORMATION, BytesPerSector) - 92usize];
};
unsafe extern "C" {
    pub fn GetDiskSpaceInformationA(
        rootPath: LPCSTR,
        diskSpaceInfo: *mut DISK_SPACE_INFORMATION,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetDiskSpaceInformationW(
        rootPath: LPCWSTR,
        diskSpaceInfo: *mut DISK_SPACE_INFORMATION,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetDriveTypeA(lpRootPathName: LPCSTR) -> UINT;
}
unsafe extern "C" {
    pub fn GetDriveTypeW(lpRootPathName: LPCWSTR) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WIN32_FILE_ATTRIBUTE_DATA {
    pub dwFileAttributes: DWORD,
    pub ftCreationTime: FILETIME,
    pub ftLastAccessTime: FILETIME,
    pub ftLastWriteTime: FILETIME,
    pub nFileSizeHigh: DWORD,
    pub nFileSizeLow: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_FILE_ATTRIBUTE_DATA"]
        [::std::mem::size_of::<_WIN32_FILE_ATTRIBUTE_DATA>() - 36usize];
    ["Alignment of _WIN32_FILE_ATTRIBUTE_DATA"]
        [::std::mem::align_of::<_WIN32_FILE_ATTRIBUTE_DATA>() - 4usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::dwFileAttributes"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, dwFileAttributes) - 0usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::ftCreationTime"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, ftCreationTime) - 4usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::ftLastAccessTime"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, ftLastAccessTime) - 12usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::ftLastWriteTime"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, ftLastWriteTime) - 20usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::nFileSizeHigh"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, nFileSizeHigh) - 28usize];
    ["Offset of field: _WIN32_FILE_ATTRIBUTE_DATA::nFileSizeLow"]
        [::std::mem::offset_of!(_WIN32_FILE_ATTRIBUTE_DATA, nFileSizeLow) - 32usize];
};
pub type WIN32_FILE_ATTRIBUTE_DATA = _WIN32_FILE_ATTRIBUTE_DATA;
pub type LPWIN32_FILE_ATTRIBUTE_DATA = *mut _WIN32_FILE_ATTRIBUTE_DATA;
unsafe extern "C" {
    pub fn GetFileAttributesA(lpFileName: LPCSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileAttributesW(lpFileName: LPCWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileAttributesExA(
        lpFileName: LPCSTR,
        fInfoLevelId: GET_FILEEX_INFO_LEVELS,
        lpFileInformation: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileAttributesExW(
        lpFileName: LPCWSTR,
        fInfoLevelId: GET_FILEEX_INFO_LEVELS,
        lpFileInformation: LPVOID,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BY_HANDLE_FILE_INFORMATION {
    pub dwFileAttributes: DWORD,
    pub ftCreationTime: FILETIME,
    pub ftLastAccessTime: FILETIME,
    pub ftLastWriteTime: FILETIME,
    pub dwVolumeSerialNumber: DWORD,
    pub nFileSizeHigh: DWORD,
    pub nFileSizeLow: DWORD,
    pub nNumberOfLinks: DWORD,
    pub nFileIndexHigh: DWORD,
    pub nFileIndexLow: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BY_HANDLE_FILE_INFORMATION"]
        [::std::mem::size_of::<_BY_HANDLE_FILE_INFORMATION>() - 52usize];
    ["Alignment of _BY_HANDLE_FILE_INFORMATION"]
        [::std::mem::align_of::<_BY_HANDLE_FILE_INFORMATION>() - 4usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::dwFileAttributes"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, dwFileAttributes) - 0usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::ftCreationTime"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, ftCreationTime) - 4usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::ftLastAccessTime"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, ftLastAccessTime) - 12usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::ftLastWriteTime"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, ftLastWriteTime) - 20usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::dwVolumeSerialNumber"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, dwVolumeSerialNumber) - 28usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::nFileSizeHigh"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, nFileSizeHigh) - 32usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::nFileSizeLow"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, nFileSizeLow) - 36usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::nNumberOfLinks"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, nNumberOfLinks) - 40usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::nFileIndexHigh"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, nFileIndexHigh) - 44usize];
    ["Offset of field: _BY_HANDLE_FILE_INFORMATION::nFileIndexLow"]
        [::std::mem::offset_of!(_BY_HANDLE_FILE_INFORMATION, nFileIndexLow) - 48usize];
};
pub type BY_HANDLE_FILE_INFORMATION = _BY_HANDLE_FILE_INFORMATION;
pub type PBY_HANDLE_FILE_INFORMATION = *mut _BY_HANDLE_FILE_INFORMATION;
pub type LPBY_HANDLE_FILE_INFORMATION = *mut _BY_HANDLE_FILE_INFORMATION;
unsafe extern "C" {
    pub fn GetFileInformationByHandle(
        hFile: HANDLE,
        lpFileInformation: LPBY_HANDLE_FILE_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileSize(hFile: HANDLE, lpFileSizeHigh: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileSizeEx(hFile: HANDLE, lpFileSize: PLARGE_INTEGER) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileType(hFile: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFinalPathNameByHandleA(
        hFile: HANDLE,
        lpszFilePath: LPSTR,
        cchFilePath: DWORD,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFinalPathNameByHandleW(
        hFile: HANDLE,
        lpszFilePath: LPWSTR,
        cchFilePath: DWORD,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileTime(
        hFile: HANDLE,
        lpCreationTime: LPFILETIME,
        lpLastAccessTime: LPFILETIME,
        lpLastWriteTime: LPFILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFullPathNameW(
        lpFileName: LPCWSTR,
        nBufferLength: DWORD,
        lpBuffer: LPWSTR,
        lpFilePart: *mut LPWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFullPathNameA(
        lpFileName: LPCSTR,
        nBufferLength: DWORD,
        lpBuffer: LPSTR,
        lpFilePart: *mut LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetLogicalDrives() -> DWORD;
}
unsafe extern "C" {
    pub fn GetLogicalDriveStringsW(nBufferLength: DWORD, lpBuffer: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetLongPathNameA(lpszShortPath: LPCSTR, lpszLongPath: LPSTR, cchBuffer: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetLongPathNameW(
        lpszShortPath: LPCWSTR,
        lpszLongPath: LPWSTR,
        cchBuffer: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn AreShortNamesEnabled(Handle: HANDLE, Enabled: *mut BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetShortPathNameW(
        lpszLongPath: LPCWSTR,
        lpszShortPath: LPWSTR,
        cchBuffer: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTempFileNameW(
        lpPathName: LPCWSTR,
        lpPrefixString: LPCWSTR,
        uUnique: UINT,
        lpTempFileName: LPWSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetVolumeInformationByHandleW(
        hFile: HANDLE,
        lpVolumeNameBuffer: LPWSTR,
        nVolumeNameSize: DWORD,
        lpVolumeSerialNumber: LPDWORD,
        lpMaximumComponentLength: LPDWORD,
        lpFileSystemFlags: LPDWORD,
        lpFileSystemNameBuffer: LPWSTR,
        nFileSystemNameSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumeInformationW(
        lpRootPathName: LPCWSTR,
        lpVolumeNameBuffer: LPWSTR,
        nVolumeNameSize: DWORD,
        lpVolumeSerialNumber: LPDWORD,
        lpMaximumComponentLength: LPDWORD,
        lpFileSystemFlags: LPDWORD,
        lpFileSystemNameBuffer: LPWSTR,
        nFileSystemNameSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumePathNameW(
        lpszFileName: LPCWSTR,
        lpszVolumePathName: LPWSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LocalFileTimeToFileTime(
        lpLocalFileTime: *const FILETIME,
        lpFileTime: LPFILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LockFile(
        hFile: HANDLE,
        dwFileOffsetLow: DWORD,
        dwFileOffsetHigh: DWORD,
        nNumberOfBytesToLockLow: DWORD,
        nNumberOfBytesToLockHigh: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LockFileEx(
        hFile: HANDLE,
        dwFlags: DWORD,
        dwReserved: DWORD,
        nNumberOfBytesToLockLow: DWORD,
        nNumberOfBytesToLockHigh: DWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryDosDeviceW(lpDeviceName: LPCWSTR, lpTargetPath: LPWSTR, ucchMax: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ReadFile(
        hFile: HANDLE,
        lpBuffer: LPVOID,
        nNumberOfBytesToRead: DWORD,
        lpNumberOfBytesRead: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadFileEx(
        hFile: HANDLE,
        lpBuffer: LPVOID,
        nNumberOfBytesToRead: DWORD,
        lpOverlapped: LPOVERLAPPED,
        lpCompletionRoutine: LPOVERLAPPED_COMPLETION_ROUTINE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadFileScatter(
        hFile: HANDLE,
        aSegmentArray: *mut FILE_SEGMENT_ELEMENT,
        nNumberOfBytesToRead: DWORD,
        lpReserved: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveDirectoryA(lpPathName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveDirectoryW(lpPathName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetEndOfFile(hFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileAttributesA(lpFileName: LPCSTR, dwFileAttributes: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileAttributesW(lpFileName: LPCWSTR, dwFileAttributes: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileInformationByHandle(
        hFile: HANDLE,
        FileInformationClass: FILE_INFO_BY_HANDLE_CLASS,
        lpFileInformation: LPVOID,
        dwBufferSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFilePointer(
        hFile: HANDLE,
        lDistanceToMove: LONG,
        lpDistanceToMoveHigh: PLONG,
        dwMoveMethod: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetFilePointerEx(
        hFile: HANDLE,
        liDistanceToMove: LARGE_INTEGER,
        lpNewFilePointer: PLARGE_INTEGER,
        dwMoveMethod: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileTime(
        hFile: HANDLE,
        lpCreationTime: *const FILETIME,
        lpLastAccessTime: *const FILETIME,
        lpLastWriteTime: *const FILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileValidData(hFile: HANDLE, ValidDataLength: LONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn UnlockFile(
        hFile: HANDLE,
        dwFileOffsetLow: DWORD,
        dwFileOffsetHigh: DWORD,
        nNumberOfBytesToUnlockLow: DWORD,
        nNumberOfBytesToUnlockHigh: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnlockFileEx(
        hFile: HANDLE,
        dwReserved: DWORD,
        nNumberOfBytesToUnlockLow: DWORD,
        nNumberOfBytesToUnlockHigh: DWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteFile(
        hFile: HANDLE,
        lpBuffer: LPCVOID,
        nNumberOfBytesToWrite: DWORD,
        lpNumberOfBytesWritten: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteFileEx(
        hFile: HANDLE,
        lpBuffer: LPCVOID,
        nNumberOfBytesToWrite: DWORD,
        lpOverlapped: LPOVERLAPPED,
        lpCompletionRoutine: LPOVERLAPPED_COMPLETION_ROUTINE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteFileGather(
        hFile: HANDLE,
        aSegmentArray: *mut FILE_SEGMENT_ELEMENT,
        nNumberOfBytesToWrite: DWORD,
        lpReserved: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTempPathW(nBufferLength: DWORD, lpBuffer: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetVolumeNameForVolumeMountPointW(
        lpszVolumeMountPoint: LPCWSTR,
        lpszVolumeName: LPWSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumePathNamesForVolumeNameW(
        lpszVolumeName: LPCWSTR,
        lpszVolumePathNames: LPWCH,
        cchBufferLength: DWORD,
        lpcchReturnLength: PDWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CREATEFILE2_EXTENDED_PARAMETERS {
    pub dwSize: DWORD,
    pub dwFileAttributes: DWORD,
    pub dwFileFlags: DWORD,
    pub dwSecurityQosFlags: DWORD,
    pub lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    pub hTemplateFile: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATEFILE2_EXTENDED_PARAMETERS"]
        [::std::mem::size_of::<_CREATEFILE2_EXTENDED_PARAMETERS>() - 32usize];
    ["Alignment of _CREATEFILE2_EXTENDED_PARAMETERS"]
        [::std::mem::align_of::<_CREATEFILE2_EXTENDED_PARAMETERS>() - 8usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::dwSize"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, dwSize) - 0usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::dwFileAttributes"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, dwFileAttributes) - 4usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::dwFileFlags"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, dwFileFlags) - 8usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::dwSecurityQosFlags"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, dwSecurityQosFlags) - 12usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::lpSecurityAttributes"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, lpSecurityAttributes) - 16usize];
    ["Offset of field: _CREATEFILE2_EXTENDED_PARAMETERS::hTemplateFile"]
        [::std::mem::offset_of!(_CREATEFILE2_EXTENDED_PARAMETERS, hTemplateFile) - 24usize];
};
pub type CREATEFILE2_EXTENDED_PARAMETERS = _CREATEFILE2_EXTENDED_PARAMETERS;
pub type PCREATEFILE2_EXTENDED_PARAMETERS = *mut _CREATEFILE2_EXTENDED_PARAMETERS;
pub type LPCREATEFILE2_EXTENDED_PARAMETERS = *mut _CREATEFILE2_EXTENDED_PARAMETERS;
unsafe extern "C" {
    pub fn CreateFile2(
        lpFileName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        dwCreationDisposition: DWORD,
        pCreateExParams: LPCREATEFILE2_EXTENDED_PARAMETERS,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetFileIoOverlappedRange(
        FileHandle: HANDLE,
        OverlappedRangeStart: PUCHAR,
        Length: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCompressedFileSizeA(lpFileName: LPCSTR, lpFileSizeHigh: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCompressedFileSizeW(lpFileName: LPCWSTR, lpFileSizeHigh: LPDWORD) -> DWORD;
}
pub const _STREAM_INFO_LEVELS_FindStreamInfoStandard: _STREAM_INFO_LEVELS = 0;
pub const _STREAM_INFO_LEVELS_FindStreamInfoMaxInfoLevel: _STREAM_INFO_LEVELS = 1;
pub type _STREAM_INFO_LEVELS = ::std::os::raw::c_int;
pub use self::_STREAM_INFO_LEVELS as STREAM_INFO_LEVELS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIN32_FIND_STREAM_DATA {
    pub StreamSize: LARGE_INTEGER,
    pub cStreamName: [WCHAR; 296usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_FIND_STREAM_DATA"]
        [::std::mem::size_of::<_WIN32_FIND_STREAM_DATA>() - 600usize];
    ["Alignment of _WIN32_FIND_STREAM_DATA"]
        [::std::mem::align_of::<_WIN32_FIND_STREAM_DATA>() - 8usize];
    ["Offset of field: _WIN32_FIND_STREAM_DATA::StreamSize"]
        [::std::mem::offset_of!(_WIN32_FIND_STREAM_DATA, StreamSize) - 0usize];
    ["Offset of field: _WIN32_FIND_STREAM_DATA::cStreamName"]
        [::std::mem::offset_of!(_WIN32_FIND_STREAM_DATA, cStreamName) - 8usize];
};
pub type WIN32_FIND_STREAM_DATA = _WIN32_FIND_STREAM_DATA;
pub type PWIN32_FIND_STREAM_DATA = *mut _WIN32_FIND_STREAM_DATA;
unsafe extern "C" {
    pub fn FindFirstStreamW(
        lpFileName: LPCWSTR,
        InfoLevel: STREAM_INFO_LEVELS,
        lpFindStreamData: LPVOID,
        dwFlags: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextStreamW(hFindStream: HANDLE, lpFindStreamData: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn AreFileApisANSI() -> BOOL;
}
unsafe extern "C" {
    pub fn GetTempPathA(nBufferLength: DWORD, lpBuffer: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn FindFirstFileNameW(
        lpFileName: LPCWSTR,
        dwFlags: DWORD,
        StringLength: LPDWORD,
        LinkName: PWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextFileNameW(hFindStream: HANDLE, StringLength: LPDWORD, LinkName: PWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumeInformationA(
        lpRootPathName: LPCSTR,
        lpVolumeNameBuffer: LPSTR,
        nVolumeNameSize: DWORD,
        lpVolumeSerialNumber: LPDWORD,
        lpMaximumComponentLength: LPDWORD,
        lpFileSystemFlags: LPDWORD,
        lpFileSystemNameBuffer: LPSTR,
        nFileSystemNameSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTempFileNameA(
        lpPathName: LPCSTR,
        lpPrefixString: LPCSTR,
        uUnique: UINT,
        lpTempFileName: LPSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn SetFileApisToOEM();
}
unsafe extern "C" {
    pub fn SetFileApisToANSI();
}
unsafe extern "C" {
    pub fn GetTempPath2W(BufferLength: DWORD, Buffer: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTempPath2A(BufferLength: DWORD, Buffer: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn CopyFileFromAppW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        bFailIfExists: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryFromAppW(
        lpPathName: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFileFromAppW(
        lpFileName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwCreationDisposition: DWORD,
        dwFlagsAndAttributes: DWORD,
        hTemplateFile: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateFile2FromAppW(
        lpFileName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        dwCreationDisposition: DWORD,
        pCreateExParams: LPCREATEFILE2_EXTENDED_PARAMETERS,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn DeleteFileFromAppW(lpFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstFileExFromAppW(
        lpFileName: LPCWSTR,
        fInfoLevelId: FINDEX_INFO_LEVELS,
        lpFindFileData: LPVOID,
        fSearchOp: FINDEX_SEARCH_OPS,
        lpSearchFilter: LPVOID,
        dwAdditionalFlags: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetFileAttributesExFromAppW(
        lpFileName: LPCWSTR,
        fInfoLevelId: GET_FILEEX_INFO_LEVELS,
        lpFileInformation: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileFromAppW(lpExistingFileName: LPCWSTR, lpNewFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveDirectoryFromAppW(lpPathName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ReplaceFileFromAppW(
        lpReplacedFileName: LPCWSTR,
        lpReplacementFileName: LPCWSTR,
        lpBackupFileName: LPCWSTR,
        dwReplaceFlags: DWORD,
        lpExclude: LPVOID,
        lpReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileAttributesFromAppW(lpFileName: LPCWSTR, dwFileAttributes: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn IsDebuggerPresent() -> BOOL;
}
unsafe extern "C" {
    pub fn DebugBreak();
}
unsafe extern "C" {
    pub fn OutputDebugStringA(lpOutputString: LPCSTR);
}
unsafe extern "C" {
    pub fn OutputDebugStringW(lpOutputString: LPCWSTR);
}
unsafe extern "C" {
    pub fn ContinueDebugEvent(
        dwProcessId: DWORD,
        dwThreadId: DWORD,
        dwContinueStatus: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitForDebugEvent(lpDebugEvent: LPDEBUG_EVENT, dwMilliseconds: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DebugActiveProcess(dwProcessId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DebugActiveProcessStop(dwProcessId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckRemoteDebuggerPresent(hProcess: HANDLE, pbDebuggerPresent: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitForDebugEventEx(lpDebugEvent: LPDEBUG_EVENT, dwMilliseconds: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EncodePointer(Ptr: PVOID) -> PVOID;
}
unsafe extern "C" {
    pub fn DecodePointer(Ptr: PVOID) -> PVOID;
}
unsafe extern "C" {
    pub fn EncodeSystemPointer(Ptr: PVOID) -> PVOID;
}
unsafe extern "C" {
    pub fn DecodeSystemPointer(Ptr: PVOID) -> PVOID;
}
unsafe extern "C" {
    pub fn EncodeRemotePointer(
        ProcessHandle: HANDLE,
        Ptr: PVOID,
        EncodedPtr: *mut PVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DecodeRemotePointer(
        ProcessHandle: HANDLE,
        Ptr: PVOID,
        DecodedPtr: *mut PVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn Beep(dwFreq: DWORD, dwDuration: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseHandle(hObject: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn DuplicateHandle(
        hSourceProcessHandle: HANDLE,
        hSourceHandle: HANDLE,
        hTargetProcessHandle: HANDLE,
        lpTargetHandle: LPHANDLE,
        dwDesiredAccess: DWORD,
        bInheritHandle: BOOL,
        dwOptions: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CompareObjectHandles(hFirstObjectHandle: HANDLE, hSecondObjectHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetHandleInformation(hObject: HANDLE, lpdwFlags: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetHandleInformation(hObject: HANDLE, dwMask: DWORD, dwFlags: DWORD) -> BOOL;
}
pub type PTOP_LEVEL_EXCEPTION_FILTER =
    ::std::option::Option<unsafe extern "C" fn(ExceptionInfo: *mut _EXCEPTION_POINTERS) -> LONG>;
pub type LPTOP_LEVEL_EXCEPTION_FILTER = PTOP_LEVEL_EXCEPTION_FILTER;
unsafe extern "C" {
    pub fn RaiseException(
        dwExceptionCode: DWORD,
        dwExceptionFlags: DWORD,
        nNumberOfArguments: DWORD,
        lpArguments: *const ULONG_PTR,
    );
}
unsafe extern "C" {
    pub fn UnhandledExceptionFilter(ExceptionInfo: *mut _EXCEPTION_POINTERS) -> LONG;
}
unsafe extern "C" {
    pub fn SetUnhandledExceptionFilter(
        lpTopLevelExceptionFilter: LPTOP_LEVEL_EXCEPTION_FILTER,
    ) -> LPTOP_LEVEL_EXCEPTION_FILTER;
}
unsafe extern "C" {
    pub fn GetLastError() -> DWORD;
}
unsafe extern "C" {
    pub fn SetLastError(dwErrCode: DWORD);
}
unsafe extern "C" {
    pub fn GetErrorMode() -> UINT;
}
unsafe extern "C" {
    pub fn SetErrorMode(uMode: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn AddVectoredExceptionHandler(First: ULONG, Handler: PVECTORED_EXCEPTION_HANDLER)
        -> PVOID;
}
unsafe extern "C" {
    pub fn RemoveVectoredExceptionHandler(Handle: PVOID) -> ULONG;
}
unsafe extern "C" {
    pub fn AddVectoredContinueHandler(First: ULONG, Handler: PVECTORED_EXCEPTION_HANDLER) -> PVOID;
}
unsafe extern "C" {
    pub fn RemoveVectoredContinueHandler(Handle: PVOID) -> ULONG;
}
unsafe extern "C" {
    pub fn RaiseFailFastException(
        pExceptionRecord: PEXCEPTION_RECORD,
        pContextRecord: PCONTEXT,
        dwFlags: DWORD,
    );
}
unsafe extern "C" {
    pub fn FatalAppExitA(uAction: UINT, lpMessageText: LPCSTR);
}
unsafe extern "C" {
    pub fn FatalAppExitW(uAction: UINT, lpMessageText: LPCWSTR);
}
unsafe extern "C" {
    pub fn GetThreadErrorMode() -> DWORD;
}
unsafe extern "C" {
    pub fn SetThreadErrorMode(dwNewMode: DWORD, lpOldMode: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn TerminateProcessOnMemoryExhaustion(FailedAllocationSize: SIZE_T);
}
unsafe extern "C" {
    pub fn FlsAlloc(lpCallback: PFLS_CALLBACK_FUNCTION) -> DWORD;
}
unsafe extern "C" {
    pub fn FlsGetValue(dwFlsIndex: DWORD) -> PVOID;
}
unsafe extern "C" {
    pub fn FlsSetValue(dwFlsIndex: DWORD, lpFlsData: PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn FlsFree(dwFlsIndex: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn IsThreadAFiber() -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePipe(
        hReadPipe: PHANDLE,
        hWritePipe: PHANDLE,
        lpPipeAttributes: LPSECURITY_ATTRIBUTES,
        nSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ConnectNamedPipe(hNamedPipe: HANDLE, lpOverlapped: LPOVERLAPPED) -> BOOL;
}
unsafe extern "C" {
    pub fn DisconnectNamedPipe(hNamedPipe: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetNamedPipeHandleState(
        hNamedPipe: HANDLE,
        lpMode: LPDWORD,
        lpMaxCollectionCount: LPDWORD,
        lpCollectDataTimeout: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PeekNamedPipe(
        hNamedPipe: HANDLE,
        lpBuffer: LPVOID,
        nBufferSize: DWORD,
        lpBytesRead: LPDWORD,
        lpTotalBytesAvail: LPDWORD,
        lpBytesLeftThisMessage: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TransactNamedPipe(
        hNamedPipe: HANDLE,
        lpInBuffer: LPVOID,
        nInBufferSize: DWORD,
        lpOutBuffer: LPVOID,
        nOutBufferSize: DWORD,
        lpBytesRead: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateNamedPipeW(
        lpName: LPCWSTR,
        dwOpenMode: DWORD,
        dwPipeMode: DWORD,
        nMaxInstances: DWORD,
        nOutBufferSize: DWORD,
        nInBufferSize: DWORD,
        nDefaultTimeOut: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WaitNamedPipeW(lpNamedPipeName: LPCWSTR, nTimeOut: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeClientComputerNameW(
        Pipe: HANDLE,
        ClientComputerName: LPWSTR,
        ClientComputerNameLength: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImpersonateNamedPipeClient(hNamedPipe: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeInfo(
        hNamedPipe: HANDLE,
        lpFlags: LPDWORD,
        lpOutBufferSize: LPDWORD,
        lpInBufferSize: LPDWORD,
        lpMaxInstances: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeHandleStateW(
        hNamedPipe: HANDLE,
        lpState: LPDWORD,
        lpCurInstances: LPDWORD,
        lpMaxCollectionCount: LPDWORD,
        lpCollectDataTimeout: LPDWORD,
        lpUserName: LPWSTR,
        nMaxUserNameSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CallNamedPipeW(
        lpNamedPipeName: LPCWSTR,
        lpInBuffer: LPVOID,
        nInBufferSize: DWORD,
        lpOutBuffer: LPVOID,
        nOutBufferSize: DWORD,
        lpBytesRead: LPDWORD,
        nTimeOut: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryPerformanceCounter(lpPerformanceCount: *mut LARGE_INTEGER) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryPerformanceFrequency(lpFrequency: *mut LARGE_INTEGER) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HEAP_SUMMARY {
    pub cb: DWORD,
    pub cbAllocated: SIZE_T,
    pub cbCommitted: SIZE_T,
    pub cbReserved: SIZE_T,
    pub cbMaxReserve: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HEAP_SUMMARY"][::std::mem::size_of::<_HEAP_SUMMARY>() - 40usize];
    ["Alignment of _HEAP_SUMMARY"][::std::mem::align_of::<_HEAP_SUMMARY>() - 8usize];
    ["Offset of field: _HEAP_SUMMARY::cb"][::std::mem::offset_of!(_HEAP_SUMMARY, cb) - 0usize];
    ["Offset of field: _HEAP_SUMMARY::cbAllocated"]
        [::std::mem::offset_of!(_HEAP_SUMMARY, cbAllocated) - 8usize];
    ["Offset of field: _HEAP_SUMMARY::cbCommitted"]
        [::std::mem::offset_of!(_HEAP_SUMMARY, cbCommitted) - 16usize];
    ["Offset of field: _HEAP_SUMMARY::cbReserved"]
        [::std::mem::offset_of!(_HEAP_SUMMARY, cbReserved) - 24usize];
    ["Offset of field: _HEAP_SUMMARY::cbMaxReserve"]
        [::std::mem::offset_of!(_HEAP_SUMMARY, cbMaxReserve) - 32usize];
};
pub type HEAP_SUMMARY = _HEAP_SUMMARY;
pub type PHEAP_SUMMARY = *mut _HEAP_SUMMARY;
pub type LPHEAP_SUMMARY = PHEAP_SUMMARY;
unsafe extern "C" {
    pub fn HeapCreate(flOptions: DWORD, dwInitialSize: SIZE_T, dwMaximumSize: SIZE_T) -> HANDLE;
}
unsafe extern "C" {
    pub fn HeapDestroy(hHeap: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapAlloc(hHeap: HANDLE, dwFlags: DWORD, dwBytes: SIZE_T) -> LPVOID;
}
unsafe extern "C" {
    pub fn HeapReAlloc(hHeap: HANDLE, dwFlags: DWORD, lpMem: LPVOID, dwBytes: SIZE_T) -> LPVOID;
}
unsafe extern "C" {
    pub fn HeapFree(hHeap: HANDLE, dwFlags: DWORD, lpMem: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapSize(hHeap: HANDLE, dwFlags: DWORD, lpMem: LPCVOID) -> SIZE_T;
}
unsafe extern "C" {
    pub fn GetProcessHeap() -> HANDLE;
}
unsafe extern "C" {
    pub fn HeapCompact(hHeap: HANDLE, dwFlags: DWORD) -> SIZE_T;
}
unsafe extern "C" {
    pub fn HeapSetInformation(
        HeapHandle: HANDLE,
        HeapInformationClass: HEAP_INFORMATION_CLASS,
        HeapInformation: PVOID,
        HeapInformationLength: SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapValidate(hHeap: HANDLE, dwFlags: DWORD, lpMem: LPCVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapSummary(hHeap: HANDLE, dwFlags: DWORD, lpSummary: LPHEAP_SUMMARY) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessHeaps(NumberOfHeaps: DWORD, ProcessHeaps: PHANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn HeapLock(hHeap: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapUnlock(hHeap: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapWalk(hHeap: HANDLE, lpEntry: LPPROCESS_HEAP_ENTRY) -> BOOL;
}
unsafe extern "C" {
    pub fn HeapQueryInformation(
        HeapHandle: HANDLE,
        HeapInformationClass: HEAP_INFORMATION_CLASS,
        HeapInformation: PVOID,
        HeapInformationLength: SIZE_T,
        ReturnLength: PSIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateIoCompletionPort(
        FileHandle: HANDLE,
        ExistingCompletionPort: HANDLE,
        CompletionKey: ULONG_PTR,
        NumberOfConcurrentThreads: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetQueuedCompletionStatus(
        CompletionPort: HANDLE,
        lpNumberOfBytesTransferred: LPDWORD,
        lpCompletionKey: PULONG_PTR,
        lpOverlapped: *mut LPOVERLAPPED,
        dwMilliseconds: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetQueuedCompletionStatusEx(
        CompletionPort: HANDLE,
        lpCompletionPortEntries: LPOVERLAPPED_ENTRY,
        ulCount: ULONG,
        ulNumEntriesRemoved: PULONG,
        dwMilliseconds: DWORD,
        fAlertable: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PostQueuedCompletionStatus(
        CompletionPort: HANDLE,
        dwNumberOfBytesTransferred: DWORD,
        dwCompletionKey: ULONG_PTR,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeviceIoControl(
        hDevice: HANDLE,
        dwIoControlCode: DWORD,
        lpInBuffer: LPVOID,
        nInBufferSize: DWORD,
        lpOutBuffer: LPVOID,
        nOutBufferSize: DWORD,
        lpBytesReturned: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOverlappedResult(
        hFile: HANDLE,
        lpOverlapped: LPOVERLAPPED,
        lpNumberOfBytesTransferred: LPDWORD,
        bWait: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelIoEx(hFile: HANDLE, lpOverlapped: LPOVERLAPPED) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelIo(hFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOverlappedResultEx(
        hFile: HANDLE,
        lpOverlapped: LPOVERLAPPED,
        lpNumberOfBytesTransferred: LPDWORD,
        dwMilliseconds: DWORD,
        bAlertable: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelSynchronousIo(hThread: HANDLE) -> BOOL;
}
pub type SRWLOCK = RTL_SRWLOCK;
pub type PSRWLOCK = *mut RTL_SRWLOCK;
unsafe extern "C" {
    pub fn InitializeSRWLock(SRWLock: PSRWLOCK);
}
unsafe extern "C" {
    pub fn ReleaseSRWLockExclusive(SRWLock: PSRWLOCK);
}
unsafe extern "C" {
    pub fn ReleaseSRWLockShared(SRWLock: PSRWLOCK);
}
unsafe extern "C" {
    pub fn AcquireSRWLockExclusive(SRWLock: PSRWLOCK);
}
unsafe extern "C" {
    pub fn AcquireSRWLockShared(SRWLock: PSRWLOCK);
}
unsafe extern "C" {
    pub fn TryAcquireSRWLockExclusive(SRWLock: PSRWLOCK) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn TryAcquireSRWLockShared(SRWLock: PSRWLOCK) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn InitializeCriticalSection(lpCriticalSection: LPCRITICAL_SECTION);
}
unsafe extern "C" {
    pub fn EnterCriticalSection(lpCriticalSection: LPCRITICAL_SECTION);
}
unsafe extern "C" {
    pub fn LeaveCriticalSection(lpCriticalSection: LPCRITICAL_SECTION);
}
unsafe extern "C" {
    pub fn InitializeCriticalSectionAndSpinCount(
        lpCriticalSection: LPCRITICAL_SECTION,
        dwSpinCount: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeCriticalSectionEx(
        lpCriticalSection: LPCRITICAL_SECTION,
        dwSpinCount: DWORD,
        Flags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCriticalSectionSpinCount(
        lpCriticalSection: LPCRITICAL_SECTION,
        dwSpinCount: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn TryEnterCriticalSection(lpCriticalSection: LPCRITICAL_SECTION) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteCriticalSection(lpCriticalSection: LPCRITICAL_SECTION);
}
pub type INIT_ONCE = RTL_RUN_ONCE;
pub type PINIT_ONCE = PRTL_RUN_ONCE;
pub type LPINIT_ONCE = PRTL_RUN_ONCE;
pub type PINIT_ONCE_FN = ::std::option::Option<
    unsafe extern "C" fn(InitOnce: PINIT_ONCE, Parameter: PVOID, Context: *mut PVOID) -> BOOL,
>;
unsafe extern "C" {
    pub fn InitOnceInitialize(InitOnce: PINIT_ONCE);
}
unsafe extern "C" {
    pub fn InitOnceExecuteOnce(
        InitOnce: PINIT_ONCE,
        InitFn: PINIT_ONCE_FN,
        Parameter: PVOID,
        Context: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitOnceBeginInitialize(
        lpInitOnce: LPINIT_ONCE,
        dwFlags: DWORD,
        fPending: PBOOL,
        lpContext: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitOnceComplete(lpInitOnce: LPINIT_ONCE, dwFlags: DWORD, lpContext: LPVOID) -> BOOL;
}
pub type CONDITION_VARIABLE = RTL_CONDITION_VARIABLE;
pub type PCONDITION_VARIABLE = *mut RTL_CONDITION_VARIABLE;
unsafe extern "C" {
    pub fn InitializeConditionVariable(ConditionVariable: PCONDITION_VARIABLE);
}
unsafe extern "C" {
    pub fn WakeConditionVariable(ConditionVariable: PCONDITION_VARIABLE);
}
unsafe extern "C" {
    pub fn WakeAllConditionVariable(ConditionVariable: PCONDITION_VARIABLE);
}
unsafe extern "C" {
    pub fn SleepConditionVariableCS(
        ConditionVariable: PCONDITION_VARIABLE,
        CriticalSection: PCRITICAL_SECTION,
        dwMilliseconds: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SleepConditionVariableSRW(
        ConditionVariable: PCONDITION_VARIABLE,
        SRWLock: PSRWLOCK,
        dwMilliseconds: DWORD,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetEvent(hEvent: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ResetEvent(hEvent: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ReleaseSemaphore(
        hSemaphore: HANDLE,
        lReleaseCount: LONG,
        lpPreviousCount: LPLONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReleaseMutex(hMutex: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitForSingleObject(hHandle: HANDLE, dwMilliseconds: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn SleepEx(dwMilliseconds: DWORD, bAlertable: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn WaitForSingleObjectEx(hHandle: HANDLE, dwMilliseconds: DWORD, bAlertable: BOOL)
        -> DWORD;
}
unsafe extern "C" {
    pub fn WaitForMultipleObjectsEx(
        nCount: DWORD,
        lpHandles: *const HANDLE,
        bWaitAll: BOOL,
        dwMilliseconds: DWORD,
        bAlertable: BOOL,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CreateMutexA(
        lpMutexAttributes: LPSECURITY_ATTRIBUTES,
        bInitialOwner: BOOL,
        lpName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateMutexW(
        lpMutexAttributes: LPSECURITY_ATTRIBUTES,
        bInitialOwner: BOOL,
        lpName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenMutexW(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateEventA(
        lpEventAttributes: LPSECURITY_ATTRIBUTES,
        bManualReset: BOOL,
        bInitialState: BOOL,
        lpName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateEventW(
        lpEventAttributes: LPSECURITY_ATTRIBUTES,
        bManualReset: BOOL,
        bInitialState: BOOL,
        lpName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenEventA(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenEventW(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenSemaphoreW(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCWSTR) -> HANDLE;
}
pub type PTIMERAPCROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        lpArgToCompletionRoutine: LPVOID,
        dwTimerLowValue: DWORD,
        dwTimerHighValue: DWORD,
    ),
>;
unsafe extern "C" {
    pub fn OpenWaitableTimerW(
        dwDesiredAccess: DWORD,
        bInheritHandle: BOOL,
        lpTimerName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetWaitableTimerEx(
        hTimer: HANDLE,
        lpDueTime: *const LARGE_INTEGER,
        lPeriod: LONG,
        pfnCompletionRoutine: PTIMERAPCROUTINE,
        lpArgToCompletionRoutine: LPVOID,
        WakeContext: PREASON_CONTEXT,
        TolerableDelay: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWaitableTimer(
        hTimer: HANDLE,
        lpDueTime: *const LARGE_INTEGER,
        lPeriod: LONG,
        pfnCompletionRoutine: PTIMERAPCROUTINE,
        lpArgToCompletionRoutine: LPVOID,
        fResume: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelWaitableTimer(hTimer: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateMutexExA(
        lpMutexAttributes: LPSECURITY_ATTRIBUTES,
        lpName: LPCSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateMutexExW(
        lpMutexAttributes: LPSECURITY_ATTRIBUTES,
        lpName: LPCWSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateEventExA(
        lpEventAttributes: LPSECURITY_ATTRIBUTES,
        lpName: LPCSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateEventExW(
        lpEventAttributes: LPSECURITY_ATTRIBUTES,
        lpName: LPCWSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateSemaphoreExW(
        lpSemaphoreAttributes: LPSECURITY_ATTRIBUTES,
        lInitialCount: LONG,
        lMaximumCount: LONG,
        lpName: LPCWSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateWaitableTimerExW(
        lpTimerAttributes: LPSECURITY_ATTRIBUTES,
        lpTimerName: LPCWSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
pub type SYNCHRONIZATION_BARRIER = RTL_BARRIER;
pub type PSYNCHRONIZATION_BARRIER = PRTL_BARRIER;
pub type LPSYNCHRONIZATION_BARRIER = PRTL_BARRIER;
unsafe extern "C" {
    pub fn EnterSynchronizationBarrier(
        lpBarrier: LPSYNCHRONIZATION_BARRIER,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeSynchronizationBarrier(
        lpBarrier: LPSYNCHRONIZATION_BARRIER,
        lTotalThreads: LONG,
        lSpinCount: LONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteSynchronizationBarrier(lpBarrier: LPSYNCHRONIZATION_BARRIER) -> BOOL;
}
unsafe extern "C" {
    pub fn Sleep(dwMilliseconds: DWORD);
}
unsafe extern "C" {
    pub fn WaitOnAddress(
        Address: *mut ::std::os::raw::c_void,
        CompareAddress: PVOID,
        AddressSize: SIZE_T,
        dwMilliseconds: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WakeByAddressSingle(Address: PVOID);
}
unsafe extern "C" {
    pub fn WakeByAddressAll(Address: PVOID);
}
unsafe extern "C" {
    pub fn SignalObjectAndWait(
        hObjectToSignal: HANDLE,
        hObjectToWaitOn: HANDLE,
        dwMilliseconds: DWORD,
        bAlertable: BOOL,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WaitForMultipleObjects(
        nCount: DWORD,
        lpHandles: *const HANDLE,
        bWaitAll: BOOL,
        dwMilliseconds: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CreateSemaphoreW(
        lpSemaphoreAttributes: LPSECURITY_ATTRIBUTES,
        lInitialCount: LONG,
        lMaximumCount: LONG,
        lpName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateWaitableTimerW(
        lpTimerAttributes: LPSECURITY_ATTRIBUTES,
        bManualReset: BOOL,
        lpTimerName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn InitializeSListHead(ListHead: PSLIST_HEADER);
}
unsafe extern "C" {
    pub fn InterlockedPopEntrySList(ListHead: PSLIST_HEADER) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn InterlockedPushEntrySList(
        ListHead: PSLIST_HEADER,
        ListEntry: PSLIST_ENTRY,
    ) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn InterlockedPushListSListEx(
        ListHead: PSLIST_HEADER,
        List: PSLIST_ENTRY,
        ListEnd: PSLIST_ENTRY,
        Count: ULONG,
    ) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn InterlockedFlushSList(ListHead: PSLIST_HEADER) -> PSLIST_ENTRY;
}
unsafe extern "C" {
    pub fn QueryDepthSList(ListHead: PSLIST_HEADER) -> USHORT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_INFORMATION {
    pub hProcess: HANDLE,
    pub hThread: HANDLE,
    pub dwProcessId: DWORD,
    pub dwThreadId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_INFORMATION"][::std::mem::size_of::<_PROCESS_INFORMATION>() - 24usize];
    ["Alignment of _PROCESS_INFORMATION"][::std::mem::align_of::<_PROCESS_INFORMATION>() - 8usize];
    ["Offset of field: _PROCESS_INFORMATION::hProcess"]
        [::std::mem::offset_of!(_PROCESS_INFORMATION, hProcess) - 0usize];
    ["Offset of field: _PROCESS_INFORMATION::hThread"]
        [::std::mem::offset_of!(_PROCESS_INFORMATION, hThread) - 8usize];
    ["Offset of field: _PROCESS_INFORMATION::dwProcessId"]
        [::std::mem::offset_of!(_PROCESS_INFORMATION, dwProcessId) - 16usize];
    ["Offset of field: _PROCESS_INFORMATION::dwThreadId"]
        [::std::mem::offset_of!(_PROCESS_INFORMATION, dwThreadId) - 20usize];
};
pub type PROCESS_INFORMATION = _PROCESS_INFORMATION;
pub type PPROCESS_INFORMATION = *mut _PROCESS_INFORMATION;
pub type LPPROCESS_INFORMATION = *mut _PROCESS_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STARTUPINFOA {
    pub cb: DWORD,
    pub lpReserved: LPSTR,
    pub lpDesktop: LPSTR,
    pub lpTitle: LPSTR,
    pub dwX: DWORD,
    pub dwY: DWORD,
    pub dwXSize: DWORD,
    pub dwYSize: DWORD,
    pub dwXCountChars: DWORD,
    pub dwYCountChars: DWORD,
    pub dwFillAttribute: DWORD,
    pub dwFlags: DWORD,
    pub wShowWindow: WORD,
    pub cbReserved2: WORD,
    pub lpReserved2: LPBYTE,
    pub hStdInput: HANDLE,
    pub hStdOutput: HANDLE,
    pub hStdError: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STARTUPINFOA"][::std::mem::size_of::<_STARTUPINFOA>() - 104usize];
    ["Alignment of _STARTUPINFOA"][::std::mem::align_of::<_STARTUPINFOA>() - 8usize];
    ["Offset of field: _STARTUPINFOA::cb"][::std::mem::offset_of!(_STARTUPINFOA, cb) - 0usize];
    ["Offset of field: _STARTUPINFOA::lpReserved"]
        [::std::mem::offset_of!(_STARTUPINFOA, lpReserved) - 8usize];
    ["Offset of field: _STARTUPINFOA::lpDesktop"]
        [::std::mem::offset_of!(_STARTUPINFOA, lpDesktop) - 16usize];
    ["Offset of field: _STARTUPINFOA::lpTitle"]
        [::std::mem::offset_of!(_STARTUPINFOA, lpTitle) - 24usize];
    ["Offset of field: _STARTUPINFOA::dwX"][::std::mem::offset_of!(_STARTUPINFOA, dwX) - 32usize];
    ["Offset of field: _STARTUPINFOA::dwY"][::std::mem::offset_of!(_STARTUPINFOA, dwY) - 36usize];
    ["Offset of field: _STARTUPINFOA::dwXSize"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwXSize) - 40usize];
    ["Offset of field: _STARTUPINFOA::dwYSize"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwYSize) - 44usize];
    ["Offset of field: _STARTUPINFOA::dwXCountChars"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwXCountChars) - 48usize];
    ["Offset of field: _STARTUPINFOA::dwYCountChars"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwYCountChars) - 52usize];
    ["Offset of field: _STARTUPINFOA::dwFillAttribute"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwFillAttribute) - 56usize];
    ["Offset of field: _STARTUPINFOA::dwFlags"]
        [::std::mem::offset_of!(_STARTUPINFOA, dwFlags) - 60usize];
    ["Offset of field: _STARTUPINFOA::wShowWindow"]
        [::std::mem::offset_of!(_STARTUPINFOA, wShowWindow) - 64usize];
    ["Offset of field: _STARTUPINFOA::cbReserved2"]
        [::std::mem::offset_of!(_STARTUPINFOA, cbReserved2) - 66usize];
    ["Offset of field: _STARTUPINFOA::lpReserved2"]
        [::std::mem::offset_of!(_STARTUPINFOA, lpReserved2) - 72usize];
    ["Offset of field: _STARTUPINFOA::hStdInput"]
        [::std::mem::offset_of!(_STARTUPINFOA, hStdInput) - 80usize];
    ["Offset of field: _STARTUPINFOA::hStdOutput"]
        [::std::mem::offset_of!(_STARTUPINFOA, hStdOutput) - 88usize];
    ["Offset of field: _STARTUPINFOA::hStdError"]
        [::std::mem::offset_of!(_STARTUPINFOA, hStdError) - 96usize];
};
pub type STARTUPINFOA = _STARTUPINFOA;
pub type LPSTARTUPINFOA = *mut _STARTUPINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STARTUPINFOW {
    pub cb: DWORD,
    pub lpReserved: LPWSTR,
    pub lpDesktop: LPWSTR,
    pub lpTitle: LPWSTR,
    pub dwX: DWORD,
    pub dwY: DWORD,
    pub dwXSize: DWORD,
    pub dwYSize: DWORD,
    pub dwXCountChars: DWORD,
    pub dwYCountChars: DWORD,
    pub dwFillAttribute: DWORD,
    pub dwFlags: DWORD,
    pub wShowWindow: WORD,
    pub cbReserved2: WORD,
    pub lpReserved2: LPBYTE,
    pub hStdInput: HANDLE,
    pub hStdOutput: HANDLE,
    pub hStdError: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STARTUPINFOW"][::std::mem::size_of::<_STARTUPINFOW>() - 104usize];
    ["Alignment of _STARTUPINFOW"][::std::mem::align_of::<_STARTUPINFOW>() - 8usize];
    ["Offset of field: _STARTUPINFOW::cb"][::std::mem::offset_of!(_STARTUPINFOW, cb) - 0usize];
    ["Offset of field: _STARTUPINFOW::lpReserved"]
        [::std::mem::offset_of!(_STARTUPINFOW, lpReserved) - 8usize];
    ["Offset of field: _STARTUPINFOW::lpDesktop"]
        [::std::mem::offset_of!(_STARTUPINFOW, lpDesktop) - 16usize];
    ["Offset of field: _STARTUPINFOW::lpTitle"]
        [::std::mem::offset_of!(_STARTUPINFOW, lpTitle) - 24usize];
    ["Offset of field: _STARTUPINFOW::dwX"][::std::mem::offset_of!(_STARTUPINFOW, dwX) - 32usize];
    ["Offset of field: _STARTUPINFOW::dwY"][::std::mem::offset_of!(_STARTUPINFOW, dwY) - 36usize];
    ["Offset of field: _STARTUPINFOW::dwXSize"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwXSize) - 40usize];
    ["Offset of field: _STARTUPINFOW::dwYSize"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwYSize) - 44usize];
    ["Offset of field: _STARTUPINFOW::dwXCountChars"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwXCountChars) - 48usize];
    ["Offset of field: _STARTUPINFOW::dwYCountChars"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwYCountChars) - 52usize];
    ["Offset of field: _STARTUPINFOW::dwFillAttribute"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwFillAttribute) - 56usize];
    ["Offset of field: _STARTUPINFOW::dwFlags"]
        [::std::mem::offset_of!(_STARTUPINFOW, dwFlags) - 60usize];
    ["Offset of field: _STARTUPINFOW::wShowWindow"]
        [::std::mem::offset_of!(_STARTUPINFOW, wShowWindow) - 64usize];
    ["Offset of field: _STARTUPINFOW::cbReserved2"]
        [::std::mem::offset_of!(_STARTUPINFOW, cbReserved2) - 66usize];
    ["Offset of field: _STARTUPINFOW::lpReserved2"]
        [::std::mem::offset_of!(_STARTUPINFOW, lpReserved2) - 72usize];
    ["Offset of field: _STARTUPINFOW::hStdInput"]
        [::std::mem::offset_of!(_STARTUPINFOW, hStdInput) - 80usize];
    ["Offset of field: _STARTUPINFOW::hStdOutput"]
        [::std::mem::offset_of!(_STARTUPINFOW, hStdOutput) - 88usize];
    ["Offset of field: _STARTUPINFOW::hStdError"]
        [::std::mem::offset_of!(_STARTUPINFOW, hStdError) - 96usize];
};
pub type STARTUPINFOW = _STARTUPINFOW;
pub type LPSTARTUPINFOW = *mut _STARTUPINFOW;
pub type STARTUPINFO = STARTUPINFOA;
pub type LPSTARTUPINFO = LPSTARTUPINFOA;
unsafe extern "C" {
    pub fn QueueUserAPC(pfnAPC: PAPCFUNC, hThread: HANDLE, dwData: ULONG_PTR) -> DWORD;
}
pub const _QUEUE_USER_APC_FLAGS_QUEUE_USER_APC_FLAGS_NONE: _QUEUE_USER_APC_FLAGS = 0;
pub const _QUEUE_USER_APC_FLAGS_QUEUE_USER_APC_FLAGS_SPECIAL_USER_APC: _QUEUE_USER_APC_FLAGS = 1;
pub type _QUEUE_USER_APC_FLAGS = ::std::os::raw::c_int;
pub use self::_QUEUE_USER_APC_FLAGS as QUEUE_USER_APC_FLAGS;
unsafe extern "C" {
    pub fn QueueUserAPC2(
        ApcRoutine: PAPCFUNC,
        Thread: HANDLE,
        Data: ULONG_PTR,
        Flags: QUEUE_USER_APC_FLAGS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessTimes(
        hProcess: HANDLE,
        lpCreationTime: LPFILETIME,
        lpExitTime: LPFILETIME,
        lpKernelTime: LPFILETIME,
        lpUserTime: LPFILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentProcess() -> HANDLE;
}
unsafe extern "C" {
    pub fn GetCurrentProcessId() -> DWORD;
}
unsafe extern "C" {
    pub fn ExitProcess(uExitCode: UINT) -> !;
}
unsafe extern "C" {
    pub fn TerminateProcess(hProcess: HANDLE, uExitCode: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetExitCodeProcess(hProcess: HANDLE, lpExitCode: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SwitchToThread() -> BOOL;
}
unsafe extern "C" {
    pub fn CreateThread(
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        dwStackSize: SIZE_T,
        lpStartAddress: LPTHREAD_START_ROUTINE,
        lpParameter: LPVOID,
        dwCreationFlags: DWORD,
        lpThreadId: LPDWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateRemoteThread(
        hProcess: HANDLE,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        dwStackSize: SIZE_T,
        lpStartAddress: LPTHREAD_START_ROUTINE,
        lpParameter: LPVOID,
        dwCreationFlags: DWORD,
        lpThreadId: LPDWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetCurrentThread() -> HANDLE;
}
unsafe extern "C" {
    pub fn GetCurrentThreadId() -> DWORD;
}
unsafe extern "C" {
    pub fn OpenThread(dwDesiredAccess: DWORD, bInheritHandle: BOOL, dwThreadId: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetThreadPriority(hThread: HANDLE, nPriority: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadPriorityBoost(hThread: HANDLE, bDisablePriorityBoost: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadPriorityBoost(hThread: HANDLE, pDisablePriorityBoost: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadPriority(hThread: HANDLE) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExitThread(dwExitCode: DWORD) -> !;
}
unsafe extern "C" {
    pub fn TerminateThread(hThread: HANDLE, dwExitCode: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetExitCodeThread(hThread: HANDLE, lpExitCode: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SuspendThread(hThread: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn ResumeThread(hThread: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn TlsAlloc() -> DWORD;
}
unsafe extern "C" {
    pub fn TlsGetValue(dwTlsIndex: DWORD) -> LPVOID;
}
unsafe extern "C" {
    pub fn TlsSetValue(dwTlsIndex: DWORD, lpTlsValue: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn TlsFree(dwTlsIndex: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateProcessA(
        lpApplicationName: LPCSTR,
        lpCommandLine: LPSTR,
        lpProcessAttributes: LPSECURITY_ATTRIBUTES,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        bInheritHandles: BOOL,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCSTR,
        lpStartupInfo: LPSTARTUPINFOA,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateProcessW(
        lpApplicationName: LPCWSTR,
        lpCommandLine: LPWSTR,
        lpProcessAttributes: LPSECURITY_ATTRIBUTES,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        bInheritHandles: BOOL,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCWSTR,
        lpStartupInfo: LPSTARTUPINFOW,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessShutdownParameters(dwLevel: DWORD, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessVersion(ProcessId: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetStartupInfoW(lpStartupInfo: LPSTARTUPINFOW);
}
unsafe extern "C" {
    pub fn CreateProcessAsUserW(
        hToken: HANDLE,
        lpApplicationName: LPCWSTR,
        lpCommandLine: LPWSTR,
        lpProcessAttributes: LPSECURITY_ATTRIBUTES,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        bInheritHandles: BOOL,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCWSTR,
        lpStartupInfo: LPSTARTUPINFOW,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadToken(Thread: PHANDLE, Token: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenProcessToken(
        ProcessHandle: HANDLE,
        DesiredAccess: DWORD,
        TokenHandle: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenThreadToken(
        ThreadHandle: HANDLE,
        DesiredAccess: DWORD,
        OpenAsSelf: BOOL,
        TokenHandle: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPriorityClass(hProcess: HANDLE, dwPriorityClass: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPriorityClass(hProcess: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn SetThreadStackGuarantee(StackSizeInBytes: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn ProcessIdToSessionId(dwProcessId: DWORD, pSessionId: *mut DWORD) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROC_THREAD_ATTRIBUTE_LIST {
    _unused: [u8; 0],
}
pub type PPROC_THREAD_ATTRIBUTE_LIST = *mut _PROC_THREAD_ATTRIBUTE_LIST;
pub type LPPROC_THREAD_ATTRIBUTE_LIST = *mut _PROC_THREAD_ATTRIBUTE_LIST;
unsafe extern "C" {
    pub fn GetProcessId(Process: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn GetThreadId(Thread: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn FlushProcessWriteBuffers();
}
unsafe extern "C" {
    pub fn GetProcessIdOfThread(Thread: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn InitializeProcThreadAttributeList(
        lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST,
        dwAttributeCount: DWORD,
        dwFlags: DWORD,
        lpSize: PSIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteProcThreadAttributeList(lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST);
}
unsafe extern "C" {
    pub fn UpdateProcThreadAttribute(
        lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST,
        dwFlags: DWORD,
        Attribute: DWORD_PTR,
        lpValue: PVOID,
        cbSize: SIZE_T,
        lpPreviousValue: PVOID,
        lpReturnSize: PSIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDynamicEHContinuationTargets(
        Process: HANDLE,
        NumberOfTargets: USHORT,
        Targets: PPROCESS_DYNAMIC_EH_CONTINUATION_TARGET,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDynamicEnforcedCetCompatibleRanges(
        Process: HANDLE,
        NumberOfRanges: USHORT,
        Ranges: PPROCESS_DYNAMIC_ENFORCED_ADDRESS_RANGE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessAffinityUpdateMode(hProcess: HANDLE, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryProcessAffinityUpdateMode(hProcess: HANDLE, lpdwFlags: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateRemoteThreadEx(
        hProcess: HANDLE,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        dwStackSize: SIZE_T,
        lpStartAddress: LPTHREAD_START_ROUTINE,
        lpParameter: LPVOID,
        dwCreationFlags: DWORD,
        lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST,
        lpThreadId: LPDWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetCurrentThreadStackLimits(LowLimit: PULONG_PTR, HighLimit: PULONG_PTR);
}
unsafe extern "C" {
    pub fn GetThreadContext(hThread: HANDLE, lpContext: LPCONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessMitigationPolicy(
        hProcess: HANDLE,
        MitigationPolicy: PROCESS_MITIGATION_POLICY,
        lpBuffer: PVOID,
        dwLength: SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadContext(hThread: HANDLE, lpContext: *const CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessMitigationPolicy(
        MitigationPolicy: PROCESS_MITIGATION_POLICY,
        lpBuffer: PVOID,
        dwLength: SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FlushInstructionCache(hProcess: HANDLE, lpBaseAddress: LPCVOID, dwSize: SIZE_T) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadTimes(
        hThread: HANDLE,
        lpCreationTime: LPFILETIME,
        lpExitTime: LPFILETIME,
        lpKernelTime: LPFILETIME,
        lpUserTime: LPFILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenProcess(dwDesiredAccess: DWORD, bInheritHandle: BOOL, dwProcessId: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn IsProcessorFeaturePresent(ProcessorFeature: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessHandleCount(hProcess: HANDLE, pdwHandleCount: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentProcessorNumber() -> DWORD;
}
unsafe extern "C" {
    pub fn SetThreadIdealProcessorEx(
        hThread: HANDLE,
        lpIdealProcessor: PPROCESSOR_NUMBER,
        lpPreviousIdealProcessor: PPROCESSOR_NUMBER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadIdealProcessorEx(hThread: HANDLE, lpIdealProcessor: PPROCESSOR_NUMBER) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentProcessorNumberEx(ProcNumber: PPROCESSOR_NUMBER);
}
unsafe extern "C" {
    pub fn GetProcessPriorityBoost(hProcess: HANDLE, pDisablePriorityBoost: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessPriorityBoost(hProcess: HANDLE, bDisablePriorityBoost: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadIOPendingFlag(hThread: HANDLE, lpIOIsPending: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemTimes(
        lpIdleTime: PFILETIME,
        lpKernelTime: PFILETIME,
        lpUserTime: PFILETIME,
    ) -> BOOL;
}
pub const _THREAD_INFORMATION_CLASS_ThreadMemoryPriority: _THREAD_INFORMATION_CLASS = 0;
pub const _THREAD_INFORMATION_CLASS_ThreadAbsoluteCpuPriority: _THREAD_INFORMATION_CLASS = 1;
pub const _THREAD_INFORMATION_CLASS_ThreadDynamicCodePolicy: _THREAD_INFORMATION_CLASS = 2;
pub const _THREAD_INFORMATION_CLASS_ThreadPowerThrottling: _THREAD_INFORMATION_CLASS = 3;
pub const _THREAD_INFORMATION_CLASS_ThreadInformationClassMax: _THREAD_INFORMATION_CLASS = 4;
pub type _THREAD_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_THREAD_INFORMATION_CLASS as THREAD_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORY_PRIORITY_INFORMATION {
    pub MemoryPriority: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORY_PRIORITY_INFORMATION"]
        [::std::mem::size_of::<_MEMORY_PRIORITY_INFORMATION>() - 4usize];
    ["Alignment of _MEMORY_PRIORITY_INFORMATION"]
        [::std::mem::align_of::<_MEMORY_PRIORITY_INFORMATION>() - 4usize];
    ["Offset of field: _MEMORY_PRIORITY_INFORMATION::MemoryPriority"]
        [::std::mem::offset_of!(_MEMORY_PRIORITY_INFORMATION, MemoryPriority) - 0usize];
};
pub type MEMORY_PRIORITY_INFORMATION = _MEMORY_PRIORITY_INFORMATION;
pub type PMEMORY_PRIORITY_INFORMATION = *mut _MEMORY_PRIORITY_INFORMATION;
unsafe extern "C" {
    pub fn GetThreadInformation(
        hThread: HANDLE,
        ThreadInformationClass: THREAD_INFORMATION_CLASS,
        ThreadInformation: LPVOID,
        ThreadInformationSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadInformation(
        hThread: HANDLE,
        ThreadInformationClass: THREAD_INFORMATION_CLASS,
        ThreadInformation: LPVOID,
        ThreadInformationSize: DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _THREAD_POWER_THROTTLING_STATE {
    pub Version: ULONG,
    pub ControlMask: ULONG,
    pub StateMask: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _THREAD_POWER_THROTTLING_STATE"]
        [::std::mem::size_of::<_THREAD_POWER_THROTTLING_STATE>() - 12usize];
    ["Alignment of _THREAD_POWER_THROTTLING_STATE"]
        [::std::mem::align_of::<_THREAD_POWER_THROTTLING_STATE>() - 4usize];
    ["Offset of field: _THREAD_POWER_THROTTLING_STATE::Version"]
        [::std::mem::offset_of!(_THREAD_POWER_THROTTLING_STATE, Version) - 0usize];
    ["Offset of field: _THREAD_POWER_THROTTLING_STATE::ControlMask"]
        [::std::mem::offset_of!(_THREAD_POWER_THROTTLING_STATE, ControlMask) - 4usize];
    ["Offset of field: _THREAD_POWER_THROTTLING_STATE::StateMask"]
        [::std::mem::offset_of!(_THREAD_POWER_THROTTLING_STATE, StateMask) - 8usize];
};
pub type THREAD_POWER_THROTTLING_STATE = _THREAD_POWER_THROTTLING_STATE;
unsafe extern "C" {
    pub fn IsProcessCritical(hProcess: HANDLE, Critical: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProtectedPolicy(
        PolicyGuid: LPCGUID,
        PolicyValue: ULONG_PTR,
        OldPolicyValue: PULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryProtectedPolicy(PolicyGuid: LPCGUID, PolicyValue: PULONG_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadIdealProcessor(hThread: HANDLE, dwIdealProcessor: DWORD) -> DWORD;
}
pub const _PROCESS_INFORMATION_CLASS_ProcessMemoryPriority: _PROCESS_INFORMATION_CLASS = 0;
pub const _PROCESS_INFORMATION_CLASS_ProcessMemoryExhaustionInfo: _PROCESS_INFORMATION_CLASS = 1;
pub const _PROCESS_INFORMATION_CLASS_ProcessAppMemoryInfo: _PROCESS_INFORMATION_CLASS = 2;
pub const _PROCESS_INFORMATION_CLASS_ProcessInPrivateInfo: _PROCESS_INFORMATION_CLASS = 3;
pub const _PROCESS_INFORMATION_CLASS_ProcessPowerThrottling: _PROCESS_INFORMATION_CLASS = 4;
pub const _PROCESS_INFORMATION_CLASS_ProcessReservedValue1: _PROCESS_INFORMATION_CLASS = 5;
pub const _PROCESS_INFORMATION_CLASS_ProcessTelemetryCoverageInfo: _PROCESS_INFORMATION_CLASS = 6;
pub const _PROCESS_INFORMATION_CLASS_ProcessProtectionLevelInfo: _PROCESS_INFORMATION_CLASS = 7;
pub const _PROCESS_INFORMATION_CLASS_ProcessLeapSecondInfo: _PROCESS_INFORMATION_CLASS = 8;
pub const _PROCESS_INFORMATION_CLASS_ProcessMachineTypeInfo: _PROCESS_INFORMATION_CLASS = 9;
pub const _PROCESS_INFORMATION_CLASS_ProcessInformationClassMax: _PROCESS_INFORMATION_CLASS = 10;
pub type _PROCESS_INFORMATION_CLASS = ::std::os::raw::c_int;
pub use self::_PROCESS_INFORMATION_CLASS as PROCESS_INFORMATION_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _APP_MEMORY_INFORMATION {
    pub AvailableCommit: ULONG64,
    pub PrivateCommitUsage: ULONG64,
    pub PeakPrivateCommitUsage: ULONG64,
    pub TotalCommitUsage: ULONG64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _APP_MEMORY_INFORMATION"][::std::mem::size_of::<_APP_MEMORY_INFORMATION>() - 32usize];
    ["Alignment of _APP_MEMORY_INFORMATION"]
        [::std::mem::align_of::<_APP_MEMORY_INFORMATION>() - 8usize];
    ["Offset of field: _APP_MEMORY_INFORMATION::AvailableCommit"]
        [::std::mem::offset_of!(_APP_MEMORY_INFORMATION, AvailableCommit) - 0usize];
    ["Offset of field: _APP_MEMORY_INFORMATION::PrivateCommitUsage"]
        [::std::mem::offset_of!(_APP_MEMORY_INFORMATION, PrivateCommitUsage) - 8usize];
    ["Offset of field: _APP_MEMORY_INFORMATION::PeakPrivateCommitUsage"]
        [::std::mem::offset_of!(_APP_MEMORY_INFORMATION, PeakPrivateCommitUsage) - 16usize];
    ["Offset of field: _APP_MEMORY_INFORMATION::TotalCommitUsage"]
        [::std::mem::offset_of!(_APP_MEMORY_INFORMATION, TotalCommitUsage) - 24usize];
};
pub type APP_MEMORY_INFORMATION = _APP_MEMORY_INFORMATION;
pub type PAPP_MEMORY_INFORMATION = *mut _APP_MEMORY_INFORMATION;
pub const _MACHINE_ATTRIBUTES_UserEnabled: _MACHINE_ATTRIBUTES = 1;
pub const _MACHINE_ATTRIBUTES_KernelEnabled: _MACHINE_ATTRIBUTES = 2;
pub const _MACHINE_ATTRIBUTES_Wow64Container: _MACHINE_ATTRIBUTES = 4;
pub type _MACHINE_ATTRIBUTES = ::std::os::raw::c_int;
pub use self::_MACHINE_ATTRIBUTES as MACHINE_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MACHINE_INFORMATION {
    pub ProcessMachine: USHORT,
    pub Res0: USHORT,
    pub MachineAttributes: MACHINE_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MACHINE_INFORMATION"]
        [::std::mem::size_of::<_PROCESS_MACHINE_INFORMATION>() - 8usize];
    ["Alignment of _PROCESS_MACHINE_INFORMATION"]
        [::std::mem::align_of::<_PROCESS_MACHINE_INFORMATION>() - 4usize];
    ["Offset of field: _PROCESS_MACHINE_INFORMATION::ProcessMachine"]
        [::std::mem::offset_of!(_PROCESS_MACHINE_INFORMATION, ProcessMachine) - 0usize];
    ["Offset of field: _PROCESS_MACHINE_INFORMATION::Res0"]
        [::std::mem::offset_of!(_PROCESS_MACHINE_INFORMATION, Res0) - 2usize];
    ["Offset of field: _PROCESS_MACHINE_INFORMATION::MachineAttributes"]
        [::std::mem::offset_of!(_PROCESS_MACHINE_INFORMATION, MachineAttributes) - 4usize];
};
pub type PROCESS_MACHINE_INFORMATION = _PROCESS_MACHINE_INFORMATION;
pub const _PROCESS_MEMORY_EXHAUSTION_TYPE_PMETypeFailFastOnCommitFailure:
    _PROCESS_MEMORY_EXHAUSTION_TYPE = 0;
pub const _PROCESS_MEMORY_EXHAUSTION_TYPE_PMETypeMax: _PROCESS_MEMORY_EXHAUSTION_TYPE = 1;
pub type _PROCESS_MEMORY_EXHAUSTION_TYPE = ::std::os::raw::c_int;
pub use self::_PROCESS_MEMORY_EXHAUSTION_TYPE as PROCESS_MEMORY_EXHAUSTION_TYPE;
pub type PPROCESS_MEMORY_EXHAUSTION_TYPE = *mut _PROCESS_MEMORY_EXHAUSTION_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_MEMORY_EXHAUSTION_INFO {
    pub Version: USHORT,
    pub Reserved: USHORT,
    pub Type: PROCESS_MEMORY_EXHAUSTION_TYPE,
    pub Value: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_MEMORY_EXHAUSTION_INFO"]
        [::std::mem::size_of::<_PROCESS_MEMORY_EXHAUSTION_INFO>() - 16usize];
    ["Alignment of _PROCESS_MEMORY_EXHAUSTION_INFO"]
        [::std::mem::align_of::<_PROCESS_MEMORY_EXHAUSTION_INFO>() - 8usize];
    ["Offset of field: _PROCESS_MEMORY_EXHAUSTION_INFO::Version"]
        [::std::mem::offset_of!(_PROCESS_MEMORY_EXHAUSTION_INFO, Version) - 0usize];
    ["Offset of field: _PROCESS_MEMORY_EXHAUSTION_INFO::Reserved"]
        [::std::mem::offset_of!(_PROCESS_MEMORY_EXHAUSTION_INFO, Reserved) - 2usize];
    ["Offset of field: _PROCESS_MEMORY_EXHAUSTION_INFO::Type"]
        [::std::mem::offset_of!(_PROCESS_MEMORY_EXHAUSTION_INFO, Type) - 4usize];
    ["Offset of field: _PROCESS_MEMORY_EXHAUSTION_INFO::Value"]
        [::std::mem::offset_of!(_PROCESS_MEMORY_EXHAUSTION_INFO, Value) - 8usize];
};
pub type PROCESS_MEMORY_EXHAUSTION_INFO = _PROCESS_MEMORY_EXHAUSTION_INFO;
pub type PPROCESS_MEMORY_EXHAUSTION_INFO = *mut _PROCESS_MEMORY_EXHAUSTION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_POWER_THROTTLING_STATE {
    pub Version: ULONG,
    pub ControlMask: ULONG,
    pub StateMask: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_POWER_THROTTLING_STATE"]
        [::std::mem::size_of::<_PROCESS_POWER_THROTTLING_STATE>() - 12usize];
    ["Alignment of _PROCESS_POWER_THROTTLING_STATE"]
        [::std::mem::align_of::<_PROCESS_POWER_THROTTLING_STATE>() - 4usize];
    ["Offset of field: _PROCESS_POWER_THROTTLING_STATE::Version"]
        [::std::mem::offset_of!(_PROCESS_POWER_THROTTLING_STATE, Version) - 0usize];
    ["Offset of field: _PROCESS_POWER_THROTTLING_STATE::ControlMask"]
        [::std::mem::offset_of!(_PROCESS_POWER_THROTTLING_STATE, ControlMask) - 4usize];
    ["Offset of field: _PROCESS_POWER_THROTTLING_STATE::StateMask"]
        [::std::mem::offset_of!(_PROCESS_POWER_THROTTLING_STATE, StateMask) - 8usize];
};
pub type PROCESS_POWER_THROTTLING_STATE = _PROCESS_POWER_THROTTLING_STATE;
pub type PPROCESS_POWER_THROTTLING_STATE = *mut _PROCESS_POWER_THROTTLING_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PROCESS_PROTECTION_LEVEL_INFORMATION {
    pub ProtectionLevel: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PROCESS_PROTECTION_LEVEL_INFORMATION"]
        [::std::mem::size_of::<PROCESS_PROTECTION_LEVEL_INFORMATION>() - 4usize];
    ["Alignment of PROCESS_PROTECTION_LEVEL_INFORMATION"]
        [::std::mem::align_of::<PROCESS_PROTECTION_LEVEL_INFORMATION>() - 4usize];
    ["Offset of field: PROCESS_PROTECTION_LEVEL_INFORMATION::ProtectionLevel"]
        [::std::mem::offset_of!(PROCESS_PROTECTION_LEVEL_INFORMATION, ProtectionLevel) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROCESS_LEAP_SECOND_INFO {
    pub Flags: ULONG,
    pub Reserved: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROCESS_LEAP_SECOND_INFO"]
        [::std::mem::size_of::<_PROCESS_LEAP_SECOND_INFO>() - 8usize];
    ["Alignment of _PROCESS_LEAP_SECOND_INFO"]
        [::std::mem::align_of::<_PROCESS_LEAP_SECOND_INFO>() - 4usize];
    ["Offset of field: _PROCESS_LEAP_SECOND_INFO::Flags"]
        [::std::mem::offset_of!(_PROCESS_LEAP_SECOND_INFO, Flags) - 0usize];
    ["Offset of field: _PROCESS_LEAP_SECOND_INFO::Reserved"]
        [::std::mem::offset_of!(_PROCESS_LEAP_SECOND_INFO, Reserved) - 4usize];
};
pub type PROCESS_LEAP_SECOND_INFO = _PROCESS_LEAP_SECOND_INFO;
pub type PPROCESS_LEAP_SECOND_INFO = *mut _PROCESS_LEAP_SECOND_INFO;
unsafe extern "C" {
    pub fn SetProcessInformation(
        hProcess: HANDLE,
        ProcessInformationClass: PROCESS_INFORMATION_CLASS,
        ProcessInformation: LPVOID,
        ProcessInformationSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessInformation(
        hProcess: HANDLE,
        ProcessInformationClass: PROCESS_INFORMATION_CLASS,
        ProcessInformation: LPVOID,
        ProcessInformationSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemCpuSetInformation(
        Information: PSYSTEM_CPU_SET_INFORMATION,
        BufferLength: ULONG,
        ReturnedLength: PULONG,
        Process: HANDLE,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessDefaultCpuSets(
        Process: HANDLE,
        CpuSetIds: PULONG,
        CpuSetIdCount: ULONG,
        RequiredIdCount: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDefaultCpuSets(
        Process: HANDLE,
        CpuSetIds: *const ULONG,
        CpuSetIdCount: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadSelectedCpuSets(
        Thread: HANDLE,
        CpuSetIds: PULONG,
        CpuSetIdCount: ULONG,
        RequiredIdCount: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadSelectedCpuSets(
        Thread: HANDLE,
        CpuSetIds: *const ULONG,
        CpuSetIdCount: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateProcessAsUserA(
        hToken: HANDLE,
        lpApplicationName: LPCSTR,
        lpCommandLine: LPSTR,
        lpProcessAttributes: LPSECURITY_ATTRIBUTES,
        lpThreadAttributes: LPSECURITY_ATTRIBUTES,
        bInheritHandles: BOOL,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCSTR,
        lpStartupInfo: LPSTARTUPINFOA,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessShutdownParameters(lpdwLevel: LPDWORD, lpdwFlags: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessDefaultCpuSetMasks(
        Process: HANDLE,
        CpuSetMasks: PGROUP_AFFINITY,
        CpuSetMaskCount: USHORT,
        RequiredMaskCount: PUSHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDefaultCpuSetMasks(
        Process: HANDLE,
        CpuSetMasks: PGROUP_AFFINITY,
        CpuSetMaskCount: USHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadSelectedCpuSetMasks(
        Thread: HANDLE,
        CpuSetMasks: PGROUP_AFFINITY,
        CpuSetMaskCount: USHORT,
        RequiredMaskCount: PUSHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadSelectedCpuSetMasks(
        Thread: HANDLE,
        CpuSetMasks: PGROUP_AFFINITY,
        CpuSetMaskCount: USHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMachineTypeAttributes(
        Machine: USHORT,
        MachineTypeAttributes: *mut MACHINE_ATTRIBUTES,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SetThreadDescription(hThread: HANDLE, lpThreadDescription: PCWSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetThreadDescription(hThread: HANDLE, ppszThreadDescription: *mut PWSTR) -> HRESULT;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SYSTEM_INFO {
    pub __bindgen_anon_1: _SYSTEM_INFO__bindgen_ty_1,
    pub dwPageSize: DWORD,
    pub lpMinimumApplicationAddress: LPVOID,
    pub lpMaximumApplicationAddress: LPVOID,
    pub dwActiveProcessorMask: DWORD_PTR,
    pub dwNumberOfProcessors: DWORD,
    pub dwProcessorType: DWORD,
    pub dwAllocationGranularity: DWORD,
    pub wProcessorLevel: WORD,
    pub wProcessorRevision: WORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SYSTEM_INFO__bindgen_ty_1 {
    pub dwOemId: DWORD,
    pub __bindgen_anon_1: _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub wProcessorArchitecture: WORD,
    pub wReserved: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1::wProcessorArchitecture"][::std::mem::offset_of!(
        _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1,
        wProcessorArchitecture
    )
        - 0usize];
    ["Offset of field: _SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1::wReserved"]
        [::std::mem::offset_of!(_SYSTEM_INFO__bindgen_ty_1__bindgen_ty_1, wReserved) - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_SYSTEM_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _SYSTEM_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_SYSTEM_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _SYSTEM_INFO__bindgen_ty_1::dwOemId"]
        [::std::mem::offset_of!(_SYSTEM_INFO__bindgen_ty_1, dwOemId) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_INFO"][::std::mem::size_of::<_SYSTEM_INFO>() - 48usize];
    ["Alignment of _SYSTEM_INFO"][::std::mem::align_of::<_SYSTEM_INFO>() - 8usize];
    ["Offset of field: _SYSTEM_INFO::dwPageSize"]
        [::std::mem::offset_of!(_SYSTEM_INFO, dwPageSize) - 4usize];
    ["Offset of field: _SYSTEM_INFO::lpMinimumApplicationAddress"]
        [::std::mem::offset_of!(_SYSTEM_INFO, lpMinimumApplicationAddress) - 8usize];
    ["Offset of field: _SYSTEM_INFO::lpMaximumApplicationAddress"]
        [::std::mem::offset_of!(_SYSTEM_INFO, lpMaximumApplicationAddress) - 16usize];
    ["Offset of field: _SYSTEM_INFO::dwActiveProcessorMask"]
        [::std::mem::offset_of!(_SYSTEM_INFO, dwActiveProcessorMask) - 24usize];
    ["Offset of field: _SYSTEM_INFO::dwNumberOfProcessors"]
        [::std::mem::offset_of!(_SYSTEM_INFO, dwNumberOfProcessors) - 32usize];
    ["Offset of field: _SYSTEM_INFO::dwProcessorType"]
        [::std::mem::offset_of!(_SYSTEM_INFO, dwProcessorType) - 36usize];
    ["Offset of field: _SYSTEM_INFO::dwAllocationGranularity"]
        [::std::mem::offset_of!(_SYSTEM_INFO, dwAllocationGranularity) - 40usize];
    ["Offset of field: _SYSTEM_INFO::wProcessorLevel"]
        [::std::mem::offset_of!(_SYSTEM_INFO, wProcessorLevel) - 44usize];
    ["Offset of field: _SYSTEM_INFO::wProcessorRevision"]
        [::std::mem::offset_of!(_SYSTEM_INFO, wProcessorRevision) - 46usize];
};
pub type SYSTEM_INFO = _SYSTEM_INFO;
pub type LPSYSTEM_INFO = *mut _SYSTEM_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORYSTATUSEX {
    pub dwLength: DWORD,
    pub dwMemoryLoad: DWORD,
    pub ullTotalPhys: DWORDLONG,
    pub ullAvailPhys: DWORDLONG,
    pub ullTotalPageFile: DWORDLONG,
    pub ullAvailPageFile: DWORDLONG,
    pub ullTotalVirtual: DWORDLONG,
    pub ullAvailVirtual: DWORDLONG,
    pub ullAvailExtendedVirtual: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORYSTATUSEX"][::std::mem::size_of::<_MEMORYSTATUSEX>() - 64usize];
    ["Alignment of _MEMORYSTATUSEX"][::std::mem::align_of::<_MEMORYSTATUSEX>() - 8usize];
    ["Offset of field: _MEMORYSTATUSEX::dwLength"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, dwLength) - 0usize];
    ["Offset of field: _MEMORYSTATUSEX::dwMemoryLoad"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, dwMemoryLoad) - 4usize];
    ["Offset of field: _MEMORYSTATUSEX::ullTotalPhys"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullTotalPhys) - 8usize];
    ["Offset of field: _MEMORYSTATUSEX::ullAvailPhys"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullAvailPhys) - 16usize];
    ["Offset of field: _MEMORYSTATUSEX::ullTotalPageFile"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullTotalPageFile) - 24usize];
    ["Offset of field: _MEMORYSTATUSEX::ullAvailPageFile"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullAvailPageFile) - 32usize];
    ["Offset of field: _MEMORYSTATUSEX::ullTotalVirtual"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullTotalVirtual) - 40usize];
    ["Offset of field: _MEMORYSTATUSEX::ullAvailVirtual"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullAvailVirtual) - 48usize];
    ["Offset of field: _MEMORYSTATUSEX::ullAvailExtendedVirtual"]
        [::std::mem::offset_of!(_MEMORYSTATUSEX, ullAvailExtendedVirtual) - 56usize];
};
pub type MEMORYSTATUSEX = _MEMORYSTATUSEX;
pub type LPMEMORYSTATUSEX = *mut _MEMORYSTATUSEX;
unsafe extern "C" {
    pub fn GlobalMemoryStatusEx(lpBuffer: LPMEMORYSTATUSEX) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemInfo(lpSystemInfo: LPSYSTEM_INFO);
}
unsafe extern "C" {
    pub fn GetSystemTime(lpSystemTime: LPSYSTEMTIME);
}
unsafe extern "C" {
    pub fn GetSystemTimeAsFileTime(lpSystemTimeAsFileTime: LPFILETIME);
}
unsafe extern "C" {
    pub fn GetLocalTime(lpSystemTime: LPSYSTEMTIME);
}
unsafe extern "C" {
    pub fn IsUserCetAvailableInEnvironment(UserCetEnvironment: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemLeapSecondInformation(Enabled: PBOOL, Flags: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVersion() -> DWORD;
}
unsafe extern "C" {
    pub fn SetLocalTime(lpSystemTime: *const SYSTEMTIME) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTickCount() -> DWORD;
}
unsafe extern "C" {
    pub fn GetTickCount64() -> ULONGLONG;
}
unsafe extern "C" {
    pub fn GetSystemTimeAdjustment(
        lpTimeAdjustment: PDWORD,
        lpTimeIncrement: PDWORD,
        lpTimeAdjustmentDisabled: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemTimeAdjustmentPrecise(
        lpTimeAdjustment: PDWORD64,
        lpTimeIncrement: PDWORD64,
        lpTimeAdjustmentDisabled: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemDirectoryA(lpBuffer: LPSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemDirectoryW(lpBuffer: LPWSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetWindowsDirectoryA(lpBuffer: LPSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetWindowsDirectoryW(lpBuffer: LPWSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemWindowsDirectoryA(lpBuffer: LPSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemWindowsDirectoryW(lpBuffer: LPWSTR, uSize: UINT) -> UINT;
}
pub const _COMPUTER_NAME_FORMAT_ComputerNameNetBIOS: _COMPUTER_NAME_FORMAT = 0;
pub const _COMPUTER_NAME_FORMAT_ComputerNameDnsHostname: _COMPUTER_NAME_FORMAT = 1;
pub const _COMPUTER_NAME_FORMAT_ComputerNameDnsDomain: _COMPUTER_NAME_FORMAT = 2;
pub const _COMPUTER_NAME_FORMAT_ComputerNameDnsFullyQualified: _COMPUTER_NAME_FORMAT = 3;
pub const _COMPUTER_NAME_FORMAT_ComputerNamePhysicalNetBIOS: _COMPUTER_NAME_FORMAT = 4;
pub const _COMPUTER_NAME_FORMAT_ComputerNamePhysicalDnsHostname: _COMPUTER_NAME_FORMAT = 5;
pub const _COMPUTER_NAME_FORMAT_ComputerNamePhysicalDnsDomain: _COMPUTER_NAME_FORMAT = 6;
pub const _COMPUTER_NAME_FORMAT_ComputerNamePhysicalDnsFullyQualified: _COMPUTER_NAME_FORMAT = 7;
pub const _COMPUTER_NAME_FORMAT_ComputerNameMax: _COMPUTER_NAME_FORMAT = 8;
pub type _COMPUTER_NAME_FORMAT = ::std::os::raw::c_int;
pub use self::_COMPUTER_NAME_FORMAT as COMPUTER_NAME_FORMAT;
unsafe extern "C" {
    pub fn GetComputerNameExA(
        NameType: COMPUTER_NAME_FORMAT,
        lpBuffer: LPSTR,
        nSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetComputerNameExW(
        NameType: COMPUTER_NAME_FORMAT,
        lpBuffer: LPWSTR,
        nSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetComputerNameExW(NameType: COMPUTER_NAME_FORMAT, lpBuffer: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemTime(lpSystemTime: *const SYSTEMTIME) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVersionExA(lpVersionInformation: LPOSVERSIONINFOA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVersionExW(lpVersionInformation: LPOSVERSIONINFOW) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLogicalProcessorInformation(
        Buffer: PSYSTEM_LOGICAL_PROCESSOR_INFORMATION,
        ReturnedLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLogicalProcessorInformationEx(
        RelationshipType: LOGICAL_PROCESSOR_RELATIONSHIP,
        Buffer: PSYSTEM_LOGICAL_PROCESSOR_INFORMATION_EX,
        ReturnedLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNativeSystemInfo(lpSystemInfo: LPSYSTEM_INFO);
}
unsafe extern "C" {
    pub fn GetSystemTimePreciseAsFileTime(lpSystemTimeAsFileTime: LPFILETIME);
}
unsafe extern "C" {
    pub fn GetProductInfo(
        dwOSMajorVersion: DWORD,
        dwOSMinorVersion: DWORD,
        dwSpMajorVersion: DWORD,
        dwSpMinorVersion: DWORD,
        pdwReturnedProductType: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOsSafeBootMode(Flags: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemFirmwareTables(
        FirmwareTableProviderSignature: DWORD,
        pFirmwareTableEnumBuffer: PVOID,
        BufferSize: DWORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemFirmwareTable(
        FirmwareTableProviderSignature: DWORD,
        FirmwareTableID: DWORD,
        pFirmwareTableBuffer: PVOID,
        BufferSize: DWORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn DnsHostnameToComputerNameExW(
        Hostname: LPCWSTR,
        ComputerName: LPWSTR,
        nSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPhysicallyInstalledSystemMemory(TotalMemoryInKilobytes: PULONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn SetComputerNameEx2W(
        NameType: COMPUTER_NAME_FORMAT,
        Flags: DWORD,
        lpBuffer: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemTimeAdjustment(dwTimeAdjustment: DWORD, bTimeAdjustmentDisabled: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemTimeAdjustmentPrecise(
        dwTimeAdjustment: DWORD64,
        bTimeAdjustmentDisabled: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InstallELAMCertificateInfo(ELAMFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessorSystemCycleTime(
        Group: USHORT,
        Buffer: PSYSTEM_PROCESSOR_CYCLE_TIME_INFORMATION,
        ReturnedLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOsManufacturingMode(pbEnabled: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetIntegratedDisplaySize(sizeInInches: *mut f64) -> HRESULT;
}
unsafe extern "C" {
    pub fn SetComputerNameA(lpComputerName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetComputerNameW(lpComputerName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetComputerNameExA(NameType: COMPUTER_NAME_FORMAT, lpBuffer: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualAlloc(
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        flAllocationType: DWORD,
        flProtect: DWORD,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn VirtualProtect(
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        flNewProtect: DWORD,
        lpflOldProtect: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualFree(lpAddress: LPVOID, dwSize: SIZE_T, dwFreeType: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualQuery(
        lpAddress: LPCVOID,
        lpBuffer: PMEMORY_BASIC_INFORMATION,
        dwLength: SIZE_T,
    ) -> SIZE_T;
}
unsafe extern "C" {
    pub fn VirtualAllocEx(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        flAllocationType: DWORD,
        flProtect: DWORD,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn VirtualProtectEx(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        flNewProtect: DWORD,
        lpflOldProtect: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualQueryEx(
        hProcess: HANDLE,
        lpAddress: LPCVOID,
        lpBuffer: PMEMORY_BASIC_INFORMATION,
        dwLength: SIZE_T,
    ) -> SIZE_T;
}
unsafe extern "C" {
    pub fn ReadProcessMemory(
        hProcess: HANDLE,
        lpBaseAddress: LPCVOID,
        lpBuffer: LPVOID,
        nSize: SIZE_T,
        lpNumberOfBytesRead: *mut SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteProcessMemory(
        hProcess: HANDLE,
        lpBaseAddress: LPVOID,
        lpBuffer: LPCVOID,
        nSize: SIZE_T,
        lpNumberOfBytesWritten: *mut SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFileMappingW(
        hFile: HANDLE,
        lpFileMappingAttributes: LPSECURITY_ATTRIBUTES,
        flProtect: DWORD,
        dwMaximumSizeHigh: DWORD,
        dwMaximumSizeLow: DWORD,
        lpName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenFileMappingW(
        dwDesiredAccess: DWORD,
        bInheritHandle: BOOL,
        lpName: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn MapViewOfFile(
        hFileMappingObject: HANDLE,
        dwDesiredAccess: DWORD,
        dwFileOffsetHigh: DWORD,
        dwFileOffsetLow: DWORD,
        dwNumberOfBytesToMap: SIZE_T,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn MapViewOfFileEx(
        hFileMappingObject: HANDLE,
        dwDesiredAccess: DWORD,
        dwFileOffsetHigh: DWORD,
        dwFileOffsetLow: DWORD,
        dwNumberOfBytesToMap: SIZE_T,
        lpBaseAddress: LPVOID,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn VirtualFreeEx(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        dwFreeType: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FlushViewOfFile(lpBaseAddress: LPCVOID, dwNumberOfBytesToFlush: SIZE_T) -> BOOL;
}
unsafe extern "C" {
    pub fn UnmapViewOfFile(lpBaseAddress: LPCVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLargePageMinimum() -> SIZE_T;
}
unsafe extern "C" {
    pub fn GetProcessWorkingSetSize(
        hProcess: HANDLE,
        lpMinimumWorkingSetSize: PSIZE_T,
        lpMaximumWorkingSetSize: PSIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessWorkingSetSizeEx(
        hProcess: HANDLE,
        lpMinimumWorkingSetSize: PSIZE_T,
        lpMaximumWorkingSetSize: PSIZE_T,
        Flags: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessWorkingSetSize(
        hProcess: HANDLE,
        dwMinimumWorkingSetSize: SIZE_T,
        dwMaximumWorkingSetSize: SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessWorkingSetSizeEx(
        hProcess: HANDLE,
        dwMinimumWorkingSetSize: SIZE_T,
        dwMaximumWorkingSetSize: SIZE_T,
        Flags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualLock(lpAddress: LPVOID, dwSize: SIZE_T) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualUnlock(lpAddress: LPVOID, dwSize: SIZE_T) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWriteWatch(
        dwFlags: DWORD,
        lpBaseAddress: PVOID,
        dwRegionSize: SIZE_T,
        lpAddresses: *mut PVOID,
        lpdwCount: *mut ULONG_PTR,
        lpdwGranularity: LPDWORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn ResetWriteWatch(lpBaseAddress: LPVOID, dwRegionSize: SIZE_T) -> UINT;
}
pub const _MEMORY_RESOURCE_NOTIFICATION_TYPE_LowMemoryResourceNotification:
    _MEMORY_RESOURCE_NOTIFICATION_TYPE = 0;
pub const _MEMORY_RESOURCE_NOTIFICATION_TYPE_HighMemoryResourceNotification:
    _MEMORY_RESOURCE_NOTIFICATION_TYPE = 1;
pub type _MEMORY_RESOURCE_NOTIFICATION_TYPE = ::std::os::raw::c_int;
pub use self::_MEMORY_RESOURCE_NOTIFICATION_TYPE as MEMORY_RESOURCE_NOTIFICATION_TYPE;
unsafe extern "C" {
    pub fn CreateMemoryResourceNotification(
        NotificationType: MEMORY_RESOURCE_NOTIFICATION_TYPE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn QueryMemoryResourceNotification(
        ResourceNotificationHandle: HANDLE,
        ResourceState: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemFileCacheSize(
        lpMinimumFileCacheSize: PSIZE_T,
        lpMaximumFileCacheSize: PSIZE_T,
        lpFlags: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemFileCacheSize(
        MinimumFileCacheSize: SIZE_T,
        MaximumFileCacheSize: SIZE_T,
        Flags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFileMappingNumaW(
        hFile: HANDLE,
        lpFileMappingAttributes: LPSECURITY_ATTRIBUTES,
        flProtect: DWORD,
        dwMaximumSizeHigh: DWORD,
        dwMaximumSizeLow: DWORD,
        lpName: LPCWSTR,
        nndPreferred: DWORD,
    ) -> HANDLE;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WIN32_MEMORY_RANGE_ENTRY {
    pub VirtualAddress: PVOID,
    pub NumberOfBytes: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_MEMORY_RANGE_ENTRY"]
        [::std::mem::size_of::<_WIN32_MEMORY_RANGE_ENTRY>() - 16usize];
    ["Alignment of _WIN32_MEMORY_RANGE_ENTRY"]
        [::std::mem::align_of::<_WIN32_MEMORY_RANGE_ENTRY>() - 8usize];
    ["Offset of field: _WIN32_MEMORY_RANGE_ENTRY::VirtualAddress"]
        [::std::mem::offset_of!(_WIN32_MEMORY_RANGE_ENTRY, VirtualAddress) - 0usize];
    ["Offset of field: _WIN32_MEMORY_RANGE_ENTRY::NumberOfBytes"]
        [::std::mem::offset_of!(_WIN32_MEMORY_RANGE_ENTRY, NumberOfBytes) - 8usize];
};
pub type WIN32_MEMORY_RANGE_ENTRY = _WIN32_MEMORY_RANGE_ENTRY;
pub type PWIN32_MEMORY_RANGE_ENTRY = *mut _WIN32_MEMORY_RANGE_ENTRY;
unsafe extern "C" {
    pub fn PrefetchVirtualMemory(
        hProcess: HANDLE,
        NumberOfEntries: ULONG_PTR,
        VirtualAddresses: PWIN32_MEMORY_RANGE_ENTRY,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFileMappingFromApp(
        hFile: HANDLE,
        SecurityAttributes: PSECURITY_ATTRIBUTES,
        PageProtection: ULONG,
        MaximumSize: ULONG64,
        Name: PCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn MapViewOfFileFromApp(
        hFileMappingObject: HANDLE,
        DesiredAccess: ULONG,
        FileOffset: ULONG64,
        NumberOfBytesToMap: SIZE_T,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn UnmapViewOfFileEx(BaseAddress: PVOID, UnmapFlags: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn AllocateUserPhysicalPages(
        hProcess: HANDLE,
        NumberOfPages: PULONG_PTR,
        PageArray: PULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FreeUserPhysicalPages(
        hProcess: HANDLE,
        NumberOfPages: PULONG_PTR,
        PageArray: PULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MapUserPhysicalPages(
        VirtualAddress: PVOID,
        NumberOfPages: ULONG_PTR,
        PageArray: PULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AllocateUserPhysicalPagesNuma(
        hProcess: HANDLE,
        NumberOfPages: PULONG_PTR,
        PageArray: PULONG_PTR,
        nndPreferred: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualAllocExNuma(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        flAllocationType: DWORD,
        flProtect: DWORD,
        nndPreferred: DWORD,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn GetMemoryErrorHandlingCapabilities(Capabilities: PULONG) -> BOOL;
}
pub type PBAD_MEMORY_CALLBACK_ROUTINE = ::std::option::Option<unsafe extern "C" fn()>;
unsafe extern "C" {
    pub fn RegisterBadMemoryNotification(Callback: PBAD_MEMORY_CALLBACK_ROUTINE) -> PVOID;
}
unsafe extern "C" {
    pub fn UnregisterBadMemoryNotification(RegistrationHandle: PVOID) -> BOOL;
}
pub const OFFER_PRIORITY_VmOfferPriorityVeryLow: OFFER_PRIORITY = 1;
pub const OFFER_PRIORITY_VmOfferPriorityLow: OFFER_PRIORITY = 2;
pub const OFFER_PRIORITY_VmOfferPriorityBelowNormal: OFFER_PRIORITY = 3;
pub const OFFER_PRIORITY_VmOfferPriorityNormal: OFFER_PRIORITY = 4;
pub type OFFER_PRIORITY = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn OfferVirtualMemory(
        VirtualAddress: PVOID,
        Size: SIZE_T,
        Priority: OFFER_PRIORITY,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ReclaimVirtualMemory(
        VirtualAddress: *const ::std::os::raw::c_void,
        Size: SIZE_T,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DiscardVirtualMemory(VirtualAddress: PVOID, Size: SIZE_T) -> DWORD;
}
unsafe extern "C" {
    pub fn SetProcessValidCallTargets(
        hProcess: HANDLE,
        VirtualAddress: PVOID,
        RegionSize: SIZE_T,
        NumberOfOffsets: ULONG,
        OffsetInformation: PCFG_CALL_TARGET_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessValidCallTargetsForMappedView(
        Process: HANDLE,
        VirtualAddress: PVOID,
        RegionSize: SIZE_T,
        NumberOfOffsets: ULONG,
        OffsetInformation: PCFG_CALL_TARGET_INFO,
        Section: HANDLE,
        ExpectedFileOffset: ULONG64,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualAllocFromApp(
        BaseAddress: PVOID,
        Size: SIZE_T,
        AllocationType: ULONG,
        Protection: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn VirtualProtectFromApp(
        Address: PVOID,
        Size: SIZE_T,
        NewProtection: ULONG,
        OldProtection: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenFileMappingFromApp(
        DesiredAccess: ULONG,
        InheritHandle: BOOL,
        Name: PCWSTR,
    ) -> HANDLE;
}
pub const WIN32_MEMORY_INFORMATION_CLASS_MemoryRegionInfo: WIN32_MEMORY_INFORMATION_CLASS = 0;
pub type WIN32_MEMORY_INFORMATION_CLASS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct WIN32_MEMORY_REGION_INFORMATION {
    pub AllocationBase: PVOID,
    pub AllocationProtect: ULONG,
    pub __bindgen_anon_1: WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1,
    pub RegionSize: SIZE_T,
    pub CommitSize: SIZE_T,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1 {
    pub Flags: ULONG,
    pub __bindgen_anon_1: WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn Private(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Private(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Private_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Private_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MappedDataFile(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MappedDataFile(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MappedDataFile_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MappedDataFile_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MappedImage(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MappedImage(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MappedImage_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MappedImage_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MappedPageFile(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MappedPageFile(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MappedPageFile_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MappedPageFile_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MappedPhysical(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_MappedPhysical(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MappedPhysical_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_MappedPhysical_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DirectMapped(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DirectMapped(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DirectMapped_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DirectMapped_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 26u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 26u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                26u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                26u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        Private: ULONG,
        MappedDataFile: ULONG,
        MappedImage: ULONG,
        MappedPageFile: ULONG,
        MappedPhysical: ULONG,
        DirectMapped: ULONG,
        Reserved: ULONG,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let Private: u32 = unsafe { ::std::mem::transmute(Private) };
            Private as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let MappedDataFile: u32 = unsafe { ::std::mem::transmute(MappedDataFile) };
            MappedDataFile as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let MappedImage: u32 = unsafe { ::std::mem::transmute(MappedImage) };
            MappedImage as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let MappedPageFile: u32 = unsafe { ::std::mem::transmute(MappedPageFile) };
            MappedPageFile as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let MappedPhysical: u32 = unsafe { ::std::mem::transmute(MappedPhysical) };
            MappedPhysical as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let DirectMapped: u32 = unsafe { ::std::mem::transmute(DirectMapped) };
            DirectMapped as u64
        });
        __bindgen_bitfield_unit.set(6usize, 26u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Alignment of WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Offset of field: WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(WIN32_MEMORY_REGION_INFORMATION__bindgen_ty_1, Flags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of WIN32_MEMORY_REGION_INFORMATION"]
        [::std::mem::size_of::<WIN32_MEMORY_REGION_INFORMATION>() - 32usize];
    ["Alignment of WIN32_MEMORY_REGION_INFORMATION"]
        [::std::mem::align_of::<WIN32_MEMORY_REGION_INFORMATION>() - 8usize];
    ["Offset of field: WIN32_MEMORY_REGION_INFORMATION::AllocationBase"]
        [::std::mem::offset_of!(WIN32_MEMORY_REGION_INFORMATION, AllocationBase) - 0usize];
    ["Offset of field: WIN32_MEMORY_REGION_INFORMATION::AllocationProtect"]
        [::std::mem::offset_of!(WIN32_MEMORY_REGION_INFORMATION, AllocationProtect) - 8usize];
    ["Offset of field: WIN32_MEMORY_REGION_INFORMATION::RegionSize"]
        [::std::mem::offset_of!(WIN32_MEMORY_REGION_INFORMATION, RegionSize) - 16usize];
    ["Offset of field: WIN32_MEMORY_REGION_INFORMATION::CommitSize"]
        [::std::mem::offset_of!(WIN32_MEMORY_REGION_INFORMATION, CommitSize) - 24usize];
};
unsafe extern "C" {
    pub fn QueryVirtualMemoryInformation(
        Process: HANDLE,
        VirtualAddress: *const ::std::os::raw::c_void,
        MemoryInformationClass: WIN32_MEMORY_INFORMATION_CLASS,
        MemoryInformation: PVOID,
        MemoryInformationSize: SIZE_T,
        ReturnSize: PSIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MapViewOfFileNuma2(
        FileMappingHandle: HANDLE,
        ProcessHandle: HANDLE,
        Offset: ULONG64,
        BaseAddress: PVOID,
        ViewSize: SIZE_T,
        AllocationType: ULONG,
        PageProtection: ULONG,
        PreferredNode: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn UnmapViewOfFile2(Process: HANDLE, BaseAddress: PVOID, UnmapFlags: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualUnlockEx(Process: HANDLE, Address: LPVOID, Size: SIZE_T) -> BOOL;
}
unsafe extern "C" {
    pub fn VirtualAlloc2(
        Process: HANDLE,
        BaseAddress: PVOID,
        Size: SIZE_T,
        AllocationType: ULONG,
        PageProtection: ULONG,
        ExtendedParameters: *mut MEM_EXTENDED_PARAMETER,
        ParameterCount: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn MapViewOfFile3(
        FileMapping: HANDLE,
        Process: HANDLE,
        BaseAddress: PVOID,
        Offset: ULONG64,
        ViewSize: SIZE_T,
        AllocationType: ULONG,
        PageProtection: ULONG,
        ExtendedParameters: *mut MEM_EXTENDED_PARAMETER,
        ParameterCount: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn VirtualAlloc2FromApp(
        Process: HANDLE,
        BaseAddress: PVOID,
        Size: SIZE_T,
        AllocationType: ULONG,
        PageProtection: ULONG,
        ExtendedParameters: *mut MEM_EXTENDED_PARAMETER,
        ParameterCount: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn MapViewOfFile3FromApp(
        FileMapping: HANDLE,
        Process: HANDLE,
        BaseAddress: PVOID,
        Offset: ULONG64,
        ViewSize: SIZE_T,
        AllocationType: ULONG,
        PageProtection: ULONG,
        ExtendedParameters: *mut MEM_EXTENDED_PARAMETER,
        ParameterCount: ULONG,
    ) -> PVOID;
}
unsafe extern "C" {
    pub fn CreateFileMapping2(
        File: HANDLE,
        SecurityAttributes: *mut SECURITY_ATTRIBUTES,
        DesiredAccess: ULONG,
        PageProtection: ULONG,
        AllocationAttributes: ULONG,
        MaximumSize: ULONG64,
        Name: PCWSTR,
        ExtendedParameters: *mut MEM_EXTENDED_PARAMETER,
        ParameterCount: ULONG,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn AllocateUserPhysicalPages2(
        ObjectHandle: HANDLE,
        NumberOfPages: PULONG_PTR,
        PageArray: PULONG_PTR,
        ExtendedParameters: PMEM_EXTENDED_PARAMETER,
        ExtendedParameterCount: ULONG,
    ) -> BOOL;
}
pub const WIN32_MEMORY_PARTITION_INFORMATION_CLASS_MemoryPartitionInfo:
    WIN32_MEMORY_PARTITION_INFORMATION_CLASS = 0;
pub const WIN32_MEMORY_PARTITION_INFORMATION_CLASS_MemoryPartitionDedicatedMemoryInfo:
    WIN32_MEMORY_PARTITION_INFORMATION_CLASS = 1;
pub type WIN32_MEMORY_PARTITION_INFORMATION_CLASS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct WIN32_MEMORY_PARTITION_INFORMATION {
    pub Flags: ULONG,
    pub NumaNode: ULONG,
    pub Channel: ULONG,
    pub NumberOfNumaNodes: ULONG,
    pub ResidentAvailablePages: ULONG64,
    pub CommittedPages: ULONG64,
    pub CommitLimit: ULONG64,
    pub PeakCommitment: ULONG64,
    pub TotalNumberOfPages: ULONG64,
    pub AvailablePages: ULONG64,
    pub ZeroPages: ULONG64,
    pub FreePages: ULONG64,
    pub StandbyPages: ULONG64,
    pub Reserved: [ULONG64; 16usize],
    pub MaximumCommitLimit: ULONG64,
    pub Reserved2: ULONG64,
    pub PartitionId: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of WIN32_MEMORY_PARTITION_INFORMATION"]
        [::std::mem::size_of::<WIN32_MEMORY_PARTITION_INFORMATION>() - 240usize];
    ["Alignment of WIN32_MEMORY_PARTITION_INFORMATION"]
        [::std::mem::align_of::<WIN32_MEMORY_PARTITION_INFORMATION>() - 8usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::Flags"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, Flags) - 0usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::NumaNode"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, NumaNode) - 4usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::Channel"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, Channel) - 8usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::NumberOfNumaNodes"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, NumberOfNumaNodes) - 12usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::ResidentAvailablePages"][::std::mem::offset_of!(
        WIN32_MEMORY_PARTITION_INFORMATION,
        ResidentAvailablePages
    ) - 16usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::CommittedPages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, CommittedPages) - 24usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::CommitLimit"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, CommitLimit) - 32usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::PeakCommitment"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, PeakCommitment) - 40usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::TotalNumberOfPages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, TotalNumberOfPages) - 48usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::AvailablePages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, AvailablePages) - 56usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::ZeroPages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, ZeroPages) - 64usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::FreePages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, FreePages) - 72usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::StandbyPages"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, StandbyPages) - 80usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::Reserved"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, Reserved) - 88usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::MaximumCommitLimit"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, MaximumCommitLimit) - 216usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::Reserved2"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, Reserved2) - 224usize];
    ["Offset of field: WIN32_MEMORY_PARTITION_INFORMATION::PartitionId"]
        [::std::mem::offset_of!(WIN32_MEMORY_PARTITION_INFORMATION, PartitionId) - 232usize];
};
unsafe extern "C" {
    pub fn OpenDedicatedMemoryPartition(
        Partition: HANDLE,
        DedicatedMemoryTypeId: ULONG64,
        DesiredAccess: ACCESS_MASK,
        InheritHandle: BOOL,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn QueryPartitionInformation(
        Partition: HANDLE,
        PartitionInformationClass: WIN32_MEMORY_PARTITION_INFORMATION_CLASS,
        PartitionInformation: PVOID,
        PartitionInformationLength: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsEnclaveTypeSupported(flEnclaveType: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateEnclave(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        dwSize: SIZE_T,
        dwInitialCommitment: SIZE_T,
        flEnclaveType: DWORD,
        lpEnclaveInformation: LPCVOID,
        dwInfoLength: DWORD,
        lpEnclaveError: LPDWORD,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn LoadEnclaveData(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        lpBuffer: LPCVOID,
        nSize: SIZE_T,
        flProtect: DWORD,
        lpPageInformation: LPCVOID,
        dwInfoLength: DWORD,
        lpNumberOfBytesWritten: PSIZE_T,
        lpEnclaveError: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeEnclave(
        hProcess: HANDLE,
        lpAddress: LPVOID,
        lpEnclaveInformation: LPCVOID,
        dwInfoLength: DWORD,
        lpEnclaveError: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LoadEnclaveImageA(lpEnclaveAddress: LPVOID, lpImageName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn LoadEnclaveImageW(lpEnclaveAddress: LPVOID, lpImageName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn CallEnclave(
        lpRoutine: LPENCLAVE_ROUTINE,
        lpParameter: LPVOID,
        fWaitForThread: BOOL,
        lpReturnValue: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TerminateEnclave(lpAddress: LPVOID, fWait: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteEnclave(lpAddress: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn QueueUserWorkItem(
        Function: LPTHREAD_START_ROUTINE,
        Context: PVOID,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterWaitEx(WaitHandle: HANDLE, CompletionEvent: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateTimerQueue() -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateTimerQueueTimer(
        phNewTimer: PHANDLE,
        TimerQueue: HANDLE,
        Callback: WAITORTIMERCALLBACK,
        Parameter: PVOID,
        DueTime: DWORD,
        Period: DWORD,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeTimerQueueTimer(
        TimerQueue: HANDLE,
        Timer: HANDLE,
        DueTime: ULONG,
        Period: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteTimerQueueTimer(
        TimerQueue: HANDLE,
        Timer: HANDLE,
        CompletionEvent: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteTimerQueue(TimerQueue: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteTimerQueueEx(TimerQueue: HANDLE, CompletionEvent: HANDLE) -> BOOL;
}
pub type PTP_WIN32_IO_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        Instance: PTP_CALLBACK_INSTANCE,
        Context: PVOID,
        Overlapped: PVOID,
        IoResult: ULONG,
        NumberOfBytesTransferred: ULONG_PTR,
        Io: PTP_IO,
    ),
>;
unsafe extern "C" {
    pub fn CreateThreadpool(reserved: PVOID) -> PTP_POOL;
}
unsafe extern "C" {
    pub fn SetThreadpoolThreadMaximum(ptpp: PTP_POOL, cthrdMost: DWORD);
}
unsafe extern "C" {
    pub fn SetThreadpoolThreadMinimum(ptpp: PTP_POOL, cthrdMic: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadpoolStackInformation(ptpp: PTP_POOL, ptpsi: PTP_POOL_STACK_INFORMATION)
        -> BOOL;
}
unsafe extern "C" {
    pub fn QueryThreadpoolStackInformation(
        ptpp: PTP_POOL,
        ptpsi: PTP_POOL_STACK_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseThreadpool(ptpp: PTP_POOL);
}
unsafe extern "C" {
    pub fn CreateThreadpoolCleanupGroup() -> PTP_CLEANUP_GROUP;
}
unsafe extern "C" {
    pub fn CloseThreadpoolCleanupGroupMembers(
        ptpcg: PTP_CLEANUP_GROUP,
        fCancelPendingCallbacks: BOOL,
        pvCleanupContext: PVOID,
    );
}
unsafe extern "C" {
    pub fn CloseThreadpoolCleanupGroup(ptpcg: PTP_CLEANUP_GROUP);
}
unsafe extern "C" {
    pub fn SetEventWhenCallbackReturns(pci: PTP_CALLBACK_INSTANCE, evt: HANDLE);
}
unsafe extern "C" {
    pub fn ReleaseSemaphoreWhenCallbackReturns(
        pci: PTP_CALLBACK_INSTANCE,
        sem: HANDLE,
        crel: DWORD,
    );
}
unsafe extern "C" {
    pub fn ReleaseMutexWhenCallbackReturns(pci: PTP_CALLBACK_INSTANCE, mut_: HANDLE);
}
unsafe extern "C" {
    pub fn LeaveCriticalSectionWhenCallbackReturns(
        pci: PTP_CALLBACK_INSTANCE,
        pcs: PCRITICAL_SECTION,
    );
}
unsafe extern "C" {
    pub fn FreeLibraryWhenCallbackReturns(pci: PTP_CALLBACK_INSTANCE, mod_: HMODULE);
}
unsafe extern "C" {
    pub fn CallbackMayRunLong(pci: PTP_CALLBACK_INSTANCE) -> BOOL;
}
unsafe extern "C" {
    pub fn DisassociateCurrentThreadFromCallback(pci: PTP_CALLBACK_INSTANCE);
}
unsafe extern "C" {
    pub fn TrySubmitThreadpoolCallback(
        pfns: PTP_SIMPLE_CALLBACK,
        pv: PVOID,
        pcbe: PTP_CALLBACK_ENVIRON,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateThreadpoolWork(
        pfnwk: PTP_WORK_CALLBACK,
        pv: PVOID,
        pcbe: PTP_CALLBACK_ENVIRON,
    ) -> PTP_WORK;
}
unsafe extern "C" {
    pub fn SubmitThreadpoolWork(pwk: PTP_WORK);
}
unsafe extern "C" {
    pub fn WaitForThreadpoolWorkCallbacks(pwk: PTP_WORK, fCancelPendingCallbacks: BOOL);
}
unsafe extern "C" {
    pub fn CloseThreadpoolWork(pwk: PTP_WORK);
}
unsafe extern "C" {
    pub fn CreateThreadpoolTimer(
        pfnti: PTP_TIMER_CALLBACK,
        pv: PVOID,
        pcbe: PTP_CALLBACK_ENVIRON,
    ) -> PTP_TIMER;
}
unsafe extern "C" {
    pub fn SetThreadpoolTimer(
        pti: PTP_TIMER,
        pftDueTime: PFILETIME,
        msPeriod: DWORD,
        msWindowLength: DWORD,
    );
}
unsafe extern "C" {
    pub fn IsThreadpoolTimerSet(pti: PTP_TIMER) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitForThreadpoolTimerCallbacks(pti: PTP_TIMER, fCancelPendingCallbacks: BOOL);
}
unsafe extern "C" {
    pub fn CloseThreadpoolTimer(pti: PTP_TIMER);
}
unsafe extern "C" {
    pub fn CreateThreadpoolWait(
        pfnwa: PTP_WAIT_CALLBACK,
        pv: PVOID,
        pcbe: PTP_CALLBACK_ENVIRON,
    ) -> PTP_WAIT;
}
unsafe extern "C" {
    pub fn SetThreadpoolWait(pwa: PTP_WAIT, h: HANDLE, pftTimeout: PFILETIME);
}
unsafe extern "C" {
    pub fn WaitForThreadpoolWaitCallbacks(pwa: PTP_WAIT, fCancelPendingCallbacks: BOOL);
}
unsafe extern "C" {
    pub fn CloseThreadpoolWait(pwa: PTP_WAIT);
}
unsafe extern "C" {
    pub fn CreateThreadpoolIo(
        fl: HANDLE,
        pfnio: PTP_WIN32_IO_CALLBACK,
        pv: PVOID,
        pcbe: PTP_CALLBACK_ENVIRON,
    ) -> PTP_IO;
}
unsafe extern "C" {
    pub fn StartThreadpoolIo(pio: PTP_IO);
}
unsafe extern "C" {
    pub fn CancelThreadpoolIo(pio: PTP_IO);
}
unsafe extern "C" {
    pub fn WaitForThreadpoolIoCallbacks(pio: PTP_IO, fCancelPendingCallbacks: BOOL);
}
unsafe extern "C" {
    pub fn CloseThreadpoolIo(pio: PTP_IO);
}
unsafe extern "C" {
    pub fn SetThreadpoolTimerEx(
        pti: PTP_TIMER,
        pftDueTime: PFILETIME,
        msPeriod: DWORD,
        msWindowLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadpoolWaitEx(
        pwa: PTP_WAIT,
        h: HANDLE,
        pftTimeout: PFILETIME,
        Reserved: PVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsProcessInJob(ProcessHandle: HANDLE, JobHandle: HANDLE, Result: PBOOL) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct JOBOBJECT_IO_RATE_CONTROL_INFORMATION {
    pub MaxIops: LONG64,
    pub MaxBandwidth: LONG64,
    pub ReservationIops: LONG64,
    pub VolumeName: PCWSTR,
    pub BaseIoSize: ULONG,
    pub ControlFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of JOBOBJECT_IO_RATE_CONTROL_INFORMATION"]
        [::std::mem::size_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION>() - 40usize];
    ["Alignment of JOBOBJECT_IO_RATE_CONTROL_INFORMATION"]
        [::std::mem::align_of::<JOBOBJECT_IO_RATE_CONTROL_INFORMATION>() - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::MaxIops"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, MaxIops) - 0usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::MaxBandwidth"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, MaxBandwidth) - 8usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::ReservationIops"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, ReservationIops) - 16usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::VolumeName"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, VolumeName) - 24usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::BaseIoSize"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, BaseIoSize) - 32usize];
    ["Offset of field: JOBOBJECT_IO_RATE_CONTROL_INFORMATION::ControlFlags"]
        [::std::mem::offset_of!(JOBOBJECT_IO_RATE_CONTROL_INFORMATION, ControlFlags) - 36usize];
};
unsafe extern "C" {
    pub fn CreateJobObjectW(lpJobAttributes: LPSECURITY_ATTRIBUTES, lpName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn FreeMemoryJobObject(Buffer: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn OpenJobObjectW(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn AssignProcessToJobObject(hJob: HANDLE, hProcess: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn TerminateJobObject(hJob: HANDLE, uExitCode: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetInformationJobObject(
        hJob: HANDLE,
        JobObjectInformationClass: JOBOBJECTINFOCLASS,
        lpJobObjectInformation: LPVOID,
        cbJobObjectInformationLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetIoRateControlInformationJobObject(
        hJob: HANDLE,
        IoRateControlInfo: *mut JOBOBJECT_IO_RATE_CONTROL_INFORMATION,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn QueryInformationJobObject(
        hJob: HANDLE,
        JobObjectInformationClass: JOBOBJECTINFOCLASS,
        lpJobObjectInformation: LPVOID,
        cbJobObjectInformationLength: DWORD,
        lpReturnLength: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryIoRateControlInformationJobObject(
        hJob: HANDLE,
        VolumeName: PCWSTR,
        InfoBlocks: *mut *mut JOBOBJECT_IO_RATE_CONTROL_INFORMATION,
        InfoBlockCount: *mut ULONG,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn Wow64EnableWow64FsRedirection(Wow64FsEnableRedirection: BOOLEAN) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn Wow64DisableWow64FsRedirection(OldValue: *mut PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn Wow64RevertWow64FsRedirection(OlValue: PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn IsWow64Process(hProcess: HANDLE, Wow64Process: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemWow64DirectoryA(lpBuffer: LPSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemWow64DirectoryW(lpBuffer: LPWSTR, uSize: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn Wow64SetThreadDefaultGuestMachine(Machine: USHORT) -> USHORT;
}
unsafe extern "C" {
    pub fn IsWow64Process2(
        hProcess: HANDLE,
        pProcessMachine: *mut USHORT,
        pNativeMachine: *mut USHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemWow64Directory2A(
        lpBuffer: LPSTR,
        uSize: UINT,
        ImageFileMachineType: WORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemWow64Directory2W(
        lpBuffer: LPWSTR,
        uSize: UINT,
        ImageFileMachineType: WORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn IsWow64GuestMachineSupported(
        WowGuestMachine: USHORT,
        MachineIsSupported: *mut BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn Wow64GetThreadContext(hThread: HANDLE, lpContext: PWOW64_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn Wow64SetThreadContext(hThread: HANDLE, lpContext: *const WOW64_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn Wow64SuspendThread(hThread: HANDLE) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMUILANG {
    pub NumOfEnumUILang: ULONG,
    pub SizeOfEnumUIBuffer: ULONG,
    pub pEnumUIBuffer: *mut LANGID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMUILANG"][::std::mem::size_of::<tagENUMUILANG>() - 16usize];
    ["Alignment of tagENUMUILANG"][::std::mem::align_of::<tagENUMUILANG>() - 8usize];
    ["Offset of field: tagENUMUILANG::NumOfEnumUILang"]
        [::std::mem::offset_of!(tagENUMUILANG, NumOfEnumUILang) - 0usize];
    ["Offset of field: tagENUMUILANG::SizeOfEnumUIBuffer"]
        [::std::mem::offset_of!(tagENUMUILANG, SizeOfEnumUIBuffer) - 4usize];
    ["Offset of field: tagENUMUILANG::pEnumUIBuffer"]
        [::std::mem::offset_of!(tagENUMUILANG, pEnumUIBuffer) - 8usize];
};
pub type ENUMUILANG = tagENUMUILANG;
pub type PENUMUILANG = *mut tagENUMUILANG;
pub type ENUMRESLANGPROCA = ::std::option::Option<
    unsafe extern "C" fn(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpName: LPCSTR,
        wLanguage: WORD,
        lParam: LONG_PTR,
    ) -> BOOL,
>;
pub type ENUMRESLANGPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpName: LPCWSTR,
        wLanguage: WORD,
        lParam: LONG_PTR,
    ) -> BOOL,
>;
pub type ENUMRESNAMEPROCA = ::std::option::Option<
    unsafe extern "C" fn(hModule: HMODULE, lpType: LPCSTR, lpName: LPSTR, lParam: LONG_PTR) -> BOOL,
>;
pub type ENUMRESNAMEPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpName: LPWSTR,
        lParam: LONG_PTR,
    ) -> BOOL,
>;
pub type ENUMRESTYPEPROCA = ::std::option::Option<
    unsafe extern "C" fn(hModule: HMODULE, lpType: LPSTR, lParam: LONG_PTR) -> BOOL,
>;
pub type ENUMRESTYPEPROCW = ::std::option::Option<
    unsafe extern "C" fn(hModule: HMODULE, lpType: LPWSTR, lParam: LONG_PTR) -> BOOL,
>;
unsafe extern "C" {
    pub fn DisableThreadLibraryCalls(hLibModule: HMODULE) -> BOOL;
}
unsafe extern "C" {
    pub fn FindResourceExW(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpName: LPCWSTR,
        wLanguage: WORD,
    ) -> HRSRC;
}
unsafe extern "C" {
    pub fn FindStringOrdinal(
        dwFindStringOrdinalFlags: DWORD,
        lpStringSource: LPCWSTR,
        cchSource: ::std::os::raw::c_int,
        lpStringValue: LPCWSTR,
        cchValue: ::std::os::raw::c_int,
        bIgnoreCase: BOOL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn FreeLibrary(hLibModule: HMODULE) -> BOOL;
}
unsafe extern "C" {
    pub fn FreeLibraryAndExitThread(hLibModule: HMODULE, dwExitCode: DWORD) -> !;
}
unsafe extern "C" {
    pub fn FreeResource(hResData: HGLOBAL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetModuleFileNameA(hModule: HMODULE, lpFilename: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetModuleFileNameW(hModule: HMODULE, lpFilename: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetModuleHandleA(lpModuleName: LPCSTR) -> HMODULE;
}
unsafe extern "C" {
    pub fn GetModuleHandleW(lpModuleName: LPCWSTR) -> HMODULE;
}
pub type PGET_MODULE_HANDLE_EXA = ::std::option::Option<
    unsafe extern "C" fn(dwFlags: DWORD, lpModuleName: LPCSTR, phModule: *mut HMODULE) -> BOOL,
>;
pub type PGET_MODULE_HANDLE_EXW = ::std::option::Option<
    unsafe extern "C" fn(dwFlags: DWORD, lpModuleName: LPCWSTR, phModule: *mut HMODULE) -> BOOL,
>;
unsafe extern "C" {
    pub fn GetModuleHandleExA(dwFlags: DWORD, lpModuleName: LPCSTR, phModule: *mut HMODULE)
        -> BOOL;
}
unsafe extern "C" {
    pub fn GetModuleHandleExW(
        dwFlags: DWORD,
        lpModuleName: LPCWSTR,
        phModule: *mut HMODULE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcAddress(hModule: HMODULE, lpProcName: LPCSTR) -> FARPROC;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REDIRECTION_FUNCTION_DESCRIPTOR {
    pub DllName: PCSTR,
    pub FunctionName: PCSTR,
    pub RedirectionTarget: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REDIRECTION_FUNCTION_DESCRIPTOR"]
        [::std::mem::size_of::<_REDIRECTION_FUNCTION_DESCRIPTOR>() - 24usize];
    ["Alignment of _REDIRECTION_FUNCTION_DESCRIPTOR"]
        [::std::mem::align_of::<_REDIRECTION_FUNCTION_DESCRIPTOR>() - 8usize];
    ["Offset of field: _REDIRECTION_FUNCTION_DESCRIPTOR::DllName"]
        [::std::mem::offset_of!(_REDIRECTION_FUNCTION_DESCRIPTOR, DllName) - 0usize];
    ["Offset of field: _REDIRECTION_FUNCTION_DESCRIPTOR::FunctionName"]
        [::std::mem::offset_of!(_REDIRECTION_FUNCTION_DESCRIPTOR, FunctionName) - 8usize];
    ["Offset of field: _REDIRECTION_FUNCTION_DESCRIPTOR::RedirectionTarget"]
        [::std::mem::offset_of!(_REDIRECTION_FUNCTION_DESCRIPTOR, RedirectionTarget) - 16usize];
};
pub type REDIRECTION_FUNCTION_DESCRIPTOR = _REDIRECTION_FUNCTION_DESCRIPTOR;
pub type PREDIRECTION_FUNCTION_DESCRIPTOR = *mut _REDIRECTION_FUNCTION_DESCRIPTOR;
pub type PCREDIRECTION_FUNCTION_DESCRIPTOR = *const REDIRECTION_FUNCTION_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REDIRECTION_DESCRIPTOR {
    pub Version: ULONG,
    pub FunctionCount: ULONG,
    pub Redirections: PCREDIRECTION_FUNCTION_DESCRIPTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REDIRECTION_DESCRIPTOR"][::std::mem::size_of::<_REDIRECTION_DESCRIPTOR>() - 16usize];
    ["Alignment of _REDIRECTION_DESCRIPTOR"]
        [::std::mem::align_of::<_REDIRECTION_DESCRIPTOR>() - 8usize];
    ["Offset of field: _REDIRECTION_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_REDIRECTION_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _REDIRECTION_DESCRIPTOR::FunctionCount"]
        [::std::mem::offset_of!(_REDIRECTION_DESCRIPTOR, FunctionCount) - 4usize];
    ["Offset of field: _REDIRECTION_DESCRIPTOR::Redirections"]
        [::std::mem::offset_of!(_REDIRECTION_DESCRIPTOR, Redirections) - 8usize];
};
pub type REDIRECTION_DESCRIPTOR = _REDIRECTION_DESCRIPTOR;
pub type PREDIRECTION_DESCRIPTOR = *mut _REDIRECTION_DESCRIPTOR;
pub type PCREDIRECTION_DESCRIPTOR = *const REDIRECTION_DESCRIPTOR;
unsafe extern "C" {
    pub fn LoadLibraryExA(lpLibFileName: LPCSTR, hFile: HANDLE, dwFlags: DWORD) -> HMODULE;
}
unsafe extern "C" {
    pub fn LoadLibraryExW(lpLibFileName: LPCWSTR, hFile: HANDLE, dwFlags: DWORD) -> HMODULE;
}
unsafe extern "C" {
    pub fn LoadResource(hModule: HMODULE, hResInfo: HRSRC) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn LoadStringA(
        hInstance: HINSTANCE,
        uID: UINT,
        lpBuffer: LPSTR,
        cchBufferMax: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LoadStringW(
        hInstance: HINSTANCE,
        uID: UINT,
        lpBuffer: LPWSTR,
        cchBufferMax: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LockResource(hResData: HGLOBAL) -> LPVOID;
}
unsafe extern "C" {
    pub fn SizeofResource(hModule: HMODULE, hResInfo: HRSRC) -> DWORD;
}
pub type DLL_DIRECTORY_COOKIE = PVOID;
pub type PDLL_DIRECTORY_COOKIE = *mut PVOID;
unsafe extern "C" {
    pub fn AddDllDirectory(NewDirectory: PCWSTR) -> DLL_DIRECTORY_COOKIE;
}
unsafe extern "C" {
    pub fn RemoveDllDirectory(Cookie: DLL_DIRECTORY_COOKIE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDefaultDllDirectories(DirectoryFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceLanguagesExA(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpName: LPCSTR,
        lpEnumFunc: ENUMRESLANGPROCA,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceLanguagesExW(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpName: LPCWSTR,
        lpEnumFunc: ENUMRESLANGPROCW,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceNamesExA(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpEnumFunc: ENUMRESNAMEPROCA,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceNamesExW(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpEnumFunc: ENUMRESNAMEPROCW,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceTypesExA(
        hModule: HMODULE,
        lpEnumFunc: ENUMRESTYPEPROCA,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceTypesExW(
        hModule: HMODULE,
        lpEnumFunc: ENUMRESTYPEPROCW,
        lParam: LONG_PTR,
        dwFlags: DWORD,
        LangId: LANGID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindResourceW(hModule: HMODULE, lpName: LPCWSTR, lpType: LPCWSTR) -> HRSRC;
}
unsafe extern "C" {
    pub fn LoadLibraryA(lpLibFileName: LPCSTR) -> HMODULE;
}
unsafe extern "C" {
    pub fn LoadLibraryW(lpLibFileName: LPCWSTR) -> HMODULE;
}
unsafe extern "C" {
    pub fn EnumResourceNamesW(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpEnumFunc: ENUMRESNAMEPROCW,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceNamesA(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpEnumFunc: ENUMRESNAMEPROCA,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheck(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        PrivilegeSet: PPRIVILEGE_SET,
        PrivilegeSetLength: LPDWORD,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckAndAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPWSTR,
        ObjectName: LPWSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        DesiredAccess: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByType(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        PrivilegeSet: PPRIVILEGE_SET,
        PrivilegeSetLength: LPDWORD,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeResultList(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        PrivilegeSet: PPRIVILEGE_SET,
        PrivilegeSetLength: LPDWORD,
        GrantedAccessList: LPDWORD,
        AccessStatusList: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeAndAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPCWSTR,
        ObjectName: LPCWSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeResultListAndAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPCWSTR,
        ObjectName: LPCWSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccessList: LPDWORD,
        AccessStatusList: LPDWORD,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeResultListAndAuditAlarmByHandleW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ClientToken: HANDLE,
        ObjectTypeName: LPCWSTR,
        ObjectName: LPCWSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccessList: LPDWORD,
        AccessStatusList: LPDWORD,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessAllowedAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessAllowedAceEx(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessAllowedObjectAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        ObjectTypeGuid: *mut GUID,
        InheritedObjectTypeGuid: *mut GUID,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessDeniedAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessDeniedAceEx(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAccessDeniedObjectAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        ObjectTypeGuid: *mut GUID,
        InheritedObjectTypeGuid: *mut GUID,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        dwStartingAceIndex: DWORD,
        pAceList: LPVOID,
        nAceListLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAuditAccessAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        dwAccessMask: DWORD,
        pSid: PSID,
        bAuditSuccess: BOOL,
        bAuditFailure: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAuditAccessAceEx(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        dwAccessMask: DWORD,
        pSid: PSID,
        bAuditSuccess: BOOL,
        bAuditFailure: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddAuditAccessObjectAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        ObjectTypeGuid: *mut GUID,
        InheritedObjectTypeGuid: *mut GUID,
        pSid: PSID,
        bAuditSuccess: BOOL,
        bAuditFailure: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddMandatoryAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        MandatoryPolicy: DWORD,
        pLabelSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddResourceAttributeAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
        pAttributeInfo: PCLAIM_SECURITY_ATTRIBUTES_INFORMATION,
        pReturnLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddScopedPolicyIDAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AccessMask: DWORD,
        pSid: PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AdjustTokenGroups(
        TokenHandle: HANDLE,
        ResetToDefault: BOOL,
        NewState: PTOKEN_GROUPS,
        BufferLength: DWORD,
        PreviousState: PTOKEN_GROUPS,
        ReturnLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AdjustTokenPrivileges(
        TokenHandle: HANDLE,
        DisableAllPrivileges: BOOL,
        NewState: PTOKEN_PRIVILEGES,
        BufferLength: DWORD,
        PreviousState: PTOKEN_PRIVILEGES,
        ReturnLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AllocateAndInitializeSid(
        pIdentifierAuthority: PSID_IDENTIFIER_AUTHORITY,
        nSubAuthorityCount: BYTE,
        nSubAuthority0: DWORD,
        nSubAuthority1: DWORD,
        nSubAuthority2: DWORD,
        nSubAuthority3: DWORD,
        nSubAuthority4: DWORD,
        nSubAuthority5: DWORD,
        nSubAuthority6: DWORD,
        nSubAuthority7: DWORD,
        pSid: *mut PSID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AllocateLocallyUniqueId(Luid: PLUID) -> BOOL;
}
unsafe extern "C" {
    pub fn AreAllAccessesGranted(GrantedAccess: DWORD, DesiredAccess: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn AreAnyAccessesGranted(GrantedAccess: DWORD, DesiredAccess: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckTokenMembership(TokenHandle: HANDLE, SidToCheck: PSID, IsMember: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckTokenCapability(
        TokenHandle: HANDLE,
        CapabilitySidToCheck: PSID,
        HasCapability: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAppContainerAce(
        Acl: PACL,
        StartingAceIndex: DWORD,
        AppContainerAce: *mut PVOID,
        AppContainerAceIndex: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckTokenMembershipEx(
        TokenHandle: HANDLE,
        SidToCheck: PSID,
        Flags: DWORD,
        IsMember: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ConvertToAutoInheritPrivateObjectSecurity(
        ParentDescriptor: PSECURITY_DESCRIPTOR,
        CurrentSecurityDescriptor: PSECURITY_DESCRIPTOR,
        NewSecurityDescriptor: *mut PSECURITY_DESCRIPTOR,
        ObjectType: *mut GUID,
        IsDirectoryObject: BOOLEAN,
        GenericMapping: PGENERIC_MAPPING,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CopySid(nDestinationSidLength: DWORD, pDestinationSid: PSID, pSourceSid: PSID) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePrivateObjectSecurity(
        ParentDescriptor: PSECURITY_DESCRIPTOR,
        CreatorDescriptor: PSECURITY_DESCRIPTOR,
        NewDescriptor: *mut PSECURITY_DESCRIPTOR,
        IsDirectoryObject: BOOL,
        Token: HANDLE,
        GenericMapping: PGENERIC_MAPPING,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePrivateObjectSecurityEx(
        ParentDescriptor: PSECURITY_DESCRIPTOR,
        CreatorDescriptor: PSECURITY_DESCRIPTOR,
        NewDescriptor: *mut PSECURITY_DESCRIPTOR,
        ObjectType: *mut GUID,
        IsContainerObject: BOOL,
        AutoInheritFlags: ULONG,
        Token: HANDLE,
        GenericMapping: PGENERIC_MAPPING,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePrivateObjectSecurityWithMultipleInheritance(
        ParentDescriptor: PSECURITY_DESCRIPTOR,
        CreatorDescriptor: PSECURITY_DESCRIPTOR,
        NewDescriptor: *mut PSECURITY_DESCRIPTOR,
        ObjectTypes: *mut *mut GUID,
        GuidCount: ULONG,
        IsContainerObject: BOOL,
        AutoInheritFlags: ULONG,
        Token: HANDLE,
        GenericMapping: PGENERIC_MAPPING,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateRestrictedToken(
        ExistingTokenHandle: HANDLE,
        Flags: DWORD,
        DisableSidCount: DWORD,
        SidsToDisable: PSID_AND_ATTRIBUTES,
        DeletePrivilegeCount: DWORD,
        PrivilegesToDelete: PLUID_AND_ATTRIBUTES,
        RestrictedSidCount: DWORD,
        SidsToRestrict: PSID_AND_ATTRIBUTES,
        NewTokenHandle: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateWellKnownSid(
        WellKnownSidType: WELL_KNOWN_SID_TYPE,
        DomainSid: PSID,
        pSid: PSID,
        cbSid: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EqualDomainSid(pSid1: PSID, pSid2: PSID, pfEqual: *mut BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteAce(pAcl: PACL, dwAceIndex: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DestroyPrivateObjectSecurity(ObjectDescriptor: *mut PSECURITY_DESCRIPTOR) -> BOOL;
}
unsafe extern "C" {
    pub fn DuplicateToken(
        ExistingTokenHandle: HANDLE,
        ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL,
        DuplicateTokenHandle: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DuplicateTokenEx(
        hExistingToken: HANDLE,
        dwDesiredAccess: DWORD,
        lpTokenAttributes: LPSECURITY_ATTRIBUTES,
        ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL,
        TokenType: TOKEN_TYPE,
        phNewToken: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EqualPrefixSid(pSid1: PSID, pSid2: PSID) -> BOOL;
}
unsafe extern "C" {
    pub fn EqualSid(pSid1: PSID, pSid2: PSID) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstFreeAce(pAcl: PACL, pAce: *mut LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn FreeSid(pSid: PSID) -> PVOID;
}
unsafe extern "C" {
    pub fn GetAce(pAcl: PACL, dwAceIndex: DWORD, pAce: *mut LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAclInformation(
        pAcl: PACL,
        pAclInformation: LPVOID,
        nAclInformationLength: DWORD,
        dwAclInformationClass: ACL_INFORMATION_CLASS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileSecurityW(
        lpFileName: LPCWSTR,
        RequestedInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetKernelObjectSecurity(
        Handle: HANDLE,
        RequestedInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLengthSid(pSid: PSID) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrivateObjectSecurity(
        ObjectDescriptor: PSECURITY_DESCRIPTOR,
        SecurityInformation: SECURITY_INFORMATION,
        ResultantDescriptor: PSECURITY_DESCRIPTOR,
        DescriptorLength: DWORD,
        ReturnLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorControl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pControl: PSECURITY_DESCRIPTOR_CONTROL,
        lpdwRevision: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorDacl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        lpbDaclPresent: LPBOOL,
        pDacl: *mut PACL,
        lpbDaclDefaulted: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorGroup(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pGroup: *mut PSID,
        lpbGroupDefaulted: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorLength(pSecurityDescriptor: PSECURITY_DESCRIPTOR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorOwner(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pOwner: *mut PSID,
        lpbOwnerDefaulted: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorRMControl(
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        RMControl: PUCHAR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetSecurityDescriptorSacl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        lpbSaclPresent: LPBOOL,
        pSacl: *mut PACL,
        lpbSaclDefaulted: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSidIdentifierAuthority(pSid: PSID) -> PSID_IDENTIFIER_AUTHORITY;
}
unsafe extern "C" {
    pub fn GetSidLengthRequired(nSubAuthorityCount: UCHAR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetSidSubAuthority(pSid: PSID, nSubAuthority: DWORD) -> PDWORD;
}
unsafe extern "C" {
    pub fn GetSidSubAuthorityCount(pSid: PSID) -> PUCHAR;
}
unsafe extern "C" {
    pub fn GetTokenInformation(
        TokenHandle: HANDLE,
        TokenInformationClass: TOKEN_INFORMATION_CLASS,
        TokenInformation: LPVOID,
        TokenInformationLength: DWORD,
        ReturnLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowsAccountDomainSid(
        pSid: PSID,
        pDomainSid: PSID,
        cbDomainSid: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImpersonateAnonymousToken(ThreadHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ImpersonateLoggedOnUser(hToken: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ImpersonateSelf(ImpersonationLevel: SECURITY_IMPERSONATION_LEVEL) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeAcl(pAcl: PACL, nAclLength: DWORD, dwAclRevision: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeSecurityDescriptor(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        dwRevision: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeSid(
        Sid: PSID,
        pIdentifierAuthority: PSID_IDENTIFIER_AUTHORITY,
        nSubAuthorityCount: BYTE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsTokenRestricted(TokenHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidAcl(pAcl: PACL) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidSecurityDescriptor(pSecurityDescriptor: PSECURITY_DESCRIPTOR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidSid(pSid: PSID) -> BOOL;
}
unsafe extern "C" {
    pub fn IsWellKnownSid(pSid: PSID, WellKnownSidType: WELL_KNOWN_SID_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn MakeAbsoluteSD(
        pSelfRelativeSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pAbsoluteSecurityDescriptor: PSECURITY_DESCRIPTOR,
        lpdwAbsoluteSecurityDescriptorSize: LPDWORD,
        pDacl: PACL,
        lpdwDaclSize: LPDWORD,
        pSacl: PACL,
        lpdwSaclSize: LPDWORD,
        pOwner: PSID,
        lpdwOwnerSize: LPDWORD,
        pPrimaryGroup: PSID,
        lpdwPrimaryGroupSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MakeSelfRelativeSD(
        pAbsoluteSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pSelfRelativeSecurityDescriptor: PSECURITY_DESCRIPTOR,
        lpdwBufferLength: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MapGenericMask(AccessMask: PDWORD, GenericMapping: PGENERIC_MAPPING);
}
unsafe extern "C" {
    pub fn ObjectCloseAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        GenerateOnClose: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectDeleteAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        GenerateOnClose: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectOpenAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPWSTR,
        ObjectName: LPWSTR,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        GrantedAccess: DWORD,
        Privileges: PPRIVILEGE_SET,
        ObjectCreation: BOOL,
        AccessGranted: BOOL,
        GenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectPrivilegeAuditAlarmW(
        SubsystemName: LPCWSTR,
        HandleId: LPVOID,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        Privileges: PPRIVILEGE_SET,
        AccessGranted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PrivilegeCheck(
        ClientToken: HANDLE,
        RequiredPrivileges: PPRIVILEGE_SET,
        pfResult: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PrivilegedServiceAuditAlarmW(
        SubsystemName: LPCWSTR,
        ServiceName: LPCWSTR,
        ClientToken: HANDLE,
        Privileges: PPRIVILEGE_SET,
        AccessGranted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QuerySecurityAccessMask(
        SecurityInformation: SECURITY_INFORMATION,
        DesiredAccess: LPDWORD,
    );
}
unsafe extern "C" {
    pub fn RevertToSelf() -> BOOL;
}
unsafe extern "C" {
    pub fn SetAclInformation(
        pAcl: PACL,
        pAclInformation: LPVOID,
        nAclInformationLength: DWORD,
        dwAclInformationClass: ACL_INFORMATION_CLASS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileSecurityW(
        lpFileName: LPCWSTR,
        SecurityInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetKernelObjectSecurity(
        Handle: HANDLE,
        SecurityInformation: SECURITY_INFORMATION,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPrivateObjectSecurity(
        SecurityInformation: SECURITY_INFORMATION,
        ModificationDescriptor: PSECURITY_DESCRIPTOR,
        ObjectsSecurityDescriptor: *mut PSECURITY_DESCRIPTOR,
        GenericMapping: PGENERIC_MAPPING,
        Token: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPrivateObjectSecurityEx(
        SecurityInformation: SECURITY_INFORMATION,
        ModificationDescriptor: PSECURITY_DESCRIPTOR,
        ObjectsSecurityDescriptor: *mut PSECURITY_DESCRIPTOR,
        AutoInheritFlags: ULONG,
        GenericMapping: PGENERIC_MAPPING,
        Token: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSecurityAccessMask(SecurityInformation: SECURITY_INFORMATION, DesiredAccess: LPDWORD);
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorControl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        ControlBitsOfInterest: SECURITY_DESCRIPTOR_CONTROL,
        ControlBitsToSet: SECURITY_DESCRIPTOR_CONTROL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorDacl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        bDaclPresent: BOOL,
        pDacl: PACL,
        bDaclDefaulted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorGroup(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pGroup: PSID,
        bGroupDefaulted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorOwner(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        pOwner: PSID,
        bOwnerDefaulted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorRMControl(
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        RMControl: PUCHAR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetSecurityDescriptorSacl(
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        bSaclPresent: BOOL,
        pSacl: PACL,
        bSaclDefaulted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetTokenInformation(
        TokenHandle: HANDLE,
        TokenInformationClass: TOKEN_INFORMATION_CLASS,
        TokenInformation: LPVOID,
        TokenInformationLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCachedSigningLevel(
        SourceFiles: PHANDLE,
        SourceFileCount: ULONG,
        Flags: ULONG,
        TargetFile: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCachedSigningLevel(
        File: HANDLE,
        Flags: PULONG,
        SigningLevel: PULONG,
        Thumbprint: PUCHAR,
        ThumbprintSize: PULONG,
        ThumbprintAlgorithm: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CveEventWrite(CveId: PCWSTR, AdditionalDetails: PCWSTR) -> LONG;
}
unsafe extern "C" {
    pub fn DeriveCapabilitySidsFromName(
        CapName: LPCWSTR,
        CapabilityGroupSids: *mut *mut PSID,
        CapabilityGroupSidCount: *mut DWORD,
        CapabilitySids: *mut *mut PSID,
        CapabilitySidCount: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePrivateNamespaceW(
        lpPrivateNamespaceAttributes: LPSECURITY_ATTRIBUTES,
        lpBoundaryDescriptor: LPVOID,
        lpAliasPrefix: LPCWSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenPrivateNamespaceW(lpBoundaryDescriptor: LPVOID, lpAliasPrefix: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn ClosePrivateNamespace(Handle: HANDLE, Flags: ULONG) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn CreateBoundaryDescriptorW(Name: LPCWSTR, Flags: ULONG) -> HANDLE;
}
unsafe extern "C" {
    pub fn AddSIDToBoundaryDescriptor(BoundaryDescriptor: *mut HANDLE, RequiredSid: PSID) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteBoundaryDescriptor(BoundaryDescriptor: HANDLE);
}
unsafe extern "C" {
    pub fn GetNumaHighestNodeNumber(HighestNodeNumber: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaNodeProcessorMaskEx(Node: USHORT, ProcessorMask: PGROUP_AFFINITY) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaNodeProcessorMask2(
        NodeNumber: USHORT,
        ProcessorMasks: PGROUP_AFFINITY,
        ProcessorMaskCount: USHORT,
        RequiredMaskCount: PUSHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaProximityNodeEx(ProximityId: ULONG, NodeNumber: PUSHORT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessGroupAffinity(
        hProcess: HANDLE,
        GroupCount: PUSHORT,
        GroupArray: PUSHORT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadGroupAffinity(hThread: HANDLE, GroupAffinity: PGROUP_AFFINITY) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadGroupAffinity(
        hThread: HANDLE,
        GroupAffinity: *const GROUP_AFFINITY,
        PreviousGroupAffinity: PGROUP_AFFINITY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAppContainerNamedObjectPath(
        Token: HANDLE,
        AppContainerSid: PSID,
        ObjectPathLength: ULONG,
        ObjectPath: LPWSTR,
        ReturnLength: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryThreadCycleTime(ThreadHandle: HANDLE, CycleTime: PULONG64) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryProcessCycleTime(ProcessHandle: HANDLE, CycleTime: PULONG64) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryIdleProcessorCycleTime(
        BufferLength: PULONG,
        ProcessorIdleCycleTime: PULONG64,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryIdleProcessorCycleTimeEx(
        Group: USHORT,
        BufferLength: PULONG,
        ProcessorIdleCycleTime: PULONG64,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryInterruptTimePrecise(lpInterruptTimePrecise: PULONGLONG);
}
unsafe extern "C" {
    pub fn QueryUnbiasedInterruptTimePrecise(lpUnbiasedInterruptTimePrecise: PULONGLONG);
}
unsafe extern "C" {
    pub fn QueryInterruptTime(lpInterruptTime: PULONGLONG);
}
unsafe extern "C" {
    pub fn QueryUnbiasedInterruptTime(UnbiasedTime: PULONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryAuxiliaryCounterFrequency(lpAuxiliaryCounterFrequency: PULONGLONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn ConvertAuxiliaryCounterToPerformanceCounter(
        ullAuxiliaryCounterValue: ULONGLONG,
        lpPerformanceCounterValue: PULONGLONG,
        lpConversionError: PULONGLONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ConvertPerformanceCounterToAuxiliaryCounter(
        ullPerformanceCounterValue: ULONGLONG,
        lpAuxiliaryCounterValue: PULONGLONG,
        lpConversionError: PULONGLONG,
    ) -> HRESULT;
}
pub type PFIBER_START_ROUTINE =
    ::std::option::Option<unsafe extern "C" fn(lpFiberParameter: LPVOID)>;
pub type LPFIBER_START_ROUTINE = PFIBER_START_ROUTINE;
pub type PFIBER_CALLOUT_ROUTINE =
    ::std::option::Option<unsafe extern "C" fn(lpParameter: LPVOID) -> LPVOID>;
pub type LPLDT_ENTRY = LPVOID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMMPROP {
    pub wPacketLength: WORD,
    pub wPacketVersion: WORD,
    pub dwServiceMask: DWORD,
    pub dwReserved1: DWORD,
    pub dwMaxTxQueue: DWORD,
    pub dwMaxRxQueue: DWORD,
    pub dwMaxBaud: DWORD,
    pub dwProvSubType: DWORD,
    pub dwProvCapabilities: DWORD,
    pub dwSettableParams: DWORD,
    pub dwSettableBaud: DWORD,
    pub wSettableData: WORD,
    pub wSettableStopParity: WORD,
    pub dwCurrentTxQueue: DWORD,
    pub dwCurrentRxQueue: DWORD,
    pub dwProvSpec1: DWORD,
    pub dwProvSpec2: DWORD,
    pub wcProvChar: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMMPROP"][::std::mem::size_of::<_COMMPROP>() - 64usize];
    ["Alignment of _COMMPROP"][::std::mem::align_of::<_COMMPROP>() - 4usize];
    ["Offset of field: _COMMPROP::wPacketLength"]
        [::std::mem::offset_of!(_COMMPROP, wPacketLength) - 0usize];
    ["Offset of field: _COMMPROP::wPacketVersion"]
        [::std::mem::offset_of!(_COMMPROP, wPacketVersion) - 2usize];
    ["Offset of field: _COMMPROP::dwServiceMask"]
        [::std::mem::offset_of!(_COMMPROP, dwServiceMask) - 4usize];
    ["Offset of field: _COMMPROP::dwReserved1"]
        [::std::mem::offset_of!(_COMMPROP, dwReserved1) - 8usize];
    ["Offset of field: _COMMPROP::dwMaxTxQueue"]
        [::std::mem::offset_of!(_COMMPROP, dwMaxTxQueue) - 12usize];
    ["Offset of field: _COMMPROP::dwMaxRxQueue"]
        [::std::mem::offset_of!(_COMMPROP, dwMaxRxQueue) - 16usize];
    ["Offset of field: _COMMPROP::dwMaxBaud"]
        [::std::mem::offset_of!(_COMMPROP, dwMaxBaud) - 20usize];
    ["Offset of field: _COMMPROP::dwProvSubType"]
        [::std::mem::offset_of!(_COMMPROP, dwProvSubType) - 24usize];
    ["Offset of field: _COMMPROP::dwProvCapabilities"]
        [::std::mem::offset_of!(_COMMPROP, dwProvCapabilities) - 28usize];
    ["Offset of field: _COMMPROP::dwSettableParams"]
        [::std::mem::offset_of!(_COMMPROP, dwSettableParams) - 32usize];
    ["Offset of field: _COMMPROP::dwSettableBaud"]
        [::std::mem::offset_of!(_COMMPROP, dwSettableBaud) - 36usize];
    ["Offset of field: _COMMPROP::wSettableData"]
        [::std::mem::offset_of!(_COMMPROP, wSettableData) - 40usize];
    ["Offset of field: _COMMPROP::wSettableStopParity"]
        [::std::mem::offset_of!(_COMMPROP, wSettableStopParity) - 42usize];
    ["Offset of field: _COMMPROP::dwCurrentTxQueue"]
        [::std::mem::offset_of!(_COMMPROP, dwCurrentTxQueue) - 44usize];
    ["Offset of field: _COMMPROP::dwCurrentRxQueue"]
        [::std::mem::offset_of!(_COMMPROP, dwCurrentRxQueue) - 48usize];
    ["Offset of field: _COMMPROP::dwProvSpec1"]
        [::std::mem::offset_of!(_COMMPROP, dwProvSpec1) - 52usize];
    ["Offset of field: _COMMPROP::dwProvSpec2"]
        [::std::mem::offset_of!(_COMMPROP, dwProvSpec2) - 56usize];
    ["Offset of field: _COMMPROP::wcProvChar"]
        [::std::mem::offset_of!(_COMMPROP, wcProvChar) - 60usize];
};
pub type COMMPROP = _COMMPROP;
pub type LPCOMMPROP = *mut _COMMPROP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMSTAT {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub cbInQue: DWORD,
    pub cbOutQue: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMSTAT"][::std::mem::size_of::<_COMSTAT>() - 12usize];
    ["Alignment of _COMSTAT"][::std::mem::align_of::<_COMSTAT>() - 4usize];
    ["Offset of field: _COMSTAT::cbInQue"][::std::mem::offset_of!(_COMSTAT, cbInQue) - 4usize];
    ["Offset of field: _COMSTAT::cbOutQue"][::std::mem::offset_of!(_COMSTAT, cbOutQue) - 8usize];
};
impl _COMSTAT {
    #[inline]
    pub fn fCtsHold(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fCtsHold(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fCtsHold_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fCtsHold_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDsrHold(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fDsrHold(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDsrHold_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fDsrHold_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRlsdHold(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fRlsdHold(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRlsdHold_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fRlsdHold_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fXoffHold(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fXoffHold(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fXoffHold_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fXoffHold_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fXoffSent(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fXoffSent(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fXoffSent_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fXoffSent_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fEof(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fEof(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fEof_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fEof_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fTxim(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fTxim(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fTxim_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fTxim_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fReserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 25u8) as u32) }
    }
    #[inline]
    pub fn set_fReserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 25u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fReserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                25u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fReserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                25u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        fCtsHold: DWORD,
        fDsrHold: DWORD,
        fRlsdHold: DWORD,
        fXoffHold: DWORD,
        fXoffSent: DWORD,
        fEof: DWORD,
        fTxim: DWORD,
        fReserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let fCtsHold: u32 = unsafe { ::std::mem::transmute(fCtsHold) };
            fCtsHold as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let fDsrHold: u32 = unsafe { ::std::mem::transmute(fDsrHold) };
            fDsrHold as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let fRlsdHold: u32 = unsafe { ::std::mem::transmute(fRlsdHold) };
            fRlsdHold as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let fXoffHold: u32 = unsafe { ::std::mem::transmute(fXoffHold) };
            fXoffHold as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let fXoffSent: u32 = unsafe { ::std::mem::transmute(fXoffSent) };
            fXoffSent as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let fEof: u32 = unsafe { ::std::mem::transmute(fEof) };
            fEof as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let fTxim: u32 = unsafe { ::std::mem::transmute(fTxim) };
            fTxim as u64
        });
        __bindgen_bitfield_unit.set(7usize, 25u8, {
            let fReserved: u32 = unsafe { ::std::mem::transmute(fReserved) };
            fReserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type COMSTAT = _COMSTAT;
pub type LPCOMSTAT = *mut _COMSTAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DCB {
    pub DCBlength: DWORD,
    pub BaudRate: DWORD,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub wReserved: WORD,
    pub XonLim: WORD,
    pub XoffLim: WORD,
    pub ByteSize: BYTE,
    pub Parity: BYTE,
    pub StopBits: BYTE,
    pub XonChar: ::std::os::raw::c_char,
    pub XoffChar: ::std::os::raw::c_char,
    pub ErrorChar: ::std::os::raw::c_char,
    pub EofChar: ::std::os::raw::c_char,
    pub EvtChar: ::std::os::raw::c_char,
    pub wReserved1: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DCB"][::std::mem::size_of::<_DCB>() - 28usize];
    ["Alignment of _DCB"][::std::mem::align_of::<_DCB>() - 4usize];
    ["Offset of field: _DCB::DCBlength"][::std::mem::offset_of!(_DCB, DCBlength) - 0usize];
    ["Offset of field: _DCB::BaudRate"][::std::mem::offset_of!(_DCB, BaudRate) - 4usize];
    ["Offset of field: _DCB::wReserved"][::std::mem::offset_of!(_DCB, wReserved) - 12usize];
    ["Offset of field: _DCB::XonLim"][::std::mem::offset_of!(_DCB, XonLim) - 14usize];
    ["Offset of field: _DCB::XoffLim"][::std::mem::offset_of!(_DCB, XoffLim) - 16usize];
    ["Offset of field: _DCB::ByteSize"][::std::mem::offset_of!(_DCB, ByteSize) - 18usize];
    ["Offset of field: _DCB::Parity"][::std::mem::offset_of!(_DCB, Parity) - 19usize];
    ["Offset of field: _DCB::StopBits"][::std::mem::offset_of!(_DCB, StopBits) - 20usize];
    ["Offset of field: _DCB::XonChar"][::std::mem::offset_of!(_DCB, XonChar) - 21usize];
    ["Offset of field: _DCB::XoffChar"][::std::mem::offset_of!(_DCB, XoffChar) - 22usize];
    ["Offset of field: _DCB::ErrorChar"][::std::mem::offset_of!(_DCB, ErrorChar) - 23usize];
    ["Offset of field: _DCB::EofChar"][::std::mem::offset_of!(_DCB, EofChar) - 24usize];
    ["Offset of field: _DCB::EvtChar"][::std::mem::offset_of!(_DCB, EvtChar) - 25usize];
    ["Offset of field: _DCB::wReserved1"][::std::mem::offset_of!(_DCB, wReserved1) - 26usize];
};
impl _DCB {
    #[inline]
    pub fn fBinary(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fBinary(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fBinary_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fBinary_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fParity(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fParity(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fParity_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fParity_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fOutxCtsFlow(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fOutxCtsFlow(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fOutxCtsFlow_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fOutxCtsFlow_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fOutxDsrFlow(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fOutxDsrFlow(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fOutxDsrFlow_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fOutxDsrFlow_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDtrControl(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_fDtrControl(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDtrControl_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fDtrControl_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDsrSensitivity(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fDsrSensitivity(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDsrSensitivity_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fDsrSensitivity_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fTXContinueOnXoff(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fTXContinueOnXoff(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fTXContinueOnXoff_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fTXContinueOnXoff_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fOutX(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fOutX(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fOutX_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fOutX_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fInX(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fInX(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fInX_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fInX_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fErrorChar(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fErrorChar(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fErrorChar_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fErrorChar_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fNull(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fNull(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fNull_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fNull_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRtsControl(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 2u8) as u32) }
    }
    #[inline]
    pub fn set_fRtsControl(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRtsControl_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                2u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fRtsControl_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAbortOnError(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fAbortOnError(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAbortOnError_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fAbortOnError_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDummy2(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 17u8) as u32) }
    }
    #[inline]
    pub fn set_fDummy2(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 17u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDummy2_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                17u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fDummy2_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                17u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        fBinary: DWORD,
        fParity: DWORD,
        fOutxCtsFlow: DWORD,
        fOutxDsrFlow: DWORD,
        fDtrControl: DWORD,
        fDsrSensitivity: DWORD,
        fTXContinueOnXoff: DWORD,
        fOutX: DWORD,
        fInX: DWORD,
        fErrorChar: DWORD,
        fNull: DWORD,
        fRtsControl: DWORD,
        fAbortOnError: DWORD,
        fDummy2: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let fBinary: u32 = unsafe { ::std::mem::transmute(fBinary) };
            fBinary as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let fParity: u32 = unsafe { ::std::mem::transmute(fParity) };
            fParity as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let fOutxCtsFlow: u32 = unsafe { ::std::mem::transmute(fOutxCtsFlow) };
            fOutxCtsFlow as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let fOutxDsrFlow: u32 = unsafe { ::std::mem::transmute(fOutxDsrFlow) };
            fOutxDsrFlow as u64
        });
        __bindgen_bitfield_unit.set(4usize, 2u8, {
            let fDtrControl: u32 = unsafe { ::std::mem::transmute(fDtrControl) };
            fDtrControl as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let fDsrSensitivity: u32 = unsafe { ::std::mem::transmute(fDsrSensitivity) };
            fDsrSensitivity as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let fTXContinueOnXoff: u32 = unsafe { ::std::mem::transmute(fTXContinueOnXoff) };
            fTXContinueOnXoff as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let fOutX: u32 = unsafe { ::std::mem::transmute(fOutX) };
            fOutX as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let fInX: u32 = unsafe { ::std::mem::transmute(fInX) };
            fInX as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let fErrorChar: u32 = unsafe { ::std::mem::transmute(fErrorChar) };
            fErrorChar as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let fNull: u32 = unsafe { ::std::mem::transmute(fNull) };
            fNull as u64
        });
        __bindgen_bitfield_unit.set(12usize, 2u8, {
            let fRtsControl: u32 = unsafe { ::std::mem::transmute(fRtsControl) };
            fRtsControl as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let fAbortOnError: u32 = unsafe { ::std::mem::transmute(fAbortOnError) };
            fAbortOnError as u64
        });
        __bindgen_bitfield_unit.set(15usize, 17u8, {
            let fDummy2: u32 = unsafe { ::std::mem::transmute(fDummy2) };
            fDummy2 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type DCB = _DCB;
pub type LPDCB = *mut _DCB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMMTIMEOUTS {
    pub ReadIntervalTimeout: DWORD,
    pub ReadTotalTimeoutMultiplier: DWORD,
    pub ReadTotalTimeoutConstant: DWORD,
    pub WriteTotalTimeoutMultiplier: DWORD,
    pub WriteTotalTimeoutConstant: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMMTIMEOUTS"][::std::mem::size_of::<_COMMTIMEOUTS>() - 20usize];
    ["Alignment of _COMMTIMEOUTS"][::std::mem::align_of::<_COMMTIMEOUTS>() - 4usize];
    ["Offset of field: _COMMTIMEOUTS::ReadIntervalTimeout"]
        [::std::mem::offset_of!(_COMMTIMEOUTS, ReadIntervalTimeout) - 0usize];
    ["Offset of field: _COMMTIMEOUTS::ReadTotalTimeoutMultiplier"]
        [::std::mem::offset_of!(_COMMTIMEOUTS, ReadTotalTimeoutMultiplier) - 4usize];
    ["Offset of field: _COMMTIMEOUTS::ReadTotalTimeoutConstant"]
        [::std::mem::offset_of!(_COMMTIMEOUTS, ReadTotalTimeoutConstant) - 8usize];
    ["Offset of field: _COMMTIMEOUTS::WriteTotalTimeoutMultiplier"]
        [::std::mem::offset_of!(_COMMTIMEOUTS, WriteTotalTimeoutMultiplier) - 12usize];
    ["Offset of field: _COMMTIMEOUTS::WriteTotalTimeoutConstant"]
        [::std::mem::offset_of!(_COMMTIMEOUTS, WriteTotalTimeoutConstant) - 16usize];
};
pub type COMMTIMEOUTS = _COMMTIMEOUTS;
pub type LPCOMMTIMEOUTS = *mut _COMMTIMEOUTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMMCONFIG {
    pub dwSize: DWORD,
    pub wVersion: WORD,
    pub wReserved: WORD,
    pub dcb: DCB,
    pub dwProviderSubType: DWORD,
    pub dwProviderOffset: DWORD,
    pub dwProviderSize: DWORD,
    pub wcProviderData: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMMCONFIG"][::std::mem::size_of::<_COMMCONFIG>() - 52usize];
    ["Alignment of _COMMCONFIG"][::std::mem::align_of::<_COMMCONFIG>() - 4usize];
    ["Offset of field: _COMMCONFIG::dwSize"][::std::mem::offset_of!(_COMMCONFIG, dwSize) - 0usize];
    ["Offset of field: _COMMCONFIG::wVersion"]
        [::std::mem::offset_of!(_COMMCONFIG, wVersion) - 4usize];
    ["Offset of field: _COMMCONFIG::wReserved"]
        [::std::mem::offset_of!(_COMMCONFIG, wReserved) - 6usize];
    ["Offset of field: _COMMCONFIG::dcb"][::std::mem::offset_of!(_COMMCONFIG, dcb) - 8usize];
    ["Offset of field: _COMMCONFIG::dwProviderSubType"]
        [::std::mem::offset_of!(_COMMCONFIG, dwProviderSubType) - 36usize];
    ["Offset of field: _COMMCONFIG::dwProviderOffset"]
        [::std::mem::offset_of!(_COMMCONFIG, dwProviderOffset) - 40usize];
    ["Offset of field: _COMMCONFIG::dwProviderSize"]
        [::std::mem::offset_of!(_COMMCONFIG, dwProviderSize) - 44usize];
    ["Offset of field: _COMMCONFIG::wcProviderData"]
        [::std::mem::offset_of!(_COMMCONFIG, wcProviderData) - 48usize];
};
pub type COMMCONFIG = _COMMCONFIG;
pub type LPCOMMCONFIG = *mut _COMMCONFIG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MEMORYSTATUS {
    pub dwLength: DWORD,
    pub dwMemoryLoad: DWORD,
    pub dwTotalPhys: SIZE_T,
    pub dwAvailPhys: SIZE_T,
    pub dwTotalPageFile: SIZE_T,
    pub dwAvailPageFile: SIZE_T,
    pub dwTotalVirtual: SIZE_T,
    pub dwAvailVirtual: SIZE_T,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MEMORYSTATUS"][::std::mem::size_of::<_MEMORYSTATUS>() - 56usize];
    ["Alignment of _MEMORYSTATUS"][::std::mem::align_of::<_MEMORYSTATUS>() - 8usize];
    ["Offset of field: _MEMORYSTATUS::dwLength"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwLength) - 0usize];
    ["Offset of field: _MEMORYSTATUS::dwMemoryLoad"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwMemoryLoad) - 4usize];
    ["Offset of field: _MEMORYSTATUS::dwTotalPhys"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwTotalPhys) - 8usize];
    ["Offset of field: _MEMORYSTATUS::dwAvailPhys"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwAvailPhys) - 16usize];
    ["Offset of field: _MEMORYSTATUS::dwTotalPageFile"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwTotalPageFile) - 24usize];
    ["Offset of field: _MEMORYSTATUS::dwAvailPageFile"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwAvailPageFile) - 32usize];
    ["Offset of field: _MEMORYSTATUS::dwTotalVirtual"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwTotalVirtual) - 40usize];
    ["Offset of field: _MEMORYSTATUS::dwAvailVirtual"]
        [::std::mem::offset_of!(_MEMORYSTATUS, dwAvailVirtual) - 48usize];
};
pub type MEMORYSTATUS = _MEMORYSTATUS;
pub type LPMEMORYSTATUS = *mut _MEMORYSTATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JIT_DEBUG_INFO {
    pub dwSize: DWORD,
    pub dwProcessorArchitecture: DWORD,
    pub dwThreadID: DWORD,
    pub dwReserved0: DWORD,
    pub lpExceptionAddress: ULONG64,
    pub lpExceptionRecord: ULONG64,
    pub lpContextRecord: ULONG64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JIT_DEBUG_INFO"][::std::mem::size_of::<_JIT_DEBUG_INFO>() - 40usize];
    ["Alignment of _JIT_DEBUG_INFO"][::std::mem::align_of::<_JIT_DEBUG_INFO>() - 8usize];
    ["Offset of field: _JIT_DEBUG_INFO::dwSize"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, dwSize) - 0usize];
    ["Offset of field: _JIT_DEBUG_INFO::dwProcessorArchitecture"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, dwProcessorArchitecture) - 4usize];
    ["Offset of field: _JIT_DEBUG_INFO::dwThreadID"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, dwThreadID) - 8usize];
    ["Offset of field: _JIT_DEBUG_INFO::dwReserved0"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, dwReserved0) - 12usize];
    ["Offset of field: _JIT_DEBUG_INFO::lpExceptionAddress"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, lpExceptionAddress) - 16usize];
    ["Offset of field: _JIT_DEBUG_INFO::lpExceptionRecord"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, lpExceptionRecord) - 24usize];
    ["Offset of field: _JIT_DEBUG_INFO::lpContextRecord"]
        [::std::mem::offset_of!(_JIT_DEBUG_INFO, lpContextRecord) - 32usize];
};
pub type JIT_DEBUG_INFO = _JIT_DEBUG_INFO;
pub type LPJIT_DEBUG_INFO = *mut _JIT_DEBUG_INFO;
pub type JIT_DEBUG_INFO32 = JIT_DEBUG_INFO;
pub type LPJIT_DEBUG_INFO32 = *mut JIT_DEBUG_INFO;
pub type JIT_DEBUG_INFO64 = JIT_DEBUG_INFO;
pub type LPJIT_DEBUG_INFO64 = *mut JIT_DEBUG_INFO;
pub type LPEXCEPTION_RECORD = PEXCEPTION_RECORD;
pub type LPEXCEPTION_POINTERS = PEXCEPTION_POINTERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OFSTRUCT {
    pub cBytes: BYTE,
    pub fFixedDisk: BYTE,
    pub nErrCode: WORD,
    pub Reserved1: WORD,
    pub Reserved2: WORD,
    pub szPathName: [CHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OFSTRUCT"][::std::mem::size_of::<_OFSTRUCT>() - 136usize];
    ["Alignment of _OFSTRUCT"][::std::mem::align_of::<_OFSTRUCT>() - 2usize];
    ["Offset of field: _OFSTRUCT::cBytes"][::std::mem::offset_of!(_OFSTRUCT, cBytes) - 0usize];
    ["Offset of field: _OFSTRUCT::fFixedDisk"]
        [::std::mem::offset_of!(_OFSTRUCT, fFixedDisk) - 1usize];
    ["Offset of field: _OFSTRUCT::nErrCode"][::std::mem::offset_of!(_OFSTRUCT, nErrCode) - 2usize];
    ["Offset of field: _OFSTRUCT::Reserved1"]
        [::std::mem::offset_of!(_OFSTRUCT, Reserved1) - 4usize];
    ["Offset of field: _OFSTRUCT::Reserved2"]
        [::std::mem::offset_of!(_OFSTRUCT, Reserved2) - 6usize];
    ["Offset of field: _OFSTRUCT::szPathName"]
        [::std::mem::offset_of!(_OFSTRUCT, szPathName) - 8usize];
};
pub type OFSTRUCT = _OFSTRUCT;
pub type LPOFSTRUCT = *mut _OFSTRUCT;
pub type POFSTRUCT = *mut _OFSTRUCT;
unsafe extern "C" {
    pub fn WinMain(
        hInstance: HINSTANCE,
        hPrevInstance: HINSTANCE,
        lpCmdLine: LPSTR,
        nShowCmd: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wWinMain(
        hInstance: HINSTANCE,
        hPrevInstance: HINSTANCE,
        lpCmdLine: LPWSTR,
        nShowCmd: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GlobalAlloc(uFlags: UINT, dwBytes: SIZE_T) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn GlobalReAlloc(hMem: HGLOBAL, dwBytes: SIZE_T, uFlags: UINT) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn GlobalSize(hMem: HGLOBAL) -> SIZE_T;
}
unsafe extern "C" {
    pub fn GlobalUnlock(hMem: HGLOBAL) -> BOOL;
}
unsafe extern "C" {
    pub fn GlobalLock(hMem: HGLOBAL) -> LPVOID;
}
unsafe extern "C" {
    pub fn GlobalFlags(hMem: HGLOBAL) -> UINT;
}
unsafe extern "C" {
    pub fn GlobalHandle(pMem: LPCVOID) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn GlobalFree(hMem: HGLOBAL) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn GlobalCompact(dwMinFree: DWORD) -> SIZE_T;
}
unsafe extern "C" {
    pub fn GlobalFix(hMem: HGLOBAL);
}
unsafe extern "C" {
    pub fn GlobalUnfix(hMem: HGLOBAL);
}
unsafe extern "C" {
    pub fn GlobalWire(hMem: HGLOBAL) -> LPVOID;
}
unsafe extern "C" {
    pub fn GlobalUnWire(hMem: HGLOBAL) -> BOOL;
}
unsafe extern "C" {
    pub fn GlobalMemoryStatus(lpBuffer: LPMEMORYSTATUS);
}
unsafe extern "C" {
    pub fn LocalAlloc(uFlags: UINT, uBytes: SIZE_T) -> HLOCAL;
}
unsafe extern "C" {
    pub fn LocalReAlloc(hMem: HLOCAL, uBytes: SIZE_T, uFlags: UINT) -> HLOCAL;
}
unsafe extern "C" {
    pub fn LocalLock(hMem: HLOCAL) -> LPVOID;
}
unsafe extern "C" {
    pub fn LocalHandle(pMem: LPCVOID) -> HLOCAL;
}
unsafe extern "C" {
    pub fn LocalUnlock(hMem: HLOCAL) -> BOOL;
}
unsafe extern "C" {
    pub fn LocalSize(hMem: HLOCAL) -> SIZE_T;
}
unsafe extern "C" {
    pub fn LocalFlags(hMem: HLOCAL) -> UINT;
}
unsafe extern "C" {
    pub fn LocalFree(hMem: HLOCAL) -> HLOCAL;
}
unsafe extern "C" {
    pub fn LocalShrink(hMem: HLOCAL, cbNewSize: UINT) -> SIZE_T;
}
unsafe extern "C" {
    pub fn LocalCompact(uMinFree: UINT) -> SIZE_T;
}
unsafe extern "C" {
    pub fn GetBinaryTypeA(lpApplicationName: LPCSTR, lpBinaryType: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetBinaryTypeW(lpApplicationName: LPCWSTR, lpBinaryType: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetShortPathNameA(lpszLongPath: LPCSTR, lpszShortPath: LPSTR, cchBuffer: DWORD)
        -> DWORD;
}
unsafe extern "C" {
    pub fn GetLongPathNameTransactedA(
        lpszShortPath: LPCSTR,
        lpszLongPath: LPSTR,
        cchBuffer: DWORD,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetLongPathNameTransactedW(
        lpszShortPath: LPCWSTR,
        lpszLongPath: LPWSTR,
        cchBuffer: DWORD,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetProcessAffinityMask(
        hProcess: HANDLE,
        lpProcessAffinityMask: PDWORD_PTR,
        lpSystemAffinityMask: PDWORD_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessAffinityMask(hProcess: HANDLE, dwProcessAffinityMask: DWORD_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessIoCounters(hProcess: HANDLE, lpIoCounters: PIO_COUNTERS) -> BOOL;
}
unsafe extern "C" {
    pub fn FatalExit(ExitCode: ::std::os::raw::c_int);
}
unsafe extern "C" {
    pub fn SetEnvironmentStringsA(NewEnvironment: LPCH) -> BOOL;
}
unsafe extern "C" {
    pub fn SwitchToFiber(lpFiber: LPVOID);
}
unsafe extern "C" {
    pub fn DeleteFiber(lpFiber: LPVOID);
}
unsafe extern "C" {
    pub fn ConvertFiberToThread() -> BOOL;
}
unsafe extern "C" {
    pub fn CreateFiberEx(
        dwStackCommitSize: SIZE_T,
        dwStackReserveSize: SIZE_T,
        dwFlags: DWORD,
        lpStartAddress: LPFIBER_START_ROUTINE,
        lpParameter: LPVOID,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn ConvertThreadToFiberEx(lpParameter: LPVOID, dwFlags: DWORD) -> LPVOID;
}
unsafe extern "C" {
    pub fn CreateFiber(
        dwStackSize: SIZE_T,
        lpStartAddress: LPFIBER_START_ROUTINE,
        lpParameter: LPVOID,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn ConvertThreadToFiber(lpParameter: LPVOID) -> LPVOID;
}
pub type PUMS_CONTEXT = *mut ::std::os::raw::c_void;
pub type PUMS_COMPLETION_LIST = *mut ::std::os::raw::c_void;
pub use self::_RTL_UMS_THREAD_INFO_CLASS as UMS_THREAD_INFO_CLASS;
pub type PUMS_THREAD_INFO_CLASS = *mut _RTL_UMS_THREAD_INFO_CLASS;
pub use self::_RTL_UMS_SCHEDULER_REASON as UMS_SCHEDULER_REASON;
pub type PUMS_SCHEDULER_ENTRY_POINT = PRTL_UMS_SCHEDULER_ENTRY_POINT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UMS_SCHEDULER_STARTUP_INFO {
    pub UmsVersion: ULONG,
    pub CompletionList: PUMS_COMPLETION_LIST,
    pub SchedulerProc: PUMS_SCHEDULER_ENTRY_POINT,
    pub SchedulerParam: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UMS_SCHEDULER_STARTUP_INFO"]
        [::std::mem::size_of::<_UMS_SCHEDULER_STARTUP_INFO>() - 32usize];
    ["Alignment of _UMS_SCHEDULER_STARTUP_INFO"]
        [::std::mem::align_of::<_UMS_SCHEDULER_STARTUP_INFO>() - 8usize];
    ["Offset of field: _UMS_SCHEDULER_STARTUP_INFO::UmsVersion"]
        [::std::mem::offset_of!(_UMS_SCHEDULER_STARTUP_INFO, UmsVersion) - 0usize];
    ["Offset of field: _UMS_SCHEDULER_STARTUP_INFO::CompletionList"]
        [::std::mem::offset_of!(_UMS_SCHEDULER_STARTUP_INFO, CompletionList) - 8usize];
    ["Offset of field: _UMS_SCHEDULER_STARTUP_INFO::SchedulerProc"]
        [::std::mem::offset_of!(_UMS_SCHEDULER_STARTUP_INFO, SchedulerProc) - 16usize];
    ["Offset of field: _UMS_SCHEDULER_STARTUP_INFO::SchedulerParam"]
        [::std::mem::offset_of!(_UMS_SCHEDULER_STARTUP_INFO, SchedulerParam) - 24usize];
};
pub type UMS_SCHEDULER_STARTUP_INFO = _UMS_SCHEDULER_STARTUP_INFO;
pub type PUMS_SCHEDULER_STARTUP_INFO = *mut _UMS_SCHEDULER_STARTUP_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _UMS_SYSTEM_THREAD_INFORMATION {
    pub UmsVersion: ULONG,
    pub __bindgen_anon_1: _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1 {
    pub __bindgen_anon_1: _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    pub ThreadUmsFlags: ULONG,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
};
impl _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn IsUmsSchedulerThread(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_IsUmsSchedulerThread(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IsUmsSchedulerThread_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IsUmsSchedulerThread_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn IsUmsWorkerThread(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_IsUmsWorkerThread(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IsUmsWorkerThread_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IsUmsWorkerThread_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        IsUmsSchedulerThread: ULONG,
        IsUmsWorkerThread: ULONG,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let IsUmsSchedulerThread: u32 = unsafe { ::std::mem::transmute(IsUmsSchedulerThread) };
            IsUmsSchedulerThread as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let IsUmsWorkerThread: u32 = unsafe { ::std::mem::transmute(IsUmsWorkerThread) };
            IsUmsWorkerThread as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1>() - 4usize];
    ["Offset of field: _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1::ThreadUmsFlags"][::std::mem::offset_of!(
        _UMS_SYSTEM_THREAD_INFORMATION__bindgen_ty_1,
        ThreadUmsFlags
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UMS_SYSTEM_THREAD_INFORMATION"]
        [::std::mem::size_of::<_UMS_SYSTEM_THREAD_INFORMATION>() - 8usize];
    ["Alignment of _UMS_SYSTEM_THREAD_INFORMATION"]
        [::std::mem::align_of::<_UMS_SYSTEM_THREAD_INFORMATION>() - 4usize];
    ["Offset of field: _UMS_SYSTEM_THREAD_INFORMATION::UmsVersion"]
        [::std::mem::offset_of!(_UMS_SYSTEM_THREAD_INFORMATION, UmsVersion) - 0usize];
};
pub type UMS_SYSTEM_THREAD_INFORMATION = _UMS_SYSTEM_THREAD_INFORMATION;
pub type PUMS_SYSTEM_THREAD_INFORMATION = *mut _UMS_SYSTEM_THREAD_INFORMATION;
unsafe extern "C" {
    pub fn CreateUmsCompletionList(UmsCompletionList: *mut PUMS_COMPLETION_LIST) -> BOOL;
}
unsafe extern "C" {
    pub fn DequeueUmsCompletionListItems(
        UmsCompletionList: PUMS_COMPLETION_LIST,
        WaitTimeOut: DWORD,
        UmsThreadList: *mut PUMS_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUmsCompletionListEvent(
        UmsCompletionList: PUMS_COMPLETION_LIST,
        UmsCompletionEvent: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ExecuteUmsThread(UmsThread: PUMS_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn UmsThreadYield(SchedulerParam: PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteUmsCompletionList(UmsCompletionList: PUMS_COMPLETION_LIST) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentUmsThread() -> PUMS_CONTEXT;
}
unsafe extern "C" {
    pub fn GetNextUmsListItem(UmsContext: PUMS_CONTEXT) -> PUMS_CONTEXT;
}
unsafe extern "C" {
    pub fn QueryUmsThreadInformation(
        UmsThread: PUMS_CONTEXT,
        UmsThreadInfoClass: UMS_THREAD_INFO_CLASS,
        UmsThreadInformation: PVOID,
        UmsThreadInformationLength: ULONG,
        ReturnLength: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetUmsThreadInformation(
        UmsThread: PUMS_CONTEXT,
        UmsThreadInfoClass: UMS_THREAD_INFO_CLASS,
        UmsThreadInformation: PVOID,
        UmsThreadInformationLength: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteUmsThreadContext(UmsThread: PUMS_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateUmsThreadContext(lpUmsThread: *mut PUMS_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn EnterUmsSchedulingMode(SchedulerStartupInfo: PUMS_SCHEDULER_STARTUP_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUmsSystemThreadInformation(
        ThreadHandle: HANDLE,
        SystemThreadInfo: PUMS_SYSTEM_THREAD_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadAffinityMask(hThread: HANDLE, dwThreadAffinityMask: DWORD_PTR) -> DWORD_PTR;
}
unsafe extern "C" {
    pub fn SetProcessDEPPolicy(dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessDEPPolicy(hProcess: HANDLE, lpFlags: LPDWORD, lpPermanent: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn RequestWakeupLatency(latency: LATENCY_TIME) -> BOOL;
}
unsafe extern "C" {
    pub fn IsSystemResumeAutomatic() -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadSelectorEntry(
        hThread: HANDLE,
        dwSelector: DWORD,
        lpSelectorEntry: LPLDT_ENTRY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadExecutionState(esFlags: EXECUTION_STATE) -> EXECUTION_STATE;
}
pub type POWER_REQUEST_CONTEXT = REASON_CONTEXT;
pub type PPOWER_REQUEST_CONTEXT = *mut REASON_CONTEXT;
pub type LPPOWER_REQUEST_CONTEXT = *mut REASON_CONTEXT;
unsafe extern "C" {
    pub fn PowerCreateRequest(Context: PREASON_CONTEXT) -> HANDLE;
}
unsafe extern "C" {
    pub fn PowerSetRequest(PowerRequest: HANDLE, RequestType: POWER_REQUEST_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn PowerClearRequest(PowerRequest: HANDLE, RequestType: POWER_REQUEST_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileCompletionNotificationModes(FileHandle: HANDLE, Flags: UCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn Wow64GetThreadSelectorEntry(
        hThread: HANDLE,
        dwSelector: DWORD,
        lpSelectorEntry: PWOW64_LDT_ENTRY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DebugSetProcessKillOnExit(KillOnExit: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn DebugBreakProcess(Process: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn PulseEvent(hEvent: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GlobalDeleteAtom(nAtom: ATOM) -> ATOM;
}
unsafe extern "C" {
    pub fn InitAtomTable(nSize: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteAtom(nAtom: ATOM) -> ATOM;
}
unsafe extern "C" {
    pub fn SetHandleCount(uNumber: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn RequestDeviceWakeup(hDevice: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelDeviceWakeupRequest(hDevice: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDevicePowerState(hDevice: HANDLE, pfOn: *mut BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMessageWaitingIndicator(hMsgIndicator: HANDLE, ulMsgCount: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileShortNameA(hFile: HANDLE, lpShortName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileShortNameW(hFile: HANDLE, lpShortName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn LoadModule(lpModuleName: LPCSTR, lpParameterBlock: LPVOID) -> DWORD;
}
unsafe extern "C" {
    pub fn WinExec(lpCmdLine: LPCSTR, uCmdShow: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn ClearCommBreak(hFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ClearCommError(hFile: HANDLE, lpErrors: LPDWORD, lpStat: LPCOMSTAT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetupComm(hFile: HANDLE, dwInQueue: DWORD, dwOutQueue: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EscapeCommFunction(hFile: HANDLE, dwFunc: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommConfig(hCommDev: HANDLE, lpCC: LPCOMMCONFIG, lpdwSize: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommMask(hFile: HANDLE, lpEvtMask: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommProperties(hFile: HANDLE, lpCommProp: LPCOMMPROP) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommModemStatus(hFile: HANDLE, lpModemStat: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommState(hFile: HANDLE, lpDCB: LPDCB) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCommTimeouts(hFile: HANDLE, lpCommTimeouts: LPCOMMTIMEOUTS) -> BOOL;
}
unsafe extern "C" {
    pub fn PurgeComm(hFile: HANDLE, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCommBreak(hFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCommConfig(hCommDev: HANDLE, lpCC: LPCOMMCONFIG, dwSize: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCommMask(hFile: HANDLE, dwEvtMask: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCommState(hFile: HANDLE, lpDCB: LPDCB) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCommTimeouts(hFile: HANDLE, lpCommTimeouts: LPCOMMTIMEOUTS) -> BOOL;
}
unsafe extern "C" {
    pub fn TransmitCommChar(hFile: HANDLE, cChar: ::std::os::raw::c_char) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitCommEvent(hFile: HANDLE, lpEvtMask: LPDWORD, lpOverlapped: LPOVERLAPPED) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenCommPort(
        uPortNumber: ULONG,
        dwDesiredAccess: DWORD,
        dwFlagsAndAttributes: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetCommPorts(
        lpPortNumbers: PULONG,
        uPortNumbersCount: ULONG,
        puPortNumbersFound: PULONG,
    ) -> ULONG;
}
unsafe extern "C" {
    pub fn SetTapePosition(
        hDevice: HANDLE,
        dwPositionMethod: DWORD,
        dwPartition: DWORD,
        dwOffsetLow: DWORD,
        dwOffsetHigh: DWORD,
        bImmediate: BOOL,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTapePosition(
        hDevice: HANDLE,
        dwPositionType: DWORD,
        lpdwPartition: LPDWORD,
        lpdwOffsetLow: LPDWORD,
        lpdwOffsetHigh: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn PrepareTape(hDevice: HANDLE, dwOperation: DWORD, bImmediate: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn EraseTape(hDevice: HANDLE, dwEraseType: DWORD, bImmediate: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn CreateTapePartition(
        hDevice: HANDLE,
        dwPartitionMethod: DWORD,
        dwCount: DWORD,
        dwSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WriteTapemark(
        hDevice: HANDLE,
        dwTapemarkType: DWORD,
        dwTapemarkCount: DWORD,
        bImmediate: BOOL,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTapeStatus(hDevice: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTapeParameters(
        hDevice: HANDLE,
        dwOperation: DWORD,
        lpdwSize: LPDWORD,
        lpTapeInformation: LPVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetTapeParameters(
        hDevice: HANDLE,
        dwOperation: DWORD,
        lpTapeInformation: LPVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn MulDiv(
        nNumber: ::std::os::raw::c_int,
        nNumerator: ::std::os::raw::c_int,
        nDenominator: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
pub const _DEP_SYSTEM_POLICY_TYPE_DEPPolicyAlwaysOff: _DEP_SYSTEM_POLICY_TYPE = 0;
pub const _DEP_SYSTEM_POLICY_TYPE_DEPPolicyAlwaysOn: _DEP_SYSTEM_POLICY_TYPE = 1;
pub const _DEP_SYSTEM_POLICY_TYPE_DEPPolicyOptIn: _DEP_SYSTEM_POLICY_TYPE = 2;
pub const _DEP_SYSTEM_POLICY_TYPE_DEPPolicyOptOut: _DEP_SYSTEM_POLICY_TYPE = 3;
pub const _DEP_SYSTEM_POLICY_TYPE_DEPTotalPolicyCount: _DEP_SYSTEM_POLICY_TYPE = 4;
pub type _DEP_SYSTEM_POLICY_TYPE = ::std::os::raw::c_int;
pub use self::_DEP_SYSTEM_POLICY_TYPE as DEP_SYSTEM_POLICY_TYPE;
unsafe extern "C" {
    pub fn GetSystemDEPPolicy() -> DEP_SYSTEM_POLICY_TYPE;
}
unsafe extern "C" {
    pub fn GetSystemRegistryQuota(pdwQuotaAllowed: PDWORD, pdwQuotaUsed: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn FileTimeToDosDateTime(
        lpFileTime: *const FILETIME,
        lpFatDate: LPWORD,
        lpFatTime: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DosDateTimeToFileTime(wFatDate: WORD, wFatTime: WORD, lpFileTime: LPFILETIME) -> BOOL;
}
unsafe extern "C" {
    pub fn FormatMessageA(
        dwFlags: DWORD,
        lpSource: LPCVOID,
        dwMessageId: DWORD,
        dwLanguageId: DWORD,
        lpBuffer: LPSTR,
        nSize: DWORD,
        Arguments: *mut va_list,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn FormatMessageW(
        dwFlags: DWORD,
        lpSource: LPCVOID,
        dwMessageId: DWORD,
        dwLanguageId: DWORD,
        lpBuffer: LPWSTR,
        nSize: DWORD,
        Arguments: *mut va_list,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CreateMailslotA(
        lpName: LPCSTR,
        nMaxMessageSize: DWORD,
        lReadTimeout: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateMailslotW(
        lpName: LPCWSTR,
        nMaxMessageSize: DWORD,
        lReadTimeout: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetMailslotInfo(
        hMailslot: HANDLE,
        lpMaxMessageSize: LPDWORD,
        lpNextSize: LPDWORD,
        lpMessageCount: LPDWORD,
        lpReadTimeout: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMailslotInfo(hMailslot: HANDLE, lReadTimeout: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EncryptFileA(lpFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn EncryptFileW(lpFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DecryptFileA(lpFileName: LPCSTR, dwReserved: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DecryptFileW(lpFileName: LPCWSTR, dwReserved: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn FileEncryptionStatusA(lpFileName: LPCSTR, lpStatus: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn FileEncryptionStatusW(lpFileName: LPCWSTR, lpStatus: LPDWORD) -> BOOL;
}
pub type PFE_EXPORT_FUNC = ::std::option::Option<
    unsafe extern "C" fn(pbData: PBYTE, pvCallbackContext: PVOID, ulLength: ULONG) -> DWORD,
>;
pub type PFE_IMPORT_FUNC = ::std::option::Option<
    unsafe extern "C" fn(pbData: PBYTE, pvCallbackContext: PVOID, ulLength: PULONG) -> DWORD,
>;
unsafe extern "C" {
    pub fn OpenEncryptedFileRawA(
        lpFileName: LPCSTR,
        ulFlags: ULONG,
        pvContext: *mut PVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn OpenEncryptedFileRawW(
        lpFileName: LPCWSTR,
        ulFlags: ULONG,
        pvContext: *mut PVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ReadEncryptedFileRaw(
        pfExportCallback: PFE_EXPORT_FUNC,
        pvCallbackContext: PVOID,
        pvContext: PVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WriteEncryptedFileRaw(
        pfImportCallback: PFE_IMPORT_FUNC,
        pvCallbackContext: PVOID,
        pvContext: PVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CloseEncryptedFileRaw(pvContext: PVOID);
}
unsafe extern "C" {
    pub fn lstrcmpA(lpString1: LPCSTR, lpString2: LPCSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn lstrcmpW(lpString1: LPCWSTR, lpString2: LPCWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn lstrcmpiA(lpString1: LPCSTR, lpString2: LPCSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn lstrcmpiW(lpString1: LPCWSTR, lpString2: LPCWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn lstrcpynA(
        lpString1: LPSTR,
        lpString2: LPCSTR,
        iMaxLength: ::std::os::raw::c_int,
    ) -> LPSTR;
}
unsafe extern "C" {
    pub fn lstrcpynW(
        lpString1: LPWSTR,
        lpString2: LPCWSTR,
        iMaxLength: ::std::os::raw::c_int,
    ) -> LPWSTR;
}
unsafe extern "C" {
    pub fn lstrcpyA(lpString1: LPSTR, lpString2: LPCSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn lstrcpyW(lpString1: LPWSTR, lpString2: LPCWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn lstrcatA(lpString1: LPSTR, lpString2: LPCSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn lstrcatW(lpString1: LPWSTR, lpString2: LPCWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn lstrlenA(lpString: LPCSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn lstrlenW(lpString: LPCWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn OpenFile(lpFileName: LPCSTR, lpReOpenBuff: LPOFSTRUCT, uStyle: UINT) -> HFILE;
}
unsafe extern "C" {
    pub fn _lopen(lpPathName: LPCSTR, iReadWrite: ::std::os::raw::c_int) -> HFILE;
}
unsafe extern "C" {
    pub fn _lcreat(lpPathName: LPCSTR, iAttribute: ::std::os::raw::c_int) -> HFILE;
}
unsafe extern "C" {
    pub fn _lread(hFile: HFILE, lpBuffer: LPVOID, uBytes: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn _lwrite(hFile: HFILE, lpBuffer: LPCCH, uBytes: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn _hread(
        hFile: HFILE,
        lpBuffer: LPVOID,
        lBytes: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _hwrite(
        hFile: HFILE,
        lpBuffer: LPCCH,
        lBytes: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _lclose(hFile: HFILE) -> HFILE;
}
unsafe extern "C" {
    pub fn _llseek(hFile: HFILE, lOffset: LONG, iOrigin: ::std::os::raw::c_int) -> LONG;
}
unsafe extern "C" {
    pub fn IsTextUnicode(
        lpv: *const ::std::os::raw::c_void,
        iSize: ::std::os::raw::c_int,
        lpiResult: LPINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BackupRead(
        hFile: HANDLE,
        lpBuffer: LPBYTE,
        nNumberOfBytesToRead: DWORD,
        lpNumberOfBytesRead: LPDWORD,
        bAbort: BOOL,
        bProcessSecurity: BOOL,
        lpContext: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BackupSeek(
        hFile: HANDLE,
        dwLowBytesToSeek: DWORD,
        dwHighBytesToSeek: DWORD,
        lpdwLowByteSeeked: LPDWORD,
        lpdwHighByteSeeked: LPDWORD,
        lpContext: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BackupWrite(
        hFile: HANDLE,
        lpBuffer: LPBYTE,
        nNumberOfBytesToWrite: DWORD,
        lpNumberOfBytesWritten: LPDWORD,
        bAbort: BOOL,
        bProcessSecurity: BOOL,
        lpContext: *mut LPVOID,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIN32_STREAM_ID {
    pub dwStreamId: DWORD,
    pub dwStreamAttributes: DWORD,
    pub Size: LARGE_INTEGER,
    pub dwStreamNameSize: DWORD,
    pub cStreamName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIN32_STREAM_ID"][::std::mem::size_of::<_WIN32_STREAM_ID>() - 24usize];
    ["Alignment of _WIN32_STREAM_ID"][::std::mem::align_of::<_WIN32_STREAM_ID>() - 8usize];
    ["Offset of field: _WIN32_STREAM_ID::dwStreamId"]
        [::std::mem::offset_of!(_WIN32_STREAM_ID, dwStreamId) - 0usize];
    ["Offset of field: _WIN32_STREAM_ID::dwStreamAttributes"]
        [::std::mem::offset_of!(_WIN32_STREAM_ID, dwStreamAttributes) - 4usize];
    ["Offset of field: _WIN32_STREAM_ID::Size"]
        [::std::mem::offset_of!(_WIN32_STREAM_ID, Size) - 8usize];
    ["Offset of field: _WIN32_STREAM_ID::dwStreamNameSize"]
        [::std::mem::offset_of!(_WIN32_STREAM_ID, dwStreamNameSize) - 16usize];
    ["Offset of field: _WIN32_STREAM_ID::cStreamName"]
        [::std::mem::offset_of!(_WIN32_STREAM_ID, cStreamName) - 20usize];
};
pub type WIN32_STREAM_ID = _WIN32_STREAM_ID;
pub type LPWIN32_STREAM_ID = *mut _WIN32_STREAM_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STARTUPINFOEXA {
    pub StartupInfo: STARTUPINFOA,
    pub lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STARTUPINFOEXA"][::std::mem::size_of::<_STARTUPINFOEXA>() - 112usize];
    ["Alignment of _STARTUPINFOEXA"][::std::mem::align_of::<_STARTUPINFOEXA>() - 8usize];
    ["Offset of field: _STARTUPINFOEXA::StartupInfo"]
        [::std::mem::offset_of!(_STARTUPINFOEXA, StartupInfo) - 0usize];
    ["Offset of field: _STARTUPINFOEXA::lpAttributeList"]
        [::std::mem::offset_of!(_STARTUPINFOEXA, lpAttributeList) - 104usize];
};
pub type STARTUPINFOEXA = _STARTUPINFOEXA;
pub type LPSTARTUPINFOEXA = *mut _STARTUPINFOEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STARTUPINFOEXW {
    pub StartupInfo: STARTUPINFOW,
    pub lpAttributeList: LPPROC_THREAD_ATTRIBUTE_LIST,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STARTUPINFOEXW"][::std::mem::size_of::<_STARTUPINFOEXW>() - 112usize];
    ["Alignment of _STARTUPINFOEXW"][::std::mem::align_of::<_STARTUPINFOEXW>() - 8usize];
    ["Offset of field: _STARTUPINFOEXW::StartupInfo"]
        [::std::mem::offset_of!(_STARTUPINFOEXW, StartupInfo) - 0usize];
    ["Offset of field: _STARTUPINFOEXW::lpAttributeList"]
        [::std::mem::offset_of!(_STARTUPINFOEXW, lpAttributeList) - 104usize];
};
pub type STARTUPINFOEXW = _STARTUPINFOEXW;
pub type LPSTARTUPINFOEXW = *mut _STARTUPINFOEXW;
pub type STARTUPINFOEX = STARTUPINFOEXA;
pub type LPSTARTUPINFOEX = LPSTARTUPINFOEXA;
unsafe extern "C" {
    pub fn OpenMutexA(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateSemaphoreA(
        lpSemaphoreAttributes: LPSECURITY_ATTRIBUTES,
        lInitialCount: LONG,
        lMaximumCount: LONG,
        lpName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenSemaphoreA(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateWaitableTimerA(
        lpTimerAttributes: LPSECURITY_ATTRIBUTES,
        bManualReset: BOOL,
        lpTimerName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenWaitableTimerA(
        dwDesiredAccess: DWORD,
        bInheritHandle: BOOL,
        lpTimerName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateSemaphoreExA(
        lpSemaphoreAttributes: LPSECURITY_ATTRIBUTES,
        lInitialCount: LONG,
        lMaximumCount: LONG,
        lpName: LPCSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateWaitableTimerExA(
        lpTimerAttributes: LPSECURITY_ATTRIBUTES,
        lpTimerName: LPCSTR,
        dwFlags: DWORD,
        dwDesiredAccess: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateFileMappingA(
        hFile: HANDLE,
        lpFileMappingAttributes: LPSECURITY_ATTRIBUTES,
        flProtect: DWORD,
        dwMaximumSizeHigh: DWORD,
        dwMaximumSizeLow: DWORD,
        lpName: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateFileMappingNumaA(
        hFile: HANDLE,
        lpFileMappingAttributes: LPSECURITY_ATTRIBUTES,
        flProtect: DWORD,
        dwMaximumSizeHigh: DWORD,
        dwMaximumSizeLow: DWORD,
        lpName: LPCSTR,
        nndPreferred: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenFileMappingA(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCSTR)
        -> HANDLE;
}
unsafe extern "C" {
    pub fn GetLogicalDriveStringsA(nBufferLength: DWORD, lpBuffer: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn LoadPackagedLibrary(lpwLibFileName: LPCWSTR, Reserved: DWORD) -> HMODULE;
}
unsafe extern "C" {
    pub fn QueryFullProcessImageNameA(
        hProcess: HANDLE,
        dwFlags: DWORD,
        lpExeName: LPSTR,
        lpdwSize: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryFullProcessImageNameW(
        hProcess: HANDLE,
        dwFlags: DWORD,
        lpExeName: LPWSTR,
        lpdwSize: PDWORD,
    ) -> BOOL;
}
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeParentProcess: _PROC_THREAD_ATTRIBUTE_NUM =
    0;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeHandleList: _PROC_THREAD_ATTRIBUTE_NUM = 2;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeGroupAffinity: _PROC_THREAD_ATTRIBUTE_NUM =
    3;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributePreferredNode: _PROC_THREAD_ATTRIBUTE_NUM =
    4;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeIdealProcessor: _PROC_THREAD_ATTRIBUTE_NUM =
    5;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeUmsThread: _PROC_THREAD_ATTRIBUTE_NUM = 6;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeMitigationPolicy:
    _PROC_THREAD_ATTRIBUTE_NUM = 7;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeSecurityCapabilities:
    _PROC_THREAD_ATTRIBUTE_NUM = 9;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeProtectionLevel:
    _PROC_THREAD_ATTRIBUTE_NUM = 11;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeJobList: _PROC_THREAD_ATTRIBUTE_NUM = 13;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeChildProcessPolicy:
    _PROC_THREAD_ATTRIBUTE_NUM = 14;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeAllApplicationPackagesPolicy:
    _PROC_THREAD_ATTRIBUTE_NUM = 15;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeWin32kFilter: _PROC_THREAD_ATTRIBUTE_NUM =
    16;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeSafeOpenPromptOriginClaim:
    _PROC_THREAD_ATTRIBUTE_NUM = 17;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeDesktopAppPolicy:
    _PROC_THREAD_ATTRIBUTE_NUM = 18;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributePseudoConsole: _PROC_THREAD_ATTRIBUTE_NUM =
    22;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeMitigationAuditPolicy:
    _PROC_THREAD_ATTRIBUTE_NUM = 24;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeMachineType: _PROC_THREAD_ATTRIBUTE_NUM =
    25;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeComponentFilter:
    _PROC_THREAD_ATTRIBUTE_NUM = 26;
pub const _PROC_THREAD_ATTRIBUTE_NUM_ProcThreadAttributeEnableOptionalXStateFeatures:
    _PROC_THREAD_ATTRIBUTE_NUM = 27;
pub type _PROC_THREAD_ATTRIBUTE_NUM = ::std::os::raw::c_int;
pub use self::_PROC_THREAD_ATTRIBUTE_NUM as PROC_THREAD_ATTRIBUTE_NUM;
unsafe extern "C" {
    pub fn GetStartupInfoA(lpStartupInfo: LPSTARTUPINFOA);
}
unsafe extern "C" {
    pub fn GetFirmwareEnvironmentVariableA(
        lpName: LPCSTR,
        lpGuid: LPCSTR,
        pBuffer: PVOID,
        nSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFirmwareEnvironmentVariableW(
        lpName: LPCWSTR,
        lpGuid: LPCWSTR,
        pBuffer: PVOID,
        nSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFirmwareEnvironmentVariableExA(
        lpName: LPCSTR,
        lpGuid: LPCSTR,
        pBuffer: PVOID,
        nSize: DWORD,
        pdwAttribubutes: PDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFirmwareEnvironmentVariableExW(
        lpName: LPCWSTR,
        lpGuid: LPCWSTR,
        pBuffer: PVOID,
        nSize: DWORD,
        pdwAttribubutes: PDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetFirmwareEnvironmentVariableA(
        lpName: LPCSTR,
        lpGuid: LPCSTR,
        pValue: PVOID,
        nSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFirmwareEnvironmentVariableW(
        lpName: LPCWSTR,
        lpGuid: LPCWSTR,
        pValue: PVOID,
        nSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFirmwareEnvironmentVariableExA(
        lpName: LPCSTR,
        lpGuid: LPCSTR,
        pValue: PVOID,
        nSize: DWORD,
        dwAttributes: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFirmwareEnvironmentVariableExW(
        lpName: LPCWSTR,
        lpGuid: LPCWSTR,
        pValue: PVOID,
        nSize: DWORD,
        dwAttributes: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFirmwareType(FirmwareType: PFIRMWARE_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn IsNativeVhdBoot(NativeVhdBoot: PBOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn FindResourceA(hModule: HMODULE, lpName: LPCSTR, lpType: LPCSTR) -> HRSRC;
}
unsafe extern "C" {
    pub fn FindResourceExA(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpName: LPCSTR,
        wLanguage: WORD,
    ) -> HRSRC;
}
unsafe extern "C" {
    pub fn EnumResourceTypesA(
        hModule: HMODULE,
        lpEnumFunc: ENUMRESTYPEPROCA,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceTypesW(
        hModule: HMODULE,
        lpEnumFunc: ENUMRESTYPEPROCW,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceLanguagesA(
        hModule: HMODULE,
        lpType: LPCSTR,
        lpName: LPCSTR,
        lpEnumFunc: ENUMRESLANGPROCA,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumResourceLanguagesW(
        hModule: HMODULE,
        lpType: LPCWSTR,
        lpName: LPCWSTR,
        lpEnumFunc: ENUMRESLANGPROCW,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BeginUpdateResourceA(pFileName: LPCSTR, bDeleteExistingResources: BOOL) -> HANDLE;
}
unsafe extern "C" {
    pub fn BeginUpdateResourceW(pFileName: LPCWSTR, bDeleteExistingResources: BOOL) -> HANDLE;
}
unsafe extern "C" {
    pub fn UpdateResourceA(
        hUpdate: HANDLE,
        lpType: LPCSTR,
        lpName: LPCSTR,
        wLanguage: WORD,
        lpData: LPVOID,
        cb: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UpdateResourceW(
        hUpdate: HANDLE,
        lpType: LPCWSTR,
        lpName: LPCWSTR,
        wLanguage: WORD,
        lpData: LPVOID,
        cb: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EndUpdateResourceA(hUpdate: HANDLE, fDiscard: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn EndUpdateResourceW(hUpdate: HANDLE, fDiscard: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GlobalAddAtomA(lpString: LPCSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalAddAtomW(lpString: LPCWSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalAddAtomExA(lpString: LPCSTR, Flags: DWORD) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalAddAtomExW(lpString: LPCWSTR, Flags: DWORD) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalFindAtomA(lpString: LPCSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalFindAtomW(lpString: LPCWSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn GlobalGetAtomNameA(nAtom: ATOM, lpBuffer: LPSTR, nSize: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn GlobalGetAtomNameW(nAtom: ATOM, lpBuffer: LPWSTR, nSize: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn AddAtomA(lpString: LPCSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn AddAtomW(lpString: LPCWSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn FindAtomA(lpString: LPCSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn FindAtomW(lpString: LPCWSTR) -> ATOM;
}
unsafe extern "C" {
    pub fn GetAtomNameA(nAtom: ATOM, lpBuffer: LPSTR, nSize: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn GetAtomNameW(nAtom: ATOM, lpBuffer: LPWSTR, nSize: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn GetProfileIntA(lpAppName: LPCSTR, lpKeyName: LPCSTR, nDefault: INT) -> UINT;
}
unsafe extern "C" {
    pub fn GetProfileIntW(lpAppName: LPCWSTR, lpKeyName: LPCWSTR, nDefault: INT) -> UINT;
}
unsafe extern "C" {
    pub fn GetProfileStringA(
        lpAppName: LPCSTR,
        lpKeyName: LPCSTR,
        lpDefault: LPCSTR,
        lpReturnedString: LPSTR,
        nSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetProfileStringW(
        lpAppName: LPCWSTR,
        lpKeyName: LPCWSTR,
        lpDefault: LPCWSTR,
        lpReturnedString: LPWSTR,
        nSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WriteProfileStringA(lpAppName: LPCSTR, lpKeyName: LPCSTR, lpString: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteProfileStringW(lpAppName: LPCWSTR, lpKeyName: LPCWSTR, lpString: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProfileSectionA(lpAppName: LPCSTR, lpReturnedString: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetProfileSectionW(lpAppName: LPCWSTR, lpReturnedString: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn WriteProfileSectionA(lpAppName: LPCSTR, lpString: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteProfileSectionW(lpAppName: LPCWSTR, lpString: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrivateProfileIntA(
        lpAppName: LPCSTR,
        lpKeyName: LPCSTR,
        nDefault: INT,
        lpFileName: LPCSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetPrivateProfileIntW(
        lpAppName: LPCWSTR,
        lpKeyName: LPCWSTR,
        nDefault: INT,
        lpFileName: LPCWSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetPrivateProfileStringA(
        lpAppName: LPCSTR,
        lpKeyName: LPCSTR,
        lpDefault: LPCSTR,
        lpReturnedString: LPSTR,
        nSize: DWORD,
        lpFileName: LPCSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrivateProfileStringW(
        lpAppName: LPCWSTR,
        lpKeyName: LPCWSTR,
        lpDefault: LPCWSTR,
        lpReturnedString: LPWSTR,
        nSize: DWORD,
        lpFileName: LPCWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WritePrivateProfileStringA(
        lpAppName: LPCSTR,
        lpKeyName: LPCSTR,
        lpString: LPCSTR,
        lpFileName: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WritePrivateProfileStringW(
        lpAppName: LPCWSTR,
        lpKeyName: LPCWSTR,
        lpString: LPCWSTR,
        lpFileName: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrivateProfileSectionA(
        lpAppName: LPCSTR,
        lpReturnedString: LPSTR,
        nSize: DWORD,
        lpFileName: LPCSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrivateProfileSectionW(
        lpAppName: LPCWSTR,
        lpReturnedString: LPWSTR,
        nSize: DWORD,
        lpFileName: LPCWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WritePrivateProfileSectionA(
        lpAppName: LPCSTR,
        lpString: LPCSTR,
        lpFileName: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WritePrivateProfileSectionW(
        lpAppName: LPCWSTR,
        lpString: LPCWSTR,
        lpFileName: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrivateProfileSectionNamesA(
        lpszReturnBuffer: LPSTR,
        nSize: DWORD,
        lpFileName: LPCSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrivateProfileSectionNamesW(
        lpszReturnBuffer: LPWSTR,
        nSize: DWORD,
        lpFileName: LPCWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrivateProfileStructA(
        lpszSection: LPCSTR,
        lpszKey: LPCSTR,
        lpStruct: LPVOID,
        uSizeStruct: UINT,
        szFile: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrivateProfileStructW(
        lpszSection: LPCWSTR,
        lpszKey: LPCWSTR,
        lpStruct: LPVOID,
        uSizeStruct: UINT,
        szFile: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WritePrivateProfileStructA(
        lpszSection: LPCSTR,
        lpszKey: LPCSTR,
        lpStruct: LPVOID,
        uSizeStruct: UINT,
        szFile: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WritePrivateProfileStructW(
        lpszSection: LPCWSTR,
        lpszKey: LPCWSTR,
        lpStruct: LPVOID,
        uSizeStruct: UINT,
        szFile: LPCWSTR,
    ) -> BOOL;
}
pub type PGET_SYSTEM_WOW64_DIRECTORY_A =
    ::std::option::Option<unsafe extern "C" fn(lpBuffer: LPSTR, uSize: UINT) -> UINT>;
pub type PGET_SYSTEM_WOW64_DIRECTORY_W =
    ::std::option::Option<unsafe extern "C" fn(lpBuffer: LPWSTR, uSize: UINT) -> UINT>;
unsafe extern "C" {
    pub fn SetDllDirectoryA(lpPathName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDllDirectoryW(lpPathName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDllDirectoryA(nBufferLength: DWORD, lpBuffer: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetDllDirectoryW(nBufferLength: DWORD, lpBuffer: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn SetSearchPathMode(Flags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryExA(
        lpTemplateDirectory: LPCSTR,
        lpNewDirectory: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryExW(
        lpTemplateDirectory: LPCWSTR,
        lpNewDirectory: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryTransactedA(
        lpTemplateDirectory: LPCSTR,
        lpNewDirectory: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDirectoryTransactedW(
        lpTemplateDirectory: LPCWSTR,
        lpNewDirectory: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveDirectoryTransactedA(lpPathName: LPCSTR, hTransaction: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveDirectoryTransactedW(lpPathName: LPCWSTR, hTransaction: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFullPathNameTransactedA(
        lpFileName: LPCSTR,
        nBufferLength: DWORD,
        lpBuffer: LPSTR,
        lpFilePart: *mut LPSTR,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFullPathNameTransactedW(
        lpFileName: LPCWSTR,
        nBufferLength: DWORD,
        lpBuffer: LPWSTR,
        lpFilePart: *mut LPWSTR,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DefineDosDeviceA(dwFlags: DWORD, lpDeviceName: LPCSTR, lpTargetPath: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryDosDeviceA(lpDeviceName: LPCSTR, lpTargetPath: LPSTR, ucchMax: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CreateFileTransactedA(
        lpFileName: LPCSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwCreationDisposition: DWORD,
        dwFlagsAndAttributes: DWORD,
        hTemplateFile: HANDLE,
        hTransaction: HANDLE,
        pusMiniVersion: PUSHORT,
        lpExtendedParameter: PVOID,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateFileTransactedW(
        lpFileName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwCreationDisposition: DWORD,
        dwFlagsAndAttributes: DWORD,
        hTemplateFile: HANDLE,
        hTransaction: HANDLE,
        pusMiniVersion: PUSHORT,
        lpExtendedParameter: PVOID,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn ReOpenFile(
        hOriginalFile: HANDLE,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        dwFlagsAndAttributes: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetFileAttributesTransactedA(
        lpFileName: LPCSTR,
        dwFileAttributes: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileAttributesTransactedW(
        lpFileName: LPCWSTR,
        dwFileAttributes: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileAttributesTransactedA(
        lpFileName: LPCSTR,
        fInfoLevelId: GET_FILEEX_INFO_LEVELS,
        lpFileInformation: LPVOID,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileAttributesTransactedW(
        lpFileName: LPCWSTR,
        fInfoLevelId: GET_FILEEX_INFO_LEVELS,
        lpFileInformation: LPVOID,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCompressedFileSizeTransactedA(
        lpFileName: LPCSTR,
        lpFileSizeHigh: LPDWORD,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCompressedFileSizeTransactedW(
        lpFileName: LPCWSTR,
        lpFileSizeHigh: LPDWORD,
        hTransaction: HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DeleteFileTransactedA(lpFileName: LPCSTR, hTransaction: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteFileTransactedW(lpFileName: LPCWSTR, hTransaction: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckNameLegalDOS8Dot3A(
        lpName: LPCSTR,
        lpOemName: LPSTR,
        OemNameSize: DWORD,
        pbNameContainsSpaces: PBOOL,
        pbNameLegal: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckNameLegalDOS8Dot3W(
        lpName: LPCWSTR,
        lpOemName: LPSTR,
        OemNameSize: DWORD,
        pbNameContainsSpaces: PBOOL,
        pbNameLegal: PBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstFileTransactedA(
        lpFileName: LPCSTR,
        fInfoLevelId: FINDEX_INFO_LEVELS,
        lpFindFileData: LPVOID,
        fSearchOp: FINDEX_SEARCH_OPS,
        lpSearchFilter: LPVOID,
        dwAdditionalFlags: DWORD,
        hTransaction: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileTransactedW(
        lpFileName: LPCWSTR,
        fInfoLevelId: FINDEX_INFO_LEVELS,
        lpFindFileData: LPVOID,
        fSearchOp: FINDEX_SEARCH_OPS,
        lpSearchFilter: LPVOID,
        dwAdditionalFlags: DWORD,
        hTransaction: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CopyFileA(
        lpExistingFileName: LPCSTR,
        lpNewFileName: LPCSTR,
        bFailIfExists: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyFileW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        bFailIfExists: BOOL,
    ) -> BOOL;
}
pub type LPPROGRESS_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        TotalFileSize: LARGE_INTEGER,
        TotalBytesTransferred: LARGE_INTEGER,
        StreamSize: LARGE_INTEGER,
        StreamBytesTransferred: LARGE_INTEGER,
        dwStreamNumber: DWORD,
        dwCallbackReason: DWORD,
        hSourceFile: HANDLE,
        hDestinationFile: HANDLE,
        lpData: LPVOID,
    ) -> DWORD,
>;
unsafe extern "C" {
    pub fn CopyFileExA(
        lpExistingFileName: LPCSTR,
        lpNewFileName: LPCSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        pbCancel: LPBOOL,
        dwCopyFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyFileExW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        pbCancel: LPBOOL,
        dwCopyFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyFileTransactedA(
        lpExistingFileName: LPCSTR,
        lpNewFileName: LPCSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        pbCancel: LPBOOL,
        dwCopyFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyFileTransactedW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        pbCancel: LPBOOL,
        dwCopyFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_NONE: _COPYFILE2_MESSAGE_TYPE = 0;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_CHUNK_STARTED: _COPYFILE2_MESSAGE_TYPE = 1;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_CHUNK_FINISHED: _COPYFILE2_MESSAGE_TYPE = 2;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_STREAM_STARTED: _COPYFILE2_MESSAGE_TYPE = 3;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_STREAM_FINISHED: _COPYFILE2_MESSAGE_TYPE = 4;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_POLL_CONTINUE: _COPYFILE2_MESSAGE_TYPE = 5;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_ERROR: _COPYFILE2_MESSAGE_TYPE = 6;
pub const _COPYFILE2_MESSAGE_TYPE_COPYFILE2_CALLBACK_MAX: _COPYFILE2_MESSAGE_TYPE = 7;
pub type _COPYFILE2_MESSAGE_TYPE = ::std::os::raw::c_int;
pub use self::_COPYFILE2_MESSAGE_TYPE as COPYFILE2_MESSAGE_TYPE;
pub const _COPYFILE2_MESSAGE_ACTION_COPYFILE2_PROGRESS_CONTINUE: _COPYFILE2_MESSAGE_ACTION = 0;
pub const _COPYFILE2_MESSAGE_ACTION_COPYFILE2_PROGRESS_CANCEL: _COPYFILE2_MESSAGE_ACTION = 1;
pub const _COPYFILE2_MESSAGE_ACTION_COPYFILE2_PROGRESS_STOP: _COPYFILE2_MESSAGE_ACTION = 2;
pub const _COPYFILE2_MESSAGE_ACTION_COPYFILE2_PROGRESS_QUIET: _COPYFILE2_MESSAGE_ACTION = 3;
pub const _COPYFILE2_MESSAGE_ACTION_COPYFILE2_PROGRESS_PAUSE: _COPYFILE2_MESSAGE_ACTION = 4;
pub type _COPYFILE2_MESSAGE_ACTION = ::std::os::raw::c_int;
pub use self::_COPYFILE2_MESSAGE_ACTION as COPYFILE2_MESSAGE_ACTION;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_NONE: _COPYFILE2_COPY_PHASE = 0;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_PREPARE_SOURCE: _COPYFILE2_COPY_PHASE = 1;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_PREPARE_DEST: _COPYFILE2_COPY_PHASE = 2;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_READ_SOURCE: _COPYFILE2_COPY_PHASE = 3;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_WRITE_DESTINATION: _COPYFILE2_COPY_PHASE = 4;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_SERVER_COPY: _COPYFILE2_COPY_PHASE = 5;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_NAMEGRAFT_COPY: _COPYFILE2_COPY_PHASE = 6;
pub const _COPYFILE2_COPY_PHASE_COPYFILE2_PHASE_MAX: _COPYFILE2_COPY_PHASE = 7;
pub type _COPYFILE2_COPY_PHASE = ::std::os::raw::c_int;
pub use self::_COPYFILE2_COPY_PHASE as COPYFILE2_COPY_PHASE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE {
    pub Type: COPYFILE2_MESSAGE_TYPE,
    pub dwPadding: DWORD,
    pub Info: COPYFILE2_MESSAGE__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union COPYFILE2_MESSAGE__bindgen_ty_1 {
    pub ChunkStarted: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
    pub ChunkFinished: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
    pub StreamStarted: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
    pub StreamFinished: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
    pub PollContinue: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5,
    pub Error: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1 {
    pub dwStreamNumber: DWORD,
    pub dwReserved: DWORD,
    pub hSourceFile: HANDLE,
    pub hDestinationFile: HANDLE,
    pub uliChunkNumber: ULARGE_INTEGER,
    pub uliChunkSize: ULARGE_INTEGER,
    pub uliStreamSize: ULARGE_INTEGER,
    pub uliTotalFileSize: ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1>() - 56usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::dwStreamNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        dwStreamNumber
    ) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::dwReserved"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        dwReserved
    ) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::hSourceFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        hSourceFile
    ) - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::hDestinationFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        hDestinationFile
    )
        - 16usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::uliChunkNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        uliChunkNumber
    ) - 24usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::uliChunkSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        uliChunkSize
    ) - 32usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::uliStreamSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        uliStreamSize
    ) - 40usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1::uliTotalFileSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_1,
        uliTotalFileSize
    )
        - 48usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2 {
    pub dwStreamNumber: DWORD,
    pub dwFlags: DWORD,
    pub hSourceFile: HANDLE,
    pub hDestinationFile: HANDLE,
    pub uliChunkNumber: ULARGE_INTEGER,
    pub uliChunkSize: ULARGE_INTEGER,
    pub uliStreamSize: ULARGE_INTEGER,
    pub uliStreamBytesTransferred: ULARGE_INTEGER,
    pub uliTotalFileSize: ULARGE_INTEGER,
    pub uliTotalBytesTransferred: ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2>() - 72usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::dwStreamNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        dwStreamNumber
    ) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::dwFlags"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2, dwFlags) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::hSourceFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        hSourceFile
    ) - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::hDestinationFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        hDestinationFile
    )
        - 16usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliChunkNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliChunkNumber
    ) - 24usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliChunkSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliChunkSize
    ) - 32usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliStreamSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliStreamSize
    ) - 40usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliStreamBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliStreamBytesTransferred
    )
        - 48usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliTotalFileSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliTotalFileSize
    )
        - 56usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2::uliTotalBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_2,
        uliTotalBytesTransferred
    )
        - 64usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3 {
    pub dwStreamNumber: DWORD,
    pub dwReserved: DWORD,
    pub hSourceFile: HANDLE,
    pub hDestinationFile: HANDLE,
    pub uliStreamSize: ULARGE_INTEGER,
    pub uliTotalFileSize: ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3>() - 40usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::dwStreamNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        dwStreamNumber
    ) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::dwReserved"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        dwReserved
    ) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::hSourceFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        hSourceFile
    ) - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::hDestinationFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        hDestinationFile
    )
        - 16usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::uliStreamSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        uliStreamSize
    ) - 24usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3::uliTotalFileSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_3,
        uliTotalFileSize
    )
        - 32usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4 {
    pub dwStreamNumber: DWORD,
    pub dwReserved: DWORD,
    pub hSourceFile: HANDLE,
    pub hDestinationFile: HANDLE,
    pub uliStreamSize: ULARGE_INTEGER,
    pub uliStreamBytesTransferred: ULARGE_INTEGER,
    pub uliTotalFileSize: ULARGE_INTEGER,
    pub uliTotalBytesTransferred: ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4>() - 56usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::dwStreamNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        dwStreamNumber
    ) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::dwReserved"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        dwReserved
    ) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::hSourceFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        hSourceFile
    ) - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::hDestinationFile"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        hDestinationFile
    )
        - 16usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::uliStreamSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        uliStreamSize
    ) - 24usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::uliStreamBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        uliStreamBytesTransferred
    )
        - 32usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::uliTotalFileSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        uliTotalFileSize
    )
        - 40usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4::uliTotalBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_4,
        uliTotalBytesTransferred
    )
        - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5 {
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5>() - 4usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5>() - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5::dwReserved"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_5,
        dwReserved
    ) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6 {
    pub CopyPhase: COPYFILE2_COPY_PHASE,
    pub dwStreamNumber: DWORD,
    pub hrFailure: HRESULT,
    pub dwReserved: DWORD,
    pub uliChunkNumber: ULARGE_INTEGER,
    pub uliStreamSize: ULARGE_INTEGER,
    pub uliStreamBytesTransferred: ULARGE_INTEGER,
    pub uliTotalFileSize: ULARGE_INTEGER,
    pub uliTotalBytesTransferred: ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6>() - 56usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::CopyPhase"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6, CopyPhase) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::dwStreamNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        dwStreamNumber
    ) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::hrFailure"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6, hrFailure) - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::dwReserved"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        dwReserved
    ) - 12usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::uliChunkNumber"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        uliChunkNumber
    ) - 16usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::uliStreamSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        uliStreamSize
    ) - 24usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::uliStreamBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        uliStreamBytesTransferred
    )
        - 32usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::uliTotalFileSize"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        uliTotalFileSize
    )
        - 40usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6::uliTotalBytesTransferred"][::std::mem::offset_of!(
        COPYFILE2_MESSAGE__bindgen_ty_1__bindgen_ty_6,
        uliTotalBytesTransferred
    )
        - 48usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE__bindgen_ty_1"]
        [::std::mem::size_of::<COPYFILE2_MESSAGE__bindgen_ty_1>() - 72usize];
    ["Alignment of COPYFILE2_MESSAGE__bindgen_ty_1"]
        [::std::mem::align_of::<COPYFILE2_MESSAGE__bindgen_ty_1>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::ChunkStarted"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, ChunkStarted) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::ChunkFinished"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, ChunkFinished) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::StreamStarted"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, StreamStarted) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::StreamFinished"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, StreamFinished) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::PollContinue"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, PollContinue) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE__bindgen_ty_1::Error"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE__bindgen_ty_1, Error) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_MESSAGE"][::std::mem::size_of::<COPYFILE2_MESSAGE>() - 80usize];
    ["Alignment of COPYFILE2_MESSAGE"][::std::mem::align_of::<COPYFILE2_MESSAGE>() - 8usize];
    ["Offset of field: COPYFILE2_MESSAGE::Type"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE, Type) - 0usize];
    ["Offset of field: COPYFILE2_MESSAGE::dwPadding"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE, dwPadding) - 4usize];
    ["Offset of field: COPYFILE2_MESSAGE::Info"]
        [::std::mem::offset_of!(COPYFILE2_MESSAGE, Info) - 8usize];
};
pub type PCOPYFILE2_PROGRESS_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        pMessage: *const COPYFILE2_MESSAGE,
        pvCallbackContext: PVOID,
    ) -> COPYFILE2_MESSAGE_ACTION,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct COPYFILE2_EXTENDED_PARAMETERS {
    pub dwSize: DWORD,
    pub dwCopyFlags: DWORD,
    pub pfCancel: *mut BOOL,
    pub pProgressRoutine: PCOPYFILE2_PROGRESS_ROUTINE,
    pub pvCallbackContext: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_EXTENDED_PARAMETERS"]
        [::std::mem::size_of::<COPYFILE2_EXTENDED_PARAMETERS>() - 32usize];
    ["Alignment of COPYFILE2_EXTENDED_PARAMETERS"]
        [::std::mem::align_of::<COPYFILE2_EXTENDED_PARAMETERS>() - 8usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS::dwSize"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS, dwSize) - 0usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS::dwCopyFlags"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS, dwCopyFlags) - 4usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS::pfCancel"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS, pfCancel) - 8usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS::pProgressRoutine"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS, pProgressRoutine) - 16usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS::pvCallbackContext"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS, pvCallbackContext) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct COPYFILE2_EXTENDED_PARAMETERS_V2 {
    pub dwSize: DWORD,
    pub dwCopyFlags: DWORD,
    pub pfCancel: *mut BOOL,
    pub pProgressRoutine: PCOPYFILE2_PROGRESS_ROUTINE,
    pub pvCallbackContext: PVOID,
    pub dwCopyFlagsV2: DWORD,
    pub ioDesiredSize: ULONG,
    pub ioDesiredRate: ULONG,
    pub reserved: [PVOID; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of COPYFILE2_EXTENDED_PARAMETERS_V2"]
        [::std::mem::size_of::<COPYFILE2_EXTENDED_PARAMETERS_V2>() - 112usize];
    ["Alignment of COPYFILE2_EXTENDED_PARAMETERS_V2"]
        [::std::mem::align_of::<COPYFILE2_EXTENDED_PARAMETERS_V2>() - 8usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::dwSize"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, dwSize) - 0usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::dwCopyFlags"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, dwCopyFlags) - 4usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::pfCancel"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, pfCancel) - 8usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::pProgressRoutine"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, pProgressRoutine) - 16usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::pvCallbackContext"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, pvCallbackContext) - 24usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::dwCopyFlagsV2"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, dwCopyFlagsV2) - 32usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::ioDesiredSize"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, ioDesiredSize) - 36usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::ioDesiredRate"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, ioDesiredRate) - 40usize];
    ["Offset of field: COPYFILE2_EXTENDED_PARAMETERS_V2::reserved"]
        [::std::mem::offset_of!(COPYFILE2_EXTENDED_PARAMETERS_V2, reserved) - 48usize];
};
unsafe extern "C" {
    pub fn CopyFile2(
        pwszExistingFileName: PCWSTR,
        pwszNewFileName: PCWSTR,
        pExtendedParameters: *mut COPYFILE2_EXTENDED_PARAMETERS,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn MoveFileA(lpExistingFileName: LPCSTR, lpNewFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileW(lpExistingFileName: LPCWSTR, lpNewFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileExA(lpExistingFileName: LPCSTR, lpNewFileName: LPCSTR, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileExW(lpExistingFileName: LPCWSTR, lpNewFileName: LPCWSTR, dwFlags: DWORD)
        -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileWithProgressA(
        lpExistingFileName: LPCSTR,
        lpNewFileName: LPCSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileWithProgressW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileTransactedA(
        lpExistingFileName: LPCSTR,
        lpNewFileName: LPCSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        dwFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveFileTransactedW(
        lpExistingFileName: LPCWSTR,
        lpNewFileName: LPCWSTR,
        lpProgressRoutine: LPPROGRESS_ROUTINE,
        lpData: LPVOID,
        dwFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReplaceFileA(
        lpReplacedFileName: LPCSTR,
        lpReplacementFileName: LPCSTR,
        lpBackupFileName: LPCSTR,
        dwReplaceFlags: DWORD,
        lpExclude: LPVOID,
        lpReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReplaceFileW(
        lpReplacedFileName: LPCWSTR,
        lpReplacementFileName: LPCWSTR,
        lpBackupFileName: LPCWSTR,
        dwReplaceFlags: DWORD,
        lpExclude: LPVOID,
        lpReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateHardLinkA(
        lpFileName: LPCSTR,
        lpExistingFileName: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateHardLinkW(
        lpFileName: LPCWSTR,
        lpExistingFileName: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateHardLinkTransactedA(
        lpFileName: LPCSTR,
        lpExistingFileName: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateHardLinkTransactedW(
        lpFileName: LPCWSTR,
        lpExistingFileName: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        hTransaction: HANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstStreamTransactedW(
        lpFileName: LPCWSTR,
        InfoLevel: STREAM_INFO_LEVELS,
        lpFindStreamData: LPVOID,
        dwFlags: DWORD,
        hTransaction: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstFileNameTransactedW(
        lpFileName: LPCWSTR,
        dwFlags: DWORD,
        StringLength: LPDWORD,
        LinkName: PWSTR,
        hTransaction: HANDLE,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateNamedPipeA(
        lpName: LPCSTR,
        dwOpenMode: DWORD,
        dwPipeMode: DWORD,
        nMaxInstances: DWORD,
        nOutBufferSize: DWORD,
        nInBufferSize: DWORD,
        nDefaultTimeOut: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetNamedPipeHandleStateA(
        hNamedPipe: HANDLE,
        lpState: LPDWORD,
        lpCurInstances: LPDWORD,
        lpMaxCollectionCount: LPDWORD,
        lpCollectDataTimeout: LPDWORD,
        lpUserName: LPSTR,
        nMaxUserNameSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CallNamedPipeA(
        lpNamedPipeName: LPCSTR,
        lpInBuffer: LPVOID,
        nInBufferSize: DWORD,
        lpOutBuffer: LPVOID,
        nOutBufferSize: DWORD,
        lpBytesRead: LPDWORD,
        nTimeOut: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitNamedPipeA(lpNamedPipeName: LPCSTR, nTimeOut: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeClientComputerNameA(
        Pipe: HANDLE,
        ClientComputerName: LPSTR,
        ClientComputerNameLength: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeClientProcessId(Pipe: HANDLE, ClientProcessId: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeClientSessionId(Pipe: HANDLE, ClientSessionId: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeServerProcessId(Pipe: HANDLE, ServerProcessId: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNamedPipeServerSessionId(Pipe: HANDLE, ServerSessionId: PULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn SetVolumeLabelA(lpRootPathName: LPCSTR, lpVolumeName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetVolumeLabelW(lpRootPathName: LPCWSTR, lpVolumeName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileBandwidthReservation(
        hFile: HANDLE,
        nPeriodMilliseconds: DWORD,
        nBytesPerPeriod: DWORD,
        bDiscardable: BOOL,
        lpTransferSize: LPDWORD,
        lpNumOutstandingRequests: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileBandwidthReservation(
        hFile: HANDLE,
        lpPeriodMilliseconds: LPDWORD,
        lpBytesPerPeriod: LPDWORD,
        pDiscardable: LPBOOL,
        lpTransferSize: LPDWORD,
        lpNumOutstandingRequests: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ClearEventLogA(hEventLog: HANDLE, lpBackupFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ClearEventLogW(hEventLog: HANDLE, lpBackupFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn BackupEventLogA(hEventLog: HANDLE, lpBackupFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn BackupEventLogW(hEventLog: HANDLE, lpBackupFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseEventLog(hEventLog: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeregisterEventSource(hEventLog: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn NotifyChangeEventLog(hEventLog: HANDLE, hEvent: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumberOfEventLogRecords(hEventLog: HANDLE, NumberOfRecords: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOldestEventLogRecord(hEventLog: HANDLE, OldestRecord: PDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenEventLogA(lpUNCServerName: LPCSTR, lpSourceName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenEventLogW(lpUNCServerName: LPCWSTR, lpSourceName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn RegisterEventSourceA(lpUNCServerName: LPCSTR, lpSourceName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn RegisterEventSourceW(lpUNCServerName: LPCWSTR, lpSourceName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenBackupEventLogA(lpUNCServerName: LPCSTR, lpFileName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenBackupEventLogW(lpUNCServerName: LPCWSTR, lpFileName: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn ReadEventLogA(
        hEventLog: HANDLE,
        dwReadFlags: DWORD,
        dwRecordOffset: DWORD,
        lpBuffer: LPVOID,
        nNumberOfBytesToRead: DWORD,
        pnBytesRead: *mut DWORD,
        pnMinNumberOfBytesNeeded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadEventLogW(
        hEventLog: HANDLE,
        dwReadFlags: DWORD,
        dwRecordOffset: DWORD,
        lpBuffer: LPVOID,
        nNumberOfBytesToRead: DWORD,
        pnBytesRead: *mut DWORD,
        pnMinNumberOfBytesNeeded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReportEventA(
        hEventLog: HANDLE,
        wType: WORD,
        wCategory: WORD,
        dwEventID: DWORD,
        lpUserSid: PSID,
        wNumStrings: WORD,
        dwDataSize: DWORD,
        lpStrings: *mut LPCSTR,
        lpRawData: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReportEventW(
        hEventLog: HANDLE,
        wType: WORD,
        wCategory: WORD,
        dwEventID: DWORD,
        lpUserSid: PSID,
        wNumStrings: WORD,
        dwDataSize: DWORD,
        lpStrings: *mut LPCWSTR,
        lpRawData: LPVOID,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EVENTLOG_FULL_INFORMATION {
    pub dwFull: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EVENTLOG_FULL_INFORMATION"]
        [::std::mem::size_of::<_EVENTLOG_FULL_INFORMATION>() - 4usize];
    ["Alignment of _EVENTLOG_FULL_INFORMATION"]
        [::std::mem::align_of::<_EVENTLOG_FULL_INFORMATION>() - 4usize];
    ["Offset of field: _EVENTLOG_FULL_INFORMATION::dwFull"]
        [::std::mem::offset_of!(_EVENTLOG_FULL_INFORMATION, dwFull) - 0usize];
};
pub type EVENTLOG_FULL_INFORMATION = _EVENTLOG_FULL_INFORMATION;
pub type LPEVENTLOG_FULL_INFORMATION = *mut _EVENTLOG_FULL_INFORMATION;
unsafe extern "C" {
    pub fn GetEventLogInformation(
        hEventLog: HANDLE,
        dwInfoLevel: DWORD,
        lpBuffer: LPVOID,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
pub type OPERATION_ID = ULONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OPERATION_START_PARAMETERS {
    pub Version: ULONG,
    pub OperationId: OPERATION_ID,
    pub Flags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OPERATION_START_PARAMETERS"]
        [::std::mem::size_of::<_OPERATION_START_PARAMETERS>() - 12usize];
    ["Alignment of _OPERATION_START_PARAMETERS"]
        [::std::mem::align_of::<_OPERATION_START_PARAMETERS>() - 4usize];
    ["Offset of field: _OPERATION_START_PARAMETERS::Version"]
        [::std::mem::offset_of!(_OPERATION_START_PARAMETERS, Version) - 0usize];
    ["Offset of field: _OPERATION_START_PARAMETERS::OperationId"]
        [::std::mem::offset_of!(_OPERATION_START_PARAMETERS, OperationId) - 4usize];
    ["Offset of field: _OPERATION_START_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_OPERATION_START_PARAMETERS, Flags) - 8usize];
};
pub type OPERATION_START_PARAMETERS = _OPERATION_START_PARAMETERS;
pub type POPERATION_START_PARAMETERS = *mut _OPERATION_START_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OPERATION_END_PARAMETERS {
    pub Version: ULONG,
    pub OperationId: OPERATION_ID,
    pub Flags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OPERATION_END_PARAMETERS"]
        [::std::mem::size_of::<_OPERATION_END_PARAMETERS>() - 12usize];
    ["Alignment of _OPERATION_END_PARAMETERS"]
        [::std::mem::align_of::<_OPERATION_END_PARAMETERS>() - 4usize];
    ["Offset of field: _OPERATION_END_PARAMETERS::Version"]
        [::std::mem::offset_of!(_OPERATION_END_PARAMETERS, Version) - 0usize];
    ["Offset of field: _OPERATION_END_PARAMETERS::OperationId"]
        [::std::mem::offset_of!(_OPERATION_END_PARAMETERS, OperationId) - 4usize];
    ["Offset of field: _OPERATION_END_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_OPERATION_END_PARAMETERS, Flags) - 8usize];
};
pub type OPERATION_END_PARAMETERS = _OPERATION_END_PARAMETERS;
pub type POPERATION_END_PARAMETERS = *mut _OPERATION_END_PARAMETERS;
unsafe extern "C" {
    pub fn OperationStart(OperationStartParams: *mut OPERATION_START_PARAMETERS) -> BOOL;
}
unsafe extern "C" {
    pub fn OperationEnd(OperationEndParams: *mut OPERATION_END_PARAMETERS) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckAndAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPSTR,
        ObjectName: LPSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        DesiredAccess: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeAndAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPCSTR,
        ObjectName: LPCSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatus: LPBOOL,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeResultListAndAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPCSTR,
        ObjectName: LPCSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatusList: LPDWORD,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AccessCheckByTypeResultListAndAuditAlarmByHandleA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ClientToken: HANDLE,
        ObjectTypeName: LPCSTR,
        ObjectName: LPCSTR,
        SecurityDescriptor: PSECURITY_DESCRIPTOR,
        PrincipalSelfSid: PSID,
        DesiredAccess: DWORD,
        AuditType: AUDIT_EVENT_TYPE,
        Flags: DWORD,
        ObjectTypeList: POBJECT_TYPE_LIST,
        ObjectTypeListLength: DWORD,
        GenericMapping: PGENERIC_MAPPING,
        ObjectCreation: BOOL,
        GrantedAccess: LPDWORD,
        AccessStatusList: LPDWORD,
        pfGenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectOpenAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ObjectTypeName: LPSTR,
        ObjectName: LPSTR,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        GrantedAccess: DWORD,
        Privileges: PPRIVILEGE_SET,
        ObjectCreation: BOOL,
        AccessGranted: BOOL,
        GenerateOnClose: LPBOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectPrivilegeAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        ClientToken: HANDLE,
        DesiredAccess: DWORD,
        Privileges: PPRIVILEGE_SET,
        AccessGranted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectCloseAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        GenerateOnClose: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ObjectDeleteAuditAlarmA(
        SubsystemName: LPCSTR,
        HandleId: LPVOID,
        GenerateOnClose: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PrivilegedServiceAuditAlarmA(
        SubsystemName: LPCSTR,
        ServiceName: LPCSTR,
        ClientToken: HANDLE,
        Privileges: PPRIVILEGE_SET,
        AccessGranted: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddConditionalAce(
        pAcl: PACL,
        dwAceRevision: DWORD,
        AceFlags: DWORD,
        AceType: UCHAR,
        AccessMask: DWORD,
        pSid: PSID,
        ConditionStr: PWCHAR,
        ReturnLength: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFileSecurityA(
        lpFileName: LPCSTR,
        SecurityInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileSecurityA(
        lpFileName: LPCSTR,
        RequestedInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadDirectoryChangesW(
        hDirectory: HANDLE,
        lpBuffer: LPVOID,
        nBufferLength: DWORD,
        bWatchSubtree: BOOL,
        dwNotifyFilter: DWORD,
        lpBytesReturned: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
        lpCompletionRoutine: LPOVERLAPPED_COMPLETION_ROUTINE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadDirectoryChangesExW(
        hDirectory: HANDLE,
        lpBuffer: LPVOID,
        nBufferLength: DWORD,
        bWatchSubtree: BOOL,
        dwNotifyFilter: DWORD,
        lpBytesReturned: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
        lpCompletionRoutine: LPOVERLAPPED_COMPLETION_ROUTINE,
        ReadDirectoryNotifyInformationClass: READ_DIRECTORY_NOTIFY_INFORMATION_CLASS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MapViewOfFileExNuma(
        hFileMappingObject: HANDLE,
        dwDesiredAccess: DWORD,
        dwFileOffsetHigh: DWORD,
        dwFileOffsetLow: DWORD,
        dwNumberOfBytesToMap: SIZE_T,
        lpBaseAddress: LPVOID,
        nndPreferred: DWORD,
    ) -> LPVOID;
}
unsafe extern "C" {
    pub fn IsBadReadPtr(lp: *const ::std::os::raw::c_void, ucb: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadWritePtr(lp: LPVOID, ucb: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadHugeReadPtr(lp: *const ::std::os::raw::c_void, ucb: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadHugeWritePtr(lp: LPVOID, ucb: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadCodePtr(lpfn: FARPROC) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadStringPtrA(lpsz: LPCSTR, ucchMax: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsBadStringPtrW(lpsz: LPCWSTR, ucchMax: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountSidA(
        lpSystemName: LPCSTR,
        Sid: PSID,
        Name: LPSTR,
        cchName: LPDWORD,
        ReferencedDomainName: LPSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountSidW(
        lpSystemName: LPCWSTR,
        Sid: PSID,
        Name: LPWSTR,
        cchName: LPDWORD,
        ReferencedDomainName: LPWSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountNameA(
        lpSystemName: LPCSTR,
        lpAccountName: LPCSTR,
        Sid: PSID,
        cbSid: LPDWORD,
        ReferencedDomainName: LPSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountNameW(
        lpSystemName: LPCWSTR,
        lpAccountName: LPCWSTR,
        Sid: PSID,
        cbSid: LPDWORD,
        ReferencedDomainName: LPWSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountNameLocalA(
        lpAccountName: LPCSTR,
        Sid: PSID,
        cbSid: LPDWORD,
        ReferencedDomainName: LPSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountNameLocalW(
        lpAccountName: LPCWSTR,
        Sid: PSID,
        cbSid: LPDWORD,
        ReferencedDomainName: LPWSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountSidLocalA(
        Sid: PSID,
        Name: LPSTR,
        cchName: LPDWORD,
        ReferencedDomainName: LPSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupAccountSidLocalW(
        Sid: PSID,
        Name: LPWSTR,
        cchName: LPDWORD,
        ReferencedDomainName: LPWSTR,
        cchReferencedDomainName: LPDWORD,
        peUse: PSID_NAME_USE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeValueA(lpSystemName: LPCSTR, lpName: LPCSTR, lpLuid: PLUID) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeValueW(lpSystemName: LPCWSTR, lpName: LPCWSTR, lpLuid: PLUID) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeNameA(
        lpSystemName: LPCSTR,
        lpLuid: PLUID,
        lpName: LPSTR,
        cchName: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeNameW(
        lpSystemName: LPCWSTR,
        lpLuid: PLUID,
        lpName: LPWSTR,
        cchName: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeDisplayNameA(
        lpSystemName: LPCSTR,
        lpName: LPCSTR,
        lpDisplayName: LPSTR,
        cchDisplayName: LPDWORD,
        lpLanguageId: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupPrivilegeDisplayNameW(
        lpSystemName: LPCWSTR,
        lpName: LPCWSTR,
        lpDisplayName: LPWSTR,
        cchDisplayName: LPDWORD,
        lpLanguageId: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BuildCommDCBA(lpDef: LPCSTR, lpDCB: LPDCB) -> BOOL;
}
unsafe extern "C" {
    pub fn BuildCommDCBW(lpDef: LPCWSTR, lpDCB: LPDCB) -> BOOL;
}
unsafe extern "C" {
    pub fn BuildCommDCBAndTimeoutsA(
        lpDef: LPCSTR,
        lpDCB: LPDCB,
        lpCommTimeouts: LPCOMMTIMEOUTS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BuildCommDCBAndTimeoutsW(
        lpDef: LPCWSTR,
        lpDCB: LPDCB,
        lpCommTimeouts: LPCOMMTIMEOUTS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CommConfigDialogA(lpszName: LPCSTR, hWnd: HWND, lpCC: LPCOMMCONFIG) -> BOOL;
}
unsafe extern "C" {
    pub fn CommConfigDialogW(lpszName: LPCWSTR, hWnd: HWND, lpCC: LPCOMMCONFIG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDefaultCommConfigA(lpszName: LPCSTR, lpCC: LPCOMMCONFIG, lpdwSize: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDefaultCommConfigW(lpszName: LPCWSTR, lpCC: LPCOMMCONFIG, lpdwSize: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDefaultCommConfigA(lpszName: LPCSTR, lpCC: LPCOMMCONFIG, dwSize: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDefaultCommConfigW(lpszName: LPCWSTR, lpCC: LPCOMMCONFIG, dwSize: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetComputerNameA(lpBuffer: LPSTR, nSize: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetComputerNameW(lpBuffer: LPWSTR, nSize: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DnsHostnameToComputerNameA(
        Hostname: LPCSTR,
        ComputerName: LPSTR,
        nSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DnsHostnameToComputerNameW(
        Hostname: LPCWSTR,
        ComputerName: LPWSTR,
        nSize: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserNameA(lpBuffer: LPSTR, pcbBuffer: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserNameW(lpBuffer: LPWSTR, pcbBuffer: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn LogonUserA(
        lpszUsername: LPCSTR,
        lpszDomain: LPCSTR,
        lpszPassword: LPCSTR,
        dwLogonType: DWORD,
        dwLogonProvider: DWORD,
        phToken: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LogonUserW(
        lpszUsername: LPCWSTR,
        lpszDomain: LPCWSTR,
        lpszPassword: LPCWSTR,
        dwLogonType: DWORD,
        dwLogonProvider: DWORD,
        phToken: PHANDLE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LogonUserExA(
        lpszUsername: LPCSTR,
        lpszDomain: LPCSTR,
        lpszPassword: LPCSTR,
        dwLogonType: DWORD,
        dwLogonProvider: DWORD,
        phToken: PHANDLE,
        ppLogonSid: *mut PSID,
        ppProfileBuffer: *mut PVOID,
        pdwProfileLength: LPDWORD,
        pQuotaLimits: PQUOTA_LIMITS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LogonUserExW(
        lpszUsername: LPCWSTR,
        lpszDomain: LPCWSTR,
        lpszPassword: LPCWSTR,
        dwLogonType: DWORD,
        dwLogonProvider: DWORD,
        phToken: PHANDLE,
        ppLogonSid: *mut PSID,
        ppProfileBuffer: *mut PVOID,
        pdwProfileLength: LPDWORD,
        pQuotaLimits: PQUOTA_LIMITS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateProcessWithLogonW(
        lpUsername: LPCWSTR,
        lpDomain: LPCWSTR,
        lpPassword: LPCWSTR,
        dwLogonFlags: DWORD,
        lpApplicationName: LPCWSTR,
        lpCommandLine: LPWSTR,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCWSTR,
        lpStartupInfo: LPSTARTUPINFOW,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateProcessWithTokenW(
        hToken: HANDLE,
        dwLogonFlags: DWORD,
        lpApplicationName: LPCWSTR,
        lpCommandLine: LPWSTR,
        dwCreationFlags: DWORD,
        lpEnvironment: LPVOID,
        lpCurrentDirectory: LPCWSTR,
        lpStartupInfo: LPSTARTUPINFOW,
        lpProcessInformation: LPPROCESS_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsTokenUntrusted(TokenHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterWaitForSingleObject(
        phNewWaitObject: PHANDLE,
        hObject: HANDLE,
        Callback: WAITORTIMERCALLBACK,
        Context: PVOID,
        dwMilliseconds: ULONG,
        dwFlags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterWait(WaitHandle: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn BindIoCompletionCallback(
        FileHandle: HANDLE,
        Function: LPOVERLAPPED_COMPLETION_ROUTINE,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetTimerQueueTimer(
        TimerQueue: HANDLE,
        Callback: WAITORTIMERCALLBACK,
        Parameter: PVOID,
        DueTime: DWORD,
        Period: DWORD,
        PreferIo: BOOL,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CancelTimerQueueTimer(TimerQueue: HANDLE, Timer: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePrivateNamespaceA(
        lpPrivateNamespaceAttributes: LPSECURITY_ATTRIBUTES,
        lpBoundaryDescriptor: LPVOID,
        lpAliasPrefix: LPCSTR,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenPrivateNamespaceA(lpBoundaryDescriptor: LPVOID, lpAliasPrefix: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateBoundaryDescriptorA(Name: LPCSTR, Flags: ULONG) -> HANDLE;
}
unsafe extern "C" {
    pub fn AddIntegrityLabelToBoundaryDescriptor(
        BoundaryDescriptor: *mut HANDLE,
        IntegrityLabel: PSID,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHW_PROFILE_INFOA {
    pub dwDockInfo: DWORD,
    pub szHwProfileGuid: [CHAR; 39usize],
    pub szHwProfileName: [CHAR; 80usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHW_PROFILE_INFOA"][::std::mem::size_of::<tagHW_PROFILE_INFOA>() - 124usize];
    ["Alignment of tagHW_PROFILE_INFOA"][::std::mem::align_of::<tagHW_PROFILE_INFOA>() - 4usize];
    ["Offset of field: tagHW_PROFILE_INFOA::dwDockInfo"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOA, dwDockInfo) - 0usize];
    ["Offset of field: tagHW_PROFILE_INFOA::szHwProfileGuid"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOA, szHwProfileGuid) - 4usize];
    ["Offset of field: tagHW_PROFILE_INFOA::szHwProfileName"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOA, szHwProfileName) - 43usize];
};
pub type HW_PROFILE_INFOA = tagHW_PROFILE_INFOA;
pub type LPHW_PROFILE_INFOA = *mut tagHW_PROFILE_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHW_PROFILE_INFOW {
    pub dwDockInfo: DWORD,
    pub szHwProfileGuid: [WCHAR; 39usize],
    pub szHwProfileName: [WCHAR; 80usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHW_PROFILE_INFOW"][::std::mem::size_of::<tagHW_PROFILE_INFOW>() - 244usize];
    ["Alignment of tagHW_PROFILE_INFOW"][::std::mem::align_of::<tagHW_PROFILE_INFOW>() - 4usize];
    ["Offset of field: tagHW_PROFILE_INFOW::dwDockInfo"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOW, dwDockInfo) - 0usize];
    ["Offset of field: tagHW_PROFILE_INFOW::szHwProfileGuid"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOW, szHwProfileGuid) - 4usize];
    ["Offset of field: tagHW_PROFILE_INFOW::szHwProfileName"]
        [::std::mem::offset_of!(tagHW_PROFILE_INFOW, szHwProfileName) - 82usize];
};
pub type HW_PROFILE_INFOW = tagHW_PROFILE_INFOW;
pub type LPHW_PROFILE_INFOW = *mut tagHW_PROFILE_INFOW;
pub type HW_PROFILE_INFO = HW_PROFILE_INFOA;
pub type LPHW_PROFILE_INFO = LPHW_PROFILE_INFOA;
unsafe extern "C" {
    pub fn GetCurrentHwProfileA(lpHwProfileInfo: LPHW_PROFILE_INFOA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentHwProfileW(lpHwProfileInfo: LPHW_PROFILE_INFOW) -> BOOL;
}
unsafe extern "C" {
    pub fn VerifyVersionInfoA(
        lpVersionInformation: LPOSVERSIONINFOEXA,
        dwTypeMask: DWORD,
        dwlConditionMask: DWORDLONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VerifyVersionInfoW(
        lpVersionInformation: LPOSVERSIONINFOEXW,
        dwTypeMask: DWORD,
        dwlConditionMask: DWORDLONG,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TIME_ZONE_INFORMATION {
    pub Bias: LONG,
    pub StandardName: [WCHAR; 32usize],
    pub StandardDate: SYSTEMTIME,
    pub StandardBias: LONG,
    pub DaylightName: [WCHAR; 32usize],
    pub DaylightDate: SYSTEMTIME,
    pub DaylightBias: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TIME_ZONE_INFORMATION"][::std::mem::size_of::<_TIME_ZONE_INFORMATION>() - 172usize];
    ["Alignment of _TIME_ZONE_INFORMATION"]
        [::std::mem::align_of::<_TIME_ZONE_INFORMATION>() - 4usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::Bias"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, Bias) - 0usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::StandardName"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, StandardName) - 4usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::StandardDate"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, StandardDate) - 68usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::StandardBias"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, StandardBias) - 84usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::DaylightName"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, DaylightName) - 88usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::DaylightDate"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, DaylightDate) - 152usize];
    ["Offset of field: _TIME_ZONE_INFORMATION::DaylightBias"]
        [::std::mem::offset_of!(_TIME_ZONE_INFORMATION, DaylightBias) - 168usize];
};
pub type TIME_ZONE_INFORMATION = _TIME_ZONE_INFORMATION;
pub type PTIME_ZONE_INFORMATION = *mut _TIME_ZONE_INFORMATION;
pub type LPTIME_ZONE_INFORMATION = *mut _TIME_ZONE_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TIME_DYNAMIC_ZONE_INFORMATION {
    pub Bias: LONG,
    pub StandardName: [WCHAR; 32usize],
    pub StandardDate: SYSTEMTIME,
    pub StandardBias: LONG,
    pub DaylightName: [WCHAR; 32usize],
    pub DaylightDate: SYSTEMTIME,
    pub DaylightBias: LONG,
    pub TimeZoneKeyName: [WCHAR; 128usize],
    pub DynamicDaylightTimeDisabled: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TIME_DYNAMIC_ZONE_INFORMATION"]
        [::std::mem::size_of::<_TIME_DYNAMIC_ZONE_INFORMATION>() - 432usize];
    ["Alignment of _TIME_DYNAMIC_ZONE_INFORMATION"]
        [::std::mem::align_of::<_TIME_DYNAMIC_ZONE_INFORMATION>() - 4usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::Bias"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, Bias) - 0usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::StandardName"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, StandardName) - 4usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::StandardDate"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, StandardDate) - 68usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::StandardBias"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, StandardBias) - 84usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::DaylightName"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, DaylightName) - 88usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::DaylightDate"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, DaylightDate) - 152usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::DaylightBias"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, DaylightBias) - 168usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::TimeZoneKeyName"]
        [::std::mem::offset_of!(_TIME_DYNAMIC_ZONE_INFORMATION, TimeZoneKeyName) - 172usize];
    ["Offset of field: _TIME_DYNAMIC_ZONE_INFORMATION::DynamicDaylightTimeDisabled"][::std::mem::offset_of!(
        _TIME_DYNAMIC_ZONE_INFORMATION,
        DynamicDaylightTimeDisabled
    ) - 428usize];
};
pub type DYNAMIC_TIME_ZONE_INFORMATION = _TIME_DYNAMIC_ZONE_INFORMATION;
pub type PDYNAMIC_TIME_ZONE_INFORMATION = *mut _TIME_DYNAMIC_ZONE_INFORMATION;
unsafe extern "C" {
    pub fn SystemTimeToTzSpecificLocalTime(
        lpTimeZoneInformation: *const TIME_ZONE_INFORMATION,
        lpUniversalTime: *const SYSTEMTIME,
        lpLocalTime: LPSYSTEMTIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TzSpecificLocalTimeToSystemTime(
        lpTimeZoneInformation: *const TIME_ZONE_INFORMATION,
        lpLocalTime: *const SYSTEMTIME,
        lpUniversalTime: LPSYSTEMTIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FileTimeToSystemTime(lpFileTime: *const FILETIME, lpSystemTime: LPSYSTEMTIME) -> BOOL;
}
unsafe extern "C" {
    pub fn SystemTimeToFileTime(lpSystemTime: *const SYSTEMTIME, lpFileTime: LPFILETIME) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTimeZoneInformation(lpTimeZoneInformation: LPTIME_ZONE_INFORMATION) -> DWORD;
}
unsafe extern "C" {
    pub fn SetTimeZoneInformation(lpTimeZoneInformation: *const TIME_ZONE_INFORMATION) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDynamicTimeZoneInformation(
        lpTimeZoneInformation: *const DYNAMIC_TIME_ZONE_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDynamicTimeZoneInformation(
        pTimeZoneInformation: PDYNAMIC_TIME_ZONE_INFORMATION,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTimeZoneInformationForYear(
        wYear: USHORT,
        pdtzi: PDYNAMIC_TIME_ZONE_INFORMATION,
        ptzi: LPTIME_ZONE_INFORMATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDynamicTimeZoneInformation(
        dwIndex: DWORD,
        lpTimeZoneInformation: PDYNAMIC_TIME_ZONE_INFORMATION,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetDynamicTimeZoneInformationEffectiveYears(
        lpTimeZoneInformation: PDYNAMIC_TIME_ZONE_INFORMATION,
        FirstYear: LPDWORD,
        LastYear: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SystemTimeToTzSpecificLocalTimeEx(
        lpTimeZoneInformation: *const DYNAMIC_TIME_ZONE_INFORMATION,
        lpUniversalTime: *const SYSTEMTIME,
        lpLocalTime: LPSYSTEMTIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TzSpecificLocalTimeToSystemTimeEx(
        lpTimeZoneInformation: *const DYNAMIC_TIME_ZONE_INFORMATION,
        lpLocalTime: *const SYSTEMTIME,
        lpUniversalTime: LPSYSTEMTIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LocalFileTimeToLocalSystemTime(
        timeZoneInformation: *const TIME_ZONE_INFORMATION,
        localFileTime: *const FILETIME,
        localSystemTime: *mut SYSTEMTIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LocalSystemTimeToLocalFileTime(
        timeZoneInformation: *const TIME_ZONE_INFORMATION,
        localSystemTime: *const SYSTEMTIME,
        localFileTime: *mut FILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemPowerState(fSuspend: BOOL, fForce: BOOL) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SYSTEM_POWER_STATUS {
    pub ACLineStatus: BYTE,
    pub BatteryFlag: BYTE,
    pub BatteryLifePercent: BYTE,
    pub SystemStatusFlag: BYTE,
    pub BatteryLifeTime: DWORD,
    pub BatteryFullLifeTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SYSTEM_POWER_STATUS"][::std::mem::size_of::<_SYSTEM_POWER_STATUS>() - 12usize];
    ["Alignment of _SYSTEM_POWER_STATUS"][::std::mem::align_of::<_SYSTEM_POWER_STATUS>() - 4usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::ACLineStatus"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, ACLineStatus) - 0usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::BatteryFlag"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, BatteryFlag) - 1usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::BatteryLifePercent"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, BatteryLifePercent) - 2usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::SystemStatusFlag"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, SystemStatusFlag) - 3usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::BatteryLifeTime"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, BatteryLifeTime) - 4usize];
    ["Offset of field: _SYSTEM_POWER_STATUS::BatteryFullLifeTime"]
        [::std::mem::offset_of!(_SYSTEM_POWER_STATUS, BatteryFullLifeTime) - 8usize];
};
pub type SYSTEM_POWER_STATUS = _SYSTEM_POWER_STATUS;
pub type LPSYSTEM_POWER_STATUS = *mut _SYSTEM_POWER_STATUS;
unsafe extern "C" {
    pub fn GetSystemPowerStatus(lpSystemPowerStatus: LPSYSTEM_POWER_STATUS) -> BOOL;
}
unsafe extern "C" {
    pub fn MapUserPhysicalPagesScatter(
        VirtualAddresses: *mut PVOID,
        NumberOfPages: ULONG_PTR,
        PageArray: PULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateJobObjectA(lpJobAttributes: LPSECURITY_ATTRIBUTES, lpName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn OpenJobObjectA(dwDesiredAccess: DWORD, bInheritHandle: BOOL, lpName: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateJobSet(NumJob: ULONG, UserJobSet: PJOB_SET_ARRAY, Flags: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstVolumeA(lpszVolumeName: LPSTR, cchBufferLength: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextVolumeA(
        hFindVolume: HANDLE,
        lpszVolumeName: LPSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindFirstVolumeMountPointA(
        lpszRootPathName: LPCSTR,
        lpszVolumeMountPoint: LPSTR,
        cchBufferLength: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindFirstVolumeMountPointW(
        lpszRootPathName: LPCWSTR,
        lpszVolumeMountPoint: LPWSTR,
        cchBufferLength: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextVolumeMountPointA(
        hFindVolumeMountPoint: HANDLE,
        lpszVolumeMountPoint: LPSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindNextVolumeMountPointW(
        hFindVolumeMountPoint: HANDLE,
        lpszVolumeMountPoint: LPWSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindVolumeMountPointClose(hFindVolumeMountPoint: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetVolumeMountPointA(lpszVolumeMountPoint: LPCSTR, lpszVolumeName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetVolumeMountPointW(lpszVolumeMountPoint: LPCWSTR, lpszVolumeName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteVolumeMountPointA(lpszVolumeMountPoint: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumeNameForVolumeMountPointA(
        lpszVolumeMountPoint: LPCSTR,
        lpszVolumeName: LPSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumePathNameA(
        lpszFileName: LPCSTR,
        lpszVolumePathName: LPSTR,
        cchBufferLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetVolumePathNamesForVolumeNameA(
        lpszVolumeName: LPCSTR,
        lpszVolumePathNames: LPCH,
        cchBufferLength: DWORD,
        lpcchReturnLength: PDWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACTCTXA {
    pub cbSize: ULONG,
    pub dwFlags: DWORD,
    pub lpSource: LPCSTR,
    pub wProcessorArchitecture: USHORT,
    pub wLangId: LANGID,
    pub lpAssemblyDirectory: LPCSTR,
    pub lpResourceName: LPCSTR,
    pub lpApplicationName: LPCSTR,
    pub hModule: HMODULE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACTCTXA"][::std::mem::size_of::<tagACTCTXA>() - 56usize];
    ["Alignment of tagACTCTXA"][::std::mem::align_of::<tagACTCTXA>() - 8usize];
    ["Offset of field: tagACTCTXA::cbSize"][::std::mem::offset_of!(tagACTCTXA, cbSize) - 0usize];
    ["Offset of field: tagACTCTXA::dwFlags"][::std::mem::offset_of!(tagACTCTXA, dwFlags) - 4usize];
    ["Offset of field: tagACTCTXA::lpSource"]
        [::std::mem::offset_of!(tagACTCTXA, lpSource) - 8usize];
    ["Offset of field: tagACTCTXA::wProcessorArchitecture"]
        [::std::mem::offset_of!(tagACTCTXA, wProcessorArchitecture) - 16usize];
    ["Offset of field: tagACTCTXA::wLangId"][::std::mem::offset_of!(tagACTCTXA, wLangId) - 18usize];
    ["Offset of field: tagACTCTXA::lpAssemblyDirectory"]
        [::std::mem::offset_of!(tagACTCTXA, lpAssemblyDirectory) - 24usize];
    ["Offset of field: tagACTCTXA::lpResourceName"]
        [::std::mem::offset_of!(tagACTCTXA, lpResourceName) - 32usize];
    ["Offset of field: tagACTCTXA::lpApplicationName"]
        [::std::mem::offset_of!(tagACTCTXA, lpApplicationName) - 40usize];
    ["Offset of field: tagACTCTXA::hModule"][::std::mem::offset_of!(tagACTCTXA, hModule) - 48usize];
};
pub type ACTCTXA = tagACTCTXA;
pub type PACTCTXA = *mut tagACTCTXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACTCTXW {
    pub cbSize: ULONG,
    pub dwFlags: DWORD,
    pub lpSource: LPCWSTR,
    pub wProcessorArchitecture: USHORT,
    pub wLangId: LANGID,
    pub lpAssemblyDirectory: LPCWSTR,
    pub lpResourceName: LPCWSTR,
    pub lpApplicationName: LPCWSTR,
    pub hModule: HMODULE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACTCTXW"][::std::mem::size_of::<tagACTCTXW>() - 56usize];
    ["Alignment of tagACTCTXW"][::std::mem::align_of::<tagACTCTXW>() - 8usize];
    ["Offset of field: tagACTCTXW::cbSize"][::std::mem::offset_of!(tagACTCTXW, cbSize) - 0usize];
    ["Offset of field: tagACTCTXW::dwFlags"][::std::mem::offset_of!(tagACTCTXW, dwFlags) - 4usize];
    ["Offset of field: tagACTCTXW::lpSource"]
        [::std::mem::offset_of!(tagACTCTXW, lpSource) - 8usize];
    ["Offset of field: tagACTCTXW::wProcessorArchitecture"]
        [::std::mem::offset_of!(tagACTCTXW, wProcessorArchitecture) - 16usize];
    ["Offset of field: tagACTCTXW::wLangId"][::std::mem::offset_of!(tagACTCTXW, wLangId) - 18usize];
    ["Offset of field: tagACTCTXW::lpAssemblyDirectory"]
        [::std::mem::offset_of!(tagACTCTXW, lpAssemblyDirectory) - 24usize];
    ["Offset of field: tagACTCTXW::lpResourceName"]
        [::std::mem::offset_of!(tagACTCTXW, lpResourceName) - 32usize];
    ["Offset of field: tagACTCTXW::lpApplicationName"]
        [::std::mem::offset_of!(tagACTCTXW, lpApplicationName) - 40usize];
    ["Offset of field: tagACTCTXW::hModule"][::std::mem::offset_of!(tagACTCTXW, hModule) - 48usize];
};
pub type ACTCTXW = tagACTCTXW;
pub type PACTCTXW = *mut tagACTCTXW;
pub type ACTCTX = ACTCTXA;
pub type PACTCTX = PACTCTXA;
pub type PCACTCTXA = *const ACTCTXA;
pub type PCACTCTXW = *const ACTCTXW;
pub type PCACTCTX = PCACTCTXA;
unsafe extern "C" {
    pub fn CreateActCtxA(pActCtx: PCACTCTXA) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateActCtxW(pActCtx: PCACTCTXW) -> HANDLE;
}
unsafe extern "C" {
    pub fn AddRefActCtx(hActCtx: HANDLE);
}
unsafe extern "C" {
    pub fn ReleaseActCtx(hActCtx: HANDLE);
}
unsafe extern "C" {
    pub fn ZombifyActCtx(hActCtx: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ActivateActCtx(hActCtx: HANDLE, lpCookie: *mut ULONG_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeactivateActCtx(dwFlags: DWORD, ulCookie: ULONG_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCurrentActCtx(lphActCtx: *mut HANDLE) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACTCTX_SECTION_KEYED_DATA_2600 {
    pub cbSize: ULONG,
    pub ulDataFormatVersion: ULONG,
    pub lpData: PVOID,
    pub ulLength: ULONG,
    pub lpSectionGlobalData: PVOID,
    pub ulSectionGlobalDataLength: ULONG,
    pub lpSectionBase: PVOID,
    pub ulSectionTotalLength: ULONG,
    pub hActCtx: HANDLE,
    pub ulAssemblyRosterIndex: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACTCTX_SECTION_KEYED_DATA_2600"]
        [::std::mem::size_of::<tagACTCTX_SECTION_KEYED_DATA_2600>() - 72usize];
    ["Alignment of tagACTCTX_SECTION_KEYED_DATA_2600"]
        [::std::mem::align_of::<tagACTCTX_SECTION_KEYED_DATA_2600>() - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::cbSize"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, cbSize) - 0usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::ulDataFormatVersion"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, ulDataFormatVersion) - 4usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::lpData"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, lpData) - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::ulLength"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, ulLength) - 16usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::lpSectionGlobalData"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, lpSectionGlobalData) - 24usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::ulSectionGlobalDataLength"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_2600,
        ulSectionGlobalDataLength
    ) - 32usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::lpSectionBase"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, lpSectionBase) - 40usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::ulSectionTotalLength"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, ulSectionTotalLength) - 48usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::hActCtx"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA_2600, hActCtx) - 56usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_2600::ulAssemblyRosterIndex"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_2600,
        ulAssemblyRosterIndex
    ) - 64usize];
};
pub type ACTCTX_SECTION_KEYED_DATA_2600 = tagACTCTX_SECTION_KEYED_DATA_2600;
pub type PACTCTX_SECTION_KEYED_DATA_2600 = *mut tagACTCTX_SECTION_KEYED_DATA_2600;
pub type PCACTCTX_SECTION_KEYED_DATA_2600 = *const ACTCTX_SECTION_KEYED_DATA_2600;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA {
    pub lpInformation: PVOID,
    pub lpSectionBase: PVOID,
    pub ulSectionLength: ULONG,
    pub lpSectionGlobalDataBase: PVOID,
    pub ulSectionGlobalDataLength: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA"]
        [::std::mem::size_of::<tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA>() - 40usize];
    ["Alignment of tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA"]
        [::std::mem::align_of::<tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA>() - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA::lpInformation"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA,
        lpInformation
    ) - 0usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA::lpSectionBase"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA,
        lpSectionBase
    ) - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA::ulSectionLength"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA,
        ulSectionLength
    )
        - 16usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA::lpSectionGlobalDataBase"][::std::mem::offset_of!(
        tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA,
        lpSectionGlobalDataBase
    )
        - 24usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA::ulSectionGlobalDataLength"] [:: std :: mem :: offset_of ! (tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA , ulSectionGlobalDataLength) - 32usize] ;
};
pub type ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA =
    tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA;
pub type PACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA =
    *mut tagACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA;
pub type PCACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA =
    *const ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACTCTX_SECTION_KEYED_DATA {
    pub cbSize: ULONG,
    pub ulDataFormatVersion: ULONG,
    pub lpData: PVOID,
    pub ulLength: ULONG,
    pub lpSectionGlobalData: PVOID,
    pub ulSectionGlobalDataLength: ULONG,
    pub lpSectionBase: PVOID,
    pub ulSectionTotalLength: ULONG,
    pub hActCtx: HANDLE,
    pub ulAssemblyRosterIndex: ULONG,
    pub ulFlags: ULONG,
    pub AssemblyMetadata: ACTCTX_SECTION_KEYED_DATA_ASSEMBLY_METADATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACTCTX_SECTION_KEYED_DATA"]
        [::std::mem::size_of::<tagACTCTX_SECTION_KEYED_DATA>() - 112usize];
    ["Alignment of tagACTCTX_SECTION_KEYED_DATA"]
        [::std::mem::align_of::<tagACTCTX_SECTION_KEYED_DATA>() - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::cbSize"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, cbSize) - 0usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulDataFormatVersion"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulDataFormatVersion) - 4usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::lpData"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, lpData) - 8usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulLength"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulLength) - 16usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::lpSectionGlobalData"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, lpSectionGlobalData) - 24usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulSectionGlobalDataLength"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulSectionGlobalDataLength) - 32usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::lpSectionBase"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, lpSectionBase) - 40usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulSectionTotalLength"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulSectionTotalLength) - 48usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::hActCtx"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, hActCtx) - 56usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulAssemblyRosterIndex"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulAssemblyRosterIndex) - 64usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::ulFlags"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, ulFlags) - 68usize];
    ["Offset of field: tagACTCTX_SECTION_KEYED_DATA::AssemblyMetadata"]
        [::std::mem::offset_of!(tagACTCTX_SECTION_KEYED_DATA, AssemblyMetadata) - 72usize];
};
pub type ACTCTX_SECTION_KEYED_DATA = tagACTCTX_SECTION_KEYED_DATA;
pub type PACTCTX_SECTION_KEYED_DATA = *mut tagACTCTX_SECTION_KEYED_DATA;
pub type PCACTCTX_SECTION_KEYED_DATA = *const ACTCTX_SECTION_KEYED_DATA;
unsafe extern "C" {
    pub fn FindActCtxSectionStringA(
        dwFlags: DWORD,
        lpExtensionGuid: *const GUID,
        ulSectionId: ULONG,
        lpStringToFind: LPCSTR,
        ReturnedData: PACTCTX_SECTION_KEYED_DATA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindActCtxSectionStringW(
        dwFlags: DWORD,
        lpExtensionGuid: *const GUID,
        ulSectionId: ULONG,
        lpStringToFind: LPCWSTR,
        ReturnedData: PACTCTX_SECTION_KEYED_DATA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FindActCtxSectionGuid(
        dwFlags: DWORD,
        lpExtensionGuid: *const GUID,
        ulSectionId: ULONG,
        lpGuidToFind: *const GUID,
        ReturnedData: PACTCTX_SECTION_KEYED_DATA,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTIVATION_CONTEXT_BASIC_INFORMATION {
    pub hActCtx: HANDLE,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTIVATION_CONTEXT_BASIC_INFORMATION"]
        [::std::mem::size_of::<_ACTIVATION_CONTEXT_BASIC_INFORMATION>() - 16usize];
    ["Alignment of _ACTIVATION_CONTEXT_BASIC_INFORMATION"]
        [::std::mem::align_of::<_ACTIVATION_CONTEXT_BASIC_INFORMATION>() - 8usize];
    ["Offset of field: _ACTIVATION_CONTEXT_BASIC_INFORMATION::hActCtx"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_BASIC_INFORMATION, hActCtx) - 0usize];
    ["Offset of field: _ACTIVATION_CONTEXT_BASIC_INFORMATION::dwFlags"]
        [::std::mem::offset_of!(_ACTIVATION_CONTEXT_BASIC_INFORMATION, dwFlags) - 8usize];
};
pub type ACTIVATION_CONTEXT_BASIC_INFORMATION = _ACTIVATION_CONTEXT_BASIC_INFORMATION;
pub type PACTIVATION_CONTEXT_BASIC_INFORMATION = *mut _ACTIVATION_CONTEXT_BASIC_INFORMATION;
pub type PCACTIVATION_CONTEXT_BASIC_INFORMATION = *const _ACTIVATION_CONTEXT_BASIC_INFORMATION;
unsafe extern "C" {
    pub fn QueryActCtxW(
        dwFlags: DWORD,
        hActCtx: HANDLE,
        pvSubInstance: PVOID,
        ulInfoClass: ULONG,
        pvBuffer: PVOID,
        cbBuffer: SIZE_T,
        pcbWrittenOrRequired: *mut SIZE_T,
    ) -> BOOL;
}
pub type PQUERYACTCTXW_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        dwFlags: DWORD,
        hActCtx: HANDLE,
        pvSubInstance: PVOID,
        ulInfoClass: ULONG,
        pvBuffer: PVOID,
        cbBuffer: SIZE_T,
        pcbWrittenOrRequired: *mut SIZE_T,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn WTSGetActiveConsoleSessionId() -> DWORD;
}
unsafe extern "C" {
    pub fn WTSGetServiceSessionId() -> DWORD;
}
unsafe extern "C" {
    pub fn WTSIsServerContainer() -> BOOLEAN;
}
unsafe extern "C" {
    pub fn GetActiveProcessorGroupCount() -> WORD;
}
unsafe extern "C" {
    pub fn GetMaximumProcessorGroupCount() -> WORD;
}
unsafe extern "C" {
    pub fn GetActiveProcessorCount(GroupNumber: WORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetMaximumProcessorCount(GroupNumber: WORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetNumaProcessorNode(Processor: UCHAR, NodeNumber: PUCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaNodeNumberFromHandle(hFile: HANDLE, NodeNumber: PUSHORT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaProcessorNodeEx(Processor: PPROCESSOR_NUMBER, NodeNumber: PUSHORT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaNodeProcessorMask(Node: UCHAR, ProcessorMask: PULONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaAvailableMemoryNode(Node: UCHAR, AvailableBytes: PULONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaAvailableMemoryNodeEx(Node: USHORT, AvailableBytes: PULONGLONG) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumaProximityNode(ProximityId: ULONG, NodeNumber: PUCHAR) -> BOOL;
}
pub type APPLICATION_RECOVERY_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(pvParameter: PVOID) -> DWORD>;
unsafe extern "C" {
    pub fn RegisterApplicationRecoveryCallback(
        pRecoveyCallback: APPLICATION_RECOVERY_CALLBACK,
        pvParameter: PVOID,
        dwPingInterval: DWORD,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UnregisterApplicationRecoveryCallback() -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterApplicationRestart(pwzCommandline: PCWSTR, dwFlags: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn UnregisterApplicationRestart() -> HRESULT;
}
unsafe extern "C" {
    pub fn GetApplicationRecoveryCallback(
        hProcess: HANDLE,
        pRecoveryCallback: *mut APPLICATION_RECOVERY_CALLBACK,
        ppvParameter: *mut PVOID,
        pdwPingInterval: PDWORD,
        pdwFlags: PDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetApplicationRestartSettings(
        hProcess: HANDLE,
        pwzCommandline: PWSTR,
        pcchSize: PDWORD,
        pdwFlags: PDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ApplicationRecoveryInProgress(pbCancelled: PBOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn ApplicationRecoveryFinished(bSuccess: BOOL);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_BASIC_INFO {
    pub CreationTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub LastWriteTime: LARGE_INTEGER,
    pub ChangeTime: LARGE_INTEGER,
    pub FileAttributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_BASIC_INFO"][::std::mem::size_of::<_FILE_BASIC_INFO>() - 40usize];
    ["Alignment of _FILE_BASIC_INFO"][::std::mem::align_of::<_FILE_BASIC_INFO>() - 8usize];
    ["Offset of field: _FILE_BASIC_INFO::CreationTime"]
        [::std::mem::offset_of!(_FILE_BASIC_INFO, CreationTime) - 0usize];
    ["Offset of field: _FILE_BASIC_INFO::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_BASIC_INFO, LastAccessTime) - 8usize];
    ["Offset of field: _FILE_BASIC_INFO::LastWriteTime"]
        [::std::mem::offset_of!(_FILE_BASIC_INFO, LastWriteTime) - 16usize];
    ["Offset of field: _FILE_BASIC_INFO::ChangeTime"]
        [::std::mem::offset_of!(_FILE_BASIC_INFO, ChangeTime) - 24usize];
    ["Offset of field: _FILE_BASIC_INFO::FileAttributes"]
        [::std::mem::offset_of!(_FILE_BASIC_INFO, FileAttributes) - 32usize];
};
pub type FILE_BASIC_INFO = _FILE_BASIC_INFO;
pub type PFILE_BASIC_INFO = *mut _FILE_BASIC_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_STANDARD_INFO {
    pub AllocationSize: LARGE_INTEGER,
    pub EndOfFile: LARGE_INTEGER,
    pub NumberOfLinks: DWORD,
    pub DeletePending: BOOLEAN,
    pub Directory: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_STANDARD_INFO"][::std::mem::size_of::<_FILE_STANDARD_INFO>() - 24usize];
    ["Alignment of _FILE_STANDARD_INFO"][::std::mem::align_of::<_FILE_STANDARD_INFO>() - 8usize];
    ["Offset of field: _FILE_STANDARD_INFO::AllocationSize"]
        [::std::mem::offset_of!(_FILE_STANDARD_INFO, AllocationSize) - 0usize];
    ["Offset of field: _FILE_STANDARD_INFO::EndOfFile"]
        [::std::mem::offset_of!(_FILE_STANDARD_INFO, EndOfFile) - 8usize];
    ["Offset of field: _FILE_STANDARD_INFO::NumberOfLinks"]
        [::std::mem::offset_of!(_FILE_STANDARD_INFO, NumberOfLinks) - 16usize];
    ["Offset of field: _FILE_STANDARD_INFO::DeletePending"]
        [::std::mem::offset_of!(_FILE_STANDARD_INFO, DeletePending) - 20usize];
    ["Offset of field: _FILE_STANDARD_INFO::Directory"]
        [::std::mem::offset_of!(_FILE_STANDARD_INFO, Directory) - 21usize];
};
pub type FILE_STANDARD_INFO = _FILE_STANDARD_INFO;
pub type PFILE_STANDARD_INFO = *mut _FILE_STANDARD_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_NAME_INFO {
    pub FileNameLength: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_NAME_INFO"][::std::mem::size_of::<_FILE_NAME_INFO>() - 8usize];
    ["Alignment of _FILE_NAME_INFO"][::std::mem::align_of::<_FILE_NAME_INFO>() - 4usize];
    ["Offset of field: _FILE_NAME_INFO::FileNameLength"]
        [::std::mem::offset_of!(_FILE_NAME_INFO, FileNameLength) - 0usize];
    ["Offset of field: _FILE_NAME_INFO::FileName"]
        [::std::mem::offset_of!(_FILE_NAME_INFO, FileName) - 4usize];
};
pub type FILE_NAME_INFO = _FILE_NAME_INFO;
pub type PFILE_NAME_INFO = *mut _FILE_NAME_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_CASE_SENSITIVE_INFO {
    pub Flags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_CASE_SENSITIVE_INFO"]
        [::std::mem::size_of::<_FILE_CASE_SENSITIVE_INFO>() - 4usize];
    ["Alignment of _FILE_CASE_SENSITIVE_INFO"]
        [::std::mem::align_of::<_FILE_CASE_SENSITIVE_INFO>() - 4usize];
    ["Offset of field: _FILE_CASE_SENSITIVE_INFO::Flags"]
        [::std::mem::offset_of!(_FILE_CASE_SENSITIVE_INFO, Flags) - 0usize];
};
pub type FILE_CASE_SENSITIVE_INFO = _FILE_CASE_SENSITIVE_INFO;
pub type PFILE_CASE_SENSITIVE_INFO = *mut _FILE_CASE_SENSITIVE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_RENAME_INFO {
    pub __bindgen_anon_1: _FILE_RENAME_INFO__bindgen_ty_1,
    pub RootDirectory: HANDLE,
    pub FileNameLength: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _FILE_RENAME_INFO__bindgen_ty_1 {
    pub ReplaceIfExists: BOOLEAN,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_RENAME_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_RENAME_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _FILE_RENAME_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_RENAME_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _FILE_RENAME_INFO__bindgen_ty_1::ReplaceIfExists"]
        [::std::mem::offset_of!(_FILE_RENAME_INFO__bindgen_ty_1, ReplaceIfExists) - 0usize];
    ["Offset of field: _FILE_RENAME_INFO__bindgen_ty_1::Flags"]
        [::std::mem::offset_of!(_FILE_RENAME_INFO__bindgen_ty_1, Flags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_RENAME_INFO"][::std::mem::size_of::<_FILE_RENAME_INFO>() - 24usize];
    ["Alignment of _FILE_RENAME_INFO"][::std::mem::align_of::<_FILE_RENAME_INFO>() - 8usize];
    ["Offset of field: _FILE_RENAME_INFO::RootDirectory"]
        [::std::mem::offset_of!(_FILE_RENAME_INFO, RootDirectory) - 8usize];
    ["Offset of field: _FILE_RENAME_INFO::FileNameLength"]
        [::std::mem::offset_of!(_FILE_RENAME_INFO, FileNameLength) - 16usize];
    ["Offset of field: _FILE_RENAME_INFO::FileName"]
        [::std::mem::offset_of!(_FILE_RENAME_INFO, FileName) - 20usize];
};
pub type FILE_RENAME_INFO = _FILE_RENAME_INFO;
pub type PFILE_RENAME_INFO = *mut _FILE_RENAME_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ALLOCATION_INFO {
    pub AllocationSize: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ALLOCATION_INFO"][::std::mem::size_of::<_FILE_ALLOCATION_INFO>() - 8usize];
    ["Alignment of _FILE_ALLOCATION_INFO"]
        [::std::mem::align_of::<_FILE_ALLOCATION_INFO>() - 8usize];
    ["Offset of field: _FILE_ALLOCATION_INFO::AllocationSize"]
        [::std::mem::offset_of!(_FILE_ALLOCATION_INFO, AllocationSize) - 0usize];
};
pub type FILE_ALLOCATION_INFO = _FILE_ALLOCATION_INFO;
pub type PFILE_ALLOCATION_INFO = *mut _FILE_ALLOCATION_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_END_OF_FILE_INFO {
    pub EndOfFile: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_END_OF_FILE_INFO"][::std::mem::size_of::<_FILE_END_OF_FILE_INFO>() - 8usize];
    ["Alignment of _FILE_END_OF_FILE_INFO"]
        [::std::mem::align_of::<_FILE_END_OF_FILE_INFO>() - 8usize];
    ["Offset of field: _FILE_END_OF_FILE_INFO::EndOfFile"]
        [::std::mem::offset_of!(_FILE_END_OF_FILE_INFO, EndOfFile) - 0usize];
};
pub type FILE_END_OF_FILE_INFO = _FILE_END_OF_FILE_INFO;
pub type PFILE_END_OF_FILE_INFO = *mut _FILE_END_OF_FILE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_STREAM_INFO {
    pub NextEntryOffset: DWORD,
    pub StreamNameLength: DWORD,
    pub StreamSize: LARGE_INTEGER,
    pub StreamAllocationSize: LARGE_INTEGER,
    pub StreamName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_STREAM_INFO"][::std::mem::size_of::<_FILE_STREAM_INFO>() - 32usize];
    ["Alignment of _FILE_STREAM_INFO"][::std::mem::align_of::<_FILE_STREAM_INFO>() - 8usize];
    ["Offset of field: _FILE_STREAM_INFO::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_STREAM_INFO, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_STREAM_INFO::StreamNameLength"]
        [::std::mem::offset_of!(_FILE_STREAM_INFO, StreamNameLength) - 4usize];
    ["Offset of field: _FILE_STREAM_INFO::StreamSize"]
        [::std::mem::offset_of!(_FILE_STREAM_INFO, StreamSize) - 8usize];
    ["Offset of field: _FILE_STREAM_INFO::StreamAllocationSize"]
        [::std::mem::offset_of!(_FILE_STREAM_INFO, StreamAllocationSize) - 16usize];
    ["Offset of field: _FILE_STREAM_INFO::StreamName"]
        [::std::mem::offset_of!(_FILE_STREAM_INFO, StreamName) - 24usize];
};
pub type FILE_STREAM_INFO = _FILE_STREAM_INFO;
pub type PFILE_STREAM_INFO = *mut _FILE_STREAM_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_COMPRESSION_INFO {
    pub CompressedFileSize: LARGE_INTEGER,
    pub CompressionFormat: WORD,
    pub CompressionUnitShift: UCHAR,
    pub ChunkShift: UCHAR,
    pub ClusterShift: UCHAR,
    pub Reserved: [UCHAR; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_COMPRESSION_INFO"][::std::mem::size_of::<_FILE_COMPRESSION_INFO>() - 16usize];
    ["Alignment of _FILE_COMPRESSION_INFO"]
        [::std::mem::align_of::<_FILE_COMPRESSION_INFO>() - 8usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::CompressedFileSize"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, CompressedFileSize) - 0usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::CompressionFormat"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, CompressionFormat) - 8usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::CompressionUnitShift"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, CompressionUnitShift) - 10usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::ChunkShift"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, ChunkShift) - 11usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::ClusterShift"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, ClusterShift) - 12usize];
    ["Offset of field: _FILE_COMPRESSION_INFO::Reserved"]
        [::std::mem::offset_of!(_FILE_COMPRESSION_INFO, Reserved) - 13usize];
};
pub type FILE_COMPRESSION_INFO = _FILE_COMPRESSION_INFO;
pub type PFILE_COMPRESSION_INFO = *mut _FILE_COMPRESSION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_ATTRIBUTE_TAG_INFO {
    pub FileAttributes: DWORD,
    pub ReparseTag: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ATTRIBUTE_TAG_INFO"]
        [::std::mem::size_of::<_FILE_ATTRIBUTE_TAG_INFO>() - 8usize];
    ["Alignment of _FILE_ATTRIBUTE_TAG_INFO"]
        [::std::mem::align_of::<_FILE_ATTRIBUTE_TAG_INFO>() - 4usize];
    ["Offset of field: _FILE_ATTRIBUTE_TAG_INFO::FileAttributes"]
        [::std::mem::offset_of!(_FILE_ATTRIBUTE_TAG_INFO, FileAttributes) - 0usize];
    ["Offset of field: _FILE_ATTRIBUTE_TAG_INFO::ReparseTag"]
        [::std::mem::offset_of!(_FILE_ATTRIBUTE_TAG_INFO, ReparseTag) - 4usize];
};
pub type FILE_ATTRIBUTE_TAG_INFO = _FILE_ATTRIBUTE_TAG_INFO;
pub type PFILE_ATTRIBUTE_TAG_INFO = *mut _FILE_ATTRIBUTE_TAG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_DISPOSITION_INFO {
    pub DeleteFileA: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_DISPOSITION_INFO"][::std::mem::size_of::<_FILE_DISPOSITION_INFO>() - 1usize];
    ["Alignment of _FILE_DISPOSITION_INFO"]
        [::std::mem::align_of::<_FILE_DISPOSITION_INFO>() - 1usize];
    ["Offset of field: _FILE_DISPOSITION_INFO::DeleteFileA"]
        [::std::mem::offset_of!(_FILE_DISPOSITION_INFO, DeleteFileA) - 0usize];
};
pub type FILE_DISPOSITION_INFO = _FILE_DISPOSITION_INFO;
pub type PFILE_DISPOSITION_INFO = *mut _FILE_DISPOSITION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_DISPOSITION_INFO_EX {
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_DISPOSITION_INFO_EX"]
        [::std::mem::size_of::<_FILE_DISPOSITION_INFO_EX>() - 4usize];
    ["Alignment of _FILE_DISPOSITION_INFO_EX"]
        [::std::mem::align_of::<_FILE_DISPOSITION_INFO_EX>() - 4usize];
    ["Offset of field: _FILE_DISPOSITION_INFO_EX::Flags"]
        [::std::mem::offset_of!(_FILE_DISPOSITION_INFO_EX, Flags) - 0usize];
};
pub type FILE_DISPOSITION_INFO_EX = _FILE_DISPOSITION_INFO_EX;
pub type PFILE_DISPOSITION_INFO_EX = *mut _FILE_DISPOSITION_INFO_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ID_BOTH_DIR_INFO {
    pub NextEntryOffset: DWORD,
    pub FileIndex: DWORD,
    pub CreationTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub LastWriteTime: LARGE_INTEGER,
    pub ChangeTime: LARGE_INTEGER,
    pub EndOfFile: LARGE_INTEGER,
    pub AllocationSize: LARGE_INTEGER,
    pub FileAttributes: DWORD,
    pub FileNameLength: DWORD,
    pub EaSize: DWORD,
    pub ShortNameLength: CCHAR,
    pub ShortName: [WCHAR; 12usize],
    pub FileId: LARGE_INTEGER,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ID_BOTH_DIR_INFO"][::std::mem::size_of::<_FILE_ID_BOTH_DIR_INFO>() - 112usize];
    ["Alignment of _FILE_ID_BOTH_DIR_INFO"]
        [::std::mem::align_of::<_FILE_ID_BOTH_DIR_INFO>() - 8usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::FileIndex"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, FileIndex) - 4usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::CreationTime"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, CreationTime) - 8usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, LastAccessTime) - 16usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::LastWriteTime"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, LastWriteTime) - 24usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::ChangeTime"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, ChangeTime) - 32usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::EndOfFile"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, EndOfFile) - 40usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::AllocationSize"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, AllocationSize) - 48usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::FileAttributes"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, FileAttributes) - 56usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::FileNameLength"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, FileNameLength) - 60usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::EaSize"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, EaSize) - 64usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::ShortNameLength"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, ShortNameLength) - 68usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::ShortName"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, ShortName) - 70usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::FileId"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, FileId) - 96usize];
    ["Offset of field: _FILE_ID_BOTH_DIR_INFO::FileName"]
        [::std::mem::offset_of!(_FILE_ID_BOTH_DIR_INFO, FileName) - 104usize];
};
pub type FILE_ID_BOTH_DIR_INFO = _FILE_ID_BOTH_DIR_INFO;
pub type PFILE_ID_BOTH_DIR_INFO = *mut _FILE_ID_BOTH_DIR_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_FULL_DIR_INFO {
    pub NextEntryOffset: ULONG,
    pub FileIndex: ULONG,
    pub CreationTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub LastWriteTime: LARGE_INTEGER,
    pub ChangeTime: LARGE_INTEGER,
    pub EndOfFile: LARGE_INTEGER,
    pub AllocationSize: LARGE_INTEGER,
    pub FileAttributes: ULONG,
    pub FileNameLength: ULONG,
    pub EaSize: ULONG,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_FULL_DIR_INFO"][::std::mem::size_of::<_FILE_FULL_DIR_INFO>() - 72usize];
    ["Alignment of _FILE_FULL_DIR_INFO"][::std::mem::align_of::<_FILE_FULL_DIR_INFO>() - 8usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::FileIndex"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, FileIndex) - 4usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::CreationTime"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, CreationTime) - 8usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, LastAccessTime) - 16usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::LastWriteTime"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, LastWriteTime) - 24usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::ChangeTime"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, ChangeTime) - 32usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::EndOfFile"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, EndOfFile) - 40usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::AllocationSize"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, AllocationSize) - 48usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::FileAttributes"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, FileAttributes) - 56usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::FileNameLength"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, FileNameLength) - 60usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::EaSize"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, EaSize) - 64usize];
    ["Offset of field: _FILE_FULL_DIR_INFO::FileName"]
        [::std::mem::offset_of!(_FILE_FULL_DIR_INFO, FileName) - 68usize];
};
pub type FILE_FULL_DIR_INFO = _FILE_FULL_DIR_INFO;
pub type PFILE_FULL_DIR_INFO = *mut _FILE_FULL_DIR_INFO;
pub const _PRIORITY_HINT_IoPriorityHintVeryLow: _PRIORITY_HINT = 0;
pub const _PRIORITY_HINT_IoPriorityHintLow: _PRIORITY_HINT = 1;
pub const _PRIORITY_HINT_IoPriorityHintNormal: _PRIORITY_HINT = 2;
pub const _PRIORITY_HINT_MaximumIoPriorityHintType: _PRIORITY_HINT = 3;
pub type _PRIORITY_HINT = ::std::os::raw::c_int;
pub use self::_PRIORITY_HINT as PRIORITY_HINT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_IO_PRIORITY_HINT_INFO {
    pub PriorityHint: PRIORITY_HINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_IO_PRIORITY_HINT_INFO"]
        [::std::mem::size_of::<_FILE_IO_PRIORITY_HINT_INFO>() - 4usize];
    ["Alignment of _FILE_IO_PRIORITY_HINT_INFO"]
        [::std::mem::align_of::<_FILE_IO_PRIORITY_HINT_INFO>() - 4usize];
    ["Offset of field: _FILE_IO_PRIORITY_HINT_INFO::PriorityHint"]
        [::std::mem::offset_of!(_FILE_IO_PRIORITY_HINT_INFO, PriorityHint) - 0usize];
};
pub type FILE_IO_PRIORITY_HINT_INFO = _FILE_IO_PRIORITY_HINT_INFO;
pub type PFILE_IO_PRIORITY_HINT_INFO = *mut _FILE_IO_PRIORITY_HINT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_ALIGNMENT_INFO {
    pub AlignmentRequirement: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ALIGNMENT_INFO"][::std::mem::size_of::<_FILE_ALIGNMENT_INFO>() - 4usize];
    ["Alignment of _FILE_ALIGNMENT_INFO"][::std::mem::align_of::<_FILE_ALIGNMENT_INFO>() - 4usize];
    ["Offset of field: _FILE_ALIGNMENT_INFO::AlignmentRequirement"]
        [::std::mem::offset_of!(_FILE_ALIGNMENT_INFO, AlignmentRequirement) - 0usize];
};
pub type FILE_ALIGNMENT_INFO = _FILE_ALIGNMENT_INFO;
pub type PFILE_ALIGNMENT_INFO = *mut _FILE_ALIGNMENT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_STORAGE_INFO {
    pub LogicalBytesPerSector: ULONG,
    pub PhysicalBytesPerSectorForAtomicity: ULONG,
    pub PhysicalBytesPerSectorForPerformance: ULONG,
    pub FileSystemEffectivePhysicalBytesPerSectorForAtomicity: ULONG,
    pub Flags: ULONG,
    pub ByteOffsetForSectorAlignment: ULONG,
    pub ByteOffsetForPartitionAlignment: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_STORAGE_INFO"][::std::mem::size_of::<_FILE_STORAGE_INFO>() - 28usize];
    ["Alignment of _FILE_STORAGE_INFO"][::std::mem::align_of::<_FILE_STORAGE_INFO>() - 4usize];
    ["Offset of field: _FILE_STORAGE_INFO::LogicalBytesPerSector"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, LogicalBytesPerSector) - 0usize];
    ["Offset of field: _FILE_STORAGE_INFO::PhysicalBytesPerSectorForAtomicity"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, PhysicalBytesPerSectorForAtomicity) - 4usize];
    ["Offset of field: _FILE_STORAGE_INFO::PhysicalBytesPerSectorForPerformance"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, PhysicalBytesPerSectorForPerformance) - 8usize];
    ["Offset of field: _FILE_STORAGE_INFO::FileSystemEffectivePhysicalBytesPerSectorForAtomicity"] [:: std :: mem :: offset_of ! (_FILE_STORAGE_INFO , FileSystemEffectivePhysicalBytesPerSectorForAtomicity) - 12usize] ;
    ["Offset of field: _FILE_STORAGE_INFO::Flags"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, Flags) - 16usize];
    ["Offset of field: _FILE_STORAGE_INFO::ByteOffsetForSectorAlignment"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, ByteOffsetForSectorAlignment) - 20usize];
    ["Offset of field: _FILE_STORAGE_INFO::ByteOffsetForPartitionAlignment"]
        [::std::mem::offset_of!(_FILE_STORAGE_INFO, ByteOffsetForPartitionAlignment) - 24usize];
};
pub type FILE_STORAGE_INFO = _FILE_STORAGE_INFO;
pub type PFILE_STORAGE_INFO = *mut _FILE_STORAGE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_ID_INFO {
    pub VolumeSerialNumber: ULONGLONG,
    pub FileId: FILE_ID_128,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ID_INFO"][::std::mem::size_of::<_FILE_ID_INFO>() - 24usize];
    ["Alignment of _FILE_ID_INFO"][::std::mem::align_of::<_FILE_ID_INFO>() - 8usize];
    ["Offset of field: _FILE_ID_INFO::VolumeSerialNumber"]
        [::std::mem::offset_of!(_FILE_ID_INFO, VolumeSerialNumber) - 0usize];
    ["Offset of field: _FILE_ID_INFO::FileId"]
        [::std::mem::offset_of!(_FILE_ID_INFO, FileId) - 8usize];
};
pub type FILE_ID_INFO = _FILE_ID_INFO;
pub type PFILE_ID_INFO = *mut _FILE_ID_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ID_EXTD_DIR_INFO {
    pub NextEntryOffset: ULONG,
    pub FileIndex: ULONG,
    pub CreationTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub LastWriteTime: LARGE_INTEGER,
    pub ChangeTime: LARGE_INTEGER,
    pub EndOfFile: LARGE_INTEGER,
    pub AllocationSize: LARGE_INTEGER,
    pub FileAttributes: ULONG,
    pub FileNameLength: ULONG,
    pub EaSize: ULONG,
    pub ReparsePointTag: ULONG,
    pub FileId: FILE_ID_128,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ID_EXTD_DIR_INFO"][::std::mem::size_of::<_FILE_ID_EXTD_DIR_INFO>() - 96usize];
    ["Alignment of _FILE_ID_EXTD_DIR_INFO"]
        [::std::mem::align_of::<_FILE_ID_EXTD_DIR_INFO>() - 8usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::NextEntryOffset"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, NextEntryOffset) - 0usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::FileIndex"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, FileIndex) - 4usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::CreationTime"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, CreationTime) - 8usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, LastAccessTime) - 16usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::LastWriteTime"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, LastWriteTime) - 24usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::ChangeTime"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, ChangeTime) - 32usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::EndOfFile"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, EndOfFile) - 40usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::AllocationSize"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, AllocationSize) - 48usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::FileAttributes"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, FileAttributes) - 56usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::FileNameLength"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, FileNameLength) - 60usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::EaSize"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, EaSize) - 64usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::ReparsePointTag"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, ReparsePointTag) - 68usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::FileId"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, FileId) - 72usize];
    ["Offset of field: _FILE_ID_EXTD_DIR_INFO::FileName"]
        [::std::mem::offset_of!(_FILE_ID_EXTD_DIR_INFO, FileName) - 88usize];
};
pub type FILE_ID_EXTD_DIR_INFO = _FILE_ID_EXTD_DIR_INFO;
pub type PFILE_ID_EXTD_DIR_INFO = *mut _FILE_ID_EXTD_DIR_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_REMOTE_PROTOCOL_INFO {
    pub StructureVersion: USHORT,
    pub StructureSize: USHORT,
    pub Protocol: ULONG,
    pub ProtocolMajorVersion: USHORT,
    pub ProtocolMinorVersion: USHORT,
    pub ProtocolRevision: USHORT,
    pub Reserved: USHORT,
    pub Flags: ULONG,
    pub GenericReserved: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1,
    pub ProtocolSpecific: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1 {
    pub Reserved: [ULONG; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1>() - 32usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1::Reserved"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_1, Reserved) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2 {
    pub Smb2: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1,
    pub Reserved: [ULONG; 16usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1 {
    pub Server: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1,
    pub Share: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1 {
    pub Capabilities: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1::Capabilities"] [:: std :: mem :: offset_of ! (_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_1 , Capabilities) - 0usize] ;
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2 {
    pub Capabilities: ULONG,
    pub CachingFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2>(
        ) - 8usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<
            _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2,
        >() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2::Capabilities"] [:: std :: mem :: offset_of ! (_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2 , Capabilities) - 0usize] ;
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2::CachingFlags"] [:: std :: mem :: offset_of ! (_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1__bindgen_ty_2 , CachingFlags) - 4usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1>() - 12usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1>() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1::Server"][::std::mem::offset_of!(
        _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1,
        Server
    ) - 0usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1::Share"][::std::mem::offset_of!(
        _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2__bindgen_ty_1,
        Share
    ) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2>() - 64usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2"]
        [::std::mem::align_of::<_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2>() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2::Smb2"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2, Smb2) - 0usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2::Reserved"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO__bindgen_ty_2, Reserved) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REMOTE_PROTOCOL_INFO"]
        [::std::mem::size_of::<_FILE_REMOTE_PROTOCOL_INFO>() - 116usize];
    ["Alignment of _FILE_REMOTE_PROTOCOL_INFO"]
        [::std::mem::align_of::<_FILE_REMOTE_PROTOCOL_INFO>() - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::StructureVersion"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, StructureVersion) - 0usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::StructureSize"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, StructureSize) - 2usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::Protocol"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, Protocol) - 4usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::ProtocolMajorVersion"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, ProtocolMajorVersion) - 8usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::ProtocolMinorVersion"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, ProtocolMinorVersion) - 10usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::ProtocolRevision"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, ProtocolRevision) - 12usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::Reserved"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, Reserved) - 14usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::Flags"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, Flags) - 16usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::GenericReserved"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, GenericReserved) - 20usize];
    ["Offset of field: _FILE_REMOTE_PROTOCOL_INFO::ProtocolSpecific"]
        [::std::mem::offset_of!(_FILE_REMOTE_PROTOCOL_INFO, ProtocolSpecific) - 52usize];
};
pub type FILE_REMOTE_PROTOCOL_INFO = _FILE_REMOTE_PROTOCOL_INFO;
pub type PFILE_REMOTE_PROTOCOL_INFO = *mut _FILE_REMOTE_PROTOCOL_INFO;
unsafe extern "C" {
    pub fn GetFileInformationByHandleEx(
        hFile: HANDLE,
        FileInformationClass: FILE_INFO_BY_HANDLE_CLASS,
        lpFileInformation: LPVOID,
        dwBufferSize: DWORD,
    ) -> BOOL;
}
pub const _FILE_ID_TYPE_FileIdType: _FILE_ID_TYPE = 0;
pub const _FILE_ID_TYPE_ObjectIdType: _FILE_ID_TYPE = 1;
pub const _FILE_ID_TYPE_ExtendedFileIdType: _FILE_ID_TYPE = 2;
pub const _FILE_ID_TYPE_MaximumFileIdType: _FILE_ID_TYPE = 3;
pub type _FILE_ID_TYPE = ::std::os::raw::c_int;
pub use self::_FILE_ID_TYPE as FILE_ID_TYPE;
pub type PFILE_ID_TYPE = *mut _FILE_ID_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct FILE_ID_DESCRIPTOR {
    pub dwSize: DWORD,
    pub Type: FILE_ID_TYPE,
    pub __bindgen_anon_1: FILE_ID_DESCRIPTOR__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union FILE_ID_DESCRIPTOR__bindgen_ty_1 {
    pub FileId: LARGE_INTEGER,
    pub ObjectId: GUID,
    pub ExtendedFileId: FILE_ID_128,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of FILE_ID_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::size_of::<FILE_ID_DESCRIPTOR__bindgen_ty_1>() - 16usize];
    ["Alignment of FILE_ID_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::align_of::<FILE_ID_DESCRIPTOR__bindgen_ty_1>() - 8usize];
    ["Offset of field: FILE_ID_DESCRIPTOR__bindgen_ty_1::FileId"]
        [::std::mem::offset_of!(FILE_ID_DESCRIPTOR__bindgen_ty_1, FileId) - 0usize];
    ["Offset of field: FILE_ID_DESCRIPTOR__bindgen_ty_1::ObjectId"]
        [::std::mem::offset_of!(FILE_ID_DESCRIPTOR__bindgen_ty_1, ObjectId) - 0usize];
    ["Offset of field: FILE_ID_DESCRIPTOR__bindgen_ty_1::ExtendedFileId"]
        [::std::mem::offset_of!(FILE_ID_DESCRIPTOR__bindgen_ty_1, ExtendedFileId) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of FILE_ID_DESCRIPTOR"][::std::mem::size_of::<FILE_ID_DESCRIPTOR>() - 24usize];
    ["Alignment of FILE_ID_DESCRIPTOR"][::std::mem::align_of::<FILE_ID_DESCRIPTOR>() - 8usize];
    ["Offset of field: FILE_ID_DESCRIPTOR::dwSize"]
        [::std::mem::offset_of!(FILE_ID_DESCRIPTOR, dwSize) - 0usize];
    ["Offset of field: FILE_ID_DESCRIPTOR::Type"]
        [::std::mem::offset_of!(FILE_ID_DESCRIPTOR, Type) - 4usize];
};
pub type LPFILE_ID_DESCRIPTOR = *mut FILE_ID_DESCRIPTOR;
unsafe extern "C" {
    pub fn OpenFileById(
        hVolumeHint: HANDLE,
        lpFileId: LPFILE_ID_DESCRIPTOR,
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        dwFlagsAndAttributes: DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CreateSymbolicLinkA(
        lpSymlinkFileName: LPCSTR,
        lpTargetFileName: LPCSTR,
        dwFlags: DWORD,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn CreateSymbolicLinkW(
        lpSymlinkFileName: LPCWSTR,
        lpTargetFileName: LPCWSTR,
        dwFlags: DWORD,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn QueryActCtxSettingsW(
        dwFlags: DWORD,
        hActCtx: HANDLE,
        settingsNameSpace: PCWSTR,
        settingName: PCWSTR,
        pvBuffer: PWSTR,
        dwBuffer: SIZE_T,
        pdwWrittenOrRequired: *mut SIZE_T,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateSymbolicLinkTransactedA(
        lpSymlinkFileName: LPCSTR,
        lpTargetFileName: LPCSTR,
        dwFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn CreateSymbolicLinkTransactedW(
        lpSymlinkFileName: LPCWSTR,
        lpTargetFileName: LPCWSTR,
        dwFlags: DWORD,
        hTransaction: HANDLE,
    ) -> BOOLEAN;
}
unsafe extern "C" {
    pub fn ReplacePartitionUnit(
        TargetPartition: PWSTR,
        SparePartition: PWSTR,
        Flags: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddSecureMemoryCacheCallback(pfnCallBack: PSECURE_MEMORY_CACHE_CALLBACK) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveSecureMemoryCacheCallback(pfnCallBack: PSECURE_MEMORY_CACHE_CALLBACK) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyContext(Destination: PCONTEXT, ContextFlags: DWORD, Source: PCONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeContext(
        Buffer: PVOID,
        ContextFlags: DWORD,
        Context: *mut PCONTEXT,
        ContextLength: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitializeContext2(
        Buffer: PVOID,
        ContextFlags: DWORD,
        Context: *mut PCONTEXT,
        ContextLength: PDWORD,
        XStateCompactionMask: ULONG64,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetEnabledXStateFeatures() -> DWORD64;
}
unsafe extern "C" {
    pub fn GetXStateFeaturesMask(Context: PCONTEXT, FeatureMask: PDWORD64) -> BOOL;
}
unsafe extern "C" {
    pub fn LocateXStateFeature(Context: PCONTEXT, FeatureId: DWORD, Length: PDWORD) -> PVOID;
}
unsafe extern "C" {
    pub fn SetXStateFeaturesMask(Context: PCONTEXT, FeatureMask: DWORD64) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadEnabledXStateFeatures() -> DWORD64;
}
unsafe extern "C" {
    pub fn EnableProcessOptionalXStateFeatures(Features: DWORD64) -> BOOL;
}
unsafe extern "C" {
    pub fn EnableThreadProfiling(
        ThreadHandle: HANDLE,
        Flags: DWORD,
        HardwareCounters: DWORD64,
        PerformanceDataHandle: *mut HANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DisableThreadProfiling(PerformanceDataHandle: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn QueryThreadProfiling(ThreadHandle: HANDLE, Enabled: PBOOLEAN) -> DWORD;
}
unsafe extern "C" {
    pub fn ReadThreadProfilingData(
        PerformanceDataHandle: HANDLE,
        Flags: DWORD,
        PerformanceData: PPERFORMANCE_DATA,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RaiseCustomSystemEventTrigger(
        CustomSystemEventTriggerConfig: PCUSTOM_SYSTEM_EVENT_TRIGGER_CONFIG,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRAWPATRECT {
    pub ptPosition: POINT,
    pub ptSize: POINT,
    pub wStyle: WORD,
    pub wPattern: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRAWPATRECT"][::std::mem::size_of::<_DRAWPATRECT>() - 20usize];
    ["Alignment of _DRAWPATRECT"][::std::mem::align_of::<_DRAWPATRECT>() - 4usize];
    ["Offset of field: _DRAWPATRECT::ptPosition"]
        [::std::mem::offset_of!(_DRAWPATRECT, ptPosition) - 0usize];
    ["Offset of field: _DRAWPATRECT::ptSize"]
        [::std::mem::offset_of!(_DRAWPATRECT, ptSize) - 8usize];
    ["Offset of field: _DRAWPATRECT::wStyle"]
        [::std::mem::offset_of!(_DRAWPATRECT, wStyle) - 16usize];
    ["Offset of field: _DRAWPATRECT::wPattern"]
        [::std::mem::offset_of!(_DRAWPATRECT, wPattern) - 18usize];
};
pub type DRAWPATRECT = _DRAWPATRECT;
pub type PDRAWPATRECT = *mut _DRAWPATRECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PSINJECTDATA {
    pub DataBytes: DWORD,
    pub InjectionPoint: WORD,
    pub PageNumber: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PSINJECTDATA"][::std::mem::size_of::<_PSINJECTDATA>() - 8usize];
    ["Alignment of _PSINJECTDATA"][::std::mem::align_of::<_PSINJECTDATA>() - 4usize];
    ["Offset of field: _PSINJECTDATA::DataBytes"]
        [::std::mem::offset_of!(_PSINJECTDATA, DataBytes) - 0usize];
    ["Offset of field: _PSINJECTDATA::InjectionPoint"]
        [::std::mem::offset_of!(_PSINJECTDATA, InjectionPoint) - 4usize];
    ["Offset of field: _PSINJECTDATA::PageNumber"]
        [::std::mem::offset_of!(_PSINJECTDATA, PageNumber) - 6usize];
};
pub type PSINJECTDATA = _PSINJECTDATA;
pub type PPSINJECTDATA = *mut _PSINJECTDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PSFEATURE_OUTPUT {
    pub bPageIndependent: BOOL,
    pub bSetPageDevice: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PSFEATURE_OUTPUT"][::std::mem::size_of::<_PSFEATURE_OUTPUT>() - 8usize];
    ["Alignment of _PSFEATURE_OUTPUT"][::std::mem::align_of::<_PSFEATURE_OUTPUT>() - 4usize];
    ["Offset of field: _PSFEATURE_OUTPUT::bPageIndependent"]
        [::std::mem::offset_of!(_PSFEATURE_OUTPUT, bPageIndependent) - 0usize];
    ["Offset of field: _PSFEATURE_OUTPUT::bSetPageDevice"]
        [::std::mem::offset_of!(_PSFEATURE_OUTPUT, bSetPageDevice) - 4usize];
};
pub type PSFEATURE_OUTPUT = _PSFEATURE_OUTPUT;
pub type PPSFEATURE_OUTPUT = *mut _PSFEATURE_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PSFEATURE_CUSTPAPER {
    pub lOrientation: LONG,
    pub lWidth: LONG,
    pub lHeight: LONG,
    pub lWidthOffset: LONG,
    pub lHeightOffset: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PSFEATURE_CUSTPAPER"][::std::mem::size_of::<_PSFEATURE_CUSTPAPER>() - 20usize];
    ["Alignment of _PSFEATURE_CUSTPAPER"][::std::mem::align_of::<_PSFEATURE_CUSTPAPER>() - 4usize];
    ["Offset of field: _PSFEATURE_CUSTPAPER::lOrientation"]
        [::std::mem::offset_of!(_PSFEATURE_CUSTPAPER, lOrientation) - 0usize];
    ["Offset of field: _PSFEATURE_CUSTPAPER::lWidth"]
        [::std::mem::offset_of!(_PSFEATURE_CUSTPAPER, lWidth) - 4usize];
    ["Offset of field: _PSFEATURE_CUSTPAPER::lHeight"]
        [::std::mem::offset_of!(_PSFEATURE_CUSTPAPER, lHeight) - 8usize];
    ["Offset of field: _PSFEATURE_CUSTPAPER::lWidthOffset"]
        [::std::mem::offset_of!(_PSFEATURE_CUSTPAPER, lWidthOffset) - 12usize];
    ["Offset of field: _PSFEATURE_CUSTPAPER::lHeightOffset"]
        [::std::mem::offset_of!(_PSFEATURE_CUSTPAPER, lHeightOffset) - 16usize];
};
pub type PSFEATURE_CUSTPAPER = _PSFEATURE_CUSTPAPER;
pub type PPSFEATURE_CUSTPAPER = *mut _PSFEATURE_CUSTPAPER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagXFORM {
    pub eM11: FLOAT,
    pub eM12: FLOAT,
    pub eM21: FLOAT,
    pub eM22: FLOAT,
    pub eDx: FLOAT,
    pub eDy: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagXFORM"][::std::mem::size_of::<tagXFORM>() - 24usize];
    ["Alignment of tagXFORM"][::std::mem::align_of::<tagXFORM>() - 4usize];
    ["Offset of field: tagXFORM::eM11"][::std::mem::offset_of!(tagXFORM, eM11) - 0usize];
    ["Offset of field: tagXFORM::eM12"][::std::mem::offset_of!(tagXFORM, eM12) - 4usize];
    ["Offset of field: tagXFORM::eM21"][::std::mem::offset_of!(tagXFORM, eM21) - 8usize];
    ["Offset of field: tagXFORM::eM22"][::std::mem::offset_of!(tagXFORM, eM22) - 12usize];
    ["Offset of field: tagXFORM::eDx"][::std::mem::offset_of!(tagXFORM, eDx) - 16usize];
    ["Offset of field: tagXFORM::eDy"][::std::mem::offset_of!(tagXFORM, eDy) - 20usize];
};
pub type XFORM = tagXFORM;
pub type PXFORM = *mut tagXFORM;
pub type LPXFORM = *mut tagXFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAP {
    pub bmType: LONG,
    pub bmWidth: LONG,
    pub bmHeight: LONG,
    pub bmWidthBytes: LONG,
    pub bmPlanes: WORD,
    pub bmBitsPixel: WORD,
    pub bmBits: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAP"][::std::mem::size_of::<tagBITMAP>() - 32usize];
    ["Alignment of tagBITMAP"][::std::mem::align_of::<tagBITMAP>() - 8usize];
    ["Offset of field: tagBITMAP::bmType"][::std::mem::offset_of!(tagBITMAP, bmType) - 0usize];
    ["Offset of field: tagBITMAP::bmWidth"][::std::mem::offset_of!(tagBITMAP, bmWidth) - 4usize];
    ["Offset of field: tagBITMAP::bmHeight"][::std::mem::offset_of!(tagBITMAP, bmHeight) - 8usize];
    ["Offset of field: tagBITMAP::bmWidthBytes"]
        [::std::mem::offset_of!(tagBITMAP, bmWidthBytes) - 12usize];
    ["Offset of field: tagBITMAP::bmPlanes"][::std::mem::offset_of!(tagBITMAP, bmPlanes) - 16usize];
    ["Offset of field: tagBITMAP::bmBitsPixel"]
        [::std::mem::offset_of!(tagBITMAP, bmBitsPixel) - 18usize];
    ["Offset of field: tagBITMAP::bmBits"][::std::mem::offset_of!(tagBITMAP, bmBits) - 24usize];
};
pub type BITMAP = tagBITMAP;
pub type PBITMAP = *mut tagBITMAP;
pub type NPBITMAP = *mut tagBITMAP;
pub type LPBITMAP = *mut tagBITMAP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRGBTRIPLE {
    pub rgbtBlue: BYTE,
    pub rgbtGreen: BYTE,
    pub rgbtRed: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRGBTRIPLE"][::std::mem::size_of::<tagRGBTRIPLE>() - 3usize];
    ["Alignment of tagRGBTRIPLE"][::std::mem::align_of::<tagRGBTRIPLE>() - 1usize];
    ["Offset of field: tagRGBTRIPLE::rgbtBlue"]
        [::std::mem::offset_of!(tagRGBTRIPLE, rgbtBlue) - 0usize];
    ["Offset of field: tagRGBTRIPLE::rgbtGreen"]
        [::std::mem::offset_of!(tagRGBTRIPLE, rgbtGreen) - 1usize];
    ["Offset of field: tagRGBTRIPLE::rgbtRed"]
        [::std::mem::offset_of!(tagRGBTRIPLE, rgbtRed) - 2usize];
};
pub type RGBTRIPLE = tagRGBTRIPLE;
pub type PRGBTRIPLE = *mut tagRGBTRIPLE;
pub type NPRGBTRIPLE = *mut tagRGBTRIPLE;
pub type LPRGBTRIPLE = *mut tagRGBTRIPLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRGBQUAD {
    pub rgbBlue: BYTE,
    pub rgbGreen: BYTE,
    pub rgbRed: BYTE,
    pub rgbReserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRGBQUAD"][::std::mem::size_of::<tagRGBQUAD>() - 4usize];
    ["Alignment of tagRGBQUAD"][::std::mem::align_of::<tagRGBQUAD>() - 1usize];
    ["Offset of field: tagRGBQUAD::rgbBlue"][::std::mem::offset_of!(tagRGBQUAD, rgbBlue) - 0usize];
    ["Offset of field: tagRGBQUAD::rgbGreen"]
        [::std::mem::offset_of!(tagRGBQUAD, rgbGreen) - 1usize];
    ["Offset of field: tagRGBQUAD::rgbRed"][::std::mem::offset_of!(tagRGBQUAD, rgbRed) - 2usize];
    ["Offset of field: tagRGBQUAD::rgbReserved"]
        [::std::mem::offset_of!(tagRGBQUAD, rgbReserved) - 3usize];
};
pub type RGBQUAD = tagRGBQUAD;
pub type LPRGBQUAD = *mut RGBQUAD;
pub type LCSCSTYPE = LONG;
pub type LCSGAMUTMATCH = LONG;
pub type FXPT16DOT16 = ::std::os::raw::c_long;
pub type LPFXPT16DOT16 = *mut ::std::os::raw::c_long;
pub type FXPT2DOT30 = ::std::os::raw::c_long;
pub type LPFXPT2DOT30 = *mut ::std::os::raw::c_long;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCIEXYZ {
    pub ciexyzX: FXPT2DOT30,
    pub ciexyzY: FXPT2DOT30,
    pub ciexyzZ: FXPT2DOT30,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCIEXYZ"][::std::mem::size_of::<tagCIEXYZ>() - 12usize];
    ["Alignment of tagCIEXYZ"][::std::mem::align_of::<tagCIEXYZ>() - 4usize];
    ["Offset of field: tagCIEXYZ::ciexyzX"][::std::mem::offset_of!(tagCIEXYZ, ciexyzX) - 0usize];
    ["Offset of field: tagCIEXYZ::ciexyzY"][::std::mem::offset_of!(tagCIEXYZ, ciexyzY) - 4usize];
    ["Offset of field: tagCIEXYZ::ciexyzZ"][::std::mem::offset_of!(tagCIEXYZ, ciexyzZ) - 8usize];
};
pub type CIEXYZ = tagCIEXYZ;
pub type LPCIEXYZ = *mut CIEXYZ;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagICEXYZTRIPLE {
    pub ciexyzRed: CIEXYZ,
    pub ciexyzGreen: CIEXYZ,
    pub ciexyzBlue: CIEXYZ,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagICEXYZTRIPLE"][::std::mem::size_of::<tagICEXYZTRIPLE>() - 36usize];
    ["Alignment of tagICEXYZTRIPLE"][::std::mem::align_of::<tagICEXYZTRIPLE>() - 4usize];
    ["Offset of field: tagICEXYZTRIPLE::ciexyzRed"]
        [::std::mem::offset_of!(tagICEXYZTRIPLE, ciexyzRed) - 0usize];
    ["Offset of field: tagICEXYZTRIPLE::ciexyzGreen"]
        [::std::mem::offset_of!(tagICEXYZTRIPLE, ciexyzGreen) - 12usize];
    ["Offset of field: tagICEXYZTRIPLE::ciexyzBlue"]
        [::std::mem::offset_of!(tagICEXYZTRIPLE, ciexyzBlue) - 24usize];
};
pub type CIEXYZTRIPLE = tagICEXYZTRIPLE;
pub type LPCIEXYZTRIPLE = *mut CIEXYZTRIPLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGCOLORSPACEA {
    pub lcsSignature: DWORD,
    pub lcsVersion: DWORD,
    pub lcsSize: DWORD,
    pub lcsCSType: LCSCSTYPE,
    pub lcsIntent: LCSGAMUTMATCH,
    pub lcsEndpoints: CIEXYZTRIPLE,
    pub lcsGammaRed: DWORD,
    pub lcsGammaGreen: DWORD,
    pub lcsGammaBlue: DWORD,
    pub lcsFilename: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGCOLORSPACEA"][::std::mem::size_of::<tagLOGCOLORSPACEA>() - 328usize];
    ["Alignment of tagLOGCOLORSPACEA"][::std::mem::align_of::<tagLOGCOLORSPACEA>() - 4usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsSignature"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsSignature) - 0usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsVersion"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsVersion) - 4usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsSize"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsSize) - 8usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsCSType"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsCSType) - 12usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsIntent"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsIntent) - 16usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsEndpoints"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsEndpoints) - 20usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsGammaRed"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsGammaRed) - 56usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsGammaGreen"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsGammaGreen) - 60usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsGammaBlue"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsGammaBlue) - 64usize];
    ["Offset of field: tagLOGCOLORSPACEA::lcsFilename"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEA, lcsFilename) - 68usize];
};
pub type LOGCOLORSPACEA = tagLOGCOLORSPACEA;
pub type LPLOGCOLORSPACEA = *mut tagLOGCOLORSPACEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGCOLORSPACEW {
    pub lcsSignature: DWORD,
    pub lcsVersion: DWORD,
    pub lcsSize: DWORD,
    pub lcsCSType: LCSCSTYPE,
    pub lcsIntent: LCSGAMUTMATCH,
    pub lcsEndpoints: CIEXYZTRIPLE,
    pub lcsGammaRed: DWORD,
    pub lcsGammaGreen: DWORD,
    pub lcsGammaBlue: DWORD,
    pub lcsFilename: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGCOLORSPACEW"][::std::mem::size_of::<tagLOGCOLORSPACEW>() - 588usize];
    ["Alignment of tagLOGCOLORSPACEW"][::std::mem::align_of::<tagLOGCOLORSPACEW>() - 4usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsSignature"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsSignature) - 0usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsVersion"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsVersion) - 4usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsSize"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsSize) - 8usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsCSType"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsCSType) - 12usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsIntent"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsIntent) - 16usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsEndpoints"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsEndpoints) - 20usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsGammaRed"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsGammaRed) - 56usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsGammaGreen"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsGammaGreen) - 60usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsGammaBlue"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsGammaBlue) - 64usize];
    ["Offset of field: tagLOGCOLORSPACEW::lcsFilename"]
        [::std::mem::offset_of!(tagLOGCOLORSPACEW, lcsFilename) - 68usize];
};
pub type LOGCOLORSPACEW = tagLOGCOLORSPACEW;
pub type LPLOGCOLORSPACEW = *mut tagLOGCOLORSPACEW;
pub type LOGCOLORSPACE = LOGCOLORSPACEA;
pub type LPLOGCOLORSPACE = LPLOGCOLORSPACEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAPCOREHEADER {
    pub bcSize: DWORD,
    pub bcWidth: WORD,
    pub bcHeight: WORD,
    pub bcPlanes: WORD,
    pub bcBitCount: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAPCOREHEADER"][::std::mem::size_of::<tagBITMAPCOREHEADER>() - 12usize];
    ["Alignment of tagBITMAPCOREHEADER"][::std::mem::align_of::<tagBITMAPCOREHEADER>() - 4usize];
    ["Offset of field: tagBITMAPCOREHEADER::bcSize"]
        [::std::mem::offset_of!(tagBITMAPCOREHEADER, bcSize) - 0usize];
    ["Offset of field: tagBITMAPCOREHEADER::bcWidth"]
        [::std::mem::offset_of!(tagBITMAPCOREHEADER, bcWidth) - 4usize];
    ["Offset of field: tagBITMAPCOREHEADER::bcHeight"]
        [::std::mem::offset_of!(tagBITMAPCOREHEADER, bcHeight) - 6usize];
    ["Offset of field: tagBITMAPCOREHEADER::bcPlanes"]
        [::std::mem::offset_of!(tagBITMAPCOREHEADER, bcPlanes) - 8usize];
    ["Offset of field: tagBITMAPCOREHEADER::bcBitCount"]
        [::std::mem::offset_of!(tagBITMAPCOREHEADER, bcBitCount) - 10usize];
};
pub type BITMAPCOREHEADER = tagBITMAPCOREHEADER;
pub type LPBITMAPCOREHEADER = *mut tagBITMAPCOREHEADER;
pub type PBITMAPCOREHEADER = *mut tagBITMAPCOREHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAPINFOHEADER {
    pub biSize: DWORD,
    pub biWidth: LONG,
    pub biHeight: LONG,
    pub biPlanes: WORD,
    pub biBitCount: WORD,
    pub biCompression: DWORD,
    pub biSizeImage: DWORD,
    pub biXPelsPerMeter: LONG,
    pub biYPelsPerMeter: LONG,
    pub biClrUsed: DWORD,
    pub biClrImportant: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAPINFOHEADER"][::std::mem::size_of::<tagBITMAPINFOHEADER>() - 40usize];
    ["Alignment of tagBITMAPINFOHEADER"][::std::mem::align_of::<tagBITMAPINFOHEADER>() - 4usize];
    ["Offset of field: tagBITMAPINFOHEADER::biSize"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biSize) - 0usize];
    ["Offset of field: tagBITMAPINFOHEADER::biWidth"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biWidth) - 4usize];
    ["Offset of field: tagBITMAPINFOHEADER::biHeight"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biHeight) - 8usize];
    ["Offset of field: tagBITMAPINFOHEADER::biPlanes"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biPlanes) - 12usize];
    ["Offset of field: tagBITMAPINFOHEADER::biBitCount"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biBitCount) - 14usize];
    ["Offset of field: tagBITMAPINFOHEADER::biCompression"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biCompression) - 16usize];
    ["Offset of field: tagBITMAPINFOHEADER::biSizeImage"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biSizeImage) - 20usize];
    ["Offset of field: tagBITMAPINFOHEADER::biXPelsPerMeter"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biXPelsPerMeter) - 24usize];
    ["Offset of field: tagBITMAPINFOHEADER::biYPelsPerMeter"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biYPelsPerMeter) - 28usize];
    ["Offset of field: tagBITMAPINFOHEADER::biClrUsed"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biClrUsed) - 32usize];
    ["Offset of field: tagBITMAPINFOHEADER::biClrImportant"]
        [::std::mem::offset_of!(tagBITMAPINFOHEADER, biClrImportant) - 36usize];
};
pub type BITMAPINFOHEADER = tagBITMAPINFOHEADER;
pub type LPBITMAPINFOHEADER = *mut tagBITMAPINFOHEADER;
pub type PBITMAPINFOHEADER = *mut tagBITMAPINFOHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct BITMAPV4HEADER {
    pub bV4Size: DWORD,
    pub bV4Width: LONG,
    pub bV4Height: LONG,
    pub bV4Planes: WORD,
    pub bV4BitCount: WORD,
    pub bV4V4Compression: DWORD,
    pub bV4SizeImage: DWORD,
    pub bV4XPelsPerMeter: LONG,
    pub bV4YPelsPerMeter: LONG,
    pub bV4ClrUsed: DWORD,
    pub bV4ClrImportant: DWORD,
    pub bV4RedMask: DWORD,
    pub bV4GreenMask: DWORD,
    pub bV4BlueMask: DWORD,
    pub bV4AlphaMask: DWORD,
    pub bV4CSType: DWORD,
    pub bV4Endpoints: CIEXYZTRIPLE,
    pub bV4GammaRed: DWORD,
    pub bV4GammaGreen: DWORD,
    pub bV4GammaBlue: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of BITMAPV4HEADER"][::std::mem::size_of::<BITMAPV4HEADER>() - 108usize];
    ["Alignment of BITMAPV4HEADER"][::std::mem::align_of::<BITMAPV4HEADER>() - 4usize];
    ["Offset of field: BITMAPV4HEADER::bV4Size"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4Size) - 0usize];
    ["Offset of field: BITMAPV4HEADER::bV4Width"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4Width) - 4usize];
    ["Offset of field: BITMAPV4HEADER::bV4Height"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4Height) - 8usize];
    ["Offset of field: BITMAPV4HEADER::bV4Planes"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4Planes) - 12usize];
    ["Offset of field: BITMAPV4HEADER::bV4BitCount"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4BitCount) - 14usize];
    ["Offset of field: BITMAPV4HEADER::bV4V4Compression"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4V4Compression) - 16usize];
    ["Offset of field: BITMAPV4HEADER::bV4SizeImage"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4SizeImage) - 20usize];
    ["Offset of field: BITMAPV4HEADER::bV4XPelsPerMeter"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4XPelsPerMeter) - 24usize];
    ["Offset of field: BITMAPV4HEADER::bV4YPelsPerMeter"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4YPelsPerMeter) - 28usize];
    ["Offset of field: BITMAPV4HEADER::bV4ClrUsed"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4ClrUsed) - 32usize];
    ["Offset of field: BITMAPV4HEADER::bV4ClrImportant"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4ClrImportant) - 36usize];
    ["Offset of field: BITMAPV4HEADER::bV4RedMask"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4RedMask) - 40usize];
    ["Offset of field: BITMAPV4HEADER::bV4GreenMask"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4GreenMask) - 44usize];
    ["Offset of field: BITMAPV4HEADER::bV4BlueMask"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4BlueMask) - 48usize];
    ["Offset of field: BITMAPV4HEADER::bV4AlphaMask"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4AlphaMask) - 52usize];
    ["Offset of field: BITMAPV4HEADER::bV4CSType"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4CSType) - 56usize];
    ["Offset of field: BITMAPV4HEADER::bV4Endpoints"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4Endpoints) - 60usize];
    ["Offset of field: BITMAPV4HEADER::bV4GammaRed"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4GammaRed) - 96usize];
    ["Offset of field: BITMAPV4HEADER::bV4GammaGreen"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4GammaGreen) - 100usize];
    ["Offset of field: BITMAPV4HEADER::bV4GammaBlue"]
        [::std::mem::offset_of!(BITMAPV4HEADER, bV4GammaBlue) - 104usize];
};
pub type LPBITMAPV4HEADER = *mut BITMAPV4HEADER;
pub type PBITMAPV4HEADER = *mut BITMAPV4HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct BITMAPV5HEADER {
    pub bV5Size: DWORD,
    pub bV5Width: LONG,
    pub bV5Height: LONG,
    pub bV5Planes: WORD,
    pub bV5BitCount: WORD,
    pub bV5Compression: DWORD,
    pub bV5SizeImage: DWORD,
    pub bV5XPelsPerMeter: LONG,
    pub bV5YPelsPerMeter: LONG,
    pub bV5ClrUsed: DWORD,
    pub bV5ClrImportant: DWORD,
    pub bV5RedMask: DWORD,
    pub bV5GreenMask: DWORD,
    pub bV5BlueMask: DWORD,
    pub bV5AlphaMask: DWORD,
    pub bV5CSType: DWORD,
    pub bV5Endpoints: CIEXYZTRIPLE,
    pub bV5GammaRed: DWORD,
    pub bV5GammaGreen: DWORD,
    pub bV5GammaBlue: DWORD,
    pub bV5Intent: DWORD,
    pub bV5ProfileData: DWORD,
    pub bV5ProfileSize: DWORD,
    pub bV5Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of BITMAPV5HEADER"][::std::mem::size_of::<BITMAPV5HEADER>() - 124usize];
    ["Alignment of BITMAPV5HEADER"][::std::mem::align_of::<BITMAPV5HEADER>() - 4usize];
    ["Offset of field: BITMAPV5HEADER::bV5Size"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Size) - 0usize];
    ["Offset of field: BITMAPV5HEADER::bV5Width"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Width) - 4usize];
    ["Offset of field: BITMAPV5HEADER::bV5Height"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Height) - 8usize];
    ["Offset of field: BITMAPV5HEADER::bV5Planes"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Planes) - 12usize];
    ["Offset of field: BITMAPV5HEADER::bV5BitCount"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5BitCount) - 14usize];
    ["Offset of field: BITMAPV5HEADER::bV5Compression"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Compression) - 16usize];
    ["Offset of field: BITMAPV5HEADER::bV5SizeImage"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5SizeImage) - 20usize];
    ["Offset of field: BITMAPV5HEADER::bV5XPelsPerMeter"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5XPelsPerMeter) - 24usize];
    ["Offset of field: BITMAPV5HEADER::bV5YPelsPerMeter"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5YPelsPerMeter) - 28usize];
    ["Offset of field: BITMAPV5HEADER::bV5ClrUsed"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5ClrUsed) - 32usize];
    ["Offset of field: BITMAPV5HEADER::bV5ClrImportant"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5ClrImportant) - 36usize];
    ["Offset of field: BITMAPV5HEADER::bV5RedMask"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5RedMask) - 40usize];
    ["Offset of field: BITMAPV5HEADER::bV5GreenMask"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5GreenMask) - 44usize];
    ["Offset of field: BITMAPV5HEADER::bV5BlueMask"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5BlueMask) - 48usize];
    ["Offset of field: BITMAPV5HEADER::bV5AlphaMask"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5AlphaMask) - 52usize];
    ["Offset of field: BITMAPV5HEADER::bV5CSType"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5CSType) - 56usize];
    ["Offset of field: BITMAPV5HEADER::bV5Endpoints"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Endpoints) - 60usize];
    ["Offset of field: BITMAPV5HEADER::bV5GammaRed"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5GammaRed) - 96usize];
    ["Offset of field: BITMAPV5HEADER::bV5GammaGreen"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5GammaGreen) - 100usize];
    ["Offset of field: BITMAPV5HEADER::bV5GammaBlue"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5GammaBlue) - 104usize];
    ["Offset of field: BITMAPV5HEADER::bV5Intent"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Intent) - 108usize];
    ["Offset of field: BITMAPV5HEADER::bV5ProfileData"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5ProfileData) - 112usize];
    ["Offset of field: BITMAPV5HEADER::bV5ProfileSize"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5ProfileSize) - 116usize];
    ["Offset of field: BITMAPV5HEADER::bV5Reserved"]
        [::std::mem::offset_of!(BITMAPV5HEADER, bV5Reserved) - 120usize];
};
pub type LPBITMAPV5HEADER = *mut BITMAPV5HEADER;
pub type PBITMAPV5HEADER = *mut BITMAPV5HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAPINFO {
    pub bmiHeader: BITMAPINFOHEADER,
    pub bmiColors: [RGBQUAD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAPINFO"][::std::mem::size_of::<tagBITMAPINFO>() - 44usize];
    ["Alignment of tagBITMAPINFO"][::std::mem::align_of::<tagBITMAPINFO>() - 4usize];
    ["Offset of field: tagBITMAPINFO::bmiHeader"]
        [::std::mem::offset_of!(tagBITMAPINFO, bmiHeader) - 0usize];
    ["Offset of field: tagBITMAPINFO::bmiColors"]
        [::std::mem::offset_of!(tagBITMAPINFO, bmiColors) - 40usize];
};
pub type BITMAPINFO = tagBITMAPINFO;
pub type LPBITMAPINFO = *mut tagBITMAPINFO;
pub type PBITMAPINFO = *mut tagBITMAPINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAPCOREINFO {
    pub bmciHeader: BITMAPCOREHEADER,
    pub bmciColors: [RGBTRIPLE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAPCOREINFO"][::std::mem::size_of::<tagBITMAPCOREINFO>() - 16usize];
    ["Alignment of tagBITMAPCOREINFO"][::std::mem::align_of::<tagBITMAPCOREINFO>() - 4usize];
    ["Offset of field: tagBITMAPCOREINFO::bmciHeader"]
        [::std::mem::offset_of!(tagBITMAPCOREINFO, bmciHeader) - 0usize];
    ["Offset of field: tagBITMAPCOREINFO::bmciColors"]
        [::std::mem::offset_of!(tagBITMAPCOREINFO, bmciColors) - 12usize];
};
pub type BITMAPCOREINFO = tagBITMAPCOREINFO;
pub type LPBITMAPCOREINFO = *mut tagBITMAPCOREINFO;
pub type PBITMAPCOREINFO = *mut tagBITMAPCOREINFO;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct tagBITMAPFILEHEADER {
    pub bfType: WORD,
    pub bfSize: DWORD,
    pub bfReserved1: WORD,
    pub bfReserved2: WORD,
    pub bfOffBits: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBITMAPFILEHEADER"][::std::mem::size_of::<tagBITMAPFILEHEADER>() - 14usize];
    ["Alignment of tagBITMAPFILEHEADER"][::std::mem::align_of::<tagBITMAPFILEHEADER>() - 2usize];
    ["Offset of field: tagBITMAPFILEHEADER::bfType"]
        [::std::mem::offset_of!(tagBITMAPFILEHEADER, bfType) - 0usize];
    ["Offset of field: tagBITMAPFILEHEADER::bfSize"]
        [::std::mem::offset_of!(tagBITMAPFILEHEADER, bfSize) - 2usize];
    ["Offset of field: tagBITMAPFILEHEADER::bfReserved1"]
        [::std::mem::offset_of!(tagBITMAPFILEHEADER, bfReserved1) - 6usize];
    ["Offset of field: tagBITMAPFILEHEADER::bfReserved2"]
        [::std::mem::offset_of!(tagBITMAPFILEHEADER, bfReserved2) - 8usize];
    ["Offset of field: tagBITMAPFILEHEADER::bfOffBits"]
        [::std::mem::offset_of!(tagBITMAPFILEHEADER, bfOffBits) - 10usize];
};
pub type BITMAPFILEHEADER = tagBITMAPFILEHEADER;
pub type LPBITMAPFILEHEADER = *mut tagBITMAPFILEHEADER;
pub type PBITMAPFILEHEADER = *mut tagBITMAPFILEHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagFONTSIGNATURE {
    pub fsUsb: [DWORD; 4usize],
    pub fsCsb: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFONTSIGNATURE"][::std::mem::size_of::<tagFONTSIGNATURE>() - 24usize];
    ["Alignment of tagFONTSIGNATURE"][::std::mem::align_of::<tagFONTSIGNATURE>() - 4usize];
    ["Offset of field: tagFONTSIGNATURE::fsUsb"]
        [::std::mem::offset_of!(tagFONTSIGNATURE, fsUsb) - 0usize];
    ["Offset of field: tagFONTSIGNATURE::fsCsb"]
        [::std::mem::offset_of!(tagFONTSIGNATURE, fsCsb) - 16usize];
};
pub type FONTSIGNATURE = tagFONTSIGNATURE;
pub type PFONTSIGNATURE = *mut tagFONTSIGNATURE;
pub type LPFONTSIGNATURE = *mut tagFONTSIGNATURE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHARSETINFO {
    pub ciCharset: UINT,
    pub ciACP: UINT,
    pub fs: FONTSIGNATURE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHARSETINFO"][::std::mem::size_of::<tagCHARSETINFO>() - 32usize];
    ["Alignment of tagCHARSETINFO"][::std::mem::align_of::<tagCHARSETINFO>() - 4usize];
    ["Offset of field: tagCHARSETINFO::ciCharset"]
        [::std::mem::offset_of!(tagCHARSETINFO, ciCharset) - 0usize];
    ["Offset of field: tagCHARSETINFO::ciACP"]
        [::std::mem::offset_of!(tagCHARSETINFO, ciACP) - 4usize];
    ["Offset of field: tagCHARSETINFO::fs"][::std::mem::offset_of!(tagCHARSETINFO, fs) - 8usize];
};
pub type CHARSETINFO = tagCHARSETINFO;
pub type PCHARSETINFO = *mut tagCHARSETINFO;
pub type NPCHARSETINFO = *mut tagCHARSETINFO;
pub type LPCHARSETINFO = *mut tagCHARSETINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOCALESIGNATURE {
    pub lsUsb: [DWORD; 4usize],
    pub lsCsbDefault: [DWORD; 2usize],
    pub lsCsbSupported: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOCALESIGNATURE"][::std::mem::size_of::<tagLOCALESIGNATURE>() - 32usize];
    ["Alignment of tagLOCALESIGNATURE"][::std::mem::align_of::<tagLOCALESIGNATURE>() - 4usize];
    ["Offset of field: tagLOCALESIGNATURE::lsUsb"]
        [::std::mem::offset_of!(tagLOCALESIGNATURE, lsUsb) - 0usize];
    ["Offset of field: tagLOCALESIGNATURE::lsCsbDefault"]
        [::std::mem::offset_of!(tagLOCALESIGNATURE, lsCsbDefault) - 16usize];
    ["Offset of field: tagLOCALESIGNATURE::lsCsbSupported"]
        [::std::mem::offset_of!(tagLOCALESIGNATURE, lsCsbSupported) - 24usize];
};
pub type LOCALESIGNATURE = tagLOCALESIGNATURE;
pub type PLOCALESIGNATURE = *mut tagLOCALESIGNATURE;
pub type LPLOCALESIGNATURE = *mut tagLOCALESIGNATURE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHANDLETABLE {
    pub objectHandle: [HGDIOBJ; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHANDLETABLE"][::std::mem::size_of::<tagHANDLETABLE>() - 8usize];
    ["Alignment of tagHANDLETABLE"][::std::mem::align_of::<tagHANDLETABLE>() - 8usize];
    ["Offset of field: tagHANDLETABLE::objectHandle"]
        [::std::mem::offset_of!(tagHANDLETABLE, objectHandle) - 0usize];
};
pub type HANDLETABLE = tagHANDLETABLE;
pub type PHANDLETABLE = *mut tagHANDLETABLE;
pub type LPHANDLETABLE = *mut tagHANDLETABLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMETARECORD {
    pub rdSize: DWORD,
    pub rdFunction: WORD,
    pub rdParm: [WORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMETARECORD"][::std::mem::size_of::<tagMETARECORD>() - 8usize];
    ["Alignment of tagMETARECORD"][::std::mem::align_of::<tagMETARECORD>() - 4usize];
    ["Offset of field: tagMETARECORD::rdSize"]
        [::std::mem::offset_of!(tagMETARECORD, rdSize) - 0usize];
    ["Offset of field: tagMETARECORD::rdFunction"]
        [::std::mem::offset_of!(tagMETARECORD, rdFunction) - 4usize];
    ["Offset of field: tagMETARECORD::rdParm"]
        [::std::mem::offset_of!(tagMETARECORD, rdParm) - 6usize];
};
pub type METARECORD = tagMETARECORD;
pub type PMETARECORD = *mut tagMETARECORD;
pub type LPMETARECORD = *mut tagMETARECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMETAFILEPICT {
    pub mm: LONG,
    pub xExt: LONG,
    pub yExt: LONG,
    pub hMF: HMETAFILE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMETAFILEPICT"][::std::mem::size_of::<tagMETAFILEPICT>() - 24usize];
    ["Alignment of tagMETAFILEPICT"][::std::mem::align_of::<tagMETAFILEPICT>() - 8usize];
    ["Offset of field: tagMETAFILEPICT::mm"][::std::mem::offset_of!(tagMETAFILEPICT, mm) - 0usize];
    ["Offset of field: tagMETAFILEPICT::xExt"]
        [::std::mem::offset_of!(tagMETAFILEPICT, xExt) - 4usize];
    ["Offset of field: tagMETAFILEPICT::yExt"]
        [::std::mem::offset_of!(tagMETAFILEPICT, yExt) - 8usize];
    ["Offset of field: tagMETAFILEPICT::hMF"]
        [::std::mem::offset_of!(tagMETAFILEPICT, hMF) - 16usize];
};
pub type METAFILEPICT = tagMETAFILEPICT;
pub type LPMETAFILEPICT = *mut tagMETAFILEPICT;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct tagMETAHEADER {
    pub mtType: WORD,
    pub mtHeaderSize: WORD,
    pub mtVersion: WORD,
    pub mtSize: DWORD,
    pub mtNoObjects: WORD,
    pub mtMaxRecord: DWORD,
    pub mtNoParameters: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMETAHEADER"][::std::mem::size_of::<tagMETAHEADER>() - 18usize];
    ["Alignment of tagMETAHEADER"][::std::mem::align_of::<tagMETAHEADER>() - 2usize];
    ["Offset of field: tagMETAHEADER::mtType"]
        [::std::mem::offset_of!(tagMETAHEADER, mtType) - 0usize];
    ["Offset of field: tagMETAHEADER::mtHeaderSize"]
        [::std::mem::offset_of!(tagMETAHEADER, mtHeaderSize) - 2usize];
    ["Offset of field: tagMETAHEADER::mtVersion"]
        [::std::mem::offset_of!(tagMETAHEADER, mtVersion) - 4usize];
    ["Offset of field: tagMETAHEADER::mtSize"]
        [::std::mem::offset_of!(tagMETAHEADER, mtSize) - 6usize];
    ["Offset of field: tagMETAHEADER::mtNoObjects"]
        [::std::mem::offset_of!(tagMETAHEADER, mtNoObjects) - 10usize];
    ["Offset of field: tagMETAHEADER::mtMaxRecord"]
        [::std::mem::offset_of!(tagMETAHEADER, mtMaxRecord) - 12usize];
    ["Offset of field: tagMETAHEADER::mtNoParameters"]
        [::std::mem::offset_of!(tagMETAHEADER, mtNoParameters) - 16usize];
};
pub type METAHEADER = tagMETAHEADER;
pub type PMETAHEADER = *mut tagMETAHEADER;
pub type LPMETAHEADER = *mut tagMETAHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENHMETARECORD {
    pub iType: DWORD,
    pub nSize: DWORD,
    pub dParm: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENHMETARECORD"][::std::mem::size_of::<tagENHMETARECORD>() - 12usize];
    ["Alignment of tagENHMETARECORD"][::std::mem::align_of::<tagENHMETARECORD>() - 4usize];
    ["Offset of field: tagENHMETARECORD::iType"]
        [::std::mem::offset_of!(tagENHMETARECORD, iType) - 0usize];
    ["Offset of field: tagENHMETARECORD::nSize"]
        [::std::mem::offset_of!(tagENHMETARECORD, nSize) - 4usize];
    ["Offset of field: tagENHMETARECORD::dParm"]
        [::std::mem::offset_of!(tagENHMETARECORD, dParm) - 8usize];
};
pub type ENHMETARECORD = tagENHMETARECORD;
pub type PENHMETARECORD = *mut tagENHMETARECORD;
pub type LPENHMETARECORD = *mut tagENHMETARECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENHMETAHEADER {
    pub iType: DWORD,
    pub nSize: DWORD,
    pub rclBounds: RECTL,
    pub rclFrame: RECTL,
    pub dSignature: DWORD,
    pub nVersion: DWORD,
    pub nBytes: DWORD,
    pub nRecords: DWORD,
    pub nHandles: WORD,
    pub sReserved: WORD,
    pub nDescription: DWORD,
    pub offDescription: DWORD,
    pub nPalEntries: DWORD,
    pub szlDevice: SIZEL,
    pub szlMillimeters: SIZEL,
    pub cbPixelFormat: DWORD,
    pub offPixelFormat: DWORD,
    pub bOpenGL: DWORD,
    pub szlMicrometers: SIZEL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENHMETAHEADER"][::std::mem::size_of::<tagENHMETAHEADER>() - 108usize];
    ["Alignment of tagENHMETAHEADER"][::std::mem::align_of::<tagENHMETAHEADER>() - 4usize];
    ["Offset of field: tagENHMETAHEADER::iType"]
        [::std::mem::offset_of!(tagENHMETAHEADER, iType) - 0usize];
    ["Offset of field: tagENHMETAHEADER::nSize"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nSize) - 4usize];
    ["Offset of field: tagENHMETAHEADER::rclBounds"]
        [::std::mem::offset_of!(tagENHMETAHEADER, rclBounds) - 8usize];
    ["Offset of field: tagENHMETAHEADER::rclFrame"]
        [::std::mem::offset_of!(tagENHMETAHEADER, rclFrame) - 24usize];
    ["Offset of field: tagENHMETAHEADER::dSignature"]
        [::std::mem::offset_of!(tagENHMETAHEADER, dSignature) - 40usize];
    ["Offset of field: tagENHMETAHEADER::nVersion"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nVersion) - 44usize];
    ["Offset of field: tagENHMETAHEADER::nBytes"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nBytes) - 48usize];
    ["Offset of field: tagENHMETAHEADER::nRecords"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nRecords) - 52usize];
    ["Offset of field: tagENHMETAHEADER::nHandles"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nHandles) - 56usize];
    ["Offset of field: tagENHMETAHEADER::sReserved"]
        [::std::mem::offset_of!(tagENHMETAHEADER, sReserved) - 58usize];
    ["Offset of field: tagENHMETAHEADER::nDescription"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nDescription) - 60usize];
    ["Offset of field: tagENHMETAHEADER::offDescription"]
        [::std::mem::offset_of!(tagENHMETAHEADER, offDescription) - 64usize];
    ["Offset of field: tagENHMETAHEADER::nPalEntries"]
        [::std::mem::offset_of!(tagENHMETAHEADER, nPalEntries) - 68usize];
    ["Offset of field: tagENHMETAHEADER::szlDevice"]
        [::std::mem::offset_of!(tagENHMETAHEADER, szlDevice) - 72usize];
    ["Offset of field: tagENHMETAHEADER::szlMillimeters"]
        [::std::mem::offset_of!(tagENHMETAHEADER, szlMillimeters) - 80usize];
    ["Offset of field: tagENHMETAHEADER::cbPixelFormat"]
        [::std::mem::offset_of!(tagENHMETAHEADER, cbPixelFormat) - 88usize];
    ["Offset of field: tagENHMETAHEADER::offPixelFormat"]
        [::std::mem::offset_of!(tagENHMETAHEADER, offPixelFormat) - 92usize];
    ["Offset of field: tagENHMETAHEADER::bOpenGL"]
        [::std::mem::offset_of!(tagENHMETAHEADER, bOpenGL) - 96usize];
    ["Offset of field: tagENHMETAHEADER::szlMicrometers"]
        [::std::mem::offset_of!(tagENHMETAHEADER, szlMicrometers) - 100usize];
};
pub type ENHMETAHEADER = tagENHMETAHEADER;
pub type PENHMETAHEADER = *mut tagENHMETAHEADER;
pub type LPENHMETAHEADER = *mut tagENHMETAHEADER;
pub type BCHAR = BYTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTEXTMETRICA {
    pub tmHeight: LONG,
    pub tmAscent: LONG,
    pub tmDescent: LONG,
    pub tmInternalLeading: LONG,
    pub tmExternalLeading: LONG,
    pub tmAveCharWidth: LONG,
    pub tmMaxCharWidth: LONG,
    pub tmWeight: LONG,
    pub tmOverhang: LONG,
    pub tmDigitizedAspectX: LONG,
    pub tmDigitizedAspectY: LONG,
    pub tmFirstChar: BYTE,
    pub tmLastChar: BYTE,
    pub tmDefaultChar: BYTE,
    pub tmBreakChar: BYTE,
    pub tmItalic: BYTE,
    pub tmUnderlined: BYTE,
    pub tmStruckOut: BYTE,
    pub tmPitchAndFamily: BYTE,
    pub tmCharSet: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTEXTMETRICA"][::std::mem::size_of::<tagTEXTMETRICA>() - 56usize];
    ["Alignment of tagTEXTMETRICA"][::std::mem::align_of::<tagTEXTMETRICA>() - 4usize];
    ["Offset of field: tagTEXTMETRICA::tmHeight"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmHeight) - 0usize];
    ["Offset of field: tagTEXTMETRICA::tmAscent"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmAscent) - 4usize];
    ["Offset of field: tagTEXTMETRICA::tmDescent"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmDescent) - 8usize];
    ["Offset of field: tagTEXTMETRICA::tmInternalLeading"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmInternalLeading) - 12usize];
    ["Offset of field: tagTEXTMETRICA::tmExternalLeading"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmExternalLeading) - 16usize];
    ["Offset of field: tagTEXTMETRICA::tmAveCharWidth"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmAveCharWidth) - 20usize];
    ["Offset of field: tagTEXTMETRICA::tmMaxCharWidth"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmMaxCharWidth) - 24usize];
    ["Offset of field: tagTEXTMETRICA::tmWeight"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmWeight) - 28usize];
    ["Offset of field: tagTEXTMETRICA::tmOverhang"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmOverhang) - 32usize];
    ["Offset of field: tagTEXTMETRICA::tmDigitizedAspectX"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmDigitizedAspectX) - 36usize];
    ["Offset of field: tagTEXTMETRICA::tmDigitizedAspectY"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmDigitizedAspectY) - 40usize];
    ["Offset of field: tagTEXTMETRICA::tmFirstChar"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmFirstChar) - 44usize];
    ["Offset of field: tagTEXTMETRICA::tmLastChar"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmLastChar) - 45usize];
    ["Offset of field: tagTEXTMETRICA::tmDefaultChar"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmDefaultChar) - 46usize];
    ["Offset of field: tagTEXTMETRICA::tmBreakChar"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmBreakChar) - 47usize];
    ["Offset of field: tagTEXTMETRICA::tmItalic"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmItalic) - 48usize];
    ["Offset of field: tagTEXTMETRICA::tmUnderlined"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmUnderlined) - 49usize];
    ["Offset of field: tagTEXTMETRICA::tmStruckOut"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmStruckOut) - 50usize];
    ["Offset of field: tagTEXTMETRICA::tmPitchAndFamily"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmPitchAndFamily) - 51usize];
    ["Offset of field: tagTEXTMETRICA::tmCharSet"]
        [::std::mem::offset_of!(tagTEXTMETRICA, tmCharSet) - 52usize];
};
pub type TEXTMETRICA = tagTEXTMETRICA;
pub type PTEXTMETRICA = *mut tagTEXTMETRICA;
pub type NPTEXTMETRICA = *mut tagTEXTMETRICA;
pub type LPTEXTMETRICA = *mut tagTEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTEXTMETRICW {
    pub tmHeight: LONG,
    pub tmAscent: LONG,
    pub tmDescent: LONG,
    pub tmInternalLeading: LONG,
    pub tmExternalLeading: LONG,
    pub tmAveCharWidth: LONG,
    pub tmMaxCharWidth: LONG,
    pub tmWeight: LONG,
    pub tmOverhang: LONG,
    pub tmDigitizedAspectX: LONG,
    pub tmDigitizedAspectY: LONG,
    pub tmFirstChar: WCHAR,
    pub tmLastChar: WCHAR,
    pub tmDefaultChar: WCHAR,
    pub tmBreakChar: WCHAR,
    pub tmItalic: BYTE,
    pub tmUnderlined: BYTE,
    pub tmStruckOut: BYTE,
    pub tmPitchAndFamily: BYTE,
    pub tmCharSet: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTEXTMETRICW"][::std::mem::size_of::<tagTEXTMETRICW>() - 60usize];
    ["Alignment of tagTEXTMETRICW"][::std::mem::align_of::<tagTEXTMETRICW>() - 4usize];
    ["Offset of field: tagTEXTMETRICW::tmHeight"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmHeight) - 0usize];
    ["Offset of field: tagTEXTMETRICW::tmAscent"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmAscent) - 4usize];
    ["Offset of field: tagTEXTMETRICW::tmDescent"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmDescent) - 8usize];
    ["Offset of field: tagTEXTMETRICW::tmInternalLeading"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmInternalLeading) - 12usize];
    ["Offset of field: tagTEXTMETRICW::tmExternalLeading"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmExternalLeading) - 16usize];
    ["Offset of field: tagTEXTMETRICW::tmAveCharWidth"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmAveCharWidth) - 20usize];
    ["Offset of field: tagTEXTMETRICW::tmMaxCharWidth"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmMaxCharWidth) - 24usize];
    ["Offset of field: tagTEXTMETRICW::tmWeight"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmWeight) - 28usize];
    ["Offset of field: tagTEXTMETRICW::tmOverhang"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmOverhang) - 32usize];
    ["Offset of field: tagTEXTMETRICW::tmDigitizedAspectX"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmDigitizedAspectX) - 36usize];
    ["Offset of field: tagTEXTMETRICW::tmDigitizedAspectY"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmDigitizedAspectY) - 40usize];
    ["Offset of field: tagTEXTMETRICW::tmFirstChar"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmFirstChar) - 44usize];
    ["Offset of field: tagTEXTMETRICW::tmLastChar"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmLastChar) - 46usize];
    ["Offset of field: tagTEXTMETRICW::tmDefaultChar"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmDefaultChar) - 48usize];
    ["Offset of field: tagTEXTMETRICW::tmBreakChar"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmBreakChar) - 50usize];
    ["Offset of field: tagTEXTMETRICW::tmItalic"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmItalic) - 52usize];
    ["Offset of field: tagTEXTMETRICW::tmUnderlined"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmUnderlined) - 53usize];
    ["Offset of field: tagTEXTMETRICW::tmStruckOut"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmStruckOut) - 54usize];
    ["Offset of field: tagTEXTMETRICW::tmPitchAndFamily"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmPitchAndFamily) - 55usize];
    ["Offset of field: tagTEXTMETRICW::tmCharSet"]
        [::std::mem::offset_of!(tagTEXTMETRICW, tmCharSet) - 56usize];
};
pub type TEXTMETRICW = tagTEXTMETRICW;
pub type PTEXTMETRICW = *mut tagTEXTMETRICW;
pub type NPTEXTMETRICW = *mut tagTEXTMETRICW;
pub type LPTEXTMETRICW = *mut tagTEXTMETRICW;
pub type TEXTMETRIC = TEXTMETRICA;
pub type PTEXTMETRIC = PTEXTMETRICA;
pub type NPTEXTMETRIC = NPTEXTMETRICA;
pub type LPTEXTMETRIC = LPTEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNEWTEXTMETRICA {
    pub tmHeight: LONG,
    pub tmAscent: LONG,
    pub tmDescent: LONG,
    pub tmInternalLeading: LONG,
    pub tmExternalLeading: LONG,
    pub tmAveCharWidth: LONG,
    pub tmMaxCharWidth: LONG,
    pub tmWeight: LONG,
    pub tmOverhang: LONG,
    pub tmDigitizedAspectX: LONG,
    pub tmDigitizedAspectY: LONG,
    pub tmFirstChar: BYTE,
    pub tmLastChar: BYTE,
    pub tmDefaultChar: BYTE,
    pub tmBreakChar: BYTE,
    pub tmItalic: BYTE,
    pub tmUnderlined: BYTE,
    pub tmStruckOut: BYTE,
    pub tmPitchAndFamily: BYTE,
    pub tmCharSet: BYTE,
    pub ntmFlags: DWORD,
    pub ntmSizeEM: UINT,
    pub ntmCellHeight: UINT,
    pub ntmAvgWidth: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNEWTEXTMETRICA"][::std::mem::size_of::<tagNEWTEXTMETRICA>() - 72usize];
    ["Alignment of tagNEWTEXTMETRICA"][::std::mem::align_of::<tagNEWTEXTMETRICA>() - 4usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmHeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmHeight) - 0usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmAscent"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmAscent) - 4usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmDescent"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmDescent) - 8usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmInternalLeading"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmInternalLeading) - 12usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmExternalLeading"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmExternalLeading) - 16usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmAveCharWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmAveCharWidth) - 20usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmMaxCharWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmMaxCharWidth) - 24usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmWeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmWeight) - 28usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmOverhang"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmOverhang) - 32usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmDigitizedAspectX"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmDigitizedAspectX) - 36usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmDigitizedAspectY"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmDigitizedAspectY) - 40usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmFirstChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmFirstChar) - 44usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmLastChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmLastChar) - 45usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmDefaultChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmDefaultChar) - 46usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmBreakChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmBreakChar) - 47usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmItalic"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmItalic) - 48usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmUnderlined"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmUnderlined) - 49usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmStruckOut"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmStruckOut) - 50usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmPitchAndFamily"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmPitchAndFamily) - 51usize];
    ["Offset of field: tagNEWTEXTMETRICA::tmCharSet"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, tmCharSet) - 52usize];
    ["Offset of field: tagNEWTEXTMETRICA::ntmFlags"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, ntmFlags) - 56usize];
    ["Offset of field: tagNEWTEXTMETRICA::ntmSizeEM"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, ntmSizeEM) - 60usize];
    ["Offset of field: tagNEWTEXTMETRICA::ntmCellHeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, ntmCellHeight) - 64usize];
    ["Offset of field: tagNEWTEXTMETRICA::ntmAvgWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICA, ntmAvgWidth) - 68usize];
};
pub type NEWTEXTMETRICA = tagNEWTEXTMETRICA;
pub type PNEWTEXTMETRICA = *mut tagNEWTEXTMETRICA;
pub type NPNEWTEXTMETRICA = *mut tagNEWTEXTMETRICA;
pub type LPNEWTEXTMETRICA = *mut tagNEWTEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNEWTEXTMETRICW {
    pub tmHeight: LONG,
    pub tmAscent: LONG,
    pub tmDescent: LONG,
    pub tmInternalLeading: LONG,
    pub tmExternalLeading: LONG,
    pub tmAveCharWidth: LONG,
    pub tmMaxCharWidth: LONG,
    pub tmWeight: LONG,
    pub tmOverhang: LONG,
    pub tmDigitizedAspectX: LONG,
    pub tmDigitizedAspectY: LONG,
    pub tmFirstChar: WCHAR,
    pub tmLastChar: WCHAR,
    pub tmDefaultChar: WCHAR,
    pub tmBreakChar: WCHAR,
    pub tmItalic: BYTE,
    pub tmUnderlined: BYTE,
    pub tmStruckOut: BYTE,
    pub tmPitchAndFamily: BYTE,
    pub tmCharSet: BYTE,
    pub ntmFlags: DWORD,
    pub ntmSizeEM: UINT,
    pub ntmCellHeight: UINT,
    pub ntmAvgWidth: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNEWTEXTMETRICW"][::std::mem::size_of::<tagNEWTEXTMETRICW>() - 76usize];
    ["Alignment of tagNEWTEXTMETRICW"][::std::mem::align_of::<tagNEWTEXTMETRICW>() - 4usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmHeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmHeight) - 0usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmAscent"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmAscent) - 4usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmDescent"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmDescent) - 8usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmInternalLeading"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmInternalLeading) - 12usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmExternalLeading"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmExternalLeading) - 16usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmAveCharWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmAveCharWidth) - 20usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmMaxCharWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmMaxCharWidth) - 24usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmWeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmWeight) - 28usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmOverhang"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmOverhang) - 32usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmDigitizedAspectX"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmDigitizedAspectX) - 36usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmDigitizedAspectY"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmDigitizedAspectY) - 40usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmFirstChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmFirstChar) - 44usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmLastChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmLastChar) - 46usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmDefaultChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmDefaultChar) - 48usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmBreakChar"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmBreakChar) - 50usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmItalic"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmItalic) - 52usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmUnderlined"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmUnderlined) - 53usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmStruckOut"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmStruckOut) - 54usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmPitchAndFamily"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmPitchAndFamily) - 55usize];
    ["Offset of field: tagNEWTEXTMETRICW::tmCharSet"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, tmCharSet) - 56usize];
    ["Offset of field: tagNEWTEXTMETRICW::ntmFlags"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, ntmFlags) - 60usize];
    ["Offset of field: tagNEWTEXTMETRICW::ntmSizeEM"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, ntmSizeEM) - 64usize];
    ["Offset of field: tagNEWTEXTMETRICW::ntmCellHeight"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, ntmCellHeight) - 68usize];
    ["Offset of field: tagNEWTEXTMETRICW::ntmAvgWidth"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICW, ntmAvgWidth) - 72usize];
};
pub type NEWTEXTMETRICW = tagNEWTEXTMETRICW;
pub type PNEWTEXTMETRICW = *mut tagNEWTEXTMETRICW;
pub type NPNEWTEXTMETRICW = *mut tagNEWTEXTMETRICW;
pub type LPNEWTEXTMETRICW = *mut tagNEWTEXTMETRICW;
pub type NEWTEXTMETRIC = NEWTEXTMETRICA;
pub type PNEWTEXTMETRIC = PNEWTEXTMETRICA;
pub type NPNEWTEXTMETRIC = NPNEWTEXTMETRICA;
pub type LPNEWTEXTMETRIC = LPNEWTEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNEWTEXTMETRICEXA {
    pub ntmTm: NEWTEXTMETRICA,
    pub ntmFontSig: FONTSIGNATURE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNEWTEXTMETRICEXA"][::std::mem::size_of::<tagNEWTEXTMETRICEXA>() - 96usize];
    ["Alignment of tagNEWTEXTMETRICEXA"][::std::mem::align_of::<tagNEWTEXTMETRICEXA>() - 4usize];
    ["Offset of field: tagNEWTEXTMETRICEXA::ntmTm"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICEXA, ntmTm) - 0usize];
    ["Offset of field: tagNEWTEXTMETRICEXA::ntmFontSig"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICEXA, ntmFontSig) - 72usize];
};
pub type NEWTEXTMETRICEXA = tagNEWTEXTMETRICEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNEWTEXTMETRICEXW {
    pub ntmTm: NEWTEXTMETRICW,
    pub ntmFontSig: FONTSIGNATURE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNEWTEXTMETRICEXW"][::std::mem::size_of::<tagNEWTEXTMETRICEXW>() - 100usize];
    ["Alignment of tagNEWTEXTMETRICEXW"][::std::mem::align_of::<tagNEWTEXTMETRICEXW>() - 4usize];
    ["Offset of field: tagNEWTEXTMETRICEXW::ntmTm"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICEXW, ntmTm) - 0usize];
    ["Offset of field: tagNEWTEXTMETRICEXW::ntmFontSig"]
        [::std::mem::offset_of!(tagNEWTEXTMETRICEXW, ntmFontSig) - 76usize];
};
pub type NEWTEXTMETRICEXW = tagNEWTEXTMETRICEXW;
pub type NEWTEXTMETRICEX = NEWTEXTMETRICEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPELARRAY {
    pub paXCount: LONG,
    pub paYCount: LONG,
    pub paXExt: LONG,
    pub paYExt: LONG,
    pub paRGBs: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPELARRAY"][::std::mem::size_of::<tagPELARRAY>() - 20usize];
    ["Alignment of tagPELARRAY"][::std::mem::align_of::<tagPELARRAY>() - 4usize];
    ["Offset of field: tagPELARRAY::paXCount"]
        [::std::mem::offset_of!(tagPELARRAY, paXCount) - 0usize];
    ["Offset of field: tagPELARRAY::paYCount"]
        [::std::mem::offset_of!(tagPELARRAY, paYCount) - 4usize];
    ["Offset of field: tagPELARRAY::paXExt"][::std::mem::offset_of!(tagPELARRAY, paXExt) - 8usize];
    ["Offset of field: tagPELARRAY::paYExt"][::std::mem::offset_of!(tagPELARRAY, paYExt) - 12usize];
    ["Offset of field: tagPELARRAY::paRGBs"][::std::mem::offset_of!(tagPELARRAY, paRGBs) - 16usize];
};
pub type PELARRAY = tagPELARRAY;
pub type PPELARRAY = *mut tagPELARRAY;
pub type NPPELARRAY = *mut tagPELARRAY;
pub type LPPELARRAY = *mut tagPELARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGBRUSH {
    pub lbStyle: UINT,
    pub lbColor: COLORREF,
    pub lbHatch: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGBRUSH"][::std::mem::size_of::<tagLOGBRUSH>() - 16usize];
    ["Alignment of tagLOGBRUSH"][::std::mem::align_of::<tagLOGBRUSH>() - 8usize];
    ["Offset of field: tagLOGBRUSH::lbStyle"]
        [::std::mem::offset_of!(tagLOGBRUSH, lbStyle) - 0usize];
    ["Offset of field: tagLOGBRUSH::lbColor"]
        [::std::mem::offset_of!(tagLOGBRUSH, lbColor) - 4usize];
    ["Offset of field: tagLOGBRUSH::lbHatch"]
        [::std::mem::offset_of!(tagLOGBRUSH, lbHatch) - 8usize];
};
pub type LOGBRUSH = tagLOGBRUSH;
pub type PLOGBRUSH = *mut tagLOGBRUSH;
pub type NPLOGBRUSH = *mut tagLOGBRUSH;
pub type LPLOGBRUSH = *mut tagLOGBRUSH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGBRUSH32 {
    pub lbStyle: UINT,
    pub lbColor: COLORREF,
    pub lbHatch: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGBRUSH32"][::std::mem::size_of::<tagLOGBRUSH32>() - 12usize];
    ["Alignment of tagLOGBRUSH32"][::std::mem::align_of::<tagLOGBRUSH32>() - 4usize];
    ["Offset of field: tagLOGBRUSH32::lbStyle"]
        [::std::mem::offset_of!(tagLOGBRUSH32, lbStyle) - 0usize];
    ["Offset of field: tagLOGBRUSH32::lbColor"]
        [::std::mem::offset_of!(tagLOGBRUSH32, lbColor) - 4usize];
    ["Offset of field: tagLOGBRUSH32::lbHatch"]
        [::std::mem::offset_of!(tagLOGBRUSH32, lbHatch) - 8usize];
};
pub type LOGBRUSH32 = tagLOGBRUSH32;
pub type PLOGBRUSH32 = *mut tagLOGBRUSH32;
pub type NPLOGBRUSH32 = *mut tagLOGBRUSH32;
pub type LPLOGBRUSH32 = *mut tagLOGBRUSH32;
pub type PATTERN = LOGBRUSH;
pub type PPATTERN = *mut PATTERN;
pub type NPPATTERN = *mut PATTERN;
pub type LPPATTERN = *mut PATTERN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGPEN {
    pub lopnStyle: UINT,
    pub lopnWidth: POINT,
    pub lopnColor: COLORREF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGPEN"][::std::mem::size_of::<tagLOGPEN>() - 16usize];
    ["Alignment of tagLOGPEN"][::std::mem::align_of::<tagLOGPEN>() - 4usize];
    ["Offset of field: tagLOGPEN::lopnStyle"]
        [::std::mem::offset_of!(tagLOGPEN, lopnStyle) - 0usize];
    ["Offset of field: tagLOGPEN::lopnWidth"]
        [::std::mem::offset_of!(tagLOGPEN, lopnWidth) - 4usize];
    ["Offset of field: tagLOGPEN::lopnColor"]
        [::std::mem::offset_of!(tagLOGPEN, lopnColor) - 12usize];
};
pub type LOGPEN = tagLOGPEN;
pub type PLOGPEN = *mut tagLOGPEN;
pub type NPLOGPEN = *mut tagLOGPEN;
pub type LPLOGPEN = *mut tagLOGPEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEXTLOGPEN {
    pub elpPenStyle: DWORD,
    pub elpWidth: DWORD,
    pub elpBrushStyle: UINT,
    pub elpColor: COLORREF,
    pub elpHatch: ULONG_PTR,
    pub elpNumEntries: DWORD,
    pub elpStyleEntry: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEXTLOGPEN"][::std::mem::size_of::<tagEXTLOGPEN>() - 32usize];
    ["Alignment of tagEXTLOGPEN"][::std::mem::align_of::<tagEXTLOGPEN>() - 8usize];
    ["Offset of field: tagEXTLOGPEN::elpPenStyle"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpPenStyle) - 0usize];
    ["Offset of field: tagEXTLOGPEN::elpWidth"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpWidth) - 4usize];
    ["Offset of field: tagEXTLOGPEN::elpBrushStyle"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpBrushStyle) - 8usize];
    ["Offset of field: tagEXTLOGPEN::elpColor"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpColor) - 12usize];
    ["Offset of field: tagEXTLOGPEN::elpHatch"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpHatch) - 16usize];
    ["Offset of field: tagEXTLOGPEN::elpNumEntries"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpNumEntries) - 24usize];
    ["Offset of field: tagEXTLOGPEN::elpStyleEntry"]
        [::std::mem::offset_of!(tagEXTLOGPEN, elpStyleEntry) - 28usize];
};
pub type EXTLOGPEN = tagEXTLOGPEN;
pub type PEXTLOGPEN = *mut tagEXTLOGPEN;
pub type NPEXTLOGPEN = *mut tagEXTLOGPEN;
pub type LPEXTLOGPEN = *mut tagEXTLOGPEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEXTLOGPEN32 {
    pub elpPenStyle: DWORD,
    pub elpWidth: DWORD,
    pub elpBrushStyle: UINT,
    pub elpColor: COLORREF,
    pub elpHatch: ULONG,
    pub elpNumEntries: DWORD,
    pub elpStyleEntry: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEXTLOGPEN32"][::std::mem::size_of::<tagEXTLOGPEN32>() - 28usize];
    ["Alignment of tagEXTLOGPEN32"][::std::mem::align_of::<tagEXTLOGPEN32>() - 4usize];
    ["Offset of field: tagEXTLOGPEN32::elpPenStyle"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpPenStyle) - 0usize];
    ["Offset of field: tagEXTLOGPEN32::elpWidth"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpWidth) - 4usize];
    ["Offset of field: tagEXTLOGPEN32::elpBrushStyle"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpBrushStyle) - 8usize];
    ["Offset of field: tagEXTLOGPEN32::elpColor"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpColor) - 12usize];
    ["Offset of field: tagEXTLOGPEN32::elpHatch"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpHatch) - 16usize];
    ["Offset of field: tagEXTLOGPEN32::elpNumEntries"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpNumEntries) - 20usize];
    ["Offset of field: tagEXTLOGPEN32::elpStyleEntry"]
        [::std::mem::offset_of!(tagEXTLOGPEN32, elpStyleEntry) - 24usize];
};
pub type EXTLOGPEN32 = tagEXTLOGPEN32;
pub type PEXTLOGPEN32 = *mut tagEXTLOGPEN32;
pub type NPEXTLOGPEN32 = *mut tagEXTLOGPEN32;
pub type LPEXTLOGPEN32 = *mut tagEXTLOGPEN32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPALETTEENTRY {
    pub peRed: BYTE,
    pub peGreen: BYTE,
    pub peBlue: BYTE,
    pub peFlags: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPALETTEENTRY"][::std::mem::size_of::<tagPALETTEENTRY>() - 4usize];
    ["Alignment of tagPALETTEENTRY"][::std::mem::align_of::<tagPALETTEENTRY>() - 1usize];
    ["Offset of field: tagPALETTEENTRY::peRed"]
        [::std::mem::offset_of!(tagPALETTEENTRY, peRed) - 0usize];
    ["Offset of field: tagPALETTEENTRY::peGreen"]
        [::std::mem::offset_of!(tagPALETTEENTRY, peGreen) - 1usize];
    ["Offset of field: tagPALETTEENTRY::peBlue"]
        [::std::mem::offset_of!(tagPALETTEENTRY, peBlue) - 2usize];
    ["Offset of field: tagPALETTEENTRY::peFlags"]
        [::std::mem::offset_of!(tagPALETTEENTRY, peFlags) - 3usize];
};
pub type PALETTEENTRY = tagPALETTEENTRY;
pub type PPALETTEENTRY = *mut tagPALETTEENTRY;
pub type LPPALETTEENTRY = *mut tagPALETTEENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGPALETTE {
    pub palVersion: WORD,
    pub palNumEntries: WORD,
    pub palPalEntry: [PALETTEENTRY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGPALETTE"][::std::mem::size_of::<tagLOGPALETTE>() - 8usize];
    ["Alignment of tagLOGPALETTE"][::std::mem::align_of::<tagLOGPALETTE>() - 2usize];
    ["Offset of field: tagLOGPALETTE::palVersion"]
        [::std::mem::offset_of!(tagLOGPALETTE, palVersion) - 0usize];
    ["Offset of field: tagLOGPALETTE::palNumEntries"]
        [::std::mem::offset_of!(tagLOGPALETTE, palNumEntries) - 2usize];
    ["Offset of field: tagLOGPALETTE::palPalEntry"]
        [::std::mem::offset_of!(tagLOGPALETTE, palPalEntry) - 4usize];
};
pub type LOGPALETTE = tagLOGPALETTE;
pub type PLOGPALETTE = *mut tagLOGPALETTE;
pub type NPLOGPALETTE = *mut tagLOGPALETTE;
pub type LPLOGPALETTE = *mut tagLOGPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGFONTA {
    pub lfHeight: LONG,
    pub lfWidth: LONG,
    pub lfEscapement: LONG,
    pub lfOrientation: LONG,
    pub lfWeight: LONG,
    pub lfItalic: BYTE,
    pub lfUnderline: BYTE,
    pub lfStrikeOut: BYTE,
    pub lfCharSet: BYTE,
    pub lfOutPrecision: BYTE,
    pub lfClipPrecision: BYTE,
    pub lfQuality: BYTE,
    pub lfPitchAndFamily: BYTE,
    pub lfFaceName: [CHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGFONTA"][::std::mem::size_of::<tagLOGFONTA>() - 60usize];
    ["Alignment of tagLOGFONTA"][::std::mem::align_of::<tagLOGFONTA>() - 4usize];
    ["Offset of field: tagLOGFONTA::lfHeight"]
        [::std::mem::offset_of!(tagLOGFONTA, lfHeight) - 0usize];
    ["Offset of field: tagLOGFONTA::lfWidth"]
        [::std::mem::offset_of!(tagLOGFONTA, lfWidth) - 4usize];
    ["Offset of field: tagLOGFONTA::lfEscapement"]
        [::std::mem::offset_of!(tagLOGFONTA, lfEscapement) - 8usize];
    ["Offset of field: tagLOGFONTA::lfOrientation"]
        [::std::mem::offset_of!(tagLOGFONTA, lfOrientation) - 12usize];
    ["Offset of field: tagLOGFONTA::lfWeight"]
        [::std::mem::offset_of!(tagLOGFONTA, lfWeight) - 16usize];
    ["Offset of field: tagLOGFONTA::lfItalic"]
        [::std::mem::offset_of!(tagLOGFONTA, lfItalic) - 20usize];
    ["Offset of field: tagLOGFONTA::lfUnderline"]
        [::std::mem::offset_of!(tagLOGFONTA, lfUnderline) - 21usize];
    ["Offset of field: tagLOGFONTA::lfStrikeOut"]
        [::std::mem::offset_of!(tagLOGFONTA, lfStrikeOut) - 22usize];
    ["Offset of field: tagLOGFONTA::lfCharSet"]
        [::std::mem::offset_of!(tagLOGFONTA, lfCharSet) - 23usize];
    ["Offset of field: tagLOGFONTA::lfOutPrecision"]
        [::std::mem::offset_of!(tagLOGFONTA, lfOutPrecision) - 24usize];
    ["Offset of field: tagLOGFONTA::lfClipPrecision"]
        [::std::mem::offset_of!(tagLOGFONTA, lfClipPrecision) - 25usize];
    ["Offset of field: tagLOGFONTA::lfQuality"]
        [::std::mem::offset_of!(tagLOGFONTA, lfQuality) - 26usize];
    ["Offset of field: tagLOGFONTA::lfPitchAndFamily"]
        [::std::mem::offset_of!(tagLOGFONTA, lfPitchAndFamily) - 27usize];
    ["Offset of field: tagLOGFONTA::lfFaceName"]
        [::std::mem::offset_of!(tagLOGFONTA, lfFaceName) - 28usize];
};
pub type LOGFONTA = tagLOGFONTA;
pub type PLOGFONTA = *mut tagLOGFONTA;
pub type NPLOGFONTA = *mut tagLOGFONTA;
pub type LPLOGFONTA = *mut tagLOGFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLOGFONTW {
    pub lfHeight: LONG,
    pub lfWidth: LONG,
    pub lfEscapement: LONG,
    pub lfOrientation: LONG,
    pub lfWeight: LONG,
    pub lfItalic: BYTE,
    pub lfUnderline: BYTE,
    pub lfStrikeOut: BYTE,
    pub lfCharSet: BYTE,
    pub lfOutPrecision: BYTE,
    pub lfClipPrecision: BYTE,
    pub lfQuality: BYTE,
    pub lfPitchAndFamily: BYTE,
    pub lfFaceName: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLOGFONTW"][::std::mem::size_of::<tagLOGFONTW>() - 92usize];
    ["Alignment of tagLOGFONTW"][::std::mem::align_of::<tagLOGFONTW>() - 4usize];
    ["Offset of field: tagLOGFONTW::lfHeight"]
        [::std::mem::offset_of!(tagLOGFONTW, lfHeight) - 0usize];
    ["Offset of field: tagLOGFONTW::lfWidth"]
        [::std::mem::offset_of!(tagLOGFONTW, lfWidth) - 4usize];
    ["Offset of field: tagLOGFONTW::lfEscapement"]
        [::std::mem::offset_of!(tagLOGFONTW, lfEscapement) - 8usize];
    ["Offset of field: tagLOGFONTW::lfOrientation"]
        [::std::mem::offset_of!(tagLOGFONTW, lfOrientation) - 12usize];
    ["Offset of field: tagLOGFONTW::lfWeight"]
        [::std::mem::offset_of!(tagLOGFONTW, lfWeight) - 16usize];
    ["Offset of field: tagLOGFONTW::lfItalic"]
        [::std::mem::offset_of!(tagLOGFONTW, lfItalic) - 20usize];
    ["Offset of field: tagLOGFONTW::lfUnderline"]
        [::std::mem::offset_of!(tagLOGFONTW, lfUnderline) - 21usize];
    ["Offset of field: tagLOGFONTW::lfStrikeOut"]
        [::std::mem::offset_of!(tagLOGFONTW, lfStrikeOut) - 22usize];
    ["Offset of field: tagLOGFONTW::lfCharSet"]
        [::std::mem::offset_of!(tagLOGFONTW, lfCharSet) - 23usize];
    ["Offset of field: tagLOGFONTW::lfOutPrecision"]
        [::std::mem::offset_of!(tagLOGFONTW, lfOutPrecision) - 24usize];
    ["Offset of field: tagLOGFONTW::lfClipPrecision"]
        [::std::mem::offset_of!(tagLOGFONTW, lfClipPrecision) - 25usize];
    ["Offset of field: tagLOGFONTW::lfQuality"]
        [::std::mem::offset_of!(tagLOGFONTW, lfQuality) - 26usize];
    ["Offset of field: tagLOGFONTW::lfPitchAndFamily"]
        [::std::mem::offset_of!(tagLOGFONTW, lfPitchAndFamily) - 27usize];
    ["Offset of field: tagLOGFONTW::lfFaceName"]
        [::std::mem::offset_of!(tagLOGFONTW, lfFaceName) - 28usize];
};
pub type LOGFONTW = tagLOGFONTW;
pub type PLOGFONTW = *mut tagLOGFONTW;
pub type NPLOGFONTW = *mut tagLOGFONTW;
pub type LPLOGFONTW = *mut tagLOGFONTW;
pub type LOGFONT = LOGFONTA;
pub type PLOGFONT = PLOGFONTA;
pub type NPLOGFONT = NPLOGFONTA;
pub type LPLOGFONT = LPLOGFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTA {
    pub elfLogFont: LOGFONTA,
    pub elfFullName: [BYTE; 64usize],
    pub elfStyle: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTA"][::std::mem::size_of::<tagENUMLOGFONTA>() - 156usize];
    ["Alignment of tagENUMLOGFONTA"][::std::mem::align_of::<tagENUMLOGFONTA>() - 4usize];
    ["Offset of field: tagENUMLOGFONTA::elfLogFont"]
        [::std::mem::offset_of!(tagENUMLOGFONTA, elfLogFont) - 0usize];
    ["Offset of field: tagENUMLOGFONTA::elfFullName"]
        [::std::mem::offset_of!(tagENUMLOGFONTA, elfFullName) - 60usize];
    ["Offset of field: tagENUMLOGFONTA::elfStyle"]
        [::std::mem::offset_of!(tagENUMLOGFONTA, elfStyle) - 124usize];
};
pub type ENUMLOGFONTA = tagENUMLOGFONTA;
pub type LPENUMLOGFONTA = *mut tagENUMLOGFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTW {
    pub elfLogFont: LOGFONTW,
    pub elfFullName: [WCHAR; 64usize],
    pub elfStyle: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTW"][::std::mem::size_of::<tagENUMLOGFONTW>() - 284usize];
    ["Alignment of tagENUMLOGFONTW"][::std::mem::align_of::<tagENUMLOGFONTW>() - 4usize];
    ["Offset of field: tagENUMLOGFONTW::elfLogFont"]
        [::std::mem::offset_of!(tagENUMLOGFONTW, elfLogFont) - 0usize];
    ["Offset of field: tagENUMLOGFONTW::elfFullName"]
        [::std::mem::offset_of!(tagENUMLOGFONTW, elfFullName) - 92usize];
    ["Offset of field: tagENUMLOGFONTW::elfStyle"]
        [::std::mem::offset_of!(tagENUMLOGFONTW, elfStyle) - 220usize];
};
pub type ENUMLOGFONTW = tagENUMLOGFONTW;
pub type LPENUMLOGFONTW = *mut tagENUMLOGFONTW;
pub type ENUMLOGFONT = ENUMLOGFONTA;
pub type LPENUMLOGFONT = LPENUMLOGFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTEXA {
    pub elfLogFont: LOGFONTA,
    pub elfFullName: [BYTE; 64usize],
    pub elfStyle: [BYTE; 32usize],
    pub elfScript: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTEXA"][::std::mem::size_of::<tagENUMLOGFONTEXA>() - 188usize];
    ["Alignment of tagENUMLOGFONTEXA"][::std::mem::align_of::<tagENUMLOGFONTEXA>() - 4usize];
    ["Offset of field: tagENUMLOGFONTEXA::elfLogFont"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXA, elfLogFont) - 0usize];
    ["Offset of field: tagENUMLOGFONTEXA::elfFullName"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXA, elfFullName) - 60usize];
    ["Offset of field: tagENUMLOGFONTEXA::elfStyle"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXA, elfStyle) - 124usize];
    ["Offset of field: tagENUMLOGFONTEXA::elfScript"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXA, elfScript) - 156usize];
};
pub type ENUMLOGFONTEXA = tagENUMLOGFONTEXA;
pub type LPENUMLOGFONTEXA = *mut tagENUMLOGFONTEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTEXW {
    pub elfLogFont: LOGFONTW,
    pub elfFullName: [WCHAR; 64usize],
    pub elfStyle: [WCHAR; 32usize],
    pub elfScript: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTEXW"][::std::mem::size_of::<tagENUMLOGFONTEXW>() - 348usize];
    ["Alignment of tagENUMLOGFONTEXW"][::std::mem::align_of::<tagENUMLOGFONTEXW>() - 4usize];
    ["Offset of field: tagENUMLOGFONTEXW::elfLogFont"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXW, elfLogFont) - 0usize];
    ["Offset of field: tagENUMLOGFONTEXW::elfFullName"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXW, elfFullName) - 92usize];
    ["Offset of field: tagENUMLOGFONTEXW::elfStyle"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXW, elfStyle) - 220usize];
    ["Offset of field: tagENUMLOGFONTEXW::elfScript"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXW, elfScript) - 284usize];
};
pub type ENUMLOGFONTEXW = tagENUMLOGFONTEXW;
pub type LPENUMLOGFONTEXW = *mut tagENUMLOGFONTEXW;
pub type ENUMLOGFONTEX = ENUMLOGFONTEXA;
pub type LPENUMLOGFONTEX = LPENUMLOGFONTEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPANOSE {
    pub bFamilyType: BYTE,
    pub bSerifStyle: BYTE,
    pub bWeight: BYTE,
    pub bProportion: BYTE,
    pub bContrast: BYTE,
    pub bStrokeVariation: BYTE,
    pub bArmStyle: BYTE,
    pub bLetterform: BYTE,
    pub bMidline: BYTE,
    pub bXHeight: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPANOSE"][::std::mem::size_of::<tagPANOSE>() - 10usize];
    ["Alignment of tagPANOSE"][::std::mem::align_of::<tagPANOSE>() - 1usize];
    ["Offset of field: tagPANOSE::bFamilyType"]
        [::std::mem::offset_of!(tagPANOSE, bFamilyType) - 0usize];
    ["Offset of field: tagPANOSE::bSerifStyle"]
        [::std::mem::offset_of!(tagPANOSE, bSerifStyle) - 1usize];
    ["Offset of field: tagPANOSE::bWeight"][::std::mem::offset_of!(tagPANOSE, bWeight) - 2usize];
    ["Offset of field: tagPANOSE::bProportion"]
        [::std::mem::offset_of!(tagPANOSE, bProportion) - 3usize];
    ["Offset of field: tagPANOSE::bContrast"]
        [::std::mem::offset_of!(tagPANOSE, bContrast) - 4usize];
    ["Offset of field: tagPANOSE::bStrokeVariation"]
        [::std::mem::offset_of!(tagPANOSE, bStrokeVariation) - 5usize];
    ["Offset of field: tagPANOSE::bArmStyle"]
        [::std::mem::offset_of!(tagPANOSE, bArmStyle) - 6usize];
    ["Offset of field: tagPANOSE::bLetterform"]
        [::std::mem::offset_of!(tagPANOSE, bLetterform) - 7usize];
    ["Offset of field: tagPANOSE::bMidline"][::std::mem::offset_of!(tagPANOSE, bMidline) - 8usize];
    ["Offset of field: tagPANOSE::bXHeight"][::std::mem::offset_of!(tagPANOSE, bXHeight) - 9usize];
};
pub type PANOSE = tagPANOSE;
pub type LPPANOSE = *mut tagPANOSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEXTLOGFONTA {
    pub elfLogFont: LOGFONTA,
    pub elfFullName: [BYTE; 64usize],
    pub elfStyle: [BYTE; 32usize],
    pub elfVersion: DWORD,
    pub elfStyleSize: DWORD,
    pub elfMatch: DWORD,
    pub elfReserved: DWORD,
    pub elfVendorId: [BYTE; 4usize],
    pub elfCulture: DWORD,
    pub elfPanose: PANOSE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEXTLOGFONTA"][::std::mem::size_of::<tagEXTLOGFONTA>() - 192usize];
    ["Alignment of tagEXTLOGFONTA"][::std::mem::align_of::<tagEXTLOGFONTA>() - 4usize];
    ["Offset of field: tagEXTLOGFONTA::elfLogFont"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfLogFont) - 0usize];
    ["Offset of field: tagEXTLOGFONTA::elfFullName"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfFullName) - 60usize];
    ["Offset of field: tagEXTLOGFONTA::elfStyle"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfStyle) - 124usize];
    ["Offset of field: tagEXTLOGFONTA::elfVersion"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfVersion) - 156usize];
    ["Offset of field: tagEXTLOGFONTA::elfStyleSize"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfStyleSize) - 160usize];
    ["Offset of field: tagEXTLOGFONTA::elfMatch"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfMatch) - 164usize];
    ["Offset of field: tagEXTLOGFONTA::elfReserved"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfReserved) - 168usize];
    ["Offset of field: tagEXTLOGFONTA::elfVendorId"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfVendorId) - 172usize];
    ["Offset of field: tagEXTLOGFONTA::elfCulture"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfCulture) - 176usize];
    ["Offset of field: tagEXTLOGFONTA::elfPanose"]
        [::std::mem::offset_of!(tagEXTLOGFONTA, elfPanose) - 180usize];
};
pub type EXTLOGFONTA = tagEXTLOGFONTA;
pub type PEXTLOGFONTA = *mut tagEXTLOGFONTA;
pub type NPEXTLOGFONTA = *mut tagEXTLOGFONTA;
pub type LPEXTLOGFONTA = *mut tagEXTLOGFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEXTLOGFONTW {
    pub elfLogFont: LOGFONTW,
    pub elfFullName: [WCHAR; 64usize],
    pub elfStyle: [WCHAR; 32usize],
    pub elfVersion: DWORD,
    pub elfStyleSize: DWORD,
    pub elfMatch: DWORD,
    pub elfReserved: DWORD,
    pub elfVendorId: [BYTE; 4usize],
    pub elfCulture: DWORD,
    pub elfPanose: PANOSE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEXTLOGFONTW"][::std::mem::size_of::<tagEXTLOGFONTW>() - 320usize];
    ["Alignment of tagEXTLOGFONTW"][::std::mem::align_of::<tagEXTLOGFONTW>() - 4usize];
    ["Offset of field: tagEXTLOGFONTW::elfLogFont"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfLogFont) - 0usize];
    ["Offset of field: tagEXTLOGFONTW::elfFullName"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfFullName) - 92usize];
    ["Offset of field: tagEXTLOGFONTW::elfStyle"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfStyle) - 220usize];
    ["Offset of field: tagEXTLOGFONTW::elfVersion"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfVersion) - 284usize];
    ["Offset of field: tagEXTLOGFONTW::elfStyleSize"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfStyleSize) - 288usize];
    ["Offset of field: tagEXTLOGFONTW::elfMatch"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfMatch) - 292usize];
    ["Offset of field: tagEXTLOGFONTW::elfReserved"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfReserved) - 296usize];
    ["Offset of field: tagEXTLOGFONTW::elfVendorId"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfVendorId) - 300usize];
    ["Offset of field: tagEXTLOGFONTW::elfCulture"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfCulture) - 304usize];
    ["Offset of field: tagEXTLOGFONTW::elfPanose"]
        [::std::mem::offset_of!(tagEXTLOGFONTW, elfPanose) - 308usize];
};
pub type EXTLOGFONTW = tagEXTLOGFONTW;
pub type PEXTLOGFONTW = *mut tagEXTLOGFONTW;
pub type NPEXTLOGFONTW = *mut tagEXTLOGFONTW;
pub type LPEXTLOGFONTW = *mut tagEXTLOGFONTW;
pub type EXTLOGFONT = EXTLOGFONTA;
pub type PEXTLOGFONT = PEXTLOGFONTA;
pub type NPEXTLOGFONT = NPEXTLOGFONTA;
pub type LPEXTLOGFONT = LPEXTLOGFONTA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _devicemodeA {
    pub dmDeviceName: [BYTE; 32usize],
    pub dmSpecVersion: WORD,
    pub dmDriverVersion: WORD,
    pub dmSize: WORD,
    pub dmDriverExtra: WORD,
    pub dmFields: DWORD,
    pub __bindgen_anon_1: _devicemodeA__bindgen_ty_1,
    pub dmColor: ::std::os::raw::c_short,
    pub dmDuplex: ::std::os::raw::c_short,
    pub dmYResolution: ::std::os::raw::c_short,
    pub dmTTOption: ::std::os::raw::c_short,
    pub dmCollate: ::std::os::raw::c_short,
    pub dmFormName: [BYTE; 32usize],
    pub dmLogPixels: WORD,
    pub dmBitsPerPel: DWORD,
    pub dmPelsWidth: DWORD,
    pub dmPelsHeight: DWORD,
    pub __bindgen_anon_2: _devicemodeA__bindgen_ty_2,
    pub dmDisplayFrequency: DWORD,
    pub dmICMMethod: DWORD,
    pub dmICMIntent: DWORD,
    pub dmMediaType: DWORD,
    pub dmDitherType: DWORD,
    pub dmReserved1: DWORD,
    pub dmReserved2: DWORD,
    pub dmPanningWidth: DWORD,
    pub dmPanningHeight: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _devicemodeA__bindgen_ty_1 {
    pub __bindgen_anon_1: _devicemodeA__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: _devicemodeA__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _devicemodeA__bindgen_ty_1__bindgen_ty_1 {
    pub dmOrientation: ::std::os::raw::c_short,
    pub dmPaperSize: ::std::os::raw::c_short,
    pub dmPaperLength: ::std::os::raw::c_short,
    pub dmPaperWidth: ::std::os::raw::c_short,
    pub dmScale: ::std::os::raw::c_short,
    pub dmCopies: ::std::os::raw::c_short,
    pub dmDefaultSource: ::std::os::raw::c_short,
    pub dmPrintQuality: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_devicemodeA__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Alignment of _devicemodeA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_devicemodeA__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmOrientation"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmOrientation) - 0usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmPaperSize"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmPaperSize) - 2usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmPaperLength"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmPaperLength) - 4usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmPaperWidth"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmPaperWidth) - 6usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmScale"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmScale) - 8usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmCopies"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_1, dmCopies) - 10usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmDefaultSource"][::std::mem::offset_of!(
        _devicemodeA__bindgen_ty_1__bindgen_ty_1,
        dmDefaultSource
    ) - 12usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_1::dmPrintQuality"][::std::mem::offset_of!(
        _devicemodeA__bindgen_ty_1__bindgen_ty_1,
        dmPrintQuality
    ) - 14usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _devicemodeA__bindgen_ty_1__bindgen_ty_2 {
    pub dmPosition: POINTL,
    pub dmDisplayOrientation: DWORD,
    pub dmDisplayFixedOutput: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeA__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_devicemodeA__bindgen_ty_1__bindgen_ty_2>() - 16usize];
    ["Alignment of _devicemodeA__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_devicemodeA__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_2::dmPosition"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_1__bindgen_ty_2, dmPosition) - 0usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_2::dmDisplayOrientation"][::std::mem::offset_of!(
        _devicemodeA__bindgen_ty_1__bindgen_ty_2,
        dmDisplayOrientation
    ) - 8usize];
    ["Offset of field: _devicemodeA__bindgen_ty_1__bindgen_ty_2::dmDisplayFixedOutput"][::std::mem::offset_of!(
        _devicemodeA__bindgen_ty_1__bindgen_ty_2,
        dmDisplayFixedOutput
    )
        - 12usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeA__bindgen_ty_1"]
        [::std::mem::size_of::<_devicemodeA__bindgen_ty_1>() - 16usize];
    ["Alignment of _devicemodeA__bindgen_ty_1"]
        [::std::mem::align_of::<_devicemodeA__bindgen_ty_1>() - 4usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _devicemodeA__bindgen_ty_2 {
    pub dmDisplayFlags: DWORD,
    pub dmNup: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeA__bindgen_ty_2"]
        [::std::mem::size_of::<_devicemodeA__bindgen_ty_2>() - 4usize];
    ["Alignment of _devicemodeA__bindgen_ty_2"]
        [::std::mem::align_of::<_devicemodeA__bindgen_ty_2>() - 4usize];
    ["Offset of field: _devicemodeA__bindgen_ty_2::dmDisplayFlags"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_2, dmDisplayFlags) - 0usize];
    ["Offset of field: _devicemodeA__bindgen_ty_2::dmNup"]
        [::std::mem::offset_of!(_devicemodeA__bindgen_ty_2, dmNup) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeA"][::std::mem::size_of::<_devicemodeA>() - 156usize];
    ["Alignment of _devicemodeA"][::std::mem::align_of::<_devicemodeA>() - 4usize];
    ["Offset of field: _devicemodeA::dmDeviceName"]
        [::std::mem::offset_of!(_devicemodeA, dmDeviceName) - 0usize];
    ["Offset of field: _devicemodeA::dmSpecVersion"]
        [::std::mem::offset_of!(_devicemodeA, dmSpecVersion) - 32usize];
    ["Offset of field: _devicemodeA::dmDriverVersion"]
        [::std::mem::offset_of!(_devicemodeA, dmDriverVersion) - 34usize];
    ["Offset of field: _devicemodeA::dmSize"]
        [::std::mem::offset_of!(_devicemodeA, dmSize) - 36usize];
    ["Offset of field: _devicemodeA::dmDriverExtra"]
        [::std::mem::offset_of!(_devicemodeA, dmDriverExtra) - 38usize];
    ["Offset of field: _devicemodeA::dmFields"]
        [::std::mem::offset_of!(_devicemodeA, dmFields) - 40usize];
    ["Offset of field: _devicemodeA::dmColor"]
        [::std::mem::offset_of!(_devicemodeA, dmColor) - 60usize];
    ["Offset of field: _devicemodeA::dmDuplex"]
        [::std::mem::offset_of!(_devicemodeA, dmDuplex) - 62usize];
    ["Offset of field: _devicemodeA::dmYResolution"]
        [::std::mem::offset_of!(_devicemodeA, dmYResolution) - 64usize];
    ["Offset of field: _devicemodeA::dmTTOption"]
        [::std::mem::offset_of!(_devicemodeA, dmTTOption) - 66usize];
    ["Offset of field: _devicemodeA::dmCollate"]
        [::std::mem::offset_of!(_devicemodeA, dmCollate) - 68usize];
    ["Offset of field: _devicemodeA::dmFormName"]
        [::std::mem::offset_of!(_devicemodeA, dmFormName) - 70usize];
    ["Offset of field: _devicemodeA::dmLogPixels"]
        [::std::mem::offset_of!(_devicemodeA, dmLogPixels) - 102usize];
    ["Offset of field: _devicemodeA::dmBitsPerPel"]
        [::std::mem::offset_of!(_devicemodeA, dmBitsPerPel) - 104usize];
    ["Offset of field: _devicemodeA::dmPelsWidth"]
        [::std::mem::offset_of!(_devicemodeA, dmPelsWidth) - 108usize];
    ["Offset of field: _devicemodeA::dmPelsHeight"]
        [::std::mem::offset_of!(_devicemodeA, dmPelsHeight) - 112usize];
    ["Offset of field: _devicemodeA::dmDisplayFrequency"]
        [::std::mem::offset_of!(_devicemodeA, dmDisplayFrequency) - 120usize];
    ["Offset of field: _devicemodeA::dmICMMethod"]
        [::std::mem::offset_of!(_devicemodeA, dmICMMethod) - 124usize];
    ["Offset of field: _devicemodeA::dmICMIntent"]
        [::std::mem::offset_of!(_devicemodeA, dmICMIntent) - 128usize];
    ["Offset of field: _devicemodeA::dmMediaType"]
        [::std::mem::offset_of!(_devicemodeA, dmMediaType) - 132usize];
    ["Offset of field: _devicemodeA::dmDitherType"]
        [::std::mem::offset_of!(_devicemodeA, dmDitherType) - 136usize];
    ["Offset of field: _devicemodeA::dmReserved1"]
        [::std::mem::offset_of!(_devicemodeA, dmReserved1) - 140usize];
    ["Offset of field: _devicemodeA::dmReserved2"]
        [::std::mem::offset_of!(_devicemodeA, dmReserved2) - 144usize];
    ["Offset of field: _devicemodeA::dmPanningWidth"]
        [::std::mem::offset_of!(_devicemodeA, dmPanningWidth) - 148usize];
    ["Offset of field: _devicemodeA::dmPanningHeight"]
        [::std::mem::offset_of!(_devicemodeA, dmPanningHeight) - 152usize];
};
pub type DEVMODEA = _devicemodeA;
pub type PDEVMODEA = *mut _devicemodeA;
pub type NPDEVMODEA = *mut _devicemodeA;
pub type LPDEVMODEA = *mut _devicemodeA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _devicemodeW {
    pub dmDeviceName: [WCHAR; 32usize],
    pub dmSpecVersion: WORD,
    pub dmDriverVersion: WORD,
    pub dmSize: WORD,
    pub dmDriverExtra: WORD,
    pub dmFields: DWORD,
    pub __bindgen_anon_1: _devicemodeW__bindgen_ty_1,
    pub dmColor: ::std::os::raw::c_short,
    pub dmDuplex: ::std::os::raw::c_short,
    pub dmYResolution: ::std::os::raw::c_short,
    pub dmTTOption: ::std::os::raw::c_short,
    pub dmCollate: ::std::os::raw::c_short,
    pub dmFormName: [WCHAR; 32usize],
    pub dmLogPixels: WORD,
    pub dmBitsPerPel: DWORD,
    pub dmPelsWidth: DWORD,
    pub dmPelsHeight: DWORD,
    pub __bindgen_anon_2: _devicemodeW__bindgen_ty_2,
    pub dmDisplayFrequency: DWORD,
    pub dmICMMethod: DWORD,
    pub dmICMIntent: DWORD,
    pub dmMediaType: DWORD,
    pub dmDitherType: DWORD,
    pub dmReserved1: DWORD,
    pub dmReserved2: DWORD,
    pub dmPanningWidth: DWORD,
    pub dmPanningHeight: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _devicemodeW__bindgen_ty_1 {
    pub __bindgen_anon_1: _devicemodeW__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: _devicemodeW__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _devicemodeW__bindgen_ty_1__bindgen_ty_1 {
    pub dmOrientation: ::std::os::raw::c_short,
    pub dmPaperSize: ::std::os::raw::c_short,
    pub dmPaperLength: ::std::os::raw::c_short,
    pub dmPaperWidth: ::std::os::raw::c_short,
    pub dmScale: ::std::os::raw::c_short,
    pub dmCopies: ::std::os::raw::c_short,
    pub dmDefaultSource: ::std::os::raw::c_short,
    pub dmPrintQuality: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeW__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_devicemodeW__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Alignment of _devicemodeW__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_devicemodeW__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmOrientation"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmOrientation) - 0usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmPaperSize"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmPaperSize) - 2usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmPaperLength"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmPaperLength) - 4usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmPaperWidth"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmPaperWidth) - 6usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmScale"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmScale) - 8usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmCopies"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_1, dmCopies) - 10usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmDefaultSource"][::std::mem::offset_of!(
        _devicemodeW__bindgen_ty_1__bindgen_ty_1,
        dmDefaultSource
    ) - 12usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_1::dmPrintQuality"][::std::mem::offset_of!(
        _devicemodeW__bindgen_ty_1__bindgen_ty_1,
        dmPrintQuality
    ) - 14usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _devicemodeW__bindgen_ty_1__bindgen_ty_2 {
    pub dmPosition: POINTL,
    pub dmDisplayOrientation: DWORD,
    pub dmDisplayFixedOutput: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeW__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_devicemodeW__bindgen_ty_1__bindgen_ty_2>() - 16usize];
    ["Alignment of _devicemodeW__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_devicemodeW__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_2::dmPosition"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_1__bindgen_ty_2, dmPosition) - 0usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_2::dmDisplayOrientation"][::std::mem::offset_of!(
        _devicemodeW__bindgen_ty_1__bindgen_ty_2,
        dmDisplayOrientation
    ) - 8usize];
    ["Offset of field: _devicemodeW__bindgen_ty_1__bindgen_ty_2::dmDisplayFixedOutput"][::std::mem::offset_of!(
        _devicemodeW__bindgen_ty_1__bindgen_ty_2,
        dmDisplayFixedOutput
    )
        - 12usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeW__bindgen_ty_1"]
        [::std::mem::size_of::<_devicemodeW__bindgen_ty_1>() - 16usize];
    ["Alignment of _devicemodeW__bindgen_ty_1"]
        [::std::mem::align_of::<_devicemodeW__bindgen_ty_1>() - 4usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _devicemodeW__bindgen_ty_2 {
    pub dmDisplayFlags: DWORD,
    pub dmNup: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeW__bindgen_ty_2"]
        [::std::mem::size_of::<_devicemodeW__bindgen_ty_2>() - 4usize];
    ["Alignment of _devicemodeW__bindgen_ty_2"]
        [::std::mem::align_of::<_devicemodeW__bindgen_ty_2>() - 4usize];
    ["Offset of field: _devicemodeW__bindgen_ty_2::dmDisplayFlags"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_2, dmDisplayFlags) - 0usize];
    ["Offset of field: _devicemodeW__bindgen_ty_2::dmNup"]
        [::std::mem::offset_of!(_devicemodeW__bindgen_ty_2, dmNup) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _devicemodeW"][::std::mem::size_of::<_devicemodeW>() - 220usize];
    ["Alignment of _devicemodeW"][::std::mem::align_of::<_devicemodeW>() - 4usize];
    ["Offset of field: _devicemodeW::dmDeviceName"]
        [::std::mem::offset_of!(_devicemodeW, dmDeviceName) - 0usize];
    ["Offset of field: _devicemodeW::dmSpecVersion"]
        [::std::mem::offset_of!(_devicemodeW, dmSpecVersion) - 64usize];
    ["Offset of field: _devicemodeW::dmDriverVersion"]
        [::std::mem::offset_of!(_devicemodeW, dmDriverVersion) - 66usize];
    ["Offset of field: _devicemodeW::dmSize"]
        [::std::mem::offset_of!(_devicemodeW, dmSize) - 68usize];
    ["Offset of field: _devicemodeW::dmDriverExtra"]
        [::std::mem::offset_of!(_devicemodeW, dmDriverExtra) - 70usize];
    ["Offset of field: _devicemodeW::dmFields"]
        [::std::mem::offset_of!(_devicemodeW, dmFields) - 72usize];
    ["Offset of field: _devicemodeW::dmColor"]
        [::std::mem::offset_of!(_devicemodeW, dmColor) - 92usize];
    ["Offset of field: _devicemodeW::dmDuplex"]
        [::std::mem::offset_of!(_devicemodeW, dmDuplex) - 94usize];
    ["Offset of field: _devicemodeW::dmYResolution"]
        [::std::mem::offset_of!(_devicemodeW, dmYResolution) - 96usize];
    ["Offset of field: _devicemodeW::dmTTOption"]
        [::std::mem::offset_of!(_devicemodeW, dmTTOption) - 98usize];
    ["Offset of field: _devicemodeW::dmCollate"]
        [::std::mem::offset_of!(_devicemodeW, dmCollate) - 100usize];
    ["Offset of field: _devicemodeW::dmFormName"]
        [::std::mem::offset_of!(_devicemodeW, dmFormName) - 102usize];
    ["Offset of field: _devicemodeW::dmLogPixels"]
        [::std::mem::offset_of!(_devicemodeW, dmLogPixels) - 166usize];
    ["Offset of field: _devicemodeW::dmBitsPerPel"]
        [::std::mem::offset_of!(_devicemodeW, dmBitsPerPel) - 168usize];
    ["Offset of field: _devicemodeW::dmPelsWidth"]
        [::std::mem::offset_of!(_devicemodeW, dmPelsWidth) - 172usize];
    ["Offset of field: _devicemodeW::dmPelsHeight"]
        [::std::mem::offset_of!(_devicemodeW, dmPelsHeight) - 176usize];
    ["Offset of field: _devicemodeW::dmDisplayFrequency"]
        [::std::mem::offset_of!(_devicemodeW, dmDisplayFrequency) - 184usize];
    ["Offset of field: _devicemodeW::dmICMMethod"]
        [::std::mem::offset_of!(_devicemodeW, dmICMMethod) - 188usize];
    ["Offset of field: _devicemodeW::dmICMIntent"]
        [::std::mem::offset_of!(_devicemodeW, dmICMIntent) - 192usize];
    ["Offset of field: _devicemodeW::dmMediaType"]
        [::std::mem::offset_of!(_devicemodeW, dmMediaType) - 196usize];
    ["Offset of field: _devicemodeW::dmDitherType"]
        [::std::mem::offset_of!(_devicemodeW, dmDitherType) - 200usize];
    ["Offset of field: _devicemodeW::dmReserved1"]
        [::std::mem::offset_of!(_devicemodeW, dmReserved1) - 204usize];
    ["Offset of field: _devicemodeW::dmReserved2"]
        [::std::mem::offset_of!(_devicemodeW, dmReserved2) - 208usize];
    ["Offset of field: _devicemodeW::dmPanningWidth"]
        [::std::mem::offset_of!(_devicemodeW, dmPanningWidth) - 212usize];
    ["Offset of field: _devicemodeW::dmPanningHeight"]
        [::std::mem::offset_of!(_devicemodeW, dmPanningHeight) - 216usize];
};
pub type DEVMODEW = _devicemodeW;
pub type PDEVMODEW = *mut _devicemodeW;
pub type NPDEVMODEW = *mut _devicemodeW;
pub type LPDEVMODEW = *mut _devicemodeW;
pub type DEVMODE = DEVMODEA;
pub type PDEVMODE = PDEVMODEA;
pub type NPDEVMODE = NPDEVMODEA;
pub type LPDEVMODE = LPDEVMODEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAY_DEVICEA {
    pub cb: DWORD,
    pub DeviceName: [CHAR; 32usize],
    pub DeviceString: [CHAR; 128usize],
    pub StateFlags: DWORD,
    pub DeviceID: [CHAR; 128usize],
    pub DeviceKey: [CHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAY_DEVICEA"][::std::mem::size_of::<_DISPLAY_DEVICEA>() - 424usize];
    ["Alignment of _DISPLAY_DEVICEA"][::std::mem::align_of::<_DISPLAY_DEVICEA>() - 4usize];
    ["Offset of field: _DISPLAY_DEVICEA::cb"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, cb) - 0usize];
    ["Offset of field: _DISPLAY_DEVICEA::DeviceName"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, DeviceName) - 4usize];
    ["Offset of field: _DISPLAY_DEVICEA::DeviceString"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, DeviceString) - 36usize];
    ["Offset of field: _DISPLAY_DEVICEA::StateFlags"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, StateFlags) - 164usize];
    ["Offset of field: _DISPLAY_DEVICEA::DeviceID"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, DeviceID) - 168usize];
    ["Offset of field: _DISPLAY_DEVICEA::DeviceKey"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEA, DeviceKey) - 296usize];
};
pub type DISPLAY_DEVICEA = _DISPLAY_DEVICEA;
pub type PDISPLAY_DEVICEA = *mut _DISPLAY_DEVICEA;
pub type LPDISPLAY_DEVICEA = *mut _DISPLAY_DEVICEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAY_DEVICEW {
    pub cb: DWORD,
    pub DeviceName: [WCHAR; 32usize],
    pub DeviceString: [WCHAR; 128usize],
    pub StateFlags: DWORD,
    pub DeviceID: [WCHAR; 128usize],
    pub DeviceKey: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAY_DEVICEW"][::std::mem::size_of::<_DISPLAY_DEVICEW>() - 840usize];
    ["Alignment of _DISPLAY_DEVICEW"][::std::mem::align_of::<_DISPLAY_DEVICEW>() - 4usize];
    ["Offset of field: _DISPLAY_DEVICEW::cb"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, cb) - 0usize];
    ["Offset of field: _DISPLAY_DEVICEW::DeviceName"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, DeviceName) - 4usize];
    ["Offset of field: _DISPLAY_DEVICEW::DeviceString"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, DeviceString) - 68usize];
    ["Offset of field: _DISPLAY_DEVICEW::StateFlags"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, StateFlags) - 324usize];
    ["Offset of field: _DISPLAY_DEVICEW::DeviceID"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, DeviceID) - 328usize];
    ["Offset of field: _DISPLAY_DEVICEW::DeviceKey"]
        [::std::mem::offset_of!(_DISPLAY_DEVICEW, DeviceKey) - 584usize];
};
pub type DISPLAY_DEVICEW = _DISPLAY_DEVICEW;
pub type PDISPLAY_DEVICEW = *mut _DISPLAY_DEVICEW;
pub type LPDISPLAY_DEVICEW = *mut _DISPLAY_DEVICEW;
pub type DISPLAY_DEVICE = DISPLAY_DEVICEA;
pub type PDISPLAY_DEVICE = PDISPLAY_DEVICEA;
pub type LPDISPLAY_DEVICE = LPDISPLAY_DEVICEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_RATIONAL {
    pub Numerator: UINT32,
    pub Denominator: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_RATIONAL"][::std::mem::size_of::<DISPLAYCONFIG_RATIONAL>() - 8usize];
    ["Alignment of DISPLAYCONFIG_RATIONAL"]
        [::std::mem::align_of::<DISPLAYCONFIG_RATIONAL>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_RATIONAL::Numerator"]
        [::std::mem::offset_of!(DISPLAYCONFIG_RATIONAL, Numerator) - 0usize];
    ["Offset of field: DISPLAYCONFIG_RATIONAL::Denominator"]
        [::std::mem::offset_of!(DISPLAYCONFIG_RATIONAL, Denominator) - 4usize];
};
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_OTHER:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = -1;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_HD15:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 0;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_SVIDEO:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 1;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_COMPOSITE_VIDEO:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 2;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_COMPONENT_VIDEO:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 3;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_DVI:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 4;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_HDMI:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 5;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_LVDS:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 6;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_D_JPN:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 8;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_SDI:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 9;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_DISPLAYPORT_EXTERNAL : DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 10 ;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_DISPLAYPORT_EMBEDDED : DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 11 ;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_UDI_EXTERNAL:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 12;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_UDI_EMBEDDED:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 13;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_SDTVDONGLE:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 14;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_MIRACAST:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 15;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_INDIRECT_WIRED:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 16;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_INDIRECT_VIRTUAL:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 17;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_DISPLAYPORT_USB_TUNNEL : DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = 18 ;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_INTERNAL:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = -2147483648;
pub const DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY_DISPLAYCONFIG_OUTPUT_TECHNOLOGY_FORCE_UINT32:
    DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = -1;
pub type DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY = ::std::os::raw::c_int;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_UNSPECIFIED:
    DISPLAYCONFIG_SCANLINE_ORDERING = 0;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_PROGRESSIVE:
    DISPLAYCONFIG_SCANLINE_ORDERING = 1;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_INTERLACED:
    DISPLAYCONFIG_SCANLINE_ORDERING = 2;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_INTERLACED_UPPERFIELDFIRST : DISPLAYCONFIG_SCANLINE_ORDERING = 2 ;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_INTERLACED_LOWERFIELDFIRST : DISPLAYCONFIG_SCANLINE_ORDERING = 3 ;
pub const DISPLAYCONFIG_SCANLINE_ORDERING_DISPLAYCONFIG_SCANLINE_ORDERING_FORCE_UINT32:
    DISPLAYCONFIG_SCANLINE_ORDERING = -1;
pub type DISPLAYCONFIG_SCANLINE_ORDERING = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_2DREGION {
    pub cx: UINT32,
    pub cy: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_2DREGION"][::std::mem::size_of::<DISPLAYCONFIG_2DREGION>() - 8usize];
    ["Alignment of DISPLAYCONFIG_2DREGION"]
        [::std::mem::align_of::<DISPLAYCONFIG_2DREGION>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_2DREGION::cx"]
        [::std::mem::offset_of!(DISPLAYCONFIG_2DREGION, cx) - 0usize];
    ["Offset of field: DISPLAYCONFIG_2DREGION::cy"]
        [::std::mem::offset_of!(DISPLAYCONFIG_2DREGION, cy) - 4usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_VIDEO_SIGNAL_INFO {
    pub pixelRate: UINT64,
    pub hSyncFreq: DISPLAYCONFIG_RATIONAL,
    pub vSyncFreq: DISPLAYCONFIG_RATIONAL,
    pub activeSize: DISPLAYCONFIG_2DREGION,
    pub totalSize: DISPLAYCONFIG_2DREGION,
    pub __bindgen_anon_1: DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1,
    pub scanLineOrdering: DISPLAYCONFIG_SCANLINE_ORDERING,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1 {
    pub AdditionalSignalInfo: DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1,
    pub videoStandard: UINT32,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn videoStandard(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_videoStandard(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn videoStandard_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_videoStandard_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn vSyncFreqDivider(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 6u8) as u32) }
    }
    #[inline]
    pub fn set_vSyncFreqDivider(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 6u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn vSyncFreqDivider_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                6u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_vSyncFreqDivider_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                6u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(22usize, 10u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(22usize, 10u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                22usize,
                10u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                22usize,
                10u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        videoStandard: UINT32,
        vSyncFreqDivider: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 16u8, {
            let videoStandard: u32 = unsafe { ::std::mem::transmute(videoStandard) };
            videoStandard as u64
        });
        __bindgen_bitfield_unit.set(16usize, 6u8, {
            let vSyncFreqDivider: u32 = unsafe { ::std::mem::transmute(vSyncFreqDivider) };
            vSyncFreqDivider as u64
        });
        __bindgen_bitfield_unit.set(22usize, 10u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1::AdditionalSignalInfo"][::std::mem::offset_of!(
        DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1,
        AdditionalSignalInfo
    )
        - 0usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1::videoStandard"][::std::mem::offset_of!(
        DISPLAYCONFIG_VIDEO_SIGNAL_INFO__bindgen_ty_1,
        videoStandard
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_VIDEO_SIGNAL_INFO"]
        [::std::mem::size_of::<DISPLAYCONFIG_VIDEO_SIGNAL_INFO>() - 48usize];
    ["Alignment of DISPLAYCONFIG_VIDEO_SIGNAL_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_VIDEO_SIGNAL_INFO>() - 8usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::pixelRate"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, pixelRate) - 0usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::hSyncFreq"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, hSyncFreq) - 8usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::vSyncFreq"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, vSyncFreq) - 16usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::activeSize"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, activeSize) - 24usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::totalSize"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, totalSize) - 32usize];
    ["Offset of field: DISPLAYCONFIG_VIDEO_SIGNAL_INFO::scanLineOrdering"]
        [::std::mem::offset_of!(DISPLAYCONFIG_VIDEO_SIGNAL_INFO, scanLineOrdering) - 44usize];
};
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_IDENTITY: DISPLAYCONFIG_SCALING = 1;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_CENTERED: DISPLAYCONFIG_SCALING = 2;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_STRETCHED: DISPLAYCONFIG_SCALING = 3;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_ASPECTRATIOCENTEREDMAX:
    DISPLAYCONFIG_SCALING = 4;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_CUSTOM: DISPLAYCONFIG_SCALING = 5;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_PREFERRED: DISPLAYCONFIG_SCALING = 128;
pub const DISPLAYCONFIG_SCALING_DISPLAYCONFIG_SCALING_FORCE_UINT32: DISPLAYCONFIG_SCALING = -1;
pub type DISPLAYCONFIG_SCALING = ::std::os::raw::c_int;
pub const DISPLAYCONFIG_ROTATION_DISPLAYCONFIG_ROTATION_IDENTITY: DISPLAYCONFIG_ROTATION = 1;
pub const DISPLAYCONFIG_ROTATION_DISPLAYCONFIG_ROTATION_ROTATE90: DISPLAYCONFIG_ROTATION = 2;
pub const DISPLAYCONFIG_ROTATION_DISPLAYCONFIG_ROTATION_ROTATE180: DISPLAYCONFIG_ROTATION = 3;
pub const DISPLAYCONFIG_ROTATION_DISPLAYCONFIG_ROTATION_ROTATE270: DISPLAYCONFIG_ROTATION = 4;
pub const DISPLAYCONFIG_ROTATION_DISPLAYCONFIG_ROTATION_FORCE_UINT32: DISPLAYCONFIG_ROTATION = -1;
pub type DISPLAYCONFIG_ROTATION = ::std::os::raw::c_int;
pub const DISPLAYCONFIG_MODE_INFO_TYPE_DISPLAYCONFIG_MODE_INFO_TYPE_SOURCE:
    DISPLAYCONFIG_MODE_INFO_TYPE = 1;
pub const DISPLAYCONFIG_MODE_INFO_TYPE_DISPLAYCONFIG_MODE_INFO_TYPE_TARGET:
    DISPLAYCONFIG_MODE_INFO_TYPE = 2;
pub const DISPLAYCONFIG_MODE_INFO_TYPE_DISPLAYCONFIG_MODE_INFO_TYPE_DESKTOP_IMAGE:
    DISPLAYCONFIG_MODE_INFO_TYPE = 3;
pub const DISPLAYCONFIG_MODE_INFO_TYPE_DISPLAYCONFIG_MODE_INFO_TYPE_FORCE_UINT32:
    DISPLAYCONFIG_MODE_INFO_TYPE = -1;
pub type DISPLAYCONFIG_MODE_INFO_TYPE = ::std::os::raw::c_int;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_8BPP: DISPLAYCONFIG_PIXELFORMAT = 1;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_16BPP: DISPLAYCONFIG_PIXELFORMAT = 2;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_24BPP: DISPLAYCONFIG_PIXELFORMAT = 3;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_32BPP: DISPLAYCONFIG_PIXELFORMAT = 4;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_NONGDI: DISPLAYCONFIG_PIXELFORMAT = 5;
pub const DISPLAYCONFIG_PIXELFORMAT_DISPLAYCONFIG_PIXELFORMAT_FORCE_UINT32:
    DISPLAYCONFIG_PIXELFORMAT = -1;
pub type DISPLAYCONFIG_PIXELFORMAT = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_SOURCE_MODE {
    pub width: UINT32,
    pub height: UINT32,
    pub pixelFormat: DISPLAYCONFIG_PIXELFORMAT,
    pub position: POINTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SOURCE_MODE"]
        [::std::mem::size_of::<DISPLAYCONFIG_SOURCE_MODE>() - 20usize];
    ["Alignment of DISPLAYCONFIG_SOURCE_MODE"]
        [::std::mem::align_of::<DISPLAYCONFIG_SOURCE_MODE>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_MODE::width"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_MODE, width) - 0usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_MODE::height"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_MODE, height) - 4usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_MODE::pixelFormat"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_MODE, pixelFormat) - 8usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_MODE::position"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_MODE, position) - 12usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_MODE {
    pub targetVideoSignalInfo: DISPLAYCONFIG_VIDEO_SIGNAL_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_MODE"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_MODE>() - 48usize];
    ["Alignment of DISPLAYCONFIG_TARGET_MODE"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_MODE>() - 8usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_MODE::targetVideoSignalInfo"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_MODE, targetVideoSignalInfo) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_DESKTOP_IMAGE_INFO {
    pub PathSourceSize: POINTL,
    pub DesktopImageRegion: RECTL,
    pub DesktopImageClip: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_DESKTOP_IMAGE_INFO"]
        [::std::mem::size_of::<DISPLAYCONFIG_DESKTOP_IMAGE_INFO>() - 40usize];
    ["Alignment of DISPLAYCONFIG_DESKTOP_IMAGE_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_DESKTOP_IMAGE_INFO>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_DESKTOP_IMAGE_INFO::PathSourceSize"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DESKTOP_IMAGE_INFO, PathSourceSize) - 0usize];
    ["Offset of field: DISPLAYCONFIG_DESKTOP_IMAGE_INFO::DesktopImageRegion"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DESKTOP_IMAGE_INFO, DesktopImageRegion) - 8usize];
    ["Offset of field: DISPLAYCONFIG_DESKTOP_IMAGE_INFO::DesktopImageClip"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DESKTOP_IMAGE_INFO, DesktopImageClip) - 24usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_MODE_INFO {
    pub infoType: DISPLAYCONFIG_MODE_INFO_TYPE,
    pub id: UINT32,
    pub adapterId: LUID,
    pub __bindgen_anon_1: DISPLAYCONFIG_MODE_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_MODE_INFO__bindgen_ty_1 {
    pub targetMode: DISPLAYCONFIG_TARGET_MODE,
    pub sourceMode: DISPLAYCONFIG_SOURCE_MODE,
    pub desktopImageInfo: DISPLAYCONFIG_DESKTOP_IMAGE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_MODE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_MODE_INFO__bindgen_ty_1>() - 48usize];
    ["Alignment of DISPLAYCONFIG_MODE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_MODE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO__bindgen_ty_1::targetMode"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO__bindgen_ty_1, targetMode) - 0usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO__bindgen_ty_1::sourceMode"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO__bindgen_ty_1, sourceMode) - 0usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO__bindgen_ty_1::desktopImageInfo"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO__bindgen_ty_1, desktopImageInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_MODE_INFO"][::std::mem::size_of::<DISPLAYCONFIG_MODE_INFO>() - 64usize];
    ["Alignment of DISPLAYCONFIG_MODE_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_MODE_INFO>() - 8usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO::infoType"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO, infoType) - 0usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO::id"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO, id) - 4usize];
    ["Offset of field: DISPLAYCONFIG_MODE_INFO::adapterId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_MODE_INFO, adapterId) - 8usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_PATH_SOURCE_INFO {
    pub adapterId: LUID,
    pub id: UINT32,
    pub __bindgen_anon_1: DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1,
    pub statusFlags: UINT32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1 {
    pub modeInfoIdx: UINT32,
    pub __bindgen_anon_1: DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
};
impl DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn cloneGroupId(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_cloneGroupId(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn cloneGroupId_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_cloneGroupId_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn sourceModeInfoIdx(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_sourceModeInfoIdx(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn sourceModeInfoIdx_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_sourceModeInfoIdx_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        cloneGroupId: UINT32,
        sourceModeInfoIdx: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 16u8, {
            let cloneGroupId: u32 = unsafe { ::std::mem::transmute(cloneGroupId) };
            cloneGroupId as u64
        });
        __bindgen_bitfield_unit.set(16usize, 16u8, {
            let sourceModeInfoIdx: u32 = unsafe { ::std::mem::transmute(sourceModeInfoIdx) };
            sourceModeInfoIdx as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1::modeInfoIdx"][::std::mem::offset_of!(
        DISPLAYCONFIG_PATH_SOURCE_INFO__bindgen_ty_1,
        modeInfoIdx
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_SOURCE_INFO"]
        [::std::mem::size_of::<DISPLAYCONFIG_PATH_SOURCE_INFO>() - 20usize];
    ["Alignment of DISPLAYCONFIG_PATH_SOURCE_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_PATH_SOURCE_INFO>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_PATH_SOURCE_INFO::adapterId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_SOURCE_INFO, adapterId) - 0usize];
    ["Offset of field: DISPLAYCONFIG_PATH_SOURCE_INFO::id"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_SOURCE_INFO, id) - 8usize];
    ["Offset of field: DISPLAYCONFIG_PATH_SOURCE_INFO::statusFlags"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_SOURCE_INFO, statusFlags) - 16usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_PATH_TARGET_INFO {
    pub adapterId: LUID,
    pub id: UINT32,
    pub __bindgen_anon_1: DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1,
    pub outputTechnology: DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY,
    pub rotation: DISPLAYCONFIG_ROTATION,
    pub scaling: DISPLAYCONFIG_SCALING,
    pub refreshRate: DISPLAYCONFIG_RATIONAL,
    pub scanLineOrdering: DISPLAYCONFIG_SCANLINE_ORDERING,
    pub targetAvailable: BOOL,
    pub statusFlags: UINT32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1 {
    pub modeInfoIdx: UINT32,
    pub __bindgen_anon_1: DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
};
impl DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn desktopModeInfoIdx(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_desktopModeInfoIdx(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn desktopModeInfoIdx_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_desktopModeInfoIdx_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn targetModeInfoIdx(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_targetModeInfoIdx(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn targetModeInfoIdx_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_targetModeInfoIdx_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        desktopModeInfoIdx: UINT32,
        targetModeInfoIdx: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 16u8, {
            let desktopModeInfoIdx: u32 = unsafe { ::std::mem::transmute(desktopModeInfoIdx) };
            desktopModeInfoIdx as u64
        });
        __bindgen_bitfield_unit.set(16usize, 16u8, {
            let targetModeInfoIdx: u32 = unsafe { ::std::mem::transmute(targetModeInfoIdx) };
            targetModeInfoIdx as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1::modeInfoIdx"][::std::mem::offset_of!(
        DISPLAYCONFIG_PATH_TARGET_INFO__bindgen_ty_1,
        modeInfoIdx
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_TARGET_INFO"]
        [::std::mem::size_of::<DISPLAYCONFIG_PATH_TARGET_INFO>() - 48usize];
    ["Alignment of DISPLAYCONFIG_PATH_TARGET_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_PATH_TARGET_INFO>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::adapterId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, adapterId) - 0usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::id"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, id) - 8usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::outputTechnology"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, outputTechnology) - 16usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::rotation"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, rotation) - 20usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::scaling"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, scaling) - 24usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::refreshRate"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, refreshRate) - 28usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::scanLineOrdering"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, scanLineOrdering) - 36usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::targetAvailable"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, targetAvailable) - 40usize];
    ["Offset of field: DISPLAYCONFIG_PATH_TARGET_INFO::statusFlags"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_TARGET_INFO, statusFlags) - 44usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_PATH_INFO {
    pub sourceInfo: DISPLAYCONFIG_PATH_SOURCE_INFO,
    pub targetInfo: DISPLAYCONFIG_PATH_TARGET_INFO,
    pub flags: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_PATH_INFO"][::std::mem::size_of::<DISPLAYCONFIG_PATH_INFO>() - 72usize];
    ["Alignment of DISPLAYCONFIG_PATH_INFO"]
        [::std::mem::align_of::<DISPLAYCONFIG_PATH_INFO>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_PATH_INFO::sourceInfo"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_INFO, sourceInfo) - 0usize];
    ["Offset of field: DISPLAYCONFIG_PATH_INFO::targetInfo"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_INFO, targetInfo) - 20usize];
    ["Offset of field: DISPLAYCONFIG_PATH_INFO::flags"]
        [::std::mem::offset_of!(DISPLAYCONFIG_PATH_INFO, flags) - 68usize];
};
pub const DISPLAYCONFIG_TOPOLOGY_ID_DISPLAYCONFIG_TOPOLOGY_INTERNAL: DISPLAYCONFIG_TOPOLOGY_ID = 1;
pub const DISPLAYCONFIG_TOPOLOGY_ID_DISPLAYCONFIG_TOPOLOGY_CLONE: DISPLAYCONFIG_TOPOLOGY_ID = 2;
pub const DISPLAYCONFIG_TOPOLOGY_ID_DISPLAYCONFIG_TOPOLOGY_EXTEND: DISPLAYCONFIG_TOPOLOGY_ID = 4;
pub const DISPLAYCONFIG_TOPOLOGY_ID_DISPLAYCONFIG_TOPOLOGY_EXTERNAL: DISPLAYCONFIG_TOPOLOGY_ID = 8;
pub const DISPLAYCONFIG_TOPOLOGY_ID_DISPLAYCONFIG_TOPOLOGY_FORCE_UINT32: DISPLAYCONFIG_TOPOLOGY_ID =
    -1;
pub type DISPLAYCONFIG_TOPOLOGY_ID = ::std::os::raw::c_int;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_SOURCE_NAME:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 1;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_TARGET_NAME:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 2;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_TARGET_PREFERRED_MODE:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 3;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_ADAPTER_NAME:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 4;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_SET_TARGET_PERSISTENCE:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 5;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_TARGET_BASE_TYPE:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 6;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_SUPPORT_VIRTUAL_RESOLUTION : DISPLAYCONFIG_DEVICE_INFO_TYPE = 7 ;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_SET_SUPPORT_VIRTUAL_RESOLUTION : DISPLAYCONFIG_DEVICE_INFO_TYPE = 8 ;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_ADVANCED_COLOR_INFO:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 9;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_SET_ADVANCED_COLOR_STATE:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 10;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_SDR_WHITE_LEVEL:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 11;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_GET_MONITOR_SPECIALIZATION:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 12;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_SET_MONITOR_SPECIALIZATION:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = 13;
pub const DISPLAYCONFIG_DEVICE_INFO_TYPE_DISPLAYCONFIG_DEVICE_INFO_FORCE_UINT32:
    DISPLAYCONFIG_DEVICE_INFO_TYPE = -1;
pub type DISPLAYCONFIG_DEVICE_INFO_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_DEVICE_INFO_HEADER {
    pub type_: DISPLAYCONFIG_DEVICE_INFO_TYPE,
    pub size: UINT32,
    pub adapterId: LUID,
    pub id: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_DEVICE_INFO_HEADER"]
        [::std::mem::size_of::<DISPLAYCONFIG_DEVICE_INFO_HEADER>() - 20usize];
    ["Alignment of DISPLAYCONFIG_DEVICE_INFO_HEADER"]
        [::std::mem::align_of::<DISPLAYCONFIG_DEVICE_INFO_HEADER>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_DEVICE_INFO_HEADER::type_"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DEVICE_INFO_HEADER, type_) - 0usize];
    ["Offset of field: DISPLAYCONFIG_DEVICE_INFO_HEADER::size"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DEVICE_INFO_HEADER, size) - 4usize];
    ["Offset of field: DISPLAYCONFIG_DEVICE_INFO_HEADER::adapterId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DEVICE_INFO_HEADER, adapterId) - 8usize];
    ["Offset of field: DISPLAYCONFIG_DEVICE_INFO_HEADER::id"]
        [::std::mem::offset_of!(DISPLAYCONFIG_DEVICE_INFO_HEADER, id) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_SOURCE_DEVICE_NAME {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub viewGdiDeviceName: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SOURCE_DEVICE_NAME"]
        [::std::mem::size_of::<DISPLAYCONFIG_SOURCE_DEVICE_NAME>() - 84usize];
    ["Alignment of DISPLAYCONFIG_SOURCE_DEVICE_NAME"]
        [::std::mem::align_of::<DISPLAYCONFIG_SOURCE_DEVICE_NAME>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_DEVICE_NAME::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_DEVICE_NAME, header) - 0usize];
    ["Offset of field: DISPLAYCONFIG_SOURCE_DEVICE_NAME::viewGdiDeviceName"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SOURCE_DEVICE_NAME, viewGdiDeviceName) - 20usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS {
    pub __bindgen_anon_1: DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1 {
    pub __bindgen_anon_1: DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn friendlyNameFromEdid(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_friendlyNameFromEdid(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn friendlyNameFromEdid_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_friendlyNameFromEdid_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn friendlyNameForced(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_friendlyNameForced(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn friendlyNameForced_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_friendlyNameForced_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn edidIdsValid(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_edidIdsValid(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn edidIdsValid_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_edidIdsValid_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 29u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 29u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                29u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                29u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        friendlyNameFromEdid: UINT32,
        friendlyNameForced: UINT32,
        edidIdsValid: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let friendlyNameFromEdid: u32 = unsafe { ::std::mem::transmute(friendlyNameFromEdid) };
            friendlyNameFromEdid as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let friendlyNameForced: u32 = unsafe { ::std::mem::transmute(friendlyNameForced) };
            friendlyNameForced as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let edidIdsValid: u32 = unsafe { ::std::mem::transmute(edidIdsValid) };
            edidIdsValid as u64
        });
        __bindgen_bitfield_unit.set(3usize, 29u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1::value"][::std::mem::offset_of!(
        DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS>() - 4usize];
    ["Alignment of DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS>() - 4usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_DEVICE_NAME {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub flags: DISPLAYCONFIG_TARGET_DEVICE_NAME_FLAGS,
    pub outputTechnology: DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY,
    pub edidManufactureId: UINT16,
    pub edidProductCodeId: UINT16,
    pub connectorInstance: UINT32,
    pub monitorFriendlyDeviceName: [WCHAR; 64usize],
    pub monitorDevicePath: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_DEVICE_NAME"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME>() - 420usize];
    ["Alignment of DISPLAYCONFIG_TARGET_DEVICE_NAME"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_DEVICE_NAME>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, header) - 0usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::flags"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, flags) - 20usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::outputTechnology"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, outputTechnology) - 24usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::edidManufactureId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, edidManufactureId) - 28usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::edidProductCodeId"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, edidProductCodeId) - 30usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::connectorInstance"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, connectorInstance) - 32usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::monitorFriendlyDeviceName"][::std::mem::offset_of!(
        DISPLAYCONFIG_TARGET_DEVICE_NAME,
        monitorFriendlyDeviceName
    ) - 36usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_DEVICE_NAME::monitorDevicePath"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_DEVICE_NAME, monitorDevicePath) - 164usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_PREFERRED_MODE {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub width: UINT32,
    pub height: UINT32,
    pub targetMode: DISPLAYCONFIG_TARGET_MODE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_PREFERRED_MODE"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_PREFERRED_MODE>() - 80usize];
    ["Alignment of DISPLAYCONFIG_TARGET_PREFERRED_MODE"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_PREFERRED_MODE>() - 8usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_PREFERRED_MODE::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_PREFERRED_MODE, header) - 0usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_PREFERRED_MODE::width"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_PREFERRED_MODE, width) - 20usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_PREFERRED_MODE::height"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_PREFERRED_MODE, height) - 24usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_PREFERRED_MODE::targetMode"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_PREFERRED_MODE, targetMode) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_ADAPTER_NAME {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub adapterDevicePath: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_ADAPTER_NAME"]
        [::std::mem::size_of::<DISPLAYCONFIG_ADAPTER_NAME>() - 276usize];
    ["Alignment of DISPLAYCONFIG_ADAPTER_NAME"]
        [::std::mem::align_of::<DISPLAYCONFIG_ADAPTER_NAME>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_ADAPTER_NAME::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_ADAPTER_NAME, header) - 0usize];
    ["Offset of field: DISPLAYCONFIG_ADAPTER_NAME::adapterDevicePath"]
        [::std::mem::offset_of!(DISPLAYCONFIG_ADAPTER_NAME, adapterDevicePath) - 20usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_TARGET_BASE_TYPE {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub baseOutputTechnology: DISPLAYCONFIG_VIDEO_OUTPUT_TECHNOLOGY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_TARGET_BASE_TYPE"]
        [::std::mem::size_of::<DISPLAYCONFIG_TARGET_BASE_TYPE>() - 24usize];
    ["Alignment of DISPLAYCONFIG_TARGET_BASE_TYPE"]
        [::std::mem::align_of::<DISPLAYCONFIG_TARGET_BASE_TYPE>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_BASE_TYPE::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_BASE_TYPE, header) - 0usize];
    ["Offset of field: DISPLAYCONFIG_TARGET_BASE_TYPE::baseOutputTechnology"]
        [::std::mem::offset_of!(DISPLAYCONFIG_TARGET_BASE_TYPE, baseOutputTechnology) - 20usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_SET_TARGET_PERSISTENCE {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1 {
    pub __bindgen_anon_1: DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn bootPersistenceOn(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_bootPersistenceOn(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn bootPersistenceOn_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_bootPersistenceOn_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        bootPersistenceOn: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let bootPersistenceOn: u32 = unsafe { ::std::mem::transmute(bootPersistenceOn) };
            bootPersistenceOn as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1::value"][::std::mem::offset_of!(
        DISPLAYCONFIG_SET_TARGET_PERSISTENCE__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SET_TARGET_PERSISTENCE"]
        [::std::mem::size_of::<DISPLAYCONFIG_SET_TARGET_PERSISTENCE>() - 24usize];
    ["Alignment of DISPLAYCONFIG_SET_TARGET_PERSISTENCE"]
        [::std::mem::align_of::<DISPLAYCONFIG_SET_TARGET_PERSISTENCE>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SET_TARGET_PERSISTENCE::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SET_TARGET_PERSISTENCE, header) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1 {
    pub __bindgen_anon_1: DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn disableMonitorVirtualResolution(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_disableMonitorVirtualResolution(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn disableMonitorVirtualResolution_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_disableMonitorVirtualResolution_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        disableMonitorVirtualResolution: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let disableMonitorVirtualResolution: u32 =
                unsafe { ::std::mem::transmute(disableMonitorVirtualResolution) };
            disableMonitorVirtualResolution as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1"]
        [::std::mem::size_of::<DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1>() - 4usize];
    ["Alignment of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1"]
        [::std::mem::align_of::<DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1::value"][::std::mem::offset_of!(
        DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION"]
        [::std::mem::size_of::<DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION>() - 24usize];
    ["Alignment of DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION"]
        [::std::mem::align_of::<DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION>() - 4usize];
    ["Offset of field: DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION::header"]
        [::std::mem::offset_of!(DISPLAYCONFIG_SUPPORT_VIRTUAL_RESOLUTION, header) - 0usize];
};
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_RGB:
    _DISPLAYCONFIG_COLOR_ENCODING = 0;
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_YCBCR444:
    _DISPLAYCONFIG_COLOR_ENCODING = 1;
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_YCBCR422:
    _DISPLAYCONFIG_COLOR_ENCODING = 2;
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_YCBCR420:
    _DISPLAYCONFIG_COLOR_ENCODING = 3;
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_INTENSITY:
    _DISPLAYCONFIG_COLOR_ENCODING = 4;
pub const _DISPLAYCONFIG_COLOR_ENCODING_DISPLAYCONFIG_COLOR_ENCODING_FORCE_UINT32:
    _DISPLAYCONFIG_COLOR_ENCODING = -1;
pub type _DISPLAYCONFIG_COLOR_ENCODING = ::std::os::raw::c_int;
pub use self::_DISPLAYCONFIG_COLOR_ENCODING as DISPLAYCONFIG_COLOR_ENCODING;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1,
    pub colorEncoding: DISPLAYCONFIG_COLOR_ENCODING,
    pub bitsPerColorChannel: UINT32,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1 {
    pub __bindgen_anon_1: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn advancedColorSupported(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_advancedColorSupported(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn advancedColorSupported_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_advancedColorSupported_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn advancedColorEnabled(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_advancedColorEnabled(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn advancedColorEnabled_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_advancedColorEnabled_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn wideColorEnforced(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_wideColorEnforced(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn wideColorEnforced_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_wideColorEnforced_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn advancedColorForceDisabled(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_advancedColorForceDisabled(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn advancedColorForceDisabled_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_advancedColorForceDisabled_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 28u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 28u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                28u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                28u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        advancedColorSupported: UINT32,
        advancedColorEnabled: UINT32,
        wideColorEnforced: UINT32,
        advancedColorForceDisabled: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let advancedColorSupported: u32 =
                unsafe { ::std::mem::transmute(advancedColorSupported) };
            advancedColorSupported as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let advancedColorEnabled: u32 = unsafe { ::std::mem::transmute(advancedColorEnabled) };
            advancedColorEnabled as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let wideColorEnforced: u32 = unsafe { ::std::mem::transmute(wideColorEnforced) };
            wideColorEnforced as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let advancedColorForceDisabled: u32 =
                unsafe { ::std::mem::transmute(advancedColorForceDisabled) };
            advancedColorForceDisabled as u64
        });
        __bindgen_bitfield_unit.set(4usize, 28u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1::value"][::std::mem::offset_of!(
        _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO"]
        [::std::mem::size_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO>() - 32usize];
    ["Alignment of _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO"]
        [::std::mem::align_of::<_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO::header"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO, header) - 0usize];
    ["Offset of field: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO::colorEncoding"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO, colorEncoding) - 24usize];
    ["Offset of field: _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO::bitsPerColorChannel"][::std::mem::offset_of!(
        _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO,
        bitsPerColorChannel
    ) - 28usize];
};
pub type DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO = _DISPLAYCONFIG_GET_ADVANCED_COLOR_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1 {
    pub __bindgen_anon_1: _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
    ["Alignment of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1>(
        ) - 4usize];
};
impl _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn enableAdvancedColor(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_enableAdvancedColor(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn enableAdvancedColor_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_enableAdvancedColor_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        enableAdvancedColor: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let enableAdvancedColor: u32 = unsafe { ::std::mem::transmute(enableAdvancedColor) };
            enableAdvancedColor as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1>() - 4usize];
    ["Alignment of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1"]
        [::std::mem::align_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1::value"][::std::mem::offset_of!(
        _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE>() - 24usize];
    ["Alignment of _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE"]
        [::std::mem::align_of::<_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE::header"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE, header) - 0usize];
};
pub type DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE = _DISPLAYCONFIG_SET_ADVANCED_COLOR_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAYCONFIG_SDR_WHITE_LEVEL {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub SDRWhiteLevel: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SDR_WHITE_LEVEL"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SDR_WHITE_LEVEL>() - 24usize];
    ["Alignment of _DISPLAYCONFIG_SDR_WHITE_LEVEL"]
        [::std::mem::align_of::<_DISPLAYCONFIG_SDR_WHITE_LEVEL>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_SDR_WHITE_LEVEL::header"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_SDR_WHITE_LEVEL, header) - 0usize];
    ["Offset of field: _DISPLAYCONFIG_SDR_WHITE_LEVEL::SDRWhiteLevel"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_SDR_WHITE_LEVEL, SDRWhiteLevel) - 20usize];
};
pub type DISPLAYCONFIG_SDR_WHITE_LEVEL = _DISPLAYCONFIG_SDR_WHITE_LEVEL;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1 {
    pub __bindgen_anon_1: _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn isSpecializationEnabled(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_isSpecializationEnabled(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn isSpecializationEnabled_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_isSpecializationEnabled_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn isSpecializationAvailableForMonitor(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_isSpecializationAvailableForMonitor(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn isSpecializationAvailableForMonitor_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_isSpecializationAvailableForMonitor_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn isSpecializationAvailableForSystem(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_isSpecializationAvailableForSystem(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn isSpecializationAvailableForSystem_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_isSpecializationAvailableForSystem_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 29u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 29u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                29u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                29u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        isSpecializationEnabled: UINT32,
        isSpecializationAvailableForMonitor: UINT32,
        isSpecializationAvailableForSystem: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let isSpecializationEnabled: u32 =
                unsafe { ::std::mem::transmute(isSpecializationEnabled) };
            isSpecializationEnabled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let isSpecializationAvailableForMonitor: u32 =
                unsafe { ::std::mem::transmute(isSpecializationAvailableForMonitor) };
            isSpecializationAvailableForMonitor as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let isSpecializationAvailableForSystem: u32 =
                unsafe { ::std::mem::transmute(isSpecializationAvailableForSystem) };
            isSpecializationAvailableForSystem as u64
        });
        __bindgen_bitfield_unit.set(3usize, 29u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1"][::std::mem::align_of::<
        _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1,
    >() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1::value"][::std::mem::offset_of!(
        _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION"]
        [::std::mem::size_of::<_DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION>() - 24usize];
    ["Alignment of _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION"]
        [::std::mem::align_of::<_DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION::header"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION, header) - 0usize];
};
pub type DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION = _DISPLAYCONFIG_GET_MONITOR_SPECIALIZATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION {
    pub header: DISPLAYCONFIG_DEVICE_INFO_HEADER,
    pub __bindgen_anon_1: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1,
    pub specializationType: GUID,
    pub specializationSubType: GUID,
    pub specializationApplicationName: [WCHAR; 128usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1 {
    pub __bindgen_anon_1: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
    pub value: UINT32,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
};
impl _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn isSpecializationEnabled(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_isSpecializationEnabled(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn isSpecializationEnabled_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_isSpecializationEnabled_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> UINT32 {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> UINT32 {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: UINT32) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        isSpecializationEnabled: UINT32,
        reserved: UINT32,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let isSpecializationEnabled: u32 =
                unsafe { ::std::mem::transmute(isSpecializationEnabled) };
            isSpecializationEnabled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let reserved: u32 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1>() - 4usize];
    ["Alignment of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1"][::std::mem::align_of::<
        _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1,
    >() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1::value"][::std::mem::offset_of!(
        _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION__bindgen_ty_1,
        value
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION"]
        [::std::mem::size_of::<_DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION>() - 312usize];
    ["Alignment of _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION"]
        [::std::mem::align_of::<_DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION>() - 4usize];
    ["Offset of field: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION::header"]
        [::std::mem::offset_of!(_DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION, header) - 0usize];
    ["Offset of field: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION::specializationType"][::std::mem::offset_of!(
        _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION,
        specializationType
    ) - 24usize];
    ["Offset of field: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION::specializationSubType"][::std::mem::offset_of!(
        _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION,
        specializationSubType
    )
        - 40usize];
    ["Offset of field: _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION::specializationApplicationName"][::std::mem::offset_of!(
        _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION,
        specializationApplicationName
    )
        - 56usize];
};
pub type DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION = _DISPLAYCONFIG_SET_MONITOR_SPECIALIZATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RGNDATAHEADER {
    pub dwSize: DWORD,
    pub iType: DWORD,
    pub nCount: DWORD,
    pub nRgnSize: DWORD,
    pub rcBound: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RGNDATAHEADER"][::std::mem::size_of::<_RGNDATAHEADER>() - 32usize];
    ["Alignment of _RGNDATAHEADER"][::std::mem::align_of::<_RGNDATAHEADER>() - 4usize];
    ["Offset of field: _RGNDATAHEADER::dwSize"]
        [::std::mem::offset_of!(_RGNDATAHEADER, dwSize) - 0usize];
    ["Offset of field: _RGNDATAHEADER::iType"]
        [::std::mem::offset_of!(_RGNDATAHEADER, iType) - 4usize];
    ["Offset of field: _RGNDATAHEADER::nCount"]
        [::std::mem::offset_of!(_RGNDATAHEADER, nCount) - 8usize];
    ["Offset of field: _RGNDATAHEADER::nRgnSize"]
        [::std::mem::offset_of!(_RGNDATAHEADER, nRgnSize) - 12usize];
    ["Offset of field: _RGNDATAHEADER::rcBound"]
        [::std::mem::offset_of!(_RGNDATAHEADER, rcBound) - 16usize];
};
pub type RGNDATAHEADER = _RGNDATAHEADER;
pub type PRGNDATAHEADER = *mut _RGNDATAHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RGNDATA {
    pub rdh: RGNDATAHEADER,
    pub Buffer: [::std::os::raw::c_char; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RGNDATA"][::std::mem::size_of::<_RGNDATA>() - 36usize];
    ["Alignment of _RGNDATA"][::std::mem::align_of::<_RGNDATA>() - 4usize];
    ["Offset of field: _RGNDATA::rdh"][::std::mem::offset_of!(_RGNDATA, rdh) - 0usize];
    ["Offset of field: _RGNDATA::Buffer"][::std::mem::offset_of!(_RGNDATA, Buffer) - 32usize];
};
pub type RGNDATA = _RGNDATA;
pub type PRGNDATA = *mut _RGNDATA;
pub type NPRGNDATA = *mut _RGNDATA;
pub type LPRGNDATA = *mut _RGNDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ABC {
    pub abcA: ::std::os::raw::c_int,
    pub abcB: UINT,
    pub abcC: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ABC"][::std::mem::size_of::<_ABC>() - 12usize];
    ["Alignment of _ABC"][::std::mem::align_of::<_ABC>() - 4usize];
    ["Offset of field: _ABC::abcA"][::std::mem::offset_of!(_ABC, abcA) - 0usize];
    ["Offset of field: _ABC::abcB"][::std::mem::offset_of!(_ABC, abcB) - 4usize];
    ["Offset of field: _ABC::abcC"][::std::mem::offset_of!(_ABC, abcC) - 8usize];
};
pub type ABC = _ABC;
pub type PABC = *mut _ABC;
pub type NPABC = *mut _ABC;
pub type LPABC = *mut _ABC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ABCFLOAT {
    pub abcfA: FLOAT,
    pub abcfB: FLOAT,
    pub abcfC: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ABCFLOAT"][::std::mem::size_of::<_ABCFLOAT>() - 12usize];
    ["Alignment of _ABCFLOAT"][::std::mem::align_of::<_ABCFLOAT>() - 4usize];
    ["Offset of field: _ABCFLOAT::abcfA"][::std::mem::offset_of!(_ABCFLOAT, abcfA) - 0usize];
    ["Offset of field: _ABCFLOAT::abcfB"][::std::mem::offset_of!(_ABCFLOAT, abcfB) - 4usize];
    ["Offset of field: _ABCFLOAT::abcfC"][::std::mem::offset_of!(_ABCFLOAT, abcfC) - 8usize];
};
pub type ABCFLOAT = _ABCFLOAT;
pub type PABCFLOAT = *mut _ABCFLOAT;
pub type NPABCFLOAT = *mut _ABCFLOAT;
pub type LPABCFLOAT = *mut _ABCFLOAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OUTLINETEXTMETRICA {
    pub otmSize: UINT,
    pub otmTextMetrics: TEXTMETRICA,
    pub otmFiller: BYTE,
    pub otmPanoseNumber: PANOSE,
    pub otmfsSelection: UINT,
    pub otmfsType: UINT,
    pub otmsCharSlopeRise: ::std::os::raw::c_int,
    pub otmsCharSlopeRun: ::std::os::raw::c_int,
    pub otmItalicAngle: ::std::os::raw::c_int,
    pub otmEMSquare: UINT,
    pub otmAscent: ::std::os::raw::c_int,
    pub otmDescent: ::std::os::raw::c_int,
    pub otmLineGap: UINT,
    pub otmsCapEmHeight: UINT,
    pub otmsXHeight: UINT,
    pub otmrcFontBox: RECT,
    pub otmMacAscent: ::std::os::raw::c_int,
    pub otmMacDescent: ::std::os::raw::c_int,
    pub otmMacLineGap: UINT,
    pub otmusMinimumPPEM: UINT,
    pub otmptSubscriptSize: POINT,
    pub otmptSubscriptOffset: POINT,
    pub otmptSuperscriptSize: POINT,
    pub otmptSuperscriptOffset: POINT,
    pub otmsStrikeoutSize: UINT,
    pub otmsStrikeoutPosition: ::std::os::raw::c_int,
    pub otmsUnderscoreSize: ::std::os::raw::c_int,
    pub otmsUnderscorePosition: ::std::os::raw::c_int,
    pub otmpFamilyName: PSTR,
    pub otmpFaceName: PSTR,
    pub otmpStyleName: PSTR,
    pub otmpFullName: PSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OUTLINETEXTMETRICA"][::std::mem::size_of::<_OUTLINETEXTMETRICA>() - 232usize];
    ["Alignment of _OUTLINETEXTMETRICA"][::std::mem::align_of::<_OUTLINETEXTMETRICA>() - 8usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmSize) - 0usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmTextMetrics"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmTextMetrics) - 4usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmFiller"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmFiller) - 60usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmPanoseNumber"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmPanoseNumber) - 61usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmfsSelection"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmfsSelection) - 72usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmfsType"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmfsType) - 76usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsCharSlopeRise"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsCharSlopeRise) - 80usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsCharSlopeRun"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsCharSlopeRun) - 84usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmItalicAngle"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmItalicAngle) - 88usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmEMSquare"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmEMSquare) - 92usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmAscent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmAscent) - 96usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmDescent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmDescent) - 100usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmLineGap"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmLineGap) - 104usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsCapEmHeight"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsCapEmHeight) - 108usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsXHeight"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsXHeight) - 112usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmrcFontBox"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmrcFontBox) - 116usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmMacAscent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmMacAscent) - 132usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmMacDescent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmMacDescent) - 136usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmMacLineGap"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmMacLineGap) - 140usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmusMinimumPPEM"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmusMinimumPPEM) - 144usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmptSubscriptSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmptSubscriptSize) - 148usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmptSubscriptOffset"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmptSubscriptOffset) - 156usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmptSuperscriptSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmptSuperscriptSize) - 164usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmptSuperscriptOffset"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmptSuperscriptOffset) - 172usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsStrikeoutSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsStrikeoutSize) - 180usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsStrikeoutPosition"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsStrikeoutPosition) - 184usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsUnderscoreSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsUnderscoreSize) - 188usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmsUnderscorePosition"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmsUnderscorePosition) - 192usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmpFamilyName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmpFamilyName) - 200usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmpFaceName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmpFaceName) - 208usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmpStyleName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmpStyleName) - 216usize];
    ["Offset of field: _OUTLINETEXTMETRICA::otmpFullName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICA, otmpFullName) - 224usize];
};
pub type OUTLINETEXTMETRICA = _OUTLINETEXTMETRICA;
pub type POUTLINETEXTMETRICA = *mut _OUTLINETEXTMETRICA;
pub type NPOUTLINETEXTMETRICA = *mut _OUTLINETEXTMETRICA;
pub type LPOUTLINETEXTMETRICA = *mut _OUTLINETEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OUTLINETEXTMETRICW {
    pub otmSize: UINT,
    pub otmTextMetrics: TEXTMETRICW,
    pub otmFiller: BYTE,
    pub otmPanoseNumber: PANOSE,
    pub otmfsSelection: UINT,
    pub otmfsType: UINT,
    pub otmsCharSlopeRise: ::std::os::raw::c_int,
    pub otmsCharSlopeRun: ::std::os::raw::c_int,
    pub otmItalicAngle: ::std::os::raw::c_int,
    pub otmEMSquare: UINT,
    pub otmAscent: ::std::os::raw::c_int,
    pub otmDescent: ::std::os::raw::c_int,
    pub otmLineGap: UINT,
    pub otmsCapEmHeight: UINT,
    pub otmsXHeight: UINT,
    pub otmrcFontBox: RECT,
    pub otmMacAscent: ::std::os::raw::c_int,
    pub otmMacDescent: ::std::os::raw::c_int,
    pub otmMacLineGap: UINT,
    pub otmusMinimumPPEM: UINT,
    pub otmptSubscriptSize: POINT,
    pub otmptSubscriptOffset: POINT,
    pub otmptSuperscriptSize: POINT,
    pub otmptSuperscriptOffset: POINT,
    pub otmsStrikeoutSize: UINT,
    pub otmsStrikeoutPosition: ::std::os::raw::c_int,
    pub otmsUnderscoreSize: ::std::os::raw::c_int,
    pub otmsUnderscorePosition: ::std::os::raw::c_int,
    pub otmpFamilyName: PSTR,
    pub otmpFaceName: PSTR,
    pub otmpStyleName: PSTR,
    pub otmpFullName: PSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OUTLINETEXTMETRICW"][::std::mem::size_of::<_OUTLINETEXTMETRICW>() - 232usize];
    ["Alignment of _OUTLINETEXTMETRICW"][::std::mem::align_of::<_OUTLINETEXTMETRICW>() - 8usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmSize) - 0usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmTextMetrics"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmTextMetrics) - 4usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmFiller"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmFiller) - 64usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmPanoseNumber"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmPanoseNumber) - 65usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmfsSelection"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmfsSelection) - 76usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmfsType"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmfsType) - 80usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsCharSlopeRise"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsCharSlopeRise) - 84usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsCharSlopeRun"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsCharSlopeRun) - 88usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmItalicAngle"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmItalicAngle) - 92usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmEMSquare"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmEMSquare) - 96usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmAscent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmAscent) - 100usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmDescent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmDescent) - 104usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmLineGap"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmLineGap) - 108usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsCapEmHeight"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsCapEmHeight) - 112usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsXHeight"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsXHeight) - 116usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmrcFontBox"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmrcFontBox) - 120usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmMacAscent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmMacAscent) - 136usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmMacDescent"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmMacDescent) - 140usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmMacLineGap"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmMacLineGap) - 144usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmusMinimumPPEM"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmusMinimumPPEM) - 148usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmptSubscriptSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmptSubscriptSize) - 152usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmptSubscriptOffset"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmptSubscriptOffset) - 160usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmptSuperscriptSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmptSuperscriptSize) - 168usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmptSuperscriptOffset"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmptSuperscriptOffset) - 176usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsStrikeoutSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsStrikeoutSize) - 184usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsStrikeoutPosition"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsStrikeoutPosition) - 188usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsUnderscoreSize"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsUnderscoreSize) - 192usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmsUnderscorePosition"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmsUnderscorePosition) - 196usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmpFamilyName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmpFamilyName) - 200usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmpFaceName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmpFaceName) - 208usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmpStyleName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmpStyleName) - 216usize];
    ["Offset of field: _OUTLINETEXTMETRICW::otmpFullName"]
        [::std::mem::offset_of!(_OUTLINETEXTMETRICW, otmpFullName) - 224usize];
};
pub type OUTLINETEXTMETRICW = _OUTLINETEXTMETRICW;
pub type POUTLINETEXTMETRICW = *mut _OUTLINETEXTMETRICW;
pub type NPOUTLINETEXTMETRICW = *mut _OUTLINETEXTMETRICW;
pub type LPOUTLINETEXTMETRICW = *mut _OUTLINETEXTMETRICW;
pub type OUTLINETEXTMETRIC = OUTLINETEXTMETRICA;
pub type POUTLINETEXTMETRIC = POUTLINETEXTMETRICA;
pub type NPOUTLINETEXTMETRIC = NPOUTLINETEXTMETRICA;
pub type LPOUTLINETEXTMETRIC = LPOUTLINETEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOLYTEXTA {
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub n: UINT,
    pub lpstr: LPCSTR,
    pub uiFlags: UINT,
    pub rcl: RECT,
    pub pdx: *mut ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOLYTEXTA"][::std::mem::size_of::<tagPOLYTEXTA>() - 56usize];
    ["Alignment of tagPOLYTEXTA"][::std::mem::align_of::<tagPOLYTEXTA>() - 8usize];
    ["Offset of field: tagPOLYTEXTA::x"][::std::mem::offset_of!(tagPOLYTEXTA, x) - 0usize];
    ["Offset of field: tagPOLYTEXTA::y"][::std::mem::offset_of!(tagPOLYTEXTA, y) - 4usize];
    ["Offset of field: tagPOLYTEXTA::n"][::std::mem::offset_of!(tagPOLYTEXTA, n) - 8usize];
    ["Offset of field: tagPOLYTEXTA::lpstr"][::std::mem::offset_of!(tagPOLYTEXTA, lpstr) - 16usize];
    ["Offset of field: tagPOLYTEXTA::uiFlags"]
        [::std::mem::offset_of!(tagPOLYTEXTA, uiFlags) - 24usize];
    ["Offset of field: tagPOLYTEXTA::rcl"][::std::mem::offset_of!(tagPOLYTEXTA, rcl) - 28usize];
    ["Offset of field: tagPOLYTEXTA::pdx"][::std::mem::offset_of!(tagPOLYTEXTA, pdx) - 48usize];
};
pub type POLYTEXTA = tagPOLYTEXTA;
pub type PPOLYTEXTA = *mut tagPOLYTEXTA;
pub type NPPOLYTEXTA = *mut tagPOLYTEXTA;
pub type LPPOLYTEXTA = *mut tagPOLYTEXTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOLYTEXTW {
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub n: UINT,
    pub lpstr: LPCWSTR,
    pub uiFlags: UINT,
    pub rcl: RECT,
    pub pdx: *mut ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOLYTEXTW"][::std::mem::size_of::<tagPOLYTEXTW>() - 56usize];
    ["Alignment of tagPOLYTEXTW"][::std::mem::align_of::<tagPOLYTEXTW>() - 8usize];
    ["Offset of field: tagPOLYTEXTW::x"][::std::mem::offset_of!(tagPOLYTEXTW, x) - 0usize];
    ["Offset of field: tagPOLYTEXTW::y"][::std::mem::offset_of!(tagPOLYTEXTW, y) - 4usize];
    ["Offset of field: tagPOLYTEXTW::n"][::std::mem::offset_of!(tagPOLYTEXTW, n) - 8usize];
    ["Offset of field: tagPOLYTEXTW::lpstr"][::std::mem::offset_of!(tagPOLYTEXTW, lpstr) - 16usize];
    ["Offset of field: tagPOLYTEXTW::uiFlags"]
        [::std::mem::offset_of!(tagPOLYTEXTW, uiFlags) - 24usize];
    ["Offset of field: tagPOLYTEXTW::rcl"][::std::mem::offset_of!(tagPOLYTEXTW, rcl) - 28usize];
    ["Offset of field: tagPOLYTEXTW::pdx"][::std::mem::offset_of!(tagPOLYTEXTW, pdx) - 48usize];
};
pub type POLYTEXTW = tagPOLYTEXTW;
pub type PPOLYTEXTW = *mut tagPOLYTEXTW;
pub type NPPOLYTEXTW = *mut tagPOLYTEXTW;
pub type LPPOLYTEXTW = *mut tagPOLYTEXTW;
pub type POLYTEXT = POLYTEXTA;
pub type PPOLYTEXT = PPOLYTEXTA;
pub type NPPOLYTEXT = NPPOLYTEXTA;
pub type LPPOLYTEXT = LPPOLYTEXTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FIXED {
    pub fract: WORD,
    pub value: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FIXED"][::std::mem::size_of::<_FIXED>() - 4usize];
    ["Alignment of _FIXED"][::std::mem::align_of::<_FIXED>() - 2usize];
    ["Offset of field: _FIXED::fract"][::std::mem::offset_of!(_FIXED, fract) - 0usize];
    ["Offset of field: _FIXED::value"][::std::mem::offset_of!(_FIXED, value) - 2usize];
};
pub type FIXED = _FIXED;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MAT2 {
    pub eM11: FIXED,
    pub eM12: FIXED,
    pub eM21: FIXED,
    pub eM22: FIXED,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MAT2"][::std::mem::size_of::<_MAT2>() - 16usize];
    ["Alignment of _MAT2"][::std::mem::align_of::<_MAT2>() - 2usize];
    ["Offset of field: _MAT2::eM11"][::std::mem::offset_of!(_MAT2, eM11) - 0usize];
    ["Offset of field: _MAT2::eM12"][::std::mem::offset_of!(_MAT2, eM12) - 4usize];
    ["Offset of field: _MAT2::eM21"][::std::mem::offset_of!(_MAT2, eM21) - 8usize];
    ["Offset of field: _MAT2::eM22"][::std::mem::offset_of!(_MAT2, eM22) - 12usize];
};
pub type MAT2 = _MAT2;
pub type LPMAT2 = *mut _MAT2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GLYPHMETRICS {
    pub gmBlackBoxX: UINT,
    pub gmBlackBoxY: UINT,
    pub gmptGlyphOrigin: POINT,
    pub gmCellIncX: ::std::os::raw::c_short,
    pub gmCellIncY: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GLYPHMETRICS"][::std::mem::size_of::<_GLYPHMETRICS>() - 20usize];
    ["Alignment of _GLYPHMETRICS"][::std::mem::align_of::<_GLYPHMETRICS>() - 4usize];
    ["Offset of field: _GLYPHMETRICS::gmBlackBoxX"]
        [::std::mem::offset_of!(_GLYPHMETRICS, gmBlackBoxX) - 0usize];
    ["Offset of field: _GLYPHMETRICS::gmBlackBoxY"]
        [::std::mem::offset_of!(_GLYPHMETRICS, gmBlackBoxY) - 4usize];
    ["Offset of field: _GLYPHMETRICS::gmptGlyphOrigin"]
        [::std::mem::offset_of!(_GLYPHMETRICS, gmptGlyphOrigin) - 8usize];
    ["Offset of field: _GLYPHMETRICS::gmCellIncX"]
        [::std::mem::offset_of!(_GLYPHMETRICS, gmCellIncX) - 16usize];
    ["Offset of field: _GLYPHMETRICS::gmCellIncY"]
        [::std::mem::offset_of!(_GLYPHMETRICS, gmCellIncY) - 18usize];
};
pub type GLYPHMETRICS = _GLYPHMETRICS;
pub type LPGLYPHMETRICS = *mut _GLYPHMETRICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTFX {
    pub x: FIXED,
    pub y: FIXED,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTFX"][::std::mem::size_of::<tagPOINTFX>() - 8usize];
    ["Alignment of tagPOINTFX"][::std::mem::align_of::<tagPOINTFX>() - 2usize];
    ["Offset of field: tagPOINTFX::x"][::std::mem::offset_of!(tagPOINTFX, x) - 0usize];
    ["Offset of field: tagPOINTFX::y"][::std::mem::offset_of!(tagPOINTFX, y) - 4usize];
};
pub type POINTFX = tagPOINTFX;
pub type LPPOINTFX = *mut tagPOINTFX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTTPOLYCURVE {
    pub wType: WORD,
    pub cpfx: WORD,
    pub apfx: [POINTFX; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTTPOLYCURVE"][::std::mem::size_of::<tagTTPOLYCURVE>() - 12usize];
    ["Alignment of tagTTPOLYCURVE"][::std::mem::align_of::<tagTTPOLYCURVE>() - 2usize];
    ["Offset of field: tagTTPOLYCURVE::wType"]
        [::std::mem::offset_of!(tagTTPOLYCURVE, wType) - 0usize];
    ["Offset of field: tagTTPOLYCURVE::cpfx"]
        [::std::mem::offset_of!(tagTTPOLYCURVE, cpfx) - 2usize];
    ["Offset of field: tagTTPOLYCURVE::apfx"]
        [::std::mem::offset_of!(tagTTPOLYCURVE, apfx) - 4usize];
};
pub type TTPOLYCURVE = tagTTPOLYCURVE;
pub type LPTTPOLYCURVE = *mut tagTTPOLYCURVE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTTPOLYGONHEADER {
    pub cb: DWORD,
    pub dwType: DWORD,
    pub pfxStart: POINTFX,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTTPOLYGONHEADER"][::std::mem::size_of::<tagTTPOLYGONHEADER>() - 16usize];
    ["Alignment of tagTTPOLYGONHEADER"][::std::mem::align_of::<tagTTPOLYGONHEADER>() - 4usize];
    ["Offset of field: tagTTPOLYGONHEADER::cb"]
        [::std::mem::offset_of!(tagTTPOLYGONHEADER, cb) - 0usize];
    ["Offset of field: tagTTPOLYGONHEADER::dwType"]
        [::std::mem::offset_of!(tagTTPOLYGONHEADER, dwType) - 4usize];
    ["Offset of field: tagTTPOLYGONHEADER::pfxStart"]
        [::std::mem::offset_of!(tagTTPOLYGONHEADER, pfxStart) - 8usize];
};
pub type TTPOLYGONHEADER = tagTTPOLYGONHEADER;
pub type LPTTPOLYGONHEADER = *mut tagTTPOLYGONHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGCP_RESULTSA {
    pub lStructSize: DWORD,
    pub lpOutString: LPSTR,
    pub lpOrder: *mut UINT,
    pub lpDx: *mut ::std::os::raw::c_int,
    pub lpCaretPos: *mut ::std::os::raw::c_int,
    pub lpClass: LPSTR,
    pub lpGlyphs: LPWSTR,
    pub nGlyphs: UINT,
    pub nMaxFit: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGCP_RESULTSA"][::std::mem::size_of::<tagGCP_RESULTSA>() - 64usize];
    ["Alignment of tagGCP_RESULTSA"][::std::mem::align_of::<tagGCP_RESULTSA>() - 8usize];
    ["Offset of field: tagGCP_RESULTSA::lStructSize"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lStructSize) - 0usize];
    ["Offset of field: tagGCP_RESULTSA::lpOutString"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpOutString) - 8usize];
    ["Offset of field: tagGCP_RESULTSA::lpOrder"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpOrder) - 16usize];
    ["Offset of field: tagGCP_RESULTSA::lpDx"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpDx) - 24usize];
    ["Offset of field: tagGCP_RESULTSA::lpCaretPos"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpCaretPos) - 32usize];
    ["Offset of field: tagGCP_RESULTSA::lpClass"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpClass) - 40usize];
    ["Offset of field: tagGCP_RESULTSA::lpGlyphs"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, lpGlyphs) - 48usize];
    ["Offset of field: tagGCP_RESULTSA::nGlyphs"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, nGlyphs) - 56usize];
    ["Offset of field: tagGCP_RESULTSA::nMaxFit"]
        [::std::mem::offset_of!(tagGCP_RESULTSA, nMaxFit) - 60usize];
};
pub type GCP_RESULTSA = tagGCP_RESULTSA;
pub type LPGCP_RESULTSA = *mut tagGCP_RESULTSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGCP_RESULTSW {
    pub lStructSize: DWORD,
    pub lpOutString: LPWSTR,
    pub lpOrder: *mut UINT,
    pub lpDx: *mut ::std::os::raw::c_int,
    pub lpCaretPos: *mut ::std::os::raw::c_int,
    pub lpClass: LPSTR,
    pub lpGlyphs: LPWSTR,
    pub nGlyphs: UINT,
    pub nMaxFit: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGCP_RESULTSW"][::std::mem::size_of::<tagGCP_RESULTSW>() - 64usize];
    ["Alignment of tagGCP_RESULTSW"][::std::mem::align_of::<tagGCP_RESULTSW>() - 8usize];
    ["Offset of field: tagGCP_RESULTSW::lStructSize"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lStructSize) - 0usize];
    ["Offset of field: tagGCP_RESULTSW::lpOutString"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpOutString) - 8usize];
    ["Offset of field: tagGCP_RESULTSW::lpOrder"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpOrder) - 16usize];
    ["Offset of field: tagGCP_RESULTSW::lpDx"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpDx) - 24usize];
    ["Offset of field: tagGCP_RESULTSW::lpCaretPos"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpCaretPos) - 32usize];
    ["Offset of field: tagGCP_RESULTSW::lpClass"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpClass) - 40usize];
    ["Offset of field: tagGCP_RESULTSW::lpGlyphs"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, lpGlyphs) - 48usize];
    ["Offset of field: tagGCP_RESULTSW::nGlyphs"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, nGlyphs) - 56usize];
    ["Offset of field: tagGCP_RESULTSW::nMaxFit"]
        [::std::mem::offset_of!(tagGCP_RESULTSW, nMaxFit) - 60usize];
};
pub type GCP_RESULTSW = tagGCP_RESULTSW;
pub type LPGCP_RESULTSW = *mut tagGCP_RESULTSW;
pub type GCP_RESULTS = GCP_RESULTSA;
pub type LPGCP_RESULTS = LPGCP_RESULTSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RASTERIZER_STATUS {
    pub nSize: ::std::os::raw::c_short,
    pub wFlags: ::std::os::raw::c_short,
    pub nLanguageID: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RASTERIZER_STATUS"][::std::mem::size_of::<_RASTERIZER_STATUS>() - 6usize];
    ["Alignment of _RASTERIZER_STATUS"][::std::mem::align_of::<_RASTERIZER_STATUS>() - 2usize];
    ["Offset of field: _RASTERIZER_STATUS::nSize"]
        [::std::mem::offset_of!(_RASTERIZER_STATUS, nSize) - 0usize];
    ["Offset of field: _RASTERIZER_STATUS::wFlags"]
        [::std::mem::offset_of!(_RASTERIZER_STATUS, wFlags) - 2usize];
    ["Offset of field: _RASTERIZER_STATUS::nLanguageID"]
        [::std::mem::offset_of!(_RASTERIZER_STATUS, nLanguageID) - 4usize];
};
pub type RASTERIZER_STATUS = _RASTERIZER_STATUS;
pub type LPRASTERIZER_STATUS = *mut _RASTERIZER_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPIXELFORMATDESCRIPTOR {
    pub nSize: WORD,
    pub nVersion: WORD,
    pub dwFlags: DWORD,
    pub iPixelType: BYTE,
    pub cColorBits: BYTE,
    pub cRedBits: BYTE,
    pub cRedShift: BYTE,
    pub cGreenBits: BYTE,
    pub cGreenShift: BYTE,
    pub cBlueBits: BYTE,
    pub cBlueShift: BYTE,
    pub cAlphaBits: BYTE,
    pub cAlphaShift: BYTE,
    pub cAccumBits: BYTE,
    pub cAccumRedBits: BYTE,
    pub cAccumGreenBits: BYTE,
    pub cAccumBlueBits: BYTE,
    pub cAccumAlphaBits: BYTE,
    pub cDepthBits: BYTE,
    pub cStencilBits: BYTE,
    pub cAuxBuffers: BYTE,
    pub iLayerType: BYTE,
    pub bReserved: BYTE,
    pub dwLayerMask: DWORD,
    pub dwVisibleMask: DWORD,
    pub dwDamageMask: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPIXELFORMATDESCRIPTOR"]
        [::std::mem::size_of::<tagPIXELFORMATDESCRIPTOR>() - 40usize];
    ["Alignment of tagPIXELFORMATDESCRIPTOR"]
        [::std::mem::align_of::<tagPIXELFORMATDESCRIPTOR>() - 4usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::nSize"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, nSize) - 0usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::nVersion"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, nVersion) - 2usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::dwFlags"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, dwFlags) - 4usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::iPixelType"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, iPixelType) - 8usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cColorBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cColorBits) - 9usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cRedBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cRedBits) - 10usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cRedShift"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cRedShift) - 11usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cGreenBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cGreenBits) - 12usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cGreenShift"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cGreenShift) - 13usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cBlueBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cBlueBits) - 14usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cBlueShift"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cBlueShift) - 15usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAlphaBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAlphaBits) - 16usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAlphaShift"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAlphaShift) - 17usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAccumBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAccumBits) - 18usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAccumRedBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAccumRedBits) - 19usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAccumGreenBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAccumGreenBits) - 20usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAccumBlueBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAccumBlueBits) - 21usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAccumAlphaBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAccumAlphaBits) - 22usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cDepthBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cDepthBits) - 23usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cStencilBits"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cStencilBits) - 24usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::cAuxBuffers"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, cAuxBuffers) - 25usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::iLayerType"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, iLayerType) - 26usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::bReserved"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, bReserved) - 27usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::dwLayerMask"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, dwLayerMask) - 28usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::dwVisibleMask"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, dwVisibleMask) - 32usize];
    ["Offset of field: tagPIXELFORMATDESCRIPTOR::dwDamageMask"]
        [::std::mem::offset_of!(tagPIXELFORMATDESCRIPTOR, dwDamageMask) - 36usize];
};
pub type PIXELFORMATDESCRIPTOR = tagPIXELFORMATDESCRIPTOR;
pub type PPIXELFORMATDESCRIPTOR = *mut tagPIXELFORMATDESCRIPTOR;
pub type LPPIXELFORMATDESCRIPTOR = *mut tagPIXELFORMATDESCRIPTOR;
pub type OLDFONTENUMPROCA = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *const LOGFONTA,
        arg2: *const TEXTMETRICA,
        arg3: DWORD,
        arg4: LPARAM,
    ) -> ::std::os::raw::c_int,
>;
pub type OLDFONTENUMPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *const LOGFONTW,
        arg2: *const TEXTMETRICW,
        arg3: DWORD,
        arg4: LPARAM,
    ) -> ::std::os::raw::c_int,
>;
pub type FONTENUMPROCA = OLDFONTENUMPROCA;
pub type FONTENUMPROCW = OLDFONTENUMPROCW;
pub type FONTENUMPROC = FONTENUMPROCA;
pub type GOBJENUMPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: LPVOID, arg2: LPARAM) -> ::std::os::raw::c_int,
>;
pub type LINEDDAPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: ::std::os::raw::c_int, arg2: ::std::os::raw::c_int, arg3: LPARAM),
>;
unsafe extern "C" {
    pub fn AddFontResourceA(arg1: LPCSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn AddFontResourceW(arg1: LPCWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn AnimatePalette(
        hPal: HPALETTE,
        iStartIndex: UINT,
        cEntries: UINT,
        ppe: *const PALETTEENTRY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn Arc(
        hdc: HDC,
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        x2: ::std::os::raw::c_int,
        y2: ::std::os::raw::c_int,
        x3: ::std::os::raw::c_int,
        y3: ::std::os::raw::c_int,
        x4: ::std::os::raw::c_int,
        y4: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BitBlt(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        hdcSrc: HDC,
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        rop: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CancelDC(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn Chord(
        hdc: HDC,
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        x2: ::std::os::raw::c_int,
        y2: ::std::os::raw::c_int,
        x3: ::std::os::raw::c_int,
        y3: ::std::os::raw::c_int,
        x4: ::std::os::raw::c_int,
        y4: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChoosePixelFormat(hdc: HDC, ppfd: *const PIXELFORMATDESCRIPTOR)
        -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CloseMetaFile(hdc: HDC) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn CombineRgn(
        hrgnDst: HRGN,
        hrgnSrc1: HRGN,
        hrgnSrc2: HRGN,
        iMode: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CopyMetaFileA(arg1: HMETAFILE, arg2: LPCSTR) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn CopyMetaFileW(arg1: HMETAFILE, arg2: LPCWSTR) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn CreateBitmap(
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        nPlanes: UINT,
        nBitCount: UINT,
        lpBits: *const ::std::os::raw::c_void,
    ) -> HBITMAP;
}
unsafe extern "C" {
    pub fn CreateBitmapIndirect(pbm: *const BITMAP) -> HBITMAP;
}
unsafe extern "C" {
    pub fn CreateBrushIndirect(plbrush: *const LOGBRUSH) -> HBRUSH;
}
unsafe extern "C" {
    pub fn CreateCompatibleBitmap(
        hdc: HDC,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
    ) -> HBITMAP;
}
unsafe extern "C" {
    pub fn CreateDiscardableBitmap(
        hdc: HDC,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
    ) -> HBITMAP;
}
unsafe extern "C" {
    pub fn CreateCompatibleDC(hdc: HDC) -> HDC;
}
unsafe extern "C" {
    pub fn CreateDCA(
        pwszDriver: LPCSTR,
        pwszDevice: LPCSTR,
        pszPort: LPCSTR,
        pdm: *const DEVMODEA,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn CreateDCW(
        pwszDriver: LPCWSTR,
        pwszDevice: LPCWSTR,
        pszPort: LPCWSTR,
        pdm: *const DEVMODEW,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn CreateDIBitmap(
        hdc: HDC,
        pbmih: *const BITMAPINFOHEADER,
        flInit: DWORD,
        pjBits: *const ::std::os::raw::c_void,
        pbmi: *const BITMAPINFO,
        iUsage: UINT,
    ) -> HBITMAP;
}
unsafe extern "C" {
    pub fn CreateDIBPatternBrush(h: HGLOBAL, iUsage: UINT) -> HBRUSH;
}
unsafe extern "C" {
    pub fn CreateDIBPatternBrushPt(
        lpPackedDIB: *const ::std::os::raw::c_void,
        iUsage: UINT,
    ) -> HBRUSH;
}
unsafe extern "C" {
    pub fn CreateEllipticRgn(
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        x2: ::std::os::raw::c_int,
        y2: ::std::os::raw::c_int,
    ) -> HRGN;
}
unsafe extern "C" {
    pub fn CreateEllipticRgnIndirect(lprect: *const RECT) -> HRGN;
}
unsafe extern "C" {
    pub fn CreateFontIndirectA(lplf: *const LOGFONTA) -> HFONT;
}
unsafe extern "C" {
    pub fn CreateFontIndirectW(lplf: *const LOGFONTW) -> HFONT;
}
unsafe extern "C" {
    pub fn CreateFontA(
        cHeight: ::std::os::raw::c_int,
        cWidth: ::std::os::raw::c_int,
        cEscapement: ::std::os::raw::c_int,
        cOrientation: ::std::os::raw::c_int,
        cWeight: ::std::os::raw::c_int,
        bItalic: DWORD,
        bUnderline: DWORD,
        bStrikeOut: DWORD,
        iCharSet: DWORD,
        iOutPrecision: DWORD,
        iClipPrecision: DWORD,
        iQuality: DWORD,
        iPitchAndFamily: DWORD,
        pszFaceName: LPCSTR,
    ) -> HFONT;
}
unsafe extern "C" {
    pub fn CreateFontW(
        cHeight: ::std::os::raw::c_int,
        cWidth: ::std::os::raw::c_int,
        cEscapement: ::std::os::raw::c_int,
        cOrientation: ::std::os::raw::c_int,
        cWeight: ::std::os::raw::c_int,
        bItalic: DWORD,
        bUnderline: DWORD,
        bStrikeOut: DWORD,
        iCharSet: DWORD,
        iOutPrecision: DWORD,
        iClipPrecision: DWORD,
        iQuality: DWORD,
        iPitchAndFamily: DWORD,
        pszFaceName: LPCWSTR,
    ) -> HFONT;
}
unsafe extern "C" {
    pub fn CreateHatchBrush(iHatch: ::std::os::raw::c_int, color: COLORREF) -> HBRUSH;
}
unsafe extern "C" {
    pub fn CreateICA(
        pszDriver: LPCSTR,
        pszDevice: LPCSTR,
        pszPort: LPCSTR,
        pdm: *const DEVMODEA,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn CreateICW(
        pszDriver: LPCWSTR,
        pszDevice: LPCWSTR,
        pszPort: LPCWSTR,
        pdm: *const DEVMODEW,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn CreateMetaFileA(pszFile: LPCSTR) -> HDC;
}
unsafe extern "C" {
    pub fn CreateMetaFileW(pszFile: LPCWSTR) -> HDC;
}
unsafe extern "C" {
    pub fn CreatePalette(plpal: *const LOGPALETTE) -> HPALETTE;
}
unsafe extern "C" {
    pub fn CreatePen(
        iStyle: ::std::os::raw::c_int,
        cWidth: ::std::os::raw::c_int,
        color: COLORREF,
    ) -> HPEN;
}
unsafe extern "C" {
    pub fn CreatePenIndirect(plpen: *const LOGPEN) -> HPEN;
}
unsafe extern "C" {
    pub fn CreatePolyPolygonRgn(
        pptl: *const POINT,
        pc: *const INT,
        cPoly: ::std::os::raw::c_int,
        iMode: ::std::os::raw::c_int,
    ) -> HRGN;
}
unsafe extern "C" {
    pub fn CreatePatternBrush(hbm: HBITMAP) -> HBRUSH;
}
unsafe extern "C" {
    pub fn CreateRectRgn(
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        x2: ::std::os::raw::c_int,
        y2: ::std::os::raw::c_int,
    ) -> HRGN;
}
unsafe extern "C" {
    pub fn CreateRectRgnIndirect(lprect: *const RECT) -> HRGN;
}
unsafe extern "C" {
    pub fn CreateRoundRectRgn(
        x1: ::std::os::raw::c_int,
        y1: ::std::os::raw::c_int,
        x2: ::std::os::raw::c_int,
        y2: ::std::os::raw::c_int,
        w: ::std::os::raw::c_int,
        h: ::std::os::raw::c_int,
    ) -> HRGN;
}
unsafe extern "C" {
    pub fn CreateScalableFontResourceA(
        fdwHidden: DWORD,
        lpszFont: LPCSTR,
        lpszFile: LPCSTR,
        lpszPath: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateScalableFontResourceW(
        fdwHidden: DWORD,
        lpszFont: LPCWSTR,
        lpszFile: LPCWSTR,
        lpszPath: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateSolidBrush(color: COLORREF) -> HBRUSH;
}
unsafe extern "C" {
    pub fn DeleteDC(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteMetaFile(hmf: HMETAFILE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteObject(ho: HGDIOBJ) -> BOOL;
}
unsafe extern "C" {
    pub fn DescribePixelFormat(
        hdc: HDC,
        iPixelFormat: ::std::os::raw::c_int,
        nBytes: UINT,
        ppfd: LPPIXELFORMATDESCRIPTOR,
    ) -> ::std::os::raw::c_int;
}
pub type LPFNDEVMODE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: HWND,
        arg2: HMODULE,
        arg3: LPDEVMODE,
        arg4: LPSTR,
        arg5: LPSTR,
        arg6: LPDEVMODE,
        arg7: LPSTR,
        arg8: UINT,
    ) -> UINT,
>;
pub type LPFNDEVCAPS = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: LPSTR,
        arg2: LPSTR,
        arg3: UINT,
        arg4: LPSTR,
        arg5: LPDEVMODE,
    ) -> DWORD,
>;
unsafe extern "C" {
    pub fn DeviceCapabilitiesA(
        pDevice: LPCSTR,
        pPort: LPCSTR,
        fwCapability: WORD,
        pOutput: LPSTR,
        pDevMode: *const DEVMODEA,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DeviceCapabilitiesW(
        pDevice: LPCWSTR,
        pPort: LPCWSTR,
        fwCapability: WORD,
        pOutput: LPWSTR,
        pDevMode: *const DEVMODEW,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DrawEscape(
        hdc: HDC,
        iEscape: ::std::os::raw::c_int,
        cjIn: ::std::os::raw::c_int,
        lpIn: LPCSTR,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn Ellipse(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumFontFamiliesExA(
        hdc: HDC,
        lpLogfont: LPLOGFONTA,
        lpProc: FONTENUMPROCA,
        lParam: LPARAM,
        dwFlags: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumFontFamiliesExW(
        hdc: HDC,
        lpLogfont: LPLOGFONTW,
        lpProc: FONTENUMPROCW,
        lParam: LPARAM,
        dwFlags: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumFontFamiliesA(
        hdc: HDC,
        lpLogfont: LPCSTR,
        lpProc: FONTENUMPROCA,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumFontFamiliesW(
        hdc: HDC,
        lpLogfont: LPCWSTR,
        lpProc: FONTENUMPROCW,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumFontsA(
        hdc: HDC,
        lpLogfont: LPCSTR,
        lpProc: FONTENUMPROCA,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumFontsW(
        hdc: HDC,
        lpLogfont: LPCWSTR,
        lpProc: FONTENUMPROCW,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumObjects(
        hdc: HDC,
        nType: ::std::os::raw::c_int,
        lpFunc: GOBJENUMPROC,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EqualRgn(hrgn1: HRGN, hrgn2: HRGN) -> BOOL;
}
unsafe extern "C" {
    pub fn Escape(
        hdc: HDC,
        iEscape: ::std::os::raw::c_int,
        cjIn: ::std::os::raw::c_int,
        pvIn: LPCSTR,
        pvOut: LPVOID,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExtEscape(
        hdc: HDC,
        iEscape: ::std::os::raw::c_int,
        cjInput: ::std::os::raw::c_int,
        lpInData: LPCSTR,
        cjOutput: ::std::os::raw::c_int,
        lpOutData: LPSTR,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExcludeClipRect(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExtCreateRegion(lpx: *const XFORM, nCount: DWORD, lpData: *const RGNDATA) -> HRGN;
}
unsafe extern "C" {
    pub fn ExtFloodFill(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        color: COLORREF,
        type_: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FillRgn(hdc: HDC, hrgn: HRGN, hbr: HBRUSH) -> BOOL;
}
unsafe extern "C" {
    pub fn FloodFill(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        color: COLORREF,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FrameRgn(
        hdc: HDC,
        hrgn: HRGN,
        hbr: HBRUSH,
        w: ::std::os::raw::c_int,
        h: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetROP2(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetAspectRatioFilterEx(hdc: HDC, lpsize: LPSIZE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetBkColor(hdc: HDC) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetDCBrushColor(hdc: HDC) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetDCPenColor(hdc: HDC) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetBkMode(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetBitmapBits(hbit: HBITMAP, cb: LONG, lpvBits: LPVOID) -> LONG;
}
unsafe extern "C" {
    pub fn GetBitmapDimensionEx(hbit: HBITMAP, lpsize: LPSIZE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetBoundsRect(hdc: HDC, lprect: LPRECT, flags: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetBrushOrgEx(hdc: HDC, lppt: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidthA(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: LPINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidthW(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: LPINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidth32A(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: LPINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidth32W(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: LPINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidthFloatA(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: PFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidthFloatW(hdc: HDC, iFirst: UINT, iLast: UINT, lpBuffer: PFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharABCWidthsA(hdc: HDC, wFirst: UINT, wLast: UINT, lpABC: LPABC) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharABCWidthsW(hdc: HDC, wFirst: UINT, wLast: UINT, lpABC: LPABC) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharABCWidthsFloatA(hdc: HDC, iFirst: UINT, iLast: UINT, lpABC: LPABCFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharABCWidthsFloatW(hdc: HDC, iFirst: UINT, iLast: UINT, lpABC: LPABCFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClipBox(hdc: HDC, lprect: LPRECT) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetClipRgn(hdc: HDC, hrgn: HRGN) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetMetaRgn(hdc: HDC, hrgn: HRGN) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCurrentObject(hdc: HDC, type_: UINT) -> HGDIOBJ;
}
unsafe extern "C" {
    pub fn GetCurrentPositionEx(hdc: HDC, lppt: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDeviceCaps(hdc: HDC, index: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDIBits(
        hdc: HDC,
        hbm: HBITMAP,
        start: UINT,
        cLines: UINT,
        lpvBits: LPVOID,
        lpbmi: LPBITMAPINFO,
        usage: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetFontData(
        hdc: HDC,
        dwTable: DWORD,
        dwOffset: DWORD,
        pvBuffer: PVOID,
        cjBuffer: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetGlyphOutlineA(
        hdc: HDC,
        uChar: UINT,
        fuFormat: UINT,
        lpgm: LPGLYPHMETRICS,
        cjBuffer: DWORD,
        pvBuffer: LPVOID,
        lpmat2: *const MAT2,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetGlyphOutlineW(
        hdc: HDC,
        uChar: UINT,
        fuFormat: UINT,
        lpgm: LPGLYPHMETRICS,
        cjBuffer: DWORD,
        pvBuffer: LPVOID,
        lpmat2: *const MAT2,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetGraphicsMode(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetMapMode(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetMetaFileBitsEx(hMF: HMETAFILE, cbBuffer: UINT, lpData: LPVOID) -> UINT;
}
unsafe extern "C" {
    pub fn GetMetaFileA(lpName: LPCSTR) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn GetMetaFileW(lpName: LPCWSTR) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn GetNearestColor(hdc: HDC, color: COLORREF) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetNearestPaletteIndex(h: HPALETTE, color: COLORREF) -> UINT;
}
unsafe extern "C" {
    pub fn GetObjectType(h: HGDIOBJ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetOutlineTextMetricsA(hdc: HDC, cjCopy: UINT, potm: LPOUTLINETEXTMETRICA) -> UINT;
}
unsafe extern "C" {
    pub fn GetOutlineTextMetricsW(hdc: HDC, cjCopy: UINT, potm: LPOUTLINETEXTMETRICW) -> UINT;
}
unsafe extern "C" {
    pub fn GetPaletteEntries(
        hpal: HPALETTE,
        iStart: UINT,
        cEntries: UINT,
        pPalEntries: LPPALETTEENTRY,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetPixel(hdc: HDC, x: ::std::os::raw::c_int, y: ::std::os::raw::c_int) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetPixelFormat(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetPolyFillMode(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetRasterizerCaps(lpraststat: LPRASTERIZER_STATUS, cjBytes: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetRandomRgn(hdc: HDC, hrgn: HRGN, i: INT) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetRegionData(hrgn: HRGN, nCount: DWORD, lpRgnData: LPRGNDATA) -> DWORD;
}
unsafe extern "C" {
    pub fn GetRgnBox(hrgn: HRGN, lprc: LPRECT) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetStockObject(i: ::std::os::raw::c_int) -> HGDIOBJ;
}
unsafe extern "C" {
    pub fn GetStretchBltMode(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetSystemPaletteEntries(
        hdc: HDC,
        iStart: UINT,
        cEntries: UINT,
        pPalEntries: LPPALETTEENTRY,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemPaletteUse(hdc: HDC) -> UINT;
}
unsafe extern "C" {
    pub fn GetTextCharacterExtra(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTextAlign(hdc: HDC) -> UINT;
}
unsafe extern "C" {
    pub fn GetTextColor(hdc: HDC) -> COLORREF;
}
unsafe extern "C" {
    pub fn GetTextExtentPointA(
        hdc: HDC,
        lpString: LPCSTR,
        c: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentPointW(
        hdc: HDC,
        lpString: LPCWSTR,
        c: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentPoint32A(
        hdc: HDC,
        lpString: LPCSTR,
        c: ::std::os::raw::c_int,
        psizl: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentPoint32W(
        hdc: HDC,
        lpString: LPCWSTR,
        c: ::std::os::raw::c_int,
        psizl: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentExPointA(
        hdc: HDC,
        lpszString: LPCSTR,
        cchString: ::std::os::raw::c_int,
        nMaxExtent: ::std::os::raw::c_int,
        lpnFit: LPINT,
        lpnDx: LPINT,
        lpSize: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentExPointW(
        hdc: HDC,
        lpszString: LPCWSTR,
        cchString: ::std::os::raw::c_int,
        nMaxExtent: ::std::os::raw::c_int,
        lpnFit: LPINT,
        lpnDx: LPINT,
        lpSize: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextCharset(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTextCharsetInfo(
        hdc: HDC,
        lpSig: LPFONTSIGNATURE,
        dwFlags: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn TranslateCharsetInfo(lpSrc: *mut DWORD, lpCs: LPCHARSETINFO, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFontLanguageInfo(hdc: HDC) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCharacterPlacementA(
        hdc: HDC,
        lpString: LPCSTR,
        nCount: ::std::os::raw::c_int,
        nMexExtent: ::std::os::raw::c_int,
        lpResults: LPGCP_RESULTSA,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCharacterPlacementW(
        hdc: HDC,
        lpString: LPCWSTR,
        nCount: ::std::os::raw::c_int,
        nMexExtent: ::std::os::raw::c_int,
        lpResults: LPGCP_RESULTSW,
        dwFlags: DWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWCRANGE {
    pub wcLow: WCHAR,
    pub cGlyphs: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWCRANGE"][::std::mem::size_of::<tagWCRANGE>() - 4usize];
    ["Alignment of tagWCRANGE"][::std::mem::align_of::<tagWCRANGE>() - 2usize];
    ["Offset of field: tagWCRANGE::wcLow"][::std::mem::offset_of!(tagWCRANGE, wcLow) - 0usize];
    ["Offset of field: tagWCRANGE::cGlyphs"][::std::mem::offset_of!(tagWCRANGE, cGlyphs) - 2usize];
};
pub type WCRANGE = tagWCRANGE;
pub type PWCRANGE = *mut tagWCRANGE;
pub type LPWCRANGE = *mut tagWCRANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGLYPHSET {
    pub cbThis: DWORD,
    pub flAccel: DWORD,
    pub cGlyphsSupported: DWORD,
    pub cRanges: DWORD,
    pub ranges: [WCRANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGLYPHSET"][::std::mem::size_of::<tagGLYPHSET>() - 20usize];
    ["Alignment of tagGLYPHSET"][::std::mem::align_of::<tagGLYPHSET>() - 4usize];
    ["Offset of field: tagGLYPHSET::cbThis"][::std::mem::offset_of!(tagGLYPHSET, cbThis) - 0usize];
    ["Offset of field: tagGLYPHSET::flAccel"]
        [::std::mem::offset_of!(tagGLYPHSET, flAccel) - 4usize];
    ["Offset of field: tagGLYPHSET::cGlyphsSupported"]
        [::std::mem::offset_of!(tagGLYPHSET, cGlyphsSupported) - 8usize];
    ["Offset of field: tagGLYPHSET::cRanges"]
        [::std::mem::offset_of!(tagGLYPHSET, cRanges) - 12usize];
    ["Offset of field: tagGLYPHSET::ranges"][::std::mem::offset_of!(tagGLYPHSET, ranges) - 16usize];
};
pub type GLYPHSET = tagGLYPHSET;
pub type PGLYPHSET = *mut tagGLYPHSET;
pub type LPGLYPHSET = *mut tagGLYPHSET;
unsafe extern "C" {
    pub fn GetFontUnicodeRanges(hdc: HDC, lpgs: LPGLYPHSET) -> DWORD;
}
unsafe extern "C" {
    pub fn GetGlyphIndicesA(
        hdc: HDC,
        lpstr: LPCSTR,
        c: ::std::os::raw::c_int,
        pgi: LPWORD,
        fl: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetGlyphIndicesW(
        hdc: HDC,
        lpstr: LPCWSTR,
        c: ::std::os::raw::c_int,
        pgi: LPWORD,
        fl: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTextExtentPointI(
        hdc: HDC,
        pgiIn: LPWORD,
        cgi: ::std::os::raw::c_int,
        psize: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextExtentExPointI(
        hdc: HDC,
        lpwszString: LPWORD,
        cwchString: ::std::os::raw::c_int,
        nMaxExtent: ::std::os::raw::c_int,
        lpnFit: LPINT,
        lpnDx: LPINT,
        lpSize: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharWidthI(hdc: HDC, giFirst: UINT, cgi: UINT, pgi: LPWORD, piWidths: LPINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCharABCWidthsI(hdc: HDC, giFirst: UINT, cgi: UINT, pgi: LPWORD, pabc: LPABC) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDESIGNVECTOR {
    pub dvReserved: DWORD,
    pub dvNumAxes: DWORD,
    pub dvValues: [LONG; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDESIGNVECTOR"][::std::mem::size_of::<tagDESIGNVECTOR>() - 72usize];
    ["Alignment of tagDESIGNVECTOR"][::std::mem::align_of::<tagDESIGNVECTOR>() - 4usize];
    ["Offset of field: tagDESIGNVECTOR::dvReserved"]
        [::std::mem::offset_of!(tagDESIGNVECTOR, dvReserved) - 0usize];
    ["Offset of field: tagDESIGNVECTOR::dvNumAxes"]
        [::std::mem::offset_of!(tagDESIGNVECTOR, dvNumAxes) - 4usize];
    ["Offset of field: tagDESIGNVECTOR::dvValues"]
        [::std::mem::offset_of!(tagDESIGNVECTOR, dvValues) - 8usize];
};
pub type DESIGNVECTOR = tagDESIGNVECTOR;
pub type PDESIGNVECTOR = *mut tagDESIGNVECTOR;
pub type LPDESIGNVECTOR = *mut tagDESIGNVECTOR;
unsafe extern "C" {
    pub fn AddFontResourceExA(name: LPCSTR, fl: DWORD, res: PVOID) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn AddFontResourceExW(name: LPCWSTR, fl: DWORD, res: PVOID) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn RemoveFontResourceExA(name: LPCSTR, fl: DWORD, pdv: PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveFontResourceExW(name: LPCWSTR, fl: DWORD, pdv: PVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn AddFontMemResourceEx(
        pFileView: PVOID,
        cjSize: DWORD,
        pvResrved: PVOID,
        pNumFonts: *mut DWORD,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn RemoveFontMemResourceEx(h: HANDLE) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagAXISINFOA {
    pub axMinValue: LONG,
    pub axMaxValue: LONG,
    pub axAxisName: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAXISINFOA"][::std::mem::size_of::<tagAXISINFOA>() - 24usize];
    ["Alignment of tagAXISINFOA"][::std::mem::align_of::<tagAXISINFOA>() - 4usize];
    ["Offset of field: tagAXISINFOA::axMinValue"]
        [::std::mem::offset_of!(tagAXISINFOA, axMinValue) - 0usize];
    ["Offset of field: tagAXISINFOA::axMaxValue"]
        [::std::mem::offset_of!(tagAXISINFOA, axMaxValue) - 4usize];
    ["Offset of field: tagAXISINFOA::axAxisName"]
        [::std::mem::offset_of!(tagAXISINFOA, axAxisName) - 8usize];
};
pub type AXISINFOA = tagAXISINFOA;
pub type PAXISINFOA = *mut tagAXISINFOA;
pub type LPAXISINFOA = *mut tagAXISINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagAXISINFOW {
    pub axMinValue: LONG,
    pub axMaxValue: LONG,
    pub axAxisName: [WCHAR; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAXISINFOW"][::std::mem::size_of::<tagAXISINFOW>() - 40usize];
    ["Alignment of tagAXISINFOW"][::std::mem::align_of::<tagAXISINFOW>() - 4usize];
    ["Offset of field: tagAXISINFOW::axMinValue"]
        [::std::mem::offset_of!(tagAXISINFOW, axMinValue) - 0usize];
    ["Offset of field: tagAXISINFOW::axMaxValue"]
        [::std::mem::offset_of!(tagAXISINFOW, axMaxValue) - 4usize];
    ["Offset of field: tagAXISINFOW::axAxisName"]
        [::std::mem::offset_of!(tagAXISINFOW, axAxisName) - 8usize];
};
pub type AXISINFOW = tagAXISINFOW;
pub type PAXISINFOW = *mut tagAXISINFOW;
pub type LPAXISINFOW = *mut tagAXISINFOW;
pub type AXISINFO = AXISINFOA;
pub type PAXISINFO = PAXISINFOA;
pub type LPAXISINFO = LPAXISINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagAXESLISTA {
    pub axlReserved: DWORD,
    pub axlNumAxes: DWORD,
    pub axlAxisInfo: [AXISINFOA; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAXESLISTA"][::std::mem::size_of::<tagAXESLISTA>() - 392usize];
    ["Alignment of tagAXESLISTA"][::std::mem::align_of::<tagAXESLISTA>() - 4usize];
    ["Offset of field: tagAXESLISTA::axlReserved"]
        [::std::mem::offset_of!(tagAXESLISTA, axlReserved) - 0usize];
    ["Offset of field: tagAXESLISTA::axlNumAxes"]
        [::std::mem::offset_of!(tagAXESLISTA, axlNumAxes) - 4usize];
    ["Offset of field: tagAXESLISTA::axlAxisInfo"]
        [::std::mem::offset_of!(tagAXESLISTA, axlAxisInfo) - 8usize];
};
pub type AXESLISTA = tagAXESLISTA;
pub type PAXESLISTA = *mut tagAXESLISTA;
pub type LPAXESLISTA = *mut tagAXESLISTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagAXESLISTW {
    pub axlReserved: DWORD,
    pub axlNumAxes: DWORD,
    pub axlAxisInfo: [AXISINFOW; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAXESLISTW"][::std::mem::size_of::<tagAXESLISTW>() - 648usize];
    ["Alignment of tagAXESLISTW"][::std::mem::align_of::<tagAXESLISTW>() - 4usize];
    ["Offset of field: tagAXESLISTW::axlReserved"]
        [::std::mem::offset_of!(tagAXESLISTW, axlReserved) - 0usize];
    ["Offset of field: tagAXESLISTW::axlNumAxes"]
        [::std::mem::offset_of!(tagAXESLISTW, axlNumAxes) - 4usize];
    ["Offset of field: tagAXESLISTW::axlAxisInfo"]
        [::std::mem::offset_of!(tagAXESLISTW, axlAxisInfo) - 8usize];
};
pub type AXESLISTW = tagAXESLISTW;
pub type PAXESLISTW = *mut tagAXESLISTW;
pub type LPAXESLISTW = *mut tagAXESLISTW;
pub type AXESLIST = AXESLISTA;
pub type PAXESLIST = PAXESLISTA;
pub type LPAXESLIST = LPAXESLISTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTEXDVA {
    pub elfEnumLogfontEx: ENUMLOGFONTEXA,
    pub elfDesignVector: DESIGNVECTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTEXDVA"][::std::mem::size_of::<tagENUMLOGFONTEXDVA>() - 260usize];
    ["Alignment of tagENUMLOGFONTEXDVA"][::std::mem::align_of::<tagENUMLOGFONTEXDVA>() - 4usize];
    ["Offset of field: tagENUMLOGFONTEXDVA::elfEnumLogfontEx"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXDVA, elfEnumLogfontEx) - 0usize];
    ["Offset of field: tagENUMLOGFONTEXDVA::elfDesignVector"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXDVA, elfDesignVector) - 188usize];
};
pub type ENUMLOGFONTEXDVA = tagENUMLOGFONTEXDVA;
pub type PENUMLOGFONTEXDVA = *mut tagENUMLOGFONTEXDVA;
pub type LPENUMLOGFONTEXDVA = *mut tagENUMLOGFONTEXDVA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMLOGFONTEXDVW {
    pub elfEnumLogfontEx: ENUMLOGFONTEXW,
    pub elfDesignVector: DESIGNVECTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMLOGFONTEXDVW"][::std::mem::size_of::<tagENUMLOGFONTEXDVW>() - 420usize];
    ["Alignment of tagENUMLOGFONTEXDVW"][::std::mem::align_of::<tagENUMLOGFONTEXDVW>() - 4usize];
    ["Offset of field: tagENUMLOGFONTEXDVW::elfEnumLogfontEx"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXDVW, elfEnumLogfontEx) - 0usize];
    ["Offset of field: tagENUMLOGFONTEXDVW::elfDesignVector"]
        [::std::mem::offset_of!(tagENUMLOGFONTEXDVW, elfDesignVector) - 348usize];
};
pub type ENUMLOGFONTEXDVW = tagENUMLOGFONTEXDVW;
pub type PENUMLOGFONTEXDVW = *mut tagENUMLOGFONTEXDVW;
pub type LPENUMLOGFONTEXDVW = *mut tagENUMLOGFONTEXDVW;
pub type ENUMLOGFONTEXDV = ENUMLOGFONTEXDVA;
pub type PENUMLOGFONTEXDV = PENUMLOGFONTEXDVA;
pub type LPENUMLOGFONTEXDV = LPENUMLOGFONTEXDVA;
unsafe extern "C" {
    pub fn CreateFontIndirectExA(arg1: *const ENUMLOGFONTEXDVA) -> HFONT;
}
unsafe extern "C" {
    pub fn CreateFontIndirectExW(arg1: *const ENUMLOGFONTEXDVW) -> HFONT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMTEXTMETRICA {
    pub etmNewTextMetricEx: NEWTEXTMETRICEXA,
    pub etmAxesList: AXESLISTA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMTEXTMETRICA"][::std::mem::size_of::<tagENUMTEXTMETRICA>() - 488usize];
    ["Alignment of tagENUMTEXTMETRICA"][::std::mem::align_of::<tagENUMTEXTMETRICA>() - 4usize];
    ["Offset of field: tagENUMTEXTMETRICA::etmNewTextMetricEx"]
        [::std::mem::offset_of!(tagENUMTEXTMETRICA, etmNewTextMetricEx) - 0usize];
    ["Offset of field: tagENUMTEXTMETRICA::etmAxesList"]
        [::std::mem::offset_of!(tagENUMTEXTMETRICA, etmAxesList) - 96usize];
};
pub type ENUMTEXTMETRICA = tagENUMTEXTMETRICA;
pub type PENUMTEXTMETRICA = *mut tagENUMTEXTMETRICA;
pub type LPENUMTEXTMETRICA = *mut tagENUMTEXTMETRICA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagENUMTEXTMETRICW {
    pub etmNewTextMetricEx: NEWTEXTMETRICEXW,
    pub etmAxesList: AXESLISTW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagENUMTEXTMETRICW"][::std::mem::size_of::<tagENUMTEXTMETRICW>() - 748usize];
    ["Alignment of tagENUMTEXTMETRICW"][::std::mem::align_of::<tagENUMTEXTMETRICW>() - 4usize];
    ["Offset of field: tagENUMTEXTMETRICW::etmNewTextMetricEx"]
        [::std::mem::offset_of!(tagENUMTEXTMETRICW, etmNewTextMetricEx) - 0usize];
    ["Offset of field: tagENUMTEXTMETRICW::etmAxesList"]
        [::std::mem::offset_of!(tagENUMTEXTMETRICW, etmAxesList) - 100usize];
};
pub type ENUMTEXTMETRICW = tagENUMTEXTMETRICW;
pub type PENUMTEXTMETRICW = *mut tagENUMTEXTMETRICW;
pub type LPENUMTEXTMETRICW = *mut tagENUMTEXTMETRICW;
pub type ENUMTEXTMETRIC = ENUMTEXTMETRICA;
pub type PENUMTEXTMETRIC = PENUMTEXTMETRICA;
pub type LPENUMTEXTMETRIC = LPENUMTEXTMETRICA;
unsafe extern "C" {
    pub fn GetViewportExtEx(hdc: HDC, lpsize: LPSIZE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetViewportOrgEx(hdc: HDC, lppoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowExtEx(hdc: HDC, lpsize: LPSIZE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowOrgEx(hdc: HDC, lppoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn IntersectClipRect(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn InvertRgn(hdc: HDC, hrgn: HRGN) -> BOOL;
}
unsafe extern "C" {
    pub fn LineDDA(
        xStart: ::std::os::raw::c_int,
        yStart: ::std::os::raw::c_int,
        xEnd: ::std::os::raw::c_int,
        yEnd: ::std::os::raw::c_int,
        lpProc: LINEDDAPROC,
        data: LPARAM,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LineTo(hdc: HDC, x: ::std::os::raw::c_int, y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn MaskBlt(
        hdcDest: HDC,
        xDest: ::std::os::raw::c_int,
        yDest: ::std::os::raw::c_int,
        width: ::std::os::raw::c_int,
        height: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xSrc: ::std::os::raw::c_int,
        ySrc: ::std::os::raw::c_int,
        hbmMask: HBITMAP,
        xMask: ::std::os::raw::c_int,
        yMask: ::std::os::raw::c_int,
        rop: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PlgBlt(
        hdcDest: HDC,
        lpPoint: *const POINT,
        hdcSrc: HDC,
        xSrc: ::std::os::raw::c_int,
        ySrc: ::std::os::raw::c_int,
        width: ::std::os::raw::c_int,
        height: ::std::os::raw::c_int,
        hbmMask: HBITMAP,
        xMask: ::std::os::raw::c_int,
        yMask: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OffsetClipRgn(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn OffsetRgn(
        hrgn: HRGN,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn PatBlt(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        w: ::std::os::raw::c_int,
        h: ::std::os::raw::c_int,
        rop: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn Pie(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
        xr1: ::std::os::raw::c_int,
        yr1: ::std::os::raw::c_int,
        xr2: ::std::os::raw::c_int,
        yr2: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PlayMetaFile(hdc: HDC, hmf: HMETAFILE) -> BOOL;
}
unsafe extern "C" {
    pub fn PaintRgn(hdc: HDC, hrgn: HRGN) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyPolygon(
        hdc: HDC,
        apt: *const POINT,
        asz: *const INT,
        csz: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PtInRegion(hrgn: HRGN, x: ::std::os::raw::c_int, y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn PtVisible(hdc: HDC, x: ::std::os::raw::c_int, y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn RectInRegion(hrgn: HRGN, lprect: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn RectVisible(hdc: HDC, lprect: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn Rectangle(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RestoreDC(hdc: HDC, nSavedDC: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn ResetDCA(hdc: HDC, lpdm: *const DEVMODEA) -> HDC;
}
unsafe extern "C" {
    pub fn ResetDCW(hdc: HDC, lpdm: *const DEVMODEW) -> HDC;
}
unsafe extern "C" {
    pub fn RealizePalette(hdc: HDC) -> UINT;
}
unsafe extern "C" {
    pub fn RemoveFontResourceA(lpFileName: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveFontResourceW(lpFileName: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn RoundRect(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
        width: ::std::os::raw::c_int,
        height: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ResizePalette(hpal: HPALETTE, n: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SaveDC(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SelectClipRgn(hdc: HDC, hrgn: HRGN) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExtSelectClipRgn(
        hdc: HDC,
        hrgn: HRGN,
        mode: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetMetaRgn(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SelectObject(hdc: HDC, h: HGDIOBJ) -> HGDIOBJ;
}
unsafe extern "C" {
    pub fn SelectPalette(hdc: HDC, hPal: HPALETTE, bForceBkgd: BOOL) -> HPALETTE;
}
unsafe extern "C" {
    pub fn SetBkColor(hdc: HDC, color: COLORREF) -> COLORREF;
}
unsafe extern "C" {
    pub fn SetDCBrushColor(hdc: HDC, color: COLORREF) -> COLORREF;
}
unsafe extern "C" {
    pub fn SetDCPenColor(hdc: HDC, color: COLORREF) -> COLORREF;
}
unsafe extern "C" {
    pub fn SetBkMode(hdc: HDC, mode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetBitmapBits(hbm: HBITMAP, cb: DWORD, pvBits: *const ::std::os::raw::c_void) -> LONG;
}
unsafe extern "C" {
    pub fn SetBoundsRect(hdc: HDC, lprect: *const RECT, flags: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn SetDIBits(
        hdc: HDC,
        hbm: HBITMAP,
        start: UINT,
        cLines: UINT,
        lpBits: *const ::std::os::raw::c_void,
        lpbmi: *const BITMAPINFO,
        ColorUse: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetDIBitsToDevice(
        hdc: HDC,
        xDest: ::std::os::raw::c_int,
        yDest: ::std::os::raw::c_int,
        w: DWORD,
        h: DWORD,
        xSrc: ::std::os::raw::c_int,
        ySrc: ::std::os::raw::c_int,
        StartScan: UINT,
        cLines: UINT,
        lpvBits: *const ::std::os::raw::c_void,
        lpbmi: *const BITMAPINFO,
        ColorUse: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetMapperFlags(hdc: HDC, flags: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn SetGraphicsMode(hdc: HDC, iMode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetMapMode(hdc: HDC, iMode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetLayout(hdc: HDC, l: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetLayout(hdc: HDC) -> DWORD;
}
unsafe extern "C" {
    pub fn SetMetaFileBitsEx(cbBuffer: UINT, lpData: *const BYTE) -> HMETAFILE;
}
unsafe extern "C" {
    pub fn SetPaletteEntries(
        hpal: HPALETTE,
        iStart: UINT,
        cEntries: UINT,
        pPalEntries: *const PALETTEENTRY,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn SetPixel(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        color: COLORREF,
    ) -> COLORREF;
}
unsafe extern "C" {
    pub fn SetPixelV(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        color: COLORREF,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPixelFormat(
        hdc: HDC,
        format: ::std::os::raw::c_int,
        ppfd: *const PIXELFORMATDESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPolyFillMode(hdc: HDC, mode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn StretchBlt(
        hdcDest: HDC,
        xDest: ::std::os::raw::c_int,
        yDest: ::std::os::raw::c_int,
        wDest: ::std::os::raw::c_int,
        hDest: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xSrc: ::std::os::raw::c_int,
        ySrc: ::std::os::raw::c_int,
        wSrc: ::std::os::raw::c_int,
        hSrc: ::std::os::raw::c_int,
        rop: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetRectRgn(
        hrgn: HRGN,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn StretchDIBits(
        hdc: HDC,
        xDest: ::std::os::raw::c_int,
        yDest: ::std::os::raw::c_int,
        DestWidth: ::std::os::raw::c_int,
        DestHeight: ::std::os::raw::c_int,
        xSrc: ::std::os::raw::c_int,
        ySrc: ::std::os::raw::c_int,
        SrcWidth: ::std::os::raw::c_int,
        SrcHeight: ::std::os::raw::c_int,
        lpBits: *const ::std::os::raw::c_void,
        lpbmi: *const BITMAPINFO,
        iUsage: UINT,
        rop: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetROP2(hdc: HDC, rop2: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetStretchBltMode(hdc: HDC, mode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetSystemPaletteUse(hdc: HDC, use_: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn SetTextCharacterExtra(hdc: HDC, extra: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetTextColor(hdc: HDC, color: COLORREF) -> COLORREF;
}
unsafe extern "C" {
    pub fn SetTextAlign(hdc: HDC, align: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn SetTextJustification(
        hdc: HDC,
        extra: ::std::os::raw::c_int,
        count: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UpdateColors(hdc: HDC) -> BOOL;
}
pub type COLOR16 = USHORT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRIVERTEX {
    pub x: LONG,
    pub y: LONG,
    pub Red: COLOR16,
    pub Green: COLOR16,
    pub Blue: COLOR16,
    pub Alpha: COLOR16,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRIVERTEX"][::std::mem::size_of::<_TRIVERTEX>() - 16usize];
    ["Alignment of _TRIVERTEX"][::std::mem::align_of::<_TRIVERTEX>() - 4usize];
    ["Offset of field: _TRIVERTEX::x"][::std::mem::offset_of!(_TRIVERTEX, x) - 0usize];
    ["Offset of field: _TRIVERTEX::y"][::std::mem::offset_of!(_TRIVERTEX, y) - 4usize];
    ["Offset of field: _TRIVERTEX::Red"][::std::mem::offset_of!(_TRIVERTEX, Red) - 8usize];
    ["Offset of field: _TRIVERTEX::Green"][::std::mem::offset_of!(_TRIVERTEX, Green) - 10usize];
    ["Offset of field: _TRIVERTEX::Blue"][::std::mem::offset_of!(_TRIVERTEX, Blue) - 12usize];
    ["Offset of field: _TRIVERTEX::Alpha"][::std::mem::offset_of!(_TRIVERTEX, Alpha) - 14usize];
};
pub type TRIVERTEX = _TRIVERTEX;
pub type PTRIVERTEX = *mut _TRIVERTEX;
pub type LPTRIVERTEX = *mut _TRIVERTEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GRADIENT_TRIANGLE {
    pub Vertex1: ULONG,
    pub Vertex2: ULONG,
    pub Vertex3: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GRADIENT_TRIANGLE"][::std::mem::size_of::<_GRADIENT_TRIANGLE>() - 12usize];
    ["Alignment of _GRADIENT_TRIANGLE"][::std::mem::align_of::<_GRADIENT_TRIANGLE>() - 4usize];
    ["Offset of field: _GRADIENT_TRIANGLE::Vertex1"]
        [::std::mem::offset_of!(_GRADIENT_TRIANGLE, Vertex1) - 0usize];
    ["Offset of field: _GRADIENT_TRIANGLE::Vertex2"]
        [::std::mem::offset_of!(_GRADIENT_TRIANGLE, Vertex2) - 4usize];
    ["Offset of field: _GRADIENT_TRIANGLE::Vertex3"]
        [::std::mem::offset_of!(_GRADIENT_TRIANGLE, Vertex3) - 8usize];
};
pub type GRADIENT_TRIANGLE = _GRADIENT_TRIANGLE;
pub type PGRADIENT_TRIANGLE = *mut _GRADIENT_TRIANGLE;
pub type LPGRADIENT_TRIANGLE = *mut _GRADIENT_TRIANGLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GRADIENT_RECT {
    pub UpperLeft: ULONG,
    pub LowerRight: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GRADIENT_RECT"][::std::mem::size_of::<_GRADIENT_RECT>() - 8usize];
    ["Alignment of _GRADIENT_RECT"][::std::mem::align_of::<_GRADIENT_RECT>() - 4usize];
    ["Offset of field: _GRADIENT_RECT::UpperLeft"]
        [::std::mem::offset_of!(_GRADIENT_RECT, UpperLeft) - 0usize];
    ["Offset of field: _GRADIENT_RECT::LowerRight"]
        [::std::mem::offset_of!(_GRADIENT_RECT, LowerRight) - 4usize];
};
pub type GRADIENT_RECT = _GRADIENT_RECT;
pub type PGRADIENT_RECT = *mut _GRADIENT_RECT;
pub type LPGRADIENT_RECT = *mut _GRADIENT_RECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BLENDFUNCTION {
    pub BlendOp: BYTE,
    pub BlendFlags: BYTE,
    pub SourceConstantAlpha: BYTE,
    pub AlphaFormat: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BLENDFUNCTION"][::std::mem::size_of::<_BLENDFUNCTION>() - 4usize];
    ["Alignment of _BLENDFUNCTION"][::std::mem::align_of::<_BLENDFUNCTION>() - 1usize];
    ["Offset of field: _BLENDFUNCTION::BlendOp"]
        [::std::mem::offset_of!(_BLENDFUNCTION, BlendOp) - 0usize];
    ["Offset of field: _BLENDFUNCTION::BlendFlags"]
        [::std::mem::offset_of!(_BLENDFUNCTION, BlendFlags) - 1usize];
    ["Offset of field: _BLENDFUNCTION::SourceConstantAlpha"]
        [::std::mem::offset_of!(_BLENDFUNCTION, SourceConstantAlpha) - 2usize];
    ["Offset of field: _BLENDFUNCTION::AlphaFormat"]
        [::std::mem::offset_of!(_BLENDFUNCTION, AlphaFormat) - 3usize];
};
pub type BLENDFUNCTION = _BLENDFUNCTION;
pub type PBLENDFUNCTION = *mut _BLENDFUNCTION;
unsafe extern "C" {
    pub fn AlphaBlend(
        hdcDest: HDC,
        xoriginDest: ::std::os::raw::c_int,
        yoriginDest: ::std::os::raw::c_int,
        wDest: ::std::os::raw::c_int,
        hDest: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xoriginSrc: ::std::os::raw::c_int,
        yoriginSrc: ::std::os::raw::c_int,
        wSrc: ::std::os::raw::c_int,
        hSrc: ::std::os::raw::c_int,
        ftn: BLENDFUNCTION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TransparentBlt(
        hdcDest: HDC,
        xoriginDest: ::std::os::raw::c_int,
        yoriginDest: ::std::os::raw::c_int,
        wDest: ::std::os::raw::c_int,
        hDest: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xoriginSrc: ::std::os::raw::c_int,
        yoriginSrc: ::std::os::raw::c_int,
        wSrc: ::std::os::raw::c_int,
        hSrc: ::std::os::raw::c_int,
        crTransparent: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GradientFill(
        hdc: HDC,
        pVertex: PTRIVERTEX,
        nVertex: ULONG,
        pMesh: PVOID,
        nMesh: ULONG,
        ulMode: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GdiAlphaBlend(
        hdcDest: HDC,
        xoriginDest: ::std::os::raw::c_int,
        yoriginDest: ::std::os::raw::c_int,
        wDest: ::std::os::raw::c_int,
        hDest: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xoriginSrc: ::std::os::raw::c_int,
        yoriginSrc: ::std::os::raw::c_int,
        wSrc: ::std::os::raw::c_int,
        hSrc: ::std::os::raw::c_int,
        ftn: BLENDFUNCTION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GdiTransparentBlt(
        hdcDest: HDC,
        xoriginDest: ::std::os::raw::c_int,
        yoriginDest: ::std::os::raw::c_int,
        wDest: ::std::os::raw::c_int,
        hDest: ::std::os::raw::c_int,
        hdcSrc: HDC,
        xoriginSrc: ::std::os::raw::c_int,
        yoriginSrc: ::std::os::raw::c_int,
        wSrc: ::std::os::raw::c_int,
        hSrc: ::std::os::raw::c_int,
        crTransparent: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GdiGradientFill(
        hdc: HDC,
        pVertex: PTRIVERTEX,
        nVertex: ULONG,
        pMesh: PVOID,
        nCount: ULONG,
        ulMode: ULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PlayMetaFileRecord(
        hdc: HDC,
        lpHandleTable: LPHANDLETABLE,
        lpMR: LPMETARECORD,
        noObjs: UINT,
    ) -> BOOL;
}
pub type MFENUMPROC = ::std::option::Option<
    unsafe extern "C" fn(
        hdc: HDC,
        lpht: *mut HANDLETABLE,
        lpMR: *mut METARECORD,
        nObj: ::std::os::raw::c_int,
        param: LPARAM,
    ) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn EnumMetaFile(hdc: HDC, hmf: HMETAFILE, proc_: MFENUMPROC, param: LPARAM) -> BOOL;
}
pub type ENHMFENUMPROC = ::std::option::Option<
    unsafe extern "C" fn(
        hdc: HDC,
        lpht: *mut HANDLETABLE,
        lpmr: *const ENHMETARECORD,
        nHandles: ::std::os::raw::c_int,
        data: LPARAM,
    ) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn CloseEnhMetaFile(hdc: HDC) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn CopyEnhMetaFileA(hEnh: HENHMETAFILE, lpFileName: LPCSTR) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn CopyEnhMetaFileW(hEnh: HENHMETAFILE, lpFileName: LPCWSTR) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn CreateEnhMetaFileA(
        hdc: HDC,
        lpFilename: LPCSTR,
        lprc: *const RECT,
        lpDesc: LPCSTR,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn CreateEnhMetaFileW(
        hdc: HDC,
        lpFilename: LPCWSTR,
        lprc: *const RECT,
        lpDesc: LPCWSTR,
    ) -> HDC;
}
unsafe extern "C" {
    pub fn DeleteEnhMetaFile(hmf: HENHMETAFILE) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumEnhMetaFile(
        hdc: HDC,
        hmf: HENHMETAFILE,
        proc_: ENHMFENUMPROC,
        param: LPVOID,
        lpRect: *const RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileA(lpName: LPCSTR) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileW(lpName: LPCWSTR) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileBits(hEMF: HENHMETAFILE, nSize: UINT, lpData: LPBYTE) -> UINT;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileDescriptionA(
        hemf: HENHMETAFILE,
        cchBuffer: UINT,
        lpDescription: LPSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileDescriptionW(
        hemf: HENHMETAFILE,
        cchBuffer: UINT,
        lpDescription: LPWSTR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetEnhMetaFileHeader(
        hemf: HENHMETAFILE,
        nSize: UINT,
        lpEnhMetaHeader: LPENHMETAHEADER,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetEnhMetaFilePaletteEntries(
        hemf: HENHMETAFILE,
        nNumEntries: UINT,
        lpPaletteEntries: LPPALETTEENTRY,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetEnhMetaFilePixelFormat(
        hemf: HENHMETAFILE,
        cbBuffer: UINT,
        ppfd: *mut PIXELFORMATDESCRIPTOR,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetWinMetaFileBits(
        hemf: HENHMETAFILE,
        cbData16: UINT,
        pData16: LPBYTE,
        iMapMode: INT,
        hdcRef: HDC,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn PlayEnhMetaFile(hdc: HDC, hmf: HENHMETAFILE, lprect: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn PlayEnhMetaFileRecord(
        hdc: HDC,
        pht: LPHANDLETABLE,
        pmr: *const ENHMETARECORD,
        cht: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetEnhMetaFileBits(nSize: UINT, pb: *const BYTE) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn SetWinMetaFileBits(
        nSize: UINT,
        lpMeta16Data: *const BYTE,
        hdcRef: HDC,
        lpMFP: *const METAFILEPICT,
    ) -> HENHMETAFILE;
}
unsafe extern "C" {
    pub fn GdiComment(hdc: HDC, nSize: UINT, lpData: *const BYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextMetricsA(hdc: HDC, lptm: LPTEXTMETRICA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextMetricsW(hdc: HDC, lptm: LPTEXTMETRICW) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDIBSECTION {
    pub dsBm: BITMAP,
    pub dsBmih: BITMAPINFOHEADER,
    pub dsBitfields: [DWORD; 3usize],
    pub dshSection: HANDLE,
    pub dsOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDIBSECTION"][::std::mem::size_of::<tagDIBSECTION>() - 104usize];
    ["Alignment of tagDIBSECTION"][::std::mem::align_of::<tagDIBSECTION>() - 8usize];
    ["Offset of field: tagDIBSECTION::dsBm"][::std::mem::offset_of!(tagDIBSECTION, dsBm) - 0usize];
    ["Offset of field: tagDIBSECTION::dsBmih"]
        [::std::mem::offset_of!(tagDIBSECTION, dsBmih) - 32usize];
    ["Offset of field: tagDIBSECTION::dsBitfields"]
        [::std::mem::offset_of!(tagDIBSECTION, dsBitfields) - 72usize];
    ["Offset of field: tagDIBSECTION::dshSection"]
        [::std::mem::offset_of!(tagDIBSECTION, dshSection) - 88usize];
    ["Offset of field: tagDIBSECTION::dsOffset"]
        [::std::mem::offset_of!(tagDIBSECTION, dsOffset) - 96usize];
};
pub type DIBSECTION = tagDIBSECTION;
pub type LPDIBSECTION = *mut tagDIBSECTION;
pub type PDIBSECTION = *mut tagDIBSECTION;
unsafe extern "C" {
    pub fn AngleArc(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        r: DWORD,
        StartAngle: FLOAT,
        SweepAngle: FLOAT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyPolyline(hdc: HDC, apt: *const POINT, asz: *const DWORD, csz: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWorldTransform(hdc: HDC, lpxf: LPXFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWorldTransform(hdc: HDC, lpxf: *const XFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn ModifyWorldTransform(hdc: HDC, lpxf: *const XFORM, mode: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CombineTransform(lpxfOut: LPXFORM, lpxf1: *const XFORM, lpxf2: *const XFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateDIBSection(
        hdc: HDC,
        pbmi: *const BITMAPINFO,
        usage: UINT,
        ppvBits: *mut *mut ::std::os::raw::c_void,
        hSection: HANDLE,
        offset: DWORD,
    ) -> HBITMAP;
}
unsafe extern "C" {
    pub fn GetDIBColorTable(hdc: HDC, iStart: UINT, cEntries: UINT, prgbq: *mut RGBQUAD) -> UINT;
}
unsafe extern "C" {
    pub fn SetDIBColorTable(hdc: HDC, iStart: UINT, cEntries: UINT, prgbq: *const RGBQUAD) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOLORADJUSTMENT {
    pub caSize: WORD,
    pub caFlags: WORD,
    pub caIlluminantIndex: WORD,
    pub caRedGamma: WORD,
    pub caGreenGamma: WORD,
    pub caBlueGamma: WORD,
    pub caReferenceBlack: WORD,
    pub caReferenceWhite: WORD,
    pub caContrast: SHORT,
    pub caBrightness: SHORT,
    pub caColorfulness: SHORT,
    pub caRedGreenTint: SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOLORADJUSTMENT"][::std::mem::size_of::<tagCOLORADJUSTMENT>() - 24usize];
    ["Alignment of tagCOLORADJUSTMENT"][::std::mem::align_of::<tagCOLORADJUSTMENT>() - 2usize];
    ["Offset of field: tagCOLORADJUSTMENT::caSize"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caSize) - 0usize];
    ["Offset of field: tagCOLORADJUSTMENT::caFlags"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caFlags) - 2usize];
    ["Offset of field: tagCOLORADJUSTMENT::caIlluminantIndex"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caIlluminantIndex) - 4usize];
    ["Offset of field: tagCOLORADJUSTMENT::caRedGamma"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caRedGamma) - 6usize];
    ["Offset of field: tagCOLORADJUSTMENT::caGreenGamma"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caGreenGamma) - 8usize];
    ["Offset of field: tagCOLORADJUSTMENT::caBlueGamma"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caBlueGamma) - 10usize];
    ["Offset of field: tagCOLORADJUSTMENT::caReferenceBlack"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caReferenceBlack) - 12usize];
    ["Offset of field: tagCOLORADJUSTMENT::caReferenceWhite"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caReferenceWhite) - 14usize];
    ["Offset of field: tagCOLORADJUSTMENT::caContrast"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caContrast) - 16usize];
    ["Offset of field: tagCOLORADJUSTMENT::caBrightness"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caBrightness) - 18usize];
    ["Offset of field: tagCOLORADJUSTMENT::caColorfulness"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caColorfulness) - 20usize];
    ["Offset of field: tagCOLORADJUSTMENT::caRedGreenTint"]
        [::std::mem::offset_of!(tagCOLORADJUSTMENT, caRedGreenTint) - 22usize];
};
pub type COLORADJUSTMENT = tagCOLORADJUSTMENT;
pub type PCOLORADJUSTMENT = *mut tagCOLORADJUSTMENT;
pub type LPCOLORADJUSTMENT = *mut tagCOLORADJUSTMENT;
unsafe extern "C" {
    pub fn SetColorAdjustment(hdc: HDC, lpca: *const COLORADJUSTMENT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetColorAdjustment(hdc: HDC, lpca: LPCOLORADJUSTMENT) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateHalftonePalette(hdc: HDC) -> HPALETTE;
}
pub type ABORTPROC =
    ::std::option::Option<unsafe extern "C" fn(arg1: HDC, arg2: ::std::os::raw::c_int) -> BOOL>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOCINFOA {
    pub cbSize: ::std::os::raw::c_int,
    pub lpszDocName: LPCSTR,
    pub lpszOutput: LPCSTR,
    pub lpszDatatype: LPCSTR,
    pub fwType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOCINFOA"][::std::mem::size_of::<_DOCINFOA>() - 40usize];
    ["Alignment of _DOCINFOA"][::std::mem::align_of::<_DOCINFOA>() - 8usize];
    ["Offset of field: _DOCINFOA::cbSize"][::std::mem::offset_of!(_DOCINFOA, cbSize) - 0usize];
    ["Offset of field: _DOCINFOA::lpszDocName"]
        [::std::mem::offset_of!(_DOCINFOA, lpszDocName) - 8usize];
    ["Offset of field: _DOCINFOA::lpszOutput"]
        [::std::mem::offset_of!(_DOCINFOA, lpszOutput) - 16usize];
    ["Offset of field: _DOCINFOA::lpszDatatype"]
        [::std::mem::offset_of!(_DOCINFOA, lpszDatatype) - 24usize];
    ["Offset of field: _DOCINFOA::fwType"][::std::mem::offset_of!(_DOCINFOA, fwType) - 32usize];
};
pub type DOCINFOA = _DOCINFOA;
pub type LPDOCINFOA = *mut _DOCINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOCINFOW {
    pub cbSize: ::std::os::raw::c_int,
    pub lpszDocName: LPCWSTR,
    pub lpszOutput: LPCWSTR,
    pub lpszDatatype: LPCWSTR,
    pub fwType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOCINFOW"][::std::mem::size_of::<_DOCINFOW>() - 40usize];
    ["Alignment of _DOCINFOW"][::std::mem::align_of::<_DOCINFOW>() - 8usize];
    ["Offset of field: _DOCINFOW::cbSize"][::std::mem::offset_of!(_DOCINFOW, cbSize) - 0usize];
    ["Offset of field: _DOCINFOW::lpszDocName"]
        [::std::mem::offset_of!(_DOCINFOW, lpszDocName) - 8usize];
    ["Offset of field: _DOCINFOW::lpszOutput"]
        [::std::mem::offset_of!(_DOCINFOW, lpszOutput) - 16usize];
    ["Offset of field: _DOCINFOW::lpszDatatype"]
        [::std::mem::offset_of!(_DOCINFOW, lpszDatatype) - 24usize];
    ["Offset of field: _DOCINFOW::fwType"][::std::mem::offset_of!(_DOCINFOW, fwType) - 32usize];
};
pub type DOCINFOW = _DOCINFOW;
pub type LPDOCINFOW = *mut _DOCINFOW;
pub type DOCINFO = DOCINFOA;
pub type LPDOCINFO = LPDOCINFOA;
unsafe extern "C" {
    pub fn StartDocA(hdc: HDC, lpdi: *const DOCINFOA) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn StartDocW(hdc: HDC, lpdi: *const DOCINFOW) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EndDoc(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn StartPage(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EndPage(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn AbortDoc(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetAbortProc(hdc: HDC, proc_: ABORTPROC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn AbortPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn ArcTo(
        hdc: HDC,
        left: ::std::os::raw::c_int,
        top: ::std::os::raw::c_int,
        right: ::std::os::raw::c_int,
        bottom: ::std::os::raw::c_int,
        xr1: ::std::os::raw::c_int,
        yr1: ::std::os::raw::c_int,
        xr2: ::std::os::raw::c_int,
        yr2: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn BeginPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseFigure(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn EndPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn FillPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn FlattenPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPath(
        hdc: HDC,
        apt: LPPOINT,
        aj: LPBYTE,
        cpt: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn PathToRegion(hdc: HDC) -> HRGN;
}
unsafe extern "C" {
    pub fn PolyDraw(
        hdc: HDC,
        apt: *const POINT,
        aj: *const BYTE,
        cpt: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SelectClipPath(hdc: HDC, mode: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn SetArcDirection(hdc: HDC, dir: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetMiterLimit(hdc: HDC, limit: FLOAT, old: PFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn StrokeAndFillPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn StrokePath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn WidenPath(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn ExtCreatePen(
        iPenStyle: DWORD,
        cWidth: DWORD,
        plbrush: *const LOGBRUSH,
        cStyle: DWORD,
        pstyle: *const DWORD,
    ) -> HPEN;
}
unsafe extern "C" {
    pub fn GetMiterLimit(hdc: HDC, plimit: PFLOAT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetArcDirection(hdc: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetObjectA(h: HANDLE, c: ::std::os::raw::c_int, pv: LPVOID) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetObjectW(h: HANDLE, c: ::std::os::raw::c_int, pv: LPVOID) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MoveToEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TextOutA(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpString: LPCSTR,
        c: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TextOutW(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpString: LPCWSTR,
        c: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ExtTextOutA(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        options: UINT,
        lprect: *const RECT,
        lpString: LPCSTR,
        c: UINT,
        lpDx: *const INT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ExtTextOutW(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        options: UINT,
        lprect: *const RECT,
        lpString: LPCWSTR,
        c: UINT,
        lpDx: *const INT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyTextOutA(hdc: HDC, ppt: *const POLYTEXTA, nstrings: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyTextOutW(hdc: HDC, ppt: *const POLYTEXTW, nstrings: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePolygonRgn(
        pptl: *const POINT,
        cPoint: ::std::os::raw::c_int,
        iMode: ::std::os::raw::c_int,
    ) -> HRGN;
}
unsafe extern "C" {
    pub fn DPtoLP(hdc: HDC, lppt: LPPOINT, c: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn LPtoDP(hdc: HDC, lppt: LPPOINT, c: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn Polygon(hdc: HDC, apt: *const POINT, cpt: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn Polyline(hdc: HDC, apt: *const POINT, cpt: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyBezier(hdc: HDC, apt: *const POINT, cpt: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn PolyBezierTo(hdc: HDC, apt: *const POINT, cpt: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn PolylineTo(hdc: HDC, apt: *const POINT, cpt: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetViewportExtEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetViewportOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowExtEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OffsetViewportOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OffsetWindowOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScaleViewportExtEx(
        hdc: HDC,
        xn: ::std::os::raw::c_int,
        dx: ::std::os::raw::c_int,
        yn: ::std::os::raw::c_int,
        yd: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScaleWindowExtEx(
        hdc: HDC,
        xn: ::std::os::raw::c_int,
        xd: ::std::os::raw::c_int,
        yn: ::std::os::raw::c_int,
        yd: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetBitmapDimensionEx(
        hbm: HBITMAP,
        w: ::std::os::raw::c_int,
        h: ::std::os::raw::c_int,
        lpsz: LPSIZE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetBrushOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lppt: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetTextFaceA(hdc: HDC, c: ::std::os::raw::c_int, lpName: LPSTR)
        -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTextFaceW(
        hdc: HDC,
        c: ::std::os::raw::c_int,
        lpName: LPWSTR,
    ) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagKERNINGPAIR {
    pub wFirst: WORD,
    pub wSecond: WORD,
    pub iKernAmount: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagKERNINGPAIR"][::std::mem::size_of::<tagKERNINGPAIR>() - 8usize];
    ["Alignment of tagKERNINGPAIR"][::std::mem::align_of::<tagKERNINGPAIR>() - 4usize];
    ["Offset of field: tagKERNINGPAIR::wFirst"]
        [::std::mem::offset_of!(tagKERNINGPAIR, wFirst) - 0usize];
    ["Offset of field: tagKERNINGPAIR::wSecond"]
        [::std::mem::offset_of!(tagKERNINGPAIR, wSecond) - 2usize];
    ["Offset of field: tagKERNINGPAIR::iKernAmount"]
        [::std::mem::offset_of!(tagKERNINGPAIR, iKernAmount) - 4usize];
};
pub type KERNINGPAIR = tagKERNINGPAIR;
pub type LPKERNINGPAIR = *mut tagKERNINGPAIR;
unsafe extern "C" {
    pub fn GetKerningPairsA(hdc: HDC, nPairs: DWORD, lpKernPair: LPKERNINGPAIR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetKerningPairsW(hdc: HDC, nPairs: DWORD, lpKernPair: LPKERNINGPAIR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetDCOrgEx(hdc: HDC, lppt: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn FixBrushOrgEx(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        ptl: LPPOINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnrealizeObject(h: HGDIOBJ) -> BOOL;
}
unsafe extern "C" {
    pub fn GdiFlush() -> BOOL;
}
unsafe extern "C" {
    pub fn GdiSetBatchLimit(dw: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GdiGetBatchLimit() -> DWORD;
}
pub type ICMENUMPROCA =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR, arg2: LPARAM) -> ::std::os::raw::c_int>;
pub type ICMENUMPROCW = ::std::option::Option<
    unsafe extern "C" fn(arg1: LPWSTR, arg2: LPARAM) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn SetICMMode(hdc: HDC, mode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CheckColorsInGamut(
        hdc: HDC,
        lpRGBTriple: LPRGBTRIPLE,
        dlpBuffer: LPVOID,
        nCount: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetColorSpace(hdc: HDC) -> HCOLORSPACE;
}
unsafe extern "C" {
    pub fn GetLogColorSpaceA(
        hColorSpace: HCOLORSPACE,
        lpBuffer: LPLOGCOLORSPACEA,
        nSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLogColorSpaceW(
        hColorSpace: HCOLORSPACE,
        lpBuffer: LPLOGCOLORSPACEW,
        nSize: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateColorSpaceA(lplcs: LPLOGCOLORSPACEA) -> HCOLORSPACE;
}
unsafe extern "C" {
    pub fn CreateColorSpaceW(lplcs: LPLOGCOLORSPACEW) -> HCOLORSPACE;
}
unsafe extern "C" {
    pub fn SetColorSpace(hdc: HDC, hcs: HCOLORSPACE) -> HCOLORSPACE;
}
unsafe extern "C" {
    pub fn DeleteColorSpace(hcs: HCOLORSPACE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetICMProfileA(hdc: HDC, pBufSize: LPDWORD, pszFilename: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetICMProfileW(hdc: HDC, pBufSize: LPDWORD, pszFilename: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetICMProfileA(hdc: HDC, lpFileName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetICMProfileW(hdc: HDC, lpFileName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDeviceGammaRamp(hdc: HDC, lpRamp: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDeviceGammaRamp(hdc: HDC, lpRamp: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn ColorMatchToTarget(hdc: HDC, hdcTarget: HDC, action: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumICMProfilesA(hdc: HDC, proc_: ICMENUMPROCA, param: LPARAM) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumICMProfilesW(hdc: HDC, proc_: ICMENUMPROCW, param: LPARAM) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn UpdateICMRegKeyA(
        reserved: DWORD,
        lpszCMID: LPSTR,
        lpszFileName: LPSTR,
        command: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UpdateICMRegKeyW(
        reserved: DWORD,
        lpszCMID: LPWSTR,
        lpszFileName: LPWSTR,
        command: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ColorCorrectPalette(hdc: HDC, hPal: HPALETTE, deFirst: DWORD, num: DWORD) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMR {
    pub iType: DWORD,
    pub nSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMR"][::std::mem::size_of::<tagEMR>() - 8usize];
    ["Alignment of tagEMR"][::std::mem::align_of::<tagEMR>() - 4usize];
    ["Offset of field: tagEMR::iType"][::std::mem::offset_of!(tagEMR, iType) - 0usize];
    ["Offset of field: tagEMR::nSize"][::std::mem::offset_of!(tagEMR, nSize) - 4usize];
};
pub type EMR = tagEMR;
pub type PEMR = *mut tagEMR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRTEXT {
    pub ptlReference: POINTL,
    pub nChars: DWORD,
    pub offString: DWORD,
    pub fOptions: DWORD,
    pub rcl: RECTL,
    pub offDx: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRTEXT"][::std::mem::size_of::<tagEMRTEXT>() - 40usize];
    ["Alignment of tagEMRTEXT"][::std::mem::align_of::<tagEMRTEXT>() - 4usize];
    ["Offset of field: tagEMRTEXT::ptlReference"]
        [::std::mem::offset_of!(tagEMRTEXT, ptlReference) - 0usize];
    ["Offset of field: tagEMRTEXT::nChars"][::std::mem::offset_of!(tagEMRTEXT, nChars) - 8usize];
    ["Offset of field: tagEMRTEXT::offString"]
        [::std::mem::offset_of!(tagEMRTEXT, offString) - 12usize];
    ["Offset of field: tagEMRTEXT::fOptions"]
        [::std::mem::offset_of!(tagEMRTEXT, fOptions) - 16usize];
    ["Offset of field: tagEMRTEXT::rcl"][::std::mem::offset_of!(tagEMRTEXT, rcl) - 20usize];
    ["Offset of field: tagEMRTEXT::offDx"][::std::mem::offset_of!(tagEMRTEXT, offDx) - 36usize];
};
pub type EMRTEXT = tagEMRTEXT;
pub type PEMRTEXT = *mut tagEMRTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagABORTPATH {
    pub emr: EMR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagABORTPATH"][::std::mem::size_of::<tagABORTPATH>() - 8usize];
    ["Alignment of tagABORTPATH"][::std::mem::align_of::<tagABORTPATH>() - 4usize];
    ["Offset of field: tagABORTPATH::emr"][::std::mem::offset_of!(tagABORTPATH, emr) - 0usize];
};
pub type EMRABORTPATH = tagABORTPATH;
pub type PEMRABORTPATH = *mut tagABORTPATH;
pub type EMRBEGINPATH = tagABORTPATH;
pub type PEMRBEGINPATH = *mut tagABORTPATH;
pub type EMRENDPATH = tagABORTPATH;
pub type PEMRENDPATH = *mut tagABORTPATH;
pub type EMRCLOSEFIGURE = tagABORTPATH;
pub type PEMRCLOSEFIGURE = *mut tagABORTPATH;
pub type EMRFLATTENPATH = tagABORTPATH;
pub type PEMRFLATTENPATH = *mut tagABORTPATH;
pub type EMRWIDENPATH = tagABORTPATH;
pub type PEMRWIDENPATH = *mut tagABORTPATH;
pub type EMRSETMETARGN = tagABORTPATH;
pub type PEMRSETMETARGN = *mut tagABORTPATH;
pub type EMRSAVEDC = tagABORTPATH;
pub type PEMRSAVEDC = *mut tagABORTPATH;
pub type EMRREALIZEPALETTE = tagABORTPATH;
pub type PEMRREALIZEPALETTE = *mut tagABORTPATH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSELECTCLIPPATH {
    pub emr: EMR,
    pub iMode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSELECTCLIPPATH"][::std::mem::size_of::<tagEMRSELECTCLIPPATH>() - 12usize];
    ["Alignment of tagEMRSELECTCLIPPATH"][::std::mem::align_of::<tagEMRSELECTCLIPPATH>() - 4usize];
    ["Offset of field: tagEMRSELECTCLIPPATH::emr"]
        [::std::mem::offset_of!(tagEMRSELECTCLIPPATH, emr) - 0usize];
    ["Offset of field: tagEMRSELECTCLIPPATH::iMode"]
        [::std::mem::offset_of!(tagEMRSELECTCLIPPATH, iMode) - 8usize];
};
pub type EMRSELECTCLIPPATH = tagEMRSELECTCLIPPATH;
pub type PEMRSELECTCLIPPATH = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETBKMODE = tagEMRSELECTCLIPPATH;
pub type PEMRSETBKMODE = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETMAPMODE = tagEMRSELECTCLIPPATH;
pub type PEMRSETMAPMODE = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETLAYOUT = tagEMRSELECTCLIPPATH;
pub type PEMRSETLAYOUT = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETPOLYFILLMODE = tagEMRSELECTCLIPPATH;
pub type PEMRSETPOLYFILLMODE = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETROP2 = tagEMRSELECTCLIPPATH;
pub type PEMRSETROP2 = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETSTRETCHBLTMODE = tagEMRSELECTCLIPPATH;
pub type PEMRSETSTRETCHBLTMODE = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETICMMODE = tagEMRSELECTCLIPPATH;
pub type PEMRSETICMMODE = *mut tagEMRSELECTCLIPPATH;
pub type EMRSETTEXTALIGN = tagEMRSELECTCLIPPATH;
pub type PEMRSETTEXTALIGN = *mut tagEMRSELECTCLIPPATH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETMITERLIMIT {
    pub emr: EMR,
    pub eMiterLimit: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETMITERLIMIT"][::std::mem::size_of::<tagEMRSETMITERLIMIT>() - 12usize];
    ["Alignment of tagEMRSETMITERLIMIT"][::std::mem::align_of::<tagEMRSETMITERLIMIT>() - 4usize];
    ["Offset of field: tagEMRSETMITERLIMIT::emr"]
        [::std::mem::offset_of!(tagEMRSETMITERLIMIT, emr) - 0usize];
    ["Offset of field: tagEMRSETMITERLIMIT::eMiterLimit"]
        [::std::mem::offset_of!(tagEMRSETMITERLIMIT, eMiterLimit) - 8usize];
};
pub type EMRSETMITERLIMIT = tagEMRSETMITERLIMIT;
pub type PEMRSETMITERLIMIT = *mut tagEMRSETMITERLIMIT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRRESTOREDC {
    pub emr: EMR,
    pub iRelative: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRRESTOREDC"][::std::mem::size_of::<tagEMRRESTOREDC>() - 12usize];
    ["Alignment of tagEMRRESTOREDC"][::std::mem::align_of::<tagEMRRESTOREDC>() - 4usize];
    ["Offset of field: tagEMRRESTOREDC::emr"]
        [::std::mem::offset_of!(tagEMRRESTOREDC, emr) - 0usize];
    ["Offset of field: tagEMRRESTOREDC::iRelative"]
        [::std::mem::offset_of!(tagEMRRESTOREDC, iRelative) - 8usize];
};
pub type EMRRESTOREDC = tagEMRRESTOREDC;
pub type PEMRRESTOREDC = *mut tagEMRRESTOREDC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETARCDIRECTION {
    pub emr: EMR,
    pub iArcDirection: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETARCDIRECTION"][::std::mem::size_of::<tagEMRSETARCDIRECTION>() - 12usize];
    ["Alignment of tagEMRSETARCDIRECTION"]
        [::std::mem::align_of::<tagEMRSETARCDIRECTION>() - 4usize];
    ["Offset of field: tagEMRSETARCDIRECTION::emr"]
        [::std::mem::offset_of!(tagEMRSETARCDIRECTION, emr) - 0usize];
    ["Offset of field: tagEMRSETARCDIRECTION::iArcDirection"]
        [::std::mem::offset_of!(tagEMRSETARCDIRECTION, iArcDirection) - 8usize];
};
pub type EMRSETARCDIRECTION = tagEMRSETARCDIRECTION;
pub type PEMRSETARCDIRECTION = *mut tagEMRSETARCDIRECTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETMAPPERFLAGS {
    pub emr: EMR,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETMAPPERFLAGS"][::std::mem::size_of::<tagEMRSETMAPPERFLAGS>() - 12usize];
    ["Alignment of tagEMRSETMAPPERFLAGS"][::std::mem::align_of::<tagEMRSETMAPPERFLAGS>() - 4usize];
    ["Offset of field: tagEMRSETMAPPERFLAGS::emr"]
        [::std::mem::offset_of!(tagEMRSETMAPPERFLAGS, emr) - 0usize];
    ["Offset of field: tagEMRSETMAPPERFLAGS::dwFlags"]
        [::std::mem::offset_of!(tagEMRSETMAPPERFLAGS, dwFlags) - 8usize];
};
pub type EMRSETMAPPERFLAGS = tagEMRSETMAPPERFLAGS;
pub type PEMRSETMAPPERFLAGS = *mut tagEMRSETMAPPERFLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETTEXTCOLOR {
    pub emr: EMR,
    pub crColor: COLORREF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETTEXTCOLOR"][::std::mem::size_of::<tagEMRSETTEXTCOLOR>() - 12usize];
    ["Alignment of tagEMRSETTEXTCOLOR"][::std::mem::align_of::<tagEMRSETTEXTCOLOR>() - 4usize];
    ["Offset of field: tagEMRSETTEXTCOLOR::emr"]
        [::std::mem::offset_of!(tagEMRSETTEXTCOLOR, emr) - 0usize];
    ["Offset of field: tagEMRSETTEXTCOLOR::crColor"]
        [::std::mem::offset_of!(tagEMRSETTEXTCOLOR, crColor) - 8usize];
};
pub type EMRSETBKCOLOR = tagEMRSETTEXTCOLOR;
pub type PEMRSETBKCOLOR = *mut tagEMRSETTEXTCOLOR;
pub type EMRSETTEXTCOLOR = tagEMRSETTEXTCOLOR;
pub type PEMRSETTEXTCOLOR = *mut tagEMRSETTEXTCOLOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSELECTOBJECT {
    pub emr: EMR,
    pub ihObject: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSELECTOBJECT"][::std::mem::size_of::<tagEMRSELECTOBJECT>() - 12usize];
    ["Alignment of tagEMRSELECTOBJECT"][::std::mem::align_of::<tagEMRSELECTOBJECT>() - 4usize];
    ["Offset of field: tagEMRSELECTOBJECT::emr"]
        [::std::mem::offset_of!(tagEMRSELECTOBJECT, emr) - 0usize];
    ["Offset of field: tagEMRSELECTOBJECT::ihObject"]
        [::std::mem::offset_of!(tagEMRSELECTOBJECT, ihObject) - 8usize];
};
pub type EMRSELECTOBJECT = tagEMRSELECTOBJECT;
pub type PEMRSELECTOBJECT = *mut tagEMRSELECTOBJECT;
pub type EMRDELETEOBJECT = tagEMRSELECTOBJECT;
pub type PEMRDELETEOBJECT = *mut tagEMRSELECTOBJECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSELECTPALETTE {
    pub emr: EMR,
    pub ihPal: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSELECTPALETTE"][::std::mem::size_of::<tagEMRSELECTPALETTE>() - 12usize];
    ["Alignment of tagEMRSELECTPALETTE"][::std::mem::align_of::<tagEMRSELECTPALETTE>() - 4usize];
    ["Offset of field: tagEMRSELECTPALETTE::emr"]
        [::std::mem::offset_of!(tagEMRSELECTPALETTE, emr) - 0usize];
    ["Offset of field: tagEMRSELECTPALETTE::ihPal"]
        [::std::mem::offset_of!(tagEMRSELECTPALETTE, ihPal) - 8usize];
};
pub type EMRSELECTPALETTE = tagEMRSELECTPALETTE;
pub type PEMRSELECTPALETTE = *mut tagEMRSELECTPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRRESIZEPALETTE {
    pub emr: EMR,
    pub ihPal: DWORD,
    pub cEntries: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRRESIZEPALETTE"][::std::mem::size_of::<tagEMRRESIZEPALETTE>() - 16usize];
    ["Alignment of tagEMRRESIZEPALETTE"][::std::mem::align_of::<tagEMRRESIZEPALETTE>() - 4usize];
    ["Offset of field: tagEMRRESIZEPALETTE::emr"]
        [::std::mem::offset_of!(tagEMRRESIZEPALETTE, emr) - 0usize];
    ["Offset of field: tagEMRRESIZEPALETTE::ihPal"]
        [::std::mem::offset_of!(tagEMRRESIZEPALETTE, ihPal) - 8usize];
    ["Offset of field: tagEMRRESIZEPALETTE::cEntries"]
        [::std::mem::offset_of!(tagEMRRESIZEPALETTE, cEntries) - 12usize];
};
pub type EMRRESIZEPALETTE = tagEMRRESIZEPALETTE;
pub type PEMRRESIZEPALETTE = *mut tagEMRRESIZEPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETPALETTEENTRIES {
    pub emr: EMR,
    pub ihPal: DWORD,
    pub iStart: DWORD,
    pub cEntries: DWORD,
    pub aPalEntries: [PALETTEENTRY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETPALETTEENTRIES"][::std::mem::size_of::<tagEMRSETPALETTEENTRIES>() - 24usize];
    ["Alignment of tagEMRSETPALETTEENTRIES"]
        [::std::mem::align_of::<tagEMRSETPALETTEENTRIES>() - 4usize];
    ["Offset of field: tagEMRSETPALETTEENTRIES::emr"]
        [::std::mem::offset_of!(tagEMRSETPALETTEENTRIES, emr) - 0usize];
    ["Offset of field: tagEMRSETPALETTEENTRIES::ihPal"]
        [::std::mem::offset_of!(tagEMRSETPALETTEENTRIES, ihPal) - 8usize];
    ["Offset of field: tagEMRSETPALETTEENTRIES::iStart"]
        [::std::mem::offset_of!(tagEMRSETPALETTEENTRIES, iStart) - 12usize];
    ["Offset of field: tagEMRSETPALETTEENTRIES::cEntries"]
        [::std::mem::offset_of!(tagEMRSETPALETTEENTRIES, cEntries) - 16usize];
    ["Offset of field: tagEMRSETPALETTEENTRIES::aPalEntries"]
        [::std::mem::offset_of!(tagEMRSETPALETTEENTRIES, aPalEntries) - 20usize];
};
pub type EMRSETPALETTEENTRIES = tagEMRSETPALETTEENTRIES;
pub type PEMRSETPALETTEENTRIES = *mut tagEMRSETPALETTEENTRIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETCOLORADJUSTMENT {
    pub emr: EMR,
    pub ColorAdjustment: COLORADJUSTMENT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETCOLORADJUSTMENT"]
        [::std::mem::size_of::<tagEMRSETCOLORADJUSTMENT>() - 32usize];
    ["Alignment of tagEMRSETCOLORADJUSTMENT"]
        [::std::mem::align_of::<tagEMRSETCOLORADJUSTMENT>() - 4usize];
    ["Offset of field: tagEMRSETCOLORADJUSTMENT::emr"]
        [::std::mem::offset_of!(tagEMRSETCOLORADJUSTMENT, emr) - 0usize];
    ["Offset of field: tagEMRSETCOLORADJUSTMENT::ColorAdjustment"]
        [::std::mem::offset_of!(tagEMRSETCOLORADJUSTMENT, ColorAdjustment) - 8usize];
};
pub type EMRSETCOLORADJUSTMENT = tagEMRSETCOLORADJUSTMENT;
pub type PEMRSETCOLORADJUSTMENT = *mut tagEMRSETCOLORADJUSTMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRGDICOMMENT {
    pub emr: EMR,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRGDICOMMENT"][::std::mem::size_of::<tagEMRGDICOMMENT>() - 16usize];
    ["Alignment of tagEMRGDICOMMENT"][::std::mem::align_of::<tagEMRGDICOMMENT>() - 4usize];
    ["Offset of field: tagEMRGDICOMMENT::emr"]
        [::std::mem::offset_of!(tagEMRGDICOMMENT, emr) - 0usize];
    ["Offset of field: tagEMRGDICOMMENT::cbData"]
        [::std::mem::offset_of!(tagEMRGDICOMMENT, cbData) - 8usize];
    ["Offset of field: tagEMRGDICOMMENT::Data"]
        [::std::mem::offset_of!(tagEMRGDICOMMENT, Data) - 12usize];
};
pub type EMRGDICOMMENT = tagEMRGDICOMMENT;
pub type PEMRGDICOMMENT = *mut tagEMRGDICOMMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREOF {
    pub emr: EMR,
    pub nPalEntries: DWORD,
    pub offPalEntries: DWORD,
    pub nSizeLast: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREOF"][::std::mem::size_of::<tagEMREOF>() - 20usize];
    ["Alignment of tagEMREOF"][::std::mem::align_of::<tagEMREOF>() - 4usize];
    ["Offset of field: tagEMREOF::emr"][::std::mem::offset_of!(tagEMREOF, emr) - 0usize];
    ["Offset of field: tagEMREOF::nPalEntries"]
        [::std::mem::offset_of!(tagEMREOF, nPalEntries) - 8usize];
    ["Offset of field: tagEMREOF::offPalEntries"]
        [::std::mem::offset_of!(tagEMREOF, offPalEntries) - 12usize];
    ["Offset of field: tagEMREOF::nSizeLast"]
        [::std::mem::offset_of!(tagEMREOF, nSizeLast) - 16usize];
};
pub type EMREOF = tagEMREOF;
pub type PEMREOF = *mut tagEMREOF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRLINETO {
    pub emr: EMR,
    pub ptl: POINTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRLINETO"][::std::mem::size_of::<tagEMRLINETO>() - 16usize];
    ["Alignment of tagEMRLINETO"][::std::mem::align_of::<tagEMRLINETO>() - 4usize];
    ["Offset of field: tagEMRLINETO::emr"][::std::mem::offset_of!(tagEMRLINETO, emr) - 0usize];
    ["Offset of field: tagEMRLINETO::ptl"][::std::mem::offset_of!(tagEMRLINETO, ptl) - 8usize];
};
pub type EMRLINETO = tagEMRLINETO;
pub type PEMRLINETO = *mut tagEMRLINETO;
pub type EMRMOVETOEX = tagEMRLINETO;
pub type PEMRMOVETOEX = *mut tagEMRLINETO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMROFFSETCLIPRGN {
    pub emr: EMR,
    pub ptlOffset: POINTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMROFFSETCLIPRGN"][::std::mem::size_of::<tagEMROFFSETCLIPRGN>() - 16usize];
    ["Alignment of tagEMROFFSETCLIPRGN"][::std::mem::align_of::<tagEMROFFSETCLIPRGN>() - 4usize];
    ["Offset of field: tagEMROFFSETCLIPRGN::emr"]
        [::std::mem::offset_of!(tagEMROFFSETCLIPRGN, emr) - 0usize];
    ["Offset of field: tagEMROFFSETCLIPRGN::ptlOffset"]
        [::std::mem::offset_of!(tagEMROFFSETCLIPRGN, ptlOffset) - 8usize];
};
pub type EMROFFSETCLIPRGN = tagEMROFFSETCLIPRGN;
pub type PEMROFFSETCLIPRGN = *mut tagEMROFFSETCLIPRGN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRFILLPATH {
    pub emr: EMR,
    pub rclBounds: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRFILLPATH"][::std::mem::size_of::<tagEMRFILLPATH>() - 24usize];
    ["Alignment of tagEMRFILLPATH"][::std::mem::align_of::<tagEMRFILLPATH>() - 4usize];
    ["Offset of field: tagEMRFILLPATH::emr"][::std::mem::offset_of!(tagEMRFILLPATH, emr) - 0usize];
    ["Offset of field: tagEMRFILLPATH::rclBounds"]
        [::std::mem::offset_of!(tagEMRFILLPATH, rclBounds) - 8usize];
};
pub type EMRFILLPATH = tagEMRFILLPATH;
pub type PEMRFILLPATH = *mut tagEMRFILLPATH;
pub type EMRSTROKEANDFILLPATH = tagEMRFILLPATH;
pub type PEMRSTROKEANDFILLPATH = *mut tagEMRFILLPATH;
pub type EMRSTROKEPATH = tagEMRFILLPATH;
pub type PEMRSTROKEPATH = *mut tagEMRFILLPATH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXCLUDECLIPRECT {
    pub emr: EMR,
    pub rclClip: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXCLUDECLIPRECT"][::std::mem::size_of::<tagEMREXCLUDECLIPRECT>() - 24usize];
    ["Alignment of tagEMREXCLUDECLIPRECT"]
        [::std::mem::align_of::<tagEMREXCLUDECLIPRECT>() - 4usize];
    ["Offset of field: tagEMREXCLUDECLIPRECT::emr"]
        [::std::mem::offset_of!(tagEMREXCLUDECLIPRECT, emr) - 0usize];
    ["Offset of field: tagEMREXCLUDECLIPRECT::rclClip"]
        [::std::mem::offset_of!(tagEMREXCLUDECLIPRECT, rclClip) - 8usize];
};
pub type EMREXCLUDECLIPRECT = tagEMREXCLUDECLIPRECT;
pub type PEMREXCLUDECLIPRECT = *mut tagEMREXCLUDECLIPRECT;
pub type EMRINTERSECTCLIPRECT = tagEMREXCLUDECLIPRECT;
pub type PEMRINTERSECTCLIPRECT = *mut tagEMREXCLUDECLIPRECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETVIEWPORTORGEX {
    pub emr: EMR,
    pub ptlOrigin: POINTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETVIEWPORTORGEX"][::std::mem::size_of::<tagEMRSETVIEWPORTORGEX>() - 16usize];
    ["Alignment of tagEMRSETVIEWPORTORGEX"]
        [::std::mem::align_of::<tagEMRSETVIEWPORTORGEX>() - 4usize];
    ["Offset of field: tagEMRSETVIEWPORTORGEX::emr"]
        [::std::mem::offset_of!(tagEMRSETVIEWPORTORGEX, emr) - 0usize];
    ["Offset of field: tagEMRSETVIEWPORTORGEX::ptlOrigin"]
        [::std::mem::offset_of!(tagEMRSETVIEWPORTORGEX, ptlOrigin) - 8usize];
};
pub type EMRSETVIEWPORTORGEX = tagEMRSETVIEWPORTORGEX;
pub type PEMRSETVIEWPORTORGEX = *mut tagEMRSETVIEWPORTORGEX;
pub type EMRSETWINDOWORGEX = tagEMRSETVIEWPORTORGEX;
pub type PEMRSETWINDOWORGEX = *mut tagEMRSETVIEWPORTORGEX;
pub type EMRSETBRUSHORGEX = tagEMRSETVIEWPORTORGEX;
pub type PEMRSETBRUSHORGEX = *mut tagEMRSETVIEWPORTORGEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETVIEWPORTEXTEX {
    pub emr: EMR,
    pub szlExtent: SIZEL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETVIEWPORTEXTEX"][::std::mem::size_of::<tagEMRSETVIEWPORTEXTEX>() - 16usize];
    ["Alignment of tagEMRSETVIEWPORTEXTEX"]
        [::std::mem::align_of::<tagEMRSETVIEWPORTEXTEX>() - 4usize];
    ["Offset of field: tagEMRSETVIEWPORTEXTEX::emr"]
        [::std::mem::offset_of!(tagEMRSETVIEWPORTEXTEX, emr) - 0usize];
    ["Offset of field: tagEMRSETVIEWPORTEXTEX::szlExtent"]
        [::std::mem::offset_of!(tagEMRSETVIEWPORTEXTEX, szlExtent) - 8usize];
};
pub type EMRSETVIEWPORTEXTEX = tagEMRSETVIEWPORTEXTEX;
pub type PEMRSETVIEWPORTEXTEX = *mut tagEMRSETVIEWPORTEXTEX;
pub type EMRSETWINDOWEXTEX = tagEMRSETVIEWPORTEXTEX;
pub type PEMRSETWINDOWEXTEX = *mut tagEMRSETVIEWPORTEXTEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSCALEVIEWPORTEXTEX {
    pub emr: EMR,
    pub xNum: LONG,
    pub xDenom: LONG,
    pub yNum: LONG,
    pub yDenom: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSCALEVIEWPORTEXTEX"]
        [::std::mem::size_of::<tagEMRSCALEVIEWPORTEXTEX>() - 24usize];
    ["Alignment of tagEMRSCALEVIEWPORTEXTEX"]
        [::std::mem::align_of::<tagEMRSCALEVIEWPORTEXTEX>() - 4usize];
    ["Offset of field: tagEMRSCALEVIEWPORTEXTEX::emr"]
        [::std::mem::offset_of!(tagEMRSCALEVIEWPORTEXTEX, emr) - 0usize];
    ["Offset of field: tagEMRSCALEVIEWPORTEXTEX::xNum"]
        [::std::mem::offset_of!(tagEMRSCALEVIEWPORTEXTEX, xNum) - 8usize];
    ["Offset of field: tagEMRSCALEVIEWPORTEXTEX::xDenom"]
        [::std::mem::offset_of!(tagEMRSCALEVIEWPORTEXTEX, xDenom) - 12usize];
    ["Offset of field: tagEMRSCALEVIEWPORTEXTEX::yNum"]
        [::std::mem::offset_of!(tagEMRSCALEVIEWPORTEXTEX, yNum) - 16usize];
    ["Offset of field: tagEMRSCALEVIEWPORTEXTEX::yDenom"]
        [::std::mem::offset_of!(tagEMRSCALEVIEWPORTEXTEX, yDenom) - 20usize];
};
pub type EMRSCALEVIEWPORTEXTEX = tagEMRSCALEVIEWPORTEXTEX;
pub type PEMRSCALEVIEWPORTEXTEX = *mut tagEMRSCALEVIEWPORTEXTEX;
pub type EMRSCALEWINDOWEXTEX = tagEMRSCALEVIEWPORTEXTEX;
pub type PEMRSCALEWINDOWEXTEX = *mut tagEMRSCALEVIEWPORTEXTEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETWORLDTRANSFORM {
    pub emr: EMR,
    pub xform: XFORM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETWORLDTRANSFORM"][::std::mem::size_of::<tagEMRSETWORLDTRANSFORM>() - 32usize];
    ["Alignment of tagEMRSETWORLDTRANSFORM"]
        [::std::mem::align_of::<tagEMRSETWORLDTRANSFORM>() - 4usize];
    ["Offset of field: tagEMRSETWORLDTRANSFORM::emr"]
        [::std::mem::offset_of!(tagEMRSETWORLDTRANSFORM, emr) - 0usize];
    ["Offset of field: tagEMRSETWORLDTRANSFORM::xform"]
        [::std::mem::offset_of!(tagEMRSETWORLDTRANSFORM, xform) - 8usize];
};
pub type EMRSETWORLDTRANSFORM = tagEMRSETWORLDTRANSFORM;
pub type PEMRSETWORLDTRANSFORM = *mut tagEMRSETWORLDTRANSFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRMODIFYWORLDTRANSFORM {
    pub emr: EMR,
    pub xform: XFORM,
    pub iMode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRMODIFYWORLDTRANSFORM"]
        [::std::mem::size_of::<tagEMRMODIFYWORLDTRANSFORM>() - 36usize];
    ["Alignment of tagEMRMODIFYWORLDTRANSFORM"]
        [::std::mem::align_of::<tagEMRMODIFYWORLDTRANSFORM>() - 4usize];
    ["Offset of field: tagEMRMODIFYWORLDTRANSFORM::emr"]
        [::std::mem::offset_of!(tagEMRMODIFYWORLDTRANSFORM, emr) - 0usize];
    ["Offset of field: tagEMRMODIFYWORLDTRANSFORM::xform"]
        [::std::mem::offset_of!(tagEMRMODIFYWORLDTRANSFORM, xform) - 8usize];
    ["Offset of field: tagEMRMODIFYWORLDTRANSFORM::iMode"]
        [::std::mem::offset_of!(tagEMRMODIFYWORLDTRANSFORM, iMode) - 32usize];
};
pub type EMRMODIFYWORLDTRANSFORM = tagEMRMODIFYWORLDTRANSFORM;
pub type PEMRMODIFYWORLDTRANSFORM = *mut tagEMRMODIFYWORLDTRANSFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETPIXELV {
    pub emr: EMR,
    pub ptlPixel: POINTL,
    pub crColor: COLORREF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETPIXELV"][::std::mem::size_of::<tagEMRSETPIXELV>() - 20usize];
    ["Alignment of tagEMRSETPIXELV"][::std::mem::align_of::<tagEMRSETPIXELV>() - 4usize];
    ["Offset of field: tagEMRSETPIXELV::emr"]
        [::std::mem::offset_of!(tagEMRSETPIXELV, emr) - 0usize];
    ["Offset of field: tagEMRSETPIXELV::ptlPixel"]
        [::std::mem::offset_of!(tagEMRSETPIXELV, ptlPixel) - 8usize];
    ["Offset of field: tagEMRSETPIXELV::crColor"]
        [::std::mem::offset_of!(tagEMRSETPIXELV, crColor) - 16usize];
};
pub type EMRSETPIXELV = tagEMRSETPIXELV;
pub type PEMRSETPIXELV = *mut tagEMRSETPIXELV;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTFLOODFILL {
    pub emr: EMR,
    pub ptlStart: POINTL,
    pub crColor: COLORREF,
    pub iMode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTFLOODFILL"][::std::mem::size_of::<tagEMREXTFLOODFILL>() - 24usize];
    ["Alignment of tagEMREXTFLOODFILL"][::std::mem::align_of::<tagEMREXTFLOODFILL>() - 4usize];
    ["Offset of field: tagEMREXTFLOODFILL::emr"]
        [::std::mem::offset_of!(tagEMREXTFLOODFILL, emr) - 0usize];
    ["Offset of field: tagEMREXTFLOODFILL::ptlStart"]
        [::std::mem::offset_of!(tagEMREXTFLOODFILL, ptlStart) - 8usize];
    ["Offset of field: tagEMREXTFLOODFILL::crColor"]
        [::std::mem::offset_of!(tagEMREXTFLOODFILL, crColor) - 16usize];
    ["Offset of field: tagEMREXTFLOODFILL::iMode"]
        [::std::mem::offset_of!(tagEMREXTFLOODFILL, iMode) - 20usize];
};
pub type EMREXTFLOODFILL = tagEMREXTFLOODFILL;
pub type PEMREXTFLOODFILL = *mut tagEMREXTFLOODFILL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRELLIPSE {
    pub emr: EMR,
    pub rclBox: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRELLIPSE"][::std::mem::size_of::<tagEMRELLIPSE>() - 24usize];
    ["Alignment of tagEMRELLIPSE"][::std::mem::align_of::<tagEMRELLIPSE>() - 4usize];
    ["Offset of field: tagEMRELLIPSE::emr"][::std::mem::offset_of!(tagEMRELLIPSE, emr) - 0usize];
    ["Offset of field: tagEMRELLIPSE::rclBox"]
        [::std::mem::offset_of!(tagEMRELLIPSE, rclBox) - 8usize];
};
pub type EMRELLIPSE = tagEMRELLIPSE;
pub type PEMRELLIPSE = *mut tagEMRELLIPSE;
pub type EMRRECTANGLE = tagEMRELLIPSE;
pub type PEMRRECTANGLE = *mut tagEMRELLIPSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRROUNDRECT {
    pub emr: EMR,
    pub rclBox: RECTL,
    pub szlCorner: SIZEL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRROUNDRECT"][::std::mem::size_of::<tagEMRROUNDRECT>() - 32usize];
    ["Alignment of tagEMRROUNDRECT"][::std::mem::align_of::<tagEMRROUNDRECT>() - 4usize];
    ["Offset of field: tagEMRROUNDRECT::emr"]
        [::std::mem::offset_of!(tagEMRROUNDRECT, emr) - 0usize];
    ["Offset of field: tagEMRROUNDRECT::rclBox"]
        [::std::mem::offset_of!(tagEMRROUNDRECT, rclBox) - 8usize];
    ["Offset of field: tagEMRROUNDRECT::szlCorner"]
        [::std::mem::offset_of!(tagEMRROUNDRECT, szlCorner) - 24usize];
};
pub type EMRROUNDRECT = tagEMRROUNDRECT;
pub type PEMRROUNDRECT = *mut tagEMRROUNDRECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRARC {
    pub emr: EMR,
    pub rclBox: RECTL,
    pub ptlStart: POINTL,
    pub ptlEnd: POINTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRARC"][::std::mem::size_of::<tagEMRARC>() - 40usize];
    ["Alignment of tagEMRARC"][::std::mem::align_of::<tagEMRARC>() - 4usize];
    ["Offset of field: tagEMRARC::emr"][::std::mem::offset_of!(tagEMRARC, emr) - 0usize];
    ["Offset of field: tagEMRARC::rclBox"][::std::mem::offset_of!(tagEMRARC, rclBox) - 8usize];
    ["Offset of field: tagEMRARC::ptlStart"][::std::mem::offset_of!(tagEMRARC, ptlStart) - 24usize];
    ["Offset of field: tagEMRARC::ptlEnd"][::std::mem::offset_of!(tagEMRARC, ptlEnd) - 32usize];
};
pub type EMRARC = tagEMRARC;
pub type PEMRARC = *mut tagEMRARC;
pub type EMRARCTO = tagEMRARC;
pub type PEMRARCTO = *mut tagEMRARC;
pub type EMRCHORD = tagEMRARC;
pub type PEMRCHORD = *mut tagEMRARC;
pub type EMRPIE = tagEMRARC;
pub type PEMRPIE = *mut tagEMRARC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRANGLEARC {
    pub emr: EMR,
    pub ptlCenter: POINTL,
    pub nRadius: DWORD,
    pub eStartAngle: FLOAT,
    pub eSweepAngle: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRANGLEARC"][::std::mem::size_of::<tagEMRANGLEARC>() - 28usize];
    ["Alignment of tagEMRANGLEARC"][::std::mem::align_of::<tagEMRANGLEARC>() - 4usize];
    ["Offset of field: tagEMRANGLEARC::emr"][::std::mem::offset_of!(tagEMRANGLEARC, emr) - 0usize];
    ["Offset of field: tagEMRANGLEARC::ptlCenter"]
        [::std::mem::offset_of!(tagEMRANGLEARC, ptlCenter) - 8usize];
    ["Offset of field: tagEMRANGLEARC::nRadius"]
        [::std::mem::offset_of!(tagEMRANGLEARC, nRadius) - 16usize];
    ["Offset of field: tagEMRANGLEARC::eStartAngle"]
        [::std::mem::offset_of!(tagEMRANGLEARC, eStartAngle) - 20usize];
    ["Offset of field: tagEMRANGLEARC::eSweepAngle"]
        [::std::mem::offset_of!(tagEMRANGLEARC, eSweepAngle) - 24usize];
};
pub type EMRANGLEARC = tagEMRANGLEARC;
pub type PEMRANGLEARC = *mut tagEMRANGLEARC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYLINE {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cptl: DWORD,
    pub aptl: [POINTL; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYLINE"][::std::mem::size_of::<tagEMRPOLYLINE>() - 36usize];
    ["Alignment of tagEMRPOLYLINE"][::std::mem::align_of::<tagEMRPOLYLINE>() - 4usize];
    ["Offset of field: tagEMRPOLYLINE::emr"][::std::mem::offset_of!(tagEMRPOLYLINE, emr) - 0usize];
    ["Offset of field: tagEMRPOLYLINE::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYLINE, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYLINE::cptl"]
        [::std::mem::offset_of!(tagEMRPOLYLINE, cptl) - 24usize];
    ["Offset of field: tagEMRPOLYLINE::aptl"]
        [::std::mem::offset_of!(tagEMRPOLYLINE, aptl) - 28usize];
};
pub type EMRPOLYLINE = tagEMRPOLYLINE;
pub type PEMRPOLYLINE = *mut tagEMRPOLYLINE;
pub type EMRPOLYBEZIER = tagEMRPOLYLINE;
pub type PEMRPOLYBEZIER = *mut tagEMRPOLYLINE;
pub type EMRPOLYGON = tagEMRPOLYLINE;
pub type PEMRPOLYGON = *mut tagEMRPOLYLINE;
pub type EMRPOLYBEZIERTO = tagEMRPOLYLINE;
pub type PEMRPOLYBEZIERTO = *mut tagEMRPOLYLINE;
pub type EMRPOLYLINETO = tagEMRPOLYLINE;
pub type PEMRPOLYLINETO = *mut tagEMRPOLYLINE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYLINE16 {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cpts: DWORD,
    pub apts: [POINTS; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYLINE16"][::std::mem::size_of::<tagEMRPOLYLINE16>() - 32usize];
    ["Alignment of tagEMRPOLYLINE16"][::std::mem::align_of::<tagEMRPOLYLINE16>() - 4usize];
    ["Offset of field: tagEMRPOLYLINE16::emr"]
        [::std::mem::offset_of!(tagEMRPOLYLINE16, emr) - 0usize];
    ["Offset of field: tagEMRPOLYLINE16::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYLINE16, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYLINE16::cpts"]
        [::std::mem::offset_of!(tagEMRPOLYLINE16, cpts) - 24usize];
    ["Offset of field: tagEMRPOLYLINE16::apts"]
        [::std::mem::offset_of!(tagEMRPOLYLINE16, apts) - 28usize];
};
pub type EMRPOLYLINE16 = tagEMRPOLYLINE16;
pub type PEMRPOLYLINE16 = *mut tagEMRPOLYLINE16;
pub type EMRPOLYBEZIER16 = tagEMRPOLYLINE16;
pub type PEMRPOLYBEZIER16 = *mut tagEMRPOLYLINE16;
pub type EMRPOLYGON16 = tagEMRPOLYLINE16;
pub type PEMRPOLYGON16 = *mut tagEMRPOLYLINE16;
pub type EMRPOLYBEZIERTO16 = tagEMRPOLYLINE16;
pub type PEMRPOLYBEZIERTO16 = *mut tagEMRPOLYLINE16;
pub type EMRPOLYLINETO16 = tagEMRPOLYLINE16;
pub type PEMRPOLYLINETO16 = *mut tagEMRPOLYLINE16;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYDRAW {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cptl: DWORD,
    pub aptl: [POINTL; 1usize],
    pub abTypes: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYDRAW"][::std::mem::size_of::<tagEMRPOLYDRAW>() - 40usize];
    ["Alignment of tagEMRPOLYDRAW"][::std::mem::align_of::<tagEMRPOLYDRAW>() - 4usize];
    ["Offset of field: tagEMRPOLYDRAW::emr"][::std::mem::offset_of!(tagEMRPOLYDRAW, emr) - 0usize];
    ["Offset of field: tagEMRPOLYDRAW::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYDRAW::cptl"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW, cptl) - 24usize];
    ["Offset of field: tagEMRPOLYDRAW::aptl"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW, aptl) - 28usize];
    ["Offset of field: tagEMRPOLYDRAW::abTypes"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW, abTypes) - 36usize];
};
pub type EMRPOLYDRAW = tagEMRPOLYDRAW;
pub type PEMRPOLYDRAW = *mut tagEMRPOLYDRAW;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYDRAW16 {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cpts: DWORD,
    pub apts: [POINTS; 1usize],
    pub abTypes: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYDRAW16"][::std::mem::size_of::<tagEMRPOLYDRAW16>() - 36usize];
    ["Alignment of tagEMRPOLYDRAW16"][::std::mem::align_of::<tagEMRPOLYDRAW16>() - 4usize];
    ["Offset of field: tagEMRPOLYDRAW16::emr"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW16, emr) - 0usize];
    ["Offset of field: tagEMRPOLYDRAW16::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW16, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYDRAW16::cpts"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW16, cpts) - 24usize];
    ["Offset of field: tagEMRPOLYDRAW16::apts"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW16, apts) - 28usize];
    ["Offset of field: tagEMRPOLYDRAW16::abTypes"]
        [::std::mem::offset_of!(tagEMRPOLYDRAW16, abTypes) - 32usize];
};
pub type EMRPOLYDRAW16 = tagEMRPOLYDRAW16;
pub type PEMRPOLYDRAW16 = *mut tagEMRPOLYDRAW16;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYPOLYLINE {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub nPolys: DWORD,
    pub cptl: DWORD,
    pub aPolyCounts: [DWORD; 1usize],
    pub aptl: [POINTL; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYPOLYLINE"][::std::mem::size_of::<tagEMRPOLYPOLYLINE>() - 44usize];
    ["Alignment of tagEMRPOLYPOLYLINE"][::std::mem::align_of::<tagEMRPOLYPOLYLINE>() - 4usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::emr"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, emr) - 0usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::nPolys"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, nPolys) - 24usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::cptl"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, cptl) - 28usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::aPolyCounts"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, aPolyCounts) - 32usize];
    ["Offset of field: tagEMRPOLYPOLYLINE::aptl"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE, aptl) - 36usize];
};
pub type EMRPOLYPOLYLINE = tagEMRPOLYPOLYLINE;
pub type PEMRPOLYPOLYLINE = *mut tagEMRPOLYPOLYLINE;
pub type EMRPOLYPOLYGON = tagEMRPOLYPOLYLINE;
pub type PEMRPOLYPOLYGON = *mut tagEMRPOLYPOLYLINE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYPOLYLINE16 {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub nPolys: DWORD,
    pub cpts: DWORD,
    pub aPolyCounts: [DWORD; 1usize],
    pub apts: [POINTS; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYPOLYLINE16"][::std::mem::size_of::<tagEMRPOLYPOLYLINE16>() - 40usize];
    ["Alignment of tagEMRPOLYPOLYLINE16"][::std::mem::align_of::<tagEMRPOLYPOLYLINE16>() - 4usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::emr"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, emr) - 0usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::nPolys"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, nPolys) - 24usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::cpts"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, cpts) - 28usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::aPolyCounts"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, aPolyCounts) - 32usize];
    ["Offset of field: tagEMRPOLYPOLYLINE16::apts"]
        [::std::mem::offset_of!(tagEMRPOLYPOLYLINE16, apts) - 36usize];
};
pub type EMRPOLYPOLYLINE16 = tagEMRPOLYPOLYLINE16;
pub type PEMRPOLYPOLYLINE16 = *mut tagEMRPOLYPOLYLINE16;
pub type EMRPOLYPOLYGON16 = tagEMRPOLYPOLYLINE16;
pub type PEMRPOLYPOLYGON16 = *mut tagEMRPOLYPOLYLINE16;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRINVERTRGN {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cbRgnData: DWORD,
    pub RgnData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRINVERTRGN"][::std::mem::size_of::<tagEMRINVERTRGN>() - 32usize];
    ["Alignment of tagEMRINVERTRGN"][::std::mem::align_of::<tagEMRINVERTRGN>() - 4usize];
    ["Offset of field: tagEMRINVERTRGN::emr"]
        [::std::mem::offset_of!(tagEMRINVERTRGN, emr) - 0usize];
    ["Offset of field: tagEMRINVERTRGN::rclBounds"]
        [::std::mem::offset_of!(tagEMRINVERTRGN, rclBounds) - 8usize];
    ["Offset of field: tagEMRINVERTRGN::cbRgnData"]
        [::std::mem::offset_of!(tagEMRINVERTRGN, cbRgnData) - 24usize];
    ["Offset of field: tagEMRINVERTRGN::RgnData"]
        [::std::mem::offset_of!(tagEMRINVERTRGN, RgnData) - 28usize];
};
pub type EMRINVERTRGN = tagEMRINVERTRGN;
pub type PEMRINVERTRGN = *mut tagEMRINVERTRGN;
pub type EMRPAINTRGN = tagEMRINVERTRGN;
pub type PEMRPAINTRGN = *mut tagEMRINVERTRGN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRFILLRGN {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cbRgnData: DWORD,
    pub ihBrush: DWORD,
    pub RgnData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRFILLRGN"][::std::mem::size_of::<tagEMRFILLRGN>() - 36usize];
    ["Alignment of tagEMRFILLRGN"][::std::mem::align_of::<tagEMRFILLRGN>() - 4usize];
    ["Offset of field: tagEMRFILLRGN::emr"][::std::mem::offset_of!(tagEMRFILLRGN, emr) - 0usize];
    ["Offset of field: tagEMRFILLRGN::rclBounds"]
        [::std::mem::offset_of!(tagEMRFILLRGN, rclBounds) - 8usize];
    ["Offset of field: tagEMRFILLRGN::cbRgnData"]
        [::std::mem::offset_of!(tagEMRFILLRGN, cbRgnData) - 24usize];
    ["Offset of field: tagEMRFILLRGN::ihBrush"]
        [::std::mem::offset_of!(tagEMRFILLRGN, ihBrush) - 28usize];
    ["Offset of field: tagEMRFILLRGN::RgnData"]
        [::std::mem::offset_of!(tagEMRFILLRGN, RgnData) - 32usize];
};
pub type EMRFILLRGN = tagEMRFILLRGN;
pub type PEMRFILLRGN = *mut tagEMRFILLRGN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRFRAMERGN {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cbRgnData: DWORD,
    pub ihBrush: DWORD,
    pub szlStroke: SIZEL,
    pub RgnData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRFRAMERGN"][::std::mem::size_of::<tagEMRFRAMERGN>() - 44usize];
    ["Alignment of tagEMRFRAMERGN"][::std::mem::align_of::<tagEMRFRAMERGN>() - 4usize];
    ["Offset of field: tagEMRFRAMERGN::emr"][::std::mem::offset_of!(tagEMRFRAMERGN, emr) - 0usize];
    ["Offset of field: tagEMRFRAMERGN::rclBounds"]
        [::std::mem::offset_of!(tagEMRFRAMERGN, rclBounds) - 8usize];
    ["Offset of field: tagEMRFRAMERGN::cbRgnData"]
        [::std::mem::offset_of!(tagEMRFRAMERGN, cbRgnData) - 24usize];
    ["Offset of field: tagEMRFRAMERGN::ihBrush"]
        [::std::mem::offset_of!(tagEMRFRAMERGN, ihBrush) - 28usize];
    ["Offset of field: tagEMRFRAMERGN::szlStroke"]
        [::std::mem::offset_of!(tagEMRFRAMERGN, szlStroke) - 32usize];
    ["Offset of field: tagEMRFRAMERGN::RgnData"]
        [::std::mem::offset_of!(tagEMRFRAMERGN, RgnData) - 40usize];
};
pub type EMRFRAMERGN = tagEMRFRAMERGN;
pub type PEMRFRAMERGN = *mut tagEMRFRAMERGN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTSELECTCLIPRGN {
    pub emr: EMR,
    pub cbRgnData: DWORD,
    pub iMode: DWORD,
    pub RgnData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTSELECTCLIPRGN"][::std::mem::size_of::<tagEMREXTSELECTCLIPRGN>() - 20usize];
    ["Alignment of tagEMREXTSELECTCLIPRGN"]
        [::std::mem::align_of::<tagEMREXTSELECTCLIPRGN>() - 4usize];
    ["Offset of field: tagEMREXTSELECTCLIPRGN::emr"]
        [::std::mem::offset_of!(tagEMREXTSELECTCLIPRGN, emr) - 0usize];
    ["Offset of field: tagEMREXTSELECTCLIPRGN::cbRgnData"]
        [::std::mem::offset_of!(tagEMREXTSELECTCLIPRGN, cbRgnData) - 8usize];
    ["Offset of field: tagEMREXTSELECTCLIPRGN::iMode"]
        [::std::mem::offset_of!(tagEMREXTSELECTCLIPRGN, iMode) - 12usize];
    ["Offset of field: tagEMREXTSELECTCLIPRGN::RgnData"]
        [::std::mem::offset_of!(tagEMREXTSELECTCLIPRGN, RgnData) - 16usize];
};
pub type EMREXTSELECTCLIPRGN = tagEMREXTSELECTCLIPRGN;
pub type PEMREXTSELECTCLIPRGN = *mut tagEMREXTSELECTCLIPRGN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTTEXTOUTA {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub iGraphicsMode: DWORD,
    pub exScale: FLOAT,
    pub eyScale: FLOAT,
    pub emrtext: EMRTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTTEXTOUTA"][::std::mem::size_of::<tagEMREXTTEXTOUTA>() - 76usize];
    ["Alignment of tagEMREXTTEXTOUTA"][::std::mem::align_of::<tagEMREXTTEXTOUTA>() - 4usize];
    ["Offset of field: tagEMREXTTEXTOUTA::emr"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, emr) - 0usize];
    ["Offset of field: tagEMREXTTEXTOUTA::rclBounds"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, rclBounds) - 8usize];
    ["Offset of field: tagEMREXTTEXTOUTA::iGraphicsMode"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, iGraphicsMode) - 24usize];
    ["Offset of field: tagEMREXTTEXTOUTA::exScale"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, exScale) - 28usize];
    ["Offset of field: tagEMREXTTEXTOUTA::eyScale"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, eyScale) - 32usize];
    ["Offset of field: tagEMREXTTEXTOUTA::emrtext"]
        [::std::mem::offset_of!(tagEMREXTTEXTOUTA, emrtext) - 36usize];
};
pub type EMREXTTEXTOUTA = tagEMREXTTEXTOUTA;
pub type PEMREXTTEXTOUTA = *mut tagEMREXTTEXTOUTA;
pub type EMREXTTEXTOUTW = tagEMREXTTEXTOUTA;
pub type PEMREXTTEXTOUTW = *mut tagEMREXTTEXTOUTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPOLYTEXTOUTA {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub iGraphicsMode: DWORD,
    pub exScale: FLOAT,
    pub eyScale: FLOAT,
    pub cStrings: LONG,
    pub aemrtext: [EMRTEXT; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPOLYTEXTOUTA"][::std::mem::size_of::<tagEMRPOLYTEXTOUTA>() - 80usize];
    ["Alignment of tagEMRPOLYTEXTOUTA"][::std::mem::align_of::<tagEMRPOLYTEXTOUTA>() - 4usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::emr"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, emr) - 0usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::rclBounds"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, rclBounds) - 8usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::iGraphicsMode"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, iGraphicsMode) - 24usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::exScale"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, exScale) - 28usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::eyScale"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, eyScale) - 32usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::cStrings"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, cStrings) - 36usize];
    ["Offset of field: tagEMRPOLYTEXTOUTA::aemrtext"]
        [::std::mem::offset_of!(tagEMRPOLYTEXTOUTA, aemrtext) - 40usize];
};
pub type EMRPOLYTEXTOUTA = tagEMRPOLYTEXTOUTA;
pub type PEMRPOLYTEXTOUTA = *mut tagEMRPOLYTEXTOUTA;
pub type EMRPOLYTEXTOUTW = tagEMRPOLYTEXTOUTA;
pub type PEMRPOLYTEXTOUTW = *mut tagEMRPOLYTEXTOUTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRBITBLT {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub cxDest: LONG,
    pub cyDest: LONG,
    pub dwRop: DWORD,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRBITBLT"][::std::mem::size_of::<tagEMRBITBLT>() - 100usize];
    ["Alignment of tagEMRBITBLT"][::std::mem::align_of::<tagEMRBITBLT>() - 4usize];
    ["Offset of field: tagEMRBITBLT::emr"][::std::mem::offset_of!(tagEMRBITBLT, emr) - 0usize];
    ["Offset of field: tagEMRBITBLT::rclBounds"]
        [::std::mem::offset_of!(tagEMRBITBLT, rclBounds) - 8usize];
    ["Offset of field: tagEMRBITBLT::xDest"][::std::mem::offset_of!(tagEMRBITBLT, xDest) - 24usize];
    ["Offset of field: tagEMRBITBLT::yDest"][::std::mem::offset_of!(tagEMRBITBLT, yDest) - 28usize];
    ["Offset of field: tagEMRBITBLT::cxDest"]
        [::std::mem::offset_of!(tagEMRBITBLT, cxDest) - 32usize];
    ["Offset of field: tagEMRBITBLT::cyDest"]
        [::std::mem::offset_of!(tagEMRBITBLT, cyDest) - 36usize];
    ["Offset of field: tagEMRBITBLT::dwRop"][::std::mem::offset_of!(tagEMRBITBLT, dwRop) - 40usize];
    ["Offset of field: tagEMRBITBLT::xSrc"][::std::mem::offset_of!(tagEMRBITBLT, xSrc) - 44usize];
    ["Offset of field: tagEMRBITBLT::ySrc"][::std::mem::offset_of!(tagEMRBITBLT, ySrc) - 48usize];
    ["Offset of field: tagEMRBITBLT::xformSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, xformSrc) - 52usize];
    ["Offset of field: tagEMRBITBLT::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, crBkColorSrc) - 76usize];
    ["Offset of field: tagEMRBITBLT::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, iUsageSrc) - 80usize];
    ["Offset of field: tagEMRBITBLT::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, offBmiSrc) - 84usize];
    ["Offset of field: tagEMRBITBLT::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, cbBmiSrc) - 88usize];
    ["Offset of field: tagEMRBITBLT::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, offBitsSrc) - 92usize];
    ["Offset of field: tagEMRBITBLT::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRBITBLT, cbBitsSrc) - 96usize];
};
pub type EMRBITBLT = tagEMRBITBLT;
pub type PEMRBITBLT = *mut tagEMRBITBLT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSTRETCHBLT {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub cxDest: LONG,
    pub cyDest: LONG,
    pub dwRop: DWORD,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub cxSrc: LONG,
    pub cySrc: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSTRETCHBLT"][::std::mem::size_of::<tagEMRSTRETCHBLT>() - 108usize];
    ["Alignment of tagEMRSTRETCHBLT"][::std::mem::align_of::<tagEMRSTRETCHBLT>() - 4usize];
    ["Offset of field: tagEMRSTRETCHBLT::emr"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, emr) - 0usize];
    ["Offset of field: tagEMRSTRETCHBLT::rclBounds"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, rclBounds) - 8usize];
    ["Offset of field: tagEMRSTRETCHBLT::xDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, xDest) - 24usize];
    ["Offset of field: tagEMRSTRETCHBLT::yDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, yDest) - 28usize];
    ["Offset of field: tagEMRSTRETCHBLT::cxDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cxDest) - 32usize];
    ["Offset of field: tagEMRSTRETCHBLT::cyDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cyDest) - 36usize];
    ["Offset of field: tagEMRSTRETCHBLT::dwRop"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, dwRop) - 40usize];
    ["Offset of field: tagEMRSTRETCHBLT::xSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, xSrc) - 44usize];
    ["Offset of field: tagEMRSTRETCHBLT::ySrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, ySrc) - 48usize];
    ["Offset of field: tagEMRSTRETCHBLT::xformSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, xformSrc) - 52usize];
    ["Offset of field: tagEMRSTRETCHBLT::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, crBkColorSrc) - 76usize];
    ["Offset of field: tagEMRSTRETCHBLT::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, iUsageSrc) - 80usize];
    ["Offset of field: tagEMRSTRETCHBLT::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, offBmiSrc) - 84usize];
    ["Offset of field: tagEMRSTRETCHBLT::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cbBmiSrc) - 88usize];
    ["Offset of field: tagEMRSTRETCHBLT::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, offBitsSrc) - 92usize];
    ["Offset of field: tagEMRSTRETCHBLT::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cbBitsSrc) - 96usize];
    ["Offset of field: tagEMRSTRETCHBLT::cxSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cxSrc) - 100usize];
    ["Offset of field: tagEMRSTRETCHBLT::cySrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHBLT, cySrc) - 104usize];
};
pub type EMRSTRETCHBLT = tagEMRSTRETCHBLT;
pub type PEMRSTRETCHBLT = *mut tagEMRSTRETCHBLT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRMASKBLT {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub cxDest: LONG,
    pub cyDest: LONG,
    pub dwRop: DWORD,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub xMask: LONG,
    pub yMask: LONG,
    pub iUsageMask: DWORD,
    pub offBmiMask: DWORD,
    pub cbBmiMask: DWORD,
    pub offBitsMask: DWORD,
    pub cbBitsMask: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRMASKBLT"][::std::mem::size_of::<tagEMRMASKBLT>() - 128usize];
    ["Alignment of tagEMRMASKBLT"][::std::mem::align_of::<tagEMRMASKBLT>() - 4usize];
    ["Offset of field: tagEMRMASKBLT::emr"][::std::mem::offset_of!(tagEMRMASKBLT, emr) - 0usize];
    ["Offset of field: tagEMRMASKBLT::rclBounds"]
        [::std::mem::offset_of!(tagEMRMASKBLT, rclBounds) - 8usize];
    ["Offset of field: tagEMRMASKBLT::xDest"]
        [::std::mem::offset_of!(tagEMRMASKBLT, xDest) - 24usize];
    ["Offset of field: tagEMRMASKBLT::yDest"]
        [::std::mem::offset_of!(tagEMRMASKBLT, yDest) - 28usize];
    ["Offset of field: tagEMRMASKBLT::cxDest"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cxDest) - 32usize];
    ["Offset of field: tagEMRMASKBLT::cyDest"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cyDest) - 36usize];
    ["Offset of field: tagEMRMASKBLT::dwRop"]
        [::std::mem::offset_of!(tagEMRMASKBLT, dwRop) - 40usize];
    ["Offset of field: tagEMRMASKBLT::xSrc"][::std::mem::offset_of!(tagEMRMASKBLT, xSrc) - 44usize];
    ["Offset of field: tagEMRMASKBLT::ySrc"][::std::mem::offset_of!(tagEMRMASKBLT, ySrc) - 48usize];
    ["Offset of field: tagEMRMASKBLT::xformSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, xformSrc) - 52usize];
    ["Offset of field: tagEMRMASKBLT::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, crBkColorSrc) - 76usize];
    ["Offset of field: tagEMRMASKBLT::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, iUsageSrc) - 80usize];
    ["Offset of field: tagEMRMASKBLT::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, offBmiSrc) - 84usize];
    ["Offset of field: tagEMRMASKBLT::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cbBmiSrc) - 88usize];
    ["Offset of field: tagEMRMASKBLT::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, offBitsSrc) - 92usize];
    ["Offset of field: tagEMRMASKBLT::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cbBitsSrc) - 96usize];
    ["Offset of field: tagEMRMASKBLT::xMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, xMask) - 100usize];
    ["Offset of field: tagEMRMASKBLT::yMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, yMask) - 104usize];
    ["Offset of field: tagEMRMASKBLT::iUsageMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, iUsageMask) - 108usize];
    ["Offset of field: tagEMRMASKBLT::offBmiMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, offBmiMask) - 112usize];
    ["Offset of field: tagEMRMASKBLT::cbBmiMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cbBmiMask) - 116usize];
    ["Offset of field: tagEMRMASKBLT::offBitsMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, offBitsMask) - 120usize];
    ["Offset of field: tagEMRMASKBLT::cbBitsMask"]
        [::std::mem::offset_of!(tagEMRMASKBLT, cbBitsMask) - 124usize];
};
pub type EMRMASKBLT = tagEMRMASKBLT;
pub type PEMRMASKBLT = *mut tagEMRMASKBLT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPLGBLT {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub aptlDest: [POINTL; 3usize],
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub cxSrc: LONG,
    pub cySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub xMask: LONG,
    pub yMask: LONG,
    pub iUsageMask: DWORD,
    pub offBmiMask: DWORD,
    pub cbBmiMask: DWORD,
    pub offBitsMask: DWORD,
    pub cbBitsMask: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPLGBLT"][::std::mem::size_of::<tagEMRPLGBLT>() - 140usize];
    ["Alignment of tagEMRPLGBLT"][::std::mem::align_of::<tagEMRPLGBLT>() - 4usize];
    ["Offset of field: tagEMRPLGBLT::emr"][::std::mem::offset_of!(tagEMRPLGBLT, emr) - 0usize];
    ["Offset of field: tagEMRPLGBLT::rclBounds"]
        [::std::mem::offset_of!(tagEMRPLGBLT, rclBounds) - 8usize];
    ["Offset of field: tagEMRPLGBLT::aptlDest"]
        [::std::mem::offset_of!(tagEMRPLGBLT, aptlDest) - 24usize];
    ["Offset of field: tagEMRPLGBLT::xSrc"][::std::mem::offset_of!(tagEMRPLGBLT, xSrc) - 48usize];
    ["Offset of field: tagEMRPLGBLT::ySrc"][::std::mem::offset_of!(tagEMRPLGBLT, ySrc) - 52usize];
    ["Offset of field: tagEMRPLGBLT::cxSrc"][::std::mem::offset_of!(tagEMRPLGBLT, cxSrc) - 56usize];
    ["Offset of field: tagEMRPLGBLT::cySrc"][::std::mem::offset_of!(tagEMRPLGBLT, cySrc) - 60usize];
    ["Offset of field: tagEMRPLGBLT::xformSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, xformSrc) - 64usize];
    ["Offset of field: tagEMRPLGBLT::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, crBkColorSrc) - 88usize];
    ["Offset of field: tagEMRPLGBLT::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, iUsageSrc) - 92usize];
    ["Offset of field: tagEMRPLGBLT::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, offBmiSrc) - 96usize];
    ["Offset of field: tagEMRPLGBLT::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, cbBmiSrc) - 100usize];
    ["Offset of field: tagEMRPLGBLT::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, offBitsSrc) - 104usize];
    ["Offset of field: tagEMRPLGBLT::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRPLGBLT, cbBitsSrc) - 108usize];
    ["Offset of field: tagEMRPLGBLT::xMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, xMask) - 112usize];
    ["Offset of field: tagEMRPLGBLT::yMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, yMask) - 116usize];
    ["Offset of field: tagEMRPLGBLT::iUsageMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, iUsageMask) - 120usize];
    ["Offset of field: tagEMRPLGBLT::offBmiMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, offBmiMask) - 124usize];
    ["Offset of field: tagEMRPLGBLT::cbBmiMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, cbBmiMask) - 128usize];
    ["Offset of field: tagEMRPLGBLT::offBitsMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, offBitsMask) - 132usize];
    ["Offset of field: tagEMRPLGBLT::cbBitsMask"]
        [::std::mem::offset_of!(tagEMRPLGBLT, cbBitsMask) - 136usize];
};
pub type EMRPLGBLT = tagEMRPLGBLT;
pub type PEMRPLGBLT = *mut tagEMRPLGBLT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETDIBITSTODEVICE {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub cxSrc: LONG,
    pub cySrc: LONG,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub iUsageSrc: DWORD,
    pub iStartScan: DWORD,
    pub cScans: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETDIBITSTODEVICE"][::std::mem::size_of::<tagEMRSETDIBITSTODEVICE>() - 76usize];
    ["Alignment of tagEMRSETDIBITSTODEVICE"]
        [::std::mem::align_of::<tagEMRSETDIBITSTODEVICE>() - 4usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::emr"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, emr) - 0usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::rclBounds"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, rclBounds) - 8usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::xDest"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, xDest) - 24usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::yDest"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, yDest) - 28usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::xSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, xSrc) - 32usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::ySrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, ySrc) - 36usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::cxSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, cxSrc) - 40usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::cySrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, cySrc) - 44usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, offBmiSrc) - 48usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, cbBmiSrc) - 52usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, offBitsSrc) - 56usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, cbBitsSrc) - 60usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, iUsageSrc) - 64usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::iStartScan"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, iStartScan) - 68usize];
    ["Offset of field: tagEMRSETDIBITSTODEVICE::cScans"]
        [::std::mem::offset_of!(tagEMRSETDIBITSTODEVICE, cScans) - 72usize];
};
pub type EMRSETDIBITSTODEVICE = tagEMRSETDIBITSTODEVICE;
pub type PEMRSETDIBITSTODEVICE = *mut tagEMRSETDIBITSTODEVICE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSTRETCHDIBITS {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub cxSrc: LONG,
    pub cySrc: LONG,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub iUsageSrc: DWORD,
    pub dwRop: DWORD,
    pub cxDest: LONG,
    pub cyDest: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSTRETCHDIBITS"][::std::mem::size_of::<tagEMRSTRETCHDIBITS>() - 80usize];
    ["Alignment of tagEMRSTRETCHDIBITS"][::std::mem::align_of::<tagEMRSTRETCHDIBITS>() - 4usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::emr"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, emr) - 0usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::rclBounds"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, rclBounds) - 8usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::xDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, xDest) - 24usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::yDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, yDest) - 28usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::xSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, xSrc) - 32usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::ySrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, ySrc) - 36usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cxSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cxSrc) - 40usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cySrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cySrc) - 44usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, offBmiSrc) - 48usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cbBmiSrc) - 52usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, offBitsSrc) - 56usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cbBitsSrc) - 60usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, iUsageSrc) - 64usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::dwRop"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, dwRop) - 68usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cxDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cxDest) - 72usize];
    ["Offset of field: tagEMRSTRETCHDIBITS::cyDest"]
        [::std::mem::offset_of!(tagEMRSTRETCHDIBITS, cyDest) - 76usize];
};
pub type EMRSTRETCHDIBITS = tagEMRSTRETCHDIBITS;
pub type PEMRSTRETCHDIBITS = *mut tagEMRSTRETCHDIBITS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTCREATEFONTINDIRECTW {
    pub emr: EMR,
    pub ihFont: DWORD,
    pub elfw: EXTLOGFONTW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTCREATEFONTINDIRECTW"]
        [::std::mem::size_of::<tagEMREXTCREATEFONTINDIRECTW>() - 332usize];
    ["Alignment of tagEMREXTCREATEFONTINDIRECTW"]
        [::std::mem::align_of::<tagEMREXTCREATEFONTINDIRECTW>() - 4usize];
    ["Offset of field: tagEMREXTCREATEFONTINDIRECTW::emr"]
        [::std::mem::offset_of!(tagEMREXTCREATEFONTINDIRECTW, emr) - 0usize];
    ["Offset of field: tagEMREXTCREATEFONTINDIRECTW::ihFont"]
        [::std::mem::offset_of!(tagEMREXTCREATEFONTINDIRECTW, ihFont) - 8usize];
    ["Offset of field: tagEMREXTCREATEFONTINDIRECTW::elfw"]
        [::std::mem::offset_of!(tagEMREXTCREATEFONTINDIRECTW, elfw) - 12usize];
};
pub type EMREXTCREATEFONTINDIRECTW = tagEMREXTCREATEFONTINDIRECTW;
pub type PEMREXTCREATEFONTINDIRECTW = *mut tagEMREXTCREATEFONTINDIRECTW;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATEPALETTE {
    pub emr: EMR,
    pub ihPal: DWORD,
    pub lgpl: LOGPALETTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATEPALETTE"][::std::mem::size_of::<tagEMRCREATEPALETTE>() - 20usize];
    ["Alignment of tagEMRCREATEPALETTE"][::std::mem::align_of::<tagEMRCREATEPALETTE>() - 4usize];
    ["Offset of field: tagEMRCREATEPALETTE::emr"]
        [::std::mem::offset_of!(tagEMRCREATEPALETTE, emr) - 0usize];
    ["Offset of field: tagEMRCREATEPALETTE::ihPal"]
        [::std::mem::offset_of!(tagEMRCREATEPALETTE, ihPal) - 8usize];
    ["Offset of field: tagEMRCREATEPALETTE::lgpl"]
        [::std::mem::offset_of!(tagEMRCREATEPALETTE, lgpl) - 12usize];
};
pub type EMRCREATEPALETTE = tagEMRCREATEPALETTE;
pub type PEMRCREATEPALETTE = *mut tagEMRCREATEPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATEPEN {
    pub emr: EMR,
    pub ihPen: DWORD,
    pub lopn: LOGPEN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATEPEN"][::std::mem::size_of::<tagEMRCREATEPEN>() - 28usize];
    ["Alignment of tagEMRCREATEPEN"][::std::mem::align_of::<tagEMRCREATEPEN>() - 4usize];
    ["Offset of field: tagEMRCREATEPEN::emr"]
        [::std::mem::offset_of!(tagEMRCREATEPEN, emr) - 0usize];
    ["Offset of field: tagEMRCREATEPEN::ihPen"]
        [::std::mem::offset_of!(tagEMRCREATEPEN, ihPen) - 8usize];
    ["Offset of field: tagEMRCREATEPEN::lopn"]
        [::std::mem::offset_of!(tagEMRCREATEPEN, lopn) - 12usize];
};
pub type EMRCREATEPEN = tagEMRCREATEPEN;
pub type PEMRCREATEPEN = *mut tagEMRCREATEPEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTCREATEPEN {
    pub emr: EMR,
    pub ihPen: DWORD,
    pub offBmi: DWORD,
    pub cbBmi: DWORD,
    pub offBits: DWORD,
    pub cbBits: DWORD,
    pub elp: EXTLOGPEN32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTCREATEPEN"][::std::mem::size_of::<tagEMREXTCREATEPEN>() - 56usize];
    ["Alignment of tagEMREXTCREATEPEN"][::std::mem::align_of::<tagEMREXTCREATEPEN>() - 4usize];
    ["Offset of field: tagEMREXTCREATEPEN::emr"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, emr) - 0usize];
    ["Offset of field: tagEMREXTCREATEPEN::ihPen"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, ihPen) - 8usize];
    ["Offset of field: tagEMREXTCREATEPEN::offBmi"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, offBmi) - 12usize];
    ["Offset of field: tagEMREXTCREATEPEN::cbBmi"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, cbBmi) - 16usize];
    ["Offset of field: tagEMREXTCREATEPEN::offBits"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, offBits) - 20usize];
    ["Offset of field: tagEMREXTCREATEPEN::cbBits"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, cbBits) - 24usize];
    ["Offset of field: tagEMREXTCREATEPEN::elp"]
        [::std::mem::offset_of!(tagEMREXTCREATEPEN, elp) - 28usize];
};
pub type EMREXTCREATEPEN = tagEMREXTCREATEPEN;
pub type PEMREXTCREATEPEN = *mut tagEMREXTCREATEPEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATEBRUSHINDIRECT {
    pub emr: EMR,
    pub ihBrush: DWORD,
    pub lb: LOGBRUSH32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATEBRUSHINDIRECT"]
        [::std::mem::size_of::<tagEMRCREATEBRUSHINDIRECT>() - 24usize];
    ["Alignment of tagEMRCREATEBRUSHINDIRECT"]
        [::std::mem::align_of::<tagEMRCREATEBRUSHINDIRECT>() - 4usize];
    ["Offset of field: tagEMRCREATEBRUSHINDIRECT::emr"]
        [::std::mem::offset_of!(tagEMRCREATEBRUSHINDIRECT, emr) - 0usize];
    ["Offset of field: tagEMRCREATEBRUSHINDIRECT::ihBrush"]
        [::std::mem::offset_of!(tagEMRCREATEBRUSHINDIRECT, ihBrush) - 8usize];
    ["Offset of field: tagEMRCREATEBRUSHINDIRECT::lb"]
        [::std::mem::offset_of!(tagEMRCREATEBRUSHINDIRECT, lb) - 12usize];
};
pub type EMRCREATEBRUSHINDIRECT = tagEMRCREATEBRUSHINDIRECT;
pub type PEMRCREATEBRUSHINDIRECT = *mut tagEMRCREATEBRUSHINDIRECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATEMONOBRUSH {
    pub emr: EMR,
    pub ihBrush: DWORD,
    pub iUsage: DWORD,
    pub offBmi: DWORD,
    pub cbBmi: DWORD,
    pub offBits: DWORD,
    pub cbBits: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATEMONOBRUSH"][::std::mem::size_of::<tagEMRCREATEMONOBRUSH>() - 32usize];
    ["Alignment of tagEMRCREATEMONOBRUSH"]
        [::std::mem::align_of::<tagEMRCREATEMONOBRUSH>() - 4usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::emr"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, emr) - 0usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::ihBrush"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, ihBrush) - 8usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::iUsage"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, iUsage) - 12usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::offBmi"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, offBmi) - 16usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::cbBmi"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, cbBmi) - 20usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::offBits"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, offBits) - 24usize];
    ["Offset of field: tagEMRCREATEMONOBRUSH::cbBits"]
        [::std::mem::offset_of!(tagEMRCREATEMONOBRUSH, cbBits) - 28usize];
};
pub type EMRCREATEMONOBRUSH = tagEMRCREATEMONOBRUSH;
pub type PEMRCREATEMONOBRUSH = *mut tagEMRCREATEMONOBRUSH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATEDIBPATTERNBRUSHPT {
    pub emr: EMR,
    pub ihBrush: DWORD,
    pub iUsage: DWORD,
    pub offBmi: DWORD,
    pub cbBmi: DWORD,
    pub offBits: DWORD,
    pub cbBits: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATEDIBPATTERNBRUSHPT"]
        [::std::mem::size_of::<tagEMRCREATEDIBPATTERNBRUSHPT>() - 32usize];
    ["Alignment of tagEMRCREATEDIBPATTERNBRUSHPT"]
        [::std::mem::align_of::<tagEMRCREATEDIBPATTERNBRUSHPT>() - 4usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::emr"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, emr) - 0usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::ihBrush"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, ihBrush) - 8usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::iUsage"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, iUsage) - 12usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::offBmi"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, offBmi) - 16usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::cbBmi"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, cbBmi) - 20usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::offBits"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, offBits) - 24usize];
    ["Offset of field: tagEMRCREATEDIBPATTERNBRUSHPT::cbBits"]
        [::std::mem::offset_of!(tagEMRCREATEDIBPATTERNBRUSHPT, cbBits) - 28usize];
};
pub type EMRCREATEDIBPATTERNBRUSHPT = tagEMRCREATEDIBPATTERNBRUSHPT;
pub type PEMRCREATEDIBPATTERNBRUSHPT = *mut tagEMRCREATEDIBPATTERNBRUSHPT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRFORMAT {
    pub dSignature: DWORD,
    pub nVersion: DWORD,
    pub cbData: DWORD,
    pub offData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRFORMAT"][::std::mem::size_of::<tagEMRFORMAT>() - 16usize];
    ["Alignment of tagEMRFORMAT"][::std::mem::align_of::<tagEMRFORMAT>() - 4usize];
    ["Offset of field: tagEMRFORMAT::dSignature"]
        [::std::mem::offset_of!(tagEMRFORMAT, dSignature) - 0usize];
    ["Offset of field: tagEMRFORMAT::nVersion"]
        [::std::mem::offset_of!(tagEMRFORMAT, nVersion) - 4usize];
    ["Offset of field: tagEMRFORMAT::cbData"]
        [::std::mem::offset_of!(tagEMRFORMAT, cbData) - 8usize];
    ["Offset of field: tagEMRFORMAT::offData"]
        [::std::mem::offset_of!(tagEMRFORMAT, offData) - 12usize];
};
pub type EMRFORMAT = tagEMRFORMAT;
pub type PEMRFORMAT = *mut tagEMRFORMAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRGLSRECORD {
    pub emr: EMR,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRGLSRECORD"][::std::mem::size_of::<tagEMRGLSRECORD>() - 16usize];
    ["Alignment of tagEMRGLSRECORD"][::std::mem::align_of::<tagEMRGLSRECORD>() - 4usize];
    ["Offset of field: tagEMRGLSRECORD::emr"]
        [::std::mem::offset_of!(tagEMRGLSRECORD, emr) - 0usize];
    ["Offset of field: tagEMRGLSRECORD::cbData"]
        [::std::mem::offset_of!(tagEMRGLSRECORD, cbData) - 8usize];
    ["Offset of field: tagEMRGLSRECORD::Data"]
        [::std::mem::offset_of!(tagEMRGLSRECORD, Data) - 12usize];
};
pub type EMRGLSRECORD = tagEMRGLSRECORD;
pub type PEMRGLSRECORD = *mut tagEMRGLSRECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRGLSBOUNDEDRECORD {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRGLSBOUNDEDRECORD"][::std::mem::size_of::<tagEMRGLSBOUNDEDRECORD>() - 32usize];
    ["Alignment of tagEMRGLSBOUNDEDRECORD"]
        [::std::mem::align_of::<tagEMRGLSBOUNDEDRECORD>() - 4usize];
    ["Offset of field: tagEMRGLSBOUNDEDRECORD::emr"]
        [::std::mem::offset_of!(tagEMRGLSBOUNDEDRECORD, emr) - 0usize];
    ["Offset of field: tagEMRGLSBOUNDEDRECORD::rclBounds"]
        [::std::mem::offset_of!(tagEMRGLSBOUNDEDRECORD, rclBounds) - 8usize];
    ["Offset of field: tagEMRGLSBOUNDEDRECORD::cbData"]
        [::std::mem::offset_of!(tagEMRGLSBOUNDEDRECORD, cbData) - 24usize];
    ["Offset of field: tagEMRGLSBOUNDEDRECORD::Data"]
        [::std::mem::offset_of!(tagEMRGLSBOUNDEDRECORD, Data) - 28usize];
};
pub type EMRGLSBOUNDEDRECORD = tagEMRGLSBOUNDEDRECORD;
pub type PEMRGLSBOUNDEDRECORD = *mut tagEMRGLSBOUNDEDRECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRPIXELFORMAT {
    pub emr: EMR,
    pub pfd: PIXELFORMATDESCRIPTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRPIXELFORMAT"][::std::mem::size_of::<tagEMRPIXELFORMAT>() - 48usize];
    ["Alignment of tagEMRPIXELFORMAT"][::std::mem::align_of::<tagEMRPIXELFORMAT>() - 4usize];
    ["Offset of field: tagEMRPIXELFORMAT::emr"]
        [::std::mem::offset_of!(tagEMRPIXELFORMAT, emr) - 0usize];
    ["Offset of field: tagEMRPIXELFORMAT::pfd"]
        [::std::mem::offset_of!(tagEMRPIXELFORMAT, pfd) - 8usize];
};
pub type EMRPIXELFORMAT = tagEMRPIXELFORMAT;
pub type PEMRPIXELFORMAT = *mut tagEMRPIXELFORMAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATECOLORSPACE {
    pub emr: EMR,
    pub ihCS: DWORD,
    pub lcs: LOGCOLORSPACEA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATECOLORSPACE"][::std::mem::size_of::<tagEMRCREATECOLORSPACE>() - 340usize];
    ["Alignment of tagEMRCREATECOLORSPACE"]
        [::std::mem::align_of::<tagEMRCREATECOLORSPACE>() - 4usize];
    ["Offset of field: tagEMRCREATECOLORSPACE::emr"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACE, emr) - 0usize];
    ["Offset of field: tagEMRCREATECOLORSPACE::ihCS"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACE, ihCS) - 8usize];
    ["Offset of field: tagEMRCREATECOLORSPACE::lcs"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACE, lcs) - 12usize];
};
pub type EMRCREATECOLORSPACE = tagEMRCREATECOLORSPACE;
pub type PEMRCREATECOLORSPACE = *mut tagEMRCREATECOLORSPACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETCOLORSPACE {
    pub emr: EMR,
    pub ihCS: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETCOLORSPACE"][::std::mem::size_of::<tagEMRSETCOLORSPACE>() - 12usize];
    ["Alignment of tagEMRSETCOLORSPACE"][::std::mem::align_of::<tagEMRSETCOLORSPACE>() - 4usize];
    ["Offset of field: tagEMRSETCOLORSPACE::emr"]
        [::std::mem::offset_of!(tagEMRSETCOLORSPACE, emr) - 0usize];
    ["Offset of field: tagEMRSETCOLORSPACE::ihCS"]
        [::std::mem::offset_of!(tagEMRSETCOLORSPACE, ihCS) - 8usize];
};
pub type EMRSETCOLORSPACE = tagEMRSETCOLORSPACE;
pub type PEMRSETCOLORSPACE = *mut tagEMRSETCOLORSPACE;
pub type EMRSELECTCOLORSPACE = tagEMRSETCOLORSPACE;
pub type PEMRSELECTCOLORSPACE = *mut tagEMRSETCOLORSPACE;
pub type EMRDELETECOLORSPACE = tagEMRSETCOLORSPACE;
pub type PEMRDELETECOLORSPACE = *mut tagEMRSETCOLORSPACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMREXTESCAPE {
    pub emr: EMR,
    pub iEscape: INT,
    pub cbEscData: INT,
    pub EscData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMREXTESCAPE"][::std::mem::size_of::<tagEMREXTESCAPE>() - 20usize];
    ["Alignment of tagEMREXTESCAPE"][::std::mem::align_of::<tagEMREXTESCAPE>() - 4usize];
    ["Offset of field: tagEMREXTESCAPE::emr"]
        [::std::mem::offset_of!(tagEMREXTESCAPE, emr) - 0usize];
    ["Offset of field: tagEMREXTESCAPE::iEscape"]
        [::std::mem::offset_of!(tagEMREXTESCAPE, iEscape) - 8usize];
    ["Offset of field: tagEMREXTESCAPE::cbEscData"]
        [::std::mem::offset_of!(tagEMREXTESCAPE, cbEscData) - 12usize];
    ["Offset of field: tagEMREXTESCAPE::EscData"]
        [::std::mem::offset_of!(tagEMREXTESCAPE, EscData) - 16usize];
};
pub type EMREXTESCAPE = tagEMREXTESCAPE;
pub type PEMREXTESCAPE = *mut tagEMREXTESCAPE;
pub type EMRDRAWESCAPE = tagEMREXTESCAPE;
pub type PEMRDRAWESCAPE = *mut tagEMREXTESCAPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRNAMEDESCAPE {
    pub emr: EMR,
    pub iEscape: INT,
    pub cbDriver: INT,
    pub cbEscData: INT,
    pub EscData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRNAMEDESCAPE"][::std::mem::size_of::<tagEMRNAMEDESCAPE>() - 24usize];
    ["Alignment of tagEMRNAMEDESCAPE"][::std::mem::align_of::<tagEMRNAMEDESCAPE>() - 4usize];
    ["Offset of field: tagEMRNAMEDESCAPE::emr"]
        [::std::mem::offset_of!(tagEMRNAMEDESCAPE, emr) - 0usize];
    ["Offset of field: tagEMRNAMEDESCAPE::iEscape"]
        [::std::mem::offset_of!(tagEMRNAMEDESCAPE, iEscape) - 8usize];
    ["Offset of field: tagEMRNAMEDESCAPE::cbDriver"]
        [::std::mem::offset_of!(tagEMRNAMEDESCAPE, cbDriver) - 12usize];
    ["Offset of field: tagEMRNAMEDESCAPE::cbEscData"]
        [::std::mem::offset_of!(tagEMRNAMEDESCAPE, cbEscData) - 16usize];
    ["Offset of field: tagEMRNAMEDESCAPE::EscData"]
        [::std::mem::offset_of!(tagEMRNAMEDESCAPE, EscData) - 20usize];
};
pub type EMRNAMEDESCAPE = tagEMRNAMEDESCAPE;
pub type PEMRNAMEDESCAPE = *mut tagEMRNAMEDESCAPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRSETICMPROFILE {
    pub emr: EMR,
    pub dwFlags: DWORD,
    pub cbName: DWORD,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRSETICMPROFILE"][::std::mem::size_of::<tagEMRSETICMPROFILE>() - 24usize];
    ["Alignment of tagEMRSETICMPROFILE"][::std::mem::align_of::<tagEMRSETICMPROFILE>() - 4usize];
    ["Offset of field: tagEMRSETICMPROFILE::emr"]
        [::std::mem::offset_of!(tagEMRSETICMPROFILE, emr) - 0usize];
    ["Offset of field: tagEMRSETICMPROFILE::dwFlags"]
        [::std::mem::offset_of!(tagEMRSETICMPROFILE, dwFlags) - 8usize];
    ["Offset of field: tagEMRSETICMPROFILE::cbName"]
        [::std::mem::offset_of!(tagEMRSETICMPROFILE, cbName) - 12usize];
    ["Offset of field: tagEMRSETICMPROFILE::cbData"]
        [::std::mem::offset_of!(tagEMRSETICMPROFILE, cbData) - 16usize];
    ["Offset of field: tagEMRSETICMPROFILE::Data"]
        [::std::mem::offset_of!(tagEMRSETICMPROFILE, Data) - 20usize];
};
pub type EMRSETICMPROFILE = tagEMRSETICMPROFILE;
pub type PEMRSETICMPROFILE = *mut tagEMRSETICMPROFILE;
pub type EMRSETICMPROFILEA = tagEMRSETICMPROFILE;
pub type PEMRSETICMPROFILEA = *mut tagEMRSETICMPROFILE;
pub type EMRSETICMPROFILEW = tagEMRSETICMPROFILE;
pub type PEMRSETICMPROFILEW = *mut tagEMRSETICMPROFILE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRCREATECOLORSPACEW {
    pub emr: EMR,
    pub ihCS: DWORD,
    pub lcs: LOGCOLORSPACEW,
    pub dwFlags: DWORD,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRCREATECOLORSPACEW"]
        [::std::mem::size_of::<tagEMRCREATECOLORSPACEW>() - 612usize];
    ["Alignment of tagEMRCREATECOLORSPACEW"]
        [::std::mem::align_of::<tagEMRCREATECOLORSPACEW>() - 4usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::emr"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, emr) - 0usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::ihCS"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, ihCS) - 8usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::lcs"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, lcs) - 12usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::dwFlags"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, dwFlags) - 600usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::cbData"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, cbData) - 604usize];
    ["Offset of field: tagEMRCREATECOLORSPACEW::Data"]
        [::std::mem::offset_of!(tagEMRCREATECOLORSPACEW, Data) - 608usize];
};
pub type EMRCREATECOLORSPACEW = tagEMRCREATECOLORSPACEW;
pub type PEMRCREATECOLORSPACEW = *mut tagEMRCREATECOLORSPACEW;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOLORMATCHTOTARGET {
    pub emr: EMR,
    pub dwAction: DWORD,
    pub dwFlags: DWORD,
    pub cbName: DWORD,
    pub cbData: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOLORMATCHTOTARGET"][::std::mem::size_of::<tagCOLORMATCHTOTARGET>() - 28usize];
    ["Alignment of tagCOLORMATCHTOTARGET"]
        [::std::mem::align_of::<tagCOLORMATCHTOTARGET>() - 4usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::emr"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, emr) - 0usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::dwAction"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, dwAction) - 8usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::dwFlags"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, dwFlags) - 12usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::cbName"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, cbName) - 16usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::cbData"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, cbData) - 20usize];
    ["Offset of field: tagCOLORMATCHTOTARGET::Data"]
        [::std::mem::offset_of!(tagCOLORMATCHTOTARGET, Data) - 24usize];
};
pub type EMRCOLORMATCHTOTARGET = tagCOLORMATCHTOTARGET;
pub type PEMRCOLORMATCHTOTARGET = *mut tagCOLORMATCHTOTARGET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOLORCORRECTPALETTE {
    pub emr: EMR,
    pub ihPalette: DWORD,
    pub nFirstEntry: DWORD,
    pub nPalEntries: DWORD,
    pub nReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOLORCORRECTPALETTE"][::std::mem::size_of::<tagCOLORCORRECTPALETTE>() - 24usize];
    ["Alignment of tagCOLORCORRECTPALETTE"]
        [::std::mem::align_of::<tagCOLORCORRECTPALETTE>() - 4usize];
    ["Offset of field: tagCOLORCORRECTPALETTE::emr"]
        [::std::mem::offset_of!(tagCOLORCORRECTPALETTE, emr) - 0usize];
    ["Offset of field: tagCOLORCORRECTPALETTE::ihPalette"]
        [::std::mem::offset_of!(tagCOLORCORRECTPALETTE, ihPalette) - 8usize];
    ["Offset of field: tagCOLORCORRECTPALETTE::nFirstEntry"]
        [::std::mem::offset_of!(tagCOLORCORRECTPALETTE, nFirstEntry) - 12usize];
    ["Offset of field: tagCOLORCORRECTPALETTE::nPalEntries"]
        [::std::mem::offset_of!(tagCOLORCORRECTPALETTE, nPalEntries) - 16usize];
    ["Offset of field: tagCOLORCORRECTPALETTE::nReserved"]
        [::std::mem::offset_of!(tagCOLORCORRECTPALETTE, nReserved) - 20usize];
};
pub type EMRCOLORCORRECTPALETTE = tagCOLORCORRECTPALETTE;
pub type PEMRCOLORCORRECTPALETTE = *mut tagCOLORCORRECTPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRALPHABLEND {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub cxDest: LONG,
    pub cyDest: LONG,
    pub dwRop: DWORD,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub cxSrc: LONG,
    pub cySrc: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRALPHABLEND"][::std::mem::size_of::<tagEMRALPHABLEND>() - 108usize];
    ["Alignment of tagEMRALPHABLEND"][::std::mem::align_of::<tagEMRALPHABLEND>() - 4usize];
    ["Offset of field: tagEMRALPHABLEND::emr"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, emr) - 0usize];
    ["Offset of field: tagEMRALPHABLEND::rclBounds"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, rclBounds) - 8usize];
    ["Offset of field: tagEMRALPHABLEND::xDest"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, xDest) - 24usize];
    ["Offset of field: tagEMRALPHABLEND::yDest"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, yDest) - 28usize];
    ["Offset of field: tagEMRALPHABLEND::cxDest"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cxDest) - 32usize];
    ["Offset of field: tagEMRALPHABLEND::cyDest"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cyDest) - 36usize];
    ["Offset of field: tagEMRALPHABLEND::dwRop"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, dwRop) - 40usize];
    ["Offset of field: tagEMRALPHABLEND::xSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, xSrc) - 44usize];
    ["Offset of field: tagEMRALPHABLEND::ySrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, ySrc) - 48usize];
    ["Offset of field: tagEMRALPHABLEND::xformSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, xformSrc) - 52usize];
    ["Offset of field: tagEMRALPHABLEND::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, crBkColorSrc) - 76usize];
    ["Offset of field: tagEMRALPHABLEND::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, iUsageSrc) - 80usize];
    ["Offset of field: tagEMRALPHABLEND::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, offBmiSrc) - 84usize];
    ["Offset of field: tagEMRALPHABLEND::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cbBmiSrc) - 88usize];
    ["Offset of field: tagEMRALPHABLEND::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, offBitsSrc) - 92usize];
    ["Offset of field: tagEMRALPHABLEND::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cbBitsSrc) - 96usize];
    ["Offset of field: tagEMRALPHABLEND::cxSrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cxSrc) - 100usize];
    ["Offset of field: tagEMRALPHABLEND::cySrc"]
        [::std::mem::offset_of!(tagEMRALPHABLEND, cySrc) - 104usize];
};
pub type EMRALPHABLEND = tagEMRALPHABLEND;
pub type PEMRALPHABLEND = *mut tagEMRALPHABLEND;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRGRADIENTFILL {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub nVer: DWORD,
    pub nTri: DWORD,
    pub ulMode: ULONG,
    pub Ver: [TRIVERTEX; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRGRADIENTFILL"][::std::mem::size_of::<tagEMRGRADIENTFILL>() - 52usize];
    ["Alignment of tagEMRGRADIENTFILL"][::std::mem::align_of::<tagEMRGRADIENTFILL>() - 4usize];
    ["Offset of field: tagEMRGRADIENTFILL::emr"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, emr) - 0usize];
    ["Offset of field: tagEMRGRADIENTFILL::rclBounds"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, rclBounds) - 8usize];
    ["Offset of field: tagEMRGRADIENTFILL::nVer"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, nVer) - 24usize];
    ["Offset of field: tagEMRGRADIENTFILL::nTri"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, nTri) - 28usize];
    ["Offset of field: tagEMRGRADIENTFILL::ulMode"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, ulMode) - 32usize];
    ["Offset of field: tagEMRGRADIENTFILL::Ver"]
        [::std::mem::offset_of!(tagEMRGRADIENTFILL, Ver) - 36usize];
};
pub type EMRGRADIENTFILL = tagEMRGRADIENTFILL;
pub type PEMRGRADIENTFILL = *mut tagEMRGRADIENTFILL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEMRTRANSPARENTBLT {
    pub emr: EMR,
    pub rclBounds: RECTL,
    pub xDest: LONG,
    pub yDest: LONG,
    pub cxDest: LONG,
    pub cyDest: LONG,
    pub dwRop: DWORD,
    pub xSrc: LONG,
    pub ySrc: LONG,
    pub xformSrc: XFORM,
    pub crBkColorSrc: COLORREF,
    pub iUsageSrc: DWORD,
    pub offBmiSrc: DWORD,
    pub cbBmiSrc: DWORD,
    pub offBitsSrc: DWORD,
    pub cbBitsSrc: DWORD,
    pub cxSrc: LONG,
    pub cySrc: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEMRTRANSPARENTBLT"][::std::mem::size_of::<tagEMRTRANSPARENTBLT>() - 108usize];
    ["Alignment of tagEMRTRANSPARENTBLT"][::std::mem::align_of::<tagEMRTRANSPARENTBLT>() - 4usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::emr"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, emr) - 0usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::rclBounds"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, rclBounds) - 8usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::xDest"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, xDest) - 24usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::yDest"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, yDest) - 28usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cxDest"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cxDest) - 32usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cyDest"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cyDest) - 36usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::dwRop"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, dwRop) - 40usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::xSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, xSrc) - 44usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::ySrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, ySrc) - 48usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::xformSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, xformSrc) - 52usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::crBkColorSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, crBkColorSrc) - 76usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::iUsageSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, iUsageSrc) - 80usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::offBmiSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, offBmiSrc) - 84usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cbBmiSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cbBmiSrc) - 88usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::offBitsSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, offBitsSrc) - 92usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cbBitsSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cbBitsSrc) - 96usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cxSrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cxSrc) - 100usize];
    ["Offset of field: tagEMRTRANSPARENTBLT::cySrc"]
        [::std::mem::offset_of!(tagEMRTRANSPARENTBLT, cySrc) - 104usize];
};
pub type EMRTRANSPARENTBLT = tagEMRTRANSPARENTBLT;
pub type PEMRTRANSPARENTBLT = *mut tagEMRTRANSPARENTBLT;
unsafe extern "C" {
    pub fn wglCopyContext(arg1: HGLRC, arg2: HGLRC, arg3: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn wglCreateContext(arg1: HDC) -> HGLRC;
}
unsafe extern "C" {
    pub fn wglCreateLayerContext(arg1: HDC, arg2: ::std::os::raw::c_int) -> HGLRC;
}
unsafe extern "C" {
    pub fn wglDeleteContext(arg1: HGLRC) -> BOOL;
}
unsafe extern "C" {
    pub fn wglGetCurrentContext() -> HGLRC;
}
unsafe extern "C" {
    pub fn wglGetCurrentDC() -> HDC;
}
unsafe extern "C" {
    pub fn wglGetProcAddress(arg1: LPCSTR) -> PROC;
}
unsafe extern "C" {
    pub fn wglMakeCurrent(arg1: HDC, arg2: HGLRC) -> BOOL;
}
unsafe extern "C" {
    pub fn wglShareLists(arg1: HGLRC, arg2: HGLRC) -> BOOL;
}
unsafe extern "C" {
    pub fn wglUseFontBitmapsA(arg1: HDC, arg2: DWORD, arg3: DWORD, arg4: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn wglUseFontBitmapsW(arg1: HDC, arg2: DWORD, arg3: DWORD, arg4: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SwapBuffers(arg1: HDC) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _POINTFLOAT {
    pub x: FLOAT,
    pub y: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _POINTFLOAT"][::std::mem::size_of::<_POINTFLOAT>() - 8usize];
    ["Alignment of _POINTFLOAT"][::std::mem::align_of::<_POINTFLOAT>() - 4usize];
    ["Offset of field: _POINTFLOAT::x"][::std::mem::offset_of!(_POINTFLOAT, x) - 0usize];
    ["Offset of field: _POINTFLOAT::y"][::std::mem::offset_of!(_POINTFLOAT, y) - 4usize];
};
pub type POINTFLOAT = _POINTFLOAT;
pub type PPOINTFLOAT = *mut _POINTFLOAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GLYPHMETRICSFLOAT {
    pub gmfBlackBoxX: FLOAT,
    pub gmfBlackBoxY: FLOAT,
    pub gmfptGlyphOrigin: POINTFLOAT,
    pub gmfCellIncX: FLOAT,
    pub gmfCellIncY: FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GLYPHMETRICSFLOAT"][::std::mem::size_of::<_GLYPHMETRICSFLOAT>() - 24usize];
    ["Alignment of _GLYPHMETRICSFLOAT"][::std::mem::align_of::<_GLYPHMETRICSFLOAT>() - 4usize];
    ["Offset of field: _GLYPHMETRICSFLOAT::gmfBlackBoxX"]
        [::std::mem::offset_of!(_GLYPHMETRICSFLOAT, gmfBlackBoxX) - 0usize];
    ["Offset of field: _GLYPHMETRICSFLOAT::gmfBlackBoxY"]
        [::std::mem::offset_of!(_GLYPHMETRICSFLOAT, gmfBlackBoxY) - 4usize];
    ["Offset of field: _GLYPHMETRICSFLOAT::gmfptGlyphOrigin"]
        [::std::mem::offset_of!(_GLYPHMETRICSFLOAT, gmfptGlyphOrigin) - 8usize];
    ["Offset of field: _GLYPHMETRICSFLOAT::gmfCellIncX"]
        [::std::mem::offset_of!(_GLYPHMETRICSFLOAT, gmfCellIncX) - 16usize];
    ["Offset of field: _GLYPHMETRICSFLOAT::gmfCellIncY"]
        [::std::mem::offset_of!(_GLYPHMETRICSFLOAT, gmfCellIncY) - 20usize];
};
pub type GLYPHMETRICSFLOAT = _GLYPHMETRICSFLOAT;
pub type PGLYPHMETRICSFLOAT = *mut _GLYPHMETRICSFLOAT;
pub type LPGLYPHMETRICSFLOAT = *mut _GLYPHMETRICSFLOAT;
unsafe extern "C" {
    pub fn wglUseFontOutlinesA(
        arg1: HDC,
        arg2: DWORD,
        arg3: DWORD,
        arg4: DWORD,
        arg5: FLOAT,
        arg6: FLOAT,
        arg7: ::std::os::raw::c_int,
        arg8: LPGLYPHMETRICSFLOAT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn wglUseFontOutlinesW(
        arg1: HDC,
        arg2: DWORD,
        arg3: DWORD,
        arg4: DWORD,
        arg5: FLOAT,
        arg6: FLOAT,
        arg7: ::std::os::raw::c_int,
        arg8: LPGLYPHMETRICSFLOAT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLAYERPLANEDESCRIPTOR {
    pub nSize: WORD,
    pub nVersion: WORD,
    pub dwFlags: DWORD,
    pub iPixelType: BYTE,
    pub cColorBits: BYTE,
    pub cRedBits: BYTE,
    pub cRedShift: BYTE,
    pub cGreenBits: BYTE,
    pub cGreenShift: BYTE,
    pub cBlueBits: BYTE,
    pub cBlueShift: BYTE,
    pub cAlphaBits: BYTE,
    pub cAlphaShift: BYTE,
    pub cAccumBits: BYTE,
    pub cAccumRedBits: BYTE,
    pub cAccumGreenBits: BYTE,
    pub cAccumBlueBits: BYTE,
    pub cAccumAlphaBits: BYTE,
    pub cDepthBits: BYTE,
    pub cStencilBits: BYTE,
    pub cAuxBuffers: BYTE,
    pub iLayerPlane: BYTE,
    pub bReserved: BYTE,
    pub crTransparent: COLORREF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLAYERPLANEDESCRIPTOR"][::std::mem::size_of::<tagLAYERPLANEDESCRIPTOR>() - 32usize];
    ["Alignment of tagLAYERPLANEDESCRIPTOR"]
        [::std::mem::align_of::<tagLAYERPLANEDESCRIPTOR>() - 4usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::nSize"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, nSize) - 0usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::nVersion"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, nVersion) - 2usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::dwFlags"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, dwFlags) - 4usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::iPixelType"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, iPixelType) - 8usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cColorBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cColorBits) - 9usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cRedBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cRedBits) - 10usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cRedShift"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cRedShift) - 11usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cGreenBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cGreenBits) - 12usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cGreenShift"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cGreenShift) - 13usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cBlueBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cBlueBits) - 14usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cBlueShift"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cBlueShift) - 15usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAlphaBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAlphaBits) - 16usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAlphaShift"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAlphaShift) - 17usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAccumBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAccumBits) - 18usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAccumRedBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAccumRedBits) - 19usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAccumGreenBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAccumGreenBits) - 20usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAccumBlueBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAccumBlueBits) - 21usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAccumAlphaBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAccumAlphaBits) - 22usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cDepthBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cDepthBits) - 23usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cStencilBits"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cStencilBits) - 24usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::cAuxBuffers"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, cAuxBuffers) - 25usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::iLayerPlane"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, iLayerPlane) - 26usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::bReserved"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, bReserved) - 27usize];
    ["Offset of field: tagLAYERPLANEDESCRIPTOR::crTransparent"]
        [::std::mem::offset_of!(tagLAYERPLANEDESCRIPTOR, crTransparent) - 28usize];
};
pub type LAYERPLANEDESCRIPTOR = tagLAYERPLANEDESCRIPTOR;
pub type PLAYERPLANEDESCRIPTOR = *mut tagLAYERPLANEDESCRIPTOR;
pub type LPLAYERPLANEDESCRIPTOR = *mut tagLAYERPLANEDESCRIPTOR;
unsafe extern "C" {
    pub fn wglDescribeLayerPlane(
        arg1: HDC,
        arg2: ::std::os::raw::c_int,
        arg3: ::std::os::raw::c_int,
        arg4: UINT,
        arg5: LPLAYERPLANEDESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn wglSetLayerPaletteEntries(
        arg1: HDC,
        arg2: ::std::os::raw::c_int,
        arg3: ::std::os::raw::c_int,
        arg4: ::std::os::raw::c_int,
        arg5: *const COLORREF,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wglGetLayerPaletteEntries(
        arg1: HDC,
        arg2: ::std::os::raw::c_int,
        arg3: ::std::os::raw::c_int,
        arg4: ::std::os::raw::c_int,
        arg5: *mut COLORREF,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wglRealizeLayerPalette(arg1: HDC, arg2: ::std::os::raw::c_int, arg3: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn wglSwapLayerBuffers(arg1: HDC, arg2: UINT) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WGLSWAP {
    pub hdc: HDC,
    pub uiFlags: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WGLSWAP"][::std::mem::size_of::<_WGLSWAP>() - 16usize];
    ["Alignment of _WGLSWAP"][::std::mem::align_of::<_WGLSWAP>() - 8usize];
    ["Offset of field: _WGLSWAP::hdc"][::std::mem::offset_of!(_WGLSWAP, hdc) - 0usize];
    ["Offset of field: _WGLSWAP::uiFlags"][::std::mem::offset_of!(_WGLSWAP, uiFlags) - 8usize];
};
pub type WGLSWAP = _WGLSWAP;
pub type PWGLSWAP = *mut _WGLSWAP;
pub type LPWGLSWAP = *mut _WGLSWAP;
unsafe extern "C" {
    pub fn wglSwapMultipleBuffers(arg1: UINT, arg2: *const WGLSWAP) -> DWORD;
}
pub type HDWP = HANDLE;
pub type MENUTEMPLATEA = ::std::os::raw::c_void;
pub type MENUTEMPLATEW = ::std::os::raw::c_void;
pub type MENUTEMPLATE = MENUTEMPLATEA;
pub type LPMENUTEMPLATEA = PVOID;
pub type LPMENUTEMPLATEW = PVOID;
pub type LPMENUTEMPLATE = LPMENUTEMPLATEA;
pub type WNDPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> LRESULT,
>;
pub type DLGPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> INT_PTR,
>;
pub type TIMERPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: UINT_PTR, arg4: DWORD),
>;
pub type GRAYSTRINGPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HDC, arg2: LPARAM, arg3: ::std::os::raw::c_int) -> BOOL,
>;
pub type WNDENUMPROC =
    ::std::option::Option<unsafe extern "C" fn(arg1: HWND, arg2: LPARAM) -> BOOL>;
pub type HOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(code: ::std::os::raw::c_int, wParam: WPARAM, lParam: LPARAM) -> LRESULT,
>;
pub type SENDASYNCPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: ULONG_PTR, arg4: LRESULT),
>;
pub type PROPENUMPROCA =
    ::std::option::Option<unsafe extern "C" fn(arg1: HWND, arg2: LPCSTR, arg3: HANDLE) -> BOOL>;
pub type PROPENUMPROCW =
    ::std::option::Option<unsafe extern "C" fn(arg1: HWND, arg2: LPCWSTR, arg3: HANDLE) -> BOOL>;
pub type PROPENUMPROCEXA = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: LPSTR, arg3: HANDLE, arg4: ULONG_PTR) -> BOOL,
>;
pub type PROPENUMPROCEXW = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: LPWSTR, arg3: HANDLE, arg4: ULONG_PTR) -> BOOL,
>;
pub type EDITWORDBREAKPROCA = ::std::option::Option<
    unsafe extern "C" fn(
        lpch: LPSTR,
        ichCurrent: ::std::os::raw::c_int,
        cch: ::std::os::raw::c_int,
        code: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int,
>;
pub type EDITWORDBREAKPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        lpch: LPWSTR,
        ichCurrent: ::std::os::raw::c_int,
        cch: ::std::os::raw::c_int,
        code: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int,
>;
pub type DRAWSTATEPROC = ::std::option::Option<
    unsafe extern "C" fn(
        hdc: HDC,
        lData: LPARAM,
        wData: WPARAM,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
    ) -> BOOL,
>;
pub type PROPENUMPROC = PROPENUMPROCA;
pub type PROPENUMPROCEX = PROPENUMPROCEXA;
pub type EDITWORDBREAKPROC = EDITWORDBREAKPROCA;
pub type NAMEENUMPROCA =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR, arg2: LPARAM) -> BOOL>;
pub type NAMEENUMPROCW =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: LPARAM) -> BOOL>;
pub type WINSTAENUMPROCA = NAMEENUMPROCA;
pub type DESKTOPENUMPROCA = NAMEENUMPROCA;
pub type WINSTAENUMPROCW = NAMEENUMPROCW;
pub type DESKTOPENUMPROCW = NAMEENUMPROCW;
pub type WINSTAENUMPROC = WINSTAENUMPROCA;
pub type DESKTOPENUMPROC = DESKTOPENUMPROCA;
unsafe extern "C" {
    pub fn wvsprintfA(arg1: LPSTR, arg2: LPCSTR, arglist: va_list) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wvsprintfW(arg1: LPWSTR, arg2: LPCWSTR, arglist: va_list) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wsprintfA(arg1: LPSTR, arg2: LPCSTR, ...) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wsprintfW(arg1: LPWSTR, arg2: LPCWSTR, ...) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCBT_CREATEWNDA {
    pub lpcs: *mut tagCREATESTRUCTA,
    pub hwndInsertAfter: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCBT_CREATEWNDA"][::std::mem::size_of::<tagCBT_CREATEWNDA>() - 16usize];
    ["Alignment of tagCBT_CREATEWNDA"][::std::mem::align_of::<tagCBT_CREATEWNDA>() - 8usize];
    ["Offset of field: tagCBT_CREATEWNDA::lpcs"]
        [::std::mem::offset_of!(tagCBT_CREATEWNDA, lpcs) - 0usize];
    ["Offset of field: tagCBT_CREATEWNDA::hwndInsertAfter"]
        [::std::mem::offset_of!(tagCBT_CREATEWNDA, hwndInsertAfter) - 8usize];
};
pub type CBT_CREATEWNDA = tagCBT_CREATEWNDA;
pub type LPCBT_CREATEWNDA = *mut tagCBT_CREATEWNDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCBT_CREATEWNDW {
    pub lpcs: *mut tagCREATESTRUCTW,
    pub hwndInsertAfter: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCBT_CREATEWNDW"][::std::mem::size_of::<tagCBT_CREATEWNDW>() - 16usize];
    ["Alignment of tagCBT_CREATEWNDW"][::std::mem::align_of::<tagCBT_CREATEWNDW>() - 8usize];
    ["Offset of field: tagCBT_CREATEWNDW::lpcs"]
        [::std::mem::offset_of!(tagCBT_CREATEWNDW, lpcs) - 0usize];
    ["Offset of field: tagCBT_CREATEWNDW::hwndInsertAfter"]
        [::std::mem::offset_of!(tagCBT_CREATEWNDW, hwndInsertAfter) - 8usize];
};
pub type CBT_CREATEWNDW = tagCBT_CREATEWNDW;
pub type LPCBT_CREATEWNDW = *mut tagCBT_CREATEWNDW;
pub type CBT_CREATEWND = CBT_CREATEWNDA;
pub type LPCBT_CREATEWND = LPCBT_CREATEWNDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCBTACTIVATESTRUCT {
    pub fMouse: BOOL,
    pub hWndActive: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCBTACTIVATESTRUCT"][::std::mem::size_of::<tagCBTACTIVATESTRUCT>() - 16usize];
    ["Alignment of tagCBTACTIVATESTRUCT"][::std::mem::align_of::<tagCBTACTIVATESTRUCT>() - 8usize];
    ["Offset of field: tagCBTACTIVATESTRUCT::fMouse"]
        [::std::mem::offset_of!(tagCBTACTIVATESTRUCT, fMouse) - 0usize];
    ["Offset of field: tagCBTACTIVATESTRUCT::hWndActive"]
        [::std::mem::offset_of!(tagCBTACTIVATESTRUCT, hWndActive) - 8usize];
};
pub type CBTACTIVATESTRUCT = tagCBTACTIVATESTRUCT;
pub type LPCBTACTIVATESTRUCT = *mut tagCBTACTIVATESTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWTSSESSION_NOTIFICATION {
    pub cbSize: DWORD,
    pub dwSessionId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWTSSESSION_NOTIFICATION"]
        [::std::mem::size_of::<tagWTSSESSION_NOTIFICATION>() - 8usize];
    ["Alignment of tagWTSSESSION_NOTIFICATION"]
        [::std::mem::align_of::<tagWTSSESSION_NOTIFICATION>() - 4usize];
    ["Offset of field: tagWTSSESSION_NOTIFICATION::cbSize"]
        [::std::mem::offset_of!(tagWTSSESSION_NOTIFICATION, cbSize) - 0usize];
    ["Offset of field: tagWTSSESSION_NOTIFICATION::dwSessionId"]
        [::std::mem::offset_of!(tagWTSSESSION_NOTIFICATION, dwSessionId) - 4usize];
};
pub type WTSSESSION_NOTIFICATION = tagWTSSESSION_NOTIFICATION;
pub type PWTSSESSION_NOTIFICATION = *mut tagWTSSESSION_NOTIFICATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SHELLHOOKINFO {
    pub hwnd: HWND,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SHELLHOOKINFO"][::std::mem::size_of::<SHELLHOOKINFO>() - 24usize];
    ["Alignment of SHELLHOOKINFO"][::std::mem::align_of::<SHELLHOOKINFO>() - 8usize];
    ["Offset of field: SHELLHOOKINFO::hwnd"][::std::mem::offset_of!(SHELLHOOKINFO, hwnd) - 0usize];
    ["Offset of field: SHELLHOOKINFO::rc"][::std::mem::offset_of!(SHELLHOOKINFO, rc) - 8usize];
};
pub type LPSHELLHOOKINFO = *mut SHELLHOOKINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEVENTMSG {
    pub message: UINT,
    pub paramL: UINT,
    pub paramH: UINT,
    pub time: DWORD,
    pub hwnd: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEVENTMSG"][::std::mem::size_of::<tagEVENTMSG>() - 24usize];
    ["Alignment of tagEVENTMSG"][::std::mem::align_of::<tagEVENTMSG>() - 8usize];
    ["Offset of field: tagEVENTMSG::message"]
        [::std::mem::offset_of!(tagEVENTMSG, message) - 0usize];
    ["Offset of field: tagEVENTMSG::paramL"][::std::mem::offset_of!(tagEVENTMSG, paramL) - 4usize];
    ["Offset of field: tagEVENTMSG::paramH"][::std::mem::offset_of!(tagEVENTMSG, paramH) - 8usize];
    ["Offset of field: tagEVENTMSG::time"][::std::mem::offset_of!(tagEVENTMSG, time) - 12usize];
    ["Offset of field: tagEVENTMSG::hwnd"][::std::mem::offset_of!(tagEVENTMSG, hwnd) - 16usize];
};
pub type EVENTMSG = tagEVENTMSG;
pub type PEVENTMSGMSG = *mut tagEVENTMSG;
pub type NPEVENTMSGMSG = *mut tagEVENTMSG;
pub type LPEVENTMSGMSG = *mut tagEVENTMSG;
pub type PEVENTMSG = *mut tagEVENTMSG;
pub type NPEVENTMSG = *mut tagEVENTMSG;
pub type LPEVENTMSG = *mut tagEVENTMSG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCWPSTRUCT {
    pub lParam: LPARAM,
    pub wParam: WPARAM,
    pub message: UINT,
    pub hwnd: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCWPSTRUCT"][::std::mem::size_of::<tagCWPSTRUCT>() - 32usize];
    ["Alignment of tagCWPSTRUCT"][::std::mem::align_of::<tagCWPSTRUCT>() - 8usize];
    ["Offset of field: tagCWPSTRUCT::lParam"]
        [::std::mem::offset_of!(tagCWPSTRUCT, lParam) - 0usize];
    ["Offset of field: tagCWPSTRUCT::wParam"]
        [::std::mem::offset_of!(tagCWPSTRUCT, wParam) - 8usize];
    ["Offset of field: tagCWPSTRUCT::message"]
        [::std::mem::offset_of!(tagCWPSTRUCT, message) - 16usize];
    ["Offset of field: tagCWPSTRUCT::hwnd"][::std::mem::offset_of!(tagCWPSTRUCT, hwnd) - 24usize];
};
pub type CWPSTRUCT = tagCWPSTRUCT;
pub type PCWPSTRUCT = *mut tagCWPSTRUCT;
pub type NPCWPSTRUCT = *mut tagCWPSTRUCT;
pub type LPCWPSTRUCT = *mut tagCWPSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCWPRETSTRUCT {
    pub lResult: LRESULT,
    pub lParam: LPARAM,
    pub wParam: WPARAM,
    pub message: UINT,
    pub hwnd: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCWPRETSTRUCT"][::std::mem::size_of::<tagCWPRETSTRUCT>() - 40usize];
    ["Alignment of tagCWPRETSTRUCT"][::std::mem::align_of::<tagCWPRETSTRUCT>() - 8usize];
    ["Offset of field: tagCWPRETSTRUCT::lResult"]
        [::std::mem::offset_of!(tagCWPRETSTRUCT, lResult) - 0usize];
    ["Offset of field: tagCWPRETSTRUCT::lParam"]
        [::std::mem::offset_of!(tagCWPRETSTRUCT, lParam) - 8usize];
    ["Offset of field: tagCWPRETSTRUCT::wParam"]
        [::std::mem::offset_of!(tagCWPRETSTRUCT, wParam) - 16usize];
    ["Offset of field: tagCWPRETSTRUCT::message"]
        [::std::mem::offset_of!(tagCWPRETSTRUCT, message) - 24usize];
    ["Offset of field: tagCWPRETSTRUCT::hwnd"]
        [::std::mem::offset_of!(tagCWPRETSTRUCT, hwnd) - 32usize];
};
pub type CWPRETSTRUCT = tagCWPRETSTRUCT;
pub type PCWPRETSTRUCT = *mut tagCWPRETSTRUCT;
pub type NPCWPRETSTRUCT = *mut tagCWPRETSTRUCT;
pub type LPCWPRETSTRUCT = *mut tagCWPRETSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagKBDLLHOOKSTRUCT {
    pub vkCode: DWORD,
    pub scanCode: DWORD,
    pub flags: DWORD,
    pub time: DWORD,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagKBDLLHOOKSTRUCT"][::std::mem::size_of::<tagKBDLLHOOKSTRUCT>() - 24usize];
    ["Alignment of tagKBDLLHOOKSTRUCT"][::std::mem::align_of::<tagKBDLLHOOKSTRUCT>() - 8usize];
    ["Offset of field: tagKBDLLHOOKSTRUCT::vkCode"]
        [::std::mem::offset_of!(tagKBDLLHOOKSTRUCT, vkCode) - 0usize];
    ["Offset of field: tagKBDLLHOOKSTRUCT::scanCode"]
        [::std::mem::offset_of!(tagKBDLLHOOKSTRUCT, scanCode) - 4usize];
    ["Offset of field: tagKBDLLHOOKSTRUCT::flags"]
        [::std::mem::offset_of!(tagKBDLLHOOKSTRUCT, flags) - 8usize];
    ["Offset of field: tagKBDLLHOOKSTRUCT::time"]
        [::std::mem::offset_of!(tagKBDLLHOOKSTRUCT, time) - 12usize];
    ["Offset of field: tagKBDLLHOOKSTRUCT::dwExtraInfo"]
        [::std::mem::offset_of!(tagKBDLLHOOKSTRUCT, dwExtraInfo) - 16usize];
};
pub type KBDLLHOOKSTRUCT = tagKBDLLHOOKSTRUCT;
pub type LPKBDLLHOOKSTRUCT = *mut tagKBDLLHOOKSTRUCT;
pub type PKBDLLHOOKSTRUCT = *mut tagKBDLLHOOKSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMSLLHOOKSTRUCT {
    pub pt: POINT,
    pub mouseData: DWORD,
    pub flags: DWORD,
    pub time: DWORD,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMSLLHOOKSTRUCT"][::std::mem::size_of::<tagMSLLHOOKSTRUCT>() - 32usize];
    ["Alignment of tagMSLLHOOKSTRUCT"][::std::mem::align_of::<tagMSLLHOOKSTRUCT>() - 8usize];
    ["Offset of field: tagMSLLHOOKSTRUCT::pt"]
        [::std::mem::offset_of!(tagMSLLHOOKSTRUCT, pt) - 0usize];
    ["Offset of field: tagMSLLHOOKSTRUCT::mouseData"]
        [::std::mem::offset_of!(tagMSLLHOOKSTRUCT, mouseData) - 8usize];
    ["Offset of field: tagMSLLHOOKSTRUCT::flags"]
        [::std::mem::offset_of!(tagMSLLHOOKSTRUCT, flags) - 12usize];
    ["Offset of field: tagMSLLHOOKSTRUCT::time"]
        [::std::mem::offset_of!(tagMSLLHOOKSTRUCT, time) - 16usize];
    ["Offset of field: tagMSLLHOOKSTRUCT::dwExtraInfo"]
        [::std::mem::offset_of!(tagMSLLHOOKSTRUCT, dwExtraInfo) - 24usize];
};
pub type MSLLHOOKSTRUCT = tagMSLLHOOKSTRUCT;
pub type LPMSLLHOOKSTRUCT = *mut tagMSLLHOOKSTRUCT;
pub type PMSLLHOOKSTRUCT = *mut tagMSLLHOOKSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDEBUGHOOKINFO {
    pub idThread: DWORD,
    pub idThreadInstaller: DWORD,
    pub lParam: LPARAM,
    pub wParam: WPARAM,
    pub code: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEBUGHOOKINFO"][::std::mem::size_of::<tagDEBUGHOOKINFO>() - 32usize];
    ["Alignment of tagDEBUGHOOKINFO"][::std::mem::align_of::<tagDEBUGHOOKINFO>() - 8usize];
    ["Offset of field: tagDEBUGHOOKINFO::idThread"]
        [::std::mem::offset_of!(tagDEBUGHOOKINFO, idThread) - 0usize];
    ["Offset of field: tagDEBUGHOOKINFO::idThreadInstaller"]
        [::std::mem::offset_of!(tagDEBUGHOOKINFO, idThreadInstaller) - 4usize];
    ["Offset of field: tagDEBUGHOOKINFO::lParam"]
        [::std::mem::offset_of!(tagDEBUGHOOKINFO, lParam) - 8usize];
    ["Offset of field: tagDEBUGHOOKINFO::wParam"]
        [::std::mem::offset_of!(tagDEBUGHOOKINFO, wParam) - 16usize];
    ["Offset of field: tagDEBUGHOOKINFO::code"]
        [::std::mem::offset_of!(tagDEBUGHOOKINFO, code) - 24usize];
};
pub type DEBUGHOOKINFO = tagDEBUGHOOKINFO;
pub type PDEBUGHOOKINFO = *mut tagDEBUGHOOKINFO;
pub type NPDEBUGHOOKINFO = *mut tagDEBUGHOOKINFO;
pub type LPDEBUGHOOKINFO = *mut tagDEBUGHOOKINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMOUSEHOOKSTRUCT {
    pub pt: POINT,
    pub hwnd: HWND,
    pub wHitTestCode: UINT,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMOUSEHOOKSTRUCT"][::std::mem::size_of::<tagMOUSEHOOKSTRUCT>() - 32usize];
    ["Alignment of tagMOUSEHOOKSTRUCT"][::std::mem::align_of::<tagMOUSEHOOKSTRUCT>() - 8usize];
    ["Offset of field: tagMOUSEHOOKSTRUCT::pt"]
        [::std::mem::offset_of!(tagMOUSEHOOKSTRUCT, pt) - 0usize];
    ["Offset of field: tagMOUSEHOOKSTRUCT::hwnd"]
        [::std::mem::offset_of!(tagMOUSEHOOKSTRUCT, hwnd) - 8usize];
    ["Offset of field: tagMOUSEHOOKSTRUCT::wHitTestCode"]
        [::std::mem::offset_of!(tagMOUSEHOOKSTRUCT, wHitTestCode) - 16usize];
    ["Offset of field: tagMOUSEHOOKSTRUCT::dwExtraInfo"]
        [::std::mem::offset_of!(tagMOUSEHOOKSTRUCT, dwExtraInfo) - 24usize];
};
pub type MOUSEHOOKSTRUCT = tagMOUSEHOOKSTRUCT;
pub type LPMOUSEHOOKSTRUCT = *mut tagMOUSEHOOKSTRUCT;
pub type PMOUSEHOOKSTRUCT = *mut tagMOUSEHOOKSTRUCT;
#[repr(C)]
#[repr(align(8))]
#[derive(Debug, Copy, Clone)]
pub struct tagMOUSEHOOKSTRUCTEX {
    pub __bindgen_padding_0: [u32; 8usize],
    pub mouseData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMOUSEHOOKSTRUCTEX"][::std::mem::size_of::<tagMOUSEHOOKSTRUCTEX>() - 40usize];
    ["Alignment of tagMOUSEHOOKSTRUCTEX"][::std::mem::align_of::<tagMOUSEHOOKSTRUCTEX>() - 8usize];
    ["Offset of field: tagMOUSEHOOKSTRUCTEX::mouseData"]
        [::std::mem::offset_of!(tagMOUSEHOOKSTRUCTEX, mouseData) - 32usize];
};
pub type MOUSEHOOKSTRUCTEX = tagMOUSEHOOKSTRUCTEX;
pub type LPMOUSEHOOKSTRUCTEX = *mut tagMOUSEHOOKSTRUCTEX;
pub type PMOUSEHOOKSTRUCTEX = *mut tagMOUSEHOOKSTRUCTEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHARDWAREHOOKSTRUCT {
    pub hwnd: HWND,
    pub message: UINT,
    pub wParam: WPARAM,
    pub lParam: LPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHARDWAREHOOKSTRUCT"][::std::mem::size_of::<tagHARDWAREHOOKSTRUCT>() - 32usize];
    ["Alignment of tagHARDWAREHOOKSTRUCT"]
        [::std::mem::align_of::<tagHARDWAREHOOKSTRUCT>() - 8usize];
    ["Offset of field: tagHARDWAREHOOKSTRUCT::hwnd"]
        [::std::mem::offset_of!(tagHARDWAREHOOKSTRUCT, hwnd) - 0usize];
    ["Offset of field: tagHARDWAREHOOKSTRUCT::message"]
        [::std::mem::offset_of!(tagHARDWAREHOOKSTRUCT, message) - 8usize];
    ["Offset of field: tagHARDWAREHOOKSTRUCT::wParam"]
        [::std::mem::offset_of!(tagHARDWAREHOOKSTRUCT, wParam) - 16usize];
    ["Offset of field: tagHARDWAREHOOKSTRUCT::lParam"]
        [::std::mem::offset_of!(tagHARDWAREHOOKSTRUCT, lParam) - 24usize];
};
pub type HARDWAREHOOKSTRUCT = tagHARDWAREHOOKSTRUCT;
pub type LPHARDWAREHOOKSTRUCT = *mut tagHARDWAREHOOKSTRUCT;
pub type PHARDWAREHOOKSTRUCT = *mut tagHARDWAREHOOKSTRUCT;
unsafe extern "C" {
    pub fn LoadKeyboardLayoutA(pwszKLID: LPCSTR, Flags: UINT) -> HKL;
}
unsafe extern "C" {
    pub fn LoadKeyboardLayoutW(pwszKLID: LPCWSTR, Flags: UINT) -> HKL;
}
unsafe extern "C" {
    pub fn ActivateKeyboardLayout(hkl: HKL, Flags: UINT) -> HKL;
}
unsafe extern "C" {
    pub fn ToUnicodeEx(
        wVirtKey: UINT,
        wScanCode: UINT,
        lpKeyState: *const BYTE,
        pwszBuff: LPWSTR,
        cchBuff: ::std::os::raw::c_int,
        wFlags: UINT,
        dwhkl: HKL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn UnloadKeyboardLayout(hkl: HKL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetKeyboardLayoutNameA(pwszKLID: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetKeyboardLayoutNameW(pwszKLID: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetKeyboardLayoutList(
        nBuff: ::std::os::raw::c_int,
        lpList: *mut HKL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetKeyboardLayout(idThread: DWORD) -> HKL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMOUSEMOVEPOINT {
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub time: DWORD,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMOUSEMOVEPOINT"][::std::mem::size_of::<tagMOUSEMOVEPOINT>() - 24usize];
    ["Alignment of tagMOUSEMOVEPOINT"][::std::mem::align_of::<tagMOUSEMOVEPOINT>() - 8usize];
    ["Offset of field: tagMOUSEMOVEPOINT::x"]
        [::std::mem::offset_of!(tagMOUSEMOVEPOINT, x) - 0usize];
    ["Offset of field: tagMOUSEMOVEPOINT::y"]
        [::std::mem::offset_of!(tagMOUSEMOVEPOINT, y) - 4usize];
    ["Offset of field: tagMOUSEMOVEPOINT::time"]
        [::std::mem::offset_of!(tagMOUSEMOVEPOINT, time) - 8usize];
    ["Offset of field: tagMOUSEMOVEPOINT::dwExtraInfo"]
        [::std::mem::offset_of!(tagMOUSEMOVEPOINT, dwExtraInfo) - 16usize];
};
pub type MOUSEMOVEPOINT = tagMOUSEMOVEPOINT;
pub type PMOUSEMOVEPOINT = *mut tagMOUSEMOVEPOINT;
pub type LPMOUSEMOVEPOINT = *mut tagMOUSEMOVEPOINT;
unsafe extern "C" {
    pub fn GetMouseMovePointsEx(
        cbSize: UINT,
        lppt: LPMOUSEMOVEPOINT,
        lpptBuf: LPMOUSEMOVEPOINT,
        nBufPoints: ::std::os::raw::c_int,
        resolution: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CreateDesktopA(
        lpszDesktop: LPCSTR,
        lpszDevice: LPCSTR,
        pDevmode: *mut DEVMODEA,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn CreateDesktopW(
        lpszDesktop: LPCWSTR,
        lpszDevice: LPCWSTR,
        pDevmode: *mut DEVMODEW,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn CreateDesktopExA(
        lpszDesktop: LPCSTR,
        lpszDevice: LPCSTR,
        pDevmode: *mut DEVMODEA,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
        ulHeapSize: ULONG,
        pvoid: PVOID,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn CreateDesktopExW(
        lpszDesktop: LPCWSTR,
        lpszDevice: LPCWSTR,
        pDevmode: *mut DEVMODEW,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
        ulHeapSize: ULONG,
        pvoid: PVOID,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn OpenDesktopA(
        lpszDesktop: LPCSTR,
        dwFlags: DWORD,
        fInherit: BOOL,
        dwDesiredAccess: ACCESS_MASK,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn OpenDesktopW(
        lpszDesktop: LPCWSTR,
        dwFlags: DWORD,
        fInherit: BOOL,
        dwDesiredAccess: ACCESS_MASK,
    ) -> HDESK;
}
unsafe extern "C" {
    pub fn OpenInputDesktop(dwFlags: DWORD, fInherit: BOOL, dwDesiredAccess: ACCESS_MASK) -> HDESK;
}
unsafe extern "C" {
    pub fn EnumDesktopsA(hwinsta: HWINSTA, lpEnumFunc: DESKTOPENUMPROCA, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDesktopsW(hwinsta: HWINSTA, lpEnumFunc: DESKTOPENUMPROCW, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDesktopWindows(hDesktop: HDESK, lpfn: WNDENUMPROC, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn SwitchDesktop(hDesktop: HDESK) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadDesktop(hDesktop: HDESK) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseDesktop(hDesktop: HDESK) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadDesktop(dwThreadId: DWORD) -> HDESK;
}
unsafe extern "C" {
    pub fn CreateWindowStationA(
        lpwinsta: LPCSTR,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
    ) -> HWINSTA;
}
unsafe extern "C" {
    pub fn CreateWindowStationW(
        lpwinsta: LPCWSTR,
        dwFlags: DWORD,
        dwDesiredAccess: ACCESS_MASK,
        lpsa: LPSECURITY_ATTRIBUTES,
    ) -> HWINSTA;
}
unsafe extern "C" {
    pub fn OpenWindowStationA(
        lpszWinSta: LPCSTR,
        fInherit: BOOL,
        dwDesiredAccess: ACCESS_MASK,
    ) -> HWINSTA;
}
unsafe extern "C" {
    pub fn OpenWindowStationW(
        lpszWinSta: LPCWSTR,
        fInherit: BOOL,
        dwDesiredAccess: ACCESS_MASK,
    ) -> HWINSTA;
}
unsafe extern "C" {
    pub fn EnumWindowStationsA(lpEnumFunc: WINSTAENUMPROCA, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumWindowStationsW(lpEnumFunc: WINSTAENUMPROCW, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseWindowStation(hWinSta: HWINSTA) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessWindowStation(hWinSta: HWINSTA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetProcessWindowStation() -> HWINSTA;
}
unsafe extern "C" {
    pub fn SetUserObjectSecurity(
        hObj: HANDLE,
        pSIRequested: PSECURITY_INFORMATION,
        pSID: PSECURITY_DESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserObjectSecurity(
        hObj: HANDLE,
        pSIRequested: PSECURITY_INFORMATION,
        pSID: PSECURITY_DESCRIPTOR,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagUSEROBJECTFLAGS {
    pub fInherit: BOOL,
    pub fReserved: BOOL,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagUSEROBJECTFLAGS"][::std::mem::size_of::<tagUSEROBJECTFLAGS>() - 12usize];
    ["Alignment of tagUSEROBJECTFLAGS"][::std::mem::align_of::<tagUSEROBJECTFLAGS>() - 4usize];
    ["Offset of field: tagUSEROBJECTFLAGS::fInherit"]
        [::std::mem::offset_of!(tagUSEROBJECTFLAGS, fInherit) - 0usize];
    ["Offset of field: tagUSEROBJECTFLAGS::fReserved"]
        [::std::mem::offset_of!(tagUSEROBJECTFLAGS, fReserved) - 4usize];
    ["Offset of field: tagUSEROBJECTFLAGS::dwFlags"]
        [::std::mem::offset_of!(tagUSEROBJECTFLAGS, dwFlags) - 8usize];
};
pub type USEROBJECTFLAGS = tagUSEROBJECTFLAGS;
pub type PUSEROBJECTFLAGS = *mut tagUSEROBJECTFLAGS;
unsafe extern "C" {
    pub fn GetUserObjectInformationA(
        hObj: HANDLE,
        nIndex: ::std::os::raw::c_int,
        pvInfo: PVOID,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserObjectInformationW(
        hObj: HANDLE,
        nIndex: ::std::os::raw::c_int,
        pvInfo: PVOID,
        nLength: DWORD,
        lpnLengthNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetUserObjectInformationA(
        hObj: HANDLE,
        nIndex: ::std::os::raw::c_int,
        pvInfo: PVOID,
        nLength: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetUserObjectInformationW(
        hObj: HANDLE,
        nIndex: ::std::os::raw::c_int,
        pvInfo: PVOID,
        nLength: DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWNDCLASSEXA {
    pub cbSize: UINT,
    pub style: UINT,
    pub lpfnWndProc: WNDPROC,
    pub cbClsExtra: ::std::os::raw::c_int,
    pub cbWndExtra: ::std::os::raw::c_int,
    pub hInstance: HINSTANCE,
    pub hIcon: HICON,
    pub hCursor: HCURSOR,
    pub hbrBackground: HBRUSH,
    pub lpszMenuName: LPCSTR,
    pub lpszClassName: LPCSTR,
    pub hIconSm: HICON,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWNDCLASSEXA"][::std::mem::size_of::<tagWNDCLASSEXA>() - 80usize];
    ["Alignment of tagWNDCLASSEXA"][::std::mem::align_of::<tagWNDCLASSEXA>() - 8usize];
    ["Offset of field: tagWNDCLASSEXA::cbSize"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, cbSize) - 0usize];
    ["Offset of field: tagWNDCLASSEXA::style"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, style) - 4usize];
    ["Offset of field: tagWNDCLASSEXA::lpfnWndProc"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, lpfnWndProc) - 8usize];
    ["Offset of field: tagWNDCLASSEXA::cbClsExtra"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, cbClsExtra) - 16usize];
    ["Offset of field: tagWNDCLASSEXA::cbWndExtra"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, cbWndExtra) - 20usize];
    ["Offset of field: tagWNDCLASSEXA::hInstance"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, hInstance) - 24usize];
    ["Offset of field: tagWNDCLASSEXA::hIcon"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, hIcon) - 32usize];
    ["Offset of field: tagWNDCLASSEXA::hCursor"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, hCursor) - 40usize];
    ["Offset of field: tagWNDCLASSEXA::hbrBackground"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, hbrBackground) - 48usize];
    ["Offset of field: tagWNDCLASSEXA::lpszMenuName"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, lpszMenuName) - 56usize];
    ["Offset of field: tagWNDCLASSEXA::lpszClassName"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, lpszClassName) - 64usize];
    ["Offset of field: tagWNDCLASSEXA::hIconSm"]
        [::std::mem::offset_of!(tagWNDCLASSEXA, hIconSm) - 72usize];
};
pub type WNDCLASSEXA = tagWNDCLASSEXA;
pub type PWNDCLASSEXA = *mut tagWNDCLASSEXA;
pub type NPWNDCLASSEXA = *mut tagWNDCLASSEXA;
pub type LPWNDCLASSEXA = *mut tagWNDCLASSEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWNDCLASSEXW {
    pub cbSize: UINT,
    pub style: UINT,
    pub lpfnWndProc: WNDPROC,
    pub cbClsExtra: ::std::os::raw::c_int,
    pub cbWndExtra: ::std::os::raw::c_int,
    pub hInstance: HINSTANCE,
    pub hIcon: HICON,
    pub hCursor: HCURSOR,
    pub hbrBackground: HBRUSH,
    pub lpszMenuName: LPCWSTR,
    pub lpszClassName: LPCWSTR,
    pub hIconSm: HICON,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWNDCLASSEXW"][::std::mem::size_of::<tagWNDCLASSEXW>() - 80usize];
    ["Alignment of tagWNDCLASSEXW"][::std::mem::align_of::<tagWNDCLASSEXW>() - 8usize];
    ["Offset of field: tagWNDCLASSEXW::cbSize"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, cbSize) - 0usize];
    ["Offset of field: tagWNDCLASSEXW::style"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, style) - 4usize];
    ["Offset of field: tagWNDCLASSEXW::lpfnWndProc"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, lpfnWndProc) - 8usize];
    ["Offset of field: tagWNDCLASSEXW::cbClsExtra"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, cbClsExtra) - 16usize];
    ["Offset of field: tagWNDCLASSEXW::cbWndExtra"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, cbWndExtra) - 20usize];
    ["Offset of field: tagWNDCLASSEXW::hInstance"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, hInstance) - 24usize];
    ["Offset of field: tagWNDCLASSEXW::hIcon"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, hIcon) - 32usize];
    ["Offset of field: tagWNDCLASSEXW::hCursor"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, hCursor) - 40usize];
    ["Offset of field: tagWNDCLASSEXW::hbrBackground"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, hbrBackground) - 48usize];
    ["Offset of field: tagWNDCLASSEXW::lpszMenuName"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, lpszMenuName) - 56usize];
    ["Offset of field: tagWNDCLASSEXW::lpszClassName"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, lpszClassName) - 64usize];
    ["Offset of field: tagWNDCLASSEXW::hIconSm"]
        [::std::mem::offset_of!(tagWNDCLASSEXW, hIconSm) - 72usize];
};
pub type WNDCLASSEXW = tagWNDCLASSEXW;
pub type PWNDCLASSEXW = *mut tagWNDCLASSEXW;
pub type NPWNDCLASSEXW = *mut tagWNDCLASSEXW;
pub type LPWNDCLASSEXW = *mut tagWNDCLASSEXW;
pub type WNDCLASSEX = WNDCLASSEXA;
pub type PWNDCLASSEX = PWNDCLASSEXA;
pub type NPWNDCLASSEX = NPWNDCLASSEXA;
pub type LPWNDCLASSEX = LPWNDCLASSEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWNDCLASSA {
    pub style: UINT,
    pub lpfnWndProc: WNDPROC,
    pub cbClsExtra: ::std::os::raw::c_int,
    pub cbWndExtra: ::std::os::raw::c_int,
    pub hInstance: HINSTANCE,
    pub hIcon: HICON,
    pub hCursor: HCURSOR,
    pub hbrBackground: HBRUSH,
    pub lpszMenuName: LPCSTR,
    pub lpszClassName: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWNDCLASSA"][::std::mem::size_of::<tagWNDCLASSA>() - 72usize];
    ["Alignment of tagWNDCLASSA"][::std::mem::align_of::<tagWNDCLASSA>() - 8usize];
    ["Offset of field: tagWNDCLASSA::style"][::std::mem::offset_of!(tagWNDCLASSA, style) - 0usize];
    ["Offset of field: tagWNDCLASSA::lpfnWndProc"]
        [::std::mem::offset_of!(tagWNDCLASSA, lpfnWndProc) - 8usize];
    ["Offset of field: tagWNDCLASSA::cbClsExtra"]
        [::std::mem::offset_of!(tagWNDCLASSA, cbClsExtra) - 16usize];
    ["Offset of field: tagWNDCLASSA::cbWndExtra"]
        [::std::mem::offset_of!(tagWNDCLASSA, cbWndExtra) - 20usize];
    ["Offset of field: tagWNDCLASSA::hInstance"]
        [::std::mem::offset_of!(tagWNDCLASSA, hInstance) - 24usize];
    ["Offset of field: tagWNDCLASSA::hIcon"][::std::mem::offset_of!(tagWNDCLASSA, hIcon) - 32usize];
    ["Offset of field: tagWNDCLASSA::hCursor"]
        [::std::mem::offset_of!(tagWNDCLASSA, hCursor) - 40usize];
    ["Offset of field: tagWNDCLASSA::hbrBackground"]
        [::std::mem::offset_of!(tagWNDCLASSA, hbrBackground) - 48usize];
    ["Offset of field: tagWNDCLASSA::lpszMenuName"]
        [::std::mem::offset_of!(tagWNDCLASSA, lpszMenuName) - 56usize];
    ["Offset of field: tagWNDCLASSA::lpszClassName"]
        [::std::mem::offset_of!(tagWNDCLASSA, lpszClassName) - 64usize];
};
pub type WNDCLASSA = tagWNDCLASSA;
pub type PWNDCLASSA = *mut tagWNDCLASSA;
pub type NPWNDCLASSA = *mut tagWNDCLASSA;
pub type LPWNDCLASSA = *mut tagWNDCLASSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWNDCLASSW {
    pub style: UINT,
    pub lpfnWndProc: WNDPROC,
    pub cbClsExtra: ::std::os::raw::c_int,
    pub cbWndExtra: ::std::os::raw::c_int,
    pub hInstance: HINSTANCE,
    pub hIcon: HICON,
    pub hCursor: HCURSOR,
    pub hbrBackground: HBRUSH,
    pub lpszMenuName: LPCWSTR,
    pub lpszClassName: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWNDCLASSW"][::std::mem::size_of::<tagWNDCLASSW>() - 72usize];
    ["Alignment of tagWNDCLASSW"][::std::mem::align_of::<tagWNDCLASSW>() - 8usize];
    ["Offset of field: tagWNDCLASSW::style"][::std::mem::offset_of!(tagWNDCLASSW, style) - 0usize];
    ["Offset of field: tagWNDCLASSW::lpfnWndProc"]
        [::std::mem::offset_of!(tagWNDCLASSW, lpfnWndProc) - 8usize];
    ["Offset of field: tagWNDCLASSW::cbClsExtra"]
        [::std::mem::offset_of!(tagWNDCLASSW, cbClsExtra) - 16usize];
    ["Offset of field: tagWNDCLASSW::cbWndExtra"]
        [::std::mem::offset_of!(tagWNDCLASSW, cbWndExtra) - 20usize];
    ["Offset of field: tagWNDCLASSW::hInstance"]
        [::std::mem::offset_of!(tagWNDCLASSW, hInstance) - 24usize];
    ["Offset of field: tagWNDCLASSW::hIcon"][::std::mem::offset_of!(tagWNDCLASSW, hIcon) - 32usize];
    ["Offset of field: tagWNDCLASSW::hCursor"]
        [::std::mem::offset_of!(tagWNDCLASSW, hCursor) - 40usize];
    ["Offset of field: tagWNDCLASSW::hbrBackground"]
        [::std::mem::offset_of!(tagWNDCLASSW, hbrBackground) - 48usize];
    ["Offset of field: tagWNDCLASSW::lpszMenuName"]
        [::std::mem::offset_of!(tagWNDCLASSW, lpszMenuName) - 56usize];
    ["Offset of field: tagWNDCLASSW::lpszClassName"]
        [::std::mem::offset_of!(tagWNDCLASSW, lpszClassName) - 64usize];
};
pub type WNDCLASSW = tagWNDCLASSW;
pub type PWNDCLASSW = *mut tagWNDCLASSW;
pub type NPWNDCLASSW = *mut tagWNDCLASSW;
pub type LPWNDCLASSW = *mut tagWNDCLASSW;
pub type WNDCLASS = WNDCLASSA;
pub type PWNDCLASS = PWNDCLASSA;
pub type NPWNDCLASS = NPWNDCLASSA;
pub type LPWNDCLASS = LPWNDCLASSA;
unsafe extern "C" {
    pub fn IsHungAppWindow(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn DisableProcessWindowsGhosting();
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMSG {
    pub hwnd: HWND,
    pub message: UINT,
    pub wParam: WPARAM,
    pub lParam: LPARAM,
    pub time: DWORD,
    pub pt: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMSG"][::std::mem::size_of::<tagMSG>() - 48usize];
    ["Alignment of tagMSG"][::std::mem::align_of::<tagMSG>() - 8usize];
    ["Offset of field: tagMSG::hwnd"][::std::mem::offset_of!(tagMSG, hwnd) - 0usize];
    ["Offset of field: tagMSG::message"][::std::mem::offset_of!(tagMSG, message) - 8usize];
    ["Offset of field: tagMSG::wParam"][::std::mem::offset_of!(tagMSG, wParam) - 16usize];
    ["Offset of field: tagMSG::lParam"][::std::mem::offset_of!(tagMSG, lParam) - 24usize];
    ["Offset of field: tagMSG::time"][::std::mem::offset_of!(tagMSG, time) - 32usize];
    ["Offset of field: tagMSG::pt"][::std::mem::offset_of!(tagMSG, pt) - 36usize];
};
pub type MSG = tagMSG;
pub type PMSG = *mut tagMSG;
pub type NPMSG = *mut tagMSG;
pub type LPMSG = *mut tagMSG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMINMAXINFO {
    pub ptReserved: POINT,
    pub ptMaxSize: POINT,
    pub ptMaxPosition: POINT,
    pub ptMinTrackSize: POINT,
    pub ptMaxTrackSize: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMINMAXINFO"][::std::mem::size_of::<tagMINMAXINFO>() - 40usize];
    ["Alignment of tagMINMAXINFO"][::std::mem::align_of::<tagMINMAXINFO>() - 4usize];
    ["Offset of field: tagMINMAXINFO::ptReserved"]
        [::std::mem::offset_of!(tagMINMAXINFO, ptReserved) - 0usize];
    ["Offset of field: tagMINMAXINFO::ptMaxSize"]
        [::std::mem::offset_of!(tagMINMAXINFO, ptMaxSize) - 8usize];
    ["Offset of field: tagMINMAXINFO::ptMaxPosition"]
        [::std::mem::offset_of!(tagMINMAXINFO, ptMaxPosition) - 16usize];
    ["Offset of field: tagMINMAXINFO::ptMinTrackSize"]
        [::std::mem::offset_of!(tagMINMAXINFO, ptMinTrackSize) - 24usize];
    ["Offset of field: tagMINMAXINFO::ptMaxTrackSize"]
        [::std::mem::offset_of!(tagMINMAXINFO, ptMaxTrackSize) - 32usize];
};
pub type MINMAXINFO = tagMINMAXINFO;
pub type PMINMAXINFO = *mut tagMINMAXINFO;
pub type LPMINMAXINFO = *mut tagMINMAXINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOPYDATASTRUCT {
    pub dwData: ULONG_PTR,
    pub cbData: DWORD,
    pub lpData: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOPYDATASTRUCT"][::std::mem::size_of::<tagCOPYDATASTRUCT>() - 24usize];
    ["Alignment of tagCOPYDATASTRUCT"][::std::mem::align_of::<tagCOPYDATASTRUCT>() - 8usize];
    ["Offset of field: tagCOPYDATASTRUCT::dwData"]
        [::std::mem::offset_of!(tagCOPYDATASTRUCT, dwData) - 0usize];
    ["Offset of field: tagCOPYDATASTRUCT::cbData"]
        [::std::mem::offset_of!(tagCOPYDATASTRUCT, cbData) - 8usize];
    ["Offset of field: tagCOPYDATASTRUCT::lpData"]
        [::std::mem::offset_of!(tagCOPYDATASTRUCT, lpData) - 16usize];
};
pub type COPYDATASTRUCT = tagCOPYDATASTRUCT;
pub type PCOPYDATASTRUCT = *mut tagCOPYDATASTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMDINEXTMENU {
    pub hmenuIn: HMENU,
    pub hmenuNext: HMENU,
    pub hwndNext: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMDINEXTMENU"][::std::mem::size_of::<tagMDINEXTMENU>() - 24usize];
    ["Alignment of tagMDINEXTMENU"][::std::mem::align_of::<tagMDINEXTMENU>() - 8usize];
    ["Offset of field: tagMDINEXTMENU::hmenuIn"]
        [::std::mem::offset_of!(tagMDINEXTMENU, hmenuIn) - 0usize];
    ["Offset of field: tagMDINEXTMENU::hmenuNext"]
        [::std::mem::offset_of!(tagMDINEXTMENU, hmenuNext) - 8usize];
    ["Offset of field: tagMDINEXTMENU::hwndNext"]
        [::std::mem::offset_of!(tagMDINEXTMENU, hwndNext) - 16usize];
};
pub type MDINEXTMENU = tagMDINEXTMENU;
pub type PMDINEXTMENU = *mut tagMDINEXTMENU;
pub type LPMDINEXTMENU = *mut tagMDINEXTMENU;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct POWERBROADCAST_SETTING {
    pub PowerSetting: GUID,
    pub DataLength: DWORD,
    pub Data: [UCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of POWERBROADCAST_SETTING"][::std::mem::size_of::<POWERBROADCAST_SETTING>() - 24usize];
    ["Alignment of POWERBROADCAST_SETTING"]
        [::std::mem::align_of::<POWERBROADCAST_SETTING>() - 4usize];
    ["Offset of field: POWERBROADCAST_SETTING::PowerSetting"]
        [::std::mem::offset_of!(POWERBROADCAST_SETTING, PowerSetting) - 0usize];
    ["Offset of field: POWERBROADCAST_SETTING::DataLength"]
        [::std::mem::offset_of!(POWERBROADCAST_SETTING, DataLength) - 16usize];
    ["Offset of field: POWERBROADCAST_SETTING::Data"]
        [::std::mem::offset_of!(POWERBROADCAST_SETTING, Data) - 20usize];
};
pub type PPOWERBROADCAST_SETTING = *mut POWERBROADCAST_SETTING;
unsafe extern "C" {
    pub fn RegisterWindowMessageA(lpString: LPCSTR) -> UINT;
}
unsafe extern "C" {
    pub fn RegisterWindowMessageW(lpString: LPCWSTR) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWINDOWPOS {
    pub hwnd: HWND,
    pub hwndInsertAfter: HWND,
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub cy: ::std::os::raw::c_int,
    pub flags: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWINDOWPOS"][::std::mem::size_of::<tagWINDOWPOS>() - 40usize];
    ["Alignment of tagWINDOWPOS"][::std::mem::align_of::<tagWINDOWPOS>() - 8usize];
    ["Offset of field: tagWINDOWPOS::hwnd"][::std::mem::offset_of!(tagWINDOWPOS, hwnd) - 0usize];
    ["Offset of field: tagWINDOWPOS::hwndInsertAfter"]
        [::std::mem::offset_of!(tagWINDOWPOS, hwndInsertAfter) - 8usize];
    ["Offset of field: tagWINDOWPOS::x"][::std::mem::offset_of!(tagWINDOWPOS, x) - 16usize];
    ["Offset of field: tagWINDOWPOS::y"][::std::mem::offset_of!(tagWINDOWPOS, y) - 20usize];
    ["Offset of field: tagWINDOWPOS::cx"][::std::mem::offset_of!(tagWINDOWPOS, cx) - 24usize];
    ["Offset of field: tagWINDOWPOS::cy"][::std::mem::offset_of!(tagWINDOWPOS, cy) - 28usize];
    ["Offset of field: tagWINDOWPOS::flags"][::std::mem::offset_of!(tagWINDOWPOS, flags) - 32usize];
};
pub type WINDOWPOS = tagWINDOWPOS;
pub type LPWINDOWPOS = *mut tagWINDOWPOS;
pub type PWINDOWPOS = *mut tagWINDOWPOS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNCCALCSIZE_PARAMS {
    pub rgrc: [RECT; 3usize],
    pub lppos: PWINDOWPOS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNCCALCSIZE_PARAMS"][::std::mem::size_of::<tagNCCALCSIZE_PARAMS>() - 56usize];
    ["Alignment of tagNCCALCSIZE_PARAMS"][::std::mem::align_of::<tagNCCALCSIZE_PARAMS>() - 8usize];
    ["Offset of field: tagNCCALCSIZE_PARAMS::rgrc"]
        [::std::mem::offset_of!(tagNCCALCSIZE_PARAMS, rgrc) - 0usize];
    ["Offset of field: tagNCCALCSIZE_PARAMS::lppos"]
        [::std::mem::offset_of!(tagNCCALCSIZE_PARAMS, lppos) - 48usize];
};
pub type NCCALCSIZE_PARAMS = tagNCCALCSIZE_PARAMS;
pub type LPNCCALCSIZE_PARAMS = *mut tagNCCALCSIZE_PARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTRACKMOUSEEVENT {
    pub cbSize: DWORD,
    pub dwFlags: DWORD,
    pub hwndTrack: HWND,
    pub dwHoverTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTRACKMOUSEEVENT"][::std::mem::size_of::<tagTRACKMOUSEEVENT>() - 24usize];
    ["Alignment of tagTRACKMOUSEEVENT"][::std::mem::align_of::<tagTRACKMOUSEEVENT>() - 8usize];
    ["Offset of field: tagTRACKMOUSEEVENT::cbSize"]
        [::std::mem::offset_of!(tagTRACKMOUSEEVENT, cbSize) - 0usize];
    ["Offset of field: tagTRACKMOUSEEVENT::dwFlags"]
        [::std::mem::offset_of!(tagTRACKMOUSEEVENT, dwFlags) - 4usize];
    ["Offset of field: tagTRACKMOUSEEVENT::hwndTrack"]
        [::std::mem::offset_of!(tagTRACKMOUSEEVENT, hwndTrack) - 8usize];
    ["Offset of field: tagTRACKMOUSEEVENT::dwHoverTime"]
        [::std::mem::offset_of!(tagTRACKMOUSEEVENT, dwHoverTime) - 16usize];
};
pub type TRACKMOUSEEVENT = tagTRACKMOUSEEVENT;
pub type LPTRACKMOUSEEVENT = *mut tagTRACKMOUSEEVENT;
unsafe extern "C" {
    pub fn TrackMouseEvent(lpEventTrack: LPTRACKMOUSEEVENT) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawEdge(hdc: HDC, qrc: LPRECT, edge: UINT, grfFlags: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawFrameControl(arg1: HDC, arg2: LPRECT, arg3: UINT, arg4: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawCaption(hwnd: HWND, hdc: HDC, lprect: *const RECT, flags: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawAnimatedRects(
        hwnd: HWND,
        idAni: ::std::os::raw::c_int,
        lprcFrom: *const RECT,
        lprcTo: *const RECT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACCEL {
    pub fVirt: BYTE,
    pub key: WORD,
    pub cmd: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACCEL"][::std::mem::size_of::<tagACCEL>() - 6usize];
    ["Alignment of tagACCEL"][::std::mem::align_of::<tagACCEL>() - 2usize];
    ["Offset of field: tagACCEL::fVirt"][::std::mem::offset_of!(tagACCEL, fVirt) - 0usize];
    ["Offset of field: tagACCEL::key"][::std::mem::offset_of!(tagACCEL, key) - 2usize];
    ["Offset of field: tagACCEL::cmd"][::std::mem::offset_of!(tagACCEL, cmd) - 4usize];
};
pub type ACCEL = tagACCEL;
pub type LPACCEL = *mut tagACCEL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPAINTSTRUCT {
    pub hdc: HDC,
    pub fErase: BOOL,
    pub rcPaint: RECT,
    pub fRestore: BOOL,
    pub fIncUpdate: BOOL,
    pub rgbReserved: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPAINTSTRUCT"][::std::mem::size_of::<tagPAINTSTRUCT>() - 72usize];
    ["Alignment of tagPAINTSTRUCT"][::std::mem::align_of::<tagPAINTSTRUCT>() - 8usize];
    ["Offset of field: tagPAINTSTRUCT::hdc"][::std::mem::offset_of!(tagPAINTSTRUCT, hdc) - 0usize];
    ["Offset of field: tagPAINTSTRUCT::fErase"]
        [::std::mem::offset_of!(tagPAINTSTRUCT, fErase) - 8usize];
    ["Offset of field: tagPAINTSTRUCT::rcPaint"]
        [::std::mem::offset_of!(tagPAINTSTRUCT, rcPaint) - 12usize];
    ["Offset of field: tagPAINTSTRUCT::fRestore"]
        [::std::mem::offset_of!(tagPAINTSTRUCT, fRestore) - 28usize];
    ["Offset of field: tagPAINTSTRUCT::fIncUpdate"]
        [::std::mem::offset_of!(tagPAINTSTRUCT, fIncUpdate) - 32usize];
    ["Offset of field: tagPAINTSTRUCT::rgbReserved"]
        [::std::mem::offset_of!(tagPAINTSTRUCT, rgbReserved) - 36usize];
};
pub type PAINTSTRUCT = tagPAINTSTRUCT;
pub type PPAINTSTRUCT = *mut tagPAINTSTRUCT;
pub type NPPAINTSTRUCT = *mut tagPAINTSTRUCT;
pub type LPPAINTSTRUCT = *mut tagPAINTSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCREATESTRUCTA {
    pub lpCreateParams: LPVOID,
    pub hInstance: HINSTANCE,
    pub hMenu: HMENU,
    pub hwndParent: HWND,
    pub cy: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub x: ::std::os::raw::c_int,
    pub style: LONG,
    pub lpszName: LPCSTR,
    pub lpszClass: LPCSTR,
    pub dwExStyle: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCREATESTRUCTA"][::std::mem::size_of::<tagCREATESTRUCTA>() - 80usize];
    ["Alignment of tagCREATESTRUCTA"][::std::mem::align_of::<tagCREATESTRUCTA>() - 8usize];
    ["Offset of field: tagCREATESTRUCTA::lpCreateParams"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, lpCreateParams) - 0usize];
    ["Offset of field: tagCREATESTRUCTA::hInstance"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, hInstance) - 8usize];
    ["Offset of field: tagCREATESTRUCTA::hMenu"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, hMenu) - 16usize];
    ["Offset of field: tagCREATESTRUCTA::hwndParent"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, hwndParent) - 24usize];
    ["Offset of field: tagCREATESTRUCTA::cy"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, cy) - 32usize];
    ["Offset of field: tagCREATESTRUCTA::cx"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, cx) - 36usize];
    ["Offset of field: tagCREATESTRUCTA::y"][::std::mem::offset_of!(tagCREATESTRUCTA, y) - 40usize];
    ["Offset of field: tagCREATESTRUCTA::x"][::std::mem::offset_of!(tagCREATESTRUCTA, x) - 44usize];
    ["Offset of field: tagCREATESTRUCTA::style"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, style) - 48usize];
    ["Offset of field: tagCREATESTRUCTA::lpszName"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, lpszName) - 56usize];
    ["Offset of field: tagCREATESTRUCTA::lpszClass"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, lpszClass) - 64usize];
    ["Offset of field: tagCREATESTRUCTA::dwExStyle"]
        [::std::mem::offset_of!(tagCREATESTRUCTA, dwExStyle) - 72usize];
};
pub type CREATESTRUCTA = tagCREATESTRUCTA;
pub type LPCREATESTRUCTA = *mut tagCREATESTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCREATESTRUCTW {
    pub lpCreateParams: LPVOID,
    pub hInstance: HINSTANCE,
    pub hMenu: HMENU,
    pub hwndParent: HWND,
    pub cy: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub x: ::std::os::raw::c_int,
    pub style: LONG,
    pub lpszName: LPCWSTR,
    pub lpszClass: LPCWSTR,
    pub dwExStyle: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCREATESTRUCTW"][::std::mem::size_of::<tagCREATESTRUCTW>() - 80usize];
    ["Alignment of tagCREATESTRUCTW"][::std::mem::align_of::<tagCREATESTRUCTW>() - 8usize];
    ["Offset of field: tagCREATESTRUCTW::lpCreateParams"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, lpCreateParams) - 0usize];
    ["Offset of field: tagCREATESTRUCTW::hInstance"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, hInstance) - 8usize];
    ["Offset of field: tagCREATESTRUCTW::hMenu"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, hMenu) - 16usize];
    ["Offset of field: tagCREATESTRUCTW::hwndParent"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, hwndParent) - 24usize];
    ["Offset of field: tagCREATESTRUCTW::cy"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, cy) - 32usize];
    ["Offset of field: tagCREATESTRUCTW::cx"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, cx) - 36usize];
    ["Offset of field: tagCREATESTRUCTW::y"][::std::mem::offset_of!(tagCREATESTRUCTW, y) - 40usize];
    ["Offset of field: tagCREATESTRUCTW::x"][::std::mem::offset_of!(tagCREATESTRUCTW, x) - 44usize];
    ["Offset of field: tagCREATESTRUCTW::style"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, style) - 48usize];
    ["Offset of field: tagCREATESTRUCTW::lpszName"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, lpszName) - 56usize];
    ["Offset of field: tagCREATESTRUCTW::lpszClass"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, lpszClass) - 64usize];
    ["Offset of field: tagCREATESTRUCTW::dwExStyle"]
        [::std::mem::offset_of!(tagCREATESTRUCTW, dwExStyle) - 72usize];
};
pub type CREATESTRUCTW = tagCREATESTRUCTW;
pub type LPCREATESTRUCTW = *mut tagCREATESTRUCTW;
pub type CREATESTRUCT = CREATESTRUCTA;
pub type LPCREATESTRUCT = LPCREATESTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWINDOWPLACEMENT {
    pub length: UINT,
    pub flags: UINT,
    pub showCmd: UINT,
    pub ptMinPosition: POINT,
    pub ptMaxPosition: POINT,
    pub rcNormalPosition: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWINDOWPLACEMENT"][::std::mem::size_of::<tagWINDOWPLACEMENT>() - 44usize];
    ["Alignment of tagWINDOWPLACEMENT"][::std::mem::align_of::<tagWINDOWPLACEMENT>() - 4usize];
    ["Offset of field: tagWINDOWPLACEMENT::length"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, length) - 0usize];
    ["Offset of field: tagWINDOWPLACEMENT::flags"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, flags) - 4usize];
    ["Offset of field: tagWINDOWPLACEMENT::showCmd"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, showCmd) - 8usize];
    ["Offset of field: tagWINDOWPLACEMENT::ptMinPosition"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, ptMinPosition) - 12usize];
    ["Offset of field: tagWINDOWPLACEMENT::ptMaxPosition"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, ptMaxPosition) - 20usize];
    ["Offset of field: tagWINDOWPLACEMENT::rcNormalPosition"]
        [::std::mem::offset_of!(tagWINDOWPLACEMENT, rcNormalPosition) - 28usize];
};
pub type WINDOWPLACEMENT = tagWINDOWPLACEMENT;
pub type PWINDOWPLACEMENT = *mut WINDOWPLACEMENT;
pub type LPWINDOWPLACEMENT = *mut WINDOWPLACEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNMHDR {
    pub hwndFrom: HWND,
    pub idFrom: UINT_PTR,
    pub code: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNMHDR"][::std::mem::size_of::<tagNMHDR>() - 24usize];
    ["Alignment of tagNMHDR"][::std::mem::align_of::<tagNMHDR>() - 8usize];
    ["Offset of field: tagNMHDR::hwndFrom"][::std::mem::offset_of!(tagNMHDR, hwndFrom) - 0usize];
    ["Offset of field: tagNMHDR::idFrom"][::std::mem::offset_of!(tagNMHDR, idFrom) - 8usize];
    ["Offset of field: tagNMHDR::code"][::std::mem::offset_of!(tagNMHDR, code) - 16usize];
};
pub type NMHDR = tagNMHDR;
pub type LPNMHDR = *mut NMHDR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTYLESTRUCT {
    pub styleOld: DWORD,
    pub styleNew: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTYLESTRUCT"][::std::mem::size_of::<tagSTYLESTRUCT>() - 8usize];
    ["Alignment of tagSTYLESTRUCT"][::std::mem::align_of::<tagSTYLESTRUCT>() - 4usize];
    ["Offset of field: tagSTYLESTRUCT::styleOld"]
        [::std::mem::offset_of!(tagSTYLESTRUCT, styleOld) - 0usize];
    ["Offset of field: tagSTYLESTRUCT::styleNew"]
        [::std::mem::offset_of!(tagSTYLESTRUCT, styleNew) - 4usize];
};
pub type STYLESTRUCT = tagSTYLESTRUCT;
pub type LPSTYLESTRUCT = *mut tagSTYLESTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMEASUREITEMSTRUCT {
    pub CtlType: UINT,
    pub CtlID: UINT,
    pub itemID: UINT,
    pub itemWidth: UINT,
    pub itemHeight: UINT,
    pub itemData: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMEASUREITEMSTRUCT"][::std::mem::size_of::<tagMEASUREITEMSTRUCT>() - 32usize];
    ["Alignment of tagMEASUREITEMSTRUCT"][::std::mem::align_of::<tagMEASUREITEMSTRUCT>() - 8usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::CtlType"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, CtlType) - 0usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::CtlID"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, CtlID) - 4usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::itemID"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, itemID) - 8usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::itemWidth"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, itemWidth) - 12usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::itemHeight"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, itemHeight) - 16usize];
    ["Offset of field: tagMEASUREITEMSTRUCT::itemData"]
        [::std::mem::offset_of!(tagMEASUREITEMSTRUCT, itemData) - 24usize];
};
pub type MEASUREITEMSTRUCT = tagMEASUREITEMSTRUCT;
pub type PMEASUREITEMSTRUCT = *mut tagMEASUREITEMSTRUCT;
pub type LPMEASUREITEMSTRUCT = *mut tagMEASUREITEMSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDRAWITEMSTRUCT {
    pub CtlType: UINT,
    pub CtlID: UINT,
    pub itemID: UINT,
    pub itemAction: UINT,
    pub itemState: UINT,
    pub hwndItem: HWND,
    pub hDC: HDC,
    pub rcItem: RECT,
    pub itemData: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDRAWITEMSTRUCT"][::std::mem::size_of::<tagDRAWITEMSTRUCT>() - 64usize];
    ["Alignment of tagDRAWITEMSTRUCT"][::std::mem::align_of::<tagDRAWITEMSTRUCT>() - 8usize];
    ["Offset of field: tagDRAWITEMSTRUCT::CtlType"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, CtlType) - 0usize];
    ["Offset of field: tagDRAWITEMSTRUCT::CtlID"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, CtlID) - 4usize];
    ["Offset of field: tagDRAWITEMSTRUCT::itemID"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, itemID) - 8usize];
    ["Offset of field: tagDRAWITEMSTRUCT::itemAction"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, itemAction) - 12usize];
    ["Offset of field: tagDRAWITEMSTRUCT::itemState"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, itemState) - 16usize];
    ["Offset of field: tagDRAWITEMSTRUCT::hwndItem"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, hwndItem) - 24usize];
    ["Offset of field: tagDRAWITEMSTRUCT::hDC"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, hDC) - 32usize];
    ["Offset of field: tagDRAWITEMSTRUCT::rcItem"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, rcItem) - 40usize];
    ["Offset of field: tagDRAWITEMSTRUCT::itemData"]
        [::std::mem::offset_of!(tagDRAWITEMSTRUCT, itemData) - 56usize];
};
pub type DRAWITEMSTRUCT = tagDRAWITEMSTRUCT;
pub type PDRAWITEMSTRUCT = *mut tagDRAWITEMSTRUCT;
pub type LPDRAWITEMSTRUCT = *mut tagDRAWITEMSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDELETEITEMSTRUCT {
    pub CtlType: UINT,
    pub CtlID: UINT,
    pub itemID: UINT,
    pub hwndItem: HWND,
    pub itemData: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDELETEITEMSTRUCT"][::std::mem::size_of::<tagDELETEITEMSTRUCT>() - 32usize];
    ["Alignment of tagDELETEITEMSTRUCT"][::std::mem::align_of::<tagDELETEITEMSTRUCT>() - 8usize];
    ["Offset of field: tagDELETEITEMSTRUCT::CtlType"]
        [::std::mem::offset_of!(tagDELETEITEMSTRUCT, CtlType) - 0usize];
    ["Offset of field: tagDELETEITEMSTRUCT::CtlID"]
        [::std::mem::offset_of!(tagDELETEITEMSTRUCT, CtlID) - 4usize];
    ["Offset of field: tagDELETEITEMSTRUCT::itemID"]
        [::std::mem::offset_of!(tagDELETEITEMSTRUCT, itemID) - 8usize];
    ["Offset of field: tagDELETEITEMSTRUCT::hwndItem"]
        [::std::mem::offset_of!(tagDELETEITEMSTRUCT, hwndItem) - 16usize];
    ["Offset of field: tagDELETEITEMSTRUCT::itemData"]
        [::std::mem::offset_of!(tagDELETEITEMSTRUCT, itemData) - 24usize];
};
pub type DELETEITEMSTRUCT = tagDELETEITEMSTRUCT;
pub type PDELETEITEMSTRUCT = *mut tagDELETEITEMSTRUCT;
pub type LPDELETEITEMSTRUCT = *mut tagDELETEITEMSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOMPAREITEMSTRUCT {
    pub CtlType: UINT,
    pub CtlID: UINT,
    pub hwndItem: HWND,
    pub itemID1: UINT,
    pub itemData1: ULONG_PTR,
    pub itemID2: UINT,
    pub itemData2: ULONG_PTR,
    pub dwLocaleId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOMPAREITEMSTRUCT"][::std::mem::size_of::<tagCOMPAREITEMSTRUCT>() - 56usize];
    ["Alignment of tagCOMPAREITEMSTRUCT"][::std::mem::align_of::<tagCOMPAREITEMSTRUCT>() - 8usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::CtlType"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, CtlType) - 0usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::CtlID"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, CtlID) - 4usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::hwndItem"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, hwndItem) - 8usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::itemID1"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, itemID1) - 16usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::itemData1"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, itemData1) - 24usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::itemID2"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, itemID2) - 32usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::itemData2"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, itemData2) - 40usize];
    ["Offset of field: tagCOMPAREITEMSTRUCT::dwLocaleId"]
        [::std::mem::offset_of!(tagCOMPAREITEMSTRUCT, dwLocaleId) - 48usize];
};
pub type COMPAREITEMSTRUCT = tagCOMPAREITEMSTRUCT;
pub type PCOMPAREITEMSTRUCT = *mut tagCOMPAREITEMSTRUCT;
pub type LPCOMPAREITEMSTRUCT = *mut tagCOMPAREITEMSTRUCT;
unsafe extern "C" {
    pub fn GetMessageA(lpMsg: LPMSG, hWnd: HWND, wMsgFilterMin: UINT, wMsgFilterMax: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMessageW(lpMsg: LPMSG, hWnd: HWND, wMsgFilterMin: UINT, wMsgFilterMax: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn TranslateMessage(lpMsg: *const MSG) -> BOOL;
}
unsafe extern "C" {
    pub fn DispatchMessageA(lpMsg: *const MSG) -> LRESULT;
}
unsafe extern "C" {
    pub fn DispatchMessageW(lpMsg: *const MSG) -> LRESULT;
}
unsafe extern "C" {
    pub fn SetMessageQueue(cMessagesMax: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn PeekMessageA(
        lpMsg: LPMSG,
        hWnd: HWND,
        wMsgFilterMin: UINT,
        wMsgFilterMax: UINT,
        wRemoveMsg: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PeekMessageW(
        lpMsg: LPMSG,
        hWnd: HWND,
        wMsgFilterMin: UINT,
        wMsgFilterMax: UINT,
        wRemoveMsg: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterHotKey(
        hWnd: HWND,
        id: ::std::os::raw::c_int,
        fsModifiers: UINT,
        vk: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterHotKey(hWnd: HWND, id: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn ExitWindowsEx(uFlags: UINT, dwReason: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SwapMouseButton(fSwap: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMessagePos() -> DWORD;
}
unsafe extern "C" {
    pub fn GetMessageTime() -> LONG;
}
unsafe extern "C" {
    pub fn GetMessageExtraInfo() -> LPARAM;
}
unsafe extern "C" {
    pub fn GetUnpredictedMessagePos() -> DWORD;
}
unsafe extern "C" {
    pub fn IsWow64Message() -> BOOL;
}
unsafe extern "C" {
    pub fn SetMessageExtraInfo(lParam: LPARAM) -> LPARAM;
}
unsafe extern "C" {
    pub fn SendMessageA(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn SendMessageW(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn SendMessageTimeoutA(
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        fuFlags: UINT,
        uTimeout: UINT,
        lpdwResult: PDWORD_PTR,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn SendMessageTimeoutW(
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        fuFlags: UINT,
        uTimeout: UINT,
        lpdwResult: PDWORD_PTR,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn SendNotifyMessageA(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn SendNotifyMessageW(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn SendMessageCallbackA(
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        lpResultCallBack: SENDASYNCPROC,
        dwData: ULONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SendMessageCallbackW(
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        lpResultCallBack: SENDASYNCPROC,
        dwData: ULONG_PTR,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct BSMINFO {
    pub cbSize: UINT,
    pub hdesk: HDESK,
    pub hwnd: HWND,
    pub luid: LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of BSMINFO"][::std::mem::size_of::<BSMINFO>() - 32usize];
    ["Alignment of BSMINFO"][::std::mem::align_of::<BSMINFO>() - 8usize];
    ["Offset of field: BSMINFO::cbSize"][::std::mem::offset_of!(BSMINFO, cbSize) - 0usize];
    ["Offset of field: BSMINFO::hdesk"][::std::mem::offset_of!(BSMINFO, hdesk) - 8usize];
    ["Offset of field: BSMINFO::hwnd"][::std::mem::offset_of!(BSMINFO, hwnd) - 16usize];
    ["Offset of field: BSMINFO::luid"][::std::mem::offset_of!(BSMINFO, luid) - 24usize];
};
pub type PBSMINFO = *mut BSMINFO;
unsafe extern "C" {
    pub fn BroadcastSystemMessageExA(
        flags: DWORD,
        lpInfo: LPDWORD,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        pbsmInfo: PBSMINFO,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn BroadcastSystemMessageExW(
        flags: DWORD,
        lpInfo: LPDWORD,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
        pbsmInfo: PBSMINFO,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn BroadcastSystemMessageA(
        flags: DWORD,
        lpInfo: LPDWORD,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn BroadcastSystemMessageW(
        flags: DWORD,
        lpInfo: LPDWORD,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_long;
}
pub type HDEVNOTIFY = PVOID;
pub type PHDEVNOTIFY = *mut HDEVNOTIFY;
unsafe extern "C" {
    pub fn RegisterDeviceNotificationA(
        hRecipient: HANDLE,
        NotificationFilter: LPVOID,
        Flags: DWORD,
    ) -> HDEVNOTIFY;
}
unsafe extern "C" {
    pub fn RegisterDeviceNotificationW(
        hRecipient: HANDLE,
        NotificationFilter: LPVOID,
        Flags: DWORD,
    ) -> HDEVNOTIFY;
}
unsafe extern "C" {
    pub fn UnregisterDeviceNotification(Handle: HDEVNOTIFY) -> BOOL;
}
pub type HPOWERNOTIFY = PVOID;
pub type PHPOWERNOTIFY = *mut HPOWERNOTIFY;
unsafe extern "C" {
    pub fn RegisterPowerSettingNotification(
        hRecipient: HANDLE,
        PowerSettingGuid: LPCGUID,
        Flags: DWORD,
    ) -> HPOWERNOTIFY;
}
unsafe extern "C" {
    pub fn UnregisterPowerSettingNotification(Handle: HPOWERNOTIFY) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterSuspendResumeNotification(hRecipient: HANDLE, Flags: DWORD) -> HPOWERNOTIFY;
}
unsafe extern "C" {
    pub fn UnregisterSuspendResumeNotification(Handle: HPOWERNOTIFY) -> BOOL;
}
unsafe extern "C" {
    pub fn PostMessageA(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn PostMessageW(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn PostThreadMessageA(idThread: DWORD, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn PostThreadMessageW(idThread: DWORD, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn AttachThreadInput(idAttach: DWORD, idAttachTo: DWORD, fAttach: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn ReplyMessage(lResult: LRESULT) -> BOOL;
}
unsafe extern "C" {
    pub fn WaitMessage() -> BOOL;
}
unsafe extern "C" {
    pub fn WaitForInputIdle(hProcess: HANDLE, dwMilliseconds: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn DefWindowProcA(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn DefWindowProcW(hWnd: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn PostQuitMessage(nExitCode: ::std::os::raw::c_int);
}
unsafe extern "C" {
    pub fn CallWindowProcA(
        lpPrevWndFunc: WNDPROC,
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn CallWindowProcW(
        lpPrevWndFunc: WNDPROC,
        hWnd: HWND,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn InSendMessage() -> BOOL;
}
unsafe extern "C" {
    pub fn InSendMessageEx(lpReserved: LPVOID) -> DWORD;
}
unsafe extern "C" {
    pub fn GetDoubleClickTime() -> UINT;
}
unsafe extern "C" {
    pub fn SetDoubleClickTime(arg1: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterClassA(lpWndClass: *const WNDCLASSA) -> ATOM;
}
unsafe extern "C" {
    pub fn RegisterClassW(lpWndClass: *const WNDCLASSW) -> ATOM;
}
unsafe extern "C" {
    pub fn UnregisterClassA(lpClassName: LPCSTR, hInstance: HINSTANCE) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterClassW(lpClassName: LPCWSTR, hInstance: HINSTANCE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClassInfoA(
        hInstance: HINSTANCE,
        lpClassName: LPCSTR,
        lpWndClass: LPWNDCLASSA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClassInfoW(
        hInstance: HINSTANCE,
        lpClassName: LPCWSTR,
        lpWndClass: LPWNDCLASSW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterClassExA(arg1: *const WNDCLASSEXA) -> ATOM;
}
unsafe extern "C" {
    pub fn RegisterClassExW(arg1: *const WNDCLASSEXW) -> ATOM;
}
unsafe extern "C" {
    pub fn GetClassInfoExA(hInstance: HINSTANCE, lpszClass: LPCSTR, lpwcx: LPWNDCLASSEXA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClassInfoExW(hInstance: HINSTANCE, lpszClass: LPCWSTR, lpwcx: LPWNDCLASSEXW) -> BOOL;
}
pub type PREGISTERCLASSNAMEW =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPCWSTR) -> BOOLEAN>;
unsafe extern "C" {
    pub fn CreateWindowExA(
        dwExStyle: DWORD,
        lpClassName: LPCSTR,
        lpWindowName: LPCSTR,
        dwStyle: DWORD,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        hWndParent: HWND,
        hMenu: HMENU,
        hInstance: HINSTANCE,
        lpParam: LPVOID,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn CreateWindowExW(
        dwExStyle: DWORD,
        lpClassName: LPCWSTR,
        lpWindowName: LPCWSTR,
        dwStyle: DWORD,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        hWndParent: HWND,
        hMenu: HMENU,
        hInstance: HINSTANCE,
        lpParam: LPVOID,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn IsWindow(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn IsMenu(hMenu: HMENU) -> BOOL;
}
unsafe extern "C" {
    pub fn IsChild(hWndParent: HWND, hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn DestroyWindow(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowWindow(hWnd: HWND, nCmdShow: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn AnimateWindow(hWnd: HWND, dwTime: DWORD, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn UpdateLayeredWindow(
        hWnd: HWND,
        hdcDst: HDC,
        pptDst: *mut POINT,
        psize: *mut SIZE,
        hdcSrc: HDC,
        pptSrc: *mut POINT,
        crKey: COLORREF,
        pblend: *mut BLENDFUNCTION,
        dwFlags: DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagUPDATELAYEREDWINDOWINFO {
    pub cbSize: DWORD,
    pub hdcDst: HDC,
    pub pptDst: *const POINT,
    pub psize: *const SIZE,
    pub hdcSrc: HDC,
    pub pptSrc: *const POINT,
    pub crKey: COLORREF,
    pub pblend: *const BLENDFUNCTION,
    pub dwFlags: DWORD,
    pub prcDirty: *const RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagUPDATELAYEREDWINDOWINFO"]
        [::std::mem::size_of::<tagUPDATELAYEREDWINDOWINFO>() - 80usize];
    ["Alignment of tagUPDATELAYEREDWINDOWINFO"]
        [::std::mem::align_of::<tagUPDATELAYEREDWINDOWINFO>() - 8usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::cbSize"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, cbSize) - 0usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::hdcDst"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, hdcDst) - 8usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::pptDst"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, pptDst) - 16usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::psize"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, psize) - 24usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::hdcSrc"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, hdcSrc) - 32usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::pptSrc"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, pptSrc) - 40usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::crKey"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, crKey) - 48usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::pblend"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, pblend) - 56usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::dwFlags"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, dwFlags) - 64usize];
    ["Offset of field: tagUPDATELAYEREDWINDOWINFO::prcDirty"]
        [::std::mem::offset_of!(tagUPDATELAYEREDWINDOWINFO, prcDirty) - 72usize];
};
pub type UPDATELAYEREDWINDOWINFO = tagUPDATELAYEREDWINDOWINFO;
pub type PUPDATELAYEREDWINDOWINFO = *mut tagUPDATELAYEREDWINDOWINFO;
unsafe extern "C" {
    pub fn UpdateLayeredWindowIndirect(
        hWnd: HWND,
        pULWInfo: *const UPDATELAYEREDWINDOWINFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLayeredWindowAttributes(
        hwnd: HWND,
        pcrKey: *mut COLORREF,
        pbAlpha: *mut BYTE,
        pdwFlags: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PrintWindow(hwnd: HWND, hdcBlt: HDC, nFlags: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetLayeredWindowAttributes(
        hwnd: HWND,
        crKey: COLORREF,
        bAlpha: BYTE,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowWindowAsync(hWnd: HWND, nCmdShow: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn FlashWindow(hWnd: HWND, bInvert: BOOL) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct FLASHWINFO {
    pub cbSize: UINT,
    pub hwnd: HWND,
    pub dwFlags: DWORD,
    pub uCount: UINT,
    pub dwTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of FLASHWINFO"][::std::mem::size_of::<FLASHWINFO>() - 32usize];
    ["Alignment of FLASHWINFO"][::std::mem::align_of::<FLASHWINFO>() - 8usize];
    ["Offset of field: FLASHWINFO::cbSize"][::std::mem::offset_of!(FLASHWINFO, cbSize) - 0usize];
    ["Offset of field: FLASHWINFO::hwnd"][::std::mem::offset_of!(FLASHWINFO, hwnd) - 8usize];
    ["Offset of field: FLASHWINFO::dwFlags"][::std::mem::offset_of!(FLASHWINFO, dwFlags) - 16usize];
    ["Offset of field: FLASHWINFO::uCount"][::std::mem::offset_of!(FLASHWINFO, uCount) - 20usize];
    ["Offset of field: FLASHWINFO::dwTimeout"]
        [::std::mem::offset_of!(FLASHWINFO, dwTimeout) - 24usize];
};
pub type PFLASHWINFO = *mut FLASHWINFO;
unsafe extern "C" {
    pub fn FlashWindowEx(pfwi: PFLASHWINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowOwnedPopups(hWnd: HWND, fShow: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenIcon(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseWindow(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn MoveWindow(
        hWnd: HWND,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        bRepaint: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowPos(
        hWnd: HWND,
        hWndInsertAfter: HWND,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        uFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowPlacement(hWnd: HWND, lpwndpl: *mut WINDOWPLACEMENT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowPlacement(hWnd: HWND, lpwndpl: *const WINDOWPLACEMENT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowDisplayAffinity(hWnd: HWND, pdwAffinity: *mut DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowDisplayAffinity(hWnd: HWND, dwAffinity: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn BeginDeferWindowPos(nNumWindows: ::std::os::raw::c_int) -> HDWP;
}
unsafe extern "C" {
    pub fn DeferWindowPos(
        hWinPosInfo: HDWP,
        hWnd: HWND,
        hWndInsertAfter: HWND,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        uFlags: UINT,
    ) -> HDWP;
}
unsafe extern "C" {
    pub fn EndDeferWindowPos(hWinPosInfo: HDWP) -> BOOL;
}
unsafe extern "C" {
    pub fn IsWindowVisible(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn IsIconic(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn AnyPopup() -> BOOL;
}
unsafe extern "C" {
    pub fn BringWindowToTop(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn IsZoomed(hWnd: HWND) -> BOOL;
}
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct DLGTEMPLATE {
    pub style: DWORD,
    pub dwExtendedStyle: DWORD,
    pub cdit: WORD,
    pub x: ::std::os::raw::c_short,
    pub y: ::std::os::raw::c_short,
    pub cx: ::std::os::raw::c_short,
    pub cy: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DLGTEMPLATE"][::std::mem::size_of::<DLGTEMPLATE>() - 18usize];
    ["Alignment of DLGTEMPLATE"][::std::mem::align_of::<DLGTEMPLATE>() - 2usize];
    ["Offset of field: DLGTEMPLATE::style"][::std::mem::offset_of!(DLGTEMPLATE, style) - 0usize];
    ["Offset of field: DLGTEMPLATE::dwExtendedStyle"]
        [::std::mem::offset_of!(DLGTEMPLATE, dwExtendedStyle) - 4usize];
    ["Offset of field: DLGTEMPLATE::cdit"][::std::mem::offset_of!(DLGTEMPLATE, cdit) - 8usize];
    ["Offset of field: DLGTEMPLATE::x"][::std::mem::offset_of!(DLGTEMPLATE, x) - 10usize];
    ["Offset of field: DLGTEMPLATE::y"][::std::mem::offset_of!(DLGTEMPLATE, y) - 12usize];
    ["Offset of field: DLGTEMPLATE::cx"][::std::mem::offset_of!(DLGTEMPLATE, cx) - 14usize];
    ["Offset of field: DLGTEMPLATE::cy"][::std::mem::offset_of!(DLGTEMPLATE, cy) - 16usize];
};
pub type LPDLGTEMPLATEA = *mut DLGTEMPLATE;
pub type LPDLGTEMPLATEW = *mut DLGTEMPLATE;
pub type LPDLGTEMPLATE = LPDLGTEMPLATEA;
pub type LPCDLGTEMPLATEA = *const DLGTEMPLATE;
pub type LPCDLGTEMPLATEW = *const DLGTEMPLATE;
pub type LPCDLGTEMPLATE = LPCDLGTEMPLATEA;
#[repr(C, packed(2))]
#[derive(Debug, Copy, Clone)]
pub struct DLGITEMTEMPLATE {
    pub style: DWORD,
    pub dwExtendedStyle: DWORD,
    pub x: ::std::os::raw::c_short,
    pub y: ::std::os::raw::c_short,
    pub cx: ::std::os::raw::c_short,
    pub cy: ::std::os::raw::c_short,
    pub id: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DLGITEMTEMPLATE"][::std::mem::size_of::<DLGITEMTEMPLATE>() - 18usize];
    ["Alignment of DLGITEMTEMPLATE"][::std::mem::align_of::<DLGITEMTEMPLATE>() - 2usize];
    ["Offset of field: DLGITEMTEMPLATE::style"]
        [::std::mem::offset_of!(DLGITEMTEMPLATE, style) - 0usize];
    ["Offset of field: DLGITEMTEMPLATE::dwExtendedStyle"]
        [::std::mem::offset_of!(DLGITEMTEMPLATE, dwExtendedStyle) - 4usize];
    ["Offset of field: DLGITEMTEMPLATE::x"][::std::mem::offset_of!(DLGITEMTEMPLATE, x) - 8usize];
    ["Offset of field: DLGITEMTEMPLATE::y"][::std::mem::offset_of!(DLGITEMTEMPLATE, y) - 10usize];
    ["Offset of field: DLGITEMTEMPLATE::cx"][::std::mem::offset_of!(DLGITEMTEMPLATE, cx) - 12usize];
    ["Offset of field: DLGITEMTEMPLATE::cy"][::std::mem::offset_of!(DLGITEMTEMPLATE, cy) - 14usize];
    ["Offset of field: DLGITEMTEMPLATE::id"][::std::mem::offset_of!(DLGITEMTEMPLATE, id) - 16usize];
};
pub type PDLGITEMTEMPLATEA = *mut DLGITEMTEMPLATE;
pub type PDLGITEMTEMPLATEW = *mut DLGITEMTEMPLATE;
pub type PDLGITEMTEMPLATE = PDLGITEMTEMPLATEA;
pub type LPDLGITEMTEMPLATEA = *mut DLGITEMTEMPLATE;
pub type LPDLGITEMTEMPLATEW = *mut DLGITEMTEMPLATE;
pub type LPDLGITEMTEMPLATE = LPDLGITEMTEMPLATEA;
unsafe extern "C" {
    pub fn CreateDialogParamA(
        hInstance: HINSTANCE,
        lpTemplateName: LPCSTR,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn CreateDialogParamW(
        hInstance: HINSTANCE,
        lpTemplateName: LPCWSTR,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn CreateDialogIndirectParamA(
        hInstance: HINSTANCE,
        lpTemplate: LPCDLGTEMPLATEA,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn CreateDialogIndirectParamW(
        hInstance: HINSTANCE,
        lpTemplate: LPCDLGTEMPLATEW,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn DialogBoxParamA(
        hInstance: HINSTANCE,
        lpTemplateName: LPCSTR,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> INT_PTR;
}
unsafe extern "C" {
    pub fn DialogBoxParamW(
        hInstance: HINSTANCE,
        lpTemplateName: LPCWSTR,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> INT_PTR;
}
unsafe extern "C" {
    pub fn DialogBoxIndirectParamA(
        hInstance: HINSTANCE,
        hDialogTemplate: LPCDLGTEMPLATEA,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> INT_PTR;
}
unsafe extern "C" {
    pub fn DialogBoxIndirectParamW(
        hInstance: HINSTANCE,
        hDialogTemplate: LPCDLGTEMPLATEW,
        hWndParent: HWND,
        lpDialogFunc: DLGPROC,
        dwInitParam: LPARAM,
    ) -> INT_PTR;
}
unsafe extern "C" {
    pub fn EndDialog(hDlg: HWND, nResult: INT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDlgItem(hDlg: HWND, nIDDlgItem: ::std::os::raw::c_int) -> HWND;
}
unsafe extern "C" {
    pub fn SetDlgItemInt(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        uValue: UINT,
        bSigned: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDlgItemInt(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        lpTranslated: *mut BOOL,
        bSigned: BOOL,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn SetDlgItemTextA(hDlg: HWND, nIDDlgItem: ::std::os::raw::c_int, lpString: LPCSTR)
        -> BOOL;
}
unsafe extern "C" {
    pub fn SetDlgItemTextW(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        lpString: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDlgItemTextA(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        lpString: LPSTR,
        cchMax: ::std::os::raw::c_int,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetDlgItemTextW(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        lpString: LPWSTR,
        cchMax: ::std::os::raw::c_int,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn CheckDlgButton(hDlg: HWND, nIDButton: ::std::os::raw::c_int, uCheck: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckRadioButton(
        hDlg: HWND,
        nIDFirstButton: ::std::os::raw::c_int,
        nIDLastButton: ::std::os::raw::c_int,
        nIDCheckButton: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsDlgButtonChecked(hDlg: HWND, nIDButton: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn SendDlgItemMessageA(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn SendDlgItemMessageW(
        hDlg: HWND,
        nIDDlgItem: ::std::os::raw::c_int,
        Msg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn GetNextDlgGroupItem(hDlg: HWND, hCtl: HWND, bPrevious: BOOL) -> HWND;
}
unsafe extern "C" {
    pub fn GetNextDlgTabItem(hDlg: HWND, hCtl: HWND, bPrevious: BOOL) -> HWND;
}
unsafe extern "C" {
    pub fn GetDlgCtrlID(hWnd: HWND) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDialogBaseUnits() -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn DefDlgProcA(hDlg: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn DefDlgProcW(hDlg: HWND, Msg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
pub const DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS_DCDC_DEFAULT: DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS = 0;
pub const DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS_DCDC_DISABLE_FONT_UPDATE:
    DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS = 1;
pub const DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS_DCDC_DISABLE_RELAYOUT:
    DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS = 2;
pub type DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn SetDialogControlDpiChangeBehavior(
        hWnd: HWND,
        mask: DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS,
        values: DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDialogControlDpiChangeBehavior(hWnd: HWND) -> DIALOG_CONTROL_DPI_CHANGE_BEHAVIORS;
}
pub const DIALOG_DPI_CHANGE_BEHAVIORS_DDC_DEFAULT: DIALOG_DPI_CHANGE_BEHAVIORS = 0;
pub const DIALOG_DPI_CHANGE_BEHAVIORS_DDC_DISABLE_ALL: DIALOG_DPI_CHANGE_BEHAVIORS = 1;
pub const DIALOG_DPI_CHANGE_BEHAVIORS_DDC_DISABLE_RESIZE: DIALOG_DPI_CHANGE_BEHAVIORS = 2;
pub const DIALOG_DPI_CHANGE_BEHAVIORS_DDC_DISABLE_CONTROL_RELAYOUT: DIALOG_DPI_CHANGE_BEHAVIORS = 4;
pub type DIALOG_DPI_CHANGE_BEHAVIORS = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn SetDialogDpiChangeBehavior(
        hDlg: HWND,
        mask: DIALOG_DPI_CHANGE_BEHAVIORS,
        values: DIALOG_DPI_CHANGE_BEHAVIORS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDialogDpiChangeBehavior(hDlg: HWND) -> DIALOG_DPI_CHANGE_BEHAVIORS;
}
unsafe extern "C" {
    pub fn CallMsgFilterA(lpMsg: LPMSG, nCode: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn CallMsgFilterW(lpMsg: LPMSG, nCode: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenClipboard(hWndNewOwner: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseClipboard() -> BOOL;
}
unsafe extern "C" {
    pub fn GetClipboardSequenceNumber() -> DWORD;
}
unsafe extern "C" {
    pub fn GetClipboardOwner() -> HWND;
}
unsafe extern "C" {
    pub fn SetClipboardViewer(hWndNewViewer: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn GetClipboardViewer() -> HWND;
}
unsafe extern "C" {
    pub fn ChangeClipboardChain(hWndRemove: HWND, hWndNewNext: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn SetClipboardData(uFormat: UINT, hMem: HANDLE) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetClipboardData(uFormat: UINT) -> HANDLE;
}
unsafe extern "C" {
    pub fn RegisterClipboardFormatA(lpszFormat: LPCSTR) -> UINT;
}
unsafe extern "C" {
    pub fn RegisterClipboardFormatW(lpszFormat: LPCWSTR) -> UINT;
}
unsafe extern "C" {
    pub fn CountClipboardFormats() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumClipboardFormats(format: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetClipboardFormatNameA(
        format: UINT,
        lpszFormatName: LPSTR,
        cchMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetClipboardFormatNameW(
        format: UINT,
        lpszFormatName: LPWSTR,
        cchMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EmptyClipboard() -> BOOL;
}
unsafe extern "C" {
    pub fn IsClipboardFormatAvailable(format: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPriorityClipboardFormat(
        paFormatPriorityList: *mut UINT,
        cFormats: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetOpenClipboardWindow() -> HWND;
}
unsafe extern "C" {
    pub fn AddClipboardFormatListener(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveClipboardFormatListener(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUpdatedClipboardFormats(
        lpuiFormats: PUINT,
        cFormats: UINT,
        pcFormatsOut: PUINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CharToOemA(pSrc: LPCSTR, pDst: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn CharToOemW(pSrc: LPCWSTR, pDst: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn OemToCharA(pSrc: LPCSTR, pDst: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn OemToCharW(pSrc: LPCSTR, pDst: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn CharToOemBuffA(lpszSrc: LPCSTR, lpszDst: LPSTR, cchDstLength: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CharToOemBuffW(lpszSrc: LPCWSTR, lpszDst: LPSTR, cchDstLength: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn OemToCharBuffA(lpszSrc: LPCSTR, lpszDst: LPSTR, cchDstLength: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn OemToCharBuffW(lpszSrc: LPCSTR, lpszDst: LPWSTR, cchDstLength: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CharUpperA(lpsz: LPSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn CharUpperW(lpsz: LPWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn CharUpperBuffA(lpsz: LPSTR, cchLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CharUpperBuffW(lpsz: LPWSTR, cchLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CharLowerA(lpsz: LPSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn CharLowerW(lpsz: LPWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn CharLowerBuffA(lpsz: LPSTR, cchLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CharLowerBuffW(lpsz: LPWSTR, cchLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CharNextA(lpsz: LPCSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn CharNextW(lpsz: LPCWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn CharPrevA(lpszStart: LPCSTR, lpszCurrent: LPCSTR) -> LPSTR;
}
unsafe extern "C" {
    pub fn CharPrevW(lpszStart: LPCWSTR, lpszCurrent: LPCWSTR) -> LPWSTR;
}
unsafe extern "C" {
    pub fn CharNextExA(CodePage: WORD, lpCurrentChar: LPCSTR, dwFlags: DWORD) -> LPSTR;
}
unsafe extern "C" {
    pub fn CharPrevExA(
        CodePage: WORD,
        lpStart: LPCSTR,
        lpCurrentChar: LPCSTR,
        dwFlags: DWORD,
    ) -> LPSTR;
}
unsafe extern "C" {
    pub fn IsCharAlphaA(ch: CHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharAlphaW(ch: WCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharAlphaNumericA(ch: CHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharAlphaNumericW(ch: WCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharUpperA(ch: CHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharUpperW(ch: WCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharLowerA(ch: CHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsCharLowerW(ch: WCHAR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFocus(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn GetActiveWindow() -> HWND;
}
unsafe extern "C" {
    pub fn GetFocus() -> HWND;
}
unsafe extern "C" {
    pub fn GetKBCodePage() -> UINT;
}
unsafe extern "C" {
    pub fn GetKeyState(nVirtKey: ::std::os::raw::c_int) -> SHORT;
}
unsafe extern "C" {
    pub fn GetAsyncKeyState(vKey: ::std::os::raw::c_int) -> SHORT;
}
unsafe extern "C" {
    pub fn GetKeyboardState(lpKeyState: PBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetKeyboardState(lpKeyState: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetKeyNameTextA(
        lParam: LONG,
        lpString: LPSTR,
        cchSize: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetKeyNameTextW(
        lParam: LONG,
        lpString: LPWSTR,
        cchSize: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetKeyboardType(nTypeFlag: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ToAscii(
        uVirtKey: UINT,
        uScanCode: UINT,
        lpKeyState: *const BYTE,
        lpChar: LPWORD,
        uFlags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ToAsciiEx(
        uVirtKey: UINT,
        uScanCode: UINT,
        lpKeyState: *const BYTE,
        lpChar: LPWORD,
        uFlags: UINT,
        dwhkl: HKL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ToUnicode(
        wVirtKey: UINT,
        wScanCode: UINT,
        lpKeyState: *const BYTE,
        pwszBuff: LPWSTR,
        cchBuff: ::std::os::raw::c_int,
        wFlags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn OemKeyScan(wOemChar: WORD) -> DWORD;
}
unsafe extern "C" {
    pub fn VkKeyScanA(ch: CHAR) -> SHORT;
}
unsafe extern "C" {
    pub fn VkKeyScanW(ch: WCHAR) -> SHORT;
}
unsafe extern "C" {
    pub fn VkKeyScanExA(ch: CHAR, dwhkl: HKL) -> SHORT;
}
unsafe extern "C" {
    pub fn VkKeyScanExW(ch: WCHAR, dwhkl: HKL) -> SHORT;
}
unsafe extern "C" {
    pub fn keybd_event(bVk: BYTE, bScan: BYTE, dwFlags: DWORD, dwExtraInfo: ULONG_PTR);
}
unsafe extern "C" {
    pub fn mouse_event(dwFlags: DWORD, dx: DWORD, dy: DWORD, dwData: DWORD, dwExtraInfo: ULONG_PTR);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMOUSEINPUT {
    pub dx: LONG,
    pub dy: LONG,
    pub mouseData: DWORD,
    pub dwFlags: DWORD,
    pub time: DWORD,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMOUSEINPUT"][::std::mem::size_of::<tagMOUSEINPUT>() - 32usize];
    ["Alignment of tagMOUSEINPUT"][::std::mem::align_of::<tagMOUSEINPUT>() - 8usize];
    ["Offset of field: tagMOUSEINPUT::dx"][::std::mem::offset_of!(tagMOUSEINPUT, dx) - 0usize];
    ["Offset of field: tagMOUSEINPUT::dy"][::std::mem::offset_of!(tagMOUSEINPUT, dy) - 4usize];
    ["Offset of field: tagMOUSEINPUT::mouseData"]
        [::std::mem::offset_of!(tagMOUSEINPUT, mouseData) - 8usize];
    ["Offset of field: tagMOUSEINPUT::dwFlags"]
        [::std::mem::offset_of!(tagMOUSEINPUT, dwFlags) - 12usize];
    ["Offset of field: tagMOUSEINPUT::time"][::std::mem::offset_of!(tagMOUSEINPUT, time) - 16usize];
    ["Offset of field: tagMOUSEINPUT::dwExtraInfo"]
        [::std::mem::offset_of!(tagMOUSEINPUT, dwExtraInfo) - 24usize];
};
pub type MOUSEINPUT = tagMOUSEINPUT;
pub type PMOUSEINPUT = *mut tagMOUSEINPUT;
pub type LPMOUSEINPUT = *mut tagMOUSEINPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagKEYBDINPUT {
    pub wVk: WORD,
    pub wScan: WORD,
    pub dwFlags: DWORD,
    pub time: DWORD,
    pub dwExtraInfo: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagKEYBDINPUT"][::std::mem::size_of::<tagKEYBDINPUT>() - 24usize];
    ["Alignment of tagKEYBDINPUT"][::std::mem::align_of::<tagKEYBDINPUT>() - 8usize];
    ["Offset of field: tagKEYBDINPUT::wVk"][::std::mem::offset_of!(tagKEYBDINPUT, wVk) - 0usize];
    ["Offset of field: tagKEYBDINPUT::wScan"]
        [::std::mem::offset_of!(tagKEYBDINPUT, wScan) - 2usize];
    ["Offset of field: tagKEYBDINPUT::dwFlags"]
        [::std::mem::offset_of!(tagKEYBDINPUT, dwFlags) - 4usize];
    ["Offset of field: tagKEYBDINPUT::time"][::std::mem::offset_of!(tagKEYBDINPUT, time) - 8usize];
    ["Offset of field: tagKEYBDINPUT::dwExtraInfo"]
        [::std::mem::offset_of!(tagKEYBDINPUT, dwExtraInfo) - 16usize];
};
pub type KEYBDINPUT = tagKEYBDINPUT;
pub type PKEYBDINPUT = *mut tagKEYBDINPUT;
pub type LPKEYBDINPUT = *mut tagKEYBDINPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHARDWAREINPUT {
    pub uMsg: DWORD,
    pub wParamL: WORD,
    pub wParamH: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHARDWAREINPUT"][::std::mem::size_of::<tagHARDWAREINPUT>() - 8usize];
    ["Alignment of tagHARDWAREINPUT"][::std::mem::align_of::<tagHARDWAREINPUT>() - 4usize];
    ["Offset of field: tagHARDWAREINPUT::uMsg"]
        [::std::mem::offset_of!(tagHARDWAREINPUT, uMsg) - 0usize];
    ["Offset of field: tagHARDWAREINPUT::wParamL"]
        [::std::mem::offset_of!(tagHARDWAREINPUT, wParamL) - 4usize];
    ["Offset of field: tagHARDWAREINPUT::wParamH"]
        [::std::mem::offset_of!(tagHARDWAREINPUT, wParamH) - 6usize];
};
pub type HARDWAREINPUT = tagHARDWAREINPUT;
pub type PHARDWAREINPUT = *mut tagHARDWAREINPUT;
pub type LPHARDWAREINPUT = *mut tagHARDWAREINPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagINPUT {
    pub type_: DWORD,
    pub __bindgen_anon_1: tagINPUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagINPUT__bindgen_ty_1 {
    pub mi: MOUSEINPUT,
    pub ki: KEYBDINPUT,
    pub hi: HARDWAREINPUT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT__bindgen_ty_1"][::std::mem::size_of::<tagINPUT__bindgen_ty_1>() - 32usize];
    ["Alignment of tagINPUT__bindgen_ty_1"]
        [::std::mem::align_of::<tagINPUT__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagINPUT__bindgen_ty_1::mi"]
        [::std::mem::offset_of!(tagINPUT__bindgen_ty_1, mi) - 0usize];
    ["Offset of field: tagINPUT__bindgen_ty_1::ki"]
        [::std::mem::offset_of!(tagINPUT__bindgen_ty_1, ki) - 0usize];
    ["Offset of field: tagINPUT__bindgen_ty_1::hi"]
        [::std::mem::offset_of!(tagINPUT__bindgen_ty_1, hi) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT"][::std::mem::size_of::<tagINPUT>() - 40usize];
    ["Alignment of tagINPUT"][::std::mem::align_of::<tagINPUT>() - 8usize];
    ["Offset of field: tagINPUT::type_"][::std::mem::offset_of!(tagINPUT, type_) - 0usize];
};
pub type INPUT = tagINPUT;
pub type PINPUT = *mut tagINPUT;
pub type LPINPUT = *mut tagINPUT;
unsafe extern "C" {
    pub fn SendInput(cInputs: UINT, pInputs: LPINPUT, cbSize: ::std::os::raw::c_int) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HTOUCHINPUT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HTOUCHINPUT__"][::std::mem::size_of::<HTOUCHINPUT__>() - 4usize];
    ["Alignment of HTOUCHINPUT__"][::std::mem::align_of::<HTOUCHINPUT__>() - 4usize];
    ["Offset of field: HTOUCHINPUT__::unused"]
        [::std::mem::offset_of!(HTOUCHINPUT__, unused) - 0usize];
};
pub type HTOUCHINPUT = *mut HTOUCHINPUT__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTOUCHINPUT {
    pub x: LONG,
    pub y: LONG,
    pub hSource: HANDLE,
    pub dwID: DWORD,
    pub dwFlags: DWORD,
    pub dwMask: DWORD,
    pub dwTime: DWORD,
    pub dwExtraInfo: ULONG_PTR,
    pub cxContact: DWORD,
    pub cyContact: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTOUCHINPUT"][::std::mem::size_of::<tagTOUCHINPUT>() - 48usize];
    ["Alignment of tagTOUCHINPUT"][::std::mem::align_of::<tagTOUCHINPUT>() - 8usize];
    ["Offset of field: tagTOUCHINPUT::x"][::std::mem::offset_of!(tagTOUCHINPUT, x) - 0usize];
    ["Offset of field: tagTOUCHINPUT::y"][::std::mem::offset_of!(tagTOUCHINPUT, y) - 4usize];
    ["Offset of field: tagTOUCHINPUT::hSource"]
        [::std::mem::offset_of!(tagTOUCHINPUT, hSource) - 8usize];
    ["Offset of field: tagTOUCHINPUT::dwID"][::std::mem::offset_of!(tagTOUCHINPUT, dwID) - 16usize];
    ["Offset of field: tagTOUCHINPUT::dwFlags"]
        [::std::mem::offset_of!(tagTOUCHINPUT, dwFlags) - 20usize];
    ["Offset of field: tagTOUCHINPUT::dwMask"]
        [::std::mem::offset_of!(tagTOUCHINPUT, dwMask) - 24usize];
    ["Offset of field: tagTOUCHINPUT::dwTime"]
        [::std::mem::offset_of!(tagTOUCHINPUT, dwTime) - 28usize];
    ["Offset of field: tagTOUCHINPUT::dwExtraInfo"]
        [::std::mem::offset_of!(tagTOUCHINPUT, dwExtraInfo) - 32usize];
    ["Offset of field: tagTOUCHINPUT::cxContact"]
        [::std::mem::offset_of!(tagTOUCHINPUT, cxContact) - 40usize];
    ["Offset of field: tagTOUCHINPUT::cyContact"]
        [::std::mem::offset_of!(tagTOUCHINPUT, cyContact) - 44usize];
};
pub type TOUCHINPUT = tagTOUCHINPUT;
pub type PTOUCHINPUT = *mut tagTOUCHINPUT;
pub type PCTOUCHINPUT = *const TOUCHINPUT;
unsafe extern "C" {
    pub fn GetTouchInputInfo(
        hTouchInput: HTOUCHINPUT,
        cInputs: UINT,
        pInputs: PTOUCHINPUT,
        cbSize: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseTouchInputHandle(hTouchInput: HTOUCHINPUT) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterTouchWindow(hwnd: HWND, ulFlags: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterTouchWindow(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn IsTouchWindow(hwnd: HWND, pulFlags: PULONG) -> BOOL;
}
pub const tagPOINTER_INPUT_TYPE_PT_POINTER: tagPOINTER_INPUT_TYPE = 1;
pub const tagPOINTER_INPUT_TYPE_PT_TOUCH: tagPOINTER_INPUT_TYPE = 2;
pub const tagPOINTER_INPUT_TYPE_PT_PEN: tagPOINTER_INPUT_TYPE = 3;
pub const tagPOINTER_INPUT_TYPE_PT_MOUSE: tagPOINTER_INPUT_TYPE = 4;
pub const tagPOINTER_INPUT_TYPE_PT_TOUCHPAD: tagPOINTER_INPUT_TYPE = 5;
pub type tagPOINTER_INPUT_TYPE = ::std::os::raw::c_int;
pub type POINTER_INPUT_TYPE = DWORD;
pub type POINTER_FLAGS = UINT32;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_NONE: tagPOINTER_BUTTON_CHANGE_TYPE = 0;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FIRSTBUTTON_DOWN:
    tagPOINTER_BUTTON_CHANGE_TYPE = 1;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FIRSTBUTTON_UP:
    tagPOINTER_BUTTON_CHANGE_TYPE = 2;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_SECONDBUTTON_DOWN:
    tagPOINTER_BUTTON_CHANGE_TYPE = 3;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_SECONDBUTTON_UP:
    tagPOINTER_BUTTON_CHANGE_TYPE = 4;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_THIRDBUTTON_DOWN:
    tagPOINTER_BUTTON_CHANGE_TYPE = 5;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_THIRDBUTTON_UP:
    tagPOINTER_BUTTON_CHANGE_TYPE = 6;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FOURTHBUTTON_DOWN:
    tagPOINTER_BUTTON_CHANGE_TYPE = 7;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FOURTHBUTTON_UP:
    tagPOINTER_BUTTON_CHANGE_TYPE = 8;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FIFTHBUTTON_DOWN:
    tagPOINTER_BUTTON_CHANGE_TYPE = 9;
pub const tagPOINTER_BUTTON_CHANGE_TYPE_POINTER_CHANGE_FIFTHBUTTON_UP:
    tagPOINTER_BUTTON_CHANGE_TYPE = 10;
pub type tagPOINTER_BUTTON_CHANGE_TYPE = ::std::os::raw::c_int;
pub use self::tagPOINTER_BUTTON_CHANGE_TYPE as POINTER_BUTTON_CHANGE_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_INFO {
    pub pointerType: POINTER_INPUT_TYPE,
    pub pointerId: UINT32,
    pub frameId: UINT32,
    pub pointerFlags: POINTER_FLAGS,
    pub sourceDevice: HANDLE,
    pub hwndTarget: HWND,
    pub ptPixelLocation: POINT,
    pub ptHimetricLocation: POINT,
    pub ptPixelLocationRaw: POINT,
    pub ptHimetricLocationRaw: POINT,
    pub dwTime: DWORD,
    pub historyCount: UINT32,
    pub InputData: INT32,
    pub dwKeyStates: DWORD,
    pub PerformanceCount: UINT64,
    pub ButtonChangeType: POINTER_BUTTON_CHANGE_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_INFO"][::std::mem::size_of::<tagPOINTER_INFO>() - 96usize];
    ["Alignment of tagPOINTER_INFO"][::std::mem::align_of::<tagPOINTER_INFO>() - 8usize];
    ["Offset of field: tagPOINTER_INFO::pointerType"]
        [::std::mem::offset_of!(tagPOINTER_INFO, pointerType) - 0usize];
    ["Offset of field: tagPOINTER_INFO::pointerId"]
        [::std::mem::offset_of!(tagPOINTER_INFO, pointerId) - 4usize];
    ["Offset of field: tagPOINTER_INFO::frameId"]
        [::std::mem::offset_of!(tagPOINTER_INFO, frameId) - 8usize];
    ["Offset of field: tagPOINTER_INFO::pointerFlags"]
        [::std::mem::offset_of!(tagPOINTER_INFO, pointerFlags) - 12usize];
    ["Offset of field: tagPOINTER_INFO::sourceDevice"]
        [::std::mem::offset_of!(tagPOINTER_INFO, sourceDevice) - 16usize];
    ["Offset of field: tagPOINTER_INFO::hwndTarget"]
        [::std::mem::offset_of!(tagPOINTER_INFO, hwndTarget) - 24usize];
    ["Offset of field: tagPOINTER_INFO::ptPixelLocation"]
        [::std::mem::offset_of!(tagPOINTER_INFO, ptPixelLocation) - 32usize];
    ["Offset of field: tagPOINTER_INFO::ptHimetricLocation"]
        [::std::mem::offset_of!(tagPOINTER_INFO, ptHimetricLocation) - 40usize];
    ["Offset of field: tagPOINTER_INFO::ptPixelLocationRaw"]
        [::std::mem::offset_of!(tagPOINTER_INFO, ptPixelLocationRaw) - 48usize];
    ["Offset of field: tagPOINTER_INFO::ptHimetricLocationRaw"]
        [::std::mem::offset_of!(tagPOINTER_INFO, ptHimetricLocationRaw) - 56usize];
    ["Offset of field: tagPOINTER_INFO::dwTime"]
        [::std::mem::offset_of!(tagPOINTER_INFO, dwTime) - 64usize];
    ["Offset of field: tagPOINTER_INFO::historyCount"]
        [::std::mem::offset_of!(tagPOINTER_INFO, historyCount) - 68usize];
    ["Offset of field: tagPOINTER_INFO::InputData"]
        [::std::mem::offset_of!(tagPOINTER_INFO, InputData) - 72usize];
    ["Offset of field: tagPOINTER_INFO::dwKeyStates"]
        [::std::mem::offset_of!(tagPOINTER_INFO, dwKeyStates) - 76usize];
    ["Offset of field: tagPOINTER_INFO::PerformanceCount"]
        [::std::mem::offset_of!(tagPOINTER_INFO, PerformanceCount) - 80usize];
    ["Offset of field: tagPOINTER_INFO::ButtonChangeType"]
        [::std::mem::offset_of!(tagPOINTER_INFO, ButtonChangeType) - 88usize];
};
pub type POINTER_INFO = tagPOINTER_INFO;
pub type TOUCH_FLAGS = UINT32;
pub type TOUCH_MASK = UINT32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_TOUCH_INFO {
    pub pointerInfo: POINTER_INFO,
    pub touchFlags: TOUCH_FLAGS,
    pub touchMask: TOUCH_MASK,
    pub rcContact: RECT,
    pub rcContactRaw: RECT,
    pub orientation: UINT32,
    pub pressure: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_TOUCH_INFO"][::std::mem::size_of::<tagPOINTER_TOUCH_INFO>() - 144usize];
    ["Alignment of tagPOINTER_TOUCH_INFO"]
        [::std::mem::align_of::<tagPOINTER_TOUCH_INFO>() - 8usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::pointerInfo"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, pointerInfo) - 0usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::touchFlags"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, touchFlags) - 96usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::touchMask"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, touchMask) - 100usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::rcContact"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, rcContact) - 104usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::rcContactRaw"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, rcContactRaw) - 120usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::orientation"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, orientation) - 136usize];
    ["Offset of field: tagPOINTER_TOUCH_INFO::pressure"]
        [::std::mem::offset_of!(tagPOINTER_TOUCH_INFO, pressure) - 140usize];
};
pub type POINTER_TOUCH_INFO = tagPOINTER_TOUCH_INFO;
pub type PEN_FLAGS = UINT32;
pub type PEN_MASK = UINT32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_PEN_INFO {
    pub pointerInfo: POINTER_INFO,
    pub penFlags: PEN_FLAGS,
    pub penMask: PEN_MASK,
    pub pressure: UINT32,
    pub rotation: UINT32,
    pub tiltX: INT32,
    pub tiltY: INT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_PEN_INFO"][::std::mem::size_of::<tagPOINTER_PEN_INFO>() - 120usize];
    ["Alignment of tagPOINTER_PEN_INFO"][::std::mem::align_of::<tagPOINTER_PEN_INFO>() - 8usize];
    ["Offset of field: tagPOINTER_PEN_INFO::pointerInfo"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, pointerInfo) - 0usize];
    ["Offset of field: tagPOINTER_PEN_INFO::penFlags"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, penFlags) - 96usize];
    ["Offset of field: tagPOINTER_PEN_INFO::penMask"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, penMask) - 100usize];
    ["Offset of field: tagPOINTER_PEN_INFO::pressure"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, pressure) - 104usize];
    ["Offset of field: tagPOINTER_PEN_INFO::rotation"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, rotation) - 108usize];
    ["Offset of field: tagPOINTER_PEN_INFO::tiltX"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, tiltX) - 112usize];
    ["Offset of field: tagPOINTER_PEN_INFO::tiltY"]
        [::std::mem::offset_of!(tagPOINTER_PEN_INFO, tiltY) - 116usize];
};
pub type POINTER_PEN_INFO = tagPOINTER_PEN_INFO;
pub const POINTER_FEEDBACK_MODE_POINTER_FEEDBACK_DEFAULT: POINTER_FEEDBACK_MODE = 1;
pub const POINTER_FEEDBACK_MODE_POINTER_FEEDBACK_INDIRECT: POINTER_FEEDBACK_MODE = 2;
pub const POINTER_FEEDBACK_MODE_POINTER_FEEDBACK_NONE: POINTER_FEEDBACK_MODE = 3;
pub type POINTER_FEEDBACK_MODE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn InitializeTouchInjection(maxCount: UINT32, dwMode: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn InjectTouchInput(count: UINT32, contacts: *const POINTER_TOUCH_INFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagUSAGE_PROPERTIES {
    pub level: USHORT,
    pub page: USHORT,
    pub usage: USHORT,
    pub logicalMinimum: INT32,
    pub logicalMaximum: INT32,
    pub unit: USHORT,
    pub exponent: USHORT,
    pub count: BYTE,
    pub physicalMinimum: INT32,
    pub physicalMaximum: INT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagUSAGE_PROPERTIES"][::std::mem::size_of::<tagUSAGE_PROPERTIES>() - 32usize];
    ["Alignment of tagUSAGE_PROPERTIES"][::std::mem::align_of::<tagUSAGE_PROPERTIES>() - 4usize];
    ["Offset of field: tagUSAGE_PROPERTIES::level"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, level) - 0usize];
    ["Offset of field: tagUSAGE_PROPERTIES::page"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, page) - 2usize];
    ["Offset of field: tagUSAGE_PROPERTIES::usage"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, usage) - 4usize];
    ["Offset of field: tagUSAGE_PROPERTIES::logicalMinimum"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, logicalMinimum) - 8usize];
    ["Offset of field: tagUSAGE_PROPERTIES::logicalMaximum"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, logicalMaximum) - 12usize];
    ["Offset of field: tagUSAGE_PROPERTIES::unit"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, unit) - 16usize];
    ["Offset of field: tagUSAGE_PROPERTIES::exponent"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, exponent) - 18usize];
    ["Offset of field: tagUSAGE_PROPERTIES::count"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, count) - 20usize];
    ["Offset of field: tagUSAGE_PROPERTIES::physicalMinimum"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, physicalMinimum) - 24usize];
    ["Offset of field: tagUSAGE_PROPERTIES::physicalMaximum"]
        [::std::mem::offset_of!(tagUSAGE_PROPERTIES, physicalMaximum) - 28usize];
};
pub type USAGE_PROPERTIES = tagUSAGE_PROPERTIES;
pub type PUSAGE_PROPERTIES = *mut tagUSAGE_PROPERTIES;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagPOINTER_TYPE_INFO {
    pub type_: POINTER_INPUT_TYPE,
    pub __bindgen_anon_1: tagPOINTER_TYPE_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagPOINTER_TYPE_INFO__bindgen_ty_1 {
    pub touchInfo: POINTER_TOUCH_INFO,
    pub penInfo: POINTER_PEN_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_TYPE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<tagPOINTER_TYPE_INFO__bindgen_ty_1>() - 144usize];
    ["Alignment of tagPOINTER_TYPE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<tagPOINTER_TYPE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagPOINTER_TYPE_INFO__bindgen_ty_1::touchInfo"]
        [::std::mem::offset_of!(tagPOINTER_TYPE_INFO__bindgen_ty_1, touchInfo) - 0usize];
    ["Offset of field: tagPOINTER_TYPE_INFO__bindgen_ty_1::penInfo"]
        [::std::mem::offset_of!(tagPOINTER_TYPE_INFO__bindgen_ty_1, penInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_TYPE_INFO"][::std::mem::size_of::<tagPOINTER_TYPE_INFO>() - 152usize];
    ["Alignment of tagPOINTER_TYPE_INFO"][::std::mem::align_of::<tagPOINTER_TYPE_INFO>() - 8usize];
    ["Offset of field: tagPOINTER_TYPE_INFO::type_"]
        [::std::mem::offset_of!(tagPOINTER_TYPE_INFO, type_) - 0usize];
};
pub type POINTER_TYPE_INFO = tagPOINTER_TYPE_INFO;
pub type PPOINTER_TYPE_INFO = *mut tagPOINTER_TYPE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagINPUT_INJECTION_VALUE {
    pub page: USHORT,
    pub usage: USHORT,
    pub value: INT32,
    pub index: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT_INJECTION_VALUE"]
        [::std::mem::size_of::<tagINPUT_INJECTION_VALUE>() - 12usize];
    ["Alignment of tagINPUT_INJECTION_VALUE"]
        [::std::mem::align_of::<tagINPUT_INJECTION_VALUE>() - 4usize];
    ["Offset of field: tagINPUT_INJECTION_VALUE::page"]
        [::std::mem::offset_of!(tagINPUT_INJECTION_VALUE, page) - 0usize];
    ["Offset of field: tagINPUT_INJECTION_VALUE::usage"]
        [::std::mem::offset_of!(tagINPUT_INJECTION_VALUE, usage) - 2usize];
    ["Offset of field: tagINPUT_INJECTION_VALUE::value"]
        [::std::mem::offset_of!(tagINPUT_INJECTION_VALUE, value) - 4usize];
    ["Offset of field: tagINPUT_INJECTION_VALUE::index"]
        [::std::mem::offset_of!(tagINPUT_INJECTION_VALUE, index) - 8usize];
};
pub type INPUT_INJECTION_VALUE = tagINPUT_INJECTION_VALUE;
pub type PINPUT_INJECTION_VALUE = *mut tagINPUT_INJECTION_VALUE;
unsafe extern "C" {
    pub fn GetPointerType(pointerId: UINT32, pointerType: *mut POINTER_INPUT_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerCursorId(pointerId: UINT32, cursorId: *mut UINT32) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerInfo(pointerId: UINT32, pointerInfo: *mut POINTER_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        pointerInfo: *mut POINTER_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFrameInfo(
        pointerId: UINT32,
        pointerCount: *mut UINT32,
        pointerInfo: *mut POINTER_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFrameInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        pointerCount: *mut UINT32,
        pointerInfo: *mut POINTER_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerTouchInfo(pointerId: UINT32, touchInfo: *mut POINTER_TOUCH_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerTouchInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        touchInfo: *mut POINTER_TOUCH_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFrameTouchInfo(
        pointerId: UINT32,
        pointerCount: *mut UINT32,
        touchInfo: *mut POINTER_TOUCH_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFrameTouchInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        pointerCount: *mut UINT32,
        touchInfo: *mut POINTER_TOUCH_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerPenInfo(pointerId: UINT32, penInfo: *mut POINTER_PEN_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerPenInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        penInfo: *mut POINTER_PEN_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFramePenInfo(
        pointerId: UINT32,
        pointerCount: *mut UINT32,
        penInfo: *mut POINTER_PEN_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerFramePenInfoHistory(
        pointerId: UINT32,
        entriesCount: *mut UINT32,
        pointerCount: *mut UINT32,
        penInfo: *mut POINTER_PEN_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SkipPointerFrameMessages(pointerId: UINT32) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterPointerInputTarget(hwnd: HWND, pointerType: POINTER_INPUT_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterPointerInputTarget(hwnd: HWND, pointerType: POINTER_INPUT_TYPE) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterPointerInputTargetEx(
        hwnd: HWND,
        pointerType: POINTER_INPUT_TYPE,
        fObserve: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnregisterPointerInputTargetEx(hwnd: HWND, pointerType: POINTER_INPUT_TYPE) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HSYNTHETICPOINTERDEVICE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HSYNTHETICPOINTERDEVICE__"]
        [::std::mem::size_of::<HSYNTHETICPOINTERDEVICE__>() - 4usize];
    ["Alignment of HSYNTHETICPOINTERDEVICE__"]
        [::std::mem::align_of::<HSYNTHETICPOINTERDEVICE__>() - 4usize];
    ["Offset of field: HSYNTHETICPOINTERDEVICE__::unused"]
        [::std::mem::offset_of!(HSYNTHETICPOINTERDEVICE__, unused) - 0usize];
};
pub type HSYNTHETICPOINTERDEVICE = *mut HSYNTHETICPOINTERDEVICE__;
unsafe extern "C" {
    pub fn CreateSyntheticPointerDevice(
        pointerType: POINTER_INPUT_TYPE,
        maxCount: ULONG,
        mode: POINTER_FEEDBACK_MODE,
    ) -> HSYNTHETICPOINTERDEVICE;
}
unsafe extern "C" {
    pub fn InjectSyntheticPointerInput(
        device: HSYNTHETICPOINTERDEVICE,
        pointerInfo: *const POINTER_TYPE_INFO,
        count: UINT32,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DestroySyntheticPointerDevice(device: HSYNTHETICPOINTERDEVICE);
}
unsafe extern "C" {
    pub fn EnableMouseInPointer(fEnable: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn IsMouseInPointerEnabled() -> BOOL;
}
unsafe extern "C" {
    pub fn EnableMouseInPointerForThread() -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterTouchHitTestingWindow(hwnd: HWND, value: ULONG) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION {
    pub score: UINT16,
    pub adjustedPoint: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION"]
        [::std::mem::size_of::<tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION>() - 12usize];
    ["Alignment of tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION"]
        [::std::mem::align_of::<tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION>() - 4usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION::score"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION, score) - 0usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION::adjustedPoint"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION, adjustedPoint) - 4usize];
};
pub type TOUCH_HIT_TESTING_PROXIMITY_EVALUATION = tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION;
pub type PTOUCH_HIT_TESTING_PROXIMITY_EVALUATION = *mut tagTOUCH_HIT_TESTING_PROXIMITY_EVALUATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTOUCH_HIT_TESTING_INPUT {
    pub pointerId: UINT32,
    pub point: POINT,
    pub boundingBox: RECT,
    pub nonOccludedBoundingBox: RECT,
    pub orientation: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTOUCH_HIT_TESTING_INPUT"]
        [::std::mem::size_of::<tagTOUCH_HIT_TESTING_INPUT>() - 48usize];
    ["Alignment of tagTOUCH_HIT_TESTING_INPUT"]
        [::std::mem::align_of::<tagTOUCH_HIT_TESTING_INPUT>() - 4usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_INPUT::pointerId"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_INPUT, pointerId) - 0usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_INPUT::point"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_INPUT, point) - 4usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_INPUT::boundingBox"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_INPUT, boundingBox) - 12usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_INPUT::nonOccludedBoundingBox"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_INPUT, nonOccludedBoundingBox) - 28usize];
    ["Offset of field: tagTOUCH_HIT_TESTING_INPUT::orientation"]
        [::std::mem::offset_of!(tagTOUCH_HIT_TESTING_INPUT, orientation) - 44usize];
};
pub type TOUCH_HIT_TESTING_INPUT = tagTOUCH_HIT_TESTING_INPUT;
pub type PTOUCH_HIT_TESTING_INPUT = *mut tagTOUCH_HIT_TESTING_INPUT;
unsafe extern "C" {
    pub fn EvaluateProximityToRect(
        controlBoundingBox: *const RECT,
        pHitTestingInput: *const TOUCH_HIT_TESTING_INPUT,
        pProximityEval: *mut TOUCH_HIT_TESTING_PROXIMITY_EVALUATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EvaluateProximityToPolygon(
        numVertices: UINT32,
        controlPolygon: *const POINT,
        pHitTestingInput: *const TOUCH_HIT_TESTING_INPUT,
        pProximityEval: *mut TOUCH_HIT_TESTING_PROXIMITY_EVALUATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PackTouchHitTestingProximityEvaluation(
        pHitTestingInput: *const TOUCH_HIT_TESTING_INPUT,
        pProximityEval: *const TOUCH_HIT_TESTING_PROXIMITY_EVALUATION,
    ) -> LRESULT;
}
pub const tagFEEDBACK_TYPE_FEEDBACK_TOUCH_CONTACTVISUALIZATION: tagFEEDBACK_TYPE = 1;
pub const tagFEEDBACK_TYPE_FEEDBACK_PEN_BARRELVISUALIZATION: tagFEEDBACK_TYPE = 2;
pub const tagFEEDBACK_TYPE_FEEDBACK_PEN_TAP: tagFEEDBACK_TYPE = 3;
pub const tagFEEDBACK_TYPE_FEEDBACK_PEN_DOUBLETAP: tagFEEDBACK_TYPE = 4;
pub const tagFEEDBACK_TYPE_FEEDBACK_PEN_PRESSANDHOLD: tagFEEDBACK_TYPE = 5;
pub const tagFEEDBACK_TYPE_FEEDBACK_PEN_RIGHTTAP: tagFEEDBACK_TYPE = 6;
pub const tagFEEDBACK_TYPE_FEEDBACK_TOUCH_TAP: tagFEEDBACK_TYPE = 7;
pub const tagFEEDBACK_TYPE_FEEDBACK_TOUCH_DOUBLETAP: tagFEEDBACK_TYPE = 8;
pub const tagFEEDBACK_TYPE_FEEDBACK_TOUCH_PRESSANDHOLD: tagFEEDBACK_TYPE = 9;
pub const tagFEEDBACK_TYPE_FEEDBACK_TOUCH_RIGHTTAP: tagFEEDBACK_TYPE = 10;
pub const tagFEEDBACK_TYPE_FEEDBACK_GESTURE_PRESSANDTAP: tagFEEDBACK_TYPE = 11;
pub const tagFEEDBACK_TYPE_FEEDBACK_MAX: tagFEEDBACK_TYPE = -1;
pub type tagFEEDBACK_TYPE = ::std::os::raw::c_int;
pub use self::tagFEEDBACK_TYPE as FEEDBACK_TYPE;
unsafe extern "C" {
    pub fn GetWindowFeedbackSetting(
        hwnd: HWND,
        feedback: FEEDBACK_TYPE,
        dwFlags: DWORD,
        pSize: *mut UINT32,
        config: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowFeedbackSetting(
        hwnd: HWND,
        feedback: FEEDBACK_TYPE,
        dwFlags: DWORD,
        size: UINT32,
        configuration: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagINPUT_TRANSFORM {
    pub __bindgen_anon_1: tagINPUT_TRANSFORM__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagINPUT_TRANSFORM__bindgen_ty_1 {
    pub __bindgen_anon_1: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1,
    pub m: [[f32; 4usize]; 4usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1 {
    pub _11: f32,
    pub _12: f32,
    pub _13: f32,
    pub _14: f32,
    pub _21: f32,
    pub _22: f32,
    pub _23: f32,
    pub _24: f32,
    pub _31: f32,
    pub _32: f32,
    pub _33: f32,
    pub _34: f32,
    pub _41: f32,
    pub _42: f32,
    pub _43: f32,
    pub _44: f32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1>() - 64usize];
    ["Alignment of tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_11"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _11) - 0usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_12"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _12) - 4usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_13"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _13) - 8usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_14"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _14) - 12usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_21"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _21) - 16usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_22"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _22) - 20usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_23"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _23) - 24usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_24"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _24) - 28usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_31"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _31) - 32usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_32"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _32) - 36usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_33"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _33) - 40usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_34"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _34) - 44usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_41"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _41) - 48usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_42"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _42) - 52usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_43"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _43) - 56usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1::_44"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1__bindgen_ty_1, _44) - 60usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT_TRANSFORM__bindgen_ty_1"]
        [::std::mem::size_of::<tagINPUT_TRANSFORM__bindgen_ty_1>() - 64usize];
    ["Alignment of tagINPUT_TRANSFORM__bindgen_ty_1"]
        [::std::mem::align_of::<tagINPUT_TRANSFORM__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagINPUT_TRANSFORM__bindgen_ty_1::m"]
        [::std::mem::offset_of!(tagINPUT_TRANSFORM__bindgen_ty_1, m) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT_TRANSFORM"][::std::mem::size_of::<tagINPUT_TRANSFORM>() - 64usize];
    ["Alignment of tagINPUT_TRANSFORM"][::std::mem::align_of::<tagINPUT_TRANSFORM>() - 4usize];
};
pub type INPUT_TRANSFORM = tagINPUT_TRANSFORM;
unsafe extern "C" {
    pub fn GetPointerInputTransform(
        pointerId: UINT32,
        historyCount: UINT32,
        inputTransform: *mut INPUT_TRANSFORM,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagLASTINPUTINFO {
    pub cbSize: UINT,
    pub dwTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagLASTINPUTINFO"][::std::mem::size_of::<tagLASTINPUTINFO>() - 8usize];
    ["Alignment of tagLASTINPUTINFO"][::std::mem::align_of::<tagLASTINPUTINFO>() - 4usize];
    ["Offset of field: tagLASTINPUTINFO::cbSize"]
        [::std::mem::offset_of!(tagLASTINPUTINFO, cbSize) - 0usize];
    ["Offset of field: tagLASTINPUTINFO::dwTime"]
        [::std::mem::offset_of!(tagLASTINPUTINFO, dwTime) - 4usize];
};
pub type LASTINPUTINFO = tagLASTINPUTINFO;
pub type PLASTINPUTINFO = *mut tagLASTINPUTINFO;
unsafe extern "C" {
    pub fn GetLastInputInfo(plii: PLASTINPUTINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn MapVirtualKeyA(uCode: UINT, uMapType: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn MapVirtualKeyW(uCode: UINT, uMapType: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn MapVirtualKeyExA(uCode: UINT, uMapType: UINT, dwhkl: HKL) -> UINT;
}
unsafe extern "C" {
    pub fn MapVirtualKeyExW(uCode: UINT, uMapType: UINT, dwhkl: HKL) -> UINT;
}
unsafe extern "C" {
    pub fn GetInputState() -> BOOL;
}
unsafe extern "C" {
    pub fn GetQueueStatus(flags: UINT) -> DWORD;
}
unsafe extern "C" {
    pub fn GetCapture() -> HWND;
}
unsafe extern "C" {
    pub fn SetCapture(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn ReleaseCapture() -> BOOL;
}
unsafe extern "C" {
    pub fn MsgWaitForMultipleObjects(
        nCount: DWORD,
        pHandles: *const HANDLE,
        fWaitAll: BOOL,
        dwMilliseconds: DWORD,
        dwWakeMask: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn MsgWaitForMultipleObjectsEx(
        nCount: DWORD,
        pHandles: *const HANDLE,
        dwMilliseconds: DWORD,
        dwWakeMask: DWORD,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetTimer(
        hWnd: HWND,
        nIDEvent: UINT_PTR,
        uElapse: UINT,
        lpTimerFunc: TIMERPROC,
    ) -> UINT_PTR;
}
unsafe extern "C" {
    pub fn SetCoalescableTimer(
        hWnd: HWND,
        nIDEvent: UINT_PTR,
        uElapse: UINT,
        lpTimerFunc: TIMERPROC,
        uToleranceDelay: ULONG,
    ) -> UINT_PTR;
}
unsafe extern "C" {
    pub fn KillTimer(hWnd: HWND, uIDEvent: UINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsWindowUnicode(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn EnableWindow(hWnd: HWND, bEnable: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn IsWindowEnabled(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn LoadAcceleratorsA(hInstance: HINSTANCE, lpTableName: LPCSTR) -> HACCEL;
}
unsafe extern "C" {
    pub fn LoadAcceleratorsW(hInstance: HINSTANCE, lpTableName: LPCWSTR) -> HACCEL;
}
unsafe extern "C" {
    pub fn CreateAcceleratorTableA(paccel: LPACCEL, cAccel: ::std::os::raw::c_int) -> HACCEL;
}
unsafe extern "C" {
    pub fn CreateAcceleratorTableW(paccel: LPACCEL, cAccel: ::std::os::raw::c_int) -> HACCEL;
}
unsafe extern "C" {
    pub fn DestroyAcceleratorTable(hAccel: HACCEL) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyAcceleratorTableA(
        hAccelSrc: HACCEL,
        lpAccelDst: LPACCEL,
        cAccelEntries: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CopyAcceleratorTableW(
        hAccelSrc: HACCEL,
        lpAccelDst: LPACCEL,
        cAccelEntries: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn TranslateAcceleratorA(
        hWnd: HWND,
        hAccTable: HACCEL,
        lpMsg: LPMSG,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn TranslateAcceleratorW(
        hWnd: HWND,
        hAccTable: HACCEL,
        lpMsg: LPMSG,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetSystemMetrics(nIndex: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetSystemMetricsForDpi(
        nIndex: ::std::os::raw::c_int,
        dpi: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LoadMenuA(hInstance: HINSTANCE, lpMenuName: LPCSTR) -> HMENU;
}
unsafe extern "C" {
    pub fn LoadMenuW(hInstance: HINSTANCE, lpMenuName: LPCWSTR) -> HMENU;
}
unsafe extern "C" {
    pub fn LoadMenuIndirectA(lpMenuTemplate: *const MENUTEMPLATEA) -> HMENU;
}
unsafe extern "C" {
    pub fn LoadMenuIndirectW(lpMenuTemplate: *const MENUTEMPLATEW) -> HMENU;
}
unsafe extern "C" {
    pub fn GetMenu(hWnd: HWND) -> HMENU;
}
unsafe extern "C" {
    pub fn SetMenu(hWnd: HWND, hMenu: HMENU) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeMenuA(
        hMenu: HMENU,
        cmd: UINT,
        lpszNewItem: LPCSTR,
        cmdInsert: UINT,
        flags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeMenuW(
        hMenu: HMENU,
        cmd: UINT,
        lpszNewItem: LPCWSTR,
        cmdInsert: UINT,
        flags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn HiliteMenuItem(hWnd: HWND, hMenu: HMENU, uIDHiliteItem: UINT, uHilite: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuStringA(
        hMenu: HMENU,
        uIDItem: UINT,
        lpString: LPSTR,
        cchMax: ::std::os::raw::c_int,
        flags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetMenuStringW(
        hMenu: HMENU,
        uIDItem: UINT,
        lpString: LPWSTR,
        cchMax: ::std::os::raw::c_int,
        flags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetMenuState(hMenu: HMENU, uId: UINT, uFlags: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn DrawMenuBar(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemMenu(hWnd: HWND, bRevert: BOOL) -> HMENU;
}
unsafe extern "C" {
    pub fn CreateMenu() -> HMENU;
}
unsafe extern "C" {
    pub fn CreatePopupMenu() -> HMENU;
}
unsafe extern "C" {
    pub fn DestroyMenu(hMenu: HMENU) -> BOOL;
}
unsafe extern "C" {
    pub fn CheckMenuItem(hMenu: HMENU, uIDCheckItem: UINT, uCheck: UINT) -> DWORD;
}
unsafe extern "C" {
    pub fn EnableMenuItem(hMenu: HMENU, uIDEnableItem: UINT, uEnable: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSubMenu(hMenu: HMENU, nPos: ::std::os::raw::c_int) -> HMENU;
}
unsafe extern "C" {
    pub fn GetMenuItemID(hMenu: HMENU, nPos: ::std::os::raw::c_int) -> UINT;
}
unsafe extern "C" {
    pub fn GetMenuItemCount(hMenu: HMENU) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn InsertMenuA(
        hMenu: HMENU,
        uPosition: UINT,
        uFlags: UINT,
        uIDNewItem: UINT_PTR,
        lpNewItem: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InsertMenuW(
        hMenu: HMENU,
        uPosition: UINT,
        uFlags: UINT,
        uIDNewItem: UINT_PTR,
        lpNewItem: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AppendMenuA(hMenu: HMENU, uFlags: UINT, uIDNewItem: UINT_PTR, lpNewItem: LPCSTR)
        -> BOOL;
}
unsafe extern "C" {
    pub fn AppendMenuW(
        hMenu: HMENU,
        uFlags: UINT,
        uIDNewItem: UINT_PTR,
        lpNewItem: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ModifyMenuA(
        hMnu: HMENU,
        uPosition: UINT,
        uFlags: UINT,
        uIDNewItem: UINT_PTR,
        lpNewItem: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ModifyMenuW(
        hMnu: HMENU,
        uPosition: UINT,
        uFlags: UINT,
        uIDNewItem: UINT_PTR,
        lpNewItem: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RemoveMenu(hMenu: HMENU, uPosition: UINT, uFlags: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteMenu(hMenu: HMENU, uPosition: UINT, uFlags: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMenuItemBitmaps(
        hMenu: HMENU,
        uPosition: UINT,
        uFlags: UINT,
        hBitmapUnchecked: HBITMAP,
        hBitmapChecked: HBITMAP,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuCheckMarkDimensions() -> LONG;
}
unsafe extern "C" {
    pub fn TrackPopupMenu(
        hMenu: HMENU,
        uFlags: UINT,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        nReserved: ::std::os::raw::c_int,
        hWnd: HWND,
        prcRect: *const RECT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTPMPARAMS {
    pub cbSize: UINT,
    pub rcExclude: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTPMPARAMS"][::std::mem::size_of::<tagTPMPARAMS>() - 20usize];
    ["Alignment of tagTPMPARAMS"][::std::mem::align_of::<tagTPMPARAMS>() - 4usize];
    ["Offset of field: tagTPMPARAMS::cbSize"]
        [::std::mem::offset_of!(tagTPMPARAMS, cbSize) - 0usize];
    ["Offset of field: tagTPMPARAMS::rcExclude"]
        [::std::mem::offset_of!(tagTPMPARAMS, rcExclude) - 4usize];
};
pub type TPMPARAMS = tagTPMPARAMS;
pub type LPTPMPARAMS = *mut TPMPARAMS;
unsafe extern "C" {
    pub fn TrackPopupMenuEx(
        hMenu: HMENU,
        uFlags: UINT,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        hwnd: HWND,
        lptpm: LPTPMPARAMS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CalculatePopupWindowPosition(
        anchorPoint: *const POINT,
        windowSize: *const SIZE,
        flags: UINT,
        excludeRect: *mut RECT,
        popupWindowPosition: *mut RECT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMENUINFO {
    pub cbSize: DWORD,
    pub fMask: DWORD,
    pub dwStyle: DWORD,
    pub cyMax: UINT,
    pub hbrBack: HBRUSH,
    pub dwContextHelpID: DWORD,
    pub dwMenuData: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMENUINFO"][::std::mem::size_of::<tagMENUINFO>() - 40usize];
    ["Alignment of tagMENUINFO"][::std::mem::align_of::<tagMENUINFO>() - 8usize];
    ["Offset of field: tagMENUINFO::cbSize"][::std::mem::offset_of!(tagMENUINFO, cbSize) - 0usize];
    ["Offset of field: tagMENUINFO::fMask"][::std::mem::offset_of!(tagMENUINFO, fMask) - 4usize];
    ["Offset of field: tagMENUINFO::dwStyle"]
        [::std::mem::offset_of!(tagMENUINFO, dwStyle) - 8usize];
    ["Offset of field: tagMENUINFO::cyMax"][::std::mem::offset_of!(tagMENUINFO, cyMax) - 12usize];
    ["Offset of field: tagMENUINFO::hbrBack"]
        [::std::mem::offset_of!(tagMENUINFO, hbrBack) - 16usize];
    ["Offset of field: tagMENUINFO::dwContextHelpID"]
        [::std::mem::offset_of!(tagMENUINFO, dwContextHelpID) - 24usize];
    ["Offset of field: tagMENUINFO::dwMenuData"]
        [::std::mem::offset_of!(tagMENUINFO, dwMenuData) - 32usize];
};
pub type MENUINFO = tagMENUINFO;
pub type LPMENUINFO = *mut tagMENUINFO;
pub type LPCMENUINFO = *const MENUINFO;
unsafe extern "C" {
    pub fn GetMenuInfo(arg1: HMENU, arg2: LPMENUINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMenuInfo(arg1: HMENU, arg2: LPCMENUINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn EndMenu() -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMENUGETOBJECTINFO {
    pub dwFlags: DWORD,
    pub uPos: UINT,
    pub hmenu: HMENU,
    pub riid: PVOID,
    pub pvObj: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMENUGETOBJECTINFO"][::std::mem::size_of::<tagMENUGETOBJECTINFO>() - 32usize];
    ["Alignment of tagMENUGETOBJECTINFO"][::std::mem::align_of::<tagMENUGETOBJECTINFO>() - 8usize];
    ["Offset of field: tagMENUGETOBJECTINFO::dwFlags"]
        [::std::mem::offset_of!(tagMENUGETOBJECTINFO, dwFlags) - 0usize];
    ["Offset of field: tagMENUGETOBJECTINFO::uPos"]
        [::std::mem::offset_of!(tagMENUGETOBJECTINFO, uPos) - 4usize];
    ["Offset of field: tagMENUGETOBJECTINFO::hmenu"]
        [::std::mem::offset_of!(tagMENUGETOBJECTINFO, hmenu) - 8usize];
    ["Offset of field: tagMENUGETOBJECTINFO::riid"]
        [::std::mem::offset_of!(tagMENUGETOBJECTINFO, riid) - 16usize];
    ["Offset of field: tagMENUGETOBJECTINFO::pvObj"]
        [::std::mem::offset_of!(tagMENUGETOBJECTINFO, pvObj) - 24usize];
};
pub type MENUGETOBJECTINFO = tagMENUGETOBJECTINFO;
pub type PMENUGETOBJECTINFO = *mut tagMENUGETOBJECTINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMENUITEMINFOA {
    pub cbSize: UINT,
    pub fMask: UINT,
    pub fType: UINT,
    pub fState: UINT,
    pub wID: UINT,
    pub hSubMenu: HMENU,
    pub hbmpChecked: HBITMAP,
    pub hbmpUnchecked: HBITMAP,
    pub dwItemData: ULONG_PTR,
    pub dwTypeData: LPSTR,
    pub cch: UINT,
    pub hbmpItem: HBITMAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMENUITEMINFOA"][::std::mem::size_of::<tagMENUITEMINFOA>() - 80usize];
    ["Alignment of tagMENUITEMINFOA"][::std::mem::align_of::<tagMENUITEMINFOA>() - 8usize];
    ["Offset of field: tagMENUITEMINFOA::cbSize"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, cbSize) - 0usize];
    ["Offset of field: tagMENUITEMINFOA::fMask"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, fMask) - 4usize];
    ["Offset of field: tagMENUITEMINFOA::fType"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, fType) - 8usize];
    ["Offset of field: tagMENUITEMINFOA::fState"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, fState) - 12usize];
    ["Offset of field: tagMENUITEMINFOA::wID"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, wID) - 16usize];
    ["Offset of field: tagMENUITEMINFOA::hSubMenu"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, hSubMenu) - 24usize];
    ["Offset of field: tagMENUITEMINFOA::hbmpChecked"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, hbmpChecked) - 32usize];
    ["Offset of field: tagMENUITEMINFOA::hbmpUnchecked"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, hbmpUnchecked) - 40usize];
    ["Offset of field: tagMENUITEMINFOA::dwItemData"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, dwItemData) - 48usize];
    ["Offset of field: tagMENUITEMINFOA::dwTypeData"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, dwTypeData) - 56usize];
    ["Offset of field: tagMENUITEMINFOA::cch"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, cch) - 64usize];
    ["Offset of field: tagMENUITEMINFOA::hbmpItem"]
        [::std::mem::offset_of!(tagMENUITEMINFOA, hbmpItem) - 72usize];
};
pub type MENUITEMINFOA = tagMENUITEMINFOA;
pub type LPMENUITEMINFOA = *mut tagMENUITEMINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMENUITEMINFOW {
    pub cbSize: UINT,
    pub fMask: UINT,
    pub fType: UINT,
    pub fState: UINT,
    pub wID: UINT,
    pub hSubMenu: HMENU,
    pub hbmpChecked: HBITMAP,
    pub hbmpUnchecked: HBITMAP,
    pub dwItemData: ULONG_PTR,
    pub dwTypeData: LPWSTR,
    pub cch: UINT,
    pub hbmpItem: HBITMAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMENUITEMINFOW"][::std::mem::size_of::<tagMENUITEMINFOW>() - 80usize];
    ["Alignment of tagMENUITEMINFOW"][::std::mem::align_of::<tagMENUITEMINFOW>() - 8usize];
    ["Offset of field: tagMENUITEMINFOW::cbSize"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, cbSize) - 0usize];
    ["Offset of field: tagMENUITEMINFOW::fMask"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, fMask) - 4usize];
    ["Offset of field: tagMENUITEMINFOW::fType"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, fType) - 8usize];
    ["Offset of field: tagMENUITEMINFOW::fState"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, fState) - 12usize];
    ["Offset of field: tagMENUITEMINFOW::wID"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, wID) - 16usize];
    ["Offset of field: tagMENUITEMINFOW::hSubMenu"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, hSubMenu) - 24usize];
    ["Offset of field: tagMENUITEMINFOW::hbmpChecked"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, hbmpChecked) - 32usize];
    ["Offset of field: tagMENUITEMINFOW::hbmpUnchecked"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, hbmpUnchecked) - 40usize];
    ["Offset of field: tagMENUITEMINFOW::dwItemData"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, dwItemData) - 48usize];
    ["Offset of field: tagMENUITEMINFOW::dwTypeData"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, dwTypeData) - 56usize];
    ["Offset of field: tagMENUITEMINFOW::cch"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, cch) - 64usize];
    ["Offset of field: tagMENUITEMINFOW::hbmpItem"]
        [::std::mem::offset_of!(tagMENUITEMINFOW, hbmpItem) - 72usize];
};
pub type MENUITEMINFOW = tagMENUITEMINFOW;
pub type LPMENUITEMINFOW = *mut tagMENUITEMINFOW;
pub type MENUITEMINFO = MENUITEMINFOA;
pub type LPMENUITEMINFO = LPMENUITEMINFOA;
pub type LPCMENUITEMINFOA = *const MENUITEMINFOA;
pub type LPCMENUITEMINFOW = *const MENUITEMINFOW;
pub type LPCMENUITEMINFO = LPCMENUITEMINFOA;
unsafe extern "C" {
    pub fn InsertMenuItemA(
        hmenu: HMENU,
        item: UINT,
        fByPosition: BOOL,
        lpmi: LPCMENUITEMINFOA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InsertMenuItemW(
        hmenu: HMENU,
        item: UINT,
        fByPosition: BOOL,
        lpmi: LPCMENUITEMINFOW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuItemInfoA(
        hmenu: HMENU,
        item: UINT,
        fByPosition: BOOL,
        lpmii: LPMENUITEMINFOA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuItemInfoW(
        hmenu: HMENU,
        item: UINT,
        fByPosition: BOOL,
        lpmii: LPMENUITEMINFOW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMenuItemInfoA(
        hmenu: HMENU,
        item: UINT,
        fByPositon: BOOL,
        lpmii: LPCMENUITEMINFOA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetMenuItemInfoW(
        hmenu: HMENU,
        item: UINT,
        fByPositon: BOOL,
        lpmii: LPCMENUITEMINFOW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuDefaultItem(hMenu: HMENU, fByPos: UINT, gmdiFlags: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn SetMenuDefaultItem(hMenu: HMENU, uItem: UINT, fByPos: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuItemRect(hWnd: HWND, hMenu: HMENU, uItem: UINT, lprcItem: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn MenuItemFromPoint(hWnd: HWND, hMenu: HMENU, ptScreen: POINT) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDROPSTRUCT {
    pub hwndSource: HWND,
    pub hwndSink: HWND,
    pub wFmt: DWORD,
    pub dwData: ULONG_PTR,
    pub ptDrop: POINT,
    pub dwControlData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDROPSTRUCT"][::std::mem::size_of::<tagDROPSTRUCT>() - 48usize];
    ["Alignment of tagDROPSTRUCT"][::std::mem::align_of::<tagDROPSTRUCT>() - 8usize];
    ["Offset of field: tagDROPSTRUCT::hwndSource"]
        [::std::mem::offset_of!(tagDROPSTRUCT, hwndSource) - 0usize];
    ["Offset of field: tagDROPSTRUCT::hwndSink"]
        [::std::mem::offset_of!(tagDROPSTRUCT, hwndSink) - 8usize];
    ["Offset of field: tagDROPSTRUCT::wFmt"][::std::mem::offset_of!(tagDROPSTRUCT, wFmt) - 16usize];
    ["Offset of field: tagDROPSTRUCT::dwData"]
        [::std::mem::offset_of!(tagDROPSTRUCT, dwData) - 24usize];
    ["Offset of field: tagDROPSTRUCT::ptDrop"]
        [::std::mem::offset_of!(tagDROPSTRUCT, ptDrop) - 32usize];
    ["Offset of field: tagDROPSTRUCT::dwControlData"]
        [::std::mem::offset_of!(tagDROPSTRUCT, dwControlData) - 40usize];
};
pub type DROPSTRUCT = tagDROPSTRUCT;
pub type PDROPSTRUCT = *mut tagDROPSTRUCT;
pub type LPDROPSTRUCT = *mut tagDROPSTRUCT;
unsafe extern "C" {
    pub fn DragObject(
        hwndParent: HWND,
        hwndFrom: HWND,
        fmt: UINT,
        data: ULONG_PTR,
        hcur: HCURSOR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DragDetect(hwnd: HWND, pt: POINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawIcon(
        hDC: HDC,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        hIcon: HICON,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDRAWTEXTPARAMS {
    pub cbSize: UINT,
    pub iTabLength: ::std::os::raw::c_int,
    pub iLeftMargin: ::std::os::raw::c_int,
    pub iRightMargin: ::std::os::raw::c_int,
    pub uiLengthDrawn: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDRAWTEXTPARAMS"][::std::mem::size_of::<tagDRAWTEXTPARAMS>() - 20usize];
    ["Alignment of tagDRAWTEXTPARAMS"][::std::mem::align_of::<tagDRAWTEXTPARAMS>() - 4usize];
    ["Offset of field: tagDRAWTEXTPARAMS::cbSize"]
        [::std::mem::offset_of!(tagDRAWTEXTPARAMS, cbSize) - 0usize];
    ["Offset of field: tagDRAWTEXTPARAMS::iTabLength"]
        [::std::mem::offset_of!(tagDRAWTEXTPARAMS, iTabLength) - 4usize];
    ["Offset of field: tagDRAWTEXTPARAMS::iLeftMargin"]
        [::std::mem::offset_of!(tagDRAWTEXTPARAMS, iLeftMargin) - 8usize];
    ["Offset of field: tagDRAWTEXTPARAMS::iRightMargin"]
        [::std::mem::offset_of!(tagDRAWTEXTPARAMS, iRightMargin) - 12usize];
    ["Offset of field: tagDRAWTEXTPARAMS::uiLengthDrawn"]
        [::std::mem::offset_of!(tagDRAWTEXTPARAMS, uiLengthDrawn) - 16usize];
};
pub type DRAWTEXTPARAMS = tagDRAWTEXTPARAMS;
pub type LPDRAWTEXTPARAMS = *mut tagDRAWTEXTPARAMS;
unsafe extern "C" {
    pub fn DrawTextA(
        hdc: HDC,
        lpchText: LPCSTR,
        cchText: ::std::os::raw::c_int,
        lprc: LPRECT,
        format: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DrawTextW(
        hdc: HDC,
        lpchText: LPCWSTR,
        cchText: ::std::os::raw::c_int,
        lprc: LPRECT,
        format: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DrawTextExA(
        hdc: HDC,
        lpchText: LPSTR,
        cchText: ::std::os::raw::c_int,
        lprc: LPRECT,
        format: UINT,
        lpdtp: LPDRAWTEXTPARAMS,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DrawTextExW(
        hdc: HDC,
        lpchText: LPWSTR,
        cchText: ::std::os::raw::c_int,
        lprc: LPRECT,
        format: UINT,
        lpdtp: LPDRAWTEXTPARAMS,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GrayStringA(
        hDC: HDC,
        hBrush: HBRUSH,
        lpOutputFunc: GRAYSTRINGPROC,
        lpData: LPARAM,
        nCount: ::std::os::raw::c_int,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GrayStringW(
        hDC: HDC,
        hBrush: HBRUSH,
        lpOutputFunc: GRAYSTRINGPROC,
        lpData: LPARAM,
        nCount: ::std::os::raw::c_int,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawStateA(
        hdc: HDC,
        hbrFore: HBRUSH,
        qfnCallBack: DRAWSTATEPROC,
        lData: LPARAM,
        wData: WPARAM,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        uFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawStateW(
        hdc: HDC,
        hbrFore: HBRUSH,
        qfnCallBack: DRAWSTATEPROC,
        lData: LPARAM,
        wData: WPARAM,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        uFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn TabbedTextOutA(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpString: LPCSTR,
        chCount: ::std::os::raw::c_int,
        nTabPositions: ::std::os::raw::c_int,
        lpnTabStopPositions: *const INT,
        nTabOrigin: ::std::os::raw::c_int,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn TabbedTextOutW(
        hdc: HDC,
        x: ::std::os::raw::c_int,
        y: ::std::os::raw::c_int,
        lpString: LPCWSTR,
        chCount: ::std::os::raw::c_int,
        nTabPositions: ::std::os::raw::c_int,
        lpnTabStopPositions: *const INT,
        nTabOrigin: ::std::os::raw::c_int,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn GetTabbedTextExtentA(
        hdc: HDC,
        lpString: LPCSTR,
        chCount: ::std::os::raw::c_int,
        nTabPositions: ::std::os::raw::c_int,
        lpnTabStopPositions: *const INT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetTabbedTextExtentW(
        hdc: HDC,
        lpString: LPCWSTR,
        chCount: ::std::os::raw::c_int,
        nTabPositions: ::std::os::raw::c_int,
        lpnTabStopPositions: *const INT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn UpdateWindow(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn SetActiveWindow(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn GetForegroundWindow() -> HWND;
}
unsafe extern "C" {
    pub fn PaintDesktop(hdc: HDC) -> BOOL;
}
unsafe extern "C" {
    pub fn SwitchToThisWindow(hwnd: HWND, fUnknown: BOOL);
}
unsafe extern "C" {
    pub fn SetForegroundWindow(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn AllowSetForegroundWindow(dwProcessId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn LockSetForegroundWindow(uLockCode: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn WindowFromDC(hDC: HDC) -> HWND;
}
unsafe extern "C" {
    pub fn GetDC(hWnd: HWND) -> HDC;
}
unsafe extern "C" {
    pub fn GetDCEx(hWnd: HWND, hrgnClip: HRGN, flags: DWORD) -> HDC;
}
unsafe extern "C" {
    pub fn GetWindowDC(hWnd: HWND) -> HDC;
}
unsafe extern "C" {
    pub fn ReleaseDC(hWnd: HWND, hDC: HDC) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn BeginPaint(hWnd: HWND, lpPaint: LPPAINTSTRUCT) -> HDC;
}
unsafe extern "C" {
    pub fn EndPaint(hWnd: HWND, lpPaint: *const PAINTSTRUCT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUpdateRect(hWnd: HWND, lpRect: LPRECT, bErase: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUpdateRgn(hWnd: HWND, hRgn: HRGN, bErase: BOOL) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetWindowRgn(hWnd: HWND, hRgn: HRGN, bRedraw: BOOL) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetWindowRgn(hWnd: HWND, hRgn: HRGN) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetWindowRgnBox(hWnd: HWND, lprc: LPRECT) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ExcludeUpdateRgn(hDC: HDC, hWnd: HWND) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn InvalidateRect(hWnd: HWND, lpRect: *const RECT, bErase: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn ValidateRect(hWnd: HWND, lpRect: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn InvalidateRgn(hWnd: HWND, hRgn: HRGN, bErase: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn ValidateRgn(hWnd: HWND, hRgn: HRGN) -> BOOL;
}
unsafe extern "C" {
    pub fn RedrawWindow(hWnd: HWND, lprcUpdate: *const RECT, hrgnUpdate: HRGN, flags: UINT)
        -> BOOL;
}
unsafe extern "C" {
    pub fn LockWindowUpdate(hWndLock: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn ScrollWindow(
        hWnd: HWND,
        XAmount: ::std::os::raw::c_int,
        YAmount: ::std::os::raw::c_int,
        lpRect: *const RECT,
        lpClipRect: *const RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScrollDC(
        hDC: HDC,
        dx: ::std::os::raw::c_int,
        dy: ::std::os::raw::c_int,
        lprcScroll: *const RECT,
        lprcClip: *const RECT,
        hrgnUpdate: HRGN,
        lprcUpdate: LPRECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScrollWindowEx(
        hWnd: HWND,
        dx: ::std::os::raw::c_int,
        dy: ::std::os::raw::c_int,
        prcScroll: *const RECT,
        prcClip: *const RECT,
        hrgnUpdate: HRGN,
        prcUpdate: LPRECT,
        flags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetScrollPos(
        hWnd: HWND,
        nBar: ::std::os::raw::c_int,
        nPos: ::std::os::raw::c_int,
        bRedraw: BOOL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetScrollPos(hWnd: HWND, nBar: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetScrollRange(
        hWnd: HWND,
        nBar: ::std::os::raw::c_int,
        nMinPos: ::std::os::raw::c_int,
        nMaxPos: ::std::os::raw::c_int,
        bRedraw: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetScrollRange(
        hWnd: HWND,
        nBar: ::std::os::raw::c_int,
        lpMinPos: LPINT,
        lpMaxPos: LPINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowScrollBar(hWnd: HWND, wBar: ::std::os::raw::c_int, bShow: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn EnableScrollBar(hWnd: HWND, wSBflags: UINT, wArrows: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPropA(hWnd: HWND, lpString: LPCSTR, hData: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPropW(hWnd: HWND, lpString: LPCWSTR, hData: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPropA(hWnd: HWND, lpString: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn GetPropW(hWnd: HWND, lpString: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn RemovePropA(hWnd: HWND, lpString: LPCSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn RemovePropW(hWnd: HWND, lpString: LPCWSTR) -> HANDLE;
}
unsafe extern "C" {
    pub fn EnumPropsExA(
        hWnd: HWND,
        lpEnumFunc: PROPENUMPROCEXA,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumPropsExW(
        hWnd: HWND,
        lpEnumFunc: PROPENUMPROCEXW,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumPropsA(hWnd: HWND, lpEnumFunc: PROPENUMPROCA) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumPropsW(hWnd: HWND, lpEnumFunc: PROPENUMPROCW) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetWindowTextA(hWnd: HWND, lpString: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowTextW(hWnd: HWND, lpString: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowTextA(
        hWnd: HWND,
        lpString: LPSTR,
        nMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetWindowTextW(
        hWnd: HWND,
        lpString: LPWSTR,
        nMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetWindowTextLengthA(hWnd: HWND) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetWindowTextLengthW(hWnd: HWND) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetClientRect(hWnd: HWND, lpRect: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowRect(hWnd: HWND, lpRect: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn AdjustWindowRect(lpRect: LPRECT, dwStyle: DWORD, bMenu: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn AdjustWindowRectEx(
        lpRect: LPRECT,
        dwStyle: DWORD,
        bMenu: BOOL,
        dwExStyle: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AdjustWindowRectExForDpi(
        lpRect: LPRECT,
        dwStyle: DWORD,
        bMenu: BOOL,
        dwExStyle: DWORD,
        dpi: UINT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHELPINFO {
    pub cbSize: UINT,
    pub iContextType: ::std::os::raw::c_int,
    pub iCtrlId: ::std::os::raw::c_int,
    pub hItemHandle: HANDLE,
    pub dwContextId: DWORD_PTR,
    pub MousePos: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHELPINFO"][::std::mem::size_of::<tagHELPINFO>() - 40usize];
    ["Alignment of tagHELPINFO"][::std::mem::align_of::<tagHELPINFO>() - 8usize];
    ["Offset of field: tagHELPINFO::cbSize"][::std::mem::offset_of!(tagHELPINFO, cbSize) - 0usize];
    ["Offset of field: tagHELPINFO::iContextType"]
        [::std::mem::offset_of!(tagHELPINFO, iContextType) - 4usize];
    ["Offset of field: tagHELPINFO::iCtrlId"]
        [::std::mem::offset_of!(tagHELPINFO, iCtrlId) - 8usize];
    ["Offset of field: tagHELPINFO::hItemHandle"]
        [::std::mem::offset_of!(tagHELPINFO, hItemHandle) - 16usize];
    ["Offset of field: tagHELPINFO::dwContextId"]
        [::std::mem::offset_of!(tagHELPINFO, dwContextId) - 24usize];
    ["Offset of field: tagHELPINFO::MousePos"]
        [::std::mem::offset_of!(tagHELPINFO, MousePos) - 32usize];
};
pub type HELPINFO = tagHELPINFO;
pub type LPHELPINFO = *mut tagHELPINFO;
unsafe extern "C" {
    pub fn SetWindowContextHelpId(arg1: HWND, arg2: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowContextHelpId(arg1: HWND) -> DWORD;
}
unsafe extern "C" {
    pub fn SetMenuContextHelpId(arg1: HMENU, arg2: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMenuContextHelpId(arg1: HMENU) -> DWORD;
}
unsafe extern "C" {
    pub fn MessageBoxA(
        hWnd: HWND,
        lpText: LPCSTR,
        lpCaption: LPCSTR,
        uType: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MessageBoxW(
        hWnd: HWND,
        lpText: LPCWSTR,
        lpCaption: LPCWSTR,
        uType: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MessageBoxExA(
        hWnd: HWND,
        lpText: LPCSTR,
        lpCaption: LPCSTR,
        uType: UINT,
        wLanguageId: WORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MessageBoxExW(
        hWnd: HWND,
        lpText: LPCWSTR,
        lpCaption: LPCWSTR,
        uType: UINT,
        wLanguageId: WORD,
    ) -> ::std::os::raw::c_int;
}
pub type MSGBOXCALLBACK = ::std::option::Option<unsafe extern "C" fn(lpHelpInfo: LPHELPINFO)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMSGBOXPARAMSA {
    pub cbSize: UINT,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpszText: LPCSTR,
    pub lpszCaption: LPCSTR,
    pub dwStyle: DWORD,
    pub lpszIcon: LPCSTR,
    pub dwContextHelpId: DWORD_PTR,
    pub lpfnMsgBoxCallback: MSGBOXCALLBACK,
    pub dwLanguageId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMSGBOXPARAMSA"][::std::mem::size_of::<tagMSGBOXPARAMSA>() - 80usize];
    ["Alignment of tagMSGBOXPARAMSA"][::std::mem::align_of::<tagMSGBOXPARAMSA>() - 8usize];
    ["Offset of field: tagMSGBOXPARAMSA::cbSize"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, cbSize) - 0usize];
    ["Offset of field: tagMSGBOXPARAMSA::hwndOwner"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, hwndOwner) - 8usize];
    ["Offset of field: tagMSGBOXPARAMSA::hInstance"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, hInstance) - 16usize];
    ["Offset of field: tagMSGBOXPARAMSA::lpszText"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, lpszText) - 24usize];
    ["Offset of field: tagMSGBOXPARAMSA::lpszCaption"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, lpszCaption) - 32usize];
    ["Offset of field: tagMSGBOXPARAMSA::dwStyle"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, dwStyle) - 40usize];
    ["Offset of field: tagMSGBOXPARAMSA::lpszIcon"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, lpszIcon) - 48usize];
    ["Offset of field: tagMSGBOXPARAMSA::dwContextHelpId"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, dwContextHelpId) - 56usize];
    ["Offset of field: tagMSGBOXPARAMSA::lpfnMsgBoxCallback"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, lpfnMsgBoxCallback) - 64usize];
    ["Offset of field: tagMSGBOXPARAMSA::dwLanguageId"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSA, dwLanguageId) - 72usize];
};
pub type MSGBOXPARAMSA = tagMSGBOXPARAMSA;
pub type PMSGBOXPARAMSA = *mut tagMSGBOXPARAMSA;
pub type LPMSGBOXPARAMSA = *mut tagMSGBOXPARAMSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMSGBOXPARAMSW {
    pub cbSize: UINT,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpszText: LPCWSTR,
    pub lpszCaption: LPCWSTR,
    pub dwStyle: DWORD,
    pub lpszIcon: LPCWSTR,
    pub dwContextHelpId: DWORD_PTR,
    pub lpfnMsgBoxCallback: MSGBOXCALLBACK,
    pub dwLanguageId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMSGBOXPARAMSW"][::std::mem::size_of::<tagMSGBOXPARAMSW>() - 80usize];
    ["Alignment of tagMSGBOXPARAMSW"][::std::mem::align_of::<tagMSGBOXPARAMSW>() - 8usize];
    ["Offset of field: tagMSGBOXPARAMSW::cbSize"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, cbSize) - 0usize];
    ["Offset of field: tagMSGBOXPARAMSW::hwndOwner"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, hwndOwner) - 8usize];
    ["Offset of field: tagMSGBOXPARAMSW::hInstance"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, hInstance) - 16usize];
    ["Offset of field: tagMSGBOXPARAMSW::lpszText"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, lpszText) - 24usize];
    ["Offset of field: tagMSGBOXPARAMSW::lpszCaption"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, lpszCaption) - 32usize];
    ["Offset of field: tagMSGBOXPARAMSW::dwStyle"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, dwStyle) - 40usize];
    ["Offset of field: tagMSGBOXPARAMSW::lpszIcon"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, lpszIcon) - 48usize];
    ["Offset of field: tagMSGBOXPARAMSW::dwContextHelpId"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, dwContextHelpId) - 56usize];
    ["Offset of field: tagMSGBOXPARAMSW::lpfnMsgBoxCallback"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, lpfnMsgBoxCallback) - 64usize];
    ["Offset of field: tagMSGBOXPARAMSW::dwLanguageId"]
        [::std::mem::offset_of!(tagMSGBOXPARAMSW, dwLanguageId) - 72usize];
};
pub type MSGBOXPARAMSW = tagMSGBOXPARAMSW;
pub type PMSGBOXPARAMSW = *mut tagMSGBOXPARAMSW;
pub type LPMSGBOXPARAMSW = *mut tagMSGBOXPARAMSW;
pub type MSGBOXPARAMS = MSGBOXPARAMSA;
pub type PMSGBOXPARAMS = PMSGBOXPARAMSA;
pub type LPMSGBOXPARAMS = LPMSGBOXPARAMSA;
unsafe extern "C" {
    pub fn MessageBoxIndirectA(lpmbp: *const MSGBOXPARAMSA) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MessageBoxIndirectW(lpmbp: *const MSGBOXPARAMSW) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn MessageBeep(uType: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowCursor(bShow: BOOL) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetCursorPos(X: ::std::os::raw::c_int, Y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPhysicalCursorPos(X: ::std::os::raw::c_int, Y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCursor(hCursor: HCURSOR) -> HCURSOR;
}
unsafe extern "C" {
    pub fn GetCursorPos(lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPhysicalCursorPos(lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClipCursor(lpRect: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCursor() -> HCURSOR;
}
unsafe extern "C" {
    pub fn CreateCaret(
        hWnd: HWND,
        hBitmap: HBITMAP,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCaretBlinkTime() -> UINT;
}
unsafe extern "C" {
    pub fn SetCaretBlinkTime(uMSeconds: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DestroyCaret() -> BOOL;
}
unsafe extern "C" {
    pub fn HideCaret(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn ShowCaret(hWnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCaretPos(X: ::std::os::raw::c_int, Y: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCaretPos(lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn ClientToScreen(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn ScreenToClient(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn LogicalToPhysicalPoint(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn PhysicalToLogicalPoint(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn LogicalToPhysicalPointForPerMonitorDPI(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn PhysicalToLogicalPointForPerMonitorDPI(hWnd: HWND, lpPoint: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn MapWindowPoints(
        hWndFrom: HWND,
        hWndTo: HWND,
        lpPoints: LPPOINT,
        cPoints: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WindowFromPoint(Point: POINT) -> HWND;
}
unsafe extern "C" {
    pub fn WindowFromPhysicalPoint(Point: POINT) -> HWND;
}
unsafe extern "C" {
    pub fn ChildWindowFromPoint(hWndParent: HWND, Point: POINT) -> HWND;
}
unsafe extern "C" {
    pub fn ClipCursor(lpRect: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn ChildWindowFromPointEx(hwnd: HWND, pt: POINT, flags: UINT) -> HWND;
}
unsafe extern "C" {
    pub fn GetSysColor(nIndex: ::std::os::raw::c_int) -> DWORD;
}
unsafe extern "C" {
    pub fn GetSysColorBrush(nIndex: ::std::os::raw::c_int) -> HBRUSH;
}
unsafe extern "C" {
    pub fn SetSysColors(
        cElements: ::std::os::raw::c_int,
        lpaElements: *const INT,
        lpaRgbValues: *const COLORREF,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DrawFocusRect(hDC: HDC, lprc: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn FillRect(hDC: HDC, lprc: *const RECT, hbr: HBRUSH) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn FrameRect(hDC: HDC, lprc: *const RECT, hbr: HBRUSH) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn InvertRect(hDC: HDC, lprc: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetRect(
        lprc: LPRECT,
        xLeft: ::std::os::raw::c_int,
        yTop: ::std::os::raw::c_int,
        xRight: ::std::os::raw::c_int,
        yBottom: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetRectEmpty(lprc: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn CopyRect(lprcDst: LPRECT, lprcSrc: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn InflateRect(lprc: LPRECT, dx: ::std::os::raw::c_int, dy: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn IntersectRect(lprcDst: LPRECT, lprcSrc1: *const RECT, lprcSrc2: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn UnionRect(lprcDst: LPRECT, lprcSrc1: *const RECT, lprcSrc2: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn SubtractRect(lprcDst: LPRECT, lprcSrc1: *const RECT, lprcSrc2: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn OffsetRect(lprc: LPRECT, dx: ::std::os::raw::c_int, dy: ::std::os::raw::c_int) -> BOOL;
}
unsafe extern "C" {
    pub fn IsRectEmpty(lprc: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn EqualRect(lprc1: *const RECT, lprc2: *const RECT) -> BOOL;
}
unsafe extern "C" {
    pub fn PtInRect(lprc: *const RECT, pt: POINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetWindowWord(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> WORD;
}
unsafe extern "C" {
    pub fn SetWindowWord(hWnd: HWND, nIndex: ::std::os::raw::c_int, wNewWord: WORD) -> WORD;
}
unsafe extern "C" {
    pub fn GetWindowLongA(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> LONG;
}
unsafe extern "C" {
    pub fn GetWindowLongW(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> LONG;
}
unsafe extern "C" {
    pub fn SetWindowLongA(hWnd: HWND, nIndex: ::std::os::raw::c_int, dwNewLong: LONG) -> LONG;
}
unsafe extern "C" {
    pub fn SetWindowLongW(hWnd: HWND, nIndex: ::std::os::raw::c_int, dwNewLong: LONG) -> LONG;
}
unsafe extern "C" {
    pub fn GetWindowLongPtrA(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> LONG_PTR;
}
unsafe extern "C" {
    pub fn GetWindowLongPtrW(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> LONG_PTR;
}
unsafe extern "C" {
    pub fn SetWindowLongPtrA(
        hWnd: HWND,
        nIndex: ::std::os::raw::c_int,
        dwNewLong: LONG_PTR,
    ) -> LONG_PTR;
}
unsafe extern "C" {
    pub fn SetWindowLongPtrW(
        hWnd: HWND,
        nIndex: ::std::os::raw::c_int,
        dwNewLong: LONG_PTR,
    ) -> LONG_PTR;
}
unsafe extern "C" {
    pub fn GetClassWord(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> WORD;
}
unsafe extern "C" {
    pub fn SetClassWord(hWnd: HWND, nIndex: ::std::os::raw::c_int, wNewWord: WORD) -> WORD;
}
unsafe extern "C" {
    pub fn GetClassLongA(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> DWORD;
}
unsafe extern "C" {
    pub fn GetClassLongW(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> DWORD;
}
unsafe extern "C" {
    pub fn SetClassLongA(hWnd: HWND, nIndex: ::std::os::raw::c_int, dwNewLong: LONG) -> DWORD;
}
unsafe extern "C" {
    pub fn SetClassLongW(hWnd: HWND, nIndex: ::std::os::raw::c_int, dwNewLong: LONG) -> DWORD;
}
unsafe extern "C" {
    pub fn GetClassLongPtrA(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> ULONG_PTR;
}
unsafe extern "C" {
    pub fn GetClassLongPtrW(hWnd: HWND, nIndex: ::std::os::raw::c_int) -> ULONG_PTR;
}
unsafe extern "C" {
    pub fn SetClassLongPtrA(
        hWnd: HWND,
        nIndex: ::std::os::raw::c_int,
        dwNewLong: LONG_PTR,
    ) -> ULONG_PTR;
}
unsafe extern "C" {
    pub fn SetClassLongPtrW(
        hWnd: HWND,
        nIndex: ::std::os::raw::c_int,
        dwNewLong: LONG_PTR,
    ) -> ULONG_PTR;
}
unsafe extern "C" {
    pub fn GetProcessDefaultLayout(pdwDefaultLayout: *mut DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDefaultLayout(dwDefaultLayout: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDesktopWindow() -> HWND;
}
unsafe extern "C" {
    pub fn GetParent(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn SetParent(hWndChild: HWND, hWndNewParent: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn EnumChildWindows(hWndParent: HWND, lpEnumFunc: WNDENUMPROC, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn FindWindowA(lpClassName: LPCSTR, lpWindowName: LPCSTR) -> HWND;
}
unsafe extern "C" {
    pub fn FindWindowW(lpClassName: LPCWSTR, lpWindowName: LPCWSTR) -> HWND;
}
unsafe extern "C" {
    pub fn FindWindowExA(
        hWndParent: HWND,
        hWndChildAfter: HWND,
        lpszClass: LPCSTR,
        lpszWindow: LPCSTR,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn FindWindowExW(
        hWndParent: HWND,
        hWndChildAfter: HWND,
        lpszClass: LPCWSTR,
        lpszWindow: LPCWSTR,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn GetShellWindow() -> HWND;
}
unsafe extern "C" {
    pub fn RegisterShellHookWindow(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn DeregisterShellHookWindow(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumWindows(lpEnumFunc: WNDENUMPROC, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumThreadWindows(dwThreadId: DWORD, lpfn: WNDENUMPROC, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn GetClassNameA(
        hWnd: HWND,
        lpClassName: LPSTR,
        nMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetClassNameW(
        hWnd: HWND,
        lpClassName: LPWSTR,
        nMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTopWindow(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn GetWindowThreadProcessId(hWnd: HWND, lpdwProcessId: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn IsGUIThread(bConvert: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLastActivePopup(hWnd: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn GetWindow(hWnd: HWND, uCmd: UINT) -> HWND;
}
unsafe extern "C" {
    pub fn SetWindowsHookA(nFilterType: ::std::os::raw::c_int, pfnFilterProc: HOOKPROC) -> HHOOK;
}
unsafe extern "C" {
    pub fn SetWindowsHookW(nFilterType: ::std::os::raw::c_int, pfnFilterProc: HOOKPROC) -> HHOOK;
}
unsafe extern "C" {
    pub fn UnhookWindowsHook(nCode: ::std::os::raw::c_int, pfnFilterProc: HOOKPROC) -> BOOL;
}
unsafe extern "C" {
    pub fn SetWindowsHookExA(
        idHook: ::std::os::raw::c_int,
        lpfn: HOOKPROC,
        hmod: HINSTANCE,
        dwThreadId: DWORD,
    ) -> HHOOK;
}
unsafe extern "C" {
    pub fn SetWindowsHookExW(
        idHook: ::std::os::raw::c_int,
        lpfn: HOOKPROC,
        hmod: HINSTANCE,
        dwThreadId: DWORD,
    ) -> HHOOK;
}
unsafe extern "C" {
    pub fn UnhookWindowsHookEx(hhk: HHOOK) -> BOOL;
}
unsafe extern "C" {
    pub fn CallNextHookEx(
        hhk: HHOOK,
        nCode: ::std::os::raw::c_int,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn CheckMenuRadioItem(
        hmenu: HMENU,
        first: UINT,
        last: UINT,
        check: UINT,
        flags: UINT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MENUITEMTEMPLATEHEADER {
    pub versionNumber: WORD,
    pub offset: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MENUITEMTEMPLATEHEADER"][::std::mem::size_of::<MENUITEMTEMPLATEHEADER>() - 4usize];
    ["Alignment of MENUITEMTEMPLATEHEADER"]
        [::std::mem::align_of::<MENUITEMTEMPLATEHEADER>() - 2usize];
    ["Offset of field: MENUITEMTEMPLATEHEADER::versionNumber"]
        [::std::mem::offset_of!(MENUITEMTEMPLATEHEADER, versionNumber) - 0usize];
    ["Offset of field: MENUITEMTEMPLATEHEADER::offset"]
        [::std::mem::offset_of!(MENUITEMTEMPLATEHEADER, offset) - 2usize];
};
pub type PMENUITEMTEMPLATEHEADER = *mut MENUITEMTEMPLATEHEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MENUITEMTEMPLATE {
    pub mtOption: WORD,
    pub mtID: WORD,
    pub mtString: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MENUITEMTEMPLATE"][::std::mem::size_of::<MENUITEMTEMPLATE>() - 6usize];
    ["Alignment of MENUITEMTEMPLATE"][::std::mem::align_of::<MENUITEMTEMPLATE>() - 2usize];
    ["Offset of field: MENUITEMTEMPLATE::mtOption"]
        [::std::mem::offset_of!(MENUITEMTEMPLATE, mtOption) - 0usize];
    ["Offset of field: MENUITEMTEMPLATE::mtID"]
        [::std::mem::offset_of!(MENUITEMTEMPLATE, mtID) - 2usize];
    ["Offset of field: MENUITEMTEMPLATE::mtString"]
        [::std::mem::offset_of!(MENUITEMTEMPLATE, mtString) - 4usize];
};
pub type PMENUITEMTEMPLATE = *mut MENUITEMTEMPLATE;
unsafe extern "C" {
    pub fn LoadBitmapA(hInstance: HINSTANCE, lpBitmapName: LPCSTR) -> HBITMAP;
}
unsafe extern "C" {
    pub fn LoadBitmapW(hInstance: HINSTANCE, lpBitmapName: LPCWSTR) -> HBITMAP;
}
unsafe extern "C" {
    pub fn LoadCursorA(hInstance: HINSTANCE, lpCursorName: LPCSTR) -> HCURSOR;
}
unsafe extern "C" {
    pub fn LoadCursorW(hInstance: HINSTANCE, lpCursorName: LPCWSTR) -> HCURSOR;
}
unsafe extern "C" {
    pub fn LoadCursorFromFileA(lpFileName: LPCSTR) -> HCURSOR;
}
unsafe extern "C" {
    pub fn LoadCursorFromFileW(lpFileName: LPCWSTR) -> HCURSOR;
}
unsafe extern "C" {
    pub fn CreateCursor(
        hInst: HINSTANCE,
        xHotSpot: ::std::os::raw::c_int,
        yHotSpot: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        pvANDPlane: *const ::std::os::raw::c_void,
        pvXORPlane: *const ::std::os::raw::c_void,
    ) -> HCURSOR;
}
unsafe extern "C" {
    pub fn DestroyCursor(hCursor: HCURSOR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetSystemCursor(hcur: HCURSOR, id: DWORD) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ICONINFO {
    pub fIcon: BOOL,
    pub xHotspot: DWORD,
    pub yHotspot: DWORD,
    pub hbmMask: HBITMAP,
    pub hbmColor: HBITMAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ICONINFO"][::std::mem::size_of::<_ICONINFO>() - 32usize];
    ["Alignment of _ICONINFO"][::std::mem::align_of::<_ICONINFO>() - 8usize];
    ["Offset of field: _ICONINFO::fIcon"][::std::mem::offset_of!(_ICONINFO, fIcon) - 0usize];
    ["Offset of field: _ICONINFO::xHotspot"][::std::mem::offset_of!(_ICONINFO, xHotspot) - 4usize];
    ["Offset of field: _ICONINFO::yHotspot"][::std::mem::offset_of!(_ICONINFO, yHotspot) - 8usize];
    ["Offset of field: _ICONINFO::hbmMask"][::std::mem::offset_of!(_ICONINFO, hbmMask) - 16usize];
    ["Offset of field: _ICONINFO::hbmColor"][::std::mem::offset_of!(_ICONINFO, hbmColor) - 24usize];
};
pub type ICONINFO = _ICONINFO;
pub type PICONINFO = *mut ICONINFO;
unsafe extern "C" {
    pub fn LoadIconA(hInstance: HINSTANCE, lpIconName: LPCSTR) -> HICON;
}
unsafe extern "C" {
    pub fn LoadIconW(hInstance: HINSTANCE, lpIconName: LPCWSTR) -> HICON;
}
unsafe extern "C" {
    pub fn PrivateExtractIconsA(
        szFileName: LPCSTR,
        nIconIndex: ::std::os::raw::c_int,
        cxIcon: ::std::os::raw::c_int,
        cyIcon: ::std::os::raw::c_int,
        phicon: *mut HICON,
        piconid: *mut UINT,
        nIcons: UINT,
        flags: UINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn PrivateExtractIconsW(
        szFileName: LPCWSTR,
        nIconIndex: ::std::os::raw::c_int,
        cxIcon: ::std::os::raw::c_int,
        cyIcon: ::std::os::raw::c_int,
        phicon: *mut HICON,
        piconid: *mut UINT,
        nIcons: UINT,
        flags: UINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn CreateIcon(
        hInstance: HINSTANCE,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        cPlanes: BYTE,
        cBitsPixel: BYTE,
        lpbANDbits: *const BYTE,
        lpbXORbits: *const BYTE,
    ) -> HICON;
}
unsafe extern "C" {
    pub fn DestroyIcon(hIcon: HICON) -> BOOL;
}
unsafe extern "C" {
    pub fn LookupIconIdFromDirectory(presbits: PBYTE, fIcon: BOOL) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LookupIconIdFromDirectoryEx(
        presbits: PBYTE,
        fIcon: BOOL,
        cxDesired: ::std::os::raw::c_int,
        cyDesired: ::std::os::raw::c_int,
        Flags: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CreateIconFromResource(
        presbits: PBYTE,
        dwResSize: DWORD,
        fIcon: BOOL,
        dwVer: DWORD,
    ) -> HICON;
}
unsafe extern "C" {
    pub fn CreateIconFromResourceEx(
        presbits: PBYTE,
        dwResSize: DWORD,
        fIcon: BOOL,
        dwVer: DWORD,
        cxDesired: ::std::os::raw::c_int,
        cyDesired: ::std::os::raw::c_int,
        Flags: UINT,
    ) -> HICON;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCURSORSHAPE {
    pub xHotSpot: ::std::os::raw::c_int,
    pub yHotSpot: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub cy: ::std::os::raw::c_int,
    pub cbWidth: ::std::os::raw::c_int,
    pub Planes: BYTE,
    pub BitsPixel: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCURSORSHAPE"][::std::mem::size_of::<tagCURSORSHAPE>() - 24usize];
    ["Alignment of tagCURSORSHAPE"][::std::mem::align_of::<tagCURSORSHAPE>() - 4usize];
    ["Offset of field: tagCURSORSHAPE::xHotSpot"]
        [::std::mem::offset_of!(tagCURSORSHAPE, xHotSpot) - 0usize];
    ["Offset of field: tagCURSORSHAPE::yHotSpot"]
        [::std::mem::offset_of!(tagCURSORSHAPE, yHotSpot) - 4usize];
    ["Offset of field: tagCURSORSHAPE::cx"][::std::mem::offset_of!(tagCURSORSHAPE, cx) - 8usize];
    ["Offset of field: tagCURSORSHAPE::cy"][::std::mem::offset_of!(tagCURSORSHAPE, cy) - 12usize];
    ["Offset of field: tagCURSORSHAPE::cbWidth"]
        [::std::mem::offset_of!(tagCURSORSHAPE, cbWidth) - 16usize];
    ["Offset of field: tagCURSORSHAPE::Planes"]
        [::std::mem::offset_of!(tagCURSORSHAPE, Planes) - 20usize];
    ["Offset of field: tagCURSORSHAPE::BitsPixel"]
        [::std::mem::offset_of!(tagCURSORSHAPE, BitsPixel) - 21usize];
};
pub type CURSORSHAPE = tagCURSORSHAPE;
pub type LPCURSORSHAPE = *mut tagCURSORSHAPE;
unsafe extern "C" {
    pub fn SetThreadCursorCreationScaling(cursorDpi: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn LoadImageA(
        hInst: HINSTANCE,
        name: LPCSTR,
        type_: UINT,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        fuLoad: UINT,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn LoadImageW(
        hInst: HINSTANCE,
        name: LPCWSTR,
        type_: UINT,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        fuLoad: UINT,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn CopyImage(
        h: HANDLE,
        type_: UINT,
        cx: ::std::os::raw::c_int,
        cy: ::std::os::raw::c_int,
        flags: UINT,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn DrawIconEx(
        hdc: HDC,
        xLeft: ::std::os::raw::c_int,
        yTop: ::std::os::raw::c_int,
        hIcon: HICON,
        cxWidth: ::std::os::raw::c_int,
        cyWidth: ::std::os::raw::c_int,
        istepIfAniCur: UINT,
        hbrFlickerFreeDraw: HBRUSH,
        diFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateIconIndirect(piconinfo: PICONINFO) -> HICON;
}
unsafe extern "C" {
    pub fn CopyIcon(hIcon: HICON) -> HICON;
}
unsafe extern "C" {
    pub fn GetIconInfo(hIcon: HICON, piconinfo: PICONINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ICONINFOEXA {
    pub cbSize: DWORD,
    pub fIcon: BOOL,
    pub xHotspot: DWORD,
    pub yHotspot: DWORD,
    pub hbmMask: HBITMAP,
    pub hbmColor: HBITMAP,
    pub wResID: WORD,
    pub szModName: [CHAR; 260usize],
    pub szResName: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ICONINFOEXA"][::std::mem::size_of::<_ICONINFOEXA>() - 560usize];
    ["Alignment of _ICONINFOEXA"][::std::mem::align_of::<_ICONINFOEXA>() - 8usize];
    ["Offset of field: _ICONINFOEXA::cbSize"]
        [::std::mem::offset_of!(_ICONINFOEXA, cbSize) - 0usize];
    ["Offset of field: _ICONINFOEXA::fIcon"][::std::mem::offset_of!(_ICONINFOEXA, fIcon) - 4usize];
    ["Offset of field: _ICONINFOEXA::xHotspot"]
        [::std::mem::offset_of!(_ICONINFOEXA, xHotspot) - 8usize];
    ["Offset of field: _ICONINFOEXA::yHotspot"]
        [::std::mem::offset_of!(_ICONINFOEXA, yHotspot) - 12usize];
    ["Offset of field: _ICONINFOEXA::hbmMask"]
        [::std::mem::offset_of!(_ICONINFOEXA, hbmMask) - 16usize];
    ["Offset of field: _ICONINFOEXA::hbmColor"]
        [::std::mem::offset_of!(_ICONINFOEXA, hbmColor) - 24usize];
    ["Offset of field: _ICONINFOEXA::wResID"]
        [::std::mem::offset_of!(_ICONINFOEXA, wResID) - 32usize];
    ["Offset of field: _ICONINFOEXA::szModName"]
        [::std::mem::offset_of!(_ICONINFOEXA, szModName) - 34usize];
    ["Offset of field: _ICONINFOEXA::szResName"]
        [::std::mem::offset_of!(_ICONINFOEXA, szResName) - 294usize];
};
pub type ICONINFOEXA = _ICONINFOEXA;
pub type PICONINFOEXA = *mut _ICONINFOEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ICONINFOEXW {
    pub cbSize: DWORD,
    pub fIcon: BOOL,
    pub xHotspot: DWORD,
    pub yHotspot: DWORD,
    pub hbmMask: HBITMAP,
    pub hbmColor: HBITMAP,
    pub wResID: WORD,
    pub szModName: [WCHAR; 260usize],
    pub szResName: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ICONINFOEXW"][::std::mem::size_of::<_ICONINFOEXW>() - 1080usize];
    ["Alignment of _ICONINFOEXW"][::std::mem::align_of::<_ICONINFOEXW>() - 8usize];
    ["Offset of field: _ICONINFOEXW::cbSize"]
        [::std::mem::offset_of!(_ICONINFOEXW, cbSize) - 0usize];
    ["Offset of field: _ICONINFOEXW::fIcon"][::std::mem::offset_of!(_ICONINFOEXW, fIcon) - 4usize];
    ["Offset of field: _ICONINFOEXW::xHotspot"]
        [::std::mem::offset_of!(_ICONINFOEXW, xHotspot) - 8usize];
    ["Offset of field: _ICONINFOEXW::yHotspot"]
        [::std::mem::offset_of!(_ICONINFOEXW, yHotspot) - 12usize];
    ["Offset of field: _ICONINFOEXW::hbmMask"]
        [::std::mem::offset_of!(_ICONINFOEXW, hbmMask) - 16usize];
    ["Offset of field: _ICONINFOEXW::hbmColor"]
        [::std::mem::offset_of!(_ICONINFOEXW, hbmColor) - 24usize];
    ["Offset of field: _ICONINFOEXW::wResID"]
        [::std::mem::offset_of!(_ICONINFOEXW, wResID) - 32usize];
    ["Offset of field: _ICONINFOEXW::szModName"]
        [::std::mem::offset_of!(_ICONINFOEXW, szModName) - 34usize];
    ["Offset of field: _ICONINFOEXW::szResName"]
        [::std::mem::offset_of!(_ICONINFOEXW, szResName) - 554usize];
};
pub type ICONINFOEXW = _ICONINFOEXW;
pub type PICONINFOEXW = *mut _ICONINFOEXW;
pub type ICONINFOEX = ICONINFOEXA;
pub type PICONINFOEX = PICONINFOEXA;
unsafe extern "C" {
    pub fn GetIconInfoExA(hicon: HICON, piconinfo: PICONINFOEXA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetIconInfoExW(hicon: HICON, piconinfo: PICONINFOEXW) -> BOOL;
}
pub const EDIT_CONTROL_FEATURE_EDIT_CONTROL_FEATURE_ENTERPRISE_DATA_PROTECTION_PASTE_SUPPORT:
    EDIT_CONTROL_FEATURE = 0;
pub const EDIT_CONTROL_FEATURE_EDIT_CONTROL_FEATURE_PASTE_NOTIFICATIONS: EDIT_CONTROL_FEATURE = 1;
pub type EDIT_CONTROL_FEATURE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn IsDialogMessageA(hDlg: HWND, lpMsg: LPMSG) -> BOOL;
}
unsafe extern "C" {
    pub fn IsDialogMessageW(hDlg: HWND, lpMsg: LPMSG) -> BOOL;
}
unsafe extern "C" {
    pub fn MapDialogRect(hDlg: HWND, lpRect: LPRECT) -> BOOL;
}
unsafe extern "C" {
    pub fn DlgDirListA(
        hDlg: HWND,
        lpPathSpec: LPSTR,
        nIDListBox: ::std::os::raw::c_int,
        nIDStaticPath: ::std::os::raw::c_int,
        uFileType: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DlgDirListW(
        hDlg: HWND,
        lpPathSpec: LPWSTR,
        nIDListBox: ::std::os::raw::c_int,
        nIDStaticPath: ::std::os::raw::c_int,
        uFileType: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DlgDirSelectExA(
        hwndDlg: HWND,
        lpString: LPSTR,
        chCount: ::std::os::raw::c_int,
        idListBox: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DlgDirSelectExW(
        hwndDlg: HWND,
        lpString: LPWSTR,
        chCount: ::std::os::raw::c_int,
        idListBox: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DlgDirListComboBoxA(
        hDlg: HWND,
        lpPathSpec: LPSTR,
        nIDComboBox: ::std::os::raw::c_int,
        nIDStaticPath: ::std::os::raw::c_int,
        uFiletype: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DlgDirListComboBoxW(
        hDlg: HWND,
        lpPathSpec: LPWSTR,
        nIDComboBox: ::std::os::raw::c_int,
        nIDStaticPath: ::std::os::raw::c_int,
        uFiletype: UINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn DlgDirSelectComboBoxExA(
        hwndDlg: HWND,
        lpString: LPSTR,
        cchOut: ::std::os::raw::c_int,
        idComboBox: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DlgDirSelectComboBoxExW(
        hwndDlg: HWND,
        lpString: LPWSTR,
        cchOut: ::std::os::raw::c_int,
        idComboBox: ::std::os::raw::c_int,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSCROLLINFO {
    pub cbSize: UINT,
    pub fMask: UINT,
    pub nMin: ::std::os::raw::c_int,
    pub nMax: ::std::os::raw::c_int,
    pub nPage: UINT,
    pub nPos: ::std::os::raw::c_int,
    pub nTrackPos: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSCROLLINFO"][::std::mem::size_of::<tagSCROLLINFO>() - 28usize];
    ["Alignment of tagSCROLLINFO"][::std::mem::align_of::<tagSCROLLINFO>() - 4usize];
    ["Offset of field: tagSCROLLINFO::cbSize"]
        [::std::mem::offset_of!(tagSCROLLINFO, cbSize) - 0usize];
    ["Offset of field: tagSCROLLINFO::fMask"]
        [::std::mem::offset_of!(tagSCROLLINFO, fMask) - 4usize];
    ["Offset of field: tagSCROLLINFO::nMin"][::std::mem::offset_of!(tagSCROLLINFO, nMin) - 8usize];
    ["Offset of field: tagSCROLLINFO::nMax"][::std::mem::offset_of!(tagSCROLLINFO, nMax) - 12usize];
    ["Offset of field: tagSCROLLINFO::nPage"]
        [::std::mem::offset_of!(tagSCROLLINFO, nPage) - 16usize];
    ["Offset of field: tagSCROLLINFO::nPos"][::std::mem::offset_of!(tagSCROLLINFO, nPos) - 20usize];
    ["Offset of field: tagSCROLLINFO::nTrackPos"]
        [::std::mem::offset_of!(tagSCROLLINFO, nTrackPos) - 24usize];
};
pub type SCROLLINFO = tagSCROLLINFO;
pub type LPSCROLLINFO = *mut tagSCROLLINFO;
pub type LPCSCROLLINFO = *const SCROLLINFO;
unsafe extern "C" {
    pub fn SetScrollInfo(
        hwnd: HWND,
        nBar: ::std::os::raw::c_int,
        lpsi: LPCSCROLLINFO,
        redraw: BOOL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetScrollInfo(hwnd: HWND, nBar: ::std::os::raw::c_int, lpsi: LPSCROLLINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMDICREATESTRUCTA {
    pub szClass: LPCSTR,
    pub szTitle: LPCSTR,
    pub hOwner: HANDLE,
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub cy: ::std::os::raw::c_int,
    pub style: DWORD,
    pub lParam: LPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMDICREATESTRUCTA"][::std::mem::size_of::<tagMDICREATESTRUCTA>() - 56usize];
    ["Alignment of tagMDICREATESTRUCTA"][::std::mem::align_of::<tagMDICREATESTRUCTA>() - 8usize];
    ["Offset of field: tagMDICREATESTRUCTA::szClass"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, szClass) - 0usize];
    ["Offset of field: tagMDICREATESTRUCTA::szTitle"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, szTitle) - 8usize];
    ["Offset of field: tagMDICREATESTRUCTA::hOwner"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, hOwner) - 16usize];
    ["Offset of field: tagMDICREATESTRUCTA::x"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, x) - 24usize];
    ["Offset of field: tagMDICREATESTRUCTA::y"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, y) - 28usize];
    ["Offset of field: tagMDICREATESTRUCTA::cx"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, cx) - 32usize];
    ["Offset of field: tagMDICREATESTRUCTA::cy"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, cy) - 36usize];
    ["Offset of field: tagMDICREATESTRUCTA::style"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, style) - 40usize];
    ["Offset of field: tagMDICREATESTRUCTA::lParam"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTA, lParam) - 48usize];
};
pub type MDICREATESTRUCTA = tagMDICREATESTRUCTA;
pub type LPMDICREATESTRUCTA = *mut tagMDICREATESTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMDICREATESTRUCTW {
    pub szClass: LPCWSTR,
    pub szTitle: LPCWSTR,
    pub hOwner: HANDLE,
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub cx: ::std::os::raw::c_int,
    pub cy: ::std::os::raw::c_int,
    pub style: DWORD,
    pub lParam: LPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMDICREATESTRUCTW"][::std::mem::size_of::<tagMDICREATESTRUCTW>() - 56usize];
    ["Alignment of tagMDICREATESTRUCTW"][::std::mem::align_of::<tagMDICREATESTRUCTW>() - 8usize];
    ["Offset of field: tagMDICREATESTRUCTW::szClass"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, szClass) - 0usize];
    ["Offset of field: tagMDICREATESTRUCTW::szTitle"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, szTitle) - 8usize];
    ["Offset of field: tagMDICREATESTRUCTW::hOwner"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, hOwner) - 16usize];
    ["Offset of field: tagMDICREATESTRUCTW::x"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, x) - 24usize];
    ["Offset of field: tagMDICREATESTRUCTW::y"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, y) - 28usize];
    ["Offset of field: tagMDICREATESTRUCTW::cx"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, cx) - 32usize];
    ["Offset of field: tagMDICREATESTRUCTW::cy"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, cy) - 36usize];
    ["Offset of field: tagMDICREATESTRUCTW::style"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, style) - 40usize];
    ["Offset of field: tagMDICREATESTRUCTW::lParam"]
        [::std::mem::offset_of!(tagMDICREATESTRUCTW, lParam) - 48usize];
};
pub type MDICREATESTRUCTW = tagMDICREATESTRUCTW;
pub type LPMDICREATESTRUCTW = *mut tagMDICREATESTRUCTW;
pub type MDICREATESTRUCT = MDICREATESTRUCTA;
pub type LPMDICREATESTRUCT = LPMDICREATESTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCLIENTCREATESTRUCT {
    pub hWindowMenu: HANDLE,
    pub idFirstChild: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCLIENTCREATESTRUCT"][::std::mem::size_of::<tagCLIENTCREATESTRUCT>() - 16usize];
    ["Alignment of tagCLIENTCREATESTRUCT"]
        [::std::mem::align_of::<tagCLIENTCREATESTRUCT>() - 8usize];
    ["Offset of field: tagCLIENTCREATESTRUCT::hWindowMenu"]
        [::std::mem::offset_of!(tagCLIENTCREATESTRUCT, hWindowMenu) - 0usize];
    ["Offset of field: tagCLIENTCREATESTRUCT::idFirstChild"]
        [::std::mem::offset_of!(tagCLIENTCREATESTRUCT, idFirstChild) - 8usize];
};
pub type CLIENTCREATESTRUCT = tagCLIENTCREATESTRUCT;
pub type LPCLIENTCREATESTRUCT = *mut tagCLIENTCREATESTRUCT;
unsafe extern "C" {
    pub fn DefFrameProcA(
        hWnd: HWND,
        hWndMDIClient: HWND,
        uMsg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn DefFrameProcW(
        hWnd: HWND,
        hWndMDIClient: HWND,
        uMsg: UINT,
        wParam: WPARAM,
        lParam: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn DefMDIChildProcA(hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn DefMDIChildProcW(hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn TranslateMDISysAccel(hWndClient: HWND, lpMsg: LPMSG) -> BOOL;
}
unsafe extern "C" {
    pub fn ArrangeIconicWindows(hWnd: HWND) -> UINT;
}
unsafe extern "C" {
    pub fn CreateMDIWindowA(
        lpClassName: LPCSTR,
        lpWindowName: LPCSTR,
        dwStyle: DWORD,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        hWndParent: HWND,
        hInstance: HINSTANCE,
        lParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn CreateMDIWindowW(
        lpClassName: LPCWSTR,
        lpWindowName: LPCWSTR,
        dwStyle: DWORD,
        X: ::std::os::raw::c_int,
        Y: ::std::os::raw::c_int,
        nWidth: ::std::os::raw::c_int,
        nHeight: ::std::os::raw::c_int,
        hWndParent: HWND,
        hInstance: HINSTANCE,
        lParam: LPARAM,
    ) -> HWND;
}
unsafe extern "C" {
    pub fn TileWindows(
        hwndParent: HWND,
        wHow: UINT,
        lpRect: *const RECT,
        cKids: UINT,
        lpKids: *const HWND,
    ) -> WORD;
}
unsafe extern "C" {
    pub fn CascadeWindows(
        hwndParent: HWND,
        wHow: UINT,
        lpRect: *const RECT,
        cKids: UINT,
        lpKids: *const HWND,
    ) -> WORD;
}
pub type HELPPOLY = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMULTIKEYHELPA {
    pub mkSize: DWORD,
    pub mkKeylist: CHAR,
    pub szKeyphrase: [CHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMULTIKEYHELPA"][::std::mem::size_of::<tagMULTIKEYHELPA>() - 8usize];
    ["Alignment of tagMULTIKEYHELPA"][::std::mem::align_of::<tagMULTIKEYHELPA>() - 4usize];
    ["Offset of field: tagMULTIKEYHELPA::mkSize"]
        [::std::mem::offset_of!(tagMULTIKEYHELPA, mkSize) - 0usize];
    ["Offset of field: tagMULTIKEYHELPA::mkKeylist"]
        [::std::mem::offset_of!(tagMULTIKEYHELPA, mkKeylist) - 4usize];
    ["Offset of field: tagMULTIKEYHELPA::szKeyphrase"]
        [::std::mem::offset_of!(tagMULTIKEYHELPA, szKeyphrase) - 5usize];
};
pub type MULTIKEYHELPA = tagMULTIKEYHELPA;
pub type PMULTIKEYHELPA = *mut tagMULTIKEYHELPA;
pub type LPMULTIKEYHELPA = *mut tagMULTIKEYHELPA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMULTIKEYHELPW {
    pub mkSize: DWORD,
    pub mkKeylist: WCHAR,
    pub szKeyphrase: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMULTIKEYHELPW"][::std::mem::size_of::<tagMULTIKEYHELPW>() - 8usize];
    ["Alignment of tagMULTIKEYHELPW"][::std::mem::align_of::<tagMULTIKEYHELPW>() - 4usize];
    ["Offset of field: tagMULTIKEYHELPW::mkSize"]
        [::std::mem::offset_of!(tagMULTIKEYHELPW, mkSize) - 0usize];
    ["Offset of field: tagMULTIKEYHELPW::mkKeylist"]
        [::std::mem::offset_of!(tagMULTIKEYHELPW, mkKeylist) - 4usize];
    ["Offset of field: tagMULTIKEYHELPW::szKeyphrase"]
        [::std::mem::offset_of!(tagMULTIKEYHELPW, szKeyphrase) - 6usize];
};
pub type MULTIKEYHELPW = tagMULTIKEYHELPW;
pub type PMULTIKEYHELPW = *mut tagMULTIKEYHELPW;
pub type LPMULTIKEYHELPW = *mut tagMULTIKEYHELPW;
pub type MULTIKEYHELP = MULTIKEYHELPA;
pub type PMULTIKEYHELP = PMULTIKEYHELPA;
pub type LPMULTIKEYHELP = LPMULTIKEYHELPA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHELPWININFOA {
    pub wStructSize: ::std::os::raw::c_int,
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub dx: ::std::os::raw::c_int,
    pub dy: ::std::os::raw::c_int,
    pub wMax: ::std::os::raw::c_int,
    pub rgchMember: [CHAR; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHELPWININFOA"][::std::mem::size_of::<tagHELPWININFOA>() - 28usize];
    ["Alignment of tagHELPWININFOA"][::std::mem::align_of::<tagHELPWININFOA>() - 4usize];
    ["Offset of field: tagHELPWININFOA::wStructSize"]
        [::std::mem::offset_of!(tagHELPWININFOA, wStructSize) - 0usize];
    ["Offset of field: tagHELPWININFOA::x"][::std::mem::offset_of!(tagHELPWININFOA, x) - 4usize];
    ["Offset of field: tagHELPWININFOA::y"][::std::mem::offset_of!(tagHELPWININFOA, y) - 8usize];
    ["Offset of field: tagHELPWININFOA::dx"][::std::mem::offset_of!(tagHELPWININFOA, dx) - 12usize];
    ["Offset of field: tagHELPWININFOA::dy"][::std::mem::offset_of!(tagHELPWININFOA, dy) - 16usize];
    ["Offset of field: tagHELPWININFOA::wMax"]
        [::std::mem::offset_of!(tagHELPWININFOA, wMax) - 20usize];
    ["Offset of field: tagHELPWININFOA::rgchMember"]
        [::std::mem::offset_of!(tagHELPWININFOA, rgchMember) - 24usize];
};
pub type HELPWININFOA = tagHELPWININFOA;
pub type PHELPWININFOA = *mut tagHELPWININFOA;
pub type LPHELPWININFOA = *mut tagHELPWININFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHELPWININFOW {
    pub wStructSize: ::std::os::raw::c_int,
    pub x: ::std::os::raw::c_int,
    pub y: ::std::os::raw::c_int,
    pub dx: ::std::os::raw::c_int,
    pub dy: ::std::os::raw::c_int,
    pub wMax: ::std::os::raw::c_int,
    pub rgchMember: [WCHAR; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHELPWININFOW"][::std::mem::size_of::<tagHELPWININFOW>() - 28usize];
    ["Alignment of tagHELPWININFOW"][::std::mem::align_of::<tagHELPWININFOW>() - 4usize];
    ["Offset of field: tagHELPWININFOW::wStructSize"]
        [::std::mem::offset_of!(tagHELPWININFOW, wStructSize) - 0usize];
    ["Offset of field: tagHELPWININFOW::x"][::std::mem::offset_of!(tagHELPWININFOW, x) - 4usize];
    ["Offset of field: tagHELPWININFOW::y"][::std::mem::offset_of!(tagHELPWININFOW, y) - 8usize];
    ["Offset of field: tagHELPWININFOW::dx"][::std::mem::offset_of!(tagHELPWININFOW, dx) - 12usize];
    ["Offset of field: tagHELPWININFOW::dy"][::std::mem::offset_of!(tagHELPWININFOW, dy) - 16usize];
    ["Offset of field: tagHELPWININFOW::wMax"]
        [::std::mem::offset_of!(tagHELPWININFOW, wMax) - 20usize];
    ["Offset of field: tagHELPWININFOW::rgchMember"]
        [::std::mem::offset_of!(tagHELPWININFOW, rgchMember) - 24usize];
};
pub type HELPWININFOW = tagHELPWININFOW;
pub type PHELPWININFOW = *mut tagHELPWININFOW;
pub type LPHELPWININFOW = *mut tagHELPWININFOW;
pub type HELPWININFO = HELPWININFOA;
pub type PHELPWININFO = PHELPWININFOA;
pub type LPHELPWININFO = LPHELPWININFOA;
unsafe extern "C" {
    pub fn WinHelpA(hWndMain: HWND, lpszHelp: LPCSTR, uCommand: UINT, dwData: ULONG_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn WinHelpW(hWndMain: HWND, lpszHelp: LPCWSTR, uCommand: UINT, dwData: ULONG_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetGuiResources(hProcess: HANDLE, uiFlags: DWORD) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTouchPredictionParameters {
    pub cbSize: UINT,
    pub dwLatency: UINT,
    pub dwSampleTime: UINT,
    pub bUseHWTimeStamp: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTouchPredictionParameters"]
        [::std::mem::size_of::<tagTouchPredictionParameters>() - 16usize];
    ["Alignment of tagTouchPredictionParameters"]
        [::std::mem::align_of::<tagTouchPredictionParameters>() - 4usize];
    ["Offset of field: tagTouchPredictionParameters::cbSize"]
        [::std::mem::offset_of!(tagTouchPredictionParameters, cbSize) - 0usize];
    ["Offset of field: tagTouchPredictionParameters::dwLatency"]
        [::std::mem::offset_of!(tagTouchPredictionParameters, dwLatency) - 4usize];
    ["Offset of field: tagTouchPredictionParameters::dwSampleTime"]
        [::std::mem::offset_of!(tagTouchPredictionParameters, dwSampleTime) - 8usize];
    ["Offset of field: tagTouchPredictionParameters::bUseHWTimeStamp"]
        [::std::mem::offset_of!(tagTouchPredictionParameters, bUseHWTimeStamp) - 12usize];
};
pub type TOUCHPREDICTIONPARAMETERS = tagTouchPredictionParameters;
pub type PTOUCHPREDICTIONPARAMETERS = *mut tagTouchPredictionParameters;
pub const tagHANDEDNESS_HANDEDNESS_LEFT: tagHANDEDNESS = 0;
pub const tagHANDEDNESS_HANDEDNESS_RIGHT: tagHANDEDNESS = 1;
pub type tagHANDEDNESS = ::std::os::raw::c_int;
pub use self::tagHANDEDNESS as HANDEDNESS;
pub type PHANDEDNESS = *mut tagHANDEDNESS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNONCLIENTMETRICSA {
    pub cbSize: UINT,
    pub iBorderWidth: ::std::os::raw::c_int,
    pub iScrollWidth: ::std::os::raw::c_int,
    pub iScrollHeight: ::std::os::raw::c_int,
    pub iCaptionWidth: ::std::os::raw::c_int,
    pub iCaptionHeight: ::std::os::raw::c_int,
    pub lfCaptionFont: LOGFONTA,
    pub iSmCaptionWidth: ::std::os::raw::c_int,
    pub iSmCaptionHeight: ::std::os::raw::c_int,
    pub lfSmCaptionFont: LOGFONTA,
    pub iMenuWidth: ::std::os::raw::c_int,
    pub iMenuHeight: ::std::os::raw::c_int,
    pub lfMenuFont: LOGFONTA,
    pub lfStatusFont: LOGFONTA,
    pub lfMessageFont: LOGFONTA,
    pub iPaddedBorderWidth: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNONCLIENTMETRICSA"][::std::mem::size_of::<tagNONCLIENTMETRICSA>() - 344usize];
    ["Alignment of tagNONCLIENTMETRICSA"][::std::mem::align_of::<tagNONCLIENTMETRICSA>() - 4usize];
    ["Offset of field: tagNONCLIENTMETRICSA::cbSize"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, cbSize) - 0usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iBorderWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iBorderWidth) - 4usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iScrollWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iScrollWidth) - 8usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iScrollHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iScrollHeight) - 12usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iCaptionWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iCaptionWidth) - 16usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iCaptionHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iCaptionHeight) - 20usize];
    ["Offset of field: tagNONCLIENTMETRICSA::lfCaptionFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, lfCaptionFont) - 24usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iSmCaptionWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iSmCaptionWidth) - 84usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iSmCaptionHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iSmCaptionHeight) - 88usize];
    ["Offset of field: tagNONCLIENTMETRICSA::lfSmCaptionFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, lfSmCaptionFont) - 92usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iMenuWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iMenuWidth) - 152usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iMenuHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iMenuHeight) - 156usize];
    ["Offset of field: tagNONCLIENTMETRICSA::lfMenuFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, lfMenuFont) - 160usize];
    ["Offset of field: tagNONCLIENTMETRICSA::lfStatusFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, lfStatusFont) - 220usize];
    ["Offset of field: tagNONCLIENTMETRICSA::lfMessageFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, lfMessageFont) - 280usize];
    ["Offset of field: tagNONCLIENTMETRICSA::iPaddedBorderWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSA, iPaddedBorderWidth) - 340usize];
};
pub type NONCLIENTMETRICSA = tagNONCLIENTMETRICSA;
pub type PNONCLIENTMETRICSA = *mut tagNONCLIENTMETRICSA;
pub type LPNONCLIENTMETRICSA = *mut tagNONCLIENTMETRICSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNONCLIENTMETRICSW {
    pub cbSize: UINT,
    pub iBorderWidth: ::std::os::raw::c_int,
    pub iScrollWidth: ::std::os::raw::c_int,
    pub iScrollHeight: ::std::os::raw::c_int,
    pub iCaptionWidth: ::std::os::raw::c_int,
    pub iCaptionHeight: ::std::os::raw::c_int,
    pub lfCaptionFont: LOGFONTW,
    pub iSmCaptionWidth: ::std::os::raw::c_int,
    pub iSmCaptionHeight: ::std::os::raw::c_int,
    pub lfSmCaptionFont: LOGFONTW,
    pub iMenuWidth: ::std::os::raw::c_int,
    pub iMenuHeight: ::std::os::raw::c_int,
    pub lfMenuFont: LOGFONTW,
    pub lfStatusFont: LOGFONTW,
    pub lfMessageFont: LOGFONTW,
    pub iPaddedBorderWidth: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNONCLIENTMETRICSW"][::std::mem::size_of::<tagNONCLIENTMETRICSW>() - 504usize];
    ["Alignment of tagNONCLIENTMETRICSW"][::std::mem::align_of::<tagNONCLIENTMETRICSW>() - 4usize];
    ["Offset of field: tagNONCLIENTMETRICSW::cbSize"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, cbSize) - 0usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iBorderWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iBorderWidth) - 4usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iScrollWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iScrollWidth) - 8usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iScrollHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iScrollHeight) - 12usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iCaptionWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iCaptionWidth) - 16usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iCaptionHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iCaptionHeight) - 20usize];
    ["Offset of field: tagNONCLIENTMETRICSW::lfCaptionFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, lfCaptionFont) - 24usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iSmCaptionWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iSmCaptionWidth) - 116usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iSmCaptionHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iSmCaptionHeight) - 120usize];
    ["Offset of field: tagNONCLIENTMETRICSW::lfSmCaptionFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, lfSmCaptionFont) - 124usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iMenuWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iMenuWidth) - 216usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iMenuHeight"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iMenuHeight) - 220usize];
    ["Offset of field: tagNONCLIENTMETRICSW::lfMenuFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, lfMenuFont) - 224usize];
    ["Offset of field: tagNONCLIENTMETRICSW::lfStatusFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, lfStatusFont) - 316usize];
    ["Offset of field: tagNONCLIENTMETRICSW::lfMessageFont"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, lfMessageFont) - 408usize];
    ["Offset of field: tagNONCLIENTMETRICSW::iPaddedBorderWidth"]
        [::std::mem::offset_of!(tagNONCLIENTMETRICSW, iPaddedBorderWidth) - 500usize];
};
pub type NONCLIENTMETRICSW = tagNONCLIENTMETRICSW;
pub type PNONCLIENTMETRICSW = *mut tagNONCLIENTMETRICSW;
pub type LPNONCLIENTMETRICSW = *mut tagNONCLIENTMETRICSW;
pub type NONCLIENTMETRICS = NONCLIENTMETRICSA;
pub type PNONCLIENTMETRICS = PNONCLIENTMETRICSA;
pub type LPNONCLIENTMETRICS = LPNONCLIENTMETRICSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMINIMIZEDMETRICS {
    pub cbSize: UINT,
    pub iWidth: ::std::os::raw::c_int,
    pub iHorzGap: ::std::os::raw::c_int,
    pub iVertGap: ::std::os::raw::c_int,
    pub iArrange: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMINIMIZEDMETRICS"][::std::mem::size_of::<tagMINIMIZEDMETRICS>() - 20usize];
    ["Alignment of tagMINIMIZEDMETRICS"][::std::mem::align_of::<tagMINIMIZEDMETRICS>() - 4usize];
    ["Offset of field: tagMINIMIZEDMETRICS::cbSize"]
        [::std::mem::offset_of!(tagMINIMIZEDMETRICS, cbSize) - 0usize];
    ["Offset of field: tagMINIMIZEDMETRICS::iWidth"]
        [::std::mem::offset_of!(tagMINIMIZEDMETRICS, iWidth) - 4usize];
    ["Offset of field: tagMINIMIZEDMETRICS::iHorzGap"]
        [::std::mem::offset_of!(tagMINIMIZEDMETRICS, iHorzGap) - 8usize];
    ["Offset of field: tagMINIMIZEDMETRICS::iVertGap"]
        [::std::mem::offset_of!(tagMINIMIZEDMETRICS, iVertGap) - 12usize];
    ["Offset of field: tagMINIMIZEDMETRICS::iArrange"]
        [::std::mem::offset_of!(tagMINIMIZEDMETRICS, iArrange) - 16usize];
};
pub type MINIMIZEDMETRICS = tagMINIMIZEDMETRICS;
pub type PMINIMIZEDMETRICS = *mut tagMINIMIZEDMETRICS;
pub type LPMINIMIZEDMETRICS = *mut tagMINIMIZEDMETRICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagICONMETRICSA {
    pub cbSize: UINT,
    pub iHorzSpacing: ::std::os::raw::c_int,
    pub iVertSpacing: ::std::os::raw::c_int,
    pub iTitleWrap: ::std::os::raw::c_int,
    pub lfFont: LOGFONTA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagICONMETRICSA"][::std::mem::size_of::<tagICONMETRICSA>() - 76usize];
    ["Alignment of tagICONMETRICSA"][::std::mem::align_of::<tagICONMETRICSA>() - 4usize];
    ["Offset of field: tagICONMETRICSA::cbSize"]
        [::std::mem::offset_of!(tagICONMETRICSA, cbSize) - 0usize];
    ["Offset of field: tagICONMETRICSA::iHorzSpacing"]
        [::std::mem::offset_of!(tagICONMETRICSA, iHorzSpacing) - 4usize];
    ["Offset of field: tagICONMETRICSA::iVertSpacing"]
        [::std::mem::offset_of!(tagICONMETRICSA, iVertSpacing) - 8usize];
    ["Offset of field: tagICONMETRICSA::iTitleWrap"]
        [::std::mem::offset_of!(tagICONMETRICSA, iTitleWrap) - 12usize];
    ["Offset of field: tagICONMETRICSA::lfFont"]
        [::std::mem::offset_of!(tagICONMETRICSA, lfFont) - 16usize];
};
pub type ICONMETRICSA = tagICONMETRICSA;
pub type PICONMETRICSA = *mut tagICONMETRICSA;
pub type LPICONMETRICSA = *mut tagICONMETRICSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagICONMETRICSW {
    pub cbSize: UINT,
    pub iHorzSpacing: ::std::os::raw::c_int,
    pub iVertSpacing: ::std::os::raw::c_int,
    pub iTitleWrap: ::std::os::raw::c_int,
    pub lfFont: LOGFONTW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagICONMETRICSW"][::std::mem::size_of::<tagICONMETRICSW>() - 108usize];
    ["Alignment of tagICONMETRICSW"][::std::mem::align_of::<tagICONMETRICSW>() - 4usize];
    ["Offset of field: tagICONMETRICSW::cbSize"]
        [::std::mem::offset_of!(tagICONMETRICSW, cbSize) - 0usize];
    ["Offset of field: tagICONMETRICSW::iHorzSpacing"]
        [::std::mem::offset_of!(tagICONMETRICSW, iHorzSpacing) - 4usize];
    ["Offset of field: tagICONMETRICSW::iVertSpacing"]
        [::std::mem::offset_of!(tagICONMETRICSW, iVertSpacing) - 8usize];
    ["Offset of field: tagICONMETRICSW::iTitleWrap"]
        [::std::mem::offset_of!(tagICONMETRICSW, iTitleWrap) - 12usize];
    ["Offset of field: tagICONMETRICSW::lfFont"]
        [::std::mem::offset_of!(tagICONMETRICSW, lfFont) - 16usize];
};
pub type ICONMETRICSW = tagICONMETRICSW;
pub type PICONMETRICSW = *mut tagICONMETRICSW;
pub type LPICONMETRICSW = *mut tagICONMETRICSW;
pub type ICONMETRICS = ICONMETRICSA;
pub type PICONMETRICS = PICONMETRICSA;
pub type LPICONMETRICS = LPICONMETRICSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagANIMATIONINFO {
    pub cbSize: UINT,
    pub iMinAnimate: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagANIMATIONINFO"][::std::mem::size_of::<tagANIMATIONINFO>() - 8usize];
    ["Alignment of tagANIMATIONINFO"][::std::mem::align_of::<tagANIMATIONINFO>() - 4usize];
    ["Offset of field: tagANIMATIONINFO::cbSize"]
        [::std::mem::offset_of!(tagANIMATIONINFO, cbSize) - 0usize];
    ["Offset of field: tagANIMATIONINFO::iMinAnimate"]
        [::std::mem::offset_of!(tagANIMATIONINFO, iMinAnimate) - 4usize];
};
pub type ANIMATIONINFO = tagANIMATIONINFO;
pub type LPANIMATIONINFO = *mut tagANIMATIONINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSERIALKEYSA {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub lpszActivePort: LPSTR,
    pub lpszPort: LPSTR,
    pub iBaudRate: UINT,
    pub iPortState: UINT,
    pub iActive: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSERIALKEYSA"][::std::mem::size_of::<tagSERIALKEYSA>() - 40usize];
    ["Alignment of tagSERIALKEYSA"][::std::mem::align_of::<tagSERIALKEYSA>() - 8usize];
    ["Offset of field: tagSERIALKEYSA::cbSize"]
        [::std::mem::offset_of!(tagSERIALKEYSA, cbSize) - 0usize];
    ["Offset of field: tagSERIALKEYSA::dwFlags"]
        [::std::mem::offset_of!(tagSERIALKEYSA, dwFlags) - 4usize];
    ["Offset of field: tagSERIALKEYSA::lpszActivePort"]
        [::std::mem::offset_of!(tagSERIALKEYSA, lpszActivePort) - 8usize];
    ["Offset of field: tagSERIALKEYSA::lpszPort"]
        [::std::mem::offset_of!(tagSERIALKEYSA, lpszPort) - 16usize];
    ["Offset of field: tagSERIALKEYSA::iBaudRate"]
        [::std::mem::offset_of!(tagSERIALKEYSA, iBaudRate) - 24usize];
    ["Offset of field: tagSERIALKEYSA::iPortState"]
        [::std::mem::offset_of!(tagSERIALKEYSA, iPortState) - 28usize];
    ["Offset of field: tagSERIALKEYSA::iActive"]
        [::std::mem::offset_of!(tagSERIALKEYSA, iActive) - 32usize];
};
pub type SERIALKEYSA = tagSERIALKEYSA;
pub type LPSERIALKEYSA = *mut tagSERIALKEYSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSERIALKEYSW {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub lpszActivePort: LPWSTR,
    pub lpszPort: LPWSTR,
    pub iBaudRate: UINT,
    pub iPortState: UINT,
    pub iActive: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSERIALKEYSW"][::std::mem::size_of::<tagSERIALKEYSW>() - 40usize];
    ["Alignment of tagSERIALKEYSW"][::std::mem::align_of::<tagSERIALKEYSW>() - 8usize];
    ["Offset of field: tagSERIALKEYSW::cbSize"]
        [::std::mem::offset_of!(tagSERIALKEYSW, cbSize) - 0usize];
    ["Offset of field: tagSERIALKEYSW::dwFlags"]
        [::std::mem::offset_of!(tagSERIALKEYSW, dwFlags) - 4usize];
    ["Offset of field: tagSERIALKEYSW::lpszActivePort"]
        [::std::mem::offset_of!(tagSERIALKEYSW, lpszActivePort) - 8usize];
    ["Offset of field: tagSERIALKEYSW::lpszPort"]
        [::std::mem::offset_of!(tagSERIALKEYSW, lpszPort) - 16usize];
    ["Offset of field: tagSERIALKEYSW::iBaudRate"]
        [::std::mem::offset_of!(tagSERIALKEYSW, iBaudRate) - 24usize];
    ["Offset of field: tagSERIALKEYSW::iPortState"]
        [::std::mem::offset_of!(tagSERIALKEYSW, iPortState) - 28usize];
    ["Offset of field: tagSERIALKEYSW::iActive"]
        [::std::mem::offset_of!(tagSERIALKEYSW, iActive) - 32usize];
};
pub type SERIALKEYSW = tagSERIALKEYSW;
pub type LPSERIALKEYSW = *mut tagSERIALKEYSW;
pub type SERIALKEYS = SERIALKEYSA;
pub type LPSERIALKEYS = LPSERIALKEYSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHIGHCONTRASTA {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub lpszDefaultScheme: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHIGHCONTRASTA"][::std::mem::size_of::<tagHIGHCONTRASTA>() - 16usize];
    ["Alignment of tagHIGHCONTRASTA"][::std::mem::align_of::<tagHIGHCONTRASTA>() - 8usize];
    ["Offset of field: tagHIGHCONTRASTA::cbSize"]
        [::std::mem::offset_of!(tagHIGHCONTRASTA, cbSize) - 0usize];
    ["Offset of field: tagHIGHCONTRASTA::dwFlags"]
        [::std::mem::offset_of!(tagHIGHCONTRASTA, dwFlags) - 4usize];
    ["Offset of field: tagHIGHCONTRASTA::lpszDefaultScheme"]
        [::std::mem::offset_of!(tagHIGHCONTRASTA, lpszDefaultScheme) - 8usize];
};
pub type HIGHCONTRASTA = tagHIGHCONTRASTA;
pub type LPHIGHCONTRASTA = *mut tagHIGHCONTRASTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHIGHCONTRASTW {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub lpszDefaultScheme: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHIGHCONTRASTW"][::std::mem::size_of::<tagHIGHCONTRASTW>() - 16usize];
    ["Alignment of tagHIGHCONTRASTW"][::std::mem::align_of::<tagHIGHCONTRASTW>() - 8usize];
    ["Offset of field: tagHIGHCONTRASTW::cbSize"]
        [::std::mem::offset_of!(tagHIGHCONTRASTW, cbSize) - 0usize];
    ["Offset of field: tagHIGHCONTRASTW::dwFlags"]
        [::std::mem::offset_of!(tagHIGHCONTRASTW, dwFlags) - 4usize];
    ["Offset of field: tagHIGHCONTRASTW::lpszDefaultScheme"]
        [::std::mem::offset_of!(tagHIGHCONTRASTW, lpszDefaultScheme) - 8usize];
};
pub type HIGHCONTRASTW = tagHIGHCONTRASTW;
pub type LPHIGHCONTRASTW = *mut tagHIGHCONTRASTW;
pub type HIGHCONTRAST = HIGHCONTRASTA;
pub type LPHIGHCONTRAST = LPHIGHCONTRASTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIDEOPARAMETERS {
    pub Guid: GUID,
    pub dwOffset: ULONG,
    pub dwCommand: ULONG,
    pub dwFlags: ULONG,
    pub dwMode: ULONG,
    pub dwTVStandard: ULONG,
    pub dwAvailableModes: ULONG,
    pub dwAvailableTVStandard: ULONG,
    pub dwFlickerFilter: ULONG,
    pub dwOverScanX: ULONG,
    pub dwOverScanY: ULONG,
    pub dwMaxUnscaledX: ULONG,
    pub dwMaxUnscaledY: ULONG,
    pub dwPositionX: ULONG,
    pub dwPositionY: ULONG,
    pub dwBrightness: ULONG,
    pub dwContrast: ULONG,
    pub dwCPType: ULONG,
    pub dwCPCommand: ULONG,
    pub dwCPStandard: ULONG,
    pub dwCPKey: ULONG,
    pub bCP_APSTriggerBits: ULONG,
    pub bOEMCopyProtection: [UCHAR; 256usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIDEOPARAMETERS"][::std::mem::size_of::<_VIDEOPARAMETERS>() - 356usize];
    ["Alignment of _VIDEOPARAMETERS"][::std::mem::align_of::<_VIDEOPARAMETERS>() - 4usize];
    ["Offset of field: _VIDEOPARAMETERS::Guid"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, Guid) - 0usize];
    ["Offset of field: _VIDEOPARAMETERS::dwOffset"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwOffset) - 16usize];
    ["Offset of field: _VIDEOPARAMETERS::dwCommand"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwCommand) - 20usize];
    ["Offset of field: _VIDEOPARAMETERS::dwFlags"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwFlags) - 24usize];
    ["Offset of field: _VIDEOPARAMETERS::dwMode"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwMode) - 28usize];
    ["Offset of field: _VIDEOPARAMETERS::dwTVStandard"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwTVStandard) - 32usize];
    ["Offset of field: _VIDEOPARAMETERS::dwAvailableModes"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwAvailableModes) - 36usize];
    ["Offset of field: _VIDEOPARAMETERS::dwAvailableTVStandard"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwAvailableTVStandard) - 40usize];
    ["Offset of field: _VIDEOPARAMETERS::dwFlickerFilter"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwFlickerFilter) - 44usize];
    ["Offset of field: _VIDEOPARAMETERS::dwOverScanX"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwOverScanX) - 48usize];
    ["Offset of field: _VIDEOPARAMETERS::dwOverScanY"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwOverScanY) - 52usize];
    ["Offset of field: _VIDEOPARAMETERS::dwMaxUnscaledX"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwMaxUnscaledX) - 56usize];
    ["Offset of field: _VIDEOPARAMETERS::dwMaxUnscaledY"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwMaxUnscaledY) - 60usize];
    ["Offset of field: _VIDEOPARAMETERS::dwPositionX"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwPositionX) - 64usize];
    ["Offset of field: _VIDEOPARAMETERS::dwPositionY"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwPositionY) - 68usize];
    ["Offset of field: _VIDEOPARAMETERS::dwBrightness"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwBrightness) - 72usize];
    ["Offset of field: _VIDEOPARAMETERS::dwContrast"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwContrast) - 76usize];
    ["Offset of field: _VIDEOPARAMETERS::dwCPType"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwCPType) - 80usize];
    ["Offset of field: _VIDEOPARAMETERS::dwCPCommand"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwCPCommand) - 84usize];
    ["Offset of field: _VIDEOPARAMETERS::dwCPStandard"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwCPStandard) - 88usize];
    ["Offset of field: _VIDEOPARAMETERS::dwCPKey"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, dwCPKey) - 92usize];
    ["Offset of field: _VIDEOPARAMETERS::bCP_APSTriggerBits"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, bCP_APSTriggerBits) - 96usize];
    ["Offset of field: _VIDEOPARAMETERS::bOEMCopyProtection"]
        [::std::mem::offset_of!(_VIDEOPARAMETERS, bOEMCopyProtection) - 100usize];
};
pub type VIDEOPARAMETERS = _VIDEOPARAMETERS;
pub type PVIDEOPARAMETERS = *mut _VIDEOPARAMETERS;
pub type LPVIDEOPARAMETERS = *mut _VIDEOPARAMETERS;
unsafe extern "C" {
    pub fn ChangeDisplaySettingsA(lpDevMode: *mut DEVMODEA, dwFlags: DWORD) -> LONG;
}
unsafe extern "C" {
    pub fn ChangeDisplaySettingsW(lpDevMode: *mut DEVMODEW, dwFlags: DWORD) -> LONG;
}
unsafe extern "C" {
    pub fn ChangeDisplaySettingsExA(
        lpszDeviceName: LPCSTR,
        lpDevMode: *mut DEVMODEA,
        hwnd: HWND,
        dwflags: DWORD,
        lParam: LPVOID,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn ChangeDisplaySettingsExW(
        lpszDeviceName: LPCWSTR,
        lpDevMode: *mut DEVMODEW,
        hwnd: HWND,
        dwflags: DWORD,
        lParam: LPVOID,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn EnumDisplaySettingsA(
        lpszDeviceName: LPCSTR,
        iModeNum: DWORD,
        lpDevMode: *mut DEVMODEA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDisplaySettingsW(
        lpszDeviceName: LPCWSTR,
        iModeNum: DWORD,
        lpDevMode: *mut DEVMODEW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDisplaySettingsExA(
        lpszDeviceName: LPCSTR,
        iModeNum: DWORD,
        lpDevMode: *mut DEVMODEA,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDisplaySettingsExW(
        lpszDeviceName: LPCWSTR,
        iModeNum: DWORD,
        lpDevMode: *mut DEVMODEW,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDisplayDevicesA(
        lpDevice: LPCSTR,
        iDevNum: DWORD,
        lpDisplayDevice: PDISPLAY_DEVICEA,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDisplayDevicesW(
        lpDevice: LPCWSTR,
        iDevNum: DWORD,
        lpDisplayDevice: PDISPLAY_DEVICEW,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDisplayConfigBufferSizes(
        flags: UINT32,
        numPathArrayElements: *mut UINT32,
        numModeInfoArrayElements: *mut UINT32,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SetDisplayConfig(
        numPathArrayElements: UINT32,
        pathArray: *mut DISPLAYCONFIG_PATH_INFO,
        numModeInfoArrayElements: UINT32,
        modeInfoArray: *mut DISPLAYCONFIG_MODE_INFO,
        flags: UINT32,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn QueryDisplayConfig(
        flags: UINT32,
        numPathArrayElements: *mut UINT32,
        pathArray: *mut DISPLAYCONFIG_PATH_INFO,
        numModeInfoArrayElements: *mut UINT32,
        modeInfoArray: *mut DISPLAYCONFIG_MODE_INFO,
        currentTopologyId: *mut DISPLAYCONFIG_TOPOLOGY_ID,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn DisplayConfigGetDeviceInfo(requestPacket: *mut DISPLAYCONFIG_DEVICE_INFO_HEADER)
        -> LONG;
}
unsafe extern "C" {
    pub fn DisplayConfigSetDeviceInfo(setPacket: *mut DISPLAYCONFIG_DEVICE_INFO_HEADER) -> LONG;
}
unsafe extern "C" {
    pub fn SystemParametersInfoA(
        uiAction: UINT,
        uiParam: UINT,
        pvParam: PVOID,
        fWinIni: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SystemParametersInfoW(
        uiAction: UINT,
        uiParam: UINT,
        pvParam: PVOID,
        fWinIni: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SystemParametersInfoForDpi(
        uiAction: UINT,
        uiParam: UINT,
        pvParam: PVOID,
        fWinIni: UINT,
        dpi: UINT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagFILTERKEYS {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub iWaitMSec: DWORD,
    pub iDelayMSec: DWORD,
    pub iRepeatMSec: DWORD,
    pub iBounceMSec: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFILTERKEYS"][::std::mem::size_of::<tagFILTERKEYS>() - 24usize];
    ["Alignment of tagFILTERKEYS"][::std::mem::align_of::<tagFILTERKEYS>() - 4usize];
    ["Offset of field: tagFILTERKEYS::cbSize"]
        [::std::mem::offset_of!(tagFILTERKEYS, cbSize) - 0usize];
    ["Offset of field: tagFILTERKEYS::dwFlags"]
        [::std::mem::offset_of!(tagFILTERKEYS, dwFlags) - 4usize];
    ["Offset of field: tagFILTERKEYS::iWaitMSec"]
        [::std::mem::offset_of!(tagFILTERKEYS, iWaitMSec) - 8usize];
    ["Offset of field: tagFILTERKEYS::iDelayMSec"]
        [::std::mem::offset_of!(tagFILTERKEYS, iDelayMSec) - 12usize];
    ["Offset of field: tagFILTERKEYS::iRepeatMSec"]
        [::std::mem::offset_of!(tagFILTERKEYS, iRepeatMSec) - 16usize];
    ["Offset of field: tagFILTERKEYS::iBounceMSec"]
        [::std::mem::offset_of!(tagFILTERKEYS, iBounceMSec) - 20usize];
};
pub type FILTERKEYS = tagFILTERKEYS;
pub type LPFILTERKEYS = *mut tagFILTERKEYS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTICKYKEYS {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTICKYKEYS"][::std::mem::size_of::<tagSTICKYKEYS>() - 8usize];
    ["Alignment of tagSTICKYKEYS"][::std::mem::align_of::<tagSTICKYKEYS>() - 4usize];
    ["Offset of field: tagSTICKYKEYS::cbSize"]
        [::std::mem::offset_of!(tagSTICKYKEYS, cbSize) - 0usize];
    ["Offset of field: tagSTICKYKEYS::dwFlags"]
        [::std::mem::offset_of!(tagSTICKYKEYS, dwFlags) - 4usize];
};
pub type STICKYKEYS = tagSTICKYKEYS;
pub type LPSTICKYKEYS = *mut tagSTICKYKEYS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMOUSEKEYS {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub iMaxSpeed: DWORD,
    pub iTimeToMaxSpeed: DWORD,
    pub iCtrlSpeed: DWORD,
    pub dwReserved1: DWORD,
    pub dwReserved2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMOUSEKEYS"][::std::mem::size_of::<tagMOUSEKEYS>() - 28usize];
    ["Alignment of tagMOUSEKEYS"][::std::mem::align_of::<tagMOUSEKEYS>() - 4usize];
    ["Offset of field: tagMOUSEKEYS::cbSize"]
        [::std::mem::offset_of!(tagMOUSEKEYS, cbSize) - 0usize];
    ["Offset of field: tagMOUSEKEYS::dwFlags"]
        [::std::mem::offset_of!(tagMOUSEKEYS, dwFlags) - 4usize];
    ["Offset of field: tagMOUSEKEYS::iMaxSpeed"]
        [::std::mem::offset_of!(tagMOUSEKEYS, iMaxSpeed) - 8usize];
    ["Offset of field: tagMOUSEKEYS::iTimeToMaxSpeed"]
        [::std::mem::offset_of!(tagMOUSEKEYS, iTimeToMaxSpeed) - 12usize];
    ["Offset of field: tagMOUSEKEYS::iCtrlSpeed"]
        [::std::mem::offset_of!(tagMOUSEKEYS, iCtrlSpeed) - 16usize];
    ["Offset of field: tagMOUSEKEYS::dwReserved1"]
        [::std::mem::offset_of!(tagMOUSEKEYS, dwReserved1) - 20usize];
    ["Offset of field: tagMOUSEKEYS::dwReserved2"]
        [::std::mem::offset_of!(tagMOUSEKEYS, dwReserved2) - 24usize];
};
pub type MOUSEKEYS = tagMOUSEKEYS;
pub type LPMOUSEKEYS = *mut tagMOUSEKEYS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagACCESSTIMEOUT {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub iTimeOutMSec: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagACCESSTIMEOUT"][::std::mem::size_of::<tagACCESSTIMEOUT>() - 12usize];
    ["Alignment of tagACCESSTIMEOUT"][::std::mem::align_of::<tagACCESSTIMEOUT>() - 4usize];
    ["Offset of field: tagACCESSTIMEOUT::cbSize"]
        [::std::mem::offset_of!(tagACCESSTIMEOUT, cbSize) - 0usize];
    ["Offset of field: tagACCESSTIMEOUT::dwFlags"]
        [::std::mem::offset_of!(tagACCESSTIMEOUT, dwFlags) - 4usize];
    ["Offset of field: tagACCESSTIMEOUT::iTimeOutMSec"]
        [::std::mem::offset_of!(tagACCESSTIMEOUT, iTimeOutMSec) - 8usize];
};
pub type ACCESSTIMEOUT = tagACCESSTIMEOUT;
pub type LPACCESSTIMEOUT = *mut tagACCESSTIMEOUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSOUNDSENTRYA {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub iFSTextEffect: DWORD,
    pub iFSTextEffectMSec: DWORD,
    pub iFSTextEffectColorBits: DWORD,
    pub iFSGrafEffect: DWORD,
    pub iFSGrafEffectMSec: DWORD,
    pub iFSGrafEffectColor: DWORD,
    pub iWindowsEffect: DWORD,
    pub iWindowsEffectMSec: DWORD,
    pub lpszWindowsEffectDLL: LPSTR,
    pub iWindowsEffectOrdinal: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSOUNDSENTRYA"][::std::mem::size_of::<tagSOUNDSENTRYA>() - 56usize];
    ["Alignment of tagSOUNDSENTRYA"][::std::mem::align_of::<tagSOUNDSENTRYA>() - 8usize];
    ["Offset of field: tagSOUNDSENTRYA::cbSize"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, cbSize) - 0usize];
    ["Offset of field: tagSOUNDSENTRYA::dwFlags"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, dwFlags) - 4usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSTextEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSTextEffect) - 8usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSTextEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSTextEffectMSec) - 12usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSTextEffectColorBits"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSTextEffectColorBits) - 16usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSGrafEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSGrafEffect) - 20usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSGrafEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSGrafEffectMSec) - 24usize];
    ["Offset of field: tagSOUNDSENTRYA::iFSGrafEffectColor"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iFSGrafEffectColor) - 28usize];
    ["Offset of field: tagSOUNDSENTRYA::iWindowsEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iWindowsEffect) - 32usize];
    ["Offset of field: tagSOUNDSENTRYA::iWindowsEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iWindowsEffectMSec) - 36usize];
    ["Offset of field: tagSOUNDSENTRYA::lpszWindowsEffectDLL"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, lpszWindowsEffectDLL) - 40usize];
    ["Offset of field: tagSOUNDSENTRYA::iWindowsEffectOrdinal"]
        [::std::mem::offset_of!(tagSOUNDSENTRYA, iWindowsEffectOrdinal) - 48usize];
};
pub type SOUNDSENTRYA = tagSOUNDSENTRYA;
pub type LPSOUNDSENTRYA = *mut tagSOUNDSENTRYA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSOUNDSENTRYW {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub iFSTextEffect: DWORD,
    pub iFSTextEffectMSec: DWORD,
    pub iFSTextEffectColorBits: DWORD,
    pub iFSGrafEffect: DWORD,
    pub iFSGrafEffectMSec: DWORD,
    pub iFSGrafEffectColor: DWORD,
    pub iWindowsEffect: DWORD,
    pub iWindowsEffectMSec: DWORD,
    pub lpszWindowsEffectDLL: LPWSTR,
    pub iWindowsEffectOrdinal: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSOUNDSENTRYW"][::std::mem::size_of::<tagSOUNDSENTRYW>() - 56usize];
    ["Alignment of tagSOUNDSENTRYW"][::std::mem::align_of::<tagSOUNDSENTRYW>() - 8usize];
    ["Offset of field: tagSOUNDSENTRYW::cbSize"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, cbSize) - 0usize];
    ["Offset of field: tagSOUNDSENTRYW::dwFlags"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, dwFlags) - 4usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSTextEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSTextEffect) - 8usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSTextEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSTextEffectMSec) - 12usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSTextEffectColorBits"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSTextEffectColorBits) - 16usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSGrafEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSGrafEffect) - 20usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSGrafEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSGrafEffectMSec) - 24usize];
    ["Offset of field: tagSOUNDSENTRYW::iFSGrafEffectColor"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iFSGrafEffectColor) - 28usize];
    ["Offset of field: tagSOUNDSENTRYW::iWindowsEffect"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iWindowsEffect) - 32usize];
    ["Offset of field: tagSOUNDSENTRYW::iWindowsEffectMSec"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iWindowsEffectMSec) - 36usize];
    ["Offset of field: tagSOUNDSENTRYW::lpszWindowsEffectDLL"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, lpszWindowsEffectDLL) - 40usize];
    ["Offset of field: tagSOUNDSENTRYW::iWindowsEffectOrdinal"]
        [::std::mem::offset_of!(tagSOUNDSENTRYW, iWindowsEffectOrdinal) - 48usize];
};
pub type SOUNDSENTRYW = tagSOUNDSENTRYW;
pub type LPSOUNDSENTRYW = *mut tagSOUNDSENTRYW;
pub type SOUNDSENTRY = SOUNDSENTRYA;
pub type LPSOUNDSENTRY = LPSOUNDSENTRYA;
unsafe extern "C" {
    pub fn SoundSentry() -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTOGGLEKEYS {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTOGGLEKEYS"][::std::mem::size_of::<tagTOGGLEKEYS>() - 8usize];
    ["Alignment of tagTOGGLEKEYS"][::std::mem::align_of::<tagTOGGLEKEYS>() - 4usize];
    ["Offset of field: tagTOGGLEKEYS::cbSize"]
        [::std::mem::offset_of!(tagTOGGLEKEYS, cbSize) - 0usize];
    ["Offset of field: tagTOGGLEKEYS::dwFlags"]
        [::std::mem::offset_of!(tagTOGGLEKEYS, dwFlags) - 4usize];
};
pub type TOGGLEKEYS = tagTOGGLEKEYS;
pub type LPTOGGLEKEYS = *mut tagTOGGLEKEYS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagAUDIODESCRIPTION {
    pub cbSize: UINT,
    pub Enabled: BOOL,
    pub Locale: LCID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAUDIODESCRIPTION"][::std::mem::size_of::<tagAUDIODESCRIPTION>() - 12usize];
    ["Alignment of tagAUDIODESCRIPTION"][::std::mem::align_of::<tagAUDIODESCRIPTION>() - 4usize];
    ["Offset of field: tagAUDIODESCRIPTION::cbSize"]
        [::std::mem::offset_of!(tagAUDIODESCRIPTION, cbSize) - 0usize];
    ["Offset of field: tagAUDIODESCRIPTION::Enabled"]
        [::std::mem::offset_of!(tagAUDIODESCRIPTION, Enabled) - 4usize];
    ["Offset of field: tagAUDIODESCRIPTION::Locale"]
        [::std::mem::offset_of!(tagAUDIODESCRIPTION, Locale) - 8usize];
};
pub type AUDIODESCRIPTION = tagAUDIODESCRIPTION;
pub type LPAUDIODESCRIPTION = *mut tagAUDIODESCRIPTION;
unsafe extern "C" {
    pub fn SetDebugErrorLevel(dwLevel: DWORD);
}
unsafe extern "C" {
    pub fn SetLastErrorEx(dwErrCode: DWORD, dwType: DWORD);
}
unsafe extern "C" {
    pub fn InternalGetWindowText(
        hWnd: HWND,
        pString: LPWSTR,
        cchMaxCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CancelShutdown() -> BOOL;
}
unsafe extern "C" {
    pub fn MonitorFromPoint(pt: POINT, dwFlags: DWORD) -> HMONITOR;
}
unsafe extern "C" {
    pub fn MonitorFromRect(lprc: LPCRECT, dwFlags: DWORD) -> HMONITOR;
}
unsafe extern "C" {
    pub fn MonitorFromWindow(hwnd: HWND, dwFlags: DWORD) -> HMONITOR;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONITORINFO {
    pub cbSize: DWORD,
    pub rcMonitor: RECT,
    pub rcWork: RECT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONITORINFO"][::std::mem::size_of::<tagMONITORINFO>() - 40usize];
    ["Alignment of tagMONITORINFO"][::std::mem::align_of::<tagMONITORINFO>() - 4usize];
    ["Offset of field: tagMONITORINFO::cbSize"]
        [::std::mem::offset_of!(tagMONITORINFO, cbSize) - 0usize];
    ["Offset of field: tagMONITORINFO::rcMonitor"]
        [::std::mem::offset_of!(tagMONITORINFO, rcMonitor) - 4usize];
    ["Offset of field: tagMONITORINFO::rcWork"]
        [::std::mem::offset_of!(tagMONITORINFO, rcWork) - 20usize];
    ["Offset of field: tagMONITORINFO::dwFlags"]
        [::std::mem::offset_of!(tagMONITORINFO, dwFlags) - 36usize];
};
pub type MONITORINFO = tagMONITORINFO;
pub type LPMONITORINFO = *mut tagMONITORINFO;
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct tagMONITORINFOEXA {
    pub __bindgen_padding_0: [u8; 40usize],
    pub szDevice: [CHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONITORINFOEXA"][::std::mem::size_of::<tagMONITORINFOEXA>() - 72usize];
    ["Alignment of tagMONITORINFOEXA"][::std::mem::align_of::<tagMONITORINFOEXA>() - 4usize];
    ["Offset of field: tagMONITORINFOEXA::szDevice"]
        [::std::mem::offset_of!(tagMONITORINFOEXA, szDevice) - 40usize];
};
pub type MONITORINFOEXA = tagMONITORINFOEXA;
pub type LPMONITORINFOEXA = *mut tagMONITORINFOEXA;
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct tagMONITORINFOEXW {
    pub __bindgen_padding_0: [u16; 20usize],
    pub szDevice: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONITORINFOEXW"][::std::mem::size_of::<tagMONITORINFOEXW>() - 104usize];
    ["Alignment of tagMONITORINFOEXW"][::std::mem::align_of::<tagMONITORINFOEXW>() - 4usize];
    ["Offset of field: tagMONITORINFOEXW::szDevice"]
        [::std::mem::offset_of!(tagMONITORINFOEXW, szDevice) - 40usize];
};
pub type MONITORINFOEXW = tagMONITORINFOEXW;
pub type LPMONITORINFOEXW = *mut tagMONITORINFOEXW;
pub type MONITORINFOEX = MONITORINFOEXA;
pub type LPMONITORINFOEX = LPMONITORINFOEXA;
unsafe extern "C" {
    pub fn GetMonitorInfoA(hMonitor: HMONITOR, lpmi: LPMONITORINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetMonitorInfoW(hMonitor: HMONITOR, lpmi: LPMONITORINFO) -> BOOL;
}
pub type MONITORENUMPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HMONITOR, arg2: HDC, arg3: LPRECT, arg4: LPARAM) -> BOOL,
>;
unsafe extern "C" {
    pub fn EnumDisplayMonitors(
        hdc: HDC,
        lprcClip: LPCRECT,
        lpfnEnum: MONITORENUMPROC,
        dwData: LPARAM,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn NotifyWinEvent(event: DWORD, hwnd: HWND, idObject: LONG, idChild: LONG);
}
pub type WINEVENTPROC = ::std::option::Option<
    unsafe extern "C" fn(
        hWinEventHook: HWINEVENTHOOK,
        event: DWORD,
        hwnd: HWND,
        idObject: LONG,
        idChild: LONG,
        idEventThread: DWORD,
        dwmsEventTime: DWORD,
    ),
>;
unsafe extern "C" {
    pub fn SetWinEventHook(
        eventMin: DWORD,
        eventMax: DWORD,
        hmodWinEventProc: HMODULE,
        pfnWinEventProc: WINEVENTPROC,
        idProcess: DWORD,
        idThread: DWORD,
        dwFlags: DWORD,
    ) -> HWINEVENTHOOK;
}
unsafe extern "C" {
    pub fn IsWinEventHookInstalled(event: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn UnhookWinEvent(hWinEventHook: HWINEVENTHOOK) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGUITHREADINFO {
    pub cbSize: DWORD,
    pub flags: DWORD,
    pub hwndActive: HWND,
    pub hwndFocus: HWND,
    pub hwndCapture: HWND,
    pub hwndMenuOwner: HWND,
    pub hwndMoveSize: HWND,
    pub hwndCaret: HWND,
    pub rcCaret: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGUITHREADINFO"][::std::mem::size_of::<tagGUITHREADINFO>() - 72usize];
    ["Alignment of tagGUITHREADINFO"][::std::mem::align_of::<tagGUITHREADINFO>() - 8usize];
    ["Offset of field: tagGUITHREADINFO::cbSize"]
        [::std::mem::offset_of!(tagGUITHREADINFO, cbSize) - 0usize];
    ["Offset of field: tagGUITHREADINFO::flags"]
        [::std::mem::offset_of!(tagGUITHREADINFO, flags) - 4usize];
    ["Offset of field: tagGUITHREADINFO::hwndActive"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndActive) - 8usize];
    ["Offset of field: tagGUITHREADINFO::hwndFocus"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndFocus) - 16usize];
    ["Offset of field: tagGUITHREADINFO::hwndCapture"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndCapture) - 24usize];
    ["Offset of field: tagGUITHREADINFO::hwndMenuOwner"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndMenuOwner) - 32usize];
    ["Offset of field: tagGUITHREADINFO::hwndMoveSize"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndMoveSize) - 40usize];
    ["Offset of field: tagGUITHREADINFO::hwndCaret"]
        [::std::mem::offset_of!(tagGUITHREADINFO, hwndCaret) - 48usize];
    ["Offset of field: tagGUITHREADINFO::rcCaret"]
        [::std::mem::offset_of!(tagGUITHREADINFO, rcCaret) - 56usize];
};
pub type GUITHREADINFO = tagGUITHREADINFO;
pub type PGUITHREADINFO = *mut tagGUITHREADINFO;
pub type LPGUITHREADINFO = *mut tagGUITHREADINFO;
unsafe extern "C" {
    pub fn GetGUIThreadInfo(idThread: DWORD, pgui: PGUITHREADINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn BlockInput(fBlockIt: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDPIAware() -> BOOL;
}
unsafe extern "C" {
    pub fn IsProcessDPIAware() -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadDpiAwarenessContext(dpiContext: DPI_AWARENESS_CONTEXT)
        -> DPI_AWARENESS_CONTEXT;
}
unsafe extern "C" {
    pub fn GetThreadDpiAwarenessContext() -> DPI_AWARENESS_CONTEXT;
}
unsafe extern "C" {
    pub fn GetWindowDpiAwarenessContext(hwnd: HWND) -> DPI_AWARENESS_CONTEXT;
}
unsafe extern "C" {
    pub fn GetAwarenessFromDpiAwarenessContext(value: DPI_AWARENESS_CONTEXT) -> DPI_AWARENESS;
}
unsafe extern "C" {
    pub fn GetDpiFromDpiAwarenessContext(value: DPI_AWARENESS_CONTEXT) -> UINT;
}
unsafe extern "C" {
    pub fn AreDpiAwarenessContextsEqual(
        dpiContextA: DPI_AWARENESS_CONTEXT,
        dpiContextB: DPI_AWARENESS_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidDpiAwarenessContext(value: DPI_AWARENESS_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDpiForWindow(hwnd: HWND) -> UINT;
}
unsafe extern "C" {
    pub fn GetDpiForSystem() -> UINT;
}
unsafe extern "C" {
    pub fn GetSystemDpiForProcess(hProcess: HANDLE) -> UINT;
}
unsafe extern "C" {
    pub fn EnableNonClientDpiScaling(hwnd: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn InheritWindowMonitor(hwnd: HWND, hwndInherit: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessDpiAwarenessContext(value: DPI_AWARENESS_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDpiAwarenessContextForProcess(hProcess: HANDLE) -> DPI_AWARENESS_CONTEXT;
}
unsafe extern "C" {
    pub fn SetThreadDpiHostingBehavior(value: DPI_HOSTING_BEHAVIOR) -> DPI_HOSTING_BEHAVIOR;
}
unsafe extern "C" {
    pub fn GetThreadDpiHostingBehavior() -> DPI_HOSTING_BEHAVIOR;
}
unsafe extern "C" {
    pub fn GetWindowDpiHostingBehavior(hwnd: HWND) -> DPI_HOSTING_BEHAVIOR;
}
unsafe extern "C" {
    pub fn GetWindowModuleFileNameA(hwnd: HWND, pszFileName: LPSTR, cchFileNameMax: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn GetWindowModuleFileNameW(hwnd: HWND, pszFileName: LPWSTR, cchFileNameMax: UINT) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCURSORINFO {
    pub cbSize: DWORD,
    pub flags: DWORD,
    pub hCursor: HCURSOR,
    pub ptScreenPos: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCURSORINFO"][::std::mem::size_of::<tagCURSORINFO>() - 24usize];
    ["Alignment of tagCURSORINFO"][::std::mem::align_of::<tagCURSORINFO>() - 8usize];
    ["Offset of field: tagCURSORINFO::cbSize"]
        [::std::mem::offset_of!(tagCURSORINFO, cbSize) - 0usize];
    ["Offset of field: tagCURSORINFO::flags"]
        [::std::mem::offset_of!(tagCURSORINFO, flags) - 4usize];
    ["Offset of field: tagCURSORINFO::hCursor"]
        [::std::mem::offset_of!(tagCURSORINFO, hCursor) - 8usize];
    ["Offset of field: tagCURSORINFO::ptScreenPos"]
        [::std::mem::offset_of!(tagCURSORINFO, ptScreenPos) - 16usize];
};
pub type CURSORINFO = tagCURSORINFO;
pub type PCURSORINFO = *mut tagCURSORINFO;
pub type LPCURSORINFO = *mut tagCURSORINFO;
unsafe extern "C" {
    pub fn GetCursorInfo(pci: PCURSORINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagWINDOWINFO {
    pub cbSize: DWORD,
    pub rcWindow: RECT,
    pub rcClient: RECT,
    pub dwStyle: DWORD,
    pub dwExStyle: DWORD,
    pub dwWindowStatus: DWORD,
    pub cxWindowBorders: UINT,
    pub cyWindowBorders: UINT,
    pub atomWindowType: ATOM,
    pub wCreatorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWINDOWINFO"][::std::mem::size_of::<tagWINDOWINFO>() - 60usize];
    ["Alignment of tagWINDOWINFO"][::std::mem::align_of::<tagWINDOWINFO>() - 4usize];
    ["Offset of field: tagWINDOWINFO::cbSize"]
        [::std::mem::offset_of!(tagWINDOWINFO, cbSize) - 0usize];
    ["Offset of field: tagWINDOWINFO::rcWindow"]
        [::std::mem::offset_of!(tagWINDOWINFO, rcWindow) - 4usize];
    ["Offset of field: tagWINDOWINFO::rcClient"]
        [::std::mem::offset_of!(tagWINDOWINFO, rcClient) - 20usize];
    ["Offset of field: tagWINDOWINFO::dwStyle"]
        [::std::mem::offset_of!(tagWINDOWINFO, dwStyle) - 36usize];
    ["Offset of field: tagWINDOWINFO::dwExStyle"]
        [::std::mem::offset_of!(tagWINDOWINFO, dwExStyle) - 40usize];
    ["Offset of field: tagWINDOWINFO::dwWindowStatus"]
        [::std::mem::offset_of!(tagWINDOWINFO, dwWindowStatus) - 44usize];
    ["Offset of field: tagWINDOWINFO::cxWindowBorders"]
        [::std::mem::offset_of!(tagWINDOWINFO, cxWindowBorders) - 48usize];
    ["Offset of field: tagWINDOWINFO::cyWindowBorders"]
        [::std::mem::offset_of!(tagWINDOWINFO, cyWindowBorders) - 52usize];
    ["Offset of field: tagWINDOWINFO::atomWindowType"]
        [::std::mem::offset_of!(tagWINDOWINFO, atomWindowType) - 56usize];
    ["Offset of field: tagWINDOWINFO::wCreatorVersion"]
        [::std::mem::offset_of!(tagWINDOWINFO, wCreatorVersion) - 58usize];
};
pub type WINDOWINFO = tagWINDOWINFO;
pub type PWINDOWINFO = *mut tagWINDOWINFO;
pub type LPWINDOWINFO = *mut tagWINDOWINFO;
unsafe extern "C" {
    pub fn GetWindowInfo(hwnd: HWND, pwi: PWINDOWINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTITLEBARINFO {
    pub cbSize: DWORD,
    pub rcTitleBar: RECT,
    pub rgstate: [DWORD; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTITLEBARINFO"][::std::mem::size_of::<tagTITLEBARINFO>() - 44usize];
    ["Alignment of tagTITLEBARINFO"][::std::mem::align_of::<tagTITLEBARINFO>() - 4usize];
    ["Offset of field: tagTITLEBARINFO::cbSize"]
        [::std::mem::offset_of!(tagTITLEBARINFO, cbSize) - 0usize];
    ["Offset of field: tagTITLEBARINFO::rcTitleBar"]
        [::std::mem::offset_of!(tagTITLEBARINFO, rcTitleBar) - 4usize];
    ["Offset of field: tagTITLEBARINFO::rgstate"]
        [::std::mem::offset_of!(tagTITLEBARINFO, rgstate) - 20usize];
};
pub type TITLEBARINFO = tagTITLEBARINFO;
pub type PTITLEBARINFO = *mut tagTITLEBARINFO;
pub type LPTITLEBARINFO = *mut tagTITLEBARINFO;
unsafe extern "C" {
    pub fn GetTitleBarInfo(hwnd: HWND, pti: PTITLEBARINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTITLEBARINFOEX {
    pub cbSize: DWORD,
    pub rcTitleBar: RECT,
    pub rgstate: [DWORD; 6usize],
    pub rgrect: [RECT; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTITLEBARINFOEX"][::std::mem::size_of::<tagTITLEBARINFOEX>() - 140usize];
    ["Alignment of tagTITLEBARINFOEX"][::std::mem::align_of::<tagTITLEBARINFOEX>() - 4usize];
    ["Offset of field: tagTITLEBARINFOEX::cbSize"]
        [::std::mem::offset_of!(tagTITLEBARINFOEX, cbSize) - 0usize];
    ["Offset of field: tagTITLEBARINFOEX::rcTitleBar"]
        [::std::mem::offset_of!(tagTITLEBARINFOEX, rcTitleBar) - 4usize];
    ["Offset of field: tagTITLEBARINFOEX::rgstate"]
        [::std::mem::offset_of!(tagTITLEBARINFOEX, rgstate) - 20usize];
    ["Offset of field: tagTITLEBARINFOEX::rgrect"]
        [::std::mem::offset_of!(tagTITLEBARINFOEX, rgrect) - 44usize];
};
pub type TITLEBARINFOEX = tagTITLEBARINFOEX;
pub type PTITLEBARINFOEX = *mut tagTITLEBARINFOEX;
pub type LPTITLEBARINFOEX = *mut tagTITLEBARINFOEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMENUBARINFO {
    pub cbSize: DWORD,
    pub rcBar: RECT,
    pub hMenu: HMENU,
    pub hwndMenu: HWND,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub __bindgen_padding_0: u32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMENUBARINFO"][::std::mem::size_of::<tagMENUBARINFO>() - 48usize];
    ["Alignment of tagMENUBARINFO"][::std::mem::align_of::<tagMENUBARINFO>() - 8usize];
    ["Offset of field: tagMENUBARINFO::cbSize"]
        [::std::mem::offset_of!(tagMENUBARINFO, cbSize) - 0usize];
    ["Offset of field: tagMENUBARINFO::rcBar"]
        [::std::mem::offset_of!(tagMENUBARINFO, rcBar) - 4usize];
    ["Offset of field: tagMENUBARINFO::hMenu"]
        [::std::mem::offset_of!(tagMENUBARINFO, hMenu) - 24usize];
    ["Offset of field: tagMENUBARINFO::hwndMenu"]
        [::std::mem::offset_of!(tagMENUBARINFO, hwndMenu) - 32usize];
};
impl tagMENUBARINFO {
    #[inline]
    pub fn fBarFocused(&self) -> BOOL {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fBarFocused(&mut self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fBarFocused_raw(this: *const Self) -> BOOL {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fBarFocused_raw(this: *mut Self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fFocused(&self) -> BOOL {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fFocused(&mut self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fFocused_raw(this: *const Self) -> BOOL {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fFocused_raw(this: *mut Self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fUnused(&self) -> BOOL {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_fUnused(&mut self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fUnused_raw(this: *const Self) -> BOOL {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fUnused_raw(this: *mut Self, val: BOOL) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        fBarFocused: BOOL,
        fFocused: BOOL,
        fUnused: BOOL,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let fBarFocused: u32 = unsafe { ::std::mem::transmute(fBarFocused) };
            fBarFocused as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let fFocused: u32 = unsafe { ::std::mem::transmute(fFocused) };
            fFocused as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let fUnused: u32 = unsafe { ::std::mem::transmute(fUnused) };
            fUnused as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type MENUBARINFO = tagMENUBARINFO;
pub type PMENUBARINFO = *mut tagMENUBARINFO;
pub type LPMENUBARINFO = *mut tagMENUBARINFO;
unsafe extern "C" {
    pub fn GetMenuBarInfo(hwnd: HWND, idObject: LONG, idItem: LONG, pmbi: PMENUBARINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSCROLLBARINFO {
    pub cbSize: DWORD,
    pub rcScrollBar: RECT,
    pub dxyLineButton: ::std::os::raw::c_int,
    pub xyThumbTop: ::std::os::raw::c_int,
    pub xyThumbBottom: ::std::os::raw::c_int,
    pub reserved: ::std::os::raw::c_int,
    pub rgstate: [DWORD; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSCROLLBARINFO"][::std::mem::size_of::<tagSCROLLBARINFO>() - 60usize];
    ["Alignment of tagSCROLLBARINFO"][::std::mem::align_of::<tagSCROLLBARINFO>() - 4usize];
    ["Offset of field: tagSCROLLBARINFO::cbSize"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, cbSize) - 0usize];
    ["Offset of field: tagSCROLLBARINFO::rcScrollBar"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, rcScrollBar) - 4usize];
    ["Offset of field: tagSCROLLBARINFO::dxyLineButton"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, dxyLineButton) - 20usize];
    ["Offset of field: tagSCROLLBARINFO::xyThumbTop"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, xyThumbTop) - 24usize];
    ["Offset of field: tagSCROLLBARINFO::xyThumbBottom"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, xyThumbBottom) - 28usize];
    ["Offset of field: tagSCROLLBARINFO::reserved"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, reserved) - 32usize];
    ["Offset of field: tagSCROLLBARINFO::rgstate"]
        [::std::mem::offset_of!(tagSCROLLBARINFO, rgstate) - 36usize];
};
pub type SCROLLBARINFO = tagSCROLLBARINFO;
pub type PSCROLLBARINFO = *mut tagSCROLLBARINFO;
pub type LPSCROLLBARINFO = *mut tagSCROLLBARINFO;
unsafe extern "C" {
    pub fn GetScrollBarInfo(hwnd: HWND, idObject: LONG, psbi: PSCROLLBARINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOMBOBOXINFO {
    pub cbSize: DWORD,
    pub rcItem: RECT,
    pub rcButton: RECT,
    pub stateButton: DWORD,
    pub hwndCombo: HWND,
    pub hwndItem: HWND,
    pub hwndList: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOMBOBOXINFO"][::std::mem::size_of::<tagCOMBOBOXINFO>() - 64usize];
    ["Alignment of tagCOMBOBOXINFO"][::std::mem::align_of::<tagCOMBOBOXINFO>() - 8usize];
    ["Offset of field: tagCOMBOBOXINFO::cbSize"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, cbSize) - 0usize];
    ["Offset of field: tagCOMBOBOXINFO::rcItem"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, rcItem) - 4usize];
    ["Offset of field: tagCOMBOBOXINFO::rcButton"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, rcButton) - 20usize];
    ["Offset of field: tagCOMBOBOXINFO::stateButton"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, stateButton) - 36usize];
    ["Offset of field: tagCOMBOBOXINFO::hwndCombo"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, hwndCombo) - 40usize];
    ["Offset of field: tagCOMBOBOXINFO::hwndItem"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, hwndItem) - 48usize];
    ["Offset of field: tagCOMBOBOXINFO::hwndList"]
        [::std::mem::offset_of!(tagCOMBOBOXINFO, hwndList) - 56usize];
};
pub type COMBOBOXINFO = tagCOMBOBOXINFO;
pub type PCOMBOBOXINFO = *mut tagCOMBOBOXINFO;
pub type LPCOMBOBOXINFO = *mut tagCOMBOBOXINFO;
unsafe extern "C" {
    pub fn GetComboBoxInfo(hwndCombo: HWND, pcbi: PCOMBOBOXINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAncestor(hwnd: HWND, gaFlags: UINT) -> HWND;
}
unsafe extern "C" {
    pub fn RealChildWindowFromPoint(hwndParent: HWND, ptParentClientCoords: POINT) -> HWND;
}
unsafe extern "C" {
    pub fn RealGetWindowClassA(hwnd: HWND, ptszClassName: LPSTR, cchClassNameMax: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn RealGetWindowClassW(hwnd: HWND, ptszClassName: LPWSTR, cchClassNameMax: UINT) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagALTTABINFO {
    pub cbSize: DWORD,
    pub cItems: ::std::os::raw::c_int,
    pub cColumns: ::std::os::raw::c_int,
    pub cRows: ::std::os::raw::c_int,
    pub iColFocus: ::std::os::raw::c_int,
    pub iRowFocus: ::std::os::raw::c_int,
    pub cxItem: ::std::os::raw::c_int,
    pub cyItem: ::std::os::raw::c_int,
    pub ptStart: POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagALTTABINFO"][::std::mem::size_of::<tagALTTABINFO>() - 40usize];
    ["Alignment of tagALTTABINFO"][::std::mem::align_of::<tagALTTABINFO>() - 4usize];
    ["Offset of field: tagALTTABINFO::cbSize"]
        [::std::mem::offset_of!(tagALTTABINFO, cbSize) - 0usize];
    ["Offset of field: tagALTTABINFO::cItems"]
        [::std::mem::offset_of!(tagALTTABINFO, cItems) - 4usize];
    ["Offset of field: tagALTTABINFO::cColumns"]
        [::std::mem::offset_of!(tagALTTABINFO, cColumns) - 8usize];
    ["Offset of field: tagALTTABINFO::cRows"]
        [::std::mem::offset_of!(tagALTTABINFO, cRows) - 12usize];
    ["Offset of field: tagALTTABINFO::iColFocus"]
        [::std::mem::offset_of!(tagALTTABINFO, iColFocus) - 16usize];
    ["Offset of field: tagALTTABINFO::iRowFocus"]
        [::std::mem::offset_of!(tagALTTABINFO, iRowFocus) - 20usize];
    ["Offset of field: tagALTTABINFO::cxItem"]
        [::std::mem::offset_of!(tagALTTABINFO, cxItem) - 24usize];
    ["Offset of field: tagALTTABINFO::cyItem"]
        [::std::mem::offset_of!(tagALTTABINFO, cyItem) - 28usize];
    ["Offset of field: tagALTTABINFO::ptStart"]
        [::std::mem::offset_of!(tagALTTABINFO, ptStart) - 32usize];
};
pub type ALTTABINFO = tagALTTABINFO;
pub type PALTTABINFO = *mut tagALTTABINFO;
pub type LPALTTABINFO = *mut tagALTTABINFO;
unsafe extern "C" {
    pub fn GetAltTabInfoA(
        hwnd: HWND,
        iItem: ::std::os::raw::c_int,
        pati: PALTTABINFO,
        pszItemText: LPSTR,
        cchItemText: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAltTabInfoW(
        hwnd: HWND,
        iItem: ::std::os::raw::c_int,
        pati: PALTTABINFO,
        pszItemText: LPWSTR,
        cchItemText: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetListBoxInfo(hwnd: HWND) -> DWORD;
}
unsafe extern "C" {
    pub fn LockWorkStation() -> BOOL;
}
unsafe extern "C" {
    pub fn UserHandleGrantAccess(hUserHandle: HANDLE, hJob: HANDLE, bGrant: BOOL) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HRAWINPUT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HRAWINPUT__"][::std::mem::size_of::<HRAWINPUT__>() - 4usize];
    ["Alignment of HRAWINPUT__"][::std::mem::align_of::<HRAWINPUT__>() - 4usize];
    ["Offset of field: HRAWINPUT__::unused"][::std::mem::offset_of!(HRAWINPUT__, unused) - 0usize];
};
pub type HRAWINPUT = *mut HRAWINPUT__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWINPUTHEADER {
    pub dwType: DWORD,
    pub dwSize: DWORD,
    pub hDevice: HANDLE,
    pub wParam: WPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWINPUTHEADER"][::std::mem::size_of::<tagRAWINPUTHEADER>() - 24usize];
    ["Alignment of tagRAWINPUTHEADER"][::std::mem::align_of::<tagRAWINPUTHEADER>() - 8usize];
    ["Offset of field: tagRAWINPUTHEADER::dwType"]
        [::std::mem::offset_of!(tagRAWINPUTHEADER, dwType) - 0usize];
    ["Offset of field: tagRAWINPUTHEADER::dwSize"]
        [::std::mem::offset_of!(tagRAWINPUTHEADER, dwSize) - 4usize];
    ["Offset of field: tagRAWINPUTHEADER::hDevice"]
        [::std::mem::offset_of!(tagRAWINPUTHEADER, hDevice) - 8usize];
    ["Offset of field: tagRAWINPUTHEADER::wParam"]
        [::std::mem::offset_of!(tagRAWINPUTHEADER, wParam) - 16usize];
};
pub type RAWINPUTHEADER = tagRAWINPUTHEADER;
pub type PRAWINPUTHEADER = *mut tagRAWINPUTHEADER;
pub type LPRAWINPUTHEADER = *mut tagRAWINPUTHEADER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagRAWMOUSE {
    pub usFlags: USHORT,
    pub __bindgen_anon_1: tagRAWMOUSE__bindgen_ty_1,
    pub ulRawButtons: ULONG,
    pub lLastX: LONG,
    pub lLastY: LONG,
    pub ulExtraInformation: ULONG,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagRAWMOUSE__bindgen_ty_1 {
    pub ulButtons: ULONG,
    pub __bindgen_anon_1: tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1 {
    pub usButtonFlags: USHORT,
    pub usButtonData: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1::usButtonFlags"]
        [::std::mem::offset_of!(tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1, usButtonFlags) - 0usize];
    ["Offset of field: tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1::usButtonData"]
        [::std::mem::offset_of!(tagRAWMOUSE__bindgen_ty_1__bindgen_ty_1, usButtonData) - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWMOUSE__bindgen_ty_1"]
        [::std::mem::size_of::<tagRAWMOUSE__bindgen_ty_1>() - 4usize];
    ["Alignment of tagRAWMOUSE__bindgen_ty_1"]
        [::std::mem::align_of::<tagRAWMOUSE__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagRAWMOUSE__bindgen_ty_1::ulButtons"]
        [::std::mem::offset_of!(tagRAWMOUSE__bindgen_ty_1, ulButtons) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWMOUSE"][::std::mem::size_of::<tagRAWMOUSE>() - 24usize];
    ["Alignment of tagRAWMOUSE"][::std::mem::align_of::<tagRAWMOUSE>() - 4usize];
    ["Offset of field: tagRAWMOUSE::usFlags"]
        [::std::mem::offset_of!(tagRAWMOUSE, usFlags) - 0usize];
    ["Offset of field: tagRAWMOUSE::ulRawButtons"]
        [::std::mem::offset_of!(tagRAWMOUSE, ulRawButtons) - 8usize];
    ["Offset of field: tagRAWMOUSE::lLastX"][::std::mem::offset_of!(tagRAWMOUSE, lLastX) - 12usize];
    ["Offset of field: tagRAWMOUSE::lLastY"][::std::mem::offset_of!(tagRAWMOUSE, lLastY) - 16usize];
    ["Offset of field: tagRAWMOUSE::ulExtraInformation"]
        [::std::mem::offset_of!(tagRAWMOUSE, ulExtraInformation) - 20usize];
};
pub type RAWMOUSE = tagRAWMOUSE;
pub type PRAWMOUSE = *mut tagRAWMOUSE;
pub type LPRAWMOUSE = *mut tagRAWMOUSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWKEYBOARD {
    pub MakeCode: USHORT,
    pub Flags: USHORT,
    pub Reserved: USHORT,
    pub VKey: USHORT,
    pub Message: UINT,
    pub ExtraInformation: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWKEYBOARD"][::std::mem::size_of::<tagRAWKEYBOARD>() - 16usize];
    ["Alignment of tagRAWKEYBOARD"][::std::mem::align_of::<tagRAWKEYBOARD>() - 4usize];
    ["Offset of field: tagRAWKEYBOARD::MakeCode"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, MakeCode) - 0usize];
    ["Offset of field: tagRAWKEYBOARD::Flags"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, Flags) - 2usize];
    ["Offset of field: tagRAWKEYBOARD::Reserved"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, Reserved) - 4usize];
    ["Offset of field: tagRAWKEYBOARD::VKey"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, VKey) - 6usize];
    ["Offset of field: tagRAWKEYBOARD::Message"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, Message) - 8usize];
    ["Offset of field: tagRAWKEYBOARD::ExtraInformation"]
        [::std::mem::offset_of!(tagRAWKEYBOARD, ExtraInformation) - 12usize];
};
pub type RAWKEYBOARD = tagRAWKEYBOARD;
pub type PRAWKEYBOARD = *mut tagRAWKEYBOARD;
pub type LPRAWKEYBOARD = *mut tagRAWKEYBOARD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWHID {
    pub dwSizeHid: DWORD,
    pub dwCount: DWORD,
    pub bRawData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWHID"][::std::mem::size_of::<tagRAWHID>() - 12usize];
    ["Alignment of tagRAWHID"][::std::mem::align_of::<tagRAWHID>() - 4usize];
    ["Offset of field: tagRAWHID::dwSizeHid"]
        [::std::mem::offset_of!(tagRAWHID, dwSizeHid) - 0usize];
    ["Offset of field: tagRAWHID::dwCount"][::std::mem::offset_of!(tagRAWHID, dwCount) - 4usize];
    ["Offset of field: tagRAWHID::bRawData"][::std::mem::offset_of!(tagRAWHID, bRawData) - 8usize];
};
pub type RAWHID = tagRAWHID;
pub type PRAWHID = *mut tagRAWHID;
pub type LPRAWHID = *mut tagRAWHID;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagRAWINPUT {
    pub header: RAWINPUTHEADER,
    pub data: tagRAWINPUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagRAWINPUT__bindgen_ty_1 {
    pub mouse: RAWMOUSE,
    pub keyboard: RAWKEYBOARD,
    pub hid: RAWHID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWINPUT__bindgen_ty_1"]
        [::std::mem::size_of::<tagRAWINPUT__bindgen_ty_1>() - 24usize];
    ["Alignment of tagRAWINPUT__bindgen_ty_1"]
        [::std::mem::align_of::<tagRAWINPUT__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagRAWINPUT__bindgen_ty_1::mouse"]
        [::std::mem::offset_of!(tagRAWINPUT__bindgen_ty_1, mouse) - 0usize];
    ["Offset of field: tagRAWINPUT__bindgen_ty_1::keyboard"]
        [::std::mem::offset_of!(tagRAWINPUT__bindgen_ty_1, keyboard) - 0usize];
    ["Offset of field: tagRAWINPUT__bindgen_ty_1::hid"]
        [::std::mem::offset_of!(tagRAWINPUT__bindgen_ty_1, hid) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWINPUT"][::std::mem::size_of::<tagRAWINPUT>() - 48usize];
    ["Alignment of tagRAWINPUT"][::std::mem::align_of::<tagRAWINPUT>() - 8usize];
    ["Offset of field: tagRAWINPUT::header"][::std::mem::offset_of!(tagRAWINPUT, header) - 0usize];
    ["Offset of field: tagRAWINPUT::data"][::std::mem::offset_of!(tagRAWINPUT, data) - 24usize];
};
pub type RAWINPUT = tagRAWINPUT;
pub type PRAWINPUT = *mut tagRAWINPUT;
pub type LPRAWINPUT = *mut tagRAWINPUT;
unsafe extern "C" {
    pub fn GetRawInputData(
        hRawInput: HRAWINPUT,
        uiCommand: UINT,
        pData: LPVOID,
        pcbSize: PUINT,
        cbSizeHeader: UINT,
    ) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRID_DEVICE_INFO_MOUSE {
    pub dwId: DWORD,
    pub dwNumberOfButtons: DWORD,
    pub dwSampleRate: DWORD,
    pub fHasHorizontalWheel: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRID_DEVICE_INFO_MOUSE"]
        [::std::mem::size_of::<tagRID_DEVICE_INFO_MOUSE>() - 16usize];
    ["Alignment of tagRID_DEVICE_INFO_MOUSE"]
        [::std::mem::align_of::<tagRID_DEVICE_INFO_MOUSE>() - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_MOUSE::dwId"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_MOUSE, dwId) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO_MOUSE::dwNumberOfButtons"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_MOUSE, dwNumberOfButtons) - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_MOUSE::dwSampleRate"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_MOUSE, dwSampleRate) - 8usize];
    ["Offset of field: tagRID_DEVICE_INFO_MOUSE::fHasHorizontalWheel"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_MOUSE, fHasHorizontalWheel) - 12usize];
};
pub type RID_DEVICE_INFO_MOUSE = tagRID_DEVICE_INFO_MOUSE;
pub type PRID_DEVICE_INFO_MOUSE = *mut tagRID_DEVICE_INFO_MOUSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRID_DEVICE_INFO_KEYBOARD {
    pub dwType: DWORD,
    pub dwSubType: DWORD,
    pub dwKeyboardMode: DWORD,
    pub dwNumberOfFunctionKeys: DWORD,
    pub dwNumberOfIndicators: DWORD,
    pub dwNumberOfKeysTotal: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRID_DEVICE_INFO_KEYBOARD"]
        [::std::mem::size_of::<tagRID_DEVICE_INFO_KEYBOARD>() - 24usize];
    ["Alignment of tagRID_DEVICE_INFO_KEYBOARD"]
        [::std::mem::align_of::<tagRID_DEVICE_INFO_KEYBOARD>() - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwType"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwType) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwSubType"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwSubType) - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwKeyboardMode"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwKeyboardMode) - 8usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwNumberOfFunctionKeys"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwNumberOfFunctionKeys) - 12usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwNumberOfIndicators"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwNumberOfIndicators) - 16usize];
    ["Offset of field: tagRID_DEVICE_INFO_KEYBOARD::dwNumberOfKeysTotal"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_KEYBOARD, dwNumberOfKeysTotal) - 20usize];
};
pub type RID_DEVICE_INFO_KEYBOARD = tagRID_DEVICE_INFO_KEYBOARD;
pub type PRID_DEVICE_INFO_KEYBOARD = *mut tagRID_DEVICE_INFO_KEYBOARD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRID_DEVICE_INFO_HID {
    pub dwVendorId: DWORD,
    pub dwProductId: DWORD,
    pub dwVersionNumber: DWORD,
    pub usUsagePage: USHORT,
    pub usUsage: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRID_DEVICE_INFO_HID"][::std::mem::size_of::<tagRID_DEVICE_INFO_HID>() - 16usize];
    ["Alignment of tagRID_DEVICE_INFO_HID"]
        [::std::mem::align_of::<tagRID_DEVICE_INFO_HID>() - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_HID::dwVendorId"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_HID, dwVendorId) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO_HID::dwProductId"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_HID, dwProductId) - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO_HID::dwVersionNumber"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_HID, dwVersionNumber) - 8usize];
    ["Offset of field: tagRID_DEVICE_INFO_HID::usUsagePage"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_HID, usUsagePage) - 12usize];
    ["Offset of field: tagRID_DEVICE_INFO_HID::usUsage"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO_HID, usUsage) - 14usize];
};
pub type RID_DEVICE_INFO_HID = tagRID_DEVICE_INFO_HID;
pub type PRID_DEVICE_INFO_HID = *mut tagRID_DEVICE_INFO_HID;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagRID_DEVICE_INFO {
    pub cbSize: DWORD,
    pub dwType: DWORD,
    pub __bindgen_anon_1: tagRID_DEVICE_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagRID_DEVICE_INFO__bindgen_ty_1 {
    pub mouse: RID_DEVICE_INFO_MOUSE,
    pub keyboard: RID_DEVICE_INFO_KEYBOARD,
    pub hid: RID_DEVICE_INFO_HID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRID_DEVICE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<tagRID_DEVICE_INFO__bindgen_ty_1>() - 24usize];
    ["Alignment of tagRID_DEVICE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<tagRID_DEVICE_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO__bindgen_ty_1::mouse"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO__bindgen_ty_1, mouse) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO__bindgen_ty_1::keyboard"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO__bindgen_ty_1, keyboard) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO__bindgen_ty_1::hid"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO__bindgen_ty_1, hid) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRID_DEVICE_INFO"][::std::mem::size_of::<tagRID_DEVICE_INFO>() - 32usize];
    ["Alignment of tagRID_DEVICE_INFO"][::std::mem::align_of::<tagRID_DEVICE_INFO>() - 4usize];
    ["Offset of field: tagRID_DEVICE_INFO::cbSize"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO, cbSize) - 0usize];
    ["Offset of field: tagRID_DEVICE_INFO::dwType"]
        [::std::mem::offset_of!(tagRID_DEVICE_INFO, dwType) - 4usize];
};
pub type RID_DEVICE_INFO = tagRID_DEVICE_INFO;
pub type PRID_DEVICE_INFO = *mut tagRID_DEVICE_INFO;
pub type LPRID_DEVICE_INFO = *mut tagRID_DEVICE_INFO;
unsafe extern "C" {
    pub fn GetRawInputDeviceInfoA(
        hDevice: HANDLE,
        uiCommand: UINT,
        pData: LPVOID,
        pcbSize: PUINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetRawInputDeviceInfoW(
        hDevice: HANDLE,
        uiCommand: UINT,
        pData: LPVOID,
        pcbSize: PUINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn GetRawInputBuffer(pData: PRAWINPUT, pcbSize: PUINT, cbSizeHeader: UINT) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWINPUTDEVICE {
    pub usUsagePage: USHORT,
    pub usUsage: USHORT,
    pub dwFlags: DWORD,
    pub hwndTarget: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWINPUTDEVICE"][::std::mem::size_of::<tagRAWINPUTDEVICE>() - 16usize];
    ["Alignment of tagRAWINPUTDEVICE"][::std::mem::align_of::<tagRAWINPUTDEVICE>() - 8usize];
    ["Offset of field: tagRAWINPUTDEVICE::usUsagePage"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICE, usUsagePage) - 0usize];
    ["Offset of field: tagRAWINPUTDEVICE::usUsage"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICE, usUsage) - 2usize];
    ["Offset of field: tagRAWINPUTDEVICE::dwFlags"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICE, dwFlags) - 4usize];
    ["Offset of field: tagRAWINPUTDEVICE::hwndTarget"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICE, hwndTarget) - 8usize];
};
pub type RAWINPUTDEVICE = tagRAWINPUTDEVICE;
pub type PRAWINPUTDEVICE = *mut tagRAWINPUTDEVICE;
pub type LPRAWINPUTDEVICE = *mut tagRAWINPUTDEVICE;
pub type PCRAWINPUTDEVICE = *const RAWINPUTDEVICE;
unsafe extern "C" {
    pub fn RegisterRawInputDevices(
        pRawInputDevices: PCRAWINPUTDEVICE,
        uiNumDevices: UINT,
        cbSize: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetRegisteredRawInputDevices(
        pRawInputDevices: PRAWINPUTDEVICE,
        puiNumDevices: PUINT,
        cbSize: UINT,
    ) -> UINT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRAWINPUTDEVICELIST {
    pub hDevice: HANDLE,
    pub dwType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRAWINPUTDEVICELIST"][::std::mem::size_of::<tagRAWINPUTDEVICELIST>() - 16usize];
    ["Alignment of tagRAWINPUTDEVICELIST"]
        [::std::mem::align_of::<tagRAWINPUTDEVICELIST>() - 8usize];
    ["Offset of field: tagRAWINPUTDEVICELIST::hDevice"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICELIST, hDevice) - 0usize];
    ["Offset of field: tagRAWINPUTDEVICELIST::dwType"]
        [::std::mem::offset_of!(tagRAWINPUTDEVICELIST, dwType) - 8usize];
};
pub type RAWINPUTDEVICELIST = tagRAWINPUTDEVICELIST;
pub type PRAWINPUTDEVICELIST = *mut tagRAWINPUTDEVICELIST;
unsafe extern "C" {
    pub fn GetRawInputDeviceList(
        pRawInputDeviceList: PRAWINPUTDEVICELIST,
        puiNumDevices: PUINT,
        cbSize: UINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn DefRawInputProc(paRawInput: *mut PRAWINPUT, nInput: INT, cbSizeHeader: UINT) -> LRESULT;
}
pub const tagPOINTER_DEVICE_TYPE_POINTER_DEVICE_TYPE_INTEGRATED_PEN: tagPOINTER_DEVICE_TYPE = 1;
pub const tagPOINTER_DEVICE_TYPE_POINTER_DEVICE_TYPE_EXTERNAL_PEN: tagPOINTER_DEVICE_TYPE = 2;
pub const tagPOINTER_DEVICE_TYPE_POINTER_DEVICE_TYPE_TOUCH: tagPOINTER_DEVICE_TYPE = 3;
pub const tagPOINTER_DEVICE_TYPE_POINTER_DEVICE_TYPE_TOUCH_PAD: tagPOINTER_DEVICE_TYPE = 4;
pub const tagPOINTER_DEVICE_TYPE_POINTER_DEVICE_TYPE_MAX: tagPOINTER_DEVICE_TYPE = -1;
pub type tagPOINTER_DEVICE_TYPE = ::std::os::raw::c_int;
pub use self::tagPOINTER_DEVICE_TYPE as POINTER_DEVICE_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_DEVICE_INFO {
    pub displayOrientation: DWORD,
    pub device: HANDLE,
    pub pointerDeviceType: POINTER_DEVICE_TYPE,
    pub monitor: HMONITOR,
    pub startingCursorId: ULONG,
    pub maxActiveContacts: USHORT,
    pub productString: [WCHAR; 520usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_DEVICE_INFO"][::std::mem::size_of::<tagPOINTER_DEVICE_INFO>() - 1080usize];
    ["Alignment of tagPOINTER_DEVICE_INFO"]
        [::std::mem::align_of::<tagPOINTER_DEVICE_INFO>() - 8usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::displayOrientation"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, displayOrientation) - 0usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::device"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, device) - 8usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::pointerDeviceType"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, pointerDeviceType) - 16usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::monitor"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, monitor) - 24usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::startingCursorId"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, startingCursorId) - 32usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::maxActiveContacts"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, maxActiveContacts) - 36usize];
    ["Offset of field: tagPOINTER_DEVICE_INFO::productString"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_INFO, productString) - 38usize];
};
pub type POINTER_DEVICE_INFO = tagPOINTER_DEVICE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_DEVICE_PROPERTY {
    pub logicalMin: INT32,
    pub logicalMax: INT32,
    pub physicalMin: INT32,
    pub physicalMax: INT32,
    pub unit: UINT32,
    pub unitExponent: UINT32,
    pub usagePageId: USHORT,
    pub usageId: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_DEVICE_PROPERTY"]
        [::std::mem::size_of::<tagPOINTER_DEVICE_PROPERTY>() - 28usize];
    ["Alignment of tagPOINTER_DEVICE_PROPERTY"]
        [::std::mem::align_of::<tagPOINTER_DEVICE_PROPERTY>() - 4usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::logicalMin"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, logicalMin) - 0usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::logicalMax"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, logicalMax) - 4usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::physicalMin"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, physicalMin) - 8usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::physicalMax"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, physicalMax) - 12usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::unit"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, unit) - 16usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::unitExponent"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, unitExponent) - 20usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::usagePageId"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, usagePageId) - 24usize];
    ["Offset of field: tagPOINTER_DEVICE_PROPERTY::usageId"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_PROPERTY, usageId) - 26usize];
};
pub type POINTER_DEVICE_PROPERTY = tagPOINTER_DEVICE_PROPERTY;
pub const tagPOINTER_DEVICE_CURSOR_TYPE_POINTER_DEVICE_CURSOR_TYPE_UNKNOWN:
    tagPOINTER_DEVICE_CURSOR_TYPE = 0;
pub const tagPOINTER_DEVICE_CURSOR_TYPE_POINTER_DEVICE_CURSOR_TYPE_TIP:
    tagPOINTER_DEVICE_CURSOR_TYPE = 1;
pub const tagPOINTER_DEVICE_CURSOR_TYPE_POINTER_DEVICE_CURSOR_TYPE_ERASER:
    tagPOINTER_DEVICE_CURSOR_TYPE = 2;
pub const tagPOINTER_DEVICE_CURSOR_TYPE_POINTER_DEVICE_CURSOR_TYPE_MAX:
    tagPOINTER_DEVICE_CURSOR_TYPE = -1;
pub type tagPOINTER_DEVICE_CURSOR_TYPE = ::std::os::raw::c_int;
pub use self::tagPOINTER_DEVICE_CURSOR_TYPE as POINTER_DEVICE_CURSOR_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPOINTER_DEVICE_CURSOR_INFO {
    pub cursorId: UINT32,
    pub cursor: POINTER_DEVICE_CURSOR_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPOINTER_DEVICE_CURSOR_INFO"]
        [::std::mem::size_of::<tagPOINTER_DEVICE_CURSOR_INFO>() - 8usize];
    ["Alignment of tagPOINTER_DEVICE_CURSOR_INFO"]
        [::std::mem::align_of::<tagPOINTER_DEVICE_CURSOR_INFO>() - 4usize];
    ["Offset of field: tagPOINTER_DEVICE_CURSOR_INFO::cursorId"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_CURSOR_INFO, cursorId) - 0usize];
    ["Offset of field: tagPOINTER_DEVICE_CURSOR_INFO::cursor"]
        [::std::mem::offset_of!(tagPOINTER_DEVICE_CURSOR_INFO, cursor) - 4usize];
};
pub type POINTER_DEVICE_CURSOR_INFO = tagPOINTER_DEVICE_CURSOR_INFO;
unsafe extern "C" {
    pub fn GetPointerDevices(
        deviceCount: *mut UINT32,
        pointerDevices: *mut POINTER_DEVICE_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerDevice(device: HANDLE, pointerDevice: *mut POINTER_DEVICE_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerDeviceProperties(
        device: HANDLE,
        propertyCount: *mut UINT32,
        pointerProperties: *mut POINTER_DEVICE_PROPERTY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterPointerDeviceNotifications(window: HWND, notifyRange: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerDeviceRects(
        device: HANDLE,
        pointerDeviceRect: *mut RECT,
        displayRect: *mut RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPointerDeviceCursors(
        device: HANDLE,
        cursorCount: *mut UINT32,
        deviceCursors: *mut POINTER_DEVICE_CURSOR_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetRawPointerDeviceData(
        pointerId: UINT32,
        historyCount: UINT32,
        propertiesCount: UINT32,
        pProperties: *mut POINTER_DEVICE_PROPERTY,
        pValues: *mut LONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeWindowMessageFilter(message: UINT, dwFlag: DWORD) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHANGEFILTERSTRUCT {
    pub cbSize: DWORD,
    pub ExtStatus: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHANGEFILTERSTRUCT"][::std::mem::size_of::<tagCHANGEFILTERSTRUCT>() - 8usize];
    ["Alignment of tagCHANGEFILTERSTRUCT"]
        [::std::mem::align_of::<tagCHANGEFILTERSTRUCT>() - 4usize];
    ["Offset of field: tagCHANGEFILTERSTRUCT::cbSize"]
        [::std::mem::offset_of!(tagCHANGEFILTERSTRUCT, cbSize) - 0usize];
    ["Offset of field: tagCHANGEFILTERSTRUCT::ExtStatus"]
        [::std::mem::offset_of!(tagCHANGEFILTERSTRUCT, ExtStatus) - 4usize];
};
pub type CHANGEFILTERSTRUCT = tagCHANGEFILTERSTRUCT;
pub type PCHANGEFILTERSTRUCT = *mut tagCHANGEFILTERSTRUCT;
unsafe extern "C" {
    pub fn ChangeWindowMessageFilterEx(
        hwnd: HWND,
        message: UINT,
        action: DWORD,
        pChangeFilterStruct: PCHANGEFILTERSTRUCT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HGESTUREINFO__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HGESTUREINFO__"][::std::mem::size_of::<HGESTUREINFO__>() - 4usize];
    ["Alignment of HGESTUREINFO__"][::std::mem::align_of::<HGESTUREINFO__>() - 4usize];
    ["Offset of field: HGESTUREINFO__::unused"]
        [::std::mem::offset_of!(HGESTUREINFO__, unused) - 0usize];
};
pub type HGESTUREINFO = *mut HGESTUREINFO__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGESTUREINFO {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub dwID: DWORD,
    pub hwndTarget: HWND,
    pub ptsLocation: POINTS,
    pub dwInstanceID: DWORD,
    pub dwSequenceID: DWORD,
    pub ullArguments: ULONGLONG,
    pub cbExtraArgs: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGESTUREINFO"][::std::mem::size_of::<tagGESTUREINFO>() - 56usize];
    ["Alignment of tagGESTUREINFO"][::std::mem::align_of::<tagGESTUREINFO>() - 8usize];
    ["Offset of field: tagGESTUREINFO::cbSize"]
        [::std::mem::offset_of!(tagGESTUREINFO, cbSize) - 0usize];
    ["Offset of field: tagGESTUREINFO::dwFlags"]
        [::std::mem::offset_of!(tagGESTUREINFO, dwFlags) - 4usize];
    ["Offset of field: tagGESTUREINFO::dwID"]
        [::std::mem::offset_of!(tagGESTUREINFO, dwID) - 8usize];
    ["Offset of field: tagGESTUREINFO::hwndTarget"]
        [::std::mem::offset_of!(tagGESTUREINFO, hwndTarget) - 16usize];
    ["Offset of field: tagGESTUREINFO::ptsLocation"]
        [::std::mem::offset_of!(tagGESTUREINFO, ptsLocation) - 24usize];
    ["Offset of field: tagGESTUREINFO::dwInstanceID"]
        [::std::mem::offset_of!(tagGESTUREINFO, dwInstanceID) - 28usize];
    ["Offset of field: tagGESTUREINFO::dwSequenceID"]
        [::std::mem::offset_of!(tagGESTUREINFO, dwSequenceID) - 32usize];
    ["Offset of field: tagGESTUREINFO::ullArguments"]
        [::std::mem::offset_of!(tagGESTUREINFO, ullArguments) - 40usize];
    ["Offset of field: tagGESTUREINFO::cbExtraArgs"]
        [::std::mem::offset_of!(tagGESTUREINFO, cbExtraArgs) - 48usize];
};
pub type GESTUREINFO = tagGESTUREINFO;
pub type PGESTUREINFO = *mut tagGESTUREINFO;
pub type PCGESTUREINFO = *const GESTUREINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGESTURENOTIFYSTRUCT {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
    pub hwndTarget: HWND,
    pub ptsLocation: POINTS,
    pub dwInstanceID: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGESTURENOTIFYSTRUCT"][::std::mem::size_of::<tagGESTURENOTIFYSTRUCT>() - 24usize];
    ["Alignment of tagGESTURENOTIFYSTRUCT"]
        [::std::mem::align_of::<tagGESTURENOTIFYSTRUCT>() - 8usize];
    ["Offset of field: tagGESTURENOTIFYSTRUCT::cbSize"]
        [::std::mem::offset_of!(tagGESTURENOTIFYSTRUCT, cbSize) - 0usize];
    ["Offset of field: tagGESTURENOTIFYSTRUCT::dwFlags"]
        [::std::mem::offset_of!(tagGESTURENOTIFYSTRUCT, dwFlags) - 4usize];
    ["Offset of field: tagGESTURENOTIFYSTRUCT::hwndTarget"]
        [::std::mem::offset_of!(tagGESTURENOTIFYSTRUCT, hwndTarget) - 8usize];
    ["Offset of field: tagGESTURENOTIFYSTRUCT::ptsLocation"]
        [::std::mem::offset_of!(tagGESTURENOTIFYSTRUCT, ptsLocation) - 16usize];
    ["Offset of field: tagGESTURENOTIFYSTRUCT::dwInstanceID"]
        [::std::mem::offset_of!(tagGESTURENOTIFYSTRUCT, dwInstanceID) - 20usize];
};
pub type GESTURENOTIFYSTRUCT = tagGESTURENOTIFYSTRUCT;
pub type PGESTURENOTIFYSTRUCT = *mut tagGESTURENOTIFYSTRUCT;
unsafe extern "C" {
    pub fn GetGestureInfo(hGestureInfo: HGESTUREINFO, pGestureInfo: PGESTUREINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetGestureExtraArgs(
        hGestureInfo: HGESTUREINFO,
        cbExtraArgs: UINT,
        pExtraArgs: PBYTE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseGestureInfoHandle(hGestureInfo: HGESTUREINFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagGESTURECONFIG {
    pub dwID: DWORD,
    pub dwWant: DWORD,
    pub dwBlock: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagGESTURECONFIG"][::std::mem::size_of::<tagGESTURECONFIG>() - 12usize];
    ["Alignment of tagGESTURECONFIG"][::std::mem::align_of::<tagGESTURECONFIG>() - 4usize];
    ["Offset of field: tagGESTURECONFIG::dwID"]
        [::std::mem::offset_of!(tagGESTURECONFIG, dwID) - 0usize];
    ["Offset of field: tagGESTURECONFIG::dwWant"]
        [::std::mem::offset_of!(tagGESTURECONFIG, dwWant) - 4usize];
    ["Offset of field: tagGESTURECONFIG::dwBlock"]
        [::std::mem::offset_of!(tagGESTURECONFIG, dwBlock) - 8usize];
};
pub type GESTURECONFIG = tagGESTURECONFIG;
pub type PGESTURECONFIG = *mut tagGESTURECONFIG;
unsafe extern "C" {
    pub fn SetGestureConfig(
        hwnd: HWND,
        dwReserved: DWORD,
        cIDs: UINT,
        pGestureConfig: PGESTURECONFIG,
        cbSize: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetGestureConfig(
        hwnd: HWND,
        dwReserved: DWORD,
        dwFlags: DWORD,
        pcIDs: PUINT,
        pGestureConfig: PGESTURECONFIG,
        cbSize: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ShutdownBlockReasonCreate(hWnd: HWND, pwszReason: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ShutdownBlockReasonQuery(hWnd: HWND, pwszBuff: LPWSTR, pcchBuff: *mut DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ShutdownBlockReasonDestroy(hWnd: HWND) -> BOOL;
}
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_UNAVAILABLE: tagINPUT_MESSAGE_DEVICE_TYPE = 0;
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_KEYBOARD: tagINPUT_MESSAGE_DEVICE_TYPE = 1;
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_MOUSE: tagINPUT_MESSAGE_DEVICE_TYPE = 2;
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_TOUCH: tagINPUT_MESSAGE_DEVICE_TYPE = 4;
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_PEN: tagINPUT_MESSAGE_DEVICE_TYPE = 8;
pub const tagINPUT_MESSAGE_DEVICE_TYPE_IMDT_TOUCHPAD: tagINPUT_MESSAGE_DEVICE_TYPE = 16;
pub type tagINPUT_MESSAGE_DEVICE_TYPE = ::std::os::raw::c_int;
pub use self::tagINPUT_MESSAGE_DEVICE_TYPE as INPUT_MESSAGE_DEVICE_TYPE;
pub const tagINPUT_MESSAGE_ORIGIN_ID_IMO_UNAVAILABLE: tagINPUT_MESSAGE_ORIGIN_ID = 0;
pub const tagINPUT_MESSAGE_ORIGIN_ID_IMO_HARDWARE: tagINPUT_MESSAGE_ORIGIN_ID = 1;
pub const tagINPUT_MESSAGE_ORIGIN_ID_IMO_INJECTED: tagINPUT_MESSAGE_ORIGIN_ID = 2;
pub const tagINPUT_MESSAGE_ORIGIN_ID_IMO_SYSTEM: tagINPUT_MESSAGE_ORIGIN_ID = 4;
pub type tagINPUT_MESSAGE_ORIGIN_ID = ::std::os::raw::c_int;
pub use self::tagINPUT_MESSAGE_ORIGIN_ID as INPUT_MESSAGE_ORIGIN_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagINPUT_MESSAGE_SOURCE {
    pub deviceType: INPUT_MESSAGE_DEVICE_TYPE,
    pub originId: INPUT_MESSAGE_ORIGIN_ID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINPUT_MESSAGE_SOURCE"][::std::mem::size_of::<tagINPUT_MESSAGE_SOURCE>() - 8usize];
    ["Alignment of tagINPUT_MESSAGE_SOURCE"]
        [::std::mem::align_of::<tagINPUT_MESSAGE_SOURCE>() - 4usize];
    ["Offset of field: tagINPUT_MESSAGE_SOURCE::deviceType"]
        [::std::mem::offset_of!(tagINPUT_MESSAGE_SOURCE, deviceType) - 0usize];
    ["Offset of field: tagINPUT_MESSAGE_SOURCE::originId"]
        [::std::mem::offset_of!(tagINPUT_MESSAGE_SOURCE, originId) - 4usize];
};
pub type INPUT_MESSAGE_SOURCE = tagINPUT_MESSAGE_SOURCE;
unsafe extern "C" {
    pub fn GetCurrentInputMessageSource(inputMessageSource: *mut INPUT_MESSAGE_SOURCE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCIMSSM(inputMessageSource: *mut INPUT_MESSAGE_SOURCE) -> BOOL;
}
pub const tagAR_STATE_AR_ENABLED: tagAR_STATE = 0;
pub const tagAR_STATE_AR_DISABLED: tagAR_STATE = 1;
pub const tagAR_STATE_AR_SUPPRESSED: tagAR_STATE = 2;
pub const tagAR_STATE_AR_REMOTESESSION: tagAR_STATE = 4;
pub const tagAR_STATE_AR_MULTIMON: tagAR_STATE = 8;
pub const tagAR_STATE_AR_NOSENSOR: tagAR_STATE = 16;
pub const tagAR_STATE_AR_NOT_SUPPORTED: tagAR_STATE = 32;
pub const tagAR_STATE_AR_DOCKED: tagAR_STATE = 64;
pub const tagAR_STATE_AR_LAPTOP: tagAR_STATE = 128;
pub type tagAR_STATE = ::std::os::raw::c_int;
pub use self::tagAR_STATE as AR_STATE;
pub type PAR_STATE = *mut tagAR_STATE;
pub const ORIENTATION_PREFERENCE_ORIENTATION_PREFERENCE_NONE: ORIENTATION_PREFERENCE = 0;
pub const ORIENTATION_PREFERENCE_ORIENTATION_PREFERENCE_LANDSCAPE: ORIENTATION_PREFERENCE = 1;
pub const ORIENTATION_PREFERENCE_ORIENTATION_PREFERENCE_PORTRAIT: ORIENTATION_PREFERENCE = 2;
pub const ORIENTATION_PREFERENCE_ORIENTATION_PREFERENCE_LANDSCAPE_FLIPPED: ORIENTATION_PREFERENCE =
    4;
pub const ORIENTATION_PREFERENCE_ORIENTATION_PREFERENCE_PORTRAIT_FLIPPED: ORIENTATION_PREFERENCE =
    8;
pub type ORIENTATION_PREFERENCE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn GetAutoRotationState(pState: PAR_STATE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDisplayAutoRotationPreferences(pOrientation: *mut ORIENTATION_PREFERENCE) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDisplayAutoRotationPreferencesByProcessId(
        dwProcessId: DWORD,
        pOrientation: *mut ORIENTATION_PREFERENCE,
        fRotateScreen: *mut BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDisplayAutoRotationPreferences(orientation: ORIENTATION_PREFERENCE) -> BOOL;
}
unsafe extern "C" {
    pub fn IsImmersiveProcess(hProcess: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessRestrictionExemption(fEnableExemption: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDateFormatA(
        Locale: LCID,
        dwFlags: DWORD,
        lpDate: *const SYSTEMTIME,
        lpFormat: LPCSTR,
        lpDateStr: LPSTR,
        cchDate: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDateFormatW(
        Locale: LCID,
        dwFlags: DWORD,
        lpDate: *const SYSTEMTIME,
        lpFormat: LPCWSTR,
        lpDateStr: LPWSTR,
        cchDate: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTimeFormatA(
        Locale: LCID,
        dwFlags: DWORD,
        lpTime: *const SYSTEMTIME,
        lpFormat: LPCSTR,
        lpTimeStr: LPSTR,
        cchTime: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTimeFormatW(
        Locale: LCID,
        dwFlags: DWORD,
        lpTime: *const SYSTEMTIME,
        lpFormat: LPCWSTR,
        lpTimeStr: LPWSTR,
        cchTime: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetTimeFormatEx(
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lpTime: *const SYSTEMTIME,
        lpFormat: LPCWSTR,
        lpTimeStr: LPWSTR,
        cchTime: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDateFormatEx(
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lpDate: *const SYSTEMTIME,
        lpFormat: LPCWSTR,
        lpDateStr: LPWSTR,
        cchDate: ::std::os::raw::c_int,
        lpCalendar: LPCWSTR,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDurationFormatEx(
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lpDuration: *const SYSTEMTIME,
        ullDuration: ULONGLONG,
        lpFormat: LPCWSTR,
        lpDurationStr: LPWSTR,
        cchDuration: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
pub type LGRPID = DWORD;
pub type LCTYPE = DWORD;
pub type CALTYPE = DWORD;
pub type CALID = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _cpinfo {
    pub MaxCharSize: UINT,
    pub DefaultChar: [BYTE; 2usize],
    pub LeadByte: [BYTE; 12usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _cpinfo"][::std::mem::size_of::<_cpinfo>() - 20usize];
    ["Alignment of _cpinfo"][::std::mem::align_of::<_cpinfo>() - 4usize];
    ["Offset of field: _cpinfo::MaxCharSize"]
        [::std::mem::offset_of!(_cpinfo, MaxCharSize) - 0usize];
    ["Offset of field: _cpinfo::DefaultChar"]
        [::std::mem::offset_of!(_cpinfo, DefaultChar) - 4usize];
    ["Offset of field: _cpinfo::LeadByte"][::std::mem::offset_of!(_cpinfo, LeadByte) - 6usize];
};
pub type CPINFO = _cpinfo;
pub type LPCPINFO = *mut _cpinfo;
pub type GEOTYPE = DWORD;
pub type GEOCLASS = DWORD;
pub type GEOID = LONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _cpinfoexA {
    pub MaxCharSize: UINT,
    pub DefaultChar: [BYTE; 2usize],
    pub LeadByte: [BYTE; 12usize],
    pub UnicodeDefaultChar: WCHAR,
    pub CodePage: UINT,
    pub CodePageName: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _cpinfoexA"][::std::mem::size_of::<_cpinfoexA>() - 284usize];
    ["Alignment of _cpinfoexA"][::std::mem::align_of::<_cpinfoexA>() - 4usize];
    ["Offset of field: _cpinfoexA::MaxCharSize"]
        [::std::mem::offset_of!(_cpinfoexA, MaxCharSize) - 0usize];
    ["Offset of field: _cpinfoexA::DefaultChar"]
        [::std::mem::offset_of!(_cpinfoexA, DefaultChar) - 4usize];
    ["Offset of field: _cpinfoexA::LeadByte"]
        [::std::mem::offset_of!(_cpinfoexA, LeadByte) - 6usize];
    ["Offset of field: _cpinfoexA::UnicodeDefaultChar"]
        [::std::mem::offset_of!(_cpinfoexA, UnicodeDefaultChar) - 18usize];
    ["Offset of field: _cpinfoexA::CodePage"]
        [::std::mem::offset_of!(_cpinfoexA, CodePage) - 20usize];
    ["Offset of field: _cpinfoexA::CodePageName"]
        [::std::mem::offset_of!(_cpinfoexA, CodePageName) - 24usize];
};
pub type CPINFOEXA = _cpinfoexA;
pub type LPCPINFOEXA = *mut _cpinfoexA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _cpinfoexW {
    pub MaxCharSize: UINT,
    pub DefaultChar: [BYTE; 2usize],
    pub LeadByte: [BYTE; 12usize],
    pub UnicodeDefaultChar: WCHAR,
    pub CodePage: UINT,
    pub CodePageName: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _cpinfoexW"][::std::mem::size_of::<_cpinfoexW>() - 544usize];
    ["Alignment of _cpinfoexW"][::std::mem::align_of::<_cpinfoexW>() - 4usize];
    ["Offset of field: _cpinfoexW::MaxCharSize"]
        [::std::mem::offset_of!(_cpinfoexW, MaxCharSize) - 0usize];
    ["Offset of field: _cpinfoexW::DefaultChar"]
        [::std::mem::offset_of!(_cpinfoexW, DefaultChar) - 4usize];
    ["Offset of field: _cpinfoexW::LeadByte"]
        [::std::mem::offset_of!(_cpinfoexW, LeadByte) - 6usize];
    ["Offset of field: _cpinfoexW::UnicodeDefaultChar"]
        [::std::mem::offset_of!(_cpinfoexW, UnicodeDefaultChar) - 18usize];
    ["Offset of field: _cpinfoexW::CodePage"]
        [::std::mem::offset_of!(_cpinfoexW, CodePage) - 20usize];
    ["Offset of field: _cpinfoexW::CodePageName"]
        [::std::mem::offset_of!(_cpinfoexW, CodePageName) - 24usize];
};
pub type CPINFOEXW = _cpinfoexW;
pub type LPCPINFOEXW = *mut _cpinfoexW;
pub type CPINFOEX = CPINFOEXA;
pub type LPCPINFOEX = LPCPINFOEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _numberfmtA {
    pub NumDigits: UINT,
    pub LeadingZero: UINT,
    pub Grouping: UINT,
    pub lpDecimalSep: LPSTR,
    pub lpThousandSep: LPSTR,
    pub NegativeOrder: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _numberfmtA"][::std::mem::size_of::<_numberfmtA>() - 40usize];
    ["Alignment of _numberfmtA"][::std::mem::align_of::<_numberfmtA>() - 8usize];
    ["Offset of field: _numberfmtA::NumDigits"]
        [::std::mem::offset_of!(_numberfmtA, NumDigits) - 0usize];
    ["Offset of field: _numberfmtA::LeadingZero"]
        [::std::mem::offset_of!(_numberfmtA, LeadingZero) - 4usize];
    ["Offset of field: _numberfmtA::Grouping"]
        [::std::mem::offset_of!(_numberfmtA, Grouping) - 8usize];
    ["Offset of field: _numberfmtA::lpDecimalSep"]
        [::std::mem::offset_of!(_numberfmtA, lpDecimalSep) - 16usize];
    ["Offset of field: _numberfmtA::lpThousandSep"]
        [::std::mem::offset_of!(_numberfmtA, lpThousandSep) - 24usize];
    ["Offset of field: _numberfmtA::NegativeOrder"]
        [::std::mem::offset_of!(_numberfmtA, NegativeOrder) - 32usize];
};
pub type NUMBERFMTA = _numberfmtA;
pub type LPNUMBERFMTA = *mut _numberfmtA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _numberfmtW {
    pub NumDigits: UINT,
    pub LeadingZero: UINT,
    pub Grouping: UINT,
    pub lpDecimalSep: LPWSTR,
    pub lpThousandSep: LPWSTR,
    pub NegativeOrder: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _numberfmtW"][::std::mem::size_of::<_numberfmtW>() - 40usize];
    ["Alignment of _numberfmtW"][::std::mem::align_of::<_numberfmtW>() - 8usize];
    ["Offset of field: _numberfmtW::NumDigits"]
        [::std::mem::offset_of!(_numberfmtW, NumDigits) - 0usize];
    ["Offset of field: _numberfmtW::LeadingZero"]
        [::std::mem::offset_of!(_numberfmtW, LeadingZero) - 4usize];
    ["Offset of field: _numberfmtW::Grouping"]
        [::std::mem::offset_of!(_numberfmtW, Grouping) - 8usize];
    ["Offset of field: _numberfmtW::lpDecimalSep"]
        [::std::mem::offset_of!(_numberfmtW, lpDecimalSep) - 16usize];
    ["Offset of field: _numberfmtW::lpThousandSep"]
        [::std::mem::offset_of!(_numberfmtW, lpThousandSep) - 24usize];
    ["Offset of field: _numberfmtW::NegativeOrder"]
        [::std::mem::offset_of!(_numberfmtW, NegativeOrder) - 32usize];
};
pub type NUMBERFMTW = _numberfmtW;
pub type LPNUMBERFMTW = *mut _numberfmtW;
pub type NUMBERFMT = NUMBERFMTA;
pub type LPNUMBERFMT = LPNUMBERFMTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _currencyfmtA {
    pub NumDigits: UINT,
    pub LeadingZero: UINT,
    pub Grouping: UINT,
    pub lpDecimalSep: LPSTR,
    pub lpThousandSep: LPSTR,
    pub NegativeOrder: UINT,
    pub PositiveOrder: UINT,
    pub lpCurrencySymbol: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _currencyfmtA"][::std::mem::size_of::<_currencyfmtA>() - 48usize];
    ["Alignment of _currencyfmtA"][::std::mem::align_of::<_currencyfmtA>() - 8usize];
    ["Offset of field: _currencyfmtA::NumDigits"]
        [::std::mem::offset_of!(_currencyfmtA, NumDigits) - 0usize];
    ["Offset of field: _currencyfmtA::LeadingZero"]
        [::std::mem::offset_of!(_currencyfmtA, LeadingZero) - 4usize];
    ["Offset of field: _currencyfmtA::Grouping"]
        [::std::mem::offset_of!(_currencyfmtA, Grouping) - 8usize];
    ["Offset of field: _currencyfmtA::lpDecimalSep"]
        [::std::mem::offset_of!(_currencyfmtA, lpDecimalSep) - 16usize];
    ["Offset of field: _currencyfmtA::lpThousandSep"]
        [::std::mem::offset_of!(_currencyfmtA, lpThousandSep) - 24usize];
    ["Offset of field: _currencyfmtA::NegativeOrder"]
        [::std::mem::offset_of!(_currencyfmtA, NegativeOrder) - 32usize];
    ["Offset of field: _currencyfmtA::PositiveOrder"]
        [::std::mem::offset_of!(_currencyfmtA, PositiveOrder) - 36usize];
    ["Offset of field: _currencyfmtA::lpCurrencySymbol"]
        [::std::mem::offset_of!(_currencyfmtA, lpCurrencySymbol) - 40usize];
};
pub type CURRENCYFMTA = _currencyfmtA;
pub type LPCURRENCYFMTA = *mut _currencyfmtA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _currencyfmtW {
    pub NumDigits: UINT,
    pub LeadingZero: UINT,
    pub Grouping: UINT,
    pub lpDecimalSep: LPWSTR,
    pub lpThousandSep: LPWSTR,
    pub NegativeOrder: UINT,
    pub PositiveOrder: UINT,
    pub lpCurrencySymbol: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _currencyfmtW"][::std::mem::size_of::<_currencyfmtW>() - 48usize];
    ["Alignment of _currencyfmtW"][::std::mem::align_of::<_currencyfmtW>() - 8usize];
    ["Offset of field: _currencyfmtW::NumDigits"]
        [::std::mem::offset_of!(_currencyfmtW, NumDigits) - 0usize];
    ["Offset of field: _currencyfmtW::LeadingZero"]
        [::std::mem::offset_of!(_currencyfmtW, LeadingZero) - 4usize];
    ["Offset of field: _currencyfmtW::Grouping"]
        [::std::mem::offset_of!(_currencyfmtW, Grouping) - 8usize];
    ["Offset of field: _currencyfmtW::lpDecimalSep"]
        [::std::mem::offset_of!(_currencyfmtW, lpDecimalSep) - 16usize];
    ["Offset of field: _currencyfmtW::lpThousandSep"]
        [::std::mem::offset_of!(_currencyfmtW, lpThousandSep) - 24usize];
    ["Offset of field: _currencyfmtW::NegativeOrder"]
        [::std::mem::offset_of!(_currencyfmtW, NegativeOrder) - 32usize];
    ["Offset of field: _currencyfmtW::PositiveOrder"]
        [::std::mem::offset_of!(_currencyfmtW, PositiveOrder) - 36usize];
    ["Offset of field: _currencyfmtW::lpCurrencySymbol"]
        [::std::mem::offset_of!(_currencyfmtW, lpCurrencySymbol) - 40usize];
};
pub type CURRENCYFMTW = _currencyfmtW;
pub type LPCURRENCYFMTW = *mut _currencyfmtW;
pub type CURRENCYFMT = CURRENCYFMTA;
pub type LPCURRENCYFMT = LPCURRENCYFMTA;
pub const SYSNLS_FUNCTION_COMPARE_STRING: SYSNLS_FUNCTION = 1;
pub type SYSNLS_FUNCTION = ::std::os::raw::c_int;
pub type NLS_FUNCTION = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _nlsversioninfo {
    pub dwNLSVersionInfoSize: DWORD,
    pub dwNLSVersion: DWORD,
    pub dwDefinedVersion: DWORD,
    pub dwEffectiveId: DWORD,
    pub guidCustomVersion: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _nlsversioninfo"][::std::mem::size_of::<_nlsversioninfo>() - 32usize];
    ["Alignment of _nlsversioninfo"][::std::mem::align_of::<_nlsversioninfo>() - 4usize];
    ["Offset of field: _nlsversioninfo::dwNLSVersionInfoSize"]
        [::std::mem::offset_of!(_nlsversioninfo, dwNLSVersionInfoSize) - 0usize];
    ["Offset of field: _nlsversioninfo::dwNLSVersion"]
        [::std::mem::offset_of!(_nlsversioninfo, dwNLSVersion) - 4usize];
    ["Offset of field: _nlsversioninfo::dwDefinedVersion"]
        [::std::mem::offset_of!(_nlsversioninfo, dwDefinedVersion) - 8usize];
    ["Offset of field: _nlsversioninfo::dwEffectiveId"]
        [::std::mem::offset_of!(_nlsversioninfo, dwEffectiveId) - 12usize];
    ["Offset of field: _nlsversioninfo::guidCustomVersion"]
        [::std::mem::offset_of!(_nlsversioninfo, guidCustomVersion) - 16usize];
};
pub type NLSVERSIONINFO = _nlsversioninfo;
pub type LPNLSVERSIONINFO = *mut _nlsversioninfo;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _nlsversioninfoex {
    pub dwNLSVersionInfoSize: DWORD,
    pub dwNLSVersion: DWORD,
    pub dwDefinedVersion: DWORD,
    pub dwEffectiveId: DWORD,
    pub guidCustomVersion: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _nlsversioninfoex"][::std::mem::size_of::<_nlsversioninfoex>() - 32usize];
    ["Alignment of _nlsversioninfoex"][::std::mem::align_of::<_nlsversioninfoex>() - 4usize];
    ["Offset of field: _nlsversioninfoex::dwNLSVersionInfoSize"]
        [::std::mem::offset_of!(_nlsversioninfoex, dwNLSVersionInfoSize) - 0usize];
    ["Offset of field: _nlsversioninfoex::dwNLSVersion"]
        [::std::mem::offset_of!(_nlsversioninfoex, dwNLSVersion) - 4usize];
    ["Offset of field: _nlsversioninfoex::dwDefinedVersion"]
        [::std::mem::offset_of!(_nlsversioninfoex, dwDefinedVersion) - 8usize];
    ["Offset of field: _nlsversioninfoex::dwEffectiveId"]
        [::std::mem::offset_of!(_nlsversioninfoex, dwEffectiveId) - 12usize];
    ["Offset of field: _nlsversioninfoex::guidCustomVersion"]
        [::std::mem::offset_of!(_nlsversioninfoex, guidCustomVersion) - 16usize];
};
pub type NLSVERSIONINFOEX = _nlsversioninfoex;
pub type LPNLSVERSIONINFOEX = *mut _nlsversioninfoex;
pub const SYSGEOTYPE_GEO_NATION: SYSGEOTYPE = 1;
pub const SYSGEOTYPE_GEO_LATITUDE: SYSGEOTYPE = 2;
pub const SYSGEOTYPE_GEO_LONGITUDE: SYSGEOTYPE = 3;
pub const SYSGEOTYPE_GEO_ISO2: SYSGEOTYPE = 4;
pub const SYSGEOTYPE_GEO_ISO3: SYSGEOTYPE = 5;
pub const SYSGEOTYPE_GEO_RFC1766: SYSGEOTYPE = 6;
pub const SYSGEOTYPE_GEO_LCID: SYSGEOTYPE = 7;
pub const SYSGEOTYPE_GEO_FRIENDLYNAME: SYSGEOTYPE = 8;
pub const SYSGEOTYPE_GEO_OFFICIALNAME: SYSGEOTYPE = 9;
pub const SYSGEOTYPE_GEO_TIMEZONES: SYSGEOTYPE = 10;
pub const SYSGEOTYPE_GEO_OFFICIALLANGUAGES: SYSGEOTYPE = 11;
pub const SYSGEOTYPE_GEO_ISO_UN_NUMBER: SYSGEOTYPE = 12;
pub const SYSGEOTYPE_GEO_PARENT: SYSGEOTYPE = 13;
pub const SYSGEOTYPE_GEO_DIALINGCODE: SYSGEOTYPE = 14;
pub const SYSGEOTYPE_GEO_CURRENCYCODE: SYSGEOTYPE = 15;
pub const SYSGEOTYPE_GEO_CURRENCYSYMBOL: SYSGEOTYPE = 16;
pub const SYSGEOTYPE_GEO_NAME: SYSGEOTYPE = 17;
pub const SYSGEOTYPE_GEO_ID: SYSGEOTYPE = 18;
pub type SYSGEOTYPE = ::std::os::raw::c_int;
pub const SYSGEOCLASS_GEOCLASS_NATION: SYSGEOCLASS = 16;
pub const SYSGEOCLASS_GEOCLASS_REGION: SYSGEOCLASS = 14;
pub const SYSGEOCLASS_GEOCLASS_ALL: SYSGEOCLASS = 0;
pub type SYSGEOCLASS = ::std::os::raw::c_int;
pub type LOCALE_ENUMPROCA = ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR) -> BOOL>;
pub type LOCALE_ENUMPROCW = ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR) -> BOOL>;
pub const _NORM_FORM_NormalizationOther: _NORM_FORM = 0;
pub const _NORM_FORM_NormalizationC: _NORM_FORM = 1;
pub const _NORM_FORM_NormalizationD: _NORM_FORM = 2;
pub const _NORM_FORM_NormalizationKC: _NORM_FORM = 5;
pub const _NORM_FORM_NormalizationKD: _NORM_FORM = 6;
pub type _NORM_FORM = ::std::os::raw::c_int;
pub use self::_NORM_FORM as NORM_FORM;
pub type LANGUAGEGROUP_ENUMPROCA = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: LGRPID,
        arg2: LPSTR,
        arg3: LPSTR,
        arg4: DWORD,
        arg5: LONG_PTR,
    ) -> BOOL,
>;
pub type LANGGROUPLOCALE_ENUMPROCA = ::std::option::Option<
    unsafe extern "C" fn(arg1: LGRPID, arg2: LCID, arg3: LPSTR, arg4: LONG_PTR) -> BOOL,
>;
pub type UILANGUAGE_ENUMPROCA =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR, arg2: LONG_PTR) -> BOOL>;
pub type CODEPAGE_ENUMPROCA = ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR) -> BOOL>;
pub type DATEFMT_ENUMPROCA = ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR) -> BOOL>;
pub type DATEFMT_ENUMPROCEXA =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR, arg2: CALID) -> BOOL>;
pub type TIMEFMT_ENUMPROCA = ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR) -> BOOL>;
pub type CALINFO_ENUMPROCA = ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR) -> BOOL>;
pub type CALINFO_ENUMPROCEXA =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPSTR, arg2: CALID) -> BOOL>;
pub type LANGUAGEGROUP_ENUMPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: LGRPID,
        arg2: LPWSTR,
        arg3: LPWSTR,
        arg4: DWORD,
        arg5: LONG_PTR,
    ) -> BOOL,
>;
pub type LANGGROUPLOCALE_ENUMPROCW = ::std::option::Option<
    unsafe extern "C" fn(arg1: LGRPID, arg2: LCID, arg3: LPWSTR, arg4: LONG_PTR) -> BOOL,
>;
pub type UILANGUAGE_ENUMPROCW =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: LONG_PTR) -> BOOL>;
pub type CODEPAGE_ENUMPROCW = ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR) -> BOOL>;
pub type DATEFMT_ENUMPROCW = ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR) -> BOOL>;
pub type DATEFMT_ENUMPROCEXW =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: CALID) -> BOOL>;
pub type TIMEFMT_ENUMPROCW = ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR) -> BOOL>;
pub type CALINFO_ENUMPROCW = ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR) -> BOOL>;
pub type CALINFO_ENUMPROCEXW =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: CALID) -> BOOL>;
pub type GEO_ENUMPROC = ::std::option::Option<unsafe extern "C" fn(arg1: GEOID) -> BOOL>;
pub type GEO_ENUMNAMEPROC =
    ::std::option::Option<unsafe extern "C" fn(arg1: PWSTR, arg2: LPARAM) -> BOOL>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILEMUIINFO {
    pub dwSize: DWORD,
    pub dwVersion: DWORD,
    pub dwFileType: DWORD,
    pub pChecksum: [BYTE; 16usize],
    pub pServiceChecksum: [BYTE; 16usize],
    pub dwLanguageNameOffset: DWORD,
    pub dwTypeIDMainSize: DWORD,
    pub dwTypeIDMainOffset: DWORD,
    pub dwTypeNameMainOffset: DWORD,
    pub dwTypeIDMUISize: DWORD,
    pub dwTypeIDMUIOffset: DWORD,
    pub dwTypeNameMUIOffset: DWORD,
    pub abBuffer: [BYTE; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILEMUIINFO"][::std::mem::size_of::<_FILEMUIINFO>() - 80usize];
    ["Alignment of _FILEMUIINFO"][::std::mem::align_of::<_FILEMUIINFO>() - 4usize];
    ["Offset of field: _FILEMUIINFO::dwSize"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwSize) - 0usize];
    ["Offset of field: _FILEMUIINFO::dwVersion"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwVersion) - 4usize];
    ["Offset of field: _FILEMUIINFO::dwFileType"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwFileType) - 8usize];
    ["Offset of field: _FILEMUIINFO::pChecksum"]
        [::std::mem::offset_of!(_FILEMUIINFO, pChecksum) - 12usize];
    ["Offset of field: _FILEMUIINFO::pServiceChecksum"]
        [::std::mem::offset_of!(_FILEMUIINFO, pServiceChecksum) - 28usize];
    ["Offset of field: _FILEMUIINFO::dwLanguageNameOffset"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwLanguageNameOffset) - 44usize];
    ["Offset of field: _FILEMUIINFO::dwTypeIDMainSize"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeIDMainSize) - 48usize];
    ["Offset of field: _FILEMUIINFO::dwTypeIDMainOffset"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeIDMainOffset) - 52usize];
    ["Offset of field: _FILEMUIINFO::dwTypeNameMainOffset"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeNameMainOffset) - 56usize];
    ["Offset of field: _FILEMUIINFO::dwTypeIDMUISize"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeIDMUISize) - 60usize];
    ["Offset of field: _FILEMUIINFO::dwTypeIDMUIOffset"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeIDMUIOffset) - 64usize];
    ["Offset of field: _FILEMUIINFO::dwTypeNameMUIOffset"]
        [::std::mem::offset_of!(_FILEMUIINFO, dwTypeNameMUIOffset) - 68usize];
    ["Offset of field: _FILEMUIINFO::abBuffer"]
        [::std::mem::offset_of!(_FILEMUIINFO, abBuffer) - 72usize];
};
pub type FILEMUIINFO = _FILEMUIINFO;
pub type PFILEMUIINFO = *mut _FILEMUIINFO;
unsafe extern "C" {
    pub fn CompareStringEx(
        lpLocaleName: LPCWSTR,
        dwCmpFlags: DWORD,
        lpString1: LPCWCH,
        cchCount1: ::std::os::raw::c_int,
        lpString2: LPCWCH,
        cchCount2: ::std::os::raw::c_int,
        lpVersionInformation: LPNLSVERSIONINFO,
        lpReserved: LPVOID,
        lParam: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CompareStringOrdinal(
        lpString1: LPCWCH,
        cchCount1: ::std::os::raw::c_int,
        lpString2: LPCWCH,
        cchCount2: ::std::os::raw::c_int,
        bIgnoreCase: BOOL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CompareStringW(
        Locale: LCID,
        dwCmpFlags: DWORD,
        lpString1: PCNZWCH,
        cchCount1: ::std::os::raw::c_int,
        lpString2: PCNZWCH,
        cchCount2: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn FoldStringW(
        dwMapFlags: DWORD,
        lpSrcStr: LPCWCH,
        cchSrc: ::std::os::raw::c_int,
        lpDestStr: LPWSTR,
        cchDest: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetStringTypeExW(
        Locale: LCID,
        dwInfoType: DWORD,
        lpSrcStr: LPCWCH,
        cchSrc: ::std::os::raw::c_int,
        lpCharType: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetStringTypeW(
        dwInfoType: DWORD,
        lpSrcStr: LPCWCH,
        cchSrc: ::std::os::raw::c_int,
        lpCharType: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn MultiByteToWideChar(
        CodePage: UINT,
        dwFlags: DWORD,
        lpMultiByteStr: LPCCH,
        cbMultiByte: ::std::os::raw::c_int,
        lpWideCharStr: LPWSTR,
        cchWideChar: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WideCharToMultiByte(
        CodePage: UINT,
        dwFlags: DWORD,
        lpWideCharStr: LPCWCH,
        cchWideChar: ::std::os::raw::c_int,
        lpMultiByteStr: LPSTR,
        cbMultiByte: ::std::os::raw::c_int,
        lpDefaultChar: LPCCH,
        lpUsedDefaultChar: LPBOOL,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IsValidCodePage(CodePage: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn GetACP() -> UINT;
}
unsafe extern "C" {
    pub fn GetOEMCP() -> UINT;
}
unsafe extern "C" {
    pub fn GetCPInfo(CodePage: UINT, lpCPInfo: LPCPINFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCPInfoExA(CodePage: UINT, dwFlags: DWORD, lpCPInfoEx: LPCPINFOEXA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCPInfoExW(CodePage: UINT, dwFlags: DWORD, lpCPInfoEx: LPCPINFOEXW) -> BOOL;
}
unsafe extern "C" {
    pub fn CompareStringA(
        Locale: LCID,
        dwCmpFlags: DWORD,
        lpString1: PCNZCH,
        cchCount1: ::std::os::raw::c_int,
        lpString2: PCNZCH,
        cchCount2: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn FindNLSString(
        Locale: LCID,
        dwFindNLSStringFlags: DWORD,
        lpStringSource: LPCWSTR,
        cchSource: ::std::os::raw::c_int,
        lpStringValue: LPCWSTR,
        cchValue: ::std::os::raw::c_int,
        pcchFound: LPINT,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LCMapStringW(
        Locale: LCID,
        dwMapFlags: DWORD,
        lpSrcStr: LPCWSTR,
        cchSrc: ::std::os::raw::c_int,
        lpDestStr: LPWSTR,
        cchDest: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LCMapStringA(
        Locale: LCID,
        dwMapFlags: DWORD,
        lpSrcStr: LPCSTR,
        cchSrc: ::std::os::raw::c_int,
        lpDestStr: LPSTR,
        cchDest: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetLocaleInfoW(
        Locale: LCID,
        LCType: LCTYPE,
        lpLCData: LPWSTR,
        cchData: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetLocaleInfoA(
        Locale: LCID,
        LCType: LCTYPE,
        lpLCData: LPSTR,
        cchData: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetLocaleInfoA(Locale: LCID, LCType: LCTYPE, lpLCData: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetLocaleInfoW(Locale: LCID, LCType: LCTYPE, lpLCData: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetCalendarInfoA(
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
        lpCalData: LPSTR,
        cchData: ::std::os::raw::c_int,
        lpValue: LPDWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCalendarInfoW(
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
        lpCalData: LPWSTR,
        cchData: ::std::os::raw::c_int,
        lpValue: LPDWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetCalendarInfoA(
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
        lpCalData: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCalendarInfoW(
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
        lpCalData: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LoadStringByReference(
        Flags: DWORD,
        Language: PCWSTR,
        SourceString: PCWSTR,
        Buffer: PWSTR,
        cchBuffer: ULONG,
        Directory: PCWSTR,
        pcchBufferOut: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsDBCSLeadByte(TestChar: BYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn IsDBCSLeadByteEx(CodePage: UINT, TestChar: BYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn LocaleNameToLCID(lpName: LPCWSTR, dwFlags: DWORD) -> LCID;
}
unsafe extern "C" {
    pub fn LCIDToLocaleName(
        Locale: LCID,
        lpName: LPWSTR,
        cchName: ::std::os::raw::c_int,
        dwFlags: DWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetDurationFormat(
        Locale: LCID,
        dwFlags: DWORD,
        lpDuration: *const SYSTEMTIME,
        ullDuration: ULONGLONG,
        lpFormat: LPCWSTR,
        lpDurationStr: LPWSTR,
        cchDuration: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetNumberFormatA(
        Locale: LCID,
        dwFlags: DWORD,
        lpValue: LPCSTR,
        lpFormat: *const NUMBERFMTA,
        lpNumberStr: LPSTR,
        cchNumber: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetNumberFormatW(
        Locale: LCID,
        dwFlags: DWORD,
        lpValue: LPCWSTR,
        lpFormat: *const NUMBERFMTW,
        lpNumberStr: LPWSTR,
        cchNumber: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCurrencyFormatA(
        Locale: LCID,
        dwFlags: DWORD,
        lpValue: LPCSTR,
        lpFormat: *const CURRENCYFMTA,
        lpCurrencyStr: LPSTR,
        cchCurrency: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCurrencyFormatW(
        Locale: LCID,
        dwFlags: DWORD,
        lpValue: LPCWSTR,
        lpFormat: *const CURRENCYFMTW,
        lpCurrencyStr: LPWSTR,
        cchCurrency: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumCalendarInfoA(
        lpCalInfoEnumProc: CALINFO_ENUMPROCA,
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumCalendarInfoW(
        lpCalInfoEnumProc: CALINFO_ENUMPROCW,
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumCalendarInfoExA(
        lpCalInfoEnumProcEx: CALINFO_ENUMPROCEXA,
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumCalendarInfoExW(
        lpCalInfoEnumProcEx: CALINFO_ENUMPROCEXW,
        Locale: LCID,
        Calendar: CALID,
        CalType: CALTYPE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumTimeFormatsA(
        lpTimeFmtEnumProc: TIMEFMT_ENUMPROCA,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumTimeFormatsW(
        lpTimeFmtEnumProc: TIMEFMT_ENUMPROCW,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDateFormatsA(
        lpDateFmtEnumProc: DATEFMT_ENUMPROCA,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDateFormatsW(
        lpDateFmtEnumProc: DATEFMT_ENUMPROCW,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDateFormatsExA(
        lpDateFmtEnumProcEx: DATEFMT_ENUMPROCEXA,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDateFormatsExW(
        lpDateFmtEnumProcEx: DATEFMT_ENUMPROCEXW,
        Locale: LCID,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidLanguageGroup(LanguageGroup: LGRPID, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNLSVersion(
        Function: NLS_FUNCTION,
        Locale: LCID,
        lpVersionInformation: LPNLSVERSIONINFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidLocale(Locale: LCID, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetGeoInfoA(
        Location: GEOID,
        GeoType: GEOTYPE,
        lpGeoData: LPSTR,
        cchData: ::std::os::raw::c_int,
        LangId: LANGID,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetGeoInfoW(
        Location: GEOID,
        GeoType: GEOTYPE,
        lpGeoData: LPWSTR,
        cchData: ::std::os::raw::c_int,
        LangId: LANGID,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetGeoInfoEx(
        location: PWSTR,
        geoType: GEOTYPE,
        geoData: PWSTR,
        geoDataCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumSystemGeoID(
        GeoClass: GEOCLASS,
        ParentGeoId: GEOID,
        lpGeoEnumProc: GEO_ENUMPROC,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemGeoNames(
        geoClass: GEOCLASS,
        geoEnumProc: GEO_ENUMNAMEPROC,
        data: LPARAM,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserGeoID(GeoClass: GEOCLASS) -> GEOID;
}
unsafe extern "C" {
    pub fn GetUserDefaultGeoName(
        geoName: LPWSTR,
        geoNameCount: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SetUserGeoID(GeoId: GEOID) -> BOOL;
}
unsafe extern "C" {
    pub fn SetUserGeoName(geoName: PWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ConvertDefaultLocale(Locale: LCID) -> LCID;
}
unsafe extern "C" {
    pub fn GetSystemDefaultUILanguage() -> LANGID;
}
unsafe extern "C" {
    pub fn GetThreadLocale() -> LCID;
}
unsafe extern "C" {
    pub fn SetThreadLocale(Locale: LCID) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserDefaultUILanguage() -> LANGID;
}
unsafe extern "C" {
    pub fn GetUserDefaultLangID() -> LANGID;
}
unsafe extern "C" {
    pub fn GetSystemDefaultLangID() -> LANGID;
}
unsafe extern "C" {
    pub fn GetSystemDefaultLCID() -> LCID;
}
unsafe extern "C" {
    pub fn GetUserDefaultLCID() -> LCID;
}
unsafe extern "C" {
    pub fn SetThreadUILanguage(LangId: LANGID) -> LANGID;
}
unsafe extern "C" {
    pub fn GetThreadUILanguage() -> LANGID;
}
unsafe extern "C" {
    pub fn GetProcessPreferredUILanguages(
        dwFlags: DWORD,
        pulNumLanguages: PULONG,
        pwszLanguagesBuffer: PZZWSTR,
        pcchLanguagesBuffer: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetProcessPreferredUILanguages(
        dwFlags: DWORD,
        pwszLanguagesBuffer: PCZZWSTR,
        pulNumLanguages: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUserPreferredUILanguages(
        dwFlags: DWORD,
        pulNumLanguages: PULONG,
        pwszLanguagesBuffer: PZZWSTR,
        pcchLanguagesBuffer: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSystemPreferredUILanguages(
        dwFlags: DWORD,
        pulNumLanguages: PULONG,
        pwszLanguagesBuffer: PZZWSTR,
        pcchLanguagesBuffer: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetThreadPreferredUILanguages(
        dwFlags: DWORD,
        pulNumLanguages: PULONG,
        pwszLanguagesBuffer: PZZWSTR,
        pcchLanguagesBuffer: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetThreadPreferredUILanguages(
        dwFlags: DWORD,
        pwszLanguagesBuffer: PCZZWSTR,
        pulNumLanguages: PULONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileMUIInfo(
        dwFlags: DWORD,
        pcwszFilePath: PCWSTR,
        pFileMUIInfo: PFILEMUIINFO,
        pcbFileMUIInfo: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileMUIPath(
        dwFlags: DWORD,
        pcwszFilePath: PCWSTR,
        pwszLanguage: PWSTR,
        pcchLanguage: PULONG,
        pwszFileMUIPath: PWSTR,
        pcchFileMUIPath: PULONG,
        pululEnumerator: PULONGLONG,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetUILanguageInfo(
        dwFlags: DWORD,
        pwmszLanguage: PCZZWSTR,
        pwszFallbackLanguages: PZZWSTR,
        pcchFallbackLanguages: PDWORD,
        pAttributes: PDWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HSAVEDUILANGUAGES__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HSAVEDUILANGUAGES__"][::std::mem::size_of::<HSAVEDUILANGUAGES__>() - 4usize];
    ["Alignment of HSAVEDUILANGUAGES__"][::std::mem::align_of::<HSAVEDUILANGUAGES__>() - 4usize];
    ["Offset of field: HSAVEDUILANGUAGES__::unused"]
        [::std::mem::offset_of!(HSAVEDUILANGUAGES__, unused) - 0usize];
};
pub type HSAVEDUILANGUAGES = *mut HSAVEDUILANGUAGES__;
unsafe extern "C" {
    pub fn SetThreadPreferredUILanguages2(
        flags: ULONG,
        languages: PCZZWSTR,
        numLanguagesSet: PULONG,
        snapshot: *mut HSAVEDUILANGUAGES,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RestoreThreadPreferredUILanguages(snapshot: HSAVEDUILANGUAGES);
}
unsafe extern "C" {
    pub fn NotifyUILanguageChange(
        dwFlags: DWORD,
        pcwstrNewLanguage: PCWSTR,
        pcwstrPreviousLanguage: PCWSTR,
        dwReserved: DWORD,
        pdwStatusRtrn: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetStringTypeExA(
        Locale: LCID,
        dwInfoType: DWORD,
        lpSrcStr: LPCSTR,
        cchSrc: ::std::os::raw::c_int,
        lpCharType: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetStringTypeA(
        Locale: LCID,
        dwInfoType: DWORD,
        lpSrcStr: LPCSTR,
        cchSrc: ::std::os::raw::c_int,
        lpCharType: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FoldStringA(
        dwMapFlags: DWORD,
        lpSrcStr: LPCSTR,
        cchSrc: ::std::os::raw::c_int,
        lpDestStr: LPSTR,
        cchDest: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn EnumSystemLocalesA(lpLocaleEnumProc: LOCALE_ENUMPROCA, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemLocalesW(lpLocaleEnumProc: LOCALE_ENUMPROCW, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemLanguageGroupsA(
        lpLanguageGroupEnumProc: LANGUAGEGROUP_ENUMPROCA,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemLanguageGroupsW(
        lpLanguageGroupEnumProc: LANGUAGEGROUP_ENUMPROCW,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumLanguageGroupLocalesA(
        lpLangGroupLocaleEnumProc: LANGGROUPLOCALE_ENUMPROCA,
        LanguageGroup: LGRPID,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumLanguageGroupLocalesW(
        lpLangGroupLocaleEnumProc: LANGGROUPLOCALE_ENUMPROCW,
        LanguageGroup: LGRPID,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumUILanguagesA(
        lpUILanguageEnumProc: UILANGUAGE_ENUMPROCA,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumUILanguagesW(
        lpUILanguageEnumProc: UILANGUAGE_ENUMPROCW,
        dwFlags: DWORD,
        lParam: LONG_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemCodePagesA(lpCodePageEnumProc: CODEPAGE_ENUMPROCA, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumSystemCodePagesW(lpCodePageEnumProc: CODEPAGE_ENUMPROCW, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn IdnToAscii(
        dwFlags: DWORD,
        lpUnicodeCharStr: LPCWSTR,
        cchUnicodeChar: ::std::os::raw::c_int,
        lpASCIICharStr: LPWSTR,
        cchASCIIChar: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IdnToUnicode(
        dwFlags: DWORD,
        lpASCIICharStr: LPCWSTR,
        cchASCIIChar: ::std::os::raw::c_int,
        lpUnicodeCharStr: LPWSTR,
        cchUnicodeChar: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IdnToNameprepUnicode(
        dwFlags: DWORD,
        lpUnicodeCharStr: LPCWSTR,
        cchUnicodeChar: ::std::os::raw::c_int,
        lpNameprepCharStr: LPWSTR,
        cchNameprepChar: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn NormalizeString(
        NormForm: NORM_FORM,
        lpSrcString: LPCWSTR,
        cwSrcLength: ::std::os::raw::c_int,
        lpDstString: LPWSTR,
        cwDstLength: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IsNormalizedString(
        NormForm: NORM_FORM,
        lpString: LPCWSTR,
        cwLength: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VerifyScripts(
        dwFlags: DWORD,
        lpLocaleScripts: LPCWSTR,
        cchLocaleScripts: ::std::os::raw::c_int,
        lpTestScripts: LPCWSTR,
        cchTestScripts: ::std::os::raw::c_int,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetStringScripts(
        dwFlags: DWORD,
        lpString: LPCWSTR,
        cchString: ::std::os::raw::c_int,
        lpScripts: LPWSTR,
        cchScripts: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetLocaleInfoEx(
        lpLocaleName: LPCWSTR,
        LCType: LCTYPE,
        lpLCData: LPWSTR,
        cchData: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCalendarInfoEx(
        lpLocaleName: LPCWSTR,
        Calendar: CALID,
        lpReserved: LPCWSTR,
        CalType: CALTYPE,
        lpCalData: LPWSTR,
        cchData: ::std::os::raw::c_int,
        lpValue: LPDWORD,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetNumberFormatEx(
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lpValue: LPCWSTR,
        lpFormat: *const NUMBERFMTW,
        lpNumberStr: LPWSTR,
        cchNumber: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetCurrencyFormatEx(
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lpValue: LPCWSTR,
        lpFormat: *const CURRENCYFMTW,
        lpCurrencyStr: LPWSTR,
        cchCurrency: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetUserDefaultLocaleName(
        lpLocaleName: LPWSTR,
        cchLocaleName: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn GetSystemDefaultLocaleName(
        lpLocaleName: LPWSTR,
        cchLocaleName: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IsNLSDefinedString(
        Function: NLS_FUNCTION,
        dwFlags: DWORD,
        lpVersionInformation: LPNLSVERSIONINFO,
        lpString: LPCWSTR,
        cchStr: INT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNLSVersionEx(
        function: NLS_FUNCTION,
        lpLocaleName: LPCWSTR,
        lpVersionInformation: LPNLSVERSIONINFOEX,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidNLSVersion(
        function: NLS_FUNCTION,
        lpLocaleName: LPCWSTR,
        lpVersionInformation: LPNLSVERSIONINFOEX,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn FindNLSStringEx(
        lpLocaleName: LPCWSTR,
        dwFindNLSStringFlags: DWORD,
        lpStringSource: LPCWSTR,
        cchSource: ::std::os::raw::c_int,
        lpStringValue: LPCWSTR,
        cchValue: ::std::os::raw::c_int,
        pcchFound: LPINT,
        lpVersionInformation: LPNLSVERSIONINFO,
        lpReserved: LPVOID,
        sortHandle: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn LCMapStringEx(
        lpLocaleName: LPCWSTR,
        dwMapFlags: DWORD,
        lpSrcStr: LPCWSTR,
        cchSrc: ::std::os::raw::c_int,
        lpDestStr: LPWSTR,
        cchDest: ::std::os::raw::c_int,
        lpVersionInformation: LPNLSVERSIONINFO,
        lpReserved: LPVOID,
        sortHandle: LPARAM,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IsValidLocaleName(lpLocaleName: LPCWSTR) -> BOOL;
}
pub type CALINFO_ENUMPROCEXEX = ::std::option::Option<
    unsafe extern "C" fn(arg1: LPWSTR, arg2: CALID, arg3: LPWSTR, arg4: LPARAM) -> BOOL,
>;
unsafe extern "C" {
    pub fn EnumCalendarInfoExEx(
        pCalInfoEnumProcExEx: CALINFO_ENUMPROCEXEX,
        lpLocaleName: LPCWSTR,
        Calendar: CALID,
        lpReserved: LPCWSTR,
        CalType: CALTYPE,
        lParam: LPARAM,
    ) -> BOOL;
}
pub type DATEFMT_ENUMPROCEXEX =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: CALID, arg3: LPARAM) -> BOOL>;
unsafe extern "C" {
    pub fn EnumDateFormatsExEx(
        lpDateFmtEnumProcExEx: DATEFMT_ENUMPROCEXEX,
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lParam: LPARAM,
    ) -> BOOL;
}
pub type TIMEFMT_ENUMPROCEX =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: LPARAM) -> BOOL>;
unsafe extern "C" {
    pub fn EnumTimeFormatsEx(
        lpTimeFmtEnumProcEx: TIMEFMT_ENUMPROCEX,
        lpLocaleName: LPCWSTR,
        dwFlags: DWORD,
        lParam: LPARAM,
    ) -> BOOL;
}
pub type LOCALE_ENUMPROCEX =
    ::std::option::Option<unsafe extern "C" fn(arg1: LPWSTR, arg2: DWORD, arg3: LPARAM) -> BOOL>;
unsafe extern "C" {
    pub fn EnumSystemLocalesEx(
        lpLocaleEnumProcEx: LOCALE_ENUMPROCEX,
        dwFlags: DWORD,
        lParam: LPARAM,
        lpReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ResolveLocaleName(
        lpNameToResolve: LPCWSTR,
        lpLocaleName: LPWSTR,
        cchLocaleName: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COORD {
    pub X: SHORT,
    pub Y: SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COORD"][::std::mem::size_of::<_COORD>() - 4usize];
    ["Alignment of _COORD"][::std::mem::align_of::<_COORD>() - 2usize];
    ["Offset of field: _COORD::X"][::std::mem::offset_of!(_COORD, X) - 0usize];
    ["Offset of field: _COORD::Y"][::std::mem::offset_of!(_COORD, Y) - 2usize];
};
pub type COORD = _COORD;
pub type PCOORD = *mut _COORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SMALL_RECT {
    pub Left: SHORT,
    pub Top: SHORT,
    pub Right: SHORT,
    pub Bottom: SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SMALL_RECT"][::std::mem::size_of::<_SMALL_RECT>() - 8usize];
    ["Alignment of _SMALL_RECT"][::std::mem::align_of::<_SMALL_RECT>() - 2usize];
    ["Offset of field: _SMALL_RECT::Left"][::std::mem::offset_of!(_SMALL_RECT, Left) - 0usize];
    ["Offset of field: _SMALL_RECT::Top"][::std::mem::offset_of!(_SMALL_RECT, Top) - 2usize];
    ["Offset of field: _SMALL_RECT::Right"][::std::mem::offset_of!(_SMALL_RECT, Right) - 4usize];
    ["Offset of field: _SMALL_RECT::Bottom"][::std::mem::offset_of!(_SMALL_RECT, Bottom) - 6usize];
};
pub type SMALL_RECT = _SMALL_RECT;
pub type PSMALL_RECT = *mut _SMALL_RECT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _KEY_EVENT_RECORD {
    pub bKeyDown: BOOL,
    pub wRepeatCount: WORD,
    pub wVirtualKeyCode: WORD,
    pub wVirtualScanCode: WORD,
    pub uChar: _KEY_EVENT_RECORD__bindgen_ty_1,
    pub dwControlKeyState: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _KEY_EVENT_RECORD__bindgen_ty_1 {
    pub UnicodeChar: WCHAR,
    pub AsciiChar: CHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KEY_EVENT_RECORD__bindgen_ty_1"]
        [::std::mem::size_of::<_KEY_EVENT_RECORD__bindgen_ty_1>() - 2usize];
    ["Alignment of _KEY_EVENT_RECORD__bindgen_ty_1"]
        [::std::mem::align_of::<_KEY_EVENT_RECORD__bindgen_ty_1>() - 2usize];
    ["Offset of field: _KEY_EVENT_RECORD__bindgen_ty_1::UnicodeChar"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD__bindgen_ty_1, UnicodeChar) - 0usize];
    ["Offset of field: _KEY_EVENT_RECORD__bindgen_ty_1::AsciiChar"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD__bindgen_ty_1, AsciiChar) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KEY_EVENT_RECORD"][::std::mem::size_of::<_KEY_EVENT_RECORD>() - 16usize];
    ["Alignment of _KEY_EVENT_RECORD"][::std::mem::align_of::<_KEY_EVENT_RECORD>() - 4usize];
    ["Offset of field: _KEY_EVENT_RECORD::bKeyDown"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, bKeyDown) - 0usize];
    ["Offset of field: _KEY_EVENT_RECORD::wRepeatCount"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, wRepeatCount) - 4usize];
    ["Offset of field: _KEY_EVENT_RECORD::wVirtualKeyCode"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, wVirtualKeyCode) - 6usize];
    ["Offset of field: _KEY_EVENT_RECORD::wVirtualScanCode"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, wVirtualScanCode) - 8usize];
    ["Offset of field: _KEY_EVENT_RECORD::uChar"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, uChar) - 10usize];
    ["Offset of field: _KEY_EVENT_RECORD::dwControlKeyState"]
        [::std::mem::offset_of!(_KEY_EVENT_RECORD, dwControlKeyState) - 12usize];
};
pub type KEY_EVENT_RECORD = _KEY_EVENT_RECORD;
pub type PKEY_EVENT_RECORD = *mut _KEY_EVENT_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MOUSE_EVENT_RECORD {
    pub dwMousePosition: COORD,
    pub dwButtonState: DWORD,
    pub dwControlKeyState: DWORD,
    pub dwEventFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MOUSE_EVENT_RECORD"][::std::mem::size_of::<_MOUSE_EVENT_RECORD>() - 16usize];
    ["Alignment of _MOUSE_EVENT_RECORD"][::std::mem::align_of::<_MOUSE_EVENT_RECORD>() - 4usize];
    ["Offset of field: _MOUSE_EVENT_RECORD::dwMousePosition"]
        [::std::mem::offset_of!(_MOUSE_EVENT_RECORD, dwMousePosition) - 0usize];
    ["Offset of field: _MOUSE_EVENT_RECORD::dwButtonState"]
        [::std::mem::offset_of!(_MOUSE_EVENT_RECORD, dwButtonState) - 4usize];
    ["Offset of field: _MOUSE_EVENT_RECORD::dwControlKeyState"]
        [::std::mem::offset_of!(_MOUSE_EVENT_RECORD, dwControlKeyState) - 8usize];
    ["Offset of field: _MOUSE_EVENT_RECORD::dwEventFlags"]
        [::std::mem::offset_of!(_MOUSE_EVENT_RECORD, dwEventFlags) - 12usize];
};
pub type MOUSE_EVENT_RECORD = _MOUSE_EVENT_RECORD;
pub type PMOUSE_EVENT_RECORD = *mut _MOUSE_EVENT_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WINDOW_BUFFER_SIZE_RECORD {
    pub dwSize: COORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WINDOW_BUFFER_SIZE_RECORD"]
        [::std::mem::size_of::<_WINDOW_BUFFER_SIZE_RECORD>() - 4usize];
    ["Alignment of _WINDOW_BUFFER_SIZE_RECORD"]
        [::std::mem::align_of::<_WINDOW_BUFFER_SIZE_RECORD>() - 2usize];
    ["Offset of field: _WINDOW_BUFFER_SIZE_RECORD::dwSize"]
        [::std::mem::offset_of!(_WINDOW_BUFFER_SIZE_RECORD, dwSize) - 0usize];
};
pub type WINDOW_BUFFER_SIZE_RECORD = _WINDOW_BUFFER_SIZE_RECORD;
pub type PWINDOW_BUFFER_SIZE_RECORD = *mut _WINDOW_BUFFER_SIZE_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MENU_EVENT_RECORD {
    pub dwCommandId: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MENU_EVENT_RECORD"][::std::mem::size_of::<_MENU_EVENT_RECORD>() - 4usize];
    ["Alignment of _MENU_EVENT_RECORD"][::std::mem::align_of::<_MENU_EVENT_RECORD>() - 4usize];
    ["Offset of field: _MENU_EVENT_RECORD::dwCommandId"]
        [::std::mem::offset_of!(_MENU_EVENT_RECORD, dwCommandId) - 0usize];
};
pub type MENU_EVENT_RECORD = _MENU_EVENT_RECORD;
pub type PMENU_EVENT_RECORD = *mut _MENU_EVENT_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FOCUS_EVENT_RECORD {
    pub bSetFocus: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FOCUS_EVENT_RECORD"][::std::mem::size_of::<_FOCUS_EVENT_RECORD>() - 4usize];
    ["Alignment of _FOCUS_EVENT_RECORD"][::std::mem::align_of::<_FOCUS_EVENT_RECORD>() - 4usize];
    ["Offset of field: _FOCUS_EVENT_RECORD::bSetFocus"]
        [::std::mem::offset_of!(_FOCUS_EVENT_RECORD, bSetFocus) - 0usize];
};
pub type FOCUS_EVENT_RECORD = _FOCUS_EVENT_RECORD;
pub type PFOCUS_EVENT_RECORD = *mut _FOCUS_EVENT_RECORD;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _INPUT_RECORD {
    pub EventType: WORD,
    pub Event: _INPUT_RECORD__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _INPUT_RECORD__bindgen_ty_1 {
    pub KeyEvent: KEY_EVENT_RECORD,
    pub MouseEvent: MOUSE_EVENT_RECORD,
    pub WindowBufferSizeEvent: WINDOW_BUFFER_SIZE_RECORD,
    pub MenuEvent: MENU_EVENT_RECORD,
    pub FocusEvent: FOCUS_EVENT_RECORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _INPUT_RECORD__bindgen_ty_1"]
        [::std::mem::size_of::<_INPUT_RECORD__bindgen_ty_1>() - 16usize];
    ["Alignment of _INPUT_RECORD__bindgen_ty_1"]
        [::std::mem::align_of::<_INPUT_RECORD__bindgen_ty_1>() - 4usize];
    ["Offset of field: _INPUT_RECORD__bindgen_ty_1::KeyEvent"]
        [::std::mem::offset_of!(_INPUT_RECORD__bindgen_ty_1, KeyEvent) - 0usize];
    ["Offset of field: _INPUT_RECORD__bindgen_ty_1::MouseEvent"]
        [::std::mem::offset_of!(_INPUT_RECORD__bindgen_ty_1, MouseEvent) - 0usize];
    ["Offset of field: _INPUT_RECORD__bindgen_ty_1::WindowBufferSizeEvent"]
        [::std::mem::offset_of!(_INPUT_RECORD__bindgen_ty_1, WindowBufferSizeEvent) - 0usize];
    ["Offset of field: _INPUT_RECORD__bindgen_ty_1::MenuEvent"]
        [::std::mem::offset_of!(_INPUT_RECORD__bindgen_ty_1, MenuEvent) - 0usize];
    ["Offset of field: _INPUT_RECORD__bindgen_ty_1::FocusEvent"]
        [::std::mem::offset_of!(_INPUT_RECORD__bindgen_ty_1, FocusEvent) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _INPUT_RECORD"][::std::mem::size_of::<_INPUT_RECORD>() - 20usize];
    ["Alignment of _INPUT_RECORD"][::std::mem::align_of::<_INPUT_RECORD>() - 4usize];
    ["Offset of field: _INPUT_RECORD::EventType"]
        [::std::mem::offset_of!(_INPUT_RECORD, EventType) - 0usize];
    ["Offset of field: _INPUT_RECORD::Event"]
        [::std::mem::offset_of!(_INPUT_RECORD, Event) - 4usize];
};
pub type INPUT_RECORD = _INPUT_RECORD;
pub type PINPUT_RECORD = *mut _INPUT_RECORD;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CHAR_INFO {
    pub Char: _CHAR_INFO__bindgen_ty_1,
    pub Attributes: WORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CHAR_INFO__bindgen_ty_1 {
    pub UnicodeChar: WCHAR,
    pub AsciiChar: CHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHAR_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CHAR_INFO__bindgen_ty_1>() - 2usize];
    ["Alignment of _CHAR_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CHAR_INFO__bindgen_ty_1>() - 2usize];
    ["Offset of field: _CHAR_INFO__bindgen_ty_1::UnicodeChar"]
        [::std::mem::offset_of!(_CHAR_INFO__bindgen_ty_1, UnicodeChar) - 0usize];
    ["Offset of field: _CHAR_INFO__bindgen_ty_1::AsciiChar"]
        [::std::mem::offset_of!(_CHAR_INFO__bindgen_ty_1, AsciiChar) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHAR_INFO"][::std::mem::size_of::<_CHAR_INFO>() - 4usize];
    ["Alignment of _CHAR_INFO"][::std::mem::align_of::<_CHAR_INFO>() - 2usize];
    ["Offset of field: _CHAR_INFO::Char"][::std::mem::offset_of!(_CHAR_INFO, Char) - 0usize];
    ["Offset of field: _CHAR_INFO::Attributes"]
        [::std::mem::offset_of!(_CHAR_INFO, Attributes) - 2usize];
};
pub type CHAR_INFO = _CHAR_INFO;
pub type PCHAR_INFO = *mut _CHAR_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_FONT_INFO {
    pub nFont: DWORD,
    pub dwFontSize: COORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_FONT_INFO"][::std::mem::size_of::<_CONSOLE_FONT_INFO>() - 8usize];
    ["Alignment of _CONSOLE_FONT_INFO"][::std::mem::align_of::<_CONSOLE_FONT_INFO>() - 4usize];
    ["Offset of field: _CONSOLE_FONT_INFO::nFont"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFO, nFont) - 0usize];
    ["Offset of field: _CONSOLE_FONT_INFO::dwFontSize"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFO, dwFontSize) - 4usize];
};
pub type CONSOLE_FONT_INFO = _CONSOLE_FONT_INFO;
pub type PCONSOLE_FONT_INFO = *mut _CONSOLE_FONT_INFO;
pub type HPCON = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub fn AllocConsole() -> BOOL;
}
unsafe extern "C" {
    pub fn FreeConsole() -> BOOL;
}
unsafe extern "C" {
    pub fn AttachConsole(dwProcessId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleCP() -> UINT;
}
unsafe extern "C" {
    pub fn GetConsoleOutputCP() -> UINT;
}
unsafe extern "C" {
    pub fn GetConsoleMode(hConsoleHandle: HANDLE, lpMode: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleMode(hConsoleHandle: HANDLE, dwMode: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumberOfConsoleInputEvents(hConsoleInput: HANDLE, lpNumberOfEvents: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleInputA(
        hConsoleInput: HANDLE,
        lpBuffer: PINPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleInputW(
        hConsoleInput: HANDLE,
        lpBuffer: PINPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PeekConsoleInputA(
        hConsoleInput: HANDLE,
        lpBuffer: PINPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PeekConsoleInputW(
        hConsoleInput: HANDLE,
        lpBuffer: PINPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsRead: LPDWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_READCONSOLE_CONTROL {
    pub nLength: ULONG,
    pub nInitialChars: ULONG,
    pub dwCtrlWakeupMask: ULONG,
    pub dwControlKeyState: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_READCONSOLE_CONTROL"]
        [::std::mem::size_of::<_CONSOLE_READCONSOLE_CONTROL>() - 16usize];
    ["Alignment of _CONSOLE_READCONSOLE_CONTROL"]
        [::std::mem::align_of::<_CONSOLE_READCONSOLE_CONTROL>() - 4usize];
    ["Offset of field: _CONSOLE_READCONSOLE_CONTROL::nLength"]
        [::std::mem::offset_of!(_CONSOLE_READCONSOLE_CONTROL, nLength) - 0usize];
    ["Offset of field: _CONSOLE_READCONSOLE_CONTROL::nInitialChars"]
        [::std::mem::offset_of!(_CONSOLE_READCONSOLE_CONTROL, nInitialChars) - 4usize];
    ["Offset of field: _CONSOLE_READCONSOLE_CONTROL::dwCtrlWakeupMask"]
        [::std::mem::offset_of!(_CONSOLE_READCONSOLE_CONTROL, dwCtrlWakeupMask) - 8usize];
    ["Offset of field: _CONSOLE_READCONSOLE_CONTROL::dwControlKeyState"]
        [::std::mem::offset_of!(_CONSOLE_READCONSOLE_CONTROL, dwControlKeyState) - 12usize];
};
pub type CONSOLE_READCONSOLE_CONTROL = _CONSOLE_READCONSOLE_CONTROL;
pub type PCONSOLE_READCONSOLE_CONTROL = *mut _CONSOLE_READCONSOLE_CONTROL;
unsafe extern "C" {
    pub fn ReadConsoleA(
        hConsoleInput: HANDLE,
        lpBuffer: LPVOID,
        nNumberOfCharsToRead: DWORD,
        lpNumberOfCharsRead: LPDWORD,
        pInputControl: PCONSOLE_READCONSOLE_CONTROL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleW(
        hConsoleInput: HANDLE,
        lpBuffer: LPVOID,
        nNumberOfCharsToRead: DWORD,
        lpNumberOfCharsRead: LPDWORD,
        pInputControl: PCONSOLE_READCONSOLE_CONTROL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleA(
        hConsoleOutput: HANDLE,
        lpBuffer: *const ::std::os::raw::c_void,
        nNumberOfCharsToWrite: DWORD,
        lpNumberOfCharsWritten: LPDWORD,
        lpReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleW(
        hConsoleOutput: HANDLE,
        lpBuffer: *const ::std::os::raw::c_void,
        nNumberOfCharsToWrite: DWORD,
        lpNumberOfCharsWritten: LPDWORD,
        lpReserved: LPVOID,
    ) -> BOOL;
}
pub type PHANDLER_ROUTINE = ::std::option::Option<unsafe extern "C" fn(CtrlType: DWORD) -> BOOL>;
unsafe extern "C" {
    pub fn SetConsoleCtrlHandler(HandlerRoutine: PHANDLER_ROUTINE, Add: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn CreatePseudoConsole(
        size: COORD,
        hInput: HANDLE,
        hOutput: HANDLE,
        dwFlags: DWORD,
        phPC: *mut HPCON,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ResizePseudoConsole(hPC: HPCON, size: COORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn ClosePseudoConsole(hPC: HPCON);
}
unsafe extern "C" {
    pub fn FillConsoleOutputCharacterA(
        hConsoleOutput: HANDLE,
        cCharacter: CHAR,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfCharsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FillConsoleOutputCharacterW(
        hConsoleOutput: HANDLE,
        cCharacter: WCHAR,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfCharsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FillConsoleOutputAttribute(
        hConsoleOutput: HANDLE,
        wAttribute: WORD,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfAttrsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GenerateConsoleCtrlEvent(dwCtrlEvent: DWORD, dwProcessGroupId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateConsoleScreenBuffer(
        dwDesiredAccess: DWORD,
        dwShareMode: DWORD,
        lpSecurityAttributes: *const SECURITY_ATTRIBUTES,
        dwFlags: DWORD,
        lpScreenBufferData: LPVOID,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn SetConsoleActiveScreenBuffer(hConsoleOutput: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn FlushConsoleInputBuffer(hConsoleInput: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleCP(wCodePageID: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleOutputCP(wCodePageID: UINT) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_CURSOR_INFO {
    pub dwSize: DWORD,
    pub bVisible: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_CURSOR_INFO"][::std::mem::size_of::<_CONSOLE_CURSOR_INFO>() - 8usize];
    ["Alignment of _CONSOLE_CURSOR_INFO"][::std::mem::align_of::<_CONSOLE_CURSOR_INFO>() - 4usize];
    ["Offset of field: _CONSOLE_CURSOR_INFO::dwSize"]
        [::std::mem::offset_of!(_CONSOLE_CURSOR_INFO, dwSize) - 0usize];
    ["Offset of field: _CONSOLE_CURSOR_INFO::bVisible"]
        [::std::mem::offset_of!(_CONSOLE_CURSOR_INFO, bVisible) - 4usize];
};
pub type CONSOLE_CURSOR_INFO = _CONSOLE_CURSOR_INFO;
pub type PCONSOLE_CURSOR_INFO = *mut _CONSOLE_CURSOR_INFO;
unsafe extern "C" {
    pub fn GetConsoleCursorInfo(
        hConsoleOutput: HANDLE,
        lpConsoleCursorInfo: PCONSOLE_CURSOR_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleCursorInfo(
        hConsoleOutput: HANDLE,
        lpConsoleCursorInfo: *const CONSOLE_CURSOR_INFO,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_SCREEN_BUFFER_INFO {
    pub dwSize: COORD,
    pub dwCursorPosition: COORD,
    pub wAttributes: WORD,
    pub srWindow: SMALL_RECT,
    pub dwMaximumWindowSize: COORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_SCREEN_BUFFER_INFO"]
        [::std::mem::size_of::<_CONSOLE_SCREEN_BUFFER_INFO>() - 22usize];
    ["Alignment of _CONSOLE_SCREEN_BUFFER_INFO"]
        [::std::mem::align_of::<_CONSOLE_SCREEN_BUFFER_INFO>() - 2usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFO::dwSize"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFO, dwSize) - 0usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFO::dwCursorPosition"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFO, dwCursorPosition) - 4usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFO::wAttributes"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFO, wAttributes) - 8usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFO::srWindow"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFO, srWindow) - 10usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFO::dwMaximumWindowSize"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFO, dwMaximumWindowSize) - 18usize];
};
pub type CONSOLE_SCREEN_BUFFER_INFO = _CONSOLE_SCREEN_BUFFER_INFO;
pub type PCONSOLE_SCREEN_BUFFER_INFO = *mut _CONSOLE_SCREEN_BUFFER_INFO;
unsafe extern "C" {
    pub fn GetConsoleScreenBufferInfo(
        hConsoleOutput: HANDLE,
        lpConsoleScreenBufferInfo: PCONSOLE_SCREEN_BUFFER_INFO,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_SCREEN_BUFFER_INFOEX {
    pub cbSize: ULONG,
    pub dwSize: COORD,
    pub dwCursorPosition: COORD,
    pub wAttributes: WORD,
    pub srWindow: SMALL_RECT,
    pub dwMaximumWindowSize: COORD,
    pub wPopupAttributes: WORD,
    pub bFullscreenSupported: BOOL,
    pub ColorTable: [COLORREF; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_SCREEN_BUFFER_INFOEX"]
        [::std::mem::size_of::<_CONSOLE_SCREEN_BUFFER_INFOEX>() - 96usize];
    ["Alignment of _CONSOLE_SCREEN_BUFFER_INFOEX"]
        [::std::mem::align_of::<_CONSOLE_SCREEN_BUFFER_INFOEX>() - 4usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::cbSize"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, cbSize) - 0usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::dwSize"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, dwSize) - 4usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::dwCursorPosition"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, dwCursorPosition) - 8usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::wAttributes"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, wAttributes) - 12usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::srWindow"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, srWindow) - 14usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::dwMaximumWindowSize"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, dwMaximumWindowSize) - 22usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::wPopupAttributes"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, wPopupAttributes) - 26usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::bFullscreenSupported"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, bFullscreenSupported) - 28usize];
    ["Offset of field: _CONSOLE_SCREEN_BUFFER_INFOEX::ColorTable"]
        [::std::mem::offset_of!(_CONSOLE_SCREEN_BUFFER_INFOEX, ColorTable) - 32usize];
};
pub type CONSOLE_SCREEN_BUFFER_INFOEX = _CONSOLE_SCREEN_BUFFER_INFOEX;
pub type PCONSOLE_SCREEN_BUFFER_INFOEX = *mut _CONSOLE_SCREEN_BUFFER_INFOEX;
unsafe extern "C" {
    pub fn GetConsoleScreenBufferInfoEx(
        hConsoleOutput: HANDLE,
        lpConsoleScreenBufferInfoEx: PCONSOLE_SCREEN_BUFFER_INFOEX,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleScreenBufferInfoEx(
        hConsoleOutput: HANDLE,
        lpConsoleScreenBufferInfoEx: PCONSOLE_SCREEN_BUFFER_INFOEX,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleScreenBufferSize(hConsoleOutput: HANDLE, dwSize: COORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleCursorPosition(hConsoleOutput: HANDLE, dwCursorPosition: COORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetLargestConsoleWindowSize(hConsoleOutput: HANDLE) -> COORD;
}
unsafe extern "C" {
    pub fn SetConsoleTextAttribute(hConsoleOutput: HANDLE, wAttributes: WORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleWindowInfo(
        hConsoleOutput: HANDLE,
        bAbsolute: BOOL,
        lpConsoleWindow: *const SMALL_RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleOutputCharacterA(
        hConsoleOutput: HANDLE,
        lpCharacter: LPCSTR,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfCharsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleOutputCharacterW(
        hConsoleOutput: HANDLE,
        lpCharacter: LPCWSTR,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfCharsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleOutputAttribute(
        hConsoleOutput: HANDLE,
        lpAttribute: *const WORD,
        nLength: DWORD,
        dwWriteCoord: COORD,
        lpNumberOfAttrsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleOutputCharacterA(
        hConsoleOutput: HANDLE,
        lpCharacter: LPSTR,
        nLength: DWORD,
        dwReadCoord: COORD,
        lpNumberOfCharsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleOutputCharacterW(
        hConsoleOutput: HANDLE,
        lpCharacter: LPWSTR,
        nLength: DWORD,
        dwReadCoord: COORD,
        lpNumberOfCharsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleOutputAttribute(
        hConsoleOutput: HANDLE,
        lpAttribute: LPWORD,
        nLength: DWORD,
        dwReadCoord: COORD,
        lpNumberOfAttrsRead: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleInputA(
        hConsoleInput: HANDLE,
        lpBuffer: *const INPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleInputW(
        hConsoleInput: HANDLE,
        lpBuffer: *const INPUT_RECORD,
        nLength: DWORD,
        lpNumberOfEventsWritten: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScrollConsoleScreenBufferA(
        hConsoleOutput: HANDLE,
        lpScrollRectangle: *const SMALL_RECT,
        lpClipRectangle: *const SMALL_RECT,
        dwDestinationOrigin: COORD,
        lpFill: *const CHAR_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScrollConsoleScreenBufferW(
        hConsoleOutput: HANDLE,
        lpScrollRectangle: *const SMALL_RECT,
        lpClipRectangle: *const SMALL_RECT,
        dwDestinationOrigin: COORD,
        lpFill: *const CHAR_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleOutputA(
        hConsoleOutput: HANDLE,
        lpBuffer: *const CHAR_INFO,
        dwBufferSize: COORD,
        dwBufferCoord: COORD,
        lpWriteRegion: PSMALL_RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn WriteConsoleOutputW(
        hConsoleOutput: HANDLE,
        lpBuffer: *const CHAR_INFO,
        dwBufferSize: COORD,
        dwBufferCoord: COORD,
        lpWriteRegion: PSMALL_RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleOutputA(
        hConsoleOutput: HANDLE,
        lpBuffer: PCHAR_INFO,
        dwBufferSize: COORD,
        dwBufferCoord: COORD,
        lpReadRegion: PSMALL_RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadConsoleOutputW(
        hConsoleOutput: HANDLE,
        lpBuffer: PCHAR_INFO,
        dwBufferSize: COORD,
        dwBufferCoord: COORD,
        lpReadRegion: PSMALL_RECT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleTitleA(lpConsoleTitle: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleTitleW(lpConsoleTitle: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleOriginalTitleA(lpConsoleTitle: LPSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleOriginalTitleW(lpConsoleTitle: LPWSTR, nSize: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn SetConsoleTitleA(lpConsoleTitle: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleTitleW(lpConsoleTitle: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetNumberOfConsoleMouseButtons(lpNumberOfMouseButtons: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleFontSize(hConsoleOutput: HANDLE, nFont: DWORD) -> COORD;
}
unsafe extern "C" {
    pub fn GetCurrentConsoleFont(
        hConsoleOutput: HANDLE,
        bMaximumWindow: BOOL,
        lpConsoleCurrentFont: PCONSOLE_FONT_INFO,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_FONT_INFOEX {
    pub cbSize: ULONG,
    pub nFont: DWORD,
    pub dwFontSize: COORD,
    pub FontFamily: UINT,
    pub FontWeight: UINT,
    pub FaceName: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_FONT_INFOEX"][::std::mem::size_of::<_CONSOLE_FONT_INFOEX>() - 84usize];
    ["Alignment of _CONSOLE_FONT_INFOEX"][::std::mem::align_of::<_CONSOLE_FONT_INFOEX>() - 4usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::cbSize"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, cbSize) - 0usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::nFont"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, nFont) - 4usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::dwFontSize"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, dwFontSize) - 8usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::FontFamily"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, FontFamily) - 12usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::FontWeight"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, FontWeight) - 16usize];
    ["Offset of field: _CONSOLE_FONT_INFOEX::FaceName"]
        [::std::mem::offset_of!(_CONSOLE_FONT_INFOEX, FaceName) - 20usize];
};
pub type CONSOLE_FONT_INFOEX = _CONSOLE_FONT_INFOEX;
pub type PCONSOLE_FONT_INFOEX = *mut _CONSOLE_FONT_INFOEX;
unsafe extern "C" {
    pub fn GetCurrentConsoleFontEx(
        hConsoleOutput: HANDLE,
        bMaximumWindow: BOOL,
        lpConsoleCurrentFontEx: PCONSOLE_FONT_INFOEX,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetCurrentConsoleFontEx(
        hConsoleOutput: HANDLE,
        bMaximumWindow: BOOL,
        lpConsoleCurrentFontEx: PCONSOLE_FONT_INFOEX,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_SELECTION_INFO {
    pub dwFlags: DWORD,
    pub dwSelectionAnchor: COORD,
    pub srSelection: SMALL_RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_SELECTION_INFO"][::std::mem::size_of::<_CONSOLE_SELECTION_INFO>() - 16usize];
    ["Alignment of _CONSOLE_SELECTION_INFO"]
        [::std::mem::align_of::<_CONSOLE_SELECTION_INFO>() - 4usize];
    ["Offset of field: _CONSOLE_SELECTION_INFO::dwFlags"]
        [::std::mem::offset_of!(_CONSOLE_SELECTION_INFO, dwFlags) - 0usize];
    ["Offset of field: _CONSOLE_SELECTION_INFO::dwSelectionAnchor"]
        [::std::mem::offset_of!(_CONSOLE_SELECTION_INFO, dwSelectionAnchor) - 4usize];
    ["Offset of field: _CONSOLE_SELECTION_INFO::srSelection"]
        [::std::mem::offset_of!(_CONSOLE_SELECTION_INFO, srSelection) - 8usize];
};
pub type CONSOLE_SELECTION_INFO = _CONSOLE_SELECTION_INFO;
pub type PCONSOLE_SELECTION_INFO = *mut _CONSOLE_SELECTION_INFO;
unsafe extern "C" {
    pub fn GetConsoleSelectionInfo(lpConsoleSelectionInfo: PCONSOLE_SELECTION_INFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONSOLE_HISTORY_INFO {
    pub cbSize: UINT,
    pub HistoryBufferSize: UINT,
    pub NumberOfHistoryBuffers: UINT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONSOLE_HISTORY_INFO"][::std::mem::size_of::<_CONSOLE_HISTORY_INFO>() - 16usize];
    ["Alignment of _CONSOLE_HISTORY_INFO"]
        [::std::mem::align_of::<_CONSOLE_HISTORY_INFO>() - 4usize];
    ["Offset of field: _CONSOLE_HISTORY_INFO::cbSize"]
        [::std::mem::offset_of!(_CONSOLE_HISTORY_INFO, cbSize) - 0usize];
    ["Offset of field: _CONSOLE_HISTORY_INFO::HistoryBufferSize"]
        [::std::mem::offset_of!(_CONSOLE_HISTORY_INFO, HistoryBufferSize) - 4usize];
    ["Offset of field: _CONSOLE_HISTORY_INFO::NumberOfHistoryBuffers"]
        [::std::mem::offset_of!(_CONSOLE_HISTORY_INFO, NumberOfHistoryBuffers) - 8usize];
    ["Offset of field: _CONSOLE_HISTORY_INFO::dwFlags"]
        [::std::mem::offset_of!(_CONSOLE_HISTORY_INFO, dwFlags) - 12usize];
};
pub type CONSOLE_HISTORY_INFO = _CONSOLE_HISTORY_INFO;
pub type PCONSOLE_HISTORY_INFO = *mut _CONSOLE_HISTORY_INFO;
unsafe extern "C" {
    pub fn GetConsoleHistoryInfo(lpConsoleHistoryInfo: PCONSOLE_HISTORY_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleHistoryInfo(lpConsoleHistoryInfo: PCONSOLE_HISTORY_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleDisplayMode(lpModeFlags: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleDisplayMode(
        hConsoleOutput: HANDLE,
        dwFlags: DWORD,
        lpNewScreenBufferDimensions: PCOORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleWindow() -> HWND;
}
unsafe extern "C" {
    pub fn AddConsoleAliasA(Source: LPSTR, Target: LPSTR, ExeName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn AddConsoleAliasW(Source: LPWSTR, Target: LPWSTR, ExeName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleAliasA(
        Source: LPSTR,
        TargetBuffer: LPSTR,
        TargetBufferLength: DWORD,
        ExeName: LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasW(
        Source: LPWSTR,
        TargetBuffer: LPWSTR,
        TargetBufferLength: DWORD,
        ExeName: LPWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasesLengthA(ExeName: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasesLengthW(ExeName: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasExesLengthA() -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasExesLengthW() -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasesA(
        AliasBuffer: LPSTR,
        AliasBufferLength: DWORD,
        ExeName: LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasesW(
        AliasBuffer: LPWSTR,
        AliasBufferLength: DWORD,
        ExeName: LPWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasExesA(ExeNameBuffer: LPSTR, ExeNameBufferLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleAliasExesW(ExeNameBuffer: LPWSTR, ExeNameBufferLength: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ExpungeConsoleCommandHistoryA(ExeName: LPSTR);
}
unsafe extern "C" {
    pub fn ExpungeConsoleCommandHistoryW(ExeName: LPWSTR);
}
unsafe extern "C" {
    pub fn SetConsoleNumberOfCommandsA(Number: DWORD, ExeName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetConsoleNumberOfCommandsW(Number: DWORD, ExeName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetConsoleCommandHistoryLengthA(ExeName: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleCommandHistoryLengthW(ExeName: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleCommandHistoryA(
        Commands: LPSTR,
        CommandBufferLength: DWORD,
        ExeName: LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleCommandHistoryW(
        Commands: LPWSTR,
        CommandBufferLength: DWORD,
        ExeName: LPWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetConsoleProcessList(lpdwProcessList: LPDWORD, dwProcessCount: DWORD) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagVS_FIXEDFILEINFO {
    pub dwSignature: DWORD,
    pub dwStrucVersion: DWORD,
    pub dwFileVersionMS: DWORD,
    pub dwFileVersionLS: DWORD,
    pub dwProductVersionMS: DWORD,
    pub dwProductVersionLS: DWORD,
    pub dwFileFlagsMask: DWORD,
    pub dwFileFlags: DWORD,
    pub dwFileOS: DWORD,
    pub dwFileType: DWORD,
    pub dwFileSubtype: DWORD,
    pub dwFileDateMS: DWORD,
    pub dwFileDateLS: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVS_FIXEDFILEINFO"][::std::mem::size_of::<tagVS_FIXEDFILEINFO>() - 52usize];
    ["Alignment of tagVS_FIXEDFILEINFO"][::std::mem::align_of::<tagVS_FIXEDFILEINFO>() - 4usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwSignature"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwSignature) - 0usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwStrucVersion"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwStrucVersion) - 4usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileVersionMS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileVersionMS) - 8usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileVersionLS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileVersionLS) - 12usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwProductVersionMS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwProductVersionMS) - 16usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwProductVersionLS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwProductVersionLS) - 20usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileFlagsMask"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileFlagsMask) - 24usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileFlags"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileFlags) - 28usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileOS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileOS) - 32usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileType"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileType) - 36usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileSubtype"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileSubtype) - 40usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileDateMS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileDateMS) - 44usize];
    ["Offset of field: tagVS_FIXEDFILEINFO::dwFileDateLS"]
        [::std::mem::offset_of!(tagVS_FIXEDFILEINFO, dwFileDateLS) - 48usize];
};
pub type VS_FIXEDFILEINFO = tagVS_FIXEDFILEINFO;
unsafe extern "C" {
    pub fn VerFindFileA(
        uFlags: DWORD,
        szFileName: LPCSTR,
        szWinDir: LPCSTR,
        szAppDir: LPCSTR,
        szCurDir: LPSTR,
        puCurDirLen: PUINT,
        szDestDir: LPSTR,
        puDestDirLen: PUINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn VerFindFileW(
        uFlags: DWORD,
        szFileName: LPCWSTR,
        szWinDir: LPCWSTR,
        szAppDir: LPCWSTR,
        szCurDir: LPWSTR,
        puCurDirLen: PUINT,
        szDestDir: LPWSTR,
        puDestDirLen: PUINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn VerInstallFileA(
        uFlags: DWORD,
        szSrcFileName: LPCSTR,
        szDestFileName: LPCSTR,
        szSrcDir: LPCSTR,
        szDestDir: LPCSTR,
        szCurDir: LPCSTR,
        szTmpFile: LPSTR,
        puTmpFileLen: PUINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn VerInstallFileW(
        uFlags: DWORD,
        szSrcFileName: LPCWSTR,
        szDestFileName: LPCWSTR,
        szSrcDir: LPCWSTR,
        szDestDir: LPCWSTR,
        szCurDir: LPCWSTR,
        szTmpFile: LPWSTR,
        puTmpFileLen: PUINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoSizeA(lptstrFilename: LPCSTR, lpdwHandle: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoSizeW(lptstrFilename: LPCWSTR, lpdwHandle: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoA(
        lptstrFilename: LPCSTR,
        dwHandle: DWORD,
        dwLen: DWORD,
        lpData: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoW(
        lptstrFilename: LPCWSTR,
        dwHandle: DWORD,
        dwLen: DWORD,
        lpData: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoSizeExA(
        dwFlags: DWORD,
        lpwstrFilename: LPCSTR,
        lpdwHandle: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoSizeExW(
        dwFlags: DWORD,
        lpwstrFilename: LPCWSTR,
        lpdwHandle: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoExA(
        dwFlags: DWORD,
        lpwstrFilename: LPCSTR,
        dwHandle: DWORD,
        dwLen: DWORD,
        lpData: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileVersionInfoExW(
        dwFlags: DWORD,
        lpwstrFilename: LPCWSTR,
        dwHandle: DWORD,
        dwLen: DWORD,
        lpData: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VerLanguageNameA(wLang: DWORD, szLang: LPSTR, cchLang: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn VerLanguageNameW(wLang: DWORD, szLang: LPWSTR, cchLang: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn VerQueryValueA(
        pBlock: LPCVOID,
        lpSubBlock: LPCSTR,
        lplpBuffer: *mut LPVOID,
        puLen: PUINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn VerQueryValueW(
        pBlock: LPCVOID,
        lpSubBlock: LPCWSTR,
        lplpBuffer: *mut LPVOID,
        puLen: PUINT,
    ) -> BOOL;
}
pub type LSTATUS = LONG;
pub type REGSAM = ACCESS_MASK;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct val_context {
    pub valuelen: ::std::os::raw::c_int,
    pub value_context: LPVOID,
    pub val_buff_ptr: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of val_context"][::std::mem::size_of::<val_context>() - 24usize];
    ["Alignment of val_context"][::std::mem::align_of::<val_context>() - 8usize];
    ["Offset of field: val_context::valuelen"]
        [::std::mem::offset_of!(val_context, valuelen) - 0usize];
    ["Offset of field: val_context::value_context"]
        [::std::mem::offset_of!(val_context, value_context) - 8usize];
    ["Offset of field: val_context::val_buff_ptr"]
        [::std::mem::offset_of!(val_context, val_buff_ptr) - 16usize];
};
pub type PVALCONTEXT = *mut val_context;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct pvalueA {
    pub pv_valuename: LPSTR,
    pub pv_valuelen: ::std::os::raw::c_int,
    pub pv_value_context: LPVOID,
    pub pv_type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of pvalueA"][::std::mem::size_of::<pvalueA>() - 32usize];
    ["Alignment of pvalueA"][::std::mem::align_of::<pvalueA>() - 8usize];
    ["Offset of field: pvalueA::pv_valuename"]
        [::std::mem::offset_of!(pvalueA, pv_valuename) - 0usize];
    ["Offset of field: pvalueA::pv_valuelen"]
        [::std::mem::offset_of!(pvalueA, pv_valuelen) - 8usize];
    ["Offset of field: pvalueA::pv_value_context"]
        [::std::mem::offset_of!(pvalueA, pv_value_context) - 16usize];
    ["Offset of field: pvalueA::pv_type"][::std::mem::offset_of!(pvalueA, pv_type) - 24usize];
};
pub type PVALUEA = pvalueA;
pub type PPVALUEA = *mut pvalueA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct pvalueW {
    pub pv_valuename: LPWSTR,
    pub pv_valuelen: ::std::os::raw::c_int,
    pub pv_value_context: LPVOID,
    pub pv_type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of pvalueW"][::std::mem::size_of::<pvalueW>() - 32usize];
    ["Alignment of pvalueW"][::std::mem::align_of::<pvalueW>() - 8usize];
    ["Offset of field: pvalueW::pv_valuename"]
        [::std::mem::offset_of!(pvalueW, pv_valuename) - 0usize];
    ["Offset of field: pvalueW::pv_valuelen"]
        [::std::mem::offset_of!(pvalueW, pv_valuelen) - 8usize];
    ["Offset of field: pvalueW::pv_value_context"]
        [::std::mem::offset_of!(pvalueW, pv_value_context) - 16usize];
    ["Offset of field: pvalueW::pv_type"][::std::mem::offset_of!(pvalueW, pv_type) - 24usize];
};
pub type PVALUEW = pvalueW;
pub type PPVALUEW = *mut pvalueW;
pub type PVALUE = PVALUEA;
pub type PPVALUE = PPVALUEA;
pub type PQUERYHANDLER = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: LPVOID,
        arg2: PVALCONTEXT,
        arg3: DWORD,
        arg4: LPVOID,
        arg5: *mut DWORD,
        arg6: DWORD,
    ) -> DWORD,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct provider_info {
    pub pi_R0_1val: PQUERYHANDLER,
    pub pi_R0_allvals: PQUERYHANDLER,
    pub pi_R3_1val: PQUERYHANDLER,
    pub pi_R3_allvals: PQUERYHANDLER,
    pub pi_flags: DWORD,
    pub pi_key_context: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of provider_info"][::std::mem::size_of::<provider_info>() - 48usize];
    ["Alignment of provider_info"][::std::mem::align_of::<provider_info>() - 8usize];
    ["Offset of field: provider_info::pi_R0_1val"]
        [::std::mem::offset_of!(provider_info, pi_R0_1val) - 0usize];
    ["Offset of field: provider_info::pi_R0_allvals"]
        [::std::mem::offset_of!(provider_info, pi_R0_allvals) - 8usize];
    ["Offset of field: provider_info::pi_R3_1val"]
        [::std::mem::offset_of!(provider_info, pi_R3_1val) - 16usize];
    ["Offset of field: provider_info::pi_R3_allvals"]
        [::std::mem::offset_of!(provider_info, pi_R3_allvals) - 24usize];
    ["Offset of field: provider_info::pi_flags"]
        [::std::mem::offset_of!(provider_info, pi_flags) - 32usize];
    ["Offset of field: provider_info::pi_key_context"]
        [::std::mem::offset_of!(provider_info, pi_key_context) - 40usize];
};
pub type REG_PROVIDER = provider_info;
pub type PPROVIDER = *mut provider_info;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct value_entA {
    pub ve_valuename: LPSTR,
    pub ve_valuelen: DWORD,
    pub ve_valueptr: DWORD_PTR,
    pub ve_type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of value_entA"][::std::mem::size_of::<value_entA>() - 32usize];
    ["Alignment of value_entA"][::std::mem::align_of::<value_entA>() - 8usize];
    ["Offset of field: value_entA::ve_valuename"]
        [::std::mem::offset_of!(value_entA, ve_valuename) - 0usize];
    ["Offset of field: value_entA::ve_valuelen"]
        [::std::mem::offset_of!(value_entA, ve_valuelen) - 8usize];
    ["Offset of field: value_entA::ve_valueptr"]
        [::std::mem::offset_of!(value_entA, ve_valueptr) - 16usize];
    ["Offset of field: value_entA::ve_type"][::std::mem::offset_of!(value_entA, ve_type) - 24usize];
};
pub type VALENTA = value_entA;
pub type PVALENTA = *mut value_entA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct value_entW {
    pub ve_valuename: LPWSTR,
    pub ve_valuelen: DWORD,
    pub ve_valueptr: DWORD_PTR,
    pub ve_type: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of value_entW"][::std::mem::size_of::<value_entW>() - 32usize];
    ["Alignment of value_entW"][::std::mem::align_of::<value_entW>() - 8usize];
    ["Offset of field: value_entW::ve_valuename"]
        [::std::mem::offset_of!(value_entW, ve_valuename) - 0usize];
    ["Offset of field: value_entW::ve_valuelen"]
        [::std::mem::offset_of!(value_entW, ve_valuelen) - 8usize];
    ["Offset of field: value_entW::ve_valueptr"]
        [::std::mem::offset_of!(value_entW, ve_valueptr) - 16usize];
    ["Offset of field: value_entW::ve_type"][::std::mem::offset_of!(value_entW, ve_type) - 24usize];
};
pub type VALENTW = value_entW;
pub type PVALENTW = *mut value_entW;
pub type VALENT = VALENTA;
pub type PVALENT = PVALENTA;
unsafe extern "C" {
    pub fn RegCloseKey(hKey: HKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOverridePredefKey(hKey: HKEY, hNewHKey: HKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenUserClassesRoot(
        hToken: HANDLE,
        dwOptions: DWORD,
        samDesired: REGSAM,
        phkResult: PHKEY,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenCurrentUser(samDesired: REGSAM, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDisablePredefinedCache() -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDisablePredefinedCacheEx() -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegConnectRegistryA(lpMachineName: LPCSTR, hKey: HKEY, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegConnectRegistryW(lpMachineName: LPCWSTR, hKey: HKEY, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegConnectRegistryExA(
        lpMachineName: LPCSTR,
        hKey: HKEY,
        Flags: ULONG,
        phkResult: PHKEY,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegConnectRegistryExW(
        lpMachineName: LPCWSTR,
        hKey: HKEY,
        Flags: ULONG,
        phkResult: PHKEY,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyA(hKey: HKEY, lpSubKey: LPCSTR, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyW(hKey: HKEY, lpSubKey: LPCWSTR, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyExA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        Reserved: DWORD,
        lpClass: LPSTR,
        dwOptions: DWORD,
        samDesired: REGSAM,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        phkResult: PHKEY,
        lpdwDisposition: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyExW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        Reserved: DWORD,
        lpClass: LPWSTR,
        dwOptions: DWORD,
        samDesired: REGSAM,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        phkResult: PHKEY,
        lpdwDisposition: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyTransactedA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        Reserved: DWORD,
        lpClass: LPSTR,
        dwOptions: DWORD,
        samDesired: REGSAM,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        phkResult: PHKEY,
        lpdwDisposition: LPDWORD,
        hTransaction: HANDLE,
        pExtendedParemeter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCreateKeyTransactedW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        Reserved: DWORD,
        lpClass: LPWSTR,
        dwOptions: DWORD,
        samDesired: REGSAM,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        phkResult: PHKEY,
        lpdwDisposition: LPDWORD,
        hTransaction: HANDLE,
        pExtendedParemeter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyA(hKey: HKEY, lpSubKey: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyW(hKey: HKEY, lpSubKey: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyExA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        samDesired: REGSAM,
        Reserved: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyExW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        samDesired: REGSAM,
        Reserved: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyTransactedA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        samDesired: REGSAM,
        Reserved: DWORD,
        hTransaction: HANDLE,
        pExtendedParameter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyTransactedW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        samDesired: REGSAM,
        Reserved: DWORD,
        hTransaction: HANDLE,
        pExtendedParameter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDisableReflectionKey(hBase: HKEY) -> LONG;
}
unsafe extern "C" {
    pub fn RegEnableReflectionKey(hBase: HKEY) -> LONG;
}
unsafe extern "C" {
    pub fn RegQueryReflectionKey(hBase: HKEY, bIsReflectionDisabled: *mut BOOL) -> LONG;
}
unsafe extern "C" {
    pub fn RegDeleteValueA(hKey: HKEY, lpValueName: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteValueW(hKey: HKEY, lpValueName: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumKeyA(hKey: HKEY, dwIndex: DWORD, lpName: LPSTR, cchName: DWORD) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumKeyW(hKey: HKEY, dwIndex: DWORD, lpName: LPWSTR, cchName: DWORD) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumKeyExA(
        hKey: HKEY,
        dwIndex: DWORD,
        lpName: LPSTR,
        lpcchName: LPDWORD,
        lpReserved: LPDWORD,
        lpClass: LPSTR,
        lpcchClass: LPDWORD,
        lpftLastWriteTime: PFILETIME,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumKeyExW(
        hKey: HKEY,
        dwIndex: DWORD,
        lpName: LPWSTR,
        lpcchName: LPDWORD,
        lpReserved: LPDWORD,
        lpClass: LPWSTR,
        lpcchClass: LPDWORD,
        lpftLastWriteTime: PFILETIME,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumValueA(
        hKey: HKEY,
        dwIndex: DWORD,
        lpValueName: LPSTR,
        lpcchValueName: LPDWORD,
        lpReserved: LPDWORD,
        lpType: LPDWORD,
        lpData: LPBYTE,
        lpcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegEnumValueW(
        hKey: HKEY,
        dwIndex: DWORD,
        lpValueName: LPWSTR,
        lpcchValueName: LPDWORD,
        lpReserved: LPDWORD,
        lpType: LPDWORD,
        lpData: LPBYTE,
        lpcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegFlushKey(hKey: HKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegGetKeySecurity(
        hKey: HKEY,
        SecurityInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        lpcbSecurityDescriptor: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadKeyA(hKey: HKEY, lpSubKey: LPCSTR, lpFile: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadKeyW(hKey: HKEY, lpSubKey: LPCWSTR, lpFile: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegNotifyChangeKeyValue(
        hKey: HKEY,
        bWatchSubtree: BOOL,
        dwNotifyFilter: DWORD,
        hEvent: HANDLE,
        fAsynchronous: BOOL,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyA(hKey: HKEY, lpSubKey: LPCSTR, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyW(hKey: HKEY, lpSubKey: LPCWSTR, phkResult: PHKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyExA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        ulOptions: DWORD,
        samDesired: REGSAM,
        phkResult: PHKEY,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyExW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        ulOptions: DWORD,
        samDesired: REGSAM,
        phkResult: PHKEY,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyTransactedA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        ulOptions: DWORD,
        samDesired: REGSAM,
        phkResult: PHKEY,
        hTransaction: HANDLE,
        pExtendedParemeter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegOpenKeyTransactedW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        ulOptions: DWORD,
        samDesired: REGSAM,
        phkResult: PHKEY,
        hTransaction: HANDLE,
        pExtendedParemeter: PVOID,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryInfoKeyA(
        hKey: HKEY,
        lpClass: LPSTR,
        lpcchClass: LPDWORD,
        lpReserved: LPDWORD,
        lpcSubKeys: LPDWORD,
        lpcbMaxSubKeyLen: LPDWORD,
        lpcbMaxClassLen: LPDWORD,
        lpcValues: LPDWORD,
        lpcbMaxValueNameLen: LPDWORD,
        lpcbMaxValueLen: LPDWORD,
        lpcbSecurityDescriptor: LPDWORD,
        lpftLastWriteTime: PFILETIME,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryInfoKeyW(
        hKey: HKEY,
        lpClass: LPWSTR,
        lpcchClass: LPDWORD,
        lpReserved: LPDWORD,
        lpcSubKeys: LPDWORD,
        lpcbMaxSubKeyLen: LPDWORD,
        lpcbMaxClassLen: LPDWORD,
        lpcValues: LPDWORD,
        lpcbMaxValueNameLen: LPDWORD,
        lpcbMaxValueLen: LPDWORD,
        lpcbSecurityDescriptor: LPDWORD,
        lpftLastWriteTime: PFILETIME,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryValueA(hKey: HKEY, lpSubKey: LPCSTR, lpData: LPSTR, lpcbData: PLONG) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryValueW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        lpData: LPWSTR,
        lpcbData: PLONG,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryMultipleValuesA(
        hKey: HKEY,
        val_list: PVALENTA,
        num_vals: DWORD,
        lpValueBuf: LPSTR,
        ldwTotsize: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryMultipleValuesW(
        hKey: HKEY,
        val_list: PVALENTW,
        num_vals: DWORD,
        lpValueBuf: LPWSTR,
        ldwTotsize: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryValueExA(
        hKey: HKEY,
        lpValueName: LPCSTR,
        lpReserved: LPDWORD,
        lpType: LPDWORD,
        lpData: LPBYTE,
        lpcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegQueryValueExW(
        hKey: HKEY,
        lpValueName: LPCWSTR,
        lpReserved: LPDWORD,
        lpType: LPDWORD,
        lpData: LPBYTE,
        lpcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegReplaceKeyA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        lpNewFile: LPCSTR,
        lpOldFile: LPCSTR,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegReplaceKeyW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        lpNewFile: LPCWSTR,
        lpOldFile: LPCWSTR,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegRestoreKeyA(hKey: HKEY, lpFile: LPCSTR, dwFlags: DWORD) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegRestoreKeyW(hKey: HKEY, lpFile: LPCWSTR, dwFlags: DWORD) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegRenameKey(hKey: HKEY, lpSubKeyName: LPCWSTR, lpNewKeyName: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSaveKeyA(
        hKey: HKEY,
        lpFile: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSaveKeyW(
        hKey: HKEY,
        lpFile: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetKeySecurity(
        hKey: HKEY,
        SecurityInformation: SECURITY_INFORMATION,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetValueA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        dwType: DWORD,
        lpData: LPCSTR,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetValueW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        dwType: DWORD,
        lpData: LPCWSTR,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetValueExA(
        hKey: HKEY,
        lpValueName: LPCSTR,
        Reserved: DWORD,
        dwType: DWORD,
        lpData: *const BYTE,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetValueExW(
        hKey: HKEY,
        lpValueName: LPCWSTR,
        Reserved: DWORD,
        dwType: DWORD,
        lpData: *const BYTE,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegUnLoadKeyA(hKey: HKEY, lpSubKey: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegUnLoadKeyW(hKey: HKEY, lpSubKey: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyValueA(hKey: HKEY, lpSubKey: LPCSTR, lpValueName: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteKeyValueW(hKey: HKEY, lpSubKey: LPCWSTR, lpValueName: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetKeyValueA(
        hKey: HKEY,
        lpSubKey: LPCSTR,
        lpValueName: LPCSTR,
        dwType: DWORD,
        lpData: LPCVOID,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSetKeyValueW(
        hKey: HKEY,
        lpSubKey: LPCWSTR,
        lpValueName: LPCWSTR,
        dwType: DWORD,
        lpData: LPCVOID,
        cbData: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteTreeA(hKey: HKEY, lpSubKey: LPCSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegDeleteTreeW(hKey: HKEY, lpSubKey: LPCWSTR) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCopyTreeA(hKeySrc: HKEY, lpSubKey: LPCSTR, hKeyDest: HKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegGetValueA(
        hkey: HKEY,
        lpSubKey: LPCSTR,
        lpValue: LPCSTR,
        dwFlags: DWORD,
        pdwType: LPDWORD,
        pvData: PVOID,
        pcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegGetValueW(
        hkey: HKEY,
        lpSubKey: LPCWSTR,
        lpValue: LPCWSTR,
        dwFlags: DWORD,
        pdwType: LPDWORD,
        pvData: PVOID,
        pcbData: LPDWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegCopyTreeW(hKeySrc: HKEY, lpSubKey: LPCWSTR, hKeyDest: HKEY) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadMUIStringA(
        hKey: HKEY,
        pszValue: LPCSTR,
        pszOutBuf: LPSTR,
        cbOutBuf: DWORD,
        pcbData: LPDWORD,
        Flags: DWORD,
        pszDirectory: LPCSTR,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadMUIStringW(
        hKey: HKEY,
        pszValue: LPCWSTR,
        pszOutBuf: LPWSTR,
        cbOutBuf: DWORD,
        pcbData: LPDWORD,
        Flags: DWORD,
        pszDirectory: LPCWSTR,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadAppKeyA(
        lpFile: LPCSTR,
        phkResult: PHKEY,
        samDesired: REGSAM,
        dwOptions: DWORD,
        Reserved: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegLoadAppKeyW(
        lpFile: LPCWSTR,
        phkResult: PHKEY,
        samDesired: REGSAM,
        dwOptions: DWORD,
        Reserved: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn InitiateSystemShutdownA(
        lpMachineName: LPSTR,
        lpMessage: LPSTR,
        dwTimeout: DWORD,
        bForceAppsClosed: BOOL,
        bRebootAfterShutdown: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitiateSystemShutdownW(
        lpMachineName: LPWSTR,
        lpMessage: LPWSTR,
        dwTimeout: DWORD,
        bForceAppsClosed: BOOL,
        bRebootAfterShutdown: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AbortSystemShutdownA(lpMachineName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn AbortSystemShutdownW(lpMachineName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn InitiateSystemShutdownExA(
        lpMachineName: LPSTR,
        lpMessage: LPSTR,
        dwTimeout: DWORD,
        bForceAppsClosed: BOOL,
        bRebootAfterShutdown: BOOL,
        dwReason: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitiateSystemShutdownExW(
        lpMachineName: LPWSTR,
        lpMessage: LPWSTR,
        dwTimeout: DWORD,
        bForceAppsClosed: BOOL,
        bRebootAfterShutdown: BOOL,
        dwReason: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InitiateShutdownA(
        lpMachineName: LPSTR,
        lpMessage: LPSTR,
        dwGracePeriod: DWORD,
        dwShutdownFlags: DWORD,
        dwReason: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn InitiateShutdownW(
        lpMachineName: LPWSTR,
        lpMessage: LPWSTR,
        dwGracePeriod: DWORD,
        dwShutdownFlags: DWORD,
        dwReason: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CheckForHiberboot(pHiberboot: PBOOLEAN, bClearFlag: BOOLEAN) -> DWORD;
}
unsafe extern "C" {
    pub fn RegSaveKeyExA(
        hKey: HKEY,
        lpFile: LPCSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        Flags: DWORD,
    ) -> LSTATUS;
}
unsafe extern "C" {
    pub fn RegSaveKeyExW(
        hKey: HKEY,
        lpFile: LPCWSTR,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
        Flags: DWORD,
    ) -> LSTATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NETRESOURCEA {
    pub dwScope: DWORD,
    pub dwType: DWORD,
    pub dwDisplayType: DWORD,
    pub dwUsage: DWORD,
    pub lpLocalName: LPSTR,
    pub lpRemoteName: LPSTR,
    pub lpComment: LPSTR,
    pub lpProvider: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NETRESOURCEA"][::std::mem::size_of::<_NETRESOURCEA>() - 48usize];
    ["Alignment of _NETRESOURCEA"][::std::mem::align_of::<_NETRESOURCEA>() - 8usize];
    ["Offset of field: _NETRESOURCEA::dwScope"]
        [::std::mem::offset_of!(_NETRESOURCEA, dwScope) - 0usize];
    ["Offset of field: _NETRESOURCEA::dwType"]
        [::std::mem::offset_of!(_NETRESOURCEA, dwType) - 4usize];
    ["Offset of field: _NETRESOURCEA::dwDisplayType"]
        [::std::mem::offset_of!(_NETRESOURCEA, dwDisplayType) - 8usize];
    ["Offset of field: _NETRESOURCEA::dwUsage"]
        [::std::mem::offset_of!(_NETRESOURCEA, dwUsage) - 12usize];
    ["Offset of field: _NETRESOURCEA::lpLocalName"]
        [::std::mem::offset_of!(_NETRESOURCEA, lpLocalName) - 16usize];
    ["Offset of field: _NETRESOURCEA::lpRemoteName"]
        [::std::mem::offset_of!(_NETRESOURCEA, lpRemoteName) - 24usize];
    ["Offset of field: _NETRESOURCEA::lpComment"]
        [::std::mem::offset_of!(_NETRESOURCEA, lpComment) - 32usize];
    ["Offset of field: _NETRESOURCEA::lpProvider"]
        [::std::mem::offset_of!(_NETRESOURCEA, lpProvider) - 40usize];
};
pub type NETRESOURCEA = _NETRESOURCEA;
pub type LPNETRESOURCEA = *mut _NETRESOURCEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NETRESOURCEW {
    pub dwScope: DWORD,
    pub dwType: DWORD,
    pub dwDisplayType: DWORD,
    pub dwUsage: DWORD,
    pub lpLocalName: LPWSTR,
    pub lpRemoteName: LPWSTR,
    pub lpComment: LPWSTR,
    pub lpProvider: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NETRESOURCEW"][::std::mem::size_of::<_NETRESOURCEW>() - 48usize];
    ["Alignment of _NETRESOURCEW"][::std::mem::align_of::<_NETRESOURCEW>() - 8usize];
    ["Offset of field: _NETRESOURCEW::dwScope"]
        [::std::mem::offset_of!(_NETRESOURCEW, dwScope) - 0usize];
    ["Offset of field: _NETRESOURCEW::dwType"]
        [::std::mem::offset_of!(_NETRESOURCEW, dwType) - 4usize];
    ["Offset of field: _NETRESOURCEW::dwDisplayType"]
        [::std::mem::offset_of!(_NETRESOURCEW, dwDisplayType) - 8usize];
    ["Offset of field: _NETRESOURCEW::dwUsage"]
        [::std::mem::offset_of!(_NETRESOURCEW, dwUsage) - 12usize];
    ["Offset of field: _NETRESOURCEW::lpLocalName"]
        [::std::mem::offset_of!(_NETRESOURCEW, lpLocalName) - 16usize];
    ["Offset of field: _NETRESOURCEW::lpRemoteName"]
        [::std::mem::offset_of!(_NETRESOURCEW, lpRemoteName) - 24usize];
    ["Offset of field: _NETRESOURCEW::lpComment"]
        [::std::mem::offset_of!(_NETRESOURCEW, lpComment) - 32usize];
    ["Offset of field: _NETRESOURCEW::lpProvider"]
        [::std::mem::offset_of!(_NETRESOURCEW, lpProvider) - 40usize];
};
pub type NETRESOURCEW = _NETRESOURCEW;
pub type LPNETRESOURCEW = *mut _NETRESOURCEW;
pub type NETRESOURCE = NETRESOURCEA;
pub type LPNETRESOURCE = LPNETRESOURCEA;
unsafe extern "C" {
    pub fn WNetAddConnectionA(
        lpRemoteName: LPCSTR,
        lpPassword: LPCSTR,
        lpLocalName: LPCSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnectionW(
        lpRemoteName: LPCWSTR,
        lpPassword: LPCWSTR,
        lpLocalName: LPCWSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection2A(
        lpNetResource: LPNETRESOURCEA,
        lpPassword: LPCSTR,
        lpUserName: LPCSTR,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection2W(
        lpNetResource: LPNETRESOURCEW,
        lpPassword: LPCWSTR,
        lpUserName: LPCWSTR,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection3A(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEA,
        lpPassword: LPCSTR,
        lpUserName: LPCSTR,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection3W(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEW,
        lpPassword: LPCWSTR,
        lpUserName: LPCWSTR,
        dwFlags: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection4A(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEA,
        pAuthBuffer: PVOID,
        cbAuthBuffer: DWORD,
        dwFlags: DWORD,
        lpUseOptions: PBYTE,
        cbUseOptions: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetAddConnection4W(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEW,
        pAuthBuffer: PVOID,
        cbAuthBuffer: DWORD,
        dwFlags: DWORD,
        lpUseOptions: PBYTE,
        cbUseOptions: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetCancelConnectionA(lpName: LPCSTR, fForce: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetCancelConnectionW(lpName: LPCWSTR, fForce: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetCancelConnection2A(lpName: LPCSTR, dwFlags: DWORD, fForce: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetCancelConnection2W(lpName: LPCWSTR, dwFlags: DWORD, fForce: BOOL) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetConnectionA(
        lpLocalName: LPCSTR,
        lpRemoteName: LPSTR,
        lpnLength: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetConnectionW(
        lpLocalName: LPCWSTR,
        lpRemoteName: LPWSTR,
        lpnLength: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetRestoreSingleConnectionW(hwndParent: HWND, lpDevice: LPCWSTR, fUseUI: BOOL)
        -> DWORD;
}
unsafe extern "C" {
    pub fn WNetUseConnectionA(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEA,
        lpPassword: LPCSTR,
        lpUserId: LPCSTR,
        dwFlags: DWORD,
        lpAccessName: LPSTR,
        lpBufferSize: LPDWORD,
        lpResult: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetUseConnectionW(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEW,
        lpPassword: LPCWSTR,
        lpUserId: LPCWSTR,
        dwFlags: DWORD,
        lpAccessName: LPWSTR,
        lpBufferSize: LPDWORD,
        lpResult: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetUseConnection4A(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEA,
        pAuthBuffer: PVOID,
        cbAuthBuffer: DWORD,
        dwFlags: DWORD,
        lpUseOptions: PBYTE,
        cbUseOptions: DWORD,
        lpAccessName: LPSTR,
        lpBufferSize: LPDWORD,
        lpResult: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetUseConnection4W(
        hwndOwner: HWND,
        lpNetResource: LPNETRESOURCEW,
        pAuthBuffer: PVOID,
        cbAuthBuffer: DWORD,
        dwFlags: DWORD,
        lpUseOptions: PBYTE,
        cbUseOptions: DWORD,
        lpAccessName: LPWSTR,
        lpBufferSize: LPDWORD,
        lpResult: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetConnectionDialog(hwnd: HWND, dwType: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetDisconnectDialog(hwnd: HWND, dwType: DWORD) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONNECTDLGSTRUCTA {
    pub cbStructure: DWORD,
    pub hwndOwner: HWND,
    pub lpConnRes: LPNETRESOURCEA,
    pub dwFlags: DWORD,
    pub dwDevNum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONNECTDLGSTRUCTA"][::std::mem::size_of::<_CONNECTDLGSTRUCTA>() - 32usize];
    ["Alignment of _CONNECTDLGSTRUCTA"][::std::mem::align_of::<_CONNECTDLGSTRUCTA>() - 8usize];
    ["Offset of field: _CONNECTDLGSTRUCTA::cbStructure"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTA, cbStructure) - 0usize];
    ["Offset of field: _CONNECTDLGSTRUCTA::hwndOwner"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTA, hwndOwner) - 8usize];
    ["Offset of field: _CONNECTDLGSTRUCTA::lpConnRes"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTA, lpConnRes) - 16usize];
    ["Offset of field: _CONNECTDLGSTRUCTA::dwFlags"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTA, dwFlags) - 24usize];
    ["Offset of field: _CONNECTDLGSTRUCTA::dwDevNum"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTA, dwDevNum) - 28usize];
};
pub type CONNECTDLGSTRUCTA = _CONNECTDLGSTRUCTA;
pub type LPCONNECTDLGSTRUCTA = *mut _CONNECTDLGSTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONNECTDLGSTRUCTW {
    pub cbStructure: DWORD,
    pub hwndOwner: HWND,
    pub lpConnRes: LPNETRESOURCEW,
    pub dwFlags: DWORD,
    pub dwDevNum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONNECTDLGSTRUCTW"][::std::mem::size_of::<_CONNECTDLGSTRUCTW>() - 32usize];
    ["Alignment of _CONNECTDLGSTRUCTW"][::std::mem::align_of::<_CONNECTDLGSTRUCTW>() - 8usize];
    ["Offset of field: _CONNECTDLGSTRUCTW::cbStructure"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTW, cbStructure) - 0usize];
    ["Offset of field: _CONNECTDLGSTRUCTW::hwndOwner"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTW, hwndOwner) - 8usize];
    ["Offset of field: _CONNECTDLGSTRUCTW::lpConnRes"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTW, lpConnRes) - 16usize];
    ["Offset of field: _CONNECTDLGSTRUCTW::dwFlags"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTW, dwFlags) - 24usize];
    ["Offset of field: _CONNECTDLGSTRUCTW::dwDevNum"]
        [::std::mem::offset_of!(_CONNECTDLGSTRUCTW, dwDevNum) - 28usize];
};
pub type CONNECTDLGSTRUCTW = _CONNECTDLGSTRUCTW;
pub type LPCONNECTDLGSTRUCTW = *mut _CONNECTDLGSTRUCTW;
pub type CONNECTDLGSTRUCT = CONNECTDLGSTRUCTA;
pub type LPCONNECTDLGSTRUCT = LPCONNECTDLGSTRUCTA;
unsafe extern "C" {
    pub fn WNetConnectionDialog1A(lpConnDlgStruct: LPCONNECTDLGSTRUCTA) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetConnectionDialog1W(lpConnDlgStruct: LPCONNECTDLGSTRUCTW) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISCDLGSTRUCTA {
    pub cbStructure: DWORD,
    pub hwndOwner: HWND,
    pub lpLocalName: LPSTR,
    pub lpRemoteName: LPSTR,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISCDLGSTRUCTA"][::std::mem::size_of::<_DISCDLGSTRUCTA>() - 40usize];
    ["Alignment of _DISCDLGSTRUCTA"][::std::mem::align_of::<_DISCDLGSTRUCTA>() - 8usize];
    ["Offset of field: _DISCDLGSTRUCTA::cbStructure"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTA, cbStructure) - 0usize];
    ["Offset of field: _DISCDLGSTRUCTA::hwndOwner"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTA, hwndOwner) - 8usize];
    ["Offset of field: _DISCDLGSTRUCTA::lpLocalName"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTA, lpLocalName) - 16usize];
    ["Offset of field: _DISCDLGSTRUCTA::lpRemoteName"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTA, lpRemoteName) - 24usize];
    ["Offset of field: _DISCDLGSTRUCTA::dwFlags"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTA, dwFlags) - 32usize];
};
pub type DISCDLGSTRUCTA = _DISCDLGSTRUCTA;
pub type LPDISCDLGSTRUCTA = *mut _DISCDLGSTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISCDLGSTRUCTW {
    pub cbStructure: DWORD,
    pub hwndOwner: HWND,
    pub lpLocalName: LPWSTR,
    pub lpRemoteName: LPWSTR,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISCDLGSTRUCTW"][::std::mem::size_of::<_DISCDLGSTRUCTW>() - 40usize];
    ["Alignment of _DISCDLGSTRUCTW"][::std::mem::align_of::<_DISCDLGSTRUCTW>() - 8usize];
    ["Offset of field: _DISCDLGSTRUCTW::cbStructure"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTW, cbStructure) - 0usize];
    ["Offset of field: _DISCDLGSTRUCTW::hwndOwner"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTW, hwndOwner) - 8usize];
    ["Offset of field: _DISCDLGSTRUCTW::lpLocalName"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTW, lpLocalName) - 16usize];
    ["Offset of field: _DISCDLGSTRUCTW::lpRemoteName"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTW, lpRemoteName) - 24usize];
    ["Offset of field: _DISCDLGSTRUCTW::dwFlags"]
        [::std::mem::offset_of!(_DISCDLGSTRUCTW, dwFlags) - 32usize];
};
pub type DISCDLGSTRUCTW = _DISCDLGSTRUCTW;
pub type LPDISCDLGSTRUCTW = *mut _DISCDLGSTRUCTW;
pub type DISCDLGSTRUCT = DISCDLGSTRUCTA;
pub type LPDISCDLGSTRUCT = LPDISCDLGSTRUCTA;
unsafe extern "C" {
    pub fn WNetDisconnectDialog1A(lpConnDlgStruct: LPDISCDLGSTRUCTA) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetDisconnectDialog1W(lpConnDlgStruct: LPDISCDLGSTRUCTW) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetOpenEnumA(
        dwScope: DWORD,
        dwType: DWORD,
        dwUsage: DWORD,
        lpNetResource: LPNETRESOURCEA,
        lphEnum: LPHANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetOpenEnumW(
        dwScope: DWORD,
        dwType: DWORD,
        dwUsage: DWORD,
        lpNetResource: LPNETRESOURCEW,
        lphEnum: LPHANDLE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetEnumResourceA(
        hEnum: HANDLE,
        lpcCount: LPDWORD,
        lpBuffer: LPVOID,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetEnumResourceW(
        hEnum: HANDLE,
        lpcCount: LPDWORD,
        lpBuffer: LPVOID,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetCloseEnum(hEnum: HANDLE) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetResourceParentA(
        lpNetResource: LPNETRESOURCEA,
        lpBuffer: LPVOID,
        lpcbBuffer: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetResourceParentW(
        lpNetResource: LPNETRESOURCEW,
        lpBuffer: LPVOID,
        lpcbBuffer: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetResourceInformationA(
        lpNetResource: LPNETRESOURCEA,
        lpBuffer: LPVOID,
        lpcbBuffer: LPDWORD,
        lplpSystem: *mut LPSTR,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetResourceInformationW(
        lpNetResource: LPNETRESOURCEW,
        lpBuffer: LPVOID,
        lpcbBuffer: LPDWORD,
        lplpSystem: *mut LPWSTR,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UNIVERSAL_NAME_INFOA {
    pub lpUniversalName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UNIVERSAL_NAME_INFOA"][::std::mem::size_of::<_UNIVERSAL_NAME_INFOA>() - 8usize];
    ["Alignment of _UNIVERSAL_NAME_INFOA"]
        [::std::mem::align_of::<_UNIVERSAL_NAME_INFOA>() - 8usize];
    ["Offset of field: _UNIVERSAL_NAME_INFOA::lpUniversalName"]
        [::std::mem::offset_of!(_UNIVERSAL_NAME_INFOA, lpUniversalName) - 0usize];
};
pub type UNIVERSAL_NAME_INFOA = _UNIVERSAL_NAME_INFOA;
pub type LPUNIVERSAL_NAME_INFOA = *mut _UNIVERSAL_NAME_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UNIVERSAL_NAME_INFOW {
    pub lpUniversalName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UNIVERSAL_NAME_INFOW"][::std::mem::size_of::<_UNIVERSAL_NAME_INFOW>() - 8usize];
    ["Alignment of _UNIVERSAL_NAME_INFOW"]
        [::std::mem::align_of::<_UNIVERSAL_NAME_INFOW>() - 8usize];
    ["Offset of field: _UNIVERSAL_NAME_INFOW::lpUniversalName"]
        [::std::mem::offset_of!(_UNIVERSAL_NAME_INFOW, lpUniversalName) - 0usize];
};
pub type UNIVERSAL_NAME_INFOW = _UNIVERSAL_NAME_INFOW;
pub type LPUNIVERSAL_NAME_INFOW = *mut _UNIVERSAL_NAME_INFOW;
pub type UNIVERSAL_NAME_INFO = UNIVERSAL_NAME_INFOA;
pub type LPUNIVERSAL_NAME_INFO = LPUNIVERSAL_NAME_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REMOTE_NAME_INFOA {
    pub lpUniversalName: LPSTR,
    pub lpConnectionName: LPSTR,
    pub lpRemainingPath: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REMOTE_NAME_INFOA"][::std::mem::size_of::<_REMOTE_NAME_INFOA>() - 24usize];
    ["Alignment of _REMOTE_NAME_INFOA"][::std::mem::align_of::<_REMOTE_NAME_INFOA>() - 8usize];
    ["Offset of field: _REMOTE_NAME_INFOA::lpUniversalName"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOA, lpUniversalName) - 0usize];
    ["Offset of field: _REMOTE_NAME_INFOA::lpConnectionName"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOA, lpConnectionName) - 8usize];
    ["Offset of field: _REMOTE_NAME_INFOA::lpRemainingPath"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOA, lpRemainingPath) - 16usize];
};
pub type REMOTE_NAME_INFOA = _REMOTE_NAME_INFOA;
pub type LPREMOTE_NAME_INFOA = *mut _REMOTE_NAME_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REMOTE_NAME_INFOW {
    pub lpUniversalName: LPWSTR,
    pub lpConnectionName: LPWSTR,
    pub lpRemainingPath: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REMOTE_NAME_INFOW"][::std::mem::size_of::<_REMOTE_NAME_INFOW>() - 24usize];
    ["Alignment of _REMOTE_NAME_INFOW"][::std::mem::align_of::<_REMOTE_NAME_INFOW>() - 8usize];
    ["Offset of field: _REMOTE_NAME_INFOW::lpUniversalName"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOW, lpUniversalName) - 0usize];
    ["Offset of field: _REMOTE_NAME_INFOW::lpConnectionName"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOW, lpConnectionName) - 8usize];
    ["Offset of field: _REMOTE_NAME_INFOW::lpRemainingPath"]
        [::std::mem::offset_of!(_REMOTE_NAME_INFOW, lpRemainingPath) - 16usize];
};
pub type REMOTE_NAME_INFOW = _REMOTE_NAME_INFOW;
pub type LPREMOTE_NAME_INFOW = *mut _REMOTE_NAME_INFOW;
pub type REMOTE_NAME_INFO = REMOTE_NAME_INFOA;
pub type LPREMOTE_NAME_INFO = LPREMOTE_NAME_INFOA;
unsafe extern "C" {
    pub fn WNetGetUniversalNameA(
        lpLocalPath: LPCSTR,
        dwInfoLevel: DWORD,
        lpBuffer: LPVOID,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetUniversalNameW(
        lpLocalPath: LPCWSTR,
        dwInfoLevel: DWORD,
        lpBuffer: LPVOID,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetUserA(lpName: LPCSTR, lpUserName: LPSTR, lpnLength: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetUserW(lpName: LPCWSTR, lpUserName: LPWSTR, lpnLength: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetProviderNameA(
        dwNetType: DWORD,
        lpProviderName: LPSTR,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetProviderNameW(
        dwNetType: DWORD,
        lpProviderName: LPWSTR,
        lpBufferSize: LPDWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NETINFOSTRUCT {
    pub cbStructure: DWORD,
    pub dwProviderVersion: DWORD,
    pub dwStatus: DWORD,
    pub dwCharacteristics: DWORD,
    pub dwHandle: ULONG_PTR,
    pub wNetType: WORD,
    pub dwPrinters: DWORD,
    pub dwDrives: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NETINFOSTRUCT"][::std::mem::size_of::<_NETINFOSTRUCT>() - 40usize];
    ["Alignment of _NETINFOSTRUCT"][::std::mem::align_of::<_NETINFOSTRUCT>() - 8usize];
    ["Offset of field: _NETINFOSTRUCT::cbStructure"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, cbStructure) - 0usize];
    ["Offset of field: _NETINFOSTRUCT::dwProviderVersion"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwProviderVersion) - 4usize];
    ["Offset of field: _NETINFOSTRUCT::dwStatus"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwStatus) - 8usize];
    ["Offset of field: _NETINFOSTRUCT::dwCharacteristics"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwCharacteristics) - 12usize];
    ["Offset of field: _NETINFOSTRUCT::dwHandle"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwHandle) - 16usize];
    ["Offset of field: _NETINFOSTRUCT::wNetType"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, wNetType) - 24usize];
    ["Offset of field: _NETINFOSTRUCT::dwPrinters"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwPrinters) - 28usize];
    ["Offset of field: _NETINFOSTRUCT::dwDrives"]
        [::std::mem::offset_of!(_NETINFOSTRUCT, dwDrives) - 32usize];
};
pub type NETINFOSTRUCT = _NETINFOSTRUCT;
pub type LPNETINFOSTRUCT = *mut _NETINFOSTRUCT;
unsafe extern "C" {
    pub fn WNetGetNetworkInformationA(
        lpProvider: LPCSTR,
        lpNetInfoStruct: LPNETINFOSTRUCT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetNetworkInformationW(
        lpProvider: LPCWSTR,
        lpNetInfoStruct: LPNETINFOSTRUCT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetLastErrorA(
        lpError: LPDWORD,
        lpErrorBuf: LPSTR,
        nErrorBufSize: DWORD,
        lpNameBuf: LPSTR,
        nNameBufSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn WNetGetLastErrorW(
        lpError: LPDWORD,
        lpErrorBuf: LPWSTR,
        nErrorBufSize: DWORD,
        lpNameBuf: LPWSTR,
        nNameBufSize: DWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NETCONNECTINFOSTRUCT {
    pub cbStructure: DWORD,
    pub dwFlags: DWORD,
    pub dwSpeed: DWORD,
    pub dwDelay: DWORD,
    pub dwOptDataSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NETCONNECTINFOSTRUCT"][::std::mem::size_of::<_NETCONNECTINFOSTRUCT>() - 20usize];
    ["Alignment of _NETCONNECTINFOSTRUCT"]
        [::std::mem::align_of::<_NETCONNECTINFOSTRUCT>() - 4usize];
    ["Offset of field: _NETCONNECTINFOSTRUCT::cbStructure"]
        [::std::mem::offset_of!(_NETCONNECTINFOSTRUCT, cbStructure) - 0usize];
    ["Offset of field: _NETCONNECTINFOSTRUCT::dwFlags"]
        [::std::mem::offset_of!(_NETCONNECTINFOSTRUCT, dwFlags) - 4usize];
    ["Offset of field: _NETCONNECTINFOSTRUCT::dwSpeed"]
        [::std::mem::offset_of!(_NETCONNECTINFOSTRUCT, dwSpeed) - 8usize];
    ["Offset of field: _NETCONNECTINFOSTRUCT::dwDelay"]
        [::std::mem::offset_of!(_NETCONNECTINFOSTRUCT, dwDelay) - 12usize];
    ["Offset of field: _NETCONNECTINFOSTRUCT::dwOptDataSize"]
        [::std::mem::offset_of!(_NETCONNECTINFOSTRUCT, dwOptDataSize) - 16usize];
};
pub type NETCONNECTINFOSTRUCT = _NETCONNECTINFOSTRUCT;
pub type LPNETCONNECTINFOSTRUCT = *mut _NETCONNECTINFOSTRUCT;
unsafe extern "C" {
    pub fn MultinetGetConnectionPerformanceA(
        lpNetResource: LPNETRESOURCEA,
        lpNetConnectInfoStruct: LPNETCONNECTINFOSTRUCT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn MultinetGetConnectionPerformanceW(
        lpNetResource: LPNETRESOURCEW,
        lpNetConnectInfoStruct: LPNETCONNECTINFOSTRUCT,
    ) -> DWORD;
}
#[repr(C)]
#[repr(align(2))]
#[derive(Debug, Copy, Clone)]
pub struct DDEACK {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDEACK"][::std::mem::size_of::<DDEACK>() - 2usize];
    ["Alignment of DDEACK"][::std::mem::align_of::<DDEACK>() - 2usize];
};
impl DDEACK {
    #[inline]
    pub fn bAppReturnCode(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 8u8) as u16) }
    }
    #[inline]
    pub fn set_bAppReturnCode(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 8u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn bAppReturnCode_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                8u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_bAppReturnCode_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                8u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 6u8) as u16) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 6u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                6u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                6u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fBusy(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fBusy(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fBusy_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fBusy_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAck(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAck(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAck_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAck_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        bAppReturnCode: ::std::os::raw::c_ushort,
        reserved: ::std::os::raw::c_ushort,
        fBusy: ::std::os::raw::c_ushort,
        fAck: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 8u8, {
            let bAppReturnCode: u16 = unsafe { ::std::mem::transmute(bAppReturnCode) };
            bAppReturnCode as u64
        });
        __bindgen_bitfield_unit.set(8usize, 6u8, {
            let reserved: u16 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let fBusy: u16 = unsafe { ::std::mem::transmute(fBusy) };
            fBusy as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let fAck: u16 = unsafe { ::std::mem::transmute(fAck) };
            fAck as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DDEADVISE {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub cfFormat: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDEADVISE"][::std::mem::size_of::<DDEADVISE>() - 4usize];
    ["Alignment of DDEADVISE"][::std::mem::align_of::<DDEADVISE>() - 2usize];
    ["Offset of field: DDEADVISE::cfFormat"][::std::mem::offset_of!(DDEADVISE, cfFormat) - 2usize];
};
impl DDEADVISE {
    #[inline]
    pub fn reserved(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 14u8) as u16) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 14u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                14u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                14u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDeferUpd(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fDeferUpd(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDeferUpd_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fDeferUpd_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAckReq(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAckReq(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAckReq_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAckReq_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        reserved: ::std::os::raw::c_ushort,
        fDeferUpd: ::std::os::raw::c_ushort,
        fAckReq: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 14u8, {
            let reserved: u16 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let fDeferUpd: u16 = unsafe { ::std::mem::transmute(fDeferUpd) };
            fDeferUpd as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let fAckReq: u16 = unsafe { ::std::mem::transmute(fAckReq) };
            fAckReq as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DDEDATA {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub cfFormat: ::std::os::raw::c_short,
    pub Value: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDEDATA"][::std::mem::size_of::<DDEDATA>() - 6usize];
    ["Alignment of DDEDATA"][::std::mem::align_of::<DDEDATA>() - 2usize];
    ["Offset of field: DDEDATA::cfFormat"][::std::mem::offset_of!(DDEDATA, cfFormat) - 2usize];
    ["Offset of field: DDEDATA::Value"][::std::mem::offset_of!(DDEDATA, Value) - 4usize];
};
impl DDEDATA {
    #[inline]
    pub fn unused(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn set_unused(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unused_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_unused_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fResponse(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fResponse(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fResponse_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fResponse_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRelease(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fRelease(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRelease_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fRelease_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn reserved(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_reserved(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn reserved_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_reserved_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAckReq(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAckReq(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAckReq_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAckReq_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        unused: ::std::os::raw::c_ushort,
        fResponse: ::std::os::raw::c_ushort,
        fRelease: ::std::os::raw::c_ushort,
        reserved: ::std::os::raw::c_ushort,
        fAckReq: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let unused: u16 = unsafe { ::std::mem::transmute(unused) };
            unused as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let fResponse: u16 = unsafe { ::std::mem::transmute(fResponse) };
            fResponse as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let fRelease: u16 = unsafe { ::std::mem::transmute(fRelease) };
            fRelease as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let reserved: u16 = unsafe { ::std::mem::transmute(reserved) };
            reserved as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let fAckReq: u16 = unsafe { ::std::mem::transmute(fAckReq) };
            fAckReq as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DDEPOKE {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub cfFormat: ::std::os::raw::c_short,
    pub Value: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDEPOKE"][::std::mem::size_of::<DDEPOKE>() - 6usize];
    ["Alignment of DDEPOKE"][::std::mem::align_of::<DDEPOKE>() - 2usize];
    ["Offset of field: DDEPOKE::cfFormat"][::std::mem::offset_of!(DDEPOKE, cfFormat) - 2usize];
    ["Offset of field: DDEPOKE::Value"][::std::mem::offset_of!(DDEPOKE, Value) - 4usize];
};
impl DDEPOKE {
    #[inline]
    pub fn unused(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 13u8) as u16) }
    }
    #[inline]
    pub fn set_unused(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 13u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unused_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                13u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_unused_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                13u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRelease(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fRelease(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRelease_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fRelease_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fReserved(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 2u8) as u16) }
    }
    #[inline]
    pub fn set_fReserved(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fReserved_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                2u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fReserved_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        unused: ::std::os::raw::c_ushort,
        fRelease: ::std::os::raw::c_ushort,
        fReserved: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 13u8, {
            let unused: u16 = unsafe { ::std::mem::transmute(unused) };
            unused as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let fRelease: u16 = unsafe { ::std::mem::transmute(fRelease) };
            fRelease as u64
        });
        __bindgen_bitfield_unit.set(14usize, 2u8, {
            let fReserved: u16 = unsafe { ::std::mem::transmute(fReserved) };
            fReserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DDELN {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub cfFormat: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDELN"][::std::mem::size_of::<DDELN>() - 4usize];
    ["Alignment of DDELN"][::std::mem::align_of::<DDELN>() - 2usize];
    ["Offset of field: DDELN::cfFormat"][::std::mem::offset_of!(DDELN, cfFormat) - 2usize];
};
impl DDELN {
    #[inline]
    pub fn unused(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 13u8) as u16) }
    }
    #[inline]
    pub fn set_unused(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 13u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unused_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                13u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_unused_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                13u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRelease(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fRelease(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRelease_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fRelease_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDeferUpd(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fDeferUpd(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDeferUpd_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fDeferUpd_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAckReq(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAckReq(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAckReq_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAckReq_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        unused: ::std::os::raw::c_ushort,
        fRelease: ::std::os::raw::c_ushort,
        fDeferUpd: ::std::os::raw::c_ushort,
        fAckReq: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 13u8, {
            let unused: u16 = unsafe { ::std::mem::transmute(unused) };
            unused as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let fRelease: u16 = unsafe { ::std::mem::transmute(fRelease) };
            fRelease as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let fDeferUpd: u16 = unsafe { ::std::mem::transmute(fDeferUpd) };
            fDeferUpd as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let fAckReq: u16 = unsafe { ::std::mem::transmute(fAckReq) };
            fAckReq as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DDEUP {
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub cfFormat: ::std::os::raw::c_short,
    pub rgb: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DDEUP"][::std::mem::size_of::<DDEUP>() - 6usize];
    ["Alignment of DDEUP"][::std::mem::align_of::<DDEUP>() - 2usize];
    ["Offset of field: DDEUP::cfFormat"][::std::mem::offset_of!(DDEUP, cfFormat) - 2usize];
    ["Offset of field: DDEUP::rgb"][::std::mem::offset_of!(DDEUP, rgb) - 4usize];
};
impl DDEUP {
    #[inline]
    pub fn unused(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 12u8) as u16) }
    }
    #[inline]
    pub fn set_unused(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 12u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn unused_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                12u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_unused_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                12u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAck(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAck(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAck_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAck_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fRelease(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fRelease(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fRelease_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fRelease_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fReserved(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(14usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fReserved(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(14usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fReserved_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                14usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fReserved_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                14usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fAckReq(&self) -> ::std::os::raw::c_ushort {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(15usize, 1u8) as u16) }
    }
    #[inline]
    pub fn set_fAckReq(&mut self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            self._bitfield_1.set(15usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fAckReq_raw(this: *const Self) -> ::std::os::raw::c_ushort {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                15usize,
                1u8,
            ) as u16)
        }
    }
    #[inline]
    pub unsafe fn set_fAckReq_raw(this: *mut Self, val: ::std::os::raw::c_ushort) {
        unsafe {
            let val: u16 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                15usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        unused: ::std::os::raw::c_ushort,
        fAck: ::std::os::raw::c_ushort,
        fRelease: ::std::os::raw::c_ushort,
        fReserved: ::std::os::raw::c_ushort,
        fAckReq: ::std::os::raw::c_ushort,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 12u8, {
            let unused: u16 = unsafe { ::std::mem::transmute(unused) };
            unused as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let fAck: u16 = unsafe { ::std::mem::transmute(fAck) };
            fAck as u64
        });
        __bindgen_bitfield_unit.set(13usize, 1u8, {
            let fRelease: u16 = unsafe { ::std::mem::transmute(fRelease) };
            fRelease as u64
        });
        __bindgen_bitfield_unit.set(14usize, 1u8, {
            let fReserved: u16 = unsafe { ::std::mem::transmute(fReserved) };
            fReserved as u64
        });
        __bindgen_bitfield_unit.set(15usize, 1u8, {
            let fAckReq: u16 = unsafe { ::std::mem::transmute(fAckReq) };
            fAckReq as u64
        });
        __bindgen_bitfield_unit
    }
}
unsafe extern "C" {
    pub fn DdeSetQualityOfService(
        hwndClient: HWND,
        pqosNew: *const SECURITY_QUALITY_OF_SERVICE,
        pqosPrev: PSECURITY_QUALITY_OF_SERVICE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImpersonateDdeClientWindow(hWndClient: HWND, hWndServer: HWND) -> BOOL;
}
unsafe extern "C" {
    pub fn PackDDElParam(msg: UINT, uiLo: UINT_PTR, uiHi: UINT_PTR) -> LPARAM;
}
unsafe extern "C" {
    pub fn UnpackDDElParam(msg: UINT, lParam: LPARAM, puiLo: PUINT_PTR, puiHi: PUINT_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn FreeDDElParam(msg: UINT, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn ReuseDDElParam(
        lParam: LPARAM,
        msgIn: UINT,
        msgOut: UINT,
        uiLo: UINT_PTR,
        uiHi: UINT_PTR,
    ) -> LPARAM;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HCONVLIST__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HCONVLIST__"][::std::mem::size_of::<HCONVLIST__>() - 4usize];
    ["Alignment of HCONVLIST__"][::std::mem::align_of::<HCONVLIST__>() - 4usize];
    ["Offset of field: HCONVLIST__::unused"][::std::mem::offset_of!(HCONVLIST__, unused) - 0usize];
};
pub type HCONVLIST = *mut HCONVLIST__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HCONV__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HCONV__"][::std::mem::size_of::<HCONV__>() - 4usize];
    ["Alignment of HCONV__"][::std::mem::align_of::<HCONV__>() - 4usize];
    ["Offset of field: HCONV__::unused"][::std::mem::offset_of!(HCONV__, unused) - 0usize];
};
pub type HCONV = *mut HCONV__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HSZ__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HSZ__"][::std::mem::size_of::<HSZ__>() - 4usize];
    ["Alignment of HSZ__"][::std::mem::align_of::<HSZ__>() - 4usize];
    ["Offset of field: HSZ__::unused"][::std::mem::offset_of!(HSZ__, unused) - 0usize];
};
pub type HSZ = *mut HSZ__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HDDEDATA__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HDDEDATA__"][::std::mem::size_of::<HDDEDATA__>() - 4usize];
    ["Alignment of HDDEDATA__"][::std::mem::align_of::<HDDEDATA__>() - 4usize];
    ["Offset of field: HDDEDATA__::unused"][::std::mem::offset_of!(HDDEDATA__, unused) - 0usize];
};
pub type HDDEDATA = *mut HDDEDATA__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagHSZPAIR {
    pub hszSvc: HSZ,
    pub hszTopic: HSZ,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagHSZPAIR"][::std::mem::size_of::<tagHSZPAIR>() - 16usize];
    ["Alignment of tagHSZPAIR"][::std::mem::align_of::<tagHSZPAIR>() - 8usize];
    ["Offset of field: tagHSZPAIR::hszSvc"][::std::mem::offset_of!(tagHSZPAIR, hszSvc) - 0usize];
    ["Offset of field: tagHSZPAIR::hszTopic"]
        [::std::mem::offset_of!(tagHSZPAIR, hszTopic) - 8usize];
};
pub type HSZPAIR = tagHSZPAIR;
pub type PHSZPAIR = *mut tagHSZPAIR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCONVCONTEXT {
    pub cb: UINT,
    pub wFlags: UINT,
    pub wCountryID: UINT,
    pub iCodePage: ::std::os::raw::c_int,
    pub dwLangID: DWORD,
    pub dwSecurity: DWORD,
    pub qos: SECURITY_QUALITY_OF_SERVICE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCONVCONTEXT"][::std::mem::size_of::<tagCONVCONTEXT>() - 36usize];
    ["Alignment of tagCONVCONTEXT"][::std::mem::align_of::<tagCONVCONTEXT>() - 4usize];
    ["Offset of field: tagCONVCONTEXT::cb"][::std::mem::offset_of!(tagCONVCONTEXT, cb) - 0usize];
    ["Offset of field: tagCONVCONTEXT::wFlags"]
        [::std::mem::offset_of!(tagCONVCONTEXT, wFlags) - 4usize];
    ["Offset of field: tagCONVCONTEXT::wCountryID"]
        [::std::mem::offset_of!(tagCONVCONTEXT, wCountryID) - 8usize];
    ["Offset of field: tagCONVCONTEXT::iCodePage"]
        [::std::mem::offset_of!(tagCONVCONTEXT, iCodePage) - 12usize];
    ["Offset of field: tagCONVCONTEXT::dwLangID"]
        [::std::mem::offset_of!(tagCONVCONTEXT, dwLangID) - 16usize];
    ["Offset of field: tagCONVCONTEXT::dwSecurity"]
        [::std::mem::offset_of!(tagCONVCONTEXT, dwSecurity) - 20usize];
    ["Offset of field: tagCONVCONTEXT::qos"][::std::mem::offset_of!(tagCONVCONTEXT, qos) - 24usize];
};
pub type CONVCONTEXT = tagCONVCONTEXT;
pub type PCONVCONTEXT = *mut tagCONVCONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCONVINFO {
    pub cb: DWORD,
    pub hUser: DWORD_PTR,
    pub hConvPartner: HCONV,
    pub hszSvcPartner: HSZ,
    pub hszServiceReq: HSZ,
    pub hszTopic: HSZ,
    pub hszItem: HSZ,
    pub wFmt: UINT,
    pub wType: UINT,
    pub wStatus: UINT,
    pub wConvst: UINT,
    pub wLastError: UINT,
    pub hConvList: HCONVLIST,
    pub ConvCtxt: CONVCONTEXT,
    pub hwnd: HWND,
    pub hwndPartner: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCONVINFO"][::std::mem::size_of::<tagCONVINFO>() - 144usize];
    ["Alignment of tagCONVINFO"][::std::mem::align_of::<tagCONVINFO>() - 8usize];
    ["Offset of field: tagCONVINFO::cb"][::std::mem::offset_of!(tagCONVINFO, cb) - 0usize];
    ["Offset of field: tagCONVINFO::hUser"][::std::mem::offset_of!(tagCONVINFO, hUser) - 8usize];
    ["Offset of field: tagCONVINFO::hConvPartner"]
        [::std::mem::offset_of!(tagCONVINFO, hConvPartner) - 16usize];
    ["Offset of field: tagCONVINFO::hszSvcPartner"]
        [::std::mem::offset_of!(tagCONVINFO, hszSvcPartner) - 24usize];
    ["Offset of field: tagCONVINFO::hszServiceReq"]
        [::std::mem::offset_of!(tagCONVINFO, hszServiceReq) - 32usize];
    ["Offset of field: tagCONVINFO::hszTopic"]
        [::std::mem::offset_of!(tagCONVINFO, hszTopic) - 40usize];
    ["Offset of field: tagCONVINFO::hszItem"]
        [::std::mem::offset_of!(tagCONVINFO, hszItem) - 48usize];
    ["Offset of field: tagCONVINFO::wFmt"][::std::mem::offset_of!(tagCONVINFO, wFmt) - 56usize];
    ["Offset of field: tagCONVINFO::wType"][::std::mem::offset_of!(tagCONVINFO, wType) - 60usize];
    ["Offset of field: tagCONVINFO::wStatus"]
        [::std::mem::offset_of!(tagCONVINFO, wStatus) - 64usize];
    ["Offset of field: tagCONVINFO::wConvst"]
        [::std::mem::offset_of!(tagCONVINFO, wConvst) - 68usize];
    ["Offset of field: tagCONVINFO::wLastError"]
        [::std::mem::offset_of!(tagCONVINFO, wLastError) - 72usize];
    ["Offset of field: tagCONVINFO::hConvList"]
        [::std::mem::offset_of!(tagCONVINFO, hConvList) - 80usize];
    ["Offset of field: tagCONVINFO::ConvCtxt"]
        [::std::mem::offset_of!(tagCONVINFO, ConvCtxt) - 88usize];
    ["Offset of field: tagCONVINFO::hwnd"][::std::mem::offset_of!(tagCONVINFO, hwnd) - 128usize];
    ["Offset of field: tagCONVINFO::hwndPartner"]
        [::std::mem::offset_of!(tagCONVINFO, hwndPartner) - 136usize];
};
pub type CONVINFO = tagCONVINFO;
pub type PCONVINFO = *mut tagCONVINFO;
pub type PFNCALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        wType: UINT,
        wFmt: UINT,
        hConv: HCONV,
        hsz1: HSZ,
        hsz2: HSZ,
        hData: HDDEDATA,
        dwData1: ULONG_PTR,
        dwData2: ULONG_PTR,
    ) -> HDDEDATA,
>;
unsafe extern "C" {
    pub fn DdeInitializeA(
        pidInst: LPDWORD,
        pfnCallback: PFNCALLBACK,
        afCmd: DWORD,
        ulRes: DWORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn DdeInitializeW(
        pidInst: LPDWORD,
        pfnCallback: PFNCALLBACK,
        afCmd: DWORD,
        ulRes: DWORD,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn DdeUninitialize(idInst: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeConnectList(
        idInst: DWORD,
        hszService: HSZ,
        hszTopic: HSZ,
        hConvList: HCONVLIST,
        pCC: PCONVCONTEXT,
    ) -> HCONVLIST;
}
unsafe extern "C" {
    pub fn DdeQueryNextServer(hConvList: HCONVLIST, hConvPrev: HCONV) -> HCONV;
}
unsafe extern "C" {
    pub fn DdeDisconnectList(hConvList: HCONVLIST) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeConnect(idInst: DWORD, hszService: HSZ, hszTopic: HSZ, pCC: PCONVCONTEXT) -> HCONV;
}
unsafe extern "C" {
    pub fn DdeDisconnect(hConv: HCONV) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeReconnect(hConv: HCONV) -> HCONV;
}
unsafe extern "C" {
    pub fn DdeQueryConvInfo(hConv: HCONV, idTransaction: DWORD, pConvInfo: PCONVINFO) -> UINT;
}
unsafe extern "C" {
    pub fn DdeSetUserHandle(hConv: HCONV, id: DWORD, hUser: DWORD_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeAbandonTransaction(idInst: DWORD, hConv: HCONV, idTransaction: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn DdePostAdvise(idInst: DWORD, hszTopic: HSZ, hszItem: HSZ) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeEnableCallback(idInst: DWORD, hConv: HCONV, wCmd: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeImpersonateClient(hConv: HCONV) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeNameService(idInst: DWORD, hsz1: HSZ, hsz2: HSZ, afCmd: UINT) -> HDDEDATA;
}
unsafe extern "C" {
    pub fn DdeClientTransaction(
        pData: LPBYTE,
        cbData: DWORD,
        hConv: HCONV,
        hszItem: HSZ,
        wFmt: UINT,
        wType: UINT,
        dwTimeout: DWORD,
        pdwResult: LPDWORD,
    ) -> HDDEDATA;
}
unsafe extern "C" {
    pub fn DdeCreateDataHandle(
        idInst: DWORD,
        pSrc: LPBYTE,
        cb: DWORD,
        cbOff: DWORD,
        hszItem: HSZ,
        wFmt: UINT,
        afCmd: UINT,
    ) -> HDDEDATA;
}
unsafe extern "C" {
    pub fn DdeAddData(hData: HDDEDATA, pSrc: LPBYTE, cb: DWORD, cbOff: DWORD) -> HDDEDATA;
}
unsafe extern "C" {
    pub fn DdeGetData(hData: HDDEDATA, pDst: LPBYTE, cbMax: DWORD, cbOff: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn DdeAccessData(hData: HDDEDATA, pcbDataSize: LPDWORD) -> LPBYTE;
}
unsafe extern "C" {
    pub fn DdeUnaccessData(hData: HDDEDATA) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeFreeDataHandle(hData: HDDEDATA) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeGetLastError(idInst: DWORD) -> UINT;
}
unsafe extern "C" {
    pub fn DdeCreateStringHandleA(
        idInst: DWORD,
        psz: LPCSTR,
        iCodePage: ::std::os::raw::c_int,
    ) -> HSZ;
}
unsafe extern "C" {
    pub fn DdeCreateStringHandleW(
        idInst: DWORD,
        psz: LPCWSTR,
        iCodePage: ::std::os::raw::c_int,
    ) -> HSZ;
}
unsafe extern "C" {
    pub fn DdeQueryStringA(
        idInst: DWORD,
        hsz: HSZ,
        psz: LPSTR,
        cchMax: DWORD,
        iCodePage: ::std::os::raw::c_int,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DdeQueryStringW(
        idInst: DWORD,
        hsz: HSZ,
        psz: LPWSTR,
        cchMax: DWORD,
        iCodePage: ::std::os::raw::c_int,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DdeFreeStringHandle(idInst: DWORD, hsz: HSZ) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeKeepStringHandle(idInst: DWORD, hsz: HSZ) -> BOOL;
}
unsafe extern "C" {
    pub fn DdeCmpStringHandles(hsz1: HSZ, hsz2: HSZ) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDDEML_MSG_HOOK_DATA {
    pub uiLo: UINT_PTR,
    pub uiHi: UINT_PTR,
    pub cbData: DWORD,
    pub Data: [DWORD; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDDEML_MSG_HOOK_DATA"][::std::mem::size_of::<tagDDEML_MSG_HOOK_DATA>() - 56usize];
    ["Alignment of tagDDEML_MSG_HOOK_DATA"]
        [::std::mem::align_of::<tagDDEML_MSG_HOOK_DATA>() - 8usize];
    ["Offset of field: tagDDEML_MSG_HOOK_DATA::uiLo"]
        [::std::mem::offset_of!(tagDDEML_MSG_HOOK_DATA, uiLo) - 0usize];
    ["Offset of field: tagDDEML_MSG_HOOK_DATA::uiHi"]
        [::std::mem::offset_of!(tagDDEML_MSG_HOOK_DATA, uiHi) - 8usize];
    ["Offset of field: tagDDEML_MSG_HOOK_DATA::cbData"]
        [::std::mem::offset_of!(tagDDEML_MSG_HOOK_DATA, cbData) - 16usize];
    ["Offset of field: tagDDEML_MSG_HOOK_DATA::Data"]
        [::std::mem::offset_of!(tagDDEML_MSG_HOOK_DATA, Data) - 20usize];
};
pub type DDEML_MSG_HOOK_DATA = tagDDEML_MSG_HOOK_DATA;
pub type PDDEML_MSG_HOOK_DATA = *mut tagDDEML_MSG_HOOK_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONMSGSTRUCT {
    pub cb: UINT,
    pub hwndTo: HWND,
    pub dwTime: DWORD,
    pub hTask: HANDLE,
    pub wMsg: UINT,
    pub wParam: WPARAM,
    pub lParam: LPARAM,
    pub dmhd: DDEML_MSG_HOOK_DATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONMSGSTRUCT"][::std::mem::size_of::<tagMONMSGSTRUCT>() - 112usize];
    ["Alignment of tagMONMSGSTRUCT"][::std::mem::align_of::<tagMONMSGSTRUCT>() - 8usize];
    ["Offset of field: tagMONMSGSTRUCT::cb"][::std::mem::offset_of!(tagMONMSGSTRUCT, cb) - 0usize];
    ["Offset of field: tagMONMSGSTRUCT::hwndTo"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, hwndTo) - 8usize];
    ["Offset of field: tagMONMSGSTRUCT::dwTime"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, dwTime) - 16usize];
    ["Offset of field: tagMONMSGSTRUCT::hTask"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, hTask) - 24usize];
    ["Offset of field: tagMONMSGSTRUCT::wMsg"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, wMsg) - 32usize];
    ["Offset of field: tagMONMSGSTRUCT::wParam"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, wParam) - 40usize];
    ["Offset of field: tagMONMSGSTRUCT::lParam"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, lParam) - 48usize];
    ["Offset of field: tagMONMSGSTRUCT::dmhd"]
        [::std::mem::offset_of!(tagMONMSGSTRUCT, dmhd) - 56usize];
};
pub type MONMSGSTRUCT = tagMONMSGSTRUCT;
pub type PMONMSGSTRUCT = *mut tagMONMSGSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONCBSTRUCT {
    pub cb: UINT,
    pub dwTime: DWORD,
    pub hTask: HANDLE,
    pub dwRet: DWORD,
    pub wType: UINT,
    pub wFmt: UINT,
    pub hConv: HCONV,
    pub hsz1: HSZ,
    pub hsz2: HSZ,
    pub hData: HDDEDATA,
    pub dwData1: ULONG_PTR,
    pub dwData2: ULONG_PTR,
    pub cc: CONVCONTEXT,
    pub cbData: DWORD,
    pub Data: [DWORD; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONCBSTRUCT"][::std::mem::size_of::<tagMONCBSTRUCT>() - 152usize];
    ["Alignment of tagMONCBSTRUCT"][::std::mem::align_of::<tagMONCBSTRUCT>() - 8usize];
    ["Offset of field: tagMONCBSTRUCT::cb"][::std::mem::offset_of!(tagMONCBSTRUCT, cb) - 0usize];
    ["Offset of field: tagMONCBSTRUCT::dwTime"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, dwTime) - 4usize];
    ["Offset of field: tagMONCBSTRUCT::hTask"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, hTask) - 8usize];
    ["Offset of field: tagMONCBSTRUCT::dwRet"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, dwRet) - 16usize];
    ["Offset of field: tagMONCBSTRUCT::wType"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, wType) - 20usize];
    ["Offset of field: tagMONCBSTRUCT::wFmt"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, wFmt) - 24usize];
    ["Offset of field: tagMONCBSTRUCT::hConv"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, hConv) - 32usize];
    ["Offset of field: tagMONCBSTRUCT::hsz1"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, hsz1) - 40usize];
    ["Offset of field: tagMONCBSTRUCT::hsz2"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, hsz2) - 48usize];
    ["Offset of field: tagMONCBSTRUCT::hData"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, hData) - 56usize];
    ["Offset of field: tagMONCBSTRUCT::dwData1"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, dwData1) - 64usize];
    ["Offset of field: tagMONCBSTRUCT::dwData2"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, dwData2) - 72usize];
    ["Offset of field: tagMONCBSTRUCT::cc"][::std::mem::offset_of!(tagMONCBSTRUCT, cc) - 80usize];
    ["Offset of field: tagMONCBSTRUCT::cbData"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, cbData) - 116usize];
    ["Offset of field: tagMONCBSTRUCT::Data"]
        [::std::mem::offset_of!(tagMONCBSTRUCT, Data) - 120usize];
};
pub type MONCBSTRUCT = tagMONCBSTRUCT;
pub type PMONCBSTRUCT = *mut tagMONCBSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONHSZSTRUCTA {
    pub cb: UINT,
    pub fsAction: BOOL,
    pub dwTime: DWORD,
    pub hsz: HSZ,
    pub hTask: HANDLE,
    pub str_: [CHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONHSZSTRUCTA"][::std::mem::size_of::<tagMONHSZSTRUCTA>() - 40usize];
    ["Alignment of tagMONHSZSTRUCTA"][::std::mem::align_of::<tagMONHSZSTRUCTA>() - 8usize];
    ["Offset of field: tagMONHSZSTRUCTA::cb"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, cb) - 0usize];
    ["Offset of field: tagMONHSZSTRUCTA::fsAction"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, fsAction) - 4usize];
    ["Offset of field: tagMONHSZSTRUCTA::dwTime"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, dwTime) - 8usize];
    ["Offset of field: tagMONHSZSTRUCTA::hsz"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, hsz) - 16usize];
    ["Offset of field: tagMONHSZSTRUCTA::hTask"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, hTask) - 24usize];
    ["Offset of field: tagMONHSZSTRUCTA::str_"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTA, str_) - 32usize];
};
pub type MONHSZSTRUCTA = tagMONHSZSTRUCTA;
pub type PMONHSZSTRUCTA = *mut tagMONHSZSTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONHSZSTRUCTW {
    pub cb: UINT,
    pub fsAction: BOOL,
    pub dwTime: DWORD,
    pub hsz: HSZ,
    pub hTask: HANDLE,
    pub str_: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONHSZSTRUCTW"][::std::mem::size_of::<tagMONHSZSTRUCTW>() - 40usize];
    ["Alignment of tagMONHSZSTRUCTW"][::std::mem::align_of::<tagMONHSZSTRUCTW>() - 8usize];
    ["Offset of field: tagMONHSZSTRUCTW::cb"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, cb) - 0usize];
    ["Offset of field: tagMONHSZSTRUCTW::fsAction"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, fsAction) - 4usize];
    ["Offset of field: tagMONHSZSTRUCTW::dwTime"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, dwTime) - 8usize];
    ["Offset of field: tagMONHSZSTRUCTW::hsz"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, hsz) - 16usize];
    ["Offset of field: tagMONHSZSTRUCTW::hTask"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, hTask) - 24usize];
    ["Offset of field: tagMONHSZSTRUCTW::str_"]
        [::std::mem::offset_of!(tagMONHSZSTRUCTW, str_) - 32usize];
};
pub type MONHSZSTRUCTW = tagMONHSZSTRUCTW;
pub type PMONHSZSTRUCTW = *mut tagMONHSZSTRUCTW;
pub type MONHSZSTRUCT = MONHSZSTRUCTA;
pub type PMONHSZSTRUCT = PMONHSZSTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONERRSTRUCT {
    pub cb: UINT,
    pub wLastError: UINT,
    pub dwTime: DWORD,
    pub hTask: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONERRSTRUCT"][::std::mem::size_of::<tagMONERRSTRUCT>() - 24usize];
    ["Alignment of tagMONERRSTRUCT"][::std::mem::align_of::<tagMONERRSTRUCT>() - 8usize];
    ["Offset of field: tagMONERRSTRUCT::cb"][::std::mem::offset_of!(tagMONERRSTRUCT, cb) - 0usize];
    ["Offset of field: tagMONERRSTRUCT::wLastError"]
        [::std::mem::offset_of!(tagMONERRSTRUCT, wLastError) - 4usize];
    ["Offset of field: tagMONERRSTRUCT::dwTime"]
        [::std::mem::offset_of!(tagMONERRSTRUCT, dwTime) - 8usize];
    ["Offset of field: tagMONERRSTRUCT::hTask"]
        [::std::mem::offset_of!(tagMONERRSTRUCT, hTask) - 16usize];
};
pub type MONERRSTRUCT = tagMONERRSTRUCT;
pub type PMONERRSTRUCT = *mut tagMONERRSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONLINKSTRUCT {
    pub cb: UINT,
    pub dwTime: DWORD,
    pub hTask: HANDLE,
    pub fEstablished: BOOL,
    pub fNoData: BOOL,
    pub hszSvc: HSZ,
    pub hszTopic: HSZ,
    pub hszItem: HSZ,
    pub wFmt: UINT,
    pub fServer: BOOL,
    pub hConvServer: HCONV,
    pub hConvClient: HCONV,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONLINKSTRUCT"][::std::mem::size_of::<tagMONLINKSTRUCT>() - 72usize];
    ["Alignment of tagMONLINKSTRUCT"][::std::mem::align_of::<tagMONLINKSTRUCT>() - 8usize];
    ["Offset of field: tagMONLINKSTRUCT::cb"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, cb) - 0usize];
    ["Offset of field: tagMONLINKSTRUCT::dwTime"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, dwTime) - 4usize];
    ["Offset of field: tagMONLINKSTRUCT::hTask"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hTask) - 8usize];
    ["Offset of field: tagMONLINKSTRUCT::fEstablished"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, fEstablished) - 16usize];
    ["Offset of field: tagMONLINKSTRUCT::fNoData"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, fNoData) - 20usize];
    ["Offset of field: tagMONLINKSTRUCT::hszSvc"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hszSvc) - 24usize];
    ["Offset of field: tagMONLINKSTRUCT::hszTopic"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hszTopic) - 32usize];
    ["Offset of field: tagMONLINKSTRUCT::hszItem"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hszItem) - 40usize];
    ["Offset of field: tagMONLINKSTRUCT::wFmt"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, wFmt) - 48usize];
    ["Offset of field: tagMONLINKSTRUCT::fServer"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, fServer) - 52usize];
    ["Offset of field: tagMONLINKSTRUCT::hConvServer"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hConvServer) - 56usize];
    ["Offset of field: tagMONLINKSTRUCT::hConvClient"]
        [::std::mem::offset_of!(tagMONLINKSTRUCT, hConvClient) - 64usize];
};
pub type MONLINKSTRUCT = tagMONLINKSTRUCT;
pub type PMONLINKSTRUCT = *mut tagMONLINKSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMONCONVSTRUCT {
    pub cb: UINT,
    pub fConnect: BOOL,
    pub dwTime: DWORD,
    pub hTask: HANDLE,
    pub hszSvc: HSZ,
    pub hszTopic: HSZ,
    pub hConvClient: HCONV,
    pub hConvServer: HCONV,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMONCONVSTRUCT"][::std::mem::size_of::<tagMONCONVSTRUCT>() - 56usize];
    ["Alignment of tagMONCONVSTRUCT"][::std::mem::align_of::<tagMONCONVSTRUCT>() - 8usize];
    ["Offset of field: tagMONCONVSTRUCT::cb"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, cb) - 0usize];
    ["Offset of field: tagMONCONVSTRUCT::fConnect"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, fConnect) - 4usize];
    ["Offset of field: tagMONCONVSTRUCT::dwTime"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, dwTime) - 8usize];
    ["Offset of field: tagMONCONVSTRUCT::hTask"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, hTask) - 16usize];
    ["Offset of field: tagMONCONVSTRUCT::hszSvc"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, hszSvc) - 24usize];
    ["Offset of field: tagMONCONVSTRUCT::hszTopic"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, hszTopic) - 32usize];
    ["Offset of field: tagMONCONVSTRUCT::hConvClient"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, hConvClient) - 40usize];
    ["Offset of field: tagMONCONVSTRUCT::hConvServer"]
        [::std::mem::offset_of!(tagMONCONVSTRUCT, hConvServer) - 48usize];
};
pub type MONCONVSTRUCT = tagMONCONVSTRUCT;
pub type PMONCONVSTRUCT = *mut tagMONCONVSTRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCRGB {
    pub bRed: BYTE,
    pub bGreen: BYTE,
    pub bBlue: BYTE,
    pub bExtra: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCRGB"][::std::mem::size_of::<tagCRGB>() - 4usize];
    ["Alignment of tagCRGB"][::std::mem::align_of::<tagCRGB>() - 1usize];
    ["Offset of field: tagCRGB::bRed"][::std::mem::offset_of!(tagCRGB, bRed) - 0usize];
    ["Offset of field: tagCRGB::bGreen"][::std::mem::offset_of!(tagCRGB, bGreen) - 1usize];
    ["Offset of field: tagCRGB::bBlue"][::std::mem::offset_of!(tagCRGB, bBlue) - 2usize];
    ["Offset of field: tagCRGB::bExtra"][::std::mem::offset_of!(tagCRGB, bExtra) - 3usize];
};
pub type CRGB = tagCRGB;
unsafe extern "C" {
    pub fn LZStart() -> INT;
}
unsafe extern "C" {
    pub fn LZDone();
}
unsafe extern "C" {
    pub fn CopyLZFile(hfSource: INT, hfDest: INT) -> LONG;
}
unsafe extern "C" {
    pub fn LZCopy(hfSource: INT, hfDest: INT) -> LONG;
}
unsafe extern "C" {
    pub fn LZInit(hfSource: INT) -> INT;
}
unsafe extern "C" {
    pub fn GetExpandedNameA(lpszSource: LPSTR, lpszBuffer: LPSTR) -> INT;
}
unsafe extern "C" {
    pub fn GetExpandedNameW(lpszSource: LPWSTR, lpszBuffer: LPWSTR) -> INT;
}
unsafe extern "C" {
    pub fn LZOpenFileA(lpFileName: LPSTR, lpReOpenBuf: LPOFSTRUCT, wStyle: WORD) -> INT;
}
unsafe extern "C" {
    pub fn LZOpenFileW(lpFileName: LPWSTR, lpReOpenBuf: LPOFSTRUCT, wStyle: WORD) -> INT;
}
unsafe extern "C" {
    pub fn LZSeek(hFile: INT, lOffset: LONG, iOrigin: INT) -> LONG;
}
unsafe extern "C" {
    pub fn LZRead(hFile: INT, lpBuffer: *mut CHAR, cbRead: INT) -> INT;
}
unsafe extern "C" {
    pub fn LZClose(hFile: INT);
}
pub type MMVERSION = UINT;
pub type MMRESULT = UINT;
pub type LPUINT = *mut UINT;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct mmtime_tag {
    pub wType: UINT,
    pub u: mmtime_tag__bindgen_ty_1,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union mmtime_tag__bindgen_ty_1 {
    pub ms: DWORD,
    pub sample: DWORD,
    pub cb: DWORD,
    pub ticks: DWORD,
    pub smpte: mmtime_tag__bindgen_ty_1__bindgen_ty_1,
    pub midi: mmtime_tag__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct mmtime_tag__bindgen_ty_1__bindgen_ty_1 {
    pub hour: BYTE,
    pub min: BYTE,
    pub sec: BYTE,
    pub frame: BYTE,
    pub fps: BYTE,
    pub dummy: BYTE,
    pub pad: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of mmtime_tag__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<mmtime_tag__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of mmtime_tag__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<mmtime_tag__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::hour"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, hour) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::min"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, min) - 1usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::sec"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, sec) - 2usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::frame"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, frame) - 3usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::fps"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, fps) - 4usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::dummy"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, dummy) - 5usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_1::pad"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_1, pad) - 6usize];
};
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct mmtime_tag__bindgen_ty_1__bindgen_ty_2 {
    pub songptrpos: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of mmtime_tag__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<mmtime_tag__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of mmtime_tag__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<mmtime_tag__bindgen_ty_1__bindgen_ty_2>() - 1usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1__bindgen_ty_2::songptrpos"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1__bindgen_ty_2, songptrpos) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of mmtime_tag__bindgen_ty_1"]
        [::std::mem::size_of::<mmtime_tag__bindgen_ty_1>() - 8usize];
    ["Alignment of mmtime_tag__bindgen_ty_1"]
        [::std::mem::align_of::<mmtime_tag__bindgen_ty_1>() - 1usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::ms"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, ms) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::sample"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, sample) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::cb"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, cb) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::ticks"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, ticks) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::smpte"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, smpte) - 0usize];
    ["Offset of field: mmtime_tag__bindgen_ty_1::midi"]
        [::std::mem::offset_of!(mmtime_tag__bindgen_ty_1, midi) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of mmtime_tag"][::std::mem::size_of::<mmtime_tag>() - 12usize];
    ["Alignment of mmtime_tag"][::std::mem::align_of::<mmtime_tag>() - 1usize];
    ["Offset of field: mmtime_tag::wType"][::std::mem::offset_of!(mmtime_tag, wType) - 0usize];
    ["Offset of field: mmtime_tag::u"][::std::mem::offset_of!(mmtime_tag, u) - 4usize];
};
pub type MMTIME = mmtime_tag;
pub type PMMTIME = *mut mmtime_tag;
pub type NPMMTIME = *mut mmtime_tag;
pub type LPMMTIME = *mut mmtime_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HDRVR__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HDRVR__"][::std::mem::size_of::<HDRVR__>() - 4usize];
    ["Alignment of HDRVR__"][::std::mem::align_of::<HDRVR__>() - 1usize];
    ["Offset of field: HDRVR__::unused"][::std::mem::offset_of!(HDRVR__, unused) - 0usize];
};
pub type HDRVR = *mut HDRVR__;
pub type LPDRVCALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: HDRVR,
        arg2: UINT,
        arg3: DWORD_PTR,
        arg4: DWORD_PTR,
        arg5: DWORD_PTR,
    ),
>;
pub type PDRVCALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: HDRVR,
        arg2: UINT,
        arg3: DWORD_PTR,
        arg4: DWORD_PTR,
        arg5: DWORD_PTR,
    ),
>;
pub type MCIERROR = DWORD;
pub type MCIDEVICEID = UINT;
pub type YIELDPROC =
    ::std::option::Option<unsafe extern "C" fn(mciId: MCIDEVICEID, dwYieldData: DWORD) -> UINT>;
unsafe extern "C" {
    pub fn mciSendCommandA(
        mciId: MCIDEVICEID,
        uMsg: UINT,
        dwParam1: DWORD_PTR,
        dwParam2: DWORD_PTR,
    ) -> MCIERROR;
}
unsafe extern "C" {
    pub fn mciSendCommandW(
        mciId: MCIDEVICEID,
        uMsg: UINT,
        dwParam1: DWORD_PTR,
        dwParam2: DWORD_PTR,
    ) -> MCIERROR;
}
unsafe extern "C" {
    pub fn mciSendStringA(
        lpstrCommand: LPCSTR,
        lpstrReturnString: LPSTR,
        uReturnLength: UINT,
        hwndCallback: HWND,
    ) -> MCIERROR;
}
unsafe extern "C" {
    pub fn mciSendStringW(
        lpstrCommand: LPCWSTR,
        lpstrReturnString: LPWSTR,
        uReturnLength: UINT,
        hwndCallback: HWND,
    ) -> MCIERROR;
}
unsafe extern "C" {
    pub fn mciGetDeviceIDA(pszDevice: LPCSTR) -> MCIDEVICEID;
}
unsafe extern "C" {
    pub fn mciGetDeviceIDW(pszDevice: LPCWSTR) -> MCIDEVICEID;
}
unsafe extern "C" {
    pub fn mciGetDeviceIDFromElementIDA(dwElementID: DWORD, lpstrType: LPCSTR) -> MCIDEVICEID;
}
unsafe extern "C" {
    pub fn mciGetDeviceIDFromElementIDW(dwElementID: DWORD, lpstrType: LPCWSTR) -> MCIDEVICEID;
}
unsafe extern "C" {
    pub fn mciGetErrorStringA(mcierr: MCIERROR, pszText: LPSTR, cchText: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn mciGetErrorStringW(mcierr: MCIERROR, pszText: LPWSTR, cchText: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn mciSetYieldProc(mciId: MCIDEVICEID, fpYieldProc: YIELDPROC, dwYieldData: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn mciGetCreatorTask(mciId: MCIDEVICEID) -> HTASK;
}
unsafe extern "C" {
    pub fn mciGetYieldProc(mciId: MCIDEVICEID, pdwYieldData: LPDWORD) -> YIELDPROC;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_GENERIC_PARMS {
    pub dwCallback: DWORD_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_GENERIC_PARMS"][::std::mem::size_of::<tagMCI_GENERIC_PARMS>() - 8usize];
    ["Alignment of tagMCI_GENERIC_PARMS"][::std::mem::align_of::<tagMCI_GENERIC_PARMS>() - 1usize];
    ["Offset of field: tagMCI_GENERIC_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_GENERIC_PARMS, dwCallback) - 0usize];
};
pub type MCI_GENERIC_PARMS = tagMCI_GENERIC_PARMS;
pub type PMCI_GENERIC_PARMS = *mut tagMCI_GENERIC_PARMS;
pub type LPMCI_GENERIC_PARMS = *mut tagMCI_GENERIC_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OPEN_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCSTR,
    pub lpstrElementName: LPCSTR,
    pub lpstrAlias: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OPEN_PARMSA"][::std::mem::size_of::<tagMCI_OPEN_PARMSA>() - 36usize];
    ["Alignment of tagMCI_OPEN_PARMSA"][::std::mem::align_of::<tagMCI_OPEN_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_OPEN_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OPEN_PARMSA::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSA, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_OPEN_PARMSA::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSA, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_OPEN_PARMSA::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSA, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_OPEN_PARMSA::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSA, lpstrAlias) - 28usize];
};
pub type MCI_OPEN_PARMSA = tagMCI_OPEN_PARMSA;
pub type PMCI_OPEN_PARMSA = *mut tagMCI_OPEN_PARMSA;
pub type LPMCI_OPEN_PARMSA = *mut tagMCI_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OPEN_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCWSTR,
    pub lpstrElementName: LPCWSTR,
    pub lpstrAlias: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OPEN_PARMSW"][::std::mem::size_of::<tagMCI_OPEN_PARMSW>() - 36usize];
    ["Alignment of tagMCI_OPEN_PARMSW"][::std::mem::align_of::<tagMCI_OPEN_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_OPEN_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OPEN_PARMSW::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSW, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_OPEN_PARMSW::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSW, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_OPEN_PARMSW::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSW, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_OPEN_PARMSW::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_OPEN_PARMSW, lpstrAlias) - 28usize];
};
pub type MCI_OPEN_PARMSW = tagMCI_OPEN_PARMSW;
pub type PMCI_OPEN_PARMSW = *mut tagMCI_OPEN_PARMSW;
pub type LPMCI_OPEN_PARMSW = *mut tagMCI_OPEN_PARMSW;
pub type MCI_OPEN_PARMS = MCI_OPEN_PARMSA;
pub type PMCI_OPEN_PARMS = PMCI_OPEN_PARMSA;
pub type LPMCI_OPEN_PARMS = LPMCI_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_PLAY_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrom: DWORD,
    pub dwTo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_PLAY_PARMS"][::std::mem::size_of::<tagMCI_PLAY_PARMS>() - 16usize];
    ["Alignment of tagMCI_PLAY_PARMS"][::std::mem::align_of::<tagMCI_PLAY_PARMS>() - 1usize];
    ["Offset of field: tagMCI_PLAY_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_PLAY_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_PLAY_PARMS::dwFrom"]
        [::std::mem::offset_of!(tagMCI_PLAY_PARMS, dwFrom) - 8usize];
    ["Offset of field: tagMCI_PLAY_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_PLAY_PARMS, dwTo) - 12usize];
};
pub type MCI_PLAY_PARMS = tagMCI_PLAY_PARMS;
pub type PMCI_PLAY_PARMS = *mut tagMCI_PLAY_PARMS;
pub type LPMCI_PLAY_PARMS = *mut tagMCI_PLAY_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SEEK_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwTo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SEEK_PARMS"][::std::mem::size_of::<tagMCI_SEEK_PARMS>() - 12usize];
    ["Alignment of tagMCI_SEEK_PARMS"][::std::mem::align_of::<tagMCI_SEEK_PARMS>() - 1usize];
    ["Offset of field: tagMCI_SEEK_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SEEK_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SEEK_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_SEEK_PARMS, dwTo) - 8usize];
};
pub type MCI_SEEK_PARMS = tagMCI_SEEK_PARMS;
pub type PMCI_SEEK_PARMS = *mut tagMCI_SEEK_PARMS;
pub type LPMCI_SEEK_PARMS = *mut tagMCI_SEEK_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_STATUS_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwReturn: DWORD_PTR,
    pub dwItem: DWORD,
    pub dwTrack: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_STATUS_PARMS"][::std::mem::size_of::<tagMCI_STATUS_PARMS>() - 24usize];
    ["Alignment of tagMCI_STATUS_PARMS"][::std::mem::align_of::<tagMCI_STATUS_PARMS>() - 1usize];
    ["Offset of field: tagMCI_STATUS_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_STATUS_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_STATUS_PARMS::dwReturn"]
        [::std::mem::offset_of!(tagMCI_STATUS_PARMS, dwReturn) - 8usize];
    ["Offset of field: tagMCI_STATUS_PARMS::dwItem"]
        [::std::mem::offset_of!(tagMCI_STATUS_PARMS, dwItem) - 16usize];
    ["Offset of field: tagMCI_STATUS_PARMS::dwTrack"]
        [::std::mem::offset_of!(tagMCI_STATUS_PARMS, dwTrack) - 20usize];
};
pub type MCI_STATUS_PARMS = tagMCI_STATUS_PARMS;
pub type PMCI_STATUS_PARMS = *mut tagMCI_STATUS_PARMS;
pub type LPMCI_STATUS_PARMS = *mut tagMCI_STATUS_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_INFO_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpstrReturn: LPSTR,
    pub dwRetSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_INFO_PARMSA"][::std::mem::size_of::<tagMCI_INFO_PARMSA>() - 20usize];
    ["Alignment of tagMCI_INFO_PARMSA"][::std::mem::align_of::<tagMCI_INFO_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_INFO_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_INFO_PARMSA::lpstrReturn"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSA, lpstrReturn) - 8usize];
    ["Offset of field: tagMCI_INFO_PARMSA::dwRetSize"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSA, dwRetSize) - 16usize];
};
pub type MCI_INFO_PARMSA = tagMCI_INFO_PARMSA;
pub type LPMCI_INFO_PARMSA = *mut tagMCI_INFO_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_INFO_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpstrReturn: LPWSTR,
    pub dwRetSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_INFO_PARMSW"][::std::mem::size_of::<tagMCI_INFO_PARMSW>() - 20usize];
    ["Alignment of tagMCI_INFO_PARMSW"][::std::mem::align_of::<tagMCI_INFO_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_INFO_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_INFO_PARMSW::lpstrReturn"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSW, lpstrReturn) - 8usize];
    ["Offset of field: tagMCI_INFO_PARMSW::dwRetSize"]
        [::std::mem::offset_of!(tagMCI_INFO_PARMSW, dwRetSize) - 16usize];
};
pub type MCI_INFO_PARMSW = tagMCI_INFO_PARMSW;
pub type LPMCI_INFO_PARMSW = *mut tagMCI_INFO_PARMSW;
pub type MCI_INFO_PARMS = MCI_INFO_PARMSA;
pub type LPMCI_INFO_PARMS = LPMCI_INFO_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_GETDEVCAPS_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwReturn: DWORD,
    pub dwItem: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_GETDEVCAPS_PARMS"][::std::mem::size_of::<tagMCI_GETDEVCAPS_PARMS>() - 16usize];
    ["Alignment of tagMCI_GETDEVCAPS_PARMS"]
        [::std::mem::align_of::<tagMCI_GETDEVCAPS_PARMS>() - 1usize];
    ["Offset of field: tagMCI_GETDEVCAPS_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_GETDEVCAPS_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_GETDEVCAPS_PARMS::dwReturn"]
        [::std::mem::offset_of!(tagMCI_GETDEVCAPS_PARMS, dwReturn) - 8usize];
    ["Offset of field: tagMCI_GETDEVCAPS_PARMS::dwItem"]
        [::std::mem::offset_of!(tagMCI_GETDEVCAPS_PARMS, dwItem) - 12usize];
};
pub type MCI_GETDEVCAPS_PARMS = tagMCI_GETDEVCAPS_PARMS;
pub type PMCI_GETDEVCAPS_PARMS = *mut tagMCI_GETDEVCAPS_PARMS;
pub type LPMCI_GETDEVCAPS_PARMS = *mut tagMCI_GETDEVCAPS_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SYSINFO_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpstrReturn: LPSTR,
    pub dwRetSize: DWORD,
    pub dwNumber: DWORD,
    pub wDeviceType: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SYSINFO_PARMSA"][::std::mem::size_of::<tagMCI_SYSINFO_PARMSA>() - 28usize];
    ["Alignment of tagMCI_SYSINFO_PARMSA"]
        [::std::mem::align_of::<tagMCI_SYSINFO_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSA::lpstrReturn"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSA, lpstrReturn) - 8usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSA::dwRetSize"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSA, dwRetSize) - 16usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSA::dwNumber"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSA, dwNumber) - 20usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSA::wDeviceType"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSA, wDeviceType) - 24usize];
};
pub type MCI_SYSINFO_PARMSA = tagMCI_SYSINFO_PARMSA;
pub type PMCI_SYSINFO_PARMSA = *mut tagMCI_SYSINFO_PARMSA;
pub type LPMCI_SYSINFO_PARMSA = *mut tagMCI_SYSINFO_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SYSINFO_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpstrReturn: LPWSTR,
    pub dwRetSize: DWORD,
    pub dwNumber: DWORD,
    pub wDeviceType: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SYSINFO_PARMSW"][::std::mem::size_of::<tagMCI_SYSINFO_PARMSW>() - 28usize];
    ["Alignment of tagMCI_SYSINFO_PARMSW"]
        [::std::mem::align_of::<tagMCI_SYSINFO_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSW::lpstrReturn"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSW, lpstrReturn) - 8usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSW::dwRetSize"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSW, dwRetSize) - 16usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSW::dwNumber"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSW, dwNumber) - 20usize];
    ["Offset of field: tagMCI_SYSINFO_PARMSW::wDeviceType"]
        [::std::mem::offset_of!(tagMCI_SYSINFO_PARMSW, wDeviceType) - 24usize];
};
pub type MCI_SYSINFO_PARMSW = tagMCI_SYSINFO_PARMSW;
pub type PMCI_SYSINFO_PARMSW = *mut tagMCI_SYSINFO_PARMSW;
pub type LPMCI_SYSINFO_PARMSW = *mut tagMCI_SYSINFO_PARMSW;
pub type MCI_SYSINFO_PARMS = MCI_SYSINFO_PARMSA;
pub type PMCI_SYSINFO_PARMS = PMCI_SYSINFO_PARMSA;
pub type LPMCI_SYSINFO_PARMS = LPMCI_SYSINFO_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SET_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwTimeFormat: DWORD,
    pub dwAudio: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SET_PARMS"][::std::mem::size_of::<tagMCI_SET_PARMS>() - 16usize];
    ["Alignment of tagMCI_SET_PARMS"][::std::mem::align_of::<tagMCI_SET_PARMS>() - 1usize];
    ["Offset of field: tagMCI_SET_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SET_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SET_PARMS::dwTimeFormat"]
        [::std::mem::offset_of!(tagMCI_SET_PARMS, dwTimeFormat) - 8usize];
    ["Offset of field: tagMCI_SET_PARMS::dwAudio"]
        [::std::mem::offset_of!(tagMCI_SET_PARMS, dwAudio) - 12usize];
};
pub type MCI_SET_PARMS = tagMCI_SET_PARMS;
pub type PMCI_SET_PARMS = *mut tagMCI_SET_PARMS;
pub type LPMCI_SET_PARMS = *mut tagMCI_SET_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_BREAK_PARMS {
    pub dwCallback: DWORD_PTR,
    pub nVirtKey: ::std::os::raw::c_int,
    pub hwndBreak: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_BREAK_PARMS"][::std::mem::size_of::<tagMCI_BREAK_PARMS>() - 20usize];
    ["Alignment of tagMCI_BREAK_PARMS"][::std::mem::align_of::<tagMCI_BREAK_PARMS>() - 1usize];
    ["Offset of field: tagMCI_BREAK_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_BREAK_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_BREAK_PARMS::nVirtKey"]
        [::std::mem::offset_of!(tagMCI_BREAK_PARMS, nVirtKey) - 8usize];
    ["Offset of field: tagMCI_BREAK_PARMS::hwndBreak"]
        [::std::mem::offset_of!(tagMCI_BREAK_PARMS, hwndBreak) - 12usize];
};
pub type MCI_BREAK_PARMS = tagMCI_BREAK_PARMS;
pub type PMCI_BREAK_PARMS = *mut tagMCI_BREAK_PARMS;
pub type LPMCI_BREAK_PARMS = *mut tagMCI_BREAK_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SAVE_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SAVE_PARMSA"][::std::mem::size_of::<tagMCI_SAVE_PARMSA>() - 16usize];
    ["Alignment of tagMCI_SAVE_PARMSA"][::std::mem::align_of::<tagMCI_SAVE_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_SAVE_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SAVE_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SAVE_PARMSA::lpfilename"]
        [::std::mem::offset_of!(tagMCI_SAVE_PARMSA, lpfilename) - 8usize];
};
pub type MCI_SAVE_PARMSA = tagMCI_SAVE_PARMSA;
pub type PMCI_SAVE_PARMSA = *mut tagMCI_SAVE_PARMSA;
pub type LPMCI_SAVE_PARMSA = *mut tagMCI_SAVE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SAVE_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SAVE_PARMSW"][::std::mem::size_of::<tagMCI_SAVE_PARMSW>() - 16usize];
    ["Alignment of tagMCI_SAVE_PARMSW"][::std::mem::align_of::<tagMCI_SAVE_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_SAVE_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SAVE_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SAVE_PARMSW::lpfilename"]
        [::std::mem::offset_of!(tagMCI_SAVE_PARMSW, lpfilename) - 8usize];
};
pub type MCI_SAVE_PARMSW = tagMCI_SAVE_PARMSW;
pub type PMCI_SAVE_PARMSW = *mut tagMCI_SAVE_PARMSW;
pub type LPMCI_SAVE_PARMSW = *mut tagMCI_SAVE_PARMSW;
pub type MCI_SAVE_PARMS = MCI_SAVE_PARMSA;
pub type PMCI_SAVE_PARMS = PMCI_SAVE_PARMSA;
pub type LPMCI_SAVE_PARMS = LPMCI_SAVE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_LOAD_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_LOAD_PARMSA"][::std::mem::size_of::<tagMCI_LOAD_PARMSA>() - 16usize];
    ["Alignment of tagMCI_LOAD_PARMSA"][::std::mem::align_of::<tagMCI_LOAD_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_LOAD_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_LOAD_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_LOAD_PARMSA::lpfilename"]
        [::std::mem::offset_of!(tagMCI_LOAD_PARMSA, lpfilename) - 8usize];
};
pub type MCI_LOAD_PARMSA = tagMCI_LOAD_PARMSA;
pub type PMCI_LOAD_PARMSA = *mut tagMCI_LOAD_PARMSA;
pub type LPMCI_LOAD_PARMSA = *mut tagMCI_LOAD_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_LOAD_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_LOAD_PARMSW"][::std::mem::size_of::<tagMCI_LOAD_PARMSW>() - 16usize];
    ["Alignment of tagMCI_LOAD_PARMSW"][::std::mem::align_of::<tagMCI_LOAD_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_LOAD_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_LOAD_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_LOAD_PARMSW::lpfilename"]
        [::std::mem::offset_of!(tagMCI_LOAD_PARMSW, lpfilename) - 8usize];
};
pub type MCI_LOAD_PARMSW = tagMCI_LOAD_PARMSW;
pub type PMCI_LOAD_PARMSW = *mut tagMCI_LOAD_PARMSW;
pub type LPMCI_LOAD_PARMSW = *mut tagMCI_LOAD_PARMSW;
pub type MCI_LOAD_PARMS = MCI_LOAD_PARMSA;
pub type PMCI_LOAD_PARMS = PMCI_LOAD_PARMSA;
pub type LPMCI_LOAD_PARMS = LPMCI_LOAD_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_RECORD_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrom: DWORD,
    pub dwTo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_RECORD_PARMS"][::std::mem::size_of::<tagMCI_RECORD_PARMS>() - 16usize];
    ["Alignment of tagMCI_RECORD_PARMS"][::std::mem::align_of::<tagMCI_RECORD_PARMS>() - 1usize];
    ["Offset of field: tagMCI_RECORD_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_RECORD_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_RECORD_PARMS::dwFrom"]
        [::std::mem::offset_of!(tagMCI_RECORD_PARMS, dwFrom) - 8usize];
    ["Offset of field: tagMCI_RECORD_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_RECORD_PARMS, dwTo) - 12usize];
};
pub type MCI_RECORD_PARMS = tagMCI_RECORD_PARMS;
pub type LPMCI_RECORD_PARMS = *mut tagMCI_RECORD_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_VD_PLAY_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrom: DWORD,
    pub dwTo: DWORD,
    pub dwSpeed: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_VD_PLAY_PARMS"][::std::mem::size_of::<tagMCI_VD_PLAY_PARMS>() - 20usize];
    ["Alignment of tagMCI_VD_PLAY_PARMS"][::std::mem::align_of::<tagMCI_VD_PLAY_PARMS>() - 1usize];
    ["Offset of field: tagMCI_VD_PLAY_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_VD_PLAY_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_VD_PLAY_PARMS::dwFrom"]
        [::std::mem::offset_of!(tagMCI_VD_PLAY_PARMS, dwFrom) - 8usize];
    ["Offset of field: tagMCI_VD_PLAY_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_VD_PLAY_PARMS, dwTo) - 12usize];
    ["Offset of field: tagMCI_VD_PLAY_PARMS::dwSpeed"]
        [::std::mem::offset_of!(tagMCI_VD_PLAY_PARMS, dwSpeed) - 16usize];
};
pub type MCI_VD_PLAY_PARMS = tagMCI_VD_PLAY_PARMS;
pub type PMCI_VD_PLAY_PARMS = *mut tagMCI_VD_PLAY_PARMS;
pub type LPMCI_VD_PLAY_PARMS = *mut tagMCI_VD_PLAY_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_VD_STEP_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrames: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_VD_STEP_PARMS"][::std::mem::size_of::<tagMCI_VD_STEP_PARMS>() - 12usize];
    ["Alignment of tagMCI_VD_STEP_PARMS"][::std::mem::align_of::<tagMCI_VD_STEP_PARMS>() - 1usize];
    ["Offset of field: tagMCI_VD_STEP_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_VD_STEP_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_VD_STEP_PARMS::dwFrames"]
        [::std::mem::offset_of!(tagMCI_VD_STEP_PARMS, dwFrames) - 8usize];
};
pub type MCI_VD_STEP_PARMS = tagMCI_VD_STEP_PARMS;
pub type PMCI_VD_STEP_PARMS = *mut tagMCI_VD_STEP_PARMS;
pub type LPMCI_VD_STEP_PARMS = *mut tagMCI_VD_STEP_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_VD_ESCAPE_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpstrCommand: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_VD_ESCAPE_PARMSA"][::std::mem::size_of::<tagMCI_VD_ESCAPE_PARMSA>() - 16usize];
    ["Alignment of tagMCI_VD_ESCAPE_PARMSA"]
        [::std::mem::align_of::<tagMCI_VD_ESCAPE_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_VD_ESCAPE_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_VD_ESCAPE_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_VD_ESCAPE_PARMSA::lpstrCommand"]
        [::std::mem::offset_of!(tagMCI_VD_ESCAPE_PARMSA, lpstrCommand) - 8usize];
};
pub type MCI_VD_ESCAPE_PARMSA = tagMCI_VD_ESCAPE_PARMSA;
pub type PMCI_VD_ESCAPE_PARMSA = *mut tagMCI_VD_ESCAPE_PARMSA;
pub type LPMCI_VD_ESCAPE_PARMSA = *mut tagMCI_VD_ESCAPE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_VD_ESCAPE_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpstrCommand: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_VD_ESCAPE_PARMSW"][::std::mem::size_of::<tagMCI_VD_ESCAPE_PARMSW>() - 16usize];
    ["Alignment of tagMCI_VD_ESCAPE_PARMSW"]
        [::std::mem::align_of::<tagMCI_VD_ESCAPE_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_VD_ESCAPE_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_VD_ESCAPE_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_VD_ESCAPE_PARMSW::lpstrCommand"]
        [::std::mem::offset_of!(tagMCI_VD_ESCAPE_PARMSW, lpstrCommand) - 8usize];
};
pub type MCI_VD_ESCAPE_PARMSW = tagMCI_VD_ESCAPE_PARMSW;
pub type PMCI_VD_ESCAPE_PARMSW = *mut tagMCI_VD_ESCAPE_PARMSW;
pub type LPMCI_VD_ESCAPE_PARMSW = *mut tagMCI_VD_ESCAPE_PARMSW;
pub type MCI_VD_ESCAPE_PARMS = MCI_VD_ESCAPE_PARMSA;
pub type PMCI_VD_ESCAPE_PARMS = PMCI_VD_ESCAPE_PARMSA;
pub type LPMCI_VD_ESCAPE_PARMS = LPMCI_VD_ESCAPE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_WAVE_OPEN_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCSTR,
    pub lpstrElementName: LPCSTR,
    pub lpstrAlias: LPCSTR,
    pub dwBufferSeconds: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_WAVE_OPEN_PARMSA"][::std::mem::size_of::<tagMCI_WAVE_OPEN_PARMSA>() - 40usize];
    ["Alignment of tagMCI_WAVE_OPEN_PARMSA"]
        [::std::mem::align_of::<tagMCI_WAVE_OPEN_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSA::dwBufferSeconds"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSA, dwBufferSeconds) - 36usize];
};
pub type MCI_WAVE_OPEN_PARMSA = tagMCI_WAVE_OPEN_PARMSA;
pub type PMCI_WAVE_OPEN_PARMSA = *mut tagMCI_WAVE_OPEN_PARMSA;
pub type LPMCI_WAVE_OPEN_PARMSA = *mut tagMCI_WAVE_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_WAVE_OPEN_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCWSTR,
    pub lpstrElementName: LPCWSTR,
    pub lpstrAlias: LPCWSTR,
    pub dwBufferSeconds: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_WAVE_OPEN_PARMSW"][::std::mem::size_of::<tagMCI_WAVE_OPEN_PARMSW>() - 40usize];
    ["Alignment of tagMCI_WAVE_OPEN_PARMSW"]
        [::std::mem::align_of::<tagMCI_WAVE_OPEN_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_WAVE_OPEN_PARMSW::dwBufferSeconds"]
        [::std::mem::offset_of!(tagMCI_WAVE_OPEN_PARMSW, dwBufferSeconds) - 36usize];
};
pub type MCI_WAVE_OPEN_PARMSW = tagMCI_WAVE_OPEN_PARMSW;
pub type PMCI_WAVE_OPEN_PARMSW = *mut tagMCI_WAVE_OPEN_PARMSW;
pub type LPMCI_WAVE_OPEN_PARMSW = *mut tagMCI_WAVE_OPEN_PARMSW;
pub type MCI_WAVE_OPEN_PARMS = MCI_WAVE_OPEN_PARMSA;
pub type PMCI_WAVE_OPEN_PARMS = PMCI_WAVE_OPEN_PARMSA;
pub type LPMCI_WAVE_OPEN_PARMS = LPMCI_WAVE_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_WAVE_DELETE_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrom: DWORD,
    pub dwTo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_WAVE_DELETE_PARMS"]
        [::std::mem::size_of::<tagMCI_WAVE_DELETE_PARMS>() - 16usize];
    ["Alignment of tagMCI_WAVE_DELETE_PARMS"]
        [::std::mem::align_of::<tagMCI_WAVE_DELETE_PARMS>() - 1usize];
    ["Offset of field: tagMCI_WAVE_DELETE_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_WAVE_DELETE_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_WAVE_DELETE_PARMS::dwFrom"]
        [::std::mem::offset_of!(tagMCI_WAVE_DELETE_PARMS, dwFrom) - 8usize];
    ["Offset of field: tagMCI_WAVE_DELETE_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_WAVE_DELETE_PARMS, dwTo) - 12usize];
};
pub type MCI_WAVE_DELETE_PARMS = tagMCI_WAVE_DELETE_PARMS;
pub type PMCI_WAVE_DELETE_PARMS = *mut tagMCI_WAVE_DELETE_PARMS;
pub type LPMCI_WAVE_DELETE_PARMS = *mut tagMCI_WAVE_DELETE_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_WAVE_SET_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwTimeFormat: DWORD,
    pub dwAudio: DWORD,
    pub wInput: UINT,
    pub wOutput: UINT,
    pub wFormatTag: WORD,
    pub wReserved2: WORD,
    pub nChannels: WORD,
    pub wReserved3: WORD,
    pub nSamplesPerSec: DWORD,
    pub nAvgBytesPerSec: DWORD,
    pub nBlockAlign: WORD,
    pub wReserved4: WORD,
    pub wBitsPerSample: WORD,
    pub wReserved5: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_WAVE_SET_PARMS"][::std::mem::size_of::<tagMCI_WAVE_SET_PARMS>() - 48usize];
    ["Alignment of tagMCI_WAVE_SET_PARMS"]
        [::std::mem::align_of::<tagMCI_WAVE_SET_PARMS>() - 1usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::dwTimeFormat"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, dwTimeFormat) - 8usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::dwAudio"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, dwAudio) - 12usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wInput"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wInput) - 16usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wOutput"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wOutput) - 20usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wFormatTag"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wFormatTag) - 24usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wReserved2"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wReserved2) - 26usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::nChannels"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, nChannels) - 28usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wReserved3"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wReserved3) - 30usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::nSamplesPerSec"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, nSamplesPerSec) - 32usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::nAvgBytesPerSec"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, nAvgBytesPerSec) - 36usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::nBlockAlign"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, nBlockAlign) - 40usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wReserved4"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wReserved4) - 42usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wBitsPerSample"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wBitsPerSample) - 44usize];
    ["Offset of field: tagMCI_WAVE_SET_PARMS::wReserved5"]
        [::std::mem::offset_of!(tagMCI_WAVE_SET_PARMS, wReserved5) - 46usize];
};
pub type MCI_WAVE_SET_PARMS = tagMCI_WAVE_SET_PARMS;
pub type PMCI_WAVE_SET_PARMS = *mut tagMCI_WAVE_SET_PARMS;
pub type LPMCI_WAVE_SET_PARMS = *mut tagMCI_WAVE_SET_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_SEQ_SET_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwTimeFormat: DWORD,
    pub dwAudio: DWORD,
    pub dwTempo: DWORD,
    pub dwPort: DWORD,
    pub dwSlave: DWORD,
    pub dwMaster: DWORD,
    pub dwOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_SEQ_SET_PARMS"][::std::mem::size_of::<tagMCI_SEQ_SET_PARMS>() - 36usize];
    ["Alignment of tagMCI_SEQ_SET_PARMS"][::std::mem::align_of::<tagMCI_SEQ_SET_PARMS>() - 1usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwTimeFormat"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwTimeFormat) - 8usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwAudio"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwAudio) - 12usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwTempo"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwTempo) - 16usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwPort"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwPort) - 20usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwSlave"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwSlave) - 24usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwMaster"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwMaster) - 28usize];
    ["Offset of field: tagMCI_SEQ_SET_PARMS::dwOffset"]
        [::std::mem::offset_of!(tagMCI_SEQ_SET_PARMS, dwOffset) - 32usize];
};
pub type MCI_SEQ_SET_PARMS = tagMCI_SEQ_SET_PARMS;
pub type PMCI_SEQ_SET_PARMS = *mut tagMCI_SEQ_SET_PARMS;
pub type LPMCI_SEQ_SET_PARMS = *mut tagMCI_SEQ_SET_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_OPEN_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCSTR,
    pub lpstrElementName: LPCSTR,
    pub lpstrAlias: LPCSTR,
    pub dwStyle: DWORD,
    pub hWndParent: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_OPEN_PARMSA"][::std::mem::size_of::<tagMCI_ANIM_OPEN_PARMSA>() - 48usize];
    ["Alignment of tagMCI_ANIM_OPEN_PARMSA"]
        [::std::mem::align_of::<tagMCI_ANIM_OPEN_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::dwStyle"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, dwStyle) - 36usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSA::hWndParent"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSA, hWndParent) - 40usize];
};
pub type MCI_ANIM_OPEN_PARMSA = tagMCI_ANIM_OPEN_PARMSA;
pub type PMCI_ANIM_OPEN_PARMSA = *mut tagMCI_ANIM_OPEN_PARMSA;
pub type LPMCI_ANIM_OPEN_PARMSA = *mut tagMCI_ANIM_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_OPEN_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCWSTR,
    pub lpstrElementName: LPCWSTR,
    pub lpstrAlias: LPCWSTR,
    pub dwStyle: DWORD,
    pub hWndParent: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_OPEN_PARMSW"][::std::mem::size_of::<tagMCI_ANIM_OPEN_PARMSW>() - 48usize];
    ["Alignment of tagMCI_ANIM_OPEN_PARMSW"]
        [::std::mem::align_of::<tagMCI_ANIM_OPEN_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::dwStyle"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, dwStyle) - 36usize];
    ["Offset of field: tagMCI_ANIM_OPEN_PARMSW::hWndParent"]
        [::std::mem::offset_of!(tagMCI_ANIM_OPEN_PARMSW, hWndParent) - 40usize];
};
pub type MCI_ANIM_OPEN_PARMSW = tagMCI_ANIM_OPEN_PARMSW;
pub type PMCI_ANIM_OPEN_PARMSW = *mut tagMCI_ANIM_OPEN_PARMSW;
pub type LPMCI_ANIM_OPEN_PARMSW = *mut tagMCI_ANIM_OPEN_PARMSW;
pub type MCI_ANIM_OPEN_PARMS = MCI_ANIM_OPEN_PARMSA;
pub type PMCI_ANIM_OPEN_PARMS = PMCI_ANIM_OPEN_PARMSA;
pub type LPMCI_ANIM_OPEN_PARMS = LPMCI_ANIM_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_PLAY_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrom: DWORD,
    pub dwTo: DWORD,
    pub dwSpeed: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_PLAY_PARMS"][::std::mem::size_of::<tagMCI_ANIM_PLAY_PARMS>() - 20usize];
    ["Alignment of tagMCI_ANIM_PLAY_PARMS"]
        [::std::mem::align_of::<tagMCI_ANIM_PLAY_PARMS>() - 1usize];
    ["Offset of field: tagMCI_ANIM_PLAY_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_PLAY_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_PLAY_PARMS::dwFrom"]
        [::std::mem::offset_of!(tagMCI_ANIM_PLAY_PARMS, dwFrom) - 8usize];
    ["Offset of field: tagMCI_ANIM_PLAY_PARMS::dwTo"]
        [::std::mem::offset_of!(tagMCI_ANIM_PLAY_PARMS, dwTo) - 12usize];
    ["Offset of field: tagMCI_ANIM_PLAY_PARMS::dwSpeed"]
        [::std::mem::offset_of!(tagMCI_ANIM_PLAY_PARMS, dwSpeed) - 16usize];
};
pub type MCI_ANIM_PLAY_PARMS = tagMCI_ANIM_PLAY_PARMS;
pub type PMCI_ANIM_PLAY_PARMS = *mut tagMCI_ANIM_PLAY_PARMS;
pub type LPMCI_ANIM_PLAY_PARMS = *mut tagMCI_ANIM_PLAY_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_STEP_PARMS {
    pub dwCallback: DWORD_PTR,
    pub dwFrames: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_STEP_PARMS"][::std::mem::size_of::<tagMCI_ANIM_STEP_PARMS>() - 12usize];
    ["Alignment of tagMCI_ANIM_STEP_PARMS"]
        [::std::mem::align_of::<tagMCI_ANIM_STEP_PARMS>() - 1usize];
    ["Offset of field: tagMCI_ANIM_STEP_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_STEP_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_STEP_PARMS::dwFrames"]
        [::std::mem::offset_of!(tagMCI_ANIM_STEP_PARMS, dwFrames) - 8usize];
};
pub type MCI_ANIM_STEP_PARMS = tagMCI_ANIM_STEP_PARMS;
pub type PMCI_ANIM_STEP_PARMS = *mut tagMCI_ANIM_STEP_PARMS;
pub type LPMCI_ANIM_STEP_PARMS = *mut tagMCI_ANIM_STEP_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_WINDOW_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub hWnd: HWND,
    pub nCmdShow: UINT,
    pub lpstrText: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_WINDOW_PARMSA"]
        [::std::mem::size_of::<tagMCI_ANIM_WINDOW_PARMSA>() - 28usize];
    ["Alignment of tagMCI_ANIM_WINDOW_PARMSA"]
        [::std::mem::align_of::<tagMCI_ANIM_WINDOW_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSA::hWnd"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSA, hWnd) - 8usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSA::nCmdShow"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSA, nCmdShow) - 16usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSA::lpstrText"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSA, lpstrText) - 20usize];
};
pub type MCI_ANIM_WINDOW_PARMSA = tagMCI_ANIM_WINDOW_PARMSA;
pub type PMCI_ANIM_WINDOW_PARMSA = *mut tagMCI_ANIM_WINDOW_PARMSA;
pub type LPMCI_ANIM_WINDOW_PARMSA = *mut tagMCI_ANIM_WINDOW_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_WINDOW_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub hWnd: HWND,
    pub nCmdShow: UINT,
    pub lpstrText: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_WINDOW_PARMSW"]
        [::std::mem::size_of::<tagMCI_ANIM_WINDOW_PARMSW>() - 28usize];
    ["Alignment of tagMCI_ANIM_WINDOW_PARMSW"]
        [::std::mem::align_of::<tagMCI_ANIM_WINDOW_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSW::hWnd"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSW, hWnd) - 8usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSW::nCmdShow"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSW, nCmdShow) - 16usize];
    ["Offset of field: tagMCI_ANIM_WINDOW_PARMSW::lpstrText"]
        [::std::mem::offset_of!(tagMCI_ANIM_WINDOW_PARMSW, lpstrText) - 20usize];
};
pub type MCI_ANIM_WINDOW_PARMSW = tagMCI_ANIM_WINDOW_PARMSW;
pub type PMCI_ANIM_WINDOW_PARMSW = *mut tagMCI_ANIM_WINDOW_PARMSW;
pub type LPMCI_ANIM_WINDOW_PARMSW = *mut tagMCI_ANIM_WINDOW_PARMSW;
pub type MCI_ANIM_WINDOW_PARMS = MCI_ANIM_WINDOW_PARMSA;
pub type PMCI_ANIM_WINDOW_PARMS = PMCI_ANIM_WINDOW_PARMSA;
pub type LPMCI_ANIM_WINDOW_PARMS = LPMCI_ANIM_WINDOW_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_RECT_PARMS {
    pub dwCallback: DWORD_PTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_RECT_PARMS"][::std::mem::size_of::<tagMCI_ANIM_RECT_PARMS>() - 24usize];
    ["Alignment of tagMCI_ANIM_RECT_PARMS"]
        [::std::mem::align_of::<tagMCI_ANIM_RECT_PARMS>() - 1usize];
    ["Offset of field: tagMCI_ANIM_RECT_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_RECT_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_RECT_PARMS::rc"]
        [::std::mem::offset_of!(tagMCI_ANIM_RECT_PARMS, rc) - 8usize];
};
pub type MCI_ANIM_RECT_PARMS = tagMCI_ANIM_RECT_PARMS;
pub type PMCI_ANIM_RECT_PARMS = *mut MCI_ANIM_RECT_PARMS;
pub type LPMCI_ANIM_RECT_PARMS = *mut MCI_ANIM_RECT_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_ANIM_UPDATE_PARMS {
    pub dwCallback: DWORD_PTR,
    pub rc: RECT,
    pub hDC: HDC,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_ANIM_UPDATE_PARMS"]
        [::std::mem::size_of::<tagMCI_ANIM_UPDATE_PARMS>() - 32usize];
    ["Alignment of tagMCI_ANIM_UPDATE_PARMS"]
        [::std::mem::align_of::<tagMCI_ANIM_UPDATE_PARMS>() - 1usize];
    ["Offset of field: tagMCI_ANIM_UPDATE_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_ANIM_UPDATE_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_ANIM_UPDATE_PARMS::rc"]
        [::std::mem::offset_of!(tagMCI_ANIM_UPDATE_PARMS, rc) - 8usize];
    ["Offset of field: tagMCI_ANIM_UPDATE_PARMS::hDC"]
        [::std::mem::offset_of!(tagMCI_ANIM_UPDATE_PARMS, hDC) - 24usize];
};
pub type MCI_ANIM_UPDATE_PARMS = tagMCI_ANIM_UPDATE_PARMS;
pub type PMCI_ANIM_UPDATE_PARMS = *mut tagMCI_ANIM_UPDATE_PARMS;
pub type LPMCI_ANIM_UPDATE_PARMS = *mut tagMCI_ANIM_UPDATE_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_OPEN_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCSTR,
    pub lpstrElementName: LPCSTR,
    pub lpstrAlias: LPCSTR,
    pub dwStyle: DWORD,
    pub hWndParent: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_OPEN_PARMSA"][::std::mem::size_of::<tagMCI_OVLY_OPEN_PARMSA>() - 48usize];
    ["Alignment of tagMCI_OVLY_OPEN_PARMSA"]
        [::std::mem::align_of::<tagMCI_OVLY_OPEN_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::dwStyle"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, dwStyle) - 36usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSA::hWndParent"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSA, hWndParent) - 40usize];
};
pub type MCI_OVLY_OPEN_PARMSA = tagMCI_OVLY_OPEN_PARMSA;
pub type PMCI_OVLY_OPEN_PARMSA = *mut tagMCI_OVLY_OPEN_PARMSA;
pub type LPMCI_OVLY_OPEN_PARMSA = *mut tagMCI_OVLY_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_OPEN_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub wDeviceID: MCIDEVICEID,
    pub lpstrDeviceType: LPCWSTR,
    pub lpstrElementName: LPCWSTR,
    pub lpstrAlias: LPCWSTR,
    pub dwStyle: DWORD,
    pub hWndParent: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_OPEN_PARMSW"][::std::mem::size_of::<tagMCI_OVLY_OPEN_PARMSW>() - 48usize];
    ["Alignment of tagMCI_OVLY_OPEN_PARMSW"]
        [::std::mem::align_of::<tagMCI_OVLY_OPEN_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::wDeviceID"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, wDeviceID) - 8usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::lpstrDeviceType"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, lpstrDeviceType) - 12usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::lpstrElementName"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, lpstrElementName) - 20usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::lpstrAlias"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, lpstrAlias) - 28usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::dwStyle"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, dwStyle) - 36usize];
    ["Offset of field: tagMCI_OVLY_OPEN_PARMSW::hWndParent"]
        [::std::mem::offset_of!(tagMCI_OVLY_OPEN_PARMSW, hWndParent) - 40usize];
};
pub type MCI_OVLY_OPEN_PARMSW = tagMCI_OVLY_OPEN_PARMSW;
pub type PMCI_OVLY_OPEN_PARMSW = *mut tagMCI_OVLY_OPEN_PARMSW;
pub type LPMCI_OVLY_OPEN_PARMSW = *mut tagMCI_OVLY_OPEN_PARMSW;
pub type MCI_OVLY_OPEN_PARMS = MCI_OVLY_OPEN_PARMSA;
pub type PMCI_OVLY_OPEN_PARMS = PMCI_OVLY_OPEN_PARMSA;
pub type LPMCI_OVLY_OPEN_PARMS = LPMCI_OVLY_OPEN_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_WINDOW_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub hWnd: HWND,
    pub nCmdShow: UINT,
    pub lpstrText: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_WINDOW_PARMSA"]
        [::std::mem::size_of::<tagMCI_OVLY_WINDOW_PARMSA>() - 28usize];
    ["Alignment of tagMCI_OVLY_WINDOW_PARMSA"]
        [::std::mem::align_of::<tagMCI_OVLY_WINDOW_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSA::hWnd"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSA, hWnd) - 8usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSA::nCmdShow"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSA, nCmdShow) - 16usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSA::lpstrText"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSA, lpstrText) - 20usize];
};
pub type MCI_OVLY_WINDOW_PARMSA = tagMCI_OVLY_WINDOW_PARMSA;
pub type PMCI_OVLY_WINDOW_PARMSA = *mut tagMCI_OVLY_WINDOW_PARMSA;
pub type LPMCI_OVLY_WINDOW_PARMSA = *mut tagMCI_OVLY_WINDOW_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_WINDOW_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub hWnd: HWND,
    pub nCmdShow: UINT,
    pub lpstrText: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_WINDOW_PARMSW"]
        [::std::mem::size_of::<tagMCI_OVLY_WINDOW_PARMSW>() - 28usize];
    ["Alignment of tagMCI_OVLY_WINDOW_PARMSW"]
        [::std::mem::align_of::<tagMCI_OVLY_WINDOW_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSW::hWnd"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSW, hWnd) - 8usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSW::nCmdShow"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSW, nCmdShow) - 16usize];
    ["Offset of field: tagMCI_OVLY_WINDOW_PARMSW::lpstrText"]
        [::std::mem::offset_of!(tagMCI_OVLY_WINDOW_PARMSW, lpstrText) - 20usize];
};
pub type MCI_OVLY_WINDOW_PARMSW = tagMCI_OVLY_WINDOW_PARMSW;
pub type PMCI_OVLY_WINDOW_PARMSW = *mut tagMCI_OVLY_WINDOW_PARMSW;
pub type LPMCI_OVLY_WINDOW_PARMSW = *mut tagMCI_OVLY_WINDOW_PARMSW;
pub type MCI_OVLY_WINDOW_PARMS = MCI_OVLY_WINDOW_PARMSA;
pub type PMCI_OVLY_WINDOW_PARMS = PMCI_OVLY_WINDOW_PARMSA;
pub type LPMCI_OVLY_WINDOW_PARMS = LPMCI_OVLY_WINDOW_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_RECT_PARMS {
    pub dwCallback: DWORD_PTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_RECT_PARMS"][::std::mem::size_of::<tagMCI_OVLY_RECT_PARMS>() - 24usize];
    ["Alignment of tagMCI_OVLY_RECT_PARMS"]
        [::std::mem::align_of::<tagMCI_OVLY_RECT_PARMS>() - 1usize];
    ["Offset of field: tagMCI_OVLY_RECT_PARMS::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_RECT_PARMS, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_RECT_PARMS::rc"]
        [::std::mem::offset_of!(tagMCI_OVLY_RECT_PARMS, rc) - 8usize];
};
pub type MCI_OVLY_RECT_PARMS = tagMCI_OVLY_RECT_PARMS;
pub type PMCI_OVLY_RECT_PARMS = *mut tagMCI_OVLY_RECT_PARMS;
pub type LPMCI_OVLY_RECT_PARMS = *mut tagMCI_OVLY_RECT_PARMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_SAVE_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCSTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_SAVE_PARMSA"][::std::mem::size_of::<tagMCI_OVLY_SAVE_PARMSA>() - 32usize];
    ["Alignment of tagMCI_OVLY_SAVE_PARMSA"]
        [::std::mem::align_of::<tagMCI_OVLY_SAVE_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSA::lpfilename"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSA, lpfilename) - 8usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSA::rc"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSA, rc) - 16usize];
};
pub type MCI_OVLY_SAVE_PARMSA = tagMCI_OVLY_SAVE_PARMSA;
pub type PMCI_OVLY_SAVE_PARMSA = *mut tagMCI_OVLY_SAVE_PARMSA;
pub type LPMCI_OVLY_SAVE_PARMSA = *mut tagMCI_OVLY_SAVE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_SAVE_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCWSTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_SAVE_PARMSW"][::std::mem::size_of::<tagMCI_OVLY_SAVE_PARMSW>() - 32usize];
    ["Alignment of tagMCI_OVLY_SAVE_PARMSW"]
        [::std::mem::align_of::<tagMCI_OVLY_SAVE_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSW::lpfilename"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSW, lpfilename) - 8usize];
    ["Offset of field: tagMCI_OVLY_SAVE_PARMSW::rc"]
        [::std::mem::offset_of!(tagMCI_OVLY_SAVE_PARMSW, rc) - 16usize];
};
pub type MCI_OVLY_SAVE_PARMSW = tagMCI_OVLY_SAVE_PARMSW;
pub type PMCI_OVLY_SAVE_PARMSW = *mut tagMCI_OVLY_SAVE_PARMSW;
pub type LPMCI_OVLY_SAVE_PARMSW = *mut tagMCI_OVLY_SAVE_PARMSW;
pub type MCI_OVLY_SAVE_PARMS = MCI_OVLY_SAVE_PARMSA;
pub type PMCI_OVLY_SAVE_PARMS = PMCI_OVLY_SAVE_PARMSA;
pub type LPMCI_OVLY_SAVE_PARMS = LPMCI_OVLY_SAVE_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_LOAD_PARMSA {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCSTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_LOAD_PARMSA"][::std::mem::size_of::<tagMCI_OVLY_LOAD_PARMSA>() - 32usize];
    ["Alignment of tagMCI_OVLY_LOAD_PARMSA"]
        [::std::mem::align_of::<tagMCI_OVLY_LOAD_PARMSA>() - 1usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSA::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSA, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSA::lpfilename"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSA, lpfilename) - 8usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSA::rc"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSA, rc) - 16usize];
};
pub type MCI_OVLY_LOAD_PARMSA = tagMCI_OVLY_LOAD_PARMSA;
pub type PMCI_OVLY_LOAD_PARMSA = *mut tagMCI_OVLY_LOAD_PARMSA;
pub type LPMCI_OVLY_LOAD_PARMSA = *mut tagMCI_OVLY_LOAD_PARMSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMCI_OVLY_LOAD_PARMSW {
    pub dwCallback: DWORD_PTR,
    pub lpfilename: LPCWSTR,
    pub rc: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMCI_OVLY_LOAD_PARMSW"][::std::mem::size_of::<tagMCI_OVLY_LOAD_PARMSW>() - 32usize];
    ["Alignment of tagMCI_OVLY_LOAD_PARMSW"]
        [::std::mem::align_of::<tagMCI_OVLY_LOAD_PARMSW>() - 1usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSW::dwCallback"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSW, dwCallback) - 0usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSW::lpfilename"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSW, lpfilename) - 8usize];
    ["Offset of field: tagMCI_OVLY_LOAD_PARMSW::rc"]
        [::std::mem::offset_of!(tagMCI_OVLY_LOAD_PARMSW, rc) - 16usize];
};
pub type MCI_OVLY_LOAD_PARMSW = tagMCI_OVLY_LOAD_PARMSW;
pub type PMCI_OVLY_LOAD_PARMSW = *mut tagMCI_OVLY_LOAD_PARMSW;
pub type LPMCI_OVLY_LOAD_PARMSW = *mut tagMCI_OVLY_LOAD_PARMSW;
pub type MCI_OVLY_LOAD_PARMS = MCI_OVLY_LOAD_PARMSA;
pub type PMCI_OVLY_LOAD_PARMS = PMCI_OVLY_LOAD_PARMSA;
pub type LPMCI_OVLY_LOAD_PARMS = LPMCI_OVLY_LOAD_PARMSA;
unsafe extern "C" {
    pub fn mciGetDriverData(wDeviceID: MCIDEVICEID) -> DWORD_PTR;
}
unsafe extern "C" {
    pub fn mciLoadCommandResource(hInstance: HANDLE, lpResName: LPCWSTR, wType: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn mciSetDriverData(wDeviceID: MCIDEVICEID, dwData: DWORD_PTR) -> BOOL;
}
unsafe extern "C" {
    pub fn mciDriverYield(wDeviceID: MCIDEVICEID) -> UINT;
}
unsafe extern "C" {
    pub fn mciDriverNotify(hwndCallback: HANDLE, wDeviceID: MCIDEVICEID, uStatus: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn mciFreeCommandResource(wTable: UINT) -> BOOL;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct DRVCONFIGINFOEX {
    pub dwDCISize: DWORD,
    pub lpszDCISectionName: LPCWSTR,
    pub lpszDCIAliasName: LPCWSTR,
    pub dnDevNode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DRVCONFIGINFOEX"][::std::mem::size_of::<DRVCONFIGINFOEX>() - 24usize];
    ["Alignment of DRVCONFIGINFOEX"][::std::mem::align_of::<DRVCONFIGINFOEX>() - 1usize];
    ["Offset of field: DRVCONFIGINFOEX::dwDCISize"]
        [::std::mem::offset_of!(DRVCONFIGINFOEX, dwDCISize) - 0usize];
    ["Offset of field: DRVCONFIGINFOEX::lpszDCISectionName"]
        [::std::mem::offset_of!(DRVCONFIGINFOEX, lpszDCISectionName) - 4usize];
    ["Offset of field: DRVCONFIGINFOEX::lpszDCIAliasName"]
        [::std::mem::offset_of!(DRVCONFIGINFOEX, lpszDCIAliasName) - 12usize];
    ["Offset of field: DRVCONFIGINFOEX::dnDevNode"]
        [::std::mem::offset_of!(DRVCONFIGINFOEX, dnDevNode) - 20usize];
};
pub type PDRVCONFIGINFOEX = *mut DRVCONFIGINFOEX;
pub type NPDRVCONFIGINFOEX = *mut DRVCONFIGINFOEX;
pub type LPDRVCONFIGINFOEX = *mut DRVCONFIGINFOEX;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagDRVCONFIGINFO {
    pub dwDCISize: DWORD,
    pub lpszDCISectionName: LPCWSTR,
    pub lpszDCIAliasName: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDRVCONFIGINFO"][::std::mem::size_of::<tagDRVCONFIGINFO>() - 20usize];
    ["Alignment of tagDRVCONFIGINFO"][::std::mem::align_of::<tagDRVCONFIGINFO>() - 1usize];
    ["Offset of field: tagDRVCONFIGINFO::dwDCISize"]
        [::std::mem::offset_of!(tagDRVCONFIGINFO, dwDCISize) - 0usize];
    ["Offset of field: tagDRVCONFIGINFO::lpszDCISectionName"]
        [::std::mem::offset_of!(tagDRVCONFIGINFO, lpszDCISectionName) - 4usize];
    ["Offset of field: tagDRVCONFIGINFO::lpszDCIAliasName"]
        [::std::mem::offset_of!(tagDRVCONFIGINFO, lpszDCIAliasName) - 12usize];
};
pub type DRVCONFIGINFO = tagDRVCONFIGINFO;
pub type PDRVCONFIGINFO = *mut tagDRVCONFIGINFO;
pub type NPDRVCONFIGINFO = *mut tagDRVCONFIGINFO;
pub type LPDRVCONFIGINFO = *mut tagDRVCONFIGINFO;
pub type DRIVERPROC = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: DWORD_PTR,
        arg2: HDRVR,
        arg3: UINT,
        arg4: LPARAM,
        arg5: LPARAM,
    ) -> LRESULT,
>;
unsafe extern "C" {
    pub fn CloseDriver(hDriver: HDRVR, lParam1: LPARAM, lParam2: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn OpenDriver(szDriverName: LPCWSTR, szSectionName: LPCWSTR, lParam2: LPARAM) -> HDRVR;
}
unsafe extern "C" {
    pub fn SendDriverMessage(
        hDriver: HDRVR,
        message: UINT,
        lParam1: LPARAM,
        lParam2: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn DrvGetModuleHandle(hDriver: HDRVR) -> HMODULE;
}
unsafe extern "C" {
    pub fn GetDriverModuleHandle(hDriver: HDRVR) -> HMODULE;
}
unsafe extern "C" {
    pub fn DefDriverProc(
        dwDriverIdentifier: DWORD_PTR,
        hdrvr: HDRVR,
        uMsg: UINT,
        lParam1: LPARAM,
        lParam2: LPARAM,
    ) -> LRESULT;
}
unsafe extern "C" {
    pub fn DriverCallback(
        dwCallback: DWORD_PTR,
        dwFlags: DWORD,
        hDevice: HDRVR,
        dwMsg: DWORD,
        dwUser: DWORD_PTR,
        dwParam1: DWORD_PTR,
        dwParam2: DWORD_PTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn sndOpenSound(
        EventName: LPCWSTR,
        AppName: LPCWSTR,
        Flags: INT32,
        FileHandle: PHANDLE,
    ) -> LONG;
}
pub type DRIVERMSGPROC = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: DWORD,
        arg2: DWORD,
        arg3: DWORD_PTR,
        arg4: DWORD_PTR,
        arg5: DWORD_PTR,
    ) -> DWORD,
>;
unsafe extern "C" {
    pub fn mmDrvInstall(
        hDriver: HDRVR,
        wszDrvEntry: LPCWSTR,
        drvMessage: DRIVERMSGPROC,
        wFlags: UINT,
    ) -> UINT;
}
pub type FOURCC = DWORD;
pub type HPSTR = *mut ::std::os::raw::c_char;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMMIO__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMMIO__"][::std::mem::size_of::<HMMIO__>() - 4usize];
    ["Alignment of HMMIO__"][::std::mem::align_of::<HMMIO__>() - 1usize];
    ["Offset of field: HMMIO__::unused"][::std::mem::offset_of!(HMMIO__, unused) - 0usize];
};
pub type HMMIO = *mut HMMIO__;
pub type LPMMIOPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: LPSTR, arg2: UINT, arg3: LPARAM, arg4: LPARAM) -> LRESULT,
>;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _MMIOINFO {
    pub dwFlags: DWORD,
    pub fccIOProc: FOURCC,
    pub pIOProc: LPMMIOPROC,
    pub wErrorRet: UINT,
    pub htask: HTASK,
    pub cchBuffer: LONG,
    pub pchBuffer: HPSTR,
    pub pchNext: HPSTR,
    pub pchEndRead: HPSTR,
    pub pchEndWrite: HPSTR,
    pub lBufOffset: LONG,
    pub lDiskOffset: LONG,
    pub adwInfo: [DWORD; 3usize],
    pub dwReserved1: DWORD,
    pub dwReserved2: DWORD,
    pub hmmio: HMMIO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MMIOINFO"][::std::mem::size_of::<_MMIOINFO>() - 100usize];
    ["Alignment of _MMIOINFO"][::std::mem::align_of::<_MMIOINFO>() - 1usize];
    ["Offset of field: _MMIOINFO::dwFlags"][::std::mem::offset_of!(_MMIOINFO, dwFlags) - 0usize];
    ["Offset of field: _MMIOINFO::fccIOProc"]
        [::std::mem::offset_of!(_MMIOINFO, fccIOProc) - 4usize];
    ["Offset of field: _MMIOINFO::pIOProc"][::std::mem::offset_of!(_MMIOINFO, pIOProc) - 8usize];
    ["Offset of field: _MMIOINFO::wErrorRet"]
        [::std::mem::offset_of!(_MMIOINFO, wErrorRet) - 16usize];
    ["Offset of field: _MMIOINFO::htask"][::std::mem::offset_of!(_MMIOINFO, htask) - 20usize];
    ["Offset of field: _MMIOINFO::cchBuffer"]
        [::std::mem::offset_of!(_MMIOINFO, cchBuffer) - 28usize];
    ["Offset of field: _MMIOINFO::pchBuffer"]
        [::std::mem::offset_of!(_MMIOINFO, pchBuffer) - 32usize];
    ["Offset of field: _MMIOINFO::pchNext"][::std::mem::offset_of!(_MMIOINFO, pchNext) - 40usize];
    ["Offset of field: _MMIOINFO::pchEndRead"]
        [::std::mem::offset_of!(_MMIOINFO, pchEndRead) - 48usize];
    ["Offset of field: _MMIOINFO::pchEndWrite"]
        [::std::mem::offset_of!(_MMIOINFO, pchEndWrite) - 56usize];
    ["Offset of field: _MMIOINFO::lBufOffset"]
        [::std::mem::offset_of!(_MMIOINFO, lBufOffset) - 64usize];
    ["Offset of field: _MMIOINFO::lDiskOffset"]
        [::std::mem::offset_of!(_MMIOINFO, lDiskOffset) - 68usize];
    ["Offset of field: _MMIOINFO::adwInfo"][::std::mem::offset_of!(_MMIOINFO, adwInfo) - 72usize];
    ["Offset of field: _MMIOINFO::dwReserved1"]
        [::std::mem::offset_of!(_MMIOINFO, dwReserved1) - 84usize];
    ["Offset of field: _MMIOINFO::dwReserved2"]
        [::std::mem::offset_of!(_MMIOINFO, dwReserved2) - 88usize];
    ["Offset of field: _MMIOINFO::hmmio"][::std::mem::offset_of!(_MMIOINFO, hmmio) - 92usize];
};
pub type MMIOINFO = _MMIOINFO;
pub type PMMIOINFO = *mut _MMIOINFO;
pub type NPMMIOINFO = *mut _MMIOINFO;
pub type LPMMIOINFO = *mut _MMIOINFO;
pub type LPCMMIOINFO = *const MMIOINFO;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _MMCKINFO {
    pub ckid: FOURCC,
    pub cksize: DWORD,
    pub fccType: FOURCC,
    pub dwDataOffset: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MMCKINFO"][::std::mem::size_of::<_MMCKINFO>() - 20usize];
    ["Alignment of _MMCKINFO"][::std::mem::align_of::<_MMCKINFO>() - 1usize];
    ["Offset of field: _MMCKINFO::ckid"][::std::mem::offset_of!(_MMCKINFO, ckid) - 0usize];
    ["Offset of field: _MMCKINFO::cksize"][::std::mem::offset_of!(_MMCKINFO, cksize) - 4usize];
    ["Offset of field: _MMCKINFO::fccType"][::std::mem::offset_of!(_MMCKINFO, fccType) - 8usize];
    ["Offset of field: _MMCKINFO::dwDataOffset"]
        [::std::mem::offset_of!(_MMCKINFO, dwDataOffset) - 12usize];
    ["Offset of field: _MMCKINFO::dwFlags"][::std::mem::offset_of!(_MMCKINFO, dwFlags) - 16usize];
};
pub type MMCKINFO = _MMCKINFO;
pub type PMMCKINFO = *mut _MMCKINFO;
pub type NPMMCKINFO = *mut _MMCKINFO;
pub type LPMMCKINFO = *mut _MMCKINFO;
pub type LPCMMCKINFO = *const MMCKINFO;
unsafe extern "C" {
    pub fn mmioStringToFOURCCA(sz: LPCSTR, uFlags: UINT) -> FOURCC;
}
unsafe extern "C" {
    pub fn mmioStringToFOURCCW(sz: LPCWSTR, uFlags: UINT) -> FOURCC;
}
unsafe extern "C" {
    pub fn mmioInstallIOProcA(fccIOProc: FOURCC, pIOProc: LPMMIOPROC, dwFlags: DWORD)
        -> LPMMIOPROC;
}
unsafe extern "C" {
    pub fn mmioInstallIOProcW(fccIOProc: FOURCC, pIOProc: LPMMIOPROC, dwFlags: DWORD)
        -> LPMMIOPROC;
}
unsafe extern "C" {
    pub fn mmioOpenA(pszFileName: LPSTR, pmmioinfo: LPMMIOINFO, fdwOpen: DWORD) -> HMMIO;
}
unsafe extern "C" {
    pub fn mmioOpenW(pszFileName: LPWSTR, pmmioinfo: LPMMIOINFO, fdwOpen: DWORD) -> HMMIO;
}
unsafe extern "C" {
    pub fn mmioRenameA(
        pszFileName: LPCSTR,
        pszNewFileName: LPCSTR,
        pmmioinfo: LPCMMIOINFO,
        fdwRename: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioRenameW(
        pszFileName: LPCWSTR,
        pszNewFileName: LPCWSTR,
        pmmioinfo: LPCMMIOINFO,
        fdwRename: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioClose(hmmio: HMMIO, fuClose: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioRead(hmmio: HMMIO, pch: HPSTR, cch: LONG) -> LONG;
}
unsafe extern "C" {
    pub fn mmioWrite(hmmio: HMMIO, pch: *const ::std::os::raw::c_char, cch: LONG) -> LONG;
}
unsafe extern "C" {
    pub fn mmioSeek(hmmio: HMMIO, lOffset: LONG, iOrigin: ::std::os::raw::c_int) -> LONG;
}
unsafe extern "C" {
    pub fn mmioGetInfo(hmmio: HMMIO, pmmioinfo: LPMMIOINFO, fuInfo: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioSetInfo(hmmio: HMMIO, pmmioinfo: LPCMMIOINFO, fuInfo: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioSetBuffer(
        hmmio: HMMIO,
        pchBuffer: LPSTR,
        cchBuffer: LONG,
        fuBuffer: UINT,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioFlush(hmmio: HMMIO, fuFlush: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioAdvance(hmmio: HMMIO, pmmioinfo: LPMMIOINFO, fuAdvance: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioSendMessage(hmmio: HMMIO, uMsg: UINT, lParam1: LPARAM, lParam2: LPARAM) -> LRESULT;
}
unsafe extern "C" {
    pub fn mmioDescend(
        hmmio: HMMIO,
        pmmcki: LPMMCKINFO,
        pmmckiParent: *const MMCKINFO,
        fuDescend: UINT,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioAscend(hmmio: HMMIO, pmmcki: LPMMCKINFO, fuAscend: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mmioCreateChunk(hmmio: HMMIO, pmmcki: LPMMCKINFO, fuCreate: UINT) -> MMRESULT;
}
pub type LPTIMECALLBACK = ::std::option::Option<
    unsafe extern "C" fn(arg1: UINT, arg2: UINT, arg3: DWORD_PTR, arg4: DWORD_PTR, arg5: DWORD_PTR),
>;
unsafe extern "C" {
    pub fn timeSetEvent(
        uDelay: UINT,
        uResolution: UINT,
        fptc: LPTIMECALLBACK,
        dwUser: DWORD_PTR,
        fuEvent: UINT,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn timeKillEvent(uTimerID: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn sndPlaySoundA(pszSound: LPCSTR, fuSound: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn sndPlaySoundW(pszSound: LPCWSTR, fuSound: UINT) -> BOOL;
}
unsafe extern "C" {
    pub fn PlaySoundA(pszSound: LPCSTR, hmod: HMODULE, fdwSound: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn PlaySoundW(pszSound: LPCWSTR, hmod: HMODULE, fdwSound: DWORD) -> BOOL;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HWAVE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWAVE__"][::std::mem::size_of::<HWAVE__>() - 4usize];
    ["Alignment of HWAVE__"][::std::mem::align_of::<HWAVE__>() - 1usize];
    ["Offset of field: HWAVE__::unused"][::std::mem::offset_of!(HWAVE__, unused) - 0usize];
};
pub type HWAVE = *mut HWAVE__;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HWAVEIN__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWAVEIN__"][::std::mem::size_of::<HWAVEIN__>() - 4usize];
    ["Alignment of HWAVEIN__"][::std::mem::align_of::<HWAVEIN__>() - 1usize];
    ["Offset of field: HWAVEIN__::unused"][::std::mem::offset_of!(HWAVEIN__, unused) - 0usize];
};
pub type HWAVEIN = *mut HWAVEIN__;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HWAVEOUT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HWAVEOUT__"][::std::mem::size_of::<HWAVEOUT__>() - 4usize];
    ["Alignment of HWAVEOUT__"][::std::mem::align_of::<HWAVEOUT__>() - 1usize];
    ["Offset of field: HWAVEOUT__::unused"][::std::mem::offset_of!(HWAVEOUT__, unused) - 0usize];
};
pub type HWAVEOUT = *mut HWAVEOUT__;
pub type LPHWAVEIN = *mut HWAVEIN;
pub type LPHWAVEOUT = *mut HWAVEOUT;
pub type LPWAVECALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: HDRVR,
        arg2: UINT,
        arg3: DWORD_PTR,
        arg4: DWORD_PTR,
        arg5: DWORD_PTR,
    ),
>;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct wavehdr_tag {
    pub lpData: LPSTR,
    pub dwBufferLength: DWORD,
    pub dwBytesRecorded: DWORD,
    pub dwUser: DWORD_PTR,
    pub dwFlags: DWORD,
    pub dwLoops: DWORD,
    pub lpNext: *mut wavehdr_tag,
    pub reserved: DWORD_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of wavehdr_tag"][::std::mem::size_of::<wavehdr_tag>() - 48usize];
    ["Alignment of wavehdr_tag"][::std::mem::align_of::<wavehdr_tag>() - 1usize];
    ["Offset of field: wavehdr_tag::lpData"][::std::mem::offset_of!(wavehdr_tag, lpData) - 0usize];
    ["Offset of field: wavehdr_tag::dwBufferLength"]
        [::std::mem::offset_of!(wavehdr_tag, dwBufferLength) - 8usize];
    ["Offset of field: wavehdr_tag::dwBytesRecorded"]
        [::std::mem::offset_of!(wavehdr_tag, dwBytesRecorded) - 12usize];
    ["Offset of field: wavehdr_tag::dwUser"][::std::mem::offset_of!(wavehdr_tag, dwUser) - 16usize];
    ["Offset of field: wavehdr_tag::dwFlags"]
        [::std::mem::offset_of!(wavehdr_tag, dwFlags) - 24usize];
    ["Offset of field: wavehdr_tag::dwLoops"]
        [::std::mem::offset_of!(wavehdr_tag, dwLoops) - 28usize];
    ["Offset of field: wavehdr_tag::lpNext"][::std::mem::offset_of!(wavehdr_tag, lpNext) - 32usize];
    ["Offset of field: wavehdr_tag::reserved"]
        [::std::mem::offset_of!(wavehdr_tag, reserved) - 40usize];
};
pub type WAVEHDR = wavehdr_tag;
pub type PWAVEHDR = *mut wavehdr_tag;
pub type NPWAVEHDR = *mut wavehdr_tag;
pub type LPWAVEHDR = *mut wavehdr_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEOUTCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEOUTCAPSA"][::std::mem::size_of::<tagWAVEOUTCAPSA>() - 52usize];
    ["Alignment of tagWAVEOUTCAPSA"][::std::mem::align_of::<tagWAVEOUTCAPSA>() - 1usize];
    ["Offset of field: tagWAVEOUTCAPSA::wMid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, wMid) - 0usize];
    ["Offset of field: tagWAVEOUTCAPSA::wPid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, wPid) - 2usize];
    ["Offset of field: tagWAVEOUTCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEOUTCAPSA::szPname"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, szPname) - 8usize];
    ["Offset of field: tagWAVEOUTCAPSA::dwFormats"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, dwFormats) - 40usize];
    ["Offset of field: tagWAVEOUTCAPSA::wChannels"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, wChannels) - 44usize];
    ["Offset of field: tagWAVEOUTCAPSA::wReserved1"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, wReserved1) - 46usize];
    ["Offset of field: tagWAVEOUTCAPSA::dwSupport"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSA, dwSupport) - 48usize];
};
pub type WAVEOUTCAPSA = tagWAVEOUTCAPSA;
pub type PWAVEOUTCAPSA = *mut tagWAVEOUTCAPSA;
pub type NPWAVEOUTCAPSA = *mut tagWAVEOUTCAPSA;
pub type LPWAVEOUTCAPSA = *mut tagWAVEOUTCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEOUTCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEOUTCAPSW"][::std::mem::size_of::<tagWAVEOUTCAPSW>() - 84usize];
    ["Alignment of tagWAVEOUTCAPSW"][::std::mem::align_of::<tagWAVEOUTCAPSW>() - 1usize];
    ["Offset of field: tagWAVEOUTCAPSW::wMid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, wMid) - 0usize];
    ["Offset of field: tagWAVEOUTCAPSW::wPid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, wPid) - 2usize];
    ["Offset of field: tagWAVEOUTCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEOUTCAPSW::szPname"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, szPname) - 8usize];
    ["Offset of field: tagWAVEOUTCAPSW::dwFormats"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, dwFormats) - 72usize];
    ["Offset of field: tagWAVEOUTCAPSW::wChannels"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, wChannels) - 76usize];
    ["Offset of field: tagWAVEOUTCAPSW::wReserved1"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, wReserved1) - 78usize];
    ["Offset of field: tagWAVEOUTCAPSW::dwSupport"]
        [::std::mem::offset_of!(tagWAVEOUTCAPSW, dwSupport) - 80usize];
};
pub type WAVEOUTCAPSW = tagWAVEOUTCAPSW;
pub type PWAVEOUTCAPSW = *mut tagWAVEOUTCAPSW;
pub type NPWAVEOUTCAPSW = *mut tagWAVEOUTCAPSW;
pub type LPWAVEOUTCAPSW = *mut tagWAVEOUTCAPSW;
pub type WAVEOUTCAPS = WAVEOUTCAPSA;
pub type PWAVEOUTCAPS = PWAVEOUTCAPSA;
pub type NPWAVEOUTCAPS = NPWAVEOUTCAPSA;
pub type LPWAVEOUTCAPS = LPWAVEOUTCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEOUTCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEOUTCAPS2A"][::std::mem::size_of::<tagWAVEOUTCAPS2A>() - 100usize];
    ["Alignment of tagWAVEOUTCAPS2A"][::std::mem::align_of::<tagWAVEOUTCAPS2A>() - 1usize];
    ["Offset of field: tagWAVEOUTCAPS2A::wMid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, wMid) - 0usize];
    ["Offset of field: tagWAVEOUTCAPS2A::wPid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, wPid) - 2usize];
    ["Offset of field: tagWAVEOUTCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEOUTCAPS2A::szPname"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, szPname) - 8usize];
    ["Offset of field: tagWAVEOUTCAPS2A::dwFormats"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, dwFormats) - 40usize];
    ["Offset of field: tagWAVEOUTCAPS2A::wChannels"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, wChannels) - 44usize];
    ["Offset of field: tagWAVEOUTCAPS2A::wReserved1"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, wReserved1) - 46usize];
    ["Offset of field: tagWAVEOUTCAPS2A::dwSupport"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, dwSupport) - 48usize];
    ["Offset of field: tagWAVEOUTCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, ManufacturerGuid) - 52usize];
    ["Offset of field: tagWAVEOUTCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, ProductGuid) - 68usize];
    ["Offset of field: tagWAVEOUTCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2A, NameGuid) - 84usize];
};
pub type WAVEOUTCAPS2A = tagWAVEOUTCAPS2A;
pub type PWAVEOUTCAPS2A = *mut tagWAVEOUTCAPS2A;
pub type NPWAVEOUTCAPS2A = *mut tagWAVEOUTCAPS2A;
pub type LPWAVEOUTCAPS2A = *mut tagWAVEOUTCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEOUTCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEOUTCAPS2W"][::std::mem::size_of::<tagWAVEOUTCAPS2W>() - 132usize];
    ["Alignment of tagWAVEOUTCAPS2W"][::std::mem::align_of::<tagWAVEOUTCAPS2W>() - 1usize];
    ["Offset of field: tagWAVEOUTCAPS2W::wMid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, wMid) - 0usize];
    ["Offset of field: tagWAVEOUTCAPS2W::wPid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, wPid) - 2usize];
    ["Offset of field: tagWAVEOUTCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEOUTCAPS2W::szPname"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, szPname) - 8usize];
    ["Offset of field: tagWAVEOUTCAPS2W::dwFormats"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, dwFormats) - 72usize];
    ["Offset of field: tagWAVEOUTCAPS2W::wChannels"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, wChannels) - 76usize];
    ["Offset of field: tagWAVEOUTCAPS2W::wReserved1"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, wReserved1) - 78usize];
    ["Offset of field: tagWAVEOUTCAPS2W::dwSupport"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, dwSupport) - 80usize];
    ["Offset of field: tagWAVEOUTCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, ManufacturerGuid) - 84usize];
    ["Offset of field: tagWAVEOUTCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, ProductGuid) - 100usize];
    ["Offset of field: tagWAVEOUTCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagWAVEOUTCAPS2W, NameGuid) - 116usize];
};
pub type WAVEOUTCAPS2W = tagWAVEOUTCAPS2W;
pub type PWAVEOUTCAPS2W = *mut tagWAVEOUTCAPS2W;
pub type NPWAVEOUTCAPS2W = *mut tagWAVEOUTCAPS2W;
pub type LPWAVEOUTCAPS2W = *mut tagWAVEOUTCAPS2W;
pub type WAVEOUTCAPS2 = WAVEOUTCAPS2A;
pub type PWAVEOUTCAPS2 = PWAVEOUTCAPS2A;
pub type NPWAVEOUTCAPS2 = NPWAVEOUTCAPS2A;
pub type LPWAVEOUTCAPS2 = LPWAVEOUTCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEINCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEINCAPSA"][::std::mem::size_of::<tagWAVEINCAPSA>() - 48usize];
    ["Alignment of tagWAVEINCAPSA"][::std::mem::align_of::<tagWAVEINCAPSA>() - 1usize];
    ["Offset of field: tagWAVEINCAPSA::wMid"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, wMid) - 0usize];
    ["Offset of field: tagWAVEINCAPSA::wPid"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, wPid) - 2usize];
    ["Offset of field: tagWAVEINCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEINCAPSA::szPname"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, szPname) - 8usize];
    ["Offset of field: tagWAVEINCAPSA::dwFormats"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, dwFormats) - 40usize];
    ["Offset of field: tagWAVEINCAPSA::wChannels"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, wChannels) - 44usize];
    ["Offset of field: tagWAVEINCAPSA::wReserved1"]
        [::std::mem::offset_of!(tagWAVEINCAPSA, wReserved1) - 46usize];
};
pub type WAVEINCAPSA = tagWAVEINCAPSA;
pub type PWAVEINCAPSA = *mut tagWAVEINCAPSA;
pub type NPWAVEINCAPSA = *mut tagWAVEINCAPSA;
pub type LPWAVEINCAPSA = *mut tagWAVEINCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEINCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEINCAPSW"][::std::mem::size_of::<tagWAVEINCAPSW>() - 80usize];
    ["Alignment of tagWAVEINCAPSW"][::std::mem::align_of::<tagWAVEINCAPSW>() - 1usize];
    ["Offset of field: tagWAVEINCAPSW::wMid"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, wMid) - 0usize];
    ["Offset of field: tagWAVEINCAPSW::wPid"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, wPid) - 2usize];
    ["Offset of field: tagWAVEINCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEINCAPSW::szPname"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, szPname) - 8usize];
    ["Offset of field: tagWAVEINCAPSW::dwFormats"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, dwFormats) - 72usize];
    ["Offset of field: tagWAVEINCAPSW::wChannels"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, wChannels) - 76usize];
    ["Offset of field: tagWAVEINCAPSW::wReserved1"]
        [::std::mem::offset_of!(tagWAVEINCAPSW, wReserved1) - 78usize];
};
pub type WAVEINCAPSW = tagWAVEINCAPSW;
pub type PWAVEINCAPSW = *mut tagWAVEINCAPSW;
pub type NPWAVEINCAPSW = *mut tagWAVEINCAPSW;
pub type LPWAVEINCAPSW = *mut tagWAVEINCAPSW;
pub type WAVEINCAPS = WAVEINCAPSA;
pub type PWAVEINCAPS = PWAVEINCAPSA;
pub type NPWAVEINCAPS = NPWAVEINCAPSA;
pub type LPWAVEINCAPS = LPWAVEINCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEINCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEINCAPS2A"][::std::mem::size_of::<tagWAVEINCAPS2A>() - 96usize];
    ["Alignment of tagWAVEINCAPS2A"][::std::mem::align_of::<tagWAVEINCAPS2A>() - 1usize];
    ["Offset of field: tagWAVEINCAPS2A::wMid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, wMid) - 0usize];
    ["Offset of field: tagWAVEINCAPS2A::wPid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, wPid) - 2usize];
    ["Offset of field: tagWAVEINCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEINCAPS2A::szPname"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, szPname) - 8usize];
    ["Offset of field: tagWAVEINCAPS2A::dwFormats"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, dwFormats) - 40usize];
    ["Offset of field: tagWAVEINCAPS2A::wChannels"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, wChannels) - 44usize];
    ["Offset of field: tagWAVEINCAPS2A::wReserved1"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, wReserved1) - 46usize];
    ["Offset of field: tagWAVEINCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, ManufacturerGuid) - 48usize];
    ["Offset of field: tagWAVEINCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, ProductGuid) - 64usize];
    ["Offset of field: tagWAVEINCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2A, NameGuid) - 80usize];
};
pub type WAVEINCAPS2A = tagWAVEINCAPS2A;
pub type PWAVEINCAPS2A = *mut tagWAVEINCAPS2A;
pub type NPWAVEINCAPS2A = *mut tagWAVEINCAPS2A;
pub type LPWAVEINCAPS2A = *mut tagWAVEINCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagWAVEINCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwFormats: DWORD,
    pub wChannels: WORD,
    pub wReserved1: WORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagWAVEINCAPS2W"][::std::mem::size_of::<tagWAVEINCAPS2W>() - 128usize];
    ["Alignment of tagWAVEINCAPS2W"][::std::mem::align_of::<tagWAVEINCAPS2W>() - 1usize];
    ["Offset of field: tagWAVEINCAPS2W::wMid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, wMid) - 0usize];
    ["Offset of field: tagWAVEINCAPS2W::wPid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, wPid) - 2usize];
    ["Offset of field: tagWAVEINCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagWAVEINCAPS2W::szPname"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, szPname) - 8usize];
    ["Offset of field: tagWAVEINCAPS2W::dwFormats"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, dwFormats) - 72usize];
    ["Offset of field: tagWAVEINCAPS2W::wChannels"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, wChannels) - 76usize];
    ["Offset of field: tagWAVEINCAPS2W::wReserved1"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, wReserved1) - 78usize];
    ["Offset of field: tagWAVEINCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, ManufacturerGuid) - 80usize];
    ["Offset of field: tagWAVEINCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, ProductGuid) - 96usize];
    ["Offset of field: tagWAVEINCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagWAVEINCAPS2W, NameGuid) - 112usize];
};
pub type WAVEINCAPS2W = tagWAVEINCAPS2W;
pub type PWAVEINCAPS2W = *mut tagWAVEINCAPS2W;
pub type NPWAVEINCAPS2W = *mut tagWAVEINCAPS2W;
pub type LPWAVEINCAPS2W = *mut tagWAVEINCAPS2W;
pub type WAVEINCAPS2 = WAVEINCAPS2A;
pub type PWAVEINCAPS2 = PWAVEINCAPS2A;
pub type NPWAVEINCAPS2 = NPWAVEINCAPS2A;
pub type LPWAVEINCAPS2 = LPWAVEINCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct waveformat_tag {
    pub wFormatTag: WORD,
    pub nChannels: WORD,
    pub nSamplesPerSec: DWORD,
    pub nAvgBytesPerSec: DWORD,
    pub nBlockAlign: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of waveformat_tag"][::std::mem::size_of::<waveformat_tag>() - 14usize];
    ["Alignment of waveformat_tag"][::std::mem::align_of::<waveformat_tag>() - 1usize];
    ["Offset of field: waveformat_tag::wFormatTag"]
        [::std::mem::offset_of!(waveformat_tag, wFormatTag) - 0usize];
    ["Offset of field: waveformat_tag::nChannels"]
        [::std::mem::offset_of!(waveformat_tag, nChannels) - 2usize];
    ["Offset of field: waveformat_tag::nSamplesPerSec"]
        [::std::mem::offset_of!(waveformat_tag, nSamplesPerSec) - 4usize];
    ["Offset of field: waveformat_tag::nAvgBytesPerSec"]
        [::std::mem::offset_of!(waveformat_tag, nAvgBytesPerSec) - 8usize];
    ["Offset of field: waveformat_tag::nBlockAlign"]
        [::std::mem::offset_of!(waveformat_tag, nBlockAlign) - 12usize];
};
pub type WAVEFORMAT = waveformat_tag;
pub type PWAVEFORMAT = *mut waveformat_tag;
pub type NPWAVEFORMAT = *mut waveformat_tag;
pub type LPWAVEFORMAT = *mut waveformat_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct pcmwaveformat_tag {
    pub wf: WAVEFORMAT,
    pub wBitsPerSample: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of pcmwaveformat_tag"][::std::mem::size_of::<pcmwaveformat_tag>() - 16usize];
    ["Alignment of pcmwaveformat_tag"][::std::mem::align_of::<pcmwaveformat_tag>() - 1usize];
    ["Offset of field: pcmwaveformat_tag::wf"]
        [::std::mem::offset_of!(pcmwaveformat_tag, wf) - 0usize];
    ["Offset of field: pcmwaveformat_tag::wBitsPerSample"]
        [::std::mem::offset_of!(pcmwaveformat_tag, wBitsPerSample) - 14usize];
};
pub type PCMWAVEFORMAT = pcmwaveformat_tag;
pub type PPCMWAVEFORMAT = *mut pcmwaveformat_tag;
pub type NPPCMWAVEFORMAT = *mut pcmwaveformat_tag;
pub type LPPCMWAVEFORMAT = *mut pcmwaveformat_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tWAVEFORMATEX {
    pub wFormatTag: WORD,
    pub nChannels: WORD,
    pub nSamplesPerSec: DWORD,
    pub nAvgBytesPerSec: DWORD,
    pub nBlockAlign: WORD,
    pub wBitsPerSample: WORD,
    pub cbSize: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tWAVEFORMATEX"][::std::mem::size_of::<tWAVEFORMATEX>() - 18usize];
    ["Alignment of tWAVEFORMATEX"][::std::mem::align_of::<tWAVEFORMATEX>() - 1usize];
    ["Offset of field: tWAVEFORMATEX::wFormatTag"]
        [::std::mem::offset_of!(tWAVEFORMATEX, wFormatTag) - 0usize];
    ["Offset of field: tWAVEFORMATEX::nChannels"]
        [::std::mem::offset_of!(tWAVEFORMATEX, nChannels) - 2usize];
    ["Offset of field: tWAVEFORMATEX::nSamplesPerSec"]
        [::std::mem::offset_of!(tWAVEFORMATEX, nSamplesPerSec) - 4usize];
    ["Offset of field: tWAVEFORMATEX::nAvgBytesPerSec"]
        [::std::mem::offset_of!(tWAVEFORMATEX, nAvgBytesPerSec) - 8usize];
    ["Offset of field: tWAVEFORMATEX::nBlockAlign"]
        [::std::mem::offset_of!(tWAVEFORMATEX, nBlockAlign) - 12usize];
    ["Offset of field: tWAVEFORMATEX::wBitsPerSample"]
        [::std::mem::offset_of!(tWAVEFORMATEX, wBitsPerSample) - 14usize];
    ["Offset of field: tWAVEFORMATEX::cbSize"]
        [::std::mem::offset_of!(tWAVEFORMATEX, cbSize) - 16usize];
};
pub type WAVEFORMATEX = tWAVEFORMATEX;
pub type PWAVEFORMATEX = *mut tWAVEFORMATEX;
pub type NPWAVEFORMATEX = *mut tWAVEFORMATEX;
pub type LPWAVEFORMATEX = *mut tWAVEFORMATEX;
pub type LPCWAVEFORMATEX = *const WAVEFORMATEX;
unsafe extern "C" {
    pub fn waveOutGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn waveOutGetDevCapsA(uDeviceID: UINT_PTR, pwoc: LPWAVEOUTCAPSA, cbwoc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetDevCapsW(uDeviceID: UINT_PTR, pwoc: LPWAVEOUTCAPSW, cbwoc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetVolume(hwo: HWAVEOUT, pdwVolume: LPDWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutSetVolume(hwo: HWAVEOUT, dwVolume: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetErrorTextA(mmrError: MMRESULT, pszText: LPSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetErrorTextW(mmrError: MMRESULT, pszText: LPWSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutOpen(
        phwo: LPHWAVEOUT,
        uDeviceID: UINT,
        pwfx: LPCWAVEFORMATEX,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutClose(hwo: HWAVEOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutPrepareHeader(hwo: HWAVEOUT, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutUnprepareHeader(hwo: HWAVEOUT, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutWrite(hwo: HWAVEOUT, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutPause(hwo: HWAVEOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutRestart(hwo: HWAVEOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutReset(hwo: HWAVEOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutBreakLoop(hwo: HWAVEOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetPosition(hwo: HWAVEOUT, pmmt: LPMMTIME, cbmmt: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetPitch(hwo: HWAVEOUT, pdwPitch: LPDWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutSetPitch(hwo: HWAVEOUT, dwPitch: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetPlaybackRate(hwo: HWAVEOUT, pdwRate: LPDWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutSetPlaybackRate(hwo: HWAVEOUT, dwRate: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutGetID(hwo: HWAVEOUT, puDeviceID: LPUINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveOutMessage(hwo: HWAVEOUT, uMsg: UINT, dw1: DWORD_PTR, dw2: DWORD_PTR) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn waveInGetDevCapsA(uDeviceID: UINT_PTR, pwic: LPWAVEINCAPSA, cbwic: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetDevCapsW(uDeviceID: UINT_PTR, pwic: LPWAVEINCAPSW, cbwic: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetErrorTextA(mmrError: MMRESULT, pszText: LPSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetErrorTextW(mmrError: MMRESULT, pszText: LPWSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInOpen(
        phwi: LPHWAVEIN,
        uDeviceID: UINT,
        pwfx: LPCWAVEFORMATEX,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInClose(hwi: HWAVEIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInPrepareHeader(hwi: HWAVEIN, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInUnprepareHeader(hwi: HWAVEIN, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInAddBuffer(hwi: HWAVEIN, pwh: LPWAVEHDR, cbwh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInStart(hwi: HWAVEIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInStop(hwi: HWAVEIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInReset(hwi: HWAVEIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetPosition(hwi: HWAVEIN, pmmt: LPMMTIME, cbmmt: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInGetID(hwi: HWAVEIN, puDeviceID: LPUINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn waveInMessage(hwi: HWAVEIN, uMsg: UINT, dw1: DWORD_PTR, dw2: DWORD_PTR) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIDI__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIDI__"][::std::mem::size_of::<HMIDI__>() - 4usize];
    ["Alignment of HMIDI__"][::std::mem::align_of::<HMIDI__>() - 1usize];
    ["Offset of field: HMIDI__::unused"][::std::mem::offset_of!(HMIDI__, unused) - 0usize];
};
pub type HMIDI = *mut HMIDI__;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIDIIN__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIDIIN__"][::std::mem::size_of::<HMIDIIN__>() - 4usize];
    ["Alignment of HMIDIIN__"][::std::mem::align_of::<HMIDIIN__>() - 1usize];
    ["Offset of field: HMIDIIN__::unused"][::std::mem::offset_of!(HMIDIIN__, unused) - 0usize];
};
pub type HMIDIIN = *mut HMIDIIN__;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIDIOUT__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIDIOUT__"][::std::mem::size_of::<HMIDIOUT__>() - 4usize];
    ["Alignment of HMIDIOUT__"][::std::mem::align_of::<HMIDIOUT__>() - 1usize];
    ["Offset of field: HMIDIOUT__::unused"][::std::mem::offset_of!(HMIDIOUT__, unused) - 0usize];
};
pub type HMIDIOUT = *mut HMIDIOUT__;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIDISTRM__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIDISTRM__"][::std::mem::size_of::<HMIDISTRM__>() - 4usize];
    ["Alignment of HMIDISTRM__"][::std::mem::align_of::<HMIDISTRM__>() - 1usize];
    ["Offset of field: HMIDISTRM__::unused"][::std::mem::offset_of!(HMIDISTRM__, unused) - 0usize];
};
pub type HMIDISTRM = *mut HMIDISTRM__;
pub type LPHMIDI = *mut HMIDI;
pub type LPHMIDIIN = *mut HMIDIIN;
pub type LPHMIDIOUT = *mut HMIDIOUT;
pub type LPHMIDISTRM = *mut HMIDISTRM;
pub type LPMIDICALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: HDRVR,
        arg2: UINT,
        arg3: DWORD_PTR,
        arg4: DWORD_PTR,
        arg5: DWORD_PTR,
    ),
>;
pub type PATCHARRAY = [WORD; 128usize];
pub type LPPATCHARRAY = *mut WORD;
pub type KEYARRAY = [WORD; 128usize];
pub type LPKEYARRAY = *mut WORD;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIOUTCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub wTechnology: WORD,
    pub wVoices: WORD,
    pub wNotes: WORD,
    pub wChannelMask: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIOUTCAPSA"][::std::mem::size_of::<tagMIDIOUTCAPSA>() - 52usize];
    ["Alignment of tagMIDIOUTCAPSA"][::std::mem::align_of::<tagMIDIOUTCAPSA>() - 1usize];
    ["Offset of field: tagMIDIOUTCAPSA::wMid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wMid) - 0usize];
    ["Offset of field: tagMIDIOUTCAPSA::wPid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wPid) - 2usize];
    ["Offset of field: tagMIDIOUTCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIOUTCAPSA::szPname"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, szPname) - 8usize];
    ["Offset of field: tagMIDIOUTCAPSA::wTechnology"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wTechnology) - 40usize];
    ["Offset of field: tagMIDIOUTCAPSA::wVoices"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wVoices) - 42usize];
    ["Offset of field: tagMIDIOUTCAPSA::wNotes"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wNotes) - 44usize];
    ["Offset of field: tagMIDIOUTCAPSA::wChannelMask"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, wChannelMask) - 46usize];
    ["Offset of field: tagMIDIOUTCAPSA::dwSupport"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSA, dwSupport) - 48usize];
};
pub type MIDIOUTCAPSA = tagMIDIOUTCAPSA;
pub type PMIDIOUTCAPSA = *mut tagMIDIOUTCAPSA;
pub type NPMIDIOUTCAPSA = *mut tagMIDIOUTCAPSA;
pub type LPMIDIOUTCAPSA = *mut tagMIDIOUTCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIOUTCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub wTechnology: WORD,
    pub wVoices: WORD,
    pub wNotes: WORD,
    pub wChannelMask: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIOUTCAPSW"][::std::mem::size_of::<tagMIDIOUTCAPSW>() - 84usize];
    ["Alignment of tagMIDIOUTCAPSW"][::std::mem::align_of::<tagMIDIOUTCAPSW>() - 1usize];
    ["Offset of field: tagMIDIOUTCAPSW::wMid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wMid) - 0usize];
    ["Offset of field: tagMIDIOUTCAPSW::wPid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wPid) - 2usize];
    ["Offset of field: tagMIDIOUTCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIOUTCAPSW::szPname"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, szPname) - 8usize];
    ["Offset of field: tagMIDIOUTCAPSW::wTechnology"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wTechnology) - 72usize];
    ["Offset of field: tagMIDIOUTCAPSW::wVoices"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wVoices) - 74usize];
    ["Offset of field: tagMIDIOUTCAPSW::wNotes"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wNotes) - 76usize];
    ["Offset of field: tagMIDIOUTCAPSW::wChannelMask"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, wChannelMask) - 78usize];
    ["Offset of field: tagMIDIOUTCAPSW::dwSupport"]
        [::std::mem::offset_of!(tagMIDIOUTCAPSW, dwSupport) - 80usize];
};
pub type MIDIOUTCAPSW = tagMIDIOUTCAPSW;
pub type PMIDIOUTCAPSW = *mut tagMIDIOUTCAPSW;
pub type NPMIDIOUTCAPSW = *mut tagMIDIOUTCAPSW;
pub type LPMIDIOUTCAPSW = *mut tagMIDIOUTCAPSW;
pub type MIDIOUTCAPS = MIDIOUTCAPSA;
pub type PMIDIOUTCAPS = PMIDIOUTCAPSA;
pub type NPMIDIOUTCAPS = NPMIDIOUTCAPSA;
pub type LPMIDIOUTCAPS = LPMIDIOUTCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIOUTCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub wTechnology: WORD,
    pub wVoices: WORD,
    pub wNotes: WORD,
    pub wChannelMask: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIOUTCAPS2A"][::std::mem::size_of::<tagMIDIOUTCAPS2A>() - 100usize];
    ["Alignment of tagMIDIOUTCAPS2A"][::std::mem::align_of::<tagMIDIOUTCAPS2A>() - 1usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wMid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wMid) - 0usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wPid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wPid) - 2usize];
    ["Offset of field: tagMIDIOUTCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIOUTCAPS2A::szPname"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, szPname) - 8usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wTechnology"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wTechnology) - 40usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wVoices"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wVoices) - 42usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wNotes"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wNotes) - 44usize];
    ["Offset of field: tagMIDIOUTCAPS2A::wChannelMask"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, wChannelMask) - 46usize];
    ["Offset of field: tagMIDIOUTCAPS2A::dwSupport"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, dwSupport) - 48usize];
    ["Offset of field: tagMIDIOUTCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, ManufacturerGuid) - 52usize];
    ["Offset of field: tagMIDIOUTCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, ProductGuid) - 68usize];
    ["Offset of field: tagMIDIOUTCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2A, NameGuid) - 84usize];
};
pub type MIDIOUTCAPS2A = tagMIDIOUTCAPS2A;
pub type PMIDIOUTCAPS2A = *mut tagMIDIOUTCAPS2A;
pub type NPMIDIOUTCAPS2A = *mut tagMIDIOUTCAPS2A;
pub type LPMIDIOUTCAPS2A = *mut tagMIDIOUTCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIOUTCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub wTechnology: WORD,
    pub wVoices: WORD,
    pub wNotes: WORD,
    pub wChannelMask: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIOUTCAPS2W"][::std::mem::size_of::<tagMIDIOUTCAPS2W>() - 132usize];
    ["Alignment of tagMIDIOUTCAPS2W"][::std::mem::align_of::<tagMIDIOUTCAPS2W>() - 1usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wMid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wMid) - 0usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wPid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wPid) - 2usize];
    ["Offset of field: tagMIDIOUTCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIOUTCAPS2W::szPname"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, szPname) - 8usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wTechnology"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wTechnology) - 72usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wVoices"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wVoices) - 74usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wNotes"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wNotes) - 76usize];
    ["Offset of field: tagMIDIOUTCAPS2W::wChannelMask"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, wChannelMask) - 78usize];
    ["Offset of field: tagMIDIOUTCAPS2W::dwSupport"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, dwSupport) - 80usize];
    ["Offset of field: tagMIDIOUTCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, ManufacturerGuid) - 84usize];
    ["Offset of field: tagMIDIOUTCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, ProductGuid) - 100usize];
    ["Offset of field: tagMIDIOUTCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagMIDIOUTCAPS2W, NameGuid) - 116usize];
};
pub type MIDIOUTCAPS2W = tagMIDIOUTCAPS2W;
pub type PMIDIOUTCAPS2W = *mut tagMIDIOUTCAPS2W;
pub type NPMIDIOUTCAPS2W = *mut tagMIDIOUTCAPS2W;
pub type LPMIDIOUTCAPS2W = *mut tagMIDIOUTCAPS2W;
pub type MIDIOUTCAPS2 = MIDIOUTCAPS2A;
pub type PMIDIOUTCAPS2 = PMIDIOUTCAPS2A;
pub type NPMIDIOUTCAPS2 = NPMIDIOUTCAPS2A;
pub type LPMIDIOUTCAPS2 = LPMIDIOUTCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIINCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIINCAPSA"][::std::mem::size_of::<tagMIDIINCAPSA>() - 44usize];
    ["Alignment of tagMIDIINCAPSA"][::std::mem::align_of::<tagMIDIINCAPSA>() - 1usize];
    ["Offset of field: tagMIDIINCAPSA::wMid"]
        [::std::mem::offset_of!(tagMIDIINCAPSA, wMid) - 0usize];
    ["Offset of field: tagMIDIINCAPSA::wPid"]
        [::std::mem::offset_of!(tagMIDIINCAPSA, wPid) - 2usize];
    ["Offset of field: tagMIDIINCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIINCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIINCAPSA::szPname"]
        [::std::mem::offset_of!(tagMIDIINCAPSA, szPname) - 8usize];
    ["Offset of field: tagMIDIINCAPSA::dwSupport"]
        [::std::mem::offset_of!(tagMIDIINCAPSA, dwSupport) - 40usize];
};
pub type MIDIINCAPSA = tagMIDIINCAPSA;
pub type PMIDIINCAPSA = *mut tagMIDIINCAPSA;
pub type NPMIDIINCAPSA = *mut tagMIDIINCAPSA;
pub type LPMIDIINCAPSA = *mut tagMIDIINCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIINCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIINCAPSW"][::std::mem::size_of::<tagMIDIINCAPSW>() - 76usize];
    ["Alignment of tagMIDIINCAPSW"][::std::mem::align_of::<tagMIDIINCAPSW>() - 1usize];
    ["Offset of field: tagMIDIINCAPSW::wMid"]
        [::std::mem::offset_of!(tagMIDIINCAPSW, wMid) - 0usize];
    ["Offset of field: tagMIDIINCAPSW::wPid"]
        [::std::mem::offset_of!(tagMIDIINCAPSW, wPid) - 2usize];
    ["Offset of field: tagMIDIINCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIINCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIINCAPSW::szPname"]
        [::std::mem::offset_of!(tagMIDIINCAPSW, szPname) - 8usize];
    ["Offset of field: tagMIDIINCAPSW::dwSupport"]
        [::std::mem::offset_of!(tagMIDIINCAPSW, dwSupport) - 72usize];
};
pub type MIDIINCAPSW = tagMIDIINCAPSW;
pub type PMIDIINCAPSW = *mut tagMIDIINCAPSW;
pub type NPMIDIINCAPSW = *mut tagMIDIINCAPSW;
pub type LPMIDIINCAPSW = *mut tagMIDIINCAPSW;
pub type MIDIINCAPS = MIDIINCAPSA;
pub type PMIDIINCAPS = PMIDIINCAPSA;
pub type NPMIDIINCAPS = NPMIDIINCAPSA;
pub type LPMIDIINCAPS = LPMIDIINCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIINCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIINCAPS2A"][::std::mem::size_of::<tagMIDIINCAPS2A>() - 92usize];
    ["Alignment of tagMIDIINCAPS2A"][::std::mem::align_of::<tagMIDIINCAPS2A>() - 1usize];
    ["Offset of field: tagMIDIINCAPS2A::wMid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, wMid) - 0usize];
    ["Offset of field: tagMIDIINCAPS2A::wPid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, wPid) - 2usize];
    ["Offset of field: tagMIDIINCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIINCAPS2A::szPname"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, szPname) - 8usize];
    ["Offset of field: tagMIDIINCAPS2A::dwSupport"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, dwSupport) - 40usize];
    ["Offset of field: tagMIDIINCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, ManufacturerGuid) - 44usize];
    ["Offset of field: tagMIDIINCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, ProductGuid) - 60usize];
    ["Offset of field: tagMIDIINCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2A, NameGuid) - 76usize];
};
pub type MIDIINCAPS2A = tagMIDIINCAPS2A;
pub type PMIDIINCAPS2A = *mut tagMIDIINCAPS2A;
pub type NPMIDIINCAPS2A = *mut tagMIDIINCAPS2A;
pub type LPMIDIINCAPS2A = *mut tagMIDIINCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIDIINCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIDIINCAPS2W"][::std::mem::size_of::<tagMIDIINCAPS2W>() - 124usize];
    ["Alignment of tagMIDIINCAPS2W"][::std::mem::align_of::<tagMIDIINCAPS2W>() - 1usize];
    ["Offset of field: tagMIDIINCAPS2W::wMid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, wMid) - 0usize];
    ["Offset of field: tagMIDIINCAPS2W::wPid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, wPid) - 2usize];
    ["Offset of field: tagMIDIINCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagMIDIINCAPS2W::szPname"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, szPname) - 8usize];
    ["Offset of field: tagMIDIINCAPS2W::dwSupport"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, dwSupport) - 72usize];
    ["Offset of field: tagMIDIINCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, ManufacturerGuid) - 76usize];
    ["Offset of field: tagMIDIINCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, ProductGuid) - 92usize];
    ["Offset of field: tagMIDIINCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagMIDIINCAPS2W, NameGuid) - 108usize];
};
pub type MIDIINCAPS2W = tagMIDIINCAPS2W;
pub type PMIDIINCAPS2W = *mut tagMIDIINCAPS2W;
pub type NPMIDIINCAPS2W = *mut tagMIDIINCAPS2W;
pub type LPMIDIINCAPS2W = *mut tagMIDIINCAPS2W;
pub type MIDIINCAPS2 = MIDIINCAPS2A;
pub type PMIDIINCAPS2 = PMIDIINCAPS2A;
pub type NPMIDIINCAPS2 = NPMIDIINCAPS2A;
pub type LPMIDIINCAPS2 = LPMIDIINCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct midihdr_tag {
    pub lpData: LPSTR,
    pub dwBufferLength: DWORD,
    pub dwBytesRecorded: DWORD,
    pub dwUser: DWORD_PTR,
    pub dwFlags: DWORD,
    pub lpNext: *mut midihdr_tag,
    pub reserved: DWORD_PTR,
    pub dwOffset: DWORD,
    pub dwReserved: [DWORD_PTR; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of midihdr_tag"][::std::mem::size_of::<midihdr_tag>() - 112usize];
    ["Alignment of midihdr_tag"][::std::mem::align_of::<midihdr_tag>() - 1usize];
    ["Offset of field: midihdr_tag::lpData"][::std::mem::offset_of!(midihdr_tag, lpData) - 0usize];
    ["Offset of field: midihdr_tag::dwBufferLength"]
        [::std::mem::offset_of!(midihdr_tag, dwBufferLength) - 8usize];
    ["Offset of field: midihdr_tag::dwBytesRecorded"]
        [::std::mem::offset_of!(midihdr_tag, dwBytesRecorded) - 12usize];
    ["Offset of field: midihdr_tag::dwUser"][::std::mem::offset_of!(midihdr_tag, dwUser) - 16usize];
    ["Offset of field: midihdr_tag::dwFlags"]
        [::std::mem::offset_of!(midihdr_tag, dwFlags) - 24usize];
    ["Offset of field: midihdr_tag::lpNext"][::std::mem::offset_of!(midihdr_tag, lpNext) - 28usize];
    ["Offset of field: midihdr_tag::reserved"]
        [::std::mem::offset_of!(midihdr_tag, reserved) - 36usize];
    ["Offset of field: midihdr_tag::dwOffset"]
        [::std::mem::offset_of!(midihdr_tag, dwOffset) - 44usize];
    ["Offset of field: midihdr_tag::dwReserved"]
        [::std::mem::offset_of!(midihdr_tag, dwReserved) - 48usize];
};
pub type MIDIHDR = midihdr_tag;
pub type PMIDIHDR = *mut midihdr_tag;
pub type NPMIDIHDR = *mut midihdr_tag;
pub type LPMIDIHDR = *mut midihdr_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct midievent_tag {
    pub dwDeltaTime: DWORD,
    pub dwStreamID: DWORD,
    pub dwEvent: DWORD,
    pub dwParms: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of midievent_tag"][::std::mem::size_of::<midievent_tag>() - 16usize];
    ["Alignment of midievent_tag"][::std::mem::align_of::<midievent_tag>() - 1usize];
    ["Offset of field: midievent_tag::dwDeltaTime"]
        [::std::mem::offset_of!(midievent_tag, dwDeltaTime) - 0usize];
    ["Offset of field: midievent_tag::dwStreamID"]
        [::std::mem::offset_of!(midievent_tag, dwStreamID) - 4usize];
    ["Offset of field: midievent_tag::dwEvent"]
        [::std::mem::offset_of!(midievent_tag, dwEvent) - 8usize];
    ["Offset of field: midievent_tag::dwParms"]
        [::std::mem::offset_of!(midievent_tag, dwParms) - 12usize];
};
pub type MIDIEVENT = midievent_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct midistrmbuffver_tag {
    pub dwVersion: DWORD,
    pub dwMid: DWORD,
    pub dwOEMVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of midistrmbuffver_tag"][::std::mem::size_of::<midistrmbuffver_tag>() - 12usize];
    ["Alignment of midistrmbuffver_tag"][::std::mem::align_of::<midistrmbuffver_tag>() - 1usize];
    ["Offset of field: midistrmbuffver_tag::dwVersion"]
        [::std::mem::offset_of!(midistrmbuffver_tag, dwVersion) - 0usize];
    ["Offset of field: midistrmbuffver_tag::dwMid"]
        [::std::mem::offset_of!(midistrmbuffver_tag, dwMid) - 4usize];
    ["Offset of field: midistrmbuffver_tag::dwOEMVersion"]
        [::std::mem::offset_of!(midistrmbuffver_tag, dwOEMVersion) - 8usize];
};
pub type MIDISTRMBUFFVER = midistrmbuffver_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct midiproptimediv_tag {
    pub cbStruct: DWORD,
    pub dwTimeDiv: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of midiproptimediv_tag"][::std::mem::size_of::<midiproptimediv_tag>() - 8usize];
    ["Alignment of midiproptimediv_tag"][::std::mem::align_of::<midiproptimediv_tag>() - 1usize];
    ["Offset of field: midiproptimediv_tag::cbStruct"]
        [::std::mem::offset_of!(midiproptimediv_tag, cbStruct) - 0usize];
    ["Offset of field: midiproptimediv_tag::dwTimeDiv"]
        [::std::mem::offset_of!(midiproptimediv_tag, dwTimeDiv) - 4usize];
};
pub type MIDIPROPTIMEDIV = midiproptimediv_tag;
pub type LPMIDIPROPTIMEDIV = *mut midiproptimediv_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct midiproptempo_tag {
    pub cbStruct: DWORD,
    pub dwTempo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of midiproptempo_tag"][::std::mem::size_of::<midiproptempo_tag>() - 8usize];
    ["Alignment of midiproptempo_tag"][::std::mem::align_of::<midiproptempo_tag>() - 1usize];
    ["Offset of field: midiproptempo_tag::cbStruct"]
        [::std::mem::offset_of!(midiproptempo_tag, cbStruct) - 0usize];
    ["Offset of field: midiproptempo_tag::dwTempo"]
        [::std::mem::offset_of!(midiproptempo_tag, dwTempo) - 4usize];
};
pub type MIDIPROPTEMPO = midiproptempo_tag;
pub type LPMIDIPROPTEMPO = *mut midiproptempo_tag;
unsafe extern "C" {
    pub fn midiOutGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn midiStreamOpen(
        phms: LPHMIDISTRM,
        puDeviceID: LPUINT,
        cMidi: DWORD,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamClose(hms: HMIDISTRM) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamProperty(hms: HMIDISTRM, lppropdata: LPBYTE, dwProperty: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamPosition(hms: HMIDISTRM, lpmmt: LPMMTIME, cbmmt: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamOut(hms: HMIDISTRM, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamPause(hms: HMIDISTRM) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamRestart(hms: HMIDISTRM) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiStreamStop(hms: HMIDISTRM) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiConnect(hmi: HMIDI, hmo: HMIDIOUT, pReserved: LPVOID) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiDisconnect(hmi: HMIDI, hmo: HMIDIOUT, pReserved: LPVOID) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetDevCapsA(uDeviceID: UINT_PTR, pmoc: LPMIDIOUTCAPSA, cbmoc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetDevCapsW(uDeviceID: UINT_PTR, pmoc: LPMIDIOUTCAPSW, cbmoc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetVolume(hmo: HMIDIOUT, pdwVolume: LPDWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutSetVolume(hmo: HMIDIOUT, dwVolume: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetErrorTextA(mmrError: MMRESULT, pszText: LPSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetErrorTextW(mmrError: MMRESULT, pszText: LPWSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutOpen(
        phmo: LPHMIDIOUT,
        uDeviceID: UINT,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutClose(hmo: HMIDIOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutPrepareHeader(hmo: HMIDIOUT, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutUnprepareHeader(hmo: HMIDIOUT, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutShortMsg(hmo: HMIDIOUT, dwMsg: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutLongMsg(hmo: HMIDIOUT, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutReset(hmo: HMIDIOUT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutCachePatches(hmo: HMIDIOUT, uBank: UINT, pwpa: LPWORD, fuCache: UINT)
        -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutCacheDrumPatches(
        hmo: HMIDIOUT,
        uPatch: UINT,
        pwkya: LPWORD,
        fuCache: UINT,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutGetID(hmo: HMIDIOUT, puDeviceID: LPUINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiOutMessage(hmo: HMIDIOUT, uMsg: UINT, dw1: DWORD_PTR, dw2: DWORD_PTR) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn midiInGetDevCapsA(uDeviceID: UINT_PTR, pmic: LPMIDIINCAPSA, cbmic: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInGetDevCapsW(uDeviceID: UINT_PTR, pmic: LPMIDIINCAPSW, cbmic: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInGetErrorTextA(mmrError: MMRESULT, pszText: LPSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInGetErrorTextW(mmrError: MMRESULT, pszText: LPWSTR, cchText: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInOpen(
        phmi: LPHMIDIIN,
        uDeviceID: UINT,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInClose(hmi: HMIDIIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInPrepareHeader(hmi: HMIDIIN, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInUnprepareHeader(hmi: HMIDIIN, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInAddBuffer(hmi: HMIDIIN, pmh: LPMIDIHDR, cbmh: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInStart(hmi: HMIDIIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInStop(hmi: HMIDIIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInReset(hmi: HMIDIIN) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInGetID(hmi: HMIDIIN, puDeviceID: LPUINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn midiInMessage(hmi: HMIDIIN, uMsg: UINT, dw1: DWORD_PTR, dw2: DWORD_PTR) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagAUXCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub wTechnology: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAUXCAPSA"][::std::mem::size_of::<tagAUXCAPSA>() - 48usize];
    ["Alignment of tagAUXCAPSA"][::std::mem::align_of::<tagAUXCAPSA>() - 1usize];
    ["Offset of field: tagAUXCAPSA::wMid"][::std::mem::offset_of!(tagAUXCAPSA, wMid) - 0usize];
    ["Offset of field: tagAUXCAPSA::wPid"][::std::mem::offset_of!(tagAUXCAPSA, wPid) - 2usize];
    ["Offset of field: tagAUXCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagAUXCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagAUXCAPSA::szPname"]
        [::std::mem::offset_of!(tagAUXCAPSA, szPname) - 8usize];
    ["Offset of field: tagAUXCAPSA::wTechnology"]
        [::std::mem::offset_of!(tagAUXCAPSA, wTechnology) - 40usize];
    ["Offset of field: tagAUXCAPSA::wReserved1"]
        [::std::mem::offset_of!(tagAUXCAPSA, wReserved1) - 42usize];
    ["Offset of field: tagAUXCAPSA::dwSupport"]
        [::std::mem::offset_of!(tagAUXCAPSA, dwSupport) - 44usize];
};
pub type AUXCAPSA = tagAUXCAPSA;
pub type PAUXCAPSA = *mut tagAUXCAPSA;
pub type NPAUXCAPSA = *mut tagAUXCAPSA;
pub type LPAUXCAPSA = *mut tagAUXCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagAUXCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub wTechnology: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAUXCAPSW"][::std::mem::size_of::<tagAUXCAPSW>() - 80usize];
    ["Alignment of tagAUXCAPSW"][::std::mem::align_of::<tagAUXCAPSW>() - 1usize];
    ["Offset of field: tagAUXCAPSW::wMid"][::std::mem::offset_of!(tagAUXCAPSW, wMid) - 0usize];
    ["Offset of field: tagAUXCAPSW::wPid"][::std::mem::offset_of!(tagAUXCAPSW, wPid) - 2usize];
    ["Offset of field: tagAUXCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagAUXCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagAUXCAPSW::szPname"]
        [::std::mem::offset_of!(tagAUXCAPSW, szPname) - 8usize];
    ["Offset of field: tagAUXCAPSW::wTechnology"]
        [::std::mem::offset_of!(tagAUXCAPSW, wTechnology) - 72usize];
    ["Offset of field: tagAUXCAPSW::wReserved1"]
        [::std::mem::offset_of!(tagAUXCAPSW, wReserved1) - 74usize];
    ["Offset of field: tagAUXCAPSW::dwSupport"]
        [::std::mem::offset_of!(tagAUXCAPSW, dwSupport) - 76usize];
};
pub type AUXCAPSW = tagAUXCAPSW;
pub type PAUXCAPSW = *mut tagAUXCAPSW;
pub type NPAUXCAPSW = *mut tagAUXCAPSW;
pub type LPAUXCAPSW = *mut tagAUXCAPSW;
pub type AUXCAPS = AUXCAPSA;
pub type PAUXCAPS = PAUXCAPSA;
pub type NPAUXCAPS = NPAUXCAPSA;
pub type LPAUXCAPS = LPAUXCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagAUXCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub wTechnology: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAUXCAPS2A"][::std::mem::size_of::<tagAUXCAPS2A>() - 96usize];
    ["Alignment of tagAUXCAPS2A"][::std::mem::align_of::<tagAUXCAPS2A>() - 1usize];
    ["Offset of field: tagAUXCAPS2A::wMid"][::std::mem::offset_of!(tagAUXCAPS2A, wMid) - 0usize];
    ["Offset of field: tagAUXCAPS2A::wPid"][::std::mem::offset_of!(tagAUXCAPS2A, wPid) - 2usize];
    ["Offset of field: tagAUXCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagAUXCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagAUXCAPS2A::szPname"]
        [::std::mem::offset_of!(tagAUXCAPS2A, szPname) - 8usize];
    ["Offset of field: tagAUXCAPS2A::wTechnology"]
        [::std::mem::offset_of!(tagAUXCAPS2A, wTechnology) - 40usize];
    ["Offset of field: tagAUXCAPS2A::wReserved1"]
        [::std::mem::offset_of!(tagAUXCAPS2A, wReserved1) - 42usize];
    ["Offset of field: tagAUXCAPS2A::dwSupport"]
        [::std::mem::offset_of!(tagAUXCAPS2A, dwSupport) - 44usize];
    ["Offset of field: tagAUXCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2A, ManufacturerGuid) - 48usize];
    ["Offset of field: tagAUXCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2A, ProductGuid) - 64usize];
    ["Offset of field: tagAUXCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2A, NameGuid) - 80usize];
};
pub type AUXCAPS2A = tagAUXCAPS2A;
pub type PAUXCAPS2A = *mut tagAUXCAPS2A;
pub type NPAUXCAPS2A = *mut tagAUXCAPS2A;
pub type LPAUXCAPS2A = *mut tagAUXCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagAUXCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub wTechnology: WORD,
    pub wReserved1: WORD,
    pub dwSupport: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagAUXCAPS2W"][::std::mem::size_of::<tagAUXCAPS2W>() - 128usize];
    ["Alignment of tagAUXCAPS2W"][::std::mem::align_of::<tagAUXCAPS2W>() - 1usize];
    ["Offset of field: tagAUXCAPS2W::wMid"][::std::mem::offset_of!(tagAUXCAPS2W, wMid) - 0usize];
    ["Offset of field: tagAUXCAPS2W::wPid"][::std::mem::offset_of!(tagAUXCAPS2W, wPid) - 2usize];
    ["Offset of field: tagAUXCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagAUXCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagAUXCAPS2W::szPname"]
        [::std::mem::offset_of!(tagAUXCAPS2W, szPname) - 8usize];
    ["Offset of field: tagAUXCAPS2W::wTechnology"]
        [::std::mem::offset_of!(tagAUXCAPS2W, wTechnology) - 72usize];
    ["Offset of field: tagAUXCAPS2W::wReserved1"]
        [::std::mem::offset_of!(tagAUXCAPS2W, wReserved1) - 74usize];
    ["Offset of field: tagAUXCAPS2W::dwSupport"]
        [::std::mem::offset_of!(tagAUXCAPS2W, dwSupport) - 76usize];
    ["Offset of field: tagAUXCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2W, ManufacturerGuid) - 80usize];
    ["Offset of field: tagAUXCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2W, ProductGuid) - 96usize];
    ["Offset of field: tagAUXCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagAUXCAPS2W, NameGuid) - 112usize];
};
pub type AUXCAPS2W = tagAUXCAPS2W;
pub type PAUXCAPS2W = *mut tagAUXCAPS2W;
pub type NPAUXCAPS2W = *mut tagAUXCAPS2W;
pub type LPAUXCAPS2W = *mut tagAUXCAPS2W;
pub type AUXCAPS2 = AUXCAPS2A;
pub type PAUXCAPS2 = PAUXCAPS2A;
pub type NPAUXCAPS2 = NPAUXCAPS2A;
pub type LPAUXCAPS2 = LPAUXCAPS2A;
unsafe extern "C" {
    pub fn auxGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn auxGetDevCapsA(uDeviceID: UINT_PTR, pac: LPAUXCAPSA, cbac: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn auxGetDevCapsW(uDeviceID: UINT_PTR, pac: LPAUXCAPSW, cbac: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn auxSetVolume(uDeviceID: UINT, dwVolume: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn auxGetVolume(uDeviceID: UINT, pdwVolume: LPDWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn auxOutMessage(uDeviceID: UINT, uMsg: UINT, dw1: DWORD_PTR, dw2: DWORD_PTR) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIXEROBJ__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIXEROBJ__"][::std::mem::size_of::<HMIXEROBJ__>() - 4usize];
    ["Alignment of HMIXEROBJ__"][::std::mem::align_of::<HMIXEROBJ__>() - 1usize];
    ["Offset of field: HMIXEROBJ__::unused"][::std::mem::offset_of!(HMIXEROBJ__, unused) - 0usize];
};
pub type HMIXEROBJ = *mut HMIXEROBJ__;
pub type LPHMIXEROBJ = *mut HMIXEROBJ;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct HMIXER__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HMIXER__"][::std::mem::size_of::<HMIXER__>() - 4usize];
    ["Alignment of HMIXER__"][::std::mem::align_of::<HMIXER__>() - 1usize];
    ["Offset of field: HMIXER__::unused"][::std::mem::offset_of!(HMIXER__, unused) - 0usize];
};
pub type HMIXER = *mut HMIXER__;
pub type LPHMIXER = *mut HMIXER;
unsafe extern "C" {
    pub fn mixerGetNumDevs() -> UINT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub fdwSupport: DWORD,
    pub cDestinations: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCAPSA"][::std::mem::size_of::<tagMIXERCAPSA>() - 48usize];
    ["Alignment of tagMIXERCAPSA"][::std::mem::align_of::<tagMIXERCAPSA>() - 1usize];
    ["Offset of field: tagMIXERCAPSA::wMid"][::std::mem::offset_of!(tagMIXERCAPSA, wMid) - 0usize];
    ["Offset of field: tagMIXERCAPSA::wPid"][::std::mem::offset_of!(tagMIXERCAPSA, wPid) - 2usize];
    ["Offset of field: tagMIXERCAPSA::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERCAPSA, vDriverVersion) - 4usize];
    ["Offset of field: tagMIXERCAPSA::szPname"]
        [::std::mem::offset_of!(tagMIXERCAPSA, szPname) - 8usize];
    ["Offset of field: tagMIXERCAPSA::fdwSupport"]
        [::std::mem::offset_of!(tagMIXERCAPSA, fdwSupport) - 40usize];
    ["Offset of field: tagMIXERCAPSA::cDestinations"]
        [::std::mem::offset_of!(tagMIXERCAPSA, cDestinations) - 44usize];
};
pub type MIXERCAPSA = tagMIXERCAPSA;
pub type PMIXERCAPSA = *mut tagMIXERCAPSA;
pub type LPMIXERCAPSA = *mut tagMIXERCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub fdwSupport: DWORD,
    pub cDestinations: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCAPSW"][::std::mem::size_of::<tagMIXERCAPSW>() - 80usize];
    ["Alignment of tagMIXERCAPSW"][::std::mem::align_of::<tagMIXERCAPSW>() - 1usize];
    ["Offset of field: tagMIXERCAPSW::wMid"][::std::mem::offset_of!(tagMIXERCAPSW, wMid) - 0usize];
    ["Offset of field: tagMIXERCAPSW::wPid"][::std::mem::offset_of!(tagMIXERCAPSW, wPid) - 2usize];
    ["Offset of field: tagMIXERCAPSW::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERCAPSW, vDriverVersion) - 4usize];
    ["Offset of field: tagMIXERCAPSW::szPname"]
        [::std::mem::offset_of!(tagMIXERCAPSW, szPname) - 8usize];
    ["Offset of field: tagMIXERCAPSW::fdwSupport"]
        [::std::mem::offset_of!(tagMIXERCAPSW, fdwSupport) - 72usize];
    ["Offset of field: tagMIXERCAPSW::cDestinations"]
        [::std::mem::offset_of!(tagMIXERCAPSW, cDestinations) - 76usize];
};
pub type MIXERCAPSW = tagMIXERCAPSW;
pub type PMIXERCAPSW = *mut tagMIXERCAPSW;
pub type LPMIXERCAPSW = *mut tagMIXERCAPSW;
pub type MIXERCAPS = MIXERCAPSA;
pub type PMIXERCAPS = PMIXERCAPSA;
pub type LPMIXERCAPS = LPMIXERCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
    pub fdwSupport: DWORD,
    pub cDestinations: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCAPS2A"][::std::mem::size_of::<tagMIXERCAPS2A>() - 96usize];
    ["Alignment of tagMIXERCAPS2A"][::std::mem::align_of::<tagMIXERCAPS2A>() - 1usize];
    ["Offset of field: tagMIXERCAPS2A::wMid"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, wMid) - 0usize];
    ["Offset of field: tagMIXERCAPS2A::wPid"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, wPid) - 2usize];
    ["Offset of field: tagMIXERCAPS2A::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, vDriverVersion) - 4usize];
    ["Offset of field: tagMIXERCAPS2A::szPname"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, szPname) - 8usize];
    ["Offset of field: tagMIXERCAPS2A::fdwSupport"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, fdwSupport) - 40usize];
    ["Offset of field: tagMIXERCAPS2A::cDestinations"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, cDestinations) - 44usize];
    ["Offset of field: tagMIXERCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, ManufacturerGuid) - 48usize];
    ["Offset of field: tagMIXERCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, ProductGuid) - 64usize];
    ["Offset of field: tagMIXERCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2A, NameGuid) - 80usize];
};
pub type MIXERCAPS2A = tagMIXERCAPS2A;
pub type PMIXERCAPS2A = *mut tagMIXERCAPS2A;
pub type LPMIXERCAPS2A = *mut tagMIXERCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
    pub fdwSupport: DWORD,
    pub cDestinations: DWORD,
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCAPS2W"][::std::mem::size_of::<tagMIXERCAPS2W>() - 128usize];
    ["Alignment of tagMIXERCAPS2W"][::std::mem::align_of::<tagMIXERCAPS2W>() - 1usize];
    ["Offset of field: tagMIXERCAPS2W::wMid"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, wMid) - 0usize];
    ["Offset of field: tagMIXERCAPS2W::wPid"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, wPid) - 2usize];
    ["Offset of field: tagMIXERCAPS2W::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, vDriverVersion) - 4usize];
    ["Offset of field: tagMIXERCAPS2W::szPname"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, szPname) - 8usize];
    ["Offset of field: tagMIXERCAPS2W::fdwSupport"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, fdwSupport) - 72usize];
    ["Offset of field: tagMIXERCAPS2W::cDestinations"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, cDestinations) - 76usize];
    ["Offset of field: tagMIXERCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, ManufacturerGuid) - 80usize];
    ["Offset of field: tagMIXERCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, ProductGuid) - 96usize];
    ["Offset of field: tagMIXERCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagMIXERCAPS2W, NameGuid) - 112usize];
};
pub type MIXERCAPS2W = tagMIXERCAPS2W;
pub type PMIXERCAPS2W = *mut tagMIXERCAPS2W;
pub type LPMIXERCAPS2W = *mut tagMIXERCAPS2W;
pub type MIXERCAPS2 = MIXERCAPS2A;
pub type PMIXERCAPS2 = PMIXERCAPS2A;
pub type LPMIXERCAPS2 = LPMIXERCAPS2A;
unsafe extern "C" {
    pub fn mixerGetDevCapsA(uMxId: UINT_PTR, pmxcaps: LPMIXERCAPSA, cbmxcaps: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerGetDevCapsW(uMxId: UINT_PTR, pmxcaps: LPMIXERCAPSW, cbmxcaps: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerOpen(
        phmx: LPHMIXER,
        uMxId: UINT,
        dwCallback: DWORD_PTR,
        dwInstance: DWORD_PTR,
        fdwOpen: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerClose(hmx: HMIXER) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerMessage(hmx: HMIXER, uMsg: UINT, dwParam1: DWORD_PTR, dwParam2: DWORD_PTR)
        -> DWORD;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERLINEA {
    pub cbStruct: DWORD,
    pub dwDestination: DWORD,
    pub dwSource: DWORD,
    pub dwLineID: DWORD,
    pub fdwLine: DWORD,
    pub dwUser: DWORD_PTR,
    pub dwComponentType: DWORD,
    pub cChannels: DWORD,
    pub cConnections: DWORD,
    pub cControls: DWORD,
    pub szShortName: [CHAR; 16usize],
    pub szName: [CHAR; 64usize],
    pub Target: tagMIXERLINEA__bindgen_ty_1,
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERLINEA__bindgen_ty_1 {
    pub dwType: DWORD,
    pub dwDeviceID: DWORD,
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [CHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINEA__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERLINEA__bindgen_ty_1>() - 48usize];
    ["Alignment of tagMIXERLINEA__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERLINEA__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::dwType"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, dwType) - 0usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::dwDeviceID"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, dwDeviceID) - 4usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::wMid"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, wMid) - 8usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::wPid"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, wPid) - 10usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, vDriverVersion) - 12usize];
    ["Offset of field: tagMIXERLINEA__bindgen_ty_1::szPname"]
        [::std::mem::offset_of!(tagMIXERLINEA__bindgen_ty_1, szPname) - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINEA"][::std::mem::size_of::<tagMIXERLINEA>() - 172usize];
    ["Alignment of tagMIXERLINEA"][::std::mem::align_of::<tagMIXERLINEA>() - 1usize];
    ["Offset of field: tagMIXERLINEA::cbStruct"]
        [::std::mem::offset_of!(tagMIXERLINEA, cbStruct) - 0usize];
    ["Offset of field: tagMIXERLINEA::dwDestination"]
        [::std::mem::offset_of!(tagMIXERLINEA, dwDestination) - 4usize];
    ["Offset of field: tagMIXERLINEA::dwSource"]
        [::std::mem::offset_of!(tagMIXERLINEA, dwSource) - 8usize];
    ["Offset of field: tagMIXERLINEA::dwLineID"]
        [::std::mem::offset_of!(tagMIXERLINEA, dwLineID) - 12usize];
    ["Offset of field: tagMIXERLINEA::fdwLine"]
        [::std::mem::offset_of!(tagMIXERLINEA, fdwLine) - 16usize];
    ["Offset of field: tagMIXERLINEA::dwUser"]
        [::std::mem::offset_of!(tagMIXERLINEA, dwUser) - 20usize];
    ["Offset of field: tagMIXERLINEA::dwComponentType"]
        [::std::mem::offset_of!(tagMIXERLINEA, dwComponentType) - 28usize];
    ["Offset of field: tagMIXERLINEA::cChannels"]
        [::std::mem::offset_of!(tagMIXERLINEA, cChannels) - 32usize];
    ["Offset of field: tagMIXERLINEA::cConnections"]
        [::std::mem::offset_of!(tagMIXERLINEA, cConnections) - 36usize];
    ["Offset of field: tagMIXERLINEA::cControls"]
        [::std::mem::offset_of!(tagMIXERLINEA, cControls) - 40usize];
    ["Offset of field: tagMIXERLINEA::szShortName"]
        [::std::mem::offset_of!(tagMIXERLINEA, szShortName) - 44usize];
    ["Offset of field: tagMIXERLINEA::szName"]
        [::std::mem::offset_of!(tagMIXERLINEA, szName) - 60usize];
    ["Offset of field: tagMIXERLINEA::Target"]
        [::std::mem::offset_of!(tagMIXERLINEA, Target) - 124usize];
};
pub type MIXERLINEA = tagMIXERLINEA;
pub type PMIXERLINEA = *mut tagMIXERLINEA;
pub type LPMIXERLINEA = *mut tagMIXERLINEA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERLINEW {
    pub cbStruct: DWORD,
    pub dwDestination: DWORD,
    pub dwSource: DWORD,
    pub dwLineID: DWORD,
    pub fdwLine: DWORD,
    pub dwUser: DWORD_PTR,
    pub dwComponentType: DWORD,
    pub cChannels: DWORD,
    pub cConnections: DWORD,
    pub cControls: DWORD,
    pub szShortName: [WCHAR; 16usize],
    pub szName: [WCHAR; 64usize],
    pub Target: tagMIXERLINEW__bindgen_ty_1,
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERLINEW__bindgen_ty_1 {
    pub dwType: DWORD,
    pub dwDeviceID: DWORD,
    pub wMid: WORD,
    pub wPid: WORD,
    pub vDriverVersion: MMVERSION,
    pub szPname: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINEW__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERLINEW__bindgen_ty_1>() - 80usize];
    ["Alignment of tagMIXERLINEW__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERLINEW__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::dwType"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, dwType) - 0usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::dwDeviceID"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, dwDeviceID) - 4usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::wMid"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, wMid) - 8usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::wPid"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, wPid) - 10usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::vDriverVersion"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, vDriverVersion) - 12usize];
    ["Offset of field: tagMIXERLINEW__bindgen_ty_1::szPname"]
        [::std::mem::offset_of!(tagMIXERLINEW__bindgen_ty_1, szPname) - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINEW"][::std::mem::size_of::<tagMIXERLINEW>() - 284usize];
    ["Alignment of tagMIXERLINEW"][::std::mem::align_of::<tagMIXERLINEW>() - 1usize];
    ["Offset of field: tagMIXERLINEW::cbStruct"]
        [::std::mem::offset_of!(tagMIXERLINEW, cbStruct) - 0usize];
    ["Offset of field: tagMIXERLINEW::dwDestination"]
        [::std::mem::offset_of!(tagMIXERLINEW, dwDestination) - 4usize];
    ["Offset of field: tagMIXERLINEW::dwSource"]
        [::std::mem::offset_of!(tagMIXERLINEW, dwSource) - 8usize];
    ["Offset of field: tagMIXERLINEW::dwLineID"]
        [::std::mem::offset_of!(tagMIXERLINEW, dwLineID) - 12usize];
    ["Offset of field: tagMIXERLINEW::fdwLine"]
        [::std::mem::offset_of!(tagMIXERLINEW, fdwLine) - 16usize];
    ["Offset of field: tagMIXERLINEW::dwUser"]
        [::std::mem::offset_of!(tagMIXERLINEW, dwUser) - 20usize];
    ["Offset of field: tagMIXERLINEW::dwComponentType"]
        [::std::mem::offset_of!(tagMIXERLINEW, dwComponentType) - 28usize];
    ["Offset of field: tagMIXERLINEW::cChannels"]
        [::std::mem::offset_of!(tagMIXERLINEW, cChannels) - 32usize];
    ["Offset of field: tagMIXERLINEW::cConnections"]
        [::std::mem::offset_of!(tagMIXERLINEW, cConnections) - 36usize];
    ["Offset of field: tagMIXERLINEW::cControls"]
        [::std::mem::offset_of!(tagMIXERLINEW, cControls) - 40usize];
    ["Offset of field: tagMIXERLINEW::szShortName"]
        [::std::mem::offset_of!(tagMIXERLINEW, szShortName) - 44usize];
    ["Offset of field: tagMIXERLINEW::szName"]
        [::std::mem::offset_of!(tagMIXERLINEW, szName) - 76usize];
    ["Offset of field: tagMIXERLINEW::Target"]
        [::std::mem::offset_of!(tagMIXERLINEW, Target) - 204usize];
};
pub type MIXERLINEW = tagMIXERLINEW;
pub type PMIXERLINEW = *mut tagMIXERLINEW;
pub type LPMIXERLINEW = *mut tagMIXERLINEW;
pub type MIXERLINE = MIXERLINEA;
pub type PMIXERLINE = PMIXERLINEA;
pub type LPMIXERLINE = LPMIXERLINEA;
unsafe extern "C" {
    pub fn mixerGetLineInfoA(hmxobj: HMIXEROBJ, pmxl: LPMIXERLINEA, fdwInfo: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerGetLineInfoW(hmxobj: HMIXEROBJ, pmxl: LPMIXERLINEW, fdwInfo: DWORD) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerGetID(hmxobj: HMIXEROBJ, puMxId: *mut UINT, fdwId: DWORD) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct tagMIXERCONTROLA {
    pub cbStruct: DWORD,
    pub dwControlID: DWORD,
    pub dwControlType: DWORD,
    pub fdwControl: DWORD,
    pub cMultipleItems: DWORD,
    pub szShortName: [CHAR; 16usize],
    pub szName: [CHAR; 64usize],
    pub Bounds: tagMIXERCONTROLA__bindgen_ty_1,
    pub Metrics: tagMIXERCONTROLA__bindgen_ty_2,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERCONTROLA__bindgen_ty_1 {
    pub __bindgen_anon_1: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2,
    pub dwReserved: [DWORD; 6usize],
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1 {
    pub lMinimum: LONG,
    pub lMaximum: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1::lMinimum"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1, lMinimum) - 0usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1::lMaximum"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_1, lMaximum) - 4usize];
};
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2 {
    pub dwMinimum: DWORD,
    pub dwMaximum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Alignment of tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2>() - 1usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2::dwMinimum"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2, dwMinimum) - 0usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2::dwMaximum"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_1__bindgen_ty_2, dwMaximum) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLA__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERCONTROLA__bindgen_ty_1>() - 24usize];
    ["Alignment of tagMIXERCONTROLA__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERCONTROLA__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_1::dwReserved"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_1, dwReserved) - 0usize];
};
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERCONTROLA__bindgen_ty_2 {
    pub cSteps: DWORD,
    pub cbCustomData: DWORD,
    pub dwReserved: [DWORD; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLA__bindgen_ty_2"]
        [::std::mem::size_of::<tagMIXERCONTROLA__bindgen_ty_2>() - 24usize];
    ["Alignment of tagMIXERCONTROLA__bindgen_ty_2"]
        [::std::mem::align_of::<tagMIXERCONTROLA__bindgen_ty_2>() - 1usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_2::cSteps"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_2, cSteps) - 0usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_2::cbCustomData"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_2, cbCustomData) - 0usize];
    ["Offset of field: tagMIXERCONTROLA__bindgen_ty_2::dwReserved"]
        [::std::mem::offset_of!(tagMIXERCONTROLA__bindgen_ty_2, dwReserved) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLA"][::std::mem::size_of::<tagMIXERCONTROLA>() - 148usize];
    ["Alignment of tagMIXERCONTROLA"][::std::mem::align_of::<tagMIXERCONTROLA>() - 1usize];
    ["Offset of field: tagMIXERCONTROLA::cbStruct"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, cbStruct) - 0usize];
    ["Offset of field: tagMIXERCONTROLA::dwControlID"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, dwControlID) - 4usize];
    ["Offset of field: tagMIXERCONTROLA::dwControlType"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, dwControlType) - 8usize];
    ["Offset of field: tagMIXERCONTROLA::fdwControl"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, fdwControl) - 12usize];
    ["Offset of field: tagMIXERCONTROLA::cMultipleItems"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, cMultipleItems) - 16usize];
    ["Offset of field: tagMIXERCONTROLA::szShortName"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, szShortName) - 20usize];
    ["Offset of field: tagMIXERCONTROLA::szName"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, szName) - 36usize];
    ["Offset of field: tagMIXERCONTROLA::Bounds"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, Bounds) - 100usize];
    ["Offset of field: tagMIXERCONTROLA::Metrics"]
        [::std::mem::offset_of!(tagMIXERCONTROLA, Metrics) - 124usize];
};
pub type MIXERCONTROLA = tagMIXERCONTROLA;
pub type PMIXERCONTROLA = *mut tagMIXERCONTROLA;
pub type LPMIXERCONTROLA = *mut tagMIXERCONTROLA;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct tagMIXERCONTROLW {
    pub cbStruct: DWORD,
    pub dwControlID: DWORD,
    pub dwControlType: DWORD,
    pub fdwControl: DWORD,
    pub cMultipleItems: DWORD,
    pub szShortName: [WCHAR; 16usize],
    pub szName: [WCHAR; 64usize],
    pub Bounds: tagMIXERCONTROLW__bindgen_ty_1,
    pub Metrics: tagMIXERCONTROLW__bindgen_ty_2,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERCONTROLW__bindgen_ty_1 {
    pub __bindgen_anon_1: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2,
    pub dwReserved: [DWORD; 6usize],
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1 {
    pub lMinimum: LONG,
    pub lMaximum: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1::lMinimum"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1, lMinimum) - 0usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1::lMaximum"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_1, lMaximum) - 4usize];
};
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2 {
    pub dwMinimum: DWORD,
    pub dwMaximum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Alignment of tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2>() - 1usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2::dwMinimum"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2, dwMinimum) - 0usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2::dwMaximum"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_1__bindgen_ty_2, dwMaximum) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLW__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERCONTROLW__bindgen_ty_1>() - 24usize];
    ["Alignment of tagMIXERCONTROLW__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERCONTROLW__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_1::dwReserved"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_1, dwReserved) - 0usize];
};
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERCONTROLW__bindgen_ty_2 {
    pub cSteps: DWORD,
    pub cbCustomData: DWORD,
    pub dwReserved: [DWORD; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLW__bindgen_ty_2"]
        [::std::mem::size_of::<tagMIXERCONTROLW__bindgen_ty_2>() - 24usize];
    ["Alignment of tagMIXERCONTROLW__bindgen_ty_2"]
        [::std::mem::align_of::<tagMIXERCONTROLW__bindgen_ty_2>() - 1usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_2::cSteps"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_2, cSteps) - 0usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_2::cbCustomData"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_2, cbCustomData) - 0usize];
    ["Offset of field: tagMIXERCONTROLW__bindgen_ty_2::dwReserved"]
        [::std::mem::offset_of!(tagMIXERCONTROLW__bindgen_ty_2, dwReserved) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLW"][::std::mem::size_of::<tagMIXERCONTROLW>() - 228usize];
    ["Alignment of tagMIXERCONTROLW"][::std::mem::align_of::<tagMIXERCONTROLW>() - 1usize];
    ["Offset of field: tagMIXERCONTROLW::cbStruct"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, cbStruct) - 0usize];
    ["Offset of field: tagMIXERCONTROLW::dwControlID"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, dwControlID) - 4usize];
    ["Offset of field: tagMIXERCONTROLW::dwControlType"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, dwControlType) - 8usize];
    ["Offset of field: tagMIXERCONTROLW::fdwControl"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, fdwControl) - 12usize];
    ["Offset of field: tagMIXERCONTROLW::cMultipleItems"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, cMultipleItems) - 16usize];
    ["Offset of field: tagMIXERCONTROLW::szShortName"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, szShortName) - 20usize];
    ["Offset of field: tagMIXERCONTROLW::szName"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, szName) - 52usize];
    ["Offset of field: tagMIXERCONTROLW::Bounds"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, Bounds) - 180usize];
    ["Offset of field: tagMIXERCONTROLW::Metrics"]
        [::std::mem::offset_of!(tagMIXERCONTROLW, Metrics) - 204usize];
};
pub type MIXERCONTROLW = tagMIXERCONTROLW;
pub type PMIXERCONTROLW = *mut tagMIXERCONTROLW;
pub type LPMIXERCONTROLW = *mut tagMIXERCONTROLW;
pub type MIXERCONTROL = MIXERCONTROLA;
pub type PMIXERCONTROL = PMIXERCONTROLA;
pub type LPMIXERCONTROL = LPMIXERCONTROLA;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct tagMIXERLINECONTROLSA {
    pub cbStruct: DWORD,
    pub dwLineID: DWORD,
    pub __bindgen_anon_1: tagMIXERLINECONTROLSA__bindgen_ty_1,
    pub cControls: DWORD,
    pub cbmxctrl: DWORD,
    pub pamxctrl: LPMIXERCONTROLA,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERLINECONTROLSA__bindgen_ty_1 {
    pub dwControlID: DWORD,
    pub dwControlType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINECONTROLSA__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERLINECONTROLSA__bindgen_ty_1>() - 4usize];
    ["Alignment of tagMIXERLINECONTROLSA__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERLINECONTROLSA__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERLINECONTROLSA__bindgen_ty_1::dwControlID"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA__bindgen_ty_1, dwControlID) - 0usize];
    ["Offset of field: tagMIXERLINECONTROLSA__bindgen_ty_1::dwControlType"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA__bindgen_ty_1, dwControlType) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINECONTROLSA"][::std::mem::size_of::<tagMIXERLINECONTROLSA>() - 28usize];
    ["Alignment of tagMIXERLINECONTROLSA"]
        [::std::mem::align_of::<tagMIXERLINECONTROLSA>() - 1usize];
    ["Offset of field: tagMIXERLINECONTROLSA::cbStruct"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA, cbStruct) - 0usize];
    ["Offset of field: tagMIXERLINECONTROLSA::dwLineID"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA, dwLineID) - 4usize];
    ["Offset of field: tagMIXERLINECONTROLSA::cControls"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA, cControls) - 12usize];
    ["Offset of field: tagMIXERLINECONTROLSA::cbmxctrl"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA, cbmxctrl) - 16usize];
    ["Offset of field: tagMIXERLINECONTROLSA::pamxctrl"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSA, pamxctrl) - 20usize];
};
pub type MIXERLINECONTROLSA = tagMIXERLINECONTROLSA;
pub type PMIXERLINECONTROLSA = *mut tagMIXERLINECONTROLSA;
pub type LPMIXERLINECONTROLSA = *mut tagMIXERLINECONTROLSA;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct tagMIXERLINECONTROLSW {
    pub cbStruct: DWORD,
    pub dwLineID: DWORD,
    pub __bindgen_anon_1: tagMIXERLINECONTROLSW__bindgen_ty_1,
    pub cControls: DWORD,
    pub cbmxctrl: DWORD,
    pub pamxctrl: LPMIXERCONTROLW,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tagMIXERLINECONTROLSW__bindgen_ty_1 {
    pub dwControlID: DWORD,
    pub dwControlType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINECONTROLSW__bindgen_ty_1"]
        [::std::mem::size_of::<tagMIXERLINECONTROLSW__bindgen_ty_1>() - 4usize];
    ["Alignment of tagMIXERLINECONTROLSW__bindgen_ty_1"]
        [::std::mem::align_of::<tagMIXERLINECONTROLSW__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagMIXERLINECONTROLSW__bindgen_ty_1::dwControlID"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW__bindgen_ty_1, dwControlID) - 0usize];
    ["Offset of field: tagMIXERLINECONTROLSW__bindgen_ty_1::dwControlType"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW__bindgen_ty_1, dwControlType) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERLINECONTROLSW"][::std::mem::size_of::<tagMIXERLINECONTROLSW>() - 28usize];
    ["Alignment of tagMIXERLINECONTROLSW"]
        [::std::mem::align_of::<tagMIXERLINECONTROLSW>() - 1usize];
    ["Offset of field: tagMIXERLINECONTROLSW::cbStruct"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW, cbStruct) - 0usize];
    ["Offset of field: tagMIXERLINECONTROLSW::dwLineID"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW, dwLineID) - 4usize];
    ["Offset of field: tagMIXERLINECONTROLSW::cControls"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW, cControls) - 12usize];
    ["Offset of field: tagMIXERLINECONTROLSW::cbmxctrl"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW, cbmxctrl) - 16usize];
    ["Offset of field: tagMIXERLINECONTROLSW::pamxctrl"]
        [::std::mem::offset_of!(tagMIXERLINECONTROLSW, pamxctrl) - 20usize];
};
pub type MIXERLINECONTROLSW = tagMIXERLINECONTROLSW;
pub type PMIXERLINECONTROLSW = *mut tagMIXERLINECONTROLSW;
pub type LPMIXERLINECONTROLSW = *mut tagMIXERLINECONTROLSW;
pub type MIXERLINECONTROLS = MIXERLINECONTROLSA;
pub type PMIXERLINECONTROLS = PMIXERLINECONTROLSA;
pub type LPMIXERLINECONTROLS = LPMIXERLINECONTROLSA;
unsafe extern "C" {
    pub fn mixerGetLineControlsA(
        hmxobj: HMIXEROBJ,
        pmxlc: LPMIXERLINECONTROLSA,
        fdwControls: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerGetLineControlsW(
        hmxobj: HMIXEROBJ,
        pmxlc: LPMIXERLINECONTROLSW,
        fdwControls: DWORD,
    ) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct tMIXERCONTROLDETAILS {
    pub cbStruct: DWORD,
    pub dwControlID: DWORD,
    pub cChannels: DWORD,
    pub __bindgen_anon_1: tMIXERCONTROLDETAILS__bindgen_ty_1,
    pub cbDetails: DWORD,
    pub paDetails: LPVOID,
}
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub union tMIXERCONTROLDETAILS__bindgen_ty_1 {
    pub hwndOwner: HWND,
    pub cMultipleItems: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tMIXERCONTROLDETAILS__bindgen_ty_1"]
        [::std::mem::size_of::<tMIXERCONTROLDETAILS__bindgen_ty_1>() - 8usize];
    ["Alignment of tMIXERCONTROLDETAILS__bindgen_ty_1"]
        [::std::mem::align_of::<tMIXERCONTROLDETAILS__bindgen_ty_1>() - 1usize];
    ["Offset of field: tMIXERCONTROLDETAILS__bindgen_ty_1::hwndOwner"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS__bindgen_ty_1, hwndOwner) - 0usize];
    ["Offset of field: tMIXERCONTROLDETAILS__bindgen_ty_1::cMultipleItems"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS__bindgen_ty_1, cMultipleItems) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tMIXERCONTROLDETAILS"][::std::mem::size_of::<tMIXERCONTROLDETAILS>() - 32usize];
    ["Alignment of tMIXERCONTROLDETAILS"][::std::mem::align_of::<tMIXERCONTROLDETAILS>() - 1usize];
    ["Offset of field: tMIXERCONTROLDETAILS::cbStruct"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS, cbStruct) - 0usize];
    ["Offset of field: tMIXERCONTROLDETAILS::dwControlID"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS, dwControlID) - 4usize];
    ["Offset of field: tMIXERCONTROLDETAILS::cChannels"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS, cChannels) - 8usize];
    ["Offset of field: tMIXERCONTROLDETAILS::cbDetails"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS, cbDetails) - 20usize];
    ["Offset of field: tMIXERCONTROLDETAILS::paDetails"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS, paDetails) - 24usize];
};
pub type MIXERCONTROLDETAILS = tMIXERCONTROLDETAILS;
pub type PMIXERCONTROLDETAILS = *mut tMIXERCONTROLDETAILS;
pub type LPMIXERCONTROLDETAILS = *mut tMIXERCONTROLDETAILS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLDETAILS_LISTTEXTA {
    pub dwParam1: DWORD,
    pub dwParam2: DWORD,
    pub szName: [CHAR; 64usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLDETAILS_LISTTEXTA"]
        [::std::mem::size_of::<tagMIXERCONTROLDETAILS_LISTTEXTA>() - 72usize];
    ["Alignment of tagMIXERCONTROLDETAILS_LISTTEXTA"]
        [::std::mem::align_of::<tagMIXERCONTROLDETAILS_LISTTEXTA>() - 1usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTA::dwParam1"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTA, dwParam1) - 0usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTA::dwParam2"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTA, dwParam2) - 4usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTA::szName"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTA, szName) - 8usize];
};
pub type MIXERCONTROLDETAILS_LISTTEXTA = tagMIXERCONTROLDETAILS_LISTTEXTA;
pub type PMIXERCONTROLDETAILS_LISTTEXTA = *mut tagMIXERCONTROLDETAILS_LISTTEXTA;
pub type LPMIXERCONTROLDETAILS_LISTTEXTA = *mut tagMIXERCONTROLDETAILS_LISTTEXTA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagMIXERCONTROLDETAILS_LISTTEXTW {
    pub dwParam1: DWORD,
    pub dwParam2: DWORD,
    pub szName: [WCHAR; 64usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMIXERCONTROLDETAILS_LISTTEXTW"]
        [::std::mem::size_of::<tagMIXERCONTROLDETAILS_LISTTEXTW>() - 136usize];
    ["Alignment of tagMIXERCONTROLDETAILS_LISTTEXTW"]
        [::std::mem::align_of::<tagMIXERCONTROLDETAILS_LISTTEXTW>() - 1usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTW::dwParam1"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTW, dwParam1) - 0usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTW::dwParam2"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTW, dwParam2) - 4usize];
    ["Offset of field: tagMIXERCONTROLDETAILS_LISTTEXTW::szName"]
        [::std::mem::offset_of!(tagMIXERCONTROLDETAILS_LISTTEXTW, szName) - 8usize];
};
pub type MIXERCONTROLDETAILS_LISTTEXTW = tagMIXERCONTROLDETAILS_LISTTEXTW;
pub type PMIXERCONTROLDETAILS_LISTTEXTW = *mut tagMIXERCONTROLDETAILS_LISTTEXTW;
pub type LPMIXERCONTROLDETAILS_LISTTEXTW = *mut tagMIXERCONTROLDETAILS_LISTTEXTW;
pub type MIXERCONTROLDETAILS_LISTTEXT = MIXERCONTROLDETAILS_LISTTEXTA;
pub type PMIXERCONTROLDETAILS_LISTTEXT = PMIXERCONTROLDETAILS_LISTTEXTA;
pub type LPMIXERCONTROLDETAILS_LISTTEXT = LPMIXERCONTROLDETAILS_LISTTEXTA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tMIXERCONTROLDETAILS_BOOLEAN {
    pub fValue: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tMIXERCONTROLDETAILS_BOOLEAN"]
        [::std::mem::size_of::<tMIXERCONTROLDETAILS_BOOLEAN>() - 4usize];
    ["Alignment of tMIXERCONTROLDETAILS_BOOLEAN"]
        [::std::mem::align_of::<tMIXERCONTROLDETAILS_BOOLEAN>() - 1usize];
    ["Offset of field: tMIXERCONTROLDETAILS_BOOLEAN::fValue"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS_BOOLEAN, fValue) - 0usize];
};
pub type MIXERCONTROLDETAILS_BOOLEAN = tMIXERCONTROLDETAILS_BOOLEAN;
pub type PMIXERCONTROLDETAILS_BOOLEAN = *mut tMIXERCONTROLDETAILS_BOOLEAN;
pub type LPMIXERCONTROLDETAILS_BOOLEAN = *mut tMIXERCONTROLDETAILS_BOOLEAN;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tMIXERCONTROLDETAILS_SIGNED {
    pub lValue: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tMIXERCONTROLDETAILS_SIGNED"]
        [::std::mem::size_of::<tMIXERCONTROLDETAILS_SIGNED>() - 4usize];
    ["Alignment of tMIXERCONTROLDETAILS_SIGNED"]
        [::std::mem::align_of::<tMIXERCONTROLDETAILS_SIGNED>() - 1usize];
    ["Offset of field: tMIXERCONTROLDETAILS_SIGNED::lValue"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS_SIGNED, lValue) - 0usize];
};
pub type MIXERCONTROLDETAILS_SIGNED = tMIXERCONTROLDETAILS_SIGNED;
pub type PMIXERCONTROLDETAILS_SIGNED = *mut tMIXERCONTROLDETAILS_SIGNED;
pub type LPMIXERCONTROLDETAILS_SIGNED = *mut tMIXERCONTROLDETAILS_SIGNED;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tMIXERCONTROLDETAILS_UNSIGNED {
    pub dwValue: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tMIXERCONTROLDETAILS_UNSIGNED"]
        [::std::mem::size_of::<tMIXERCONTROLDETAILS_UNSIGNED>() - 4usize];
    ["Alignment of tMIXERCONTROLDETAILS_UNSIGNED"]
        [::std::mem::align_of::<tMIXERCONTROLDETAILS_UNSIGNED>() - 1usize];
    ["Offset of field: tMIXERCONTROLDETAILS_UNSIGNED::dwValue"]
        [::std::mem::offset_of!(tMIXERCONTROLDETAILS_UNSIGNED, dwValue) - 0usize];
};
pub type MIXERCONTROLDETAILS_UNSIGNED = tMIXERCONTROLDETAILS_UNSIGNED;
pub type PMIXERCONTROLDETAILS_UNSIGNED = *mut tMIXERCONTROLDETAILS_UNSIGNED;
pub type LPMIXERCONTROLDETAILS_UNSIGNED = *mut tMIXERCONTROLDETAILS_UNSIGNED;
unsafe extern "C" {
    pub fn mixerGetControlDetailsA(
        hmxobj: HMIXEROBJ,
        pmxcd: LPMIXERCONTROLDETAILS,
        fdwDetails: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerGetControlDetailsW(
        hmxobj: HMIXEROBJ,
        pmxcd: LPMIXERCONTROLDETAILS,
        fdwDetails: DWORD,
    ) -> MMRESULT;
}
unsafe extern "C" {
    pub fn mixerSetControlDetails(
        hmxobj: HMIXEROBJ,
        pmxcd: LPMIXERCONTROLDETAILS,
        fdwDetails: DWORD,
    ) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct timecaps_tag {
    pub wPeriodMin: UINT,
    pub wPeriodMax: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of timecaps_tag"][::std::mem::size_of::<timecaps_tag>() - 8usize];
    ["Alignment of timecaps_tag"][::std::mem::align_of::<timecaps_tag>() - 1usize];
    ["Offset of field: timecaps_tag::wPeriodMin"]
        [::std::mem::offset_of!(timecaps_tag, wPeriodMin) - 0usize];
    ["Offset of field: timecaps_tag::wPeriodMax"]
        [::std::mem::offset_of!(timecaps_tag, wPeriodMax) - 4usize];
};
pub type TIMECAPS = timecaps_tag;
pub type PTIMECAPS = *mut timecaps_tag;
pub type NPTIMECAPS = *mut timecaps_tag;
pub type LPTIMECAPS = *mut timecaps_tag;
unsafe extern "C" {
    pub fn timeGetSystemTime(pmmt: LPMMTIME, cbmmt: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn timeGetTime() -> DWORD;
}
unsafe extern "C" {
    pub fn timeGetDevCaps(ptc: LPTIMECAPS, cbtc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn timeBeginPeriod(uPeriod: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn timeEndPeriod(uPeriod: UINT) -> MMRESULT;
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagJOYCAPSA {
    pub wMid: WORD,
    pub wPid: WORD,
    pub szPname: [CHAR; 32usize],
    pub wXmin: UINT,
    pub wXmax: UINT,
    pub wYmin: UINT,
    pub wYmax: UINT,
    pub wZmin: UINT,
    pub wZmax: UINT,
    pub wNumButtons: UINT,
    pub wPeriodMin: UINT,
    pub wPeriodMax: UINT,
    pub wRmin: UINT,
    pub wRmax: UINT,
    pub wUmin: UINT,
    pub wUmax: UINT,
    pub wVmin: UINT,
    pub wVmax: UINT,
    pub wCaps: UINT,
    pub wMaxAxes: UINT,
    pub wNumAxes: UINT,
    pub wMaxButtons: UINT,
    pub szRegKey: [CHAR; 32usize],
    pub szOEMVxD: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagJOYCAPSA"][::std::mem::size_of::<tagJOYCAPSA>() - 404usize];
    ["Alignment of tagJOYCAPSA"][::std::mem::align_of::<tagJOYCAPSA>() - 1usize];
    ["Offset of field: tagJOYCAPSA::wMid"][::std::mem::offset_of!(tagJOYCAPSA, wMid) - 0usize];
    ["Offset of field: tagJOYCAPSA::wPid"][::std::mem::offset_of!(tagJOYCAPSA, wPid) - 2usize];
    ["Offset of field: tagJOYCAPSA::szPname"]
        [::std::mem::offset_of!(tagJOYCAPSA, szPname) - 4usize];
    ["Offset of field: tagJOYCAPSA::wXmin"][::std::mem::offset_of!(tagJOYCAPSA, wXmin) - 36usize];
    ["Offset of field: tagJOYCAPSA::wXmax"][::std::mem::offset_of!(tagJOYCAPSA, wXmax) - 40usize];
    ["Offset of field: tagJOYCAPSA::wYmin"][::std::mem::offset_of!(tagJOYCAPSA, wYmin) - 44usize];
    ["Offset of field: tagJOYCAPSA::wYmax"][::std::mem::offset_of!(tagJOYCAPSA, wYmax) - 48usize];
    ["Offset of field: tagJOYCAPSA::wZmin"][::std::mem::offset_of!(tagJOYCAPSA, wZmin) - 52usize];
    ["Offset of field: tagJOYCAPSA::wZmax"][::std::mem::offset_of!(tagJOYCAPSA, wZmax) - 56usize];
    ["Offset of field: tagJOYCAPSA::wNumButtons"]
        [::std::mem::offset_of!(tagJOYCAPSA, wNumButtons) - 60usize];
    ["Offset of field: tagJOYCAPSA::wPeriodMin"]
        [::std::mem::offset_of!(tagJOYCAPSA, wPeriodMin) - 64usize];
    ["Offset of field: tagJOYCAPSA::wPeriodMax"]
        [::std::mem::offset_of!(tagJOYCAPSA, wPeriodMax) - 68usize];
    ["Offset of field: tagJOYCAPSA::wRmin"][::std::mem::offset_of!(tagJOYCAPSA, wRmin) - 72usize];
    ["Offset of field: tagJOYCAPSA::wRmax"][::std::mem::offset_of!(tagJOYCAPSA, wRmax) - 76usize];
    ["Offset of field: tagJOYCAPSA::wUmin"][::std::mem::offset_of!(tagJOYCAPSA, wUmin) - 80usize];
    ["Offset of field: tagJOYCAPSA::wUmax"][::std::mem::offset_of!(tagJOYCAPSA, wUmax) - 84usize];
    ["Offset of field: tagJOYCAPSA::wVmin"][::std::mem::offset_of!(tagJOYCAPSA, wVmin) - 88usize];
    ["Offset of field: tagJOYCAPSA::wVmax"][::std::mem::offset_of!(tagJOYCAPSA, wVmax) - 92usize];
    ["Offset of field: tagJOYCAPSA::wCaps"][::std::mem::offset_of!(tagJOYCAPSA, wCaps) - 96usize];
    ["Offset of field: tagJOYCAPSA::wMaxAxes"]
        [::std::mem::offset_of!(tagJOYCAPSA, wMaxAxes) - 100usize];
    ["Offset of field: tagJOYCAPSA::wNumAxes"]
        [::std::mem::offset_of!(tagJOYCAPSA, wNumAxes) - 104usize];
    ["Offset of field: tagJOYCAPSA::wMaxButtons"]
        [::std::mem::offset_of!(tagJOYCAPSA, wMaxButtons) - 108usize];
    ["Offset of field: tagJOYCAPSA::szRegKey"]
        [::std::mem::offset_of!(tagJOYCAPSA, szRegKey) - 112usize];
    ["Offset of field: tagJOYCAPSA::szOEMVxD"]
        [::std::mem::offset_of!(tagJOYCAPSA, szOEMVxD) - 144usize];
};
pub type JOYCAPSA = tagJOYCAPSA;
pub type PJOYCAPSA = *mut tagJOYCAPSA;
pub type NPJOYCAPSA = *mut tagJOYCAPSA;
pub type LPJOYCAPSA = *mut tagJOYCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagJOYCAPSW {
    pub wMid: WORD,
    pub wPid: WORD,
    pub szPname: [WCHAR; 32usize],
    pub wXmin: UINT,
    pub wXmax: UINT,
    pub wYmin: UINT,
    pub wYmax: UINT,
    pub wZmin: UINT,
    pub wZmax: UINT,
    pub wNumButtons: UINT,
    pub wPeriodMin: UINT,
    pub wPeriodMax: UINT,
    pub wRmin: UINT,
    pub wRmax: UINT,
    pub wUmin: UINT,
    pub wUmax: UINT,
    pub wVmin: UINT,
    pub wVmax: UINT,
    pub wCaps: UINT,
    pub wMaxAxes: UINT,
    pub wNumAxes: UINT,
    pub wMaxButtons: UINT,
    pub szRegKey: [WCHAR; 32usize],
    pub szOEMVxD: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagJOYCAPSW"][::std::mem::size_of::<tagJOYCAPSW>() - 728usize];
    ["Alignment of tagJOYCAPSW"][::std::mem::align_of::<tagJOYCAPSW>() - 1usize];
    ["Offset of field: tagJOYCAPSW::wMid"][::std::mem::offset_of!(tagJOYCAPSW, wMid) - 0usize];
    ["Offset of field: tagJOYCAPSW::wPid"][::std::mem::offset_of!(tagJOYCAPSW, wPid) - 2usize];
    ["Offset of field: tagJOYCAPSW::szPname"]
        [::std::mem::offset_of!(tagJOYCAPSW, szPname) - 4usize];
    ["Offset of field: tagJOYCAPSW::wXmin"][::std::mem::offset_of!(tagJOYCAPSW, wXmin) - 68usize];
    ["Offset of field: tagJOYCAPSW::wXmax"][::std::mem::offset_of!(tagJOYCAPSW, wXmax) - 72usize];
    ["Offset of field: tagJOYCAPSW::wYmin"][::std::mem::offset_of!(tagJOYCAPSW, wYmin) - 76usize];
    ["Offset of field: tagJOYCAPSW::wYmax"][::std::mem::offset_of!(tagJOYCAPSW, wYmax) - 80usize];
    ["Offset of field: tagJOYCAPSW::wZmin"][::std::mem::offset_of!(tagJOYCAPSW, wZmin) - 84usize];
    ["Offset of field: tagJOYCAPSW::wZmax"][::std::mem::offset_of!(tagJOYCAPSW, wZmax) - 88usize];
    ["Offset of field: tagJOYCAPSW::wNumButtons"]
        [::std::mem::offset_of!(tagJOYCAPSW, wNumButtons) - 92usize];
    ["Offset of field: tagJOYCAPSW::wPeriodMin"]
        [::std::mem::offset_of!(tagJOYCAPSW, wPeriodMin) - 96usize];
    ["Offset of field: tagJOYCAPSW::wPeriodMax"]
        [::std::mem::offset_of!(tagJOYCAPSW, wPeriodMax) - 100usize];
    ["Offset of field: tagJOYCAPSW::wRmin"][::std::mem::offset_of!(tagJOYCAPSW, wRmin) - 104usize];
    ["Offset of field: tagJOYCAPSW::wRmax"][::std::mem::offset_of!(tagJOYCAPSW, wRmax) - 108usize];
    ["Offset of field: tagJOYCAPSW::wUmin"][::std::mem::offset_of!(tagJOYCAPSW, wUmin) - 112usize];
    ["Offset of field: tagJOYCAPSW::wUmax"][::std::mem::offset_of!(tagJOYCAPSW, wUmax) - 116usize];
    ["Offset of field: tagJOYCAPSW::wVmin"][::std::mem::offset_of!(tagJOYCAPSW, wVmin) - 120usize];
    ["Offset of field: tagJOYCAPSW::wVmax"][::std::mem::offset_of!(tagJOYCAPSW, wVmax) - 124usize];
    ["Offset of field: tagJOYCAPSW::wCaps"][::std::mem::offset_of!(tagJOYCAPSW, wCaps) - 128usize];
    ["Offset of field: tagJOYCAPSW::wMaxAxes"]
        [::std::mem::offset_of!(tagJOYCAPSW, wMaxAxes) - 132usize];
    ["Offset of field: tagJOYCAPSW::wNumAxes"]
        [::std::mem::offset_of!(tagJOYCAPSW, wNumAxes) - 136usize];
    ["Offset of field: tagJOYCAPSW::wMaxButtons"]
        [::std::mem::offset_of!(tagJOYCAPSW, wMaxButtons) - 140usize];
    ["Offset of field: tagJOYCAPSW::szRegKey"]
        [::std::mem::offset_of!(tagJOYCAPSW, szRegKey) - 144usize];
    ["Offset of field: tagJOYCAPSW::szOEMVxD"]
        [::std::mem::offset_of!(tagJOYCAPSW, szOEMVxD) - 208usize];
};
pub type JOYCAPSW = tagJOYCAPSW;
pub type PJOYCAPSW = *mut tagJOYCAPSW;
pub type NPJOYCAPSW = *mut tagJOYCAPSW;
pub type LPJOYCAPSW = *mut tagJOYCAPSW;
pub type JOYCAPS = JOYCAPSA;
pub type PJOYCAPS = PJOYCAPSA;
pub type NPJOYCAPS = NPJOYCAPSA;
pub type LPJOYCAPS = LPJOYCAPSA;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagJOYCAPS2A {
    pub wMid: WORD,
    pub wPid: WORD,
    pub szPname: [CHAR; 32usize],
    pub wXmin: UINT,
    pub wXmax: UINT,
    pub wYmin: UINT,
    pub wYmax: UINT,
    pub wZmin: UINT,
    pub wZmax: UINT,
    pub wNumButtons: UINT,
    pub wPeriodMin: UINT,
    pub wPeriodMax: UINT,
    pub wRmin: UINT,
    pub wRmax: UINT,
    pub wUmin: UINT,
    pub wUmax: UINT,
    pub wVmin: UINT,
    pub wVmax: UINT,
    pub wCaps: UINT,
    pub wMaxAxes: UINT,
    pub wNumAxes: UINT,
    pub wMaxButtons: UINT,
    pub szRegKey: [CHAR; 32usize],
    pub szOEMVxD: [CHAR; 260usize],
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagJOYCAPS2A"][::std::mem::size_of::<tagJOYCAPS2A>() - 452usize];
    ["Alignment of tagJOYCAPS2A"][::std::mem::align_of::<tagJOYCAPS2A>() - 1usize];
    ["Offset of field: tagJOYCAPS2A::wMid"][::std::mem::offset_of!(tagJOYCAPS2A, wMid) - 0usize];
    ["Offset of field: tagJOYCAPS2A::wPid"][::std::mem::offset_of!(tagJOYCAPS2A, wPid) - 2usize];
    ["Offset of field: tagJOYCAPS2A::szPname"]
        [::std::mem::offset_of!(tagJOYCAPS2A, szPname) - 4usize];
    ["Offset of field: tagJOYCAPS2A::wXmin"][::std::mem::offset_of!(tagJOYCAPS2A, wXmin) - 36usize];
    ["Offset of field: tagJOYCAPS2A::wXmax"][::std::mem::offset_of!(tagJOYCAPS2A, wXmax) - 40usize];
    ["Offset of field: tagJOYCAPS2A::wYmin"][::std::mem::offset_of!(tagJOYCAPS2A, wYmin) - 44usize];
    ["Offset of field: tagJOYCAPS2A::wYmax"][::std::mem::offset_of!(tagJOYCAPS2A, wYmax) - 48usize];
    ["Offset of field: tagJOYCAPS2A::wZmin"][::std::mem::offset_of!(tagJOYCAPS2A, wZmin) - 52usize];
    ["Offset of field: tagJOYCAPS2A::wZmax"][::std::mem::offset_of!(tagJOYCAPS2A, wZmax) - 56usize];
    ["Offset of field: tagJOYCAPS2A::wNumButtons"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wNumButtons) - 60usize];
    ["Offset of field: tagJOYCAPS2A::wPeriodMin"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wPeriodMin) - 64usize];
    ["Offset of field: tagJOYCAPS2A::wPeriodMax"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wPeriodMax) - 68usize];
    ["Offset of field: tagJOYCAPS2A::wRmin"][::std::mem::offset_of!(tagJOYCAPS2A, wRmin) - 72usize];
    ["Offset of field: tagJOYCAPS2A::wRmax"][::std::mem::offset_of!(tagJOYCAPS2A, wRmax) - 76usize];
    ["Offset of field: tagJOYCAPS2A::wUmin"][::std::mem::offset_of!(tagJOYCAPS2A, wUmin) - 80usize];
    ["Offset of field: tagJOYCAPS2A::wUmax"][::std::mem::offset_of!(tagJOYCAPS2A, wUmax) - 84usize];
    ["Offset of field: tagJOYCAPS2A::wVmin"][::std::mem::offset_of!(tagJOYCAPS2A, wVmin) - 88usize];
    ["Offset of field: tagJOYCAPS2A::wVmax"][::std::mem::offset_of!(tagJOYCAPS2A, wVmax) - 92usize];
    ["Offset of field: tagJOYCAPS2A::wCaps"][::std::mem::offset_of!(tagJOYCAPS2A, wCaps) - 96usize];
    ["Offset of field: tagJOYCAPS2A::wMaxAxes"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wMaxAxes) - 100usize];
    ["Offset of field: tagJOYCAPS2A::wNumAxes"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wNumAxes) - 104usize];
    ["Offset of field: tagJOYCAPS2A::wMaxButtons"]
        [::std::mem::offset_of!(tagJOYCAPS2A, wMaxButtons) - 108usize];
    ["Offset of field: tagJOYCAPS2A::szRegKey"]
        [::std::mem::offset_of!(tagJOYCAPS2A, szRegKey) - 112usize];
    ["Offset of field: tagJOYCAPS2A::szOEMVxD"]
        [::std::mem::offset_of!(tagJOYCAPS2A, szOEMVxD) - 144usize];
    ["Offset of field: tagJOYCAPS2A::ManufacturerGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2A, ManufacturerGuid) - 404usize];
    ["Offset of field: tagJOYCAPS2A::ProductGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2A, ProductGuid) - 420usize];
    ["Offset of field: tagJOYCAPS2A::NameGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2A, NameGuid) - 436usize];
};
pub type JOYCAPS2A = tagJOYCAPS2A;
pub type PJOYCAPS2A = *mut tagJOYCAPS2A;
pub type NPJOYCAPS2A = *mut tagJOYCAPS2A;
pub type LPJOYCAPS2A = *mut tagJOYCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct tagJOYCAPS2W {
    pub wMid: WORD,
    pub wPid: WORD,
    pub szPname: [WCHAR; 32usize],
    pub wXmin: UINT,
    pub wXmax: UINT,
    pub wYmin: UINT,
    pub wYmax: UINT,
    pub wZmin: UINT,
    pub wZmax: UINT,
    pub wNumButtons: UINT,
    pub wPeriodMin: UINT,
    pub wPeriodMax: UINT,
    pub wRmin: UINT,
    pub wRmax: UINT,
    pub wUmin: UINT,
    pub wUmax: UINT,
    pub wVmin: UINT,
    pub wVmax: UINT,
    pub wCaps: UINT,
    pub wMaxAxes: UINT,
    pub wNumAxes: UINT,
    pub wMaxButtons: UINT,
    pub szRegKey: [WCHAR; 32usize],
    pub szOEMVxD: [WCHAR; 260usize],
    pub ManufacturerGuid: GUID,
    pub ProductGuid: GUID,
    pub NameGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagJOYCAPS2W"][::std::mem::size_of::<tagJOYCAPS2W>() - 776usize];
    ["Alignment of tagJOYCAPS2W"][::std::mem::align_of::<tagJOYCAPS2W>() - 1usize];
    ["Offset of field: tagJOYCAPS2W::wMid"][::std::mem::offset_of!(tagJOYCAPS2W, wMid) - 0usize];
    ["Offset of field: tagJOYCAPS2W::wPid"][::std::mem::offset_of!(tagJOYCAPS2W, wPid) - 2usize];
    ["Offset of field: tagJOYCAPS2W::szPname"]
        [::std::mem::offset_of!(tagJOYCAPS2W, szPname) - 4usize];
    ["Offset of field: tagJOYCAPS2W::wXmin"][::std::mem::offset_of!(tagJOYCAPS2W, wXmin) - 68usize];
    ["Offset of field: tagJOYCAPS2W::wXmax"][::std::mem::offset_of!(tagJOYCAPS2W, wXmax) - 72usize];
    ["Offset of field: tagJOYCAPS2W::wYmin"][::std::mem::offset_of!(tagJOYCAPS2W, wYmin) - 76usize];
    ["Offset of field: tagJOYCAPS2W::wYmax"][::std::mem::offset_of!(tagJOYCAPS2W, wYmax) - 80usize];
    ["Offset of field: tagJOYCAPS2W::wZmin"][::std::mem::offset_of!(tagJOYCAPS2W, wZmin) - 84usize];
    ["Offset of field: tagJOYCAPS2W::wZmax"][::std::mem::offset_of!(tagJOYCAPS2W, wZmax) - 88usize];
    ["Offset of field: tagJOYCAPS2W::wNumButtons"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wNumButtons) - 92usize];
    ["Offset of field: tagJOYCAPS2W::wPeriodMin"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wPeriodMin) - 96usize];
    ["Offset of field: tagJOYCAPS2W::wPeriodMax"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wPeriodMax) - 100usize];
    ["Offset of field: tagJOYCAPS2W::wRmin"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wRmin) - 104usize];
    ["Offset of field: tagJOYCAPS2W::wRmax"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wRmax) - 108usize];
    ["Offset of field: tagJOYCAPS2W::wUmin"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wUmin) - 112usize];
    ["Offset of field: tagJOYCAPS2W::wUmax"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wUmax) - 116usize];
    ["Offset of field: tagJOYCAPS2W::wVmin"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wVmin) - 120usize];
    ["Offset of field: tagJOYCAPS2W::wVmax"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wVmax) - 124usize];
    ["Offset of field: tagJOYCAPS2W::wCaps"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wCaps) - 128usize];
    ["Offset of field: tagJOYCAPS2W::wMaxAxes"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wMaxAxes) - 132usize];
    ["Offset of field: tagJOYCAPS2W::wNumAxes"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wNumAxes) - 136usize];
    ["Offset of field: tagJOYCAPS2W::wMaxButtons"]
        [::std::mem::offset_of!(tagJOYCAPS2W, wMaxButtons) - 140usize];
    ["Offset of field: tagJOYCAPS2W::szRegKey"]
        [::std::mem::offset_of!(tagJOYCAPS2W, szRegKey) - 144usize];
    ["Offset of field: tagJOYCAPS2W::szOEMVxD"]
        [::std::mem::offset_of!(tagJOYCAPS2W, szOEMVxD) - 208usize];
    ["Offset of field: tagJOYCAPS2W::ManufacturerGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2W, ManufacturerGuid) - 728usize];
    ["Offset of field: tagJOYCAPS2W::ProductGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2W, ProductGuid) - 744usize];
    ["Offset of field: tagJOYCAPS2W::NameGuid"]
        [::std::mem::offset_of!(tagJOYCAPS2W, NameGuid) - 760usize];
};
pub type JOYCAPS2W = tagJOYCAPS2W;
pub type PJOYCAPS2W = *mut tagJOYCAPS2W;
pub type NPJOYCAPS2W = *mut tagJOYCAPS2W;
pub type LPJOYCAPS2W = *mut tagJOYCAPS2W;
pub type JOYCAPS2 = JOYCAPS2A;
pub type PJOYCAPS2 = PJOYCAPS2A;
pub type NPJOYCAPS2 = NPJOYCAPS2A;
pub type LPJOYCAPS2 = LPJOYCAPS2A;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct joyinfo_tag {
    pub wXpos: UINT,
    pub wYpos: UINT,
    pub wZpos: UINT,
    pub wButtons: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of joyinfo_tag"][::std::mem::size_of::<joyinfo_tag>() - 16usize];
    ["Alignment of joyinfo_tag"][::std::mem::align_of::<joyinfo_tag>() - 1usize];
    ["Offset of field: joyinfo_tag::wXpos"][::std::mem::offset_of!(joyinfo_tag, wXpos) - 0usize];
    ["Offset of field: joyinfo_tag::wYpos"][::std::mem::offset_of!(joyinfo_tag, wYpos) - 4usize];
    ["Offset of field: joyinfo_tag::wZpos"][::std::mem::offset_of!(joyinfo_tag, wZpos) - 8usize];
    ["Offset of field: joyinfo_tag::wButtons"]
        [::std::mem::offset_of!(joyinfo_tag, wButtons) - 12usize];
};
pub type JOYINFO = joyinfo_tag;
pub type PJOYINFO = *mut joyinfo_tag;
pub type NPJOYINFO = *mut joyinfo_tag;
pub type LPJOYINFO = *mut joyinfo_tag;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct joyinfoex_tag {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub dwXpos: DWORD,
    pub dwYpos: DWORD,
    pub dwZpos: DWORD,
    pub dwRpos: DWORD,
    pub dwUpos: DWORD,
    pub dwVpos: DWORD,
    pub dwButtons: DWORD,
    pub dwButtonNumber: DWORD,
    pub dwPOV: DWORD,
    pub dwReserved1: DWORD,
    pub dwReserved2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of joyinfoex_tag"][::std::mem::size_of::<joyinfoex_tag>() - 52usize];
    ["Alignment of joyinfoex_tag"][::std::mem::align_of::<joyinfoex_tag>() - 1usize];
    ["Offset of field: joyinfoex_tag::dwSize"]
        [::std::mem::offset_of!(joyinfoex_tag, dwSize) - 0usize];
    ["Offset of field: joyinfoex_tag::dwFlags"]
        [::std::mem::offset_of!(joyinfoex_tag, dwFlags) - 4usize];
    ["Offset of field: joyinfoex_tag::dwXpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwXpos) - 8usize];
    ["Offset of field: joyinfoex_tag::dwYpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwYpos) - 12usize];
    ["Offset of field: joyinfoex_tag::dwZpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwZpos) - 16usize];
    ["Offset of field: joyinfoex_tag::dwRpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwRpos) - 20usize];
    ["Offset of field: joyinfoex_tag::dwUpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwUpos) - 24usize];
    ["Offset of field: joyinfoex_tag::dwVpos"]
        [::std::mem::offset_of!(joyinfoex_tag, dwVpos) - 28usize];
    ["Offset of field: joyinfoex_tag::dwButtons"]
        [::std::mem::offset_of!(joyinfoex_tag, dwButtons) - 32usize];
    ["Offset of field: joyinfoex_tag::dwButtonNumber"]
        [::std::mem::offset_of!(joyinfoex_tag, dwButtonNumber) - 36usize];
    ["Offset of field: joyinfoex_tag::dwPOV"]
        [::std::mem::offset_of!(joyinfoex_tag, dwPOV) - 40usize];
    ["Offset of field: joyinfoex_tag::dwReserved1"]
        [::std::mem::offset_of!(joyinfoex_tag, dwReserved1) - 44usize];
    ["Offset of field: joyinfoex_tag::dwReserved2"]
        [::std::mem::offset_of!(joyinfoex_tag, dwReserved2) - 48usize];
};
pub type JOYINFOEX = joyinfoex_tag;
pub type PJOYINFOEX = *mut joyinfoex_tag;
pub type NPJOYINFOEX = *mut joyinfoex_tag;
pub type LPJOYINFOEX = *mut joyinfoex_tag;
unsafe extern "C" {
    pub fn joyGetPosEx(uJoyID: UINT, pji: LPJOYINFOEX) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyGetNumDevs() -> UINT;
}
unsafe extern "C" {
    pub fn joyGetDevCapsA(uJoyID: UINT_PTR, pjc: LPJOYCAPSA, cbjc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyGetDevCapsW(uJoyID: UINT_PTR, pjc: LPJOYCAPSW, cbjc: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyGetPos(uJoyID: UINT, pji: LPJOYINFO) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyGetThreshold(uJoyID: UINT, puThreshold: LPUINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyReleaseCapture(uJoyID: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joySetCapture(hwnd: HWND, uJoyID: UINT, uPeriod: UINT, fChanged: BOOL) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joySetThreshold(uJoyID: UINT, uThreshold: UINT) -> MMRESULT;
}
unsafe extern "C" {
    pub fn joyConfigChanged(dwFlags: DWORD) -> MMRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCB {
    pub ncb_command: UCHAR,
    pub ncb_retcode: UCHAR,
    pub ncb_lsn: UCHAR,
    pub ncb_num: UCHAR,
    pub ncb_buffer: PUCHAR,
    pub ncb_length: WORD,
    pub ncb_callname: [UCHAR; 16usize],
    pub ncb_name: [UCHAR; 16usize],
    pub ncb_rto: UCHAR,
    pub ncb_sto: UCHAR,
    pub ncb_post: ::std::option::Option<unsafe extern "C" fn(arg1: *mut _NCB)>,
    pub ncb_lana_num: UCHAR,
    pub ncb_cmd_cplt: UCHAR,
    pub ncb_reserve: [UCHAR; 18usize],
    pub ncb_event: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCB"][::std::mem::size_of::<_NCB>() - 96usize];
    ["Alignment of _NCB"][::std::mem::align_of::<_NCB>() - 8usize];
    ["Offset of field: _NCB::ncb_command"][::std::mem::offset_of!(_NCB, ncb_command) - 0usize];
    ["Offset of field: _NCB::ncb_retcode"][::std::mem::offset_of!(_NCB, ncb_retcode) - 1usize];
    ["Offset of field: _NCB::ncb_lsn"][::std::mem::offset_of!(_NCB, ncb_lsn) - 2usize];
    ["Offset of field: _NCB::ncb_num"][::std::mem::offset_of!(_NCB, ncb_num) - 3usize];
    ["Offset of field: _NCB::ncb_buffer"][::std::mem::offset_of!(_NCB, ncb_buffer) - 8usize];
    ["Offset of field: _NCB::ncb_length"][::std::mem::offset_of!(_NCB, ncb_length) - 16usize];
    ["Offset of field: _NCB::ncb_callname"][::std::mem::offset_of!(_NCB, ncb_callname) - 18usize];
    ["Offset of field: _NCB::ncb_name"][::std::mem::offset_of!(_NCB, ncb_name) - 34usize];
    ["Offset of field: _NCB::ncb_rto"][::std::mem::offset_of!(_NCB, ncb_rto) - 50usize];
    ["Offset of field: _NCB::ncb_sto"][::std::mem::offset_of!(_NCB, ncb_sto) - 51usize];
    ["Offset of field: _NCB::ncb_post"][::std::mem::offset_of!(_NCB, ncb_post) - 56usize];
    ["Offset of field: _NCB::ncb_lana_num"][::std::mem::offset_of!(_NCB, ncb_lana_num) - 64usize];
    ["Offset of field: _NCB::ncb_cmd_cplt"][::std::mem::offset_of!(_NCB, ncb_cmd_cplt) - 65usize];
    ["Offset of field: _NCB::ncb_reserve"][::std::mem::offset_of!(_NCB, ncb_reserve) - 66usize];
    ["Offset of field: _NCB::ncb_event"][::std::mem::offset_of!(_NCB, ncb_event) - 88usize];
};
pub type NCB = _NCB;
pub type PNCB = *mut _NCB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ADAPTER_STATUS {
    pub adapter_address: [UCHAR; 6usize],
    pub rev_major: UCHAR,
    pub reserved0: UCHAR,
    pub adapter_type: UCHAR,
    pub rev_minor: UCHAR,
    pub duration: WORD,
    pub frmr_recv: WORD,
    pub frmr_xmit: WORD,
    pub iframe_recv_err: WORD,
    pub xmit_aborts: WORD,
    pub xmit_success: DWORD,
    pub recv_success: DWORD,
    pub iframe_xmit_err: WORD,
    pub recv_buff_unavail: WORD,
    pub t1_timeouts: WORD,
    pub ti_timeouts: WORD,
    pub reserved1: DWORD,
    pub free_ncbs: WORD,
    pub max_cfg_ncbs: WORD,
    pub max_ncbs: WORD,
    pub xmit_buf_unavail: WORD,
    pub max_dgram_size: WORD,
    pub pending_sess: WORD,
    pub max_cfg_sess: WORD,
    pub max_sess: WORD,
    pub max_sess_pkt_size: WORD,
    pub name_count: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ADAPTER_STATUS"][::std::mem::size_of::<_ADAPTER_STATUS>() - 60usize];
    ["Alignment of _ADAPTER_STATUS"][::std::mem::align_of::<_ADAPTER_STATUS>() - 4usize];
    ["Offset of field: _ADAPTER_STATUS::adapter_address"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, adapter_address) - 0usize];
    ["Offset of field: _ADAPTER_STATUS::rev_major"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, rev_major) - 6usize];
    ["Offset of field: _ADAPTER_STATUS::reserved0"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, reserved0) - 7usize];
    ["Offset of field: _ADAPTER_STATUS::adapter_type"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, adapter_type) - 8usize];
    ["Offset of field: _ADAPTER_STATUS::rev_minor"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, rev_minor) - 9usize];
    ["Offset of field: _ADAPTER_STATUS::duration"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, duration) - 10usize];
    ["Offset of field: _ADAPTER_STATUS::frmr_recv"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, frmr_recv) - 12usize];
    ["Offset of field: _ADAPTER_STATUS::frmr_xmit"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, frmr_xmit) - 14usize];
    ["Offset of field: _ADAPTER_STATUS::iframe_recv_err"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, iframe_recv_err) - 16usize];
    ["Offset of field: _ADAPTER_STATUS::xmit_aborts"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, xmit_aborts) - 18usize];
    ["Offset of field: _ADAPTER_STATUS::xmit_success"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, xmit_success) - 20usize];
    ["Offset of field: _ADAPTER_STATUS::recv_success"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, recv_success) - 24usize];
    ["Offset of field: _ADAPTER_STATUS::iframe_xmit_err"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, iframe_xmit_err) - 28usize];
    ["Offset of field: _ADAPTER_STATUS::recv_buff_unavail"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, recv_buff_unavail) - 30usize];
    ["Offset of field: _ADAPTER_STATUS::t1_timeouts"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, t1_timeouts) - 32usize];
    ["Offset of field: _ADAPTER_STATUS::ti_timeouts"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, ti_timeouts) - 34usize];
    ["Offset of field: _ADAPTER_STATUS::reserved1"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, reserved1) - 36usize];
    ["Offset of field: _ADAPTER_STATUS::free_ncbs"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, free_ncbs) - 40usize];
    ["Offset of field: _ADAPTER_STATUS::max_cfg_ncbs"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_cfg_ncbs) - 42usize];
    ["Offset of field: _ADAPTER_STATUS::max_ncbs"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_ncbs) - 44usize];
    ["Offset of field: _ADAPTER_STATUS::xmit_buf_unavail"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, xmit_buf_unavail) - 46usize];
    ["Offset of field: _ADAPTER_STATUS::max_dgram_size"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_dgram_size) - 48usize];
    ["Offset of field: _ADAPTER_STATUS::pending_sess"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, pending_sess) - 50usize];
    ["Offset of field: _ADAPTER_STATUS::max_cfg_sess"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_cfg_sess) - 52usize];
    ["Offset of field: _ADAPTER_STATUS::max_sess"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_sess) - 54usize];
    ["Offset of field: _ADAPTER_STATUS::max_sess_pkt_size"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, max_sess_pkt_size) - 56usize];
    ["Offset of field: _ADAPTER_STATUS::name_count"]
        [::std::mem::offset_of!(_ADAPTER_STATUS, name_count) - 58usize];
};
pub type ADAPTER_STATUS = _ADAPTER_STATUS;
pub type PADAPTER_STATUS = *mut _ADAPTER_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NAME_BUFFER {
    pub name: [UCHAR; 16usize],
    pub name_num: UCHAR,
    pub name_flags: UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NAME_BUFFER"][::std::mem::size_of::<_NAME_BUFFER>() - 18usize];
    ["Alignment of _NAME_BUFFER"][::std::mem::align_of::<_NAME_BUFFER>() - 1usize];
    ["Offset of field: _NAME_BUFFER::name"][::std::mem::offset_of!(_NAME_BUFFER, name) - 0usize];
    ["Offset of field: _NAME_BUFFER::name_num"]
        [::std::mem::offset_of!(_NAME_BUFFER, name_num) - 16usize];
    ["Offset of field: _NAME_BUFFER::name_flags"]
        [::std::mem::offset_of!(_NAME_BUFFER, name_flags) - 17usize];
};
pub type NAME_BUFFER = _NAME_BUFFER;
pub type PNAME_BUFFER = *mut _NAME_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SESSION_HEADER {
    pub sess_name: UCHAR,
    pub num_sess: UCHAR,
    pub rcv_dg_outstanding: UCHAR,
    pub rcv_any_outstanding: UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SESSION_HEADER"][::std::mem::size_of::<_SESSION_HEADER>() - 4usize];
    ["Alignment of _SESSION_HEADER"][::std::mem::align_of::<_SESSION_HEADER>() - 1usize];
    ["Offset of field: _SESSION_HEADER::sess_name"]
        [::std::mem::offset_of!(_SESSION_HEADER, sess_name) - 0usize];
    ["Offset of field: _SESSION_HEADER::num_sess"]
        [::std::mem::offset_of!(_SESSION_HEADER, num_sess) - 1usize];
    ["Offset of field: _SESSION_HEADER::rcv_dg_outstanding"]
        [::std::mem::offset_of!(_SESSION_HEADER, rcv_dg_outstanding) - 2usize];
    ["Offset of field: _SESSION_HEADER::rcv_any_outstanding"]
        [::std::mem::offset_of!(_SESSION_HEADER, rcv_any_outstanding) - 3usize];
};
pub type SESSION_HEADER = _SESSION_HEADER;
pub type PSESSION_HEADER = *mut _SESSION_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SESSION_BUFFER {
    pub lsn: UCHAR,
    pub state: UCHAR,
    pub local_name: [UCHAR; 16usize],
    pub remote_name: [UCHAR; 16usize],
    pub rcvs_outstanding: UCHAR,
    pub sends_outstanding: UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SESSION_BUFFER"][::std::mem::size_of::<_SESSION_BUFFER>() - 36usize];
    ["Alignment of _SESSION_BUFFER"][::std::mem::align_of::<_SESSION_BUFFER>() - 1usize];
    ["Offset of field: _SESSION_BUFFER::lsn"]
        [::std::mem::offset_of!(_SESSION_BUFFER, lsn) - 0usize];
    ["Offset of field: _SESSION_BUFFER::state"]
        [::std::mem::offset_of!(_SESSION_BUFFER, state) - 1usize];
    ["Offset of field: _SESSION_BUFFER::local_name"]
        [::std::mem::offset_of!(_SESSION_BUFFER, local_name) - 2usize];
    ["Offset of field: _SESSION_BUFFER::remote_name"]
        [::std::mem::offset_of!(_SESSION_BUFFER, remote_name) - 18usize];
    ["Offset of field: _SESSION_BUFFER::rcvs_outstanding"]
        [::std::mem::offset_of!(_SESSION_BUFFER, rcvs_outstanding) - 34usize];
    ["Offset of field: _SESSION_BUFFER::sends_outstanding"]
        [::std::mem::offset_of!(_SESSION_BUFFER, sends_outstanding) - 35usize];
};
pub type SESSION_BUFFER = _SESSION_BUFFER;
pub type PSESSION_BUFFER = *mut _SESSION_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LANA_ENUM {
    pub length: UCHAR,
    pub lana: [UCHAR; 255usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LANA_ENUM"][::std::mem::size_of::<_LANA_ENUM>() - 256usize];
    ["Alignment of _LANA_ENUM"][::std::mem::align_of::<_LANA_ENUM>() - 1usize];
    ["Offset of field: _LANA_ENUM::length"][::std::mem::offset_of!(_LANA_ENUM, length) - 0usize];
    ["Offset of field: _LANA_ENUM::lana"][::std::mem::offset_of!(_LANA_ENUM, lana) - 1usize];
};
pub type LANA_ENUM = _LANA_ENUM;
pub type PLANA_ENUM = *mut _LANA_ENUM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FIND_NAME_HEADER {
    pub node_count: WORD,
    pub reserved: UCHAR,
    pub unique_group: UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FIND_NAME_HEADER"][::std::mem::size_of::<_FIND_NAME_HEADER>() - 4usize];
    ["Alignment of _FIND_NAME_HEADER"][::std::mem::align_of::<_FIND_NAME_HEADER>() - 2usize];
    ["Offset of field: _FIND_NAME_HEADER::node_count"]
        [::std::mem::offset_of!(_FIND_NAME_HEADER, node_count) - 0usize];
    ["Offset of field: _FIND_NAME_HEADER::reserved"]
        [::std::mem::offset_of!(_FIND_NAME_HEADER, reserved) - 2usize];
    ["Offset of field: _FIND_NAME_HEADER::unique_group"]
        [::std::mem::offset_of!(_FIND_NAME_HEADER, unique_group) - 3usize];
};
pub type FIND_NAME_HEADER = _FIND_NAME_HEADER;
pub type PFIND_NAME_HEADER = *mut _FIND_NAME_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FIND_NAME_BUFFER {
    pub length: UCHAR,
    pub access_control: UCHAR,
    pub frame_control: UCHAR,
    pub destination_addr: [UCHAR; 6usize],
    pub source_addr: [UCHAR; 6usize],
    pub routing_info: [UCHAR; 18usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FIND_NAME_BUFFER"][::std::mem::size_of::<_FIND_NAME_BUFFER>() - 33usize];
    ["Alignment of _FIND_NAME_BUFFER"][::std::mem::align_of::<_FIND_NAME_BUFFER>() - 1usize];
    ["Offset of field: _FIND_NAME_BUFFER::length"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, length) - 0usize];
    ["Offset of field: _FIND_NAME_BUFFER::access_control"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, access_control) - 1usize];
    ["Offset of field: _FIND_NAME_BUFFER::frame_control"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, frame_control) - 2usize];
    ["Offset of field: _FIND_NAME_BUFFER::destination_addr"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, destination_addr) - 3usize];
    ["Offset of field: _FIND_NAME_BUFFER::source_addr"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, source_addr) - 9usize];
    ["Offset of field: _FIND_NAME_BUFFER::routing_info"]
        [::std::mem::offset_of!(_FIND_NAME_BUFFER, routing_info) - 15usize];
};
pub type FIND_NAME_BUFFER = _FIND_NAME_BUFFER;
pub type PFIND_NAME_BUFFER = *mut _FIND_NAME_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTION_HEADER {
    pub transport_id: ULONG,
    pub action_code: USHORT,
    pub reserved: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ACTION_HEADER"][::std::mem::size_of::<_ACTION_HEADER>() - 8usize];
    ["Alignment of _ACTION_HEADER"][::std::mem::align_of::<_ACTION_HEADER>() - 4usize];
    ["Offset of field: _ACTION_HEADER::transport_id"]
        [::std::mem::offset_of!(_ACTION_HEADER, transport_id) - 0usize];
    ["Offset of field: _ACTION_HEADER::action_code"]
        [::std::mem::offset_of!(_ACTION_HEADER, action_code) - 4usize];
    ["Offset of field: _ACTION_HEADER::reserved"]
        [::std::mem::offset_of!(_ACTION_HEADER, reserved) - 6usize];
};
pub type ACTION_HEADER = _ACTION_HEADER;
pub type PACTION_HEADER = *mut _ACTION_HEADER;
unsafe extern "C" {
    pub fn Netbios(pncb: PNCB) -> UCHAR;
}
pub type I_RPC_HANDLE = *mut ::std::os::raw::c_void;
pub type RPC_STATUS = ::std::os::raw::c_long;
pub type RPC_CSTR = *mut ::std::os::raw::c_uchar;
pub type RPC_WSTR = *mut ::std::os::raw::c_ushort;
pub type RPC_CWSTR = *const ::std::os::raw::c_ushort;
pub type RPC_BINDING_HANDLE = I_RPC_HANDLE;
pub type handle_t = RPC_BINDING_HANDLE;
pub type UUID = GUID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_BINDING_VECTOR {
    pub Count: ::std::os::raw::c_ulong,
    pub BindingH: [RPC_BINDING_HANDLE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_VECTOR"][::std::mem::size_of::<_RPC_BINDING_VECTOR>() - 16usize];
    ["Alignment of _RPC_BINDING_VECTOR"][::std::mem::align_of::<_RPC_BINDING_VECTOR>() - 8usize];
    ["Offset of field: _RPC_BINDING_VECTOR::Count"]
        [::std::mem::offset_of!(_RPC_BINDING_VECTOR, Count) - 0usize];
    ["Offset of field: _RPC_BINDING_VECTOR::BindingH"]
        [::std::mem::offset_of!(_RPC_BINDING_VECTOR, BindingH) - 8usize];
};
pub type RPC_BINDING_VECTOR = _RPC_BINDING_VECTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _UUID_VECTOR {
    pub Count: ::std::os::raw::c_ulong,
    pub Uuid: [*mut UUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _UUID_VECTOR"][::std::mem::size_of::<_UUID_VECTOR>() - 16usize];
    ["Alignment of _UUID_VECTOR"][::std::mem::align_of::<_UUID_VECTOR>() - 8usize];
    ["Offset of field: _UUID_VECTOR::Count"][::std::mem::offset_of!(_UUID_VECTOR, Count) - 0usize];
    ["Offset of field: _UUID_VECTOR::Uuid"][::std::mem::offset_of!(_UUID_VECTOR, Uuid) - 8usize];
};
pub type UUID_VECTOR = _UUID_VECTOR;
pub type RPC_IF_HANDLE = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_IF_ID {
    pub Uuid: UUID,
    pub VersMajor: ::std::os::raw::c_ushort,
    pub VersMinor: ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_IF_ID"][::std::mem::size_of::<_RPC_IF_ID>() - 20usize];
    ["Alignment of _RPC_IF_ID"][::std::mem::align_of::<_RPC_IF_ID>() - 4usize];
    ["Offset of field: _RPC_IF_ID::Uuid"][::std::mem::offset_of!(_RPC_IF_ID, Uuid) - 0usize];
    ["Offset of field: _RPC_IF_ID::VersMajor"]
        [::std::mem::offset_of!(_RPC_IF_ID, VersMajor) - 16usize];
    ["Offset of field: _RPC_IF_ID::VersMinor"]
        [::std::mem::offset_of!(_RPC_IF_ID, VersMinor) - 18usize];
};
pub type RPC_IF_ID = _RPC_IF_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_PROTSEQ_VECTORA {
    pub Count: ::std::os::raw::c_uint,
    pub Protseq: [*mut ::std::os::raw::c_uchar; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_PROTSEQ_VECTORA"][::std::mem::size_of::<_RPC_PROTSEQ_VECTORA>() - 16usize];
    ["Alignment of _RPC_PROTSEQ_VECTORA"][::std::mem::align_of::<_RPC_PROTSEQ_VECTORA>() - 8usize];
    ["Offset of field: _RPC_PROTSEQ_VECTORA::Count"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_VECTORA, Count) - 0usize];
    ["Offset of field: _RPC_PROTSEQ_VECTORA::Protseq"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_VECTORA, Protseq) - 8usize];
};
pub type RPC_PROTSEQ_VECTORA = _RPC_PROTSEQ_VECTORA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_PROTSEQ_VECTORW {
    pub Count: ::std::os::raw::c_uint,
    pub Protseq: [*mut ::std::os::raw::c_ushort; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_PROTSEQ_VECTORW"][::std::mem::size_of::<_RPC_PROTSEQ_VECTORW>() - 16usize];
    ["Alignment of _RPC_PROTSEQ_VECTORW"][::std::mem::align_of::<_RPC_PROTSEQ_VECTORW>() - 8usize];
    ["Offset of field: _RPC_PROTSEQ_VECTORW::Count"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_VECTORW, Count) - 0usize];
    ["Offset of field: _RPC_PROTSEQ_VECTORW::Protseq"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_VECTORW, Protseq) - 8usize];
};
pub type RPC_PROTSEQ_VECTORW = _RPC_PROTSEQ_VECTORW;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_POLICY {
    pub Length: ::std::os::raw::c_uint,
    pub EndpointFlags: ::std::os::raw::c_ulong,
    pub NICFlags: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_POLICY"][::std::mem::size_of::<_RPC_POLICY>() - 12usize];
    ["Alignment of _RPC_POLICY"][::std::mem::align_of::<_RPC_POLICY>() - 4usize];
    ["Offset of field: _RPC_POLICY::Length"][::std::mem::offset_of!(_RPC_POLICY, Length) - 0usize];
    ["Offset of field: _RPC_POLICY::EndpointFlags"]
        [::std::mem::offset_of!(_RPC_POLICY, EndpointFlags) - 4usize];
    ["Offset of field: _RPC_POLICY::NICFlags"]
        [::std::mem::offset_of!(_RPC_POLICY, NICFlags) - 8usize];
};
pub type RPC_POLICY = _RPC_POLICY;
pub type PRPC_POLICY = *mut _RPC_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_STATS_VECTOR {
    pub Count: ::std::os::raw::c_uint,
    pub Stats: [::std::os::raw::c_ulong; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_STATS_VECTOR"][::std::mem::size_of::<RPC_STATS_VECTOR>() - 8usize];
    ["Alignment of RPC_STATS_VECTOR"][::std::mem::align_of::<RPC_STATS_VECTOR>() - 4usize];
    ["Offset of field: RPC_STATS_VECTOR::Count"]
        [::std::mem::offset_of!(RPC_STATS_VECTOR, Count) - 0usize];
    ["Offset of field: RPC_STATS_VECTOR::Stats"]
        [::std::mem::offset_of!(RPC_STATS_VECTOR, Stats) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_IF_ID_VECTOR {
    pub Count: ::std::os::raw::c_ulong,
    pub IfId: [*mut RPC_IF_ID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_IF_ID_VECTOR"][::std::mem::size_of::<RPC_IF_ID_VECTOR>() - 16usize];
    ["Alignment of RPC_IF_ID_VECTOR"][::std::mem::align_of::<RPC_IF_ID_VECTOR>() - 8usize];
    ["Offset of field: RPC_IF_ID_VECTOR::Count"]
        [::std::mem::offset_of!(RPC_IF_ID_VECTOR, Count) - 0usize];
    ["Offset of field: RPC_IF_ID_VECTOR::IfId"]
        [::std::mem::offset_of!(RPC_IF_ID_VECTOR, IfId) - 8usize];
};
unsafe extern "C" {
    pub fn RpcBindingCopy(
        SourceBinding: RPC_BINDING_HANDLE,
        DestinationBinding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingFree(Binding: *mut RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetOption(
        hBinding: RPC_BINDING_HANDLE,
        option: ::std::os::raw::c_ulong,
        optionValue: ULONG_PTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqOption(
        hBinding: RPC_BINDING_HANDLE,
        option: ::std::os::raw::c_ulong,
        pOptionValue: *mut ULONG_PTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingFromStringBindingA(
        StringBinding: RPC_CSTR,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingFromStringBindingW(
        StringBinding: RPC_WSTR,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSsGetContextBinding(
        ContextHandle: *mut ::std::os::raw::c_void,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqMaxCalls(
        Binding: RPC_BINDING_HANDLE,
        MaxCalls: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqObject(Binding: RPC_BINDING_HANDLE, ObjectUuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingReset(Binding: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetObject(Binding: RPC_BINDING_HANDLE, ObjectUuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqDefaultProtectLevel(
        AuthnSvc: ::std::os::raw::c_ulong,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingToStringBindingA(
        Binding: RPC_BINDING_HANDLE,
        StringBinding: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingToStringBindingW(
        Binding: RPC_BINDING_HANDLE,
        StringBinding: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingVectorFree(BindingVector: *mut *mut RPC_BINDING_VECTOR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringBindingComposeA(
        ObjUuid: RPC_CSTR,
        ProtSeq: RPC_CSTR,
        NetworkAddr: RPC_CSTR,
        Endpoint: RPC_CSTR,
        Options: RPC_CSTR,
        StringBinding: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringBindingComposeW(
        ObjUuid: RPC_WSTR,
        ProtSeq: RPC_WSTR,
        NetworkAddr: RPC_WSTR,
        Endpoint: RPC_WSTR,
        Options: RPC_WSTR,
        StringBinding: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringBindingParseA(
        StringBinding: RPC_CSTR,
        ObjUuid: *mut RPC_CSTR,
        Protseq: *mut RPC_CSTR,
        NetworkAddr: *mut RPC_CSTR,
        Endpoint: *mut RPC_CSTR,
        NetworkOptions: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringBindingParseW(
        StringBinding: RPC_WSTR,
        ObjUuid: *mut RPC_WSTR,
        Protseq: *mut RPC_WSTR,
        NetworkAddr: *mut RPC_WSTR,
        Endpoint: *mut RPC_WSTR,
        NetworkOptions: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringFreeA(String: *mut RPC_CSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcStringFreeW(String: *mut RPC_WSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcIfInqId(RpcIfHandle: RPC_IF_HANDLE, RpcIfId: *mut RPC_IF_ID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNetworkIsProtseqValidA(Protseq: RPC_CSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNetworkIsProtseqValidW(Protseq: RPC_WSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqComTimeout(
        Binding: RPC_BINDING_HANDLE,
        Timeout: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtSetComTimeout(
        Binding: RPC_BINDING_HANDLE,
        Timeout: ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtSetCancelTimeout(Timeout: ::std::os::raw::c_long) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNetworkInqProtseqsA(ProtseqVector: *mut *mut RPC_PROTSEQ_VECTORA) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNetworkInqProtseqsW(ProtseqVector: *mut *mut RPC_PROTSEQ_VECTORW) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcObjectInqType(ObjUuid: *mut UUID, TypeUuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcObjectSetInqFn(
        InquiryFn: ::std::option::Option<
            unsafe extern "C" fn(arg1: *mut UUID, arg2: *mut UUID, arg3: *mut RPC_STATUS),
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcObjectSetType(ObjUuid: *mut UUID, TypeUuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcProtseqVectorFreeA(ProtseqVector: *mut *mut RPC_PROTSEQ_VECTORA) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcProtseqVectorFreeW(ProtseqVector: *mut *mut RPC_PROTSEQ_VECTORW) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqBindings(BindingVector: *mut *mut RPC_BINDING_VECTOR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqBindingsEx(
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        BindingVector: *mut *mut RPC_BINDING_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqIf(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        MgrEpv: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerListen(
        MinimumCallThreads: ::std::os::raw::c_uint,
        MaxCalls: ::std::os::raw::c_uint,
        DontWait: ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterIf(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        MgrEpv: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterIfEx(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        MgrEpv: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_uint,
        MaxCalls: ::std::os::raw::c_uint,
        IfCallback: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: RPC_IF_HANDLE,
                arg2: *mut ::std::os::raw::c_void,
            ) -> RPC_STATUS,
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterIf2(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        MgrEpv: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_uint,
        MaxCalls: ::std::os::raw::c_uint,
        MaxRpcSize: ::std::os::raw::c_uint,
        IfCallbackFn: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: RPC_IF_HANDLE,
                arg2: *mut ::std::os::raw::c_void,
            ) -> RPC_STATUS,
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterIf3(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        MgrEpv: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_uint,
        MaxCalls: ::std::os::raw::c_uint,
        MaxRpcSize: ::std::os::raw::c_uint,
        IfCallback: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: RPC_IF_HANDLE,
                arg2: *mut ::std::os::raw::c_void,
            ) -> RPC_STATUS,
        >,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUnregisterIf(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        WaitForCallsToComplete: ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUnregisterIfEx(
        IfSpec: RPC_IF_HANDLE,
        MgrTypeUuid: *mut UUID,
        RundownContextHandles: ::std::os::raw::c_int,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseAllProtseqs(
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseAllProtseqsEx(
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseAllProtseqsIf(
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseAllProtseqsIfEx(
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqExA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqExW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqEpA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_CSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqEpExA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_CSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqEpW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_WSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqEpExW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_WSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqIfA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqIfExA(
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqIfW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUseProtseqIfExW(
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        IfSpec: RPC_IF_HANDLE,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: PRPC_POLICY,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerYield();
}
unsafe extern "C" {
    pub fn RpcMgmtStatsVectorFree(StatsVector: *mut *mut RPC_STATS_VECTOR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqStats(
        Binding: RPC_BINDING_HANDLE,
        Statistics: *mut *mut RPC_STATS_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtIsServerListening(Binding: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtStopServerListening(Binding: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtWaitServerListen() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtSetServerStackSize(ThreadStackSize: ::std::os::raw::c_ulong) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSsDontSerializeContext();
}
unsafe extern "C" {
    pub fn RpcMgmtEnableIdleCleanup() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqIfIds(
        Binding: RPC_BINDING_HANDLE,
        IfIdVector: *mut *mut RPC_IF_ID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcIfIdVectorFree(IfIdVector: *mut *mut RPC_IF_ID_VECTOR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqServerPrincNameA(
        Binding: RPC_BINDING_HANDLE,
        AuthnSvc: ::std::os::raw::c_ulong,
        ServerPrincName: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtInqServerPrincNameW(
        Binding: RPC_BINDING_HANDLE,
        AuthnSvc: ::std::os::raw::c_ulong,
        ServerPrincName: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqDefaultPrincNameA(
        AuthnSvc: ::std::os::raw::c_ulong,
        PrincName: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqDefaultPrincNameW(
        AuthnSvc: ::std::os::raw::c_ulong,
        PrincName: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcEpResolveBinding(Binding: RPC_BINDING_HANDLE, IfSpec: RPC_IF_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingInqEntryNameA(
        Binding: RPC_BINDING_HANDLE,
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingInqEntryNameW(
        Binding: RPC_BINDING_HANDLE,
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
pub type RPC_AUTH_IDENTITY_HANDLE = *mut ::std::os::raw::c_void;
pub type RPC_AUTHZ_HANDLE = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_SECURITY_QOS {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS"][::std::mem::size_of::<_RPC_SECURITY_QOS>() - 16usize];
    ["Alignment of _RPC_SECURITY_QOS"][::std::mem::align_of::<_RPC_SECURITY_QOS>() - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS, ImpersonationType) - 12usize];
};
pub type RPC_SECURITY_QOS = _RPC_SECURITY_QOS;
pub type PRPC_SECURITY_QOS = *mut _RPC_SECURITY_QOS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SEC_WINNT_AUTH_IDENTITY_W {
    pub User: *mut ::std::os::raw::c_ushort,
    pub UserLength: ::std::os::raw::c_ulong,
    pub Domain: *mut ::std::os::raw::c_ushort,
    pub DomainLength: ::std::os::raw::c_ulong,
    pub Password: *mut ::std::os::raw::c_ushort,
    pub PasswordLength: ::std::os::raw::c_ulong,
    pub Flags: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SEC_WINNT_AUTH_IDENTITY_W"]
        [::std::mem::size_of::<_SEC_WINNT_AUTH_IDENTITY_W>() - 48usize];
    ["Alignment of _SEC_WINNT_AUTH_IDENTITY_W"]
        [::std::mem::align_of::<_SEC_WINNT_AUTH_IDENTITY_W>() - 8usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::User"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, User) - 0usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::UserLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, UserLength) - 8usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::Domain"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, Domain) - 16usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::DomainLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, DomainLength) - 24usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::Password"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, Password) - 32usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::PasswordLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, PasswordLength) - 40usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_W::Flags"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_W, Flags) - 44usize];
};
pub type SEC_WINNT_AUTH_IDENTITY_W = _SEC_WINNT_AUTH_IDENTITY_W;
pub type PSEC_WINNT_AUTH_IDENTITY_W = *mut _SEC_WINNT_AUTH_IDENTITY_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SEC_WINNT_AUTH_IDENTITY_A {
    pub User: *mut ::std::os::raw::c_uchar,
    pub UserLength: ::std::os::raw::c_ulong,
    pub Domain: *mut ::std::os::raw::c_uchar,
    pub DomainLength: ::std::os::raw::c_ulong,
    pub Password: *mut ::std::os::raw::c_uchar,
    pub PasswordLength: ::std::os::raw::c_ulong,
    pub Flags: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SEC_WINNT_AUTH_IDENTITY_A"]
        [::std::mem::size_of::<_SEC_WINNT_AUTH_IDENTITY_A>() - 48usize];
    ["Alignment of _SEC_WINNT_AUTH_IDENTITY_A"]
        [::std::mem::align_of::<_SEC_WINNT_AUTH_IDENTITY_A>() - 8usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::User"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, User) - 0usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::UserLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, UserLength) - 8usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::Domain"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, Domain) - 16usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::DomainLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, DomainLength) - 24usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::Password"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, Password) - 32usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::PasswordLength"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, PasswordLength) - 40usize];
    ["Offset of field: _SEC_WINNT_AUTH_IDENTITY_A::Flags"]
        [::std::mem::offset_of!(_SEC_WINNT_AUTH_IDENTITY_A, Flags) - 44usize];
};
pub type SEC_WINNT_AUTH_IDENTITY_A = _SEC_WINNT_AUTH_IDENTITY_A;
pub type PSEC_WINNT_AUTH_IDENTITY_A = *mut _SEC_WINNT_AUTH_IDENTITY_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_W {
    pub TransportCredentials: *mut SEC_WINNT_AUTH_IDENTITY_W,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_W"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_W>() - 40usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_W"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_W>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::TransportCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_W, TransportCredentials) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_W, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::AuthenticationTarget"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_W, AuthenticationTarget) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::NumberOfAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_W, NumberOfAuthnSchemes) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_W, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_W::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_W,
        ServerCertificateSubject
    ) - 32usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_W = _RPC_HTTP_TRANSPORT_CREDENTIALS_W;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_W = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_A {
    pub TransportCredentials: *mut SEC_WINNT_AUTH_IDENTITY_A,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_A"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_A>() - 40usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_A"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_A>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::TransportCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_A, TransportCredentials) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_A, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::AuthenticationTarget"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_A, AuthenticationTarget) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::NumberOfAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_A, NumberOfAuthnSchemes) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_A, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_A::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_A,
        ServerCertificateSubject
    ) - 32usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_A = _RPC_HTTP_TRANSPORT_CREDENTIALS_A;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_A = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W {
    pub TransportCredentials: *mut SEC_WINNT_AUTH_IDENTITY_W,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_ushort,
    pub ProxyCredentials: *mut SEC_WINNT_AUTH_IDENTITY_W,
    pub NumberOfProxyAuthnSchemes: ::std::os::raw::c_ulong,
    pub ProxyAuthnSchemes: *mut ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W>() - 64usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::TransportCredentials"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W,
        TransportCredentials
    ) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::AuthenticationTarget"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W,
        AuthenticationTarget
    ) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::NumberOfAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W,
        NumberOfAuthnSchemes
    ) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W,
        ServerCertificateSubject
    )
        - 32usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::ProxyCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W, ProxyCredentials) - 40usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::NumberOfProxyAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W,
        NumberOfProxyAuthnSchemes
    )
        - 48usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W::ProxyAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W, ProxyAuthnSchemes) - 56usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W = _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_V2_W = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A {
    pub TransportCredentials: *mut SEC_WINNT_AUTH_IDENTITY_A,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_uchar,
    pub ProxyCredentials: *mut SEC_WINNT_AUTH_IDENTITY_A,
    pub NumberOfProxyAuthnSchemes: ::std::os::raw::c_ulong,
    pub ProxyAuthnSchemes: *mut ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A>() - 64usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::TransportCredentials"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A,
        TransportCredentials
    ) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::AuthenticationTarget"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A,
        AuthenticationTarget
    ) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::NumberOfAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A,
        NumberOfAuthnSchemes
    ) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A,
        ServerCertificateSubject
    )
        - 32usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::ProxyCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A, ProxyCredentials) - 40usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::NumberOfProxyAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A,
        NumberOfProxyAuthnSchemes
    )
        - 48usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A::ProxyAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A, ProxyAuthnSchemes) - 56usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A = _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_V2_A = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_V2_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W {
    pub TransportCredentials: RPC_AUTH_IDENTITY_HANDLE,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_ushort,
    pub ProxyCredentials: RPC_AUTH_IDENTITY_HANDLE,
    pub NumberOfProxyAuthnSchemes: ::std::os::raw::c_ulong,
    pub ProxyAuthnSchemes: *mut ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W>() - 64usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::TransportCredentials"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W,
        TransportCredentials
    ) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::AuthenticationTarget"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W,
        AuthenticationTarget
    ) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::NumberOfAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W,
        NumberOfAuthnSchemes
    ) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W,
        ServerCertificateSubject
    )
        - 32usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::ProxyCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W, ProxyCredentials) - 40usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::NumberOfProxyAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W,
        NumberOfProxyAuthnSchemes
    )
        - 48usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W::ProxyAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W, ProxyAuthnSchemes) - 56usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W = _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_V3_W = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A {
    pub TransportCredentials: RPC_AUTH_IDENTITY_HANDLE,
    pub Flags: ::std::os::raw::c_ulong,
    pub AuthenticationTarget: ::std::os::raw::c_ulong,
    pub NumberOfAuthnSchemes: ::std::os::raw::c_ulong,
    pub AuthnSchemes: *mut ::std::os::raw::c_ulong,
    pub ServerCertificateSubject: *mut ::std::os::raw::c_uchar,
    pub ProxyCredentials: RPC_AUTH_IDENTITY_HANDLE,
    pub NumberOfProxyAuthnSchemes: ::std::os::raw::c_ulong,
    pub ProxyAuthnSchemes: *mut ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A"]
        [::std::mem::size_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A>() - 64usize];
    ["Alignment of _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A"]
        [::std::mem::align_of::<_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A>() - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::TransportCredentials"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A,
        TransportCredentials
    ) - 0usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::Flags"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A, Flags) - 8usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::AuthenticationTarget"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A,
        AuthenticationTarget
    ) - 12usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::NumberOfAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A,
        NumberOfAuthnSchemes
    ) - 16usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::AuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A, AuthnSchemes) - 24usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::ServerCertificateSubject"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A,
        ServerCertificateSubject
    )
        - 32usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::ProxyCredentials"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A, ProxyCredentials) - 40usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::NumberOfProxyAuthnSchemes"][::std::mem::offset_of!(
        _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A,
        NumberOfProxyAuthnSchemes
    )
        - 48usize];
    ["Offset of field: _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A::ProxyAuthnSchemes"]
        [::std::mem::offset_of!(_RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A, ProxyAuthnSchemes) - 56usize];
};
pub type RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A = _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A;
pub type PRPC_HTTP_TRANSPORT_CREDENTIALS_V3_A = *mut _RPC_HTTP_TRANSPORT_CREDENTIALS_V3_A;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V2_W {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V2_W__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V2_W__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_W,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V2_W__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V2_W__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V2_W__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V2_W__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V2_W"][::std::mem::size_of::<_RPC_SECURITY_QOS_V2_W>() - 32usize];
    ["Alignment of _RPC_SECURITY_QOS_V2_W"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V2_W>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_W::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_W, u) - 24usize];
};
pub type RPC_SECURITY_QOS_V2_W = _RPC_SECURITY_QOS_V2_W;
pub type PRPC_SECURITY_QOS_V2_W = *mut _RPC_SECURITY_QOS_V2_W;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V2_A {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V2_A__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V2_A__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V2_A__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V2_A__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V2_A__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V2_A__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V2_A"][::std::mem::size_of::<_RPC_SECURITY_QOS_V2_A>() - 32usize];
    ["Alignment of _RPC_SECURITY_QOS_V2_A"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V2_A>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V2_A::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V2_A, u) - 24usize];
};
pub type RPC_SECURITY_QOS_V2_A = _RPC_SECURITY_QOS_V2_A;
pub type PRPC_SECURITY_QOS_V2_A = *mut _RPC_SECURITY_QOS_V2_A;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V3_W {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V3_W__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V3_W__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_W,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V3_W__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V3_W__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V3_W__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V3_W__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V3_W"][::std::mem::size_of::<_RPC_SECURITY_QOS_V3_W>() - 40usize];
    ["Alignment of _RPC_SECURITY_QOS_V3_W"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V3_W>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_W::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_W, Sid) - 32usize];
};
pub type RPC_SECURITY_QOS_V3_W = _RPC_SECURITY_QOS_V3_W;
pub type PRPC_SECURITY_QOS_V3_W = *mut _RPC_SECURITY_QOS_V3_W;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V3_A {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V3_A__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V3_A__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V3_A__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V3_A__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V3_A__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V3_A__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V3_A"][::std::mem::size_of::<_RPC_SECURITY_QOS_V3_A>() - 40usize];
    ["Alignment of _RPC_SECURITY_QOS_V3_A"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V3_A>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V3_A::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V3_A, Sid) - 32usize];
};
pub type RPC_SECURITY_QOS_V3_A = _RPC_SECURITY_QOS_V3_A;
pub type PRPC_SECURITY_QOS_V3_A = *mut _RPC_SECURITY_QOS_V3_A;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V4_W {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V4_W__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
    pub EffectiveOnly: ::std::os::raw::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V4_W__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_W,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V4_W__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V4_W__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V4_W__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V4_W__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V4_W"][::std::mem::size_of::<_RPC_SECURITY_QOS_V4_W>() - 48usize];
    ["Alignment of _RPC_SECURITY_QOS_V4_W"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V4_W>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, Sid) - 32usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_W::EffectiveOnly"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_W, EffectiveOnly) - 40usize];
};
pub type RPC_SECURITY_QOS_V4_W = _RPC_SECURITY_QOS_V4_W;
pub type PRPC_SECURITY_QOS_V4_W = *mut _RPC_SECURITY_QOS_V4_W;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V4_A {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V4_A__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
    pub EffectiveOnly: ::std::os::raw::c_uint,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V4_A__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V4_A__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V4_A__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V4_A__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V4_A__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V4_A"][::std::mem::size_of::<_RPC_SECURITY_QOS_V4_A>() - 48usize];
    ["Alignment of _RPC_SECURITY_QOS_V4_A"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V4_A>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, Sid) - 32usize];
    ["Offset of field: _RPC_SECURITY_QOS_V4_A::EffectiveOnly"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V4_A, EffectiveOnly) - 40usize];
};
pub type RPC_SECURITY_QOS_V4_A = _RPC_SECURITY_QOS_V4_A;
pub type PRPC_SECURITY_QOS_V4_A = *mut _RPC_SECURITY_QOS_V4_A;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V5_W {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V5_W__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
    pub EffectiveOnly: ::std::os::raw::c_uint,
    pub ServerSecurityDescriptor: *mut ::std::os::raw::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V5_W__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_W,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V5_W__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V5_W__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V5_W__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V5_W__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V5_W"][::std::mem::size_of::<_RPC_SECURITY_QOS_V5_W>() - 56usize];
    ["Alignment of _RPC_SECURITY_QOS_V5_W"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V5_W>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, Sid) - 32usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::EffectiveOnly"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, EffectiveOnly) - 40usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_W::ServerSecurityDescriptor"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_W, ServerSecurityDescriptor) - 48usize];
};
pub type RPC_SECURITY_QOS_V5_W = _RPC_SECURITY_QOS_V5_W;
pub type PRPC_SECURITY_QOS_V5_W = *mut _RPC_SECURITY_QOS_V5_W;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_SECURITY_QOS_V5_A {
    pub Version: ::std::os::raw::c_ulong,
    pub Capabilities: ::std::os::raw::c_ulong,
    pub IdentityTracking: ::std::os::raw::c_ulong,
    pub ImpersonationType: ::std::os::raw::c_ulong,
    pub AdditionalSecurityInfoType: ::std::os::raw::c_ulong,
    pub u: _RPC_SECURITY_QOS_V5_A__bindgen_ty_1,
    pub Sid: *mut ::std::os::raw::c_void,
    pub EffectiveOnly: ::std::os::raw::c_uint,
    pub ServerSecurityDescriptor: *mut ::std::os::raw::c_void,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_SECURITY_QOS_V5_A__bindgen_ty_1 {
    pub HttpCredentials: *mut RPC_HTTP_TRANSPORT_CREDENTIALS_A,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V5_A__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_SECURITY_QOS_V5_A__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_SECURITY_QOS_V5_A__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V5_A__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A__bindgen_ty_1::HttpCredentials"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A__bindgen_ty_1, HttpCredentials) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SECURITY_QOS_V5_A"][::std::mem::size_of::<_RPC_SECURITY_QOS_V5_A>() - 56usize];
    ["Alignment of _RPC_SECURITY_QOS_V5_A"]
        [::std::mem::align_of::<_RPC_SECURITY_QOS_V5_A>() - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::Version"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, Version) - 0usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::Capabilities"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, Capabilities) - 4usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::IdentityTracking"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, IdentityTracking) - 8usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::ImpersonationType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, ImpersonationType) - 12usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::AdditionalSecurityInfoType"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, AdditionalSecurityInfoType) - 16usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::u"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, u) - 24usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::Sid"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, Sid) - 32usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::EffectiveOnly"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, EffectiveOnly) - 40usize];
    ["Offset of field: _RPC_SECURITY_QOS_V5_A::ServerSecurityDescriptor"]
        [::std::mem::offset_of!(_RPC_SECURITY_QOS_V5_A, ServerSecurityDescriptor) - 48usize];
};
pub type RPC_SECURITY_QOS_V5_A = _RPC_SECURITY_QOS_V5_A;
pub type PRPC_SECURITY_QOS_V5_A = *mut _RPC_SECURITY_QOS_V5_A;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_BINDING_HANDLE_TEMPLATE_V1_W {
    pub Version: ::std::os::raw::c_ulong,
    pub Flags: ::std::os::raw::c_ulong,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub NetworkAddress: *mut ::std::os::raw::c_ushort,
    pub StringEndpoint: *mut ::std::os::raw::c_ushort,
    pub u1: _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1,
    pub ObjectUuid: UUID,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1 {
    pub Reserved: *mut ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1::Reserved"][::std::mem::offset_of!(
        _RPC_BINDING_HANDLE_TEMPLATE_V1_W__bindgen_ty_1,
        Reserved
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_TEMPLATE_V1_W"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_W>() - 56usize];
    ["Alignment of _RPC_BINDING_HANDLE_TEMPLATE_V1_W"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_W>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::Version"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, Version) - 0usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::Flags"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, Flags) - 4usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::ProtocolSequence"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, ProtocolSequence) - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::NetworkAddress"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, NetworkAddress) - 16usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::StringEndpoint"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, StringEndpoint) - 24usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::u1"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, u1) - 32usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_W::ObjectUuid"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_W, ObjectUuid) - 40usize];
};
pub type RPC_BINDING_HANDLE_TEMPLATE_V1_W = _RPC_BINDING_HANDLE_TEMPLATE_V1_W;
pub type PRPC_BINDING_HANDLE_TEMPLATE_V1_W = *mut _RPC_BINDING_HANDLE_TEMPLATE_V1_W;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_BINDING_HANDLE_TEMPLATE_V1_A {
    pub Version: ::std::os::raw::c_ulong,
    pub Flags: ::std::os::raw::c_ulong,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub NetworkAddress: *mut ::std::os::raw::c_uchar,
    pub StringEndpoint: *mut ::std::os::raw::c_uchar,
    pub u1: _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1,
    pub ObjectUuid: UUID,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1 {
    pub Reserved: *mut ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1>() - 8usize];
    ["Alignment of _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1::Reserved"][::std::mem::offset_of!(
        _RPC_BINDING_HANDLE_TEMPLATE_V1_A__bindgen_ty_1,
        Reserved
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_TEMPLATE_V1_A"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_A>() - 56usize];
    ["Alignment of _RPC_BINDING_HANDLE_TEMPLATE_V1_A"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_TEMPLATE_V1_A>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::Version"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, Version) - 0usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::Flags"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, Flags) - 4usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::ProtocolSequence"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, ProtocolSequence) - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::NetworkAddress"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, NetworkAddress) - 16usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::StringEndpoint"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, StringEndpoint) - 24usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::u1"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, u1) - 32usize];
    ["Offset of field: _RPC_BINDING_HANDLE_TEMPLATE_V1_A::ObjectUuid"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_TEMPLATE_V1_A, ObjectUuid) - 40usize];
};
pub type RPC_BINDING_HANDLE_TEMPLATE_V1_A = _RPC_BINDING_HANDLE_TEMPLATE_V1_A;
pub type PRPC_BINDING_HANDLE_TEMPLATE_V1_A = *mut _RPC_BINDING_HANDLE_TEMPLATE_V1_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_BINDING_HANDLE_SECURITY_V1_W {
    pub Version: ::std::os::raw::c_ulong,
    pub ServerPrincName: *mut ::std::os::raw::c_ushort,
    pub AuthnLevel: ::std::os::raw::c_ulong,
    pub AuthnSvc: ::std::os::raw::c_ulong,
    pub AuthIdentity: *mut SEC_WINNT_AUTH_IDENTITY_W,
    pub SecurityQos: *mut RPC_SECURITY_QOS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_SECURITY_V1_W"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_SECURITY_V1_W>() - 40usize];
    ["Alignment of _RPC_BINDING_HANDLE_SECURITY_V1_W"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_SECURITY_V1_W>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::Version"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, Version) - 0usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::ServerPrincName"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, ServerPrincName) - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::AuthnLevel"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, AuthnLevel) - 16usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::AuthnSvc"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, AuthnSvc) - 20usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::AuthIdentity"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, AuthIdentity) - 24usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_W::SecurityQos"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_W, SecurityQos) - 32usize];
};
pub type RPC_BINDING_HANDLE_SECURITY_V1_W = _RPC_BINDING_HANDLE_SECURITY_V1_W;
pub type PRPC_BINDING_HANDLE_SECURITY_V1_W = *mut _RPC_BINDING_HANDLE_SECURITY_V1_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_BINDING_HANDLE_SECURITY_V1_A {
    pub Version: ::std::os::raw::c_ulong,
    pub ServerPrincName: *mut ::std::os::raw::c_uchar,
    pub AuthnLevel: ::std::os::raw::c_ulong,
    pub AuthnSvc: ::std::os::raw::c_ulong,
    pub AuthIdentity: *mut SEC_WINNT_AUTH_IDENTITY_A,
    pub SecurityQos: *mut RPC_SECURITY_QOS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_SECURITY_V1_A"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_SECURITY_V1_A>() - 40usize];
    ["Alignment of _RPC_BINDING_HANDLE_SECURITY_V1_A"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_SECURITY_V1_A>() - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::Version"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, Version) - 0usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::ServerPrincName"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, ServerPrincName) - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::AuthnLevel"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, AuthnLevel) - 16usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::AuthnSvc"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, AuthnSvc) - 20usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::AuthIdentity"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, AuthIdentity) - 24usize];
    ["Offset of field: _RPC_BINDING_HANDLE_SECURITY_V1_A::SecurityQos"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_SECURITY_V1_A, SecurityQos) - 32usize];
};
pub type RPC_BINDING_HANDLE_SECURITY_V1_A = _RPC_BINDING_HANDLE_SECURITY_V1_A;
pub type PRPC_BINDING_HANDLE_SECURITY_V1_A = *mut _RPC_BINDING_HANDLE_SECURITY_V1_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_BINDING_HANDLE_OPTIONS_V1 {
    pub Version: ::std::os::raw::c_ulong,
    pub Flags: ::std::os::raw::c_ulong,
    pub ComTimeout: ::std::os::raw::c_ulong,
    pub CallTimeout: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_BINDING_HANDLE_OPTIONS_V1"]
        [::std::mem::size_of::<_RPC_BINDING_HANDLE_OPTIONS_V1>() - 16usize];
    ["Alignment of _RPC_BINDING_HANDLE_OPTIONS_V1"]
        [::std::mem::align_of::<_RPC_BINDING_HANDLE_OPTIONS_V1>() - 4usize];
    ["Offset of field: _RPC_BINDING_HANDLE_OPTIONS_V1::Version"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_OPTIONS_V1, Version) - 0usize];
    ["Offset of field: _RPC_BINDING_HANDLE_OPTIONS_V1::Flags"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_OPTIONS_V1, Flags) - 4usize];
    ["Offset of field: _RPC_BINDING_HANDLE_OPTIONS_V1::ComTimeout"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_OPTIONS_V1, ComTimeout) - 8usize];
    ["Offset of field: _RPC_BINDING_HANDLE_OPTIONS_V1::CallTimeout"]
        [::std::mem::offset_of!(_RPC_BINDING_HANDLE_OPTIONS_V1, CallTimeout) - 12usize];
};
pub type RPC_BINDING_HANDLE_OPTIONS_V1 = _RPC_BINDING_HANDLE_OPTIONS_V1;
pub type PRPC_BINDING_HANDLE_OPTIONS_V1 = *mut _RPC_BINDING_HANDLE_OPTIONS_V1;
unsafe extern "C" {
    pub fn RpcBindingCreateA(
        Template: *mut RPC_BINDING_HANDLE_TEMPLATE_V1_A,
        Security: *mut RPC_BINDING_HANDLE_SECURITY_V1_A,
        Options: *mut RPC_BINDING_HANDLE_OPTIONS_V1,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingCreateW(
        Template: *mut RPC_BINDING_HANDLE_TEMPLATE_V1_W,
        Security: *mut RPC_BINDING_HANDLE_SECURITY_V1_W,
        Options: *mut RPC_BINDING_HANDLE_OPTIONS_V1,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingGetTrainingContextHandle(
        Binding: RPC_BINDING_HANDLE,
        ContextHandle: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqBindingHandle(Binding: *mut RPC_BINDING_HANDLE) -> RPC_STATUS;
}
pub const _RPC_HTTP_REDIRECTOR_STAGE_RPCHTTP_RS_REDIRECT: _RPC_HTTP_REDIRECTOR_STAGE = 1;
pub const _RPC_HTTP_REDIRECTOR_STAGE_RPCHTTP_RS_ACCESS_1: _RPC_HTTP_REDIRECTOR_STAGE = 2;
pub const _RPC_HTTP_REDIRECTOR_STAGE_RPCHTTP_RS_SESSION: _RPC_HTTP_REDIRECTOR_STAGE = 3;
pub const _RPC_HTTP_REDIRECTOR_STAGE_RPCHTTP_RS_ACCESS_2: _RPC_HTTP_REDIRECTOR_STAGE = 4;
pub const _RPC_HTTP_REDIRECTOR_STAGE_RPCHTTP_RS_INTERFACE: _RPC_HTTP_REDIRECTOR_STAGE = 5;
pub type _RPC_HTTP_REDIRECTOR_STAGE = ::std::os::raw::c_int;
pub use self::_RPC_HTTP_REDIRECTOR_STAGE as RPC_HTTP_REDIRECTOR_STAGE;
pub type RPC_NEW_HTTP_PROXY_CHANNEL = ::std::option::Option<
    unsafe extern "C" fn(
        RedirectorStage: RPC_HTTP_REDIRECTOR_STAGE,
        ServerName: RPC_WSTR,
        ServerPort: RPC_WSTR,
        RemoteUser: RPC_WSTR,
        AuthType: RPC_WSTR,
        ResourceUuid: *mut ::std::os::raw::c_void,
        SessionId: *mut ::std::os::raw::c_void,
        Interface: *mut ::std::os::raw::c_void,
        Reserved: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_ulong,
        NewServerName: *mut RPC_WSTR,
        NewServerPort: *mut RPC_WSTR,
    ) -> RPC_STATUS,
>;
pub type RPC_HTTP_PROXY_FREE_STRING = ::std::option::Option<unsafe extern "C" fn(String: RPC_WSTR)>;
unsafe extern "C" {
    pub fn RpcImpersonateClient(BindingHandle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcImpersonateClient2(BindingHandle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcRevertToSelfEx(BindingHandle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcRevertToSelf() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcImpersonateClientContainer(BindingHandle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcRevertContainerImpersonation() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthClientA(
        ClientBinding: RPC_BINDING_HANDLE,
        Privs: *mut RPC_AUTHZ_HANDLE,
        ServerPrincName: *mut RPC_CSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthClientW(
        ClientBinding: RPC_BINDING_HANDLE,
        Privs: *mut RPC_AUTHZ_HANDLE,
        ServerPrincName: *mut RPC_WSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthClientExA(
        ClientBinding: RPC_BINDING_HANDLE,
        Privs: *mut RPC_AUTHZ_HANDLE,
        ServerPrincName: *mut RPC_CSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
        Flags: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthClientExW(
        ClientBinding: RPC_BINDING_HANDLE,
        Privs: *mut RPC_AUTHZ_HANDLE,
        ServerPrincName: *mut RPC_WSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
        Flags: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthInfoA(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: *mut RPC_CSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthIdentity: *mut RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthInfoW(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: *mut RPC_WSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthIdentity: *mut RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetAuthInfoA(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: RPC_CSTR,
        AuthnLevel: ::std::os::raw::c_ulong,
        AuthnSvc: ::std::os::raw::c_ulong,
        AuthIdentity: RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetAuthInfoExA(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: RPC_CSTR,
        AuthnLevel: ::std::os::raw::c_ulong,
        AuthnSvc: ::std::os::raw::c_ulong,
        AuthIdentity: RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: ::std::os::raw::c_ulong,
        SecurityQos: *mut RPC_SECURITY_QOS,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetAuthInfoW(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: RPC_WSTR,
        AuthnLevel: ::std::os::raw::c_ulong,
        AuthnSvc: ::std::os::raw::c_ulong,
        AuthIdentity: RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingSetAuthInfoExW(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: RPC_WSTR,
        AuthnLevel: ::std::os::raw::c_ulong,
        AuthnSvc: ::std::os::raw::c_ulong,
        AuthIdentity: RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: ::std::os::raw::c_ulong,
        SecurityQOS: *mut RPC_SECURITY_QOS,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthInfoExA(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: *mut RPC_CSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthIdentity: *mut RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
        RpcQosVersion: ::std::os::raw::c_ulong,
        SecurityQOS: *mut RPC_SECURITY_QOS,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingInqAuthInfoExW(
        Binding: RPC_BINDING_HANDLE,
        ServerPrincName: *mut RPC_WSTR,
        AuthnLevel: *mut ::std::os::raw::c_ulong,
        AuthnSvc: *mut ::std::os::raw::c_ulong,
        AuthIdentity: *mut RPC_AUTH_IDENTITY_HANDLE,
        AuthzSvc: *mut ::std::os::raw::c_ulong,
        RpcQosVersion: ::std::os::raw::c_ulong,
        SecurityQOS: *mut RPC_SECURITY_QOS,
    ) -> RPC_STATUS;
}
pub type RPC_AUTH_KEY_RETRIEVAL_FN = ::std::option::Option<
    unsafe extern "C" fn(
        Arg: *mut ::std::os::raw::c_void,
        ServerPrincName: RPC_WSTR,
        KeyVer: ::std::os::raw::c_ulong,
        Key: *mut *mut ::std::os::raw::c_void,
        Status: *mut RPC_STATUS,
    ),
>;
unsafe extern "C" {
    pub fn RpcServerCompleteSecurityCallback(
        BindingHandle: RPC_BINDING_HANDLE,
        Status: RPC_STATUS,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterAuthInfoA(
        ServerPrincName: RPC_CSTR,
        AuthnSvc: ::std::os::raw::c_ulong,
        GetKeyFn: RPC_AUTH_KEY_RETRIEVAL_FN,
        Arg: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerRegisterAuthInfoW(
        ServerPrincName: RPC_WSTR,
        AuthnSvc: ::std::os::raw::c_ulong,
        GetKeyFn: RPC_AUTH_KEY_RETRIEVAL_FN,
        Arg: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_CLIENT_INFORMATION1 {
    pub UserName: *mut ::std::os::raw::c_uchar,
    pub ComputerName: *mut ::std::os::raw::c_uchar,
    pub Privilege: ::std::os::raw::c_ushort,
    pub AuthFlags: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_CLIENT_INFORMATION1"][::std::mem::size_of::<RPC_CLIENT_INFORMATION1>() - 24usize];
    ["Alignment of RPC_CLIENT_INFORMATION1"]
        [::std::mem::align_of::<RPC_CLIENT_INFORMATION1>() - 8usize];
    ["Offset of field: RPC_CLIENT_INFORMATION1::UserName"]
        [::std::mem::offset_of!(RPC_CLIENT_INFORMATION1, UserName) - 0usize];
    ["Offset of field: RPC_CLIENT_INFORMATION1::ComputerName"]
        [::std::mem::offset_of!(RPC_CLIENT_INFORMATION1, ComputerName) - 8usize];
    ["Offset of field: RPC_CLIENT_INFORMATION1::Privilege"]
        [::std::mem::offset_of!(RPC_CLIENT_INFORMATION1, Privilege) - 16usize];
    ["Offset of field: RPC_CLIENT_INFORMATION1::AuthFlags"]
        [::std::mem::offset_of!(RPC_CLIENT_INFORMATION1, AuthFlags) - 20usize];
};
pub type PRPC_CLIENT_INFORMATION1 = *mut RPC_CLIENT_INFORMATION1;
unsafe extern "C" {
    pub fn RpcBindingServerFromClient(
        ClientBinding: RPC_BINDING_HANDLE,
        ServerBinding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcRaiseException(exception: RPC_STATUS) -> !;
}
unsafe extern "C" {
    pub fn RpcTestCancel() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerTestCancel(BindingHandle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcCancelThread(Thread: *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcCancelThreadEx(
        Thread: *mut ::std::os::raw::c_void,
        Timeout: ::std::os::raw::c_long,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidCreate(Uuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidCreateSequential(Uuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidToStringA(Uuid: *const UUID, StringUuid: *mut RPC_CSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidFromStringA(StringUuid: RPC_CSTR, Uuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidToStringW(Uuid: *const UUID, StringUuid: *mut RPC_WSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidFromStringW(StringUuid: RPC_WSTR, Uuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidCompare(
        Uuid1: *mut UUID,
        Uuid2: *mut UUID,
        Status: *mut RPC_STATUS,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn UuidCreateNil(NilUuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn UuidEqual(
        Uuid1: *mut UUID,
        Uuid2: *mut UUID,
        Status: *mut RPC_STATUS,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn UuidHash(Uuid: *mut UUID, Status: *mut RPC_STATUS) -> ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn UuidIsNil(Uuid: *mut UUID, Status: *mut RPC_STATUS) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn RpcEpRegisterNoReplaceA(
        IfSpec: RPC_IF_HANDLE,
        BindingVector: *mut RPC_BINDING_VECTOR,
        UuidVector: *mut UUID_VECTOR,
        Annotation: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcEpRegisterNoReplaceW(
        IfSpec: RPC_IF_HANDLE,
        BindingVector: *mut RPC_BINDING_VECTOR,
        UuidVector: *mut UUID_VECTOR,
        Annotation: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcEpRegisterA(
        IfSpec: RPC_IF_HANDLE,
        BindingVector: *mut RPC_BINDING_VECTOR,
        UuidVector: *mut UUID_VECTOR,
        Annotation: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcEpRegisterW(
        IfSpec: RPC_IF_HANDLE,
        BindingVector: *mut RPC_BINDING_VECTOR,
        UuidVector: *mut UUID_VECTOR,
        Annotation: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcEpUnregister(
        IfSpec: RPC_IF_HANDLE,
        BindingVector: *mut RPC_BINDING_VECTOR,
        UuidVector: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn DceErrorInqTextA(RpcStatus: RPC_STATUS, ErrorText: RPC_CSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn DceErrorInqTextW(RpcStatus: RPC_STATUS, ErrorText: RPC_WSTR) -> RPC_STATUS;
}
pub type RPC_EP_INQ_HANDLE = *mut I_RPC_HANDLE;
unsafe extern "C" {
    pub fn RpcMgmtEpEltInqBegin(
        EpBinding: RPC_BINDING_HANDLE,
        InquiryType: ::std::os::raw::c_ulong,
        IfId: *mut RPC_IF_ID,
        VersOption: ::std::os::raw::c_ulong,
        ObjectUuid: *mut UUID,
        InquiryContext: *mut RPC_EP_INQ_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtEpEltInqDone(InquiryContext: *mut RPC_EP_INQ_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtEpEltInqNextA(
        InquiryContext: RPC_EP_INQ_HANDLE,
        IfId: *mut RPC_IF_ID,
        Binding: *mut RPC_BINDING_HANDLE,
        ObjectUuid: *mut UUID,
        Annotation: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtEpEltInqNextW(
        InquiryContext: RPC_EP_INQ_HANDLE,
        IfId: *mut RPC_IF_ID,
        Binding: *mut RPC_BINDING_HANDLE,
        ObjectUuid: *mut UUID,
        Annotation: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcMgmtEpUnregister(
        EpBinding: RPC_BINDING_HANDLE,
        IfId: *mut RPC_IF_ID,
        Binding: RPC_BINDING_HANDLE,
        ObjectUuid: *mut UUID,
    ) -> RPC_STATUS;
}
pub type RPC_MGMT_AUTHORIZATION_FN = ::std::option::Option<
    unsafe extern "C" fn(
        ClientBinding: RPC_BINDING_HANDLE,
        RequestedMgmtOperation: ::std::os::raw::c_ulong,
        Status: *mut RPC_STATUS,
    ) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn RpcMgmtSetAuthorizationFn(AuthorizationFn: RPC_MGMT_AUTHORIZATION_FN) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcExceptionFilter(ExceptionCode: ::std::os::raw::c_ulong) -> ::std::os::raw::c_int;
}
pub type RPC_INTERFACE_GROUP = *mut ::std::os::raw::c_void;
pub type PRPC_INTERFACE_GROUP = *mut *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_ENDPOINT_TEMPLATEW {
    pub Version: ::std::os::raw::c_ulong,
    pub ProtSeq: RPC_WSTR,
    pub Endpoint: RPC_WSTR,
    pub SecurityDescriptor: *mut ::std::os::raw::c_void,
    pub Backlog: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_ENDPOINT_TEMPLATEW"][::std::mem::size_of::<RPC_ENDPOINT_TEMPLATEW>() - 40usize];
    ["Alignment of RPC_ENDPOINT_TEMPLATEW"]
        [::std::mem::align_of::<RPC_ENDPOINT_TEMPLATEW>() - 8usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEW::Version"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEW, Version) - 0usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEW::ProtSeq"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEW, ProtSeq) - 8usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEW::Endpoint"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEW, Endpoint) - 16usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEW::SecurityDescriptor"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEW, SecurityDescriptor) - 24usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEW::Backlog"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEW, Backlog) - 32usize];
};
pub type PRPC_ENDPOINT_TEMPLATEW = *mut RPC_ENDPOINT_TEMPLATEW;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_ENDPOINT_TEMPLATEA {
    pub Version: ::std::os::raw::c_ulong,
    pub ProtSeq: RPC_CSTR,
    pub Endpoint: RPC_CSTR,
    pub SecurityDescriptor: *mut ::std::os::raw::c_void,
    pub Backlog: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_ENDPOINT_TEMPLATEA"][::std::mem::size_of::<RPC_ENDPOINT_TEMPLATEA>() - 40usize];
    ["Alignment of RPC_ENDPOINT_TEMPLATEA"]
        [::std::mem::align_of::<RPC_ENDPOINT_TEMPLATEA>() - 8usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEA::Version"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEA, Version) - 0usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEA::ProtSeq"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEA, ProtSeq) - 8usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEA::Endpoint"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEA, Endpoint) - 16usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEA::SecurityDescriptor"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEA, SecurityDescriptor) - 24usize];
    ["Offset of field: RPC_ENDPOINT_TEMPLATEA::Backlog"]
        [::std::mem::offset_of!(RPC_ENDPOINT_TEMPLATEA, Backlog) - 32usize];
};
pub type PRPC_ENDPOINT_TEMPLATEA = *mut RPC_ENDPOINT_TEMPLATEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_INTERFACE_TEMPLATEA {
    pub Version: ::std::os::raw::c_ulong,
    pub IfSpec: RPC_IF_HANDLE,
    pub MgrTypeUuid: *mut UUID,
    pub MgrEpv: *mut ::std::os::raw::c_void,
    pub Flags: ::std::os::raw::c_uint,
    pub MaxCalls: ::std::os::raw::c_uint,
    pub MaxRpcSize: ::std::os::raw::c_uint,
    pub IfCallback: ::std::option::Option<
        unsafe extern "C" fn(arg1: RPC_IF_HANDLE, arg2: *mut ::std::os::raw::c_void) -> RPC_STATUS,
    >,
    pub UuidVector: *mut UUID_VECTOR,
    pub Annotation: RPC_CSTR,
    pub SecurityDescriptor: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_INTERFACE_TEMPLATEA"][::std::mem::size_of::<RPC_INTERFACE_TEMPLATEA>() - 80usize];
    ["Alignment of RPC_INTERFACE_TEMPLATEA"]
        [::std::mem::align_of::<RPC_INTERFACE_TEMPLATEA>() - 8usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::Version"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, Version) - 0usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::IfSpec"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, IfSpec) - 8usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::MgrTypeUuid"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, MgrTypeUuid) - 16usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::MgrEpv"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, MgrEpv) - 24usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::Flags"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, Flags) - 32usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::MaxCalls"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, MaxCalls) - 36usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::MaxRpcSize"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, MaxRpcSize) - 40usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::IfCallback"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, IfCallback) - 48usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::UuidVector"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, UuidVector) - 56usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::Annotation"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, Annotation) - 64usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEA::SecurityDescriptor"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEA, SecurityDescriptor) - 72usize];
};
pub type PRPC_INTERFACE_TEMPLATEA = *mut RPC_INTERFACE_TEMPLATEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_INTERFACE_TEMPLATEW {
    pub Version: ::std::os::raw::c_ulong,
    pub IfSpec: RPC_IF_HANDLE,
    pub MgrTypeUuid: *mut UUID,
    pub MgrEpv: *mut ::std::os::raw::c_void,
    pub Flags: ::std::os::raw::c_uint,
    pub MaxCalls: ::std::os::raw::c_uint,
    pub MaxRpcSize: ::std::os::raw::c_uint,
    pub IfCallback: ::std::option::Option<
        unsafe extern "C" fn(arg1: RPC_IF_HANDLE, arg2: *mut ::std::os::raw::c_void) -> RPC_STATUS,
    >,
    pub UuidVector: *mut UUID_VECTOR,
    pub Annotation: RPC_WSTR,
    pub SecurityDescriptor: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_INTERFACE_TEMPLATEW"][::std::mem::size_of::<RPC_INTERFACE_TEMPLATEW>() - 80usize];
    ["Alignment of RPC_INTERFACE_TEMPLATEW"]
        [::std::mem::align_of::<RPC_INTERFACE_TEMPLATEW>() - 8usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::Version"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, Version) - 0usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::IfSpec"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, IfSpec) - 8usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::MgrTypeUuid"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, MgrTypeUuid) - 16usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::MgrEpv"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, MgrEpv) - 24usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::Flags"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, Flags) - 32usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::MaxCalls"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, MaxCalls) - 36usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::MaxRpcSize"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, MaxRpcSize) - 40usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::IfCallback"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, IfCallback) - 48usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::UuidVector"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, UuidVector) - 56usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::Annotation"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, Annotation) - 64usize];
    ["Offset of field: RPC_INTERFACE_TEMPLATEW::SecurityDescriptor"]
        [::std::mem::offset_of!(RPC_INTERFACE_TEMPLATEW, SecurityDescriptor) - 72usize];
};
pub type PRPC_INTERFACE_TEMPLATEW = *mut RPC_INTERFACE_TEMPLATEW;
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupCreateW(
        Interfaces: *mut RPC_INTERFACE_TEMPLATEW,
        NumIfs: ::std::os::raw::c_ulong,
        Endpoints: *mut RPC_ENDPOINT_TEMPLATEW,
        NumEndpoints: ::std::os::raw::c_ulong,
        IdlePeriod: ::std::os::raw::c_ulong,
        IdleCallbackFn: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: RPC_INTERFACE_GROUP,
                arg2: *mut ::std::os::raw::c_void,
                arg3: ::std::os::raw::c_ulong,
            ),
        >,
        IdleCallbackContext: *mut ::std::os::raw::c_void,
        IfGroup: PRPC_INTERFACE_GROUP,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupCreateA(
        Interfaces: *mut RPC_INTERFACE_TEMPLATEA,
        NumIfs: ::std::os::raw::c_ulong,
        Endpoints: *mut RPC_ENDPOINT_TEMPLATEA,
        NumEndpoints: ::std::os::raw::c_ulong,
        IdlePeriod: ::std::os::raw::c_ulong,
        IdleCallbackFn: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: RPC_INTERFACE_GROUP,
                arg2: *mut ::std::os::raw::c_void,
                arg3: ::std::os::raw::c_ulong,
            ),
        >,
        IdleCallbackContext: *mut ::std::os::raw::c_void,
        IfGroup: PRPC_INTERFACE_GROUP,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupClose(IfGroup: RPC_INTERFACE_GROUP) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupActivate(IfGroup: RPC_INTERFACE_GROUP) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupDeactivate(
        IfGroup: RPC_INTERFACE_GROUP,
        ForceDeactivation: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInterfaceGroupInqBindings(
        IfGroup: RPC_INTERFACE_GROUP,
        BindingVector: *mut *mut RPC_BINDING_VECTOR,
    ) -> RPC_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_VERSION {
    pub MajorVersion: ::std::os::raw::c_ushort,
    pub MinorVersion: ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_VERSION"][::std::mem::size_of::<_RPC_VERSION>() - 4usize];
    ["Alignment of _RPC_VERSION"][::std::mem::align_of::<_RPC_VERSION>() - 2usize];
    ["Offset of field: _RPC_VERSION::MajorVersion"]
        [::std::mem::offset_of!(_RPC_VERSION, MajorVersion) - 0usize];
    ["Offset of field: _RPC_VERSION::MinorVersion"]
        [::std::mem::offset_of!(_RPC_VERSION, MinorVersion) - 2usize];
};
pub type RPC_VERSION = _RPC_VERSION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_SYNTAX_IDENTIFIER {
    pub SyntaxGUID: GUID,
    pub SyntaxVersion: RPC_VERSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SYNTAX_IDENTIFIER"][::std::mem::size_of::<_RPC_SYNTAX_IDENTIFIER>() - 20usize];
    ["Alignment of _RPC_SYNTAX_IDENTIFIER"]
        [::std::mem::align_of::<_RPC_SYNTAX_IDENTIFIER>() - 4usize];
    ["Offset of field: _RPC_SYNTAX_IDENTIFIER::SyntaxGUID"]
        [::std::mem::offset_of!(_RPC_SYNTAX_IDENTIFIER, SyntaxGUID) - 0usize];
    ["Offset of field: _RPC_SYNTAX_IDENTIFIER::SyntaxVersion"]
        [::std::mem::offset_of!(_RPC_SYNTAX_IDENTIFIER, SyntaxVersion) - 16usize];
};
pub type RPC_SYNTAX_IDENTIFIER = _RPC_SYNTAX_IDENTIFIER;
pub type PRPC_SYNTAX_IDENTIFIER = *mut _RPC_SYNTAX_IDENTIFIER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_MESSAGE {
    pub Handle: RPC_BINDING_HANDLE,
    pub DataRepresentation: ::std::os::raw::c_ulong,
    pub Buffer: *mut ::std::os::raw::c_void,
    pub BufferLength: ::std::os::raw::c_uint,
    pub ProcNum: ::std::os::raw::c_uint,
    pub TransferSyntax: PRPC_SYNTAX_IDENTIFIER,
    pub RpcInterfaceInformation: *mut ::std::os::raw::c_void,
    pub ReservedForRuntime: *mut ::std::os::raw::c_void,
    pub ManagerEpv: *mut ::std::os::raw::c_void,
    pub ImportContext: *mut ::std::os::raw::c_void,
    pub RpcFlags: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_MESSAGE"][::std::mem::size_of::<_RPC_MESSAGE>() - 80usize];
    ["Alignment of _RPC_MESSAGE"][::std::mem::align_of::<_RPC_MESSAGE>() - 8usize];
    ["Offset of field: _RPC_MESSAGE::Handle"]
        [::std::mem::offset_of!(_RPC_MESSAGE, Handle) - 0usize];
    ["Offset of field: _RPC_MESSAGE::DataRepresentation"]
        [::std::mem::offset_of!(_RPC_MESSAGE, DataRepresentation) - 8usize];
    ["Offset of field: _RPC_MESSAGE::Buffer"]
        [::std::mem::offset_of!(_RPC_MESSAGE, Buffer) - 16usize];
    ["Offset of field: _RPC_MESSAGE::BufferLength"]
        [::std::mem::offset_of!(_RPC_MESSAGE, BufferLength) - 24usize];
    ["Offset of field: _RPC_MESSAGE::ProcNum"]
        [::std::mem::offset_of!(_RPC_MESSAGE, ProcNum) - 28usize];
    ["Offset of field: _RPC_MESSAGE::TransferSyntax"]
        [::std::mem::offset_of!(_RPC_MESSAGE, TransferSyntax) - 32usize];
    ["Offset of field: _RPC_MESSAGE::RpcInterfaceInformation"]
        [::std::mem::offset_of!(_RPC_MESSAGE, RpcInterfaceInformation) - 40usize];
    ["Offset of field: _RPC_MESSAGE::ReservedForRuntime"]
        [::std::mem::offset_of!(_RPC_MESSAGE, ReservedForRuntime) - 48usize];
    ["Offset of field: _RPC_MESSAGE::ManagerEpv"]
        [::std::mem::offset_of!(_RPC_MESSAGE, ManagerEpv) - 56usize];
    ["Offset of field: _RPC_MESSAGE::ImportContext"]
        [::std::mem::offset_of!(_RPC_MESSAGE, ImportContext) - 64usize];
    ["Offset of field: _RPC_MESSAGE::RpcFlags"]
        [::std::mem::offset_of!(_RPC_MESSAGE, RpcFlags) - 72usize];
};
pub type RPC_MESSAGE = _RPC_MESSAGE;
pub type PRPC_MESSAGE = *mut _RPC_MESSAGE;
pub const RPC_ADDRESS_CHANGE_TYPE_PROTOCOL_NOT_LOADED: RPC_ADDRESS_CHANGE_TYPE = 1;
pub const RPC_ADDRESS_CHANGE_TYPE_PROTOCOL_LOADED: RPC_ADDRESS_CHANGE_TYPE = 2;
pub const RPC_ADDRESS_CHANGE_TYPE_PROTOCOL_ADDRESS_CHANGE: RPC_ADDRESS_CHANGE_TYPE = 3;
pub type RPC_ADDRESS_CHANGE_TYPE = ::std::os::raw::c_int;
pub type RPC_DISPATCH_FUNCTION = ::std::option::Option<unsafe extern "C" fn(Message: PRPC_MESSAGE)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_DISPATCH_TABLE {
    pub DispatchTableCount: ::std::os::raw::c_uint,
    pub DispatchTable: *mut RPC_DISPATCH_FUNCTION,
    pub Reserved: LONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_DISPATCH_TABLE"][::std::mem::size_of::<RPC_DISPATCH_TABLE>() - 24usize];
    ["Alignment of RPC_DISPATCH_TABLE"][::std::mem::align_of::<RPC_DISPATCH_TABLE>() - 8usize];
    ["Offset of field: RPC_DISPATCH_TABLE::DispatchTableCount"]
        [::std::mem::offset_of!(RPC_DISPATCH_TABLE, DispatchTableCount) - 0usize];
    ["Offset of field: RPC_DISPATCH_TABLE::DispatchTable"]
        [::std::mem::offset_of!(RPC_DISPATCH_TABLE, DispatchTable) - 8usize];
    ["Offset of field: RPC_DISPATCH_TABLE::Reserved"]
        [::std::mem::offset_of!(RPC_DISPATCH_TABLE, Reserved) - 16usize];
};
pub type PRPC_DISPATCH_TABLE = *mut RPC_DISPATCH_TABLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_PROTSEQ_ENDPOINT {
    pub RpcProtocolSequence: *mut ::std::os::raw::c_uchar,
    pub Endpoint: *mut ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_PROTSEQ_ENDPOINT"][::std::mem::size_of::<_RPC_PROTSEQ_ENDPOINT>() - 16usize];
    ["Alignment of _RPC_PROTSEQ_ENDPOINT"]
        [::std::mem::align_of::<_RPC_PROTSEQ_ENDPOINT>() - 8usize];
    ["Offset of field: _RPC_PROTSEQ_ENDPOINT::RpcProtocolSequence"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_ENDPOINT, RpcProtocolSequence) - 0usize];
    ["Offset of field: _RPC_PROTSEQ_ENDPOINT::Endpoint"]
        [::std::mem::offset_of!(_RPC_PROTSEQ_ENDPOINT, Endpoint) - 8usize];
};
pub type RPC_PROTSEQ_ENDPOINT = _RPC_PROTSEQ_ENDPOINT;
pub type PRPC_PROTSEQ_ENDPOINT = *mut _RPC_PROTSEQ_ENDPOINT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_SERVER_INTERFACE {
    pub Length: ::std::os::raw::c_uint,
    pub InterfaceId: RPC_SYNTAX_IDENTIFIER,
    pub TransferSyntax: RPC_SYNTAX_IDENTIFIER,
    pub DispatchTable: PRPC_DISPATCH_TABLE,
    pub RpcProtseqEndpointCount: ::std::os::raw::c_uint,
    pub RpcProtseqEndpoint: PRPC_PROTSEQ_ENDPOINT,
    pub DefaultManagerEpv: *mut ::std::os::raw::c_void,
    pub InterpreterInfo: *const ::std::os::raw::c_void,
    pub Flags: ::std::os::raw::c_uint,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SERVER_INTERFACE"][::std::mem::size_of::<_RPC_SERVER_INTERFACE>() - 96usize];
    ["Alignment of _RPC_SERVER_INTERFACE"]
        [::std::mem::align_of::<_RPC_SERVER_INTERFACE>() - 8usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::Length"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, Length) - 0usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::InterfaceId"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, InterfaceId) - 4usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::TransferSyntax"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, TransferSyntax) - 24usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::DispatchTable"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, DispatchTable) - 48usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::RpcProtseqEndpointCount"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, RpcProtseqEndpointCount) - 56usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::RpcProtseqEndpoint"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, RpcProtseqEndpoint) - 64usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::DefaultManagerEpv"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, DefaultManagerEpv) - 72usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::InterpreterInfo"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, InterpreterInfo) - 80usize];
    ["Offset of field: _RPC_SERVER_INTERFACE::Flags"]
        [::std::mem::offset_of!(_RPC_SERVER_INTERFACE, Flags) - 88usize];
};
pub type RPC_SERVER_INTERFACE = _RPC_SERVER_INTERFACE;
pub type PRPC_SERVER_INTERFACE = *mut _RPC_SERVER_INTERFACE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_CLIENT_INTERFACE {
    pub Length: ::std::os::raw::c_uint,
    pub InterfaceId: RPC_SYNTAX_IDENTIFIER,
    pub TransferSyntax: RPC_SYNTAX_IDENTIFIER,
    pub DispatchTable: PRPC_DISPATCH_TABLE,
    pub RpcProtseqEndpointCount: ::std::os::raw::c_uint,
    pub RpcProtseqEndpoint: PRPC_PROTSEQ_ENDPOINT,
    pub Reserved: ULONG_PTR,
    pub InterpreterInfo: *const ::std::os::raw::c_void,
    pub Flags: ::std::os::raw::c_uint,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_CLIENT_INTERFACE"][::std::mem::size_of::<_RPC_CLIENT_INTERFACE>() - 96usize];
    ["Alignment of _RPC_CLIENT_INTERFACE"]
        [::std::mem::align_of::<_RPC_CLIENT_INTERFACE>() - 8usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::Length"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, Length) - 0usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::InterfaceId"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, InterfaceId) - 4usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::TransferSyntax"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, TransferSyntax) - 24usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::DispatchTable"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, DispatchTable) - 48usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::RpcProtseqEndpointCount"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, RpcProtseqEndpointCount) - 56usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::RpcProtseqEndpoint"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, RpcProtseqEndpoint) - 64usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::Reserved"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, Reserved) - 72usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::InterpreterInfo"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, InterpreterInfo) - 80usize];
    ["Offset of field: _RPC_CLIENT_INTERFACE::Flags"]
        [::std::mem::offset_of!(_RPC_CLIENT_INTERFACE, Flags) - 88usize];
};
pub type RPC_CLIENT_INTERFACE = _RPC_CLIENT_INTERFACE;
pub type PRPC_CLIENT_INTERFACE = *mut _RPC_CLIENT_INTERFACE;
unsafe extern "C" {
    pub fn I_RpcNegotiateTransferSyntax(Message: *mut RPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetBuffer(Message: *mut RPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetBufferWithObject(Message: *mut RPC_MESSAGE, ObjectUuid: *mut UUID)
        -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcSendReceive(Message: *mut RPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcFreeBuffer(Message: *mut RPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcSend(Message: PRPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcReceive(Message: PRPC_MESSAGE, Size: ::std::os::raw::c_uint) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcFreePipeBuffer(Message: *mut RPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcReallocPipeBuffer(
        Message: PRPC_MESSAGE,
        NewSize: ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
pub type I_RPC_MUTEX = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub fn I_RpcRequestMutex(Mutex: *mut I_RPC_MUTEX);
}
unsafe extern "C" {
    pub fn I_RpcClearMutex(Mutex: I_RPC_MUTEX);
}
unsafe extern "C" {
    pub fn I_RpcDeleteMutex(Mutex: I_RPC_MUTEX);
}
unsafe extern "C" {
    pub fn I_RpcAllocate(Size: ::std::os::raw::c_uint) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn I_RpcFree(Object: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn I_RpcFreeSystemHandleCollection(
        CallObj: *mut ::std::os::raw::c_void,
        FreeFlags: ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn I_RpcSetSystemHandle(
        Handle: *mut ::std::os::raw::c_void,
        Type: ::std::os::raw::c_uchar,
        AccessMask: ::std::os::raw::c_ulong,
        CallObj: *mut ::std::os::raw::c_void,
        HandleIndex: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetSystemHandle(
        pMemory: *mut ::std::os::raw::c_uchar,
        Type: ::std::os::raw::c_uchar,
        AccessMask: ::std::os::raw::c_ulong,
        HandleIndex: ::std::os::raw::c_ulong,
        CallObj: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcFreeSystemHandle(
        Type: ::std::os::raw::c_uchar,
        Handle: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn I_RpcPauseExecution(Milliseconds: ::std::os::raw::c_ulong);
}
unsafe extern "C" {
    pub fn I_RpcGetExtendedError() -> RPC_STATUS;
}
pub const _LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION_MarshalDirectionMarshal:
    _LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION = 0;
pub const _LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION_MarshalDirectionUnmarshal:
    _LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION = 1;
pub type _LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION = ::std::os::raw::c_int;
pub use self::_LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION as LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION;
unsafe extern "C" {
    pub fn I_RpcSystemHandleTypeSpecificWork(
        Handle: *mut ::std::os::raw::c_void,
        ActualType: ::std::os::raw::c_uchar,
        IdlType: ::std::os::raw::c_uchar,
        MarshalDirection: LRPC_SYSTEM_HANDLE_MARSHAL_DIRECTION,
    ) -> RPC_STATUS;
}
pub type PRPC_RUNDOWN =
    ::std::option::Option<unsafe extern "C" fn(AssociationContext: *mut ::std::os::raw::c_void)>;
unsafe extern "C" {
    pub fn I_RpcMonitorAssociation(
        Handle: RPC_BINDING_HANDLE,
        RundownRoutine: PRPC_RUNDOWN,
        Context: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcStopMonitorAssociation(Handle: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetCurrentCallHandle() -> RPC_BINDING_HANDLE;
}
unsafe extern "C" {
    pub fn I_RpcGetAssociationContext(
        BindingHandle: RPC_BINDING_HANDLE,
        AssociationContext: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetServerContextList(
        BindingHandle: RPC_BINDING_HANDLE,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn I_RpcSetServerContextList(
        BindingHandle: RPC_BINDING_HANDLE,
        ServerContextList: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn I_RpcNsInterfaceExported(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: *mut ::std::os::raw::c_ushort,
        RpcInterfaceInformation: *mut RPC_SERVER_INTERFACE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcNsInterfaceUnexported(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: *mut ::std::os::raw::c_ushort,
        RpcInterfaceInformation: *mut RPC_SERVER_INTERFACE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingToStaticStringBindingW(
        Binding: RPC_BINDING_HANDLE,
        StringBinding: *mut *mut ::std::os::raw::c_ushort,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqSecurityContext(
        Binding: RPC_BINDING_HANDLE,
        SecurityContextHandle: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_SEC_CONTEXT_KEY_INFO {
    pub EncryptAlgorithm: ::std::os::raw::c_ulong,
    pub KeySize: ::std::os::raw::c_ulong,
    pub SignatureAlgorithm: ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_SEC_CONTEXT_KEY_INFO"]
        [::std::mem::size_of::<_RPC_SEC_CONTEXT_KEY_INFO>() - 12usize];
    ["Alignment of _RPC_SEC_CONTEXT_KEY_INFO"]
        [::std::mem::align_of::<_RPC_SEC_CONTEXT_KEY_INFO>() - 4usize];
    ["Offset of field: _RPC_SEC_CONTEXT_KEY_INFO::EncryptAlgorithm"]
        [::std::mem::offset_of!(_RPC_SEC_CONTEXT_KEY_INFO, EncryptAlgorithm) - 0usize];
    ["Offset of field: _RPC_SEC_CONTEXT_KEY_INFO::KeySize"]
        [::std::mem::offset_of!(_RPC_SEC_CONTEXT_KEY_INFO, KeySize) - 4usize];
    ["Offset of field: _RPC_SEC_CONTEXT_KEY_INFO::SignatureAlgorithm"]
        [::std::mem::offset_of!(_RPC_SEC_CONTEXT_KEY_INFO, SignatureAlgorithm) - 8usize];
};
pub type RPC_SEC_CONTEXT_KEY_INFO = _RPC_SEC_CONTEXT_KEY_INFO;
pub type PRPC_SEC_CONTEXT_KEY_INFO = *mut _RPC_SEC_CONTEXT_KEY_INFO;
unsafe extern "C" {
    pub fn I_RpcBindingInqSecurityContextKeyInfo(
        Binding: RPC_BINDING_HANDLE,
        KeyInfo: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqWireIdForSnego(
        Binding: RPC_BINDING_HANDLE,
        WireId: *mut ::std::os::raw::c_uchar,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqMarshalledTargetInfo(
        Binding: RPC_BINDING_HANDLE,
        MarshalledTargetInfoSize: *mut ::std::os::raw::c_ulong,
        MarshalledTargetInfo: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqLocalClientPID(
        Binding: RPC_BINDING_HANDLE,
        Pid: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingHandleToAsyncHandle(
        Binding: RPC_BINDING_HANDLE,
        AsyncHandle: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcNsBindingSetEntryNameW(
        Binding: RPC_BINDING_HANDLE,
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcNsBindingSetEntryNameA(
        Binding: RPC_BINDING_HANDLE,
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUseProtseqEp2A(
        NetworkAddress: RPC_CSTR,
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_CSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUseProtseqEp2W(
        NetworkAddress: RPC_WSTR,
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        Endpoint: RPC_WSTR,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUseProtseq2W(
        NetworkAddress: RPC_WSTR,
        Protseq: RPC_WSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUseProtseq2A(
        NetworkAddress: RPC_CSTR,
        Protseq: RPC_CSTR,
        MaxCalls: ::std::os::raw::c_uint,
        SecurityDescriptor: *mut ::std::os::raw::c_void,
        Policy: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerStartService(
        Protseq: RPC_WSTR,
        Endpoint: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqDynamicEndpointW(
        Binding: RPC_BINDING_HANDLE,
        DynamicEndpoint: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqDynamicEndpointA(
        Binding: RPC_BINDING_HANDLE,
        DynamicEndpoint: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerCheckClientRestriction(Context: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqTransportType(
        Binding: RPC_BINDING_HANDLE,
        Type: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_TRANSFER_SYNTAX {
    pub Uuid: UUID,
    pub VersMajor: ::std::os::raw::c_ushort,
    pub VersMinor: ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_TRANSFER_SYNTAX"][::std::mem::size_of::<_RPC_TRANSFER_SYNTAX>() - 20usize];
    ["Alignment of _RPC_TRANSFER_SYNTAX"][::std::mem::align_of::<_RPC_TRANSFER_SYNTAX>() - 4usize];
    ["Offset of field: _RPC_TRANSFER_SYNTAX::Uuid"]
        [::std::mem::offset_of!(_RPC_TRANSFER_SYNTAX, Uuid) - 0usize];
    ["Offset of field: _RPC_TRANSFER_SYNTAX::VersMajor"]
        [::std::mem::offset_of!(_RPC_TRANSFER_SYNTAX, VersMajor) - 16usize];
    ["Offset of field: _RPC_TRANSFER_SYNTAX::VersMinor"]
        [::std::mem::offset_of!(_RPC_TRANSFER_SYNTAX, VersMinor) - 18usize];
};
pub type RPC_TRANSFER_SYNTAX = _RPC_TRANSFER_SYNTAX;
unsafe extern "C" {
    pub fn I_RpcIfInqTransferSyntaxes(
        RpcIfHandle: RPC_IF_HANDLE,
        TransferSyntaxes: *mut RPC_TRANSFER_SYNTAX,
        TransferSyntaxSize: ::std::os::raw::c_uint,
        TransferSyntaxCount: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_UuidCreate(Uuid: *mut UUID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcUninitializeNdrOle();
}
unsafe extern "C" {
    pub fn I_RpcBindingCopy(
        SourceBinding: RPC_BINDING_HANDLE,
        DestinationBinding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingIsClientLocal(
        BindingHandle: RPC_BINDING_HANDLE,
        ClientLocalFlag: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqConnId(
        Binding: RPC_BINDING_HANDLE,
        ConnId: *mut *mut ::std::os::raw::c_void,
        pfFirstCall: *mut ::std::os::raw::c_int,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingCreateNP(
        ServerName: RPC_WSTR,
        ServiceName: RPC_WSTR,
        NetworkOptions: RPC_WSTR,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcSsDontSerializeContext();
}
unsafe extern "C" {
    pub fn I_RpcLaunchDatagramReceiveThread(pAddress: *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerRegisterForwardFunction(
        pForwardFunction: ::std::option::Option<
            unsafe extern "C" fn(
                arg1: *mut UUID,
                arg2: *mut RPC_VERSION,
                arg3: *mut UUID,
                arg4: *mut ::std::os::raw::c_uchar,
                arg5: *mut *mut ::std::os::raw::c_void,
            ) -> RPC_STATUS,
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerInqAddressChangeFn(
    ) -> ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>;
}
unsafe extern "C" {
    pub fn I_RpcServerSetAddressChangeFn(
        pAddressChangeFn: ::std::option::Option<
            unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void),
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerInqLocalConnAddress(
        Binding: RPC_BINDING_HANDLE,
        Buffer: *mut ::std::os::raw::c_void,
        BufferSize: *mut ::std::os::raw::c_ulong,
        AddressFormat: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerInqRemoteConnAddress(
        Binding: RPC_BINDING_HANDLE,
        Buffer: *mut ::std::os::raw::c_void,
        BufferSize: *mut ::std::os::raw::c_ulong,
        AddressFormat: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcSessionStrictContextHandle();
}
unsafe extern "C" {
    pub fn I_RpcTurnOnEEInfoPropagation() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcConnectionInqSockBuffSize(
        RecvBuffSize: *mut ::std::os::raw::c_ulong,
        SendBuffSize: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcConnectionSetSockBuffSize(
        RecvBuffSize: ::std::os::raw::c_ulong,
        SendBuffSize: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
pub type RPCLT_PDU_FILTER_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        Buffer: *mut ::std::os::raw::c_void,
        BufferLength: ::std::os::raw::c_uint,
        fDatagram: ::std::os::raw::c_int,
    ),
>;
pub type RPC_SETFILTER_FUNC =
    ::std::option::Option<unsafe extern "C" fn(pfnFilter: RPCLT_PDU_FILTER_FUNC)>;
unsafe extern "C" {
    pub fn I_RpcServerStartListening(hWnd: *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerStopListening() -> RPC_STATUS;
}
pub type RPC_BLOCKING_FN = ::std::option::Option<
    unsafe extern "C" fn(
        hWnd: *mut ::std::os::raw::c_void,
        Context: *mut ::std::os::raw::c_void,
        hSyncEvent: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS,
>;
unsafe extern "C" {
    pub fn I_RpcBindingSetAsync(
        Binding: RPC_BINDING_HANDLE,
        BlockingFn: RPC_BLOCKING_FN,
        ServerTid: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcSetThreadParams(
        fClientFree: ::std::os::raw::c_int,
        Context: *mut ::std::os::raw::c_void,
        hWndClient: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcWindowProc(
        hWnd: *mut ::std::os::raw::c_void,
        Message: ::std::os::raw::c_uint,
        wParam: ::std::os::raw::c_uint,
        lParam: ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_uint;
}
unsafe extern "C" {
    pub fn I_RpcServerUnregisterEndpointA(Protseq: RPC_CSTR, Endpoint: RPC_CSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUnregisterEndpointW(Protseq: RPC_WSTR, Endpoint: RPC_WSTR) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerInqTransportType(Type: *mut ::std::os::raw::c_uint) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcMapWin32Status(Status: RPC_STATUS) -> ::std::os::raw::c_long;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR {
    pub BufferSize: ::std::os::raw::c_ulong,
    pub Buffer: *mut ::std::os::raw::c_char,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR"]
        [::std::mem::size_of::<_RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR>() - 16usize];
    ["Alignment of _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR"]
        [::std::mem::align_of::<_RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR>() - 8usize];
    ["Offset of field: _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR::BufferSize"]
        [::std::mem::offset_of!(_RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR, BufferSize) - 0usize];
    ["Offset of field: _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR::Buffer"]
        [::std::mem::offset_of!(_RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR, Buffer) - 8usize];
};
pub type RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR = _RPC_C_OPT_COOKIE_AUTH_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RDR_CALLOUT_STATE {
    pub LastError: RPC_STATUS,
    pub LastEEInfo: *mut ::std::os::raw::c_void,
    pub LastCalledStage: RPC_HTTP_REDIRECTOR_STAGE,
    pub ServerName: *mut ::std::os::raw::c_ushort,
    pub ServerPort: *mut ::std::os::raw::c_ushort,
    pub RemoteUser: *mut ::std::os::raw::c_ushort,
    pub AuthType: *mut ::std::os::raw::c_ushort,
    pub ResourceTypePresent: ::std::os::raw::c_uchar,
    pub SessionIdPresent: ::std::os::raw::c_uchar,
    pub InterfacePresent: ::std::os::raw::c_uchar,
    pub ResourceType: UUID,
    pub SessionId: UUID,
    pub Interface: RPC_SYNTAX_IDENTIFIER,
    pub CertContext: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RDR_CALLOUT_STATE"][::std::mem::size_of::<_RDR_CALLOUT_STATE>() - 120usize];
    ["Alignment of _RDR_CALLOUT_STATE"][::std::mem::align_of::<_RDR_CALLOUT_STATE>() - 8usize];
    ["Offset of field: _RDR_CALLOUT_STATE::LastError"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, LastError) - 0usize];
    ["Offset of field: _RDR_CALLOUT_STATE::LastEEInfo"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, LastEEInfo) - 8usize];
    ["Offset of field: _RDR_CALLOUT_STATE::LastCalledStage"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, LastCalledStage) - 16usize];
    ["Offset of field: _RDR_CALLOUT_STATE::ServerName"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, ServerName) - 24usize];
    ["Offset of field: _RDR_CALLOUT_STATE::ServerPort"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, ServerPort) - 32usize];
    ["Offset of field: _RDR_CALLOUT_STATE::RemoteUser"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, RemoteUser) - 40usize];
    ["Offset of field: _RDR_CALLOUT_STATE::AuthType"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, AuthType) - 48usize];
    ["Offset of field: _RDR_CALLOUT_STATE::ResourceTypePresent"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, ResourceTypePresent) - 56usize];
    ["Offset of field: _RDR_CALLOUT_STATE::SessionIdPresent"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, SessionIdPresent) - 57usize];
    ["Offset of field: _RDR_CALLOUT_STATE::InterfacePresent"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, InterfacePresent) - 58usize];
    ["Offset of field: _RDR_CALLOUT_STATE::ResourceType"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, ResourceType) - 60usize];
    ["Offset of field: _RDR_CALLOUT_STATE::SessionId"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, SessionId) - 76usize];
    ["Offset of field: _RDR_CALLOUT_STATE::Interface"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, Interface) - 92usize];
    ["Offset of field: _RDR_CALLOUT_STATE::CertContext"]
        [::std::mem::offset_of!(_RDR_CALLOUT_STATE, CertContext) - 112usize];
};
pub type RDR_CALLOUT_STATE = _RDR_CALLOUT_STATE;
pub type I_RpcProxyIsValidMachineFn = ::std::option::Option<
    unsafe extern "C" fn(
        Machine: RPC_WSTR,
        DotMachine: RPC_WSTR,
        PortNumber: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS,
>;
pub type I_RpcProxyGetClientAddressFn = ::std::option::Option<
    unsafe extern "C" fn(
        Context: *mut ::std::os::raw::c_void,
        Buffer: *mut ::std::os::raw::c_char,
        BufferLength: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS,
>;
pub type I_RpcProxyGetConnectionTimeoutFn = ::std::option::Option<
    unsafe extern "C" fn(ConnectionTimeout: *mut ::std::os::raw::c_ulong) -> RPC_STATUS,
>;
pub type I_RpcPerformCalloutFn = ::std::option::Option<
    unsafe extern "C" fn(
        Context: *mut ::std::os::raw::c_void,
        CallOutState: *mut RDR_CALLOUT_STATE,
        Stage: RPC_HTTP_REDIRECTOR_STAGE,
    ) -> RPC_STATUS,
>;
pub type I_RpcFreeCalloutStateFn =
    ::std::option::Option<unsafe extern "C" fn(CallOutState: *mut RDR_CALLOUT_STATE)>;
pub type I_RpcProxyGetClientSessionAndResourceUUID = ::std::option::Option<
    unsafe extern "C" fn(
        Context: *mut ::std::os::raw::c_void,
        SessionIdPresent: *mut ::std::os::raw::c_int,
        SessionId: *mut UUID,
        ResourceIdPresent: *mut ::std::os::raw::c_int,
        ResourceId: *mut UUID,
    ) -> RPC_STATUS,
>;
pub type I_RpcProxyFilterIfFn = ::std::option::Option<
    unsafe extern "C" fn(
        Context: *mut ::std::os::raw::c_void,
        IfUuid: *mut UUID,
        IfMajorVersion: ::std::os::raw::c_ushort,
        fAllow: *mut ::std::os::raw::c_int,
    ) -> RPC_STATUS,
>;
pub const RpcProxyPerfCounters_RpcCurrentUniqueUser: RpcProxyPerfCounters = 1;
pub const RpcProxyPerfCounters_RpcBackEndConnectionAttempts: RpcProxyPerfCounters = 2;
pub const RpcProxyPerfCounters_RpcBackEndConnectionFailed: RpcProxyPerfCounters = 3;
pub const RpcProxyPerfCounters_RpcRequestsPerSecond: RpcProxyPerfCounters = 4;
pub const RpcProxyPerfCounters_RpcIncomingConnections: RpcProxyPerfCounters = 5;
pub const RpcProxyPerfCounters_RpcIncomingBandwidth: RpcProxyPerfCounters = 6;
pub const RpcProxyPerfCounters_RpcOutgoingBandwidth: RpcProxyPerfCounters = 7;
pub const RpcProxyPerfCounters_RpcAttemptedLbsDecisions: RpcProxyPerfCounters = 8;
pub const RpcProxyPerfCounters_RpcFailedLbsDecisions: RpcProxyPerfCounters = 9;
pub const RpcProxyPerfCounters_RpcAttemptedLbsMessages: RpcProxyPerfCounters = 10;
pub const RpcProxyPerfCounters_RpcFailedLbsMessages: RpcProxyPerfCounters = 11;
pub const RpcProxyPerfCounters_RpcLastCounter: RpcProxyPerfCounters = 12;
pub type RpcProxyPerfCounters = ::std::os::raw::c_int;
pub use self::RpcProxyPerfCounters as RpcPerfCounters;
pub type I_RpcProxyUpdatePerfCounterFn = ::std::option::Option<
    unsafe extern "C" fn(
        Counter: RpcPerfCounters,
        ModifyTrend: ::std::os::raw::c_int,
        Size: ::std::os::raw::c_ulong,
    ),
>;
pub type I_RpcProxyUpdatePerfCounterBackendServerFn = ::std::option::Option<
    unsafe extern "C" fn(
        MachineName: *mut ::std::os::raw::c_ushort,
        IsConnectEvent: ::std::os::raw::c_int,
    ),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagI_RpcProxyCallbackInterface {
    pub IsValidMachineFn: I_RpcProxyIsValidMachineFn,
    pub GetClientAddressFn: I_RpcProxyGetClientAddressFn,
    pub GetConnectionTimeoutFn: I_RpcProxyGetConnectionTimeoutFn,
    pub PerformCalloutFn: I_RpcPerformCalloutFn,
    pub FreeCalloutStateFn: I_RpcFreeCalloutStateFn,
    pub GetClientSessionAndResourceUUIDFn: I_RpcProxyGetClientSessionAndResourceUUID,
    pub ProxyFilterIfFn: I_RpcProxyFilterIfFn,
    pub RpcProxyUpdatePerfCounterFn: I_RpcProxyUpdatePerfCounterFn,
    pub RpcProxyUpdatePerfCounterBackendServerFn: I_RpcProxyUpdatePerfCounterBackendServerFn,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagI_RpcProxyCallbackInterface"]
        [::std::mem::size_of::<tagI_RpcProxyCallbackInterface>() - 72usize];
    ["Alignment of tagI_RpcProxyCallbackInterface"]
        [::std::mem::align_of::<tagI_RpcProxyCallbackInterface>() - 8usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::IsValidMachineFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, IsValidMachineFn) - 0usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::GetClientAddressFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, GetClientAddressFn) - 8usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::GetConnectionTimeoutFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, GetConnectionTimeoutFn) - 16usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::PerformCalloutFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, PerformCalloutFn) - 24usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::FreeCalloutStateFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, FreeCalloutStateFn) - 32usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::GetClientSessionAndResourceUUIDFn"][::std::mem::offset_of!(
        tagI_RpcProxyCallbackInterface,
        GetClientSessionAndResourceUUIDFn
    )
        - 40usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::ProxyFilterIfFn"]
        [::std::mem::offset_of!(tagI_RpcProxyCallbackInterface, ProxyFilterIfFn) - 48usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::RpcProxyUpdatePerfCounterFn"][::std::mem::offset_of!(
        tagI_RpcProxyCallbackInterface,
        RpcProxyUpdatePerfCounterFn
    ) - 56usize];
    ["Offset of field: tagI_RpcProxyCallbackInterface::RpcProxyUpdatePerfCounterBackendServerFn"][::std::mem::offset_of!(
        tagI_RpcProxyCallbackInterface,
        RpcProxyUpdatePerfCounterBackendServerFn
    )
        - 64usize];
};
pub type I_RpcProxyCallbackInterface = tagI_RpcProxyCallbackInterface;
unsafe extern "C" {
    pub fn I_RpcProxyNewConnection(
        ConnectionType: ::std::os::raw::c_ulong,
        ServerAddress: *mut ::std::os::raw::c_ushort,
        ServerPort: *mut ::std::os::raw::c_ushort,
        MinConnTimeout: *mut ::std::os::raw::c_ushort,
        ConnectionParameter: *mut ::std::os::raw::c_void,
        CallOutState: *mut RDR_CALLOUT_STATE,
        ProxyCallbackInterface: *mut I_RpcProxyCallbackInterface,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcReplyToClientWithStatus(
        ConnectionParameter: *mut ::std::os::raw::c_void,
        RpcStatus: RPC_STATUS,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcRecordCalloutFailure(
        RpcStatus: RPC_STATUS,
        CallOutState: *mut RDR_CALLOUT_STATE,
        DllName: *mut ::std::os::raw::c_ushort,
    );
}
unsafe extern "C" {
    pub fn I_RpcMgmtEnableDedicatedThreadPool() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcGetDefaultSD(ppSecurityDescriptor: *mut *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcOpenClientProcess(
        Binding: RPC_BINDING_HANDLE,
        DesiredAccess: ::std::os::raw::c_ulong,
        ClientProcess: *mut *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingIsServerLocal(
        Binding: RPC_BINDING_HANDLE,
        ServerLocalFlag: *mut ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcBindingSetPrivateOption(
        hBinding: RPC_BINDING_HANDLE,
        option: ::std::os::raw::c_ulong,
        optionValue: ULONG_PTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerSubscribeForDisconnectNotification(
        Binding: RPC_BINDING_HANDLE,
        hEvent: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerGetAssociationID(
        Binding: RPC_BINDING_HANDLE,
        AssociationID: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerDisableExceptionFilter() -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn I_RpcServerSubscribeForDisconnectNotification2(
        Binding: RPC_BINDING_HANDLE,
        hEvent: *mut ::std::os::raw::c_void,
        SubscriptionId: *mut UUID,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcServerUnsubscribeForDisconnectNotification(
        Binding: RPC_BINDING_HANDLE,
        SubscriptionId: UUID,
    ) -> RPC_STATUS;
}
pub type RPC_NS_HANDLE = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub fn RpcNsBindingExportA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        BindingVec: *mut RPC_BINDING_VECTOR,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingUnexportA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingExportW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        BindingVec: *mut RPC_BINDING_VECTOR,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingUnexportW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingExportPnPA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectVector: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingUnexportPnPA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectVector: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingExportPnPW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectVector: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingUnexportPnPW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjectVector: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingLookupBeginA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjUuid: *mut UUID,
        BindingMaxCount: ::std::os::raw::c_ulong,
        LookupContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingLookupBeginW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjUuid: *mut UUID,
        BindingMaxCount: ::std::os::raw::c_ulong,
        LookupContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingLookupNext(
        LookupContext: RPC_NS_HANDLE,
        BindingVec: *mut *mut RPC_BINDING_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingLookupDone(LookupContext: *mut RPC_NS_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupDeleteA(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrAddA(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_CSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrRemoveA(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_CSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrInqBeginA(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_CSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrInqNextA(
        InquiryContext: RPC_NS_HANDLE,
        MemberName: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupDeleteW(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrAddW(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_WSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrRemoveW(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_WSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrInqBeginW(
        GroupNameSyntax: ::std::os::raw::c_ulong,
        GroupName: RPC_WSTR,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrInqNextW(
        InquiryContext: RPC_NS_HANDLE,
        MemberName: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsGroupMbrInqDone(InquiryContext: *mut RPC_NS_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileDeleteA(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltAddA(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_CSTR,
        IfId: *mut RPC_IF_ID,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_CSTR,
        Priority: ::std::os::raw::c_ulong,
        Annotation: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltRemoveA(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_CSTR,
        IfId: *mut RPC_IF_ID,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltInqBeginA(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_CSTR,
        InquiryType: ::std::os::raw::c_ulong,
        IfId: *mut RPC_IF_ID,
        VersOption: ::std::os::raw::c_ulong,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_CSTR,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltInqNextA(
        InquiryContext: RPC_NS_HANDLE,
        IfId: *mut RPC_IF_ID,
        MemberName: *mut RPC_CSTR,
        Priority: *mut ::std::os::raw::c_ulong,
        Annotation: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileDeleteW(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltAddW(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_WSTR,
        IfId: *mut RPC_IF_ID,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_WSTR,
        Priority: ::std::os::raw::c_ulong,
        Annotation: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltRemoveW(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_WSTR,
        IfId: *mut RPC_IF_ID,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltInqBeginW(
        ProfileNameSyntax: ::std::os::raw::c_ulong,
        ProfileName: RPC_WSTR,
        InquiryType: ::std::os::raw::c_ulong,
        IfId: *mut RPC_IF_ID,
        VersOption: ::std::os::raw::c_ulong,
        MemberNameSyntax: ::std::os::raw::c_ulong,
        MemberName: RPC_WSTR,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltInqNextW(
        InquiryContext: RPC_NS_HANDLE,
        IfId: *mut RPC_IF_ID,
        MemberName: *mut RPC_WSTR,
        Priority: *mut ::std::os::raw::c_ulong,
        Annotation: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsProfileEltInqDone(InquiryContext: *mut RPC_NS_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryObjectInqBeginA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryObjectInqBeginW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        InquiryContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryObjectInqNext(InquiryContext: RPC_NS_HANDLE, ObjUuid: *mut UUID)
        -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryObjectInqDone(InquiryContext: *mut RPC_NS_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryExpandNameA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        ExpandedName: *mut RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtBindingUnexportA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfId: *mut RPC_IF_ID,
        VersOption: ::std::os::raw::c_ulong,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryCreateA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryDeleteA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryInqIfIdsA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfIdVec: *mut *mut RPC_IF_ID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtHandleSetExpAge(
        NsHandle: RPC_NS_HANDLE,
        ExpirationAge: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtInqExpAge(ExpirationAge: *mut ::std::os::raw::c_ulong) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtSetExpAge(ExpirationAge: ::std::os::raw::c_ulong) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsEntryExpandNameW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        ExpandedName: *mut RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtBindingUnexportW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfId: *mut RPC_IF_ID,
        VersOption: ::std::os::raw::c_ulong,
        ObjectUuidVec: *mut UUID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryCreateW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryDeleteW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsMgmtEntryInqIfIdsW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfIdVec: *mut *mut RPC_IF_ID_VECTOR,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingImportBeginA(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_CSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjUuid: *mut UUID,
        ImportContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingImportBeginW(
        EntryNameSyntax: ::std::os::raw::c_ulong,
        EntryName: RPC_WSTR,
        IfSpec: RPC_IF_HANDLE,
        ObjUuid: *mut UUID,
        ImportContext: *mut RPC_NS_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingImportNext(
        ImportContext: RPC_NS_HANDLE,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingImportDone(ImportContext: *mut RPC_NS_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcNsBindingSelect(
        BindingVec: *mut RPC_BINDING_VECTOR,
        Binding: *mut RPC_BINDING_HANDLE,
    ) -> RPC_STATUS;
}
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeNone: _RPC_NOTIFICATION_TYPES = 0;
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeEvent: _RPC_NOTIFICATION_TYPES = 1;
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeApc: _RPC_NOTIFICATION_TYPES = 2;
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeIoc: _RPC_NOTIFICATION_TYPES = 3;
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeHwnd: _RPC_NOTIFICATION_TYPES = 4;
pub const _RPC_NOTIFICATION_TYPES_RpcNotificationTypeCallback: _RPC_NOTIFICATION_TYPES = 5;
pub type _RPC_NOTIFICATION_TYPES = ::std::os::raw::c_int;
pub use self::_RPC_NOTIFICATION_TYPES as RPC_NOTIFICATION_TYPES;
pub const _RPC_ASYNC_EVENT_RpcCallComplete: _RPC_ASYNC_EVENT = 0;
pub const _RPC_ASYNC_EVENT_RpcSendComplete: _RPC_ASYNC_EVENT = 1;
pub const _RPC_ASYNC_EVENT_RpcReceiveComplete: _RPC_ASYNC_EVENT = 2;
pub const _RPC_ASYNC_EVENT_RpcClientDisconnect: _RPC_ASYNC_EVENT = 3;
pub const _RPC_ASYNC_EVENT_RpcClientCancel: _RPC_ASYNC_EVENT = 4;
pub type _RPC_ASYNC_EVENT = ::std::os::raw::c_int;
pub use self::_RPC_ASYNC_EVENT as RPC_ASYNC_EVENT;
pub type PFN_RPCNOTIFICATION_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut _RPC_ASYNC_STATE,
        arg2: *mut ::std::os::raw::c_void,
        arg3: RPC_ASYNC_EVENT,
    ),
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RPC_ASYNC_NOTIFICATION_INFO {
    pub APC: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1,
    pub IOC: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2,
    pub HWND: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3,
    pub hEvent: HANDLE,
    pub NotificationRoutine: PFN_RPCNOTIFICATION_ROUTINE,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1 {
    pub NotificationRoutine: PFN_RPCNOTIFICATION_ROUTINE,
    pub hThread: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1>() - 16usize];
    ["Alignment of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1::NotificationRoutine"][::std::mem::offset_of!(
        _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1,
        NotificationRoutine
    )
        - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1::hThread"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_1, hThread) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2 {
    pub hIOPort: HANDLE,
    pub dwNumberOfBytesTransferred: DWORD,
    pub dwCompletionKey: DWORD_PTR,
    pub lpOverlapped: LPOVERLAPPED,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2"]
        [::std::mem::size_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2>() - 32usize];
    ["Alignment of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2"]
        [::std::mem::align_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2>() - 8usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2::hIOPort"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2, hIOPort) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2::dwNumberOfBytesTransferred"][::std::mem::offset_of!(
        _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2,
        dwNumberOfBytesTransferred
    )
        - 8usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2::dwCompletionKey"][::std::mem::offset_of!(
        _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2,
        dwCompletionKey
    ) - 16usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2::lpOverlapped"][::std::mem::offset_of!(
        _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_2,
        lpOverlapped
    ) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3 {
    pub hWnd: HWND,
    pub Msg: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3"]
        [::std::mem::size_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3>() - 16usize];
    ["Alignment of _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3"]
        [::std::mem::align_of::<_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3>() - 8usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3::hWnd"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3, hWnd) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3::Msg"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO__bindgen_ty_3, Msg) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_ASYNC_NOTIFICATION_INFO"]
        [::std::mem::size_of::<_RPC_ASYNC_NOTIFICATION_INFO>() - 32usize];
    ["Alignment of _RPC_ASYNC_NOTIFICATION_INFO"]
        [::std::mem::align_of::<_RPC_ASYNC_NOTIFICATION_INFO>() - 8usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO::APC"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO, APC) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO::IOC"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO, IOC) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO::HWND"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO, HWND) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO::hEvent"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO, hEvent) - 0usize];
    ["Offset of field: _RPC_ASYNC_NOTIFICATION_INFO::NotificationRoutine"]
        [::std::mem::offset_of!(_RPC_ASYNC_NOTIFICATION_INFO, NotificationRoutine) - 0usize];
};
pub type RPC_ASYNC_NOTIFICATION_INFO = _RPC_ASYNC_NOTIFICATION_INFO;
pub type PRPC_ASYNC_NOTIFICATION_INFO = *mut _RPC_ASYNC_NOTIFICATION_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RPC_ASYNC_STATE {
    pub Size: ::std::os::raw::c_uint,
    pub Signature: ::std::os::raw::c_ulong,
    pub Lock: ::std::os::raw::c_long,
    pub Flags: ::std::os::raw::c_ulong,
    pub StubInfo: *mut ::std::os::raw::c_void,
    pub UserInfo: *mut ::std::os::raw::c_void,
    pub RuntimeInfo: *mut ::std::os::raw::c_void,
    pub Event: RPC_ASYNC_EVENT,
    pub NotificationType: RPC_NOTIFICATION_TYPES,
    pub u: RPC_ASYNC_NOTIFICATION_INFO,
    pub Reserved: [LONG_PTR; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_ASYNC_STATE"][::std::mem::size_of::<_RPC_ASYNC_STATE>() - 112usize];
    ["Alignment of _RPC_ASYNC_STATE"][::std::mem::align_of::<_RPC_ASYNC_STATE>() - 8usize];
    ["Offset of field: _RPC_ASYNC_STATE::Size"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Size) - 0usize];
    ["Offset of field: _RPC_ASYNC_STATE::Signature"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Signature) - 4usize];
    ["Offset of field: _RPC_ASYNC_STATE::Lock"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Lock) - 8usize];
    ["Offset of field: _RPC_ASYNC_STATE::Flags"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Flags) - 12usize];
    ["Offset of field: _RPC_ASYNC_STATE::StubInfo"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, StubInfo) - 16usize];
    ["Offset of field: _RPC_ASYNC_STATE::UserInfo"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, UserInfo) - 24usize];
    ["Offset of field: _RPC_ASYNC_STATE::RuntimeInfo"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, RuntimeInfo) - 32usize];
    ["Offset of field: _RPC_ASYNC_STATE::Event"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Event) - 40usize];
    ["Offset of field: _RPC_ASYNC_STATE::NotificationType"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, NotificationType) - 44usize];
    ["Offset of field: _RPC_ASYNC_STATE::u"][::std::mem::offset_of!(_RPC_ASYNC_STATE, u) - 48usize];
    ["Offset of field: _RPC_ASYNC_STATE::Reserved"]
        [::std::mem::offset_of!(_RPC_ASYNC_STATE, Reserved) - 80usize];
};
pub type RPC_ASYNC_STATE = _RPC_ASYNC_STATE;
pub type PRPC_ASYNC_STATE = *mut _RPC_ASYNC_STATE;
unsafe extern "C" {
    pub fn RpcAsyncRegisterInfo(pAsync: PRPC_ASYNC_STATE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcAsyncInitializeHandle(
        pAsync: PRPC_ASYNC_STATE,
        Size: ::std::os::raw::c_uint,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcAsyncGetCallStatus(pAsync: PRPC_ASYNC_STATE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcAsyncCompleteCall(
        pAsync: PRPC_ASYNC_STATE,
        Reply: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcAsyncAbortCall(
        pAsync: PRPC_ASYNC_STATE,
        ExceptionCode: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcAsyncCancelCall(pAsync: PRPC_ASYNC_STATE, fAbort: BOOL) -> RPC_STATUS;
}
pub const tagExtendedErrorParamTypes_eeptAnsiString: tagExtendedErrorParamTypes = 1;
pub const tagExtendedErrorParamTypes_eeptUnicodeString: tagExtendedErrorParamTypes = 2;
pub const tagExtendedErrorParamTypes_eeptLongVal: tagExtendedErrorParamTypes = 3;
pub const tagExtendedErrorParamTypes_eeptShortVal: tagExtendedErrorParamTypes = 4;
pub const tagExtendedErrorParamTypes_eeptPointerVal: tagExtendedErrorParamTypes = 5;
pub const tagExtendedErrorParamTypes_eeptNone: tagExtendedErrorParamTypes = 6;
pub const tagExtendedErrorParamTypes_eeptBinary: tagExtendedErrorParamTypes = 7;
pub type tagExtendedErrorParamTypes = ::std::os::raw::c_int;
pub use self::tagExtendedErrorParamTypes as ExtendedErrorParamTypes;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBinaryParam {
    pub Buffer: *mut ::std::os::raw::c_void,
    pub Size: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBinaryParam"][::std::mem::size_of::<tagBinaryParam>() - 16usize];
    ["Alignment of tagBinaryParam"][::std::mem::align_of::<tagBinaryParam>() - 8usize];
    ["Offset of field: tagBinaryParam::Buffer"]
        [::std::mem::offset_of!(tagBinaryParam, Buffer) - 0usize];
    ["Offset of field: tagBinaryParam::Size"]
        [::std::mem::offset_of!(tagBinaryParam, Size) - 8usize];
};
pub type BinaryParam = tagBinaryParam;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagRPC_EE_INFO_PARAM {
    pub ParameterType: ExtendedErrorParamTypes,
    pub u: tagRPC_EE_INFO_PARAM__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagRPC_EE_INFO_PARAM__bindgen_ty_1 {
    pub AnsiString: LPSTR,
    pub UnicodeString: LPWSTR,
    pub LVal: ::std::os::raw::c_long,
    pub SVal: ::std::os::raw::c_short,
    pub PVal: ULONGLONG,
    pub BVal: BinaryParam,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_EE_INFO_PARAM__bindgen_ty_1"]
        [::std::mem::size_of::<tagRPC_EE_INFO_PARAM__bindgen_ty_1>() - 16usize];
    ["Alignment of tagRPC_EE_INFO_PARAM__bindgen_ty_1"]
        [::std::mem::align_of::<tagRPC_EE_INFO_PARAM__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::AnsiString"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, AnsiString) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::UnicodeString"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, UnicodeString) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::LVal"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, LVal) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::SVal"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, SVal) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::PVal"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, PVal) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM__bindgen_ty_1::BVal"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM__bindgen_ty_1, BVal) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_EE_INFO_PARAM"][::std::mem::size_of::<tagRPC_EE_INFO_PARAM>() - 24usize];
    ["Alignment of tagRPC_EE_INFO_PARAM"][::std::mem::align_of::<tagRPC_EE_INFO_PARAM>() - 8usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM::ParameterType"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM, ParameterType) - 0usize];
    ["Offset of field: tagRPC_EE_INFO_PARAM::u"]
        [::std::mem::offset_of!(tagRPC_EE_INFO_PARAM, u) - 8usize];
};
pub type RPC_EE_INFO_PARAM = tagRPC_EE_INFO_PARAM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagRPC_EXTENDED_ERROR_INFO {
    pub Version: ULONG,
    pub ComputerName: LPWSTR,
    pub ProcessID: ULONG,
    pub u: tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1,
    pub GeneratingComponent: ULONG,
    pub Status: ULONG,
    pub DetectionLocation: USHORT,
    pub Flags: USHORT,
    pub NumberOfParameters: ::std::os::raw::c_int,
    pub Parameters: [RPC_EE_INFO_PARAM; 4usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1 {
    pub SystemTime: SYSTEMTIME,
    pub FileTime: FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1>() - 16usize];
    ["Alignment of tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1::SystemTime"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1, SystemTime) - 0usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1::FileTime"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO__bindgen_ty_1, FileTime) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_EXTENDED_ERROR_INFO"]
        [::std::mem::size_of::<tagRPC_EXTENDED_ERROR_INFO>() - 152usize];
    ["Alignment of tagRPC_EXTENDED_ERROR_INFO"]
        [::std::mem::align_of::<tagRPC_EXTENDED_ERROR_INFO>() - 8usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::Version"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, Version) - 0usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::ComputerName"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, ComputerName) - 8usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::ProcessID"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, ProcessID) - 16usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::u"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, u) - 20usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::GeneratingComponent"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, GeneratingComponent) - 36usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::Status"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, Status) - 40usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::DetectionLocation"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, DetectionLocation) - 44usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::Flags"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, Flags) - 46usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::NumberOfParameters"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, NumberOfParameters) - 48usize];
    ["Offset of field: tagRPC_EXTENDED_ERROR_INFO::Parameters"]
        [::std::mem::offset_of!(tagRPC_EXTENDED_ERROR_INFO, Parameters) - 56usize];
};
pub type RPC_EXTENDED_ERROR_INFO = tagRPC_EXTENDED_ERROR_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_ERROR_ENUM_HANDLE {
    pub Signature: ULONG,
    pub CurrentPos: *mut ::std::os::raw::c_void,
    pub Head: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_ERROR_ENUM_HANDLE"]
        [::std::mem::size_of::<tagRPC_ERROR_ENUM_HANDLE>() - 24usize];
    ["Alignment of tagRPC_ERROR_ENUM_HANDLE"]
        [::std::mem::align_of::<tagRPC_ERROR_ENUM_HANDLE>() - 8usize];
    ["Offset of field: tagRPC_ERROR_ENUM_HANDLE::Signature"]
        [::std::mem::offset_of!(tagRPC_ERROR_ENUM_HANDLE, Signature) - 0usize];
    ["Offset of field: tagRPC_ERROR_ENUM_HANDLE::CurrentPos"]
        [::std::mem::offset_of!(tagRPC_ERROR_ENUM_HANDLE, CurrentPos) - 8usize];
    ["Offset of field: tagRPC_ERROR_ENUM_HANDLE::Head"]
        [::std::mem::offset_of!(tagRPC_ERROR_ENUM_HANDLE, Head) - 16usize];
};
pub type RPC_ERROR_ENUM_HANDLE = tagRPC_ERROR_ENUM_HANDLE;
unsafe extern "C" {
    pub fn RpcErrorStartEnumeration(EnumHandle: *mut RPC_ERROR_ENUM_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorGetNextRecord(
        EnumHandle: *mut RPC_ERROR_ENUM_HANDLE,
        CopyStrings: BOOL,
        ErrorInfo: *mut RPC_EXTENDED_ERROR_INFO,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorEndEnumeration(EnumHandle: *mut RPC_ERROR_ENUM_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorResetEnumeration(EnumHandle: *mut RPC_ERROR_ENUM_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorGetNumberOfRecords(
        EnumHandle: *mut RPC_ERROR_ENUM_HANDLE,
        Records: *mut ::std::os::raw::c_int,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorSaveErrorInfo(
        EnumHandle: *mut RPC_ERROR_ENUM_HANDLE,
        ErrorBlob: *mut PVOID,
        BlobSize: *mut usize,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorLoadErrorInfo(
        ErrorBlob: PVOID,
        BlobSize: usize,
        EnumHandle: *mut RPC_ERROR_ENUM_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorAddRecord(ErrorInfo: *mut RPC_EXTENDED_ERROR_INFO) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcErrorClearInformation();
}
unsafe extern "C" {
    pub fn RpcAsyncCleanupThread(dwTimeout: DWORD) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcGetAuthorizationContextForClient(
        ClientBinding: RPC_BINDING_HANDLE,
        ImpersonateOnReturn: BOOL,
        Reserved1: PVOID,
        pExpirationTime: PLARGE_INTEGER,
        Reserved2: LUID,
        Reserved3: DWORD,
        Reserved4: PVOID,
        pAuthzClientContext: *mut PVOID,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcFreeAuthorizationContext(pAuthzClientContext: *mut PVOID) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSsContextLockExclusive(
        ServerBindingHandle: RPC_BINDING_HANDLE,
        UserContext: PVOID,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSsContextLockShared(
        ServerBindingHandle: RPC_BINDING_HANDLE,
        UserContext: PVOID,
    ) -> RPC_STATUS;
}
pub const tagRpcLocalAddressFormat_rlafInvalid: tagRpcLocalAddressFormat = 0;
pub const tagRpcLocalAddressFormat_rlafIPv4: tagRpcLocalAddressFormat = 1;
pub const tagRpcLocalAddressFormat_rlafIPv6: tagRpcLocalAddressFormat = 2;
pub type tagRpcLocalAddressFormat = ::std::os::raw::c_int;
pub use self::tagRpcLocalAddressFormat as RpcLocalAddressFormat;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RPC_CALL_LOCAL_ADDRESS_V1 {
    pub Version: ::std::os::raw::c_uint,
    pub Buffer: *mut ::std::os::raw::c_void,
    pub BufferSize: ::std::os::raw::c_ulong,
    pub AddressFormat: RpcLocalAddressFormat,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RPC_CALL_LOCAL_ADDRESS_V1"]
        [::std::mem::size_of::<_RPC_CALL_LOCAL_ADDRESS_V1>() - 24usize];
    ["Alignment of _RPC_CALL_LOCAL_ADDRESS_V1"]
        [::std::mem::align_of::<_RPC_CALL_LOCAL_ADDRESS_V1>() - 8usize];
    ["Offset of field: _RPC_CALL_LOCAL_ADDRESS_V1::Version"]
        [::std::mem::offset_of!(_RPC_CALL_LOCAL_ADDRESS_V1, Version) - 0usize];
    ["Offset of field: _RPC_CALL_LOCAL_ADDRESS_V1::Buffer"]
        [::std::mem::offset_of!(_RPC_CALL_LOCAL_ADDRESS_V1, Buffer) - 8usize];
    ["Offset of field: _RPC_CALL_LOCAL_ADDRESS_V1::BufferSize"]
        [::std::mem::offset_of!(_RPC_CALL_LOCAL_ADDRESS_V1, BufferSize) - 16usize];
    ["Offset of field: _RPC_CALL_LOCAL_ADDRESS_V1::AddressFormat"]
        [::std::mem::offset_of!(_RPC_CALL_LOCAL_ADDRESS_V1, AddressFormat) - 20usize];
};
pub type RPC_CALL_LOCAL_ADDRESS_V1 = _RPC_CALL_LOCAL_ADDRESS_V1;
pub type PRPC_CALL_LOCAL_ADDRESS_V1 = *mut _RPC_CALL_LOCAL_ADDRESS_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V1_W {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_ushort,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_ushort,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V1_W"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V1_W>() - 56usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V1_W"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V1_W>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V1_W,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V1_W,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_W::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_W, NullSession) - 48usize];
};
pub type RPC_CALL_ATTRIBUTES_V1_W = tagRPC_CALL_ATTRIBUTES_V1_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V1_A {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_uchar,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_uchar,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V1_A"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V1_A>() - 56usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V1_A"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V1_A>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V1_A,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V1_A,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V1_A::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V1_A, NullSession) - 48usize];
};
pub type RPC_CALL_ATTRIBUTES_V1_A = tagRPC_CALL_ATTRIBUTES_V1_A;
pub const tagRpcCallType_rctInvalid: tagRpcCallType = 0;
pub const tagRpcCallType_rctNormal: tagRpcCallType = 1;
pub const tagRpcCallType_rctTraining: tagRpcCallType = 2;
pub const tagRpcCallType_rctGuaranteed: tagRpcCallType = 3;
pub type tagRpcCallType = ::std::os::raw::c_int;
pub use self::tagRpcCallType as RpcCallType;
pub const tagRpcCallClientLocality_rcclInvalid: tagRpcCallClientLocality = 0;
pub const tagRpcCallClientLocality_rcclLocal: tagRpcCallClientLocality = 1;
pub const tagRpcCallClientLocality_rcclRemote: tagRpcCallClientLocality = 2;
pub const tagRpcCallClientLocality_rcclClientUnknownLocality: tagRpcCallClientLocality = 3;
pub type tagRpcCallClientLocality = ::std::os::raw::c_int;
pub use self::tagRpcCallClientLocality as RpcCallClientLocality;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V2_W {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_ushort,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_ushort,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
    pub KernelModeCaller: BOOL,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub IsClientLocal: RpcCallClientLocality,
    pub ClientPID: HANDLE,
    pub CallStatus: ::std::os::raw::c_ulong,
    pub CallType: RpcCallType,
    pub CallLocalAddress: *mut RPC_CALL_LOCAL_ADDRESS_V1,
    pub OpNum: ::std::os::raw::c_ushort,
    pub InterfaceUuid: UUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V2_W"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V2_W>() - 112usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V2_W"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V2_W>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V2_W,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V2_W,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, NullSession) - 48usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::KernelModeCaller"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, KernelModeCaller) - 52usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ProtocolSequence"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, ProtocolSequence) - 56usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::IsClientLocal"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, IsClientLocal) - 60usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::ClientPID"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, ClientPID) - 64usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::CallStatus"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, CallStatus) - 72usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::CallType"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, CallType) - 76usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::CallLocalAddress"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, CallLocalAddress) - 80usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::OpNum"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, OpNum) - 88usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_W::InterfaceUuid"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_W, InterfaceUuid) - 92usize];
};
pub type RPC_CALL_ATTRIBUTES_V2_W = tagRPC_CALL_ATTRIBUTES_V2_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V2_A {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_uchar,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_uchar,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
    pub KernelModeCaller: BOOL,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub IsClientLocal: ::std::os::raw::c_ulong,
    pub ClientPID: HANDLE,
    pub CallStatus: ::std::os::raw::c_ulong,
    pub CallType: RpcCallType,
    pub CallLocalAddress: *mut RPC_CALL_LOCAL_ADDRESS_V1,
    pub OpNum: ::std::os::raw::c_ushort,
    pub InterfaceUuid: UUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V2_A"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V2_A>() - 112usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V2_A"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V2_A>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V2_A,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V2_A,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, NullSession) - 48usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::KernelModeCaller"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, KernelModeCaller) - 52usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ProtocolSequence"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, ProtocolSequence) - 56usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::IsClientLocal"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, IsClientLocal) - 60usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::ClientPID"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, ClientPID) - 64usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::CallStatus"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, CallStatus) - 72usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::CallType"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, CallType) - 76usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::CallLocalAddress"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, CallLocalAddress) - 80usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::OpNum"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, OpNum) - 88usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V2_A::InterfaceUuid"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V2_A, InterfaceUuid) - 92usize];
};
pub type RPC_CALL_ATTRIBUTES_V2_A = tagRPC_CALL_ATTRIBUTES_V2_A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V3_W {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_ushort,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_ushort,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
    pub KernelModeCaller: BOOL,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub IsClientLocal: RpcCallClientLocality,
    pub ClientPID: HANDLE,
    pub CallStatus: ::std::os::raw::c_ulong,
    pub CallType: RpcCallType,
    pub CallLocalAddress: *mut RPC_CALL_LOCAL_ADDRESS_V1,
    pub OpNum: ::std::os::raw::c_ushort,
    pub InterfaceUuid: UUID,
    pub ClientIdentifierBufferLength: ::std::os::raw::c_ulong,
    pub ClientIdentifier: *mut ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V3_W"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V3_W>() - 120usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V3_W"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V3_W>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_W,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_W,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, NullSession) - 48usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::KernelModeCaller"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, KernelModeCaller) - 52usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ProtocolSequence"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, ProtocolSequence) - 56usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::IsClientLocal"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, IsClientLocal) - 60usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ClientPID"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, ClientPID) - 64usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::CallStatus"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, CallStatus) - 72usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::CallType"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, CallType) - 76usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::CallLocalAddress"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, CallLocalAddress) - 80usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::OpNum"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, OpNum) - 88usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::InterfaceUuid"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, InterfaceUuid) - 92usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ClientIdentifierBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_W,
        ClientIdentifierBufferLength
    ) - 108usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_W::ClientIdentifier"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_W, ClientIdentifier) - 112usize];
};
pub type RPC_CALL_ATTRIBUTES_V3_W = tagRPC_CALL_ATTRIBUTES_V3_W;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPC_CALL_ATTRIBUTES_V3_A {
    pub Version: ::std::os::raw::c_uint,
    pub Flags: ::std::os::raw::c_ulong,
    pub ServerPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ServerPrincipalName: *mut ::std::os::raw::c_uchar,
    pub ClientPrincipalNameBufferLength: ::std::os::raw::c_ulong,
    pub ClientPrincipalName: *mut ::std::os::raw::c_uchar,
    pub AuthenticationLevel: ::std::os::raw::c_ulong,
    pub AuthenticationService: ::std::os::raw::c_ulong,
    pub NullSession: BOOL,
    pub KernelModeCaller: BOOL,
    pub ProtocolSequence: ::std::os::raw::c_ulong,
    pub IsClientLocal: ::std::os::raw::c_ulong,
    pub ClientPID: HANDLE,
    pub CallStatus: ::std::os::raw::c_ulong,
    pub CallType: RpcCallType,
    pub CallLocalAddress: *mut RPC_CALL_LOCAL_ADDRESS_V1,
    pub OpNum: ::std::os::raw::c_ushort,
    pub InterfaceUuid: UUID,
    pub ClientIdentifierBufferLength: ::std::os::raw::c_ulong,
    pub ClientIdentifier: *mut ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPC_CALL_ATTRIBUTES_V3_A"]
        [::std::mem::size_of::<tagRPC_CALL_ATTRIBUTES_V3_A>() - 120usize];
    ["Alignment of tagRPC_CALL_ATTRIBUTES_V3_A"]
        [::std::mem::align_of::<tagRPC_CALL_ATTRIBUTES_V3_A>() - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::Version"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, Version) - 0usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::Flags"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, Flags) - 4usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ServerPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_A,
        ServerPrincipalNameBufferLength
    ) - 8usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ServerPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, ServerPrincipalName) - 16usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ClientPrincipalNameBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_A,
        ClientPrincipalNameBufferLength
    ) - 24usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ClientPrincipalName"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, ClientPrincipalName) - 32usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::AuthenticationLevel"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, AuthenticationLevel) - 40usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::AuthenticationService"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, AuthenticationService) - 44usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::NullSession"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, NullSession) - 48usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::KernelModeCaller"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, KernelModeCaller) - 52usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ProtocolSequence"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, ProtocolSequence) - 56usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::IsClientLocal"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, IsClientLocal) - 60usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ClientPID"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, ClientPID) - 64usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::CallStatus"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, CallStatus) - 72usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::CallType"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, CallType) - 76usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::CallLocalAddress"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, CallLocalAddress) - 80usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::OpNum"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, OpNum) - 88usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::InterfaceUuid"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, InterfaceUuid) - 92usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ClientIdentifierBufferLength"][::std::mem::offset_of!(
        tagRPC_CALL_ATTRIBUTES_V3_A,
        ClientIdentifierBufferLength
    ) - 108usize];
    ["Offset of field: tagRPC_CALL_ATTRIBUTES_V3_A::ClientIdentifier"]
        [::std::mem::offset_of!(tagRPC_CALL_ATTRIBUTES_V3_A, ClientIdentifier) - 112usize];
};
pub type RPC_CALL_ATTRIBUTES_V3_A = tagRPC_CALL_ATTRIBUTES_V3_A;
unsafe extern "C" {
    pub fn RpcServerInqCallAttributesW(
        ClientBinding: RPC_BINDING_HANDLE,
        RpcCallAttributes: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerInqCallAttributesA(
        ClientBinding: RPC_BINDING_HANDLE,
        RpcCallAttributes: *mut ::std::os::raw::c_void,
    ) -> RPC_STATUS;
}
pub type RPC_CALL_ATTRIBUTES = RPC_CALL_ATTRIBUTES_V3_A;
pub const _RPC_NOTIFICATIONS_RpcNotificationCallNone: _RPC_NOTIFICATIONS = 0;
pub const _RPC_NOTIFICATIONS_RpcNotificationClientDisconnect: _RPC_NOTIFICATIONS = 1;
pub const _RPC_NOTIFICATIONS_RpcNotificationCallCancel: _RPC_NOTIFICATIONS = 2;
pub type _RPC_NOTIFICATIONS = ::std::os::raw::c_int;
pub use self::_RPC_NOTIFICATIONS as RPC_NOTIFICATIONS;
unsafe extern "C" {
    pub fn RpcServerSubscribeForNotification(
        Binding: RPC_BINDING_HANDLE,
        Notification: RPC_NOTIFICATIONS,
        NotificationType: RPC_NOTIFICATION_TYPES,
        NotificationInfo: *mut RPC_ASYNC_NOTIFICATION_INFO,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcServerUnsubscribeForNotification(
        Binding: RPC_BINDING_HANDLE,
        Notification: RPC_NOTIFICATIONS,
        NotificationsQueued: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingBind(
        pAsync: PRPC_ASYNC_STATE,
        Binding: RPC_BINDING_HANDLE,
        IfSpec: RPC_IF_HANDLE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcBindingUnbind(Binding: RPC_BINDING_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcAsyncSetHandle(Message: PRPC_MESSAGE, pAsync: PRPC_ASYNC_STATE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcAsyncAbortCall(
        pAsync: PRPC_ASYNC_STATE,
        ExceptionCode: ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcExceptionFilter(ExceptionCode: ::std::os::raw::c_ulong) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn I_RpcBindingInqClientTokenAttributes(
        Binding: RPC_BINDING_HANDLE,
        TokenId: *mut LUID,
        AuthenticationId: *mut LUID,
        ModifiedId: *mut LUID,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn CommandLineToArgvW(
        lpCmdLine: LPCWSTR,
        pNumArgs: *mut ::std::os::raw::c_int,
    ) -> *mut LPWSTR;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HDROP__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HDROP__"][::std::mem::size_of::<HDROP__>() - 4usize];
    ["Alignment of HDROP__"][::std::mem::align_of::<HDROP__>() - 4usize];
    ["Offset of field: HDROP__::unused"][::std::mem::offset_of!(HDROP__, unused) - 0usize];
};
pub type HDROP = *mut HDROP__;
unsafe extern "C" {
    pub fn DragQueryFileA(hDrop: HDROP, iFile: UINT, lpszFile: LPSTR, cch: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn DragQueryFileW(hDrop: HDROP, iFile: UINT, lpszFile: LPWSTR, cch: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn DragQueryPoint(hDrop: HDROP, ppt: *mut POINT) -> BOOL;
}
unsafe extern "C" {
    pub fn DragFinish(hDrop: HDROP);
}
unsafe extern "C" {
    pub fn DragAcceptFiles(hWnd: HWND, fAccept: BOOL);
}
unsafe extern "C" {
    pub fn ShellExecuteA(
        hwnd: HWND,
        lpOperation: LPCSTR,
        lpFile: LPCSTR,
        lpParameters: LPCSTR,
        lpDirectory: LPCSTR,
        nShowCmd: INT,
    ) -> HINSTANCE;
}
unsafe extern "C" {
    pub fn ShellExecuteW(
        hwnd: HWND,
        lpOperation: LPCWSTR,
        lpFile: LPCWSTR,
        lpParameters: LPCWSTR,
        lpDirectory: LPCWSTR,
        nShowCmd: INT,
    ) -> HINSTANCE;
}
unsafe extern "C" {
    pub fn FindExecutableA(lpFile: LPCSTR, lpDirectory: LPCSTR, lpResult: LPSTR) -> HINSTANCE;
}
unsafe extern "C" {
    pub fn FindExecutableW(lpFile: LPCWSTR, lpDirectory: LPCWSTR, lpResult: LPWSTR) -> HINSTANCE;
}
unsafe extern "C" {
    pub fn ShellAboutA(hWnd: HWND, szApp: LPCSTR, szOtherStuff: LPCSTR, hIcon: HICON) -> INT;
}
unsafe extern "C" {
    pub fn ShellAboutW(hWnd: HWND, szApp: LPCWSTR, szOtherStuff: LPCWSTR, hIcon: HICON) -> INT;
}
unsafe extern "C" {
    pub fn DuplicateIcon(hInst: HINSTANCE, hIcon: HICON) -> HICON;
}
unsafe extern "C" {
    pub fn ExtractAssociatedIconA(hInst: HINSTANCE, pszIconPath: LPSTR, piIcon: *mut WORD)
        -> HICON;
}
unsafe extern "C" {
    pub fn ExtractAssociatedIconW(
        hInst: HINSTANCE,
        pszIconPath: LPWSTR,
        piIcon: *mut WORD,
    ) -> HICON;
}
unsafe extern "C" {
    pub fn ExtractAssociatedIconExA(
        hInst: HINSTANCE,
        pszIconPath: LPSTR,
        piIconIndex: *mut WORD,
        piIconId: *mut WORD,
    ) -> HICON;
}
unsafe extern "C" {
    pub fn ExtractAssociatedIconExW(
        hInst: HINSTANCE,
        pszIconPath: LPWSTR,
        piIconIndex: *mut WORD,
        piIconId: *mut WORD,
    ) -> HICON;
}
unsafe extern "C" {
    pub fn ExtractIconA(hInst: HINSTANCE, pszExeFileName: LPCSTR, nIconIndex: UINT) -> HICON;
}
unsafe extern "C" {
    pub fn ExtractIconW(hInst: HINSTANCE, pszExeFileName: LPCWSTR, nIconIndex: UINT) -> HICON;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRAGINFOA {
    pub uSize: UINT,
    pub pt: POINT,
    pub fNC: BOOL,
    pub lpFileList: PZZSTR,
    pub grfKeyState: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRAGINFOA"][::std::mem::size_of::<_DRAGINFOA>() - 32usize];
    ["Alignment of _DRAGINFOA"][::std::mem::align_of::<_DRAGINFOA>() - 8usize];
    ["Offset of field: _DRAGINFOA::uSize"][::std::mem::offset_of!(_DRAGINFOA, uSize) - 0usize];
    ["Offset of field: _DRAGINFOA::pt"][::std::mem::offset_of!(_DRAGINFOA, pt) - 4usize];
    ["Offset of field: _DRAGINFOA::fNC"][::std::mem::offset_of!(_DRAGINFOA, fNC) - 12usize];
    ["Offset of field: _DRAGINFOA::lpFileList"]
        [::std::mem::offset_of!(_DRAGINFOA, lpFileList) - 16usize];
    ["Offset of field: _DRAGINFOA::grfKeyState"]
        [::std::mem::offset_of!(_DRAGINFOA, grfKeyState) - 24usize];
};
pub type DRAGINFOA = _DRAGINFOA;
pub type LPDRAGINFOA = *mut _DRAGINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRAGINFOW {
    pub uSize: UINT,
    pub pt: POINT,
    pub fNC: BOOL,
    pub lpFileList: PZZWSTR,
    pub grfKeyState: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRAGINFOW"][::std::mem::size_of::<_DRAGINFOW>() - 32usize];
    ["Alignment of _DRAGINFOW"][::std::mem::align_of::<_DRAGINFOW>() - 8usize];
    ["Offset of field: _DRAGINFOW::uSize"][::std::mem::offset_of!(_DRAGINFOW, uSize) - 0usize];
    ["Offset of field: _DRAGINFOW::pt"][::std::mem::offset_of!(_DRAGINFOW, pt) - 4usize];
    ["Offset of field: _DRAGINFOW::fNC"][::std::mem::offset_of!(_DRAGINFOW, fNC) - 12usize];
    ["Offset of field: _DRAGINFOW::lpFileList"]
        [::std::mem::offset_of!(_DRAGINFOW, lpFileList) - 16usize];
    ["Offset of field: _DRAGINFOW::grfKeyState"]
        [::std::mem::offset_of!(_DRAGINFOW, grfKeyState) - 24usize];
};
pub type DRAGINFOW = _DRAGINFOW;
pub type LPDRAGINFOW = *mut _DRAGINFOW;
pub type DRAGINFO = DRAGINFOA;
pub type LPDRAGINFO = LPDRAGINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _AppBarData {
    pub cbSize: DWORD,
    pub hWnd: HWND,
    pub uCallbackMessage: UINT,
    pub uEdge: UINT,
    pub rc: RECT,
    pub lParam: LPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _AppBarData"][::std::mem::size_of::<_AppBarData>() - 48usize];
    ["Alignment of _AppBarData"][::std::mem::align_of::<_AppBarData>() - 8usize];
    ["Offset of field: _AppBarData::cbSize"][::std::mem::offset_of!(_AppBarData, cbSize) - 0usize];
    ["Offset of field: _AppBarData::hWnd"][::std::mem::offset_of!(_AppBarData, hWnd) - 8usize];
    ["Offset of field: _AppBarData::uCallbackMessage"]
        [::std::mem::offset_of!(_AppBarData, uCallbackMessage) - 16usize];
    ["Offset of field: _AppBarData::uEdge"][::std::mem::offset_of!(_AppBarData, uEdge) - 20usize];
    ["Offset of field: _AppBarData::rc"][::std::mem::offset_of!(_AppBarData, rc) - 24usize];
    ["Offset of field: _AppBarData::lParam"][::std::mem::offset_of!(_AppBarData, lParam) - 40usize];
};
pub type APPBARDATA = _AppBarData;
pub type PAPPBARDATA = *mut _AppBarData;
unsafe extern "C" {
    pub fn SHAppBarMessage(dwMessage: DWORD, pData: PAPPBARDATA) -> UINT_PTR;
}
unsafe extern "C" {
    pub fn DoEnvironmentSubstA(pszSrc: LPSTR, cchSrc: UINT) -> DWORD;
}
unsafe extern "C" {
    pub fn DoEnvironmentSubstW(pszSrc: LPWSTR, cchSrc: UINT) -> DWORD;
}
unsafe extern "C" {
    pub fn ExtractIconExA(
        lpszFile: LPCSTR,
        nIconIndex: ::std::os::raw::c_int,
        phiconLarge: *mut HICON,
        phiconSmall: *mut HICON,
        nIcons: UINT,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn ExtractIconExW(
        lpszFile: LPCWSTR,
        nIconIndex: ::std::os::raw::c_int,
        phiconLarge: *mut HICON,
        phiconSmall: *mut HICON,
        nIcons: UINT,
    ) -> UINT;
}
pub type FILEOP_FLAGS = WORD;
pub type PRINTEROP_FLAGS = WORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHFILEOPSTRUCTA {
    pub hwnd: HWND,
    pub wFunc: UINT,
    pub pFrom: PCZZSTR,
    pub pTo: PCZZSTR,
    pub fFlags: FILEOP_FLAGS,
    pub fAnyOperationsAborted: BOOL,
    pub hNameMappings: LPVOID,
    pub lpszProgressTitle: PCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHFILEOPSTRUCTA"][::std::mem::size_of::<_SHFILEOPSTRUCTA>() - 56usize];
    ["Alignment of _SHFILEOPSTRUCTA"][::std::mem::align_of::<_SHFILEOPSTRUCTA>() - 8usize];
    ["Offset of field: _SHFILEOPSTRUCTA::hwnd"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, hwnd) - 0usize];
    ["Offset of field: _SHFILEOPSTRUCTA::wFunc"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, wFunc) - 8usize];
    ["Offset of field: _SHFILEOPSTRUCTA::pFrom"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, pFrom) - 16usize];
    ["Offset of field: _SHFILEOPSTRUCTA::pTo"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, pTo) - 24usize];
    ["Offset of field: _SHFILEOPSTRUCTA::fFlags"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, fFlags) - 32usize];
    ["Offset of field: _SHFILEOPSTRUCTA::fAnyOperationsAborted"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, fAnyOperationsAborted) - 36usize];
    ["Offset of field: _SHFILEOPSTRUCTA::hNameMappings"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, hNameMappings) - 40usize];
    ["Offset of field: _SHFILEOPSTRUCTA::lpszProgressTitle"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTA, lpszProgressTitle) - 48usize];
};
pub type SHFILEOPSTRUCTA = _SHFILEOPSTRUCTA;
pub type LPSHFILEOPSTRUCTA = *mut _SHFILEOPSTRUCTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHFILEOPSTRUCTW {
    pub hwnd: HWND,
    pub wFunc: UINT,
    pub pFrom: PCZZWSTR,
    pub pTo: PCZZWSTR,
    pub fFlags: FILEOP_FLAGS,
    pub fAnyOperationsAborted: BOOL,
    pub hNameMappings: LPVOID,
    pub lpszProgressTitle: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHFILEOPSTRUCTW"][::std::mem::size_of::<_SHFILEOPSTRUCTW>() - 56usize];
    ["Alignment of _SHFILEOPSTRUCTW"][::std::mem::align_of::<_SHFILEOPSTRUCTW>() - 8usize];
    ["Offset of field: _SHFILEOPSTRUCTW::hwnd"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, hwnd) - 0usize];
    ["Offset of field: _SHFILEOPSTRUCTW::wFunc"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, wFunc) - 8usize];
    ["Offset of field: _SHFILEOPSTRUCTW::pFrom"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, pFrom) - 16usize];
    ["Offset of field: _SHFILEOPSTRUCTW::pTo"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, pTo) - 24usize];
    ["Offset of field: _SHFILEOPSTRUCTW::fFlags"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, fFlags) - 32usize];
    ["Offset of field: _SHFILEOPSTRUCTW::fAnyOperationsAborted"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, fAnyOperationsAborted) - 36usize];
    ["Offset of field: _SHFILEOPSTRUCTW::hNameMappings"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, hNameMappings) - 40usize];
    ["Offset of field: _SHFILEOPSTRUCTW::lpszProgressTitle"]
        [::std::mem::offset_of!(_SHFILEOPSTRUCTW, lpszProgressTitle) - 48usize];
};
pub type SHFILEOPSTRUCTW = _SHFILEOPSTRUCTW;
pub type LPSHFILEOPSTRUCTW = *mut _SHFILEOPSTRUCTW;
pub type SHFILEOPSTRUCT = SHFILEOPSTRUCTA;
pub type LPSHFILEOPSTRUCT = LPSHFILEOPSTRUCTA;
unsafe extern "C" {
    pub fn SHFileOperationA(lpFileOp: LPSHFILEOPSTRUCTA) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SHFileOperationW(lpFileOp: LPSHFILEOPSTRUCTW) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn SHFreeNameMappings(hNameMappings: HANDLE);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHNAMEMAPPINGA {
    pub pszOldPath: LPSTR,
    pub pszNewPath: LPSTR,
    pub cchOldPath: ::std::os::raw::c_int,
    pub cchNewPath: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHNAMEMAPPINGA"][::std::mem::size_of::<_SHNAMEMAPPINGA>() - 24usize];
    ["Alignment of _SHNAMEMAPPINGA"][::std::mem::align_of::<_SHNAMEMAPPINGA>() - 8usize];
    ["Offset of field: _SHNAMEMAPPINGA::pszOldPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGA, pszOldPath) - 0usize];
    ["Offset of field: _SHNAMEMAPPINGA::pszNewPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGA, pszNewPath) - 8usize];
    ["Offset of field: _SHNAMEMAPPINGA::cchOldPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGA, cchOldPath) - 16usize];
    ["Offset of field: _SHNAMEMAPPINGA::cchNewPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGA, cchNewPath) - 20usize];
};
pub type SHNAMEMAPPINGA = _SHNAMEMAPPINGA;
pub type LPSHNAMEMAPPINGA = *mut _SHNAMEMAPPINGA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHNAMEMAPPINGW {
    pub pszOldPath: LPWSTR,
    pub pszNewPath: LPWSTR,
    pub cchOldPath: ::std::os::raw::c_int,
    pub cchNewPath: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHNAMEMAPPINGW"][::std::mem::size_of::<_SHNAMEMAPPINGW>() - 24usize];
    ["Alignment of _SHNAMEMAPPINGW"][::std::mem::align_of::<_SHNAMEMAPPINGW>() - 8usize];
    ["Offset of field: _SHNAMEMAPPINGW::pszOldPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGW, pszOldPath) - 0usize];
    ["Offset of field: _SHNAMEMAPPINGW::pszNewPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGW, pszNewPath) - 8usize];
    ["Offset of field: _SHNAMEMAPPINGW::cchOldPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGW, cchOldPath) - 16usize];
    ["Offset of field: _SHNAMEMAPPINGW::cchNewPath"]
        [::std::mem::offset_of!(_SHNAMEMAPPINGW, cchNewPath) - 20usize];
};
pub type SHNAMEMAPPINGW = _SHNAMEMAPPINGW;
pub type LPSHNAMEMAPPINGW = *mut _SHNAMEMAPPINGW;
pub type SHNAMEMAPPING = SHNAMEMAPPINGA;
pub type LPSHNAMEMAPPING = LPSHNAMEMAPPINGA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SHELLEXECUTEINFOA {
    pub cbSize: DWORD,
    pub fMask: ULONG,
    pub hwnd: HWND,
    pub lpVerb: LPCSTR,
    pub lpFile: LPCSTR,
    pub lpParameters: LPCSTR,
    pub lpDirectory: LPCSTR,
    pub nShow: ::std::os::raw::c_int,
    pub hInstApp: HINSTANCE,
    pub lpIDList: *mut ::std::os::raw::c_void,
    pub lpClass: LPCSTR,
    pub hkeyClass: HKEY,
    pub dwHotKey: DWORD,
    pub __bindgen_anon_1: _SHELLEXECUTEINFOA__bindgen_ty_1,
    pub hProcess: HANDLE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SHELLEXECUTEINFOA__bindgen_ty_1 {
    pub hIcon: HANDLE,
    pub hMonitor: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHELLEXECUTEINFOA__bindgen_ty_1"]
        [::std::mem::size_of::<_SHELLEXECUTEINFOA__bindgen_ty_1>() - 8usize];
    ["Alignment of _SHELLEXECUTEINFOA__bindgen_ty_1"]
        [::std::mem::align_of::<_SHELLEXECUTEINFOA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOA__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _SHELLEXECUTEINFOA__bindgen_ty_1::hMonitor"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA__bindgen_ty_1, hMonitor) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHELLEXECUTEINFOA"][::std::mem::size_of::<_SHELLEXECUTEINFOA>() - 112usize];
    ["Alignment of _SHELLEXECUTEINFOA"][::std::mem::align_of::<_SHELLEXECUTEINFOA>() - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOA::cbSize"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, cbSize) - 0usize];
    ["Offset of field: _SHELLEXECUTEINFOA::fMask"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, fMask) - 4usize];
    ["Offset of field: _SHELLEXECUTEINFOA::hwnd"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, hwnd) - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpVerb"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpVerb) - 16usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpFile"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpFile) - 24usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpParameters"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpParameters) - 32usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpDirectory"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpDirectory) - 40usize];
    ["Offset of field: _SHELLEXECUTEINFOA::nShow"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, nShow) - 48usize];
    ["Offset of field: _SHELLEXECUTEINFOA::hInstApp"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, hInstApp) - 56usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpIDList"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpIDList) - 64usize];
    ["Offset of field: _SHELLEXECUTEINFOA::lpClass"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, lpClass) - 72usize];
    ["Offset of field: _SHELLEXECUTEINFOA::hkeyClass"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, hkeyClass) - 80usize];
    ["Offset of field: _SHELLEXECUTEINFOA::dwHotKey"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, dwHotKey) - 88usize];
    ["Offset of field: _SHELLEXECUTEINFOA::hProcess"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOA, hProcess) - 104usize];
};
pub type SHELLEXECUTEINFOA = _SHELLEXECUTEINFOA;
pub type LPSHELLEXECUTEINFOA = *mut _SHELLEXECUTEINFOA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SHELLEXECUTEINFOW {
    pub cbSize: DWORD,
    pub fMask: ULONG,
    pub hwnd: HWND,
    pub lpVerb: LPCWSTR,
    pub lpFile: LPCWSTR,
    pub lpParameters: LPCWSTR,
    pub lpDirectory: LPCWSTR,
    pub nShow: ::std::os::raw::c_int,
    pub hInstApp: HINSTANCE,
    pub lpIDList: *mut ::std::os::raw::c_void,
    pub lpClass: LPCWSTR,
    pub hkeyClass: HKEY,
    pub dwHotKey: DWORD,
    pub __bindgen_anon_1: _SHELLEXECUTEINFOW__bindgen_ty_1,
    pub hProcess: HANDLE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SHELLEXECUTEINFOW__bindgen_ty_1 {
    pub hIcon: HANDLE,
    pub hMonitor: HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHELLEXECUTEINFOW__bindgen_ty_1"]
        [::std::mem::size_of::<_SHELLEXECUTEINFOW__bindgen_ty_1>() - 8usize];
    ["Alignment of _SHELLEXECUTEINFOW__bindgen_ty_1"]
        [::std::mem::align_of::<_SHELLEXECUTEINFOW__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOW__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _SHELLEXECUTEINFOW__bindgen_ty_1::hMonitor"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW__bindgen_ty_1, hMonitor) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHELLEXECUTEINFOW"][::std::mem::size_of::<_SHELLEXECUTEINFOW>() - 112usize];
    ["Alignment of _SHELLEXECUTEINFOW"][::std::mem::align_of::<_SHELLEXECUTEINFOW>() - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOW::cbSize"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, cbSize) - 0usize];
    ["Offset of field: _SHELLEXECUTEINFOW::fMask"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, fMask) - 4usize];
    ["Offset of field: _SHELLEXECUTEINFOW::hwnd"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, hwnd) - 8usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpVerb"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpVerb) - 16usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpFile"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpFile) - 24usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpParameters"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpParameters) - 32usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpDirectory"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpDirectory) - 40usize];
    ["Offset of field: _SHELLEXECUTEINFOW::nShow"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, nShow) - 48usize];
    ["Offset of field: _SHELLEXECUTEINFOW::hInstApp"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, hInstApp) - 56usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpIDList"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpIDList) - 64usize];
    ["Offset of field: _SHELLEXECUTEINFOW::lpClass"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, lpClass) - 72usize];
    ["Offset of field: _SHELLEXECUTEINFOW::hkeyClass"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, hkeyClass) - 80usize];
    ["Offset of field: _SHELLEXECUTEINFOW::dwHotKey"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, dwHotKey) - 88usize];
    ["Offset of field: _SHELLEXECUTEINFOW::hProcess"]
        [::std::mem::offset_of!(_SHELLEXECUTEINFOW, hProcess) - 104usize];
};
pub type SHELLEXECUTEINFOW = _SHELLEXECUTEINFOW;
pub type LPSHELLEXECUTEINFOW = *mut _SHELLEXECUTEINFOW;
pub type SHELLEXECUTEINFO = SHELLEXECUTEINFOA;
pub type LPSHELLEXECUTEINFO = LPSHELLEXECUTEINFOA;
unsafe extern "C" {
    pub fn ShellExecuteExA(pExecInfo: *mut SHELLEXECUTEINFOA) -> BOOL;
}
unsafe extern "C" {
    pub fn ShellExecuteExW(pExecInfo: *mut SHELLEXECUTEINFOW) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHCREATEPROCESSINFOW {
    pub cbSize: DWORD,
    pub fMask: ULONG,
    pub hwnd: HWND,
    pub pszFile: LPCWSTR,
    pub pszParameters: LPCWSTR,
    pub pszCurrentDirectory: LPCWSTR,
    pub hUserToken: HANDLE,
    pub lpProcessAttributes: LPSECURITY_ATTRIBUTES,
    pub lpThreadAttributes: LPSECURITY_ATTRIBUTES,
    pub bInheritHandles: BOOL,
    pub dwCreationFlags: DWORD,
    pub lpStartupInfo: LPSTARTUPINFOW,
    pub lpProcessInformation: LPPROCESS_INFORMATION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHCREATEPROCESSINFOW"][::std::mem::size_of::<_SHCREATEPROCESSINFOW>() - 88usize];
    ["Alignment of _SHCREATEPROCESSINFOW"]
        [::std::mem::align_of::<_SHCREATEPROCESSINFOW>() - 8usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::cbSize"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, cbSize) - 0usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::fMask"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, fMask) - 4usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::hwnd"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, hwnd) - 8usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::pszFile"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, pszFile) - 16usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::pszParameters"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, pszParameters) - 24usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::pszCurrentDirectory"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, pszCurrentDirectory) - 32usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::hUserToken"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, hUserToken) - 40usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::lpProcessAttributes"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, lpProcessAttributes) - 48usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::lpThreadAttributes"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, lpThreadAttributes) - 56usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::bInheritHandles"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, bInheritHandles) - 64usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::dwCreationFlags"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, dwCreationFlags) - 68usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::lpStartupInfo"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, lpStartupInfo) - 72usize];
    ["Offset of field: _SHCREATEPROCESSINFOW::lpProcessInformation"]
        [::std::mem::offset_of!(_SHCREATEPROCESSINFOW, lpProcessInformation) - 80usize];
};
pub type SHCREATEPROCESSINFOW = _SHCREATEPROCESSINFOW;
pub type PSHCREATEPROCESSINFOW = *mut _SHCREATEPROCESSINFOW;
unsafe extern "C" {
    pub fn SHCreateProcessAsUserW(pscpi: PSHCREATEPROCESSINFOW) -> BOOL;
}
unsafe extern "C" {
    pub fn SHEvaluateSystemCommandTemplate(
        pszCmdTemplate: PCWSTR,
        ppszApplication: *mut PWSTR,
        ppszCommandLine: *mut PWSTR,
        ppszParameters: *mut PWSTR,
    ) -> HRESULT;
}
pub const ASSOCCLASS_ASSOCCLASS_SHELL_KEY: ASSOCCLASS = 0;
pub const ASSOCCLASS_ASSOCCLASS_PROGID_KEY: ASSOCCLASS = 1;
pub const ASSOCCLASS_ASSOCCLASS_PROGID_STR: ASSOCCLASS = 2;
pub const ASSOCCLASS_ASSOCCLASS_CLSID_KEY: ASSOCCLASS = 3;
pub const ASSOCCLASS_ASSOCCLASS_CLSID_STR: ASSOCCLASS = 4;
pub const ASSOCCLASS_ASSOCCLASS_APP_KEY: ASSOCCLASS = 5;
pub const ASSOCCLASS_ASSOCCLASS_APP_STR: ASSOCCLASS = 6;
pub const ASSOCCLASS_ASSOCCLASS_SYSTEM_STR: ASSOCCLASS = 7;
pub const ASSOCCLASS_ASSOCCLASS_FOLDER: ASSOCCLASS = 8;
pub const ASSOCCLASS_ASSOCCLASS_STAR: ASSOCCLASS = 9;
pub const ASSOCCLASS_ASSOCCLASS_FIXED_PROGID_STR: ASSOCCLASS = 10;
pub const ASSOCCLASS_ASSOCCLASS_PROTOCOL_STR: ASSOCCLASS = 11;
pub type ASSOCCLASS = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ASSOCIATIONELEMENT {
    pub ac: ASSOCCLASS,
    pub hkClass: HKEY,
    pub pszClass: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ASSOCIATIONELEMENT"][::std::mem::size_of::<ASSOCIATIONELEMENT>() - 24usize];
    ["Alignment of ASSOCIATIONELEMENT"][::std::mem::align_of::<ASSOCIATIONELEMENT>() - 8usize];
    ["Offset of field: ASSOCIATIONELEMENT::ac"]
        [::std::mem::offset_of!(ASSOCIATIONELEMENT, ac) - 0usize];
    ["Offset of field: ASSOCIATIONELEMENT::hkClass"]
        [::std::mem::offset_of!(ASSOCIATIONELEMENT, hkClass) - 8usize];
    ["Offset of field: ASSOCIATIONELEMENT::pszClass"]
        [::std::mem::offset_of!(ASSOCIATIONELEMENT, pszClass) - 16usize];
};
unsafe extern "C" {
    pub fn AssocCreateForClasses(
        rgClasses: *const ASSOCIATIONELEMENT,
        cClasses: ULONG,
        riid: *const IID,
        ppv: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHQUERYRBINFO {
    pub cbSize: DWORD,
    pub i64Size: ::std::os::raw::c_longlong,
    pub i64NumItems: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHQUERYRBINFO"][::std::mem::size_of::<_SHQUERYRBINFO>() - 24usize];
    ["Alignment of _SHQUERYRBINFO"][::std::mem::align_of::<_SHQUERYRBINFO>() - 8usize];
    ["Offset of field: _SHQUERYRBINFO::cbSize"]
        [::std::mem::offset_of!(_SHQUERYRBINFO, cbSize) - 0usize];
    ["Offset of field: _SHQUERYRBINFO::i64Size"]
        [::std::mem::offset_of!(_SHQUERYRBINFO, i64Size) - 8usize];
    ["Offset of field: _SHQUERYRBINFO::i64NumItems"]
        [::std::mem::offset_of!(_SHQUERYRBINFO, i64NumItems) - 16usize];
};
pub type SHQUERYRBINFO = _SHQUERYRBINFO;
pub type LPSHQUERYRBINFO = *mut _SHQUERYRBINFO;
unsafe extern "C" {
    pub fn SHQueryRecycleBinA(pszRootPath: LPCSTR, pSHQueryRBInfo: LPSHQUERYRBINFO) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHQueryRecycleBinW(pszRootPath: LPCWSTR, pSHQueryRBInfo: LPSHQUERYRBINFO) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHEmptyRecycleBinA(hwnd: HWND, pszRootPath: LPCSTR, dwFlags: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHEmptyRecycleBinW(hwnd: HWND, pszRootPath: LPCWSTR, dwFlags: DWORD) -> HRESULT;
}
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_NOT_PRESENT: QUERY_USER_NOTIFICATION_STATE = 1;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_BUSY: QUERY_USER_NOTIFICATION_STATE = 2;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_RUNNING_D3D_FULL_SCREEN:
    QUERY_USER_NOTIFICATION_STATE = 3;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_PRESENTATION_MODE: QUERY_USER_NOTIFICATION_STATE = 4;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_ACCEPTS_NOTIFICATIONS: QUERY_USER_NOTIFICATION_STATE =
    5;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_QUIET_TIME: QUERY_USER_NOTIFICATION_STATE = 6;
pub const QUERY_USER_NOTIFICATION_STATE_QUNS_APP: QUERY_USER_NOTIFICATION_STATE = 7;
pub type QUERY_USER_NOTIFICATION_STATE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn SHQueryUserNotificationState(pquns: *mut QUERY_USER_NOTIFICATION_STATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHGetPropertyStoreForWindow(
        hwnd: HWND,
        riid: *const IID,
        ppv: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NOTIFYICONDATAA {
    pub cbSize: DWORD,
    pub hWnd: HWND,
    pub uID: UINT,
    pub uFlags: UINT,
    pub uCallbackMessage: UINT,
    pub hIcon: HICON,
    pub szTip: [CHAR; 128usize],
    pub dwState: DWORD,
    pub dwStateMask: DWORD,
    pub szInfo: [CHAR; 256usize],
    pub __bindgen_anon_1: _NOTIFYICONDATAA__bindgen_ty_1,
    pub szInfoTitle: [CHAR; 64usize],
    pub dwInfoFlags: DWORD,
    pub guidItem: GUID,
    pub hBalloonIcon: HICON,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NOTIFYICONDATAA__bindgen_ty_1 {
    pub uTimeout: UINT,
    pub uVersion: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NOTIFYICONDATAA__bindgen_ty_1"]
        [::std::mem::size_of::<_NOTIFYICONDATAA__bindgen_ty_1>() - 4usize];
    ["Alignment of _NOTIFYICONDATAA__bindgen_ty_1"]
        [::std::mem::align_of::<_NOTIFYICONDATAA__bindgen_ty_1>() - 4usize];
    ["Offset of field: _NOTIFYICONDATAA__bindgen_ty_1::uTimeout"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA__bindgen_ty_1, uTimeout) - 0usize];
    ["Offset of field: _NOTIFYICONDATAA__bindgen_ty_1::uVersion"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA__bindgen_ty_1, uVersion) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NOTIFYICONDATAA"][::std::mem::size_of::<_NOTIFYICONDATAA>() - 528usize];
    ["Alignment of _NOTIFYICONDATAA"][::std::mem::align_of::<_NOTIFYICONDATAA>() - 8usize];
    ["Offset of field: _NOTIFYICONDATAA::cbSize"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, cbSize) - 0usize];
    ["Offset of field: _NOTIFYICONDATAA::hWnd"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, hWnd) - 8usize];
    ["Offset of field: _NOTIFYICONDATAA::uID"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, uID) - 16usize];
    ["Offset of field: _NOTIFYICONDATAA::uFlags"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, uFlags) - 20usize];
    ["Offset of field: _NOTIFYICONDATAA::uCallbackMessage"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, uCallbackMessage) - 24usize];
    ["Offset of field: _NOTIFYICONDATAA::hIcon"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, hIcon) - 32usize];
    ["Offset of field: _NOTIFYICONDATAA::szTip"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, szTip) - 40usize];
    ["Offset of field: _NOTIFYICONDATAA::dwState"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, dwState) - 168usize];
    ["Offset of field: _NOTIFYICONDATAA::dwStateMask"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, dwStateMask) - 172usize];
    ["Offset of field: _NOTIFYICONDATAA::szInfo"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, szInfo) - 176usize];
    ["Offset of field: _NOTIFYICONDATAA::szInfoTitle"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, szInfoTitle) - 436usize];
    ["Offset of field: _NOTIFYICONDATAA::dwInfoFlags"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, dwInfoFlags) - 500usize];
    ["Offset of field: _NOTIFYICONDATAA::guidItem"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, guidItem) - 504usize];
    ["Offset of field: _NOTIFYICONDATAA::hBalloonIcon"]
        [::std::mem::offset_of!(_NOTIFYICONDATAA, hBalloonIcon) - 520usize];
};
pub type NOTIFYICONDATAA = _NOTIFYICONDATAA;
pub type PNOTIFYICONDATAA = *mut _NOTIFYICONDATAA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NOTIFYICONDATAW {
    pub cbSize: DWORD,
    pub hWnd: HWND,
    pub uID: UINT,
    pub uFlags: UINT,
    pub uCallbackMessage: UINT,
    pub hIcon: HICON,
    pub szTip: [WCHAR; 128usize],
    pub dwState: DWORD,
    pub dwStateMask: DWORD,
    pub szInfo: [WCHAR; 256usize],
    pub __bindgen_anon_1: _NOTIFYICONDATAW__bindgen_ty_1,
    pub szInfoTitle: [WCHAR; 64usize],
    pub dwInfoFlags: DWORD,
    pub guidItem: GUID,
    pub hBalloonIcon: HICON,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NOTIFYICONDATAW__bindgen_ty_1 {
    pub uTimeout: UINT,
    pub uVersion: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NOTIFYICONDATAW__bindgen_ty_1"]
        [::std::mem::size_of::<_NOTIFYICONDATAW__bindgen_ty_1>() - 4usize];
    ["Alignment of _NOTIFYICONDATAW__bindgen_ty_1"]
        [::std::mem::align_of::<_NOTIFYICONDATAW__bindgen_ty_1>() - 4usize];
    ["Offset of field: _NOTIFYICONDATAW__bindgen_ty_1::uTimeout"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW__bindgen_ty_1, uTimeout) - 0usize];
    ["Offset of field: _NOTIFYICONDATAW__bindgen_ty_1::uVersion"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW__bindgen_ty_1, uVersion) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NOTIFYICONDATAW"][::std::mem::size_of::<_NOTIFYICONDATAW>() - 976usize];
    ["Alignment of _NOTIFYICONDATAW"][::std::mem::align_of::<_NOTIFYICONDATAW>() - 8usize];
    ["Offset of field: _NOTIFYICONDATAW::cbSize"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, cbSize) - 0usize];
    ["Offset of field: _NOTIFYICONDATAW::hWnd"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, hWnd) - 8usize];
    ["Offset of field: _NOTIFYICONDATAW::uID"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, uID) - 16usize];
    ["Offset of field: _NOTIFYICONDATAW::uFlags"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, uFlags) - 20usize];
    ["Offset of field: _NOTIFYICONDATAW::uCallbackMessage"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, uCallbackMessage) - 24usize];
    ["Offset of field: _NOTIFYICONDATAW::hIcon"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, hIcon) - 32usize];
    ["Offset of field: _NOTIFYICONDATAW::szTip"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, szTip) - 40usize];
    ["Offset of field: _NOTIFYICONDATAW::dwState"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, dwState) - 296usize];
    ["Offset of field: _NOTIFYICONDATAW::dwStateMask"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, dwStateMask) - 300usize];
    ["Offset of field: _NOTIFYICONDATAW::szInfo"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, szInfo) - 304usize];
    ["Offset of field: _NOTIFYICONDATAW::szInfoTitle"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, szInfoTitle) - 820usize];
    ["Offset of field: _NOTIFYICONDATAW::dwInfoFlags"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, dwInfoFlags) - 948usize];
    ["Offset of field: _NOTIFYICONDATAW::guidItem"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, guidItem) - 952usize];
    ["Offset of field: _NOTIFYICONDATAW::hBalloonIcon"]
        [::std::mem::offset_of!(_NOTIFYICONDATAW, hBalloonIcon) - 968usize];
};
pub type NOTIFYICONDATAW = _NOTIFYICONDATAW;
pub type PNOTIFYICONDATAW = *mut _NOTIFYICONDATAW;
pub type NOTIFYICONDATA = NOTIFYICONDATAA;
pub type PNOTIFYICONDATA = PNOTIFYICONDATAA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NOTIFYICONIDENTIFIER {
    pub cbSize: DWORD,
    pub hWnd: HWND,
    pub uID: UINT,
    pub guidItem: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NOTIFYICONIDENTIFIER"][::std::mem::size_of::<_NOTIFYICONIDENTIFIER>() - 40usize];
    ["Alignment of _NOTIFYICONIDENTIFIER"]
        [::std::mem::align_of::<_NOTIFYICONIDENTIFIER>() - 8usize];
    ["Offset of field: _NOTIFYICONIDENTIFIER::cbSize"]
        [::std::mem::offset_of!(_NOTIFYICONIDENTIFIER, cbSize) - 0usize];
    ["Offset of field: _NOTIFYICONIDENTIFIER::hWnd"]
        [::std::mem::offset_of!(_NOTIFYICONIDENTIFIER, hWnd) - 8usize];
    ["Offset of field: _NOTIFYICONIDENTIFIER::uID"]
        [::std::mem::offset_of!(_NOTIFYICONIDENTIFIER, uID) - 16usize];
    ["Offset of field: _NOTIFYICONIDENTIFIER::guidItem"]
        [::std::mem::offset_of!(_NOTIFYICONIDENTIFIER, guidItem) - 20usize];
};
pub type NOTIFYICONIDENTIFIER = _NOTIFYICONIDENTIFIER;
pub type PNOTIFYICONIDENTIFIER = *mut _NOTIFYICONIDENTIFIER;
unsafe extern "C" {
    pub fn Shell_NotifyIconA(dwMessage: DWORD, lpData: PNOTIFYICONDATAA) -> BOOL;
}
unsafe extern "C" {
    pub fn Shell_NotifyIconW(dwMessage: DWORD, lpData: PNOTIFYICONDATAW) -> BOOL;
}
unsafe extern "C" {
    pub fn Shell_NotifyIconGetRect(
        identifier: *const NOTIFYICONIDENTIFIER,
        iconLocation: *mut RECT,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHFILEINFOA {
    pub hIcon: HICON,
    pub iIcon: ::std::os::raw::c_int,
    pub dwAttributes: DWORD,
    pub szDisplayName: [CHAR; 260usize],
    pub szTypeName: [CHAR; 80usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHFILEINFOA"][::std::mem::size_of::<_SHFILEINFOA>() - 360usize];
    ["Alignment of _SHFILEINFOA"][::std::mem::align_of::<_SHFILEINFOA>() - 8usize];
    ["Offset of field: _SHFILEINFOA::hIcon"][::std::mem::offset_of!(_SHFILEINFOA, hIcon) - 0usize];
    ["Offset of field: _SHFILEINFOA::iIcon"][::std::mem::offset_of!(_SHFILEINFOA, iIcon) - 8usize];
    ["Offset of field: _SHFILEINFOA::dwAttributes"]
        [::std::mem::offset_of!(_SHFILEINFOA, dwAttributes) - 12usize];
    ["Offset of field: _SHFILEINFOA::szDisplayName"]
        [::std::mem::offset_of!(_SHFILEINFOA, szDisplayName) - 16usize];
    ["Offset of field: _SHFILEINFOA::szTypeName"]
        [::std::mem::offset_of!(_SHFILEINFOA, szTypeName) - 276usize];
};
pub type SHFILEINFOA = _SHFILEINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHFILEINFOW {
    pub hIcon: HICON,
    pub iIcon: ::std::os::raw::c_int,
    pub dwAttributes: DWORD,
    pub szDisplayName: [WCHAR; 260usize],
    pub szTypeName: [WCHAR; 80usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHFILEINFOW"][::std::mem::size_of::<_SHFILEINFOW>() - 696usize];
    ["Alignment of _SHFILEINFOW"][::std::mem::align_of::<_SHFILEINFOW>() - 8usize];
    ["Offset of field: _SHFILEINFOW::hIcon"][::std::mem::offset_of!(_SHFILEINFOW, hIcon) - 0usize];
    ["Offset of field: _SHFILEINFOW::iIcon"][::std::mem::offset_of!(_SHFILEINFOW, iIcon) - 8usize];
    ["Offset of field: _SHFILEINFOW::dwAttributes"]
        [::std::mem::offset_of!(_SHFILEINFOW, dwAttributes) - 12usize];
    ["Offset of field: _SHFILEINFOW::szDisplayName"]
        [::std::mem::offset_of!(_SHFILEINFOW, szDisplayName) - 16usize];
    ["Offset of field: _SHFILEINFOW::szTypeName"]
        [::std::mem::offset_of!(_SHFILEINFOW, szTypeName) - 536usize];
};
pub type SHFILEINFOW = _SHFILEINFOW;
pub type SHFILEINFO = SHFILEINFOA;
unsafe extern "C" {
    pub fn SHGetFileInfoA(
        pszPath: LPCSTR,
        dwFileAttributes: DWORD,
        psfi: *mut SHFILEINFOA,
        cbFileInfo: UINT,
        uFlags: UINT,
    ) -> DWORD_PTR;
}
unsafe extern "C" {
    pub fn SHGetFileInfoW(
        pszPath: LPCWSTR,
        dwFileAttributes: DWORD,
        psfi: *mut SHFILEINFOW,
        cbFileInfo: UINT,
        uFlags: UINT,
    ) -> DWORD_PTR;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHSTOCKICONINFO {
    pub cbSize: DWORD,
    pub hIcon: HICON,
    pub iSysImageIndex: ::std::os::raw::c_int,
    pub iIcon: ::std::os::raw::c_int,
    pub szPath: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHSTOCKICONINFO"][::std::mem::size_of::<_SHSTOCKICONINFO>() - 544usize];
    ["Alignment of _SHSTOCKICONINFO"][::std::mem::align_of::<_SHSTOCKICONINFO>() - 8usize];
    ["Offset of field: _SHSTOCKICONINFO::cbSize"]
        [::std::mem::offset_of!(_SHSTOCKICONINFO, cbSize) - 0usize];
    ["Offset of field: _SHSTOCKICONINFO::hIcon"]
        [::std::mem::offset_of!(_SHSTOCKICONINFO, hIcon) - 8usize];
    ["Offset of field: _SHSTOCKICONINFO::iSysImageIndex"]
        [::std::mem::offset_of!(_SHSTOCKICONINFO, iSysImageIndex) - 16usize];
    ["Offset of field: _SHSTOCKICONINFO::iIcon"]
        [::std::mem::offset_of!(_SHSTOCKICONINFO, iIcon) - 20usize];
    ["Offset of field: _SHSTOCKICONINFO::szPath"]
        [::std::mem::offset_of!(_SHSTOCKICONINFO, szPath) - 24usize];
};
pub type SHSTOCKICONINFO = _SHSTOCKICONINFO;
pub const SHSTOCKICONID_SIID_DOCNOASSOC: SHSTOCKICONID = 0;
pub const SHSTOCKICONID_SIID_DOCASSOC: SHSTOCKICONID = 1;
pub const SHSTOCKICONID_SIID_APPLICATION: SHSTOCKICONID = 2;
pub const SHSTOCKICONID_SIID_FOLDER: SHSTOCKICONID = 3;
pub const SHSTOCKICONID_SIID_FOLDEROPEN: SHSTOCKICONID = 4;
pub const SHSTOCKICONID_SIID_DRIVE525: SHSTOCKICONID = 5;
pub const SHSTOCKICONID_SIID_DRIVE35: SHSTOCKICONID = 6;
pub const SHSTOCKICONID_SIID_DRIVEREMOVE: SHSTOCKICONID = 7;
pub const SHSTOCKICONID_SIID_DRIVEFIXED: SHSTOCKICONID = 8;
pub const SHSTOCKICONID_SIID_DRIVENET: SHSTOCKICONID = 9;
pub const SHSTOCKICONID_SIID_DRIVENETDISABLED: SHSTOCKICONID = 10;
pub const SHSTOCKICONID_SIID_DRIVECD: SHSTOCKICONID = 11;
pub const SHSTOCKICONID_SIID_DRIVERAM: SHSTOCKICONID = 12;
pub const SHSTOCKICONID_SIID_WORLD: SHSTOCKICONID = 13;
pub const SHSTOCKICONID_SIID_SERVER: SHSTOCKICONID = 15;
pub const SHSTOCKICONID_SIID_PRINTER: SHSTOCKICONID = 16;
pub const SHSTOCKICONID_SIID_MYNETWORK: SHSTOCKICONID = 17;
pub const SHSTOCKICONID_SIID_FIND: SHSTOCKICONID = 22;
pub const SHSTOCKICONID_SIID_HELP: SHSTOCKICONID = 23;
pub const SHSTOCKICONID_SIID_SHARE: SHSTOCKICONID = 28;
pub const SHSTOCKICONID_SIID_LINK: SHSTOCKICONID = 29;
pub const SHSTOCKICONID_SIID_SLOWFILE: SHSTOCKICONID = 30;
pub const SHSTOCKICONID_SIID_RECYCLER: SHSTOCKICONID = 31;
pub const SHSTOCKICONID_SIID_RECYCLERFULL: SHSTOCKICONID = 32;
pub const SHSTOCKICONID_SIID_MEDIACDAUDIO: SHSTOCKICONID = 40;
pub const SHSTOCKICONID_SIID_LOCK: SHSTOCKICONID = 47;
pub const SHSTOCKICONID_SIID_AUTOLIST: SHSTOCKICONID = 49;
pub const SHSTOCKICONID_SIID_PRINTERNET: SHSTOCKICONID = 50;
pub const SHSTOCKICONID_SIID_SERVERSHARE: SHSTOCKICONID = 51;
pub const SHSTOCKICONID_SIID_PRINTERFAX: SHSTOCKICONID = 52;
pub const SHSTOCKICONID_SIID_PRINTERFAXNET: SHSTOCKICONID = 53;
pub const SHSTOCKICONID_SIID_PRINTERFILE: SHSTOCKICONID = 54;
pub const SHSTOCKICONID_SIID_STACK: SHSTOCKICONID = 55;
pub const SHSTOCKICONID_SIID_MEDIASVCD: SHSTOCKICONID = 56;
pub const SHSTOCKICONID_SIID_STUFFEDFOLDER: SHSTOCKICONID = 57;
pub const SHSTOCKICONID_SIID_DRIVEUNKNOWN: SHSTOCKICONID = 58;
pub const SHSTOCKICONID_SIID_DRIVEDVD: SHSTOCKICONID = 59;
pub const SHSTOCKICONID_SIID_MEDIADVD: SHSTOCKICONID = 60;
pub const SHSTOCKICONID_SIID_MEDIADVDRAM: SHSTOCKICONID = 61;
pub const SHSTOCKICONID_SIID_MEDIADVDRW: SHSTOCKICONID = 62;
pub const SHSTOCKICONID_SIID_MEDIADVDR: SHSTOCKICONID = 63;
pub const SHSTOCKICONID_SIID_MEDIADVDROM: SHSTOCKICONID = 64;
pub const SHSTOCKICONID_SIID_MEDIACDAUDIOPLUS: SHSTOCKICONID = 65;
pub const SHSTOCKICONID_SIID_MEDIACDRW: SHSTOCKICONID = 66;
pub const SHSTOCKICONID_SIID_MEDIACDR: SHSTOCKICONID = 67;
pub const SHSTOCKICONID_SIID_MEDIACDBURN: SHSTOCKICONID = 68;
pub const SHSTOCKICONID_SIID_MEDIABLANKCD: SHSTOCKICONID = 69;
pub const SHSTOCKICONID_SIID_MEDIACDROM: SHSTOCKICONID = 70;
pub const SHSTOCKICONID_SIID_AUDIOFILES: SHSTOCKICONID = 71;
pub const SHSTOCKICONID_SIID_IMAGEFILES: SHSTOCKICONID = 72;
pub const SHSTOCKICONID_SIID_VIDEOFILES: SHSTOCKICONID = 73;
pub const SHSTOCKICONID_SIID_MIXEDFILES: SHSTOCKICONID = 74;
pub const SHSTOCKICONID_SIID_FOLDERBACK: SHSTOCKICONID = 75;
pub const SHSTOCKICONID_SIID_FOLDERFRONT: SHSTOCKICONID = 76;
pub const SHSTOCKICONID_SIID_SHIELD: SHSTOCKICONID = 77;
pub const SHSTOCKICONID_SIID_WARNING: SHSTOCKICONID = 78;
pub const SHSTOCKICONID_SIID_INFO: SHSTOCKICONID = 79;
pub const SHSTOCKICONID_SIID_ERROR: SHSTOCKICONID = 80;
pub const SHSTOCKICONID_SIID_KEY: SHSTOCKICONID = 81;
pub const SHSTOCKICONID_SIID_SOFTWARE: SHSTOCKICONID = 82;
pub const SHSTOCKICONID_SIID_RENAME: SHSTOCKICONID = 83;
pub const SHSTOCKICONID_SIID_DELETE: SHSTOCKICONID = 84;
pub const SHSTOCKICONID_SIID_MEDIAAUDIODVD: SHSTOCKICONID = 85;
pub const SHSTOCKICONID_SIID_MEDIAMOVIEDVD: SHSTOCKICONID = 86;
pub const SHSTOCKICONID_SIID_MEDIAENHANCEDCD: SHSTOCKICONID = 87;
pub const SHSTOCKICONID_SIID_MEDIAENHANCEDDVD: SHSTOCKICONID = 88;
pub const SHSTOCKICONID_SIID_MEDIAHDDVD: SHSTOCKICONID = 89;
pub const SHSTOCKICONID_SIID_MEDIABLURAY: SHSTOCKICONID = 90;
pub const SHSTOCKICONID_SIID_MEDIAVCD: SHSTOCKICONID = 91;
pub const SHSTOCKICONID_SIID_MEDIADVDPLUSR: SHSTOCKICONID = 92;
pub const SHSTOCKICONID_SIID_MEDIADVDPLUSRW: SHSTOCKICONID = 93;
pub const SHSTOCKICONID_SIID_DESKTOPPC: SHSTOCKICONID = 94;
pub const SHSTOCKICONID_SIID_MOBILEPC: SHSTOCKICONID = 95;
pub const SHSTOCKICONID_SIID_USERS: SHSTOCKICONID = 96;
pub const SHSTOCKICONID_SIID_MEDIASMARTMEDIA: SHSTOCKICONID = 97;
pub const SHSTOCKICONID_SIID_MEDIACOMPACTFLASH: SHSTOCKICONID = 98;
pub const SHSTOCKICONID_SIID_DEVICECELLPHONE: SHSTOCKICONID = 99;
pub const SHSTOCKICONID_SIID_DEVICECAMERA: SHSTOCKICONID = 100;
pub const SHSTOCKICONID_SIID_DEVICEVIDEOCAMERA: SHSTOCKICONID = 101;
pub const SHSTOCKICONID_SIID_DEVICEAUDIOPLAYER: SHSTOCKICONID = 102;
pub const SHSTOCKICONID_SIID_NETWORKCONNECT: SHSTOCKICONID = 103;
pub const SHSTOCKICONID_SIID_INTERNET: SHSTOCKICONID = 104;
pub const SHSTOCKICONID_SIID_ZIPFILE: SHSTOCKICONID = 105;
pub const SHSTOCKICONID_SIID_SETTINGS: SHSTOCKICONID = 106;
pub const SHSTOCKICONID_SIID_DRIVEHDDVD: SHSTOCKICONID = 132;
pub const SHSTOCKICONID_SIID_DRIVEBD: SHSTOCKICONID = 133;
pub const SHSTOCKICONID_SIID_MEDIAHDDVDROM: SHSTOCKICONID = 134;
pub const SHSTOCKICONID_SIID_MEDIAHDDVDR: SHSTOCKICONID = 135;
pub const SHSTOCKICONID_SIID_MEDIAHDDVDRAM: SHSTOCKICONID = 136;
pub const SHSTOCKICONID_SIID_MEDIABDROM: SHSTOCKICONID = 137;
pub const SHSTOCKICONID_SIID_MEDIABDR: SHSTOCKICONID = 138;
pub const SHSTOCKICONID_SIID_MEDIABDRE: SHSTOCKICONID = 139;
pub const SHSTOCKICONID_SIID_CLUSTEREDDRIVE: SHSTOCKICONID = 140;
pub const SHSTOCKICONID_SIID_MAX_ICONS: SHSTOCKICONID = 181;
pub type SHSTOCKICONID = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn SHGetStockIconInfo(
        siid: SHSTOCKICONID,
        uFlags: UINT,
        psii: *mut SHSTOCKICONINFO,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHGetDiskFreeSpaceExA(
        pszDirectoryName: LPCSTR,
        pulFreeBytesAvailableToCaller: *mut ULARGE_INTEGER,
        pulTotalNumberOfBytes: *mut ULARGE_INTEGER,
        pulTotalNumberOfFreeBytes: *mut ULARGE_INTEGER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SHGetDiskFreeSpaceExW(
        pszDirectoryName: LPCWSTR,
        pulFreeBytesAvailableToCaller: *mut ULARGE_INTEGER,
        pulTotalNumberOfBytes: *mut ULARGE_INTEGER,
        pulTotalNumberOfFreeBytes: *mut ULARGE_INTEGER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SHGetNewLinkInfoA(
        pszLinkTo: LPCSTR,
        pszDir: LPCSTR,
        pszName: LPSTR,
        pfMustCopy: *mut BOOL,
        uFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SHGetNewLinkInfoW(
        pszLinkTo: LPCWSTR,
        pszDir: LPCWSTR,
        pszName: LPWSTR,
        pfMustCopy: *mut BOOL,
        uFlags: UINT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SHInvokePrinterCommandA(
        hwnd: HWND,
        uAction: UINT,
        lpBuf1: LPCSTR,
        lpBuf2: LPCSTR,
        fModal: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SHInvokePrinterCommandW(
        hwnd: HWND,
        uAction: UINT,
        lpBuf1: LPCWSTR,
        lpBuf2: LPCWSTR,
        fModal: BOOL,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OPEN_PRINTER_PROPS_INFOA {
    pub dwSize: DWORD,
    pub pszSheetName: LPSTR,
    pub uSheetIndex: UINT,
    pub dwFlags: DWORD,
    pub bModal: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OPEN_PRINTER_PROPS_INFOA"]
        [::std::mem::size_of::<_OPEN_PRINTER_PROPS_INFOA>() - 32usize];
    ["Alignment of _OPEN_PRINTER_PROPS_INFOA"]
        [::std::mem::align_of::<_OPEN_PRINTER_PROPS_INFOA>() - 8usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOA::dwSize"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOA, dwSize) - 0usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOA::pszSheetName"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOA, pszSheetName) - 8usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOA::uSheetIndex"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOA, uSheetIndex) - 16usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOA::dwFlags"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOA, dwFlags) - 20usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOA::bModal"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOA, bModal) - 24usize];
};
pub type OPEN_PRINTER_PROPS_INFOA = _OPEN_PRINTER_PROPS_INFOA;
pub type POPEN_PRINTER_PROPS_INFOA = *mut _OPEN_PRINTER_PROPS_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OPEN_PRINTER_PROPS_INFOW {
    pub dwSize: DWORD,
    pub pszSheetName: LPWSTR,
    pub uSheetIndex: UINT,
    pub dwFlags: DWORD,
    pub bModal: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OPEN_PRINTER_PROPS_INFOW"]
        [::std::mem::size_of::<_OPEN_PRINTER_PROPS_INFOW>() - 32usize];
    ["Alignment of _OPEN_PRINTER_PROPS_INFOW"]
        [::std::mem::align_of::<_OPEN_PRINTER_PROPS_INFOW>() - 8usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOW::dwSize"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOW, dwSize) - 0usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOW::pszSheetName"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOW, pszSheetName) - 8usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOW::uSheetIndex"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOW, uSheetIndex) - 16usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOW::dwFlags"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOW, dwFlags) - 20usize];
    ["Offset of field: _OPEN_PRINTER_PROPS_INFOW::bModal"]
        [::std::mem::offset_of!(_OPEN_PRINTER_PROPS_INFOW, bModal) - 24usize];
};
pub type OPEN_PRINTER_PROPS_INFOW = _OPEN_PRINTER_PROPS_INFOW;
pub type POPEN_PRINTER_PROPS_INFOW = *mut _OPEN_PRINTER_PROPS_INFOW;
pub type OPEN_PRINTER_PROPS_INFO = OPEN_PRINTER_PROPS_INFOA;
pub type POPEN_PRINTER_PROPS_INFO = POPEN_PRINTER_PROPS_INFOA;
unsafe extern "C" {
    pub fn SHLoadNonloadedIconOverlayIdentifiers() -> HRESULT;
}
unsafe extern "C" {
    pub fn SHIsFileAvailableOffline(pwszPath: PCWSTR, pdwStatus: *mut DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHSetLocalizedName(
        pszPath: PCWSTR,
        pszResModule: PCWSTR,
        idsRes: ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHRemoveLocalizedName(pszPath: PCWSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHGetLocalizedName(
        pszPath: PCWSTR,
        pszResModule: PWSTR,
        cch: UINT,
        pidsRes: *mut ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ShellMessageBoxA(
        hAppInst: HINSTANCE,
        hWnd: HWND,
        lpcText: LPCSTR,
        lpcTitle: LPCSTR,
        fuStyle: UINT,
        ...
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ShellMessageBoxW(
        hAppInst: HINSTANCE,
        hWnd: HWND,
        lpcText: LPCWSTR,
        lpcTitle: LPCWSTR,
        fuStyle: UINT,
        ...
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn IsLFNDriveA(pszPath: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsLFNDriveW(pszPath: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SHEnumerateUnreadMailAccountsA(
        hKeyUser: HKEY,
        dwIndex: DWORD,
        pszMailAddress: LPSTR,
        cchMailAddress: ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHEnumerateUnreadMailAccountsW(
        hKeyUser: HKEY,
        dwIndex: DWORD,
        pszMailAddress: LPWSTR,
        cchMailAddress: ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHGetUnreadMailCountA(
        hKeyUser: HKEY,
        pszMailAddress: LPCSTR,
        pdwCount: *mut DWORD,
        pFileTime: *mut FILETIME,
        pszShellExecuteCommand: LPSTR,
        cchShellExecuteCommand: ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHGetUnreadMailCountW(
        hKeyUser: HKEY,
        pszMailAddress: LPCWSTR,
        pdwCount: *mut DWORD,
        pFileTime: *mut FILETIME,
        pszShellExecuteCommand: LPWSTR,
        cchShellExecuteCommand: ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHSetUnreadMailCountA(
        pszMailAddress: LPCSTR,
        dwCount: DWORD,
        pszShellExecuteCommand: LPCSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHSetUnreadMailCountW(
        pszMailAddress: LPCWSTR,
        dwCount: DWORD,
        pszShellExecuteCommand: LPCWSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SHTestTokenMembership(hToken: HANDLE, ulRID: ULONG) -> BOOL;
}
unsafe extern "C" {
    pub fn SHGetImageList(
        iImageList: ::std::os::raw::c_int,
        riid: *const IID,
        ppvObj: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
pub type PFNCANSHAREFOLDERW =
    ::std::option::Option<unsafe extern "C" fn(pszPath: PCWSTR) -> HRESULT>;
pub type PFNSHOWSHAREFOLDERUIW =
    ::std::option::Option<unsafe extern "C" fn(hwndParent: HWND, pszPath: PCWSTR) -> HRESULT>;
unsafe extern "C" {
    pub fn InitNetworkAddressControl() -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagNC_ADDRESS {
    pub pAddrInfo: *mut NET_ADDRESS_INFO_,
    pub PortNumber: USHORT,
    pub PrefixLength: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagNC_ADDRESS"][::std::mem::size_of::<tagNC_ADDRESS>() - 16usize];
    ["Alignment of tagNC_ADDRESS"][::std::mem::align_of::<tagNC_ADDRESS>() - 8usize];
    ["Offset of field: tagNC_ADDRESS::pAddrInfo"]
        [::std::mem::offset_of!(tagNC_ADDRESS, pAddrInfo) - 0usize];
    ["Offset of field: tagNC_ADDRESS::PortNumber"]
        [::std::mem::offset_of!(tagNC_ADDRESS, PortNumber) - 8usize];
    ["Offset of field: tagNC_ADDRESS::PrefixLength"]
        [::std::mem::offset_of!(tagNC_ADDRESS, PrefixLength) - 10usize];
};
pub type NC_ADDRESS = tagNC_ADDRESS;
pub type PNC_ADDRESS = *mut tagNC_ADDRESS;
unsafe extern "C" {
    pub fn SHGetDriveMedia(pszDrive: PCWSTR, pdwMediaContent: *mut DWORD) -> HRESULT;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PERF_DATA_BLOCK {
    pub Signature: [WCHAR; 4usize],
    pub LittleEndian: DWORD,
    pub Version: DWORD,
    pub Revision: DWORD,
    pub TotalByteLength: DWORD,
    pub HeaderLength: DWORD,
    pub NumObjectTypes: DWORD,
    pub DefaultObject: LONG,
    pub SystemTime: SYSTEMTIME,
    pub PerfTime: LARGE_INTEGER,
    pub PerfFreq: LARGE_INTEGER,
    pub PerfTime100nSec: LARGE_INTEGER,
    pub SystemNameLength: DWORD,
    pub SystemNameOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_DATA_BLOCK"][::std::mem::size_of::<_PERF_DATA_BLOCK>() - 88usize];
    ["Alignment of _PERF_DATA_BLOCK"][::std::mem::align_of::<_PERF_DATA_BLOCK>() - 8usize];
    ["Offset of field: _PERF_DATA_BLOCK::Signature"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, Signature) - 0usize];
    ["Offset of field: _PERF_DATA_BLOCK::LittleEndian"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, LittleEndian) - 8usize];
    ["Offset of field: _PERF_DATA_BLOCK::Version"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, Version) - 12usize];
    ["Offset of field: _PERF_DATA_BLOCK::Revision"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, Revision) - 16usize];
    ["Offset of field: _PERF_DATA_BLOCK::TotalByteLength"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, TotalByteLength) - 20usize];
    ["Offset of field: _PERF_DATA_BLOCK::HeaderLength"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, HeaderLength) - 24usize];
    ["Offset of field: _PERF_DATA_BLOCK::NumObjectTypes"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, NumObjectTypes) - 28usize];
    ["Offset of field: _PERF_DATA_BLOCK::DefaultObject"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, DefaultObject) - 32usize];
    ["Offset of field: _PERF_DATA_BLOCK::SystemTime"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, SystemTime) - 36usize];
    ["Offset of field: _PERF_DATA_BLOCK::PerfTime"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, PerfTime) - 56usize];
    ["Offset of field: _PERF_DATA_BLOCK::PerfFreq"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, PerfFreq) - 64usize];
    ["Offset of field: _PERF_DATA_BLOCK::PerfTime100nSec"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, PerfTime100nSec) - 72usize];
    ["Offset of field: _PERF_DATA_BLOCK::SystemNameLength"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, SystemNameLength) - 80usize];
    ["Offset of field: _PERF_DATA_BLOCK::SystemNameOffset"]
        [::std::mem::offset_of!(_PERF_DATA_BLOCK, SystemNameOffset) - 84usize];
};
pub type PERF_DATA_BLOCK = _PERF_DATA_BLOCK;
pub type PPERF_DATA_BLOCK = *mut _PERF_DATA_BLOCK;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PERF_OBJECT_TYPE {
    pub TotalByteLength: DWORD,
    pub DefinitionLength: DWORD,
    pub HeaderLength: DWORD,
    pub ObjectNameTitleIndex: DWORD,
    pub ObjectNameTitle: DWORD,
    pub ObjectHelpTitleIndex: DWORD,
    pub ObjectHelpTitle: DWORD,
    pub DetailLevel: DWORD,
    pub NumCounters: DWORD,
    pub DefaultCounter: LONG,
    pub NumInstances: LONG,
    pub CodePage: DWORD,
    pub PerfTime: LARGE_INTEGER,
    pub PerfFreq: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_OBJECT_TYPE"][::std::mem::size_of::<_PERF_OBJECT_TYPE>() - 64usize];
    ["Alignment of _PERF_OBJECT_TYPE"][::std::mem::align_of::<_PERF_OBJECT_TYPE>() - 8usize];
    ["Offset of field: _PERF_OBJECT_TYPE::TotalByteLength"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, TotalByteLength) - 0usize];
    ["Offset of field: _PERF_OBJECT_TYPE::DefinitionLength"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, DefinitionLength) - 4usize];
    ["Offset of field: _PERF_OBJECT_TYPE::HeaderLength"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, HeaderLength) - 8usize];
    ["Offset of field: _PERF_OBJECT_TYPE::ObjectNameTitleIndex"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, ObjectNameTitleIndex) - 12usize];
    ["Offset of field: _PERF_OBJECT_TYPE::ObjectNameTitle"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, ObjectNameTitle) - 16usize];
    ["Offset of field: _PERF_OBJECT_TYPE::ObjectHelpTitleIndex"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, ObjectHelpTitleIndex) - 20usize];
    ["Offset of field: _PERF_OBJECT_TYPE::ObjectHelpTitle"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, ObjectHelpTitle) - 24usize];
    ["Offset of field: _PERF_OBJECT_TYPE::DetailLevel"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, DetailLevel) - 28usize];
    ["Offset of field: _PERF_OBJECT_TYPE::NumCounters"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, NumCounters) - 32usize];
    ["Offset of field: _PERF_OBJECT_TYPE::DefaultCounter"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, DefaultCounter) - 36usize];
    ["Offset of field: _PERF_OBJECT_TYPE::NumInstances"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, NumInstances) - 40usize];
    ["Offset of field: _PERF_OBJECT_TYPE::CodePage"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, CodePage) - 44usize];
    ["Offset of field: _PERF_OBJECT_TYPE::PerfTime"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, PerfTime) - 48usize];
    ["Offset of field: _PERF_OBJECT_TYPE::PerfFreq"]
        [::std::mem::offset_of!(_PERF_OBJECT_TYPE, PerfFreq) - 56usize];
};
pub type PERF_OBJECT_TYPE = _PERF_OBJECT_TYPE;
pub type PPERF_OBJECT_TYPE = *mut _PERF_OBJECT_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PERF_COUNTER_DEFINITION {
    pub ByteLength: DWORD,
    pub CounterNameTitleIndex: DWORD,
    pub CounterNameTitle: DWORD,
    pub CounterHelpTitleIndex: DWORD,
    pub CounterHelpTitle: DWORD,
    pub DefaultScale: LONG,
    pub DetailLevel: DWORD,
    pub CounterType: DWORD,
    pub CounterSize: DWORD,
    pub CounterOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_COUNTER_DEFINITION"]
        [::std::mem::size_of::<_PERF_COUNTER_DEFINITION>() - 40usize];
    ["Alignment of _PERF_COUNTER_DEFINITION"]
        [::std::mem::align_of::<_PERF_COUNTER_DEFINITION>() - 4usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::ByteLength"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, ByteLength) - 0usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterNameTitleIndex"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterNameTitleIndex) - 4usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterNameTitle"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterNameTitle) - 8usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterHelpTitleIndex"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterHelpTitleIndex) - 12usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterHelpTitle"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterHelpTitle) - 16usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::DefaultScale"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, DefaultScale) - 20usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::DetailLevel"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, DetailLevel) - 24usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterType"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterType) - 28usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterSize"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterSize) - 32usize];
    ["Offset of field: _PERF_COUNTER_DEFINITION::CounterOffset"]
        [::std::mem::offset_of!(_PERF_COUNTER_DEFINITION, CounterOffset) - 36usize];
};
pub type PERF_COUNTER_DEFINITION = _PERF_COUNTER_DEFINITION;
pub type PPERF_COUNTER_DEFINITION = *mut _PERF_COUNTER_DEFINITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PERF_INSTANCE_DEFINITION {
    pub ByteLength: DWORD,
    pub ParentObjectTitleIndex: DWORD,
    pub ParentObjectInstance: DWORD,
    pub UniqueID: LONG,
    pub NameOffset: DWORD,
    pub NameLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_INSTANCE_DEFINITION"]
        [::std::mem::size_of::<_PERF_INSTANCE_DEFINITION>() - 24usize];
    ["Alignment of _PERF_INSTANCE_DEFINITION"]
        [::std::mem::align_of::<_PERF_INSTANCE_DEFINITION>() - 4usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::ByteLength"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, ByteLength) - 0usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::ParentObjectTitleIndex"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, ParentObjectTitleIndex) - 4usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::ParentObjectInstance"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, ParentObjectInstance) - 8usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::UniqueID"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, UniqueID) - 12usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::NameOffset"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, NameOffset) - 16usize];
    ["Offset of field: _PERF_INSTANCE_DEFINITION::NameLength"]
        [::std::mem::offset_of!(_PERF_INSTANCE_DEFINITION, NameLength) - 20usize];
};
pub type PERF_INSTANCE_DEFINITION = _PERF_INSTANCE_DEFINITION;
pub type PPERF_INSTANCE_DEFINITION = *mut _PERF_INSTANCE_DEFINITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PERF_COUNTER_BLOCK {
    pub ByteLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_COUNTER_BLOCK"][::std::mem::size_of::<_PERF_COUNTER_BLOCK>() - 4usize];
    ["Alignment of _PERF_COUNTER_BLOCK"][::std::mem::align_of::<_PERF_COUNTER_BLOCK>() - 4usize];
    ["Offset of field: _PERF_COUNTER_BLOCK::ByteLength"]
        [::std::mem::offset_of!(_PERF_COUNTER_BLOCK, ByteLength) - 0usize];
};
pub type PERF_COUNTER_BLOCK = _PERF_COUNTER_BLOCK;
pub type PPERF_COUNTER_BLOCK = *mut _PERF_COUNTER_BLOCK;
pub type u_char = ::std::os::raw::c_uchar;
pub type u_short = ::std::os::raw::c_ushort;
pub type u_int = ::std::os::raw::c_uint;
pub type u_long = ::std::os::raw::c_ulong;
pub type SOCKET = UINT_PTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct fd_set {
    pub fd_count: u_int,
    pub fd_array: [SOCKET; 64usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of fd_set"][::std::mem::size_of::<fd_set>() - 520usize];
    ["Alignment of fd_set"][::std::mem::align_of::<fd_set>() - 8usize];
    ["Offset of field: fd_set::fd_count"][::std::mem::offset_of!(fd_set, fd_count) - 0usize];
    ["Offset of field: fd_set::fd_array"][::std::mem::offset_of!(fd_set, fd_array) - 8usize];
};
unsafe extern "C" {
    pub fn __WSAFDIsSet(arg1: SOCKET, arg2: *mut fd_set) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct timeval {
    pub tv_sec: ::std::os::raw::c_long,
    pub tv_usec: ::std::os::raw::c_long,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of timeval"][::std::mem::size_of::<timeval>() - 8usize];
    ["Alignment of timeval"][::std::mem::align_of::<timeval>() - 4usize];
    ["Offset of field: timeval::tv_sec"][::std::mem::offset_of!(timeval, tv_sec) - 0usize];
    ["Offset of field: timeval::tv_usec"][::std::mem::offset_of!(timeval, tv_usec) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct hostent {
    pub h_name: *mut ::std::os::raw::c_char,
    pub h_aliases: *mut *mut ::std::os::raw::c_char,
    pub h_addrtype: ::std::os::raw::c_short,
    pub h_length: ::std::os::raw::c_short,
    pub h_addr_list: *mut *mut ::std::os::raw::c_char,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of hostent"][::std::mem::size_of::<hostent>() - 32usize];
    ["Alignment of hostent"][::std::mem::align_of::<hostent>() - 8usize];
    ["Offset of field: hostent::h_name"][::std::mem::offset_of!(hostent, h_name) - 0usize];
    ["Offset of field: hostent::h_aliases"][::std::mem::offset_of!(hostent, h_aliases) - 8usize];
    ["Offset of field: hostent::h_addrtype"][::std::mem::offset_of!(hostent, h_addrtype) - 16usize];
    ["Offset of field: hostent::h_length"][::std::mem::offset_of!(hostent, h_length) - 18usize];
    ["Offset of field: hostent::h_addr_list"]
        [::std::mem::offset_of!(hostent, h_addr_list) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct netent {
    pub n_name: *mut ::std::os::raw::c_char,
    pub n_aliases: *mut *mut ::std::os::raw::c_char,
    pub n_addrtype: ::std::os::raw::c_short,
    pub n_net: u_long,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of netent"][::std::mem::size_of::<netent>() - 24usize];
    ["Alignment of netent"][::std::mem::align_of::<netent>() - 8usize];
    ["Offset of field: netent::n_name"][::std::mem::offset_of!(netent, n_name) - 0usize];
    ["Offset of field: netent::n_aliases"][::std::mem::offset_of!(netent, n_aliases) - 8usize];
    ["Offset of field: netent::n_addrtype"][::std::mem::offset_of!(netent, n_addrtype) - 16usize];
    ["Offset of field: netent::n_net"][::std::mem::offset_of!(netent, n_net) - 20usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct servent {
    pub s_name: *mut ::std::os::raw::c_char,
    pub s_aliases: *mut *mut ::std::os::raw::c_char,
    pub s_proto: *mut ::std::os::raw::c_char,
    pub s_port: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of servent"][::std::mem::size_of::<servent>() - 32usize];
    ["Alignment of servent"][::std::mem::align_of::<servent>() - 8usize];
    ["Offset of field: servent::s_name"][::std::mem::offset_of!(servent, s_name) - 0usize];
    ["Offset of field: servent::s_aliases"][::std::mem::offset_of!(servent, s_aliases) - 8usize];
    ["Offset of field: servent::s_proto"][::std::mem::offset_of!(servent, s_proto) - 16usize];
    ["Offset of field: servent::s_port"][::std::mem::offset_of!(servent, s_port) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct protoent {
    pub p_name: *mut ::std::os::raw::c_char,
    pub p_aliases: *mut *mut ::std::os::raw::c_char,
    pub p_proto: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of protoent"][::std::mem::size_of::<protoent>() - 24usize];
    ["Alignment of protoent"][::std::mem::align_of::<protoent>() - 8usize];
    ["Offset of field: protoent::p_name"][::std::mem::offset_of!(protoent, p_name) - 0usize];
    ["Offset of field: protoent::p_aliases"][::std::mem::offset_of!(protoent, p_aliases) - 8usize];
    ["Offset of field: protoent::p_proto"][::std::mem::offset_of!(protoent, p_proto) - 16usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct in_addr {
    pub S_un: in_addr__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union in_addr__bindgen_ty_1 {
    pub S_un_b: in_addr__bindgen_ty_1__bindgen_ty_1,
    pub S_un_w: in_addr__bindgen_ty_1__bindgen_ty_2,
    pub S_addr: ULONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct in_addr__bindgen_ty_1__bindgen_ty_1 {
    pub s_b1: UCHAR,
    pub s_b2: UCHAR,
    pub s_b3: UCHAR,
    pub s_b4: UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of in_addr__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<in_addr__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of in_addr__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<in_addr__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_1::s_b1"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_1, s_b1) - 0usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_1::s_b2"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_1, s_b2) - 1usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_1::s_b3"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_1, s_b3) - 2usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_1::s_b4"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_1, s_b4) - 3usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct in_addr__bindgen_ty_1__bindgen_ty_2 {
    pub s_w1: USHORT,
    pub s_w2: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of in_addr__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<in_addr__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of in_addr__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<in_addr__bindgen_ty_1__bindgen_ty_2>() - 2usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_2::s_w1"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_2, s_w1) - 0usize];
    ["Offset of field: in_addr__bindgen_ty_1__bindgen_ty_2::s_w2"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1__bindgen_ty_2, s_w2) - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of in_addr__bindgen_ty_1"][::std::mem::size_of::<in_addr__bindgen_ty_1>() - 4usize];
    ["Alignment of in_addr__bindgen_ty_1"]
        [::std::mem::align_of::<in_addr__bindgen_ty_1>() - 4usize];
    ["Offset of field: in_addr__bindgen_ty_1::S_un_b"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1, S_un_b) - 0usize];
    ["Offset of field: in_addr__bindgen_ty_1::S_un_w"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1, S_un_w) - 0usize];
    ["Offset of field: in_addr__bindgen_ty_1::S_addr"]
        [::std::mem::offset_of!(in_addr__bindgen_ty_1, S_addr) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of in_addr"][::std::mem::size_of::<in_addr>() - 4usize];
    ["Alignment of in_addr"][::std::mem::align_of::<in_addr>() - 4usize];
    ["Offset of field: in_addr::S_un"][::std::mem::offset_of!(in_addr, S_un) - 0usize];
};
pub type IN_ADDR = in_addr;
pub type PIN_ADDR = *mut in_addr;
pub type LPIN_ADDR = *mut in_addr;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct sockaddr_in {
    pub sin_family: ::std::os::raw::c_short,
    pub sin_port: u_short,
    pub sin_addr: in_addr,
    pub sin_zero: [::std::os::raw::c_char; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of sockaddr_in"][::std::mem::size_of::<sockaddr_in>() - 16usize];
    ["Alignment of sockaddr_in"][::std::mem::align_of::<sockaddr_in>() - 4usize];
    ["Offset of field: sockaddr_in::sin_family"]
        [::std::mem::offset_of!(sockaddr_in, sin_family) - 0usize];
    ["Offset of field: sockaddr_in::sin_port"]
        [::std::mem::offset_of!(sockaddr_in, sin_port) - 2usize];
    ["Offset of field: sockaddr_in::sin_addr"]
        [::std::mem::offset_of!(sockaddr_in, sin_addr) - 4usize];
    ["Offset of field: sockaddr_in::sin_zero"]
        [::std::mem::offset_of!(sockaddr_in, sin_zero) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct WSAData {
    pub wVersion: WORD,
    pub wHighVersion: WORD,
    pub iMaxSockets: ::std::os::raw::c_ushort,
    pub iMaxUdpDg: ::std::os::raw::c_ushort,
    pub lpVendorInfo: *mut ::std::os::raw::c_char,
    pub szDescription: [::std::os::raw::c_char; 257usize],
    pub szSystemStatus: [::std::os::raw::c_char; 129usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of WSAData"][::std::mem::size_of::<WSAData>() - 408usize];
    ["Alignment of WSAData"][::std::mem::align_of::<WSAData>() - 8usize];
    ["Offset of field: WSAData::wVersion"][::std::mem::offset_of!(WSAData, wVersion) - 0usize];
    ["Offset of field: WSAData::wHighVersion"]
        [::std::mem::offset_of!(WSAData, wHighVersion) - 2usize];
    ["Offset of field: WSAData::iMaxSockets"]
        [::std::mem::offset_of!(WSAData, iMaxSockets) - 4usize];
    ["Offset of field: WSAData::iMaxUdpDg"][::std::mem::offset_of!(WSAData, iMaxUdpDg) - 6usize];
    ["Offset of field: WSAData::lpVendorInfo"]
        [::std::mem::offset_of!(WSAData, lpVendorInfo) - 8usize];
    ["Offset of field: WSAData::szDescription"]
        [::std::mem::offset_of!(WSAData, szDescription) - 16usize];
    ["Offset of field: WSAData::szSystemStatus"]
        [::std::mem::offset_of!(WSAData, szSystemStatus) - 273usize];
};
pub type WSADATA = WSAData;
pub type LPWSADATA = *mut WSADATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct ip_mreq {
    pub imr_multiaddr: in_addr,
    pub imr_interface: in_addr,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ip_mreq"][::std::mem::size_of::<ip_mreq>() - 8usize];
    ["Alignment of ip_mreq"][::std::mem::align_of::<ip_mreq>() - 4usize];
    ["Offset of field: ip_mreq::imr_multiaddr"]
        [::std::mem::offset_of!(ip_mreq, imr_multiaddr) - 0usize];
    ["Offset of field: ip_mreq::imr_interface"]
        [::std::mem::offset_of!(ip_mreq, imr_interface) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct sockaddr {
    pub sa_family: u_short,
    pub sa_data: [::std::os::raw::c_char; 14usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of sockaddr"][::std::mem::size_of::<sockaddr>() - 16usize];
    ["Alignment of sockaddr"][::std::mem::align_of::<sockaddr>() - 2usize];
    ["Offset of field: sockaddr::sa_family"][::std::mem::offset_of!(sockaddr, sa_family) - 0usize];
    ["Offset of field: sockaddr::sa_data"][::std::mem::offset_of!(sockaddr, sa_data) - 2usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct sockproto {
    pub sp_family: u_short,
    pub sp_protocol: u_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of sockproto"][::std::mem::size_of::<sockproto>() - 4usize];
    ["Alignment of sockproto"][::std::mem::align_of::<sockproto>() - 2usize];
    ["Offset of field: sockproto::sp_family"]
        [::std::mem::offset_of!(sockproto, sp_family) - 0usize];
    ["Offset of field: sockproto::sp_protocol"]
        [::std::mem::offset_of!(sockproto, sp_protocol) - 2usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct linger {
    pub l_onoff: u_short,
    pub l_linger: u_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of linger"][::std::mem::size_of::<linger>() - 4usize];
    ["Alignment of linger"][::std::mem::align_of::<linger>() - 2usize];
    ["Offset of field: linger::l_onoff"][::std::mem::offset_of!(linger, l_onoff) - 0usize];
    ["Offset of field: linger::l_linger"][::std::mem::offset_of!(linger, l_linger) - 2usize];
};
unsafe extern "C" {
    pub fn accept(s: SOCKET, addr: *mut sockaddr, addrlen: *mut ::std::os::raw::c_int) -> SOCKET;
}
unsafe extern "C" {
    pub fn bind(
        s: SOCKET,
        addr: *const sockaddr,
        namelen: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn closesocket(s: SOCKET) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn connect(
        s: SOCKET,
        name: *const sockaddr,
        namelen: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ioctlsocket(
        s: SOCKET,
        cmd: ::std::os::raw::c_long,
        argp: *mut u_long,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn getpeername(
        s: SOCKET,
        name: *mut sockaddr,
        namelen: *mut ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn getsockname(
        s: SOCKET,
        name: *mut sockaddr,
        namelen: *mut ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn getsockopt(
        s: SOCKET,
        level: ::std::os::raw::c_int,
        optname: ::std::os::raw::c_int,
        optval: *mut ::std::os::raw::c_char,
        optlen: *mut ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn htonl(hostlong: u_long) -> u_long;
}
unsafe extern "C" {
    pub fn htons(hostshort: u_short) -> u_short;
}
unsafe extern "C" {
    pub fn inet_addr(cp: *const ::std::os::raw::c_char) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn inet_ntoa(in_: in_addr) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn listen(s: SOCKET, backlog: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn ntohl(netlong: u_long) -> u_long;
}
unsafe extern "C" {
    pub fn ntohs(netshort: u_short) -> u_short;
}
unsafe extern "C" {
    pub fn recv(
        s: SOCKET,
        buf: *mut ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        flags: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn recvfrom(
        s: SOCKET,
        buf: *mut ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        flags: ::std::os::raw::c_int,
        from: *mut sockaddr,
        fromlen: *mut ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn select(
        nfds: ::std::os::raw::c_int,
        readfds: *mut fd_set,
        writefds: *mut fd_set,
        exceptfds: *mut fd_set,
        timeout: *const timeval,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn send(
        s: SOCKET,
        buf: *const ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        flags: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn sendto(
        s: SOCKET,
        buf: *const ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        flags: ::std::os::raw::c_int,
        to: *const sockaddr,
        tolen: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn setsockopt(
        s: SOCKET,
        level: ::std::os::raw::c_int,
        optname: ::std::os::raw::c_int,
        optval: *const ::std::os::raw::c_char,
        optlen: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn shutdown(s: SOCKET, how: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn socket(
        af: ::std::os::raw::c_int,
        type_: ::std::os::raw::c_int,
        protocol: ::std::os::raw::c_int,
    ) -> SOCKET;
}
unsafe extern "C" {
    pub fn gethostbyaddr(
        addr: *const ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        type_: ::std::os::raw::c_int,
    ) -> *mut hostent;
}
unsafe extern "C" {
    pub fn gethostbyname(name: *const ::std::os::raw::c_char) -> *mut hostent;
}
unsafe extern "C" {
    pub fn gethostname(
        name: *mut ::std::os::raw::c_char,
        namelen: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn getservbyport(
        port: ::std::os::raw::c_int,
        proto: *const ::std::os::raw::c_char,
    ) -> *mut servent;
}
unsafe extern "C" {
    pub fn getservbyname(
        name: *const ::std::os::raw::c_char,
        proto: *const ::std::os::raw::c_char,
    ) -> *mut servent;
}
unsafe extern "C" {
    pub fn getprotobynumber(proto: ::std::os::raw::c_int) -> *mut protoent;
}
unsafe extern "C" {
    pub fn getprotobyname(name: *const ::std::os::raw::c_char) -> *mut protoent;
}
unsafe extern "C" {
    pub fn WSAStartup(wVersionRequired: WORD, lpWSAData: LPWSADATA) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSACleanup() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSASetLastError(iError: ::std::os::raw::c_int);
}
unsafe extern "C" {
    pub fn WSAGetLastError() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSAIsBlocking() -> BOOL;
}
unsafe extern "C" {
    pub fn WSAUnhookBlockingHook() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSASetBlockingHook(lpBlockFunc: FARPROC) -> FARPROC;
}
unsafe extern "C" {
    pub fn WSACancelBlockingCall() -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSAAsyncGetServByName(
        hWnd: HWND,
        wMsg: u_int,
        name: *const ::std::os::raw::c_char,
        proto: *const ::std::os::raw::c_char,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSAAsyncGetServByPort(
        hWnd: HWND,
        wMsg: u_int,
        port: ::std::os::raw::c_int,
        proto: *const ::std::os::raw::c_char,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSAAsyncGetProtoByName(
        hWnd: HWND,
        wMsg: u_int,
        name: *const ::std::os::raw::c_char,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSAAsyncGetProtoByNumber(
        hWnd: HWND,
        wMsg: u_int,
        number: ::std::os::raw::c_int,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSAAsyncGetHostByName(
        hWnd: HWND,
        wMsg: u_int,
        name: *const ::std::os::raw::c_char,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSAAsyncGetHostByAddr(
        hWnd: HWND,
        wMsg: u_int,
        addr: *const ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        type_: ::std::os::raw::c_int,
        buf: *mut ::std::os::raw::c_char,
        buflen: ::std::os::raw::c_int,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn WSACancelAsyncRequest(hAsyncTaskHandle: HANDLE) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSAAsyncSelect(
        s: SOCKET,
        hWnd: HWND,
        wMsg: u_int,
        lEvent: ::std::os::raw::c_long,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn WSARecvEx(
        s: SOCKET,
        buf: *mut ::std::os::raw::c_char,
        len: ::std::os::raw::c_int,
        flags: *mut ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TRANSMIT_FILE_BUFFERS {
    pub Head: PVOID,
    pub HeadLength: DWORD,
    pub Tail: PVOID,
    pub TailLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TRANSMIT_FILE_BUFFERS"][::std::mem::size_of::<_TRANSMIT_FILE_BUFFERS>() - 32usize];
    ["Alignment of _TRANSMIT_FILE_BUFFERS"]
        [::std::mem::align_of::<_TRANSMIT_FILE_BUFFERS>() - 8usize];
    ["Offset of field: _TRANSMIT_FILE_BUFFERS::Head"]
        [::std::mem::offset_of!(_TRANSMIT_FILE_BUFFERS, Head) - 0usize];
    ["Offset of field: _TRANSMIT_FILE_BUFFERS::HeadLength"]
        [::std::mem::offset_of!(_TRANSMIT_FILE_BUFFERS, HeadLength) - 8usize];
    ["Offset of field: _TRANSMIT_FILE_BUFFERS::Tail"]
        [::std::mem::offset_of!(_TRANSMIT_FILE_BUFFERS, Tail) - 16usize];
    ["Offset of field: _TRANSMIT_FILE_BUFFERS::TailLength"]
        [::std::mem::offset_of!(_TRANSMIT_FILE_BUFFERS, TailLength) - 24usize];
};
pub type TRANSMIT_FILE_BUFFERS = _TRANSMIT_FILE_BUFFERS;
pub type PTRANSMIT_FILE_BUFFERS = *mut _TRANSMIT_FILE_BUFFERS;
pub type LPTRANSMIT_FILE_BUFFERS = *mut _TRANSMIT_FILE_BUFFERS;
unsafe extern "C" {
    pub fn TransmitFile(
        hSocket: SOCKET,
        hFile: HANDLE,
        nNumberOfBytesToWrite: DWORD,
        nNumberOfBytesPerSend: DWORD,
        lpOverlapped: LPOVERLAPPED,
        lpTransmitBuffers: LPTRANSMIT_FILE_BUFFERS,
        dwReserved: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AcceptEx(
        sListenSocket: SOCKET,
        sAcceptSocket: SOCKET,
        lpOutputBuffer: PVOID,
        dwReceiveDataLength: DWORD,
        dwLocalAddressLength: DWORD,
        dwRemoteAddressLength: DWORD,
        lpdwBytesReceived: LPDWORD,
        lpOverlapped: LPOVERLAPPED,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetAcceptExSockaddrs(
        lpOutputBuffer: PVOID,
        dwReceiveDataLength: DWORD,
        dwLocalAddressLength: DWORD,
        dwRemoteAddressLength: DWORD,
        LocalSockaddr: *mut *mut sockaddr,
        LocalSockaddrLength: LPINT,
        RemoteSockaddr: *mut *mut sockaddr,
        RemoteSockaddrLength: LPINT,
    );
}
pub type SOCKADDR = sockaddr;
pub type PSOCKADDR = *mut sockaddr;
pub type LPSOCKADDR = *mut sockaddr;
pub type SOCKADDR_IN = sockaddr_in;
pub type PSOCKADDR_IN = *mut sockaddr_in;
pub type LPSOCKADDR_IN = *mut sockaddr_in;
pub type LINGER = linger;
pub type PLINGER = *mut linger;
pub type LPLINGER = *mut linger;
pub type FD_SET = fd_set;
pub type PFD_SET = *mut fd_set;
pub type LPFD_SET = *mut fd_set;
pub type HOSTENT = hostent;
pub type PHOSTENT = *mut hostent;
pub type LPHOSTENT = *mut hostent;
pub type SERVENT = servent;
pub type PSERVENT = *mut servent;
pub type LPSERVENT = *mut servent;
pub type PROTOENT = protoent;
pub type PPROTOENT = *mut protoent;
pub type LPPROTOENT = *mut protoent;
pub type TIMEVAL = timeval;
pub type PTIMEVAL = *mut timeval;
pub type LPTIMEVAL = *mut timeval;
pub type ALG_ID = ::std::os::raw::c_uint;
pub type HCRYPTPROV = ULONG_PTR;
pub type HCRYPTKEY = ULONG_PTR;
pub type HCRYPTHASH = ULONG_PTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMS_KEY_INFO {
    pub dwVersion: DWORD,
    pub Algid: ALG_ID,
    pub pbOID: *mut BYTE,
    pub cbOID: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMS_KEY_INFO"][::std::mem::size_of::<_CMS_KEY_INFO>() - 24usize];
    ["Alignment of _CMS_KEY_INFO"][::std::mem::align_of::<_CMS_KEY_INFO>() - 8usize];
    ["Offset of field: _CMS_KEY_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMS_KEY_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMS_KEY_INFO::Algid"]
        [::std::mem::offset_of!(_CMS_KEY_INFO, Algid) - 4usize];
    ["Offset of field: _CMS_KEY_INFO::pbOID"]
        [::std::mem::offset_of!(_CMS_KEY_INFO, pbOID) - 8usize];
    ["Offset of field: _CMS_KEY_INFO::cbOID"]
        [::std::mem::offset_of!(_CMS_KEY_INFO, cbOID) - 16usize];
};
pub type CMS_KEY_INFO = _CMS_KEY_INFO;
pub type PCMS_KEY_INFO = *mut _CMS_KEY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HMAC_Info {
    pub HashAlgid: ALG_ID,
    pub pbInnerString: *mut BYTE,
    pub cbInnerString: DWORD,
    pub pbOuterString: *mut BYTE,
    pub cbOuterString: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HMAC_Info"][::std::mem::size_of::<_HMAC_Info>() - 40usize];
    ["Alignment of _HMAC_Info"][::std::mem::align_of::<_HMAC_Info>() - 8usize];
    ["Offset of field: _HMAC_Info::HashAlgid"]
        [::std::mem::offset_of!(_HMAC_Info, HashAlgid) - 0usize];
    ["Offset of field: _HMAC_Info::pbInnerString"]
        [::std::mem::offset_of!(_HMAC_Info, pbInnerString) - 8usize];
    ["Offset of field: _HMAC_Info::cbInnerString"]
        [::std::mem::offset_of!(_HMAC_Info, cbInnerString) - 16usize];
    ["Offset of field: _HMAC_Info::pbOuterString"]
        [::std::mem::offset_of!(_HMAC_Info, pbOuterString) - 24usize];
    ["Offset of field: _HMAC_Info::cbOuterString"]
        [::std::mem::offset_of!(_HMAC_Info, cbOuterString) - 32usize];
};
pub type HMAC_INFO = _HMAC_Info;
pub type PHMAC_INFO = *mut _HMAC_Info;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCHANNEL_ALG {
    pub dwUse: DWORD,
    pub Algid: ALG_ID,
    pub cBits: DWORD,
    pub dwFlags: DWORD,
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCHANNEL_ALG"][::std::mem::size_of::<_SCHANNEL_ALG>() - 20usize];
    ["Alignment of _SCHANNEL_ALG"][::std::mem::align_of::<_SCHANNEL_ALG>() - 4usize];
    ["Offset of field: _SCHANNEL_ALG::dwUse"]
        [::std::mem::offset_of!(_SCHANNEL_ALG, dwUse) - 0usize];
    ["Offset of field: _SCHANNEL_ALG::Algid"]
        [::std::mem::offset_of!(_SCHANNEL_ALG, Algid) - 4usize];
    ["Offset of field: _SCHANNEL_ALG::cBits"]
        [::std::mem::offset_of!(_SCHANNEL_ALG, cBits) - 8usize];
    ["Offset of field: _SCHANNEL_ALG::dwFlags"]
        [::std::mem::offset_of!(_SCHANNEL_ALG, dwFlags) - 12usize];
    ["Offset of field: _SCHANNEL_ALG::dwReserved"]
        [::std::mem::offset_of!(_SCHANNEL_ALG, dwReserved) - 16usize];
};
pub type SCHANNEL_ALG = _SCHANNEL_ALG;
pub type PSCHANNEL_ALG = *mut _SCHANNEL_ALG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROV_ENUMALGS {
    pub aiAlgid: ALG_ID,
    pub dwBitLen: DWORD,
    pub dwNameLen: DWORD,
    pub szName: [CHAR; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROV_ENUMALGS"][::std::mem::size_of::<_PROV_ENUMALGS>() - 32usize];
    ["Alignment of _PROV_ENUMALGS"][::std::mem::align_of::<_PROV_ENUMALGS>() - 4usize];
    ["Offset of field: _PROV_ENUMALGS::aiAlgid"]
        [::std::mem::offset_of!(_PROV_ENUMALGS, aiAlgid) - 0usize];
    ["Offset of field: _PROV_ENUMALGS::dwBitLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS, dwBitLen) - 4usize];
    ["Offset of field: _PROV_ENUMALGS::dwNameLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS, dwNameLen) - 8usize];
    ["Offset of field: _PROV_ENUMALGS::szName"]
        [::std::mem::offset_of!(_PROV_ENUMALGS, szName) - 12usize];
};
pub type PROV_ENUMALGS = _PROV_ENUMALGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROV_ENUMALGS_EX {
    pub aiAlgid: ALG_ID,
    pub dwDefaultLen: DWORD,
    pub dwMinLen: DWORD,
    pub dwMaxLen: DWORD,
    pub dwProtocols: DWORD,
    pub dwNameLen: DWORD,
    pub szName: [CHAR; 20usize],
    pub dwLongNameLen: DWORD,
    pub szLongName: [CHAR; 40usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROV_ENUMALGS_EX"][::std::mem::size_of::<_PROV_ENUMALGS_EX>() - 88usize];
    ["Alignment of _PROV_ENUMALGS_EX"][::std::mem::align_of::<_PROV_ENUMALGS_EX>() - 4usize];
    ["Offset of field: _PROV_ENUMALGS_EX::aiAlgid"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, aiAlgid) - 0usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwDefaultLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwDefaultLen) - 4usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwMinLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwMinLen) - 8usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwMaxLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwMaxLen) - 12usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwProtocols"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwProtocols) - 16usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwNameLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwNameLen) - 20usize];
    ["Offset of field: _PROV_ENUMALGS_EX::szName"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, szName) - 24usize];
    ["Offset of field: _PROV_ENUMALGS_EX::dwLongNameLen"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, dwLongNameLen) - 44usize];
    ["Offset of field: _PROV_ENUMALGS_EX::szLongName"]
        [::std::mem::offset_of!(_PROV_ENUMALGS_EX, szLongName) - 48usize];
};
pub type PROV_ENUMALGS_EX = _PROV_ENUMALGS_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PUBLICKEYSTRUC {
    pub bType: BYTE,
    pub bVersion: BYTE,
    pub reserved: WORD,
    pub aiKeyAlg: ALG_ID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PUBLICKEYSTRUC"][::std::mem::size_of::<_PUBLICKEYSTRUC>() - 8usize];
    ["Alignment of _PUBLICKEYSTRUC"][::std::mem::align_of::<_PUBLICKEYSTRUC>() - 4usize];
    ["Offset of field: _PUBLICKEYSTRUC::bType"]
        [::std::mem::offset_of!(_PUBLICKEYSTRUC, bType) - 0usize];
    ["Offset of field: _PUBLICKEYSTRUC::bVersion"]
        [::std::mem::offset_of!(_PUBLICKEYSTRUC, bVersion) - 1usize];
    ["Offset of field: _PUBLICKEYSTRUC::reserved"]
        [::std::mem::offset_of!(_PUBLICKEYSTRUC, reserved) - 2usize];
    ["Offset of field: _PUBLICKEYSTRUC::aiKeyAlg"]
        [::std::mem::offset_of!(_PUBLICKEYSTRUC, aiKeyAlg) - 4usize];
};
pub type BLOBHEADER = _PUBLICKEYSTRUC;
pub type PUBLICKEYSTRUC = _PUBLICKEYSTRUC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _RSAPUBKEY {
    pub magic: DWORD,
    pub bitlen: DWORD,
    pub pubexp: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RSAPUBKEY"][::std::mem::size_of::<_RSAPUBKEY>() - 12usize];
    ["Alignment of _RSAPUBKEY"][::std::mem::align_of::<_RSAPUBKEY>() - 4usize];
    ["Offset of field: _RSAPUBKEY::magic"][::std::mem::offset_of!(_RSAPUBKEY, magic) - 0usize];
    ["Offset of field: _RSAPUBKEY::bitlen"][::std::mem::offset_of!(_RSAPUBKEY, bitlen) - 4usize];
    ["Offset of field: _RSAPUBKEY::pubexp"][::std::mem::offset_of!(_RSAPUBKEY, pubexp) - 8usize];
};
pub type RSAPUBKEY = _RSAPUBKEY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PUBKEY {
    pub magic: DWORD,
    pub bitlen: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PUBKEY"][::std::mem::size_of::<_PUBKEY>() - 8usize];
    ["Alignment of _PUBKEY"][::std::mem::align_of::<_PUBKEY>() - 4usize];
    ["Offset of field: _PUBKEY::magic"][::std::mem::offset_of!(_PUBKEY, magic) - 0usize];
    ["Offset of field: _PUBKEY::bitlen"][::std::mem::offset_of!(_PUBKEY, bitlen) - 4usize];
};
pub type DHPUBKEY = _PUBKEY;
pub type DSSPUBKEY = _PUBKEY;
pub type KEAPUBKEY = _PUBKEY;
pub type TEKPUBKEY = _PUBKEY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DSSSEED {
    pub counter: DWORD,
    pub seed: [BYTE; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DSSSEED"][::std::mem::size_of::<_DSSSEED>() - 24usize];
    ["Alignment of _DSSSEED"][::std::mem::align_of::<_DSSSEED>() - 4usize];
    ["Offset of field: _DSSSEED::counter"][::std::mem::offset_of!(_DSSSEED, counter) - 0usize];
    ["Offset of field: _DSSSEED::seed"][::std::mem::offset_of!(_DSSSEED, seed) - 4usize];
};
pub type DSSSEED = _DSSSEED;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PUBKEYVER3 {
    pub magic: DWORD,
    pub bitlenP: DWORD,
    pub bitlenQ: DWORD,
    pub bitlenJ: DWORD,
    pub DSSSeed: DSSSEED,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PUBKEYVER3"][::std::mem::size_of::<_PUBKEYVER3>() - 40usize];
    ["Alignment of _PUBKEYVER3"][::std::mem::align_of::<_PUBKEYVER3>() - 4usize];
    ["Offset of field: _PUBKEYVER3::magic"][::std::mem::offset_of!(_PUBKEYVER3, magic) - 0usize];
    ["Offset of field: _PUBKEYVER3::bitlenP"]
        [::std::mem::offset_of!(_PUBKEYVER3, bitlenP) - 4usize];
    ["Offset of field: _PUBKEYVER3::bitlenQ"]
        [::std::mem::offset_of!(_PUBKEYVER3, bitlenQ) - 8usize];
    ["Offset of field: _PUBKEYVER3::bitlenJ"]
        [::std::mem::offset_of!(_PUBKEYVER3, bitlenJ) - 12usize];
    ["Offset of field: _PUBKEYVER3::DSSSeed"]
        [::std::mem::offset_of!(_PUBKEYVER3, DSSSeed) - 16usize];
};
pub type DHPUBKEY_VER3 = _PUBKEYVER3;
pub type DSSPUBKEY_VER3 = _PUBKEYVER3;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRIVKEYVER3 {
    pub magic: DWORD,
    pub bitlenP: DWORD,
    pub bitlenQ: DWORD,
    pub bitlenJ: DWORD,
    pub bitlenX: DWORD,
    pub DSSSeed: DSSSEED,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRIVKEYVER3"][::std::mem::size_of::<_PRIVKEYVER3>() - 44usize];
    ["Alignment of _PRIVKEYVER3"][::std::mem::align_of::<_PRIVKEYVER3>() - 4usize];
    ["Offset of field: _PRIVKEYVER3::magic"][::std::mem::offset_of!(_PRIVKEYVER3, magic) - 0usize];
    ["Offset of field: _PRIVKEYVER3::bitlenP"]
        [::std::mem::offset_of!(_PRIVKEYVER3, bitlenP) - 4usize];
    ["Offset of field: _PRIVKEYVER3::bitlenQ"]
        [::std::mem::offset_of!(_PRIVKEYVER3, bitlenQ) - 8usize];
    ["Offset of field: _PRIVKEYVER3::bitlenJ"]
        [::std::mem::offset_of!(_PRIVKEYVER3, bitlenJ) - 12usize];
    ["Offset of field: _PRIVKEYVER3::bitlenX"]
        [::std::mem::offset_of!(_PRIVKEYVER3, bitlenX) - 16usize];
    ["Offset of field: _PRIVKEYVER3::DSSSeed"]
        [::std::mem::offset_of!(_PRIVKEYVER3, DSSSeed) - 20usize];
};
pub type DHPRIVKEY_VER3 = _PRIVKEYVER3;
pub type DSSPRIVKEY_VER3 = _PRIVKEYVER3;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _KEY_TYPE_SUBTYPE {
    pub dwKeySpec: DWORD,
    pub Type: GUID,
    pub Subtype: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _KEY_TYPE_SUBTYPE"][::std::mem::size_of::<_KEY_TYPE_SUBTYPE>() - 36usize];
    ["Alignment of _KEY_TYPE_SUBTYPE"][::std::mem::align_of::<_KEY_TYPE_SUBTYPE>() - 4usize];
    ["Offset of field: _KEY_TYPE_SUBTYPE::dwKeySpec"]
        [::std::mem::offset_of!(_KEY_TYPE_SUBTYPE, dwKeySpec) - 0usize];
    ["Offset of field: _KEY_TYPE_SUBTYPE::Type"]
        [::std::mem::offset_of!(_KEY_TYPE_SUBTYPE, Type) - 4usize];
    ["Offset of field: _KEY_TYPE_SUBTYPE::Subtype"]
        [::std::mem::offset_of!(_KEY_TYPE_SUBTYPE, Subtype) - 20usize];
};
pub type KEY_TYPE_SUBTYPE = _KEY_TYPE_SUBTYPE;
pub type PKEY_TYPE_SUBTYPE = *mut _KEY_TYPE_SUBTYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_FORTEZZA_DATA_PROP {
    pub SerialNumber: [::std::os::raw::c_uchar; 8usize],
    pub CertIndex: ::std::os::raw::c_int,
    pub CertLabel: [::std::os::raw::c_uchar; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_FORTEZZA_DATA_PROP"]
        [::std::mem::size_of::<_CERT_FORTEZZA_DATA_PROP>() - 48usize];
    ["Alignment of _CERT_FORTEZZA_DATA_PROP"]
        [::std::mem::align_of::<_CERT_FORTEZZA_DATA_PROP>() - 4usize];
    ["Offset of field: _CERT_FORTEZZA_DATA_PROP::SerialNumber"]
        [::std::mem::offset_of!(_CERT_FORTEZZA_DATA_PROP, SerialNumber) - 0usize];
    ["Offset of field: _CERT_FORTEZZA_DATA_PROP::CertIndex"]
        [::std::mem::offset_of!(_CERT_FORTEZZA_DATA_PROP, CertIndex) - 8usize];
    ["Offset of field: _CERT_FORTEZZA_DATA_PROP::CertLabel"]
        [::std::mem::offset_of!(_CERT_FORTEZZA_DATA_PROP, CertLabel) - 12usize];
};
pub type CERT_FORTEZZA_DATA_PROP = _CERT_FORTEZZA_DATA_PROP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_RC4_KEY_STATE {
    pub Key: [::std::os::raw::c_uchar; 16usize],
    pub SBox: [::std::os::raw::c_uchar; 256usize],
    pub i: ::std::os::raw::c_uchar,
    pub j: ::std::os::raw::c_uchar,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_RC4_KEY_STATE"][::std::mem::size_of::<_CRYPT_RC4_KEY_STATE>() - 274usize];
    ["Alignment of _CRYPT_RC4_KEY_STATE"][::std::mem::align_of::<_CRYPT_RC4_KEY_STATE>() - 1usize];
    ["Offset of field: _CRYPT_RC4_KEY_STATE::Key"]
        [::std::mem::offset_of!(_CRYPT_RC4_KEY_STATE, Key) - 0usize];
    ["Offset of field: _CRYPT_RC4_KEY_STATE::SBox"]
        [::std::mem::offset_of!(_CRYPT_RC4_KEY_STATE, SBox) - 16usize];
    ["Offset of field: _CRYPT_RC4_KEY_STATE::i"]
        [::std::mem::offset_of!(_CRYPT_RC4_KEY_STATE, i) - 272usize];
    ["Offset of field: _CRYPT_RC4_KEY_STATE::j"]
        [::std::mem::offset_of!(_CRYPT_RC4_KEY_STATE, j) - 273usize];
};
pub type CRYPT_RC4_KEY_STATE = _CRYPT_RC4_KEY_STATE;
pub type PCRYPT_RC4_KEY_STATE = *mut _CRYPT_RC4_KEY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_DES_KEY_STATE {
    pub Key: [::std::os::raw::c_uchar; 8usize],
    pub IV: [::std::os::raw::c_uchar; 8usize],
    pub Feedback: [::std::os::raw::c_uchar; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_DES_KEY_STATE"][::std::mem::size_of::<_CRYPT_DES_KEY_STATE>() - 24usize];
    ["Alignment of _CRYPT_DES_KEY_STATE"][::std::mem::align_of::<_CRYPT_DES_KEY_STATE>() - 1usize];
    ["Offset of field: _CRYPT_DES_KEY_STATE::Key"]
        [::std::mem::offset_of!(_CRYPT_DES_KEY_STATE, Key) - 0usize];
    ["Offset of field: _CRYPT_DES_KEY_STATE::IV"]
        [::std::mem::offset_of!(_CRYPT_DES_KEY_STATE, IV) - 8usize];
    ["Offset of field: _CRYPT_DES_KEY_STATE::Feedback"]
        [::std::mem::offset_of!(_CRYPT_DES_KEY_STATE, Feedback) - 16usize];
};
pub type CRYPT_DES_KEY_STATE = _CRYPT_DES_KEY_STATE;
pub type PCRYPT_DES_KEY_STATE = *mut _CRYPT_DES_KEY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_3DES_KEY_STATE {
    pub Key: [::std::os::raw::c_uchar; 24usize],
    pub IV: [::std::os::raw::c_uchar; 8usize],
    pub Feedback: [::std::os::raw::c_uchar; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_3DES_KEY_STATE"][::std::mem::size_of::<_CRYPT_3DES_KEY_STATE>() - 40usize];
    ["Alignment of _CRYPT_3DES_KEY_STATE"]
        [::std::mem::align_of::<_CRYPT_3DES_KEY_STATE>() - 1usize];
    ["Offset of field: _CRYPT_3DES_KEY_STATE::Key"]
        [::std::mem::offset_of!(_CRYPT_3DES_KEY_STATE, Key) - 0usize];
    ["Offset of field: _CRYPT_3DES_KEY_STATE::IV"]
        [::std::mem::offset_of!(_CRYPT_3DES_KEY_STATE, IV) - 24usize];
    ["Offset of field: _CRYPT_3DES_KEY_STATE::Feedback"]
        [::std::mem::offset_of!(_CRYPT_3DES_KEY_STATE, Feedback) - 32usize];
};
pub type CRYPT_3DES_KEY_STATE = _CRYPT_3DES_KEY_STATE;
pub type PCRYPT_3DES_KEY_STATE = *mut _CRYPT_3DES_KEY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_AES_128_KEY_STATE {
    pub Key: [::std::os::raw::c_uchar; 16usize],
    pub IV: [::std::os::raw::c_uchar; 16usize],
    pub EncryptionState: [[::std::os::raw::c_uchar; 16usize]; 11usize],
    pub DecryptionState: [[::std::os::raw::c_uchar; 16usize]; 11usize],
    pub Feedback: [::std::os::raw::c_uchar; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_AES_128_KEY_STATE"]
        [::std::mem::size_of::<_CRYPT_AES_128_KEY_STATE>() - 400usize];
    ["Alignment of _CRYPT_AES_128_KEY_STATE"]
        [::std::mem::align_of::<_CRYPT_AES_128_KEY_STATE>() - 1usize];
    ["Offset of field: _CRYPT_AES_128_KEY_STATE::Key"]
        [::std::mem::offset_of!(_CRYPT_AES_128_KEY_STATE, Key) - 0usize];
    ["Offset of field: _CRYPT_AES_128_KEY_STATE::IV"]
        [::std::mem::offset_of!(_CRYPT_AES_128_KEY_STATE, IV) - 16usize];
    ["Offset of field: _CRYPT_AES_128_KEY_STATE::EncryptionState"]
        [::std::mem::offset_of!(_CRYPT_AES_128_KEY_STATE, EncryptionState) - 32usize];
    ["Offset of field: _CRYPT_AES_128_KEY_STATE::DecryptionState"]
        [::std::mem::offset_of!(_CRYPT_AES_128_KEY_STATE, DecryptionState) - 208usize];
    ["Offset of field: _CRYPT_AES_128_KEY_STATE::Feedback"]
        [::std::mem::offset_of!(_CRYPT_AES_128_KEY_STATE, Feedback) - 384usize];
};
pub type CRYPT_AES_128_KEY_STATE = _CRYPT_AES_128_KEY_STATE;
pub type PCRYPT_AES_128_KEY_STATE = *mut _CRYPT_AES_128_KEY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_AES_256_KEY_STATE {
    pub Key: [::std::os::raw::c_uchar; 32usize],
    pub IV: [::std::os::raw::c_uchar; 16usize],
    pub EncryptionState: [[::std::os::raw::c_uchar; 16usize]; 15usize],
    pub DecryptionState: [[::std::os::raw::c_uchar; 16usize]; 15usize],
    pub Feedback: [::std::os::raw::c_uchar; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_AES_256_KEY_STATE"]
        [::std::mem::size_of::<_CRYPT_AES_256_KEY_STATE>() - 544usize];
    ["Alignment of _CRYPT_AES_256_KEY_STATE"]
        [::std::mem::align_of::<_CRYPT_AES_256_KEY_STATE>() - 1usize];
    ["Offset of field: _CRYPT_AES_256_KEY_STATE::Key"]
        [::std::mem::offset_of!(_CRYPT_AES_256_KEY_STATE, Key) - 0usize];
    ["Offset of field: _CRYPT_AES_256_KEY_STATE::IV"]
        [::std::mem::offset_of!(_CRYPT_AES_256_KEY_STATE, IV) - 32usize];
    ["Offset of field: _CRYPT_AES_256_KEY_STATE::EncryptionState"]
        [::std::mem::offset_of!(_CRYPT_AES_256_KEY_STATE, EncryptionState) - 48usize];
    ["Offset of field: _CRYPT_AES_256_KEY_STATE::DecryptionState"]
        [::std::mem::offset_of!(_CRYPT_AES_256_KEY_STATE, DecryptionState) - 288usize];
    ["Offset of field: _CRYPT_AES_256_KEY_STATE::Feedback"]
        [::std::mem::offset_of!(_CRYPT_AES_256_KEY_STATE, Feedback) - 528usize];
};
pub type CRYPT_AES_256_KEY_STATE = _CRYPT_AES_256_KEY_STATE;
pub type PCRYPT_AES_256_KEY_STATE = *mut _CRYPT_AES_256_KEY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPTOAPI_BLOB {
    pub cbData: DWORD,
    pub pbData: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPTOAPI_BLOB"][::std::mem::size_of::<_CRYPTOAPI_BLOB>() - 16usize];
    ["Alignment of _CRYPTOAPI_BLOB"][::std::mem::align_of::<_CRYPTOAPI_BLOB>() - 8usize];
    ["Offset of field: _CRYPTOAPI_BLOB::cbData"]
        [::std::mem::offset_of!(_CRYPTOAPI_BLOB, cbData) - 0usize];
    ["Offset of field: _CRYPTOAPI_BLOB::pbData"]
        [::std::mem::offset_of!(_CRYPTOAPI_BLOB, pbData) - 8usize];
};
pub type CRYPT_INTEGER_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_INTEGER_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_UINT_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_UINT_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_OBJID_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_OBJID_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CERT_NAME_BLOB = _CRYPTOAPI_BLOB;
pub type PCERT_NAME_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CERT_RDN_VALUE_BLOB = _CRYPTOAPI_BLOB;
pub type PCERT_RDN_VALUE_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CERT_BLOB = _CRYPTOAPI_BLOB;
pub type PCERT_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRL_BLOB = _CRYPTOAPI_BLOB;
pub type PCRL_BLOB = *mut _CRYPTOAPI_BLOB;
pub type DATA_BLOB = _CRYPTOAPI_BLOB;
pub type PDATA_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_DATA_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_DATA_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_HASH_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_HASH_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_DIGEST_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_DIGEST_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_DER_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_DER_BLOB = *mut _CRYPTOAPI_BLOB;
pub type CRYPT_ATTR_BLOB = _CRYPTOAPI_BLOB;
pub type PCRYPT_ATTR_BLOB = *mut _CRYPTOAPI_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMS_DH_KEY_INFO {
    pub dwVersion: DWORD,
    pub Algid: ALG_ID,
    pub pszContentEncObjId: LPSTR,
    pub PubInfo: CRYPT_DATA_BLOB,
    pub pReserved: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMS_DH_KEY_INFO"][::std::mem::size_of::<_CMS_DH_KEY_INFO>() - 40usize];
    ["Alignment of _CMS_DH_KEY_INFO"][::std::mem::align_of::<_CMS_DH_KEY_INFO>() - 8usize];
    ["Offset of field: _CMS_DH_KEY_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMS_DH_KEY_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMS_DH_KEY_INFO::Algid"]
        [::std::mem::offset_of!(_CMS_DH_KEY_INFO, Algid) - 4usize];
    ["Offset of field: _CMS_DH_KEY_INFO::pszContentEncObjId"]
        [::std::mem::offset_of!(_CMS_DH_KEY_INFO, pszContentEncObjId) - 8usize];
    ["Offset of field: _CMS_DH_KEY_INFO::PubInfo"]
        [::std::mem::offset_of!(_CMS_DH_KEY_INFO, PubInfo) - 16usize];
    ["Offset of field: _CMS_DH_KEY_INFO::pReserved"]
        [::std::mem::offset_of!(_CMS_DH_KEY_INFO, pReserved) - 32usize];
};
pub type CMS_DH_KEY_INFO = _CMS_DH_KEY_INFO;
pub type PCMS_DH_KEY_INFO = *mut _CMS_DH_KEY_INFO;
unsafe extern "C" {
    pub fn CryptAcquireContextA(
        phProv: *mut HCRYPTPROV,
        szContainer: LPCSTR,
        szProvider: LPCSTR,
        dwProvType: DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptAcquireContextW(
        phProv: *mut HCRYPTPROV,
        szContainer: LPCWSTR,
        szProvider: LPCWSTR,
        dwProvType: DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptReleaseContext(hProv: HCRYPTPROV, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGenKey(
        hProv: HCRYPTPROV,
        Algid: ALG_ID,
        dwFlags: DWORD,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDeriveKey(
        hProv: HCRYPTPROV,
        Algid: ALG_ID,
        hBaseData: HCRYPTHASH,
        dwFlags: DWORD,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDestroyKey(hKey: HCRYPTKEY) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetKeyParam(
        hKey: HCRYPTKEY,
        dwParam: DWORD,
        pbData: *const BYTE,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetKeyParam(
        hKey: HCRYPTKEY,
        dwParam: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetHashParam(
        hHash: HCRYPTHASH,
        dwParam: DWORD,
        pbData: *const BYTE,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetHashParam(
        hHash: HCRYPTHASH,
        dwParam: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetProvParam(
        hProv: HCRYPTPROV,
        dwParam: DWORD,
        pbData: *const BYTE,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetProvParam(
        hProv: HCRYPTPROV,
        dwParam: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGenRandom(hProv: HCRYPTPROV, dwLen: DWORD, pbBuffer: *mut BYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetUserKey(hProv: HCRYPTPROV, dwKeySpec: DWORD, phUserKey: *mut HCRYPTKEY) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptExportKey(
        hKey: HCRYPTKEY,
        hExpKey: HCRYPTKEY,
        dwBlobType: DWORD,
        dwFlags: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptImportKey(
        hProv: HCRYPTPROV,
        pbData: *const BYTE,
        dwDataLen: DWORD,
        hPubKey: HCRYPTKEY,
        dwFlags: DWORD,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEncrypt(
        hKey: HCRYPTKEY,
        hHash: HCRYPTHASH,
        Final: BOOL,
        dwFlags: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
        dwBufLen: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDecrypt(
        hKey: HCRYPTKEY,
        hHash: HCRYPTHASH,
        Final: BOOL,
        dwFlags: DWORD,
        pbData: *mut BYTE,
        pdwDataLen: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptCreateHash(
        hProv: HCRYPTPROV,
        Algid: ALG_ID,
        hKey: HCRYPTKEY,
        dwFlags: DWORD,
        phHash: *mut HCRYPTHASH,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashData(
        hHash: HCRYPTHASH,
        pbData: *const BYTE,
        dwDataLen: DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashSessionKey(hHash: HCRYPTHASH, hKey: HCRYPTKEY, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDestroyHash(hHash: HCRYPTHASH) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignHashA(
        hHash: HCRYPTHASH,
        dwKeySpec: DWORD,
        szDescription: LPCSTR,
        dwFlags: DWORD,
        pbSignature: *mut BYTE,
        pdwSigLen: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignHashW(
        hHash: HCRYPTHASH,
        dwKeySpec: DWORD,
        szDescription: LPCWSTR,
        dwFlags: DWORD,
        pbSignature: *mut BYTE,
        pdwSigLen: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifySignatureA(
        hHash: HCRYPTHASH,
        pbSignature: *const BYTE,
        dwSigLen: DWORD,
        hPubKey: HCRYPTKEY,
        szDescription: LPCSTR,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifySignatureW(
        hHash: HCRYPTHASH,
        pbSignature: *const BYTE,
        dwSigLen: DWORD,
        hPubKey: HCRYPTKEY,
        szDescription: LPCWSTR,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetProviderA(pszProvName: LPCSTR, dwProvType: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetProviderW(pszProvName: LPCWSTR, dwProvType: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetProviderExA(
        pszProvName: LPCSTR,
        dwProvType: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetProviderExW(
        pszProvName: LPCWSTR,
        dwProvType: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetDefaultProviderA(
        dwProvType: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pszProvName: LPSTR,
        pcbProvName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetDefaultProviderW(
        dwProvType: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pszProvName: LPWSTR,
        pcbProvName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEnumProviderTypesA(
        dwIndex: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pdwProvType: *mut DWORD,
        szTypeName: LPSTR,
        pcbTypeName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEnumProviderTypesW(
        dwIndex: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pdwProvType: *mut DWORD,
        szTypeName: LPWSTR,
        pcbTypeName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEnumProvidersA(
        dwIndex: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pdwProvType: *mut DWORD,
        szProvName: LPSTR,
        pcbProvName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEnumProvidersW(
        dwIndex: DWORD,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        pdwProvType: *mut DWORD,
        szProvName: LPWSTR,
        pcbProvName: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptContextAddRef(hProv: HCRYPTPROV, pdwReserved: *mut DWORD, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDuplicateKey(
        hKey: HCRYPTKEY,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDuplicateHash(
        hHash: HCRYPTHASH,
        pdwReserved: *mut DWORD,
        dwFlags: DWORD,
        phHash: *mut HCRYPTHASH,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetEncSChannel(pData: *mut *mut BYTE, dwDecSize: *mut DWORD) -> BOOL;
}
pub type NTSTATUS = LONG;
pub type PNTSTATUS = *mut NTSTATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __BCRYPT_KEY_LENGTHS_STRUCT {
    pub dwMinLength: ULONG,
    pub dwMaxLength: ULONG,
    pub dwIncrement: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __BCRYPT_KEY_LENGTHS_STRUCT"]
        [::std::mem::size_of::<__BCRYPT_KEY_LENGTHS_STRUCT>() - 12usize];
    ["Alignment of __BCRYPT_KEY_LENGTHS_STRUCT"]
        [::std::mem::align_of::<__BCRYPT_KEY_LENGTHS_STRUCT>() - 4usize];
    ["Offset of field: __BCRYPT_KEY_LENGTHS_STRUCT::dwMinLength"]
        [::std::mem::offset_of!(__BCRYPT_KEY_LENGTHS_STRUCT, dwMinLength) - 0usize];
    ["Offset of field: __BCRYPT_KEY_LENGTHS_STRUCT::dwMaxLength"]
        [::std::mem::offset_of!(__BCRYPT_KEY_LENGTHS_STRUCT, dwMaxLength) - 4usize];
    ["Offset of field: __BCRYPT_KEY_LENGTHS_STRUCT::dwIncrement"]
        [::std::mem::offset_of!(__BCRYPT_KEY_LENGTHS_STRUCT, dwIncrement) - 8usize];
};
pub type BCRYPT_KEY_LENGTHS_STRUCT = __BCRYPT_KEY_LENGTHS_STRUCT;
pub type BCRYPT_AUTH_TAG_LENGTHS_STRUCT = BCRYPT_KEY_LENGTHS_STRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_OID {
    pub cbOID: ULONG,
    pub pbOID: PUCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_OID"][::std::mem::size_of::<_BCRYPT_OID>() - 16usize];
    ["Alignment of _BCRYPT_OID"][::std::mem::align_of::<_BCRYPT_OID>() - 8usize];
    ["Offset of field: _BCRYPT_OID::cbOID"][::std::mem::offset_of!(_BCRYPT_OID, cbOID) - 0usize];
    ["Offset of field: _BCRYPT_OID::pbOID"][::std::mem::offset_of!(_BCRYPT_OID, pbOID) - 8usize];
};
pub type BCRYPT_OID = _BCRYPT_OID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_OID_LIST {
    pub dwOIDCount: ULONG,
    pub pOIDs: *mut BCRYPT_OID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_OID_LIST"][::std::mem::size_of::<_BCRYPT_OID_LIST>() - 16usize];
    ["Alignment of _BCRYPT_OID_LIST"][::std::mem::align_of::<_BCRYPT_OID_LIST>() - 8usize];
    ["Offset of field: _BCRYPT_OID_LIST::dwOIDCount"]
        [::std::mem::offset_of!(_BCRYPT_OID_LIST, dwOIDCount) - 0usize];
    ["Offset of field: _BCRYPT_OID_LIST::pOIDs"]
        [::std::mem::offset_of!(_BCRYPT_OID_LIST, pOIDs) - 8usize];
};
pub type BCRYPT_OID_LIST = _BCRYPT_OID_LIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_PKCS1_PADDING_INFO {
    pub pszAlgId: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_PKCS1_PADDING_INFO"]
        [::std::mem::size_of::<_BCRYPT_PKCS1_PADDING_INFO>() - 8usize];
    ["Alignment of _BCRYPT_PKCS1_PADDING_INFO"]
        [::std::mem::align_of::<_BCRYPT_PKCS1_PADDING_INFO>() - 8usize];
    ["Offset of field: _BCRYPT_PKCS1_PADDING_INFO::pszAlgId"]
        [::std::mem::offset_of!(_BCRYPT_PKCS1_PADDING_INFO, pszAlgId) - 0usize];
};
pub type BCRYPT_PKCS1_PADDING_INFO = _BCRYPT_PKCS1_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_PSS_PADDING_INFO {
    pub pszAlgId: LPCWSTR,
    pub cbSalt: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_PSS_PADDING_INFO"]
        [::std::mem::size_of::<_BCRYPT_PSS_PADDING_INFO>() - 16usize];
    ["Alignment of _BCRYPT_PSS_PADDING_INFO"]
        [::std::mem::align_of::<_BCRYPT_PSS_PADDING_INFO>() - 8usize];
    ["Offset of field: _BCRYPT_PSS_PADDING_INFO::pszAlgId"]
        [::std::mem::offset_of!(_BCRYPT_PSS_PADDING_INFO, pszAlgId) - 0usize];
    ["Offset of field: _BCRYPT_PSS_PADDING_INFO::cbSalt"]
        [::std::mem::offset_of!(_BCRYPT_PSS_PADDING_INFO, cbSalt) - 8usize];
};
pub type BCRYPT_PSS_PADDING_INFO = _BCRYPT_PSS_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_OAEP_PADDING_INFO {
    pub pszAlgId: LPCWSTR,
    pub pbLabel: PUCHAR,
    pub cbLabel: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_OAEP_PADDING_INFO"]
        [::std::mem::size_of::<_BCRYPT_OAEP_PADDING_INFO>() - 24usize];
    ["Alignment of _BCRYPT_OAEP_PADDING_INFO"]
        [::std::mem::align_of::<_BCRYPT_OAEP_PADDING_INFO>() - 8usize];
    ["Offset of field: _BCRYPT_OAEP_PADDING_INFO::pszAlgId"]
        [::std::mem::offset_of!(_BCRYPT_OAEP_PADDING_INFO, pszAlgId) - 0usize];
    ["Offset of field: _BCRYPT_OAEP_PADDING_INFO::pbLabel"]
        [::std::mem::offset_of!(_BCRYPT_OAEP_PADDING_INFO, pbLabel) - 8usize];
    ["Offset of field: _BCRYPT_OAEP_PADDING_INFO::cbLabel"]
        [::std::mem::offset_of!(_BCRYPT_OAEP_PADDING_INFO, cbLabel) - 16usize];
};
pub type BCRYPT_OAEP_PADDING_INFO = _BCRYPT_OAEP_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO {
    pub cbSize: ULONG,
    pub dwInfoVersion: ULONG,
    pub pbNonce: PUCHAR,
    pub cbNonce: ULONG,
    pub pbAuthData: PUCHAR,
    pub cbAuthData: ULONG,
    pub pbTag: PUCHAR,
    pub cbTag: ULONG,
    pub pbMacContext: PUCHAR,
    pub cbMacContext: ULONG,
    pub cbAAD: ULONG,
    pub cbData: ULONGLONG,
    pub dwFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO"]
        [::std::mem::size_of::<_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO>() - 88usize];
    ["Alignment of _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO"]
        [::std::mem::align_of::<_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO>() - 8usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbSize"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbSize) - 0usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::dwInfoVersion"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, dwInfoVersion) - 4usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::pbNonce"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, pbNonce) - 8usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbNonce"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbNonce) - 16usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::pbAuthData"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, pbAuthData) - 24usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbAuthData"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbAuthData) - 32usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::pbTag"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, pbTag) - 40usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbTag"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbTag) - 48usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::pbMacContext"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, pbMacContext) - 56usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbMacContext"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbMacContext) - 64usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbAAD"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbAAD) - 68usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::cbData"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, cbData) - 72usize];
    ["Offset of field: _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO::dwFlags"]
        [::std::mem::offset_of!(_BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO, dwFlags) - 80usize];
};
pub type BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO = _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO;
pub type PBCRYPT_AUTHENTICATED_CIPHER_MODE_INFO = *mut _BCRYPT_AUTHENTICATED_CIPHER_MODE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCryptBuffer {
    pub cbBuffer: ULONG,
    pub BufferType: ULONG,
    pub pvBuffer: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCryptBuffer"][::std::mem::size_of::<_BCryptBuffer>() - 16usize];
    ["Alignment of _BCryptBuffer"][::std::mem::align_of::<_BCryptBuffer>() - 8usize];
    ["Offset of field: _BCryptBuffer::cbBuffer"]
        [::std::mem::offset_of!(_BCryptBuffer, cbBuffer) - 0usize];
    ["Offset of field: _BCryptBuffer::BufferType"]
        [::std::mem::offset_of!(_BCryptBuffer, BufferType) - 4usize];
    ["Offset of field: _BCryptBuffer::pvBuffer"]
        [::std::mem::offset_of!(_BCryptBuffer, pvBuffer) - 8usize];
};
pub type BCryptBuffer = _BCryptBuffer;
pub type PBCryptBuffer = *mut _BCryptBuffer;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCryptBufferDesc {
    pub ulVersion: ULONG,
    pub cBuffers: ULONG,
    pub pBuffers: PBCryptBuffer,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCryptBufferDesc"][::std::mem::size_of::<_BCryptBufferDesc>() - 16usize];
    ["Alignment of _BCryptBufferDesc"][::std::mem::align_of::<_BCryptBufferDesc>() - 8usize];
    ["Offset of field: _BCryptBufferDesc::ulVersion"]
        [::std::mem::offset_of!(_BCryptBufferDesc, ulVersion) - 0usize];
    ["Offset of field: _BCryptBufferDesc::cBuffers"]
        [::std::mem::offset_of!(_BCryptBufferDesc, cBuffers) - 4usize];
    ["Offset of field: _BCryptBufferDesc::pBuffers"]
        [::std::mem::offset_of!(_BCryptBufferDesc, pBuffers) - 8usize];
};
pub type BCryptBufferDesc = _BCryptBufferDesc;
pub type PBCryptBufferDesc = *mut _BCryptBufferDesc;
pub type BCRYPT_HANDLE = PVOID;
pub type BCRYPT_ALG_HANDLE = PVOID;
pub type BCRYPT_KEY_HANDLE = PVOID;
pub type BCRYPT_HASH_HANDLE = PVOID;
pub type BCRYPT_SECRET_HANDLE = PVOID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_KEY_BLOB {
    pub Magic: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_KEY_BLOB"][::std::mem::size_of::<_BCRYPT_KEY_BLOB>() - 4usize];
    ["Alignment of _BCRYPT_KEY_BLOB"][::std::mem::align_of::<_BCRYPT_KEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_KEY_BLOB::Magic"]
        [::std::mem::offset_of!(_BCRYPT_KEY_BLOB, Magic) - 0usize];
};
pub type BCRYPT_KEY_BLOB = _BCRYPT_KEY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_RSAKEY_BLOB {
    pub Magic: ULONG,
    pub BitLength: ULONG,
    pub cbPublicExp: ULONG,
    pub cbModulus: ULONG,
    pub cbPrime1: ULONG,
    pub cbPrime2: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_RSAKEY_BLOB"][::std::mem::size_of::<_BCRYPT_RSAKEY_BLOB>() - 24usize];
    ["Alignment of _BCRYPT_RSAKEY_BLOB"][::std::mem::align_of::<_BCRYPT_RSAKEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::Magic"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, Magic) - 0usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::BitLength"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, BitLength) - 4usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::cbPublicExp"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, cbPublicExp) - 8usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::cbModulus"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, cbModulus) - 12usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::cbPrime1"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, cbPrime1) - 16usize];
    ["Offset of field: _BCRYPT_RSAKEY_BLOB::cbPrime2"]
        [::std::mem::offset_of!(_BCRYPT_RSAKEY_BLOB, cbPrime2) - 20usize];
};
pub type BCRYPT_RSAKEY_BLOB = _BCRYPT_RSAKEY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_ECCKEY_BLOB {
    pub dwMagic: ULONG,
    pub cbKey: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_ECCKEY_BLOB"][::std::mem::size_of::<_BCRYPT_ECCKEY_BLOB>() - 8usize];
    ["Alignment of _BCRYPT_ECCKEY_BLOB"][::std::mem::align_of::<_BCRYPT_ECCKEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_ECCKEY_BLOB::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_ECCKEY_BLOB, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_ECCKEY_BLOB::cbKey"]
        [::std::mem::offset_of!(_BCRYPT_ECCKEY_BLOB, cbKey) - 4usize];
};
pub type BCRYPT_ECCKEY_BLOB = _BCRYPT_ECCKEY_BLOB;
pub type PBCRYPT_ECCKEY_BLOB = *mut _BCRYPT_ECCKEY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SSL_ECCKEY_BLOB {
    pub dwCurveType: ULONG,
    pub cbKey: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SSL_ECCKEY_BLOB"][::std::mem::size_of::<_SSL_ECCKEY_BLOB>() - 8usize];
    ["Alignment of _SSL_ECCKEY_BLOB"][::std::mem::align_of::<_SSL_ECCKEY_BLOB>() - 4usize];
    ["Offset of field: _SSL_ECCKEY_BLOB::dwCurveType"]
        [::std::mem::offset_of!(_SSL_ECCKEY_BLOB, dwCurveType) - 0usize];
    ["Offset of field: _SSL_ECCKEY_BLOB::cbKey"]
        [::std::mem::offset_of!(_SSL_ECCKEY_BLOB, cbKey) - 4usize];
};
pub type SSL_ECCKEY_BLOB = _SSL_ECCKEY_BLOB;
pub type PSSL_ECCKEY_BLOB = *mut _SSL_ECCKEY_BLOB;
pub const ECC_CURVE_TYPE_ENUM_BCRYPT_ECC_PRIME_SHORT_WEIERSTRASS_CURVE: ECC_CURVE_TYPE_ENUM = 1;
pub const ECC_CURVE_TYPE_ENUM_BCRYPT_ECC_PRIME_TWISTED_EDWARDS_CURVE: ECC_CURVE_TYPE_ENUM = 2;
pub const ECC_CURVE_TYPE_ENUM_BCRYPT_ECC_PRIME_MONTGOMERY_CURVE: ECC_CURVE_TYPE_ENUM = 3;
pub type ECC_CURVE_TYPE_ENUM = ::std::os::raw::c_int;
pub const ECC_CURVE_ALG_ID_ENUM_BCRYPT_NO_CURVE_GENERATION_ALG_ID: ECC_CURVE_ALG_ID_ENUM = 0;
pub type ECC_CURVE_ALG_ID_ENUM = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_ECCFULLKEY_BLOB {
    pub dwMagic: ULONG,
    pub dwVersion: ULONG,
    pub dwCurveType: ECC_CURVE_TYPE_ENUM,
    pub dwCurveGenerationAlgId: ECC_CURVE_ALG_ID_ENUM,
    pub cbFieldLength: ULONG,
    pub cbSubgroupOrder: ULONG,
    pub cbCofactor: ULONG,
    pub cbSeed: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_ECCFULLKEY_BLOB"][::std::mem::size_of::<_BCRYPT_ECCFULLKEY_BLOB>() - 32usize];
    ["Alignment of _BCRYPT_ECCFULLKEY_BLOB"]
        [::std::mem::align_of::<_BCRYPT_ECCFULLKEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::dwVersion"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, dwVersion) - 4usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::dwCurveType"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, dwCurveType) - 8usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::dwCurveGenerationAlgId"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, dwCurveGenerationAlgId) - 12usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::cbFieldLength"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, cbFieldLength) - 16usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::cbSubgroupOrder"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, cbSubgroupOrder) - 20usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::cbCofactor"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, cbCofactor) - 24usize];
    ["Offset of field: _BCRYPT_ECCFULLKEY_BLOB::cbSeed"]
        [::std::mem::offset_of!(_BCRYPT_ECCFULLKEY_BLOB, cbSeed) - 28usize];
};
pub type BCRYPT_ECCFULLKEY_BLOB = _BCRYPT_ECCFULLKEY_BLOB;
pub type PBCRYPT_ECCFULLKEY_BLOB = *mut _BCRYPT_ECCFULLKEY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DH_KEY_BLOB {
    pub dwMagic: ULONG,
    pub cbKey: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DH_KEY_BLOB"][::std::mem::size_of::<_BCRYPT_DH_KEY_BLOB>() - 8usize];
    ["Alignment of _BCRYPT_DH_KEY_BLOB"][::std::mem::align_of::<_BCRYPT_DH_KEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_DH_KEY_BLOB::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DH_KEY_BLOB, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_DH_KEY_BLOB::cbKey"]
        [::std::mem::offset_of!(_BCRYPT_DH_KEY_BLOB, cbKey) - 4usize];
};
pub type BCRYPT_DH_KEY_BLOB = _BCRYPT_DH_KEY_BLOB;
pub type PBCRYPT_DH_KEY_BLOB = *mut _BCRYPT_DH_KEY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DH_PARAMETER_HEADER {
    pub cbLength: ULONG,
    pub dwMagic: ULONG,
    pub cbKeyLength: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DH_PARAMETER_HEADER"]
        [::std::mem::size_of::<_BCRYPT_DH_PARAMETER_HEADER>() - 12usize];
    ["Alignment of _BCRYPT_DH_PARAMETER_HEADER"]
        [::std::mem::align_of::<_BCRYPT_DH_PARAMETER_HEADER>() - 4usize];
    ["Offset of field: _BCRYPT_DH_PARAMETER_HEADER::cbLength"]
        [::std::mem::offset_of!(_BCRYPT_DH_PARAMETER_HEADER, cbLength) - 0usize];
    ["Offset of field: _BCRYPT_DH_PARAMETER_HEADER::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DH_PARAMETER_HEADER, dwMagic) - 4usize];
    ["Offset of field: _BCRYPT_DH_PARAMETER_HEADER::cbKeyLength"]
        [::std::mem::offset_of!(_BCRYPT_DH_PARAMETER_HEADER, cbKeyLength) - 8usize];
};
pub type BCRYPT_DH_PARAMETER_HEADER = _BCRYPT_DH_PARAMETER_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DSA_KEY_BLOB {
    pub dwMagic: ULONG,
    pub cbKey: ULONG,
    pub Count: [UCHAR; 4usize],
    pub Seed: [UCHAR; 20usize],
    pub q: [UCHAR; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DSA_KEY_BLOB"][::std::mem::size_of::<_BCRYPT_DSA_KEY_BLOB>() - 52usize];
    ["Alignment of _BCRYPT_DSA_KEY_BLOB"][::std::mem::align_of::<_BCRYPT_DSA_KEY_BLOB>() - 4usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB::cbKey"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB, cbKey) - 4usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB::Count"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB, Count) - 8usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB::Seed"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB, Seed) - 12usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB::q"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB, q) - 32usize];
};
pub type BCRYPT_DSA_KEY_BLOB = _BCRYPT_DSA_KEY_BLOB;
pub type PBCRYPT_DSA_KEY_BLOB = *mut _BCRYPT_DSA_KEY_BLOB;
pub const HASHALGORITHM_ENUM_DSA_HASH_ALGORITHM_SHA1: HASHALGORITHM_ENUM = 0;
pub const HASHALGORITHM_ENUM_DSA_HASH_ALGORITHM_SHA256: HASHALGORITHM_ENUM = 1;
pub const HASHALGORITHM_ENUM_DSA_HASH_ALGORITHM_SHA512: HASHALGORITHM_ENUM = 2;
pub type HASHALGORITHM_ENUM = ::std::os::raw::c_int;
pub const DSAFIPSVERSION_ENUM_DSA_FIPS186_2: DSAFIPSVERSION_ENUM = 0;
pub const DSAFIPSVERSION_ENUM_DSA_FIPS186_3: DSAFIPSVERSION_ENUM = 1;
pub type DSAFIPSVERSION_ENUM = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DSA_KEY_BLOB_V2 {
    pub dwMagic: ULONG,
    pub cbKey: ULONG,
    pub hashAlgorithm: HASHALGORITHM_ENUM,
    pub standardVersion: DSAFIPSVERSION_ENUM,
    pub cbSeedLength: ULONG,
    pub cbGroupSize: ULONG,
    pub Count: [UCHAR; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DSA_KEY_BLOB_V2"][::std::mem::size_of::<_BCRYPT_DSA_KEY_BLOB_V2>() - 28usize];
    ["Alignment of _BCRYPT_DSA_KEY_BLOB_V2"]
        [::std::mem::align_of::<_BCRYPT_DSA_KEY_BLOB_V2>() - 4usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::cbKey"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, cbKey) - 4usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::hashAlgorithm"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, hashAlgorithm) - 8usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::standardVersion"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, standardVersion) - 12usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::cbSeedLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, cbSeedLength) - 16usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::cbGroupSize"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, cbGroupSize) - 20usize];
    ["Offset of field: _BCRYPT_DSA_KEY_BLOB_V2::Count"]
        [::std::mem::offset_of!(_BCRYPT_DSA_KEY_BLOB_V2, Count) - 24usize];
};
pub type BCRYPT_DSA_KEY_BLOB_V2 = _BCRYPT_DSA_KEY_BLOB_V2;
pub type PBCRYPT_DSA_KEY_BLOB_V2 = *mut _BCRYPT_DSA_KEY_BLOB_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_KEY_DATA_BLOB_HEADER {
    pub dwMagic: ULONG,
    pub dwVersion: ULONG,
    pub cbKeyData: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_KEY_DATA_BLOB_HEADER"]
        [::std::mem::size_of::<_BCRYPT_KEY_DATA_BLOB_HEADER>() - 12usize];
    ["Alignment of _BCRYPT_KEY_DATA_BLOB_HEADER"]
        [::std::mem::align_of::<_BCRYPT_KEY_DATA_BLOB_HEADER>() - 4usize];
    ["Offset of field: _BCRYPT_KEY_DATA_BLOB_HEADER::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_KEY_DATA_BLOB_HEADER, dwMagic) - 0usize];
    ["Offset of field: _BCRYPT_KEY_DATA_BLOB_HEADER::dwVersion"]
        [::std::mem::offset_of!(_BCRYPT_KEY_DATA_BLOB_HEADER, dwVersion) - 4usize];
    ["Offset of field: _BCRYPT_KEY_DATA_BLOB_HEADER::cbKeyData"]
        [::std::mem::offset_of!(_BCRYPT_KEY_DATA_BLOB_HEADER, cbKeyData) - 8usize];
};
pub type BCRYPT_KEY_DATA_BLOB_HEADER = _BCRYPT_KEY_DATA_BLOB_HEADER;
pub type PBCRYPT_KEY_DATA_BLOB_HEADER = *mut _BCRYPT_KEY_DATA_BLOB_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DSA_PARAMETER_HEADER {
    pub cbLength: ULONG,
    pub dwMagic: ULONG,
    pub cbKeyLength: ULONG,
    pub Count: [UCHAR; 4usize],
    pub Seed: [UCHAR; 20usize],
    pub q: [UCHAR; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DSA_PARAMETER_HEADER"]
        [::std::mem::size_of::<_BCRYPT_DSA_PARAMETER_HEADER>() - 56usize];
    ["Alignment of _BCRYPT_DSA_PARAMETER_HEADER"]
        [::std::mem::align_of::<_BCRYPT_DSA_PARAMETER_HEADER>() - 4usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::cbLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, cbLength) - 0usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, dwMagic) - 4usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::cbKeyLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, cbKeyLength) - 8usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::Count"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, Count) - 12usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::Seed"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, Seed) - 16usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER::q"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER, q) - 36usize];
};
pub type BCRYPT_DSA_PARAMETER_HEADER = _BCRYPT_DSA_PARAMETER_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_DSA_PARAMETER_HEADER_V2 {
    pub cbLength: ULONG,
    pub dwMagic: ULONG,
    pub cbKeyLength: ULONG,
    pub hashAlgorithm: HASHALGORITHM_ENUM,
    pub standardVersion: DSAFIPSVERSION_ENUM,
    pub cbSeedLength: ULONG,
    pub cbGroupSize: ULONG,
    pub Count: [UCHAR; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_DSA_PARAMETER_HEADER_V2"]
        [::std::mem::size_of::<_BCRYPT_DSA_PARAMETER_HEADER_V2>() - 32usize];
    ["Alignment of _BCRYPT_DSA_PARAMETER_HEADER_V2"]
        [::std::mem::align_of::<_BCRYPT_DSA_PARAMETER_HEADER_V2>() - 4usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::cbLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, cbLength) - 0usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::dwMagic"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, dwMagic) - 4usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::cbKeyLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, cbKeyLength) - 8usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::hashAlgorithm"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, hashAlgorithm) - 12usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::standardVersion"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, standardVersion) - 16usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::cbSeedLength"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, cbSeedLength) - 20usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::cbGroupSize"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, cbGroupSize) - 24usize];
    ["Offset of field: _BCRYPT_DSA_PARAMETER_HEADER_V2::Count"]
        [::std::mem::offset_of!(_BCRYPT_DSA_PARAMETER_HEADER_V2, Count) - 28usize];
};
pub type BCRYPT_DSA_PARAMETER_HEADER_V2 = _BCRYPT_DSA_PARAMETER_HEADER_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_ECC_CURVE_NAMES {
    pub dwEccCurveNames: ULONG,
    pub pEccCurveNames: *mut LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_ECC_CURVE_NAMES"][::std::mem::size_of::<_BCRYPT_ECC_CURVE_NAMES>() - 16usize];
    ["Alignment of _BCRYPT_ECC_CURVE_NAMES"]
        [::std::mem::align_of::<_BCRYPT_ECC_CURVE_NAMES>() - 8usize];
    ["Offset of field: _BCRYPT_ECC_CURVE_NAMES::dwEccCurveNames"]
        [::std::mem::offset_of!(_BCRYPT_ECC_CURVE_NAMES, dwEccCurveNames) - 0usize];
    ["Offset of field: _BCRYPT_ECC_CURVE_NAMES::pEccCurveNames"]
        [::std::mem::offset_of!(_BCRYPT_ECC_CURVE_NAMES, pEccCurveNames) - 8usize];
};
pub type BCRYPT_ECC_CURVE_NAMES = _BCRYPT_ECC_CURVE_NAMES;
pub const BCRYPT_HASH_OPERATION_TYPE_BCRYPT_HASH_OPERATION_HASH_DATA: BCRYPT_HASH_OPERATION_TYPE =
    1;
pub const BCRYPT_HASH_OPERATION_TYPE_BCRYPT_HASH_OPERATION_FINISH_HASH: BCRYPT_HASH_OPERATION_TYPE =
    2;
pub type BCRYPT_HASH_OPERATION_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_MULTI_HASH_OPERATION {
    pub iHash: ULONG,
    pub hashOperation: BCRYPT_HASH_OPERATION_TYPE,
    pub pbBuffer: PUCHAR,
    pub cbBuffer: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_MULTI_HASH_OPERATION"]
        [::std::mem::size_of::<_BCRYPT_MULTI_HASH_OPERATION>() - 24usize];
    ["Alignment of _BCRYPT_MULTI_HASH_OPERATION"]
        [::std::mem::align_of::<_BCRYPT_MULTI_HASH_OPERATION>() - 8usize];
    ["Offset of field: _BCRYPT_MULTI_HASH_OPERATION::iHash"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_HASH_OPERATION, iHash) - 0usize];
    ["Offset of field: _BCRYPT_MULTI_HASH_OPERATION::hashOperation"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_HASH_OPERATION, hashOperation) - 4usize];
    ["Offset of field: _BCRYPT_MULTI_HASH_OPERATION::pbBuffer"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_HASH_OPERATION, pbBuffer) - 8usize];
    ["Offset of field: _BCRYPT_MULTI_HASH_OPERATION::cbBuffer"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_HASH_OPERATION, cbBuffer) - 16usize];
};
pub type BCRYPT_MULTI_HASH_OPERATION = _BCRYPT_MULTI_HASH_OPERATION;
pub const BCRYPT_MULTI_OPERATION_TYPE_BCRYPT_OPERATION_TYPE_HASH: BCRYPT_MULTI_OPERATION_TYPE = 1;
pub type BCRYPT_MULTI_OPERATION_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT {
    pub cbPerObject: ULONG,
    pub cbPerElement: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT"]
        [::std::mem::size_of::<_BCRYPT_MULTI_OBJECT_LENGTH_STRUCT>() - 8usize];
    ["Alignment of _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT"]
        [::std::mem::align_of::<_BCRYPT_MULTI_OBJECT_LENGTH_STRUCT>() - 4usize];
    ["Offset of field: _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT::cbPerObject"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_OBJECT_LENGTH_STRUCT, cbPerObject) - 0usize];
    ["Offset of field: _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT::cbPerElement"]
        [::std::mem::offset_of!(_BCRYPT_MULTI_OBJECT_LENGTH_STRUCT, cbPerElement) - 4usize];
};
pub type BCRYPT_MULTI_OBJECT_LENGTH_STRUCT = _BCRYPT_MULTI_OBJECT_LENGTH_STRUCT;
unsafe extern "C" {
    pub fn BCryptOpenAlgorithmProvider(
        phAlgorithm: *mut BCRYPT_ALG_HANDLE,
        pszAlgId: LPCWSTR,
        pszImplementation: LPCWSTR,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_ALGORITHM_IDENTIFIER {
    pub pszName: LPWSTR,
    pub dwClass: ULONG,
    pub dwFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_ALGORITHM_IDENTIFIER"]
        [::std::mem::size_of::<_BCRYPT_ALGORITHM_IDENTIFIER>() - 16usize];
    ["Alignment of _BCRYPT_ALGORITHM_IDENTIFIER"]
        [::std::mem::align_of::<_BCRYPT_ALGORITHM_IDENTIFIER>() - 8usize];
    ["Offset of field: _BCRYPT_ALGORITHM_IDENTIFIER::pszName"]
        [::std::mem::offset_of!(_BCRYPT_ALGORITHM_IDENTIFIER, pszName) - 0usize];
    ["Offset of field: _BCRYPT_ALGORITHM_IDENTIFIER::dwClass"]
        [::std::mem::offset_of!(_BCRYPT_ALGORITHM_IDENTIFIER, dwClass) - 8usize];
    ["Offset of field: _BCRYPT_ALGORITHM_IDENTIFIER::dwFlags"]
        [::std::mem::offset_of!(_BCRYPT_ALGORITHM_IDENTIFIER, dwFlags) - 12usize];
};
pub type BCRYPT_ALGORITHM_IDENTIFIER = _BCRYPT_ALGORITHM_IDENTIFIER;
unsafe extern "C" {
    pub fn BCryptEnumAlgorithms(
        dwAlgOperations: ULONG,
        pAlgCount: *mut ULONG,
        ppAlgList: *mut *mut BCRYPT_ALGORITHM_IDENTIFIER,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_PROVIDER_NAME {
    pub pszProviderName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_PROVIDER_NAME"][::std::mem::size_of::<_BCRYPT_PROVIDER_NAME>() - 8usize];
    ["Alignment of _BCRYPT_PROVIDER_NAME"]
        [::std::mem::align_of::<_BCRYPT_PROVIDER_NAME>() - 8usize];
    ["Offset of field: _BCRYPT_PROVIDER_NAME::pszProviderName"]
        [::std::mem::offset_of!(_BCRYPT_PROVIDER_NAME, pszProviderName) - 0usize];
};
pub type BCRYPT_PROVIDER_NAME = _BCRYPT_PROVIDER_NAME;
unsafe extern "C" {
    pub fn BCryptEnumProviders(
        pszAlgId: LPCWSTR,
        pImplCount: *mut ULONG,
        ppImplList: *mut *mut BCRYPT_PROVIDER_NAME,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptGetProperty(
        hObject: BCRYPT_HANDLE,
        pszProperty: LPCWSTR,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptSetProperty(
        hObject: BCRYPT_HANDLE,
        pszProperty: LPCWSTR,
        pbInput: PUCHAR,
        cbInput: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptCloseAlgorithmProvider(hAlgorithm: BCRYPT_ALG_HANDLE, dwFlags: ULONG) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptFreeBuffer(pvBuffer: PVOID);
}
unsafe extern "C" {
    pub fn BCryptGenerateSymmetricKey(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        phKey: *mut BCRYPT_KEY_HANDLE,
        pbKeyObject: PUCHAR,
        cbKeyObject: ULONG,
        pbSecret: PUCHAR,
        cbSecret: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptGenerateKeyPair(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        phKey: *mut BCRYPT_KEY_HANDLE,
        dwLength: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptEncrypt(
        hKey: BCRYPT_KEY_HANDLE,
        pbInput: PUCHAR,
        cbInput: ULONG,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbIV: PUCHAR,
        cbIV: ULONG,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDecrypt(
        hKey: BCRYPT_KEY_HANDLE,
        pbInput: PUCHAR,
        cbInput: ULONG,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbIV: PUCHAR,
        cbIV: ULONG,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptExportKey(
        hKey: BCRYPT_KEY_HANDLE,
        hExportKey: BCRYPT_KEY_HANDLE,
        pszBlobType: LPCWSTR,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptImportKey(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        hImportKey: BCRYPT_KEY_HANDLE,
        pszBlobType: LPCWSTR,
        phKey: *mut BCRYPT_KEY_HANDLE,
        pbKeyObject: PUCHAR,
        cbKeyObject: ULONG,
        pbInput: PUCHAR,
        cbInput: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptImportKeyPair(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        hImportKey: BCRYPT_KEY_HANDLE,
        pszBlobType: LPCWSTR,
        phKey: *mut BCRYPT_KEY_HANDLE,
        pbInput: PUCHAR,
        cbInput: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDuplicateKey(
        hKey: BCRYPT_KEY_HANDLE,
        phNewKey: *mut BCRYPT_KEY_HANDLE,
        pbKeyObject: PUCHAR,
        cbKeyObject: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptFinalizeKeyPair(hKey: BCRYPT_KEY_HANDLE, dwFlags: ULONG) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDestroyKey(hKey: BCRYPT_KEY_HANDLE) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDestroySecret(hSecret: BCRYPT_SECRET_HANDLE) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptSignHash(
        hKey: BCRYPT_KEY_HANDLE,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbInput: PUCHAR,
        cbInput: ULONG,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptVerifySignature(
        hKey: BCRYPT_KEY_HANDLE,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbHash: PUCHAR,
        cbHash: ULONG,
        pbSignature: PUCHAR,
        cbSignature: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptSecretAgreement(
        hPrivKey: BCRYPT_KEY_HANDLE,
        hPubKey: BCRYPT_KEY_HANDLE,
        phAgreedSecret: *mut BCRYPT_SECRET_HANDLE,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDeriveKey(
        hSharedSecret: BCRYPT_SECRET_HANDLE,
        pwszKDF: LPCWSTR,
        pParameterList: *mut BCryptBufferDesc,
        pbDerivedKey: PUCHAR,
        cbDerivedKey: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptKeyDerivation(
        hKey: BCRYPT_KEY_HANDLE,
        pParameterList: *mut BCryptBufferDesc,
        pbDerivedKey: PUCHAR,
        cbDerivedKey: ULONG,
        pcbResult: *mut ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptCreateHash(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        phHash: *mut BCRYPT_HASH_HANDLE,
        pbHashObject: PUCHAR,
        cbHashObject: ULONG,
        pbSecret: PUCHAR,
        cbSecret: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptHashData(
        hHash: BCRYPT_HASH_HANDLE,
        pbInput: PUCHAR,
        cbInput: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptFinishHash(
        hHash: BCRYPT_HASH_HANDLE,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptCreateMultiHash(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        phHash: *mut BCRYPT_HASH_HANDLE,
        nHashes: ULONG,
        pbHashObject: PUCHAR,
        cbHashObject: ULONG,
        pbSecret: PUCHAR,
        cbSecret: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptProcessMultiOperations(
        hObject: BCRYPT_HANDLE,
        operationType: BCRYPT_MULTI_OPERATION_TYPE,
        pOperations: PVOID,
        cbOperations: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDuplicateHash(
        hHash: BCRYPT_HASH_HANDLE,
        phNewHash: *mut BCRYPT_HASH_HANDLE,
        pbHashObject: PUCHAR,
        cbHashObject: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDestroyHash(hHash: BCRYPT_HASH_HANDLE) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptHash(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        pbSecret: PUCHAR,
        cbSecret: ULONG,
        pbInput: PUCHAR,
        cbInput: ULONG,
        pbOutput: PUCHAR,
        cbOutput: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptGenRandom(
        hAlgorithm: BCRYPT_ALG_HANDLE,
        pbBuffer: PUCHAR,
        cbBuffer: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDeriveKeyCapi(
        hHash: BCRYPT_HASH_HANDLE,
        hTargetAlg: BCRYPT_ALG_HANDLE,
        pbDerivedKey: PUCHAR,
        cbDerivedKey: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDeriveKeyPBKDF2(
        hPrf: BCRYPT_ALG_HANDLE,
        pbPassword: PUCHAR,
        cbPassword: ULONG,
        pbSalt: PUCHAR,
        cbSalt: ULONG,
        cIterations: ULONGLONG,
        pbDerivedKey: PUCHAR,
        cbDerivedKey: ULONG,
        dwFlags: ULONG,
    ) -> NTSTATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BCRYPT_INTERFACE_VERSION {
    pub MajorVersion: USHORT,
    pub MinorVersion: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BCRYPT_INTERFACE_VERSION"]
        [::std::mem::size_of::<_BCRYPT_INTERFACE_VERSION>() - 4usize];
    ["Alignment of _BCRYPT_INTERFACE_VERSION"]
        [::std::mem::align_of::<_BCRYPT_INTERFACE_VERSION>() - 2usize];
    ["Offset of field: _BCRYPT_INTERFACE_VERSION::MajorVersion"]
        [::std::mem::offset_of!(_BCRYPT_INTERFACE_VERSION, MajorVersion) - 0usize];
    ["Offset of field: _BCRYPT_INTERFACE_VERSION::MinorVersion"]
        [::std::mem::offset_of!(_BCRYPT_INTERFACE_VERSION, MinorVersion) - 2usize];
};
pub type BCRYPT_INTERFACE_VERSION = _BCRYPT_INTERFACE_VERSION;
pub type PBCRYPT_INTERFACE_VERSION = *mut _BCRYPT_INTERFACE_VERSION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_INTERFACE_REG {
    pub dwInterface: ULONG,
    pub dwFlags: ULONG,
    pub cFunctions: ULONG,
    pub rgpszFunctions: *mut PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_INTERFACE_REG"][::std::mem::size_of::<_CRYPT_INTERFACE_REG>() - 24usize];
    ["Alignment of _CRYPT_INTERFACE_REG"][::std::mem::align_of::<_CRYPT_INTERFACE_REG>() - 8usize];
    ["Offset of field: _CRYPT_INTERFACE_REG::dwInterface"]
        [::std::mem::offset_of!(_CRYPT_INTERFACE_REG, dwInterface) - 0usize];
    ["Offset of field: _CRYPT_INTERFACE_REG::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_INTERFACE_REG, dwFlags) - 4usize];
    ["Offset of field: _CRYPT_INTERFACE_REG::cFunctions"]
        [::std::mem::offset_of!(_CRYPT_INTERFACE_REG, cFunctions) - 8usize];
    ["Offset of field: _CRYPT_INTERFACE_REG::rgpszFunctions"]
        [::std::mem::offset_of!(_CRYPT_INTERFACE_REG, rgpszFunctions) - 16usize];
};
pub type CRYPT_INTERFACE_REG = _CRYPT_INTERFACE_REG;
pub type PCRYPT_INTERFACE_REG = *mut _CRYPT_INTERFACE_REG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_IMAGE_REG {
    pub pszImage: PWSTR,
    pub cInterfaces: ULONG,
    pub rgpInterfaces: *mut PCRYPT_INTERFACE_REG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_IMAGE_REG"][::std::mem::size_of::<_CRYPT_IMAGE_REG>() - 24usize];
    ["Alignment of _CRYPT_IMAGE_REG"][::std::mem::align_of::<_CRYPT_IMAGE_REG>() - 8usize];
    ["Offset of field: _CRYPT_IMAGE_REG::pszImage"]
        [::std::mem::offset_of!(_CRYPT_IMAGE_REG, pszImage) - 0usize];
    ["Offset of field: _CRYPT_IMAGE_REG::cInterfaces"]
        [::std::mem::offset_of!(_CRYPT_IMAGE_REG, cInterfaces) - 8usize];
    ["Offset of field: _CRYPT_IMAGE_REG::rgpInterfaces"]
        [::std::mem::offset_of!(_CRYPT_IMAGE_REG, rgpInterfaces) - 16usize];
};
pub type CRYPT_IMAGE_REG = _CRYPT_IMAGE_REG;
pub type PCRYPT_IMAGE_REG = *mut _CRYPT_IMAGE_REG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PROVIDER_REG {
    pub cAliases: ULONG,
    pub rgpszAliases: *mut PWSTR,
    pub pUM: PCRYPT_IMAGE_REG,
    pub pKM: PCRYPT_IMAGE_REG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PROVIDER_REG"][::std::mem::size_of::<_CRYPT_PROVIDER_REG>() - 32usize];
    ["Alignment of _CRYPT_PROVIDER_REG"][::std::mem::align_of::<_CRYPT_PROVIDER_REG>() - 8usize];
    ["Offset of field: _CRYPT_PROVIDER_REG::cAliases"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REG, cAliases) - 0usize];
    ["Offset of field: _CRYPT_PROVIDER_REG::rgpszAliases"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REG, rgpszAliases) - 8usize];
    ["Offset of field: _CRYPT_PROVIDER_REG::pUM"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REG, pUM) - 16usize];
    ["Offset of field: _CRYPT_PROVIDER_REG::pKM"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REG, pKM) - 24usize];
};
pub type CRYPT_PROVIDER_REG = _CRYPT_PROVIDER_REG;
pub type PCRYPT_PROVIDER_REG = *mut _CRYPT_PROVIDER_REG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PROVIDERS {
    pub cProviders: ULONG,
    pub rgpszProviders: *mut PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PROVIDERS"][::std::mem::size_of::<_CRYPT_PROVIDERS>() - 16usize];
    ["Alignment of _CRYPT_PROVIDERS"][::std::mem::align_of::<_CRYPT_PROVIDERS>() - 8usize];
    ["Offset of field: _CRYPT_PROVIDERS::cProviders"]
        [::std::mem::offset_of!(_CRYPT_PROVIDERS, cProviders) - 0usize];
    ["Offset of field: _CRYPT_PROVIDERS::rgpszProviders"]
        [::std::mem::offset_of!(_CRYPT_PROVIDERS, rgpszProviders) - 8usize];
};
pub type CRYPT_PROVIDERS = _CRYPT_PROVIDERS;
pub type PCRYPT_PROVIDERS = *mut _CRYPT_PROVIDERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTEXT_CONFIG {
    pub dwFlags: ULONG,
    pub dwReserved: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTEXT_CONFIG"][::std::mem::size_of::<_CRYPT_CONTEXT_CONFIG>() - 8usize];
    ["Alignment of _CRYPT_CONTEXT_CONFIG"]
        [::std::mem::align_of::<_CRYPT_CONTEXT_CONFIG>() - 4usize];
    ["Offset of field: _CRYPT_CONTEXT_CONFIG::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_CONFIG, dwFlags) - 0usize];
    ["Offset of field: _CRYPT_CONTEXT_CONFIG::dwReserved"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_CONFIG, dwReserved) - 4usize];
};
pub type CRYPT_CONTEXT_CONFIG = _CRYPT_CONTEXT_CONFIG;
pub type PCRYPT_CONTEXT_CONFIG = *mut _CRYPT_CONTEXT_CONFIG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTEXT_FUNCTION_CONFIG {
    pub dwFlags: ULONG,
    pub dwReserved: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTEXT_FUNCTION_CONFIG"]
        [::std::mem::size_of::<_CRYPT_CONTEXT_FUNCTION_CONFIG>() - 8usize];
    ["Alignment of _CRYPT_CONTEXT_FUNCTION_CONFIG"]
        [::std::mem::align_of::<_CRYPT_CONTEXT_FUNCTION_CONFIG>() - 4usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTION_CONFIG::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTION_CONFIG, dwFlags) - 0usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTION_CONFIG::dwReserved"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTION_CONFIG, dwReserved) - 4usize];
};
pub type CRYPT_CONTEXT_FUNCTION_CONFIG = _CRYPT_CONTEXT_FUNCTION_CONFIG;
pub type PCRYPT_CONTEXT_FUNCTION_CONFIG = *mut _CRYPT_CONTEXT_FUNCTION_CONFIG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTEXTS {
    pub cContexts: ULONG,
    pub rgpszContexts: *mut PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTEXTS"][::std::mem::size_of::<_CRYPT_CONTEXTS>() - 16usize];
    ["Alignment of _CRYPT_CONTEXTS"][::std::mem::align_of::<_CRYPT_CONTEXTS>() - 8usize];
    ["Offset of field: _CRYPT_CONTEXTS::cContexts"]
        [::std::mem::offset_of!(_CRYPT_CONTEXTS, cContexts) - 0usize];
    ["Offset of field: _CRYPT_CONTEXTS::rgpszContexts"]
        [::std::mem::offset_of!(_CRYPT_CONTEXTS, rgpszContexts) - 8usize];
};
pub type CRYPT_CONTEXTS = _CRYPT_CONTEXTS;
pub type PCRYPT_CONTEXTS = *mut _CRYPT_CONTEXTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTEXT_FUNCTIONS {
    pub cFunctions: ULONG,
    pub rgpszFunctions: *mut PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTEXT_FUNCTIONS"]
        [::std::mem::size_of::<_CRYPT_CONTEXT_FUNCTIONS>() - 16usize];
    ["Alignment of _CRYPT_CONTEXT_FUNCTIONS"]
        [::std::mem::align_of::<_CRYPT_CONTEXT_FUNCTIONS>() - 8usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTIONS::cFunctions"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTIONS, cFunctions) - 0usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTIONS::rgpszFunctions"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTIONS, rgpszFunctions) - 8usize];
};
pub type CRYPT_CONTEXT_FUNCTIONS = _CRYPT_CONTEXT_FUNCTIONS;
pub type PCRYPT_CONTEXT_FUNCTIONS = *mut _CRYPT_CONTEXT_FUNCTIONS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTEXT_FUNCTION_PROVIDERS {
    pub cProviders: ULONG,
    pub rgpszProviders: *mut PWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTEXT_FUNCTION_PROVIDERS"]
        [::std::mem::size_of::<_CRYPT_CONTEXT_FUNCTION_PROVIDERS>() - 16usize];
    ["Alignment of _CRYPT_CONTEXT_FUNCTION_PROVIDERS"]
        [::std::mem::align_of::<_CRYPT_CONTEXT_FUNCTION_PROVIDERS>() - 8usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTION_PROVIDERS::cProviders"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTION_PROVIDERS, cProviders) - 0usize];
    ["Offset of field: _CRYPT_CONTEXT_FUNCTION_PROVIDERS::rgpszProviders"]
        [::std::mem::offset_of!(_CRYPT_CONTEXT_FUNCTION_PROVIDERS, rgpszProviders) - 8usize];
};
pub type CRYPT_CONTEXT_FUNCTION_PROVIDERS = _CRYPT_CONTEXT_FUNCTION_PROVIDERS;
pub type PCRYPT_CONTEXT_FUNCTION_PROVIDERS = *mut _CRYPT_CONTEXT_FUNCTION_PROVIDERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PROPERTY_REF {
    pub pszProperty: PWSTR,
    pub cbValue: ULONG,
    pub pbValue: PUCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PROPERTY_REF"][::std::mem::size_of::<_CRYPT_PROPERTY_REF>() - 24usize];
    ["Alignment of _CRYPT_PROPERTY_REF"][::std::mem::align_of::<_CRYPT_PROPERTY_REF>() - 8usize];
    ["Offset of field: _CRYPT_PROPERTY_REF::pszProperty"]
        [::std::mem::offset_of!(_CRYPT_PROPERTY_REF, pszProperty) - 0usize];
    ["Offset of field: _CRYPT_PROPERTY_REF::cbValue"]
        [::std::mem::offset_of!(_CRYPT_PROPERTY_REF, cbValue) - 8usize];
    ["Offset of field: _CRYPT_PROPERTY_REF::pbValue"]
        [::std::mem::offset_of!(_CRYPT_PROPERTY_REF, pbValue) - 16usize];
};
pub type CRYPT_PROPERTY_REF = _CRYPT_PROPERTY_REF;
pub type PCRYPT_PROPERTY_REF = *mut _CRYPT_PROPERTY_REF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_IMAGE_REF {
    pub pszImage: PWSTR,
    pub dwFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_IMAGE_REF"][::std::mem::size_of::<_CRYPT_IMAGE_REF>() - 16usize];
    ["Alignment of _CRYPT_IMAGE_REF"][::std::mem::align_of::<_CRYPT_IMAGE_REF>() - 8usize];
    ["Offset of field: _CRYPT_IMAGE_REF::pszImage"]
        [::std::mem::offset_of!(_CRYPT_IMAGE_REF, pszImage) - 0usize];
    ["Offset of field: _CRYPT_IMAGE_REF::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_IMAGE_REF, dwFlags) - 8usize];
};
pub type CRYPT_IMAGE_REF = _CRYPT_IMAGE_REF;
pub type PCRYPT_IMAGE_REF = *mut _CRYPT_IMAGE_REF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PROVIDER_REF {
    pub dwInterface: ULONG,
    pub pszFunction: PWSTR,
    pub pszProvider: PWSTR,
    pub cProperties: ULONG,
    pub rgpProperties: *mut PCRYPT_PROPERTY_REF,
    pub pUM: PCRYPT_IMAGE_REF,
    pub pKM: PCRYPT_IMAGE_REF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PROVIDER_REF"][::std::mem::size_of::<_CRYPT_PROVIDER_REF>() - 56usize];
    ["Alignment of _CRYPT_PROVIDER_REF"][::std::mem::align_of::<_CRYPT_PROVIDER_REF>() - 8usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::dwInterface"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, dwInterface) - 0usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::pszFunction"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, pszFunction) - 8usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::pszProvider"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, pszProvider) - 16usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::cProperties"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, cProperties) - 24usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::rgpProperties"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, rgpProperties) - 32usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::pUM"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, pUM) - 40usize];
    ["Offset of field: _CRYPT_PROVIDER_REF::pKM"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REF, pKM) - 48usize];
};
pub type CRYPT_PROVIDER_REF = _CRYPT_PROVIDER_REF;
pub type PCRYPT_PROVIDER_REF = *mut _CRYPT_PROVIDER_REF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PROVIDER_REFS {
    pub cProviders: ULONG,
    pub rgpProviders: *mut PCRYPT_PROVIDER_REF,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PROVIDER_REFS"][::std::mem::size_of::<_CRYPT_PROVIDER_REFS>() - 16usize];
    ["Alignment of _CRYPT_PROVIDER_REFS"][::std::mem::align_of::<_CRYPT_PROVIDER_REFS>() - 8usize];
    ["Offset of field: _CRYPT_PROVIDER_REFS::cProviders"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REFS, cProviders) - 0usize];
    ["Offset of field: _CRYPT_PROVIDER_REFS::rgpProviders"]
        [::std::mem::offset_of!(_CRYPT_PROVIDER_REFS, rgpProviders) - 8usize];
};
pub type CRYPT_PROVIDER_REFS = _CRYPT_PROVIDER_REFS;
pub type PCRYPT_PROVIDER_REFS = *mut _CRYPT_PROVIDER_REFS;
unsafe extern "C" {
    pub fn BCryptQueryProviderRegistration(
        pszProvider: LPCWSTR,
        dwMode: ULONG,
        dwInterface: ULONG,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_PROVIDER_REG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptEnumRegisteredProviders(
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_PROVIDERS,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptCreateContext(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        pConfig: PCRYPT_CONTEXT_CONFIG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptDeleteContext(dwTable: ULONG, pszContext: LPCWSTR) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptEnumContexts(
        dwTable: ULONG,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_CONTEXTS,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptConfigureContext(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        pConfig: PCRYPT_CONTEXT_CONFIG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptQueryContextConfiguration(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_CONTEXT_CONFIG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptAddContextFunction(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        dwPosition: ULONG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptRemoveContextFunction(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptEnumContextFunctions(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_CONTEXT_FUNCTIONS,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptConfigureContextFunction(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pConfig: PCRYPT_CONTEXT_FUNCTION_CONFIG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptQueryContextFunctionConfiguration(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_CONTEXT_FUNCTION_CONFIG,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptEnumContextFunctionProviders(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_CONTEXT_FUNCTION_PROVIDERS,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptSetContextFunctionProperty(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pszProperty: LPCWSTR,
        cbValue: ULONG,
        pbValue: PUCHAR,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptQueryContextFunctionProperty(
        dwTable: ULONG,
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pszProperty: LPCWSTR,
        pcbValue: *mut ULONG,
        ppbValue: *mut PUCHAR,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptRegisterConfigChangeNotify(phEvent: *mut HANDLE) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptUnregisterConfigChangeNotify(hEvent: HANDLE) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptResolveProviders(
        pszContext: LPCWSTR,
        dwInterface: ULONG,
        pszFunction: LPCWSTR,
        pszProvider: LPCWSTR,
        dwMode: ULONG,
        dwFlags: ULONG,
        pcbBuffer: *mut ULONG,
        ppBuffer: *mut PCRYPT_PROVIDER_REFS,
    ) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn BCryptGetFipsAlgorithmMode(pfEnabled: *mut BOOLEAN) -> NTSTATUS;
}
unsafe extern "C" {
    pub fn CngGetFipsAlgorithmMode() -> BOOLEAN;
}
pub type SECURITY_STATUS = LONG;
pub type PFN_NCRYPT_ALLOC = ::std::option::Option<unsafe extern "C" fn(cbSize: SIZE_T) -> LPVOID>;
pub type PFN_NCRYPT_FREE = ::std::option::Option<unsafe extern "C" fn(pv: LPVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NCRYPT_ALLOC_PARA {
    pub cbSize: DWORD,
    pub pfnAlloc: PFN_NCRYPT_ALLOC,
    pub pfnFree: PFN_NCRYPT_FREE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NCRYPT_ALLOC_PARA"][::std::mem::size_of::<NCRYPT_ALLOC_PARA>() - 24usize];
    ["Alignment of NCRYPT_ALLOC_PARA"][::std::mem::align_of::<NCRYPT_ALLOC_PARA>() - 8usize];
    ["Offset of field: NCRYPT_ALLOC_PARA::cbSize"]
        [::std::mem::offset_of!(NCRYPT_ALLOC_PARA, cbSize) - 0usize];
    ["Offset of field: NCRYPT_ALLOC_PARA::pfnAlloc"]
        [::std::mem::offset_of!(NCRYPT_ALLOC_PARA, pfnAlloc) - 8usize];
    ["Offset of field: NCRYPT_ALLOC_PARA::pfnFree"]
        [::std::mem::offset_of!(NCRYPT_ALLOC_PARA, pfnFree) - 16usize];
};
pub type NCryptBuffer = BCryptBuffer;
pub type PNCryptBuffer = *mut BCryptBuffer;
pub type NCryptBufferDesc = BCryptBufferDesc;
pub type PNCryptBufferDesc = *mut BCryptBufferDesc;
pub type NCRYPT_HANDLE = ULONG_PTR;
pub type NCRYPT_PROV_HANDLE = ULONG_PTR;
pub type NCRYPT_KEY_HANDLE = ULONG_PTR;
pub type NCRYPT_HASH_HANDLE = ULONG_PTR;
pub type NCRYPT_SECRET_HANDLE = ULONG_PTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_CIPHER_PADDING_INFO {
    pub cbSize: ULONG,
    pub dwFlags: DWORD,
    pub pbIV: PUCHAR,
    pub cbIV: ULONG,
    pub pbOtherInfo: PUCHAR,
    pub cbOtherInfo: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_CIPHER_PADDING_INFO"]
        [::std::mem::size_of::<_NCRYPT_CIPHER_PADDING_INFO>() - 40usize];
    ["Alignment of _NCRYPT_CIPHER_PADDING_INFO"]
        [::std::mem::align_of::<_NCRYPT_CIPHER_PADDING_INFO>() - 8usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::cbSize"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, cbSize) - 0usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::dwFlags"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, dwFlags) - 4usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::pbIV"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, pbIV) - 8usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::cbIV"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, cbIV) - 16usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::pbOtherInfo"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, pbOtherInfo) - 24usize];
    ["Offset of field: _NCRYPT_CIPHER_PADDING_INFO::cbOtherInfo"]
        [::std::mem::offset_of!(_NCRYPT_CIPHER_PADDING_INFO, cbOtherInfo) - 32usize];
};
pub type NCRYPT_CIPHER_PADDING_INFO = _NCRYPT_CIPHER_PADDING_INFO;
pub type PNCRYPT_CIPHER_PADDING_INFO = *mut _NCRYPT_CIPHER_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_PLATFORM_ATTEST_PADDING_INFO {
    pub magic: ULONG,
    pub pcrMask: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_PLATFORM_ATTEST_PADDING_INFO"]
        [::std::mem::size_of::<_NCRYPT_PLATFORM_ATTEST_PADDING_INFO>() - 8usize];
    ["Alignment of _NCRYPT_PLATFORM_ATTEST_PADDING_INFO"]
        [::std::mem::align_of::<_NCRYPT_PLATFORM_ATTEST_PADDING_INFO>() - 4usize];
    ["Offset of field: _NCRYPT_PLATFORM_ATTEST_PADDING_INFO::magic"]
        [::std::mem::offset_of!(_NCRYPT_PLATFORM_ATTEST_PADDING_INFO, magic) - 0usize];
    ["Offset of field: _NCRYPT_PLATFORM_ATTEST_PADDING_INFO::pcrMask"]
        [::std::mem::offset_of!(_NCRYPT_PLATFORM_ATTEST_PADDING_INFO, pcrMask) - 4usize];
};
pub type NCRYPT_PLATFORM_ATTEST_PADDING_INFO = _NCRYPT_PLATFORM_ATTEST_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_KEY_ATTEST_PADDING_INFO {
    pub magic: ULONG,
    pub pbKeyBlob: PUCHAR,
    pub cbKeyBlob: ULONG,
    pub pbKeyAuth: PUCHAR,
    pub cbKeyAuth: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_KEY_ATTEST_PADDING_INFO"]
        [::std::mem::size_of::<_NCRYPT_KEY_ATTEST_PADDING_INFO>() - 40usize];
    ["Alignment of _NCRYPT_KEY_ATTEST_PADDING_INFO"]
        [::std::mem::align_of::<_NCRYPT_KEY_ATTEST_PADDING_INFO>() - 8usize];
    ["Offset of field: _NCRYPT_KEY_ATTEST_PADDING_INFO::magic"]
        [::std::mem::offset_of!(_NCRYPT_KEY_ATTEST_PADDING_INFO, magic) - 0usize];
    ["Offset of field: _NCRYPT_KEY_ATTEST_PADDING_INFO::pbKeyBlob"]
        [::std::mem::offset_of!(_NCRYPT_KEY_ATTEST_PADDING_INFO, pbKeyBlob) - 8usize];
    ["Offset of field: _NCRYPT_KEY_ATTEST_PADDING_INFO::cbKeyBlob"]
        [::std::mem::offset_of!(_NCRYPT_KEY_ATTEST_PADDING_INFO, cbKeyBlob) - 16usize];
    ["Offset of field: _NCRYPT_KEY_ATTEST_PADDING_INFO::pbKeyAuth"]
        [::std::mem::offset_of!(_NCRYPT_KEY_ATTEST_PADDING_INFO, pbKeyAuth) - 24usize];
    ["Offset of field: _NCRYPT_KEY_ATTEST_PADDING_INFO::cbKeyAuth"]
        [::std::mem::offset_of!(_NCRYPT_KEY_ATTEST_PADDING_INFO, cbKeyAuth) - 32usize];
};
pub type NCRYPT_KEY_ATTEST_PADDING_INFO = _NCRYPT_KEY_ATTEST_PADDING_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES {
    pub Version: ULONG,
    pub Flags: ULONG,
    pub cbPublicKeyBlob: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES"]
        [::std::mem::size_of::<_NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES>() - 12usize];
    ["Alignment of _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES"]
        [::std::mem::align_of::<_NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES>() - 4usize];
    ["Offset of field: _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES::Version"]
        [::std::mem::offset_of!(_NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES, Version) - 0usize];
    ["Offset of field: _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES::Flags"]
        [::std::mem::offset_of!(_NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES, Flags) - 4usize];
    ["Offset of field: _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES::cbPublicKeyBlob"][::std::mem::offset_of!(
        _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES,
        cbPublicKeyBlob
    ) - 8usize];
};
pub type NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES = _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES;
pub type PNCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES = *mut _NCRYPT_ISOLATED_KEY_ATTESTED_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT {
    pub Magic: ULONG,
    pub Version: ULONG,
    pub cbSignature: ULONG,
    pub cbReport: ULONG,
    pub cbAttributes: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT"]
        [::std::mem::size_of::<_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT>() - 20usize];
    ["Alignment of _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT"]
        [::std::mem::align_of::<_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT>() - 4usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT::Magic"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT, Magic) - 0usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT::Version"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT, Version) - 4usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT::cbSignature"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT, cbSignature) - 8usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT::cbReport"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT, cbReport) - 12usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT::cbAttributes"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_STATEMENT, cbAttributes) - 16usize];
};
pub type NCRYPT_VSM_KEY_ATTESTATION_STATEMENT = _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT;
pub type PNCRYPT_VSM_KEY_ATTESTATION_STATEMENT = *mut _NCRYPT_VSM_KEY_ATTESTATION_STATEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS {
    pub Version: ULONG,
    pub TrustletId: ULONGLONG,
    pub MinSvn: ULONG,
    pub FlagsMask: ULONG,
    pub FlagsExpected: ULONG,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS"]
        [::std::mem::size_of::<_NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS>() - 32usize];
    ["Alignment of _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS"]
        [::std::mem::align_of::<_NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS>() - 8usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS::Version"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS, Version) - 0usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS::TrustletId"][::std::mem::offset_of!(
        _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS,
        TrustletId
    ) - 8usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS::MinSvn"]
        [::std::mem::offset_of!(_NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS, MinSvn) - 16usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS::FlagsMask"][::std::mem::offset_of!(
        _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS,
        FlagsMask
    ) - 20usize];
    ["Offset of field: _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS::FlagsExpected"][::std::mem::offset_of!(
        _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS,
        FlagsExpected
    ) - 24usize];
};
impl _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS {
    #[inline]
    pub fn AllowDebugging(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_AllowDebugging(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AllowDebugging_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_AllowDebugging_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        AllowDebugging: ULONG,
        Reserved: ULONG,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let AllowDebugging: u32 = unsafe { ::std::mem::transmute(AllowDebugging) };
            AllowDebugging as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS =
    _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS;
pub type PNCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS =
    *mut _NCRYPT_VSM_KEY_ATTESTATION_CLAIM_RESTRICTIONS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER {
    pub Version: ULONG,
    pub KeyUsage: ULONG,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub cbAlgName: ULONG,
    pub cbNonce: ULONG,
    pub cbAuthTag: ULONG,
    pub cbWrappingKey: ULONG,
    pub cbIsolatedKey: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER"]
        [::std::mem::size_of::<_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER>() - 32usize];
    ["Alignment of _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER"]
        [::std::mem::align_of::<_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER>() - 4usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::Version"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, Version) - 0usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::KeyUsage"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, KeyUsage) - 4usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::cbAlgName"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, cbAlgName) - 12usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::cbNonce"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, cbNonce) - 16usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::cbAuthTag"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, cbAuthTag) - 20usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::cbWrappingKey"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, cbWrappingKey) - 24usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER::cbIsolatedKey"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_HEADER, cbIsolatedKey) - 28usize];
};
impl _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER {
    #[inline]
    pub fn PerBootKey(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_PerBootKey(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn PerBootKey_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_PerBootKey_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> ULONG {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> ULONG {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: ULONG) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        PerBootKey: ULONG,
        Reserved: ULONG,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let PerBootKey: u32 = unsafe { ::std::mem::transmute(PerBootKey) };
            PerBootKey as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type NCRYPT_EXPORTED_ISOLATED_KEY_HEADER = _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER;
pub type PNCRYPT_EXPORTED_ISOLATED_KEY_HEADER = *mut _NCRYPT_EXPORTED_ISOLATED_KEY_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE {
    pub Header: NCRYPT_EXPORTED_ISOLATED_KEY_HEADER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE"]
        [::std::mem::size_of::<_NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE>() - 32usize];
    ["Alignment of _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE"]
        [::std::mem::align_of::<_NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE>() - 4usize];
    ["Offset of field: _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE::Header"]
        [::std::mem::offset_of!(_NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE, Header) - 0usize];
};
pub type NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE = _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE;
pub type PNCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE = *mut _NCRYPT_EXPORTED_ISOLATED_KEY_ENVELOPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT {
    pub Magic: UINT32,
    pub Version: UINT32,
    pub HeaderSize: UINT32,
    pub cbCertifyInfo: UINT32,
    pub cbSignature: UINT32,
    pub cbTpmPublic: UINT32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT"]
        [::std::mem::size_of::<__NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT>() - 24usize];
    ["Alignment of __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT"]
        [::std::mem::align_of::<__NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT>() - 4usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::Magic"]
        [::std::mem::offset_of!(__NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT, Magic) - 0usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::Version"][::std::mem::offset_of!(
        __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT,
        Version
    ) - 4usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::HeaderSize"][::std::mem::offset_of!(
        __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT,
        HeaderSize
    ) - 8usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::cbCertifyInfo"][::std::mem::offset_of!(
        __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT,
        cbCertifyInfo
    )
        - 12usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::cbSignature"][::std::mem::offset_of!(
        __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT,
        cbSignature
    ) - 16usize];
    ["Offset of field: __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT::cbTpmPublic"][::std::mem::offset_of!(
        __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT,
        cbTpmPublic
    ) - 20usize];
};
pub type NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT =
    __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT;
pub type PNCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT =
    *mut __NCRYPT_PCP_TPM_WEB_AUTHN_ATTESTATION_STATEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT {
    pub Magic: ULONG,
    pub Version: ULONG,
    pub pcrAlg: ULONG,
    pub cbSignature: ULONG,
    pub cbQuote: ULONG,
    pub cbPcrs: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT"]
        [::std::mem::size_of::<_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT>() - 24usize];
    ["Alignment of _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT"]
        [::std::mem::align_of::<_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT>() - 4usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::Magic"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, Magic) - 0usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::Version"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, Version) - 4usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::pcrAlg"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, pcrAlg) - 8usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::cbSignature"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, cbSignature) - 12usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::cbQuote"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, cbQuote) - 16usize];
    ["Offset of field: _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT::cbPcrs"]
        [::std::mem::offset_of!(_NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT, cbPcrs) - 20usize];
};
pub type NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT = _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT;
pub type PNCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT =
    *mut _NCRYPT_TPM_PLATFORM_ATTESTATION_STATEMENT;
unsafe extern "C" {
    pub fn NCryptOpenStorageProvider(
        phProvider: *mut NCRYPT_PROV_HANDLE,
        pszProviderName: LPCWSTR,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCryptAlgorithmName {
    pub pszName: LPWSTR,
    pub dwClass: DWORD,
    pub dwAlgOperations: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCryptAlgorithmName"][::std::mem::size_of::<_NCryptAlgorithmName>() - 24usize];
    ["Alignment of _NCryptAlgorithmName"][::std::mem::align_of::<_NCryptAlgorithmName>() - 8usize];
    ["Offset of field: _NCryptAlgorithmName::pszName"]
        [::std::mem::offset_of!(_NCryptAlgorithmName, pszName) - 0usize];
    ["Offset of field: _NCryptAlgorithmName::dwClass"]
        [::std::mem::offset_of!(_NCryptAlgorithmName, dwClass) - 8usize];
    ["Offset of field: _NCryptAlgorithmName::dwAlgOperations"]
        [::std::mem::offset_of!(_NCryptAlgorithmName, dwAlgOperations) - 12usize];
    ["Offset of field: _NCryptAlgorithmName::dwFlags"]
        [::std::mem::offset_of!(_NCryptAlgorithmName, dwFlags) - 16usize];
};
pub type NCryptAlgorithmName = _NCryptAlgorithmName;
unsafe extern "C" {
    pub fn NCryptEnumAlgorithms(
        hProvider: NCRYPT_PROV_HANDLE,
        dwAlgOperations: DWORD,
        pdwAlgCount: *mut DWORD,
        ppAlgList: *mut *mut NCryptAlgorithmName,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptIsAlgSupported(
        hProvider: NCRYPT_PROV_HANDLE,
        pszAlgId: LPCWSTR,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NCryptKeyName {
    pub pszName: LPWSTR,
    pub pszAlgid: LPWSTR,
    pub dwLegacyKeySpec: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NCryptKeyName"][::std::mem::size_of::<NCryptKeyName>() - 24usize];
    ["Alignment of NCryptKeyName"][::std::mem::align_of::<NCryptKeyName>() - 8usize];
    ["Offset of field: NCryptKeyName::pszName"]
        [::std::mem::offset_of!(NCryptKeyName, pszName) - 0usize];
    ["Offset of field: NCryptKeyName::pszAlgid"]
        [::std::mem::offset_of!(NCryptKeyName, pszAlgid) - 8usize];
    ["Offset of field: NCryptKeyName::dwLegacyKeySpec"]
        [::std::mem::offset_of!(NCryptKeyName, dwLegacyKeySpec) - 16usize];
    ["Offset of field: NCryptKeyName::dwFlags"]
        [::std::mem::offset_of!(NCryptKeyName, dwFlags) - 20usize];
};
unsafe extern "C" {
    pub fn NCryptEnumKeys(
        hProvider: NCRYPT_PROV_HANDLE,
        pszScope: LPCWSTR,
        ppKeyName: *mut *mut NCryptKeyName,
        ppEnumState: *mut PVOID,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NCryptProviderName {
    pub pszName: LPWSTR,
    pub pszComment: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NCryptProviderName"][::std::mem::size_of::<NCryptProviderName>() - 16usize];
    ["Alignment of NCryptProviderName"][::std::mem::align_of::<NCryptProviderName>() - 8usize];
    ["Offset of field: NCryptProviderName::pszName"]
        [::std::mem::offset_of!(NCryptProviderName, pszName) - 0usize];
    ["Offset of field: NCryptProviderName::pszComment"]
        [::std::mem::offset_of!(NCryptProviderName, pszComment) - 8usize];
};
unsafe extern "C" {
    pub fn NCryptEnumStorageProviders(
        pdwProviderCount: *mut DWORD,
        ppProviderList: *mut *mut NCryptProviderName,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptFreeBuffer(pvInput: PVOID) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptOpenKey(
        hProvider: NCRYPT_PROV_HANDLE,
        phKey: *mut NCRYPT_KEY_HANDLE,
        pszKeyName: LPCWSTR,
        dwLegacyKeySpec: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptCreatePersistedKey(
        hProvider: NCRYPT_PROV_HANDLE,
        phKey: *mut NCRYPT_KEY_HANDLE,
        pszAlgId: LPCWSTR,
        pszKeyName: LPCWSTR,
        dwLegacyKeySpec: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_UI_POLICY {
    pub dwVersion: DWORD,
    pub dwFlags: DWORD,
    pub pszCreationTitle: LPCWSTR,
    pub pszFriendlyName: LPCWSTR,
    pub pszDescription: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_UI_POLICY"][::std::mem::size_of::<__NCRYPT_UI_POLICY>() - 32usize];
    ["Alignment of __NCRYPT_UI_POLICY"][::std::mem::align_of::<__NCRYPT_UI_POLICY>() - 8usize];
    ["Offset of field: __NCRYPT_UI_POLICY::dwVersion"]
        [::std::mem::offset_of!(__NCRYPT_UI_POLICY, dwVersion) - 0usize];
    ["Offset of field: __NCRYPT_UI_POLICY::dwFlags"]
        [::std::mem::offset_of!(__NCRYPT_UI_POLICY, dwFlags) - 4usize];
    ["Offset of field: __NCRYPT_UI_POLICY::pszCreationTitle"]
        [::std::mem::offset_of!(__NCRYPT_UI_POLICY, pszCreationTitle) - 8usize];
    ["Offset of field: __NCRYPT_UI_POLICY::pszFriendlyName"]
        [::std::mem::offset_of!(__NCRYPT_UI_POLICY, pszFriendlyName) - 16usize];
    ["Offset of field: __NCRYPT_UI_POLICY::pszDescription"]
        [::std::mem::offset_of!(__NCRYPT_UI_POLICY, pszDescription) - 24usize];
};
pub type NCRYPT_UI_POLICY = __NCRYPT_UI_POLICY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_KEY_ACCESS_POLICY_BLOB {
    pub dwVersion: DWORD,
    pub dwPolicyFlags: DWORD,
    pub cbUserSid: DWORD,
    pub cbApplicationSid: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_KEY_ACCESS_POLICY_BLOB"]
        [::std::mem::size_of::<__NCRYPT_KEY_ACCESS_POLICY_BLOB>() - 16usize];
    ["Alignment of __NCRYPT_KEY_ACCESS_POLICY_BLOB"]
        [::std::mem::align_of::<__NCRYPT_KEY_ACCESS_POLICY_BLOB>() - 4usize];
    ["Offset of field: __NCRYPT_KEY_ACCESS_POLICY_BLOB::dwVersion"]
        [::std::mem::offset_of!(__NCRYPT_KEY_ACCESS_POLICY_BLOB, dwVersion) - 0usize];
    ["Offset of field: __NCRYPT_KEY_ACCESS_POLICY_BLOB::dwPolicyFlags"]
        [::std::mem::offset_of!(__NCRYPT_KEY_ACCESS_POLICY_BLOB, dwPolicyFlags) - 4usize];
    ["Offset of field: __NCRYPT_KEY_ACCESS_POLICY_BLOB::cbUserSid"]
        [::std::mem::offset_of!(__NCRYPT_KEY_ACCESS_POLICY_BLOB, cbUserSid) - 8usize];
    ["Offset of field: __NCRYPT_KEY_ACCESS_POLICY_BLOB::cbApplicationSid"]
        [::std::mem::offset_of!(__NCRYPT_KEY_ACCESS_POLICY_BLOB, cbApplicationSid) - 12usize];
};
pub type NCRYPT_KEY_ACCESS_POLICY_BLOB = __NCRYPT_KEY_ACCESS_POLICY_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_SUPPORTED_LENGTHS {
    pub dwMinLength: DWORD,
    pub dwMaxLength: DWORD,
    pub dwIncrement: DWORD,
    pub dwDefaultLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_SUPPORTED_LENGTHS"]
        [::std::mem::size_of::<__NCRYPT_SUPPORTED_LENGTHS>() - 16usize];
    ["Alignment of __NCRYPT_SUPPORTED_LENGTHS"]
        [::std::mem::align_of::<__NCRYPT_SUPPORTED_LENGTHS>() - 4usize];
    ["Offset of field: __NCRYPT_SUPPORTED_LENGTHS::dwMinLength"]
        [::std::mem::offset_of!(__NCRYPT_SUPPORTED_LENGTHS, dwMinLength) - 0usize];
    ["Offset of field: __NCRYPT_SUPPORTED_LENGTHS::dwMaxLength"]
        [::std::mem::offset_of!(__NCRYPT_SUPPORTED_LENGTHS, dwMaxLength) - 4usize];
    ["Offset of field: __NCRYPT_SUPPORTED_LENGTHS::dwIncrement"]
        [::std::mem::offset_of!(__NCRYPT_SUPPORTED_LENGTHS, dwIncrement) - 8usize];
    ["Offset of field: __NCRYPT_SUPPORTED_LENGTHS::dwDefaultLength"]
        [::std::mem::offset_of!(__NCRYPT_SUPPORTED_LENGTHS, dwDefaultLength) - 12usize];
};
pub type NCRYPT_SUPPORTED_LENGTHS = __NCRYPT_SUPPORTED_LENGTHS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO {
    pub dwVersion: DWORD,
    pub iExpiration: INT32,
    pub pabNonce: [BYTE; 32usize],
    pub pabPolicyRef: [BYTE; 32usize],
    pub pabHMAC: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO"]
        [::std::mem::size_of::<__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO>() - 104usize];
    ["Alignment of __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO"]
        [::std::mem::align_of::<__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO>() - 4usize];
    ["Offset of field: __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO::dwVersion"]
        [::std::mem::offset_of!(__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO, dwVersion) - 0usize];
    ["Offset of field: __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO::iExpiration"]
        [::std::mem::offset_of!(__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO, iExpiration) - 4usize];
    ["Offset of field: __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO::pabNonce"]
        [::std::mem::offset_of!(__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO, pabNonce) - 8usize];
    ["Offset of field: __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO::pabPolicyRef"]
        [::std::mem::offset_of!(__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO, pabPolicyRef) - 40usize];
    ["Offset of field: __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO::pabHMAC"]
        [::std::mem::offset_of!(__NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO, pabHMAC) - 72usize];
};
pub type NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO = __NCRYPT_PCP_HMAC_AUTH_SIGNATURE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_PCP_TPM_FW_VERSION_INFO {
    pub major1: UINT16,
    pub major2: UINT16,
    pub minor1: UINT16,
    pub minor2: UINT16,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_PCP_TPM_FW_VERSION_INFO"]
        [::std::mem::size_of::<__NCRYPT_PCP_TPM_FW_VERSION_INFO>() - 8usize];
    ["Alignment of __NCRYPT_PCP_TPM_FW_VERSION_INFO"]
        [::std::mem::align_of::<__NCRYPT_PCP_TPM_FW_VERSION_INFO>() - 2usize];
    ["Offset of field: __NCRYPT_PCP_TPM_FW_VERSION_INFO::major1"]
        [::std::mem::offset_of!(__NCRYPT_PCP_TPM_FW_VERSION_INFO, major1) - 0usize];
    ["Offset of field: __NCRYPT_PCP_TPM_FW_VERSION_INFO::major2"]
        [::std::mem::offset_of!(__NCRYPT_PCP_TPM_FW_VERSION_INFO, major2) - 2usize];
    ["Offset of field: __NCRYPT_PCP_TPM_FW_VERSION_INFO::minor1"]
        [::std::mem::offset_of!(__NCRYPT_PCP_TPM_FW_VERSION_INFO, minor1) - 4usize];
    ["Offset of field: __NCRYPT_PCP_TPM_FW_VERSION_INFO::minor2"]
        [::std::mem::offset_of!(__NCRYPT_PCP_TPM_FW_VERSION_INFO, minor2) - 6usize];
};
pub type NCRYPT_PCP_TPM_FW_VERSION_INFO = __NCRYPT_PCP_TPM_FW_VERSION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __NCRYPT_PCP_RAW_POLICYDIGEST {
    pub dwVersion: DWORD,
    pub cbDigest: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __NCRYPT_PCP_RAW_POLICYDIGEST"]
        [::std::mem::size_of::<__NCRYPT_PCP_RAW_POLICYDIGEST>() - 8usize];
    ["Alignment of __NCRYPT_PCP_RAW_POLICYDIGEST"]
        [::std::mem::align_of::<__NCRYPT_PCP_RAW_POLICYDIGEST>() - 4usize];
    ["Offset of field: __NCRYPT_PCP_RAW_POLICYDIGEST::dwVersion"]
        [::std::mem::offset_of!(__NCRYPT_PCP_RAW_POLICYDIGEST, dwVersion) - 0usize];
    ["Offset of field: __NCRYPT_PCP_RAW_POLICYDIGEST::cbDigest"]
        [::std::mem::offset_of!(__NCRYPT_PCP_RAW_POLICYDIGEST, cbDigest) - 4usize];
};
pub type NCRYPT_PCP_RAW_POLICYDIGEST_INFO = __NCRYPT_PCP_RAW_POLICYDIGEST;
unsafe extern "C" {
    pub fn NCryptGetProperty(
        hObject: NCRYPT_HANDLE,
        pszProperty: LPCWSTR,
        pbOutput: PBYTE,
        cbOutput: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptSetProperty(
        hObject: NCRYPT_HANDLE,
        pszProperty: LPCWSTR,
        pbInput: PBYTE,
        cbInput: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptFinalizeKey(hKey: NCRYPT_KEY_HANDLE, dwFlags: DWORD) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptEncrypt(
        hKey: NCRYPT_KEY_HANDLE,
        pbInput: PBYTE,
        cbInput: DWORD,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbOutput: PBYTE,
        cbOutput: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptDecrypt(
        hKey: NCRYPT_KEY_HANDLE,
        pbInput: PBYTE,
        cbInput: DWORD,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbOutput: PBYTE,
        cbOutput: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NCRYPT_KEY_BLOB_HEADER {
    pub cbSize: ULONG,
    pub dwMagic: ULONG,
    pub cbAlgName: ULONG,
    pub cbKeyData: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NCRYPT_KEY_BLOB_HEADER"][::std::mem::size_of::<_NCRYPT_KEY_BLOB_HEADER>() - 16usize];
    ["Alignment of _NCRYPT_KEY_BLOB_HEADER"]
        [::std::mem::align_of::<_NCRYPT_KEY_BLOB_HEADER>() - 4usize];
    ["Offset of field: _NCRYPT_KEY_BLOB_HEADER::cbSize"]
        [::std::mem::offset_of!(_NCRYPT_KEY_BLOB_HEADER, cbSize) - 0usize];
    ["Offset of field: _NCRYPT_KEY_BLOB_HEADER::dwMagic"]
        [::std::mem::offset_of!(_NCRYPT_KEY_BLOB_HEADER, dwMagic) - 4usize];
    ["Offset of field: _NCRYPT_KEY_BLOB_HEADER::cbAlgName"]
        [::std::mem::offset_of!(_NCRYPT_KEY_BLOB_HEADER, cbAlgName) - 8usize];
    ["Offset of field: _NCRYPT_KEY_BLOB_HEADER::cbKeyData"]
        [::std::mem::offset_of!(_NCRYPT_KEY_BLOB_HEADER, cbKeyData) - 12usize];
};
pub type NCRYPT_KEY_BLOB_HEADER = _NCRYPT_KEY_BLOB_HEADER;
pub type PNCRYPT_KEY_BLOB_HEADER = *mut _NCRYPT_KEY_BLOB_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER {
    pub magic: DWORD,
    pub cbHeader: DWORD,
    pub cbPublic: DWORD,
    pub cbPrivate: DWORD,
    pub cbName: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER"]
        [::std::mem::size_of::<NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER>() - 20usize];
    ["Alignment of NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER"]
        [::std::mem::align_of::<NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER>() - 4usize];
    ["Offset of field: NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER::magic"]
        [::std::mem::offset_of!(NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER, magic) - 0usize];
    ["Offset of field: NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER::cbHeader"]
        [::std::mem::offset_of!(NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER, cbHeader) - 4usize];
    ["Offset of field: NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER::cbPublic"]
        [::std::mem::offset_of!(NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER, cbPublic) - 8usize];
    ["Offset of field: NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER::cbPrivate"]
        [::std::mem::offset_of!(NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER, cbPrivate) - 12usize];
    ["Offset of field: NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER::cbName"]
        [::std::mem::offset_of!(NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER, cbName) - 16usize];
};
pub type PNCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER = *mut NCRYPT_TPM_LOADABLE_KEY_BLOB_HEADER;
unsafe extern "C" {
    pub fn NCryptImportKey(
        hProvider: NCRYPT_PROV_HANDLE,
        hImportKey: NCRYPT_KEY_HANDLE,
        pszBlobType: LPCWSTR,
        pParameterList: *mut NCryptBufferDesc,
        phKey: *mut NCRYPT_KEY_HANDLE,
        pbData: PBYTE,
        cbData: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptExportKey(
        hKey: NCRYPT_KEY_HANDLE,
        hExportKey: NCRYPT_KEY_HANDLE,
        pszBlobType: LPCWSTR,
        pParameterList: *mut NCryptBufferDesc,
        pbOutput: PBYTE,
        cbOutput: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptSignHash(
        hKey: NCRYPT_KEY_HANDLE,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbHashValue: PBYTE,
        cbHashValue: DWORD,
        pbSignature: PBYTE,
        cbSignature: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptVerifySignature(
        hKey: NCRYPT_KEY_HANDLE,
        pPaddingInfo: *mut ::std::os::raw::c_void,
        pbHashValue: PBYTE,
        cbHashValue: DWORD,
        pbSignature: PBYTE,
        cbSignature: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptDeleteKey(hKey: NCRYPT_KEY_HANDLE, dwFlags: DWORD) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptFreeObject(hObject: NCRYPT_HANDLE) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptIsKeyHandle(hKey: NCRYPT_KEY_HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn NCryptTranslateHandle(
        phProvider: *mut NCRYPT_PROV_HANDLE,
        phKey: *mut NCRYPT_KEY_HANDLE,
        hLegacyProv: HCRYPTPROV,
        hLegacyKey: HCRYPTKEY,
        dwLegacyKeySpec: DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptNotifyChangeKey(
        hProvider: NCRYPT_PROV_HANDLE,
        phEvent: *mut HANDLE,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptSecretAgreement(
        hPrivKey: NCRYPT_KEY_HANDLE,
        hPubKey: NCRYPT_KEY_HANDLE,
        phAgreedSecret: *mut NCRYPT_SECRET_HANDLE,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptDeriveKey(
        hSharedSecret: NCRYPT_SECRET_HANDLE,
        pwszKDF: LPCWSTR,
        pParameterList: *mut NCryptBufferDesc,
        pbDerivedKey: PBYTE,
        cbDerivedKey: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: ULONG,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptKeyDerivation(
        hKey: NCRYPT_KEY_HANDLE,
        pParameterList: *mut NCryptBufferDesc,
        pbDerivedKey: PUCHAR,
        cbDerivedKey: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: ULONG,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptCreateClaim(
        hSubjectKey: NCRYPT_KEY_HANDLE,
        hAuthorityKey: NCRYPT_KEY_HANDLE,
        dwClaimType: DWORD,
        pParameterList: *mut NCryptBufferDesc,
        pbClaimBlob: PBYTE,
        cbClaimBlob: DWORD,
        pcbResult: *mut DWORD,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
unsafe extern "C" {
    pub fn NCryptVerifyClaim(
        hSubjectKey: NCRYPT_KEY_HANDLE,
        hAuthorityKey: NCRYPT_KEY_HANDLE,
        dwClaimType: DWORD,
        pParameterList: *mut NCryptBufferDesc,
        pbClaimBlob: PBYTE,
        cbClaimBlob: DWORD,
        pOutput: *mut NCryptBufferDesc,
        dwFlags: DWORD,
    ) -> SECURITY_STATUS;
}
pub type HCRYPTPROV_OR_NCRYPT_KEY_HANDLE = ULONG_PTR;
pub type HCRYPTPROV_LEGACY = ULONG_PTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_BIT_BLOB {
    pub cbData: DWORD,
    pub pbData: *mut BYTE,
    pub cUnusedBits: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_BIT_BLOB"][::std::mem::size_of::<_CRYPT_BIT_BLOB>() - 24usize];
    ["Alignment of _CRYPT_BIT_BLOB"][::std::mem::align_of::<_CRYPT_BIT_BLOB>() - 8usize];
    ["Offset of field: _CRYPT_BIT_BLOB::cbData"]
        [::std::mem::offset_of!(_CRYPT_BIT_BLOB, cbData) - 0usize];
    ["Offset of field: _CRYPT_BIT_BLOB::pbData"]
        [::std::mem::offset_of!(_CRYPT_BIT_BLOB, pbData) - 8usize];
    ["Offset of field: _CRYPT_BIT_BLOB::cUnusedBits"]
        [::std::mem::offset_of!(_CRYPT_BIT_BLOB, cUnusedBits) - 16usize];
};
pub type CRYPT_BIT_BLOB = _CRYPT_BIT_BLOB;
pub type PCRYPT_BIT_BLOB = *mut _CRYPT_BIT_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ALGORITHM_IDENTIFIER {
    pub pszObjId: LPSTR,
    pub Parameters: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ALGORITHM_IDENTIFIER"]
        [::std::mem::size_of::<_CRYPT_ALGORITHM_IDENTIFIER>() - 24usize];
    ["Alignment of _CRYPT_ALGORITHM_IDENTIFIER"]
        [::std::mem::align_of::<_CRYPT_ALGORITHM_IDENTIFIER>() - 8usize];
    ["Offset of field: _CRYPT_ALGORITHM_IDENTIFIER::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_ALGORITHM_IDENTIFIER, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_ALGORITHM_IDENTIFIER::Parameters"]
        [::std::mem::offset_of!(_CRYPT_ALGORITHM_IDENTIFIER, Parameters) - 8usize];
};
pub type CRYPT_ALGORITHM_IDENTIFIER = _CRYPT_ALGORITHM_IDENTIFIER;
pub type PCRYPT_ALGORITHM_IDENTIFIER = *mut _CRYPT_ALGORITHM_IDENTIFIER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_OBJID_TABLE {
    pub dwAlgId: DWORD,
    pub pszObjId: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_OBJID_TABLE"][::std::mem::size_of::<_CRYPT_OBJID_TABLE>() - 16usize];
    ["Alignment of _CRYPT_OBJID_TABLE"][::std::mem::align_of::<_CRYPT_OBJID_TABLE>() - 8usize];
    ["Offset of field: _CRYPT_OBJID_TABLE::dwAlgId"]
        [::std::mem::offset_of!(_CRYPT_OBJID_TABLE, dwAlgId) - 0usize];
    ["Offset of field: _CRYPT_OBJID_TABLE::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_OBJID_TABLE, pszObjId) - 8usize];
};
pub type CRYPT_OBJID_TABLE = _CRYPT_OBJID_TABLE;
pub type PCRYPT_OBJID_TABLE = *mut _CRYPT_OBJID_TABLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_HASH_INFO {
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Hash: CRYPT_HASH_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_HASH_INFO"][::std::mem::size_of::<_CRYPT_HASH_INFO>() - 40usize];
    ["Alignment of _CRYPT_HASH_INFO"][::std::mem::align_of::<_CRYPT_HASH_INFO>() - 8usize];
    ["Offset of field: _CRYPT_HASH_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_HASH_INFO, HashAlgorithm) - 0usize];
    ["Offset of field: _CRYPT_HASH_INFO::Hash"]
        [::std::mem::offset_of!(_CRYPT_HASH_INFO, Hash) - 24usize];
};
pub type CRYPT_HASH_INFO = _CRYPT_HASH_INFO;
pub type PCRYPT_HASH_INFO = *mut _CRYPT_HASH_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_EXTENSION {
    pub pszObjId: LPSTR,
    pub fCritical: BOOL,
    pub Value: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_EXTENSION"][::std::mem::size_of::<_CERT_EXTENSION>() - 32usize];
    ["Alignment of _CERT_EXTENSION"][::std::mem::align_of::<_CERT_EXTENSION>() - 8usize];
    ["Offset of field: _CERT_EXTENSION::pszObjId"]
        [::std::mem::offset_of!(_CERT_EXTENSION, pszObjId) - 0usize];
    ["Offset of field: _CERT_EXTENSION::fCritical"]
        [::std::mem::offset_of!(_CERT_EXTENSION, fCritical) - 8usize];
    ["Offset of field: _CERT_EXTENSION::Value"]
        [::std::mem::offset_of!(_CERT_EXTENSION, Value) - 16usize];
};
pub type CERT_EXTENSION = _CERT_EXTENSION;
pub type PCERT_EXTENSION = *mut _CERT_EXTENSION;
pub type PCCERT_EXTENSION = *const CERT_EXTENSION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ATTRIBUTE_TYPE_VALUE {
    pub pszObjId: LPSTR,
    pub Value: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ATTRIBUTE_TYPE_VALUE"]
        [::std::mem::size_of::<_CRYPT_ATTRIBUTE_TYPE_VALUE>() - 24usize];
    ["Alignment of _CRYPT_ATTRIBUTE_TYPE_VALUE"]
        [::std::mem::align_of::<_CRYPT_ATTRIBUTE_TYPE_VALUE>() - 8usize];
    ["Offset of field: _CRYPT_ATTRIBUTE_TYPE_VALUE::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTE_TYPE_VALUE, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_ATTRIBUTE_TYPE_VALUE::Value"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTE_TYPE_VALUE, Value) - 8usize];
};
pub type CRYPT_ATTRIBUTE_TYPE_VALUE = _CRYPT_ATTRIBUTE_TYPE_VALUE;
pub type PCRYPT_ATTRIBUTE_TYPE_VALUE = *mut _CRYPT_ATTRIBUTE_TYPE_VALUE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ATTRIBUTE {
    pub pszObjId: LPSTR,
    pub cValue: DWORD,
    pub rgValue: PCRYPT_ATTR_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ATTRIBUTE"][::std::mem::size_of::<_CRYPT_ATTRIBUTE>() - 24usize];
    ["Alignment of _CRYPT_ATTRIBUTE"][::std::mem::align_of::<_CRYPT_ATTRIBUTE>() - 8usize];
    ["Offset of field: _CRYPT_ATTRIBUTE::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTE, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_ATTRIBUTE::cValue"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTE, cValue) - 8usize];
    ["Offset of field: _CRYPT_ATTRIBUTE::rgValue"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTE, rgValue) - 16usize];
};
pub type CRYPT_ATTRIBUTE = _CRYPT_ATTRIBUTE;
pub type PCRYPT_ATTRIBUTE = *mut _CRYPT_ATTRIBUTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ATTRIBUTES {
    pub cAttr: DWORD,
    pub rgAttr: PCRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ATTRIBUTES"][::std::mem::size_of::<_CRYPT_ATTRIBUTES>() - 16usize];
    ["Alignment of _CRYPT_ATTRIBUTES"][::std::mem::align_of::<_CRYPT_ATTRIBUTES>() - 8usize];
    ["Offset of field: _CRYPT_ATTRIBUTES::cAttr"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTES, cAttr) - 0usize];
    ["Offset of field: _CRYPT_ATTRIBUTES::rgAttr"]
        [::std::mem::offset_of!(_CRYPT_ATTRIBUTES, rgAttr) - 8usize];
};
pub type CRYPT_ATTRIBUTES = _CRYPT_ATTRIBUTES;
pub type PCRYPT_ATTRIBUTES = *mut _CRYPT_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_RDN_ATTR {
    pub pszObjId: LPSTR,
    pub dwValueType: DWORD,
    pub Value: CERT_RDN_VALUE_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_RDN_ATTR"][::std::mem::size_of::<_CERT_RDN_ATTR>() - 32usize];
    ["Alignment of _CERT_RDN_ATTR"][::std::mem::align_of::<_CERT_RDN_ATTR>() - 8usize];
    ["Offset of field: _CERT_RDN_ATTR::pszObjId"]
        [::std::mem::offset_of!(_CERT_RDN_ATTR, pszObjId) - 0usize];
    ["Offset of field: _CERT_RDN_ATTR::dwValueType"]
        [::std::mem::offset_of!(_CERT_RDN_ATTR, dwValueType) - 8usize];
    ["Offset of field: _CERT_RDN_ATTR::Value"]
        [::std::mem::offset_of!(_CERT_RDN_ATTR, Value) - 16usize];
};
pub type CERT_RDN_ATTR = _CERT_RDN_ATTR;
pub type PCERT_RDN_ATTR = *mut _CERT_RDN_ATTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_RDN {
    pub cRDNAttr: DWORD,
    pub rgRDNAttr: PCERT_RDN_ATTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_RDN"][::std::mem::size_of::<_CERT_RDN>() - 16usize];
    ["Alignment of _CERT_RDN"][::std::mem::align_of::<_CERT_RDN>() - 8usize];
    ["Offset of field: _CERT_RDN::cRDNAttr"][::std::mem::offset_of!(_CERT_RDN, cRDNAttr) - 0usize];
    ["Offset of field: _CERT_RDN::rgRDNAttr"]
        [::std::mem::offset_of!(_CERT_RDN, rgRDNAttr) - 8usize];
};
pub type CERT_RDN = _CERT_RDN;
pub type PCERT_RDN = *mut _CERT_RDN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_NAME_INFO {
    pub cRDN: DWORD,
    pub rgRDN: PCERT_RDN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_NAME_INFO"][::std::mem::size_of::<_CERT_NAME_INFO>() - 16usize];
    ["Alignment of _CERT_NAME_INFO"][::std::mem::align_of::<_CERT_NAME_INFO>() - 8usize];
    ["Offset of field: _CERT_NAME_INFO::cRDN"]
        [::std::mem::offset_of!(_CERT_NAME_INFO, cRDN) - 0usize];
    ["Offset of field: _CERT_NAME_INFO::rgRDN"]
        [::std::mem::offset_of!(_CERT_NAME_INFO, rgRDN) - 8usize];
};
pub type CERT_NAME_INFO = _CERT_NAME_INFO;
pub type PCERT_NAME_INFO = *mut _CERT_NAME_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_NAME_VALUE {
    pub dwValueType: DWORD,
    pub Value: CERT_RDN_VALUE_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_NAME_VALUE"][::std::mem::size_of::<_CERT_NAME_VALUE>() - 24usize];
    ["Alignment of _CERT_NAME_VALUE"][::std::mem::align_of::<_CERT_NAME_VALUE>() - 8usize];
    ["Offset of field: _CERT_NAME_VALUE::dwValueType"]
        [::std::mem::offset_of!(_CERT_NAME_VALUE, dwValueType) - 0usize];
    ["Offset of field: _CERT_NAME_VALUE::Value"]
        [::std::mem::offset_of!(_CERT_NAME_VALUE, Value) - 8usize];
};
pub type CERT_NAME_VALUE = _CERT_NAME_VALUE;
pub type PCERT_NAME_VALUE = *mut _CERT_NAME_VALUE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_PUBLIC_KEY_INFO {
    pub Algorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub PublicKey: CRYPT_BIT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_PUBLIC_KEY_INFO"][::std::mem::size_of::<_CERT_PUBLIC_KEY_INFO>() - 48usize];
    ["Alignment of _CERT_PUBLIC_KEY_INFO"]
        [::std::mem::align_of::<_CERT_PUBLIC_KEY_INFO>() - 8usize];
    ["Offset of field: _CERT_PUBLIC_KEY_INFO::Algorithm"]
        [::std::mem::offset_of!(_CERT_PUBLIC_KEY_INFO, Algorithm) - 0usize];
    ["Offset of field: _CERT_PUBLIC_KEY_INFO::PublicKey"]
        [::std::mem::offset_of!(_CERT_PUBLIC_KEY_INFO, PublicKey) - 24usize];
};
pub type CERT_PUBLIC_KEY_INFO = _CERT_PUBLIC_KEY_INFO;
pub type PCERT_PUBLIC_KEY_INFO = *mut _CERT_PUBLIC_KEY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ECC_PRIVATE_KEY_INFO {
    pub dwVersion: DWORD,
    pub PrivateKey: CRYPT_DER_BLOB,
    pub szCurveOid: LPSTR,
    pub PublicKey: CRYPT_BIT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ECC_PRIVATE_KEY_INFO"]
        [::std::mem::size_of::<_CRYPT_ECC_PRIVATE_KEY_INFO>() - 56usize];
    ["Alignment of _CRYPT_ECC_PRIVATE_KEY_INFO"]
        [::std::mem::align_of::<_CRYPT_ECC_PRIVATE_KEY_INFO>() - 8usize];
    ["Offset of field: _CRYPT_ECC_PRIVATE_KEY_INFO::dwVersion"]
        [::std::mem::offset_of!(_CRYPT_ECC_PRIVATE_KEY_INFO, dwVersion) - 0usize];
    ["Offset of field: _CRYPT_ECC_PRIVATE_KEY_INFO::PrivateKey"]
        [::std::mem::offset_of!(_CRYPT_ECC_PRIVATE_KEY_INFO, PrivateKey) - 8usize];
    ["Offset of field: _CRYPT_ECC_PRIVATE_KEY_INFO::szCurveOid"]
        [::std::mem::offset_of!(_CRYPT_ECC_PRIVATE_KEY_INFO, szCurveOid) - 24usize];
    ["Offset of field: _CRYPT_ECC_PRIVATE_KEY_INFO::PublicKey"]
        [::std::mem::offset_of!(_CRYPT_ECC_PRIVATE_KEY_INFO, PublicKey) - 32usize];
};
pub type CRYPT_ECC_PRIVATE_KEY_INFO = _CRYPT_ECC_PRIVATE_KEY_INFO;
pub type PCRYPT_ECC_PRIVATE_KEY_INFO = *mut _CRYPT_ECC_PRIVATE_KEY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PRIVATE_KEY_INFO {
    pub Version: DWORD,
    pub Algorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub PrivateKey: CRYPT_DER_BLOB,
    pub pAttributes: PCRYPT_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PRIVATE_KEY_INFO"][::std::mem::size_of::<_CRYPT_PRIVATE_KEY_INFO>() - 56usize];
    ["Alignment of _CRYPT_PRIVATE_KEY_INFO"]
        [::std::mem::align_of::<_CRYPT_PRIVATE_KEY_INFO>() - 8usize];
    ["Offset of field: _CRYPT_PRIVATE_KEY_INFO::Version"]
        [::std::mem::offset_of!(_CRYPT_PRIVATE_KEY_INFO, Version) - 0usize];
    ["Offset of field: _CRYPT_PRIVATE_KEY_INFO::Algorithm"]
        [::std::mem::offset_of!(_CRYPT_PRIVATE_KEY_INFO, Algorithm) - 8usize];
    ["Offset of field: _CRYPT_PRIVATE_KEY_INFO::PrivateKey"]
        [::std::mem::offset_of!(_CRYPT_PRIVATE_KEY_INFO, PrivateKey) - 32usize];
    ["Offset of field: _CRYPT_PRIVATE_KEY_INFO::pAttributes"]
        [::std::mem::offset_of!(_CRYPT_PRIVATE_KEY_INFO, pAttributes) - 48usize];
};
pub type CRYPT_PRIVATE_KEY_INFO = _CRYPT_PRIVATE_KEY_INFO;
pub type PCRYPT_PRIVATE_KEY_INFO = *mut _CRYPT_PRIVATE_KEY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO {
    pub EncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedPrivateKey: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO"]
        [::std::mem::size_of::<_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO>() - 40usize];
    ["Alignment of _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO"]
        [::std::mem::align_of::<_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO>() - 8usize];
    ["Offset of field: _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO::EncryptionAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO, EncryptionAlgorithm) - 0usize];
    ["Offset of field: _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO::EncryptedPrivateKey"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPTED_PRIVATE_KEY_INFO, EncryptedPrivateKey) - 24usize];
};
pub type CRYPT_ENCRYPTED_PRIVATE_KEY_INFO = _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO;
pub type PCRYPT_ENCRYPTED_PRIVATE_KEY_INFO = *mut _CRYPT_ENCRYPTED_PRIVATE_KEY_INFO;
pub type PCRYPT_DECRYPT_PRIVATE_KEY_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        Algorithm: CRYPT_ALGORITHM_IDENTIFIER,
        EncryptedPrivateKey: CRYPT_DATA_BLOB,
        pbClearTextKey: *mut BYTE,
        pcbClearTextKey: *mut DWORD,
        pVoidDecryptFunc: LPVOID,
    ) -> BOOL,
>;
pub type PCRYPT_ENCRYPT_PRIVATE_KEY_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        pAlgorithm: *mut CRYPT_ALGORITHM_IDENTIFIER,
        pClearTextPrivateKey: *mut CRYPT_DATA_BLOB,
        pbEncryptedKey: *mut BYTE,
        pcbEncryptedKey: *mut DWORD,
        pVoidEncryptFunc: LPVOID,
    ) -> BOOL,
>;
pub type PCRYPT_RESOLVE_HCRYPTPROV_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        pPrivateKeyInfo: *mut CRYPT_PRIVATE_KEY_INFO,
        phCryptProv: *mut HCRYPTPROV,
        pVoidResolveFunc: LPVOID,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PKCS8_IMPORT_PARAMS {
    pub PrivateKey: CRYPT_DIGEST_BLOB,
    pub pResolvehCryptProvFunc: PCRYPT_RESOLVE_HCRYPTPROV_FUNC,
    pub pVoidResolveFunc: LPVOID,
    pub pDecryptPrivateKeyFunc: PCRYPT_DECRYPT_PRIVATE_KEY_FUNC,
    pub pVoidDecryptFunc: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PKCS8_IMPORT_PARAMS"]
        [::std::mem::size_of::<_CRYPT_PKCS8_IMPORT_PARAMS>() - 48usize];
    ["Alignment of _CRYPT_PKCS8_IMPORT_PARAMS"]
        [::std::mem::align_of::<_CRYPT_PKCS8_IMPORT_PARAMS>() - 8usize];
    ["Offset of field: _CRYPT_PKCS8_IMPORT_PARAMS::PrivateKey"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_IMPORT_PARAMS, PrivateKey) - 0usize];
    ["Offset of field: _CRYPT_PKCS8_IMPORT_PARAMS::pResolvehCryptProvFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_IMPORT_PARAMS, pResolvehCryptProvFunc) - 16usize];
    ["Offset of field: _CRYPT_PKCS8_IMPORT_PARAMS::pVoidResolveFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_IMPORT_PARAMS, pVoidResolveFunc) - 24usize];
    ["Offset of field: _CRYPT_PKCS8_IMPORT_PARAMS::pDecryptPrivateKeyFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_IMPORT_PARAMS, pDecryptPrivateKeyFunc) - 32usize];
    ["Offset of field: _CRYPT_PKCS8_IMPORT_PARAMS::pVoidDecryptFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_IMPORT_PARAMS, pVoidDecryptFunc) - 40usize];
};
pub type CRYPT_PKCS8_IMPORT_PARAMS = _CRYPT_PKCS8_IMPORT_PARAMS;
pub type PCRYPT_PKCS8_IMPORT_PARAMS = *mut _CRYPT_PKCS8_IMPORT_PARAMS;
pub type CRYPT_PRIVATE_KEY_BLOB_AND_PARAMS = _CRYPT_PKCS8_IMPORT_PARAMS;
pub type PCRYPT_PRIVATE_KEY_BLOB_AND_PARAMS = *mut _CRYPT_PKCS8_IMPORT_PARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PKCS8_EXPORT_PARAMS {
    pub hCryptProv: HCRYPTPROV,
    pub dwKeySpec: DWORD,
    pub pszPrivateKeyObjId: LPSTR,
    pub pEncryptPrivateKeyFunc: PCRYPT_ENCRYPT_PRIVATE_KEY_FUNC,
    pub pVoidEncryptFunc: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PKCS8_EXPORT_PARAMS"]
        [::std::mem::size_of::<_CRYPT_PKCS8_EXPORT_PARAMS>() - 40usize];
    ["Alignment of _CRYPT_PKCS8_EXPORT_PARAMS"]
        [::std::mem::align_of::<_CRYPT_PKCS8_EXPORT_PARAMS>() - 8usize];
    ["Offset of field: _CRYPT_PKCS8_EXPORT_PARAMS::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_EXPORT_PARAMS, hCryptProv) - 0usize];
    ["Offset of field: _CRYPT_PKCS8_EXPORT_PARAMS::dwKeySpec"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_EXPORT_PARAMS, dwKeySpec) - 8usize];
    ["Offset of field: _CRYPT_PKCS8_EXPORT_PARAMS::pszPrivateKeyObjId"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_EXPORT_PARAMS, pszPrivateKeyObjId) - 16usize];
    ["Offset of field: _CRYPT_PKCS8_EXPORT_PARAMS::pEncryptPrivateKeyFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_EXPORT_PARAMS, pEncryptPrivateKeyFunc) - 24usize];
    ["Offset of field: _CRYPT_PKCS8_EXPORT_PARAMS::pVoidEncryptFunc"]
        [::std::mem::offset_of!(_CRYPT_PKCS8_EXPORT_PARAMS, pVoidEncryptFunc) - 32usize];
};
pub type CRYPT_PKCS8_EXPORT_PARAMS = _CRYPT_PKCS8_EXPORT_PARAMS;
pub type PCRYPT_PKCS8_EXPORT_PARAMS = *mut _CRYPT_PKCS8_EXPORT_PARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_INFO {
    pub dwVersion: DWORD,
    pub SerialNumber: CRYPT_INTEGER_BLOB,
    pub SignatureAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Issuer: CERT_NAME_BLOB,
    pub NotBefore: FILETIME,
    pub NotAfter: FILETIME,
    pub Subject: CERT_NAME_BLOB,
    pub SubjectPublicKeyInfo: CERT_PUBLIC_KEY_INFO,
    pub IssuerUniqueId: CRYPT_BIT_BLOB,
    pub SubjectUniqueId: CRYPT_BIT_BLOB,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_INFO"][::std::mem::size_of::<_CERT_INFO>() - 208usize];
    ["Alignment of _CERT_INFO"][::std::mem::align_of::<_CERT_INFO>() - 8usize];
    ["Offset of field: _CERT_INFO::dwVersion"]
        [::std::mem::offset_of!(_CERT_INFO, dwVersion) - 0usize];
    ["Offset of field: _CERT_INFO::SerialNumber"]
        [::std::mem::offset_of!(_CERT_INFO, SerialNumber) - 8usize];
    ["Offset of field: _CERT_INFO::SignatureAlgorithm"]
        [::std::mem::offset_of!(_CERT_INFO, SignatureAlgorithm) - 24usize];
    ["Offset of field: _CERT_INFO::Issuer"][::std::mem::offset_of!(_CERT_INFO, Issuer) - 48usize];
    ["Offset of field: _CERT_INFO::NotBefore"]
        [::std::mem::offset_of!(_CERT_INFO, NotBefore) - 64usize];
    ["Offset of field: _CERT_INFO::NotAfter"]
        [::std::mem::offset_of!(_CERT_INFO, NotAfter) - 72usize];
    ["Offset of field: _CERT_INFO::Subject"][::std::mem::offset_of!(_CERT_INFO, Subject) - 80usize];
    ["Offset of field: _CERT_INFO::SubjectPublicKeyInfo"]
        [::std::mem::offset_of!(_CERT_INFO, SubjectPublicKeyInfo) - 96usize];
    ["Offset of field: _CERT_INFO::IssuerUniqueId"]
        [::std::mem::offset_of!(_CERT_INFO, IssuerUniqueId) - 144usize];
    ["Offset of field: _CERT_INFO::SubjectUniqueId"]
        [::std::mem::offset_of!(_CERT_INFO, SubjectUniqueId) - 168usize];
    ["Offset of field: _CERT_INFO::cExtension"]
        [::std::mem::offset_of!(_CERT_INFO, cExtension) - 192usize];
    ["Offset of field: _CERT_INFO::rgExtension"]
        [::std::mem::offset_of!(_CERT_INFO, rgExtension) - 200usize];
};
pub type CERT_INFO = _CERT_INFO;
pub type PCERT_INFO = *mut _CERT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_ENTRY {
    pub SerialNumber: CRYPT_INTEGER_BLOB,
    pub RevocationDate: FILETIME,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_ENTRY"][::std::mem::size_of::<_CRL_ENTRY>() - 40usize];
    ["Alignment of _CRL_ENTRY"][::std::mem::align_of::<_CRL_ENTRY>() - 8usize];
    ["Offset of field: _CRL_ENTRY::SerialNumber"]
        [::std::mem::offset_of!(_CRL_ENTRY, SerialNumber) - 0usize];
    ["Offset of field: _CRL_ENTRY::RevocationDate"]
        [::std::mem::offset_of!(_CRL_ENTRY, RevocationDate) - 16usize];
    ["Offset of field: _CRL_ENTRY::cExtension"]
        [::std::mem::offset_of!(_CRL_ENTRY, cExtension) - 24usize];
    ["Offset of field: _CRL_ENTRY::rgExtension"]
        [::std::mem::offset_of!(_CRL_ENTRY, rgExtension) - 32usize];
};
pub type CRL_ENTRY = _CRL_ENTRY;
pub type PCRL_ENTRY = *mut _CRL_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_INFO {
    pub dwVersion: DWORD,
    pub SignatureAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Issuer: CERT_NAME_BLOB,
    pub ThisUpdate: FILETIME,
    pub NextUpdate: FILETIME,
    pub cCRLEntry: DWORD,
    pub rgCRLEntry: PCRL_ENTRY,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_INFO"][::std::mem::size_of::<_CRL_INFO>() - 96usize];
    ["Alignment of _CRL_INFO"][::std::mem::align_of::<_CRL_INFO>() - 8usize];
    ["Offset of field: _CRL_INFO::dwVersion"]
        [::std::mem::offset_of!(_CRL_INFO, dwVersion) - 0usize];
    ["Offset of field: _CRL_INFO::SignatureAlgorithm"]
        [::std::mem::offset_of!(_CRL_INFO, SignatureAlgorithm) - 8usize];
    ["Offset of field: _CRL_INFO::Issuer"][::std::mem::offset_of!(_CRL_INFO, Issuer) - 32usize];
    ["Offset of field: _CRL_INFO::ThisUpdate"]
        [::std::mem::offset_of!(_CRL_INFO, ThisUpdate) - 48usize];
    ["Offset of field: _CRL_INFO::NextUpdate"]
        [::std::mem::offset_of!(_CRL_INFO, NextUpdate) - 56usize];
    ["Offset of field: _CRL_INFO::cCRLEntry"]
        [::std::mem::offset_of!(_CRL_INFO, cCRLEntry) - 64usize];
    ["Offset of field: _CRL_INFO::rgCRLEntry"]
        [::std::mem::offset_of!(_CRL_INFO, rgCRLEntry) - 72usize];
    ["Offset of field: _CRL_INFO::cExtension"]
        [::std::mem::offset_of!(_CRL_INFO, cExtension) - 80usize];
    ["Offset of field: _CRL_INFO::rgExtension"]
        [::std::mem::offset_of!(_CRL_INFO, rgExtension) - 88usize];
};
pub type CRL_INFO = _CRL_INFO;
pub type PCRL_INFO = *mut _CRL_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_OR_CRL_BLOB {
    pub dwChoice: DWORD,
    pub cbEncoded: DWORD,
    pub pbEncoded: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_OR_CRL_BLOB"][::std::mem::size_of::<_CERT_OR_CRL_BLOB>() - 16usize];
    ["Alignment of _CERT_OR_CRL_BLOB"][::std::mem::align_of::<_CERT_OR_CRL_BLOB>() - 8usize];
    ["Offset of field: _CERT_OR_CRL_BLOB::dwChoice"]
        [::std::mem::offset_of!(_CERT_OR_CRL_BLOB, dwChoice) - 0usize];
    ["Offset of field: _CERT_OR_CRL_BLOB::cbEncoded"]
        [::std::mem::offset_of!(_CERT_OR_CRL_BLOB, cbEncoded) - 4usize];
    ["Offset of field: _CERT_OR_CRL_BLOB::pbEncoded"]
        [::std::mem::offset_of!(_CERT_OR_CRL_BLOB, pbEncoded) - 8usize];
};
pub type CERT_OR_CRL_BLOB = _CERT_OR_CRL_BLOB;
pub type PCERT_OR_CRL_BLOB = *mut _CERT_OR_CRL_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_OR_CRL_BUNDLE {
    pub cItem: DWORD,
    pub rgItem: PCERT_OR_CRL_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_OR_CRL_BUNDLE"][::std::mem::size_of::<_CERT_OR_CRL_BUNDLE>() - 16usize];
    ["Alignment of _CERT_OR_CRL_BUNDLE"][::std::mem::align_of::<_CERT_OR_CRL_BUNDLE>() - 8usize];
    ["Offset of field: _CERT_OR_CRL_BUNDLE::cItem"]
        [::std::mem::offset_of!(_CERT_OR_CRL_BUNDLE, cItem) - 0usize];
    ["Offset of field: _CERT_OR_CRL_BUNDLE::rgItem"]
        [::std::mem::offset_of!(_CERT_OR_CRL_BUNDLE, rgItem) - 8usize];
};
pub type CERT_OR_CRL_BUNDLE = _CERT_OR_CRL_BUNDLE;
pub type PCERT_OR_CRL_BUNDLE = *mut _CERT_OR_CRL_BUNDLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REQUEST_INFO {
    pub dwVersion: DWORD,
    pub Subject: CERT_NAME_BLOB,
    pub SubjectPublicKeyInfo: CERT_PUBLIC_KEY_INFO,
    pub cAttribute: DWORD,
    pub rgAttribute: PCRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REQUEST_INFO"][::std::mem::size_of::<_CERT_REQUEST_INFO>() - 88usize];
    ["Alignment of _CERT_REQUEST_INFO"][::std::mem::align_of::<_CERT_REQUEST_INFO>() - 8usize];
    ["Offset of field: _CERT_REQUEST_INFO::dwVersion"]
        [::std::mem::offset_of!(_CERT_REQUEST_INFO, dwVersion) - 0usize];
    ["Offset of field: _CERT_REQUEST_INFO::Subject"]
        [::std::mem::offset_of!(_CERT_REQUEST_INFO, Subject) - 8usize];
    ["Offset of field: _CERT_REQUEST_INFO::SubjectPublicKeyInfo"]
        [::std::mem::offset_of!(_CERT_REQUEST_INFO, SubjectPublicKeyInfo) - 24usize];
    ["Offset of field: _CERT_REQUEST_INFO::cAttribute"]
        [::std::mem::offset_of!(_CERT_REQUEST_INFO, cAttribute) - 72usize];
    ["Offset of field: _CERT_REQUEST_INFO::rgAttribute"]
        [::std::mem::offset_of!(_CERT_REQUEST_INFO, rgAttribute) - 80usize];
};
pub type CERT_REQUEST_INFO = _CERT_REQUEST_INFO;
pub type PCERT_REQUEST_INFO = *mut _CERT_REQUEST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_KEYGEN_REQUEST_INFO {
    pub dwVersion: DWORD,
    pub SubjectPublicKeyInfo: CERT_PUBLIC_KEY_INFO,
    pub pwszChallengeString: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_KEYGEN_REQUEST_INFO"]
        [::std::mem::size_of::<_CERT_KEYGEN_REQUEST_INFO>() - 64usize];
    ["Alignment of _CERT_KEYGEN_REQUEST_INFO"]
        [::std::mem::align_of::<_CERT_KEYGEN_REQUEST_INFO>() - 8usize];
    ["Offset of field: _CERT_KEYGEN_REQUEST_INFO::dwVersion"]
        [::std::mem::offset_of!(_CERT_KEYGEN_REQUEST_INFO, dwVersion) - 0usize];
    ["Offset of field: _CERT_KEYGEN_REQUEST_INFO::SubjectPublicKeyInfo"]
        [::std::mem::offset_of!(_CERT_KEYGEN_REQUEST_INFO, SubjectPublicKeyInfo) - 8usize];
    ["Offset of field: _CERT_KEYGEN_REQUEST_INFO::pwszChallengeString"]
        [::std::mem::offset_of!(_CERT_KEYGEN_REQUEST_INFO, pwszChallengeString) - 56usize];
};
pub type CERT_KEYGEN_REQUEST_INFO = _CERT_KEYGEN_REQUEST_INFO;
pub type PCERT_KEYGEN_REQUEST_INFO = *mut _CERT_KEYGEN_REQUEST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SIGNED_CONTENT_INFO {
    pub ToBeSigned: CRYPT_DER_BLOB,
    pub SignatureAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Signature: CRYPT_BIT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SIGNED_CONTENT_INFO"]
        [::std::mem::size_of::<_CERT_SIGNED_CONTENT_INFO>() - 64usize];
    ["Alignment of _CERT_SIGNED_CONTENT_INFO"]
        [::std::mem::align_of::<_CERT_SIGNED_CONTENT_INFO>() - 8usize];
    ["Offset of field: _CERT_SIGNED_CONTENT_INFO::ToBeSigned"]
        [::std::mem::offset_of!(_CERT_SIGNED_CONTENT_INFO, ToBeSigned) - 0usize];
    ["Offset of field: _CERT_SIGNED_CONTENT_INFO::SignatureAlgorithm"]
        [::std::mem::offset_of!(_CERT_SIGNED_CONTENT_INFO, SignatureAlgorithm) - 16usize];
    ["Offset of field: _CERT_SIGNED_CONTENT_INFO::Signature"]
        [::std::mem::offset_of!(_CERT_SIGNED_CONTENT_INFO, Signature) - 40usize];
};
pub type CERT_SIGNED_CONTENT_INFO = _CERT_SIGNED_CONTENT_INFO;
pub type PCERT_SIGNED_CONTENT_INFO = *mut _CERT_SIGNED_CONTENT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_USAGE {
    pub cUsageIdentifier: DWORD,
    pub rgpszUsageIdentifier: *mut LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_USAGE"][::std::mem::size_of::<_CTL_USAGE>() - 16usize];
    ["Alignment of _CTL_USAGE"][::std::mem::align_of::<_CTL_USAGE>() - 8usize];
    ["Offset of field: _CTL_USAGE::cUsageIdentifier"]
        [::std::mem::offset_of!(_CTL_USAGE, cUsageIdentifier) - 0usize];
    ["Offset of field: _CTL_USAGE::rgpszUsageIdentifier"]
        [::std::mem::offset_of!(_CTL_USAGE, rgpszUsageIdentifier) - 8usize];
};
pub type CTL_USAGE = _CTL_USAGE;
pub type PCTL_USAGE = *mut _CTL_USAGE;
pub type CERT_ENHKEY_USAGE = _CTL_USAGE;
pub type PCERT_ENHKEY_USAGE = *mut _CTL_USAGE;
pub type PCCTL_USAGE = *const CTL_USAGE;
pub type PCCERT_ENHKEY_USAGE = *const CERT_ENHKEY_USAGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_ENTRY {
    pub SubjectIdentifier: CRYPT_DATA_BLOB,
    pub cAttribute: DWORD,
    pub rgAttribute: PCRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_ENTRY"][::std::mem::size_of::<_CTL_ENTRY>() - 32usize];
    ["Alignment of _CTL_ENTRY"][::std::mem::align_of::<_CTL_ENTRY>() - 8usize];
    ["Offset of field: _CTL_ENTRY::SubjectIdentifier"]
        [::std::mem::offset_of!(_CTL_ENTRY, SubjectIdentifier) - 0usize];
    ["Offset of field: _CTL_ENTRY::cAttribute"]
        [::std::mem::offset_of!(_CTL_ENTRY, cAttribute) - 16usize];
    ["Offset of field: _CTL_ENTRY::rgAttribute"]
        [::std::mem::offset_of!(_CTL_ENTRY, rgAttribute) - 24usize];
};
pub type CTL_ENTRY = _CTL_ENTRY;
pub type PCTL_ENTRY = *mut _CTL_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_INFO {
    pub dwVersion: DWORD,
    pub SubjectUsage: CTL_USAGE,
    pub ListIdentifier: CRYPT_DATA_BLOB,
    pub SequenceNumber: CRYPT_INTEGER_BLOB,
    pub ThisUpdate: FILETIME,
    pub NextUpdate: FILETIME,
    pub SubjectAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub cCTLEntry: DWORD,
    pub rgCTLEntry: PCTL_ENTRY,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_INFO"][::std::mem::size_of::<_CTL_INFO>() - 128usize];
    ["Alignment of _CTL_INFO"][::std::mem::align_of::<_CTL_INFO>() - 8usize];
    ["Offset of field: _CTL_INFO::dwVersion"]
        [::std::mem::offset_of!(_CTL_INFO, dwVersion) - 0usize];
    ["Offset of field: _CTL_INFO::SubjectUsage"]
        [::std::mem::offset_of!(_CTL_INFO, SubjectUsage) - 8usize];
    ["Offset of field: _CTL_INFO::ListIdentifier"]
        [::std::mem::offset_of!(_CTL_INFO, ListIdentifier) - 24usize];
    ["Offset of field: _CTL_INFO::SequenceNumber"]
        [::std::mem::offset_of!(_CTL_INFO, SequenceNumber) - 40usize];
    ["Offset of field: _CTL_INFO::ThisUpdate"]
        [::std::mem::offset_of!(_CTL_INFO, ThisUpdate) - 56usize];
    ["Offset of field: _CTL_INFO::NextUpdate"]
        [::std::mem::offset_of!(_CTL_INFO, NextUpdate) - 64usize];
    ["Offset of field: _CTL_INFO::SubjectAlgorithm"]
        [::std::mem::offset_of!(_CTL_INFO, SubjectAlgorithm) - 72usize];
    ["Offset of field: _CTL_INFO::cCTLEntry"]
        [::std::mem::offset_of!(_CTL_INFO, cCTLEntry) - 96usize];
    ["Offset of field: _CTL_INFO::rgCTLEntry"]
        [::std::mem::offset_of!(_CTL_INFO, rgCTLEntry) - 104usize];
    ["Offset of field: _CTL_INFO::cExtension"]
        [::std::mem::offset_of!(_CTL_INFO, cExtension) - 112usize];
    ["Offset of field: _CTL_INFO::rgExtension"]
        [::std::mem::offset_of!(_CTL_INFO, rgExtension) - 120usize];
};
pub type CTL_INFO = _CTL_INFO;
pub type PCTL_INFO = *mut _CTL_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIME_STAMP_REQUEST_INFO {
    pub pszTimeStampAlgorithm: LPSTR,
    pub pszContentType: LPSTR,
    pub Content: CRYPT_OBJID_BLOB,
    pub cAttribute: DWORD,
    pub rgAttribute: PCRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIME_STAMP_REQUEST_INFO"]
        [::std::mem::size_of::<_CRYPT_TIME_STAMP_REQUEST_INFO>() - 48usize];
    ["Alignment of _CRYPT_TIME_STAMP_REQUEST_INFO"]
        [::std::mem::align_of::<_CRYPT_TIME_STAMP_REQUEST_INFO>() - 8usize];
    ["Offset of field: _CRYPT_TIME_STAMP_REQUEST_INFO::pszTimeStampAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_TIME_STAMP_REQUEST_INFO, pszTimeStampAlgorithm) - 0usize];
    ["Offset of field: _CRYPT_TIME_STAMP_REQUEST_INFO::pszContentType"]
        [::std::mem::offset_of!(_CRYPT_TIME_STAMP_REQUEST_INFO, pszContentType) - 8usize];
    ["Offset of field: _CRYPT_TIME_STAMP_REQUEST_INFO::Content"]
        [::std::mem::offset_of!(_CRYPT_TIME_STAMP_REQUEST_INFO, Content) - 16usize];
    ["Offset of field: _CRYPT_TIME_STAMP_REQUEST_INFO::cAttribute"]
        [::std::mem::offset_of!(_CRYPT_TIME_STAMP_REQUEST_INFO, cAttribute) - 32usize];
    ["Offset of field: _CRYPT_TIME_STAMP_REQUEST_INFO::rgAttribute"]
        [::std::mem::offset_of!(_CRYPT_TIME_STAMP_REQUEST_INFO, rgAttribute) - 40usize];
};
pub type CRYPT_TIME_STAMP_REQUEST_INFO = _CRYPT_TIME_STAMP_REQUEST_INFO;
pub type PCRYPT_TIME_STAMP_REQUEST_INFO = *mut _CRYPT_TIME_STAMP_REQUEST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ENROLLMENT_NAME_VALUE_PAIR {
    pub pwszName: LPWSTR,
    pub pwszValue: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ENROLLMENT_NAME_VALUE_PAIR"]
        [::std::mem::size_of::<_CRYPT_ENROLLMENT_NAME_VALUE_PAIR>() - 16usize];
    ["Alignment of _CRYPT_ENROLLMENT_NAME_VALUE_PAIR"]
        [::std::mem::align_of::<_CRYPT_ENROLLMENT_NAME_VALUE_PAIR>() - 8usize];
    ["Offset of field: _CRYPT_ENROLLMENT_NAME_VALUE_PAIR::pwszName"]
        [::std::mem::offset_of!(_CRYPT_ENROLLMENT_NAME_VALUE_PAIR, pwszName) - 0usize];
    ["Offset of field: _CRYPT_ENROLLMENT_NAME_VALUE_PAIR::pwszValue"]
        [::std::mem::offset_of!(_CRYPT_ENROLLMENT_NAME_VALUE_PAIR, pwszValue) - 8usize];
};
pub type CRYPT_ENROLLMENT_NAME_VALUE_PAIR = _CRYPT_ENROLLMENT_NAME_VALUE_PAIR;
pub type PCRYPT_ENROLLMENT_NAME_VALUE_PAIR = *mut _CRYPT_ENROLLMENT_NAME_VALUE_PAIR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CSP_PROVIDER {
    pub dwKeySpec: DWORD,
    pub pwszProviderName: LPWSTR,
    pub Signature: CRYPT_BIT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CSP_PROVIDER"][::std::mem::size_of::<_CRYPT_CSP_PROVIDER>() - 40usize];
    ["Alignment of _CRYPT_CSP_PROVIDER"][::std::mem::align_of::<_CRYPT_CSP_PROVIDER>() - 8usize];
    ["Offset of field: _CRYPT_CSP_PROVIDER::dwKeySpec"]
        [::std::mem::offset_of!(_CRYPT_CSP_PROVIDER, dwKeySpec) - 0usize];
    ["Offset of field: _CRYPT_CSP_PROVIDER::pwszProviderName"]
        [::std::mem::offset_of!(_CRYPT_CSP_PROVIDER, pwszProviderName) - 8usize];
    ["Offset of field: _CRYPT_CSP_PROVIDER::Signature"]
        [::std::mem::offset_of!(_CRYPT_CSP_PROVIDER, Signature) - 16usize];
};
pub type CRYPT_CSP_PROVIDER = _CRYPT_CSP_PROVIDER;
pub type PCRYPT_CSP_PROVIDER = *mut _CRYPT_CSP_PROVIDER;
unsafe extern "C" {
    pub fn CryptFormatObject(
        dwCertEncodingType: DWORD,
        dwFormatType: DWORD,
        dwFormatStrType: DWORD,
        pFormatStruct: *mut ::std::os::raw::c_void,
        lpszStructType: LPCSTR,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        pbFormat: *mut ::std::os::raw::c_void,
        pcbFormat: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CRYPT_ALLOC = ::std::option::Option<unsafe extern "C" fn(cbSize: usize) -> LPVOID>;
pub type PFN_CRYPT_FREE = ::std::option::Option<unsafe extern "C" fn(pv: LPVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ENCODE_PARA {
    pub cbSize: DWORD,
    pub pfnAlloc: PFN_CRYPT_ALLOC,
    pub pfnFree: PFN_CRYPT_FREE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ENCODE_PARA"][::std::mem::size_of::<_CRYPT_ENCODE_PARA>() - 24usize];
    ["Alignment of _CRYPT_ENCODE_PARA"][::std::mem::align_of::<_CRYPT_ENCODE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_ENCODE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_ENCODE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_ENCODE_PARA::pfnAlloc"]
        [::std::mem::offset_of!(_CRYPT_ENCODE_PARA, pfnAlloc) - 8usize];
    ["Offset of field: _CRYPT_ENCODE_PARA::pfnFree"]
        [::std::mem::offset_of!(_CRYPT_ENCODE_PARA, pfnFree) - 16usize];
};
pub type CRYPT_ENCODE_PARA = _CRYPT_ENCODE_PARA;
pub type PCRYPT_ENCODE_PARA = *mut _CRYPT_ENCODE_PARA;
unsafe extern "C" {
    pub fn CryptEncodeObjectEx(
        dwCertEncodingType: DWORD,
        lpszStructType: LPCSTR,
        pvStructInfo: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pEncodePara: PCRYPT_ENCODE_PARA,
        pvEncoded: *mut ::std::os::raw::c_void,
        pcbEncoded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEncodeObject(
        dwCertEncodingType: DWORD,
        lpszStructType: LPCSTR,
        pvStructInfo: *const ::std::os::raw::c_void,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_DECODE_PARA {
    pub cbSize: DWORD,
    pub pfnAlloc: PFN_CRYPT_ALLOC,
    pub pfnFree: PFN_CRYPT_FREE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_DECODE_PARA"][::std::mem::size_of::<_CRYPT_DECODE_PARA>() - 24usize];
    ["Alignment of _CRYPT_DECODE_PARA"][::std::mem::align_of::<_CRYPT_DECODE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_DECODE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_DECODE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_DECODE_PARA::pfnAlloc"]
        [::std::mem::offset_of!(_CRYPT_DECODE_PARA, pfnAlloc) - 8usize];
    ["Offset of field: _CRYPT_DECODE_PARA::pfnFree"]
        [::std::mem::offset_of!(_CRYPT_DECODE_PARA, pfnFree) - 16usize];
};
pub type CRYPT_DECODE_PARA = _CRYPT_DECODE_PARA;
pub type PCRYPT_DECODE_PARA = *mut _CRYPT_DECODE_PARA;
unsafe extern "C" {
    pub fn CryptDecodeObjectEx(
        dwCertEncodingType: DWORD,
        lpszStructType: LPCSTR,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        dwFlags: DWORD,
        pDecodePara: PCRYPT_DECODE_PARA,
        pvStructInfo: *mut ::std::os::raw::c_void,
        pcbStructInfo: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDecodeObject(
        dwCertEncodingType: DWORD,
        lpszStructType: LPCSTR,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        dwFlags: DWORD,
        pvStructInfo: *mut ::std::os::raw::c_void,
        pcbStructInfo: *mut DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_EXTENSIONS {
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_EXTENSIONS"][::std::mem::size_of::<_CERT_EXTENSIONS>() - 16usize];
    ["Alignment of _CERT_EXTENSIONS"][::std::mem::align_of::<_CERT_EXTENSIONS>() - 8usize];
    ["Offset of field: _CERT_EXTENSIONS::cExtension"]
        [::std::mem::offset_of!(_CERT_EXTENSIONS, cExtension) - 0usize];
    ["Offset of field: _CERT_EXTENSIONS::rgExtension"]
        [::std::mem::offset_of!(_CERT_EXTENSIONS, rgExtension) - 8usize];
};
pub type CERT_EXTENSIONS = _CERT_EXTENSIONS;
pub type PCERT_EXTENSIONS = *mut _CERT_EXTENSIONS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_AUTHORITY_KEY_ID_INFO {
    pub KeyId: CRYPT_DATA_BLOB,
    pub CertIssuer: CERT_NAME_BLOB,
    pub CertSerialNumber: CRYPT_INTEGER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_AUTHORITY_KEY_ID_INFO"]
        [::std::mem::size_of::<_CERT_AUTHORITY_KEY_ID_INFO>() - 48usize];
    ["Alignment of _CERT_AUTHORITY_KEY_ID_INFO"]
        [::std::mem::align_of::<_CERT_AUTHORITY_KEY_ID_INFO>() - 8usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID_INFO::KeyId"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID_INFO, KeyId) - 0usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID_INFO::CertIssuer"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID_INFO, CertIssuer) - 16usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID_INFO::CertSerialNumber"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID_INFO, CertSerialNumber) - 32usize];
};
pub type CERT_AUTHORITY_KEY_ID_INFO = _CERT_AUTHORITY_KEY_ID_INFO;
pub type PCERT_AUTHORITY_KEY_ID_INFO = *mut _CERT_AUTHORITY_KEY_ID_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_PRIVATE_KEY_VALIDITY {
    pub NotBefore: FILETIME,
    pub NotAfter: FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_PRIVATE_KEY_VALIDITY"]
        [::std::mem::size_of::<_CERT_PRIVATE_KEY_VALIDITY>() - 16usize];
    ["Alignment of _CERT_PRIVATE_KEY_VALIDITY"]
        [::std::mem::align_of::<_CERT_PRIVATE_KEY_VALIDITY>() - 4usize];
    ["Offset of field: _CERT_PRIVATE_KEY_VALIDITY::NotBefore"]
        [::std::mem::offset_of!(_CERT_PRIVATE_KEY_VALIDITY, NotBefore) - 0usize];
    ["Offset of field: _CERT_PRIVATE_KEY_VALIDITY::NotAfter"]
        [::std::mem::offset_of!(_CERT_PRIVATE_KEY_VALIDITY, NotAfter) - 8usize];
};
pub type CERT_PRIVATE_KEY_VALIDITY = _CERT_PRIVATE_KEY_VALIDITY;
pub type PCERT_PRIVATE_KEY_VALIDITY = *mut _CERT_PRIVATE_KEY_VALIDITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_KEY_ATTRIBUTES_INFO {
    pub KeyId: CRYPT_DATA_BLOB,
    pub IntendedKeyUsage: CRYPT_BIT_BLOB,
    pub pPrivateKeyUsagePeriod: PCERT_PRIVATE_KEY_VALIDITY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_KEY_ATTRIBUTES_INFO"]
        [::std::mem::size_of::<_CERT_KEY_ATTRIBUTES_INFO>() - 48usize];
    ["Alignment of _CERT_KEY_ATTRIBUTES_INFO"]
        [::std::mem::align_of::<_CERT_KEY_ATTRIBUTES_INFO>() - 8usize];
    ["Offset of field: _CERT_KEY_ATTRIBUTES_INFO::KeyId"]
        [::std::mem::offset_of!(_CERT_KEY_ATTRIBUTES_INFO, KeyId) - 0usize];
    ["Offset of field: _CERT_KEY_ATTRIBUTES_INFO::IntendedKeyUsage"]
        [::std::mem::offset_of!(_CERT_KEY_ATTRIBUTES_INFO, IntendedKeyUsage) - 16usize];
    ["Offset of field: _CERT_KEY_ATTRIBUTES_INFO::pPrivateKeyUsagePeriod"]
        [::std::mem::offset_of!(_CERT_KEY_ATTRIBUTES_INFO, pPrivateKeyUsagePeriod) - 40usize];
};
pub type CERT_KEY_ATTRIBUTES_INFO = _CERT_KEY_ATTRIBUTES_INFO;
pub type PCERT_KEY_ATTRIBUTES_INFO = *mut _CERT_KEY_ATTRIBUTES_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_ID {
    pub cCertPolicyElementId: DWORD,
    pub rgpszCertPolicyElementId: *mut LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_ID"][::std::mem::size_of::<_CERT_POLICY_ID>() - 16usize];
    ["Alignment of _CERT_POLICY_ID"][::std::mem::align_of::<_CERT_POLICY_ID>() - 8usize];
    ["Offset of field: _CERT_POLICY_ID::cCertPolicyElementId"]
        [::std::mem::offset_of!(_CERT_POLICY_ID, cCertPolicyElementId) - 0usize];
    ["Offset of field: _CERT_POLICY_ID::rgpszCertPolicyElementId"]
        [::std::mem::offset_of!(_CERT_POLICY_ID, rgpszCertPolicyElementId) - 8usize];
};
pub type CERT_POLICY_ID = _CERT_POLICY_ID;
pub type PCERT_POLICY_ID = *mut _CERT_POLICY_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_KEY_USAGE_RESTRICTION_INFO {
    pub cCertPolicyId: DWORD,
    pub rgCertPolicyId: PCERT_POLICY_ID,
    pub RestrictedKeyUsage: CRYPT_BIT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_KEY_USAGE_RESTRICTION_INFO"]
        [::std::mem::size_of::<_CERT_KEY_USAGE_RESTRICTION_INFO>() - 40usize];
    ["Alignment of _CERT_KEY_USAGE_RESTRICTION_INFO"]
        [::std::mem::align_of::<_CERT_KEY_USAGE_RESTRICTION_INFO>() - 8usize];
    ["Offset of field: _CERT_KEY_USAGE_RESTRICTION_INFO::cCertPolicyId"]
        [::std::mem::offset_of!(_CERT_KEY_USAGE_RESTRICTION_INFO, cCertPolicyId) - 0usize];
    ["Offset of field: _CERT_KEY_USAGE_RESTRICTION_INFO::rgCertPolicyId"]
        [::std::mem::offset_of!(_CERT_KEY_USAGE_RESTRICTION_INFO, rgCertPolicyId) - 8usize];
    ["Offset of field: _CERT_KEY_USAGE_RESTRICTION_INFO::RestrictedKeyUsage"]
        [::std::mem::offset_of!(_CERT_KEY_USAGE_RESTRICTION_INFO, RestrictedKeyUsage) - 16usize];
};
pub type CERT_KEY_USAGE_RESTRICTION_INFO = _CERT_KEY_USAGE_RESTRICTION_INFO;
pub type PCERT_KEY_USAGE_RESTRICTION_INFO = *mut _CERT_KEY_USAGE_RESTRICTION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_OTHER_NAME {
    pub pszObjId: LPSTR,
    pub Value: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_OTHER_NAME"][::std::mem::size_of::<_CERT_OTHER_NAME>() - 24usize];
    ["Alignment of _CERT_OTHER_NAME"][::std::mem::align_of::<_CERT_OTHER_NAME>() - 8usize];
    ["Offset of field: _CERT_OTHER_NAME::pszObjId"]
        [::std::mem::offset_of!(_CERT_OTHER_NAME, pszObjId) - 0usize];
    ["Offset of field: _CERT_OTHER_NAME::Value"]
        [::std::mem::offset_of!(_CERT_OTHER_NAME, Value) - 8usize];
};
pub type CERT_OTHER_NAME = _CERT_OTHER_NAME;
pub type PCERT_OTHER_NAME = *mut _CERT_OTHER_NAME;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_ALT_NAME_ENTRY {
    pub dwAltNameChoice: DWORD,
    pub __bindgen_anon_1: _CERT_ALT_NAME_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_ALT_NAME_ENTRY__bindgen_ty_1 {
    pub pOtherName: PCERT_OTHER_NAME,
    pub pwszRfc822Name: LPWSTR,
    pub pwszDNSName: LPWSTR,
    pub DirectoryName: CERT_NAME_BLOB,
    pub pwszURL: LPWSTR,
    pub IPAddress: CRYPT_DATA_BLOB,
    pub pszRegisteredID: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ALT_NAME_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_ALT_NAME_ENTRY__bindgen_ty_1>() - 16usize];
    ["Alignment of _CERT_ALT_NAME_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_ALT_NAME_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::pOtherName"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, pOtherName) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::pwszRfc822Name"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, pwszRfc822Name) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::pwszDNSName"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, pwszDNSName) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::DirectoryName"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, DirectoryName) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::pwszURL"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, pwszURL) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::IPAddress"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, IPAddress) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY__bindgen_ty_1::pszRegisteredID"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY__bindgen_ty_1, pszRegisteredID) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ALT_NAME_ENTRY"][::std::mem::size_of::<_CERT_ALT_NAME_ENTRY>() - 24usize];
    ["Alignment of _CERT_ALT_NAME_ENTRY"][::std::mem::align_of::<_CERT_ALT_NAME_ENTRY>() - 8usize];
    ["Offset of field: _CERT_ALT_NAME_ENTRY::dwAltNameChoice"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_ENTRY, dwAltNameChoice) - 0usize];
};
pub type CERT_ALT_NAME_ENTRY = _CERT_ALT_NAME_ENTRY;
pub type PCERT_ALT_NAME_ENTRY = *mut _CERT_ALT_NAME_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_ALT_NAME_INFO {
    pub cAltEntry: DWORD,
    pub rgAltEntry: PCERT_ALT_NAME_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ALT_NAME_INFO"][::std::mem::size_of::<_CERT_ALT_NAME_INFO>() - 16usize];
    ["Alignment of _CERT_ALT_NAME_INFO"][::std::mem::align_of::<_CERT_ALT_NAME_INFO>() - 8usize];
    ["Offset of field: _CERT_ALT_NAME_INFO::cAltEntry"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_INFO, cAltEntry) - 0usize];
    ["Offset of field: _CERT_ALT_NAME_INFO::rgAltEntry"]
        [::std::mem::offset_of!(_CERT_ALT_NAME_INFO, rgAltEntry) - 8usize];
};
pub type CERT_ALT_NAME_INFO = _CERT_ALT_NAME_INFO;
pub type PCERT_ALT_NAME_INFO = *mut _CERT_ALT_NAME_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_BASIC_CONSTRAINTS_INFO {
    pub SubjectType: CRYPT_BIT_BLOB,
    pub fPathLenConstraint: BOOL,
    pub dwPathLenConstraint: DWORD,
    pub cSubtreesConstraint: DWORD,
    pub rgSubtreesConstraint: *mut CERT_NAME_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_BASIC_CONSTRAINTS_INFO"]
        [::std::mem::size_of::<_CERT_BASIC_CONSTRAINTS_INFO>() - 48usize];
    ["Alignment of _CERT_BASIC_CONSTRAINTS_INFO"]
        [::std::mem::align_of::<_CERT_BASIC_CONSTRAINTS_INFO>() - 8usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS_INFO::SubjectType"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS_INFO, SubjectType) - 0usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS_INFO::fPathLenConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS_INFO, fPathLenConstraint) - 24usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS_INFO::dwPathLenConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS_INFO, dwPathLenConstraint) - 28usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS_INFO::cSubtreesConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS_INFO, cSubtreesConstraint) - 32usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS_INFO::rgSubtreesConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS_INFO, rgSubtreesConstraint) - 40usize];
};
pub type CERT_BASIC_CONSTRAINTS_INFO = _CERT_BASIC_CONSTRAINTS_INFO;
pub type PCERT_BASIC_CONSTRAINTS_INFO = *mut _CERT_BASIC_CONSTRAINTS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_BASIC_CONSTRAINTS2_INFO {
    pub fCA: BOOL,
    pub fPathLenConstraint: BOOL,
    pub dwPathLenConstraint: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_BASIC_CONSTRAINTS2_INFO"]
        [::std::mem::size_of::<_CERT_BASIC_CONSTRAINTS2_INFO>() - 12usize];
    ["Alignment of _CERT_BASIC_CONSTRAINTS2_INFO"]
        [::std::mem::align_of::<_CERT_BASIC_CONSTRAINTS2_INFO>() - 4usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS2_INFO::fCA"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS2_INFO, fCA) - 0usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS2_INFO::fPathLenConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS2_INFO, fPathLenConstraint) - 4usize];
    ["Offset of field: _CERT_BASIC_CONSTRAINTS2_INFO::dwPathLenConstraint"]
        [::std::mem::offset_of!(_CERT_BASIC_CONSTRAINTS2_INFO, dwPathLenConstraint) - 8usize];
};
pub type CERT_BASIC_CONSTRAINTS2_INFO = _CERT_BASIC_CONSTRAINTS2_INFO;
pub type PCERT_BASIC_CONSTRAINTS2_INFO = *mut _CERT_BASIC_CONSTRAINTS2_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_QUALIFIER_INFO {
    pub pszPolicyQualifierId: LPSTR,
    pub Qualifier: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_QUALIFIER_INFO"]
        [::std::mem::size_of::<_CERT_POLICY_QUALIFIER_INFO>() - 24usize];
    ["Alignment of _CERT_POLICY_QUALIFIER_INFO"]
        [::std::mem::align_of::<_CERT_POLICY_QUALIFIER_INFO>() - 8usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_INFO::pszPolicyQualifierId"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_INFO, pszPolicyQualifierId) - 0usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_INFO::Qualifier"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_INFO, Qualifier) - 8usize];
};
pub type CERT_POLICY_QUALIFIER_INFO = _CERT_POLICY_QUALIFIER_INFO;
pub type PCERT_POLICY_QUALIFIER_INFO = *mut _CERT_POLICY_QUALIFIER_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_INFO {
    pub pszPolicyIdentifier: LPSTR,
    pub cPolicyQualifier: DWORD,
    pub rgPolicyQualifier: *mut CERT_POLICY_QUALIFIER_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_INFO"][::std::mem::size_of::<_CERT_POLICY_INFO>() - 24usize];
    ["Alignment of _CERT_POLICY_INFO"][::std::mem::align_of::<_CERT_POLICY_INFO>() - 8usize];
    ["Offset of field: _CERT_POLICY_INFO::pszPolicyIdentifier"]
        [::std::mem::offset_of!(_CERT_POLICY_INFO, pszPolicyIdentifier) - 0usize];
    ["Offset of field: _CERT_POLICY_INFO::cPolicyQualifier"]
        [::std::mem::offset_of!(_CERT_POLICY_INFO, cPolicyQualifier) - 8usize];
    ["Offset of field: _CERT_POLICY_INFO::rgPolicyQualifier"]
        [::std::mem::offset_of!(_CERT_POLICY_INFO, rgPolicyQualifier) - 16usize];
};
pub type CERT_POLICY_INFO = _CERT_POLICY_INFO;
pub type PCERT_POLICY_INFO = *mut _CERT_POLICY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICIES_INFO {
    pub cPolicyInfo: DWORD,
    pub rgPolicyInfo: *mut CERT_POLICY_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICIES_INFO"][::std::mem::size_of::<_CERT_POLICIES_INFO>() - 16usize];
    ["Alignment of _CERT_POLICIES_INFO"][::std::mem::align_of::<_CERT_POLICIES_INFO>() - 8usize];
    ["Offset of field: _CERT_POLICIES_INFO::cPolicyInfo"]
        [::std::mem::offset_of!(_CERT_POLICIES_INFO, cPolicyInfo) - 0usize];
    ["Offset of field: _CERT_POLICIES_INFO::rgPolicyInfo"]
        [::std::mem::offset_of!(_CERT_POLICIES_INFO, rgPolicyInfo) - 8usize];
};
pub type CERT_POLICIES_INFO = _CERT_POLICIES_INFO;
pub type PCERT_POLICIES_INFO = *mut _CERT_POLICIES_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE {
    pub pszOrganization: LPSTR,
    pub cNoticeNumbers: DWORD,
    pub rgNoticeNumbers: *mut ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE"]
        [::std::mem::size_of::<_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE>() - 24usize];
    ["Alignment of _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE"]
        [::std::mem::align_of::<_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE>() - 8usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE::pszOrganization"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE, pszOrganization) - 0usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE::cNoticeNumbers"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_NOTICE_REFERENCE, cNoticeNumbers) - 8usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE::rgNoticeNumbers"][::std::mem::offset_of!(
        _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE,
        rgNoticeNumbers
    ) - 16usize];
};
pub type CERT_POLICY_QUALIFIER_NOTICE_REFERENCE = _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE;
pub type PCERT_POLICY_QUALIFIER_NOTICE_REFERENCE = *mut _CERT_POLICY_QUALIFIER_NOTICE_REFERENCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_QUALIFIER_USER_NOTICE {
    pub pNoticeReference: *mut CERT_POLICY_QUALIFIER_NOTICE_REFERENCE,
    pub pszDisplayText: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_QUALIFIER_USER_NOTICE"]
        [::std::mem::size_of::<_CERT_POLICY_QUALIFIER_USER_NOTICE>() - 16usize];
    ["Alignment of _CERT_POLICY_QUALIFIER_USER_NOTICE"]
        [::std::mem::align_of::<_CERT_POLICY_QUALIFIER_USER_NOTICE>() - 8usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_USER_NOTICE::pNoticeReference"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_USER_NOTICE, pNoticeReference) - 0usize];
    ["Offset of field: _CERT_POLICY_QUALIFIER_USER_NOTICE::pszDisplayText"]
        [::std::mem::offset_of!(_CERT_POLICY_QUALIFIER_USER_NOTICE, pszDisplayText) - 8usize];
};
pub type CERT_POLICY_QUALIFIER_USER_NOTICE = _CERT_POLICY_QUALIFIER_USER_NOTICE;
pub type PCERT_POLICY_QUALIFIER_USER_NOTICE = *mut _CERT_POLICY_QUALIFIER_USER_NOTICE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CPS_URLS {
    pub pszURL: LPWSTR,
    pub pAlgorithm: *mut CRYPT_ALGORITHM_IDENTIFIER,
    pub pDigest: *mut CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CPS_URLS"][::std::mem::size_of::<_CPS_URLS>() - 24usize];
    ["Alignment of _CPS_URLS"][::std::mem::align_of::<_CPS_URLS>() - 8usize];
    ["Offset of field: _CPS_URLS::pszURL"][::std::mem::offset_of!(_CPS_URLS, pszURL) - 0usize];
    ["Offset of field: _CPS_URLS::pAlgorithm"]
        [::std::mem::offset_of!(_CPS_URLS, pAlgorithm) - 8usize];
    ["Offset of field: _CPS_URLS::pDigest"][::std::mem::offset_of!(_CPS_URLS, pDigest) - 16usize];
};
pub type CPS_URLS = _CPS_URLS;
pub type PCPS_URLS = *mut _CPS_URLS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY95_QUALIFIER1 {
    pub pszPracticesReference: LPWSTR,
    pub pszNoticeIdentifier: LPSTR,
    pub pszNSINoticeIdentifier: LPSTR,
    pub cCPSURLs: DWORD,
    pub rgCPSURLs: *mut CPS_URLS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY95_QUALIFIER1"]
        [::std::mem::size_of::<_CERT_POLICY95_QUALIFIER1>() - 40usize];
    ["Alignment of _CERT_POLICY95_QUALIFIER1"]
        [::std::mem::align_of::<_CERT_POLICY95_QUALIFIER1>() - 8usize];
    ["Offset of field: _CERT_POLICY95_QUALIFIER1::pszPracticesReference"]
        [::std::mem::offset_of!(_CERT_POLICY95_QUALIFIER1, pszPracticesReference) - 0usize];
    ["Offset of field: _CERT_POLICY95_QUALIFIER1::pszNoticeIdentifier"]
        [::std::mem::offset_of!(_CERT_POLICY95_QUALIFIER1, pszNoticeIdentifier) - 8usize];
    ["Offset of field: _CERT_POLICY95_QUALIFIER1::pszNSINoticeIdentifier"]
        [::std::mem::offset_of!(_CERT_POLICY95_QUALIFIER1, pszNSINoticeIdentifier) - 16usize];
    ["Offset of field: _CERT_POLICY95_QUALIFIER1::cCPSURLs"]
        [::std::mem::offset_of!(_CERT_POLICY95_QUALIFIER1, cCPSURLs) - 24usize];
    ["Offset of field: _CERT_POLICY95_QUALIFIER1::rgCPSURLs"]
        [::std::mem::offset_of!(_CERT_POLICY95_QUALIFIER1, rgCPSURLs) - 32usize];
};
pub type CERT_POLICY95_QUALIFIER1 = _CERT_POLICY95_QUALIFIER1;
pub type PCERT_POLICY95_QUALIFIER1 = *mut _CERT_POLICY95_QUALIFIER1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_MAPPING {
    pub pszIssuerDomainPolicy: LPSTR,
    pub pszSubjectDomainPolicy: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_MAPPING"][::std::mem::size_of::<_CERT_POLICY_MAPPING>() - 16usize];
    ["Alignment of _CERT_POLICY_MAPPING"][::std::mem::align_of::<_CERT_POLICY_MAPPING>() - 8usize];
    ["Offset of field: _CERT_POLICY_MAPPING::pszIssuerDomainPolicy"]
        [::std::mem::offset_of!(_CERT_POLICY_MAPPING, pszIssuerDomainPolicy) - 0usize];
    ["Offset of field: _CERT_POLICY_MAPPING::pszSubjectDomainPolicy"]
        [::std::mem::offset_of!(_CERT_POLICY_MAPPING, pszSubjectDomainPolicy) - 8usize];
};
pub type CERT_POLICY_MAPPING = _CERT_POLICY_MAPPING;
pub type PCERT_POLICY_MAPPING = *mut _CERT_POLICY_MAPPING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_MAPPINGS_INFO {
    pub cPolicyMapping: DWORD,
    pub rgPolicyMapping: PCERT_POLICY_MAPPING,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_MAPPINGS_INFO"]
        [::std::mem::size_of::<_CERT_POLICY_MAPPINGS_INFO>() - 16usize];
    ["Alignment of _CERT_POLICY_MAPPINGS_INFO"]
        [::std::mem::align_of::<_CERT_POLICY_MAPPINGS_INFO>() - 8usize];
    ["Offset of field: _CERT_POLICY_MAPPINGS_INFO::cPolicyMapping"]
        [::std::mem::offset_of!(_CERT_POLICY_MAPPINGS_INFO, cPolicyMapping) - 0usize];
    ["Offset of field: _CERT_POLICY_MAPPINGS_INFO::rgPolicyMapping"]
        [::std::mem::offset_of!(_CERT_POLICY_MAPPINGS_INFO, rgPolicyMapping) - 8usize];
};
pub type CERT_POLICY_MAPPINGS_INFO = _CERT_POLICY_MAPPINGS_INFO;
pub type PCERT_POLICY_MAPPINGS_INFO = *mut _CERT_POLICY_MAPPINGS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_POLICY_CONSTRAINTS_INFO {
    pub fRequireExplicitPolicy: BOOL,
    pub dwRequireExplicitPolicySkipCerts: DWORD,
    pub fInhibitPolicyMapping: BOOL,
    pub dwInhibitPolicyMappingSkipCerts: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_POLICY_CONSTRAINTS_INFO"]
        [::std::mem::size_of::<_CERT_POLICY_CONSTRAINTS_INFO>() - 16usize];
    ["Alignment of _CERT_POLICY_CONSTRAINTS_INFO"]
        [::std::mem::align_of::<_CERT_POLICY_CONSTRAINTS_INFO>() - 4usize];
    ["Offset of field: _CERT_POLICY_CONSTRAINTS_INFO::fRequireExplicitPolicy"]
        [::std::mem::offset_of!(_CERT_POLICY_CONSTRAINTS_INFO, fRequireExplicitPolicy) - 0usize];
    ["Offset of field: _CERT_POLICY_CONSTRAINTS_INFO::dwRequireExplicitPolicySkipCerts"][::std::mem::offset_of!(
        _CERT_POLICY_CONSTRAINTS_INFO,
        dwRequireExplicitPolicySkipCerts
    )
        - 4usize];
    ["Offset of field: _CERT_POLICY_CONSTRAINTS_INFO::fInhibitPolicyMapping"]
        [::std::mem::offset_of!(_CERT_POLICY_CONSTRAINTS_INFO, fInhibitPolicyMapping) - 8usize];
    ["Offset of field: _CERT_POLICY_CONSTRAINTS_INFO::dwInhibitPolicyMappingSkipCerts"][::std::mem::offset_of!(
        _CERT_POLICY_CONSTRAINTS_INFO,
        dwInhibitPolicyMappingSkipCerts
    )
        - 12usize];
};
pub type CERT_POLICY_CONSTRAINTS_INFO = _CERT_POLICY_CONSTRAINTS_INFO;
pub type PCERT_POLICY_CONSTRAINTS_INFO = *mut _CERT_POLICY_CONSTRAINTS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY {
    pub pszObjId: LPSTR,
    pub cValue: DWORD,
    pub rgValue: PCRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY"]
        [::std::mem::size_of::<_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY>() - 24usize];
    ["Alignment of _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY"]
        [::std::mem::align_of::<_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY>() - 8usize];
    ["Offset of field: _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY::cValue"]
        [::std::mem::offset_of!(_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY, cValue) - 8usize];
    ["Offset of field: _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY::rgValue"]
        [::std::mem::offset_of!(_CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY, rgValue) - 16usize];
};
pub type CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY = _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY;
pub type PCRYPT_CONTENT_INFO_SEQUENCE_OF_ANY = *mut _CRYPT_CONTENT_INFO_SEQUENCE_OF_ANY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CONTENT_INFO {
    pub pszObjId: LPSTR,
    pub Content: CRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CONTENT_INFO"][::std::mem::size_of::<_CRYPT_CONTENT_INFO>() - 24usize];
    ["Alignment of _CRYPT_CONTENT_INFO"][::std::mem::align_of::<_CRYPT_CONTENT_INFO>() - 8usize];
    ["Offset of field: _CRYPT_CONTENT_INFO::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_CONTENT_INFO, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_CONTENT_INFO::Content"]
        [::std::mem::offset_of!(_CRYPT_CONTENT_INFO, Content) - 8usize];
};
pub type CRYPT_CONTENT_INFO = _CRYPT_CONTENT_INFO;
pub type PCRYPT_CONTENT_INFO = *mut _CRYPT_CONTENT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_SEQUENCE_OF_ANY {
    pub cValue: DWORD,
    pub rgValue: PCRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_SEQUENCE_OF_ANY"][::std::mem::size_of::<_CRYPT_SEQUENCE_OF_ANY>() - 16usize];
    ["Alignment of _CRYPT_SEQUENCE_OF_ANY"]
        [::std::mem::align_of::<_CRYPT_SEQUENCE_OF_ANY>() - 8usize];
    ["Offset of field: _CRYPT_SEQUENCE_OF_ANY::cValue"]
        [::std::mem::offset_of!(_CRYPT_SEQUENCE_OF_ANY, cValue) - 0usize];
    ["Offset of field: _CRYPT_SEQUENCE_OF_ANY::rgValue"]
        [::std::mem::offset_of!(_CRYPT_SEQUENCE_OF_ANY, rgValue) - 8usize];
};
pub type CRYPT_SEQUENCE_OF_ANY = _CRYPT_SEQUENCE_OF_ANY;
pub type PCRYPT_SEQUENCE_OF_ANY = *mut _CRYPT_SEQUENCE_OF_ANY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_AUTHORITY_KEY_ID2_INFO {
    pub KeyId: CRYPT_DATA_BLOB,
    pub AuthorityCertIssuer: CERT_ALT_NAME_INFO,
    pub AuthorityCertSerialNumber: CRYPT_INTEGER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_AUTHORITY_KEY_ID2_INFO"]
        [::std::mem::size_of::<_CERT_AUTHORITY_KEY_ID2_INFO>() - 48usize];
    ["Alignment of _CERT_AUTHORITY_KEY_ID2_INFO"]
        [::std::mem::align_of::<_CERT_AUTHORITY_KEY_ID2_INFO>() - 8usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID2_INFO::KeyId"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID2_INFO, KeyId) - 0usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID2_INFO::AuthorityCertIssuer"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID2_INFO, AuthorityCertIssuer) - 16usize];
    ["Offset of field: _CERT_AUTHORITY_KEY_ID2_INFO::AuthorityCertSerialNumber"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_KEY_ID2_INFO, AuthorityCertSerialNumber) - 32usize];
};
pub type CERT_AUTHORITY_KEY_ID2_INFO = _CERT_AUTHORITY_KEY_ID2_INFO;
pub type PCERT_AUTHORITY_KEY_ID2_INFO = *mut _CERT_AUTHORITY_KEY_ID2_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_ACCESS_DESCRIPTION {
    pub pszAccessMethod: LPSTR,
    pub AccessLocation: CERT_ALT_NAME_ENTRY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ACCESS_DESCRIPTION"]
        [::std::mem::size_of::<_CERT_ACCESS_DESCRIPTION>() - 32usize];
    ["Alignment of _CERT_ACCESS_DESCRIPTION"]
        [::std::mem::align_of::<_CERT_ACCESS_DESCRIPTION>() - 8usize];
    ["Offset of field: _CERT_ACCESS_DESCRIPTION::pszAccessMethod"]
        [::std::mem::offset_of!(_CERT_ACCESS_DESCRIPTION, pszAccessMethod) - 0usize];
    ["Offset of field: _CERT_ACCESS_DESCRIPTION::AccessLocation"]
        [::std::mem::offset_of!(_CERT_ACCESS_DESCRIPTION, AccessLocation) - 8usize];
};
pub type CERT_ACCESS_DESCRIPTION = _CERT_ACCESS_DESCRIPTION;
pub type PCERT_ACCESS_DESCRIPTION = *mut _CERT_ACCESS_DESCRIPTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_AUTHORITY_INFO_ACCESS {
    pub cAccDescr: DWORD,
    pub rgAccDescr: PCERT_ACCESS_DESCRIPTION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_AUTHORITY_INFO_ACCESS"]
        [::std::mem::size_of::<_CERT_AUTHORITY_INFO_ACCESS>() - 16usize];
    ["Alignment of _CERT_AUTHORITY_INFO_ACCESS"]
        [::std::mem::align_of::<_CERT_AUTHORITY_INFO_ACCESS>() - 8usize];
    ["Offset of field: _CERT_AUTHORITY_INFO_ACCESS::cAccDescr"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_INFO_ACCESS, cAccDescr) - 0usize];
    ["Offset of field: _CERT_AUTHORITY_INFO_ACCESS::rgAccDescr"]
        [::std::mem::offset_of!(_CERT_AUTHORITY_INFO_ACCESS, rgAccDescr) - 8usize];
};
pub type CERT_AUTHORITY_INFO_ACCESS = _CERT_AUTHORITY_INFO_ACCESS;
pub type PCERT_AUTHORITY_INFO_ACCESS = *mut _CERT_AUTHORITY_INFO_ACCESS;
pub type CERT_SUBJECT_INFO_ACCESS = _CERT_AUTHORITY_INFO_ACCESS;
pub type PCERT_SUBJECT_INFO_ACCESS = *mut _CERT_AUTHORITY_INFO_ACCESS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CRL_DIST_POINT_NAME {
    pub dwDistPointNameChoice: DWORD,
    pub __bindgen_anon_1: _CRL_DIST_POINT_NAME__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CRL_DIST_POINT_NAME__bindgen_ty_1 {
    pub FullName: CERT_ALT_NAME_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_DIST_POINT_NAME__bindgen_ty_1"]
        [::std::mem::size_of::<_CRL_DIST_POINT_NAME__bindgen_ty_1>() - 16usize];
    ["Alignment of _CRL_DIST_POINT_NAME__bindgen_ty_1"]
        [::std::mem::align_of::<_CRL_DIST_POINT_NAME__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CRL_DIST_POINT_NAME__bindgen_ty_1::FullName"]
        [::std::mem::offset_of!(_CRL_DIST_POINT_NAME__bindgen_ty_1, FullName) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_DIST_POINT_NAME"][::std::mem::size_of::<_CRL_DIST_POINT_NAME>() - 24usize];
    ["Alignment of _CRL_DIST_POINT_NAME"][::std::mem::align_of::<_CRL_DIST_POINT_NAME>() - 8usize];
    ["Offset of field: _CRL_DIST_POINT_NAME::dwDistPointNameChoice"]
        [::std::mem::offset_of!(_CRL_DIST_POINT_NAME, dwDistPointNameChoice) - 0usize];
};
pub type CRL_DIST_POINT_NAME = _CRL_DIST_POINT_NAME;
pub type PCRL_DIST_POINT_NAME = *mut _CRL_DIST_POINT_NAME;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CRL_DIST_POINT {
    pub DistPointName: CRL_DIST_POINT_NAME,
    pub ReasonFlags: CRYPT_BIT_BLOB,
    pub CRLIssuer: CERT_ALT_NAME_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_DIST_POINT"][::std::mem::size_of::<_CRL_DIST_POINT>() - 64usize];
    ["Alignment of _CRL_DIST_POINT"][::std::mem::align_of::<_CRL_DIST_POINT>() - 8usize];
    ["Offset of field: _CRL_DIST_POINT::DistPointName"]
        [::std::mem::offset_of!(_CRL_DIST_POINT, DistPointName) - 0usize];
    ["Offset of field: _CRL_DIST_POINT::ReasonFlags"]
        [::std::mem::offset_of!(_CRL_DIST_POINT, ReasonFlags) - 24usize];
    ["Offset of field: _CRL_DIST_POINT::CRLIssuer"]
        [::std::mem::offset_of!(_CRL_DIST_POINT, CRLIssuer) - 48usize];
};
pub type CRL_DIST_POINT = _CRL_DIST_POINT;
pub type PCRL_DIST_POINT = *mut _CRL_DIST_POINT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_DIST_POINTS_INFO {
    pub cDistPoint: DWORD,
    pub rgDistPoint: PCRL_DIST_POINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_DIST_POINTS_INFO"][::std::mem::size_of::<_CRL_DIST_POINTS_INFO>() - 16usize];
    ["Alignment of _CRL_DIST_POINTS_INFO"]
        [::std::mem::align_of::<_CRL_DIST_POINTS_INFO>() - 8usize];
    ["Offset of field: _CRL_DIST_POINTS_INFO::cDistPoint"]
        [::std::mem::offset_of!(_CRL_DIST_POINTS_INFO, cDistPoint) - 0usize];
    ["Offset of field: _CRL_DIST_POINTS_INFO::rgDistPoint"]
        [::std::mem::offset_of!(_CRL_DIST_POINTS_INFO, rgDistPoint) - 8usize];
};
pub type CRL_DIST_POINTS_INFO = _CRL_DIST_POINTS_INFO;
pub type PCRL_DIST_POINTS_INFO = *mut _CRL_DIST_POINTS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CROSS_CERT_DIST_POINTS_INFO {
    pub dwSyncDeltaTime: DWORD,
    pub cDistPoint: DWORD,
    pub rgDistPoint: PCERT_ALT_NAME_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CROSS_CERT_DIST_POINTS_INFO"]
        [::std::mem::size_of::<_CROSS_CERT_DIST_POINTS_INFO>() - 16usize];
    ["Alignment of _CROSS_CERT_DIST_POINTS_INFO"]
        [::std::mem::align_of::<_CROSS_CERT_DIST_POINTS_INFO>() - 8usize];
    ["Offset of field: _CROSS_CERT_DIST_POINTS_INFO::dwSyncDeltaTime"]
        [::std::mem::offset_of!(_CROSS_CERT_DIST_POINTS_INFO, dwSyncDeltaTime) - 0usize];
    ["Offset of field: _CROSS_CERT_DIST_POINTS_INFO::cDistPoint"]
        [::std::mem::offset_of!(_CROSS_CERT_DIST_POINTS_INFO, cDistPoint) - 4usize];
    ["Offset of field: _CROSS_CERT_DIST_POINTS_INFO::rgDistPoint"]
        [::std::mem::offset_of!(_CROSS_CERT_DIST_POINTS_INFO, rgDistPoint) - 8usize];
};
pub type CROSS_CERT_DIST_POINTS_INFO = _CROSS_CERT_DIST_POINTS_INFO;
pub type PCROSS_CERT_DIST_POINTS_INFO = *mut _CROSS_CERT_DIST_POINTS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_PAIR {
    pub Forward: CERT_BLOB,
    pub Reverse: CERT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_PAIR"][::std::mem::size_of::<_CERT_PAIR>() - 32usize];
    ["Alignment of _CERT_PAIR"][::std::mem::align_of::<_CERT_PAIR>() - 8usize];
    ["Offset of field: _CERT_PAIR::Forward"][::std::mem::offset_of!(_CERT_PAIR, Forward) - 0usize];
    ["Offset of field: _CERT_PAIR::Reverse"][::std::mem::offset_of!(_CERT_PAIR, Reverse) - 16usize];
};
pub type CERT_PAIR = _CERT_PAIR;
pub type PCERT_PAIR = *mut _CERT_PAIR;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CRL_ISSUING_DIST_POINT {
    pub DistPointName: CRL_DIST_POINT_NAME,
    pub fOnlyContainsUserCerts: BOOL,
    pub fOnlyContainsCACerts: BOOL,
    pub OnlySomeReasonFlags: CRYPT_BIT_BLOB,
    pub fIndirectCRL: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_ISSUING_DIST_POINT"][::std::mem::size_of::<_CRL_ISSUING_DIST_POINT>() - 64usize];
    ["Alignment of _CRL_ISSUING_DIST_POINT"]
        [::std::mem::align_of::<_CRL_ISSUING_DIST_POINT>() - 8usize];
    ["Offset of field: _CRL_ISSUING_DIST_POINT::DistPointName"]
        [::std::mem::offset_of!(_CRL_ISSUING_DIST_POINT, DistPointName) - 0usize];
    ["Offset of field: _CRL_ISSUING_DIST_POINT::fOnlyContainsUserCerts"]
        [::std::mem::offset_of!(_CRL_ISSUING_DIST_POINT, fOnlyContainsUserCerts) - 24usize];
    ["Offset of field: _CRL_ISSUING_DIST_POINT::fOnlyContainsCACerts"]
        [::std::mem::offset_of!(_CRL_ISSUING_DIST_POINT, fOnlyContainsCACerts) - 28usize];
    ["Offset of field: _CRL_ISSUING_DIST_POINT::OnlySomeReasonFlags"]
        [::std::mem::offset_of!(_CRL_ISSUING_DIST_POINT, OnlySomeReasonFlags) - 32usize];
    ["Offset of field: _CRL_ISSUING_DIST_POINT::fIndirectCRL"]
        [::std::mem::offset_of!(_CRL_ISSUING_DIST_POINT, fIndirectCRL) - 56usize];
};
pub type CRL_ISSUING_DIST_POINT = _CRL_ISSUING_DIST_POINT;
pub type PCRL_ISSUING_DIST_POINT = *mut _CRL_ISSUING_DIST_POINT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_GENERAL_SUBTREE {
    pub Base: CERT_ALT_NAME_ENTRY,
    pub dwMinimum: DWORD,
    pub fMaximum: BOOL,
    pub dwMaximum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_GENERAL_SUBTREE"][::std::mem::size_of::<_CERT_GENERAL_SUBTREE>() - 40usize];
    ["Alignment of _CERT_GENERAL_SUBTREE"]
        [::std::mem::align_of::<_CERT_GENERAL_SUBTREE>() - 8usize];
    ["Offset of field: _CERT_GENERAL_SUBTREE::Base"]
        [::std::mem::offset_of!(_CERT_GENERAL_SUBTREE, Base) - 0usize];
    ["Offset of field: _CERT_GENERAL_SUBTREE::dwMinimum"]
        [::std::mem::offset_of!(_CERT_GENERAL_SUBTREE, dwMinimum) - 24usize];
    ["Offset of field: _CERT_GENERAL_SUBTREE::fMaximum"]
        [::std::mem::offset_of!(_CERT_GENERAL_SUBTREE, fMaximum) - 28usize];
    ["Offset of field: _CERT_GENERAL_SUBTREE::dwMaximum"]
        [::std::mem::offset_of!(_CERT_GENERAL_SUBTREE, dwMaximum) - 32usize];
};
pub type CERT_GENERAL_SUBTREE = _CERT_GENERAL_SUBTREE;
pub type PCERT_GENERAL_SUBTREE = *mut _CERT_GENERAL_SUBTREE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_NAME_CONSTRAINTS_INFO {
    pub cPermittedSubtree: DWORD,
    pub rgPermittedSubtree: PCERT_GENERAL_SUBTREE,
    pub cExcludedSubtree: DWORD,
    pub rgExcludedSubtree: PCERT_GENERAL_SUBTREE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_NAME_CONSTRAINTS_INFO"]
        [::std::mem::size_of::<_CERT_NAME_CONSTRAINTS_INFO>() - 32usize];
    ["Alignment of _CERT_NAME_CONSTRAINTS_INFO"]
        [::std::mem::align_of::<_CERT_NAME_CONSTRAINTS_INFO>() - 8usize];
    ["Offset of field: _CERT_NAME_CONSTRAINTS_INFO::cPermittedSubtree"]
        [::std::mem::offset_of!(_CERT_NAME_CONSTRAINTS_INFO, cPermittedSubtree) - 0usize];
    ["Offset of field: _CERT_NAME_CONSTRAINTS_INFO::rgPermittedSubtree"]
        [::std::mem::offset_of!(_CERT_NAME_CONSTRAINTS_INFO, rgPermittedSubtree) - 8usize];
    ["Offset of field: _CERT_NAME_CONSTRAINTS_INFO::cExcludedSubtree"]
        [::std::mem::offset_of!(_CERT_NAME_CONSTRAINTS_INFO, cExcludedSubtree) - 16usize];
    ["Offset of field: _CERT_NAME_CONSTRAINTS_INFO::rgExcludedSubtree"]
        [::std::mem::offset_of!(_CERT_NAME_CONSTRAINTS_INFO, rgExcludedSubtree) - 24usize];
};
pub type CERT_NAME_CONSTRAINTS_INFO = _CERT_NAME_CONSTRAINTS_INFO;
pub type PCERT_NAME_CONSTRAINTS_INFO = *mut _CERT_NAME_CONSTRAINTS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_DSS_PARAMETERS {
    pub p: CRYPT_UINT_BLOB,
    pub q: CRYPT_UINT_BLOB,
    pub g: CRYPT_UINT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_DSS_PARAMETERS"][::std::mem::size_of::<_CERT_DSS_PARAMETERS>() - 48usize];
    ["Alignment of _CERT_DSS_PARAMETERS"][::std::mem::align_of::<_CERT_DSS_PARAMETERS>() - 8usize];
    ["Offset of field: _CERT_DSS_PARAMETERS::p"]
        [::std::mem::offset_of!(_CERT_DSS_PARAMETERS, p) - 0usize];
    ["Offset of field: _CERT_DSS_PARAMETERS::q"]
        [::std::mem::offset_of!(_CERT_DSS_PARAMETERS, q) - 16usize];
    ["Offset of field: _CERT_DSS_PARAMETERS::g"]
        [::std::mem::offset_of!(_CERT_DSS_PARAMETERS, g) - 32usize];
};
pub type CERT_DSS_PARAMETERS = _CERT_DSS_PARAMETERS;
pub type PCERT_DSS_PARAMETERS = *mut _CERT_DSS_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_DH_PARAMETERS {
    pub p: CRYPT_UINT_BLOB,
    pub g: CRYPT_UINT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_DH_PARAMETERS"][::std::mem::size_of::<_CERT_DH_PARAMETERS>() - 32usize];
    ["Alignment of _CERT_DH_PARAMETERS"][::std::mem::align_of::<_CERT_DH_PARAMETERS>() - 8usize];
    ["Offset of field: _CERT_DH_PARAMETERS::p"]
        [::std::mem::offset_of!(_CERT_DH_PARAMETERS, p) - 0usize];
    ["Offset of field: _CERT_DH_PARAMETERS::g"]
        [::std::mem::offset_of!(_CERT_DH_PARAMETERS, g) - 16usize];
};
pub type CERT_DH_PARAMETERS = _CERT_DH_PARAMETERS;
pub type PCERT_DH_PARAMETERS = *mut _CERT_DH_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_ECC_SIGNATURE {
    pub r: CRYPT_UINT_BLOB,
    pub s: CRYPT_UINT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ECC_SIGNATURE"][::std::mem::size_of::<_CERT_ECC_SIGNATURE>() - 32usize];
    ["Alignment of _CERT_ECC_SIGNATURE"][::std::mem::align_of::<_CERT_ECC_SIGNATURE>() - 8usize];
    ["Offset of field: _CERT_ECC_SIGNATURE::r"]
        [::std::mem::offset_of!(_CERT_ECC_SIGNATURE, r) - 0usize];
    ["Offset of field: _CERT_ECC_SIGNATURE::s"]
        [::std::mem::offset_of!(_CERT_ECC_SIGNATURE, s) - 16usize];
};
pub type CERT_ECC_SIGNATURE = _CERT_ECC_SIGNATURE;
pub type PCERT_ECC_SIGNATURE = *mut _CERT_ECC_SIGNATURE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_X942_DH_VALIDATION_PARAMS {
    pub seed: CRYPT_BIT_BLOB,
    pub pgenCounter: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_X942_DH_VALIDATION_PARAMS"]
        [::std::mem::size_of::<_CERT_X942_DH_VALIDATION_PARAMS>() - 32usize];
    ["Alignment of _CERT_X942_DH_VALIDATION_PARAMS"]
        [::std::mem::align_of::<_CERT_X942_DH_VALIDATION_PARAMS>() - 8usize];
    ["Offset of field: _CERT_X942_DH_VALIDATION_PARAMS::seed"]
        [::std::mem::offset_of!(_CERT_X942_DH_VALIDATION_PARAMS, seed) - 0usize];
    ["Offset of field: _CERT_X942_DH_VALIDATION_PARAMS::pgenCounter"]
        [::std::mem::offset_of!(_CERT_X942_DH_VALIDATION_PARAMS, pgenCounter) - 24usize];
};
pub type CERT_X942_DH_VALIDATION_PARAMS = _CERT_X942_DH_VALIDATION_PARAMS;
pub type PCERT_X942_DH_VALIDATION_PARAMS = *mut _CERT_X942_DH_VALIDATION_PARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_X942_DH_PARAMETERS {
    pub p: CRYPT_UINT_BLOB,
    pub g: CRYPT_UINT_BLOB,
    pub q: CRYPT_UINT_BLOB,
    pub j: CRYPT_UINT_BLOB,
    pub pValidationParams: PCERT_X942_DH_VALIDATION_PARAMS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_X942_DH_PARAMETERS"]
        [::std::mem::size_of::<_CERT_X942_DH_PARAMETERS>() - 72usize];
    ["Alignment of _CERT_X942_DH_PARAMETERS"]
        [::std::mem::align_of::<_CERT_X942_DH_PARAMETERS>() - 8usize];
    ["Offset of field: _CERT_X942_DH_PARAMETERS::p"]
        [::std::mem::offset_of!(_CERT_X942_DH_PARAMETERS, p) - 0usize];
    ["Offset of field: _CERT_X942_DH_PARAMETERS::g"]
        [::std::mem::offset_of!(_CERT_X942_DH_PARAMETERS, g) - 16usize];
    ["Offset of field: _CERT_X942_DH_PARAMETERS::q"]
        [::std::mem::offset_of!(_CERT_X942_DH_PARAMETERS, q) - 32usize];
    ["Offset of field: _CERT_X942_DH_PARAMETERS::j"]
        [::std::mem::offset_of!(_CERT_X942_DH_PARAMETERS, j) - 48usize];
    ["Offset of field: _CERT_X942_DH_PARAMETERS::pValidationParams"]
        [::std::mem::offset_of!(_CERT_X942_DH_PARAMETERS, pValidationParams) - 64usize];
};
pub type CERT_X942_DH_PARAMETERS = _CERT_X942_DH_PARAMETERS;
pub type PCERT_X942_DH_PARAMETERS = *mut _CERT_X942_DH_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_X942_OTHER_INFO {
    pub pszContentEncryptionObjId: LPSTR,
    pub rgbCounter: [BYTE; 4usize],
    pub rgbKeyLength: [BYTE; 4usize],
    pub PubInfo: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_X942_OTHER_INFO"][::std::mem::size_of::<_CRYPT_X942_OTHER_INFO>() - 32usize];
    ["Alignment of _CRYPT_X942_OTHER_INFO"]
        [::std::mem::align_of::<_CRYPT_X942_OTHER_INFO>() - 8usize];
    ["Offset of field: _CRYPT_X942_OTHER_INFO::pszContentEncryptionObjId"]
        [::std::mem::offset_of!(_CRYPT_X942_OTHER_INFO, pszContentEncryptionObjId) - 0usize];
    ["Offset of field: _CRYPT_X942_OTHER_INFO::rgbCounter"]
        [::std::mem::offset_of!(_CRYPT_X942_OTHER_INFO, rgbCounter) - 8usize];
    ["Offset of field: _CRYPT_X942_OTHER_INFO::rgbKeyLength"]
        [::std::mem::offset_of!(_CRYPT_X942_OTHER_INFO, rgbKeyLength) - 12usize];
    ["Offset of field: _CRYPT_X942_OTHER_INFO::PubInfo"]
        [::std::mem::offset_of!(_CRYPT_X942_OTHER_INFO, PubInfo) - 16usize];
};
pub type CRYPT_X942_OTHER_INFO = _CRYPT_X942_OTHER_INFO;
pub type PCRYPT_X942_OTHER_INFO = *mut _CRYPT_X942_OTHER_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ECC_CMS_SHARED_INFO {
    pub Algorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EntityUInfo: CRYPT_DATA_BLOB,
    pub rgbSuppPubInfo: [BYTE; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ECC_CMS_SHARED_INFO"]
        [::std::mem::size_of::<_CRYPT_ECC_CMS_SHARED_INFO>() - 48usize];
    ["Alignment of _CRYPT_ECC_CMS_SHARED_INFO"]
        [::std::mem::align_of::<_CRYPT_ECC_CMS_SHARED_INFO>() - 8usize];
    ["Offset of field: _CRYPT_ECC_CMS_SHARED_INFO::Algorithm"]
        [::std::mem::offset_of!(_CRYPT_ECC_CMS_SHARED_INFO, Algorithm) - 0usize];
    ["Offset of field: _CRYPT_ECC_CMS_SHARED_INFO::EntityUInfo"]
        [::std::mem::offset_of!(_CRYPT_ECC_CMS_SHARED_INFO, EntityUInfo) - 24usize];
    ["Offset of field: _CRYPT_ECC_CMS_SHARED_INFO::rgbSuppPubInfo"]
        [::std::mem::offset_of!(_CRYPT_ECC_CMS_SHARED_INFO, rgbSuppPubInfo) - 40usize];
};
pub type CRYPT_ECC_CMS_SHARED_INFO = _CRYPT_ECC_CMS_SHARED_INFO;
pub type PCRYPT_ECC_CMS_SHARED_INFO = *mut _CRYPT_ECC_CMS_SHARED_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_RC2_CBC_PARAMETERS {
    pub dwVersion: DWORD,
    pub fIV: BOOL,
    pub rgbIV: [BYTE; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_RC2_CBC_PARAMETERS"]
        [::std::mem::size_of::<_CRYPT_RC2_CBC_PARAMETERS>() - 16usize];
    ["Alignment of _CRYPT_RC2_CBC_PARAMETERS"]
        [::std::mem::align_of::<_CRYPT_RC2_CBC_PARAMETERS>() - 4usize];
    ["Offset of field: _CRYPT_RC2_CBC_PARAMETERS::dwVersion"]
        [::std::mem::offset_of!(_CRYPT_RC2_CBC_PARAMETERS, dwVersion) - 0usize];
    ["Offset of field: _CRYPT_RC2_CBC_PARAMETERS::fIV"]
        [::std::mem::offset_of!(_CRYPT_RC2_CBC_PARAMETERS, fIV) - 4usize];
    ["Offset of field: _CRYPT_RC2_CBC_PARAMETERS::rgbIV"]
        [::std::mem::offset_of!(_CRYPT_RC2_CBC_PARAMETERS, rgbIV) - 8usize];
};
pub type CRYPT_RC2_CBC_PARAMETERS = _CRYPT_RC2_CBC_PARAMETERS;
pub type PCRYPT_RC2_CBC_PARAMETERS = *mut _CRYPT_RC2_CBC_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_SMIME_CAPABILITY {
    pub pszObjId: LPSTR,
    pub Parameters: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_SMIME_CAPABILITY"][::std::mem::size_of::<_CRYPT_SMIME_CAPABILITY>() - 24usize];
    ["Alignment of _CRYPT_SMIME_CAPABILITY"]
        [::std::mem::align_of::<_CRYPT_SMIME_CAPABILITY>() - 8usize];
    ["Offset of field: _CRYPT_SMIME_CAPABILITY::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_SMIME_CAPABILITY, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_SMIME_CAPABILITY::Parameters"]
        [::std::mem::offset_of!(_CRYPT_SMIME_CAPABILITY, Parameters) - 8usize];
};
pub type CRYPT_SMIME_CAPABILITY = _CRYPT_SMIME_CAPABILITY;
pub type PCRYPT_SMIME_CAPABILITY = *mut _CRYPT_SMIME_CAPABILITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_SMIME_CAPABILITIES {
    pub cCapability: DWORD,
    pub rgCapability: PCRYPT_SMIME_CAPABILITY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_SMIME_CAPABILITIES"]
        [::std::mem::size_of::<_CRYPT_SMIME_CAPABILITIES>() - 16usize];
    ["Alignment of _CRYPT_SMIME_CAPABILITIES"]
        [::std::mem::align_of::<_CRYPT_SMIME_CAPABILITIES>() - 8usize];
    ["Offset of field: _CRYPT_SMIME_CAPABILITIES::cCapability"]
        [::std::mem::offset_of!(_CRYPT_SMIME_CAPABILITIES, cCapability) - 0usize];
    ["Offset of field: _CRYPT_SMIME_CAPABILITIES::rgCapability"]
        [::std::mem::offset_of!(_CRYPT_SMIME_CAPABILITIES, rgCapability) - 8usize];
};
pub type CRYPT_SMIME_CAPABILITIES = _CRYPT_SMIME_CAPABILITIES;
pub type PCRYPT_SMIME_CAPABILITIES = *mut _CRYPT_SMIME_CAPABILITIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_QC_STATEMENT {
    pub pszStatementId: LPSTR,
    pub StatementInfo: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_QC_STATEMENT"][::std::mem::size_of::<_CERT_QC_STATEMENT>() - 24usize];
    ["Alignment of _CERT_QC_STATEMENT"][::std::mem::align_of::<_CERT_QC_STATEMENT>() - 8usize];
    ["Offset of field: _CERT_QC_STATEMENT::pszStatementId"]
        [::std::mem::offset_of!(_CERT_QC_STATEMENT, pszStatementId) - 0usize];
    ["Offset of field: _CERT_QC_STATEMENT::StatementInfo"]
        [::std::mem::offset_of!(_CERT_QC_STATEMENT, StatementInfo) - 8usize];
};
pub type CERT_QC_STATEMENT = _CERT_QC_STATEMENT;
pub type PCERT_QC_STATEMENT = *mut _CERT_QC_STATEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_QC_STATEMENTS_EXT_INFO {
    pub cStatement: DWORD,
    pub rgStatement: PCERT_QC_STATEMENT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_QC_STATEMENTS_EXT_INFO"]
        [::std::mem::size_of::<_CERT_QC_STATEMENTS_EXT_INFO>() - 16usize];
    ["Alignment of _CERT_QC_STATEMENTS_EXT_INFO"]
        [::std::mem::align_of::<_CERT_QC_STATEMENTS_EXT_INFO>() - 8usize];
    ["Offset of field: _CERT_QC_STATEMENTS_EXT_INFO::cStatement"]
        [::std::mem::offset_of!(_CERT_QC_STATEMENTS_EXT_INFO, cStatement) - 0usize];
    ["Offset of field: _CERT_QC_STATEMENTS_EXT_INFO::rgStatement"]
        [::std::mem::offset_of!(_CERT_QC_STATEMENTS_EXT_INFO, rgStatement) - 8usize];
};
pub type CERT_QC_STATEMENTS_EXT_INFO = _CERT_QC_STATEMENTS_EXT_INFO;
pub type PCERT_QC_STATEMENTS_EXT_INFO = *mut _CERT_QC_STATEMENTS_EXT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_MASK_GEN_ALGORITHM {
    pub pszObjId: LPSTR,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_MASK_GEN_ALGORITHM"]
        [::std::mem::size_of::<_CRYPT_MASK_GEN_ALGORITHM>() - 32usize];
    ["Alignment of _CRYPT_MASK_GEN_ALGORITHM"]
        [::std::mem::align_of::<_CRYPT_MASK_GEN_ALGORITHM>() - 8usize];
    ["Offset of field: _CRYPT_MASK_GEN_ALGORITHM::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_MASK_GEN_ALGORITHM, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_MASK_GEN_ALGORITHM::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_MASK_GEN_ALGORITHM, HashAlgorithm) - 8usize];
};
pub type CRYPT_MASK_GEN_ALGORITHM = _CRYPT_MASK_GEN_ALGORITHM;
pub type PCRYPT_MASK_GEN_ALGORITHM = *mut _CRYPT_MASK_GEN_ALGORITHM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_RSA_SSA_PSS_PARAMETERS {
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub MaskGenAlgorithm: CRYPT_MASK_GEN_ALGORITHM,
    pub dwSaltLength: DWORD,
    pub dwTrailerField: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_RSA_SSA_PSS_PARAMETERS"]
        [::std::mem::size_of::<_CRYPT_RSA_SSA_PSS_PARAMETERS>() - 64usize];
    ["Alignment of _CRYPT_RSA_SSA_PSS_PARAMETERS"]
        [::std::mem::align_of::<_CRYPT_RSA_SSA_PSS_PARAMETERS>() - 8usize];
    ["Offset of field: _CRYPT_RSA_SSA_PSS_PARAMETERS::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_RSA_SSA_PSS_PARAMETERS, HashAlgorithm) - 0usize];
    ["Offset of field: _CRYPT_RSA_SSA_PSS_PARAMETERS::MaskGenAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_RSA_SSA_PSS_PARAMETERS, MaskGenAlgorithm) - 24usize];
    ["Offset of field: _CRYPT_RSA_SSA_PSS_PARAMETERS::dwSaltLength"]
        [::std::mem::offset_of!(_CRYPT_RSA_SSA_PSS_PARAMETERS, dwSaltLength) - 56usize];
    ["Offset of field: _CRYPT_RSA_SSA_PSS_PARAMETERS::dwTrailerField"]
        [::std::mem::offset_of!(_CRYPT_RSA_SSA_PSS_PARAMETERS, dwTrailerField) - 60usize];
};
pub type CRYPT_RSA_SSA_PSS_PARAMETERS = _CRYPT_RSA_SSA_PSS_PARAMETERS;
pub type PCRYPT_RSA_SSA_PSS_PARAMETERS = *mut _CRYPT_RSA_SSA_PSS_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PSOURCE_ALGORITHM {
    pub pszObjId: LPSTR,
    pub EncodingParameters: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PSOURCE_ALGORITHM"]
        [::std::mem::size_of::<_CRYPT_PSOURCE_ALGORITHM>() - 24usize];
    ["Alignment of _CRYPT_PSOURCE_ALGORITHM"]
        [::std::mem::align_of::<_CRYPT_PSOURCE_ALGORITHM>() - 8usize];
    ["Offset of field: _CRYPT_PSOURCE_ALGORITHM::pszObjId"]
        [::std::mem::offset_of!(_CRYPT_PSOURCE_ALGORITHM, pszObjId) - 0usize];
    ["Offset of field: _CRYPT_PSOURCE_ALGORITHM::EncodingParameters"]
        [::std::mem::offset_of!(_CRYPT_PSOURCE_ALGORITHM, EncodingParameters) - 8usize];
};
pub type CRYPT_PSOURCE_ALGORITHM = _CRYPT_PSOURCE_ALGORITHM;
pub type PCRYPT_PSOURCE_ALGORITHM = *mut _CRYPT_PSOURCE_ALGORITHM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_RSAES_OAEP_PARAMETERS {
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub MaskGenAlgorithm: CRYPT_MASK_GEN_ALGORITHM,
    pub PSourceAlgorithm: CRYPT_PSOURCE_ALGORITHM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_RSAES_OAEP_PARAMETERS"]
        [::std::mem::size_of::<_CRYPT_RSAES_OAEP_PARAMETERS>() - 80usize];
    ["Alignment of _CRYPT_RSAES_OAEP_PARAMETERS"]
        [::std::mem::align_of::<_CRYPT_RSAES_OAEP_PARAMETERS>() - 8usize];
    ["Offset of field: _CRYPT_RSAES_OAEP_PARAMETERS::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_RSAES_OAEP_PARAMETERS, HashAlgorithm) - 0usize];
    ["Offset of field: _CRYPT_RSAES_OAEP_PARAMETERS::MaskGenAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_RSAES_OAEP_PARAMETERS, MaskGenAlgorithm) - 24usize];
    ["Offset of field: _CRYPT_RSAES_OAEP_PARAMETERS::PSourceAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_RSAES_OAEP_PARAMETERS, PSourceAlgorithm) - 56usize];
};
pub type CRYPT_RSAES_OAEP_PARAMETERS = _CRYPT_RSAES_OAEP_PARAMETERS;
pub type PCRYPT_RSAES_OAEP_PARAMETERS = *mut _CRYPT_RSAES_OAEP_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_TAGGED_ATTRIBUTE {
    pub dwBodyPartID: DWORD,
    pub Attribute: CRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_ATTRIBUTE"][::std::mem::size_of::<_CMC_TAGGED_ATTRIBUTE>() - 32usize];
    ["Alignment of _CMC_TAGGED_ATTRIBUTE"]
        [::std::mem::align_of::<_CMC_TAGGED_ATTRIBUTE>() - 8usize];
    ["Offset of field: _CMC_TAGGED_ATTRIBUTE::dwBodyPartID"]
        [::std::mem::offset_of!(_CMC_TAGGED_ATTRIBUTE, dwBodyPartID) - 0usize];
    ["Offset of field: _CMC_TAGGED_ATTRIBUTE::Attribute"]
        [::std::mem::offset_of!(_CMC_TAGGED_ATTRIBUTE, Attribute) - 8usize];
};
pub type CMC_TAGGED_ATTRIBUTE = _CMC_TAGGED_ATTRIBUTE;
pub type PCMC_TAGGED_ATTRIBUTE = *mut _CMC_TAGGED_ATTRIBUTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_TAGGED_CERT_REQUEST {
    pub dwBodyPartID: DWORD,
    pub SignedCertRequest: CRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_CERT_REQUEST"]
        [::std::mem::size_of::<_CMC_TAGGED_CERT_REQUEST>() - 24usize];
    ["Alignment of _CMC_TAGGED_CERT_REQUEST"]
        [::std::mem::align_of::<_CMC_TAGGED_CERT_REQUEST>() - 8usize];
    ["Offset of field: _CMC_TAGGED_CERT_REQUEST::dwBodyPartID"]
        [::std::mem::offset_of!(_CMC_TAGGED_CERT_REQUEST, dwBodyPartID) - 0usize];
    ["Offset of field: _CMC_TAGGED_CERT_REQUEST::SignedCertRequest"]
        [::std::mem::offset_of!(_CMC_TAGGED_CERT_REQUEST, SignedCertRequest) - 8usize];
};
pub type CMC_TAGGED_CERT_REQUEST = _CMC_TAGGED_CERT_REQUEST;
pub type PCMC_TAGGED_CERT_REQUEST = *mut _CMC_TAGGED_CERT_REQUEST;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMC_TAGGED_REQUEST {
    pub dwTaggedRequestChoice: DWORD,
    pub __bindgen_anon_1: _CMC_TAGGED_REQUEST__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMC_TAGGED_REQUEST__bindgen_ty_1 {
    pub pTaggedCertRequest: PCMC_TAGGED_CERT_REQUEST,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_REQUEST__bindgen_ty_1"]
        [::std::mem::size_of::<_CMC_TAGGED_REQUEST__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMC_TAGGED_REQUEST__bindgen_ty_1"]
        [::std::mem::align_of::<_CMC_TAGGED_REQUEST__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMC_TAGGED_REQUEST__bindgen_ty_1::pTaggedCertRequest"]
        [::std::mem::offset_of!(_CMC_TAGGED_REQUEST__bindgen_ty_1, pTaggedCertRequest) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_REQUEST"][::std::mem::size_of::<_CMC_TAGGED_REQUEST>() - 16usize];
    ["Alignment of _CMC_TAGGED_REQUEST"][::std::mem::align_of::<_CMC_TAGGED_REQUEST>() - 8usize];
    ["Offset of field: _CMC_TAGGED_REQUEST::dwTaggedRequestChoice"]
        [::std::mem::offset_of!(_CMC_TAGGED_REQUEST, dwTaggedRequestChoice) - 0usize];
};
pub type CMC_TAGGED_REQUEST = _CMC_TAGGED_REQUEST;
pub type PCMC_TAGGED_REQUEST = *mut _CMC_TAGGED_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_TAGGED_CONTENT_INFO {
    pub dwBodyPartID: DWORD,
    pub EncodedContentInfo: CRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_CONTENT_INFO"]
        [::std::mem::size_of::<_CMC_TAGGED_CONTENT_INFO>() - 24usize];
    ["Alignment of _CMC_TAGGED_CONTENT_INFO"]
        [::std::mem::align_of::<_CMC_TAGGED_CONTENT_INFO>() - 8usize];
    ["Offset of field: _CMC_TAGGED_CONTENT_INFO::dwBodyPartID"]
        [::std::mem::offset_of!(_CMC_TAGGED_CONTENT_INFO, dwBodyPartID) - 0usize];
    ["Offset of field: _CMC_TAGGED_CONTENT_INFO::EncodedContentInfo"]
        [::std::mem::offset_of!(_CMC_TAGGED_CONTENT_INFO, EncodedContentInfo) - 8usize];
};
pub type CMC_TAGGED_CONTENT_INFO = _CMC_TAGGED_CONTENT_INFO;
pub type PCMC_TAGGED_CONTENT_INFO = *mut _CMC_TAGGED_CONTENT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_TAGGED_OTHER_MSG {
    pub dwBodyPartID: DWORD,
    pub pszObjId: LPSTR,
    pub Value: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_TAGGED_OTHER_MSG"][::std::mem::size_of::<_CMC_TAGGED_OTHER_MSG>() - 32usize];
    ["Alignment of _CMC_TAGGED_OTHER_MSG"]
        [::std::mem::align_of::<_CMC_TAGGED_OTHER_MSG>() - 8usize];
    ["Offset of field: _CMC_TAGGED_OTHER_MSG::dwBodyPartID"]
        [::std::mem::offset_of!(_CMC_TAGGED_OTHER_MSG, dwBodyPartID) - 0usize];
    ["Offset of field: _CMC_TAGGED_OTHER_MSG::pszObjId"]
        [::std::mem::offset_of!(_CMC_TAGGED_OTHER_MSG, pszObjId) - 8usize];
    ["Offset of field: _CMC_TAGGED_OTHER_MSG::Value"]
        [::std::mem::offset_of!(_CMC_TAGGED_OTHER_MSG, Value) - 16usize];
};
pub type CMC_TAGGED_OTHER_MSG = _CMC_TAGGED_OTHER_MSG;
pub type PCMC_TAGGED_OTHER_MSG = *mut _CMC_TAGGED_OTHER_MSG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_DATA_INFO {
    pub cTaggedAttribute: DWORD,
    pub rgTaggedAttribute: PCMC_TAGGED_ATTRIBUTE,
    pub cTaggedRequest: DWORD,
    pub rgTaggedRequest: PCMC_TAGGED_REQUEST,
    pub cTaggedContentInfo: DWORD,
    pub rgTaggedContentInfo: PCMC_TAGGED_CONTENT_INFO,
    pub cTaggedOtherMsg: DWORD,
    pub rgTaggedOtherMsg: PCMC_TAGGED_OTHER_MSG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_DATA_INFO"][::std::mem::size_of::<_CMC_DATA_INFO>() - 64usize];
    ["Alignment of _CMC_DATA_INFO"][::std::mem::align_of::<_CMC_DATA_INFO>() - 8usize];
    ["Offset of field: _CMC_DATA_INFO::cTaggedAttribute"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, cTaggedAttribute) - 0usize];
    ["Offset of field: _CMC_DATA_INFO::rgTaggedAttribute"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, rgTaggedAttribute) - 8usize];
    ["Offset of field: _CMC_DATA_INFO::cTaggedRequest"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, cTaggedRequest) - 16usize];
    ["Offset of field: _CMC_DATA_INFO::rgTaggedRequest"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, rgTaggedRequest) - 24usize];
    ["Offset of field: _CMC_DATA_INFO::cTaggedContentInfo"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, cTaggedContentInfo) - 32usize];
    ["Offset of field: _CMC_DATA_INFO::rgTaggedContentInfo"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, rgTaggedContentInfo) - 40usize];
    ["Offset of field: _CMC_DATA_INFO::cTaggedOtherMsg"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, cTaggedOtherMsg) - 48usize];
    ["Offset of field: _CMC_DATA_INFO::rgTaggedOtherMsg"]
        [::std::mem::offset_of!(_CMC_DATA_INFO, rgTaggedOtherMsg) - 56usize];
};
pub type CMC_DATA_INFO = _CMC_DATA_INFO;
pub type PCMC_DATA_INFO = *mut _CMC_DATA_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_RESPONSE_INFO {
    pub cTaggedAttribute: DWORD,
    pub rgTaggedAttribute: PCMC_TAGGED_ATTRIBUTE,
    pub cTaggedContentInfo: DWORD,
    pub rgTaggedContentInfo: PCMC_TAGGED_CONTENT_INFO,
    pub cTaggedOtherMsg: DWORD,
    pub rgTaggedOtherMsg: PCMC_TAGGED_OTHER_MSG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_RESPONSE_INFO"][::std::mem::size_of::<_CMC_RESPONSE_INFO>() - 48usize];
    ["Alignment of _CMC_RESPONSE_INFO"][::std::mem::align_of::<_CMC_RESPONSE_INFO>() - 8usize];
    ["Offset of field: _CMC_RESPONSE_INFO::cTaggedAttribute"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, cTaggedAttribute) - 0usize];
    ["Offset of field: _CMC_RESPONSE_INFO::rgTaggedAttribute"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, rgTaggedAttribute) - 8usize];
    ["Offset of field: _CMC_RESPONSE_INFO::cTaggedContentInfo"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, cTaggedContentInfo) - 16usize];
    ["Offset of field: _CMC_RESPONSE_INFO::rgTaggedContentInfo"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, rgTaggedContentInfo) - 24usize];
    ["Offset of field: _CMC_RESPONSE_INFO::cTaggedOtherMsg"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, cTaggedOtherMsg) - 32usize];
    ["Offset of field: _CMC_RESPONSE_INFO::rgTaggedOtherMsg"]
        [::std::mem::offset_of!(_CMC_RESPONSE_INFO, rgTaggedOtherMsg) - 40usize];
};
pub type CMC_RESPONSE_INFO = _CMC_RESPONSE_INFO;
pub type PCMC_RESPONSE_INFO = *mut _CMC_RESPONSE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_PEND_INFO {
    pub PendToken: CRYPT_DATA_BLOB,
    pub PendTime: FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_PEND_INFO"][::std::mem::size_of::<_CMC_PEND_INFO>() - 24usize];
    ["Alignment of _CMC_PEND_INFO"][::std::mem::align_of::<_CMC_PEND_INFO>() - 8usize];
    ["Offset of field: _CMC_PEND_INFO::PendToken"]
        [::std::mem::offset_of!(_CMC_PEND_INFO, PendToken) - 0usize];
    ["Offset of field: _CMC_PEND_INFO::PendTime"]
        [::std::mem::offset_of!(_CMC_PEND_INFO, PendTime) - 16usize];
};
pub type CMC_PEND_INFO = _CMC_PEND_INFO;
pub type PCMC_PEND_INFO = *mut _CMC_PEND_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMC_STATUS_INFO {
    pub dwStatus: DWORD,
    pub cBodyList: DWORD,
    pub rgdwBodyList: *mut DWORD,
    pub pwszStatusString: LPWSTR,
    pub dwOtherInfoChoice: DWORD,
    pub __bindgen_anon_1: _CMC_STATUS_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMC_STATUS_INFO__bindgen_ty_1 {
    pub dwFailInfo: DWORD,
    pub pPendInfo: PCMC_PEND_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_STATUS_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMC_STATUS_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMC_STATUS_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMC_STATUS_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMC_STATUS_INFO__bindgen_ty_1::dwFailInfo"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO__bindgen_ty_1, dwFailInfo) - 0usize];
    ["Offset of field: _CMC_STATUS_INFO__bindgen_ty_1::pPendInfo"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO__bindgen_ty_1, pPendInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_STATUS_INFO"][::std::mem::size_of::<_CMC_STATUS_INFO>() - 40usize];
    ["Alignment of _CMC_STATUS_INFO"][::std::mem::align_of::<_CMC_STATUS_INFO>() - 8usize];
    ["Offset of field: _CMC_STATUS_INFO::dwStatus"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO, dwStatus) - 0usize];
    ["Offset of field: _CMC_STATUS_INFO::cBodyList"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO, cBodyList) - 4usize];
    ["Offset of field: _CMC_STATUS_INFO::rgdwBodyList"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO, rgdwBodyList) - 8usize];
    ["Offset of field: _CMC_STATUS_INFO::pwszStatusString"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO, pwszStatusString) - 16usize];
    ["Offset of field: _CMC_STATUS_INFO::dwOtherInfoChoice"]
        [::std::mem::offset_of!(_CMC_STATUS_INFO, dwOtherInfoChoice) - 24usize];
};
pub type CMC_STATUS_INFO = _CMC_STATUS_INFO;
pub type PCMC_STATUS_INFO = *mut _CMC_STATUS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_ADD_EXTENSIONS_INFO {
    pub dwCmcDataReference: DWORD,
    pub cCertReference: DWORD,
    pub rgdwCertReference: *mut DWORD,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_ADD_EXTENSIONS_INFO"]
        [::std::mem::size_of::<_CMC_ADD_EXTENSIONS_INFO>() - 32usize];
    ["Alignment of _CMC_ADD_EXTENSIONS_INFO"]
        [::std::mem::align_of::<_CMC_ADD_EXTENSIONS_INFO>() - 8usize];
    ["Offset of field: _CMC_ADD_EXTENSIONS_INFO::dwCmcDataReference"]
        [::std::mem::offset_of!(_CMC_ADD_EXTENSIONS_INFO, dwCmcDataReference) - 0usize];
    ["Offset of field: _CMC_ADD_EXTENSIONS_INFO::cCertReference"]
        [::std::mem::offset_of!(_CMC_ADD_EXTENSIONS_INFO, cCertReference) - 4usize];
    ["Offset of field: _CMC_ADD_EXTENSIONS_INFO::rgdwCertReference"]
        [::std::mem::offset_of!(_CMC_ADD_EXTENSIONS_INFO, rgdwCertReference) - 8usize];
    ["Offset of field: _CMC_ADD_EXTENSIONS_INFO::cExtension"]
        [::std::mem::offset_of!(_CMC_ADD_EXTENSIONS_INFO, cExtension) - 16usize];
    ["Offset of field: _CMC_ADD_EXTENSIONS_INFO::rgExtension"]
        [::std::mem::offset_of!(_CMC_ADD_EXTENSIONS_INFO, rgExtension) - 24usize];
};
pub type CMC_ADD_EXTENSIONS_INFO = _CMC_ADD_EXTENSIONS_INFO;
pub type PCMC_ADD_EXTENSIONS_INFO = *mut _CMC_ADD_EXTENSIONS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMC_ADD_ATTRIBUTES_INFO {
    pub dwCmcDataReference: DWORD,
    pub cCertReference: DWORD,
    pub rgdwCertReference: *mut DWORD,
    pub cAttribute: DWORD,
    pub rgAttribute: PCRYPT_ATTRIBUTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMC_ADD_ATTRIBUTES_INFO"]
        [::std::mem::size_of::<_CMC_ADD_ATTRIBUTES_INFO>() - 32usize];
    ["Alignment of _CMC_ADD_ATTRIBUTES_INFO"]
        [::std::mem::align_of::<_CMC_ADD_ATTRIBUTES_INFO>() - 8usize];
    ["Offset of field: _CMC_ADD_ATTRIBUTES_INFO::dwCmcDataReference"]
        [::std::mem::offset_of!(_CMC_ADD_ATTRIBUTES_INFO, dwCmcDataReference) - 0usize];
    ["Offset of field: _CMC_ADD_ATTRIBUTES_INFO::cCertReference"]
        [::std::mem::offset_of!(_CMC_ADD_ATTRIBUTES_INFO, cCertReference) - 4usize];
    ["Offset of field: _CMC_ADD_ATTRIBUTES_INFO::rgdwCertReference"]
        [::std::mem::offset_of!(_CMC_ADD_ATTRIBUTES_INFO, rgdwCertReference) - 8usize];
    ["Offset of field: _CMC_ADD_ATTRIBUTES_INFO::cAttribute"]
        [::std::mem::offset_of!(_CMC_ADD_ATTRIBUTES_INFO, cAttribute) - 16usize];
    ["Offset of field: _CMC_ADD_ATTRIBUTES_INFO::rgAttribute"]
        [::std::mem::offset_of!(_CMC_ADD_ATTRIBUTES_INFO, rgAttribute) - 24usize];
};
pub type CMC_ADD_ATTRIBUTES_INFO = _CMC_ADD_ATTRIBUTES_INFO;
pub type PCMC_ADD_ATTRIBUTES_INFO = *mut _CMC_ADD_ATTRIBUTES_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_TEMPLATE_EXT {
    pub pszObjId: LPSTR,
    pub dwMajorVersion: DWORD,
    pub fMinorVersion: BOOL,
    pub dwMinorVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_TEMPLATE_EXT"][::std::mem::size_of::<_CERT_TEMPLATE_EXT>() - 24usize];
    ["Alignment of _CERT_TEMPLATE_EXT"][::std::mem::align_of::<_CERT_TEMPLATE_EXT>() - 8usize];
    ["Offset of field: _CERT_TEMPLATE_EXT::pszObjId"]
        [::std::mem::offset_of!(_CERT_TEMPLATE_EXT, pszObjId) - 0usize];
    ["Offset of field: _CERT_TEMPLATE_EXT::dwMajorVersion"]
        [::std::mem::offset_of!(_CERT_TEMPLATE_EXT, dwMajorVersion) - 8usize];
    ["Offset of field: _CERT_TEMPLATE_EXT::fMinorVersion"]
        [::std::mem::offset_of!(_CERT_TEMPLATE_EXT, fMinorVersion) - 12usize];
    ["Offset of field: _CERT_TEMPLATE_EXT::dwMinorVersion"]
        [::std::mem::offset_of!(_CERT_TEMPLATE_EXT, dwMinorVersion) - 16usize];
};
pub type CERT_TEMPLATE_EXT = _CERT_TEMPLATE_EXT;
pub type PCERT_TEMPLATE_EXT = *mut _CERT_TEMPLATE_EXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_HASHED_URL {
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Hash: CRYPT_HASH_BLOB,
    pub pwszUrl: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_HASHED_URL"][::std::mem::size_of::<_CERT_HASHED_URL>() - 48usize];
    ["Alignment of _CERT_HASHED_URL"][::std::mem::align_of::<_CERT_HASHED_URL>() - 8usize];
    ["Offset of field: _CERT_HASHED_URL::HashAlgorithm"]
        [::std::mem::offset_of!(_CERT_HASHED_URL, HashAlgorithm) - 0usize];
    ["Offset of field: _CERT_HASHED_URL::Hash"]
        [::std::mem::offset_of!(_CERT_HASHED_URL, Hash) - 24usize];
    ["Offset of field: _CERT_HASHED_URL::pwszUrl"]
        [::std::mem::offset_of!(_CERT_HASHED_URL, pwszUrl) - 40usize];
};
pub type CERT_HASHED_URL = _CERT_HASHED_URL;
pub type PCERT_HASHED_URL = *mut _CERT_HASHED_URL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_DETAILS {
    pub pwszMimeType: LPWSTR,
    pub cHashedUrl: DWORD,
    pub rgHashedUrl: PCERT_HASHED_URL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_DETAILS"][::std::mem::size_of::<_CERT_LOGOTYPE_DETAILS>() - 24usize];
    ["Alignment of _CERT_LOGOTYPE_DETAILS"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_DETAILS>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_DETAILS::pwszMimeType"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DETAILS, pwszMimeType) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_DETAILS::cHashedUrl"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DETAILS, cHashedUrl) - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_DETAILS::rgHashedUrl"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DETAILS, rgHashedUrl) - 16usize];
};
pub type CERT_LOGOTYPE_DETAILS = _CERT_LOGOTYPE_DETAILS;
pub type PCERT_LOGOTYPE_DETAILS = *mut _CERT_LOGOTYPE_DETAILS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_REFERENCE {
    pub cHashedUrl: DWORD,
    pub rgHashedUrl: PCERT_HASHED_URL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_REFERENCE"]
        [::std::mem::size_of::<_CERT_LOGOTYPE_REFERENCE>() - 16usize];
    ["Alignment of _CERT_LOGOTYPE_REFERENCE"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_REFERENCE>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_REFERENCE::cHashedUrl"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_REFERENCE, cHashedUrl) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_REFERENCE::rgHashedUrl"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_REFERENCE, rgHashedUrl) - 8usize];
};
pub type CERT_LOGOTYPE_REFERENCE = _CERT_LOGOTYPE_REFERENCE;
pub type PCERT_LOGOTYPE_REFERENCE = *mut _CERT_LOGOTYPE_REFERENCE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_LOGOTYPE_IMAGE_INFO {
    pub dwLogotypeImageInfoChoice: DWORD,
    pub dwFileSize: DWORD,
    pub dwXSize: DWORD,
    pub dwYSize: DWORD,
    pub dwLogotypeImageResolutionChoice: DWORD,
    pub __bindgen_anon_1: _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1,
    pub pwszLanguage: LPWSTR,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1 {
    pub dwNumBits: DWORD,
    pub dwTableSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1::dwNumBits"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1, dwNumBits) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1::dwTableSize"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO__bindgen_ty_1, dwTableSize) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_IMAGE_INFO"]
        [::std::mem::size_of::<_CERT_LOGOTYPE_IMAGE_INFO>() - 32usize];
    ["Alignment of _CERT_LOGOTYPE_IMAGE_INFO"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_IMAGE_INFO>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::dwLogotypeImageInfoChoice"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO, dwLogotypeImageInfoChoice) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::dwFileSize"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO, dwFileSize) - 4usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::dwXSize"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO, dwXSize) - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::dwYSize"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO, dwYSize) - 12usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::dwLogotypeImageResolutionChoice"][::std::mem::offset_of!(
        _CERT_LOGOTYPE_IMAGE_INFO,
        dwLogotypeImageResolutionChoice
    ) - 16usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE_INFO::pwszLanguage"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE_INFO, pwszLanguage) - 24usize];
};
pub type CERT_LOGOTYPE_IMAGE_INFO = _CERT_LOGOTYPE_IMAGE_INFO;
pub type PCERT_LOGOTYPE_IMAGE_INFO = *mut _CERT_LOGOTYPE_IMAGE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_IMAGE {
    pub LogotypeDetails: CERT_LOGOTYPE_DETAILS,
    pub pLogotypeImageInfo: PCERT_LOGOTYPE_IMAGE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_IMAGE"][::std::mem::size_of::<_CERT_LOGOTYPE_IMAGE>() - 32usize];
    ["Alignment of _CERT_LOGOTYPE_IMAGE"][::std::mem::align_of::<_CERT_LOGOTYPE_IMAGE>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE::LogotypeDetails"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE, LogotypeDetails) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_IMAGE::pLogotypeImageInfo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_IMAGE, pLogotypeImageInfo) - 24usize];
};
pub type CERT_LOGOTYPE_IMAGE = _CERT_LOGOTYPE_IMAGE;
pub type PCERT_LOGOTYPE_IMAGE = *mut _CERT_LOGOTYPE_IMAGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_AUDIO_INFO {
    pub dwFileSize: DWORD,
    pub dwPlayTime: DWORD,
    pub dwChannels: DWORD,
    pub dwSampleRate: DWORD,
    pub pwszLanguage: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_AUDIO_INFO"]
        [::std::mem::size_of::<_CERT_LOGOTYPE_AUDIO_INFO>() - 24usize];
    ["Alignment of _CERT_LOGOTYPE_AUDIO_INFO"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_AUDIO_INFO>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO_INFO::dwFileSize"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO_INFO, dwFileSize) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO_INFO::dwPlayTime"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO_INFO, dwPlayTime) - 4usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO_INFO::dwChannels"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO_INFO, dwChannels) - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO_INFO::dwSampleRate"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO_INFO, dwSampleRate) - 12usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO_INFO::pwszLanguage"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO_INFO, pwszLanguage) - 16usize];
};
pub type CERT_LOGOTYPE_AUDIO_INFO = _CERT_LOGOTYPE_AUDIO_INFO;
pub type PCERT_LOGOTYPE_AUDIO_INFO = *mut _CERT_LOGOTYPE_AUDIO_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_AUDIO {
    pub LogotypeDetails: CERT_LOGOTYPE_DETAILS,
    pub pLogotypeAudioInfo: PCERT_LOGOTYPE_AUDIO_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_AUDIO"][::std::mem::size_of::<_CERT_LOGOTYPE_AUDIO>() - 32usize];
    ["Alignment of _CERT_LOGOTYPE_AUDIO"][::std::mem::align_of::<_CERT_LOGOTYPE_AUDIO>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO::LogotypeDetails"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO, LogotypeDetails) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_AUDIO::pLogotypeAudioInfo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_AUDIO, pLogotypeAudioInfo) - 24usize];
};
pub type CERT_LOGOTYPE_AUDIO = _CERT_LOGOTYPE_AUDIO;
pub type PCERT_LOGOTYPE_AUDIO = *mut _CERT_LOGOTYPE_AUDIO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_DATA {
    pub cLogotypeImage: DWORD,
    pub rgLogotypeImage: PCERT_LOGOTYPE_IMAGE,
    pub cLogotypeAudio: DWORD,
    pub rgLogotypeAudio: PCERT_LOGOTYPE_AUDIO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_DATA"][::std::mem::size_of::<_CERT_LOGOTYPE_DATA>() - 32usize];
    ["Alignment of _CERT_LOGOTYPE_DATA"][::std::mem::align_of::<_CERT_LOGOTYPE_DATA>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_DATA::cLogotypeImage"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DATA, cLogotypeImage) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_DATA::rgLogotypeImage"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DATA, rgLogotypeImage) - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_DATA::cLogotypeAudio"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DATA, cLogotypeAudio) - 16usize];
    ["Offset of field: _CERT_LOGOTYPE_DATA::rgLogotypeAudio"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_DATA, rgLogotypeAudio) - 24usize];
};
pub type CERT_LOGOTYPE_DATA = _CERT_LOGOTYPE_DATA;
pub type PCERT_LOGOTYPE_DATA = *mut _CERT_LOGOTYPE_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_LOGOTYPE_INFO {
    pub dwLogotypeInfoChoice: DWORD,
    pub __bindgen_anon_1: _CERT_LOGOTYPE_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_LOGOTYPE_INFO__bindgen_ty_1 {
    pub pLogotypeDirectInfo: PCERT_LOGOTYPE_DATA,
    pub pLogotypeIndirectInfo: PCERT_LOGOTYPE_REFERENCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_LOGOTYPE_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CERT_LOGOTYPE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_INFO__bindgen_ty_1::pLogotypeDirectInfo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_INFO__bindgen_ty_1, pLogotypeDirectInfo) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_INFO__bindgen_ty_1::pLogotypeIndirectInfo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_INFO__bindgen_ty_1, pLogotypeIndirectInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_INFO"][::std::mem::size_of::<_CERT_LOGOTYPE_INFO>() - 16usize];
    ["Alignment of _CERT_LOGOTYPE_INFO"][::std::mem::align_of::<_CERT_LOGOTYPE_INFO>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_INFO::dwLogotypeInfoChoice"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_INFO, dwLogotypeInfoChoice) - 0usize];
};
pub type CERT_LOGOTYPE_INFO = _CERT_LOGOTYPE_INFO;
pub type PCERT_LOGOTYPE_INFO = *mut _CERT_LOGOTYPE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_OTHER_LOGOTYPE_INFO {
    pub pszObjId: LPSTR,
    pub LogotypeInfo: CERT_LOGOTYPE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_OTHER_LOGOTYPE_INFO"]
        [::std::mem::size_of::<_CERT_OTHER_LOGOTYPE_INFO>() - 24usize];
    ["Alignment of _CERT_OTHER_LOGOTYPE_INFO"]
        [::std::mem::align_of::<_CERT_OTHER_LOGOTYPE_INFO>() - 8usize];
    ["Offset of field: _CERT_OTHER_LOGOTYPE_INFO::pszObjId"]
        [::std::mem::offset_of!(_CERT_OTHER_LOGOTYPE_INFO, pszObjId) - 0usize];
    ["Offset of field: _CERT_OTHER_LOGOTYPE_INFO::LogotypeInfo"]
        [::std::mem::offset_of!(_CERT_OTHER_LOGOTYPE_INFO, LogotypeInfo) - 8usize];
};
pub type CERT_OTHER_LOGOTYPE_INFO = _CERT_OTHER_LOGOTYPE_INFO;
pub type PCERT_OTHER_LOGOTYPE_INFO = *mut _CERT_OTHER_LOGOTYPE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LOGOTYPE_EXT_INFO {
    pub cCommunityLogo: DWORD,
    pub rgCommunityLogo: PCERT_LOGOTYPE_INFO,
    pub pIssuerLogo: PCERT_LOGOTYPE_INFO,
    pub pSubjectLogo: PCERT_LOGOTYPE_INFO,
    pub cOtherLogo: DWORD,
    pub rgOtherLogo: PCERT_OTHER_LOGOTYPE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LOGOTYPE_EXT_INFO"][::std::mem::size_of::<_CERT_LOGOTYPE_EXT_INFO>() - 48usize];
    ["Alignment of _CERT_LOGOTYPE_EXT_INFO"]
        [::std::mem::align_of::<_CERT_LOGOTYPE_EXT_INFO>() - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::cCommunityLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, cCommunityLogo) - 0usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::rgCommunityLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, rgCommunityLogo) - 8usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::pIssuerLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, pIssuerLogo) - 16usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::pSubjectLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, pSubjectLogo) - 24usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::cOtherLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, cOtherLogo) - 32usize];
    ["Offset of field: _CERT_LOGOTYPE_EXT_INFO::rgOtherLogo"]
        [::std::mem::offset_of!(_CERT_LOGOTYPE_EXT_INFO, rgOtherLogo) - 40usize];
};
pub type CERT_LOGOTYPE_EXT_INFO = _CERT_LOGOTYPE_EXT_INFO;
pub type PCERT_LOGOTYPE_EXT_INFO = *mut _CERT_LOGOTYPE_EXT_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_BIOMETRIC_DATA {
    pub dwTypeOfBiometricDataChoice: DWORD,
    pub __bindgen_anon_1: _CERT_BIOMETRIC_DATA__bindgen_ty_1,
    pub HashedUrl: CERT_HASHED_URL,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_BIOMETRIC_DATA__bindgen_ty_1 {
    pub dwPredefined: DWORD,
    pub pszObjId: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_BIOMETRIC_DATA__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_BIOMETRIC_DATA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CERT_BIOMETRIC_DATA__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_BIOMETRIC_DATA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_BIOMETRIC_DATA__bindgen_ty_1::dwPredefined"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_DATA__bindgen_ty_1, dwPredefined) - 0usize];
    ["Offset of field: _CERT_BIOMETRIC_DATA__bindgen_ty_1::pszObjId"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_DATA__bindgen_ty_1, pszObjId) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_BIOMETRIC_DATA"][::std::mem::size_of::<_CERT_BIOMETRIC_DATA>() - 64usize];
    ["Alignment of _CERT_BIOMETRIC_DATA"][::std::mem::align_of::<_CERT_BIOMETRIC_DATA>() - 8usize];
    ["Offset of field: _CERT_BIOMETRIC_DATA::dwTypeOfBiometricDataChoice"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_DATA, dwTypeOfBiometricDataChoice) - 0usize];
    ["Offset of field: _CERT_BIOMETRIC_DATA::HashedUrl"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_DATA, HashedUrl) - 16usize];
};
pub type CERT_BIOMETRIC_DATA = _CERT_BIOMETRIC_DATA;
pub type PCERT_BIOMETRIC_DATA = *mut _CERT_BIOMETRIC_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_BIOMETRIC_EXT_INFO {
    pub cBiometricData: DWORD,
    pub rgBiometricData: PCERT_BIOMETRIC_DATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_BIOMETRIC_EXT_INFO"]
        [::std::mem::size_of::<_CERT_BIOMETRIC_EXT_INFO>() - 16usize];
    ["Alignment of _CERT_BIOMETRIC_EXT_INFO"]
        [::std::mem::align_of::<_CERT_BIOMETRIC_EXT_INFO>() - 8usize];
    ["Offset of field: _CERT_BIOMETRIC_EXT_INFO::cBiometricData"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_EXT_INFO, cBiometricData) - 0usize];
    ["Offset of field: _CERT_BIOMETRIC_EXT_INFO::rgBiometricData"]
        [::std::mem::offset_of!(_CERT_BIOMETRIC_EXT_INFO, rgBiometricData) - 8usize];
};
pub type CERT_BIOMETRIC_EXT_INFO = _CERT_BIOMETRIC_EXT_INFO;
pub type PCERT_BIOMETRIC_EXT_INFO = *mut _CERT_BIOMETRIC_EXT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_SIGNATURE_INFO {
    pub SignatureAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub Signature: CRYPT_BIT_BLOB,
    pub cCertEncoded: DWORD,
    pub rgCertEncoded: PCERT_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_SIGNATURE_INFO"][::std::mem::size_of::<_OCSP_SIGNATURE_INFO>() - 64usize];
    ["Alignment of _OCSP_SIGNATURE_INFO"][::std::mem::align_of::<_OCSP_SIGNATURE_INFO>() - 8usize];
    ["Offset of field: _OCSP_SIGNATURE_INFO::SignatureAlgorithm"]
        [::std::mem::offset_of!(_OCSP_SIGNATURE_INFO, SignatureAlgorithm) - 0usize];
    ["Offset of field: _OCSP_SIGNATURE_INFO::Signature"]
        [::std::mem::offset_of!(_OCSP_SIGNATURE_INFO, Signature) - 24usize];
    ["Offset of field: _OCSP_SIGNATURE_INFO::cCertEncoded"]
        [::std::mem::offset_of!(_OCSP_SIGNATURE_INFO, cCertEncoded) - 48usize];
    ["Offset of field: _OCSP_SIGNATURE_INFO::rgCertEncoded"]
        [::std::mem::offset_of!(_OCSP_SIGNATURE_INFO, rgCertEncoded) - 56usize];
};
pub type OCSP_SIGNATURE_INFO = _OCSP_SIGNATURE_INFO;
pub type POCSP_SIGNATURE_INFO = *mut _OCSP_SIGNATURE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_SIGNED_REQUEST_INFO {
    pub ToBeSigned: CRYPT_DER_BLOB,
    pub pOptionalSignatureInfo: POCSP_SIGNATURE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_SIGNED_REQUEST_INFO"]
        [::std::mem::size_of::<_OCSP_SIGNED_REQUEST_INFO>() - 24usize];
    ["Alignment of _OCSP_SIGNED_REQUEST_INFO"]
        [::std::mem::align_of::<_OCSP_SIGNED_REQUEST_INFO>() - 8usize];
    ["Offset of field: _OCSP_SIGNED_REQUEST_INFO::ToBeSigned"]
        [::std::mem::offset_of!(_OCSP_SIGNED_REQUEST_INFO, ToBeSigned) - 0usize];
    ["Offset of field: _OCSP_SIGNED_REQUEST_INFO::pOptionalSignatureInfo"]
        [::std::mem::offset_of!(_OCSP_SIGNED_REQUEST_INFO, pOptionalSignatureInfo) - 16usize];
};
pub type OCSP_SIGNED_REQUEST_INFO = _OCSP_SIGNED_REQUEST_INFO;
pub type POCSP_SIGNED_REQUEST_INFO = *mut _OCSP_SIGNED_REQUEST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_CERT_ID {
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub IssuerNameHash: CRYPT_HASH_BLOB,
    pub IssuerKeyHash: CRYPT_HASH_BLOB,
    pub SerialNumber: CRYPT_INTEGER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_CERT_ID"][::std::mem::size_of::<_OCSP_CERT_ID>() - 72usize];
    ["Alignment of _OCSP_CERT_ID"][::std::mem::align_of::<_OCSP_CERT_ID>() - 8usize];
    ["Offset of field: _OCSP_CERT_ID::HashAlgorithm"]
        [::std::mem::offset_of!(_OCSP_CERT_ID, HashAlgorithm) - 0usize];
    ["Offset of field: _OCSP_CERT_ID::IssuerNameHash"]
        [::std::mem::offset_of!(_OCSP_CERT_ID, IssuerNameHash) - 24usize];
    ["Offset of field: _OCSP_CERT_ID::IssuerKeyHash"]
        [::std::mem::offset_of!(_OCSP_CERT_ID, IssuerKeyHash) - 40usize];
    ["Offset of field: _OCSP_CERT_ID::SerialNumber"]
        [::std::mem::offset_of!(_OCSP_CERT_ID, SerialNumber) - 56usize];
};
pub type OCSP_CERT_ID = _OCSP_CERT_ID;
pub type POCSP_CERT_ID = *mut _OCSP_CERT_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_REQUEST_ENTRY {
    pub CertId: OCSP_CERT_ID,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_REQUEST_ENTRY"][::std::mem::size_of::<_OCSP_REQUEST_ENTRY>() - 88usize];
    ["Alignment of _OCSP_REQUEST_ENTRY"][::std::mem::align_of::<_OCSP_REQUEST_ENTRY>() - 8usize];
    ["Offset of field: _OCSP_REQUEST_ENTRY::CertId"]
        [::std::mem::offset_of!(_OCSP_REQUEST_ENTRY, CertId) - 0usize];
    ["Offset of field: _OCSP_REQUEST_ENTRY::cExtension"]
        [::std::mem::offset_of!(_OCSP_REQUEST_ENTRY, cExtension) - 72usize];
    ["Offset of field: _OCSP_REQUEST_ENTRY::rgExtension"]
        [::std::mem::offset_of!(_OCSP_REQUEST_ENTRY, rgExtension) - 80usize];
};
pub type OCSP_REQUEST_ENTRY = _OCSP_REQUEST_ENTRY;
pub type POCSP_REQUEST_ENTRY = *mut _OCSP_REQUEST_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_REQUEST_INFO {
    pub dwVersion: DWORD,
    pub pRequestorName: PCERT_ALT_NAME_ENTRY,
    pub cRequestEntry: DWORD,
    pub rgRequestEntry: POCSP_REQUEST_ENTRY,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_REQUEST_INFO"][::std::mem::size_of::<_OCSP_REQUEST_INFO>() - 48usize];
    ["Alignment of _OCSP_REQUEST_INFO"][::std::mem::align_of::<_OCSP_REQUEST_INFO>() - 8usize];
    ["Offset of field: _OCSP_REQUEST_INFO::dwVersion"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, dwVersion) - 0usize];
    ["Offset of field: _OCSP_REQUEST_INFO::pRequestorName"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, pRequestorName) - 8usize];
    ["Offset of field: _OCSP_REQUEST_INFO::cRequestEntry"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, cRequestEntry) - 16usize];
    ["Offset of field: _OCSP_REQUEST_INFO::rgRequestEntry"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, rgRequestEntry) - 24usize];
    ["Offset of field: _OCSP_REQUEST_INFO::cExtension"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, cExtension) - 32usize];
    ["Offset of field: _OCSP_REQUEST_INFO::rgExtension"]
        [::std::mem::offset_of!(_OCSP_REQUEST_INFO, rgExtension) - 40usize];
};
pub type OCSP_REQUEST_INFO = _OCSP_REQUEST_INFO;
pub type POCSP_REQUEST_INFO = *mut _OCSP_REQUEST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_RESPONSE_INFO {
    pub dwStatus: DWORD,
    pub pszObjId: LPSTR,
    pub Value: CRYPT_OBJID_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_RESPONSE_INFO"][::std::mem::size_of::<_OCSP_RESPONSE_INFO>() - 32usize];
    ["Alignment of _OCSP_RESPONSE_INFO"][::std::mem::align_of::<_OCSP_RESPONSE_INFO>() - 8usize];
    ["Offset of field: _OCSP_RESPONSE_INFO::dwStatus"]
        [::std::mem::offset_of!(_OCSP_RESPONSE_INFO, dwStatus) - 0usize];
    ["Offset of field: _OCSP_RESPONSE_INFO::pszObjId"]
        [::std::mem::offset_of!(_OCSP_RESPONSE_INFO, pszObjId) - 8usize];
    ["Offset of field: _OCSP_RESPONSE_INFO::Value"]
        [::std::mem::offset_of!(_OCSP_RESPONSE_INFO, Value) - 16usize];
};
pub type OCSP_RESPONSE_INFO = _OCSP_RESPONSE_INFO;
pub type POCSP_RESPONSE_INFO = *mut _OCSP_RESPONSE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_BASIC_SIGNED_RESPONSE_INFO {
    pub ToBeSigned: CRYPT_DER_BLOB,
    pub SignatureInfo: OCSP_SIGNATURE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_SIGNED_RESPONSE_INFO"]
        [::std::mem::size_of::<_OCSP_BASIC_SIGNED_RESPONSE_INFO>() - 80usize];
    ["Alignment of _OCSP_BASIC_SIGNED_RESPONSE_INFO"]
        [::std::mem::align_of::<_OCSP_BASIC_SIGNED_RESPONSE_INFO>() - 8usize];
    ["Offset of field: _OCSP_BASIC_SIGNED_RESPONSE_INFO::ToBeSigned"]
        [::std::mem::offset_of!(_OCSP_BASIC_SIGNED_RESPONSE_INFO, ToBeSigned) - 0usize];
    ["Offset of field: _OCSP_BASIC_SIGNED_RESPONSE_INFO::SignatureInfo"]
        [::std::mem::offset_of!(_OCSP_BASIC_SIGNED_RESPONSE_INFO, SignatureInfo) - 16usize];
};
pub type OCSP_BASIC_SIGNED_RESPONSE_INFO = _OCSP_BASIC_SIGNED_RESPONSE_INFO;
pub type POCSP_BASIC_SIGNED_RESPONSE_INFO = *mut _OCSP_BASIC_SIGNED_RESPONSE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OCSP_BASIC_REVOKED_INFO {
    pub RevocationDate: FILETIME,
    pub dwCrlReasonCode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_REVOKED_INFO"]
        [::std::mem::size_of::<_OCSP_BASIC_REVOKED_INFO>() - 12usize];
    ["Alignment of _OCSP_BASIC_REVOKED_INFO"]
        [::std::mem::align_of::<_OCSP_BASIC_REVOKED_INFO>() - 4usize];
    ["Offset of field: _OCSP_BASIC_REVOKED_INFO::RevocationDate"]
        [::std::mem::offset_of!(_OCSP_BASIC_REVOKED_INFO, RevocationDate) - 0usize];
    ["Offset of field: _OCSP_BASIC_REVOKED_INFO::dwCrlReasonCode"]
        [::std::mem::offset_of!(_OCSP_BASIC_REVOKED_INFO, dwCrlReasonCode) - 8usize];
};
pub type OCSP_BASIC_REVOKED_INFO = _OCSP_BASIC_REVOKED_INFO;
pub type POCSP_BASIC_REVOKED_INFO = *mut _OCSP_BASIC_REVOKED_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _OCSP_BASIC_RESPONSE_ENTRY {
    pub CertId: OCSP_CERT_ID,
    pub dwCertStatus: DWORD,
    pub __bindgen_anon_1: _OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1,
    pub ThisUpdate: FILETIME,
    pub NextUpdate: FILETIME,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1 {
    pub pRevokedInfo: POCSP_BASIC_REVOKED_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1>() - 8usize];
    ["Alignment of _OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1::pRevokedInfo"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY__bindgen_ty_1, pRevokedInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_RESPONSE_ENTRY"]
        [::std::mem::size_of::<_OCSP_BASIC_RESPONSE_ENTRY>() - 120usize];
    ["Alignment of _OCSP_BASIC_RESPONSE_ENTRY"]
        [::std::mem::align_of::<_OCSP_BASIC_RESPONSE_ENTRY>() - 8usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::CertId"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, CertId) - 0usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::dwCertStatus"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, dwCertStatus) - 72usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::ThisUpdate"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, ThisUpdate) - 88usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::NextUpdate"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, NextUpdate) - 96usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::cExtension"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, cExtension) - 104usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_ENTRY::rgExtension"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_ENTRY, rgExtension) - 112usize];
};
pub type OCSP_BASIC_RESPONSE_ENTRY = _OCSP_BASIC_RESPONSE_ENTRY;
pub type POCSP_BASIC_RESPONSE_ENTRY = *mut _OCSP_BASIC_RESPONSE_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _OCSP_BASIC_RESPONSE_INFO {
    pub dwVersion: DWORD,
    pub dwResponderIdChoice: DWORD,
    pub __bindgen_anon_1: _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1,
    pub ProducedAt: FILETIME,
    pub cResponseEntry: DWORD,
    pub rgResponseEntry: POCSP_BASIC_RESPONSE_ENTRY,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1 {
    pub ByNameResponderId: CERT_NAME_BLOB,
    pub ByKeyResponderId: CRYPT_HASH_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1>() - 16usize];
    ["Alignment of _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1::ByNameResponderId"][::std::mem::offset_of!(
        _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1,
        ByNameResponderId
    ) - 0usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1::ByKeyResponderId"][::std::mem::offset_of!(
        _OCSP_BASIC_RESPONSE_INFO__bindgen_ty_1,
        ByKeyResponderId
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OCSP_BASIC_RESPONSE_INFO"]
        [::std::mem::size_of::<_OCSP_BASIC_RESPONSE_INFO>() - 64usize];
    ["Alignment of _OCSP_BASIC_RESPONSE_INFO"]
        [::std::mem::align_of::<_OCSP_BASIC_RESPONSE_INFO>() - 8usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::dwVersion"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, dwVersion) - 0usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::dwResponderIdChoice"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, dwResponderIdChoice) - 4usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::ProducedAt"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, ProducedAt) - 24usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::cResponseEntry"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, cResponseEntry) - 32usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::rgResponseEntry"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, rgResponseEntry) - 40usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::cExtension"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, cExtension) - 48usize];
    ["Offset of field: _OCSP_BASIC_RESPONSE_INFO::rgExtension"]
        [::std::mem::offset_of!(_OCSP_BASIC_RESPONSE_INFO, rgExtension) - 56usize];
};
pub type OCSP_BASIC_RESPONSE_INFO = _OCSP_BASIC_RESPONSE_INFO;
pub type POCSP_BASIC_RESPONSE_INFO = *mut _OCSP_BASIC_RESPONSE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SUPPORTED_ALGORITHM_INFO {
    pub Algorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub IntendedKeyUsage: CRYPT_BIT_BLOB,
    pub IntendedCertPolicies: CERT_POLICIES_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SUPPORTED_ALGORITHM_INFO"]
        [::std::mem::size_of::<_CERT_SUPPORTED_ALGORITHM_INFO>() - 64usize];
    ["Alignment of _CERT_SUPPORTED_ALGORITHM_INFO"]
        [::std::mem::align_of::<_CERT_SUPPORTED_ALGORITHM_INFO>() - 8usize];
    ["Offset of field: _CERT_SUPPORTED_ALGORITHM_INFO::Algorithm"]
        [::std::mem::offset_of!(_CERT_SUPPORTED_ALGORITHM_INFO, Algorithm) - 0usize];
    ["Offset of field: _CERT_SUPPORTED_ALGORITHM_INFO::IntendedKeyUsage"]
        [::std::mem::offset_of!(_CERT_SUPPORTED_ALGORITHM_INFO, IntendedKeyUsage) - 24usize];
    ["Offset of field: _CERT_SUPPORTED_ALGORITHM_INFO::IntendedCertPolicies"]
        [::std::mem::offset_of!(_CERT_SUPPORTED_ALGORITHM_INFO, IntendedCertPolicies) - 48usize];
};
pub type CERT_SUPPORTED_ALGORITHM_INFO = _CERT_SUPPORTED_ALGORITHM_INFO;
pub type PCERT_SUPPORTED_ALGORITHM_INFO = *mut _CERT_SUPPORTED_ALGORITHM_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_TPM_SPECIFICATION_INFO {
    pub pwszFamily: LPWSTR,
    pub dwLevel: DWORD,
    pub dwRevision: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_TPM_SPECIFICATION_INFO"]
        [::std::mem::size_of::<_CERT_TPM_SPECIFICATION_INFO>() - 16usize];
    ["Alignment of _CERT_TPM_SPECIFICATION_INFO"]
        [::std::mem::align_of::<_CERT_TPM_SPECIFICATION_INFO>() - 8usize];
    ["Offset of field: _CERT_TPM_SPECIFICATION_INFO::pwszFamily"]
        [::std::mem::offset_of!(_CERT_TPM_SPECIFICATION_INFO, pwszFamily) - 0usize];
    ["Offset of field: _CERT_TPM_SPECIFICATION_INFO::dwLevel"]
        [::std::mem::offset_of!(_CERT_TPM_SPECIFICATION_INFO, dwLevel) - 8usize];
    ["Offset of field: _CERT_TPM_SPECIFICATION_INFO::dwRevision"]
        [::std::mem::offset_of!(_CERT_TPM_SPECIFICATION_INFO, dwRevision) - 12usize];
};
pub type CERT_TPM_SPECIFICATION_INFO = _CERT_TPM_SPECIFICATION_INFO;
pub type PCERT_TPM_SPECIFICATION_INFO = *mut _CERT_TPM_SPECIFICATION_INFO;
pub type HCRYPTOIDFUNCSET = *mut ::std::os::raw::c_void;
pub type HCRYPTOIDFUNCADDR = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_OID_FUNC_ENTRY {
    pub pszOID: LPCSTR,
    pub pvFuncAddr: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_OID_FUNC_ENTRY"][::std::mem::size_of::<_CRYPT_OID_FUNC_ENTRY>() - 16usize];
    ["Alignment of _CRYPT_OID_FUNC_ENTRY"]
        [::std::mem::align_of::<_CRYPT_OID_FUNC_ENTRY>() - 8usize];
    ["Offset of field: _CRYPT_OID_FUNC_ENTRY::pszOID"]
        [::std::mem::offset_of!(_CRYPT_OID_FUNC_ENTRY, pszOID) - 0usize];
    ["Offset of field: _CRYPT_OID_FUNC_ENTRY::pvFuncAddr"]
        [::std::mem::offset_of!(_CRYPT_OID_FUNC_ENTRY, pvFuncAddr) - 8usize];
};
pub type CRYPT_OID_FUNC_ENTRY = _CRYPT_OID_FUNC_ENTRY;
pub type PCRYPT_OID_FUNC_ENTRY = *mut _CRYPT_OID_FUNC_ENTRY;
unsafe extern "C" {
    pub fn CryptInstallOIDFunctionAddress(
        hModule: HMODULE,
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        cFuncEntry: DWORD,
        rgFuncEntry: *const CRYPT_OID_FUNC_ENTRY,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptInitOIDFunctionSet(pszFuncName: LPCSTR, dwFlags: DWORD) -> HCRYPTOIDFUNCSET;
}
unsafe extern "C" {
    pub fn CryptGetOIDFunctionAddress(
        hFuncSet: HCRYPTOIDFUNCSET,
        dwEncodingType: DWORD,
        pszOID: LPCSTR,
        dwFlags: DWORD,
        ppvFuncAddr: *mut *mut ::std::os::raw::c_void,
        phFuncAddr: *mut HCRYPTOIDFUNCADDR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetDefaultOIDDllList(
        hFuncSet: HCRYPTOIDFUNCSET,
        dwEncodingType: DWORD,
        pwszDllList: *mut WCHAR,
        pcchDllList: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetDefaultOIDFunctionAddress(
        hFuncSet: HCRYPTOIDFUNCSET,
        dwEncodingType: DWORD,
        pwszDll: LPCWSTR,
        dwFlags: DWORD,
        ppvFuncAddr: *mut *mut ::std::os::raw::c_void,
        phFuncAddr: *mut HCRYPTOIDFUNCADDR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptFreeOIDFunctionAddress(hFuncAddr: HCRYPTOIDFUNCADDR, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptRegisterOIDFunction(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
        pwszDll: LPCWSTR,
        pszOverrideFuncName: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnregisterOIDFunction(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptRegisterDefaultOIDFunction(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        dwIndex: DWORD,
        pwszDll: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnregisterDefaultOIDFunction(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pwszDll: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetOIDFunctionValue(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
        pwszValueName: LPCWSTR,
        dwValueType: DWORD,
        pbValueData: *const BYTE,
        cbValueData: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetOIDFunctionValue(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
        pwszValueName: LPCWSTR,
        pdwValueType: *mut DWORD,
        pbValueData: *mut BYTE,
        pcbValueData: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CRYPT_ENUM_OID_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
        cValue: DWORD,
        rgdwValueType: *const DWORD,
        rgpwszValueName: *const LPCWSTR,
        rgpbValueData: *const *const BYTE,
        rgcbValueData: *const DWORD,
        pvArg: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptEnumOIDFunction(
        dwEncodingType: DWORD,
        pszFuncName: LPCSTR,
        pszOID: LPCSTR,
        dwFlags: DWORD,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnumOIDFunc: PFN_CRYPT_ENUM_OID_FUNC,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CRYPT_OID_INFO {
    pub cbSize: DWORD,
    pub pszOID: LPCSTR,
    pub pwszName: LPCWSTR,
    pub dwGroupId: DWORD,
    pub __bindgen_anon_1: _CRYPT_OID_INFO__bindgen_ty_1,
    pub ExtraInfo: CRYPT_DATA_BLOB,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CRYPT_OID_INFO__bindgen_ty_1 {
    pub dwValue: DWORD,
    pub Algid: ALG_ID,
    pub dwLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_OID_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CRYPT_OID_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _CRYPT_OID_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CRYPT_OID_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _CRYPT_OID_INFO__bindgen_ty_1::dwValue"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO__bindgen_ty_1, dwValue) - 0usize];
    ["Offset of field: _CRYPT_OID_INFO__bindgen_ty_1::Algid"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO__bindgen_ty_1, Algid) - 0usize];
    ["Offset of field: _CRYPT_OID_INFO__bindgen_ty_1::dwLength"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO__bindgen_ty_1, dwLength) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_OID_INFO"][::std::mem::size_of::<_CRYPT_OID_INFO>() - 48usize];
    ["Alignment of _CRYPT_OID_INFO"][::std::mem::align_of::<_CRYPT_OID_INFO>() - 8usize];
    ["Offset of field: _CRYPT_OID_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPT_OID_INFO::pszOID"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO, pszOID) - 8usize];
    ["Offset of field: _CRYPT_OID_INFO::pwszName"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO, pwszName) - 16usize];
    ["Offset of field: _CRYPT_OID_INFO::dwGroupId"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO, dwGroupId) - 24usize];
    ["Offset of field: _CRYPT_OID_INFO::ExtraInfo"]
        [::std::mem::offset_of!(_CRYPT_OID_INFO, ExtraInfo) - 32usize];
};
pub type CRYPT_OID_INFO = _CRYPT_OID_INFO;
pub type PCRYPT_OID_INFO = *mut _CRYPT_OID_INFO;
pub type CCRYPT_OID_INFO = CRYPT_OID_INFO;
pub type PCCRYPT_OID_INFO = *const CRYPT_OID_INFO;
unsafe extern "C" {
    pub fn CryptFindOIDInfo(
        dwKeyType: DWORD,
        pvKey: *mut ::std::os::raw::c_void,
        dwGroupId: DWORD,
    ) -> PCCRYPT_OID_INFO;
}
unsafe extern "C" {
    pub fn CryptRegisterOIDInfo(pInfo: PCCRYPT_OID_INFO, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnregisterOIDInfo(pInfo: PCCRYPT_OID_INFO) -> BOOL;
}
pub type PFN_CRYPT_ENUM_OID_INFO = ::std::option::Option<
    unsafe extern "C" fn(pInfo: PCCRYPT_OID_INFO, pvArg: *mut ::std::os::raw::c_void) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptEnumOIDInfo(
        dwGroupId: DWORD,
        dwFlags: DWORD,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnumOIDInfo: PFN_CRYPT_ENUM_OID_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptFindLocalizedName(pwszCryptName: LPCWSTR) -> LPCWSTR;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_STRONG_SIGN_SERIALIZED_INFO {
    pub dwFlags: DWORD,
    pub pwszCNGSignHashAlgids: LPWSTR,
    pub pwszCNGPubKeyMinBitLengths: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_STRONG_SIGN_SERIALIZED_INFO"]
        [::std::mem::size_of::<_CERT_STRONG_SIGN_SERIALIZED_INFO>() - 24usize];
    ["Alignment of _CERT_STRONG_SIGN_SERIALIZED_INFO"]
        [::std::mem::align_of::<_CERT_STRONG_SIGN_SERIALIZED_INFO>() - 8usize];
    ["Offset of field: _CERT_STRONG_SIGN_SERIALIZED_INFO::dwFlags"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_SERIALIZED_INFO, dwFlags) - 0usize];
    ["Offset of field: _CERT_STRONG_SIGN_SERIALIZED_INFO::pwszCNGSignHashAlgids"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_SERIALIZED_INFO, pwszCNGSignHashAlgids) - 8usize];
    ["Offset of field: _CERT_STRONG_SIGN_SERIALIZED_INFO::pwszCNGPubKeyMinBitLengths"][::std::mem::offset_of!(
        _CERT_STRONG_SIGN_SERIALIZED_INFO,
        pwszCNGPubKeyMinBitLengths
    ) - 16usize];
};
pub type CERT_STRONG_SIGN_SERIALIZED_INFO = _CERT_STRONG_SIGN_SERIALIZED_INFO;
pub type PCERT_STRONG_SIGN_SERIALIZED_INFO = *mut _CERT_STRONG_SIGN_SERIALIZED_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_STRONG_SIGN_PARA {
    pub cbSize: DWORD,
    pub dwInfoChoice: DWORD,
    pub __bindgen_anon_1: _CERT_STRONG_SIGN_PARA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_STRONG_SIGN_PARA__bindgen_ty_1 {
    pub pvInfo: *mut ::std::os::raw::c_void,
    pub pSerializedInfo: PCERT_STRONG_SIGN_SERIALIZED_INFO,
    pub pszOID: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_STRONG_SIGN_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_STRONG_SIGN_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CERT_STRONG_SIGN_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_STRONG_SIGN_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_STRONG_SIGN_PARA__bindgen_ty_1::pvInfo"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_PARA__bindgen_ty_1, pvInfo) - 0usize];
    ["Offset of field: _CERT_STRONG_SIGN_PARA__bindgen_ty_1::pSerializedInfo"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_PARA__bindgen_ty_1, pSerializedInfo) - 0usize];
    ["Offset of field: _CERT_STRONG_SIGN_PARA__bindgen_ty_1::pszOID"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_PARA__bindgen_ty_1, pszOID) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_STRONG_SIGN_PARA"][::std::mem::size_of::<_CERT_STRONG_SIGN_PARA>() - 16usize];
    ["Alignment of _CERT_STRONG_SIGN_PARA"]
        [::std::mem::align_of::<_CERT_STRONG_SIGN_PARA>() - 8usize];
    ["Offset of field: _CERT_STRONG_SIGN_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_STRONG_SIGN_PARA::dwInfoChoice"]
        [::std::mem::offset_of!(_CERT_STRONG_SIGN_PARA, dwInfoChoice) - 4usize];
};
pub type CERT_STRONG_SIGN_PARA = _CERT_STRONG_SIGN_PARA;
pub type PCERT_STRONG_SIGN_PARA = *mut _CERT_STRONG_SIGN_PARA;
pub type PCCERT_STRONG_SIGN_PARA = *const CERT_STRONG_SIGN_PARA;
pub type HCRYPTMSG = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_ISSUER_SERIAL_NUMBER {
    pub Issuer: CERT_NAME_BLOB,
    pub SerialNumber: CRYPT_INTEGER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ISSUER_SERIAL_NUMBER"]
        [::std::mem::size_of::<_CERT_ISSUER_SERIAL_NUMBER>() - 32usize];
    ["Alignment of _CERT_ISSUER_SERIAL_NUMBER"]
        [::std::mem::align_of::<_CERT_ISSUER_SERIAL_NUMBER>() - 8usize];
    ["Offset of field: _CERT_ISSUER_SERIAL_NUMBER::Issuer"]
        [::std::mem::offset_of!(_CERT_ISSUER_SERIAL_NUMBER, Issuer) - 0usize];
    ["Offset of field: _CERT_ISSUER_SERIAL_NUMBER::SerialNumber"]
        [::std::mem::offset_of!(_CERT_ISSUER_SERIAL_NUMBER, SerialNumber) - 16usize];
};
pub type CERT_ISSUER_SERIAL_NUMBER = _CERT_ISSUER_SERIAL_NUMBER;
pub type PCERT_ISSUER_SERIAL_NUMBER = *mut _CERT_ISSUER_SERIAL_NUMBER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_ID {
    pub dwIdChoice: DWORD,
    pub __bindgen_anon_1: _CERT_ID__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_ID__bindgen_ty_1 {
    pub IssuerSerialNumber: CERT_ISSUER_SERIAL_NUMBER,
    pub KeyId: CRYPT_HASH_BLOB,
    pub HashId: CRYPT_HASH_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ID__bindgen_ty_1"][::std::mem::size_of::<_CERT_ID__bindgen_ty_1>() - 32usize];
    ["Alignment of _CERT_ID__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_ID__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_ID__bindgen_ty_1::IssuerSerialNumber"]
        [::std::mem::offset_of!(_CERT_ID__bindgen_ty_1, IssuerSerialNumber) - 0usize];
    ["Offset of field: _CERT_ID__bindgen_ty_1::KeyId"]
        [::std::mem::offset_of!(_CERT_ID__bindgen_ty_1, KeyId) - 0usize];
    ["Offset of field: _CERT_ID__bindgen_ty_1::HashId"]
        [::std::mem::offset_of!(_CERT_ID__bindgen_ty_1, HashId) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_ID"][::std::mem::size_of::<_CERT_ID>() - 40usize];
    ["Alignment of _CERT_ID"][::std::mem::align_of::<_CERT_ID>() - 8usize];
    ["Offset of field: _CERT_ID::dwIdChoice"]
        [::std::mem::offset_of!(_CERT_ID, dwIdChoice) - 0usize];
};
pub type CERT_ID = _CERT_ID;
pub type PCERT_ID = *mut _CERT_ID;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_SIGNER_ENCODE_INFO {
    pub cbSize: DWORD,
    pub pCertInfo: PCERT_INFO,
    pub __bindgen_anon_1: _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1,
    pub dwKeySpec: DWORD,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvHashAuxInfo: *mut ::std::os::raw::c_void,
    pub cAuthAttr: DWORD,
    pub rgAuthAttr: PCRYPT_ATTRIBUTE,
    pub cUnauthAttr: DWORD,
    pub rgUnauthAttr: PCRYPT_ATTRIBUTE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1, hCryptProv) - 0usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1::hNCryptKey"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO__bindgen_ty_1, hNCryptKey) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SIGNER_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_SIGNER_ENCODE_INFO>() - 96usize];
    ["Alignment of _CMSG_SIGNER_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_SIGNER_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::pCertInfo"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, pCertInfo) - 8usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::dwKeySpec"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, dwKeySpec) - 24usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, HashAlgorithm) - 32usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::pvHashAuxInfo"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, pvHashAuxInfo) - 56usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::cAuthAttr"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, cAuthAttr) - 64usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::rgAuthAttr"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, rgAuthAttr) - 72usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::cUnauthAttr"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, cUnauthAttr) - 80usize];
    ["Offset of field: _CMSG_SIGNER_ENCODE_INFO::rgUnauthAttr"]
        [::std::mem::offset_of!(_CMSG_SIGNER_ENCODE_INFO, rgUnauthAttr) - 88usize];
};
pub type CMSG_SIGNER_ENCODE_INFO = _CMSG_SIGNER_ENCODE_INFO;
pub type PCMSG_SIGNER_ENCODE_INFO = *mut _CMSG_SIGNER_ENCODE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_SIGNED_ENCODE_INFO {
    pub cbSize: DWORD,
    pub cSigners: DWORD,
    pub rgSigners: PCMSG_SIGNER_ENCODE_INFO,
    pub cCertEncoded: DWORD,
    pub rgCertEncoded: PCERT_BLOB,
    pub cCrlEncoded: DWORD,
    pub rgCrlEncoded: PCRL_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SIGNED_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_SIGNED_ENCODE_INFO>() - 48usize];
    ["Alignment of _CMSG_SIGNED_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_SIGNED_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::cSigners"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, cSigners) - 4usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::rgSigners"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, rgSigners) - 8usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::cCertEncoded"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, cCertEncoded) - 16usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::rgCertEncoded"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, rgCertEncoded) - 24usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::cCrlEncoded"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, cCrlEncoded) - 32usize];
    ["Offset of field: _CMSG_SIGNED_ENCODE_INFO::rgCrlEncoded"]
        [::std::mem::offset_of!(_CMSG_SIGNED_ENCODE_INFO, rgCrlEncoded) - 40usize];
};
pub type CMSG_SIGNED_ENCODE_INFO = _CMSG_SIGNED_ENCODE_INFO;
pub type PCMSG_SIGNED_ENCODE_INFO = *mut _CMSG_SIGNED_ENCODE_INFO;
pub type CMSG_RECIPIENT_ENCODE_INFO = _CMSG_RECIPIENT_ENCODE_INFO;
pub type PCMSG_RECIPIENT_ENCODE_INFO = *mut _CMSG_RECIPIENT_ENCODE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_ENVELOPED_ENCODE_INFO {
    pub cbSize: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub ContentEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub cRecipients: DWORD,
    pub rgpRecipients: *mut PCERT_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_ENVELOPED_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_ENVELOPED_ENCODE_INFO>() - 64usize];
    ["Alignment of _CMSG_ENVELOPED_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_ENVELOPED_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, hCryptProv) - 8usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::ContentEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, ContentEncryptionAlgorithm) - 16usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::pvEncryptionAuxInfo"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, pvEncryptionAuxInfo) - 40usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::cRecipients"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, cRecipients) - 48usize];
    ["Offset of field: _CMSG_ENVELOPED_ENCODE_INFO::rgpRecipients"]
        [::std::mem::offset_of!(_CMSG_ENVELOPED_ENCODE_INFO, rgpRecipients) - 56usize];
};
pub type CMSG_ENVELOPED_ENCODE_INFO = _CMSG_ENVELOPED_ENCODE_INFO;
pub type PCMSG_ENVELOPED_ENCODE_INFO = *mut _CMSG_ENVELOPED_ENCODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO {
    pub cbSize: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvKeyEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub RecipientPublicKey: CRYPT_BIT_BLOB,
    pub RecipientId: CERT_ID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO>() - 112usize];
    ["Alignment of _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::KeyEncryptionAlgorithm"][::std::mem::offset_of!(
        _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO,
        KeyEncryptionAlgorithm
    ) - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::pvKeyEncryptionAuxInfo"][::std::mem::offset_of!(
        _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO,
        pvKeyEncryptionAuxInfo
    ) - 32usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO, hCryptProv) - 40usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::RecipientPublicKey"][::std::mem::offset_of!(
        _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO,
        RecipientPublicKey
    ) - 48usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO::RecipientId"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO, RecipientId) - 72usize];
};
pub type CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO = _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO;
pub type PCMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO = *mut _CMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO {
    pub cbSize: DWORD,
    pub RecipientPublicKey: CRYPT_BIT_BLOB,
    pub RecipientId: CERT_ID,
    pub Date: FILETIME,
    pub pOtherAttr: PCRYPT_ATTRIBUTE_TYPE_VALUE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO>() - 88usize];
    ["Alignment of _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO::RecipientPublicKey"][::std::mem::offset_of!(
        _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO,
        RecipientPublicKey
    ) - 8usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO::RecipientId"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO, RecipientId) - 32usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO::Date"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO, Date) - 72usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO::pOtherAttr"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO, pOtherAttr) - 80usize];
};
pub type CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO = _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO;
pub type PCMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO = *mut _CMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO {
    pub cbSize: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvKeyEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub KeyWrapAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvKeyWrapAuxInfo: *mut ::std::os::raw::c_void,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub dwKeySpec: DWORD,
    pub dwKeyChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
    pub UserKeyingMaterial: CRYPT_DATA_BLOB,
    pub cRecipientEncryptedKeys: DWORD,
    pub rgpRecipientEncryptedKeys: *mut PCMSG_RECIPIENT_ENCRYPTED_KEY_ENCODE_INFO,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1 {
    pub pEphemeralAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
    pub pSenderId: PCERT_ID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pEphemeralAlgorithm"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
        pEphemeralAlgorithm
    )
        - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pSenderId"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
        pSenderId
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO>() - 128usize];
    ["Alignment of _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::KeyEncryptionAlgorithm"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        KeyEncryptionAlgorithm
    ) - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::pvKeyEncryptionAuxInfo"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        pvKeyEncryptionAuxInfo
    ) - 32usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::KeyWrapAlgorithm"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, KeyWrapAlgorithm) - 40usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::pvKeyWrapAuxInfo"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, pvKeyWrapAuxInfo) - 64usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, hCryptProv) - 72usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::dwKeySpec"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, dwKeySpec) - 80usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::dwKeyChoice"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO, dwKeyChoice) - 84usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::UserKeyingMaterial"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        UserKeyingMaterial
    ) - 96usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::cRecipientEncryptedKeys"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        cRecipientEncryptedKeys
    )
        - 112usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO::rgpRecipientEncryptedKeys"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        rgpRecipientEncryptedKeys
    )
        - 120usize];
};
pub type CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO = _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO;
pub type PCMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO = *mut _CMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO {
    pub cbSize: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvKeyEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub hCryptProv: HCRYPTPROV,
    pub dwKeyChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
    pub KeyId: CRYPT_DATA_BLOB,
    pub Date: FILETIME,
    pub pOtherAttr: PCRYPT_ATTRIBUTE_TYPE_VALUE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1 {
    pub hKeyEncryptionKey: HCRYPTKEY,
    pub pvKeyEncryptionKey: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1::hKeyEncryptionKey"][::std::mem::offset_of!(
        _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
        hKeyEncryptionKey
    )
        - 0usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pvKeyEncryptionKey"][::std::mem::offset_of!(
        _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
        pvKeyEncryptionKey
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO>() - 96usize];
    ["Alignment of _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::KeyEncryptionAlgorithm"][::std::mem::offset_of!(
        _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO,
        KeyEncryptionAlgorithm
    ) - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::pvKeyEncryptionAuxInfo"][::std::mem::offset_of!(
        _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO,
        pvKeyEncryptionAuxInfo
    ) - 32usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, hCryptProv) - 40usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::dwKeyChoice"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, dwKeyChoice) - 48usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::KeyId"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, KeyId) - 64usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::Date"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, Date) - 80usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO::pOtherAttr"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO, pOtherAttr) - 88usize];
};
pub type CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO = _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO;
pub type PCMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO = *mut _CMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_RECIPIENT_ENCODE_INFO {
    pub dwRecipientChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1 {
    pub pKeyTrans: PCMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO,
    pub pKeyAgree: PCMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
    pub pMailList: PCMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pKeyTrans"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1, pKeyTrans) - 0usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pKeyAgree"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1, pKeyAgree) - 0usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1::pMailList"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCODE_INFO__bindgen_ty_1, pMailList) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RECIPIENT_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_RECIPIENT_ENCODE_INFO>() - 16usize];
    ["Alignment of _CMSG_RECIPIENT_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_RECIPIENT_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCODE_INFO::dwRecipientChoice"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCODE_INFO, dwRecipientChoice) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_RC2_AUX_INFO {
    pub cbSize: DWORD,
    pub dwBitLen: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RC2_AUX_INFO"][::std::mem::size_of::<_CMSG_RC2_AUX_INFO>() - 8usize];
    ["Alignment of _CMSG_RC2_AUX_INFO"][::std::mem::align_of::<_CMSG_RC2_AUX_INFO>() - 4usize];
    ["Offset of field: _CMSG_RC2_AUX_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_RC2_AUX_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_RC2_AUX_INFO::dwBitLen"]
        [::std::mem::offset_of!(_CMSG_RC2_AUX_INFO, dwBitLen) - 4usize];
};
pub type CMSG_RC2_AUX_INFO = _CMSG_RC2_AUX_INFO;
pub type PCMSG_RC2_AUX_INFO = *mut _CMSG_RC2_AUX_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_SP3_COMPATIBLE_AUX_INFO {
    pub cbSize: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SP3_COMPATIBLE_AUX_INFO"]
        [::std::mem::size_of::<_CMSG_SP3_COMPATIBLE_AUX_INFO>() - 8usize];
    ["Alignment of _CMSG_SP3_COMPATIBLE_AUX_INFO"]
        [::std::mem::align_of::<_CMSG_SP3_COMPATIBLE_AUX_INFO>() - 4usize];
    ["Offset of field: _CMSG_SP3_COMPATIBLE_AUX_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_SP3_COMPATIBLE_AUX_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_SP3_COMPATIBLE_AUX_INFO::dwFlags"]
        [::std::mem::offset_of!(_CMSG_SP3_COMPATIBLE_AUX_INFO, dwFlags) - 4usize];
};
pub type CMSG_SP3_COMPATIBLE_AUX_INFO = _CMSG_SP3_COMPATIBLE_AUX_INFO;
pub type PCMSG_SP3_COMPATIBLE_AUX_INFO = *mut _CMSG_SP3_COMPATIBLE_AUX_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_RC4_AUX_INFO {
    pub cbSize: DWORD,
    pub dwBitLen: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RC4_AUX_INFO"][::std::mem::size_of::<_CMSG_RC4_AUX_INFO>() - 8usize];
    ["Alignment of _CMSG_RC4_AUX_INFO"][::std::mem::align_of::<_CMSG_RC4_AUX_INFO>() - 4usize];
    ["Offset of field: _CMSG_RC4_AUX_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_RC4_AUX_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_RC4_AUX_INFO::dwBitLen"]
        [::std::mem::offset_of!(_CMSG_RC4_AUX_INFO, dwBitLen) - 4usize];
};
pub type CMSG_RC4_AUX_INFO = _CMSG_RC4_AUX_INFO;
pub type PCMSG_RC4_AUX_INFO = *mut _CMSG_RC4_AUX_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO {
    pub cbSize: DWORD,
    pub SignedInfo: CMSG_SIGNED_ENCODE_INFO,
    pub EnvelopedInfo: CMSG_ENVELOPED_ENCODE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO>() - 120usize];
    ["Alignment of _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO::SignedInfo"]
        [::std::mem::offset_of!(_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO, SignedInfo) - 8usize];
    ["Offset of field: _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO::EnvelopedInfo"]
        [::std::mem::offset_of!(_CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO, EnvelopedInfo) - 56usize];
};
pub type CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO = _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO;
pub type PCMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO = *mut _CMSG_SIGNED_AND_ENVELOPED_ENCODE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_HASHED_ENCODE_INFO {
    pub cbSize: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvHashAuxInfo: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_HASHED_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_HASHED_ENCODE_INFO>() - 48usize];
    ["Alignment of _CMSG_HASHED_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_HASHED_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_HASHED_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_HASHED_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_HASHED_ENCODE_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_HASHED_ENCODE_INFO, hCryptProv) - 8usize];
    ["Offset of field: _CMSG_HASHED_ENCODE_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CMSG_HASHED_ENCODE_INFO, HashAlgorithm) - 16usize];
    ["Offset of field: _CMSG_HASHED_ENCODE_INFO::pvHashAuxInfo"]
        [::std::mem::offset_of!(_CMSG_HASHED_ENCODE_INFO, pvHashAuxInfo) - 40usize];
};
pub type CMSG_HASHED_ENCODE_INFO = _CMSG_HASHED_ENCODE_INFO;
pub type PCMSG_HASHED_ENCODE_INFO = *mut _CMSG_HASHED_ENCODE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_ENCRYPTED_ENCODE_INFO {
    pub cbSize: DWORD,
    pub ContentEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvEncryptionAuxInfo: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_ENCRYPTED_ENCODE_INFO"]
        [::std::mem::size_of::<_CMSG_ENCRYPTED_ENCODE_INFO>() - 40usize];
    ["Alignment of _CMSG_ENCRYPTED_ENCODE_INFO"]
        [::std::mem::align_of::<_CMSG_ENCRYPTED_ENCODE_INFO>() - 8usize];
    ["Offset of field: _CMSG_ENCRYPTED_ENCODE_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_ENCRYPTED_ENCODE_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_ENCRYPTED_ENCODE_INFO::ContentEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_ENCRYPTED_ENCODE_INFO, ContentEncryptionAlgorithm) - 8usize];
    ["Offset of field: _CMSG_ENCRYPTED_ENCODE_INFO::pvEncryptionAuxInfo"]
        [::std::mem::offset_of!(_CMSG_ENCRYPTED_ENCODE_INFO, pvEncryptionAuxInfo) - 32usize];
};
pub type CMSG_ENCRYPTED_ENCODE_INFO = _CMSG_ENCRYPTED_ENCODE_INFO;
pub type PCMSG_ENCRYPTED_ENCODE_INFO = *mut _CMSG_ENCRYPTED_ENCODE_INFO;
pub type PFN_CMSG_STREAM_OUTPUT = ::std::option::Option<
    unsafe extern "C" fn(
        pvArg: *const ::std::os::raw::c_void,
        pbData: *mut BYTE,
        cbData: DWORD,
        fFinal: BOOL,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_STREAM_INFO {
    pub cbContent: DWORD,
    pub pfnStreamOutput: PFN_CMSG_STREAM_OUTPUT,
    pub pvArg: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_STREAM_INFO"][::std::mem::size_of::<_CMSG_STREAM_INFO>() - 24usize];
    ["Alignment of _CMSG_STREAM_INFO"][::std::mem::align_of::<_CMSG_STREAM_INFO>() - 8usize];
    ["Offset of field: _CMSG_STREAM_INFO::cbContent"]
        [::std::mem::offset_of!(_CMSG_STREAM_INFO, cbContent) - 0usize];
    ["Offset of field: _CMSG_STREAM_INFO::pfnStreamOutput"]
        [::std::mem::offset_of!(_CMSG_STREAM_INFO, pfnStreamOutput) - 8usize];
    ["Offset of field: _CMSG_STREAM_INFO::pvArg"]
        [::std::mem::offset_of!(_CMSG_STREAM_INFO, pvArg) - 16usize];
};
pub type CMSG_STREAM_INFO = _CMSG_STREAM_INFO;
pub type PCMSG_STREAM_INFO = *mut _CMSG_STREAM_INFO;
unsafe extern "C" {
    pub fn CryptMsgOpenToEncode(
        dwMsgEncodingType: DWORD,
        dwFlags: DWORD,
        dwMsgType: DWORD,
        pvMsgEncodeInfo: *const ::std::os::raw::c_void,
        pszInnerContentObjID: LPSTR,
        pStreamInfo: PCMSG_STREAM_INFO,
    ) -> HCRYPTMSG;
}
unsafe extern "C" {
    pub fn CryptMsgCalculateEncodedLength(
        dwMsgEncodingType: DWORD,
        dwFlags: DWORD,
        dwMsgType: DWORD,
        pvMsgEncodeInfo: *const ::std::os::raw::c_void,
        pszInnerContentObjID: LPSTR,
        cbData: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CryptMsgOpenToDecode(
        dwMsgEncodingType: DWORD,
        dwFlags: DWORD,
        dwMsgType: DWORD,
        hCryptProv: HCRYPTPROV_LEGACY,
        pRecipientInfo: PCERT_INFO,
        pStreamInfo: PCMSG_STREAM_INFO,
    ) -> HCRYPTMSG;
}
unsafe extern "C" {
    pub fn CryptMsgDuplicate(hCryptMsg: HCRYPTMSG) -> HCRYPTMSG;
}
unsafe extern "C" {
    pub fn CryptMsgClose(hCryptMsg: HCRYPTMSG) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgUpdate(
        hCryptMsg: HCRYPTMSG,
        pbData: *const BYTE,
        cbData: DWORD,
        fFinal: BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgGetParam(
        hCryptMsg: HCRYPTMSG,
        dwParamType: DWORD,
        dwIndex: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_SIGNER_INFO {
    pub dwVersion: DWORD,
    pub Issuer: CERT_NAME_BLOB,
    pub SerialNumber: CRYPT_INTEGER_BLOB,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub HashEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedHash: CRYPT_DATA_BLOB,
    pub AuthAttrs: CRYPT_ATTRIBUTES,
    pub UnauthAttrs: CRYPT_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_SIGNER_INFO"][::std::mem::size_of::<_CMSG_SIGNER_INFO>() - 136usize];
    ["Alignment of _CMSG_SIGNER_INFO"][::std::mem::align_of::<_CMSG_SIGNER_INFO>() - 8usize];
    ["Offset of field: _CMSG_SIGNER_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMSG_SIGNER_INFO::Issuer"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, Issuer) - 8usize];
    ["Offset of field: _CMSG_SIGNER_INFO::SerialNumber"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, SerialNumber) - 24usize];
    ["Offset of field: _CMSG_SIGNER_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, HashAlgorithm) - 40usize];
    ["Offset of field: _CMSG_SIGNER_INFO::HashEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, HashEncryptionAlgorithm) - 64usize];
    ["Offset of field: _CMSG_SIGNER_INFO::EncryptedHash"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, EncryptedHash) - 88usize];
    ["Offset of field: _CMSG_SIGNER_INFO::AuthAttrs"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, AuthAttrs) - 104usize];
    ["Offset of field: _CMSG_SIGNER_INFO::UnauthAttrs"]
        [::std::mem::offset_of!(_CMSG_SIGNER_INFO, UnauthAttrs) - 120usize];
};
pub type CMSG_SIGNER_INFO = _CMSG_SIGNER_INFO;
pub type PCMSG_SIGNER_INFO = *mut _CMSG_SIGNER_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CMS_SIGNER_INFO {
    pub dwVersion: DWORD,
    pub SignerId: CERT_ID,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub HashEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedHash: CRYPT_DATA_BLOB,
    pub AuthAttrs: CRYPT_ATTRIBUTES,
    pub UnauthAttrs: CRYPT_ATTRIBUTES,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CMS_SIGNER_INFO"][::std::mem::size_of::<_CMSG_CMS_SIGNER_INFO>() - 144usize];
    ["Alignment of _CMSG_CMS_SIGNER_INFO"]
        [::std::mem::align_of::<_CMSG_CMS_SIGNER_INFO>() - 8usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::SignerId"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, SignerId) - 8usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, HashAlgorithm) - 48usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::HashEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, HashEncryptionAlgorithm) - 72usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::EncryptedHash"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, EncryptedHash) - 96usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::AuthAttrs"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, AuthAttrs) - 112usize];
    ["Offset of field: _CMSG_CMS_SIGNER_INFO::UnauthAttrs"]
        [::std::mem::offset_of!(_CMSG_CMS_SIGNER_INFO, UnauthAttrs) - 128usize];
};
pub type CMSG_CMS_SIGNER_INFO = _CMSG_CMS_SIGNER_INFO;
pub type PCMSG_CMS_SIGNER_INFO = *mut _CMSG_CMS_SIGNER_INFO;
pub type CMSG_ATTR = CRYPT_ATTRIBUTES;
pub type PCMSG_ATTR = *mut CRYPT_ATTRIBUTES;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_KEY_TRANS_RECIPIENT_INFO {
    pub dwVersion: DWORD,
    pub RecipientId: CERT_ID,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedKey: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_TRANS_RECIPIENT_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_TRANS_RECIPIENT_INFO>() - 88usize];
    ["Alignment of _CMSG_KEY_TRANS_RECIPIENT_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_TRANS_RECIPIENT_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_INFO::RecipientId"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_INFO, RecipientId) - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_INFO, KeyEncryptionAlgorithm) - 48usize];
    ["Offset of field: _CMSG_KEY_TRANS_RECIPIENT_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_RECIPIENT_INFO, EncryptedKey) - 72usize];
};
pub type CMSG_KEY_TRANS_RECIPIENT_INFO = _CMSG_KEY_TRANS_RECIPIENT_INFO;
pub type PCMSG_KEY_TRANS_RECIPIENT_INFO = *mut _CMSG_KEY_TRANS_RECIPIENT_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO {
    pub RecipientId: CERT_ID,
    pub EncryptedKey: CRYPT_DATA_BLOB,
    pub Date: FILETIME,
    pub pOtherAttr: PCRYPT_ATTRIBUTE_TYPE_VALUE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO"]
        [::std::mem::size_of::<_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO>() - 72usize];
    ["Alignment of _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO"]
        [::std::mem::align_of::<_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO>() - 8usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO::RecipientId"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO, RecipientId) - 0usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO, EncryptedKey) - 40usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO::Date"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO, Date) - 56usize];
    ["Offset of field: _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO::pOtherAttr"]
        [::std::mem::offset_of!(_CMSG_RECIPIENT_ENCRYPTED_KEY_INFO, pOtherAttr) - 64usize];
};
pub type CMSG_RECIPIENT_ENCRYPTED_KEY_INFO = _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO;
pub type PCMSG_RECIPIENT_ENCRYPTED_KEY_INFO = *mut _CMSG_RECIPIENT_ENCRYPTED_KEY_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_KEY_AGREE_RECIPIENT_INFO {
    pub dwVersion: DWORD,
    pub dwOriginatorChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1,
    pub UserKeyingMaterial: CRYPT_DATA_BLOB,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub cRecipientEncryptedKeys: DWORD,
    pub rgpRecipientEncryptedKeys: *mut PCMSG_RECIPIENT_ENCRYPTED_KEY_INFO,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1 {
    pub OriginatorCertId: CERT_ID,
    pub OriginatorPublicKeyInfo: CERT_PUBLIC_KEY_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1>() - 48usize];
    ["Alignment of _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1::OriginatorCertId"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1,
        OriginatorCertId
    ) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1::OriginatorPublicKeyInfo"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_INFO__bindgen_ty_1,
        OriginatorPublicKeyInfo
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_RECIPIENT_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_RECIPIENT_INFO>() - 112usize];
    ["Alignment of _CMSG_KEY_AGREE_RECIPIENT_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_RECIPIENT_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::dwOriginatorChoice"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_INFO, dwOriginatorChoice) - 4usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::UserKeyingMaterial"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_INFO, UserKeyingMaterial) - 56usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_INFO, KeyEncryptionAlgorithm) - 72usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::cRecipientEncryptedKeys"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_RECIPIENT_INFO, cRecipientEncryptedKeys) - 96usize];
    ["Offset of field: _CMSG_KEY_AGREE_RECIPIENT_INFO::rgpRecipientEncryptedKeys"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_RECIPIENT_INFO,
        rgpRecipientEncryptedKeys
    ) - 104usize];
};
pub type CMSG_KEY_AGREE_RECIPIENT_INFO = _CMSG_KEY_AGREE_RECIPIENT_INFO;
pub type PCMSG_KEY_AGREE_RECIPIENT_INFO = *mut _CMSG_KEY_AGREE_RECIPIENT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_MAIL_LIST_RECIPIENT_INFO {
    pub dwVersion: DWORD,
    pub KeyId: CRYPT_DATA_BLOB,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedKey: CRYPT_DATA_BLOB,
    pub Date: FILETIME,
    pub pOtherAttr: PCRYPT_ATTRIBUTE_TYPE_VALUE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_MAIL_LIST_RECIPIENT_INFO"]
        [::std::mem::size_of::<_CMSG_MAIL_LIST_RECIPIENT_INFO>() - 80usize];
    ["Alignment of _CMSG_MAIL_LIST_RECIPIENT_INFO"]
        [::std::mem::align_of::<_CMSG_MAIL_LIST_RECIPIENT_INFO>() - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::dwVersion"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, dwVersion) - 0usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::KeyId"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, KeyId) - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, KeyEncryptionAlgorithm) - 24usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, EncryptedKey) - 48usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::Date"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, Date) - 64usize];
    ["Offset of field: _CMSG_MAIL_LIST_RECIPIENT_INFO::pOtherAttr"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_RECIPIENT_INFO, pOtherAttr) - 72usize];
};
pub type CMSG_MAIL_LIST_RECIPIENT_INFO = _CMSG_MAIL_LIST_RECIPIENT_INFO;
pub type PCMSG_MAIL_LIST_RECIPIENT_INFO = *mut _CMSG_MAIL_LIST_RECIPIENT_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CMS_RECIPIENT_INFO {
    pub dwRecipientChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1 {
    pub pKeyTrans: PCMSG_KEY_TRANS_RECIPIENT_INFO,
    pub pKeyAgree: PCMSG_KEY_AGREE_RECIPIENT_INFO,
    pub pMailList: PCMSG_MAIL_LIST_RECIPIENT_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1::pKeyTrans"]
        [::std::mem::offset_of!(_CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1, pKeyTrans) - 0usize];
    ["Offset of field: _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1::pKeyAgree"]
        [::std::mem::offset_of!(_CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1, pKeyAgree) - 0usize];
    ["Offset of field: _CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1::pMailList"]
        [::std::mem::offset_of!(_CMSG_CMS_RECIPIENT_INFO__bindgen_ty_1, pMailList) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CMS_RECIPIENT_INFO"]
        [::std::mem::size_of::<_CMSG_CMS_RECIPIENT_INFO>() - 16usize];
    ["Alignment of _CMSG_CMS_RECIPIENT_INFO"]
        [::std::mem::align_of::<_CMSG_CMS_RECIPIENT_INFO>() - 8usize];
    ["Offset of field: _CMSG_CMS_RECIPIENT_INFO::dwRecipientChoice"]
        [::std::mem::offset_of!(_CMSG_CMS_RECIPIENT_INFO, dwRecipientChoice) - 0usize];
};
pub type CMSG_CMS_RECIPIENT_INFO = _CMSG_CMS_RECIPIENT_INFO;
pub type PCMSG_CMS_RECIPIENT_INFO = *mut _CMSG_CMS_RECIPIENT_INFO;
unsafe extern "C" {
    pub fn CryptMsgControl(
        hCryptMsg: HCRYPTMSG,
        dwFlags: DWORD,
        dwCtrlType: DWORD,
        pvCtrlPara: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA {
    pub cbSize: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub dwSignerIndex: DWORD,
    pub dwSignerType: DWORD,
    pub pvSigner: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA>() - 32usize];
    ["Alignment of _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA, hCryptProv) - 8usize];
    ["Offset of field: _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA::dwSignerIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA, dwSignerIndex) - 16usize];
    ["Offset of field: _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA::dwSignerType"]
        [::std::mem::offset_of!(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA, dwSignerType) - 20usize];
    ["Offset of field: _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA::pvSigner"]
        [::std::mem::offset_of!(_CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA, pvSigner) - 24usize];
};
pub type CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA = _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA;
pub type PCMSG_CTRL_VERIFY_SIGNATURE_EX_PARA = *mut _CMSG_CTRL_VERIFY_SIGNATURE_EX_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CTRL_DECRYPT_PARA {
    pub cbSize: DWORD,
    pub __bindgen_anon_1: _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1,
    pub dwKeySpec: DWORD,
    pub dwRecipientIndex: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1, hCryptProv) - 0usize];
    ["Offset of field: _CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1::hNCryptKey"]
        [::std::mem::offset_of!(_CMSG_CTRL_DECRYPT_PARA__bindgen_ty_1, hNCryptKey) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_DECRYPT_PARA"][::std::mem::size_of::<_CMSG_CTRL_DECRYPT_PARA>() - 24usize];
    ["Alignment of _CMSG_CTRL_DECRYPT_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_DECRYPT_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_DECRYPT_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_DECRYPT_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_DECRYPT_PARA::dwKeySpec"]
        [::std::mem::offset_of!(_CMSG_CTRL_DECRYPT_PARA, dwKeySpec) - 16usize];
    ["Offset of field: _CMSG_CTRL_DECRYPT_PARA::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_DECRYPT_PARA, dwRecipientIndex) - 20usize];
};
pub type CMSG_CTRL_DECRYPT_PARA = _CMSG_CTRL_DECRYPT_PARA;
pub type PCMSG_CTRL_DECRYPT_PARA = *mut _CMSG_CTRL_DECRYPT_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA {
    pub cbSize: DWORD,
    pub __bindgen_anon_1: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1,
    pub dwKeySpec: DWORD,
    pub pKeyTrans: PCMSG_KEY_TRANS_RECIPIENT_INFO,
    pub dwRecipientIndex: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1::hCryptProv"][::std::mem::offset_of!(
        _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1,
        hCryptProv
    ) - 0usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1::hNCryptKey"][::std::mem::offset_of!(
        _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA__bindgen_ty_1,
        hNCryptKey
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA>() - 40usize];
    ["Alignment of _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA::dwKeySpec"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA, dwKeySpec) - 16usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA::pKeyTrans"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA, pKeyTrans) - 24usize];
    ["Offset of field: _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_TRANS_DECRYPT_PARA, dwRecipientIndex) - 32usize];
};
pub type CMSG_CTRL_KEY_TRANS_DECRYPT_PARA = _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA;
pub type PCMSG_CTRL_KEY_TRANS_DECRYPT_PARA = *mut _CMSG_CTRL_KEY_TRANS_DECRYPT_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA {
    pub cbSize: DWORD,
    pub __bindgen_anon_1: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1,
    pub dwKeySpec: DWORD,
    pub pKeyAgree: PCMSG_KEY_AGREE_RECIPIENT_INFO,
    pub dwRecipientIndex: DWORD,
    pub dwRecipientEncryptedKeyIndex: DWORD,
    pub OriginatorPublicKey: CRYPT_BIT_BLOB,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1::hCryptProv"][::std::mem::offset_of!(
        _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1,
        hCryptProv
    ) - 0usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1::hNCryptKey"][::std::mem::offset_of!(
        _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA__bindgen_ty_1,
        hNCryptKey
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA>() - 64usize];
    ["Alignment of _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::dwKeySpec"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA, dwKeySpec) - 16usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::pKeyAgree"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA, pKeyAgree) - 24usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA, dwRecipientIndex) - 32usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::dwRecipientEncryptedKeyIndex"][::std::mem::offset_of!(
        _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA,
        dwRecipientEncryptedKeyIndex
    )
        - 36usize];
    ["Offset of field: _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA::OriginatorPublicKey"]
        [::std::mem::offset_of!(_CMSG_CTRL_KEY_AGREE_DECRYPT_PARA, OriginatorPublicKey) - 40usize];
};
pub type CMSG_CTRL_KEY_AGREE_DECRYPT_PARA = _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA;
pub type PCMSG_CTRL_KEY_AGREE_DECRYPT_PARA = *mut _CMSG_CTRL_KEY_AGREE_DECRYPT_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA {
    pub cbSize: DWORD,
    pub hCryptProv: HCRYPTPROV,
    pub pMailList: PCMSG_MAIL_LIST_RECIPIENT_INFO,
    pub dwRecipientIndex: DWORD,
    pub dwKeyChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1 {
    pub hKeyEncryptionKey: HCRYPTKEY,
    pub pvKeyEncryptionKey: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1::hKeyEncryptionKey"][::std::mem::offset_of!(
        _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1,
        hKeyEncryptionKey
    )
        - 0usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1::pvKeyEncryptionKey"][::std::mem::offset_of!(
        _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA__bindgen_ty_1,
        pvKeyEncryptionKey
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA>() - 40usize];
    ["Alignment of _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA, hCryptProv) - 8usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA::pMailList"]
        [::std::mem::offset_of!(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA, pMailList) - 16usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA, dwRecipientIndex) - 24usize];
    ["Offset of field: _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA::dwKeyChoice"]
        [::std::mem::offset_of!(_CMSG_CTRL_MAIL_LIST_DECRYPT_PARA, dwKeyChoice) - 28usize];
};
pub type CMSG_CTRL_MAIL_LIST_DECRYPT_PARA = _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA;
pub type PCMSG_CTRL_MAIL_LIST_DECRYPT_PARA = *mut _CMSG_CTRL_MAIL_LIST_DECRYPT_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA {
    pub cbSize: DWORD,
    pub dwSignerIndex: DWORD,
    pub blob: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA>() - 24usize];
    ["Alignment of _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA>() - 8usize];
    ["Offset of field: _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA::dwSignerIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA, dwSignerIndex) - 4usize];
    ["Offset of field: _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA::blob"]
        [::std::mem::offset_of!(_CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA, blob) - 8usize];
};
pub type CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA = _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA;
pub type PCMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA = *mut _CMSG_CTRL_ADD_SIGNER_UNAUTH_ATTR_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA {
    pub cbSize: DWORD,
    pub dwSignerIndex: DWORD,
    pub dwUnauthAttrIndex: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA"]
        [::std::mem::size_of::<_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA>() - 12usize];
    ["Alignment of _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA"]
        [::std::mem::align_of::<_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA>() - 4usize];
    ["Offset of field: _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA::cbSize"]
        [::std::mem::offset_of!(_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA, cbSize) - 0usize];
    ["Offset of field: _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA::dwSignerIndex"]
        [::std::mem::offset_of!(_CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA, dwSignerIndex) - 4usize];
    ["Offset of field: _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA::dwUnauthAttrIndex"][::std::mem::offset_of!(
        _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA,
        dwUnauthAttrIndex
    ) - 8usize];
};
pub type CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA = _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA;
pub type PCMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA = *mut _CMSG_CTRL_DEL_SIGNER_UNAUTH_ATTR_PARA;
unsafe extern "C" {
    pub fn CryptMsgVerifyCountersignatureEncoded(
        hCryptProv: HCRYPTPROV_LEGACY,
        dwEncodingType: DWORD,
        pbSignerInfo: PBYTE,
        cbSignerInfo: DWORD,
        pbSignerInfoCountersignature: PBYTE,
        cbSignerInfoCountersignature: DWORD,
        pciCountersigner: PCERT_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgVerifyCountersignatureEncodedEx(
        hCryptProv: HCRYPTPROV_LEGACY,
        dwEncodingType: DWORD,
        pbSignerInfo: PBYTE,
        cbSignerInfo: DWORD,
        pbSignerInfoCountersignature: PBYTE,
        cbSignerInfoCountersignature: DWORD,
        dwSignerType: DWORD,
        pvSigner: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
        pvExtra: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgCountersign(
        hCryptMsg: HCRYPTMSG,
        dwIndex: DWORD,
        cCountersigners: DWORD,
        rgCountersigners: PCMSG_SIGNER_ENCODE_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgCountersignEncoded(
        dwEncodingType: DWORD,
        pbSignerInfo: PBYTE,
        cbSignerInfo: DWORD,
        cCountersigners: DWORD,
        rgCountersigners: PCMSG_SIGNER_ENCODE_INFO,
        pbCountersignature: PBYTE,
        pcbCountersignature: PDWORD,
    ) -> BOOL;
}
pub type PFN_CMSG_ALLOC =
    ::std::option::Option<unsafe extern "C" fn(cb: usize) -> *mut ::std::os::raw::c_void>;
pub type PFN_CMSG_FREE =
    ::std::option::Option<unsafe extern "C" fn(pv: *mut ::std::os::raw::c_void)>;
pub type PFN_CMSG_GEN_ENCRYPT_KEY = ::std::option::Option<
    unsafe extern "C" fn(
        phCryptProv: *mut HCRYPTPROV,
        paiEncrypt: PCRYPT_ALGORITHM_IDENTIFIER,
        pvEncryptAuxInfo: PVOID,
        pPublicKeyInfo: PCERT_PUBLIC_KEY_INFO,
        pfnAlloc: PFN_CMSG_ALLOC,
        phEncryptKey: *mut HCRYPTKEY,
        ppbEncryptParameters: *mut PBYTE,
        pcbEncryptParameters: PDWORD,
    ) -> BOOL,
>;
pub type PFN_CMSG_EXPORT_ENCRYPT_KEY = ::std::option::Option<
    unsafe extern "C" fn(
        hCryptProv: HCRYPTPROV,
        hEncryptKey: HCRYPTKEY,
        pPublicKeyInfo: PCERT_PUBLIC_KEY_INFO,
        pbData: PBYTE,
        pcbData: PDWORD,
    ) -> BOOL,
>;
pub type PFN_CMSG_IMPORT_ENCRYPT_KEY = ::std::option::Option<
    unsafe extern "C" fn(
        hCryptProv: HCRYPTPROV,
        dwKeySpec: DWORD,
        paiEncrypt: PCRYPT_ALGORITHM_IDENTIFIER,
        paiPubKey: PCRYPT_ALGORITHM_IDENTIFIER,
        pbEncodedKey: PBYTE,
        cbEncodedKey: DWORD,
        phEncryptKey: *mut HCRYPTKEY,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_CONTENT_ENCRYPT_INFO {
    pub cbSize: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub ContentEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub cRecipients: DWORD,
    pub rgCmsRecipients: PCMSG_RECIPIENT_ENCODE_INFO,
    pub pfnAlloc: PFN_CMSG_ALLOC,
    pub pfnFree: PFN_CMSG_FREE,
    pub dwEncryptFlags: DWORD,
    pub __bindgen_anon_1: _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1,
    pub dwFlags: DWORD,
    pub fCNG: BOOL,
    pub pbCNGContentEncryptKeyObject: *mut BYTE,
    pub pbContentEncryptKey: *mut BYTE,
    pub cbContentEncryptKey: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1 {
    pub hContentEncryptKey: HCRYPTKEY,
    pub hCNGContentEncryptKey: BCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1::hContentEncryptKey"][::std::mem::offset_of!(
        _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1,
        hContentEncryptKey
    ) - 0usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1::hCNGContentEncryptKey"][::std::mem::offset_of!(
        _CMSG_CONTENT_ENCRYPT_INFO__bindgen_ty_1,
        hCNGContentEncryptKey
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CONTENT_ENCRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_CONTENT_ENCRYPT_INFO>() - 128usize];
    ["Alignment of _CMSG_CONTENT_ENCRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_CONTENT_ENCRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::hCryptProv"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, hCryptProv) - 8usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::ContentEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, ContentEncryptionAlgorithm) - 16usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::pvEncryptionAuxInfo"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, pvEncryptionAuxInfo) - 40usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::cRecipients"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, cRecipients) - 48usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::rgCmsRecipients"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, rgCmsRecipients) - 56usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::pfnAlloc"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, pfnAlloc) - 64usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::pfnFree"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, pfnFree) - 72usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::dwEncryptFlags"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, dwEncryptFlags) - 80usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::dwFlags"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, dwFlags) - 96usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::fCNG"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, fCNG) - 100usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::pbCNGContentEncryptKeyObject"][::std::mem::offset_of!(
        _CMSG_CONTENT_ENCRYPT_INFO,
        pbCNGContentEncryptKeyObject
    ) - 104usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::pbContentEncryptKey"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, pbContentEncryptKey) - 112usize];
    ["Offset of field: _CMSG_CONTENT_ENCRYPT_INFO::cbContentEncryptKey"]
        [::std::mem::offset_of!(_CMSG_CONTENT_ENCRYPT_INFO, cbContentEncryptKey) - 120usize];
};
pub type CMSG_CONTENT_ENCRYPT_INFO = _CMSG_CONTENT_ENCRYPT_INFO;
pub type PCMSG_CONTENT_ENCRYPT_INFO = *mut _CMSG_CONTENT_ENCRYPT_INFO;
pub type PFN_CMSG_GEN_CONTENT_ENCRYPT_KEY = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptInfo: PCMSG_CONTENT_ENCRYPT_INFO,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_KEY_TRANS_ENCRYPT_INFO {
    pub cbSize: DWORD,
    pub dwRecipientIndex: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedKey: CRYPT_DATA_BLOB,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_TRANS_ENCRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_TRANS_ENCRYPT_INFO>() - 56usize];
    ["Alignment of _CMSG_KEY_TRANS_ENCRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_TRANS_ENCRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_ENCRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_ENCRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_KEY_TRANS_ENCRYPT_INFO::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_ENCRYPT_INFO, dwRecipientIndex) - 4usize];
    ["Offset of field: _CMSG_KEY_TRANS_ENCRYPT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_ENCRYPT_INFO, KeyEncryptionAlgorithm) - 8usize];
    ["Offset of field: _CMSG_KEY_TRANS_ENCRYPT_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_ENCRYPT_INFO, EncryptedKey) - 32usize];
    ["Offset of field: _CMSG_KEY_TRANS_ENCRYPT_INFO::dwFlags"]
        [::std::mem::offset_of!(_CMSG_KEY_TRANS_ENCRYPT_INFO, dwFlags) - 48usize];
};
pub type CMSG_KEY_TRANS_ENCRYPT_INFO = _CMSG_KEY_TRANS_ENCRYPT_INFO;
pub type PCMSG_KEY_TRANS_ENCRYPT_INFO = *mut _CMSG_KEY_TRANS_ENCRYPT_INFO;
pub type PFN_CMSG_EXPORT_KEY_TRANS = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptInfo: PCMSG_CONTENT_ENCRYPT_INFO,
        pKeyTransEncodeInfo: PCMSG_KEY_TRANS_RECIPIENT_ENCODE_INFO,
        pKeyTransEncryptInfo: PCMSG_KEY_TRANS_ENCRYPT_INFO,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO {
    pub cbSize: DWORD,
    pub EncryptedKey: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO>() - 24usize];
    ["Alignment of _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_KEY_ENCRYPT_INFO, EncryptedKey) - 8usize];
};
pub type CMSG_KEY_AGREE_KEY_ENCRYPT_INFO = _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO;
pub type PCMSG_KEY_AGREE_KEY_ENCRYPT_INFO = *mut _CMSG_KEY_AGREE_KEY_ENCRYPT_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CMSG_KEY_AGREE_ENCRYPT_INFO {
    pub cbSize: DWORD,
    pub dwRecipientIndex: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub UserKeyingMaterial: CRYPT_DATA_BLOB,
    pub dwOriginatorChoice: DWORD,
    pub __bindgen_anon_1: _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1,
    pub cKeyAgreeKeyEncryptInfo: DWORD,
    pub rgpKeyAgreeKeyEncryptInfo: *mut PCMSG_KEY_AGREE_KEY_ENCRYPT_INFO,
    pub dwFlags: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1 {
    pub OriginatorCertId: CERT_ID,
    pub OriginatorPublicKeyInfo: CERT_PUBLIC_KEY_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1>() - 48usize];
    ["Alignment of _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1::OriginatorCertId"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1,
        OriginatorCertId
    ) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1::OriginatorPublicKeyInfo"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_ENCRYPT_INFO__bindgen_ty_1,
        OriginatorPublicKeyInfo
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_KEY_AGREE_ENCRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_KEY_AGREE_ENCRYPT_INFO>() - 128usize];
    ["Alignment of _CMSG_KEY_AGREE_ENCRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_KEY_AGREE_ENCRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, dwRecipientIndex) - 4usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, KeyEncryptionAlgorithm) - 8usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::UserKeyingMaterial"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, UserKeyingMaterial) - 32usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::dwOriginatorChoice"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, dwOriginatorChoice) - 48usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::cKeyAgreeKeyEncryptInfo"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, cKeyAgreeKeyEncryptInfo) - 104usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::rgpKeyAgreeKeyEncryptInfo"][::std::mem::offset_of!(
        _CMSG_KEY_AGREE_ENCRYPT_INFO,
        rgpKeyAgreeKeyEncryptInfo
    ) - 112usize];
    ["Offset of field: _CMSG_KEY_AGREE_ENCRYPT_INFO::dwFlags"]
        [::std::mem::offset_of!(_CMSG_KEY_AGREE_ENCRYPT_INFO, dwFlags) - 120usize];
};
pub type CMSG_KEY_AGREE_ENCRYPT_INFO = _CMSG_KEY_AGREE_ENCRYPT_INFO;
pub type PCMSG_KEY_AGREE_ENCRYPT_INFO = *mut _CMSG_KEY_AGREE_ENCRYPT_INFO;
pub type PFN_CMSG_EXPORT_KEY_AGREE = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptInfo: PCMSG_CONTENT_ENCRYPT_INFO,
        pKeyAgreeEncodeInfo: PCMSG_KEY_AGREE_RECIPIENT_ENCODE_INFO,
        pKeyAgreeEncryptInfo: PCMSG_KEY_AGREE_ENCRYPT_INFO,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_MAIL_LIST_ENCRYPT_INFO {
    pub cbSize: DWORD,
    pub dwRecipientIndex: DWORD,
    pub KeyEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub EncryptedKey: CRYPT_DATA_BLOB,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_MAIL_LIST_ENCRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_MAIL_LIST_ENCRYPT_INFO>() - 56usize];
    ["Alignment of _CMSG_MAIL_LIST_ENCRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_MAIL_LIST_ENCRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_ENCRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_ENCRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_MAIL_LIST_ENCRYPT_INFO::dwRecipientIndex"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_ENCRYPT_INFO, dwRecipientIndex) - 4usize];
    ["Offset of field: _CMSG_MAIL_LIST_ENCRYPT_INFO::KeyEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_ENCRYPT_INFO, KeyEncryptionAlgorithm) - 8usize];
    ["Offset of field: _CMSG_MAIL_LIST_ENCRYPT_INFO::EncryptedKey"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_ENCRYPT_INFO, EncryptedKey) - 32usize];
    ["Offset of field: _CMSG_MAIL_LIST_ENCRYPT_INFO::dwFlags"]
        [::std::mem::offset_of!(_CMSG_MAIL_LIST_ENCRYPT_INFO, dwFlags) - 48usize];
};
pub type CMSG_MAIL_LIST_ENCRYPT_INFO = _CMSG_MAIL_LIST_ENCRYPT_INFO;
pub type PCMSG_MAIL_LIST_ENCRYPT_INFO = *mut _CMSG_MAIL_LIST_ENCRYPT_INFO;
pub type PFN_CMSG_EXPORT_MAIL_LIST = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptInfo: PCMSG_CONTENT_ENCRYPT_INFO,
        pMailListEncodeInfo: PCMSG_MAIL_LIST_RECIPIENT_ENCODE_INFO,
        pMailListEncryptInfo: PCMSG_MAIL_LIST_ENCRYPT_INFO,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CMSG_IMPORT_KEY_TRANS = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptionAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pKeyTransDecryptPara: PCMSG_CTRL_KEY_TRANS_DECRYPT_PARA,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        phContentEncryptKey: *mut HCRYPTKEY,
    ) -> BOOL,
>;
pub type PFN_CMSG_IMPORT_KEY_AGREE = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptionAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pKeyAgreeDecryptPara: PCMSG_CTRL_KEY_AGREE_DECRYPT_PARA,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        phContentEncryptKey: *mut HCRYPTKEY,
    ) -> BOOL,
>;
pub type PFN_CMSG_IMPORT_MAIL_LIST = ::std::option::Option<
    unsafe extern "C" fn(
        pContentEncryptionAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pMailListDecryptPara: PCMSG_CTRL_MAIL_LIST_DECRYPT_PARA,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        phContentEncryptKey: *mut HCRYPTKEY,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CMSG_CNG_CONTENT_DECRYPT_INFO {
    pub cbSize: DWORD,
    pub ContentEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pfnAlloc: PFN_CMSG_ALLOC,
    pub pfnFree: PFN_CMSG_FREE,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
    pub pbContentEncryptKey: *mut BYTE,
    pub cbContentEncryptKey: DWORD,
    pub hCNGContentEncryptKey: BCRYPT_KEY_HANDLE,
    pub pbCNGContentEncryptKeyObject: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CMSG_CNG_CONTENT_DECRYPT_INFO"]
        [::std::mem::size_of::<_CMSG_CNG_CONTENT_DECRYPT_INFO>() - 88usize];
    ["Alignment of _CMSG_CNG_CONTENT_DECRYPT_INFO"]
        [::std::mem::align_of::<_CMSG_CNG_CONTENT_DECRYPT_INFO>() - 8usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::cbSize"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, cbSize) - 0usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::ContentEncryptionAlgorithm"][::std::mem::offset_of!(
        _CMSG_CNG_CONTENT_DECRYPT_INFO,
        ContentEncryptionAlgorithm
    ) - 8usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::pfnAlloc"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, pfnAlloc) - 32usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::pfnFree"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, pfnFree) - 40usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::hNCryptKey"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, hNCryptKey) - 48usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::pbContentEncryptKey"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, pbContentEncryptKey) - 56usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::cbContentEncryptKey"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, cbContentEncryptKey) - 64usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::hCNGContentEncryptKey"]
        [::std::mem::offset_of!(_CMSG_CNG_CONTENT_DECRYPT_INFO, hCNGContentEncryptKey) - 72usize];
    ["Offset of field: _CMSG_CNG_CONTENT_DECRYPT_INFO::pbCNGContentEncryptKeyObject"][::std::mem::offset_of!(
        _CMSG_CNG_CONTENT_DECRYPT_INFO,
        pbCNGContentEncryptKeyObject
    ) - 80usize];
};
pub type CMSG_CNG_CONTENT_DECRYPT_INFO = _CMSG_CNG_CONTENT_DECRYPT_INFO;
pub type PCMSG_CNG_CONTENT_DECRYPT_INFO = *mut _CMSG_CNG_CONTENT_DECRYPT_INFO;
pub type PFN_CMSG_CNG_IMPORT_KEY_TRANS = ::std::option::Option<
    unsafe extern "C" fn(
        pCNGContentDecryptInfo: PCMSG_CNG_CONTENT_DECRYPT_INFO,
        pKeyTransDecryptPara: PCMSG_CTRL_KEY_TRANS_DECRYPT_PARA,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CMSG_CNG_IMPORT_KEY_AGREE = ::std::option::Option<
    unsafe extern "C" fn(
        pCNGContentDecryptInfo: PCMSG_CNG_CONTENT_DECRYPT_INFO,
        pKeyAgreeDecryptPara: PCMSG_CTRL_KEY_AGREE_DECRYPT_PARA,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CMSG_CNG_IMPORT_CONTENT_ENCRYPT_KEY = ::std::option::Option<
    unsafe extern "C" fn(
        pCNGContentDecryptInfo: PCMSG_CNG_CONTENT_DECRYPT_INFO,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type HCERTSTORE = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CONTEXT {
    pub dwCertEncodingType: DWORD,
    pub pbCertEncoded: *mut BYTE,
    pub cbCertEncoded: DWORD,
    pub pCertInfo: PCERT_INFO,
    pub hCertStore: HCERTSTORE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CONTEXT"][::std::mem::size_of::<_CERT_CONTEXT>() - 40usize];
    ["Alignment of _CERT_CONTEXT"][::std::mem::align_of::<_CERT_CONTEXT>() - 8usize];
    ["Offset of field: _CERT_CONTEXT::dwCertEncodingType"]
        [::std::mem::offset_of!(_CERT_CONTEXT, dwCertEncodingType) - 0usize];
    ["Offset of field: _CERT_CONTEXT::pbCertEncoded"]
        [::std::mem::offset_of!(_CERT_CONTEXT, pbCertEncoded) - 8usize];
    ["Offset of field: _CERT_CONTEXT::cbCertEncoded"]
        [::std::mem::offset_of!(_CERT_CONTEXT, cbCertEncoded) - 16usize];
    ["Offset of field: _CERT_CONTEXT::pCertInfo"]
        [::std::mem::offset_of!(_CERT_CONTEXT, pCertInfo) - 24usize];
    ["Offset of field: _CERT_CONTEXT::hCertStore"]
        [::std::mem::offset_of!(_CERT_CONTEXT, hCertStore) - 32usize];
};
pub type CERT_CONTEXT = _CERT_CONTEXT;
pub type PCERT_CONTEXT = *mut _CERT_CONTEXT;
pub type PCCERT_CONTEXT = *const CERT_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_CONTEXT {
    pub dwCertEncodingType: DWORD,
    pub pbCrlEncoded: *mut BYTE,
    pub cbCrlEncoded: DWORD,
    pub pCrlInfo: PCRL_INFO,
    pub hCertStore: HCERTSTORE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_CONTEXT"][::std::mem::size_of::<_CRL_CONTEXT>() - 40usize];
    ["Alignment of _CRL_CONTEXT"][::std::mem::align_of::<_CRL_CONTEXT>() - 8usize];
    ["Offset of field: _CRL_CONTEXT::dwCertEncodingType"]
        [::std::mem::offset_of!(_CRL_CONTEXT, dwCertEncodingType) - 0usize];
    ["Offset of field: _CRL_CONTEXT::pbCrlEncoded"]
        [::std::mem::offset_of!(_CRL_CONTEXT, pbCrlEncoded) - 8usize];
    ["Offset of field: _CRL_CONTEXT::cbCrlEncoded"]
        [::std::mem::offset_of!(_CRL_CONTEXT, cbCrlEncoded) - 16usize];
    ["Offset of field: _CRL_CONTEXT::pCrlInfo"]
        [::std::mem::offset_of!(_CRL_CONTEXT, pCrlInfo) - 24usize];
    ["Offset of field: _CRL_CONTEXT::hCertStore"]
        [::std::mem::offset_of!(_CRL_CONTEXT, hCertStore) - 32usize];
};
pub type CRL_CONTEXT = _CRL_CONTEXT;
pub type PCRL_CONTEXT = *mut _CRL_CONTEXT;
pub type PCCRL_CONTEXT = *const CRL_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_CONTEXT {
    pub dwMsgAndCertEncodingType: DWORD,
    pub pbCtlEncoded: *mut BYTE,
    pub cbCtlEncoded: DWORD,
    pub pCtlInfo: PCTL_INFO,
    pub hCertStore: HCERTSTORE,
    pub hCryptMsg: HCRYPTMSG,
    pub pbCtlContent: *mut BYTE,
    pub cbCtlContent: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_CONTEXT"][::std::mem::size_of::<_CTL_CONTEXT>() - 64usize];
    ["Alignment of _CTL_CONTEXT"][::std::mem::align_of::<_CTL_CONTEXT>() - 8usize];
    ["Offset of field: _CTL_CONTEXT::dwMsgAndCertEncodingType"]
        [::std::mem::offset_of!(_CTL_CONTEXT, dwMsgAndCertEncodingType) - 0usize];
    ["Offset of field: _CTL_CONTEXT::pbCtlEncoded"]
        [::std::mem::offset_of!(_CTL_CONTEXT, pbCtlEncoded) - 8usize];
    ["Offset of field: _CTL_CONTEXT::cbCtlEncoded"]
        [::std::mem::offset_of!(_CTL_CONTEXT, cbCtlEncoded) - 16usize];
    ["Offset of field: _CTL_CONTEXT::pCtlInfo"]
        [::std::mem::offset_of!(_CTL_CONTEXT, pCtlInfo) - 24usize];
    ["Offset of field: _CTL_CONTEXT::hCertStore"]
        [::std::mem::offset_of!(_CTL_CONTEXT, hCertStore) - 32usize];
    ["Offset of field: _CTL_CONTEXT::hCryptMsg"]
        [::std::mem::offset_of!(_CTL_CONTEXT, hCryptMsg) - 40usize];
    ["Offset of field: _CTL_CONTEXT::pbCtlContent"]
        [::std::mem::offset_of!(_CTL_CONTEXT, pbCtlContent) - 48usize];
    ["Offset of field: _CTL_CONTEXT::cbCtlContent"]
        [::std::mem::offset_of!(_CTL_CONTEXT, cbCtlContent) - 56usize];
};
pub type CTL_CONTEXT = _CTL_CONTEXT;
pub type PCTL_CONTEXT = *mut _CTL_CONTEXT;
pub type PCCTL_CONTEXT = *const CTL_CONTEXT;
pub const CertKeyType_KeyTypeOther: CertKeyType = 0;
pub const CertKeyType_KeyTypeVirtualSmartCard: CertKeyType = 1;
pub const CertKeyType_KeyTypePhysicalSmartCard: CertKeyType = 2;
pub const CertKeyType_KeyTypePassport: CertKeyType = 3;
pub const CertKeyType_KeyTypePassportRemote: CertKeyType = 4;
pub const CertKeyType_KeyTypePassportSmartCard: CertKeyType = 5;
pub const CertKeyType_KeyTypeHardware: CertKeyType = 6;
pub const CertKeyType_KeyTypeSoftware: CertKeyType = 7;
pub const CertKeyType_KeyTypeSelfSigned: CertKeyType = 8;
pub type CertKeyType = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_KEY_PROV_PARAM {
    pub dwParam: DWORD,
    pub pbData: *mut BYTE,
    pub cbData: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_KEY_PROV_PARAM"][::std::mem::size_of::<_CRYPT_KEY_PROV_PARAM>() - 24usize];
    ["Alignment of _CRYPT_KEY_PROV_PARAM"]
        [::std::mem::align_of::<_CRYPT_KEY_PROV_PARAM>() - 8usize];
    ["Offset of field: _CRYPT_KEY_PROV_PARAM::dwParam"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_PARAM, dwParam) - 0usize];
    ["Offset of field: _CRYPT_KEY_PROV_PARAM::pbData"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_PARAM, pbData) - 8usize];
    ["Offset of field: _CRYPT_KEY_PROV_PARAM::cbData"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_PARAM, cbData) - 16usize];
    ["Offset of field: _CRYPT_KEY_PROV_PARAM::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_PARAM, dwFlags) - 20usize];
};
pub type CRYPT_KEY_PROV_PARAM = _CRYPT_KEY_PROV_PARAM;
pub type PCRYPT_KEY_PROV_PARAM = *mut _CRYPT_KEY_PROV_PARAM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_KEY_PROV_INFO {
    pub pwszContainerName: LPWSTR,
    pub pwszProvName: LPWSTR,
    pub dwProvType: DWORD,
    pub dwFlags: DWORD,
    pub cProvParam: DWORD,
    pub rgProvParam: PCRYPT_KEY_PROV_PARAM,
    pub dwKeySpec: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_KEY_PROV_INFO"][::std::mem::size_of::<_CRYPT_KEY_PROV_INFO>() - 48usize];
    ["Alignment of _CRYPT_KEY_PROV_INFO"][::std::mem::align_of::<_CRYPT_KEY_PROV_INFO>() - 8usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::pwszContainerName"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, pwszContainerName) - 0usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::pwszProvName"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, pwszProvName) - 8usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::dwProvType"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, dwProvType) - 16usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, dwFlags) - 20usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::cProvParam"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, cProvParam) - 24usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::rgProvParam"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, rgProvParam) - 32usize];
    ["Offset of field: _CRYPT_KEY_PROV_INFO::dwKeySpec"]
        [::std::mem::offset_of!(_CRYPT_KEY_PROV_INFO, dwKeySpec) - 40usize];
};
pub type CRYPT_KEY_PROV_INFO = _CRYPT_KEY_PROV_INFO;
pub type PCRYPT_KEY_PROV_INFO = *mut _CRYPT_KEY_PROV_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_KEY_CONTEXT {
    pub cbSize: DWORD,
    pub __bindgen_anon_1: _CERT_KEY_CONTEXT__bindgen_ty_1,
    pub dwKeySpec: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_KEY_CONTEXT__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_KEY_CONTEXT__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_KEY_CONTEXT__bindgen_ty_1>() - 8usize];
    ["Alignment of _CERT_KEY_CONTEXT__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_KEY_CONTEXT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_KEY_CONTEXT__bindgen_ty_1::hCryptProv"]
        [::std::mem::offset_of!(_CERT_KEY_CONTEXT__bindgen_ty_1, hCryptProv) - 0usize];
    ["Offset of field: _CERT_KEY_CONTEXT__bindgen_ty_1::hNCryptKey"]
        [::std::mem::offset_of!(_CERT_KEY_CONTEXT__bindgen_ty_1, hNCryptKey) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_KEY_CONTEXT"][::std::mem::size_of::<_CERT_KEY_CONTEXT>() - 24usize];
    ["Alignment of _CERT_KEY_CONTEXT"][::std::mem::align_of::<_CERT_KEY_CONTEXT>() - 8usize];
    ["Offset of field: _CERT_KEY_CONTEXT::cbSize"]
        [::std::mem::offset_of!(_CERT_KEY_CONTEXT, cbSize) - 0usize];
    ["Offset of field: _CERT_KEY_CONTEXT::dwKeySpec"]
        [::std::mem::offset_of!(_CERT_KEY_CONTEXT, dwKeySpec) - 16usize];
};
pub type CERT_KEY_CONTEXT = _CERT_KEY_CONTEXT;
pub type PCERT_KEY_CONTEXT = *mut _CERT_KEY_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ROOT_INFO_LUID {
    pub LowPart: DWORD,
    pub HighPart: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ROOT_INFO_LUID"][::std::mem::size_of::<_ROOT_INFO_LUID>() - 8usize];
    ["Alignment of _ROOT_INFO_LUID"][::std::mem::align_of::<_ROOT_INFO_LUID>() - 4usize];
    ["Offset of field: _ROOT_INFO_LUID::LowPart"]
        [::std::mem::offset_of!(_ROOT_INFO_LUID, LowPart) - 0usize];
    ["Offset of field: _ROOT_INFO_LUID::HighPart"]
        [::std::mem::offset_of!(_ROOT_INFO_LUID, HighPart) - 4usize];
};
pub type ROOT_INFO_LUID = _ROOT_INFO_LUID;
pub type PROOT_INFO_LUID = *mut _ROOT_INFO_LUID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_SMART_CARD_ROOT_INFO {
    pub rgbCardID: [BYTE; 16usize],
    pub luid: ROOT_INFO_LUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_SMART_CARD_ROOT_INFO"]
        [::std::mem::size_of::<_CRYPT_SMART_CARD_ROOT_INFO>() - 24usize];
    ["Alignment of _CRYPT_SMART_CARD_ROOT_INFO"]
        [::std::mem::align_of::<_CRYPT_SMART_CARD_ROOT_INFO>() - 4usize];
    ["Offset of field: _CRYPT_SMART_CARD_ROOT_INFO::rgbCardID"]
        [::std::mem::offset_of!(_CRYPT_SMART_CARD_ROOT_INFO, rgbCardID) - 0usize];
    ["Offset of field: _CRYPT_SMART_CARD_ROOT_INFO::luid"]
        [::std::mem::offset_of!(_CRYPT_SMART_CARD_ROOT_INFO, luid) - 16usize];
};
pub type CRYPT_SMART_CARD_ROOT_INFO = _CRYPT_SMART_CARD_ROOT_INFO;
pub type PCRYPT_SMART_CARD_ROOT_INFO = *mut _CRYPT_SMART_CARD_ROOT_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CERT_SYSTEM_STORE_RELOCATE_PARA {
    pub __bindgen_anon_1: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1,
    pub __bindgen_anon_2: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1 {
    pub hKeyBase: HKEY,
    pub pvBase: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1::hKeyBase"]
        [::std::mem::offset_of!(_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1, hKeyBase) - 0usize];
    ["Offset of field: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1::pvBase"]
        [::std::mem::offset_of!(_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_1, pvBase) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2 {
    pub pvSystemStore: *mut ::std::os::raw::c_void,
    pub pszSystemStore: LPCSTR,
    pub pwszSystemStore: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2"]
        [::std::mem::size_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2>() - 8usize];
    ["Alignment of _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2"]
        [::std::mem::align_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2>() - 8usize];
    ["Offset of field: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2::pvSystemStore"][::std::mem::offset_of!(
        _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2,
        pvSystemStore
    ) - 0usize];
    ["Offset of field: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2::pszSystemStore"][::std::mem::offset_of!(
        _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2,
        pszSystemStore
    ) - 0usize];
    ["Offset of field: _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2::pwszSystemStore"][::std::mem::offset_of!(
        _CERT_SYSTEM_STORE_RELOCATE_PARA__bindgen_ty_2,
        pwszSystemStore
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SYSTEM_STORE_RELOCATE_PARA"]
        [::std::mem::size_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA>() - 16usize];
    ["Alignment of _CERT_SYSTEM_STORE_RELOCATE_PARA"]
        [::std::mem::align_of::<_CERT_SYSTEM_STORE_RELOCATE_PARA>() - 8usize];
};
pub type CERT_SYSTEM_STORE_RELOCATE_PARA = _CERT_SYSTEM_STORE_RELOCATE_PARA;
pub type PCERT_SYSTEM_STORE_RELOCATE_PARA = *mut _CERT_SYSTEM_STORE_RELOCATE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REGISTRY_STORE_CLIENT_GPT_PARA {
    pub hKeyBase: HKEY,
    pub pwszRegPath: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REGISTRY_STORE_CLIENT_GPT_PARA"]
        [::std::mem::size_of::<_CERT_REGISTRY_STORE_CLIENT_GPT_PARA>() - 16usize];
    ["Alignment of _CERT_REGISTRY_STORE_CLIENT_GPT_PARA"]
        [::std::mem::align_of::<_CERT_REGISTRY_STORE_CLIENT_GPT_PARA>() - 8usize];
    ["Offset of field: _CERT_REGISTRY_STORE_CLIENT_GPT_PARA::hKeyBase"]
        [::std::mem::offset_of!(_CERT_REGISTRY_STORE_CLIENT_GPT_PARA, hKeyBase) - 0usize];
    ["Offset of field: _CERT_REGISTRY_STORE_CLIENT_GPT_PARA::pwszRegPath"]
        [::std::mem::offset_of!(_CERT_REGISTRY_STORE_CLIENT_GPT_PARA, pwszRegPath) - 8usize];
};
pub type CERT_REGISTRY_STORE_CLIENT_GPT_PARA = _CERT_REGISTRY_STORE_CLIENT_GPT_PARA;
pub type PCERT_REGISTRY_STORE_CLIENT_GPT_PARA = *mut _CERT_REGISTRY_STORE_CLIENT_GPT_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REGISTRY_STORE_ROAMING_PARA {
    pub hKey: HKEY,
    pub pwszStoreDirectory: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REGISTRY_STORE_ROAMING_PARA"]
        [::std::mem::size_of::<_CERT_REGISTRY_STORE_ROAMING_PARA>() - 16usize];
    ["Alignment of _CERT_REGISTRY_STORE_ROAMING_PARA"]
        [::std::mem::align_of::<_CERT_REGISTRY_STORE_ROAMING_PARA>() - 8usize];
    ["Offset of field: _CERT_REGISTRY_STORE_ROAMING_PARA::hKey"]
        [::std::mem::offset_of!(_CERT_REGISTRY_STORE_ROAMING_PARA, hKey) - 0usize];
    ["Offset of field: _CERT_REGISTRY_STORE_ROAMING_PARA::pwszStoreDirectory"]
        [::std::mem::offset_of!(_CERT_REGISTRY_STORE_ROAMING_PARA, pwszStoreDirectory) - 8usize];
};
pub type CERT_REGISTRY_STORE_ROAMING_PARA = _CERT_REGISTRY_STORE_ROAMING_PARA;
pub type PCERT_REGISTRY_STORE_ROAMING_PARA = *mut _CERT_REGISTRY_STORE_ROAMING_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_LDAP_STORE_OPENED_PARA {
    pub pvLdapSessionHandle: *mut ::std::os::raw::c_void,
    pub pwszLdapUrl: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_LDAP_STORE_OPENED_PARA"]
        [::std::mem::size_of::<_CERT_LDAP_STORE_OPENED_PARA>() - 16usize];
    ["Alignment of _CERT_LDAP_STORE_OPENED_PARA"]
        [::std::mem::align_of::<_CERT_LDAP_STORE_OPENED_PARA>() - 8usize];
    ["Offset of field: _CERT_LDAP_STORE_OPENED_PARA::pvLdapSessionHandle"]
        [::std::mem::offset_of!(_CERT_LDAP_STORE_OPENED_PARA, pvLdapSessionHandle) - 0usize];
    ["Offset of field: _CERT_LDAP_STORE_OPENED_PARA::pwszLdapUrl"]
        [::std::mem::offset_of!(_CERT_LDAP_STORE_OPENED_PARA, pwszLdapUrl) - 8usize];
};
pub type CERT_LDAP_STORE_OPENED_PARA = _CERT_LDAP_STORE_OPENED_PARA;
pub type PCERT_LDAP_STORE_OPENED_PARA = *mut _CERT_LDAP_STORE_OPENED_PARA;
unsafe extern "C" {
    pub fn CertOpenStore(
        lpszStoreProvider: LPCSTR,
        dwEncodingType: DWORD,
        hCryptProv: HCRYPTPROV_LEGACY,
        dwFlags: DWORD,
        pvPara: *const ::std::os::raw::c_void,
    ) -> HCERTSTORE;
}
pub type HCERTSTOREPROV = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_STORE_PROV_INFO {
    pub cbSize: DWORD,
    pub cStoreProvFunc: DWORD,
    pub rgpvStoreProvFunc: *mut *mut ::std::os::raw::c_void,
    pub hStoreProv: HCERTSTOREPROV,
    pub dwStoreProvFlags: DWORD,
    pub hStoreProvFuncAddr2: HCRYPTOIDFUNCADDR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_STORE_PROV_INFO"][::std::mem::size_of::<_CERT_STORE_PROV_INFO>() - 40usize];
    ["Alignment of _CERT_STORE_PROV_INFO"]
        [::std::mem::align_of::<_CERT_STORE_PROV_INFO>() - 8usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::cStoreProvFunc"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, cStoreProvFunc) - 4usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::rgpvStoreProvFunc"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, rgpvStoreProvFunc) - 8usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::hStoreProv"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, hStoreProv) - 16usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::dwStoreProvFlags"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, dwStoreProvFlags) - 24usize];
    ["Offset of field: _CERT_STORE_PROV_INFO::hStoreProvFuncAddr2"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_INFO, hStoreProvFuncAddr2) - 32usize];
};
pub type CERT_STORE_PROV_INFO = _CERT_STORE_PROV_INFO;
pub type PCERT_STORE_PROV_INFO = *mut _CERT_STORE_PROV_INFO;
pub type PFN_CERT_DLL_OPEN_STORE_PROV_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        lpszStoreProvider: LPCSTR,
        dwEncodingType: DWORD,
        hCryptProv: HCRYPTPROV_LEGACY,
        dwFlags: DWORD,
        pvPara: *const ::std::os::raw::c_void,
        hCertStore: HCERTSTORE,
        pStoreProvInfo: PCERT_STORE_PROV_INFO,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_CLOSE =
    ::std::option::Option<unsafe extern "C" fn(hStoreProv: HCERTSTOREPROV, dwFlags: DWORD)>;
pub type PFN_CERT_STORE_PROV_READ_CERT = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pStoreCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
        ppProvCertContext: *mut PCCERT_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_WRITE_CERT = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_DELETE_CERT = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_SET_CERT_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCertContext: PCCERT_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_READ_CRL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pStoreCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
        ppProvCrlContext: *mut PCCRL_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_WRITE_CRL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_DELETE_CRL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_SET_CRL_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCrlContext: PCCRL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_READ_CTL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pStoreCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
        ppProvCtlContext: *mut PCCTL_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_WRITE_CTL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_DELETE_CTL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_SET_CTL_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCtlContext: PCCTL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_CONTROL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        dwFlags: DWORD,
        dwCtrlType: DWORD,
        pvCtrlPara: *const ::std::os::raw::c_void,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_STORE_PROV_FIND_INFO {
    pub cbSize: DWORD,
    pub dwMsgAndCertEncodingType: DWORD,
    pub dwFindFlags: DWORD,
    pub dwFindType: DWORD,
    pub pvFindPara: *const ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_STORE_PROV_FIND_INFO"]
        [::std::mem::size_of::<_CERT_STORE_PROV_FIND_INFO>() - 24usize];
    ["Alignment of _CERT_STORE_PROV_FIND_INFO"]
        [::std::mem::align_of::<_CERT_STORE_PROV_FIND_INFO>() - 8usize];
    ["Offset of field: _CERT_STORE_PROV_FIND_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_FIND_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_STORE_PROV_FIND_INFO::dwMsgAndCertEncodingType"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_FIND_INFO, dwMsgAndCertEncodingType) - 4usize];
    ["Offset of field: _CERT_STORE_PROV_FIND_INFO::dwFindFlags"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_FIND_INFO, dwFindFlags) - 8usize];
    ["Offset of field: _CERT_STORE_PROV_FIND_INFO::dwFindType"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_FIND_INFO, dwFindType) - 12usize];
    ["Offset of field: _CERT_STORE_PROV_FIND_INFO::pvFindPara"]
        [::std::mem::offset_of!(_CERT_STORE_PROV_FIND_INFO, pvFindPara) - 16usize];
};
pub type CERT_STORE_PROV_FIND_INFO = _CERT_STORE_PROV_FIND_INFO;
pub type PCERT_STORE_PROV_FIND_INFO = *mut _CERT_STORE_PROV_FIND_INFO;
pub type CCERT_STORE_PROV_FIND_INFO = CERT_STORE_PROV_FIND_INFO;
pub type PCCERT_STORE_PROV_FIND_INFO = *const CERT_STORE_PROV_FIND_INFO;
pub type PFN_CERT_STORE_PROV_FIND_CERT = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pFindInfo: PCCERT_STORE_PROV_FIND_INFO,
        pPrevCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
        ppvStoreProvFindInfo: *mut *mut ::std::os::raw::c_void,
        ppProvCertContext: *mut PCCERT_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_FREE_FIND_CERT = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCertContext: PCCERT_CONTEXT,
        pvStoreProvFindInfo: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_GET_CERT_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCertContext: PCCERT_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_FIND_CRL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pFindInfo: PCCERT_STORE_PROV_FIND_INFO,
        pPrevCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
        ppvStoreProvFindInfo: *mut *mut ::std::os::raw::c_void,
        ppProvCrlContext: *mut PCCRL_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_FREE_FIND_CRL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCrlContext: PCCRL_CONTEXT,
        pvStoreProvFindInfo: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_GET_CRL_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCrlContext: PCCRL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_FIND_CTL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pFindInfo: PCCERT_STORE_PROV_FIND_INFO,
        pPrevCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
        ppvStoreProvFindInfo: *mut *mut ::std::os::raw::c_void,
        ppProvCtlContext: *mut PCCTL_CONTEXT,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_FREE_FIND_CTL = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCtlContext: PCCTL_CONTEXT,
        pvStoreProvFindInfo: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL,
>;
pub type PFN_CERT_STORE_PROV_GET_CTL_PROPERTY = ::std::option::Option<
    unsafe extern "C" fn(
        hStoreProv: HCERTSTOREPROV,
        pCtlContext: PCCTL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CertDuplicateStore(hCertStore: HCERTSTORE) -> HCERTSTORE;
}
unsafe extern "C" {
    pub fn CertSaveStore(
        hCertStore: HCERTSTORE,
        dwEncodingType: DWORD,
        dwSaveAs: DWORD,
        dwSaveTo: DWORD,
        pvSaveToPara: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertCloseStore(hCertStore: HCERTSTORE, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetSubjectCertificateFromStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        pCertId: PCERT_INFO,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertEnumCertificatesInStore(
        hCertStore: HCERTSTORE,
        pPrevCertContext: PCCERT_CONTEXT,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFindCertificateInStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        dwFindFlags: DWORD,
        dwFindType: DWORD,
        pvFindPara: *const ::std::os::raw::c_void,
        pPrevCertContext: PCCERT_CONTEXT,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertGetIssuerCertificateFromStore(
        hCertStore: HCERTSTORE,
        pSubjectContext: PCCERT_CONTEXT,
        pPrevIssuerContext: PCCERT_CONTEXT,
        pdwFlags: *mut DWORD,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertVerifySubjectCertificateContext(
        pSubject: PCCERT_CONTEXT,
        pIssuer: PCCERT_CONTEXT,
        pdwFlags: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertDuplicateCertificateContext(pCertContext: PCCERT_CONTEXT) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertCreateCertificateContext(
        dwCertEncodingType: DWORD,
        pbCertEncoded: *const BYTE,
        cbCertEncoded: DWORD,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFreeCertificateContext(pCertContext: PCCERT_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetCertificateContextProperty(
        pCertContext: PCCERT_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetCertificateContextProperty(
        pCertContext: PCCERT_CONTEXT,
        dwPropId: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumCertificateContextProperties(
        pCertContext: PCCERT_CONTEXT,
        dwPropId: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertCreateCTLEntryFromCertificateContextProperties(
        pCertContext: PCCERT_CONTEXT,
        cOptAttr: DWORD,
        rgOptAttr: PCRYPT_ATTRIBUTE,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pCtlEntry: PCTL_ENTRY,
        pcbCtlEntry: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetCertificateContextPropertiesFromCTLEntry(
        pCertContext: PCCERT_CONTEXT,
        pCtlEntry: PCTL_ENTRY,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetCRLFromStore(
        hCertStore: HCERTSTORE,
        pIssuerContext: PCCERT_CONTEXT,
        pPrevCrlContext: PCCRL_CONTEXT,
        pdwFlags: *mut DWORD,
    ) -> PCCRL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertEnumCRLsInStore(
        hCertStore: HCERTSTORE,
        pPrevCrlContext: PCCRL_CONTEXT,
    ) -> PCCRL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFindCRLInStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        dwFindFlags: DWORD,
        dwFindType: DWORD,
        pvFindPara: *const ::std::os::raw::c_void,
        pPrevCrlContext: PCCRL_CONTEXT,
    ) -> PCCRL_CONTEXT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_FIND_ISSUED_FOR_PARA {
    pub pSubjectCert: PCCERT_CONTEXT,
    pub pIssuerCert: PCCERT_CONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_FIND_ISSUED_FOR_PARA"]
        [::std::mem::size_of::<_CRL_FIND_ISSUED_FOR_PARA>() - 16usize];
    ["Alignment of _CRL_FIND_ISSUED_FOR_PARA"]
        [::std::mem::align_of::<_CRL_FIND_ISSUED_FOR_PARA>() - 8usize];
    ["Offset of field: _CRL_FIND_ISSUED_FOR_PARA::pSubjectCert"]
        [::std::mem::offset_of!(_CRL_FIND_ISSUED_FOR_PARA, pSubjectCert) - 0usize];
    ["Offset of field: _CRL_FIND_ISSUED_FOR_PARA::pIssuerCert"]
        [::std::mem::offset_of!(_CRL_FIND_ISSUED_FOR_PARA, pIssuerCert) - 8usize];
};
pub type CRL_FIND_ISSUED_FOR_PARA = _CRL_FIND_ISSUED_FOR_PARA;
pub type PCRL_FIND_ISSUED_FOR_PARA = *mut _CRL_FIND_ISSUED_FOR_PARA;
unsafe extern "C" {
    pub fn CertDuplicateCRLContext(pCrlContext: PCCRL_CONTEXT) -> PCCRL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertCreateCRLContext(
        dwCertEncodingType: DWORD,
        pbCrlEncoded: *const BYTE,
        cbCrlEncoded: DWORD,
    ) -> PCCRL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFreeCRLContext(pCrlContext: PCCRL_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetCRLContextProperty(
        pCrlContext: PCCRL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetCRLContextProperty(
        pCrlContext: PCCRL_CONTEXT,
        dwPropId: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumCRLContextProperties(pCrlContext: PCCRL_CONTEXT, dwPropId: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CertFindCertificateInCRL(
        pCert: PCCERT_CONTEXT,
        pCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        ppCrlEntry: *mut PCRL_ENTRY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertIsValidCRLForCertificate(
        pCert: PCCERT_CONTEXT,
        pCrl: PCCRL_CONTEXT,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddEncodedCertificateToStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        pbCertEncoded: *const BYTE,
        cbCertEncoded: DWORD,
        dwAddDisposition: DWORD,
        ppCertContext: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCertificateContextToStore(
        hCertStore: HCERTSTORE,
        pCertContext: PCCERT_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddSerializedElementToStore(
        hCertStore: HCERTSTORE,
        pbElement: *const BYTE,
        cbElement: DWORD,
        dwAddDisposition: DWORD,
        dwFlags: DWORD,
        dwContextTypeFlags: DWORD,
        pdwContextType: *mut DWORD,
        ppvContext: *mut *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertDeleteCertificateFromStore(pCertContext: PCCERT_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddEncodedCRLToStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        pbCrlEncoded: *const BYTE,
        cbCrlEncoded: DWORD,
        dwAddDisposition: DWORD,
        ppCrlContext: *mut PCCRL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCRLContextToStore(
        hCertStore: HCERTSTORE,
        pCrlContext: PCCRL_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCRL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertDeleteCRLFromStore(pCrlContext: PCCRL_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSerializeCertificateStoreElement(
        pCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
        pbElement: *mut BYTE,
        pcbElement: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSerializeCRLStoreElement(
        pCrlContext: PCCRL_CONTEXT,
        dwFlags: DWORD,
        pbElement: *mut BYTE,
        pcbElement: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertDuplicateCTLContext(pCtlContext: PCCTL_CONTEXT) -> PCCTL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertCreateCTLContext(
        dwMsgAndCertEncodingType: DWORD,
        pbCtlEncoded: *const BYTE,
        cbCtlEncoded: DWORD,
    ) -> PCCTL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFreeCTLContext(pCtlContext: PCCTL_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetCTLContextProperty(
        pCtlContext: PCCTL_CONTEXT,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetCTLContextProperty(
        pCtlContext: PCCTL_CONTEXT,
        dwPropId: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumCTLContextProperties(pCtlContext: PCCTL_CONTEXT, dwPropId: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn CertEnumCTLsInStore(
        hCertStore: HCERTSTORE,
        pPrevCtlContext: PCCTL_CONTEXT,
    ) -> PCCTL_CONTEXT;
}
unsafe extern "C" {
    pub fn CertFindSubjectInCTL(
        dwEncodingType: DWORD,
        dwSubjectType: DWORD,
        pvSubject: *mut ::std::os::raw::c_void,
        pCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
    ) -> PCTL_ENTRY;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_ANY_SUBJECT_INFO {
    pub SubjectAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub SubjectIdentifier: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_ANY_SUBJECT_INFO"][::std::mem::size_of::<_CTL_ANY_SUBJECT_INFO>() - 40usize];
    ["Alignment of _CTL_ANY_SUBJECT_INFO"]
        [::std::mem::align_of::<_CTL_ANY_SUBJECT_INFO>() - 8usize];
    ["Offset of field: _CTL_ANY_SUBJECT_INFO::SubjectAlgorithm"]
        [::std::mem::offset_of!(_CTL_ANY_SUBJECT_INFO, SubjectAlgorithm) - 0usize];
    ["Offset of field: _CTL_ANY_SUBJECT_INFO::SubjectIdentifier"]
        [::std::mem::offset_of!(_CTL_ANY_SUBJECT_INFO, SubjectIdentifier) - 24usize];
};
pub type CTL_ANY_SUBJECT_INFO = _CTL_ANY_SUBJECT_INFO;
pub type PCTL_ANY_SUBJECT_INFO = *mut _CTL_ANY_SUBJECT_INFO;
unsafe extern "C" {
    pub fn CertFindCTLInStore(
        hCertStore: HCERTSTORE,
        dwMsgAndCertEncodingType: DWORD,
        dwFindFlags: DWORD,
        dwFindType: DWORD,
        pvFindPara: *const ::std::os::raw::c_void,
        pPrevCtlContext: PCCTL_CONTEXT,
    ) -> PCCTL_CONTEXT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_FIND_USAGE_PARA {
    pub cbSize: DWORD,
    pub SubjectUsage: CTL_USAGE,
    pub ListIdentifier: CRYPT_DATA_BLOB,
    pub pSigner: PCERT_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_FIND_USAGE_PARA"][::std::mem::size_of::<_CTL_FIND_USAGE_PARA>() - 48usize];
    ["Alignment of _CTL_FIND_USAGE_PARA"][::std::mem::align_of::<_CTL_FIND_USAGE_PARA>() - 8usize];
    ["Offset of field: _CTL_FIND_USAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CTL_FIND_USAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CTL_FIND_USAGE_PARA::SubjectUsage"]
        [::std::mem::offset_of!(_CTL_FIND_USAGE_PARA, SubjectUsage) - 8usize];
    ["Offset of field: _CTL_FIND_USAGE_PARA::ListIdentifier"]
        [::std::mem::offset_of!(_CTL_FIND_USAGE_PARA, ListIdentifier) - 24usize];
    ["Offset of field: _CTL_FIND_USAGE_PARA::pSigner"]
        [::std::mem::offset_of!(_CTL_FIND_USAGE_PARA, pSigner) - 40usize];
};
pub type CTL_FIND_USAGE_PARA = _CTL_FIND_USAGE_PARA;
pub type PCTL_FIND_USAGE_PARA = *mut _CTL_FIND_USAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_FIND_SUBJECT_PARA {
    pub cbSize: DWORD,
    pub pUsagePara: PCTL_FIND_USAGE_PARA,
    pub dwSubjectType: DWORD,
    pub pvSubject: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_FIND_SUBJECT_PARA"][::std::mem::size_of::<_CTL_FIND_SUBJECT_PARA>() - 32usize];
    ["Alignment of _CTL_FIND_SUBJECT_PARA"]
        [::std::mem::align_of::<_CTL_FIND_SUBJECT_PARA>() - 8usize];
    ["Offset of field: _CTL_FIND_SUBJECT_PARA::cbSize"]
        [::std::mem::offset_of!(_CTL_FIND_SUBJECT_PARA, cbSize) - 0usize];
    ["Offset of field: _CTL_FIND_SUBJECT_PARA::pUsagePara"]
        [::std::mem::offset_of!(_CTL_FIND_SUBJECT_PARA, pUsagePara) - 8usize];
    ["Offset of field: _CTL_FIND_SUBJECT_PARA::dwSubjectType"]
        [::std::mem::offset_of!(_CTL_FIND_SUBJECT_PARA, dwSubjectType) - 16usize];
    ["Offset of field: _CTL_FIND_SUBJECT_PARA::pvSubject"]
        [::std::mem::offset_of!(_CTL_FIND_SUBJECT_PARA, pvSubject) - 24usize];
};
pub type CTL_FIND_SUBJECT_PARA = _CTL_FIND_SUBJECT_PARA;
pub type PCTL_FIND_SUBJECT_PARA = *mut _CTL_FIND_SUBJECT_PARA;
unsafe extern "C" {
    pub fn CertAddEncodedCTLToStore(
        hCertStore: HCERTSTORE,
        dwMsgAndCertEncodingType: DWORD,
        pbCtlEncoded: *const BYTE,
        cbCtlEncoded: DWORD,
        dwAddDisposition: DWORD,
        ppCtlContext: *mut PCCTL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCTLContextToStore(
        hCertStore: HCERTSTORE,
        pCtlContext: PCCTL_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCTL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSerializeCTLStoreElement(
        pCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
        pbElement: *mut BYTE,
        pcbElement: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertDeleteCTLFromStore(pCtlContext: PCCTL_CONTEXT) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCertificateLinkToStore(
        hCertStore: HCERTSTORE,
        pCertContext: PCCERT_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCRLLinkToStore(
        hCertStore: HCERTSTORE,
        pCrlContext: PCCRL_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCRL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddCTLLinkToStore(
        hCertStore: HCERTSTORE,
        pCtlContext: PCCTL_CONTEXT,
        dwAddDisposition: DWORD,
        ppStoreContext: *mut PCCTL_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddStoreToCollection(
        hCollectionStore: HCERTSTORE,
        hSiblingStore: HCERTSTORE,
        dwUpdateFlags: DWORD,
        dwPriority: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertRemoveStoreFromCollection(hCollectionStore: HCERTSTORE, hSiblingStore: HCERTSTORE);
}
unsafe extern "C" {
    pub fn CertControlStore(
        hCertStore: HCERTSTORE,
        dwFlags: DWORD,
        dwCtrlType: DWORD,
        pvCtrlPara: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetStoreProperty(
        hCertStore: HCERTSTORE,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetStoreProperty(
        hCertStore: HCERTSTORE,
        dwPropId: DWORD,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CERT_CREATE_CONTEXT_SORT_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        cbTotalEncoded: DWORD,
        cbRemainEncoded: DWORD,
        cEntry: DWORD,
        pvSort: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CREATE_CONTEXT_PARA {
    pub cbSize: DWORD,
    pub pfnFree: PFN_CRYPT_FREE,
    pub pvFree: *mut ::std::os::raw::c_void,
    pub pfnSort: PFN_CERT_CREATE_CONTEXT_SORT_FUNC,
    pub pvSort: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CREATE_CONTEXT_PARA"]
        [::std::mem::size_of::<_CERT_CREATE_CONTEXT_PARA>() - 40usize];
    ["Alignment of _CERT_CREATE_CONTEXT_PARA"]
        [::std::mem::align_of::<_CERT_CREATE_CONTEXT_PARA>() - 8usize];
    ["Offset of field: _CERT_CREATE_CONTEXT_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_CREATE_CONTEXT_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_CREATE_CONTEXT_PARA::pfnFree"]
        [::std::mem::offset_of!(_CERT_CREATE_CONTEXT_PARA, pfnFree) - 8usize];
    ["Offset of field: _CERT_CREATE_CONTEXT_PARA::pvFree"]
        [::std::mem::offset_of!(_CERT_CREATE_CONTEXT_PARA, pvFree) - 16usize];
    ["Offset of field: _CERT_CREATE_CONTEXT_PARA::pfnSort"]
        [::std::mem::offset_of!(_CERT_CREATE_CONTEXT_PARA, pfnSort) - 24usize];
    ["Offset of field: _CERT_CREATE_CONTEXT_PARA::pvSort"]
        [::std::mem::offset_of!(_CERT_CREATE_CONTEXT_PARA, pvSort) - 32usize];
};
pub type CERT_CREATE_CONTEXT_PARA = _CERT_CREATE_CONTEXT_PARA;
pub type PCERT_CREATE_CONTEXT_PARA = *mut _CERT_CREATE_CONTEXT_PARA;
unsafe extern "C" {
    pub fn CertCreateContext(
        dwContextType: DWORD,
        dwEncodingType: DWORD,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        dwFlags: DWORD,
        pCreatePara: PCERT_CREATE_CONTEXT_PARA,
    ) -> *const ::std::os::raw::c_void;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SYSTEM_STORE_INFO {
    pub cbSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SYSTEM_STORE_INFO"][::std::mem::size_of::<_CERT_SYSTEM_STORE_INFO>() - 4usize];
    ["Alignment of _CERT_SYSTEM_STORE_INFO"]
        [::std::mem::align_of::<_CERT_SYSTEM_STORE_INFO>() - 4usize];
    ["Offset of field: _CERT_SYSTEM_STORE_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_SYSTEM_STORE_INFO, cbSize) - 0usize];
};
pub type CERT_SYSTEM_STORE_INFO = _CERT_SYSTEM_STORE_INFO;
pub type PCERT_SYSTEM_STORE_INFO = *mut _CERT_SYSTEM_STORE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_PHYSICAL_STORE_INFO {
    pub cbSize: DWORD,
    pub pszOpenStoreProvider: LPSTR,
    pub dwOpenEncodingType: DWORD,
    pub dwOpenFlags: DWORD,
    pub OpenParameters: CRYPT_DATA_BLOB,
    pub dwFlags: DWORD,
    pub dwPriority: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_PHYSICAL_STORE_INFO"]
        [::std::mem::size_of::<_CERT_PHYSICAL_STORE_INFO>() - 48usize];
    ["Alignment of _CERT_PHYSICAL_STORE_INFO"]
        [::std::mem::align_of::<_CERT_PHYSICAL_STORE_INFO>() - 8usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::pszOpenStoreProvider"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, pszOpenStoreProvider) - 8usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::dwOpenEncodingType"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, dwOpenEncodingType) - 16usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::dwOpenFlags"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, dwOpenFlags) - 20usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::OpenParameters"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, OpenParameters) - 24usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::dwFlags"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, dwFlags) - 40usize];
    ["Offset of field: _CERT_PHYSICAL_STORE_INFO::dwPriority"]
        [::std::mem::offset_of!(_CERT_PHYSICAL_STORE_INFO, dwPriority) - 44usize];
};
pub type CERT_PHYSICAL_STORE_INFO = _CERT_PHYSICAL_STORE_INFO;
pub type PCERT_PHYSICAL_STORE_INFO = *mut _CERT_PHYSICAL_STORE_INFO;
unsafe extern "C" {
    pub fn CertRegisterSystemStore(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pStoreInfo: PCERT_SYSTEM_STORE_INFO,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertRegisterPhysicalStore(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pwszStoreName: LPCWSTR,
        pStoreInfo: PCERT_PHYSICAL_STORE_INFO,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertUnregisterSystemStore(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertUnregisterPhysicalStore(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pwszStoreName: LPCWSTR,
    ) -> BOOL;
}
pub type PFN_CERT_ENUM_SYSTEM_STORE_LOCATION = ::std::option::Option<
    unsafe extern "C" fn(
        pwszStoreLocation: LPCWSTR,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CERT_ENUM_SYSTEM_STORE = ::std::option::Option<
    unsafe extern "C" fn(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pStoreInfo: PCERT_SYSTEM_STORE_INFO,
        pvReserved: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
pub type PFN_CERT_ENUM_PHYSICAL_STORE = ::std::option::Option<
    unsafe extern "C" fn(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pwszStoreName: LPCWSTR,
        pStoreInfo: PCERT_PHYSICAL_STORE_INFO,
        pvReserved: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CertEnumSystemStoreLocation(
        dwFlags: DWORD,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnum: PFN_CERT_ENUM_SYSTEM_STORE_LOCATION,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumSystemStore(
        dwFlags: DWORD,
        pvSystemStoreLocationPara: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnum: PFN_CERT_ENUM_SYSTEM_STORE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumPhysicalStore(
        pvSystemStore: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnum: PFN_CERT_ENUM_PHYSICAL_STORE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetEnhancedKeyUsage(
        pCertContext: PCCERT_CONTEXT,
        dwFlags: DWORD,
        pUsage: PCERT_ENHKEY_USAGE,
        pcbUsage: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertSetEnhancedKeyUsage(
        pCertContext: PCCERT_CONTEXT,
        pUsage: PCERT_ENHKEY_USAGE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddEnhancedKeyUsageIdentifier(
        pCertContext: PCCERT_CONTEXT,
        pszUsageIdentifier: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertRemoveEnhancedKeyUsageIdentifier(
        pCertContext: PCCERT_CONTEXT,
        pszUsageIdentifier: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetValidUsages(
        cCerts: DWORD,
        rghCerts: *mut PCCERT_CONTEXT,
        cNumOIDs: *mut ::std::os::raw::c_int,
        rghOIDs: *mut LPSTR,
        pcbOIDs: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgGetAndVerifySigner(
        hCryptMsg: HCRYPTMSG,
        cSignerStore: DWORD,
        rghSignerStore: *mut HCERTSTORE,
        dwFlags: DWORD,
        ppSigner: *mut PCCERT_CONTEXT,
        pdwSignerIndex: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgSignCTL(
        dwMsgEncodingType: DWORD,
        pbCtlContent: *mut BYTE,
        cbCtlContent: DWORD,
        pSignInfo: PCMSG_SIGNED_ENCODE_INFO,
        dwFlags: DWORD,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMsgEncodeAndSignCTL(
        dwMsgEncodingType: DWORD,
        pCtlInfo: PCTL_INFO,
        pSignInfo: PCMSG_SIGNED_ENCODE_INFO,
        dwFlags: DWORD,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertFindSubjectInSortedCTL(
        pSubjectIdentifier: PCRYPT_DATA_BLOB,
        pCtlContext: PCCTL_CONTEXT,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pEncodedAttributes: PCRYPT_DER_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertEnumSubjectInSortedCTL(
        pCtlContext: PCCTL_CONTEXT,
        ppvNextSubject: *mut *mut ::std::os::raw::c_void,
        pSubjectIdentifier: PCRYPT_DER_BLOB,
        pEncodedAttributes: PCRYPT_DER_BLOB,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_VERIFY_USAGE_PARA {
    pub cbSize: DWORD,
    pub ListIdentifier: CRYPT_DATA_BLOB,
    pub cCtlStore: DWORD,
    pub rghCtlStore: *mut HCERTSTORE,
    pub cSignerStore: DWORD,
    pub rghSignerStore: *mut HCERTSTORE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_VERIFY_USAGE_PARA"][::std::mem::size_of::<_CTL_VERIFY_USAGE_PARA>() - 56usize];
    ["Alignment of _CTL_VERIFY_USAGE_PARA"]
        [::std::mem::align_of::<_CTL_VERIFY_USAGE_PARA>() - 8usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::ListIdentifier"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, ListIdentifier) - 8usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::cCtlStore"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, cCtlStore) - 24usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::rghCtlStore"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, rghCtlStore) - 32usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::cSignerStore"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, cSignerStore) - 40usize];
    ["Offset of field: _CTL_VERIFY_USAGE_PARA::rghSignerStore"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_PARA, rghSignerStore) - 48usize];
};
pub type CTL_VERIFY_USAGE_PARA = _CTL_VERIFY_USAGE_PARA;
pub type PCTL_VERIFY_USAGE_PARA = *mut _CTL_VERIFY_USAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_VERIFY_USAGE_STATUS {
    pub cbSize: DWORD,
    pub dwError: DWORD,
    pub dwFlags: DWORD,
    pub ppCtl: *mut PCCTL_CONTEXT,
    pub dwCtlEntryIndex: DWORD,
    pub ppSigner: *mut PCCERT_CONTEXT,
    pub dwSignerIndex: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_VERIFY_USAGE_STATUS"]
        [::std::mem::size_of::<_CTL_VERIFY_USAGE_STATUS>() - 48usize];
    ["Alignment of _CTL_VERIFY_USAGE_STATUS"]
        [::std::mem::align_of::<_CTL_VERIFY_USAGE_STATUS>() - 8usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::cbSize"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, cbSize) - 0usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::dwError"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, dwError) - 4usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::dwFlags"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, dwFlags) - 8usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::ppCtl"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, ppCtl) - 16usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::dwCtlEntryIndex"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, dwCtlEntryIndex) - 24usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::ppSigner"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, ppSigner) - 32usize];
    ["Offset of field: _CTL_VERIFY_USAGE_STATUS::dwSignerIndex"]
        [::std::mem::offset_of!(_CTL_VERIFY_USAGE_STATUS, dwSignerIndex) - 40usize];
};
pub type CTL_VERIFY_USAGE_STATUS = _CTL_VERIFY_USAGE_STATUS;
pub type PCTL_VERIFY_USAGE_STATUS = *mut _CTL_VERIFY_USAGE_STATUS;
unsafe extern "C" {
    pub fn CertVerifyCTLUsage(
        dwEncodingType: DWORD,
        dwSubjectType: DWORD,
        pvSubject: *mut ::std::os::raw::c_void,
        pSubjectUsage: PCTL_USAGE,
        dwFlags: DWORD,
        pVerifyUsagePara: PCTL_VERIFY_USAGE_PARA,
        pVerifyUsageStatus: PCTL_VERIFY_USAGE_STATUS,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REVOCATION_CRL_INFO {
    pub cbSize: DWORD,
    pub pBaseCrlContext: PCCRL_CONTEXT,
    pub pDeltaCrlContext: PCCRL_CONTEXT,
    pub pCrlEntry: PCRL_ENTRY,
    pub fDeltaCrlEntry: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REVOCATION_CRL_INFO"]
        [::std::mem::size_of::<_CERT_REVOCATION_CRL_INFO>() - 40usize];
    ["Alignment of _CERT_REVOCATION_CRL_INFO"]
        [::std::mem::align_of::<_CERT_REVOCATION_CRL_INFO>() - 8usize];
    ["Offset of field: _CERT_REVOCATION_CRL_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CRL_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_REVOCATION_CRL_INFO::pBaseCrlContext"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CRL_INFO, pBaseCrlContext) - 8usize];
    ["Offset of field: _CERT_REVOCATION_CRL_INFO::pDeltaCrlContext"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CRL_INFO, pDeltaCrlContext) - 16usize];
    ["Offset of field: _CERT_REVOCATION_CRL_INFO::pCrlEntry"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CRL_INFO, pCrlEntry) - 24usize];
    ["Offset of field: _CERT_REVOCATION_CRL_INFO::fDeltaCrlEntry"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CRL_INFO, fDeltaCrlEntry) - 32usize];
};
pub type CERT_REVOCATION_CRL_INFO = _CERT_REVOCATION_CRL_INFO;
pub type PCERT_REVOCATION_CRL_INFO = *mut _CERT_REVOCATION_CRL_INFO;
pub type CERT_REVOCATION_CHAIN_PARA = _CERT_REVOCATION_CHAIN_PARA;
pub type PCERT_REVOCATION_CHAIN_PARA = *mut _CERT_REVOCATION_CHAIN_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REVOCATION_PARA {
    pub cbSize: DWORD,
    pub pIssuerCert: PCCERT_CONTEXT,
    pub cCertStore: DWORD,
    pub rgCertStore: *mut HCERTSTORE,
    pub hCrlStore: HCERTSTORE,
    pub pftTimeToUse: LPFILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REVOCATION_PARA"][::std::mem::size_of::<_CERT_REVOCATION_PARA>() - 48usize];
    ["Alignment of _CERT_REVOCATION_PARA"]
        [::std::mem::align_of::<_CERT_REVOCATION_PARA>() - 8usize];
    ["Offset of field: _CERT_REVOCATION_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_REVOCATION_PARA::pIssuerCert"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, pIssuerCert) - 8usize];
    ["Offset of field: _CERT_REVOCATION_PARA::cCertStore"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, cCertStore) - 16usize];
    ["Offset of field: _CERT_REVOCATION_PARA::rgCertStore"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, rgCertStore) - 24usize];
    ["Offset of field: _CERT_REVOCATION_PARA::hCrlStore"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, hCrlStore) - 32usize];
    ["Offset of field: _CERT_REVOCATION_PARA::pftTimeToUse"]
        [::std::mem::offset_of!(_CERT_REVOCATION_PARA, pftTimeToUse) - 40usize];
};
pub type CERT_REVOCATION_PARA = _CERT_REVOCATION_PARA;
pub type PCERT_REVOCATION_PARA = *mut _CERT_REVOCATION_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REVOCATION_STATUS {
    pub cbSize: DWORD,
    pub dwIndex: DWORD,
    pub dwError: DWORD,
    pub dwReason: DWORD,
    pub fHasFreshnessTime: BOOL,
    pub dwFreshnessTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REVOCATION_STATUS"][::std::mem::size_of::<_CERT_REVOCATION_STATUS>() - 24usize];
    ["Alignment of _CERT_REVOCATION_STATUS"]
        [::std::mem::align_of::<_CERT_REVOCATION_STATUS>() - 4usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::cbSize"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, cbSize) - 0usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::dwIndex"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, dwIndex) - 4usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::dwError"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, dwError) - 8usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::dwReason"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, dwReason) - 12usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::fHasFreshnessTime"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, fHasFreshnessTime) - 16usize];
    ["Offset of field: _CERT_REVOCATION_STATUS::dwFreshnessTime"]
        [::std::mem::offset_of!(_CERT_REVOCATION_STATUS, dwFreshnessTime) - 20usize];
};
pub type CERT_REVOCATION_STATUS = _CERT_REVOCATION_STATUS;
pub type PCERT_REVOCATION_STATUS = *mut _CERT_REVOCATION_STATUS;
unsafe extern "C" {
    pub fn CertVerifyRevocation(
        dwEncodingType: DWORD,
        dwRevType: DWORD,
        cContext: DWORD,
        rgpvContext: *mut PVOID,
        dwFlags: DWORD,
        pRevPara: PCERT_REVOCATION_PARA,
        pRevStatus: PCERT_REVOCATION_STATUS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertCompareIntegerBlob(pInt1: PCRYPT_INTEGER_BLOB, pInt2: PCRYPT_INTEGER_BLOB) -> BOOL;
}
unsafe extern "C" {
    pub fn CertCompareCertificate(
        dwCertEncodingType: DWORD,
        pCertId1: PCERT_INFO,
        pCertId2: PCERT_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertCompareCertificateName(
        dwCertEncodingType: DWORD,
        pCertName1: PCERT_NAME_BLOB,
        pCertName2: PCERT_NAME_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertIsRDNAttrsInCertificateName(
        dwCertEncodingType: DWORD,
        dwFlags: DWORD,
        pCertName: PCERT_NAME_BLOB,
        pRDN: PCERT_RDN,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertComparePublicKeyInfo(
        dwCertEncodingType: DWORD,
        pPublicKey1: PCERT_PUBLIC_KEY_INFO,
        pPublicKey2: PCERT_PUBLIC_KEY_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetPublicKeyLength(
        dwCertEncodingType: DWORD,
        pPublicKey: PCERT_PUBLIC_KEY_INFO,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CryptVerifyCertificateSignature(
        hCryptProv: HCRYPTPROV_LEGACY,
        dwCertEncodingType: DWORD,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        pPublicKey: PCERT_PUBLIC_KEY_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyCertificateSignatureEx(
        hCryptProv: HCRYPTPROV_LEGACY,
        dwCertEncodingType: DWORD,
        dwSubjectType: DWORD,
        pvSubject: *mut ::std::os::raw::c_void,
        dwIssuerType: DWORD,
        pvIssuer: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
        pvExtra: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO {
    pub CertSignHashCNGAlgPropData: CRYPT_DATA_BLOB,
    pub CertIssuerPubKeyBitLengthPropData: CRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO"]
        [::std::mem::size_of::<_CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO>() - 32usize];
    ["Alignment of _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO"]
        [::std::mem::align_of::<_CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO>() - 8usize];
    ["Offset of field: _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO::CertSignHashCNGAlgPropData"] [:: std :: mem :: offset_of ! (_CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO , CertSignHashCNGAlgPropData) - 0usize] ;
    ["Offset of field: _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO::CertIssuerPubKeyBitLengthPropData"] [:: std :: mem :: offset_of ! (_CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO , CertIssuerPubKeyBitLengthPropData) - 16usize] ;
};
pub type CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO =
    _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO;
pub type PCRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO =
    *mut _CRYPT_VERIFY_CERT_SIGN_STRONG_PROPERTIES_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO {
    pub cCNGHashAlgid: DWORD,
    pub rgpwszCNGHashAlgid: *mut PCWSTR,
    pub dwWeakIndex: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO"]
        [::std::mem::size_of::<_CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO>() - 24usize];
    ["Alignment of _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO"]
        [::std::mem::align_of::<_CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO>() - 8usize];
    ["Offset of field: _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO::cCNGHashAlgid"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO, cCNGHashAlgid) - 0usize];
    ["Offset of field: _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO::rgpwszCNGHashAlgid"][::std::mem::offset_of!(
        _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO,
        rgpwszCNGHashAlgid
    ) - 8usize];
    ["Offset of field: _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO::dwWeakIndex"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO, dwWeakIndex) - 16usize];
};
pub type CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO = _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO;
pub type PCRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO = *mut _CRYPT_VERIFY_CERT_SIGN_WEAK_HASH_INFO;
unsafe extern "C" {
    pub fn CertIsStrongHashToSign(
        pStrongSignPara: PCCERT_STRONG_SIGN_PARA,
        pwszCNGHashAlgid: LPCWSTR,
        pSigningCert: PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashToBeSigned(
        hCryptProv: HCRYPTPROV_LEGACY,
        dwCertEncodingType: DWORD,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashCertificate(
        hCryptProv: HCRYPTPROV_LEGACY,
        Algid: ALG_ID,
        dwFlags: DWORD,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashCertificate2(
        pwszCNGHashAlgid: LPCWSTR,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pbEncoded: *const BYTE,
        cbEncoded: DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignCertificate(
        hCryptProvOrNCryptKey: HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        dwKeySpec: DWORD,
        dwCertEncodingType: DWORD,
        pbEncodedToBeSigned: *const BYTE,
        cbEncodedToBeSigned: DWORD,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pvHashAuxInfo: *const ::std::os::raw::c_void,
        pbSignature: *mut BYTE,
        pcbSignature: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignAndEncodeCertificate(
        hCryptProvOrNCryptKey: HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        dwKeySpec: DWORD,
        dwCertEncodingType: DWORD,
        lpszStructType: LPCSTR,
        pvStructInfo: *const ::std::os::raw::c_void,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pvHashAuxInfo: *const ::std::os::raw::c_void,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CRYPT_EXTRACT_ENCODED_SIGNATURE_PARAMETERS_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        dwCertEncodingType: DWORD,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        ppvDecodedSignPara: *mut *mut ::std::os::raw::c_void,
        ppwszCNGHashAlgid: *mut LPWSTR,
    ) -> BOOL,
>;
pub type PFN_CRYPT_SIGN_AND_ENCODE_HASH_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        hKey: NCRYPT_KEY_HANDLE,
        dwCertEncodingType: DWORD,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pvDecodedSignPara: *mut ::std::os::raw::c_void,
        pwszCNGPubKeyAlgid: LPCWSTR,
        pwszCNGHashAlgid: LPCWSTR,
        pbComputedHash: *mut BYTE,
        cbComputedHash: DWORD,
        pbSignature: *mut BYTE,
        pcbSignature: *mut DWORD,
    ) -> BOOL,
>;
pub type PFN_CRYPT_VERIFY_ENCODED_SIGNATURE_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        dwCertEncodingType: DWORD,
        pPubKeyInfo: PCERT_PUBLIC_KEY_INFO,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pvDecodedSignPara: *mut ::std::os::raw::c_void,
        pwszCNGPubKeyAlgid: LPCWSTR,
        pwszCNGHashAlgid: LPCWSTR,
        pbComputedHash: *mut BYTE,
        cbComputedHash: DWORD,
        pbSignature: *mut BYTE,
        cbSignature: DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CertVerifyTimeValidity(pTimeToVerify: LPFILETIME, pCertInfo: PCERT_INFO) -> LONG;
}
unsafe extern "C" {
    pub fn CertVerifyCRLTimeValidity(pTimeToVerify: LPFILETIME, pCrlInfo: PCRL_INFO) -> LONG;
}
unsafe extern "C" {
    pub fn CertVerifyValidityNesting(pSubjectInfo: PCERT_INFO, pIssuerInfo: PCERT_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn CertVerifyCRLRevocation(
        dwCertEncodingType: DWORD,
        pCertId: PCERT_INFO,
        cCrlInfo: DWORD,
        rgpCrlInfo: *mut PCRL_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAlgIdToOID(dwAlgId: DWORD) -> LPCSTR;
}
unsafe extern "C" {
    pub fn CertOIDToAlgId(pszObjId: LPCSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn CertFindExtension(
        pszObjId: LPCSTR,
        cExtensions: DWORD,
        rgExtensions: *mut CERT_EXTENSION,
    ) -> PCERT_EXTENSION;
}
unsafe extern "C" {
    pub fn CertFindAttribute(
        pszObjId: LPCSTR,
        cAttr: DWORD,
        rgAttr: *mut CRYPT_ATTRIBUTE,
    ) -> PCRYPT_ATTRIBUTE;
}
unsafe extern "C" {
    pub fn CertFindRDNAttr(pszObjId: LPCSTR, pName: PCERT_NAME_INFO) -> PCERT_RDN_ATTR;
}
unsafe extern "C" {
    pub fn CertGetIntendedKeyUsage(
        dwCertEncodingType: DWORD,
        pCertInfo: PCERT_INFO,
        pbKeyUsage: *mut BYTE,
        cbKeyUsage: DWORD,
    ) -> BOOL;
}
pub type HCRYPTDEFAULTCONTEXT = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub fn CryptInstallDefaultContext(
        hCryptProv: HCRYPTPROV,
        dwDefaultType: DWORD,
        pvDefaultPara: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        phDefaultContext: *mut HCRYPTDEFAULTCONTEXT,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA {
    pub cOID: DWORD,
    pub rgpszOID: *mut LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA"]
        [::std::mem::size_of::<_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA>() - 16usize];
    ["Alignment of _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA"]
        [::std::mem::align_of::<_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA>() - 8usize];
    ["Offset of field: _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA::cOID"]
        [::std::mem::offset_of!(_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA, cOID) - 0usize];
    ["Offset of field: _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA::rgpszOID"]
        [::std::mem::offset_of!(_CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA, rgpszOID) - 8usize];
};
pub type CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA = _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA;
pub type PCRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA = *mut _CRYPT_DEFAULT_CONTEXT_MULTI_OID_PARA;
unsafe extern "C" {
    pub fn CryptUninstallDefaultContext(
        hDefaultContext: HCRYPTDEFAULTCONTEXT,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptExportPublicKeyInfo(
        hCryptProvOrNCryptKey: HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        dwKeySpec: DWORD,
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pcbInfo: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptExportPublicKeyInfoEx(
        hCryptProvOrNCryptKey: HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        dwKeySpec: DWORD,
        dwCertEncodingType: DWORD,
        pszPublicKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pcbInfo: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CRYPT_EXPORT_PUBLIC_KEY_INFO_EX2_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        hNCryptKey: NCRYPT_KEY_HANDLE,
        dwCertEncodingType: DWORD,
        pszPublicKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pcbInfo: *mut DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptExportPublicKeyInfoFromBCryptKeyHandle(
        hBCryptKey: BCRYPT_KEY_HANDLE,
        dwCertEncodingType: DWORD,
        pszPublicKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pcbInfo: *mut DWORD,
    ) -> BOOL;
}
pub type PFN_CRYPT_EXPORT_PUBLIC_KEY_INFO_FROM_BCRYPT_HANDLE_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        hBCryptKey: BCRYPT_KEY_HANDLE,
        dwCertEncodingType: DWORD,
        pszPublicKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pcbInfo: *mut DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptImportPublicKeyInfo(
        hCryptProv: HCRYPTPROV,
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptImportPublicKeyInfoEx(
        hCryptProv: HCRYPTPROV,
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        aiKeyAlg: ALG_ID,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        phKey: *mut HCRYPTKEY,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptImportPublicKeyInfoEx2(
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        phKey: *mut BCRYPT_KEY_HANDLE,
    ) -> BOOL;
}
pub type PFN_IMPORT_PUBLIC_KEY_INFO_EX2_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        phKey: *mut BCRYPT_KEY_HANDLE,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptAcquireCertificatePrivateKey(
        pCert: PCCERT_CONTEXT,
        dwFlags: DWORD,
        pvParameters: *mut ::std::os::raw::c_void,
        phCryptProvOrNCryptKey: *mut HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        pdwKeySpec: *mut DWORD,
        pfCallerFreeProvOrNCryptKey: *mut BOOL,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptFindCertificateKeyProvInfo(
        pCert: PCCERT_CONTEXT,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
pub type PFN_IMPORT_PRIV_KEY_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        hCryptProv: HCRYPTPROV,
        pPrivateKeyInfo: *mut CRYPT_PRIVATE_KEY_INFO,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptImportPKCS8(
        sPrivateKeyAndParams: CRYPT_PKCS8_IMPORT_PARAMS,
        dwFlags: DWORD,
        phCryptProv: *mut HCRYPTPROV,
        pvAuxInfo: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
pub type PFN_EXPORT_PRIV_KEY_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        hCryptProv: HCRYPTPROV,
        dwKeySpec: DWORD,
        pszPrivateKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pPrivateKeyInfo: *mut CRYPT_PRIVATE_KEY_INFO,
        pcbPrivateKeyInfo: *mut DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptExportPKCS8(
        hCryptProv: HCRYPTPROV,
        dwKeySpec: DWORD,
        pszPrivateKeyObjId: LPSTR,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pbPrivateKeyBlob: *mut BYTE,
        pcbPrivateKeyBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptExportPKCS8Ex(
        psExportParams: *mut CRYPT_PKCS8_EXPORT_PARAMS,
        dwFlags: DWORD,
        pvAuxInfo: *mut ::std::os::raw::c_void,
        pbPrivateKeyBlob: *mut BYTE,
        pcbPrivateKeyBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashPublicKeyInfo(
        hCryptProv: HCRYPTPROV_LEGACY,
        Algid: ALG_ID,
        dwFlags: DWORD,
        dwCertEncodingType: DWORD,
        pInfo: PCERT_PUBLIC_KEY_INFO,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertRDNValueToStrA(
        dwValueType: DWORD,
        pValue: PCERT_RDN_VALUE_BLOB,
        psz: LPSTR,
        csz: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertRDNValueToStrW(
        dwValueType: DWORD,
        pValue: PCERT_RDN_VALUE_BLOB,
        psz: LPWSTR,
        csz: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertNameToStrA(
        dwCertEncodingType: DWORD,
        pName: PCERT_NAME_BLOB,
        dwStrType: DWORD,
        psz: LPSTR,
        csz: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertNameToStrW(
        dwCertEncodingType: DWORD,
        pName: PCERT_NAME_BLOB,
        dwStrType: DWORD,
        psz: LPWSTR,
        csz: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertStrToNameA(
        dwCertEncodingType: DWORD,
        pszX500: LPCSTR,
        dwStrType: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
        ppszError: *mut LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertStrToNameW(
        dwCertEncodingType: DWORD,
        pszX500: LPCWSTR,
        dwStrType: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pbEncoded: *mut BYTE,
        pcbEncoded: *mut DWORD,
        ppszError: *mut LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertGetNameStringA(
        pCertContext: PCCERT_CONTEXT,
        dwType: DWORD,
        dwFlags: DWORD,
        pvTypePara: *mut ::std::os::raw::c_void,
        pszNameString: LPSTR,
        cchNameString: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn CertGetNameStringW(
        pCertContext: PCCERT_CONTEXT,
        dwType: DWORD,
        dwFlags: DWORD,
        pvTypePara: *mut ::std::os::raw::c_void,
        pszNameString: LPWSTR,
        cchNameString: DWORD,
    ) -> DWORD;
}
pub type PFN_CRYPT_GET_SIGNER_CERTIFICATE = ::std::option::Option<
    unsafe extern "C" fn(
        pvGetArg: *mut ::std::os::raw::c_void,
        dwCertEncodingType: DWORD,
        pSignerId: PCERT_INFO,
        hMsgCertStore: HCERTSTORE,
    ) -> PCCERT_CONTEXT,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_SIGN_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgEncodingType: DWORD,
    pub pSigningCert: PCCERT_CONTEXT,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvHashAuxInfo: *mut ::std::os::raw::c_void,
    pub cMsgCert: DWORD,
    pub rgpMsgCert: *mut PCCERT_CONTEXT,
    pub cMsgCrl: DWORD,
    pub rgpMsgCrl: *mut PCCRL_CONTEXT,
    pub cAuthAttr: DWORD,
    pub rgAuthAttr: PCRYPT_ATTRIBUTE,
    pub cUnauthAttr: DWORD,
    pub rgUnauthAttr: PCRYPT_ATTRIBUTE,
    pub dwFlags: DWORD,
    pub dwInnerContentType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_SIGN_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_SIGN_MESSAGE_PARA>() - 120usize];
    ["Alignment of _CRYPT_SIGN_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_SIGN_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::dwMsgEncodingType"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, dwMsgEncodingType) - 4usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::pSigningCert"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, pSigningCert) - 8usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, HashAlgorithm) - 16usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::pvHashAuxInfo"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, pvHashAuxInfo) - 40usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::cMsgCert"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, cMsgCert) - 48usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::rgpMsgCert"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, rgpMsgCert) - 56usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::cMsgCrl"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, cMsgCrl) - 64usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::rgpMsgCrl"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, rgpMsgCrl) - 72usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::cAuthAttr"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, cAuthAttr) - 80usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::rgAuthAttr"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, rgAuthAttr) - 88usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::cUnauthAttr"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, cUnauthAttr) - 96usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::rgUnauthAttr"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, rgUnauthAttr) - 104usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, dwFlags) - 112usize];
    ["Offset of field: _CRYPT_SIGN_MESSAGE_PARA::dwInnerContentType"]
        [::std::mem::offset_of!(_CRYPT_SIGN_MESSAGE_PARA, dwInnerContentType) - 116usize];
};
pub type CRYPT_SIGN_MESSAGE_PARA = _CRYPT_SIGN_MESSAGE_PARA;
pub type PCRYPT_SIGN_MESSAGE_PARA = *mut _CRYPT_SIGN_MESSAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_VERIFY_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgAndCertEncodingType: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub pfnGetSignerCertificate: PFN_CRYPT_GET_SIGNER_CERTIFICATE,
    pub pvGetArg: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_VERIFY_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_VERIFY_MESSAGE_PARA>() - 32usize];
    ["Alignment of _CRYPT_VERIFY_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_VERIFY_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_VERIFY_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_VERIFY_MESSAGE_PARA::dwMsgAndCertEncodingType"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_MESSAGE_PARA, dwMsgAndCertEncodingType) - 4usize];
    ["Offset of field: _CRYPT_VERIFY_MESSAGE_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_MESSAGE_PARA, hCryptProv) - 8usize];
    ["Offset of field: _CRYPT_VERIFY_MESSAGE_PARA::pfnGetSignerCertificate"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_MESSAGE_PARA, pfnGetSignerCertificate) - 16usize];
    ["Offset of field: _CRYPT_VERIFY_MESSAGE_PARA::pvGetArg"]
        [::std::mem::offset_of!(_CRYPT_VERIFY_MESSAGE_PARA, pvGetArg) - 24usize];
};
pub type CRYPT_VERIFY_MESSAGE_PARA = _CRYPT_VERIFY_MESSAGE_PARA;
pub type PCRYPT_VERIFY_MESSAGE_PARA = *mut _CRYPT_VERIFY_MESSAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ENCRYPT_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgEncodingType: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub ContentEncryptionAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvEncryptionAuxInfo: *mut ::std::os::raw::c_void,
    pub dwFlags: DWORD,
    pub dwInnerContentType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ENCRYPT_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_ENCRYPT_MESSAGE_PARA>() - 56usize];
    ["Alignment of _CRYPT_ENCRYPT_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_ENCRYPT_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::dwMsgEncodingType"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, dwMsgEncodingType) - 4usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, hCryptProv) - 8usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::ContentEncryptionAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, ContentEncryptionAlgorithm) - 16usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::pvEncryptionAuxInfo"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, pvEncryptionAuxInfo) - 40usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::dwFlags"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, dwFlags) - 48usize];
    ["Offset of field: _CRYPT_ENCRYPT_MESSAGE_PARA::dwInnerContentType"]
        [::std::mem::offset_of!(_CRYPT_ENCRYPT_MESSAGE_PARA, dwInnerContentType) - 52usize];
};
pub type CRYPT_ENCRYPT_MESSAGE_PARA = _CRYPT_ENCRYPT_MESSAGE_PARA;
pub type PCRYPT_ENCRYPT_MESSAGE_PARA = *mut _CRYPT_ENCRYPT_MESSAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_DECRYPT_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgAndCertEncodingType: DWORD,
    pub cCertStore: DWORD,
    pub rghCertStore: *mut HCERTSTORE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_DECRYPT_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_DECRYPT_MESSAGE_PARA>() - 24usize];
    ["Alignment of _CRYPT_DECRYPT_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_DECRYPT_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_DECRYPT_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_DECRYPT_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_DECRYPT_MESSAGE_PARA::dwMsgAndCertEncodingType"]
        [::std::mem::offset_of!(_CRYPT_DECRYPT_MESSAGE_PARA, dwMsgAndCertEncodingType) - 4usize];
    ["Offset of field: _CRYPT_DECRYPT_MESSAGE_PARA::cCertStore"]
        [::std::mem::offset_of!(_CRYPT_DECRYPT_MESSAGE_PARA, cCertStore) - 8usize];
    ["Offset of field: _CRYPT_DECRYPT_MESSAGE_PARA::rghCertStore"]
        [::std::mem::offset_of!(_CRYPT_DECRYPT_MESSAGE_PARA, rghCertStore) - 16usize];
};
pub type CRYPT_DECRYPT_MESSAGE_PARA = _CRYPT_DECRYPT_MESSAGE_PARA;
pub type PCRYPT_DECRYPT_MESSAGE_PARA = *mut _CRYPT_DECRYPT_MESSAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_HASH_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgEncodingType: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvHashAuxInfo: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_HASH_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_HASH_MESSAGE_PARA>() - 48usize];
    ["Alignment of _CRYPT_HASH_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_HASH_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_HASH_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_HASH_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_HASH_MESSAGE_PARA::dwMsgEncodingType"]
        [::std::mem::offset_of!(_CRYPT_HASH_MESSAGE_PARA, dwMsgEncodingType) - 4usize];
    ["Offset of field: _CRYPT_HASH_MESSAGE_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_HASH_MESSAGE_PARA, hCryptProv) - 8usize];
    ["Offset of field: _CRYPT_HASH_MESSAGE_PARA::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_HASH_MESSAGE_PARA, HashAlgorithm) - 16usize];
    ["Offset of field: _CRYPT_HASH_MESSAGE_PARA::pvHashAuxInfo"]
        [::std::mem::offset_of!(_CRYPT_HASH_MESSAGE_PARA, pvHashAuxInfo) - 40usize];
};
pub type CRYPT_HASH_MESSAGE_PARA = _CRYPT_HASH_MESSAGE_PARA;
pub type PCRYPT_HASH_MESSAGE_PARA = *mut _CRYPT_HASH_MESSAGE_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CRYPT_KEY_SIGN_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgAndCertEncodingType: DWORD,
    pub __bindgen_anon_1: _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1,
    pub dwKeySpec: DWORD,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub pvHashAuxInfo: *mut ::std::os::raw::c_void,
    pub PubKeyAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1 {
    pub hCryptProv: HCRYPTPROV,
    pub hNCryptKey: NCRYPT_KEY_HANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1"]
        [::std::mem::size_of::<_CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1>() - 8usize];
    ["Alignment of _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1"]
        [::std::mem::align_of::<_CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1, hCryptProv) - 0usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1::hNCryptKey"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA__bindgen_ty_1, hNCryptKey) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_KEY_SIGN_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_KEY_SIGN_MESSAGE_PARA>() - 80usize];
    ["Alignment of _CRYPT_KEY_SIGN_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_KEY_SIGN_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::dwMsgAndCertEncodingType"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, dwMsgAndCertEncodingType) - 4usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::dwKeySpec"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, dwKeySpec) - 16usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, HashAlgorithm) - 24usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::pvHashAuxInfo"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, pvHashAuxInfo) - 48usize];
    ["Offset of field: _CRYPT_KEY_SIGN_MESSAGE_PARA::PubKeyAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_KEY_SIGN_MESSAGE_PARA, PubKeyAlgorithm) - 56usize];
};
pub type CRYPT_KEY_SIGN_MESSAGE_PARA = _CRYPT_KEY_SIGN_MESSAGE_PARA;
pub type PCRYPT_KEY_SIGN_MESSAGE_PARA = *mut _CRYPT_KEY_SIGN_MESSAGE_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_KEY_VERIFY_MESSAGE_PARA {
    pub cbSize: DWORD,
    pub dwMsgEncodingType: DWORD,
    pub hCryptProv: HCRYPTPROV_LEGACY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_KEY_VERIFY_MESSAGE_PARA"]
        [::std::mem::size_of::<_CRYPT_KEY_VERIFY_MESSAGE_PARA>() - 16usize];
    ["Alignment of _CRYPT_KEY_VERIFY_MESSAGE_PARA"]
        [::std::mem::align_of::<_CRYPT_KEY_VERIFY_MESSAGE_PARA>() - 8usize];
    ["Offset of field: _CRYPT_KEY_VERIFY_MESSAGE_PARA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_KEY_VERIFY_MESSAGE_PARA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_KEY_VERIFY_MESSAGE_PARA::dwMsgEncodingType"]
        [::std::mem::offset_of!(_CRYPT_KEY_VERIFY_MESSAGE_PARA, dwMsgEncodingType) - 4usize];
    ["Offset of field: _CRYPT_KEY_VERIFY_MESSAGE_PARA::hCryptProv"]
        [::std::mem::offset_of!(_CRYPT_KEY_VERIFY_MESSAGE_PARA, hCryptProv) - 8usize];
};
pub type CRYPT_KEY_VERIFY_MESSAGE_PARA = _CRYPT_KEY_VERIFY_MESSAGE_PARA;
pub type PCRYPT_KEY_VERIFY_MESSAGE_PARA = *mut _CRYPT_KEY_VERIFY_MESSAGE_PARA;
unsafe extern "C" {
    pub fn CryptSignMessage(
        pSignPara: PCRYPT_SIGN_MESSAGE_PARA,
        fDetachedSignature: BOOL,
        cToBeSigned: DWORD,
        rgpbToBeSigned: *mut *const BYTE,
        rgcbToBeSigned: *mut DWORD,
        pbSignedBlob: *mut BYTE,
        pcbSignedBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyMessageSignature(
        pVerifyPara: PCRYPT_VERIFY_MESSAGE_PARA,
        dwSignerIndex: DWORD,
        pbSignedBlob: *const BYTE,
        cbSignedBlob: DWORD,
        pbDecoded: *mut BYTE,
        pcbDecoded: *mut DWORD,
        ppSignerCert: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetMessageSignerCount(
        dwMsgEncodingType: DWORD,
        pbSignedBlob: *const BYTE,
        cbSignedBlob: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn CryptGetMessageCertificates(
        dwMsgAndCertEncodingType: DWORD,
        hCryptProv: HCRYPTPROV_LEGACY,
        dwFlags: DWORD,
        pbSignedBlob: *const BYTE,
        cbSignedBlob: DWORD,
    ) -> HCERTSTORE;
}
unsafe extern "C" {
    pub fn CryptVerifyDetachedMessageSignature(
        pVerifyPara: PCRYPT_VERIFY_MESSAGE_PARA,
        dwSignerIndex: DWORD,
        pbDetachedSignBlob: *const BYTE,
        cbDetachedSignBlob: DWORD,
        cToBeSigned: DWORD,
        rgpbToBeSigned: *mut *const BYTE,
        rgcbToBeSigned: *mut DWORD,
        ppSignerCert: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptEncryptMessage(
        pEncryptPara: PCRYPT_ENCRYPT_MESSAGE_PARA,
        cRecipientCert: DWORD,
        rgpRecipientCert: *mut PCCERT_CONTEXT,
        pbToBeEncrypted: *const BYTE,
        cbToBeEncrypted: DWORD,
        pbEncryptedBlob: *mut BYTE,
        pcbEncryptedBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDecryptMessage(
        pDecryptPara: PCRYPT_DECRYPT_MESSAGE_PARA,
        pbEncryptedBlob: *const BYTE,
        cbEncryptedBlob: DWORD,
        pbDecrypted: *mut BYTE,
        pcbDecrypted: *mut DWORD,
        ppXchgCert: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignAndEncryptMessage(
        pSignPara: PCRYPT_SIGN_MESSAGE_PARA,
        pEncryptPara: PCRYPT_ENCRYPT_MESSAGE_PARA,
        cRecipientCert: DWORD,
        rgpRecipientCert: *mut PCCERT_CONTEXT,
        pbToBeSignedAndEncrypted: *const BYTE,
        cbToBeSignedAndEncrypted: DWORD,
        pbSignedAndEncryptedBlob: *mut BYTE,
        pcbSignedAndEncryptedBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDecryptAndVerifyMessageSignature(
        pDecryptPara: PCRYPT_DECRYPT_MESSAGE_PARA,
        pVerifyPara: PCRYPT_VERIFY_MESSAGE_PARA,
        dwSignerIndex: DWORD,
        pbEncryptedBlob: *const BYTE,
        cbEncryptedBlob: DWORD,
        pbDecrypted: *mut BYTE,
        pcbDecrypted: *mut DWORD,
        ppXchgCert: *mut PCCERT_CONTEXT,
        ppSignerCert: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptDecodeMessage(
        dwMsgTypeFlags: DWORD,
        pDecryptPara: PCRYPT_DECRYPT_MESSAGE_PARA,
        pVerifyPara: PCRYPT_VERIFY_MESSAGE_PARA,
        dwSignerIndex: DWORD,
        pbEncodedBlob: *const BYTE,
        cbEncodedBlob: DWORD,
        dwPrevInnerContentType: DWORD,
        pdwMsgType: *mut DWORD,
        pdwInnerContentType: *mut DWORD,
        pbDecoded: *mut BYTE,
        pcbDecoded: *mut DWORD,
        ppXchgCert: *mut PCCERT_CONTEXT,
        ppSignerCert: *mut PCCERT_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptHashMessage(
        pHashPara: PCRYPT_HASH_MESSAGE_PARA,
        fDetachedHash: BOOL,
        cToBeHashed: DWORD,
        rgpbToBeHashed: *mut *const BYTE,
        rgcbToBeHashed: *mut DWORD,
        pbHashedBlob: *mut BYTE,
        pcbHashedBlob: *mut DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyMessageHash(
        pHashPara: PCRYPT_HASH_MESSAGE_PARA,
        pbHashedBlob: *mut BYTE,
        cbHashedBlob: DWORD,
        pbToBeHashed: *mut BYTE,
        pcbToBeHashed: *mut DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyDetachedMessageHash(
        pHashPara: PCRYPT_HASH_MESSAGE_PARA,
        pbDetachedHashBlob: *mut BYTE,
        cbDetachedHashBlob: DWORD,
        cToBeHashed: DWORD,
        rgpbToBeHashed: *mut *const BYTE,
        rgcbToBeHashed: *mut DWORD,
        pbComputedHash: *mut BYTE,
        pcbComputedHash: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSignMessageWithKey(
        pSignPara: PCRYPT_KEY_SIGN_MESSAGE_PARA,
        pbToBeSigned: *const BYTE,
        cbToBeSigned: DWORD,
        pbSignedBlob: *mut BYTE,
        pcbSignedBlob: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyMessageSignatureWithKey(
        pVerifyPara: PCRYPT_KEY_VERIFY_MESSAGE_PARA,
        pPublicKeyInfo: PCERT_PUBLIC_KEY_INFO,
        pbSignedBlob: *const BYTE,
        cbSignedBlob: DWORD,
        pbDecoded: *mut BYTE,
        pcbDecoded: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertOpenSystemStoreA(
        hProv: HCRYPTPROV_LEGACY,
        szSubsystemProtocol: LPCSTR,
    ) -> HCERTSTORE;
}
unsafe extern "C" {
    pub fn CertOpenSystemStoreW(
        hProv: HCRYPTPROV_LEGACY,
        szSubsystemProtocol: LPCWSTR,
    ) -> HCERTSTORE;
}
unsafe extern "C" {
    pub fn CertAddEncodedCertificateToSystemStoreA(
        szCertStoreName: LPCSTR,
        pbCertEncoded: *const BYTE,
        cbCertEncoded: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertAddEncodedCertificateToSystemStoreW(
        szCertStoreName: LPCWSTR,
        pbCertEncoded: *const BYTE,
        cbCertEncoded: DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN {
    pub cCerts: DWORD,
    pub certs: PCERT_BLOB,
    pub keyLocatorInfo: CRYPT_KEY_PROV_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN"][::std::mem::size_of::<_CERT_CHAIN>() - 64usize];
    ["Alignment of _CERT_CHAIN"][::std::mem::align_of::<_CERT_CHAIN>() - 8usize];
    ["Offset of field: _CERT_CHAIN::cCerts"][::std::mem::offset_of!(_CERT_CHAIN, cCerts) - 0usize];
    ["Offset of field: _CERT_CHAIN::certs"][::std::mem::offset_of!(_CERT_CHAIN, certs) - 8usize];
    ["Offset of field: _CERT_CHAIN::keyLocatorInfo"]
        [::std::mem::offset_of!(_CERT_CHAIN, keyLocatorInfo) - 16usize];
};
pub type CERT_CHAIN = _CERT_CHAIN;
pub type PCERT_CHAIN = *mut _CERT_CHAIN;
unsafe extern "C" {
    pub fn FindCertsByIssuer(
        pCertChains: PCERT_CHAIN,
        pcbCertChains: *mut DWORD,
        pcCertChains: *mut DWORD,
        pbEncodedIssuerName: *mut BYTE,
        cbEncodedIssuerName: DWORD,
        pwszPurpose: LPCWSTR,
        dwKeySpec: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CryptQueryObject(
        dwObjectType: DWORD,
        pvObject: *const ::std::os::raw::c_void,
        dwExpectedContentTypeFlags: DWORD,
        dwExpectedFormatTypeFlags: DWORD,
        dwFlags: DWORD,
        pdwMsgAndCertEncodingType: *mut DWORD,
        pdwContentType: *mut DWORD,
        pdwFormatType: *mut DWORD,
        phCertStore: *mut HCERTSTORE,
        phMsg: *mut HCRYPTMSG,
        ppvContext: *mut *const ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptMemAlloc(cbSize: ULONG) -> LPVOID;
}
unsafe extern "C" {
    pub fn CryptMemRealloc(pv: LPVOID, cbSize: ULONG) -> LPVOID;
}
unsafe extern "C" {
    pub fn CryptMemFree(pv: LPVOID);
}
pub type HCRYPTASYNC = HANDLE;
pub type PHCRYPTASYNC = *mut HANDLE;
pub type PFN_CRYPT_ASYNC_PARAM_FREE_FUNC =
    ::std::option::Option<unsafe extern "C" fn(pszParamOid: LPSTR, pvParam: LPVOID)>;
unsafe extern "C" {
    pub fn CryptCreateAsyncHandle(dwFlags: DWORD, phAsync: PHCRYPTASYNC) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetAsyncParam(
        hAsync: HCRYPTASYNC,
        pszParamOid: LPSTR,
        pvParam: LPVOID,
        pfnFree: PFN_CRYPT_ASYNC_PARAM_FREE_FUNC,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptGetAsyncParam(
        hAsync: HCRYPTASYNC,
        pszParamOid: LPSTR,
        ppvParam: *mut LPVOID,
        ppfnFree: *mut PFN_CRYPT_ASYNC_PARAM_FREE_FUNC,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptCloseAsyncHandle(hAsync: HCRYPTASYNC) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_BLOB_ARRAY {
    pub cBlob: DWORD,
    pub rgBlob: PCRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_BLOB_ARRAY"][::std::mem::size_of::<_CRYPT_BLOB_ARRAY>() - 16usize];
    ["Alignment of _CRYPT_BLOB_ARRAY"][::std::mem::align_of::<_CRYPT_BLOB_ARRAY>() - 8usize];
    ["Offset of field: _CRYPT_BLOB_ARRAY::cBlob"]
        [::std::mem::offset_of!(_CRYPT_BLOB_ARRAY, cBlob) - 0usize];
    ["Offset of field: _CRYPT_BLOB_ARRAY::rgBlob"]
        [::std::mem::offset_of!(_CRYPT_BLOB_ARRAY, rgBlob) - 8usize];
};
pub type CRYPT_BLOB_ARRAY = _CRYPT_BLOB_ARRAY;
pub type PCRYPT_BLOB_ARRAY = *mut _CRYPT_BLOB_ARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_CREDENTIALS {
    pub cbSize: DWORD,
    pub pszCredentialsOid: LPCSTR,
    pub pvCredentials: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_CREDENTIALS"][::std::mem::size_of::<_CRYPT_CREDENTIALS>() - 24usize];
    ["Alignment of _CRYPT_CREDENTIALS"][::std::mem::align_of::<_CRYPT_CREDENTIALS>() - 8usize];
    ["Offset of field: _CRYPT_CREDENTIALS::cbSize"]
        [::std::mem::offset_of!(_CRYPT_CREDENTIALS, cbSize) - 0usize];
    ["Offset of field: _CRYPT_CREDENTIALS::pszCredentialsOid"]
        [::std::mem::offset_of!(_CRYPT_CREDENTIALS, pszCredentialsOid) - 8usize];
    ["Offset of field: _CRYPT_CREDENTIALS::pvCredentials"]
        [::std::mem::offset_of!(_CRYPT_CREDENTIALS, pvCredentials) - 16usize];
};
pub type CRYPT_CREDENTIALS = _CRYPT_CREDENTIALS;
pub type PCRYPT_CREDENTIALS = *mut _CRYPT_CREDENTIALS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PASSWORD_CREDENTIALSA {
    pub cbSize: DWORD,
    pub pszUsername: LPSTR,
    pub pszPassword: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PASSWORD_CREDENTIALSA"]
        [::std::mem::size_of::<_CRYPT_PASSWORD_CREDENTIALSA>() - 24usize];
    ["Alignment of _CRYPT_PASSWORD_CREDENTIALSA"]
        [::std::mem::align_of::<_CRYPT_PASSWORD_CREDENTIALSA>() - 8usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSA::cbSize"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSA, cbSize) - 0usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSA::pszUsername"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSA, pszUsername) - 8usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSA::pszPassword"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSA, pszPassword) - 16usize];
};
pub type CRYPT_PASSWORD_CREDENTIALSA = _CRYPT_PASSWORD_CREDENTIALSA;
pub type PCRYPT_PASSWORD_CREDENTIALSA = *mut _CRYPT_PASSWORD_CREDENTIALSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PASSWORD_CREDENTIALSW {
    pub cbSize: DWORD,
    pub pszUsername: LPWSTR,
    pub pszPassword: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PASSWORD_CREDENTIALSW"]
        [::std::mem::size_of::<_CRYPT_PASSWORD_CREDENTIALSW>() - 24usize];
    ["Alignment of _CRYPT_PASSWORD_CREDENTIALSW"]
        [::std::mem::align_of::<_CRYPT_PASSWORD_CREDENTIALSW>() - 8usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSW::cbSize"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSW, cbSize) - 0usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSW::pszUsername"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSW, pszUsername) - 8usize];
    ["Offset of field: _CRYPT_PASSWORD_CREDENTIALSW::pszPassword"]
        [::std::mem::offset_of!(_CRYPT_PASSWORD_CREDENTIALSW, pszPassword) - 16usize];
};
pub type CRYPT_PASSWORD_CREDENTIALSW = _CRYPT_PASSWORD_CREDENTIALSW;
pub type PCRYPT_PASSWORD_CREDENTIALSW = *mut _CRYPT_PASSWORD_CREDENTIALSW;
pub type CRYPT_PASSWORD_CREDENTIALS = CRYPT_PASSWORD_CREDENTIALSA;
pub type PCRYPT_PASSWORD_CREDENTIALS = PCRYPT_PASSWORD_CREDENTIALSA;
pub type PFN_FREE_ENCODED_OBJECT_FUNC = ::std::option::Option<
    unsafe extern "C" fn(pszObjectOid: LPCSTR, pObject: PCRYPT_BLOB_ARRAY, pvFreeContext: LPVOID),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPTNET_URL_CACHE_PRE_FETCH_INFO {
    pub cbSize: DWORD,
    pub dwObjectType: DWORD,
    pub dwError: DWORD,
    pub dwReserved: DWORD,
    pub ThisUpdateTime: FILETIME,
    pub NextUpdateTime: FILETIME,
    pub PublishTime: FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPTNET_URL_CACHE_PRE_FETCH_INFO"]
        [::std::mem::size_of::<_CRYPTNET_URL_CACHE_PRE_FETCH_INFO>() - 40usize];
    ["Alignment of _CRYPTNET_URL_CACHE_PRE_FETCH_INFO"]
        [::std::mem::align_of::<_CRYPTNET_URL_CACHE_PRE_FETCH_INFO>() - 4usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::dwObjectType"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, dwObjectType) - 4usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::dwError"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, dwError) - 8usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::dwReserved"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, dwReserved) - 12usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::ThisUpdateTime"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, ThisUpdateTime) - 16usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::NextUpdateTime"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, NextUpdateTime) - 24usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_PRE_FETCH_INFO::PublishTime"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_PRE_FETCH_INFO, PublishTime) - 32usize];
};
pub type CRYPTNET_URL_CACHE_PRE_FETCH_INFO = _CRYPTNET_URL_CACHE_PRE_FETCH_INFO;
pub type PCRYPTNET_URL_CACHE_PRE_FETCH_INFO = *mut _CRYPTNET_URL_CACHE_PRE_FETCH_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPTNET_URL_CACHE_FLUSH_INFO {
    pub cbSize: DWORD,
    pub dwExemptSeconds: DWORD,
    pub ExpireTime: FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPTNET_URL_CACHE_FLUSH_INFO"]
        [::std::mem::size_of::<_CRYPTNET_URL_CACHE_FLUSH_INFO>() - 16usize];
    ["Alignment of _CRYPTNET_URL_CACHE_FLUSH_INFO"]
        [::std::mem::align_of::<_CRYPTNET_URL_CACHE_FLUSH_INFO>() - 4usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_FLUSH_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_FLUSH_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_FLUSH_INFO::dwExemptSeconds"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_FLUSH_INFO, dwExemptSeconds) - 4usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_FLUSH_INFO::ExpireTime"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_FLUSH_INFO, ExpireTime) - 8usize];
};
pub type CRYPTNET_URL_CACHE_FLUSH_INFO = _CRYPTNET_URL_CACHE_FLUSH_INFO;
pub type PCRYPTNET_URL_CACHE_FLUSH_INFO = *mut _CRYPTNET_URL_CACHE_FLUSH_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPTNET_URL_CACHE_RESPONSE_INFO {
    pub cbSize: DWORD,
    pub wResponseType: WORD,
    pub wResponseFlags: WORD,
    pub LastModifiedTime: FILETIME,
    pub dwMaxAge: DWORD,
    pub pwszETag: LPCWSTR,
    pub dwProxyId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPTNET_URL_CACHE_RESPONSE_INFO"]
        [::std::mem::size_of::<_CRYPTNET_URL_CACHE_RESPONSE_INFO>() - 40usize];
    ["Alignment of _CRYPTNET_URL_CACHE_RESPONSE_INFO"]
        [::std::mem::align_of::<_CRYPTNET_URL_CACHE_RESPONSE_INFO>() - 8usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::wResponseType"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, wResponseType) - 4usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::wResponseFlags"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, wResponseFlags) - 6usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::LastModifiedTime"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, LastModifiedTime) - 8usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::dwMaxAge"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, dwMaxAge) - 16usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::pwszETag"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, pwszETag) - 24usize];
    ["Offset of field: _CRYPTNET_URL_CACHE_RESPONSE_INFO::dwProxyId"]
        [::std::mem::offset_of!(_CRYPTNET_URL_CACHE_RESPONSE_INFO, dwProxyId) - 32usize];
};
pub type CRYPTNET_URL_CACHE_RESPONSE_INFO = _CRYPTNET_URL_CACHE_RESPONSE_INFO;
pub type PCRYPTNET_URL_CACHE_RESPONSE_INFO = *mut _CRYPTNET_URL_CACHE_RESPONSE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_RETRIEVE_AUX_INFO {
    pub cbSize: DWORD,
    pub pLastSyncTime: *mut FILETIME,
    pub dwMaxUrlRetrievalByteCount: DWORD,
    pub pPreFetchInfo: PCRYPTNET_URL_CACHE_PRE_FETCH_INFO,
    pub pFlushInfo: PCRYPTNET_URL_CACHE_FLUSH_INFO,
    pub ppResponseInfo: *mut PCRYPTNET_URL_CACHE_RESPONSE_INFO,
    pub pwszCacheFileNamePrefix: LPWSTR,
    pub pftCacheResync: LPFILETIME,
    pub fProxyCacheRetrieval: BOOL,
    pub dwHttpStatusCode: DWORD,
    pub ppwszErrorResponseHeaders: *mut LPWSTR,
    pub ppErrorContentBlob: *mut PCRYPT_DATA_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_RETRIEVE_AUX_INFO"]
        [::std::mem::size_of::<_CRYPT_RETRIEVE_AUX_INFO>() - 88usize];
    ["Alignment of _CRYPT_RETRIEVE_AUX_INFO"]
        [::std::mem::align_of::<_CRYPT_RETRIEVE_AUX_INFO>() - 8usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::pLastSyncTime"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, pLastSyncTime) - 8usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::dwMaxUrlRetrievalByteCount"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, dwMaxUrlRetrievalByteCount) - 16usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::pPreFetchInfo"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, pPreFetchInfo) - 24usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::pFlushInfo"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, pFlushInfo) - 32usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::ppResponseInfo"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, ppResponseInfo) - 40usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::pwszCacheFileNamePrefix"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, pwszCacheFileNamePrefix) - 48usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::pftCacheResync"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, pftCacheResync) - 56usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::fProxyCacheRetrieval"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, fProxyCacheRetrieval) - 64usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::dwHttpStatusCode"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, dwHttpStatusCode) - 68usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::ppwszErrorResponseHeaders"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, ppwszErrorResponseHeaders) - 72usize];
    ["Offset of field: _CRYPT_RETRIEVE_AUX_INFO::ppErrorContentBlob"]
        [::std::mem::offset_of!(_CRYPT_RETRIEVE_AUX_INFO, ppErrorContentBlob) - 80usize];
};
pub type CRYPT_RETRIEVE_AUX_INFO = _CRYPT_RETRIEVE_AUX_INFO;
pub type PCRYPT_RETRIEVE_AUX_INFO = *mut _CRYPT_RETRIEVE_AUX_INFO;
unsafe extern "C" {
    pub fn CryptRetrieveObjectByUrlA(
        pszUrl: LPCSTR,
        pszObjectOid: LPCSTR,
        dwRetrievalFlags: DWORD,
        dwTimeout: DWORD,
        ppvObject: *mut LPVOID,
        hAsyncRetrieve: HCRYPTASYNC,
        pCredentials: PCRYPT_CREDENTIALS,
        pvVerify: LPVOID,
        pAuxInfo: PCRYPT_RETRIEVE_AUX_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptRetrieveObjectByUrlW(
        pszUrl: LPCWSTR,
        pszObjectOid: LPCSTR,
        dwRetrievalFlags: DWORD,
        dwTimeout: DWORD,
        ppvObject: *mut LPVOID,
        hAsyncRetrieve: HCRYPTASYNC,
        pCredentials: PCRYPT_CREDENTIALS,
        pvVerify: LPVOID,
        pAuxInfo: PCRYPT_RETRIEVE_AUX_INFO,
    ) -> BOOL;
}
pub type PFN_CRYPT_CANCEL_RETRIEVAL = ::std::option::Option<
    unsafe extern "C" fn(dwFlags: DWORD, pvArg: *mut ::std::os::raw::c_void) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptInstallCancelRetrieval(
        pfnCancel: PFN_CRYPT_CANCEL_RETRIEVAL,
        pvArg: *const ::std::os::raw::c_void,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUninstallCancelRetrieval(
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptCancelAsyncRetrieval(hAsyncRetrieval: HCRYPTASYNC) -> BOOL;
}
pub type PFN_CRYPT_ASYNC_RETRIEVAL_COMPLETION_FUNC = ::std::option::Option<
    unsafe extern "C" fn(
        pvCompletion: LPVOID,
        dwCompletionCode: DWORD,
        pszUrl: LPCSTR,
        pszObjectOid: LPSTR,
        pvObject: LPVOID,
    ),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_ASYNC_RETRIEVAL_COMPLETION {
    pub pfnCompletion: PFN_CRYPT_ASYNC_RETRIEVAL_COMPLETION_FUNC,
    pub pvCompletion: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_ASYNC_RETRIEVAL_COMPLETION"]
        [::std::mem::size_of::<_CRYPT_ASYNC_RETRIEVAL_COMPLETION>() - 16usize];
    ["Alignment of _CRYPT_ASYNC_RETRIEVAL_COMPLETION"]
        [::std::mem::align_of::<_CRYPT_ASYNC_RETRIEVAL_COMPLETION>() - 8usize];
    ["Offset of field: _CRYPT_ASYNC_RETRIEVAL_COMPLETION::pfnCompletion"]
        [::std::mem::offset_of!(_CRYPT_ASYNC_RETRIEVAL_COMPLETION, pfnCompletion) - 0usize];
    ["Offset of field: _CRYPT_ASYNC_RETRIEVAL_COMPLETION::pvCompletion"]
        [::std::mem::offset_of!(_CRYPT_ASYNC_RETRIEVAL_COMPLETION, pvCompletion) - 8usize];
};
pub type CRYPT_ASYNC_RETRIEVAL_COMPLETION = _CRYPT_ASYNC_RETRIEVAL_COMPLETION;
pub type PCRYPT_ASYNC_RETRIEVAL_COMPLETION = *mut _CRYPT_ASYNC_RETRIEVAL_COMPLETION;
pub type PFN_CANCEL_ASYNC_RETRIEVAL_FUNC =
    ::std::option::Option<unsafe extern "C" fn(hAsyncRetrieve: HCRYPTASYNC) -> BOOL>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_URL_ARRAY {
    pub cUrl: DWORD,
    pub rgwszUrl: *mut LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_URL_ARRAY"][::std::mem::size_of::<_CRYPT_URL_ARRAY>() - 16usize];
    ["Alignment of _CRYPT_URL_ARRAY"][::std::mem::align_of::<_CRYPT_URL_ARRAY>() - 8usize];
    ["Offset of field: _CRYPT_URL_ARRAY::cUrl"]
        [::std::mem::offset_of!(_CRYPT_URL_ARRAY, cUrl) - 0usize];
    ["Offset of field: _CRYPT_URL_ARRAY::rgwszUrl"]
        [::std::mem::offset_of!(_CRYPT_URL_ARRAY, rgwszUrl) - 8usize];
};
pub type CRYPT_URL_ARRAY = _CRYPT_URL_ARRAY;
pub type PCRYPT_URL_ARRAY = *mut _CRYPT_URL_ARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_URL_INFO {
    pub cbSize: DWORD,
    pub dwSyncDeltaTime: DWORD,
    pub cGroup: DWORD,
    pub rgcGroupEntry: *mut DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_URL_INFO"][::std::mem::size_of::<_CRYPT_URL_INFO>() - 24usize];
    ["Alignment of _CRYPT_URL_INFO"][::std::mem::align_of::<_CRYPT_URL_INFO>() - 8usize];
    ["Offset of field: _CRYPT_URL_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPT_URL_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPT_URL_INFO::dwSyncDeltaTime"]
        [::std::mem::offset_of!(_CRYPT_URL_INFO, dwSyncDeltaTime) - 4usize];
    ["Offset of field: _CRYPT_URL_INFO::cGroup"]
        [::std::mem::offset_of!(_CRYPT_URL_INFO, cGroup) - 8usize];
    ["Offset of field: _CRYPT_URL_INFO::rgcGroupEntry"]
        [::std::mem::offset_of!(_CRYPT_URL_INFO, rgcGroupEntry) - 16usize];
};
pub type CRYPT_URL_INFO = _CRYPT_URL_INFO;
pub type PCRYPT_URL_INFO = *mut _CRYPT_URL_INFO;
unsafe extern "C" {
    pub fn CryptGetObjectUrl(
        pszUrlOid: LPCSTR,
        pvPara: LPVOID,
        dwFlags: DWORD,
        pUrlArray: PCRYPT_URL_ARRAY,
        pcbUrlArray: *mut DWORD,
        pUrlInfo: PCRYPT_URL_INFO,
        pcbUrlInfo: *mut DWORD,
        pvReserved: LPVOID,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CRL_CONTEXT_PAIR {
    pub pCertContext: PCCERT_CONTEXT,
    pub pCrlContext: PCCRL_CONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CRL_CONTEXT_PAIR"][::std::mem::size_of::<_CERT_CRL_CONTEXT_PAIR>() - 16usize];
    ["Alignment of _CERT_CRL_CONTEXT_PAIR"]
        [::std::mem::align_of::<_CERT_CRL_CONTEXT_PAIR>() - 8usize];
    ["Offset of field: _CERT_CRL_CONTEXT_PAIR::pCertContext"]
        [::std::mem::offset_of!(_CERT_CRL_CONTEXT_PAIR, pCertContext) - 0usize];
    ["Offset of field: _CERT_CRL_CONTEXT_PAIR::pCrlContext"]
        [::std::mem::offset_of!(_CERT_CRL_CONTEXT_PAIR, pCrlContext) - 8usize];
};
pub type CERT_CRL_CONTEXT_PAIR = _CERT_CRL_CONTEXT_PAIR;
pub type PCERT_CRL_CONTEXT_PAIR = *mut _CERT_CRL_CONTEXT_PAIR;
pub type PCCERT_CRL_CONTEXT_PAIR = *const CERT_CRL_CONTEXT_PAIR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO {
    pub cbSize: DWORD,
    pub iDeltaCrlIndicator: ::std::os::raw::c_int,
    pub pftCacheResync: LPFILETIME,
    pub pLastSyncTime: LPFILETIME,
    pub pMaxAgeTime: LPFILETIME,
    pub pChainPara: PCERT_REVOCATION_CHAIN_PARA,
    pub pDeltaCrlIndicator: PCRYPT_INTEGER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO"]
        [::std::mem::size_of::<_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO>() - 48usize];
    ["Alignment of _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO"]
        [::std::mem::align_of::<_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO>() - 8usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::cbSize"]
        [::std::mem::offset_of!(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO, cbSize) - 0usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::iDeltaCrlIndicator"][::std::mem::offset_of!(
        _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO,
        iDeltaCrlIndicator
    ) - 4usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::pftCacheResync"]
        [::std::mem::offset_of!(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO, pftCacheResync) - 8usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::pLastSyncTime"]
        [::std::mem::offset_of!(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO, pLastSyncTime) - 16usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::pMaxAgeTime"]
        [::std::mem::offset_of!(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO, pMaxAgeTime) - 24usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::pChainPara"]
        [::std::mem::offset_of!(_CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO, pChainPara) - 32usize];
    ["Offset of field: _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO::pDeltaCrlIndicator"][::std::mem::offset_of!(
        _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO,
        pDeltaCrlIndicator
    ) - 40usize];
};
pub type CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO = _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO;
pub type PCRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO = *mut _CRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO;
unsafe extern "C" {
    pub fn CryptGetTimeValidObject(
        pszTimeValidOid: LPCSTR,
        pvPara: LPVOID,
        pIssuer: PCCERT_CONTEXT,
        pftValidFor: LPFILETIME,
        dwFlags: DWORD,
        dwTimeout: DWORD,
        ppvObject: *mut LPVOID,
        pCredentials: PCRYPT_CREDENTIALS,
        pExtraInfo: PCRYPT_GET_TIME_VALID_OBJECT_EXTRA_INFO,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptFlushTimeValidObject(
        pszFlushTimeValidOid: LPCSTR,
        pvPara: LPVOID,
        pIssuer: PCCERT_CONTEXT,
        dwFlags: DWORD,
        pvReserved: LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertCreateSelfSignCertificate(
        hCryptProvOrNCryptKey: HCRYPTPROV_OR_NCRYPT_KEY_HANDLE,
        pSubjectIssuerBlob: PCERT_NAME_BLOB,
        dwFlags: DWORD,
        pKeyProvInfo: PCRYPT_KEY_PROV_INFO,
        pSignatureAlgorithm: PCRYPT_ALGORITHM_IDENTIFIER,
        pStartTime: PSYSTEMTIME,
        pEndTime: PSYSTEMTIME,
        pExtensions: PCERT_EXTENSIONS,
    ) -> PCCERT_CONTEXT;
}
unsafe extern "C" {
    pub fn CryptGetKeyIdentifierProperty(
        pKeyIdentifier: *const CRYPT_HASH_BLOB,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pwszComputerName: LPCWSTR,
        pvReserved: *mut ::std::os::raw::c_void,
        pvData: *mut ::std::os::raw::c_void,
        pcbData: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptSetKeyIdentifierProperty(
        pKeyIdentifier: *const CRYPT_HASH_BLOB,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pwszComputerName: LPCWSTR,
        pvReserved: *mut ::std::os::raw::c_void,
        pvData: *const ::std::os::raw::c_void,
    ) -> BOOL;
}
pub type PFN_CRYPT_ENUM_KEYID_PROP = ::std::option::Option<
    unsafe extern "C" fn(
        pKeyIdentifier: *const CRYPT_HASH_BLOB,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
        cProp: DWORD,
        rgdwPropId: *mut DWORD,
        rgpvData: *mut *mut ::std::os::raw::c_void,
        rgcbData: *mut DWORD,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CryptEnumKeyIdentifierProperties(
        pKeyIdentifier: *const CRYPT_HASH_BLOB,
        dwPropId: DWORD,
        dwFlags: DWORD,
        pwszComputerName: LPCWSTR,
        pvReserved: *mut ::std::os::raw::c_void,
        pvArg: *mut ::std::os::raw::c_void,
        pfnEnum: PFN_CRYPT_ENUM_KEYID_PROP,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptCreateKeyIdentifierFromCSP(
        dwCertEncodingType: DWORD,
        pszPubKeyOID: LPCSTR,
        pPubKeyStruc: *const PUBLICKEYSTRUC,
        cbPubKeyStruc: DWORD,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        pbHash: *mut BYTE,
        pcbHash: *mut DWORD,
    ) -> BOOL;
}
pub type HCERTCHAINENGINE = HANDLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_ENGINE_CONFIG {
    pub cbSize: DWORD,
    pub hRestrictedRoot: HCERTSTORE,
    pub hRestrictedTrust: HCERTSTORE,
    pub hRestrictedOther: HCERTSTORE,
    pub cAdditionalStore: DWORD,
    pub rghAdditionalStore: *mut HCERTSTORE,
    pub dwFlags: DWORD,
    pub dwUrlRetrievalTimeout: DWORD,
    pub MaximumCachedCertificates: DWORD,
    pub CycleDetectionModulus: DWORD,
    pub hExclusiveRoot: HCERTSTORE,
    pub hExclusiveTrustedPeople: HCERTSTORE,
    pub dwExclusiveFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_ENGINE_CONFIG"]
        [::std::mem::size_of::<_CERT_CHAIN_ENGINE_CONFIG>() - 88usize];
    ["Alignment of _CERT_CHAIN_ENGINE_CONFIG"]
        [::std::mem::align_of::<_CERT_CHAIN_ENGINE_CONFIG>() - 8usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::hRestrictedRoot"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, hRestrictedRoot) - 8usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::hRestrictedTrust"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, hRestrictedTrust) - 16usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::hRestrictedOther"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, hRestrictedOther) - 24usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::cAdditionalStore"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, cAdditionalStore) - 32usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::rghAdditionalStore"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, rghAdditionalStore) - 40usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::dwFlags"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, dwFlags) - 48usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::dwUrlRetrievalTimeout"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, dwUrlRetrievalTimeout) - 52usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::MaximumCachedCertificates"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, MaximumCachedCertificates) - 56usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::CycleDetectionModulus"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, CycleDetectionModulus) - 60usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::hExclusiveRoot"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, hExclusiveRoot) - 64usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::hExclusiveTrustedPeople"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, hExclusiveTrustedPeople) - 72usize];
    ["Offset of field: _CERT_CHAIN_ENGINE_CONFIG::dwExclusiveFlags"]
        [::std::mem::offset_of!(_CERT_CHAIN_ENGINE_CONFIG, dwExclusiveFlags) - 80usize];
};
pub type CERT_CHAIN_ENGINE_CONFIG = _CERT_CHAIN_ENGINE_CONFIG;
pub type PCERT_CHAIN_ENGINE_CONFIG = *mut _CERT_CHAIN_ENGINE_CONFIG;
unsafe extern "C" {
    pub fn CertCreateCertificateChainEngine(
        pConfig: PCERT_CHAIN_ENGINE_CONFIG,
        phChainEngine: *mut HCERTCHAINENGINE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertFreeCertificateChainEngine(hChainEngine: HCERTCHAINENGINE);
}
unsafe extern "C" {
    pub fn CertResyncCertificateChainEngine(hChainEngine: HCERTCHAINENGINE) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_TRUST_STATUS {
    pub dwErrorStatus: DWORD,
    pub dwInfoStatus: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_TRUST_STATUS"][::std::mem::size_of::<_CERT_TRUST_STATUS>() - 8usize];
    ["Alignment of _CERT_TRUST_STATUS"][::std::mem::align_of::<_CERT_TRUST_STATUS>() - 4usize];
    ["Offset of field: _CERT_TRUST_STATUS::dwErrorStatus"]
        [::std::mem::offset_of!(_CERT_TRUST_STATUS, dwErrorStatus) - 0usize];
    ["Offset of field: _CERT_TRUST_STATUS::dwInfoStatus"]
        [::std::mem::offset_of!(_CERT_TRUST_STATUS, dwInfoStatus) - 4usize];
};
pub type CERT_TRUST_STATUS = _CERT_TRUST_STATUS;
pub type PCERT_TRUST_STATUS = *mut _CERT_TRUST_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REVOCATION_INFO {
    pub cbSize: DWORD,
    pub dwRevocationResult: DWORD,
    pub pszRevocationOid: LPCSTR,
    pub pvOidSpecificInfo: LPVOID,
    pub fHasFreshnessTime: BOOL,
    pub dwFreshnessTime: DWORD,
    pub pCrlInfo: PCERT_REVOCATION_CRL_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REVOCATION_INFO"][::std::mem::size_of::<_CERT_REVOCATION_INFO>() - 40usize];
    ["Alignment of _CERT_REVOCATION_INFO"]
        [::std::mem::align_of::<_CERT_REVOCATION_INFO>() - 8usize];
    ["Offset of field: _CERT_REVOCATION_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_REVOCATION_INFO::dwRevocationResult"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, dwRevocationResult) - 4usize];
    ["Offset of field: _CERT_REVOCATION_INFO::pszRevocationOid"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, pszRevocationOid) - 8usize];
    ["Offset of field: _CERT_REVOCATION_INFO::pvOidSpecificInfo"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, pvOidSpecificInfo) - 16usize];
    ["Offset of field: _CERT_REVOCATION_INFO::fHasFreshnessTime"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, fHasFreshnessTime) - 24usize];
    ["Offset of field: _CERT_REVOCATION_INFO::dwFreshnessTime"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, dwFreshnessTime) - 28usize];
    ["Offset of field: _CERT_REVOCATION_INFO::pCrlInfo"]
        [::std::mem::offset_of!(_CERT_REVOCATION_INFO, pCrlInfo) - 32usize];
};
pub type CERT_REVOCATION_INFO = _CERT_REVOCATION_INFO;
pub type PCERT_REVOCATION_INFO = *mut _CERT_REVOCATION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_TRUST_LIST_INFO {
    pub cbSize: DWORD,
    pub pCtlEntry: PCTL_ENTRY,
    pub pCtlContext: PCCTL_CONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_TRUST_LIST_INFO"][::std::mem::size_of::<_CERT_TRUST_LIST_INFO>() - 24usize];
    ["Alignment of _CERT_TRUST_LIST_INFO"]
        [::std::mem::align_of::<_CERT_TRUST_LIST_INFO>() - 8usize];
    ["Offset of field: _CERT_TRUST_LIST_INFO::cbSize"]
        [::std::mem::offset_of!(_CERT_TRUST_LIST_INFO, cbSize) - 0usize];
    ["Offset of field: _CERT_TRUST_LIST_INFO::pCtlEntry"]
        [::std::mem::offset_of!(_CERT_TRUST_LIST_INFO, pCtlEntry) - 8usize];
    ["Offset of field: _CERT_TRUST_LIST_INFO::pCtlContext"]
        [::std::mem::offset_of!(_CERT_TRUST_LIST_INFO, pCtlContext) - 16usize];
};
pub type CERT_TRUST_LIST_INFO = _CERT_TRUST_LIST_INFO;
pub type PCERT_TRUST_LIST_INFO = *mut _CERT_TRUST_LIST_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_ELEMENT {
    pub cbSize: DWORD,
    pub pCertContext: PCCERT_CONTEXT,
    pub TrustStatus: CERT_TRUST_STATUS,
    pub pRevocationInfo: PCERT_REVOCATION_INFO,
    pub pIssuanceUsage: PCERT_ENHKEY_USAGE,
    pub pApplicationUsage: PCERT_ENHKEY_USAGE,
    pub pwszExtendedErrorInfo: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_ELEMENT"][::std::mem::size_of::<_CERT_CHAIN_ELEMENT>() - 56usize];
    ["Alignment of _CERT_CHAIN_ELEMENT"][::std::mem::align_of::<_CERT_CHAIN_ELEMENT>() - 8usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::pCertContext"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, pCertContext) - 8usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::TrustStatus"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, TrustStatus) - 16usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::pRevocationInfo"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, pRevocationInfo) - 24usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::pIssuanceUsage"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, pIssuanceUsage) - 32usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::pApplicationUsage"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, pApplicationUsage) - 40usize];
    ["Offset of field: _CERT_CHAIN_ELEMENT::pwszExtendedErrorInfo"]
        [::std::mem::offset_of!(_CERT_CHAIN_ELEMENT, pwszExtendedErrorInfo) - 48usize];
};
pub type CERT_CHAIN_ELEMENT = _CERT_CHAIN_ELEMENT;
pub type PCERT_CHAIN_ELEMENT = *mut _CERT_CHAIN_ELEMENT;
pub type PCCERT_CHAIN_ELEMENT = *const CERT_CHAIN_ELEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SIMPLE_CHAIN {
    pub cbSize: DWORD,
    pub TrustStatus: CERT_TRUST_STATUS,
    pub cElement: DWORD,
    pub rgpElement: *mut PCERT_CHAIN_ELEMENT,
    pub pTrustListInfo: PCERT_TRUST_LIST_INFO,
    pub fHasRevocationFreshnessTime: BOOL,
    pub dwRevocationFreshnessTime: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SIMPLE_CHAIN"][::std::mem::size_of::<_CERT_SIMPLE_CHAIN>() - 40usize];
    ["Alignment of _CERT_SIMPLE_CHAIN"][::std::mem::align_of::<_CERT_SIMPLE_CHAIN>() - 8usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::cbSize"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, cbSize) - 0usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::TrustStatus"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, TrustStatus) - 4usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::cElement"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, cElement) - 12usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::rgpElement"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, rgpElement) - 16usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::pTrustListInfo"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, pTrustListInfo) - 24usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::fHasRevocationFreshnessTime"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, fHasRevocationFreshnessTime) - 32usize];
    ["Offset of field: _CERT_SIMPLE_CHAIN::dwRevocationFreshnessTime"]
        [::std::mem::offset_of!(_CERT_SIMPLE_CHAIN, dwRevocationFreshnessTime) - 36usize];
};
pub type CERT_SIMPLE_CHAIN = _CERT_SIMPLE_CHAIN;
pub type PCERT_SIMPLE_CHAIN = *mut _CERT_SIMPLE_CHAIN;
pub type PCCERT_SIMPLE_CHAIN = *const CERT_SIMPLE_CHAIN;
pub type CERT_CHAIN_CONTEXT = _CERT_CHAIN_CONTEXT;
pub type PCERT_CHAIN_CONTEXT = *mut _CERT_CHAIN_CONTEXT;
pub type PCCERT_CHAIN_CONTEXT = *const CERT_CHAIN_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_CONTEXT {
    pub cbSize: DWORD,
    pub TrustStatus: CERT_TRUST_STATUS,
    pub cChain: DWORD,
    pub rgpChain: *mut PCERT_SIMPLE_CHAIN,
    pub cLowerQualityChainContext: DWORD,
    pub rgpLowerQualityChainContext: *mut PCCERT_CHAIN_CONTEXT,
    pub fHasRevocationFreshnessTime: BOOL,
    pub dwRevocationFreshnessTime: DWORD,
    pub dwCreateFlags: DWORD,
    pub ChainId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_CONTEXT"][::std::mem::size_of::<_CERT_CHAIN_CONTEXT>() - 72usize];
    ["Alignment of _CERT_CHAIN_CONTEXT"][::std::mem::align_of::<_CERT_CHAIN_CONTEXT>() - 8usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::TrustStatus"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, TrustStatus) - 4usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::cChain"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, cChain) - 12usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::rgpChain"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, rgpChain) - 16usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::cLowerQualityChainContext"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, cLowerQualityChainContext) - 24usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::rgpLowerQualityChainContext"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, rgpLowerQualityChainContext) - 32usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::fHasRevocationFreshnessTime"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, fHasRevocationFreshnessTime) - 40usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::dwRevocationFreshnessTime"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, dwRevocationFreshnessTime) - 44usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::dwCreateFlags"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, dwCreateFlags) - 48usize];
    ["Offset of field: _CERT_CHAIN_CONTEXT::ChainId"]
        [::std::mem::offset_of!(_CERT_CHAIN_CONTEXT, ChainId) - 52usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_USAGE_MATCH {
    pub dwType: DWORD,
    pub Usage: CERT_ENHKEY_USAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_USAGE_MATCH"][::std::mem::size_of::<_CERT_USAGE_MATCH>() - 24usize];
    ["Alignment of _CERT_USAGE_MATCH"][::std::mem::align_of::<_CERT_USAGE_MATCH>() - 8usize];
    ["Offset of field: _CERT_USAGE_MATCH::dwType"]
        [::std::mem::offset_of!(_CERT_USAGE_MATCH, dwType) - 0usize];
    ["Offset of field: _CERT_USAGE_MATCH::Usage"]
        [::std::mem::offset_of!(_CERT_USAGE_MATCH, Usage) - 8usize];
};
pub type CERT_USAGE_MATCH = _CERT_USAGE_MATCH;
pub type PCERT_USAGE_MATCH = *mut _CERT_USAGE_MATCH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CTL_USAGE_MATCH {
    pub dwType: DWORD,
    pub Usage: CTL_USAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CTL_USAGE_MATCH"][::std::mem::size_of::<_CTL_USAGE_MATCH>() - 24usize];
    ["Alignment of _CTL_USAGE_MATCH"][::std::mem::align_of::<_CTL_USAGE_MATCH>() - 8usize];
    ["Offset of field: _CTL_USAGE_MATCH::dwType"]
        [::std::mem::offset_of!(_CTL_USAGE_MATCH, dwType) - 0usize];
    ["Offset of field: _CTL_USAGE_MATCH::Usage"]
        [::std::mem::offset_of!(_CTL_USAGE_MATCH, Usage) - 8usize];
};
pub type CTL_USAGE_MATCH = _CTL_USAGE_MATCH;
pub type PCTL_USAGE_MATCH = *mut _CTL_USAGE_MATCH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_PARA {
    pub cbSize: DWORD,
    pub RequestedUsage: CERT_USAGE_MATCH,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_PARA"][::std::mem::size_of::<_CERT_CHAIN_PARA>() - 32usize];
    ["Alignment of _CERT_CHAIN_PARA"][::std::mem::align_of::<_CERT_CHAIN_PARA>() - 8usize];
    ["Offset of field: _CERT_CHAIN_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_PARA::RequestedUsage"]
        [::std::mem::offset_of!(_CERT_CHAIN_PARA, RequestedUsage) - 8usize];
};
pub type CERT_CHAIN_PARA = _CERT_CHAIN_PARA;
pub type PCERT_CHAIN_PARA = *mut _CERT_CHAIN_PARA;
unsafe extern "C" {
    pub fn CertGetCertificateChain(
        hChainEngine: HCERTCHAINENGINE,
        pCertContext: PCCERT_CONTEXT,
        pTime: LPFILETIME,
        hAdditionalStore: HCERTSTORE,
        pChainPara: PCERT_CHAIN_PARA,
        dwFlags: DWORD,
        pvReserved: LPVOID,
        ppChainContext: *mut PCCERT_CHAIN_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertFreeCertificateChain(pChainContext: PCCERT_CHAIN_CONTEXT);
}
unsafe extern "C" {
    pub fn CertDuplicateCertificateChain(
        pChainContext: PCCERT_CHAIN_CONTEXT,
    ) -> PCCERT_CHAIN_CONTEXT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_REVOCATION_CHAIN_PARA {
    pub cbSize: DWORD,
    pub hChainEngine: HCERTCHAINENGINE,
    pub hAdditionalStore: HCERTSTORE,
    pub dwChainFlags: DWORD,
    pub dwUrlRetrievalTimeout: DWORD,
    pub pftCurrentTime: LPFILETIME,
    pub pftCacheResync: LPFILETIME,
    pub cbMaxUrlRetrievalByteCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_REVOCATION_CHAIN_PARA"]
        [::std::mem::size_of::<_CERT_REVOCATION_CHAIN_PARA>() - 56usize];
    ["Alignment of _CERT_REVOCATION_CHAIN_PARA"]
        [::std::mem::align_of::<_CERT_REVOCATION_CHAIN_PARA>() - 8usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::hChainEngine"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, hChainEngine) - 8usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::hAdditionalStore"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, hAdditionalStore) - 16usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::dwChainFlags"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, dwChainFlags) - 24usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::dwUrlRetrievalTimeout"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, dwUrlRetrievalTimeout) - 28usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::pftCurrentTime"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, pftCurrentTime) - 32usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::pftCacheResync"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, pftCacheResync) - 40usize];
    ["Offset of field: _CERT_REVOCATION_CHAIN_PARA::cbMaxUrlRetrievalByteCount"]
        [::std::mem::offset_of!(_CERT_REVOCATION_CHAIN_PARA, cbMaxUrlRetrievalByteCount) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRL_REVOCATION_INFO {
    pub pCrlEntry: PCRL_ENTRY,
    pub pCrlContext: PCCRL_CONTEXT,
    pub pCrlIssuerChain: PCCERT_CHAIN_CONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRL_REVOCATION_INFO"][::std::mem::size_of::<_CRL_REVOCATION_INFO>() - 24usize];
    ["Alignment of _CRL_REVOCATION_INFO"][::std::mem::align_of::<_CRL_REVOCATION_INFO>() - 8usize];
    ["Offset of field: _CRL_REVOCATION_INFO::pCrlEntry"]
        [::std::mem::offset_of!(_CRL_REVOCATION_INFO, pCrlEntry) - 0usize];
    ["Offset of field: _CRL_REVOCATION_INFO::pCrlContext"]
        [::std::mem::offset_of!(_CRL_REVOCATION_INFO, pCrlContext) - 8usize];
    ["Offset of field: _CRL_REVOCATION_INFO::pCrlIssuerChain"]
        [::std::mem::offset_of!(_CRL_REVOCATION_INFO, pCrlIssuerChain) - 16usize];
};
pub type CRL_REVOCATION_INFO = _CRL_REVOCATION_INFO;
pub type PCRL_REVOCATION_INFO = *mut _CRL_REVOCATION_INFO;
unsafe extern "C" {
    pub fn CertFindChainInStore(
        hCertStore: HCERTSTORE,
        dwCertEncodingType: DWORD,
        dwFindFlags: DWORD,
        dwFindType: DWORD,
        pvFindPara: *const ::std::os::raw::c_void,
        pPrevChainContext: PCCERT_CHAIN_CONTEXT,
    ) -> PCCERT_CHAIN_CONTEXT;
}
pub type PFN_CERT_CHAIN_FIND_BY_ISSUER_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(pCert: PCCERT_CONTEXT, pvFindArg: *mut ::std::os::raw::c_void) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_FIND_BY_ISSUER_PARA {
    pub cbSize: DWORD,
    pub pszUsageIdentifier: LPCSTR,
    pub dwKeySpec: DWORD,
    pub dwAcquirePrivateKeyFlags: DWORD,
    pub cIssuer: DWORD,
    pub rgIssuer: *mut CERT_NAME_BLOB,
    pub pfnFindCallback: PFN_CERT_CHAIN_FIND_BY_ISSUER_CALLBACK,
    pub pvFindArg: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_FIND_BY_ISSUER_PARA"]
        [::std::mem::size_of::<_CERT_CHAIN_FIND_BY_ISSUER_PARA>() - 56usize];
    ["Alignment of _CERT_CHAIN_FIND_BY_ISSUER_PARA"]
        [::std::mem::align_of::<_CERT_CHAIN_FIND_BY_ISSUER_PARA>() - 8usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::pszUsageIdentifier"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, pszUsageIdentifier) - 8usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::dwKeySpec"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, dwKeySpec) - 16usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::dwAcquirePrivateKeyFlags"][::std::mem::offset_of!(
        _CERT_CHAIN_FIND_BY_ISSUER_PARA,
        dwAcquirePrivateKeyFlags
    ) - 20usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::cIssuer"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, cIssuer) - 24usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::rgIssuer"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, rgIssuer) - 32usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::pfnFindCallback"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, pfnFindCallback) - 40usize];
    ["Offset of field: _CERT_CHAIN_FIND_BY_ISSUER_PARA::pvFindArg"]
        [::std::mem::offset_of!(_CERT_CHAIN_FIND_BY_ISSUER_PARA, pvFindArg) - 48usize];
};
pub type CERT_CHAIN_FIND_ISSUER_PARA = _CERT_CHAIN_FIND_BY_ISSUER_PARA;
pub type PCERT_CHAIN_FIND_ISSUER_PARA = *mut _CERT_CHAIN_FIND_BY_ISSUER_PARA;
pub type CERT_CHAIN_FIND_BY_ISSUER_PARA = _CERT_CHAIN_FIND_BY_ISSUER_PARA;
pub type PCERT_CHAIN_FIND_BY_ISSUER_PARA = *mut _CERT_CHAIN_FIND_BY_ISSUER_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwFlags: DWORD,
    pub pvExtraPolicyPara: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_POLICY_PARA"][::std::mem::size_of::<_CERT_CHAIN_POLICY_PARA>() - 16usize];
    ["Alignment of _CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_CERT_CHAIN_POLICY_PARA>() - 8usize];
    ["Offset of field: _CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_POLICY_PARA::dwFlags"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_PARA, dwFlags) - 4usize];
    ["Offset of field: _CERT_CHAIN_POLICY_PARA::pvExtraPolicyPara"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_PARA, pvExtraPolicyPara) - 8usize];
};
pub type CERT_CHAIN_POLICY_PARA = _CERT_CHAIN_POLICY_PARA;
pub type PCERT_CHAIN_POLICY_PARA = *mut _CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_CHAIN_POLICY_STATUS {
    pub cbSize: DWORD,
    pub dwError: DWORD,
    pub lChainIndex: LONG,
    pub lElementIndex: LONG,
    pub pvExtraPolicyStatus: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::size_of::<_CERT_CHAIN_POLICY_STATUS>() - 24usize];
    ["Alignment of _CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::align_of::<_CERT_CHAIN_POLICY_STATUS>() - 8usize];
    ["Offset of field: _CERT_CHAIN_POLICY_STATUS::cbSize"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_STATUS, cbSize) - 0usize];
    ["Offset of field: _CERT_CHAIN_POLICY_STATUS::dwError"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_STATUS, dwError) - 4usize];
    ["Offset of field: _CERT_CHAIN_POLICY_STATUS::lChainIndex"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_STATUS, lChainIndex) - 8usize];
    ["Offset of field: _CERT_CHAIN_POLICY_STATUS::lElementIndex"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_STATUS, lElementIndex) - 12usize];
    ["Offset of field: _CERT_CHAIN_POLICY_STATUS::pvExtraPolicyStatus"]
        [::std::mem::offset_of!(_CERT_CHAIN_POLICY_STATUS, pvExtraPolicyStatus) - 16usize];
};
pub type CERT_CHAIN_POLICY_STATUS = _CERT_CHAIN_POLICY_STATUS;
pub type PCERT_CHAIN_POLICY_STATUS = *mut _CERT_CHAIN_POLICY_STATUS;
unsafe extern "C" {
    pub fn CertVerifyCertificateChainPolicy(
        pszPolicyOID: LPCSTR,
        pChainContext: PCCERT_CHAIN_CONTEXT,
        pPolicyPara: PCERT_CHAIN_POLICY_PARA,
        pPolicyStatus: PCERT_CHAIN_POLICY_STATUS,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwRegPolicySettings: DWORD,
    pub pSignerInfo: PCMSG_SIGNER_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::size_of::<_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA>() - 16usize];
    ["Alignment of _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA>() - 8usize];
    ["Offset of field: _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA::dwRegPolicySettings"][::std::mem::offset_of!(
        _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA,
        dwRegPolicySettings
    )
        - 4usize];
    ["Offset of field: _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA::pSignerInfo"]
        [::std::mem::offset_of!(_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA, pSignerInfo) - 8usize];
};
pub type AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA = _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA;
pub type PAUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA =
    *mut _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS {
    pub cbSize: DWORD,
    pub fCommercial: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::size_of::<_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 8usize];
    ["Alignment of _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::align_of::<_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 4usize];
    ["Offset of field: _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS::cbSize"]
        [::std::mem::offset_of!(_AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS, cbSize) - 0usize];
    ["Offset of field: _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS::fCommercial"][::std::mem::offset_of!(
        _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS,
        fCommercial
    ) - 4usize];
};
pub type AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS = _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS;
pub type PAUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS =
    *mut _AUTHENTICODE_EXTRA_CERT_CHAIN_POLICY_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwRegPolicySettings: DWORD,
    pub fCommercial: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::size_of::<_AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA>() - 12usize];
    ["Alignment of _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA>() - 4usize];
    ["Offset of field: _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA::dwRegPolicySettings"][::std::mem::offset_of!(
        _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA,
        dwRegPolicySettings
    )
        - 4usize];
    ["Offset of field: _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA::fCommercial"][::std::mem::offset_of!(
        _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA,
        fCommercial
    ) - 8usize];
};
pub type AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA =
    _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA;
pub type PAUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA =
    *mut _AUTHENTICODE_TS_EXTRA_CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _HTTPSPolicyCallbackData {
    pub __bindgen_anon_1: _HTTPSPolicyCallbackData__bindgen_ty_1,
    pub dwAuthType: DWORD,
    pub fdwChecks: DWORD,
    pub pwszServerName: *mut WCHAR,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _HTTPSPolicyCallbackData__bindgen_ty_1 {
    pub cbStruct: DWORD,
    pub cbSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HTTPSPolicyCallbackData__bindgen_ty_1"]
        [::std::mem::size_of::<_HTTPSPolicyCallbackData__bindgen_ty_1>() - 4usize];
    ["Alignment of _HTTPSPolicyCallbackData__bindgen_ty_1"]
        [::std::mem::align_of::<_HTTPSPolicyCallbackData__bindgen_ty_1>() - 4usize];
    ["Offset of field: _HTTPSPolicyCallbackData__bindgen_ty_1::cbStruct"]
        [::std::mem::offset_of!(_HTTPSPolicyCallbackData__bindgen_ty_1, cbStruct) - 0usize];
    ["Offset of field: _HTTPSPolicyCallbackData__bindgen_ty_1::cbSize"]
        [::std::mem::offset_of!(_HTTPSPolicyCallbackData__bindgen_ty_1, cbSize) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HTTPSPolicyCallbackData"]
        [::std::mem::size_of::<_HTTPSPolicyCallbackData>() - 24usize];
    ["Alignment of _HTTPSPolicyCallbackData"]
        [::std::mem::align_of::<_HTTPSPolicyCallbackData>() - 8usize];
    ["Offset of field: _HTTPSPolicyCallbackData::dwAuthType"]
        [::std::mem::offset_of!(_HTTPSPolicyCallbackData, dwAuthType) - 4usize];
    ["Offset of field: _HTTPSPolicyCallbackData::fdwChecks"]
        [::std::mem::offset_of!(_HTTPSPolicyCallbackData, fdwChecks) - 8usize];
    ["Offset of field: _HTTPSPolicyCallbackData::pwszServerName"]
        [::std::mem::offset_of!(_HTTPSPolicyCallbackData, pwszServerName) - 16usize];
};
pub type HTTPSPolicyCallbackData = _HTTPSPolicyCallbackData;
pub type PHTTPSPolicyCallbackData = *mut _HTTPSPolicyCallbackData;
pub type SSL_EXTRA_CERT_CHAIN_POLICY_PARA = _HTTPSPolicyCallbackData;
pub type PSSL_EXTRA_CERT_CHAIN_POLICY_PARA = *mut _HTTPSPolicyCallbackData;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EV_EXTRA_CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwRootProgramQualifierFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EV_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::size_of::<_EV_EXTRA_CERT_CHAIN_POLICY_PARA>() - 8usize];
    ["Alignment of _EV_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_EV_EXTRA_CERT_CHAIN_POLICY_PARA>() - 4usize];
    ["Offset of field: _EV_EXTRA_CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_EV_EXTRA_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _EV_EXTRA_CERT_CHAIN_POLICY_PARA::dwRootProgramQualifierFlags"][::std::mem::offset_of!(
        _EV_EXTRA_CERT_CHAIN_POLICY_PARA,
        dwRootProgramQualifierFlags
    ) - 4usize];
};
pub type EV_EXTRA_CERT_CHAIN_POLICY_PARA = _EV_EXTRA_CERT_CHAIN_POLICY_PARA;
pub type PEV_EXTRA_CERT_CHAIN_POLICY_PARA = *mut _EV_EXTRA_CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EV_EXTRA_CERT_CHAIN_POLICY_STATUS {
    pub cbSize: DWORD,
    pub dwQualifiers: DWORD,
    pub dwIssuanceUsageIndex: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EV_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::size_of::<_EV_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 12usize];
    ["Alignment of _EV_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::align_of::<_EV_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 4usize];
    ["Offset of field: _EV_EXTRA_CERT_CHAIN_POLICY_STATUS::cbSize"]
        [::std::mem::offset_of!(_EV_EXTRA_CERT_CHAIN_POLICY_STATUS, cbSize) - 0usize];
    ["Offset of field: _EV_EXTRA_CERT_CHAIN_POLICY_STATUS::dwQualifiers"]
        [::std::mem::offset_of!(_EV_EXTRA_CERT_CHAIN_POLICY_STATUS, dwQualifiers) - 4usize];
    ["Offset of field: _EV_EXTRA_CERT_CHAIN_POLICY_STATUS::dwIssuanceUsageIndex"]
        [::std::mem::offset_of!(_EV_EXTRA_CERT_CHAIN_POLICY_STATUS, dwIssuanceUsageIndex) - 8usize];
};
pub type EV_EXTRA_CERT_CHAIN_POLICY_STATUS = _EV_EXTRA_CERT_CHAIN_POLICY_STATUS;
pub type PEV_EXTRA_CERT_CHAIN_POLICY_STATUS = *mut _EV_EXTRA_CERT_CHAIN_POLICY_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS {
    pub cbSize: DWORD,
    pub dwErrorLevel: DWORD,
    pub dwErrorCategory: DWORD,
    pub dwReserved: DWORD,
    pub wszErrorText: [WCHAR; 256usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::size_of::<_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 528usize];
    ["Alignment of _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::align_of::<_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 4usize];
    ["Offset of field: _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS::cbSize"]
        [::std::mem::offset_of!(_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS, cbSize) - 0usize];
    ["Offset of field: _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS::dwErrorLevel"]
        [::std::mem::offset_of!(_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS, dwErrorLevel) - 4usize];
    ["Offset of field: _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS::dwErrorCategory"]
        [::std::mem::offset_of!(_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS, dwErrorCategory) - 8usize];
    ["Offset of field: _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS::dwReserved"]
        [::std::mem::offset_of!(_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS, dwReserved) - 12usize];
    ["Offset of field: _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS::wszErrorText"]
        [::std::mem::offset_of!(_SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS, wszErrorText) - 16usize];
};
pub type SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS = _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS;
pub type PSSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS = *mut _SSL_F12_EXTRA_CERT_CHAIN_POLICY_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwReserved: DWORD,
    pub pwszServerName: LPWSTR,
    pub rgpszHpkpValue: [LPSTR; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::size_of::<_SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA>() - 32usize];
    ["Alignment of _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA>() - 8usize];
    ["Offset of field: _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA::dwReserved"][::std::mem::offset_of!(
        _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA,
        dwReserved
    ) - 4usize];
    ["Offset of field: _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA::pwszServerName"][::std::mem::offset_of!(
        _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA,
        pwszServerName
    ) - 8usize];
    ["Offset of field: _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA::rgpszHpkpValue"][::std::mem::offset_of!(
        _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA,
        rgpszHpkpValue
    ) - 16usize];
};
pub type SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA =
    _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA;
pub type PSSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA =
    *mut _SSL_HPKP_HEADER_EXTRA_CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA {
    pub cbSize: DWORD,
    pub dwReserved: DWORD,
    pub pwszServerName: PCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::size_of::<_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA>() - 16usize];
    ["Alignment of _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA"]
        [::std::mem::align_of::<_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA>() - 8usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA::cbSize"]
        [::std::mem::offset_of!(_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA, cbSize) - 0usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA::dwReserved"]
        [::std::mem::offset_of!(_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA, dwReserved) - 4usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA::pwszServerName"][::std::mem::offset_of!(
        _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA,
        pwszServerName
    ) - 8usize];
};
pub type SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA = _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA;
pub type PSSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA = *mut _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS {
    pub cbSize: DWORD,
    pub lError: LONG,
    pub wszErrorText: [WCHAR; 512usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::size_of::<_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 1032usize];
    ["Alignment of _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS"]
        [::std::mem::align_of::<_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS>() - 4usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS::cbSize"]
        [::std::mem::offset_of!(_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS, cbSize) - 0usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS::lError"]
        [::std::mem::offset_of!(_SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS, lError) - 4usize];
    ["Offset of field: _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS::wszErrorText"][::std::mem::offset_of!(
        _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS,
        wszErrorText
    ) - 8usize];
};
pub type SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS = _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS;
pub type PSSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS =
    *mut _SSL_KEY_PIN_EXTRA_CERT_CHAIN_POLICY_STATUS;
unsafe extern "C" {
    pub fn CryptStringToBinaryA(
        pszString: LPCSTR,
        cchString: DWORD,
        dwFlags: DWORD,
        pbBinary: *mut BYTE,
        pcbBinary: *mut DWORD,
        pdwSkip: *mut DWORD,
        pdwFlags: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptStringToBinaryW(
        pszString: LPCWSTR,
        cchString: DWORD,
        dwFlags: DWORD,
        pbBinary: *mut BYTE,
        pcbBinary: *mut DWORD,
        pdwSkip: *mut DWORD,
        pdwFlags: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptBinaryToStringA(
        pbBinary: *const BYTE,
        cbBinary: DWORD,
        dwFlags: DWORD,
        pszString: LPSTR,
        pcchString: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptBinaryToStringW(
        pbBinary: *const BYTE,
        cbBinary: DWORD,
        dwFlags: DWORD,
        pszString: LPWSTR,
        pcchString: *mut DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_PKCS12_PBE_PARAMS {
    pub iIterations: ::std::os::raw::c_int,
    pub cbSalt: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_PKCS12_PBE_PARAMS"]
        [::std::mem::size_of::<_CRYPT_PKCS12_PBE_PARAMS>() - 8usize];
    ["Alignment of _CRYPT_PKCS12_PBE_PARAMS"]
        [::std::mem::align_of::<_CRYPT_PKCS12_PBE_PARAMS>() - 4usize];
    ["Offset of field: _CRYPT_PKCS12_PBE_PARAMS::iIterations"]
        [::std::mem::offset_of!(_CRYPT_PKCS12_PBE_PARAMS, iIterations) - 0usize];
    ["Offset of field: _CRYPT_PKCS12_PBE_PARAMS::cbSalt"]
        [::std::mem::offset_of!(_CRYPT_PKCS12_PBE_PARAMS, cbSalt) - 4usize];
};
pub type CRYPT_PKCS12_PBE_PARAMS = _CRYPT_PKCS12_PBE_PARAMS;
unsafe extern "C" {
    pub fn PFXImportCertStore(
        pPFX: *mut CRYPT_DATA_BLOB,
        szPassword: LPCWSTR,
        dwFlags: DWORD,
    ) -> HCERTSTORE;
}
unsafe extern "C" {
    pub fn PFXIsPFXBlob(pPFX: *mut CRYPT_DATA_BLOB) -> BOOL;
}
unsafe extern "C" {
    pub fn PFXVerifyPassword(
        pPFX: *mut CRYPT_DATA_BLOB,
        szPassword: LPCWSTR,
        dwFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn PFXExportCertStoreEx(
        hStore: HCERTSTORE,
        pPFX: *mut CRYPT_DATA_BLOB,
        szPassword: LPCWSTR,
        pvPara: *mut ::std::os::raw::c_void,
        dwFlags: DWORD,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PKCS12_PBES2_EXPORT_PARAMS {
    pub dwSize: DWORD,
    pub hNcryptDescriptor: PVOID,
    pub pwszPbes2Alg: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PKCS12_PBES2_EXPORT_PARAMS"]
        [::std::mem::size_of::<_PKCS12_PBES2_EXPORT_PARAMS>() - 24usize];
    ["Alignment of _PKCS12_PBES2_EXPORT_PARAMS"]
        [::std::mem::align_of::<_PKCS12_PBES2_EXPORT_PARAMS>() - 8usize];
    ["Offset of field: _PKCS12_PBES2_EXPORT_PARAMS::dwSize"]
        [::std::mem::offset_of!(_PKCS12_PBES2_EXPORT_PARAMS, dwSize) - 0usize];
    ["Offset of field: _PKCS12_PBES2_EXPORT_PARAMS::hNcryptDescriptor"]
        [::std::mem::offset_of!(_PKCS12_PBES2_EXPORT_PARAMS, hNcryptDescriptor) - 8usize];
    ["Offset of field: _PKCS12_PBES2_EXPORT_PARAMS::pwszPbes2Alg"]
        [::std::mem::offset_of!(_PKCS12_PBES2_EXPORT_PARAMS, pwszPbes2Alg) - 16usize];
};
pub type PKCS12_PBES2_EXPORT_PARAMS = _PKCS12_PBES2_EXPORT_PARAMS;
pub type PPKCS12_PBES2_EXPORT_PARAMS = *mut _PKCS12_PBES2_EXPORT_PARAMS;
unsafe extern "C" {
    pub fn PFXExportCertStore(
        hStore: HCERTSTORE,
        pPFX: *mut CRYPT_DATA_BLOB,
        szPassword: LPCWSTR,
        dwFlags: DWORD,
    ) -> BOOL;
}
pub type HCERT_SERVER_OCSP_RESPONSE = *mut ::std::os::raw::c_void;
pub type CERT_SERVER_OCSP_RESPONSE_CONTEXT = _CERT_SERVER_OCSP_RESPONSE_CONTEXT;
pub type PCERT_SERVER_OCSP_RESPONSE_CONTEXT = *mut _CERT_SERVER_OCSP_RESPONSE_CONTEXT;
pub type PCCERT_SERVER_OCSP_RESPONSE_CONTEXT = *const CERT_SERVER_OCSP_RESPONSE_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SERVER_OCSP_RESPONSE_CONTEXT {
    pub cbSize: DWORD,
    pub pbEncodedOcspResponse: *mut BYTE,
    pub cbEncodedOcspResponse: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SERVER_OCSP_RESPONSE_CONTEXT"]
        [::std::mem::size_of::<_CERT_SERVER_OCSP_RESPONSE_CONTEXT>() - 24usize];
    ["Alignment of _CERT_SERVER_OCSP_RESPONSE_CONTEXT"]
        [::std::mem::align_of::<_CERT_SERVER_OCSP_RESPONSE_CONTEXT>() - 8usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_CONTEXT::cbSize"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_CONTEXT, cbSize) - 0usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_CONTEXT::pbEncodedOcspResponse"][::std::mem::offset_of!(
        _CERT_SERVER_OCSP_RESPONSE_CONTEXT,
        pbEncodedOcspResponse
    ) - 8usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_CONTEXT::cbEncodedOcspResponse"][::std::mem::offset_of!(
        _CERT_SERVER_OCSP_RESPONSE_CONTEXT,
        cbEncodedOcspResponse
    ) - 16usize];
};
pub type PFN_CERT_SERVER_OCSP_RESPONSE_UPDATE_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        pChainContext: PCCERT_CHAIN_CONTEXT,
        pServerOcspResponseContext: PCCERT_SERVER_OCSP_RESPONSE_CONTEXT,
        pNewCrlContext: PCCRL_CONTEXT,
        pPrevCrlContext: PCCRL_CONTEXT,
        pvArg: PVOID,
        dwWriteOcspFileError: DWORD,
    ),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA {
    pub cbSize: DWORD,
    pub dwFlags: DWORD,
    pub pcbUsedSize: *mut DWORD,
    pub pwszOcspDirectory: PWSTR,
    pub pfnUpdateCallback: PFN_CERT_SERVER_OCSP_RESPONSE_UPDATE_CALLBACK,
    pub pvUpdateCallbackArg: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA"]
        [::std::mem::size_of::<_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA>() - 40usize];
    ["Alignment of _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA"]
        [::std::mem::align_of::<_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA>() - 8usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::cbSize"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA, cbSize) - 0usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::dwFlags"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA, dwFlags) - 4usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::pcbUsedSize"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA, pcbUsedSize) - 8usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::pwszOcspDirectory"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA, pwszOcspDirectory) - 16usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::pfnUpdateCallback"]
        [::std::mem::offset_of!(_CERT_SERVER_OCSP_RESPONSE_OPEN_PARA, pfnUpdateCallback) - 24usize];
    ["Offset of field: _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA::pvUpdateCallbackArg"][::std::mem::offset_of!(
        _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA,
        pvUpdateCallbackArg
    ) - 32usize];
};
pub type CERT_SERVER_OCSP_RESPONSE_OPEN_PARA = _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA;
pub type PCERT_SERVER_OCSP_RESPONSE_OPEN_PARA = *mut _CERT_SERVER_OCSP_RESPONSE_OPEN_PARA;
unsafe extern "C" {
    pub fn CertOpenServerOcspResponse(
        pChainContext: PCCERT_CHAIN_CONTEXT,
        dwFlags: DWORD,
        pOpenPara: PCERT_SERVER_OCSP_RESPONSE_OPEN_PARA,
    ) -> HCERT_SERVER_OCSP_RESPONSE;
}
unsafe extern "C" {
    pub fn CertAddRefServerOcspResponse(hServerOcspResponse: HCERT_SERVER_OCSP_RESPONSE);
}
unsafe extern "C" {
    pub fn CertCloseServerOcspResponse(
        hServerOcspResponse: HCERT_SERVER_OCSP_RESPONSE,
        dwFlags: DWORD,
    );
}
unsafe extern "C" {
    pub fn CertGetServerOcspResponseContext(
        hServerOcspResponse: HCERT_SERVER_OCSP_RESPONSE,
        dwFlags: DWORD,
        pvReserved: LPVOID,
    ) -> PCCERT_SERVER_OCSP_RESPONSE_CONTEXT;
}
unsafe extern "C" {
    pub fn CertAddRefServerOcspResponseContext(
        pServerOcspResponseContext: PCCERT_SERVER_OCSP_RESPONSE_CONTEXT,
    );
}
unsafe extern "C" {
    pub fn CertFreeServerOcspResponseContext(
        pServerOcspResponseContext: PCCERT_SERVER_OCSP_RESPONSE_CONTEXT,
    );
}
unsafe extern "C" {
    pub fn CertRetrieveLogoOrBiometricInfo(
        pCertContext: PCCERT_CONTEXT,
        lpszLogoOrBiometricType: LPCSTR,
        dwRetrievalFlags: DWORD,
        dwTimeout: DWORD,
        dwFlags: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
        ppbData: *mut *mut BYTE,
        pcbData: *mut DWORD,
        ppwszMimeType: *mut LPWSTR,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SELECT_CHAIN_PARA {
    pub hChainEngine: HCERTCHAINENGINE,
    pub pTime: PFILETIME,
    pub hAdditionalStore: HCERTSTORE,
    pub pChainPara: PCERT_CHAIN_PARA,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SELECT_CHAIN_PARA"][::std::mem::size_of::<_CERT_SELECT_CHAIN_PARA>() - 40usize];
    ["Alignment of _CERT_SELECT_CHAIN_PARA"]
        [::std::mem::align_of::<_CERT_SELECT_CHAIN_PARA>() - 8usize];
    ["Offset of field: _CERT_SELECT_CHAIN_PARA::hChainEngine"]
        [::std::mem::offset_of!(_CERT_SELECT_CHAIN_PARA, hChainEngine) - 0usize];
    ["Offset of field: _CERT_SELECT_CHAIN_PARA::pTime"]
        [::std::mem::offset_of!(_CERT_SELECT_CHAIN_PARA, pTime) - 8usize];
    ["Offset of field: _CERT_SELECT_CHAIN_PARA::hAdditionalStore"]
        [::std::mem::offset_of!(_CERT_SELECT_CHAIN_PARA, hAdditionalStore) - 16usize];
    ["Offset of field: _CERT_SELECT_CHAIN_PARA::pChainPara"]
        [::std::mem::offset_of!(_CERT_SELECT_CHAIN_PARA, pChainPara) - 24usize];
    ["Offset of field: _CERT_SELECT_CHAIN_PARA::dwFlags"]
        [::std::mem::offset_of!(_CERT_SELECT_CHAIN_PARA, dwFlags) - 32usize];
};
pub type CERT_SELECT_CHAIN_PARA = _CERT_SELECT_CHAIN_PARA;
pub type PCERT_SELECT_CHAIN_PARA = *mut _CERT_SELECT_CHAIN_PARA;
pub type PCCERT_SELECT_CHAIN_PARA = *const CERT_SELECT_CHAIN_PARA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERT_SELECT_CRITERIA {
    pub dwType: DWORD,
    pub cPara: DWORD,
    pub ppPara: *mut *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERT_SELECT_CRITERIA"][::std::mem::size_of::<_CERT_SELECT_CRITERIA>() - 16usize];
    ["Alignment of _CERT_SELECT_CRITERIA"]
        [::std::mem::align_of::<_CERT_SELECT_CRITERIA>() - 8usize];
    ["Offset of field: _CERT_SELECT_CRITERIA::dwType"]
        [::std::mem::offset_of!(_CERT_SELECT_CRITERIA, dwType) - 0usize];
    ["Offset of field: _CERT_SELECT_CRITERIA::cPara"]
        [::std::mem::offset_of!(_CERT_SELECT_CRITERIA, cPara) - 4usize];
    ["Offset of field: _CERT_SELECT_CRITERIA::ppPara"]
        [::std::mem::offset_of!(_CERT_SELECT_CRITERIA, ppPara) - 8usize];
};
pub type CERT_SELECT_CRITERIA = _CERT_SELECT_CRITERIA;
pub type PCERT_SELECT_CRITERIA = *mut _CERT_SELECT_CRITERIA;
pub type PCCERT_SELECT_CRITERIA = *const CERT_SELECT_CRITERIA;
unsafe extern "C" {
    pub fn CertSelectCertificateChains(
        pSelectionContext: LPCGUID,
        dwFlags: DWORD,
        pChainParameters: PCCERT_SELECT_CHAIN_PARA,
        cCriteria: DWORD,
        rgpCriteria: PCCERT_SELECT_CRITERIA,
        hStore: HCERTSTORE,
        pcSelection: PDWORD,
        pprgpSelection: *mut *mut PCCERT_CHAIN_CONTEXT,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CertFreeCertificateChainList(prgpSelection: *mut PCCERT_CHAIN_CONTEXT);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_REQUEST {
    pub dwVersion: DWORD,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub HashedMessage: CRYPT_DER_BLOB,
    pub pszTSAPolicyId: LPSTR,
    pub Nonce: CRYPT_INTEGER_BLOB,
    pub fCertReq: BOOL,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_REQUEST"]
        [::std::mem::size_of::<_CRYPT_TIMESTAMP_REQUEST>() - 88usize];
    ["Alignment of _CRYPT_TIMESTAMP_REQUEST"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_REQUEST>() - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::dwVersion"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, dwVersion) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, HashAlgorithm) - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::HashedMessage"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, HashedMessage) - 32usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::pszTSAPolicyId"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, pszTSAPolicyId) - 48usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::Nonce"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, Nonce) - 56usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::fCertReq"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, fCertReq) - 72usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::cExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, cExtension) - 76usize];
    ["Offset of field: _CRYPT_TIMESTAMP_REQUEST::rgExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_REQUEST, rgExtension) - 80usize];
};
pub type CRYPT_TIMESTAMP_REQUEST = _CRYPT_TIMESTAMP_REQUEST;
pub type PCRYPT_TIMESTAMP_REQUEST = *mut _CRYPT_TIMESTAMP_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_RESPONSE {
    pub dwStatus: DWORD,
    pub cFreeText: DWORD,
    pub rgFreeText: *mut LPWSTR,
    pub FailureInfo: CRYPT_BIT_BLOB,
    pub ContentInfo: CRYPT_DER_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_RESPONSE"]
        [::std::mem::size_of::<_CRYPT_TIMESTAMP_RESPONSE>() - 56usize];
    ["Alignment of _CRYPT_TIMESTAMP_RESPONSE"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_RESPONSE>() - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_RESPONSE::dwStatus"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_RESPONSE, dwStatus) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_RESPONSE::cFreeText"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_RESPONSE, cFreeText) - 4usize];
    ["Offset of field: _CRYPT_TIMESTAMP_RESPONSE::rgFreeText"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_RESPONSE, rgFreeText) - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_RESPONSE::FailureInfo"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_RESPONSE, FailureInfo) - 16usize];
    ["Offset of field: _CRYPT_TIMESTAMP_RESPONSE::ContentInfo"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_RESPONSE, ContentInfo) - 40usize];
};
pub type CRYPT_TIMESTAMP_RESPONSE = _CRYPT_TIMESTAMP_RESPONSE;
pub type PCRYPT_TIMESTAMP_RESPONSE = *mut _CRYPT_TIMESTAMP_RESPONSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_ACCURACY {
    pub dwSeconds: DWORD,
    pub dwMillis: DWORD,
    pub dwMicros: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_ACCURACY"]
        [::std::mem::size_of::<_CRYPT_TIMESTAMP_ACCURACY>() - 12usize];
    ["Alignment of _CRYPT_TIMESTAMP_ACCURACY"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_ACCURACY>() - 4usize];
    ["Offset of field: _CRYPT_TIMESTAMP_ACCURACY::dwSeconds"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_ACCURACY, dwSeconds) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_ACCURACY::dwMillis"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_ACCURACY, dwMillis) - 4usize];
    ["Offset of field: _CRYPT_TIMESTAMP_ACCURACY::dwMicros"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_ACCURACY, dwMicros) - 8usize];
};
pub type CRYPT_TIMESTAMP_ACCURACY = _CRYPT_TIMESTAMP_ACCURACY;
pub type PCRYPT_TIMESTAMP_ACCURACY = *mut _CRYPT_TIMESTAMP_ACCURACY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_INFO {
    pub dwVersion: DWORD,
    pub pszTSAPolicyId: LPSTR,
    pub HashAlgorithm: CRYPT_ALGORITHM_IDENTIFIER,
    pub HashedMessage: CRYPT_DER_BLOB,
    pub SerialNumber: CRYPT_INTEGER_BLOB,
    pub ftTime: FILETIME,
    pub pvAccuracy: PCRYPT_TIMESTAMP_ACCURACY,
    pub fOrdering: BOOL,
    pub Nonce: CRYPT_DER_BLOB,
    pub Tsa: CRYPT_DER_BLOB,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_INFO"][::std::mem::size_of::<_CRYPT_TIMESTAMP_INFO>() - 144usize];
    ["Alignment of _CRYPT_TIMESTAMP_INFO"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_INFO>() - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::dwVersion"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, dwVersion) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::pszTSAPolicyId"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, pszTSAPolicyId) - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::HashAlgorithm"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, HashAlgorithm) - 16usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::HashedMessage"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, HashedMessage) - 40usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::SerialNumber"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, SerialNumber) - 56usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::ftTime"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, ftTime) - 72usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::pvAccuracy"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, pvAccuracy) - 80usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::fOrdering"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, fOrdering) - 88usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::Nonce"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, Nonce) - 96usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::Tsa"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, Tsa) - 112usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::cExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, cExtension) - 128usize];
    ["Offset of field: _CRYPT_TIMESTAMP_INFO::rgExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_INFO, rgExtension) - 136usize];
};
pub type CRYPT_TIMESTAMP_INFO = _CRYPT_TIMESTAMP_INFO;
pub type PCRYPT_TIMESTAMP_INFO = *mut _CRYPT_TIMESTAMP_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_CONTEXT {
    pub cbEncoded: DWORD,
    pub pbEncoded: *mut BYTE,
    pub pTimeStamp: PCRYPT_TIMESTAMP_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_CONTEXT"]
        [::std::mem::size_of::<_CRYPT_TIMESTAMP_CONTEXT>() - 24usize];
    ["Alignment of _CRYPT_TIMESTAMP_CONTEXT"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_CONTEXT>() - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_CONTEXT::cbEncoded"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_CONTEXT, cbEncoded) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_CONTEXT::pbEncoded"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_CONTEXT, pbEncoded) - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_CONTEXT::pTimeStamp"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_CONTEXT, pTimeStamp) - 16usize];
};
pub type CRYPT_TIMESTAMP_CONTEXT = _CRYPT_TIMESTAMP_CONTEXT;
pub type PCRYPT_TIMESTAMP_CONTEXT = *mut _CRYPT_TIMESTAMP_CONTEXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_TIMESTAMP_PARA {
    pub pszTSAPolicyId: LPCSTR,
    pub fRequestCerts: BOOL,
    pub Nonce: CRYPT_INTEGER_BLOB,
    pub cExtension: DWORD,
    pub rgExtension: PCERT_EXTENSION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_TIMESTAMP_PARA"][::std::mem::size_of::<_CRYPT_TIMESTAMP_PARA>() - 48usize];
    ["Alignment of _CRYPT_TIMESTAMP_PARA"]
        [::std::mem::align_of::<_CRYPT_TIMESTAMP_PARA>() - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_PARA::pszTSAPolicyId"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_PARA, pszTSAPolicyId) - 0usize];
    ["Offset of field: _CRYPT_TIMESTAMP_PARA::fRequestCerts"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_PARA, fRequestCerts) - 8usize];
    ["Offset of field: _CRYPT_TIMESTAMP_PARA::Nonce"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_PARA, Nonce) - 16usize];
    ["Offset of field: _CRYPT_TIMESTAMP_PARA::cExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_PARA, cExtension) - 32usize];
    ["Offset of field: _CRYPT_TIMESTAMP_PARA::rgExtension"]
        [::std::mem::offset_of!(_CRYPT_TIMESTAMP_PARA, rgExtension) - 40usize];
};
pub type CRYPT_TIMESTAMP_PARA = _CRYPT_TIMESTAMP_PARA;
pub type PCRYPT_TIMESTAMP_PARA = *mut _CRYPT_TIMESTAMP_PARA;
unsafe extern "C" {
    pub fn CryptRetrieveTimeStamp(
        wszUrl: LPCWSTR,
        dwRetrievalFlags: DWORD,
        dwTimeout: DWORD,
        pszHashId: LPCSTR,
        pPara: *const CRYPT_TIMESTAMP_PARA,
        pbData: *const BYTE,
        cbData: DWORD,
        ppTsContext: *mut PCRYPT_TIMESTAMP_CONTEXT,
        ppTsSigner: *mut PCCERT_CONTEXT,
        phStore: *mut HCERTSTORE,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptVerifyTimeStampSignature(
        pbTSContentInfo: *const BYTE,
        cbTSContentInfo: DWORD,
        pbData: *const BYTE,
        cbData: DWORD,
        hAdditionalStore: HCERTSTORE,
        ppTsContext: *mut PCRYPT_TIMESTAMP_CONTEXT,
        ppTsSigner: *mut PCCERT_CONTEXT,
        phStore: *mut HCERTSTORE,
    ) -> BOOL;
}
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FLUSH = ::std::option::Option<
    unsafe extern "C" fn(
        pContext: LPVOID,
        rgIdentifierOrNameList: *mut PCERT_NAME_BLOB,
        dwIdentifierOrNameListCount: DWORD,
    ) -> BOOL,
>;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_GET = ::std::option::Option<
    unsafe extern "C" fn(
        pPluginContext: LPVOID,
        pIdentifier: PCRYPT_DATA_BLOB,
        dwNameType: DWORD,
        pNameBlob: PCERT_NAME_BLOB,
        ppbContent: *mut PBYTE,
        pcbContent: *mut DWORD,
        ppwszPassword: *mut PCWSTR,
        ppIdentifier: *mut PCRYPT_DATA_BLOB,
    ) -> BOOL,
>;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_RELEASE =
    ::std::option::Option<unsafe extern "C" fn(dwReason: DWORD, pPluginContext: LPVOID)>;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE_PASSWORD =
    ::std::option::Option<unsafe extern "C" fn(pPluginContext: LPVOID, pwszPassword: PCWSTR)>;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE =
    ::std::option::Option<unsafe extern "C" fn(pPluginContext: LPVOID, pbData: PBYTE)>;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE_IDENTIFIER = ::std::option::Option<
    unsafe extern "C" fn(pPluginContext: LPVOID, pIdentifier: PCRYPT_DATA_BLOB),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE {
    pub cbSize: DWORD,
    pub pfnGet: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_GET,
    pub pfnRelease: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_RELEASE,
    pub pfnFreePassword: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE_PASSWORD,
    pub pfnFree: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE,
    pub pfnFreeIdentifier: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FREE_IDENTIFIER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE"]
        [::std::mem::size_of::<_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE>() - 48usize];
    ["Alignment of _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE"]
        [::std::mem::align_of::<_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE>() - 8usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::cbSize"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, cbSize) - 0usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::pfnGet"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, pfnGet) - 8usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::pfnRelease"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, pfnRelease) - 16usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::pfnFreePassword"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, pfnFreePassword) - 24usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::pfnFree"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, pfnFree) - 32usize];
    ["Offset of field: _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE::pfnFreeIdentifier"]
        [::std::mem::offset_of!(_CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE, pfnFreeIdentifier) - 40usize];
};
pub type CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE = _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE;
pub type PCRYPT_OBJECT_LOCATOR_PROVIDER_TABLE = *mut _CRYPT_OBJECT_LOCATOR_PROVIDER_TABLE;
pub type PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_INITIALIZE = ::std::option::Option<
    unsafe extern "C" fn(
        pfnFlush: PFN_CRYPT_OBJECT_LOCATOR_PROVIDER_FLUSH,
        pContext: LPVOID,
        pdwExpectedObjectCount: *mut DWORD,
        ppFuncTable: *mut PCRYPT_OBJECT_LOCATOR_PROVIDER_TABLE,
        ppPluginContext: *mut *mut ::std::os::raw::c_void,
    ) -> BOOL,
>;
unsafe extern "C" {
    pub fn CertIsWeakHash(
        dwHashUseType: DWORD,
        pwszCNGHashAlgid: LPCWSTR,
        dwChainFlags: DWORD,
        pSignerChainContext: PCCERT_CHAIN_CONTEXT,
        pTimeStamp: LPFILETIME,
        pwszFileName: LPCWSTR,
    ) -> BOOL;
}
pub type PFN_CERT_IS_WEAK_HASH = ::std::option::Option<
    unsafe extern "C" fn(
        dwHashUseType: DWORD,
        pwszCNGHashAlgid: LPCWSTR,
        dwChainFlags: DWORD,
        pSignerChainContext: PCCERT_CHAIN_CONTEXT,
        pTimeStamp: LPFILETIME,
        pwszFileName: LPCWSTR,
    ) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRYPTPROTECT_PROMPTSTRUCT {
    pub cbSize: DWORD,
    pub dwPromptFlags: DWORD,
    pub hwndApp: HWND,
    pub szPrompt: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRYPTPROTECT_PROMPTSTRUCT"]
        [::std::mem::size_of::<_CRYPTPROTECT_PROMPTSTRUCT>() - 24usize];
    ["Alignment of _CRYPTPROTECT_PROMPTSTRUCT"]
        [::std::mem::align_of::<_CRYPTPROTECT_PROMPTSTRUCT>() - 8usize];
    ["Offset of field: _CRYPTPROTECT_PROMPTSTRUCT::cbSize"]
        [::std::mem::offset_of!(_CRYPTPROTECT_PROMPTSTRUCT, cbSize) - 0usize];
    ["Offset of field: _CRYPTPROTECT_PROMPTSTRUCT::dwPromptFlags"]
        [::std::mem::offset_of!(_CRYPTPROTECT_PROMPTSTRUCT, dwPromptFlags) - 4usize];
    ["Offset of field: _CRYPTPROTECT_PROMPTSTRUCT::hwndApp"]
        [::std::mem::offset_of!(_CRYPTPROTECT_PROMPTSTRUCT, hwndApp) - 8usize];
    ["Offset of field: _CRYPTPROTECT_PROMPTSTRUCT::szPrompt"]
        [::std::mem::offset_of!(_CRYPTPROTECT_PROMPTSTRUCT, szPrompt) - 16usize];
};
pub type CRYPTPROTECT_PROMPTSTRUCT = _CRYPTPROTECT_PROMPTSTRUCT;
pub type PCRYPTPROTECT_PROMPTSTRUCT = *mut _CRYPTPROTECT_PROMPTSTRUCT;
unsafe extern "C" {
    pub fn CryptProtectData(
        pDataIn: *mut DATA_BLOB,
        szDataDescr: LPCWSTR,
        pOptionalEntropy: *mut DATA_BLOB,
        pvReserved: PVOID,
        pPromptStruct: *mut CRYPTPROTECT_PROMPTSTRUCT,
        dwFlags: DWORD,
        pDataOut: *mut DATA_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnprotectData(
        pDataIn: *mut DATA_BLOB,
        ppszDataDescr: *mut LPWSTR,
        pOptionalEntropy: *mut DATA_BLOB,
        pvReserved: PVOID,
        pPromptStruct: *mut CRYPTPROTECT_PROMPTSTRUCT,
        dwFlags: DWORD,
        pDataOut: *mut DATA_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptProtectDataNoUI(
        pDataIn: *mut DATA_BLOB,
        szDataDescr: LPCWSTR,
        pOptionalEntropy: *mut DATA_BLOB,
        pvReserved: PVOID,
        pPromptStruct: *mut CRYPTPROTECT_PROMPTSTRUCT,
        dwFlags: DWORD,
        pbOptionalPassword: *const BYTE,
        cbOptionalPassword: DWORD,
        pDataOut: *mut DATA_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnprotectDataNoUI(
        pDataIn: *mut DATA_BLOB,
        ppszDataDescr: *mut LPWSTR,
        pOptionalEntropy: *mut DATA_BLOB,
        pvReserved: PVOID,
        pPromptStruct: *mut CRYPTPROTECT_PROMPTSTRUCT,
        dwFlags: DWORD,
        pbOptionalPassword: *const BYTE,
        cbOptionalPassword: DWORD,
        pDataOut: *mut DATA_BLOB,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUpdateProtectedState(
        pOldSid: PSID,
        pwszOldPassword: LPCWSTR,
        dwFlags: DWORD,
        pdwSuccessCount: *mut DWORD,
        pdwFailureCount: *mut DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptProtectMemory(pDataIn: LPVOID, cbDataIn: DWORD, dwFlags: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn CryptUnprotectMemory(pDataIn: LPVOID, cbDataIn: DWORD, dwFlags: DWORD) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CERTIFICATE_BLOB {
    pub dwCertEncodingType: DWORD,
    pub cbData: DWORD,
    pub pbData: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CERTIFICATE_BLOB"][::std::mem::size_of::<_CERTIFICATE_BLOB>() - 16usize];
    ["Alignment of _CERTIFICATE_BLOB"][::std::mem::align_of::<_CERTIFICATE_BLOB>() - 8usize];
    ["Offset of field: _CERTIFICATE_BLOB::dwCertEncodingType"]
        [::std::mem::offset_of!(_CERTIFICATE_BLOB, dwCertEncodingType) - 0usize];
    ["Offset of field: _CERTIFICATE_BLOB::cbData"]
        [::std::mem::offset_of!(_CERTIFICATE_BLOB, cbData) - 4usize];
    ["Offset of field: _CERTIFICATE_BLOB::pbData"]
        [::std::mem::offset_of!(_CERTIFICATE_BLOB, pbData) - 8usize];
};
pub type EFS_CERTIFICATE_BLOB = _CERTIFICATE_BLOB;
pub type PEFS_CERTIFICATE_BLOB = *mut _CERTIFICATE_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_HASH_BLOB {
    pub cbData: DWORD,
    pub pbData: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_HASH_BLOB"][::std::mem::size_of::<_EFS_HASH_BLOB>() - 16usize];
    ["Alignment of _EFS_HASH_BLOB"][::std::mem::align_of::<_EFS_HASH_BLOB>() - 8usize];
    ["Offset of field: _EFS_HASH_BLOB::cbData"]
        [::std::mem::offset_of!(_EFS_HASH_BLOB, cbData) - 0usize];
    ["Offset of field: _EFS_HASH_BLOB::pbData"]
        [::std::mem::offset_of!(_EFS_HASH_BLOB, pbData) - 8usize];
};
pub type EFS_HASH_BLOB = _EFS_HASH_BLOB;
pub type PEFS_HASH_BLOB = *mut _EFS_HASH_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_RPC_BLOB {
    pub cbData: DWORD,
    pub pbData: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_RPC_BLOB"][::std::mem::size_of::<_EFS_RPC_BLOB>() - 16usize];
    ["Alignment of _EFS_RPC_BLOB"][::std::mem::align_of::<_EFS_RPC_BLOB>() - 8usize];
    ["Offset of field: _EFS_RPC_BLOB::cbData"]
        [::std::mem::offset_of!(_EFS_RPC_BLOB, cbData) - 0usize];
    ["Offset of field: _EFS_RPC_BLOB::pbData"]
        [::std::mem::offset_of!(_EFS_RPC_BLOB, pbData) - 8usize];
};
pub type EFS_RPC_BLOB = _EFS_RPC_BLOB;
pub type PEFS_RPC_BLOB = *mut _EFS_RPC_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_PIN_BLOB {
    pub cbPadding: DWORD,
    pub cbData: DWORD,
    pub pbData: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_PIN_BLOB"][::std::mem::size_of::<_EFS_PIN_BLOB>() - 16usize];
    ["Alignment of _EFS_PIN_BLOB"][::std::mem::align_of::<_EFS_PIN_BLOB>() - 8usize];
    ["Offset of field: _EFS_PIN_BLOB::cbPadding"]
        [::std::mem::offset_of!(_EFS_PIN_BLOB, cbPadding) - 0usize];
    ["Offset of field: _EFS_PIN_BLOB::cbData"]
        [::std::mem::offset_of!(_EFS_PIN_BLOB, cbData) - 4usize];
    ["Offset of field: _EFS_PIN_BLOB::pbData"]
        [::std::mem::offset_of!(_EFS_PIN_BLOB, pbData) - 8usize];
};
pub type EFS_PIN_BLOB = _EFS_PIN_BLOB;
pub type PEFS_PIN_BLOB = *mut _EFS_PIN_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_KEY_INFO {
    pub dwVersion: DWORD,
    pub Entropy: ULONG,
    pub Algorithm: ALG_ID,
    pub KeyLength: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_KEY_INFO"][::std::mem::size_of::<_EFS_KEY_INFO>() - 16usize];
    ["Alignment of _EFS_KEY_INFO"][::std::mem::align_of::<_EFS_KEY_INFO>() - 4usize];
    ["Offset of field: _EFS_KEY_INFO::dwVersion"]
        [::std::mem::offset_of!(_EFS_KEY_INFO, dwVersion) - 0usize];
    ["Offset of field: _EFS_KEY_INFO::Entropy"]
        [::std::mem::offset_of!(_EFS_KEY_INFO, Entropy) - 4usize];
    ["Offset of field: _EFS_KEY_INFO::Algorithm"]
        [::std::mem::offset_of!(_EFS_KEY_INFO, Algorithm) - 8usize];
    ["Offset of field: _EFS_KEY_INFO::KeyLength"]
        [::std::mem::offset_of!(_EFS_KEY_INFO, KeyLength) - 12usize];
};
pub type EFS_KEY_INFO = _EFS_KEY_INFO;
pub type PEFS_KEY_INFO = *mut _EFS_KEY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_COMPATIBILITY_INFO {
    pub EfsVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_COMPATIBILITY_INFO"][::std::mem::size_of::<_EFS_COMPATIBILITY_INFO>() - 4usize];
    ["Alignment of _EFS_COMPATIBILITY_INFO"]
        [::std::mem::align_of::<_EFS_COMPATIBILITY_INFO>() - 4usize];
    ["Offset of field: _EFS_COMPATIBILITY_INFO::EfsVersion"]
        [::std::mem::offset_of!(_EFS_COMPATIBILITY_INFO, EfsVersion) - 0usize];
};
pub type EFS_COMPATIBILITY_INFO = _EFS_COMPATIBILITY_INFO;
pub type PEFS_COMPATIBILITY_INFO = *mut _EFS_COMPATIBILITY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_VERSION_INFO {
    pub EfsVersion: DWORD,
    pub SubVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_VERSION_INFO"][::std::mem::size_of::<_EFS_VERSION_INFO>() - 8usize];
    ["Alignment of _EFS_VERSION_INFO"][::std::mem::align_of::<_EFS_VERSION_INFO>() - 4usize];
    ["Offset of field: _EFS_VERSION_INFO::EfsVersion"]
        [::std::mem::offset_of!(_EFS_VERSION_INFO, EfsVersion) - 0usize];
    ["Offset of field: _EFS_VERSION_INFO::SubVersion"]
        [::std::mem::offset_of!(_EFS_VERSION_INFO, SubVersion) - 4usize];
};
pub type EFS_VERSION_INFO = _EFS_VERSION_INFO;
pub type PEFS_VERSION_INFO = *mut _EFS_VERSION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_DECRYPTION_STATUS_INFO {
    pub dwDecryptionError: DWORD,
    pub dwHashOffset: DWORD,
    pub cbHash: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_DECRYPTION_STATUS_INFO"]
        [::std::mem::size_of::<_EFS_DECRYPTION_STATUS_INFO>() - 12usize];
    ["Alignment of _EFS_DECRYPTION_STATUS_INFO"]
        [::std::mem::align_of::<_EFS_DECRYPTION_STATUS_INFO>() - 4usize];
    ["Offset of field: _EFS_DECRYPTION_STATUS_INFO::dwDecryptionError"]
        [::std::mem::offset_of!(_EFS_DECRYPTION_STATUS_INFO, dwDecryptionError) - 0usize];
    ["Offset of field: _EFS_DECRYPTION_STATUS_INFO::dwHashOffset"]
        [::std::mem::offset_of!(_EFS_DECRYPTION_STATUS_INFO, dwHashOffset) - 4usize];
    ["Offset of field: _EFS_DECRYPTION_STATUS_INFO::cbHash"]
        [::std::mem::offset_of!(_EFS_DECRYPTION_STATUS_INFO, cbHash) - 8usize];
};
pub type EFS_DECRYPTION_STATUS_INFO = _EFS_DECRYPTION_STATUS_INFO;
pub type PEFS_DECRYPTION_STATUS_INFO = *mut _EFS_DECRYPTION_STATUS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EFS_ENCRYPTION_STATUS_INFO {
    pub bHasCurrentKey: BOOL,
    pub dwEncryptionError: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EFS_ENCRYPTION_STATUS_INFO"]
        [::std::mem::size_of::<_EFS_ENCRYPTION_STATUS_INFO>() - 8usize];
    ["Alignment of _EFS_ENCRYPTION_STATUS_INFO"]
        [::std::mem::align_of::<_EFS_ENCRYPTION_STATUS_INFO>() - 4usize];
    ["Offset of field: _EFS_ENCRYPTION_STATUS_INFO::bHasCurrentKey"]
        [::std::mem::offset_of!(_EFS_ENCRYPTION_STATUS_INFO, bHasCurrentKey) - 0usize];
    ["Offset of field: _EFS_ENCRYPTION_STATUS_INFO::dwEncryptionError"]
        [::std::mem::offset_of!(_EFS_ENCRYPTION_STATUS_INFO, dwEncryptionError) - 4usize];
};
pub type EFS_ENCRYPTION_STATUS_INFO = _EFS_ENCRYPTION_STATUS_INFO;
pub type PEFS_ENCRYPTION_STATUS_INFO = *mut _EFS_ENCRYPTION_STATUS_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_CERTIFICATE {
    pub cbTotalLength: DWORD,
    pub pUserSid: *mut SID,
    pub pCertBlob: PEFS_CERTIFICATE_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_CERTIFICATE"][::std::mem::size_of::<_ENCRYPTION_CERTIFICATE>() - 24usize];
    ["Alignment of _ENCRYPTION_CERTIFICATE"]
        [::std::mem::align_of::<_ENCRYPTION_CERTIFICATE>() - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE::cbTotalLength"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE, cbTotalLength) - 0usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE::pUserSid"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE, pUserSid) - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE::pCertBlob"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE, pCertBlob) - 16usize];
};
pub type ENCRYPTION_CERTIFICATE = _ENCRYPTION_CERTIFICATE;
pub type PENCRYPTION_CERTIFICATE = *mut _ENCRYPTION_CERTIFICATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_CERTIFICATE_HASH {
    pub cbTotalLength: DWORD,
    pub pUserSid: *mut SID,
    pub pHash: PEFS_HASH_BLOB,
    pub lpDisplayInformation: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_CERTIFICATE_HASH"]
        [::std::mem::size_of::<_ENCRYPTION_CERTIFICATE_HASH>() - 32usize];
    ["Alignment of _ENCRYPTION_CERTIFICATE_HASH"]
        [::std::mem::align_of::<_ENCRYPTION_CERTIFICATE_HASH>() - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH::cbTotalLength"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH, cbTotalLength) - 0usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH::pUserSid"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH, pUserSid) - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH::pHash"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH, pHash) - 16usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH::lpDisplayInformation"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH, lpDisplayInformation) - 24usize];
};
pub type ENCRYPTION_CERTIFICATE_HASH = _ENCRYPTION_CERTIFICATE_HASH;
pub type PENCRYPTION_CERTIFICATE_HASH = *mut _ENCRYPTION_CERTIFICATE_HASH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_CERTIFICATE_HASH_LIST {
    pub nCert_Hash: DWORD,
    pub pUsers: *mut PENCRYPTION_CERTIFICATE_HASH,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_CERTIFICATE_HASH_LIST"]
        [::std::mem::size_of::<_ENCRYPTION_CERTIFICATE_HASH_LIST>() - 16usize];
    ["Alignment of _ENCRYPTION_CERTIFICATE_HASH_LIST"]
        [::std::mem::align_of::<_ENCRYPTION_CERTIFICATE_HASH_LIST>() - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH_LIST::nCert_Hash"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH_LIST, nCert_Hash) - 0usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_HASH_LIST::pUsers"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_HASH_LIST, pUsers) - 8usize];
};
pub type ENCRYPTION_CERTIFICATE_HASH_LIST = _ENCRYPTION_CERTIFICATE_HASH_LIST;
pub type PENCRYPTION_CERTIFICATE_HASH_LIST = *mut _ENCRYPTION_CERTIFICATE_HASH_LIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_CERTIFICATE_LIST {
    pub nUsers: DWORD,
    pub pUsers: *mut PENCRYPTION_CERTIFICATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_CERTIFICATE_LIST"]
        [::std::mem::size_of::<_ENCRYPTION_CERTIFICATE_LIST>() - 16usize];
    ["Alignment of _ENCRYPTION_CERTIFICATE_LIST"]
        [::std::mem::align_of::<_ENCRYPTION_CERTIFICATE_LIST>() - 8usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_LIST::nUsers"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_LIST, nUsers) - 0usize];
    ["Offset of field: _ENCRYPTION_CERTIFICATE_LIST::pUsers"]
        [::std::mem::offset_of!(_ENCRYPTION_CERTIFICATE_LIST, pUsers) - 8usize];
};
pub type ENCRYPTION_CERTIFICATE_LIST = _ENCRYPTION_CERTIFICATE_LIST;
pub type PENCRYPTION_CERTIFICATE_LIST = *mut _ENCRYPTION_CERTIFICATE_LIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTED_FILE_METADATA_SIGNATURE {
    pub dwEfsAccessType: DWORD,
    pub pCertificatesAdded: PENCRYPTION_CERTIFICATE_HASH_LIST,
    pub pEncryptionCertificate: PENCRYPTION_CERTIFICATE,
    pub pEfsStreamSignature: PEFS_RPC_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTED_FILE_METADATA_SIGNATURE"]
        [::std::mem::size_of::<_ENCRYPTED_FILE_METADATA_SIGNATURE>() - 32usize];
    ["Alignment of _ENCRYPTED_FILE_METADATA_SIGNATURE"]
        [::std::mem::align_of::<_ENCRYPTED_FILE_METADATA_SIGNATURE>() - 8usize];
    ["Offset of field: _ENCRYPTED_FILE_METADATA_SIGNATURE::dwEfsAccessType"]
        [::std::mem::offset_of!(_ENCRYPTED_FILE_METADATA_SIGNATURE, dwEfsAccessType) - 0usize];
    ["Offset of field: _ENCRYPTED_FILE_METADATA_SIGNATURE::pCertificatesAdded"]
        [::std::mem::offset_of!(_ENCRYPTED_FILE_METADATA_SIGNATURE, pCertificatesAdded) - 8usize];
    ["Offset of field: _ENCRYPTED_FILE_METADATA_SIGNATURE::pEncryptionCertificate"][::std::mem::offset_of!(
        _ENCRYPTED_FILE_METADATA_SIGNATURE,
        pEncryptionCertificate
    ) - 16usize];
    ["Offset of field: _ENCRYPTED_FILE_METADATA_SIGNATURE::pEfsStreamSignature"]
        [::std::mem::offset_of!(_ENCRYPTED_FILE_METADATA_SIGNATURE, pEfsStreamSignature) - 24usize];
};
pub type ENCRYPTED_FILE_METADATA_SIGNATURE = _ENCRYPTED_FILE_METADATA_SIGNATURE;
pub type PENCRYPTED_FILE_METADATA_SIGNATURE = *mut _ENCRYPTED_FILE_METADATA_SIGNATURE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_PROTECTOR {
    pub cbTotalLength: DWORD,
    pub pUserSid: *mut SID,
    pub lpProtectorDescriptor: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_PROTECTOR"][::std::mem::size_of::<_ENCRYPTION_PROTECTOR>() - 24usize];
    ["Alignment of _ENCRYPTION_PROTECTOR"]
        [::std::mem::align_of::<_ENCRYPTION_PROTECTOR>() - 8usize];
    ["Offset of field: _ENCRYPTION_PROTECTOR::cbTotalLength"]
        [::std::mem::offset_of!(_ENCRYPTION_PROTECTOR, cbTotalLength) - 0usize];
    ["Offset of field: _ENCRYPTION_PROTECTOR::pUserSid"]
        [::std::mem::offset_of!(_ENCRYPTION_PROTECTOR, pUserSid) - 8usize];
    ["Offset of field: _ENCRYPTION_PROTECTOR::lpProtectorDescriptor"]
        [::std::mem::offset_of!(_ENCRYPTION_PROTECTOR, lpProtectorDescriptor) - 16usize];
};
pub type ENCRYPTION_PROTECTOR = _ENCRYPTION_PROTECTOR;
pub type PENCRYPTION_PROTECTOR = *mut _ENCRYPTION_PROTECTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_PROTECTOR_LIST {
    pub nProtectors: DWORD,
    pub pProtectors: *mut PENCRYPTION_PROTECTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_PROTECTOR_LIST"]
        [::std::mem::size_of::<_ENCRYPTION_PROTECTOR_LIST>() - 16usize];
    ["Alignment of _ENCRYPTION_PROTECTOR_LIST"]
        [::std::mem::align_of::<_ENCRYPTION_PROTECTOR_LIST>() - 8usize];
    ["Offset of field: _ENCRYPTION_PROTECTOR_LIST::nProtectors"]
        [::std::mem::offset_of!(_ENCRYPTION_PROTECTOR_LIST, nProtectors) - 0usize];
    ["Offset of field: _ENCRYPTION_PROTECTOR_LIST::pProtectors"]
        [::std::mem::offset_of!(_ENCRYPTION_PROTECTOR_LIST, pProtectors) - 8usize];
};
pub type ENCRYPTION_PROTECTOR_LIST = _ENCRYPTION_PROTECTOR_LIST;
pub type PENCRYPTION_PROTECTOR_LIST = *mut _ENCRYPTION_PROTECTOR_LIST;
unsafe extern "C" {
    pub fn QueryUsersOnEncryptedFile(
        lpFileName: LPCWSTR,
        pUsers: *mut PENCRYPTION_CERTIFICATE_HASH_LIST,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn QueryRecoveryAgentsOnEncryptedFile(
        lpFileName: LPCWSTR,
        pRecoveryAgents: *mut PENCRYPTION_CERTIFICATE_HASH_LIST,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn RemoveUsersFromEncryptedFile(
        lpFileName: LPCWSTR,
        pHashes: PENCRYPTION_CERTIFICATE_HASH_LIST,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn AddUsersToEncryptedFile(
        lpFileName: LPCWSTR,
        pEncryptionCertificates: PENCRYPTION_CERTIFICATE_LIST,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetUserFileEncryptionKey(pEncryptionCertificate: PENCRYPTION_CERTIFICATE) -> DWORD;
}
unsafe extern "C" {
    pub fn SetUserFileEncryptionKeyEx(
        pEncryptionCertificate: PENCRYPTION_CERTIFICATE,
        dwCapabilities: DWORD,
        dwFlags: DWORD,
        pvReserved: LPVOID,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn FreeEncryptionCertificateHashList(pUsers: PENCRYPTION_CERTIFICATE_HASH_LIST);
}
unsafe extern "C" {
    pub fn EncryptionDisable(DirPath: LPCWSTR, Disable: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn DuplicateEncryptionInfoFile(
        SrcFileName: LPCWSTR,
        DstFileName: LPCWSTR,
        dwCreationDistribution: DWORD,
        dwAttributes: DWORD,
        lpSecurityAttributes: LPSECURITY_ATTRIBUTES,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetEncryptedFileMetadata(
        lpFileName: LPCWSTR,
        pcbMetadata: PDWORD,
        ppbMetadata: *mut PBYTE,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetEncryptedFileMetadata(
        lpFileName: LPCWSTR,
        pbOldMetadata: PBYTE,
        pbNewMetadata: PBYTE,
        pOwnerHash: PENCRYPTION_CERTIFICATE_HASH,
        dwOperation: DWORD,
        pCertificatesAdded: PENCRYPTION_CERTIFICATE_HASH_LIST,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn FreeEncryptedFileMetadata(pbMetadata: PBYTE);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RPC_IMPORT_CONTEXT_P {
    pub LookupContext: RPC_NS_HANDLE,
    pub ProposedHandle: RPC_BINDING_HANDLE,
    pub Bindings: *mut RPC_BINDING_VECTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RPC_IMPORT_CONTEXT_P"][::std::mem::size_of::<RPC_IMPORT_CONTEXT_P>() - 24usize];
    ["Alignment of RPC_IMPORT_CONTEXT_P"][::std::mem::align_of::<RPC_IMPORT_CONTEXT_P>() - 8usize];
    ["Offset of field: RPC_IMPORT_CONTEXT_P::LookupContext"]
        [::std::mem::offset_of!(RPC_IMPORT_CONTEXT_P, LookupContext) - 0usize];
    ["Offset of field: RPC_IMPORT_CONTEXT_P::ProposedHandle"]
        [::std::mem::offset_of!(RPC_IMPORT_CONTEXT_P, ProposedHandle) - 8usize];
    ["Offset of field: RPC_IMPORT_CONTEXT_P::Bindings"]
        [::std::mem::offset_of!(RPC_IMPORT_CONTEXT_P, Bindings) - 16usize];
};
pub type PRPC_IMPORT_CONTEXT_P = *mut RPC_IMPORT_CONTEXT_P;
unsafe extern "C" {
    pub fn I_RpcNsGetBuffer(Message: PRPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcNsSendReceive(Message: PRPC_MESSAGE, Handle: *mut RPC_BINDING_HANDLE)
        -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_RpcNsRaiseException(Message: PRPC_MESSAGE, Status: RPC_STATUS);
}
unsafe extern "C" {
    pub fn I_RpcReBindBuffer(Message: PRPC_MESSAGE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_NsServerBindSearch() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_NsClientBindSearch() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn I_NsClientBindDone();
}
pub type byte = ::std::os::raw::c_uchar;
pub type cs_byte = byte;
pub type boolean = ::std::os::raw::c_uchar;
unsafe extern "C" {
    pub fn MIDL_user_allocate(size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn MIDL_user_free(arg1: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn I_RpcDefaultAllocate(
        bh: handle_t,
        size: usize,
        RealAlloc: ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn I_RpcDefaultFree(
        bh: handle_t,
        arg1: *mut ::std::os::raw::c_void,
        RealFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    );
}
pub type NDR_CCONTEXT = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_SCONTEXT {
    pub pad: [*mut ::std::os::raw::c_void; 2usize],
    pub userContext: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_SCONTEXT"][::std::mem::size_of::<_NDR_SCONTEXT>() - 24usize];
    ["Alignment of _NDR_SCONTEXT"][::std::mem::align_of::<_NDR_SCONTEXT>() - 8usize];
    ["Offset of field: _NDR_SCONTEXT::pad"][::std::mem::offset_of!(_NDR_SCONTEXT, pad) - 0usize];
    ["Offset of field: _NDR_SCONTEXT::userContext"]
        [::std::mem::offset_of!(_NDR_SCONTEXT, userContext) - 16usize];
};
pub type NDR_SCONTEXT = *mut _NDR_SCONTEXT;
pub type NDR_RUNDOWN =
    ::std::option::Option<unsafe extern "C" fn(context: *mut ::std::os::raw::c_void)>;
pub type NDR_NOTIFY_ROUTINE = ::std::option::Option<unsafe extern "C" fn()>;
pub type NDR_NOTIFY2_ROUTINE = ::std::option::Option<unsafe extern "C" fn(flag: boolean)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCONTEXT_QUEUE {
    pub NumberOfObjects: ::std::os::raw::c_ulong,
    pub ArrayOfObjects: *mut NDR_SCONTEXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCONTEXT_QUEUE"][::std::mem::size_of::<_SCONTEXT_QUEUE>() - 16usize];
    ["Alignment of _SCONTEXT_QUEUE"][::std::mem::align_of::<_SCONTEXT_QUEUE>() - 8usize];
    ["Offset of field: _SCONTEXT_QUEUE::NumberOfObjects"]
        [::std::mem::offset_of!(_SCONTEXT_QUEUE, NumberOfObjects) - 0usize];
    ["Offset of field: _SCONTEXT_QUEUE::ArrayOfObjects"]
        [::std::mem::offset_of!(_SCONTEXT_QUEUE, ArrayOfObjects) - 8usize];
};
pub type SCONTEXT_QUEUE = _SCONTEXT_QUEUE;
pub type PSCONTEXT_QUEUE = *mut _SCONTEXT_QUEUE;
unsafe extern "C" {
    pub fn NDRCContextBinding(CContext: NDR_CCONTEXT) -> RPC_BINDING_HANDLE;
}
unsafe extern "C" {
    pub fn NDRCContextMarshall(CContext: NDR_CCONTEXT, pBuff: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn NDRCContextUnmarshall(
        pCContext: *mut NDR_CCONTEXT,
        hBinding: RPC_BINDING_HANDLE,
        pBuff: *mut ::std::os::raw::c_void,
        DataRepresentation: ::std::os::raw::c_ulong,
    );
}
unsafe extern "C" {
    pub fn NDRCContextUnmarshall2(
        pCContext: *mut NDR_CCONTEXT,
        hBinding: RPC_BINDING_HANDLE,
        pBuff: *mut ::std::os::raw::c_void,
        DataRepresentation: ::std::os::raw::c_ulong,
    );
}
unsafe extern "C" {
    pub fn NDRSContextMarshall(
        CContext: NDR_SCONTEXT,
        pBuff: *mut ::std::os::raw::c_void,
        userRunDownIn: NDR_RUNDOWN,
    );
}
unsafe extern "C" {
    pub fn NDRSContextUnmarshall(
        pBuff: *mut ::std::os::raw::c_void,
        DataRepresentation: ::std::os::raw::c_ulong,
    ) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn NDRSContextMarshallEx(
        BindingHandle: RPC_BINDING_HANDLE,
        CContext: NDR_SCONTEXT,
        pBuff: *mut ::std::os::raw::c_void,
        userRunDownIn: NDR_RUNDOWN,
    );
}
unsafe extern "C" {
    pub fn NDRSContextMarshall2(
        BindingHandle: RPC_BINDING_HANDLE,
        CContext: NDR_SCONTEXT,
        pBuff: *mut ::std::os::raw::c_void,
        userRunDownIn: NDR_RUNDOWN,
        CtxGuard: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_ulong,
    );
}
unsafe extern "C" {
    pub fn NDRSContextUnmarshallEx(
        BindingHandle: RPC_BINDING_HANDLE,
        pBuff: *mut ::std::os::raw::c_void,
        DataRepresentation: ::std::os::raw::c_ulong,
    ) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn NDRSContextUnmarshall2(
        BindingHandle: RPC_BINDING_HANDLE,
        pBuff: *mut ::std::os::raw::c_void,
        DataRepresentation: ::std::os::raw::c_ulong,
        CtxGuard: *mut ::std::os::raw::c_void,
        Flags: ::std::os::raw::c_ulong,
    ) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn RpcSsDestroyClientContext(ContextHandle: *mut *mut ::std::os::raw::c_void);
}
pub type error_status_t = ::std::os::raw::c_ulong;
pub type RPC_BUFPTR = *mut ::std::os::raw::c_uchar;
pub type RPC_LENGTH = ::std::os::raw::c_ulong;
pub type EXPR_EVAL = ::std::option::Option<unsafe extern "C" fn(arg1: *mut _MIDL_STUB_MESSAGE)>;
pub type PFORMAT_STRING = *const ::std::os::raw::c_uchar;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ARRAY_INFO {
    pub Dimension: ::std::os::raw::c_long,
    pub BufferConformanceMark: *mut ::std::os::raw::c_ulong,
    pub BufferVarianceMark: *mut ::std::os::raw::c_ulong,
    pub MaxCountArray: *mut ::std::os::raw::c_ulong,
    pub OffsetArray: *mut ::std::os::raw::c_ulong,
    pub ActualCountArray: *mut ::std::os::raw::c_ulong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ARRAY_INFO"][::std::mem::size_of::<ARRAY_INFO>() - 48usize];
    ["Alignment of ARRAY_INFO"][::std::mem::align_of::<ARRAY_INFO>() - 8usize];
    ["Offset of field: ARRAY_INFO::Dimension"]
        [::std::mem::offset_of!(ARRAY_INFO, Dimension) - 0usize];
    ["Offset of field: ARRAY_INFO::BufferConformanceMark"]
        [::std::mem::offset_of!(ARRAY_INFO, BufferConformanceMark) - 8usize];
    ["Offset of field: ARRAY_INFO::BufferVarianceMark"]
        [::std::mem::offset_of!(ARRAY_INFO, BufferVarianceMark) - 16usize];
    ["Offset of field: ARRAY_INFO::MaxCountArray"]
        [::std::mem::offset_of!(ARRAY_INFO, MaxCountArray) - 24usize];
    ["Offset of field: ARRAY_INFO::OffsetArray"]
        [::std::mem::offset_of!(ARRAY_INFO, OffsetArray) - 32usize];
    ["Offset of field: ARRAY_INFO::ActualCountArray"]
        [::std::mem::offset_of!(ARRAY_INFO, ActualCountArray) - 40usize];
};
pub type PARRAY_INFO = *mut ARRAY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_ASYNC_MESSAGE {
    _unused: [u8; 0],
}
pub type PNDR_ASYNC_MESSAGE = *mut _NDR_ASYNC_MESSAGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_CORRELATION_INFO {
    _unused: [u8; 0],
}
pub type PNDR_CORRELATION_INFO = *mut _NDR_CORRELATION_INFO;
pub type MIDL_SYNTAX_INFO = _MIDL_SYNTAX_INFO;
pub type PMIDL_SYNTAX_INFO = *mut _MIDL_SYNTAX_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NDR_ALLOC_ALL_NODES_CONTEXT {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NDR_POINTER_QUEUE_STATE {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_PROC_CONTEXT {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_STUB_MESSAGE {
    pub RpcMsg: PRPC_MESSAGE,
    pub Buffer: *mut ::std::os::raw::c_uchar,
    pub BufferStart: *mut ::std::os::raw::c_uchar,
    pub BufferEnd: *mut ::std::os::raw::c_uchar,
    pub BufferMark: *mut ::std::os::raw::c_uchar,
    pub BufferLength: ::std::os::raw::c_ulong,
    pub MemorySize: ::std::os::raw::c_ulong,
    pub Memory: *mut ::std::os::raw::c_uchar,
    pub IsClient: ::std::os::raw::c_uchar,
    pub Pad: ::std::os::raw::c_uchar,
    pub uFlags2: ::std::os::raw::c_ushort,
    pub ReuseBuffer: ::std::os::raw::c_int,
    pub pAllocAllNodesContext: *mut NDR_ALLOC_ALL_NODES_CONTEXT,
    pub pPointerQueueState: *mut NDR_POINTER_QUEUE_STATE,
    pub IgnoreEmbeddedPointers: ::std::os::raw::c_int,
    pub PointerBufferMark: *mut ::std::os::raw::c_uchar,
    pub CorrDespIncrement: ::std::os::raw::c_uchar,
    pub uFlags: ::std::os::raw::c_uchar,
    pub UniquePtrCount: ::std::os::raw::c_ushort,
    pub MaxCount: ULONG_PTR,
    pub Offset: ::std::os::raw::c_ulong,
    pub ActualCount: ::std::os::raw::c_ulong,
    pub pfnAllocate:
        ::std::option::Option<unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void>,
    pub pfnFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    pub StackTop: *mut ::std::os::raw::c_uchar,
    pub pPresentedType: *mut ::std::os::raw::c_uchar,
    pub pTransmitType: *mut ::std::os::raw::c_uchar,
    pub SavedHandle: handle_t,
    pub StubDesc: *const _MIDL_STUB_DESC,
    pub FullPtrXlatTables: *mut _FULL_PTR_XLAT_TABLES,
    pub FullPtrRefId: ::std::os::raw::c_ulong,
    pub PointerLength: ::std::os::raw::c_ulong,
    pub _bitfield_align_1: [u16; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub dwDestContext: ::std::os::raw::c_ulong,
    pub pvDestContext: *mut ::std::os::raw::c_void,
    pub SavedContextHandles: *mut NDR_SCONTEXT,
    pub ParamNumber: ::std::os::raw::c_long,
    pub pRpcChannelBuffer: *mut IRpcChannelBuffer,
    pub pArrayInfo: PARRAY_INFO,
    pub SizePtrCountArray: *mut ::std::os::raw::c_ulong,
    pub SizePtrOffsetArray: *mut ::std::os::raw::c_ulong,
    pub SizePtrLengthArray: *mut ::std::os::raw::c_ulong,
    pub pArgQueue: *mut ::std::os::raw::c_void,
    pub dwStubPhase: ::std::os::raw::c_ulong,
    pub LowStackMark: *mut ::std::os::raw::c_void,
    pub pAsyncMsg: PNDR_ASYNC_MESSAGE,
    pub pCorrInfo: PNDR_CORRELATION_INFO,
    pub pCorrMemory: *mut ::std::os::raw::c_uchar,
    pub pMemoryList: *mut ::std::os::raw::c_void,
    pub pCSInfo: INT_PTR,
    pub ConformanceMark: *mut ::std::os::raw::c_uchar,
    pub VarianceMark: *mut ::std::os::raw::c_uchar,
    pub Unused: INT_PTR,
    pub pContext: *mut _NDR_PROC_CONTEXT,
    pub ContextHandleHash: *mut ::std::os::raw::c_void,
    pub pUserMarshalList: *mut ::std::os::raw::c_void,
    pub Reserved51_3: INT_PTR,
    pub Reserved51_4: INT_PTR,
    pub Reserved51_5: INT_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_STUB_MESSAGE"][::std::mem::size_of::<_MIDL_STUB_MESSAGE>() - 400usize];
    ["Alignment of _MIDL_STUB_MESSAGE"][::std::mem::align_of::<_MIDL_STUB_MESSAGE>() - 8usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::RpcMsg"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, RpcMsg) - 0usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Buffer"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Buffer) - 8usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::BufferStart"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, BufferStart) - 16usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::BufferEnd"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, BufferEnd) - 24usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::BufferMark"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, BufferMark) - 32usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::BufferLength"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, BufferLength) - 40usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::MemorySize"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, MemorySize) - 44usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Memory"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Memory) - 48usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::IsClient"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, IsClient) - 56usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Pad"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Pad) - 57usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::uFlags2"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, uFlags2) - 58usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::ReuseBuffer"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, ReuseBuffer) - 60usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pAllocAllNodesContext"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pAllocAllNodesContext) - 64usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pPointerQueueState"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pPointerQueueState) - 72usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::IgnoreEmbeddedPointers"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, IgnoreEmbeddedPointers) - 80usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::PointerBufferMark"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, PointerBufferMark) - 88usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::CorrDespIncrement"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, CorrDespIncrement) - 96usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::uFlags"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, uFlags) - 97usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::UniquePtrCount"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, UniquePtrCount) - 98usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::MaxCount"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, MaxCount) - 104usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Offset"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Offset) - 112usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::ActualCount"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, ActualCount) - 116usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pfnAllocate"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pfnAllocate) - 120usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pfnFree"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pfnFree) - 128usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::StackTop"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, StackTop) - 136usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pPresentedType"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pPresentedType) - 144usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pTransmitType"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pTransmitType) - 152usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::SavedHandle"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, SavedHandle) - 160usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::StubDesc"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, StubDesc) - 168usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::FullPtrXlatTables"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, FullPtrXlatTables) - 176usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::FullPtrRefId"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, FullPtrRefId) - 184usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::PointerLength"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, PointerLength) - 188usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::dwDestContext"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, dwDestContext) - 196usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pvDestContext"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pvDestContext) - 200usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::SavedContextHandles"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, SavedContextHandles) - 208usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::ParamNumber"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, ParamNumber) - 216usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pRpcChannelBuffer"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pRpcChannelBuffer) - 224usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pArrayInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pArrayInfo) - 232usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::SizePtrCountArray"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, SizePtrCountArray) - 240usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::SizePtrOffsetArray"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, SizePtrOffsetArray) - 248usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::SizePtrLengthArray"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, SizePtrLengthArray) - 256usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pArgQueue"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pArgQueue) - 264usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::dwStubPhase"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, dwStubPhase) - 272usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::LowStackMark"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, LowStackMark) - 280usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pAsyncMsg"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pAsyncMsg) - 288usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pCorrInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pCorrInfo) - 296usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pCorrMemory"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pCorrMemory) - 304usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pMemoryList"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pMemoryList) - 312usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pCSInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pCSInfo) - 320usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::ConformanceMark"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, ConformanceMark) - 328usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::VarianceMark"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, VarianceMark) - 336usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Unused"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Unused) - 344usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pContext"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pContext) - 352usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::ContextHandleHash"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, ContextHandleHash) - 360usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::pUserMarshalList"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, pUserMarshalList) - 368usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Reserved51_3"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Reserved51_3) - 376usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Reserved51_4"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Reserved51_4) - 384usize];
    ["Offset of field: _MIDL_STUB_MESSAGE::Reserved51_5"]
        [::std::mem::offset_of!(_MIDL_STUB_MESSAGE, Reserved51_5) - 392usize];
};
impl _MIDL_STUB_MESSAGE {
    #[inline]
    pub fn fInDontFree(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fInDontFree(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fInDontFree_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fInDontFree_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fDontCallFreeInst(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fDontCallFreeInst(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fDontCallFreeInst_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fDontCallFreeInst_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fUnused1(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fUnused1(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fUnused1_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fUnused1_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fHasReturn(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fHasReturn(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fHasReturn_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fHasReturn_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fHasExtensions(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fHasExtensions(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fHasExtensions_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fHasExtensions_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fHasNewCorrDesc(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fHasNewCorrDesc(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fHasNewCorrDesc_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fHasNewCorrDesc_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fIsIn(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fIsIn(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fIsIn_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fIsIn_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fIsOut(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fIsOut(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fIsOut_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fIsOut_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fIsOicf(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fIsOicf(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fIsOicf_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fIsOicf_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fBufferValid(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(9usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fBufferValid(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(9usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fBufferValid_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                9usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fBufferValid_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                9usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fHasMemoryValidateCallback(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(10usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fHasMemoryValidateCallback(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(10usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fHasMemoryValidateCallback_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                10usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fHasMemoryValidateCallback_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                10usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fInFree(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(11usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fInFree(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(11usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fInFree_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                11usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fInFree_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                11usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fNeedMCCP(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_fNeedMCCP(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fNeedMCCP_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fNeedMCCP_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fUnused2(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(13usize, 3u8) as u32) }
    }
    #[inline]
    pub fn set_fUnused2(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(13usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fUnused2_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                13usize,
                3u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fUnused2_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                13usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn fUnused3(&self) -> ::std::os::raw::c_int {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(16usize, 16u8) as u32) }
    }
    #[inline]
    pub fn set_fUnused3(&mut self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(16usize, 16u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn fUnused3_raw(this: *const Self) -> ::std::os::raw::c_int {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                16usize,
                16u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_fUnused3_raw(this: *mut Self, val: ::std::os::raw::c_int) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                16usize,
                16u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        fInDontFree: ::std::os::raw::c_int,
        fDontCallFreeInst: ::std::os::raw::c_int,
        fUnused1: ::std::os::raw::c_int,
        fHasReturn: ::std::os::raw::c_int,
        fHasExtensions: ::std::os::raw::c_int,
        fHasNewCorrDesc: ::std::os::raw::c_int,
        fIsIn: ::std::os::raw::c_int,
        fIsOut: ::std::os::raw::c_int,
        fIsOicf: ::std::os::raw::c_int,
        fBufferValid: ::std::os::raw::c_int,
        fHasMemoryValidateCallback: ::std::os::raw::c_int,
        fInFree: ::std::os::raw::c_int,
        fNeedMCCP: ::std::os::raw::c_int,
        fUnused2: ::std::os::raw::c_int,
        fUnused3: ::std::os::raw::c_int,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let fInDontFree: u32 = unsafe { ::std::mem::transmute(fInDontFree) };
            fInDontFree as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let fDontCallFreeInst: u32 = unsafe { ::std::mem::transmute(fDontCallFreeInst) };
            fDontCallFreeInst as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let fUnused1: u32 = unsafe { ::std::mem::transmute(fUnused1) };
            fUnused1 as u64
        });
        __bindgen_bitfield_unit.set(3usize, 1u8, {
            let fHasReturn: u32 = unsafe { ::std::mem::transmute(fHasReturn) };
            fHasReturn as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let fHasExtensions: u32 = unsafe { ::std::mem::transmute(fHasExtensions) };
            fHasExtensions as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let fHasNewCorrDesc: u32 = unsafe { ::std::mem::transmute(fHasNewCorrDesc) };
            fHasNewCorrDesc as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let fIsIn: u32 = unsafe { ::std::mem::transmute(fIsIn) };
            fIsIn as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let fIsOut: u32 = unsafe { ::std::mem::transmute(fIsOut) };
            fIsOut as u64
        });
        __bindgen_bitfield_unit.set(8usize, 1u8, {
            let fIsOicf: u32 = unsafe { ::std::mem::transmute(fIsOicf) };
            fIsOicf as u64
        });
        __bindgen_bitfield_unit.set(9usize, 1u8, {
            let fBufferValid: u32 = unsafe { ::std::mem::transmute(fBufferValid) };
            fBufferValid as u64
        });
        __bindgen_bitfield_unit.set(10usize, 1u8, {
            let fHasMemoryValidateCallback: u32 =
                unsafe { ::std::mem::transmute(fHasMemoryValidateCallback) };
            fHasMemoryValidateCallback as u64
        });
        __bindgen_bitfield_unit.set(11usize, 1u8, {
            let fInFree: u32 = unsafe { ::std::mem::transmute(fInFree) };
            fInFree as u64
        });
        __bindgen_bitfield_unit.set(12usize, 1u8, {
            let fNeedMCCP: u32 = unsafe { ::std::mem::transmute(fNeedMCCP) };
            fNeedMCCP as u64
        });
        __bindgen_bitfield_unit.set(13usize, 3u8, {
            let fUnused2: u32 = unsafe { ::std::mem::transmute(fUnused2) };
            fUnused2 as u64
        });
        __bindgen_bitfield_unit.set(16usize, 16u8, {
            let fUnused3: u32 = unsafe { ::std::mem::transmute(fUnused3) };
            fUnused3 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type MIDL_STUB_MESSAGE = _MIDL_STUB_MESSAGE;
pub type PMIDL_STUB_MESSAGE = *mut _MIDL_STUB_MESSAGE;
pub type GENERIC_BINDING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void) -> *mut ::std::os::raw::c_void,
>;
pub type GENERIC_UNBIND_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void, arg2: *mut ::std::os::raw::c_uchar),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GENERIC_BINDING_ROUTINE_PAIR {
    pub pfnBind: GENERIC_BINDING_ROUTINE,
    pub pfnUnbind: GENERIC_UNBIND_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GENERIC_BINDING_ROUTINE_PAIR"]
        [::std::mem::size_of::<_GENERIC_BINDING_ROUTINE_PAIR>() - 16usize];
    ["Alignment of _GENERIC_BINDING_ROUTINE_PAIR"]
        [::std::mem::align_of::<_GENERIC_BINDING_ROUTINE_PAIR>() - 8usize];
    ["Offset of field: _GENERIC_BINDING_ROUTINE_PAIR::pfnBind"]
        [::std::mem::offset_of!(_GENERIC_BINDING_ROUTINE_PAIR, pfnBind) - 0usize];
    ["Offset of field: _GENERIC_BINDING_ROUTINE_PAIR::pfnUnbind"]
        [::std::mem::offset_of!(_GENERIC_BINDING_ROUTINE_PAIR, pfnUnbind) - 8usize];
};
pub type GENERIC_BINDING_ROUTINE_PAIR = _GENERIC_BINDING_ROUTINE_PAIR;
pub type PGENERIC_BINDING_ROUTINE_PAIR = *mut _GENERIC_BINDING_ROUTINE_PAIR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __GENERIC_BINDING_INFO {
    pub pObj: *mut ::std::os::raw::c_void,
    pub Size: ::std::os::raw::c_uint,
    pub pfnBind: GENERIC_BINDING_ROUTINE,
    pub pfnUnbind: GENERIC_UNBIND_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __GENERIC_BINDING_INFO"][::std::mem::size_of::<__GENERIC_BINDING_INFO>() - 32usize];
    ["Alignment of __GENERIC_BINDING_INFO"]
        [::std::mem::align_of::<__GENERIC_BINDING_INFO>() - 8usize];
    ["Offset of field: __GENERIC_BINDING_INFO::pObj"]
        [::std::mem::offset_of!(__GENERIC_BINDING_INFO, pObj) - 0usize];
    ["Offset of field: __GENERIC_BINDING_INFO::Size"]
        [::std::mem::offset_of!(__GENERIC_BINDING_INFO, Size) - 8usize];
    ["Offset of field: __GENERIC_BINDING_INFO::pfnBind"]
        [::std::mem::offset_of!(__GENERIC_BINDING_INFO, pfnBind) - 16usize];
    ["Offset of field: __GENERIC_BINDING_INFO::pfnUnbind"]
        [::std::mem::offset_of!(__GENERIC_BINDING_INFO, pfnUnbind) - 24usize];
};
pub type GENERIC_BINDING_INFO = __GENERIC_BINDING_INFO;
pub type PGENERIC_BINDING_INFO = *mut __GENERIC_BINDING_INFO;
pub type XMIT_HELPER_ROUTINE =
    ::std::option::Option<unsafe extern "C" fn(arg1: PMIDL_STUB_MESSAGE)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _XMIT_ROUTINE_QUINTUPLE {
    pub pfnTranslateToXmit: XMIT_HELPER_ROUTINE,
    pub pfnTranslateFromXmit: XMIT_HELPER_ROUTINE,
    pub pfnFreeXmit: XMIT_HELPER_ROUTINE,
    pub pfnFreeInst: XMIT_HELPER_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _XMIT_ROUTINE_QUINTUPLE"][::std::mem::size_of::<_XMIT_ROUTINE_QUINTUPLE>() - 32usize];
    ["Alignment of _XMIT_ROUTINE_QUINTUPLE"]
        [::std::mem::align_of::<_XMIT_ROUTINE_QUINTUPLE>() - 8usize];
    ["Offset of field: _XMIT_ROUTINE_QUINTUPLE::pfnTranslateToXmit"]
        [::std::mem::offset_of!(_XMIT_ROUTINE_QUINTUPLE, pfnTranslateToXmit) - 0usize];
    ["Offset of field: _XMIT_ROUTINE_QUINTUPLE::pfnTranslateFromXmit"]
        [::std::mem::offset_of!(_XMIT_ROUTINE_QUINTUPLE, pfnTranslateFromXmit) - 8usize];
    ["Offset of field: _XMIT_ROUTINE_QUINTUPLE::pfnFreeXmit"]
        [::std::mem::offset_of!(_XMIT_ROUTINE_QUINTUPLE, pfnFreeXmit) - 16usize];
    ["Offset of field: _XMIT_ROUTINE_QUINTUPLE::pfnFreeInst"]
        [::std::mem::offset_of!(_XMIT_ROUTINE_QUINTUPLE, pfnFreeInst) - 24usize];
};
pub type XMIT_ROUTINE_QUINTUPLE = _XMIT_ROUTINE_QUINTUPLE;
pub type PXMIT_ROUTINE_QUINTUPLE = *mut _XMIT_ROUTINE_QUINTUPLE;
pub type USER_MARSHAL_SIZING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut ::std::os::raw::c_void,
    ) -> ::std::os::raw::c_ulong,
>;
pub type USER_MARSHAL_MARSHALLING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_uchar,
>;
pub type USER_MARSHAL_UNMARSHALLING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_uchar,
>;
pub type USER_MARSHAL_FREEING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut ::std::os::raw::c_void),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _USER_MARSHAL_ROUTINE_QUADRUPLE {
    pub pfnBufferSize: USER_MARSHAL_SIZING_ROUTINE,
    pub pfnMarshall: USER_MARSHAL_MARSHALLING_ROUTINE,
    pub pfnUnmarshall: USER_MARSHAL_UNMARSHALLING_ROUTINE,
    pub pfnFree: USER_MARSHAL_FREEING_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _USER_MARSHAL_ROUTINE_QUADRUPLE"]
        [::std::mem::size_of::<_USER_MARSHAL_ROUTINE_QUADRUPLE>() - 32usize];
    ["Alignment of _USER_MARSHAL_ROUTINE_QUADRUPLE"]
        [::std::mem::align_of::<_USER_MARSHAL_ROUTINE_QUADRUPLE>() - 8usize];
    ["Offset of field: _USER_MARSHAL_ROUTINE_QUADRUPLE::pfnBufferSize"]
        [::std::mem::offset_of!(_USER_MARSHAL_ROUTINE_QUADRUPLE, pfnBufferSize) - 0usize];
    ["Offset of field: _USER_MARSHAL_ROUTINE_QUADRUPLE::pfnMarshall"]
        [::std::mem::offset_of!(_USER_MARSHAL_ROUTINE_QUADRUPLE, pfnMarshall) - 8usize];
    ["Offset of field: _USER_MARSHAL_ROUTINE_QUADRUPLE::pfnUnmarshall"]
        [::std::mem::offset_of!(_USER_MARSHAL_ROUTINE_QUADRUPLE, pfnUnmarshall) - 16usize];
    ["Offset of field: _USER_MARSHAL_ROUTINE_QUADRUPLE::pfnFree"]
        [::std::mem::offset_of!(_USER_MARSHAL_ROUTINE_QUADRUPLE, pfnFree) - 24usize];
};
pub type USER_MARSHAL_ROUTINE_QUADRUPLE = _USER_MARSHAL_ROUTINE_QUADRUPLE;
pub const _USER_MARSHAL_CB_TYPE_USER_MARSHAL_CB_BUFFER_SIZE: _USER_MARSHAL_CB_TYPE = 0;
pub const _USER_MARSHAL_CB_TYPE_USER_MARSHAL_CB_MARSHALL: _USER_MARSHAL_CB_TYPE = 1;
pub const _USER_MARSHAL_CB_TYPE_USER_MARSHAL_CB_UNMARSHALL: _USER_MARSHAL_CB_TYPE = 2;
pub const _USER_MARSHAL_CB_TYPE_USER_MARSHAL_CB_FREE: _USER_MARSHAL_CB_TYPE = 3;
pub type _USER_MARSHAL_CB_TYPE = ::std::os::raw::c_int;
pub use self::_USER_MARSHAL_CB_TYPE as USER_MARSHAL_CB_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _USER_MARSHAL_CB {
    pub Flags: ::std::os::raw::c_ulong,
    pub pStubMsg: PMIDL_STUB_MESSAGE,
    pub pReserve: PFORMAT_STRING,
    pub Signature: ::std::os::raw::c_ulong,
    pub CBType: USER_MARSHAL_CB_TYPE,
    pub pFormat: PFORMAT_STRING,
    pub pTypeFormat: PFORMAT_STRING,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _USER_MARSHAL_CB"][::std::mem::size_of::<_USER_MARSHAL_CB>() - 48usize];
    ["Alignment of _USER_MARSHAL_CB"][::std::mem::align_of::<_USER_MARSHAL_CB>() - 8usize];
    ["Offset of field: _USER_MARSHAL_CB::Flags"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, Flags) - 0usize];
    ["Offset of field: _USER_MARSHAL_CB::pStubMsg"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, pStubMsg) - 8usize];
    ["Offset of field: _USER_MARSHAL_CB::pReserve"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, pReserve) - 16usize];
    ["Offset of field: _USER_MARSHAL_CB::Signature"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, Signature) - 24usize];
    ["Offset of field: _USER_MARSHAL_CB::CBType"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, CBType) - 28usize];
    ["Offset of field: _USER_MARSHAL_CB::pFormat"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, pFormat) - 32usize];
    ["Offset of field: _USER_MARSHAL_CB::pTypeFormat"]
        [::std::mem::offset_of!(_USER_MARSHAL_CB, pTypeFormat) - 40usize];
};
pub type USER_MARSHAL_CB = _USER_MARSHAL_CB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MALLOC_FREE_STRUCT {
    pub pfnAllocate:
        ::std::option::Option<unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void>,
    pub pfnFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MALLOC_FREE_STRUCT"][::std::mem::size_of::<_MALLOC_FREE_STRUCT>() - 16usize];
    ["Alignment of _MALLOC_FREE_STRUCT"][::std::mem::align_of::<_MALLOC_FREE_STRUCT>() - 8usize];
    ["Offset of field: _MALLOC_FREE_STRUCT::pfnAllocate"]
        [::std::mem::offset_of!(_MALLOC_FREE_STRUCT, pfnAllocate) - 0usize];
    ["Offset of field: _MALLOC_FREE_STRUCT::pfnFree"]
        [::std::mem::offset_of!(_MALLOC_FREE_STRUCT, pfnFree) - 8usize];
};
pub type MALLOC_FREE_STRUCT = _MALLOC_FREE_STRUCT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COMM_FAULT_OFFSETS {
    pub CommOffset: ::std::os::raw::c_short,
    pub FaultOffset: ::std::os::raw::c_short,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COMM_FAULT_OFFSETS"][::std::mem::size_of::<_COMM_FAULT_OFFSETS>() - 4usize];
    ["Alignment of _COMM_FAULT_OFFSETS"][::std::mem::align_of::<_COMM_FAULT_OFFSETS>() - 2usize];
    ["Offset of field: _COMM_FAULT_OFFSETS::CommOffset"]
        [::std::mem::offset_of!(_COMM_FAULT_OFFSETS, CommOffset) - 0usize];
    ["Offset of field: _COMM_FAULT_OFFSETS::FaultOffset"]
        [::std::mem::offset_of!(_COMM_FAULT_OFFSETS, FaultOffset) - 2usize];
};
pub type COMM_FAULT_OFFSETS = _COMM_FAULT_OFFSETS;
pub const _IDL_CS_CONVERT_IDL_CS_NO_CONVERT: _IDL_CS_CONVERT = 0;
pub const _IDL_CS_CONVERT_IDL_CS_IN_PLACE_CONVERT: _IDL_CS_CONVERT = 1;
pub const _IDL_CS_CONVERT_IDL_CS_NEW_BUFFER_CONVERT: _IDL_CS_CONVERT = 2;
pub type _IDL_CS_CONVERT = ::std::os::raw::c_int;
pub use self::_IDL_CS_CONVERT as IDL_CS_CONVERT;
pub type CS_TYPE_NET_SIZE_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        hBinding: RPC_BINDING_HANDLE,
        ulNetworkCodeSet: ::std::os::raw::c_ulong,
        ulLocalBufferSize: ::std::os::raw::c_ulong,
        conversionType: *mut IDL_CS_CONVERT,
        pulNetworkBufferSize: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    ),
>;
pub type CS_TYPE_LOCAL_SIZE_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        hBinding: RPC_BINDING_HANDLE,
        ulNetworkCodeSet: ::std::os::raw::c_ulong,
        ulNetworkBufferSize: ::std::os::raw::c_ulong,
        conversionType: *mut IDL_CS_CONVERT,
        pulLocalBufferSize: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    ),
>;
pub type CS_TYPE_TO_NETCS_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        hBinding: RPC_BINDING_HANDLE,
        ulNetworkCodeSet: ::std::os::raw::c_ulong,
        pLocalData: *mut ::std::os::raw::c_void,
        ulLocalDataLength: ::std::os::raw::c_ulong,
        pNetworkData: *mut byte,
        pulNetworkDataLength: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    ),
>;
pub type CS_TYPE_FROM_NETCS_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        hBinding: RPC_BINDING_HANDLE,
        ulNetworkCodeSet: ::std::os::raw::c_ulong,
        pNetworkData: *mut byte,
        ulNetworkDataLength: ::std::os::raw::c_ulong,
        ulLocalBufferSize: ::std::os::raw::c_ulong,
        pLocalData: *mut ::std::os::raw::c_void,
        pulLocalDataLength: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    ),
>;
pub type CS_TAG_GETTING_ROUTINE = ::std::option::Option<
    unsafe extern "C" fn(
        hBinding: RPC_BINDING_HANDLE,
        fServerSide: ::std::os::raw::c_int,
        pulSendingTag: *mut ::std::os::raw::c_ulong,
        pulDesiredReceivingTag: *mut ::std::os::raw::c_ulong,
        pulReceivingTag: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    ),
>;
unsafe extern "C" {
    pub fn RpcCsGetTags(
        hBinding: RPC_BINDING_HANDLE,
        fServerSide: ::std::os::raw::c_int,
        pulSendingTag: *mut ::std::os::raw::c_ulong,
        pulDesiredReceivingTag: *mut ::std::os::raw::c_ulong,
        pulReceivingTag: *mut ::std::os::raw::c_ulong,
        pStatus: *mut error_status_t,
    );
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_CS_SIZE_CONVERT_ROUTINES {
    pub pfnNetSize: CS_TYPE_NET_SIZE_ROUTINE,
    pub pfnToNetCs: CS_TYPE_TO_NETCS_ROUTINE,
    pub pfnLocalSize: CS_TYPE_LOCAL_SIZE_ROUTINE,
    pub pfnFromNetCs: CS_TYPE_FROM_NETCS_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_CS_SIZE_CONVERT_ROUTINES"]
        [::std::mem::size_of::<_NDR_CS_SIZE_CONVERT_ROUTINES>() - 32usize];
    ["Alignment of _NDR_CS_SIZE_CONVERT_ROUTINES"]
        [::std::mem::align_of::<_NDR_CS_SIZE_CONVERT_ROUTINES>() - 8usize];
    ["Offset of field: _NDR_CS_SIZE_CONVERT_ROUTINES::pfnNetSize"]
        [::std::mem::offset_of!(_NDR_CS_SIZE_CONVERT_ROUTINES, pfnNetSize) - 0usize];
    ["Offset of field: _NDR_CS_SIZE_CONVERT_ROUTINES::pfnToNetCs"]
        [::std::mem::offset_of!(_NDR_CS_SIZE_CONVERT_ROUTINES, pfnToNetCs) - 8usize];
    ["Offset of field: _NDR_CS_SIZE_CONVERT_ROUTINES::pfnLocalSize"]
        [::std::mem::offset_of!(_NDR_CS_SIZE_CONVERT_ROUTINES, pfnLocalSize) - 16usize];
    ["Offset of field: _NDR_CS_SIZE_CONVERT_ROUTINES::pfnFromNetCs"]
        [::std::mem::offset_of!(_NDR_CS_SIZE_CONVERT_ROUTINES, pfnFromNetCs) - 24usize];
};
pub type NDR_CS_SIZE_CONVERT_ROUTINES = _NDR_CS_SIZE_CONVERT_ROUTINES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_CS_ROUTINES {
    pub pSizeConvertRoutines: *mut NDR_CS_SIZE_CONVERT_ROUTINES,
    pub pTagGettingRoutines: *mut CS_TAG_GETTING_ROUTINE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_CS_ROUTINES"][::std::mem::size_of::<_NDR_CS_ROUTINES>() - 16usize];
    ["Alignment of _NDR_CS_ROUTINES"][::std::mem::align_of::<_NDR_CS_ROUTINES>() - 8usize];
    ["Offset of field: _NDR_CS_ROUTINES::pSizeConvertRoutines"]
        [::std::mem::offset_of!(_NDR_CS_ROUTINES, pSizeConvertRoutines) - 0usize];
    ["Offset of field: _NDR_CS_ROUTINES::pTagGettingRoutines"]
        [::std::mem::offset_of!(_NDR_CS_ROUTINES, pTagGettingRoutines) - 8usize];
};
pub type NDR_CS_ROUTINES = _NDR_CS_ROUTINES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_EXPR_DESC {
    pub pOffset: *const ::std::os::raw::c_ushort,
    pub pFormatExpr: PFORMAT_STRING,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_EXPR_DESC"][::std::mem::size_of::<_NDR_EXPR_DESC>() - 16usize];
    ["Alignment of _NDR_EXPR_DESC"][::std::mem::align_of::<_NDR_EXPR_DESC>() - 8usize];
    ["Offset of field: _NDR_EXPR_DESC::pOffset"]
        [::std::mem::offset_of!(_NDR_EXPR_DESC, pOffset) - 0usize];
    ["Offset of field: _NDR_EXPR_DESC::pFormatExpr"]
        [::std::mem::offset_of!(_NDR_EXPR_DESC, pFormatExpr) - 8usize];
};
pub type NDR_EXPR_DESC = _NDR_EXPR_DESC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _MIDL_STUB_DESC {
    pub RpcInterfaceInformation: *mut ::std::os::raw::c_void,
    pub pfnAllocate:
        ::std::option::Option<unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void>,
    pub pfnFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    pub IMPLICIT_HANDLE_INFO: _MIDL_STUB_DESC__bindgen_ty_1,
    pub apfnNdrRundownRoutines: *const NDR_RUNDOWN,
    pub aGenericBindingRoutinePairs: *const GENERIC_BINDING_ROUTINE_PAIR,
    pub apfnExprEval: *const EXPR_EVAL,
    pub aXmitQuintuple: *const XMIT_ROUTINE_QUINTUPLE,
    pub pFormatTypes: *const ::std::os::raw::c_uchar,
    pub fCheckBounds: ::std::os::raw::c_int,
    pub Version: ::std::os::raw::c_ulong,
    pub pMallocFreeStruct: *mut MALLOC_FREE_STRUCT,
    pub MIDLVersion: ::std::os::raw::c_long,
    pub CommFaultOffsets: *const COMM_FAULT_OFFSETS,
    pub aUserMarshalQuadruple: *const USER_MARSHAL_ROUTINE_QUADRUPLE,
    pub NotifyRoutineTable: *const NDR_NOTIFY_ROUTINE,
    pub mFlags: ULONG_PTR,
    pub CsRoutineTables: *const NDR_CS_ROUTINES,
    pub ProxyServerInfo: *mut ::std::os::raw::c_void,
    pub pExprInfo: *const NDR_EXPR_DESC,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _MIDL_STUB_DESC__bindgen_ty_1 {
    pub pAutoHandle: *mut handle_t,
    pub pPrimitiveHandle: *mut handle_t,
    pub pGenericBindingInfo: PGENERIC_BINDING_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_STUB_DESC__bindgen_ty_1"]
        [::std::mem::size_of::<_MIDL_STUB_DESC__bindgen_ty_1>() - 8usize];
    ["Alignment of _MIDL_STUB_DESC__bindgen_ty_1"]
        [::std::mem::align_of::<_MIDL_STUB_DESC__bindgen_ty_1>() - 8usize];
    ["Offset of field: _MIDL_STUB_DESC__bindgen_ty_1::pAutoHandle"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC__bindgen_ty_1, pAutoHandle) - 0usize];
    ["Offset of field: _MIDL_STUB_DESC__bindgen_ty_1::pPrimitiveHandle"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC__bindgen_ty_1, pPrimitiveHandle) - 0usize];
    ["Offset of field: _MIDL_STUB_DESC__bindgen_ty_1::pGenericBindingInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC__bindgen_ty_1, pGenericBindingInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_STUB_DESC"][::std::mem::size_of::<_MIDL_STUB_DESC>() - 152usize];
    ["Alignment of _MIDL_STUB_DESC"][::std::mem::align_of::<_MIDL_STUB_DESC>() - 8usize];
    ["Offset of field: _MIDL_STUB_DESC::RpcInterfaceInformation"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, RpcInterfaceInformation) - 0usize];
    ["Offset of field: _MIDL_STUB_DESC::pfnAllocate"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, pfnAllocate) - 8usize];
    ["Offset of field: _MIDL_STUB_DESC::pfnFree"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, pfnFree) - 16usize];
    ["Offset of field: _MIDL_STUB_DESC::IMPLICIT_HANDLE_INFO"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, IMPLICIT_HANDLE_INFO) - 24usize];
    ["Offset of field: _MIDL_STUB_DESC::apfnNdrRundownRoutines"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, apfnNdrRundownRoutines) - 32usize];
    ["Offset of field: _MIDL_STUB_DESC::aGenericBindingRoutinePairs"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, aGenericBindingRoutinePairs) - 40usize];
    ["Offset of field: _MIDL_STUB_DESC::apfnExprEval"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, apfnExprEval) - 48usize];
    ["Offset of field: _MIDL_STUB_DESC::aXmitQuintuple"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, aXmitQuintuple) - 56usize];
    ["Offset of field: _MIDL_STUB_DESC::pFormatTypes"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, pFormatTypes) - 64usize];
    ["Offset of field: _MIDL_STUB_DESC::fCheckBounds"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, fCheckBounds) - 72usize];
    ["Offset of field: _MIDL_STUB_DESC::Version"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, Version) - 76usize];
    ["Offset of field: _MIDL_STUB_DESC::pMallocFreeStruct"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, pMallocFreeStruct) - 80usize];
    ["Offset of field: _MIDL_STUB_DESC::MIDLVersion"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, MIDLVersion) - 88usize];
    ["Offset of field: _MIDL_STUB_DESC::CommFaultOffsets"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, CommFaultOffsets) - 96usize];
    ["Offset of field: _MIDL_STUB_DESC::aUserMarshalQuadruple"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, aUserMarshalQuadruple) - 104usize];
    ["Offset of field: _MIDL_STUB_DESC::NotifyRoutineTable"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, NotifyRoutineTable) - 112usize];
    ["Offset of field: _MIDL_STUB_DESC::mFlags"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, mFlags) - 120usize];
    ["Offset of field: _MIDL_STUB_DESC::CsRoutineTables"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, CsRoutineTables) - 128usize];
    ["Offset of field: _MIDL_STUB_DESC::ProxyServerInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, ProxyServerInfo) - 136usize];
    ["Offset of field: _MIDL_STUB_DESC::pExprInfo"]
        [::std::mem::offset_of!(_MIDL_STUB_DESC, pExprInfo) - 144usize];
};
pub type MIDL_STUB_DESC = _MIDL_STUB_DESC;
pub type PMIDL_STUB_DESC = *const MIDL_STUB_DESC;
pub type PMIDL_XMIT_TYPE = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Debug)]
pub struct _MIDL_FORMAT_STRING {
    pub Pad: ::std::os::raw::c_short,
    pub Format: __IncompleteArrayField<::std::os::raw::c_uchar>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_FORMAT_STRING"][::std::mem::size_of::<_MIDL_FORMAT_STRING>() - 2usize];
    ["Alignment of _MIDL_FORMAT_STRING"][::std::mem::align_of::<_MIDL_FORMAT_STRING>() - 2usize];
    ["Offset of field: _MIDL_FORMAT_STRING::Pad"]
        [::std::mem::offset_of!(_MIDL_FORMAT_STRING, Pad) - 0usize];
    ["Offset of field: _MIDL_FORMAT_STRING::Format"]
        [::std::mem::offset_of!(_MIDL_FORMAT_STRING, Format) - 2usize];
};
pub type MIDL_FORMAT_STRING = _MIDL_FORMAT_STRING;
pub type STUB_THUNK = ::std::option::Option<unsafe extern "C" fn(arg1: PMIDL_STUB_MESSAGE)>;
pub type SERVER_ROUTINE = ::std::option::Option<unsafe extern "C" fn() -> ::std::os::raw::c_long>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_METHOD_PROPERTY {
    pub Id: ::std::os::raw::c_ulong,
    pub Value: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_METHOD_PROPERTY"][::std::mem::size_of::<_MIDL_METHOD_PROPERTY>() - 16usize];
    ["Alignment of _MIDL_METHOD_PROPERTY"]
        [::std::mem::align_of::<_MIDL_METHOD_PROPERTY>() - 8usize];
    ["Offset of field: _MIDL_METHOD_PROPERTY::Id"]
        [::std::mem::offset_of!(_MIDL_METHOD_PROPERTY, Id) - 0usize];
    ["Offset of field: _MIDL_METHOD_PROPERTY::Value"]
        [::std::mem::offset_of!(_MIDL_METHOD_PROPERTY, Value) - 8usize];
};
pub type MIDL_METHOD_PROPERTY = _MIDL_METHOD_PROPERTY;
pub type PMIDL_METHOD_PROPERTY = *mut _MIDL_METHOD_PROPERTY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_METHOD_PROPERTY_MAP {
    pub Count: ::std::os::raw::c_ulong,
    pub Properties: *const MIDL_METHOD_PROPERTY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_METHOD_PROPERTY_MAP"]
        [::std::mem::size_of::<_MIDL_METHOD_PROPERTY_MAP>() - 16usize];
    ["Alignment of _MIDL_METHOD_PROPERTY_MAP"]
        [::std::mem::align_of::<_MIDL_METHOD_PROPERTY_MAP>() - 8usize];
    ["Offset of field: _MIDL_METHOD_PROPERTY_MAP::Count"]
        [::std::mem::offset_of!(_MIDL_METHOD_PROPERTY_MAP, Count) - 0usize];
    ["Offset of field: _MIDL_METHOD_PROPERTY_MAP::Properties"]
        [::std::mem::offset_of!(_MIDL_METHOD_PROPERTY_MAP, Properties) - 8usize];
};
pub type MIDL_METHOD_PROPERTY_MAP = _MIDL_METHOD_PROPERTY_MAP;
pub type PMIDL_METHOD_PROPERTY_MAP = *mut _MIDL_METHOD_PROPERTY_MAP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_INTERFACE_METHOD_PROPERTIES {
    pub MethodCount: ::std::os::raw::c_ushort,
    pub MethodProperties: *const *const MIDL_METHOD_PROPERTY_MAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_INTERFACE_METHOD_PROPERTIES"]
        [::std::mem::size_of::<_MIDL_INTERFACE_METHOD_PROPERTIES>() - 16usize];
    ["Alignment of _MIDL_INTERFACE_METHOD_PROPERTIES"]
        [::std::mem::align_of::<_MIDL_INTERFACE_METHOD_PROPERTIES>() - 8usize];
    ["Offset of field: _MIDL_INTERFACE_METHOD_PROPERTIES::MethodCount"]
        [::std::mem::offset_of!(_MIDL_INTERFACE_METHOD_PROPERTIES, MethodCount) - 0usize];
    ["Offset of field: _MIDL_INTERFACE_METHOD_PROPERTIES::MethodProperties"]
        [::std::mem::offset_of!(_MIDL_INTERFACE_METHOD_PROPERTIES, MethodProperties) - 8usize];
};
pub type MIDL_INTERFACE_METHOD_PROPERTIES = _MIDL_INTERFACE_METHOD_PROPERTIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_SERVER_INFO_ {
    pub pStubDesc: PMIDL_STUB_DESC,
    pub DispatchTable: *const SERVER_ROUTINE,
    pub ProcString: PFORMAT_STRING,
    pub FmtStringOffset: *const ::std::os::raw::c_ushort,
    pub ThunkTable: *const STUB_THUNK,
    pub pTransferSyntax: PRPC_SYNTAX_IDENTIFIER,
    pub nCount: ULONG_PTR,
    pub pSyntaxInfo: PMIDL_SYNTAX_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_SERVER_INFO_"][::std::mem::size_of::<_MIDL_SERVER_INFO_>() - 64usize];
    ["Alignment of _MIDL_SERVER_INFO_"][::std::mem::align_of::<_MIDL_SERVER_INFO_>() - 8usize];
    ["Offset of field: _MIDL_SERVER_INFO_::pStubDesc"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, pStubDesc) - 0usize];
    ["Offset of field: _MIDL_SERVER_INFO_::DispatchTable"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, DispatchTable) - 8usize];
    ["Offset of field: _MIDL_SERVER_INFO_::ProcString"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, ProcString) - 16usize];
    ["Offset of field: _MIDL_SERVER_INFO_::FmtStringOffset"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, FmtStringOffset) - 24usize];
    ["Offset of field: _MIDL_SERVER_INFO_::ThunkTable"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, ThunkTable) - 32usize];
    ["Offset of field: _MIDL_SERVER_INFO_::pTransferSyntax"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, pTransferSyntax) - 40usize];
    ["Offset of field: _MIDL_SERVER_INFO_::nCount"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, nCount) - 48usize];
    ["Offset of field: _MIDL_SERVER_INFO_::pSyntaxInfo"]
        [::std::mem::offset_of!(_MIDL_SERVER_INFO_, pSyntaxInfo) - 56usize];
};
pub type MIDL_SERVER_INFO = _MIDL_SERVER_INFO_;
pub type PMIDL_SERVER_INFO = *mut _MIDL_SERVER_INFO_;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_STUBLESS_PROXY_INFO {
    pub pStubDesc: PMIDL_STUB_DESC,
    pub ProcFormatString: PFORMAT_STRING,
    pub FormatStringOffset: *const ::std::os::raw::c_ushort,
    pub pTransferSyntax: PRPC_SYNTAX_IDENTIFIER,
    pub nCount: ULONG_PTR,
    pub pSyntaxInfo: PMIDL_SYNTAX_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_STUBLESS_PROXY_INFO"]
        [::std::mem::size_of::<_MIDL_STUBLESS_PROXY_INFO>() - 48usize];
    ["Alignment of _MIDL_STUBLESS_PROXY_INFO"]
        [::std::mem::align_of::<_MIDL_STUBLESS_PROXY_INFO>() - 8usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::pStubDesc"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, pStubDesc) - 0usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::ProcFormatString"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, ProcFormatString) - 8usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::FormatStringOffset"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, FormatStringOffset) - 16usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::pTransferSyntax"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, pTransferSyntax) - 24usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::nCount"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, nCount) - 32usize];
    ["Offset of field: _MIDL_STUBLESS_PROXY_INFO::pSyntaxInfo"]
        [::std::mem::offset_of!(_MIDL_STUBLESS_PROXY_INFO, pSyntaxInfo) - 40usize];
};
pub type MIDL_STUBLESS_PROXY_INFO = _MIDL_STUBLESS_PROXY_INFO;
pub type PMIDL_STUBLESS_PROXY_INFO = *mut MIDL_STUBLESS_PROXY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_SYNTAX_INFO {
    pub TransferSyntax: RPC_SYNTAX_IDENTIFIER,
    pub DispatchTable: *mut RPC_DISPATCH_TABLE,
    pub ProcString: PFORMAT_STRING,
    pub FmtStringOffset: *const ::std::os::raw::c_ushort,
    pub TypeString: PFORMAT_STRING,
    pub aUserMarshalQuadruple: *const ::std::os::raw::c_void,
    pub pMethodProperties: *const MIDL_INTERFACE_METHOD_PROPERTIES,
    pub pReserved2: ULONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_SYNTAX_INFO"][::std::mem::size_of::<_MIDL_SYNTAX_INFO>() - 80usize];
    ["Alignment of _MIDL_SYNTAX_INFO"][::std::mem::align_of::<_MIDL_SYNTAX_INFO>() - 8usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::TransferSyntax"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, TransferSyntax) - 0usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::DispatchTable"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, DispatchTable) - 24usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::ProcString"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, ProcString) - 32usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::FmtStringOffset"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, FmtStringOffset) - 40usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::TypeString"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, TypeString) - 48usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::aUserMarshalQuadruple"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, aUserMarshalQuadruple) - 56usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::pMethodProperties"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, pMethodProperties) - 64usize];
    ["Offset of field: _MIDL_SYNTAX_INFO::pReserved2"]
        [::std::mem::offset_of!(_MIDL_SYNTAX_INFO, pReserved2) - 72usize];
};
pub type PARAM_OFFSETTABLE = *mut ::std::os::raw::c_ushort;
pub type PPARAM_OFFSETTABLE = *mut ::std::os::raw::c_ushort;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CLIENT_CALL_RETURN {
    pub Pointer: *mut ::std::os::raw::c_void,
    pub Simple: LONG_PTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLIENT_CALL_RETURN"][::std::mem::size_of::<_CLIENT_CALL_RETURN>() - 8usize];
    ["Alignment of _CLIENT_CALL_RETURN"][::std::mem::align_of::<_CLIENT_CALL_RETURN>() - 8usize];
    ["Offset of field: _CLIENT_CALL_RETURN::Pointer"]
        [::std::mem::offset_of!(_CLIENT_CALL_RETURN, Pointer) - 0usize];
    ["Offset of field: _CLIENT_CALL_RETURN::Simple"]
        [::std::mem::offset_of!(_CLIENT_CALL_RETURN, Simple) - 0usize];
};
pub type CLIENT_CALL_RETURN = _CLIENT_CALL_RETURN;
pub const XLAT_SIDE_XLAT_SERVER: XLAT_SIDE = 1;
pub const XLAT_SIDE_XLAT_CLIENT: XLAT_SIDE = 2;
pub type XLAT_SIDE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FULL_PTR_XLAT_TABLES {
    pub RefIdToPointer: *mut ::std::os::raw::c_void,
    pub PointerToRefId: *mut ::std::os::raw::c_void,
    pub NextRefId: ::std::os::raw::c_ulong,
    pub XlatSide: XLAT_SIDE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FULL_PTR_XLAT_TABLES"][::std::mem::size_of::<_FULL_PTR_XLAT_TABLES>() - 24usize];
    ["Alignment of _FULL_PTR_XLAT_TABLES"]
        [::std::mem::align_of::<_FULL_PTR_XLAT_TABLES>() - 8usize];
    ["Offset of field: _FULL_PTR_XLAT_TABLES::RefIdToPointer"]
        [::std::mem::offset_of!(_FULL_PTR_XLAT_TABLES, RefIdToPointer) - 0usize];
    ["Offset of field: _FULL_PTR_XLAT_TABLES::PointerToRefId"]
        [::std::mem::offset_of!(_FULL_PTR_XLAT_TABLES, PointerToRefId) - 8usize];
    ["Offset of field: _FULL_PTR_XLAT_TABLES::NextRefId"]
        [::std::mem::offset_of!(_FULL_PTR_XLAT_TABLES, NextRefId) - 16usize];
    ["Offset of field: _FULL_PTR_XLAT_TABLES::XlatSide"]
        [::std::mem::offset_of!(_FULL_PTR_XLAT_TABLES, XlatSide) - 20usize];
};
pub type FULL_PTR_XLAT_TABLES = _FULL_PTR_XLAT_TABLES;
pub type PFULL_PTR_XLAT_TABLES = *mut _FULL_PTR_XLAT_TABLES;
pub const _system_handle_t_SYSTEM_HANDLE_FILE: _system_handle_t = 0;
pub const _system_handle_t_SYSTEM_HANDLE_SEMAPHORE: _system_handle_t = 1;
pub const _system_handle_t_SYSTEM_HANDLE_EVENT: _system_handle_t = 2;
pub const _system_handle_t_SYSTEM_HANDLE_MUTEX: _system_handle_t = 3;
pub const _system_handle_t_SYSTEM_HANDLE_PROCESS: _system_handle_t = 4;
pub const _system_handle_t_SYSTEM_HANDLE_TOKEN: _system_handle_t = 5;
pub const _system_handle_t_SYSTEM_HANDLE_SECTION: _system_handle_t = 6;
pub const _system_handle_t_SYSTEM_HANDLE_REG_KEY: _system_handle_t = 7;
pub const _system_handle_t_SYSTEM_HANDLE_THREAD: _system_handle_t = 8;
pub const _system_handle_t_SYSTEM_HANDLE_COMPOSITION_OBJECT: _system_handle_t = 9;
pub const _system_handle_t_SYSTEM_HANDLE_SOCKET: _system_handle_t = 10;
pub const _system_handle_t_SYSTEM_HANDLE_JOB: _system_handle_t = 11;
pub const _system_handle_t_SYSTEM_HANDLE_PIPE: _system_handle_t = 12;
pub const _system_handle_t_SYSTEM_HANDLE_MAX: _system_handle_t = 12;
pub const _system_handle_t_SYSTEM_HANDLE_INVALID: _system_handle_t = 255;
pub type _system_handle_t = ::std::os::raw::c_int;
pub use self::_system_handle_t as system_handle_t;
pub const MidlInterceptionInfoVersionOne: _bindgen_ty_2 = 1;
pub type _bindgen_ty_2 = ::std::os::raw::c_int;
pub const MidlWinrtTypeSerializationInfoVersionOne: _bindgen_ty_3 = 1;
pub type _bindgen_ty_3 = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_INTERCEPTION_INFO {
    pub Version: ::std::os::raw::c_ulong,
    pub ProcString: PFORMAT_STRING,
    pub ProcFormatOffsetTable: *const ::std::os::raw::c_ushort,
    pub ProcCount: ::std::os::raw::c_ulong,
    pub TypeString: PFORMAT_STRING,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_INTERCEPTION_INFO"][::std::mem::size_of::<_MIDL_INTERCEPTION_INFO>() - 40usize];
    ["Alignment of _MIDL_INTERCEPTION_INFO"]
        [::std::mem::align_of::<_MIDL_INTERCEPTION_INFO>() - 8usize];
    ["Offset of field: _MIDL_INTERCEPTION_INFO::Version"]
        [::std::mem::offset_of!(_MIDL_INTERCEPTION_INFO, Version) - 0usize];
    ["Offset of field: _MIDL_INTERCEPTION_INFO::ProcString"]
        [::std::mem::offset_of!(_MIDL_INTERCEPTION_INFO, ProcString) - 8usize];
    ["Offset of field: _MIDL_INTERCEPTION_INFO::ProcFormatOffsetTable"]
        [::std::mem::offset_of!(_MIDL_INTERCEPTION_INFO, ProcFormatOffsetTable) - 16usize];
    ["Offset of field: _MIDL_INTERCEPTION_INFO::ProcCount"]
        [::std::mem::offset_of!(_MIDL_INTERCEPTION_INFO, ProcCount) - 24usize];
    ["Offset of field: _MIDL_INTERCEPTION_INFO::TypeString"]
        [::std::mem::offset_of!(_MIDL_INTERCEPTION_INFO, TypeString) - 32usize];
};
pub type MIDL_INTERCEPTION_INFO = _MIDL_INTERCEPTION_INFO;
pub type PMIDL_INTERCEPTION_INFO = *mut _MIDL_INTERCEPTION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MIDL_WINRT_TYPE_SERIALIZATION_INFO {
    pub Version: ::std::os::raw::c_ulong,
    pub TypeFormatString: PFORMAT_STRING,
    pub FormatStringSize: ::std::os::raw::c_ushort,
    pub TypeOffset: ::std::os::raw::c_ushort,
    pub StubDesc: PMIDL_STUB_DESC,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MIDL_WINRT_TYPE_SERIALIZATION_INFO"]
        [::std::mem::size_of::<_MIDL_WINRT_TYPE_SERIALIZATION_INFO>() - 32usize];
    ["Alignment of _MIDL_WINRT_TYPE_SERIALIZATION_INFO"]
        [::std::mem::align_of::<_MIDL_WINRT_TYPE_SERIALIZATION_INFO>() - 8usize];
    ["Offset of field: _MIDL_WINRT_TYPE_SERIALIZATION_INFO::Version"]
        [::std::mem::offset_of!(_MIDL_WINRT_TYPE_SERIALIZATION_INFO, Version) - 0usize];
    ["Offset of field: _MIDL_WINRT_TYPE_SERIALIZATION_INFO::TypeFormatString"]
        [::std::mem::offset_of!(_MIDL_WINRT_TYPE_SERIALIZATION_INFO, TypeFormatString) - 8usize];
    ["Offset of field: _MIDL_WINRT_TYPE_SERIALIZATION_INFO::FormatStringSize"]
        [::std::mem::offset_of!(_MIDL_WINRT_TYPE_SERIALIZATION_INFO, FormatStringSize) - 16usize];
    ["Offset of field: _MIDL_WINRT_TYPE_SERIALIZATION_INFO::TypeOffset"]
        [::std::mem::offset_of!(_MIDL_WINRT_TYPE_SERIALIZATION_INFO, TypeOffset) - 18usize];
    ["Offset of field: _MIDL_WINRT_TYPE_SERIALIZATION_INFO::StubDesc"]
        [::std::mem::offset_of!(_MIDL_WINRT_TYPE_SERIALIZATION_INFO, StubDesc) - 24usize];
};
pub type MIDL_WINRT_TYPE_SERIALIZATION_INFO = _MIDL_WINRT_TYPE_SERIALIZATION_INFO;
pub type PMIDL_WINRT_TYPE_SERIALIZATION_INFO = *mut _MIDL_WINRT_TYPE_SERIALIZATION_INFO;
unsafe extern "C" {
    pub fn NdrClientGetSupportedSyntaxes(
        pInf: *mut RPC_CLIENT_INTERFACE,
        pCount: *mut ::std::os::raw::c_ulong,
        pArr: *mut *mut MIDL_SYNTAX_INFO,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn NdrServerGetSupportedSyntaxes(
        pInf: *mut RPC_SERVER_INTERFACE,
        pCount: *mut ::std::os::raw::c_ulong,
        pArr: *mut *mut MIDL_SYNTAX_INFO,
        pPreferSyntaxIndex: *mut ::std::os::raw::c_ulong,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn NdrSimpleTypeMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        FormatChar: ::std::os::raw::c_uchar,
    );
}
unsafe extern "C" {
    pub fn NdrPointerMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrCsArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrCsTagMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrSimpleStructMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantStructMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingStructMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrComplexStructMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrFixedArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrVaryingArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrComplexArrayMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNonConformantStringMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantStringMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrEncapsulatedUnionMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNonEncapsulatedUnionMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrByteCountPointerMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrXmitOrRepAsMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrUserMarshalMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrInterfacePointerMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrClientContextMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ContextHandle: NDR_CCONTEXT,
        fCheck: ::std::os::raw::c_int,
    );
}
unsafe extern "C" {
    pub fn NdrServerContextMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ContextHandle: NDR_SCONTEXT,
        RundownRoutine: NDR_RUNDOWN,
    );
}
unsafe extern "C" {
    pub fn NdrServerContextNewMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ContextHandle: NDR_SCONTEXT,
        RundownRoutine: NDR_RUNDOWN,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrSimpleTypeUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        FormatChar: ::std::os::raw::c_uchar,
    );
}
unsafe extern "C" {
    pub fn NdrCsArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrCsTagUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrRangeUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrCorrelationInitialize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_void,
        CacheSize: ::std::os::raw::c_ulong,
        flags: ::std::os::raw::c_ulong,
    );
}
unsafe extern "C" {
    pub fn NdrCorrelationPass(pStubMsg: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrCorrelationFree(pStubMsg: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrPointerUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrSimpleStructUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantStructUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingStructUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrComplexStructUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrFixedArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrVaryingArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrComplexArrayUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNonConformantStringUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrConformantStringUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrEncapsulatedUnionUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNonEncapsulatedUnionUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrByteCountPointerUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrXmitOrRepAsUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrUserMarshalUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrInterfacePointerUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
        fMustAlloc: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrClientContextUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pContextHandle: *mut NDR_CCONTEXT,
        BindHandle: RPC_BINDING_HANDLE,
    );
}
unsafe extern "C" {
    pub fn NdrServerContextUnmarshall(pStubMsg: PMIDL_STUB_MESSAGE) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn NdrContextHandleInitialize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn NdrServerContextNewUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> NDR_SCONTEXT;
}
unsafe extern "C" {
    pub fn NdrPointerBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrCsArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrCsTagBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrSimpleStructBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantStructBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantVaryingStructBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrComplexStructBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrFixedArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantVaryingArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrVaryingArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrComplexArrayBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantStringBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrNonConformantStringBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrEncapsulatedUnionBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrNonEncapsulatedUnionBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrByteCountPointerBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrXmitOrRepAsBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrUserMarshalBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrInterfacePointerBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrContextHandleSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrPointerMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrContextHandleMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrCsArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrCsTagMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrSimpleStructMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrConformantStructMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingStructMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrComplexStructMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrFixedArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrConformantArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrConformantVaryingArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrVaryingArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrComplexArrayMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrConformantStringMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrNonConformantStringMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrEncapsulatedUnionMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrNonEncapsulatedUnionMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrXmitOrRepAsMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrUserMarshalMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrInterfacePointerMemorySize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn NdrPointerFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrCsArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrSimpleStructFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantStructFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantVaryingStructFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrComplexStructFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrFixedArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConformantVaryingArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrVaryingArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrComplexArrayFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrEncapsulatedUnionFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrNonEncapsulatedUnionFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrByteCountPointerFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrXmitOrRepAsFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrUserMarshalFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrInterfacePointerFree(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_uchar,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrConvert2(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
        NumberParams: ::std::os::raw::c_long,
    );
}
unsafe extern "C" {
    pub fn NdrConvert(pStubMsg: PMIDL_STUB_MESSAGE, pFormat: PFORMAT_STRING);
}
unsafe extern "C" {
    pub fn NdrUserMarshalSimpleTypeConvert(
        pFlags: *mut ::std::os::raw::c_ulong,
        pBuffer: *mut ::std::os::raw::c_uchar,
        FormatChar: ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrClientInitializeNew(
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
        ProcNum: ::std::os::raw::c_uint,
    );
}
unsafe extern "C" {
    pub fn NdrServerInitializeNew(
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrServerInitializePartial(
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
        RequestedBufferSize: ::std::os::raw::c_ulong,
    );
}
unsafe extern "C" {
    pub fn NdrClientInitialize(
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
        ProcNum: ::std::os::raw::c_uint,
    );
}
unsafe extern "C" {
    pub fn NdrServerInitialize(
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrServerInitializeUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
        pRpcMsg: PRPC_MESSAGE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrServerInitializeMarshall(pRpcMsg: PRPC_MESSAGE, pStubMsg: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrGetBuffer(
        pStubMsg: PMIDL_STUB_MESSAGE,
        BufferLength: ::std::os::raw::c_ulong,
        Handle: RPC_BINDING_HANDLE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNsGetBuffer(
        pStubMsg: PMIDL_STUB_MESSAGE,
        BufferLength: ::std::os::raw::c_ulong,
        Handle: RPC_BINDING_HANDLE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrSendReceive(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pBufferEnd: *mut ::std::os::raw::c_uchar,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrNsSendReceive(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pBufferEnd: *mut ::std::os::raw::c_uchar,
        pAutoHandle: *mut RPC_BINDING_HANDLE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn NdrFreeBuffer(pStubMsg: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrGetDcomProtocolVersion(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pVersion: *mut RPC_VERSION,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn NdrClientCall2(
        pStubDescriptor: PMIDL_STUB_DESC,
        pFormat: PFORMAT_STRING,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn NdrClientCall(
        pStubDescriptor: PMIDL_STUB_DESC,
        pFormat: PFORMAT_STRING,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn NdrAsyncClientCall(
        pStubDescriptor: PMIDL_STUB_DESC,
        pFormat: PFORMAT_STRING,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn NdrDcomAsyncClientCall(
        pStubDescriptor: PMIDL_STUB_DESC,
        pFormat: PFORMAT_STRING,
        ...
    ) -> CLIENT_CALL_RETURN;
}
pub const STUB_PHASE_STUB_UNMARSHAL: STUB_PHASE = 0;
pub const STUB_PHASE_STUB_CALL_SERVER: STUB_PHASE = 1;
pub const STUB_PHASE_STUB_MARSHAL: STUB_PHASE = 2;
pub const STUB_PHASE_STUB_CALL_SERVER_NO_HRESULT: STUB_PHASE = 3;
pub type STUB_PHASE = ::std::os::raw::c_int;
pub const PROXY_PHASE_PROXY_CALCSIZE: PROXY_PHASE = 0;
pub const PROXY_PHASE_PROXY_GETBUFFER: PROXY_PHASE = 1;
pub const PROXY_PHASE_PROXY_MARSHAL: PROXY_PHASE = 2;
pub const PROXY_PHASE_PROXY_SENDRECEIVE: PROXY_PHASE = 3;
pub const PROXY_PHASE_PROXY_UNMARSHAL: PROXY_PHASE = 4;
pub type PROXY_PHASE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn NdrAsyncServerCall(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrAsyncStubCall(
        pThis: *mut IRpcStubBuffer,
        pChannel: *mut IRpcChannelBuffer,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrDcomAsyncStubCall(
        pThis: *mut IRpcStubBuffer,
        pChannel: *mut IRpcChannelBuffer,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrStubCall2(
        pThis: *mut ::std::os::raw::c_void,
        pChannel: *mut ::std::os::raw::c_void,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrServerCall2(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrStubCall(
        pThis: *mut ::std::os::raw::c_void,
        pChannel: *mut ::std::os::raw::c_void,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrServerCall(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrServerUnmarshall(
        pChannel: *mut ::std::os::raw::c_void,
        pRpcMsg: PRPC_MESSAGE,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pStubDescriptor: PMIDL_STUB_DESC,
        pFormat: PFORMAT_STRING,
        pParamList: *mut ::std::os::raw::c_void,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn NdrServerMarshall(
        pThis: *mut ::std::os::raw::c_void,
        pChannel: *mut ::std::os::raw::c_void,
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn NdrMapCommAndFaultStatus(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pCommStatus: *mut ::std::os::raw::c_ulong,
        pFaultStatus: *mut ::std::os::raw::c_ulong,
        Status: RPC_STATUS,
    ) -> RPC_STATUS;
}
pub type RPC_SS_THREAD_HANDLE = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub fn RpcSsAllocate(Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn RpcSsDisableAllocate();
}
unsafe extern "C" {
    pub fn RpcSsEnableAllocate();
}
unsafe extern "C" {
    pub fn RpcSsFree(NodeToFree: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn RpcSsGetThreadHandle() -> RPC_SS_THREAD_HANDLE;
}
unsafe extern "C" {
    pub fn RpcSsSetClientAllocFree(
        ClientAlloc: ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        ClientFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    );
}
unsafe extern "C" {
    pub fn RpcSsSetThreadHandle(Id: RPC_SS_THREAD_HANDLE);
}
unsafe extern "C" {
    pub fn RpcSsSwapClientAllocFree(
        ClientAlloc: ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        ClientFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
        OldClientAlloc: *mut ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        OldClientFree: *mut ::std::option::Option<
            unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void),
        >,
    );
}
unsafe extern "C" {
    pub fn RpcSmAllocate(Size: usize, pStatus: *mut RPC_STATUS) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn RpcSmClientFree(pNodeToFree: *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmDestroyClientContext(ContextHandle: *mut *mut ::std::os::raw::c_void)
        -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmDisableAllocate() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmEnableAllocate() -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmFree(NodeToFree: *mut ::std::os::raw::c_void) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmGetThreadHandle(pStatus: *mut RPC_STATUS) -> RPC_SS_THREAD_HANDLE;
}
unsafe extern "C" {
    pub fn RpcSmSetClientAllocFree(
        ClientAlloc: ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        ClientFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmSetThreadHandle(Id: RPC_SS_THREAD_HANDLE) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn RpcSmSwapClientAllocFree(
        ClientAlloc: ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        ClientFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
        OldClientAlloc: *mut ::std::option::Option<
            unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void,
        >,
        OldClientFree: *mut ::std::option::Option<
            unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void),
        >,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn NdrRpcSsEnableAllocate(pMessage: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrRpcSsDisableAllocate(pMessage: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrRpcSmSetClientToOsf(pMessage: PMIDL_STUB_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrRpcSmClientAllocate(Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn NdrRpcSmClientFree(NodeToFree: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn NdrRpcSsDefaultAllocate(Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn NdrRpcSsDefaultFree(NodeToFree: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn NdrFullPointerXlatInit(
        NumberOfPointers: ::std::os::raw::c_ulong,
        XlatSide: XLAT_SIDE,
    ) -> PFULL_PTR_XLAT_TABLES;
}
unsafe extern "C" {
    pub fn NdrFullPointerXlatFree(pXlatTables: PFULL_PTR_XLAT_TABLES);
}
unsafe extern "C" {
    pub fn NdrAllocate(pStubMsg: PMIDL_STUB_MESSAGE, Len: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn NdrClearOutParameters(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pFormat: PFORMAT_STRING,
        ArgAddr: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn NdrOleAllocate(Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn NdrOleFree(NodeToFree: *mut ::std::os::raw::c_void);
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NDR_USER_MARSHAL_INFO_LEVEL1 {
    pub Buffer: *mut ::std::os::raw::c_void,
    pub BufferSize: ::std::os::raw::c_ulong,
    pub pfnAllocate:
        ::std::option::Option<unsafe extern "C" fn(arg1: usize) -> *mut ::std::os::raw::c_void>,
    pub pfnFree: ::std::option::Option<unsafe extern "C" fn(arg1: *mut ::std::os::raw::c_void)>,
    pub pRpcChannelBuffer: *mut IRpcChannelBuffer,
    pub Reserved: [ULONG_PTR; 5usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_USER_MARSHAL_INFO_LEVEL1"]
        [::std::mem::size_of::<_NDR_USER_MARSHAL_INFO_LEVEL1>() - 80usize];
    ["Alignment of _NDR_USER_MARSHAL_INFO_LEVEL1"]
        [::std::mem::align_of::<_NDR_USER_MARSHAL_INFO_LEVEL1>() - 8usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::Buffer"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, Buffer) - 0usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::BufferSize"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, BufferSize) - 8usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::pfnAllocate"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, pfnAllocate) - 16usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::pfnFree"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, pfnFree) - 24usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::pRpcChannelBuffer"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, pRpcChannelBuffer) - 32usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO_LEVEL1::Reserved"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO_LEVEL1, Reserved) - 40usize];
};
pub type NDR_USER_MARSHAL_INFO_LEVEL1 = _NDR_USER_MARSHAL_INFO_LEVEL1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _NDR_USER_MARSHAL_INFO {
    pub InformationLevel: ::std::os::raw::c_ulong,
    pub __bindgen_anon_1: _NDR_USER_MARSHAL_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _NDR_USER_MARSHAL_INFO__bindgen_ty_1 {
    pub Level1: NDR_USER_MARSHAL_INFO_LEVEL1,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_USER_MARSHAL_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_NDR_USER_MARSHAL_INFO__bindgen_ty_1>() - 80usize];
    ["Alignment of _NDR_USER_MARSHAL_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_NDR_USER_MARSHAL_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO__bindgen_ty_1::Level1"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO__bindgen_ty_1, Level1) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NDR_USER_MARSHAL_INFO"][::std::mem::size_of::<_NDR_USER_MARSHAL_INFO>() - 88usize];
    ["Alignment of _NDR_USER_MARSHAL_INFO"]
        [::std::mem::align_of::<_NDR_USER_MARSHAL_INFO>() - 8usize];
    ["Offset of field: _NDR_USER_MARSHAL_INFO::InformationLevel"]
        [::std::mem::offset_of!(_NDR_USER_MARSHAL_INFO, InformationLevel) - 0usize];
};
pub type NDR_USER_MARSHAL_INFO = _NDR_USER_MARSHAL_INFO;
unsafe extern "C" {
    pub fn NdrGetUserMarshalInfo(
        pFlags: *mut ::std::os::raw::c_ulong,
        InformationLevel: ::std::os::raw::c_ulong,
        pMarshalInfo: *mut NDR_USER_MARSHAL_INFO,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn NdrCreateServerInterfaceFromStub(
        pStub: *mut IRpcStubBuffer,
        pServerIf: *mut RPC_SERVER_INTERFACE,
    ) -> RPC_STATUS;
}
unsafe extern "C" {
    pub fn NdrClientCall3(
        pProxyInfo: *mut MIDL_STUBLESS_PROXY_INFO,
        nProcNum: ::std::os::raw::c_ulong,
        pReturnValue: *mut ::std::os::raw::c_void,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn Ndr64AsyncClientCall(
        pProxyInfo: *mut MIDL_STUBLESS_PROXY_INFO,
        nProcNum: ::std::os::raw::c_ulong,
        pReturnValue: *mut ::std::os::raw::c_void,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn Ndr64DcomAsyncClientCall(
        pProxyInfo: *mut MIDL_STUBLESS_PROXY_INFO,
        nProcNum: ::std::os::raw::c_ulong,
        pReturnValue: *mut ::std::os::raw::c_void,
        ...
    ) -> CLIENT_CALL_RETURN;
}
unsafe extern "C" {
    pub fn Ndr64AsyncServerCall(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn Ndr64AsyncServerCall64(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn Ndr64AsyncServerCallAll(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn Ndr64AsyncStubCall(
        pThis: *mut IRpcStubBuffer,
        pChannel: *mut IRpcChannelBuffer,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn Ndr64DcomAsyncStubCall(
        pThis: *mut IRpcStubBuffer,
        pChannel: *mut IRpcChannelBuffer,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrStubCall3(
        pThis: *mut ::std::os::raw::c_void,
        pChannel: *mut ::std::os::raw::c_void,
        pRpcMsg: PRPC_MESSAGE,
        pdwStubPhase: *mut ::std::os::raw::c_ulong,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn NdrServerCallAll(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrServerCallNdr64(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrServerCall3(pRpcMsg: PRPC_MESSAGE);
}
unsafe extern "C" {
    pub fn NdrPartialIgnoreClientMarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn NdrPartialIgnoreServerUnmarshall(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn NdrPartialIgnoreClientBufferSize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        pMemory: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn NdrPartialIgnoreServerInitialize(
        pStubMsg: PMIDL_STUB_MESSAGE,
        ppMemory: *mut *mut ::std::os::raw::c_void,
        pFormat: PFORMAT_STRING,
    );
}
unsafe extern "C" {
    pub fn RpcUserFree(AsyncHandle: handle_t, pBuffer: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypesbase_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypesbase_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type OLECHAR = WCHAR;
pub type LPOLESTR = *mut OLECHAR;
pub type LPCOLESTR = *const OLECHAR;
pub type DOUBLE = f64;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COAUTHIDENTITY {
    pub User: *mut USHORT,
    pub UserLength: ULONG,
    pub Domain: *mut USHORT,
    pub DomainLength: ULONG,
    pub Password: *mut USHORT,
    pub PasswordLength: ULONG,
    pub Flags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COAUTHIDENTITY"][::std::mem::size_of::<_COAUTHIDENTITY>() - 48usize];
    ["Alignment of _COAUTHIDENTITY"][::std::mem::align_of::<_COAUTHIDENTITY>() - 8usize];
    ["Offset of field: _COAUTHIDENTITY::User"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, User) - 0usize];
    ["Offset of field: _COAUTHIDENTITY::UserLength"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, UserLength) - 8usize];
    ["Offset of field: _COAUTHIDENTITY::Domain"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, Domain) - 16usize];
    ["Offset of field: _COAUTHIDENTITY::DomainLength"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, DomainLength) - 24usize];
    ["Offset of field: _COAUTHIDENTITY::Password"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, Password) - 32usize];
    ["Offset of field: _COAUTHIDENTITY::PasswordLength"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, PasswordLength) - 40usize];
    ["Offset of field: _COAUTHIDENTITY::Flags"]
        [::std::mem::offset_of!(_COAUTHIDENTITY, Flags) - 44usize];
};
pub type COAUTHIDENTITY = _COAUTHIDENTITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COAUTHINFO {
    pub dwAuthnSvc: DWORD,
    pub dwAuthzSvc: DWORD,
    pub pwszServerPrincName: LPWSTR,
    pub dwAuthnLevel: DWORD,
    pub dwImpersonationLevel: DWORD,
    pub pAuthIdentityData: *mut COAUTHIDENTITY,
    pub dwCapabilities: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COAUTHINFO"][::std::mem::size_of::<_COAUTHINFO>() - 40usize];
    ["Alignment of _COAUTHINFO"][::std::mem::align_of::<_COAUTHINFO>() - 8usize];
    ["Offset of field: _COAUTHINFO::dwAuthnSvc"]
        [::std::mem::offset_of!(_COAUTHINFO, dwAuthnSvc) - 0usize];
    ["Offset of field: _COAUTHINFO::dwAuthzSvc"]
        [::std::mem::offset_of!(_COAUTHINFO, dwAuthzSvc) - 4usize];
    ["Offset of field: _COAUTHINFO::pwszServerPrincName"]
        [::std::mem::offset_of!(_COAUTHINFO, pwszServerPrincName) - 8usize];
    ["Offset of field: _COAUTHINFO::dwAuthnLevel"]
        [::std::mem::offset_of!(_COAUTHINFO, dwAuthnLevel) - 16usize];
    ["Offset of field: _COAUTHINFO::dwImpersonationLevel"]
        [::std::mem::offset_of!(_COAUTHINFO, dwImpersonationLevel) - 20usize];
    ["Offset of field: _COAUTHINFO::pAuthIdentityData"]
        [::std::mem::offset_of!(_COAUTHINFO, pAuthIdentityData) - 24usize];
    ["Offset of field: _COAUTHINFO::dwCapabilities"]
        [::std::mem::offset_of!(_COAUTHINFO, dwCapabilities) - 32usize];
};
pub type COAUTHINFO = _COAUTHINFO;
pub type SCODE = LONG;
pub type PSCODE = *mut SCODE;
pub const tagMEMCTX_MEMCTX_TASK: tagMEMCTX = 1;
pub const tagMEMCTX_MEMCTX_SHARED: tagMEMCTX = 2;
pub const tagMEMCTX_MEMCTX_MACSYSTEM: tagMEMCTX = 3;
pub const tagMEMCTX_MEMCTX_UNKNOWN: tagMEMCTX = -1;
pub const tagMEMCTX_MEMCTX_SAME: tagMEMCTX = -2;
pub type tagMEMCTX = ::std::os::raw::c_int;
pub use self::tagMEMCTX as MEMCTX;
pub const tagCLSCTX_CLSCTX_INPROC_SERVER: tagCLSCTX = 1;
pub const tagCLSCTX_CLSCTX_INPROC_HANDLER: tagCLSCTX = 2;
pub const tagCLSCTX_CLSCTX_LOCAL_SERVER: tagCLSCTX = 4;
pub const tagCLSCTX_CLSCTX_INPROC_SERVER16: tagCLSCTX = 8;
pub const tagCLSCTX_CLSCTX_REMOTE_SERVER: tagCLSCTX = 16;
pub const tagCLSCTX_CLSCTX_INPROC_HANDLER16: tagCLSCTX = 32;
pub const tagCLSCTX_CLSCTX_RESERVED1: tagCLSCTX = 64;
pub const tagCLSCTX_CLSCTX_RESERVED2: tagCLSCTX = 128;
pub const tagCLSCTX_CLSCTX_RESERVED3: tagCLSCTX = 256;
pub const tagCLSCTX_CLSCTX_RESERVED4: tagCLSCTX = 512;
pub const tagCLSCTX_CLSCTX_NO_CODE_DOWNLOAD: tagCLSCTX = 1024;
pub const tagCLSCTX_CLSCTX_RESERVED5: tagCLSCTX = 2048;
pub const tagCLSCTX_CLSCTX_NO_CUSTOM_MARSHAL: tagCLSCTX = 4096;
pub const tagCLSCTX_CLSCTX_ENABLE_CODE_DOWNLOAD: tagCLSCTX = 8192;
pub const tagCLSCTX_CLSCTX_NO_FAILURE_LOG: tagCLSCTX = 16384;
pub const tagCLSCTX_CLSCTX_DISABLE_AAA: tagCLSCTX = 32768;
pub const tagCLSCTX_CLSCTX_ENABLE_AAA: tagCLSCTX = 65536;
pub const tagCLSCTX_CLSCTX_FROM_DEFAULT_CONTEXT: tagCLSCTX = 131072;
pub const tagCLSCTX_CLSCTX_ACTIVATE_X86_SERVER: tagCLSCTX = 262144;
pub const tagCLSCTX_CLSCTX_ACTIVATE_32_BIT_SERVER: tagCLSCTX = 262144;
pub const tagCLSCTX_CLSCTX_ACTIVATE_64_BIT_SERVER: tagCLSCTX = 524288;
pub const tagCLSCTX_CLSCTX_ENABLE_CLOAKING: tagCLSCTX = 1048576;
pub const tagCLSCTX_CLSCTX_APPCONTAINER: tagCLSCTX = 4194304;
pub const tagCLSCTX_CLSCTX_ACTIVATE_AAA_AS_IU: tagCLSCTX = 8388608;
pub const tagCLSCTX_CLSCTX_RESERVED6: tagCLSCTX = 16777216;
pub const tagCLSCTX_CLSCTX_ACTIVATE_ARM32_SERVER: tagCLSCTX = 33554432;
pub const tagCLSCTX_CLSCTX_ALLOW_LOWER_TRUST_REGISTRATION: tagCLSCTX = 67108864;
pub const tagCLSCTX_CLSCTX_PS_DLL: tagCLSCTX = -2147483648;
pub type tagCLSCTX = ::std::os::raw::c_int;
pub use self::tagCLSCTX as CLSCTX;
pub const tagMSHLFLAGS_MSHLFLAGS_NORMAL: tagMSHLFLAGS = 0;
pub const tagMSHLFLAGS_MSHLFLAGS_TABLESTRONG: tagMSHLFLAGS = 1;
pub const tagMSHLFLAGS_MSHLFLAGS_TABLEWEAK: tagMSHLFLAGS = 2;
pub const tagMSHLFLAGS_MSHLFLAGS_NOPING: tagMSHLFLAGS = 4;
pub const tagMSHLFLAGS_MSHLFLAGS_RESERVED1: tagMSHLFLAGS = 8;
pub const tagMSHLFLAGS_MSHLFLAGS_RESERVED2: tagMSHLFLAGS = 16;
pub const tagMSHLFLAGS_MSHLFLAGS_RESERVED3: tagMSHLFLAGS = 32;
pub const tagMSHLFLAGS_MSHLFLAGS_RESERVED4: tagMSHLFLAGS = 64;
pub type tagMSHLFLAGS = ::std::os::raw::c_int;
pub use self::tagMSHLFLAGS as MSHLFLAGS;
pub const tagMSHCTX_MSHCTX_LOCAL: tagMSHCTX = 0;
pub const tagMSHCTX_MSHCTX_NOSHAREDMEM: tagMSHCTX = 1;
pub const tagMSHCTX_MSHCTX_DIFFERENTMACHINE: tagMSHCTX = 2;
pub const tagMSHCTX_MSHCTX_INPROC: tagMSHCTX = 3;
pub const tagMSHCTX_MSHCTX_CROSSCTX: tagMSHCTX = 4;
pub const tagMSHCTX_MSHCTX_CONTAINER: tagMSHCTX = 5;
pub type tagMSHCTX = ::std::os::raw::c_int;
pub use self::tagMSHCTX as MSHCTX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BYTE_BLOB {
    pub clSize: ULONG,
    pub abData: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BYTE_BLOB"][::std::mem::size_of::<_BYTE_BLOB>() - 8usize];
    ["Alignment of _BYTE_BLOB"][::std::mem::align_of::<_BYTE_BLOB>() - 4usize];
    ["Offset of field: _BYTE_BLOB::clSize"][::std::mem::offset_of!(_BYTE_BLOB, clSize) - 0usize];
    ["Offset of field: _BYTE_BLOB::abData"][::std::mem::offset_of!(_BYTE_BLOB, abData) - 4usize];
};
pub type BYTE_BLOB = _BYTE_BLOB;
pub type UP_BYTE_BLOB = *mut BYTE_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WORD_BLOB {
    pub clSize: ULONG,
    pub asData: [::std::os::raw::c_ushort; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WORD_BLOB"][::std::mem::size_of::<_WORD_BLOB>() - 8usize];
    ["Alignment of _WORD_BLOB"][::std::mem::align_of::<_WORD_BLOB>() - 4usize];
    ["Offset of field: _WORD_BLOB::clSize"][::std::mem::offset_of!(_WORD_BLOB, clSize) - 0usize];
    ["Offset of field: _WORD_BLOB::asData"][::std::mem::offset_of!(_WORD_BLOB, asData) - 4usize];
};
pub type WORD_BLOB = _WORD_BLOB;
pub type UP_WORD_BLOB = *mut WORD_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DWORD_BLOB {
    pub clSize: ULONG,
    pub alData: [ULONG; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DWORD_BLOB"][::std::mem::size_of::<_DWORD_BLOB>() - 8usize];
    ["Alignment of _DWORD_BLOB"][::std::mem::align_of::<_DWORD_BLOB>() - 4usize];
    ["Offset of field: _DWORD_BLOB::clSize"][::std::mem::offset_of!(_DWORD_BLOB, clSize) - 0usize];
    ["Offset of field: _DWORD_BLOB::alData"][::std::mem::offset_of!(_DWORD_BLOB, alData) - 4usize];
};
pub type DWORD_BLOB = _DWORD_BLOB;
pub type UP_DWORD_BLOB = *mut DWORD_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FLAGGED_BYTE_BLOB {
    pub fFlags: ULONG,
    pub clSize: ULONG,
    pub abData: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FLAGGED_BYTE_BLOB"][::std::mem::size_of::<_FLAGGED_BYTE_BLOB>() - 12usize];
    ["Alignment of _FLAGGED_BYTE_BLOB"][::std::mem::align_of::<_FLAGGED_BYTE_BLOB>() - 4usize];
    ["Offset of field: _FLAGGED_BYTE_BLOB::fFlags"]
        [::std::mem::offset_of!(_FLAGGED_BYTE_BLOB, fFlags) - 0usize];
    ["Offset of field: _FLAGGED_BYTE_BLOB::clSize"]
        [::std::mem::offset_of!(_FLAGGED_BYTE_BLOB, clSize) - 4usize];
    ["Offset of field: _FLAGGED_BYTE_BLOB::abData"]
        [::std::mem::offset_of!(_FLAGGED_BYTE_BLOB, abData) - 8usize];
};
pub type FLAGGED_BYTE_BLOB = _FLAGGED_BYTE_BLOB;
pub type UP_FLAGGED_BYTE_BLOB = *mut FLAGGED_BYTE_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FLAGGED_WORD_BLOB {
    pub fFlags: ULONG,
    pub clSize: ULONG,
    pub asData: [::std::os::raw::c_ushort; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FLAGGED_WORD_BLOB"][::std::mem::size_of::<_FLAGGED_WORD_BLOB>() - 12usize];
    ["Alignment of _FLAGGED_WORD_BLOB"][::std::mem::align_of::<_FLAGGED_WORD_BLOB>() - 4usize];
    ["Offset of field: _FLAGGED_WORD_BLOB::fFlags"]
        [::std::mem::offset_of!(_FLAGGED_WORD_BLOB, fFlags) - 0usize];
    ["Offset of field: _FLAGGED_WORD_BLOB::clSize"]
        [::std::mem::offset_of!(_FLAGGED_WORD_BLOB, clSize) - 4usize];
    ["Offset of field: _FLAGGED_WORD_BLOB::asData"]
        [::std::mem::offset_of!(_FLAGGED_WORD_BLOB, asData) - 8usize];
};
pub type FLAGGED_WORD_BLOB = _FLAGGED_WORD_BLOB;
pub type UP_FLAGGED_WORD_BLOB = *mut FLAGGED_WORD_BLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BYTE_SIZEDARR {
    pub clSize: ULONG,
    pub pData: *mut byte,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BYTE_SIZEDARR"][::std::mem::size_of::<_BYTE_SIZEDARR>() - 16usize];
    ["Alignment of _BYTE_SIZEDARR"][::std::mem::align_of::<_BYTE_SIZEDARR>() - 8usize];
    ["Offset of field: _BYTE_SIZEDARR::clSize"]
        [::std::mem::offset_of!(_BYTE_SIZEDARR, clSize) - 0usize];
    ["Offset of field: _BYTE_SIZEDARR::pData"]
        [::std::mem::offset_of!(_BYTE_SIZEDARR, pData) - 8usize];
};
pub type BYTE_SIZEDARR = _BYTE_SIZEDARR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHORT_SIZEDARR {
    pub clSize: ULONG,
    pub pData: *mut ::std::os::raw::c_ushort,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHORT_SIZEDARR"][::std::mem::size_of::<_SHORT_SIZEDARR>() - 16usize];
    ["Alignment of _SHORT_SIZEDARR"][::std::mem::align_of::<_SHORT_SIZEDARR>() - 8usize];
    ["Offset of field: _SHORT_SIZEDARR::clSize"]
        [::std::mem::offset_of!(_SHORT_SIZEDARR, clSize) - 0usize];
    ["Offset of field: _SHORT_SIZEDARR::pData"]
        [::std::mem::offset_of!(_SHORT_SIZEDARR, pData) - 8usize];
};
pub type WORD_SIZEDARR = _SHORT_SIZEDARR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LONG_SIZEDARR {
    pub clSize: ULONG,
    pub pData: *mut ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LONG_SIZEDARR"][::std::mem::size_of::<_LONG_SIZEDARR>() - 16usize];
    ["Alignment of _LONG_SIZEDARR"][::std::mem::align_of::<_LONG_SIZEDARR>() - 8usize];
    ["Offset of field: _LONG_SIZEDARR::clSize"]
        [::std::mem::offset_of!(_LONG_SIZEDARR, clSize) - 0usize];
    ["Offset of field: _LONG_SIZEDARR::pData"]
        [::std::mem::offset_of!(_LONG_SIZEDARR, pData) - 8usize];
};
pub type DWORD_SIZEDARR = _LONG_SIZEDARR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HYPER_SIZEDARR {
    pub clSize: ULONG,
    pub pData: *mut ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HYPER_SIZEDARR"][::std::mem::size_of::<_HYPER_SIZEDARR>() - 16usize];
    ["Alignment of _HYPER_SIZEDARR"][::std::mem::align_of::<_HYPER_SIZEDARR>() - 8usize];
    ["Offset of field: _HYPER_SIZEDARR::clSize"]
        [::std::mem::offset_of!(_HYPER_SIZEDARR, clSize) - 0usize];
    ["Offset of field: _HYPER_SIZEDARR::pData"]
        [::std::mem::offset_of!(_HYPER_SIZEDARR, pData) - 8usize];
};
pub type HYPER_SIZEDARR = _HYPER_SIZEDARR;
unsafe extern "C" {
    pub static mut IWinTypesBase_v0_1_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut IWinTypesBase_v0_1_s_ifspec: RPC_IF_HANDLE;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBLOB {
    pub cbSize: ULONG,
    pub pBlobData: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBLOB"][::std::mem::size_of::<tagBLOB>() - 16usize];
    ["Alignment of tagBLOB"][::std::mem::align_of::<tagBLOB>() - 8usize];
    ["Offset of field: tagBLOB::cbSize"][::std::mem::offset_of!(tagBLOB, cbSize) - 0usize];
    ["Offset of field: tagBLOB::pBlobData"][::std::mem::offset_of!(tagBLOB, pBlobData) - 8usize];
};
pub type BLOB = tagBLOB;
pub type LPBLOB = *mut tagBLOB;
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypesbase_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypesbase_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypes_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypes_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemHGLOBAL {
    pub fNullHGlobal: LONG,
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemHGLOBAL"][::std::mem::size_of::<tagRemHGLOBAL>() - 12usize];
    ["Alignment of tagRemHGLOBAL"][::std::mem::align_of::<tagRemHGLOBAL>() - 4usize];
    ["Offset of field: tagRemHGLOBAL::fNullHGlobal"]
        [::std::mem::offset_of!(tagRemHGLOBAL, fNullHGlobal) - 0usize];
    ["Offset of field: tagRemHGLOBAL::cbData"]
        [::std::mem::offset_of!(tagRemHGLOBAL, cbData) - 4usize];
    ["Offset of field: tagRemHGLOBAL::data"][::std::mem::offset_of!(tagRemHGLOBAL, data) - 8usize];
};
pub type RemHGLOBAL = tagRemHGLOBAL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemHMETAFILEPICT {
    pub mm: LONG,
    pub xExt: LONG,
    pub yExt: LONG,
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemHMETAFILEPICT"][::std::mem::size_of::<tagRemHMETAFILEPICT>() - 20usize];
    ["Alignment of tagRemHMETAFILEPICT"][::std::mem::align_of::<tagRemHMETAFILEPICT>() - 4usize];
    ["Offset of field: tagRemHMETAFILEPICT::mm"]
        [::std::mem::offset_of!(tagRemHMETAFILEPICT, mm) - 0usize];
    ["Offset of field: tagRemHMETAFILEPICT::xExt"]
        [::std::mem::offset_of!(tagRemHMETAFILEPICT, xExt) - 4usize];
    ["Offset of field: tagRemHMETAFILEPICT::yExt"]
        [::std::mem::offset_of!(tagRemHMETAFILEPICT, yExt) - 8usize];
    ["Offset of field: tagRemHMETAFILEPICT::cbData"]
        [::std::mem::offset_of!(tagRemHMETAFILEPICT, cbData) - 12usize];
    ["Offset of field: tagRemHMETAFILEPICT::data"]
        [::std::mem::offset_of!(tagRemHMETAFILEPICT, data) - 16usize];
};
pub type RemHMETAFILEPICT = tagRemHMETAFILEPICT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemHENHMETAFILE {
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemHENHMETAFILE"][::std::mem::size_of::<tagRemHENHMETAFILE>() - 8usize];
    ["Alignment of tagRemHENHMETAFILE"][::std::mem::align_of::<tagRemHENHMETAFILE>() - 4usize];
    ["Offset of field: tagRemHENHMETAFILE::cbData"]
        [::std::mem::offset_of!(tagRemHENHMETAFILE, cbData) - 0usize];
    ["Offset of field: tagRemHENHMETAFILE::data"]
        [::std::mem::offset_of!(tagRemHENHMETAFILE, data) - 4usize];
};
pub type RemHENHMETAFILE = tagRemHENHMETAFILE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemHBITMAP {
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemHBITMAP"][::std::mem::size_of::<tagRemHBITMAP>() - 8usize];
    ["Alignment of tagRemHBITMAP"][::std::mem::align_of::<tagRemHBITMAP>() - 4usize];
    ["Offset of field: tagRemHBITMAP::cbData"]
        [::std::mem::offset_of!(tagRemHBITMAP, cbData) - 0usize];
    ["Offset of field: tagRemHBITMAP::data"][::std::mem::offset_of!(tagRemHBITMAP, data) - 4usize];
};
pub type RemHBITMAP = tagRemHBITMAP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemHPALETTE {
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemHPALETTE"][::std::mem::size_of::<tagRemHPALETTE>() - 8usize];
    ["Alignment of tagRemHPALETTE"][::std::mem::align_of::<tagRemHPALETTE>() - 4usize];
    ["Offset of field: tagRemHPALETTE::cbData"]
        [::std::mem::offset_of!(tagRemHPALETTE, cbData) - 0usize];
    ["Offset of field: tagRemHPALETTE::data"]
        [::std::mem::offset_of!(tagRemHPALETTE, data) - 4usize];
};
pub type RemHPALETTE = tagRemHPALETTE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemBRUSH {
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemBRUSH"][::std::mem::size_of::<tagRemBRUSH>() - 8usize];
    ["Alignment of tagRemBRUSH"][::std::mem::align_of::<tagRemBRUSH>() - 4usize];
    ["Offset of field: tagRemBRUSH::cbData"][::std::mem::offset_of!(tagRemBRUSH, cbData) - 0usize];
    ["Offset of field: tagRemBRUSH::data"][::std::mem::offset_of!(tagRemBRUSH, data) - 4usize];
};
pub type RemHBRUSH = tagRemBRUSH;
pub const tagDVASPECT_DVASPECT_CONTENT: tagDVASPECT = 1;
pub const tagDVASPECT_DVASPECT_THUMBNAIL: tagDVASPECT = 2;
pub const tagDVASPECT_DVASPECT_ICON: tagDVASPECT = 4;
pub const tagDVASPECT_DVASPECT_DOCPRINT: tagDVASPECT = 8;
pub type tagDVASPECT = ::std::os::raw::c_int;
pub use self::tagDVASPECT as DVASPECT;
pub const tagSTGC_STGC_DEFAULT: tagSTGC = 0;
pub const tagSTGC_STGC_OVERWRITE: tagSTGC = 1;
pub const tagSTGC_STGC_ONLYIFCURRENT: tagSTGC = 2;
pub const tagSTGC_STGC_DANGEROUSLYCOMMITMERELYTODISKCACHE: tagSTGC = 4;
pub const tagSTGC_STGC_CONSOLIDATE: tagSTGC = 8;
pub type tagSTGC = ::std::os::raw::c_int;
pub use self::tagSTGC as STGC;
pub const tagSTGMOVE_STGMOVE_MOVE: tagSTGMOVE = 0;
pub const tagSTGMOVE_STGMOVE_COPY: tagSTGMOVE = 1;
pub const tagSTGMOVE_STGMOVE_SHALLOWCOPY: tagSTGMOVE = 2;
pub type tagSTGMOVE = ::std::os::raw::c_int;
pub use self::tagSTGMOVE as STGMOVE;
pub const tagSTATFLAG_STATFLAG_DEFAULT: tagSTATFLAG = 0;
pub const tagSTATFLAG_STATFLAG_NONAME: tagSTATFLAG = 1;
pub const tagSTATFLAG_STATFLAG_NOOPEN: tagSTATFLAG = 2;
pub type tagSTATFLAG = ::std::os::raw::c_int;
pub use self::tagSTATFLAG as STATFLAG;
pub type HCONTEXT = *mut ::std::os::raw::c_void;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userCLIPFORMAT {
    pub fContext: LONG,
    pub u: _userCLIPFORMAT___MIDL_IWinTypes_0001,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userCLIPFORMAT___MIDL_IWinTypes_0001 {
    pub dwValue: DWORD,
    pub pwszName: *mut wchar_t,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userCLIPFORMAT___MIDL_IWinTypes_0001"]
        [::std::mem::size_of::<_userCLIPFORMAT___MIDL_IWinTypes_0001>() - 8usize];
    ["Alignment of _userCLIPFORMAT___MIDL_IWinTypes_0001"]
        [::std::mem::align_of::<_userCLIPFORMAT___MIDL_IWinTypes_0001>() - 8usize];
    ["Offset of field: _userCLIPFORMAT___MIDL_IWinTypes_0001::dwValue"]
        [::std::mem::offset_of!(_userCLIPFORMAT___MIDL_IWinTypes_0001, dwValue) - 0usize];
    ["Offset of field: _userCLIPFORMAT___MIDL_IWinTypes_0001::pwszName"]
        [::std::mem::offset_of!(_userCLIPFORMAT___MIDL_IWinTypes_0001, pwszName) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userCLIPFORMAT"][::std::mem::size_of::<_userCLIPFORMAT>() - 16usize];
    ["Alignment of _userCLIPFORMAT"][::std::mem::align_of::<_userCLIPFORMAT>() - 8usize];
    ["Offset of field: _userCLIPFORMAT::fContext"]
        [::std::mem::offset_of!(_userCLIPFORMAT, fContext) - 0usize];
    ["Offset of field: _userCLIPFORMAT::u"][::std::mem::offset_of!(_userCLIPFORMAT, u) - 8usize];
};
pub type userCLIPFORMAT = _userCLIPFORMAT;
pub type wireCLIPFORMAT = *mut userCLIPFORMAT;
pub type CLIPFORMAT = WORD;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _GDI_NONREMOTE {
    pub fContext: LONG,
    pub u: _GDI_NONREMOTE___MIDL_IWinTypes_0002,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _GDI_NONREMOTE___MIDL_IWinTypes_0002 {
    pub hInproc: LONG,
    pub hRemote: *mut DWORD_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GDI_NONREMOTE___MIDL_IWinTypes_0002"]
        [::std::mem::size_of::<_GDI_NONREMOTE___MIDL_IWinTypes_0002>() - 8usize];
    ["Alignment of _GDI_NONREMOTE___MIDL_IWinTypes_0002"]
        [::std::mem::align_of::<_GDI_NONREMOTE___MIDL_IWinTypes_0002>() - 8usize];
    ["Offset of field: _GDI_NONREMOTE___MIDL_IWinTypes_0002::hInproc"]
        [::std::mem::offset_of!(_GDI_NONREMOTE___MIDL_IWinTypes_0002, hInproc) - 0usize];
    ["Offset of field: _GDI_NONREMOTE___MIDL_IWinTypes_0002::hRemote"]
        [::std::mem::offset_of!(_GDI_NONREMOTE___MIDL_IWinTypes_0002, hRemote) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GDI_NONREMOTE"][::std::mem::size_of::<_GDI_NONREMOTE>() - 16usize];
    ["Alignment of _GDI_NONREMOTE"][::std::mem::align_of::<_GDI_NONREMOTE>() - 8usize];
    ["Offset of field: _GDI_NONREMOTE::fContext"]
        [::std::mem::offset_of!(_GDI_NONREMOTE, fContext) - 0usize];
    ["Offset of field: _GDI_NONREMOTE::u"][::std::mem::offset_of!(_GDI_NONREMOTE, u) - 8usize];
};
pub type GDI_NONREMOTE = _GDI_NONREMOTE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHGLOBAL {
    pub fContext: LONG,
    pub u: _userHGLOBAL___MIDL_IWinTypes_0003,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHGLOBAL___MIDL_IWinTypes_0003 {
    pub hInproc: LONG,
    pub hRemote: *mut FLAGGED_BYTE_BLOB,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHGLOBAL___MIDL_IWinTypes_0003"]
        [::std::mem::size_of::<_userHGLOBAL___MIDL_IWinTypes_0003>() - 8usize];
    ["Alignment of _userHGLOBAL___MIDL_IWinTypes_0003"]
        [::std::mem::align_of::<_userHGLOBAL___MIDL_IWinTypes_0003>() - 8usize];
    ["Offset of field: _userHGLOBAL___MIDL_IWinTypes_0003::hInproc"]
        [::std::mem::offset_of!(_userHGLOBAL___MIDL_IWinTypes_0003, hInproc) - 0usize];
    ["Offset of field: _userHGLOBAL___MIDL_IWinTypes_0003::hRemote"]
        [::std::mem::offset_of!(_userHGLOBAL___MIDL_IWinTypes_0003, hRemote) - 0usize];
    ["Offset of field: _userHGLOBAL___MIDL_IWinTypes_0003::hInproc64"]
        [::std::mem::offset_of!(_userHGLOBAL___MIDL_IWinTypes_0003, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHGLOBAL"][::std::mem::size_of::<_userHGLOBAL>() - 16usize];
    ["Alignment of _userHGLOBAL"][::std::mem::align_of::<_userHGLOBAL>() - 8usize];
    ["Offset of field: _userHGLOBAL::fContext"]
        [::std::mem::offset_of!(_userHGLOBAL, fContext) - 0usize];
    ["Offset of field: _userHGLOBAL::u"][::std::mem::offset_of!(_userHGLOBAL, u) - 8usize];
};
pub type userHGLOBAL = _userHGLOBAL;
pub type wireHGLOBAL = *mut userHGLOBAL;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHMETAFILE {
    pub fContext: LONG,
    pub u: _userHMETAFILE___MIDL_IWinTypes_0004,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHMETAFILE___MIDL_IWinTypes_0004 {
    pub hInproc: LONG,
    pub hRemote: *mut BYTE_BLOB,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHMETAFILE___MIDL_IWinTypes_0004"]
        [::std::mem::size_of::<_userHMETAFILE___MIDL_IWinTypes_0004>() - 8usize];
    ["Alignment of _userHMETAFILE___MIDL_IWinTypes_0004"]
        [::std::mem::align_of::<_userHMETAFILE___MIDL_IWinTypes_0004>() - 8usize];
    ["Offset of field: _userHMETAFILE___MIDL_IWinTypes_0004::hInproc"]
        [::std::mem::offset_of!(_userHMETAFILE___MIDL_IWinTypes_0004, hInproc) - 0usize];
    ["Offset of field: _userHMETAFILE___MIDL_IWinTypes_0004::hRemote"]
        [::std::mem::offset_of!(_userHMETAFILE___MIDL_IWinTypes_0004, hRemote) - 0usize];
    ["Offset of field: _userHMETAFILE___MIDL_IWinTypes_0004::hInproc64"]
        [::std::mem::offset_of!(_userHMETAFILE___MIDL_IWinTypes_0004, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHMETAFILE"][::std::mem::size_of::<_userHMETAFILE>() - 16usize];
    ["Alignment of _userHMETAFILE"][::std::mem::align_of::<_userHMETAFILE>() - 8usize];
    ["Offset of field: _userHMETAFILE::fContext"]
        [::std::mem::offset_of!(_userHMETAFILE, fContext) - 0usize];
    ["Offset of field: _userHMETAFILE::u"][::std::mem::offset_of!(_userHMETAFILE, u) - 8usize];
};
pub type userHMETAFILE = _userHMETAFILE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _remoteMETAFILEPICT {
    pub mm: LONG,
    pub xExt: LONG,
    pub yExt: LONG,
    pub hMF: *mut userHMETAFILE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _remoteMETAFILEPICT"][::std::mem::size_of::<_remoteMETAFILEPICT>() - 24usize];
    ["Alignment of _remoteMETAFILEPICT"][::std::mem::align_of::<_remoteMETAFILEPICT>() - 8usize];
    ["Offset of field: _remoteMETAFILEPICT::mm"]
        [::std::mem::offset_of!(_remoteMETAFILEPICT, mm) - 0usize];
    ["Offset of field: _remoteMETAFILEPICT::xExt"]
        [::std::mem::offset_of!(_remoteMETAFILEPICT, xExt) - 4usize];
    ["Offset of field: _remoteMETAFILEPICT::yExt"]
        [::std::mem::offset_of!(_remoteMETAFILEPICT, yExt) - 8usize];
    ["Offset of field: _remoteMETAFILEPICT::hMF"]
        [::std::mem::offset_of!(_remoteMETAFILEPICT, hMF) - 16usize];
};
pub type remoteMETAFILEPICT = _remoteMETAFILEPICT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHMETAFILEPICT {
    pub fContext: LONG,
    pub u: _userHMETAFILEPICT___MIDL_IWinTypes_0005,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHMETAFILEPICT___MIDL_IWinTypes_0005 {
    pub hInproc: LONG,
    pub hRemote: *mut remoteMETAFILEPICT,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHMETAFILEPICT___MIDL_IWinTypes_0005"]
        [::std::mem::size_of::<_userHMETAFILEPICT___MIDL_IWinTypes_0005>() - 8usize];
    ["Alignment of _userHMETAFILEPICT___MIDL_IWinTypes_0005"]
        [::std::mem::align_of::<_userHMETAFILEPICT___MIDL_IWinTypes_0005>() - 8usize];
    ["Offset of field: _userHMETAFILEPICT___MIDL_IWinTypes_0005::hInproc"]
        [::std::mem::offset_of!(_userHMETAFILEPICT___MIDL_IWinTypes_0005, hInproc) - 0usize];
    ["Offset of field: _userHMETAFILEPICT___MIDL_IWinTypes_0005::hRemote"]
        [::std::mem::offset_of!(_userHMETAFILEPICT___MIDL_IWinTypes_0005, hRemote) - 0usize];
    ["Offset of field: _userHMETAFILEPICT___MIDL_IWinTypes_0005::hInproc64"]
        [::std::mem::offset_of!(_userHMETAFILEPICT___MIDL_IWinTypes_0005, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHMETAFILEPICT"][::std::mem::size_of::<_userHMETAFILEPICT>() - 16usize];
    ["Alignment of _userHMETAFILEPICT"][::std::mem::align_of::<_userHMETAFILEPICT>() - 8usize];
    ["Offset of field: _userHMETAFILEPICT::fContext"]
        [::std::mem::offset_of!(_userHMETAFILEPICT, fContext) - 0usize];
    ["Offset of field: _userHMETAFILEPICT::u"]
        [::std::mem::offset_of!(_userHMETAFILEPICT, u) - 8usize];
};
pub type userHMETAFILEPICT = _userHMETAFILEPICT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHENHMETAFILE {
    pub fContext: LONG,
    pub u: _userHENHMETAFILE___MIDL_IWinTypes_0006,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHENHMETAFILE___MIDL_IWinTypes_0006 {
    pub hInproc: LONG,
    pub hRemote: *mut BYTE_BLOB,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHENHMETAFILE___MIDL_IWinTypes_0006"]
        [::std::mem::size_of::<_userHENHMETAFILE___MIDL_IWinTypes_0006>() - 8usize];
    ["Alignment of _userHENHMETAFILE___MIDL_IWinTypes_0006"]
        [::std::mem::align_of::<_userHENHMETAFILE___MIDL_IWinTypes_0006>() - 8usize];
    ["Offset of field: _userHENHMETAFILE___MIDL_IWinTypes_0006::hInproc"]
        [::std::mem::offset_of!(_userHENHMETAFILE___MIDL_IWinTypes_0006, hInproc) - 0usize];
    ["Offset of field: _userHENHMETAFILE___MIDL_IWinTypes_0006::hRemote"]
        [::std::mem::offset_of!(_userHENHMETAFILE___MIDL_IWinTypes_0006, hRemote) - 0usize];
    ["Offset of field: _userHENHMETAFILE___MIDL_IWinTypes_0006::hInproc64"]
        [::std::mem::offset_of!(_userHENHMETAFILE___MIDL_IWinTypes_0006, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHENHMETAFILE"][::std::mem::size_of::<_userHENHMETAFILE>() - 16usize];
    ["Alignment of _userHENHMETAFILE"][::std::mem::align_of::<_userHENHMETAFILE>() - 8usize];
    ["Offset of field: _userHENHMETAFILE::fContext"]
        [::std::mem::offset_of!(_userHENHMETAFILE, fContext) - 0usize];
    ["Offset of field: _userHENHMETAFILE::u"]
        [::std::mem::offset_of!(_userHENHMETAFILE, u) - 8usize];
};
pub type userHENHMETAFILE = _userHENHMETAFILE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _userBITMAP {
    pub bmType: LONG,
    pub bmWidth: LONG,
    pub bmHeight: LONG,
    pub bmWidthBytes: LONG,
    pub bmPlanes: WORD,
    pub bmBitsPixel: WORD,
    pub cbSize: ULONG,
    pub pBuffer: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userBITMAP"][::std::mem::size_of::<_userBITMAP>() - 28usize];
    ["Alignment of _userBITMAP"][::std::mem::align_of::<_userBITMAP>() - 4usize];
    ["Offset of field: _userBITMAP::bmType"][::std::mem::offset_of!(_userBITMAP, bmType) - 0usize];
    ["Offset of field: _userBITMAP::bmWidth"]
        [::std::mem::offset_of!(_userBITMAP, bmWidth) - 4usize];
    ["Offset of field: _userBITMAP::bmHeight"]
        [::std::mem::offset_of!(_userBITMAP, bmHeight) - 8usize];
    ["Offset of field: _userBITMAP::bmWidthBytes"]
        [::std::mem::offset_of!(_userBITMAP, bmWidthBytes) - 12usize];
    ["Offset of field: _userBITMAP::bmPlanes"]
        [::std::mem::offset_of!(_userBITMAP, bmPlanes) - 16usize];
    ["Offset of field: _userBITMAP::bmBitsPixel"]
        [::std::mem::offset_of!(_userBITMAP, bmBitsPixel) - 18usize];
    ["Offset of field: _userBITMAP::cbSize"][::std::mem::offset_of!(_userBITMAP, cbSize) - 20usize];
    ["Offset of field: _userBITMAP::pBuffer"]
        [::std::mem::offset_of!(_userBITMAP, pBuffer) - 24usize];
};
pub type userBITMAP = _userBITMAP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHBITMAP {
    pub fContext: LONG,
    pub u: _userHBITMAP___MIDL_IWinTypes_0007,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHBITMAP___MIDL_IWinTypes_0007 {
    pub hInproc: LONG,
    pub hRemote: *mut userBITMAP,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHBITMAP___MIDL_IWinTypes_0007"]
        [::std::mem::size_of::<_userHBITMAP___MIDL_IWinTypes_0007>() - 8usize];
    ["Alignment of _userHBITMAP___MIDL_IWinTypes_0007"]
        [::std::mem::align_of::<_userHBITMAP___MIDL_IWinTypes_0007>() - 8usize];
    ["Offset of field: _userHBITMAP___MIDL_IWinTypes_0007::hInproc"]
        [::std::mem::offset_of!(_userHBITMAP___MIDL_IWinTypes_0007, hInproc) - 0usize];
    ["Offset of field: _userHBITMAP___MIDL_IWinTypes_0007::hRemote"]
        [::std::mem::offset_of!(_userHBITMAP___MIDL_IWinTypes_0007, hRemote) - 0usize];
    ["Offset of field: _userHBITMAP___MIDL_IWinTypes_0007::hInproc64"]
        [::std::mem::offset_of!(_userHBITMAP___MIDL_IWinTypes_0007, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHBITMAP"][::std::mem::size_of::<_userHBITMAP>() - 16usize];
    ["Alignment of _userHBITMAP"][::std::mem::align_of::<_userHBITMAP>() - 8usize];
    ["Offset of field: _userHBITMAP::fContext"]
        [::std::mem::offset_of!(_userHBITMAP, fContext) - 0usize];
    ["Offset of field: _userHBITMAP::u"][::std::mem::offset_of!(_userHBITMAP, u) - 8usize];
};
pub type userHBITMAP = _userHBITMAP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userHPALETTE {
    pub fContext: LONG,
    pub u: _userHPALETTE___MIDL_IWinTypes_0008,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userHPALETTE___MIDL_IWinTypes_0008 {
    pub hInproc: LONG,
    pub hRemote: *mut LOGPALETTE,
    pub hInproc64: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHPALETTE___MIDL_IWinTypes_0008"]
        [::std::mem::size_of::<_userHPALETTE___MIDL_IWinTypes_0008>() - 8usize];
    ["Alignment of _userHPALETTE___MIDL_IWinTypes_0008"]
        [::std::mem::align_of::<_userHPALETTE___MIDL_IWinTypes_0008>() - 8usize];
    ["Offset of field: _userHPALETTE___MIDL_IWinTypes_0008::hInproc"]
        [::std::mem::offset_of!(_userHPALETTE___MIDL_IWinTypes_0008, hInproc) - 0usize];
    ["Offset of field: _userHPALETTE___MIDL_IWinTypes_0008::hRemote"]
        [::std::mem::offset_of!(_userHPALETTE___MIDL_IWinTypes_0008, hRemote) - 0usize];
    ["Offset of field: _userHPALETTE___MIDL_IWinTypes_0008::hInproc64"]
        [::std::mem::offset_of!(_userHPALETTE___MIDL_IWinTypes_0008, hInproc64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userHPALETTE"][::std::mem::size_of::<_userHPALETTE>() - 16usize];
    ["Alignment of _userHPALETTE"][::std::mem::align_of::<_userHPALETTE>() - 8usize];
    ["Offset of field: _userHPALETTE::fContext"]
        [::std::mem::offset_of!(_userHPALETTE, fContext) - 0usize];
    ["Offset of field: _userHPALETTE::u"][::std::mem::offset_of!(_userHPALETTE, u) - 8usize];
};
pub type userHPALETTE = _userHPALETTE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RemotableHandle {
    pub fContext: LONG,
    pub u: _RemotableHandle___MIDL_IWinTypes_0009,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _RemotableHandle___MIDL_IWinTypes_0009 {
    pub hInproc: LONG,
    pub hRemote: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RemotableHandle___MIDL_IWinTypes_0009"]
        [::std::mem::size_of::<_RemotableHandle___MIDL_IWinTypes_0009>() - 4usize];
    ["Alignment of _RemotableHandle___MIDL_IWinTypes_0009"]
        [::std::mem::align_of::<_RemotableHandle___MIDL_IWinTypes_0009>() - 4usize];
    ["Offset of field: _RemotableHandle___MIDL_IWinTypes_0009::hInproc"]
        [::std::mem::offset_of!(_RemotableHandle___MIDL_IWinTypes_0009, hInproc) - 0usize];
    ["Offset of field: _RemotableHandle___MIDL_IWinTypes_0009::hRemote"]
        [::std::mem::offset_of!(_RemotableHandle___MIDL_IWinTypes_0009, hRemote) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RemotableHandle"][::std::mem::size_of::<_RemotableHandle>() - 8usize];
    ["Alignment of _RemotableHandle"][::std::mem::align_of::<_RemotableHandle>() - 4usize];
    ["Offset of field: _RemotableHandle::fContext"]
        [::std::mem::offset_of!(_RemotableHandle, fContext) - 0usize];
    ["Offset of field: _RemotableHandle::u"][::std::mem::offset_of!(_RemotableHandle, u) - 4usize];
};
pub type RemotableHandle = _RemotableHandle;
pub type wireHWND = *mut RemotableHandle;
pub type wireHMENU = *mut RemotableHandle;
pub type wireHACCEL = *mut RemotableHandle;
pub type wireHBRUSH = *mut RemotableHandle;
pub type wireHFONT = *mut RemotableHandle;
pub type wireHDC = *mut RemotableHandle;
pub type wireHICON = *mut RemotableHandle;
pub type wireHRGN = *mut RemotableHandle;
pub type wireHMONITOR = *mut RemotableHandle;
pub type wireHBITMAP = *mut userHBITMAP;
pub type wireHPALETTE = *mut userHPALETTE;
pub type wireHENHMETAFILE = *mut userHENHMETAFILE;
pub type wireHMETAFILE = *mut userHMETAFILE;
pub type wireHMETAFILEPICT = *mut userHMETAFILEPICT;
pub type HMETAFILEPICT = *mut ::std::os::raw::c_void;
unsafe extern "C" {
    pub static mut IWinTypes_v0_1_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut IWinTypes_v0_1_s_ifspec: RPC_IF_HANDLE;
}
pub type DATE = f64;
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagCY {
    pub __bindgen_anon_1: tagCY__bindgen_ty_1,
    pub int64: LONGLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCY__bindgen_ty_1 {
    pub Lo: ULONG,
    pub Hi: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCY__bindgen_ty_1"][::std::mem::size_of::<tagCY__bindgen_ty_1>() - 8usize];
    ["Alignment of tagCY__bindgen_ty_1"][::std::mem::align_of::<tagCY__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagCY__bindgen_ty_1::Lo"]
        [::std::mem::offset_of!(tagCY__bindgen_ty_1, Lo) - 0usize];
    ["Offset of field: tagCY__bindgen_ty_1::Hi"]
        [::std::mem::offset_of!(tagCY__bindgen_ty_1, Hi) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCY"][::std::mem::size_of::<tagCY>() - 8usize];
    ["Alignment of tagCY"][::std::mem::align_of::<tagCY>() - 8usize];
    ["Offset of field: tagCY::int64"][::std::mem::offset_of!(tagCY, int64) - 0usize];
};
pub type CY = tagCY;
pub type LPCY = *mut CY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagDEC {
    pub wReserved: USHORT,
    pub __bindgen_anon_1: tagDEC__bindgen_ty_1,
    pub Hi32: ULONG,
    pub __bindgen_anon_2: tagDEC__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagDEC__bindgen_ty_1 {
    pub __bindgen_anon_1: tagDEC__bindgen_ty_1__bindgen_ty_1,
    pub signscale: USHORT,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDEC__bindgen_ty_1__bindgen_ty_1 {
    pub scale: BYTE,
    pub sign: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEC__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagDEC__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Alignment of tagDEC__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagDEC__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: tagDEC__bindgen_ty_1__bindgen_ty_1::scale"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_1__bindgen_ty_1, scale) - 0usize];
    ["Offset of field: tagDEC__bindgen_ty_1__bindgen_ty_1::sign"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_1__bindgen_ty_1, sign) - 1usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEC__bindgen_ty_1"][::std::mem::size_of::<tagDEC__bindgen_ty_1>() - 2usize];
    ["Alignment of tagDEC__bindgen_ty_1"][::std::mem::align_of::<tagDEC__bindgen_ty_1>() - 2usize];
    ["Offset of field: tagDEC__bindgen_ty_1::signscale"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_1, signscale) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagDEC__bindgen_ty_2 {
    pub __bindgen_anon_1: tagDEC__bindgen_ty_2__bindgen_ty_1,
    pub Lo64: ULONGLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDEC__bindgen_ty_2__bindgen_ty_1 {
    pub Lo32: ULONG,
    pub Mid32: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEC__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::size_of::<tagDEC__bindgen_ty_2__bindgen_ty_1>() - 8usize];
    ["Alignment of tagDEC__bindgen_ty_2__bindgen_ty_1"]
        [::std::mem::align_of::<tagDEC__bindgen_ty_2__bindgen_ty_1>() - 4usize];
    ["Offset of field: tagDEC__bindgen_ty_2__bindgen_ty_1::Lo32"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_2__bindgen_ty_1, Lo32) - 0usize];
    ["Offset of field: tagDEC__bindgen_ty_2__bindgen_ty_1::Mid32"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_2__bindgen_ty_1, Mid32) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEC__bindgen_ty_2"][::std::mem::size_of::<tagDEC__bindgen_ty_2>() - 8usize];
    ["Alignment of tagDEC__bindgen_ty_2"][::std::mem::align_of::<tagDEC__bindgen_ty_2>() - 8usize];
    ["Offset of field: tagDEC__bindgen_ty_2::Lo64"]
        [::std::mem::offset_of!(tagDEC__bindgen_ty_2, Lo64) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEC"][::std::mem::size_of::<tagDEC>() - 16usize];
    ["Alignment of tagDEC"][::std::mem::align_of::<tagDEC>() - 8usize];
    ["Offset of field: tagDEC::wReserved"][::std::mem::offset_of!(tagDEC, wReserved) - 0usize];
    ["Offset of field: tagDEC::Hi32"][::std::mem::offset_of!(tagDEC, Hi32) - 4usize];
};
pub type DECIMAL = tagDEC;
pub type LPDECIMAL = *mut DECIMAL;
pub type wireBSTR = *mut FLAGGED_WORD_BLOB;
pub type BSTR = *mut OLECHAR;
pub type LPBSTR = *mut BSTR;
pub type VARIANT_BOOL = ::std::os::raw::c_short;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBSTRBLOB {
    pub cbSize: ULONG,
    pub pData: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBSTRBLOB"][::std::mem::size_of::<tagBSTRBLOB>() - 16usize];
    ["Alignment of tagBSTRBLOB"][::std::mem::align_of::<tagBSTRBLOB>() - 8usize];
    ["Offset of field: tagBSTRBLOB::cbSize"][::std::mem::offset_of!(tagBSTRBLOB, cbSize) - 0usize];
    ["Offset of field: tagBSTRBLOB::pData"][::std::mem::offset_of!(tagBSTRBLOB, pData) - 8usize];
};
pub type BSTRBLOB = tagBSTRBLOB;
pub type LPBSTRBLOB = *mut tagBSTRBLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCLIPDATA {
    pub cbSize: ULONG,
    pub ulClipFmt: LONG,
    pub pClipData: *mut BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCLIPDATA"][::std::mem::size_of::<tagCLIPDATA>() - 16usize];
    ["Alignment of tagCLIPDATA"][::std::mem::align_of::<tagCLIPDATA>() - 8usize];
    ["Offset of field: tagCLIPDATA::cbSize"][::std::mem::offset_of!(tagCLIPDATA, cbSize) - 0usize];
    ["Offset of field: tagCLIPDATA::ulClipFmt"]
        [::std::mem::offset_of!(tagCLIPDATA, ulClipFmt) - 4usize];
    ["Offset of field: tagCLIPDATA::pClipData"]
        [::std::mem::offset_of!(tagCLIPDATA, pClipData) - 8usize];
};
pub type CLIPDATA = tagCLIPDATA;
pub type VARTYPE = ::std::os::raw::c_ushort;
pub const VARENUM_VT_EMPTY: VARENUM = 0;
pub const VARENUM_VT_NULL: VARENUM = 1;
pub const VARENUM_VT_I2: VARENUM = 2;
pub const VARENUM_VT_I4: VARENUM = 3;
pub const VARENUM_VT_R4: VARENUM = 4;
pub const VARENUM_VT_R8: VARENUM = 5;
pub const VARENUM_VT_CY: VARENUM = 6;
pub const VARENUM_VT_DATE: VARENUM = 7;
pub const VARENUM_VT_BSTR: VARENUM = 8;
pub const VARENUM_VT_DISPATCH: VARENUM = 9;
pub const VARENUM_VT_ERROR: VARENUM = 10;
pub const VARENUM_VT_BOOL: VARENUM = 11;
pub const VARENUM_VT_VARIANT: VARENUM = 12;
pub const VARENUM_VT_UNKNOWN: VARENUM = 13;
pub const VARENUM_VT_DECIMAL: VARENUM = 14;
pub const VARENUM_VT_I1: VARENUM = 16;
pub const VARENUM_VT_UI1: VARENUM = 17;
pub const VARENUM_VT_UI2: VARENUM = 18;
pub const VARENUM_VT_UI4: VARENUM = 19;
pub const VARENUM_VT_I8: VARENUM = 20;
pub const VARENUM_VT_UI8: VARENUM = 21;
pub const VARENUM_VT_INT: VARENUM = 22;
pub const VARENUM_VT_UINT: VARENUM = 23;
pub const VARENUM_VT_VOID: VARENUM = 24;
pub const VARENUM_VT_HRESULT: VARENUM = 25;
pub const VARENUM_VT_PTR: VARENUM = 26;
pub const VARENUM_VT_SAFEARRAY: VARENUM = 27;
pub const VARENUM_VT_CARRAY: VARENUM = 28;
pub const VARENUM_VT_USERDEFINED: VARENUM = 29;
pub const VARENUM_VT_LPSTR: VARENUM = 30;
pub const VARENUM_VT_LPWSTR: VARENUM = 31;
pub const VARENUM_VT_RECORD: VARENUM = 36;
pub const VARENUM_VT_INT_PTR: VARENUM = 37;
pub const VARENUM_VT_UINT_PTR: VARENUM = 38;
pub const VARENUM_VT_FILETIME: VARENUM = 64;
pub const VARENUM_VT_BLOB: VARENUM = 65;
pub const VARENUM_VT_STREAM: VARENUM = 66;
pub const VARENUM_VT_STORAGE: VARENUM = 67;
pub const VARENUM_VT_STREAMED_OBJECT: VARENUM = 68;
pub const VARENUM_VT_STORED_OBJECT: VARENUM = 69;
pub const VARENUM_VT_BLOB_OBJECT: VARENUM = 70;
pub const VARENUM_VT_CF: VARENUM = 71;
pub const VARENUM_VT_CLSID: VARENUM = 72;
pub const VARENUM_VT_VERSIONED_STREAM: VARENUM = 73;
pub const VARENUM_VT_BSTR_BLOB: VARENUM = 4095;
pub const VARENUM_VT_VECTOR: VARENUM = 4096;
pub const VARENUM_VT_ARRAY: VARENUM = 8192;
pub const VARENUM_VT_BYREF: VARENUM = 16384;
pub const VARENUM_VT_RESERVED: VARENUM = 32768;
pub const VARENUM_VT_ILLEGAL: VARENUM = 65535;
pub const VARENUM_VT_ILLEGALMASKED: VARENUM = 4095;
pub const VARENUM_VT_TYPEMASK: VARENUM = 4095;
pub type VARENUM = ::std::os::raw::c_int;
pub type PROPID = ULONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagpropertykey {
    pub fmtid: GUID,
    pub pid: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagpropertykey"][::std::mem::size_of::<_tagpropertykey>() - 20usize];
    ["Alignment of _tagpropertykey"][::std::mem::align_of::<_tagpropertykey>() - 4usize];
    ["Offset of field: _tagpropertykey::fmtid"]
        [::std::mem::offset_of!(_tagpropertykey, fmtid) - 0usize];
    ["Offset of field: _tagpropertykey::pid"]
        [::std::mem::offset_of!(_tagpropertykey, pid) - 16usize];
};
pub type PROPERTYKEY = _tagpropertykey;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCSPLATFORM {
    pub dwPlatformId: DWORD,
    pub dwVersionHi: DWORD,
    pub dwVersionLo: DWORD,
    pub dwProcessorArch: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCSPLATFORM"][::std::mem::size_of::<tagCSPLATFORM>() - 16usize];
    ["Alignment of tagCSPLATFORM"][::std::mem::align_of::<tagCSPLATFORM>() - 4usize];
    ["Offset of field: tagCSPLATFORM::dwPlatformId"]
        [::std::mem::offset_of!(tagCSPLATFORM, dwPlatformId) - 0usize];
    ["Offset of field: tagCSPLATFORM::dwVersionHi"]
        [::std::mem::offset_of!(tagCSPLATFORM, dwVersionHi) - 4usize];
    ["Offset of field: tagCSPLATFORM::dwVersionLo"]
        [::std::mem::offset_of!(tagCSPLATFORM, dwVersionLo) - 8usize];
    ["Offset of field: tagCSPLATFORM::dwProcessorArch"]
        [::std::mem::offset_of!(tagCSPLATFORM, dwProcessorArch) - 12usize];
};
pub type CSPLATFORM = tagCSPLATFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagQUERYCONTEXT {
    pub dwContext: DWORD,
    pub Platform: CSPLATFORM,
    pub Locale: LCID,
    pub dwVersionHi: DWORD,
    pub dwVersionLo: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagQUERYCONTEXT"][::std::mem::size_of::<tagQUERYCONTEXT>() - 32usize];
    ["Alignment of tagQUERYCONTEXT"][::std::mem::align_of::<tagQUERYCONTEXT>() - 4usize];
    ["Offset of field: tagQUERYCONTEXT::dwContext"]
        [::std::mem::offset_of!(tagQUERYCONTEXT, dwContext) - 0usize];
    ["Offset of field: tagQUERYCONTEXT::Platform"]
        [::std::mem::offset_of!(tagQUERYCONTEXT, Platform) - 4usize];
    ["Offset of field: tagQUERYCONTEXT::Locale"]
        [::std::mem::offset_of!(tagQUERYCONTEXT, Locale) - 20usize];
    ["Offset of field: tagQUERYCONTEXT::dwVersionHi"]
        [::std::mem::offset_of!(tagQUERYCONTEXT, dwVersionHi) - 24usize];
    ["Offset of field: tagQUERYCONTEXT::dwVersionLo"]
        [::std::mem::offset_of!(tagQUERYCONTEXT, dwVersionLo) - 28usize];
};
pub type QUERYCONTEXT = tagQUERYCONTEXT;
pub const tagTYSPEC_TYSPEC_CLSID: tagTYSPEC = 0;
pub const tagTYSPEC_TYSPEC_FILEEXT: tagTYSPEC = 1;
pub const tagTYSPEC_TYSPEC_MIMETYPE: tagTYSPEC = 2;
pub const tagTYSPEC_TYSPEC_FILENAME: tagTYSPEC = 3;
pub const tagTYSPEC_TYSPEC_PROGID: tagTYSPEC = 4;
pub const tagTYSPEC_TYSPEC_PACKAGENAME: tagTYSPEC = 5;
pub const tagTYSPEC_TYSPEC_OBJECTID: tagTYSPEC = 6;
pub type tagTYSPEC = ::std::os::raw::c_int;
pub use self::tagTYSPEC as TYSPEC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct __MIDL___MIDL_itf_wtypes_0000_0001_0001 {
    pub tyspec: DWORD,
    pub tagged_union:
        __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 { pub clsid : CLSID , pub pFileExt : LPOLESTR , pub pMimeType : LPOLESTR , pub pProgId : LPOLESTR , pub pFileName : LPOLESTR , pub ByName : __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1 , pub ByObjectId : __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2 , }
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1
{
    pub pPackageName: LPOLESTR,
    pub PolicyId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1"] [:: std :: mem :: size_of :: < __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1 > () - 24usize] ;
    ["Alignment of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1"] [:: std :: mem :: align_of :: < __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1 > () - 8usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1::pPackageName"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1 , pPackageName) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1::PolicyId"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_1 , PolicyId) - 8usize] ;
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2
{
    pub ObjectId: GUID,
    pub PolicyId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2"] [:: std :: mem :: size_of :: < __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2 > () - 32usize] ;
    ["Alignment of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2"] [:: std :: mem :: align_of :: < __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2 > () - 4usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2::ObjectId"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2 , ObjectId) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2::PolicyId"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005__bindgen_ty_2 , PolicyId) - 16usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005"]
        [::std::mem::size_of::<
            __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005,
        >() - 32usize];
    ["Alignment of __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005"] [:: std :: mem :: align_of :: < __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 > () - 8usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::clsid"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , clsid) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::pFileExt"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , pFileExt) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::pMimeType"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , pMimeType) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::pProgId"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , pProgId) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::pFileName"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , pFileName) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::ByName"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , ByName) - 0usize] ;
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005::ByObjectId"] [:: std :: mem :: offset_of ! (__MIDL___MIDL_itf_wtypes_0000_0001_0001___MIDL___MIDL_itf_wtypes_0000_0001_0005 , ByObjectId) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of __MIDL___MIDL_itf_wtypes_0000_0001_0001"]
        [::std::mem::size_of::<__MIDL___MIDL_itf_wtypes_0000_0001_0001>() - 40usize];
    ["Alignment of __MIDL___MIDL_itf_wtypes_0000_0001_0001"]
        [::std::mem::align_of::<__MIDL___MIDL_itf_wtypes_0000_0001_0001>() - 8usize];
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001::tyspec"]
        [::std::mem::offset_of!(__MIDL___MIDL_itf_wtypes_0000_0001_0001, tyspec) - 0usize];
    ["Offset of field: __MIDL___MIDL_itf_wtypes_0000_0001_0001::tagged_union"]
        [::std::mem::offset_of!(__MIDL___MIDL_itf_wtypes_0000_0001_0001, tagged_union) - 8usize];
};
pub type uCLSSPEC = __MIDL___MIDL_itf_wtypes_0000_0001_0001;
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypes_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_wtypes_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_DISK: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_CDROM: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_PARTITION: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_TAPE: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_WRITEONCEDISK: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_VOLUME: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_MEDIUMCHANGER: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_FLOPPY: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_CDCHANGER: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_STORAGEPORT: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_VMLUN: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_SES: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_ZNSDISK: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_SERVICE_VOLUME: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_HIDDEN_VOLUME: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_UNIFIED_ACCESS_RPMB: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_SCM_PHYSICAL_DEVICE: GUID;
}
unsafe extern "C" {
    pub static GUID_SCM_PD_HEALTH_NOTIFICATION: GUID;
}
unsafe extern "C" {
    pub static GUID_SCM_PD_PASSTHROUGH_INVDIMM: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_COMPORT: GUID;
}
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_SERENUM_BUS_ENUMERATOR: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HOTPLUG_INFO {
    pub Size: DWORD,
    pub MediaRemovable: BOOLEAN,
    pub MediaHotplug: BOOLEAN,
    pub DeviceHotplug: BOOLEAN,
    pub WriteCacheEnableOverride: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HOTPLUG_INFO"][::std::mem::size_of::<_STORAGE_HOTPLUG_INFO>() - 8usize];
    ["Alignment of _STORAGE_HOTPLUG_INFO"]
        [::std::mem::align_of::<_STORAGE_HOTPLUG_INFO>() - 4usize];
    ["Offset of field: _STORAGE_HOTPLUG_INFO::Size"]
        [::std::mem::offset_of!(_STORAGE_HOTPLUG_INFO, Size) - 0usize];
    ["Offset of field: _STORAGE_HOTPLUG_INFO::MediaRemovable"]
        [::std::mem::offset_of!(_STORAGE_HOTPLUG_INFO, MediaRemovable) - 4usize];
    ["Offset of field: _STORAGE_HOTPLUG_INFO::MediaHotplug"]
        [::std::mem::offset_of!(_STORAGE_HOTPLUG_INFO, MediaHotplug) - 5usize];
    ["Offset of field: _STORAGE_HOTPLUG_INFO::DeviceHotplug"]
        [::std::mem::offset_of!(_STORAGE_HOTPLUG_INFO, DeviceHotplug) - 6usize];
    ["Offset of field: _STORAGE_HOTPLUG_INFO::WriteCacheEnableOverride"]
        [::std::mem::offset_of!(_STORAGE_HOTPLUG_INFO, WriteCacheEnableOverride) - 7usize];
};
pub type STORAGE_HOTPLUG_INFO = _STORAGE_HOTPLUG_INFO;
pub type PSTORAGE_HOTPLUG_INFO = *mut _STORAGE_HOTPLUG_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_NUMBER {
    pub DeviceType: DWORD,
    pub DeviceNumber: DWORD,
    pub PartitionNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_NUMBER"][::std::mem::size_of::<_STORAGE_DEVICE_NUMBER>() - 12usize];
    ["Alignment of _STORAGE_DEVICE_NUMBER"]
        [::std::mem::align_of::<_STORAGE_DEVICE_NUMBER>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER::DeviceType"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER, DeviceType) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER::DeviceNumber"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER, DeviceNumber) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER::PartitionNumber"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER, PartitionNumber) - 8usize];
};
pub type STORAGE_DEVICE_NUMBER = _STORAGE_DEVICE_NUMBER;
pub type PSTORAGE_DEVICE_NUMBER = *mut _STORAGE_DEVICE_NUMBER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_NUMBERS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumberOfDevices: DWORD,
    pub Devices: [STORAGE_DEVICE_NUMBER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_NUMBERS"][::std::mem::size_of::<_STORAGE_DEVICE_NUMBERS>() - 24usize];
    ["Alignment of _STORAGE_DEVICE_NUMBERS"]
        [::std::mem::align_of::<_STORAGE_DEVICE_NUMBERS>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBERS::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBERS, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBERS::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBERS, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBERS::NumberOfDevices"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBERS, NumberOfDevices) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBERS::Devices"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBERS, Devices) - 12usize];
};
pub type STORAGE_DEVICE_NUMBERS = _STORAGE_DEVICE_NUMBERS;
pub type PSTORAGE_DEVICE_NUMBERS = *mut _STORAGE_DEVICE_NUMBERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_NUMBER_EX {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub DeviceType: DWORD,
    pub DeviceNumber: DWORD,
    pub DeviceGuid: GUID,
    pub PartitionNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_NUMBER_EX"]
        [::std::mem::size_of::<_STORAGE_DEVICE_NUMBER_EX>() - 40usize];
    ["Alignment of _STORAGE_DEVICE_NUMBER_EX"]
        [::std::mem::align_of::<_STORAGE_DEVICE_NUMBER_EX>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::Flags"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, Flags) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::DeviceType"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, DeviceType) - 12usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::DeviceNumber"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, DeviceNumber) - 16usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::DeviceGuid"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, DeviceGuid) - 20usize];
    ["Offset of field: _STORAGE_DEVICE_NUMBER_EX::PartitionNumber"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMBER_EX, PartitionNumber) - 36usize];
};
pub type STORAGE_DEVICE_NUMBER_EX = _STORAGE_DEVICE_NUMBER_EX;
pub type PSTORAGE_DEVICE_NUMBER_EX = *mut _STORAGE_DEVICE_NUMBER_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_BUS_RESET_REQUEST {
    pub PathId: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_BUS_RESET_REQUEST"]
        [::std::mem::size_of::<_STORAGE_BUS_RESET_REQUEST>() - 1usize];
    ["Alignment of _STORAGE_BUS_RESET_REQUEST"]
        [::std::mem::align_of::<_STORAGE_BUS_RESET_REQUEST>() - 1usize];
    ["Offset of field: _STORAGE_BUS_RESET_REQUEST::PathId"]
        [::std::mem::offset_of!(_STORAGE_BUS_RESET_REQUEST, PathId) - 0usize];
};
pub type STORAGE_BUS_RESET_REQUEST = _STORAGE_BUS_RESET_REQUEST;
pub type PSTORAGE_BUS_RESET_REQUEST = *mut _STORAGE_BUS_RESET_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct STORAGE_BREAK_RESERVATION_REQUEST {
    pub Length: DWORD,
    pub _unused: BYTE,
    pub PathId: BYTE,
    pub TargetId: BYTE,
    pub Lun: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of STORAGE_BREAK_RESERVATION_REQUEST"]
        [::std::mem::size_of::<STORAGE_BREAK_RESERVATION_REQUEST>() - 8usize];
    ["Alignment of STORAGE_BREAK_RESERVATION_REQUEST"]
        [::std::mem::align_of::<STORAGE_BREAK_RESERVATION_REQUEST>() - 4usize];
    ["Offset of field: STORAGE_BREAK_RESERVATION_REQUEST::Length"]
        [::std::mem::offset_of!(STORAGE_BREAK_RESERVATION_REQUEST, Length) - 0usize];
    ["Offset of field: STORAGE_BREAK_RESERVATION_REQUEST::_unused"]
        [::std::mem::offset_of!(STORAGE_BREAK_RESERVATION_REQUEST, _unused) - 4usize];
    ["Offset of field: STORAGE_BREAK_RESERVATION_REQUEST::PathId"]
        [::std::mem::offset_of!(STORAGE_BREAK_RESERVATION_REQUEST, PathId) - 5usize];
    ["Offset of field: STORAGE_BREAK_RESERVATION_REQUEST::TargetId"]
        [::std::mem::offset_of!(STORAGE_BREAK_RESERVATION_REQUEST, TargetId) - 6usize];
    ["Offset of field: STORAGE_BREAK_RESERVATION_REQUEST::Lun"]
        [::std::mem::offset_of!(STORAGE_BREAK_RESERVATION_REQUEST, Lun) - 7usize];
};
pub type PSTORAGE_BREAK_RESERVATION_REQUEST = *mut STORAGE_BREAK_RESERVATION_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PREVENT_MEDIA_REMOVAL {
    pub PreventMediaRemoval: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PREVENT_MEDIA_REMOVAL"][::std::mem::size_of::<_PREVENT_MEDIA_REMOVAL>() - 1usize];
    ["Alignment of _PREVENT_MEDIA_REMOVAL"]
        [::std::mem::align_of::<_PREVENT_MEDIA_REMOVAL>() - 1usize];
    ["Offset of field: _PREVENT_MEDIA_REMOVAL::PreventMediaRemoval"]
        [::std::mem::offset_of!(_PREVENT_MEDIA_REMOVAL, PreventMediaRemoval) - 0usize];
};
pub type PREVENT_MEDIA_REMOVAL = _PREVENT_MEDIA_REMOVAL;
pub type PPREVENT_MEDIA_REMOVAL = *mut _PREVENT_MEDIA_REMOVAL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CLASS_MEDIA_CHANGE_CONTEXT {
    pub MediaChangeCount: DWORD,
    pub NewState: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLASS_MEDIA_CHANGE_CONTEXT"]
        [::std::mem::size_of::<_CLASS_MEDIA_CHANGE_CONTEXT>() - 8usize];
    ["Alignment of _CLASS_MEDIA_CHANGE_CONTEXT"]
        [::std::mem::align_of::<_CLASS_MEDIA_CHANGE_CONTEXT>() - 4usize];
    ["Offset of field: _CLASS_MEDIA_CHANGE_CONTEXT::MediaChangeCount"]
        [::std::mem::offset_of!(_CLASS_MEDIA_CHANGE_CONTEXT, MediaChangeCount) - 0usize];
    ["Offset of field: _CLASS_MEDIA_CHANGE_CONTEXT::NewState"]
        [::std::mem::offset_of!(_CLASS_MEDIA_CHANGE_CONTEXT, NewState) - 4usize];
};
pub type CLASS_MEDIA_CHANGE_CONTEXT = _CLASS_MEDIA_CHANGE_CONTEXT;
pub type PCLASS_MEDIA_CHANGE_CONTEXT = *mut _CLASS_MEDIA_CHANGE_CONTEXT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TAPE_STATISTICS {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub RecoveredWrites: LARGE_INTEGER,
    pub UnrecoveredWrites: LARGE_INTEGER,
    pub RecoveredReads: LARGE_INTEGER,
    pub UnrecoveredReads: LARGE_INTEGER,
    pub CompressionRatioReads: BYTE,
    pub CompressionRatioWrites: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_STATISTICS"][::std::mem::size_of::<_TAPE_STATISTICS>() - 48usize];
    ["Alignment of _TAPE_STATISTICS"][::std::mem::align_of::<_TAPE_STATISTICS>() - 8usize];
    ["Offset of field: _TAPE_STATISTICS::Version"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, Version) - 0usize];
    ["Offset of field: _TAPE_STATISTICS::Flags"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, Flags) - 4usize];
    ["Offset of field: _TAPE_STATISTICS::RecoveredWrites"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, RecoveredWrites) - 8usize];
    ["Offset of field: _TAPE_STATISTICS::UnrecoveredWrites"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, UnrecoveredWrites) - 16usize];
    ["Offset of field: _TAPE_STATISTICS::RecoveredReads"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, RecoveredReads) - 24usize];
    ["Offset of field: _TAPE_STATISTICS::UnrecoveredReads"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, UnrecoveredReads) - 32usize];
    ["Offset of field: _TAPE_STATISTICS::CompressionRatioReads"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, CompressionRatioReads) - 40usize];
    ["Offset of field: _TAPE_STATISTICS::CompressionRatioWrites"]
        [::std::mem::offset_of!(_TAPE_STATISTICS, CompressionRatioWrites) - 41usize];
};
pub type TAPE_STATISTICS = _TAPE_STATISTICS;
pub type PTAPE_STATISTICS = *mut _TAPE_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TAPE_GET_STATISTICS {
    pub Operation: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TAPE_GET_STATISTICS"][::std::mem::size_of::<_TAPE_GET_STATISTICS>() - 4usize];
    ["Alignment of _TAPE_GET_STATISTICS"][::std::mem::align_of::<_TAPE_GET_STATISTICS>() - 4usize];
    ["Offset of field: _TAPE_GET_STATISTICS::Operation"]
        [::std::mem::offset_of!(_TAPE_GET_STATISTICS, Operation) - 0usize];
};
pub type TAPE_GET_STATISTICS = _TAPE_GET_STATISTICS;
pub type PTAPE_GET_STATISTICS = *mut _TAPE_GET_STATISTICS;
pub const _STORAGE_MEDIA_TYPE_DDS_4mm: _STORAGE_MEDIA_TYPE = 32;
pub const _STORAGE_MEDIA_TYPE_MiniQic: _STORAGE_MEDIA_TYPE = 33;
pub const _STORAGE_MEDIA_TYPE_Travan: _STORAGE_MEDIA_TYPE = 34;
pub const _STORAGE_MEDIA_TYPE_QIC: _STORAGE_MEDIA_TYPE = 35;
pub const _STORAGE_MEDIA_TYPE_MP_8mm: _STORAGE_MEDIA_TYPE = 36;
pub const _STORAGE_MEDIA_TYPE_AME_8mm: _STORAGE_MEDIA_TYPE = 37;
pub const _STORAGE_MEDIA_TYPE_AIT1_8mm: _STORAGE_MEDIA_TYPE = 38;
pub const _STORAGE_MEDIA_TYPE_DLT: _STORAGE_MEDIA_TYPE = 39;
pub const _STORAGE_MEDIA_TYPE_NCTP: _STORAGE_MEDIA_TYPE = 40;
pub const _STORAGE_MEDIA_TYPE_IBM_3480: _STORAGE_MEDIA_TYPE = 41;
pub const _STORAGE_MEDIA_TYPE_IBM_3490E: _STORAGE_MEDIA_TYPE = 42;
pub const _STORAGE_MEDIA_TYPE_IBM_Magstar_3590: _STORAGE_MEDIA_TYPE = 43;
pub const _STORAGE_MEDIA_TYPE_IBM_Magstar_MP: _STORAGE_MEDIA_TYPE = 44;
pub const _STORAGE_MEDIA_TYPE_STK_DATA_D3: _STORAGE_MEDIA_TYPE = 45;
pub const _STORAGE_MEDIA_TYPE_SONY_DTF: _STORAGE_MEDIA_TYPE = 46;
pub const _STORAGE_MEDIA_TYPE_DV_6mm: _STORAGE_MEDIA_TYPE = 47;
pub const _STORAGE_MEDIA_TYPE_DMI: _STORAGE_MEDIA_TYPE = 48;
pub const _STORAGE_MEDIA_TYPE_SONY_D2: _STORAGE_MEDIA_TYPE = 49;
pub const _STORAGE_MEDIA_TYPE_CLEANER_CARTRIDGE: _STORAGE_MEDIA_TYPE = 50;
pub const _STORAGE_MEDIA_TYPE_CD_ROM: _STORAGE_MEDIA_TYPE = 51;
pub const _STORAGE_MEDIA_TYPE_CD_R: _STORAGE_MEDIA_TYPE = 52;
pub const _STORAGE_MEDIA_TYPE_CD_RW: _STORAGE_MEDIA_TYPE = 53;
pub const _STORAGE_MEDIA_TYPE_DVD_ROM: _STORAGE_MEDIA_TYPE = 54;
pub const _STORAGE_MEDIA_TYPE_DVD_R: _STORAGE_MEDIA_TYPE = 55;
pub const _STORAGE_MEDIA_TYPE_DVD_RW: _STORAGE_MEDIA_TYPE = 56;
pub const _STORAGE_MEDIA_TYPE_MO_3_RW: _STORAGE_MEDIA_TYPE = 57;
pub const _STORAGE_MEDIA_TYPE_MO_5_WO: _STORAGE_MEDIA_TYPE = 58;
pub const _STORAGE_MEDIA_TYPE_MO_5_RW: _STORAGE_MEDIA_TYPE = 59;
pub const _STORAGE_MEDIA_TYPE_MO_5_LIMDOW: _STORAGE_MEDIA_TYPE = 60;
pub const _STORAGE_MEDIA_TYPE_PC_5_WO: _STORAGE_MEDIA_TYPE = 61;
pub const _STORAGE_MEDIA_TYPE_PC_5_RW: _STORAGE_MEDIA_TYPE = 62;
pub const _STORAGE_MEDIA_TYPE_PD_5_RW: _STORAGE_MEDIA_TYPE = 63;
pub const _STORAGE_MEDIA_TYPE_ABL_5_WO: _STORAGE_MEDIA_TYPE = 64;
pub const _STORAGE_MEDIA_TYPE_PINNACLE_APEX_5_RW: _STORAGE_MEDIA_TYPE = 65;
pub const _STORAGE_MEDIA_TYPE_SONY_12_WO: _STORAGE_MEDIA_TYPE = 66;
pub const _STORAGE_MEDIA_TYPE_PHILIPS_12_WO: _STORAGE_MEDIA_TYPE = 67;
pub const _STORAGE_MEDIA_TYPE_HITACHI_12_WO: _STORAGE_MEDIA_TYPE = 68;
pub const _STORAGE_MEDIA_TYPE_CYGNET_12_WO: _STORAGE_MEDIA_TYPE = 69;
pub const _STORAGE_MEDIA_TYPE_KODAK_14_WO: _STORAGE_MEDIA_TYPE = 70;
pub const _STORAGE_MEDIA_TYPE_MO_NFR_525: _STORAGE_MEDIA_TYPE = 71;
pub const _STORAGE_MEDIA_TYPE_NIKON_12_RW: _STORAGE_MEDIA_TYPE = 72;
pub const _STORAGE_MEDIA_TYPE_IOMEGA_ZIP: _STORAGE_MEDIA_TYPE = 73;
pub const _STORAGE_MEDIA_TYPE_IOMEGA_JAZ: _STORAGE_MEDIA_TYPE = 74;
pub const _STORAGE_MEDIA_TYPE_SYQUEST_EZ135: _STORAGE_MEDIA_TYPE = 75;
pub const _STORAGE_MEDIA_TYPE_SYQUEST_EZFLYER: _STORAGE_MEDIA_TYPE = 76;
pub const _STORAGE_MEDIA_TYPE_SYQUEST_SYJET: _STORAGE_MEDIA_TYPE = 77;
pub const _STORAGE_MEDIA_TYPE_AVATAR_F2: _STORAGE_MEDIA_TYPE = 78;
pub const _STORAGE_MEDIA_TYPE_MP2_8mm: _STORAGE_MEDIA_TYPE = 79;
pub const _STORAGE_MEDIA_TYPE_DST_S: _STORAGE_MEDIA_TYPE = 80;
pub const _STORAGE_MEDIA_TYPE_DST_M: _STORAGE_MEDIA_TYPE = 81;
pub const _STORAGE_MEDIA_TYPE_DST_L: _STORAGE_MEDIA_TYPE = 82;
pub const _STORAGE_MEDIA_TYPE_VXATape_1: _STORAGE_MEDIA_TYPE = 83;
pub const _STORAGE_MEDIA_TYPE_VXATape_2: _STORAGE_MEDIA_TYPE = 84;
pub const _STORAGE_MEDIA_TYPE_STK_9840: _STORAGE_MEDIA_TYPE = 85;
pub const _STORAGE_MEDIA_TYPE_LTO_Ultrium: _STORAGE_MEDIA_TYPE = 86;
pub const _STORAGE_MEDIA_TYPE_LTO_Accelis: _STORAGE_MEDIA_TYPE = 87;
pub const _STORAGE_MEDIA_TYPE_DVD_RAM: _STORAGE_MEDIA_TYPE = 88;
pub const _STORAGE_MEDIA_TYPE_AIT_8mm: _STORAGE_MEDIA_TYPE = 89;
pub const _STORAGE_MEDIA_TYPE_ADR_1: _STORAGE_MEDIA_TYPE = 90;
pub const _STORAGE_MEDIA_TYPE_ADR_2: _STORAGE_MEDIA_TYPE = 91;
pub const _STORAGE_MEDIA_TYPE_STK_9940: _STORAGE_MEDIA_TYPE = 92;
pub const _STORAGE_MEDIA_TYPE_SAIT: _STORAGE_MEDIA_TYPE = 93;
pub const _STORAGE_MEDIA_TYPE_VXATape: _STORAGE_MEDIA_TYPE = 94;
pub type _STORAGE_MEDIA_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_MEDIA_TYPE as STORAGE_MEDIA_TYPE;
pub type PSTORAGE_MEDIA_TYPE = *mut _STORAGE_MEDIA_TYPE;
pub const _STORAGE_BUS_TYPE_BusTypeUnknown: _STORAGE_BUS_TYPE = 0;
pub const _STORAGE_BUS_TYPE_BusTypeScsi: _STORAGE_BUS_TYPE = 1;
pub const _STORAGE_BUS_TYPE_BusTypeAtapi: _STORAGE_BUS_TYPE = 2;
pub const _STORAGE_BUS_TYPE_BusTypeAta: _STORAGE_BUS_TYPE = 3;
pub const _STORAGE_BUS_TYPE_BusType1394: _STORAGE_BUS_TYPE = 4;
pub const _STORAGE_BUS_TYPE_BusTypeSsa: _STORAGE_BUS_TYPE = 5;
pub const _STORAGE_BUS_TYPE_BusTypeFibre: _STORAGE_BUS_TYPE = 6;
pub const _STORAGE_BUS_TYPE_BusTypeUsb: _STORAGE_BUS_TYPE = 7;
pub const _STORAGE_BUS_TYPE_BusTypeRAID: _STORAGE_BUS_TYPE = 8;
pub const _STORAGE_BUS_TYPE_BusTypeiScsi: _STORAGE_BUS_TYPE = 9;
pub const _STORAGE_BUS_TYPE_BusTypeSas: _STORAGE_BUS_TYPE = 10;
pub const _STORAGE_BUS_TYPE_BusTypeSata: _STORAGE_BUS_TYPE = 11;
pub const _STORAGE_BUS_TYPE_BusTypeSd: _STORAGE_BUS_TYPE = 12;
pub const _STORAGE_BUS_TYPE_BusTypeMmc: _STORAGE_BUS_TYPE = 13;
pub const _STORAGE_BUS_TYPE_BusTypeVirtual: _STORAGE_BUS_TYPE = 14;
pub const _STORAGE_BUS_TYPE_BusTypeFileBackedVirtual: _STORAGE_BUS_TYPE = 15;
pub const _STORAGE_BUS_TYPE_BusTypeSpaces: _STORAGE_BUS_TYPE = 16;
pub const _STORAGE_BUS_TYPE_BusTypeNvme: _STORAGE_BUS_TYPE = 17;
pub const _STORAGE_BUS_TYPE_BusTypeSCM: _STORAGE_BUS_TYPE = 18;
pub const _STORAGE_BUS_TYPE_BusTypeUfs: _STORAGE_BUS_TYPE = 19;
pub const _STORAGE_BUS_TYPE_BusTypeMax: _STORAGE_BUS_TYPE = 20;
pub const _STORAGE_BUS_TYPE_BusTypeMaxReserved: _STORAGE_BUS_TYPE = 127;
pub type _STORAGE_BUS_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_BUS_TYPE as STORAGE_BUS_TYPE;
pub type PSTORAGE_BUS_TYPE = *mut _STORAGE_BUS_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_MEDIA_INFO {
    pub DeviceSpecific: _DEVICE_MEDIA_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEVICE_MEDIA_INFO__bindgen_ty_1 {
    pub DiskInfo: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
    pub RemovableDiskInfo: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
    pub TapeInfo: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub Cylinders: LARGE_INTEGER,
    pub MediaType: STORAGE_MEDIA_TYPE,
    pub TracksPerCylinder: DWORD,
    pub SectorsPerTrack: DWORD,
    pub BytesPerSector: DWORD,
    pub NumberMediaSides: DWORD,
    pub MediaCharacteristics: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1>() - 32usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::Cylinders"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        Cylinders
    ) - 0usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::MediaType"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        MediaType
    ) - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::TracksPerCylinder"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        TracksPerCylinder
    )
        - 12usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::SectorsPerTrack"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        SectorsPerTrack
    )
        - 16usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::BytesPerSector"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        BytesPerSector
    )
        - 20usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::NumberMediaSides"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        NumberMediaSides
    )
        - 24usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1::MediaCharacteristics"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_1,
        MediaCharacteristics
    )
        - 28usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2 {
    pub Cylinders: LARGE_INTEGER,
    pub MediaType: STORAGE_MEDIA_TYPE,
    pub TracksPerCylinder: DWORD,
    pub SectorsPerTrack: DWORD,
    pub BytesPerSector: DWORD,
    pub NumberMediaSides: DWORD,
    pub MediaCharacteristics: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2>() - 32usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::Cylinders"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        Cylinders
    ) - 0usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::MediaType"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        MediaType
    ) - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::TracksPerCylinder"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        TracksPerCylinder
    )
        - 12usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::SectorsPerTrack"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        SectorsPerTrack
    )
        - 16usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::BytesPerSector"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        BytesPerSector
    )
        - 20usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::NumberMediaSides"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        NumberMediaSides
    )
        - 24usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2::MediaCharacteristics"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_2,
        MediaCharacteristics
    )
        - 28usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3 {
    pub MediaType: STORAGE_MEDIA_TYPE,
    pub MediaCharacteristics: DWORD,
    pub CurrentBlockSize: DWORD,
    pub BusType: STORAGE_BUS_TYPE,
    pub BusSpecificData: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1 {
    pub ScsiInformation: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1 {
    pub MediumType: BYTE,
    pub DensityCode: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1,
        >() - 2usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1,
        >() - 1usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1::MediumType"] [:: std :: mem :: offset_of ! (_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1 , MediumType) - 0usize] ;
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1::DensityCode"] [:: std :: mem :: offset_of ! (_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1__bindgen_ty_1 , DensityCode) - 1usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1"][::std::mem::size_of::<
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1,
    >() - 2usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1>()
            - 1usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1::ScsiInformation"] [:: std :: mem :: offset_of ! (_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3__bindgen_ty_1 , ScsiInformation) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::size_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3>() - 20usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::align_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3>() - 4usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3::MediaType"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3,
        MediaType
    ) - 0usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3::MediaCharacteristics"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3,
        MediaCharacteristics
    )
        - 4usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3::CurrentBlockSize"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3,
        CurrentBlockSize
    )
        - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3::BusType"]
        [::std::mem::offset_of!(_DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3, BusType) - 12usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3::BusSpecificData"][::std::mem::offset_of!(
        _DEVICE_MEDIA_INFO__bindgen_ty_1__bindgen_ty_3,
        BusSpecificData
    )
        - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1>() - 32usize];
    ["Alignment of _DEVICE_MEDIA_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_MEDIA_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1::DiskInfo"]
        [::std::mem::offset_of!(_DEVICE_MEDIA_INFO__bindgen_ty_1, DiskInfo) - 0usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1::RemovableDiskInfo"]
        [::std::mem::offset_of!(_DEVICE_MEDIA_INFO__bindgen_ty_1, RemovableDiskInfo) - 0usize];
    ["Offset of field: _DEVICE_MEDIA_INFO__bindgen_ty_1::TapeInfo"]
        [::std::mem::offset_of!(_DEVICE_MEDIA_INFO__bindgen_ty_1, TapeInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MEDIA_INFO"][::std::mem::size_of::<_DEVICE_MEDIA_INFO>() - 32usize];
    ["Alignment of _DEVICE_MEDIA_INFO"][::std::mem::align_of::<_DEVICE_MEDIA_INFO>() - 8usize];
    ["Offset of field: _DEVICE_MEDIA_INFO::DeviceSpecific"]
        [::std::mem::offset_of!(_DEVICE_MEDIA_INFO, DeviceSpecific) - 0usize];
};
pub type DEVICE_MEDIA_INFO = _DEVICE_MEDIA_INFO;
pub type PDEVICE_MEDIA_INFO = *mut _DEVICE_MEDIA_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _GET_MEDIA_TYPES {
    pub DeviceType: DWORD,
    pub MediaInfoCount: DWORD,
    pub MediaInfo: [DEVICE_MEDIA_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_MEDIA_TYPES"][::std::mem::size_of::<_GET_MEDIA_TYPES>() - 40usize];
    ["Alignment of _GET_MEDIA_TYPES"][::std::mem::align_of::<_GET_MEDIA_TYPES>() - 8usize];
    ["Offset of field: _GET_MEDIA_TYPES::DeviceType"]
        [::std::mem::offset_of!(_GET_MEDIA_TYPES, DeviceType) - 0usize];
    ["Offset of field: _GET_MEDIA_TYPES::MediaInfoCount"]
        [::std::mem::offset_of!(_GET_MEDIA_TYPES, MediaInfoCount) - 4usize];
    ["Offset of field: _GET_MEDIA_TYPES::MediaInfo"]
        [::std::mem::offset_of!(_GET_MEDIA_TYPES, MediaInfo) - 8usize];
};
pub type GET_MEDIA_TYPES = _GET_MEDIA_TYPES;
pub type PGET_MEDIA_TYPES = *mut _GET_MEDIA_TYPES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PREDICT_FAILURE {
    pub PredictFailure: DWORD,
    pub VendorSpecific: [BYTE; 512usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PREDICT_FAILURE"]
        [::std::mem::size_of::<_STORAGE_PREDICT_FAILURE>() - 516usize];
    ["Alignment of _STORAGE_PREDICT_FAILURE"]
        [::std::mem::align_of::<_STORAGE_PREDICT_FAILURE>() - 4usize];
    ["Offset of field: _STORAGE_PREDICT_FAILURE::PredictFailure"]
        [::std::mem::offset_of!(_STORAGE_PREDICT_FAILURE, PredictFailure) - 0usize];
    ["Offset of field: _STORAGE_PREDICT_FAILURE::VendorSpecific"]
        [::std::mem::offset_of!(_STORAGE_PREDICT_FAILURE, VendorSpecific) - 4usize];
};
pub type STORAGE_PREDICT_FAILURE = _STORAGE_PREDICT_FAILURE;
pub type PSTORAGE_PREDICT_FAILURE = *mut _STORAGE_PREDICT_FAILURE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_FAILURE_PREDICTION_CONFIG {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Set: BOOLEAN,
    pub Enabled: BOOLEAN,
    pub Reserved: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_FAILURE_PREDICTION_CONFIG"]
        [::std::mem::size_of::<_STORAGE_FAILURE_PREDICTION_CONFIG>() - 12usize];
    ["Alignment of _STORAGE_FAILURE_PREDICTION_CONFIG"]
        [::std::mem::align_of::<_STORAGE_FAILURE_PREDICTION_CONFIG>() - 4usize];
    ["Offset of field: _STORAGE_FAILURE_PREDICTION_CONFIG::Version"]
        [::std::mem::offset_of!(_STORAGE_FAILURE_PREDICTION_CONFIG, Version) - 0usize];
    ["Offset of field: _STORAGE_FAILURE_PREDICTION_CONFIG::Size"]
        [::std::mem::offset_of!(_STORAGE_FAILURE_PREDICTION_CONFIG, Size) - 4usize];
    ["Offset of field: _STORAGE_FAILURE_PREDICTION_CONFIG::Set"]
        [::std::mem::offset_of!(_STORAGE_FAILURE_PREDICTION_CONFIG, Set) - 8usize];
    ["Offset of field: _STORAGE_FAILURE_PREDICTION_CONFIG::Enabled"]
        [::std::mem::offset_of!(_STORAGE_FAILURE_PREDICTION_CONFIG, Enabled) - 9usize];
    ["Offset of field: _STORAGE_FAILURE_PREDICTION_CONFIG::Reserved"]
        [::std::mem::offset_of!(_STORAGE_FAILURE_PREDICTION_CONFIG, Reserved) - 10usize];
};
pub type STORAGE_FAILURE_PREDICTION_CONFIG = _STORAGE_FAILURE_PREDICTION_CONFIG;
pub type PSTORAGE_FAILURE_PREDICTION_CONFIG = *mut _STORAGE_FAILURE_PREDICTION_CONFIG;
pub const _STORAGE_QUERY_TYPE_PropertyStandardQuery: _STORAGE_QUERY_TYPE = 0;
pub const _STORAGE_QUERY_TYPE_PropertyExistsQuery: _STORAGE_QUERY_TYPE = 1;
pub const _STORAGE_QUERY_TYPE_PropertyMaskQuery: _STORAGE_QUERY_TYPE = 2;
pub const _STORAGE_QUERY_TYPE_PropertyQueryMaxDefined: _STORAGE_QUERY_TYPE = 3;
pub type _STORAGE_QUERY_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_QUERY_TYPE as STORAGE_QUERY_TYPE;
pub type PSTORAGE_QUERY_TYPE = *mut _STORAGE_QUERY_TYPE;
pub const _STORAGE_SET_TYPE_PropertyStandardSet: _STORAGE_SET_TYPE = 0;
pub const _STORAGE_SET_TYPE_PropertyExistsSet: _STORAGE_SET_TYPE = 1;
pub const _STORAGE_SET_TYPE_PropertySetMaxDefined: _STORAGE_SET_TYPE = 2;
pub type _STORAGE_SET_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_SET_TYPE as STORAGE_SET_TYPE;
pub type PSTORAGE_SET_TYPE = *mut _STORAGE_SET_TYPE;
pub const _STORAGE_PROPERTY_ID_StorageDeviceProperty: _STORAGE_PROPERTY_ID = 0;
pub const _STORAGE_PROPERTY_ID_StorageAdapterProperty: _STORAGE_PROPERTY_ID = 1;
pub const _STORAGE_PROPERTY_ID_StorageDeviceIdProperty: _STORAGE_PROPERTY_ID = 2;
pub const _STORAGE_PROPERTY_ID_StorageDeviceUniqueIdProperty: _STORAGE_PROPERTY_ID = 3;
pub const _STORAGE_PROPERTY_ID_StorageDeviceWriteCacheProperty: _STORAGE_PROPERTY_ID = 4;
pub const _STORAGE_PROPERTY_ID_StorageMiniportProperty: _STORAGE_PROPERTY_ID = 5;
pub const _STORAGE_PROPERTY_ID_StorageAccessAlignmentProperty: _STORAGE_PROPERTY_ID = 6;
pub const _STORAGE_PROPERTY_ID_StorageDeviceSeekPenaltyProperty: _STORAGE_PROPERTY_ID = 7;
pub const _STORAGE_PROPERTY_ID_StorageDeviceTrimProperty: _STORAGE_PROPERTY_ID = 8;
pub const _STORAGE_PROPERTY_ID_StorageDeviceWriteAggregationProperty: _STORAGE_PROPERTY_ID = 9;
pub const _STORAGE_PROPERTY_ID_StorageDeviceDeviceTelemetryProperty: _STORAGE_PROPERTY_ID = 10;
pub const _STORAGE_PROPERTY_ID_StorageDeviceLBProvisioningProperty: _STORAGE_PROPERTY_ID = 11;
pub const _STORAGE_PROPERTY_ID_StorageDevicePowerProperty: _STORAGE_PROPERTY_ID = 12;
pub const _STORAGE_PROPERTY_ID_StorageDeviceCopyOffloadProperty: _STORAGE_PROPERTY_ID = 13;
pub const _STORAGE_PROPERTY_ID_StorageDeviceResiliencyProperty: _STORAGE_PROPERTY_ID = 14;
pub const _STORAGE_PROPERTY_ID_StorageDeviceMediumProductType: _STORAGE_PROPERTY_ID = 15;
pub const _STORAGE_PROPERTY_ID_StorageAdapterRpmbProperty: _STORAGE_PROPERTY_ID = 16;
pub const _STORAGE_PROPERTY_ID_StorageAdapterCryptoProperty: _STORAGE_PROPERTY_ID = 17;
pub const _STORAGE_PROPERTY_ID_StorageDeviceIoCapabilityProperty: _STORAGE_PROPERTY_ID = 48;
pub const _STORAGE_PROPERTY_ID_StorageAdapterProtocolSpecificProperty: _STORAGE_PROPERTY_ID = 49;
pub const _STORAGE_PROPERTY_ID_StorageDeviceProtocolSpecificProperty: _STORAGE_PROPERTY_ID = 50;
pub const _STORAGE_PROPERTY_ID_StorageAdapterTemperatureProperty: _STORAGE_PROPERTY_ID = 51;
pub const _STORAGE_PROPERTY_ID_StorageDeviceTemperatureProperty: _STORAGE_PROPERTY_ID = 52;
pub const _STORAGE_PROPERTY_ID_StorageAdapterPhysicalTopologyProperty: _STORAGE_PROPERTY_ID = 53;
pub const _STORAGE_PROPERTY_ID_StorageDevicePhysicalTopologyProperty: _STORAGE_PROPERTY_ID = 54;
pub const _STORAGE_PROPERTY_ID_StorageDeviceAttributesProperty: _STORAGE_PROPERTY_ID = 55;
pub const _STORAGE_PROPERTY_ID_StorageDeviceManagementStatus: _STORAGE_PROPERTY_ID = 56;
pub const _STORAGE_PROPERTY_ID_StorageAdapterSerialNumberProperty: _STORAGE_PROPERTY_ID = 57;
pub const _STORAGE_PROPERTY_ID_StorageDeviceLocationProperty: _STORAGE_PROPERTY_ID = 58;
pub const _STORAGE_PROPERTY_ID_StorageDeviceNumaProperty: _STORAGE_PROPERTY_ID = 59;
pub const _STORAGE_PROPERTY_ID_StorageDeviceZonedDeviceProperty: _STORAGE_PROPERTY_ID = 60;
pub const _STORAGE_PROPERTY_ID_StorageDeviceUnsafeShutdownCount: _STORAGE_PROPERTY_ID = 61;
pub const _STORAGE_PROPERTY_ID_StorageDeviceEnduranceProperty: _STORAGE_PROPERTY_ID = 62;
pub const _STORAGE_PROPERTY_ID_StorageDeviceLedStateProperty: _STORAGE_PROPERTY_ID = 63;
pub const _STORAGE_PROPERTY_ID_StorageDeviceSelfEncryptionProperty: _STORAGE_PROPERTY_ID = 64;
pub const _STORAGE_PROPERTY_ID_StorageFruIdProperty: _STORAGE_PROPERTY_ID = 65;
pub type _STORAGE_PROPERTY_ID = ::std::os::raw::c_int;
pub use self::_STORAGE_PROPERTY_ID as STORAGE_PROPERTY_ID;
pub type PSTORAGE_PROPERTY_ID = *mut _STORAGE_PROPERTY_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROPERTY_QUERY {
    pub PropertyId: STORAGE_PROPERTY_ID,
    pub QueryType: STORAGE_QUERY_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROPERTY_QUERY"][::std::mem::size_of::<_STORAGE_PROPERTY_QUERY>() - 12usize];
    ["Alignment of _STORAGE_PROPERTY_QUERY"]
        [::std::mem::align_of::<_STORAGE_PROPERTY_QUERY>() - 4usize];
    ["Offset of field: _STORAGE_PROPERTY_QUERY::PropertyId"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_QUERY, PropertyId) - 0usize];
    ["Offset of field: _STORAGE_PROPERTY_QUERY::QueryType"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_QUERY, QueryType) - 4usize];
    ["Offset of field: _STORAGE_PROPERTY_QUERY::AdditionalParameters"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_QUERY, AdditionalParameters) - 8usize];
};
pub type STORAGE_PROPERTY_QUERY = _STORAGE_PROPERTY_QUERY;
pub type PSTORAGE_PROPERTY_QUERY = *mut _STORAGE_PROPERTY_QUERY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROPERTY_SET {
    pub PropertyId: STORAGE_PROPERTY_ID,
    pub SetType: STORAGE_SET_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROPERTY_SET"][::std::mem::size_of::<_STORAGE_PROPERTY_SET>() - 12usize];
    ["Alignment of _STORAGE_PROPERTY_SET"]
        [::std::mem::align_of::<_STORAGE_PROPERTY_SET>() - 4usize];
    ["Offset of field: _STORAGE_PROPERTY_SET::PropertyId"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_SET, PropertyId) - 0usize];
    ["Offset of field: _STORAGE_PROPERTY_SET::SetType"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_SET, SetType) - 4usize];
    ["Offset of field: _STORAGE_PROPERTY_SET::AdditionalParameters"]
        [::std::mem::offset_of!(_STORAGE_PROPERTY_SET, AdditionalParameters) - 8usize];
};
pub type STORAGE_PROPERTY_SET = _STORAGE_PROPERTY_SET;
pub type PSTORAGE_PROPERTY_SET = *mut _STORAGE_PROPERTY_SET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DESCRIPTOR_HEADER {
    pub Version: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DESCRIPTOR_HEADER"]
        [::std::mem::size_of::<_STORAGE_DESCRIPTOR_HEADER>() - 8usize];
    ["Alignment of _STORAGE_DESCRIPTOR_HEADER"]
        [::std::mem::align_of::<_STORAGE_DESCRIPTOR_HEADER>() - 4usize];
    ["Offset of field: _STORAGE_DESCRIPTOR_HEADER::Version"]
        [::std::mem::offset_of!(_STORAGE_DESCRIPTOR_HEADER, Version) - 0usize];
    ["Offset of field: _STORAGE_DESCRIPTOR_HEADER::Size"]
        [::std::mem::offset_of!(_STORAGE_DESCRIPTOR_HEADER, Size) - 4usize];
};
pub type STORAGE_DESCRIPTOR_HEADER = _STORAGE_DESCRIPTOR_HEADER;
pub type PSTORAGE_DESCRIPTOR_HEADER = *mut _STORAGE_DESCRIPTOR_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceType: BYTE,
    pub DeviceTypeModifier: BYTE,
    pub RemovableMedia: BOOLEAN,
    pub CommandQueueing: BOOLEAN,
    pub VendorIdOffset: DWORD,
    pub ProductIdOffset: DWORD,
    pub ProductRevisionOffset: DWORD,
    pub SerialNumberOffset: DWORD,
    pub BusType: STORAGE_BUS_TYPE,
    pub RawPropertiesLength: DWORD,
    pub RawDeviceProperties: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_DESCRIPTOR>() - 40usize];
    ["Alignment of _STORAGE_DEVICE_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::DeviceType"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, DeviceType) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::DeviceTypeModifier"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, DeviceTypeModifier) - 9usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::RemovableMedia"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, RemovableMedia) - 10usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::CommandQueueing"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, CommandQueueing) - 11usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::VendorIdOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, VendorIdOffset) - 12usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::ProductIdOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, ProductIdOffset) - 16usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::ProductRevisionOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, ProductRevisionOffset) - 20usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::SerialNumberOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, SerialNumberOffset) - 24usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::BusType"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, BusType) - 28usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::RawPropertiesLength"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, RawPropertiesLength) - 32usize];
    ["Offset of field: _STORAGE_DEVICE_DESCRIPTOR::RawDeviceProperties"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_DESCRIPTOR, RawDeviceProperties) - 36usize];
};
pub type STORAGE_DEVICE_DESCRIPTOR = _STORAGE_DEVICE_DESCRIPTOR;
pub type PSTORAGE_DEVICE_DESCRIPTOR = *mut _STORAGE_DEVICE_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ADAPTER_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub MaximumTransferLength: DWORD,
    pub MaximumPhysicalPages: DWORD,
    pub AlignmentMask: DWORD,
    pub AdapterUsesPio: BOOLEAN,
    pub AdapterScansDown: BOOLEAN,
    pub CommandQueueing: BOOLEAN,
    pub AcceleratedTransfer: BOOLEAN,
    pub BusType: BYTE,
    pub BusMajorVersion: WORD,
    pub BusMinorVersion: WORD,
    pub SrbType: BYTE,
    pub AddressType: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ADAPTER_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_ADAPTER_DESCRIPTOR>() - 32usize];
    ["Alignment of _STORAGE_ADAPTER_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_ADAPTER_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::MaximumTransferLength"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, MaximumTransferLength) - 8usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::MaximumPhysicalPages"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, MaximumPhysicalPages) - 12usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::AlignmentMask"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, AlignmentMask) - 16usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::AdapterUsesPio"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, AdapterUsesPio) - 20usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::AdapterScansDown"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, AdapterScansDown) - 21usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::CommandQueueing"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, CommandQueueing) - 22usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::AcceleratedTransfer"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, AcceleratedTransfer) - 23usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::BusType"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, BusType) - 24usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::BusMajorVersion"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, BusMajorVersion) - 26usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::BusMinorVersion"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, BusMinorVersion) - 28usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::SrbType"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, SrbType) - 30usize];
    ["Offset of field: _STORAGE_ADAPTER_DESCRIPTOR::AddressType"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_DESCRIPTOR, AddressType) - 31usize];
};
pub type STORAGE_ADAPTER_DESCRIPTOR = _STORAGE_ADAPTER_DESCRIPTOR;
pub type PSTORAGE_ADAPTER_DESCRIPTOR = *mut _STORAGE_ADAPTER_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub BytesPerCacheLine: DWORD,
    pub BytesOffsetForCacheAlignment: DWORD,
    pub BytesPerLogicalSector: DWORD,
    pub BytesPerPhysicalSector: DWORD,
    pub BytesOffsetForSectorAlignment: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR>() - 28usize];
    ["Alignment of _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::BytesPerCacheLine"]
        [::std::mem::offset_of!(_STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR, BytesPerCacheLine) - 8usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::BytesOffsetForCacheAlignment"][::std::mem::offset_of!(
        _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR,
        BytesOffsetForCacheAlignment
    )
        - 12usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::BytesPerLogicalSector"][::std::mem::offset_of!(
        _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR,
        BytesPerLogicalSector
    ) - 16usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::BytesPerPhysicalSector"][::std::mem::offset_of!(
        _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR,
        BytesPerPhysicalSector
    ) - 20usize];
    ["Offset of field: _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR::BytesOffsetForSectorAlignment"][::std::mem::offset_of!(
        _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR,
        BytesOffsetForSectorAlignment
    )
        - 24usize];
};
pub type STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR = _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR;
pub type PSTORAGE_ACCESS_ALIGNMENT_DESCRIPTOR = *mut _STORAGE_ACCESS_ALIGNMENT_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub MediumProductType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR>() - 12usize];
    ["Alignment of _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR::MediumProductType"][::std::mem::offset_of!(
        _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR,
        MediumProductType
    ) - 8usize];
};
pub type STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR = _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR;
pub type PSTORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR = *mut _STORAGE_MEDIUM_PRODUCT_TYPE_DESCRIPTOR;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetReserved: _STORAGE_PORT_CODE_SET = 0;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetStorport: _STORAGE_PORT_CODE_SET = 1;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetSCSIport: _STORAGE_PORT_CODE_SET = 2;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetSpaceport: _STORAGE_PORT_CODE_SET = 3;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetATAport: _STORAGE_PORT_CODE_SET = 4;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetUSBport: _STORAGE_PORT_CODE_SET = 5;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetSBP2port: _STORAGE_PORT_CODE_SET = 6;
pub const _STORAGE_PORT_CODE_SET_StoragePortCodeSetSDport: _STORAGE_PORT_CODE_SET = 7;
pub type _STORAGE_PORT_CODE_SET = ::std::os::raw::c_int;
pub use self::_STORAGE_PORT_CODE_SET as STORAGE_PORT_CODE_SET;
pub type PSTORAGE_PORT_CODE_SET = *mut _STORAGE_PORT_CODE_SET;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_MINIPORT_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Portdriver: STORAGE_PORT_CODE_SET,
    pub LUNResetSupported: BOOLEAN,
    pub TargetResetSupported: BOOLEAN,
    pub IoTimeoutValue: WORD,
    pub ExtraIoInfoSupported: BOOLEAN,
    pub Flags: _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1,
    pub Reserved0: [BYTE; 2usize],
    pub Reserved1: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1 {
    pub __bindgen_anon_1: _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    pub AsBYTE: BYTE,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    >() - 1usize];
    ["Alignment of _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    >() - 1usize];
};
impl _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn LogicalPoFxForDisk(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_LogicalPoFxForDisk(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn LogicalPoFxForDisk_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_LogicalPoFxForDisk_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 7u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                7u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        LogicalPoFxForDisk: BYTE,
        Reserved: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let LogicalPoFxForDisk: u8 = unsafe { ::std::mem::transmute(LogicalPoFxForDisk) };
            LogicalPoFxForDisk as u64
        });
        __bindgen_bitfield_unit.set(1usize, 7u8, {
            let Reserved: u8 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1>() - 1usize];
    ["Alignment of _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1>() - 1usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1::AsBYTE"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR__bindgen_ty_1, AsBYTE) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_MINIPORT_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_MINIPORT_DESCRIPTOR>() - 24usize];
    ["Alignment of _STORAGE_MINIPORT_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_MINIPORT_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Portdriver"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Portdriver) - 8usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::LUNResetSupported"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, LUNResetSupported) - 12usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::TargetResetSupported"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, TargetResetSupported) - 13usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::IoTimeoutValue"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, IoTimeoutValue) - 14usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::ExtraIoInfoSupported"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, ExtraIoInfoSupported) - 16usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Flags"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Flags) - 17usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Reserved0) - 18usize];
    ["Offset of field: _STORAGE_MINIPORT_DESCRIPTOR::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_MINIPORT_DESCRIPTOR, Reserved1) - 20usize];
};
pub type STORAGE_MINIPORT_DESCRIPTOR = _STORAGE_MINIPORT_DESCRIPTOR;
pub type PSTORAGE_MINIPORT_DESCRIPTOR = *mut _STORAGE_MINIPORT_DESCRIPTOR;
pub const _STORAGE_IDENTIFIER_CODE_SET_StorageIdCodeSetReserved: _STORAGE_IDENTIFIER_CODE_SET = 0;
pub const _STORAGE_IDENTIFIER_CODE_SET_StorageIdCodeSetBinary: _STORAGE_IDENTIFIER_CODE_SET = 1;
pub const _STORAGE_IDENTIFIER_CODE_SET_StorageIdCodeSetAscii: _STORAGE_IDENTIFIER_CODE_SET = 2;
pub const _STORAGE_IDENTIFIER_CODE_SET_StorageIdCodeSetUtf8: _STORAGE_IDENTIFIER_CODE_SET = 3;
pub type _STORAGE_IDENTIFIER_CODE_SET = ::std::os::raw::c_int;
pub use self::_STORAGE_IDENTIFIER_CODE_SET as STORAGE_IDENTIFIER_CODE_SET;
pub type PSTORAGE_IDENTIFIER_CODE_SET = *mut _STORAGE_IDENTIFIER_CODE_SET;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeVendorSpecific: _STORAGE_IDENTIFIER_TYPE = 0;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeVendorId: _STORAGE_IDENTIFIER_TYPE = 1;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeEUI64: _STORAGE_IDENTIFIER_TYPE = 2;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeFCPHName: _STORAGE_IDENTIFIER_TYPE = 3;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypePortRelative: _STORAGE_IDENTIFIER_TYPE = 4;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeTargetPortGroup: _STORAGE_IDENTIFIER_TYPE = 5;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeLogicalUnitGroup: _STORAGE_IDENTIFIER_TYPE = 6;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeMD5LogicalUnitIdentifier: _STORAGE_IDENTIFIER_TYPE =
    7;
pub const _STORAGE_IDENTIFIER_TYPE_StorageIdTypeScsiNameString: _STORAGE_IDENTIFIER_TYPE = 8;
pub type _STORAGE_IDENTIFIER_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_IDENTIFIER_TYPE as STORAGE_IDENTIFIER_TYPE;
pub type PSTORAGE_IDENTIFIER_TYPE = *mut _STORAGE_IDENTIFIER_TYPE;
pub const _STORAGE_ID_NAA_FORMAT_StorageIdNAAFormatIEEEExtended: _STORAGE_ID_NAA_FORMAT = 2;
pub const _STORAGE_ID_NAA_FORMAT_StorageIdNAAFormatIEEERegistered: _STORAGE_ID_NAA_FORMAT = 3;
pub const _STORAGE_ID_NAA_FORMAT_StorageIdNAAFormatIEEEERegisteredExtended: _STORAGE_ID_NAA_FORMAT =
    5;
pub type _STORAGE_ID_NAA_FORMAT = ::std::os::raw::c_int;
pub use self::_STORAGE_ID_NAA_FORMAT as STORAGE_ID_NAA_FORMAT;
pub type PSTORAGE_ID_NAA_FORMAT = *mut _STORAGE_ID_NAA_FORMAT;
pub const _STORAGE_ASSOCIATION_TYPE_StorageIdAssocDevice: _STORAGE_ASSOCIATION_TYPE = 0;
pub const _STORAGE_ASSOCIATION_TYPE_StorageIdAssocPort: _STORAGE_ASSOCIATION_TYPE = 1;
pub const _STORAGE_ASSOCIATION_TYPE_StorageIdAssocTarget: _STORAGE_ASSOCIATION_TYPE = 2;
pub type _STORAGE_ASSOCIATION_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_ASSOCIATION_TYPE as STORAGE_ASSOCIATION_TYPE;
pub type PSTORAGE_ASSOCIATION_TYPE = *mut _STORAGE_ASSOCIATION_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_IDENTIFIER {
    pub CodeSet: STORAGE_IDENTIFIER_CODE_SET,
    pub Type: STORAGE_IDENTIFIER_TYPE,
    pub IdentifierSize: WORD,
    pub NextOffset: WORD,
    pub Association: STORAGE_ASSOCIATION_TYPE,
    pub Identifier: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_IDENTIFIER"][::std::mem::size_of::<_STORAGE_IDENTIFIER>() - 20usize];
    ["Alignment of _STORAGE_IDENTIFIER"][::std::mem::align_of::<_STORAGE_IDENTIFIER>() - 4usize];
    ["Offset of field: _STORAGE_IDENTIFIER::CodeSet"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, CodeSet) - 0usize];
    ["Offset of field: _STORAGE_IDENTIFIER::Type"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, Type) - 4usize];
    ["Offset of field: _STORAGE_IDENTIFIER::IdentifierSize"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, IdentifierSize) - 8usize];
    ["Offset of field: _STORAGE_IDENTIFIER::NextOffset"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, NextOffset) - 10usize];
    ["Offset of field: _STORAGE_IDENTIFIER::Association"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, Association) - 12usize];
    ["Offset of field: _STORAGE_IDENTIFIER::Identifier"]
        [::std::mem::offset_of!(_STORAGE_IDENTIFIER, Identifier) - 16usize];
};
pub type STORAGE_IDENTIFIER = _STORAGE_IDENTIFIER;
pub type PSTORAGE_IDENTIFIER = *mut _STORAGE_IDENTIFIER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_ID_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumberOfIdentifiers: DWORD,
    pub Identifiers: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_ID_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_ID_DESCRIPTOR>() - 16usize];
    ["Alignment of _STORAGE_DEVICE_ID_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_ID_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_ID_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ID_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_ID_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ID_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_ID_DESCRIPTOR::NumberOfIdentifiers"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ID_DESCRIPTOR, NumberOfIdentifiers) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_ID_DESCRIPTOR::Identifiers"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ID_DESCRIPTOR, Identifiers) - 12usize];
};
pub type STORAGE_DEVICE_ID_DESCRIPTOR = _STORAGE_DEVICE_ID_DESCRIPTOR;
pub type PSTORAGE_DEVICE_ID_DESCRIPTOR = *mut _STORAGE_DEVICE_ID_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_SEEK_PENALTY_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub IncursSeekPenalty: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_SEEK_PENALTY_DESCRIPTOR"]
        [::std::mem::size_of::<_DEVICE_SEEK_PENALTY_DESCRIPTOR>() - 12usize];
    ["Alignment of _DEVICE_SEEK_PENALTY_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_SEEK_PENALTY_DESCRIPTOR>() - 4usize];
    ["Offset of field: _DEVICE_SEEK_PENALTY_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_SEEK_PENALTY_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_SEEK_PENALTY_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_SEEK_PENALTY_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_SEEK_PENALTY_DESCRIPTOR::IncursSeekPenalty"]
        [::std::mem::offset_of!(_DEVICE_SEEK_PENALTY_DESCRIPTOR, IncursSeekPenalty) - 8usize];
};
pub type DEVICE_SEEK_PENALTY_DESCRIPTOR = _DEVICE_SEEK_PENALTY_DESCRIPTOR;
pub type PDEVICE_SEEK_PENALTY_DESCRIPTOR = *mut _DEVICE_SEEK_PENALTY_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_WRITE_AGGREGATION_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub BenefitsFromWriteAggregation: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_WRITE_AGGREGATION_DESCRIPTOR"]
        [::std::mem::size_of::<_DEVICE_WRITE_AGGREGATION_DESCRIPTOR>() - 12usize];
    ["Alignment of _DEVICE_WRITE_AGGREGATION_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_WRITE_AGGREGATION_DESCRIPTOR>() - 4usize];
    ["Offset of field: _DEVICE_WRITE_AGGREGATION_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_WRITE_AGGREGATION_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_WRITE_AGGREGATION_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_WRITE_AGGREGATION_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_WRITE_AGGREGATION_DESCRIPTOR::BenefitsFromWriteAggregation"][::std::mem::offset_of!(
        _DEVICE_WRITE_AGGREGATION_DESCRIPTOR,
        BenefitsFromWriteAggregation
    )
        - 8usize];
};
pub type DEVICE_WRITE_AGGREGATION_DESCRIPTOR = _DEVICE_WRITE_AGGREGATION_DESCRIPTOR;
pub type PDEVICE_WRITE_AGGREGATION_DESCRIPTOR = *mut _DEVICE_WRITE_AGGREGATION_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_TRIM_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub TrimEnabled: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_TRIM_DESCRIPTOR"][::std::mem::size_of::<_DEVICE_TRIM_DESCRIPTOR>() - 12usize];
    ["Alignment of _DEVICE_TRIM_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_TRIM_DESCRIPTOR>() - 4usize];
    ["Offset of field: _DEVICE_TRIM_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_TRIM_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_TRIM_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_TRIM_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_TRIM_DESCRIPTOR::TrimEnabled"]
        [::std::mem::offset_of!(_DEVICE_TRIM_DESCRIPTOR, TrimEnabled) - 8usize];
};
pub type DEVICE_TRIM_DESCRIPTOR = _DEVICE_TRIM_DESCRIPTOR;
pub type PDEVICE_TRIM_DESCRIPTOR = *mut _DEVICE_TRIM_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_LB_PROVISIONING_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub Reserved1: [BYTE; 7usize],
    pub OptimalUnmapGranularity: DWORDLONG,
    pub UnmapGranularityAlignment: DWORDLONG,
    pub MaxUnmapLbaCount: DWORD,
    pub MaxUnmapBlockDescriptorCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_LB_PROVISIONING_DESCRIPTOR"]
        [::std::mem::size_of::<_DEVICE_LB_PROVISIONING_DESCRIPTOR>() - 40usize];
    ["Alignment of _DEVICE_LB_PROVISIONING_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_LB_PROVISIONING_DESCRIPTOR>() - 8usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_LB_PROVISIONING_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_LB_PROVISIONING_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::Reserved1"]
        [::std::mem::offset_of!(_DEVICE_LB_PROVISIONING_DESCRIPTOR, Reserved1) - 9usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::OptimalUnmapGranularity"][::std::mem::offset_of!(
        _DEVICE_LB_PROVISIONING_DESCRIPTOR,
        OptimalUnmapGranularity
    ) - 16usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::UnmapGranularityAlignment"][::std::mem::offset_of!(
        _DEVICE_LB_PROVISIONING_DESCRIPTOR,
        UnmapGranularityAlignment
    ) - 24usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::MaxUnmapLbaCount"]
        [::std::mem::offset_of!(_DEVICE_LB_PROVISIONING_DESCRIPTOR, MaxUnmapLbaCount) - 32usize];
    ["Offset of field: _DEVICE_LB_PROVISIONING_DESCRIPTOR::MaxUnmapBlockDescriptorCount"][::std::mem::offset_of!(
        _DEVICE_LB_PROVISIONING_DESCRIPTOR,
        MaxUnmapBlockDescriptorCount
    )
        - 36usize];
};
impl _DEVICE_LB_PROVISIONING_DESCRIPTOR {
    #[inline]
    pub fn ThinProvisioningEnabled(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ThinProvisioningEnabled(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ThinProvisioningEnabled_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ThinProvisioningEnabled_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn ThinProvisioningReadZeros(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ThinProvisioningReadZeros(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ThinProvisioningReadZeros_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ThinProvisioningReadZeros_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn AnchorSupported(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_AnchorSupported(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AnchorSupported_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_AnchorSupported_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn UnmapGranularityAlignmentValid(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_UnmapGranularityAlignmentValid(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn UnmapGranularityAlignmentValid_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_UnmapGranularityAlignmentValid_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn GetFreeSpaceSupported(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(6usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_GetFreeSpaceSupported(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(6usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn GetFreeSpaceSupported_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                6usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_GetFreeSpaceSupported_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                6usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn MapSupported(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(7usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_MapSupported(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(7usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn MapSupported_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                7usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_MapSupported_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                7usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ThinProvisioningEnabled: BYTE,
        ThinProvisioningReadZeros: BYTE,
        AnchorSupported: BYTE,
        UnmapGranularityAlignmentValid: BYTE,
        GetFreeSpaceSupported: BYTE,
        MapSupported: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ThinProvisioningEnabled: u8 =
                unsafe { ::std::mem::transmute(ThinProvisioningEnabled) };
            ThinProvisioningEnabled as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let ThinProvisioningReadZeros: u8 =
                unsafe { ::std::mem::transmute(ThinProvisioningReadZeros) };
            ThinProvisioningReadZeros as u64
        });
        __bindgen_bitfield_unit.set(2usize, 3u8, {
            let AnchorSupported: u8 = unsafe { ::std::mem::transmute(AnchorSupported) };
            AnchorSupported as u64
        });
        __bindgen_bitfield_unit.set(5usize, 1u8, {
            let UnmapGranularityAlignmentValid: u8 =
                unsafe { ::std::mem::transmute(UnmapGranularityAlignmentValid) };
            UnmapGranularityAlignmentValid as u64
        });
        __bindgen_bitfield_unit.set(6usize, 1u8, {
            let GetFreeSpaceSupported: u8 = unsafe { ::std::mem::transmute(GetFreeSpaceSupported) };
            GetFreeSpaceSupported as u64
        });
        __bindgen_bitfield_unit.set(7usize, 1u8, {
            let MapSupported: u8 = unsafe { ::std::mem::transmute(MapSupported) };
            MapSupported as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type DEVICE_LB_PROVISIONING_DESCRIPTOR = _DEVICE_LB_PROVISIONING_DESCRIPTOR;
pub type PDEVICE_LB_PROVISIONING_DESCRIPTOR = *mut _DEVICE_LB_PROVISIONING_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_LB_PROVISIONING_MAP_RESOURCES {
    pub Size: DWORD,
    pub Version: DWORD,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub Reserved1: [BYTE; 3usize],
    pub _bitfield_align_2: [u8; 0],
    pub _bitfield_2: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub Reserved3: [BYTE; 3usize],
    pub AvailableMappingResources: DWORDLONG,
    pub UsedMappingResources: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_LB_PROVISIONING_MAP_RESOURCES"]
        [::std::mem::size_of::<_STORAGE_LB_PROVISIONING_MAP_RESOURCES>() - 32usize];
    ["Alignment of _STORAGE_LB_PROVISIONING_MAP_RESOURCES"]
        [::std::mem::align_of::<_STORAGE_LB_PROVISIONING_MAP_RESOURCES>() - 8usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::Size"]
        [::std::mem::offset_of!(_STORAGE_LB_PROVISIONING_MAP_RESOURCES, Size) - 0usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::Version"]
        [::std::mem::offset_of!(_STORAGE_LB_PROVISIONING_MAP_RESOURCES, Version) - 4usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_LB_PROVISIONING_MAP_RESOURCES, Reserved1) - 9usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::Reserved3"]
        [::std::mem::offset_of!(_STORAGE_LB_PROVISIONING_MAP_RESOURCES, Reserved3) - 13usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::AvailableMappingResources"][::std::mem::offset_of!(
        _STORAGE_LB_PROVISIONING_MAP_RESOURCES,
        AvailableMappingResources
    )
        - 16usize];
    ["Offset of field: _STORAGE_LB_PROVISIONING_MAP_RESOURCES::UsedMappingResources"][::std::mem::offset_of!(
        _STORAGE_LB_PROVISIONING_MAP_RESOURCES,
        UsedMappingResources
    ) - 24usize];
};
impl _STORAGE_LB_PROVISIONING_MAP_RESOURCES {
    #[inline]
    pub fn AvailableMappingResourcesValid(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_AvailableMappingResourcesValid(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AvailableMappingResourcesValid_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_AvailableMappingResourcesValid_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn UsedMappingResourcesValid(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_UsedMappingResourcesValid(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn UsedMappingResourcesValid_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_UsedMappingResourcesValid_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved0(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 6u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved0(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 6u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved0_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                6u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved0_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                6u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        AvailableMappingResourcesValid: BYTE,
        UsedMappingResourcesValid: BYTE,
        Reserved0: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let AvailableMappingResourcesValid: u8 =
                unsafe { ::std::mem::transmute(AvailableMappingResourcesValid) };
            AvailableMappingResourcesValid as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let UsedMappingResourcesValid: u8 =
                unsafe { ::std::mem::transmute(UsedMappingResourcesValid) };
            UsedMappingResourcesValid as u64
        });
        __bindgen_bitfield_unit.set(2usize, 6u8, {
            let Reserved0: u8 = unsafe { ::std::mem::transmute(Reserved0) };
            Reserved0 as u64
        });
        __bindgen_bitfield_unit
    }
    #[inline]
    pub fn AvailableMappingResourcesScope(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_2.get(0usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_AvailableMappingResourcesScope(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_2.set(0usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn AvailableMappingResourcesScope_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_2),
                0usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_AvailableMappingResourcesScope_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_2),
                0usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn UsedMappingResourcesScope(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_2.get(2usize, 2u8) as u8) }
    }
    #[inline]
    pub fn set_UsedMappingResourcesScope(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_2.set(2usize, 2u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn UsedMappingResourcesScope_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_2),
                2usize,
                2u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_UsedMappingResourcesScope_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_2),
                2usize,
                2u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved2(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_2.get(4usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved2(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_2.set(4usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved2_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_2),
                4usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved2_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_2),
                4usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_2(
        AvailableMappingResourcesScope: BYTE,
        UsedMappingResourcesScope: BYTE,
        Reserved2: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 2u8, {
            let AvailableMappingResourcesScope: u8 =
                unsafe { ::std::mem::transmute(AvailableMappingResourcesScope) };
            AvailableMappingResourcesScope as u64
        });
        __bindgen_bitfield_unit.set(2usize, 2u8, {
            let UsedMappingResourcesScope: u8 =
                unsafe { ::std::mem::transmute(UsedMappingResourcesScope) };
            UsedMappingResourcesScope as u64
        });
        __bindgen_bitfield_unit.set(4usize, 4u8, {
            let Reserved2: u8 = unsafe { ::std::mem::transmute(Reserved2) };
            Reserved2 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type STORAGE_LB_PROVISIONING_MAP_RESOURCES = _STORAGE_LB_PROVISIONING_MAP_RESOURCES;
pub type PSTORAGE_LB_PROVISIONING_MAP_RESOURCES = *mut _STORAGE_LB_PROVISIONING_MAP_RESOURCES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_POWER_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceAttentionSupported: BOOLEAN,
    pub AsynchronousNotificationSupported: BOOLEAN,
    pub IdlePowerManagementEnabled: BOOLEAN,
    pub D3ColdEnabled: BOOLEAN,
    pub D3ColdSupported: BOOLEAN,
    pub NoVerifyDuringIdlePower: BOOLEAN,
    pub Reserved: [BYTE; 2usize],
    pub IdleTimeoutInMS: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_POWER_DESCRIPTOR"]
        [::std::mem::size_of::<_DEVICE_POWER_DESCRIPTOR>() - 20usize];
    ["Alignment of _DEVICE_POWER_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_POWER_DESCRIPTOR>() - 4usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::DeviceAttentionSupported"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, DeviceAttentionSupported) - 8usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::AsynchronousNotificationSupported"][::std::mem::offset_of!(
        _DEVICE_POWER_DESCRIPTOR,
        AsynchronousNotificationSupported
    ) - 9usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::IdlePowerManagementEnabled"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, IdlePowerManagementEnabled) - 10usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::D3ColdEnabled"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, D3ColdEnabled) - 11usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::D3ColdSupported"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, D3ColdSupported) - 12usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::NoVerifyDuringIdlePower"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, NoVerifyDuringIdlePower) - 13usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::Reserved"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, Reserved) - 14usize];
    ["Offset of field: _DEVICE_POWER_DESCRIPTOR::IdleTimeoutInMS"]
        [::std::mem::offset_of!(_DEVICE_POWER_DESCRIPTOR, IdleTimeoutInMS) - 16usize];
};
pub type DEVICE_POWER_DESCRIPTOR = _DEVICE_POWER_DESCRIPTOR;
pub type PDEVICE_POWER_DESCRIPTOR = *mut _DEVICE_POWER_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_COPY_OFFLOAD_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub MaximumTokenLifetime: DWORD,
    pub DefaultTokenLifetime: DWORD,
    pub MaximumTransferSize: DWORDLONG,
    pub OptimalTransferCount: DWORDLONG,
    pub MaximumDataDescriptors: DWORD,
    pub MaximumTransferLengthPerDescriptor: DWORD,
    pub OptimalTransferLengthPerDescriptor: DWORD,
    pub OptimalTransferLengthGranularity: WORD,
    pub Reserved: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_COPY_OFFLOAD_DESCRIPTOR"]
        [::std::mem::size_of::<_DEVICE_COPY_OFFLOAD_DESCRIPTOR>() - 48usize];
    ["Alignment of _DEVICE_COPY_OFFLOAD_DESCRIPTOR"]
        [::std::mem::align_of::<_DEVICE_COPY_OFFLOAD_DESCRIPTOR>() - 8usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::MaximumTokenLifetime"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, MaximumTokenLifetime) - 8usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::DefaultTokenLifetime"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, DefaultTokenLifetime) - 12usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::MaximumTransferSize"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, MaximumTransferSize) - 16usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::OptimalTransferCount"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, OptimalTransferCount) - 24usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::MaximumDataDescriptors"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, MaximumDataDescriptors) - 32usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::MaximumTransferLengthPerDescriptor"][::std::mem::offset_of!(
        _DEVICE_COPY_OFFLOAD_DESCRIPTOR,
        MaximumTransferLengthPerDescriptor
    )
        - 36usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::OptimalTransferLengthPerDescriptor"][::std::mem::offset_of!(
        _DEVICE_COPY_OFFLOAD_DESCRIPTOR,
        OptimalTransferLengthPerDescriptor
    )
        - 40usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::OptimalTransferLengthGranularity"][::std::mem::offset_of!(
        _DEVICE_COPY_OFFLOAD_DESCRIPTOR,
        OptimalTransferLengthGranularity
    )
        - 44usize];
    ["Offset of field: _DEVICE_COPY_OFFLOAD_DESCRIPTOR::Reserved"]
        [::std::mem::offset_of!(_DEVICE_COPY_OFFLOAD_DESCRIPTOR, Reserved) - 46usize];
};
pub type DEVICE_COPY_OFFLOAD_DESCRIPTOR = _DEVICE_COPY_OFFLOAD_DESCRIPTOR;
pub type PDEVICE_COPY_OFFLOAD_DESCRIPTOR = *mut _DEVICE_COPY_OFFLOAD_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NameOffset: DWORD,
    pub NumberOfLogicalCopies: DWORD,
    pub NumberOfPhysicalCopies: DWORD,
    pub PhysicalDiskRedundancy: DWORD,
    pub NumberOfColumns: DWORD,
    pub Interleave: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR>() - 32usize];
    ["Alignment of _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::NameOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR, NameOffset) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::NumberOfLogicalCopies"][::std::mem::offset_of!(
        _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR,
        NumberOfLogicalCopies
    ) - 12usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::NumberOfPhysicalCopies"][::std::mem::offset_of!(
        _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR,
        NumberOfPhysicalCopies
    ) - 16usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::PhysicalDiskRedundancy"][::std::mem::offset_of!(
        _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR,
        PhysicalDiskRedundancy
    ) - 20usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::NumberOfColumns"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR, NumberOfColumns) - 24usize];
    ["Offset of field: _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR::Interleave"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_RESILIENCY_DESCRIPTOR, Interleave) - 28usize];
};
pub type STORAGE_DEVICE_RESILIENCY_DESCRIPTOR = _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR;
pub type PSTORAGE_DEVICE_RESILIENCY_DESCRIPTOR = *mut _STORAGE_DEVICE_RESILIENCY_DESCRIPTOR;
pub const _STORAGE_RPMB_FRAME_TYPE_StorageRpmbFrameTypeUnknown: _STORAGE_RPMB_FRAME_TYPE = 0;
pub const _STORAGE_RPMB_FRAME_TYPE_StorageRpmbFrameTypeStandard: _STORAGE_RPMB_FRAME_TYPE = 1;
pub const _STORAGE_RPMB_FRAME_TYPE_StorageRpmbFrameTypeMax: _STORAGE_RPMB_FRAME_TYPE = 2;
pub type _STORAGE_RPMB_FRAME_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_RPMB_FRAME_TYPE as STORAGE_RPMB_FRAME_TYPE;
pub type PSTORAGE_RPMB_FRAME_TYPE = *mut _STORAGE_RPMB_FRAME_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_RPMB_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SizeInBytes: DWORD,
    pub MaxReliableWriteSizeInBytes: DWORD,
    pub FrameFormat: STORAGE_RPMB_FRAME_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_RPMB_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_RPMB_DESCRIPTOR>() - 20usize];
    ["Alignment of _STORAGE_RPMB_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_RPMB_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_RPMB_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_RPMB_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_RPMB_DESCRIPTOR::SizeInBytes"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DESCRIPTOR, SizeInBytes) - 8usize];
    ["Offset of field: _STORAGE_RPMB_DESCRIPTOR::MaxReliableWriteSizeInBytes"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DESCRIPTOR, MaxReliableWriteSizeInBytes) - 12usize];
    ["Offset of field: _STORAGE_RPMB_DESCRIPTOR::FrameFormat"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DESCRIPTOR, FrameFormat) - 16usize];
};
pub type STORAGE_RPMB_DESCRIPTOR = _STORAGE_RPMB_DESCRIPTOR;
pub type PSTORAGE_RPMB_DESCRIPTOR = *mut _STORAGE_RPMB_DESCRIPTOR;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmUnknown: _STORAGE_CRYPTO_ALGORITHM_ID =
    0;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmXTSAES: _STORAGE_CRYPTO_ALGORITHM_ID =
    1;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmBitlockerAESCBC:
    _STORAGE_CRYPTO_ALGORITHM_ID = 2;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmAESECB: _STORAGE_CRYPTO_ALGORITHM_ID =
    3;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmESSIVAESCBC:
    _STORAGE_CRYPTO_ALGORITHM_ID = 4;
pub const _STORAGE_CRYPTO_ALGORITHM_ID_StorageCryptoAlgorithmMax: _STORAGE_CRYPTO_ALGORITHM_ID = 5;
pub type _STORAGE_CRYPTO_ALGORITHM_ID = ::std::os::raw::c_int;
pub use self::_STORAGE_CRYPTO_ALGORITHM_ID as STORAGE_CRYPTO_ALGORITHM_ID;
pub type PSTORAGE_CRYPTO_ALGORITHM_ID = *mut _STORAGE_CRYPTO_ALGORITHM_ID;
pub const _STORAGE_CRYPTO_KEY_SIZE_StorageCryptoKeySizeUnknown: _STORAGE_CRYPTO_KEY_SIZE = 0;
pub const _STORAGE_CRYPTO_KEY_SIZE_StorageCryptoKeySize128Bits: _STORAGE_CRYPTO_KEY_SIZE = 1;
pub const _STORAGE_CRYPTO_KEY_SIZE_StorageCryptoKeySize192Bits: _STORAGE_CRYPTO_KEY_SIZE = 2;
pub const _STORAGE_CRYPTO_KEY_SIZE_StorageCryptoKeySize256Bits: _STORAGE_CRYPTO_KEY_SIZE = 3;
pub const _STORAGE_CRYPTO_KEY_SIZE_StorageCryptoKeySize512Bits: _STORAGE_CRYPTO_KEY_SIZE = 4;
pub type _STORAGE_CRYPTO_KEY_SIZE = ::std::os::raw::c_int;
pub use self::_STORAGE_CRYPTO_KEY_SIZE as STORAGE_CRYPTO_KEY_SIZE;
pub type PSTORAGE_CRYPTO_KEY_SIZE = *mut _STORAGE_CRYPTO_KEY_SIZE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_CRYPTO_CAPABILITY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub CryptoCapabilityIndex: DWORD,
    pub AlgorithmId: STORAGE_CRYPTO_ALGORITHM_ID,
    pub KeySize: STORAGE_CRYPTO_KEY_SIZE,
    pub DataUnitSizeBitmask: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_CRYPTO_CAPABILITY"]
        [::std::mem::size_of::<_STORAGE_CRYPTO_CAPABILITY>() - 24usize];
    ["Alignment of _STORAGE_CRYPTO_CAPABILITY"]
        [::std::mem::align_of::<_STORAGE_CRYPTO_CAPABILITY>() - 4usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::Version"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, Version) - 0usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::Size"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, Size) - 4usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::CryptoCapabilityIndex"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, CryptoCapabilityIndex) - 8usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::AlgorithmId"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, AlgorithmId) - 12usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::KeySize"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, KeySize) - 16usize];
    ["Offset of field: _STORAGE_CRYPTO_CAPABILITY::DataUnitSizeBitmask"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_CAPABILITY, DataUnitSizeBitmask) - 20usize];
};
pub type STORAGE_CRYPTO_CAPABILITY = _STORAGE_CRYPTO_CAPABILITY;
pub type PSTORAGE_CRYPTO_CAPABILITY = *mut _STORAGE_CRYPTO_CAPABILITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_CRYPTO_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumKeysSupported: DWORD,
    pub NumCryptoCapabilities: DWORD,
    pub CryptoCapabilities: [STORAGE_CRYPTO_CAPABILITY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_CRYPTO_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_CRYPTO_DESCRIPTOR>() - 40usize];
    ["Alignment of _STORAGE_CRYPTO_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_CRYPTO_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_CRYPTO_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_CRYPTO_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_CRYPTO_DESCRIPTOR::NumKeysSupported"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_DESCRIPTOR, NumKeysSupported) - 8usize];
    ["Offset of field: _STORAGE_CRYPTO_DESCRIPTOR::NumCryptoCapabilities"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_DESCRIPTOR, NumCryptoCapabilities) - 12usize];
    ["Offset of field: _STORAGE_CRYPTO_DESCRIPTOR::CryptoCapabilities"]
        [::std::mem::offset_of!(_STORAGE_CRYPTO_DESCRIPTOR, CryptoCapabilities) - 16usize];
};
pub type STORAGE_CRYPTO_DESCRIPTOR = _STORAGE_CRYPTO_DESCRIPTOR;
pub type PSTORAGE_CRYPTO_DESCRIPTOR = *mut _STORAGE_CRYPTO_DESCRIPTOR;
pub const _STORAGE_TIER_MEDIA_TYPE_StorageTierMediaTypeUnspecified: _STORAGE_TIER_MEDIA_TYPE = 0;
pub const _STORAGE_TIER_MEDIA_TYPE_StorageTierMediaTypeDisk: _STORAGE_TIER_MEDIA_TYPE = 1;
pub const _STORAGE_TIER_MEDIA_TYPE_StorageTierMediaTypeSsd: _STORAGE_TIER_MEDIA_TYPE = 2;
pub const _STORAGE_TIER_MEDIA_TYPE_StorageTierMediaTypeScm: _STORAGE_TIER_MEDIA_TYPE = 4;
pub const _STORAGE_TIER_MEDIA_TYPE_StorageTierMediaTypeMax: _STORAGE_TIER_MEDIA_TYPE = 5;
pub type _STORAGE_TIER_MEDIA_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_TIER_MEDIA_TYPE as STORAGE_TIER_MEDIA_TYPE;
pub type PSTORAGE_TIER_MEDIA_TYPE = *mut _STORAGE_TIER_MEDIA_TYPE;
pub const _STORAGE_TIER_CLASS_StorageTierClassUnspecified: _STORAGE_TIER_CLASS = 0;
pub const _STORAGE_TIER_CLASS_StorageTierClassCapacity: _STORAGE_TIER_CLASS = 1;
pub const _STORAGE_TIER_CLASS_StorageTierClassPerformance: _STORAGE_TIER_CLASS = 2;
pub const _STORAGE_TIER_CLASS_StorageTierClassMax: _STORAGE_TIER_CLASS = 3;
pub type _STORAGE_TIER_CLASS = ::std::os::raw::c_int;
pub use self::_STORAGE_TIER_CLASS as STORAGE_TIER_CLASS;
pub type PSTORAGE_TIER_CLASS = *mut _STORAGE_TIER_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_TIER {
    pub Id: GUID,
    pub Name: [WCHAR; 256usize],
    pub Description: [WCHAR; 256usize],
    pub Flags: DWORDLONG,
    pub ProvisionedCapacity: DWORDLONG,
    pub MediaType: STORAGE_TIER_MEDIA_TYPE,
    pub Class: STORAGE_TIER_CLASS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_TIER"][::std::mem::size_of::<_STORAGE_TIER>() - 1064usize];
    ["Alignment of _STORAGE_TIER"][::std::mem::align_of::<_STORAGE_TIER>() - 8usize];
    ["Offset of field: _STORAGE_TIER::Id"][::std::mem::offset_of!(_STORAGE_TIER, Id) - 0usize];
    ["Offset of field: _STORAGE_TIER::Name"][::std::mem::offset_of!(_STORAGE_TIER, Name) - 16usize];
    ["Offset of field: _STORAGE_TIER::Description"]
        [::std::mem::offset_of!(_STORAGE_TIER, Description) - 528usize];
    ["Offset of field: _STORAGE_TIER::Flags"]
        [::std::mem::offset_of!(_STORAGE_TIER, Flags) - 1040usize];
    ["Offset of field: _STORAGE_TIER::ProvisionedCapacity"]
        [::std::mem::offset_of!(_STORAGE_TIER, ProvisionedCapacity) - 1048usize];
    ["Offset of field: _STORAGE_TIER::MediaType"]
        [::std::mem::offset_of!(_STORAGE_TIER, MediaType) - 1056usize];
    ["Offset of field: _STORAGE_TIER::Class"]
        [::std::mem::offset_of!(_STORAGE_TIER, Class) - 1060usize];
};
pub type STORAGE_TIER = _STORAGE_TIER;
pub type PSTORAGE_TIER = *mut _STORAGE_TIER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_TIERING_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub TotalNumberOfTiers: DWORD,
    pub NumberOfTiersReturned: DWORD,
    pub Tiers: [STORAGE_TIER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_TIERING_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_TIERING_DESCRIPTOR>() - 1088usize];
    ["Alignment of _STORAGE_DEVICE_TIERING_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_TIERING_DESCRIPTOR>() - 8usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_TIERING_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_TIERING_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::Flags"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_TIERING_DESCRIPTOR, Flags) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::TotalNumberOfTiers"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_TIERING_DESCRIPTOR, TotalNumberOfTiers) - 12usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::NumberOfTiersReturned"][::std::mem::offset_of!(
        _STORAGE_DEVICE_TIERING_DESCRIPTOR,
        NumberOfTiersReturned
    ) - 16usize];
    ["Offset of field: _STORAGE_DEVICE_TIERING_DESCRIPTOR::Tiers"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_TIERING_DESCRIPTOR, Tiers) - 24usize];
};
pub type STORAGE_DEVICE_TIERING_DESCRIPTOR = _STORAGE_DEVICE_TIERING_DESCRIPTOR;
pub type PSTORAGE_DEVICE_TIERING_DESCRIPTOR = *mut _STORAGE_DEVICE_TIERING_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumberOfFaultDomains: DWORD,
    pub FaultDomainIds: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR>() - 28usize];
    ["Alignment of _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR::NumberOfFaultDomains"][::std::mem::offset_of!(
        _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR,
        NumberOfFaultDomains
    ) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR::FaultDomainIds"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR, FaultDomainIds) - 12usize];
};
pub type STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR = _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR;
pub type PSTORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR = *mut _STORAGE_DEVICE_FAULT_DOMAIN_DESCRIPTOR;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeUnknown: _STORAGE_PROTOCOL_TYPE = 0;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeScsi: _STORAGE_PROTOCOL_TYPE = 1;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeAta: _STORAGE_PROTOCOL_TYPE = 2;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeNvme: _STORAGE_PROTOCOL_TYPE = 3;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeSd: _STORAGE_PROTOCOL_TYPE = 4;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeUfs: _STORAGE_PROTOCOL_TYPE = 5;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeProprietary: _STORAGE_PROTOCOL_TYPE = 126;
pub const _STORAGE_PROTOCOL_TYPE_ProtocolTypeMaxReserved: _STORAGE_PROTOCOL_TYPE = 127;
pub type _STORAGE_PROTOCOL_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_PROTOCOL_TYPE as STORAGE_PROTOCOL_TYPE;
pub type PSTORAGE_PROTOCOL_TYPE = *mut _STORAGE_PROTOCOL_TYPE;
pub const _STORAGE_PROTOCOL_NVME_DATA_TYPE_NVMeDataTypeUnknown: _STORAGE_PROTOCOL_NVME_DATA_TYPE =
    0;
pub const _STORAGE_PROTOCOL_NVME_DATA_TYPE_NVMeDataTypeIdentify: _STORAGE_PROTOCOL_NVME_DATA_TYPE =
    1;
pub const _STORAGE_PROTOCOL_NVME_DATA_TYPE_NVMeDataTypeLogPage: _STORAGE_PROTOCOL_NVME_DATA_TYPE =
    2;
pub const _STORAGE_PROTOCOL_NVME_DATA_TYPE_NVMeDataTypeFeature: _STORAGE_PROTOCOL_NVME_DATA_TYPE =
    3;
pub type _STORAGE_PROTOCOL_NVME_DATA_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_PROTOCOL_NVME_DATA_TYPE as STORAGE_PROTOCOL_NVME_DATA_TYPE;
pub type PSTORAGE_PROTOCOL_NVME_DATA_TYPE = *mut _STORAGE_PROTOCOL_NVME_DATA_TYPE;
pub const _STORAGE_PROTOCOL_ATA_DATA_TYPE_AtaDataTypeUnknown: _STORAGE_PROTOCOL_ATA_DATA_TYPE = 0;
pub const _STORAGE_PROTOCOL_ATA_DATA_TYPE_AtaDataTypeIdentify: _STORAGE_PROTOCOL_ATA_DATA_TYPE = 1;
pub const _STORAGE_PROTOCOL_ATA_DATA_TYPE_AtaDataTypeLogPage: _STORAGE_PROTOCOL_ATA_DATA_TYPE = 2;
pub type _STORAGE_PROTOCOL_ATA_DATA_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_PROTOCOL_ATA_DATA_TYPE as STORAGE_PROTOCOL_ATA_DATA_TYPE;
pub type PSTORAGE_PROTOCOL_ATA_DATA_TYPE = *mut _STORAGE_PROTOCOL_ATA_DATA_TYPE;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeUnknown: _STORAGE_PROTOCOL_UFS_DATA_TYPE = 0;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeQueryDescriptor:
    _STORAGE_PROTOCOL_UFS_DATA_TYPE = 1;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeQueryAttribute:
    _STORAGE_PROTOCOL_UFS_DATA_TYPE = 2;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeQueryFlag: _STORAGE_PROTOCOL_UFS_DATA_TYPE = 3;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeQueryDmeAttribute:
    _STORAGE_PROTOCOL_UFS_DATA_TYPE = 4;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeQueryDmePeerAttribute:
    _STORAGE_PROTOCOL_UFS_DATA_TYPE = 5;
pub const _STORAGE_PROTOCOL_UFS_DATA_TYPE_UfsDataTypeMax: _STORAGE_PROTOCOL_UFS_DATA_TYPE = 6;
pub type _STORAGE_PROTOCOL_UFS_DATA_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_PROTOCOL_UFS_DATA_TYPE as STORAGE_PROTOCOL_UFS_DATA_TYPE;
pub type PSTORAGE_PROTOCOL_UFS_DATA_TYPE = *mut _STORAGE_PROTOCOL_UFS_DATA_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE {
    pub __bindgen_anon_1: _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1,
    pub AsUlong: DWORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1"][::std::mem::size_of::<
        _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1"][::std::mem::align_of::<
        _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1,
    >() - 4usize];
};
impl _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE__bindgen_ty_1 {
    #[inline]
    pub fn RetainAsynEvent(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_RetainAsynEvent(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn RetainAsynEvent_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_RetainAsynEvent_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn LogSpecificField(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_LogSpecificField(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn LogSpecificField_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_LogSpecificField_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 27u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 27u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                27u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                27u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        RetainAsynEvent: DWORD,
        LogSpecificField: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let RetainAsynEvent: u32 = unsafe { ::std::mem::transmute(RetainAsynEvent) };
            RetainAsynEvent as u64
        });
        __bindgen_bitfield_unit.set(1usize, 4u8, {
            let LogSpecificField: u32 = unsafe { ::std::mem::transmute(LogSpecificField) };
            LogSpecificField as u64
        });
        __bindgen_bitfield_unit.set(5usize, 27u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE>() - 4usize];
    ["Alignment of _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE::AsUlong"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE, AsUlong) - 0usize];
};
pub type STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE = _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE;
pub type PSTORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE =
    *mut _STORAGE_PROTOCOL_DATA_SUBVALUE_GET_LOG_PAGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_SPECIFIC_DATA {
    pub ProtocolType: STORAGE_PROTOCOL_TYPE,
    pub DataType: DWORD,
    pub ProtocolDataRequestValue: DWORD,
    pub ProtocolDataRequestSubValue: DWORD,
    pub ProtocolDataOffset: DWORD,
    pub ProtocolDataLength: DWORD,
    pub FixedProtocolReturnData: DWORD,
    pub ProtocolDataRequestSubValue2: DWORD,
    pub ProtocolDataRequestSubValue3: DWORD,
    pub ProtocolDataRequestSubValue4: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_SPECIFIC_DATA"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_SPECIFIC_DATA>() - 40usize];
    ["Alignment of _STORAGE_PROTOCOL_SPECIFIC_DATA"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_SPECIFIC_DATA>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolType"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA, ProtocolType) - 0usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::DataType"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA, DataType) - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataRequestValue"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        ProtocolDataRequestValue
    ) - 8usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataRequestSubValue"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        ProtocolDataRequestSubValue
    ) - 12usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataOffset"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA, ProtocolDataOffset) - 16usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA, ProtocolDataLength) - 20usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::FixedProtocolReturnData"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        FixedProtocolReturnData
    ) - 24usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataRequestSubValue2"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        ProtocolDataRequestSubValue2
    ) - 28usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataRequestSubValue3"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        ProtocolDataRequestSubValue3
    ) - 32usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA::ProtocolDataRequestSubValue4"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA,
        ProtocolDataRequestSubValue4
    ) - 36usize];
};
pub type STORAGE_PROTOCOL_SPECIFIC_DATA = _STORAGE_PROTOCOL_SPECIFIC_DATA;
pub type PSTORAGE_PROTOCOL_SPECIFIC_DATA = *mut _STORAGE_PROTOCOL_SPECIFIC_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT {
    pub ProtocolType: STORAGE_PROTOCOL_TYPE,
    pub DataType: DWORD,
    pub ProtocolDataValue: DWORD,
    pub ProtocolDataSubValue: DWORD,
    pub ProtocolDataOffset: DWORD,
    pub ProtocolDataLength: DWORD,
    pub FixedProtocolReturnData: DWORD,
    pub ProtocolDataSubValue2: DWORD,
    pub ProtocolDataSubValue3: DWORD,
    pub ProtocolDataSubValue4: DWORD,
    pub ProtocolDataSubValue5: DWORD,
    pub Reserved: [DWORD; 5usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT>() - 64usize];
    ["Alignment of _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolType"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, ProtocolType) - 0usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::DataType"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, DataType) - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataValue"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, ProtocolDataValue) - 8usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataSubValue"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        ProtocolDataSubValue
    ) - 12usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataOffset"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, ProtocolDataOffset) - 16usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, ProtocolDataLength) - 20usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::FixedProtocolReturnData"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        FixedProtocolReturnData
    ) - 24usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataSubValue2"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        ProtocolDataSubValue2
    ) - 28usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataSubValue3"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        ProtocolDataSubValue3
    ) - 32usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataSubValue4"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        ProtocolDataSubValue4
    ) - 36usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::ProtocolDataSubValue5"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
        ProtocolDataSubValue5
    ) - 40usize];
    ["Offset of field: _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT::Reserved"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_SPECIFIC_DATA_EXT, Reserved) - 44usize];
};
pub type STORAGE_PROTOCOL_SPECIFIC_DATA_EXT = _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT;
pub type PSTORAGE_PROTOCOL_SPECIFIC_DATA_EXT = *mut _STORAGE_PROTOCOL_SPECIFIC_DATA_EXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_DATA_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ProtocolSpecificData: STORAGE_PROTOCOL_SPECIFIC_DATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_DATA_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_DATA_DESCRIPTOR>() - 48usize];
    ["Alignment of _STORAGE_PROTOCOL_DATA_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_DATA_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR::ProtocolSpecificData"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_DESCRIPTOR, ProtocolSpecificData) - 8usize];
};
pub type STORAGE_PROTOCOL_DATA_DESCRIPTOR = _STORAGE_PROTOCOL_DATA_DESCRIPTOR;
pub type PSTORAGE_PROTOCOL_DATA_DESCRIPTOR = *mut _STORAGE_PROTOCOL_DATA_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ProtocolSpecificData: STORAGE_PROTOCOL_SPECIFIC_DATA_EXT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT>() - 72usize];
    ["Alignment of _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT::Version"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT, Version) - 0usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT::Size"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT, Size) - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT::ProtocolSpecificData"][::std::mem::offset_of!(
        _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT,
        ProtocolSpecificData
    ) - 8usize];
};
pub type STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT = _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT;
pub type PSTORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT = *mut _STORAGE_PROTOCOL_DATA_DESCRIPTOR_EXT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_TEMPERATURE_INFO {
    pub Index: WORD,
    pub Temperature: SHORT,
    pub OverThreshold: SHORT,
    pub UnderThreshold: SHORT,
    pub OverThresholdChangable: BOOLEAN,
    pub UnderThresholdChangable: BOOLEAN,
    pub EventGenerated: BOOLEAN,
    pub Reserved0: BYTE,
    pub Reserved1: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_TEMPERATURE_INFO"]
        [::std::mem::size_of::<_STORAGE_TEMPERATURE_INFO>() - 16usize];
    ["Alignment of _STORAGE_TEMPERATURE_INFO"]
        [::std::mem::align_of::<_STORAGE_TEMPERATURE_INFO>() - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::Index"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, Index) - 0usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::Temperature"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, Temperature) - 2usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::OverThreshold"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, OverThreshold) - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::UnderThreshold"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, UnderThreshold) - 6usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::OverThresholdChangable"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, OverThresholdChangable) - 8usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::UnderThresholdChangable"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, UnderThresholdChangable) - 9usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::EventGenerated"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, EventGenerated) - 10usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, Reserved0) - 11usize];
    ["Offset of field: _STORAGE_TEMPERATURE_INFO::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_INFO, Reserved1) - 12usize];
};
pub type STORAGE_TEMPERATURE_INFO = _STORAGE_TEMPERATURE_INFO;
pub type PSTORAGE_TEMPERATURE_INFO = *mut _STORAGE_TEMPERATURE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_TEMPERATURE_DATA_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub CriticalTemperature: SHORT,
    pub WarningTemperature: SHORT,
    pub InfoCount: WORD,
    pub Reserved0: [BYTE; 2usize],
    pub Reserved1: [DWORD; 2usize],
    pub TemperatureInfo: [STORAGE_TEMPERATURE_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_TEMPERATURE_DATA_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_TEMPERATURE_DATA_DESCRIPTOR>() - 40usize];
    ["Alignment of _STORAGE_TEMPERATURE_DATA_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_TEMPERATURE_DATA_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::CriticalTemperature"][::std::mem::offset_of!(
        _STORAGE_TEMPERATURE_DATA_DESCRIPTOR,
        CriticalTemperature
    ) - 8usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::WarningTemperature"][::std::mem::offset_of!(
        _STORAGE_TEMPERATURE_DATA_DESCRIPTOR,
        WarningTemperature
    ) - 10usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::InfoCount"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, InfoCount) - 12usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, Reserved0) - 14usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, Reserved1) - 16usize];
    ["Offset of field: _STORAGE_TEMPERATURE_DATA_DESCRIPTOR::TemperatureInfo"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_DATA_DESCRIPTOR, TemperatureInfo) - 24usize];
};
pub type STORAGE_TEMPERATURE_DATA_DESCRIPTOR = _STORAGE_TEMPERATURE_DATA_DESCRIPTOR;
pub type PSTORAGE_TEMPERATURE_DATA_DESCRIPTOR = *mut _STORAGE_TEMPERATURE_DATA_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_TEMPERATURE_THRESHOLD {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: WORD,
    pub Index: WORD,
    pub Threshold: SHORT,
    pub OverThreshold: BOOLEAN,
    pub Reserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_TEMPERATURE_THRESHOLD"]
        [::std::mem::size_of::<_STORAGE_TEMPERATURE_THRESHOLD>() - 16usize];
    ["Alignment of _STORAGE_TEMPERATURE_THRESHOLD"]
        [::std::mem::align_of::<_STORAGE_TEMPERATURE_THRESHOLD>() - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Version"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Version) - 0usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Size"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Size) - 4usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Flags"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Flags) - 8usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Index"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Index) - 10usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Threshold"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Threshold) - 12usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::OverThreshold"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, OverThreshold) - 14usize];
    ["Offset of field: _STORAGE_TEMPERATURE_THRESHOLD::Reserved"]
        [::std::mem::offset_of!(_STORAGE_TEMPERATURE_THRESHOLD, Reserved) - 15usize];
};
pub type STORAGE_TEMPERATURE_THRESHOLD = _STORAGE_TEMPERATURE_THRESHOLD;
pub type PSTORAGE_TEMPERATURE_THRESHOLD = *mut _STORAGE_TEMPERATURE_THRESHOLD;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorUnknown: _STORAGE_DEVICE_FORM_FACTOR = 0;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactor3_5: _STORAGE_DEVICE_FORM_FACTOR = 1;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactor2_5: _STORAGE_DEVICE_FORM_FACTOR = 2;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactor1_8: _STORAGE_DEVICE_FORM_FACTOR = 3;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactor1_8Less: _STORAGE_DEVICE_FORM_FACTOR = 4;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorEmbedded: _STORAGE_DEVICE_FORM_FACTOR = 5;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorMemoryCard: _STORAGE_DEVICE_FORM_FACTOR = 6;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactormSata: _STORAGE_DEVICE_FORM_FACTOR = 7;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorM_2: _STORAGE_DEVICE_FORM_FACTOR = 8;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorPCIeBoard: _STORAGE_DEVICE_FORM_FACTOR = 9;
pub const _STORAGE_DEVICE_FORM_FACTOR_FormFactorDimm: _STORAGE_DEVICE_FORM_FACTOR = 10;
pub type _STORAGE_DEVICE_FORM_FACTOR = ::std::os::raw::c_int;
pub use self::_STORAGE_DEVICE_FORM_FACTOR as STORAGE_DEVICE_FORM_FACTOR;
pub type PSTORAGE_DEVICE_FORM_FACTOR = *mut _STORAGE_DEVICE_FORM_FACTOR;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusUnknown: _STORAGE_COMPONENT_HEALTH_STATUS =
    0;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusNormal: _STORAGE_COMPONENT_HEALTH_STATUS = 1;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusThrottled: _STORAGE_COMPONENT_HEALTH_STATUS =
    2;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusWarning: _STORAGE_COMPONENT_HEALTH_STATUS =
    3;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusDisabled: _STORAGE_COMPONENT_HEALTH_STATUS =
    4;
pub const _STORAGE_COMPONENT_HEALTH_STATUS_HealthStatusFailed: _STORAGE_COMPONENT_HEALTH_STATUS = 5;
pub type _STORAGE_COMPONENT_HEALTH_STATUS = ::std::os::raw::c_int;
pub use self::_STORAGE_COMPONENT_HEALTH_STATUS as STORAGE_COMPONENT_HEALTH_STATUS;
pub type PSTORAGE_COMPONENT_HEALTH_STATUS = *mut _STORAGE_COMPONENT_HEALTH_STATUS;
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_SPEC_VERSION {
    pub __bindgen_anon_1: _STORAGE_SPEC_VERSION__bindgen_ty_1,
    pub AsUlong: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_SPEC_VERSION__bindgen_ty_1 {
    pub MinorVersion: _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1,
    pub MajorVersion: WORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1 {
    pub __bindgen_anon_1: _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    pub AsUshort: WORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub SubMinor: BYTE,
    pub Minor: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    >() - 2usize];
    ["Alignment of _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>()
            - 1usize];
    ["Offset of field: _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::SubMinor"] [:: std :: mem :: offset_of ! (_STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , SubMinor) - 0usize] ;
    ["Offset of field: _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::Minor"][::std::mem::offset_of!(
        _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        Minor
    )
        - 1usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Alignment of _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1::AsUshort"][::std::mem::offset_of!(
        _STORAGE_SPEC_VERSION__bindgen_ty_1__bindgen_ty_1,
        AsUshort
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_SPEC_VERSION__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_SPEC_VERSION__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_SPEC_VERSION__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_SPEC_VERSION__bindgen_ty_1>() - 2usize];
    ["Offset of field: _STORAGE_SPEC_VERSION__bindgen_ty_1::MinorVersion"]
        [::std::mem::offset_of!(_STORAGE_SPEC_VERSION__bindgen_ty_1, MinorVersion) - 0usize];
    ["Offset of field: _STORAGE_SPEC_VERSION__bindgen_ty_1::MajorVersion"]
        [::std::mem::offset_of!(_STORAGE_SPEC_VERSION__bindgen_ty_1, MajorVersion) - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_SPEC_VERSION"][::std::mem::size_of::<_STORAGE_SPEC_VERSION>() - 4usize];
    ["Alignment of _STORAGE_SPEC_VERSION"]
        [::std::mem::align_of::<_STORAGE_SPEC_VERSION>() - 4usize];
    ["Offset of field: _STORAGE_SPEC_VERSION::AsUlong"]
        [::std::mem::offset_of!(_STORAGE_SPEC_VERSION, AsUlong) - 0usize];
};
pub type STORAGE_SPEC_VERSION = _STORAGE_SPEC_VERSION;
pub type PSTORAGE_SPEC_VERSION = *mut _STORAGE_SPEC_VERSION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_PHYSICAL_DEVICE_DATA {
    pub DeviceId: DWORD,
    pub Role: DWORD,
    pub HealthStatus: STORAGE_COMPONENT_HEALTH_STATUS,
    pub CommandProtocol: STORAGE_PROTOCOL_TYPE,
    pub SpecVersion: STORAGE_SPEC_VERSION,
    pub FormFactor: STORAGE_DEVICE_FORM_FACTOR,
    pub Vendor: [BYTE; 8usize],
    pub Model: [BYTE; 40usize],
    pub FirmwareRevision: [BYTE; 16usize],
    pub Capacity: DWORDLONG,
    pub PhysicalLocation: [BYTE; 32usize],
    pub Reserved: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PHYSICAL_DEVICE_DATA"]
        [::std::mem::size_of::<_STORAGE_PHYSICAL_DEVICE_DATA>() - 136usize];
    ["Alignment of _STORAGE_PHYSICAL_DEVICE_DATA"]
        [::std::mem::align_of::<_STORAGE_PHYSICAL_DEVICE_DATA>() - 8usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::DeviceId"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, DeviceId) - 0usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::Role"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, Role) - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::HealthStatus"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, HealthStatus) - 8usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::CommandProtocol"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, CommandProtocol) - 12usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::SpecVersion"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, SpecVersion) - 16usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::FormFactor"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, FormFactor) - 20usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::Vendor"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, Vendor) - 24usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::Model"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, Model) - 32usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::FirmwareRevision"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, FirmwareRevision) - 72usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::Capacity"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, Capacity) - 88usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::PhysicalLocation"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, PhysicalLocation) - 96usize];
    ["Offset of field: _STORAGE_PHYSICAL_DEVICE_DATA::Reserved"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_DEVICE_DATA, Reserved) - 128usize];
};
pub type STORAGE_PHYSICAL_DEVICE_DATA = _STORAGE_PHYSICAL_DEVICE_DATA;
pub type PSTORAGE_PHYSICAL_DEVICE_DATA = *mut _STORAGE_PHYSICAL_DEVICE_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_PHYSICAL_ADAPTER_DATA {
    pub AdapterId: DWORD,
    pub HealthStatus: STORAGE_COMPONENT_HEALTH_STATUS,
    pub CommandProtocol: STORAGE_PROTOCOL_TYPE,
    pub SpecVersion: STORAGE_SPEC_VERSION,
    pub Vendor: [BYTE; 8usize],
    pub Model: [BYTE; 40usize],
    pub FirmwareRevision: [BYTE; 16usize],
    pub PhysicalLocation: [BYTE; 32usize],
    pub ExpanderConnected: BOOLEAN,
    pub Reserved0: [BYTE; 3usize],
    pub Reserved1: [DWORD; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PHYSICAL_ADAPTER_DATA"]
        [::std::mem::size_of::<_STORAGE_PHYSICAL_ADAPTER_DATA>() - 128usize];
    ["Alignment of _STORAGE_PHYSICAL_ADAPTER_DATA"]
        [::std::mem::align_of::<_STORAGE_PHYSICAL_ADAPTER_DATA>() - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::AdapterId"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, AdapterId) - 0usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::HealthStatus"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, HealthStatus) - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::CommandProtocol"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, CommandProtocol) - 8usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::SpecVersion"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, SpecVersion) - 12usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::Vendor"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, Vendor) - 16usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::Model"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, Model) - 24usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::FirmwareRevision"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, FirmwareRevision) - 64usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::PhysicalLocation"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, PhysicalLocation) - 80usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::ExpanderConnected"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, ExpanderConnected) - 112usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, Reserved0) - 113usize];
    ["Offset of field: _STORAGE_PHYSICAL_ADAPTER_DATA::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_ADAPTER_DATA, Reserved1) - 116usize];
};
pub type STORAGE_PHYSICAL_ADAPTER_DATA = _STORAGE_PHYSICAL_ADAPTER_DATA;
pub type PSTORAGE_PHYSICAL_ADAPTER_DATA = *mut _STORAGE_PHYSICAL_ADAPTER_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PHYSICAL_NODE_DATA {
    pub NodeId: DWORD,
    pub AdapterCount: DWORD,
    pub AdapterDataLength: DWORD,
    pub AdapterDataOffset: DWORD,
    pub DeviceCount: DWORD,
    pub DeviceDataLength: DWORD,
    pub DeviceDataOffset: DWORD,
    pub Reserved: [DWORD; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PHYSICAL_NODE_DATA"]
        [::std::mem::size_of::<_STORAGE_PHYSICAL_NODE_DATA>() - 40usize];
    ["Alignment of _STORAGE_PHYSICAL_NODE_DATA"]
        [::std::mem::align_of::<_STORAGE_PHYSICAL_NODE_DATA>() - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::NodeId"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, NodeId) - 0usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::AdapterCount"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, AdapterCount) - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::AdapterDataLength"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, AdapterDataLength) - 8usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::AdapterDataOffset"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, AdapterDataOffset) - 12usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::DeviceCount"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, DeviceCount) - 16usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::DeviceDataLength"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, DeviceDataLength) - 20usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::DeviceDataOffset"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, DeviceDataOffset) - 24usize];
    ["Offset of field: _STORAGE_PHYSICAL_NODE_DATA::Reserved"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_NODE_DATA, Reserved) - 28usize];
};
pub type STORAGE_PHYSICAL_NODE_DATA = _STORAGE_PHYSICAL_NODE_DATA;
pub type PSTORAGE_PHYSICAL_NODE_DATA = *mut _STORAGE_PHYSICAL_NODE_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NodeCount: DWORD,
    pub Reserved: DWORD,
    pub Node: [STORAGE_PHYSICAL_NODE_DATA; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR>() - 56usize];
    ["Alignment of _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR::NodeCount"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR, NodeCount) - 8usize];
    ["Offset of field: _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR::Reserved"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR, Reserved) - 12usize];
    ["Offset of field: _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR::Node"]
        [::std::mem::offset_of!(_STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR, Node) - 16usize];
};
pub type STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR = _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR;
pub type PSTORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR = *mut _STORAGE_PHYSICAL_TOPOLOGY_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub LunMaxIoCount: DWORD,
    pub AdapterMaxIoCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR>() - 16usize];
    ["Alignment of _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR::LunMaxIoCount"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR, LunMaxIoCount) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR::AdapterMaxIoCount"][::std::mem::offset_of!(
        _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR,
        AdapterMaxIoCount
    ) - 12usize];
};
pub type STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR = _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR;
pub type PSTORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR = *mut _STORAGE_DEVICE_IO_CAPABILITY_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Attributes: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR>() - 16usize];
    ["Alignment of _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR>() - 8usize];
    ["Offset of field: _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR::Attributes"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR, Attributes) - 8usize];
};
pub type STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR = _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR;
pub type PSTORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR = *mut _STORAGE_DEVICE_ATTRIBUTES_DESCRIPTOR;
pub const _STORAGE_DISK_HEALTH_STATUS_DiskHealthUnknown: _STORAGE_DISK_HEALTH_STATUS = 0;
pub const _STORAGE_DISK_HEALTH_STATUS_DiskHealthUnhealthy: _STORAGE_DISK_HEALTH_STATUS = 1;
pub const _STORAGE_DISK_HEALTH_STATUS_DiskHealthWarning: _STORAGE_DISK_HEALTH_STATUS = 2;
pub const _STORAGE_DISK_HEALTH_STATUS_DiskHealthHealthy: _STORAGE_DISK_HEALTH_STATUS = 3;
pub const _STORAGE_DISK_HEALTH_STATUS_DiskHealthMax: _STORAGE_DISK_HEALTH_STATUS = 4;
pub type _STORAGE_DISK_HEALTH_STATUS = ::std::os::raw::c_int;
pub use self::_STORAGE_DISK_HEALTH_STATUS as STORAGE_DISK_HEALTH_STATUS;
pub type PSTORAGE_DISK_HEALTH_STATUS = *mut _STORAGE_DISK_HEALTH_STATUS;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusNone: _STORAGE_DISK_OPERATIONAL_STATUS = 0;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusUnknown: _STORAGE_DISK_OPERATIONAL_STATUS =
    1;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusOk: _STORAGE_DISK_OPERATIONAL_STATUS = 2;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusPredictingFailure:
    _STORAGE_DISK_OPERATIONAL_STATUS = 3;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusInService: _STORAGE_DISK_OPERATIONAL_STATUS =
    4;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusHardwareError:
    _STORAGE_DISK_OPERATIONAL_STATUS = 5;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusNotUsable: _STORAGE_DISK_OPERATIONAL_STATUS =
    6;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusTransientError:
    _STORAGE_DISK_OPERATIONAL_STATUS = 7;
pub const _STORAGE_DISK_OPERATIONAL_STATUS_DiskOpStatusMissing: _STORAGE_DISK_OPERATIONAL_STATUS =
    8;
pub type _STORAGE_DISK_OPERATIONAL_STATUS = ::std::os::raw::c_int;
pub use self::_STORAGE_DISK_OPERATIONAL_STATUS as STORAGE_DISK_OPERATIONAL_STATUS;
pub type PSTORAGE_DISK_OPERATIONAL_STATUS = *mut _STORAGE_DISK_OPERATIONAL_STATUS;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonUnknown:
    _STORAGE_OPERATIONAL_STATUS_REASON = 0;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonScsiSenseCode:
    _STORAGE_OPERATIONAL_STATUS_REASON = 1;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonMedia: _STORAGE_OPERATIONAL_STATUS_REASON =
    2;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonIo: _STORAGE_OPERATIONAL_STATUS_REASON = 3;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonThresholdExceeded:
    _STORAGE_OPERATIONAL_STATUS_REASON = 4;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonLostData:
    _STORAGE_OPERATIONAL_STATUS_REASON = 5;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonEnergySource:
    _STORAGE_OPERATIONAL_STATUS_REASON = 6;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonConfiguration:
    _STORAGE_OPERATIONAL_STATUS_REASON = 7;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonDeviceController:
    _STORAGE_OPERATIONAL_STATUS_REASON = 8;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonMediaController:
    _STORAGE_OPERATIONAL_STATUS_REASON = 9;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonComponent:
    _STORAGE_OPERATIONAL_STATUS_REASON = 10;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonNVDIMM_N:
    _STORAGE_OPERATIONAL_STATUS_REASON = 11;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonBackgroundOperation:
    _STORAGE_OPERATIONAL_STATUS_REASON = 12;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonInvalidFirmware:
    _STORAGE_OPERATIONAL_STATUS_REASON = 13;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonHealthCheck:
    _STORAGE_OPERATIONAL_STATUS_REASON = 14;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonLostDataPersistence:
    _STORAGE_OPERATIONAL_STATUS_REASON = 15;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonDisabledByPlatform:
    _STORAGE_OPERATIONAL_STATUS_REASON = 16;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonLostWritePersistence:
    _STORAGE_OPERATIONAL_STATUS_REASON = 17;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonDataPersistenceLossImminent:
    _STORAGE_OPERATIONAL_STATUS_REASON = 18;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonWritePersistenceLossImminent:
    _STORAGE_OPERATIONAL_STATUS_REASON = 19;
pub const _STORAGE_OPERATIONAL_STATUS_REASON_DiskOpReasonMax: _STORAGE_OPERATIONAL_STATUS_REASON =
    20;
pub type _STORAGE_OPERATIONAL_STATUS_REASON = ::std::os::raw::c_int;
pub use self::_STORAGE_OPERATIONAL_STATUS_REASON as STORAGE_OPERATIONAL_STATUS_REASON;
pub type PSTORAGE_OPERATIONAL_STATUS_REASON = *mut _STORAGE_OPERATIONAL_STATUS_REASON;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_OPERATIONAL_REASON {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Reason: STORAGE_OPERATIONAL_STATUS_REASON,
    pub RawBytes: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_OPERATIONAL_REASON__bindgen_ty_1 {
    pub ScsiSenseKey: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
    pub NVDIMM_N: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2,
    pub AsUlong: DWORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1 {
    pub SenseKey: BYTE,
    pub ASC: BYTE,
    pub ASCQ: BYTE,
    pub Reserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
    >() - 1usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1::SenseKey"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
        SenseKey
    )
        - 0usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1::ASC"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
        ASC
    ) - 1usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1::ASCQ"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
        ASCQ
    ) - 2usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1::Reserved"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_1,
        Reserved
    )
        - 3usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2 {
    pub CriticalHealth: BYTE,
    pub ModuleHealth: [BYTE; 2usize],
    pub ErrorThresholdStatus: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2"][::std::mem::align_of::<
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2,
    >() - 1usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2::CriticalHealth"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2,
        CriticalHealth
    )
        - 0usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2::ModuleHealth"][::std::mem::offset_of!(
        _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2,
        ModuleHealth
    )
        - 1usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2::ErrorThresholdStatus"] [:: std :: mem :: offset_of ! (_STORAGE_OPERATIONAL_REASON__bindgen_ty_1__bindgen_ty_2 , ErrorThresholdStatus) - 3usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_OPERATIONAL_REASON__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_OPERATIONAL_REASON__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_OPERATIONAL_REASON__bindgen_ty_1>() - 4usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1::ScsiSenseKey"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON__bindgen_ty_1, ScsiSenseKey) - 0usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1::NVDIMM_N"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON__bindgen_ty_1, NVDIMM_N) - 0usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON__bindgen_ty_1::AsUlong"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON__bindgen_ty_1, AsUlong) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OPERATIONAL_REASON"]
        [::std::mem::size_of::<_STORAGE_OPERATIONAL_REASON>() - 16usize];
    ["Alignment of _STORAGE_OPERATIONAL_REASON"]
        [::std::mem::align_of::<_STORAGE_OPERATIONAL_REASON>() - 4usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON::Version"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON, Version) - 0usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON::Size"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON, Size) - 4usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON::Reason"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON, Reason) - 8usize];
    ["Offset of field: _STORAGE_OPERATIONAL_REASON::RawBytes"]
        [::std::mem::offset_of!(_STORAGE_OPERATIONAL_REASON, RawBytes) - 12usize];
};
pub type STORAGE_OPERATIONAL_REASON = _STORAGE_OPERATIONAL_REASON;
pub type PSTORAGE_OPERATIONAL_REASON = *mut _STORAGE_OPERATIONAL_REASON;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_DEVICE_MANAGEMENT_STATUS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Health: STORAGE_DISK_HEALTH_STATUS,
    pub NumberOfOperationalStatus: DWORD,
    pub NumberOfAdditionalReasons: DWORD,
    pub OperationalStatus: [STORAGE_DISK_OPERATIONAL_STATUS; 16usize],
    pub AdditionalReasons: [STORAGE_OPERATIONAL_REASON; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_MANAGEMENT_STATUS"]
        [::std::mem::size_of::<_STORAGE_DEVICE_MANAGEMENT_STATUS>() - 100usize];
    ["Alignment of _STORAGE_DEVICE_MANAGEMENT_STATUS"]
        [::std::mem::align_of::<_STORAGE_DEVICE_MANAGEMENT_STATUS>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_MANAGEMENT_STATUS, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_MANAGEMENT_STATUS, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::Health"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_MANAGEMENT_STATUS, Health) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::NumberOfOperationalStatus"][::std::mem::offset_of!(
        _STORAGE_DEVICE_MANAGEMENT_STATUS,
        NumberOfOperationalStatus
    ) - 12usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::NumberOfAdditionalReasons"][::std::mem::offset_of!(
        _STORAGE_DEVICE_MANAGEMENT_STATUS,
        NumberOfAdditionalReasons
    ) - 16usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::OperationalStatus"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_MANAGEMENT_STATUS, OperationalStatus) - 20usize];
    ["Offset of field: _STORAGE_DEVICE_MANAGEMENT_STATUS::AdditionalReasons"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_MANAGEMENT_STATUS, AdditionalReasons) - 84usize];
};
pub type STORAGE_DEVICE_MANAGEMENT_STATUS = _STORAGE_DEVICE_MANAGEMENT_STATUS;
pub type PSTORAGE_DEVICE_MANAGEMENT_STATUS = *mut _STORAGE_DEVICE_MANAGEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ADAPTER_SERIAL_NUMBER {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SerialNumber: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ADAPTER_SERIAL_NUMBER"]
        [::std::mem::size_of::<_STORAGE_ADAPTER_SERIAL_NUMBER>() - 264usize];
    ["Alignment of _STORAGE_ADAPTER_SERIAL_NUMBER"]
        [::std::mem::align_of::<_STORAGE_ADAPTER_SERIAL_NUMBER>() - 4usize];
    ["Offset of field: _STORAGE_ADAPTER_SERIAL_NUMBER::Version"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_SERIAL_NUMBER, Version) - 0usize];
    ["Offset of field: _STORAGE_ADAPTER_SERIAL_NUMBER::Size"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_SERIAL_NUMBER, Size) - 4usize];
    ["Offset of field: _STORAGE_ADAPTER_SERIAL_NUMBER::SerialNumber"]
        [::std::mem::offset_of!(_STORAGE_ADAPTER_SERIAL_NUMBER, SerialNumber) - 8usize];
};
pub type STORAGE_ADAPTER_SERIAL_NUMBER = _STORAGE_ADAPTER_SERIAL_NUMBER;
pub type PSTORAGE_ADAPTER_SERIAL_NUMBER = *mut _STORAGE_ADAPTER_SERIAL_NUMBER;
pub const _STORAGE_ZONED_DEVICE_TYPES_ZonedDeviceTypeUnknown: _STORAGE_ZONED_DEVICE_TYPES = 0;
pub const _STORAGE_ZONED_DEVICE_TYPES_ZonedDeviceTypeHostManaged: _STORAGE_ZONED_DEVICE_TYPES = 1;
pub const _STORAGE_ZONED_DEVICE_TYPES_ZonedDeviceTypeHostAware: _STORAGE_ZONED_DEVICE_TYPES = 2;
pub const _STORAGE_ZONED_DEVICE_TYPES_ZonedDeviceTypeDeviceManaged: _STORAGE_ZONED_DEVICE_TYPES = 3;
pub type _STORAGE_ZONED_DEVICE_TYPES = ::std::os::raw::c_int;
pub use self::_STORAGE_ZONED_DEVICE_TYPES as STORAGE_ZONED_DEVICE_TYPES;
pub type PSTORAGE_ZONED_DEVICE_TYPES = *mut _STORAGE_ZONED_DEVICE_TYPES;
pub const _STORAGE_ZONE_TYPES_ZoneTypeUnknown: _STORAGE_ZONE_TYPES = 0;
pub const _STORAGE_ZONE_TYPES_ZoneTypeConventional: _STORAGE_ZONE_TYPES = 1;
pub const _STORAGE_ZONE_TYPES_ZoneTypeSequentialWriteRequired: _STORAGE_ZONE_TYPES = 2;
pub const _STORAGE_ZONE_TYPES_ZoneTypeSequentialWritePreferred: _STORAGE_ZONE_TYPES = 3;
pub const _STORAGE_ZONE_TYPES_ZoneTypeMax: _STORAGE_ZONE_TYPES = 4;
pub type _STORAGE_ZONE_TYPES = ::std::os::raw::c_int;
pub use self::_STORAGE_ZONE_TYPES as STORAGE_ZONE_TYPES;
pub type PSTORAGE_ZONE_TYPES = *mut _STORAGE_ZONE_TYPES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ZONE_GROUP {
    pub ZoneCount: DWORD,
    pub ZoneType: STORAGE_ZONE_TYPES,
    pub ZoneSize: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONE_GROUP"][::std::mem::size_of::<_STORAGE_ZONE_GROUP>() - 16usize];
    ["Alignment of _STORAGE_ZONE_GROUP"][::std::mem::align_of::<_STORAGE_ZONE_GROUP>() - 8usize];
    ["Offset of field: _STORAGE_ZONE_GROUP::ZoneCount"]
        [::std::mem::offset_of!(_STORAGE_ZONE_GROUP, ZoneCount) - 0usize];
    ["Offset of field: _STORAGE_ZONE_GROUP::ZoneType"]
        [::std::mem::offset_of!(_STORAGE_ZONE_GROUP, ZoneType) - 4usize];
    ["Offset of field: _STORAGE_ZONE_GROUP::ZoneSize"]
        [::std::mem::offset_of!(_STORAGE_ZONE_GROUP, ZoneSize) - 8usize];
};
pub type STORAGE_ZONE_GROUP = _STORAGE_ZONE_GROUP;
pub type PSTORAGE_ZONE_GROUP = *mut _STORAGE_ZONE_GROUP;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_ZONED_DEVICE_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceType: STORAGE_ZONED_DEVICE_TYPES,
    pub ZoneCount: DWORD,
    pub ZoneAttributes: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1,
    pub ZoneGroupCount: DWORD,
    pub ZoneGroup: [STORAGE_ZONE_GROUP; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1 {
    pub SequentialRequiredZone: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    pub SequentialPreferredZone: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 {
    pub MaxOpenZoneCount: DWORD,
    pub UnrestrictedRead: BOOLEAN,
    pub Reserved: [BYTE; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
    >() - 8usize];
    ["Alignment of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1::MaxOpenZoneCount"] [:: std :: mem :: offset_of ! (_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 , MaxOpenZoneCount) - 0usize] ;
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1::UnrestrictedRead"] [:: std :: mem :: offset_of ! (_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1 , UnrestrictedRead) - 4usize] ;
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1::Reserved"][::std::mem::offset_of!(
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_1,
        Reserved
    )
        - 5usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2 {
    pub OptimalOpenZoneCount: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2"][::std::mem::size_of::<
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2,
    >() - 8usize];
    ["Alignment of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2>()
            - 4usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2::OptimalOpenZoneCount"] [:: std :: mem :: offset_of ! (_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2 , OptimalOpenZoneCount) - 0usize] ;
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2::Reserved"][::std::mem::offset_of!(
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1__bindgen_ty_2,
        Reserved
    )
        - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1>() - 8usize];
    ["Alignment of _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1>() - 4usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1::SequentialRequiredZone"][::std::mem::offset_of!(
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1,
        SequentialRequiredZone
    )
        - 0usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1::SequentialPreferredZone"][::std::mem::offset_of!(
        _STORAGE_ZONED_DEVICE_DESCRIPTOR__bindgen_ty_1,
        SequentialPreferredZone
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONED_DEVICE_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR>() - 48usize];
    ["Alignment of _STORAGE_ZONED_DEVICE_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_ZONED_DEVICE_DESCRIPTOR>() - 8usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::DeviceType"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, DeviceType) - 8usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::ZoneCount"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, ZoneCount) - 12usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::ZoneAttributes"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, ZoneAttributes) - 16usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::ZoneGroupCount"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, ZoneGroupCount) - 24usize];
    ["Offset of field: _STORAGE_ZONED_DEVICE_DESCRIPTOR::ZoneGroup"]
        [::std::mem::offset_of!(_STORAGE_ZONED_DEVICE_DESCRIPTOR, ZoneGroup) - 32usize];
};
pub type STORAGE_ZONED_DEVICE_DESCRIPTOR = _STORAGE_ZONED_DEVICE_DESCRIPTOR;
pub type PSTORAGE_ZONED_DEVICE_DESCRIPTOR = *mut _STORAGE_ZONED_DEVICE_DESCRIPTOR;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_LOCATION {
    pub Socket: DWORD,
    pub Slot: DWORD,
    pub Adapter: DWORD,
    pub Port: DWORD,
    pub __bindgen_anon_1: _DEVICE_LOCATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEVICE_LOCATION__bindgen_ty_1 {
    pub __bindgen_anon_1: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1,
    pub __bindgen_anon_2: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1 {
    pub Channel: DWORD,
    pub Device: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1::Channel"]
        [::std::mem::offset_of!(_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1, Channel) - 0usize];
    ["Offset of field: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1::Device"]
        [::std::mem::offset_of!(_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_1, Device) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2 {
    pub Target: DWORD,
    pub Lun: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2>() - 8usize];
    ["Alignment of _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Offset of field: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2::Target"]
        [::std::mem::offset_of!(_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2, Target) - 0usize];
    ["Offset of field: _DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2::Lun"]
        [::std::mem::offset_of!(_DEVICE_LOCATION__bindgen_ty_1__bindgen_ty_2, Lun) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_LOCATION__bindgen_ty_1"]
        [::std::mem::size_of::<_DEVICE_LOCATION__bindgen_ty_1>() - 8usize];
    ["Alignment of _DEVICE_LOCATION__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_LOCATION__bindgen_ty_1>() - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_LOCATION"][::std::mem::size_of::<_DEVICE_LOCATION>() - 24usize];
    ["Alignment of _DEVICE_LOCATION"][::std::mem::align_of::<_DEVICE_LOCATION>() - 4usize];
    ["Offset of field: _DEVICE_LOCATION::Socket"]
        [::std::mem::offset_of!(_DEVICE_LOCATION, Socket) - 0usize];
    ["Offset of field: _DEVICE_LOCATION::Slot"]
        [::std::mem::offset_of!(_DEVICE_LOCATION, Slot) - 4usize];
    ["Offset of field: _DEVICE_LOCATION::Adapter"]
        [::std::mem::offset_of!(_DEVICE_LOCATION, Adapter) - 8usize];
    ["Offset of field: _DEVICE_LOCATION::Port"]
        [::std::mem::offset_of!(_DEVICE_LOCATION, Port) - 12usize];
};
pub type DEVICE_LOCATION = _DEVICE_LOCATION;
pub type PDEVICE_LOCATION = *mut _DEVICE_LOCATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_DEVICE_LOCATION_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Location: DEVICE_LOCATION,
    pub StringOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_LOCATION_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_LOCATION_DESCRIPTOR>() - 36usize];
    ["Alignment of _STORAGE_DEVICE_LOCATION_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_LOCATION_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_LOCATION_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LOCATION_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_LOCATION_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LOCATION_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_LOCATION_DESCRIPTOR::Location"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LOCATION_DESCRIPTOR, Location) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_LOCATION_DESCRIPTOR::StringOffset"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LOCATION_DESCRIPTOR, StringOffset) - 32usize];
};
pub type STORAGE_DEVICE_LOCATION_DESCRIPTOR = _STORAGE_DEVICE_LOCATION_DESCRIPTOR;
pub type PSTORAGE_DEVICE_LOCATION_DESCRIPTOR = *mut _STORAGE_DEVICE_LOCATION_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_NUMA_PROPERTY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumaNode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_NUMA_PROPERTY"]
        [::std::mem::size_of::<_STORAGE_DEVICE_NUMA_PROPERTY>() - 12usize];
    ["Alignment of _STORAGE_DEVICE_NUMA_PROPERTY"]
        [::std::mem::align_of::<_STORAGE_DEVICE_NUMA_PROPERTY>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMA_PROPERTY::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMA_PROPERTY, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_NUMA_PROPERTY::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMA_PROPERTY, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_NUMA_PROPERTY::NumaNode"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_NUMA_PROPERTY, NumaNode) - 8usize];
};
pub type STORAGE_DEVICE_NUMA_PROPERTY = _STORAGE_DEVICE_NUMA_PROPERTY;
pub type PSTORAGE_DEVICE_NUMA_PROPERTY = *mut _STORAGE_DEVICE_NUMA_PROPERTY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub UnsafeShutdownCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT"]
        [::std::mem::size_of::<_STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT>() - 12usize];
    ["Alignment of _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT"]
        [::std::mem::align_of::<_STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT::UnsafeShutdownCount"][::std::mem::offset_of!(
        _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT,
        UnsafeShutdownCount
    ) - 8usize];
};
pub type STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT = _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT;
pub type PSTORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT = *mut _STORAGE_DEVICE_UNSAFE_SHUTDOWN_COUNT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_ENDURANCE_INFO {
    pub ValidFields: DWORD,
    pub GroupId: DWORD,
    pub Flags: _STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1,
    pub LifePercentage: DWORD,
    pub BytesReadCount: [BYTE; 16usize],
    pub ByteWriteCount: [BYTE; 16usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1>() - 4usize];
};
impl _STORAGE_HW_ENDURANCE_INFO__bindgen_ty_1 {
    #[inline]
    pub fn Shared(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Shared(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Shared_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Shared_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 31u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 31u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                31u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                31u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(Shared: DWORD, Reserved: DWORD) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let Shared: u32 = unsafe { ::std::mem::transmute(Shared) };
            Shared as u64
        });
        __bindgen_bitfield_unit.set(1usize, 31u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_ENDURANCE_INFO"]
        [::std::mem::size_of::<_STORAGE_HW_ENDURANCE_INFO>() - 48usize];
    ["Alignment of _STORAGE_HW_ENDURANCE_INFO"]
        [::std::mem::align_of::<_STORAGE_HW_ENDURANCE_INFO>() - 4usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::ValidFields"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, ValidFields) - 0usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::GroupId"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, GroupId) - 4usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::Flags"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, Flags) - 8usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::LifePercentage"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, LifePercentage) - 12usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::BytesReadCount"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, BytesReadCount) - 16usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_INFO::ByteWriteCount"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_INFO, ByteWriteCount) - 32usize];
};
pub type STORAGE_HW_ENDURANCE_INFO = _STORAGE_HW_ENDURANCE_INFO;
pub type PSTORAGE_HW_ENDURANCE_INFO = *mut _STORAGE_HW_ENDURANCE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub EnduranceInfo: STORAGE_HW_ENDURANCE_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR>() - 56usize];
    ["Alignment of _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR::EnduranceInfo"]
        [::std::mem::offset_of!(_STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR, EnduranceInfo) - 8usize];
};
pub type STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR = _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR;
pub type PSTORAGE_HW_ENDURANCE_DATA_DESCRIPTOR = *mut _STORAGE_HW_ENDURANCE_DATA_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_LED_STATE_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub State: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_LED_STATE_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_DEVICE_LED_STATE_DESCRIPTOR>() - 16usize];
    ["Alignment of _STORAGE_DEVICE_LED_STATE_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_DEVICE_LED_STATE_DESCRIPTOR>() - 8usize];
    ["Offset of field: _STORAGE_DEVICE_LED_STATE_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LED_STATE_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_LED_STATE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LED_STATE_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_LED_STATE_DESCRIPTOR::State"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_LED_STATE_DESCRIPTOR, State) - 8usize];
};
pub type STORAGE_DEVICE_LED_STATE_DESCRIPTOR = _STORAGE_DEVICE_LED_STATE_DESCRIPTOR;
pub type PSTORAGE_DEVICE_LED_STATE_DESCRIPTOR = *mut _STORAGE_DEVICE_LED_STATE_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SupportsSelfEncryption: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY"]
        [::std::mem::size_of::<_STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY>() - 12usize];
    ["Alignment of _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY"]
        [::std::mem::align_of::<_STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY>() - 4usize];
    ["Offset of field: _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY::SupportsSelfEncryption"][::std::mem::offset_of!(
        _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY,
        SupportsSelfEncryption
    )
        - 8usize];
};
pub type STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY = _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY;
pub type PSTORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY = *mut _STORAGE_DEVICE_SELF_ENCRYPTION_PROPERTY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_FRU_ID_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub IdentifierSize: DWORD,
    pub Identifier: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_FRU_ID_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_FRU_ID_DESCRIPTOR>() - 16usize];
    ["Alignment of _STORAGE_FRU_ID_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_FRU_ID_DESCRIPTOR>() - 4usize];
    ["Offset of field: _STORAGE_FRU_ID_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_STORAGE_FRU_ID_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _STORAGE_FRU_ID_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_FRU_ID_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _STORAGE_FRU_ID_DESCRIPTOR::IdentifierSize"]
        [::std::mem::offset_of!(_STORAGE_FRU_ID_DESCRIPTOR, IdentifierSize) - 8usize];
    ["Offset of field: _STORAGE_FRU_ID_DESCRIPTOR::Identifier"]
        [::std::mem::offset_of!(_STORAGE_FRU_ID_DESCRIPTOR, Identifier) - 12usize];
};
pub type STORAGE_FRU_ID_DESCRIPTOR = _STORAGE_FRU_ID_DESCRIPTOR;
pub type PSTORAGE_FRU_ID_DESCRIPTOR = *mut _STORAGE_FRU_ID_DESCRIPTOR;
pub type DEVICE_DATA_MANAGEMENT_SET_ACTION = DWORD;
pub type DEVICE_DSM_ACTION = DWORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_RANGE {
    pub StartingOffset: LONGLONG,
    pub LengthInBytes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_RANGE"][::std::mem::size_of::<_DEVICE_DATA_SET_RANGE>() - 16usize];
    ["Alignment of _DEVICE_DATA_SET_RANGE"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_RANGE>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_RANGE::StartingOffset"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_RANGE, StartingOffset) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_RANGE::LengthInBytes"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_RANGE, LengthInBytes) - 8usize];
};
pub type DEVICE_DATA_SET_RANGE = _DEVICE_DATA_SET_RANGE;
pub type PDEVICE_DATA_SET_RANGE = *mut _DEVICE_DATA_SET_RANGE;
pub type DEVICE_DSM_RANGE = _DEVICE_DATA_SET_RANGE;
pub type PDEVICE_DSM_RANGE = *mut _DEVICE_DATA_SET_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_MANAGE_DATA_SET_ATTRIBUTES {
    pub Size: DWORD,
    pub Action: DEVICE_DSM_ACTION,
    pub Flags: DWORD,
    pub ParameterBlockOffset: DWORD,
    pub ParameterBlockLength: DWORD,
    pub DataSetRangesOffset: DWORD,
    pub DataSetRangesLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MANAGE_DATA_SET_ATTRIBUTES"]
        [::std::mem::size_of::<_DEVICE_MANAGE_DATA_SET_ATTRIBUTES>() - 28usize];
    ["Alignment of _DEVICE_MANAGE_DATA_SET_ATTRIBUTES"]
        [::std::mem::align_of::<_DEVICE_MANAGE_DATA_SET_ATTRIBUTES>() - 4usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::Size"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES, Size) - 0usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::Action"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES, Action) - 4usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::Flags"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES, Flags) - 8usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::ParameterBlockOffset"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES,
        ParameterBlockOffset
    ) - 12usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::ParameterBlockLength"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES,
        ParameterBlockLength
    ) - 16usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::DataSetRangesOffset"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES, DataSetRangesOffset) - 20usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES::DataSetRangesLength"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES, DataSetRangesLength) - 24usize];
};
pub type DEVICE_MANAGE_DATA_SET_ATTRIBUTES = _DEVICE_MANAGE_DATA_SET_ATTRIBUTES;
pub type PDEVICE_MANAGE_DATA_SET_ATTRIBUTES = *mut _DEVICE_MANAGE_DATA_SET_ATTRIBUTES;
pub type DEVICE_DSM_INPUT = _DEVICE_MANAGE_DATA_SET_ATTRIBUTES;
pub type PDEVICE_DSM_INPUT = *mut _DEVICE_MANAGE_DATA_SET_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT {
    pub Size: DWORD,
    pub Action: DEVICE_DSM_ACTION,
    pub Flags: DWORD,
    pub OperationStatus: DWORD,
    pub ExtendedError: DWORD,
    pub TargetDetailedError: DWORD,
    pub ReservedStatus: DWORD,
    pub OutputBlockOffset: DWORD,
    pub OutputBlockLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT>() - 36usize];
    ["Alignment of _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT>() - 4usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::Size"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT, Size) - 0usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::Action"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT, Action) - 4usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::Flags"]
        [::std::mem::offset_of!(_DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT, Flags) - 8usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::OperationStatus"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        OperationStatus
    ) - 12usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::ExtendedError"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        ExtendedError
    ) - 16usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::TargetDetailedError"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        TargetDetailedError
    )
        - 20usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::ReservedStatus"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        ReservedStatus
    ) - 24usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::OutputBlockOffset"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        OutputBlockOffset
    ) - 28usize];
    ["Offset of field: _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT::OutputBlockLength"][::std::mem::offset_of!(
        _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT,
        OutputBlockLength
    ) - 32usize];
};
pub type DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT = _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT;
pub type PDEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT = *mut _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT;
pub type DEVICE_DSM_OUTPUT = _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT;
pub type PDEVICE_DSM_OUTPUT = *mut _DEVICE_MANAGE_DATA_SET_ATTRIBUTES_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_DEFINITION {
    pub Action: DEVICE_DSM_ACTION,
    pub SingleRange: BOOLEAN,
    pub ParameterBlockAlignment: DWORD,
    pub ParameterBlockLength: DWORD,
    pub HasOutput: BOOLEAN,
    pub OutputBlockAlignment: DWORD,
    pub OutputBlockLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_DEFINITION"][::std::mem::size_of::<_DEVICE_DSM_DEFINITION>() - 28usize];
    ["Alignment of _DEVICE_DSM_DEFINITION"]
        [::std::mem::align_of::<_DEVICE_DSM_DEFINITION>() - 4usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::Action"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, Action) - 0usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::SingleRange"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, SingleRange) - 4usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::ParameterBlockAlignment"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, ParameterBlockAlignment) - 8usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::ParameterBlockLength"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, ParameterBlockLength) - 12usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::HasOutput"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, HasOutput) - 16usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::OutputBlockAlignment"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, OutputBlockAlignment) - 20usize];
    ["Offset of field: _DEVICE_DSM_DEFINITION::OutputBlockLength"]
        [::std::mem::offset_of!(_DEVICE_DSM_DEFINITION, OutputBlockLength) - 24usize];
};
pub type DEVICE_DSM_DEFINITION = _DEVICE_DSM_DEFINITION;
pub type PDEVICE_DSM_DEFINITION = *mut _DEVICE_DSM_DEFINITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_NOTIFICATION_PARAMETERS {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub NumFileTypeIDs: DWORD,
    pub FileTypeID: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_NOTIFICATION_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_NOTIFICATION_PARAMETERS>() - 28usize];
    ["Alignment of _DEVICE_DSM_NOTIFICATION_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_NOTIFICATION_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DSM_NOTIFICATION_PARAMETERS::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_NOTIFICATION_PARAMETERS, Size) - 0usize];
    ["Offset of field: _DEVICE_DSM_NOTIFICATION_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_NOTIFICATION_PARAMETERS, Flags) - 4usize];
    ["Offset of field: _DEVICE_DSM_NOTIFICATION_PARAMETERS::NumFileTypeIDs"]
        [::std::mem::offset_of!(_DEVICE_DSM_NOTIFICATION_PARAMETERS, NumFileTypeIDs) - 8usize];
    ["Offset of field: _DEVICE_DSM_NOTIFICATION_PARAMETERS::FileTypeID"]
        [::std::mem::offset_of!(_DEVICE_DSM_NOTIFICATION_PARAMETERS, FileTypeID) - 12usize];
};
pub type DEVICE_DSM_NOTIFICATION_PARAMETERS = _DEVICE_DSM_NOTIFICATION_PARAMETERS;
pub type PDEVICE_DSM_NOTIFICATION_PARAMETERS = *mut _DEVICE_DSM_NOTIFICATION_PARAMETERS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_OFFLOAD_TOKEN {
    pub TokenType: [BYTE; 4usize],
    pub Reserved: [BYTE; 2usize],
    pub TokenIdLength: [BYTE; 2usize],
    pub __bindgen_anon_1: _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1 {
    pub StorageOffloadZeroDataToken: _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1,
    pub Token: [BYTE; 504usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1 {
    pub Reserved2: [BYTE; 504usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1>() - 504usize];
    ["Alignment of _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1::Reserved2"][::std::mem::offset_of!(
        _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1__bindgen_ty_1,
        Reserved2
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_OFFLOAD_TOKEN__bindgen_ty_1>() - 504usize];
    ["Alignment of _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_OFFLOAD_TOKEN__bindgen_ty_1>() - 1usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1::StorageOffloadZeroDataToken"][::std::mem::offset_of!(
        _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1,
        StorageOffloadZeroDataToken
    )
        - 0usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN__bindgen_ty_1::Token"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_TOKEN__bindgen_ty_1, Token) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OFFLOAD_TOKEN"][::std::mem::size_of::<_STORAGE_OFFLOAD_TOKEN>() - 512usize];
    ["Alignment of _STORAGE_OFFLOAD_TOKEN"]
        [::std::mem::align_of::<_STORAGE_OFFLOAD_TOKEN>() - 1usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN::TokenType"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_TOKEN, TokenType) - 0usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN::Reserved"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_TOKEN, Reserved) - 4usize];
    ["Offset of field: _STORAGE_OFFLOAD_TOKEN::TokenIdLength"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_TOKEN, TokenIdLength) - 6usize];
};
pub type STORAGE_OFFLOAD_TOKEN = _STORAGE_OFFLOAD_TOKEN;
pub type PSTORAGE_OFFLOAD_TOKEN = *mut _STORAGE_OFFLOAD_TOKEN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_OFFLOAD_READ_PARAMETERS {
    pub Flags: DWORD,
    pub TimeToLive: DWORD,
    pub Reserved: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_OFFLOAD_READ_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_OFFLOAD_READ_PARAMETERS>() - 16usize];
    ["Alignment of _DEVICE_DSM_OFFLOAD_READ_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_OFFLOAD_READ_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_READ_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_READ_PARAMETERS, Flags) - 0usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_READ_PARAMETERS::TimeToLive"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_READ_PARAMETERS, TimeToLive) - 4usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_READ_PARAMETERS::Reserved"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_READ_PARAMETERS, Reserved) - 8usize];
};
pub type DEVICE_DSM_OFFLOAD_READ_PARAMETERS = _DEVICE_DSM_OFFLOAD_READ_PARAMETERS;
pub type PDEVICE_DSM_OFFLOAD_READ_PARAMETERS = *mut _DEVICE_DSM_OFFLOAD_READ_PARAMETERS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_OFFLOAD_READ_OUTPUT {
    pub OffloadReadFlags: DWORD,
    pub Reserved: DWORD,
    pub LengthProtected: DWORDLONG,
    pub TokenLength: DWORD,
    pub Token: STORAGE_OFFLOAD_TOKEN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OFFLOAD_READ_OUTPUT"]
        [::std::mem::size_of::<_STORAGE_OFFLOAD_READ_OUTPUT>() - 536usize];
    ["Alignment of _STORAGE_OFFLOAD_READ_OUTPUT"]
        [::std::mem::align_of::<_STORAGE_OFFLOAD_READ_OUTPUT>() - 8usize];
    ["Offset of field: _STORAGE_OFFLOAD_READ_OUTPUT::OffloadReadFlags"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_READ_OUTPUT, OffloadReadFlags) - 0usize];
    ["Offset of field: _STORAGE_OFFLOAD_READ_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_READ_OUTPUT, Reserved) - 4usize];
    ["Offset of field: _STORAGE_OFFLOAD_READ_OUTPUT::LengthProtected"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_READ_OUTPUT, LengthProtected) - 8usize];
    ["Offset of field: _STORAGE_OFFLOAD_READ_OUTPUT::TokenLength"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_READ_OUTPUT, TokenLength) - 16usize];
    ["Offset of field: _STORAGE_OFFLOAD_READ_OUTPUT::Token"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_READ_OUTPUT, Token) - 20usize];
};
pub type STORAGE_OFFLOAD_READ_OUTPUT = _STORAGE_OFFLOAD_READ_OUTPUT;
pub type PSTORAGE_OFFLOAD_READ_OUTPUT = *mut _STORAGE_OFFLOAD_READ_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS {
    pub Flags: DWORD,
    pub Reserved: DWORD,
    pub TokenOffset: DWORDLONG,
    pub Token: STORAGE_OFFLOAD_TOKEN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS>() - 528usize];
    ["Alignment of _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS>() - 8usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS, Flags) - 0usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS::Reserved"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS, Reserved) - 4usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS::TokenOffset"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS, TokenOffset) - 8usize];
    ["Offset of field: _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS::Token"]
        [::std::mem::offset_of!(_DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS, Token) - 16usize];
};
pub type DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS = _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS;
pub type PDEVICE_DSM_OFFLOAD_WRITE_PARAMETERS = *mut _DEVICE_DSM_OFFLOAD_WRITE_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_OFFLOAD_WRITE_OUTPUT {
    pub OffloadWriteFlags: DWORD,
    pub Reserved: DWORD,
    pub LengthCopied: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_OFFLOAD_WRITE_OUTPUT"]
        [::std::mem::size_of::<_STORAGE_OFFLOAD_WRITE_OUTPUT>() - 16usize];
    ["Alignment of _STORAGE_OFFLOAD_WRITE_OUTPUT"]
        [::std::mem::align_of::<_STORAGE_OFFLOAD_WRITE_OUTPUT>() - 8usize];
    ["Offset of field: _STORAGE_OFFLOAD_WRITE_OUTPUT::OffloadWriteFlags"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_WRITE_OUTPUT, OffloadWriteFlags) - 0usize];
    ["Offset of field: _STORAGE_OFFLOAD_WRITE_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_WRITE_OUTPUT, Reserved) - 4usize];
    ["Offset of field: _STORAGE_OFFLOAD_WRITE_OUTPUT::LengthCopied"]
        [::std::mem::offset_of!(_STORAGE_OFFLOAD_WRITE_OUTPUT, LengthCopied) - 8usize];
};
pub type STORAGE_OFFLOAD_WRITE_OUTPUT = _STORAGE_OFFLOAD_WRITE_OUTPUT;
pub type PSTORAGE_OFFLOAD_WRITE_OUTPUT = *mut _STORAGE_OFFLOAD_WRITE_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_LBP_STATE_PARAMETERS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub OutputVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_LBP_STATE_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_LBP_STATE_PARAMETERS>() - 16usize];
    ["Alignment of _DEVICE_DATA_SET_LBP_STATE_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_LBP_STATE_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_LBP_STATE_PARAMETERS::Version"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LBP_STATE_PARAMETERS, Version) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_LBP_STATE_PARAMETERS::Size"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LBP_STATE_PARAMETERS, Size) - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_LBP_STATE_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LBP_STATE_PARAMETERS, Flags) - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_LBP_STATE_PARAMETERS::OutputVersion"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LBP_STATE_PARAMETERS, OutputVersion) - 12usize];
};
pub type DEVICE_DATA_SET_LBP_STATE_PARAMETERS = _DEVICE_DATA_SET_LBP_STATE_PARAMETERS;
pub type PDEVICE_DATA_SET_LBP_STATE_PARAMETERS = *mut _DEVICE_DATA_SET_LBP_STATE_PARAMETERS;
pub type DEVICE_DSM_ALLOCATION_PARAMETERS = _DEVICE_DATA_SET_LBP_STATE_PARAMETERS;
pub type PDEVICE_DSM_ALLOCATION_PARAMETERS = *mut _DEVICE_DATA_SET_LBP_STATE_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_LB_PROVISIONING_STATE {
    pub Size: DWORD,
    pub Version: DWORD,
    pub SlabSizeInBytes: DWORDLONG,
    pub SlabOffsetDeltaInBytes: DWORD,
    pub SlabAllocationBitMapBitCount: DWORD,
    pub SlabAllocationBitMapLength: DWORD,
    pub SlabAllocationBitMap: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_LB_PROVISIONING_STATE"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_LB_PROVISIONING_STATE>() - 32usize];
    ["Alignment of _DEVICE_DATA_SET_LB_PROVISIONING_STATE"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_LB_PROVISIONING_STATE>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::Size"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LB_PROVISIONING_STATE, Size) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::Version"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LB_PROVISIONING_STATE, Version) - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::SlabSizeInBytes"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LB_PROVISIONING_STATE, SlabSizeInBytes) - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::SlabOffsetDeltaInBytes"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE,
        SlabOffsetDeltaInBytes
    )
        - 16usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::SlabAllocationBitMapBitCount"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE,
        SlabAllocationBitMapBitCount
    )
        - 20usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::SlabAllocationBitMapLength"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE,
        SlabAllocationBitMapLength
    )
        - 24usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE::SlabAllocationBitMap"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE,
        SlabAllocationBitMap
    ) - 28usize];
};
pub type DEVICE_DATA_SET_LB_PROVISIONING_STATE = _DEVICE_DATA_SET_LB_PROVISIONING_STATE;
pub type PDEVICE_DATA_SET_LB_PROVISIONING_STATE = *mut _DEVICE_DATA_SET_LB_PROVISIONING_STATE;
pub type DEVICE_DSM_ALLOCATION_OUTPUT = _DEVICE_DATA_SET_LB_PROVISIONING_STATE;
pub type PDEVICE_DSM_ALLOCATION_OUTPUT = *mut _DEVICE_DATA_SET_LB_PROVISIONING_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2 {
    pub Size: DWORD,
    pub Version: DWORD,
    pub SlabSizeInBytes: DWORDLONG,
    pub SlabOffsetDeltaInBytes: DWORDLONG,
    pub SlabAllocationBitMapBitCount: DWORD,
    pub SlabAllocationBitMapLength: DWORD,
    pub SlabAllocationBitMap: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2>() - 40usize];
    ["Alignment of _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::Size"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2, Size) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::Version"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2, Version) - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::SlabSizeInBytes"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2,
        SlabSizeInBytes
    ) - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::SlabOffsetDeltaInBytes"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2,
        SlabOffsetDeltaInBytes
    )
        - 16usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::SlabAllocationBitMapBitCount"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2,
        SlabAllocationBitMapBitCount
    )
        - 24usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::SlabAllocationBitMapLength"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2,
        SlabAllocationBitMapLength
    )
        - 28usize];
    ["Offset of field: _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2::SlabAllocationBitMap"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2,
        SlabAllocationBitMap
    )
        - 32usize];
};
pub type DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2 = _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2;
pub type PDEVICE_DATA_SET_LB_PROVISIONING_STATE_V2 = *mut _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2;
pub type DEVICE_DSM_ALLOCATION_OUTPUT2 = _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2;
pub type PDEVICE_DSM_ALLOCATION_OUTPUT2 = *mut _DEVICE_DATA_SET_LB_PROVISIONING_STATE_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_REPAIR_PARAMETERS {
    pub NumberOfRepairCopies: DWORD,
    pub SourceCopy: DWORD,
    pub RepairCopies: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_REPAIR_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_REPAIR_PARAMETERS>() - 12usize];
    ["Alignment of _DEVICE_DATA_SET_REPAIR_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_REPAIR_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_REPAIR_PARAMETERS::NumberOfRepairCopies"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_REPAIR_PARAMETERS, NumberOfRepairCopies) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_REPAIR_PARAMETERS::SourceCopy"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_REPAIR_PARAMETERS, SourceCopy) - 4usize];
    ["Offset of field: _DEVICE_DATA_SET_REPAIR_PARAMETERS::RepairCopies"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_REPAIR_PARAMETERS, RepairCopies) - 8usize];
};
pub type DEVICE_DATA_SET_REPAIR_PARAMETERS = _DEVICE_DATA_SET_REPAIR_PARAMETERS;
pub type PDEVICE_DATA_SET_REPAIR_PARAMETERS = *mut _DEVICE_DATA_SET_REPAIR_PARAMETERS;
pub type DEVICE_DSM_REPAIR_PARAMETERS = _DEVICE_DATA_SET_REPAIR_PARAMETERS;
pub type PDEVICE_DSM_REPAIR_PARAMETERS = *mut _DEVICE_DATA_SET_REPAIR_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_REPAIR_OUTPUT {
    pub ParityExtent: DEVICE_DSM_RANGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_REPAIR_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_REPAIR_OUTPUT>() - 16usize];
    ["Alignment of _DEVICE_DATA_SET_REPAIR_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_REPAIR_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_REPAIR_OUTPUT::ParityExtent"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_REPAIR_OUTPUT, ParityExtent) - 0usize];
};
pub type DEVICE_DATA_SET_REPAIR_OUTPUT = _DEVICE_DATA_SET_REPAIR_OUTPUT;
pub type PDEVICE_DATA_SET_REPAIR_OUTPUT = *mut _DEVICE_DATA_SET_REPAIR_OUTPUT;
pub type DEVICE_DSM_REPAIR_OUTPUT = _DEVICE_DATA_SET_REPAIR_OUTPUT;
pub type PDEVICE_DSM_REPAIR_OUTPUT = *mut _DEVICE_DATA_SET_REPAIR_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_SCRUB_OUTPUT {
    pub BytesProcessed: DWORDLONG,
    pub BytesRepaired: DWORDLONG,
    pub BytesFailed: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_SCRUB_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_SCRUB_OUTPUT>() - 24usize];
    ["Alignment of _DEVICE_DATA_SET_SCRUB_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_SCRUB_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_OUTPUT::BytesProcessed"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_OUTPUT, BytesProcessed) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_OUTPUT::BytesRepaired"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_OUTPUT, BytesRepaired) - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_OUTPUT::BytesFailed"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_OUTPUT, BytesFailed) - 16usize];
};
pub type DEVICE_DATA_SET_SCRUB_OUTPUT = _DEVICE_DATA_SET_SCRUB_OUTPUT;
pub type PDEVICE_DATA_SET_SCRUB_OUTPUT = *mut _DEVICE_DATA_SET_SCRUB_OUTPUT;
pub type DEVICE_DSM_SCRUB_OUTPUT = _DEVICE_DATA_SET_SCRUB_OUTPUT;
pub type PDEVICE_DSM_SCRUB_OUTPUT = *mut _DEVICE_DATA_SET_SCRUB_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_SCRUB_EX_OUTPUT {
    pub BytesProcessed: DWORDLONG,
    pub BytesRepaired: DWORDLONG,
    pub BytesFailed: DWORDLONG,
    pub ParityExtent: DEVICE_DSM_RANGE,
    pub BytesScrubbed: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_SCRUB_EX_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_SCRUB_EX_OUTPUT>() - 48usize];
    ["Alignment of _DEVICE_DATA_SET_SCRUB_EX_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_SCRUB_EX_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_EX_OUTPUT::BytesProcessed"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_EX_OUTPUT, BytesProcessed) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_EX_OUTPUT::BytesRepaired"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_EX_OUTPUT, BytesRepaired) - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_EX_OUTPUT::BytesFailed"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_EX_OUTPUT, BytesFailed) - 16usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_EX_OUTPUT::ParityExtent"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_EX_OUTPUT, ParityExtent) - 24usize];
    ["Offset of field: _DEVICE_DATA_SET_SCRUB_EX_OUTPUT::BytesScrubbed"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_SCRUB_EX_OUTPUT, BytesScrubbed) - 40usize];
};
pub type DEVICE_DATA_SET_SCRUB_EX_OUTPUT = _DEVICE_DATA_SET_SCRUB_EX_OUTPUT;
pub type PDEVICE_DATA_SET_SCRUB_EX_OUTPUT = *mut _DEVICE_DATA_SET_SCRUB_EX_OUTPUT;
pub type DEVICE_DSM_SCRUB_OUTPUT2 = _DEVICE_DATA_SET_SCRUB_EX_OUTPUT;
pub type PDEVICE_DSM_SCRUB_OUTPUT2 = *mut _DEVICE_DATA_SET_SCRUB_EX_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_TIERING_QUERY_INPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub NumberOfTierIds: DWORD,
    pub TierIds: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_TIERING_QUERY_INPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_TIERING_QUERY_INPUT>() - 32usize];
    ["Alignment of _DEVICE_DSM_TIERING_QUERY_INPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_TIERING_QUERY_INPUT>() - 4usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_INPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_INPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_INPUT::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_INPUT, Size) - 4usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_INPUT::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_INPUT, Flags) - 8usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_INPUT::NumberOfTierIds"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_INPUT, NumberOfTierIds) - 12usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_INPUT::TierIds"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_INPUT, TierIds) - 16usize];
};
pub type DEVICE_DSM_TIERING_QUERY_INPUT = _DEVICE_DSM_TIERING_QUERY_INPUT;
pub type PDEVICE_DSM_TIERING_QUERY_INPUT = *mut _DEVICE_DSM_TIERING_QUERY_INPUT;
pub type DEVICE_DSM_TIERING_QUERY_PARAMETERS = _DEVICE_DSM_TIERING_QUERY_INPUT;
pub type PDEVICE_DSM_TIERING_QUERY_PARAMETERS = *mut _DEVICE_DSM_TIERING_QUERY_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_TIER_REGION {
    pub TierId: GUID,
    pub Offset: DWORDLONG,
    pub Length: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_TIER_REGION"][::std::mem::size_of::<_STORAGE_TIER_REGION>() - 32usize];
    ["Alignment of _STORAGE_TIER_REGION"][::std::mem::align_of::<_STORAGE_TIER_REGION>() - 8usize];
    ["Offset of field: _STORAGE_TIER_REGION::TierId"]
        [::std::mem::offset_of!(_STORAGE_TIER_REGION, TierId) - 0usize];
    ["Offset of field: _STORAGE_TIER_REGION::Offset"]
        [::std::mem::offset_of!(_STORAGE_TIER_REGION, Offset) - 16usize];
    ["Offset of field: _STORAGE_TIER_REGION::Length"]
        [::std::mem::offset_of!(_STORAGE_TIER_REGION, Length) - 24usize];
};
pub type STORAGE_TIER_REGION = _STORAGE_TIER_REGION;
pub type PSTORAGE_TIER_REGION = *mut _STORAGE_TIER_REGION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_TIERING_QUERY_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Reserved: DWORD,
    pub Alignment: DWORDLONG,
    pub TotalNumberOfRegions: DWORD,
    pub NumberOfRegionsReturned: DWORD,
    pub Regions: [STORAGE_TIER_REGION; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_TIERING_QUERY_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_TIERING_QUERY_OUTPUT>() - 64usize];
    ["Alignment of _DEVICE_DSM_TIERING_QUERY_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_TIERING_QUERY_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Size) - 4usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Flags) - 8usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Reserved) - 12usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Alignment"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Alignment) - 16usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::TotalNumberOfRegions"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, TotalNumberOfRegions) - 24usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::NumberOfRegionsReturned"][::std::mem::offset_of!(
        _DEVICE_DSM_TIERING_QUERY_OUTPUT,
        NumberOfRegionsReturned
    ) - 28usize];
    ["Offset of field: _DEVICE_DSM_TIERING_QUERY_OUTPUT::Regions"]
        [::std::mem::offset_of!(_DEVICE_DSM_TIERING_QUERY_OUTPUT, Regions) - 32usize];
};
pub type DEVICE_DSM_TIERING_QUERY_OUTPUT = _DEVICE_DSM_TIERING_QUERY_OUTPUT;
pub type PDEVICE_DSM_TIERING_QUERY_OUTPUT = *mut _DEVICE_DSM_TIERING_QUERY_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS {
    pub Size: DWORD,
    pub TargetPriority: BYTE,
    pub Reserved: [BYTE; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS>() - 8usize];
    ["Alignment of _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS, Size) - 0usize];
    ["Offset of field: _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS::TargetPriority"][::std::mem::offset_of!(
        _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS,
        TargetPriority
    ) - 4usize];
    ["Offset of field: _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS::Reserved"]
        [::std::mem::offset_of!(_DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS, Reserved) - 5usize];
};
pub type DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS =
    _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS;
pub type PDEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS =
    *mut _DEVICE_DSM_NVCACHE_CHANGE_PRIORITY_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT {
    pub TopologyRangeBytes: DWORDLONG,
    pub TopologyId: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT>() - 24usize];
    ["Alignment of _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT::TopologyRangeBytes"][::std::mem::offset_of!(
        _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT,
        TopologyRangeBytes
    ) - 0usize];
    ["Offset of field: _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT::TopologyId"]
        [::std::mem::offset_of!(_DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT, TopologyId) - 8usize];
};
pub type DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT = _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT;
pub type PDEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT = *mut _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT;
pub type DEVICE_DSM_TOPOLOGY_ID_QUERY_OUTPUT = _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT;
pub type PDEVICE_DSM_TOPOLOGY_ID_QUERY_OUTPUT = *mut _DEVICE_DATA_SET_TOPOLOGY_ID_QUERY_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_STORAGE_ADDRESS_RANGE {
    pub StartAddress: LONGLONG,
    pub LengthInBytes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_STORAGE_ADDRESS_RANGE"]
        [::std::mem::size_of::<_DEVICE_STORAGE_ADDRESS_RANGE>() - 16usize];
    ["Alignment of _DEVICE_STORAGE_ADDRESS_RANGE"]
        [::std::mem::align_of::<_DEVICE_STORAGE_ADDRESS_RANGE>() - 8usize];
    ["Offset of field: _DEVICE_STORAGE_ADDRESS_RANGE::StartAddress"]
        [::std::mem::offset_of!(_DEVICE_STORAGE_ADDRESS_RANGE, StartAddress) - 0usize];
    ["Offset of field: _DEVICE_STORAGE_ADDRESS_RANGE::LengthInBytes"]
        [::std::mem::offset_of!(_DEVICE_STORAGE_ADDRESS_RANGE, LengthInBytes) - 8usize];
};
pub type DEVICE_STORAGE_ADDRESS_RANGE = _DEVICE_STORAGE_ADDRESS_RANGE;
pub type PDEVICE_STORAGE_ADDRESS_RANGE = *mut _DEVICE_STORAGE_ADDRESS_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub TotalNumberOfRanges: DWORD,
    pub NumberOfRangesReturned: DWORD,
    pub Ranges: [DEVICE_STORAGE_ADDRESS_RANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT>() - 32usize];
    ["Alignment of _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT, Flags) - 4usize];
    ["Offset of field: _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT::TotalNumberOfRanges"][::std::mem::offset_of!(
        _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT,
        TotalNumberOfRanges
    ) - 8usize];
    ["Offset of field: _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT::NumberOfRangesReturned"][::std::mem::offset_of!(
        _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT,
        NumberOfRangesReturned
    ) - 12usize];
    ["Offset of field: _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT::Ranges"]
        [::std::mem::offset_of!(_DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT, Ranges) - 16usize];
};
pub type DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT = _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT;
pub type PDEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT = *mut _DEVICE_DSM_PHYSICAL_ADDRESSES_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_REPORT_ZONES_PARAMETERS {
    pub Size: DWORD,
    pub ReportOption: BYTE,
    pub Partial: BYTE,
    pub Reserved: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_REPORT_ZONES_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_REPORT_ZONES_PARAMETERS>() - 8usize];
    ["Alignment of _DEVICE_DSM_REPORT_ZONES_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_REPORT_ZONES_PARAMETERS>() - 4usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_PARAMETERS::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_PARAMETERS, Size) - 0usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_PARAMETERS::ReportOption"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_PARAMETERS, ReportOption) - 4usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_PARAMETERS::Partial"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_PARAMETERS, Partial) - 5usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_PARAMETERS::Reserved"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_PARAMETERS, Reserved) - 6usize];
};
pub type DEVICE_DSM_REPORT_ZONES_PARAMETERS = _DEVICE_DSM_REPORT_ZONES_PARAMETERS;
pub type PDEVICE_DSM_REPORT_ZONES_PARAMETERS = *mut _DEVICE_DSM_REPORT_ZONES_PARAMETERS;
pub const _STORAGE_ZONES_ATTRIBUTES_ZonesAttributeTypeAndLengthMayDifferent:
    _STORAGE_ZONES_ATTRIBUTES = 0;
pub const _STORAGE_ZONES_ATTRIBUTES_ZonesAttributeTypeSameLengthSame: _STORAGE_ZONES_ATTRIBUTES = 1;
pub const _STORAGE_ZONES_ATTRIBUTES_ZonesAttributeTypeSameLastZoneLengthDifferent:
    _STORAGE_ZONES_ATTRIBUTES = 2;
pub const _STORAGE_ZONES_ATTRIBUTES_ZonesAttributeTypeMayDifferentLengthSame:
    _STORAGE_ZONES_ATTRIBUTES = 3;
pub type _STORAGE_ZONES_ATTRIBUTES = ::std::os::raw::c_int;
pub use self::_STORAGE_ZONES_ATTRIBUTES as STORAGE_ZONES_ATTRIBUTES;
pub type PSTORAGE_ZONES_ATTRIBUTES = *mut _STORAGE_ZONES_ATTRIBUTES;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionConventional: _STORAGE_ZONE_CONDITION = 0;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionEmpty: _STORAGE_ZONE_CONDITION = 1;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionImplicitlyOpened: _STORAGE_ZONE_CONDITION = 2;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionExplicitlyOpened: _STORAGE_ZONE_CONDITION = 3;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionClosed: _STORAGE_ZONE_CONDITION = 4;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionReadOnly: _STORAGE_ZONE_CONDITION = 13;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionFull: _STORAGE_ZONE_CONDITION = 14;
pub const _STORAGE_ZONE_CONDITION_ZoneConditionOffline: _STORAGE_ZONE_CONDITION = 15;
pub type _STORAGE_ZONE_CONDITION = ::std::os::raw::c_int;
pub use self::_STORAGE_ZONE_CONDITION as STORAGE_ZONE_CONDITION;
pub type PSTORAGE_ZONE_CONDITION = *mut _STORAGE_ZONE_CONDITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ZONE_DESCRIPTOR {
    pub Size: DWORD,
    pub ZoneType: STORAGE_ZONE_TYPES,
    pub ZoneCondition: STORAGE_ZONE_CONDITION,
    pub ResetWritePointerRecommend: BOOLEAN,
    pub Reserved0: [BYTE; 3usize],
    pub ZoneSize: DWORDLONG,
    pub WritePointerOffset: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ZONE_DESCRIPTOR"]
        [::std::mem::size_of::<_STORAGE_ZONE_DESCRIPTOR>() - 32usize];
    ["Alignment of _STORAGE_ZONE_DESCRIPTOR"]
        [::std::mem::align_of::<_STORAGE_ZONE_DESCRIPTOR>() - 8usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, Size) - 0usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::ZoneType"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, ZoneType) - 4usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::ZoneCondition"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, ZoneCondition) - 8usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::ResetWritePointerRecommend"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, ResetWritePointerRecommend) - 12usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, Reserved0) - 13usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::ZoneSize"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, ZoneSize) - 16usize];
    ["Offset of field: _STORAGE_ZONE_DESCRIPTOR::WritePointerOffset"]
        [::std::mem::offset_of!(_STORAGE_ZONE_DESCRIPTOR, WritePointerOffset) - 24usize];
};
pub type STORAGE_ZONE_DESCRIPTOR = _STORAGE_ZONE_DESCRIPTOR;
pub type PSTORAGE_ZONE_DESCRIPTOR = *mut _STORAGE_ZONE_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_REPORT_ZONES_DATA {
    pub Size: DWORD,
    pub ZoneCount: DWORD,
    pub Attributes: STORAGE_ZONES_ATTRIBUTES,
    pub Reserved0: DWORD,
    pub ZoneDescriptors: [STORAGE_ZONE_DESCRIPTOR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_REPORT_ZONES_DATA"]
        [::std::mem::size_of::<_DEVICE_DSM_REPORT_ZONES_DATA>() - 48usize];
    ["Alignment of _DEVICE_DSM_REPORT_ZONES_DATA"]
        [::std::mem::align_of::<_DEVICE_DSM_REPORT_ZONES_DATA>() - 8usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_DATA::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_DATA, Size) - 0usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_DATA::ZoneCount"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_DATA, ZoneCount) - 4usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_DATA::Attributes"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_DATA, Attributes) - 8usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_DATA::Reserved0"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_DATA, Reserved0) - 12usize];
    ["Offset of field: _DEVICE_DSM_REPORT_ZONES_DATA::ZoneDescriptors"]
        [::std::mem::offset_of!(_DEVICE_DSM_REPORT_ZONES_DATA, ZoneDescriptors) - 16usize];
};
pub type DEVICE_DSM_REPORT_ZONES_DATA = _DEVICE_DSM_REPORT_ZONES_DATA;
pub type PDEVICE_DSM_REPORT_ZONES_DATA = *mut _DEVICE_DSM_REPORT_ZONES_DATA;
pub type DEVICE_DSM_REPORT_ZONES_OUTPUT = _DEVICE_DSM_REPORT_ZONES_DATA;
pub type PDEVICE_DSM_REPORT_ZONES_OUTPUT = *mut _DEVICE_DSM_REPORT_ZONES_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_STORAGE_RANGE_ATTRIBUTES {
    pub LengthInBytes: DWORDLONG,
    pub __bindgen_anon_1: _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1,
    pub Reserved: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1 {
    pub AllFlags: DWORD,
    pub __bindgen_anon_1: _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1>()
            - 4usize];
};
impl _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn IsRangeBad(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_IsRangeBad(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn IsRangeBad_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_IsRangeBad_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(IsRangeBad: DWORD) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let IsRangeBad: u32 = unsafe { ::std::mem::transmute(IsRangeBad) };
            IsRangeBad as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1"]
        [::std::mem::size_of::<_DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1>() - 4usize];
    ["Alignment of _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1"]
        [::std::mem::align_of::<_DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1::AllFlags"]
        [::std::mem::offset_of!(_DEVICE_STORAGE_RANGE_ATTRIBUTES__bindgen_ty_1, AllFlags) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_STORAGE_RANGE_ATTRIBUTES"]
        [::std::mem::size_of::<_DEVICE_STORAGE_RANGE_ATTRIBUTES>() - 16usize];
    ["Alignment of _DEVICE_STORAGE_RANGE_ATTRIBUTES"]
        [::std::mem::align_of::<_DEVICE_STORAGE_RANGE_ATTRIBUTES>() - 8usize];
    ["Offset of field: _DEVICE_STORAGE_RANGE_ATTRIBUTES::LengthInBytes"]
        [::std::mem::offset_of!(_DEVICE_STORAGE_RANGE_ATTRIBUTES, LengthInBytes) - 0usize];
    ["Offset of field: _DEVICE_STORAGE_RANGE_ATTRIBUTES::Reserved"]
        [::std::mem::offset_of!(_DEVICE_STORAGE_RANGE_ATTRIBUTES, Reserved) - 12usize];
};
pub type DEVICE_STORAGE_RANGE_ATTRIBUTES = _DEVICE_STORAGE_RANGE_ATTRIBUTES;
pub type PDEVICE_STORAGE_RANGE_ATTRIBUTES = *mut _DEVICE_STORAGE_RANGE_ATTRIBUTES;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DEVICE_DSM_RANGE_ERROR_INFO {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub TotalNumberOfRanges: DWORD,
    pub NumberOfRangesReturned: DWORD,
    pub Ranges: [DEVICE_STORAGE_RANGE_ATTRIBUTES; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_RANGE_ERROR_INFO"]
        [::std::mem::size_of::<_DEVICE_DSM_RANGE_ERROR_INFO>() - 32usize];
    ["Alignment of _DEVICE_DSM_RANGE_ERROR_INFO"]
        [::std::mem::align_of::<_DEVICE_DSM_RANGE_ERROR_INFO>() - 8usize];
    ["Offset of field: _DEVICE_DSM_RANGE_ERROR_INFO::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_RANGE_ERROR_INFO, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_RANGE_ERROR_INFO::Flags"]
        [::std::mem::offset_of!(_DEVICE_DSM_RANGE_ERROR_INFO, Flags) - 4usize];
    ["Offset of field: _DEVICE_DSM_RANGE_ERROR_INFO::TotalNumberOfRanges"]
        [::std::mem::offset_of!(_DEVICE_DSM_RANGE_ERROR_INFO, TotalNumberOfRanges) - 8usize];
    ["Offset of field: _DEVICE_DSM_RANGE_ERROR_INFO::NumberOfRangesReturned"]
        [::std::mem::offset_of!(_DEVICE_DSM_RANGE_ERROR_INFO, NumberOfRangesReturned) - 12usize];
    ["Offset of field: _DEVICE_DSM_RANGE_ERROR_INFO::Ranges"]
        [::std::mem::offset_of!(_DEVICE_DSM_RANGE_ERROR_INFO, Ranges) - 16usize];
};
pub type DEVICE_DSM_RANGE_ERROR_INFO = _DEVICE_DSM_RANGE_ERROR_INFO;
pub type PDEVICE_DSM_RANGE_ERROR_INFO = *mut _DEVICE_DSM_RANGE_ERROR_INFO;
pub type DEVICE_DSM_RANGE_ERROR_OUTPUT = _DEVICE_DSM_RANGE_ERROR_INFO;
pub type PDEVICE_DSM_RANGE_ERROR_OUTPUT = *mut _DEVICE_DSM_RANGE_ERROR_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_LOST_QUERY_PARAMETERS {
    pub Version: DWORD,
    pub Granularity: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_LOST_QUERY_PARAMETERS"]
        [::std::mem::size_of::<_DEVICE_DSM_LOST_QUERY_PARAMETERS>() - 16usize];
    ["Alignment of _DEVICE_DSM_LOST_QUERY_PARAMETERS"]
        [::std::mem::align_of::<_DEVICE_DSM_LOST_QUERY_PARAMETERS>() - 8usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_PARAMETERS::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_PARAMETERS, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_PARAMETERS::Granularity"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_PARAMETERS, Granularity) - 8usize];
};
pub type DEVICE_DSM_LOST_QUERY_PARAMETERS = _DEVICE_DSM_LOST_QUERY_PARAMETERS;
pub type PDEVICE_DSM_LOST_QUERY_PARAMETERS = *mut _DEVICE_DSM_LOST_QUERY_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_LOST_QUERY_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Alignment: DWORDLONG,
    pub NumberOfBits: DWORD,
    pub BitMap: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_LOST_QUERY_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_LOST_QUERY_OUTPUT>() - 24usize];
    ["Alignment of _DEVICE_DSM_LOST_QUERY_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_LOST_QUERY_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_OUTPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_OUTPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_OUTPUT::Size"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_OUTPUT, Size) - 4usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_OUTPUT::Alignment"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_OUTPUT, Alignment) - 8usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_OUTPUT::NumberOfBits"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_OUTPUT, NumberOfBits) - 16usize];
    ["Offset of field: _DEVICE_DSM_LOST_QUERY_OUTPUT::BitMap"]
        [::std::mem::offset_of!(_DEVICE_DSM_LOST_QUERY_OUTPUT, BitMap) - 20usize];
};
pub type DEVICE_DSM_LOST_QUERY_OUTPUT = _DEVICE_DSM_LOST_QUERY_OUTPUT;
pub type PDEVICE_DSM_LOST_QUERY_OUTPUT = *mut _DEVICE_DSM_LOST_QUERY_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_FREE_SPACE_OUTPUT {
    pub Version: DWORD,
    pub FreeSpace: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_FREE_SPACE_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_FREE_SPACE_OUTPUT>() - 16usize];
    ["Alignment of _DEVICE_DSM_FREE_SPACE_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_FREE_SPACE_OUTPUT>() - 8usize];
    ["Offset of field: _DEVICE_DSM_FREE_SPACE_OUTPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_FREE_SPACE_OUTPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_FREE_SPACE_OUTPUT::FreeSpace"]
        [::std::mem::offset_of!(_DEVICE_DSM_FREE_SPACE_OUTPUT, FreeSpace) - 8usize];
};
pub type DEVICE_DSM_FREE_SPACE_OUTPUT = _DEVICE_DSM_FREE_SPACE_OUTPUT;
pub type PDEVICE_DSM_FREE_SPACE_OUTPUT = *mut _DEVICE_DSM_FREE_SPACE_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_DSM_CONVERSION_OUTPUT {
    pub Version: DWORD,
    pub Source: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_DSM_CONVERSION_OUTPUT"]
        [::std::mem::size_of::<_DEVICE_DSM_CONVERSION_OUTPUT>() - 20usize];
    ["Alignment of _DEVICE_DSM_CONVERSION_OUTPUT"]
        [::std::mem::align_of::<_DEVICE_DSM_CONVERSION_OUTPUT>() - 4usize];
    ["Offset of field: _DEVICE_DSM_CONVERSION_OUTPUT::Version"]
        [::std::mem::offset_of!(_DEVICE_DSM_CONVERSION_OUTPUT, Version) - 0usize];
    ["Offset of field: _DEVICE_DSM_CONVERSION_OUTPUT::Source"]
        [::std::mem::offset_of!(_DEVICE_DSM_CONVERSION_OUTPUT, Source) - 4usize];
};
pub type DEVICE_DSM_CONVERSION_OUTPUT = _DEVICE_DSM_CONVERSION_OUTPUT;
pub type PDEVICE_DSM_CONVERSION_OUTPUT = *mut _DEVICE_DSM_CONVERSION_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_GET_BC_PROPERTIES_OUTPUT {
    pub MaximumRequestsPerPeriod: DWORD,
    pub MinimumPeriod: DWORD,
    pub MaximumRequestSize: DWORDLONG,
    pub EstimatedTimePerRequest: DWORD,
    pub NumOutStandingRequests: DWORD,
    pub RequestSize: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_GET_BC_PROPERTIES_OUTPUT"]
        [::std::mem::size_of::<_STORAGE_GET_BC_PROPERTIES_OUTPUT>() - 32usize];
    ["Alignment of _STORAGE_GET_BC_PROPERTIES_OUTPUT"]
        [::std::mem::align_of::<_STORAGE_GET_BC_PROPERTIES_OUTPUT>() - 8usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::MaximumRequestsPerPeriod"][::std::mem::offset_of!(
        _STORAGE_GET_BC_PROPERTIES_OUTPUT,
        MaximumRequestsPerPeriod
    ) - 0usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::MinimumPeriod"]
        [::std::mem::offset_of!(_STORAGE_GET_BC_PROPERTIES_OUTPUT, MinimumPeriod) - 4usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::MaximumRequestSize"]
        [::std::mem::offset_of!(_STORAGE_GET_BC_PROPERTIES_OUTPUT, MaximumRequestSize) - 8usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::EstimatedTimePerRequest"][::std::mem::offset_of!(
        _STORAGE_GET_BC_PROPERTIES_OUTPUT,
        EstimatedTimePerRequest
    ) - 16usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::NumOutStandingRequests"][::std::mem::offset_of!(
        _STORAGE_GET_BC_PROPERTIES_OUTPUT,
        NumOutStandingRequests
    ) - 20usize];
    ["Offset of field: _STORAGE_GET_BC_PROPERTIES_OUTPUT::RequestSize"]
        [::std::mem::offset_of!(_STORAGE_GET_BC_PROPERTIES_OUTPUT, RequestSize) - 24usize];
};
pub type STORAGE_GET_BC_PROPERTIES_OUTPUT = _STORAGE_GET_BC_PROPERTIES_OUTPUT;
pub type PSTORAGE_GET_BC_PROPERTIES_OUTPUT = *mut _STORAGE_GET_BC_PROPERTIES_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ALLOCATE_BC_STREAM_INPUT {
    pub Version: DWORD,
    pub RequestsPerPeriod: DWORD,
    pub Period: DWORD,
    pub RetryFailures: BOOLEAN,
    pub Discardable: BOOLEAN,
    pub Reserved1: [BOOLEAN; 2usize],
    pub AccessType: DWORD,
    pub AccessMode: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ALLOCATE_BC_STREAM_INPUT"]
        [::std::mem::size_of::<_STORAGE_ALLOCATE_BC_STREAM_INPUT>() - 24usize];
    ["Alignment of _STORAGE_ALLOCATE_BC_STREAM_INPUT"]
        [::std::mem::align_of::<_STORAGE_ALLOCATE_BC_STREAM_INPUT>() - 4usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::Version"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, Version) - 0usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::RequestsPerPeriod"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, RequestsPerPeriod) - 4usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::Period"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, Period) - 8usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::RetryFailures"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, RetryFailures) - 12usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::Discardable"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, Discardable) - 13usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, Reserved1) - 14usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::AccessType"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, AccessType) - 16usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_INPUT::AccessMode"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_INPUT, AccessMode) - 20usize];
};
pub type STORAGE_ALLOCATE_BC_STREAM_INPUT = _STORAGE_ALLOCATE_BC_STREAM_INPUT;
pub type PSTORAGE_ALLOCATE_BC_STREAM_INPUT = *mut _STORAGE_ALLOCATE_BC_STREAM_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ALLOCATE_BC_STREAM_OUTPUT {
    pub RequestSize: DWORDLONG,
    pub NumOutStandingRequests: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ALLOCATE_BC_STREAM_OUTPUT"]
        [::std::mem::size_of::<_STORAGE_ALLOCATE_BC_STREAM_OUTPUT>() - 16usize];
    ["Alignment of _STORAGE_ALLOCATE_BC_STREAM_OUTPUT"]
        [::std::mem::align_of::<_STORAGE_ALLOCATE_BC_STREAM_OUTPUT>() - 8usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_OUTPUT::RequestSize"]
        [::std::mem::offset_of!(_STORAGE_ALLOCATE_BC_STREAM_OUTPUT, RequestSize) - 0usize];
    ["Offset of field: _STORAGE_ALLOCATE_BC_STREAM_OUTPUT::NumOutStandingRequests"][::std::mem::offset_of!(
        _STORAGE_ALLOCATE_BC_STREAM_OUTPUT,
        NumOutStandingRequests
    ) - 8usize];
};
pub type STORAGE_ALLOCATE_BC_STREAM_OUTPUT = _STORAGE_ALLOCATE_BC_STREAM_OUTPUT;
pub type PSTORAGE_ALLOCATE_BC_STREAM_OUTPUT = *mut _STORAGE_ALLOCATE_BC_STREAM_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PRIORITY_HINT_SUPPORT {
    pub SupportFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PRIORITY_HINT_SUPPORT"]
        [::std::mem::size_of::<_STORAGE_PRIORITY_HINT_SUPPORT>() - 4usize];
    ["Alignment of _STORAGE_PRIORITY_HINT_SUPPORT"]
        [::std::mem::align_of::<_STORAGE_PRIORITY_HINT_SUPPORT>() - 4usize];
    ["Offset of field: _STORAGE_PRIORITY_HINT_SUPPORT::SupportFlags"]
        [::std::mem::offset_of!(_STORAGE_PRIORITY_HINT_SUPPORT, SupportFlags) - 0usize];
};
pub type STORAGE_PRIORITY_HINT_SUPPORT = _STORAGE_PRIORITY_HINT_SUPPORT;
pub type PSTORAGE_PRIORITY_HINT_SUPPORT = *mut _STORAGE_PRIORITY_HINT_SUPPORT;
pub const _STORAGE_DIAGNOSTIC_LEVEL_StorageDiagnosticLevelDefault: _STORAGE_DIAGNOSTIC_LEVEL = 0;
pub const _STORAGE_DIAGNOSTIC_LEVEL_StorageDiagnosticLevelMax: _STORAGE_DIAGNOSTIC_LEVEL = 1;
pub type _STORAGE_DIAGNOSTIC_LEVEL = ::std::os::raw::c_int;
pub use self::_STORAGE_DIAGNOSTIC_LEVEL as STORAGE_DIAGNOSTIC_LEVEL;
pub type PSTORAGE_DIAGNOSTIC_LEVEL = *mut _STORAGE_DIAGNOSTIC_LEVEL;
pub const _STORAGE_DIAGNOSTIC_TARGET_TYPE_StorageDiagnosticTargetTypeUndefined:
    _STORAGE_DIAGNOSTIC_TARGET_TYPE = 0;
pub const _STORAGE_DIAGNOSTIC_TARGET_TYPE_StorageDiagnosticTargetTypePort:
    _STORAGE_DIAGNOSTIC_TARGET_TYPE = 1;
pub const _STORAGE_DIAGNOSTIC_TARGET_TYPE_StorageDiagnosticTargetTypeMiniport:
    _STORAGE_DIAGNOSTIC_TARGET_TYPE = 2;
pub const _STORAGE_DIAGNOSTIC_TARGET_TYPE_StorageDiagnosticTargetTypeHbaFirmware:
    _STORAGE_DIAGNOSTIC_TARGET_TYPE = 3;
pub const _STORAGE_DIAGNOSTIC_TARGET_TYPE_StorageDiagnosticTargetTypeMax:
    _STORAGE_DIAGNOSTIC_TARGET_TYPE = 4;
pub type _STORAGE_DIAGNOSTIC_TARGET_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_DIAGNOSTIC_TARGET_TYPE as STORAGE_DIAGNOSTIC_TARGET_TYPE;
pub type PSTORAGE_DIAGNOSTIC_TARGET_TYPE = *mut _STORAGE_DIAGNOSTIC_TARGET_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DIAGNOSTIC_REQUEST {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub TargetType: STORAGE_DIAGNOSTIC_TARGET_TYPE,
    pub Level: STORAGE_DIAGNOSTIC_LEVEL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DIAGNOSTIC_REQUEST"]
        [::std::mem::size_of::<_STORAGE_DIAGNOSTIC_REQUEST>() - 20usize];
    ["Alignment of _STORAGE_DIAGNOSTIC_REQUEST"]
        [::std::mem::align_of::<_STORAGE_DIAGNOSTIC_REQUEST>() - 4usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_REQUEST::Version"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_REQUEST, Version) - 0usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_REQUEST::Size"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_REQUEST, Size) - 4usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_REQUEST::Flags"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_REQUEST, Flags) - 8usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_REQUEST::TargetType"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_REQUEST, TargetType) - 12usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_REQUEST::Level"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_REQUEST, Level) - 16usize];
};
pub type STORAGE_DIAGNOSTIC_REQUEST = _STORAGE_DIAGNOSTIC_REQUEST;
pub type PSTORAGE_DIAGNOSTIC_REQUEST = *mut _STORAGE_DIAGNOSTIC_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DIAGNOSTIC_DATA {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ProviderId: GUID,
    pub BufferSize: DWORD,
    pub Reserved: DWORD,
    pub DiagnosticDataBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DIAGNOSTIC_DATA"]
        [::std::mem::size_of::<_STORAGE_DIAGNOSTIC_DATA>() - 36usize];
    ["Alignment of _STORAGE_DIAGNOSTIC_DATA"]
        [::std::mem::align_of::<_STORAGE_DIAGNOSTIC_DATA>() - 4usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::Version"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, Version) - 0usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::Size"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, Size) - 4usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::ProviderId"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, ProviderId) - 8usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::BufferSize"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, BufferSize) - 24usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::Reserved"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, Reserved) - 28usize];
    ["Offset of field: _STORAGE_DIAGNOSTIC_DATA::DiagnosticDataBuffer"]
        [::std::mem::offset_of!(_STORAGE_DIAGNOSTIC_DATA, DiagnosticDataBuffer) - 32usize];
};
pub type STORAGE_DIAGNOSTIC_DATA = _STORAGE_DIAGNOSTIC_DATA;
pub type PSTORAGE_DIAGNOSTIC_DATA = *mut _STORAGE_DIAGNOSTIC_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PHYSICAL_ELEMENT_STATUS_REQUEST {
    pub Version: DWORD,
    pub Size: DWORD,
    pub StartingElement: DWORD,
    pub Filter: BYTE,
    pub ReportType: BYTE,
    pub Reserved: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PHYSICAL_ELEMENT_STATUS_REQUEST"]
        [::std::mem::size_of::<_PHYSICAL_ELEMENT_STATUS_REQUEST>() - 16usize];
    ["Alignment of _PHYSICAL_ELEMENT_STATUS_REQUEST"]
        [::std::mem::align_of::<_PHYSICAL_ELEMENT_STATUS_REQUEST>() - 4usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::Version"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, Version) - 0usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::Size"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, Size) - 4usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::StartingElement"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, StartingElement) - 8usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::Filter"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, Filter) - 12usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::ReportType"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, ReportType) - 13usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_REQUEST::Reserved"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_REQUEST, Reserved) - 14usize];
};
pub type PHYSICAL_ELEMENT_STATUS_REQUEST = _PHYSICAL_ELEMENT_STATUS_REQUEST;
pub type PPHYSICAL_ELEMENT_STATUS_REQUEST = *mut _PHYSICAL_ELEMENT_STATUS_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ElementIdentifier: DWORD,
    pub PhysicalElementType: BYTE,
    pub PhysicalElementHealth: BYTE,
    pub Reserved1: [BYTE; 2usize],
    pub AssociatedCapacity: DWORDLONG,
    pub Reserved2: [DWORD; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR"]
        [::std::mem::size_of::<_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR>() - 40usize];
    ["Alignment of _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR"]
        [::std::mem::align_of::<_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR>() - 8usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::Version"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, Version) - 0usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::Size"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, Size) - 4usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::ElementIdentifier"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, ElementIdentifier) - 8usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::PhysicalElementType"][::std::mem::offset_of!(
        _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR,
        PhysicalElementType
    ) - 12usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::PhysicalElementHealth"][::std::mem::offset_of!(
        _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR,
        PhysicalElementHealth
    ) - 13usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::Reserved1"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, Reserved1) - 14usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::AssociatedCapacity"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, AssociatedCapacity) - 16usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR::Reserved2"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS_DESCRIPTOR, Reserved2) - 24usize];
};
pub type PHYSICAL_ELEMENT_STATUS_DESCRIPTOR = _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR;
pub type PPHYSICAL_ELEMENT_STATUS_DESCRIPTOR = *mut _PHYSICAL_ELEMENT_STATUS_DESCRIPTOR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PHYSICAL_ELEMENT_STATUS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DescriptorCount: DWORD,
    pub ReturnedDescriptorCount: DWORD,
    pub ElementIdentifierBeingDepoped: DWORD,
    pub Reserved: DWORD,
    pub Descriptors: [PHYSICAL_ELEMENT_STATUS_DESCRIPTOR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PHYSICAL_ELEMENT_STATUS"]
        [::std::mem::size_of::<_PHYSICAL_ELEMENT_STATUS>() - 64usize];
    ["Alignment of _PHYSICAL_ELEMENT_STATUS"]
        [::std::mem::align_of::<_PHYSICAL_ELEMENT_STATUS>() - 8usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::Version"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, Version) - 0usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::Size"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, Size) - 4usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::DescriptorCount"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, DescriptorCount) - 8usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::ReturnedDescriptorCount"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, ReturnedDescriptorCount) - 12usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::ElementIdentifierBeingDepoped"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, ElementIdentifierBeingDepoped) - 16usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::Reserved"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, Reserved) - 20usize];
    ["Offset of field: _PHYSICAL_ELEMENT_STATUS::Descriptors"]
        [::std::mem::offset_of!(_PHYSICAL_ELEMENT_STATUS, Descriptors) - 24usize];
};
pub type PHYSICAL_ELEMENT_STATUS = _PHYSICAL_ELEMENT_STATUS;
pub type PPHYSICAL_ELEMENT_STATUS = *mut _PHYSICAL_ELEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST {
    pub Version: DWORD,
    pub Size: DWORD,
    pub RequestCapacity: DWORDLONG,
    pub ElementIdentifier: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST"]
        [::std::mem::size_of::<_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST>() - 24usize];
    ["Alignment of _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST"]
        [::std::mem::align_of::<_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST>() - 8usize];
    ["Offset of field: _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST::Version"]
        [::std::mem::offset_of!(_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST, Version) - 0usize];
    ["Offset of field: _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST::Size"]
        [::std::mem::offset_of!(_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST, Size) - 4usize];
    ["Offset of field: _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST::RequestCapacity"]
        [::std::mem::offset_of!(_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST, RequestCapacity) - 8usize];
    ["Offset of field: _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST::ElementIdentifier"]
        [::std::mem::offset_of!(_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST, ElementIdentifier) - 16usize];
    ["Offset of field: _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST::Reserved"]
        [::std::mem::offset_of!(_REMOVE_ELEMENT_AND_TRUNCATE_REQUEST, Reserved) - 20usize];
};
pub type REMOVE_ELEMENT_AND_TRUNCATE_REQUEST = _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST;
pub type PREMOVE_ELEMENT_AND_TRUNCATE_REQUEST = *mut _REMOVE_ELEMENT_AND_TRUNCATE_REQUEST;
pub const _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE_DeviceInternalStatusDataRequestTypeUndefined:
    _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = 0;
pub const _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE_DeviceCurrentInternalStatusDataHeader:
    _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = 1;
pub const _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE_DeviceCurrentInternalStatusData:
    _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = 2;
pub const _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE_DeviceSavedInternalStatusDataHeader:
    _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = 3;
pub const _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE_DeviceSavedInternalStatusData:
    _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = 4;
pub type _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = ::std::os::raw::c_int;
pub use self::_DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE as DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE;
pub type PDEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE = *mut _DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSetUndefined:
    _DEVICE_INTERNAL_STATUS_DATA_SET = 0;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSet1: _DEVICE_INTERNAL_STATUS_DATA_SET =
    1;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSet2: _DEVICE_INTERNAL_STATUS_DATA_SET =
    2;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSet3: _DEVICE_INTERNAL_STATUS_DATA_SET =
    3;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSet4: _DEVICE_INTERNAL_STATUS_DATA_SET =
    4;
pub const _DEVICE_INTERNAL_STATUS_DATA_SET_DeviceStatusDataSetMax:
    _DEVICE_INTERNAL_STATUS_DATA_SET = 5;
pub type _DEVICE_INTERNAL_STATUS_DATA_SET = ::std::os::raw::c_int;
pub use self::_DEVICE_INTERNAL_STATUS_DATA_SET as DEVICE_INTERNAL_STATUS_DATA_SET;
pub type PDEVICE_INTERNAL_STATUS_DATA_SET = *mut _DEVICE_INTERNAL_STATUS_DATA_SET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST {
    pub Version: DWORD,
    pub Size: DWORD,
    pub RequestDataType: DEVICE_INTERNAL_STATUS_DATA_REQUEST_TYPE,
    pub RequestDataSet: DEVICE_INTERNAL_STATUS_DATA_SET,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST"]
        [::std::mem::size_of::<_GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST>() - 16usize];
    ["Alignment of _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST"]
        [::std::mem::align_of::<_GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST>() - 4usize];
    ["Offset of field: _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST::Version"]
        [::std::mem::offset_of!(_GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST, Version) - 0usize];
    ["Offset of field: _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST::Size"]
        [::std::mem::offset_of!(_GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST, Size) - 4usize];
    ["Offset of field: _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST::RequestDataType"][::std::mem::offset_of!(
        _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST,
        RequestDataType
    ) - 8usize];
    ["Offset of field: _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST::RequestDataSet"][::std::mem::offset_of!(
        _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST,
        RequestDataSet
    ) - 12usize];
};
pub type GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST = _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST;
pub type PGET_DEVICE_INTERNAL_STATUS_DATA_REQUEST = *mut _GET_DEVICE_INTERNAL_STATUS_DATA_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICE_INTERNAL_STATUS_DATA {
    pub Version: DWORD,
    pub Size: DWORD,
    pub T10VendorId: DWORDLONG,
    pub DataSet1Length: DWORD,
    pub DataSet2Length: DWORD,
    pub DataSet3Length: DWORD,
    pub DataSet4Length: DWORD,
    pub StatusDataVersion: BYTE,
    pub Reserved: [BYTE; 3usize],
    pub ReasonIdentifier: [BYTE; 128usize],
    pub StatusDataLength: DWORD,
    pub StatusData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICE_INTERNAL_STATUS_DATA"]
        [::std::mem::size_of::<_DEVICE_INTERNAL_STATUS_DATA>() - 176usize];
    ["Alignment of _DEVICE_INTERNAL_STATUS_DATA"]
        [::std::mem::align_of::<_DEVICE_INTERNAL_STATUS_DATA>() - 8usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::Version"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, Version) - 0usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::Size"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, Size) - 4usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::T10VendorId"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, T10VendorId) - 8usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::DataSet1Length"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, DataSet1Length) - 16usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::DataSet2Length"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, DataSet2Length) - 20usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::DataSet3Length"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, DataSet3Length) - 24usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::DataSet4Length"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, DataSet4Length) - 28usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::StatusDataVersion"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, StatusDataVersion) - 32usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::Reserved"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, Reserved) - 33usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::ReasonIdentifier"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, ReasonIdentifier) - 36usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::StatusDataLength"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, StatusDataLength) - 164usize];
    ["Offset of field: _DEVICE_INTERNAL_STATUS_DATA::StatusData"]
        [::std::mem::offset_of!(_DEVICE_INTERNAL_STATUS_DATA, StatusData) - 168usize];
};
pub type DEVICE_INTERNAL_STATUS_DATA = _DEVICE_INTERNAL_STATUS_DATA;
pub type PDEVICE_INTERNAL_STATUS_DATA = *mut _DEVICE_INTERNAL_STATUS_DATA;
pub const _STORAGE_SANITIZE_METHOD_StorageSanitizeMethodDefault: _STORAGE_SANITIZE_METHOD = 0;
pub const _STORAGE_SANITIZE_METHOD_StorageSanitizeMethodBlockErase: _STORAGE_SANITIZE_METHOD = 1;
pub const _STORAGE_SANITIZE_METHOD_StorageSanitizeMethodCryptoErase: _STORAGE_SANITIZE_METHOD = 2;
pub type _STORAGE_SANITIZE_METHOD = ::std::os::raw::c_int;
pub use self::_STORAGE_SANITIZE_METHOD as STORAGE_SANITIZE_METHOD;
pub type PSTORAGE_SANITIZE_METHOD = *mut _STORAGE_SANITIZE_METHOD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_REINITIALIZE_MEDIA {
    pub Version: DWORD,
    pub Size: DWORD,
    pub TimeoutInSeconds: DWORD,
    pub SanitizeOption: _STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1>() - 4usize];
};
impl _STORAGE_REINITIALIZE_MEDIA__bindgen_ty_1 {
    #[inline]
    pub fn SanitizeMethod(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 4u8) as u32) }
    }
    #[inline]
    pub fn set_SanitizeMethod(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SanitizeMethod_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                4u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_SanitizeMethod_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn DisallowUnrestrictedSanitizeExit(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(4usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_DisallowUnrestrictedSanitizeExit(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(4usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn DisallowUnrestrictedSanitizeExit_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                4usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_DisallowUnrestrictedSanitizeExit_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                4usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 27u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 27u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                27u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                27u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        SanitizeMethod: DWORD,
        DisallowUnrestrictedSanitizeExit: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 4u8, {
            let SanitizeMethod: u32 = unsafe { ::std::mem::transmute(SanitizeMethod) };
            SanitizeMethod as u64
        });
        __bindgen_bitfield_unit.set(4usize, 1u8, {
            let DisallowUnrestrictedSanitizeExit: u32 =
                unsafe { ::std::mem::transmute(DisallowUnrestrictedSanitizeExit) };
            DisallowUnrestrictedSanitizeExit as u64
        });
        __bindgen_bitfield_unit.set(5usize, 27u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_REINITIALIZE_MEDIA"]
        [::std::mem::size_of::<_STORAGE_REINITIALIZE_MEDIA>() - 16usize];
    ["Alignment of _STORAGE_REINITIALIZE_MEDIA"]
        [::std::mem::align_of::<_STORAGE_REINITIALIZE_MEDIA>() - 4usize];
    ["Offset of field: _STORAGE_REINITIALIZE_MEDIA::Version"]
        [::std::mem::offset_of!(_STORAGE_REINITIALIZE_MEDIA, Version) - 0usize];
    ["Offset of field: _STORAGE_REINITIALIZE_MEDIA::Size"]
        [::std::mem::offset_of!(_STORAGE_REINITIALIZE_MEDIA, Size) - 4usize];
    ["Offset of field: _STORAGE_REINITIALIZE_MEDIA::TimeoutInSeconds"]
        [::std::mem::offset_of!(_STORAGE_REINITIALIZE_MEDIA, TimeoutInSeconds) - 8usize];
    ["Offset of field: _STORAGE_REINITIALIZE_MEDIA::SanitizeOption"]
        [::std::mem::offset_of!(_STORAGE_REINITIALIZE_MEDIA, SanitizeOption) - 12usize];
};
pub type STORAGE_REINITIALIZE_MEDIA = _STORAGE_REINITIALIZE_MEDIA;
pub type PSTORAGE_REINITIALIZE_MEDIA = *mut _STORAGE_REINITIALIZE_MEDIA;
#[repr(C)]
#[derive(Debug)]
pub struct _STORAGE_MEDIA_SERIAL_NUMBER_DATA {
    pub Reserved: WORD,
    pub SerialNumberLength: WORD,
    pub SerialNumber: __IncompleteArrayField<BYTE>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_MEDIA_SERIAL_NUMBER_DATA"]
        [::std::mem::size_of::<_STORAGE_MEDIA_SERIAL_NUMBER_DATA>() - 4usize];
    ["Alignment of _STORAGE_MEDIA_SERIAL_NUMBER_DATA"]
        [::std::mem::align_of::<_STORAGE_MEDIA_SERIAL_NUMBER_DATA>() - 2usize];
    ["Offset of field: _STORAGE_MEDIA_SERIAL_NUMBER_DATA::Reserved"]
        [::std::mem::offset_of!(_STORAGE_MEDIA_SERIAL_NUMBER_DATA, Reserved) - 0usize];
    ["Offset of field: _STORAGE_MEDIA_SERIAL_NUMBER_DATA::SerialNumberLength"]
        [::std::mem::offset_of!(_STORAGE_MEDIA_SERIAL_NUMBER_DATA, SerialNumberLength) - 2usize];
    ["Offset of field: _STORAGE_MEDIA_SERIAL_NUMBER_DATA::SerialNumber"]
        [::std::mem::offset_of!(_STORAGE_MEDIA_SERIAL_NUMBER_DATA, SerialNumber) - 4usize];
};
pub type STORAGE_MEDIA_SERIAL_NUMBER_DATA = _STORAGE_MEDIA_SERIAL_NUMBER_DATA;
pub type PSTORAGE_MEDIA_SERIAL_NUMBER_DATA = *mut _STORAGE_MEDIA_SERIAL_NUMBER_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_READ_CAPACITY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub BlockLength: DWORD,
    pub NumberOfBlocks: LARGE_INTEGER,
    pub DiskLength: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_READ_CAPACITY"][::std::mem::size_of::<_STORAGE_READ_CAPACITY>() - 32usize];
    ["Alignment of _STORAGE_READ_CAPACITY"]
        [::std::mem::align_of::<_STORAGE_READ_CAPACITY>() - 8usize];
    ["Offset of field: _STORAGE_READ_CAPACITY::Version"]
        [::std::mem::offset_of!(_STORAGE_READ_CAPACITY, Version) - 0usize];
    ["Offset of field: _STORAGE_READ_CAPACITY::Size"]
        [::std::mem::offset_of!(_STORAGE_READ_CAPACITY, Size) - 4usize];
    ["Offset of field: _STORAGE_READ_CAPACITY::BlockLength"]
        [::std::mem::offset_of!(_STORAGE_READ_CAPACITY, BlockLength) - 8usize];
    ["Offset of field: _STORAGE_READ_CAPACITY::NumberOfBlocks"]
        [::std::mem::offset_of!(_STORAGE_READ_CAPACITY, NumberOfBlocks) - 16usize];
    ["Offset of field: _STORAGE_READ_CAPACITY::DiskLength"]
        [::std::mem::offset_of!(_STORAGE_READ_CAPACITY, DiskLength) - 24usize];
};
pub type STORAGE_READ_CAPACITY = _STORAGE_READ_CAPACITY;
pub type PSTORAGE_READ_CAPACITY = *mut _STORAGE_READ_CAPACITY;
pub const _WRITE_CACHE_TYPE_WriteCacheTypeUnknown: _WRITE_CACHE_TYPE = 0;
pub const _WRITE_CACHE_TYPE_WriteCacheTypeNone: _WRITE_CACHE_TYPE = 1;
pub const _WRITE_CACHE_TYPE_WriteCacheTypeWriteBack: _WRITE_CACHE_TYPE = 2;
pub const _WRITE_CACHE_TYPE_WriteCacheTypeWriteThrough: _WRITE_CACHE_TYPE = 3;
pub type _WRITE_CACHE_TYPE = ::std::os::raw::c_int;
pub use self::_WRITE_CACHE_TYPE as WRITE_CACHE_TYPE;
pub const _WRITE_CACHE_ENABLE_WriteCacheEnableUnknown: _WRITE_CACHE_ENABLE = 0;
pub const _WRITE_CACHE_ENABLE_WriteCacheDisabled: _WRITE_CACHE_ENABLE = 1;
pub const _WRITE_CACHE_ENABLE_WriteCacheEnabled: _WRITE_CACHE_ENABLE = 2;
pub type _WRITE_CACHE_ENABLE = ::std::os::raw::c_int;
pub use self::_WRITE_CACHE_ENABLE as WRITE_CACHE_ENABLE;
pub const _WRITE_CACHE_CHANGE_WriteCacheChangeUnknown: _WRITE_CACHE_CHANGE = 0;
pub const _WRITE_CACHE_CHANGE_WriteCacheNotChangeable: _WRITE_CACHE_CHANGE = 1;
pub const _WRITE_CACHE_CHANGE_WriteCacheChangeable: _WRITE_CACHE_CHANGE = 2;
pub type _WRITE_CACHE_CHANGE = ::std::os::raw::c_int;
pub use self::_WRITE_CACHE_CHANGE as WRITE_CACHE_CHANGE;
pub const _WRITE_THROUGH_WriteThroughUnknown: _WRITE_THROUGH = 0;
pub const _WRITE_THROUGH_WriteThroughNotSupported: _WRITE_THROUGH = 1;
pub const _WRITE_THROUGH_WriteThroughSupported: _WRITE_THROUGH = 2;
pub type _WRITE_THROUGH = ::std::os::raw::c_int;
pub use self::_WRITE_THROUGH as WRITE_THROUGH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_WRITE_CACHE_PROPERTY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub WriteCacheType: WRITE_CACHE_TYPE,
    pub WriteCacheEnabled: WRITE_CACHE_ENABLE,
    pub WriteCacheChangeable: WRITE_CACHE_CHANGE,
    pub WriteThroughSupported: WRITE_THROUGH,
    pub FlushCacheSupported: BOOLEAN,
    pub UserDefinedPowerProtection: BOOLEAN,
    pub NVCacheEnabled: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_WRITE_CACHE_PROPERTY"]
        [::std::mem::size_of::<_STORAGE_WRITE_CACHE_PROPERTY>() - 28usize];
    ["Alignment of _STORAGE_WRITE_CACHE_PROPERTY"]
        [::std::mem::align_of::<_STORAGE_WRITE_CACHE_PROPERTY>() - 4usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::Version"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, Version) - 0usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::Size"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, Size) - 4usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::WriteCacheType"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, WriteCacheType) - 8usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::WriteCacheEnabled"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, WriteCacheEnabled) - 12usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::WriteCacheChangeable"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, WriteCacheChangeable) - 16usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::WriteThroughSupported"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, WriteThroughSupported) - 20usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::FlushCacheSupported"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, FlushCacheSupported) - 24usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::UserDefinedPowerProtection"][::std::mem::offset_of!(
        _STORAGE_WRITE_CACHE_PROPERTY,
        UserDefinedPowerProtection
    ) - 25usize];
    ["Offset of field: _STORAGE_WRITE_CACHE_PROPERTY::NVCacheEnabled"]
        [::std::mem::offset_of!(_STORAGE_WRITE_CACHE_PROPERTY, NVCacheEnabled) - 26usize];
};
pub type STORAGE_WRITE_CACHE_PROPERTY = _STORAGE_WRITE_CACHE_PROPERTY;
pub type PSTORAGE_WRITE_CACHE_PROPERTY = *mut _STORAGE_WRITE_CACHE_PROPERTY;
#[repr(C)]
pub struct _PERSISTENT_RESERVE_COMMAND {
    pub Version: DWORD,
    pub Size: DWORD,
    pub __bindgen_anon_1: _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1,
}
#[repr(C)]
pub struct _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1 {
    pub PR_IN: __BindgenUnionField<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1>,
    pub PR_OUT: __BindgenUnionField<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2>,
    pub bindgen_union_field: [u16; 2usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub AllocationLength: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Alignment of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1,
    >() - 2usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1::AllocationLength"] [:: std :: mem :: offset_of ! (_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1 , AllocationLength) - 2usize] ;
};
impl _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_1 {
    #[inline]
    pub fn ServiceAction(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 5u8) as u8) }
    }
    #[inline]
    pub fn set_ServiceAction(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ServiceAction_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                5u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ServiceAction_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved1(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved1(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved1_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved1_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ServiceAction: BYTE,
        Reserved1: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 5u8, {
            let ServiceAction: u8 = unsafe { ::std::mem::transmute(ServiceAction) };
            ServiceAction as u64
        });
        __bindgen_bitfield_unit.set(5usize, 3u8, {
            let Reserved1: u8 = unsafe { ::std::mem::transmute(Reserved1) };
            Reserved1 as u64
        });
        __bindgen_bitfield_unit
    }
}
#[repr(C)]
#[derive(Debug)]
pub struct _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 2usize]>,
    pub ParameterList: __IncompleteArrayField<BYTE>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2>() - 2usize];
    ["Alignment of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2"][::std::mem::align_of::<
        _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2,
    >() - 1usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2::ParameterList"][::std::mem::offset_of!(
        _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2,
        ParameterList
    )
        - 2usize];
};
impl _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1__bindgen_ty_2 {
    #[inline]
    pub fn ServiceAction(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 5u8) as u8) }
    }
    #[inline]
    pub fn set_ServiceAction(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 5u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ServiceAction_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                5u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ServiceAction_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                5u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved1(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(5usize, 3u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved1(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(5usize, 3u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved1_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                5usize,
                3u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved1_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                5usize,
                3u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Type(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(8usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_Type(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(8usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Type_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                8usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Type_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                8usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Scope(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(12usize, 4u8) as u8) }
    }
    #[inline]
    pub fn set_Scope(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(12usize, 4u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Scope_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 2usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                12usize,
                4u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Scope_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 2usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                12usize,
                4u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ServiceAction: BYTE,
        Reserved1: BYTE,
        Type: BYTE,
        Scope: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 2usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 2usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 5u8, {
            let ServiceAction: u8 = unsafe { ::std::mem::transmute(ServiceAction) };
            ServiceAction as u64
        });
        __bindgen_bitfield_unit.set(5usize, 3u8, {
            let Reserved1: u8 = unsafe { ::std::mem::transmute(Reserved1) };
            Reserved1 as u64
        });
        __bindgen_bitfield_unit.set(8usize, 4u8, {
            let Type: u8 = unsafe { ::std::mem::transmute(Type) };
            Type as u64
        });
        __bindgen_bitfield_unit.set(12usize, 4u8, {
            let Scope: u8 = unsafe { ::std::mem::transmute(Scope) };
            Scope as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1"]
        [::std::mem::size_of::<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1>() - 4usize];
    ["Alignment of _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1"]
        [::std::mem::align_of::<_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1>() - 2usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1::PR_IN"]
        [::std::mem::offset_of!(_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1, PR_IN) - 0usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND__bindgen_ty_1::PR_OUT"]
        [::std::mem::offset_of!(_PERSISTENT_RESERVE_COMMAND__bindgen_ty_1, PR_OUT) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERSISTENT_RESERVE_COMMAND"]
        [::std::mem::size_of::<_PERSISTENT_RESERVE_COMMAND>() - 12usize];
    ["Alignment of _PERSISTENT_RESERVE_COMMAND"]
        [::std::mem::align_of::<_PERSISTENT_RESERVE_COMMAND>() - 4usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND::Version"]
        [::std::mem::offset_of!(_PERSISTENT_RESERVE_COMMAND, Version) - 0usize];
    ["Offset of field: _PERSISTENT_RESERVE_COMMAND::Size"]
        [::std::mem::offset_of!(_PERSISTENT_RESERVE_COMMAND, Size) - 4usize];
};
pub type PERSISTENT_RESERVE_COMMAND = _PERSISTENT_RESERVE_COMMAND;
pub type PPERSISTENT_RESERVE_COMMAND = *mut _PERSISTENT_RESERVE_COMMAND;
pub const _DEVICEDUMP_COLLECTION_TYPE_TCCollectionBugCheck: _DEVICEDUMP_COLLECTION_TYPE = 1;
pub const _DEVICEDUMP_COLLECTION_TYPE_TCCollectionApplicationRequested:
    _DEVICEDUMP_COLLECTION_TYPE = 2;
pub const _DEVICEDUMP_COLLECTION_TYPE_TCCollectionDeviceRequested: _DEVICEDUMP_COLLECTION_TYPE = 3;
pub type _DEVICEDUMP_COLLECTION_TYPE = ::std::os::raw::c_int;
pub use self::_DEVICEDUMP_COLLECTION_TYPE as DEVICEDUMP_COLLECTION_TYPEIDE_NOTIFICATION_TYPE;
pub type PDEVICEDUMP_COLLECTION_TYPE = *mut _DEVICEDUMP_COLLECTION_TYPE;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_SUBSECTION_POINTER {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub dwOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_SUBSECTION_POINTER"]
        [::std::mem::size_of::<_DEVICEDUMP_SUBSECTION_POINTER>() - 12usize];
    ["Alignment of _DEVICEDUMP_SUBSECTION_POINTER"]
        [::std::mem::align_of::<_DEVICEDUMP_SUBSECTION_POINTER>() - 1usize];
    ["Offset of field: _DEVICEDUMP_SUBSECTION_POINTER::dwSize"]
        [::std::mem::offset_of!(_DEVICEDUMP_SUBSECTION_POINTER, dwSize) - 0usize];
    ["Offset of field: _DEVICEDUMP_SUBSECTION_POINTER::dwFlags"]
        [::std::mem::offset_of!(_DEVICEDUMP_SUBSECTION_POINTER, dwFlags) - 4usize];
    ["Offset of field: _DEVICEDUMP_SUBSECTION_POINTER::dwOffset"]
        [::std::mem::offset_of!(_DEVICEDUMP_SUBSECTION_POINTER, dwOffset) - 8usize];
};
pub type DEVICEDUMP_SUBSECTION_POINTER = _DEVICEDUMP_SUBSECTION_POINTER;
pub type PDEVICEDUMP_SUBSECTION_POINTER = *mut _DEVICEDUMP_SUBSECTION_POINTER;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_STRUCTURE_VERSION {
    pub dwSignature: DWORD,
    pub dwVersion: DWORD,
    pub dwSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STRUCTURE_VERSION"]
        [::std::mem::size_of::<_DEVICEDUMP_STRUCTURE_VERSION>() - 12usize];
    ["Alignment of _DEVICEDUMP_STRUCTURE_VERSION"]
        [::std::mem::align_of::<_DEVICEDUMP_STRUCTURE_VERSION>() - 1usize];
    ["Offset of field: _DEVICEDUMP_STRUCTURE_VERSION::dwSignature"]
        [::std::mem::offset_of!(_DEVICEDUMP_STRUCTURE_VERSION, dwSignature) - 0usize];
    ["Offset of field: _DEVICEDUMP_STRUCTURE_VERSION::dwVersion"]
        [::std::mem::offset_of!(_DEVICEDUMP_STRUCTURE_VERSION, dwVersion) - 4usize];
    ["Offset of field: _DEVICEDUMP_STRUCTURE_VERSION::dwSize"]
        [::std::mem::offset_of!(_DEVICEDUMP_STRUCTURE_VERSION, dwSize) - 8usize];
};
pub type DEVICEDUMP_STRUCTURE_VERSION = _DEVICEDUMP_STRUCTURE_VERSION;
pub type PDEVICEDUMP_STRUCTURE_VERSION = *mut _DEVICEDUMP_STRUCTURE_VERSION;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_SECTION_HEADER {
    pub guidDeviceDataId: GUID,
    pub sOrganizationID: [BYTE; 16usize],
    pub dwFirmwareRevision: DWORD,
    pub sModelNumber: [BYTE; 32usize],
    pub szDeviceManufacturingID: [BYTE; 32usize],
    pub dwFlags: DWORD,
    pub bRestrictedPrivateDataVersion: DWORD,
    pub dwFirmwareIssueId: DWORD,
    pub szIssueDescriptionString: [BYTE; 132usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_SECTION_HEADER"]
        [::std::mem::size_of::<_DEVICEDUMP_SECTION_HEADER>() - 244usize];
    ["Alignment of _DEVICEDUMP_SECTION_HEADER"]
        [::std::mem::align_of::<_DEVICEDUMP_SECTION_HEADER>() - 1usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::guidDeviceDataId"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, guidDeviceDataId) - 0usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::sOrganizationID"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, sOrganizationID) - 16usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::dwFirmwareRevision"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, dwFirmwareRevision) - 32usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::sModelNumber"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, sModelNumber) - 36usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::szDeviceManufacturingID"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, szDeviceManufacturingID) - 68usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::dwFlags"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, dwFlags) - 100usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::bRestrictedPrivateDataVersion"][::std::mem::offset_of!(
        _DEVICEDUMP_SECTION_HEADER,
        bRestrictedPrivateDataVersion
    ) - 104usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::dwFirmwareIssueId"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, dwFirmwareIssueId) - 108usize];
    ["Offset of field: _DEVICEDUMP_SECTION_HEADER::szIssueDescriptionString"]
        [::std::mem::offset_of!(_DEVICEDUMP_SECTION_HEADER, szIssueDescriptionString) - 112usize];
};
pub type DEVICEDUMP_SECTION_HEADER = _DEVICEDUMP_SECTION_HEADER;
pub type PDEVICEDUMP_SECTION_HEADER = *mut _DEVICEDUMP_SECTION_HEADER;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _GP_LOG_PAGE_DESCRIPTOR {
    pub LogAddress: WORD,
    pub LogSectors: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GP_LOG_PAGE_DESCRIPTOR"][::std::mem::size_of::<_GP_LOG_PAGE_DESCRIPTOR>() - 4usize];
    ["Alignment of _GP_LOG_PAGE_DESCRIPTOR"]
        [::std::mem::align_of::<_GP_LOG_PAGE_DESCRIPTOR>() - 1usize];
    ["Offset of field: _GP_LOG_PAGE_DESCRIPTOR::LogAddress"]
        [::std::mem::offset_of!(_GP_LOG_PAGE_DESCRIPTOR, LogAddress) - 0usize];
    ["Offset of field: _GP_LOG_PAGE_DESCRIPTOR::LogSectors"]
        [::std::mem::offset_of!(_GP_LOG_PAGE_DESCRIPTOR, LogSectors) - 2usize];
};
pub type GP_LOG_PAGE_DESCRIPTOR = _GP_LOG_PAGE_DESCRIPTOR;
pub type PGP_LOG_PAGE_DESCRIPTOR = *mut _GP_LOG_PAGE_DESCRIPTOR;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_PUBLIC_SUBSECTION {
    pub dwFlags: DWORD,
    pub GPLogTable: [GP_LOG_PAGE_DESCRIPTOR; 16usize],
    pub szDescription: [CHAR; 16usize],
    pub bData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_PUBLIC_SUBSECTION"]
        [::std::mem::size_of::<_DEVICEDUMP_PUBLIC_SUBSECTION>() - 85usize];
    ["Alignment of _DEVICEDUMP_PUBLIC_SUBSECTION"]
        [::std::mem::align_of::<_DEVICEDUMP_PUBLIC_SUBSECTION>() - 1usize];
    ["Offset of field: _DEVICEDUMP_PUBLIC_SUBSECTION::dwFlags"]
        [::std::mem::offset_of!(_DEVICEDUMP_PUBLIC_SUBSECTION, dwFlags) - 0usize];
    ["Offset of field: _DEVICEDUMP_PUBLIC_SUBSECTION::GPLogTable"]
        [::std::mem::offset_of!(_DEVICEDUMP_PUBLIC_SUBSECTION, GPLogTable) - 4usize];
    ["Offset of field: _DEVICEDUMP_PUBLIC_SUBSECTION::szDescription"]
        [::std::mem::offset_of!(_DEVICEDUMP_PUBLIC_SUBSECTION, szDescription) - 68usize];
    ["Offset of field: _DEVICEDUMP_PUBLIC_SUBSECTION::bData"]
        [::std::mem::offset_of!(_DEVICEDUMP_PUBLIC_SUBSECTION, bData) - 84usize];
};
pub type DEVICEDUMP_PUBLIC_SUBSECTION = _DEVICEDUMP_PUBLIC_SUBSECTION;
pub type PDEVICEDUMP_PUBLIC_SUBSECTION = *mut _DEVICEDUMP_PUBLIC_SUBSECTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_RESTRICTED_SUBSECTION {
    pub bData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_RESTRICTED_SUBSECTION"]
        [::std::mem::size_of::<_DEVICEDUMP_RESTRICTED_SUBSECTION>() - 1usize];
    ["Alignment of _DEVICEDUMP_RESTRICTED_SUBSECTION"]
        [::std::mem::align_of::<_DEVICEDUMP_RESTRICTED_SUBSECTION>() - 1usize];
    ["Offset of field: _DEVICEDUMP_RESTRICTED_SUBSECTION::bData"]
        [::std::mem::offset_of!(_DEVICEDUMP_RESTRICTED_SUBSECTION, bData) - 0usize];
};
pub type DEVICEDUMP_RESTRICTED_SUBSECTION = _DEVICEDUMP_RESTRICTED_SUBSECTION;
pub type PDEVICEDUMP_RESTRICTED_SUBSECTION = *mut _DEVICEDUMP_RESTRICTED_SUBSECTION;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_PRIVATE_SUBSECTION {
    pub dwFlags: DWORD,
    pub GPLogId: GP_LOG_PAGE_DESCRIPTOR,
    pub bData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_PRIVATE_SUBSECTION"]
        [::std::mem::size_of::<_DEVICEDUMP_PRIVATE_SUBSECTION>() - 9usize];
    ["Alignment of _DEVICEDUMP_PRIVATE_SUBSECTION"]
        [::std::mem::align_of::<_DEVICEDUMP_PRIVATE_SUBSECTION>() - 1usize];
    ["Offset of field: _DEVICEDUMP_PRIVATE_SUBSECTION::dwFlags"]
        [::std::mem::offset_of!(_DEVICEDUMP_PRIVATE_SUBSECTION, dwFlags) - 0usize];
    ["Offset of field: _DEVICEDUMP_PRIVATE_SUBSECTION::GPLogId"]
        [::std::mem::offset_of!(_DEVICEDUMP_PRIVATE_SUBSECTION, GPLogId) - 4usize];
    ["Offset of field: _DEVICEDUMP_PRIVATE_SUBSECTION::bData"]
        [::std::mem::offset_of!(_DEVICEDUMP_PRIVATE_SUBSECTION, bData) - 8usize];
};
pub type DEVICEDUMP_PRIVATE_SUBSECTION = _DEVICEDUMP_PRIVATE_SUBSECTION;
pub type PDEVICEDUMP_PRIVATE_SUBSECTION = *mut _DEVICEDUMP_PRIVATE_SUBSECTION;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_STORAGEDEVICE_DATA {
    pub Descriptor: DEVICEDUMP_STRUCTURE_VERSION,
    pub SectionHeader: DEVICEDUMP_SECTION_HEADER,
    pub dwBufferSize: DWORD,
    pub dwReasonForCollection: DWORD,
    pub PublicData: DEVICEDUMP_SUBSECTION_POINTER,
    pub RestrictedData: DEVICEDUMP_SUBSECTION_POINTER,
    pub PrivateData: DEVICEDUMP_SUBSECTION_POINTER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGEDEVICE_DATA"]
        [::std::mem::size_of::<_DEVICEDUMP_STORAGEDEVICE_DATA>() - 300usize];
    ["Alignment of _DEVICEDUMP_STORAGEDEVICE_DATA"]
        [::std::mem::align_of::<_DEVICEDUMP_STORAGEDEVICE_DATA>() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::Descriptor"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, Descriptor) - 0usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::SectionHeader"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, SectionHeader) - 12usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::dwBufferSize"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, dwBufferSize) - 256usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::dwReasonForCollection"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, dwReasonForCollection) - 260usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::PublicData"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, PublicData) - 264usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::RestrictedData"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, RestrictedData) - 276usize];
    ["Offset of field: _DEVICEDUMP_STORAGEDEVICE_DATA::PrivateData"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGEDEVICE_DATA, PrivateData) - 288usize];
};
pub type DEVICEDUMP_STORAGEDEVICE_DATA = _DEVICEDUMP_STORAGEDEVICE_DATA;
pub type PDEVICEDUMP_STORAGEDEVICE_DATA = *mut _DEVICEDUMP_STORAGEDEVICE_DATA;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD {
    pub Cdb: [BYTE; 16usize],
    pub Command: [BYTE; 16usize],
    pub StartTime: DWORDLONG,
    pub EndTime: DWORDLONG,
    pub OperationStatus: DWORD,
    pub OperationError: DWORD,
    pub StackSpecific: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1 {
    pub ExternalStack: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1,
    pub AtaPort: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2,
    pub StorPort: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3,
}
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1 {
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1,
        >() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1::dwReserved"] [:: std :: mem :: offset_of ! (_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_1 , dwReserved) - 0usize] ;
};
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2 {
    pub dwAtaPortSpecific: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2,
        >() - 4usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2,
        >() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2::dwAtaPortSpecific"] [:: std :: mem :: offset_of ! (_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_2 , dwAtaPortSpecific) - 0usize] ;
};
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3 {
    pub SrbTag: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::size_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3,
        >() - 4usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3"]
        [::std::mem::align_of::<
            _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3,
        >() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3::SrbTag"] [:: std :: mem :: offset_of ! (_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1__bindgen_ty_3 , SrbTag) - 0usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1"][::std::mem::size_of::<
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1,
    >() - 4usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1"][::std::mem::align_of::<
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1,
    >() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1::ExternalStack"] [:: std :: mem :: offset_of ! (_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1 , ExternalStack) - 0usize] ;
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1::AtaPort"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1,
        AtaPort
    )
        - 0usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1::StorPort"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD__bindgen_ty_1,
        StorPort
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD"]
        [::std::mem::size_of::<_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD>() - 60usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD"]
        [::std::mem::align_of::<_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD>() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::Cdb"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD, Cdb) - 0usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::Command"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD, Command) - 16usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::StartTime"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD, StartTime) - 32usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::EndTime"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD, EndTime) - 40usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::OperationStatus"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD,
        OperationStatus
    ) - 48usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::OperationError"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD,
        OperationError
    ) - 52usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD::StackSpecific"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD,
        StackSpecific
    ) - 56usize];
};
pub type DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD = _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD;
pub type PDEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD =
    *mut _DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP {
    pub Descriptor: DEVICEDUMP_STRUCTURE_VERSION,
    pub dwReasonForCollection: DWORD,
    pub cDriverName: [BYTE; 16usize],
    pub uiNumRecords: DWORD,
    pub RecordArray: [DEVICEDUMP_STORAGESTACK_PUBLIC_STATE_RECORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP"]
        [::std::mem::size_of::<_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP>() - 96usize];
    ["Alignment of _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP"]
        [::std::mem::align_of::<_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP>() - 1usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP::Descriptor"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP, Descriptor) - 0usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP::dwReasonForCollection"][::std::mem::offset_of!(
        _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP,
        dwReasonForCollection
    ) - 12usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP::cDriverName"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP, cDriverName) - 16usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP::uiNumRecords"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP, uiNumRecords) - 32usize];
    ["Offset of field: _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP::RecordArray"]
        [::std::mem::offset_of!(_DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP, RecordArray) - 36usize];
};
pub type DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP = _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP;
pub type PDEVICEDUMP_STORAGESTACK_PUBLIC_DUMP = *mut _DEVICEDUMP_STORAGESTACK_PUBLIC_DUMP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_IDLE_POWER {
    pub Version: DWORD,
    pub Size: DWORD,
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
    pub D3IdleTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_IDLE_POWER"][::std::mem::size_of::<_STORAGE_IDLE_POWER>() - 16usize];
    ["Alignment of _STORAGE_IDLE_POWER"][::std::mem::align_of::<_STORAGE_IDLE_POWER>() - 4usize];
    ["Offset of field: _STORAGE_IDLE_POWER::Version"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWER, Version) - 0usize];
    ["Offset of field: _STORAGE_IDLE_POWER::Size"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWER, Size) - 4usize];
    ["Offset of field: _STORAGE_IDLE_POWER::D3IdleTimeout"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWER, D3IdleTimeout) - 12usize];
};
impl _STORAGE_IDLE_POWER {
    #[inline]
    pub fn WakeCapableHint(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_WakeCapableHint(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn WakeCapableHint_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_WakeCapableHint_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn D3ColdSupported(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_D3ColdSupported(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn D3ColdSupported_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_D3ColdSupported_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        WakeCapableHint: DWORD,
        D3ColdSupported: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let WakeCapableHint: u32 = unsafe { ::std::mem::transmute(WakeCapableHint) };
            WakeCapableHint as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let D3ColdSupported: u32 = unsafe { ::std::mem::transmute(D3ColdSupported) };
            D3ColdSupported as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type STORAGE_IDLE_POWER = _STORAGE_IDLE_POWER;
pub type PSTORAGE_IDLE_POWER = *mut _STORAGE_IDLE_POWER;
pub const _STORAGE_POWERUP_REASON_TYPE_StoragePowerupUnknown: _STORAGE_POWERUP_REASON_TYPE = 0;
pub const _STORAGE_POWERUP_REASON_TYPE_StoragePowerupIO: _STORAGE_POWERUP_REASON_TYPE = 1;
pub const _STORAGE_POWERUP_REASON_TYPE_StoragePowerupDeviceAttention: _STORAGE_POWERUP_REASON_TYPE =
    2;
pub type _STORAGE_POWERUP_REASON_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_POWERUP_REASON_TYPE as STORAGE_POWERUP_REASON_TYPE;
pub type PSTORAGE_POWERUP_REASON_TYPE = *mut _STORAGE_POWERUP_REASON_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_IDLE_POWERUP_REASON {
    pub Version: DWORD,
    pub Size: DWORD,
    pub PowerupReason: STORAGE_POWERUP_REASON_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_IDLE_POWERUP_REASON"]
        [::std::mem::size_of::<_STORAGE_IDLE_POWERUP_REASON>() - 12usize];
    ["Alignment of _STORAGE_IDLE_POWERUP_REASON"]
        [::std::mem::align_of::<_STORAGE_IDLE_POWERUP_REASON>() - 4usize];
    ["Offset of field: _STORAGE_IDLE_POWERUP_REASON::Version"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWERUP_REASON, Version) - 0usize];
    ["Offset of field: _STORAGE_IDLE_POWERUP_REASON::Size"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWERUP_REASON, Size) - 4usize];
    ["Offset of field: _STORAGE_IDLE_POWERUP_REASON::PowerupReason"]
        [::std::mem::offset_of!(_STORAGE_IDLE_POWERUP_REASON, PowerupReason) - 8usize];
};
pub type STORAGE_IDLE_POWERUP_REASON = _STORAGE_IDLE_POWERUP_REASON;
pub type PSTORAGE_IDLE_POWERUP_REASON = *mut _STORAGE_IDLE_POWERUP_REASON;
pub const _STORAGE_DEVICE_POWER_CAP_UNITS_StorageDevicePowerCapUnitsPercent:
    _STORAGE_DEVICE_POWER_CAP_UNITS = 0;
pub const _STORAGE_DEVICE_POWER_CAP_UNITS_StorageDevicePowerCapUnitsMilliwatts:
    _STORAGE_DEVICE_POWER_CAP_UNITS = 1;
pub type _STORAGE_DEVICE_POWER_CAP_UNITS = ::std::os::raw::c_int;
pub use self::_STORAGE_DEVICE_POWER_CAP_UNITS as STORAGE_DEVICE_POWER_CAP_UNITS;
pub type PSTORAGE_DEVICE_POWER_CAP_UNITS = *mut _STORAGE_DEVICE_POWER_CAP_UNITS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_DEVICE_POWER_CAP {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Units: STORAGE_DEVICE_POWER_CAP_UNITS,
    pub MaxPower: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_DEVICE_POWER_CAP"]
        [::std::mem::size_of::<_STORAGE_DEVICE_POWER_CAP>() - 24usize];
    ["Alignment of _STORAGE_DEVICE_POWER_CAP"]
        [::std::mem::align_of::<_STORAGE_DEVICE_POWER_CAP>() - 8usize];
    ["Offset of field: _STORAGE_DEVICE_POWER_CAP::Version"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_POWER_CAP, Version) - 0usize];
    ["Offset of field: _STORAGE_DEVICE_POWER_CAP::Size"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_POWER_CAP, Size) - 4usize];
    ["Offset of field: _STORAGE_DEVICE_POWER_CAP::Units"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_POWER_CAP, Units) - 8usize];
    ["Offset of field: _STORAGE_DEVICE_POWER_CAP::MaxPower"]
        [::std::mem::offset_of!(_STORAGE_DEVICE_POWER_CAP, MaxPower) - 16usize];
};
pub type STORAGE_DEVICE_POWER_CAP = _STORAGE_DEVICE_POWER_CAP;
pub type PSTORAGE_DEVICE_POWER_CAP = *mut _STORAGE_DEVICE_POWER_CAP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_RPMB_DATA_FRAME {
    pub Stuff: [BYTE; 196usize],
    pub KeyOrMAC: [BYTE; 32usize],
    pub Data: [BYTE; 256usize],
    pub Nonce: [BYTE; 16usize],
    pub WriteCounter: [BYTE; 4usize],
    pub Address: [BYTE; 2usize],
    pub BlockCount: [BYTE; 2usize],
    pub OperationResult: [BYTE; 2usize],
    pub RequestOrResponseType: [BYTE; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_RPMB_DATA_FRAME"]
        [::std::mem::size_of::<_STORAGE_RPMB_DATA_FRAME>() - 512usize];
    ["Alignment of _STORAGE_RPMB_DATA_FRAME"]
        [::std::mem::align_of::<_STORAGE_RPMB_DATA_FRAME>() - 1usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::Stuff"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, Stuff) - 0usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::KeyOrMAC"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, KeyOrMAC) - 196usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::Data"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, Data) - 228usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::Nonce"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, Nonce) - 484usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::WriteCounter"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, WriteCounter) - 500usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::Address"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, Address) - 504usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::BlockCount"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, BlockCount) - 506usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::OperationResult"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, OperationResult) - 508usize];
    ["Offset of field: _STORAGE_RPMB_DATA_FRAME::RequestOrResponseType"]
        [::std::mem::offset_of!(_STORAGE_RPMB_DATA_FRAME, RequestOrResponseType) - 510usize];
};
pub type STORAGE_RPMB_DATA_FRAME = _STORAGE_RPMB_DATA_FRAME;
pub type PSTORAGE_RPMB_DATA_FRAME = *mut _STORAGE_RPMB_DATA_FRAME;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbProgramAuthKey: _STORAGE_RPMB_COMMAND_TYPE = 1;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbQueryWriteCounter: _STORAGE_RPMB_COMMAND_TYPE = 2;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbAuthenticatedWrite: _STORAGE_RPMB_COMMAND_TYPE = 3;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbAuthenticatedRead: _STORAGE_RPMB_COMMAND_TYPE = 4;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbReadResultRequest: _STORAGE_RPMB_COMMAND_TYPE = 5;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbAuthenticatedDeviceConfigWrite:
    _STORAGE_RPMB_COMMAND_TYPE = 6;
pub const _STORAGE_RPMB_COMMAND_TYPE_StorRpmbAuthenticatedDeviceConfigRead:
    _STORAGE_RPMB_COMMAND_TYPE = 7;
pub type _STORAGE_RPMB_COMMAND_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_RPMB_COMMAND_TYPE as STORAGE_RPMB_COMMAND_TYPE;
pub type PSTORAGE_RPMB_COMMAND_TYPE = *mut _STORAGE_RPMB_COMMAND_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_EVENT_NOTIFICATION {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Events: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_EVENT_NOTIFICATION"]
        [::std::mem::size_of::<_STORAGE_EVENT_NOTIFICATION>() - 16usize];
    ["Alignment of _STORAGE_EVENT_NOTIFICATION"]
        [::std::mem::align_of::<_STORAGE_EVENT_NOTIFICATION>() - 8usize];
    ["Offset of field: _STORAGE_EVENT_NOTIFICATION::Version"]
        [::std::mem::offset_of!(_STORAGE_EVENT_NOTIFICATION, Version) - 0usize];
    ["Offset of field: _STORAGE_EVENT_NOTIFICATION::Size"]
        [::std::mem::offset_of!(_STORAGE_EVENT_NOTIFICATION, Size) - 4usize];
    ["Offset of field: _STORAGE_EVENT_NOTIFICATION::Events"]
        [::std::mem::offset_of!(_STORAGE_EVENT_NOTIFICATION, Events) - 8usize];
};
pub type STORAGE_EVENT_NOTIFICATION = _STORAGE_EVENT_NOTIFICATION;
pub type PSTORAGE_EVENT_NOTIFICATION = *mut _STORAGE_EVENT_NOTIFICATION;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeUnknown: _STORAGE_COUNTER_TYPE = 0;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeTemperatureCelsius: _STORAGE_COUNTER_TYPE = 1;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeTemperatureCelsiusMax: _STORAGE_COUNTER_TYPE = 2;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeReadErrorsTotal: _STORAGE_COUNTER_TYPE = 3;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeReadErrorsCorrected: _STORAGE_COUNTER_TYPE = 4;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeReadErrorsUncorrected: _STORAGE_COUNTER_TYPE = 5;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWriteErrorsTotal: _STORAGE_COUNTER_TYPE = 6;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWriteErrorsCorrected: _STORAGE_COUNTER_TYPE = 7;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWriteErrorsUncorrected: _STORAGE_COUNTER_TYPE = 8;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeManufactureDate: _STORAGE_COUNTER_TYPE = 9;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeStartStopCycleCount: _STORAGE_COUNTER_TYPE = 10;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeStartStopCycleCountMax: _STORAGE_COUNTER_TYPE =
    11;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeLoadUnloadCycleCount: _STORAGE_COUNTER_TYPE = 12;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeLoadUnloadCycleCountMax: _STORAGE_COUNTER_TYPE =
    13;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWearPercentage: _STORAGE_COUNTER_TYPE = 14;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWearPercentageWarning: _STORAGE_COUNTER_TYPE = 15;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWearPercentageMax: _STORAGE_COUNTER_TYPE = 16;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypePowerOnHours: _STORAGE_COUNTER_TYPE = 17;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeReadLatency100NSMax: _STORAGE_COUNTER_TYPE = 18;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeWriteLatency100NSMax: _STORAGE_COUNTER_TYPE = 19;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeFlushLatency100NSMax: _STORAGE_COUNTER_TYPE = 20;
pub const _STORAGE_COUNTER_TYPE_StorageCounterTypeMax: _STORAGE_COUNTER_TYPE = 21;
pub type _STORAGE_COUNTER_TYPE = ::std::os::raw::c_int;
pub use self::_STORAGE_COUNTER_TYPE as STORAGE_COUNTER_TYPE;
pub type PSTORAGE_COUNTER_TYPE = *mut _STORAGE_COUNTER_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_COUNTER {
    pub Type: STORAGE_COUNTER_TYPE,
    pub Value: _STORAGE_COUNTER__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STORAGE_COUNTER__bindgen_ty_1 {
    pub ManufactureDate: _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1,
    pub AsUlonglong: DWORDLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1 {
    pub Week: DWORD,
    pub Year: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1::Week"]
        [::std::mem::offset_of!(_STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1, Week) - 0usize];
    ["Offset of field: _STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1::Year"]
        [::std::mem::offset_of!(_STORAGE_COUNTER__bindgen_ty_1__bindgen_ty_1, Year) - 4usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_COUNTER__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_COUNTER__bindgen_ty_1>() - 8usize];
    ["Alignment of _STORAGE_COUNTER__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_COUNTER__bindgen_ty_1>() - 8usize];
    ["Offset of field: _STORAGE_COUNTER__bindgen_ty_1::ManufactureDate"]
        [::std::mem::offset_of!(_STORAGE_COUNTER__bindgen_ty_1, ManufactureDate) - 0usize];
    ["Offset of field: _STORAGE_COUNTER__bindgen_ty_1::AsUlonglong"]
        [::std::mem::offset_of!(_STORAGE_COUNTER__bindgen_ty_1, AsUlonglong) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_COUNTER"][::std::mem::size_of::<_STORAGE_COUNTER>() - 16usize];
    ["Alignment of _STORAGE_COUNTER"][::std::mem::align_of::<_STORAGE_COUNTER>() - 8usize];
    ["Offset of field: _STORAGE_COUNTER::Type"]
        [::std::mem::offset_of!(_STORAGE_COUNTER, Type) - 0usize];
    ["Offset of field: _STORAGE_COUNTER::Value"]
        [::std::mem::offset_of!(_STORAGE_COUNTER, Value) - 8usize];
};
pub type STORAGE_COUNTER = _STORAGE_COUNTER;
pub type PSTORAGE_COUNTER = *mut _STORAGE_COUNTER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STORAGE_COUNTERS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumberOfCounters: DWORD,
    pub Counters: [STORAGE_COUNTER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_COUNTERS"][::std::mem::size_of::<_STORAGE_COUNTERS>() - 32usize];
    ["Alignment of _STORAGE_COUNTERS"][::std::mem::align_of::<_STORAGE_COUNTERS>() - 8usize];
    ["Offset of field: _STORAGE_COUNTERS::Version"]
        [::std::mem::offset_of!(_STORAGE_COUNTERS, Version) - 0usize];
    ["Offset of field: _STORAGE_COUNTERS::Size"]
        [::std::mem::offset_of!(_STORAGE_COUNTERS, Size) - 4usize];
    ["Offset of field: _STORAGE_COUNTERS::NumberOfCounters"]
        [::std::mem::offset_of!(_STORAGE_COUNTERS, NumberOfCounters) - 8usize];
    ["Offset of field: _STORAGE_COUNTERS::Counters"]
        [::std::mem::offset_of!(_STORAGE_COUNTERS, Counters) - 16usize];
};
pub type STORAGE_COUNTERS = _STORAGE_COUNTERS;
pub type PSTORAGE_COUNTERS = *mut _STORAGE_COUNTERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_INFO_QUERY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_INFO_QUERY"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_INFO_QUERY>() - 16usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_INFO_QUERY"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_INFO_QUERY>() - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO_QUERY::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO_QUERY, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO_QUERY::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO_QUERY, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO_QUERY::Flags"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO_QUERY, Flags) - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO_QUERY::Reserved"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO_QUERY, Reserved) - 12usize];
};
pub type STORAGE_HW_FIRMWARE_INFO_QUERY = _STORAGE_HW_FIRMWARE_INFO_QUERY;
pub type PSTORAGE_HW_FIRMWARE_INFO_QUERY = *mut _STORAGE_HW_FIRMWARE_INFO_QUERY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_SLOT_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SlotNumber: BYTE,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub Reserved1: [BYTE; 6usize],
    pub Revision: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_SLOT_INFO"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_SLOT_INFO>() - 32usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_SLOT_INFO"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_SLOT_INFO>() - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_SLOT_INFO::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_SLOT_INFO, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_SLOT_INFO::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_SLOT_INFO, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_SLOT_INFO::SlotNumber"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_SLOT_INFO, SlotNumber) - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_SLOT_INFO::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_SLOT_INFO, Reserved1) - 10usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_SLOT_INFO::Revision"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_SLOT_INFO, Revision) - 16usize];
};
impl _STORAGE_HW_FIRMWARE_SLOT_INFO {
    #[inline]
    pub fn ReadOnly(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ReadOnly(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReadOnly_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ReadOnly_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved0(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 7u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved0(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved0_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                7u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved0_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(ReadOnly: BYTE, Reserved0: BYTE) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ReadOnly: u8 = unsafe { ::std::mem::transmute(ReadOnly) };
            ReadOnly as u64
        });
        __bindgen_bitfield_unit.set(1usize, 7u8, {
            let Reserved0: u8 = unsafe { ::std::mem::transmute(Reserved0) };
            Reserved0 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type STORAGE_HW_FIRMWARE_SLOT_INFO = _STORAGE_HW_FIRMWARE_SLOT_INFO;
pub type PSTORAGE_HW_FIRMWARE_SLOT_INFO = *mut _STORAGE_HW_FIRMWARE_SLOT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub SlotCount: BYTE,
    pub ActiveSlot: BYTE,
    pub PendingActivateSlot: BYTE,
    pub FirmwareShared: BOOLEAN,
    pub Reserved: [BYTE; 3usize],
    pub ImagePayloadAlignment: DWORD,
    pub ImagePayloadMaxSize: DWORD,
    pub Slot: [STORAGE_HW_FIRMWARE_SLOT_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_INFO"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_INFO>() - 56usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_INFO"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_INFO>() - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::SlotCount"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, SlotCount) - 9usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::ActiveSlot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, ActiveSlot) - 10usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::PendingActivateSlot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, PendingActivateSlot) - 11usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::FirmwareShared"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, FirmwareShared) - 12usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::Reserved"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, Reserved) - 13usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::ImagePayloadAlignment"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, ImagePayloadAlignment) - 16usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::ImagePayloadMaxSize"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, ImagePayloadMaxSize) - 20usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_INFO::Slot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_INFO, Slot) - 24usize];
};
impl _STORAGE_HW_FIRMWARE_INFO {
    #[inline]
    pub fn SupportUpgrade(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_SupportUpgrade(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn SupportUpgrade_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_SupportUpgrade_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved0(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 7u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved0(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved0_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                7u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved0_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        SupportUpgrade: BYTE,
        Reserved0: BYTE,
    ) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let SupportUpgrade: u8 = unsafe { ::std::mem::transmute(SupportUpgrade) };
            SupportUpgrade as u64
        });
        __bindgen_bitfield_unit.set(1usize, 7u8, {
            let Reserved0: u8 = unsafe { ::std::mem::transmute(Reserved0) };
            Reserved0 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type STORAGE_HW_FIRMWARE_INFO = _STORAGE_HW_FIRMWARE_INFO;
pub type PSTORAGE_HW_FIRMWARE_INFO = *mut _STORAGE_HW_FIRMWARE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_DOWNLOAD {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Slot: BYTE,
    pub Reserved: [BYTE; 3usize],
    pub Offset: DWORDLONG,
    pub BufferSize: DWORDLONG,
    pub ImageBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_DOWNLOAD"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_DOWNLOAD>() - 40usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_DOWNLOAD"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_DOWNLOAD>() - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Flags"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Flags) - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Slot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Slot) - 12usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Reserved"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Reserved) - 13usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::Offset"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, Offset) - 16usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::BufferSize"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, BufferSize) - 24usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD::ImageBuffer"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD, ImageBuffer) - 32usize];
};
pub type STORAGE_HW_FIRMWARE_DOWNLOAD = _STORAGE_HW_FIRMWARE_DOWNLOAD;
pub type PSTORAGE_HW_FIRMWARE_DOWNLOAD = *mut _STORAGE_HW_FIRMWARE_DOWNLOAD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_DOWNLOAD_V2 {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Slot: BYTE,
    pub Reserved: [BYTE; 3usize],
    pub Offset: DWORDLONG,
    pub BufferSize: DWORDLONG,
    pub ImageSize: DWORD,
    pub Reserved2: DWORD,
    pub ImageBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_DOWNLOAD_V2"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_DOWNLOAD_V2>() - 48usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_DOWNLOAD_V2"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_DOWNLOAD_V2>() - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Flags"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Flags) - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Slot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Slot) - 12usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Reserved"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Reserved) - 13usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Offset"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Offset) - 16usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::BufferSize"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, BufferSize) - 24usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::ImageSize"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, ImageSize) - 32usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::Reserved2"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, Reserved2) - 36usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_DOWNLOAD_V2::ImageBuffer"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_DOWNLOAD_V2, ImageBuffer) - 40usize];
};
pub type STORAGE_HW_FIRMWARE_DOWNLOAD_V2 = _STORAGE_HW_FIRMWARE_DOWNLOAD_V2;
pub type PSTORAGE_HW_FIRMWARE_DOWNLOAD_V2 = *mut _STORAGE_HW_FIRMWARE_DOWNLOAD_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_HW_FIRMWARE_ACTIVATE {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Slot: BYTE,
    pub Reserved0: [BYTE; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_HW_FIRMWARE_ACTIVATE"]
        [::std::mem::size_of::<_STORAGE_HW_FIRMWARE_ACTIVATE>() - 16usize];
    ["Alignment of _STORAGE_HW_FIRMWARE_ACTIVATE"]
        [::std::mem::align_of::<_STORAGE_HW_FIRMWARE_ACTIVATE>() - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_ACTIVATE::Version"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_ACTIVATE, Version) - 0usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_ACTIVATE::Size"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_ACTIVATE, Size) - 4usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_ACTIVATE::Flags"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_ACTIVATE, Flags) - 8usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_ACTIVATE::Slot"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_ACTIVATE, Slot) - 12usize];
    ["Offset of field: _STORAGE_HW_FIRMWARE_ACTIVATE::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_HW_FIRMWARE_ACTIVATE, Reserved0) - 13usize];
};
pub type STORAGE_HW_FIRMWARE_ACTIVATE = _STORAGE_HW_FIRMWARE_ACTIVATE;
pub type PSTORAGE_HW_FIRMWARE_ACTIVATE = *mut _STORAGE_HW_FIRMWARE_ACTIVATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_PROTOCOL_COMMAND {
    pub Version: DWORD,
    pub Length: DWORD,
    pub ProtocolType: STORAGE_PROTOCOL_TYPE,
    pub Flags: DWORD,
    pub ReturnStatus: DWORD,
    pub ErrorCode: DWORD,
    pub CommandLength: DWORD,
    pub ErrorInfoLength: DWORD,
    pub DataToDeviceTransferLength: DWORD,
    pub DataFromDeviceTransferLength: DWORD,
    pub TimeOutValue: DWORD,
    pub ErrorInfoOffset: DWORD,
    pub DataToDeviceBufferOffset: DWORD,
    pub DataFromDeviceBufferOffset: DWORD,
    pub CommandSpecific: DWORD,
    pub Reserved0: DWORD,
    pub FixedProtocolReturnData: DWORD,
    pub Reserved1: [DWORD; 3usize],
    pub Command: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_PROTOCOL_COMMAND"]
        [::std::mem::size_of::<_STORAGE_PROTOCOL_COMMAND>() - 84usize];
    ["Alignment of _STORAGE_PROTOCOL_COMMAND"]
        [::std::mem::align_of::<_STORAGE_PROTOCOL_COMMAND>() - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Version"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Version) - 0usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Length"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Length) - 4usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::ProtocolType"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, ProtocolType) - 8usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Flags"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Flags) - 12usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::ReturnStatus"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, ReturnStatus) - 16usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::ErrorCode"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, ErrorCode) - 20usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::CommandLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, CommandLength) - 24usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::ErrorInfoLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, ErrorInfoLength) - 28usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::DataToDeviceTransferLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, DataToDeviceTransferLength) - 32usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::DataFromDeviceTransferLength"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, DataFromDeviceTransferLength) - 36usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::TimeOutValue"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, TimeOutValue) - 40usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::ErrorInfoOffset"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, ErrorInfoOffset) - 44usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::DataToDeviceBufferOffset"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, DataToDeviceBufferOffset) - 48usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::DataFromDeviceBufferOffset"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, DataFromDeviceBufferOffset) - 52usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::CommandSpecific"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, CommandSpecific) - 56usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Reserved0"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Reserved0) - 60usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::FixedProtocolReturnData"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, FixedProtocolReturnData) - 64usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Reserved1"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Reserved1) - 68usize];
    ["Offset of field: _STORAGE_PROTOCOL_COMMAND::Command"]
        [::std::mem::offset_of!(_STORAGE_PROTOCOL_COMMAND, Command) - 80usize];
};
pub type STORAGE_PROTOCOL_COMMAND = _STORAGE_PROTOCOL_COMMAND;
pub type PSTORAGE_PROTOCOL_COMMAND = *mut _STORAGE_PROTOCOL_COMMAND;
pub const _STORAGE_ATTRIBUTE_MGMT_ACTION_StorAttributeMgmt_ClearAttribute:
    _STORAGE_ATTRIBUTE_MGMT_ACTION = 0;
pub const _STORAGE_ATTRIBUTE_MGMT_ACTION_StorAttributeMgmt_SetAttribute:
    _STORAGE_ATTRIBUTE_MGMT_ACTION = 1;
pub const _STORAGE_ATTRIBUTE_MGMT_ACTION_StorAttributeMgmt_ResetAttribute:
    _STORAGE_ATTRIBUTE_MGMT_ACTION = 2;
pub type _STORAGE_ATTRIBUTE_MGMT_ACTION = ::std::os::raw::c_int;
pub use self::_STORAGE_ATTRIBUTE_MGMT_ACTION as STORAGE_ATTRIBUTE_MGMT_ACTION;
pub type PSTORAGE_ATTRIBUTE_MGMT_ACTION = *mut _STORAGE_ATTRIBUTE_MGMT_ACTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_ATTRIBUTE_MGMT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Action: STORAGE_ATTRIBUTE_MGMT_ACTION,
    pub Attribute: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_ATTRIBUTE_MGMT"][::std::mem::size_of::<_STORAGE_ATTRIBUTE_MGMT>() - 16usize];
    ["Alignment of _STORAGE_ATTRIBUTE_MGMT"]
        [::std::mem::align_of::<_STORAGE_ATTRIBUTE_MGMT>() - 4usize];
    ["Offset of field: _STORAGE_ATTRIBUTE_MGMT::Version"]
        [::std::mem::offset_of!(_STORAGE_ATTRIBUTE_MGMT, Version) - 0usize];
    ["Offset of field: _STORAGE_ATTRIBUTE_MGMT::Size"]
        [::std::mem::offset_of!(_STORAGE_ATTRIBUTE_MGMT, Size) - 4usize];
    ["Offset of field: _STORAGE_ATTRIBUTE_MGMT::Action"]
        [::std::mem::offset_of!(_STORAGE_ATTRIBUTE_MGMT, Action) - 8usize];
    ["Offset of field: _STORAGE_ATTRIBUTE_MGMT::Attribute"]
        [::std::mem::offset_of!(_STORAGE_ATTRIBUTE_MGMT, Attribute) - 12usize];
};
pub type STORAGE_ATTRIBUTE_MGMT = _STORAGE_ATTRIBUTE_MGMT;
pub type PSTORAGE_ATTRIBUTE_MGMT = *mut _STORAGE_ATTRIBUTE_MGMT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_HEALTH_NOTIFICATION_DATA {
    pub DeviceGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_HEALTH_NOTIFICATION_DATA"]
        [::std::mem::size_of::<_SCM_PD_HEALTH_NOTIFICATION_DATA>() - 16usize];
    ["Alignment of _SCM_PD_HEALTH_NOTIFICATION_DATA"]
        [::std::mem::align_of::<_SCM_PD_HEALTH_NOTIFICATION_DATA>() - 4usize];
    ["Offset of field: _SCM_PD_HEALTH_NOTIFICATION_DATA::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_PD_HEALTH_NOTIFICATION_DATA, DeviceGuid) - 0usize];
};
pub type SCM_PD_HEALTH_NOTIFICATION_DATA = _SCM_PD_HEALTH_NOTIFICATION_DATA;
pub type PSCM_PD_HEALTH_NOTIFICATION_DATA = *mut _SCM_PD_HEALTH_NOTIFICATION_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_LOGICAL_DEVICE_INSTANCE {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceGuid: GUID,
    pub SymbolicLink: [WCHAR; 256usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_LOGICAL_DEVICE_INSTANCE"]
        [::std::mem::size_of::<_SCM_LOGICAL_DEVICE_INSTANCE>() - 536usize];
    ["Alignment of _SCM_LOGICAL_DEVICE_INSTANCE"]
        [::std::mem::align_of::<_SCM_LOGICAL_DEVICE_INSTANCE>() - 4usize];
    ["Offset of field: _SCM_LOGICAL_DEVICE_INSTANCE::Version"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICE_INSTANCE, Version) - 0usize];
    ["Offset of field: _SCM_LOGICAL_DEVICE_INSTANCE::Size"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICE_INSTANCE, Size) - 4usize];
    ["Offset of field: _SCM_LOGICAL_DEVICE_INSTANCE::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICE_INSTANCE, DeviceGuid) - 8usize];
    ["Offset of field: _SCM_LOGICAL_DEVICE_INSTANCE::SymbolicLink"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICE_INSTANCE, SymbolicLink) - 24usize];
};
pub type SCM_LOGICAL_DEVICE_INSTANCE = _SCM_LOGICAL_DEVICE_INSTANCE;
pub type PSCM_LOGICAL_DEVICE_INSTANCE = *mut _SCM_LOGICAL_DEVICE_INSTANCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_LOGICAL_DEVICES {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceCount: DWORD,
    pub Devices: [SCM_LOGICAL_DEVICE_INSTANCE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_LOGICAL_DEVICES"][::std::mem::size_of::<_SCM_LOGICAL_DEVICES>() - 548usize];
    ["Alignment of _SCM_LOGICAL_DEVICES"][::std::mem::align_of::<_SCM_LOGICAL_DEVICES>() - 4usize];
    ["Offset of field: _SCM_LOGICAL_DEVICES::Version"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICES, Version) - 0usize];
    ["Offset of field: _SCM_LOGICAL_DEVICES::Size"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICES, Size) - 4usize];
    ["Offset of field: _SCM_LOGICAL_DEVICES::DeviceCount"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICES, DeviceCount) - 8usize];
    ["Offset of field: _SCM_LOGICAL_DEVICES::Devices"]
        [::std::mem::offset_of!(_SCM_LOGICAL_DEVICES, Devices) - 12usize];
};
pub type SCM_LOGICAL_DEVICES = _SCM_LOGICAL_DEVICES;
pub type PSCM_LOGICAL_DEVICES = *mut _SCM_LOGICAL_DEVICES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PHYSICAL_DEVICE_INSTANCE {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NfitHandle: DWORD,
    pub SymbolicLink: [WCHAR; 256usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PHYSICAL_DEVICE_INSTANCE"]
        [::std::mem::size_of::<_SCM_PHYSICAL_DEVICE_INSTANCE>() - 524usize];
    ["Alignment of _SCM_PHYSICAL_DEVICE_INSTANCE"]
        [::std::mem::align_of::<_SCM_PHYSICAL_DEVICE_INSTANCE>() - 4usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICE_INSTANCE::Version"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICE_INSTANCE, Version) - 0usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICE_INSTANCE::Size"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICE_INSTANCE, Size) - 4usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICE_INSTANCE::NfitHandle"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICE_INSTANCE, NfitHandle) - 8usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICE_INSTANCE::SymbolicLink"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICE_INSTANCE, SymbolicLink) - 12usize];
};
pub type SCM_PHYSICAL_DEVICE_INSTANCE = _SCM_PHYSICAL_DEVICE_INSTANCE;
pub type PSCM_PHYSICAL_DEVICE_INSTANCE = *mut _SCM_PHYSICAL_DEVICE_INSTANCE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PHYSICAL_DEVICES {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceCount: DWORD,
    pub Devices: [SCM_PHYSICAL_DEVICE_INSTANCE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PHYSICAL_DEVICES"][::std::mem::size_of::<_SCM_PHYSICAL_DEVICES>() - 536usize];
    ["Alignment of _SCM_PHYSICAL_DEVICES"]
        [::std::mem::align_of::<_SCM_PHYSICAL_DEVICES>() - 4usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICES::Version"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICES, Version) - 0usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICES::Size"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICES, Size) - 4usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICES::DeviceCount"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICES, DeviceCount) - 8usize];
    ["Offset of field: _SCM_PHYSICAL_DEVICES::Devices"]
        [::std::mem::offset_of!(_SCM_PHYSICAL_DEVICES, Devices) - 12usize];
};
pub type SCM_PHYSICAL_DEVICES = _SCM_PHYSICAL_DEVICES;
pub type PSCM_PHYSICAL_DEVICES = *mut _SCM_PHYSICAL_DEVICES;
pub const _SCM_REGION_FLAG_ScmRegionFlagNone: _SCM_REGION_FLAG = 0;
pub const _SCM_REGION_FLAG_ScmRegionFlagLabel: _SCM_REGION_FLAG = 1;
pub type _SCM_REGION_FLAG = ::std::os::raw::c_int;
pub use self::_SCM_REGION_FLAG as SCM_REGION_FLAG;
pub type PSCM_REGION_FLAG = *mut _SCM_REGION_FLAG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_REGION {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub NfitHandle: DWORD,
    pub LogicalDeviceGuid: GUID,
    pub AddressRangeType: GUID,
    pub AssociatedId: DWORD,
    pub Length: DWORD64,
    pub StartingDPA: DWORD64,
    pub BaseSPA: DWORD64,
    pub SPAOffset: DWORD64,
    pub RegionOffset: DWORD64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_REGION"][::std::mem::size_of::<_SCM_REGION>() - 96usize];
    ["Alignment of _SCM_REGION"][::std::mem::align_of::<_SCM_REGION>() - 8usize];
    ["Offset of field: _SCM_REGION::Version"]
        [::std::mem::offset_of!(_SCM_REGION, Version) - 0usize];
    ["Offset of field: _SCM_REGION::Size"][::std::mem::offset_of!(_SCM_REGION, Size) - 4usize];
    ["Offset of field: _SCM_REGION::Flags"][::std::mem::offset_of!(_SCM_REGION, Flags) - 8usize];
    ["Offset of field: _SCM_REGION::NfitHandle"]
        [::std::mem::offset_of!(_SCM_REGION, NfitHandle) - 12usize];
    ["Offset of field: _SCM_REGION::LogicalDeviceGuid"]
        [::std::mem::offset_of!(_SCM_REGION, LogicalDeviceGuid) - 16usize];
    ["Offset of field: _SCM_REGION::AddressRangeType"]
        [::std::mem::offset_of!(_SCM_REGION, AddressRangeType) - 32usize];
    ["Offset of field: _SCM_REGION::AssociatedId"]
        [::std::mem::offset_of!(_SCM_REGION, AssociatedId) - 48usize];
    ["Offset of field: _SCM_REGION::Length"][::std::mem::offset_of!(_SCM_REGION, Length) - 56usize];
    ["Offset of field: _SCM_REGION::StartingDPA"]
        [::std::mem::offset_of!(_SCM_REGION, StartingDPA) - 64usize];
    ["Offset of field: _SCM_REGION::BaseSPA"]
        [::std::mem::offset_of!(_SCM_REGION, BaseSPA) - 72usize];
    ["Offset of field: _SCM_REGION::SPAOffset"]
        [::std::mem::offset_of!(_SCM_REGION, SPAOffset) - 80usize];
    ["Offset of field: _SCM_REGION::RegionOffset"]
        [::std::mem::offset_of!(_SCM_REGION, RegionOffset) - 88usize];
};
pub type SCM_REGION = _SCM_REGION;
pub type PSCM_REGION = *mut _SCM_REGION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_REGIONS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub RegionCount: DWORD,
    pub Regions: [SCM_REGION; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_REGIONS"][::std::mem::size_of::<_SCM_REGIONS>() - 112usize];
    ["Alignment of _SCM_REGIONS"][::std::mem::align_of::<_SCM_REGIONS>() - 8usize];
    ["Offset of field: _SCM_REGIONS::Version"]
        [::std::mem::offset_of!(_SCM_REGIONS, Version) - 0usize];
    ["Offset of field: _SCM_REGIONS::Size"][::std::mem::offset_of!(_SCM_REGIONS, Size) - 4usize];
    ["Offset of field: _SCM_REGIONS::RegionCount"]
        [::std::mem::offset_of!(_SCM_REGIONS, RegionCount) - 8usize];
    ["Offset of field: _SCM_REGIONS::Regions"]
        [::std::mem::offset_of!(_SCM_REGIONS, Regions) - 16usize];
};
pub type SCM_REGIONS = _SCM_REGIONS;
pub type PSCM_REGIONS = *mut _SCM_REGIONS;
pub const _SCM_BUS_QUERY_TYPE_ScmBusQuery_Descriptor: _SCM_BUS_QUERY_TYPE = 0;
pub const _SCM_BUS_QUERY_TYPE_ScmBusQuery_IsSupported: _SCM_BUS_QUERY_TYPE = 1;
pub const _SCM_BUS_QUERY_TYPE_ScmBusQuery_Max: _SCM_BUS_QUERY_TYPE = 2;
pub type _SCM_BUS_QUERY_TYPE = ::std::os::raw::c_int;
pub use self::_SCM_BUS_QUERY_TYPE as SCM_BUS_QUERY_TYPE;
pub type PSCM_BUS_QUERY_TYPE = *mut _SCM_BUS_QUERY_TYPE;
pub const _SCM_BUS_SET_TYPE_ScmBusSet_Descriptor: _SCM_BUS_SET_TYPE = 0;
pub const _SCM_BUS_SET_TYPE_ScmBusSet_IsSupported: _SCM_BUS_SET_TYPE = 1;
pub const _SCM_BUS_SET_TYPE_ScmBusSet_Max: _SCM_BUS_SET_TYPE = 2;
pub type _SCM_BUS_SET_TYPE = ::std::os::raw::c_int;
pub use self::_SCM_BUS_SET_TYPE as SCM_BUS_SET_TYPE;
pub type PSCM_BUS_SET_TYPE = *mut _SCM_BUS_SET_TYPE;
pub const _SCM_BUS_PROPERTY_ID_ScmBusProperty_RuntimeFwActivationInfo: _SCM_BUS_PROPERTY_ID = 0;
pub const _SCM_BUS_PROPERTY_ID_ScmBusProperty_DedicatedMemoryInfo: _SCM_BUS_PROPERTY_ID = 1;
pub const _SCM_BUS_PROPERTY_ID_ScmBusProperty_DedicatedMemoryState: _SCM_BUS_PROPERTY_ID = 2;
pub const _SCM_BUS_PROPERTY_ID_ScmBusProperty_Max: _SCM_BUS_PROPERTY_ID = 3;
pub type _SCM_BUS_PROPERTY_ID = ::std::os::raw::c_int;
pub use self::_SCM_BUS_PROPERTY_ID as SCM_BUS_PROPERTY_ID;
pub type PSCM_BUS_PROPERTY_ID = *mut _SCM_BUS_PROPERTY_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_PROPERTY_QUERY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub PropertyId: SCM_BUS_PROPERTY_ID,
    pub QueryType: SCM_BUS_QUERY_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_PROPERTY_QUERY"][::std::mem::size_of::<_SCM_BUS_PROPERTY_QUERY>() - 20usize];
    ["Alignment of _SCM_BUS_PROPERTY_QUERY"]
        [::std::mem::align_of::<_SCM_BUS_PROPERTY_QUERY>() - 4usize];
    ["Offset of field: _SCM_BUS_PROPERTY_QUERY::Version"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_QUERY, Version) - 0usize];
    ["Offset of field: _SCM_BUS_PROPERTY_QUERY::Size"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_QUERY, Size) - 4usize];
    ["Offset of field: _SCM_BUS_PROPERTY_QUERY::PropertyId"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_QUERY, PropertyId) - 8usize];
    ["Offset of field: _SCM_BUS_PROPERTY_QUERY::QueryType"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_QUERY, QueryType) - 12usize];
    ["Offset of field: _SCM_BUS_PROPERTY_QUERY::AdditionalParameters"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_QUERY, AdditionalParameters) - 16usize];
};
pub type SCM_BUS_PROPERTY_QUERY = _SCM_BUS_PROPERTY_QUERY;
pub type PSCM_BUS_PROPERTY_QUERY = *mut _SCM_BUS_PROPERTY_QUERY;
pub const _SCM_BUS_FIRMWARE_ACTIVATION_STATE_ScmBusFirmwareActivationState_Idle:
    _SCM_BUS_FIRMWARE_ACTIVATION_STATE = 0;
pub const _SCM_BUS_FIRMWARE_ACTIVATION_STATE_ScmBusFirmwareActivationState_Armed:
    _SCM_BUS_FIRMWARE_ACTIVATION_STATE = 1;
pub const _SCM_BUS_FIRMWARE_ACTIVATION_STATE_ScmBusFirmwareActivationState_Busy:
    _SCM_BUS_FIRMWARE_ACTIVATION_STATE = 2;
pub type _SCM_BUS_FIRMWARE_ACTIVATION_STATE = ::std::os::raw::c_int;
pub use self::_SCM_BUS_FIRMWARE_ACTIVATION_STATE as SCM_BUS_FIRMWARE_ACTIVATION_STATE;
pub type PSCM_BUS_FIRMWARE_ACTIVATION_STATE = *mut _SCM_BUS_FIRMWARE_ACTIVATION_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub RuntimeFwActivationSupported: BOOLEAN,
    pub FirmwareActivationState: SCM_BUS_FIRMWARE_ACTIVATION_STATE,
    pub FirmwareActivationCapability: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1,
    pub EstimatedFirmwareActivationTimeInUSecs: DWORDLONG,
    pub EstimatedProcessorAccessQuiesceTimeInUSecs: DWORDLONG,
    pub EstimatedIOAccessQuiesceTimeInUSecs: DWORDLONG,
    pub PlatformSupportedMaxIOAccessQuiesceTimeInUSecs: DWORDLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1>() - 4usize];
};
impl _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO__bindgen_ty_1 {
    #[inline]
    pub fn FwManagedIoQuiesceFwActivationSupported(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_FwManagedIoQuiesceFwActivationSupported(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn FwManagedIoQuiesceFwActivationSupported_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_FwManagedIoQuiesceFwActivationSupported_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn OsManagedIoQuiesceFwActivationSupported(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_OsManagedIoQuiesceFwActivationSupported(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn OsManagedIoQuiesceFwActivationSupported_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_OsManagedIoQuiesceFwActivationSupported_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn WarmResetBasedFwActivationSupported(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_WarmResetBasedFwActivationSupported(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn WarmResetBasedFwActivationSupported_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_WarmResetBasedFwActivationSupported_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(3usize, 29u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(3usize, 29u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                3usize,
                29u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                3usize,
                29u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        FwManagedIoQuiesceFwActivationSupported: DWORD,
        OsManagedIoQuiesceFwActivationSupported: DWORD,
        WarmResetBasedFwActivationSupported: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let FwManagedIoQuiesceFwActivationSupported: u32 =
                unsafe { ::std::mem::transmute(FwManagedIoQuiesceFwActivationSupported) };
            FwManagedIoQuiesceFwActivationSupported as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let OsManagedIoQuiesceFwActivationSupported: u32 =
                unsafe { ::std::mem::transmute(OsManagedIoQuiesceFwActivationSupported) };
            OsManagedIoQuiesceFwActivationSupported as u64
        });
        __bindgen_bitfield_unit.set(2usize, 1u8, {
            let WarmResetBasedFwActivationSupported: u32 =
                unsafe { ::std::mem::transmute(WarmResetBasedFwActivationSupported) };
            WarmResetBasedFwActivationSupported as u64
        });
        __bindgen_bitfield_unit.set(3usize, 29u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO"]
        [::std::mem::size_of::<_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO>() - 56usize];
    ["Alignment of _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO"]
        [::std::mem::align_of::<_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO>() - 8usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::Version"]
        [::std::mem::offset_of!(_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO, Version) - 0usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::Size"]
        [::std::mem::offset_of!(_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO, Size) - 4usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::RuntimeFwActivationSupported"][::std::mem::offset_of!(
        _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO,
        RuntimeFwActivationSupported
    )
        - 8usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::FirmwareActivationState"][::std::mem::offset_of!(
        _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO,
        FirmwareActivationState
    ) - 12usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::FirmwareActivationCapability"][::std::mem::offset_of!(
        _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO,
        FirmwareActivationCapability
    )
        - 16usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::EstimatedFirmwareActivationTimeInUSecs"] [:: std :: mem :: offset_of ! (_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO , EstimatedFirmwareActivationTimeInUSecs) - 24usize] ;
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::EstimatedProcessorAccessQuiesceTimeInUSecs"] [:: std :: mem :: offset_of ! (_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO , EstimatedProcessorAccessQuiesceTimeInUSecs) - 32usize] ;
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::EstimatedIOAccessQuiesceTimeInUSecs"][::std::mem::offset_of!(
        _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO,
        EstimatedIOAccessQuiesceTimeInUSecs
    )
        - 40usize];
    ["Offset of field: _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO::PlatformSupportedMaxIOAccessQuiesceTimeInUSecs"] [:: std :: mem :: offset_of ! (_SCM_BUS_RUNTIME_FW_ACTIVATION_INFO , PlatformSupportedMaxIOAccessQuiesceTimeInUSecs) - 48usize] ;
};
pub type SCM_BUS_RUNTIME_FW_ACTIVATION_INFO = _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO;
pub type PSCM_BUS_RUNTIME_FW_ACTIVATION_INFO = *mut _SCM_BUS_RUNTIME_FW_ACTIVATION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO {
    pub DeviceGuid: GUID,
    pub DeviceNumber: DWORD,
    pub Flags: _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1,
    pub DeviceSize: DWORDLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1 {
    pub _bitfield_align_1: [u32; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 4usize]>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1>() - 4usize];
};
impl _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO__bindgen_ty_1 {
    #[inline]
    pub fn ForcedByRegistry(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_ForcedByRegistry(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ForcedByRegistry_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_ForcedByRegistry_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Initialized(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Initialized(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Initialized_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Initialized_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(2usize, 30u8) as u32) }
    }
    #[inline]
    pub fn set_Reserved(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(2usize, 30u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 4usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                2usize,
                30u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 4usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                2usize,
                30u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(
        ForcedByRegistry: DWORD,
        Initialized: DWORD,
        Reserved: DWORD,
    ) -> __BindgenBitfieldUnit<[u8; 4usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 4usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ForcedByRegistry: u32 = unsafe { ::std::mem::transmute(ForcedByRegistry) };
            ForcedByRegistry as u64
        });
        __bindgen_bitfield_unit.set(1usize, 1u8, {
            let Initialized: u32 = unsafe { ::std::mem::transmute(Initialized) };
            Initialized as u64
        });
        __bindgen_bitfield_unit.set(2usize, 30u8, {
            let Reserved: u32 = unsafe { ::std::mem::transmute(Reserved) };
            Reserved as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO"]
        [::std::mem::size_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO>() - 32usize];
    ["Alignment of _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO"]
        [::std::mem::align_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO>() - 8usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO, DeviceGuid) - 0usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO::DeviceNumber"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO, DeviceNumber) - 16usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO::Flags"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO, Flags) - 20usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO::DeviceSize"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO, DeviceSize) - 24usize];
};
pub type SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO = _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO;
pub type PSCM_BUS_DEDICATED_MEMORY_DEVICE_INFO = *mut _SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceCount: DWORD,
    pub Devices: [SCM_BUS_DEDICATED_MEMORY_DEVICE_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO"]
        [::std::mem::size_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO>() - 48usize];
    ["Alignment of _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO"]
        [::std::mem::align_of::<_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO>() - 8usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO::Version"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO, Version) - 0usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO::Size"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO, Size) - 4usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO::DeviceCount"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO, DeviceCount) - 8usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO::Devices"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO, Devices) - 16usize];
};
pub type SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO = _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO;
pub type PSCM_BUS_DEDICATED_MEMORY_DEVICES_INFO = *mut _SCM_BUS_DEDICATED_MEMORY_DEVICES_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_PROPERTY_SET {
    pub Version: DWORD,
    pub Size: DWORD,
    pub PropertyId: SCM_BUS_PROPERTY_ID,
    pub SetType: SCM_BUS_SET_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_PROPERTY_SET"][::std::mem::size_of::<_SCM_BUS_PROPERTY_SET>() - 20usize];
    ["Alignment of _SCM_BUS_PROPERTY_SET"]
        [::std::mem::align_of::<_SCM_BUS_PROPERTY_SET>() - 4usize];
    ["Offset of field: _SCM_BUS_PROPERTY_SET::Version"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_SET, Version) - 0usize];
    ["Offset of field: _SCM_BUS_PROPERTY_SET::Size"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_SET, Size) - 4usize];
    ["Offset of field: _SCM_BUS_PROPERTY_SET::PropertyId"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_SET, PropertyId) - 8usize];
    ["Offset of field: _SCM_BUS_PROPERTY_SET::SetType"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_SET, SetType) - 12usize];
    ["Offset of field: _SCM_BUS_PROPERTY_SET::AdditionalParameters"]
        [::std::mem::offset_of!(_SCM_BUS_PROPERTY_SET, AdditionalParameters) - 16usize];
};
pub type SCM_BUS_PROPERTY_SET = _SCM_BUS_PROPERTY_SET;
pub type PSCM_BUS_PROPERTY_SET = *mut _SCM_BUS_PROPERTY_SET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_BUS_DEDICATED_MEMORY_STATE {
    pub ActivateState: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_BUS_DEDICATED_MEMORY_STATE"]
        [::std::mem::size_of::<_SCM_BUS_DEDICATED_MEMORY_STATE>() - 1usize];
    ["Alignment of _SCM_BUS_DEDICATED_MEMORY_STATE"]
        [::std::mem::align_of::<_SCM_BUS_DEDICATED_MEMORY_STATE>() - 1usize];
    ["Offset of field: _SCM_BUS_DEDICATED_MEMORY_STATE::ActivateState"]
        [::std::mem::offset_of!(_SCM_BUS_DEDICATED_MEMORY_STATE, ActivateState) - 0usize];
};
pub type SCM_BUS_DEDICATED_MEMORY_STATE = _SCM_BUS_DEDICATED_MEMORY_STATE;
pub type PSCM_BUS_DEDICATED_MEMORY_STATE = *mut _SCM_BUS_DEDICATED_MEMORY_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_INTERLEAVED_PD_INFO {
    pub DeviceHandle: DWORD,
    pub DeviceGuid: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_INTERLEAVED_PD_INFO"]
        [::std::mem::size_of::<_SCM_INTERLEAVED_PD_INFO>() - 20usize];
    ["Alignment of _SCM_INTERLEAVED_PD_INFO"]
        [::std::mem::align_of::<_SCM_INTERLEAVED_PD_INFO>() - 4usize];
    ["Offset of field: _SCM_INTERLEAVED_PD_INFO::DeviceHandle"]
        [::std::mem::offset_of!(_SCM_INTERLEAVED_PD_INFO, DeviceHandle) - 0usize];
    ["Offset of field: _SCM_INTERLEAVED_PD_INFO::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_INTERLEAVED_PD_INFO, DeviceGuid) - 4usize];
};
pub type SCM_INTERLEAVED_PD_INFO = _SCM_INTERLEAVED_PD_INFO;
pub type PSCM_INTERLEAVED_PD_INFO = *mut _SCM_INTERLEAVED_PD_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_LD_INTERLEAVE_SET_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub InterleaveSetSize: DWORD,
    pub InterleaveSet: [SCM_INTERLEAVED_PD_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_LD_INTERLEAVE_SET_INFO"]
        [::std::mem::size_of::<_SCM_LD_INTERLEAVE_SET_INFO>() - 32usize];
    ["Alignment of _SCM_LD_INTERLEAVE_SET_INFO"]
        [::std::mem::align_of::<_SCM_LD_INTERLEAVE_SET_INFO>() - 4usize];
    ["Offset of field: _SCM_LD_INTERLEAVE_SET_INFO::Version"]
        [::std::mem::offset_of!(_SCM_LD_INTERLEAVE_SET_INFO, Version) - 0usize];
    ["Offset of field: _SCM_LD_INTERLEAVE_SET_INFO::Size"]
        [::std::mem::offset_of!(_SCM_LD_INTERLEAVE_SET_INFO, Size) - 4usize];
    ["Offset of field: _SCM_LD_INTERLEAVE_SET_INFO::InterleaveSetSize"]
        [::std::mem::offset_of!(_SCM_LD_INTERLEAVE_SET_INFO, InterleaveSetSize) - 8usize];
    ["Offset of field: _SCM_LD_INTERLEAVE_SET_INFO::InterleaveSet"]
        [::std::mem::offset_of!(_SCM_LD_INTERLEAVE_SET_INFO, InterleaveSet) - 12usize];
};
pub type SCM_LD_INTERLEAVE_SET_INFO = _SCM_LD_INTERLEAVE_SET_INFO;
pub type PSCM_LD_INTERLEAVE_SET_INFO = *mut _SCM_LD_INTERLEAVE_SET_INFO;
pub const _SCM_PD_QUERY_TYPE_ScmPhysicalDeviceQuery_Descriptor: _SCM_PD_QUERY_TYPE = 0;
pub const _SCM_PD_QUERY_TYPE_ScmPhysicalDeviceQuery_IsSupported: _SCM_PD_QUERY_TYPE = 1;
pub const _SCM_PD_QUERY_TYPE_ScmPhysicalDeviceQuery_Max: _SCM_PD_QUERY_TYPE = 2;
pub type _SCM_PD_QUERY_TYPE = ::std::os::raw::c_int;
pub use self::_SCM_PD_QUERY_TYPE as SCM_PD_QUERY_TYPE;
pub type PSCM_PD_QUERY_TYPE = *mut _SCM_PD_QUERY_TYPE;
pub const _SCM_PD_SET_TYPE_ScmPhysicalDeviceSet_Descriptor: _SCM_PD_SET_TYPE = 0;
pub const _SCM_PD_SET_TYPE_ScmPhysicalDeviceSet_IsSupported: _SCM_PD_SET_TYPE = 1;
pub const _SCM_PD_SET_TYPE_ScmPhysicalDeviceSet_Max: _SCM_PD_SET_TYPE = 2;
pub type _SCM_PD_SET_TYPE = ::std::os::raw::c_int;
pub use self::_SCM_PD_SET_TYPE as SCM_PD_SET_TYPE;
pub type PSCM_PD_SET_TYPE = *mut _SCM_PD_SET_TYPE;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_DeviceInfo: _SCM_PD_PROPERTY_ID = 0;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_ManagementStatus: _SCM_PD_PROPERTY_ID = 1;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_FirmwareInfo: _SCM_PD_PROPERTY_ID = 2;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_LocationString: _SCM_PD_PROPERTY_ID = 3;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_DeviceSpecificInfo: _SCM_PD_PROPERTY_ID = 4;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_DeviceHandle: _SCM_PD_PROPERTY_ID = 5;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_FruIdString: _SCM_PD_PROPERTY_ID = 6;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_RuntimeFwActivationInfo:
    _SCM_PD_PROPERTY_ID = 7;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_RuntimeFwActivationArmState:
    _SCM_PD_PROPERTY_ID = 8;
pub const _SCM_PD_PROPERTY_ID_ScmPhysicalDeviceProperty_Max: _SCM_PD_PROPERTY_ID = 9;
pub type _SCM_PD_PROPERTY_ID = ::std::os::raw::c_int;
pub use self::_SCM_PD_PROPERTY_ID as SCM_PD_PROPERTY_ID;
pub type PSCM_PD_PROPERTY_ID = *mut _SCM_PD_PROPERTY_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PROPERTY_QUERY {
    pub Version: DWORD,
    pub Size: DWORD,
    pub PropertyId: SCM_PD_PROPERTY_ID,
    pub QueryType: SCM_PD_QUERY_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PROPERTY_QUERY"][::std::mem::size_of::<_SCM_PD_PROPERTY_QUERY>() - 20usize];
    ["Alignment of _SCM_PD_PROPERTY_QUERY"]
        [::std::mem::align_of::<_SCM_PD_PROPERTY_QUERY>() - 4usize];
    ["Offset of field: _SCM_PD_PROPERTY_QUERY::Version"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_QUERY, Version) - 0usize];
    ["Offset of field: _SCM_PD_PROPERTY_QUERY::Size"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_QUERY, Size) - 4usize];
    ["Offset of field: _SCM_PD_PROPERTY_QUERY::PropertyId"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_QUERY, PropertyId) - 8usize];
    ["Offset of field: _SCM_PD_PROPERTY_QUERY::QueryType"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_QUERY, QueryType) - 12usize];
    ["Offset of field: _SCM_PD_PROPERTY_QUERY::AdditionalParameters"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_QUERY, AdditionalParameters) - 16usize];
};
pub type SCM_PD_PROPERTY_QUERY = _SCM_PD_PROPERTY_QUERY;
pub type PSCM_PD_PROPERTY_QUERY = *mut _SCM_PD_PROPERTY_QUERY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PROPERTY_SET {
    pub Version: DWORD,
    pub Size: DWORD,
    pub PropertyId: SCM_PD_PROPERTY_ID,
    pub SetType: SCM_PD_SET_TYPE,
    pub AdditionalParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PROPERTY_SET"][::std::mem::size_of::<_SCM_PD_PROPERTY_SET>() - 20usize];
    ["Alignment of _SCM_PD_PROPERTY_SET"][::std::mem::align_of::<_SCM_PD_PROPERTY_SET>() - 4usize];
    ["Offset of field: _SCM_PD_PROPERTY_SET::Version"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_SET, Version) - 0usize];
    ["Offset of field: _SCM_PD_PROPERTY_SET::Size"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_SET, Size) - 4usize];
    ["Offset of field: _SCM_PD_PROPERTY_SET::PropertyId"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_SET, PropertyId) - 8usize];
    ["Offset of field: _SCM_PD_PROPERTY_SET::SetType"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_SET, SetType) - 12usize];
    ["Offset of field: _SCM_PD_PROPERTY_SET::AdditionalParameters"]
        [::std::mem::offset_of!(_SCM_PD_PROPERTY_SET, AdditionalParameters) - 16usize];
};
pub type SCM_PD_PROPERTY_SET = _SCM_PD_PROPERTY_SET;
pub type PSCM_PD_PROPERTY_SET = *mut _SCM_PD_PROPERTY_SET;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE {
    pub ArmState: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE"]
        [::std::mem::size_of::<_SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE>() - 1usize];
    ["Alignment of _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE"]
        [::std::mem::align_of::<_SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE>() - 1usize];
    ["Offset of field: _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE::ArmState"]
        [::std::mem::offset_of!(_SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE, ArmState) - 0usize];
};
pub type SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE = _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE;
pub type PSCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE = *mut _SCM_PD_RUNTIME_FW_ACTIVATION_ARM_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_DESCRIPTOR_HEADER {
    pub Version: DWORD,
    pub Size: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_DESCRIPTOR_HEADER"]
        [::std::mem::size_of::<_SCM_PD_DESCRIPTOR_HEADER>() - 8usize];
    ["Alignment of _SCM_PD_DESCRIPTOR_HEADER"]
        [::std::mem::align_of::<_SCM_PD_DESCRIPTOR_HEADER>() - 4usize];
    ["Offset of field: _SCM_PD_DESCRIPTOR_HEADER::Version"]
        [::std::mem::offset_of!(_SCM_PD_DESCRIPTOR_HEADER, Version) - 0usize];
    ["Offset of field: _SCM_PD_DESCRIPTOR_HEADER::Size"]
        [::std::mem::offset_of!(_SCM_PD_DESCRIPTOR_HEADER, Size) - 4usize];
};
pub type SCM_PD_DESCRIPTOR_HEADER = _SCM_PD_DESCRIPTOR_HEADER;
pub type PSCM_PD_DESCRIPTOR_HEADER = *mut _SCM_PD_DESCRIPTOR_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_DEVICE_HANDLE {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceGuid: GUID,
    pub DeviceHandle: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_DEVICE_HANDLE"][::std::mem::size_of::<_SCM_PD_DEVICE_HANDLE>() - 28usize];
    ["Alignment of _SCM_PD_DEVICE_HANDLE"]
        [::std::mem::align_of::<_SCM_PD_DEVICE_HANDLE>() - 4usize];
    ["Offset of field: _SCM_PD_DEVICE_HANDLE::Version"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_HANDLE, Version) - 0usize];
    ["Offset of field: _SCM_PD_DEVICE_HANDLE::Size"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_HANDLE, Size) - 4usize];
    ["Offset of field: _SCM_PD_DEVICE_HANDLE::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_HANDLE, DeviceGuid) - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_HANDLE::DeviceHandle"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_HANDLE, DeviceHandle) - 24usize];
};
pub type SCM_PD_DEVICE_HANDLE = _SCM_PD_DEVICE_HANDLE;
pub type PSCM_PD_DEVICE_HANDLE = *mut _SCM_PD_DEVICE_HANDLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_DEVICE_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub DeviceGuid: GUID,
    pub UnsafeShutdownCount: DWORD,
    pub PersistentMemorySizeInBytes: DWORD64,
    pub VolatileMemorySizeInBytes: DWORD64,
    pub TotalMemorySizeInBytes: DWORD64,
    pub SlotNumber: DWORD,
    pub DeviceHandle: DWORD,
    pub PhysicalId: WORD,
    pub NumberOfFormatInterfaceCodes: BYTE,
    pub FormatInterfaceCodes: [WORD; 8usize],
    pub VendorId: DWORD,
    pub ProductId: DWORD,
    pub SubsystemDeviceId: DWORD,
    pub SubsystemVendorId: DWORD,
    pub ManufacturingLocation: BYTE,
    pub ManufacturingWeek: BYTE,
    pub ManufacturingYear: BYTE,
    pub SerialNumber4Byte: DWORD,
    pub SerialNumberLengthInChars: DWORD,
    pub SerialNumber: [CHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_DEVICE_INFO"][::std::mem::size_of::<_SCM_PD_DEVICE_INFO>() - 120usize];
    ["Alignment of _SCM_PD_DEVICE_INFO"][::std::mem::align_of::<_SCM_PD_DEVICE_INFO>() - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::Version"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, Version) - 0usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::Size"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, Size) - 4usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::DeviceGuid"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, DeviceGuid) - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::UnsafeShutdownCount"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, UnsafeShutdownCount) - 24usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::PersistentMemorySizeInBytes"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, PersistentMemorySizeInBytes) - 32usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::VolatileMemorySizeInBytes"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, VolatileMemorySizeInBytes) - 40usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::TotalMemorySizeInBytes"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, TotalMemorySizeInBytes) - 48usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SlotNumber"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SlotNumber) - 56usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::DeviceHandle"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, DeviceHandle) - 60usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::PhysicalId"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, PhysicalId) - 64usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::NumberOfFormatInterfaceCodes"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, NumberOfFormatInterfaceCodes) - 66usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::FormatInterfaceCodes"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, FormatInterfaceCodes) - 68usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::VendorId"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, VendorId) - 84usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::ProductId"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, ProductId) - 88usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SubsystemDeviceId"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SubsystemDeviceId) - 92usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SubsystemVendorId"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SubsystemVendorId) - 96usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::ManufacturingLocation"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, ManufacturingLocation) - 100usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::ManufacturingWeek"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, ManufacturingWeek) - 101usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::ManufacturingYear"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, ManufacturingYear) - 102usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SerialNumber4Byte"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SerialNumber4Byte) - 104usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SerialNumberLengthInChars"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SerialNumberLengthInChars) - 108usize];
    ["Offset of field: _SCM_PD_DEVICE_INFO::SerialNumber"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_INFO, SerialNumber) - 112usize];
};
pub type SCM_PD_DEVICE_INFO = _SCM_PD_DEVICE_INFO;
pub type PSCM_PD_DEVICE_INFO = *mut _SCM_PD_DEVICE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_DEVICE_SPECIFIC_PROPERTY {
    pub Name: [WCHAR; 128usize],
    pub Value: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_DEVICE_SPECIFIC_PROPERTY"]
        [::std::mem::size_of::<_SCM_PD_DEVICE_SPECIFIC_PROPERTY>() - 264usize];
    ["Alignment of _SCM_PD_DEVICE_SPECIFIC_PROPERTY"]
        [::std::mem::align_of::<_SCM_PD_DEVICE_SPECIFIC_PROPERTY>() - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_PROPERTY::Name"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_PROPERTY, Name) - 0usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_PROPERTY::Value"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_PROPERTY, Value) - 256usize];
};
pub type SCM_PD_DEVICE_SPECIFIC_PROPERTY = _SCM_PD_DEVICE_SPECIFIC_PROPERTY;
pub type PSCM_PD_DEVICE_SPECIFIC_PROPERTY = *mut _SCM_PD_DEVICE_SPECIFIC_PROPERTY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_DEVICE_SPECIFIC_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub NumberOfProperties: DWORD,
    pub DeviceSpecificProperties: [SCM_PD_DEVICE_SPECIFIC_PROPERTY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_DEVICE_SPECIFIC_INFO"]
        [::std::mem::size_of::<_SCM_PD_DEVICE_SPECIFIC_INFO>() - 280usize];
    ["Alignment of _SCM_PD_DEVICE_SPECIFIC_INFO"]
        [::std::mem::align_of::<_SCM_PD_DEVICE_SPECIFIC_INFO>() - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_INFO::Version"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_INFO, Version) - 0usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_INFO::Size"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_INFO, Size) - 4usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_INFO::NumberOfProperties"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_INFO, NumberOfProperties) - 8usize];
    ["Offset of field: _SCM_PD_DEVICE_SPECIFIC_INFO::DeviceSpecificProperties"]
        [::std::mem::offset_of!(_SCM_PD_DEVICE_SPECIFIC_INFO, DeviceSpecificProperties) - 16usize];
};
pub type SCM_PD_DEVICE_SPECIFIC_INFO = _SCM_PD_DEVICE_SPECIFIC_INFO;
pub type PSCM_PD_DEVICE_SPECIFIC_INFO = *mut _SCM_PD_DEVICE_SPECIFIC_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_FIRMWARE_SLOT_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub SlotNumber: BYTE,
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub Reserved1: [BYTE; 6usize],
    pub Revision: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_FIRMWARE_SLOT_INFO"]
        [::std::mem::size_of::<_SCM_PD_FIRMWARE_SLOT_INFO>() - 48usize];
    ["Alignment of _SCM_PD_FIRMWARE_SLOT_INFO"]
        [::std::mem::align_of::<_SCM_PD_FIRMWARE_SLOT_INFO>() - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_SLOT_INFO::Version"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_SLOT_INFO, Version) - 0usize];
    ["Offset of field: _SCM_PD_FIRMWARE_SLOT_INFO::Size"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_SLOT_INFO, Size) - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_SLOT_INFO::SlotNumber"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_SLOT_INFO, SlotNumber) - 8usize];
    ["Offset of field: _SCM_PD_FIRMWARE_SLOT_INFO::Reserved1"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_SLOT_INFO, Reserved1) - 10usize];
    ["Offset of field: _SCM_PD_FIRMWARE_SLOT_INFO::Revision"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_SLOT_INFO, Revision) - 16usize];
};
impl _SCM_PD_FIRMWARE_SLOT_INFO {
    #[inline]
    pub fn ReadOnly(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u8) }
    }
    #[inline]
    pub fn set_ReadOnly(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn ReadOnly_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_ReadOnly_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn Reserved0(&self) -> BYTE {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(1usize, 7u8) as u8) }
    }
    #[inline]
    pub fn set_Reserved0(&mut self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            self._bitfield_1.set(1usize, 7u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Reserved0_raw(this: *const Self) -> BYTE {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                1usize,
                7u8,
            ) as u8)
        }
    }
    #[inline]
    pub unsafe fn set_Reserved0_raw(this: *mut Self, val: BYTE) {
        unsafe {
            let val: u8 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                1usize,
                7u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(ReadOnly: BYTE, Reserved0: BYTE) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let ReadOnly: u8 = unsafe { ::std::mem::transmute(ReadOnly) };
            ReadOnly as u64
        });
        __bindgen_bitfield_unit.set(1usize, 7u8, {
            let Reserved0: u8 = unsafe { ::std::mem::transmute(Reserved0) };
            Reserved0 as u64
        });
        __bindgen_bitfield_unit
    }
}
pub type SCM_PD_FIRMWARE_SLOT_INFO = _SCM_PD_FIRMWARE_SLOT_INFO;
pub type PSCM_PD_FIRMWARE_SLOT_INFO = *mut _SCM_PD_FIRMWARE_SLOT_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_FIRMWARE_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ActiveSlot: BYTE,
    pub NextActiveSlot: BYTE,
    pub SlotCount: BYTE,
    pub Slots: [SCM_PD_FIRMWARE_SLOT_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_FIRMWARE_INFO"][::std::mem::size_of::<_SCM_PD_FIRMWARE_INFO>() - 60usize];
    ["Alignment of _SCM_PD_FIRMWARE_INFO"]
        [::std::mem::align_of::<_SCM_PD_FIRMWARE_INFO>() - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::Version"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, Version) - 0usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::Size"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, Size) - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::ActiveSlot"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, ActiveSlot) - 8usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::NextActiveSlot"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, NextActiveSlot) - 9usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::SlotCount"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, SlotCount) - 10usize];
    ["Offset of field: _SCM_PD_FIRMWARE_INFO::Slots"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_INFO, Slots) - 12usize];
};
pub type SCM_PD_FIRMWARE_INFO = _SCM_PD_FIRMWARE_INFO;
pub type PSCM_PD_FIRMWARE_INFO = *mut _SCM_PD_FIRMWARE_INFO;
pub const _SCM_PD_HEALTH_STATUS_ScmPhysicalDeviceHealth_Unknown: _SCM_PD_HEALTH_STATUS = 0;
pub const _SCM_PD_HEALTH_STATUS_ScmPhysicalDeviceHealth_Unhealthy: _SCM_PD_HEALTH_STATUS = 1;
pub const _SCM_PD_HEALTH_STATUS_ScmPhysicalDeviceHealth_Warning: _SCM_PD_HEALTH_STATUS = 2;
pub const _SCM_PD_HEALTH_STATUS_ScmPhysicalDeviceHealth_Healthy: _SCM_PD_HEALTH_STATUS = 3;
pub const _SCM_PD_HEALTH_STATUS_ScmPhysicalDeviceHealth_Max: _SCM_PD_HEALTH_STATUS = 4;
pub type _SCM_PD_HEALTH_STATUS = ::std::os::raw::c_int;
pub use self::_SCM_PD_HEALTH_STATUS as SCM_PD_HEALTH_STATUS;
pub type PSCM_PD_HEALTH_STATUS = *mut _SCM_PD_HEALTH_STATUS;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_Unknown: _SCM_PD_OPERATIONAL_STATUS =
    0;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_Ok: _SCM_PD_OPERATIONAL_STATUS = 1;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_PredictingFailure:
    _SCM_PD_OPERATIONAL_STATUS = 2;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_InService:
    _SCM_PD_OPERATIONAL_STATUS = 3;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_HardwareError:
    _SCM_PD_OPERATIONAL_STATUS = 4;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_NotUsable:
    _SCM_PD_OPERATIONAL_STATUS = 5;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_TransientError:
    _SCM_PD_OPERATIONAL_STATUS = 6;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_Missing: _SCM_PD_OPERATIONAL_STATUS =
    7;
pub const _SCM_PD_OPERATIONAL_STATUS_ScmPhysicalDeviceOpStatus_Max: _SCM_PD_OPERATIONAL_STATUS = 8;
pub type _SCM_PD_OPERATIONAL_STATUS = ::std::os::raw::c_int;
pub use self::_SCM_PD_OPERATIONAL_STATUS as SCM_PD_OPERATIONAL_STATUS;
pub type PSCM_PD_OPERATIONAL_STATUS = *mut _SCM_PD_OPERATIONAL_STATUS;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_Unknown:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 0;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_Media:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 1;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_ThresholdExceeded:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 2;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_LostData:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 3;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_EnergySource:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 4;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_Configuration:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 5;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_DeviceController:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 6;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_MediaController:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 7;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_Component:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 8;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_BackgroundOperation:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 9;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_InvalidFirmware:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 10;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_HealthCheck:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 11;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_LostDataPersistence:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 12;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_DisabledByPlatform:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 13;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_PermanentError:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 14;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_LostWritePersistence:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 15;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_FatalError:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 16;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_DataPersistenceLossImminent : _SCM_PD_OPERATIONAL_STATUS_REASON = 17 ;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_WritePersistenceLossImminent : _SCM_PD_OPERATIONAL_STATUS_REASON = 18 ;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_MediaRemainingSpareBlock:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 19;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_PerformanceDegradation:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 20;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_ExcessiveTemperature:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 21;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_InternalFailure:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 22;
pub const _SCM_PD_OPERATIONAL_STATUS_REASON_ScmPhysicalDeviceOpReason_Max:
    _SCM_PD_OPERATIONAL_STATUS_REASON = 23;
pub type _SCM_PD_OPERATIONAL_STATUS_REASON = ::std::os::raw::c_int;
pub use self::_SCM_PD_OPERATIONAL_STATUS_REASON as SCM_PD_OPERATIONAL_STATUS_REASON;
pub type PSCM_PD_OPERATIONAL_STATUS_REASON = *mut _SCM_PD_OPERATIONAL_STATUS_REASON;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_MANAGEMENT_STATUS {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Health: SCM_PD_HEALTH_STATUS,
    pub NumberOfOperationalStatus: DWORD,
    pub NumberOfAdditionalReasons: DWORD,
    pub OperationalStatus: [SCM_PD_OPERATIONAL_STATUS; 16usize],
    pub AdditionalReasons: [SCM_PD_OPERATIONAL_STATUS_REASON; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_MANAGEMENT_STATUS"]
        [::std::mem::size_of::<_SCM_PD_MANAGEMENT_STATUS>() - 88usize];
    ["Alignment of _SCM_PD_MANAGEMENT_STATUS"]
        [::std::mem::align_of::<_SCM_PD_MANAGEMENT_STATUS>() - 4usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::Version"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, Version) - 0usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::Size"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, Size) - 4usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::Health"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, Health) - 8usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::NumberOfOperationalStatus"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, NumberOfOperationalStatus) - 12usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::NumberOfAdditionalReasons"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, NumberOfAdditionalReasons) - 16usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::OperationalStatus"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, OperationalStatus) - 20usize];
    ["Offset of field: _SCM_PD_MANAGEMENT_STATUS::AdditionalReasons"]
        [::std::mem::offset_of!(_SCM_PD_MANAGEMENT_STATUS, AdditionalReasons) - 84usize];
};
pub type SCM_PD_MANAGEMENT_STATUS = _SCM_PD_MANAGEMENT_STATUS;
pub type PSCM_PD_MANAGEMENT_STATUS = *mut _SCM_PD_MANAGEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_LOCATION_STRING {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Location: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_LOCATION_STRING"][::std::mem::size_of::<_SCM_PD_LOCATION_STRING>() - 12usize];
    ["Alignment of _SCM_PD_LOCATION_STRING"]
        [::std::mem::align_of::<_SCM_PD_LOCATION_STRING>() - 4usize];
    ["Offset of field: _SCM_PD_LOCATION_STRING::Version"]
        [::std::mem::offset_of!(_SCM_PD_LOCATION_STRING, Version) - 0usize];
    ["Offset of field: _SCM_PD_LOCATION_STRING::Size"]
        [::std::mem::offset_of!(_SCM_PD_LOCATION_STRING, Size) - 4usize];
    ["Offset of field: _SCM_PD_LOCATION_STRING::Location"]
        [::std::mem::offset_of!(_SCM_PD_LOCATION_STRING, Location) - 8usize];
};
pub type SCM_PD_LOCATION_STRING = _SCM_PD_LOCATION_STRING;
pub type PSCM_PD_LOCATION_STRING = *mut _SCM_PD_LOCATION_STRING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_FRU_ID_STRING {
    pub Version: DWORD,
    pub Size: DWORD,
    pub IdentifierSize: DWORD,
    pub Identifier: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_FRU_ID_STRING"][::std::mem::size_of::<_SCM_PD_FRU_ID_STRING>() - 16usize];
    ["Alignment of _SCM_PD_FRU_ID_STRING"]
        [::std::mem::align_of::<_SCM_PD_FRU_ID_STRING>() - 4usize];
    ["Offset of field: _SCM_PD_FRU_ID_STRING::Version"]
        [::std::mem::offset_of!(_SCM_PD_FRU_ID_STRING, Version) - 0usize];
    ["Offset of field: _SCM_PD_FRU_ID_STRING::Size"]
        [::std::mem::offset_of!(_SCM_PD_FRU_ID_STRING, Size) - 4usize];
    ["Offset of field: _SCM_PD_FRU_ID_STRING::IdentifierSize"]
        [::std::mem::offset_of!(_SCM_PD_FRU_ID_STRING, IdentifierSize) - 8usize];
    ["Offset of field: _SCM_PD_FRU_ID_STRING::Identifier"]
        [::std::mem::offset_of!(_SCM_PD_FRU_ID_STRING, Identifier) - 12usize];
};
pub type SCM_PD_FRU_ID_STRING = _SCM_PD_FRU_ID_STRING;
pub type PSCM_PD_FRU_ID_STRING = *mut _SCM_PD_FRU_ID_STRING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_FIRMWARE_DOWNLOAD {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Slot: BYTE,
    pub Reserved: [BYTE; 3usize],
    pub Offset: DWORD64,
    pub FirmwareImageSizeInBytes: DWORD,
    pub FirmwareImage: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_FIRMWARE_DOWNLOAD"]
        [::std::mem::size_of::<_SCM_PD_FIRMWARE_DOWNLOAD>() - 32usize];
    ["Alignment of _SCM_PD_FIRMWARE_DOWNLOAD"]
        [::std::mem::align_of::<_SCM_PD_FIRMWARE_DOWNLOAD>() - 8usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Version"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Version) - 0usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Size"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Size) - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Flags"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Flags) - 8usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Slot"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Slot) - 12usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Reserved"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Reserved) - 13usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::Offset"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, Offset) - 16usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::FirmwareImageSizeInBytes"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, FirmwareImageSizeInBytes) - 24usize];
    ["Offset of field: _SCM_PD_FIRMWARE_DOWNLOAD::FirmwareImage"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_DOWNLOAD, FirmwareImage) - 28usize];
};
pub type SCM_PD_FIRMWARE_DOWNLOAD = _SCM_PD_FIRMWARE_DOWNLOAD;
pub type PSCM_PD_FIRMWARE_DOWNLOAD = *mut _SCM_PD_FIRMWARE_DOWNLOAD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_FIRMWARE_ACTIVATE {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Slot: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_FIRMWARE_ACTIVATE"]
        [::std::mem::size_of::<_SCM_PD_FIRMWARE_ACTIVATE>() - 16usize];
    ["Alignment of _SCM_PD_FIRMWARE_ACTIVATE"]
        [::std::mem::align_of::<_SCM_PD_FIRMWARE_ACTIVATE>() - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_ACTIVATE::Version"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_ACTIVATE, Version) - 0usize];
    ["Offset of field: _SCM_PD_FIRMWARE_ACTIVATE::Size"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_ACTIVATE, Size) - 4usize];
    ["Offset of field: _SCM_PD_FIRMWARE_ACTIVATE::Flags"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_ACTIVATE, Flags) - 8usize];
    ["Offset of field: _SCM_PD_FIRMWARE_ACTIVATE::Slot"]
        [::std::mem::offset_of!(_SCM_PD_FIRMWARE_ACTIVATE, Slot) - 12usize];
};
pub type SCM_PD_FIRMWARE_ACTIVATE = _SCM_PD_FIRMWARE_ACTIVATE;
pub type PSCM_PD_FIRMWARE_ACTIVATE = *mut _SCM_PD_FIRMWARE_ACTIVATE;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivationStatus_None:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 0;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivationStatus_Success:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 1;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivationStatus_FwNotFound:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 2;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivationStatus_ColdRebootRequired:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 3;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivaitonStatus_ActivationInProgress:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 4;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivaitonStatus_Retry:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 5;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivaitonStatus_FwUnsupported:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 6;
pub const _SCM_PD_LAST_FW_ACTIVATION_STATUS_ScmPdLastFwActivaitonStatus_UnknownError:
    _SCM_PD_LAST_FW_ACTIVATION_STATUS = 7;
pub type _SCM_PD_LAST_FW_ACTIVATION_STATUS = ::std::os::raw::c_int;
pub use self::_SCM_PD_LAST_FW_ACTIVATION_STATUS as SCM_PD_LAST_FW_ACTIVATION_STATUS;
pub type PSCM_PD_LAST_FW_ACTIVATION_STATUS = *mut _SCM_PD_LAST_FW_ACTIVATION_STATUS;
pub const _SCM_PD_FIRMWARE_ACTIVATION_STATE_ScmPdFirmwareActivationState_Idle:
    _SCM_PD_FIRMWARE_ACTIVATION_STATE = 0;
pub const _SCM_PD_FIRMWARE_ACTIVATION_STATE_ScmPdFirmwareActivationState_Armed:
    _SCM_PD_FIRMWARE_ACTIVATION_STATE = 1;
pub const _SCM_PD_FIRMWARE_ACTIVATION_STATE_ScmPdFirmwareActivationState_Busy:
    _SCM_PD_FIRMWARE_ACTIVATION_STATE = 2;
pub type _SCM_PD_FIRMWARE_ACTIVATION_STATE = ::std::os::raw::c_int;
pub use self::_SCM_PD_FIRMWARE_ACTIVATION_STATE as SCM_PD_FIRMWARE_ACTIVATION_STATE;
pub type PSCM_PD_FIRMWARE_ACTIVATION_STATE = *mut _SCM_PD_FIRMWARE_ACTIVATION_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_RUNTIME_FW_ACTIVATION_INFO {
    pub Version: DWORD,
    pub Size: DWORD,
    pub LastFirmwareActivationStatus: SCM_PD_LAST_FW_ACTIVATION_STATUS,
    pub FirmwareActivationState: SCM_PD_FIRMWARE_ACTIVATION_STATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_RUNTIME_FW_ACTIVATION_INFO"]
        [::std::mem::size_of::<_SCM_PD_RUNTIME_FW_ACTIVATION_INFO>() - 16usize];
    ["Alignment of _SCM_PD_RUNTIME_FW_ACTIVATION_INFO"]
        [::std::mem::align_of::<_SCM_PD_RUNTIME_FW_ACTIVATION_INFO>() - 4usize];
    ["Offset of field: _SCM_PD_RUNTIME_FW_ACTIVATION_INFO::Version"]
        [::std::mem::offset_of!(_SCM_PD_RUNTIME_FW_ACTIVATION_INFO, Version) - 0usize];
    ["Offset of field: _SCM_PD_RUNTIME_FW_ACTIVATION_INFO::Size"]
        [::std::mem::offset_of!(_SCM_PD_RUNTIME_FW_ACTIVATION_INFO, Size) - 4usize];
    ["Offset of field: _SCM_PD_RUNTIME_FW_ACTIVATION_INFO::LastFirmwareActivationStatus"][::std::mem::offset_of!(
        _SCM_PD_RUNTIME_FW_ACTIVATION_INFO,
        LastFirmwareActivationStatus
    )
        - 8usize];
    ["Offset of field: _SCM_PD_RUNTIME_FW_ACTIVATION_INFO::FirmwareActivationState"][::std::mem::offset_of!(
        _SCM_PD_RUNTIME_FW_ACTIVATION_INFO,
        FirmwareActivationState
    ) - 12usize];
};
pub type SCM_PD_RUNTIME_FW_ACTIVATION_INFO = _SCM_PD_RUNTIME_FW_ACTIVATION_INFO;
pub type PSCM_PD_RUNTIME_FW_ACTIVATION_INFO = *mut _SCM_PD_RUNTIME_FW_ACTIVATION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PASSTHROUGH_INPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ProtocolGuid: GUID,
    pub DataSize: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PASSTHROUGH_INPUT"]
        [::std::mem::size_of::<_SCM_PD_PASSTHROUGH_INPUT>() - 32usize];
    ["Alignment of _SCM_PD_PASSTHROUGH_INPUT"]
        [::std::mem::align_of::<_SCM_PD_PASSTHROUGH_INPUT>() - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INPUT::Version"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INPUT, Version) - 0usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INPUT::Size"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INPUT, Size) - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INPUT::ProtocolGuid"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INPUT, ProtocolGuid) - 8usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INPUT::DataSize"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INPUT, DataSize) - 24usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INPUT::Data"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INPUT, Data) - 28usize];
};
pub type SCM_PD_PASSTHROUGH_INPUT = _SCM_PD_PASSTHROUGH_INPUT;
pub type PSCM_PD_PASSTHROUGH_INPUT = *mut _SCM_PD_PASSTHROUGH_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PASSTHROUGH_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub ProtocolGuid: GUID,
    pub DataSize: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PASSTHROUGH_OUTPUT"]
        [::std::mem::size_of::<_SCM_PD_PASSTHROUGH_OUTPUT>() - 32usize];
    ["Alignment of _SCM_PD_PASSTHROUGH_OUTPUT"]
        [::std::mem::align_of::<_SCM_PD_PASSTHROUGH_OUTPUT>() - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_OUTPUT::Version"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_OUTPUT, Version) - 0usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_OUTPUT::Size"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_OUTPUT, Size) - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_OUTPUT::ProtocolGuid"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_OUTPUT, ProtocolGuid) - 8usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_OUTPUT::DataSize"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_OUTPUT, DataSize) - 24usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_OUTPUT::Data"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_OUTPUT, Data) - 28usize];
};
pub type SCM_PD_PASSTHROUGH_OUTPUT = _SCM_PD_PASSTHROUGH_OUTPUT;
pub type PSCM_PD_PASSTHROUGH_OUTPUT = *mut _SCM_PD_PASSTHROUGH_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PASSTHROUGH_INVDIMM_INPUT {
    pub Opcode: DWORD,
    pub OpcodeParametersLength: DWORD,
    pub OpcodeParameters: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PASSTHROUGH_INVDIMM_INPUT"]
        [::std::mem::size_of::<_SCM_PD_PASSTHROUGH_INVDIMM_INPUT>() - 12usize];
    ["Alignment of _SCM_PD_PASSTHROUGH_INVDIMM_INPUT"]
        [::std::mem::align_of::<_SCM_PD_PASSTHROUGH_INVDIMM_INPUT>() - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_INPUT::Opcode"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_INPUT, Opcode) - 0usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_INPUT::OpcodeParametersLength"][::std::mem::offset_of!(
        _SCM_PD_PASSTHROUGH_INVDIMM_INPUT,
        OpcodeParametersLength
    ) - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_INPUT::OpcodeParameters"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_INPUT, OpcodeParameters) - 8usize];
};
pub type SCM_PD_PASSTHROUGH_INVDIMM_INPUT = _SCM_PD_PASSTHROUGH_INVDIMM_INPUT;
pub type PSCM_PD_PASSTHROUGH_INVDIMM_INPUT = *mut _SCM_PD_PASSTHROUGH_INVDIMM_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT {
    pub GeneralStatus: WORD,
    pub ExtendedStatus: WORD,
    pub OutputDataLength: DWORD,
    pub OutputData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT"]
        [::std::mem::size_of::<_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT>() - 12usize];
    ["Alignment of _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT"]
        [::std::mem::align_of::<_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT>() - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT::GeneralStatus"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT, GeneralStatus) - 0usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT::ExtendedStatus"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT, ExtendedStatus) - 2usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT::OutputDataLength"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT, OutputDataLength) - 4usize];
    ["Offset of field: _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT::OutputData"]
        [::std::mem::offset_of!(_SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT, OutputData) - 8usize];
};
pub type SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT = _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT;
pub type PSCM_PD_PASSTHROUGH_INVDIMM_OUTPUT = *mut _SCM_PD_PASSTHROUGH_INVDIMM_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_REINITIALIZE_MEDIA_INPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Options: _SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1,
}
#[repr(C)]
#[repr(align(4))]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1 {
    pub _bitfield_align_1: [u8; 0],
    pub _bitfield_1: __BindgenBitfieldUnit<[u8; 1usize]>,
    pub __bindgen_padding_0: [u8; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1"]
        [::std::mem::size_of::<_SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1>() - 4usize];
    ["Alignment of _SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1"]
        [::std::mem::align_of::<_SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1>() - 4usize];
};
impl _SCM_PD_REINITIALIZE_MEDIA_INPUT__bindgen_ty_1 {
    #[inline]
    pub fn Overwrite(&self) -> DWORD {
        unsafe { ::std::mem::transmute(self._bitfield_1.get(0usize, 1u8) as u32) }
    }
    #[inline]
    pub fn set_Overwrite(&mut self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            self._bitfield_1.set(0usize, 1u8, val as u64)
        }
    }
    #[inline]
    pub unsafe fn Overwrite_raw(this: *const Self) -> DWORD {
        unsafe {
            ::std::mem::transmute(<__BindgenBitfieldUnit<[u8; 1usize]>>::raw_get(
                ::std::ptr::addr_of!((*this)._bitfield_1),
                0usize,
                1u8,
            ) as u32)
        }
    }
    #[inline]
    pub unsafe fn set_Overwrite_raw(this: *mut Self, val: DWORD) {
        unsafe {
            let val: u32 = ::std::mem::transmute(val);
            <__BindgenBitfieldUnit<[u8; 1usize]>>::raw_set(
                ::std::ptr::addr_of_mut!((*this)._bitfield_1),
                0usize,
                1u8,
                val as u64,
            )
        }
    }
    #[inline]
    pub fn new_bitfield_1(Overwrite: DWORD) -> __BindgenBitfieldUnit<[u8; 1usize]> {
        let mut __bindgen_bitfield_unit: __BindgenBitfieldUnit<[u8; 1usize]> = Default::default();
        __bindgen_bitfield_unit.set(0usize, 1u8, {
            let Overwrite: u32 = unsafe { ::std::mem::transmute(Overwrite) };
            Overwrite as u64
        });
        __bindgen_bitfield_unit
    }
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_REINITIALIZE_MEDIA_INPUT"]
        [::std::mem::size_of::<_SCM_PD_REINITIALIZE_MEDIA_INPUT>() - 12usize];
    ["Alignment of _SCM_PD_REINITIALIZE_MEDIA_INPUT"]
        [::std::mem::align_of::<_SCM_PD_REINITIALIZE_MEDIA_INPUT>() - 4usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_INPUT::Version"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_INPUT, Version) - 0usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_INPUT::Size"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_INPUT, Size) - 4usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_INPUT::Options"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_INPUT, Options) - 8usize];
};
pub type SCM_PD_REINITIALIZE_MEDIA_INPUT = _SCM_PD_REINITIALIZE_MEDIA_INPUT;
pub type PSCM_PD_REINITIALIZE_MEDIA_INPUT = *mut _SCM_PD_REINITIALIZE_MEDIA_INPUT;
pub const _SCM_PD_MEDIA_REINITIALIZATION_STATUS_ScmPhysicalDeviceReinit_Success:
    _SCM_PD_MEDIA_REINITIALIZATION_STATUS = 0;
pub const _SCM_PD_MEDIA_REINITIALIZATION_STATUS_ScmPhysicalDeviceReinit_RebootNeeded:
    _SCM_PD_MEDIA_REINITIALIZATION_STATUS = 1;
pub const _SCM_PD_MEDIA_REINITIALIZATION_STATUS_ScmPhysicalDeviceReinit_ColdBootNeeded:
    _SCM_PD_MEDIA_REINITIALIZATION_STATUS = 2;
pub const _SCM_PD_MEDIA_REINITIALIZATION_STATUS_ScmPhysicalDeviceReinit_Max:
    _SCM_PD_MEDIA_REINITIALIZATION_STATUS = 3;
pub type _SCM_PD_MEDIA_REINITIALIZATION_STATUS = ::std::os::raw::c_int;
pub use self::_SCM_PD_MEDIA_REINITIALIZATION_STATUS as SCM_PD_MEDIA_REINITIALIZATION_STATUS;
pub type PSCM_PD_MEDIA_REINITIALIZATION_STATUS = *mut _SCM_PD_MEDIA_REINITIALIZATION_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCM_PD_REINITIALIZE_MEDIA_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Status: SCM_PD_MEDIA_REINITIALIZATION_STATUS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCM_PD_REINITIALIZE_MEDIA_OUTPUT"]
        [::std::mem::size_of::<_SCM_PD_REINITIALIZE_MEDIA_OUTPUT>() - 12usize];
    ["Alignment of _SCM_PD_REINITIALIZE_MEDIA_OUTPUT"]
        [::std::mem::align_of::<_SCM_PD_REINITIALIZE_MEDIA_OUTPUT>() - 4usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_OUTPUT::Version"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_OUTPUT, Version) - 0usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_OUTPUT::Size"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_OUTPUT, Size) - 4usize];
    ["Offset of field: _SCM_PD_REINITIALIZE_MEDIA_OUTPUT::Status"]
        [::std::mem::offset_of!(_SCM_PD_REINITIALIZE_MEDIA_OUTPUT, Status) - 8usize];
};
pub type SCM_PD_REINITIALIZE_MEDIA_OUTPUT = _SCM_PD_REINITIALIZE_MEDIA_OUTPUT;
pub type PSCM_PD_REINITIALIZE_MEDIA_OUTPUT = *mut _SCM_PD_REINITIALIZE_MEDIA_OUTPUT;
pub const _MEDIA_TYPE_Unknown: _MEDIA_TYPE = 0;
pub const _MEDIA_TYPE_F5_1Pt2_512: _MEDIA_TYPE = 1;
pub const _MEDIA_TYPE_F3_1Pt44_512: _MEDIA_TYPE = 2;
pub const _MEDIA_TYPE_F3_2Pt88_512: _MEDIA_TYPE = 3;
pub const _MEDIA_TYPE_F3_20Pt8_512: _MEDIA_TYPE = 4;
pub const _MEDIA_TYPE_F3_720_512: _MEDIA_TYPE = 5;
pub const _MEDIA_TYPE_F5_360_512: _MEDIA_TYPE = 6;
pub const _MEDIA_TYPE_F5_320_512: _MEDIA_TYPE = 7;
pub const _MEDIA_TYPE_F5_320_1024: _MEDIA_TYPE = 8;
pub const _MEDIA_TYPE_F5_180_512: _MEDIA_TYPE = 9;
pub const _MEDIA_TYPE_F5_160_512: _MEDIA_TYPE = 10;
pub const _MEDIA_TYPE_RemovableMedia: _MEDIA_TYPE = 11;
pub const _MEDIA_TYPE_FixedMedia: _MEDIA_TYPE = 12;
pub const _MEDIA_TYPE_F3_120M_512: _MEDIA_TYPE = 13;
pub const _MEDIA_TYPE_F3_640_512: _MEDIA_TYPE = 14;
pub const _MEDIA_TYPE_F5_640_512: _MEDIA_TYPE = 15;
pub const _MEDIA_TYPE_F5_720_512: _MEDIA_TYPE = 16;
pub const _MEDIA_TYPE_F3_1Pt2_512: _MEDIA_TYPE = 17;
pub const _MEDIA_TYPE_F3_1Pt23_1024: _MEDIA_TYPE = 18;
pub const _MEDIA_TYPE_F5_1Pt23_1024: _MEDIA_TYPE = 19;
pub const _MEDIA_TYPE_F3_128Mb_512: _MEDIA_TYPE = 20;
pub const _MEDIA_TYPE_F3_230Mb_512: _MEDIA_TYPE = 21;
pub const _MEDIA_TYPE_F8_256_128: _MEDIA_TYPE = 22;
pub const _MEDIA_TYPE_F3_200Mb_512: _MEDIA_TYPE = 23;
pub const _MEDIA_TYPE_F3_240M_512: _MEDIA_TYPE = 24;
pub const _MEDIA_TYPE_F3_32M_512: _MEDIA_TYPE = 25;
pub type _MEDIA_TYPE = ::std::os::raw::c_int;
pub use self::_MEDIA_TYPE as MEDIA_TYPE;
pub type PMEDIA_TYPE = *mut _MEDIA_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORMAT_PARAMETERS {
    pub MediaType: MEDIA_TYPE,
    pub StartCylinderNumber: DWORD,
    pub EndCylinderNumber: DWORD,
    pub StartHeadNumber: DWORD,
    pub EndHeadNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORMAT_PARAMETERS"][::std::mem::size_of::<_FORMAT_PARAMETERS>() - 20usize];
    ["Alignment of _FORMAT_PARAMETERS"][::std::mem::align_of::<_FORMAT_PARAMETERS>() - 4usize];
    ["Offset of field: _FORMAT_PARAMETERS::MediaType"]
        [::std::mem::offset_of!(_FORMAT_PARAMETERS, MediaType) - 0usize];
    ["Offset of field: _FORMAT_PARAMETERS::StartCylinderNumber"]
        [::std::mem::offset_of!(_FORMAT_PARAMETERS, StartCylinderNumber) - 4usize];
    ["Offset of field: _FORMAT_PARAMETERS::EndCylinderNumber"]
        [::std::mem::offset_of!(_FORMAT_PARAMETERS, EndCylinderNumber) - 8usize];
    ["Offset of field: _FORMAT_PARAMETERS::StartHeadNumber"]
        [::std::mem::offset_of!(_FORMAT_PARAMETERS, StartHeadNumber) - 12usize];
    ["Offset of field: _FORMAT_PARAMETERS::EndHeadNumber"]
        [::std::mem::offset_of!(_FORMAT_PARAMETERS, EndHeadNumber) - 16usize];
};
pub type FORMAT_PARAMETERS = _FORMAT_PARAMETERS;
pub type PFORMAT_PARAMETERS = *mut _FORMAT_PARAMETERS;
pub type BAD_TRACK_NUMBER = WORD;
pub type PBAD_TRACK_NUMBER = *mut WORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORMAT_EX_PARAMETERS {
    pub MediaType: MEDIA_TYPE,
    pub StartCylinderNumber: DWORD,
    pub EndCylinderNumber: DWORD,
    pub StartHeadNumber: DWORD,
    pub EndHeadNumber: DWORD,
    pub FormatGapLength: WORD,
    pub SectorsPerTrack: WORD,
    pub SectorNumber: [WORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORMAT_EX_PARAMETERS"][::std::mem::size_of::<_FORMAT_EX_PARAMETERS>() - 28usize];
    ["Alignment of _FORMAT_EX_PARAMETERS"]
        [::std::mem::align_of::<_FORMAT_EX_PARAMETERS>() - 4usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::MediaType"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, MediaType) - 0usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::StartCylinderNumber"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, StartCylinderNumber) - 4usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::EndCylinderNumber"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, EndCylinderNumber) - 8usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::StartHeadNumber"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, StartHeadNumber) - 12usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::EndHeadNumber"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, EndHeadNumber) - 16usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::FormatGapLength"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, FormatGapLength) - 20usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::SectorsPerTrack"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, SectorsPerTrack) - 22usize];
    ["Offset of field: _FORMAT_EX_PARAMETERS::SectorNumber"]
        [::std::mem::offset_of!(_FORMAT_EX_PARAMETERS, SectorNumber) - 24usize];
};
pub type FORMAT_EX_PARAMETERS = _FORMAT_EX_PARAMETERS;
pub type PFORMAT_EX_PARAMETERS = *mut _FORMAT_EX_PARAMETERS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_GEOMETRY {
    pub Cylinders: LARGE_INTEGER,
    pub MediaType: MEDIA_TYPE,
    pub TracksPerCylinder: DWORD,
    pub SectorsPerTrack: DWORD,
    pub BytesPerSector: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_GEOMETRY"][::std::mem::size_of::<_DISK_GEOMETRY>() - 24usize];
    ["Alignment of _DISK_GEOMETRY"][::std::mem::align_of::<_DISK_GEOMETRY>() - 8usize];
    ["Offset of field: _DISK_GEOMETRY::Cylinders"]
        [::std::mem::offset_of!(_DISK_GEOMETRY, Cylinders) - 0usize];
    ["Offset of field: _DISK_GEOMETRY::MediaType"]
        [::std::mem::offset_of!(_DISK_GEOMETRY, MediaType) - 8usize];
    ["Offset of field: _DISK_GEOMETRY::TracksPerCylinder"]
        [::std::mem::offset_of!(_DISK_GEOMETRY, TracksPerCylinder) - 12usize];
    ["Offset of field: _DISK_GEOMETRY::SectorsPerTrack"]
        [::std::mem::offset_of!(_DISK_GEOMETRY, SectorsPerTrack) - 16usize];
    ["Offset of field: _DISK_GEOMETRY::BytesPerSector"]
        [::std::mem::offset_of!(_DISK_GEOMETRY, BytesPerSector) - 20usize];
};
pub type DISK_GEOMETRY = _DISK_GEOMETRY;
pub type PDISK_GEOMETRY = *mut _DISK_GEOMETRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PARTITION_INFORMATION {
    pub StartingOffset: LARGE_INTEGER,
    pub PartitionLength: LARGE_INTEGER,
    pub HiddenSectors: DWORD,
    pub PartitionNumber: DWORD,
    pub PartitionType: BYTE,
    pub BootIndicator: BOOLEAN,
    pub RecognizedPartition: BOOLEAN,
    pub RewritePartition: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PARTITION_INFORMATION"][::std::mem::size_of::<_PARTITION_INFORMATION>() - 32usize];
    ["Alignment of _PARTITION_INFORMATION"]
        [::std::mem::align_of::<_PARTITION_INFORMATION>() - 8usize];
    ["Offset of field: _PARTITION_INFORMATION::StartingOffset"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, StartingOffset) - 0usize];
    ["Offset of field: _PARTITION_INFORMATION::PartitionLength"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, PartitionLength) - 8usize];
    ["Offset of field: _PARTITION_INFORMATION::HiddenSectors"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, HiddenSectors) - 16usize];
    ["Offset of field: _PARTITION_INFORMATION::PartitionNumber"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, PartitionNumber) - 20usize];
    ["Offset of field: _PARTITION_INFORMATION::PartitionType"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, PartitionType) - 24usize];
    ["Offset of field: _PARTITION_INFORMATION::BootIndicator"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, BootIndicator) - 25usize];
    ["Offset of field: _PARTITION_INFORMATION::RecognizedPartition"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, RecognizedPartition) - 26usize];
    ["Offset of field: _PARTITION_INFORMATION::RewritePartition"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION, RewritePartition) - 27usize];
};
pub type PARTITION_INFORMATION = _PARTITION_INFORMATION;
pub type PPARTITION_INFORMATION = *mut _PARTITION_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SET_PARTITION_INFORMATION {
    pub PartitionType: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_PARTITION_INFORMATION"]
        [::std::mem::size_of::<_SET_PARTITION_INFORMATION>() - 1usize];
    ["Alignment of _SET_PARTITION_INFORMATION"]
        [::std::mem::align_of::<_SET_PARTITION_INFORMATION>() - 1usize];
    ["Offset of field: _SET_PARTITION_INFORMATION::PartitionType"]
        [::std::mem::offset_of!(_SET_PARTITION_INFORMATION, PartitionType) - 0usize];
};
pub type SET_PARTITION_INFORMATION = _SET_PARTITION_INFORMATION;
pub type PSET_PARTITION_INFORMATION = *mut _SET_PARTITION_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DRIVE_LAYOUT_INFORMATION {
    pub PartitionCount: DWORD,
    pub Signature: DWORD,
    pub PartitionEntry: [PARTITION_INFORMATION; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVE_LAYOUT_INFORMATION"]
        [::std::mem::size_of::<_DRIVE_LAYOUT_INFORMATION>() - 40usize];
    ["Alignment of _DRIVE_LAYOUT_INFORMATION"]
        [::std::mem::align_of::<_DRIVE_LAYOUT_INFORMATION>() - 8usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION::PartitionCount"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION, PartitionCount) - 0usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION::Signature"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION, Signature) - 4usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION::PartitionEntry"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION, PartitionEntry) - 8usize];
};
pub type DRIVE_LAYOUT_INFORMATION = _DRIVE_LAYOUT_INFORMATION;
pub type PDRIVE_LAYOUT_INFORMATION = *mut _DRIVE_LAYOUT_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _VERIFY_INFORMATION {
    pub StartingOffset: LARGE_INTEGER,
    pub Length: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VERIFY_INFORMATION"][::std::mem::size_of::<_VERIFY_INFORMATION>() - 16usize];
    ["Alignment of _VERIFY_INFORMATION"][::std::mem::align_of::<_VERIFY_INFORMATION>() - 8usize];
    ["Offset of field: _VERIFY_INFORMATION::StartingOffset"]
        [::std::mem::offset_of!(_VERIFY_INFORMATION, StartingOffset) - 0usize];
    ["Offset of field: _VERIFY_INFORMATION::Length"]
        [::std::mem::offset_of!(_VERIFY_INFORMATION, Length) - 8usize];
};
pub type VERIFY_INFORMATION = _VERIFY_INFORMATION;
pub type PVERIFY_INFORMATION = *mut _VERIFY_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REASSIGN_BLOCKS {
    pub Reserved: WORD,
    pub Count: WORD,
    pub BlockNumber: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REASSIGN_BLOCKS"][::std::mem::size_of::<_REASSIGN_BLOCKS>() - 8usize];
    ["Alignment of _REASSIGN_BLOCKS"][::std::mem::align_of::<_REASSIGN_BLOCKS>() - 4usize];
    ["Offset of field: _REASSIGN_BLOCKS::Reserved"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS, Reserved) - 0usize];
    ["Offset of field: _REASSIGN_BLOCKS::Count"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS, Count) - 2usize];
    ["Offset of field: _REASSIGN_BLOCKS::BlockNumber"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS, BlockNumber) - 4usize];
};
pub type REASSIGN_BLOCKS = _REASSIGN_BLOCKS;
pub type PREASSIGN_BLOCKS = *mut _REASSIGN_BLOCKS;
#[repr(C, packed)]
#[derive(Copy, Clone)]
pub struct _REASSIGN_BLOCKS_EX {
    pub Reserved: WORD,
    pub Count: WORD,
    pub BlockNumber: [LARGE_INTEGER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REASSIGN_BLOCKS_EX"][::std::mem::size_of::<_REASSIGN_BLOCKS_EX>() - 12usize];
    ["Alignment of _REASSIGN_BLOCKS_EX"][::std::mem::align_of::<_REASSIGN_BLOCKS_EX>() - 1usize];
    ["Offset of field: _REASSIGN_BLOCKS_EX::Reserved"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS_EX, Reserved) - 0usize];
    ["Offset of field: _REASSIGN_BLOCKS_EX::Count"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS_EX, Count) - 2usize];
    ["Offset of field: _REASSIGN_BLOCKS_EX::BlockNumber"]
        [::std::mem::offset_of!(_REASSIGN_BLOCKS_EX, BlockNumber) - 4usize];
};
pub type REASSIGN_BLOCKS_EX = _REASSIGN_BLOCKS_EX;
pub type PREASSIGN_BLOCKS_EX = *mut _REASSIGN_BLOCKS_EX;
pub const _PARTITION_STYLE_PARTITION_STYLE_MBR: _PARTITION_STYLE = 0;
pub const _PARTITION_STYLE_PARTITION_STYLE_GPT: _PARTITION_STYLE = 1;
pub const _PARTITION_STYLE_PARTITION_STYLE_RAW: _PARTITION_STYLE = 2;
pub type _PARTITION_STYLE = ::std::os::raw::c_int;
pub use self::_PARTITION_STYLE as PARTITION_STYLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PARTITION_INFORMATION_GPT {
    pub PartitionType: GUID,
    pub PartitionId: GUID,
    pub Attributes: DWORD64,
    pub Name: [WCHAR; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PARTITION_INFORMATION_GPT"]
        [::std::mem::size_of::<_PARTITION_INFORMATION_GPT>() - 112usize];
    ["Alignment of _PARTITION_INFORMATION_GPT"]
        [::std::mem::align_of::<_PARTITION_INFORMATION_GPT>() - 8usize];
    ["Offset of field: _PARTITION_INFORMATION_GPT::PartitionType"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_GPT, PartitionType) - 0usize];
    ["Offset of field: _PARTITION_INFORMATION_GPT::PartitionId"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_GPT, PartitionId) - 16usize];
    ["Offset of field: _PARTITION_INFORMATION_GPT::Attributes"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_GPT, Attributes) - 32usize];
    ["Offset of field: _PARTITION_INFORMATION_GPT::Name"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_GPT, Name) - 40usize];
};
pub type PARTITION_INFORMATION_GPT = _PARTITION_INFORMATION_GPT;
pub type PPARTITION_INFORMATION_GPT = *mut _PARTITION_INFORMATION_GPT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PARTITION_INFORMATION_MBR {
    pub PartitionType: BYTE,
    pub BootIndicator: BOOLEAN,
    pub RecognizedPartition: BOOLEAN,
    pub HiddenSectors: DWORD,
    pub PartitionId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PARTITION_INFORMATION_MBR"]
        [::std::mem::size_of::<_PARTITION_INFORMATION_MBR>() - 24usize];
    ["Alignment of _PARTITION_INFORMATION_MBR"]
        [::std::mem::align_of::<_PARTITION_INFORMATION_MBR>() - 4usize];
    ["Offset of field: _PARTITION_INFORMATION_MBR::PartitionType"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_MBR, PartitionType) - 0usize];
    ["Offset of field: _PARTITION_INFORMATION_MBR::BootIndicator"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_MBR, BootIndicator) - 1usize];
    ["Offset of field: _PARTITION_INFORMATION_MBR::RecognizedPartition"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_MBR, RecognizedPartition) - 2usize];
    ["Offset of field: _PARTITION_INFORMATION_MBR::HiddenSectors"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_MBR, HiddenSectors) - 4usize];
    ["Offset of field: _PARTITION_INFORMATION_MBR::PartitionId"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_MBR, PartitionId) - 8usize];
};
pub type PARTITION_INFORMATION_MBR = _PARTITION_INFORMATION_MBR;
pub type PPARTITION_INFORMATION_MBR = *mut _PARTITION_INFORMATION_MBR;
pub type SET_PARTITION_INFORMATION_MBR = SET_PARTITION_INFORMATION;
pub type SET_PARTITION_INFORMATION_GPT = PARTITION_INFORMATION_GPT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SET_PARTITION_INFORMATION_EX {
    pub PartitionStyle: PARTITION_STYLE,
    pub __bindgen_anon_1: _SET_PARTITION_INFORMATION_EX__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SET_PARTITION_INFORMATION_EX__bindgen_ty_1 {
    pub Mbr: SET_PARTITION_INFORMATION_MBR,
    pub Gpt: SET_PARTITION_INFORMATION_GPT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_PARTITION_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_SET_PARTITION_INFORMATION_EX__bindgen_ty_1>() - 112usize];
    ["Alignment of _SET_PARTITION_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_SET_PARTITION_INFORMATION_EX__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SET_PARTITION_INFORMATION_EX__bindgen_ty_1::Mbr"]
        [::std::mem::offset_of!(_SET_PARTITION_INFORMATION_EX__bindgen_ty_1, Mbr) - 0usize];
    ["Offset of field: _SET_PARTITION_INFORMATION_EX__bindgen_ty_1::Gpt"]
        [::std::mem::offset_of!(_SET_PARTITION_INFORMATION_EX__bindgen_ty_1, Gpt) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_PARTITION_INFORMATION_EX"]
        [::std::mem::size_of::<_SET_PARTITION_INFORMATION_EX>() - 120usize];
    ["Alignment of _SET_PARTITION_INFORMATION_EX"]
        [::std::mem::align_of::<_SET_PARTITION_INFORMATION_EX>() - 8usize];
    ["Offset of field: _SET_PARTITION_INFORMATION_EX::PartitionStyle"]
        [::std::mem::offset_of!(_SET_PARTITION_INFORMATION_EX, PartitionStyle) - 0usize];
};
pub type SET_PARTITION_INFORMATION_EX = _SET_PARTITION_INFORMATION_EX;
pub type PSET_PARTITION_INFORMATION_EX = *mut _SET_PARTITION_INFORMATION_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CREATE_DISK_GPT {
    pub DiskId: GUID,
    pub MaxPartitionCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_DISK_GPT"][::std::mem::size_of::<_CREATE_DISK_GPT>() - 20usize];
    ["Alignment of _CREATE_DISK_GPT"][::std::mem::align_of::<_CREATE_DISK_GPT>() - 4usize];
    ["Offset of field: _CREATE_DISK_GPT::DiskId"]
        [::std::mem::offset_of!(_CREATE_DISK_GPT, DiskId) - 0usize];
    ["Offset of field: _CREATE_DISK_GPT::MaxPartitionCount"]
        [::std::mem::offset_of!(_CREATE_DISK_GPT, MaxPartitionCount) - 16usize];
};
pub type CREATE_DISK_GPT = _CREATE_DISK_GPT;
pub type PCREATE_DISK_GPT = *mut _CREATE_DISK_GPT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CREATE_DISK_MBR {
    pub Signature: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_DISK_MBR"][::std::mem::size_of::<_CREATE_DISK_MBR>() - 4usize];
    ["Alignment of _CREATE_DISK_MBR"][::std::mem::align_of::<_CREATE_DISK_MBR>() - 4usize];
    ["Offset of field: _CREATE_DISK_MBR::Signature"]
        [::std::mem::offset_of!(_CREATE_DISK_MBR, Signature) - 0usize];
};
pub type CREATE_DISK_MBR = _CREATE_DISK_MBR;
pub type PCREATE_DISK_MBR = *mut _CREATE_DISK_MBR;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CREATE_DISK {
    pub PartitionStyle: PARTITION_STYLE,
    pub __bindgen_anon_1: _CREATE_DISK__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _CREATE_DISK__bindgen_ty_1 {
    pub Mbr: CREATE_DISK_MBR,
    pub Gpt: CREATE_DISK_GPT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_DISK__bindgen_ty_1"]
        [::std::mem::size_of::<_CREATE_DISK__bindgen_ty_1>() - 20usize];
    ["Alignment of _CREATE_DISK__bindgen_ty_1"]
        [::std::mem::align_of::<_CREATE_DISK__bindgen_ty_1>() - 4usize];
    ["Offset of field: _CREATE_DISK__bindgen_ty_1::Mbr"]
        [::std::mem::offset_of!(_CREATE_DISK__bindgen_ty_1, Mbr) - 0usize];
    ["Offset of field: _CREATE_DISK__bindgen_ty_1::Gpt"]
        [::std::mem::offset_of!(_CREATE_DISK__bindgen_ty_1, Gpt) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CREATE_DISK"][::std::mem::size_of::<_CREATE_DISK>() - 24usize];
    ["Alignment of _CREATE_DISK"][::std::mem::align_of::<_CREATE_DISK>() - 4usize];
    ["Offset of field: _CREATE_DISK::PartitionStyle"]
        [::std::mem::offset_of!(_CREATE_DISK, PartitionStyle) - 0usize];
};
pub type CREATE_DISK = _CREATE_DISK;
pub type PCREATE_DISK = *mut _CREATE_DISK;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _GET_LENGTH_INFORMATION {
    pub Length: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_LENGTH_INFORMATION"][::std::mem::size_of::<_GET_LENGTH_INFORMATION>() - 8usize];
    ["Alignment of _GET_LENGTH_INFORMATION"]
        [::std::mem::align_of::<_GET_LENGTH_INFORMATION>() - 8usize];
    ["Offset of field: _GET_LENGTH_INFORMATION::Length"]
        [::std::mem::offset_of!(_GET_LENGTH_INFORMATION, Length) - 0usize];
};
pub type GET_LENGTH_INFORMATION = _GET_LENGTH_INFORMATION;
pub type PGET_LENGTH_INFORMATION = *mut _GET_LENGTH_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PARTITION_INFORMATION_EX {
    pub PartitionStyle: PARTITION_STYLE,
    pub StartingOffset: LARGE_INTEGER,
    pub PartitionLength: LARGE_INTEGER,
    pub PartitionNumber: DWORD,
    pub RewritePartition: BOOLEAN,
    pub IsServicePartition: BOOLEAN,
    pub __bindgen_anon_1: _PARTITION_INFORMATION_EX__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PARTITION_INFORMATION_EX__bindgen_ty_1 {
    pub Mbr: PARTITION_INFORMATION_MBR,
    pub Gpt: PARTITION_INFORMATION_GPT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PARTITION_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_PARTITION_INFORMATION_EX__bindgen_ty_1>() - 112usize];
    ["Alignment of _PARTITION_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_PARTITION_INFORMATION_EX__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PARTITION_INFORMATION_EX__bindgen_ty_1::Mbr"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX__bindgen_ty_1, Mbr) - 0usize];
    ["Offset of field: _PARTITION_INFORMATION_EX__bindgen_ty_1::Gpt"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX__bindgen_ty_1, Gpt) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PARTITION_INFORMATION_EX"]
        [::std::mem::size_of::<_PARTITION_INFORMATION_EX>() - 144usize];
    ["Alignment of _PARTITION_INFORMATION_EX"]
        [::std::mem::align_of::<_PARTITION_INFORMATION_EX>() - 8usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::PartitionStyle"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, PartitionStyle) - 0usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::StartingOffset"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, StartingOffset) - 8usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::PartitionLength"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, PartitionLength) - 16usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::PartitionNumber"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, PartitionNumber) - 24usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::RewritePartition"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, RewritePartition) - 28usize];
    ["Offset of field: _PARTITION_INFORMATION_EX::IsServicePartition"]
        [::std::mem::offset_of!(_PARTITION_INFORMATION_EX, IsServicePartition) - 29usize];
};
pub type PARTITION_INFORMATION_EX = _PARTITION_INFORMATION_EX;
pub type PPARTITION_INFORMATION_EX = *mut _PARTITION_INFORMATION_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DRIVE_LAYOUT_INFORMATION_GPT {
    pub DiskId: GUID,
    pub StartingUsableOffset: LARGE_INTEGER,
    pub UsableLength: LARGE_INTEGER,
    pub MaxPartitionCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVE_LAYOUT_INFORMATION_GPT"]
        [::std::mem::size_of::<_DRIVE_LAYOUT_INFORMATION_GPT>() - 40usize];
    ["Alignment of _DRIVE_LAYOUT_INFORMATION_GPT"]
        [::std::mem::align_of::<_DRIVE_LAYOUT_INFORMATION_GPT>() - 8usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_GPT::DiskId"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_GPT, DiskId) - 0usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_GPT::StartingUsableOffset"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_GPT, StartingUsableOffset) - 16usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_GPT::UsableLength"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_GPT, UsableLength) - 24usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_GPT::MaxPartitionCount"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_GPT, MaxPartitionCount) - 32usize];
};
pub type DRIVE_LAYOUT_INFORMATION_GPT = _DRIVE_LAYOUT_INFORMATION_GPT;
pub type PDRIVE_LAYOUT_INFORMATION_GPT = *mut _DRIVE_LAYOUT_INFORMATION_GPT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVE_LAYOUT_INFORMATION_MBR {
    pub Signature: DWORD,
    pub CheckSum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVE_LAYOUT_INFORMATION_MBR"]
        [::std::mem::size_of::<_DRIVE_LAYOUT_INFORMATION_MBR>() - 8usize];
    ["Alignment of _DRIVE_LAYOUT_INFORMATION_MBR"]
        [::std::mem::align_of::<_DRIVE_LAYOUT_INFORMATION_MBR>() - 4usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_MBR::Signature"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_MBR, Signature) - 0usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_MBR::CheckSum"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_MBR, CheckSum) - 4usize];
};
pub type DRIVE_LAYOUT_INFORMATION_MBR = _DRIVE_LAYOUT_INFORMATION_MBR;
pub type PDRIVE_LAYOUT_INFORMATION_MBR = *mut _DRIVE_LAYOUT_INFORMATION_MBR;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DRIVE_LAYOUT_INFORMATION_EX {
    pub PartitionStyle: DWORD,
    pub PartitionCount: DWORD,
    pub __bindgen_anon_1: _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1,
    pub PartitionEntry: [PARTITION_INFORMATION_EX; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1 {
    pub Mbr: DRIVE_LAYOUT_INFORMATION_MBR,
    pub Gpt: DRIVE_LAYOUT_INFORMATION_GPT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1>() - 40usize];
    ["Alignment of _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1::Mbr"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1, Mbr) - 0usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1::Gpt"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_EX__bindgen_ty_1, Gpt) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVE_LAYOUT_INFORMATION_EX"]
        [::std::mem::size_of::<_DRIVE_LAYOUT_INFORMATION_EX>() - 192usize];
    ["Alignment of _DRIVE_LAYOUT_INFORMATION_EX"]
        [::std::mem::align_of::<_DRIVE_LAYOUT_INFORMATION_EX>() - 8usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_EX::PartitionStyle"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_EX, PartitionStyle) - 0usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_EX::PartitionCount"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_EX, PartitionCount) - 4usize];
    ["Offset of field: _DRIVE_LAYOUT_INFORMATION_EX::PartitionEntry"]
        [::std::mem::offset_of!(_DRIVE_LAYOUT_INFORMATION_EX, PartitionEntry) - 48usize];
};
pub type DRIVE_LAYOUT_INFORMATION_EX = _DRIVE_LAYOUT_INFORMATION_EX;
pub type PDRIVE_LAYOUT_INFORMATION_EX = *mut _DRIVE_LAYOUT_INFORMATION_EX;
pub const _DETECTION_TYPE_DetectNone: _DETECTION_TYPE = 0;
pub const _DETECTION_TYPE_DetectInt13: _DETECTION_TYPE = 1;
pub const _DETECTION_TYPE_DetectExInt13: _DETECTION_TYPE = 2;
pub type _DETECTION_TYPE = ::std::os::raw::c_int;
pub use self::_DETECTION_TYPE as DETECTION_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_INT13_INFO {
    pub DriveSelect: WORD,
    pub MaxCylinders: DWORD,
    pub SectorsPerTrack: WORD,
    pub MaxHeads: WORD,
    pub NumberDrives: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_INT13_INFO"][::std::mem::size_of::<_DISK_INT13_INFO>() - 16usize];
    ["Alignment of _DISK_INT13_INFO"][::std::mem::align_of::<_DISK_INT13_INFO>() - 4usize];
    ["Offset of field: _DISK_INT13_INFO::DriveSelect"]
        [::std::mem::offset_of!(_DISK_INT13_INFO, DriveSelect) - 0usize];
    ["Offset of field: _DISK_INT13_INFO::MaxCylinders"]
        [::std::mem::offset_of!(_DISK_INT13_INFO, MaxCylinders) - 4usize];
    ["Offset of field: _DISK_INT13_INFO::SectorsPerTrack"]
        [::std::mem::offset_of!(_DISK_INT13_INFO, SectorsPerTrack) - 8usize];
    ["Offset of field: _DISK_INT13_INFO::MaxHeads"]
        [::std::mem::offset_of!(_DISK_INT13_INFO, MaxHeads) - 10usize];
    ["Offset of field: _DISK_INT13_INFO::NumberDrives"]
        [::std::mem::offset_of!(_DISK_INT13_INFO, NumberDrives) - 12usize];
};
pub type DISK_INT13_INFO = _DISK_INT13_INFO;
pub type PDISK_INT13_INFO = *mut _DISK_INT13_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_EX_INT13_INFO {
    pub ExBufferSize: WORD,
    pub ExFlags: WORD,
    pub ExCylinders: DWORD,
    pub ExHeads: DWORD,
    pub ExSectorsPerTrack: DWORD,
    pub ExSectorsPerDrive: DWORD64,
    pub ExSectorSize: WORD,
    pub ExReserved: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_EX_INT13_INFO"][::std::mem::size_of::<_DISK_EX_INT13_INFO>() - 32usize];
    ["Alignment of _DISK_EX_INT13_INFO"][::std::mem::align_of::<_DISK_EX_INT13_INFO>() - 8usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExBufferSize"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExBufferSize) - 0usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExFlags"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExFlags) - 2usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExCylinders"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExCylinders) - 4usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExHeads"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExHeads) - 8usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExSectorsPerTrack"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExSectorsPerTrack) - 12usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExSectorsPerDrive"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExSectorsPerDrive) - 16usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExSectorSize"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExSectorSize) - 24usize];
    ["Offset of field: _DISK_EX_INT13_INFO::ExReserved"]
        [::std::mem::offset_of!(_DISK_EX_INT13_INFO, ExReserved) - 26usize];
};
pub type DISK_EX_INT13_INFO = _DISK_EX_INT13_INFO;
pub type PDISK_EX_INT13_INFO = *mut _DISK_EX_INT13_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_DETECTION_INFO {
    pub SizeOfDetectInfo: DWORD,
    pub DetectionType: DETECTION_TYPE,
    pub __bindgen_anon_1: _DISK_DETECTION_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISK_DETECTION_INFO__bindgen_ty_1 {
    pub __bindgen_anon_1: _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub Int13: DISK_INT13_INFO,
    pub ExInt13: DISK_EX_INT13_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1>() - 48usize];
    ["Alignment of _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1::Int13"]
        [::std::mem::offset_of!(_DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1, Int13) - 0usize];
    ["Offset of field: _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1::ExInt13"][::std::mem::offset_of!(
        _DISK_DETECTION_INFO__bindgen_ty_1__bindgen_ty_1,
        ExInt13
    ) - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_DETECTION_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_DETECTION_INFO__bindgen_ty_1>() - 48usize];
    ["Alignment of _DISK_DETECTION_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_DETECTION_INFO__bindgen_ty_1>() - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_DETECTION_INFO"][::std::mem::size_of::<_DISK_DETECTION_INFO>() - 56usize];
    ["Alignment of _DISK_DETECTION_INFO"][::std::mem::align_of::<_DISK_DETECTION_INFO>() - 8usize];
    ["Offset of field: _DISK_DETECTION_INFO::SizeOfDetectInfo"]
        [::std::mem::offset_of!(_DISK_DETECTION_INFO, SizeOfDetectInfo) - 0usize];
    ["Offset of field: _DISK_DETECTION_INFO::DetectionType"]
        [::std::mem::offset_of!(_DISK_DETECTION_INFO, DetectionType) - 4usize];
};
pub type DISK_DETECTION_INFO = _DISK_DETECTION_INFO;
pub type PDISK_DETECTION_INFO = *mut _DISK_DETECTION_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_PARTITION_INFO {
    pub SizeOfPartitionInfo: DWORD,
    pub PartitionStyle: PARTITION_STYLE,
    pub __bindgen_anon_1: _DISK_PARTITION_INFO__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISK_PARTITION_INFO__bindgen_ty_1 {
    pub Mbr: _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1,
    pub Gpt: _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1 {
    pub Signature: DWORD,
    pub CheckSum: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Alignment of _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1::Signature"][::std::mem::offset_of!(
        _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1,
        Signature
    ) - 0usize];
    ["Offset of field: _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1::CheckSum"][::std::mem::offset_of!(
        _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_1,
        CheckSum
    ) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2 {
    pub DiskId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2>() - 16usize];
    ["Alignment of _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Offset of field: _DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2::DiskId"]
        [::std::mem::offset_of!(_DISK_PARTITION_INFO__bindgen_ty_1__bindgen_ty_2, DiskId) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_PARTITION_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_PARTITION_INFO__bindgen_ty_1>() - 16usize];
    ["Alignment of _DISK_PARTITION_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_PARTITION_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _DISK_PARTITION_INFO__bindgen_ty_1::Mbr"]
        [::std::mem::offset_of!(_DISK_PARTITION_INFO__bindgen_ty_1, Mbr) - 0usize];
    ["Offset of field: _DISK_PARTITION_INFO__bindgen_ty_1::Gpt"]
        [::std::mem::offset_of!(_DISK_PARTITION_INFO__bindgen_ty_1, Gpt) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_PARTITION_INFO"][::std::mem::size_of::<_DISK_PARTITION_INFO>() - 24usize];
    ["Alignment of _DISK_PARTITION_INFO"][::std::mem::align_of::<_DISK_PARTITION_INFO>() - 4usize];
    ["Offset of field: _DISK_PARTITION_INFO::SizeOfPartitionInfo"]
        [::std::mem::offset_of!(_DISK_PARTITION_INFO, SizeOfPartitionInfo) - 0usize];
    ["Offset of field: _DISK_PARTITION_INFO::PartitionStyle"]
        [::std::mem::offset_of!(_DISK_PARTITION_INFO, PartitionStyle) - 4usize];
};
pub type DISK_PARTITION_INFO = _DISK_PARTITION_INFO;
pub type PDISK_PARTITION_INFO = *mut _DISK_PARTITION_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_GEOMETRY_EX {
    pub Geometry: DISK_GEOMETRY,
    pub DiskSize: LARGE_INTEGER,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_GEOMETRY_EX"][::std::mem::size_of::<_DISK_GEOMETRY_EX>() - 40usize];
    ["Alignment of _DISK_GEOMETRY_EX"][::std::mem::align_of::<_DISK_GEOMETRY_EX>() - 8usize];
    ["Offset of field: _DISK_GEOMETRY_EX::Geometry"]
        [::std::mem::offset_of!(_DISK_GEOMETRY_EX, Geometry) - 0usize];
    ["Offset of field: _DISK_GEOMETRY_EX::DiskSize"]
        [::std::mem::offset_of!(_DISK_GEOMETRY_EX, DiskSize) - 24usize];
    ["Offset of field: _DISK_GEOMETRY_EX::Data"]
        [::std::mem::offset_of!(_DISK_GEOMETRY_EX, Data) - 32usize];
};
pub type DISK_GEOMETRY_EX = _DISK_GEOMETRY_EX;
pub type PDISK_GEOMETRY_EX = *mut _DISK_GEOMETRY_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_CONTROLLER_NUMBER {
    pub ControllerNumber: DWORD,
    pub DiskNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_CONTROLLER_NUMBER"][::std::mem::size_of::<_DISK_CONTROLLER_NUMBER>() - 8usize];
    ["Alignment of _DISK_CONTROLLER_NUMBER"]
        [::std::mem::align_of::<_DISK_CONTROLLER_NUMBER>() - 4usize];
    ["Offset of field: _DISK_CONTROLLER_NUMBER::ControllerNumber"]
        [::std::mem::offset_of!(_DISK_CONTROLLER_NUMBER, ControllerNumber) - 0usize];
    ["Offset of field: _DISK_CONTROLLER_NUMBER::DiskNumber"]
        [::std::mem::offset_of!(_DISK_CONTROLLER_NUMBER, DiskNumber) - 4usize];
};
pub type DISK_CONTROLLER_NUMBER = _DISK_CONTROLLER_NUMBER;
pub type PDISK_CONTROLLER_NUMBER = *mut _DISK_CONTROLLER_NUMBER;
pub const DISK_CACHE_RETENTION_PRIORITY_EqualPriority: DISK_CACHE_RETENTION_PRIORITY = 0;
pub const DISK_CACHE_RETENTION_PRIORITY_KeepPrefetchedData: DISK_CACHE_RETENTION_PRIORITY = 1;
pub const DISK_CACHE_RETENTION_PRIORITY_KeepReadData: DISK_CACHE_RETENTION_PRIORITY = 2;
pub type DISK_CACHE_RETENTION_PRIORITY = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_CACHE_INFORMATION {
    pub ParametersSavable: BOOLEAN,
    pub ReadCacheEnabled: BOOLEAN,
    pub WriteCacheEnabled: BOOLEAN,
    pub ReadRetentionPriority: DISK_CACHE_RETENTION_PRIORITY,
    pub WriteRetentionPriority: DISK_CACHE_RETENTION_PRIORITY,
    pub DisablePrefetchTransferLength: WORD,
    pub PrefetchScalar: BOOLEAN,
    pub __bindgen_anon_1: _DISK_CACHE_INFORMATION__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _DISK_CACHE_INFORMATION__bindgen_ty_1 {
    pub ScalarPrefetch: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1,
    pub BlockPrefetch: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1 {
    pub Minimum: WORD,
    pub Maximum: WORD,
    pub MaximumBlocks: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1>() - 6usize];
    ["Alignment of _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1>() - 2usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1::Minimum"][::std::mem::offset_of!(
        _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        Minimum
    ) - 0usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1::Maximum"][::std::mem::offset_of!(
        _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        Maximum
    ) - 2usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1::MaximumBlocks"][::std::mem::offset_of!(
        _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_1,
        MaximumBlocks
    )
        - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2 {
    pub Minimum: WORD,
    pub Maximum: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Alignment of _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2>() - 2usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2::Minimum"][::std::mem::offset_of!(
        _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2,
        Minimum
    ) - 0usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2::Maximum"][::std::mem::offset_of!(
        _DISK_CACHE_INFORMATION__bindgen_ty_1__bindgen_ty_2,
        Maximum
    ) - 2usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_CACHE_INFORMATION__bindgen_ty_1"]
        [::std::mem::size_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1>() - 6usize];
    ["Alignment of _DISK_CACHE_INFORMATION__bindgen_ty_1"]
        [::std::mem::align_of::<_DISK_CACHE_INFORMATION__bindgen_ty_1>() - 2usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1::ScalarPrefetch"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION__bindgen_ty_1, ScalarPrefetch) - 0usize];
    ["Offset of field: _DISK_CACHE_INFORMATION__bindgen_ty_1::BlockPrefetch"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION__bindgen_ty_1, BlockPrefetch) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_CACHE_INFORMATION"][::std::mem::size_of::<_DISK_CACHE_INFORMATION>() - 24usize];
    ["Alignment of _DISK_CACHE_INFORMATION"]
        [::std::mem::align_of::<_DISK_CACHE_INFORMATION>() - 4usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::ParametersSavable"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, ParametersSavable) - 0usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::ReadCacheEnabled"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, ReadCacheEnabled) - 1usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::WriteCacheEnabled"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, WriteCacheEnabled) - 2usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::ReadRetentionPriority"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, ReadRetentionPriority) - 4usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::WriteRetentionPriority"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, WriteRetentionPriority) - 8usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::DisablePrefetchTransferLength"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, DisablePrefetchTransferLength) - 12usize];
    ["Offset of field: _DISK_CACHE_INFORMATION::PrefetchScalar"]
        [::std::mem::offset_of!(_DISK_CACHE_INFORMATION, PrefetchScalar) - 14usize];
};
pub type DISK_CACHE_INFORMATION = _DISK_CACHE_INFORMATION;
pub type PDISK_CACHE_INFORMATION = *mut _DISK_CACHE_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_GROW_PARTITION {
    pub PartitionNumber: DWORD,
    pub BytesToGrow: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_GROW_PARTITION"][::std::mem::size_of::<_DISK_GROW_PARTITION>() - 16usize];
    ["Alignment of _DISK_GROW_PARTITION"][::std::mem::align_of::<_DISK_GROW_PARTITION>() - 8usize];
    ["Offset of field: _DISK_GROW_PARTITION::PartitionNumber"]
        [::std::mem::offset_of!(_DISK_GROW_PARTITION, PartitionNumber) - 0usize];
    ["Offset of field: _DISK_GROW_PARTITION::BytesToGrow"]
        [::std::mem::offset_of!(_DISK_GROW_PARTITION, BytesToGrow) - 8usize];
};
pub type DISK_GROW_PARTITION = _DISK_GROW_PARTITION;
pub type PDISK_GROW_PARTITION = *mut _DISK_GROW_PARTITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _HISTOGRAM_BUCKET {
    pub Reads: DWORD,
    pub Writes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _HISTOGRAM_BUCKET"][::std::mem::size_of::<_HISTOGRAM_BUCKET>() - 8usize];
    ["Alignment of _HISTOGRAM_BUCKET"][::std::mem::align_of::<_HISTOGRAM_BUCKET>() - 4usize];
    ["Offset of field: _HISTOGRAM_BUCKET::Reads"]
        [::std::mem::offset_of!(_HISTOGRAM_BUCKET, Reads) - 0usize];
    ["Offset of field: _HISTOGRAM_BUCKET::Writes"]
        [::std::mem::offset_of!(_HISTOGRAM_BUCKET, Writes) - 4usize];
};
pub type HISTOGRAM_BUCKET = _HISTOGRAM_BUCKET;
pub type PHISTOGRAM_BUCKET = *mut _HISTOGRAM_BUCKET;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_HISTOGRAM {
    pub DiskSize: LARGE_INTEGER,
    pub Start: LARGE_INTEGER,
    pub End: LARGE_INTEGER,
    pub Average: LARGE_INTEGER,
    pub AverageRead: LARGE_INTEGER,
    pub AverageWrite: LARGE_INTEGER,
    pub Granularity: DWORD,
    pub Size: DWORD,
    pub ReadCount: DWORD,
    pub WriteCount: DWORD,
    pub Histogram: PHISTOGRAM_BUCKET,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_HISTOGRAM"][::std::mem::size_of::<_DISK_HISTOGRAM>() - 72usize];
    ["Alignment of _DISK_HISTOGRAM"][::std::mem::align_of::<_DISK_HISTOGRAM>() - 8usize];
    ["Offset of field: _DISK_HISTOGRAM::DiskSize"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, DiskSize) - 0usize];
    ["Offset of field: _DISK_HISTOGRAM::Start"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, Start) - 8usize];
    ["Offset of field: _DISK_HISTOGRAM::End"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, End) - 16usize];
    ["Offset of field: _DISK_HISTOGRAM::Average"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, Average) - 24usize];
    ["Offset of field: _DISK_HISTOGRAM::AverageRead"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, AverageRead) - 32usize];
    ["Offset of field: _DISK_HISTOGRAM::AverageWrite"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, AverageWrite) - 40usize];
    ["Offset of field: _DISK_HISTOGRAM::Granularity"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, Granularity) - 48usize];
    ["Offset of field: _DISK_HISTOGRAM::Size"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, Size) - 52usize];
    ["Offset of field: _DISK_HISTOGRAM::ReadCount"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, ReadCount) - 56usize];
    ["Offset of field: _DISK_HISTOGRAM::WriteCount"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, WriteCount) - 60usize];
    ["Offset of field: _DISK_HISTOGRAM::Histogram"]
        [::std::mem::offset_of!(_DISK_HISTOGRAM, Histogram) - 64usize];
};
pub type DISK_HISTOGRAM = _DISK_HISTOGRAM;
pub type PDISK_HISTOGRAM = *mut _DISK_HISTOGRAM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_PERFORMANCE {
    pub BytesRead: LARGE_INTEGER,
    pub BytesWritten: LARGE_INTEGER,
    pub ReadTime: LARGE_INTEGER,
    pub WriteTime: LARGE_INTEGER,
    pub IdleTime: LARGE_INTEGER,
    pub ReadCount: DWORD,
    pub WriteCount: DWORD,
    pub QueueDepth: DWORD,
    pub SplitCount: DWORD,
    pub QueryTime: LARGE_INTEGER,
    pub StorageDeviceNumber: DWORD,
    pub StorageManagerName: [WCHAR; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_PERFORMANCE"][::std::mem::size_of::<_DISK_PERFORMANCE>() - 88usize];
    ["Alignment of _DISK_PERFORMANCE"][::std::mem::align_of::<_DISK_PERFORMANCE>() - 8usize];
    ["Offset of field: _DISK_PERFORMANCE::BytesRead"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, BytesRead) - 0usize];
    ["Offset of field: _DISK_PERFORMANCE::BytesWritten"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, BytesWritten) - 8usize];
    ["Offset of field: _DISK_PERFORMANCE::ReadTime"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, ReadTime) - 16usize];
    ["Offset of field: _DISK_PERFORMANCE::WriteTime"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, WriteTime) - 24usize];
    ["Offset of field: _DISK_PERFORMANCE::IdleTime"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, IdleTime) - 32usize];
    ["Offset of field: _DISK_PERFORMANCE::ReadCount"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, ReadCount) - 40usize];
    ["Offset of field: _DISK_PERFORMANCE::WriteCount"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, WriteCount) - 44usize];
    ["Offset of field: _DISK_PERFORMANCE::QueueDepth"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, QueueDepth) - 48usize];
    ["Offset of field: _DISK_PERFORMANCE::SplitCount"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, SplitCount) - 52usize];
    ["Offset of field: _DISK_PERFORMANCE::QueryTime"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, QueryTime) - 56usize];
    ["Offset of field: _DISK_PERFORMANCE::StorageDeviceNumber"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, StorageDeviceNumber) - 64usize];
    ["Offset of field: _DISK_PERFORMANCE::StorageManagerName"]
        [::std::mem::offset_of!(_DISK_PERFORMANCE, StorageManagerName) - 68usize];
};
pub type DISK_PERFORMANCE = _DISK_PERFORMANCE;
pub type PDISK_PERFORMANCE = *mut _DISK_PERFORMANCE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_RECORD {
    pub ByteOffset: LARGE_INTEGER,
    pub StartTime: LARGE_INTEGER,
    pub EndTime: LARGE_INTEGER,
    pub VirtualAddress: PVOID,
    pub NumberOfBytes: DWORD,
    pub DeviceNumber: BYTE,
    pub ReadRequest: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_RECORD"][::std::mem::size_of::<_DISK_RECORD>() - 40usize];
    ["Alignment of _DISK_RECORD"][::std::mem::align_of::<_DISK_RECORD>() - 8usize];
    ["Offset of field: _DISK_RECORD::ByteOffset"]
        [::std::mem::offset_of!(_DISK_RECORD, ByteOffset) - 0usize];
    ["Offset of field: _DISK_RECORD::StartTime"]
        [::std::mem::offset_of!(_DISK_RECORD, StartTime) - 8usize];
    ["Offset of field: _DISK_RECORD::EndTime"]
        [::std::mem::offset_of!(_DISK_RECORD, EndTime) - 16usize];
    ["Offset of field: _DISK_RECORD::VirtualAddress"]
        [::std::mem::offset_of!(_DISK_RECORD, VirtualAddress) - 24usize];
    ["Offset of field: _DISK_RECORD::NumberOfBytes"]
        [::std::mem::offset_of!(_DISK_RECORD, NumberOfBytes) - 32usize];
    ["Offset of field: _DISK_RECORD::DeviceNumber"]
        [::std::mem::offset_of!(_DISK_RECORD, DeviceNumber) - 36usize];
    ["Offset of field: _DISK_RECORD::ReadRequest"]
        [::std::mem::offset_of!(_DISK_RECORD, ReadRequest) - 37usize];
};
pub type DISK_RECORD = _DISK_RECORD;
pub type PDISK_RECORD = *mut _DISK_RECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DISK_LOGGING {
    pub Function: BYTE,
    pub BufferAddress: PVOID,
    pub BufferSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_LOGGING"][::std::mem::size_of::<_DISK_LOGGING>() - 24usize];
    ["Alignment of _DISK_LOGGING"][::std::mem::align_of::<_DISK_LOGGING>() - 8usize];
    ["Offset of field: _DISK_LOGGING::Function"]
        [::std::mem::offset_of!(_DISK_LOGGING, Function) - 0usize];
    ["Offset of field: _DISK_LOGGING::BufferAddress"]
        [::std::mem::offset_of!(_DISK_LOGGING, BufferAddress) - 8usize];
    ["Offset of field: _DISK_LOGGING::BufferSize"]
        [::std::mem::offset_of!(_DISK_LOGGING, BufferSize) - 16usize];
};
pub type DISK_LOGGING = _DISK_LOGGING;
pub type PDISK_LOGGING = *mut _DISK_LOGGING;
pub const _BIN_TYPES_RequestSize: _BIN_TYPES = 0;
pub const _BIN_TYPES_RequestLocation: _BIN_TYPES = 1;
pub type _BIN_TYPES = ::std::os::raw::c_int;
pub use self::_BIN_TYPES as BIN_TYPES;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIN_RANGE {
    pub StartValue: LARGE_INTEGER,
    pub Length: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIN_RANGE"][::std::mem::size_of::<_BIN_RANGE>() - 16usize];
    ["Alignment of _BIN_RANGE"][::std::mem::align_of::<_BIN_RANGE>() - 8usize];
    ["Offset of field: _BIN_RANGE::StartValue"]
        [::std::mem::offset_of!(_BIN_RANGE, StartValue) - 0usize];
    ["Offset of field: _BIN_RANGE::Length"][::std::mem::offset_of!(_BIN_RANGE, Length) - 8usize];
};
pub type BIN_RANGE = _BIN_RANGE;
pub type PBIN_RANGE = *mut _BIN_RANGE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PERF_BIN {
    pub NumberOfBins: DWORD,
    pub TypeOfBin: DWORD,
    pub BinsRanges: [BIN_RANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PERF_BIN"][::std::mem::size_of::<_PERF_BIN>() - 24usize];
    ["Alignment of _PERF_BIN"][::std::mem::align_of::<_PERF_BIN>() - 8usize];
    ["Offset of field: _PERF_BIN::NumberOfBins"]
        [::std::mem::offset_of!(_PERF_BIN, NumberOfBins) - 0usize];
    ["Offset of field: _PERF_BIN::TypeOfBin"]
        [::std::mem::offset_of!(_PERF_BIN, TypeOfBin) - 4usize];
    ["Offset of field: _PERF_BIN::BinsRanges"]
        [::std::mem::offset_of!(_PERF_BIN, BinsRanges) - 8usize];
};
pub type PERF_BIN = _PERF_BIN;
pub type PPERF_BIN = *mut _PERF_BIN;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIN_COUNT {
    pub BinRange: BIN_RANGE,
    pub BinCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIN_COUNT"][::std::mem::size_of::<_BIN_COUNT>() - 24usize];
    ["Alignment of _BIN_COUNT"][::std::mem::align_of::<_BIN_COUNT>() - 8usize];
    ["Offset of field: _BIN_COUNT::BinRange"]
        [::std::mem::offset_of!(_BIN_COUNT, BinRange) - 0usize];
    ["Offset of field: _BIN_COUNT::BinCount"]
        [::std::mem::offset_of!(_BIN_COUNT, BinCount) - 16usize];
};
pub type BIN_COUNT = _BIN_COUNT;
pub type PBIN_COUNT = *mut _BIN_COUNT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIN_RESULTS {
    pub NumberOfBins: DWORD,
    pub BinCounts: [BIN_COUNT; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIN_RESULTS"][::std::mem::size_of::<_BIN_RESULTS>() - 32usize];
    ["Alignment of _BIN_RESULTS"][::std::mem::align_of::<_BIN_RESULTS>() - 8usize];
    ["Offset of field: _BIN_RESULTS::NumberOfBins"]
        [::std::mem::offset_of!(_BIN_RESULTS, NumberOfBins) - 0usize];
    ["Offset of field: _BIN_RESULTS::BinCounts"]
        [::std::mem::offset_of!(_BIN_RESULTS, BinCounts) - 8usize];
};
pub type BIN_RESULTS = _BIN_RESULTS;
pub type PBIN_RESULTS = *mut _BIN_RESULTS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _GETVERSIONINPARAMS {
    pub bVersion: BYTE,
    pub bRevision: BYTE,
    pub bReserved: BYTE,
    pub bIDEDeviceMap: BYTE,
    pub fCapabilities: DWORD,
    pub dwReserved: [DWORD; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GETVERSIONINPARAMS"][::std::mem::size_of::<_GETVERSIONINPARAMS>() - 24usize];
    ["Alignment of _GETVERSIONINPARAMS"][::std::mem::align_of::<_GETVERSIONINPARAMS>() - 1usize];
    ["Offset of field: _GETVERSIONINPARAMS::bVersion"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, bVersion) - 0usize];
    ["Offset of field: _GETVERSIONINPARAMS::bRevision"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, bRevision) - 1usize];
    ["Offset of field: _GETVERSIONINPARAMS::bReserved"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, bReserved) - 2usize];
    ["Offset of field: _GETVERSIONINPARAMS::bIDEDeviceMap"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, bIDEDeviceMap) - 3usize];
    ["Offset of field: _GETVERSIONINPARAMS::fCapabilities"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, fCapabilities) - 4usize];
    ["Offset of field: _GETVERSIONINPARAMS::dwReserved"]
        [::std::mem::offset_of!(_GETVERSIONINPARAMS, dwReserved) - 8usize];
};
pub type GETVERSIONINPARAMS = _GETVERSIONINPARAMS;
pub type PGETVERSIONINPARAMS = *mut _GETVERSIONINPARAMS;
pub type LPGETVERSIONINPARAMS = *mut _GETVERSIONINPARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IDEREGS {
    pub bFeaturesReg: BYTE,
    pub bSectorCountReg: BYTE,
    pub bSectorNumberReg: BYTE,
    pub bCylLowReg: BYTE,
    pub bCylHighReg: BYTE,
    pub bDriveHeadReg: BYTE,
    pub bCommandReg: BYTE,
    pub bReserved: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IDEREGS"][::std::mem::size_of::<_IDEREGS>() - 8usize];
    ["Alignment of _IDEREGS"][::std::mem::align_of::<_IDEREGS>() - 1usize];
    ["Offset of field: _IDEREGS::bFeaturesReg"]
        [::std::mem::offset_of!(_IDEREGS, bFeaturesReg) - 0usize];
    ["Offset of field: _IDEREGS::bSectorCountReg"]
        [::std::mem::offset_of!(_IDEREGS, bSectorCountReg) - 1usize];
    ["Offset of field: _IDEREGS::bSectorNumberReg"]
        [::std::mem::offset_of!(_IDEREGS, bSectorNumberReg) - 2usize];
    ["Offset of field: _IDEREGS::bCylLowReg"]
        [::std::mem::offset_of!(_IDEREGS, bCylLowReg) - 3usize];
    ["Offset of field: _IDEREGS::bCylHighReg"]
        [::std::mem::offset_of!(_IDEREGS, bCylHighReg) - 4usize];
    ["Offset of field: _IDEREGS::bDriveHeadReg"]
        [::std::mem::offset_of!(_IDEREGS, bDriveHeadReg) - 5usize];
    ["Offset of field: _IDEREGS::bCommandReg"]
        [::std::mem::offset_of!(_IDEREGS, bCommandReg) - 6usize];
    ["Offset of field: _IDEREGS::bReserved"][::std::mem::offset_of!(_IDEREGS, bReserved) - 7usize];
};
pub type IDEREGS = _IDEREGS;
pub type PIDEREGS = *mut _IDEREGS;
pub type LPIDEREGS = *mut _IDEREGS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _SENDCMDINPARAMS {
    pub cBufferSize: DWORD,
    pub irDriveRegs: IDEREGS,
    pub bDriveNumber: BYTE,
    pub bReserved: [BYTE; 3usize],
    pub dwReserved: [DWORD; 4usize],
    pub bBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SENDCMDINPARAMS"][::std::mem::size_of::<_SENDCMDINPARAMS>() - 33usize];
    ["Alignment of _SENDCMDINPARAMS"][::std::mem::align_of::<_SENDCMDINPARAMS>() - 1usize];
    ["Offset of field: _SENDCMDINPARAMS::cBufferSize"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, cBufferSize) - 0usize];
    ["Offset of field: _SENDCMDINPARAMS::irDriveRegs"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, irDriveRegs) - 4usize];
    ["Offset of field: _SENDCMDINPARAMS::bDriveNumber"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, bDriveNumber) - 12usize];
    ["Offset of field: _SENDCMDINPARAMS::bReserved"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, bReserved) - 13usize];
    ["Offset of field: _SENDCMDINPARAMS::dwReserved"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, dwReserved) - 16usize];
    ["Offset of field: _SENDCMDINPARAMS::bBuffer"]
        [::std::mem::offset_of!(_SENDCMDINPARAMS, bBuffer) - 32usize];
};
pub type SENDCMDINPARAMS = _SENDCMDINPARAMS;
pub type PSENDCMDINPARAMS = *mut _SENDCMDINPARAMS;
pub type LPSENDCMDINPARAMS = *mut _SENDCMDINPARAMS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVERSTATUS {
    pub bDriverError: BYTE,
    pub bIDEError: BYTE,
    pub bReserved: [BYTE; 2usize],
    pub dwReserved: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVERSTATUS"][::std::mem::size_of::<_DRIVERSTATUS>() - 12usize];
    ["Alignment of _DRIVERSTATUS"][::std::mem::align_of::<_DRIVERSTATUS>() - 1usize];
    ["Offset of field: _DRIVERSTATUS::bDriverError"]
        [::std::mem::offset_of!(_DRIVERSTATUS, bDriverError) - 0usize];
    ["Offset of field: _DRIVERSTATUS::bIDEError"]
        [::std::mem::offset_of!(_DRIVERSTATUS, bIDEError) - 1usize];
    ["Offset of field: _DRIVERSTATUS::bReserved"]
        [::std::mem::offset_of!(_DRIVERSTATUS, bReserved) - 2usize];
    ["Offset of field: _DRIVERSTATUS::dwReserved"]
        [::std::mem::offset_of!(_DRIVERSTATUS, dwReserved) - 4usize];
};
pub type DRIVERSTATUS = _DRIVERSTATUS;
pub type PDRIVERSTATUS = *mut _DRIVERSTATUS;
pub type LPDRIVERSTATUS = *mut _DRIVERSTATUS;
#[repr(C, packed)]
#[derive(Debug, Copy, Clone)]
pub struct _SENDCMDOUTPARAMS {
    pub cBufferSize: DWORD,
    pub DriverStatus: DRIVERSTATUS,
    pub bBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SENDCMDOUTPARAMS"][::std::mem::size_of::<_SENDCMDOUTPARAMS>() - 17usize];
    ["Alignment of _SENDCMDOUTPARAMS"][::std::mem::align_of::<_SENDCMDOUTPARAMS>() - 1usize];
    ["Offset of field: _SENDCMDOUTPARAMS::cBufferSize"]
        [::std::mem::offset_of!(_SENDCMDOUTPARAMS, cBufferSize) - 0usize];
    ["Offset of field: _SENDCMDOUTPARAMS::DriverStatus"]
        [::std::mem::offset_of!(_SENDCMDOUTPARAMS, DriverStatus) - 4usize];
    ["Offset of field: _SENDCMDOUTPARAMS::bBuffer"]
        [::std::mem::offset_of!(_SENDCMDOUTPARAMS, bBuffer) - 16usize];
};
pub type SENDCMDOUTPARAMS = _SENDCMDOUTPARAMS;
pub type PSENDCMDOUTPARAMS = *mut _SENDCMDOUTPARAMS;
pub type LPSENDCMDOUTPARAMS = *mut _SENDCMDOUTPARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GET_DISK_ATTRIBUTES {
    pub Version: DWORD,
    pub Reserved1: DWORD,
    pub Attributes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_DISK_ATTRIBUTES"][::std::mem::size_of::<_GET_DISK_ATTRIBUTES>() - 16usize];
    ["Alignment of _GET_DISK_ATTRIBUTES"][::std::mem::align_of::<_GET_DISK_ATTRIBUTES>() - 8usize];
    ["Offset of field: _GET_DISK_ATTRIBUTES::Version"]
        [::std::mem::offset_of!(_GET_DISK_ATTRIBUTES, Version) - 0usize];
    ["Offset of field: _GET_DISK_ATTRIBUTES::Reserved1"]
        [::std::mem::offset_of!(_GET_DISK_ATTRIBUTES, Reserved1) - 4usize];
    ["Offset of field: _GET_DISK_ATTRIBUTES::Attributes"]
        [::std::mem::offset_of!(_GET_DISK_ATTRIBUTES, Attributes) - 8usize];
};
pub type GET_DISK_ATTRIBUTES = _GET_DISK_ATTRIBUTES;
pub type PGET_DISK_ATTRIBUTES = *mut _GET_DISK_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SET_DISK_ATTRIBUTES {
    pub Version: DWORD,
    pub Persist: BOOLEAN,
    pub Reserved1: [BYTE; 3usize],
    pub Attributes: DWORDLONG,
    pub AttributesMask: DWORDLONG,
    pub Reserved2: [DWORD; 4usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_DISK_ATTRIBUTES"][::std::mem::size_of::<_SET_DISK_ATTRIBUTES>() - 40usize];
    ["Alignment of _SET_DISK_ATTRIBUTES"][::std::mem::align_of::<_SET_DISK_ATTRIBUTES>() - 8usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::Version"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, Version) - 0usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::Persist"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, Persist) - 4usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::Reserved1"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, Reserved1) - 5usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::Attributes"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, Attributes) - 8usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::AttributesMask"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, AttributesMask) - 16usize];
    ["Offset of field: _SET_DISK_ATTRIBUTES::Reserved2"]
        [::std::mem::offset_of!(_SET_DISK_ATTRIBUTES, Reserved2) - 24usize];
};
pub type SET_DISK_ATTRIBUTES = _SET_DISK_ATTRIBUTES;
pub type PSET_DISK_ATTRIBUTES = *mut _SET_DISK_ATTRIBUTES;
pub const _ELEMENT_TYPE_AllElements: _ELEMENT_TYPE = 0;
pub const _ELEMENT_TYPE_ChangerTransport: _ELEMENT_TYPE = 1;
pub const _ELEMENT_TYPE_ChangerSlot: _ELEMENT_TYPE = 2;
pub const _ELEMENT_TYPE_ChangerIEPort: _ELEMENT_TYPE = 3;
pub const _ELEMENT_TYPE_ChangerDrive: _ELEMENT_TYPE = 4;
pub const _ELEMENT_TYPE_ChangerDoor: _ELEMENT_TYPE = 5;
pub const _ELEMENT_TYPE_ChangerKeypad: _ELEMENT_TYPE = 6;
pub const _ELEMENT_TYPE_ChangerMaxElement: _ELEMENT_TYPE = 7;
pub type _ELEMENT_TYPE = ::std::os::raw::c_int;
pub use self::_ELEMENT_TYPE as ELEMENT_TYPE;
pub type PELEMENT_TYPE = *mut _ELEMENT_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_ELEMENT {
    pub ElementType: ELEMENT_TYPE,
    pub ElementAddress: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_ELEMENT"][::std::mem::size_of::<_CHANGER_ELEMENT>() - 8usize];
    ["Alignment of _CHANGER_ELEMENT"][::std::mem::align_of::<_CHANGER_ELEMENT>() - 4usize];
    ["Offset of field: _CHANGER_ELEMENT::ElementType"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT, ElementType) - 0usize];
    ["Offset of field: _CHANGER_ELEMENT::ElementAddress"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT, ElementAddress) - 4usize];
};
pub type CHANGER_ELEMENT = _CHANGER_ELEMENT;
pub type PCHANGER_ELEMENT = *mut _CHANGER_ELEMENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_ELEMENT_LIST {
    pub Element: CHANGER_ELEMENT,
    pub NumberOfElements: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_ELEMENT_LIST"][::std::mem::size_of::<_CHANGER_ELEMENT_LIST>() - 12usize];
    ["Alignment of _CHANGER_ELEMENT_LIST"]
        [::std::mem::align_of::<_CHANGER_ELEMENT_LIST>() - 4usize];
    ["Offset of field: _CHANGER_ELEMENT_LIST::Element"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_LIST, Element) - 0usize];
    ["Offset of field: _CHANGER_ELEMENT_LIST::NumberOfElements"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_LIST, NumberOfElements) - 8usize];
};
pub type CHANGER_ELEMENT_LIST = _CHANGER_ELEMENT_LIST;
pub type PCHANGER_ELEMENT_LIST = *mut _CHANGER_ELEMENT_LIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GET_CHANGER_PARAMETERS {
    pub Size: DWORD,
    pub NumberTransportElements: WORD,
    pub NumberStorageElements: WORD,
    pub NumberCleanerSlots: WORD,
    pub NumberIEElements: WORD,
    pub NumberDataTransferElements: WORD,
    pub NumberOfDoors: WORD,
    pub FirstSlotNumber: WORD,
    pub FirstDriveNumber: WORD,
    pub FirstTransportNumber: WORD,
    pub FirstIEPortNumber: WORD,
    pub FirstCleanerSlotAddress: WORD,
    pub MagazineSize: WORD,
    pub DriveCleanTimeout: DWORD,
    pub Features0: DWORD,
    pub Features1: DWORD,
    pub MoveFromTransport: BYTE,
    pub MoveFromSlot: BYTE,
    pub MoveFromIePort: BYTE,
    pub MoveFromDrive: BYTE,
    pub ExchangeFromTransport: BYTE,
    pub ExchangeFromSlot: BYTE,
    pub ExchangeFromIePort: BYTE,
    pub ExchangeFromDrive: BYTE,
    pub LockUnlockCapabilities: BYTE,
    pub PositionCapabilities: BYTE,
    pub Reserved1: [BYTE; 2usize],
    pub Reserved2: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_CHANGER_PARAMETERS"][::std::mem::size_of::<_GET_CHANGER_PARAMETERS>() - 60usize];
    ["Alignment of _GET_CHANGER_PARAMETERS"]
        [::std::mem::align_of::<_GET_CHANGER_PARAMETERS>() - 4usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::Size"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, Size) - 0usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberTransportElements"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberTransportElements) - 4usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberStorageElements"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberStorageElements) - 6usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberCleanerSlots"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberCleanerSlots) - 8usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberIEElements"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberIEElements) - 10usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberDataTransferElements"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberDataTransferElements) - 12usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::NumberOfDoors"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, NumberOfDoors) - 14usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::FirstSlotNumber"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, FirstSlotNumber) - 16usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::FirstDriveNumber"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, FirstDriveNumber) - 18usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::FirstTransportNumber"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, FirstTransportNumber) - 20usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::FirstIEPortNumber"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, FirstIEPortNumber) - 22usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::FirstCleanerSlotAddress"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, FirstCleanerSlotAddress) - 24usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::MagazineSize"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, MagazineSize) - 26usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::DriveCleanTimeout"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, DriveCleanTimeout) - 28usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::Features0"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, Features0) - 32usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::Features1"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, Features1) - 36usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::MoveFromTransport"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, MoveFromTransport) - 40usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::MoveFromSlot"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, MoveFromSlot) - 41usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::MoveFromIePort"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, MoveFromIePort) - 42usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::MoveFromDrive"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, MoveFromDrive) - 43usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::ExchangeFromTransport"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, ExchangeFromTransport) - 44usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::ExchangeFromSlot"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, ExchangeFromSlot) - 45usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::ExchangeFromIePort"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, ExchangeFromIePort) - 46usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::ExchangeFromDrive"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, ExchangeFromDrive) - 47usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::LockUnlockCapabilities"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, LockUnlockCapabilities) - 48usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::PositionCapabilities"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, PositionCapabilities) - 49usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::Reserved1"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, Reserved1) - 50usize];
    ["Offset of field: _GET_CHANGER_PARAMETERS::Reserved2"]
        [::std::mem::offset_of!(_GET_CHANGER_PARAMETERS, Reserved2) - 52usize];
};
pub type GET_CHANGER_PARAMETERS = _GET_CHANGER_PARAMETERS;
pub type PGET_CHANGER_PARAMETERS = *mut _GET_CHANGER_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_PRODUCT_DATA {
    pub VendorId: [BYTE; 8usize],
    pub ProductId: [BYTE; 16usize],
    pub Revision: [BYTE; 4usize],
    pub SerialNumber: [BYTE; 32usize],
    pub DeviceType: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_PRODUCT_DATA"][::std::mem::size_of::<_CHANGER_PRODUCT_DATA>() - 61usize];
    ["Alignment of _CHANGER_PRODUCT_DATA"]
        [::std::mem::align_of::<_CHANGER_PRODUCT_DATA>() - 1usize];
    ["Offset of field: _CHANGER_PRODUCT_DATA::VendorId"]
        [::std::mem::offset_of!(_CHANGER_PRODUCT_DATA, VendorId) - 0usize];
    ["Offset of field: _CHANGER_PRODUCT_DATA::ProductId"]
        [::std::mem::offset_of!(_CHANGER_PRODUCT_DATA, ProductId) - 8usize];
    ["Offset of field: _CHANGER_PRODUCT_DATA::Revision"]
        [::std::mem::offset_of!(_CHANGER_PRODUCT_DATA, Revision) - 24usize];
    ["Offset of field: _CHANGER_PRODUCT_DATA::SerialNumber"]
        [::std::mem::offset_of!(_CHANGER_PRODUCT_DATA, SerialNumber) - 28usize];
    ["Offset of field: _CHANGER_PRODUCT_DATA::DeviceType"]
        [::std::mem::offset_of!(_CHANGER_PRODUCT_DATA, DeviceType) - 60usize];
};
pub type CHANGER_PRODUCT_DATA = _CHANGER_PRODUCT_DATA;
pub type PCHANGER_PRODUCT_DATA = *mut _CHANGER_PRODUCT_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_SET_ACCESS {
    pub Element: CHANGER_ELEMENT,
    pub Control: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_SET_ACCESS"][::std::mem::size_of::<_CHANGER_SET_ACCESS>() - 12usize];
    ["Alignment of _CHANGER_SET_ACCESS"][::std::mem::align_of::<_CHANGER_SET_ACCESS>() - 4usize];
    ["Offset of field: _CHANGER_SET_ACCESS::Element"]
        [::std::mem::offset_of!(_CHANGER_SET_ACCESS, Element) - 0usize];
    ["Offset of field: _CHANGER_SET_ACCESS::Control"]
        [::std::mem::offset_of!(_CHANGER_SET_ACCESS, Control) - 8usize];
};
pub type CHANGER_SET_ACCESS = _CHANGER_SET_ACCESS;
pub type PCHANGER_SET_ACCESS = *mut _CHANGER_SET_ACCESS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_READ_ELEMENT_STATUS {
    pub ElementList: CHANGER_ELEMENT_LIST,
    pub VolumeTagInfo: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_READ_ELEMENT_STATUS"]
        [::std::mem::size_of::<_CHANGER_READ_ELEMENT_STATUS>() - 16usize];
    ["Alignment of _CHANGER_READ_ELEMENT_STATUS"]
        [::std::mem::align_of::<_CHANGER_READ_ELEMENT_STATUS>() - 4usize];
    ["Offset of field: _CHANGER_READ_ELEMENT_STATUS::ElementList"]
        [::std::mem::offset_of!(_CHANGER_READ_ELEMENT_STATUS, ElementList) - 0usize];
    ["Offset of field: _CHANGER_READ_ELEMENT_STATUS::VolumeTagInfo"]
        [::std::mem::offset_of!(_CHANGER_READ_ELEMENT_STATUS, VolumeTagInfo) - 12usize];
};
pub type CHANGER_READ_ELEMENT_STATUS = _CHANGER_READ_ELEMENT_STATUS;
pub type PCHANGER_READ_ELEMENT_STATUS = *mut _CHANGER_READ_ELEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_ELEMENT_STATUS {
    pub Element: CHANGER_ELEMENT,
    pub SrcElementAddress: CHANGER_ELEMENT,
    pub Flags: DWORD,
    pub ExceptionCode: DWORD,
    pub TargetId: BYTE,
    pub Lun: BYTE,
    pub Reserved: WORD,
    pub PrimaryVolumeID: [BYTE; 36usize],
    pub AlternateVolumeID: [BYTE; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_ELEMENT_STATUS"]
        [::std::mem::size_of::<_CHANGER_ELEMENT_STATUS>() - 100usize];
    ["Alignment of _CHANGER_ELEMENT_STATUS"]
        [::std::mem::align_of::<_CHANGER_ELEMENT_STATUS>() - 4usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::Element"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, Element) - 0usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::SrcElementAddress"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, SrcElementAddress) - 8usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::Flags"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, Flags) - 16usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::ExceptionCode"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, ExceptionCode) - 20usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::TargetId"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, TargetId) - 24usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::Lun"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, Lun) - 25usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::Reserved"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, Reserved) - 26usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::PrimaryVolumeID"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, PrimaryVolumeID) - 28usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS::AlternateVolumeID"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS, AlternateVolumeID) - 64usize];
};
pub type CHANGER_ELEMENT_STATUS = _CHANGER_ELEMENT_STATUS;
pub type PCHANGER_ELEMENT_STATUS = *mut _CHANGER_ELEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_ELEMENT_STATUS_EX {
    pub Element: CHANGER_ELEMENT,
    pub SrcElementAddress: CHANGER_ELEMENT,
    pub Flags: DWORD,
    pub ExceptionCode: DWORD,
    pub TargetId: BYTE,
    pub Lun: BYTE,
    pub Reserved: WORD,
    pub PrimaryVolumeID: [BYTE; 36usize],
    pub AlternateVolumeID: [BYTE; 36usize],
    pub VendorIdentification: [BYTE; 8usize],
    pub ProductIdentification: [BYTE; 16usize],
    pub SerialNumber: [BYTE; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_ELEMENT_STATUS_EX"]
        [::std::mem::size_of::<_CHANGER_ELEMENT_STATUS_EX>() - 156usize];
    ["Alignment of _CHANGER_ELEMENT_STATUS_EX"]
        [::std::mem::align_of::<_CHANGER_ELEMENT_STATUS_EX>() - 4usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::Element"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, Element) - 0usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::SrcElementAddress"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, SrcElementAddress) - 8usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::Flags"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, Flags) - 16usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::ExceptionCode"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, ExceptionCode) - 20usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::TargetId"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, TargetId) - 24usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::Lun"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, Lun) - 25usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::Reserved"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, Reserved) - 26usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::PrimaryVolumeID"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, PrimaryVolumeID) - 28usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::AlternateVolumeID"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, AlternateVolumeID) - 64usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::VendorIdentification"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, VendorIdentification) - 100usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::ProductIdentification"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, ProductIdentification) - 108usize];
    ["Offset of field: _CHANGER_ELEMENT_STATUS_EX::SerialNumber"]
        [::std::mem::offset_of!(_CHANGER_ELEMENT_STATUS_EX, SerialNumber) - 124usize];
};
pub type CHANGER_ELEMENT_STATUS_EX = _CHANGER_ELEMENT_STATUS_EX;
pub type PCHANGER_ELEMENT_STATUS_EX = *mut _CHANGER_ELEMENT_STATUS_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_INITIALIZE_ELEMENT_STATUS {
    pub ElementList: CHANGER_ELEMENT_LIST,
    pub BarCodeScan: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_INITIALIZE_ELEMENT_STATUS"]
        [::std::mem::size_of::<_CHANGER_INITIALIZE_ELEMENT_STATUS>() - 16usize];
    ["Alignment of _CHANGER_INITIALIZE_ELEMENT_STATUS"]
        [::std::mem::align_of::<_CHANGER_INITIALIZE_ELEMENT_STATUS>() - 4usize];
    ["Offset of field: _CHANGER_INITIALIZE_ELEMENT_STATUS::ElementList"]
        [::std::mem::offset_of!(_CHANGER_INITIALIZE_ELEMENT_STATUS, ElementList) - 0usize];
    ["Offset of field: _CHANGER_INITIALIZE_ELEMENT_STATUS::BarCodeScan"]
        [::std::mem::offset_of!(_CHANGER_INITIALIZE_ELEMENT_STATUS, BarCodeScan) - 12usize];
};
pub type CHANGER_INITIALIZE_ELEMENT_STATUS = _CHANGER_INITIALIZE_ELEMENT_STATUS;
pub type PCHANGER_INITIALIZE_ELEMENT_STATUS = *mut _CHANGER_INITIALIZE_ELEMENT_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_SET_POSITION {
    pub Transport: CHANGER_ELEMENT,
    pub Destination: CHANGER_ELEMENT,
    pub Flip: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_SET_POSITION"][::std::mem::size_of::<_CHANGER_SET_POSITION>() - 20usize];
    ["Alignment of _CHANGER_SET_POSITION"]
        [::std::mem::align_of::<_CHANGER_SET_POSITION>() - 4usize];
    ["Offset of field: _CHANGER_SET_POSITION::Transport"]
        [::std::mem::offset_of!(_CHANGER_SET_POSITION, Transport) - 0usize];
    ["Offset of field: _CHANGER_SET_POSITION::Destination"]
        [::std::mem::offset_of!(_CHANGER_SET_POSITION, Destination) - 8usize];
    ["Offset of field: _CHANGER_SET_POSITION::Flip"]
        [::std::mem::offset_of!(_CHANGER_SET_POSITION, Flip) - 16usize];
};
pub type CHANGER_SET_POSITION = _CHANGER_SET_POSITION;
pub type PCHANGER_SET_POSITION = *mut _CHANGER_SET_POSITION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_EXCHANGE_MEDIUM {
    pub Transport: CHANGER_ELEMENT,
    pub Source: CHANGER_ELEMENT,
    pub Destination1: CHANGER_ELEMENT,
    pub Destination2: CHANGER_ELEMENT,
    pub Flip1: BOOLEAN,
    pub Flip2: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_EXCHANGE_MEDIUM"]
        [::std::mem::size_of::<_CHANGER_EXCHANGE_MEDIUM>() - 36usize];
    ["Alignment of _CHANGER_EXCHANGE_MEDIUM"]
        [::std::mem::align_of::<_CHANGER_EXCHANGE_MEDIUM>() - 4usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Transport"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Transport) - 0usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Source"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Source) - 8usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Destination1"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Destination1) - 16usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Destination2"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Destination2) - 24usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Flip1"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Flip1) - 32usize];
    ["Offset of field: _CHANGER_EXCHANGE_MEDIUM::Flip2"]
        [::std::mem::offset_of!(_CHANGER_EXCHANGE_MEDIUM, Flip2) - 33usize];
};
pub type CHANGER_EXCHANGE_MEDIUM = _CHANGER_EXCHANGE_MEDIUM;
pub type PCHANGER_EXCHANGE_MEDIUM = *mut _CHANGER_EXCHANGE_MEDIUM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_MOVE_MEDIUM {
    pub Transport: CHANGER_ELEMENT,
    pub Source: CHANGER_ELEMENT,
    pub Destination: CHANGER_ELEMENT,
    pub Flip: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_MOVE_MEDIUM"][::std::mem::size_of::<_CHANGER_MOVE_MEDIUM>() - 28usize];
    ["Alignment of _CHANGER_MOVE_MEDIUM"][::std::mem::align_of::<_CHANGER_MOVE_MEDIUM>() - 4usize];
    ["Offset of field: _CHANGER_MOVE_MEDIUM::Transport"]
        [::std::mem::offset_of!(_CHANGER_MOVE_MEDIUM, Transport) - 0usize];
    ["Offset of field: _CHANGER_MOVE_MEDIUM::Source"]
        [::std::mem::offset_of!(_CHANGER_MOVE_MEDIUM, Source) - 8usize];
    ["Offset of field: _CHANGER_MOVE_MEDIUM::Destination"]
        [::std::mem::offset_of!(_CHANGER_MOVE_MEDIUM, Destination) - 16usize];
    ["Offset of field: _CHANGER_MOVE_MEDIUM::Flip"]
        [::std::mem::offset_of!(_CHANGER_MOVE_MEDIUM, Flip) - 24usize];
};
pub type CHANGER_MOVE_MEDIUM = _CHANGER_MOVE_MEDIUM;
pub type PCHANGER_MOVE_MEDIUM = *mut _CHANGER_MOVE_MEDIUM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CHANGER_SEND_VOLUME_TAG_INFORMATION {
    pub StartingElement: CHANGER_ELEMENT,
    pub ActionCode: DWORD,
    pub VolumeIDTemplate: [BYTE; 40usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CHANGER_SEND_VOLUME_TAG_INFORMATION"]
        [::std::mem::size_of::<_CHANGER_SEND_VOLUME_TAG_INFORMATION>() - 52usize];
    ["Alignment of _CHANGER_SEND_VOLUME_TAG_INFORMATION"]
        [::std::mem::align_of::<_CHANGER_SEND_VOLUME_TAG_INFORMATION>() - 4usize];
    ["Offset of field: _CHANGER_SEND_VOLUME_TAG_INFORMATION::StartingElement"]
        [::std::mem::offset_of!(_CHANGER_SEND_VOLUME_TAG_INFORMATION, StartingElement) - 0usize];
    ["Offset of field: _CHANGER_SEND_VOLUME_TAG_INFORMATION::ActionCode"]
        [::std::mem::offset_of!(_CHANGER_SEND_VOLUME_TAG_INFORMATION, ActionCode) - 8usize];
    ["Offset of field: _CHANGER_SEND_VOLUME_TAG_INFORMATION::VolumeIDTemplate"]
        [::std::mem::offset_of!(_CHANGER_SEND_VOLUME_TAG_INFORMATION, VolumeIDTemplate) - 12usize];
};
pub type CHANGER_SEND_VOLUME_TAG_INFORMATION = _CHANGER_SEND_VOLUME_TAG_INFORMATION;
pub type PCHANGER_SEND_VOLUME_TAG_INFORMATION = *mut _CHANGER_SEND_VOLUME_TAG_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _READ_ELEMENT_ADDRESS_INFO {
    pub NumberOfElements: DWORD,
    pub ElementStatus: [CHANGER_ELEMENT_STATUS; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _READ_ELEMENT_ADDRESS_INFO"]
        [::std::mem::size_of::<_READ_ELEMENT_ADDRESS_INFO>() - 104usize];
    ["Alignment of _READ_ELEMENT_ADDRESS_INFO"]
        [::std::mem::align_of::<_READ_ELEMENT_ADDRESS_INFO>() - 4usize];
    ["Offset of field: _READ_ELEMENT_ADDRESS_INFO::NumberOfElements"]
        [::std::mem::offset_of!(_READ_ELEMENT_ADDRESS_INFO, NumberOfElements) - 0usize];
    ["Offset of field: _READ_ELEMENT_ADDRESS_INFO::ElementStatus"]
        [::std::mem::offset_of!(_READ_ELEMENT_ADDRESS_INFO, ElementStatus) - 4usize];
};
pub type READ_ELEMENT_ADDRESS_INFO = _READ_ELEMENT_ADDRESS_INFO;
pub type PREAD_ELEMENT_ADDRESS_INFO = *mut _READ_ELEMENT_ADDRESS_INFO;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemNone: _CHANGER_DEVICE_PROBLEM_TYPE = 0;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemHardware: _CHANGER_DEVICE_PROBLEM_TYPE = 1;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCHMError: _CHANGER_DEVICE_PROBLEM_TYPE = 2;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemDoorOpen: _CHANGER_DEVICE_PROBLEM_TYPE = 3;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCalibrationError: _CHANGER_DEVICE_PROBLEM_TYPE =
    4;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemTargetFailure: _CHANGER_DEVICE_PROBLEM_TYPE = 5;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCHMMoveError: _CHANGER_DEVICE_PROBLEM_TYPE = 6;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCHMZeroError: _CHANGER_DEVICE_PROBLEM_TYPE = 7;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCartridgeInsertError:
    _CHANGER_DEVICE_PROBLEM_TYPE = 8;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemPositionError: _CHANGER_DEVICE_PROBLEM_TYPE = 9;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemSensorError: _CHANGER_DEVICE_PROBLEM_TYPE = 10;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemCartridgeEjectError:
    _CHANGER_DEVICE_PROBLEM_TYPE = 11;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemGripperError: _CHANGER_DEVICE_PROBLEM_TYPE = 12;
pub const _CHANGER_DEVICE_PROBLEM_TYPE_DeviceProblemDriveError: _CHANGER_DEVICE_PROBLEM_TYPE = 13;
pub type _CHANGER_DEVICE_PROBLEM_TYPE = ::std::os::raw::c_int;
pub use self::_CHANGER_DEVICE_PROBLEM_TYPE as CHANGER_DEVICE_PROBLEM_TYPE;
pub type PCHANGER_DEVICE_PROBLEM_TYPE = *mut _CHANGER_DEVICE_PROBLEM_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PATHNAME_BUFFER {
    pub PathNameLength: DWORD,
    pub Name: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PATHNAME_BUFFER"][::std::mem::size_of::<_PATHNAME_BUFFER>() - 8usize];
    ["Alignment of _PATHNAME_BUFFER"][::std::mem::align_of::<_PATHNAME_BUFFER>() - 4usize];
    ["Offset of field: _PATHNAME_BUFFER::PathNameLength"]
        [::std::mem::offset_of!(_PATHNAME_BUFFER, PathNameLength) - 0usize];
    ["Offset of field: _PATHNAME_BUFFER::Name"]
        [::std::mem::offset_of!(_PATHNAME_BUFFER, Name) - 4usize];
};
pub type PATHNAME_BUFFER = _PATHNAME_BUFFER;
pub type PPATHNAME_BUFFER = *mut _PATHNAME_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_QUERY_FAT_BPB_BUFFER {
    pub First0x24BytesOfBootSector: [BYTE; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_QUERY_FAT_BPB_BUFFER"]
        [::std::mem::size_of::<_FSCTL_QUERY_FAT_BPB_BUFFER>() - 36usize];
    ["Alignment of _FSCTL_QUERY_FAT_BPB_BUFFER"]
        [::std::mem::align_of::<_FSCTL_QUERY_FAT_BPB_BUFFER>() - 1usize];
    ["Offset of field: _FSCTL_QUERY_FAT_BPB_BUFFER::First0x24BytesOfBootSector"]
        [::std::mem::offset_of!(_FSCTL_QUERY_FAT_BPB_BUFFER, First0x24BytesOfBootSector) - 0usize];
};
pub type FSCTL_QUERY_FAT_BPB_BUFFER = _FSCTL_QUERY_FAT_BPB_BUFFER;
pub type PFSCTL_QUERY_FAT_BPB_BUFFER = *mut _FSCTL_QUERY_FAT_BPB_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct NTFS_VOLUME_DATA_BUFFER {
    pub VolumeSerialNumber: LARGE_INTEGER,
    pub NumberSectors: LARGE_INTEGER,
    pub TotalClusters: LARGE_INTEGER,
    pub FreeClusters: LARGE_INTEGER,
    pub TotalReserved: LARGE_INTEGER,
    pub BytesPerSector: DWORD,
    pub BytesPerCluster: DWORD,
    pub BytesPerFileRecordSegment: DWORD,
    pub ClustersPerFileRecordSegment: DWORD,
    pub MftValidDataLength: LARGE_INTEGER,
    pub MftStartLcn: LARGE_INTEGER,
    pub Mft2StartLcn: LARGE_INTEGER,
    pub MftZoneStart: LARGE_INTEGER,
    pub MftZoneEnd: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NTFS_VOLUME_DATA_BUFFER"][::std::mem::size_of::<NTFS_VOLUME_DATA_BUFFER>() - 96usize];
    ["Alignment of NTFS_VOLUME_DATA_BUFFER"]
        [::std::mem::align_of::<NTFS_VOLUME_DATA_BUFFER>() - 8usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::VolumeSerialNumber"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, VolumeSerialNumber) - 0usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::NumberSectors"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, NumberSectors) - 8usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::TotalClusters"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, TotalClusters) - 16usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::FreeClusters"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, FreeClusters) - 24usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::TotalReserved"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, TotalReserved) - 32usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::BytesPerSector"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, BytesPerSector) - 40usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::BytesPerCluster"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, BytesPerCluster) - 44usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::BytesPerFileRecordSegment"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, BytesPerFileRecordSegment) - 48usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::ClustersPerFileRecordSegment"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, ClustersPerFileRecordSegment) - 52usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::MftValidDataLength"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, MftValidDataLength) - 56usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::MftStartLcn"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, MftStartLcn) - 64usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::Mft2StartLcn"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, Mft2StartLcn) - 72usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::MftZoneStart"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, MftZoneStart) - 80usize];
    ["Offset of field: NTFS_VOLUME_DATA_BUFFER::MftZoneEnd"]
        [::std::mem::offset_of!(NTFS_VOLUME_DATA_BUFFER, MftZoneEnd) - 88usize];
};
pub type PNTFS_VOLUME_DATA_BUFFER = *mut NTFS_VOLUME_DATA_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NTFS_EXTENDED_VOLUME_DATA {
    pub ByteCount: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub BytesPerPhysicalSector: DWORD,
    pub LfsMajorVersion: WORD,
    pub LfsMinorVersion: WORD,
    pub MaxDeviceTrimExtentCount: DWORD,
    pub MaxDeviceTrimByteCount: DWORD,
    pub MaxVolumeTrimExtentCount: DWORD,
    pub MaxVolumeTrimByteCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NTFS_EXTENDED_VOLUME_DATA"]
        [::std::mem::size_of::<NTFS_EXTENDED_VOLUME_DATA>() - 32usize];
    ["Alignment of NTFS_EXTENDED_VOLUME_DATA"]
        [::std::mem::align_of::<NTFS_EXTENDED_VOLUME_DATA>() - 4usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::ByteCount"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, ByteCount) - 0usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MajorVersion"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MajorVersion) - 4usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MinorVersion"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MinorVersion) - 6usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::BytesPerPhysicalSector"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, BytesPerPhysicalSector) - 8usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::LfsMajorVersion"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, LfsMajorVersion) - 12usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::LfsMinorVersion"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, LfsMinorVersion) - 14usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MaxDeviceTrimExtentCount"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MaxDeviceTrimExtentCount) - 16usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MaxDeviceTrimByteCount"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MaxDeviceTrimByteCount) - 20usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MaxVolumeTrimExtentCount"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MaxVolumeTrimExtentCount) - 24usize];
    ["Offset of field: NTFS_EXTENDED_VOLUME_DATA::MaxVolumeTrimByteCount"]
        [::std::mem::offset_of!(NTFS_EXTENDED_VOLUME_DATA, MaxVolumeTrimByteCount) - 28usize];
};
pub type PNTFS_EXTENDED_VOLUME_DATA = *mut NTFS_EXTENDED_VOLUME_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct REFS_VOLUME_DATA_BUFFER {
    pub ByteCount: DWORD,
    pub MajorVersion: DWORD,
    pub MinorVersion: DWORD,
    pub BytesPerPhysicalSector: DWORD,
    pub VolumeSerialNumber: LARGE_INTEGER,
    pub NumberSectors: LARGE_INTEGER,
    pub TotalClusters: LARGE_INTEGER,
    pub FreeClusters: LARGE_INTEGER,
    pub TotalReserved: LARGE_INTEGER,
    pub BytesPerSector: DWORD,
    pub BytesPerCluster: DWORD,
    pub MaximumSizeOfResidentFile: LARGE_INTEGER,
    pub FastTierDataFillRatio: WORD,
    pub SlowTierDataFillRatio: WORD,
    pub DestagesFastTierToSlowTierRate: DWORD,
    pub Reserved: [LARGE_INTEGER; 9usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of REFS_VOLUME_DATA_BUFFER"]
        [::std::mem::size_of::<REFS_VOLUME_DATA_BUFFER>() - 152usize];
    ["Alignment of REFS_VOLUME_DATA_BUFFER"]
        [::std::mem::align_of::<REFS_VOLUME_DATA_BUFFER>() - 8usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::ByteCount"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, ByteCount) - 0usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::MajorVersion"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, MajorVersion) - 4usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::MinorVersion"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, MinorVersion) - 8usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::BytesPerPhysicalSector"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, BytesPerPhysicalSector) - 12usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::VolumeSerialNumber"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, VolumeSerialNumber) - 16usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::NumberSectors"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, NumberSectors) - 24usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::TotalClusters"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, TotalClusters) - 32usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::FreeClusters"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, FreeClusters) - 40usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::TotalReserved"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, TotalReserved) - 48usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::BytesPerSector"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, BytesPerSector) - 56usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::BytesPerCluster"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, BytesPerCluster) - 60usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::MaximumSizeOfResidentFile"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, MaximumSizeOfResidentFile) - 64usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::FastTierDataFillRatio"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, FastTierDataFillRatio) - 72usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::SlowTierDataFillRatio"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, SlowTierDataFillRatio) - 74usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::DestagesFastTierToSlowTierRate"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, DestagesFastTierToSlowTierRate) - 76usize];
    ["Offset of field: REFS_VOLUME_DATA_BUFFER::Reserved"]
        [::std::mem::offset_of!(REFS_VOLUME_DATA_BUFFER, Reserved) - 80usize];
};
pub type PREFS_VOLUME_DATA_BUFFER = *mut REFS_VOLUME_DATA_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct STARTING_LCN_INPUT_BUFFER {
    pub StartingLcn: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of STARTING_LCN_INPUT_BUFFER"]
        [::std::mem::size_of::<STARTING_LCN_INPUT_BUFFER>() - 8usize];
    ["Alignment of STARTING_LCN_INPUT_BUFFER"]
        [::std::mem::align_of::<STARTING_LCN_INPUT_BUFFER>() - 8usize];
    ["Offset of field: STARTING_LCN_INPUT_BUFFER::StartingLcn"]
        [::std::mem::offset_of!(STARTING_LCN_INPUT_BUFFER, StartingLcn) - 0usize];
};
pub type PSTARTING_LCN_INPUT_BUFFER = *mut STARTING_LCN_INPUT_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct STARTING_LCN_INPUT_BUFFER_EX {
    pub StartingLcn: LARGE_INTEGER,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of STARTING_LCN_INPUT_BUFFER_EX"]
        [::std::mem::size_of::<STARTING_LCN_INPUT_BUFFER_EX>() - 16usize];
    ["Alignment of STARTING_LCN_INPUT_BUFFER_EX"]
        [::std::mem::align_of::<STARTING_LCN_INPUT_BUFFER_EX>() - 8usize];
    ["Offset of field: STARTING_LCN_INPUT_BUFFER_EX::StartingLcn"]
        [::std::mem::offset_of!(STARTING_LCN_INPUT_BUFFER_EX, StartingLcn) - 0usize];
    ["Offset of field: STARTING_LCN_INPUT_BUFFER_EX::Flags"]
        [::std::mem::offset_of!(STARTING_LCN_INPUT_BUFFER_EX, Flags) - 8usize];
};
pub type PSTARTING_LCN_INPUT_BUFFER_EX = *mut STARTING_LCN_INPUT_BUFFER_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct VOLUME_BITMAP_BUFFER {
    pub StartingLcn: LARGE_INTEGER,
    pub BitmapSize: LARGE_INTEGER,
    pub Buffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of VOLUME_BITMAP_BUFFER"][::std::mem::size_of::<VOLUME_BITMAP_BUFFER>() - 24usize];
    ["Alignment of VOLUME_BITMAP_BUFFER"][::std::mem::align_of::<VOLUME_BITMAP_BUFFER>() - 8usize];
    ["Offset of field: VOLUME_BITMAP_BUFFER::StartingLcn"]
        [::std::mem::offset_of!(VOLUME_BITMAP_BUFFER, StartingLcn) - 0usize];
    ["Offset of field: VOLUME_BITMAP_BUFFER::BitmapSize"]
        [::std::mem::offset_of!(VOLUME_BITMAP_BUFFER, BitmapSize) - 8usize];
    ["Offset of field: VOLUME_BITMAP_BUFFER::Buffer"]
        [::std::mem::offset_of!(VOLUME_BITMAP_BUFFER, Buffer) - 16usize];
};
pub type PVOLUME_BITMAP_BUFFER = *mut VOLUME_BITMAP_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct STARTING_VCN_INPUT_BUFFER {
    pub StartingVcn: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of STARTING_VCN_INPUT_BUFFER"]
        [::std::mem::size_of::<STARTING_VCN_INPUT_BUFFER>() - 8usize];
    ["Alignment of STARTING_VCN_INPUT_BUFFER"]
        [::std::mem::align_of::<STARTING_VCN_INPUT_BUFFER>() - 8usize];
    ["Offset of field: STARTING_VCN_INPUT_BUFFER::StartingVcn"]
        [::std::mem::offset_of!(STARTING_VCN_INPUT_BUFFER, StartingVcn) - 0usize];
};
pub type PSTARTING_VCN_INPUT_BUFFER = *mut STARTING_VCN_INPUT_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct RETRIEVAL_POINTERS_BUFFER {
    pub ExtentCount: DWORD,
    pub StartingVcn: LARGE_INTEGER,
    pub Extents: [RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1 {
    pub NextVcn: LARGE_INTEGER,
    pub Lcn: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1"]
        [::std::mem::size_of::<RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1>() - 16usize];
    ["Alignment of RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1"]
        [::std::mem::align_of::<RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1>() - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1::NextVcn"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1, NextVcn) - 0usize];
    ["Offset of field: RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1::Lcn"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_BUFFER__bindgen_ty_1, Lcn) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RETRIEVAL_POINTERS_BUFFER"]
        [::std::mem::size_of::<RETRIEVAL_POINTERS_BUFFER>() - 32usize];
    ["Alignment of RETRIEVAL_POINTERS_BUFFER"]
        [::std::mem::align_of::<RETRIEVAL_POINTERS_BUFFER>() - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_BUFFER::ExtentCount"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_BUFFER, ExtentCount) - 0usize];
    ["Offset of field: RETRIEVAL_POINTERS_BUFFER::StartingVcn"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_BUFFER, StartingVcn) - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_BUFFER::Extents"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_BUFFER, Extents) - 16usize];
};
pub type PRETRIEVAL_POINTERS_BUFFER = *mut RETRIEVAL_POINTERS_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER {
    pub ExtentCount: DWORD,
    pub StartingVcn: LARGE_INTEGER,
    pub Extents: [RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1; 1usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1 {
    pub NextVcn: LARGE_INTEGER,
    pub Lcn: LARGE_INTEGER,
    pub ReferenceCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1"]
        [::std::mem::size_of::<RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1>() - 24usize];
    ["Alignment of RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1"]
        [::std::mem::align_of::<RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1>() - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1::NextVcn"][::std::mem::offset_of!(
        RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1,
        NextVcn
    ) - 0usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1::Lcn"][::std::mem::offset_of!(
        RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1,
        Lcn
    ) - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1::ReferenceCount"][::std::mem::offset_of!(
        RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER__bindgen_ty_1,
        ReferenceCount
    )
        - 16usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER"]
        [::std::mem::size_of::<RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER>() - 40usize];
    ["Alignment of RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER"]
        [::std::mem::align_of::<RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER>() - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER::ExtentCount"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER, ExtentCount) - 0usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER::StartingVcn"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER, StartingVcn) - 8usize];
    ["Offset of field: RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER::Extents"]
        [::std::mem::offset_of!(RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER, Extents) - 16usize];
};
pub type PRETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER = *mut RETRIEVAL_POINTERS_AND_REFCOUNT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct RETRIEVAL_POINTER_COUNT {
    pub ExtentCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of RETRIEVAL_POINTER_COUNT"][::std::mem::size_of::<RETRIEVAL_POINTER_COUNT>() - 4usize];
    ["Alignment of RETRIEVAL_POINTER_COUNT"]
        [::std::mem::align_of::<RETRIEVAL_POINTER_COUNT>() - 4usize];
    ["Offset of field: RETRIEVAL_POINTER_COUNT::ExtentCount"]
        [::std::mem::offset_of!(RETRIEVAL_POINTER_COUNT, ExtentCount) - 0usize];
};
pub type PRETRIEVAL_POINTER_COUNT = *mut RETRIEVAL_POINTER_COUNT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct NTFS_FILE_RECORD_INPUT_BUFFER {
    pub FileReferenceNumber: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NTFS_FILE_RECORD_INPUT_BUFFER"]
        [::std::mem::size_of::<NTFS_FILE_RECORD_INPUT_BUFFER>() - 8usize];
    ["Alignment of NTFS_FILE_RECORD_INPUT_BUFFER"]
        [::std::mem::align_of::<NTFS_FILE_RECORD_INPUT_BUFFER>() - 8usize];
    ["Offset of field: NTFS_FILE_RECORD_INPUT_BUFFER::FileReferenceNumber"]
        [::std::mem::offset_of!(NTFS_FILE_RECORD_INPUT_BUFFER, FileReferenceNumber) - 0usize];
};
pub type PNTFS_FILE_RECORD_INPUT_BUFFER = *mut NTFS_FILE_RECORD_INPUT_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct NTFS_FILE_RECORD_OUTPUT_BUFFER {
    pub FileReferenceNumber: LARGE_INTEGER,
    pub FileRecordLength: DWORD,
    pub FileRecordBuffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NTFS_FILE_RECORD_OUTPUT_BUFFER"]
        [::std::mem::size_of::<NTFS_FILE_RECORD_OUTPUT_BUFFER>() - 16usize];
    ["Alignment of NTFS_FILE_RECORD_OUTPUT_BUFFER"]
        [::std::mem::align_of::<NTFS_FILE_RECORD_OUTPUT_BUFFER>() - 8usize];
    ["Offset of field: NTFS_FILE_RECORD_OUTPUT_BUFFER::FileReferenceNumber"]
        [::std::mem::offset_of!(NTFS_FILE_RECORD_OUTPUT_BUFFER, FileReferenceNumber) - 0usize];
    ["Offset of field: NTFS_FILE_RECORD_OUTPUT_BUFFER::FileRecordLength"]
        [::std::mem::offset_of!(NTFS_FILE_RECORD_OUTPUT_BUFFER, FileRecordLength) - 8usize];
    ["Offset of field: NTFS_FILE_RECORD_OUTPUT_BUFFER::FileRecordBuffer"]
        [::std::mem::offset_of!(NTFS_FILE_RECORD_OUTPUT_BUFFER, FileRecordBuffer) - 12usize];
};
pub type PNTFS_FILE_RECORD_OUTPUT_BUFFER = *mut NTFS_FILE_RECORD_OUTPUT_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct MOVE_FILE_DATA {
    pub FileHandle: HANDLE,
    pub StartingVcn: LARGE_INTEGER,
    pub StartingLcn: LARGE_INTEGER,
    pub ClusterCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MOVE_FILE_DATA"][::std::mem::size_of::<MOVE_FILE_DATA>() - 32usize];
    ["Alignment of MOVE_FILE_DATA"][::std::mem::align_of::<MOVE_FILE_DATA>() - 8usize];
    ["Offset of field: MOVE_FILE_DATA::FileHandle"]
        [::std::mem::offset_of!(MOVE_FILE_DATA, FileHandle) - 0usize];
    ["Offset of field: MOVE_FILE_DATA::StartingVcn"]
        [::std::mem::offset_of!(MOVE_FILE_DATA, StartingVcn) - 8usize];
    ["Offset of field: MOVE_FILE_DATA::StartingLcn"]
        [::std::mem::offset_of!(MOVE_FILE_DATA, StartingLcn) - 16usize];
    ["Offset of field: MOVE_FILE_DATA::ClusterCount"]
        [::std::mem::offset_of!(MOVE_FILE_DATA, ClusterCount) - 24usize];
};
pub type PMOVE_FILE_DATA = *mut MOVE_FILE_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct MOVE_FILE_RECORD_DATA {
    pub FileHandle: HANDLE,
    pub SourceFileRecord: LARGE_INTEGER,
    pub TargetFileRecord: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MOVE_FILE_RECORD_DATA"][::std::mem::size_of::<MOVE_FILE_RECORD_DATA>() - 24usize];
    ["Alignment of MOVE_FILE_RECORD_DATA"]
        [::std::mem::align_of::<MOVE_FILE_RECORD_DATA>() - 8usize];
    ["Offset of field: MOVE_FILE_RECORD_DATA::FileHandle"]
        [::std::mem::offset_of!(MOVE_FILE_RECORD_DATA, FileHandle) - 0usize];
    ["Offset of field: MOVE_FILE_RECORD_DATA::SourceFileRecord"]
        [::std::mem::offset_of!(MOVE_FILE_RECORD_DATA, SourceFileRecord) - 8usize];
    ["Offset of field: MOVE_FILE_RECORD_DATA::TargetFileRecord"]
        [::std::mem::offset_of!(MOVE_FILE_RECORD_DATA, TargetFileRecord) - 16usize];
};
pub type PMOVE_FILE_RECORD_DATA = *mut MOVE_FILE_RECORD_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _MOVE_FILE_DATA32 {
    pub FileHandle: UINT32,
    pub StartingVcn: LARGE_INTEGER,
    pub StartingLcn: LARGE_INTEGER,
    pub ClusterCount: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MOVE_FILE_DATA32"][::std::mem::size_of::<_MOVE_FILE_DATA32>() - 32usize];
    ["Alignment of _MOVE_FILE_DATA32"][::std::mem::align_of::<_MOVE_FILE_DATA32>() - 8usize];
    ["Offset of field: _MOVE_FILE_DATA32::FileHandle"]
        [::std::mem::offset_of!(_MOVE_FILE_DATA32, FileHandle) - 0usize];
    ["Offset of field: _MOVE_FILE_DATA32::StartingVcn"]
        [::std::mem::offset_of!(_MOVE_FILE_DATA32, StartingVcn) - 8usize];
    ["Offset of field: _MOVE_FILE_DATA32::StartingLcn"]
        [::std::mem::offset_of!(_MOVE_FILE_DATA32, StartingLcn) - 16usize];
    ["Offset of field: _MOVE_FILE_DATA32::ClusterCount"]
        [::std::mem::offset_of!(_MOVE_FILE_DATA32, ClusterCount) - 24usize];
};
pub type MOVE_FILE_DATA32 = _MOVE_FILE_DATA32;
pub type PMOVE_FILE_DATA32 = *mut _MOVE_FILE_DATA32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct FIND_BY_SID_DATA {
    pub Restart: DWORD,
    pub Sid: SID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of FIND_BY_SID_DATA"][::std::mem::size_of::<FIND_BY_SID_DATA>() - 16usize];
    ["Alignment of FIND_BY_SID_DATA"][::std::mem::align_of::<FIND_BY_SID_DATA>() - 4usize];
    ["Offset of field: FIND_BY_SID_DATA::Restart"]
        [::std::mem::offset_of!(FIND_BY_SID_DATA, Restart) - 0usize];
    ["Offset of field: FIND_BY_SID_DATA::Sid"]
        [::std::mem::offset_of!(FIND_BY_SID_DATA, Sid) - 4usize];
};
pub type PFIND_BY_SID_DATA = *mut FIND_BY_SID_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct FIND_BY_SID_OUTPUT {
    pub NextEntryOffset: DWORD,
    pub FileIndex: DWORD,
    pub FileNameLength: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of FIND_BY_SID_OUTPUT"][::std::mem::size_of::<FIND_BY_SID_OUTPUT>() - 16usize];
    ["Alignment of FIND_BY_SID_OUTPUT"][::std::mem::align_of::<FIND_BY_SID_OUTPUT>() - 4usize];
    ["Offset of field: FIND_BY_SID_OUTPUT::NextEntryOffset"]
        [::std::mem::offset_of!(FIND_BY_SID_OUTPUT, NextEntryOffset) - 0usize];
    ["Offset of field: FIND_BY_SID_OUTPUT::FileIndex"]
        [::std::mem::offset_of!(FIND_BY_SID_OUTPUT, FileIndex) - 4usize];
    ["Offset of field: FIND_BY_SID_OUTPUT::FileNameLength"]
        [::std::mem::offset_of!(FIND_BY_SID_OUTPUT, FileNameLength) - 8usize];
    ["Offset of field: FIND_BY_SID_OUTPUT::FileName"]
        [::std::mem::offset_of!(FIND_BY_SID_OUTPUT, FileName) - 12usize];
};
pub type PFIND_BY_SID_OUTPUT = *mut FIND_BY_SID_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MFT_ENUM_DATA_V0 {
    pub StartFileReferenceNumber: DWORDLONG,
    pub LowUsn: USN,
    pub HighUsn: USN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MFT_ENUM_DATA_V0"][::std::mem::size_of::<MFT_ENUM_DATA_V0>() - 24usize];
    ["Alignment of MFT_ENUM_DATA_V0"][::std::mem::align_of::<MFT_ENUM_DATA_V0>() - 8usize];
    ["Offset of field: MFT_ENUM_DATA_V0::StartFileReferenceNumber"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V0, StartFileReferenceNumber) - 0usize];
    ["Offset of field: MFT_ENUM_DATA_V0::LowUsn"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V0, LowUsn) - 8usize];
    ["Offset of field: MFT_ENUM_DATA_V0::HighUsn"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V0, HighUsn) - 16usize];
};
pub type PMFT_ENUM_DATA_V0 = *mut MFT_ENUM_DATA_V0;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MFT_ENUM_DATA_V1 {
    pub StartFileReferenceNumber: DWORDLONG,
    pub LowUsn: USN,
    pub HighUsn: USN,
    pub MinMajorVersion: WORD,
    pub MaxMajorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MFT_ENUM_DATA_V1"][::std::mem::size_of::<MFT_ENUM_DATA_V1>() - 32usize];
    ["Alignment of MFT_ENUM_DATA_V1"][::std::mem::align_of::<MFT_ENUM_DATA_V1>() - 8usize];
    ["Offset of field: MFT_ENUM_DATA_V1::StartFileReferenceNumber"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V1, StartFileReferenceNumber) - 0usize];
    ["Offset of field: MFT_ENUM_DATA_V1::LowUsn"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V1, LowUsn) - 8usize];
    ["Offset of field: MFT_ENUM_DATA_V1::HighUsn"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V1, HighUsn) - 16usize];
    ["Offset of field: MFT_ENUM_DATA_V1::MinMajorVersion"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V1, MinMajorVersion) - 24usize];
    ["Offset of field: MFT_ENUM_DATA_V1::MaxMajorVersion"]
        [::std::mem::offset_of!(MFT_ENUM_DATA_V1, MaxMajorVersion) - 26usize];
};
pub type PMFT_ENUM_DATA_V1 = *mut MFT_ENUM_DATA_V1;
pub type MFT_ENUM_DATA = MFT_ENUM_DATA_V1;
pub type PMFT_ENUM_DATA = *mut MFT_ENUM_DATA_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CREATE_USN_JOURNAL_DATA {
    pub MaximumSize: DWORDLONG,
    pub AllocationDelta: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CREATE_USN_JOURNAL_DATA"][::std::mem::size_of::<CREATE_USN_JOURNAL_DATA>() - 16usize];
    ["Alignment of CREATE_USN_JOURNAL_DATA"]
        [::std::mem::align_of::<CREATE_USN_JOURNAL_DATA>() - 8usize];
    ["Offset of field: CREATE_USN_JOURNAL_DATA::MaximumSize"]
        [::std::mem::offset_of!(CREATE_USN_JOURNAL_DATA, MaximumSize) - 0usize];
    ["Offset of field: CREATE_USN_JOURNAL_DATA::AllocationDelta"]
        [::std::mem::offset_of!(CREATE_USN_JOURNAL_DATA, AllocationDelta) - 8usize];
};
pub type PCREATE_USN_JOURNAL_DATA = *mut CREATE_USN_JOURNAL_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READ_FILE_USN_DATA {
    pub MinMajorVersion: WORD,
    pub MaxMajorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READ_FILE_USN_DATA"][::std::mem::size_of::<READ_FILE_USN_DATA>() - 4usize];
    ["Alignment of READ_FILE_USN_DATA"][::std::mem::align_of::<READ_FILE_USN_DATA>() - 2usize];
    ["Offset of field: READ_FILE_USN_DATA::MinMajorVersion"]
        [::std::mem::offset_of!(READ_FILE_USN_DATA, MinMajorVersion) - 0usize];
    ["Offset of field: READ_FILE_USN_DATA::MaxMajorVersion"]
        [::std::mem::offset_of!(READ_FILE_USN_DATA, MaxMajorVersion) - 2usize];
};
pub type PREAD_FILE_USN_DATA = *mut READ_FILE_USN_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READ_USN_JOURNAL_DATA_V0 {
    pub StartUsn: USN,
    pub ReasonMask: DWORD,
    pub ReturnOnlyOnClose: DWORD,
    pub Timeout: DWORDLONG,
    pub BytesToWaitFor: DWORDLONG,
    pub UsnJournalID: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READ_USN_JOURNAL_DATA_V0"]
        [::std::mem::size_of::<READ_USN_JOURNAL_DATA_V0>() - 40usize];
    ["Alignment of READ_USN_JOURNAL_DATA_V0"]
        [::std::mem::align_of::<READ_USN_JOURNAL_DATA_V0>() - 8usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::StartUsn"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, StartUsn) - 0usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::ReasonMask"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, ReasonMask) - 8usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::ReturnOnlyOnClose"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, ReturnOnlyOnClose) - 12usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::Timeout"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, Timeout) - 16usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::BytesToWaitFor"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, BytesToWaitFor) - 24usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V0::UsnJournalID"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V0, UsnJournalID) - 32usize];
};
pub type PREAD_USN_JOURNAL_DATA_V0 = *mut READ_USN_JOURNAL_DATA_V0;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READ_USN_JOURNAL_DATA_V1 {
    pub StartUsn: USN,
    pub ReasonMask: DWORD,
    pub ReturnOnlyOnClose: DWORD,
    pub Timeout: DWORDLONG,
    pub BytesToWaitFor: DWORDLONG,
    pub UsnJournalID: DWORDLONG,
    pub MinMajorVersion: WORD,
    pub MaxMajorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READ_USN_JOURNAL_DATA_V1"]
        [::std::mem::size_of::<READ_USN_JOURNAL_DATA_V1>() - 48usize];
    ["Alignment of READ_USN_JOURNAL_DATA_V1"]
        [::std::mem::align_of::<READ_USN_JOURNAL_DATA_V1>() - 8usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::StartUsn"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, StartUsn) - 0usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::ReasonMask"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, ReasonMask) - 8usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::ReturnOnlyOnClose"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, ReturnOnlyOnClose) - 12usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::Timeout"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, Timeout) - 16usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::BytesToWaitFor"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, BytesToWaitFor) - 24usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::UsnJournalID"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, UsnJournalID) - 32usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::MinMajorVersion"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, MinMajorVersion) - 40usize];
    ["Offset of field: READ_USN_JOURNAL_DATA_V1::MaxMajorVersion"]
        [::std::mem::offset_of!(READ_USN_JOURNAL_DATA_V1, MaxMajorVersion) - 42usize];
};
pub type PREAD_USN_JOURNAL_DATA_V1 = *mut READ_USN_JOURNAL_DATA_V1;
pub type READ_USN_JOURNAL_DATA = READ_USN_JOURNAL_DATA_V1;
pub type PREAD_USN_JOURNAL_DATA = *mut READ_USN_JOURNAL_DATA_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_TRACK_MODIFIED_RANGES {
    pub Flags: DWORD,
    pub Unused: DWORD,
    pub ChunkSize: DWORDLONG,
    pub FileSizeThreshold: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_TRACK_MODIFIED_RANGES"]
        [::std::mem::size_of::<USN_TRACK_MODIFIED_RANGES>() - 24usize];
    ["Alignment of USN_TRACK_MODIFIED_RANGES"]
        [::std::mem::align_of::<USN_TRACK_MODIFIED_RANGES>() - 8usize];
    ["Offset of field: USN_TRACK_MODIFIED_RANGES::Flags"]
        [::std::mem::offset_of!(USN_TRACK_MODIFIED_RANGES, Flags) - 0usize];
    ["Offset of field: USN_TRACK_MODIFIED_RANGES::Unused"]
        [::std::mem::offset_of!(USN_TRACK_MODIFIED_RANGES, Unused) - 4usize];
    ["Offset of field: USN_TRACK_MODIFIED_RANGES::ChunkSize"]
        [::std::mem::offset_of!(USN_TRACK_MODIFIED_RANGES, ChunkSize) - 8usize];
    ["Offset of field: USN_TRACK_MODIFIED_RANGES::FileSizeThreshold"]
        [::std::mem::offset_of!(USN_TRACK_MODIFIED_RANGES, FileSizeThreshold) - 16usize];
};
pub type PUSN_TRACK_MODIFIED_RANGES = *mut USN_TRACK_MODIFIED_RANGES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_RANGE_TRACK_OUTPUT {
    pub Usn: USN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RANGE_TRACK_OUTPUT"][::std::mem::size_of::<USN_RANGE_TRACK_OUTPUT>() - 8usize];
    ["Alignment of USN_RANGE_TRACK_OUTPUT"]
        [::std::mem::align_of::<USN_RANGE_TRACK_OUTPUT>() - 8usize];
    ["Offset of field: USN_RANGE_TRACK_OUTPUT::Usn"]
        [::std::mem::offset_of!(USN_RANGE_TRACK_OUTPUT, Usn) - 0usize];
};
pub type PUSN_RANGE_TRACK_OUTPUT = *mut USN_RANGE_TRACK_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct USN_RECORD_V2 {
    pub RecordLength: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub FileReferenceNumber: DWORDLONG,
    pub ParentFileReferenceNumber: DWORDLONG,
    pub Usn: USN,
    pub TimeStamp: LARGE_INTEGER,
    pub Reason: DWORD,
    pub SourceInfo: DWORD,
    pub SecurityId: DWORD,
    pub FileAttributes: DWORD,
    pub FileNameLength: WORD,
    pub FileNameOffset: WORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_V2"][::std::mem::size_of::<USN_RECORD_V2>() - 64usize];
    ["Alignment of USN_RECORD_V2"][::std::mem::align_of::<USN_RECORD_V2>() - 8usize];
    ["Offset of field: USN_RECORD_V2::RecordLength"]
        [::std::mem::offset_of!(USN_RECORD_V2, RecordLength) - 0usize];
    ["Offset of field: USN_RECORD_V2::MajorVersion"]
        [::std::mem::offset_of!(USN_RECORD_V2, MajorVersion) - 4usize];
    ["Offset of field: USN_RECORD_V2::MinorVersion"]
        [::std::mem::offset_of!(USN_RECORD_V2, MinorVersion) - 6usize];
    ["Offset of field: USN_RECORD_V2::FileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V2, FileReferenceNumber) - 8usize];
    ["Offset of field: USN_RECORD_V2::ParentFileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V2, ParentFileReferenceNumber) - 16usize];
    ["Offset of field: USN_RECORD_V2::Usn"][::std::mem::offset_of!(USN_RECORD_V2, Usn) - 24usize];
    ["Offset of field: USN_RECORD_V2::TimeStamp"]
        [::std::mem::offset_of!(USN_RECORD_V2, TimeStamp) - 32usize];
    ["Offset of field: USN_RECORD_V2::Reason"]
        [::std::mem::offset_of!(USN_RECORD_V2, Reason) - 40usize];
    ["Offset of field: USN_RECORD_V2::SourceInfo"]
        [::std::mem::offset_of!(USN_RECORD_V2, SourceInfo) - 44usize];
    ["Offset of field: USN_RECORD_V2::SecurityId"]
        [::std::mem::offset_of!(USN_RECORD_V2, SecurityId) - 48usize];
    ["Offset of field: USN_RECORD_V2::FileAttributes"]
        [::std::mem::offset_of!(USN_RECORD_V2, FileAttributes) - 52usize];
    ["Offset of field: USN_RECORD_V2::FileNameLength"]
        [::std::mem::offset_of!(USN_RECORD_V2, FileNameLength) - 56usize];
    ["Offset of field: USN_RECORD_V2::FileNameOffset"]
        [::std::mem::offset_of!(USN_RECORD_V2, FileNameOffset) - 58usize];
    ["Offset of field: USN_RECORD_V2::FileName"]
        [::std::mem::offset_of!(USN_RECORD_V2, FileName) - 60usize];
};
pub type PUSN_RECORD_V2 = *mut USN_RECORD_V2;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct USN_RECORD_V3 {
    pub RecordLength: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
    pub FileReferenceNumber: FILE_ID_128,
    pub ParentFileReferenceNumber: FILE_ID_128,
    pub Usn: USN,
    pub TimeStamp: LARGE_INTEGER,
    pub Reason: DWORD,
    pub SourceInfo: DWORD,
    pub SecurityId: DWORD,
    pub FileAttributes: DWORD,
    pub FileNameLength: WORD,
    pub FileNameOffset: WORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_V3"][::std::mem::size_of::<USN_RECORD_V3>() - 80usize];
    ["Alignment of USN_RECORD_V3"][::std::mem::align_of::<USN_RECORD_V3>() - 8usize];
    ["Offset of field: USN_RECORD_V3::RecordLength"]
        [::std::mem::offset_of!(USN_RECORD_V3, RecordLength) - 0usize];
    ["Offset of field: USN_RECORD_V3::MajorVersion"]
        [::std::mem::offset_of!(USN_RECORD_V3, MajorVersion) - 4usize];
    ["Offset of field: USN_RECORD_V3::MinorVersion"]
        [::std::mem::offset_of!(USN_RECORD_V3, MinorVersion) - 6usize];
    ["Offset of field: USN_RECORD_V3::FileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V3, FileReferenceNumber) - 8usize];
    ["Offset of field: USN_RECORD_V3::ParentFileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V3, ParentFileReferenceNumber) - 24usize];
    ["Offset of field: USN_RECORD_V3::Usn"][::std::mem::offset_of!(USN_RECORD_V3, Usn) - 40usize];
    ["Offset of field: USN_RECORD_V3::TimeStamp"]
        [::std::mem::offset_of!(USN_RECORD_V3, TimeStamp) - 48usize];
    ["Offset of field: USN_RECORD_V3::Reason"]
        [::std::mem::offset_of!(USN_RECORD_V3, Reason) - 56usize];
    ["Offset of field: USN_RECORD_V3::SourceInfo"]
        [::std::mem::offset_of!(USN_RECORD_V3, SourceInfo) - 60usize];
    ["Offset of field: USN_RECORD_V3::SecurityId"]
        [::std::mem::offset_of!(USN_RECORD_V3, SecurityId) - 64usize];
    ["Offset of field: USN_RECORD_V3::FileAttributes"]
        [::std::mem::offset_of!(USN_RECORD_V3, FileAttributes) - 68usize];
    ["Offset of field: USN_RECORD_V3::FileNameLength"]
        [::std::mem::offset_of!(USN_RECORD_V3, FileNameLength) - 72usize];
    ["Offset of field: USN_RECORD_V3::FileNameOffset"]
        [::std::mem::offset_of!(USN_RECORD_V3, FileNameOffset) - 74usize];
    ["Offset of field: USN_RECORD_V3::FileName"]
        [::std::mem::offset_of!(USN_RECORD_V3, FileName) - 76usize];
};
pub type PUSN_RECORD_V3 = *mut USN_RECORD_V3;
pub type USN_RECORD = USN_RECORD_V2;
pub type PUSN_RECORD = *mut USN_RECORD_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_RECORD_COMMON_HEADER {
    pub RecordLength: DWORD,
    pub MajorVersion: WORD,
    pub MinorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_COMMON_HEADER"]
        [::std::mem::size_of::<USN_RECORD_COMMON_HEADER>() - 8usize];
    ["Alignment of USN_RECORD_COMMON_HEADER"]
        [::std::mem::align_of::<USN_RECORD_COMMON_HEADER>() - 4usize];
    ["Offset of field: USN_RECORD_COMMON_HEADER::RecordLength"]
        [::std::mem::offset_of!(USN_RECORD_COMMON_HEADER, RecordLength) - 0usize];
    ["Offset of field: USN_RECORD_COMMON_HEADER::MajorVersion"]
        [::std::mem::offset_of!(USN_RECORD_COMMON_HEADER, MajorVersion) - 4usize];
    ["Offset of field: USN_RECORD_COMMON_HEADER::MinorVersion"]
        [::std::mem::offset_of!(USN_RECORD_COMMON_HEADER, MinorVersion) - 6usize];
};
pub type PUSN_RECORD_COMMON_HEADER = *mut USN_RECORD_COMMON_HEADER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_RECORD_EXTENT {
    pub Offset: LONGLONG,
    pub Length: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_EXTENT"][::std::mem::size_of::<USN_RECORD_EXTENT>() - 16usize];
    ["Alignment of USN_RECORD_EXTENT"][::std::mem::align_of::<USN_RECORD_EXTENT>() - 8usize];
    ["Offset of field: USN_RECORD_EXTENT::Offset"]
        [::std::mem::offset_of!(USN_RECORD_EXTENT, Offset) - 0usize];
    ["Offset of field: USN_RECORD_EXTENT::Length"]
        [::std::mem::offset_of!(USN_RECORD_EXTENT, Length) - 8usize];
};
pub type PUSN_RECORD_EXTENT = *mut USN_RECORD_EXTENT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_RECORD_V4 {
    pub Header: USN_RECORD_COMMON_HEADER,
    pub FileReferenceNumber: FILE_ID_128,
    pub ParentFileReferenceNumber: FILE_ID_128,
    pub Usn: USN,
    pub Reason: DWORD,
    pub SourceInfo: DWORD,
    pub RemainingExtents: DWORD,
    pub NumberOfExtents: WORD,
    pub ExtentSize: WORD,
    pub Extents: [USN_RECORD_EXTENT; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_V4"][::std::mem::size_of::<USN_RECORD_V4>() - 80usize];
    ["Alignment of USN_RECORD_V4"][::std::mem::align_of::<USN_RECORD_V4>() - 8usize];
    ["Offset of field: USN_RECORD_V4::Header"]
        [::std::mem::offset_of!(USN_RECORD_V4, Header) - 0usize];
    ["Offset of field: USN_RECORD_V4::FileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V4, FileReferenceNumber) - 8usize];
    ["Offset of field: USN_RECORD_V4::ParentFileReferenceNumber"]
        [::std::mem::offset_of!(USN_RECORD_V4, ParentFileReferenceNumber) - 24usize];
    ["Offset of field: USN_RECORD_V4::Usn"][::std::mem::offset_of!(USN_RECORD_V4, Usn) - 40usize];
    ["Offset of field: USN_RECORD_V4::Reason"]
        [::std::mem::offset_of!(USN_RECORD_V4, Reason) - 48usize];
    ["Offset of field: USN_RECORD_V4::SourceInfo"]
        [::std::mem::offset_of!(USN_RECORD_V4, SourceInfo) - 52usize];
    ["Offset of field: USN_RECORD_V4::RemainingExtents"]
        [::std::mem::offset_of!(USN_RECORD_V4, RemainingExtents) - 56usize];
    ["Offset of field: USN_RECORD_V4::NumberOfExtents"]
        [::std::mem::offset_of!(USN_RECORD_V4, NumberOfExtents) - 60usize];
    ["Offset of field: USN_RECORD_V4::ExtentSize"]
        [::std::mem::offset_of!(USN_RECORD_V4, ExtentSize) - 62usize];
    ["Offset of field: USN_RECORD_V4::Extents"]
        [::std::mem::offset_of!(USN_RECORD_V4, Extents) - 64usize];
};
pub type PUSN_RECORD_V4 = *mut USN_RECORD_V4;
#[repr(C)]
#[derive(Copy, Clone)]
pub union USN_RECORD_UNION {
    pub Header: USN_RECORD_COMMON_HEADER,
    pub V2: USN_RECORD_V2,
    pub V3: USN_RECORD_V3,
    pub V4: USN_RECORD_V4,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_RECORD_UNION"][::std::mem::size_of::<USN_RECORD_UNION>() - 80usize];
    ["Alignment of USN_RECORD_UNION"][::std::mem::align_of::<USN_RECORD_UNION>() - 8usize];
    ["Offset of field: USN_RECORD_UNION::Header"]
        [::std::mem::offset_of!(USN_RECORD_UNION, Header) - 0usize];
    ["Offset of field: USN_RECORD_UNION::V2"]
        [::std::mem::offset_of!(USN_RECORD_UNION, V2) - 0usize];
    ["Offset of field: USN_RECORD_UNION::V3"]
        [::std::mem::offset_of!(USN_RECORD_UNION, V3) - 0usize];
    ["Offset of field: USN_RECORD_UNION::V4"]
        [::std::mem::offset_of!(USN_RECORD_UNION, V4) - 0usize];
};
pub type PUSN_RECORD_UNION = *mut USN_RECORD_UNION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_JOURNAL_DATA_V0 {
    pub UsnJournalID: DWORDLONG,
    pub FirstUsn: USN,
    pub NextUsn: USN,
    pub LowestValidUsn: USN,
    pub MaxUsn: USN,
    pub MaximumSize: DWORDLONG,
    pub AllocationDelta: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_JOURNAL_DATA_V0"][::std::mem::size_of::<USN_JOURNAL_DATA_V0>() - 56usize];
    ["Alignment of USN_JOURNAL_DATA_V0"][::std::mem::align_of::<USN_JOURNAL_DATA_V0>() - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::UsnJournalID"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, UsnJournalID) - 0usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::FirstUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, FirstUsn) - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::NextUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, NextUsn) - 16usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::LowestValidUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, LowestValidUsn) - 24usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::MaxUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, MaxUsn) - 32usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::MaximumSize"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, MaximumSize) - 40usize];
    ["Offset of field: USN_JOURNAL_DATA_V0::AllocationDelta"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V0, AllocationDelta) - 48usize];
};
pub type PUSN_JOURNAL_DATA_V0 = *mut USN_JOURNAL_DATA_V0;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_JOURNAL_DATA_V1 {
    pub UsnJournalID: DWORDLONG,
    pub FirstUsn: USN,
    pub NextUsn: USN,
    pub LowestValidUsn: USN,
    pub MaxUsn: USN,
    pub MaximumSize: DWORDLONG,
    pub AllocationDelta: DWORDLONG,
    pub MinSupportedMajorVersion: WORD,
    pub MaxSupportedMajorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_JOURNAL_DATA_V1"][::std::mem::size_of::<USN_JOURNAL_DATA_V1>() - 64usize];
    ["Alignment of USN_JOURNAL_DATA_V1"][::std::mem::align_of::<USN_JOURNAL_DATA_V1>() - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::UsnJournalID"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, UsnJournalID) - 0usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::FirstUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, FirstUsn) - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::NextUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, NextUsn) - 16usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::LowestValidUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, LowestValidUsn) - 24usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::MaxUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, MaxUsn) - 32usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::MaximumSize"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, MaximumSize) - 40usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::AllocationDelta"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, AllocationDelta) - 48usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::MinSupportedMajorVersion"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, MinSupportedMajorVersion) - 56usize];
    ["Offset of field: USN_JOURNAL_DATA_V1::MaxSupportedMajorVersion"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V1, MaxSupportedMajorVersion) - 58usize];
};
pub type PUSN_JOURNAL_DATA_V1 = *mut USN_JOURNAL_DATA_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct USN_JOURNAL_DATA_V2 {
    pub UsnJournalID: DWORDLONG,
    pub FirstUsn: USN,
    pub NextUsn: USN,
    pub LowestValidUsn: USN,
    pub MaxUsn: USN,
    pub MaximumSize: DWORDLONG,
    pub AllocationDelta: DWORDLONG,
    pub MinSupportedMajorVersion: WORD,
    pub MaxSupportedMajorVersion: WORD,
    pub Flags: DWORD,
    pub RangeTrackChunkSize: DWORDLONG,
    pub RangeTrackFileSizeThreshold: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of USN_JOURNAL_DATA_V2"][::std::mem::size_of::<USN_JOURNAL_DATA_V2>() - 80usize];
    ["Alignment of USN_JOURNAL_DATA_V2"][::std::mem::align_of::<USN_JOURNAL_DATA_V2>() - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::UsnJournalID"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, UsnJournalID) - 0usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::FirstUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, FirstUsn) - 8usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::NextUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, NextUsn) - 16usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::LowestValidUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, LowestValidUsn) - 24usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::MaxUsn"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, MaxUsn) - 32usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::MaximumSize"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, MaximumSize) - 40usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::AllocationDelta"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, AllocationDelta) - 48usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::MinSupportedMajorVersion"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, MinSupportedMajorVersion) - 56usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::MaxSupportedMajorVersion"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, MaxSupportedMajorVersion) - 58usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::Flags"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, Flags) - 60usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::RangeTrackChunkSize"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, RangeTrackChunkSize) - 64usize];
    ["Offset of field: USN_JOURNAL_DATA_V2::RangeTrackFileSizeThreshold"]
        [::std::mem::offset_of!(USN_JOURNAL_DATA_V2, RangeTrackFileSizeThreshold) - 72usize];
};
pub type PUSN_JOURNAL_DATA_V2 = *mut USN_JOURNAL_DATA_V2;
pub type USN_JOURNAL_DATA = USN_JOURNAL_DATA_V1;
pub type PUSN_JOURNAL_DATA = *mut USN_JOURNAL_DATA_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DELETE_USN_JOURNAL_DATA {
    pub UsnJournalID: DWORDLONG,
    pub DeleteFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of DELETE_USN_JOURNAL_DATA"][::std::mem::size_of::<DELETE_USN_JOURNAL_DATA>() - 16usize];
    ["Alignment of DELETE_USN_JOURNAL_DATA"]
        [::std::mem::align_of::<DELETE_USN_JOURNAL_DATA>() - 8usize];
    ["Offset of field: DELETE_USN_JOURNAL_DATA::UsnJournalID"]
        [::std::mem::offset_of!(DELETE_USN_JOURNAL_DATA, UsnJournalID) - 0usize];
    ["Offset of field: DELETE_USN_JOURNAL_DATA::DeleteFlags"]
        [::std::mem::offset_of!(DELETE_USN_JOURNAL_DATA, DeleteFlags) - 8usize];
};
pub type PDELETE_USN_JOURNAL_DATA = *mut DELETE_USN_JOURNAL_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _MARK_HANDLE_INFO {
    pub __bindgen_anon_1: _MARK_HANDLE_INFO__bindgen_ty_1,
    pub VolumeHandle: HANDLE,
    pub HandleInfo: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _MARK_HANDLE_INFO__bindgen_ty_1 {
    pub UsnSourceInfo: DWORD,
    pub CopyNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MARK_HANDLE_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_MARK_HANDLE_INFO__bindgen_ty_1>() - 4usize];
    ["Alignment of _MARK_HANDLE_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_MARK_HANDLE_INFO__bindgen_ty_1>() - 4usize];
    ["Offset of field: _MARK_HANDLE_INFO__bindgen_ty_1::UsnSourceInfo"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO__bindgen_ty_1, UsnSourceInfo) - 0usize];
    ["Offset of field: _MARK_HANDLE_INFO__bindgen_ty_1::CopyNumber"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO__bindgen_ty_1, CopyNumber) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MARK_HANDLE_INFO"][::std::mem::size_of::<_MARK_HANDLE_INFO>() - 24usize];
    ["Alignment of _MARK_HANDLE_INFO"][::std::mem::align_of::<_MARK_HANDLE_INFO>() - 8usize];
    ["Offset of field: _MARK_HANDLE_INFO::VolumeHandle"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO, VolumeHandle) - 8usize];
    ["Offset of field: _MARK_HANDLE_INFO::HandleInfo"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO, HandleInfo) - 16usize];
};
pub type MARK_HANDLE_INFO = _MARK_HANDLE_INFO;
pub type PMARK_HANDLE_INFO = *mut _MARK_HANDLE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _MARK_HANDLE_INFO32 {
    pub __bindgen_anon_1: _MARK_HANDLE_INFO32__bindgen_ty_1,
    pub VolumeHandle: UINT32,
    pub HandleInfo: DWORD,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _MARK_HANDLE_INFO32__bindgen_ty_1 {
    pub UsnSourceInfo: DWORD,
    pub CopyNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MARK_HANDLE_INFO32__bindgen_ty_1"]
        [::std::mem::size_of::<_MARK_HANDLE_INFO32__bindgen_ty_1>() - 4usize];
    ["Alignment of _MARK_HANDLE_INFO32__bindgen_ty_1"]
        [::std::mem::align_of::<_MARK_HANDLE_INFO32__bindgen_ty_1>() - 4usize];
    ["Offset of field: _MARK_HANDLE_INFO32__bindgen_ty_1::UsnSourceInfo"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO32__bindgen_ty_1, UsnSourceInfo) - 0usize];
    ["Offset of field: _MARK_HANDLE_INFO32__bindgen_ty_1::CopyNumber"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO32__bindgen_ty_1, CopyNumber) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MARK_HANDLE_INFO32"][::std::mem::size_of::<_MARK_HANDLE_INFO32>() - 12usize];
    ["Alignment of _MARK_HANDLE_INFO32"][::std::mem::align_of::<_MARK_HANDLE_INFO32>() - 4usize];
    ["Offset of field: _MARK_HANDLE_INFO32::VolumeHandle"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO32, VolumeHandle) - 4usize];
    ["Offset of field: _MARK_HANDLE_INFO32::HandleInfo"]
        [::std::mem::offset_of!(_MARK_HANDLE_INFO32, HandleInfo) - 8usize];
};
pub type MARK_HANDLE_INFO32 = _MARK_HANDLE_INFO32;
pub type PMARK_HANDLE_INFO32 = *mut _MARK_HANDLE_INFO32;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct BULK_SECURITY_TEST_DATA {
    pub DesiredAccess: ACCESS_MASK,
    pub SecurityIds: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of BULK_SECURITY_TEST_DATA"][::std::mem::size_of::<BULK_SECURITY_TEST_DATA>() - 8usize];
    ["Alignment of BULK_SECURITY_TEST_DATA"]
        [::std::mem::align_of::<BULK_SECURITY_TEST_DATA>() - 4usize];
    ["Offset of field: BULK_SECURITY_TEST_DATA::DesiredAccess"]
        [::std::mem::offset_of!(BULK_SECURITY_TEST_DATA, DesiredAccess) - 0usize];
    ["Offset of field: BULK_SECURITY_TEST_DATA::SecurityIds"]
        [::std::mem::offset_of!(BULK_SECURITY_TEST_DATA, SecurityIds) - 4usize];
};
pub type PBULK_SECURITY_TEST_DATA = *mut BULK_SECURITY_TEST_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_PREFETCH {
    pub Type: DWORD,
    pub Count: DWORD,
    pub Prefetch: [DWORDLONG; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_PREFETCH"][::std::mem::size_of::<_FILE_PREFETCH>() - 16usize];
    ["Alignment of _FILE_PREFETCH"][::std::mem::align_of::<_FILE_PREFETCH>() - 8usize];
    ["Offset of field: _FILE_PREFETCH::Type"]
        [::std::mem::offset_of!(_FILE_PREFETCH, Type) - 0usize];
    ["Offset of field: _FILE_PREFETCH::Count"]
        [::std::mem::offset_of!(_FILE_PREFETCH, Count) - 4usize];
    ["Offset of field: _FILE_PREFETCH::Prefetch"]
        [::std::mem::offset_of!(_FILE_PREFETCH, Prefetch) - 8usize];
};
pub type FILE_PREFETCH = _FILE_PREFETCH;
pub type PFILE_PREFETCH = *mut _FILE_PREFETCH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_PREFETCH_EX {
    pub Type: DWORD,
    pub Count: DWORD,
    pub Context: PVOID,
    pub Prefetch: [DWORDLONG; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_PREFETCH_EX"][::std::mem::size_of::<_FILE_PREFETCH_EX>() - 24usize];
    ["Alignment of _FILE_PREFETCH_EX"][::std::mem::align_of::<_FILE_PREFETCH_EX>() - 8usize];
    ["Offset of field: _FILE_PREFETCH_EX::Type"]
        [::std::mem::offset_of!(_FILE_PREFETCH_EX, Type) - 0usize];
    ["Offset of field: _FILE_PREFETCH_EX::Count"]
        [::std::mem::offset_of!(_FILE_PREFETCH_EX, Count) - 4usize];
    ["Offset of field: _FILE_PREFETCH_EX::Context"]
        [::std::mem::offset_of!(_FILE_PREFETCH_EX, Context) - 8usize];
    ["Offset of field: _FILE_PREFETCH_EX::Prefetch"]
        [::std::mem::offset_of!(_FILE_PREFETCH_EX, Prefetch) - 16usize];
};
pub type FILE_PREFETCH_EX = _FILE_PREFETCH_EX;
pub type PFILE_PREFETCH_EX = *mut _FILE_PREFETCH_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILESYSTEM_STATISTICS {
    pub FileSystemType: WORD,
    pub Version: WORD,
    pub SizeOfCompleteStructure: DWORD,
    pub UserFileReads: DWORD,
    pub UserFileReadBytes: DWORD,
    pub UserDiskReads: DWORD,
    pub UserFileWrites: DWORD,
    pub UserFileWriteBytes: DWORD,
    pub UserDiskWrites: DWORD,
    pub MetaDataReads: DWORD,
    pub MetaDataReadBytes: DWORD,
    pub MetaDataDiskReads: DWORD,
    pub MetaDataWrites: DWORD,
    pub MetaDataWriteBytes: DWORD,
    pub MetaDataDiskWrites: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILESYSTEM_STATISTICS"][::std::mem::size_of::<_FILESYSTEM_STATISTICS>() - 56usize];
    ["Alignment of _FILESYSTEM_STATISTICS"]
        [::std::mem::align_of::<_FILESYSTEM_STATISTICS>() - 4usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::FileSystemType"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, FileSystemType) - 0usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::Version"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, Version) - 2usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::SizeOfCompleteStructure"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, SizeOfCompleteStructure) - 4usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserFileReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserFileReads) - 8usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserFileReadBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserFileReadBytes) - 12usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserDiskReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserDiskReads) - 16usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserFileWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserFileWrites) - 20usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserFileWriteBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserFileWriteBytes) - 24usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::UserDiskWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, UserDiskWrites) - 28usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataReads) - 32usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataReadBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataReadBytes) - 36usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataDiskReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataDiskReads) - 40usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataWrites) - 44usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataWriteBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataWriteBytes) - 48usize];
    ["Offset of field: _FILESYSTEM_STATISTICS::MetaDataDiskWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS, MetaDataDiskWrites) - 52usize];
};
pub type FILESYSTEM_STATISTICS = _FILESYSTEM_STATISTICS;
pub type PFILESYSTEM_STATISTICS = *mut _FILESYSTEM_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FAT_STATISTICS {
    pub CreateHits: DWORD,
    pub SuccessfulCreates: DWORD,
    pub FailedCreates: DWORD,
    pub NonCachedReads: DWORD,
    pub NonCachedReadBytes: DWORD,
    pub NonCachedWrites: DWORD,
    pub NonCachedWriteBytes: DWORD,
    pub NonCachedDiskReads: DWORD,
    pub NonCachedDiskWrites: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FAT_STATISTICS"][::std::mem::size_of::<_FAT_STATISTICS>() - 36usize];
    ["Alignment of _FAT_STATISTICS"][::std::mem::align_of::<_FAT_STATISTICS>() - 4usize];
    ["Offset of field: _FAT_STATISTICS::CreateHits"]
        [::std::mem::offset_of!(_FAT_STATISTICS, CreateHits) - 0usize];
    ["Offset of field: _FAT_STATISTICS::SuccessfulCreates"]
        [::std::mem::offset_of!(_FAT_STATISTICS, SuccessfulCreates) - 4usize];
    ["Offset of field: _FAT_STATISTICS::FailedCreates"]
        [::std::mem::offset_of!(_FAT_STATISTICS, FailedCreates) - 8usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedReads"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedReads) - 12usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedReadBytes"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedReadBytes) - 16usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedWrites"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedWrites) - 20usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedWriteBytes"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedWriteBytes) - 24usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedDiskReads"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedDiskReads) - 28usize];
    ["Offset of field: _FAT_STATISTICS::NonCachedDiskWrites"]
        [::std::mem::offset_of!(_FAT_STATISTICS, NonCachedDiskWrites) - 32usize];
};
pub type FAT_STATISTICS = _FAT_STATISTICS;
pub type PFAT_STATISTICS = *mut _FAT_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXFAT_STATISTICS {
    pub CreateHits: DWORD,
    pub SuccessfulCreates: DWORD,
    pub FailedCreates: DWORD,
    pub NonCachedReads: DWORD,
    pub NonCachedReadBytes: DWORD,
    pub NonCachedWrites: DWORD,
    pub NonCachedWriteBytes: DWORD,
    pub NonCachedDiskReads: DWORD,
    pub NonCachedDiskWrites: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXFAT_STATISTICS"][::std::mem::size_of::<_EXFAT_STATISTICS>() - 36usize];
    ["Alignment of _EXFAT_STATISTICS"][::std::mem::align_of::<_EXFAT_STATISTICS>() - 4usize];
    ["Offset of field: _EXFAT_STATISTICS::CreateHits"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, CreateHits) - 0usize];
    ["Offset of field: _EXFAT_STATISTICS::SuccessfulCreates"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, SuccessfulCreates) - 4usize];
    ["Offset of field: _EXFAT_STATISTICS::FailedCreates"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, FailedCreates) - 8usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedReads"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedReads) - 12usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedReadBytes"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedReadBytes) - 16usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedWrites"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedWrites) - 20usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedWriteBytes"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedWriteBytes) - 24usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedDiskReads"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedDiskReads) - 28usize];
    ["Offset of field: _EXFAT_STATISTICS::NonCachedDiskWrites"]
        [::std::mem::offset_of!(_EXFAT_STATISTICS, NonCachedDiskWrites) - 32usize];
};
pub type EXFAT_STATISTICS = _EXFAT_STATISTICS;
pub type PEXFAT_STATISTICS = *mut _EXFAT_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS {
    pub LogFileFullExceptions: DWORD,
    pub OtherExceptions: DWORD,
    pub MftReads: DWORD,
    pub MftReadBytes: DWORD,
    pub MftWrites: DWORD,
    pub MftWriteBytes: DWORD,
    pub MftWritesUserLevel: _NTFS_STATISTICS__bindgen_ty_1,
    pub MftWritesFlushForLogFileFull: WORD,
    pub MftWritesLazyWriter: WORD,
    pub MftWritesUserRequest: WORD,
    pub Mft2Writes: DWORD,
    pub Mft2WriteBytes: DWORD,
    pub Mft2WritesUserLevel: _NTFS_STATISTICS__bindgen_ty_2,
    pub Mft2WritesFlushForLogFileFull: WORD,
    pub Mft2WritesLazyWriter: WORD,
    pub Mft2WritesUserRequest: WORD,
    pub RootIndexReads: DWORD,
    pub RootIndexReadBytes: DWORD,
    pub RootIndexWrites: DWORD,
    pub RootIndexWriteBytes: DWORD,
    pub BitmapReads: DWORD,
    pub BitmapReadBytes: DWORD,
    pub BitmapWrites: DWORD,
    pub BitmapWriteBytes: DWORD,
    pub BitmapWritesFlushForLogFileFull: WORD,
    pub BitmapWritesLazyWriter: WORD,
    pub BitmapWritesUserRequest: WORD,
    pub BitmapWritesUserLevel: _NTFS_STATISTICS__bindgen_ty_3,
    pub MftBitmapReads: DWORD,
    pub MftBitmapReadBytes: DWORD,
    pub MftBitmapWrites: DWORD,
    pub MftBitmapWriteBytes: DWORD,
    pub MftBitmapWritesFlushForLogFileFull: WORD,
    pub MftBitmapWritesLazyWriter: WORD,
    pub MftBitmapWritesUserRequest: WORD,
    pub MftBitmapWritesUserLevel: _NTFS_STATISTICS__bindgen_ty_4,
    pub UserIndexReads: DWORD,
    pub UserIndexReadBytes: DWORD,
    pub UserIndexWrites: DWORD,
    pub UserIndexWriteBytes: DWORD,
    pub LogFileReads: DWORD,
    pub LogFileReadBytes: DWORD,
    pub LogFileWrites: DWORD,
    pub LogFileWriteBytes: DWORD,
    pub Allocate: _NTFS_STATISTICS__bindgen_ty_5,
    pub DiskResourcesExhausted: DWORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS__bindgen_ty_1 {
    pub Write: WORD,
    pub Create: WORD,
    pub SetInfo: WORD,
    pub Flush: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS__bindgen_ty_1"]
        [::std::mem::size_of::<_NTFS_STATISTICS__bindgen_ty_1>() - 8usize];
    ["Alignment of _NTFS_STATISTICS__bindgen_ty_1"]
        [::std::mem::align_of::<_NTFS_STATISTICS__bindgen_ty_1>() - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_1::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_1, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_1::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_1, Create) - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_1::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_1, SetInfo) - 4usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_1::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_1, Flush) - 6usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS__bindgen_ty_2 {
    pub Write: WORD,
    pub Create: WORD,
    pub SetInfo: WORD,
    pub Flush: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS__bindgen_ty_2"]
        [::std::mem::size_of::<_NTFS_STATISTICS__bindgen_ty_2>() - 8usize];
    ["Alignment of _NTFS_STATISTICS__bindgen_ty_2"]
        [::std::mem::align_of::<_NTFS_STATISTICS__bindgen_ty_2>() - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_2::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_2, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_2::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_2, Create) - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_2::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_2, SetInfo) - 4usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_2::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_2, Flush) - 6usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS__bindgen_ty_3 {
    pub Write: WORD,
    pub Create: WORD,
    pub SetInfo: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS__bindgen_ty_3"]
        [::std::mem::size_of::<_NTFS_STATISTICS__bindgen_ty_3>() - 6usize];
    ["Alignment of _NTFS_STATISTICS__bindgen_ty_3"]
        [::std::mem::align_of::<_NTFS_STATISTICS__bindgen_ty_3>() - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_3::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_3, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_3::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_3, Create) - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_3::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_3, SetInfo) - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS__bindgen_ty_4 {
    pub Write: WORD,
    pub Create: WORD,
    pub SetInfo: WORD,
    pub Flush: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS__bindgen_ty_4"]
        [::std::mem::size_of::<_NTFS_STATISTICS__bindgen_ty_4>() - 8usize];
    ["Alignment of _NTFS_STATISTICS__bindgen_ty_4"]
        [::std::mem::align_of::<_NTFS_STATISTICS__bindgen_ty_4>() - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_4::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_4, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_4::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_4, Create) - 2usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_4::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_4, SetInfo) - 4usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_4::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_4, Flush) - 6usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS__bindgen_ty_5 {
    pub Calls: DWORD,
    pub Clusters: DWORD,
    pub Hints: DWORD,
    pub RunsReturned: DWORD,
    pub HintsHonored: DWORD,
    pub HintsClusters: DWORD,
    pub Cache: DWORD,
    pub CacheClusters: DWORD,
    pub CacheMiss: DWORD,
    pub CacheMissClusters: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS__bindgen_ty_5"]
        [::std::mem::size_of::<_NTFS_STATISTICS__bindgen_ty_5>() - 40usize];
    ["Alignment of _NTFS_STATISTICS__bindgen_ty_5"]
        [::std::mem::align_of::<_NTFS_STATISTICS__bindgen_ty_5>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::Calls"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, Calls) - 0usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::Clusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, Clusters) - 4usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::Hints"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, Hints) - 8usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::RunsReturned"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, RunsReturned) - 12usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::HintsHonored"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, HintsHonored) - 16usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::HintsClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, HintsClusters) - 20usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::Cache"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, Cache) - 24usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::CacheClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, CacheClusters) - 28usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::CacheMiss"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, CacheMiss) - 32usize];
    ["Offset of field: _NTFS_STATISTICS__bindgen_ty_5::CacheMissClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS__bindgen_ty_5, CacheMissClusters) - 36usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS"][::std::mem::size_of::<_NTFS_STATISTICS>() - 216usize];
    ["Alignment of _NTFS_STATISTICS"][::std::mem::align_of::<_NTFS_STATISTICS>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS::LogFileFullExceptions"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, LogFileFullExceptions) - 0usize];
    ["Offset of field: _NTFS_STATISTICS::OtherExceptions"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, OtherExceptions) - 4usize];
    ["Offset of field: _NTFS_STATISTICS::MftReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftReads) - 8usize];
    ["Offset of field: _NTFS_STATISTICS::MftReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftReadBytes) - 12usize];
    ["Offset of field: _NTFS_STATISTICS::MftWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWrites) - 16usize];
    ["Offset of field: _NTFS_STATISTICS::MftWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWriteBytes) - 20usize];
    ["Offset of field: _NTFS_STATISTICS::MftWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWritesUserLevel) - 24usize];
    ["Offset of field: _NTFS_STATISTICS::MftWritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWritesFlushForLogFileFull) - 32usize];
    ["Offset of field: _NTFS_STATISTICS::MftWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWritesLazyWriter) - 34usize];
    ["Offset of field: _NTFS_STATISTICS::MftWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftWritesUserRequest) - 36usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2Writes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2Writes) - 40usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2WriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2WriteBytes) - 44usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2WritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2WritesUserLevel) - 48usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2WritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2WritesFlushForLogFileFull) - 56usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2WritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2WritesLazyWriter) - 58usize];
    ["Offset of field: _NTFS_STATISTICS::Mft2WritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Mft2WritesUserRequest) - 60usize];
    ["Offset of field: _NTFS_STATISTICS::RootIndexReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, RootIndexReads) - 64usize];
    ["Offset of field: _NTFS_STATISTICS::RootIndexReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, RootIndexReadBytes) - 68usize];
    ["Offset of field: _NTFS_STATISTICS::RootIndexWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, RootIndexWrites) - 72usize];
    ["Offset of field: _NTFS_STATISTICS::RootIndexWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, RootIndexWriteBytes) - 76usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapReads) - 80usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapReadBytes) - 84usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWrites) - 88usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWriteBytes) - 92usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWritesFlushForLogFileFull) - 96usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWritesLazyWriter) - 98usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWritesUserRequest) - 100usize];
    ["Offset of field: _NTFS_STATISTICS::BitmapWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, BitmapWritesUserLevel) - 102usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapReads) - 108usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapReadBytes) - 112usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWrites) - 116usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWriteBytes) - 120usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWritesFlushForLogFileFull) - 124usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWritesLazyWriter) - 126usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWritesUserRequest) - 128usize];
    ["Offset of field: _NTFS_STATISTICS::MftBitmapWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, MftBitmapWritesUserLevel) - 130usize];
    ["Offset of field: _NTFS_STATISTICS::UserIndexReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, UserIndexReads) - 140usize];
    ["Offset of field: _NTFS_STATISTICS::UserIndexReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, UserIndexReadBytes) - 144usize];
    ["Offset of field: _NTFS_STATISTICS::UserIndexWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, UserIndexWrites) - 148usize];
    ["Offset of field: _NTFS_STATISTICS::UserIndexWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, UserIndexWriteBytes) - 152usize];
    ["Offset of field: _NTFS_STATISTICS::LogFileReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, LogFileReads) - 156usize];
    ["Offset of field: _NTFS_STATISTICS::LogFileReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, LogFileReadBytes) - 160usize];
    ["Offset of field: _NTFS_STATISTICS::LogFileWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, LogFileWrites) - 164usize];
    ["Offset of field: _NTFS_STATISTICS::LogFileWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, LogFileWriteBytes) - 168usize];
    ["Offset of field: _NTFS_STATISTICS::Allocate"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, Allocate) - 172usize];
    ["Offset of field: _NTFS_STATISTICS::DiskResourcesExhausted"]
        [::std::mem::offset_of!(_NTFS_STATISTICS, DiskResourcesExhausted) - 212usize];
};
pub type NTFS_STATISTICS = _NTFS_STATISTICS;
pub type PNTFS_STATISTICS = *mut _NTFS_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILESYSTEM_STATISTICS_EX {
    pub FileSystemType: WORD,
    pub Version: WORD,
    pub SizeOfCompleteStructure: DWORD,
    pub UserFileReads: DWORDLONG,
    pub UserFileReadBytes: DWORDLONG,
    pub UserDiskReads: DWORDLONG,
    pub UserFileWrites: DWORDLONG,
    pub UserFileWriteBytes: DWORDLONG,
    pub UserDiskWrites: DWORDLONG,
    pub MetaDataReads: DWORDLONG,
    pub MetaDataReadBytes: DWORDLONG,
    pub MetaDataDiskReads: DWORDLONG,
    pub MetaDataWrites: DWORDLONG,
    pub MetaDataWriteBytes: DWORDLONG,
    pub MetaDataDiskWrites: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILESYSTEM_STATISTICS_EX"]
        [::std::mem::size_of::<_FILESYSTEM_STATISTICS_EX>() - 104usize];
    ["Alignment of _FILESYSTEM_STATISTICS_EX"]
        [::std::mem::align_of::<_FILESYSTEM_STATISTICS_EX>() - 8usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::FileSystemType"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, FileSystemType) - 0usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::Version"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, Version) - 2usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::SizeOfCompleteStructure"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, SizeOfCompleteStructure) - 4usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserFileReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserFileReads) - 8usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserFileReadBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserFileReadBytes) - 16usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserDiskReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserDiskReads) - 24usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserFileWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserFileWrites) - 32usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserFileWriteBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserFileWriteBytes) - 40usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::UserDiskWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, UserDiskWrites) - 48usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataReads) - 56usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataReadBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataReadBytes) - 64usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataDiskReads"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataDiskReads) - 72usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataWrites) - 80usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataWriteBytes"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataWriteBytes) - 88usize];
    ["Offset of field: _FILESYSTEM_STATISTICS_EX::MetaDataDiskWrites"]
        [::std::mem::offset_of!(_FILESYSTEM_STATISTICS_EX, MetaDataDiskWrites) - 96usize];
};
pub type FILESYSTEM_STATISTICS_EX = _FILESYSTEM_STATISTICS_EX;
pub type PFILESYSTEM_STATISTICS_EX = *mut _FILESYSTEM_STATISTICS_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX {
    pub LogFileFullExceptions: DWORD,
    pub OtherExceptions: DWORD,
    pub MftReads: DWORDLONG,
    pub MftReadBytes: DWORDLONG,
    pub MftWrites: DWORDLONG,
    pub MftWriteBytes: DWORDLONG,
    pub MftWritesUserLevel: _NTFS_STATISTICS_EX__bindgen_ty_1,
    pub MftWritesFlushForLogFileFull: DWORD,
    pub MftWritesLazyWriter: DWORD,
    pub MftWritesUserRequest: DWORD,
    pub Mft2Writes: DWORDLONG,
    pub Mft2WriteBytes: DWORDLONG,
    pub Mft2WritesUserLevel: _NTFS_STATISTICS_EX__bindgen_ty_2,
    pub Mft2WritesFlushForLogFileFull: DWORD,
    pub Mft2WritesLazyWriter: DWORD,
    pub Mft2WritesUserRequest: DWORD,
    pub RootIndexReads: DWORDLONG,
    pub RootIndexReadBytes: DWORDLONG,
    pub RootIndexWrites: DWORDLONG,
    pub RootIndexWriteBytes: DWORDLONG,
    pub BitmapReads: DWORDLONG,
    pub BitmapReadBytes: DWORDLONG,
    pub BitmapWrites: DWORDLONG,
    pub BitmapWriteBytes: DWORDLONG,
    pub BitmapWritesFlushForLogFileFull: DWORD,
    pub BitmapWritesLazyWriter: DWORD,
    pub BitmapWritesUserRequest: DWORD,
    pub BitmapWritesUserLevel: _NTFS_STATISTICS_EX__bindgen_ty_3,
    pub MftBitmapReads: DWORDLONG,
    pub MftBitmapReadBytes: DWORDLONG,
    pub MftBitmapWrites: DWORDLONG,
    pub MftBitmapWriteBytes: DWORDLONG,
    pub MftBitmapWritesFlushForLogFileFull: DWORD,
    pub MftBitmapWritesLazyWriter: DWORD,
    pub MftBitmapWritesUserRequest: DWORD,
    pub MftBitmapWritesUserLevel: _NTFS_STATISTICS_EX__bindgen_ty_4,
    pub UserIndexReads: DWORDLONG,
    pub UserIndexReadBytes: DWORDLONG,
    pub UserIndexWrites: DWORDLONG,
    pub UserIndexWriteBytes: DWORDLONG,
    pub LogFileReads: DWORDLONG,
    pub LogFileReadBytes: DWORDLONG,
    pub LogFileWrites: DWORDLONG,
    pub LogFileWriteBytes: DWORDLONG,
    pub Allocate: _NTFS_STATISTICS_EX__bindgen_ty_5,
    pub DiskResourcesExhausted: DWORD,
    pub VolumeTrimCount: DWORDLONG,
    pub VolumeTrimTime: DWORDLONG,
    pub VolumeTrimByteCount: DWORDLONG,
    pub FileLevelTrimCount: DWORDLONG,
    pub FileLevelTrimTime: DWORDLONG,
    pub FileLevelTrimByteCount: DWORDLONG,
    pub VolumeTrimSkippedCount: DWORDLONG,
    pub VolumeTrimSkippedByteCount: DWORDLONG,
    pub NtfsFillStatInfoFromMftRecordCalledCount: DWORDLONG,
    pub NtfsFillStatInfoFromMftRecordBailedBecauseOfAttributeListCount: DWORDLONG,
    pub NtfsFillStatInfoFromMftRecordBailedBecauseOfNonResReparsePointCount: DWORDLONG,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX__bindgen_ty_1 {
    pub Write: DWORD,
    pub Create: DWORD,
    pub SetInfo: DWORD,
    pub Flush: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX__bindgen_ty_1"]
        [::std::mem::size_of::<_NTFS_STATISTICS_EX__bindgen_ty_1>() - 16usize];
    ["Alignment of _NTFS_STATISTICS_EX__bindgen_ty_1"]
        [::std::mem::align_of::<_NTFS_STATISTICS_EX__bindgen_ty_1>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_1::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_1, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_1::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_1, Create) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_1::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_1, SetInfo) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_1::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_1, Flush) - 12usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX__bindgen_ty_2 {
    pub Write: DWORD,
    pub Create: DWORD,
    pub SetInfo: DWORD,
    pub Flush: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX__bindgen_ty_2"]
        [::std::mem::size_of::<_NTFS_STATISTICS_EX__bindgen_ty_2>() - 16usize];
    ["Alignment of _NTFS_STATISTICS_EX__bindgen_ty_2"]
        [::std::mem::align_of::<_NTFS_STATISTICS_EX__bindgen_ty_2>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_2::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_2, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_2::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_2, Create) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_2::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_2, SetInfo) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_2::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_2, Flush) - 12usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX__bindgen_ty_3 {
    pub Write: DWORD,
    pub Create: DWORD,
    pub SetInfo: DWORD,
    pub Flush: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX__bindgen_ty_3"]
        [::std::mem::size_of::<_NTFS_STATISTICS_EX__bindgen_ty_3>() - 16usize];
    ["Alignment of _NTFS_STATISTICS_EX__bindgen_ty_3"]
        [::std::mem::align_of::<_NTFS_STATISTICS_EX__bindgen_ty_3>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_3::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_3, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_3::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_3, Create) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_3::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_3, SetInfo) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_3::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_3, Flush) - 12usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX__bindgen_ty_4 {
    pub Write: DWORD,
    pub Create: DWORD,
    pub SetInfo: DWORD,
    pub Flush: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX__bindgen_ty_4"]
        [::std::mem::size_of::<_NTFS_STATISTICS_EX__bindgen_ty_4>() - 16usize];
    ["Alignment of _NTFS_STATISTICS_EX__bindgen_ty_4"]
        [::std::mem::align_of::<_NTFS_STATISTICS_EX__bindgen_ty_4>() - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_4::Write"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_4, Write) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_4::Create"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_4, Create) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_4::SetInfo"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_4, SetInfo) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_4::Flush"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_4, Flush) - 12usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _NTFS_STATISTICS_EX__bindgen_ty_5 {
    pub Calls: DWORD,
    pub RunsReturned: DWORD,
    pub Hints: DWORD,
    pub HintsHonored: DWORD,
    pub Cache: DWORD,
    pub CacheMiss: DWORD,
    pub Clusters: DWORDLONG,
    pub HintsClusters: DWORDLONG,
    pub CacheClusters: DWORDLONG,
    pub CacheMissClusters: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX__bindgen_ty_5"]
        [::std::mem::size_of::<_NTFS_STATISTICS_EX__bindgen_ty_5>() - 56usize];
    ["Alignment of _NTFS_STATISTICS_EX__bindgen_ty_5"]
        [::std::mem::align_of::<_NTFS_STATISTICS_EX__bindgen_ty_5>() - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::Calls"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, Calls) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::RunsReturned"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, RunsReturned) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::Hints"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, Hints) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::HintsHonored"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, HintsHonored) - 12usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::Cache"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, Cache) - 16usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::CacheMiss"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, CacheMiss) - 20usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::Clusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, Clusters) - 24usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::HintsClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, HintsClusters) - 32usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::CacheClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, CacheClusters) - 40usize];
    ["Offset of field: _NTFS_STATISTICS_EX__bindgen_ty_5::CacheMissClusters"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX__bindgen_ty_5, CacheMissClusters) - 48usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _NTFS_STATISTICS_EX"][::std::mem::size_of::<_NTFS_STATISTICS_EX>() - 496usize];
    ["Alignment of _NTFS_STATISTICS_EX"][::std::mem::align_of::<_NTFS_STATISTICS_EX>() - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX::LogFileFullExceptions"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, LogFileFullExceptions) - 0usize];
    ["Offset of field: _NTFS_STATISTICS_EX::OtherExceptions"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, OtherExceptions) - 4usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftReads) - 8usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftReadBytes) - 16usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWrites) - 24usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWriteBytes) - 32usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWritesUserLevel) - 40usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWritesFlushForLogFileFull) - 56usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWritesLazyWriter) - 60usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftWritesUserRequest) - 64usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2Writes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2Writes) - 72usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2WriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2WriteBytes) - 80usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2WritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2WritesUserLevel) - 88usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2WritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2WritesFlushForLogFileFull) - 104usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2WritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2WritesLazyWriter) - 108usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Mft2WritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Mft2WritesUserRequest) - 112usize];
    ["Offset of field: _NTFS_STATISTICS_EX::RootIndexReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, RootIndexReads) - 120usize];
    ["Offset of field: _NTFS_STATISTICS_EX::RootIndexReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, RootIndexReadBytes) - 128usize];
    ["Offset of field: _NTFS_STATISTICS_EX::RootIndexWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, RootIndexWrites) - 136usize];
    ["Offset of field: _NTFS_STATISTICS_EX::RootIndexWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, RootIndexWriteBytes) - 144usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapReads) - 152usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapReadBytes) - 160usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWrites) - 168usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWriteBytes) - 176usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWritesFlushForLogFileFull"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWritesFlushForLogFileFull) - 184usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWritesLazyWriter) - 188usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWritesUserRequest) - 192usize];
    ["Offset of field: _NTFS_STATISTICS_EX::BitmapWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, BitmapWritesUserLevel) - 196usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapReads) - 216usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapReadBytes) - 224usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapWrites) - 232usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapWriteBytes) - 240usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWritesFlushForLogFileFull"][::std::mem::offset_of!(
        _NTFS_STATISTICS_EX,
        MftBitmapWritesFlushForLogFileFull
    ) - 248usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWritesLazyWriter"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapWritesLazyWriter) - 252usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWritesUserRequest"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapWritesUserRequest) - 256usize];
    ["Offset of field: _NTFS_STATISTICS_EX::MftBitmapWritesUserLevel"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, MftBitmapWritesUserLevel) - 260usize];
    ["Offset of field: _NTFS_STATISTICS_EX::UserIndexReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, UserIndexReads) - 280usize];
    ["Offset of field: _NTFS_STATISTICS_EX::UserIndexReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, UserIndexReadBytes) - 288usize];
    ["Offset of field: _NTFS_STATISTICS_EX::UserIndexWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, UserIndexWrites) - 296usize];
    ["Offset of field: _NTFS_STATISTICS_EX::UserIndexWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, UserIndexWriteBytes) - 304usize];
    ["Offset of field: _NTFS_STATISTICS_EX::LogFileReads"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, LogFileReads) - 312usize];
    ["Offset of field: _NTFS_STATISTICS_EX::LogFileReadBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, LogFileReadBytes) - 320usize];
    ["Offset of field: _NTFS_STATISTICS_EX::LogFileWrites"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, LogFileWrites) - 328usize];
    ["Offset of field: _NTFS_STATISTICS_EX::LogFileWriteBytes"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, LogFileWriteBytes) - 336usize];
    ["Offset of field: _NTFS_STATISTICS_EX::Allocate"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, Allocate) - 344usize];
    ["Offset of field: _NTFS_STATISTICS_EX::DiskResourcesExhausted"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, DiskResourcesExhausted) - 400usize];
    ["Offset of field: _NTFS_STATISTICS_EX::VolumeTrimCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, VolumeTrimCount) - 408usize];
    ["Offset of field: _NTFS_STATISTICS_EX::VolumeTrimTime"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, VolumeTrimTime) - 416usize];
    ["Offset of field: _NTFS_STATISTICS_EX::VolumeTrimByteCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, VolumeTrimByteCount) - 424usize];
    ["Offset of field: _NTFS_STATISTICS_EX::FileLevelTrimCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, FileLevelTrimCount) - 432usize];
    ["Offset of field: _NTFS_STATISTICS_EX::FileLevelTrimTime"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, FileLevelTrimTime) - 440usize];
    ["Offset of field: _NTFS_STATISTICS_EX::FileLevelTrimByteCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, FileLevelTrimByteCount) - 448usize];
    ["Offset of field: _NTFS_STATISTICS_EX::VolumeTrimSkippedCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, VolumeTrimSkippedCount) - 456usize];
    ["Offset of field: _NTFS_STATISTICS_EX::VolumeTrimSkippedByteCount"]
        [::std::mem::offset_of!(_NTFS_STATISTICS_EX, VolumeTrimSkippedByteCount) - 464usize];
    ["Offset of field: _NTFS_STATISTICS_EX::NtfsFillStatInfoFromMftRecordCalledCount"][::std::mem::offset_of!(
        _NTFS_STATISTICS_EX,
        NtfsFillStatInfoFromMftRecordCalledCount
    )
        - 472usize];
    ["Offset of field: _NTFS_STATISTICS_EX::NtfsFillStatInfoFromMftRecordBailedBecauseOfAttributeListCount"] [:: std :: mem :: offset_of ! (_NTFS_STATISTICS_EX , NtfsFillStatInfoFromMftRecordBailedBecauseOfAttributeListCount) - 480usize] ;
    ["Offset of field: _NTFS_STATISTICS_EX::NtfsFillStatInfoFromMftRecordBailedBecauseOfNonResReparsePointCount"] [:: std :: mem :: offset_of ! (_NTFS_STATISTICS_EX , NtfsFillStatInfoFromMftRecordBailedBecauseOfNonResReparsePointCount) - 488usize] ;
};
pub type NTFS_STATISTICS_EX = _NTFS_STATISTICS_EX;
pub type PNTFS_STATISTICS_EX = *mut _NTFS_STATISTICS_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_OBJECTID_BUFFER {
    pub ObjectId: [BYTE; 16usize],
    pub __bindgen_anon_1: _FILE_OBJECTID_BUFFER__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _FILE_OBJECTID_BUFFER__bindgen_ty_1 {
    pub __bindgen_anon_1: _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1,
    pub ExtendedInfo: [BYTE; 48usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1 {
    pub BirthVolumeId: [BYTE; 16usize],
    pub BirthObjectId: [BYTE; 16usize],
    pub DomainId: [BYTE; 16usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1>() - 48usize];
    ["Alignment of _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1>() - 1usize];
    ["Offset of field: _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1::BirthVolumeId"][::std::mem::offset_of!(
        _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1,
        BirthVolumeId
    )
        - 0usize];
    ["Offset of field: _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1::BirthObjectId"][::std::mem::offset_of!(
        _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1,
        BirthObjectId
    )
        - 16usize];
    ["Offset of field: _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1::DomainId"][::std::mem::offset_of!(
        _FILE_OBJECTID_BUFFER__bindgen_ty_1__bindgen_ty_1,
        DomainId
    ) - 32usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_OBJECTID_BUFFER__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_OBJECTID_BUFFER__bindgen_ty_1>() - 48usize];
    ["Alignment of _FILE_OBJECTID_BUFFER__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_OBJECTID_BUFFER__bindgen_ty_1>() - 1usize];
    ["Offset of field: _FILE_OBJECTID_BUFFER__bindgen_ty_1::ExtendedInfo"]
        [::std::mem::offset_of!(_FILE_OBJECTID_BUFFER__bindgen_ty_1, ExtendedInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_OBJECTID_BUFFER"][::std::mem::size_of::<_FILE_OBJECTID_BUFFER>() - 64usize];
    ["Alignment of _FILE_OBJECTID_BUFFER"]
        [::std::mem::align_of::<_FILE_OBJECTID_BUFFER>() - 1usize];
    ["Offset of field: _FILE_OBJECTID_BUFFER::ObjectId"]
        [::std::mem::offset_of!(_FILE_OBJECTID_BUFFER, ObjectId) - 0usize];
};
pub type FILE_OBJECTID_BUFFER = _FILE_OBJECTID_BUFFER;
pub type PFILE_OBJECTID_BUFFER = *mut _FILE_OBJECTID_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_SET_SPARSE_BUFFER {
    pub SetSparse: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_SET_SPARSE_BUFFER"][::std::mem::size_of::<_FILE_SET_SPARSE_BUFFER>() - 1usize];
    ["Alignment of _FILE_SET_SPARSE_BUFFER"]
        [::std::mem::align_of::<_FILE_SET_SPARSE_BUFFER>() - 1usize];
    ["Offset of field: _FILE_SET_SPARSE_BUFFER::SetSparse"]
        [::std::mem::offset_of!(_FILE_SET_SPARSE_BUFFER, SetSparse) - 0usize];
};
pub type FILE_SET_SPARSE_BUFFER = _FILE_SET_SPARSE_BUFFER;
pub type PFILE_SET_SPARSE_BUFFER = *mut _FILE_SET_SPARSE_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ZERO_DATA_INFORMATION {
    pub FileOffset: LARGE_INTEGER,
    pub BeyondFinalZero: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ZERO_DATA_INFORMATION"]
        [::std::mem::size_of::<_FILE_ZERO_DATA_INFORMATION>() - 16usize];
    ["Alignment of _FILE_ZERO_DATA_INFORMATION"]
        [::std::mem::align_of::<_FILE_ZERO_DATA_INFORMATION>() - 8usize];
    ["Offset of field: _FILE_ZERO_DATA_INFORMATION::FileOffset"]
        [::std::mem::offset_of!(_FILE_ZERO_DATA_INFORMATION, FileOffset) - 0usize];
    ["Offset of field: _FILE_ZERO_DATA_INFORMATION::BeyondFinalZero"]
        [::std::mem::offset_of!(_FILE_ZERO_DATA_INFORMATION, BeyondFinalZero) - 8usize];
};
pub type FILE_ZERO_DATA_INFORMATION = _FILE_ZERO_DATA_INFORMATION;
pub type PFILE_ZERO_DATA_INFORMATION = *mut _FILE_ZERO_DATA_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ZERO_DATA_INFORMATION_EX {
    pub FileOffset: LARGE_INTEGER,
    pub BeyondFinalZero: LARGE_INTEGER,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ZERO_DATA_INFORMATION_EX"]
        [::std::mem::size_of::<_FILE_ZERO_DATA_INFORMATION_EX>() - 24usize];
    ["Alignment of _FILE_ZERO_DATA_INFORMATION_EX"]
        [::std::mem::align_of::<_FILE_ZERO_DATA_INFORMATION_EX>() - 8usize];
    ["Offset of field: _FILE_ZERO_DATA_INFORMATION_EX::FileOffset"]
        [::std::mem::offset_of!(_FILE_ZERO_DATA_INFORMATION_EX, FileOffset) - 0usize];
    ["Offset of field: _FILE_ZERO_DATA_INFORMATION_EX::BeyondFinalZero"]
        [::std::mem::offset_of!(_FILE_ZERO_DATA_INFORMATION_EX, BeyondFinalZero) - 8usize];
    ["Offset of field: _FILE_ZERO_DATA_INFORMATION_EX::Flags"]
        [::std::mem::offset_of!(_FILE_ZERO_DATA_INFORMATION_EX, Flags) - 16usize];
};
pub type FILE_ZERO_DATA_INFORMATION_EX = _FILE_ZERO_DATA_INFORMATION_EX;
pub type PFILE_ZERO_DATA_INFORMATION_EX = *mut _FILE_ZERO_DATA_INFORMATION_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_ALLOCATED_RANGE_BUFFER {
    pub FileOffset: LARGE_INTEGER,
    pub Length: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_ALLOCATED_RANGE_BUFFER"]
        [::std::mem::size_of::<_FILE_ALLOCATED_RANGE_BUFFER>() - 16usize];
    ["Alignment of _FILE_ALLOCATED_RANGE_BUFFER"]
        [::std::mem::align_of::<_FILE_ALLOCATED_RANGE_BUFFER>() - 8usize];
    ["Offset of field: _FILE_ALLOCATED_RANGE_BUFFER::FileOffset"]
        [::std::mem::offset_of!(_FILE_ALLOCATED_RANGE_BUFFER, FileOffset) - 0usize];
    ["Offset of field: _FILE_ALLOCATED_RANGE_BUFFER::Length"]
        [::std::mem::offset_of!(_FILE_ALLOCATED_RANGE_BUFFER, Length) - 8usize];
};
pub type FILE_ALLOCATED_RANGE_BUFFER = _FILE_ALLOCATED_RANGE_BUFFER;
pub type PFILE_ALLOCATED_RANGE_BUFFER = *mut _FILE_ALLOCATED_RANGE_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_BUFFER {
    pub EncryptionOperation: DWORD,
    pub Private: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_BUFFER"][::std::mem::size_of::<_ENCRYPTION_BUFFER>() - 8usize];
    ["Alignment of _ENCRYPTION_BUFFER"][::std::mem::align_of::<_ENCRYPTION_BUFFER>() - 4usize];
    ["Offset of field: _ENCRYPTION_BUFFER::EncryptionOperation"]
        [::std::mem::offset_of!(_ENCRYPTION_BUFFER, EncryptionOperation) - 0usize];
    ["Offset of field: _ENCRYPTION_BUFFER::Private"]
        [::std::mem::offset_of!(_ENCRYPTION_BUFFER, Private) - 4usize];
};
pub type ENCRYPTION_BUFFER = _ENCRYPTION_BUFFER;
pub type PENCRYPTION_BUFFER = *mut _ENCRYPTION_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DECRYPTION_STATUS_BUFFER {
    pub NoEncryptedStreams: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DECRYPTION_STATUS_BUFFER"]
        [::std::mem::size_of::<_DECRYPTION_STATUS_BUFFER>() - 1usize];
    ["Alignment of _DECRYPTION_STATUS_BUFFER"]
        [::std::mem::align_of::<_DECRYPTION_STATUS_BUFFER>() - 1usize];
    ["Offset of field: _DECRYPTION_STATUS_BUFFER::NoEncryptedStreams"]
        [::std::mem::offset_of!(_DECRYPTION_STATUS_BUFFER, NoEncryptedStreams) - 0usize];
};
pub type DECRYPTION_STATUS_BUFFER = _DECRYPTION_STATUS_BUFFER;
pub type PDECRYPTION_STATUS_BUFFER = *mut _DECRYPTION_STATUS_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REQUEST_RAW_ENCRYPTED_DATA {
    pub FileOffset: LONGLONG,
    pub Length: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REQUEST_RAW_ENCRYPTED_DATA"]
        [::std::mem::size_of::<_REQUEST_RAW_ENCRYPTED_DATA>() - 16usize];
    ["Alignment of _REQUEST_RAW_ENCRYPTED_DATA"]
        [::std::mem::align_of::<_REQUEST_RAW_ENCRYPTED_DATA>() - 8usize];
    ["Offset of field: _REQUEST_RAW_ENCRYPTED_DATA::FileOffset"]
        [::std::mem::offset_of!(_REQUEST_RAW_ENCRYPTED_DATA, FileOffset) - 0usize];
    ["Offset of field: _REQUEST_RAW_ENCRYPTED_DATA::Length"]
        [::std::mem::offset_of!(_REQUEST_RAW_ENCRYPTED_DATA, Length) - 8usize];
};
pub type REQUEST_RAW_ENCRYPTED_DATA = _REQUEST_RAW_ENCRYPTED_DATA;
pub type PREQUEST_RAW_ENCRYPTED_DATA = *mut _REQUEST_RAW_ENCRYPTED_DATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTED_DATA_INFO {
    pub StartingFileOffset: DWORDLONG,
    pub OutputBufferOffset: DWORD,
    pub BytesWithinFileSize: DWORD,
    pub BytesWithinValidDataLength: DWORD,
    pub CompressionFormat: WORD,
    pub DataUnitShift: BYTE,
    pub ChunkShift: BYTE,
    pub ClusterShift: BYTE,
    pub EncryptionFormat: BYTE,
    pub NumberOfDataBlocks: WORD,
    pub DataBlockSize: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTED_DATA_INFO"][::std::mem::size_of::<_ENCRYPTED_DATA_INFO>() - 32usize];
    ["Alignment of _ENCRYPTED_DATA_INFO"][::std::mem::align_of::<_ENCRYPTED_DATA_INFO>() - 8usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::StartingFileOffset"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, StartingFileOffset) - 0usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::OutputBufferOffset"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, OutputBufferOffset) - 8usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::BytesWithinFileSize"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, BytesWithinFileSize) - 12usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::BytesWithinValidDataLength"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, BytesWithinValidDataLength) - 16usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::CompressionFormat"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, CompressionFormat) - 20usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::DataUnitShift"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, DataUnitShift) - 22usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::ChunkShift"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, ChunkShift) - 23usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::ClusterShift"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, ClusterShift) - 24usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::EncryptionFormat"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, EncryptionFormat) - 25usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::NumberOfDataBlocks"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, NumberOfDataBlocks) - 26usize];
    ["Offset of field: _ENCRYPTED_DATA_INFO::DataBlockSize"]
        [::std::mem::offset_of!(_ENCRYPTED_DATA_INFO, DataBlockSize) - 28usize];
};
pub type ENCRYPTED_DATA_INFO = _ENCRYPTED_DATA_INFO;
pub type PENCRYPTED_DATA_INFO = *mut _ENCRYPTED_DATA_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _EXTENDED_ENCRYPTED_DATA_INFO {
    pub ExtendedCode: DWORD,
    pub Length: DWORD,
    pub Flags: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _EXTENDED_ENCRYPTED_DATA_INFO"]
        [::std::mem::size_of::<_EXTENDED_ENCRYPTED_DATA_INFO>() - 16usize];
    ["Alignment of _EXTENDED_ENCRYPTED_DATA_INFO"]
        [::std::mem::align_of::<_EXTENDED_ENCRYPTED_DATA_INFO>() - 4usize];
    ["Offset of field: _EXTENDED_ENCRYPTED_DATA_INFO::ExtendedCode"]
        [::std::mem::offset_of!(_EXTENDED_ENCRYPTED_DATA_INFO, ExtendedCode) - 0usize];
    ["Offset of field: _EXTENDED_ENCRYPTED_DATA_INFO::Length"]
        [::std::mem::offset_of!(_EXTENDED_ENCRYPTED_DATA_INFO, Length) - 4usize];
    ["Offset of field: _EXTENDED_ENCRYPTED_DATA_INFO::Flags"]
        [::std::mem::offset_of!(_EXTENDED_ENCRYPTED_DATA_INFO, Flags) - 8usize];
    ["Offset of field: _EXTENDED_ENCRYPTED_DATA_INFO::Reserved"]
        [::std::mem::offset_of!(_EXTENDED_ENCRYPTED_DATA_INFO, Reserved) - 12usize];
};
pub type EXTENDED_ENCRYPTED_DATA_INFO = _EXTENDED_ENCRYPTED_DATA_INFO;
pub type PEXTENDED_ENCRYPTED_DATA_INFO = *mut _EXTENDED_ENCRYPTED_DATA_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PLEX_READ_DATA_REQUEST {
    pub ByteOffset: LARGE_INTEGER,
    pub ByteLength: DWORD,
    pub PlexNumber: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PLEX_READ_DATA_REQUEST"][::std::mem::size_of::<_PLEX_READ_DATA_REQUEST>() - 16usize];
    ["Alignment of _PLEX_READ_DATA_REQUEST"]
        [::std::mem::align_of::<_PLEX_READ_DATA_REQUEST>() - 8usize];
    ["Offset of field: _PLEX_READ_DATA_REQUEST::ByteOffset"]
        [::std::mem::offset_of!(_PLEX_READ_DATA_REQUEST, ByteOffset) - 0usize];
    ["Offset of field: _PLEX_READ_DATA_REQUEST::ByteLength"]
        [::std::mem::offset_of!(_PLEX_READ_DATA_REQUEST, ByteLength) - 8usize];
    ["Offset of field: _PLEX_READ_DATA_REQUEST::PlexNumber"]
        [::std::mem::offset_of!(_PLEX_READ_DATA_REQUEST, PlexNumber) - 12usize];
};
pub type PLEX_READ_DATA_REQUEST = _PLEX_READ_DATA_REQUEST;
pub type PPLEX_READ_DATA_REQUEST = *mut _PLEX_READ_DATA_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SI_COPYFILE {
    pub SourceFileNameLength: DWORD,
    pub DestinationFileNameLength: DWORD,
    pub Flags: DWORD,
    pub FileNameBuffer: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SI_COPYFILE"][::std::mem::size_of::<_SI_COPYFILE>() - 16usize];
    ["Alignment of _SI_COPYFILE"][::std::mem::align_of::<_SI_COPYFILE>() - 4usize];
    ["Offset of field: _SI_COPYFILE::SourceFileNameLength"]
        [::std::mem::offset_of!(_SI_COPYFILE, SourceFileNameLength) - 0usize];
    ["Offset of field: _SI_COPYFILE::DestinationFileNameLength"]
        [::std::mem::offset_of!(_SI_COPYFILE, DestinationFileNameLength) - 4usize];
    ["Offset of field: _SI_COPYFILE::Flags"][::std::mem::offset_of!(_SI_COPYFILE, Flags) - 8usize];
    ["Offset of field: _SI_COPYFILE::FileNameBuffer"]
        [::std::mem::offset_of!(_SI_COPYFILE, FileNameBuffer) - 12usize];
};
pub type SI_COPYFILE = _SI_COPYFILE;
pub type PSI_COPYFILE = *mut _SI_COPYFILE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_MAKE_COMPATIBLE_BUFFER {
    pub CloseDisc: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_MAKE_COMPATIBLE_BUFFER"]
        [::std::mem::size_of::<_FILE_MAKE_COMPATIBLE_BUFFER>() - 1usize];
    ["Alignment of _FILE_MAKE_COMPATIBLE_BUFFER"]
        [::std::mem::align_of::<_FILE_MAKE_COMPATIBLE_BUFFER>() - 1usize];
    ["Offset of field: _FILE_MAKE_COMPATIBLE_BUFFER::CloseDisc"]
        [::std::mem::offset_of!(_FILE_MAKE_COMPATIBLE_BUFFER, CloseDisc) - 0usize];
};
pub type FILE_MAKE_COMPATIBLE_BUFFER = _FILE_MAKE_COMPATIBLE_BUFFER;
pub type PFILE_MAKE_COMPATIBLE_BUFFER = *mut _FILE_MAKE_COMPATIBLE_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_SET_DEFECT_MGMT_BUFFER {
    pub Disable: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_SET_DEFECT_MGMT_BUFFER"]
        [::std::mem::size_of::<_FILE_SET_DEFECT_MGMT_BUFFER>() - 1usize];
    ["Alignment of _FILE_SET_DEFECT_MGMT_BUFFER"]
        [::std::mem::align_of::<_FILE_SET_DEFECT_MGMT_BUFFER>() - 1usize];
    ["Offset of field: _FILE_SET_DEFECT_MGMT_BUFFER::Disable"]
        [::std::mem::offset_of!(_FILE_SET_DEFECT_MGMT_BUFFER, Disable) - 0usize];
};
pub type FILE_SET_DEFECT_MGMT_BUFFER = _FILE_SET_DEFECT_MGMT_BUFFER;
pub type PFILE_SET_DEFECT_MGMT_BUFFER = *mut _FILE_SET_DEFECT_MGMT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_QUERY_SPARING_BUFFER {
    pub SparingUnitBytes: DWORD,
    pub SoftwareSparing: BOOLEAN,
    pub TotalSpareBlocks: DWORD,
    pub FreeSpareBlocks: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_QUERY_SPARING_BUFFER"]
        [::std::mem::size_of::<_FILE_QUERY_SPARING_BUFFER>() - 16usize];
    ["Alignment of _FILE_QUERY_SPARING_BUFFER"]
        [::std::mem::align_of::<_FILE_QUERY_SPARING_BUFFER>() - 4usize];
    ["Offset of field: _FILE_QUERY_SPARING_BUFFER::SparingUnitBytes"]
        [::std::mem::offset_of!(_FILE_QUERY_SPARING_BUFFER, SparingUnitBytes) - 0usize];
    ["Offset of field: _FILE_QUERY_SPARING_BUFFER::SoftwareSparing"]
        [::std::mem::offset_of!(_FILE_QUERY_SPARING_BUFFER, SoftwareSparing) - 4usize];
    ["Offset of field: _FILE_QUERY_SPARING_BUFFER::TotalSpareBlocks"]
        [::std::mem::offset_of!(_FILE_QUERY_SPARING_BUFFER, TotalSpareBlocks) - 8usize];
    ["Offset of field: _FILE_QUERY_SPARING_BUFFER::FreeSpareBlocks"]
        [::std::mem::offset_of!(_FILE_QUERY_SPARING_BUFFER, FreeSpareBlocks) - 12usize];
};
pub type FILE_QUERY_SPARING_BUFFER = _FILE_QUERY_SPARING_BUFFER;
pub type PFILE_QUERY_SPARING_BUFFER = *mut _FILE_QUERY_SPARING_BUFFER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER {
    pub DirectoryCount: LARGE_INTEGER,
    pub FileCount: LARGE_INTEGER,
    pub FsFormatMajVersion: WORD,
    pub FsFormatMinVersion: WORD,
    pub FsFormatName: [WCHAR; 12usize],
    pub FormatTime: LARGE_INTEGER,
    pub LastUpdateTime: LARGE_INTEGER,
    pub CopyrightInfo: [WCHAR; 34usize],
    pub AbstractInfo: [WCHAR; 34usize],
    pub FormattingImplementationInfo: [WCHAR; 34usize],
    pub LastModifyingImplementationInfo: [WCHAR; 34usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER"]
        [::std::mem::size_of::<_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER>() - 336usize];
    ["Alignment of _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER"]
        [::std::mem::align_of::<_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER>() - 8usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::DirectoryCount"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, DirectoryCount) - 0usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FileCount"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, FileCount) - 8usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FsFormatMajVersion"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, FsFormatMajVersion) - 16usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FsFormatMinVersion"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, FsFormatMinVersion) - 18usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FsFormatName"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, FsFormatName) - 20usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FormatTime"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, FormatTime) - 48usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::LastUpdateTime"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, LastUpdateTime) - 56usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::CopyrightInfo"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, CopyrightInfo) - 64usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::AbstractInfo"]
        [::std::mem::offset_of!(_FILE_QUERY_ON_DISK_VOL_INFO_BUFFER, AbstractInfo) - 132usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::FormattingImplementationInfo"][::std::mem::offset_of!(
        _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER,
        FormattingImplementationInfo
    )
        - 200usize];
    ["Offset of field: _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER::LastModifyingImplementationInfo"][::std::mem::offset_of!(
        _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER,
        LastModifyingImplementationInfo
    )
        - 268usize];
};
pub type FILE_QUERY_ON_DISK_VOL_INFO_BUFFER = _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER;
pub type PFILE_QUERY_ON_DISK_VOL_INFO_BUFFER = *mut _FILE_QUERY_ON_DISK_VOL_INFO_BUFFER;
pub type CLSN = DWORDLONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_INITIATE_REPAIR_OUTPUT_BUFFER {
    pub Hint1: DWORDLONG,
    pub Hint2: DWORDLONG,
    pub Clsn: CLSN,
    pub Status: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_INITIATE_REPAIR_OUTPUT_BUFFER"]
        [::std::mem::size_of::<_FILE_INITIATE_REPAIR_OUTPUT_BUFFER>() - 32usize];
    ["Alignment of _FILE_INITIATE_REPAIR_OUTPUT_BUFFER"]
        [::std::mem::align_of::<_FILE_INITIATE_REPAIR_OUTPUT_BUFFER>() - 8usize];
    ["Offset of field: _FILE_INITIATE_REPAIR_OUTPUT_BUFFER::Hint1"]
        [::std::mem::offset_of!(_FILE_INITIATE_REPAIR_OUTPUT_BUFFER, Hint1) - 0usize];
    ["Offset of field: _FILE_INITIATE_REPAIR_OUTPUT_BUFFER::Hint2"]
        [::std::mem::offset_of!(_FILE_INITIATE_REPAIR_OUTPUT_BUFFER, Hint2) - 8usize];
    ["Offset of field: _FILE_INITIATE_REPAIR_OUTPUT_BUFFER::Clsn"]
        [::std::mem::offset_of!(_FILE_INITIATE_REPAIR_OUTPUT_BUFFER, Clsn) - 16usize];
    ["Offset of field: _FILE_INITIATE_REPAIR_OUTPUT_BUFFER::Status"]
        [::std::mem::offset_of!(_FILE_INITIATE_REPAIR_OUTPUT_BUFFER, Status) - 24usize];
};
pub type FILE_INITIATE_REPAIR_OUTPUT_BUFFER = _FILE_INITIATE_REPAIR_OUTPUT_BUFFER;
pub type PFILE_INITIATE_REPAIR_OUTPUT_BUFFER = *mut _FILE_INITIATE_REPAIR_OUTPUT_BUFFER;
pub const _SHRINK_VOLUME_REQUEST_TYPES_ShrinkPrepare: _SHRINK_VOLUME_REQUEST_TYPES = 1;
pub const _SHRINK_VOLUME_REQUEST_TYPES_ShrinkCommit: _SHRINK_VOLUME_REQUEST_TYPES = 2;
pub const _SHRINK_VOLUME_REQUEST_TYPES_ShrinkAbort: _SHRINK_VOLUME_REQUEST_TYPES = 3;
pub type _SHRINK_VOLUME_REQUEST_TYPES = ::std::os::raw::c_int;
pub use self::_SHRINK_VOLUME_REQUEST_TYPES as SHRINK_VOLUME_REQUEST_TYPES;
pub type PSHRINK_VOLUME_REQUEST_TYPES = *mut _SHRINK_VOLUME_REQUEST_TYPES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SHRINK_VOLUME_INFORMATION {
    pub ShrinkRequestType: SHRINK_VOLUME_REQUEST_TYPES,
    pub Flags: DWORDLONG,
    pub NewNumberOfSectors: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SHRINK_VOLUME_INFORMATION"]
        [::std::mem::size_of::<_SHRINK_VOLUME_INFORMATION>() - 24usize];
    ["Alignment of _SHRINK_VOLUME_INFORMATION"]
        [::std::mem::align_of::<_SHRINK_VOLUME_INFORMATION>() - 8usize];
    ["Offset of field: _SHRINK_VOLUME_INFORMATION::ShrinkRequestType"]
        [::std::mem::offset_of!(_SHRINK_VOLUME_INFORMATION, ShrinkRequestType) - 0usize];
    ["Offset of field: _SHRINK_VOLUME_INFORMATION::Flags"]
        [::std::mem::offset_of!(_SHRINK_VOLUME_INFORMATION, Flags) - 8usize];
    ["Offset of field: _SHRINK_VOLUME_INFORMATION::NewNumberOfSectors"]
        [::std::mem::offset_of!(_SHRINK_VOLUME_INFORMATION, NewNumberOfSectors) - 16usize];
};
pub type SHRINK_VOLUME_INFORMATION = _SHRINK_VOLUME_INFORMATION;
pub type PSHRINK_VOLUME_INFORMATION = *mut _SHRINK_VOLUME_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_MODIFY_RM {
    pub Flags: DWORD,
    pub LogContainerCountMax: DWORD,
    pub LogContainerCountMin: DWORD,
    pub LogContainerCount: DWORD,
    pub LogGrowthIncrement: DWORD,
    pub LogAutoShrinkPercentage: DWORD,
    pub Reserved: DWORDLONG,
    pub LoggingMode: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_MODIFY_RM"][::std::mem::size_of::<_TXFS_MODIFY_RM>() - 40usize];
    ["Alignment of _TXFS_MODIFY_RM"][::std::mem::align_of::<_TXFS_MODIFY_RM>() - 8usize];
    ["Offset of field: _TXFS_MODIFY_RM::Flags"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, Flags) - 0usize];
    ["Offset of field: _TXFS_MODIFY_RM::LogContainerCountMax"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LogContainerCountMax) - 4usize];
    ["Offset of field: _TXFS_MODIFY_RM::LogContainerCountMin"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LogContainerCountMin) - 8usize];
    ["Offset of field: _TXFS_MODIFY_RM::LogContainerCount"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LogContainerCount) - 12usize];
    ["Offset of field: _TXFS_MODIFY_RM::LogGrowthIncrement"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LogGrowthIncrement) - 16usize];
    ["Offset of field: _TXFS_MODIFY_RM::LogAutoShrinkPercentage"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LogAutoShrinkPercentage) - 20usize];
    ["Offset of field: _TXFS_MODIFY_RM::Reserved"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, Reserved) - 24usize];
    ["Offset of field: _TXFS_MODIFY_RM::LoggingMode"]
        [::std::mem::offset_of!(_TXFS_MODIFY_RM, LoggingMode) - 32usize];
};
pub type TXFS_MODIFY_RM = _TXFS_MODIFY_RM;
pub type PTXFS_MODIFY_RM = *mut _TXFS_MODIFY_RM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TXFS_QUERY_RM_INFORMATION {
    pub BytesRequired: DWORD,
    pub TailLsn: DWORDLONG,
    pub CurrentLsn: DWORDLONG,
    pub ArchiveTailLsn: DWORDLONG,
    pub LogContainerSize: DWORDLONG,
    pub HighestVirtualClock: LARGE_INTEGER,
    pub LogContainerCount: DWORD,
    pub LogContainerCountMax: DWORD,
    pub LogContainerCountMin: DWORD,
    pub LogGrowthIncrement: DWORD,
    pub LogAutoShrinkPercentage: DWORD,
    pub Flags: DWORD,
    pub LoggingMode: WORD,
    pub Reserved: WORD,
    pub RmState: DWORD,
    pub LogCapacity: DWORDLONG,
    pub LogFree: DWORDLONG,
    pub TopsSize: DWORDLONG,
    pub TopsUsed: DWORDLONG,
    pub TransactionCount: DWORDLONG,
    pub OnePCCount: DWORDLONG,
    pub TwoPCCount: DWORDLONG,
    pub NumberLogFileFull: DWORDLONG,
    pub OldestTransactionAge: DWORDLONG,
    pub RMName: GUID,
    pub TmLogPathOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_QUERY_RM_INFORMATION"]
        [::std::mem::size_of::<_TXFS_QUERY_RM_INFORMATION>() - 176usize];
    ["Alignment of _TXFS_QUERY_RM_INFORMATION"]
        [::std::mem::align_of::<_TXFS_QUERY_RM_INFORMATION>() - 8usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::BytesRequired"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, BytesRequired) - 0usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TailLsn"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TailLsn) - 8usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::CurrentLsn"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, CurrentLsn) - 16usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::ArchiveTailLsn"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, ArchiveTailLsn) - 24usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogContainerSize"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogContainerSize) - 32usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::HighestVirtualClock"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, HighestVirtualClock) - 40usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogContainerCount"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogContainerCount) - 48usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogContainerCountMax"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogContainerCountMax) - 52usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogContainerCountMin"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogContainerCountMin) - 56usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogGrowthIncrement"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogGrowthIncrement) - 60usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogAutoShrinkPercentage"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogAutoShrinkPercentage) - 64usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::Flags"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, Flags) - 68usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LoggingMode"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LoggingMode) - 72usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::Reserved"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, Reserved) - 74usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::RmState"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, RmState) - 76usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogCapacity"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogCapacity) - 80usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::LogFree"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, LogFree) - 88usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TopsSize"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TopsSize) - 96usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TopsUsed"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TopsUsed) - 104usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TransactionCount"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TransactionCount) - 112usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::OnePCCount"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, OnePCCount) - 120usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TwoPCCount"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TwoPCCount) - 128usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::NumberLogFileFull"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, NumberLogFileFull) - 136usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::OldestTransactionAge"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, OldestTransactionAge) - 144usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::RMName"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, RMName) - 152usize];
    ["Offset of field: _TXFS_QUERY_RM_INFORMATION::TmLogPathOffset"]
        [::std::mem::offset_of!(_TXFS_QUERY_RM_INFORMATION, TmLogPathOffset) - 168usize];
};
pub type TXFS_QUERY_RM_INFORMATION = _TXFS_QUERY_RM_INFORMATION;
pub type PTXFS_QUERY_RM_INFORMATION = *mut _TXFS_QUERY_RM_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TXFS_ROLLFORWARD_REDO_INFORMATION {
    pub LastVirtualClock: LARGE_INTEGER,
    pub LastRedoLsn: DWORDLONG,
    pub HighestRecoveryLsn: DWORDLONG,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_ROLLFORWARD_REDO_INFORMATION"]
        [::std::mem::size_of::<_TXFS_ROLLFORWARD_REDO_INFORMATION>() - 32usize];
    ["Alignment of _TXFS_ROLLFORWARD_REDO_INFORMATION"]
        [::std::mem::align_of::<_TXFS_ROLLFORWARD_REDO_INFORMATION>() - 8usize];
    ["Offset of field: _TXFS_ROLLFORWARD_REDO_INFORMATION::LastVirtualClock"]
        [::std::mem::offset_of!(_TXFS_ROLLFORWARD_REDO_INFORMATION, LastVirtualClock) - 0usize];
    ["Offset of field: _TXFS_ROLLFORWARD_REDO_INFORMATION::LastRedoLsn"]
        [::std::mem::offset_of!(_TXFS_ROLLFORWARD_REDO_INFORMATION, LastRedoLsn) - 8usize];
    ["Offset of field: _TXFS_ROLLFORWARD_REDO_INFORMATION::HighestRecoveryLsn"]
        [::std::mem::offset_of!(_TXFS_ROLLFORWARD_REDO_INFORMATION, HighestRecoveryLsn) - 16usize];
    ["Offset of field: _TXFS_ROLLFORWARD_REDO_INFORMATION::Flags"]
        [::std::mem::offset_of!(_TXFS_ROLLFORWARD_REDO_INFORMATION, Flags) - 24usize];
};
pub type TXFS_ROLLFORWARD_REDO_INFORMATION = _TXFS_ROLLFORWARD_REDO_INFORMATION;
pub type PTXFS_ROLLFORWARD_REDO_INFORMATION = *mut _TXFS_ROLLFORWARD_REDO_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_START_RM_INFORMATION {
    pub Flags: DWORD,
    pub LogContainerSize: DWORDLONG,
    pub LogContainerCountMin: DWORD,
    pub LogContainerCountMax: DWORD,
    pub LogGrowthIncrement: DWORD,
    pub LogAutoShrinkPercentage: DWORD,
    pub TmLogPathOffset: DWORD,
    pub TmLogPathLength: WORD,
    pub LoggingMode: WORD,
    pub LogPathLength: WORD,
    pub Reserved: WORD,
    pub LogPath: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_START_RM_INFORMATION"]
        [::std::mem::size_of::<_TXFS_START_RM_INFORMATION>() - 48usize];
    ["Alignment of _TXFS_START_RM_INFORMATION"]
        [::std::mem::align_of::<_TXFS_START_RM_INFORMATION>() - 8usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::Flags"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, Flags) - 0usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogContainerSize"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogContainerSize) - 8usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogContainerCountMin"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogContainerCountMin) - 16usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogContainerCountMax"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogContainerCountMax) - 20usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogGrowthIncrement"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogGrowthIncrement) - 24usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogAutoShrinkPercentage"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogAutoShrinkPercentage) - 28usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::TmLogPathOffset"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, TmLogPathOffset) - 32usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::TmLogPathLength"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, TmLogPathLength) - 36usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LoggingMode"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LoggingMode) - 38usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogPathLength"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogPathLength) - 40usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::Reserved"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, Reserved) - 42usize];
    ["Offset of field: _TXFS_START_RM_INFORMATION::LogPath"]
        [::std::mem::offset_of!(_TXFS_START_RM_INFORMATION, LogPath) - 44usize];
};
pub type TXFS_START_RM_INFORMATION = _TXFS_START_RM_INFORMATION;
pub type PTXFS_START_RM_INFORMATION = *mut _TXFS_START_RM_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_GET_METADATA_INFO_OUT {
    pub TxfFileId: _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1,
    pub LockingTransaction: GUID,
    pub LastLsn: DWORDLONG,
    pub TransactionState: DWORD,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1 {
    pub LowPart: LONGLONG,
    pub HighPart: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1"]
        [::std::mem::size_of::<_TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1>() - 16usize];
    ["Alignment of _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1"]
        [::std::mem::align_of::<_TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1::LowPart"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1, LowPart) - 0usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1::HighPart"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT__bindgen_ty_1, HighPart) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_GET_METADATA_INFO_OUT"]
        [::std::mem::size_of::<_TXFS_GET_METADATA_INFO_OUT>() - 48usize];
    ["Alignment of _TXFS_GET_METADATA_INFO_OUT"]
        [::std::mem::align_of::<_TXFS_GET_METADATA_INFO_OUT>() - 8usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT::TxfFileId"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT, TxfFileId) - 0usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT::LockingTransaction"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT, LockingTransaction) - 16usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT::LastLsn"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT, LastLsn) - 32usize];
    ["Offset of field: _TXFS_GET_METADATA_INFO_OUT::TransactionState"]
        [::std::mem::offset_of!(_TXFS_GET_METADATA_INFO_OUT, TransactionState) - 40usize];
};
pub type TXFS_GET_METADATA_INFO_OUT = _TXFS_GET_METADATA_INFO_OUT;
pub type PTXFS_GET_METADATA_INFO_OUT = *mut _TXFS_GET_METADATA_INFO_OUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY {
    pub Offset: DWORDLONG,
    pub NameFlags: DWORD,
    pub FileId: LONGLONG,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD,
    pub Reserved3: LONGLONG,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY"]
        [::std::mem::size_of::<_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY>() - 48usize];
    ["Alignment of _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY"]
        [::std::mem::align_of::<_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY>() - 8usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::Offset"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, Offset) - 0usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::NameFlags"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, NameFlags) - 8usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::FileId"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, FileId) - 16usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::Reserved1"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, Reserved1) - 24usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::Reserved2"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, Reserved2) - 28usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::Reserved3"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, Reserved3) - 32usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY::FileName"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY, FileName) - 40usize];
};
pub type TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY = _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY;
pub type PTXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY = *mut _TXFS_LIST_TRANSACTION_LOCKED_FILES_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_LIST_TRANSACTION_LOCKED_FILES {
    pub KtmTransaction: GUID,
    pub NumberOfFiles: DWORDLONG,
    pub BufferSizeRequired: DWORDLONG,
    pub Offset: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_LIST_TRANSACTION_LOCKED_FILES"]
        [::std::mem::size_of::<_TXFS_LIST_TRANSACTION_LOCKED_FILES>() - 40usize];
    ["Alignment of _TXFS_LIST_TRANSACTION_LOCKED_FILES"]
        [::std::mem::align_of::<_TXFS_LIST_TRANSACTION_LOCKED_FILES>() - 8usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES::KtmTransaction"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES, KtmTransaction) - 0usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES::NumberOfFiles"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES, NumberOfFiles) - 16usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES::BufferSizeRequired"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES, BufferSizeRequired) - 24usize];
    ["Offset of field: _TXFS_LIST_TRANSACTION_LOCKED_FILES::Offset"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTION_LOCKED_FILES, Offset) - 32usize];
};
pub type TXFS_LIST_TRANSACTION_LOCKED_FILES = _TXFS_LIST_TRANSACTION_LOCKED_FILES;
pub type PTXFS_LIST_TRANSACTION_LOCKED_FILES = *mut _TXFS_LIST_TRANSACTION_LOCKED_FILES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_LIST_TRANSACTIONS_ENTRY {
    pub TransactionId: GUID,
    pub TransactionState: DWORD,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD,
    pub Reserved3: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_LIST_TRANSACTIONS_ENTRY"]
        [::std::mem::size_of::<_TXFS_LIST_TRANSACTIONS_ENTRY>() - 40usize];
    ["Alignment of _TXFS_LIST_TRANSACTIONS_ENTRY"]
        [::std::mem::align_of::<_TXFS_LIST_TRANSACTIONS_ENTRY>() - 8usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS_ENTRY::TransactionId"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS_ENTRY, TransactionId) - 0usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS_ENTRY::TransactionState"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS_ENTRY, TransactionState) - 16usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS_ENTRY::Reserved1"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS_ENTRY, Reserved1) - 20usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS_ENTRY::Reserved2"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS_ENTRY, Reserved2) - 24usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS_ENTRY::Reserved3"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS_ENTRY, Reserved3) - 32usize];
};
pub type TXFS_LIST_TRANSACTIONS_ENTRY = _TXFS_LIST_TRANSACTIONS_ENTRY;
pub type PTXFS_LIST_TRANSACTIONS_ENTRY = *mut _TXFS_LIST_TRANSACTIONS_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_LIST_TRANSACTIONS {
    pub NumberOfTransactions: DWORDLONG,
    pub BufferSizeRequired: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_LIST_TRANSACTIONS"][::std::mem::size_of::<_TXFS_LIST_TRANSACTIONS>() - 16usize];
    ["Alignment of _TXFS_LIST_TRANSACTIONS"]
        [::std::mem::align_of::<_TXFS_LIST_TRANSACTIONS>() - 8usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS::NumberOfTransactions"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS, NumberOfTransactions) - 0usize];
    ["Offset of field: _TXFS_LIST_TRANSACTIONS::BufferSizeRequired"]
        [::std::mem::offset_of!(_TXFS_LIST_TRANSACTIONS, BufferSizeRequired) - 8usize];
};
pub type TXFS_LIST_TRANSACTIONS = _TXFS_LIST_TRANSACTIONS;
pub type PTXFS_LIST_TRANSACTIONS = *mut _TXFS_LIST_TRANSACTIONS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _TXFS_READ_BACKUP_INFORMATION_OUT {
    pub __bindgen_anon_1: _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1 {
    pub BufferLength: DWORD,
    pub Buffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1"]
        [::std::mem::size_of::<_TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1>() - 4usize];
    ["Alignment of _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1"]
        [::std::mem::align_of::<_TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1>() - 4usize];
    ["Offset of field: _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1::BufferLength"][::std::mem::offset_of!(
        _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1,
        BufferLength
    ) - 0usize];
    ["Offset of field: _TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1::Buffer"]
        [::std::mem::offset_of!(_TXFS_READ_BACKUP_INFORMATION_OUT__bindgen_ty_1, Buffer) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_READ_BACKUP_INFORMATION_OUT"]
        [::std::mem::size_of::<_TXFS_READ_BACKUP_INFORMATION_OUT>() - 4usize];
    ["Alignment of _TXFS_READ_BACKUP_INFORMATION_OUT"]
        [::std::mem::align_of::<_TXFS_READ_BACKUP_INFORMATION_OUT>() - 4usize];
};
pub type TXFS_READ_BACKUP_INFORMATION_OUT = _TXFS_READ_BACKUP_INFORMATION_OUT;
pub type PTXFS_READ_BACKUP_INFORMATION_OUT = *mut _TXFS_READ_BACKUP_INFORMATION_OUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_WRITE_BACKUP_INFORMATION {
    pub Buffer: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_WRITE_BACKUP_INFORMATION"]
        [::std::mem::size_of::<_TXFS_WRITE_BACKUP_INFORMATION>() - 1usize];
    ["Alignment of _TXFS_WRITE_BACKUP_INFORMATION"]
        [::std::mem::align_of::<_TXFS_WRITE_BACKUP_INFORMATION>() - 1usize];
    ["Offset of field: _TXFS_WRITE_BACKUP_INFORMATION::Buffer"]
        [::std::mem::offset_of!(_TXFS_WRITE_BACKUP_INFORMATION, Buffer) - 0usize];
};
pub type TXFS_WRITE_BACKUP_INFORMATION = _TXFS_WRITE_BACKUP_INFORMATION;
pub type PTXFS_WRITE_BACKUP_INFORMATION = *mut _TXFS_WRITE_BACKUP_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_GET_TRANSACTED_VERSION {
    pub ThisBaseVersion: DWORD,
    pub LatestVersion: DWORD,
    pub ThisMiniVersion: WORD,
    pub FirstMiniVersion: WORD,
    pub LatestMiniVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_GET_TRANSACTED_VERSION"]
        [::std::mem::size_of::<_TXFS_GET_TRANSACTED_VERSION>() - 16usize];
    ["Alignment of _TXFS_GET_TRANSACTED_VERSION"]
        [::std::mem::align_of::<_TXFS_GET_TRANSACTED_VERSION>() - 4usize];
    ["Offset of field: _TXFS_GET_TRANSACTED_VERSION::ThisBaseVersion"]
        [::std::mem::offset_of!(_TXFS_GET_TRANSACTED_VERSION, ThisBaseVersion) - 0usize];
    ["Offset of field: _TXFS_GET_TRANSACTED_VERSION::LatestVersion"]
        [::std::mem::offset_of!(_TXFS_GET_TRANSACTED_VERSION, LatestVersion) - 4usize];
    ["Offset of field: _TXFS_GET_TRANSACTED_VERSION::ThisMiniVersion"]
        [::std::mem::offset_of!(_TXFS_GET_TRANSACTED_VERSION, ThisMiniVersion) - 8usize];
    ["Offset of field: _TXFS_GET_TRANSACTED_VERSION::FirstMiniVersion"]
        [::std::mem::offset_of!(_TXFS_GET_TRANSACTED_VERSION, FirstMiniVersion) - 10usize];
    ["Offset of field: _TXFS_GET_TRANSACTED_VERSION::LatestMiniVersion"]
        [::std::mem::offset_of!(_TXFS_GET_TRANSACTED_VERSION, LatestMiniVersion) - 12usize];
};
pub type TXFS_GET_TRANSACTED_VERSION = _TXFS_GET_TRANSACTED_VERSION;
pub type PTXFS_GET_TRANSACTED_VERSION = *mut _TXFS_GET_TRANSACTED_VERSION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_SAVEPOINT_INFORMATION {
    pub KtmTransaction: HANDLE,
    pub ActionCode: DWORD,
    pub SavepointId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_SAVEPOINT_INFORMATION"]
        [::std::mem::size_of::<_TXFS_SAVEPOINT_INFORMATION>() - 16usize];
    ["Alignment of _TXFS_SAVEPOINT_INFORMATION"]
        [::std::mem::align_of::<_TXFS_SAVEPOINT_INFORMATION>() - 8usize];
    ["Offset of field: _TXFS_SAVEPOINT_INFORMATION::KtmTransaction"]
        [::std::mem::offset_of!(_TXFS_SAVEPOINT_INFORMATION, KtmTransaction) - 0usize];
    ["Offset of field: _TXFS_SAVEPOINT_INFORMATION::ActionCode"]
        [::std::mem::offset_of!(_TXFS_SAVEPOINT_INFORMATION, ActionCode) - 8usize];
    ["Offset of field: _TXFS_SAVEPOINT_INFORMATION::SavepointId"]
        [::std::mem::offset_of!(_TXFS_SAVEPOINT_INFORMATION, SavepointId) - 12usize];
};
pub type TXFS_SAVEPOINT_INFORMATION = _TXFS_SAVEPOINT_INFORMATION;
pub type PTXFS_SAVEPOINT_INFORMATION = *mut _TXFS_SAVEPOINT_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_CREATE_MINIVERSION_INFO {
    pub StructureVersion: WORD,
    pub StructureLength: WORD,
    pub BaseVersion: DWORD,
    pub MiniVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_CREATE_MINIVERSION_INFO"]
        [::std::mem::size_of::<_TXFS_CREATE_MINIVERSION_INFO>() - 12usize];
    ["Alignment of _TXFS_CREATE_MINIVERSION_INFO"]
        [::std::mem::align_of::<_TXFS_CREATE_MINIVERSION_INFO>() - 4usize];
    ["Offset of field: _TXFS_CREATE_MINIVERSION_INFO::StructureVersion"]
        [::std::mem::offset_of!(_TXFS_CREATE_MINIVERSION_INFO, StructureVersion) - 0usize];
    ["Offset of field: _TXFS_CREATE_MINIVERSION_INFO::StructureLength"]
        [::std::mem::offset_of!(_TXFS_CREATE_MINIVERSION_INFO, StructureLength) - 2usize];
    ["Offset of field: _TXFS_CREATE_MINIVERSION_INFO::BaseVersion"]
        [::std::mem::offset_of!(_TXFS_CREATE_MINIVERSION_INFO, BaseVersion) - 4usize];
    ["Offset of field: _TXFS_CREATE_MINIVERSION_INFO::MiniVersion"]
        [::std::mem::offset_of!(_TXFS_CREATE_MINIVERSION_INFO, MiniVersion) - 8usize];
};
pub type TXFS_CREATE_MINIVERSION_INFO = _TXFS_CREATE_MINIVERSION_INFO;
pub type PTXFS_CREATE_MINIVERSION_INFO = *mut _TXFS_CREATE_MINIVERSION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _TXFS_TRANSACTION_ACTIVE_INFO {
    pub TransactionsActiveAtSnapshot: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _TXFS_TRANSACTION_ACTIVE_INFO"]
        [::std::mem::size_of::<_TXFS_TRANSACTION_ACTIVE_INFO>() - 1usize];
    ["Alignment of _TXFS_TRANSACTION_ACTIVE_INFO"]
        [::std::mem::align_of::<_TXFS_TRANSACTION_ACTIVE_INFO>() - 1usize];
    ["Offset of field: _TXFS_TRANSACTION_ACTIVE_INFO::TransactionsActiveAtSnapshot"][::std::mem::offset_of!(
        _TXFS_TRANSACTION_ACTIVE_INFO,
        TransactionsActiveAtSnapshot
    ) - 0usize];
};
pub type TXFS_TRANSACTION_ACTIVE_INFO = _TXFS_TRANSACTION_ACTIVE_INFO;
pub type PTXFS_TRANSACTION_ACTIVE_INFO = *mut _TXFS_TRANSACTION_ACTIVE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BOOT_AREA_INFO {
    pub BootSectorCount: DWORD,
    pub BootSectors: [_BOOT_AREA_INFO__bindgen_ty_1; 2usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BOOT_AREA_INFO__bindgen_ty_1 {
    pub Offset: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BOOT_AREA_INFO__bindgen_ty_1"]
        [::std::mem::size_of::<_BOOT_AREA_INFO__bindgen_ty_1>() - 8usize];
    ["Alignment of _BOOT_AREA_INFO__bindgen_ty_1"]
        [::std::mem::align_of::<_BOOT_AREA_INFO__bindgen_ty_1>() - 8usize];
    ["Offset of field: _BOOT_AREA_INFO__bindgen_ty_1::Offset"]
        [::std::mem::offset_of!(_BOOT_AREA_INFO__bindgen_ty_1, Offset) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BOOT_AREA_INFO"][::std::mem::size_of::<_BOOT_AREA_INFO>() - 24usize];
    ["Alignment of _BOOT_AREA_INFO"][::std::mem::align_of::<_BOOT_AREA_INFO>() - 8usize];
    ["Offset of field: _BOOT_AREA_INFO::BootSectorCount"]
        [::std::mem::offset_of!(_BOOT_AREA_INFO, BootSectorCount) - 0usize];
    ["Offset of field: _BOOT_AREA_INFO::BootSectors"]
        [::std::mem::offset_of!(_BOOT_AREA_INFO, BootSectors) - 8usize];
};
pub type BOOT_AREA_INFO = _BOOT_AREA_INFO;
pub type PBOOT_AREA_INFO = *mut _BOOT_AREA_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _RETRIEVAL_POINTER_BASE {
    pub FileAreaOffset: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _RETRIEVAL_POINTER_BASE"][::std::mem::size_of::<_RETRIEVAL_POINTER_BASE>() - 8usize];
    ["Alignment of _RETRIEVAL_POINTER_BASE"]
        [::std::mem::align_of::<_RETRIEVAL_POINTER_BASE>() - 8usize];
    ["Offset of field: _RETRIEVAL_POINTER_BASE::FileAreaOffset"]
        [::std::mem::offset_of!(_RETRIEVAL_POINTER_BASE, FileAreaOffset) - 0usize];
};
pub type RETRIEVAL_POINTER_BASE = _RETRIEVAL_POINTER_BASE;
pub type PRETRIEVAL_POINTER_BASE = *mut _RETRIEVAL_POINTER_BASE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_FS_PERSISTENT_VOLUME_INFORMATION {
    pub VolumeFlags: DWORD,
    pub FlagMask: DWORD,
    pub Version: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_FS_PERSISTENT_VOLUME_INFORMATION"]
        [::std::mem::size_of::<_FILE_FS_PERSISTENT_VOLUME_INFORMATION>() - 16usize];
    ["Alignment of _FILE_FS_PERSISTENT_VOLUME_INFORMATION"]
        [::std::mem::align_of::<_FILE_FS_PERSISTENT_VOLUME_INFORMATION>() - 4usize];
    ["Offset of field: _FILE_FS_PERSISTENT_VOLUME_INFORMATION::VolumeFlags"]
        [::std::mem::offset_of!(_FILE_FS_PERSISTENT_VOLUME_INFORMATION, VolumeFlags) - 0usize];
    ["Offset of field: _FILE_FS_PERSISTENT_VOLUME_INFORMATION::FlagMask"]
        [::std::mem::offset_of!(_FILE_FS_PERSISTENT_VOLUME_INFORMATION, FlagMask) - 4usize];
    ["Offset of field: _FILE_FS_PERSISTENT_VOLUME_INFORMATION::Version"]
        [::std::mem::offset_of!(_FILE_FS_PERSISTENT_VOLUME_INFORMATION, Version) - 8usize];
    ["Offset of field: _FILE_FS_PERSISTENT_VOLUME_INFORMATION::Reserved"]
        [::std::mem::offset_of!(_FILE_FS_PERSISTENT_VOLUME_INFORMATION, Reserved) - 12usize];
};
pub type FILE_FS_PERSISTENT_VOLUME_INFORMATION = _FILE_FS_PERSISTENT_VOLUME_INFORMATION;
pub type PFILE_FS_PERSISTENT_VOLUME_INFORMATION = *mut _FILE_FS_PERSISTENT_VOLUME_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_SYSTEM_RECOGNITION_INFORMATION {
    pub FileSystem: [CHAR; 9usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_SYSTEM_RECOGNITION_INFORMATION"]
        [::std::mem::size_of::<_FILE_SYSTEM_RECOGNITION_INFORMATION>() - 9usize];
    ["Alignment of _FILE_SYSTEM_RECOGNITION_INFORMATION"]
        [::std::mem::align_of::<_FILE_SYSTEM_RECOGNITION_INFORMATION>() - 1usize];
    ["Offset of field: _FILE_SYSTEM_RECOGNITION_INFORMATION::FileSystem"]
        [::std::mem::offset_of!(_FILE_SYSTEM_RECOGNITION_INFORMATION, FileSystem) - 0usize];
};
pub type FILE_SYSTEM_RECOGNITION_INFORMATION = _FILE_SYSTEM_RECOGNITION_INFORMATION;
pub type PFILE_SYSTEM_RECOGNITION_INFORMATION = *mut _FILE_SYSTEM_RECOGNITION_INFORMATION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REQUEST_OPLOCK_INPUT_BUFFER {
    pub StructureVersion: WORD,
    pub StructureLength: WORD,
    pub RequestedOplockLevel: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REQUEST_OPLOCK_INPUT_BUFFER"]
        [::std::mem::size_of::<_REQUEST_OPLOCK_INPUT_BUFFER>() - 12usize];
    ["Alignment of _REQUEST_OPLOCK_INPUT_BUFFER"]
        [::std::mem::align_of::<_REQUEST_OPLOCK_INPUT_BUFFER>() - 4usize];
    ["Offset of field: _REQUEST_OPLOCK_INPUT_BUFFER::StructureVersion"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_INPUT_BUFFER, StructureVersion) - 0usize];
    ["Offset of field: _REQUEST_OPLOCK_INPUT_BUFFER::StructureLength"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_INPUT_BUFFER, StructureLength) - 2usize];
    ["Offset of field: _REQUEST_OPLOCK_INPUT_BUFFER::RequestedOplockLevel"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_INPUT_BUFFER, RequestedOplockLevel) - 4usize];
    ["Offset of field: _REQUEST_OPLOCK_INPUT_BUFFER::Flags"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_INPUT_BUFFER, Flags) - 8usize];
};
pub type REQUEST_OPLOCK_INPUT_BUFFER = _REQUEST_OPLOCK_INPUT_BUFFER;
pub type PREQUEST_OPLOCK_INPUT_BUFFER = *mut _REQUEST_OPLOCK_INPUT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REQUEST_OPLOCK_OUTPUT_BUFFER {
    pub StructureVersion: WORD,
    pub StructureLength: WORD,
    pub OriginalOplockLevel: DWORD,
    pub NewOplockLevel: DWORD,
    pub Flags: DWORD,
    pub AccessMode: ACCESS_MASK,
    pub ShareMode: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REQUEST_OPLOCK_OUTPUT_BUFFER"]
        [::std::mem::size_of::<_REQUEST_OPLOCK_OUTPUT_BUFFER>() - 24usize];
    ["Alignment of _REQUEST_OPLOCK_OUTPUT_BUFFER"]
        [::std::mem::align_of::<_REQUEST_OPLOCK_OUTPUT_BUFFER>() - 4usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::StructureVersion"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, StructureVersion) - 0usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::StructureLength"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, StructureLength) - 2usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::OriginalOplockLevel"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, OriginalOplockLevel) - 4usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::NewOplockLevel"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, NewOplockLevel) - 8usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::Flags"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, Flags) - 12usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::AccessMode"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, AccessMode) - 16usize];
    ["Offset of field: _REQUEST_OPLOCK_OUTPUT_BUFFER::ShareMode"]
        [::std::mem::offset_of!(_REQUEST_OPLOCK_OUTPUT_BUFFER, ShareMode) - 20usize];
};
pub type REQUEST_OPLOCK_OUTPUT_BUFFER = _REQUEST_OPLOCK_OUTPUT_BUFFER;
pub type PREQUEST_OPLOCK_OUTPUT_BUFFER = *mut _REQUEST_OPLOCK_OUTPUT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIRTUAL_STORAGE_TYPE {
    pub DeviceId: DWORD,
    pub VendorId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIRTUAL_STORAGE_TYPE"][::std::mem::size_of::<_VIRTUAL_STORAGE_TYPE>() - 20usize];
    ["Alignment of _VIRTUAL_STORAGE_TYPE"]
        [::std::mem::align_of::<_VIRTUAL_STORAGE_TYPE>() - 4usize];
    ["Offset of field: _VIRTUAL_STORAGE_TYPE::DeviceId"]
        [::std::mem::offset_of!(_VIRTUAL_STORAGE_TYPE, DeviceId) - 0usize];
    ["Offset of field: _VIRTUAL_STORAGE_TYPE::VendorId"]
        [::std::mem::offset_of!(_VIRTUAL_STORAGE_TYPE, VendorId) - 4usize];
};
pub type VIRTUAL_STORAGE_TYPE = _VIRTUAL_STORAGE_TYPE;
pub type PVIRTUAL_STORAGE_TYPE = *mut _VIRTUAL_STORAGE_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST {
    pub RequestLevel: DWORD,
    pub RequestFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST"]
        [::std::mem::size_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST>() - 8usize];
    ["Alignment of _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST"]
        [::std::mem::align_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST>() - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST::RequestLevel"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST, RequestLevel) - 0usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST::RequestFlags"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST, RequestFlags) - 4usize];
};
pub type STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST = _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST;
pub type PSTORAGE_QUERY_DEPENDENT_VOLUME_REQUEST = *mut _STORAGE_QUERY_DEPENDENT_VOLUME_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY {
    pub EntryLength: DWORD,
    pub DependencyTypeFlags: DWORD,
    pub ProviderSpecificFlags: DWORD,
    pub VirtualStorageType: VIRTUAL_STORAGE_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY"]
        [::std::mem::size_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY>() - 32usize];
    ["Alignment of _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY"]
        [::std::mem::align_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY>() - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY::EntryLength"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY, EntryLength) - 0usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY::DependencyTypeFlags"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY,
        DependencyTypeFlags
    )
        - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY::ProviderSpecificFlags"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY,
        ProviderSpecificFlags
    )
        - 8usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY::VirtualStorageType"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY,
        VirtualStorageType
    )
        - 12usize];
};
pub type STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY = _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY;
pub type PSTORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY =
    *mut _STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY {
    pub EntryLength: DWORD,
    pub DependencyTypeFlags: DWORD,
    pub ProviderSpecificFlags: DWORD,
    pub VirtualStorageType: VIRTUAL_STORAGE_TYPE,
    pub AncestorLevel: DWORD,
    pub HostVolumeNameOffset: DWORD,
    pub HostVolumeNameSize: DWORD,
    pub DependentVolumeNameOffset: DWORD,
    pub DependentVolumeNameSize: DWORD,
    pub RelativePathOffset: DWORD,
    pub RelativePathSize: DWORD,
    pub DependentDeviceNameOffset: DWORD,
    pub DependentDeviceNameSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY"]
        [::std::mem::size_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY>() - 68usize];
    ["Alignment of _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY"]
        [::std::mem::align_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY>() - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::EntryLength"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY, EntryLength) - 0usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::DependencyTypeFlags"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        DependencyTypeFlags
    )
        - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::ProviderSpecificFlags"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        ProviderSpecificFlags
    )
        - 8usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::VirtualStorageType"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        VirtualStorageType
    )
        - 12usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::AncestorLevel"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        AncestorLevel
    ) - 32usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::HostVolumeNameOffset"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        HostVolumeNameOffset
    )
        - 36usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::HostVolumeNameSize"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        HostVolumeNameSize
    )
        - 40usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::DependentVolumeNameOffset"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        DependentVolumeNameOffset
    )
        - 44usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::DependentVolumeNameSize"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        DependentVolumeNameSize
    )
        - 48usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::RelativePathOffset"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        RelativePathOffset
    )
        - 52usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::RelativePathSize"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        RelativePathSize
    ) - 56usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::DependentDeviceNameOffset"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        DependentDeviceNameOffset
    )
        - 60usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY::DependentDeviceNameSize"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY,
        DependentDeviceNameSize
    )
        - 64usize];
};
pub type STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY = _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY;
pub type PSTORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY =
    *mut _STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY;
#[repr(C)]
pub struct _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE {
    pub ResponseLevel: DWORD,
    pub NumberEntries: DWORD,
    pub __bindgen_anon_1: _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1,
}
#[repr(C)]
pub struct _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1 {
    pub Lev1Depends: __BindgenUnionField<[STORAGE_QUERY_DEPENDENT_VOLUME_LEV1_ENTRY; 0usize]>,
    pub Lev2Depends: __BindgenUnionField<[STORAGE_QUERY_DEPENDENT_VOLUME_LEV2_ENTRY; 0usize]>,
    pub bindgen_union_field: u32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1"]
        [::std::mem::size_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1>() - 4usize];
    ["Alignment of _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1"]
        [::std::mem::align_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1>() - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1::Lev1Depends"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1,
        Lev1Depends
    )
        - 0usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1::Lev2Depends"][::std::mem::offset_of!(
        _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE__bindgen_ty_1,
        Lev2Depends
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE"]
        [::std::mem::size_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE>() - 12usize];
    ["Alignment of _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE"]
        [::std::mem::align_of::<_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE>() - 4usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE::ResponseLevel"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE, ResponseLevel) - 0usize];
    ["Offset of field: _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE::NumberEntries"]
        [::std::mem::offset_of!(_STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE, NumberEntries) - 4usize];
};
pub type STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE = _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE;
pub type PSTORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE = *mut _STORAGE_QUERY_DEPENDENT_VOLUME_RESPONSE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_CHANGE_MACHINE_SID_INPUT {
    pub CurrentMachineSIDOffset: WORD,
    pub CurrentMachineSIDLength: WORD,
    pub NewMachineSIDOffset: WORD,
    pub NewMachineSIDLength: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_CHANGE_MACHINE_SID_INPUT"]
        [::std::mem::size_of::<_SD_CHANGE_MACHINE_SID_INPUT>() - 8usize];
    ["Alignment of _SD_CHANGE_MACHINE_SID_INPUT"]
        [::std::mem::align_of::<_SD_CHANGE_MACHINE_SID_INPUT>() - 2usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_INPUT::CurrentMachineSIDOffset"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_INPUT, CurrentMachineSIDOffset) - 0usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_INPUT::CurrentMachineSIDLength"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_INPUT, CurrentMachineSIDLength) - 2usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_INPUT::NewMachineSIDOffset"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_INPUT, NewMachineSIDOffset) - 4usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_INPUT::NewMachineSIDLength"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_INPUT, NewMachineSIDLength) - 6usize];
};
pub type SD_CHANGE_MACHINE_SID_INPUT = _SD_CHANGE_MACHINE_SID_INPUT;
pub type PSD_CHANGE_MACHINE_SID_INPUT = *mut _SD_CHANGE_MACHINE_SID_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_CHANGE_MACHINE_SID_OUTPUT {
    pub NumSDChangedSuccess: DWORDLONG,
    pub NumSDChangedFail: DWORDLONG,
    pub NumSDUnused: DWORDLONG,
    pub NumSDTotal: DWORDLONG,
    pub NumMftSDChangedSuccess: DWORDLONG,
    pub NumMftSDChangedFail: DWORDLONG,
    pub NumMftSDTotal: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_CHANGE_MACHINE_SID_OUTPUT"]
        [::std::mem::size_of::<_SD_CHANGE_MACHINE_SID_OUTPUT>() - 56usize];
    ["Alignment of _SD_CHANGE_MACHINE_SID_OUTPUT"]
        [::std::mem::align_of::<_SD_CHANGE_MACHINE_SID_OUTPUT>() - 8usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumSDChangedSuccess"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumSDChangedSuccess) - 0usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumSDChangedFail"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumSDChangedFail) - 8usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumSDUnused"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumSDUnused) - 16usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumSDTotal"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumSDTotal) - 24usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumMftSDChangedSuccess"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumMftSDChangedSuccess) - 32usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumMftSDChangedFail"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumMftSDChangedFail) - 40usize];
    ["Offset of field: _SD_CHANGE_MACHINE_SID_OUTPUT::NumMftSDTotal"]
        [::std::mem::offset_of!(_SD_CHANGE_MACHINE_SID_OUTPUT, NumMftSDTotal) - 48usize];
};
pub type SD_CHANGE_MACHINE_SID_OUTPUT = _SD_CHANGE_MACHINE_SID_OUTPUT;
pub type PSD_CHANGE_MACHINE_SID_OUTPUT = *mut _SD_CHANGE_MACHINE_SID_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_QUERY_STATS_INPUT {
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_QUERY_STATS_INPUT"][::std::mem::size_of::<_SD_QUERY_STATS_INPUT>() - 4usize];
    ["Alignment of _SD_QUERY_STATS_INPUT"]
        [::std::mem::align_of::<_SD_QUERY_STATS_INPUT>() - 4usize];
    ["Offset of field: _SD_QUERY_STATS_INPUT::Reserved"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_INPUT, Reserved) - 0usize];
};
pub type SD_QUERY_STATS_INPUT = _SD_QUERY_STATS_INPUT;
pub type PSD_QUERY_STATS_INPUT = *mut _SD_QUERY_STATS_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_QUERY_STATS_OUTPUT {
    pub SdsStreamSize: DWORDLONG,
    pub SdsAllocationSize: DWORDLONG,
    pub SiiStreamSize: DWORDLONG,
    pub SiiAllocationSize: DWORDLONG,
    pub SdhStreamSize: DWORDLONG,
    pub SdhAllocationSize: DWORDLONG,
    pub NumSDTotal: DWORDLONG,
    pub NumSDUnused: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_QUERY_STATS_OUTPUT"][::std::mem::size_of::<_SD_QUERY_STATS_OUTPUT>() - 64usize];
    ["Alignment of _SD_QUERY_STATS_OUTPUT"]
        [::std::mem::align_of::<_SD_QUERY_STATS_OUTPUT>() - 8usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SdsStreamSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SdsStreamSize) - 0usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SdsAllocationSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SdsAllocationSize) - 8usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SiiStreamSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SiiStreamSize) - 16usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SiiAllocationSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SiiAllocationSize) - 24usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SdhStreamSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SdhStreamSize) - 32usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::SdhAllocationSize"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, SdhAllocationSize) - 40usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::NumSDTotal"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, NumSDTotal) - 48usize];
    ["Offset of field: _SD_QUERY_STATS_OUTPUT::NumSDUnused"]
        [::std::mem::offset_of!(_SD_QUERY_STATS_OUTPUT, NumSDUnused) - 56usize];
};
pub type SD_QUERY_STATS_OUTPUT = _SD_QUERY_STATS_OUTPUT;
pub type PSD_QUERY_STATS_OUTPUT = *mut _SD_QUERY_STATS_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_ENUM_SDS_INPUT {
    pub StartingOffset: DWORDLONG,
    pub MaxSDEntriesToReturn: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_ENUM_SDS_INPUT"][::std::mem::size_of::<_SD_ENUM_SDS_INPUT>() - 16usize];
    ["Alignment of _SD_ENUM_SDS_INPUT"][::std::mem::align_of::<_SD_ENUM_SDS_INPUT>() - 8usize];
    ["Offset of field: _SD_ENUM_SDS_INPUT::StartingOffset"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_INPUT, StartingOffset) - 0usize];
    ["Offset of field: _SD_ENUM_SDS_INPUT::MaxSDEntriesToReturn"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_INPUT, MaxSDEntriesToReturn) - 8usize];
};
pub type SD_ENUM_SDS_INPUT = _SD_ENUM_SDS_INPUT;
pub type PSD_ENUM_SDS_INPUT = *mut _SD_ENUM_SDS_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_ENUM_SDS_ENTRY {
    pub Hash: DWORD,
    pub SecurityId: DWORD,
    pub Offset: DWORDLONG,
    pub Length: DWORD,
    pub Descriptor: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_ENUM_SDS_ENTRY"][::std::mem::size_of::<_SD_ENUM_SDS_ENTRY>() - 24usize];
    ["Alignment of _SD_ENUM_SDS_ENTRY"][::std::mem::align_of::<_SD_ENUM_SDS_ENTRY>() - 8usize];
    ["Offset of field: _SD_ENUM_SDS_ENTRY::Hash"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_ENTRY, Hash) - 0usize];
    ["Offset of field: _SD_ENUM_SDS_ENTRY::SecurityId"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_ENTRY, SecurityId) - 4usize];
    ["Offset of field: _SD_ENUM_SDS_ENTRY::Offset"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_ENTRY, Offset) - 8usize];
    ["Offset of field: _SD_ENUM_SDS_ENTRY::Length"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_ENTRY, Length) - 16usize];
    ["Offset of field: _SD_ENUM_SDS_ENTRY::Descriptor"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_ENTRY, Descriptor) - 20usize];
};
pub type SD_ENUM_SDS_ENTRY = _SD_ENUM_SDS_ENTRY;
pub type PSD_ENUM_SDS_ENTRY = *mut _SD_ENUM_SDS_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SD_ENUM_SDS_OUTPUT {
    pub NextOffset: DWORDLONG,
    pub NumSDEntriesReturned: DWORDLONG,
    pub NumSDBytesReturned: DWORDLONG,
    pub SDEntry: [SD_ENUM_SDS_ENTRY; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_ENUM_SDS_OUTPUT"][::std::mem::size_of::<_SD_ENUM_SDS_OUTPUT>() - 48usize];
    ["Alignment of _SD_ENUM_SDS_OUTPUT"][::std::mem::align_of::<_SD_ENUM_SDS_OUTPUT>() - 8usize];
    ["Offset of field: _SD_ENUM_SDS_OUTPUT::NextOffset"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_OUTPUT, NextOffset) - 0usize];
    ["Offset of field: _SD_ENUM_SDS_OUTPUT::NumSDEntriesReturned"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_OUTPUT, NumSDEntriesReturned) - 8usize];
    ["Offset of field: _SD_ENUM_SDS_OUTPUT::NumSDBytesReturned"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_OUTPUT, NumSDBytesReturned) - 16usize];
    ["Offset of field: _SD_ENUM_SDS_OUTPUT::SDEntry"]
        [::std::mem::offset_of!(_SD_ENUM_SDS_OUTPUT, SDEntry) - 24usize];
};
pub type SD_ENUM_SDS_OUTPUT = _SD_ENUM_SDS_OUTPUT;
pub type PSD_ENUM_SDS_OUTPUT = *mut _SD_ENUM_SDS_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SD_GLOBAL_CHANGE_INPUT {
    pub Flags: DWORD,
    pub ChangeType: DWORD,
    pub __bindgen_anon_1: _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1 {
    pub SdChange: SD_CHANGE_MACHINE_SID_INPUT,
    pub SdQueryStats: SD_QUERY_STATS_INPUT,
    pub SdEnumSds: SD_ENUM_SDS_INPUT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1"]
        [::std::mem::size_of::<_SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1>() - 16usize];
    ["Alignment of _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1"]
        [::std::mem::align_of::<_SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1::SdChange"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1, SdChange) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1::SdQueryStats"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1, SdQueryStats) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1::SdEnumSds"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_INPUT__bindgen_ty_1, SdEnumSds) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_GLOBAL_CHANGE_INPUT"][::std::mem::size_of::<_SD_GLOBAL_CHANGE_INPUT>() - 24usize];
    ["Alignment of _SD_GLOBAL_CHANGE_INPUT"]
        [::std::mem::align_of::<_SD_GLOBAL_CHANGE_INPUT>() - 8usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_INPUT::Flags"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_INPUT, Flags) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_INPUT::ChangeType"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_INPUT, ChangeType) - 4usize];
};
pub type SD_GLOBAL_CHANGE_INPUT = _SD_GLOBAL_CHANGE_INPUT;
pub type PSD_GLOBAL_CHANGE_INPUT = *mut _SD_GLOBAL_CHANGE_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SD_GLOBAL_CHANGE_OUTPUT {
    pub Flags: DWORD,
    pub ChangeType: DWORD,
    pub __bindgen_anon_1: _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1 {
    pub SdChange: SD_CHANGE_MACHINE_SID_OUTPUT,
    pub SdQueryStats: SD_QUERY_STATS_OUTPUT,
    pub SdEnumSds: SD_ENUM_SDS_OUTPUT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1"]
        [::std::mem::size_of::<_SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1>() - 64usize];
    ["Alignment of _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1"]
        [::std::mem::align_of::<_SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1::SdChange"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1, SdChange) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1::SdQueryStats"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1, SdQueryStats) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1::SdEnumSds"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_OUTPUT__bindgen_ty_1, SdEnumSds) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SD_GLOBAL_CHANGE_OUTPUT"]
        [::std::mem::size_of::<_SD_GLOBAL_CHANGE_OUTPUT>() - 72usize];
    ["Alignment of _SD_GLOBAL_CHANGE_OUTPUT"]
        [::std::mem::align_of::<_SD_GLOBAL_CHANGE_OUTPUT>() - 8usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_OUTPUT::Flags"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_OUTPUT, Flags) - 0usize];
    ["Offset of field: _SD_GLOBAL_CHANGE_OUTPUT::ChangeType"]
        [::std::mem::offset_of!(_SD_GLOBAL_CHANGE_OUTPUT, ChangeType) - 4usize];
};
pub type SD_GLOBAL_CHANGE_OUTPUT = _SD_GLOBAL_CHANGE_OUTPUT;
pub type PSD_GLOBAL_CHANGE_OUTPUT = *mut _SD_GLOBAL_CHANGE_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _LOOKUP_STREAM_FROM_CLUSTER_INPUT {
    pub Flags: DWORD,
    pub NumberOfClusters: DWORD,
    pub Cluster: [LARGE_INTEGER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LOOKUP_STREAM_FROM_CLUSTER_INPUT"]
        [::std::mem::size_of::<_LOOKUP_STREAM_FROM_CLUSTER_INPUT>() - 16usize];
    ["Alignment of _LOOKUP_STREAM_FROM_CLUSTER_INPUT"]
        [::std::mem::align_of::<_LOOKUP_STREAM_FROM_CLUSTER_INPUT>() - 8usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_INPUT::Flags"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_INPUT, Flags) - 0usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_INPUT::NumberOfClusters"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_INPUT, NumberOfClusters) - 4usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_INPUT::Cluster"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_INPUT, Cluster) - 8usize];
};
pub type LOOKUP_STREAM_FROM_CLUSTER_INPUT = _LOOKUP_STREAM_FROM_CLUSTER_INPUT;
pub type PLOOKUP_STREAM_FROM_CLUSTER_INPUT = *mut _LOOKUP_STREAM_FROM_CLUSTER_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT {
    pub Offset: DWORD,
    pub NumberOfMatches: DWORD,
    pub BufferSizeRequired: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT"]
        [::std::mem::size_of::<_LOOKUP_STREAM_FROM_CLUSTER_OUTPUT>() - 12usize];
    ["Alignment of _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT"]
        [::std::mem::align_of::<_LOOKUP_STREAM_FROM_CLUSTER_OUTPUT>() - 4usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT::Offset"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_OUTPUT, Offset) - 0usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT::NumberOfMatches"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_OUTPUT, NumberOfMatches) - 4usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT::BufferSizeRequired"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_OUTPUT, BufferSizeRequired) - 8usize];
};
pub type LOOKUP_STREAM_FROM_CLUSTER_OUTPUT = _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT;
pub type PLOOKUP_STREAM_FROM_CLUSTER_OUTPUT = *mut _LOOKUP_STREAM_FROM_CLUSTER_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _LOOKUP_STREAM_FROM_CLUSTER_ENTRY {
    pub OffsetToNext: DWORD,
    pub Flags: DWORD,
    pub Reserved: LARGE_INTEGER,
    pub Cluster: LARGE_INTEGER,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LOOKUP_STREAM_FROM_CLUSTER_ENTRY"]
        [::std::mem::size_of::<_LOOKUP_STREAM_FROM_CLUSTER_ENTRY>() - 32usize];
    ["Alignment of _LOOKUP_STREAM_FROM_CLUSTER_ENTRY"]
        [::std::mem::align_of::<_LOOKUP_STREAM_FROM_CLUSTER_ENTRY>() - 8usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_ENTRY::OffsetToNext"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_ENTRY, OffsetToNext) - 0usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_ENTRY::Flags"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_ENTRY, Flags) - 4usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_ENTRY::Reserved"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_ENTRY, Reserved) - 8usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_ENTRY::Cluster"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_ENTRY, Cluster) - 16usize];
    ["Offset of field: _LOOKUP_STREAM_FROM_CLUSTER_ENTRY::FileName"]
        [::std::mem::offset_of!(_LOOKUP_STREAM_FROM_CLUSTER_ENTRY, FileName) - 24usize];
};
pub type LOOKUP_STREAM_FROM_CLUSTER_ENTRY = _LOOKUP_STREAM_FROM_CLUSTER_ENTRY;
pub type PLOOKUP_STREAM_FROM_CLUSTER_ENTRY = *mut _LOOKUP_STREAM_FROM_CLUSTER_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_TYPE_NOTIFICATION_INPUT {
    pub Flags: DWORD,
    pub NumFileTypeIDs: DWORD,
    pub FileTypeID: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_TYPE_NOTIFICATION_INPUT"]
        [::std::mem::size_of::<_FILE_TYPE_NOTIFICATION_INPUT>() - 24usize];
    ["Alignment of _FILE_TYPE_NOTIFICATION_INPUT"]
        [::std::mem::align_of::<_FILE_TYPE_NOTIFICATION_INPUT>() - 4usize];
    ["Offset of field: _FILE_TYPE_NOTIFICATION_INPUT::Flags"]
        [::std::mem::offset_of!(_FILE_TYPE_NOTIFICATION_INPUT, Flags) - 0usize];
    ["Offset of field: _FILE_TYPE_NOTIFICATION_INPUT::NumFileTypeIDs"]
        [::std::mem::offset_of!(_FILE_TYPE_NOTIFICATION_INPUT, NumFileTypeIDs) - 4usize];
    ["Offset of field: _FILE_TYPE_NOTIFICATION_INPUT::FileTypeID"]
        [::std::mem::offset_of!(_FILE_TYPE_NOTIFICATION_INPUT, FileTypeID) - 8usize];
};
pub type FILE_TYPE_NOTIFICATION_INPUT = _FILE_TYPE_NOTIFICATION_INPUT;
pub type PFILE_TYPE_NOTIFICATION_INPUT = *mut _FILE_TYPE_NOTIFICATION_INPUT;
unsafe extern "C" {
    pub static FILE_TYPE_NOTIFICATION_GUID_PAGE_FILE: GUID;
}
unsafe extern "C" {
    pub static FILE_TYPE_NOTIFICATION_GUID_HIBERNATION_FILE: GUID;
}
unsafe extern "C" {
    pub static FILE_TYPE_NOTIFICATION_GUID_CRASHDUMP_FILE: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_MGMT_LOCK {
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_MGMT_LOCK"][::std::mem::size_of::<_CSV_MGMT_LOCK>() - 4usize];
    ["Alignment of _CSV_MGMT_LOCK"][::std::mem::align_of::<_CSV_MGMT_LOCK>() - 4usize];
    ["Offset of field: _CSV_MGMT_LOCK::Flags"]
        [::std::mem::offset_of!(_CSV_MGMT_LOCK, Flags) - 0usize];
};
pub type CSV_MGMT_LOCK = _CSV_MGMT_LOCK;
pub type PCSV_MGMT_LOCK = *mut _CSV_MGMT_LOCK;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CSV_NAMESPACE_INFO {
    pub Version: DWORD,
    pub DeviceNumber: DWORD,
    pub StartingOffset: LARGE_INTEGER,
    pub SectorSize: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_NAMESPACE_INFO"][::std::mem::size_of::<_CSV_NAMESPACE_INFO>() - 24usize];
    ["Alignment of _CSV_NAMESPACE_INFO"][::std::mem::align_of::<_CSV_NAMESPACE_INFO>() - 8usize];
    ["Offset of field: _CSV_NAMESPACE_INFO::Version"]
        [::std::mem::offset_of!(_CSV_NAMESPACE_INFO, Version) - 0usize];
    ["Offset of field: _CSV_NAMESPACE_INFO::DeviceNumber"]
        [::std::mem::offset_of!(_CSV_NAMESPACE_INFO, DeviceNumber) - 4usize];
    ["Offset of field: _CSV_NAMESPACE_INFO::StartingOffset"]
        [::std::mem::offset_of!(_CSV_NAMESPACE_INFO, StartingOffset) - 8usize];
    ["Offset of field: _CSV_NAMESPACE_INFO::SectorSize"]
        [::std::mem::offset_of!(_CSV_NAMESPACE_INFO, SectorSize) - 16usize];
};
pub type CSV_NAMESPACE_INFO = _CSV_NAMESPACE_INFO;
pub type PCSV_NAMESPACE_INFO = *mut _CSV_NAMESPACE_INFO;
pub const _CSV_CONTROL_OP_CsvControlStartRedirectFile: _CSV_CONTROL_OP = 2;
pub const _CSV_CONTROL_OP_CsvControlStopRedirectFile: _CSV_CONTROL_OP = 3;
pub const _CSV_CONTROL_OP_CsvControlQueryRedirectState: _CSV_CONTROL_OP = 4;
pub const _CSV_CONTROL_OP_CsvControlQueryFileRevision: _CSV_CONTROL_OP = 6;
pub const _CSV_CONTROL_OP_CsvControlQueryMdsPath: _CSV_CONTROL_OP = 8;
pub const _CSV_CONTROL_OP_CsvControlQueryFileRevisionFileId128: _CSV_CONTROL_OP = 9;
pub const _CSV_CONTROL_OP_CsvControlQueryVolumeRedirectState: _CSV_CONTROL_OP = 10;
pub const _CSV_CONTROL_OP_CsvControlEnableUSNRangeModificationTracking: _CSV_CONTROL_OP = 13;
pub const _CSV_CONTROL_OP_CsvControlMarkHandleLocalVolumeMount: _CSV_CONTROL_OP = 14;
pub const _CSV_CONTROL_OP_CsvControlUnmarkHandleLocalVolumeMount: _CSV_CONTROL_OP = 15;
pub const _CSV_CONTROL_OP_CsvControlGetCsvFsMdsPathV2: _CSV_CONTROL_OP = 18;
pub const _CSV_CONTROL_OP_CsvControlDisableCaching: _CSV_CONTROL_OP = 19;
pub const _CSV_CONTROL_OP_CsvControlEnableCaching: _CSV_CONTROL_OP = 20;
pub const _CSV_CONTROL_OP_CsvControlStartForceDFO: _CSV_CONTROL_OP = 21;
pub const _CSV_CONTROL_OP_CsvControlStopForceDFO: _CSV_CONTROL_OP = 22;
pub const _CSV_CONTROL_OP_CsvControlQueryMdsPathNoPause: _CSV_CONTROL_OP = 23;
pub const _CSV_CONTROL_OP_CsvControlSetVolumeId: _CSV_CONTROL_OP = 24;
pub const _CSV_CONTROL_OP_CsvControlQueryVolumeId: _CSV_CONTROL_OP = 25;
pub type _CSV_CONTROL_OP = ::std::os::raw::c_int;
pub use self::_CSV_CONTROL_OP as CSV_CONTROL_OP;
pub type PCSV_CONTROL_OP = *mut _CSV_CONTROL_OP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_CONTROL_PARAM {
    pub Operation: CSV_CONTROL_OP,
    pub Unused: LONGLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_CONTROL_PARAM"][::std::mem::size_of::<_CSV_CONTROL_PARAM>() - 16usize];
    ["Alignment of _CSV_CONTROL_PARAM"][::std::mem::align_of::<_CSV_CONTROL_PARAM>() - 8usize];
    ["Offset of field: _CSV_CONTROL_PARAM::Operation"]
        [::std::mem::offset_of!(_CSV_CONTROL_PARAM, Operation) - 0usize];
    ["Offset of field: _CSV_CONTROL_PARAM::Unused"]
        [::std::mem::offset_of!(_CSV_CONTROL_PARAM, Unused) - 8usize];
};
pub type CSV_CONTROL_PARAM = _CSV_CONTROL_PARAM;
pub type PCSV_CONTROL_PARAM = *mut _CSV_CONTROL_PARAM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_REDIRECT_STATE {
    pub MdsNodeId: DWORD,
    pub DsNodeId: DWORD,
    pub FileRedirected: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_REDIRECT_STATE"]
        [::std::mem::size_of::<_CSV_QUERY_REDIRECT_STATE>() - 12usize];
    ["Alignment of _CSV_QUERY_REDIRECT_STATE"]
        [::std::mem::align_of::<_CSV_QUERY_REDIRECT_STATE>() - 4usize];
    ["Offset of field: _CSV_QUERY_REDIRECT_STATE::MdsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_REDIRECT_STATE, MdsNodeId) - 0usize];
    ["Offset of field: _CSV_QUERY_REDIRECT_STATE::DsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_REDIRECT_STATE, DsNodeId) - 4usize];
    ["Offset of field: _CSV_QUERY_REDIRECT_STATE::FileRedirected"]
        [::std::mem::offset_of!(_CSV_QUERY_REDIRECT_STATE, FileRedirected) - 8usize];
};
pub type CSV_QUERY_REDIRECT_STATE = _CSV_QUERY_REDIRECT_STATE;
pub type PCSV_QUERY_REDIRECT_STATE = *mut _CSV_QUERY_REDIRECT_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_FILE_REVISION {
    pub FileId: LONGLONG,
    pub FileRevision: [LONGLONG; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_FILE_REVISION"]
        [::std::mem::size_of::<_CSV_QUERY_FILE_REVISION>() - 32usize];
    ["Alignment of _CSV_QUERY_FILE_REVISION"]
        [::std::mem::align_of::<_CSV_QUERY_FILE_REVISION>() - 8usize];
    ["Offset of field: _CSV_QUERY_FILE_REVISION::FileId"]
        [::std::mem::offset_of!(_CSV_QUERY_FILE_REVISION, FileId) - 0usize];
    ["Offset of field: _CSV_QUERY_FILE_REVISION::FileRevision"]
        [::std::mem::offset_of!(_CSV_QUERY_FILE_REVISION, FileRevision) - 8usize];
};
pub type CSV_QUERY_FILE_REVISION = _CSV_QUERY_FILE_REVISION;
pub type PCSV_QUERY_FILE_REVISION = *mut _CSV_QUERY_FILE_REVISION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_FILE_REVISION_FILE_ID_128 {
    pub FileId: FILE_ID_128,
    pub FileRevision: [LONGLONG; 3usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_FILE_REVISION_FILE_ID_128"]
        [::std::mem::size_of::<_CSV_QUERY_FILE_REVISION_FILE_ID_128>() - 40usize];
    ["Alignment of _CSV_QUERY_FILE_REVISION_FILE_ID_128"]
        [::std::mem::align_of::<_CSV_QUERY_FILE_REVISION_FILE_ID_128>() - 8usize];
    ["Offset of field: _CSV_QUERY_FILE_REVISION_FILE_ID_128::FileId"]
        [::std::mem::offset_of!(_CSV_QUERY_FILE_REVISION_FILE_ID_128, FileId) - 0usize];
    ["Offset of field: _CSV_QUERY_FILE_REVISION_FILE_ID_128::FileRevision"]
        [::std::mem::offset_of!(_CSV_QUERY_FILE_REVISION_FILE_ID_128, FileRevision) - 16usize];
};
pub type CSV_QUERY_FILE_REVISION_FILE_ID_128 = _CSV_QUERY_FILE_REVISION_FILE_ID_128;
pub type PCSV_QUERY_FILE_REVISION_FILE_ID_128 = *mut _CSV_QUERY_FILE_REVISION_FILE_ID_128;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_MDS_PATH {
    pub MdsNodeId: DWORD,
    pub DsNodeId: DWORD,
    pub PathLength: DWORD,
    pub Path: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_MDS_PATH"][::std::mem::size_of::<_CSV_QUERY_MDS_PATH>() - 16usize];
    ["Alignment of _CSV_QUERY_MDS_PATH"][::std::mem::align_of::<_CSV_QUERY_MDS_PATH>() - 4usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH::MdsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH, MdsNodeId) - 0usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH::DsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH, DsNodeId) - 4usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH::PathLength"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH, PathLength) - 8usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH::Path"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH, Path) - 12usize];
};
pub type CSV_QUERY_MDS_PATH = _CSV_QUERY_MDS_PATH;
pub type PCSV_QUERY_MDS_PATH = *mut _CSV_QUERY_MDS_PATH;
pub const _CSVFS_DISK_CONNECTIVITY_CsvFsDiskConnectivityNone: _CSVFS_DISK_CONNECTIVITY = 0;
pub const _CSVFS_DISK_CONNECTIVITY_CsvFsDiskConnectivityMdsNodeOnly: _CSVFS_DISK_CONNECTIVITY = 1;
pub const _CSVFS_DISK_CONNECTIVITY_CsvFsDiskConnectivitySubsetOfNodes: _CSVFS_DISK_CONNECTIVITY = 2;
pub const _CSVFS_DISK_CONNECTIVITY_CsvFsDiskConnectivityAllNodes: _CSVFS_DISK_CONNECTIVITY = 3;
pub type _CSVFS_DISK_CONNECTIVITY = ::std::os::raw::c_int;
pub use self::_CSVFS_DISK_CONNECTIVITY as CSVFS_DISK_CONNECTIVITY;
pub type PCSVFS_DISK_CONNECTIVITY = *mut _CSVFS_DISK_CONNECTIVITY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_VOLUME_REDIRECT_STATE {
    pub MdsNodeId: DWORD,
    pub DsNodeId: DWORD,
    pub IsDiskConnected: BOOLEAN,
    pub ClusterEnableDirectIo: BOOLEAN,
    pub DiskConnectivity: CSVFS_DISK_CONNECTIVITY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_VOLUME_REDIRECT_STATE"]
        [::std::mem::size_of::<_CSV_QUERY_VOLUME_REDIRECT_STATE>() - 16usize];
    ["Alignment of _CSV_QUERY_VOLUME_REDIRECT_STATE"]
        [::std::mem::align_of::<_CSV_QUERY_VOLUME_REDIRECT_STATE>() - 4usize];
    ["Offset of field: _CSV_QUERY_VOLUME_REDIRECT_STATE::MdsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_REDIRECT_STATE, MdsNodeId) - 0usize];
    ["Offset of field: _CSV_QUERY_VOLUME_REDIRECT_STATE::DsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_REDIRECT_STATE, DsNodeId) - 4usize];
    ["Offset of field: _CSV_QUERY_VOLUME_REDIRECT_STATE::IsDiskConnected"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_REDIRECT_STATE, IsDiskConnected) - 8usize];
    ["Offset of field: _CSV_QUERY_VOLUME_REDIRECT_STATE::ClusterEnableDirectIo"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_REDIRECT_STATE, ClusterEnableDirectIo) - 9usize];
    ["Offset of field: _CSV_QUERY_VOLUME_REDIRECT_STATE::DiskConnectivity"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_REDIRECT_STATE, DiskConnectivity) - 12usize];
};
pub type CSV_QUERY_VOLUME_REDIRECT_STATE = _CSV_QUERY_VOLUME_REDIRECT_STATE;
pub type PCSV_QUERY_VOLUME_REDIRECT_STATE = *mut _CSV_QUERY_VOLUME_REDIRECT_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_MDS_PATH_V2 {
    pub Version: LONGLONG,
    pub RequiredSize: DWORD,
    pub MdsNodeId: DWORD,
    pub DsNodeId: DWORD,
    pub Flags: DWORD,
    pub DiskConnectivity: CSVFS_DISK_CONNECTIVITY,
    pub VolumeId: GUID,
    pub IpAddressOffset: DWORD,
    pub IpAddressLength: DWORD,
    pub PathOffset: DWORD,
    pub PathLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_MDS_PATH_V2"][::std::mem::size_of::<_CSV_QUERY_MDS_PATH_V2>() - 64usize];
    ["Alignment of _CSV_QUERY_MDS_PATH_V2"]
        [::std::mem::align_of::<_CSV_QUERY_MDS_PATH_V2>() - 8usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::Version"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, Version) - 0usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::RequiredSize"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, RequiredSize) - 8usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::MdsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, MdsNodeId) - 12usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::DsNodeId"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, DsNodeId) - 16usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::Flags"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, Flags) - 20usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::DiskConnectivity"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, DiskConnectivity) - 24usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::VolumeId"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, VolumeId) - 28usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::IpAddressOffset"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, IpAddressOffset) - 44usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::IpAddressLength"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, IpAddressLength) - 48usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::PathOffset"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, PathOffset) - 52usize];
    ["Offset of field: _CSV_QUERY_MDS_PATH_V2::PathLength"]
        [::std::mem::offset_of!(_CSV_QUERY_MDS_PATH_V2, PathLength) - 56usize];
};
pub type CSV_QUERY_MDS_PATH_V2 = _CSV_QUERY_MDS_PATH_V2;
pub type PCSV_QUERY_MDS_PATH_V2 = *mut _CSV_QUERY_MDS_PATH_V2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_SET_VOLUME_ID {
    pub VolumeId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_SET_VOLUME_ID"][::std::mem::size_of::<_CSV_SET_VOLUME_ID>() - 16usize];
    ["Alignment of _CSV_SET_VOLUME_ID"][::std::mem::align_of::<_CSV_SET_VOLUME_ID>() - 4usize];
    ["Offset of field: _CSV_SET_VOLUME_ID::VolumeId"]
        [::std::mem::offset_of!(_CSV_SET_VOLUME_ID, VolumeId) - 0usize];
};
pub type CSV_SET_VOLUME_ID = _CSV_SET_VOLUME_ID;
pub type PCSV_SET_VOLUME_ID = *mut _CSV_SET_VOLUME_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_VOLUME_ID {
    pub VolumeId: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_VOLUME_ID"][::std::mem::size_of::<_CSV_QUERY_VOLUME_ID>() - 16usize];
    ["Alignment of _CSV_QUERY_VOLUME_ID"][::std::mem::align_of::<_CSV_QUERY_VOLUME_ID>() - 4usize];
    ["Offset of field: _CSV_QUERY_VOLUME_ID::VolumeId"]
        [::std::mem::offset_of!(_CSV_QUERY_VOLUME_ID, VolumeId) - 0usize];
};
pub type CSV_QUERY_VOLUME_ID = _CSV_QUERY_VOLUME_ID;
pub type PCSV_QUERY_VOLUME_ID = *mut _CSV_QUERY_VOLUME_ID;
pub const _LMR_QUERY_INFO_CLASS_LMRQuerySessionInfo: _LMR_QUERY_INFO_CLASS = 1;
pub type _LMR_QUERY_INFO_CLASS = ::std::os::raw::c_int;
pub use self::_LMR_QUERY_INFO_CLASS as LMR_QUERY_INFO_CLASS;
pub type PLMR_QUERY_INFO_CLASS = *mut _LMR_QUERY_INFO_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LMR_QUERY_INFO_PARAM {
    pub Operation: LMR_QUERY_INFO_CLASS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LMR_QUERY_INFO_PARAM"][::std::mem::size_of::<_LMR_QUERY_INFO_PARAM>() - 4usize];
    ["Alignment of _LMR_QUERY_INFO_PARAM"]
        [::std::mem::align_of::<_LMR_QUERY_INFO_PARAM>() - 4usize];
    ["Offset of field: _LMR_QUERY_INFO_PARAM::Operation"]
        [::std::mem::offset_of!(_LMR_QUERY_INFO_PARAM, Operation) - 0usize];
};
pub type LMR_QUERY_INFO_PARAM = _LMR_QUERY_INFO_PARAM;
pub type PLMR_QUERY_INFO_PARAM = *mut _LMR_QUERY_INFO_PARAM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LMR_QUERY_SESSION_INFO {
    pub SessionId: UINT64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LMR_QUERY_SESSION_INFO"][::std::mem::size_of::<_LMR_QUERY_SESSION_INFO>() - 8usize];
    ["Alignment of _LMR_QUERY_SESSION_INFO"]
        [::std::mem::align_of::<_LMR_QUERY_SESSION_INFO>() - 8usize];
    ["Offset of field: _LMR_QUERY_SESSION_INFO::SessionId"]
        [::std::mem::offset_of!(_LMR_QUERY_SESSION_INFO, SessionId) - 0usize];
};
pub type LMR_QUERY_SESSION_INFO = _LMR_QUERY_SESSION_INFO;
pub type PLMR_QUERY_SESSION_INFO = *mut _LMR_QUERY_SESSION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT {
    pub VetoedFromAltitudeIntegral: DWORDLONG,
    pub VetoedFromAltitudeDecimal: DWORDLONG,
    pub Reason: [WCHAR; 256usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT"]
        [::std::mem::size_of::<_CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT>() - 528usize];
    ["Alignment of _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT"]
        [::std::mem::align_of::<_CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT>() - 8usize];
    ["Offset of field: _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT::VetoedFromAltitudeIntegral"][::std::mem::offset_of!(
        _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT,
        VetoedFromAltitudeIntegral
    )
        - 0usize];
    ["Offset of field: _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT::VetoedFromAltitudeDecimal"][::std::mem::offset_of!(
        _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT,
        VetoedFromAltitudeDecimal
    )
        - 8usize];
    ["Offset of field: _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT::Reason"]
        [::std::mem::offset_of!(_CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT, Reason) - 16usize];
};
pub type CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT = _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT;
pub type PCSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT = *mut _CSV_QUERY_VETO_FILE_DIRECT_IO_OUTPUT;
pub const _STORAGE_RESERVE_ID_StorageReserveIdNone: _STORAGE_RESERVE_ID = 0;
pub const _STORAGE_RESERVE_ID_StorageReserveIdHard: _STORAGE_RESERVE_ID = 1;
pub const _STORAGE_RESERVE_ID_StorageReserveIdSoft: _STORAGE_RESERVE_ID = 2;
pub const _STORAGE_RESERVE_ID_StorageReserveIdUpdateScratch: _STORAGE_RESERVE_ID = 3;
pub const _STORAGE_RESERVE_ID_StorageReserveIdMax: _STORAGE_RESERVE_ID = 4;
pub type _STORAGE_RESERVE_ID = ::std::os::raw::c_int;
pub use self::_STORAGE_RESERVE_ID as STORAGE_RESERVE_ID;
pub type PSTORAGE_RESERVE_ID = *mut _STORAGE_RESERVE_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CSV_IS_OWNED_BY_CSVFS {
    pub OwnedByCSVFS: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CSV_IS_OWNED_BY_CSVFS"][::std::mem::size_of::<_CSV_IS_OWNED_BY_CSVFS>() - 1usize];
    ["Alignment of _CSV_IS_OWNED_BY_CSVFS"]
        [::std::mem::align_of::<_CSV_IS_OWNED_BY_CSVFS>() - 1usize];
    ["Offset of field: _CSV_IS_OWNED_BY_CSVFS::OwnedByCSVFS"]
        [::std::mem::offset_of!(_CSV_IS_OWNED_BY_CSVFS, OwnedByCSVFS) - 0usize];
};
pub type CSV_IS_OWNED_BY_CSVFS = _CSV_IS_OWNED_BY_CSVFS;
pub type PCSV_IS_OWNED_BY_CSVFS = *mut _CSV_IS_OWNED_BY_CSVFS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_LEVEL_TRIM_RANGE {
    pub Offset: DWORDLONG,
    pub Length: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LEVEL_TRIM_RANGE"][::std::mem::size_of::<_FILE_LEVEL_TRIM_RANGE>() - 16usize];
    ["Alignment of _FILE_LEVEL_TRIM_RANGE"]
        [::std::mem::align_of::<_FILE_LEVEL_TRIM_RANGE>() - 8usize];
    ["Offset of field: _FILE_LEVEL_TRIM_RANGE::Offset"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM_RANGE, Offset) - 0usize];
    ["Offset of field: _FILE_LEVEL_TRIM_RANGE::Length"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM_RANGE, Length) - 8usize];
};
pub type FILE_LEVEL_TRIM_RANGE = _FILE_LEVEL_TRIM_RANGE;
pub type PFILE_LEVEL_TRIM_RANGE = *mut _FILE_LEVEL_TRIM_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_LEVEL_TRIM {
    pub Key: DWORD,
    pub NumRanges: DWORD,
    pub Ranges: [FILE_LEVEL_TRIM_RANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LEVEL_TRIM"][::std::mem::size_of::<_FILE_LEVEL_TRIM>() - 24usize];
    ["Alignment of _FILE_LEVEL_TRIM"][::std::mem::align_of::<_FILE_LEVEL_TRIM>() - 8usize];
    ["Offset of field: _FILE_LEVEL_TRIM::Key"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM, Key) - 0usize];
    ["Offset of field: _FILE_LEVEL_TRIM::NumRanges"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM, NumRanges) - 4usize];
    ["Offset of field: _FILE_LEVEL_TRIM::Ranges"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM, Ranges) - 8usize];
};
pub type FILE_LEVEL_TRIM = _FILE_LEVEL_TRIM;
pub type PFILE_LEVEL_TRIM = *mut _FILE_LEVEL_TRIM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_LEVEL_TRIM_OUTPUT {
    pub NumRangesProcessed: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LEVEL_TRIM_OUTPUT"][::std::mem::size_of::<_FILE_LEVEL_TRIM_OUTPUT>() - 4usize];
    ["Alignment of _FILE_LEVEL_TRIM_OUTPUT"]
        [::std::mem::align_of::<_FILE_LEVEL_TRIM_OUTPUT>() - 4usize];
    ["Offset of field: _FILE_LEVEL_TRIM_OUTPUT::NumRangesProcessed"]
        [::std::mem::offset_of!(_FILE_LEVEL_TRIM_OUTPUT, NumRangesProcessed) - 0usize];
};
pub type FILE_LEVEL_TRIM_OUTPUT = _FILE_LEVEL_TRIM_OUTPUT;
pub type PFILE_LEVEL_TRIM_OUTPUT = *mut _FILE_LEVEL_TRIM_OUTPUT;
pub const _QUERY_FILE_LAYOUT_FILTER_TYPE_QUERY_FILE_LAYOUT_FILTER_TYPE_NONE:
    _QUERY_FILE_LAYOUT_FILTER_TYPE = 0;
pub const _QUERY_FILE_LAYOUT_FILTER_TYPE_QUERY_FILE_LAYOUT_FILTER_TYPE_CLUSTERS:
    _QUERY_FILE_LAYOUT_FILTER_TYPE = 1;
pub const _QUERY_FILE_LAYOUT_FILTER_TYPE_QUERY_FILE_LAYOUT_FILTER_TYPE_FILEID:
    _QUERY_FILE_LAYOUT_FILTER_TYPE = 2;
pub const _QUERY_FILE_LAYOUT_FILTER_TYPE_QUERY_FILE_LAYOUT_FILTER_TYPE_STORAGE_RESERVE_ID:
    _QUERY_FILE_LAYOUT_FILTER_TYPE = 3;
pub const _QUERY_FILE_LAYOUT_FILTER_TYPE_QUERY_FILE_LAYOUT_NUM_FILTER_TYPES:
    _QUERY_FILE_LAYOUT_FILTER_TYPE = 4;
pub type _QUERY_FILE_LAYOUT_FILTER_TYPE = ::std::os::raw::c_int;
pub use self::_QUERY_FILE_LAYOUT_FILTER_TYPE as QUERY_FILE_LAYOUT_FILTER_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _CLUSTER_RANGE {
    pub StartingCluster: LARGE_INTEGER,
    pub ClusterCount: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CLUSTER_RANGE"][::std::mem::size_of::<_CLUSTER_RANGE>() - 16usize];
    ["Alignment of _CLUSTER_RANGE"][::std::mem::align_of::<_CLUSTER_RANGE>() - 8usize];
    ["Offset of field: _CLUSTER_RANGE::StartingCluster"]
        [::std::mem::offset_of!(_CLUSTER_RANGE, StartingCluster) - 0usize];
    ["Offset of field: _CLUSTER_RANGE::ClusterCount"]
        [::std::mem::offset_of!(_CLUSTER_RANGE, ClusterCount) - 8usize];
};
pub type CLUSTER_RANGE = _CLUSTER_RANGE;
pub type PCLUSTER_RANGE = *mut _CLUSTER_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REFERENCE_RANGE {
    pub StartingFileReferenceNumber: DWORDLONG,
    pub EndingFileReferenceNumber: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REFERENCE_RANGE"][::std::mem::size_of::<_FILE_REFERENCE_RANGE>() - 16usize];
    ["Alignment of _FILE_REFERENCE_RANGE"]
        [::std::mem::align_of::<_FILE_REFERENCE_RANGE>() - 8usize];
    ["Offset of field: _FILE_REFERENCE_RANGE::StartingFileReferenceNumber"]
        [::std::mem::offset_of!(_FILE_REFERENCE_RANGE, StartingFileReferenceNumber) - 0usize];
    ["Offset of field: _FILE_REFERENCE_RANGE::EndingFileReferenceNumber"]
        [::std::mem::offset_of!(_FILE_REFERENCE_RANGE, EndingFileReferenceNumber) - 8usize];
};
pub type FILE_REFERENCE_RANGE = _FILE_REFERENCE_RANGE;
pub type PFILE_REFERENCE_RANGE = *mut _FILE_REFERENCE_RANGE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _QUERY_FILE_LAYOUT_INPUT {
    pub __bindgen_anon_1: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1,
    pub Flags: DWORD,
    pub FilterType: QUERY_FILE_LAYOUT_FILTER_TYPE,
    pub Reserved: DWORD,
    pub Filter: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1 {
    pub FilterEntryCount: DWORD,
    pub NumberOfPairs: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1"]
        [::std::mem::size_of::<_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1>() - 4usize];
    ["Alignment of _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1"]
        [::std::mem::align_of::<_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1>() - 4usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1::FilterEntryCount"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1, FilterEntryCount) - 0usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1::NumberOfPairs"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_1, NumberOfPairs) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2 {
    pub ClusterRanges: [CLUSTER_RANGE; 1usize],
    pub FileReferenceRanges: [FILE_REFERENCE_RANGE; 1usize],
    pub StorageReserveIds: [STORAGE_RESERVE_ID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2"]
        [::std::mem::size_of::<_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2>() - 16usize];
    ["Alignment of _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2"]
        [::std::mem::align_of::<_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2>() - 8usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2::ClusterRanges"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2, ClusterRanges) - 0usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2::FileReferenceRanges"][::std::mem::offset_of!(
        _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2,
        FileReferenceRanges
    ) - 0usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2::StorageReserveIds"][::std::mem::offset_of!(
        _QUERY_FILE_LAYOUT_INPUT__bindgen_ty_2,
        StorageReserveIds
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_FILE_LAYOUT_INPUT"]
        [::std::mem::size_of::<_QUERY_FILE_LAYOUT_INPUT>() - 32usize];
    ["Alignment of _QUERY_FILE_LAYOUT_INPUT"]
        [::std::mem::align_of::<_QUERY_FILE_LAYOUT_INPUT>() - 8usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT::Flags"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT, Flags) - 4usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT::FilterType"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT, FilterType) - 8usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT::Reserved"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT, Reserved) - 12usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_INPUT::Filter"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_INPUT, Filter) - 16usize];
};
pub type QUERY_FILE_LAYOUT_INPUT = _QUERY_FILE_LAYOUT_INPUT;
pub type PQUERY_FILE_LAYOUT_INPUT = *mut _QUERY_FILE_LAYOUT_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_FILE_LAYOUT_OUTPUT {
    pub FileEntryCount: DWORD,
    pub FirstFileOffset: DWORD,
    pub Flags: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_FILE_LAYOUT_OUTPUT"]
        [::std::mem::size_of::<_QUERY_FILE_LAYOUT_OUTPUT>() - 16usize];
    ["Alignment of _QUERY_FILE_LAYOUT_OUTPUT"]
        [::std::mem::align_of::<_QUERY_FILE_LAYOUT_OUTPUT>() - 4usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_OUTPUT::FileEntryCount"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_OUTPUT, FileEntryCount) - 0usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_OUTPUT::FirstFileOffset"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_OUTPUT, FirstFileOffset) - 4usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_OUTPUT::Flags"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_OUTPUT, Flags) - 8usize];
    ["Offset of field: _QUERY_FILE_LAYOUT_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_QUERY_FILE_LAYOUT_OUTPUT, Reserved) - 12usize];
};
pub type QUERY_FILE_LAYOUT_OUTPUT = _QUERY_FILE_LAYOUT_OUTPUT;
pub type PQUERY_FILE_LAYOUT_OUTPUT = *mut _QUERY_FILE_LAYOUT_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_LAYOUT_ENTRY {
    pub Version: DWORD,
    pub NextFileOffset: DWORD,
    pub Flags: DWORD,
    pub FileAttributes: DWORD,
    pub FileReferenceNumber: DWORDLONG,
    pub FirstNameOffset: DWORD,
    pub FirstStreamOffset: DWORD,
    pub ExtraInfoOffset: DWORD,
    pub ExtraInfoLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LAYOUT_ENTRY"][::std::mem::size_of::<_FILE_LAYOUT_ENTRY>() - 40usize];
    ["Alignment of _FILE_LAYOUT_ENTRY"][::std::mem::align_of::<_FILE_LAYOUT_ENTRY>() - 8usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::Version"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, Version) - 0usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::NextFileOffset"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, NextFileOffset) - 4usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::Flags"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, Flags) - 8usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::FileAttributes"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, FileAttributes) - 12usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::FileReferenceNumber"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, FileReferenceNumber) - 16usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::FirstNameOffset"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, FirstNameOffset) - 24usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::FirstStreamOffset"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, FirstStreamOffset) - 28usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::ExtraInfoOffset"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, ExtraInfoOffset) - 32usize];
    ["Offset of field: _FILE_LAYOUT_ENTRY::ExtraInfoLength"]
        [::std::mem::offset_of!(_FILE_LAYOUT_ENTRY, ExtraInfoLength) - 36usize];
};
pub type FILE_LAYOUT_ENTRY = _FILE_LAYOUT_ENTRY;
pub type PFILE_LAYOUT_ENTRY = *mut _FILE_LAYOUT_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_LAYOUT_NAME_ENTRY {
    pub NextNameOffset: DWORD,
    pub Flags: DWORD,
    pub ParentFileReferenceNumber: DWORDLONG,
    pub FileNameLength: DWORD,
    pub Reserved: DWORD,
    pub FileName: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LAYOUT_NAME_ENTRY"][::std::mem::size_of::<_FILE_LAYOUT_NAME_ENTRY>() - 32usize];
    ["Alignment of _FILE_LAYOUT_NAME_ENTRY"]
        [::std::mem::align_of::<_FILE_LAYOUT_NAME_ENTRY>() - 8usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::NextNameOffset"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, NextNameOffset) - 0usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::Flags"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, Flags) - 4usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::ParentFileReferenceNumber"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, ParentFileReferenceNumber) - 8usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::FileNameLength"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, FileNameLength) - 16usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::Reserved"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, Reserved) - 20usize];
    ["Offset of field: _FILE_LAYOUT_NAME_ENTRY::FileName"]
        [::std::mem::offset_of!(_FILE_LAYOUT_NAME_ENTRY, FileName) - 24usize];
};
pub type FILE_LAYOUT_NAME_ENTRY = _FILE_LAYOUT_NAME_ENTRY;
pub type PFILE_LAYOUT_NAME_ENTRY = *mut _FILE_LAYOUT_NAME_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_LAYOUT_INFO_ENTRY {
    pub BasicInformation: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1,
    pub OwnerId: DWORD,
    pub SecurityId: DWORD,
    pub Usn: USN,
    pub StorageReserveId: STORAGE_RESERVE_ID,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1 {
    pub CreationTime: LARGE_INTEGER,
    pub LastAccessTime: LARGE_INTEGER,
    pub LastWriteTime: LARGE_INTEGER,
    pub ChangeTime: LARGE_INTEGER,
    pub FileAttributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1>() - 40usize];
    ["Alignment of _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1::CreationTime"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1, CreationTime) - 0usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1::LastAccessTime"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1, LastAccessTime) - 8usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1::LastWriteTime"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1, LastWriteTime) - 16usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1::ChangeTime"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1, ChangeTime) - 24usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1::FileAttributes"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY__bindgen_ty_1, FileAttributes) - 32usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_LAYOUT_INFO_ENTRY"][::std::mem::size_of::<_FILE_LAYOUT_INFO_ENTRY>() - 64usize];
    ["Alignment of _FILE_LAYOUT_INFO_ENTRY"]
        [::std::mem::align_of::<_FILE_LAYOUT_INFO_ENTRY>() - 8usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY::BasicInformation"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY, BasicInformation) - 0usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY::OwnerId"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY, OwnerId) - 40usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY::SecurityId"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY, SecurityId) - 44usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY::Usn"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY, Usn) - 48usize];
    ["Offset of field: _FILE_LAYOUT_INFO_ENTRY::StorageReserveId"]
        [::std::mem::offset_of!(_FILE_LAYOUT_INFO_ENTRY, StorageReserveId) - 56usize];
};
pub type FILE_LAYOUT_INFO_ENTRY = _FILE_LAYOUT_INFO_ENTRY;
pub type PFILE_LAYOUT_INFO_ENTRY = *mut _FILE_LAYOUT_INFO_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STREAM_LAYOUT_ENTRY {
    pub Version: DWORD,
    pub NextStreamOffset: DWORD,
    pub Flags: DWORD,
    pub ExtentInformationOffset: DWORD,
    pub AllocationSize: LARGE_INTEGER,
    pub EndOfFile: LARGE_INTEGER,
    pub StreamInformationOffset: DWORD,
    pub AttributeTypeCode: DWORD,
    pub AttributeFlags: DWORD,
    pub StreamIdentifierLength: DWORD,
    pub StreamIdentifier: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_LAYOUT_ENTRY"][::std::mem::size_of::<_STREAM_LAYOUT_ENTRY>() - 56usize];
    ["Alignment of _STREAM_LAYOUT_ENTRY"][::std::mem::align_of::<_STREAM_LAYOUT_ENTRY>() - 8usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::Version"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, Version) - 0usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::NextStreamOffset"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, NextStreamOffset) - 4usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::Flags"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, Flags) - 8usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::ExtentInformationOffset"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, ExtentInformationOffset) - 12usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::AllocationSize"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, AllocationSize) - 16usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::EndOfFile"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, EndOfFile) - 24usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::StreamInformationOffset"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, StreamInformationOffset) - 32usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::AttributeTypeCode"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, AttributeTypeCode) - 36usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::AttributeFlags"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, AttributeFlags) - 40usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::StreamIdentifierLength"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, StreamIdentifierLength) - 44usize];
    ["Offset of field: _STREAM_LAYOUT_ENTRY::StreamIdentifier"]
        [::std::mem::offset_of!(_STREAM_LAYOUT_ENTRY, StreamIdentifier) - 48usize];
};
pub type STREAM_LAYOUT_ENTRY = _STREAM_LAYOUT_ENTRY;
pub type PSTREAM_LAYOUT_ENTRY = *mut _STREAM_LAYOUT_ENTRY;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STREAM_EXTENT_ENTRY {
    pub Flags: DWORD,
    pub ExtentInformation: _STREAM_EXTENT_ENTRY__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STREAM_EXTENT_ENTRY__bindgen_ty_1 {
    pub RetrievalPointers: RETRIEVAL_POINTERS_BUFFER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_EXTENT_ENTRY__bindgen_ty_1"]
        [::std::mem::size_of::<_STREAM_EXTENT_ENTRY__bindgen_ty_1>() - 32usize];
    ["Alignment of _STREAM_EXTENT_ENTRY__bindgen_ty_1"]
        [::std::mem::align_of::<_STREAM_EXTENT_ENTRY__bindgen_ty_1>() - 8usize];
    ["Offset of field: _STREAM_EXTENT_ENTRY__bindgen_ty_1::RetrievalPointers"]
        [::std::mem::offset_of!(_STREAM_EXTENT_ENTRY__bindgen_ty_1, RetrievalPointers) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_EXTENT_ENTRY"][::std::mem::size_of::<_STREAM_EXTENT_ENTRY>() - 40usize];
    ["Alignment of _STREAM_EXTENT_ENTRY"][::std::mem::align_of::<_STREAM_EXTENT_ENTRY>() - 8usize];
    ["Offset of field: _STREAM_EXTENT_ENTRY::Flags"]
        [::std::mem::offset_of!(_STREAM_EXTENT_ENTRY, Flags) - 0usize];
    ["Offset of field: _STREAM_EXTENT_ENTRY::ExtentInformation"]
        [::std::mem::offset_of!(_STREAM_EXTENT_ENTRY, ExtentInformation) - 8usize];
};
pub type STREAM_EXTENT_ENTRY = _STREAM_EXTENT_ENTRY;
pub type PSTREAM_EXTENT_ENTRY = *mut _STREAM_EXTENT_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER {
    pub ChecksumAlgorithm: WORD,
    pub Reserved: WORD,
    pub Flags: DWORD,
    pub ChecksumChunkSizeInBytes: DWORD,
    pub ClusterSizeInBytes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER"]
        [::std::mem::size_of::<_FSCTL_GET_INTEGRITY_INFORMATION_BUFFER>() - 16usize];
    ["Alignment of _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER"]
        [::std::mem::align_of::<_FSCTL_GET_INTEGRITY_INFORMATION_BUFFER>() - 4usize];
    ["Offset of field: _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER::ChecksumAlgorithm"][::std::mem::offset_of!(
        _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER,
        ChecksumAlgorithm
    ) - 0usize];
    ["Offset of field: _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER::Reserved"]
        [::std::mem::offset_of!(_FSCTL_GET_INTEGRITY_INFORMATION_BUFFER, Reserved) - 2usize];
    ["Offset of field: _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER::Flags"]
        [::std::mem::offset_of!(_FSCTL_GET_INTEGRITY_INFORMATION_BUFFER, Flags) - 4usize];
    ["Offset of field: _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER::ChecksumChunkSizeInBytes"][::std::mem::offset_of!(
        _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER,
        ChecksumChunkSizeInBytes
    )
        - 8usize];
    ["Offset of field: _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER::ClusterSizeInBytes"][::std::mem::offset_of!(
        _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER,
        ClusterSizeInBytes
    ) - 12usize];
};
pub type FSCTL_GET_INTEGRITY_INFORMATION_BUFFER = _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER;
pub type PFSCTL_GET_INTEGRITY_INFORMATION_BUFFER = *mut _FSCTL_GET_INTEGRITY_INFORMATION_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER {
    pub ChecksumAlgorithm: WORD,
    pub Reserved: WORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER"]
        [::std::mem::size_of::<_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER>() - 8usize];
    ["Alignment of _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER"]
        [::std::mem::align_of::<_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER>() - 4usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER::ChecksumAlgorithm"][::std::mem::offset_of!(
        _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER,
        ChecksumAlgorithm
    ) - 0usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER::Reserved"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER, Reserved) - 2usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER::Flags"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER, Flags) - 4usize];
};
pub type FSCTL_SET_INTEGRITY_INFORMATION_BUFFER = _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER;
pub type PFSCTL_SET_INTEGRITY_INFORMATION_BUFFER = *mut _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX {
    pub EnableIntegrity: BYTE,
    pub KeepIntegrityStateUnchanged: BYTE,
    pub Reserved: WORD,
    pub Flags: DWORD,
    pub Version: BYTE,
    pub Reserved2: [BYTE; 7usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX"]
        [::std::mem::size_of::<_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX>() - 16usize];
    ["Alignment of _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX"]
        [::std::mem::align_of::<_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX>() - 4usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::EnableIntegrity"][::std::mem::offset_of!(
        _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX,
        EnableIntegrity
    ) - 0usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::KeepIntegrityStateUnchanged"][::std::mem::offset_of!(
        _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX,
        KeepIntegrityStateUnchanged
    )
        - 1usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::Reserved"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX, Reserved) - 2usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::Flags"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX, Flags) - 4usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::Version"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX, Version) - 8usize];
    ["Offset of field: _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX::Reserved2"]
        [::std::mem::offset_of!(_FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX, Reserved2) - 9usize];
};
pub type FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX = _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX;
pub type PFSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX =
    *mut _FSCTL_SET_INTEGRITY_INFORMATION_BUFFER_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_OFFLOAD_READ_INPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub TokenTimeToLive: DWORD,
    pub Reserved: DWORD,
    pub FileOffset: DWORDLONG,
    pub CopyLength: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_OFFLOAD_READ_INPUT"]
        [::std::mem::size_of::<_FSCTL_OFFLOAD_READ_INPUT>() - 32usize];
    ["Alignment of _FSCTL_OFFLOAD_READ_INPUT"]
        [::std::mem::align_of::<_FSCTL_OFFLOAD_READ_INPUT>() - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, Size) - 0usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, Flags) - 4usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::TokenTimeToLive"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, TokenTimeToLive) - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::Reserved"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, Reserved) - 12usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::FileOffset"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, FileOffset) - 16usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_INPUT::CopyLength"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_INPUT, CopyLength) - 24usize];
};
pub type FSCTL_OFFLOAD_READ_INPUT = _FSCTL_OFFLOAD_READ_INPUT;
pub type PFSCTL_OFFLOAD_READ_INPUT = *mut _FSCTL_OFFLOAD_READ_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_OFFLOAD_READ_OUTPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub TransferLength: DWORDLONG,
    pub Token: [BYTE; 512usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_OFFLOAD_READ_OUTPUT"]
        [::std::mem::size_of::<_FSCTL_OFFLOAD_READ_OUTPUT>() - 528usize];
    ["Alignment of _FSCTL_OFFLOAD_READ_OUTPUT"]
        [::std::mem::align_of::<_FSCTL_OFFLOAD_READ_OUTPUT>() - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_OUTPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_OUTPUT, Size) - 0usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_OUTPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_OUTPUT, Flags) - 4usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_OUTPUT::TransferLength"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_OUTPUT, TransferLength) - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_READ_OUTPUT::Token"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_READ_OUTPUT, Token) - 16usize];
};
pub type FSCTL_OFFLOAD_READ_OUTPUT = _FSCTL_OFFLOAD_READ_OUTPUT;
pub type PFSCTL_OFFLOAD_READ_OUTPUT = *mut _FSCTL_OFFLOAD_READ_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_OFFLOAD_WRITE_INPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub FileOffset: DWORDLONG,
    pub CopyLength: DWORDLONG,
    pub TransferOffset: DWORDLONG,
    pub Token: [BYTE; 512usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_OFFLOAD_WRITE_INPUT"]
        [::std::mem::size_of::<_FSCTL_OFFLOAD_WRITE_INPUT>() - 544usize];
    ["Alignment of _FSCTL_OFFLOAD_WRITE_INPUT"]
        [::std::mem::align_of::<_FSCTL_OFFLOAD_WRITE_INPUT>() - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, Size) - 0usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, Flags) - 4usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::FileOffset"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, FileOffset) - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::CopyLength"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, CopyLength) - 16usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::TransferOffset"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, TransferOffset) - 24usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_INPUT::Token"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_INPUT, Token) - 32usize];
};
pub type FSCTL_OFFLOAD_WRITE_INPUT = _FSCTL_OFFLOAD_WRITE_INPUT;
pub type PFSCTL_OFFLOAD_WRITE_INPUT = *mut _FSCTL_OFFLOAD_WRITE_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_OFFLOAD_WRITE_OUTPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub LengthWritten: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_OFFLOAD_WRITE_OUTPUT"]
        [::std::mem::size_of::<_FSCTL_OFFLOAD_WRITE_OUTPUT>() - 16usize];
    ["Alignment of _FSCTL_OFFLOAD_WRITE_OUTPUT"]
        [::std::mem::align_of::<_FSCTL_OFFLOAD_WRITE_OUTPUT>() - 8usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_OUTPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_OUTPUT, Size) - 0usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_OUTPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_OUTPUT, Flags) - 4usize];
    ["Offset of field: _FSCTL_OFFLOAD_WRITE_OUTPUT::LengthWritten"]
        [::std::mem::offset_of!(_FSCTL_OFFLOAD_WRITE_OUTPUT, LengthWritten) - 8usize];
};
pub type FSCTL_OFFLOAD_WRITE_OUTPUT = _FSCTL_OFFLOAD_WRITE_OUTPUT;
pub type PFSCTL_OFFLOAD_WRITE_OUTPUT = *mut _FSCTL_OFFLOAD_WRITE_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SET_PURGE_FAILURE_MODE_INPUT {
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_PURGE_FAILURE_MODE_INPUT"]
        [::std::mem::size_of::<_SET_PURGE_FAILURE_MODE_INPUT>() - 4usize];
    ["Alignment of _SET_PURGE_FAILURE_MODE_INPUT"]
        [::std::mem::align_of::<_SET_PURGE_FAILURE_MODE_INPUT>() - 4usize];
    ["Offset of field: _SET_PURGE_FAILURE_MODE_INPUT::Flags"]
        [::std::mem::offset_of!(_SET_PURGE_FAILURE_MODE_INPUT, Flags) - 0usize];
};
pub type SET_PURGE_FAILURE_MODE_INPUT = _SET_PURGE_FAILURE_MODE_INPUT;
pub type PSET_PURGE_FAILURE_MODE_INPUT = *mut _SET_PURGE_FAILURE_MODE_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _REPAIR_COPIES_INPUT {
    pub Size: DWORD,
    pub Flags: DWORD,
    pub FileOffset: LARGE_INTEGER,
    pub Length: DWORD,
    pub SourceCopy: DWORD,
    pub NumberOfRepairCopies: DWORD,
    pub RepairCopies: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REPAIR_COPIES_INPUT"][::std::mem::size_of::<_REPAIR_COPIES_INPUT>() - 32usize];
    ["Alignment of _REPAIR_COPIES_INPUT"][::std::mem::align_of::<_REPAIR_COPIES_INPUT>() - 8usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::Size"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, Size) - 0usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::Flags"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, Flags) - 4usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::FileOffset"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, FileOffset) - 8usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::Length"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, Length) - 16usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::SourceCopy"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, SourceCopy) - 20usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::NumberOfRepairCopies"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, NumberOfRepairCopies) - 24usize];
    ["Offset of field: _REPAIR_COPIES_INPUT::RepairCopies"]
        [::std::mem::offset_of!(_REPAIR_COPIES_INPUT, RepairCopies) - 28usize];
};
pub type REPAIR_COPIES_INPUT = _REPAIR_COPIES_INPUT;
pub type PREPAIR_COPIES_INPUT = *mut _REPAIR_COPIES_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _REPAIR_COPIES_OUTPUT {
    pub Size: DWORD,
    pub Status: DWORD,
    pub ResumeFileOffset: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REPAIR_COPIES_OUTPUT"][::std::mem::size_of::<_REPAIR_COPIES_OUTPUT>() - 16usize];
    ["Alignment of _REPAIR_COPIES_OUTPUT"]
        [::std::mem::align_of::<_REPAIR_COPIES_OUTPUT>() - 8usize];
    ["Offset of field: _REPAIR_COPIES_OUTPUT::Size"]
        [::std::mem::offset_of!(_REPAIR_COPIES_OUTPUT, Size) - 0usize];
    ["Offset of field: _REPAIR_COPIES_OUTPUT::Status"]
        [::std::mem::offset_of!(_REPAIR_COPIES_OUTPUT, Status) - 4usize];
    ["Offset of field: _REPAIR_COPIES_OUTPUT::ResumeFileOffset"]
        [::std::mem::offset_of!(_REPAIR_COPIES_OUTPUT, ResumeFileOffset) - 8usize];
};
pub type REPAIR_COPIES_OUTPUT = _REPAIR_COPIES_OUTPUT;
pub type PREPAIR_COPIES_OUTPUT = *mut _REPAIR_COPIES_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REGION_INFO {
    pub FileOffset: LONGLONG,
    pub Length: LONGLONG,
    pub Usage: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REGION_INFO"][::std::mem::size_of::<_FILE_REGION_INFO>() - 24usize];
    ["Alignment of _FILE_REGION_INFO"][::std::mem::align_of::<_FILE_REGION_INFO>() - 8usize];
    ["Offset of field: _FILE_REGION_INFO::FileOffset"]
        [::std::mem::offset_of!(_FILE_REGION_INFO, FileOffset) - 0usize];
    ["Offset of field: _FILE_REGION_INFO::Length"]
        [::std::mem::offset_of!(_FILE_REGION_INFO, Length) - 8usize];
    ["Offset of field: _FILE_REGION_INFO::Usage"]
        [::std::mem::offset_of!(_FILE_REGION_INFO, Usage) - 16usize];
    ["Offset of field: _FILE_REGION_INFO::Reserved"]
        [::std::mem::offset_of!(_FILE_REGION_INFO, Reserved) - 20usize];
};
pub type FILE_REGION_INFO = _FILE_REGION_INFO;
pub type PFILE_REGION_INFO = *mut _FILE_REGION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REGION_OUTPUT {
    pub Flags: DWORD,
    pub TotalRegionEntryCount: DWORD,
    pub RegionEntryCount: DWORD,
    pub Reserved: DWORD,
    pub Region: [FILE_REGION_INFO; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REGION_OUTPUT"][::std::mem::size_of::<_FILE_REGION_OUTPUT>() - 40usize];
    ["Alignment of _FILE_REGION_OUTPUT"][::std::mem::align_of::<_FILE_REGION_OUTPUT>() - 8usize];
    ["Offset of field: _FILE_REGION_OUTPUT::Flags"]
        [::std::mem::offset_of!(_FILE_REGION_OUTPUT, Flags) - 0usize];
    ["Offset of field: _FILE_REGION_OUTPUT::TotalRegionEntryCount"]
        [::std::mem::offset_of!(_FILE_REGION_OUTPUT, TotalRegionEntryCount) - 4usize];
    ["Offset of field: _FILE_REGION_OUTPUT::RegionEntryCount"]
        [::std::mem::offset_of!(_FILE_REGION_OUTPUT, RegionEntryCount) - 8usize];
    ["Offset of field: _FILE_REGION_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_FILE_REGION_OUTPUT, Reserved) - 12usize];
    ["Offset of field: _FILE_REGION_OUTPUT::Region"]
        [::std::mem::offset_of!(_FILE_REGION_OUTPUT, Region) - 16usize];
};
pub type FILE_REGION_OUTPUT = _FILE_REGION_OUTPUT;
pub type PFILE_REGION_OUTPUT = *mut _FILE_REGION_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_REGION_INPUT {
    pub FileOffset: LONGLONG,
    pub Length: LONGLONG,
    pub DesiredUsage: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_REGION_INPUT"][::std::mem::size_of::<_FILE_REGION_INPUT>() - 24usize];
    ["Alignment of _FILE_REGION_INPUT"][::std::mem::align_of::<_FILE_REGION_INPUT>() - 8usize];
    ["Offset of field: _FILE_REGION_INPUT::FileOffset"]
        [::std::mem::offset_of!(_FILE_REGION_INPUT, FileOffset) - 0usize];
    ["Offset of field: _FILE_REGION_INPUT::Length"]
        [::std::mem::offset_of!(_FILE_REGION_INPUT, Length) - 8usize];
    ["Offset of field: _FILE_REGION_INPUT::DesiredUsage"]
        [::std::mem::offset_of!(_FILE_REGION_INPUT, DesiredUsage) - 16usize];
};
pub type FILE_REGION_INPUT = _FILE_REGION_INPUT;
pub type PFILE_REGION_INPUT = *mut _FILE_REGION_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WRITE_USN_REASON_INPUT {
    pub Flags: DWORD,
    pub UsnReasonToWrite: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WRITE_USN_REASON_INPUT"][::std::mem::size_of::<_WRITE_USN_REASON_INPUT>() - 8usize];
    ["Alignment of _WRITE_USN_REASON_INPUT"]
        [::std::mem::align_of::<_WRITE_USN_REASON_INPUT>() - 4usize];
    ["Offset of field: _WRITE_USN_REASON_INPUT::Flags"]
        [::std::mem::offset_of!(_WRITE_USN_REASON_INPUT, Flags) - 0usize];
    ["Offset of field: _WRITE_USN_REASON_INPUT::UsnReasonToWrite"]
        [::std::mem::offset_of!(_WRITE_USN_REASON_INPUT, UsnReasonToWrite) - 4usize];
};
pub type WRITE_USN_REASON_INPUT = _WRITE_USN_REASON_INPUT;
pub type PWRITE_USN_REASON_INPUT = *mut _WRITE_USN_REASON_INPUT;
pub const _FILE_STORAGE_TIER_MEDIA_TYPE_FileStorageTierMediaTypeUnspecified:
    _FILE_STORAGE_TIER_MEDIA_TYPE = 0;
pub const _FILE_STORAGE_TIER_MEDIA_TYPE_FileStorageTierMediaTypeDisk:
    _FILE_STORAGE_TIER_MEDIA_TYPE = 1;
pub const _FILE_STORAGE_TIER_MEDIA_TYPE_FileStorageTierMediaTypeSsd: _FILE_STORAGE_TIER_MEDIA_TYPE =
    2;
pub const _FILE_STORAGE_TIER_MEDIA_TYPE_FileStorageTierMediaTypeScm: _FILE_STORAGE_TIER_MEDIA_TYPE =
    4;
pub const _FILE_STORAGE_TIER_MEDIA_TYPE_FileStorageTierMediaTypeMax: _FILE_STORAGE_TIER_MEDIA_TYPE =
    5;
pub type _FILE_STORAGE_TIER_MEDIA_TYPE = ::std::os::raw::c_int;
pub use self::_FILE_STORAGE_TIER_MEDIA_TYPE as FILE_STORAGE_TIER_MEDIA_TYPE;
pub type PFILE_STORAGE_TIER_MEDIA_TYPE = *mut _FILE_STORAGE_TIER_MEDIA_TYPE;
pub const _FILE_STORAGE_TIER_CLASS_FileStorageTierClassUnspecified: _FILE_STORAGE_TIER_CLASS = 0;
pub const _FILE_STORAGE_TIER_CLASS_FileStorageTierClassCapacity: _FILE_STORAGE_TIER_CLASS = 1;
pub const _FILE_STORAGE_TIER_CLASS_FileStorageTierClassPerformance: _FILE_STORAGE_TIER_CLASS = 2;
pub const _FILE_STORAGE_TIER_CLASS_FileStorageTierClassMax: _FILE_STORAGE_TIER_CLASS = 3;
pub type _FILE_STORAGE_TIER_CLASS = ::std::os::raw::c_int;
pub use self::_FILE_STORAGE_TIER_CLASS as FILE_STORAGE_TIER_CLASS;
pub type PFILE_STORAGE_TIER_CLASS = *mut _FILE_STORAGE_TIER_CLASS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_STORAGE_TIER {
    pub Id: GUID,
    pub Name: [WCHAR; 256usize],
    pub Description: [WCHAR; 256usize],
    pub Flags: DWORDLONG,
    pub ProvisionedCapacity: DWORDLONG,
    pub MediaType: FILE_STORAGE_TIER_MEDIA_TYPE,
    pub Class: FILE_STORAGE_TIER_CLASS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_STORAGE_TIER"][::std::mem::size_of::<_FILE_STORAGE_TIER>() - 1064usize];
    ["Alignment of _FILE_STORAGE_TIER"][::std::mem::align_of::<_FILE_STORAGE_TIER>() - 8usize];
    ["Offset of field: _FILE_STORAGE_TIER::Id"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, Id) - 0usize];
    ["Offset of field: _FILE_STORAGE_TIER::Name"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, Name) - 16usize];
    ["Offset of field: _FILE_STORAGE_TIER::Description"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, Description) - 528usize];
    ["Offset of field: _FILE_STORAGE_TIER::Flags"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, Flags) - 1040usize];
    ["Offset of field: _FILE_STORAGE_TIER::ProvisionedCapacity"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, ProvisionedCapacity) - 1048usize];
    ["Offset of field: _FILE_STORAGE_TIER::MediaType"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, MediaType) - 1056usize];
    ["Offset of field: _FILE_STORAGE_TIER::Class"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER, Class) - 1060usize];
};
pub type FILE_STORAGE_TIER = _FILE_STORAGE_TIER;
pub type PFILE_STORAGE_TIER = *mut _FILE_STORAGE_TIER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub TotalNumberOfTiers: DWORD,
    pub NumberOfTiersReturned: DWORD,
    pub Tiers: [FILE_STORAGE_TIER; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT"]
        [::std::mem::size_of::<_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT>() - 1088usize];
    ["Alignment of _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT"]
        [::std::mem::align_of::<_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT>() - 8usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::Version"]
        [::std::mem::offset_of!(_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT, Version) - 0usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT, Size) - 4usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT, Flags) - 8usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::TotalNumberOfTiers"]
        [::std::mem::offset_of!(_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT, TotalNumberOfTiers) - 12usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::NumberOfTiersReturned"][::std::mem::offset_of!(
        _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT,
        NumberOfTiersReturned
    ) - 16usize];
    ["Offset of field: _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT::Tiers"]
        [::std::mem::offset_of!(_FSCTL_QUERY_STORAGE_CLASSES_OUTPUT, Tiers) - 24usize];
};
pub type FSCTL_QUERY_STORAGE_CLASSES_OUTPUT = _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT;
pub type PFSCTL_QUERY_STORAGE_CLASSES_OUTPUT = *mut _FSCTL_QUERY_STORAGE_CLASSES_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _STREAM_INFORMATION_ENTRY {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub StreamInformation: _STREAM_INFORMATION_ENTRY__StreamInformation,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _STREAM_INFORMATION_ENTRY__StreamInformation {
    pub DesiredStorageClass: _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass,
    pub DataStream: _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
    pub Reparse: _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse,
    pub Ea: _STREAM_INFORMATION_ENTRY__StreamInformation__Ea,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass {
    pub Class: FILE_STORAGE_TIER_CLASS,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass"]
        [::std::mem::size_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass>(
        ) - 8usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass"]
        [::std::mem::align_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass>(
        ) - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass::Class"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass,
        Class
    )
        - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass::Flags"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DesiredStorageClass,
        Flags
    )
        - 4usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream {
    pub Length: WORD,
    pub Flags: WORD,
    pub Reserved: DWORD,
    pub Vdl: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream"][::std::mem::size_of::<
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
    >() - 16usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream"][::std::mem::align_of::<
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
    >() - 8usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream::Length"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
        Length
    )
        - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream::Flags"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
        Flags
    )
        - 2usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream::Reserved"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
        Reserved
    )
        - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream::Vdl"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__DataStream,
        Vdl
    ) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse {
    pub Length: WORD,
    pub Flags: WORD,
    pub ReparseDataSize: DWORD,
    pub ReparseDataOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse"]
        [::std::mem::size_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__Reparse>() - 12usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse"]
        [::std::mem::align_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__Reparse>() - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse::Length"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse,
        Length
    ) - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse::Flags"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse,
        Flags
    ) - 2usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse::ReparseDataSize"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse,
        ReparseDataSize
    )
        - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse::ReparseDataOffset"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__Reparse,
        ReparseDataOffset
    )
        - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAM_INFORMATION_ENTRY__StreamInformation__Ea {
    pub Length: WORD,
    pub Flags: WORD,
    pub EaSize: DWORD,
    pub EaInformationOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY__StreamInformation__Ea"]
        [::std::mem::size_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__Ea>() - 12usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY__StreamInformation__Ea"]
        [::std::mem::align_of::<_STREAM_INFORMATION_ENTRY__StreamInformation__Ea>() - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Ea::Length"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation__Ea, Length) - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Ea::Flags"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation__Ea, Flags) - 2usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Ea::EaSize"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation__Ea, EaSize) - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation__Ea::EaInformationOffset"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation__Ea,
        EaInformationOffset
    )
        - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY__StreamInformation"]
        [::std::mem::size_of::<_STREAM_INFORMATION_ENTRY__StreamInformation>() - 16usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY__StreamInformation"]
        [::std::mem::align_of::<_STREAM_INFORMATION_ENTRY__StreamInformation>() - 8usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation::DesiredStorageClass"][::std::mem::offset_of!(
        _STREAM_INFORMATION_ENTRY__StreamInformation,
        DesiredStorageClass
    )
        - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation::DataStream"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation, DataStream) - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation::Reparse"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation, Reparse) - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY__StreamInformation::Ea"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY__StreamInformation, Ea) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAM_INFORMATION_ENTRY"]
        [::std::mem::size_of::<_STREAM_INFORMATION_ENTRY>() - 24usize];
    ["Alignment of _STREAM_INFORMATION_ENTRY"]
        [::std::mem::align_of::<_STREAM_INFORMATION_ENTRY>() - 8usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY::Version"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY, Version) - 0usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY::Flags"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY, Flags) - 4usize];
    ["Offset of field: _STREAM_INFORMATION_ENTRY::StreamInformation"]
        [::std::mem::offset_of!(_STREAM_INFORMATION_ENTRY, StreamInformation) - 8usize];
};
pub type STREAM_INFORMATION_ENTRY = _STREAM_INFORMATION_ENTRY;
pub type PSTREAM_INFORMATION_ENTRY = *mut _STREAM_INFORMATION_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_QUERY_REGION_INFO_INPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub NumberOfTierIds: DWORD,
    pub TierIds: [GUID; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_QUERY_REGION_INFO_INPUT"]
        [::std::mem::size_of::<_FSCTL_QUERY_REGION_INFO_INPUT>() - 32usize];
    ["Alignment of _FSCTL_QUERY_REGION_INFO_INPUT"]
        [::std::mem::align_of::<_FSCTL_QUERY_REGION_INFO_INPUT>() - 4usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_INPUT::Version"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_INPUT, Version) - 0usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_INPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_INPUT, Size) - 4usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_INPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_INPUT, Flags) - 8usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_INPUT::NumberOfTierIds"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_INPUT, NumberOfTierIds) - 12usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_INPUT::TierIds"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_INPUT, TierIds) - 16usize];
};
pub type FSCTL_QUERY_REGION_INFO_INPUT = _FSCTL_QUERY_REGION_INFO_INPUT;
pub type PFSCTL_QUERY_REGION_INFO_INPUT = *mut _FSCTL_QUERY_REGION_INFO_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_STORAGE_TIER_REGION {
    pub TierId: GUID,
    pub Offset: DWORDLONG,
    pub Length: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_STORAGE_TIER_REGION"]
        [::std::mem::size_of::<_FILE_STORAGE_TIER_REGION>() - 32usize];
    ["Alignment of _FILE_STORAGE_TIER_REGION"]
        [::std::mem::align_of::<_FILE_STORAGE_TIER_REGION>() - 8usize];
    ["Offset of field: _FILE_STORAGE_TIER_REGION::TierId"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER_REGION, TierId) - 0usize];
    ["Offset of field: _FILE_STORAGE_TIER_REGION::Offset"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER_REGION, Offset) - 16usize];
    ["Offset of field: _FILE_STORAGE_TIER_REGION::Length"]
        [::std::mem::offset_of!(_FILE_STORAGE_TIER_REGION, Length) - 24usize];
};
pub type FILE_STORAGE_TIER_REGION = _FILE_STORAGE_TIER_REGION;
pub type PFILE_STORAGE_TIER_REGION = *mut _FILE_STORAGE_TIER_REGION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FSCTL_QUERY_REGION_INFO_OUTPUT {
    pub Version: DWORD,
    pub Size: DWORD,
    pub Flags: DWORD,
    pub Reserved: DWORD,
    pub Alignment: DWORDLONG,
    pub TotalNumberOfRegions: DWORD,
    pub NumberOfRegionsReturned: DWORD,
    pub Regions: [FILE_STORAGE_TIER_REGION; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FSCTL_QUERY_REGION_INFO_OUTPUT"]
        [::std::mem::size_of::<_FSCTL_QUERY_REGION_INFO_OUTPUT>() - 64usize];
    ["Alignment of _FSCTL_QUERY_REGION_INFO_OUTPUT"]
        [::std::mem::align_of::<_FSCTL_QUERY_REGION_INFO_OUTPUT>() - 8usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Version"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Version) - 0usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Size"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Size) - 4usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Flags"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Flags) - 8usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Reserved"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Reserved) - 12usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Alignment"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Alignment) - 16usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::TotalNumberOfRegions"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, TotalNumberOfRegions) - 24usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::NumberOfRegionsReturned"][::std::mem::offset_of!(
        _FSCTL_QUERY_REGION_INFO_OUTPUT,
        NumberOfRegionsReturned
    ) - 28usize];
    ["Offset of field: _FSCTL_QUERY_REGION_INFO_OUTPUT::Regions"]
        [::std::mem::offset_of!(_FSCTL_QUERY_REGION_INFO_OUTPUT, Regions) - 32usize];
};
pub type FSCTL_QUERY_REGION_INFO_OUTPUT = _FSCTL_QUERY_REGION_INFO_OUTPUT;
pub type PFSCTL_QUERY_REGION_INFO_OUTPUT = *mut _FSCTL_QUERY_REGION_INFO_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_DESIRED_STORAGE_CLASS_INFORMATION {
    pub Class: FILE_STORAGE_TIER_CLASS,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_DESIRED_STORAGE_CLASS_INFORMATION"]
        [::std::mem::size_of::<_FILE_DESIRED_STORAGE_CLASS_INFORMATION>() - 8usize];
    ["Alignment of _FILE_DESIRED_STORAGE_CLASS_INFORMATION"]
        [::std::mem::align_of::<_FILE_DESIRED_STORAGE_CLASS_INFORMATION>() - 4usize];
    ["Offset of field: _FILE_DESIRED_STORAGE_CLASS_INFORMATION::Class"]
        [::std::mem::offset_of!(_FILE_DESIRED_STORAGE_CLASS_INFORMATION, Class) - 0usize];
    ["Offset of field: _FILE_DESIRED_STORAGE_CLASS_INFORMATION::Flags"]
        [::std::mem::offset_of!(_FILE_DESIRED_STORAGE_CLASS_INFORMATION, Flags) - 4usize];
};
pub type FILE_DESIRED_STORAGE_CLASS_INFORMATION = _FILE_DESIRED_STORAGE_CLASS_INFORMATION;
pub type PFILE_DESIRED_STORAGE_CLASS_INFORMATION = *mut _FILE_DESIRED_STORAGE_CLASS_INFORMATION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DUPLICATE_EXTENTS_DATA {
    pub FileHandle: HANDLE,
    pub SourceFileOffset: LARGE_INTEGER,
    pub TargetFileOffset: LARGE_INTEGER,
    pub ByteCount: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DUPLICATE_EXTENTS_DATA"][::std::mem::size_of::<_DUPLICATE_EXTENTS_DATA>() - 32usize];
    ["Alignment of _DUPLICATE_EXTENTS_DATA"]
        [::std::mem::align_of::<_DUPLICATE_EXTENTS_DATA>() - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA::FileHandle"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA, FileHandle) - 0usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA::SourceFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA, SourceFileOffset) - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA::TargetFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA, TargetFileOffset) - 16usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA::ByteCount"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA, ByteCount) - 24usize];
};
pub type DUPLICATE_EXTENTS_DATA = _DUPLICATE_EXTENTS_DATA;
pub type PDUPLICATE_EXTENTS_DATA = *mut _DUPLICATE_EXTENTS_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DUPLICATE_EXTENTS_DATA32 {
    pub FileHandle: UINT32,
    pub SourceFileOffset: LARGE_INTEGER,
    pub TargetFileOffset: LARGE_INTEGER,
    pub ByteCount: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DUPLICATE_EXTENTS_DATA32"]
        [::std::mem::size_of::<_DUPLICATE_EXTENTS_DATA32>() - 32usize];
    ["Alignment of _DUPLICATE_EXTENTS_DATA32"]
        [::std::mem::align_of::<_DUPLICATE_EXTENTS_DATA32>() - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA32::FileHandle"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA32, FileHandle) - 0usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA32::SourceFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA32, SourceFileOffset) - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA32::TargetFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA32, TargetFileOffset) - 16usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA32::ByteCount"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA32, ByteCount) - 24usize];
};
pub type DUPLICATE_EXTENTS_DATA32 = _DUPLICATE_EXTENTS_DATA32;
pub type PDUPLICATE_EXTENTS_DATA32 = *mut _DUPLICATE_EXTENTS_DATA32;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DUPLICATE_EXTENTS_DATA_EX {
    pub Size: SIZE_T,
    pub FileHandle: HANDLE,
    pub SourceFileOffset: LARGE_INTEGER,
    pub TargetFileOffset: LARGE_INTEGER,
    pub ByteCount: LARGE_INTEGER,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DUPLICATE_EXTENTS_DATA_EX"]
        [::std::mem::size_of::<_DUPLICATE_EXTENTS_DATA_EX>() - 48usize];
    ["Alignment of _DUPLICATE_EXTENTS_DATA_EX"]
        [::std::mem::align_of::<_DUPLICATE_EXTENTS_DATA_EX>() - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::Size"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, Size) - 0usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::FileHandle"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, FileHandle) - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::SourceFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, SourceFileOffset) - 16usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::TargetFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, TargetFileOffset) - 24usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::ByteCount"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, ByteCount) - 32usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX::Flags"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX, Flags) - 40usize];
};
pub type DUPLICATE_EXTENTS_DATA_EX = _DUPLICATE_EXTENTS_DATA_EX;
pub type PDUPLICATE_EXTENTS_DATA_EX = *mut _DUPLICATE_EXTENTS_DATA_EX;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DUPLICATE_EXTENTS_DATA_EX32 {
    pub Size: DWORD32,
    pub FileHandle: DWORD32,
    pub SourceFileOffset: LARGE_INTEGER,
    pub TargetFileOffset: LARGE_INTEGER,
    pub ByteCount: LARGE_INTEGER,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DUPLICATE_EXTENTS_DATA_EX32"]
        [::std::mem::size_of::<_DUPLICATE_EXTENTS_DATA_EX32>() - 40usize];
    ["Alignment of _DUPLICATE_EXTENTS_DATA_EX32"]
        [::std::mem::align_of::<_DUPLICATE_EXTENTS_DATA_EX32>() - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::Size"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, Size) - 0usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::FileHandle"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, FileHandle) - 4usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::SourceFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, SourceFileOffset) - 8usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::TargetFileOffset"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, TargetFileOffset) - 16usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::ByteCount"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, ByteCount) - 24usize];
    ["Offset of field: _DUPLICATE_EXTENTS_DATA_EX32::Flags"]
        [::std::mem::offset_of!(_DUPLICATE_EXTENTS_DATA_EX32, Flags) - 32usize];
};
pub type DUPLICATE_EXTENTS_DATA_EX32 = _DUPLICATE_EXTENTS_DATA_EX32;
pub type PDUPLICATE_EXTENTS_DATA_EX32 = *mut _DUPLICATE_EXTENTS_DATA_EX32;
pub const _DUPLICATE_EXTENTS_STATE_FileSnapStateInactive: _DUPLICATE_EXTENTS_STATE = 0;
pub const _DUPLICATE_EXTENTS_STATE_FileSnapStateSource: _DUPLICATE_EXTENTS_STATE = 1;
pub const _DUPLICATE_EXTENTS_STATE_FileSnapStateTarget: _DUPLICATE_EXTENTS_STATE = 2;
pub type _DUPLICATE_EXTENTS_STATE = ::std::os::raw::c_int;
pub use self::_DUPLICATE_EXTENTS_STATE as DUPLICATE_EXTENTS_STATE;
pub type PDUPLICATE_EXTENTS_STATE = *mut _DUPLICATE_EXTENTS_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ASYNC_DUPLICATE_EXTENTS_STATUS {
    pub Version: DWORD,
    pub State: DUPLICATE_EXTENTS_STATE,
    pub SourceFileOffset: DWORDLONG,
    pub TargetFileOffset: DWORDLONG,
    pub ByteCount: DWORDLONG,
    pub BytesDuplicated: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ASYNC_DUPLICATE_EXTENTS_STATUS"]
        [::std::mem::size_of::<_ASYNC_DUPLICATE_EXTENTS_STATUS>() - 40usize];
    ["Alignment of _ASYNC_DUPLICATE_EXTENTS_STATUS"]
        [::std::mem::align_of::<_ASYNC_DUPLICATE_EXTENTS_STATUS>() - 8usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::Version"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, Version) - 0usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::State"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, State) - 4usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::SourceFileOffset"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, SourceFileOffset) - 8usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::TargetFileOffset"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, TargetFileOffset) - 16usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::ByteCount"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, ByteCount) - 24usize];
    ["Offset of field: _ASYNC_DUPLICATE_EXTENTS_STATUS::BytesDuplicated"]
        [::std::mem::offset_of!(_ASYNC_DUPLICATE_EXTENTS_STATUS, BytesDuplicated) - 32usize];
};
pub type ASYNC_DUPLICATE_EXTENTS_STATUS = _ASYNC_DUPLICATE_EXTENTS_STATUS;
pub type PASYNC_DUPLICATE_EXTENTS_STATUS = *mut _ASYNC_DUPLICATE_EXTENTS_STATUS;
pub const _REFS_SMR_VOLUME_GC_STATE_SmrGcStateInactive: _REFS_SMR_VOLUME_GC_STATE = 0;
pub const _REFS_SMR_VOLUME_GC_STATE_SmrGcStatePaused: _REFS_SMR_VOLUME_GC_STATE = 1;
pub const _REFS_SMR_VOLUME_GC_STATE_SmrGcStateActive: _REFS_SMR_VOLUME_GC_STATE = 2;
pub const _REFS_SMR_VOLUME_GC_STATE_SmrGcStateActiveFullSpeed: _REFS_SMR_VOLUME_GC_STATE = 3;
pub type _REFS_SMR_VOLUME_GC_STATE = ::std::os::raw::c_int;
pub use self::_REFS_SMR_VOLUME_GC_STATE as REFS_SMR_VOLUME_GC_STATE;
pub type PREFS_SMR_VOLUME_GC_STATE = *mut _REFS_SMR_VOLUME_GC_STATE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _REFS_SMR_VOLUME_INFO_OUTPUT {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub SizeOfRandomlyWritableTier: LARGE_INTEGER,
    pub FreeSpaceInRandomlyWritableTier: LARGE_INTEGER,
    pub SizeofSMRTier: LARGE_INTEGER,
    pub FreeSpaceInSMRTier: LARGE_INTEGER,
    pub UsableFreeSpaceInSMRTier: LARGE_INTEGER,
    pub VolumeGcState: REFS_SMR_VOLUME_GC_STATE,
    pub VolumeGcLastStatus: DWORD,
    pub CurrentGcBandFillPercentage: DWORD,
    pub Unused: [DWORDLONG; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REFS_SMR_VOLUME_INFO_OUTPUT"]
        [::std::mem::size_of::<_REFS_SMR_VOLUME_INFO_OUTPUT>() - 112usize];
    ["Alignment of _REFS_SMR_VOLUME_INFO_OUTPUT"]
        [::std::mem::align_of::<_REFS_SMR_VOLUME_INFO_OUTPUT>() - 8usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::Version"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, Version) - 0usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::Flags"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, Flags) - 4usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::SizeOfRandomlyWritableTier"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, SizeOfRandomlyWritableTier) - 8usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::FreeSpaceInRandomlyWritableTier"][::std::mem::offset_of!(
        _REFS_SMR_VOLUME_INFO_OUTPUT,
        FreeSpaceInRandomlyWritableTier
    ) - 16usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::SizeofSMRTier"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, SizeofSMRTier) - 24usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::FreeSpaceInSMRTier"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, FreeSpaceInSMRTier) - 32usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::UsableFreeSpaceInSMRTier"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, UsableFreeSpaceInSMRTier) - 40usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::VolumeGcState"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, VolumeGcState) - 48usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::VolumeGcLastStatus"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, VolumeGcLastStatus) - 52usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::CurrentGcBandFillPercentage"][::std::mem::offset_of!(
        _REFS_SMR_VOLUME_INFO_OUTPUT,
        CurrentGcBandFillPercentage
    ) - 56usize];
    ["Offset of field: _REFS_SMR_VOLUME_INFO_OUTPUT::Unused"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_INFO_OUTPUT, Unused) - 64usize];
};
pub type REFS_SMR_VOLUME_INFO_OUTPUT = _REFS_SMR_VOLUME_INFO_OUTPUT;
pub type PREFS_SMR_VOLUME_INFO_OUTPUT = *mut _REFS_SMR_VOLUME_INFO_OUTPUT;
pub const _REFS_SMR_VOLUME_GC_ACTION_SmrGcActionStart: _REFS_SMR_VOLUME_GC_ACTION = 1;
pub const _REFS_SMR_VOLUME_GC_ACTION_SmrGcActionStartFullSpeed: _REFS_SMR_VOLUME_GC_ACTION = 2;
pub const _REFS_SMR_VOLUME_GC_ACTION_SmrGcActionPause: _REFS_SMR_VOLUME_GC_ACTION = 3;
pub const _REFS_SMR_VOLUME_GC_ACTION_SmrGcActionStop: _REFS_SMR_VOLUME_GC_ACTION = 4;
pub type _REFS_SMR_VOLUME_GC_ACTION = ::std::os::raw::c_int;
pub use self::_REFS_SMR_VOLUME_GC_ACTION as REFS_SMR_VOLUME_GC_ACTION;
pub type PREFS_SMR_VOLUME_GC_ACTION = *mut _REFS_SMR_VOLUME_GC_ACTION;
pub const _REFS_SMR_VOLUME_GC_METHOD_SmrGcMethodCompaction: _REFS_SMR_VOLUME_GC_METHOD = 1;
pub const _REFS_SMR_VOLUME_GC_METHOD_SmrGcMethodCompression: _REFS_SMR_VOLUME_GC_METHOD = 2;
pub const _REFS_SMR_VOLUME_GC_METHOD_SmrGcMethodRotation: _REFS_SMR_VOLUME_GC_METHOD = 3;
pub type _REFS_SMR_VOLUME_GC_METHOD = ::std::os::raw::c_int;
pub use self::_REFS_SMR_VOLUME_GC_METHOD as REFS_SMR_VOLUME_GC_METHOD;
pub type PREFS_SMR_VOLUME_GC_METHOD = *mut _REFS_SMR_VOLUME_GC_METHOD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REFS_SMR_VOLUME_GC_PARAMETERS {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub Action: REFS_SMR_VOLUME_GC_ACTION,
    pub Method: REFS_SMR_VOLUME_GC_METHOD,
    pub IoGranularity: DWORD,
    pub CompressionFormat: DWORD,
    pub Unused: [DWORDLONG; 8usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REFS_SMR_VOLUME_GC_PARAMETERS"]
        [::std::mem::size_of::<_REFS_SMR_VOLUME_GC_PARAMETERS>() - 88usize];
    ["Alignment of _REFS_SMR_VOLUME_GC_PARAMETERS"]
        [::std::mem::align_of::<_REFS_SMR_VOLUME_GC_PARAMETERS>() - 8usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::Version"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, Version) - 0usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::Flags"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, Flags) - 4usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::Action"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, Action) - 8usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::Method"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, Method) - 12usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::IoGranularity"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, IoGranularity) - 16usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::CompressionFormat"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, CompressionFormat) - 20usize];
    ["Offset of field: _REFS_SMR_VOLUME_GC_PARAMETERS::Unused"]
        [::std::mem::offset_of!(_REFS_SMR_VOLUME_GC_PARAMETERS, Unused) - 24usize];
};
pub type REFS_SMR_VOLUME_GC_PARAMETERS = _REFS_SMR_VOLUME_GC_PARAMETERS;
pub type PREFS_SMR_VOLUME_GC_PARAMETERS = *mut _REFS_SMR_VOLUME_GC_PARAMETERS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER {
    pub OptimalWriteSize: DWORD,
    pub StreamGranularitySize: DWORD,
    pub StreamIdMin: DWORD,
    pub StreamIdMax: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER"]
        [::std::mem::size_of::<_STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER>() - 16usize];
    ["Alignment of _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER"]
        [::std::mem::align_of::<_STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER>() - 4usize];
    ["Offset of field: _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER::OptimalWriteSize"][::std::mem::offset_of!(
        _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER,
        OptimalWriteSize
    ) - 0usize];
    ["Offset of field: _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER::StreamGranularitySize"][::std::mem::offset_of!(
        _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER,
        StreamGranularitySize
    ) - 4usize];
    ["Offset of field: _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER::StreamIdMin"]
        [::std::mem::offset_of!(_STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER, StreamIdMin) - 8usize];
    ["Offset of field: _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER::StreamIdMax"]
        [::std::mem::offset_of!(_STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER, StreamIdMax) - 12usize];
};
pub type STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER = _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER;
pub type PSTREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER = *mut _STREAMS_QUERY_PARAMETERS_OUTPUT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAMS_ASSOCIATE_ID_INPUT_BUFFER {
    pub Flags: DWORD,
    pub StreamId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAMS_ASSOCIATE_ID_INPUT_BUFFER"]
        [::std::mem::size_of::<_STREAMS_ASSOCIATE_ID_INPUT_BUFFER>() - 8usize];
    ["Alignment of _STREAMS_ASSOCIATE_ID_INPUT_BUFFER"]
        [::std::mem::align_of::<_STREAMS_ASSOCIATE_ID_INPUT_BUFFER>() - 4usize];
    ["Offset of field: _STREAMS_ASSOCIATE_ID_INPUT_BUFFER::Flags"]
        [::std::mem::offset_of!(_STREAMS_ASSOCIATE_ID_INPUT_BUFFER, Flags) - 0usize];
    ["Offset of field: _STREAMS_ASSOCIATE_ID_INPUT_BUFFER::StreamId"]
        [::std::mem::offset_of!(_STREAMS_ASSOCIATE_ID_INPUT_BUFFER, StreamId) - 4usize];
};
pub type STREAMS_ASSOCIATE_ID_INPUT_BUFFER = _STREAMS_ASSOCIATE_ID_INPUT_BUFFER;
pub type PSTREAMS_ASSOCIATE_ID_INPUT_BUFFER = *mut _STREAMS_ASSOCIATE_ID_INPUT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _STREAMS_QUERY_ID_OUTPUT_BUFFER {
    pub StreamId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _STREAMS_QUERY_ID_OUTPUT_BUFFER"]
        [::std::mem::size_of::<_STREAMS_QUERY_ID_OUTPUT_BUFFER>() - 4usize];
    ["Alignment of _STREAMS_QUERY_ID_OUTPUT_BUFFER"]
        [::std::mem::align_of::<_STREAMS_QUERY_ID_OUTPUT_BUFFER>() - 4usize];
    ["Offset of field: _STREAMS_QUERY_ID_OUTPUT_BUFFER::StreamId"]
        [::std::mem::offset_of!(_STREAMS_QUERY_ID_OUTPUT_BUFFER, StreamId) - 0usize];
};
pub type STREAMS_QUERY_ID_OUTPUT_BUFFER = _STREAMS_QUERY_ID_OUTPUT_BUFFER;
pub type PSTREAMS_QUERY_ID_OUTPUT_BUFFER = *mut _STREAMS_QUERY_ID_OUTPUT_BUFFER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_BAD_RANGES_INPUT_RANGE {
    pub StartOffset: DWORDLONG,
    pub LengthInBytes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_BAD_RANGES_INPUT_RANGE"]
        [::std::mem::size_of::<_QUERY_BAD_RANGES_INPUT_RANGE>() - 16usize];
    ["Alignment of _QUERY_BAD_RANGES_INPUT_RANGE"]
        [::std::mem::align_of::<_QUERY_BAD_RANGES_INPUT_RANGE>() - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_INPUT_RANGE::StartOffset"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_INPUT_RANGE, StartOffset) - 0usize];
    ["Offset of field: _QUERY_BAD_RANGES_INPUT_RANGE::LengthInBytes"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_INPUT_RANGE, LengthInBytes) - 8usize];
};
pub type QUERY_BAD_RANGES_INPUT_RANGE = _QUERY_BAD_RANGES_INPUT_RANGE;
pub type PQUERY_BAD_RANGES_INPUT_RANGE = *mut _QUERY_BAD_RANGES_INPUT_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_BAD_RANGES_INPUT {
    pub Flags: DWORD,
    pub NumRanges: DWORD,
    pub Ranges: [QUERY_BAD_RANGES_INPUT_RANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_BAD_RANGES_INPUT"][::std::mem::size_of::<_QUERY_BAD_RANGES_INPUT>() - 24usize];
    ["Alignment of _QUERY_BAD_RANGES_INPUT"]
        [::std::mem::align_of::<_QUERY_BAD_RANGES_INPUT>() - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_INPUT::Flags"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_INPUT, Flags) - 0usize];
    ["Offset of field: _QUERY_BAD_RANGES_INPUT::NumRanges"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_INPUT, NumRanges) - 4usize];
    ["Offset of field: _QUERY_BAD_RANGES_INPUT::Ranges"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_INPUT, Ranges) - 8usize];
};
pub type QUERY_BAD_RANGES_INPUT = _QUERY_BAD_RANGES_INPUT;
pub type PQUERY_BAD_RANGES_INPUT = *mut _QUERY_BAD_RANGES_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_BAD_RANGES_OUTPUT_RANGE {
    pub Flags: DWORD,
    pub Reserved: DWORD,
    pub StartOffset: DWORDLONG,
    pub LengthInBytes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_BAD_RANGES_OUTPUT_RANGE"]
        [::std::mem::size_of::<_QUERY_BAD_RANGES_OUTPUT_RANGE>() - 24usize];
    ["Alignment of _QUERY_BAD_RANGES_OUTPUT_RANGE"]
        [::std::mem::align_of::<_QUERY_BAD_RANGES_OUTPUT_RANGE>() - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT_RANGE::Flags"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT_RANGE, Flags) - 0usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT_RANGE::Reserved"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT_RANGE, Reserved) - 4usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT_RANGE::StartOffset"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT_RANGE, StartOffset) - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT_RANGE::LengthInBytes"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT_RANGE, LengthInBytes) - 16usize];
};
pub type QUERY_BAD_RANGES_OUTPUT_RANGE = _QUERY_BAD_RANGES_OUTPUT_RANGE;
pub type PQUERY_BAD_RANGES_OUTPUT_RANGE = *mut _QUERY_BAD_RANGES_OUTPUT_RANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_BAD_RANGES_OUTPUT {
    pub Flags: DWORD,
    pub NumBadRanges: DWORD,
    pub NextOffsetToLookUp: DWORDLONG,
    pub BadRanges: [QUERY_BAD_RANGES_OUTPUT_RANGE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_BAD_RANGES_OUTPUT"]
        [::std::mem::size_of::<_QUERY_BAD_RANGES_OUTPUT>() - 40usize];
    ["Alignment of _QUERY_BAD_RANGES_OUTPUT"]
        [::std::mem::align_of::<_QUERY_BAD_RANGES_OUTPUT>() - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT::Flags"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT, Flags) - 0usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT::NumBadRanges"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT, NumBadRanges) - 4usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT::NextOffsetToLookUp"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT, NextOffsetToLookUp) - 8usize];
    ["Offset of field: _QUERY_BAD_RANGES_OUTPUT::BadRanges"]
        [::std::mem::offset_of!(_QUERY_BAD_RANGES_OUTPUT, BadRanges) - 16usize];
};
pub type QUERY_BAD_RANGES_OUTPUT = _QUERY_BAD_RANGES_OUTPUT;
pub type PQUERY_BAD_RANGES_OUTPUT = *mut _QUERY_BAD_RANGES_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT {
    pub Flags: DWORD,
    pub AlignmentShift: DWORD,
    pub FileOffsetToAlign: DWORDLONG,
    pub FallbackAlignmentShift: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT"]
        [::std::mem::size_of::<_SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT>() - 24usize];
    ["Alignment of _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT"]
        [::std::mem::align_of::<_SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT>() - 8usize];
    ["Offset of field: _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT::Flags"]
        [::std::mem::offset_of!(_SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT, Flags) - 0usize];
    ["Offset of field: _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT::AlignmentShift"]
        [::std::mem::offset_of!(_SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT, AlignmentShift) - 4usize];
    ["Offset of field: _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT::FileOffsetToAlign"]
        [::std::mem::offset_of!(_SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT, FileOffsetToAlign) - 8usize];
    ["Offset of field: _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT::FallbackAlignmentShift"][::std::mem::offset_of!(
        _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT,
        FallbackAlignmentShift
    ) - 16usize];
};
pub type SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT = _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT;
pub type PSET_DAX_ALLOC_ALIGNMENT_HINT_INPUT = *mut _SET_DAX_ALLOC_ALIGNMENT_HINT_INPUT;
pub const _VIRTUAL_STORAGE_BEHAVIOR_CODE_VirtualStorageBehaviorUndefined:
    _VIRTUAL_STORAGE_BEHAVIOR_CODE = 0;
pub const _VIRTUAL_STORAGE_BEHAVIOR_CODE_VirtualStorageBehaviorCacheWriteThrough:
    _VIRTUAL_STORAGE_BEHAVIOR_CODE = 1;
pub const _VIRTUAL_STORAGE_BEHAVIOR_CODE_VirtualStorageBehaviorCacheWriteBack:
    _VIRTUAL_STORAGE_BEHAVIOR_CODE = 2;
pub const _VIRTUAL_STORAGE_BEHAVIOR_CODE_VirtualStorageBehaviorStopIoProcessing:
    _VIRTUAL_STORAGE_BEHAVIOR_CODE = 3;
pub const _VIRTUAL_STORAGE_BEHAVIOR_CODE_VirtualStorageBehaviorRestartIoProcessing:
    _VIRTUAL_STORAGE_BEHAVIOR_CODE = 4;
pub type _VIRTUAL_STORAGE_BEHAVIOR_CODE = ::std::os::raw::c_int;
pub use self::_VIRTUAL_STORAGE_BEHAVIOR_CODE as VIRTUAL_STORAGE_BEHAVIOR_CODE;
pub type PVIRTUAL_STORAGE_BEHAVIOR_CODE = *mut _VIRTUAL_STORAGE_BEHAVIOR_CODE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT {
    pub Size: DWORD,
    pub BehaviorCode: VIRTUAL_STORAGE_BEHAVIOR_CODE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT"]
        [::std::mem::size_of::<_VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT>() - 8usize];
    ["Alignment of _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT"]
        [::std::mem::align_of::<_VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT>() - 4usize];
    ["Offset of field: _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT::Size"]
        [::std::mem::offset_of!(_VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT, Size) - 0usize];
    ["Offset of field: _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT::BehaviorCode"]
        [::std::mem::offset_of!(_VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT, BehaviorCode) - 4usize];
};
pub type VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT = _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT;
pub type PVIRTUAL_STORAGE_SET_BEHAVIOR_INPUT = *mut _VIRTUAL_STORAGE_SET_BEHAVIOR_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENCRYPTION_KEY_CTRL_INPUT {
    pub HeaderSize: DWORD,
    pub StructureSize: DWORD,
    pub KeyOffset: WORD,
    pub KeySize: WORD,
    pub DplLock: DWORD,
    pub DplUserId: DWORDLONG,
    pub DplCredentialId: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENCRYPTION_KEY_CTRL_INPUT"]
        [::std::mem::size_of::<_ENCRYPTION_KEY_CTRL_INPUT>() - 32usize];
    ["Alignment of _ENCRYPTION_KEY_CTRL_INPUT"]
        [::std::mem::align_of::<_ENCRYPTION_KEY_CTRL_INPUT>() - 8usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::HeaderSize"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, HeaderSize) - 0usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::StructureSize"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, StructureSize) - 4usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::KeyOffset"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, KeyOffset) - 8usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::KeySize"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, KeySize) - 10usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::DplLock"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, DplLock) - 12usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::DplUserId"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, DplUserId) - 16usize];
    ["Offset of field: _ENCRYPTION_KEY_CTRL_INPUT::DplCredentialId"]
        [::std::mem::offset_of!(_ENCRYPTION_KEY_CTRL_INPUT, DplCredentialId) - 24usize];
};
pub type ENCRYPTION_KEY_CTRL_INPUT = _ENCRYPTION_KEY_CTRL_INPUT;
pub type PENCRYPTION_KEY_CTRL_INPUT = *mut _ENCRYPTION_KEY_CTRL_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOF_EXTERNAL_INFO {
    pub Version: DWORD,
    pub Provider: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOF_EXTERNAL_INFO"][::std::mem::size_of::<_WOF_EXTERNAL_INFO>() - 8usize];
    ["Alignment of _WOF_EXTERNAL_INFO"][::std::mem::align_of::<_WOF_EXTERNAL_INFO>() - 4usize];
    ["Offset of field: _WOF_EXTERNAL_INFO::Version"]
        [::std::mem::offset_of!(_WOF_EXTERNAL_INFO, Version) - 0usize];
    ["Offset of field: _WOF_EXTERNAL_INFO::Provider"]
        [::std::mem::offset_of!(_WOF_EXTERNAL_INFO, Provider) - 4usize];
};
pub type WOF_EXTERNAL_INFO = _WOF_EXTERNAL_INFO;
pub type PWOF_EXTERNAL_INFO = *mut _WOF_EXTERNAL_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOF_EXTERNAL_FILE_ID {
    pub FileId: FILE_ID_128,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOF_EXTERNAL_FILE_ID"][::std::mem::size_of::<_WOF_EXTERNAL_FILE_ID>() - 16usize];
    ["Alignment of _WOF_EXTERNAL_FILE_ID"]
        [::std::mem::align_of::<_WOF_EXTERNAL_FILE_ID>() - 1usize];
    ["Offset of field: _WOF_EXTERNAL_FILE_ID::FileId"]
        [::std::mem::offset_of!(_WOF_EXTERNAL_FILE_ID, FileId) - 0usize];
};
pub type WOF_EXTERNAL_FILE_ID = _WOF_EXTERNAL_FILE_ID;
pub type PWOF_EXTERNAL_FILE_ID = *mut _WOF_EXTERNAL_FILE_ID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WOF_VERSION_INFO {
    pub WofVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WOF_VERSION_INFO"][::std::mem::size_of::<_WOF_VERSION_INFO>() - 4usize];
    ["Alignment of _WOF_VERSION_INFO"][::std::mem::align_of::<_WOF_VERSION_INFO>() - 4usize];
    ["Offset of field: _WOF_VERSION_INFO::WofVersion"]
        [::std::mem::offset_of!(_WOF_VERSION_INFO, WofVersion) - 0usize];
};
pub type WOF_VERSION_INFO = _WOF_VERSION_INFO;
pub type PWOF_VERSION_INFO = *mut _WOF_VERSION_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIM_PROVIDER_EXTERNAL_INFO {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub DataSourceId: LARGE_INTEGER,
    pub ResourceHash: [BYTE; 20usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_EXTERNAL_INFO"]
        [::std::mem::size_of::<_WIM_PROVIDER_EXTERNAL_INFO>() - 40usize];
    ["Alignment of _WIM_PROVIDER_EXTERNAL_INFO"]
        [::std::mem::align_of::<_WIM_PROVIDER_EXTERNAL_INFO>() - 8usize];
    ["Offset of field: _WIM_PROVIDER_EXTERNAL_INFO::Version"]
        [::std::mem::offset_of!(_WIM_PROVIDER_EXTERNAL_INFO, Version) - 0usize];
    ["Offset of field: _WIM_PROVIDER_EXTERNAL_INFO::Flags"]
        [::std::mem::offset_of!(_WIM_PROVIDER_EXTERNAL_INFO, Flags) - 4usize];
    ["Offset of field: _WIM_PROVIDER_EXTERNAL_INFO::DataSourceId"]
        [::std::mem::offset_of!(_WIM_PROVIDER_EXTERNAL_INFO, DataSourceId) - 8usize];
    ["Offset of field: _WIM_PROVIDER_EXTERNAL_INFO::ResourceHash"]
        [::std::mem::offset_of!(_WIM_PROVIDER_EXTERNAL_INFO, ResourceHash) - 16usize];
};
pub type WIM_PROVIDER_EXTERNAL_INFO = _WIM_PROVIDER_EXTERNAL_INFO;
pub type PWIM_PROVIDER_EXTERNAL_INFO = *mut _WIM_PROVIDER_EXTERNAL_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _WIM_PROVIDER_ADD_OVERLAY_INPUT {
    pub WimType: DWORD,
    pub WimIndex: DWORD,
    pub WimFileNameOffset: DWORD,
    pub WimFileNameLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_ADD_OVERLAY_INPUT"]
        [::std::mem::size_of::<_WIM_PROVIDER_ADD_OVERLAY_INPUT>() - 16usize];
    ["Alignment of _WIM_PROVIDER_ADD_OVERLAY_INPUT"]
        [::std::mem::align_of::<_WIM_PROVIDER_ADD_OVERLAY_INPUT>() - 4usize];
    ["Offset of field: _WIM_PROVIDER_ADD_OVERLAY_INPUT::WimType"]
        [::std::mem::offset_of!(_WIM_PROVIDER_ADD_OVERLAY_INPUT, WimType) - 0usize];
    ["Offset of field: _WIM_PROVIDER_ADD_OVERLAY_INPUT::WimIndex"]
        [::std::mem::offset_of!(_WIM_PROVIDER_ADD_OVERLAY_INPUT, WimIndex) - 4usize];
    ["Offset of field: _WIM_PROVIDER_ADD_OVERLAY_INPUT::WimFileNameOffset"]
        [::std::mem::offset_of!(_WIM_PROVIDER_ADD_OVERLAY_INPUT, WimFileNameOffset) - 8usize];
    ["Offset of field: _WIM_PROVIDER_ADD_OVERLAY_INPUT::WimFileNameLength"]
        [::std::mem::offset_of!(_WIM_PROVIDER_ADD_OVERLAY_INPUT, WimFileNameLength) - 12usize];
};
pub type WIM_PROVIDER_ADD_OVERLAY_INPUT = _WIM_PROVIDER_ADD_OVERLAY_INPUT;
pub type PWIM_PROVIDER_ADD_OVERLAY_INPUT = *mut _WIM_PROVIDER_ADD_OVERLAY_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIM_PROVIDER_UPDATE_OVERLAY_INPUT {
    pub DataSourceId: LARGE_INTEGER,
    pub WimFileNameOffset: DWORD,
    pub WimFileNameLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_UPDATE_OVERLAY_INPUT"]
        [::std::mem::size_of::<_WIM_PROVIDER_UPDATE_OVERLAY_INPUT>() - 16usize];
    ["Alignment of _WIM_PROVIDER_UPDATE_OVERLAY_INPUT"]
        [::std::mem::align_of::<_WIM_PROVIDER_UPDATE_OVERLAY_INPUT>() - 8usize];
    ["Offset of field: _WIM_PROVIDER_UPDATE_OVERLAY_INPUT::DataSourceId"]
        [::std::mem::offset_of!(_WIM_PROVIDER_UPDATE_OVERLAY_INPUT, DataSourceId) - 0usize];
    ["Offset of field: _WIM_PROVIDER_UPDATE_OVERLAY_INPUT::WimFileNameOffset"]
        [::std::mem::offset_of!(_WIM_PROVIDER_UPDATE_OVERLAY_INPUT, WimFileNameOffset) - 8usize];
    ["Offset of field: _WIM_PROVIDER_UPDATE_OVERLAY_INPUT::WimFileNameLength"]
        [::std::mem::offset_of!(_WIM_PROVIDER_UPDATE_OVERLAY_INPUT, WimFileNameLength) - 12usize];
};
pub type WIM_PROVIDER_UPDATE_OVERLAY_INPUT = _WIM_PROVIDER_UPDATE_OVERLAY_INPUT;
pub type PWIM_PROVIDER_UPDATE_OVERLAY_INPUT = *mut _WIM_PROVIDER_UPDATE_OVERLAY_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIM_PROVIDER_REMOVE_OVERLAY_INPUT {
    pub DataSourceId: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_REMOVE_OVERLAY_INPUT"]
        [::std::mem::size_of::<_WIM_PROVIDER_REMOVE_OVERLAY_INPUT>() - 8usize];
    ["Alignment of _WIM_PROVIDER_REMOVE_OVERLAY_INPUT"]
        [::std::mem::align_of::<_WIM_PROVIDER_REMOVE_OVERLAY_INPUT>() - 8usize];
    ["Offset of field: _WIM_PROVIDER_REMOVE_OVERLAY_INPUT::DataSourceId"]
        [::std::mem::offset_of!(_WIM_PROVIDER_REMOVE_OVERLAY_INPUT, DataSourceId) - 0usize];
};
pub type WIM_PROVIDER_REMOVE_OVERLAY_INPUT = _WIM_PROVIDER_REMOVE_OVERLAY_INPUT;
pub type PWIM_PROVIDER_REMOVE_OVERLAY_INPUT = *mut _WIM_PROVIDER_REMOVE_OVERLAY_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT {
    pub DataSourceId: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT"]
        [::std::mem::size_of::<_WIM_PROVIDER_SUSPEND_OVERLAY_INPUT>() - 8usize];
    ["Alignment of _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT"]
        [::std::mem::align_of::<_WIM_PROVIDER_SUSPEND_OVERLAY_INPUT>() - 8usize];
    ["Offset of field: _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT::DataSourceId"]
        [::std::mem::offset_of!(_WIM_PROVIDER_SUSPEND_OVERLAY_INPUT, DataSourceId) - 0usize];
};
pub type WIM_PROVIDER_SUSPEND_OVERLAY_INPUT = _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT;
pub type PWIM_PROVIDER_SUSPEND_OVERLAY_INPUT = *mut _WIM_PROVIDER_SUSPEND_OVERLAY_INPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _WIM_PROVIDER_OVERLAY_ENTRY {
    pub NextEntryOffset: DWORD,
    pub DataSourceId: LARGE_INTEGER,
    pub WimGuid: GUID,
    pub WimFileNameOffset: DWORD,
    pub WimType: DWORD,
    pub WimIndex: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _WIM_PROVIDER_OVERLAY_ENTRY"]
        [::std::mem::size_of::<_WIM_PROVIDER_OVERLAY_ENTRY>() - 48usize];
    ["Alignment of _WIM_PROVIDER_OVERLAY_ENTRY"]
        [::std::mem::align_of::<_WIM_PROVIDER_OVERLAY_ENTRY>() - 8usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::NextEntryOffset"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, NextEntryOffset) - 0usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::DataSourceId"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, DataSourceId) - 8usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::WimGuid"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, WimGuid) - 16usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::WimFileNameOffset"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, WimFileNameOffset) - 32usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::WimType"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, WimType) - 36usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::WimIndex"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, WimIndex) - 40usize];
    ["Offset of field: _WIM_PROVIDER_OVERLAY_ENTRY::Flags"]
        [::std::mem::offset_of!(_WIM_PROVIDER_OVERLAY_ENTRY, Flags) - 44usize];
};
pub type WIM_PROVIDER_OVERLAY_ENTRY = _WIM_PROVIDER_OVERLAY_ENTRY;
pub type PWIM_PROVIDER_OVERLAY_ENTRY = *mut _WIM_PROVIDER_OVERLAY_ENTRY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_PROVIDER_EXTERNAL_INFO_V0 {
    pub Version: DWORD,
    pub Algorithm: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_PROVIDER_EXTERNAL_INFO_V0"]
        [::std::mem::size_of::<_FILE_PROVIDER_EXTERNAL_INFO_V0>() - 8usize];
    ["Alignment of _FILE_PROVIDER_EXTERNAL_INFO_V0"]
        [::std::mem::align_of::<_FILE_PROVIDER_EXTERNAL_INFO_V0>() - 4usize];
    ["Offset of field: _FILE_PROVIDER_EXTERNAL_INFO_V0::Version"]
        [::std::mem::offset_of!(_FILE_PROVIDER_EXTERNAL_INFO_V0, Version) - 0usize];
    ["Offset of field: _FILE_PROVIDER_EXTERNAL_INFO_V0::Algorithm"]
        [::std::mem::offset_of!(_FILE_PROVIDER_EXTERNAL_INFO_V0, Algorithm) - 4usize];
};
pub type FILE_PROVIDER_EXTERNAL_INFO_V0 = _FILE_PROVIDER_EXTERNAL_INFO_V0;
pub type PFILE_PROVIDER_EXTERNAL_INFO_V0 = *mut _FILE_PROVIDER_EXTERNAL_INFO_V0;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FILE_PROVIDER_EXTERNAL_INFO_V1 {
    pub Version: DWORD,
    pub Algorithm: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FILE_PROVIDER_EXTERNAL_INFO_V1"]
        [::std::mem::size_of::<_FILE_PROVIDER_EXTERNAL_INFO_V1>() - 12usize];
    ["Alignment of _FILE_PROVIDER_EXTERNAL_INFO_V1"]
        [::std::mem::align_of::<_FILE_PROVIDER_EXTERNAL_INFO_V1>() - 4usize];
    ["Offset of field: _FILE_PROVIDER_EXTERNAL_INFO_V1::Version"]
        [::std::mem::offset_of!(_FILE_PROVIDER_EXTERNAL_INFO_V1, Version) - 0usize];
    ["Offset of field: _FILE_PROVIDER_EXTERNAL_INFO_V1::Algorithm"]
        [::std::mem::offset_of!(_FILE_PROVIDER_EXTERNAL_INFO_V1, Algorithm) - 4usize];
    ["Offset of field: _FILE_PROVIDER_EXTERNAL_INFO_V1::Flags"]
        [::std::mem::offset_of!(_FILE_PROVIDER_EXTERNAL_INFO_V1, Flags) - 8usize];
};
pub type FILE_PROVIDER_EXTERNAL_INFO_V1 = _FILE_PROVIDER_EXTERNAL_INFO_V1;
pub type PFILE_PROVIDER_EXTERNAL_INFO_V1 = *mut _FILE_PROVIDER_EXTERNAL_INFO_V1;
pub type FILE_PROVIDER_EXTERNAL_INFO = FILE_PROVIDER_EXTERNAL_INFO_V1;
pub type PFILE_PROVIDER_EXTERNAL_INFO = PFILE_PROVIDER_EXTERNAL_INFO_V1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONTAINER_VOLUME_STATE {
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTAINER_VOLUME_STATE"][::std::mem::size_of::<_CONTAINER_VOLUME_STATE>() - 4usize];
    ["Alignment of _CONTAINER_VOLUME_STATE"]
        [::std::mem::align_of::<_CONTAINER_VOLUME_STATE>() - 4usize];
    ["Offset of field: _CONTAINER_VOLUME_STATE::Flags"]
        [::std::mem::offset_of!(_CONTAINER_VOLUME_STATE, Flags) - 0usize];
};
pub type CONTAINER_VOLUME_STATE = _CONTAINER_VOLUME_STATE;
pub type PCONTAINER_VOLUME_STATE = *mut _CONTAINER_VOLUME_STATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONTAINER_ROOT_INFO_INPUT {
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTAINER_ROOT_INFO_INPUT"]
        [::std::mem::size_of::<_CONTAINER_ROOT_INFO_INPUT>() - 4usize];
    ["Alignment of _CONTAINER_ROOT_INFO_INPUT"]
        [::std::mem::align_of::<_CONTAINER_ROOT_INFO_INPUT>() - 4usize];
    ["Offset of field: _CONTAINER_ROOT_INFO_INPUT::Flags"]
        [::std::mem::offset_of!(_CONTAINER_ROOT_INFO_INPUT, Flags) - 0usize];
};
pub type CONTAINER_ROOT_INFO_INPUT = _CONTAINER_ROOT_INFO_INPUT;
pub type PCONTAINER_ROOT_INFO_INPUT = *mut _CONTAINER_ROOT_INFO_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CONTAINER_ROOT_INFO_OUTPUT {
    pub ContainerRootIdLength: WORD,
    pub ContainerRootId: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CONTAINER_ROOT_INFO_OUTPUT"]
        [::std::mem::size_of::<_CONTAINER_ROOT_INFO_OUTPUT>() - 4usize];
    ["Alignment of _CONTAINER_ROOT_INFO_OUTPUT"]
        [::std::mem::align_of::<_CONTAINER_ROOT_INFO_OUTPUT>() - 2usize];
    ["Offset of field: _CONTAINER_ROOT_INFO_OUTPUT::ContainerRootIdLength"]
        [::std::mem::offset_of!(_CONTAINER_ROOT_INFO_OUTPUT, ContainerRootIdLength) - 0usize];
    ["Offset of field: _CONTAINER_ROOT_INFO_OUTPUT::ContainerRootId"]
        [::std::mem::offset_of!(_CONTAINER_ROOT_INFO_OUTPUT, ContainerRootId) - 2usize];
};
pub type CONTAINER_ROOT_INFO_OUTPUT = _CONTAINER_ROOT_INFO_OUTPUT;
pub type PCONTAINER_ROOT_INFO_OUTPUT = *mut _CONTAINER_ROOT_INFO_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIRTUALIZATION_INSTANCE_INFO_INPUT {
    pub NumberOfWorkerThreads: DWORD,
    pub Flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIRTUALIZATION_INSTANCE_INFO_INPUT"]
        [::std::mem::size_of::<_VIRTUALIZATION_INSTANCE_INFO_INPUT>() - 8usize];
    ["Alignment of _VIRTUALIZATION_INSTANCE_INFO_INPUT"]
        [::std::mem::align_of::<_VIRTUALIZATION_INSTANCE_INFO_INPUT>() - 4usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT::NumberOfWorkerThreads"][::std::mem::offset_of!(
        _VIRTUALIZATION_INSTANCE_INFO_INPUT,
        NumberOfWorkerThreads
    ) - 0usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT::Flags"]
        [::std::mem::offset_of!(_VIRTUALIZATION_INSTANCE_INFO_INPUT, Flags) - 4usize];
};
pub type VIRTUALIZATION_INSTANCE_INFO_INPUT = _VIRTUALIZATION_INSTANCE_INFO_INPUT;
pub type PVIRTUALIZATION_INSTANCE_INFO_INPUT = *mut _VIRTUALIZATION_INSTANCE_INFO_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX {
    pub HeaderSize: WORD,
    pub Flags: DWORD,
    pub NotificationInfoSize: DWORD,
    pub NotificationInfoOffset: WORD,
    pub ProviderMajorVersion: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX"]
        [::std::mem::size_of::<_VIRTUALIZATION_INSTANCE_INFO_INPUT_EX>() - 16usize];
    ["Alignment of _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX"]
        [::std::mem::align_of::<_VIRTUALIZATION_INSTANCE_INFO_INPUT_EX>() - 4usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX::HeaderSize"]
        [::std::mem::offset_of!(_VIRTUALIZATION_INSTANCE_INFO_INPUT_EX, HeaderSize) - 0usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX::Flags"]
        [::std::mem::offset_of!(_VIRTUALIZATION_INSTANCE_INFO_INPUT_EX, Flags) - 4usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX::NotificationInfoSize"][::std::mem::offset_of!(
        _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX,
        NotificationInfoSize
    ) - 8usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX::NotificationInfoOffset"][::std::mem::offset_of!(
        _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX,
        NotificationInfoOffset
    )
        - 12usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX::ProviderMajorVersion"][::std::mem::offset_of!(
        _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX,
        ProviderMajorVersion
    ) - 14usize];
};
pub type VIRTUALIZATION_INSTANCE_INFO_INPUT_EX = _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX;
pub type PVIRTUALIZATION_INSTANCE_INFO_INPUT_EX = *mut _VIRTUALIZATION_INSTANCE_INFO_INPUT_EX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VIRTUALIZATION_INSTANCE_INFO_OUTPUT {
    pub VirtualizationInstanceID: GUID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VIRTUALIZATION_INSTANCE_INFO_OUTPUT"]
        [::std::mem::size_of::<_VIRTUALIZATION_INSTANCE_INFO_OUTPUT>() - 16usize];
    ["Alignment of _VIRTUALIZATION_INSTANCE_INFO_OUTPUT"]
        [::std::mem::align_of::<_VIRTUALIZATION_INSTANCE_INFO_OUTPUT>() - 4usize];
    ["Offset of field: _VIRTUALIZATION_INSTANCE_INFO_OUTPUT::VirtualizationInstanceID"][::std::mem::offset_of!(
        _VIRTUALIZATION_INSTANCE_INFO_OUTPUT,
        VirtualizationInstanceID
    ) - 0usize];
};
pub type VIRTUALIZATION_INSTANCE_INFO_OUTPUT = _VIRTUALIZATION_INSTANCE_INFO_OUTPUT;
pub type PVIRTUALIZATION_INSTANCE_INFO_OUTPUT = *mut _VIRTUALIZATION_INSTANCE_INFO_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GET_FILTER_FILE_IDENTIFIER_INPUT {
    pub AltitudeLength: WORD,
    pub Altitude: [WCHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_FILTER_FILE_IDENTIFIER_INPUT"]
        [::std::mem::size_of::<_GET_FILTER_FILE_IDENTIFIER_INPUT>() - 4usize];
    ["Alignment of _GET_FILTER_FILE_IDENTIFIER_INPUT"]
        [::std::mem::align_of::<_GET_FILTER_FILE_IDENTIFIER_INPUT>() - 2usize];
    ["Offset of field: _GET_FILTER_FILE_IDENTIFIER_INPUT::AltitudeLength"]
        [::std::mem::offset_of!(_GET_FILTER_FILE_IDENTIFIER_INPUT, AltitudeLength) - 0usize];
    ["Offset of field: _GET_FILTER_FILE_IDENTIFIER_INPUT::Altitude"]
        [::std::mem::offset_of!(_GET_FILTER_FILE_IDENTIFIER_INPUT, Altitude) - 2usize];
};
pub type GET_FILTER_FILE_IDENTIFIER_INPUT = _GET_FILTER_FILE_IDENTIFIER_INPUT;
pub type PGET_FILTER_FILE_IDENTIFIER_INPUT = *mut _GET_FILTER_FILE_IDENTIFIER_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _GET_FILTER_FILE_IDENTIFIER_OUTPUT {
    pub FilterFileIdentifierLength: WORD,
    pub FilterFileIdentifier: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GET_FILTER_FILE_IDENTIFIER_OUTPUT"]
        [::std::mem::size_of::<_GET_FILTER_FILE_IDENTIFIER_OUTPUT>() - 4usize];
    ["Alignment of _GET_FILTER_FILE_IDENTIFIER_OUTPUT"]
        [::std::mem::align_of::<_GET_FILTER_FILE_IDENTIFIER_OUTPUT>() - 2usize];
    ["Offset of field: _GET_FILTER_FILE_IDENTIFIER_OUTPUT::FilterFileIdentifierLength"][::std::mem::offset_of!(
        _GET_FILTER_FILE_IDENTIFIER_OUTPUT,
        FilterFileIdentifierLength
    ) - 0usize];
    ["Offset of field: _GET_FILTER_FILE_IDENTIFIER_OUTPUT::FilterFileIdentifier"]
        [::std::mem::offset_of!(_GET_FILTER_FILE_IDENTIFIER_OUTPUT, FilterFileIdentifier) - 2usize];
};
pub type GET_FILTER_FILE_IDENTIFIER_OUTPUT = _GET_FILTER_FILE_IDENTIFIER_OUTPUT;
pub type PGET_FILTER_FILE_IDENTIFIER_OUTPUT = *mut _GET_FILTER_FILE_IDENTIFIER_OUTPUT;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_ENABLE: _FS_BPIO_OPERATIONS = 1;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_DISABLE: _FS_BPIO_OPERATIONS = 2;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_QUERY: _FS_BPIO_OPERATIONS = 3;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_VOLUME_STACK_PAUSE: _FS_BPIO_OPERATIONS = 4;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_VOLUME_STACK_RESUME: _FS_BPIO_OPERATIONS = 5;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_STREAM_PAUSE: _FS_BPIO_OPERATIONS = 6;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_STREAM_RESUME: _FS_BPIO_OPERATIONS = 7;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_GET_INFO: _FS_BPIO_OPERATIONS = 8;
pub const _FS_BPIO_OPERATIONS_FS_BPIO_OP_MAX_OPERATION: _FS_BPIO_OPERATIONS = 9;
pub type _FS_BPIO_OPERATIONS = ::std::os::raw::c_int;
pub use self::_FS_BPIO_OPERATIONS as FS_BPIO_OPERATIONS;
pub const _FS_BPIO_INFLAGS_FSBPIO_INFL_None: _FS_BPIO_INFLAGS = 0;
pub const _FS_BPIO_INFLAGS_FSBPIO_INFL_SKIP_STORAGE_STACK_QUERY: _FS_BPIO_INFLAGS = 1;
pub type _FS_BPIO_INFLAGS = ::std::os::raw::c_int;
pub use self::_FS_BPIO_INFLAGS as FS_BPIO_INFLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FS_BPIO_INPUT {
    pub Operation: FS_BPIO_OPERATIONS,
    pub InFlags: FS_BPIO_INFLAGS,
    pub Reserved1: DWORDLONG,
    pub Reserved2: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FS_BPIO_INPUT"][::std::mem::size_of::<_FS_BPIO_INPUT>() - 24usize];
    ["Alignment of _FS_BPIO_INPUT"][::std::mem::align_of::<_FS_BPIO_INPUT>() - 8usize];
    ["Offset of field: _FS_BPIO_INPUT::Operation"]
        [::std::mem::offset_of!(_FS_BPIO_INPUT, Operation) - 0usize];
    ["Offset of field: _FS_BPIO_INPUT::InFlags"]
        [::std::mem::offset_of!(_FS_BPIO_INPUT, InFlags) - 4usize];
    ["Offset of field: _FS_BPIO_INPUT::Reserved1"]
        [::std::mem::offset_of!(_FS_BPIO_INPUT, Reserved1) - 8usize];
    ["Offset of field: _FS_BPIO_INPUT::Reserved2"]
        [::std::mem::offset_of!(_FS_BPIO_INPUT, Reserved2) - 16usize];
};
pub type FS_BPIO_INPUT = _FS_BPIO_INPUT;
pub type PFS_BPIO_INPUT = *mut _FS_BPIO_INPUT;
pub const _FS_BPIO_OUTFLAGS_FSBPIO_OUTFL_None: _FS_BPIO_OUTFLAGS = 0;
pub const _FS_BPIO_OUTFLAGS_FSBPIO_OUTFL_VOLUME_STACK_BYPASS_PAUSED: _FS_BPIO_OUTFLAGS = 1;
pub const _FS_BPIO_OUTFLAGS_FSBPIO_OUTFL_STREAM_BYPASS_PAUSED: _FS_BPIO_OUTFLAGS = 2;
pub const _FS_BPIO_OUTFLAGS_FSBPIO_OUTFL_FILTER_ATTACH_BLOCKED: _FS_BPIO_OUTFLAGS = 4;
pub const _FS_BPIO_OUTFLAGS_FSBPIO_OUTFL_COMPATIBLE_STORAGE_DRIVER: _FS_BPIO_OUTFLAGS = 8;
pub type _FS_BPIO_OUTFLAGS = ::std::os::raw::c_int;
pub use self::_FS_BPIO_OUTFLAGS as FS_BPIO_OUTFLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FS_BPIO_RESULTS {
    pub OpStatus: DWORD,
    pub FailingDriverNameLen: WORD,
    pub FailingDriverName: [WCHAR; 32usize],
    pub FailureReasonLen: WORD,
    pub FailureReason: [WCHAR; 128usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FS_BPIO_RESULTS"][::std::mem::size_of::<_FS_BPIO_RESULTS>() - 328usize];
    ["Alignment of _FS_BPIO_RESULTS"][::std::mem::align_of::<_FS_BPIO_RESULTS>() - 4usize];
    ["Offset of field: _FS_BPIO_RESULTS::OpStatus"]
        [::std::mem::offset_of!(_FS_BPIO_RESULTS, OpStatus) - 0usize];
    ["Offset of field: _FS_BPIO_RESULTS::FailingDriverNameLen"]
        [::std::mem::offset_of!(_FS_BPIO_RESULTS, FailingDriverNameLen) - 4usize];
    ["Offset of field: _FS_BPIO_RESULTS::FailingDriverName"]
        [::std::mem::offset_of!(_FS_BPIO_RESULTS, FailingDriverName) - 6usize];
    ["Offset of field: _FS_BPIO_RESULTS::FailureReasonLen"]
        [::std::mem::offset_of!(_FS_BPIO_RESULTS, FailureReasonLen) - 70usize];
    ["Offset of field: _FS_BPIO_RESULTS::FailureReason"]
        [::std::mem::offset_of!(_FS_BPIO_RESULTS, FailureReason) - 72usize];
};
pub type FS_BPIO_RESULTS = _FS_BPIO_RESULTS;
pub type PFS_BPIO_RESULTS = *mut _FS_BPIO_RESULTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FS_BPIO_INFO {
    pub ActiveBypassIoCount: DWORD,
    pub StorageDriverNameLen: WORD,
    pub StorageDriverName: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FS_BPIO_INFO"][::std::mem::size_of::<_FS_BPIO_INFO>() - 72usize];
    ["Alignment of _FS_BPIO_INFO"][::std::mem::align_of::<_FS_BPIO_INFO>() - 4usize];
    ["Offset of field: _FS_BPIO_INFO::ActiveBypassIoCount"]
        [::std::mem::offset_of!(_FS_BPIO_INFO, ActiveBypassIoCount) - 0usize];
    ["Offset of field: _FS_BPIO_INFO::StorageDriverNameLen"]
        [::std::mem::offset_of!(_FS_BPIO_INFO, StorageDriverNameLen) - 4usize];
    ["Offset of field: _FS_BPIO_INFO::StorageDriverName"]
        [::std::mem::offset_of!(_FS_BPIO_INFO, StorageDriverName) - 6usize];
};
pub type FS_BPIO_INFO = _FS_BPIO_INFO;
pub type PFS_BPIO_INFO = *mut _FS_BPIO_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FS_BPIO_OUTPUT {
    pub Operation: FS_BPIO_OPERATIONS,
    pub OutFlags: FS_BPIO_OUTFLAGS,
    pub Reserved1: DWORDLONG,
    pub Reserved2: DWORDLONG,
    pub __bindgen_anon_1: _FS_BPIO_OUTPUT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _FS_BPIO_OUTPUT__bindgen_ty_1 {
    pub Enable: FS_BPIO_RESULTS,
    pub Query: FS_BPIO_RESULTS,
    pub VolumeStackResume: FS_BPIO_RESULTS,
    pub StreamResume: FS_BPIO_RESULTS,
    pub GetInfo: FS_BPIO_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FS_BPIO_OUTPUT__bindgen_ty_1"]
        [::std::mem::size_of::<_FS_BPIO_OUTPUT__bindgen_ty_1>() - 328usize];
    ["Alignment of _FS_BPIO_OUTPUT__bindgen_ty_1"]
        [::std::mem::align_of::<_FS_BPIO_OUTPUT__bindgen_ty_1>() - 4usize];
    ["Offset of field: _FS_BPIO_OUTPUT__bindgen_ty_1::Enable"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT__bindgen_ty_1, Enable) - 0usize];
    ["Offset of field: _FS_BPIO_OUTPUT__bindgen_ty_1::Query"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT__bindgen_ty_1, Query) - 0usize];
    ["Offset of field: _FS_BPIO_OUTPUT__bindgen_ty_1::VolumeStackResume"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT__bindgen_ty_1, VolumeStackResume) - 0usize];
    ["Offset of field: _FS_BPIO_OUTPUT__bindgen_ty_1::StreamResume"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT__bindgen_ty_1, StreamResume) - 0usize];
    ["Offset of field: _FS_BPIO_OUTPUT__bindgen_ty_1::GetInfo"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT__bindgen_ty_1, GetInfo) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FS_BPIO_OUTPUT"][::std::mem::size_of::<_FS_BPIO_OUTPUT>() - 352usize];
    ["Alignment of _FS_BPIO_OUTPUT"][::std::mem::align_of::<_FS_BPIO_OUTPUT>() - 8usize];
    ["Offset of field: _FS_BPIO_OUTPUT::Operation"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT, Operation) - 0usize];
    ["Offset of field: _FS_BPIO_OUTPUT::OutFlags"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT, OutFlags) - 4usize];
    ["Offset of field: _FS_BPIO_OUTPUT::Reserved1"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT, Reserved1) - 8usize];
    ["Offset of field: _FS_BPIO_OUTPUT::Reserved2"]
        [::std::mem::offset_of!(_FS_BPIO_OUTPUT, Reserved2) - 16usize];
};
pub type FS_BPIO_OUTPUT = _FS_BPIO_OUTPUT;
pub type PFS_BPIO_OUTPUT = *mut _FS_BPIO_OUTPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SMB_SHARE_FLUSH_AND_PURGE_INPUT {
    pub Version: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SMB_SHARE_FLUSH_AND_PURGE_INPUT"]
        [::std::mem::size_of::<_SMB_SHARE_FLUSH_AND_PURGE_INPUT>() - 2usize];
    ["Alignment of _SMB_SHARE_FLUSH_AND_PURGE_INPUT"]
        [::std::mem::align_of::<_SMB_SHARE_FLUSH_AND_PURGE_INPUT>() - 2usize];
    ["Offset of field: _SMB_SHARE_FLUSH_AND_PURGE_INPUT::Version"]
        [::std::mem::offset_of!(_SMB_SHARE_FLUSH_AND_PURGE_INPUT, Version) - 0usize];
};
pub type SMB_SHARE_FLUSH_AND_PURGE_INPUT = _SMB_SHARE_FLUSH_AND_PURGE_INPUT;
pub type PSMB_SHARE_FLUSH_AND_PURGE_INPUT = *mut _SMB_SHARE_FLUSH_AND_PURGE_INPUT;
pub type PCSMB_SHARE_FLUSH_AND_PURGE_INPUT = *const _SMB_SHARE_FLUSH_AND_PURGE_INPUT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT {
    pub cEntriesPurged: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT"]
        [::std::mem::size_of::<_SMB_SHARE_FLUSH_AND_PURGE_OUTPUT>() - 4usize];
    ["Alignment of _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT"]
        [::std::mem::align_of::<_SMB_SHARE_FLUSH_AND_PURGE_OUTPUT>() - 4usize];
    ["Offset of field: _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT::cEntriesPurged"]
        [::std::mem::offset_of!(_SMB_SHARE_FLUSH_AND_PURGE_OUTPUT, cEntriesPurged) - 0usize];
};
pub type SMB_SHARE_FLUSH_AND_PURGE_OUTPUT = _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT;
pub type PSMB_SHARE_FLUSH_AND_PURGE_OUTPUT = *mut _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT;
pub type PCSMB_SHARE_FLUSH_AND_PURGE_OUTPUT = *const _SMB_SHARE_FLUSH_AND_PURGE_OUTPUT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _DISK_EXTENT {
    pub DiskNumber: DWORD,
    pub StartingOffset: LARGE_INTEGER,
    pub ExtentLength: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DISK_EXTENT"][::std::mem::size_of::<_DISK_EXTENT>() - 24usize];
    ["Alignment of _DISK_EXTENT"][::std::mem::align_of::<_DISK_EXTENT>() - 8usize];
    ["Offset of field: _DISK_EXTENT::DiskNumber"]
        [::std::mem::offset_of!(_DISK_EXTENT, DiskNumber) - 0usize];
    ["Offset of field: _DISK_EXTENT::StartingOffset"]
        [::std::mem::offset_of!(_DISK_EXTENT, StartingOffset) - 8usize];
    ["Offset of field: _DISK_EXTENT::ExtentLength"]
        [::std::mem::offset_of!(_DISK_EXTENT, ExtentLength) - 16usize];
};
pub type DISK_EXTENT = _DISK_EXTENT;
pub type PDISK_EXTENT = *mut _DISK_EXTENT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _VOLUME_DISK_EXTENTS {
    pub NumberOfDiskExtents: DWORD,
    pub Extents: [DISK_EXTENT; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VOLUME_DISK_EXTENTS"][::std::mem::size_of::<_VOLUME_DISK_EXTENTS>() - 32usize];
    ["Alignment of _VOLUME_DISK_EXTENTS"][::std::mem::align_of::<_VOLUME_DISK_EXTENTS>() - 8usize];
    ["Offset of field: _VOLUME_DISK_EXTENTS::NumberOfDiskExtents"]
        [::std::mem::offset_of!(_VOLUME_DISK_EXTENTS, NumberOfDiskExtents) - 0usize];
    ["Offset of field: _VOLUME_DISK_EXTENTS::Extents"]
        [::std::mem::offset_of!(_VOLUME_DISK_EXTENTS, Extents) - 8usize];
};
pub type VOLUME_DISK_EXTENTS = _VOLUME_DISK_EXTENTS;
pub type PVOLUME_DISK_EXTENTS = *mut _VOLUME_DISK_EXTENTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION {
    pub GptAttributes: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION"]
        [::std::mem::size_of::<_VOLUME_GET_GPT_ATTRIBUTES_INFORMATION>() - 8usize];
    ["Alignment of _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION"]
        [::std::mem::align_of::<_VOLUME_GET_GPT_ATTRIBUTES_INFORMATION>() - 8usize];
    ["Offset of field: _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION::GptAttributes"]
        [::std::mem::offset_of!(_VOLUME_GET_GPT_ATTRIBUTES_INFORMATION, GptAttributes) - 0usize];
};
pub type VOLUME_GET_GPT_ATTRIBUTES_INFORMATION = _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION;
pub type PVOLUME_GET_GPT_ATTRIBUTES_INFORMATION = *mut _VOLUME_GET_GPT_ATTRIBUTES_INFORMATION;
pub type PIO_IRP_EXT_PROCESS_TRACKED_OFFSET_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(
        SourceContext: *mut _IO_IRP_EXT_TRACK_OFFSET_HEADER,
        TargetContext: *mut _IO_IRP_EXT_TRACK_OFFSET_HEADER,
        RelativeOffset: LONGLONG,
    ),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _IO_IRP_EXT_TRACK_OFFSET_HEADER {
    pub Validation: WORD,
    pub Flags: WORD,
    pub TrackedOffsetCallback: PIO_IRP_EXT_PROCESS_TRACKED_OFFSET_CALLBACK,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _IO_IRP_EXT_TRACK_OFFSET_HEADER"]
        [::std::mem::size_of::<_IO_IRP_EXT_TRACK_OFFSET_HEADER>() - 16usize];
    ["Alignment of _IO_IRP_EXT_TRACK_OFFSET_HEADER"]
        [::std::mem::align_of::<_IO_IRP_EXT_TRACK_OFFSET_HEADER>() - 8usize];
    ["Offset of field: _IO_IRP_EXT_TRACK_OFFSET_HEADER::Validation"]
        [::std::mem::offset_of!(_IO_IRP_EXT_TRACK_OFFSET_HEADER, Validation) - 0usize];
    ["Offset of field: _IO_IRP_EXT_TRACK_OFFSET_HEADER::Flags"]
        [::std::mem::offset_of!(_IO_IRP_EXT_TRACK_OFFSET_HEADER, Flags) - 2usize];
    ["Offset of field: _IO_IRP_EXT_TRACK_OFFSET_HEADER::TrackedOffsetCallback"]
        [::std::mem::offset_of!(_IO_IRP_EXT_TRACK_OFFSET_HEADER, TrackedOffsetCallback) - 8usize];
};
pub type IO_IRP_EXT_TRACK_OFFSET_HEADER = _IO_IRP_EXT_TRACK_OFFSET_HEADER;
pub type PIO_IRP_EXT_TRACK_OFFSET_HEADER = *mut _IO_IRP_EXT_TRACK_OFFSET_HEADER;
pub type UWORD = WORD;
unsafe extern "C" {
    pub static GUID_DEVINTERFACE_SMARTCARD_READER: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCARD_IO_REQUEST {
    pub dwProtocol: DWORD,
    pub cbPciLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_IO_REQUEST"][::std::mem::size_of::<_SCARD_IO_REQUEST>() - 8usize];
    ["Alignment of _SCARD_IO_REQUEST"][::std::mem::align_of::<_SCARD_IO_REQUEST>() - 4usize];
    ["Offset of field: _SCARD_IO_REQUEST::dwProtocol"]
        [::std::mem::offset_of!(_SCARD_IO_REQUEST, dwProtocol) - 0usize];
    ["Offset of field: _SCARD_IO_REQUEST::cbPciLength"]
        [::std::mem::offset_of!(_SCARD_IO_REQUEST, cbPciLength) - 4usize];
};
pub type SCARD_IO_REQUEST = _SCARD_IO_REQUEST;
pub type PSCARD_IO_REQUEST = *mut _SCARD_IO_REQUEST;
pub type LPSCARD_IO_REQUEST = *mut _SCARD_IO_REQUEST;
pub type LPCSCARD_IO_REQUEST = *const SCARD_IO_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCARD_T0_COMMAND {
    pub bCla: BYTE,
    pub bIns: BYTE,
    pub bP1: BYTE,
    pub bP2: BYTE,
    pub bP3: BYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_T0_COMMAND"][::std::mem::size_of::<_SCARD_T0_COMMAND>() - 5usize];
    ["Alignment of _SCARD_T0_COMMAND"][::std::mem::align_of::<_SCARD_T0_COMMAND>() - 1usize];
    ["Offset of field: _SCARD_T0_COMMAND::bCla"]
        [::std::mem::offset_of!(_SCARD_T0_COMMAND, bCla) - 0usize];
    ["Offset of field: _SCARD_T0_COMMAND::bIns"]
        [::std::mem::offset_of!(_SCARD_T0_COMMAND, bIns) - 1usize];
    ["Offset of field: _SCARD_T0_COMMAND::bP1"]
        [::std::mem::offset_of!(_SCARD_T0_COMMAND, bP1) - 2usize];
    ["Offset of field: _SCARD_T0_COMMAND::bP2"]
        [::std::mem::offset_of!(_SCARD_T0_COMMAND, bP2) - 3usize];
    ["Offset of field: _SCARD_T0_COMMAND::bP3"]
        [::std::mem::offset_of!(_SCARD_T0_COMMAND, bP3) - 4usize];
};
pub type SCARD_T0_COMMAND = _SCARD_T0_COMMAND;
pub type LPSCARD_T0_COMMAND = *mut _SCARD_T0_COMMAND;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SCARD_T0_REQUEST {
    pub ioRequest: SCARD_IO_REQUEST,
    pub bSw1: BYTE,
    pub bSw2: BYTE,
    pub __bindgen_anon_1: _SCARD_T0_REQUEST__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SCARD_T0_REQUEST__bindgen_ty_1 {
    pub CmdBytes: SCARD_T0_COMMAND,
    pub rgbHeader: [BYTE; 5usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_T0_REQUEST__bindgen_ty_1"]
        [::std::mem::size_of::<_SCARD_T0_REQUEST__bindgen_ty_1>() - 5usize];
    ["Alignment of _SCARD_T0_REQUEST__bindgen_ty_1"]
        [::std::mem::align_of::<_SCARD_T0_REQUEST__bindgen_ty_1>() - 1usize];
    ["Offset of field: _SCARD_T0_REQUEST__bindgen_ty_1::CmdBytes"]
        [::std::mem::offset_of!(_SCARD_T0_REQUEST__bindgen_ty_1, CmdBytes) - 0usize];
    ["Offset of field: _SCARD_T0_REQUEST__bindgen_ty_1::rgbHeader"]
        [::std::mem::offset_of!(_SCARD_T0_REQUEST__bindgen_ty_1, rgbHeader) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_T0_REQUEST"][::std::mem::size_of::<_SCARD_T0_REQUEST>() - 16usize];
    ["Alignment of _SCARD_T0_REQUEST"][::std::mem::align_of::<_SCARD_T0_REQUEST>() - 4usize];
    ["Offset of field: _SCARD_T0_REQUEST::ioRequest"]
        [::std::mem::offset_of!(_SCARD_T0_REQUEST, ioRequest) - 0usize];
    ["Offset of field: _SCARD_T0_REQUEST::bSw1"]
        [::std::mem::offset_of!(_SCARD_T0_REQUEST, bSw1) - 8usize];
    ["Offset of field: _SCARD_T0_REQUEST::bSw2"]
        [::std::mem::offset_of!(_SCARD_T0_REQUEST, bSw2) - 9usize];
};
pub type SCARD_T0_REQUEST = _SCARD_T0_REQUEST;
pub type PSCARD_T0_REQUEST = *mut SCARD_T0_REQUEST;
pub type LPSCARD_T0_REQUEST = *mut SCARD_T0_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCARD_T1_REQUEST {
    pub ioRequest: SCARD_IO_REQUEST,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_T1_REQUEST"][::std::mem::size_of::<_SCARD_T1_REQUEST>() - 8usize];
    ["Alignment of _SCARD_T1_REQUEST"][::std::mem::align_of::<_SCARD_T1_REQUEST>() - 4usize];
    ["Offset of field: _SCARD_T1_REQUEST::ioRequest"]
        [::std::mem::offset_of!(_SCARD_T1_REQUEST, ioRequest) - 0usize];
};
pub type SCARD_T1_REQUEST = _SCARD_T1_REQUEST;
pub type PSCARD_T1_REQUEST = *mut SCARD_T1_REQUEST;
pub type LPSCARD_T1_REQUEST = *mut SCARD_T1_REQUEST;
pub type LPCBYTE = *const BYTE;
unsafe extern "C" {
    pub static g_rgSCardT0Pci: SCARD_IO_REQUEST;
}
unsafe extern "C" {
    pub static g_rgSCardT1Pci: SCARD_IO_REQUEST;
}
unsafe extern "C" {
    pub static g_rgSCardRawPci: SCARD_IO_REQUEST;
}
pub type SCARDCONTEXT = ULONG_PTR;
pub type PSCARDCONTEXT = *mut SCARDCONTEXT;
pub type LPSCARDCONTEXT = *mut SCARDCONTEXT;
pub type SCARDHANDLE = ULONG_PTR;
pub type PSCARDHANDLE = *mut SCARDHANDLE;
pub type LPSCARDHANDLE = *mut SCARDHANDLE;
unsafe extern "C" {
    pub fn SCardEstablishContext(
        dwScope: DWORD,
        pvReserved1: LPCVOID,
        pvReserved2: LPCVOID,
        phContext: LPSCARDCONTEXT,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardReleaseContext(hContext: SCARDCONTEXT) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIsValidContext(hContext: SCARDCONTEXT) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReaderGroupsA(
        hContext: SCARDCONTEXT,
        mszGroups: LPSTR,
        pcchGroups: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReaderGroupsW(
        hContext: SCARDCONTEXT,
        mszGroups: LPWSTR,
        pcchGroups: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReadersA(
        hContext: SCARDCONTEXT,
        mszGroups: LPCSTR,
        mszReaders: LPSTR,
        pcchReaders: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReadersW(
        hContext: SCARDCONTEXT,
        mszGroups: LPCWSTR,
        mszReaders: LPWSTR,
        pcchReaders: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListCardsA(
        hContext: SCARDCONTEXT,
        pbAtr: LPCBYTE,
        rgquidInterfaces: LPCGUID,
        cguidInterfaceCount: DWORD,
        mszCards: *mut CHAR,
        pcchCards: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListCardsW(
        hContext: SCARDCONTEXT,
        pbAtr: LPCBYTE,
        rgquidInterfaces: LPCGUID,
        cguidInterfaceCount: DWORD,
        mszCards: *mut WCHAR,
        pcchCards: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListInterfacesA(
        hContext: SCARDCONTEXT,
        szCard: LPCSTR,
        pguidInterfaces: LPGUID,
        pcguidInterfaces: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListInterfacesW(
        hContext: SCARDCONTEXT,
        szCard: LPCWSTR,
        pguidInterfaces: LPGUID,
        pcguidInterfaces: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetProviderIdA(
        hContext: SCARDCONTEXT,
        szCard: LPCSTR,
        pguidProviderId: LPGUID,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetProviderIdW(
        hContext: SCARDCONTEXT,
        szCard: LPCWSTR,
        pguidProviderId: LPGUID,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetCardTypeProviderNameA(
        hContext: SCARDCONTEXT,
        szCardName: LPCSTR,
        dwProviderId: DWORD,
        szProvider: *mut CHAR,
        pcchProvider: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetCardTypeProviderNameW(
        hContext: SCARDCONTEXT,
        szCardName: LPCWSTR,
        dwProviderId: DWORD,
        szProvider: *mut WCHAR,
        pcchProvider: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceReaderGroupA(hContext: SCARDCONTEXT, szGroupName: LPCSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceReaderGroupW(hContext: SCARDCONTEXT, szGroupName: LPCWSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetReaderGroupA(hContext: SCARDCONTEXT, szGroupName: LPCSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetReaderGroupW(hContext: SCARDCONTEXT, szGroupName: LPCWSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceReaderA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        szDeviceName: LPCSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceReaderW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        szDeviceName: LPCWSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetReaderA(hContext: SCARDCONTEXT, szReaderName: LPCSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetReaderW(hContext: SCARDCONTEXT, szReaderName: LPCWSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardAddReaderToGroupA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        szGroupName: LPCSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardAddReaderToGroupW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        szGroupName: LPCWSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardRemoveReaderFromGroupA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        szGroupName: LPCSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardRemoveReaderFromGroupW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        szGroupName: LPCWSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceCardTypeA(
        hContext: SCARDCONTEXT,
        szCardName: LPCSTR,
        pguidPrimaryProvider: LPCGUID,
        rgguidInterfaces: LPCGUID,
        dwInterfaceCount: DWORD,
        pbAtr: LPCBYTE,
        pbAtrMask: LPCBYTE,
        cbAtrLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardIntroduceCardTypeW(
        hContext: SCARDCONTEXT,
        szCardName: LPCWSTR,
        pguidPrimaryProvider: LPCGUID,
        rgguidInterfaces: LPCGUID,
        dwInterfaceCount: DWORD,
        pbAtr: LPCBYTE,
        pbAtrMask: LPCBYTE,
        cbAtrLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardSetCardTypeProviderNameA(
        hContext: SCARDCONTEXT,
        szCardName: LPCSTR,
        dwProviderId: DWORD,
        szProvider: LPCSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardSetCardTypeProviderNameW(
        hContext: SCARDCONTEXT,
        szCardName: LPCWSTR,
        dwProviderId: DWORD,
        szProvider: LPCWSTR,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetCardTypeA(hContext: SCARDCONTEXT, szCardName: LPCSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardForgetCardTypeW(hContext: SCARDCONTEXT, szCardName: LPCWSTR) -> LONG;
}
unsafe extern "C" {
    pub fn SCardFreeMemory(hContext: SCARDCONTEXT, pvMem: LPCVOID) -> LONG;
}
unsafe extern "C" {
    pub fn SCardAccessStartedEvent() -> HANDLE;
}
unsafe extern "C" {
    pub fn SCardReleaseStartedEvent();
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SCARD_READERSTATEA {
    pub szReader: LPCSTR,
    pub pvUserData: LPVOID,
    pub dwCurrentState: DWORD,
    pub dwEventState: DWORD,
    pub cbAtr: DWORD,
    pub rgbAtr: [BYTE; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SCARD_READERSTATEA"][::std::mem::size_of::<SCARD_READERSTATEA>() - 64usize];
    ["Alignment of SCARD_READERSTATEA"][::std::mem::align_of::<SCARD_READERSTATEA>() - 8usize];
    ["Offset of field: SCARD_READERSTATEA::szReader"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, szReader) - 0usize];
    ["Offset of field: SCARD_READERSTATEA::pvUserData"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, pvUserData) - 8usize];
    ["Offset of field: SCARD_READERSTATEA::dwCurrentState"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, dwCurrentState) - 16usize];
    ["Offset of field: SCARD_READERSTATEA::dwEventState"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, dwEventState) - 20usize];
    ["Offset of field: SCARD_READERSTATEA::cbAtr"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, cbAtr) - 24usize];
    ["Offset of field: SCARD_READERSTATEA::rgbAtr"]
        [::std::mem::offset_of!(SCARD_READERSTATEA, rgbAtr) - 28usize];
};
pub type PSCARD_READERSTATEA = *mut SCARD_READERSTATEA;
pub type LPSCARD_READERSTATEA = *mut SCARD_READERSTATEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SCARD_READERSTATEW {
    pub szReader: LPCWSTR,
    pub pvUserData: LPVOID,
    pub dwCurrentState: DWORD,
    pub dwEventState: DWORD,
    pub cbAtr: DWORD,
    pub rgbAtr: [BYTE; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SCARD_READERSTATEW"][::std::mem::size_of::<SCARD_READERSTATEW>() - 64usize];
    ["Alignment of SCARD_READERSTATEW"][::std::mem::align_of::<SCARD_READERSTATEW>() - 8usize];
    ["Offset of field: SCARD_READERSTATEW::szReader"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, szReader) - 0usize];
    ["Offset of field: SCARD_READERSTATEW::pvUserData"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, pvUserData) - 8usize];
    ["Offset of field: SCARD_READERSTATEW::dwCurrentState"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, dwCurrentState) - 16usize];
    ["Offset of field: SCARD_READERSTATEW::dwEventState"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, dwEventState) - 20usize];
    ["Offset of field: SCARD_READERSTATEW::cbAtr"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, cbAtr) - 24usize];
    ["Offset of field: SCARD_READERSTATEW::rgbAtr"]
        [::std::mem::offset_of!(SCARD_READERSTATEW, rgbAtr) - 28usize];
};
pub type PSCARD_READERSTATEW = *mut SCARD_READERSTATEW;
pub type LPSCARD_READERSTATEW = *mut SCARD_READERSTATEW;
pub type SCARD_READERSTATE = SCARD_READERSTATEA;
pub type PSCARD_READERSTATE = PSCARD_READERSTATEA;
pub type LPSCARD_READERSTATE = LPSCARD_READERSTATEA;
unsafe extern "C" {
    pub fn SCardLocateCardsA(
        hContext: SCARDCONTEXT,
        mszCards: LPCSTR,
        rgReaderStates: LPSCARD_READERSTATEA,
        cReaders: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardLocateCardsW(
        hContext: SCARDCONTEXT,
        mszCards: LPCWSTR,
        rgReaderStates: LPSCARD_READERSTATEW,
        cReaders: DWORD,
    ) -> LONG;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SCARD_ATRMASK {
    pub cbAtr: DWORD,
    pub rgbAtr: [BYTE; 36usize],
    pub rgbMask: [BYTE; 36usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SCARD_ATRMASK"][::std::mem::size_of::<_SCARD_ATRMASK>() - 76usize];
    ["Alignment of _SCARD_ATRMASK"][::std::mem::align_of::<_SCARD_ATRMASK>() - 4usize];
    ["Offset of field: _SCARD_ATRMASK::cbAtr"]
        [::std::mem::offset_of!(_SCARD_ATRMASK, cbAtr) - 0usize];
    ["Offset of field: _SCARD_ATRMASK::rgbAtr"]
        [::std::mem::offset_of!(_SCARD_ATRMASK, rgbAtr) - 4usize];
    ["Offset of field: _SCARD_ATRMASK::rgbMask"]
        [::std::mem::offset_of!(_SCARD_ATRMASK, rgbMask) - 40usize];
};
pub type SCARD_ATRMASK = _SCARD_ATRMASK;
pub type PSCARD_ATRMASK = *mut _SCARD_ATRMASK;
pub type LPSCARD_ATRMASK = *mut _SCARD_ATRMASK;
unsafe extern "C" {
    pub fn SCardLocateCardsByATRA(
        hContext: SCARDCONTEXT,
        rgAtrMasks: LPSCARD_ATRMASK,
        cAtrs: DWORD,
        rgReaderStates: LPSCARD_READERSTATEA,
        cReaders: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardLocateCardsByATRW(
        hContext: SCARDCONTEXT,
        rgAtrMasks: LPSCARD_ATRMASK,
        cAtrs: DWORD,
        rgReaderStates: LPSCARD_READERSTATEW,
        cReaders: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetStatusChangeA(
        hContext: SCARDCONTEXT,
        dwTimeout: DWORD,
        rgReaderStates: LPSCARD_READERSTATEA,
        cReaders: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetStatusChangeW(
        hContext: SCARDCONTEXT,
        dwTimeout: DWORD,
        rgReaderStates: LPSCARD_READERSTATEW,
        cReaders: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardCancel(hContext: SCARDCONTEXT) -> LONG;
}
unsafe extern "C" {
    pub fn SCardConnectA(
        hContext: SCARDCONTEXT,
        szReader: LPCSTR,
        dwShareMode: DWORD,
        dwPreferredProtocols: DWORD,
        phCard: LPSCARDHANDLE,
        pdwActiveProtocol: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardConnectW(
        hContext: SCARDCONTEXT,
        szReader: LPCWSTR,
        dwShareMode: DWORD,
        dwPreferredProtocols: DWORD,
        phCard: LPSCARDHANDLE,
        pdwActiveProtocol: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardReconnect(
        hCard: SCARDHANDLE,
        dwShareMode: DWORD,
        dwPreferredProtocols: DWORD,
        dwInitialization: DWORD,
        pdwActiveProtocol: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardDisconnect(hCard: SCARDHANDLE, dwDisposition: DWORD) -> LONG;
}
unsafe extern "C" {
    pub fn SCardBeginTransaction(hCard: SCARDHANDLE) -> LONG;
}
unsafe extern "C" {
    pub fn SCardEndTransaction(hCard: SCARDHANDLE, dwDisposition: DWORD) -> LONG;
}
unsafe extern "C" {
    pub fn SCardCancelTransaction(hCard: SCARDHANDLE) -> LONG;
}
unsafe extern "C" {
    pub fn SCardState(
        hCard: SCARDHANDLE,
        pdwState: LPDWORD,
        pdwProtocol: LPDWORD,
        pbAtr: LPBYTE,
        pcbAtrLen: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardStatusA(
        hCard: SCARDHANDLE,
        mszReaderNames: LPSTR,
        pcchReaderLen: LPDWORD,
        pdwState: LPDWORD,
        pdwProtocol: LPDWORD,
        pbAtr: LPBYTE,
        pcbAtrLen: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardStatusW(
        hCard: SCARDHANDLE,
        mszReaderNames: LPWSTR,
        pcchReaderLen: LPDWORD,
        pdwState: LPDWORD,
        pdwProtocol: LPDWORD,
        pbAtr: LPBYTE,
        pcbAtrLen: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardTransmit(
        hCard: SCARDHANDLE,
        pioSendPci: LPCSCARD_IO_REQUEST,
        pbSendBuffer: LPCBYTE,
        cbSendLength: DWORD,
        pioRecvPci: LPSCARD_IO_REQUEST,
        pbRecvBuffer: LPBYTE,
        pcbRecvLength: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetTransmitCount(hCard: SCARDHANDLE, pcTransmitCount: LPDWORD) -> LONG;
}
unsafe extern "C" {
    pub fn SCardControl(
        hCard: SCARDHANDLE,
        dwControlCode: DWORD,
        lpInBuffer: LPCVOID,
        cbInBufferSize: DWORD,
        lpOutBuffer: LPVOID,
        cbOutBufferSize: DWORD,
        lpBytesReturned: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetAttrib(
        hCard: SCARDHANDLE,
        dwAttrId: DWORD,
        pbAttr: LPBYTE,
        pcbAttrLen: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardSetAttrib(
        hCard: SCARDHANDLE,
        dwAttrId: DWORD,
        pbAttr: LPCBYTE,
        cbAttrLen: DWORD,
    ) -> LONG;
}
pub type LPOCNCONNPROCA = ::std::option::Option<
    unsafe extern "C" fn(arg1: SCARDCONTEXT, arg2: LPSTR, arg3: LPSTR, arg4: PVOID) -> SCARDHANDLE,
>;
pub type LPOCNCONNPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: SCARDCONTEXT,
        arg2: LPWSTR,
        arg3: LPWSTR,
        arg4: PVOID,
    ) -> SCARDHANDLE,
>;
pub type LPOCNCHKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: SCARDCONTEXT, arg2: SCARDHANDLE, arg3: PVOID) -> BOOL,
>;
pub type LPOCNDSCPROC =
    ::std::option::Option<unsafe extern "C" fn(arg1: SCARDCONTEXT, arg2: SCARDHANDLE, arg3: PVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARD_SEARCH_CRITERIAA {
    pub dwStructSize: DWORD,
    pub lpstrGroupNames: LPSTR,
    pub nMaxGroupNames: DWORD,
    pub rgguidInterfaces: LPCGUID,
    pub cguidInterfaces: DWORD,
    pub lpstrCardNames: LPSTR,
    pub nMaxCardNames: DWORD,
    pub lpfnCheck: LPOCNCHKPROC,
    pub lpfnConnect: LPOCNCONNPROCA,
    pub lpfnDisconnect: LPOCNDSCPROC,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARD_SEARCH_CRITERIAA"]
        [::std::mem::size_of::<OPENCARD_SEARCH_CRITERIAA>() - 96usize];
    ["Alignment of OPENCARD_SEARCH_CRITERIAA"]
        [::std::mem::align_of::<OPENCARD_SEARCH_CRITERIAA>() - 8usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::dwStructSize"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, dwStructSize) - 0usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::lpstrGroupNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, lpstrGroupNames) - 8usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::nMaxGroupNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, nMaxGroupNames) - 16usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::rgguidInterfaces"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, rgguidInterfaces) - 24usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::cguidInterfaces"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, cguidInterfaces) - 32usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::lpstrCardNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, lpstrCardNames) - 40usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::nMaxCardNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, nMaxCardNames) - 48usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::lpfnCheck"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, lpfnCheck) - 56usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, lpfnConnect) - 64usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::lpfnDisconnect"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, lpfnDisconnect) - 72usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::pvUserData"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, pvUserData) - 80usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::dwShareMode"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, dwShareMode) - 88usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAA::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAA, dwPreferredProtocols) - 92usize];
};
pub type POPENCARD_SEARCH_CRITERIAA = *mut OPENCARD_SEARCH_CRITERIAA;
pub type LPOPENCARD_SEARCH_CRITERIAA = *mut OPENCARD_SEARCH_CRITERIAA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARD_SEARCH_CRITERIAW {
    pub dwStructSize: DWORD,
    pub lpstrGroupNames: LPWSTR,
    pub nMaxGroupNames: DWORD,
    pub rgguidInterfaces: LPCGUID,
    pub cguidInterfaces: DWORD,
    pub lpstrCardNames: LPWSTR,
    pub nMaxCardNames: DWORD,
    pub lpfnCheck: LPOCNCHKPROC,
    pub lpfnConnect: LPOCNCONNPROCW,
    pub lpfnDisconnect: LPOCNDSCPROC,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARD_SEARCH_CRITERIAW"]
        [::std::mem::size_of::<OPENCARD_SEARCH_CRITERIAW>() - 96usize];
    ["Alignment of OPENCARD_SEARCH_CRITERIAW"]
        [::std::mem::align_of::<OPENCARD_SEARCH_CRITERIAW>() - 8usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::dwStructSize"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, dwStructSize) - 0usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::lpstrGroupNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, lpstrGroupNames) - 8usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::nMaxGroupNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, nMaxGroupNames) - 16usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::rgguidInterfaces"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, rgguidInterfaces) - 24usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::cguidInterfaces"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, cguidInterfaces) - 32usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::lpstrCardNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, lpstrCardNames) - 40usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::nMaxCardNames"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, nMaxCardNames) - 48usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::lpfnCheck"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, lpfnCheck) - 56usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, lpfnConnect) - 64usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::lpfnDisconnect"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, lpfnDisconnect) - 72usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::pvUserData"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, pvUserData) - 80usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::dwShareMode"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, dwShareMode) - 88usize];
    ["Offset of field: OPENCARD_SEARCH_CRITERIAW::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARD_SEARCH_CRITERIAW, dwPreferredProtocols) - 92usize];
};
pub type POPENCARD_SEARCH_CRITERIAW = *mut OPENCARD_SEARCH_CRITERIAW;
pub type LPOPENCARD_SEARCH_CRITERIAW = *mut OPENCARD_SEARCH_CRITERIAW;
pub type OPENCARD_SEARCH_CRITERIA = OPENCARD_SEARCH_CRITERIAA;
pub type POPENCARD_SEARCH_CRITERIA = POPENCARD_SEARCH_CRITERIAA;
pub type LPOPENCARD_SEARCH_CRITERIA = LPOPENCARD_SEARCH_CRITERIAA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARDNAME_EXA {
    pub dwStructSize: DWORD,
    pub hSCardContext: SCARDCONTEXT,
    pub hwndOwner: HWND,
    pub dwFlags: DWORD,
    pub lpstrTitle: LPCSTR,
    pub lpstrSearchDesc: LPCSTR,
    pub hIcon: HICON,
    pub pOpenCardSearchCriteria: POPENCARD_SEARCH_CRITERIAA,
    pub lpfnConnect: LPOCNCONNPROCA,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
    pub lpstrRdr: LPSTR,
    pub nMaxRdr: DWORD,
    pub lpstrCard: LPSTR,
    pub nMaxCard: DWORD,
    pub dwActiveProtocol: DWORD,
    pub hCardHandle: SCARDHANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARDNAME_EXA"][::std::mem::size_of::<OPENCARDNAME_EXA>() - 128usize];
    ["Alignment of OPENCARDNAME_EXA"][::std::mem::align_of::<OPENCARDNAME_EXA>() - 8usize];
    ["Offset of field: OPENCARDNAME_EXA::dwStructSize"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, dwStructSize) - 0usize];
    ["Offset of field: OPENCARDNAME_EXA::hSCardContext"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, hSCardContext) - 8usize];
    ["Offset of field: OPENCARDNAME_EXA::hwndOwner"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, hwndOwner) - 16usize];
    ["Offset of field: OPENCARDNAME_EXA::dwFlags"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, dwFlags) - 24usize];
    ["Offset of field: OPENCARDNAME_EXA::lpstrTitle"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, lpstrTitle) - 32usize];
    ["Offset of field: OPENCARDNAME_EXA::lpstrSearchDesc"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, lpstrSearchDesc) - 40usize];
    ["Offset of field: OPENCARDNAME_EXA::hIcon"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, hIcon) - 48usize];
    ["Offset of field: OPENCARDNAME_EXA::pOpenCardSearchCriteria"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, pOpenCardSearchCriteria) - 56usize];
    ["Offset of field: OPENCARDNAME_EXA::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, lpfnConnect) - 64usize];
    ["Offset of field: OPENCARDNAME_EXA::pvUserData"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, pvUserData) - 72usize];
    ["Offset of field: OPENCARDNAME_EXA::dwShareMode"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, dwShareMode) - 80usize];
    ["Offset of field: OPENCARDNAME_EXA::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, dwPreferredProtocols) - 84usize];
    ["Offset of field: OPENCARDNAME_EXA::lpstrRdr"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, lpstrRdr) - 88usize];
    ["Offset of field: OPENCARDNAME_EXA::nMaxRdr"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, nMaxRdr) - 96usize];
    ["Offset of field: OPENCARDNAME_EXA::lpstrCard"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, lpstrCard) - 104usize];
    ["Offset of field: OPENCARDNAME_EXA::nMaxCard"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, nMaxCard) - 112usize];
    ["Offset of field: OPENCARDNAME_EXA::dwActiveProtocol"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, dwActiveProtocol) - 116usize];
    ["Offset of field: OPENCARDNAME_EXA::hCardHandle"]
        [::std::mem::offset_of!(OPENCARDNAME_EXA, hCardHandle) - 120usize];
};
pub type POPENCARDNAME_EXA = *mut OPENCARDNAME_EXA;
pub type LPOPENCARDNAME_EXA = *mut OPENCARDNAME_EXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARDNAME_EXW {
    pub dwStructSize: DWORD,
    pub hSCardContext: SCARDCONTEXT,
    pub hwndOwner: HWND,
    pub dwFlags: DWORD,
    pub lpstrTitle: LPCWSTR,
    pub lpstrSearchDesc: LPCWSTR,
    pub hIcon: HICON,
    pub pOpenCardSearchCriteria: POPENCARD_SEARCH_CRITERIAW,
    pub lpfnConnect: LPOCNCONNPROCW,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
    pub lpstrRdr: LPWSTR,
    pub nMaxRdr: DWORD,
    pub lpstrCard: LPWSTR,
    pub nMaxCard: DWORD,
    pub dwActiveProtocol: DWORD,
    pub hCardHandle: SCARDHANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARDNAME_EXW"][::std::mem::size_of::<OPENCARDNAME_EXW>() - 128usize];
    ["Alignment of OPENCARDNAME_EXW"][::std::mem::align_of::<OPENCARDNAME_EXW>() - 8usize];
    ["Offset of field: OPENCARDNAME_EXW::dwStructSize"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, dwStructSize) - 0usize];
    ["Offset of field: OPENCARDNAME_EXW::hSCardContext"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, hSCardContext) - 8usize];
    ["Offset of field: OPENCARDNAME_EXW::hwndOwner"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, hwndOwner) - 16usize];
    ["Offset of field: OPENCARDNAME_EXW::dwFlags"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, dwFlags) - 24usize];
    ["Offset of field: OPENCARDNAME_EXW::lpstrTitle"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, lpstrTitle) - 32usize];
    ["Offset of field: OPENCARDNAME_EXW::lpstrSearchDesc"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, lpstrSearchDesc) - 40usize];
    ["Offset of field: OPENCARDNAME_EXW::hIcon"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, hIcon) - 48usize];
    ["Offset of field: OPENCARDNAME_EXW::pOpenCardSearchCriteria"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, pOpenCardSearchCriteria) - 56usize];
    ["Offset of field: OPENCARDNAME_EXW::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, lpfnConnect) - 64usize];
    ["Offset of field: OPENCARDNAME_EXW::pvUserData"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, pvUserData) - 72usize];
    ["Offset of field: OPENCARDNAME_EXW::dwShareMode"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, dwShareMode) - 80usize];
    ["Offset of field: OPENCARDNAME_EXW::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, dwPreferredProtocols) - 84usize];
    ["Offset of field: OPENCARDNAME_EXW::lpstrRdr"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, lpstrRdr) - 88usize];
    ["Offset of field: OPENCARDNAME_EXW::nMaxRdr"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, nMaxRdr) - 96usize];
    ["Offset of field: OPENCARDNAME_EXW::lpstrCard"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, lpstrCard) - 104usize];
    ["Offset of field: OPENCARDNAME_EXW::nMaxCard"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, nMaxCard) - 112usize];
    ["Offset of field: OPENCARDNAME_EXW::dwActiveProtocol"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, dwActiveProtocol) - 116usize];
    ["Offset of field: OPENCARDNAME_EXW::hCardHandle"]
        [::std::mem::offset_of!(OPENCARDNAME_EXW, hCardHandle) - 120usize];
};
pub type POPENCARDNAME_EXW = *mut OPENCARDNAME_EXW;
pub type LPOPENCARDNAME_EXW = *mut OPENCARDNAME_EXW;
pub type OPENCARDNAME_EX = OPENCARDNAME_EXA;
pub type POPENCARDNAME_EX = POPENCARDNAME_EXA;
pub type LPOPENCARDNAME_EX = LPOPENCARDNAME_EXA;
pub const READER_SEL_REQUEST_MATCH_TYPE_RSR_MATCH_TYPE_READER_AND_CONTAINER:
    READER_SEL_REQUEST_MATCH_TYPE = 1;
pub const READER_SEL_REQUEST_MATCH_TYPE_RSR_MATCH_TYPE_SERIAL_NUMBER:
    READER_SEL_REQUEST_MATCH_TYPE = 2;
pub const READER_SEL_REQUEST_MATCH_TYPE_RSR_MATCH_TYPE_ALL_CARDS: READER_SEL_REQUEST_MATCH_TYPE = 3;
pub type READER_SEL_REQUEST_MATCH_TYPE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct READER_SEL_REQUEST {
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
    pub MatchType: READER_SEL_REQUEST_MATCH_TYPE,
    pub __bindgen_anon_1: READER_SEL_REQUEST__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union READER_SEL_REQUEST__bindgen_ty_1 {
    pub ReaderAndContainerParameter: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
    pub SerialNumberParameter: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1 {
    pub cbReaderNameOffset: DWORD,
    pub cchReaderNameLength: DWORD,
    pub cbContainerNameOffset: DWORD,
    pub cchContainerNameLength: DWORD,
    pub dwDesiredCardModuleVersion: DWORD,
    pub dwCspFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1>() - 24usize];
    ["Alignment of READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1>() - 4usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::cbReaderNameOffset"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
        cbReaderNameOffset
    )
        - 0usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::cchReaderNameLength"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
        cchReaderNameLength
    )
        - 4usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::cbContainerNameOffset"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
        cbContainerNameOffset
    )
        - 8usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::cchContainerNameLength"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
        cchContainerNameLength
    )
        - 12usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::dwDesiredCardModuleVersion"] [:: std :: mem :: offset_of ! (READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1 , dwDesiredCardModuleVersion) - 16usize] ;
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1::dwCspFlags"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_1,
        dwCspFlags
    ) - 20usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2 {
    pub cbSerialNumberOffset: DWORD,
    pub cbSerialNumberLength: DWORD,
    pub dwDesiredCardModuleVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::size_of::<READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2>() - 12usize];
    ["Alignment of READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2"]
        [::std::mem::align_of::<READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2>() - 4usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2::cbSerialNumberOffset"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2,
        cbSerialNumberOffset
    )
        - 0usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2::cbSerialNumberLength"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2,
        cbSerialNumberLength
    )
        - 4usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2::dwDesiredCardModuleVersion"] [:: std :: mem :: offset_of ! (READER_SEL_REQUEST__bindgen_ty_1__bindgen_ty_2 , dwDesiredCardModuleVersion) - 8usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READER_SEL_REQUEST__bindgen_ty_1"]
        [::std::mem::size_of::<READER_SEL_REQUEST__bindgen_ty_1>() - 24usize];
    ["Alignment of READER_SEL_REQUEST__bindgen_ty_1"]
        [::std::mem::align_of::<READER_SEL_REQUEST__bindgen_ty_1>() - 4usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1::ReaderAndContainerParameter"][::std::mem::offset_of!(
        READER_SEL_REQUEST__bindgen_ty_1,
        ReaderAndContainerParameter
    ) - 0usize];
    ["Offset of field: READER_SEL_REQUEST__bindgen_ty_1::SerialNumberParameter"]
        [::std::mem::offset_of!(READER_SEL_REQUEST__bindgen_ty_1, SerialNumberParameter) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READER_SEL_REQUEST"][::std::mem::size_of::<READER_SEL_REQUEST>() - 36usize];
    ["Alignment of READER_SEL_REQUEST"][::std::mem::align_of::<READER_SEL_REQUEST>() - 4usize];
    ["Offset of field: READER_SEL_REQUEST::dwShareMode"]
        [::std::mem::offset_of!(READER_SEL_REQUEST, dwShareMode) - 0usize];
    ["Offset of field: READER_SEL_REQUEST::dwPreferredProtocols"]
        [::std::mem::offset_of!(READER_SEL_REQUEST, dwPreferredProtocols) - 4usize];
    ["Offset of field: READER_SEL_REQUEST::MatchType"]
        [::std::mem::offset_of!(READER_SEL_REQUEST, MatchType) - 8usize];
};
pub type PREADER_SEL_REQUEST = *mut READER_SEL_REQUEST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct READER_SEL_RESPONSE {
    pub cbReaderNameOffset: DWORD,
    pub cchReaderNameLength: DWORD,
    pub cbCardNameOffset: DWORD,
    pub cchCardNameLength: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of READER_SEL_RESPONSE"][::std::mem::size_of::<READER_SEL_RESPONSE>() - 16usize];
    ["Alignment of READER_SEL_RESPONSE"][::std::mem::align_of::<READER_SEL_RESPONSE>() - 4usize];
    ["Offset of field: READER_SEL_RESPONSE::cbReaderNameOffset"]
        [::std::mem::offset_of!(READER_SEL_RESPONSE, cbReaderNameOffset) - 0usize];
    ["Offset of field: READER_SEL_RESPONSE::cchReaderNameLength"]
        [::std::mem::offset_of!(READER_SEL_RESPONSE, cchReaderNameLength) - 4usize];
    ["Offset of field: READER_SEL_RESPONSE::cbCardNameOffset"]
        [::std::mem::offset_of!(READER_SEL_RESPONSE, cbCardNameOffset) - 8usize];
    ["Offset of field: READER_SEL_RESPONSE::cchCardNameLength"]
        [::std::mem::offset_of!(READER_SEL_RESPONSE, cchCardNameLength) - 12usize];
};
pub type PREADER_SEL_RESPONSE = *mut READER_SEL_RESPONSE;
unsafe extern "C" {
    pub fn SCardUIDlgSelectCardA(arg1: LPOPENCARDNAME_EXA) -> LONG;
}
unsafe extern "C" {
    pub fn SCardUIDlgSelectCardW(arg1: LPOPENCARDNAME_EXW) -> LONG;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARDNAMEA {
    pub dwStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hSCardContext: SCARDCONTEXT,
    pub lpstrGroupNames: LPSTR,
    pub nMaxGroupNames: DWORD,
    pub lpstrCardNames: LPSTR,
    pub nMaxCardNames: DWORD,
    pub rgguidInterfaces: LPCGUID,
    pub cguidInterfaces: DWORD,
    pub lpstrRdr: LPSTR,
    pub nMaxRdr: DWORD,
    pub lpstrCard: LPSTR,
    pub nMaxCard: DWORD,
    pub lpstrTitle: LPCSTR,
    pub dwFlags: DWORD,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
    pub dwActiveProtocol: DWORD,
    pub lpfnConnect: LPOCNCONNPROCA,
    pub lpfnCheck: LPOCNCHKPROC,
    pub lpfnDisconnect: LPOCNDSCPROC,
    pub hCardHandle: SCARDHANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARDNAMEA"][::std::mem::size_of::<OPENCARDNAMEA>() - 176usize];
    ["Alignment of OPENCARDNAMEA"][::std::mem::align_of::<OPENCARDNAMEA>() - 8usize];
    ["Offset of field: OPENCARDNAMEA::dwStructSize"]
        [::std::mem::offset_of!(OPENCARDNAMEA, dwStructSize) - 0usize];
    ["Offset of field: OPENCARDNAMEA::hwndOwner"]
        [::std::mem::offset_of!(OPENCARDNAMEA, hwndOwner) - 8usize];
    ["Offset of field: OPENCARDNAMEA::hSCardContext"]
        [::std::mem::offset_of!(OPENCARDNAMEA, hSCardContext) - 16usize];
    ["Offset of field: OPENCARDNAMEA::lpstrGroupNames"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpstrGroupNames) - 24usize];
    ["Offset of field: OPENCARDNAMEA::nMaxGroupNames"]
        [::std::mem::offset_of!(OPENCARDNAMEA, nMaxGroupNames) - 32usize];
    ["Offset of field: OPENCARDNAMEA::lpstrCardNames"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpstrCardNames) - 40usize];
    ["Offset of field: OPENCARDNAMEA::nMaxCardNames"]
        [::std::mem::offset_of!(OPENCARDNAMEA, nMaxCardNames) - 48usize];
    ["Offset of field: OPENCARDNAMEA::rgguidInterfaces"]
        [::std::mem::offset_of!(OPENCARDNAMEA, rgguidInterfaces) - 56usize];
    ["Offset of field: OPENCARDNAMEA::cguidInterfaces"]
        [::std::mem::offset_of!(OPENCARDNAMEA, cguidInterfaces) - 64usize];
    ["Offset of field: OPENCARDNAMEA::lpstrRdr"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpstrRdr) - 72usize];
    ["Offset of field: OPENCARDNAMEA::nMaxRdr"]
        [::std::mem::offset_of!(OPENCARDNAMEA, nMaxRdr) - 80usize];
    ["Offset of field: OPENCARDNAMEA::lpstrCard"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpstrCard) - 88usize];
    ["Offset of field: OPENCARDNAMEA::nMaxCard"]
        [::std::mem::offset_of!(OPENCARDNAMEA, nMaxCard) - 96usize];
    ["Offset of field: OPENCARDNAMEA::lpstrTitle"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpstrTitle) - 104usize];
    ["Offset of field: OPENCARDNAMEA::dwFlags"]
        [::std::mem::offset_of!(OPENCARDNAMEA, dwFlags) - 112usize];
    ["Offset of field: OPENCARDNAMEA::pvUserData"]
        [::std::mem::offset_of!(OPENCARDNAMEA, pvUserData) - 120usize];
    ["Offset of field: OPENCARDNAMEA::dwShareMode"]
        [::std::mem::offset_of!(OPENCARDNAMEA, dwShareMode) - 128usize];
    ["Offset of field: OPENCARDNAMEA::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARDNAMEA, dwPreferredProtocols) - 132usize];
    ["Offset of field: OPENCARDNAMEA::dwActiveProtocol"]
        [::std::mem::offset_of!(OPENCARDNAMEA, dwActiveProtocol) - 136usize];
    ["Offset of field: OPENCARDNAMEA::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpfnConnect) - 144usize];
    ["Offset of field: OPENCARDNAMEA::lpfnCheck"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpfnCheck) - 152usize];
    ["Offset of field: OPENCARDNAMEA::lpfnDisconnect"]
        [::std::mem::offset_of!(OPENCARDNAMEA, lpfnDisconnect) - 160usize];
    ["Offset of field: OPENCARDNAMEA::hCardHandle"]
        [::std::mem::offset_of!(OPENCARDNAMEA, hCardHandle) - 168usize];
};
pub type POPENCARDNAMEA = *mut OPENCARDNAMEA;
pub type LPOPENCARDNAMEA = *mut OPENCARDNAMEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct OPENCARDNAMEW {
    pub dwStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hSCardContext: SCARDCONTEXT,
    pub lpstrGroupNames: LPWSTR,
    pub nMaxGroupNames: DWORD,
    pub lpstrCardNames: LPWSTR,
    pub nMaxCardNames: DWORD,
    pub rgguidInterfaces: LPCGUID,
    pub cguidInterfaces: DWORD,
    pub lpstrRdr: LPWSTR,
    pub nMaxRdr: DWORD,
    pub lpstrCard: LPWSTR,
    pub nMaxCard: DWORD,
    pub lpstrTitle: LPCWSTR,
    pub dwFlags: DWORD,
    pub pvUserData: LPVOID,
    pub dwShareMode: DWORD,
    pub dwPreferredProtocols: DWORD,
    pub dwActiveProtocol: DWORD,
    pub lpfnConnect: LPOCNCONNPROCW,
    pub lpfnCheck: LPOCNCHKPROC,
    pub lpfnDisconnect: LPOCNDSCPROC,
    pub hCardHandle: SCARDHANDLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of OPENCARDNAMEW"][::std::mem::size_of::<OPENCARDNAMEW>() - 176usize];
    ["Alignment of OPENCARDNAMEW"][::std::mem::align_of::<OPENCARDNAMEW>() - 8usize];
    ["Offset of field: OPENCARDNAMEW::dwStructSize"]
        [::std::mem::offset_of!(OPENCARDNAMEW, dwStructSize) - 0usize];
    ["Offset of field: OPENCARDNAMEW::hwndOwner"]
        [::std::mem::offset_of!(OPENCARDNAMEW, hwndOwner) - 8usize];
    ["Offset of field: OPENCARDNAMEW::hSCardContext"]
        [::std::mem::offset_of!(OPENCARDNAMEW, hSCardContext) - 16usize];
    ["Offset of field: OPENCARDNAMEW::lpstrGroupNames"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpstrGroupNames) - 24usize];
    ["Offset of field: OPENCARDNAMEW::nMaxGroupNames"]
        [::std::mem::offset_of!(OPENCARDNAMEW, nMaxGroupNames) - 32usize];
    ["Offset of field: OPENCARDNAMEW::lpstrCardNames"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpstrCardNames) - 40usize];
    ["Offset of field: OPENCARDNAMEW::nMaxCardNames"]
        [::std::mem::offset_of!(OPENCARDNAMEW, nMaxCardNames) - 48usize];
    ["Offset of field: OPENCARDNAMEW::rgguidInterfaces"]
        [::std::mem::offset_of!(OPENCARDNAMEW, rgguidInterfaces) - 56usize];
    ["Offset of field: OPENCARDNAMEW::cguidInterfaces"]
        [::std::mem::offset_of!(OPENCARDNAMEW, cguidInterfaces) - 64usize];
    ["Offset of field: OPENCARDNAMEW::lpstrRdr"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpstrRdr) - 72usize];
    ["Offset of field: OPENCARDNAMEW::nMaxRdr"]
        [::std::mem::offset_of!(OPENCARDNAMEW, nMaxRdr) - 80usize];
    ["Offset of field: OPENCARDNAMEW::lpstrCard"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpstrCard) - 88usize];
    ["Offset of field: OPENCARDNAMEW::nMaxCard"]
        [::std::mem::offset_of!(OPENCARDNAMEW, nMaxCard) - 96usize];
    ["Offset of field: OPENCARDNAMEW::lpstrTitle"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpstrTitle) - 104usize];
    ["Offset of field: OPENCARDNAMEW::dwFlags"]
        [::std::mem::offset_of!(OPENCARDNAMEW, dwFlags) - 112usize];
    ["Offset of field: OPENCARDNAMEW::pvUserData"]
        [::std::mem::offset_of!(OPENCARDNAMEW, pvUserData) - 120usize];
    ["Offset of field: OPENCARDNAMEW::dwShareMode"]
        [::std::mem::offset_of!(OPENCARDNAMEW, dwShareMode) - 128usize];
    ["Offset of field: OPENCARDNAMEW::dwPreferredProtocols"]
        [::std::mem::offset_of!(OPENCARDNAMEW, dwPreferredProtocols) - 132usize];
    ["Offset of field: OPENCARDNAMEW::dwActiveProtocol"]
        [::std::mem::offset_of!(OPENCARDNAMEW, dwActiveProtocol) - 136usize];
    ["Offset of field: OPENCARDNAMEW::lpfnConnect"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpfnConnect) - 144usize];
    ["Offset of field: OPENCARDNAMEW::lpfnCheck"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpfnCheck) - 152usize];
    ["Offset of field: OPENCARDNAMEW::lpfnDisconnect"]
        [::std::mem::offset_of!(OPENCARDNAMEW, lpfnDisconnect) - 160usize];
    ["Offset of field: OPENCARDNAMEW::hCardHandle"]
        [::std::mem::offset_of!(OPENCARDNAMEW, hCardHandle) - 168usize];
};
pub type POPENCARDNAMEW = *mut OPENCARDNAMEW;
pub type LPOPENCARDNAMEW = *mut OPENCARDNAMEW;
pub type OPENCARDNAME = OPENCARDNAMEA;
pub type POPENCARDNAME = POPENCARDNAMEA;
pub type LPOPENCARDNAME = LPOPENCARDNAMEA;
unsafe extern "C" {
    pub fn GetOpenCardNameA(arg1: LPOPENCARDNAMEA) -> LONG;
}
unsafe extern "C" {
    pub fn GetOpenCardNameW(arg1: LPOPENCARDNAMEW) -> LONG;
}
unsafe extern "C" {
    pub fn SCardDlgExtendedError() -> LONG;
}
unsafe extern "C" {
    pub fn SCardReadCacheA(
        hContext: SCARDCONTEXT,
        CardIdentifier: *mut UUID,
        FreshnessCounter: DWORD,
        LookupName: LPSTR,
        Data: PBYTE,
        DataLen: *mut DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardReadCacheW(
        hContext: SCARDCONTEXT,
        CardIdentifier: *mut UUID,
        FreshnessCounter: DWORD,
        LookupName: LPWSTR,
        Data: PBYTE,
        DataLen: *mut DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardWriteCacheA(
        hContext: SCARDCONTEXT,
        CardIdentifier: *mut UUID,
        FreshnessCounter: DWORD,
        LookupName: LPSTR,
        Data: PBYTE,
        DataLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardWriteCacheW(
        hContext: SCARDCONTEXT,
        CardIdentifier: *mut UUID,
        FreshnessCounter: DWORD,
        LookupName: LPWSTR,
        Data: PBYTE,
        DataLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetReaderIconA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        pbIcon: LPBYTE,
        pcbIcon: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetReaderIconW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        pbIcon: LPBYTE,
        pcbIcon: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetDeviceTypeIdA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        pdwDeviceTypeId: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetDeviceTypeIdW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        pdwDeviceTypeId: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetReaderDeviceInstanceIdA(
        hContext: SCARDCONTEXT,
        szReaderName: LPCSTR,
        szDeviceInstanceId: LPSTR,
        pcchDeviceInstanceId: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardGetReaderDeviceInstanceIdW(
        hContext: SCARDCONTEXT,
        szReaderName: LPCWSTR,
        szDeviceInstanceId: LPWSTR,
        pcchDeviceInstanceId: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReadersWithDeviceInstanceIdA(
        hContext: SCARDCONTEXT,
        szDeviceInstanceId: LPCSTR,
        mszReaders: LPSTR,
        pcchReaders: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardListReadersWithDeviceInstanceIdW(
        hContext: SCARDCONTEXT,
        szDeviceInstanceId: LPCWSTR,
        mszReaders: LPWSTR,
        pcchReaders: LPDWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn SCardAudit(hContext: SCARDCONTEXT, dwEvent: DWORD) -> LONG;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PSP {
    _unused: [u8; 0],
}
pub type HPROPSHEETPAGE = *mut _PSP;
pub type LPFNPSPCALLBACKA = ::std::option::Option<
    unsafe extern "C" fn(hwnd: HWND, uMsg: UINT, ppsp: *mut _PROPSHEETPAGEA) -> UINT,
>;
pub type LPFNPSPCALLBACKW = ::std::option::Option<
    unsafe extern "C" fn(hwnd: HWND, uMsg: UINT, ppsp: *mut _PROPSHEETPAGEW) -> UINT,
>;
pub type PROPSHEETPAGE_RESOURCE = LPCDLGTEMPLATE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEA_V1 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEA_V1__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEA_V1__bindgen_ty_2,
    pub pszTitle: LPCSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKA,
    pub pcRefParent: *mut UINT,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V1__bindgen_ty_1 {
    pub pszTemplate: LPCSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V1__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V1__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V1__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V1__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V1__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V1__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V1__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V1__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V1__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V1"][::std::mem::size_of::<_PROPSHEETPAGEA_V1>() - 72usize];
    ["Alignment of _PROPSHEETPAGEA_V1"][::std::mem::align_of::<_PROPSHEETPAGEA_V1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEA_V1::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V1, pcRefParent) - 64usize];
};
pub type PROPSHEETPAGEA_V1 = _PROPSHEETPAGEA_V1;
pub type LPPROPSHEETPAGEA_V1 = *mut _PROPSHEETPAGEA_V1;
pub type LPCPROPSHEETPAGEA_V1 = *const PROPSHEETPAGEA_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEA_V2 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEA_V2__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEA_V2__bindgen_ty_2,
    pub pszTitle: LPCSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKA,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCSTR,
    pub pszHeaderSubTitle: LPCSTR,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V2__bindgen_ty_1 {
    pub pszTemplate: LPCSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V2__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V2__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V2__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V2__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V2__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V2__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V2__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V2__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V2__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V2__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V2__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V2__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V2__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V2"][::std::mem::size_of::<_PROPSHEETPAGEA_V2>() - 88usize];
    ["Alignment of _PROPSHEETPAGEA_V2"][::std::mem::align_of::<_PROPSHEETPAGEA_V2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEA_V2::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V2, pszHeaderSubTitle) - 80usize];
};
pub type PROPSHEETPAGEA_V2 = _PROPSHEETPAGEA_V2;
pub type LPPROPSHEETPAGEA_V2 = *mut _PROPSHEETPAGEA_V2;
pub type LPCPROPSHEETPAGEA_V2 = *const PROPSHEETPAGEA_V2;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEA_V3 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEA_V3__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEA_V3__bindgen_ty_2,
    pub pszTitle: LPCSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKA,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCSTR,
    pub pszHeaderSubTitle: LPCSTR,
    pub hActCtx: HANDLE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V3__bindgen_ty_1 {
    pub pszTemplate: LPCSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V3__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V3__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V3__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V3__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V3__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V3__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA_V3__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V3__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEA_V3__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA_V3__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEA_V3__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V3__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V3__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA_V3"][::std::mem::size_of::<_PROPSHEETPAGEA_V3>() - 96usize];
    ["Alignment of _PROPSHEETPAGEA_V3"][::std::mem::align_of::<_PROPSHEETPAGEA_V3>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, pszHeaderSubTitle) - 80usize];
    ["Offset of field: _PROPSHEETPAGEA_V3::hActCtx"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA_V3, hActCtx) - 88usize];
};
pub type PROPSHEETPAGEA_V3 = _PROPSHEETPAGEA_V3;
pub type LPPROPSHEETPAGEA_V3 = *mut _PROPSHEETPAGEA_V3;
pub type LPCPROPSHEETPAGEA_V3 = *const PROPSHEETPAGEA_V3;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEA {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEA__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEA__bindgen_ty_2,
    pub pszTitle: LPCSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKA,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCSTR,
    pub pszHeaderSubTitle: LPCSTR,
    pub hActCtx: HANDLE,
    pub __bindgen_anon_3: _PROPSHEETPAGEA__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA__bindgen_ty_1 {
    pub pszTemplate: LPCSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEA__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEA__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEA__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_2, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEA__bindgen_ty_3 {
    pub hbmHeader: HBITMAP,
    pub pszbmHeader: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETPAGEA__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETPAGEA__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETPAGEA__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_3::hbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_3, hbmHeader) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA__bindgen_ty_3::pszbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA__bindgen_ty_3, pszbmHeader) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEA"][::std::mem::size_of::<_PROPSHEETPAGEA>() - 104usize];
    ["Alignment of _PROPSHEETPAGEA"][::std::mem::align_of::<_PROPSHEETPAGEA>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEA::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEA::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEA::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEA::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEA::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEA::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEA::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEA::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEA::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEA::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, pszHeaderSubTitle) - 80usize];
    ["Offset of field: _PROPSHEETPAGEA::hActCtx"]
        [::std::mem::offset_of!(_PROPSHEETPAGEA, hActCtx) - 88usize];
};
pub type PROPSHEETPAGEA_V4 = _PROPSHEETPAGEA;
pub type LPPROPSHEETPAGEA_V4 = *mut _PROPSHEETPAGEA;
pub type LPCPROPSHEETPAGEA_V4 = *const PROPSHEETPAGEA_V4;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEW_V1 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEW_V1__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEW_V1__bindgen_ty_2,
    pub pszTitle: LPCWSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKW,
    pub pcRefParent: *mut UINT,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V1__bindgen_ty_1 {
    pub pszTemplate: LPCWSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V1__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V1__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V1__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V1__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V1__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V1__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V1__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V1__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V1__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V1"][::std::mem::size_of::<_PROPSHEETPAGEW_V1>() - 72usize];
    ["Alignment of _PROPSHEETPAGEW_V1"][::std::mem::align_of::<_PROPSHEETPAGEW_V1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEW_V1::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V1, pcRefParent) - 64usize];
};
pub type PROPSHEETPAGEW_V1 = _PROPSHEETPAGEW_V1;
pub type LPPROPSHEETPAGEW_V1 = *mut _PROPSHEETPAGEW_V1;
pub type LPCPROPSHEETPAGEW_V1 = *const PROPSHEETPAGEW_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEW_V2 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEW_V2__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEW_V2__bindgen_ty_2,
    pub pszTitle: LPCWSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKW,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCWSTR,
    pub pszHeaderSubTitle: LPCWSTR,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V2__bindgen_ty_1 {
    pub pszTemplate: LPCWSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V2__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V2__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V2__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V2__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V2__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V2__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V2__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V2__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V2__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V2__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V2__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V2__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V2__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V2"][::std::mem::size_of::<_PROPSHEETPAGEW_V2>() - 88usize];
    ["Alignment of _PROPSHEETPAGEW_V2"][::std::mem::align_of::<_PROPSHEETPAGEW_V2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEW_V2::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V2, pszHeaderSubTitle) - 80usize];
};
pub type PROPSHEETPAGEW_V2 = _PROPSHEETPAGEW_V2;
pub type LPPROPSHEETPAGEW_V2 = *mut _PROPSHEETPAGEW_V2;
pub type LPCPROPSHEETPAGEW_V2 = *const PROPSHEETPAGEW_V2;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEW_V3 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEW_V3__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEW_V3__bindgen_ty_2,
    pub pszTitle: LPCWSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKW,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCWSTR,
    pub pszHeaderSubTitle: LPCWSTR,
    pub hActCtx: HANDLE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V3__bindgen_ty_1 {
    pub pszTemplate: LPCWSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V3__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V3__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V3__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V3__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V3__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V3__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW_V3__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V3__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEW_V3__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW_V3__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEW_V3__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V3__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V3__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3__bindgen_ty_2, pszIcon) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW_V3"][::std::mem::size_of::<_PROPSHEETPAGEW_V3>() - 96usize];
    ["Alignment of _PROPSHEETPAGEW_V3"][::std::mem::align_of::<_PROPSHEETPAGEW_V3>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, pszHeaderSubTitle) - 80usize];
    ["Offset of field: _PROPSHEETPAGEW_V3::hActCtx"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW_V3, hActCtx) - 88usize];
};
pub type PROPSHEETPAGEW_V3 = _PROPSHEETPAGEW_V3;
pub type LPPROPSHEETPAGEW_V3 = *mut _PROPSHEETPAGEW_V3;
pub type LPCPROPSHEETPAGEW_V3 = *const PROPSHEETPAGEW_V3;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETPAGEW {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETPAGEW__bindgen_ty_1,
    pub __bindgen_anon_2: _PROPSHEETPAGEW__bindgen_ty_2,
    pub pszTitle: LPCWSTR,
    pub pfnDlgProc: DLGPROC,
    pub lParam: LPARAM,
    pub pfnCallback: LPFNPSPCALLBACKW,
    pub pcRefParent: *mut UINT,
    pub pszHeaderTitle: LPCWSTR,
    pub pszHeaderSubTitle: LPCWSTR,
    pub hActCtx: HANDLE,
    pub __bindgen_anon_3: _PROPSHEETPAGEW__bindgen_ty_3,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW__bindgen_ty_1 {
    pub pszTemplate: LPCWSTR,
    pub pResource: PROPSHEETPAGE_RESOURCE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETPAGEW__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETPAGEW__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_1::pszTemplate"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_1, pszTemplate) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_1::pResource"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_1, pResource) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW__bindgen_ty_2 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETPAGEW__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETPAGEW__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_2::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_2, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_2::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_2, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETPAGEW__bindgen_ty_3 {
    pub hbmHeader: HBITMAP,
    pub pszbmHeader: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETPAGEW__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETPAGEW__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETPAGEW__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_3::hbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_3, hbmHeader) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW__bindgen_ty_3::pszbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW__bindgen_ty_3, pszbmHeader) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETPAGEW"][::std::mem::size_of::<_PROPSHEETPAGEW>() - 104usize];
    ["Alignment of _PROPSHEETPAGEW"][::std::mem::align_of::<_PROPSHEETPAGEW>() - 8usize];
    ["Offset of field: _PROPSHEETPAGEW::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETPAGEW::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETPAGEW::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, hInstance) - 8usize];
    ["Offset of field: _PROPSHEETPAGEW::pszTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pszTitle) - 32usize];
    ["Offset of field: _PROPSHEETPAGEW::pfnDlgProc"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pfnDlgProc) - 40usize];
    ["Offset of field: _PROPSHEETPAGEW::lParam"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, lParam) - 48usize];
    ["Offset of field: _PROPSHEETPAGEW::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pfnCallback) - 56usize];
    ["Offset of field: _PROPSHEETPAGEW::pcRefParent"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pcRefParent) - 64usize];
    ["Offset of field: _PROPSHEETPAGEW::pszHeaderTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pszHeaderTitle) - 72usize];
    ["Offset of field: _PROPSHEETPAGEW::pszHeaderSubTitle"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, pszHeaderSubTitle) - 80usize];
    ["Offset of field: _PROPSHEETPAGEW::hActCtx"]
        [::std::mem::offset_of!(_PROPSHEETPAGEW, hActCtx) - 88usize];
};
pub type PROPSHEETPAGEW_V4 = _PROPSHEETPAGEW;
pub type LPPROPSHEETPAGEW_V4 = *mut _PROPSHEETPAGEW;
pub type LPCPROPSHEETPAGEW_V4 = *const PROPSHEETPAGEW_V4;
pub type PROPSHEETPAGEA_LATEST = PROPSHEETPAGEA_V4;
pub type PROPSHEETPAGEW_LATEST = PROPSHEETPAGEW_V4;
pub type LPPROPSHEETPAGEA_LATEST = LPPROPSHEETPAGEA_V4;
pub type LPPROPSHEETPAGEW_LATEST = LPPROPSHEETPAGEW_V4;
pub type LPCPROPSHEETPAGEA_LATEST = LPCPROPSHEETPAGEA_V4;
pub type LPCPROPSHEETPAGEW_LATEST = LPCPROPSHEETPAGEW_V4;
pub type PROPSHEETPAGEA = PROPSHEETPAGEA_V4;
pub type PROPSHEETPAGEW = PROPSHEETPAGEW_V4;
pub type LPPROPSHEETPAGEA = LPPROPSHEETPAGEA_V4;
pub type LPPROPSHEETPAGEW = LPPROPSHEETPAGEW_V4;
pub type LPCPROPSHEETPAGEA = LPCPROPSHEETPAGEA_V4;
pub type LPCPROPSHEETPAGEW = LPCPROPSHEETPAGEW_V4;
pub type PFNPROPSHEETCALLBACK = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: LPARAM) -> ::std::os::raw::c_int,
>;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETHEADERA_V1 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hwndParent: HWND,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETHEADERA_V1__bindgen_ty_1,
    pub pszCaption: LPCSTR,
    pub nPages: UINT,
    pub __bindgen_anon_2: _PROPSHEETHEADERA_V1__bindgen_ty_2,
    pub __bindgen_anon_3: _PROPSHEETHEADERA_V1__bindgen_ty_3,
    pub pfnCallback: PFNPROPSHEETCALLBACK,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V1__bindgen_ty_1 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V1__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_1::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_1, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V1__bindgen_ty_2 {
    pub nStartPage: UINT,
    pub pStartPage: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V1__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V1__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V1__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_2::nStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_2, nStartPage) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_2::pStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_2, pStartPage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V1__bindgen_ty_3 {
    pub ppsp: LPCPROPSHEETPAGEA,
    pub phpage: *mut HPROPSHEETPAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V1__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V1__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V1__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V1__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_3::ppsp"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_3, ppsp) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V1__bindgen_ty_3::phpage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1__bindgen_ty_3, phpage) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V1"][::std::mem::size_of::<_PROPSHEETHEADERA_V1>() - 72usize];
    ["Alignment of _PROPSHEETHEADERA_V1"][::std::mem::align_of::<_PROPSHEETHEADERA_V1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::hwndParent"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, hwndParent) - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, hInstance) - 16usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::pszCaption"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, pszCaption) - 32usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::nPages"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, nPages) - 40usize];
    ["Offset of field: _PROPSHEETHEADERA_V1::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V1, pfnCallback) - 64usize];
};
pub type PROPSHEETHEADERA_V1 = _PROPSHEETHEADERA_V1;
pub type LPPROPSHEETHEADERA_V1 = *mut _PROPSHEETHEADERA_V1;
pub type LPCPROPSHEETHEADERA_V1 = *const PROPSHEETHEADERA_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETHEADERA_V2 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hwndParent: HWND,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETHEADERA_V2__bindgen_ty_1,
    pub pszCaption: LPCSTR,
    pub nPages: UINT,
    pub __bindgen_anon_2: _PROPSHEETHEADERA_V2__bindgen_ty_2,
    pub __bindgen_anon_3: _PROPSHEETHEADERA_V2__bindgen_ty_3,
    pub pfnCallback: PFNPROPSHEETCALLBACK,
    pub __bindgen_anon_4: _PROPSHEETHEADERA_V2__bindgen_ty_4,
    pub hplWatermark: HPALETTE,
    pub __bindgen_anon_5: _PROPSHEETHEADERA_V2__bindgen_ty_5,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V2__bindgen_ty_1 {
    pub hIcon: HICON,
    pub pszIcon: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V2__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V2__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V2__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_1::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_1, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V2__bindgen_ty_2 {
    pub nStartPage: UINT,
    pub pStartPage: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V2__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V2__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V2__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_2::nStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_2, nStartPage) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_2::pStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_2, pStartPage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V2__bindgen_ty_3 {
    pub ppsp: LPCPROPSHEETPAGEA,
    pub phpage: *mut HPROPSHEETPAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V2__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V2__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V2__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_3::ppsp"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_3, ppsp) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_3::phpage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_3, phpage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V2__bindgen_ty_4 {
    pub hbmWatermark: HBITMAP,
    pub pszbmWatermark: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2__bindgen_ty_4"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V2__bindgen_ty_4>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V2__bindgen_ty_4"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V2__bindgen_ty_4>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_4::hbmWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_4, hbmWatermark) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_4::pszbmWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_4, pszbmWatermark) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERA_V2__bindgen_ty_5 {
    pub hbmHeader: HBITMAP,
    pub pszbmHeader: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2__bindgen_ty_5"]
        [::std::mem::size_of::<_PROPSHEETHEADERA_V2__bindgen_ty_5>() - 8usize];
    ["Alignment of _PROPSHEETHEADERA_V2__bindgen_ty_5"]
        [::std::mem::align_of::<_PROPSHEETHEADERA_V2__bindgen_ty_5>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_5::hbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_5, hbmHeader) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2__bindgen_ty_5::pszbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2__bindgen_ty_5, pszbmHeader) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERA_V2"][::std::mem::size_of::<_PROPSHEETHEADERA_V2>() - 96usize];
    ["Alignment of _PROPSHEETHEADERA_V2"][::std::mem::align_of::<_PROPSHEETHEADERA_V2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::hwndParent"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, hwndParent) - 8usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, hInstance) - 16usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::pszCaption"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, pszCaption) - 32usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::nPages"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, nPages) - 40usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, pfnCallback) - 64usize];
    ["Offset of field: _PROPSHEETHEADERA_V2::hplWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERA_V2, hplWatermark) - 80usize];
};
pub type PROPSHEETHEADERA_V2 = _PROPSHEETHEADERA_V2;
pub type LPPROPSHEETHEADERA_V2 = *mut _PROPSHEETHEADERA_V2;
pub type LPCPROPSHEETHEADERA_V2 = *const PROPSHEETHEADERA_V2;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETHEADERW_V1 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hwndParent: HWND,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETHEADERW_V1__bindgen_ty_1,
    pub pszCaption: LPCWSTR,
    pub nPages: UINT,
    pub __bindgen_anon_2: _PROPSHEETHEADERW_V1__bindgen_ty_2,
    pub __bindgen_anon_3: _PROPSHEETHEADERW_V1__bindgen_ty_3,
    pub pfnCallback: PFNPROPSHEETCALLBACK,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V1__bindgen_ty_1 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V1__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V1__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V1__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_1::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_1, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V1__bindgen_ty_2 {
    pub nStartPage: UINT,
    pub pStartPage: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V1__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V1__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V1__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V1__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_2::nStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_2, nStartPage) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_2::pStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_2, pStartPage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V1__bindgen_ty_3 {
    pub ppsp: LPCPROPSHEETPAGEW,
    pub phpage: *mut HPROPSHEETPAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V1__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V1__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V1__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V1__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_3::ppsp"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_3, ppsp) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V1__bindgen_ty_3::phpage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1__bindgen_ty_3, phpage) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V1"][::std::mem::size_of::<_PROPSHEETHEADERW_V1>() - 72usize];
    ["Alignment of _PROPSHEETHEADERW_V1"][::std::mem::align_of::<_PROPSHEETHEADERW_V1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::hwndParent"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, hwndParent) - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, hInstance) - 16usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::pszCaption"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, pszCaption) - 32usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::nPages"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, nPages) - 40usize];
    ["Offset of field: _PROPSHEETHEADERW_V1::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V1, pfnCallback) - 64usize];
};
pub type PROPSHEETHEADERW_V1 = _PROPSHEETHEADERW_V1;
pub type LPPROPSHEETHEADERW_V1 = *mut _PROPSHEETHEADERW_V1;
pub type LPCPROPSHEETHEADERW_V1 = *const PROPSHEETHEADERW_V1;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PROPSHEETHEADERW_V2 {
    pub dwSize: DWORD,
    pub dwFlags: DWORD,
    pub hwndParent: HWND,
    pub hInstance: HINSTANCE,
    pub __bindgen_anon_1: _PROPSHEETHEADERW_V2__bindgen_ty_1,
    pub pszCaption: LPCWSTR,
    pub nPages: UINT,
    pub __bindgen_anon_2: _PROPSHEETHEADERW_V2__bindgen_ty_2,
    pub __bindgen_anon_3: _PROPSHEETHEADERW_V2__bindgen_ty_3,
    pub pfnCallback: PFNPROPSHEETCALLBACK,
    pub __bindgen_anon_4: _PROPSHEETHEADERW_V2__bindgen_ty_4,
    pub hplWatermark: HPALETTE,
    pub __bindgen_anon_5: _PROPSHEETHEADERW_V2__bindgen_ty_5,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V2__bindgen_ty_1 {
    pub hIcon: HICON,
    pub pszIcon: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2__bindgen_ty_1"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V2__bindgen_ty_1>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V2__bindgen_ty_1"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V2__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_1::hIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_1, hIcon) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_1::pszIcon"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_1, pszIcon) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V2__bindgen_ty_2 {
    pub nStartPage: UINT,
    pub pStartPage: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2__bindgen_ty_2"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V2__bindgen_ty_2>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V2__bindgen_ty_2"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V2__bindgen_ty_2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_2::nStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_2, nStartPage) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_2::pStartPage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_2, pStartPage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V2__bindgen_ty_3 {
    pub ppsp: LPCPROPSHEETPAGEW,
    pub phpage: *mut HPROPSHEETPAGE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2__bindgen_ty_3"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V2__bindgen_ty_3>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V2__bindgen_ty_3"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V2__bindgen_ty_3>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_3::ppsp"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_3, ppsp) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_3::phpage"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_3, phpage) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V2__bindgen_ty_4 {
    pub hbmWatermark: HBITMAP,
    pub pszbmWatermark: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2__bindgen_ty_4"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V2__bindgen_ty_4>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V2__bindgen_ty_4"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V2__bindgen_ty_4>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_4::hbmWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_4, hbmWatermark) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_4::pszbmWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_4, pszbmWatermark) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PROPSHEETHEADERW_V2__bindgen_ty_5 {
    pub hbmHeader: HBITMAP,
    pub pszbmHeader: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2__bindgen_ty_5"]
        [::std::mem::size_of::<_PROPSHEETHEADERW_V2__bindgen_ty_5>() - 8usize];
    ["Alignment of _PROPSHEETHEADERW_V2__bindgen_ty_5"]
        [::std::mem::align_of::<_PROPSHEETHEADERW_V2__bindgen_ty_5>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_5::hbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_5, hbmHeader) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2__bindgen_ty_5::pszbmHeader"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2__bindgen_ty_5, pszbmHeader) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROPSHEETHEADERW_V2"][::std::mem::size_of::<_PROPSHEETHEADERW_V2>() - 96usize];
    ["Alignment of _PROPSHEETHEADERW_V2"][::std::mem::align_of::<_PROPSHEETHEADERW_V2>() - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::dwSize"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, dwSize) - 0usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::dwFlags"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, dwFlags) - 4usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::hwndParent"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, hwndParent) - 8usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::hInstance"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, hInstance) - 16usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::pszCaption"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, pszCaption) - 32usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::nPages"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, nPages) - 40usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::pfnCallback"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, pfnCallback) - 64usize];
    ["Offset of field: _PROPSHEETHEADERW_V2::hplWatermark"]
        [::std::mem::offset_of!(_PROPSHEETHEADERW_V2, hplWatermark) - 80usize];
};
pub type PROPSHEETHEADERW_V2 = _PROPSHEETHEADERW_V2;
pub type LPPROPSHEETHEADERW_V2 = *mut _PROPSHEETHEADERW_V2;
pub type LPCPROPSHEETHEADERW_V2 = *const PROPSHEETHEADERW_V2;
pub type PROPSHEETHEADERA = PROPSHEETHEADERA_V2;
pub type PROPSHEETHEADERW = PROPSHEETHEADERW_V2;
pub type LPPROPSHEETHEADERA = LPPROPSHEETHEADERA_V2;
pub type LPPROPSHEETHEADERW = LPPROPSHEETHEADERW_V2;
pub type LPCPROPSHEETHEADERA = LPCPROPSHEETHEADERA_V2;
pub type LPCPROPSHEETHEADERW = LPCPROPSHEETHEADERW_V2;
unsafe extern "C" {
    pub fn CreatePropertySheetPageA(constPropSheetPagePointer: LPCPROPSHEETPAGEA)
        -> HPROPSHEETPAGE;
}
unsafe extern "C" {
    pub fn CreatePropertySheetPageW(constPropSheetPagePointer: LPCPROPSHEETPAGEW)
        -> HPROPSHEETPAGE;
}
unsafe extern "C" {
    pub fn DestroyPropertySheetPage(arg1: HPROPSHEETPAGE) -> BOOL;
}
unsafe extern "C" {
    pub fn PropertySheetA(arg1: LPCPROPSHEETHEADERA) -> INT_PTR;
}
unsafe extern "C" {
    pub fn PropertySheetW(arg1: LPCPROPSHEETHEADERW) -> INT_PTR;
}
pub type LPFNADDPROPSHEETPAGE =
    ::std::option::Option<unsafe extern "C" fn(arg1: HPROPSHEETPAGE, arg2: LPARAM) -> BOOL>;
pub type LPFNADDPROPSHEETPAGES = ::std::option::Option<
    unsafe extern "C" fn(arg1: LPVOID, arg2: LPFNADDPROPSHEETPAGE, arg3: LPARAM) -> BOOL,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PSHNOTIFY {
    pub hdr: NMHDR,
    pub lParam: LPARAM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PSHNOTIFY"][::std::mem::size_of::<_PSHNOTIFY>() - 32usize];
    ["Alignment of _PSHNOTIFY"][::std::mem::align_of::<_PSHNOTIFY>() - 8usize];
    ["Offset of field: _PSHNOTIFY::hdr"][::std::mem::offset_of!(_PSHNOTIFY, hdr) - 0usize];
    ["Offset of field: _PSHNOTIFY::lParam"][::std::mem::offset_of!(_PSHNOTIFY, lParam) - 24usize];
};
pub type PSHNOTIFY = _PSHNOTIFY;
pub type LPPSHNOTIFY = *mut _PSHNOTIFY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_1A {
    pub Flags: DWORD,
    pub pDescription: LPSTR,
    pub pName: LPSTR,
    pub pComment: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_1A"][::std::mem::size_of::<_PRINTER_INFO_1A>() - 32usize];
    ["Alignment of _PRINTER_INFO_1A"][::std::mem::align_of::<_PRINTER_INFO_1A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_1A::Flags"]
        [::std::mem::offset_of!(_PRINTER_INFO_1A, Flags) - 0usize];
    ["Offset of field: _PRINTER_INFO_1A::pDescription"]
        [::std::mem::offset_of!(_PRINTER_INFO_1A, pDescription) - 8usize];
    ["Offset of field: _PRINTER_INFO_1A::pName"]
        [::std::mem::offset_of!(_PRINTER_INFO_1A, pName) - 16usize];
    ["Offset of field: _PRINTER_INFO_1A::pComment"]
        [::std::mem::offset_of!(_PRINTER_INFO_1A, pComment) - 24usize];
};
pub type PRINTER_INFO_1A = _PRINTER_INFO_1A;
pub type PPRINTER_INFO_1A = *mut _PRINTER_INFO_1A;
pub type LPPRINTER_INFO_1A = *mut _PRINTER_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_1W {
    pub Flags: DWORD,
    pub pDescription: LPWSTR,
    pub pName: LPWSTR,
    pub pComment: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_1W"][::std::mem::size_of::<_PRINTER_INFO_1W>() - 32usize];
    ["Alignment of _PRINTER_INFO_1W"][::std::mem::align_of::<_PRINTER_INFO_1W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_1W::Flags"]
        [::std::mem::offset_of!(_PRINTER_INFO_1W, Flags) - 0usize];
    ["Offset of field: _PRINTER_INFO_1W::pDescription"]
        [::std::mem::offset_of!(_PRINTER_INFO_1W, pDescription) - 8usize];
    ["Offset of field: _PRINTER_INFO_1W::pName"]
        [::std::mem::offset_of!(_PRINTER_INFO_1W, pName) - 16usize];
    ["Offset of field: _PRINTER_INFO_1W::pComment"]
        [::std::mem::offset_of!(_PRINTER_INFO_1W, pComment) - 24usize];
};
pub type PRINTER_INFO_1W = _PRINTER_INFO_1W;
pub type PPRINTER_INFO_1W = *mut _PRINTER_INFO_1W;
pub type LPPRINTER_INFO_1W = *mut _PRINTER_INFO_1W;
pub type PRINTER_INFO_1 = PRINTER_INFO_1A;
pub type PPRINTER_INFO_1 = PPRINTER_INFO_1A;
pub type LPPRINTER_INFO_1 = LPPRINTER_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_2A {
    pub pServerName: LPSTR,
    pub pPrinterName: LPSTR,
    pub pShareName: LPSTR,
    pub pPortName: LPSTR,
    pub pDriverName: LPSTR,
    pub pComment: LPSTR,
    pub pLocation: LPSTR,
    pub pDevMode: LPDEVMODEA,
    pub pSepFile: LPSTR,
    pub pPrintProcessor: LPSTR,
    pub pDatatype: LPSTR,
    pub pParameters: LPSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Attributes: DWORD,
    pub Priority: DWORD,
    pub DefaultPriority: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub Status: DWORD,
    pub cJobs: DWORD,
    pub AveragePPM: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_2A"][::std::mem::size_of::<_PRINTER_INFO_2A>() - 136usize];
    ["Alignment of _PRINTER_INFO_2A"][::std::mem::align_of::<_PRINTER_INFO_2A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_2A::pServerName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pServerName) - 0usize];
    ["Offset of field: _PRINTER_INFO_2A::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pPrinterName) - 8usize];
    ["Offset of field: _PRINTER_INFO_2A::pShareName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pShareName) - 16usize];
    ["Offset of field: _PRINTER_INFO_2A::pPortName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pPortName) - 24usize];
    ["Offset of field: _PRINTER_INFO_2A::pDriverName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pDriverName) - 32usize];
    ["Offset of field: _PRINTER_INFO_2A::pComment"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pComment) - 40usize];
    ["Offset of field: _PRINTER_INFO_2A::pLocation"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pLocation) - 48usize];
    ["Offset of field: _PRINTER_INFO_2A::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pDevMode) - 56usize];
    ["Offset of field: _PRINTER_INFO_2A::pSepFile"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pSepFile) - 64usize];
    ["Offset of field: _PRINTER_INFO_2A::pPrintProcessor"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pPrintProcessor) - 72usize];
    ["Offset of field: _PRINTER_INFO_2A::pDatatype"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pDatatype) - 80usize];
    ["Offset of field: _PRINTER_INFO_2A::pParameters"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pParameters) - 88usize];
    ["Offset of field: _PRINTER_INFO_2A::pSecurityDescriptor"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, pSecurityDescriptor) - 96usize];
    ["Offset of field: _PRINTER_INFO_2A::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, Attributes) - 104usize];
    ["Offset of field: _PRINTER_INFO_2A::Priority"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, Priority) - 108usize];
    ["Offset of field: _PRINTER_INFO_2A::DefaultPriority"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, DefaultPriority) - 112usize];
    ["Offset of field: _PRINTER_INFO_2A::StartTime"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, StartTime) - 116usize];
    ["Offset of field: _PRINTER_INFO_2A::UntilTime"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, UntilTime) - 120usize];
    ["Offset of field: _PRINTER_INFO_2A::Status"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, Status) - 124usize];
    ["Offset of field: _PRINTER_INFO_2A::cJobs"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, cJobs) - 128usize];
    ["Offset of field: _PRINTER_INFO_2A::AveragePPM"]
        [::std::mem::offset_of!(_PRINTER_INFO_2A, AveragePPM) - 132usize];
};
pub type PRINTER_INFO_2A = _PRINTER_INFO_2A;
pub type PPRINTER_INFO_2A = *mut _PRINTER_INFO_2A;
pub type LPPRINTER_INFO_2A = *mut _PRINTER_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_2W {
    pub pServerName: LPWSTR,
    pub pPrinterName: LPWSTR,
    pub pShareName: LPWSTR,
    pub pPortName: LPWSTR,
    pub pDriverName: LPWSTR,
    pub pComment: LPWSTR,
    pub pLocation: LPWSTR,
    pub pDevMode: LPDEVMODEW,
    pub pSepFile: LPWSTR,
    pub pPrintProcessor: LPWSTR,
    pub pDatatype: LPWSTR,
    pub pParameters: LPWSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Attributes: DWORD,
    pub Priority: DWORD,
    pub DefaultPriority: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub Status: DWORD,
    pub cJobs: DWORD,
    pub AveragePPM: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_2W"][::std::mem::size_of::<_PRINTER_INFO_2W>() - 136usize];
    ["Alignment of _PRINTER_INFO_2W"][::std::mem::align_of::<_PRINTER_INFO_2W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_2W::pServerName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pServerName) - 0usize];
    ["Offset of field: _PRINTER_INFO_2W::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pPrinterName) - 8usize];
    ["Offset of field: _PRINTER_INFO_2W::pShareName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pShareName) - 16usize];
    ["Offset of field: _PRINTER_INFO_2W::pPortName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pPortName) - 24usize];
    ["Offset of field: _PRINTER_INFO_2W::pDriverName"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pDriverName) - 32usize];
    ["Offset of field: _PRINTER_INFO_2W::pComment"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pComment) - 40usize];
    ["Offset of field: _PRINTER_INFO_2W::pLocation"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pLocation) - 48usize];
    ["Offset of field: _PRINTER_INFO_2W::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pDevMode) - 56usize];
    ["Offset of field: _PRINTER_INFO_2W::pSepFile"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pSepFile) - 64usize];
    ["Offset of field: _PRINTER_INFO_2W::pPrintProcessor"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pPrintProcessor) - 72usize];
    ["Offset of field: _PRINTER_INFO_2W::pDatatype"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pDatatype) - 80usize];
    ["Offset of field: _PRINTER_INFO_2W::pParameters"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pParameters) - 88usize];
    ["Offset of field: _PRINTER_INFO_2W::pSecurityDescriptor"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, pSecurityDescriptor) - 96usize];
    ["Offset of field: _PRINTER_INFO_2W::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, Attributes) - 104usize];
    ["Offset of field: _PRINTER_INFO_2W::Priority"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, Priority) - 108usize];
    ["Offset of field: _PRINTER_INFO_2W::DefaultPriority"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, DefaultPriority) - 112usize];
    ["Offset of field: _PRINTER_INFO_2W::StartTime"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, StartTime) - 116usize];
    ["Offset of field: _PRINTER_INFO_2W::UntilTime"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, UntilTime) - 120usize];
    ["Offset of field: _PRINTER_INFO_2W::Status"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, Status) - 124usize];
    ["Offset of field: _PRINTER_INFO_2W::cJobs"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, cJobs) - 128usize];
    ["Offset of field: _PRINTER_INFO_2W::AveragePPM"]
        [::std::mem::offset_of!(_PRINTER_INFO_2W, AveragePPM) - 132usize];
};
pub type PRINTER_INFO_2W = _PRINTER_INFO_2W;
pub type PPRINTER_INFO_2W = *mut _PRINTER_INFO_2W;
pub type LPPRINTER_INFO_2W = *mut _PRINTER_INFO_2W;
pub type PRINTER_INFO_2 = PRINTER_INFO_2A;
pub type PPRINTER_INFO_2 = PPRINTER_INFO_2A;
pub type LPPRINTER_INFO_2 = LPPRINTER_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_3 {
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_3"][::std::mem::size_of::<_PRINTER_INFO_3>() - 8usize];
    ["Alignment of _PRINTER_INFO_3"][::std::mem::align_of::<_PRINTER_INFO_3>() - 8usize];
    ["Offset of field: _PRINTER_INFO_3::pSecurityDescriptor"]
        [::std::mem::offset_of!(_PRINTER_INFO_3, pSecurityDescriptor) - 0usize];
};
pub type PRINTER_INFO_3 = _PRINTER_INFO_3;
pub type PPRINTER_INFO_3 = *mut _PRINTER_INFO_3;
pub type LPPRINTER_INFO_3 = *mut _PRINTER_INFO_3;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_4A {
    pub pPrinterName: LPSTR,
    pub pServerName: LPSTR,
    pub Attributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_4A"][::std::mem::size_of::<_PRINTER_INFO_4A>() - 24usize];
    ["Alignment of _PRINTER_INFO_4A"][::std::mem::align_of::<_PRINTER_INFO_4A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_4A::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_4A, pPrinterName) - 0usize];
    ["Offset of field: _PRINTER_INFO_4A::pServerName"]
        [::std::mem::offset_of!(_PRINTER_INFO_4A, pServerName) - 8usize];
    ["Offset of field: _PRINTER_INFO_4A::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_4A, Attributes) - 16usize];
};
pub type PRINTER_INFO_4A = _PRINTER_INFO_4A;
pub type PPRINTER_INFO_4A = *mut _PRINTER_INFO_4A;
pub type LPPRINTER_INFO_4A = *mut _PRINTER_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_4W {
    pub pPrinterName: LPWSTR,
    pub pServerName: LPWSTR,
    pub Attributes: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_4W"][::std::mem::size_of::<_PRINTER_INFO_4W>() - 24usize];
    ["Alignment of _PRINTER_INFO_4W"][::std::mem::align_of::<_PRINTER_INFO_4W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_4W::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_4W, pPrinterName) - 0usize];
    ["Offset of field: _PRINTER_INFO_4W::pServerName"]
        [::std::mem::offset_of!(_PRINTER_INFO_4W, pServerName) - 8usize];
    ["Offset of field: _PRINTER_INFO_4W::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_4W, Attributes) - 16usize];
};
pub type PRINTER_INFO_4W = _PRINTER_INFO_4W;
pub type PPRINTER_INFO_4W = *mut _PRINTER_INFO_4W;
pub type LPPRINTER_INFO_4W = *mut _PRINTER_INFO_4W;
pub type PRINTER_INFO_4 = PRINTER_INFO_4A;
pub type PPRINTER_INFO_4 = PPRINTER_INFO_4A;
pub type LPPRINTER_INFO_4 = LPPRINTER_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_5A {
    pub pPrinterName: LPSTR,
    pub pPortName: LPSTR,
    pub Attributes: DWORD,
    pub DeviceNotSelectedTimeout: DWORD,
    pub TransmissionRetryTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_5A"][::std::mem::size_of::<_PRINTER_INFO_5A>() - 32usize];
    ["Alignment of _PRINTER_INFO_5A"][::std::mem::align_of::<_PRINTER_INFO_5A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_5A::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_5A, pPrinterName) - 0usize];
    ["Offset of field: _PRINTER_INFO_5A::pPortName"]
        [::std::mem::offset_of!(_PRINTER_INFO_5A, pPortName) - 8usize];
    ["Offset of field: _PRINTER_INFO_5A::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_5A, Attributes) - 16usize];
    ["Offset of field: _PRINTER_INFO_5A::DeviceNotSelectedTimeout"]
        [::std::mem::offset_of!(_PRINTER_INFO_5A, DeviceNotSelectedTimeout) - 20usize];
    ["Offset of field: _PRINTER_INFO_5A::TransmissionRetryTimeout"]
        [::std::mem::offset_of!(_PRINTER_INFO_5A, TransmissionRetryTimeout) - 24usize];
};
pub type PRINTER_INFO_5A = _PRINTER_INFO_5A;
pub type PPRINTER_INFO_5A = *mut _PRINTER_INFO_5A;
pub type LPPRINTER_INFO_5A = *mut _PRINTER_INFO_5A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_5W {
    pub pPrinterName: LPWSTR,
    pub pPortName: LPWSTR,
    pub Attributes: DWORD,
    pub DeviceNotSelectedTimeout: DWORD,
    pub TransmissionRetryTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_5W"][::std::mem::size_of::<_PRINTER_INFO_5W>() - 32usize];
    ["Alignment of _PRINTER_INFO_5W"][::std::mem::align_of::<_PRINTER_INFO_5W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_5W::pPrinterName"]
        [::std::mem::offset_of!(_PRINTER_INFO_5W, pPrinterName) - 0usize];
    ["Offset of field: _PRINTER_INFO_5W::pPortName"]
        [::std::mem::offset_of!(_PRINTER_INFO_5W, pPortName) - 8usize];
    ["Offset of field: _PRINTER_INFO_5W::Attributes"]
        [::std::mem::offset_of!(_PRINTER_INFO_5W, Attributes) - 16usize];
    ["Offset of field: _PRINTER_INFO_5W::DeviceNotSelectedTimeout"]
        [::std::mem::offset_of!(_PRINTER_INFO_5W, DeviceNotSelectedTimeout) - 20usize];
    ["Offset of field: _PRINTER_INFO_5W::TransmissionRetryTimeout"]
        [::std::mem::offset_of!(_PRINTER_INFO_5W, TransmissionRetryTimeout) - 24usize];
};
pub type PRINTER_INFO_5W = _PRINTER_INFO_5W;
pub type PPRINTER_INFO_5W = *mut _PRINTER_INFO_5W;
pub type LPPRINTER_INFO_5W = *mut _PRINTER_INFO_5W;
pub type PRINTER_INFO_5 = PRINTER_INFO_5A;
pub type PPRINTER_INFO_5 = PPRINTER_INFO_5A;
pub type LPPRINTER_INFO_5 = LPPRINTER_INFO_5A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_6 {
    pub dwStatus: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_6"][::std::mem::size_of::<_PRINTER_INFO_6>() - 4usize];
    ["Alignment of _PRINTER_INFO_6"][::std::mem::align_of::<_PRINTER_INFO_6>() - 4usize];
    ["Offset of field: _PRINTER_INFO_6::dwStatus"]
        [::std::mem::offset_of!(_PRINTER_INFO_6, dwStatus) - 0usize];
};
pub type PRINTER_INFO_6 = _PRINTER_INFO_6;
pub type PPRINTER_INFO_6 = *mut _PRINTER_INFO_6;
pub type LPPRINTER_INFO_6 = *mut _PRINTER_INFO_6;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_7A {
    pub pszObjectGUID: LPSTR,
    pub dwAction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_7A"][::std::mem::size_of::<_PRINTER_INFO_7A>() - 16usize];
    ["Alignment of _PRINTER_INFO_7A"][::std::mem::align_of::<_PRINTER_INFO_7A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_7A::pszObjectGUID"]
        [::std::mem::offset_of!(_PRINTER_INFO_7A, pszObjectGUID) - 0usize];
    ["Offset of field: _PRINTER_INFO_7A::dwAction"]
        [::std::mem::offset_of!(_PRINTER_INFO_7A, dwAction) - 8usize];
};
pub type PRINTER_INFO_7A = _PRINTER_INFO_7A;
pub type PPRINTER_INFO_7A = *mut _PRINTER_INFO_7A;
pub type LPPRINTER_INFO_7A = *mut _PRINTER_INFO_7A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_7W {
    pub pszObjectGUID: LPWSTR,
    pub dwAction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_7W"][::std::mem::size_of::<_PRINTER_INFO_7W>() - 16usize];
    ["Alignment of _PRINTER_INFO_7W"][::std::mem::align_of::<_PRINTER_INFO_7W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_7W::pszObjectGUID"]
        [::std::mem::offset_of!(_PRINTER_INFO_7W, pszObjectGUID) - 0usize];
    ["Offset of field: _PRINTER_INFO_7W::dwAction"]
        [::std::mem::offset_of!(_PRINTER_INFO_7W, dwAction) - 8usize];
};
pub type PRINTER_INFO_7W = _PRINTER_INFO_7W;
pub type PPRINTER_INFO_7W = *mut _PRINTER_INFO_7W;
pub type LPPRINTER_INFO_7W = *mut _PRINTER_INFO_7W;
pub type PRINTER_INFO_7 = PRINTER_INFO_7A;
pub type PPRINTER_INFO_7 = PPRINTER_INFO_7A;
pub type LPPRINTER_INFO_7 = LPPRINTER_INFO_7A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_8A {
    pub pDevMode: LPDEVMODEA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_8A"][::std::mem::size_of::<_PRINTER_INFO_8A>() - 8usize];
    ["Alignment of _PRINTER_INFO_8A"][::std::mem::align_of::<_PRINTER_INFO_8A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_8A::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_8A, pDevMode) - 0usize];
};
pub type PRINTER_INFO_8A = _PRINTER_INFO_8A;
pub type PPRINTER_INFO_8A = *mut _PRINTER_INFO_8A;
pub type LPPRINTER_INFO_8A = *mut _PRINTER_INFO_8A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_8W {
    pub pDevMode: LPDEVMODEW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_8W"][::std::mem::size_of::<_PRINTER_INFO_8W>() - 8usize];
    ["Alignment of _PRINTER_INFO_8W"][::std::mem::align_of::<_PRINTER_INFO_8W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_8W::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_8W, pDevMode) - 0usize];
};
pub type PRINTER_INFO_8W = _PRINTER_INFO_8W;
pub type PPRINTER_INFO_8W = *mut _PRINTER_INFO_8W;
pub type LPPRINTER_INFO_8W = *mut _PRINTER_INFO_8W;
pub type PRINTER_INFO_8 = PRINTER_INFO_8A;
pub type PPRINTER_INFO_8 = PPRINTER_INFO_8A;
pub type LPPRINTER_INFO_8 = LPPRINTER_INFO_8A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_9A {
    pub pDevMode: LPDEVMODEA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_9A"][::std::mem::size_of::<_PRINTER_INFO_9A>() - 8usize];
    ["Alignment of _PRINTER_INFO_9A"][::std::mem::align_of::<_PRINTER_INFO_9A>() - 8usize];
    ["Offset of field: _PRINTER_INFO_9A::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_9A, pDevMode) - 0usize];
};
pub type PRINTER_INFO_9A = _PRINTER_INFO_9A;
pub type PPRINTER_INFO_9A = *mut _PRINTER_INFO_9A;
pub type LPPRINTER_INFO_9A = *mut _PRINTER_INFO_9A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_INFO_9W {
    pub pDevMode: LPDEVMODEW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_INFO_9W"][::std::mem::size_of::<_PRINTER_INFO_9W>() - 8usize];
    ["Alignment of _PRINTER_INFO_9W"][::std::mem::align_of::<_PRINTER_INFO_9W>() - 8usize];
    ["Offset of field: _PRINTER_INFO_9W::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_INFO_9W, pDevMode) - 0usize];
};
pub type PRINTER_INFO_9W = _PRINTER_INFO_9W;
pub type PPRINTER_INFO_9W = *mut _PRINTER_INFO_9W;
pub type LPPRINTER_INFO_9W = *mut _PRINTER_INFO_9W;
pub type PRINTER_INFO_9 = PRINTER_INFO_9A;
pub type PPRINTER_INFO_9 = PPRINTER_INFO_9A;
pub type LPPRINTER_INFO_9 = LPPRINTER_INFO_9A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_1A {
    pub JobId: DWORD,
    pub pPrinterName: LPSTR,
    pub pMachineName: LPSTR,
    pub pUserName: LPSTR,
    pub pDocument: LPSTR,
    pub pDatatype: LPSTR,
    pub pStatus: LPSTR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub TotalPages: DWORD,
    pub PagesPrinted: DWORD,
    pub Submitted: SYSTEMTIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_1A"][::std::mem::size_of::<_JOB_INFO_1A>() - 96usize];
    ["Alignment of _JOB_INFO_1A"][::std::mem::align_of::<_JOB_INFO_1A>() - 8usize];
    ["Offset of field: _JOB_INFO_1A::JobId"][::std::mem::offset_of!(_JOB_INFO_1A, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_1A::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_1A::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_1A::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_1A::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_1A::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pDatatype) - 40usize];
    ["Offset of field: _JOB_INFO_1A::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_1A, pStatus) - 48usize];
    ["Offset of field: _JOB_INFO_1A::Status"]
        [::std::mem::offset_of!(_JOB_INFO_1A, Status) - 56usize];
    ["Offset of field: _JOB_INFO_1A::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_1A, Priority) - 60usize];
    ["Offset of field: _JOB_INFO_1A::Position"]
        [::std::mem::offset_of!(_JOB_INFO_1A, Position) - 64usize];
    ["Offset of field: _JOB_INFO_1A::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_1A, TotalPages) - 68usize];
    ["Offset of field: _JOB_INFO_1A::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_1A, PagesPrinted) - 72usize];
    ["Offset of field: _JOB_INFO_1A::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_1A, Submitted) - 76usize];
};
pub type JOB_INFO_1A = _JOB_INFO_1A;
pub type PJOB_INFO_1A = *mut _JOB_INFO_1A;
pub type LPJOB_INFO_1A = *mut _JOB_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_1W {
    pub JobId: DWORD,
    pub pPrinterName: LPWSTR,
    pub pMachineName: LPWSTR,
    pub pUserName: LPWSTR,
    pub pDocument: LPWSTR,
    pub pDatatype: LPWSTR,
    pub pStatus: LPWSTR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub TotalPages: DWORD,
    pub PagesPrinted: DWORD,
    pub Submitted: SYSTEMTIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_1W"][::std::mem::size_of::<_JOB_INFO_1W>() - 96usize];
    ["Alignment of _JOB_INFO_1W"][::std::mem::align_of::<_JOB_INFO_1W>() - 8usize];
    ["Offset of field: _JOB_INFO_1W::JobId"][::std::mem::offset_of!(_JOB_INFO_1W, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_1W::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_1W::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_1W::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_1W::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_1W::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pDatatype) - 40usize];
    ["Offset of field: _JOB_INFO_1W::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_1W, pStatus) - 48usize];
    ["Offset of field: _JOB_INFO_1W::Status"]
        [::std::mem::offset_of!(_JOB_INFO_1W, Status) - 56usize];
    ["Offset of field: _JOB_INFO_1W::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_1W, Priority) - 60usize];
    ["Offset of field: _JOB_INFO_1W::Position"]
        [::std::mem::offset_of!(_JOB_INFO_1W, Position) - 64usize];
    ["Offset of field: _JOB_INFO_1W::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_1W, TotalPages) - 68usize];
    ["Offset of field: _JOB_INFO_1W::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_1W, PagesPrinted) - 72usize];
    ["Offset of field: _JOB_INFO_1W::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_1W, Submitted) - 76usize];
};
pub type JOB_INFO_1W = _JOB_INFO_1W;
pub type PJOB_INFO_1W = *mut _JOB_INFO_1W;
pub type LPJOB_INFO_1W = *mut _JOB_INFO_1W;
pub type JOB_INFO_1 = JOB_INFO_1A;
pub type PJOB_INFO_1 = PJOB_INFO_1A;
pub type LPJOB_INFO_1 = LPJOB_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_2A {
    pub JobId: DWORD,
    pub pPrinterName: LPSTR,
    pub pMachineName: LPSTR,
    pub pUserName: LPSTR,
    pub pDocument: LPSTR,
    pub pNotifyName: LPSTR,
    pub pDatatype: LPSTR,
    pub pPrintProcessor: LPSTR,
    pub pParameters: LPSTR,
    pub pDriverName: LPSTR,
    pub pDevMode: LPDEVMODEA,
    pub pStatus: LPSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub TotalPages: DWORD,
    pub Size: DWORD,
    pub Submitted: SYSTEMTIME,
    pub Time: DWORD,
    pub PagesPrinted: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_2A"][::std::mem::size_of::<_JOB_INFO_2A>() - 160usize];
    ["Alignment of _JOB_INFO_2A"][::std::mem::align_of::<_JOB_INFO_2A>() - 8usize];
    ["Offset of field: _JOB_INFO_2A::JobId"][::std::mem::offset_of!(_JOB_INFO_2A, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_2A::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_2A::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_2A::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_2A::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_2A::pNotifyName"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pNotifyName) - 40usize];
    ["Offset of field: _JOB_INFO_2A::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pDatatype) - 48usize];
    ["Offset of field: _JOB_INFO_2A::pPrintProcessor"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pPrintProcessor) - 56usize];
    ["Offset of field: _JOB_INFO_2A::pParameters"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pParameters) - 64usize];
    ["Offset of field: _JOB_INFO_2A::pDriverName"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pDriverName) - 72usize];
    ["Offset of field: _JOB_INFO_2A::pDevMode"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pDevMode) - 80usize];
    ["Offset of field: _JOB_INFO_2A::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pStatus) - 88usize];
    ["Offset of field: _JOB_INFO_2A::pSecurityDescriptor"]
        [::std::mem::offset_of!(_JOB_INFO_2A, pSecurityDescriptor) - 96usize];
    ["Offset of field: _JOB_INFO_2A::Status"]
        [::std::mem::offset_of!(_JOB_INFO_2A, Status) - 104usize];
    ["Offset of field: _JOB_INFO_2A::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_2A, Priority) - 108usize];
    ["Offset of field: _JOB_INFO_2A::Position"]
        [::std::mem::offset_of!(_JOB_INFO_2A, Position) - 112usize];
    ["Offset of field: _JOB_INFO_2A::StartTime"]
        [::std::mem::offset_of!(_JOB_INFO_2A, StartTime) - 116usize];
    ["Offset of field: _JOB_INFO_2A::UntilTime"]
        [::std::mem::offset_of!(_JOB_INFO_2A, UntilTime) - 120usize];
    ["Offset of field: _JOB_INFO_2A::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_2A, TotalPages) - 124usize];
    ["Offset of field: _JOB_INFO_2A::Size"][::std::mem::offset_of!(_JOB_INFO_2A, Size) - 128usize];
    ["Offset of field: _JOB_INFO_2A::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_2A, Submitted) - 132usize];
    ["Offset of field: _JOB_INFO_2A::Time"][::std::mem::offset_of!(_JOB_INFO_2A, Time) - 148usize];
    ["Offset of field: _JOB_INFO_2A::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_2A, PagesPrinted) - 152usize];
};
pub type JOB_INFO_2A = _JOB_INFO_2A;
pub type PJOB_INFO_2A = *mut _JOB_INFO_2A;
pub type LPJOB_INFO_2A = *mut _JOB_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_2W {
    pub JobId: DWORD,
    pub pPrinterName: LPWSTR,
    pub pMachineName: LPWSTR,
    pub pUserName: LPWSTR,
    pub pDocument: LPWSTR,
    pub pNotifyName: LPWSTR,
    pub pDatatype: LPWSTR,
    pub pPrintProcessor: LPWSTR,
    pub pParameters: LPWSTR,
    pub pDriverName: LPWSTR,
    pub pDevMode: LPDEVMODEW,
    pub pStatus: LPWSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub TotalPages: DWORD,
    pub Size: DWORD,
    pub Submitted: SYSTEMTIME,
    pub Time: DWORD,
    pub PagesPrinted: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_2W"][::std::mem::size_of::<_JOB_INFO_2W>() - 160usize];
    ["Alignment of _JOB_INFO_2W"][::std::mem::align_of::<_JOB_INFO_2W>() - 8usize];
    ["Offset of field: _JOB_INFO_2W::JobId"][::std::mem::offset_of!(_JOB_INFO_2W, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_2W::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_2W::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_2W::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_2W::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_2W::pNotifyName"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pNotifyName) - 40usize];
    ["Offset of field: _JOB_INFO_2W::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pDatatype) - 48usize];
    ["Offset of field: _JOB_INFO_2W::pPrintProcessor"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pPrintProcessor) - 56usize];
    ["Offset of field: _JOB_INFO_2W::pParameters"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pParameters) - 64usize];
    ["Offset of field: _JOB_INFO_2W::pDriverName"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pDriverName) - 72usize];
    ["Offset of field: _JOB_INFO_2W::pDevMode"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pDevMode) - 80usize];
    ["Offset of field: _JOB_INFO_2W::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pStatus) - 88usize];
    ["Offset of field: _JOB_INFO_2W::pSecurityDescriptor"]
        [::std::mem::offset_of!(_JOB_INFO_2W, pSecurityDescriptor) - 96usize];
    ["Offset of field: _JOB_INFO_2W::Status"]
        [::std::mem::offset_of!(_JOB_INFO_2W, Status) - 104usize];
    ["Offset of field: _JOB_INFO_2W::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_2W, Priority) - 108usize];
    ["Offset of field: _JOB_INFO_2W::Position"]
        [::std::mem::offset_of!(_JOB_INFO_2W, Position) - 112usize];
    ["Offset of field: _JOB_INFO_2W::StartTime"]
        [::std::mem::offset_of!(_JOB_INFO_2W, StartTime) - 116usize];
    ["Offset of field: _JOB_INFO_2W::UntilTime"]
        [::std::mem::offset_of!(_JOB_INFO_2W, UntilTime) - 120usize];
    ["Offset of field: _JOB_INFO_2W::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_2W, TotalPages) - 124usize];
    ["Offset of field: _JOB_INFO_2W::Size"][::std::mem::offset_of!(_JOB_INFO_2W, Size) - 128usize];
    ["Offset of field: _JOB_INFO_2W::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_2W, Submitted) - 132usize];
    ["Offset of field: _JOB_INFO_2W::Time"][::std::mem::offset_of!(_JOB_INFO_2W, Time) - 148usize];
    ["Offset of field: _JOB_INFO_2W::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_2W, PagesPrinted) - 152usize];
};
pub type JOB_INFO_2W = _JOB_INFO_2W;
pub type PJOB_INFO_2W = *mut _JOB_INFO_2W;
pub type LPJOB_INFO_2W = *mut _JOB_INFO_2W;
pub type JOB_INFO_2 = JOB_INFO_2A;
pub type PJOB_INFO_2 = PJOB_INFO_2A;
pub type LPJOB_INFO_2 = LPJOB_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_3 {
    pub JobId: DWORD,
    pub NextJobId: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_3"][::std::mem::size_of::<_JOB_INFO_3>() - 12usize];
    ["Alignment of _JOB_INFO_3"][::std::mem::align_of::<_JOB_INFO_3>() - 4usize];
    ["Offset of field: _JOB_INFO_3::JobId"][::std::mem::offset_of!(_JOB_INFO_3, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_3::NextJobId"]
        [::std::mem::offset_of!(_JOB_INFO_3, NextJobId) - 4usize];
    ["Offset of field: _JOB_INFO_3::Reserved"]
        [::std::mem::offset_of!(_JOB_INFO_3, Reserved) - 8usize];
};
pub type JOB_INFO_3 = _JOB_INFO_3;
pub type PJOB_INFO_3 = *mut _JOB_INFO_3;
pub type LPJOB_INFO_3 = *mut _JOB_INFO_3;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_4A {
    pub JobId: DWORD,
    pub pPrinterName: LPSTR,
    pub pMachineName: LPSTR,
    pub pUserName: LPSTR,
    pub pDocument: LPSTR,
    pub pNotifyName: LPSTR,
    pub pDatatype: LPSTR,
    pub pPrintProcessor: LPSTR,
    pub pParameters: LPSTR,
    pub pDriverName: LPSTR,
    pub pDevMode: LPDEVMODEA,
    pub pStatus: LPSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub TotalPages: DWORD,
    pub Size: DWORD,
    pub Submitted: SYSTEMTIME,
    pub Time: DWORD,
    pub PagesPrinted: DWORD,
    pub SizeHigh: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_4A"][::std::mem::size_of::<_JOB_INFO_4A>() - 160usize];
    ["Alignment of _JOB_INFO_4A"][::std::mem::align_of::<_JOB_INFO_4A>() - 8usize];
    ["Offset of field: _JOB_INFO_4A::JobId"][::std::mem::offset_of!(_JOB_INFO_4A, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_4A::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_4A::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_4A::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_4A::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_4A::pNotifyName"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pNotifyName) - 40usize];
    ["Offset of field: _JOB_INFO_4A::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pDatatype) - 48usize];
    ["Offset of field: _JOB_INFO_4A::pPrintProcessor"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pPrintProcessor) - 56usize];
    ["Offset of field: _JOB_INFO_4A::pParameters"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pParameters) - 64usize];
    ["Offset of field: _JOB_INFO_4A::pDriverName"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pDriverName) - 72usize];
    ["Offset of field: _JOB_INFO_4A::pDevMode"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pDevMode) - 80usize];
    ["Offset of field: _JOB_INFO_4A::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pStatus) - 88usize];
    ["Offset of field: _JOB_INFO_4A::pSecurityDescriptor"]
        [::std::mem::offset_of!(_JOB_INFO_4A, pSecurityDescriptor) - 96usize];
    ["Offset of field: _JOB_INFO_4A::Status"]
        [::std::mem::offset_of!(_JOB_INFO_4A, Status) - 104usize];
    ["Offset of field: _JOB_INFO_4A::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_4A, Priority) - 108usize];
    ["Offset of field: _JOB_INFO_4A::Position"]
        [::std::mem::offset_of!(_JOB_INFO_4A, Position) - 112usize];
    ["Offset of field: _JOB_INFO_4A::StartTime"]
        [::std::mem::offset_of!(_JOB_INFO_4A, StartTime) - 116usize];
    ["Offset of field: _JOB_INFO_4A::UntilTime"]
        [::std::mem::offset_of!(_JOB_INFO_4A, UntilTime) - 120usize];
    ["Offset of field: _JOB_INFO_4A::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_4A, TotalPages) - 124usize];
    ["Offset of field: _JOB_INFO_4A::Size"][::std::mem::offset_of!(_JOB_INFO_4A, Size) - 128usize];
    ["Offset of field: _JOB_INFO_4A::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_4A, Submitted) - 132usize];
    ["Offset of field: _JOB_INFO_4A::Time"][::std::mem::offset_of!(_JOB_INFO_4A, Time) - 148usize];
    ["Offset of field: _JOB_INFO_4A::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_4A, PagesPrinted) - 152usize];
    ["Offset of field: _JOB_INFO_4A::SizeHigh"]
        [::std::mem::offset_of!(_JOB_INFO_4A, SizeHigh) - 156usize];
};
pub type JOB_INFO_4A = _JOB_INFO_4A;
pub type PJOB_INFO_4A = *mut _JOB_INFO_4A;
pub type LPJOB_INFO_4A = *mut _JOB_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _JOB_INFO_4W {
    pub JobId: DWORD,
    pub pPrinterName: LPWSTR,
    pub pMachineName: LPWSTR,
    pub pUserName: LPWSTR,
    pub pDocument: LPWSTR,
    pub pNotifyName: LPWSTR,
    pub pDatatype: LPWSTR,
    pub pPrintProcessor: LPWSTR,
    pub pParameters: LPWSTR,
    pub pDriverName: LPWSTR,
    pub pDevMode: LPDEVMODEW,
    pub pStatus: LPWSTR,
    pub pSecurityDescriptor: PSECURITY_DESCRIPTOR,
    pub Status: DWORD,
    pub Priority: DWORD,
    pub Position: DWORD,
    pub StartTime: DWORD,
    pub UntilTime: DWORD,
    pub TotalPages: DWORD,
    pub Size: DWORD,
    pub Submitted: SYSTEMTIME,
    pub Time: DWORD,
    pub PagesPrinted: DWORD,
    pub SizeHigh: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _JOB_INFO_4W"][::std::mem::size_of::<_JOB_INFO_4W>() - 160usize];
    ["Alignment of _JOB_INFO_4W"][::std::mem::align_of::<_JOB_INFO_4W>() - 8usize];
    ["Offset of field: _JOB_INFO_4W::JobId"][::std::mem::offset_of!(_JOB_INFO_4W, JobId) - 0usize];
    ["Offset of field: _JOB_INFO_4W::pPrinterName"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pPrinterName) - 8usize];
    ["Offset of field: _JOB_INFO_4W::pMachineName"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pMachineName) - 16usize];
    ["Offset of field: _JOB_INFO_4W::pUserName"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pUserName) - 24usize];
    ["Offset of field: _JOB_INFO_4W::pDocument"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pDocument) - 32usize];
    ["Offset of field: _JOB_INFO_4W::pNotifyName"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pNotifyName) - 40usize];
    ["Offset of field: _JOB_INFO_4W::pDatatype"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pDatatype) - 48usize];
    ["Offset of field: _JOB_INFO_4W::pPrintProcessor"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pPrintProcessor) - 56usize];
    ["Offset of field: _JOB_INFO_4W::pParameters"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pParameters) - 64usize];
    ["Offset of field: _JOB_INFO_4W::pDriverName"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pDriverName) - 72usize];
    ["Offset of field: _JOB_INFO_4W::pDevMode"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pDevMode) - 80usize];
    ["Offset of field: _JOB_INFO_4W::pStatus"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pStatus) - 88usize];
    ["Offset of field: _JOB_INFO_4W::pSecurityDescriptor"]
        [::std::mem::offset_of!(_JOB_INFO_4W, pSecurityDescriptor) - 96usize];
    ["Offset of field: _JOB_INFO_4W::Status"]
        [::std::mem::offset_of!(_JOB_INFO_4W, Status) - 104usize];
    ["Offset of field: _JOB_INFO_4W::Priority"]
        [::std::mem::offset_of!(_JOB_INFO_4W, Priority) - 108usize];
    ["Offset of field: _JOB_INFO_4W::Position"]
        [::std::mem::offset_of!(_JOB_INFO_4W, Position) - 112usize];
    ["Offset of field: _JOB_INFO_4W::StartTime"]
        [::std::mem::offset_of!(_JOB_INFO_4W, StartTime) - 116usize];
    ["Offset of field: _JOB_INFO_4W::UntilTime"]
        [::std::mem::offset_of!(_JOB_INFO_4W, UntilTime) - 120usize];
    ["Offset of field: _JOB_INFO_4W::TotalPages"]
        [::std::mem::offset_of!(_JOB_INFO_4W, TotalPages) - 124usize];
    ["Offset of field: _JOB_INFO_4W::Size"][::std::mem::offset_of!(_JOB_INFO_4W, Size) - 128usize];
    ["Offset of field: _JOB_INFO_4W::Submitted"]
        [::std::mem::offset_of!(_JOB_INFO_4W, Submitted) - 132usize];
    ["Offset of field: _JOB_INFO_4W::Time"][::std::mem::offset_of!(_JOB_INFO_4W, Time) - 148usize];
    ["Offset of field: _JOB_INFO_4W::PagesPrinted"]
        [::std::mem::offset_of!(_JOB_INFO_4W, PagesPrinted) - 152usize];
    ["Offset of field: _JOB_INFO_4W::SizeHigh"]
        [::std::mem::offset_of!(_JOB_INFO_4W, SizeHigh) - 156usize];
};
pub type JOB_INFO_4W = _JOB_INFO_4W;
pub type PJOB_INFO_4W = *mut _JOB_INFO_4W;
pub type LPJOB_INFO_4W = *mut _JOB_INFO_4W;
pub type JOB_INFO_4 = JOB_INFO_4A;
pub type PJOB_INFO_4 = PJOB_INFO_4A;
pub type LPJOB_INFO_4 = LPJOB_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ADDJOB_INFO_1A {
    pub Path: LPSTR,
    pub JobId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ADDJOB_INFO_1A"][::std::mem::size_of::<_ADDJOB_INFO_1A>() - 16usize];
    ["Alignment of _ADDJOB_INFO_1A"][::std::mem::align_of::<_ADDJOB_INFO_1A>() - 8usize];
    ["Offset of field: _ADDJOB_INFO_1A::Path"]
        [::std::mem::offset_of!(_ADDJOB_INFO_1A, Path) - 0usize];
    ["Offset of field: _ADDJOB_INFO_1A::JobId"]
        [::std::mem::offset_of!(_ADDJOB_INFO_1A, JobId) - 8usize];
};
pub type ADDJOB_INFO_1A = _ADDJOB_INFO_1A;
pub type PADDJOB_INFO_1A = *mut _ADDJOB_INFO_1A;
pub type LPADDJOB_INFO_1A = *mut _ADDJOB_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ADDJOB_INFO_1W {
    pub Path: LPWSTR,
    pub JobId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ADDJOB_INFO_1W"][::std::mem::size_of::<_ADDJOB_INFO_1W>() - 16usize];
    ["Alignment of _ADDJOB_INFO_1W"][::std::mem::align_of::<_ADDJOB_INFO_1W>() - 8usize];
    ["Offset of field: _ADDJOB_INFO_1W::Path"]
        [::std::mem::offset_of!(_ADDJOB_INFO_1W, Path) - 0usize];
    ["Offset of field: _ADDJOB_INFO_1W::JobId"]
        [::std::mem::offset_of!(_ADDJOB_INFO_1W, JobId) - 8usize];
};
pub type ADDJOB_INFO_1W = _ADDJOB_INFO_1W;
pub type PADDJOB_INFO_1W = *mut _ADDJOB_INFO_1W;
pub type LPADDJOB_INFO_1W = *mut _ADDJOB_INFO_1W;
pub type ADDJOB_INFO_1 = ADDJOB_INFO_1A;
pub type PADDJOB_INFO_1 = PADDJOB_INFO_1A;
pub type LPADDJOB_INFO_1 = LPADDJOB_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_1A {
    pub pName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_1A"][::std::mem::size_of::<_DRIVER_INFO_1A>() - 8usize];
    ["Alignment of _DRIVER_INFO_1A"][::std::mem::align_of::<_DRIVER_INFO_1A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_1A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_1A, pName) - 0usize];
};
pub type DRIVER_INFO_1A = _DRIVER_INFO_1A;
pub type PDRIVER_INFO_1A = *mut _DRIVER_INFO_1A;
pub type LPDRIVER_INFO_1A = *mut _DRIVER_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_1W {
    pub pName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_1W"][::std::mem::size_of::<_DRIVER_INFO_1W>() - 8usize];
    ["Alignment of _DRIVER_INFO_1W"][::std::mem::align_of::<_DRIVER_INFO_1W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_1W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_1W, pName) - 0usize];
};
pub type DRIVER_INFO_1W = _DRIVER_INFO_1W;
pub type PDRIVER_INFO_1W = *mut _DRIVER_INFO_1W;
pub type LPDRIVER_INFO_1W = *mut _DRIVER_INFO_1W;
pub type DRIVER_INFO_1 = DRIVER_INFO_1A;
pub type PDRIVER_INFO_1 = PDRIVER_INFO_1A;
pub type LPDRIVER_INFO_1 = LPDRIVER_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_2A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_2A"][::std::mem::size_of::<_DRIVER_INFO_2A>() - 48usize];
    ["Alignment of _DRIVER_INFO_2A"][::std::mem::align_of::<_DRIVER_INFO_2A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_2A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_2A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_2A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_2A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_2A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_2A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_2A, pConfigFile) - 40usize];
};
pub type DRIVER_INFO_2A = _DRIVER_INFO_2A;
pub type PDRIVER_INFO_2A = *mut _DRIVER_INFO_2A;
pub type LPDRIVER_INFO_2A = *mut _DRIVER_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_2W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_2W"][::std::mem::size_of::<_DRIVER_INFO_2W>() - 48usize];
    ["Alignment of _DRIVER_INFO_2W"][::std::mem::align_of::<_DRIVER_INFO_2W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_2W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_2W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_2W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_2W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_2W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_2W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_2W, pConfigFile) - 40usize];
};
pub type DRIVER_INFO_2W = _DRIVER_INFO_2W;
pub type PDRIVER_INFO_2W = *mut _DRIVER_INFO_2W;
pub type LPDRIVER_INFO_2W = *mut _DRIVER_INFO_2W;
pub type DRIVER_INFO_2 = DRIVER_INFO_2A;
pub type PDRIVER_INFO_2 = PDRIVER_INFO_2A;
pub type LPDRIVER_INFO_2 = LPDRIVER_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_3A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
    pub pHelpFile: LPSTR,
    pub pDependentFiles: LPSTR,
    pub pMonitorName: LPSTR,
    pub pDefaultDataType: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_3A"][::std::mem::size_of::<_DRIVER_INFO_3A>() - 80usize];
    ["Alignment of _DRIVER_INFO_3A"][::std::mem::align_of::<_DRIVER_INFO_3A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_3A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_3A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_3A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_3A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_3A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_3A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_3A::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_3A::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_3A::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_3A::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_3A, pDefaultDataType) - 72usize];
};
pub type DRIVER_INFO_3A = _DRIVER_INFO_3A;
pub type PDRIVER_INFO_3A = *mut _DRIVER_INFO_3A;
pub type LPDRIVER_INFO_3A = *mut _DRIVER_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_3W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
    pub pHelpFile: LPWSTR,
    pub pDependentFiles: LPWSTR,
    pub pMonitorName: LPWSTR,
    pub pDefaultDataType: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_3W"][::std::mem::size_of::<_DRIVER_INFO_3W>() - 80usize];
    ["Alignment of _DRIVER_INFO_3W"][::std::mem::align_of::<_DRIVER_INFO_3W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_3W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_3W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_3W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_3W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_3W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_3W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_3W::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_3W::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_3W::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_3W::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_3W, pDefaultDataType) - 72usize];
};
pub type DRIVER_INFO_3W = _DRIVER_INFO_3W;
pub type PDRIVER_INFO_3W = *mut _DRIVER_INFO_3W;
pub type LPDRIVER_INFO_3W = *mut _DRIVER_INFO_3W;
pub type DRIVER_INFO_3 = DRIVER_INFO_3A;
pub type PDRIVER_INFO_3 = PDRIVER_INFO_3A;
pub type LPDRIVER_INFO_3 = LPDRIVER_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_4A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
    pub pHelpFile: LPSTR,
    pub pDependentFiles: LPSTR,
    pub pMonitorName: LPSTR,
    pub pDefaultDataType: LPSTR,
    pub pszzPreviousNames: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_4A"][::std::mem::size_of::<_DRIVER_INFO_4A>() - 88usize];
    ["Alignment of _DRIVER_INFO_4A"][::std::mem::align_of::<_DRIVER_INFO_4A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_4A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_4A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_4A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_4A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_4A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_4A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_4A::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_4A::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_4A::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_4A::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_4A::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_4A, pszzPreviousNames) - 80usize];
};
pub type DRIVER_INFO_4A = _DRIVER_INFO_4A;
pub type PDRIVER_INFO_4A = *mut _DRIVER_INFO_4A;
pub type LPDRIVER_INFO_4A = *mut _DRIVER_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_4W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
    pub pHelpFile: LPWSTR,
    pub pDependentFiles: LPWSTR,
    pub pMonitorName: LPWSTR,
    pub pDefaultDataType: LPWSTR,
    pub pszzPreviousNames: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_4W"][::std::mem::size_of::<_DRIVER_INFO_4W>() - 88usize];
    ["Alignment of _DRIVER_INFO_4W"][::std::mem::align_of::<_DRIVER_INFO_4W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_4W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_4W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_4W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_4W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_4W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_4W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_4W::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_4W::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_4W::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_4W::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_4W::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_4W, pszzPreviousNames) - 80usize];
};
pub type DRIVER_INFO_4W = _DRIVER_INFO_4W;
pub type PDRIVER_INFO_4W = *mut _DRIVER_INFO_4W;
pub type LPDRIVER_INFO_4W = *mut _DRIVER_INFO_4W;
pub type DRIVER_INFO_4 = DRIVER_INFO_4A;
pub type PDRIVER_INFO_4 = PDRIVER_INFO_4A;
pub type LPDRIVER_INFO_4 = LPDRIVER_INFO_4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_5A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
    pub dwDriverAttributes: DWORD,
    pub dwConfigVersion: DWORD,
    pub dwDriverVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_5A"][::std::mem::size_of::<_DRIVER_INFO_5A>() - 64usize];
    ["Alignment of _DRIVER_INFO_5A"][::std::mem::align_of::<_DRIVER_INFO_5A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_5A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_5A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_5A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_5A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_5A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_5A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_5A::dwDriverAttributes"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, dwDriverAttributes) - 48usize];
    ["Offset of field: _DRIVER_INFO_5A::dwConfigVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, dwConfigVersion) - 52usize];
    ["Offset of field: _DRIVER_INFO_5A::dwDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5A, dwDriverVersion) - 56usize];
};
pub type DRIVER_INFO_5A = _DRIVER_INFO_5A;
pub type PDRIVER_INFO_5A = *mut _DRIVER_INFO_5A;
pub type LPDRIVER_INFO_5A = *mut _DRIVER_INFO_5A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_5W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
    pub dwDriverAttributes: DWORD,
    pub dwConfigVersion: DWORD,
    pub dwDriverVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_5W"][::std::mem::size_of::<_DRIVER_INFO_5W>() - 64usize];
    ["Alignment of _DRIVER_INFO_5W"][::std::mem::align_of::<_DRIVER_INFO_5W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_5W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_5W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_5W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_5W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_5W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_5W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_5W::dwDriverAttributes"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, dwDriverAttributes) - 48usize];
    ["Offset of field: _DRIVER_INFO_5W::dwConfigVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, dwConfigVersion) - 52usize];
    ["Offset of field: _DRIVER_INFO_5W::dwDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_5W, dwDriverVersion) - 56usize];
};
pub type DRIVER_INFO_5W = _DRIVER_INFO_5W;
pub type PDRIVER_INFO_5W = *mut _DRIVER_INFO_5W;
pub type LPDRIVER_INFO_5W = *mut _DRIVER_INFO_5W;
pub type DRIVER_INFO_5 = DRIVER_INFO_5A;
pub type PDRIVER_INFO_5 = PDRIVER_INFO_5A;
pub type LPDRIVER_INFO_5 = LPDRIVER_INFO_5A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_6A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
    pub pHelpFile: LPSTR,
    pub pDependentFiles: LPSTR,
    pub pMonitorName: LPSTR,
    pub pDefaultDataType: LPSTR,
    pub pszzPreviousNames: LPSTR,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub pszMfgName: LPSTR,
    pub pszOEMUrl: LPSTR,
    pub pszHardwareID: LPSTR,
    pub pszProvider: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_6A"][::std::mem::size_of::<_DRIVER_INFO_6A>() - 136usize];
    ["Alignment of _DRIVER_INFO_6A"][::std::mem::align_of::<_DRIVER_INFO_6A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_6A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_6A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_6A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_6A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_6A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_6A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_6A::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_6A::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_6A::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_6A::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_6A::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pszzPreviousNames) - 80usize];
    ["Offset of field: _DRIVER_INFO_6A::ftDriverDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, ftDriverDate) - 88usize];
    ["Offset of field: _DRIVER_INFO_6A::dwlDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, dwlDriverVersion) - 96usize];
    ["Offset of field: _DRIVER_INFO_6A::pszMfgName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pszMfgName) - 104usize];
    ["Offset of field: _DRIVER_INFO_6A::pszOEMUrl"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pszOEMUrl) - 112usize];
    ["Offset of field: _DRIVER_INFO_6A::pszHardwareID"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pszHardwareID) - 120usize];
    ["Offset of field: _DRIVER_INFO_6A::pszProvider"]
        [::std::mem::offset_of!(_DRIVER_INFO_6A, pszProvider) - 128usize];
};
pub type DRIVER_INFO_6A = _DRIVER_INFO_6A;
pub type PDRIVER_INFO_6A = *mut _DRIVER_INFO_6A;
pub type LPDRIVER_INFO_6A = *mut _DRIVER_INFO_6A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_6W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
    pub pHelpFile: LPWSTR,
    pub pDependentFiles: LPWSTR,
    pub pMonitorName: LPWSTR,
    pub pDefaultDataType: LPWSTR,
    pub pszzPreviousNames: LPWSTR,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub pszMfgName: LPWSTR,
    pub pszOEMUrl: LPWSTR,
    pub pszHardwareID: LPWSTR,
    pub pszProvider: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_6W"][::std::mem::size_of::<_DRIVER_INFO_6W>() - 136usize];
    ["Alignment of _DRIVER_INFO_6W"][::std::mem::align_of::<_DRIVER_INFO_6W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_6W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_6W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_6W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_6W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_6W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_6W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_6W::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_6W::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_6W::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_6W::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_6W::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pszzPreviousNames) - 80usize];
    ["Offset of field: _DRIVER_INFO_6W::ftDriverDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, ftDriverDate) - 88usize];
    ["Offset of field: _DRIVER_INFO_6W::dwlDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, dwlDriverVersion) - 96usize];
    ["Offset of field: _DRIVER_INFO_6W::pszMfgName"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pszMfgName) - 104usize];
    ["Offset of field: _DRIVER_INFO_6W::pszOEMUrl"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pszOEMUrl) - 112usize];
    ["Offset of field: _DRIVER_INFO_6W::pszHardwareID"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pszHardwareID) - 120usize];
    ["Offset of field: _DRIVER_INFO_6W::pszProvider"]
        [::std::mem::offset_of!(_DRIVER_INFO_6W, pszProvider) - 128usize];
};
pub type DRIVER_INFO_6W = _DRIVER_INFO_6W;
pub type PDRIVER_INFO_6W = *mut _DRIVER_INFO_6W;
pub type LPDRIVER_INFO_6W = *mut _DRIVER_INFO_6W;
pub type DRIVER_INFO_6 = DRIVER_INFO_6A;
pub type PDRIVER_INFO_6 = PDRIVER_INFO_6A;
pub type LPDRIVER_INFO_6 = LPDRIVER_INFO_6A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_8A {
    pub cVersion: DWORD,
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDriverPath: LPSTR,
    pub pDataFile: LPSTR,
    pub pConfigFile: LPSTR,
    pub pHelpFile: LPSTR,
    pub pDependentFiles: LPSTR,
    pub pMonitorName: LPSTR,
    pub pDefaultDataType: LPSTR,
    pub pszzPreviousNames: LPSTR,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub pszMfgName: LPSTR,
    pub pszOEMUrl: LPSTR,
    pub pszHardwareID: LPSTR,
    pub pszProvider: LPSTR,
    pub pszPrintProcessor: LPSTR,
    pub pszVendorSetup: LPSTR,
    pub pszzColorProfiles: LPSTR,
    pub pszInfPath: LPSTR,
    pub dwPrinterDriverAttributes: DWORD,
    pub pszzCoreDriverDependencies: LPSTR,
    pub ftMinInboxDriverVerDate: FILETIME,
    pub dwlMinInboxDriverVerVersion: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_8A"][::std::mem::size_of::<_DRIVER_INFO_8A>() - 200usize];
    ["Alignment of _DRIVER_INFO_8A"][::std::mem::align_of::<_DRIVER_INFO_8A>() - 8usize];
    ["Offset of field: _DRIVER_INFO_8A::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_8A::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_8A::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_8A::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_8A::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_8A::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_8A::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_8A::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_8A::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_8A::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_8A::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszzPreviousNames) - 80usize];
    ["Offset of field: _DRIVER_INFO_8A::ftDriverDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, ftDriverDate) - 88usize];
    ["Offset of field: _DRIVER_INFO_8A::dwlDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, dwlDriverVersion) - 96usize];
    ["Offset of field: _DRIVER_INFO_8A::pszMfgName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszMfgName) - 104usize];
    ["Offset of field: _DRIVER_INFO_8A::pszOEMUrl"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszOEMUrl) - 112usize];
    ["Offset of field: _DRIVER_INFO_8A::pszHardwareID"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszHardwareID) - 120usize];
    ["Offset of field: _DRIVER_INFO_8A::pszProvider"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszProvider) - 128usize];
    ["Offset of field: _DRIVER_INFO_8A::pszPrintProcessor"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszPrintProcessor) - 136usize];
    ["Offset of field: _DRIVER_INFO_8A::pszVendorSetup"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszVendorSetup) - 144usize];
    ["Offset of field: _DRIVER_INFO_8A::pszzColorProfiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszzColorProfiles) - 152usize];
    ["Offset of field: _DRIVER_INFO_8A::pszInfPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszInfPath) - 160usize];
    ["Offset of field: _DRIVER_INFO_8A::dwPrinterDriverAttributes"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, dwPrinterDriverAttributes) - 168usize];
    ["Offset of field: _DRIVER_INFO_8A::pszzCoreDriverDependencies"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, pszzCoreDriverDependencies) - 176usize];
    ["Offset of field: _DRIVER_INFO_8A::ftMinInboxDriverVerDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, ftMinInboxDriverVerDate) - 184usize];
    ["Offset of field: _DRIVER_INFO_8A::dwlMinInboxDriverVerVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8A, dwlMinInboxDriverVerVersion) - 192usize];
};
pub type DRIVER_INFO_8A = _DRIVER_INFO_8A;
pub type PDRIVER_INFO_8A = *mut _DRIVER_INFO_8A;
pub type LPDRIVER_INFO_8A = *mut _DRIVER_INFO_8A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DRIVER_INFO_8W {
    pub cVersion: DWORD,
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDriverPath: LPWSTR,
    pub pDataFile: LPWSTR,
    pub pConfigFile: LPWSTR,
    pub pHelpFile: LPWSTR,
    pub pDependentFiles: LPWSTR,
    pub pMonitorName: LPWSTR,
    pub pDefaultDataType: LPWSTR,
    pub pszzPreviousNames: LPWSTR,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub pszMfgName: LPWSTR,
    pub pszOEMUrl: LPWSTR,
    pub pszHardwareID: LPWSTR,
    pub pszProvider: LPWSTR,
    pub pszPrintProcessor: LPWSTR,
    pub pszVendorSetup: LPWSTR,
    pub pszzColorProfiles: LPWSTR,
    pub pszInfPath: LPWSTR,
    pub dwPrinterDriverAttributes: DWORD,
    pub pszzCoreDriverDependencies: LPWSTR,
    pub ftMinInboxDriverVerDate: FILETIME,
    pub dwlMinInboxDriverVerVersion: DWORDLONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DRIVER_INFO_8W"][::std::mem::size_of::<_DRIVER_INFO_8W>() - 200usize];
    ["Alignment of _DRIVER_INFO_8W"][::std::mem::align_of::<_DRIVER_INFO_8W>() - 8usize];
    ["Offset of field: _DRIVER_INFO_8W::cVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, cVersion) - 0usize];
    ["Offset of field: _DRIVER_INFO_8W::pName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pName) - 8usize];
    ["Offset of field: _DRIVER_INFO_8W::pEnvironment"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pEnvironment) - 16usize];
    ["Offset of field: _DRIVER_INFO_8W::pDriverPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pDriverPath) - 24usize];
    ["Offset of field: _DRIVER_INFO_8W::pDataFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pDataFile) - 32usize];
    ["Offset of field: _DRIVER_INFO_8W::pConfigFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pConfigFile) - 40usize];
    ["Offset of field: _DRIVER_INFO_8W::pHelpFile"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pHelpFile) - 48usize];
    ["Offset of field: _DRIVER_INFO_8W::pDependentFiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pDependentFiles) - 56usize];
    ["Offset of field: _DRIVER_INFO_8W::pMonitorName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pMonitorName) - 64usize];
    ["Offset of field: _DRIVER_INFO_8W::pDefaultDataType"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pDefaultDataType) - 72usize];
    ["Offset of field: _DRIVER_INFO_8W::pszzPreviousNames"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszzPreviousNames) - 80usize];
    ["Offset of field: _DRIVER_INFO_8W::ftDriverDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, ftDriverDate) - 88usize];
    ["Offset of field: _DRIVER_INFO_8W::dwlDriverVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, dwlDriverVersion) - 96usize];
    ["Offset of field: _DRIVER_INFO_8W::pszMfgName"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszMfgName) - 104usize];
    ["Offset of field: _DRIVER_INFO_8W::pszOEMUrl"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszOEMUrl) - 112usize];
    ["Offset of field: _DRIVER_INFO_8W::pszHardwareID"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszHardwareID) - 120usize];
    ["Offset of field: _DRIVER_INFO_8W::pszProvider"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszProvider) - 128usize];
    ["Offset of field: _DRIVER_INFO_8W::pszPrintProcessor"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszPrintProcessor) - 136usize];
    ["Offset of field: _DRIVER_INFO_8W::pszVendorSetup"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszVendorSetup) - 144usize];
    ["Offset of field: _DRIVER_INFO_8W::pszzColorProfiles"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszzColorProfiles) - 152usize];
    ["Offset of field: _DRIVER_INFO_8W::pszInfPath"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszInfPath) - 160usize];
    ["Offset of field: _DRIVER_INFO_8W::dwPrinterDriverAttributes"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, dwPrinterDriverAttributes) - 168usize];
    ["Offset of field: _DRIVER_INFO_8W::pszzCoreDriverDependencies"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, pszzCoreDriverDependencies) - 176usize];
    ["Offset of field: _DRIVER_INFO_8W::ftMinInboxDriverVerDate"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, ftMinInboxDriverVerDate) - 184usize];
    ["Offset of field: _DRIVER_INFO_8W::dwlMinInboxDriverVerVersion"]
        [::std::mem::offset_of!(_DRIVER_INFO_8W, dwlMinInboxDriverVerVersion) - 192usize];
};
pub type DRIVER_INFO_8W = _DRIVER_INFO_8W;
pub type PDRIVER_INFO_8W = *mut _DRIVER_INFO_8W;
pub type LPDRIVER_INFO_8W = *mut _DRIVER_INFO_8W;
pub type DRIVER_INFO_8 = DRIVER_INFO_8A;
pub type PDRIVER_INFO_8 = PDRIVER_INFO_8A;
pub type LPDRIVER_INFO_8 = LPDRIVER_INFO_8A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_1A {
    pub pDocName: LPSTR,
    pub pOutputFile: LPSTR,
    pub pDatatype: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_1A"][::std::mem::size_of::<_DOC_INFO_1A>() - 24usize];
    ["Alignment of _DOC_INFO_1A"][::std::mem::align_of::<_DOC_INFO_1A>() - 8usize];
    ["Offset of field: _DOC_INFO_1A::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_1A, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_1A::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_1A, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_1A::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_1A, pDatatype) - 16usize];
};
pub type DOC_INFO_1A = _DOC_INFO_1A;
pub type PDOC_INFO_1A = *mut _DOC_INFO_1A;
pub type LPDOC_INFO_1A = *mut _DOC_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_1W {
    pub pDocName: LPWSTR,
    pub pOutputFile: LPWSTR,
    pub pDatatype: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_1W"][::std::mem::size_of::<_DOC_INFO_1W>() - 24usize];
    ["Alignment of _DOC_INFO_1W"][::std::mem::align_of::<_DOC_INFO_1W>() - 8usize];
    ["Offset of field: _DOC_INFO_1W::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_1W, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_1W::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_1W, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_1W::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_1W, pDatatype) - 16usize];
};
pub type DOC_INFO_1W = _DOC_INFO_1W;
pub type PDOC_INFO_1W = *mut _DOC_INFO_1W;
pub type LPDOC_INFO_1W = *mut _DOC_INFO_1W;
pub type DOC_INFO_1 = DOC_INFO_1A;
pub type PDOC_INFO_1 = PDOC_INFO_1A;
pub type LPDOC_INFO_1 = LPDOC_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORM_INFO_1A {
    pub Flags: DWORD,
    pub pName: LPSTR,
    pub Size: SIZEL,
    pub ImageableArea: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORM_INFO_1A"][::std::mem::size_of::<_FORM_INFO_1A>() - 40usize];
    ["Alignment of _FORM_INFO_1A"][::std::mem::align_of::<_FORM_INFO_1A>() - 8usize];
    ["Offset of field: _FORM_INFO_1A::Flags"]
        [::std::mem::offset_of!(_FORM_INFO_1A, Flags) - 0usize];
    ["Offset of field: _FORM_INFO_1A::pName"]
        [::std::mem::offset_of!(_FORM_INFO_1A, pName) - 8usize];
    ["Offset of field: _FORM_INFO_1A::Size"][::std::mem::offset_of!(_FORM_INFO_1A, Size) - 16usize];
    ["Offset of field: _FORM_INFO_1A::ImageableArea"]
        [::std::mem::offset_of!(_FORM_INFO_1A, ImageableArea) - 24usize];
};
pub type FORM_INFO_1A = _FORM_INFO_1A;
pub type PFORM_INFO_1A = *mut _FORM_INFO_1A;
pub type LPFORM_INFO_1A = *mut _FORM_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORM_INFO_1W {
    pub Flags: DWORD,
    pub pName: LPWSTR,
    pub Size: SIZEL,
    pub ImageableArea: RECTL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORM_INFO_1W"][::std::mem::size_of::<_FORM_INFO_1W>() - 40usize];
    ["Alignment of _FORM_INFO_1W"][::std::mem::align_of::<_FORM_INFO_1W>() - 8usize];
    ["Offset of field: _FORM_INFO_1W::Flags"]
        [::std::mem::offset_of!(_FORM_INFO_1W, Flags) - 0usize];
    ["Offset of field: _FORM_INFO_1W::pName"]
        [::std::mem::offset_of!(_FORM_INFO_1W, pName) - 8usize];
    ["Offset of field: _FORM_INFO_1W::Size"][::std::mem::offset_of!(_FORM_INFO_1W, Size) - 16usize];
    ["Offset of field: _FORM_INFO_1W::ImageableArea"]
        [::std::mem::offset_of!(_FORM_INFO_1W, ImageableArea) - 24usize];
};
pub type FORM_INFO_1W = _FORM_INFO_1W;
pub type PFORM_INFO_1W = *mut _FORM_INFO_1W;
pub type LPFORM_INFO_1W = *mut _FORM_INFO_1W;
pub type FORM_INFO_1 = FORM_INFO_1A;
pub type PFORM_INFO_1 = PFORM_INFO_1A;
pub type LPFORM_INFO_1 = LPFORM_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORM_INFO_2A {
    pub Flags: DWORD,
    pub pName: LPCSTR,
    pub Size: SIZEL,
    pub ImageableArea: RECTL,
    pub pKeyword: LPCSTR,
    pub StringType: DWORD,
    pub pMuiDll: LPCSTR,
    pub dwResourceId: DWORD,
    pub pDisplayName: LPCSTR,
    pub wLangId: LANGID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORM_INFO_2A"][::std::mem::size_of::<_FORM_INFO_2A>() - 88usize];
    ["Alignment of _FORM_INFO_2A"][::std::mem::align_of::<_FORM_INFO_2A>() - 8usize];
    ["Offset of field: _FORM_INFO_2A::Flags"]
        [::std::mem::offset_of!(_FORM_INFO_2A, Flags) - 0usize];
    ["Offset of field: _FORM_INFO_2A::pName"]
        [::std::mem::offset_of!(_FORM_INFO_2A, pName) - 8usize];
    ["Offset of field: _FORM_INFO_2A::Size"][::std::mem::offset_of!(_FORM_INFO_2A, Size) - 16usize];
    ["Offset of field: _FORM_INFO_2A::ImageableArea"]
        [::std::mem::offset_of!(_FORM_INFO_2A, ImageableArea) - 24usize];
    ["Offset of field: _FORM_INFO_2A::pKeyword"]
        [::std::mem::offset_of!(_FORM_INFO_2A, pKeyword) - 40usize];
    ["Offset of field: _FORM_INFO_2A::StringType"]
        [::std::mem::offset_of!(_FORM_INFO_2A, StringType) - 48usize];
    ["Offset of field: _FORM_INFO_2A::pMuiDll"]
        [::std::mem::offset_of!(_FORM_INFO_2A, pMuiDll) - 56usize];
    ["Offset of field: _FORM_INFO_2A::dwResourceId"]
        [::std::mem::offset_of!(_FORM_INFO_2A, dwResourceId) - 64usize];
    ["Offset of field: _FORM_INFO_2A::pDisplayName"]
        [::std::mem::offset_of!(_FORM_INFO_2A, pDisplayName) - 72usize];
    ["Offset of field: _FORM_INFO_2A::wLangId"]
        [::std::mem::offset_of!(_FORM_INFO_2A, wLangId) - 80usize];
};
pub type FORM_INFO_2A = _FORM_INFO_2A;
pub type PFORM_INFO_2A = *mut _FORM_INFO_2A;
pub type LPFORM_INFO_2A = *mut _FORM_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _FORM_INFO_2W {
    pub Flags: DWORD,
    pub pName: LPCWSTR,
    pub Size: SIZEL,
    pub ImageableArea: RECTL,
    pub pKeyword: LPCSTR,
    pub StringType: DWORD,
    pub pMuiDll: LPCWSTR,
    pub dwResourceId: DWORD,
    pub pDisplayName: LPCWSTR,
    pub wLangId: LANGID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FORM_INFO_2W"][::std::mem::size_of::<_FORM_INFO_2W>() - 88usize];
    ["Alignment of _FORM_INFO_2W"][::std::mem::align_of::<_FORM_INFO_2W>() - 8usize];
    ["Offset of field: _FORM_INFO_2W::Flags"]
        [::std::mem::offset_of!(_FORM_INFO_2W, Flags) - 0usize];
    ["Offset of field: _FORM_INFO_2W::pName"]
        [::std::mem::offset_of!(_FORM_INFO_2W, pName) - 8usize];
    ["Offset of field: _FORM_INFO_2W::Size"][::std::mem::offset_of!(_FORM_INFO_2W, Size) - 16usize];
    ["Offset of field: _FORM_INFO_2W::ImageableArea"]
        [::std::mem::offset_of!(_FORM_INFO_2W, ImageableArea) - 24usize];
    ["Offset of field: _FORM_INFO_2W::pKeyword"]
        [::std::mem::offset_of!(_FORM_INFO_2W, pKeyword) - 40usize];
    ["Offset of field: _FORM_INFO_2W::StringType"]
        [::std::mem::offset_of!(_FORM_INFO_2W, StringType) - 48usize];
    ["Offset of field: _FORM_INFO_2W::pMuiDll"]
        [::std::mem::offset_of!(_FORM_INFO_2W, pMuiDll) - 56usize];
    ["Offset of field: _FORM_INFO_2W::dwResourceId"]
        [::std::mem::offset_of!(_FORM_INFO_2W, dwResourceId) - 64usize];
    ["Offset of field: _FORM_INFO_2W::pDisplayName"]
        [::std::mem::offset_of!(_FORM_INFO_2W, pDisplayName) - 72usize];
    ["Offset of field: _FORM_INFO_2W::wLangId"]
        [::std::mem::offset_of!(_FORM_INFO_2W, wLangId) - 80usize];
};
pub type FORM_INFO_2W = _FORM_INFO_2W;
pub type PFORM_INFO_2W = *mut _FORM_INFO_2W;
pub type LPFORM_INFO_2W = *mut _FORM_INFO_2W;
pub type FORM_INFO_2 = FORM_INFO_2A;
pub type PFORM_INFO_2 = PFORM_INFO_2A;
pub type LPFORM_INFO_2 = LPFORM_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_2A {
    pub pDocName: LPSTR,
    pub pOutputFile: LPSTR,
    pub pDatatype: LPSTR,
    pub dwMode: DWORD,
    pub JobId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_2A"][::std::mem::size_of::<_DOC_INFO_2A>() - 32usize];
    ["Alignment of _DOC_INFO_2A"][::std::mem::align_of::<_DOC_INFO_2A>() - 8usize];
    ["Offset of field: _DOC_INFO_2A::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_2A, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_2A::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_2A, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_2A::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_2A, pDatatype) - 16usize];
    ["Offset of field: _DOC_INFO_2A::dwMode"]
        [::std::mem::offset_of!(_DOC_INFO_2A, dwMode) - 24usize];
    ["Offset of field: _DOC_INFO_2A::JobId"][::std::mem::offset_of!(_DOC_INFO_2A, JobId) - 28usize];
};
pub type DOC_INFO_2A = _DOC_INFO_2A;
pub type PDOC_INFO_2A = *mut _DOC_INFO_2A;
pub type LPDOC_INFO_2A = *mut _DOC_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_2W {
    pub pDocName: LPWSTR,
    pub pOutputFile: LPWSTR,
    pub pDatatype: LPWSTR,
    pub dwMode: DWORD,
    pub JobId: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_2W"][::std::mem::size_of::<_DOC_INFO_2W>() - 32usize];
    ["Alignment of _DOC_INFO_2W"][::std::mem::align_of::<_DOC_INFO_2W>() - 8usize];
    ["Offset of field: _DOC_INFO_2W::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_2W, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_2W::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_2W, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_2W::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_2W, pDatatype) - 16usize];
    ["Offset of field: _DOC_INFO_2W::dwMode"]
        [::std::mem::offset_of!(_DOC_INFO_2W, dwMode) - 24usize];
    ["Offset of field: _DOC_INFO_2W::JobId"][::std::mem::offset_of!(_DOC_INFO_2W, JobId) - 28usize];
};
pub type DOC_INFO_2W = _DOC_INFO_2W;
pub type PDOC_INFO_2W = *mut _DOC_INFO_2W;
pub type LPDOC_INFO_2W = *mut _DOC_INFO_2W;
pub type DOC_INFO_2 = DOC_INFO_2A;
pub type PDOC_INFO_2 = PDOC_INFO_2A;
pub type LPDOC_INFO_2 = LPDOC_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_3A {
    pub pDocName: LPSTR,
    pub pOutputFile: LPSTR,
    pub pDatatype: LPSTR,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_3A"][::std::mem::size_of::<_DOC_INFO_3A>() - 32usize];
    ["Alignment of _DOC_INFO_3A"][::std::mem::align_of::<_DOC_INFO_3A>() - 8usize];
    ["Offset of field: _DOC_INFO_3A::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_3A, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_3A::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_3A, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_3A::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_3A, pDatatype) - 16usize];
    ["Offset of field: _DOC_INFO_3A::dwFlags"]
        [::std::mem::offset_of!(_DOC_INFO_3A, dwFlags) - 24usize];
};
pub type DOC_INFO_3A = _DOC_INFO_3A;
pub type PDOC_INFO_3A = *mut _DOC_INFO_3A;
pub type LPDOC_INFO_3A = *mut _DOC_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DOC_INFO_3W {
    pub pDocName: LPWSTR,
    pub pOutputFile: LPWSTR,
    pub pDatatype: LPWSTR,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DOC_INFO_3W"][::std::mem::size_of::<_DOC_INFO_3W>() - 32usize];
    ["Alignment of _DOC_INFO_3W"][::std::mem::align_of::<_DOC_INFO_3W>() - 8usize];
    ["Offset of field: _DOC_INFO_3W::pDocName"]
        [::std::mem::offset_of!(_DOC_INFO_3W, pDocName) - 0usize];
    ["Offset of field: _DOC_INFO_3W::pOutputFile"]
        [::std::mem::offset_of!(_DOC_INFO_3W, pOutputFile) - 8usize];
    ["Offset of field: _DOC_INFO_3W::pDatatype"]
        [::std::mem::offset_of!(_DOC_INFO_3W, pDatatype) - 16usize];
    ["Offset of field: _DOC_INFO_3W::dwFlags"]
        [::std::mem::offset_of!(_DOC_INFO_3W, dwFlags) - 24usize];
};
pub type DOC_INFO_3W = _DOC_INFO_3W;
pub type PDOC_INFO_3W = *mut _DOC_INFO_3W;
pub type LPDOC_INFO_3W = *mut _DOC_INFO_3W;
pub type DOC_INFO_3 = DOC_INFO_3A;
pub type PDOC_INFO_3 = PDOC_INFO_3A;
pub type LPDOC_INFO_3 = LPDOC_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTPROCESSOR_INFO_1A {
    pub pName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTPROCESSOR_INFO_1A"][::std::mem::size_of::<_PRINTPROCESSOR_INFO_1A>() - 8usize];
    ["Alignment of _PRINTPROCESSOR_INFO_1A"]
        [::std::mem::align_of::<_PRINTPROCESSOR_INFO_1A>() - 8usize];
    ["Offset of field: _PRINTPROCESSOR_INFO_1A::pName"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_INFO_1A, pName) - 0usize];
};
pub type PRINTPROCESSOR_INFO_1A = _PRINTPROCESSOR_INFO_1A;
pub type PPRINTPROCESSOR_INFO_1A = *mut _PRINTPROCESSOR_INFO_1A;
pub type LPPRINTPROCESSOR_INFO_1A = *mut _PRINTPROCESSOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTPROCESSOR_INFO_1W {
    pub pName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTPROCESSOR_INFO_1W"][::std::mem::size_of::<_PRINTPROCESSOR_INFO_1W>() - 8usize];
    ["Alignment of _PRINTPROCESSOR_INFO_1W"]
        [::std::mem::align_of::<_PRINTPROCESSOR_INFO_1W>() - 8usize];
    ["Offset of field: _PRINTPROCESSOR_INFO_1W::pName"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_INFO_1W, pName) - 0usize];
};
pub type PRINTPROCESSOR_INFO_1W = _PRINTPROCESSOR_INFO_1W;
pub type PPRINTPROCESSOR_INFO_1W = *mut _PRINTPROCESSOR_INFO_1W;
pub type LPPRINTPROCESSOR_INFO_1W = *mut _PRINTPROCESSOR_INFO_1W;
pub type PRINTPROCESSOR_INFO_1 = PRINTPROCESSOR_INFO_1A;
pub type PPRINTPROCESSOR_INFO_1 = PPRINTPROCESSOR_INFO_1A;
pub type LPPRINTPROCESSOR_INFO_1 = LPPRINTPROCESSOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTPROCESSOR_CAPS_1 {
    pub dwLevel: DWORD,
    pub dwNupOptions: DWORD,
    pub dwPageOrderFlags: DWORD,
    pub dwNumberOfCopies: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTPROCESSOR_CAPS_1"][::std::mem::size_of::<_PRINTPROCESSOR_CAPS_1>() - 16usize];
    ["Alignment of _PRINTPROCESSOR_CAPS_1"]
        [::std::mem::align_of::<_PRINTPROCESSOR_CAPS_1>() - 4usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_1::dwLevel"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_1, dwLevel) - 0usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_1::dwNupOptions"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_1, dwNupOptions) - 4usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_1::dwPageOrderFlags"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_1, dwPageOrderFlags) - 8usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_1::dwNumberOfCopies"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_1, dwNumberOfCopies) - 12usize];
};
pub type PRINTPROCESSOR_CAPS_1 = _PRINTPROCESSOR_CAPS_1;
pub type PPRINTPROCESSOR_CAPS_1 = *mut _PRINTPROCESSOR_CAPS_1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTPROCESSOR_CAPS_2 {
    pub dwLevel: DWORD,
    pub dwNupOptions: DWORD,
    pub dwPageOrderFlags: DWORD,
    pub dwNumberOfCopies: DWORD,
    pub dwDuplexHandlingCaps: DWORD,
    pub dwNupDirectionCaps: DWORD,
    pub dwNupBorderCaps: DWORD,
    pub dwBookletHandlingCaps: DWORD,
    pub dwScalingCaps: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTPROCESSOR_CAPS_2"][::std::mem::size_of::<_PRINTPROCESSOR_CAPS_2>() - 36usize];
    ["Alignment of _PRINTPROCESSOR_CAPS_2"]
        [::std::mem::align_of::<_PRINTPROCESSOR_CAPS_2>() - 4usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwLevel"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwLevel) - 0usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwNupOptions"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwNupOptions) - 4usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwPageOrderFlags"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwPageOrderFlags) - 8usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwNumberOfCopies"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwNumberOfCopies) - 12usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwDuplexHandlingCaps"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwDuplexHandlingCaps) - 16usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwNupDirectionCaps"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwNupDirectionCaps) - 20usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwNupBorderCaps"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwNupBorderCaps) - 24usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwBookletHandlingCaps"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwBookletHandlingCaps) - 28usize];
    ["Offset of field: _PRINTPROCESSOR_CAPS_2::dwScalingCaps"]
        [::std::mem::offset_of!(_PRINTPROCESSOR_CAPS_2, dwScalingCaps) - 32usize];
};
pub type PRINTPROCESSOR_CAPS_2 = _PRINTPROCESSOR_CAPS_2;
pub type PPRINTPROCESSOR_CAPS_2 = *mut _PRINTPROCESSOR_CAPS_2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_1A {
    pub pName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_1A"][::std::mem::size_of::<_PORT_INFO_1A>() - 8usize];
    ["Alignment of _PORT_INFO_1A"][::std::mem::align_of::<_PORT_INFO_1A>() - 8usize];
    ["Offset of field: _PORT_INFO_1A::pName"]
        [::std::mem::offset_of!(_PORT_INFO_1A, pName) - 0usize];
};
pub type PORT_INFO_1A = _PORT_INFO_1A;
pub type PPORT_INFO_1A = *mut _PORT_INFO_1A;
pub type LPPORT_INFO_1A = *mut _PORT_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_1W {
    pub pName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_1W"][::std::mem::size_of::<_PORT_INFO_1W>() - 8usize];
    ["Alignment of _PORT_INFO_1W"][::std::mem::align_of::<_PORT_INFO_1W>() - 8usize];
    ["Offset of field: _PORT_INFO_1W::pName"]
        [::std::mem::offset_of!(_PORT_INFO_1W, pName) - 0usize];
};
pub type PORT_INFO_1W = _PORT_INFO_1W;
pub type PPORT_INFO_1W = *mut _PORT_INFO_1W;
pub type LPPORT_INFO_1W = *mut _PORT_INFO_1W;
pub type PORT_INFO_1 = PORT_INFO_1A;
pub type PPORT_INFO_1 = PPORT_INFO_1A;
pub type LPPORT_INFO_1 = LPPORT_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_2A {
    pub pPortName: LPSTR,
    pub pMonitorName: LPSTR,
    pub pDescription: LPSTR,
    pub fPortType: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_2A"][::std::mem::size_of::<_PORT_INFO_2A>() - 32usize];
    ["Alignment of _PORT_INFO_2A"][::std::mem::align_of::<_PORT_INFO_2A>() - 8usize];
    ["Offset of field: _PORT_INFO_2A::pPortName"]
        [::std::mem::offset_of!(_PORT_INFO_2A, pPortName) - 0usize];
    ["Offset of field: _PORT_INFO_2A::pMonitorName"]
        [::std::mem::offset_of!(_PORT_INFO_2A, pMonitorName) - 8usize];
    ["Offset of field: _PORT_INFO_2A::pDescription"]
        [::std::mem::offset_of!(_PORT_INFO_2A, pDescription) - 16usize];
    ["Offset of field: _PORT_INFO_2A::fPortType"]
        [::std::mem::offset_of!(_PORT_INFO_2A, fPortType) - 24usize];
    ["Offset of field: _PORT_INFO_2A::Reserved"]
        [::std::mem::offset_of!(_PORT_INFO_2A, Reserved) - 28usize];
};
pub type PORT_INFO_2A = _PORT_INFO_2A;
pub type PPORT_INFO_2A = *mut _PORT_INFO_2A;
pub type LPPORT_INFO_2A = *mut _PORT_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_2W {
    pub pPortName: LPWSTR,
    pub pMonitorName: LPWSTR,
    pub pDescription: LPWSTR,
    pub fPortType: DWORD,
    pub Reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_2W"][::std::mem::size_of::<_PORT_INFO_2W>() - 32usize];
    ["Alignment of _PORT_INFO_2W"][::std::mem::align_of::<_PORT_INFO_2W>() - 8usize];
    ["Offset of field: _PORT_INFO_2W::pPortName"]
        [::std::mem::offset_of!(_PORT_INFO_2W, pPortName) - 0usize];
    ["Offset of field: _PORT_INFO_2W::pMonitorName"]
        [::std::mem::offset_of!(_PORT_INFO_2W, pMonitorName) - 8usize];
    ["Offset of field: _PORT_INFO_2W::pDescription"]
        [::std::mem::offset_of!(_PORT_INFO_2W, pDescription) - 16usize];
    ["Offset of field: _PORT_INFO_2W::fPortType"]
        [::std::mem::offset_of!(_PORT_INFO_2W, fPortType) - 24usize];
    ["Offset of field: _PORT_INFO_2W::Reserved"]
        [::std::mem::offset_of!(_PORT_INFO_2W, Reserved) - 28usize];
};
pub type PORT_INFO_2W = _PORT_INFO_2W;
pub type PPORT_INFO_2W = *mut _PORT_INFO_2W;
pub type LPPORT_INFO_2W = *mut _PORT_INFO_2W;
pub type PORT_INFO_2 = PORT_INFO_2A;
pub type PPORT_INFO_2 = PPORT_INFO_2A;
pub type LPPORT_INFO_2 = LPPORT_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_3A {
    pub dwStatus: DWORD,
    pub pszStatus: LPSTR,
    pub dwSeverity: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_3A"][::std::mem::size_of::<_PORT_INFO_3A>() - 24usize];
    ["Alignment of _PORT_INFO_3A"][::std::mem::align_of::<_PORT_INFO_3A>() - 8usize];
    ["Offset of field: _PORT_INFO_3A::dwStatus"]
        [::std::mem::offset_of!(_PORT_INFO_3A, dwStatus) - 0usize];
    ["Offset of field: _PORT_INFO_3A::pszStatus"]
        [::std::mem::offset_of!(_PORT_INFO_3A, pszStatus) - 8usize];
    ["Offset of field: _PORT_INFO_3A::dwSeverity"]
        [::std::mem::offset_of!(_PORT_INFO_3A, dwSeverity) - 16usize];
};
pub type PORT_INFO_3A = _PORT_INFO_3A;
pub type PPORT_INFO_3A = *mut _PORT_INFO_3A;
pub type LPPORT_INFO_3A = *mut _PORT_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PORT_INFO_3W {
    pub dwStatus: DWORD,
    pub pszStatus: LPWSTR,
    pub dwSeverity: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PORT_INFO_3W"][::std::mem::size_of::<_PORT_INFO_3W>() - 24usize];
    ["Alignment of _PORT_INFO_3W"][::std::mem::align_of::<_PORT_INFO_3W>() - 8usize];
    ["Offset of field: _PORT_INFO_3W::dwStatus"]
        [::std::mem::offset_of!(_PORT_INFO_3W, dwStatus) - 0usize];
    ["Offset of field: _PORT_INFO_3W::pszStatus"]
        [::std::mem::offset_of!(_PORT_INFO_3W, pszStatus) - 8usize];
    ["Offset of field: _PORT_INFO_3W::dwSeverity"]
        [::std::mem::offset_of!(_PORT_INFO_3W, dwSeverity) - 16usize];
};
pub type PORT_INFO_3W = _PORT_INFO_3W;
pub type PPORT_INFO_3W = *mut _PORT_INFO_3W;
pub type LPPORT_INFO_3W = *mut _PORT_INFO_3W;
pub type PORT_INFO_3 = PORT_INFO_3A;
pub type PPORT_INFO_3 = PPORT_INFO_3A;
pub type LPPORT_INFO_3 = LPPORT_INFO_3A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MONITOR_INFO_1A {
    pub pName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MONITOR_INFO_1A"][::std::mem::size_of::<_MONITOR_INFO_1A>() - 8usize];
    ["Alignment of _MONITOR_INFO_1A"][::std::mem::align_of::<_MONITOR_INFO_1A>() - 8usize];
    ["Offset of field: _MONITOR_INFO_1A::pName"]
        [::std::mem::offset_of!(_MONITOR_INFO_1A, pName) - 0usize];
};
pub type MONITOR_INFO_1A = _MONITOR_INFO_1A;
pub type PMONITOR_INFO_1A = *mut _MONITOR_INFO_1A;
pub type LPMONITOR_INFO_1A = *mut _MONITOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MONITOR_INFO_1W {
    pub pName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MONITOR_INFO_1W"][::std::mem::size_of::<_MONITOR_INFO_1W>() - 8usize];
    ["Alignment of _MONITOR_INFO_1W"][::std::mem::align_of::<_MONITOR_INFO_1W>() - 8usize];
    ["Offset of field: _MONITOR_INFO_1W::pName"]
        [::std::mem::offset_of!(_MONITOR_INFO_1W, pName) - 0usize];
};
pub type MONITOR_INFO_1W = _MONITOR_INFO_1W;
pub type PMONITOR_INFO_1W = *mut _MONITOR_INFO_1W;
pub type LPMONITOR_INFO_1W = *mut _MONITOR_INFO_1W;
pub type MONITOR_INFO_1 = MONITOR_INFO_1A;
pub type PMONITOR_INFO_1 = PMONITOR_INFO_1A;
pub type LPMONITOR_INFO_1 = LPMONITOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MONITOR_INFO_2A {
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDLLName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MONITOR_INFO_2A"][::std::mem::size_of::<_MONITOR_INFO_2A>() - 24usize];
    ["Alignment of _MONITOR_INFO_2A"][::std::mem::align_of::<_MONITOR_INFO_2A>() - 8usize];
    ["Offset of field: _MONITOR_INFO_2A::pName"]
        [::std::mem::offset_of!(_MONITOR_INFO_2A, pName) - 0usize];
    ["Offset of field: _MONITOR_INFO_2A::pEnvironment"]
        [::std::mem::offset_of!(_MONITOR_INFO_2A, pEnvironment) - 8usize];
    ["Offset of field: _MONITOR_INFO_2A::pDLLName"]
        [::std::mem::offset_of!(_MONITOR_INFO_2A, pDLLName) - 16usize];
};
pub type MONITOR_INFO_2A = _MONITOR_INFO_2A;
pub type PMONITOR_INFO_2A = *mut _MONITOR_INFO_2A;
pub type LPMONITOR_INFO_2A = *mut _MONITOR_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MONITOR_INFO_2W {
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDLLName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MONITOR_INFO_2W"][::std::mem::size_of::<_MONITOR_INFO_2W>() - 24usize];
    ["Alignment of _MONITOR_INFO_2W"][::std::mem::align_of::<_MONITOR_INFO_2W>() - 8usize];
    ["Offset of field: _MONITOR_INFO_2W::pName"]
        [::std::mem::offset_of!(_MONITOR_INFO_2W, pName) - 0usize];
    ["Offset of field: _MONITOR_INFO_2W::pEnvironment"]
        [::std::mem::offset_of!(_MONITOR_INFO_2W, pEnvironment) - 8usize];
    ["Offset of field: _MONITOR_INFO_2W::pDLLName"]
        [::std::mem::offset_of!(_MONITOR_INFO_2W, pDLLName) - 16usize];
};
pub type MONITOR_INFO_2W = _MONITOR_INFO_2W;
pub type PMONITOR_INFO_2W = *mut _MONITOR_INFO_2W;
pub type LPMONITOR_INFO_2W = *mut _MONITOR_INFO_2W;
pub type MONITOR_INFO_2 = MONITOR_INFO_2A;
pub type PMONITOR_INFO_2 = PMONITOR_INFO_2A;
pub type LPMONITOR_INFO_2 = LPMONITOR_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DATATYPES_INFO_1A {
    pub pName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DATATYPES_INFO_1A"][::std::mem::size_of::<_DATATYPES_INFO_1A>() - 8usize];
    ["Alignment of _DATATYPES_INFO_1A"][::std::mem::align_of::<_DATATYPES_INFO_1A>() - 8usize];
    ["Offset of field: _DATATYPES_INFO_1A::pName"]
        [::std::mem::offset_of!(_DATATYPES_INFO_1A, pName) - 0usize];
};
pub type DATATYPES_INFO_1A = _DATATYPES_INFO_1A;
pub type PDATATYPES_INFO_1A = *mut _DATATYPES_INFO_1A;
pub type LPDATATYPES_INFO_1A = *mut _DATATYPES_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _DATATYPES_INFO_1W {
    pub pName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _DATATYPES_INFO_1W"][::std::mem::size_of::<_DATATYPES_INFO_1W>() - 8usize];
    ["Alignment of _DATATYPES_INFO_1W"][::std::mem::align_of::<_DATATYPES_INFO_1W>() - 8usize];
    ["Offset of field: _DATATYPES_INFO_1W::pName"]
        [::std::mem::offset_of!(_DATATYPES_INFO_1W, pName) - 0usize];
};
pub type DATATYPES_INFO_1W = _DATATYPES_INFO_1W;
pub type PDATATYPES_INFO_1W = *mut _DATATYPES_INFO_1W;
pub type LPDATATYPES_INFO_1W = *mut _DATATYPES_INFO_1W;
pub type DATATYPES_INFO_1 = DATATYPES_INFO_1A;
pub type PDATATYPES_INFO_1 = PDATATYPES_INFO_1A;
pub type LPDATATYPES_INFO_1 = LPDATATYPES_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_DEFAULTSA {
    pub pDatatype: LPSTR,
    pub pDevMode: LPDEVMODEA,
    pub DesiredAccess: ACCESS_MASK,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_DEFAULTSA"][::std::mem::size_of::<_PRINTER_DEFAULTSA>() - 24usize];
    ["Alignment of _PRINTER_DEFAULTSA"][::std::mem::align_of::<_PRINTER_DEFAULTSA>() - 8usize];
    ["Offset of field: _PRINTER_DEFAULTSA::pDatatype"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSA, pDatatype) - 0usize];
    ["Offset of field: _PRINTER_DEFAULTSA::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSA, pDevMode) - 8usize];
    ["Offset of field: _PRINTER_DEFAULTSA::DesiredAccess"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSA, DesiredAccess) - 16usize];
};
pub type PRINTER_DEFAULTSA = _PRINTER_DEFAULTSA;
pub type PPRINTER_DEFAULTSA = *mut _PRINTER_DEFAULTSA;
pub type LPPRINTER_DEFAULTSA = *mut _PRINTER_DEFAULTSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_DEFAULTSW {
    pub pDatatype: LPWSTR,
    pub pDevMode: LPDEVMODEW,
    pub DesiredAccess: ACCESS_MASK,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_DEFAULTSW"][::std::mem::size_of::<_PRINTER_DEFAULTSW>() - 24usize];
    ["Alignment of _PRINTER_DEFAULTSW"][::std::mem::align_of::<_PRINTER_DEFAULTSW>() - 8usize];
    ["Offset of field: _PRINTER_DEFAULTSW::pDatatype"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSW, pDatatype) - 0usize];
    ["Offset of field: _PRINTER_DEFAULTSW::pDevMode"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSW, pDevMode) - 8usize];
    ["Offset of field: _PRINTER_DEFAULTSW::DesiredAccess"]
        [::std::mem::offset_of!(_PRINTER_DEFAULTSW, DesiredAccess) - 16usize];
};
pub type PRINTER_DEFAULTSW = _PRINTER_DEFAULTSW;
pub type PPRINTER_DEFAULTSW = *mut _PRINTER_DEFAULTSW;
pub type LPPRINTER_DEFAULTSW = *mut _PRINTER_DEFAULTSW;
pub type PRINTER_DEFAULTS = PRINTER_DEFAULTSA;
pub type PPRINTER_DEFAULTS = PPRINTER_DEFAULTSA;
pub type LPPRINTER_DEFAULTS = LPPRINTER_DEFAULTSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_ENUM_VALUESA {
    pub pValueName: LPSTR,
    pub cbValueName: DWORD,
    pub dwType: DWORD,
    pub pData: LPBYTE,
    pub cbData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_ENUM_VALUESA"][::std::mem::size_of::<_PRINTER_ENUM_VALUESA>() - 32usize];
    ["Alignment of _PRINTER_ENUM_VALUESA"]
        [::std::mem::align_of::<_PRINTER_ENUM_VALUESA>() - 8usize];
    ["Offset of field: _PRINTER_ENUM_VALUESA::pValueName"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESA, pValueName) - 0usize];
    ["Offset of field: _PRINTER_ENUM_VALUESA::cbValueName"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESA, cbValueName) - 8usize];
    ["Offset of field: _PRINTER_ENUM_VALUESA::dwType"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESA, dwType) - 12usize];
    ["Offset of field: _PRINTER_ENUM_VALUESA::pData"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESA, pData) - 16usize];
    ["Offset of field: _PRINTER_ENUM_VALUESA::cbData"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESA, cbData) - 24usize];
};
pub type PRINTER_ENUM_VALUESA = _PRINTER_ENUM_VALUESA;
pub type PPRINTER_ENUM_VALUESA = *mut _PRINTER_ENUM_VALUESA;
pub type LPPRINTER_ENUM_VALUESA = *mut _PRINTER_ENUM_VALUESA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_ENUM_VALUESW {
    pub pValueName: LPWSTR,
    pub cbValueName: DWORD,
    pub dwType: DWORD,
    pub pData: LPBYTE,
    pub cbData: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_ENUM_VALUESW"][::std::mem::size_of::<_PRINTER_ENUM_VALUESW>() - 32usize];
    ["Alignment of _PRINTER_ENUM_VALUESW"]
        [::std::mem::align_of::<_PRINTER_ENUM_VALUESW>() - 8usize];
    ["Offset of field: _PRINTER_ENUM_VALUESW::pValueName"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESW, pValueName) - 0usize];
    ["Offset of field: _PRINTER_ENUM_VALUESW::cbValueName"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESW, cbValueName) - 8usize];
    ["Offset of field: _PRINTER_ENUM_VALUESW::dwType"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESW, dwType) - 12usize];
    ["Offset of field: _PRINTER_ENUM_VALUESW::pData"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESW, pData) - 16usize];
    ["Offset of field: _PRINTER_ENUM_VALUESW::cbData"]
        [::std::mem::offset_of!(_PRINTER_ENUM_VALUESW, cbData) - 24usize];
};
pub type PRINTER_ENUM_VALUESW = _PRINTER_ENUM_VALUESW;
pub type PPRINTER_ENUM_VALUESW = *mut _PRINTER_ENUM_VALUESW;
pub type LPPRINTER_ENUM_VALUESW = *mut _PRINTER_ENUM_VALUESW;
pub type PRINTER_ENUM_VALUES = PRINTER_ENUM_VALUESA;
pub type PPRINTER_ENUM_VALUES = PPRINTER_ENUM_VALUESA;
pub type LPPRINTER_ENUM_VALUES = LPPRINTER_ENUM_VALUESA;
unsafe extern "C" {
    pub fn EnumPrintersA(
        Flags: DWORD,
        Name: LPSTR,
        Level: DWORD,
        pPrinterEnum: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrintersW(
        Flags: DWORD,
        Name: LPWSTR,
        Level: DWORD,
        pPrinterEnum: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSpoolFileHandle(hPrinter: HANDLE) -> HANDLE;
}
unsafe extern "C" {
    pub fn CommitSpoolData(hPrinter: HANDLE, hSpoolFile: HANDLE, cbCommit: DWORD) -> HANDLE;
}
unsafe extern "C" {
    pub fn CloseSpoolFileHandle(hPrinter: HANDLE, hSpoolFile: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenPrinterA(
        pPrinterName: LPSTR,
        phPrinter: LPHANDLE,
        pDefault: LPPRINTER_DEFAULTSA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenPrinterW(
        pPrinterName: LPWSTR,
        phPrinter: LPHANDLE,
        pDefault: LPPRINTER_DEFAULTSW,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ResetPrinterA(hPrinter: HANDLE, pDefault: LPPRINTER_DEFAULTSA) -> BOOL;
}
unsafe extern "C" {
    pub fn ResetPrinterW(hPrinter: HANDLE, pDefault: LPPRINTER_DEFAULTSW) -> BOOL;
}
unsafe extern "C" {
    pub fn SetJobA(
        hPrinter: HANDLE,
        JobId: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        Command: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetJobW(
        hPrinter: HANDLE,
        JobId: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        Command: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetJobA(
        hPrinter: HANDLE,
        JobId: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetJobW(
        hPrinter: HANDLE,
        JobId: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumJobsA(
        hPrinter: HANDLE,
        FirstJob: DWORD,
        NoJobs: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumJobsW(
        hPrinter: HANDLE,
        FirstJob: DWORD,
        NoJobs: DWORD,
        Level: DWORD,
        pJob: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterA(pName: LPSTR, Level: DWORD, pPrinter: LPBYTE) -> HANDLE;
}
unsafe extern "C" {
    pub fn AddPrinterW(pName: LPWSTR, Level: DWORD, pPrinter: LPBYTE) -> HANDLE;
}
unsafe extern "C" {
    pub fn DeletePrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPrinterA(hPrinter: HANDLE, Level: DWORD, pPrinter: LPBYTE, Command: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPrinterW(hPrinter: HANDLE, Level: DWORD, pPrinter: LPBYTE, Command: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterA(
        hPrinter: HANDLE,
        Level: DWORD,
        pPrinter: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterW(
        hPrinter: HANDLE,
        Level: DWORD,
        pPrinter: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterDriverA(pName: LPSTR, Level: DWORD, pDriverInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterDriverW(pName: LPWSTR, Level: DWORD, pDriverInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterDriverExA(
        pName: LPSTR,
        Level: DWORD,
        lpbDriverInfo: PBYTE,
        dwFileCopyFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterDriverExW(
        pName: LPWSTR,
        Level: DWORD,
        lpbDriverInfo: PBYTE,
        dwFileCopyFlags: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrinterDriversA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrinterDriversW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterDriverA(
        hPrinter: HANDLE,
        pEnvironment: LPSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterDriverW(
        hPrinter: HANDLE,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterDriverDirectoryA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        Level: DWORD,
        pDriverDirectory: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterDriverDirectoryW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pDriverDirectory: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverA(pName: LPSTR, pEnvironment: LPSTR, pDriverName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverW(pName: LPWSTR, pEnvironment: LPWSTR, pDriverName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverExA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        pDriverName: LPSTR,
        dwDeleteFlag: DWORD,
        dwVersionFlag: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverExW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        pDriverName: LPWSTR,
        dwDeleteFlag: DWORD,
        dwVersionFlag: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrintProcessorA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        pPathName: LPSTR,
        pPrintProcessorName: LPSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrintProcessorW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        pPathName: LPWSTR,
        pPrintProcessorName: LPWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrintProcessorsA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        Level: DWORD,
        pPrintProcessorInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrintProcessorsW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pPrintProcessorInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrintProcessorDirectoryA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        Level: DWORD,
        pPrintProcessorInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrintProcessorDirectoryW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pPrintProcessorInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrintProcessorDatatypesA(
        pName: LPSTR,
        pPrintProcessorName: LPSTR,
        Level: DWORD,
        pDatatypes: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPrintProcessorDatatypesW(
        pName: LPWSTR,
        pPrintProcessorName: LPWSTR,
        Level: DWORD,
        pDatatypes: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrintProcessorA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        pPrintProcessorName: LPSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrintProcessorW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        pPrintProcessorName: LPWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn StartDocPrinterA(hPrinter: HANDLE, Level: DWORD, pDocInfo: LPBYTE) -> DWORD;
}
unsafe extern "C" {
    pub fn StartDocPrinterW(hPrinter: HANDLE, Level: DWORD, pDocInfo: LPBYTE) -> DWORD;
}
unsafe extern "C" {
    pub fn StartPagePrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn WritePrinter(hPrinter: HANDLE, pBuf: LPVOID, cbBuf: DWORD, pcWritten: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn FlushPrinter(
        hPrinter: HANDLE,
        pBuf: LPVOID,
        cbBuf: DWORD,
        pcWritten: LPDWORD,
        cSleep: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EndPagePrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn AbortPrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ReadPrinter(hPrinter: HANDLE, pBuf: LPVOID, cbBuf: DWORD, pNoBytesRead: LPDWORD)
        -> BOOL;
}
unsafe extern "C" {
    pub fn EndDocPrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddJobA(
        hPrinter: HANDLE,
        Level: DWORD,
        pData: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddJobW(
        hPrinter: HANDLE,
        Level: DWORD,
        pData: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ScheduleJob(hPrinter: HANDLE, JobId: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn PrinterProperties(hWnd: HWND, hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn DocumentPropertiesA(
        hWnd: HWND,
        hPrinter: HANDLE,
        pDeviceName: LPSTR,
        pDevModeOutput: PDEVMODEA,
        pDevModeInput: PDEVMODEA,
        fMode: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn DocumentPropertiesW(
        hWnd: HWND,
        hPrinter: HANDLE,
        pDeviceName: LPWSTR,
        pDevModeOutput: PDEVMODEW,
        pDevModeInput: PDEVMODEW,
        fMode: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn AdvancedDocumentPropertiesA(
        hWnd: HWND,
        hPrinter: HANDLE,
        pDeviceName: LPSTR,
        pDevModeOutput: PDEVMODEA,
        pDevModeInput: PDEVMODEA,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn AdvancedDocumentPropertiesW(
        hWnd: HWND,
        hPrinter: HANDLE,
        pDeviceName: LPWSTR,
        pDevModeOutput: PDEVMODEW,
        pDevModeInput: PDEVMODEW,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn ExtDeviceMode(
        hWnd: HWND,
        hInst: HANDLE,
        pDevModeOutput: LPDEVMODEA,
        pDeviceName: LPSTR,
        pPort: LPSTR,
        pDevModeInput: LPDEVMODEA,
        pProfile: LPSTR,
        fMode: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn GetPrinterDataA(
        hPrinter: HANDLE,
        pValueName: LPSTR,
        pType: LPDWORD,
        pData: LPBYTE,
        nSize: DWORD,
        pcbNeeded: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrinterDataW(
        hPrinter: HANDLE,
        pValueName: LPWSTR,
        pType: LPDWORD,
        pData: LPBYTE,
        nSize: DWORD,
        pcbNeeded: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrinterDataExA(
        hPrinter: HANDLE,
        pKeyName: LPCSTR,
        pValueName: LPCSTR,
        pType: LPDWORD,
        pData: LPBYTE,
        nSize: DWORD,
        pcbNeeded: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrinterDataExW(
        hPrinter: HANDLE,
        pKeyName: LPCWSTR,
        pValueName: LPCWSTR,
        pType: LPDWORD,
        pData: LPBYTE,
        nSize: DWORD,
        pcbNeeded: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterDataA(
        hPrinter: HANDLE,
        dwIndex: DWORD,
        pValueName: LPSTR,
        cbValueName: DWORD,
        pcbValueName: LPDWORD,
        pType: LPDWORD,
        pData: LPBYTE,
        cbData: DWORD,
        pcbData: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterDataW(
        hPrinter: HANDLE,
        dwIndex: DWORD,
        pValueName: LPWSTR,
        cbValueName: DWORD,
        pcbValueName: LPDWORD,
        pType: LPDWORD,
        pData: LPBYTE,
        cbData: DWORD,
        pcbData: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterDataExA(
        hPrinter: HANDLE,
        pKeyName: LPCSTR,
        pEnumValues: LPBYTE,
        cbEnumValues: DWORD,
        pcbEnumValues: LPDWORD,
        pnEnumValues: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterDataExW(
        hPrinter: HANDLE,
        pKeyName: LPCWSTR,
        pEnumValues: LPBYTE,
        cbEnumValues: DWORD,
        pcbEnumValues: LPDWORD,
        pnEnumValues: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterKeyA(
        hPrinter: HANDLE,
        pKeyName: LPCSTR,
        pSubkey: LPSTR,
        cbSubkey: DWORD,
        pcbSubkey: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumPrinterKeyW(
        hPrinter: HANDLE,
        pKeyName: LPCWSTR,
        pSubkey: LPWSTR,
        cbSubkey: DWORD,
        pcbSubkey: LPDWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetPrinterDataA(
        hPrinter: HANDLE,
        pValueName: LPSTR,
        Type: DWORD,
        pData: LPBYTE,
        cbData: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetPrinterDataW(
        hPrinter: HANDLE,
        pValueName: LPWSTR,
        Type: DWORD,
        pData: LPBYTE,
        cbData: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetPrinterDataExA(
        hPrinter: HANDLE,
        pKeyName: LPCSTR,
        pValueName: LPCSTR,
        Type: DWORD,
        pData: LPBYTE,
        cbData: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn SetPrinterDataExW(
        hPrinter: HANDLE,
        pKeyName: LPCWSTR,
        pValueName: LPCWSTR,
        Type: DWORD,
        pData: LPBYTE,
        cbData: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterDataA(hPrinter: HANDLE, pValueName: LPSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterDataW(hPrinter: HANDLE, pValueName: LPWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterDataExA(hPrinter: HANDLE, pKeyName: LPCSTR, pValueName: LPCSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterDataExW(hPrinter: HANDLE, pKeyName: LPCWSTR, pValueName: LPCWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterKeyA(hPrinter: HANDLE, pKeyName: LPCSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn DeletePrinterKeyW(hPrinter: HANDLE, pKeyName: LPCWSTR) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_NOTIFY_OPTIONS_TYPE {
    pub Type: WORD,
    pub Reserved0: WORD,
    pub Reserved1: DWORD,
    pub Reserved2: DWORD,
    pub Count: DWORD,
    pub pFields: PWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_OPTIONS_TYPE"]
        [::std::mem::size_of::<_PRINTER_NOTIFY_OPTIONS_TYPE>() - 24usize];
    ["Alignment of _PRINTER_NOTIFY_OPTIONS_TYPE"]
        [::std::mem::align_of::<_PRINTER_NOTIFY_OPTIONS_TYPE>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::Type"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, Type) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::Reserved0"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, Reserved0) - 2usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::Reserved1"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, Reserved1) - 4usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::Reserved2"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, Reserved2) - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::Count"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, Count) - 12usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS_TYPE::pFields"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS_TYPE, pFields) - 16usize];
};
pub type PRINTER_NOTIFY_OPTIONS_TYPE = _PRINTER_NOTIFY_OPTIONS_TYPE;
pub type PPRINTER_NOTIFY_OPTIONS_TYPE = *mut _PRINTER_NOTIFY_OPTIONS_TYPE;
pub type LPPRINTER_NOTIFY_OPTIONS_TYPE = *mut _PRINTER_NOTIFY_OPTIONS_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_NOTIFY_OPTIONS {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub Count: DWORD,
    pub pTypes: PPRINTER_NOTIFY_OPTIONS_TYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_OPTIONS"][::std::mem::size_of::<_PRINTER_NOTIFY_OPTIONS>() - 24usize];
    ["Alignment of _PRINTER_NOTIFY_OPTIONS"]
        [::std::mem::align_of::<_PRINTER_NOTIFY_OPTIONS>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS::Version"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS, Version) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS::Flags"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS, Flags) - 4usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS::Count"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS, Count) - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_OPTIONS::pTypes"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_OPTIONS, pTypes) - 16usize];
};
pub type PRINTER_NOTIFY_OPTIONS = _PRINTER_NOTIFY_OPTIONS;
pub type PPRINTER_NOTIFY_OPTIONS = *mut _PRINTER_NOTIFY_OPTIONS;
pub type LPPRINTER_NOTIFY_OPTIONS = *mut _PRINTER_NOTIFY_OPTIONS;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PRINTER_NOTIFY_INFO_DATA {
    pub Type: WORD,
    pub Field: WORD,
    pub Reserved: DWORD,
    pub Id: DWORD,
    pub NotifyData: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1 {
    pub adwData: [DWORD; 2usize],
    pub Data: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1 {
    pub cbBuf: DWORD,
    pub pBuf: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Alignment of _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1::cbBuf"][::std::mem::offset_of!(
        _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1,
        cbBuf
    ) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1::pBuf"][::std::mem::offset_of!(
        _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1__bindgen_ty_1,
        pBuf
    ) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1"]
        [::std::mem::size_of::<_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1>() - 16usize];
    ["Alignment of _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1"]
        [::std::mem::align_of::<_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1::adwData"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1, adwData) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1::Data"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA__bindgen_ty_1, Data) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_INFO_DATA"]
        [::std::mem::size_of::<_PRINTER_NOTIFY_INFO_DATA>() - 32usize];
    ["Alignment of _PRINTER_NOTIFY_INFO_DATA"]
        [::std::mem::align_of::<_PRINTER_NOTIFY_INFO_DATA>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA::Type"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA, Type) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA::Field"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA, Field) - 2usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA::Reserved"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA, Reserved) - 4usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA::Id"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA, Id) - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO_DATA::NotifyData"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO_DATA, NotifyData) - 16usize];
};
pub type PRINTER_NOTIFY_INFO_DATA = _PRINTER_NOTIFY_INFO_DATA;
pub type PPRINTER_NOTIFY_INFO_DATA = *mut _PRINTER_NOTIFY_INFO_DATA;
pub type LPPRINTER_NOTIFY_INFO_DATA = *mut _PRINTER_NOTIFY_INFO_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _PRINTER_NOTIFY_INFO {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub Count: DWORD,
    pub aData: [PRINTER_NOTIFY_INFO_DATA; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_NOTIFY_INFO"][::std::mem::size_of::<_PRINTER_NOTIFY_INFO>() - 48usize];
    ["Alignment of _PRINTER_NOTIFY_INFO"][::std::mem::align_of::<_PRINTER_NOTIFY_INFO>() - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO::Version"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO, Version) - 0usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO::Flags"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO, Flags) - 4usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO::Count"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO, Count) - 8usize];
    ["Offset of field: _PRINTER_NOTIFY_INFO::aData"]
        [::std::mem::offset_of!(_PRINTER_NOTIFY_INFO, aData) - 16usize];
};
pub type PRINTER_NOTIFY_INFO = _PRINTER_NOTIFY_INFO;
pub type PPRINTER_NOTIFY_INFO = *mut _PRINTER_NOTIFY_INFO;
pub type LPPRINTER_NOTIFY_INFO = *mut _PRINTER_NOTIFY_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _BINARY_CONTAINER {
    pub cbBuf: DWORD,
    pub pData: LPBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BINARY_CONTAINER"][::std::mem::size_of::<_BINARY_CONTAINER>() - 16usize];
    ["Alignment of _BINARY_CONTAINER"][::std::mem::align_of::<_BINARY_CONTAINER>() - 8usize];
    ["Offset of field: _BINARY_CONTAINER::cbBuf"]
        [::std::mem::offset_of!(_BINARY_CONTAINER, cbBuf) - 0usize];
    ["Offset of field: _BINARY_CONTAINER::pData"]
        [::std::mem::offset_of!(_BINARY_CONTAINER, pData) - 8usize];
};
pub type BINARY_CONTAINER = _BINARY_CONTAINER;
pub type PBINARY_CONTAINER = *mut _BINARY_CONTAINER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIDI_DATA {
    pub dwBidiType: DWORD,
    pub u: _BIDI_DATA__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _BIDI_DATA__bindgen_ty_1 {
    pub bData: BOOL,
    pub iData: LONG,
    pub sData: LPWSTR,
    pub fData: FLOAT,
    pub biData: BINARY_CONTAINER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_DATA__bindgen_ty_1"]
        [::std::mem::size_of::<_BIDI_DATA__bindgen_ty_1>() - 16usize];
    ["Alignment of _BIDI_DATA__bindgen_ty_1"]
        [::std::mem::align_of::<_BIDI_DATA__bindgen_ty_1>() - 8usize];
    ["Offset of field: _BIDI_DATA__bindgen_ty_1::bData"]
        [::std::mem::offset_of!(_BIDI_DATA__bindgen_ty_1, bData) - 0usize];
    ["Offset of field: _BIDI_DATA__bindgen_ty_1::iData"]
        [::std::mem::offset_of!(_BIDI_DATA__bindgen_ty_1, iData) - 0usize];
    ["Offset of field: _BIDI_DATA__bindgen_ty_1::sData"]
        [::std::mem::offset_of!(_BIDI_DATA__bindgen_ty_1, sData) - 0usize];
    ["Offset of field: _BIDI_DATA__bindgen_ty_1::fData"]
        [::std::mem::offset_of!(_BIDI_DATA__bindgen_ty_1, fData) - 0usize];
    ["Offset of field: _BIDI_DATA__bindgen_ty_1::biData"]
        [::std::mem::offset_of!(_BIDI_DATA__bindgen_ty_1, biData) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_DATA"][::std::mem::size_of::<_BIDI_DATA>() - 24usize];
    ["Alignment of _BIDI_DATA"][::std::mem::align_of::<_BIDI_DATA>() - 8usize];
    ["Offset of field: _BIDI_DATA::dwBidiType"]
        [::std::mem::offset_of!(_BIDI_DATA, dwBidiType) - 0usize];
    ["Offset of field: _BIDI_DATA::u"][::std::mem::offset_of!(_BIDI_DATA, u) - 8usize];
};
pub type BIDI_DATA = _BIDI_DATA;
pub type PBIDI_DATA = *mut _BIDI_DATA;
pub type LPBIDI_DATA = *mut _BIDI_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIDI_REQUEST_DATA {
    pub dwReqNumber: DWORD,
    pub pSchema: LPWSTR,
    pub data: BIDI_DATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_REQUEST_DATA"][::std::mem::size_of::<_BIDI_REQUEST_DATA>() - 40usize];
    ["Alignment of _BIDI_REQUEST_DATA"][::std::mem::align_of::<_BIDI_REQUEST_DATA>() - 8usize];
    ["Offset of field: _BIDI_REQUEST_DATA::dwReqNumber"]
        [::std::mem::offset_of!(_BIDI_REQUEST_DATA, dwReqNumber) - 0usize];
    ["Offset of field: _BIDI_REQUEST_DATA::pSchema"]
        [::std::mem::offset_of!(_BIDI_REQUEST_DATA, pSchema) - 8usize];
    ["Offset of field: _BIDI_REQUEST_DATA::data"]
        [::std::mem::offset_of!(_BIDI_REQUEST_DATA, data) - 16usize];
};
pub type BIDI_REQUEST_DATA = _BIDI_REQUEST_DATA;
pub type PBIDI_REQUEST_DATA = *mut _BIDI_REQUEST_DATA;
pub type LPBIDI_REQUEST_DATA = *mut _BIDI_REQUEST_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIDI_REQUEST_CONTAINER {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub Count: DWORD,
    pub aData: [BIDI_REQUEST_DATA; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_REQUEST_CONTAINER"][::std::mem::size_of::<_BIDI_REQUEST_CONTAINER>() - 56usize];
    ["Alignment of _BIDI_REQUEST_CONTAINER"]
        [::std::mem::align_of::<_BIDI_REQUEST_CONTAINER>() - 8usize];
    ["Offset of field: _BIDI_REQUEST_CONTAINER::Version"]
        [::std::mem::offset_of!(_BIDI_REQUEST_CONTAINER, Version) - 0usize];
    ["Offset of field: _BIDI_REQUEST_CONTAINER::Flags"]
        [::std::mem::offset_of!(_BIDI_REQUEST_CONTAINER, Flags) - 4usize];
    ["Offset of field: _BIDI_REQUEST_CONTAINER::Count"]
        [::std::mem::offset_of!(_BIDI_REQUEST_CONTAINER, Count) - 8usize];
    ["Offset of field: _BIDI_REQUEST_CONTAINER::aData"]
        [::std::mem::offset_of!(_BIDI_REQUEST_CONTAINER, aData) - 16usize];
};
pub type BIDI_REQUEST_CONTAINER = _BIDI_REQUEST_CONTAINER;
pub type PBIDI_REQUEST_CONTAINER = *mut _BIDI_REQUEST_CONTAINER;
pub type LPBIDI_REQUEST_CONTAINER = *mut _BIDI_REQUEST_CONTAINER;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIDI_RESPONSE_DATA {
    pub dwResult: DWORD,
    pub dwReqNumber: DWORD,
    pub pSchema: LPWSTR,
    pub data: BIDI_DATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_RESPONSE_DATA"][::std::mem::size_of::<_BIDI_RESPONSE_DATA>() - 40usize];
    ["Alignment of _BIDI_RESPONSE_DATA"][::std::mem::align_of::<_BIDI_RESPONSE_DATA>() - 8usize];
    ["Offset of field: _BIDI_RESPONSE_DATA::dwResult"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_DATA, dwResult) - 0usize];
    ["Offset of field: _BIDI_RESPONSE_DATA::dwReqNumber"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_DATA, dwReqNumber) - 4usize];
    ["Offset of field: _BIDI_RESPONSE_DATA::pSchema"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_DATA, pSchema) - 8usize];
    ["Offset of field: _BIDI_RESPONSE_DATA::data"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_DATA, data) - 16usize];
};
pub type BIDI_RESPONSE_DATA = _BIDI_RESPONSE_DATA;
pub type PBIDI_RESPONSE_DATA = *mut _BIDI_RESPONSE_DATA;
pub type LPBIDI_RESPONSE_DATA = *mut _BIDI_RESPONSE_DATA;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _BIDI_RESPONSE_CONTAINER {
    pub Version: DWORD,
    pub Flags: DWORD,
    pub Count: DWORD,
    pub aData: [BIDI_RESPONSE_DATA; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _BIDI_RESPONSE_CONTAINER"]
        [::std::mem::size_of::<_BIDI_RESPONSE_CONTAINER>() - 56usize];
    ["Alignment of _BIDI_RESPONSE_CONTAINER"]
        [::std::mem::align_of::<_BIDI_RESPONSE_CONTAINER>() - 8usize];
    ["Offset of field: _BIDI_RESPONSE_CONTAINER::Version"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_CONTAINER, Version) - 0usize];
    ["Offset of field: _BIDI_RESPONSE_CONTAINER::Flags"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_CONTAINER, Flags) - 4usize];
    ["Offset of field: _BIDI_RESPONSE_CONTAINER::Count"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_CONTAINER, Count) - 8usize];
    ["Offset of field: _BIDI_RESPONSE_CONTAINER::aData"]
        [::std::mem::offset_of!(_BIDI_RESPONSE_CONTAINER, aData) - 16usize];
};
pub type BIDI_RESPONSE_CONTAINER = _BIDI_RESPONSE_CONTAINER;
pub type PBIDI_RESPONSE_CONTAINER = *mut _BIDI_RESPONSE_CONTAINER;
pub type LPBIDI_RESPONSE_CONTAINER = *mut _BIDI_RESPONSE_CONTAINER;
pub const BIDI_TYPE_BIDI_NULL: BIDI_TYPE = 0;
pub const BIDI_TYPE_BIDI_INT: BIDI_TYPE = 1;
pub const BIDI_TYPE_BIDI_FLOAT: BIDI_TYPE = 2;
pub const BIDI_TYPE_BIDI_BOOL: BIDI_TYPE = 3;
pub const BIDI_TYPE_BIDI_STRING: BIDI_TYPE = 4;
pub const BIDI_TYPE_BIDI_TEXT: BIDI_TYPE = 5;
pub const BIDI_TYPE_BIDI_ENUM: BIDI_TYPE = 6;
pub const BIDI_TYPE_BIDI_BLOB: BIDI_TYPE = 7;
pub type BIDI_TYPE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn WaitForPrinterChange(hPrinter: HANDLE, Flags: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn FindFirstPrinterChangeNotification(
        hPrinter: HANDLE,
        fdwFilter: DWORD,
        fdwOptions: DWORD,
        pPrinterNotifyOptions: PVOID,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn FindNextPrinterChangeNotification(
        hChange: HANDLE,
        pdwChange: PDWORD,
        pvReserved: LPVOID,
        ppPrinterNotifyInfo: *mut LPVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn FreePrinterNotifyInfo(pPrinterNotifyInfo: PPRINTER_NOTIFY_INFO) -> BOOL;
}
unsafe extern "C" {
    pub fn FindClosePrinterChangeNotification(hChange: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn PrinterMessageBoxA(
        hPrinter: HANDLE,
        Error: DWORD,
        hWnd: HWND,
        pText: LPSTR,
        pCaption: LPSTR,
        dwType: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn PrinterMessageBoxW(
        hPrinter: HANDLE,
        Error: DWORD,
        hWnd: HWND,
        pText: LPWSTR,
        pCaption: LPWSTR,
        dwType: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ClosePrinter(hPrinter: HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddFormA(hPrinter: HANDLE, Level: DWORD, pForm: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddFormW(hPrinter: HANDLE, Level: DWORD, pForm: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteFormA(hPrinter: HANDLE, pFormName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteFormW(hPrinter: HANDLE, pFormName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFormA(
        hPrinter: HANDLE,
        pFormName: LPSTR,
        Level: DWORD,
        pForm: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFormW(
        hPrinter: HANDLE,
        pFormName: LPWSTR,
        Level: DWORD,
        pForm: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFormA(hPrinter: HANDLE, pFormName: LPSTR, Level: DWORD, pForm: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetFormW(hPrinter: HANDLE, pFormName: LPWSTR, Level: DWORD, pForm: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumFormsA(
        hPrinter: HANDLE,
        Level: DWORD,
        pForm: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumFormsW(
        hPrinter: HANDLE,
        Level: DWORD,
        pForm: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumMonitorsA(
        pName: LPSTR,
        Level: DWORD,
        pMonitor: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumMonitorsW(
        pName: LPWSTR,
        Level: DWORD,
        pMonitor: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddMonitorA(pName: LPSTR, Level: DWORD, pMonitors: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddMonitorW(pName: LPWSTR, Level: DWORD, pMonitors: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteMonitorA(pName: LPSTR, pEnvironment: LPSTR, pMonitorName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeleteMonitorW(pName: LPWSTR, pEnvironment: LPWSTR, pMonitorName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPortsA(
        pName: LPSTR,
        Level: DWORD,
        pPort: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumPortsW(
        pName: LPWSTR,
        Level: DWORD,
        pPort: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
        pcReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPortA(pName: LPSTR, hWnd: HWND, pMonitorName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPortW(pName: LPWSTR, hWnd: HWND, pMonitorName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ConfigurePortA(pName: LPSTR, hWnd: HWND, pPortName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ConfigurePortW(pName: LPWSTR, hWnd: HWND, pPortName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePortA(pName: LPSTR, hWnd: HWND, pPortName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePortW(pName: LPWSTR, hWnd: HWND, pPortName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn XcvDataW(
        hXcv: HANDLE,
        pszDataName: PCWSTR,
        pInputData: PBYTE,
        cbInputData: DWORD,
        pOutputData: PBYTE,
        cbOutputData: DWORD,
        pcbOutputNeeded: PDWORD,
        pdwStatus: PDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDefaultPrinterA(pszBuffer: LPSTR, pcchBuffer: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn GetDefaultPrinterW(pszBuffer: LPWSTR, pcchBuffer: LPDWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDefaultPrinterA(pszPrinter: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetDefaultPrinterW(pszPrinter: LPCWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPortA(pName: LPSTR, pPortName: LPSTR, dwLevel: DWORD, pPortInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn SetPortW(pName: LPWSTR, pPortName: LPWSTR, dwLevel: DWORD, pPortInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterConnectionA(pName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterConnectionW(pName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterConnectionA(pName: LPSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrinterConnectionW(pName: LPWSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn ConnectToPrinterDlg(hwnd: HWND, Flags: DWORD) -> HANDLE;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROVIDOR_INFO_1A {
    pub pName: LPSTR,
    pub pEnvironment: LPSTR,
    pub pDLLName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROVIDOR_INFO_1A"][::std::mem::size_of::<_PROVIDOR_INFO_1A>() - 24usize];
    ["Alignment of _PROVIDOR_INFO_1A"][::std::mem::align_of::<_PROVIDOR_INFO_1A>() - 8usize];
    ["Offset of field: _PROVIDOR_INFO_1A::pName"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1A, pName) - 0usize];
    ["Offset of field: _PROVIDOR_INFO_1A::pEnvironment"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1A, pEnvironment) - 8usize];
    ["Offset of field: _PROVIDOR_INFO_1A::pDLLName"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1A, pDLLName) - 16usize];
};
pub type PROVIDOR_INFO_1A = _PROVIDOR_INFO_1A;
pub type PPROVIDOR_INFO_1A = *mut _PROVIDOR_INFO_1A;
pub type LPPROVIDOR_INFO_1A = *mut _PROVIDOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROVIDOR_INFO_1W {
    pub pName: LPWSTR,
    pub pEnvironment: LPWSTR,
    pub pDLLName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROVIDOR_INFO_1W"][::std::mem::size_of::<_PROVIDOR_INFO_1W>() - 24usize];
    ["Alignment of _PROVIDOR_INFO_1W"][::std::mem::align_of::<_PROVIDOR_INFO_1W>() - 8usize];
    ["Offset of field: _PROVIDOR_INFO_1W::pName"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1W, pName) - 0usize];
    ["Offset of field: _PROVIDOR_INFO_1W::pEnvironment"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1W, pEnvironment) - 8usize];
    ["Offset of field: _PROVIDOR_INFO_1W::pDLLName"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_1W, pDLLName) - 16usize];
};
pub type PROVIDOR_INFO_1W = _PROVIDOR_INFO_1W;
pub type PPROVIDOR_INFO_1W = *mut _PROVIDOR_INFO_1W;
pub type LPPROVIDOR_INFO_1W = *mut _PROVIDOR_INFO_1W;
pub type PROVIDOR_INFO_1 = PROVIDOR_INFO_1A;
pub type PPROVIDOR_INFO_1 = PPROVIDOR_INFO_1A;
pub type LPPROVIDOR_INFO_1 = LPPROVIDOR_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROVIDOR_INFO_2A {
    pub pOrder: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROVIDOR_INFO_2A"][::std::mem::size_of::<_PROVIDOR_INFO_2A>() - 8usize];
    ["Alignment of _PROVIDOR_INFO_2A"][::std::mem::align_of::<_PROVIDOR_INFO_2A>() - 8usize];
    ["Offset of field: _PROVIDOR_INFO_2A::pOrder"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_2A, pOrder) - 0usize];
};
pub type PROVIDOR_INFO_2A = _PROVIDOR_INFO_2A;
pub type PPROVIDOR_INFO_2A = *mut _PROVIDOR_INFO_2A;
pub type LPPROVIDOR_INFO_2A = *mut _PROVIDOR_INFO_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PROVIDOR_INFO_2W {
    pub pOrder: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PROVIDOR_INFO_2W"][::std::mem::size_of::<_PROVIDOR_INFO_2W>() - 8usize];
    ["Alignment of _PROVIDOR_INFO_2W"][::std::mem::align_of::<_PROVIDOR_INFO_2W>() - 8usize];
    ["Offset of field: _PROVIDOR_INFO_2W::pOrder"]
        [::std::mem::offset_of!(_PROVIDOR_INFO_2W, pOrder) - 0usize];
};
pub type PROVIDOR_INFO_2W = _PROVIDOR_INFO_2W;
pub type PPROVIDOR_INFO_2W = *mut _PROVIDOR_INFO_2W;
pub type LPPROVIDOR_INFO_2W = *mut _PROVIDOR_INFO_2W;
pub type PROVIDOR_INFO_2 = PROVIDOR_INFO_2A;
pub type PPROVIDOR_INFO_2 = PPROVIDOR_INFO_2A;
pub type LPPROVIDOR_INFO_2 = LPPROVIDOR_INFO_2A;
unsafe extern "C" {
    pub fn AddPrintProvidorA(pName: LPSTR, Level: DWORD, pProvidorInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrintProvidorW(pName: LPWSTR, Level: DWORD, pProvidorInfo: LPBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrintProvidorA(
        pName: LPSTR,
        pEnvironment: LPSTR,
        pPrintProvidorName: LPSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn DeletePrintProvidorW(
        pName: LPWSTR,
        pEnvironment: LPWSTR,
        pPrintProvidorName: LPWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidDevmodeA(pDevmode: PDEVMODEA, DevmodeSize: usize) -> BOOL;
}
unsafe extern "C" {
    pub fn IsValidDevmodeW(pDevmode: PDEVMODEW, DevmodeSize: usize) -> BOOL;
}
pub const _PRINTER_OPTION_FLAGS_PRINTER_OPTION_NO_CACHE: _PRINTER_OPTION_FLAGS = 1;
pub const _PRINTER_OPTION_FLAGS_PRINTER_OPTION_CACHE: _PRINTER_OPTION_FLAGS = 2;
pub const _PRINTER_OPTION_FLAGS_PRINTER_OPTION_CLIENT_CHANGE: _PRINTER_OPTION_FLAGS = 4;
pub const _PRINTER_OPTION_FLAGS_PRINTER_OPTION_NO_CLIENT_DATA: _PRINTER_OPTION_FLAGS = 8;
pub type _PRINTER_OPTION_FLAGS = ::std::os::raw::c_int;
pub use self::_PRINTER_OPTION_FLAGS as PRINTER_OPTION_FLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_OPTIONSA {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_OPTIONSA"][::std::mem::size_of::<_PRINTER_OPTIONSA>() - 8usize];
    ["Alignment of _PRINTER_OPTIONSA"][::std::mem::align_of::<_PRINTER_OPTIONSA>() - 4usize];
    ["Offset of field: _PRINTER_OPTIONSA::cbSize"]
        [::std::mem::offset_of!(_PRINTER_OPTIONSA, cbSize) - 0usize];
    ["Offset of field: _PRINTER_OPTIONSA::dwFlags"]
        [::std::mem::offset_of!(_PRINTER_OPTIONSA, dwFlags) - 4usize];
};
pub type PRINTER_OPTIONSA = _PRINTER_OPTIONSA;
pub type PPRINTER_OPTIONSA = *mut _PRINTER_OPTIONSA;
pub type LPPRINTER_OPTIONSA = *mut _PRINTER_OPTIONSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_OPTIONSW {
    pub cbSize: UINT,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_OPTIONSW"][::std::mem::size_of::<_PRINTER_OPTIONSW>() - 8usize];
    ["Alignment of _PRINTER_OPTIONSW"][::std::mem::align_of::<_PRINTER_OPTIONSW>() - 4usize];
    ["Offset of field: _PRINTER_OPTIONSW::cbSize"]
        [::std::mem::offset_of!(_PRINTER_OPTIONSW, cbSize) - 0usize];
    ["Offset of field: _PRINTER_OPTIONSW::dwFlags"]
        [::std::mem::offset_of!(_PRINTER_OPTIONSW, dwFlags) - 4usize];
};
pub type PRINTER_OPTIONSW = _PRINTER_OPTIONSW;
pub type PPRINTER_OPTIONSW = *mut _PRINTER_OPTIONSW;
pub type LPPRINTER_OPTIONSW = *mut _PRINTER_OPTIONSW;
pub type PRINTER_OPTIONS = PRINTER_OPTIONSA;
pub type PPRINTER_OPTIONS = PPRINTER_OPTIONSA;
pub type LPPRINTER_OPTIONS = LPPRINTER_OPTIONSA;
unsafe extern "C" {
    pub fn OpenPrinter2A(
        pPrinterName: LPCSTR,
        phPrinter: LPHANDLE,
        pDefault: PPRINTER_DEFAULTSA,
        pOptions: PPRINTER_OPTIONSA,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenPrinter2W(
        pPrinterName: LPCWSTR,
        phPrinter: LPHANDLE,
        pDefault: PPRINTER_DEFAULTSW,
        pOptions: PPRINTER_OPTIONSW,
    ) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_CONNECTION_INFO_1A {
    pub dwFlags: DWORD,
    pub pszDriverName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_CONNECTION_INFO_1A"]
        [::std::mem::size_of::<_PRINTER_CONNECTION_INFO_1A>() - 16usize];
    ["Alignment of _PRINTER_CONNECTION_INFO_1A"]
        [::std::mem::align_of::<_PRINTER_CONNECTION_INFO_1A>() - 8usize];
    ["Offset of field: _PRINTER_CONNECTION_INFO_1A::dwFlags"]
        [::std::mem::offset_of!(_PRINTER_CONNECTION_INFO_1A, dwFlags) - 0usize];
    ["Offset of field: _PRINTER_CONNECTION_INFO_1A::pszDriverName"]
        [::std::mem::offset_of!(_PRINTER_CONNECTION_INFO_1A, pszDriverName) - 8usize];
};
pub type PRINTER_CONNECTION_INFO_1A = _PRINTER_CONNECTION_INFO_1A;
pub type PPRINTER_CONNECTION_INFO_1A = *mut _PRINTER_CONNECTION_INFO_1A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _PRINTER_CONNECTION_INFO_1W {
    pub dwFlags: DWORD,
    pub pszDriverName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _PRINTER_CONNECTION_INFO_1W"]
        [::std::mem::size_of::<_PRINTER_CONNECTION_INFO_1W>() - 16usize];
    ["Alignment of _PRINTER_CONNECTION_INFO_1W"]
        [::std::mem::align_of::<_PRINTER_CONNECTION_INFO_1W>() - 8usize];
    ["Offset of field: _PRINTER_CONNECTION_INFO_1W::dwFlags"]
        [::std::mem::offset_of!(_PRINTER_CONNECTION_INFO_1W, dwFlags) - 0usize];
    ["Offset of field: _PRINTER_CONNECTION_INFO_1W::pszDriverName"]
        [::std::mem::offset_of!(_PRINTER_CONNECTION_INFO_1W, pszDriverName) - 8usize];
};
pub type PRINTER_CONNECTION_INFO_1W = _PRINTER_CONNECTION_INFO_1W;
pub type PPRINTER_CONNECTION_INFO_1W = *mut _PRINTER_CONNECTION_INFO_1W;
pub type PRINTER_CONNECTION_INFO_1 = PRINTER_CONNECTION_INFO_1A;
pub type PPRINTER_CONNECTION_INFO_1 = PPRINTER_CONNECTION_INFO_1A;
unsafe extern "C" {
    pub fn AddPrinterConnection2A(
        hWnd: HWND,
        pszName: LPCSTR,
        dwLevel: DWORD,
        pConnectionInfo: PVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn AddPrinterConnection2W(
        hWnd: HWND,
        pszName: LPCWSTR,
        dwLevel: DWORD,
        pConnectionInfo: PVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn InstallPrinterDriverFromPackageA(
        pszServer: LPCSTR,
        pszInfPath: LPCSTR,
        pszDriverName: LPCSTR,
        pszEnvironment: LPCSTR,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn InstallPrinterDriverFromPackageW(
        pszServer: LPCWSTR,
        pszInfPath: LPCWSTR,
        pszDriverName: LPCWSTR,
        pszEnvironment: LPCWSTR,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UploadPrinterDriverPackageA(
        pszServer: LPCSTR,
        pszInfPath: LPCSTR,
        pszEnvironment: LPCSTR,
        dwFlags: DWORD,
        hwnd: HWND,
        pszDestInfPath: LPSTR,
        pcchDestInfPath: PULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UploadPrinterDriverPackageW(
        pszServer: LPCWSTR,
        pszInfPath: LPCWSTR,
        pszEnvironment: LPCWSTR,
        dwFlags: DWORD,
        hwnd: HWND,
        pszDestInfPath: LPWSTR,
        pcchDestInfPath: PULONG,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CORE_PRINTER_DRIVERA {
    pub CoreDriverGUID: GUID,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub szPackageID: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CORE_PRINTER_DRIVERA"][::std::mem::size_of::<_CORE_PRINTER_DRIVERA>() - 296usize];
    ["Alignment of _CORE_PRINTER_DRIVERA"]
        [::std::mem::align_of::<_CORE_PRINTER_DRIVERA>() - 8usize];
    ["Offset of field: _CORE_PRINTER_DRIVERA::CoreDriverGUID"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERA, CoreDriverGUID) - 0usize];
    ["Offset of field: _CORE_PRINTER_DRIVERA::ftDriverDate"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERA, ftDriverDate) - 16usize];
    ["Offset of field: _CORE_PRINTER_DRIVERA::dwlDriverVersion"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERA, dwlDriverVersion) - 24usize];
    ["Offset of field: _CORE_PRINTER_DRIVERA::szPackageID"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERA, szPackageID) - 32usize];
};
pub type CORE_PRINTER_DRIVERA = _CORE_PRINTER_DRIVERA;
pub type PCORE_PRINTER_DRIVERA = *mut _CORE_PRINTER_DRIVERA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CORE_PRINTER_DRIVERW {
    pub CoreDriverGUID: GUID,
    pub ftDriverDate: FILETIME,
    pub dwlDriverVersion: DWORDLONG,
    pub szPackageID: [WCHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CORE_PRINTER_DRIVERW"][::std::mem::size_of::<_CORE_PRINTER_DRIVERW>() - 552usize];
    ["Alignment of _CORE_PRINTER_DRIVERW"]
        [::std::mem::align_of::<_CORE_PRINTER_DRIVERW>() - 8usize];
    ["Offset of field: _CORE_PRINTER_DRIVERW::CoreDriverGUID"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERW, CoreDriverGUID) - 0usize];
    ["Offset of field: _CORE_PRINTER_DRIVERW::ftDriverDate"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERW, ftDriverDate) - 16usize];
    ["Offset of field: _CORE_PRINTER_DRIVERW::dwlDriverVersion"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERW, dwlDriverVersion) - 24usize];
    ["Offset of field: _CORE_PRINTER_DRIVERW::szPackageID"]
        [::std::mem::offset_of!(_CORE_PRINTER_DRIVERW, szPackageID) - 32usize];
};
pub type CORE_PRINTER_DRIVERW = _CORE_PRINTER_DRIVERW;
pub type PCORE_PRINTER_DRIVERW = *mut _CORE_PRINTER_DRIVERW;
pub type CORE_PRINTER_DRIVER = CORE_PRINTER_DRIVERA;
pub type PCORE_PRINTER_DRIVER = PCORE_PRINTER_DRIVERA;
unsafe extern "C" {
    pub fn GetCorePrinterDriversA(
        pszServer: LPCSTR,
        pszEnvironment: LPCSTR,
        pszzCoreDriverDependencies: LPCSTR,
        cCorePrinterDrivers: DWORD,
        pCorePrinterDrivers: PCORE_PRINTER_DRIVERA,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetCorePrinterDriversW(
        pszServer: LPCWSTR,
        pszEnvironment: LPCWSTR,
        pszzCoreDriverDependencies: LPCWSTR,
        cCorePrinterDrivers: DWORD,
        pCorePrinterDrivers: PCORE_PRINTER_DRIVERW,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CorePrinterDriverInstalledA(
        pszServer: LPCSTR,
        pszEnvironment: LPCSTR,
        CoreDriverGUID: GUID,
        ftDriverDate: FILETIME,
        dwlDriverVersion: DWORDLONG,
        pbDriverInstalled: *mut BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CorePrinterDriverInstalledW(
        pszServer: LPCWSTR,
        pszEnvironment: LPCWSTR,
        CoreDriverGUID: GUID,
        ftDriverDate: FILETIME,
        dwlDriverVersion: DWORDLONG,
        pbDriverInstalled: *mut BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetPrinterDriverPackagePathA(
        pszServer: LPCSTR,
        pszEnvironment: LPCSTR,
        pszLanguage: LPCSTR,
        pszPackageID: LPCSTR,
        pszDriverPackageCab: LPSTR,
        cchDriverPackageCab: DWORD,
        pcchRequiredSize: LPDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetPrinterDriverPackagePathW(
        pszServer: LPCWSTR,
        pszEnvironment: LPCWSTR,
        pszLanguage: LPCWSTR,
        pszPackageID: LPCWSTR,
        pszDriverPackageCab: LPWSTR,
        cchDriverPackageCab: DWORD,
        pcchRequiredSize: LPDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverPackageA(
        pszServer: LPCSTR,
        pszInfPath: LPCSTR,
        pszEnvironment: LPCSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DeletePrinterDriverPackageW(
        pszServer: LPCWSTR,
        pszInfPath: LPCWSTR,
        pszEnvironment: LPCWSTR,
    ) -> HRESULT;
}
pub const EPrintPropertyType_kPropertyTypeString: EPrintPropertyType = 1;
pub const EPrintPropertyType_kPropertyTypeInt32: EPrintPropertyType = 2;
pub const EPrintPropertyType_kPropertyTypeInt64: EPrintPropertyType = 3;
pub const EPrintPropertyType_kPropertyTypeByte: EPrintPropertyType = 4;
pub const EPrintPropertyType_kPropertyTypeTime: EPrintPropertyType = 5;
pub const EPrintPropertyType_kPropertyTypeDevMode: EPrintPropertyType = 6;
pub const EPrintPropertyType_kPropertyTypeSD: EPrintPropertyType = 7;
pub const EPrintPropertyType_kPropertyTypeNotificationReply: EPrintPropertyType = 8;
pub const EPrintPropertyType_kPropertyTypeNotificationOptions: EPrintPropertyType = 9;
pub const EPrintPropertyType_kPropertyTypeBuffer: EPrintPropertyType = 10;
pub type EPrintPropertyType = ::std::os::raw::c_int;
pub const EPrintXPSJobProgress_kAddingDocumentSequence: EPrintXPSJobProgress = 0;
pub const EPrintXPSJobProgress_kDocumentSequenceAdded: EPrintXPSJobProgress = 1;
pub const EPrintXPSJobProgress_kAddingFixedDocument: EPrintXPSJobProgress = 2;
pub const EPrintXPSJobProgress_kFixedDocumentAdded: EPrintXPSJobProgress = 3;
pub const EPrintXPSJobProgress_kAddingFixedPage: EPrintXPSJobProgress = 4;
pub const EPrintXPSJobProgress_kFixedPageAdded: EPrintXPSJobProgress = 5;
pub const EPrintXPSJobProgress_kResourceAdded: EPrintXPSJobProgress = 6;
pub const EPrintXPSJobProgress_kFontAdded: EPrintXPSJobProgress = 7;
pub const EPrintXPSJobProgress_kImageAdded: EPrintXPSJobProgress = 8;
pub const EPrintXPSJobProgress_kXpsDocumentCommitted: EPrintXPSJobProgress = 9;
pub type EPrintXPSJobProgress = ::std::os::raw::c_int;
pub const EPrintXPSJobOperation_kJobProduction: EPrintXPSJobOperation = 1;
pub const EPrintXPSJobOperation_kJobConsumption: EPrintXPSJobOperation = 2;
pub type EPrintXPSJobOperation = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct PrintPropertyValue {
    pub ePropertyType: EPrintPropertyType,
    pub value: PrintPropertyValue__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union PrintPropertyValue__bindgen_ty_1 {
    pub propertyByte: BYTE,
    pub propertyString: PWSTR,
    pub propertyInt32: LONG,
    pub propertyInt64: LONGLONG,
    pub propertyBlob: PrintPropertyValue__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PrintPropertyValue__bindgen_ty_1__bindgen_ty_1 {
    pub cbBuf: DWORD,
    pub pBuf: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PrintPropertyValue__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<PrintPropertyValue__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Alignment of PrintPropertyValue__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<PrintPropertyValue__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1__bindgen_ty_1::cbBuf"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1__bindgen_ty_1, cbBuf) - 0usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1__bindgen_ty_1::pBuf"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1__bindgen_ty_1, pBuf) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PrintPropertyValue__bindgen_ty_1"]
        [::std::mem::size_of::<PrintPropertyValue__bindgen_ty_1>() - 16usize];
    ["Alignment of PrintPropertyValue__bindgen_ty_1"]
        [::std::mem::align_of::<PrintPropertyValue__bindgen_ty_1>() - 8usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1::propertyByte"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1, propertyByte) - 0usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1::propertyString"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1, propertyString) - 0usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1::propertyInt32"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1, propertyInt32) - 0usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1::propertyInt64"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1, propertyInt64) - 0usize];
    ["Offset of field: PrintPropertyValue__bindgen_ty_1::propertyBlob"]
        [::std::mem::offset_of!(PrintPropertyValue__bindgen_ty_1, propertyBlob) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PrintPropertyValue"][::std::mem::size_of::<PrintPropertyValue>() - 24usize];
    ["Alignment of PrintPropertyValue"][::std::mem::align_of::<PrintPropertyValue>() - 8usize];
    ["Offset of field: PrintPropertyValue::ePropertyType"]
        [::std::mem::offset_of!(PrintPropertyValue, ePropertyType) - 0usize];
    ["Offset of field: PrintPropertyValue::value"]
        [::std::mem::offset_of!(PrintPropertyValue, value) - 8usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct PrintNamedProperty {
    pub propertyName: *mut WCHAR,
    pub propertyValue: PrintPropertyValue,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PrintNamedProperty"][::std::mem::size_of::<PrintNamedProperty>() - 32usize];
    ["Alignment of PrintNamedProperty"][::std::mem::align_of::<PrintNamedProperty>() - 8usize];
    ["Offset of field: PrintNamedProperty::propertyName"]
        [::std::mem::offset_of!(PrintNamedProperty, propertyName) - 0usize];
    ["Offset of field: PrintNamedProperty::propertyValue"]
        [::std::mem::offset_of!(PrintNamedProperty, propertyValue) - 8usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PrintPropertiesCollection {
    pub numberOfProperties: ULONG,
    pub propertiesCollection: *mut PrintNamedProperty,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PrintPropertiesCollection"]
        [::std::mem::size_of::<PrintPropertiesCollection>() - 16usize];
    ["Alignment of PrintPropertiesCollection"]
        [::std::mem::align_of::<PrintPropertiesCollection>() - 8usize];
    ["Offset of field: PrintPropertiesCollection::numberOfProperties"]
        [::std::mem::offset_of!(PrintPropertiesCollection, numberOfProperties) - 0usize];
    ["Offset of field: PrintPropertiesCollection::propertiesCollection"]
        [::std::mem::offset_of!(PrintPropertiesCollection, propertiesCollection) - 8usize];
};
unsafe extern "C" {
    pub fn ReportJobProcessingProgress(
        printerHandle: HANDLE,
        jobId: ULONG,
        jobOperation: EPrintXPSJobOperation,
        jobProgress: EPrintXPSJobProgress,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetPrinterDriver2A(
        hWnd: HWND,
        hPrinter: HANDLE,
        pEnvironment: LPSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetPrinterDriver2W(
        hWnd: HWND,
        hPrinter: HANDLE,
        pEnvironment: LPWSTR,
        Level: DWORD,
        pDriverInfo: LPBYTE,
        cbBuf: DWORD,
        pcbNeeded: LPDWORD,
    ) -> BOOL;
}
pub const PRINT_EXECUTION_CONTEXT_PRINT_EXECUTION_CONTEXT_APPLICATION: PRINT_EXECUTION_CONTEXT = 0;
pub const PRINT_EXECUTION_CONTEXT_PRINT_EXECUTION_CONTEXT_SPOOLER_SERVICE: PRINT_EXECUTION_CONTEXT =
    1;
pub const PRINT_EXECUTION_CONTEXT_PRINT_EXECUTION_CONTEXT_SPOOLER_ISOLATION_HOST:
    PRINT_EXECUTION_CONTEXT = 2;
pub const PRINT_EXECUTION_CONTEXT_PRINT_EXECUTION_CONTEXT_FILTER_PIPELINE: PRINT_EXECUTION_CONTEXT =
    3;
pub const PRINT_EXECUTION_CONTEXT_PRINT_EXECUTION_CONTEXT_WOW64: PRINT_EXECUTION_CONTEXT = 4;
pub type PRINT_EXECUTION_CONTEXT = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct PRINT_EXECUTION_DATA {
    pub context: PRINT_EXECUTION_CONTEXT,
    pub clientAppPID: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of PRINT_EXECUTION_DATA"][::std::mem::size_of::<PRINT_EXECUTION_DATA>() - 8usize];
    ["Alignment of PRINT_EXECUTION_DATA"][::std::mem::align_of::<PRINT_EXECUTION_DATA>() - 4usize];
    ["Offset of field: PRINT_EXECUTION_DATA::context"]
        [::std::mem::offset_of!(PRINT_EXECUTION_DATA, context) - 0usize];
    ["Offset of field: PRINT_EXECUTION_DATA::clientAppPID"]
        [::std::mem::offset_of!(PRINT_EXECUTION_DATA, clientAppPID) - 4usize];
};
unsafe extern "C" {
    pub fn GetPrintExecutionData(pData: *mut PRINT_EXECUTION_DATA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetJobNamedPropertyValue(
        hPrinter: HANDLE,
        JobId: DWORD,
        pszName: PCWSTR,
        pValue: *mut PrintPropertyValue,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn FreePrintPropertyValue(pValue: *mut PrintPropertyValue);
}
unsafe extern "C" {
    pub fn FreePrintNamedPropertyArray(
        cProperties: DWORD,
        ppProperties: *mut *mut PrintNamedProperty,
    );
}
unsafe extern "C" {
    pub fn SetJobNamedProperty(
        hPrinter: HANDLE,
        JobId: DWORD,
        pProperty: *const PrintNamedProperty,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn DeleteJobNamedProperty(hPrinter: HANDLE, JobId: DWORD, pszName: PCWSTR) -> DWORD;
}
unsafe extern "C" {
    pub fn EnumJobNamedProperties(
        hPrinter: HANDLE,
        JobId: DWORD,
        pcProperties: *mut DWORD,
        ppProperties: *mut *mut PrintNamedProperty,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn GetPrintOutputInfo(
        hWnd: HWND,
        pszPrinter: PCWSTR,
        phFile: *mut HANDLE,
        ppszOutputFile: *mut PWSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn _calloc_base(_Count: usize, _Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn calloc(
        _Count: ::std::os::raw::c_ulonglong,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _callnewh(_Size: usize) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _expand(
        _Block: *mut ::std::os::raw::c_void,
        _Size: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _free_base(_Block: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn free(_Block: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn _malloc_base(_Size: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn malloc(_Size: ::std::os::raw::c_ulonglong) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _msize_base(_Block: *mut ::std::os::raw::c_void) -> usize;
}
unsafe extern "C" {
    pub fn _msize(_Block: *mut ::std::os::raw::c_void) -> usize;
}
unsafe extern "C" {
    pub fn _realloc_base(
        _Block: *mut ::std::os::raw::c_void,
        _Size: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn realloc(
        _Block: *mut ::std::os::raw::c_void,
        _Size: ::std::os::raw::c_ulonglong,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _recalloc_base(
        _Block: *mut ::std::os::raw::c_void,
        _Count: usize,
        _Size: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _recalloc(
        _Block: *mut ::std::os::raw::c_void,
        _Count: usize,
        _Size: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_free(_Block: *mut ::std::os::raw::c_void);
}
unsafe extern "C" {
    pub fn _aligned_malloc(_Size: usize, _Alignment: usize) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_offset_malloc(
        _Size: usize,
        _Alignment: usize,
        _Offset: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_msize(
        _Block: *mut ::std::os::raw::c_void,
        _Alignment: usize,
        _Offset: usize,
    ) -> usize;
}
unsafe extern "C" {
    pub fn _aligned_offset_realloc(
        _Block: *mut ::std::os::raw::c_void,
        _Size: usize,
        _Alignment: usize,
        _Offset: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_offset_recalloc(
        _Block: *mut ::std::os::raw::c_void,
        _Count: usize,
        _Size: usize,
        _Alignment: usize,
        _Offset: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_realloc(
        _Block: *mut ::std::os::raw::c_void,
        _Size: usize,
        _Alignment: usize,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _aligned_recalloc(
        _Block: *mut ::std::os::raw::c_void,
        _Count: usize,
        _Size: usize,
        _Alignment: usize,
    ) -> *mut ::std::os::raw::c_void;
}
pub type max_align_t = f64;
pub type _CoreCrtSecureSearchSortCompareFunction = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *mut ::std::os::raw::c_void,
        arg2: *const ::std::os::raw::c_void,
        arg3: *const ::std::os::raw::c_void,
    ) -> ::std::os::raw::c_int,
>;
pub type _CoreCrtNonSecureSearchSortCompareFunction = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *const ::std::os::raw::c_void,
        arg2: *const ::std::os::raw::c_void,
    ) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn bsearch_s(
        _Key: *const ::std::os::raw::c_void,
        _Base: *const ::std::os::raw::c_void,
        _NumOfElements: rsize_t,
        _SizeOfElements: rsize_t,
        _CompareFunction: _CoreCrtSecureSearchSortCompareFunction,
        _Context: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn qsort_s(
        _Base: *mut ::std::os::raw::c_void,
        _NumOfElements: rsize_t,
        _SizeOfElements: rsize_t,
        _CompareFunction: _CoreCrtSecureSearchSortCompareFunction,
        _Context: *mut ::std::os::raw::c_void,
    );
}
unsafe extern "C" {
    pub fn bsearch(
        _Key: *const ::std::os::raw::c_void,
        _Base: *const ::std::os::raw::c_void,
        _NumOfElements: usize,
        _SizeOfElements: usize,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn qsort(
        _Base: *mut ::std::os::raw::c_void,
        _NumOfElements: usize,
        _SizeOfElements: usize,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    );
}
unsafe extern "C" {
    pub fn _lfind_s(
        _Key: *const ::std::os::raw::c_void,
        _Base: *const ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: usize,
        _CompareFunction: _CoreCrtSecureSearchSortCompareFunction,
        _Context: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _lfind(
        _Key: *const ::std::os::raw::c_void,
        _Base: *const ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: ::std::os::raw::c_uint,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _lsearch_s(
        _Key: *const ::std::os::raw::c_void,
        _Base: *mut ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: usize,
        _CompareFunction: _CoreCrtSecureSearchSortCompareFunction,
        _Context: *mut ::std::os::raw::c_void,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _lsearch(
        _Key: *const ::std::os::raw::c_void,
        _Base: *mut ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: ::std::os::raw::c_uint,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn lfind(
        _Key: *const ::std::os::raw::c_void,
        _Base: *const ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: ::std::os::raw::c_uint,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn lsearch(
        _Key: *const ::std::os::raw::c_void,
        _Base: *mut ::std::os::raw::c_void,
        _NumOfElements: *mut ::std::os::raw::c_uint,
        _SizeOfElements: ::std::os::raw::c_uint,
        _CompareFunction: _CoreCrtNonSecureSearchSortCompareFunction,
    ) -> *mut ::std::os::raw::c_void;
}
unsafe extern "C" {
    pub fn _itow_s(
        _Value: ::std::os::raw::c_int,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _itow(
        _Value: ::std::os::raw::c_int,
        _Buffer: *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _ltow_s(
        _Value: ::std::os::raw::c_long,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ltow(
        _Value: ::std::os::raw::c_long,
        _Buffer: *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _ultow_s(
        _Value: ::std::os::raw::c_ulong,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ultow(
        _Value: ::std::os::raw::c_ulong,
        _Buffer: *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn wcstod(_String: *const wchar_t, _EndPtr: *mut *mut wchar_t) -> f64;
}
unsafe extern "C" {
    pub fn _wcstod_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Locale: _locale_t,
    ) -> f64;
}
unsafe extern "C" {
    pub fn wcstol(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _wcstol_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn wcstoll(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wcstoll_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn wcstoul(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _wcstoul_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn wcstoull(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _wcstoull_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn wcstold(_String: *const wchar_t, _EndPtr: *mut *mut wchar_t) -> f64;
}
unsafe extern "C" {
    pub fn _wcstold_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Locale: _locale_t,
    ) -> f64;
}
unsafe extern "C" {
    pub fn wcstof(_String: *const wchar_t, _EndPtr: *mut *mut wchar_t) -> f32;
}
unsafe extern "C" {
    pub fn _wcstof_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Locale: _locale_t,
    ) -> f32;
}
unsafe extern "C" {
    pub fn _wtof(_String: *const wchar_t) -> f64;
}
unsafe extern "C" {
    pub fn _wtof_l(_String: *const wchar_t, _Locale: _locale_t) -> f64;
}
unsafe extern "C" {
    pub fn _wtoi(_String: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wtoi_l(_String: *const wchar_t, _Locale: _locale_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wtol(_String: *const wchar_t) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _wtol_l(_String: *const wchar_t, _Locale: _locale_t) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _wtoll(_String: *const wchar_t) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wtoll_l(_String: *const wchar_t, _Locale: _locale_t) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _i64tow_s(
        _Value: ::std::os::raw::c_longlong,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _i64tow(
        _Value: ::std::os::raw::c_longlong,
        _Buffer: *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _ui64tow_s(
        _Value: ::std::os::raw::c_ulonglong,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ui64tow(
        _Value: ::std::os::raw::c_ulonglong,
        _Buffer: *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wtoi64(_String: *const wchar_t) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wtoi64_l(_String: *const wchar_t, _Locale: _locale_t) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wcstoi64(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wcstoi64_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _wcstoui64(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _wcstoui64_l(
        _String: *const wchar_t,
        _EndPtr: *mut *mut wchar_t,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _wfullpath(
        _Buffer: *mut wchar_t,
        _Path: *const wchar_t,
        _BufferCount: usize,
    ) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wmakepath_s(
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _Drive: *const wchar_t,
        _Dir: *const wchar_t,
        _Filename: *const wchar_t,
        _Ext: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wmakepath(
        _Buffer: *mut wchar_t,
        _Drive: *const wchar_t,
        _Dir: *const wchar_t,
        _Filename: *const wchar_t,
        _Ext: *const wchar_t,
    );
}
unsafe extern "C" {
    pub fn _wperror(_ErrorMessage: *const wchar_t);
}
unsafe extern "C" {
    pub fn _wsplitpath(
        _FullPath: *const wchar_t,
        _Drive: *mut wchar_t,
        _Dir: *mut wchar_t,
        _Filename: *mut wchar_t,
        _Ext: *mut wchar_t,
    );
}
unsafe extern "C" {
    pub fn _wsplitpath_s(
        _FullPath: *const wchar_t,
        _Drive: *mut wchar_t,
        _DriveCount: usize,
        _Dir: *mut wchar_t,
        _DirCount: usize,
        _Filename: *mut wchar_t,
        _FilenameCount: usize,
        _Ext: *mut wchar_t,
        _ExtCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wdupenv_s(
        _Buffer: *mut *mut wchar_t,
        _BufferCount: *mut usize,
        _VarName: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wgetenv(_VarName: *const wchar_t) -> *mut wchar_t;
}
unsafe extern "C" {
    pub fn _wgetenv_s(
        _RequiredCount: *mut usize,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
        _VarName: *const wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wputenv(_EnvString: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wputenv_s(_Name: *const wchar_t, _Value: *const wchar_t) -> errno_t;
}
unsafe extern "C" {
    pub fn _wsearchenv_s(
        _Filename: *const wchar_t,
        _VarName: *const wchar_t,
        _Buffer: *mut wchar_t,
        _BufferCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wsearchenv(
        _Filename: *const wchar_t,
        _VarName: *const wchar_t,
        _ResultPath: *mut wchar_t,
    );
}
unsafe extern "C" {
    pub fn _wsystem(_Command: *const wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _swab(
        _Buf1: *mut ::std::os::raw::c_char,
        _Buf2: *mut ::std::os::raw::c_char,
        _SizeInBytes: ::std::os::raw::c_int,
    );
}
unsafe extern "C" {
    pub fn exit(_Code: ::std::os::raw::c_int) -> !;
}
unsafe extern "C" {
    pub fn _exit(_Code: ::std::os::raw::c_int) -> !;
}
unsafe extern "C" {
    pub fn _Exit(_Code: ::std::os::raw::c_int) -> !;
}
unsafe extern "C" {
    pub fn quick_exit(_Code: ::std::os::raw::c_int) -> !;
}
unsafe extern "C" {
    pub fn abort() -> !;
}
unsafe extern "C" {
    pub fn _set_abort_behavior(
        _Flags: ::std::os::raw::c_uint,
        _Mask: ::std::os::raw::c_uint,
    ) -> ::std::os::raw::c_uint;
}
pub type _onexit_t = ::std::option::Option<unsafe extern "C" fn() -> ::std::os::raw::c_int>;
unsafe extern "C" {
    pub fn atexit(arg1: ::std::option::Option<unsafe extern "C" fn()>) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _onexit(_Func: _onexit_t) -> _onexit_t;
}
unsafe extern "C" {
    pub fn at_quick_exit(
        arg1: ::std::option::Option<unsafe extern "C" fn()>,
    ) -> ::std::os::raw::c_int;
}
pub type _purecall_handler = ::std::option::Option<unsafe extern "C" fn()>;
pub type _invalid_parameter_handler = ::std::option::Option<
    unsafe extern "C" fn(
        arg1: *const wchar_t,
        arg2: *const wchar_t,
        arg3: *const wchar_t,
        arg4: ::std::os::raw::c_uint,
        arg5: usize,
    ),
>;
unsafe extern "C" {
    pub fn _set_purecall_handler(_Handler: _purecall_handler) -> _purecall_handler;
}
unsafe extern "C" {
    pub fn _get_purecall_handler() -> _purecall_handler;
}
unsafe extern "C" {
    pub fn _set_invalid_parameter_handler(
        _Handler: _invalid_parameter_handler,
    ) -> _invalid_parameter_handler;
}
unsafe extern "C" {
    pub fn _get_invalid_parameter_handler() -> _invalid_parameter_handler;
}
unsafe extern "C" {
    pub fn _set_thread_local_invalid_parameter_handler(
        _Handler: _invalid_parameter_handler,
    ) -> _invalid_parameter_handler;
}
unsafe extern "C" {
    pub fn _get_thread_local_invalid_parameter_handler() -> _invalid_parameter_handler;
}
unsafe extern "C" {
    pub fn _set_error_mode(_Mode: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __sys_errlist() -> *mut *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn __sys_nerr() -> *mut ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn perror(_ErrMsg: *const ::std::os::raw::c_char);
}
unsafe extern "C" {
    pub fn __p__pgmptr() -> *mut *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn __p__wpgmptr() -> *mut *mut wchar_t;
}
unsafe extern "C" {
    pub fn __p__fmode() -> *mut ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _get_pgmptr(_Value: *mut *mut ::std::os::raw::c_char) -> errno_t;
}
unsafe extern "C" {
    pub fn _get_wpgmptr(_Value: *mut *mut wchar_t) -> errno_t;
}
unsafe extern "C" {
    pub fn _set_fmode(_Mode: ::std::os::raw::c_int) -> errno_t;
}
unsafe extern "C" {
    pub fn _get_fmode(_PMode: *mut ::std::os::raw::c_int) -> errno_t;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _div_t {
    pub quot: ::std::os::raw::c_int,
    pub rem: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _div_t"][::std::mem::size_of::<_div_t>() - 8usize];
    ["Alignment of _div_t"][::std::mem::align_of::<_div_t>() - 4usize];
    ["Offset of field: _div_t::quot"][::std::mem::offset_of!(_div_t, quot) - 0usize];
    ["Offset of field: _div_t::rem"][::std::mem::offset_of!(_div_t, rem) - 4usize];
};
pub type div_t = _div_t;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ldiv_t {
    pub quot: ::std::os::raw::c_long,
    pub rem: ::std::os::raw::c_long,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ldiv_t"][::std::mem::size_of::<_ldiv_t>() - 8usize];
    ["Alignment of _ldiv_t"][::std::mem::align_of::<_ldiv_t>() - 4usize];
    ["Offset of field: _ldiv_t::quot"][::std::mem::offset_of!(_ldiv_t, quot) - 0usize];
    ["Offset of field: _ldiv_t::rem"][::std::mem::offset_of!(_ldiv_t, rem) - 4usize];
};
pub type ldiv_t = _ldiv_t;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _lldiv_t {
    pub quot: ::std::os::raw::c_longlong,
    pub rem: ::std::os::raw::c_longlong,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _lldiv_t"][::std::mem::size_of::<_lldiv_t>() - 16usize];
    ["Alignment of _lldiv_t"][::std::mem::align_of::<_lldiv_t>() - 8usize];
    ["Offset of field: _lldiv_t::quot"][::std::mem::offset_of!(_lldiv_t, quot) - 0usize];
    ["Offset of field: _lldiv_t::rem"][::std::mem::offset_of!(_lldiv_t, rem) - 8usize];
};
pub type lldiv_t = _lldiv_t;
unsafe extern "C" {
    pub fn abs(_Number: ::std::os::raw::c_int) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn labs(_Number: ::std::os::raw::c_long) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn llabs(_Number: ::std::os::raw::c_longlong) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _abs64(_Number: ::std::os::raw::c_longlong) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _byteswap_ushort(_Number: ::std::os::raw::c_ushort) -> ::std::os::raw::c_ushort;
}
unsafe extern "C" {
    pub fn _byteswap_ulong(_Number: ::std::os::raw::c_ulong) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _byteswap_uint64(_Number: ::std::os::raw::c_ulonglong) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn div(_Numerator: ::std::os::raw::c_int, _Denominator: ::std::os::raw::c_int) -> div_t;
}
unsafe extern "C" {
    pub fn ldiv(_Numerator: ::std::os::raw::c_long, _Denominator: ::std::os::raw::c_long)
        -> ldiv_t;
}
unsafe extern "C" {
    pub fn lldiv(
        _Numerator: ::std::os::raw::c_longlong,
        _Denominator: ::std::os::raw::c_longlong,
    ) -> lldiv_t;
}
unsafe extern "C" {
    pub fn _lrotl(
        _Value: ::std::os::raw::c_ulong,
        _Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _lrotr(
        _Value: ::std::os::raw::c_ulong,
        _Shift: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn srand(_Seed: ::std::os::raw::c_uint);
}
unsafe extern "C" {
    pub fn rand() -> ::std::os::raw::c_int;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LDOUBLE {
    pub ld: [::std::os::raw::c_uchar; 10usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDOUBLE"][::std::mem::size_of::<_LDOUBLE>() - 10usize];
    ["Alignment of _LDOUBLE"][::std::mem::align_of::<_LDOUBLE>() - 1usize];
    ["Offset of field: _LDOUBLE::ld"][::std::mem::offset_of!(_LDOUBLE, ld) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRT_DOUBLE {
    pub x: f64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRT_DOUBLE"][::std::mem::size_of::<_CRT_DOUBLE>() - 8usize];
    ["Alignment of _CRT_DOUBLE"][::std::mem::align_of::<_CRT_DOUBLE>() - 8usize];
    ["Offset of field: _CRT_DOUBLE::x"][::std::mem::offset_of!(_CRT_DOUBLE, x) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _CRT_FLOAT {
    pub f: f32,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _CRT_FLOAT"][::std::mem::size_of::<_CRT_FLOAT>() - 4usize];
    ["Alignment of _CRT_FLOAT"][::std::mem::align_of::<_CRT_FLOAT>() - 4usize];
    ["Offset of field: _CRT_FLOAT::f"][::std::mem::offset_of!(_CRT_FLOAT, f) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LONGDOUBLE {
    pub x: f64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LONGDOUBLE"][::std::mem::size_of::<_LONGDOUBLE>() - 8usize];
    ["Alignment of _LONGDOUBLE"][::std::mem::align_of::<_LONGDOUBLE>() - 8usize];
    ["Offset of field: _LONGDOUBLE::x"][::std::mem::offset_of!(_LONGDOUBLE, x) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _LDBL12 {
    pub ld12: [::std::os::raw::c_uchar; 12usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _LDBL12"][::std::mem::size_of::<_LDBL12>() - 12usize];
    ["Alignment of _LDBL12"][::std::mem::align_of::<_LDBL12>() - 1usize];
    ["Offset of field: _LDBL12::ld12"][::std::mem::offset_of!(_LDBL12, ld12) - 0usize];
};
unsafe extern "C" {
    pub fn atof(_String: *const ::std::os::raw::c_char) -> f64;
}
unsafe extern "C" {
    pub fn atoi(_String: *const ::std::os::raw::c_char) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn atol(_String: *const ::std::os::raw::c_char) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn atoll(_String: *const ::std::os::raw::c_char) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _atoi64(_String: *const ::std::os::raw::c_char) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _atof_l(_String: *const ::std::os::raw::c_char, _Locale: _locale_t) -> f64;
}
unsafe extern "C" {
    pub fn _atoi_l(
        _String: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atol_l(
        _String: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _atoll_l(
        _String: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _atoi64_l(
        _String: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _atoflt(
        _Result: *mut _CRT_FLOAT,
        _String: *const ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atodbl(
        _Result: *mut _CRT_DOUBLE,
        _String: *mut ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atoldbl(
        _Result: *mut _LDOUBLE,
        _String: *mut ::std::os::raw::c_char,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atoflt_l(
        _Result: *mut _CRT_FLOAT,
        _String: *const ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atodbl_l(
        _Result: *mut _CRT_DOUBLE,
        _String: *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _atoldbl_l(
        _Result: *mut _LDOUBLE,
        _String: *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn strtof(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
    ) -> f32;
}
unsafe extern "C" {
    pub fn _strtof_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> f32;
}
unsafe extern "C" {
    pub fn strtod(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
    ) -> f64;
}
unsafe extern "C" {
    pub fn _strtod_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> f64;
}
unsafe extern "C" {
    pub fn strtold(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
    ) -> f64;
}
unsafe extern "C" {
    pub fn _strtold_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Locale: _locale_t,
    ) -> f64;
}
unsafe extern "C" {
    pub fn strtol(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn _strtol_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_long;
}
unsafe extern "C" {
    pub fn strtoll(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _strtoll_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn strtoul(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn _strtoul_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn strtoull(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strtoull_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strtoi64(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _strtoi64_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_longlong;
}
unsafe extern "C" {
    pub fn _strtoui64(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _strtoui64_l(
        _String: *const ::std::os::raw::c_char,
        _EndPtr: *mut *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_ulonglong;
}
unsafe extern "C" {
    pub fn _itoa_s(
        _Value: ::std::os::raw::c_int,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _itoa(
        _Value: ::std::os::raw::c_int,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _ltoa_s(
        _Value: ::std::os::raw::c_long,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ltoa(
        _Value: ::std::os::raw::c_long,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _ultoa_s(
        _Value: ::std::os::raw::c_ulong,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ultoa(
        _Value: ::std::os::raw::c_ulong,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _i64toa_s(
        _Value: ::std::os::raw::c_longlong,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _i64toa(
        _Value: ::std::os::raw::c_longlong,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _ui64toa_s(
        _Value: ::std::os::raw::c_ulonglong,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Radix: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ui64toa(
        _Value: ::std::os::raw::c_ulonglong,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _ecvt_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _ecvt(
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _fcvt_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Value: f64,
        _FractionalDigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _fcvt(
        _Value: f64,
        _FractionalDigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _gcvt_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _gcvt(
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
        _Buffer: *mut ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn mblen(_Ch: *const ::std::os::raw::c_char, _MaxCount: usize) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _mblen_l(
        _Ch: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _mbstrlen(_String: *const ::std::os::raw::c_char) -> usize;
}
unsafe extern "C" {
    pub fn _mbstrlen_l(_String: *const ::std::os::raw::c_char, _Locale: _locale_t) -> usize;
}
unsafe extern "C" {
    pub fn _mbstrnlen(_String: *const ::std::os::raw::c_char, _MaxCount: usize) -> usize;
}
unsafe extern "C" {
    pub fn _mbstrnlen_l(
        _String: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> usize;
}
unsafe extern "C" {
    pub fn mbtowc(
        _DstCh: *mut wchar_t,
        _SrcCh: *const ::std::os::raw::c_char,
        _SrcSizeInBytes: usize,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _mbtowc_l(
        _DstCh: *mut wchar_t,
        _SrcCh: *const ::std::os::raw::c_char,
        _SrcSizeInBytes: usize,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn mbstowcs_s(
        _PtNumOfCharConverted: *mut usize,
        _DstBuf: *mut wchar_t,
        _SizeInWords: usize,
        _SrcBuf: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn mbstowcs(
        _Dest: *mut wchar_t,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: usize,
    ) -> usize;
}
unsafe extern "C" {
    pub fn _mbstowcs_s_l(
        _PtNumOfCharConverted: *mut usize,
        _DstBuf: *mut wchar_t,
        _SizeInWords: usize,
        _SrcBuf: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _mbstowcs_l(
        _Dest: *mut wchar_t,
        _Source: *const ::std::os::raw::c_char,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> usize;
}
unsafe extern "C" {
    pub fn wctomb(_MbCh: *mut ::std::os::raw::c_char, _WCh: wchar_t) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _wctomb_l(
        _MbCh: *mut ::std::os::raw::c_char,
        _WCh: wchar_t,
        _Locale: _locale_t,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn wctomb_s(
        _SizeConverted: *mut ::std::os::raw::c_int,
        _MbCh: *mut ::std::os::raw::c_char,
        _SizeInBytes: rsize_t,
        _WCh: wchar_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wctomb_s_l(
        _SizeConverted: *mut ::std::os::raw::c_int,
        _MbCh: *mut ::std::os::raw::c_char,
        _SizeInBytes: usize,
        _WCh: wchar_t,
        _Locale: _locale_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcstombs_s(
        _PtNumOfCharConverted: *mut usize,
        _Dst: *mut ::std::os::raw::c_char,
        _DstSizeInBytes: usize,
        _Src: *const wchar_t,
        _MaxCountInBytes: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn wcstombs(
        _Dest: *mut ::std::os::raw::c_char,
        _Source: *const wchar_t,
        _MaxCount: usize,
    ) -> usize;
}
unsafe extern "C" {
    pub fn _wcstombs_s_l(
        _PtNumOfCharConverted: *mut usize,
        _Dst: *mut ::std::os::raw::c_char,
        _DstSizeInBytes: usize,
        _Src: *const wchar_t,
        _MaxCountInBytes: usize,
        _Locale: _locale_t,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _wcstombs_l(
        _Dest: *mut ::std::os::raw::c_char,
        _Source: *const wchar_t,
        _MaxCount: usize,
        _Locale: _locale_t,
    ) -> usize;
}
unsafe extern "C" {
    pub fn _fullpath(
        _Buffer: *mut ::std::os::raw::c_char,
        _Path: *const ::std::os::raw::c_char,
        _BufferCount: usize,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _makepath_s(
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
        _Drive: *const ::std::os::raw::c_char,
        _Dir: *const ::std::os::raw::c_char,
        _Filename: *const ::std::os::raw::c_char,
        _Ext: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _makepath(
        _Buffer: *mut ::std::os::raw::c_char,
        _Drive: *const ::std::os::raw::c_char,
        _Dir: *const ::std::os::raw::c_char,
        _Filename: *const ::std::os::raw::c_char,
        _Ext: *const ::std::os::raw::c_char,
    );
}
unsafe extern "C" {
    pub fn _splitpath(
        _FullPath: *const ::std::os::raw::c_char,
        _Drive: *mut ::std::os::raw::c_char,
        _Dir: *mut ::std::os::raw::c_char,
        _Filename: *mut ::std::os::raw::c_char,
        _Ext: *mut ::std::os::raw::c_char,
    );
}
unsafe extern "C" {
    pub fn _splitpath_s(
        _FullPath: *const ::std::os::raw::c_char,
        _Drive: *mut ::std::os::raw::c_char,
        _DriveCount: usize,
        _Dir: *mut ::std::os::raw::c_char,
        _DirCount: usize,
        _Filename: *mut ::std::os::raw::c_char,
        _FilenameCount: usize,
        _Ext: *mut ::std::os::raw::c_char,
        _ExtCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn getenv_s(
        _RequiredCount: *mut usize,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: rsize_t,
        _VarName: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn __p___argc() -> *mut ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn __p___argv() -> *mut *mut *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn __p___wargv() -> *mut *mut *mut wchar_t;
}
unsafe extern "C" {
    pub fn __p__environ() -> *mut *mut *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn __p__wenviron() -> *mut *mut *mut wchar_t;
}
unsafe extern "C" {
    pub fn getenv(_VarName: *const ::std::os::raw::c_char) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn _dupenv_s(
        _Buffer: *mut *mut ::std::os::raw::c_char,
        _BufferCount: *mut usize,
        _VarName: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn system(_Command: *const ::std::os::raw::c_char) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _putenv(_EnvString: *const ::std::os::raw::c_char) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn _putenv_s(
        _Name: *const ::std::os::raw::c_char,
        _Value: *const ::std::os::raw::c_char,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _searchenv_s(
        _Filename: *const ::std::os::raw::c_char,
        _VarName: *const ::std::os::raw::c_char,
        _Buffer: *mut ::std::os::raw::c_char,
        _BufferCount: usize,
    ) -> errno_t;
}
unsafe extern "C" {
    pub fn _searchenv(
        _Filename: *const ::std::os::raw::c_char,
        _VarName: *const ::std::os::raw::c_char,
        _Buffer: *mut ::std::os::raw::c_char,
    );
}
unsafe extern "C" {
    pub fn _seterrormode(_Mode: ::std::os::raw::c_int);
}
unsafe extern "C" {
    pub fn _beep(_Frequency: ::std::os::raw::c_uint, _Duration: ::std::os::raw::c_uint);
}
unsafe extern "C" {
    pub fn _sleep(_Duration: ::std::os::raw::c_ulong);
}
unsafe extern "C" {
    pub fn ecvt(
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn fcvt(
        _Value: f64,
        _FractionalDigitCount: ::std::os::raw::c_int,
        _PtDec: *mut ::std::os::raw::c_int,
        _PtSign: *mut ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn gcvt(
        _Value: f64,
        _DigitCount: ::std::os::raw::c_int,
        _DstBuf: *mut ::std::os::raw::c_char,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn itoa(
        _Value: ::std::os::raw::c_int,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn ltoa(
        _Value: ::std::os::raw::c_long,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn swab(
        _Buf1: *mut ::std::os::raw::c_char,
        _Buf2: *mut ::std::os::raw::c_char,
        _SizeInBytes: ::std::os::raw::c_int,
    );
}
unsafe extern "C" {
    pub fn ultoa(
        _Value: ::std::os::raw::c_ulong,
        _Buffer: *mut ::std::os::raw::c_char,
        _Radix: ::std::os::raw::c_int,
    ) -> *mut ::std::os::raw::c_char;
}
unsafe extern "C" {
    pub fn putenv(_EnvString: *const ::std::os::raw::c_char) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn onexit(_Func: _onexit_t) -> _onexit_t;
}
pub const tagREGCLS_REGCLS_SINGLEUSE: tagREGCLS = 0;
pub const tagREGCLS_REGCLS_MULTIPLEUSE: tagREGCLS = 1;
pub const tagREGCLS_REGCLS_MULTI_SEPARATE: tagREGCLS = 2;
pub const tagREGCLS_REGCLS_SUSPENDED: tagREGCLS = 4;
pub const tagREGCLS_REGCLS_SURROGATE: tagREGCLS = 8;
pub const tagREGCLS_REGCLS_AGILE: tagREGCLS = 16;
pub type tagREGCLS = ::std::os::raw::c_int;
pub use self::tagREGCLS as REGCLS;
pub const tagCOINITBASE_COINITBASE_MULTITHREADED: tagCOINITBASE = 0;
pub type tagCOINITBASE = ::std::os::raw::c_int;
pub use self::tagCOINITBASE as COINITBASE;
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPUNKNOWN = *mut IUnknown;
unsafe extern "C" {
    pub static IID_IUnknown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUnknownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUnknown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUnknown) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IUnknown) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUnknownVtbl"][::std::mem::size_of::<IUnknownVtbl>() - 24usize];
    ["Alignment of IUnknownVtbl"][::std::mem::align_of::<IUnknownVtbl>() - 8usize];
    ["Offset of field: IUnknownVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUnknownVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUnknownVtbl::AddRef"]
        [::std::mem::offset_of!(IUnknownVtbl, AddRef) - 8usize];
    ["Offset of field: IUnknownVtbl::Release"]
        [::std::mem::offset_of!(IUnknownVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUnknown {
    pub lpVtbl: *mut IUnknownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUnknown"][::std::mem::size_of::<IUnknown>() - 8usize];
    ["Alignment of IUnknown"][::std::mem::align_of::<IUnknown>() - 8usize];
    ["Offset of field: IUnknown::lpVtbl"][::std::mem::offset_of!(IUnknown, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IUnknown_QueryInterface_Proxy(
        This: *mut IUnknown,
        riid: *const IID,
        ppvObject: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IUnknown_QueryInterface_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IUnknown_AddRef_Proxy(This: *mut IUnknown) -> ULONG;
}
unsafe extern "C" {
    pub fn IUnknown_AddRef_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IUnknown_Release_Proxy(This: *mut IUnknown) -> ULONG;
}
unsafe extern "C" {
    pub fn IUnknown_Release_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_AsyncIUnknown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIUnknownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIUnknown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> ULONG>,
    pub Begin_QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIUnknown, riid: *const IID) -> HRESULT,
    >,
    pub Finish_QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIUnknown,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub Begin_AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> HRESULT>,
    pub Finish_AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> ULONG>,
    pub Begin_Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> HRESULT>,
    pub Finish_Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIUnknown) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIUnknownVtbl"][::std::mem::size_of::<AsyncIUnknownVtbl>() - 72usize];
    ["Alignment of AsyncIUnknownVtbl"][::std::mem::align_of::<AsyncIUnknownVtbl>() - 8usize];
    ["Offset of field: AsyncIUnknownVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIUnknownVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIUnknownVtbl::Release"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Release) - 16usize];
    ["Offset of field: AsyncIUnknownVtbl::Begin_QueryInterface"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Begin_QueryInterface) - 24usize];
    ["Offset of field: AsyncIUnknownVtbl::Finish_QueryInterface"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Finish_QueryInterface) - 32usize];
    ["Offset of field: AsyncIUnknownVtbl::Begin_AddRef"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Begin_AddRef) - 40usize];
    ["Offset of field: AsyncIUnknownVtbl::Finish_AddRef"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Finish_AddRef) - 48usize];
    ["Offset of field: AsyncIUnknownVtbl::Begin_Release"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Begin_Release) - 56usize];
    ["Offset of field: AsyncIUnknownVtbl::Finish_Release"]
        [::std::mem::offset_of!(AsyncIUnknownVtbl, Finish_Release) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIUnknown {
    pub lpVtbl: *mut AsyncIUnknownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIUnknown"][::std::mem::size_of::<AsyncIUnknown>() - 8usize];
    ["Alignment of AsyncIUnknown"][::std::mem::align_of::<AsyncIUnknown>() - 8usize];
    ["Offset of field: AsyncIUnknown::lpVtbl"]
        [::std::mem::offset_of!(AsyncIUnknown, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0002_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0002_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPCLASSFACTORY = *mut IClassFactory;
unsafe extern "C" {
    pub static IID_IClassFactory: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClassFactoryVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClassFactory,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IClassFactory) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IClassFactory) -> ULONG>,
    pub CreateInstance: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClassFactory,
            pUnkOuter: *mut IUnknown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub LockServer: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IClassFactory, fLock: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClassFactoryVtbl"][::std::mem::size_of::<IClassFactoryVtbl>() - 40usize];
    ["Alignment of IClassFactoryVtbl"][::std::mem::align_of::<IClassFactoryVtbl>() - 8usize];
    ["Offset of field: IClassFactoryVtbl::QueryInterface"]
        [::std::mem::offset_of!(IClassFactoryVtbl, QueryInterface) - 0usize];
    ["Offset of field: IClassFactoryVtbl::AddRef"]
        [::std::mem::offset_of!(IClassFactoryVtbl, AddRef) - 8usize];
    ["Offset of field: IClassFactoryVtbl::Release"]
        [::std::mem::offset_of!(IClassFactoryVtbl, Release) - 16usize];
    ["Offset of field: IClassFactoryVtbl::CreateInstance"]
        [::std::mem::offset_of!(IClassFactoryVtbl, CreateInstance) - 24usize];
    ["Offset of field: IClassFactoryVtbl::LockServer"]
        [::std::mem::offset_of!(IClassFactoryVtbl, LockServer) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClassFactory {
    pub lpVtbl: *mut IClassFactoryVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClassFactory"][::std::mem::size_of::<IClassFactory>() - 8usize];
    ["Alignment of IClassFactory"][::std::mem::align_of::<IClassFactory>() - 8usize];
    ["Offset of field: IClassFactory::lpVtbl"]
        [::std::mem::offset_of!(IClassFactory, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IClassFactory_RemoteCreateInstance_Proxy(
        This: *mut IClassFactory,
        riid: *const IID,
        ppvObject: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IClassFactory_RemoteCreateInstance_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IClassFactory_RemoteLockServer_Proxy(This: *mut IClassFactory, fLock: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn IClassFactory_RemoteLockServer_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0003_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwnbase_0000_0003_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn IClassFactory_CreateInstance_Proxy(
        This: *mut IClassFactory,
        pUnkOuter: *mut IUnknown,
        riid: *const IID,
        ppvObject: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IClassFactory_CreateInstance_Stub(
        This: *mut IClassFactory,
        riid: *const IID,
        ppvObject: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IClassFactory_LockServer_Proxy(This: *mut IClassFactory, fLock: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn IClassFactory_LockServer_Stub(This: *mut IClassFactory, fLock: BOOL) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumContextProps {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IContext {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IObjContext {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _COSERVERINFO {
    pub dwReserved1: DWORD,
    pub pwszName: LPWSTR,
    pub pAuthInfo: *mut COAUTHINFO,
    pub dwReserved2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _COSERVERINFO"][::std::mem::size_of::<_COSERVERINFO>() - 32usize];
    ["Alignment of _COSERVERINFO"][::std::mem::align_of::<_COSERVERINFO>() - 8usize];
    ["Offset of field: _COSERVERINFO::dwReserved1"]
        [::std::mem::offset_of!(_COSERVERINFO, dwReserved1) - 0usize];
    ["Offset of field: _COSERVERINFO::pwszName"]
        [::std::mem::offset_of!(_COSERVERINFO, pwszName) - 8usize];
    ["Offset of field: _COSERVERINFO::pAuthInfo"]
        [::std::mem::offset_of!(_COSERVERINFO, pAuthInfo) - 16usize];
    ["Offset of field: _COSERVERINFO::dwReserved2"]
        [::std::mem::offset_of!(_COSERVERINFO, dwReserved2) - 24usize];
};
pub type COSERVERINFO = _COSERVERINFO;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPMARSHAL = *mut IMarshal;
unsafe extern "C" {
    pub static IID_IMarshal: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshalVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshal) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshal) -> ULONG>,
    pub GetUnmarshalClass: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
            pCid: *mut CLSID,
        ) -> HRESULT,
    >,
    pub GetMarshalSizeMax: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
            pSize: *mut DWORD,
        ) -> HRESULT,
    >,
    pub MarshalInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal,
            pStm: *mut IStream,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
        ) -> HRESULT,
    >,
    pub UnmarshalInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal,
            pStm: *mut IStream,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub ReleaseMarshalData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshal, pStm: *mut IStream) -> HRESULT,
    >,
    pub DisconnectObject: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshal, dwReserved: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshalVtbl"][::std::mem::size_of::<IMarshalVtbl>() - 72usize];
    ["Alignment of IMarshalVtbl"][::std::mem::align_of::<IMarshalVtbl>() - 8usize];
    ["Offset of field: IMarshalVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMarshalVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMarshalVtbl::AddRef"]
        [::std::mem::offset_of!(IMarshalVtbl, AddRef) - 8usize];
    ["Offset of field: IMarshalVtbl::Release"]
        [::std::mem::offset_of!(IMarshalVtbl, Release) - 16usize];
    ["Offset of field: IMarshalVtbl::GetUnmarshalClass"]
        [::std::mem::offset_of!(IMarshalVtbl, GetUnmarshalClass) - 24usize];
    ["Offset of field: IMarshalVtbl::GetMarshalSizeMax"]
        [::std::mem::offset_of!(IMarshalVtbl, GetMarshalSizeMax) - 32usize];
    ["Offset of field: IMarshalVtbl::MarshalInterface"]
        [::std::mem::offset_of!(IMarshalVtbl, MarshalInterface) - 40usize];
    ["Offset of field: IMarshalVtbl::UnmarshalInterface"]
        [::std::mem::offset_of!(IMarshalVtbl, UnmarshalInterface) - 48usize];
    ["Offset of field: IMarshalVtbl::ReleaseMarshalData"]
        [::std::mem::offset_of!(IMarshalVtbl, ReleaseMarshalData) - 56usize];
    ["Offset of field: IMarshalVtbl::DisconnectObject"]
        [::std::mem::offset_of!(IMarshalVtbl, DisconnectObject) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshal {
    pub lpVtbl: *mut IMarshalVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshal"][::std::mem::size_of::<IMarshal>() - 8usize];
    ["Alignment of IMarshal"][::std::mem::align_of::<IMarshal>() - 8usize];
    ["Offset of field: IMarshal::lpVtbl"][::std::mem::offset_of!(IMarshal, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_INoMarshal: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct INoMarshalVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut INoMarshal,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut INoMarshal) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut INoMarshal) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of INoMarshalVtbl"][::std::mem::size_of::<INoMarshalVtbl>() - 24usize];
    ["Alignment of INoMarshalVtbl"][::std::mem::align_of::<INoMarshalVtbl>() - 8usize];
    ["Offset of field: INoMarshalVtbl::QueryInterface"]
        [::std::mem::offset_of!(INoMarshalVtbl, QueryInterface) - 0usize];
    ["Offset of field: INoMarshalVtbl::AddRef"]
        [::std::mem::offset_of!(INoMarshalVtbl, AddRef) - 8usize];
    ["Offset of field: INoMarshalVtbl::Release"]
        [::std::mem::offset_of!(INoMarshalVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct INoMarshal {
    pub lpVtbl: *mut INoMarshalVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of INoMarshal"][::std::mem::size_of::<INoMarshal>() - 8usize];
    ["Alignment of INoMarshal"][::std::mem::align_of::<INoMarshal>() - 8usize];
    ["Offset of field: INoMarshal::lpVtbl"][::std::mem::offset_of!(INoMarshal, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IAgileObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAgileObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAgileObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAgileObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAgileObject) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAgileObjectVtbl"][::std::mem::size_of::<IAgileObjectVtbl>() - 24usize];
    ["Alignment of IAgileObjectVtbl"][::std::mem::align_of::<IAgileObjectVtbl>() - 8usize];
    ["Offset of field: IAgileObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAgileObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAgileObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IAgileObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IAgileObjectVtbl::Release"]
        [::std::mem::offset_of!(IAgileObjectVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAgileObject {
    pub lpVtbl: *mut IAgileObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAgileObject"][::std::mem::size_of::<IAgileObject>() - 8usize];
    ["Alignment of IAgileObject"][::std::mem::align_of::<IAgileObject>() - 8usize];
    ["Offset of field: IAgileObject::lpVtbl"]
        [::std::mem::offset_of!(IAgileObject, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0003_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0003_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_UNCATEGORIZED: tagACTIVATIONTYPE = 0;
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_FROM_MONIKER: tagACTIVATIONTYPE = 1;
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_FROM_DATA: tagACTIVATIONTYPE = 2;
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_FROM_STORAGE: tagACTIVATIONTYPE = 4;
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_FROM_STREAM: tagACTIVATIONTYPE = 8;
pub const tagACTIVATIONTYPE_ACTIVATIONTYPE_FROM_FILE: tagACTIVATIONTYPE = 16;
pub type tagACTIVATIONTYPE = ::std::os::raw::c_int;
pub use self::tagACTIVATIONTYPE as ACTIVATIONTYPE;
unsafe extern "C" {
    pub static IID_IActivationFilter: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IActivationFilterVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IActivationFilter,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IActivationFilter) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IActivationFilter) -> ULONG>,
    pub HandleActivation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IActivationFilter,
            dwActivationType: DWORD,
            rclsid: *const IID,
            pReplacementClsId: *mut CLSID,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IActivationFilterVtbl"][::std::mem::size_of::<IActivationFilterVtbl>() - 32usize];
    ["Alignment of IActivationFilterVtbl"]
        [::std::mem::align_of::<IActivationFilterVtbl>() - 8usize];
    ["Offset of field: IActivationFilterVtbl::QueryInterface"]
        [::std::mem::offset_of!(IActivationFilterVtbl, QueryInterface) - 0usize];
    ["Offset of field: IActivationFilterVtbl::AddRef"]
        [::std::mem::offset_of!(IActivationFilterVtbl, AddRef) - 8usize];
    ["Offset of field: IActivationFilterVtbl::Release"]
        [::std::mem::offset_of!(IActivationFilterVtbl, Release) - 16usize];
    ["Offset of field: IActivationFilterVtbl::HandleActivation"]
        [::std::mem::offset_of!(IActivationFilterVtbl, HandleActivation) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IActivationFilter {
    pub lpVtbl: *mut IActivationFilterVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IActivationFilter"][::std::mem::size_of::<IActivationFilter>() - 8usize];
    ["Alignment of IActivationFilter"][::std::mem::align_of::<IActivationFilter>() - 8usize];
    ["Offset of field: IActivationFilter::lpVtbl"]
        [::std::mem::offset_of!(IActivationFilter, lpVtbl) - 0usize];
};
pub type LPMARSHAL2 = *mut IMarshal2;
unsafe extern "C" {
    pub static IID_IMarshal2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshal2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshal2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshal2) -> ULONG>,
    pub GetUnmarshalClass: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal2,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
            pCid: *mut CLSID,
        ) -> HRESULT,
    >,
    pub GetMarshalSizeMax: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal2,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
            pSize: *mut DWORD,
        ) -> HRESULT,
    >,
    pub MarshalInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal2,
            pStm: *mut IStream,
            riid: *const IID,
            pv: *mut ::std::os::raw::c_void,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            mshlflags: DWORD,
        ) -> HRESULT,
    >,
    pub UnmarshalInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshal2,
            pStm: *mut IStream,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub ReleaseMarshalData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshal2, pStm: *mut IStream) -> HRESULT,
    >,
    pub DisconnectObject: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshal2, dwReserved: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshal2Vtbl"][::std::mem::size_of::<IMarshal2Vtbl>() - 72usize];
    ["Alignment of IMarshal2Vtbl"][::std::mem::align_of::<IMarshal2Vtbl>() - 8usize];
    ["Offset of field: IMarshal2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IMarshal2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IMarshal2Vtbl::AddRef"]
        [::std::mem::offset_of!(IMarshal2Vtbl, AddRef) - 8usize];
    ["Offset of field: IMarshal2Vtbl::Release"]
        [::std::mem::offset_of!(IMarshal2Vtbl, Release) - 16usize];
    ["Offset of field: IMarshal2Vtbl::GetUnmarshalClass"]
        [::std::mem::offset_of!(IMarshal2Vtbl, GetUnmarshalClass) - 24usize];
    ["Offset of field: IMarshal2Vtbl::GetMarshalSizeMax"]
        [::std::mem::offset_of!(IMarshal2Vtbl, GetMarshalSizeMax) - 32usize];
    ["Offset of field: IMarshal2Vtbl::MarshalInterface"]
        [::std::mem::offset_of!(IMarshal2Vtbl, MarshalInterface) - 40usize];
    ["Offset of field: IMarshal2Vtbl::UnmarshalInterface"]
        [::std::mem::offset_of!(IMarshal2Vtbl, UnmarshalInterface) - 48usize];
    ["Offset of field: IMarshal2Vtbl::ReleaseMarshalData"]
        [::std::mem::offset_of!(IMarshal2Vtbl, ReleaseMarshalData) - 56usize];
    ["Offset of field: IMarshal2Vtbl::DisconnectObject"]
        [::std::mem::offset_of!(IMarshal2Vtbl, DisconnectObject) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshal2 {
    pub lpVtbl: *mut IMarshal2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshal2"][::std::mem::size_of::<IMarshal2>() - 8usize];
    ["Alignment of IMarshal2"][::std::mem::align_of::<IMarshal2>() - 8usize];
    ["Offset of field: IMarshal2::lpVtbl"][::std::mem::offset_of!(IMarshal2, lpVtbl) - 0usize];
};
pub type LPMALLOC = *mut IMalloc;
unsafe extern "C" {
    pub static IID_IMalloc: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMallocVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMalloc,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMalloc) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMalloc) -> ULONG>,
    pub Alloc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMalloc, cb: SIZE_T) -> *mut ::std::os::raw::c_void,
    >,
    pub Realloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMalloc,
            pv: *mut ::std::os::raw::c_void,
            cb: SIZE_T,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub Free: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMalloc, pv: *mut ::std::os::raw::c_void),
    >,
    pub GetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMalloc, pv: *mut ::std::os::raw::c_void) -> SIZE_T,
    >,
    pub DidAlloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMalloc,
            pv: *mut ::std::os::raw::c_void,
        ) -> ::std::os::raw::c_int,
    >,
    pub HeapMinimize: ::std::option::Option<unsafe extern "C" fn(This: *mut IMalloc)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMallocVtbl"][::std::mem::size_of::<IMallocVtbl>() - 72usize];
    ["Alignment of IMallocVtbl"][::std::mem::align_of::<IMallocVtbl>() - 8usize];
    ["Offset of field: IMallocVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMallocVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMallocVtbl::AddRef"][::std::mem::offset_of!(IMallocVtbl, AddRef) - 8usize];
    ["Offset of field: IMallocVtbl::Release"]
        [::std::mem::offset_of!(IMallocVtbl, Release) - 16usize];
    ["Offset of field: IMallocVtbl::Alloc"][::std::mem::offset_of!(IMallocVtbl, Alloc) - 24usize];
    ["Offset of field: IMallocVtbl::Realloc"]
        [::std::mem::offset_of!(IMallocVtbl, Realloc) - 32usize];
    ["Offset of field: IMallocVtbl::Free"][::std::mem::offset_of!(IMallocVtbl, Free) - 40usize];
    ["Offset of field: IMallocVtbl::GetSize"]
        [::std::mem::offset_of!(IMallocVtbl, GetSize) - 48usize];
    ["Offset of field: IMallocVtbl::DidAlloc"]
        [::std::mem::offset_of!(IMallocVtbl, DidAlloc) - 56usize];
    ["Offset of field: IMallocVtbl::HeapMinimize"]
        [::std::mem::offset_of!(IMallocVtbl, HeapMinimize) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMalloc {
    pub lpVtbl: *mut IMallocVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMalloc"][::std::mem::size_of::<IMalloc>() - 8usize];
    ["Alignment of IMalloc"][::std::mem::align_of::<IMalloc>() - 8usize];
    ["Offset of field: IMalloc::lpVtbl"][::std::mem::offset_of!(IMalloc, lpVtbl) - 0usize];
};
pub type LPSTDMARSHALINFO = *mut IStdMarshalInfo;
unsafe extern "C" {
    pub static IID_IStdMarshalInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStdMarshalInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStdMarshalInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IStdMarshalInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IStdMarshalInfo) -> ULONG>,
    pub GetClassForHandler: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStdMarshalInfo,
            dwDestContext: DWORD,
            pvDestContext: *mut ::std::os::raw::c_void,
            pClsid: *mut CLSID,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStdMarshalInfoVtbl"][::std::mem::size_of::<IStdMarshalInfoVtbl>() - 32usize];
    ["Alignment of IStdMarshalInfoVtbl"][::std::mem::align_of::<IStdMarshalInfoVtbl>() - 8usize];
    ["Offset of field: IStdMarshalInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IStdMarshalInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IStdMarshalInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IStdMarshalInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IStdMarshalInfoVtbl::Release"]
        [::std::mem::offset_of!(IStdMarshalInfoVtbl, Release) - 16usize];
    ["Offset of field: IStdMarshalInfoVtbl::GetClassForHandler"]
        [::std::mem::offset_of!(IStdMarshalInfoVtbl, GetClassForHandler) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStdMarshalInfo {
    pub lpVtbl: *mut IStdMarshalInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStdMarshalInfo"][::std::mem::size_of::<IStdMarshalInfo>() - 8usize];
    ["Alignment of IStdMarshalInfo"][::std::mem::align_of::<IStdMarshalInfo>() - 8usize];
    ["Offset of field: IStdMarshalInfo::lpVtbl"]
        [::std::mem::offset_of!(IStdMarshalInfo, lpVtbl) - 0usize];
};
pub type LPEXTERNALCONNECTION = *mut IExternalConnection;
pub const tagEXTCONN_EXTCONN_STRONG: tagEXTCONN = 1;
pub const tagEXTCONN_EXTCONN_WEAK: tagEXTCONN = 2;
pub const tagEXTCONN_EXTCONN_CALLABLE: tagEXTCONN = 4;
pub type tagEXTCONN = ::std::os::raw::c_int;
pub use self::tagEXTCONN as EXTCONN;
unsafe extern "C" {
    pub static IID_IExternalConnection: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IExternalConnectionVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IExternalConnection,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IExternalConnection) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IExternalConnection) -> ULONG>,
    pub AddConnection: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IExternalConnection,
            extconn: DWORD,
            reserved: DWORD,
        ) -> DWORD,
    >,
    pub ReleaseConnection: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IExternalConnection,
            extconn: DWORD,
            reserved: DWORD,
            fLastReleaseCloses: BOOL,
        ) -> DWORD,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IExternalConnectionVtbl"][::std::mem::size_of::<IExternalConnectionVtbl>() - 40usize];
    ["Alignment of IExternalConnectionVtbl"]
        [::std::mem::align_of::<IExternalConnectionVtbl>() - 8usize];
    ["Offset of field: IExternalConnectionVtbl::QueryInterface"]
        [::std::mem::offset_of!(IExternalConnectionVtbl, QueryInterface) - 0usize];
    ["Offset of field: IExternalConnectionVtbl::AddRef"]
        [::std::mem::offset_of!(IExternalConnectionVtbl, AddRef) - 8usize];
    ["Offset of field: IExternalConnectionVtbl::Release"]
        [::std::mem::offset_of!(IExternalConnectionVtbl, Release) - 16usize];
    ["Offset of field: IExternalConnectionVtbl::AddConnection"]
        [::std::mem::offset_of!(IExternalConnectionVtbl, AddConnection) - 24usize];
    ["Offset of field: IExternalConnectionVtbl::ReleaseConnection"]
        [::std::mem::offset_of!(IExternalConnectionVtbl, ReleaseConnection) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IExternalConnection {
    pub lpVtbl: *mut IExternalConnectionVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IExternalConnection"][::std::mem::size_of::<IExternalConnection>() - 8usize];
    ["Alignment of IExternalConnection"][::std::mem::align_of::<IExternalConnection>() - 8usize];
    ["Offset of field: IExternalConnection::lpVtbl"]
        [::std::mem::offset_of!(IExternalConnection, lpVtbl) - 0usize];
};
pub type LPMULTIQI = *mut IMultiQI;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMULTI_QI {
    pub pIID: *const IID,
    pub pItf: *mut IUnknown,
    pub hr: HRESULT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMULTI_QI"][::std::mem::size_of::<tagMULTI_QI>() - 24usize];
    ["Alignment of tagMULTI_QI"][::std::mem::align_of::<tagMULTI_QI>() - 8usize];
    ["Offset of field: tagMULTI_QI::pIID"][::std::mem::offset_of!(tagMULTI_QI, pIID) - 0usize];
    ["Offset of field: tagMULTI_QI::pItf"][::std::mem::offset_of!(tagMULTI_QI, pItf) - 8usize];
    ["Offset of field: tagMULTI_QI::hr"][::std::mem::offset_of!(tagMULTI_QI, hr) - 16usize];
};
pub type MULTI_QI = tagMULTI_QI;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0008_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0008_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IMultiQI: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMultiQIVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMultiQI,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMultiQI) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMultiQI) -> ULONG>,
    pub QueryMultipleInterfaces: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMultiQI, cMQIs: ULONG, pMQIs: *mut MULTI_QI) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMultiQIVtbl"][::std::mem::size_of::<IMultiQIVtbl>() - 32usize];
    ["Alignment of IMultiQIVtbl"][::std::mem::align_of::<IMultiQIVtbl>() - 8usize];
    ["Offset of field: IMultiQIVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMultiQIVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMultiQIVtbl::AddRef"]
        [::std::mem::offset_of!(IMultiQIVtbl, AddRef) - 8usize];
    ["Offset of field: IMultiQIVtbl::Release"]
        [::std::mem::offset_of!(IMultiQIVtbl, Release) - 16usize];
    ["Offset of field: IMultiQIVtbl::QueryMultipleInterfaces"]
        [::std::mem::offset_of!(IMultiQIVtbl, QueryMultipleInterfaces) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMultiQI {
    pub lpVtbl: *mut IMultiQIVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMultiQI"][::std::mem::size_of::<IMultiQI>() - 8usize];
    ["Alignment of IMultiQI"][::std::mem::align_of::<IMultiQI>() - 8usize];
    ["Offset of field: IMultiQI::lpVtbl"][::std::mem::offset_of!(IMultiQI, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_AsyncIMultiQI: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIMultiQIVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIMultiQI,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIMultiQI) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIMultiQI) -> ULONG>,
    pub Begin_QueryMultipleInterfaces: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIMultiQI,
            cMQIs: ULONG,
            pMQIs: *mut MULTI_QI,
        ) -> HRESULT,
    >,
    pub Finish_QueryMultipleInterfaces: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIMultiQI, pMQIs: *mut MULTI_QI) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIMultiQIVtbl"][::std::mem::size_of::<AsyncIMultiQIVtbl>() - 40usize];
    ["Alignment of AsyncIMultiQIVtbl"][::std::mem::align_of::<AsyncIMultiQIVtbl>() - 8usize];
    ["Offset of field: AsyncIMultiQIVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIMultiQIVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIMultiQIVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIMultiQIVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIMultiQIVtbl::Release"]
        [::std::mem::offset_of!(AsyncIMultiQIVtbl, Release) - 16usize];
    ["Offset of field: AsyncIMultiQIVtbl::Begin_QueryMultipleInterfaces"]
        [::std::mem::offset_of!(AsyncIMultiQIVtbl, Begin_QueryMultipleInterfaces) - 24usize];
    ["Offset of field: AsyncIMultiQIVtbl::Finish_QueryMultipleInterfaces"]
        [::std::mem::offset_of!(AsyncIMultiQIVtbl, Finish_QueryMultipleInterfaces) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIMultiQI {
    pub lpVtbl: *mut AsyncIMultiQIVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIMultiQI"][::std::mem::size_of::<AsyncIMultiQI>() - 8usize];
    ["Alignment of AsyncIMultiQI"][::std::mem::align_of::<AsyncIMultiQI>() - 8usize];
    ["Offset of field: AsyncIMultiQI::lpVtbl"]
        [::std::mem::offset_of!(AsyncIMultiQI, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0009_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0009_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternalUnknown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternalUnknownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternalUnknown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternalUnknown) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternalUnknown) -> ULONG>,
    pub QueryInternalInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternalUnknown,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternalUnknownVtbl"][::std::mem::size_of::<IInternalUnknownVtbl>() - 32usize];
    ["Alignment of IInternalUnknownVtbl"][::std::mem::align_of::<IInternalUnknownVtbl>() - 8usize];
    ["Offset of field: IInternalUnknownVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternalUnknownVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternalUnknownVtbl::AddRef"]
        [::std::mem::offset_of!(IInternalUnknownVtbl, AddRef) - 8usize];
    ["Offset of field: IInternalUnknownVtbl::Release"]
        [::std::mem::offset_of!(IInternalUnknownVtbl, Release) - 16usize];
    ["Offset of field: IInternalUnknownVtbl::QueryInternalInterface"]
        [::std::mem::offset_of!(IInternalUnknownVtbl, QueryInternalInterface) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternalUnknown {
    pub lpVtbl: *mut IInternalUnknownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternalUnknown"][::std::mem::size_of::<IInternalUnknown>() - 8usize];
    ["Alignment of IInternalUnknown"][::std::mem::align_of::<IInternalUnknown>() - 8usize];
    ["Offset of field: IInternalUnknown::lpVtbl"]
        [::std::mem::offset_of!(IInternalUnknown, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0010_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0010_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPENUMUNKNOWN = *mut IEnumUnknown;
unsafe extern "C" {
    pub static IID_IEnumUnknown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumUnknownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumUnknown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumUnknown) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumUnknown) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumUnknown,
            celt: ULONG,
            rgelt: *mut *mut IUnknown,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumUnknown, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumUnknown) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumUnknown, ppenum: *mut *mut IEnumUnknown) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumUnknownVtbl"][::std::mem::size_of::<IEnumUnknownVtbl>() - 56usize];
    ["Alignment of IEnumUnknownVtbl"][::std::mem::align_of::<IEnumUnknownVtbl>() - 8usize];
    ["Offset of field: IEnumUnknownVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumUnknownVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumUnknownVtbl::Release"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, Release) - 16usize];
    ["Offset of field: IEnumUnknownVtbl::Next"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, Next) - 24usize];
    ["Offset of field: IEnumUnknownVtbl::Skip"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, Skip) - 32usize];
    ["Offset of field: IEnumUnknownVtbl::Reset"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, Reset) - 40usize];
    ["Offset of field: IEnumUnknownVtbl::Clone"]
        [::std::mem::offset_of!(IEnumUnknownVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumUnknown {
    pub lpVtbl: *mut IEnumUnknownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumUnknown"][::std::mem::size_of::<IEnumUnknown>() - 8usize];
    ["Alignment of IEnumUnknown"][::std::mem::align_of::<IEnumUnknown>() - 8usize];
    ["Offset of field: IEnumUnknown::lpVtbl"]
        [::std::mem::offset_of!(IEnumUnknown, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumUnknown_RemoteNext_Proxy(
        This: *mut IEnumUnknown,
        celt: ULONG,
        rgelt: *mut *mut IUnknown,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumUnknown_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMSTRING = *mut IEnumString;
unsafe extern "C" {
    pub static IID_IEnumString: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumStringVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumString,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumString) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumString) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumString,
            celt: ULONG,
            rgelt: *mut LPOLESTR,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumString, celt: ULONG) -> HRESULT>,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumString) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumString, ppenum: *mut *mut IEnumString) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumStringVtbl"][::std::mem::size_of::<IEnumStringVtbl>() - 56usize];
    ["Alignment of IEnumStringVtbl"][::std::mem::align_of::<IEnumStringVtbl>() - 8usize];
    ["Offset of field: IEnumStringVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumStringVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumStringVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumStringVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumStringVtbl::Release"]
        [::std::mem::offset_of!(IEnumStringVtbl, Release) - 16usize];
    ["Offset of field: IEnumStringVtbl::Next"]
        [::std::mem::offset_of!(IEnumStringVtbl, Next) - 24usize];
    ["Offset of field: IEnumStringVtbl::Skip"]
        [::std::mem::offset_of!(IEnumStringVtbl, Skip) - 32usize];
    ["Offset of field: IEnumStringVtbl::Reset"]
        [::std::mem::offset_of!(IEnumStringVtbl, Reset) - 40usize];
    ["Offset of field: IEnumStringVtbl::Clone"]
        [::std::mem::offset_of!(IEnumStringVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumString {
    pub lpVtbl: *mut IEnumStringVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumString"][::std::mem::size_of::<IEnumString>() - 8usize];
    ["Alignment of IEnumString"][::std::mem::align_of::<IEnumString>() - 8usize];
    ["Offset of field: IEnumString::lpVtbl"][::std::mem::offset_of!(IEnumString, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumString_RemoteNext_Proxy(
        This: *mut IEnumString,
        celt: ULONG,
        rgelt: *mut LPOLESTR,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumString_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static IID_ISequentialStream: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISequentialStreamVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISequentialStream,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISequentialStream) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISequentialStream) -> ULONG>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISequentialStream,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Write: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISequentialStream,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISequentialStreamVtbl"][::std::mem::size_of::<ISequentialStreamVtbl>() - 40usize];
    ["Alignment of ISequentialStreamVtbl"]
        [::std::mem::align_of::<ISequentialStreamVtbl>() - 8usize];
    ["Offset of field: ISequentialStreamVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISequentialStreamVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISequentialStreamVtbl::AddRef"]
        [::std::mem::offset_of!(ISequentialStreamVtbl, AddRef) - 8usize];
    ["Offset of field: ISequentialStreamVtbl::Release"]
        [::std::mem::offset_of!(ISequentialStreamVtbl, Release) - 16usize];
    ["Offset of field: ISequentialStreamVtbl::Read"]
        [::std::mem::offset_of!(ISequentialStreamVtbl, Read) - 24usize];
    ["Offset of field: ISequentialStreamVtbl::Write"]
        [::std::mem::offset_of!(ISequentialStreamVtbl, Write) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISequentialStream {
    pub lpVtbl: *mut ISequentialStreamVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISequentialStream"][::std::mem::size_of::<ISequentialStream>() - 8usize];
    ["Alignment of ISequentialStream"][::std::mem::align_of::<ISequentialStream>() - 8usize];
    ["Offset of field: ISequentialStream::lpVtbl"]
        [::std::mem::offset_of!(ISequentialStream, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ISequentialStream_RemoteRead_Proxy(
        This: *mut ISequentialStream,
        pv: *mut byte,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_RemoteRead_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ISequentialStream_RemoteWrite_Proxy(
        This: *mut ISequentialStream,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_RemoteWrite_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPSTREAM = *mut IStream;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagSTATSTG {
    pub pwcsName: LPOLESTR,
    pub type_: DWORD,
    pub cbSize: ULARGE_INTEGER,
    pub mtime: FILETIME,
    pub ctime: FILETIME,
    pub atime: FILETIME,
    pub grfMode: DWORD,
    pub grfLocksSupported: DWORD,
    pub clsid: CLSID,
    pub grfStateBits: DWORD,
    pub reserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTATSTG"][::std::mem::size_of::<tagSTATSTG>() - 80usize];
    ["Alignment of tagSTATSTG"][::std::mem::align_of::<tagSTATSTG>() - 8usize];
    ["Offset of field: tagSTATSTG::pwcsName"]
        [::std::mem::offset_of!(tagSTATSTG, pwcsName) - 0usize];
    ["Offset of field: tagSTATSTG::type_"][::std::mem::offset_of!(tagSTATSTG, type_) - 8usize];
    ["Offset of field: tagSTATSTG::cbSize"][::std::mem::offset_of!(tagSTATSTG, cbSize) - 16usize];
    ["Offset of field: tagSTATSTG::mtime"][::std::mem::offset_of!(tagSTATSTG, mtime) - 24usize];
    ["Offset of field: tagSTATSTG::ctime"][::std::mem::offset_of!(tagSTATSTG, ctime) - 32usize];
    ["Offset of field: tagSTATSTG::atime"][::std::mem::offset_of!(tagSTATSTG, atime) - 40usize];
    ["Offset of field: tagSTATSTG::grfMode"][::std::mem::offset_of!(tagSTATSTG, grfMode) - 48usize];
    ["Offset of field: tagSTATSTG::grfLocksSupported"]
        [::std::mem::offset_of!(tagSTATSTG, grfLocksSupported) - 52usize];
    ["Offset of field: tagSTATSTG::clsid"][::std::mem::offset_of!(tagSTATSTG, clsid) - 56usize];
    ["Offset of field: tagSTATSTG::grfStateBits"]
        [::std::mem::offset_of!(tagSTATSTG, grfStateBits) - 72usize];
    ["Offset of field: tagSTATSTG::reserved"]
        [::std::mem::offset_of!(tagSTATSTG, reserved) - 76usize];
};
pub type STATSTG = tagSTATSTG;
pub const tagSTGTY_STGTY_STORAGE: tagSTGTY = 1;
pub const tagSTGTY_STGTY_STREAM: tagSTGTY = 2;
pub const tagSTGTY_STGTY_LOCKBYTES: tagSTGTY = 3;
pub const tagSTGTY_STGTY_PROPERTY: tagSTGTY = 4;
pub type tagSTGTY = ::std::os::raw::c_int;
pub use self::tagSTGTY as STGTY;
pub const tagSTREAM_SEEK_STREAM_SEEK_SET: tagSTREAM_SEEK = 0;
pub const tagSTREAM_SEEK_STREAM_SEEK_CUR: tagSTREAM_SEEK = 1;
pub const tagSTREAM_SEEK_STREAM_SEEK_END: tagSTREAM_SEEK = 2;
pub type tagSTREAM_SEEK = ::std::os::raw::c_int;
pub use self::tagSTREAM_SEEK as STREAM_SEEK;
pub const tagLOCKTYPE_LOCK_WRITE: tagLOCKTYPE = 1;
pub const tagLOCKTYPE_LOCK_EXCLUSIVE: tagLOCKTYPE = 2;
pub const tagLOCKTYPE_LOCK_ONLYONCE: tagLOCKTYPE = 4;
pub type tagLOCKTYPE = ::std::os::raw::c_int;
pub use self::tagLOCKTYPE as LOCKTYPE;
unsafe extern "C" {
    pub static IID_IStream: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStreamVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IStream) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IStream) -> ULONG>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Write: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Seek: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            dlibMove: LARGE_INTEGER,
            dwOrigin: DWORD,
            plibNewPosition: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub SetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStream, libNewSize: ULARGE_INTEGER) -> HRESULT,
    >,
    pub CopyTo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            pstm: *mut IStream,
            cb: ULARGE_INTEGER,
            pcbRead: *mut ULARGE_INTEGER,
            pcbWritten: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub Commit: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStream, grfCommitFlags: DWORD) -> HRESULT,
    >,
    pub Revert: ::std::option::Option<unsafe extern "C" fn(This: *mut IStream) -> HRESULT>,
    pub LockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub UnlockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub Stat: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStream,
            pstatstg: *mut STATSTG,
            grfStatFlag: DWORD,
        ) -> HRESULT,
    >,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStream, ppstm: *mut *mut IStream) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStreamVtbl"][::std::mem::size_of::<IStreamVtbl>() - 112usize];
    ["Alignment of IStreamVtbl"][::std::mem::align_of::<IStreamVtbl>() - 8usize];
    ["Offset of field: IStreamVtbl::QueryInterface"]
        [::std::mem::offset_of!(IStreamVtbl, QueryInterface) - 0usize];
    ["Offset of field: IStreamVtbl::AddRef"][::std::mem::offset_of!(IStreamVtbl, AddRef) - 8usize];
    ["Offset of field: IStreamVtbl::Release"]
        [::std::mem::offset_of!(IStreamVtbl, Release) - 16usize];
    ["Offset of field: IStreamVtbl::Read"][::std::mem::offset_of!(IStreamVtbl, Read) - 24usize];
    ["Offset of field: IStreamVtbl::Write"][::std::mem::offset_of!(IStreamVtbl, Write) - 32usize];
    ["Offset of field: IStreamVtbl::Seek"][::std::mem::offset_of!(IStreamVtbl, Seek) - 40usize];
    ["Offset of field: IStreamVtbl::SetSize"]
        [::std::mem::offset_of!(IStreamVtbl, SetSize) - 48usize];
    ["Offset of field: IStreamVtbl::CopyTo"][::std::mem::offset_of!(IStreamVtbl, CopyTo) - 56usize];
    ["Offset of field: IStreamVtbl::Commit"][::std::mem::offset_of!(IStreamVtbl, Commit) - 64usize];
    ["Offset of field: IStreamVtbl::Revert"][::std::mem::offset_of!(IStreamVtbl, Revert) - 72usize];
    ["Offset of field: IStreamVtbl::LockRegion"]
        [::std::mem::offset_of!(IStreamVtbl, LockRegion) - 80usize];
    ["Offset of field: IStreamVtbl::UnlockRegion"]
        [::std::mem::offset_of!(IStreamVtbl, UnlockRegion) - 88usize];
    ["Offset of field: IStreamVtbl::Stat"][::std::mem::offset_of!(IStreamVtbl, Stat) - 96usize];
    ["Offset of field: IStreamVtbl::Clone"][::std::mem::offset_of!(IStreamVtbl, Clone) - 104usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStream {
    pub lpVtbl: *mut IStreamVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStream"][::std::mem::size_of::<IStream>() - 8usize];
    ["Alignment of IStream"][::std::mem::align_of::<IStream>() - 8usize];
    ["Offset of field: IStream::lpVtbl"][::std::mem::offset_of!(IStream, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IStream_RemoteSeek_Proxy(
        This: *mut IStream,
        dlibMove: LARGE_INTEGER,
        dwOrigin: DWORD,
        plibNewPosition: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_RemoteSeek_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IStream_RemoteCopyTo_Proxy(
        This: *mut IStream,
        pstm: *mut IStream,
        cb: ULARGE_INTEGER,
        pcbRead: *mut ULARGE_INTEGER,
        pcbWritten: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_RemoteCopyTo_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type RPCOLEDATAREP = ULONG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRPCOLEMESSAGE {
    pub reserved1: *mut ::std::os::raw::c_void,
    pub dataRepresentation: RPCOLEDATAREP,
    pub Buffer: *mut ::std::os::raw::c_void,
    pub cbBuffer: ULONG,
    pub iMethod: ULONG,
    pub reserved2: [*mut ::std::os::raw::c_void; 5usize],
    pub rpcFlags: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRPCOLEMESSAGE"][::std::mem::size_of::<tagRPCOLEMESSAGE>() - 80usize];
    ["Alignment of tagRPCOLEMESSAGE"][::std::mem::align_of::<tagRPCOLEMESSAGE>() - 8usize];
    ["Offset of field: tagRPCOLEMESSAGE::reserved1"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, reserved1) - 0usize];
    ["Offset of field: tagRPCOLEMESSAGE::dataRepresentation"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, dataRepresentation) - 8usize];
    ["Offset of field: tagRPCOLEMESSAGE::Buffer"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, Buffer) - 16usize];
    ["Offset of field: tagRPCOLEMESSAGE::cbBuffer"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, cbBuffer) - 24usize];
    ["Offset of field: tagRPCOLEMESSAGE::iMethod"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, iMethod) - 28usize];
    ["Offset of field: tagRPCOLEMESSAGE::reserved2"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, reserved2) - 32usize];
    ["Offset of field: tagRPCOLEMESSAGE::rpcFlags"]
        [::std::mem::offset_of!(tagRPCOLEMESSAGE, rpcFlags) - 72usize];
};
pub type RPCOLEMESSAGE = tagRPCOLEMESSAGE;
pub type PRPCOLEMESSAGE = *mut RPCOLEMESSAGE;
unsafe extern "C" {
    pub static IID_IRpcChannelBuffer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBufferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer) -> ULONG>,
    pub GetBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer,
            pMessage: *mut RPCOLEMESSAGE,
            riid: *const IID,
        ) -> HRESULT,
    >,
    pub SendReceive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer,
            pMessage: *mut RPCOLEMESSAGE,
            pStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub FreeBuffer: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcChannelBuffer, pMessage: *mut RPCOLEMESSAGE) -> HRESULT,
    >,
    pub GetDestCtx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub IsConnected:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBufferVtbl"][::std::mem::size_of::<IRpcChannelBufferVtbl>() - 64usize];
    ["Alignment of IRpcChannelBufferVtbl"]
        [::std::mem::align_of::<IRpcChannelBufferVtbl>() - 8usize];
    ["Offset of field: IRpcChannelBufferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcChannelBufferVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcChannelBufferVtbl::Release"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, Release) - 16usize];
    ["Offset of field: IRpcChannelBufferVtbl::GetBuffer"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, GetBuffer) - 24usize];
    ["Offset of field: IRpcChannelBufferVtbl::SendReceive"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, SendReceive) - 32usize];
    ["Offset of field: IRpcChannelBufferVtbl::FreeBuffer"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, FreeBuffer) - 40usize];
    ["Offset of field: IRpcChannelBufferVtbl::GetDestCtx"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, GetDestCtx) - 48usize];
    ["Offset of field: IRpcChannelBufferVtbl::IsConnected"]
        [::std::mem::offset_of!(IRpcChannelBufferVtbl, IsConnected) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBuffer {
    pub lpVtbl: *mut IRpcChannelBufferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBuffer"][::std::mem::size_of::<IRpcChannelBuffer>() - 8usize];
    ["Alignment of IRpcChannelBuffer"][::std::mem::align_of::<IRpcChannelBuffer>() - 8usize];
    ["Offset of field: IRpcChannelBuffer::lpVtbl"]
        [::std::mem::offset_of!(IRpcChannelBuffer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0015_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0015_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IRpcChannelBuffer2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBuffer2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer2) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer2) -> ULONG>,
    pub GetBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer2,
            pMessage: *mut RPCOLEMESSAGE,
            riid: *const IID,
        ) -> HRESULT,
    >,
    pub SendReceive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer2,
            pMessage: *mut RPCOLEMESSAGE,
            pStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub FreeBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer2,
            pMessage: *mut RPCOLEMESSAGE,
        ) -> HRESULT,
    >,
    pub GetDestCtx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer2,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub IsConnected:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer2) -> HRESULT>,
    pub GetProtocolVersion: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcChannelBuffer2, pdwVersion: *mut DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBuffer2Vtbl"][::std::mem::size_of::<IRpcChannelBuffer2Vtbl>() - 72usize];
    ["Alignment of IRpcChannelBuffer2Vtbl"]
        [::std::mem::align_of::<IRpcChannelBuffer2Vtbl>() - 8usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::AddRef"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, AddRef) - 8usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::Release"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, Release) - 16usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::GetBuffer"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, GetBuffer) - 24usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::SendReceive"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, SendReceive) - 32usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::FreeBuffer"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, FreeBuffer) - 40usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::GetDestCtx"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, GetDestCtx) - 48usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::IsConnected"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, IsConnected) - 56usize];
    ["Offset of field: IRpcChannelBuffer2Vtbl::GetProtocolVersion"]
        [::std::mem::offset_of!(IRpcChannelBuffer2Vtbl, GetProtocolVersion) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBuffer2 {
    pub lpVtbl: *mut IRpcChannelBuffer2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBuffer2"][::std::mem::size_of::<IRpcChannelBuffer2>() - 8usize];
    ["Alignment of IRpcChannelBuffer2"][::std::mem::align_of::<IRpcChannelBuffer2>() - 8usize];
    ["Offset of field: IRpcChannelBuffer2::lpVtbl"]
        [::std::mem::offset_of!(IRpcChannelBuffer2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IAsyncRpcChannelBuffer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAsyncRpcChannelBufferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAsyncRpcChannelBuffer) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAsyncRpcChannelBuffer) -> ULONG>,
    pub GetBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMessage: *mut RPCOLEMESSAGE,
            riid: *const IID,
        ) -> HRESULT,
    >,
    pub SendReceive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMessage: *mut RPCOLEMESSAGE,
            pStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub FreeBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMessage: *mut RPCOLEMESSAGE,
        ) -> HRESULT,
    >,
    pub GetDestCtx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub IsConnected:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAsyncRpcChannelBuffer) -> HRESULT>,
    pub GetProtocolVersion: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IAsyncRpcChannelBuffer, pdwVersion: *mut DWORD) -> HRESULT,
    >,
    pub Send: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMsg: *mut RPCOLEMESSAGE,
            pSync: *mut ISynchronize,
            pulStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Receive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMsg: *mut RPCOLEMESSAGE,
            pulStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub GetDestCtxEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncRpcChannelBuffer,
            pMsg: *mut RPCOLEMESSAGE,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAsyncRpcChannelBufferVtbl"]
        [::std::mem::size_of::<IAsyncRpcChannelBufferVtbl>() - 96usize];
    ["Alignment of IAsyncRpcChannelBufferVtbl"]
        [::std::mem::align_of::<IAsyncRpcChannelBufferVtbl>() - 8usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::AddRef"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, AddRef) - 8usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::Release"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, Release) - 16usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::GetBuffer"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, GetBuffer) - 24usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::SendReceive"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, SendReceive) - 32usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::FreeBuffer"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, FreeBuffer) - 40usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::GetDestCtx"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, GetDestCtx) - 48usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::IsConnected"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, IsConnected) - 56usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::GetProtocolVersion"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, GetProtocolVersion) - 64usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::Send"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, Send) - 72usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::Receive"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, Receive) - 80usize];
    ["Offset of field: IAsyncRpcChannelBufferVtbl::GetDestCtxEx"]
        [::std::mem::offset_of!(IAsyncRpcChannelBufferVtbl, GetDestCtxEx) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAsyncRpcChannelBuffer {
    pub lpVtbl: *mut IAsyncRpcChannelBufferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAsyncRpcChannelBuffer"][::std::mem::size_of::<IAsyncRpcChannelBuffer>() - 8usize];
    ["Alignment of IAsyncRpcChannelBuffer"]
        [::std::mem::align_of::<IAsyncRpcChannelBuffer>() - 8usize];
    ["Offset of field: IAsyncRpcChannelBuffer::lpVtbl"]
        [::std::mem::offset_of!(IAsyncRpcChannelBuffer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IRpcChannelBuffer3: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBuffer3Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer3) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer3) -> ULONG>,
    pub GetBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMessage: *mut RPCOLEMESSAGE,
            riid: *const IID,
        ) -> HRESULT,
    >,
    pub SendReceive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMessage: *mut RPCOLEMESSAGE,
            pStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub FreeBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMessage: *mut RPCOLEMESSAGE,
        ) -> HRESULT,
    >,
    pub GetDestCtx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub IsConnected:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcChannelBuffer3) -> HRESULT>,
    pub GetProtocolVersion: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcChannelBuffer3, pdwVersion: *mut DWORD) -> HRESULT,
    >,
    pub Send: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            pulStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Receive: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            ulSize: ULONG,
            pulStatus: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Cancel: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcChannelBuffer3, pMsg: *mut RPCOLEMESSAGE) -> HRESULT,
    >,
    pub GetCallContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            riid: *const IID,
            pInterface: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub GetDestCtxEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            pdwDestContext: *mut DWORD,
            ppvDestContext: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub GetState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            pState: *mut DWORD,
        ) -> HRESULT,
    >,
    pub RegisterAsync: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcChannelBuffer3,
            pMsg: *mut RPCOLEMESSAGE,
            pAsyncMgr: *mut IAsyncManager,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBuffer3Vtbl"][::std::mem::size_of::<IRpcChannelBuffer3Vtbl>() - 128usize];
    ["Alignment of IRpcChannelBuffer3Vtbl"]
        [::std::mem::align_of::<IRpcChannelBuffer3Vtbl>() - 8usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::AddRef"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, AddRef) - 8usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::Release"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, Release) - 16usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetBuffer"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetBuffer) - 24usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::SendReceive"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, SendReceive) - 32usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::FreeBuffer"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, FreeBuffer) - 40usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetDestCtx"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetDestCtx) - 48usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::IsConnected"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, IsConnected) - 56usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetProtocolVersion"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetProtocolVersion) - 64usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::Send"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, Send) - 72usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::Receive"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, Receive) - 80usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::Cancel"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, Cancel) - 88usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetCallContext"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetCallContext) - 96usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetDestCtxEx"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetDestCtxEx) - 104usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::GetState"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, GetState) - 112usize];
    ["Offset of field: IRpcChannelBuffer3Vtbl::RegisterAsync"]
        [::std::mem::offset_of!(IRpcChannelBuffer3Vtbl, RegisterAsync) - 120usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcChannelBuffer3 {
    pub lpVtbl: *mut IRpcChannelBuffer3Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcChannelBuffer3"][::std::mem::size_of::<IRpcChannelBuffer3>() - 8usize];
    ["Alignment of IRpcChannelBuffer3"][::std::mem::align_of::<IRpcChannelBuffer3>() - 8usize];
    ["Offset of field: IRpcChannelBuffer3::lpVtbl"]
        [::std::mem::offset_of!(IRpcChannelBuffer3, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IRpcSyntaxNegotiate: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcSyntaxNegotiateVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcSyntaxNegotiate,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcSyntaxNegotiate) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcSyntaxNegotiate) -> ULONG>,
    pub NegotiateSyntax: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcSyntaxNegotiate, pMsg: *mut RPCOLEMESSAGE) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcSyntaxNegotiateVtbl"][::std::mem::size_of::<IRpcSyntaxNegotiateVtbl>() - 32usize];
    ["Alignment of IRpcSyntaxNegotiateVtbl"]
        [::std::mem::align_of::<IRpcSyntaxNegotiateVtbl>() - 8usize];
    ["Offset of field: IRpcSyntaxNegotiateVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcSyntaxNegotiateVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcSyntaxNegotiateVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcSyntaxNegotiateVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcSyntaxNegotiateVtbl::Release"]
        [::std::mem::offset_of!(IRpcSyntaxNegotiateVtbl, Release) - 16usize];
    ["Offset of field: IRpcSyntaxNegotiateVtbl::NegotiateSyntax"]
        [::std::mem::offset_of!(IRpcSyntaxNegotiateVtbl, NegotiateSyntax) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcSyntaxNegotiate {
    pub lpVtbl: *mut IRpcSyntaxNegotiateVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcSyntaxNegotiate"][::std::mem::size_of::<IRpcSyntaxNegotiate>() - 8usize];
    ["Alignment of IRpcSyntaxNegotiate"][::std::mem::align_of::<IRpcSyntaxNegotiate>() - 8usize];
    ["Offset of field: IRpcSyntaxNegotiate::lpVtbl"]
        [::std::mem::offset_of!(IRpcSyntaxNegotiate, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IRpcProxyBuffer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcProxyBufferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcProxyBuffer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcProxyBuffer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcProxyBuffer) -> ULONG>,
    pub Connect: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcProxyBuffer,
            pRpcChannelBuffer: *mut IRpcChannelBuffer,
        ) -> HRESULT,
    >,
    pub Disconnect: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcProxyBuffer)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcProxyBufferVtbl"][::std::mem::size_of::<IRpcProxyBufferVtbl>() - 40usize];
    ["Alignment of IRpcProxyBufferVtbl"][::std::mem::align_of::<IRpcProxyBufferVtbl>() - 8usize];
    ["Offset of field: IRpcProxyBufferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcProxyBufferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcProxyBufferVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcProxyBufferVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcProxyBufferVtbl::Release"]
        [::std::mem::offset_of!(IRpcProxyBufferVtbl, Release) - 16usize];
    ["Offset of field: IRpcProxyBufferVtbl::Connect"]
        [::std::mem::offset_of!(IRpcProxyBufferVtbl, Connect) - 24usize];
    ["Offset of field: IRpcProxyBufferVtbl::Disconnect"]
        [::std::mem::offset_of!(IRpcProxyBufferVtbl, Disconnect) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcProxyBuffer {
    pub lpVtbl: *mut IRpcProxyBufferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcProxyBuffer"][::std::mem::size_of::<IRpcProxyBuffer>() - 8usize];
    ["Alignment of IRpcProxyBuffer"][::std::mem::align_of::<IRpcProxyBuffer>() - 8usize];
    ["Offset of field: IRpcProxyBuffer::lpVtbl"]
        [::std::mem::offset_of!(IRpcProxyBuffer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0020_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0020_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IRpcStubBuffer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcStubBufferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcStubBuffer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcStubBuffer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcStubBuffer) -> ULONG>,
    pub Connect: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcStubBuffer, pUnkServer: *mut IUnknown) -> HRESULT,
    >,
    pub Disconnect: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcStubBuffer)>,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcStubBuffer,
            _prpcmsg: *mut RPCOLEMESSAGE,
            _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        ) -> HRESULT,
    >,
    pub IsIIDSupported: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcStubBuffer, riid: *const IID) -> *mut IRpcStubBuffer,
    >,
    pub CountRefs: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcStubBuffer) -> ULONG>,
    pub DebugServerQueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcStubBuffer,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub DebugServerRelease: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcStubBuffer, pv: *mut ::std::os::raw::c_void),
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcStubBufferVtbl"][::std::mem::size_of::<IRpcStubBufferVtbl>() - 80usize];
    ["Alignment of IRpcStubBufferVtbl"][::std::mem::align_of::<IRpcStubBufferVtbl>() - 8usize];
    ["Offset of field: IRpcStubBufferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcStubBufferVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcStubBufferVtbl::Release"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, Release) - 16usize];
    ["Offset of field: IRpcStubBufferVtbl::Connect"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, Connect) - 24usize];
    ["Offset of field: IRpcStubBufferVtbl::Disconnect"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, Disconnect) - 32usize];
    ["Offset of field: IRpcStubBufferVtbl::Invoke"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, Invoke) - 40usize];
    ["Offset of field: IRpcStubBufferVtbl::IsIIDSupported"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, IsIIDSupported) - 48usize];
    ["Offset of field: IRpcStubBufferVtbl::CountRefs"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, CountRefs) - 56usize];
    ["Offset of field: IRpcStubBufferVtbl::DebugServerQueryInterface"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, DebugServerQueryInterface) - 64usize];
    ["Offset of field: IRpcStubBufferVtbl::DebugServerRelease"]
        [::std::mem::offset_of!(IRpcStubBufferVtbl, DebugServerRelease) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcStubBuffer {
    pub lpVtbl: *mut IRpcStubBufferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcStubBuffer"][::std::mem::size_of::<IRpcStubBuffer>() - 8usize];
    ["Alignment of IRpcStubBuffer"][::std::mem::align_of::<IRpcStubBuffer>() - 8usize];
    ["Offset of field: IRpcStubBuffer::lpVtbl"]
        [::std::mem::offset_of!(IRpcStubBuffer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IPSFactoryBuffer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPSFactoryBufferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPSFactoryBuffer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPSFactoryBuffer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPSFactoryBuffer) -> ULONG>,
    pub CreateProxy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPSFactoryBuffer,
            pUnkOuter: *mut IUnknown,
            riid: *const IID,
            ppProxy: *mut *mut IRpcProxyBuffer,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub CreateStub: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPSFactoryBuffer,
            riid: *const IID,
            pUnkServer: *mut IUnknown,
            ppStub: *mut *mut IRpcStubBuffer,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPSFactoryBufferVtbl"][::std::mem::size_of::<IPSFactoryBufferVtbl>() - 40usize];
    ["Alignment of IPSFactoryBufferVtbl"][::std::mem::align_of::<IPSFactoryBufferVtbl>() - 8usize];
    ["Offset of field: IPSFactoryBufferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPSFactoryBufferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPSFactoryBufferVtbl::AddRef"]
        [::std::mem::offset_of!(IPSFactoryBufferVtbl, AddRef) - 8usize];
    ["Offset of field: IPSFactoryBufferVtbl::Release"]
        [::std::mem::offset_of!(IPSFactoryBufferVtbl, Release) - 16usize];
    ["Offset of field: IPSFactoryBufferVtbl::CreateProxy"]
        [::std::mem::offset_of!(IPSFactoryBufferVtbl, CreateProxy) - 24usize];
    ["Offset of field: IPSFactoryBufferVtbl::CreateStub"]
        [::std::mem::offset_of!(IPSFactoryBufferVtbl, CreateStub) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPSFactoryBuffer {
    pub lpVtbl: *mut IPSFactoryBufferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPSFactoryBuffer"][::std::mem::size_of::<IPSFactoryBuffer>() - 8usize];
    ["Alignment of IPSFactoryBuffer"][::std::mem::align_of::<IPSFactoryBuffer>() - 8usize];
    ["Offset of field: IPSFactoryBuffer::lpVtbl"]
        [::std::mem::offset_of!(IPSFactoryBuffer, lpVtbl) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SChannelHookCallInfo {
    pub iid: IID,
    pub cbSize: DWORD,
    pub uCausality: GUID,
    pub dwServerPid: DWORD,
    pub iMethod: DWORD,
    pub pObject: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SChannelHookCallInfo"][::std::mem::size_of::<SChannelHookCallInfo>() - 56usize];
    ["Alignment of SChannelHookCallInfo"][::std::mem::align_of::<SChannelHookCallInfo>() - 8usize];
    ["Offset of field: SChannelHookCallInfo::iid"]
        [::std::mem::offset_of!(SChannelHookCallInfo, iid) - 0usize];
    ["Offset of field: SChannelHookCallInfo::cbSize"]
        [::std::mem::offset_of!(SChannelHookCallInfo, cbSize) - 16usize];
    ["Offset of field: SChannelHookCallInfo::uCausality"]
        [::std::mem::offset_of!(SChannelHookCallInfo, uCausality) - 20usize];
    ["Offset of field: SChannelHookCallInfo::dwServerPid"]
        [::std::mem::offset_of!(SChannelHookCallInfo, dwServerPid) - 36usize];
    ["Offset of field: SChannelHookCallInfo::iMethod"]
        [::std::mem::offset_of!(SChannelHookCallInfo, iMethod) - 40usize];
    ["Offset of field: SChannelHookCallInfo::pObject"]
        [::std::mem::offset_of!(SChannelHookCallInfo, pObject) - 48usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0022_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0022_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IChannelHook: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IChannelHookVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IChannelHook) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IChannelHook) -> ULONG>,
    pub ClientGetSize: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            pDataSize: *mut ULONG,
        ),
    >,
    pub ClientFillBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            pDataSize: *mut ULONG,
            pDataBuffer: *mut ::std::os::raw::c_void,
        ),
    >,
    pub ClientNotify: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            cbDataSize: ULONG,
            pDataBuffer: *mut ::std::os::raw::c_void,
            lDataRep: DWORD,
            hrFault: HRESULT,
        ),
    >,
    pub ServerNotify: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            cbDataSize: ULONG,
            pDataBuffer: *mut ::std::os::raw::c_void,
            lDataRep: DWORD,
        ),
    >,
    pub ServerGetSize: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            hrFault: HRESULT,
            pDataSize: *mut ULONG,
        ),
    >,
    pub ServerFillBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IChannelHook,
            uExtent: *const GUID,
            riid: *const IID,
            pDataSize: *mut ULONG,
            pDataBuffer: *mut ::std::os::raw::c_void,
            hrFault: HRESULT,
        ),
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IChannelHookVtbl"][::std::mem::size_of::<IChannelHookVtbl>() - 72usize];
    ["Alignment of IChannelHookVtbl"][::std::mem::align_of::<IChannelHookVtbl>() - 8usize];
    ["Offset of field: IChannelHookVtbl::QueryInterface"]
        [::std::mem::offset_of!(IChannelHookVtbl, QueryInterface) - 0usize];
    ["Offset of field: IChannelHookVtbl::AddRef"]
        [::std::mem::offset_of!(IChannelHookVtbl, AddRef) - 8usize];
    ["Offset of field: IChannelHookVtbl::Release"]
        [::std::mem::offset_of!(IChannelHookVtbl, Release) - 16usize];
    ["Offset of field: IChannelHookVtbl::ClientGetSize"]
        [::std::mem::offset_of!(IChannelHookVtbl, ClientGetSize) - 24usize];
    ["Offset of field: IChannelHookVtbl::ClientFillBuffer"]
        [::std::mem::offset_of!(IChannelHookVtbl, ClientFillBuffer) - 32usize];
    ["Offset of field: IChannelHookVtbl::ClientNotify"]
        [::std::mem::offset_of!(IChannelHookVtbl, ClientNotify) - 40usize];
    ["Offset of field: IChannelHookVtbl::ServerNotify"]
        [::std::mem::offset_of!(IChannelHookVtbl, ServerNotify) - 48usize];
    ["Offset of field: IChannelHookVtbl::ServerGetSize"]
        [::std::mem::offset_of!(IChannelHookVtbl, ServerGetSize) - 56usize];
    ["Offset of field: IChannelHookVtbl::ServerFillBuffer"]
        [::std::mem::offset_of!(IChannelHookVtbl, ServerFillBuffer) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IChannelHook {
    pub lpVtbl: *mut IChannelHookVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IChannelHook"][::std::mem::size_of::<IChannelHook>() - 8usize];
    ["Alignment of IChannelHook"][::std::mem::align_of::<IChannelHook>() - 8usize];
    ["Offset of field: IChannelHook::lpVtbl"]
        [::std::mem::offset_of!(IChannelHook, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0023_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0023_v0_0_s_ifspec: RPC_IF_HANDLE;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSOLE_AUTHENTICATION_SERVICE {
    pub dwAuthnSvc: DWORD,
    pub dwAuthzSvc: DWORD,
    pub pPrincipalName: *mut OLECHAR,
    pub hr: HRESULT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSOLE_AUTHENTICATION_SERVICE"]
        [::std::mem::size_of::<tagSOLE_AUTHENTICATION_SERVICE>() - 24usize];
    ["Alignment of tagSOLE_AUTHENTICATION_SERVICE"]
        [::std::mem::align_of::<tagSOLE_AUTHENTICATION_SERVICE>() - 8usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_SERVICE::dwAuthnSvc"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_SERVICE, dwAuthnSvc) - 0usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_SERVICE::dwAuthzSvc"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_SERVICE, dwAuthzSvc) - 4usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_SERVICE::pPrincipalName"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_SERVICE, pPrincipalName) - 8usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_SERVICE::hr"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_SERVICE, hr) - 16usize];
};
pub type SOLE_AUTHENTICATION_SERVICE = tagSOLE_AUTHENTICATION_SERVICE;
pub type PSOLE_AUTHENTICATION_SERVICE = *mut SOLE_AUTHENTICATION_SERVICE;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_NONE: tagEOLE_AUTHENTICATION_CAPABILITIES = 0;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_MUTUAL_AUTH:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 1;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_STATIC_CLOAKING:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 32;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_DYNAMIC_CLOAKING:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 64;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_ANY_AUTHORITY:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 128;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_MAKE_FULLSIC:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 256;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_DEFAULT: tagEOLE_AUTHENTICATION_CAPABILITIES =
    2048;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_SECURE_REFS:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 2;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_ACCESS_CONTROL:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 4;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_APPID: tagEOLE_AUTHENTICATION_CAPABILITIES = 8;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_DYNAMIC: tagEOLE_AUTHENTICATION_CAPABILITIES =
    16;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_REQUIRE_FULLSIC:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 512;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_AUTO_IMPERSONATE:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 1024;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_DISABLE_AAA:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 4096;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_NO_CUSTOM_MARSHAL:
    tagEOLE_AUTHENTICATION_CAPABILITIES = 8192;
pub const tagEOLE_AUTHENTICATION_CAPABILITIES_EOAC_RESERVED1: tagEOLE_AUTHENTICATION_CAPABILITIES =
    16384;
pub type tagEOLE_AUTHENTICATION_CAPABILITIES = ::std::os::raw::c_int;
pub use self::tagEOLE_AUTHENTICATION_CAPABILITIES as EOLE_AUTHENTICATION_CAPABILITIES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSOLE_AUTHENTICATION_INFO {
    pub dwAuthnSvc: DWORD,
    pub dwAuthzSvc: DWORD,
    pub pAuthInfo: *mut ::std::os::raw::c_void,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSOLE_AUTHENTICATION_INFO"]
        [::std::mem::size_of::<tagSOLE_AUTHENTICATION_INFO>() - 16usize];
    ["Alignment of tagSOLE_AUTHENTICATION_INFO"]
        [::std::mem::align_of::<tagSOLE_AUTHENTICATION_INFO>() - 8usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_INFO::dwAuthnSvc"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_INFO, dwAuthnSvc) - 0usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_INFO::dwAuthzSvc"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_INFO, dwAuthzSvc) - 4usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_INFO::pAuthInfo"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_INFO, pAuthInfo) - 8usize];
};
pub type SOLE_AUTHENTICATION_INFO = tagSOLE_AUTHENTICATION_INFO;
pub type PSOLE_AUTHENTICATION_INFO = *mut tagSOLE_AUTHENTICATION_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSOLE_AUTHENTICATION_LIST {
    pub cAuthInfo: DWORD,
    pub aAuthInfo: *mut SOLE_AUTHENTICATION_INFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSOLE_AUTHENTICATION_LIST"]
        [::std::mem::size_of::<tagSOLE_AUTHENTICATION_LIST>() - 16usize];
    ["Alignment of tagSOLE_AUTHENTICATION_LIST"]
        [::std::mem::align_of::<tagSOLE_AUTHENTICATION_LIST>() - 8usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_LIST::cAuthInfo"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_LIST, cAuthInfo) - 0usize];
    ["Offset of field: tagSOLE_AUTHENTICATION_LIST::aAuthInfo"]
        [::std::mem::offset_of!(tagSOLE_AUTHENTICATION_LIST, aAuthInfo) - 8usize];
};
pub type SOLE_AUTHENTICATION_LIST = tagSOLE_AUTHENTICATION_LIST;
pub type PSOLE_AUTHENTICATION_LIST = *mut tagSOLE_AUTHENTICATION_LIST;
unsafe extern "C" {
    pub static IID_IClientSecurity: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClientSecurityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClientSecurity,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IClientSecurity) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IClientSecurity) -> ULONG>,
    pub QueryBlanket: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClientSecurity,
            pProxy: *mut IUnknown,
            pAuthnSvc: *mut DWORD,
            pAuthzSvc: *mut DWORD,
            pServerPrincName: *mut *mut OLECHAR,
            pAuthnLevel: *mut DWORD,
            pImpLevel: *mut DWORD,
            pAuthInfo: *mut *mut ::std::os::raw::c_void,
            pCapabilites: *mut DWORD,
        ) -> HRESULT,
    >,
    pub SetBlanket: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClientSecurity,
            pProxy: *mut IUnknown,
            dwAuthnSvc: DWORD,
            dwAuthzSvc: DWORD,
            pServerPrincName: *mut OLECHAR,
            dwAuthnLevel: DWORD,
            dwImpLevel: DWORD,
            pAuthInfo: *mut ::std::os::raw::c_void,
            dwCapabilities: DWORD,
        ) -> HRESULT,
    >,
    pub CopyProxy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClientSecurity,
            pProxy: *mut IUnknown,
            ppCopy: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClientSecurityVtbl"][::std::mem::size_of::<IClientSecurityVtbl>() - 48usize];
    ["Alignment of IClientSecurityVtbl"][::std::mem::align_of::<IClientSecurityVtbl>() - 8usize];
    ["Offset of field: IClientSecurityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IClientSecurityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IClientSecurityVtbl::AddRef"]
        [::std::mem::offset_of!(IClientSecurityVtbl, AddRef) - 8usize];
    ["Offset of field: IClientSecurityVtbl::Release"]
        [::std::mem::offset_of!(IClientSecurityVtbl, Release) - 16usize];
    ["Offset of field: IClientSecurityVtbl::QueryBlanket"]
        [::std::mem::offset_of!(IClientSecurityVtbl, QueryBlanket) - 24usize];
    ["Offset of field: IClientSecurityVtbl::SetBlanket"]
        [::std::mem::offset_of!(IClientSecurityVtbl, SetBlanket) - 32usize];
    ["Offset of field: IClientSecurityVtbl::CopyProxy"]
        [::std::mem::offset_of!(IClientSecurityVtbl, CopyProxy) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClientSecurity {
    pub lpVtbl: *mut IClientSecurityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClientSecurity"][::std::mem::size_of::<IClientSecurity>() - 8usize];
    ["Alignment of IClientSecurity"][::std::mem::align_of::<IClientSecurity>() - 8usize];
    ["Offset of field: IClientSecurity::lpVtbl"]
        [::std::mem::offset_of!(IClientSecurity, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0024_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0024_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IServerSecurity: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IServerSecurityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IServerSecurity,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IServerSecurity) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IServerSecurity) -> ULONG>,
    pub QueryBlanket: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IServerSecurity,
            pAuthnSvc: *mut DWORD,
            pAuthzSvc: *mut DWORD,
            pServerPrincName: *mut *mut OLECHAR,
            pAuthnLevel: *mut DWORD,
            pImpLevel: *mut DWORD,
            pPrivs: *mut *mut ::std::os::raw::c_void,
            pCapabilities: *mut DWORD,
        ) -> HRESULT,
    >,
    pub ImpersonateClient:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IServerSecurity) -> HRESULT>,
    pub RevertToSelf:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IServerSecurity) -> HRESULT>,
    pub IsImpersonating:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IServerSecurity) -> BOOL>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IServerSecurityVtbl"][::std::mem::size_of::<IServerSecurityVtbl>() - 56usize];
    ["Alignment of IServerSecurityVtbl"][::std::mem::align_of::<IServerSecurityVtbl>() - 8usize];
    ["Offset of field: IServerSecurityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IServerSecurityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IServerSecurityVtbl::AddRef"]
        [::std::mem::offset_of!(IServerSecurityVtbl, AddRef) - 8usize];
    ["Offset of field: IServerSecurityVtbl::Release"]
        [::std::mem::offset_of!(IServerSecurityVtbl, Release) - 16usize];
    ["Offset of field: IServerSecurityVtbl::QueryBlanket"]
        [::std::mem::offset_of!(IServerSecurityVtbl, QueryBlanket) - 24usize];
    ["Offset of field: IServerSecurityVtbl::ImpersonateClient"]
        [::std::mem::offset_of!(IServerSecurityVtbl, ImpersonateClient) - 32usize];
    ["Offset of field: IServerSecurityVtbl::RevertToSelf"]
        [::std::mem::offset_of!(IServerSecurityVtbl, RevertToSelf) - 40usize];
    ["Offset of field: IServerSecurityVtbl::IsImpersonating"]
        [::std::mem::offset_of!(IServerSecurityVtbl, IsImpersonating) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IServerSecurity {
    pub lpVtbl: *mut IServerSecurityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IServerSecurity"][::std::mem::size_of::<IServerSecurity>() - 8usize];
    ["Alignment of IServerSecurity"][::std::mem::align_of::<IServerSecurity>() - 8usize];
    ["Offset of field: IServerSecurity::lpVtbl"]
        [::std::mem::offset_of!(IServerSecurity, lpVtbl) - 0usize];
};
pub const tagRPCOPT_PROPERTIES_COMBND_RPCTIMEOUT: tagRPCOPT_PROPERTIES = 1;
pub const tagRPCOPT_PROPERTIES_COMBND_SERVER_LOCALITY: tagRPCOPT_PROPERTIES = 2;
pub const tagRPCOPT_PROPERTIES_COMBND_RESERVED1: tagRPCOPT_PROPERTIES = 4;
pub const tagRPCOPT_PROPERTIES_COMBND_RESERVED2: tagRPCOPT_PROPERTIES = 5;
pub const tagRPCOPT_PROPERTIES_COMBND_RESERVED3: tagRPCOPT_PROPERTIES = 8;
pub const tagRPCOPT_PROPERTIES_COMBND_RESERVED4: tagRPCOPT_PROPERTIES = 16;
pub type tagRPCOPT_PROPERTIES = ::std::os::raw::c_int;
pub use self::tagRPCOPT_PROPERTIES as RPCOPT_PROPERTIES;
pub const tagRPCOPT_SERVER_LOCALITY_VALUES_SERVER_LOCALITY_PROCESS_LOCAL:
    tagRPCOPT_SERVER_LOCALITY_VALUES = 0;
pub const tagRPCOPT_SERVER_LOCALITY_VALUES_SERVER_LOCALITY_MACHINE_LOCAL:
    tagRPCOPT_SERVER_LOCALITY_VALUES = 1;
pub const tagRPCOPT_SERVER_LOCALITY_VALUES_SERVER_LOCALITY_REMOTE:
    tagRPCOPT_SERVER_LOCALITY_VALUES = 2;
pub type tagRPCOPT_SERVER_LOCALITY_VALUES = ::std::os::raw::c_int;
pub use self::tagRPCOPT_SERVER_LOCALITY_VALUES as RPCOPT_SERVER_LOCALITY_VALUES;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0025_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0025_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IRpcOptions: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcOptionsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcOptions,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcOptions) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcOptions) -> ULONG>,
    pub Set: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcOptions,
            pPrx: *mut IUnknown,
            dwProperty: RPCOPT_PROPERTIES,
            dwValue: ULONG_PTR,
        ) -> HRESULT,
    >,
    pub Query: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcOptions,
            pPrx: *mut IUnknown,
            dwProperty: RPCOPT_PROPERTIES,
            pdwValue: *mut ULONG_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcOptionsVtbl"][::std::mem::size_of::<IRpcOptionsVtbl>() - 40usize];
    ["Alignment of IRpcOptionsVtbl"][::std::mem::align_of::<IRpcOptionsVtbl>() - 8usize];
    ["Offset of field: IRpcOptionsVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcOptionsVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcOptionsVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcOptionsVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcOptionsVtbl::Release"]
        [::std::mem::offset_of!(IRpcOptionsVtbl, Release) - 16usize];
    ["Offset of field: IRpcOptionsVtbl::Set"]
        [::std::mem::offset_of!(IRpcOptionsVtbl, Set) - 24usize];
    ["Offset of field: IRpcOptionsVtbl::Query"]
        [::std::mem::offset_of!(IRpcOptionsVtbl, Query) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcOptions {
    pub lpVtbl: *mut IRpcOptionsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcOptions"][::std::mem::size_of::<IRpcOptions>() - 8usize];
    ["Alignment of IRpcOptions"][::std::mem::align_of::<IRpcOptions>() - 8usize];
    ["Offset of field: IRpcOptions::lpVtbl"][::std::mem::offset_of!(IRpcOptions, lpVtbl) - 0usize];
};
pub const tagGLOBALOPT_PROPERTIES_COMGLB_EXCEPTION_HANDLING: tagGLOBALOPT_PROPERTIES = 1;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_APPID: tagGLOBALOPT_PROPERTIES = 2;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_RPC_THREADPOOL_SETTING: tagGLOBALOPT_PROPERTIES = 3;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_RO_SETTINGS: tagGLOBALOPT_PROPERTIES = 4;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_UNMARSHALING_POLICY: tagGLOBALOPT_PROPERTIES = 5;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_PROPERTIES_RESERVED1: tagGLOBALOPT_PROPERTIES = 6;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_PROPERTIES_RESERVED2: tagGLOBALOPT_PROPERTIES = 7;
pub const tagGLOBALOPT_PROPERTIES_COMGLB_PROPERTIES_RESERVED3: tagGLOBALOPT_PROPERTIES = 8;
pub type tagGLOBALOPT_PROPERTIES = ::std::os::raw::c_int;
pub use self::tagGLOBALOPT_PROPERTIES as GLOBALOPT_PROPERTIES;
pub const tagGLOBALOPT_EH_VALUES_COMGLB_EXCEPTION_HANDLE: tagGLOBALOPT_EH_VALUES = 0;
pub const tagGLOBALOPT_EH_VALUES_COMGLB_EXCEPTION_DONOT_HANDLE_FATAL: tagGLOBALOPT_EH_VALUES = 1;
pub const tagGLOBALOPT_EH_VALUES_COMGLB_EXCEPTION_DONOT_HANDLE: tagGLOBALOPT_EH_VALUES = 1;
pub const tagGLOBALOPT_EH_VALUES_COMGLB_EXCEPTION_DONOT_HANDLE_ANY: tagGLOBALOPT_EH_VALUES = 2;
pub type tagGLOBALOPT_EH_VALUES = ::std::os::raw::c_int;
pub use self::tagGLOBALOPT_EH_VALUES as GLOBALOPT_EH_VALUES;
pub const tagGLOBALOPT_RPCTP_VALUES_COMGLB_RPC_THREADPOOL_SETTING_DEFAULT_POOL:
    tagGLOBALOPT_RPCTP_VALUES = 0;
pub const tagGLOBALOPT_RPCTP_VALUES_COMGLB_RPC_THREADPOOL_SETTING_PRIVATE_POOL:
    tagGLOBALOPT_RPCTP_VALUES = 1;
pub type tagGLOBALOPT_RPCTP_VALUES = ::std::os::raw::c_int;
pub use self::tagGLOBALOPT_RPCTP_VALUES as GLOBALOPT_RPCTP_VALUES;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_STA_MODALLOOP_REMOVE_TOUCH_MESSAGES: tagGLOBALOPT_RO_FLAGS =
    1;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_STA_MODALLOOP_SHARED_QUEUE_REMOVE_INPUT_MESSAGES:
    tagGLOBALOPT_RO_FLAGS = 2;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_STA_MODALLOOP_SHARED_QUEUE_DONOT_REMOVE_INPUT_MESSAGES:
    tagGLOBALOPT_RO_FLAGS = 4;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_FAST_RUNDOWN: tagGLOBALOPT_RO_FLAGS = 8;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED1: tagGLOBALOPT_RO_FLAGS = 16;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED2: tagGLOBALOPT_RO_FLAGS = 32;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED3: tagGLOBALOPT_RO_FLAGS = 64;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_STA_MODALLOOP_SHARED_QUEUE_REORDER_POINTER_MESSAGES:
    tagGLOBALOPT_RO_FLAGS = 128;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED4: tagGLOBALOPT_RO_FLAGS = 256;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED5: tagGLOBALOPT_RO_FLAGS = 512;
pub const tagGLOBALOPT_RO_FLAGS_COMGLB_RESERVED6: tagGLOBALOPT_RO_FLAGS = 1024;
pub type tagGLOBALOPT_RO_FLAGS = ::std::os::raw::c_int;
pub use self::tagGLOBALOPT_RO_FLAGS as GLOBALOPT_RO_FLAGS;
pub const tagGLOBALOPT_UNMARSHALING_POLICY_VALUES_COMGLB_UNMARSHALING_POLICY_NORMAL:
    tagGLOBALOPT_UNMARSHALING_POLICY_VALUES = 0;
pub const tagGLOBALOPT_UNMARSHALING_POLICY_VALUES_COMGLB_UNMARSHALING_POLICY_STRONG:
    tagGLOBALOPT_UNMARSHALING_POLICY_VALUES = 1;
pub const tagGLOBALOPT_UNMARSHALING_POLICY_VALUES_COMGLB_UNMARSHALING_POLICY_HYBRID:
    tagGLOBALOPT_UNMARSHALING_POLICY_VALUES = 2;
pub type tagGLOBALOPT_UNMARSHALING_POLICY_VALUES = ::std::os::raw::c_int;
pub use self::tagGLOBALOPT_UNMARSHALING_POLICY_VALUES as GLOBALOPT_UNMARSHALING_POLICY_VALUES;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0026_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0026_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IGlobalOptions: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGlobalOptionsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalOptions,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IGlobalOptions) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IGlobalOptions) -> ULONG>,
    pub Set: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalOptions,
            dwProperty: GLOBALOPT_PROPERTIES,
            dwValue: ULONG_PTR,
        ) -> HRESULT,
    >,
    pub Query: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalOptions,
            dwProperty: GLOBALOPT_PROPERTIES,
            pdwValue: *mut ULONG_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGlobalOptionsVtbl"][::std::mem::size_of::<IGlobalOptionsVtbl>() - 40usize];
    ["Alignment of IGlobalOptionsVtbl"][::std::mem::align_of::<IGlobalOptionsVtbl>() - 8usize];
    ["Offset of field: IGlobalOptionsVtbl::QueryInterface"]
        [::std::mem::offset_of!(IGlobalOptionsVtbl, QueryInterface) - 0usize];
    ["Offset of field: IGlobalOptionsVtbl::AddRef"]
        [::std::mem::offset_of!(IGlobalOptionsVtbl, AddRef) - 8usize];
    ["Offset of field: IGlobalOptionsVtbl::Release"]
        [::std::mem::offset_of!(IGlobalOptionsVtbl, Release) - 16usize];
    ["Offset of field: IGlobalOptionsVtbl::Set"]
        [::std::mem::offset_of!(IGlobalOptionsVtbl, Set) - 24usize];
    ["Offset of field: IGlobalOptionsVtbl::Query"]
        [::std::mem::offset_of!(IGlobalOptionsVtbl, Query) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGlobalOptions {
    pub lpVtbl: *mut IGlobalOptionsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGlobalOptions"][::std::mem::size_of::<IGlobalOptions>() - 8usize];
    ["Alignment of IGlobalOptions"][::std::mem::align_of::<IGlobalOptions>() - 8usize];
    ["Offset of field: IGlobalOptions::lpVtbl"]
        [::std::mem::offset_of!(IGlobalOptions, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0027_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0027_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPSURROGATE = *mut ISurrogate;
unsafe extern "C" {
    pub static IID_ISurrogate: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISurrogateVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISurrogate,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISurrogate) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISurrogate) -> ULONG>,
    pub LoadDllServer: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISurrogate, Clsid: *const IID) -> HRESULT,
    >,
    pub FreeSurrogate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISurrogate) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISurrogateVtbl"][::std::mem::size_of::<ISurrogateVtbl>() - 40usize];
    ["Alignment of ISurrogateVtbl"][::std::mem::align_of::<ISurrogateVtbl>() - 8usize];
    ["Offset of field: ISurrogateVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISurrogateVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISurrogateVtbl::AddRef"]
        [::std::mem::offset_of!(ISurrogateVtbl, AddRef) - 8usize];
    ["Offset of field: ISurrogateVtbl::Release"]
        [::std::mem::offset_of!(ISurrogateVtbl, Release) - 16usize];
    ["Offset of field: ISurrogateVtbl::LoadDllServer"]
        [::std::mem::offset_of!(ISurrogateVtbl, LoadDllServer) - 24usize];
    ["Offset of field: ISurrogateVtbl::FreeSurrogate"]
        [::std::mem::offset_of!(ISurrogateVtbl, FreeSurrogate) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISurrogate {
    pub lpVtbl: *mut ISurrogateVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISurrogate"][::std::mem::size_of::<ISurrogate>() - 8usize];
    ["Alignment of ISurrogate"][::std::mem::align_of::<ISurrogate>() - 8usize];
    ["Offset of field: ISurrogate::lpVtbl"][::std::mem::offset_of!(ISurrogate, lpVtbl) - 0usize];
};
pub type LPGLOBALINTERFACETABLE = *mut IGlobalInterfaceTable;
unsafe extern "C" {
    pub static IID_IGlobalInterfaceTable: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGlobalInterfaceTableVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalInterfaceTable,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IGlobalInterfaceTable) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IGlobalInterfaceTable) -> ULONG>,
    pub RegisterInterfaceInGlobal: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalInterfaceTable,
            pUnk: *mut IUnknown,
            riid: *const IID,
            pdwCookie: *mut DWORD,
        ) -> HRESULT,
    >,
    pub RevokeInterfaceFromGlobal: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IGlobalInterfaceTable, dwCookie: DWORD) -> HRESULT,
    >,
    pub GetInterfaceFromGlobal: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGlobalInterfaceTable,
            dwCookie: DWORD,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGlobalInterfaceTableVtbl"]
        [::std::mem::size_of::<IGlobalInterfaceTableVtbl>() - 48usize];
    ["Alignment of IGlobalInterfaceTableVtbl"]
        [::std::mem::align_of::<IGlobalInterfaceTableVtbl>() - 8usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::QueryInterface"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, QueryInterface) - 0usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::AddRef"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, AddRef) - 8usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::Release"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, Release) - 16usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::RegisterInterfaceInGlobal"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, RegisterInterfaceInGlobal) - 24usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::RevokeInterfaceFromGlobal"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, RevokeInterfaceFromGlobal) - 32usize];
    ["Offset of field: IGlobalInterfaceTableVtbl::GetInterfaceFromGlobal"]
        [::std::mem::offset_of!(IGlobalInterfaceTableVtbl, GetInterfaceFromGlobal) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGlobalInterfaceTable {
    pub lpVtbl: *mut IGlobalInterfaceTableVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGlobalInterfaceTable"][::std::mem::size_of::<IGlobalInterfaceTable>() - 8usize];
    ["Alignment of IGlobalInterfaceTable"]
        [::std::mem::align_of::<IGlobalInterfaceTable>() - 8usize];
    ["Offset of field: IGlobalInterfaceTable::lpVtbl"]
        [::std::mem::offset_of!(IGlobalInterfaceTable, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0029_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0029_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_ISynchronize: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronize,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronize) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronize) -> ULONG>,
    pub Wait: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronize,
            dwFlags: DWORD,
            dwMilliseconds: DWORD,
        ) -> HRESULT,
    >,
    pub Signal: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronize) -> HRESULT>,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronize) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeVtbl"][::std::mem::size_of::<ISynchronizeVtbl>() - 48usize];
    ["Alignment of ISynchronizeVtbl"][::std::mem::align_of::<ISynchronizeVtbl>() - 8usize];
    ["Offset of field: ISynchronizeVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISynchronizeVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISynchronizeVtbl::AddRef"]
        [::std::mem::offset_of!(ISynchronizeVtbl, AddRef) - 8usize];
    ["Offset of field: ISynchronizeVtbl::Release"]
        [::std::mem::offset_of!(ISynchronizeVtbl, Release) - 16usize];
    ["Offset of field: ISynchronizeVtbl::Wait"]
        [::std::mem::offset_of!(ISynchronizeVtbl, Wait) - 24usize];
    ["Offset of field: ISynchronizeVtbl::Signal"]
        [::std::mem::offset_of!(ISynchronizeVtbl, Signal) - 32usize];
    ["Offset of field: ISynchronizeVtbl::Reset"]
        [::std::mem::offset_of!(ISynchronizeVtbl, Reset) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronize {
    pub lpVtbl: *mut ISynchronizeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronize"][::std::mem::size_of::<ISynchronize>() - 8usize];
    ["Alignment of ISynchronize"][::std::mem::align_of::<ISynchronize>() - 8usize];
    ["Offset of field: ISynchronize::lpVtbl"]
        [::std::mem::offset_of!(ISynchronize, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ISynchronizeHandle: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeHandleVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeHandle,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeHandle) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeHandle) -> ULONG>,
    pub GetHandle: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISynchronizeHandle, ph: *mut HANDLE) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeHandleVtbl"][::std::mem::size_of::<ISynchronizeHandleVtbl>() - 32usize];
    ["Alignment of ISynchronizeHandleVtbl"]
        [::std::mem::align_of::<ISynchronizeHandleVtbl>() - 8usize];
    ["Offset of field: ISynchronizeHandleVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISynchronizeHandleVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISynchronizeHandleVtbl::AddRef"]
        [::std::mem::offset_of!(ISynchronizeHandleVtbl, AddRef) - 8usize];
    ["Offset of field: ISynchronizeHandleVtbl::Release"]
        [::std::mem::offset_of!(ISynchronizeHandleVtbl, Release) - 16usize];
    ["Offset of field: ISynchronizeHandleVtbl::GetHandle"]
        [::std::mem::offset_of!(ISynchronizeHandleVtbl, GetHandle) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeHandle {
    pub lpVtbl: *mut ISynchronizeHandleVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeHandle"][::std::mem::size_of::<ISynchronizeHandle>() - 8usize];
    ["Alignment of ISynchronizeHandle"][::std::mem::align_of::<ISynchronizeHandle>() - 8usize];
    ["Offset of field: ISynchronizeHandle::lpVtbl"]
        [::std::mem::offset_of!(ISynchronizeHandle, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ISynchronizeEvent: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeEventVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeEvent,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeEvent) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeEvent) -> ULONG>,
    pub GetHandle: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISynchronizeEvent, ph: *mut HANDLE) -> HRESULT,
    >,
    pub SetEventHandle: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISynchronizeEvent, ph: *mut HANDLE) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeEventVtbl"][::std::mem::size_of::<ISynchronizeEventVtbl>() - 40usize];
    ["Alignment of ISynchronizeEventVtbl"]
        [::std::mem::align_of::<ISynchronizeEventVtbl>() - 8usize];
    ["Offset of field: ISynchronizeEventVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISynchronizeEventVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISynchronizeEventVtbl::AddRef"]
        [::std::mem::offset_of!(ISynchronizeEventVtbl, AddRef) - 8usize];
    ["Offset of field: ISynchronizeEventVtbl::Release"]
        [::std::mem::offset_of!(ISynchronizeEventVtbl, Release) - 16usize];
    ["Offset of field: ISynchronizeEventVtbl::GetHandle"]
        [::std::mem::offset_of!(ISynchronizeEventVtbl, GetHandle) - 24usize];
    ["Offset of field: ISynchronizeEventVtbl::SetEventHandle"]
        [::std::mem::offset_of!(ISynchronizeEventVtbl, SetEventHandle) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeEvent {
    pub lpVtbl: *mut ISynchronizeEventVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeEvent"][::std::mem::size_of::<ISynchronizeEvent>() - 8usize];
    ["Alignment of ISynchronizeEvent"][::std::mem::align_of::<ISynchronizeEvent>() - 8usize];
    ["Offset of field: ISynchronizeEvent::lpVtbl"]
        [::std::mem::offset_of!(ISynchronizeEvent, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ISynchronizeContainer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeContainerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeContainer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeContainer) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeContainer) -> ULONG>,
    pub AddSynchronize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISynchronizeContainer, pSync: *mut ISynchronize) -> HRESULT,
    >,
    pub WaitMultiple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeContainer,
            dwFlags: DWORD,
            dwTimeOut: DWORD,
            ppSync: *mut *mut ISynchronize,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeContainerVtbl"]
        [::std::mem::size_of::<ISynchronizeContainerVtbl>() - 40usize];
    ["Alignment of ISynchronizeContainerVtbl"]
        [::std::mem::align_of::<ISynchronizeContainerVtbl>() - 8usize];
    ["Offset of field: ISynchronizeContainerVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISynchronizeContainerVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISynchronizeContainerVtbl::AddRef"]
        [::std::mem::offset_of!(ISynchronizeContainerVtbl, AddRef) - 8usize];
    ["Offset of field: ISynchronizeContainerVtbl::Release"]
        [::std::mem::offset_of!(ISynchronizeContainerVtbl, Release) - 16usize];
    ["Offset of field: ISynchronizeContainerVtbl::AddSynchronize"]
        [::std::mem::offset_of!(ISynchronizeContainerVtbl, AddSynchronize) - 24usize];
    ["Offset of field: ISynchronizeContainerVtbl::WaitMultiple"]
        [::std::mem::offset_of!(ISynchronizeContainerVtbl, WaitMultiple) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeContainer {
    pub lpVtbl: *mut ISynchronizeContainerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeContainer"][::std::mem::size_of::<ISynchronizeContainer>() - 8usize];
    ["Alignment of ISynchronizeContainer"]
        [::std::mem::align_of::<ISynchronizeContainer>() - 8usize];
    ["Offset of field: ISynchronizeContainer::lpVtbl"]
        [::std::mem::offset_of!(ISynchronizeContainer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ISynchronizeMutex: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeMutexVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeMutex,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeMutex) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeMutex) -> ULONG>,
    pub Wait: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISynchronizeMutex,
            dwFlags: DWORD,
            dwMilliseconds: DWORD,
        ) -> HRESULT,
    >,
    pub Signal:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeMutex) -> HRESULT>,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeMutex) -> HRESULT>,
    pub ReleaseMutex:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ISynchronizeMutex) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeMutexVtbl"][::std::mem::size_of::<ISynchronizeMutexVtbl>() - 56usize];
    ["Alignment of ISynchronizeMutexVtbl"]
        [::std::mem::align_of::<ISynchronizeMutexVtbl>() - 8usize];
    ["Offset of field: ISynchronizeMutexVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISynchronizeMutexVtbl::AddRef"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, AddRef) - 8usize];
    ["Offset of field: ISynchronizeMutexVtbl::Release"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, Release) - 16usize];
    ["Offset of field: ISynchronizeMutexVtbl::Wait"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, Wait) - 24usize];
    ["Offset of field: ISynchronizeMutexVtbl::Signal"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, Signal) - 32usize];
    ["Offset of field: ISynchronizeMutexVtbl::Reset"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, Reset) - 40usize];
    ["Offset of field: ISynchronizeMutexVtbl::ReleaseMutex"]
        [::std::mem::offset_of!(ISynchronizeMutexVtbl, ReleaseMutex) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISynchronizeMutex {
    pub lpVtbl: *mut ISynchronizeMutexVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISynchronizeMutex"][::std::mem::size_of::<ISynchronizeMutex>() - 8usize];
    ["Alignment of ISynchronizeMutex"][::std::mem::align_of::<ISynchronizeMutex>() - 8usize];
    ["Offset of field: ISynchronizeMutex::lpVtbl"]
        [::std::mem::offset_of!(ISynchronizeMutex, lpVtbl) - 0usize];
};
pub type LPCANCELMETHODCALLS = *mut ICancelMethodCalls;
unsafe extern "C" {
    pub static IID_ICancelMethodCalls: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICancelMethodCallsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICancelMethodCalls,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICancelMethodCalls) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ICancelMethodCalls) -> ULONG>,
    pub Cancel: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICancelMethodCalls, ulSeconds: ULONG) -> HRESULT,
    >,
    pub TestCancel:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ICancelMethodCalls) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICancelMethodCallsVtbl"][::std::mem::size_of::<ICancelMethodCallsVtbl>() - 40usize];
    ["Alignment of ICancelMethodCallsVtbl"]
        [::std::mem::align_of::<ICancelMethodCallsVtbl>() - 8usize];
    ["Offset of field: ICancelMethodCallsVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICancelMethodCallsVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICancelMethodCallsVtbl::AddRef"]
        [::std::mem::offset_of!(ICancelMethodCallsVtbl, AddRef) - 8usize];
    ["Offset of field: ICancelMethodCallsVtbl::Release"]
        [::std::mem::offset_of!(ICancelMethodCallsVtbl, Release) - 16usize];
    ["Offset of field: ICancelMethodCallsVtbl::Cancel"]
        [::std::mem::offset_of!(ICancelMethodCallsVtbl, Cancel) - 24usize];
    ["Offset of field: ICancelMethodCallsVtbl::TestCancel"]
        [::std::mem::offset_of!(ICancelMethodCallsVtbl, TestCancel) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICancelMethodCalls {
    pub lpVtbl: *mut ICancelMethodCallsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICancelMethodCalls"][::std::mem::size_of::<ICancelMethodCalls>() - 8usize];
    ["Alignment of ICancelMethodCalls"][::std::mem::align_of::<ICancelMethodCalls>() - 8usize];
    ["Offset of field: ICancelMethodCalls::lpVtbl"]
        [::std::mem::offset_of!(ICancelMethodCalls, lpVtbl) - 0usize];
};
pub const tagDCOM_CALL_STATE_DCOM_NONE: tagDCOM_CALL_STATE = 0;
pub const tagDCOM_CALL_STATE_DCOM_CALL_COMPLETE: tagDCOM_CALL_STATE = 1;
pub const tagDCOM_CALL_STATE_DCOM_CALL_CANCELED: tagDCOM_CALL_STATE = 2;
pub type tagDCOM_CALL_STATE = ::std::os::raw::c_int;
pub use self::tagDCOM_CALL_STATE as DCOM_CALL_STATE;
unsafe extern "C" {
    pub static IID_IAsyncManager: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAsyncManagerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncManager,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAsyncManager) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAsyncManager) -> ULONG>,
    pub CompleteCall: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IAsyncManager, Result: HRESULT) -> HRESULT,
    >,
    pub GetCallContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAsyncManager,
            riid: *const IID,
            pInterface: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub GetState: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IAsyncManager, pulStateFlags: *mut ULONG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAsyncManagerVtbl"][::std::mem::size_of::<IAsyncManagerVtbl>() - 48usize];
    ["Alignment of IAsyncManagerVtbl"][::std::mem::align_of::<IAsyncManagerVtbl>() - 8usize];
    ["Offset of field: IAsyncManagerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAsyncManagerVtbl::AddRef"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, AddRef) - 8usize];
    ["Offset of field: IAsyncManagerVtbl::Release"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, Release) - 16usize];
    ["Offset of field: IAsyncManagerVtbl::CompleteCall"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, CompleteCall) - 24usize];
    ["Offset of field: IAsyncManagerVtbl::GetCallContext"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, GetCallContext) - 32usize];
    ["Offset of field: IAsyncManagerVtbl::GetState"]
        [::std::mem::offset_of!(IAsyncManagerVtbl, GetState) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAsyncManager {
    pub lpVtbl: *mut IAsyncManagerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAsyncManager"][::std::mem::size_of::<IAsyncManager>() - 8usize];
    ["Alignment of IAsyncManager"][::std::mem::align_of::<IAsyncManager>() - 8usize];
    ["Offset of field: IAsyncManager::lpVtbl"]
        [::std::mem::offset_of!(IAsyncManager, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ICallFactory: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICallFactoryVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICallFactory,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICallFactory) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICallFactory) -> ULONG>,
    pub CreateCall: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICallFactory,
            riid: *const IID,
            pCtrlUnk: *mut IUnknown,
            riid2: *const IID,
            ppv: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICallFactoryVtbl"][::std::mem::size_of::<ICallFactoryVtbl>() - 32usize];
    ["Alignment of ICallFactoryVtbl"][::std::mem::align_of::<ICallFactoryVtbl>() - 8usize];
    ["Offset of field: ICallFactoryVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICallFactoryVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICallFactoryVtbl::AddRef"]
        [::std::mem::offset_of!(ICallFactoryVtbl, AddRef) - 8usize];
    ["Offset of field: ICallFactoryVtbl::Release"]
        [::std::mem::offset_of!(ICallFactoryVtbl, Release) - 16usize];
    ["Offset of field: ICallFactoryVtbl::CreateCall"]
        [::std::mem::offset_of!(ICallFactoryVtbl, CreateCall) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICallFactory {
    pub lpVtbl: *mut ICallFactoryVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICallFactory"][::std::mem::size_of::<ICallFactory>() - 8usize];
    ["Alignment of ICallFactory"][::std::mem::align_of::<ICallFactory>() - 8usize];
    ["Offset of field: ICallFactory::lpVtbl"]
        [::std::mem::offset_of!(ICallFactory, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IRpcHelper: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcHelperVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcHelper,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcHelper) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRpcHelper) -> ULONG>,
    pub GetDCOMProtocolVersion: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRpcHelper, pComVersion: *mut DWORD) -> HRESULT,
    >,
    pub GetIIDFromOBJREF: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRpcHelper,
            pObjRef: *mut ::std::os::raw::c_void,
            piid: *mut *mut IID,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcHelperVtbl"][::std::mem::size_of::<IRpcHelperVtbl>() - 40usize];
    ["Alignment of IRpcHelperVtbl"][::std::mem::align_of::<IRpcHelperVtbl>() - 8usize];
    ["Offset of field: IRpcHelperVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRpcHelperVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRpcHelperVtbl::AddRef"]
        [::std::mem::offset_of!(IRpcHelperVtbl, AddRef) - 8usize];
    ["Offset of field: IRpcHelperVtbl::Release"]
        [::std::mem::offset_of!(IRpcHelperVtbl, Release) - 16usize];
    ["Offset of field: IRpcHelperVtbl::GetDCOMProtocolVersion"]
        [::std::mem::offset_of!(IRpcHelperVtbl, GetDCOMProtocolVersion) - 24usize];
    ["Offset of field: IRpcHelperVtbl::GetIIDFromOBJREF"]
        [::std::mem::offset_of!(IRpcHelperVtbl, GetIIDFromOBJREF) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRpcHelper {
    pub lpVtbl: *mut IRpcHelperVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRpcHelper"][::std::mem::size_of::<IRpcHelper>() - 8usize];
    ["Alignment of IRpcHelper"][::std::mem::align_of::<IRpcHelper>() - 8usize];
    ["Offset of field: IRpcHelper::lpVtbl"][::std::mem::offset_of!(IRpcHelper, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IReleaseMarshalBuffers: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IReleaseMarshalBuffersVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IReleaseMarshalBuffers,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IReleaseMarshalBuffers) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IReleaseMarshalBuffers) -> ULONG>,
    pub ReleaseMarshalBuffer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IReleaseMarshalBuffers,
            pMsg: *mut RPCOLEMESSAGE,
            dwFlags: DWORD,
            pChnl: *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IReleaseMarshalBuffersVtbl"]
        [::std::mem::size_of::<IReleaseMarshalBuffersVtbl>() - 32usize];
    ["Alignment of IReleaseMarshalBuffersVtbl"]
        [::std::mem::align_of::<IReleaseMarshalBuffersVtbl>() - 8usize];
    ["Offset of field: IReleaseMarshalBuffersVtbl::QueryInterface"]
        [::std::mem::offset_of!(IReleaseMarshalBuffersVtbl, QueryInterface) - 0usize];
    ["Offset of field: IReleaseMarshalBuffersVtbl::AddRef"]
        [::std::mem::offset_of!(IReleaseMarshalBuffersVtbl, AddRef) - 8usize];
    ["Offset of field: IReleaseMarshalBuffersVtbl::Release"]
        [::std::mem::offset_of!(IReleaseMarshalBuffersVtbl, Release) - 16usize];
    ["Offset of field: IReleaseMarshalBuffersVtbl::ReleaseMarshalBuffer"]
        [::std::mem::offset_of!(IReleaseMarshalBuffersVtbl, ReleaseMarshalBuffer) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IReleaseMarshalBuffers {
    pub lpVtbl: *mut IReleaseMarshalBuffersVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IReleaseMarshalBuffers"][::std::mem::size_of::<IReleaseMarshalBuffers>() - 8usize];
    ["Alignment of IReleaseMarshalBuffers"]
        [::std::mem::align_of::<IReleaseMarshalBuffers>() - 8usize];
    ["Offset of field: IReleaseMarshalBuffers::lpVtbl"]
        [::std::mem::offset_of!(IReleaseMarshalBuffers, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IWaitMultiple: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWaitMultipleVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWaitMultiple,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWaitMultiple) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IWaitMultiple) -> ULONG>,
    pub WaitMultiple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWaitMultiple,
            timeout: DWORD,
            pSync: *mut *mut ISynchronize,
        ) -> HRESULT,
    >,
    pub AddSynchronize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IWaitMultiple, pSync: *mut ISynchronize) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWaitMultipleVtbl"][::std::mem::size_of::<IWaitMultipleVtbl>() - 40usize];
    ["Alignment of IWaitMultipleVtbl"][::std::mem::align_of::<IWaitMultipleVtbl>() - 8usize];
    ["Offset of field: IWaitMultipleVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWaitMultipleVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWaitMultipleVtbl::AddRef"]
        [::std::mem::offset_of!(IWaitMultipleVtbl, AddRef) - 8usize];
    ["Offset of field: IWaitMultipleVtbl::Release"]
        [::std::mem::offset_of!(IWaitMultipleVtbl, Release) - 16usize];
    ["Offset of field: IWaitMultipleVtbl::WaitMultiple"]
        [::std::mem::offset_of!(IWaitMultipleVtbl, WaitMultiple) - 24usize];
    ["Offset of field: IWaitMultipleVtbl::AddSynchronize"]
        [::std::mem::offset_of!(IWaitMultipleVtbl, AddSynchronize) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWaitMultiple {
    pub lpVtbl: *mut IWaitMultipleVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWaitMultiple"][::std::mem::size_of::<IWaitMultiple>() - 8usize];
    ["Alignment of IWaitMultiple"][::std::mem::align_of::<IWaitMultiple>() - 8usize];
    ["Offset of field: IWaitMultiple::lpVtbl"]
        [::std::mem::offset_of!(IWaitMultiple, lpVtbl) - 0usize];
};
pub type LPADDRTRACKINGCONTROL = *mut IAddrTrackingControl;
unsafe extern "C" {
    pub static IID_IAddrTrackingControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAddrTrackingControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAddrTrackingControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrTrackingControl) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrTrackingControl) -> ULONG>,
    pub EnableCOMDynamicAddrTracking:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrTrackingControl) -> HRESULT>,
    pub DisableCOMDynamicAddrTracking:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrTrackingControl) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAddrTrackingControlVtbl"]
        [::std::mem::size_of::<IAddrTrackingControlVtbl>() - 40usize];
    ["Alignment of IAddrTrackingControlVtbl"]
        [::std::mem::align_of::<IAddrTrackingControlVtbl>() - 8usize];
    ["Offset of field: IAddrTrackingControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAddrTrackingControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAddrTrackingControlVtbl::AddRef"]
        [::std::mem::offset_of!(IAddrTrackingControlVtbl, AddRef) - 8usize];
    ["Offset of field: IAddrTrackingControlVtbl::Release"]
        [::std::mem::offset_of!(IAddrTrackingControlVtbl, Release) - 16usize];
    ["Offset of field: IAddrTrackingControlVtbl::EnableCOMDynamicAddrTracking"]
        [::std::mem::offset_of!(IAddrTrackingControlVtbl, EnableCOMDynamicAddrTracking) - 24usize];
    ["Offset of field: IAddrTrackingControlVtbl::DisableCOMDynamicAddrTracking"]
        [::std::mem::offset_of!(IAddrTrackingControlVtbl, DisableCOMDynamicAddrTracking) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAddrTrackingControl {
    pub lpVtbl: *mut IAddrTrackingControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAddrTrackingControl"][::std::mem::size_of::<IAddrTrackingControl>() - 8usize];
    ["Alignment of IAddrTrackingControl"][::std::mem::align_of::<IAddrTrackingControl>() - 8usize];
    ["Offset of field: IAddrTrackingControl::lpVtbl"]
        [::std::mem::offset_of!(IAddrTrackingControl, lpVtbl) - 0usize];
};
pub type LPADDREXCLUSIONCONTROL = *mut IAddrExclusionControl;
unsafe extern "C" {
    pub static IID_IAddrExclusionControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAddrExclusionControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAddrExclusionControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrExclusionControl) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAddrExclusionControl) -> ULONG>,
    pub GetCurrentAddrExclusionList: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAddrExclusionControl,
            riid: *const IID,
            ppEnumerator: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub UpdateAddrExclusionList: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAddrExclusionControl,
            pEnumerator: *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAddrExclusionControlVtbl"]
        [::std::mem::size_of::<IAddrExclusionControlVtbl>() - 40usize];
    ["Alignment of IAddrExclusionControlVtbl"]
        [::std::mem::align_of::<IAddrExclusionControlVtbl>() - 8usize];
    ["Offset of field: IAddrExclusionControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAddrExclusionControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAddrExclusionControlVtbl::AddRef"]
        [::std::mem::offset_of!(IAddrExclusionControlVtbl, AddRef) - 8usize];
    ["Offset of field: IAddrExclusionControlVtbl::Release"]
        [::std::mem::offset_of!(IAddrExclusionControlVtbl, Release) - 16usize];
    ["Offset of field: IAddrExclusionControlVtbl::GetCurrentAddrExclusionList"]
        [::std::mem::offset_of!(IAddrExclusionControlVtbl, GetCurrentAddrExclusionList) - 24usize];
    ["Offset of field: IAddrExclusionControlVtbl::UpdateAddrExclusionList"]
        [::std::mem::offset_of!(IAddrExclusionControlVtbl, UpdateAddrExclusionList) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAddrExclusionControl {
    pub lpVtbl: *mut IAddrExclusionControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAddrExclusionControl"][::std::mem::size_of::<IAddrExclusionControl>() - 8usize];
    ["Alignment of IAddrExclusionControl"]
        [::std::mem::align_of::<IAddrExclusionControl>() - 8usize];
    ["Offset of field: IAddrExclusionControl::lpVtbl"]
        [::std::mem::offset_of!(IAddrExclusionControl, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IPipeByte: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeByteVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeByte,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeByte) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeByte) -> ULONG>,
    pub Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeByte,
            buf: *mut BYTE,
            cRequest: ULONG,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Push: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPipeByte, buf: *mut BYTE, cSent: ULONG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeByteVtbl"][::std::mem::size_of::<IPipeByteVtbl>() - 40usize];
    ["Alignment of IPipeByteVtbl"][::std::mem::align_of::<IPipeByteVtbl>() - 8usize];
    ["Offset of field: IPipeByteVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPipeByteVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPipeByteVtbl::AddRef"]
        [::std::mem::offset_of!(IPipeByteVtbl, AddRef) - 8usize];
    ["Offset of field: IPipeByteVtbl::Release"]
        [::std::mem::offset_of!(IPipeByteVtbl, Release) - 16usize];
    ["Offset of field: IPipeByteVtbl::Pull"][::std::mem::offset_of!(IPipeByteVtbl, Pull) - 24usize];
    ["Offset of field: IPipeByteVtbl::Push"][::std::mem::offset_of!(IPipeByteVtbl, Push) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeByte {
    pub lpVtbl: *mut IPipeByteVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeByte"][::std::mem::size_of::<IPipeByte>() - 8usize];
    ["Alignment of IPipeByte"][::std::mem::align_of::<IPipeByte>() - 8usize];
    ["Offset of field: IPipeByte::lpVtbl"][::std::mem::offset_of!(IPipeByte, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_AsyncIPipeByte: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeByteVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeByte,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeByte) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeByte) -> ULONG>,
    pub Begin_Pull: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIPipeByte, cRequest: ULONG) -> HRESULT,
    >,
    pub Finish_Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeByte,
            buf: *mut BYTE,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Begin_Push: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIPipeByte, buf: *mut BYTE, cSent: ULONG) -> HRESULT,
    >,
    pub Finish_Push:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeByte) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeByteVtbl"][::std::mem::size_of::<AsyncIPipeByteVtbl>() - 56usize];
    ["Alignment of AsyncIPipeByteVtbl"][::std::mem::align_of::<AsyncIPipeByteVtbl>() - 8usize];
    ["Offset of field: AsyncIPipeByteVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIPipeByteVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIPipeByteVtbl::Release"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, Release) - 16usize];
    ["Offset of field: AsyncIPipeByteVtbl::Begin_Pull"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, Begin_Pull) - 24usize];
    ["Offset of field: AsyncIPipeByteVtbl::Finish_Pull"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, Finish_Pull) - 32usize];
    ["Offset of field: AsyncIPipeByteVtbl::Begin_Push"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, Begin_Push) - 40usize];
    ["Offset of field: AsyncIPipeByteVtbl::Finish_Push"]
        [::std::mem::offset_of!(AsyncIPipeByteVtbl, Finish_Push) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeByte {
    pub lpVtbl: *mut AsyncIPipeByteVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeByte"][::std::mem::size_of::<AsyncIPipeByte>() - 8usize];
    ["Alignment of AsyncIPipeByte"][::std::mem::align_of::<AsyncIPipeByte>() - 8usize];
    ["Offset of field: AsyncIPipeByte::lpVtbl"]
        [::std::mem::offset_of!(AsyncIPipeByte, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IPipeLong: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeLongVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeLong,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeLong) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeLong) -> ULONG>,
    pub Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeLong,
            buf: *mut LONG,
            cRequest: ULONG,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Push: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPipeLong, buf: *mut LONG, cSent: ULONG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeLongVtbl"][::std::mem::size_of::<IPipeLongVtbl>() - 40usize];
    ["Alignment of IPipeLongVtbl"][::std::mem::align_of::<IPipeLongVtbl>() - 8usize];
    ["Offset of field: IPipeLongVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPipeLongVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPipeLongVtbl::AddRef"]
        [::std::mem::offset_of!(IPipeLongVtbl, AddRef) - 8usize];
    ["Offset of field: IPipeLongVtbl::Release"]
        [::std::mem::offset_of!(IPipeLongVtbl, Release) - 16usize];
    ["Offset of field: IPipeLongVtbl::Pull"][::std::mem::offset_of!(IPipeLongVtbl, Pull) - 24usize];
    ["Offset of field: IPipeLongVtbl::Push"][::std::mem::offset_of!(IPipeLongVtbl, Push) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeLong {
    pub lpVtbl: *mut IPipeLongVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeLong"][::std::mem::size_of::<IPipeLong>() - 8usize];
    ["Alignment of IPipeLong"][::std::mem::align_of::<IPipeLong>() - 8usize];
    ["Offset of field: IPipeLong::lpVtbl"][::std::mem::offset_of!(IPipeLong, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_AsyncIPipeLong: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeLongVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeLong,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeLong) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeLong) -> ULONG>,
    pub Begin_Pull: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIPipeLong, cRequest: ULONG) -> HRESULT,
    >,
    pub Finish_Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeLong,
            buf: *mut LONG,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Begin_Push: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIPipeLong, buf: *mut LONG, cSent: ULONG) -> HRESULT,
    >,
    pub Finish_Push:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeLong) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeLongVtbl"][::std::mem::size_of::<AsyncIPipeLongVtbl>() - 56usize];
    ["Alignment of AsyncIPipeLongVtbl"][::std::mem::align_of::<AsyncIPipeLongVtbl>() - 8usize];
    ["Offset of field: AsyncIPipeLongVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIPipeLongVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIPipeLongVtbl::Release"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, Release) - 16usize];
    ["Offset of field: AsyncIPipeLongVtbl::Begin_Pull"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, Begin_Pull) - 24usize];
    ["Offset of field: AsyncIPipeLongVtbl::Finish_Pull"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, Finish_Pull) - 32usize];
    ["Offset of field: AsyncIPipeLongVtbl::Begin_Push"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, Begin_Push) - 40usize];
    ["Offset of field: AsyncIPipeLongVtbl::Finish_Push"]
        [::std::mem::offset_of!(AsyncIPipeLongVtbl, Finish_Push) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeLong {
    pub lpVtbl: *mut AsyncIPipeLongVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeLong"][::std::mem::size_of::<AsyncIPipeLong>() - 8usize];
    ["Alignment of AsyncIPipeLong"][::std::mem::align_of::<AsyncIPipeLong>() - 8usize];
    ["Offset of field: AsyncIPipeLong::lpVtbl"]
        [::std::mem::offset_of!(AsyncIPipeLong, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IPipeDouble: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeDoubleVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeDouble,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeDouble) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPipeDouble) -> ULONG>,
    pub Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPipeDouble,
            buf: *mut DOUBLE,
            cRequest: ULONG,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Push: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPipeDouble, buf: *mut DOUBLE, cSent: ULONG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeDoubleVtbl"][::std::mem::size_of::<IPipeDoubleVtbl>() - 40usize];
    ["Alignment of IPipeDoubleVtbl"][::std::mem::align_of::<IPipeDoubleVtbl>() - 8usize];
    ["Offset of field: IPipeDoubleVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPipeDoubleVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPipeDoubleVtbl::AddRef"]
        [::std::mem::offset_of!(IPipeDoubleVtbl, AddRef) - 8usize];
    ["Offset of field: IPipeDoubleVtbl::Release"]
        [::std::mem::offset_of!(IPipeDoubleVtbl, Release) - 16usize];
    ["Offset of field: IPipeDoubleVtbl::Pull"]
        [::std::mem::offset_of!(IPipeDoubleVtbl, Pull) - 24usize];
    ["Offset of field: IPipeDoubleVtbl::Push"]
        [::std::mem::offset_of!(IPipeDoubleVtbl, Push) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPipeDouble {
    pub lpVtbl: *mut IPipeDoubleVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPipeDouble"][::std::mem::size_of::<IPipeDouble>() - 8usize];
    ["Alignment of IPipeDouble"][::std::mem::align_of::<IPipeDouble>() - 8usize];
    ["Offset of field: IPipeDouble::lpVtbl"][::std::mem::offset_of!(IPipeDouble, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_AsyncIPipeDouble: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeDoubleVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeDouble,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeDouble) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeDouble) -> ULONG>,
    pub Begin_Pull: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIPipeDouble, cRequest: ULONG) -> HRESULT,
    >,
    pub Finish_Pull: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeDouble,
            buf: *mut DOUBLE,
            pcReturned: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Begin_Push: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIPipeDouble,
            buf: *mut DOUBLE,
            cSent: ULONG,
        ) -> HRESULT,
    >,
    pub Finish_Push:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIPipeDouble) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeDoubleVtbl"][::std::mem::size_of::<AsyncIPipeDoubleVtbl>() - 56usize];
    ["Alignment of AsyncIPipeDoubleVtbl"][::std::mem::align_of::<AsyncIPipeDoubleVtbl>() - 8usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::Release"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, Release) - 16usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::Begin_Pull"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, Begin_Pull) - 24usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::Finish_Pull"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, Finish_Pull) - 32usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::Begin_Push"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, Begin_Push) - 40usize];
    ["Offset of field: AsyncIPipeDoubleVtbl::Finish_Push"]
        [::std::mem::offset_of!(AsyncIPipeDoubleVtbl, Finish_Push) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIPipeDouble {
    pub lpVtbl: *mut AsyncIPipeDoubleVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIPipeDouble"][::std::mem::size_of::<AsyncIPipeDouble>() - 8usize];
    ["Alignment of AsyncIPipeDouble"][::std::mem::align_of::<AsyncIPipeDouble>() - 8usize];
    ["Offset of field: AsyncIPipeDouble::lpVtbl"]
        [::std::mem::offset_of!(AsyncIPipeDouble, lpVtbl) - 0usize];
};
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_NONE: _APTTYPEQUALIFIER = 0;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_IMPLICIT_MTA: _APTTYPEQUALIFIER = 1;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_NA_ON_MTA: _APTTYPEQUALIFIER = 2;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_NA_ON_STA: _APTTYPEQUALIFIER = 3;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_NA_ON_IMPLICIT_MTA: _APTTYPEQUALIFIER = 4;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_NA_ON_MAINSTA: _APTTYPEQUALIFIER = 5;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_APPLICATION_STA: _APTTYPEQUALIFIER = 6;
pub const _APTTYPEQUALIFIER_APTTYPEQUALIFIER_RESERVED_1: _APTTYPEQUALIFIER = 7;
pub type _APTTYPEQUALIFIER = ::std::os::raw::c_int;
pub use self::_APTTYPEQUALIFIER as APTTYPEQUALIFIER;
pub const _APTTYPE_APTTYPE_CURRENT: _APTTYPE = -1;
pub const _APTTYPE_APTTYPE_STA: _APTTYPE = 0;
pub const _APTTYPE_APTTYPE_MTA: _APTTYPE = 1;
pub const _APTTYPE_APTTYPE_NA: _APTTYPE = 2;
pub const _APTTYPE_APTTYPE_MAINSTA: _APTTYPE = 3;
pub type _APTTYPE = ::std::os::raw::c_int;
pub use self::_APTTYPE as APTTYPE;
pub const _THDTYPE_THDTYPE_BLOCKMESSAGES: _THDTYPE = 0;
pub const _THDTYPE_THDTYPE_PROCESSMESSAGES: _THDTYPE = 1;
pub type _THDTYPE = ::std::os::raw::c_int;
pub use self::_THDTYPE as THDTYPE;
pub type APARTMENTID = DWORD;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0048_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0048_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IComThreadingInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IComThreadingInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IComThreadingInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IComThreadingInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IComThreadingInfo) -> ULONG>,
    pub GetCurrentApartmentType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IComThreadingInfo, pAptType: *mut APTTYPE) -> HRESULT,
    >,
    pub GetCurrentThreadType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IComThreadingInfo, pThreadType: *mut THDTYPE) -> HRESULT,
    >,
    pub GetCurrentLogicalThreadId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IComThreadingInfo,
            pguidLogicalThreadId: *mut GUID,
        ) -> HRESULT,
    >,
    pub SetCurrentLogicalThreadId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IComThreadingInfo, rguid: *const GUID) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IComThreadingInfoVtbl"][::std::mem::size_of::<IComThreadingInfoVtbl>() - 56usize];
    ["Alignment of IComThreadingInfoVtbl"]
        [::std::mem::align_of::<IComThreadingInfoVtbl>() - 8usize];
    ["Offset of field: IComThreadingInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IComThreadingInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IComThreadingInfoVtbl::Release"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, Release) - 16usize];
    ["Offset of field: IComThreadingInfoVtbl::GetCurrentApartmentType"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, GetCurrentApartmentType) - 24usize];
    ["Offset of field: IComThreadingInfoVtbl::GetCurrentThreadType"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, GetCurrentThreadType) - 32usize];
    ["Offset of field: IComThreadingInfoVtbl::GetCurrentLogicalThreadId"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, GetCurrentLogicalThreadId) - 40usize];
    ["Offset of field: IComThreadingInfoVtbl::SetCurrentLogicalThreadId"]
        [::std::mem::offset_of!(IComThreadingInfoVtbl, SetCurrentLogicalThreadId) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IComThreadingInfo {
    pub lpVtbl: *mut IComThreadingInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IComThreadingInfo"][::std::mem::size_of::<IComThreadingInfo>() - 8usize];
    ["Alignment of IComThreadingInfo"][::std::mem::align_of::<IComThreadingInfo>() - 8usize];
    ["Offset of field: IComThreadingInfo::lpVtbl"]
        [::std::mem::offset_of!(IComThreadingInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IProcessInitControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProcessInitControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IProcessInitControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessInitControl) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessInitControl) -> ULONG>,
    pub ResetInitializerTimeout: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IProcessInitControl, dwSecondsRemaining: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProcessInitControlVtbl"][::std::mem::size_of::<IProcessInitControlVtbl>() - 32usize];
    ["Alignment of IProcessInitControlVtbl"]
        [::std::mem::align_of::<IProcessInitControlVtbl>() - 8usize];
    ["Offset of field: IProcessInitControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(IProcessInitControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: IProcessInitControlVtbl::AddRef"]
        [::std::mem::offset_of!(IProcessInitControlVtbl, AddRef) - 8usize];
    ["Offset of field: IProcessInitControlVtbl::Release"]
        [::std::mem::offset_of!(IProcessInitControlVtbl, Release) - 16usize];
    ["Offset of field: IProcessInitControlVtbl::ResetInitializerTimeout"]
        [::std::mem::offset_of!(IProcessInitControlVtbl, ResetInitializerTimeout) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProcessInitControl {
    pub lpVtbl: *mut IProcessInitControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProcessInitControl"][::std::mem::size_of::<IProcessInitControl>() - 8usize];
    ["Alignment of IProcessInitControl"][::std::mem::align_of::<IProcessInitControl>() - 8usize];
    ["Offset of field: IProcessInitControl::lpVtbl"]
        [::std::mem::offset_of!(IProcessInitControl, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IFastRundown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IFastRundownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IFastRundown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IFastRundown) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IFastRundown) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IFastRundownVtbl"][::std::mem::size_of::<IFastRundownVtbl>() - 24usize];
    ["Alignment of IFastRundownVtbl"][::std::mem::align_of::<IFastRundownVtbl>() - 8usize];
    ["Offset of field: IFastRundownVtbl::QueryInterface"]
        [::std::mem::offset_of!(IFastRundownVtbl, QueryInterface) - 0usize];
    ["Offset of field: IFastRundownVtbl::AddRef"]
        [::std::mem::offset_of!(IFastRundownVtbl, AddRef) - 8usize];
    ["Offset of field: IFastRundownVtbl::Release"]
        [::std::mem::offset_of!(IFastRundownVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IFastRundown {
    pub lpVtbl: *mut IFastRundownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IFastRundown"][::std::mem::size_of::<IFastRundown>() - 8usize];
    ["Alignment of IFastRundown"][::std::mem::align_of::<IFastRundown>() - 8usize];
    ["Offset of field: IFastRundown::lpVtbl"]
        [::std::mem::offset_of!(IFastRundown, lpVtbl) - 0usize];
};
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_SOURCE_IS_APP_CONTAINER:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = 0;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_1:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483648;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_2:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483647;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_3:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483646;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_4:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483645;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_5:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483644;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_6:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483643;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_7:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483642;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_8:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483641;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_9:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483640;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_10:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483639;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_11:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483638;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_12:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483637;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_13:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483636;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_14:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483635;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_15:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483634;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_16:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483633;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_17:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483632;
pub const CO_MARSHALING_CONTEXT_ATTRIBUTES_CO_MARSHALING_CONTEXT_ATTRIBUTE_RESERVED_18:
    CO_MARSHALING_CONTEXT_ATTRIBUTES = -2147483631;
pub type CO_MARSHALING_CONTEXT_ATTRIBUTES = ::std::os::raw::c_int;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0051_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0051_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IMarshalingStream: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshalingStreamVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshalingStream) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshalingStream) -> ULONG>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Write: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Seek: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            dlibMove: LARGE_INTEGER,
            dwOrigin: DWORD,
            plibNewPosition: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub SetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshalingStream, libNewSize: ULARGE_INTEGER) -> HRESULT,
    >,
    pub CopyTo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            pstm: *mut IStream,
            cb: ULARGE_INTEGER,
            pcbRead: *mut ULARGE_INTEGER,
            pcbWritten: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub Commit: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshalingStream, grfCommitFlags: DWORD) -> HRESULT,
    >,
    pub Revert:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IMarshalingStream) -> HRESULT>,
    pub LockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub UnlockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub Stat: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            pstatstg: *mut STATSTG,
            grfStatFlag: DWORD,
        ) -> HRESULT,
    >,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMarshalingStream, ppstm: *mut *mut IStream) -> HRESULT,
    >,
    pub GetMarshalingContextAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMarshalingStream,
            attribute: CO_MARSHALING_CONTEXT_ATTRIBUTES,
            pAttributeValue: *mut ULONG_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshalingStreamVtbl"][::std::mem::size_of::<IMarshalingStreamVtbl>() - 120usize];
    ["Alignment of IMarshalingStreamVtbl"]
        [::std::mem::align_of::<IMarshalingStreamVtbl>() - 8usize];
    ["Offset of field: IMarshalingStreamVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMarshalingStreamVtbl::AddRef"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, AddRef) - 8usize];
    ["Offset of field: IMarshalingStreamVtbl::Release"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Release) - 16usize];
    ["Offset of field: IMarshalingStreamVtbl::Read"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Read) - 24usize];
    ["Offset of field: IMarshalingStreamVtbl::Write"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Write) - 32usize];
    ["Offset of field: IMarshalingStreamVtbl::Seek"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Seek) - 40usize];
    ["Offset of field: IMarshalingStreamVtbl::SetSize"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, SetSize) - 48usize];
    ["Offset of field: IMarshalingStreamVtbl::CopyTo"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, CopyTo) - 56usize];
    ["Offset of field: IMarshalingStreamVtbl::Commit"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Commit) - 64usize];
    ["Offset of field: IMarshalingStreamVtbl::Revert"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Revert) - 72usize];
    ["Offset of field: IMarshalingStreamVtbl::LockRegion"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, LockRegion) - 80usize];
    ["Offset of field: IMarshalingStreamVtbl::UnlockRegion"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, UnlockRegion) - 88usize];
    ["Offset of field: IMarshalingStreamVtbl::Stat"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Stat) - 96usize];
    ["Offset of field: IMarshalingStreamVtbl::Clone"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, Clone) - 104usize];
    ["Offset of field: IMarshalingStreamVtbl::GetMarshalingContextAttribute"]
        [::std::mem::offset_of!(IMarshalingStreamVtbl, GetMarshalingContextAttribute) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMarshalingStream {
    pub lpVtbl: *mut IMarshalingStreamVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMarshalingStream"][::std::mem::size_of::<IMarshalingStream>() - 8usize];
    ["Alignment of IMarshalingStream"][::std::mem::align_of::<IMarshalingStream>() - 8usize];
    ["Offset of field: IMarshalingStream::lpVtbl"]
        [::std::mem::offset_of!(IMarshalingStream, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0052_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0052_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IAgileReference: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAgileReferenceVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAgileReference,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAgileReference) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAgileReference) -> ULONG>,
    pub Resolve: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAgileReference,
            riid: *const IID,
            ppvObjectReference: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAgileReferenceVtbl"][::std::mem::size_of::<IAgileReferenceVtbl>() - 32usize];
    ["Alignment of IAgileReferenceVtbl"][::std::mem::align_of::<IAgileReferenceVtbl>() - 8usize];
    ["Offset of field: IAgileReferenceVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAgileReferenceVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAgileReferenceVtbl::AddRef"]
        [::std::mem::offset_of!(IAgileReferenceVtbl, AddRef) - 8usize];
    ["Offset of field: IAgileReferenceVtbl::Release"]
        [::std::mem::offset_of!(IAgileReferenceVtbl, Release) - 16usize];
    ["Offset of field: IAgileReferenceVtbl::Resolve"]
        [::std::mem::offset_of!(IAgileReferenceVtbl, Resolve) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAgileReference {
    pub lpVtbl: *mut IAgileReferenceVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAgileReference"][::std::mem::size_of::<IAgileReference>() - 8usize];
    ["Alignment of IAgileReference"][::std::mem::align_of::<IAgileReference>() - 8usize];
    ["Offset of field: IAgileReference::lpVtbl"]
        [::std::mem::offset_of!(IAgileReference, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ICallbackWithNoReentrancyToApplicationSTA: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct MachineGlobalObjectTableRegistrationToken__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of MachineGlobalObjectTableRegistrationToken__"]
        [::std::mem::size_of::<MachineGlobalObjectTableRegistrationToken__>() - 4usize];
    ["Alignment of MachineGlobalObjectTableRegistrationToken__"]
        [::std::mem::align_of::<MachineGlobalObjectTableRegistrationToken__>() - 4usize];
    ["Offset of field: MachineGlobalObjectTableRegistrationToken__::unused"]
        [::std::mem::offset_of!(MachineGlobalObjectTableRegistrationToken__, unused) - 0usize];
};
pub type MachineGlobalObjectTableRegistrationToken =
    *mut MachineGlobalObjectTableRegistrationToken__;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0053_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0053_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IMachineGlobalObjectTable: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMachineGlobalObjectTableVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMachineGlobalObjectTable,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IMachineGlobalObjectTable) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IMachineGlobalObjectTable) -> ULONG>,
    pub RegisterObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMachineGlobalObjectTable,
            clsid: *const IID,
            identifier: LPCWSTR,
            object: *mut IUnknown,
            token: *mut MachineGlobalObjectTableRegistrationToken,
        ) -> HRESULT,
    >,
    pub GetObjectA: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMachineGlobalObjectTable,
            clsid: *const IID,
            identifier: LPCWSTR,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub RevokeObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMachineGlobalObjectTable,
            token: MachineGlobalObjectTableRegistrationToken,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMachineGlobalObjectTableVtbl"]
        [::std::mem::size_of::<IMachineGlobalObjectTableVtbl>() - 48usize];
    ["Alignment of IMachineGlobalObjectTableVtbl"]
        [::std::mem::align_of::<IMachineGlobalObjectTableVtbl>() - 8usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::AddRef"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, AddRef) - 8usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::Release"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, Release) - 16usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::RegisterObject"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, RegisterObject) - 24usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::GetObjectA"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, GetObjectA) - 32usize];
    ["Offset of field: IMachineGlobalObjectTableVtbl::RevokeObject"]
        [::std::mem::offset_of!(IMachineGlobalObjectTableVtbl, RevokeObject) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMachineGlobalObjectTable {
    pub lpVtbl: *mut IMachineGlobalObjectTableVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMachineGlobalObjectTable"]
        [::std::mem::size_of::<IMachineGlobalObjectTable>() - 8usize];
    ["Alignment of IMachineGlobalObjectTable"]
        [::std::mem::align_of::<IMachineGlobalObjectTable>() - 8usize];
    ["Offset of field: IMachineGlobalObjectTable::lpVtbl"]
        [::std::mem::offset_of!(IMachineGlobalObjectTable, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0054_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0054_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_ISupportAllowLowerTrustActivation: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISupportAllowLowerTrustActivationVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISupportAllowLowerTrustActivation,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISupportAllowLowerTrustActivation) -> ULONG,
    >,
    pub Release: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISupportAllowLowerTrustActivation) -> ULONG,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISupportAllowLowerTrustActivationVtbl"]
        [::std::mem::size_of::<ISupportAllowLowerTrustActivationVtbl>() - 24usize];
    ["Alignment of ISupportAllowLowerTrustActivationVtbl"]
        [::std::mem::align_of::<ISupportAllowLowerTrustActivationVtbl>() - 8usize];
    ["Offset of field: ISupportAllowLowerTrustActivationVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISupportAllowLowerTrustActivationVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISupportAllowLowerTrustActivationVtbl::AddRef"]
        [::std::mem::offset_of!(ISupportAllowLowerTrustActivationVtbl, AddRef) - 8usize];
    ["Offset of field: ISupportAllowLowerTrustActivationVtbl::Release"]
        [::std::mem::offset_of!(ISupportAllowLowerTrustActivationVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISupportAllowLowerTrustActivation {
    pub lpVtbl: *mut ISupportAllowLowerTrustActivationVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISupportAllowLowerTrustActivation"]
        [::std::mem::size_of::<ISupportAllowLowerTrustActivation>() - 8usize];
    ["Alignment of ISupportAllowLowerTrustActivation"]
        [::std::mem::align_of::<ISupportAllowLowerTrustActivation>() - 8usize];
    ["Offset of field: ISupportAllowLowerTrustActivation::lpVtbl"]
        [::std::mem::offset_of!(ISupportAllowLowerTrustActivation, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0055_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidlbase_0000_0055_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn IEnumUnknown_Next_Proxy(
        This: *mut IEnumUnknown,
        celt: ULONG,
        rgelt: *mut *mut IUnknown,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumUnknown_Next_Stub(
        This: *mut IEnumUnknown,
        celt: ULONG,
        rgelt: *mut *mut IUnknown,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumString_Next_Proxy(
        This: *mut IEnumString,
        celt: ULONG,
        rgelt: *mut LPOLESTR,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumString_Next_Stub(
        This: *mut IEnumString,
        celt: ULONG,
        rgelt: *mut LPOLESTR,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_Read_Proxy(
        This: *mut ISequentialStream,
        pv: *mut ::std::os::raw::c_void,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_Read_Stub(
        This: *mut ISequentialStream,
        pv: *mut byte,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_Write_Proxy(
        This: *mut ISequentialStream,
        pv: *const ::std::os::raw::c_void,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ISequentialStream_Write_Stub(
        This: *mut ISequentialStream,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_Seek_Proxy(
        This: *mut IStream,
        dlibMove: LARGE_INTEGER,
        dwOrigin: DWORD,
        plibNewPosition: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_Seek_Stub(
        This: *mut IStream,
        dlibMove: LARGE_INTEGER,
        dwOrigin: DWORD,
        plibNewPosition: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_CopyTo_Proxy(
        This: *mut IStream,
        pstm: *mut IStream,
        cb: ULARGE_INTEGER,
        pcbRead: *mut ULARGE_INTEGER,
        pcbWritten: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStream_CopyTo_Stub(
        This: *mut IStream,
        pstm: *mut IStream,
        cb: ULARGE_INTEGER,
        pcbRead: *mut ULARGE_INTEGER,
        pcbWritten: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static GUID_NULL: IID;
}
unsafe extern "C" {
    pub static CATID_MARSHALER: IID;
}
unsafe extern "C" {
    pub static IID_IRpcChannel: IID;
}
unsafe extern "C" {
    pub static IID_IRpcStub: IID;
}
unsafe extern "C" {
    pub static IID_IStubManager: IID;
}
unsafe extern "C" {
    pub static IID_IRpcProxy: IID;
}
unsafe extern "C" {
    pub static IID_IProxyManager: IID;
}
unsafe extern "C" {
    pub static IID_IPSFactory: IID;
}
unsafe extern "C" {
    pub static IID_IInternalMoniker: IID;
}
unsafe extern "C" {
    pub static IID_IDfReserved1: IID;
}
unsafe extern "C" {
    pub static IID_IDfReserved2: IID;
}
unsafe extern "C" {
    pub static IID_IDfReserved3: IID;
}
unsafe extern "C" {
    pub static CLSID_StdMarshal: CLSID;
}
unsafe extern "C" {
    pub static CLSID_AggStdMarshal: CLSID;
}
unsafe extern "C" {
    pub static CLSID_StdAsyncActManager: CLSID;
}
unsafe extern "C" {
    pub static IID_IStub: IID;
}
unsafe extern "C" {
    pub static IID_IProxy: IID;
}
unsafe extern "C" {
    pub static IID_IEnumGeneric: IID;
}
unsafe extern "C" {
    pub static IID_IEnumHolder: IID;
}
unsafe extern "C" {
    pub static IID_IEnumCallback: IID;
}
unsafe extern "C" {
    pub static IID_IOleManager: IID;
}
unsafe extern "C" {
    pub static IID_IOlePresObj: IID;
}
unsafe extern "C" {
    pub static IID_IDebug: IID;
}
unsafe extern "C" {
    pub static IID_IDebugStream: IID;
}
unsafe extern "C" {
    pub static CLSID_PSGenObject: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSClientSite: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSClassObject: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSInPlaceActive: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSInPlaceFrame: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSDragDrop: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSBindCtx: CLSID;
}
unsafe extern "C" {
    pub static CLSID_PSEnumerators: CLSID;
}
unsafe extern "C" {
    pub static CLSID_StaticMetafile: CLSID;
}
unsafe extern "C" {
    pub static CLSID_StaticDib: CLSID;
}
unsafe extern "C" {
    pub static CID_CDfsVolume: CLSID;
}
unsafe extern "C" {
    pub static CLSID_DCOMAccessControl: CLSID;
}
unsafe extern "C" {
    pub static CLSID_GlobalOptions: CLSID;
}
unsafe extern "C" {
    pub static CLSID_StdGlobalInterfaceTable: CLSID;
}
unsafe extern "C" {
    pub static CLSID_MachineGlobalObjectTable: CLSID;
}
unsafe extern "C" {
    pub static CLSID_ActivationCapabilities: CLSID;
}
unsafe extern "C" {
    pub static CLSID_ComBinding: CLSID;
}
unsafe extern "C" {
    pub static CLSID_StdEvent: CLSID;
}
unsafe extern "C" {
    pub static CLSID_ManualResetEvent: CLSID;
}
unsafe extern "C" {
    pub static CLSID_SynchronizeContainer: CLSID;
}
unsafe extern "C" {
    pub static CLSID_AddrControl: CLSID;
}
unsafe extern "C" {
    pub static CLSID_ContextSwitcher: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDFormKrnl: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDFormDialog: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDCommandButton: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDComboBox: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDTextBox: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDCheckBox: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDLabel: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDOptionButton: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDListBox: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDScrollBar: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDGroupBox: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDGeneralPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDGenericPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDFontPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDColorPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDLabelPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDCheckBoxPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDTextBoxPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDOptionButtonPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDListBoxPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDCommandButtonPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDComboBoxPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDScrollBarPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDGroupBoxPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CCDXObjectPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CStdPropertyFrame: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CFormPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CGridPropertyPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CWSJArticlePage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_CSystemPage: CLSID;
}
unsafe extern "C" {
    pub static CLSID_IdentityUnmarshal: CLSID;
}
unsafe extern "C" {
    pub static CLSID_InProcFreeMarshaler: CLSID;
}
unsafe extern "C" {
    pub static CLSID_Picture_Metafile: CLSID;
}
unsafe extern "C" {
    pub static CLSID_Picture_EnhMetafile: CLSID;
}
unsafe extern "C" {
    pub static CLSID_Picture_Dib: CLSID;
}
unsafe extern "C" {
    pub static GUID_TRISTATE: GUID;
}
unsafe extern "C" {
    pub fn CoGetMalloc(dwMemContext: DWORD, ppMalloc: *mut LPMALLOC) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateStreamOnHGlobal(
        hGlobal: HGLOBAL,
        fDeleteOnRelease: BOOL,
        ppstm: *mut LPSTREAM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetHGlobalFromStream(pstm: LPSTREAM, phglobal: *mut HGLOBAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoUninitialize();
}
unsafe extern "C" {
    pub fn CoGetCurrentProcess() -> DWORD;
}
unsafe extern "C" {
    pub fn CoInitializeEx(pvReserved: LPVOID, dwCoInit: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetCallerTID(lpdwTID: LPDWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetCurrentLogicalThreadId(pguid: *mut GUID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetContextToken(pToken: *mut ULONG_PTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetDefaultContext(
        aptType: APTTYPE,
        riid: *const IID,
        ppv: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetApartmentType(
        pAptType: *mut APTTYPE,
        pAptQualifier: *mut APTTYPEQUALIFIER,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagServerInformation {
    pub dwServerPid: DWORD,
    pub dwServerTid: DWORD,
    pub ui64ServerAddress: UINT64,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagServerInformation"][::std::mem::size_of::<tagServerInformation>() - 16usize];
    ["Alignment of tagServerInformation"][::std::mem::align_of::<tagServerInformation>() - 8usize];
    ["Offset of field: tagServerInformation::dwServerPid"]
        [::std::mem::offset_of!(tagServerInformation, dwServerPid) - 0usize];
    ["Offset of field: tagServerInformation::dwServerTid"]
        [::std::mem::offset_of!(tagServerInformation, dwServerTid) - 4usize];
    ["Offset of field: tagServerInformation::ui64ServerAddress"]
        [::std::mem::offset_of!(tagServerInformation, ui64ServerAddress) - 8usize];
};
pub type ServerInformation = tagServerInformation;
pub type PServerInformation = *mut tagServerInformation;
unsafe extern "C" {
    pub fn CoDecodeProxy(
        dwClientPid: DWORD,
        ui64ProxyAddress: UINT64,
        pServerInformation: PServerInformation,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CO_MTA_USAGE_COOKIE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CO_MTA_USAGE_COOKIE__"][::std::mem::size_of::<CO_MTA_USAGE_COOKIE__>() - 4usize];
    ["Alignment of CO_MTA_USAGE_COOKIE__"]
        [::std::mem::align_of::<CO_MTA_USAGE_COOKIE__>() - 4usize];
    ["Offset of field: CO_MTA_USAGE_COOKIE__::unused"]
        [::std::mem::offset_of!(CO_MTA_USAGE_COOKIE__, unused) - 0usize];
};
pub type CO_MTA_USAGE_COOKIE = *mut CO_MTA_USAGE_COOKIE__;
unsafe extern "C" {
    pub fn CoIncrementMTAUsage(pCookie: *mut CO_MTA_USAGE_COOKIE) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoDecrementMTAUsage(Cookie: CO_MTA_USAGE_COOKIE) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoAllowUnmarshalerCLSID(clsid: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetObjectContext(riid: *const IID, ppv: *mut LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetClassObject(
        rclsid: *const IID,
        dwClsContext: DWORD,
        pvReserved: LPVOID,
        riid: *const IID,
        ppv: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterClassObject(
        rclsid: *const IID,
        pUnk: LPUNKNOWN,
        dwClsContext: DWORD,
        flags: DWORD,
        lpdwRegister: LPDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRevokeClassObject(dwRegister: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoResumeClassObjects() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoSuspendClassObjects() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoAddRefServerProcess() -> ULONG;
}
unsafe extern "C" {
    pub fn CoReleaseServerProcess() -> ULONG;
}
unsafe extern "C" {
    pub fn CoGetPSClsid(riid: *const IID, pClsid: *mut CLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterPSClsid(riid: *const IID, rclsid: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterSurrogate(pSurrogate: LPSURROGATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetMarshalSizeMax(
        pulSize: *mut ULONG,
        riid: *const IID,
        pUnk: LPUNKNOWN,
        dwDestContext: DWORD,
        pvDestContext: LPVOID,
        mshlflags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoMarshalInterface(
        pStm: LPSTREAM,
        riid: *const IID,
        pUnk: LPUNKNOWN,
        dwDestContext: DWORD,
        pvDestContext: LPVOID,
        mshlflags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoUnmarshalInterface(pStm: LPSTREAM, riid: *const IID, ppv: *mut LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoMarshalHresult(pstm: LPSTREAM, hresult: HRESULT) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoUnmarshalHresult(pstm: LPSTREAM, phresult: *mut HRESULT) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoReleaseMarshalData(pStm: LPSTREAM) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoDisconnectObject(pUnk: LPUNKNOWN, dwReserved: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoLockObjectExternal(pUnk: LPUNKNOWN, fLock: BOOL, fLastUnlockReleases: BOOL)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetStandardMarshal(
        riid: *const IID,
        pUnk: LPUNKNOWN,
        dwDestContext: DWORD,
        pvDestContext: LPVOID,
        mshlflags: DWORD,
        ppMarshal: *mut LPMARSHAL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetStdMarshalEx(
        pUnkOuter: LPUNKNOWN,
        smexflags: DWORD,
        ppUnkInner: *mut LPUNKNOWN,
    ) -> HRESULT;
}
pub const tagSTDMSHLFLAGS_SMEXF_SERVER: tagSTDMSHLFLAGS = 1;
pub const tagSTDMSHLFLAGS_SMEXF_HANDLER: tagSTDMSHLFLAGS = 2;
pub type tagSTDMSHLFLAGS = ::std::os::raw::c_int;
pub use self::tagSTDMSHLFLAGS as STDMSHLFLAGS;
unsafe extern "C" {
    pub fn CoIsHandlerConnected(pUnk: LPUNKNOWN) -> BOOL;
}
unsafe extern "C" {
    pub fn CoMarshalInterThreadInterfaceInStream(
        riid: *const IID,
        pUnk: LPUNKNOWN,
        ppStm: *mut LPSTREAM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetInterfaceAndReleaseStream(
        pStm: LPSTREAM,
        iid: *const IID,
        ppv: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCreateFreeThreadedMarshaler(
        punkOuter: LPUNKNOWN,
        ppunkMarshal: *mut LPUNKNOWN,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoFreeUnusedLibraries();
}
unsafe extern "C" {
    pub fn CoFreeUnusedLibrariesEx(dwUnloadDelay: DWORD, dwReserved: DWORD);
}
unsafe extern "C" {
    pub fn CoDisconnectContext(dwTimeout: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInitializeSecurity(
        pSecDesc: PSECURITY_DESCRIPTOR,
        cAuthSvc: LONG,
        asAuthSvc: *mut SOLE_AUTHENTICATION_SERVICE,
        pReserved1: *mut ::std::os::raw::c_void,
        dwAuthnLevel: DWORD,
        dwImpLevel: DWORD,
        pAuthList: *mut ::std::os::raw::c_void,
        dwCapabilities: DWORD,
        pReserved3: *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetCallContext(
        riid: *const IID,
        ppInterface: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoQueryProxyBlanket(
        pProxy: *mut IUnknown,
        pwAuthnSvc: *mut DWORD,
        pAuthzSvc: *mut DWORD,
        pServerPrincName: *mut LPOLESTR,
        pAuthnLevel: *mut DWORD,
        pImpLevel: *mut DWORD,
        pAuthInfo: *mut RPC_AUTH_IDENTITY_HANDLE,
        pCapabilites: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoSetProxyBlanket(
        pProxy: *mut IUnknown,
        dwAuthnSvc: DWORD,
        dwAuthzSvc: DWORD,
        pServerPrincName: *mut OLECHAR,
        dwAuthnLevel: DWORD,
        dwImpLevel: DWORD,
        pAuthInfo: RPC_AUTH_IDENTITY_HANDLE,
        dwCapabilities: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCopyProxy(pProxy: *mut IUnknown, ppCopy: *mut *mut IUnknown) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoQueryClientBlanket(
        pAuthnSvc: *mut DWORD,
        pAuthzSvc: *mut DWORD,
        pServerPrincName: *mut LPOLESTR,
        pAuthnLevel: *mut DWORD,
        pImpLevel: *mut DWORD,
        pPrivs: *mut RPC_AUTHZ_HANDLE,
        pCapabilities: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoImpersonateClient() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRevertToSelf() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoQueryAuthenticationServices(
        pcAuthSvc: *mut DWORD,
        asAuthSvc: *mut *mut SOLE_AUTHENTICATION_SERVICE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoSwitchCallContext(
        pNewObject: *mut IUnknown,
        ppOldObject: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCreateInstance(
        rclsid: *const IID,
        pUnkOuter: LPUNKNOWN,
        dwClsContext: DWORD,
        riid: *const IID,
        ppv: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCreateInstanceEx(
        Clsid: *const IID,
        punkOuter: *mut IUnknown,
        dwClsCtx: DWORD,
        pServerInfo: *mut COSERVERINFO,
        dwCount: DWORD,
        pResults: *mut MULTI_QI,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCreateInstanceFromApp(
        Clsid: *const IID,
        punkOuter: *mut IUnknown,
        dwClsCtx: DWORD,
        reserved: PVOID,
        dwCount: DWORD,
        pResults: *mut MULTI_QI,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterActivationFilter(pActivationFilter: *mut IActivationFilter) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetCancelObject(
        dwThreadId: DWORD,
        iid: *const IID,
        ppUnk: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoSetCancelObject(pUnk: *mut IUnknown) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCancelCall(dwThreadId: DWORD, ulTimeout: ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoTestCancel() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoEnableCallCancellation(pReserved: LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoDisableCallCancellation(pReserved: LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn StringFromCLSID(rclsid: *const IID, lplpsz: *mut LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn CLSIDFromString(lpsz: LPCOLESTR, pclsid: LPCLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn StringFromIID(rclsid: *const IID, lplpsz: *mut LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn IIDFromString(lpsz: LPCOLESTR, lpiid: LPIID) -> HRESULT;
}
unsafe extern "C" {
    pub fn ProgIDFromCLSID(clsid: *const IID, lplpszProgID: *mut LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn CLSIDFromProgID(lpszProgID: LPCOLESTR, lpclsid: LPCLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn StringFromGUID2(
        rguid: *const GUID,
        lpsz: LPOLESTR,
        cchMax: ::std::os::raw::c_int,
    ) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn CoCreateGuid(pguid: *mut GUID) -> HRESULT;
}
pub type PROPVARIANT = tagPROPVARIANT;
unsafe extern "C" {
    pub fn PropVariantCopy(pvarDest: *mut PROPVARIANT, pvarSrc: *const PROPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn PropVariantClear(pvar: *mut PROPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn FreePropVariantArray(cVariants: ULONG, rgvars: *mut PROPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoWaitForMultipleHandles(
        dwFlags: DWORD,
        dwTimeout: DWORD,
        cHandles: ULONG,
        pHandles: LPHANDLE,
        lpdwindex: LPDWORD,
    ) -> HRESULT;
}
pub const tagCOWAIT_FLAGS_COWAIT_DEFAULT: tagCOWAIT_FLAGS = 0;
pub const tagCOWAIT_FLAGS_COWAIT_WAITALL: tagCOWAIT_FLAGS = 1;
pub const tagCOWAIT_FLAGS_COWAIT_ALERTABLE: tagCOWAIT_FLAGS = 2;
pub const tagCOWAIT_FLAGS_COWAIT_INPUTAVAILABLE: tagCOWAIT_FLAGS = 4;
pub const tagCOWAIT_FLAGS_COWAIT_DISPATCH_CALLS: tagCOWAIT_FLAGS = 8;
pub const tagCOWAIT_FLAGS_COWAIT_DISPATCH_WINDOW_MESSAGES: tagCOWAIT_FLAGS = 16;
pub type tagCOWAIT_FLAGS = ::std::os::raw::c_int;
pub use self::tagCOWAIT_FLAGS as COWAIT_FLAGS;
pub const CWMO_FLAGS_CWMO_DEFAULT: CWMO_FLAGS = 0;
pub const CWMO_FLAGS_CWMO_DISPATCH_CALLS: CWMO_FLAGS = 1;
pub const CWMO_FLAGS_CWMO_DISPATCH_WINDOW_MESSAGES: CWMO_FLAGS = 2;
pub type CWMO_FLAGS = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn CoWaitForMultipleObjects(
        dwFlags: DWORD,
        dwTimeout: DWORD,
        cHandles: ULONG,
        pHandles: *const HANDLE,
        lpdwindex: LPDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetTreatAsClass(clsidOld: *const IID, pClsidNew: LPCLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInvalidateRemoteMachineBindings(pszMachineName: LPOLESTR) -> HRESULT;
}
pub const AgileReferenceOptions_AGILEREFERENCE_DEFAULT: AgileReferenceOptions = 0;
pub const AgileReferenceOptions_AGILEREFERENCE_DELAYEDMARSHAL: AgileReferenceOptions = 1;
pub type AgileReferenceOptions = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn RoGetAgileReference(
        options: AgileReferenceOptions,
        riid: *const IID,
        pUnk: *mut IUnknown,
        ppAgileReference: *mut *mut IAgileReference,
    ) -> HRESULT;
}
pub type LPFNGETCLASSOBJECT = ::std::option::Option<
    unsafe extern "C" fn(arg1: *const IID, arg2: *const IID, arg3: *mut LPVOID) -> HRESULT,
>;
pub type LPFNCANUNLOADNOW = ::std::option::Option<unsafe extern "C" fn() -> HRESULT>;
unsafe extern "C" {
    pub fn DllGetClassObject(rclsid: *const IID, riid: *const IID, ppv: *mut LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn DllCanUnloadNow() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoTaskMemAlloc(cb: SIZE_T) -> LPVOID;
}
unsafe extern "C" {
    pub fn CoTaskMemRealloc(pv: LPVOID, cb: SIZE_T) -> LPVOID;
}
unsafe extern "C" {
    pub fn CoTaskMemFree(pv: LPVOID);
}
unsafe extern "C" {
    pub fn CoFileTimeNow(lpFileTime: *mut FILETIME) -> HRESULT;
}
unsafe extern "C" {
    pub fn CLSIDFromProgIDEx(lpszProgID: LPCOLESTR, lpclsid: LPCLSID) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CO_DEVICE_CATALOG_COOKIE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CO_DEVICE_CATALOG_COOKIE__"]
        [::std::mem::size_of::<CO_DEVICE_CATALOG_COOKIE__>() - 4usize];
    ["Alignment of CO_DEVICE_CATALOG_COOKIE__"]
        [::std::mem::align_of::<CO_DEVICE_CATALOG_COOKIE__>() - 4usize];
    ["Offset of field: CO_DEVICE_CATALOG_COOKIE__::unused"]
        [::std::mem::offset_of!(CO_DEVICE_CATALOG_COOKIE__, unused) - 0usize];
};
pub type CO_DEVICE_CATALOG_COOKIE = *mut CO_DEVICE_CATALOG_COOKIE__;
unsafe extern "C" {
    pub fn CoRegisterDeviceCatalog(
        deviceInstanceId: PCWSTR,
        cookie: *mut CO_DEVICE_CATALOG_COOKIE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRevokeDeviceCatalog(cookie: CO_DEVICE_CATALOG_COOKIE) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0002_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0002_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0003_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_unknwn_0000_0003_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0055_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0055_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPMALLOCSPY = *mut IMallocSpy;
unsafe extern "C" {
    pub static IID_IMallocSpy: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMallocSpyVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMallocSpy) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMallocSpy) -> ULONG>,
    pub PreAlloc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMallocSpy, cbRequest: SIZE_T) -> SIZE_T,
    >,
    pub PostAlloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pActual: *mut ::std::os::raw::c_void,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub PreFree: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pRequest: *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub PostFree: ::std::option::Option<unsafe extern "C" fn(This: *mut IMallocSpy, fSpyed: BOOL)>,
    pub PreRealloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pRequest: *mut ::std::os::raw::c_void,
            cbRequest: SIZE_T,
            ppNewRequest: *mut *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
        ) -> SIZE_T,
    >,
    pub PostRealloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pActual: *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub PreGetSize: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pRequest: *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub PostGetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMallocSpy, cbActual: SIZE_T, fSpyed: BOOL) -> SIZE_T,
    >,
    pub PreDidAlloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pRequest: *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
        ) -> *mut ::std::os::raw::c_void,
    >,
    pub PostDidAlloc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMallocSpy,
            pRequest: *mut ::std::os::raw::c_void,
            fSpyed: BOOL,
            fActual: ::std::os::raw::c_int,
        ) -> ::std::os::raw::c_int,
    >,
    pub PreHeapMinimize: ::std::option::Option<unsafe extern "C" fn(This: *mut IMallocSpy)>,
    pub PostHeapMinimize: ::std::option::Option<unsafe extern "C" fn(This: *mut IMallocSpy)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMallocSpyVtbl"][::std::mem::size_of::<IMallocSpyVtbl>() - 120usize];
    ["Alignment of IMallocSpyVtbl"][::std::mem::align_of::<IMallocSpyVtbl>() - 8usize];
    ["Offset of field: IMallocSpyVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMallocSpyVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMallocSpyVtbl::AddRef"]
        [::std::mem::offset_of!(IMallocSpyVtbl, AddRef) - 8usize];
    ["Offset of field: IMallocSpyVtbl::Release"]
        [::std::mem::offset_of!(IMallocSpyVtbl, Release) - 16usize];
    ["Offset of field: IMallocSpyVtbl::PreAlloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreAlloc) - 24usize];
    ["Offset of field: IMallocSpyVtbl::PostAlloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostAlloc) - 32usize];
    ["Offset of field: IMallocSpyVtbl::PreFree"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreFree) - 40usize];
    ["Offset of field: IMallocSpyVtbl::PostFree"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostFree) - 48usize];
    ["Offset of field: IMallocSpyVtbl::PreRealloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreRealloc) - 56usize];
    ["Offset of field: IMallocSpyVtbl::PostRealloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostRealloc) - 64usize];
    ["Offset of field: IMallocSpyVtbl::PreGetSize"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreGetSize) - 72usize];
    ["Offset of field: IMallocSpyVtbl::PostGetSize"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostGetSize) - 80usize];
    ["Offset of field: IMallocSpyVtbl::PreDidAlloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreDidAlloc) - 88usize];
    ["Offset of field: IMallocSpyVtbl::PostDidAlloc"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostDidAlloc) - 96usize];
    ["Offset of field: IMallocSpyVtbl::PreHeapMinimize"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PreHeapMinimize) - 104usize];
    ["Offset of field: IMallocSpyVtbl::PostHeapMinimize"]
        [::std::mem::offset_of!(IMallocSpyVtbl, PostHeapMinimize) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMallocSpy {
    pub lpVtbl: *mut IMallocSpyVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMallocSpy"][::std::mem::size_of::<IMallocSpy>() - 8usize];
    ["Alignment of IMallocSpy"][::std::mem::align_of::<IMallocSpy>() - 8usize];
    ["Offset of field: IMallocSpy::lpVtbl"][::std::mem::offset_of!(IMallocSpy, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0056_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0056_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBC = *mut IBindCtx;
pub type LPBINDCTX = *mut IBindCtx;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBIND_OPTS {
    pub cbStruct: DWORD,
    pub grfFlags: DWORD,
    pub grfMode: DWORD,
    pub dwTickCountDeadline: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBIND_OPTS"][::std::mem::size_of::<tagBIND_OPTS>() - 16usize];
    ["Alignment of tagBIND_OPTS"][::std::mem::align_of::<tagBIND_OPTS>() - 4usize];
    ["Offset of field: tagBIND_OPTS::cbStruct"]
        [::std::mem::offset_of!(tagBIND_OPTS, cbStruct) - 0usize];
    ["Offset of field: tagBIND_OPTS::grfFlags"]
        [::std::mem::offset_of!(tagBIND_OPTS, grfFlags) - 4usize];
    ["Offset of field: tagBIND_OPTS::grfMode"]
        [::std::mem::offset_of!(tagBIND_OPTS, grfMode) - 8usize];
    ["Offset of field: tagBIND_OPTS::dwTickCountDeadline"]
        [::std::mem::offset_of!(tagBIND_OPTS, dwTickCountDeadline) - 12usize];
};
pub type BIND_OPTS = tagBIND_OPTS;
pub type LPBIND_OPTS = *mut tagBIND_OPTS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBIND_OPTS2 {
    pub cbStruct: DWORD,
    pub grfFlags: DWORD,
    pub grfMode: DWORD,
    pub dwTickCountDeadline: DWORD,
    pub dwTrackFlags: DWORD,
    pub dwClassContext: DWORD,
    pub locale: LCID,
    pub pServerInfo: *mut COSERVERINFO,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBIND_OPTS2"][::std::mem::size_of::<tagBIND_OPTS2>() - 40usize];
    ["Alignment of tagBIND_OPTS2"][::std::mem::align_of::<tagBIND_OPTS2>() - 8usize];
    ["Offset of field: tagBIND_OPTS2::cbStruct"]
        [::std::mem::offset_of!(tagBIND_OPTS2, cbStruct) - 0usize];
    ["Offset of field: tagBIND_OPTS2::grfFlags"]
        [::std::mem::offset_of!(tagBIND_OPTS2, grfFlags) - 4usize];
    ["Offset of field: tagBIND_OPTS2::grfMode"]
        [::std::mem::offset_of!(tagBIND_OPTS2, grfMode) - 8usize];
    ["Offset of field: tagBIND_OPTS2::dwTickCountDeadline"]
        [::std::mem::offset_of!(tagBIND_OPTS2, dwTickCountDeadline) - 12usize];
    ["Offset of field: tagBIND_OPTS2::dwTrackFlags"]
        [::std::mem::offset_of!(tagBIND_OPTS2, dwTrackFlags) - 16usize];
    ["Offset of field: tagBIND_OPTS2::dwClassContext"]
        [::std::mem::offset_of!(tagBIND_OPTS2, dwClassContext) - 20usize];
    ["Offset of field: tagBIND_OPTS2::locale"]
        [::std::mem::offset_of!(tagBIND_OPTS2, locale) - 24usize];
    ["Offset of field: tagBIND_OPTS2::pServerInfo"]
        [::std::mem::offset_of!(tagBIND_OPTS2, pServerInfo) - 32usize];
};
pub type BIND_OPTS2 = tagBIND_OPTS2;
pub type LPBIND_OPTS2 = *mut tagBIND_OPTS2;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagBIND_OPTS3 {
    pub cbStruct: DWORD,
    pub grfFlags: DWORD,
    pub grfMode: DWORD,
    pub dwTickCountDeadline: DWORD,
    pub dwTrackFlags: DWORD,
    pub dwClassContext: DWORD,
    pub locale: LCID,
    pub pServerInfo: *mut COSERVERINFO,
    pub hwnd: HWND,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBIND_OPTS3"][::std::mem::size_of::<tagBIND_OPTS3>() - 48usize];
    ["Alignment of tagBIND_OPTS3"][::std::mem::align_of::<tagBIND_OPTS3>() - 8usize];
    ["Offset of field: tagBIND_OPTS3::cbStruct"]
        [::std::mem::offset_of!(tagBIND_OPTS3, cbStruct) - 0usize];
    ["Offset of field: tagBIND_OPTS3::grfFlags"]
        [::std::mem::offset_of!(tagBIND_OPTS3, grfFlags) - 4usize];
    ["Offset of field: tagBIND_OPTS3::grfMode"]
        [::std::mem::offset_of!(tagBIND_OPTS3, grfMode) - 8usize];
    ["Offset of field: tagBIND_OPTS3::dwTickCountDeadline"]
        [::std::mem::offset_of!(tagBIND_OPTS3, dwTickCountDeadline) - 12usize];
    ["Offset of field: tagBIND_OPTS3::dwTrackFlags"]
        [::std::mem::offset_of!(tagBIND_OPTS3, dwTrackFlags) - 16usize];
    ["Offset of field: tagBIND_OPTS3::dwClassContext"]
        [::std::mem::offset_of!(tagBIND_OPTS3, dwClassContext) - 20usize];
    ["Offset of field: tagBIND_OPTS3::locale"]
        [::std::mem::offset_of!(tagBIND_OPTS3, locale) - 24usize];
    ["Offset of field: tagBIND_OPTS3::pServerInfo"]
        [::std::mem::offset_of!(tagBIND_OPTS3, pServerInfo) - 32usize];
    ["Offset of field: tagBIND_OPTS3::hwnd"][::std::mem::offset_of!(tagBIND_OPTS3, hwnd) - 40usize];
};
pub type BIND_OPTS3 = tagBIND_OPTS3;
pub type LPBIND_OPTS3 = *mut tagBIND_OPTS3;
pub const tagBIND_FLAGS_BIND_MAYBOTHERUSER: tagBIND_FLAGS = 1;
pub const tagBIND_FLAGS_BIND_JUSTTESTEXISTENCE: tagBIND_FLAGS = 2;
pub type tagBIND_FLAGS = ::std::os::raw::c_int;
pub use self::tagBIND_FLAGS as BIND_FLAGS;
unsafe extern "C" {
    pub static IID_IBindCtx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindCtxVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindCtx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindCtx) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindCtx) -> ULONG>,
    pub RegisterObjectBound: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, punk: *mut IUnknown) -> HRESULT,
    >,
    pub RevokeObjectBound: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, punk: *mut IUnknown) -> HRESULT,
    >,
    pub ReleaseBoundObjects:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindCtx) -> HRESULT>,
    pub SetBindOptions: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS) -> HRESULT,
    >,
    pub GetBindOptions: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS) -> HRESULT,
    >,
    pub GetRunningObjectTable: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, pprot: *mut *mut IRunningObjectTable) -> HRESULT,
    >,
    pub RegisterObjectParam: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, pszKey: LPOLESTR, punk: *mut IUnknown) -> HRESULT,
    >,
    pub GetObjectParam: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindCtx,
            pszKey: LPOLESTR,
            ppunk: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
    pub EnumObjectParam: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, ppenum: *mut *mut IEnumString) -> HRESULT,
    >,
    pub RevokeObjectParam: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindCtx, pszKey: LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindCtxVtbl"][::std::mem::size_of::<IBindCtxVtbl>() - 104usize];
    ["Alignment of IBindCtxVtbl"][::std::mem::align_of::<IBindCtxVtbl>() - 8usize];
    ["Offset of field: IBindCtxVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindCtxVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindCtxVtbl::AddRef"]
        [::std::mem::offset_of!(IBindCtxVtbl, AddRef) - 8usize];
    ["Offset of field: IBindCtxVtbl::Release"]
        [::std::mem::offset_of!(IBindCtxVtbl, Release) - 16usize];
    ["Offset of field: IBindCtxVtbl::RegisterObjectBound"]
        [::std::mem::offset_of!(IBindCtxVtbl, RegisterObjectBound) - 24usize];
    ["Offset of field: IBindCtxVtbl::RevokeObjectBound"]
        [::std::mem::offset_of!(IBindCtxVtbl, RevokeObjectBound) - 32usize];
    ["Offset of field: IBindCtxVtbl::ReleaseBoundObjects"]
        [::std::mem::offset_of!(IBindCtxVtbl, ReleaseBoundObjects) - 40usize];
    ["Offset of field: IBindCtxVtbl::SetBindOptions"]
        [::std::mem::offset_of!(IBindCtxVtbl, SetBindOptions) - 48usize];
    ["Offset of field: IBindCtxVtbl::GetBindOptions"]
        [::std::mem::offset_of!(IBindCtxVtbl, GetBindOptions) - 56usize];
    ["Offset of field: IBindCtxVtbl::GetRunningObjectTable"]
        [::std::mem::offset_of!(IBindCtxVtbl, GetRunningObjectTable) - 64usize];
    ["Offset of field: IBindCtxVtbl::RegisterObjectParam"]
        [::std::mem::offset_of!(IBindCtxVtbl, RegisterObjectParam) - 72usize];
    ["Offset of field: IBindCtxVtbl::GetObjectParam"]
        [::std::mem::offset_of!(IBindCtxVtbl, GetObjectParam) - 80usize];
    ["Offset of field: IBindCtxVtbl::EnumObjectParam"]
        [::std::mem::offset_of!(IBindCtxVtbl, EnumObjectParam) - 88usize];
    ["Offset of field: IBindCtxVtbl::RevokeObjectParam"]
        [::std::mem::offset_of!(IBindCtxVtbl, RevokeObjectParam) - 96usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindCtx {
    pub lpVtbl: *mut IBindCtxVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindCtx"][::std::mem::size_of::<IBindCtx>() - 8usize];
    ["Alignment of IBindCtx"][::std::mem::align_of::<IBindCtx>() - 8usize];
    ["Offset of field: IBindCtx::lpVtbl"][::std::mem::offset_of!(IBindCtx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IBindCtx_RemoteSetBindOptions_Proxy(
        This: *mut IBindCtx,
        pbindopts: *mut BIND_OPTS2,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindCtx_RemoteSetBindOptions_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IBindCtx_RemoteGetBindOptions_Proxy(
        This: *mut IBindCtx,
        pbindopts: *mut BIND_OPTS2,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindCtx_RemoteGetBindOptions_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMMONIKER = *mut IEnumMoniker;
unsafe extern "C" {
    pub static IID_IEnumMoniker: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumMonikerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumMoniker,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumMoniker) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumMoniker) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumMoniker,
            celt: ULONG,
            rgelt: *mut *mut IMoniker,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumMoniker, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumMoniker) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumMoniker, ppenum: *mut *mut IEnumMoniker) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumMonikerVtbl"][::std::mem::size_of::<IEnumMonikerVtbl>() - 56usize];
    ["Alignment of IEnumMonikerVtbl"][::std::mem::align_of::<IEnumMonikerVtbl>() - 8usize];
    ["Offset of field: IEnumMonikerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumMonikerVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumMonikerVtbl::Release"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, Release) - 16usize];
    ["Offset of field: IEnumMonikerVtbl::Next"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, Next) - 24usize];
    ["Offset of field: IEnumMonikerVtbl::Skip"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, Skip) - 32usize];
    ["Offset of field: IEnumMonikerVtbl::Reset"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, Reset) - 40usize];
    ["Offset of field: IEnumMonikerVtbl::Clone"]
        [::std::mem::offset_of!(IEnumMonikerVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumMoniker {
    pub lpVtbl: *mut IEnumMonikerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumMoniker"][::std::mem::size_of::<IEnumMoniker>() - 8usize];
    ["Alignment of IEnumMoniker"][::std::mem::align_of::<IEnumMoniker>() - 8usize];
    ["Offset of field: IEnumMoniker::lpVtbl"]
        [::std::mem::offset_of!(IEnumMoniker, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumMoniker_RemoteNext_Proxy(
        This: *mut IEnumMoniker,
        celt: ULONG,
        rgelt: *mut *mut IMoniker,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumMoniker_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0058_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0058_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPRUNNABLEOBJECT = *mut IRunnableObject;
unsafe extern "C" {
    pub static IID_IRunnableObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRunnableObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunnableObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRunnableObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRunnableObject) -> ULONG>,
    pub GetRunningClass: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRunnableObject, lpClsid: LPCLSID) -> HRESULT,
    >,
    pub Run: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRunnableObject, pbc: LPBINDCTX) -> HRESULT,
    >,
    pub IsRunning: ::std::option::Option<unsafe extern "C" fn(This: *mut IRunnableObject) -> BOOL>,
    pub LockRunning: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunnableObject,
            fLock: BOOL,
            fLastUnlockCloses: BOOL,
        ) -> HRESULT,
    >,
    pub SetContainedObject: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRunnableObject, fContained: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRunnableObjectVtbl"][::std::mem::size_of::<IRunnableObjectVtbl>() - 64usize];
    ["Alignment of IRunnableObjectVtbl"][::std::mem::align_of::<IRunnableObjectVtbl>() - 8usize];
    ["Offset of field: IRunnableObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRunnableObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IRunnableObjectVtbl::Release"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, Release) - 16usize];
    ["Offset of field: IRunnableObjectVtbl::GetRunningClass"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, GetRunningClass) - 24usize];
    ["Offset of field: IRunnableObjectVtbl::Run"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, Run) - 32usize];
    ["Offset of field: IRunnableObjectVtbl::IsRunning"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, IsRunning) - 40usize];
    ["Offset of field: IRunnableObjectVtbl::LockRunning"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, LockRunning) - 48usize];
    ["Offset of field: IRunnableObjectVtbl::SetContainedObject"]
        [::std::mem::offset_of!(IRunnableObjectVtbl, SetContainedObject) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRunnableObject {
    pub lpVtbl: *mut IRunnableObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRunnableObject"][::std::mem::size_of::<IRunnableObject>() - 8usize];
    ["Alignment of IRunnableObject"][::std::mem::align_of::<IRunnableObject>() - 8usize];
    ["Offset of field: IRunnableObject::lpVtbl"]
        [::std::mem::offset_of!(IRunnableObject, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IRunnableObject_RemoteIsRunning_Proxy(This: *mut IRunnableObject) -> HRESULT;
}
unsafe extern "C" {
    pub fn IRunnableObject_RemoteIsRunning_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPRUNNINGOBJECTTABLE = *mut IRunningObjectTable;
unsafe extern "C" {
    pub static IID_IRunningObjectTable: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRunningObjectTableVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRunningObjectTable) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IRunningObjectTable) -> ULONG>,
    pub Register: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            grfFlags: DWORD,
            punkObject: *mut IUnknown,
            pmkObjectName: *mut IMoniker,
            pdwRegister: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Revoke: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRunningObjectTable, dwRegister: DWORD) -> HRESULT,
    >,
    pub IsRunning: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            pmkObjectName: *mut IMoniker,
        ) -> HRESULT,
    >,
    pub GetObjectA: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            pmkObjectName: *mut IMoniker,
            ppunkObject: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
    pub NoteChangeTime: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            dwRegister: DWORD,
            pfiletime: *mut FILETIME,
        ) -> HRESULT,
    >,
    pub GetTimeOfLastChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            pmkObjectName: *mut IMoniker,
            pfiletime: *mut FILETIME,
        ) -> HRESULT,
    >,
    pub EnumRunning: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRunningObjectTable,
            ppenumMoniker: *mut *mut IEnumMoniker,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRunningObjectTableVtbl"][::std::mem::size_of::<IRunningObjectTableVtbl>() - 80usize];
    ["Alignment of IRunningObjectTableVtbl"]
        [::std::mem::align_of::<IRunningObjectTableVtbl>() - 8usize];
    ["Offset of field: IRunningObjectTableVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRunningObjectTableVtbl::AddRef"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, AddRef) - 8usize];
    ["Offset of field: IRunningObjectTableVtbl::Release"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, Release) - 16usize];
    ["Offset of field: IRunningObjectTableVtbl::Register"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, Register) - 24usize];
    ["Offset of field: IRunningObjectTableVtbl::Revoke"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, Revoke) - 32usize];
    ["Offset of field: IRunningObjectTableVtbl::IsRunning"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, IsRunning) - 40usize];
    ["Offset of field: IRunningObjectTableVtbl::GetObjectA"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, GetObjectA) - 48usize];
    ["Offset of field: IRunningObjectTableVtbl::NoteChangeTime"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, NoteChangeTime) - 56usize];
    ["Offset of field: IRunningObjectTableVtbl::GetTimeOfLastChange"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, GetTimeOfLastChange) - 64usize];
    ["Offset of field: IRunningObjectTableVtbl::EnumRunning"]
        [::std::mem::offset_of!(IRunningObjectTableVtbl, EnumRunning) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRunningObjectTable {
    pub lpVtbl: *mut IRunningObjectTableVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRunningObjectTable"][::std::mem::size_of::<IRunningObjectTable>() - 8usize];
    ["Alignment of IRunningObjectTable"][::std::mem::align_of::<IRunningObjectTable>() - 8usize];
    ["Offset of field: IRunningObjectTable::lpVtbl"]
        [::std::mem::offset_of!(IRunningObjectTable, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0060_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0060_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPPERSIST = *mut IPersist;
unsafe extern "C" {
    pub static IID_IPersist: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersist,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersist) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersist) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersist, pClassID: *mut CLSID) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistVtbl"][::std::mem::size_of::<IPersistVtbl>() - 32usize];
    ["Alignment of IPersistVtbl"][::std::mem::align_of::<IPersistVtbl>() - 8usize];
    ["Offset of field: IPersistVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPersistVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPersistVtbl::AddRef"]
        [::std::mem::offset_of!(IPersistVtbl, AddRef) - 8usize];
    ["Offset of field: IPersistVtbl::Release"]
        [::std::mem::offset_of!(IPersistVtbl, Release) - 16usize];
    ["Offset of field: IPersistVtbl::GetClassID"]
        [::std::mem::offset_of!(IPersistVtbl, GetClassID) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersist {
    pub lpVtbl: *mut IPersistVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersist"][::std::mem::size_of::<IPersist>() - 8usize];
    ["Alignment of IPersist"][::std::mem::align_of::<IPersist>() - 8usize];
    ["Offset of field: IPersist::lpVtbl"][::std::mem::offset_of!(IPersist, lpVtbl) - 0usize];
};
pub type LPPERSISTSTREAM = *mut IPersistStream;
unsafe extern "C" {
    pub static IID_IPersistStream: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistStreamVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistStream,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStream) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStream) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStream, pClassID: *mut CLSID) -> HRESULT,
    >,
    pub IsDirty: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStream) -> HRESULT>,
    pub Load: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStream, pStm: *mut IStream) -> HRESULT,
    >,
    pub Save: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistStream,
            pStm: *mut IStream,
            fClearDirty: BOOL,
        ) -> HRESULT,
    >,
    pub GetSizeMax: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStream, pcbSize: *mut ULARGE_INTEGER) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistStreamVtbl"][::std::mem::size_of::<IPersistStreamVtbl>() - 64usize];
    ["Alignment of IPersistStreamVtbl"][::std::mem::align_of::<IPersistStreamVtbl>() - 8usize];
    ["Offset of field: IPersistStreamVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPersistStreamVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPersistStreamVtbl::AddRef"]
        [::std::mem::offset_of!(IPersistStreamVtbl, AddRef) - 8usize];
    ["Offset of field: IPersistStreamVtbl::Release"]
        [::std::mem::offset_of!(IPersistStreamVtbl, Release) - 16usize];
    ["Offset of field: IPersistStreamVtbl::GetClassID"]
        [::std::mem::offset_of!(IPersistStreamVtbl, GetClassID) - 24usize];
    ["Offset of field: IPersistStreamVtbl::IsDirty"]
        [::std::mem::offset_of!(IPersistStreamVtbl, IsDirty) - 32usize];
    ["Offset of field: IPersistStreamVtbl::Load"]
        [::std::mem::offset_of!(IPersistStreamVtbl, Load) - 40usize];
    ["Offset of field: IPersistStreamVtbl::Save"]
        [::std::mem::offset_of!(IPersistStreamVtbl, Save) - 48usize];
    ["Offset of field: IPersistStreamVtbl::GetSizeMax"]
        [::std::mem::offset_of!(IPersistStreamVtbl, GetSizeMax) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistStream {
    pub lpVtbl: *mut IPersistStreamVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistStream"][::std::mem::size_of::<IPersistStream>() - 8usize];
    ["Alignment of IPersistStream"][::std::mem::align_of::<IPersistStream>() - 8usize];
    ["Offset of field: IPersistStream::lpVtbl"]
        [::std::mem::offset_of!(IPersistStream, lpVtbl) - 0usize];
};
pub type LPMONIKER = *mut IMoniker;
pub const tagMKSYS_MKSYS_NONE: tagMKSYS = 0;
pub const tagMKSYS_MKSYS_GENERICCOMPOSITE: tagMKSYS = 1;
pub const tagMKSYS_MKSYS_FILEMONIKER: tagMKSYS = 2;
pub const tagMKSYS_MKSYS_ANTIMONIKER: tagMKSYS = 3;
pub const tagMKSYS_MKSYS_ITEMMONIKER: tagMKSYS = 4;
pub const tagMKSYS_MKSYS_POINTERMONIKER: tagMKSYS = 5;
pub const tagMKSYS_MKSYS_CLASSMONIKER: tagMKSYS = 7;
pub const tagMKSYS_MKSYS_OBJREFMONIKER: tagMKSYS = 8;
pub const tagMKSYS_MKSYS_SESSIONMONIKER: tagMKSYS = 9;
pub const tagMKSYS_MKSYS_LUAMONIKER: tagMKSYS = 10;
pub type tagMKSYS = ::std::os::raw::c_int;
pub use self::tagMKSYS as MKSYS;
pub const tagMKREDUCE_MKRREDUCE_ONE: tagMKREDUCE = 196608;
pub const tagMKREDUCE_MKRREDUCE_TOUSER: tagMKREDUCE = 131072;
pub const tagMKREDUCE_MKRREDUCE_THROUGHUSER: tagMKREDUCE = 65536;
pub const tagMKREDUCE_MKRREDUCE_ALL: tagMKREDUCE = 0;
pub type tagMKREDUCE = ::std::os::raw::c_int;
pub use self::tagMKREDUCE as MKRREDUCE;
unsafe extern "C" {
    pub static IID_IMoniker: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMonikerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMoniker) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMoniker) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pClassID: *mut CLSID) -> HRESULT,
    >,
    pub IsDirty: ::std::option::Option<unsafe extern "C" fn(This: *mut IMoniker) -> HRESULT>,
    pub Load: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pStm: *mut IStream) -> HRESULT,
    >,
    pub Save: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pStm: *mut IStream, fClearDirty: BOOL) -> HRESULT,
    >,
    pub GetSizeMax: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pcbSize: *mut ULARGE_INTEGER) -> HRESULT,
    >,
    pub BindToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            riidResult: *const IID,
            ppvResult: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub BindToStorage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            riid: *const IID,
            ppvObj: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub Reduce: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            dwReduceHowFar: DWORD,
            ppmkToLeft: *mut *mut IMoniker,
            ppmkReduced: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub ComposeWith: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pmkRight: *mut IMoniker,
            fOnlyIfNotGeneric: BOOL,
            ppmkComposite: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub Enum: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            fForward: BOOL,
            ppenumMoniker: *mut *mut IEnumMoniker,
        ) -> HRESULT,
    >,
    pub IsEqual: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pmkOtherMoniker: *mut IMoniker) -> HRESULT,
    >,
    pub Hash: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pdwHash: *mut DWORD) -> HRESULT,
    >,
    pub IsRunning: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            pmkNewlyRunning: *mut IMoniker,
        ) -> HRESULT,
    >,
    pub GetTimeOfLastChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            pFileTime: *mut FILETIME,
        ) -> HRESULT,
    >,
    pub Inverse: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, ppmk: *mut *mut IMoniker) -> HRESULT,
    >,
    pub CommonPrefixWith: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pmkOther: *mut IMoniker,
            ppmkPrefix: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub RelativePathTo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pmkOther: *mut IMoniker,
            ppmkRelPath: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub GetDisplayName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            ppszDisplayName: *mut LPOLESTR,
        ) -> HRESULT,
    >,
    pub ParseDisplayName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMoniker,
            pbc: *mut IBindCtx,
            pmkToLeft: *mut IMoniker,
            pszDisplayName: LPOLESTR,
            pchEaten: *mut ULONG,
            ppmkOut: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub IsSystemMoniker: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IMoniker, pdwMksys: *mut DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMonikerVtbl"][::std::mem::size_of::<IMonikerVtbl>() - 184usize];
    ["Alignment of IMonikerVtbl"][::std::mem::align_of::<IMonikerVtbl>() - 8usize];
    ["Offset of field: IMonikerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMonikerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMonikerVtbl::AddRef"]
        [::std::mem::offset_of!(IMonikerVtbl, AddRef) - 8usize];
    ["Offset of field: IMonikerVtbl::Release"]
        [::std::mem::offset_of!(IMonikerVtbl, Release) - 16usize];
    ["Offset of field: IMonikerVtbl::GetClassID"]
        [::std::mem::offset_of!(IMonikerVtbl, GetClassID) - 24usize];
    ["Offset of field: IMonikerVtbl::IsDirty"]
        [::std::mem::offset_of!(IMonikerVtbl, IsDirty) - 32usize];
    ["Offset of field: IMonikerVtbl::Load"][::std::mem::offset_of!(IMonikerVtbl, Load) - 40usize];
    ["Offset of field: IMonikerVtbl::Save"][::std::mem::offset_of!(IMonikerVtbl, Save) - 48usize];
    ["Offset of field: IMonikerVtbl::GetSizeMax"]
        [::std::mem::offset_of!(IMonikerVtbl, GetSizeMax) - 56usize];
    ["Offset of field: IMonikerVtbl::BindToObject"]
        [::std::mem::offset_of!(IMonikerVtbl, BindToObject) - 64usize];
    ["Offset of field: IMonikerVtbl::BindToStorage"]
        [::std::mem::offset_of!(IMonikerVtbl, BindToStorage) - 72usize];
    ["Offset of field: IMonikerVtbl::Reduce"]
        [::std::mem::offset_of!(IMonikerVtbl, Reduce) - 80usize];
    ["Offset of field: IMonikerVtbl::ComposeWith"]
        [::std::mem::offset_of!(IMonikerVtbl, ComposeWith) - 88usize];
    ["Offset of field: IMonikerVtbl::Enum"][::std::mem::offset_of!(IMonikerVtbl, Enum) - 96usize];
    ["Offset of field: IMonikerVtbl::IsEqual"]
        [::std::mem::offset_of!(IMonikerVtbl, IsEqual) - 104usize];
    ["Offset of field: IMonikerVtbl::Hash"][::std::mem::offset_of!(IMonikerVtbl, Hash) - 112usize];
    ["Offset of field: IMonikerVtbl::IsRunning"]
        [::std::mem::offset_of!(IMonikerVtbl, IsRunning) - 120usize];
    ["Offset of field: IMonikerVtbl::GetTimeOfLastChange"]
        [::std::mem::offset_of!(IMonikerVtbl, GetTimeOfLastChange) - 128usize];
    ["Offset of field: IMonikerVtbl::Inverse"]
        [::std::mem::offset_of!(IMonikerVtbl, Inverse) - 136usize];
    ["Offset of field: IMonikerVtbl::CommonPrefixWith"]
        [::std::mem::offset_of!(IMonikerVtbl, CommonPrefixWith) - 144usize];
    ["Offset of field: IMonikerVtbl::RelativePathTo"]
        [::std::mem::offset_of!(IMonikerVtbl, RelativePathTo) - 152usize];
    ["Offset of field: IMonikerVtbl::GetDisplayName"]
        [::std::mem::offset_of!(IMonikerVtbl, GetDisplayName) - 160usize];
    ["Offset of field: IMonikerVtbl::ParseDisplayName"]
        [::std::mem::offset_of!(IMonikerVtbl, ParseDisplayName) - 168usize];
    ["Offset of field: IMonikerVtbl::IsSystemMoniker"]
        [::std::mem::offset_of!(IMonikerVtbl, IsSystemMoniker) - 176usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMoniker {
    pub lpVtbl: *mut IMonikerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMoniker"][::std::mem::size_of::<IMoniker>() - 8usize];
    ["Alignment of IMoniker"][::std::mem::align_of::<IMoniker>() - 8usize];
    ["Offset of field: IMoniker::lpVtbl"][::std::mem::offset_of!(IMoniker, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IMoniker_RemoteBindToObject_Proxy(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riidResult: *const IID,
        ppvResult: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_RemoteBindToObject_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IMoniker_RemoteBindToStorage_Proxy(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_RemoteBindToStorage_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0063_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0063_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IROTData: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IROTDataVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IROTData,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IROTData) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IROTData) -> ULONG>,
    pub GetComparisonData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IROTData,
            pbData: *mut byte,
            cbMax: ULONG,
            pcbData: *mut ULONG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IROTDataVtbl"][::std::mem::size_of::<IROTDataVtbl>() - 32usize];
    ["Alignment of IROTDataVtbl"][::std::mem::align_of::<IROTDataVtbl>() - 8usize];
    ["Offset of field: IROTDataVtbl::QueryInterface"]
        [::std::mem::offset_of!(IROTDataVtbl, QueryInterface) - 0usize];
    ["Offset of field: IROTDataVtbl::AddRef"]
        [::std::mem::offset_of!(IROTDataVtbl, AddRef) - 8usize];
    ["Offset of field: IROTDataVtbl::Release"]
        [::std::mem::offset_of!(IROTDataVtbl, Release) - 16usize];
    ["Offset of field: IROTDataVtbl::GetComparisonData"]
        [::std::mem::offset_of!(IROTDataVtbl, GetComparisonData) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IROTData {
    pub lpVtbl: *mut IROTDataVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IROTData"][::std::mem::size_of::<IROTData>() - 8usize];
    ["Alignment of IROTData"][::std::mem::align_of::<IROTData>() - 8usize];
    ["Offset of field: IROTData::lpVtbl"][::std::mem::offset_of!(IROTData, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0064_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0064_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPENUMSTATSTG = *mut IEnumSTATSTG;
unsafe extern "C" {
    pub static IID_IEnumSTATSTG: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATSTGVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATSTG,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATSTG) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATSTG) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATSTG,
            celt: ULONG,
            rgelt: *mut STATSTG,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATSTG, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATSTG) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATSTG, ppenum: *mut *mut IEnumSTATSTG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATSTGVtbl"][::std::mem::size_of::<IEnumSTATSTGVtbl>() - 56usize];
    ["Alignment of IEnumSTATSTGVtbl"][::std::mem::align_of::<IEnumSTATSTGVtbl>() - 8usize];
    ["Offset of field: IEnumSTATSTGVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumSTATSTGVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumSTATSTGVtbl::Release"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, Release) - 16usize];
    ["Offset of field: IEnumSTATSTGVtbl::Next"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, Next) - 24usize];
    ["Offset of field: IEnumSTATSTGVtbl::Skip"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, Skip) - 32usize];
    ["Offset of field: IEnumSTATSTGVtbl::Reset"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, Reset) - 40usize];
    ["Offset of field: IEnumSTATSTGVtbl::Clone"]
        [::std::mem::offset_of!(IEnumSTATSTGVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATSTG {
    pub lpVtbl: *mut IEnumSTATSTGVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATSTG"][::std::mem::size_of::<IEnumSTATSTG>() - 8usize];
    ["Alignment of IEnumSTATSTG"][::std::mem::align_of::<IEnumSTATSTG>() - 8usize];
    ["Offset of field: IEnumSTATSTG::lpVtbl"]
        [::std::mem::offset_of!(IEnumSTATSTG, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumSTATSTG_RemoteNext_Proxy(
        This: *mut IEnumSTATSTG,
        celt: ULONG,
        rgelt: *mut STATSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATSTG_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPSTORAGE = *mut IStorage;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemSNB {
    pub ulCntStr: ULONG,
    pub ulCntChar: ULONG,
    pub rgString: [OLECHAR; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemSNB"][::std::mem::size_of::<tagRemSNB>() - 12usize];
    ["Alignment of tagRemSNB"][::std::mem::align_of::<tagRemSNB>() - 4usize];
    ["Offset of field: tagRemSNB::ulCntStr"][::std::mem::offset_of!(tagRemSNB, ulCntStr) - 0usize];
    ["Offset of field: tagRemSNB::ulCntChar"]
        [::std::mem::offset_of!(tagRemSNB, ulCntChar) - 4usize];
    ["Offset of field: tagRemSNB::rgString"][::std::mem::offset_of!(tagRemSNB, rgString) - 8usize];
};
pub type RemSNB = tagRemSNB;
pub type wireSNB = *mut RemSNB;
pub type SNB = *mut LPOLESTR;
unsafe extern "C" {
    pub static IID_IStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IStorage) -> ULONG>,
    pub CreateStream: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            grfMode: DWORD,
            reserved1: DWORD,
            reserved2: DWORD,
            ppstm: *mut *mut IStream,
        ) -> HRESULT,
    >,
    pub OpenStream: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            reserved1: *mut ::std::os::raw::c_void,
            grfMode: DWORD,
            reserved2: DWORD,
            ppstm: *mut *mut IStream,
        ) -> HRESULT,
    >,
    pub CreateStorage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            grfMode: DWORD,
            reserved1: DWORD,
            reserved2: DWORD,
            ppstg: *mut *mut IStorage,
        ) -> HRESULT,
    >,
    pub OpenStorage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            pstgPriority: *mut IStorage,
            grfMode: DWORD,
            snbExclude: SNB,
            reserved: DWORD,
            ppstg: *mut *mut IStorage,
        ) -> HRESULT,
    >,
    pub CopyTo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            ciidExclude: DWORD,
            rgiidExclude: *const IID,
            snbExclude: SNB,
            pstgDest: *mut IStorage,
        ) -> HRESULT,
    >,
    pub MoveElementTo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            pstgDest: *mut IStorage,
            pwcsNewName: *const OLECHAR,
            grfFlags: DWORD,
        ) -> HRESULT,
    >,
    pub Commit: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStorage, grfCommitFlags: DWORD) -> HRESULT,
    >,
    pub Revert: ::std::option::Option<unsafe extern "C" fn(This: *mut IStorage) -> HRESULT>,
    pub EnumElements: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            reserved1: DWORD,
            reserved2: *mut ::std::os::raw::c_void,
            reserved3: DWORD,
            ppenum: *mut *mut IEnumSTATSTG,
        ) -> HRESULT,
    >,
    pub DestroyElement: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStorage, pwcsName: *const OLECHAR) -> HRESULT,
    >,
    pub RenameElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsOldName: *const OLECHAR,
            pwcsNewName: *const OLECHAR,
        ) -> HRESULT,
    >,
    pub SetElementTimes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pwcsName: *const OLECHAR,
            pctime: *const FILETIME,
            patime: *const FILETIME,
            pmtime: *const FILETIME,
        ) -> HRESULT,
    >,
    pub SetClass: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStorage, clsid: *const IID) -> HRESULT,
    >,
    pub SetStateBits: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IStorage, grfStateBits: DWORD, grfMask: DWORD) -> HRESULT,
    >,
    pub Stat: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IStorage,
            pstatstg: *mut STATSTG,
            grfStatFlag: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStorageVtbl"][::std::mem::size_of::<IStorageVtbl>() - 144usize];
    ["Alignment of IStorageVtbl"][::std::mem::align_of::<IStorageVtbl>() - 8usize];
    ["Offset of field: IStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IStorageVtbl::Release"]
        [::std::mem::offset_of!(IStorageVtbl, Release) - 16usize];
    ["Offset of field: IStorageVtbl::CreateStream"]
        [::std::mem::offset_of!(IStorageVtbl, CreateStream) - 24usize];
    ["Offset of field: IStorageVtbl::OpenStream"]
        [::std::mem::offset_of!(IStorageVtbl, OpenStream) - 32usize];
    ["Offset of field: IStorageVtbl::CreateStorage"]
        [::std::mem::offset_of!(IStorageVtbl, CreateStorage) - 40usize];
    ["Offset of field: IStorageVtbl::OpenStorage"]
        [::std::mem::offset_of!(IStorageVtbl, OpenStorage) - 48usize];
    ["Offset of field: IStorageVtbl::CopyTo"]
        [::std::mem::offset_of!(IStorageVtbl, CopyTo) - 56usize];
    ["Offset of field: IStorageVtbl::MoveElementTo"]
        [::std::mem::offset_of!(IStorageVtbl, MoveElementTo) - 64usize];
    ["Offset of field: IStorageVtbl::Commit"]
        [::std::mem::offset_of!(IStorageVtbl, Commit) - 72usize];
    ["Offset of field: IStorageVtbl::Revert"]
        [::std::mem::offset_of!(IStorageVtbl, Revert) - 80usize];
    ["Offset of field: IStorageVtbl::EnumElements"]
        [::std::mem::offset_of!(IStorageVtbl, EnumElements) - 88usize];
    ["Offset of field: IStorageVtbl::DestroyElement"]
        [::std::mem::offset_of!(IStorageVtbl, DestroyElement) - 96usize];
    ["Offset of field: IStorageVtbl::RenameElement"]
        [::std::mem::offset_of!(IStorageVtbl, RenameElement) - 104usize];
    ["Offset of field: IStorageVtbl::SetElementTimes"]
        [::std::mem::offset_of!(IStorageVtbl, SetElementTimes) - 112usize];
    ["Offset of field: IStorageVtbl::SetClass"]
        [::std::mem::offset_of!(IStorageVtbl, SetClass) - 120usize];
    ["Offset of field: IStorageVtbl::SetStateBits"]
        [::std::mem::offset_of!(IStorageVtbl, SetStateBits) - 128usize];
    ["Offset of field: IStorageVtbl::Stat"][::std::mem::offset_of!(IStorageVtbl, Stat) - 136usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IStorage {
    pub lpVtbl: *mut IStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IStorage"][::std::mem::size_of::<IStorage>() - 8usize];
    ["Alignment of IStorage"][::std::mem::align_of::<IStorage>() - 8usize];
    ["Offset of field: IStorage::lpVtbl"][::std::mem::offset_of!(IStorage, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IStorage_RemoteOpenStream_Proxy(
        This: *mut IStorage,
        pwcsName: *const OLECHAR,
        cbReserved1: ULONG,
        reserved1: *mut byte,
        grfMode: DWORD,
        reserved2: DWORD,
        ppstm: *mut *mut IStream,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_RemoteOpenStream_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IStorage_RemoteCopyTo_Proxy(
        This: *mut IStorage,
        ciidExclude: DWORD,
        rgiidExclude: *const IID,
        snbExclude: SNB,
        pstgDest: *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_RemoteCopyTo_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IStorage_RemoteEnumElements_Proxy(
        This: *mut IStorage,
        reserved1: DWORD,
        cbReserved2: ULONG,
        reserved2: *mut byte,
        reserved3: DWORD,
        ppenum: *mut *mut IEnumSTATSTG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_RemoteEnumElements_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0066_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0066_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPPERSISTFILE = *mut IPersistFile;
unsafe extern "C" {
    pub static IID_IPersistFile: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistFileVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistFile,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistFile) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistFile) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistFile, pClassID: *mut CLSID) -> HRESULT,
    >,
    pub IsDirty: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistFile) -> HRESULT>,
    pub Load: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistFile,
            pszFileName: LPCOLESTR,
            dwMode: DWORD,
        ) -> HRESULT,
    >,
    pub Save: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistFile,
            pszFileName: LPCOLESTR,
            fRemember: BOOL,
        ) -> HRESULT,
    >,
    pub SaveCompleted: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistFile, pszFileName: LPCOLESTR) -> HRESULT,
    >,
    pub GetCurFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistFile, ppszFileName: *mut LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistFileVtbl"][::std::mem::size_of::<IPersistFileVtbl>() - 72usize];
    ["Alignment of IPersistFileVtbl"][::std::mem::align_of::<IPersistFileVtbl>() - 8usize];
    ["Offset of field: IPersistFileVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPersistFileVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPersistFileVtbl::AddRef"]
        [::std::mem::offset_of!(IPersistFileVtbl, AddRef) - 8usize];
    ["Offset of field: IPersistFileVtbl::Release"]
        [::std::mem::offset_of!(IPersistFileVtbl, Release) - 16usize];
    ["Offset of field: IPersistFileVtbl::GetClassID"]
        [::std::mem::offset_of!(IPersistFileVtbl, GetClassID) - 24usize];
    ["Offset of field: IPersistFileVtbl::IsDirty"]
        [::std::mem::offset_of!(IPersistFileVtbl, IsDirty) - 32usize];
    ["Offset of field: IPersistFileVtbl::Load"]
        [::std::mem::offset_of!(IPersistFileVtbl, Load) - 40usize];
    ["Offset of field: IPersistFileVtbl::Save"]
        [::std::mem::offset_of!(IPersistFileVtbl, Save) - 48usize];
    ["Offset of field: IPersistFileVtbl::SaveCompleted"]
        [::std::mem::offset_of!(IPersistFileVtbl, SaveCompleted) - 56usize];
    ["Offset of field: IPersistFileVtbl::GetCurFile"]
        [::std::mem::offset_of!(IPersistFileVtbl, GetCurFile) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistFile {
    pub lpVtbl: *mut IPersistFileVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistFile"][::std::mem::size_of::<IPersistFile>() - 8usize];
    ["Alignment of IPersistFile"][::std::mem::align_of::<IPersistFile>() - 8usize];
    ["Offset of field: IPersistFile::lpVtbl"]
        [::std::mem::offset_of!(IPersistFile, lpVtbl) - 0usize];
};
pub type LPPERSISTSTORAGE = *mut IPersistStorage;
unsafe extern "C" {
    pub static IID_IPersistStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStorage) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStorage, pClassID: *mut CLSID) -> HRESULT,
    >,
    pub IsDirty: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStorage) -> HRESULT>,
    pub InitNew: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStorage, pStg: *mut IStorage) -> HRESULT,
    >,
    pub Load: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStorage, pStg: *mut IStorage) -> HRESULT,
    >,
    pub Save: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistStorage,
            pStgSave: *mut IStorage,
            fSameAsLoad: BOOL,
        ) -> HRESULT,
    >,
    pub SaveCompleted: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistStorage, pStgNew: *mut IStorage) -> HRESULT,
    >,
    pub HandsOffStorage:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistStorage) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistStorageVtbl"][::std::mem::size_of::<IPersistStorageVtbl>() - 80usize];
    ["Alignment of IPersistStorageVtbl"][::std::mem::align_of::<IPersistStorageVtbl>() - 8usize];
    ["Offset of field: IPersistStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPersistStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPersistStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IPersistStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IPersistStorageVtbl::Release"]
        [::std::mem::offset_of!(IPersistStorageVtbl, Release) - 16usize];
    ["Offset of field: IPersistStorageVtbl::GetClassID"]
        [::std::mem::offset_of!(IPersistStorageVtbl, GetClassID) - 24usize];
    ["Offset of field: IPersistStorageVtbl::IsDirty"]
        [::std::mem::offset_of!(IPersistStorageVtbl, IsDirty) - 32usize];
    ["Offset of field: IPersistStorageVtbl::InitNew"]
        [::std::mem::offset_of!(IPersistStorageVtbl, InitNew) - 40usize];
    ["Offset of field: IPersistStorageVtbl::Load"]
        [::std::mem::offset_of!(IPersistStorageVtbl, Load) - 48usize];
    ["Offset of field: IPersistStorageVtbl::Save"]
        [::std::mem::offset_of!(IPersistStorageVtbl, Save) - 56usize];
    ["Offset of field: IPersistStorageVtbl::SaveCompleted"]
        [::std::mem::offset_of!(IPersistStorageVtbl, SaveCompleted) - 64usize];
    ["Offset of field: IPersistStorageVtbl::HandsOffStorage"]
        [::std::mem::offset_of!(IPersistStorageVtbl, HandsOffStorage) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistStorage {
    pub lpVtbl: *mut IPersistStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistStorage"][::std::mem::size_of::<IPersistStorage>() - 8usize];
    ["Alignment of IPersistStorage"][::std::mem::align_of::<IPersistStorage>() - 8usize];
    ["Offset of field: IPersistStorage::lpVtbl"]
        [::std::mem::offset_of!(IPersistStorage, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0068_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0068_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPLOCKBYTES = *mut ILockBytes;
unsafe extern "C" {
    pub static IID_ILockBytes: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ILockBytesVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ILockBytes) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ILockBytes) -> ULONG>,
    pub ReadAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            ulOffset: ULARGE_INTEGER,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub WriteAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            ulOffset: ULARGE_INTEGER,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Flush: ::std::option::Option<unsafe extern "C" fn(This: *mut ILockBytes) -> HRESULT>,
    pub SetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ILockBytes, cb: ULARGE_INTEGER) -> HRESULT,
    >,
    pub LockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub UnlockRegion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            libOffset: ULARGE_INTEGER,
            cb: ULARGE_INTEGER,
            dwLockType: DWORD,
        ) -> HRESULT,
    >,
    pub Stat: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILockBytes,
            pstatstg: *mut STATSTG,
            grfStatFlag: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ILockBytesVtbl"][::std::mem::size_of::<ILockBytesVtbl>() - 80usize];
    ["Alignment of ILockBytesVtbl"][::std::mem::align_of::<ILockBytesVtbl>() - 8usize];
    ["Offset of field: ILockBytesVtbl::QueryInterface"]
        [::std::mem::offset_of!(ILockBytesVtbl, QueryInterface) - 0usize];
    ["Offset of field: ILockBytesVtbl::AddRef"]
        [::std::mem::offset_of!(ILockBytesVtbl, AddRef) - 8usize];
    ["Offset of field: ILockBytesVtbl::Release"]
        [::std::mem::offset_of!(ILockBytesVtbl, Release) - 16usize];
    ["Offset of field: ILockBytesVtbl::ReadAt"]
        [::std::mem::offset_of!(ILockBytesVtbl, ReadAt) - 24usize];
    ["Offset of field: ILockBytesVtbl::WriteAt"]
        [::std::mem::offset_of!(ILockBytesVtbl, WriteAt) - 32usize];
    ["Offset of field: ILockBytesVtbl::Flush"]
        [::std::mem::offset_of!(ILockBytesVtbl, Flush) - 40usize];
    ["Offset of field: ILockBytesVtbl::SetSize"]
        [::std::mem::offset_of!(ILockBytesVtbl, SetSize) - 48usize];
    ["Offset of field: ILockBytesVtbl::LockRegion"]
        [::std::mem::offset_of!(ILockBytesVtbl, LockRegion) - 56usize];
    ["Offset of field: ILockBytesVtbl::UnlockRegion"]
        [::std::mem::offset_of!(ILockBytesVtbl, UnlockRegion) - 64usize];
    ["Offset of field: ILockBytesVtbl::Stat"]
        [::std::mem::offset_of!(ILockBytesVtbl, Stat) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ILockBytes {
    pub lpVtbl: *mut ILockBytesVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ILockBytes"][::std::mem::size_of::<ILockBytes>() - 8usize];
    ["Alignment of ILockBytes"][::std::mem::align_of::<ILockBytes>() - 8usize];
    ["Offset of field: ILockBytes::lpVtbl"][::std::mem::offset_of!(ILockBytes, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ILockBytes_RemoteReadAt_Proxy(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *mut byte,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_RemoteReadAt_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ILockBytes_RemoteWriteAt_Proxy(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_RemoteWriteAt_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMFORMATETC = *mut IEnumFORMATETC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDVTARGETDEVICE {
    pub tdSize: DWORD,
    pub tdDriverNameOffset: WORD,
    pub tdDeviceNameOffset: WORD,
    pub tdPortNameOffset: WORD,
    pub tdExtDevmodeOffset: WORD,
    pub tdData: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDVTARGETDEVICE"][::std::mem::size_of::<tagDVTARGETDEVICE>() - 16usize];
    ["Alignment of tagDVTARGETDEVICE"][::std::mem::align_of::<tagDVTARGETDEVICE>() - 4usize];
    ["Offset of field: tagDVTARGETDEVICE::tdSize"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdSize) - 0usize];
    ["Offset of field: tagDVTARGETDEVICE::tdDriverNameOffset"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdDriverNameOffset) - 4usize];
    ["Offset of field: tagDVTARGETDEVICE::tdDeviceNameOffset"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdDeviceNameOffset) - 6usize];
    ["Offset of field: tagDVTARGETDEVICE::tdPortNameOffset"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdPortNameOffset) - 8usize];
    ["Offset of field: tagDVTARGETDEVICE::tdExtDevmodeOffset"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdExtDevmodeOffset) - 10usize];
    ["Offset of field: tagDVTARGETDEVICE::tdData"]
        [::std::mem::offset_of!(tagDVTARGETDEVICE, tdData) - 12usize];
};
pub type DVTARGETDEVICE = tagDVTARGETDEVICE;
pub type LPCLIPFORMAT = *mut CLIPFORMAT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagFORMATETC {
    pub cfFormat: CLIPFORMAT,
    pub ptd: *mut DVTARGETDEVICE,
    pub dwAspect: DWORD,
    pub lindex: LONG,
    pub tymed: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFORMATETC"][::std::mem::size_of::<tagFORMATETC>() - 32usize];
    ["Alignment of tagFORMATETC"][::std::mem::align_of::<tagFORMATETC>() - 8usize];
    ["Offset of field: tagFORMATETC::cfFormat"]
        [::std::mem::offset_of!(tagFORMATETC, cfFormat) - 0usize];
    ["Offset of field: tagFORMATETC::ptd"][::std::mem::offset_of!(tagFORMATETC, ptd) - 8usize];
    ["Offset of field: tagFORMATETC::dwAspect"]
        [::std::mem::offset_of!(tagFORMATETC, dwAspect) - 16usize];
    ["Offset of field: tagFORMATETC::lindex"]
        [::std::mem::offset_of!(tagFORMATETC, lindex) - 20usize];
    ["Offset of field: tagFORMATETC::tymed"][::std::mem::offset_of!(tagFORMATETC, tymed) - 24usize];
};
pub type FORMATETC = tagFORMATETC;
pub type LPFORMATETC = *mut tagFORMATETC;
unsafe extern "C" {
    pub static IID_IEnumFORMATETC: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumFORMATETCVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumFORMATETC,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumFORMATETC) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumFORMATETC) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumFORMATETC,
            celt: ULONG,
            rgelt: *mut FORMATETC,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumFORMATETC, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumFORMATETC) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumFORMATETC,
            ppenum: *mut *mut IEnumFORMATETC,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumFORMATETCVtbl"][::std::mem::size_of::<IEnumFORMATETCVtbl>() - 56usize];
    ["Alignment of IEnumFORMATETCVtbl"][::std::mem::align_of::<IEnumFORMATETCVtbl>() - 8usize];
    ["Offset of field: IEnumFORMATETCVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumFORMATETCVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumFORMATETCVtbl::Release"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, Release) - 16usize];
    ["Offset of field: IEnumFORMATETCVtbl::Next"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, Next) - 24usize];
    ["Offset of field: IEnumFORMATETCVtbl::Skip"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, Skip) - 32usize];
    ["Offset of field: IEnumFORMATETCVtbl::Reset"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, Reset) - 40usize];
    ["Offset of field: IEnumFORMATETCVtbl::Clone"]
        [::std::mem::offset_of!(IEnumFORMATETCVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumFORMATETC {
    pub lpVtbl: *mut IEnumFORMATETCVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumFORMATETC"][::std::mem::size_of::<IEnumFORMATETC>() - 8usize];
    ["Alignment of IEnumFORMATETC"][::std::mem::align_of::<IEnumFORMATETC>() - 8usize];
    ["Offset of field: IEnumFORMATETC::lpVtbl"]
        [::std::mem::offset_of!(IEnumFORMATETC, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumFORMATETC_RemoteNext_Proxy(
        This: *mut IEnumFORMATETC,
        celt: ULONG,
        rgelt: *mut FORMATETC,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumFORMATETC_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMSTATDATA = *mut IEnumSTATDATA;
pub const tagADVF_ADVF_NODATA: tagADVF = 1;
pub const tagADVF_ADVF_PRIMEFIRST: tagADVF = 2;
pub const tagADVF_ADVF_ONLYONCE: tagADVF = 4;
pub const tagADVF_ADVF_DATAONSTOP: tagADVF = 64;
pub const tagADVF_ADVFCACHE_NOHANDLER: tagADVF = 8;
pub const tagADVF_ADVFCACHE_FORCEBUILTIN: tagADVF = 16;
pub const tagADVF_ADVFCACHE_ONSAVE: tagADVF = 32;
pub type tagADVF = ::std::os::raw::c_int;
pub use self::tagADVF as ADVF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTATDATA {
    pub formatetc: FORMATETC,
    pub advf: DWORD,
    pub pAdvSink: *mut IAdviseSink,
    pub dwConnection: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTATDATA"][::std::mem::size_of::<tagSTATDATA>() - 56usize];
    ["Alignment of tagSTATDATA"][::std::mem::align_of::<tagSTATDATA>() - 8usize];
    ["Offset of field: tagSTATDATA::formatetc"]
        [::std::mem::offset_of!(tagSTATDATA, formatetc) - 0usize];
    ["Offset of field: tagSTATDATA::advf"][::std::mem::offset_of!(tagSTATDATA, advf) - 32usize];
    ["Offset of field: tagSTATDATA::pAdvSink"]
        [::std::mem::offset_of!(tagSTATDATA, pAdvSink) - 40usize];
    ["Offset of field: tagSTATDATA::dwConnection"]
        [::std::mem::offset_of!(tagSTATDATA, dwConnection) - 48usize];
};
pub type STATDATA = tagSTATDATA;
pub type LPSTATDATA = *mut STATDATA;
unsafe extern "C" {
    pub static IID_IEnumSTATDATA: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATDATAVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATDATA,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATDATA) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATDATA) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATDATA,
            celt: ULONG,
            rgelt: *mut STATDATA,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATDATA, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATDATA) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATDATA, ppenum: *mut *mut IEnumSTATDATA) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATDATAVtbl"][::std::mem::size_of::<IEnumSTATDATAVtbl>() - 56usize];
    ["Alignment of IEnumSTATDATAVtbl"][::std::mem::align_of::<IEnumSTATDATAVtbl>() - 8usize];
    ["Offset of field: IEnumSTATDATAVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumSTATDATAVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumSTATDATAVtbl::Release"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, Release) - 16usize];
    ["Offset of field: IEnumSTATDATAVtbl::Next"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, Next) - 24usize];
    ["Offset of field: IEnumSTATDATAVtbl::Skip"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, Skip) - 32usize];
    ["Offset of field: IEnumSTATDATAVtbl::Reset"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, Reset) - 40usize];
    ["Offset of field: IEnumSTATDATAVtbl::Clone"]
        [::std::mem::offset_of!(IEnumSTATDATAVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATDATA {
    pub lpVtbl: *mut IEnumSTATDATAVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATDATA"][::std::mem::size_of::<IEnumSTATDATA>() - 8usize];
    ["Alignment of IEnumSTATDATA"][::std::mem::align_of::<IEnumSTATDATA>() - 8usize];
    ["Offset of field: IEnumSTATDATA::lpVtbl"]
        [::std::mem::offset_of!(IEnumSTATDATA, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumSTATDATA_RemoteNext_Proxy(
        This: *mut IEnumSTATDATA,
        celt: ULONG,
        rgelt: *mut STATDATA,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATDATA_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPROOTSTORAGE = *mut IRootStorage;
unsafe extern "C" {
    pub static IID_IRootStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRootStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRootStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRootStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRootStorage) -> ULONG>,
    pub SwitchToFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRootStorage, pszFile: LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRootStorageVtbl"][::std::mem::size_of::<IRootStorageVtbl>() - 32usize];
    ["Alignment of IRootStorageVtbl"][::std::mem::align_of::<IRootStorageVtbl>() - 8usize];
    ["Offset of field: IRootStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRootStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRootStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IRootStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IRootStorageVtbl::Release"]
        [::std::mem::offset_of!(IRootStorageVtbl, Release) - 16usize];
    ["Offset of field: IRootStorageVtbl::SwitchToFile"]
        [::std::mem::offset_of!(IRootStorageVtbl, SwitchToFile) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRootStorage {
    pub lpVtbl: *mut IRootStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRootStorage"][::std::mem::size_of::<IRootStorage>() - 8usize];
    ["Alignment of IRootStorage"][::std::mem::align_of::<IRootStorage>() - 8usize];
    ["Offset of field: IRootStorage::lpVtbl"]
        [::std::mem::offset_of!(IRootStorage, lpVtbl) - 0usize];
};
pub type LPADVISESINK = *mut IAdviseSink;
pub const tagTYMED_TYMED_HGLOBAL: tagTYMED = 1;
pub const tagTYMED_TYMED_FILE: tagTYMED = 2;
pub const tagTYMED_TYMED_ISTREAM: tagTYMED = 4;
pub const tagTYMED_TYMED_ISTORAGE: tagTYMED = 8;
pub const tagTYMED_TYMED_GDI: tagTYMED = 16;
pub const tagTYMED_TYMED_MFPICT: tagTYMED = 32;
pub const tagTYMED_TYMED_ENHMF: tagTYMED = 64;
pub const tagTYMED_TYMED_NULL: tagTYMED = 0;
pub type tagTYMED = ::std::os::raw::c_int;
pub use self::tagTYMED as TYMED;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemSTGMEDIUM {
    pub tymed: DWORD,
    pub dwHandleType: DWORD,
    pub pData: ULONG,
    pub pUnkForRelease: ULONG,
    pub cbData: ULONG,
    pub data: [byte; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemSTGMEDIUM"][::std::mem::size_of::<tagRemSTGMEDIUM>() - 24usize];
    ["Alignment of tagRemSTGMEDIUM"][::std::mem::align_of::<tagRemSTGMEDIUM>() - 4usize];
    ["Offset of field: tagRemSTGMEDIUM::tymed"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, tymed) - 0usize];
    ["Offset of field: tagRemSTGMEDIUM::dwHandleType"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, dwHandleType) - 4usize];
    ["Offset of field: tagRemSTGMEDIUM::pData"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, pData) - 8usize];
    ["Offset of field: tagRemSTGMEDIUM::pUnkForRelease"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, pUnkForRelease) - 12usize];
    ["Offset of field: tagRemSTGMEDIUM::cbData"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, cbData) - 16usize];
    ["Offset of field: tagRemSTGMEDIUM::data"]
        [::std::mem::offset_of!(tagRemSTGMEDIUM, data) - 20usize];
};
pub type RemSTGMEDIUM = tagRemSTGMEDIUM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagSTGMEDIUM {
    pub tymed: DWORD,
    pub __bindgen_anon_1: tagSTGMEDIUM__bindgen_ty_1,
    pub pUnkForRelease: *mut IUnknown,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagSTGMEDIUM__bindgen_ty_1 {
    pub hBitmap: HBITMAP,
    pub hMetaFilePict: HMETAFILEPICT,
    pub hEnhMetaFile: HENHMETAFILE,
    pub hGlobal: HGLOBAL,
    pub lpszFileName: LPOLESTR,
    pub pstm: *mut IStream,
    pub pstg: *mut IStorage,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTGMEDIUM__bindgen_ty_1"]
        [::std::mem::size_of::<tagSTGMEDIUM__bindgen_ty_1>() - 8usize];
    ["Alignment of tagSTGMEDIUM__bindgen_ty_1"]
        [::std::mem::align_of::<tagSTGMEDIUM__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::hBitmap"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, hBitmap) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::hMetaFilePict"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, hMetaFilePict) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::hEnhMetaFile"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, hEnhMetaFile) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::hGlobal"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, hGlobal) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::lpszFileName"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, lpszFileName) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::pstm"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, pstm) - 0usize];
    ["Offset of field: tagSTGMEDIUM__bindgen_ty_1::pstg"]
        [::std::mem::offset_of!(tagSTGMEDIUM__bindgen_ty_1, pstg) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTGMEDIUM"][::std::mem::size_of::<tagSTGMEDIUM>() - 24usize];
    ["Alignment of tagSTGMEDIUM"][::std::mem::align_of::<tagSTGMEDIUM>() - 8usize];
    ["Offset of field: tagSTGMEDIUM::tymed"][::std::mem::offset_of!(tagSTGMEDIUM, tymed) - 0usize];
    ["Offset of field: tagSTGMEDIUM::pUnkForRelease"]
        [::std::mem::offset_of!(tagSTGMEDIUM, pUnkForRelease) - 16usize];
};
pub type uSTGMEDIUM = tagSTGMEDIUM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _GDI_OBJECT {
    pub ObjectType: DWORD,
    pub u: _GDI_OBJECT___MIDL_IAdviseSink_0002,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _GDI_OBJECT___MIDL_IAdviseSink_0002 {
    pub hBitmap: wireHBITMAP,
    pub hPalette: wireHPALETTE,
    pub hGeneric: wireHGLOBAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GDI_OBJECT___MIDL_IAdviseSink_0002"]
        [::std::mem::size_of::<_GDI_OBJECT___MIDL_IAdviseSink_0002>() - 8usize];
    ["Alignment of _GDI_OBJECT___MIDL_IAdviseSink_0002"]
        [::std::mem::align_of::<_GDI_OBJECT___MIDL_IAdviseSink_0002>() - 8usize];
    ["Offset of field: _GDI_OBJECT___MIDL_IAdviseSink_0002::hBitmap"]
        [::std::mem::offset_of!(_GDI_OBJECT___MIDL_IAdviseSink_0002, hBitmap) - 0usize];
    ["Offset of field: _GDI_OBJECT___MIDL_IAdviseSink_0002::hPalette"]
        [::std::mem::offset_of!(_GDI_OBJECT___MIDL_IAdviseSink_0002, hPalette) - 0usize];
    ["Offset of field: _GDI_OBJECT___MIDL_IAdviseSink_0002::hGeneric"]
        [::std::mem::offset_of!(_GDI_OBJECT___MIDL_IAdviseSink_0002, hGeneric) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _GDI_OBJECT"][::std::mem::size_of::<_GDI_OBJECT>() - 16usize];
    ["Alignment of _GDI_OBJECT"][::std::mem::align_of::<_GDI_OBJECT>() - 8usize];
    ["Offset of field: _GDI_OBJECT::ObjectType"]
        [::std::mem::offset_of!(_GDI_OBJECT, ObjectType) - 0usize];
    ["Offset of field: _GDI_OBJECT::u"][::std::mem::offset_of!(_GDI_OBJECT, u) - 8usize];
};
pub type GDI_OBJECT = _GDI_OBJECT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _userSTGMEDIUM {
    pub __bindgen_padding_0: [u64; 2usize],
    pub pUnkForRelease: *mut IUnknown,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _userSTGMEDIUM__STGMEDIUM_UNION {
    pub tymed: DWORD,
    pub u: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003 {
    pub hMetaFilePict: wireHMETAFILEPICT,
    pub hHEnhMetaFile: wireHENHMETAFILE,
    pub hGdiHandle: *mut GDI_OBJECT,
    pub hGlobal: wireHGLOBAL,
    pub lpszFileName: LPOLESTR,
    pub pstm: *mut BYTE_BLOB,
    pub pstg: *mut BYTE_BLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003"]
        [::std::mem::size_of::<_userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003>() - 8usize];
    ["Alignment of _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003"][::std::mem::align_of::<
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
    >() - 8usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::hMetaFilePict"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        hMetaFilePict
    )
        - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::hHEnhMetaFile"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        hHEnhMetaFile
    )
        - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::hGdiHandle"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        hGdiHandle
    )
        - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::hGlobal"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        hGlobal
    )
        - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::lpszFileName"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        lpszFileName
    )
        - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::pstm"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        pstm
    ) - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003::pstg"][::std::mem::offset_of!(
        _userSTGMEDIUM__STGMEDIUM_UNION___MIDL_IAdviseSink_0003,
        pstg
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userSTGMEDIUM__STGMEDIUM_UNION"]
        [::std::mem::size_of::<_userSTGMEDIUM__STGMEDIUM_UNION>() - 16usize];
    ["Alignment of _userSTGMEDIUM__STGMEDIUM_UNION"]
        [::std::mem::align_of::<_userSTGMEDIUM__STGMEDIUM_UNION>() - 8usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION::tymed"]
        [::std::mem::offset_of!(_userSTGMEDIUM__STGMEDIUM_UNION, tymed) - 0usize];
    ["Offset of field: _userSTGMEDIUM__STGMEDIUM_UNION::u"]
        [::std::mem::offset_of!(_userSTGMEDIUM__STGMEDIUM_UNION, u) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userSTGMEDIUM"][::std::mem::size_of::<_userSTGMEDIUM>() - 24usize];
    ["Alignment of _userSTGMEDIUM"][::std::mem::align_of::<_userSTGMEDIUM>() - 8usize];
    ["Offset of field: _userSTGMEDIUM::pUnkForRelease"]
        [::std::mem::offset_of!(_userSTGMEDIUM, pUnkForRelease) - 16usize];
};
pub type userSTGMEDIUM = _userSTGMEDIUM;
pub type wireSTGMEDIUM = *mut userSTGMEDIUM;
pub type STGMEDIUM = uSTGMEDIUM;
pub type wireASYNC_STGMEDIUM = *mut userSTGMEDIUM;
pub type ASYNC_STGMEDIUM = STGMEDIUM;
pub type LPSTGMEDIUM = *mut STGMEDIUM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _userFLAG_STGMEDIUM {
    pub ContextFlags: LONG,
    pub fPassOwnership: LONG,
    pub Stgmed: userSTGMEDIUM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _userFLAG_STGMEDIUM"][::std::mem::size_of::<_userFLAG_STGMEDIUM>() - 32usize];
    ["Alignment of _userFLAG_STGMEDIUM"][::std::mem::align_of::<_userFLAG_STGMEDIUM>() - 8usize];
    ["Offset of field: _userFLAG_STGMEDIUM::ContextFlags"]
        [::std::mem::offset_of!(_userFLAG_STGMEDIUM, ContextFlags) - 0usize];
    ["Offset of field: _userFLAG_STGMEDIUM::fPassOwnership"]
        [::std::mem::offset_of!(_userFLAG_STGMEDIUM, fPassOwnership) - 4usize];
    ["Offset of field: _userFLAG_STGMEDIUM::Stgmed"]
        [::std::mem::offset_of!(_userFLAG_STGMEDIUM, Stgmed) - 8usize];
};
pub type userFLAG_STGMEDIUM = _userFLAG_STGMEDIUM;
pub type wireFLAG_STGMEDIUM = *mut userFLAG_STGMEDIUM;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _FLAG_STGMEDIUM {
    pub ContextFlags: LONG,
    pub fPassOwnership: LONG,
    pub Stgmed: STGMEDIUM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _FLAG_STGMEDIUM"][::std::mem::size_of::<_FLAG_STGMEDIUM>() - 32usize];
    ["Alignment of _FLAG_STGMEDIUM"][::std::mem::align_of::<_FLAG_STGMEDIUM>() - 8usize];
    ["Offset of field: _FLAG_STGMEDIUM::ContextFlags"]
        [::std::mem::offset_of!(_FLAG_STGMEDIUM, ContextFlags) - 0usize];
    ["Offset of field: _FLAG_STGMEDIUM::fPassOwnership"]
        [::std::mem::offset_of!(_FLAG_STGMEDIUM, fPassOwnership) - 4usize];
    ["Offset of field: _FLAG_STGMEDIUM::Stgmed"]
        [::std::mem::offset_of!(_FLAG_STGMEDIUM, Stgmed) - 8usize];
};
pub type FLAG_STGMEDIUM = _FLAG_STGMEDIUM;
unsafe extern "C" {
    pub static IID_IAdviseSink: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAdviseSinkVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAdviseSink,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink) -> ULONG>,
    pub OnDataChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAdviseSink,
            pFormatetc: *mut FORMATETC,
            pStgmed: *mut STGMEDIUM,
        ),
    >,
    pub OnViewChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IAdviseSink, dwAspect: DWORD, lindex: LONG),
    >,
    pub OnRename:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink, pmk: *mut IMoniker)>,
    pub OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink)>,
    pub OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAdviseSinkVtbl"][::std::mem::size_of::<IAdviseSinkVtbl>() - 64usize];
    ["Alignment of IAdviseSinkVtbl"][::std::mem::align_of::<IAdviseSinkVtbl>() - 8usize];
    ["Offset of field: IAdviseSinkVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAdviseSinkVtbl::AddRef"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, AddRef) - 8usize];
    ["Offset of field: IAdviseSinkVtbl::Release"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, Release) - 16usize];
    ["Offset of field: IAdviseSinkVtbl::OnDataChange"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, OnDataChange) - 24usize];
    ["Offset of field: IAdviseSinkVtbl::OnViewChange"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, OnViewChange) - 32usize];
    ["Offset of field: IAdviseSinkVtbl::OnRename"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, OnRename) - 40usize];
    ["Offset of field: IAdviseSinkVtbl::OnSave"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, OnSave) - 48usize];
    ["Offset of field: IAdviseSinkVtbl::OnClose"]
        [::std::mem::offset_of!(IAdviseSinkVtbl, OnClose) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAdviseSink {
    pub lpVtbl: *mut IAdviseSinkVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAdviseSink"][::std::mem::size_of::<IAdviseSink>() - 8usize];
    ["Alignment of IAdviseSink"][::std::mem::align_of::<IAdviseSink>() - 8usize];
    ["Offset of field: IAdviseSink::lpVtbl"][::std::mem::offset_of!(IAdviseSink, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnDataChange_Proxy(
        This: *mut IAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut ASYNC_STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnDataChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnViewChange_Proxy(
        This: *mut IAdviseSink,
        dwAspect: DWORD,
        lindex: LONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnViewChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnRename_Proxy(This: *mut IAdviseSink, pmk: *mut IMoniker) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnRename_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnSave_Proxy(This: *mut IAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnSave_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnClose_Proxy(This: *mut IAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_RemoteOnClose_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static IID_AsyncIAdviseSink: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIAdviseSinkVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIAdviseSink,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink) -> ULONG>,
    pub Begin_OnDataChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIAdviseSink,
            pFormatetc: *mut FORMATETC,
            pStgmed: *mut STGMEDIUM,
        ),
    >,
    pub Finish_OnDataChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Begin_OnViewChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIAdviseSink, dwAspect: DWORD, lindex: LONG),
    >,
    pub Finish_OnViewChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Begin_OnRename: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIAdviseSink, pmk: *mut IMoniker),
    >,
    pub Finish_OnRename: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Begin_OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Finish_OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Begin_OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
    pub Finish_OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIAdviseSinkVtbl"][::std::mem::size_of::<AsyncIAdviseSinkVtbl>() - 104usize];
    ["Alignment of AsyncIAdviseSinkVtbl"][::std::mem::align_of::<AsyncIAdviseSinkVtbl>() - 8usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Release"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Release) - 16usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Begin_OnDataChange"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Begin_OnDataChange) - 24usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Finish_OnDataChange"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Finish_OnDataChange) - 32usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Begin_OnViewChange"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Begin_OnViewChange) - 40usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Finish_OnViewChange"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Finish_OnViewChange) - 48usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Begin_OnRename"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Begin_OnRename) - 56usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Finish_OnRename"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Finish_OnRename) - 64usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Begin_OnSave"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Begin_OnSave) - 72usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Finish_OnSave"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Finish_OnSave) - 80usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Begin_OnClose"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Begin_OnClose) - 88usize];
    ["Offset of field: AsyncIAdviseSinkVtbl::Finish_OnClose"]
        [::std::mem::offset_of!(AsyncIAdviseSinkVtbl, Finish_OnClose) - 96usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIAdviseSink {
    pub lpVtbl: *mut AsyncIAdviseSinkVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIAdviseSink"][::std::mem::size_of::<AsyncIAdviseSink>() - 8usize];
    ["Alignment of AsyncIAdviseSink"][::std::mem::align_of::<AsyncIAdviseSink>() - 8usize];
    ["Offset of field: AsyncIAdviseSink::lpVtbl"]
        [::std::mem::offset_of!(AsyncIAdviseSink, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnDataChange_Proxy(
        This: *mut AsyncIAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut ASYNC_STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnDataChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnDataChange_Proxy(This: *mut AsyncIAdviseSink)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnDataChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnViewChange_Proxy(
        This: *mut AsyncIAdviseSink,
        dwAspect: DWORD,
        lindex: LONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnViewChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnViewChange_Proxy(This: *mut AsyncIAdviseSink)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnViewChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnRename_Proxy(
        This: *mut AsyncIAdviseSink,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnRename_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnRename_Proxy(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnRename_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnSave_Proxy(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnSave_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnSave_Proxy(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnSave_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnClose_Proxy(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_RemoteOnClose_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnClose_Proxy(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_RemoteOnClose_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0073_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0073_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPADVISESINK2 = *mut IAdviseSink2;
unsafe extern "C" {
    pub static IID_IAdviseSink2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAdviseSink2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAdviseSink2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2) -> ULONG>,
    pub OnDataChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAdviseSink2,
            pFormatetc: *mut FORMATETC,
            pStgmed: *mut STGMEDIUM,
        ),
    >,
    pub OnViewChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IAdviseSink2, dwAspect: DWORD, lindex: LONG),
    >,
    pub OnRename:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2, pmk: *mut IMoniker)>,
    pub OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2)>,
    pub OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2)>,
    pub OnLinkSrcChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IAdviseSink2, pmk: *mut IMoniker)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAdviseSink2Vtbl"][::std::mem::size_of::<IAdviseSink2Vtbl>() - 72usize];
    ["Alignment of IAdviseSink2Vtbl"][::std::mem::align_of::<IAdviseSink2Vtbl>() - 8usize];
    ["Offset of field: IAdviseSink2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IAdviseSink2Vtbl::AddRef"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, AddRef) - 8usize];
    ["Offset of field: IAdviseSink2Vtbl::Release"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, Release) - 16usize];
    ["Offset of field: IAdviseSink2Vtbl::OnDataChange"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnDataChange) - 24usize];
    ["Offset of field: IAdviseSink2Vtbl::OnViewChange"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnViewChange) - 32usize];
    ["Offset of field: IAdviseSink2Vtbl::OnRename"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnRename) - 40usize];
    ["Offset of field: IAdviseSink2Vtbl::OnSave"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnSave) - 48usize];
    ["Offset of field: IAdviseSink2Vtbl::OnClose"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnClose) - 56usize];
    ["Offset of field: IAdviseSink2Vtbl::OnLinkSrcChange"]
        [::std::mem::offset_of!(IAdviseSink2Vtbl, OnLinkSrcChange) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAdviseSink2 {
    pub lpVtbl: *mut IAdviseSink2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAdviseSink2"][::std::mem::size_of::<IAdviseSink2>() - 8usize];
    ["Alignment of IAdviseSink2"][::std::mem::align_of::<IAdviseSink2>() - 8usize];
    ["Offset of field: IAdviseSink2::lpVtbl"]
        [::std::mem::offset_of!(IAdviseSink2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IAdviseSink2_RemoteOnLinkSrcChange_Proxy(
        This: *mut IAdviseSink2,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink2_RemoteOnLinkSrcChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static IID_AsyncIAdviseSink2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIAdviseSink2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIAdviseSink2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2) -> ULONG>,
    pub Begin_OnDataChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut AsyncIAdviseSink2,
            pFormatetc: *mut FORMATETC,
            pStgmed: *mut STGMEDIUM,
        ),
    >,
    pub Finish_OnDataChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Begin_OnViewChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIAdviseSink2, dwAspect: DWORD, lindex: LONG),
    >,
    pub Finish_OnViewChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Begin_OnRename: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIAdviseSink2, pmk: *mut IMoniker),
    >,
    pub Finish_OnRename: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Begin_OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Finish_OnSave: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Begin_OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Finish_OnClose: ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
    pub Begin_OnLinkSrcChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut AsyncIAdviseSink2, pmk: *mut IMoniker),
    >,
    pub Finish_OnLinkSrcChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut AsyncIAdviseSink2)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIAdviseSink2Vtbl"][::std::mem::size_of::<AsyncIAdviseSink2Vtbl>() - 120usize];
    ["Alignment of AsyncIAdviseSink2Vtbl"]
        [::std::mem::align_of::<AsyncIAdviseSink2Vtbl>() - 8usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::AddRef"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, AddRef) - 8usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Release"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Release) - 16usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnDataChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnDataChange) - 24usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnDataChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnDataChange) - 32usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnViewChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnViewChange) - 40usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnViewChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnViewChange) - 48usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnRename"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnRename) - 56usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnRename"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnRename) - 64usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnSave"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnSave) - 72usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnSave"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnSave) - 80usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnClose"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnClose) - 88usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnClose"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnClose) - 96usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Begin_OnLinkSrcChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Begin_OnLinkSrcChange) - 104usize];
    ["Offset of field: AsyncIAdviseSink2Vtbl::Finish_OnLinkSrcChange"]
        [::std::mem::offset_of!(AsyncIAdviseSink2Vtbl, Finish_OnLinkSrcChange) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct AsyncIAdviseSink2 {
    pub lpVtbl: *mut AsyncIAdviseSink2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of AsyncIAdviseSink2"][::std::mem::size_of::<AsyncIAdviseSink2>() - 8usize];
    ["Alignment of AsyncIAdviseSink2"][::std::mem::align_of::<AsyncIAdviseSink2>() - 8usize];
    ["Offset of field: AsyncIAdviseSink2::lpVtbl"]
        [::std::mem::offset_of!(AsyncIAdviseSink2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Begin_RemoteOnLinkSrcChange_Proxy(
        This: *mut AsyncIAdviseSink2,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Begin_RemoteOnLinkSrcChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Finish_RemoteOnLinkSrcChange_Proxy(
        This: *mut AsyncIAdviseSink2,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Finish_RemoteOnLinkSrcChange_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0074_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0074_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPDATAOBJECT = *mut IDataObject;
pub const tagDATADIR_DATADIR_GET: tagDATADIR = 1;
pub const tagDATADIR_DATADIR_SET: tagDATADIR = 2;
pub type tagDATADIR = ::std::os::raw::c_int;
pub use self::tagDATADIR as DATADIR;
unsafe extern "C" {
    pub static IID_IDataObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataObject) -> ULONG>,
    pub GetData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            pformatetcIn: *mut FORMATETC,
            pmedium: *mut STGMEDIUM,
        ) -> HRESULT,
    >,
    pub GetDataHere: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            pformatetc: *mut FORMATETC,
            pmedium: *mut STGMEDIUM,
        ) -> HRESULT,
    >,
    pub QueryGetData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDataObject, pformatetc: *mut FORMATETC) -> HRESULT,
    >,
    pub GetCanonicalFormatEtc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            pformatectIn: *mut FORMATETC,
            pformatetcOut: *mut FORMATETC,
        ) -> HRESULT,
    >,
    pub SetData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            pformatetc: *mut FORMATETC,
            pmedium: *mut STGMEDIUM,
            fRelease: BOOL,
        ) -> HRESULT,
    >,
    pub EnumFormatEtc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            dwDirection: DWORD,
            ppenumFormatEtc: *mut *mut IEnumFORMATETC,
        ) -> HRESULT,
    >,
    pub DAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            pformatetc: *mut FORMATETC,
            advf: DWORD,
            pAdvSink: *mut IAdviseSink,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DUnadvise: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDataObject, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumDAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataObject,
            ppenumAdvise: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataObjectVtbl"][::std::mem::size_of::<IDataObjectVtbl>() - 96usize];
    ["Alignment of IDataObjectVtbl"][::std::mem::align_of::<IDataObjectVtbl>() - 8usize];
    ["Offset of field: IDataObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDataObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDataObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IDataObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IDataObjectVtbl::Release"]
        [::std::mem::offset_of!(IDataObjectVtbl, Release) - 16usize];
    ["Offset of field: IDataObjectVtbl::GetData"]
        [::std::mem::offset_of!(IDataObjectVtbl, GetData) - 24usize];
    ["Offset of field: IDataObjectVtbl::GetDataHere"]
        [::std::mem::offset_of!(IDataObjectVtbl, GetDataHere) - 32usize];
    ["Offset of field: IDataObjectVtbl::QueryGetData"]
        [::std::mem::offset_of!(IDataObjectVtbl, QueryGetData) - 40usize];
    ["Offset of field: IDataObjectVtbl::GetCanonicalFormatEtc"]
        [::std::mem::offset_of!(IDataObjectVtbl, GetCanonicalFormatEtc) - 48usize];
    ["Offset of field: IDataObjectVtbl::SetData"]
        [::std::mem::offset_of!(IDataObjectVtbl, SetData) - 56usize];
    ["Offset of field: IDataObjectVtbl::EnumFormatEtc"]
        [::std::mem::offset_of!(IDataObjectVtbl, EnumFormatEtc) - 64usize];
    ["Offset of field: IDataObjectVtbl::DAdvise"]
        [::std::mem::offset_of!(IDataObjectVtbl, DAdvise) - 72usize];
    ["Offset of field: IDataObjectVtbl::DUnadvise"]
        [::std::mem::offset_of!(IDataObjectVtbl, DUnadvise) - 80usize];
    ["Offset of field: IDataObjectVtbl::EnumDAdvise"]
        [::std::mem::offset_of!(IDataObjectVtbl, EnumDAdvise) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataObject {
    pub lpVtbl: *mut IDataObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataObject"][::std::mem::size_of::<IDataObject>() - 8usize];
    ["Alignment of IDataObject"][::std::mem::align_of::<IDataObject>() - 8usize];
    ["Offset of field: IDataObject::lpVtbl"][::std::mem::offset_of!(IDataObject, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IDataObject_RemoteGetData_Proxy(
        This: *mut IDataObject,
        pformatetcIn: *mut FORMATETC,
        pRemoteMedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_RemoteGetData_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IDataObject_RemoteGetDataHere_Proxy(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pRemoteMedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_RemoteGetDataHere_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IDataObject_RemoteSetData_Proxy(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pmedium: *mut FLAG_STGMEDIUM,
        fRelease: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_RemoteSetData_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0075_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0075_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPDATAADVISEHOLDER = *mut IDataAdviseHolder;
unsafe extern "C" {
    pub static IID_IDataAdviseHolder: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataAdviseHolderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataAdviseHolder,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataAdviseHolder) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataAdviseHolder) -> ULONG>,
    pub Advise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataAdviseHolder,
            pDataObject: *mut IDataObject,
            pFetc: *mut FORMATETC,
            advf: DWORD,
            pAdvise: *mut IAdviseSink,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Unadvise: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDataAdviseHolder, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataAdviseHolder,
            ppenumAdvise: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
    pub SendOnDataChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataAdviseHolder,
            pDataObject: *mut IDataObject,
            dwReserved: DWORD,
            advf: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataAdviseHolderVtbl"][::std::mem::size_of::<IDataAdviseHolderVtbl>() - 56usize];
    ["Alignment of IDataAdviseHolderVtbl"]
        [::std::mem::align_of::<IDataAdviseHolderVtbl>() - 8usize];
    ["Offset of field: IDataAdviseHolderVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDataAdviseHolderVtbl::AddRef"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, AddRef) - 8usize];
    ["Offset of field: IDataAdviseHolderVtbl::Release"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, Release) - 16usize];
    ["Offset of field: IDataAdviseHolderVtbl::Advise"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, Advise) - 24usize];
    ["Offset of field: IDataAdviseHolderVtbl::Unadvise"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, Unadvise) - 32usize];
    ["Offset of field: IDataAdviseHolderVtbl::EnumAdvise"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, EnumAdvise) - 40usize];
    ["Offset of field: IDataAdviseHolderVtbl::SendOnDataChange"]
        [::std::mem::offset_of!(IDataAdviseHolderVtbl, SendOnDataChange) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataAdviseHolder {
    pub lpVtbl: *mut IDataAdviseHolderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataAdviseHolder"][::std::mem::size_of::<IDataAdviseHolder>() - 8usize];
    ["Alignment of IDataAdviseHolder"][::std::mem::align_of::<IDataAdviseHolder>() - 8usize];
    ["Offset of field: IDataAdviseHolder::lpVtbl"]
        [::std::mem::offset_of!(IDataAdviseHolder, lpVtbl) - 0usize];
};
pub type LPMESSAGEFILTER = *mut IMessageFilter;
pub const tagCALLTYPE_CALLTYPE_TOPLEVEL: tagCALLTYPE = 1;
pub const tagCALLTYPE_CALLTYPE_NESTED: tagCALLTYPE = 2;
pub const tagCALLTYPE_CALLTYPE_ASYNC: tagCALLTYPE = 3;
pub const tagCALLTYPE_CALLTYPE_TOPLEVEL_CALLPENDING: tagCALLTYPE = 4;
pub const tagCALLTYPE_CALLTYPE_ASYNC_CALLPENDING: tagCALLTYPE = 5;
pub type tagCALLTYPE = ::std::os::raw::c_int;
pub use self::tagCALLTYPE as CALLTYPE;
pub const tagSERVERCALL_SERVERCALL_ISHANDLED: tagSERVERCALL = 0;
pub const tagSERVERCALL_SERVERCALL_REJECTED: tagSERVERCALL = 1;
pub const tagSERVERCALL_SERVERCALL_RETRYLATER: tagSERVERCALL = 2;
pub type tagSERVERCALL = ::std::os::raw::c_int;
pub use self::tagSERVERCALL as SERVERCALL;
pub const tagPENDINGTYPE_PENDINGTYPE_TOPLEVEL: tagPENDINGTYPE = 1;
pub const tagPENDINGTYPE_PENDINGTYPE_NESTED: tagPENDINGTYPE = 2;
pub type tagPENDINGTYPE = ::std::os::raw::c_int;
pub use self::tagPENDINGTYPE as PENDINGTYPE;
pub const tagPENDINGMSG_PENDINGMSG_CANCELCALL: tagPENDINGMSG = 0;
pub const tagPENDINGMSG_PENDINGMSG_WAITNOPROCESS: tagPENDINGMSG = 1;
pub const tagPENDINGMSG_PENDINGMSG_WAITDEFPROCESS: tagPENDINGMSG = 2;
pub type tagPENDINGMSG = ::std::os::raw::c_int;
pub use self::tagPENDINGMSG as PENDINGMSG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagINTERFACEINFO {
    pub pUnk: *mut IUnknown,
    pub iid: IID,
    pub wMethod: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINTERFACEINFO"][::std::mem::size_of::<tagINTERFACEINFO>() - 32usize];
    ["Alignment of tagINTERFACEINFO"][::std::mem::align_of::<tagINTERFACEINFO>() - 8usize];
    ["Offset of field: tagINTERFACEINFO::pUnk"]
        [::std::mem::offset_of!(tagINTERFACEINFO, pUnk) - 0usize];
    ["Offset of field: tagINTERFACEINFO::iid"]
        [::std::mem::offset_of!(tagINTERFACEINFO, iid) - 8usize];
    ["Offset of field: tagINTERFACEINFO::wMethod"]
        [::std::mem::offset_of!(tagINTERFACEINFO, wMethod) - 24usize];
};
pub type INTERFACEINFO = tagINTERFACEINFO;
pub type LPINTERFACEINFO = *mut tagINTERFACEINFO;
unsafe extern "C" {
    pub static IID_IMessageFilter: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMessageFilterVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMessageFilter,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMessageFilter) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMessageFilter) -> ULONG>,
    pub HandleInComingCall: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMessageFilter,
            dwCallType: DWORD,
            htaskCaller: HTASK,
            dwTickCount: DWORD,
            lpInterfaceInfo: LPINTERFACEINFO,
        ) -> DWORD,
    >,
    pub RetryRejectedCall: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMessageFilter,
            htaskCallee: HTASK,
            dwTickCount: DWORD,
            dwRejectType: DWORD,
        ) -> DWORD,
    >,
    pub MessagePending: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMessageFilter,
            htaskCallee: HTASK,
            dwTickCount: DWORD,
            dwPendingType: DWORD,
        ) -> DWORD,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMessageFilterVtbl"][::std::mem::size_of::<IMessageFilterVtbl>() - 48usize];
    ["Alignment of IMessageFilterVtbl"][::std::mem::align_of::<IMessageFilterVtbl>() - 8usize];
    ["Offset of field: IMessageFilterVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMessageFilterVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMessageFilterVtbl::AddRef"]
        [::std::mem::offset_of!(IMessageFilterVtbl, AddRef) - 8usize];
    ["Offset of field: IMessageFilterVtbl::Release"]
        [::std::mem::offset_of!(IMessageFilterVtbl, Release) - 16usize];
    ["Offset of field: IMessageFilterVtbl::HandleInComingCall"]
        [::std::mem::offset_of!(IMessageFilterVtbl, HandleInComingCall) - 24usize];
    ["Offset of field: IMessageFilterVtbl::RetryRejectedCall"]
        [::std::mem::offset_of!(IMessageFilterVtbl, RetryRejectedCall) - 32usize];
    ["Offset of field: IMessageFilterVtbl::MessagePending"]
        [::std::mem::offset_of!(IMessageFilterVtbl, MessagePending) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMessageFilter {
    pub lpVtbl: *mut IMessageFilterVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMessageFilter"][::std::mem::size_of::<IMessageFilter>() - 8usize];
    ["Alignment of IMessageFilter"][::std::mem::align_of::<IMessageFilter>() - 8usize];
    ["Offset of field: IMessageFilter::lpVtbl"]
        [::std::mem::offset_of!(IMessageFilter, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static FMTID_SummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_DocSummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_UserDefinedProperties: FMTID;
}
unsafe extern "C" {
    pub static FMTID_DiscardableInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_ImageSummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_AudioSummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_VideoSummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static FMTID_MediaFileSummaryInformation: FMTID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0077_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0077_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IClassActivator: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClassActivatorVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClassActivator,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IClassActivator) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IClassActivator) -> ULONG>,
    pub GetClassObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IClassActivator,
            rclsid: *const IID,
            dwClassContext: DWORD,
            locale: LCID,
            riid: *const IID,
            ppv: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClassActivatorVtbl"][::std::mem::size_of::<IClassActivatorVtbl>() - 32usize];
    ["Alignment of IClassActivatorVtbl"][::std::mem::align_of::<IClassActivatorVtbl>() - 8usize];
    ["Offset of field: IClassActivatorVtbl::QueryInterface"]
        [::std::mem::offset_of!(IClassActivatorVtbl, QueryInterface) - 0usize];
    ["Offset of field: IClassActivatorVtbl::AddRef"]
        [::std::mem::offset_of!(IClassActivatorVtbl, AddRef) - 8usize];
    ["Offset of field: IClassActivatorVtbl::Release"]
        [::std::mem::offset_of!(IClassActivatorVtbl, Release) - 16usize];
    ["Offset of field: IClassActivatorVtbl::GetClassObject"]
        [::std::mem::offset_of!(IClassActivatorVtbl, GetClassObject) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IClassActivator {
    pub lpVtbl: *mut IClassActivatorVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IClassActivator"][::std::mem::size_of::<IClassActivator>() - 8usize];
    ["Alignment of IClassActivator"][::std::mem::align_of::<IClassActivator>() - 8usize];
    ["Offset of field: IClassActivator::lpVtbl"]
        [::std::mem::offset_of!(IClassActivator, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0078_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0078_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IFillLockBytes: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IFillLockBytesVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IFillLockBytes,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IFillLockBytes) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IFillLockBytes) -> ULONG>,
    pub FillAppend: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IFillLockBytes,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub FillAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IFillLockBytes,
            ulOffset: ULARGE_INTEGER,
            pv: *const ::std::os::raw::c_void,
            cb: ULONG,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub SetFillSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IFillLockBytes, ulSize: ULARGE_INTEGER) -> HRESULT,
    >,
    pub Terminate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IFillLockBytes, bCanceled: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IFillLockBytesVtbl"][::std::mem::size_of::<IFillLockBytesVtbl>() - 56usize];
    ["Alignment of IFillLockBytesVtbl"][::std::mem::align_of::<IFillLockBytesVtbl>() - 8usize];
    ["Offset of field: IFillLockBytesVtbl::QueryInterface"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, QueryInterface) - 0usize];
    ["Offset of field: IFillLockBytesVtbl::AddRef"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, AddRef) - 8usize];
    ["Offset of field: IFillLockBytesVtbl::Release"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, Release) - 16usize];
    ["Offset of field: IFillLockBytesVtbl::FillAppend"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, FillAppend) - 24usize];
    ["Offset of field: IFillLockBytesVtbl::FillAt"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, FillAt) - 32usize];
    ["Offset of field: IFillLockBytesVtbl::SetFillSize"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, SetFillSize) - 40usize];
    ["Offset of field: IFillLockBytesVtbl::Terminate"]
        [::std::mem::offset_of!(IFillLockBytesVtbl, Terminate) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IFillLockBytes {
    pub lpVtbl: *mut IFillLockBytesVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IFillLockBytes"][::std::mem::size_of::<IFillLockBytes>() - 8usize];
    ["Alignment of IFillLockBytes"][::std::mem::align_of::<IFillLockBytes>() - 8usize];
    ["Offset of field: IFillLockBytes::lpVtbl"]
        [::std::mem::offset_of!(IFillLockBytes, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IFillLockBytes_RemoteFillAppend_Proxy(
        This: *mut IFillLockBytes,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_RemoteFillAppend_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IFillLockBytes_RemoteFillAt_Proxy(
        This: *mut IFillLockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_RemoteFillAt_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0079_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0079_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IProgressNotify: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProgressNotifyVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IProgressNotify,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IProgressNotify) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IProgressNotify) -> ULONG>,
    pub OnProgress: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IProgressNotify,
            dwProgressCurrent: DWORD,
            dwProgressMaximum: DWORD,
            fAccurate: BOOL,
            fOwner: BOOL,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProgressNotifyVtbl"][::std::mem::size_of::<IProgressNotifyVtbl>() - 32usize];
    ["Alignment of IProgressNotifyVtbl"][::std::mem::align_of::<IProgressNotifyVtbl>() - 8usize];
    ["Offset of field: IProgressNotifyVtbl::QueryInterface"]
        [::std::mem::offset_of!(IProgressNotifyVtbl, QueryInterface) - 0usize];
    ["Offset of field: IProgressNotifyVtbl::AddRef"]
        [::std::mem::offset_of!(IProgressNotifyVtbl, AddRef) - 8usize];
    ["Offset of field: IProgressNotifyVtbl::Release"]
        [::std::mem::offset_of!(IProgressNotifyVtbl, Release) - 16usize];
    ["Offset of field: IProgressNotifyVtbl::OnProgress"]
        [::std::mem::offset_of!(IProgressNotifyVtbl, OnProgress) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProgressNotify {
    pub lpVtbl: *mut IProgressNotifyVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProgressNotify"][::std::mem::size_of::<IProgressNotify>() - 8usize];
    ["Alignment of IProgressNotify"][::std::mem::align_of::<IProgressNotify>() - 8usize];
    ["Offset of field: IProgressNotify::lpVtbl"]
        [::std::mem::offset_of!(IProgressNotify, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0080_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0080_v0_0_s_ifspec: RPC_IF_HANDLE;
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagStorageLayout {
    pub LayoutType: DWORD,
    pub pwcsElementName: *mut OLECHAR,
    pub cOffset: LARGE_INTEGER,
    pub cBytes: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagStorageLayout"][::std::mem::size_of::<tagStorageLayout>() - 32usize];
    ["Alignment of tagStorageLayout"][::std::mem::align_of::<tagStorageLayout>() - 8usize];
    ["Offset of field: tagStorageLayout::LayoutType"]
        [::std::mem::offset_of!(tagStorageLayout, LayoutType) - 0usize];
    ["Offset of field: tagStorageLayout::pwcsElementName"]
        [::std::mem::offset_of!(tagStorageLayout, pwcsElementName) - 8usize];
    ["Offset of field: tagStorageLayout::cOffset"]
        [::std::mem::offset_of!(tagStorageLayout, cOffset) - 16usize];
    ["Offset of field: tagStorageLayout::cBytes"]
        [::std::mem::offset_of!(tagStorageLayout, cBytes) - 24usize];
};
pub type StorageLayout = tagStorageLayout;
unsafe extern "C" {
    pub static IID_ILayoutStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ILayoutStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILayoutStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ILayoutStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ILayoutStorage) -> ULONG>,
    pub LayoutScript: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ILayoutStorage,
            pStorageLayout: *mut StorageLayout,
            nEntries: DWORD,
            glfInterleavedFlag: DWORD,
        ) -> HRESULT,
    >,
    pub BeginMonitor:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ILayoutStorage) -> HRESULT>,
    pub EndMonitor:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ILayoutStorage) -> HRESULT>,
    pub ReLayoutDocfile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ILayoutStorage, pwcsNewDfName: *mut OLECHAR) -> HRESULT,
    >,
    pub ReLayoutDocfileOnILockBytes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ILayoutStorage, pILockBytes: *mut ILockBytes) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ILayoutStorageVtbl"][::std::mem::size_of::<ILayoutStorageVtbl>() - 64usize];
    ["Alignment of ILayoutStorageVtbl"][::std::mem::align_of::<ILayoutStorageVtbl>() - 8usize];
    ["Offset of field: ILayoutStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: ILayoutStorageVtbl::AddRef"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, AddRef) - 8usize];
    ["Offset of field: ILayoutStorageVtbl::Release"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, Release) - 16usize];
    ["Offset of field: ILayoutStorageVtbl::LayoutScript"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, LayoutScript) - 24usize];
    ["Offset of field: ILayoutStorageVtbl::BeginMonitor"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, BeginMonitor) - 32usize];
    ["Offset of field: ILayoutStorageVtbl::EndMonitor"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, EndMonitor) - 40usize];
    ["Offset of field: ILayoutStorageVtbl::ReLayoutDocfile"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, ReLayoutDocfile) - 48usize];
    ["Offset of field: ILayoutStorageVtbl::ReLayoutDocfileOnILockBytes"]
        [::std::mem::offset_of!(ILayoutStorageVtbl, ReLayoutDocfileOnILockBytes) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ILayoutStorage {
    pub lpVtbl: *mut ILayoutStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ILayoutStorage"][::std::mem::size_of::<ILayoutStorage>() - 8usize];
    ["Alignment of ILayoutStorage"][::std::mem::align_of::<ILayoutStorage>() - 8usize];
    ["Offset of field: ILayoutStorage::lpVtbl"]
        [::std::mem::offset_of!(ILayoutStorage, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0081_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0081_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IBlockingLock: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBlockingLockVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBlockingLock,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBlockingLock) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBlockingLock) -> ULONG>,
    pub Lock: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBlockingLock, dwTimeout: DWORD) -> HRESULT,
    >,
    pub Unlock: ::std::option::Option<unsafe extern "C" fn(This: *mut IBlockingLock) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBlockingLockVtbl"][::std::mem::size_of::<IBlockingLockVtbl>() - 40usize];
    ["Alignment of IBlockingLockVtbl"][::std::mem::align_of::<IBlockingLockVtbl>() - 8usize];
    ["Offset of field: IBlockingLockVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBlockingLockVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBlockingLockVtbl::AddRef"]
        [::std::mem::offset_of!(IBlockingLockVtbl, AddRef) - 8usize];
    ["Offset of field: IBlockingLockVtbl::Release"]
        [::std::mem::offset_of!(IBlockingLockVtbl, Release) - 16usize];
    ["Offset of field: IBlockingLockVtbl::Lock"]
        [::std::mem::offset_of!(IBlockingLockVtbl, Lock) - 24usize];
    ["Offset of field: IBlockingLockVtbl::Unlock"]
        [::std::mem::offset_of!(IBlockingLockVtbl, Unlock) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBlockingLock {
    pub lpVtbl: *mut IBlockingLockVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBlockingLock"][::std::mem::size_of::<IBlockingLock>() - 8usize];
    ["Alignment of IBlockingLock"][::std::mem::align_of::<IBlockingLock>() - 8usize];
    ["Offset of field: IBlockingLock::lpVtbl"]
        [::std::mem::offset_of!(IBlockingLock, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ITimeAndNoticeControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITimeAndNoticeControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITimeAndNoticeControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITimeAndNoticeControl) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITimeAndNoticeControl) -> ULONG>,
    pub SuppressChanges: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITimeAndNoticeControl, res1: DWORD, res2: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITimeAndNoticeControlVtbl"]
        [::std::mem::size_of::<ITimeAndNoticeControlVtbl>() - 32usize];
    ["Alignment of ITimeAndNoticeControlVtbl"]
        [::std::mem::align_of::<ITimeAndNoticeControlVtbl>() - 8usize];
    ["Offset of field: ITimeAndNoticeControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITimeAndNoticeControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITimeAndNoticeControlVtbl::AddRef"]
        [::std::mem::offset_of!(ITimeAndNoticeControlVtbl, AddRef) - 8usize];
    ["Offset of field: ITimeAndNoticeControlVtbl::Release"]
        [::std::mem::offset_of!(ITimeAndNoticeControlVtbl, Release) - 16usize];
    ["Offset of field: ITimeAndNoticeControlVtbl::SuppressChanges"]
        [::std::mem::offset_of!(ITimeAndNoticeControlVtbl, SuppressChanges) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITimeAndNoticeControl {
    pub lpVtbl: *mut ITimeAndNoticeControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITimeAndNoticeControl"][::std::mem::size_of::<ITimeAndNoticeControl>() - 8usize];
    ["Alignment of ITimeAndNoticeControl"]
        [::std::mem::align_of::<ITimeAndNoticeControl>() - 8usize];
    ["Offset of field: ITimeAndNoticeControl::lpVtbl"]
        [::std::mem::offset_of!(ITimeAndNoticeControl, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IOplockStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOplockStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOplockStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOplockStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOplockStorage) -> ULONG>,
    pub CreateStorageEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOplockStorage,
            pwcsName: LPCWSTR,
            grfMode: DWORD,
            stgfmt: DWORD,
            grfAttrs: DWORD,
            riid: *const IID,
            ppstgOpen: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub OpenStorageEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOplockStorage,
            pwcsName: LPCWSTR,
            grfMode: DWORD,
            stgfmt: DWORD,
            grfAttrs: DWORD,
            riid: *const IID,
            ppstgOpen: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOplockStorageVtbl"][::std::mem::size_of::<IOplockStorageVtbl>() - 40usize];
    ["Alignment of IOplockStorageVtbl"][::std::mem::align_of::<IOplockStorageVtbl>() - 8usize];
    ["Offset of field: IOplockStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOplockStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOplockStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IOplockStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IOplockStorageVtbl::Release"]
        [::std::mem::offset_of!(IOplockStorageVtbl, Release) - 16usize];
    ["Offset of field: IOplockStorageVtbl::CreateStorageEx"]
        [::std::mem::offset_of!(IOplockStorageVtbl, CreateStorageEx) - 24usize];
    ["Offset of field: IOplockStorageVtbl::OpenStorageEx"]
        [::std::mem::offset_of!(IOplockStorageVtbl, OpenStorageEx) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOplockStorage {
    pub lpVtbl: *mut IOplockStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOplockStorage"][::std::mem::size_of::<IOplockStorage>() - 8usize];
    ["Alignment of IOplockStorage"][::std::mem::align_of::<IOplockStorage>() - 8usize];
    ["Offset of field: IOplockStorage::lpVtbl"]
        [::std::mem::offset_of!(IOplockStorage, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0084_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0084_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IDirectWriterLock: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDirectWriterLockVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDirectWriterLock,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDirectWriterLock) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDirectWriterLock) -> ULONG>,
    pub WaitForWriteAccess: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDirectWriterLock, dwTimeout: DWORD) -> HRESULT,
    >,
    pub ReleaseWriteAccess:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IDirectWriterLock) -> HRESULT>,
    pub HaveWriteAccess:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IDirectWriterLock) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDirectWriterLockVtbl"][::std::mem::size_of::<IDirectWriterLockVtbl>() - 48usize];
    ["Alignment of IDirectWriterLockVtbl"]
        [::std::mem::align_of::<IDirectWriterLockVtbl>() - 8usize];
    ["Offset of field: IDirectWriterLockVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDirectWriterLockVtbl::AddRef"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, AddRef) - 8usize];
    ["Offset of field: IDirectWriterLockVtbl::Release"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, Release) - 16usize];
    ["Offset of field: IDirectWriterLockVtbl::WaitForWriteAccess"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, WaitForWriteAccess) - 24usize];
    ["Offset of field: IDirectWriterLockVtbl::ReleaseWriteAccess"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, ReleaseWriteAccess) - 32usize];
    ["Offset of field: IDirectWriterLockVtbl::HaveWriteAccess"]
        [::std::mem::offset_of!(IDirectWriterLockVtbl, HaveWriteAccess) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDirectWriterLock {
    pub lpVtbl: *mut IDirectWriterLockVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDirectWriterLock"][::std::mem::size_of::<IDirectWriterLock>() - 8usize];
    ["Alignment of IDirectWriterLock"][::std::mem::align_of::<IDirectWriterLock>() - 8usize];
    ["Offset of field: IDirectWriterLock::lpVtbl"]
        [::std::mem::offset_of!(IDirectWriterLock, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0085_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0085_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IUrlMon: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUrlMonVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUrlMon,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUrlMon) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IUrlMon) -> ULONG>,
    pub AsyncGetClassBits: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUrlMon,
            rclsid: *const IID,
            pszTYPE: LPCWSTR,
            pszExt: LPCWSTR,
            dwFileVersionMS: DWORD,
            dwFileVersionLS: DWORD,
            pszCodeBase: LPCWSTR,
            pbc: *mut IBindCtx,
            dwClassContext: DWORD,
            riid: *const IID,
            flags: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUrlMonVtbl"][::std::mem::size_of::<IUrlMonVtbl>() - 32usize];
    ["Alignment of IUrlMonVtbl"][::std::mem::align_of::<IUrlMonVtbl>() - 8usize];
    ["Offset of field: IUrlMonVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUrlMonVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUrlMonVtbl::AddRef"][::std::mem::offset_of!(IUrlMonVtbl, AddRef) - 8usize];
    ["Offset of field: IUrlMonVtbl::Release"]
        [::std::mem::offset_of!(IUrlMonVtbl, Release) - 16usize];
    ["Offset of field: IUrlMonVtbl::AsyncGetClassBits"]
        [::std::mem::offset_of!(IUrlMonVtbl, AsyncGetClassBits) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUrlMon {
    pub lpVtbl: *mut IUrlMonVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUrlMon"][::std::mem::size_of::<IUrlMon>() - 8usize];
    ["Alignment of IUrlMon"][::std::mem::align_of::<IUrlMon>() - 8usize];
    ["Offset of field: IUrlMon::lpVtbl"][::std::mem::offset_of!(IUrlMon, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IForegroundTransfer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IForegroundTransferVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IForegroundTransfer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IForegroundTransfer) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IForegroundTransfer) -> ULONG>,
    pub AllowForegroundTransfer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IForegroundTransfer,
            lpvReserved: *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IForegroundTransferVtbl"][::std::mem::size_of::<IForegroundTransferVtbl>() - 32usize];
    ["Alignment of IForegroundTransferVtbl"]
        [::std::mem::align_of::<IForegroundTransferVtbl>() - 8usize];
    ["Offset of field: IForegroundTransferVtbl::QueryInterface"]
        [::std::mem::offset_of!(IForegroundTransferVtbl, QueryInterface) - 0usize];
    ["Offset of field: IForegroundTransferVtbl::AddRef"]
        [::std::mem::offset_of!(IForegroundTransferVtbl, AddRef) - 8usize];
    ["Offset of field: IForegroundTransferVtbl::Release"]
        [::std::mem::offset_of!(IForegroundTransferVtbl, Release) - 16usize];
    ["Offset of field: IForegroundTransferVtbl::AllowForegroundTransfer"]
        [::std::mem::offset_of!(IForegroundTransferVtbl, AllowForegroundTransfer) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IForegroundTransfer {
    pub lpVtbl: *mut IForegroundTransferVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IForegroundTransfer"][::std::mem::size_of::<IForegroundTransfer>() - 8usize];
    ["Alignment of IForegroundTransfer"][::std::mem::align_of::<IForegroundTransfer>() - 8usize];
    ["Offset of field: IForegroundTransfer::lpVtbl"]
        [::std::mem::offset_of!(IForegroundTransfer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IThumbnailExtractor: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IThumbnailExtractorVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IThumbnailExtractor,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IThumbnailExtractor) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IThumbnailExtractor) -> ULONG>,
    pub ExtractThumbnail: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IThumbnailExtractor,
            pStg: *mut IStorage,
            ulLength: ULONG,
            ulHeight: ULONG,
            pulOutputLength: *mut ULONG,
            pulOutputHeight: *mut ULONG,
            phOutputBitmap: *mut HBITMAP,
        ) -> HRESULT,
    >,
    pub OnFileUpdated: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IThumbnailExtractor, pStg: *mut IStorage) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IThumbnailExtractorVtbl"][::std::mem::size_of::<IThumbnailExtractorVtbl>() - 40usize];
    ["Alignment of IThumbnailExtractorVtbl"]
        [::std::mem::align_of::<IThumbnailExtractorVtbl>() - 8usize];
    ["Offset of field: IThumbnailExtractorVtbl::QueryInterface"]
        [::std::mem::offset_of!(IThumbnailExtractorVtbl, QueryInterface) - 0usize];
    ["Offset of field: IThumbnailExtractorVtbl::AddRef"]
        [::std::mem::offset_of!(IThumbnailExtractorVtbl, AddRef) - 8usize];
    ["Offset of field: IThumbnailExtractorVtbl::Release"]
        [::std::mem::offset_of!(IThumbnailExtractorVtbl, Release) - 16usize];
    ["Offset of field: IThumbnailExtractorVtbl::ExtractThumbnail"]
        [::std::mem::offset_of!(IThumbnailExtractorVtbl, ExtractThumbnail) - 24usize];
    ["Offset of field: IThumbnailExtractorVtbl::OnFileUpdated"]
        [::std::mem::offset_of!(IThumbnailExtractorVtbl, OnFileUpdated) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IThumbnailExtractor {
    pub lpVtbl: *mut IThumbnailExtractorVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IThumbnailExtractor"][::std::mem::size_of::<IThumbnailExtractor>() - 8usize];
    ["Alignment of IThumbnailExtractor"][::std::mem::align_of::<IThumbnailExtractor>() - 8usize];
    ["Offset of field: IThumbnailExtractor::lpVtbl"]
        [::std::mem::offset_of!(IThumbnailExtractor, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IDummyHICONIncluder: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDummyHICONIncluderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDummyHICONIncluder,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IDummyHICONIncluder) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IDummyHICONIncluder) -> ULONG>,
    pub Dummy: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDummyHICONIncluder, h1: HICON, h2: HDC) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDummyHICONIncluderVtbl"][::std::mem::size_of::<IDummyHICONIncluderVtbl>() - 32usize];
    ["Alignment of IDummyHICONIncluderVtbl"]
        [::std::mem::align_of::<IDummyHICONIncluderVtbl>() - 8usize];
    ["Offset of field: IDummyHICONIncluderVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDummyHICONIncluderVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDummyHICONIncluderVtbl::AddRef"]
        [::std::mem::offset_of!(IDummyHICONIncluderVtbl, AddRef) - 8usize];
    ["Offset of field: IDummyHICONIncluderVtbl::Release"]
        [::std::mem::offset_of!(IDummyHICONIncluderVtbl, Release) - 16usize];
    ["Offset of field: IDummyHICONIncluderVtbl::Dummy"]
        [::std::mem::offset_of!(IDummyHICONIncluderVtbl, Dummy) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDummyHICONIncluder {
    pub lpVtbl: *mut IDummyHICONIncluderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDummyHICONIncluder"][::std::mem::size_of::<IDummyHICONIncluder>() - 8usize];
    ["Alignment of IDummyHICONIncluder"][::std::mem::align_of::<IDummyHICONIncluder>() - 8usize];
    ["Offset of field: IDummyHICONIncluder::lpVtbl"]
        [::std::mem::offset_of!(IDummyHICONIncluder, lpVtbl) - 0usize];
};
pub const tagApplicationType_ServerApplication: tagApplicationType = 0;
pub const tagApplicationType_LibraryApplication: tagApplicationType = 1;
pub type tagApplicationType = ::std::os::raw::c_int;
pub use self::tagApplicationType as ApplicationType;
pub const tagShutdownType_IdleShutdown: tagShutdownType = 0;
pub const tagShutdownType_ForcedShutdown: tagShutdownType = 1;
pub type tagShutdownType = ::std::os::raw::c_int;
pub use self::tagShutdownType as ShutdownType;
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0089_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0089_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IProcessLock: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProcessLockVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IProcessLock,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessLock) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessLock) -> ULONG>,
    pub AddRefOnProcess:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessLock) -> ULONG>,
    pub ReleaseRefOnProcess:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IProcessLock) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProcessLockVtbl"][::std::mem::size_of::<IProcessLockVtbl>() - 40usize];
    ["Alignment of IProcessLockVtbl"][::std::mem::align_of::<IProcessLockVtbl>() - 8usize];
    ["Offset of field: IProcessLockVtbl::QueryInterface"]
        [::std::mem::offset_of!(IProcessLockVtbl, QueryInterface) - 0usize];
    ["Offset of field: IProcessLockVtbl::AddRef"]
        [::std::mem::offset_of!(IProcessLockVtbl, AddRef) - 8usize];
    ["Offset of field: IProcessLockVtbl::Release"]
        [::std::mem::offset_of!(IProcessLockVtbl, Release) - 16usize];
    ["Offset of field: IProcessLockVtbl::AddRefOnProcess"]
        [::std::mem::offset_of!(IProcessLockVtbl, AddRefOnProcess) - 24usize];
    ["Offset of field: IProcessLockVtbl::ReleaseRefOnProcess"]
        [::std::mem::offset_of!(IProcessLockVtbl, ReleaseRefOnProcess) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IProcessLock {
    pub lpVtbl: *mut IProcessLockVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IProcessLock"][::std::mem::size_of::<IProcessLock>() - 8usize];
    ["Alignment of IProcessLock"][::std::mem::align_of::<IProcessLock>() - 8usize];
    ["Offset of field: IProcessLock::lpVtbl"]
        [::std::mem::offset_of!(IProcessLock, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ISurrogateService: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISurrogateServiceVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISurrogateService,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISurrogateService) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISurrogateService) -> ULONG>,
    pub Init: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISurrogateService,
            rguidProcessID: *const GUID,
            pProcessLock: *mut IProcessLock,
            pfApplicationAware: *mut BOOL,
        ) -> HRESULT,
    >,
    pub ApplicationLaunch: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISurrogateService,
            rguidApplID: *const GUID,
            appType: ApplicationType,
        ) -> HRESULT,
    >,
    pub ApplicationFree: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISurrogateService, rguidApplID: *const GUID) -> HRESULT,
    >,
    pub CatalogRefresh: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISurrogateService, ulReserved: ULONG) -> HRESULT,
    >,
    pub ProcessShutdown: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISurrogateService, shutdownType: ShutdownType) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISurrogateServiceVtbl"][::std::mem::size_of::<ISurrogateServiceVtbl>() - 64usize];
    ["Alignment of ISurrogateServiceVtbl"]
        [::std::mem::align_of::<ISurrogateServiceVtbl>() - 8usize];
    ["Offset of field: ISurrogateServiceVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISurrogateServiceVtbl::AddRef"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, AddRef) - 8usize];
    ["Offset of field: ISurrogateServiceVtbl::Release"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, Release) - 16usize];
    ["Offset of field: ISurrogateServiceVtbl::Init"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, Init) - 24usize];
    ["Offset of field: ISurrogateServiceVtbl::ApplicationLaunch"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, ApplicationLaunch) - 32usize];
    ["Offset of field: ISurrogateServiceVtbl::ApplicationFree"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, ApplicationFree) - 40usize];
    ["Offset of field: ISurrogateServiceVtbl::CatalogRefresh"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, CatalogRefresh) - 48usize];
    ["Offset of field: ISurrogateServiceVtbl::ProcessShutdown"]
        [::std::mem::offset_of!(ISurrogateServiceVtbl, ProcessShutdown) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISurrogateService {
    pub lpVtbl: *mut ISurrogateServiceVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISurrogateService"][::std::mem::size_of::<ISurrogateService>() - 8usize];
    ["Alignment of ISurrogateService"][::std::mem::align_of::<ISurrogateService>() - 8usize];
    ["Offset of field: ISurrogateService::lpVtbl"]
        [::std::mem::offset_of!(ISurrogateService, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0091_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0091_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPINITIALIZESPY = *mut IInitializeSpy;
unsafe extern "C" {
    pub static IID_IInitializeSpy: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInitializeSpyVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInitializeSpy,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInitializeSpy) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInitializeSpy) -> ULONG>,
    pub PreInitialize: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInitializeSpy,
            dwCoInit: DWORD,
            dwCurThreadAptRefs: DWORD,
        ) -> HRESULT,
    >,
    pub PostInitialize: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInitializeSpy,
            hrCoInit: HRESULT,
            dwCoInit: DWORD,
            dwNewThreadAptRefs: DWORD,
        ) -> HRESULT,
    >,
    pub PreUninitialize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInitializeSpy, dwCurThreadAptRefs: DWORD) -> HRESULT,
    >,
    pub PostUninitialize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInitializeSpy, dwNewThreadAptRefs: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInitializeSpyVtbl"][::std::mem::size_of::<IInitializeSpyVtbl>() - 56usize];
    ["Alignment of IInitializeSpyVtbl"][::std::mem::align_of::<IInitializeSpyVtbl>() - 8usize];
    ["Offset of field: IInitializeSpyVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInitializeSpyVtbl::AddRef"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, AddRef) - 8usize];
    ["Offset of field: IInitializeSpyVtbl::Release"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, Release) - 16usize];
    ["Offset of field: IInitializeSpyVtbl::PreInitialize"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, PreInitialize) - 24usize];
    ["Offset of field: IInitializeSpyVtbl::PostInitialize"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, PostInitialize) - 32usize];
    ["Offset of field: IInitializeSpyVtbl::PreUninitialize"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, PreUninitialize) - 40usize];
    ["Offset of field: IInitializeSpyVtbl::PostUninitialize"]
        [::std::mem::offset_of!(IInitializeSpyVtbl, PostUninitialize) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInitializeSpy {
    pub lpVtbl: *mut IInitializeSpyVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInitializeSpy"][::std::mem::size_of::<IInitializeSpy>() - 8usize];
    ["Alignment of IInitializeSpy"][::std::mem::align_of::<IInitializeSpy>() - 8usize];
    ["Offset of field: IInitializeSpy::lpVtbl"]
        [::std::mem::offset_of!(IInitializeSpy, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0092_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0092_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IApartmentShutdown: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IApartmentShutdownVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IApartmentShutdown,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IApartmentShutdown) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IApartmentShutdown) -> ULONG>,
    pub OnUninitialize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IApartmentShutdown, ui64ApartmentIdentifier: UINT64),
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IApartmentShutdownVtbl"][::std::mem::size_of::<IApartmentShutdownVtbl>() - 32usize];
    ["Alignment of IApartmentShutdownVtbl"]
        [::std::mem::align_of::<IApartmentShutdownVtbl>() - 8usize];
    ["Offset of field: IApartmentShutdownVtbl::QueryInterface"]
        [::std::mem::offset_of!(IApartmentShutdownVtbl, QueryInterface) - 0usize];
    ["Offset of field: IApartmentShutdownVtbl::AddRef"]
        [::std::mem::offset_of!(IApartmentShutdownVtbl, AddRef) - 8usize];
    ["Offset of field: IApartmentShutdownVtbl::Release"]
        [::std::mem::offset_of!(IApartmentShutdownVtbl, Release) - 16usize];
    ["Offset of field: IApartmentShutdownVtbl::OnUninitialize"]
        [::std::mem::offset_of!(IApartmentShutdownVtbl, OnUninitialize) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IApartmentShutdown {
    pub lpVtbl: *mut IApartmentShutdownVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IApartmentShutdown"][::std::mem::size_of::<IApartmentShutdown>() - 8usize];
    ["Alignment of IApartmentShutdown"][::std::mem::align_of::<IApartmentShutdown>() - 8usize];
    ["Offset of field: IApartmentShutdown::lpVtbl"]
        [::std::mem::offset_of!(IApartmentShutdown, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0093_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_objidl_0000_0093_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut ASYNC_STGMEDIUM);
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut CLIPFORMAT,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLIPFORMAT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLIPFORMAT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut CLIPFORMAT);
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut FLAG_STGMEDIUM);
}
unsafe extern "C" {
    pub fn HBITMAP_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HBITMAP,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HBITMAP_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HBITMAP,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HBITMAP_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HBITMAP,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HBITMAP_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HBITMAP);
}
unsafe extern "C" {
    pub fn HDC_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HDC,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HDC_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HDC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HDC_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HDC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HDC_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HDC);
}
unsafe extern "C" {
    pub fn HICON_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HICON,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HICON_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HICON,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HICON_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HICON,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HICON_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HICON);
}
unsafe extern "C" {
    pub fn SNB_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut SNB,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn SNB_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut SNB,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn SNB_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut SNB,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn SNB_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut SNB);
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut STGMEDIUM);
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut ASYNC_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn ASYNC_STGMEDIUM_UserFree64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ASYNC_STGMEDIUM,
    );
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut CLIPFORMAT,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLIPFORMAT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLIPFORMAT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLIPFORMAT_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut CLIPFORMAT);
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut FLAG_STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn FLAG_STGMEDIUM_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut FLAG_STGMEDIUM);
}
unsafe extern "C" {
    pub fn HBITMAP_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HBITMAP,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HBITMAP_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HBITMAP,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HBITMAP_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HBITMAP,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HBITMAP_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HBITMAP);
}
unsafe extern "C" {
    pub fn HDC_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HDC,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HDC_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HDC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HDC_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HDC,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HDC_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HDC);
}
unsafe extern "C" {
    pub fn HICON_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HICON,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HICON_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HICON,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HICON_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HICON,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HICON_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HICON);
}
unsafe extern "C" {
    pub fn SNB_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut SNB,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn SNB_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut SNB,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn SNB_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut SNB,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn SNB_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut SNB);
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut STGMEDIUM,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut STGMEDIUM,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn STGMEDIUM_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut STGMEDIUM);
}
unsafe extern "C" {
    pub fn IBindCtx_SetBindOptions_Proxy(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindCtx_SetBindOptions_Stub(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS2)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindCtx_GetBindOptions_Proxy(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindCtx_GetBindOptions_Stub(This: *mut IBindCtx, pbindopts: *mut BIND_OPTS2)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumMoniker_Next_Proxy(
        This: *mut IEnumMoniker,
        celt: ULONG,
        rgelt: *mut *mut IMoniker,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumMoniker_Next_Stub(
        This: *mut IEnumMoniker,
        celt: ULONG,
        rgelt: *mut *mut IMoniker,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IRunnableObject_IsRunning_Proxy(This: *mut IRunnableObject) -> BOOL;
}
unsafe extern "C" {
    pub fn IRunnableObject_IsRunning_Stub(This: *mut IRunnableObject) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_BindToObject_Proxy(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riidResult: *const IID,
        ppvResult: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_BindToObject_Stub(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riidResult: *const IID,
        ppvResult: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_BindToStorage_Proxy(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riid: *const IID,
        ppvObj: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IMoniker_BindToStorage_Stub(
        This: *mut IMoniker,
        pbc: *mut IBindCtx,
        pmkToLeft: *mut IMoniker,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATSTG_Next_Proxy(
        This: *mut IEnumSTATSTG,
        celt: ULONG,
        rgelt: *mut STATSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATSTG_Next_Stub(
        This: *mut IEnumSTATSTG,
        celt: ULONG,
        rgelt: *mut STATSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_OpenStream_Proxy(
        This: *mut IStorage,
        pwcsName: *const OLECHAR,
        reserved1: *mut ::std::os::raw::c_void,
        grfMode: DWORD,
        reserved2: DWORD,
        ppstm: *mut *mut IStream,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_OpenStream_Stub(
        This: *mut IStorage,
        pwcsName: *const OLECHAR,
        cbReserved1: ULONG,
        reserved1: *mut byte,
        grfMode: DWORD,
        reserved2: DWORD,
        ppstm: *mut *mut IStream,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_CopyTo_Proxy(
        This: *mut IStorage,
        ciidExclude: DWORD,
        rgiidExclude: *const IID,
        snbExclude: SNB,
        pstgDest: *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_CopyTo_Stub(
        This: *mut IStorage,
        ciidExclude: DWORD,
        rgiidExclude: *const IID,
        snbExclude: SNB,
        pstgDest: *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_EnumElements_Proxy(
        This: *mut IStorage,
        reserved1: DWORD,
        reserved2: *mut ::std::os::raw::c_void,
        reserved3: DWORD,
        ppenum: *mut *mut IEnumSTATSTG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IStorage_EnumElements_Stub(
        This: *mut IStorage,
        reserved1: DWORD,
        cbReserved2: ULONG,
        reserved2: *mut byte,
        reserved3: DWORD,
        ppenum: *mut *mut IEnumSTATSTG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_ReadAt_Proxy(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *mut ::std::os::raw::c_void,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_ReadAt_Stub(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *mut byte,
        cb: ULONG,
        pcbRead: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_WriteAt_Proxy(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const ::std::os::raw::c_void,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ILockBytes_WriteAt_Stub(
        This: *mut ILockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumFORMATETC_Next_Proxy(
        This: *mut IEnumFORMATETC,
        celt: ULONG,
        rgelt: *mut FORMATETC,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumFORMATETC_Next_Stub(
        This: *mut IEnumFORMATETC,
        celt: ULONG,
        rgelt: *mut FORMATETC,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATDATA_Next_Proxy(
        This: *mut IEnumSTATDATA,
        celt: ULONG,
        rgelt: *mut STATDATA,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATDATA_Next_Stub(
        This: *mut IEnumSTATDATA,
        celt: ULONG,
        rgelt: *mut STATDATA,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_OnDataChange_Proxy(
        This: *mut IAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut STGMEDIUM,
    );
}
unsafe extern "C" {
    pub fn IAdviseSink_OnDataChange_Stub(
        This: *mut IAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut ASYNC_STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_OnViewChange_Proxy(This: *mut IAdviseSink, dwAspect: DWORD, lindex: LONG);
}
unsafe extern "C" {
    pub fn IAdviseSink_OnViewChange_Stub(
        This: *mut IAdviseSink,
        dwAspect: DWORD,
        lindex: LONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_OnRename_Proxy(This: *mut IAdviseSink, pmk: *mut IMoniker);
}
unsafe extern "C" {
    pub fn IAdviseSink_OnRename_Stub(This: *mut IAdviseSink, pmk: *mut IMoniker) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_OnSave_Proxy(This: *mut IAdviseSink);
}
unsafe extern "C" {
    pub fn IAdviseSink_OnSave_Stub(This: *mut IAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink_OnClose_Proxy(This: *mut IAdviseSink);
}
unsafe extern "C" {
    pub fn IAdviseSink_OnClose_Stub(This: *mut IAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnDataChange_Proxy(
        This: *mut AsyncIAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut STGMEDIUM,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnDataChange_Stub(
        This: *mut AsyncIAdviseSink,
        pFormatetc: *mut FORMATETC,
        pStgmed: *mut ASYNC_STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnDataChange_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnDataChange_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnViewChange_Proxy(
        This: *mut AsyncIAdviseSink,
        dwAspect: DWORD,
        lindex: LONG,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnViewChange_Stub(
        This: *mut AsyncIAdviseSink,
        dwAspect: DWORD,
        lindex: LONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnViewChange_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnViewChange_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnRename_Proxy(This: *mut AsyncIAdviseSink, pmk: *mut IMoniker);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnRename_Stub(
        This: *mut AsyncIAdviseSink,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnRename_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnRename_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnSave_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnSave_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnSave_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnSave_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnClose_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Begin_OnClose_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnClose_Proxy(This: *mut AsyncIAdviseSink);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink_Finish_OnClose_Stub(This: *mut AsyncIAdviseSink) -> HRESULT;
}
unsafe extern "C" {
    pub fn IAdviseSink2_OnLinkSrcChange_Proxy(This: *mut IAdviseSink2, pmk: *mut IMoniker);
}
unsafe extern "C" {
    pub fn IAdviseSink2_OnLinkSrcChange_Stub(
        This: *mut IAdviseSink2,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Begin_OnLinkSrcChange_Proxy(
        This: *mut AsyncIAdviseSink2,
        pmk: *mut IMoniker,
    );
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Begin_OnLinkSrcChange_Stub(
        This: *mut AsyncIAdviseSink2,
        pmk: *mut IMoniker,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Finish_OnLinkSrcChange_Proxy(This: *mut AsyncIAdviseSink2);
}
unsafe extern "C" {
    pub fn AsyncIAdviseSink2_Finish_OnLinkSrcChange_Stub(This: *mut AsyncIAdviseSink2) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_GetData_Proxy(
        This: *mut IDataObject,
        pformatetcIn: *mut FORMATETC,
        pmedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_GetData_Stub(
        This: *mut IDataObject,
        pformatetcIn: *mut FORMATETC,
        pRemoteMedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_GetDataHere_Proxy(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pmedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_GetDataHere_Stub(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pRemoteMedium: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_SetData_Proxy(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pmedium: *mut STGMEDIUM,
        fRelease: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDataObject_SetData_Stub(
        This: *mut IDataObject,
        pformatetc: *mut FORMATETC,
        pmedium: *mut FLAG_STGMEDIUM,
        fRelease: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_FillAppend_Proxy(
        This: *mut IFillLockBytes,
        pv: *const ::std::os::raw::c_void,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_FillAppend_Stub(
        This: *mut IFillLockBytes,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_FillAt_Proxy(
        This: *mut IFillLockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const ::std::os::raw::c_void,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IFillLockBytes_FillAt_Stub(
        This: *mut IFillLockBytes,
        ulOffset: ULARGE_INTEGER,
        pv: *const byte,
        cb: ULONG,
        pcbWritten: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type CURRENCY = CY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSAFEARRAYBOUND {
    pub cElements: ULONG,
    pub lLbound: LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSAFEARRAYBOUND"][::std::mem::size_of::<tagSAFEARRAYBOUND>() - 8usize];
    ["Alignment of tagSAFEARRAYBOUND"][::std::mem::align_of::<tagSAFEARRAYBOUND>() - 4usize];
    ["Offset of field: tagSAFEARRAYBOUND::cElements"]
        [::std::mem::offset_of!(tagSAFEARRAYBOUND, cElements) - 0usize];
    ["Offset of field: tagSAFEARRAYBOUND::lLbound"]
        [::std::mem::offset_of!(tagSAFEARRAYBOUND, lLbound) - 4usize];
};
pub type SAFEARRAYBOUND = tagSAFEARRAYBOUND;
pub type LPSAFEARRAYBOUND = *mut tagSAFEARRAYBOUND;
pub type wireVARIANT = *mut _wireVARIANT;
pub type wireBRECORD = *mut _wireBRECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_BSTR {
    pub Size: ULONG,
    pub aBstr: *mut wireBSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_BSTR"][::std::mem::size_of::<_wireSAFEARR_BSTR>() - 16usize];
    ["Alignment of _wireSAFEARR_BSTR"][::std::mem::align_of::<_wireSAFEARR_BSTR>() - 8usize];
    ["Offset of field: _wireSAFEARR_BSTR::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_BSTR, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_BSTR::aBstr"]
        [::std::mem::offset_of!(_wireSAFEARR_BSTR, aBstr) - 8usize];
};
pub type SAFEARR_BSTR = _wireSAFEARR_BSTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_UNKNOWN {
    pub Size: ULONG,
    pub apUnknown: *mut *mut IUnknown,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_UNKNOWN"][::std::mem::size_of::<_wireSAFEARR_UNKNOWN>() - 16usize];
    ["Alignment of _wireSAFEARR_UNKNOWN"][::std::mem::align_of::<_wireSAFEARR_UNKNOWN>() - 8usize];
    ["Offset of field: _wireSAFEARR_UNKNOWN::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_UNKNOWN, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_UNKNOWN::apUnknown"]
        [::std::mem::offset_of!(_wireSAFEARR_UNKNOWN, apUnknown) - 8usize];
};
pub type SAFEARR_UNKNOWN = _wireSAFEARR_UNKNOWN;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_DISPATCH {
    pub Size: ULONG,
    pub apDispatch: *mut *mut IDispatch,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_DISPATCH"][::std::mem::size_of::<_wireSAFEARR_DISPATCH>() - 16usize];
    ["Alignment of _wireSAFEARR_DISPATCH"]
        [::std::mem::align_of::<_wireSAFEARR_DISPATCH>() - 8usize];
    ["Offset of field: _wireSAFEARR_DISPATCH::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_DISPATCH, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_DISPATCH::apDispatch"]
        [::std::mem::offset_of!(_wireSAFEARR_DISPATCH, apDispatch) - 8usize];
};
pub type SAFEARR_DISPATCH = _wireSAFEARR_DISPATCH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_VARIANT {
    pub Size: ULONG,
    pub aVariant: *mut wireVARIANT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_VARIANT"][::std::mem::size_of::<_wireSAFEARR_VARIANT>() - 16usize];
    ["Alignment of _wireSAFEARR_VARIANT"][::std::mem::align_of::<_wireSAFEARR_VARIANT>() - 8usize];
    ["Offset of field: _wireSAFEARR_VARIANT::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_VARIANT, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_VARIANT::aVariant"]
        [::std::mem::offset_of!(_wireSAFEARR_VARIANT, aVariant) - 8usize];
};
pub type SAFEARR_VARIANT = _wireSAFEARR_VARIANT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_BRECORD {
    pub Size: ULONG,
    pub aRecord: *mut wireBRECORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_BRECORD"][::std::mem::size_of::<_wireSAFEARR_BRECORD>() - 16usize];
    ["Alignment of _wireSAFEARR_BRECORD"][::std::mem::align_of::<_wireSAFEARR_BRECORD>() - 8usize];
    ["Offset of field: _wireSAFEARR_BRECORD::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_BRECORD, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_BRECORD::aRecord"]
        [::std::mem::offset_of!(_wireSAFEARR_BRECORD, aRecord) - 8usize];
};
pub type SAFEARR_BRECORD = _wireSAFEARR_BRECORD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireSAFEARR_HAVEIID {
    pub Size: ULONG,
    pub apUnknown: *mut *mut IUnknown,
    pub iid: IID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARR_HAVEIID"][::std::mem::size_of::<_wireSAFEARR_HAVEIID>() - 32usize];
    ["Alignment of _wireSAFEARR_HAVEIID"][::std::mem::align_of::<_wireSAFEARR_HAVEIID>() - 8usize];
    ["Offset of field: _wireSAFEARR_HAVEIID::Size"]
        [::std::mem::offset_of!(_wireSAFEARR_HAVEIID, Size) - 0usize];
    ["Offset of field: _wireSAFEARR_HAVEIID::apUnknown"]
        [::std::mem::offset_of!(_wireSAFEARR_HAVEIID, apUnknown) - 8usize];
    ["Offset of field: _wireSAFEARR_HAVEIID::iid"]
        [::std::mem::offset_of!(_wireSAFEARR_HAVEIID, iid) - 16usize];
};
pub type SAFEARR_HAVEIID = _wireSAFEARR_HAVEIID;
pub const tagSF_TYPE_SF_ERROR: tagSF_TYPE = 10;
pub const tagSF_TYPE_SF_I1: tagSF_TYPE = 16;
pub const tagSF_TYPE_SF_I2: tagSF_TYPE = 2;
pub const tagSF_TYPE_SF_I4: tagSF_TYPE = 3;
pub const tagSF_TYPE_SF_I8: tagSF_TYPE = 20;
pub const tagSF_TYPE_SF_BSTR: tagSF_TYPE = 8;
pub const tagSF_TYPE_SF_UNKNOWN: tagSF_TYPE = 13;
pub const tagSF_TYPE_SF_DISPATCH: tagSF_TYPE = 9;
pub const tagSF_TYPE_SF_VARIANT: tagSF_TYPE = 12;
pub const tagSF_TYPE_SF_RECORD: tagSF_TYPE = 36;
pub const tagSF_TYPE_SF_HAVEIID: tagSF_TYPE = 32781;
pub type tagSF_TYPE = ::std::os::raw::c_int;
pub use self::tagSF_TYPE as SF_TYPE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _wireSAFEARRAY_UNION {
    pub sfType: ULONG,
    pub u: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001 {
    pub BstrStr: SAFEARR_BSTR,
    pub UnknownStr: SAFEARR_UNKNOWN,
    pub DispatchStr: SAFEARR_DISPATCH,
    pub VariantStr: SAFEARR_VARIANT,
    pub RecordStr: SAFEARR_BRECORD,
    pub HaveIidStr: SAFEARR_HAVEIID,
    pub ByteStr: BYTE_SIZEDARR,
    pub WordStr: WORD_SIZEDARR,
    pub LongStr: DWORD_SIZEDARR,
    pub HyperStr: HYPER_SIZEDARR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001"]
        [::std::mem::size_of::<_wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001>() - 32usize];
    ["Alignment of _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001"]
        [::std::mem::align_of::<_wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001>() - 8usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::BstrStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        BstrStr
    ) - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::UnknownStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        UnknownStr
    )
        - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::DispatchStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        DispatchStr
    )
        - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::VariantStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        VariantStr
    )
        - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::RecordStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        RecordStr
    )
        - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::HaveIidStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        HaveIidStr
    )
        - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::ByteStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        ByteStr
    ) - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::WordStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        WordStr
    ) - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::LongStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        LongStr
    ) - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001::HyperStr"][::std::mem::offset_of!(
        _wireSAFEARRAY_UNION___MIDL_IOleAutomationTypes_0001,
        HyperStr
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARRAY_UNION"][::std::mem::size_of::<_wireSAFEARRAY_UNION>() - 40usize];
    ["Alignment of _wireSAFEARRAY_UNION"][::std::mem::align_of::<_wireSAFEARRAY_UNION>() - 8usize];
    ["Offset of field: _wireSAFEARRAY_UNION::sfType"]
        [::std::mem::offset_of!(_wireSAFEARRAY_UNION, sfType) - 0usize];
    ["Offset of field: _wireSAFEARRAY_UNION::u"]
        [::std::mem::offset_of!(_wireSAFEARRAY_UNION, u) - 8usize];
};
pub type SAFEARRAYUNION = _wireSAFEARRAY_UNION;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _wireSAFEARRAY {
    pub cDims: USHORT,
    pub fFeatures: USHORT,
    pub cbElements: ULONG,
    pub cLocks: ULONG,
    pub uArrayStructs: SAFEARRAYUNION,
    pub rgsabound: [SAFEARRAYBOUND; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireSAFEARRAY"][::std::mem::size_of::<_wireSAFEARRAY>() - 64usize];
    ["Alignment of _wireSAFEARRAY"][::std::mem::align_of::<_wireSAFEARRAY>() - 8usize];
    ["Offset of field: _wireSAFEARRAY::cDims"]
        [::std::mem::offset_of!(_wireSAFEARRAY, cDims) - 0usize];
    ["Offset of field: _wireSAFEARRAY::fFeatures"]
        [::std::mem::offset_of!(_wireSAFEARRAY, fFeatures) - 2usize];
    ["Offset of field: _wireSAFEARRAY::cbElements"]
        [::std::mem::offset_of!(_wireSAFEARRAY, cbElements) - 4usize];
    ["Offset of field: _wireSAFEARRAY::cLocks"]
        [::std::mem::offset_of!(_wireSAFEARRAY, cLocks) - 8usize];
    ["Offset of field: _wireSAFEARRAY::uArrayStructs"]
        [::std::mem::offset_of!(_wireSAFEARRAY, uArrayStructs) - 16usize];
    ["Offset of field: _wireSAFEARRAY::rgsabound"]
        [::std::mem::offset_of!(_wireSAFEARRAY, rgsabound) - 56usize];
};
pub type wireSAFEARRAY = *mut _wireSAFEARRAY;
pub type wirePSAFEARRAY = *mut wireSAFEARRAY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSAFEARRAY {
    pub cDims: USHORT,
    pub fFeatures: USHORT,
    pub cbElements: ULONG,
    pub cLocks: ULONG,
    pub pvData: PVOID,
    pub rgsabound: [SAFEARRAYBOUND; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSAFEARRAY"][::std::mem::size_of::<tagSAFEARRAY>() - 32usize];
    ["Alignment of tagSAFEARRAY"][::std::mem::align_of::<tagSAFEARRAY>() - 8usize];
    ["Offset of field: tagSAFEARRAY::cDims"][::std::mem::offset_of!(tagSAFEARRAY, cDims) - 0usize];
    ["Offset of field: tagSAFEARRAY::fFeatures"]
        [::std::mem::offset_of!(tagSAFEARRAY, fFeatures) - 2usize];
    ["Offset of field: tagSAFEARRAY::cbElements"]
        [::std::mem::offset_of!(tagSAFEARRAY, cbElements) - 4usize];
    ["Offset of field: tagSAFEARRAY::cLocks"]
        [::std::mem::offset_of!(tagSAFEARRAY, cLocks) - 8usize];
    ["Offset of field: tagSAFEARRAY::pvData"]
        [::std::mem::offset_of!(tagSAFEARRAY, pvData) - 16usize];
    ["Offset of field: tagSAFEARRAY::rgsabound"]
        [::std::mem::offset_of!(tagSAFEARRAY, rgsabound) - 24usize];
};
pub type SAFEARRAY = tagSAFEARRAY;
pub type LPSAFEARRAY = *mut SAFEARRAY;
pub type VARIANT = tagVARIANT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagVARIANT {
    pub __bindgen_anon_1: tagVARIANT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagVARIANT__bindgen_ty_1 {
    pub __bindgen_anon_1: tagVARIANT__bindgen_ty_1__bindgen_ty_1,
    pub decVal: DECIMAL,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagVARIANT__bindgen_ty_1__bindgen_ty_1 {
    pub vt: VARTYPE,
    pub wReserved1: WORD,
    pub wReserved2: WORD,
    pub wReserved3: WORD,
    pub __bindgen_anon_1: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub llVal: LONGLONG,
    pub lVal: LONG,
    pub bVal: BYTE,
    pub iVal: SHORT,
    pub fltVal: FLOAT,
    pub dblVal: DOUBLE,
    pub boolVal: VARIANT_BOOL,
    pub __OBSOLETE__VARIANT_BOOL: VARIANT_BOOL,
    pub scode: SCODE,
    pub cyVal: CY,
    pub date: DATE,
    pub bstrVal: BSTR,
    pub punkVal: *mut IUnknown,
    pub pdispVal: *mut IDispatch,
    pub parray: *mut SAFEARRAY,
    pub pbVal: *mut BYTE,
    pub piVal: *mut SHORT,
    pub plVal: *mut LONG,
    pub pllVal: *mut LONGLONG,
    pub pfltVal: *mut FLOAT,
    pub pdblVal: *mut DOUBLE,
    pub pboolVal: *mut VARIANT_BOOL,
    pub __OBSOLETE__VARIANT_PBOOL: *mut VARIANT_BOOL,
    pub pscode: *mut SCODE,
    pub pcyVal: *mut CY,
    pub pdate: *mut DATE,
    pub pbstrVal: *mut BSTR,
    pub ppunkVal: *mut *mut IUnknown,
    pub ppdispVal: *mut *mut IDispatch,
    pub pparray: *mut *mut SAFEARRAY,
    pub pvarVal: *mut VARIANT,
    pub byref: PVOID,
    pub cVal: CHAR,
    pub uiVal: USHORT,
    pub ulVal: ULONG,
    pub ullVal: ULONGLONG,
    pub intVal: INT,
    pub uintVal: UINT,
    pub pdecVal: *mut DECIMAL,
    pub pcVal: *mut CHAR,
    pub puiVal: *mut USHORT,
    pub pulVal: *mut ULONG,
    pub pullVal: *mut ULONGLONG,
    pub pintVal: *mut INT,
    pub puintVal: *mut UINT,
    pub __bindgen_anon_1: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub pvRecord: PVOID,
    pub pRecInfo: *mut IRecordInfo,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>(
        ) - 16usize];
    ["Alignment of tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>(
        ) - 8usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pvRecord"] [:: std :: mem :: offset_of ! (tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , pvRecord) - 0usize] ;
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pRecInfo"] [:: std :: mem :: offset_of ! (tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , pRecInfo) - 8usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>() - 16usize];
    ["Alignment of tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::llVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        llVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::lVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        lVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::bVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        bVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::iVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        iVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::fltVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        fltVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::dblVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        dblVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::boolVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        boolVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::__OBSOLETE__VARIANT_BOOL"] [:: std :: mem :: offset_of ! (tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , __OBSOLETE__VARIANT_BOOL) - 0usize] ;
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::scode"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        scode
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cyVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cyVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::date"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        date
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::bstrVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        bstrVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::punkVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        punkVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdispVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdispVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::parray"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        parray
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pbVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pbVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::piVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        piVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::plVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        plVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pllVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pllVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pfltVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pfltVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdblVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdblVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pboolVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pboolVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::__OBSOLETE__VARIANT_PBOOL"] [:: std :: mem :: offset_of ! (tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , __OBSOLETE__VARIANT_PBOOL) - 0usize] ;
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pscode"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pscode
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pcyVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pcyVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdate"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdate
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pbstrVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pbstrVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ppunkVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ppunkVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ppdispVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ppdispVal
    )
        - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pparray"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pparray
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pvarVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pvarVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::byref"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        byref
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::uiVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        uiVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ulVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ulVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ullVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ullVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::intVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        intVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::uintVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        uintVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdecVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdecVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pcVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pcVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::puiVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        puiVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pulVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pulVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pullVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pullVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pintVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pintVal
    ) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::puintVal"][::std::mem::offset_of!(
        tagVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        puintVal
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARIANT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1>() - 24usize];
    ["Alignment of tagVARIANT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagVARIANT__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1::vt"]
        [::std::mem::offset_of!(tagVARIANT__bindgen_ty_1__bindgen_ty_1, vt) - 0usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved1"]
        [::std::mem::offset_of!(tagVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved1) - 2usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved2"]
        [::std::mem::offset_of!(tagVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved2) - 4usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved3"]
        [::std::mem::offset_of!(tagVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved3) - 6usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARIANT__bindgen_ty_1"]
        [::std::mem::size_of::<tagVARIANT__bindgen_ty_1>() - 24usize];
    ["Alignment of tagVARIANT__bindgen_ty_1"]
        [::std::mem::align_of::<tagVARIANT__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagVARIANT__bindgen_ty_1::decVal"]
        [::std::mem::offset_of!(tagVARIANT__bindgen_ty_1, decVal) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARIANT"][::std::mem::size_of::<tagVARIANT>() - 24usize];
    ["Alignment of tagVARIANT"][::std::mem::align_of::<tagVARIANT>() - 8usize];
};
pub type LPVARIANT = *mut VARIANT;
pub type VARIANTARG = VARIANT;
pub type LPVARIANTARG = *mut VARIANT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _wireBRECORD {
    pub fFlags: ULONG,
    pub clSize: ULONG,
    pub pRecInfo: *mut IRecordInfo,
    pub pRecord: *mut byte,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireBRECORD"][::std::mem::size_of::<_wireBRECORD>() - 24usize];
    ["Alignment of _wireBRECORD"][::std::mem::align_of::<_wireBRECORD>() - 8usize];
    ["Offset of field: _wireBRECORD::fFlags"]
        [::std::mem::offset_of!(_wireBRECORD, fFlags) - 0usize];
    ["Offset of field: _wireBRECORD::clSize"]
        [::std::mem::offset_of!(_wireBRECORD, clSize) - 4usize];
    ["Offset of field: _wireBRECORD::pRecInfo"]
        [::std::mem::offset_of!(_wireBRECORD, pRecInfo) - 8usize];
    ["Offset of field: _wireBRECORD::pRecord"]
        [::std::mem::offset_of!(_wireBRECORD, pRecord) - 16usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _wireVARIANT {
    pub clSize: DWORD,
    pub rpcReserved: DWORD,
    pub vt: USHORT,
    pub wReserved1: USHORT,
    pub wReserved2: USHORT,
    pub wReserved3: USHORT,
    pub __bindgen_anon_1: _wireVARIANT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _wireVARIANT__bindgen_ty_1 {
    pub llVal: LONGLONG,
    pub lVal: LONG,
    pub bVal: BYTE,
    pub iVal: SHORT,
    pub fltVal: FLOAT,
    pub dblVal: DOUBLE,
    pub boolVal: VARIANT_BOOL,
    pub scode: SCODE,
    pub cyVal: CY,
    pub date: DATE,
    pub bstrVal: wireBSTR,
    pub punkVal: *mut IUnknown,
    pub pdispVal: *mut IDispatch,
    pub parray: wirePSAFEARRAY,
    pub brecVal: wireBRECORD,
    pub pbVal: *mut BYTE,
    pub piVal: *mut SHORT,
    pub plVal: *mut LONG,
    pub pllVal: *mut LONGLONG,
    pub pfltVal: *mut FLOAT,
    pub pdblVal: *mut DOUBLE,
    pub pboolVal: *mut VARIANT_BOOL,
    pub pscode: *mut SCODE,
    pub pcyVal: *mut CY,
    pub pdate: *mut DATE,
    pub pbstrVal: *mut wireBSTR,
    pub ppunkVal: *mut *mut IUnknown,
    pub ppdispVal: *mut *mut IDispatch,
    pub pparray: *mut wirePSAFEARRAY,
    pub pvarVal: *mut wireVARIANT,
    pub cVal: CHAR,
    pub uiVal: USHORT,
    pub ulVal: ULONG,
    pub ullVal: ULONGLONG,
    pub intVal: INT,
    pub uintVal: UINT,
    pub decVal: DECIMAL,
    pub pdecVal: *mut DECIMAL,
    pub pcVal: *mut CHAR,
    pub puiVal: *mut USHORT,
    pub pulVal: *mut ULONG,
    pub pullVal: *mut ULONGLONG,
    pub pintVal: *mut INT,
    pub puintVal: *mut UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireVARIANT__bindgen_ty_1"]
        [::std::mem::size_of::<_wireVARIANT__bindgen_ty_1>() - 16usize];
    ["Alignment of _wireVARIANT__bindgen_ty_1"]
        [::std::mem::align_of::<_wireVARIANT__bindgen_ty_1>() - 8usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::llVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, llVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::lVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, lVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::bVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, bVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::iVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, iVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::fltVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, fltVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::dblVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, dblVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::boolVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, boolVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::scode"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, scode) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::cyVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, cyVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::date"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, date) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::bstrVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, bstrVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::punkVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, punkVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pdispVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pdispVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::parray"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, parray) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::brecVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, brecVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pbVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pbVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::piVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, piVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::plVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, plVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pllVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pllVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pfltVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pfltVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pdblVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pdblVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pboolVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pboolVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pscode"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pscode) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pcyVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pcyVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pdate"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pdate) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pbstrVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pbstrVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::ppunkVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, ppunkVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::ppdispVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, ppdispVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pparray"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pparray) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pvarVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pvarVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::cVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, cVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::uiVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, uiVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::ulVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, ulVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::ullVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, ullVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::intVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, intVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::uintVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, uintVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::decVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, decVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pdecVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pdecVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pcVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pcVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::puiVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, puiVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pulVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pulVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pullVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pullVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::pintVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, pintVal) - 0usize];
    ["Offset of field: _wireVARIANT__bindgen_ty_1::puintVal"]
        [::std::mem::offset_of!(_wireVARIANT__bindgen_ty_1, puintVal) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _wireVARIANT"][::std::mem::size_of::<_wireVARIANT>() - 32usize];
    ["Alignment of _wireVARIANT"][::std::mem::align_of::<_wireVARIANT>() - 8usize];
    ["Offset of field: _wireVARIANT::clSize"]
        [::std::mem::offset_of!(_wireVARIANT, clSize) - 0usize];
    ["Offset of field: _wireVARIANT::rpcReserved"]
        [::std::mem::offset_of!(_wireVARIANT, rpcReserved) - 4usize];
    ["Offset of field: _wireVARIANT::vt"][::std::mem::offset_of!(_wireVARIANT, vt) - 8usize];
    ["Offset of field: _wireVARIANT::wReserved1"]
        [::std::mem::offset_of!(_wireVARIANT, wReserved1) - 10usize];
    ["Offset of field: _wireVARIANT::wReserved2"]
        [::std::mem::offset_of!(_wireVARIANT, wReserved2) - 12usize];
    ["Offset of field: _wireVARIANT::wReserved3"]
        [::std::mem::offset_of!(_wireVARIANT, wReserved3) - 14usize];
};
pub type DISPID = LONG;
pub type MEMBERID = DISPID;
pub type HREFTYPE = DWORD;
pub const tagTYPEKIND_TKIND_ENUM: tagTYPEKIND = 0;
pub const tagTYPEKIND_TKIND_RECORD: tagTYPEKIND = 1;
pub const tagTYPEKIND_TKIND_MODULE: tagTYPEKIND = 2;
pub const tagTYPEKIND_TKIND_INTERFACE: tagTYPEKIND = 3;
pub const tagTYPEKIND_TKIND_DISPATCH: tagTYPEKIND = 4;
pub const tagTYPEKIND_TKIND_COCLASS: tagTYPEKIND = 5;
pub const tagTYPEKIND_TKIND_ALIAS: tagTYPEKIND = 6;
pub const tagTYPEKIND_TKIND_UNION: tagTYPEKIND = 7;
pub const tagTYPEKIND_TKIND_MAX: tagTYPEKIND = 8;
pub type tagTYPEKIND = ::std::os::raw::c_int;
pub use self::tagTYPEKIND as TYPEKIND;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagTYPEDESC {
    pub __bindgen_anon_1: tagTYPEDESC__bindgen_ty_1,
    pub vt: VARTYPE,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagTYPEDESC__bindgen_ty_1 {
    pub lptdesc: *mut tagTYPEDESC,
    pub lpadesc: *mut tagARRAYDESC,
    pub hreftype: HREFTYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTYPEDESC__bindgen_ty_1"]
        [::std::mem::size_of::<tagTYPEDESC__bindgen_ty_1>() - 8usize];
    ["Alignment of tagTYPEDESC__bindgen_ty_1"]
        [::std::mem::align_of::<tagTYPEDESC__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagTYPEDESC__bindgen_ty_1::lptdesc"]
        [::std::mem::offset_of!(tagTYPEDESC__bindgen_ty_1, lptdesc) - 0usize];
    ["Offset of field: tagTYPEDESC__bindgen_ty_1::lpadesc"]
        [::std::mem::offset_of!(tagTYPEDESC__bindgen_ty_1, lpadesc) - 0usize];
    ["Offset of field: tagTYPEDESC__bindgen_ty_1::hreftype"]
        [::std::mem::offset_of!(tagTYPEDESC__bindgen_ty_1, hreftype) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTYPEDESC"][::std::mem::size_of::<tagTYPEDESC>() - 16usize];
    ["Alignment of tagTYPEDESC"][::std::mem::align_of::<tagTYPEDESC>() - 8usize];
    ["Offset of field: tagTYPEDESC::vt"][::std::mem::offset_of!(tagTYPEDESC, vt) - 8usize];
};
pub type TYPEDESC = tagTYPEDESC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagARRAYDESC {
    pub tdescElem: TYPEDESC,
    pub cDims: USHORT,
    pub rgbounds: [SAFEARRAYBOUND; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagARRAYDESC"][::std::mem::size_of::<tagARRAYDESC>() - 32usize];
    ["Alignment of tagARRAYDESC"][::std::mem::align_of::<tagARRAYDESC>() - 8usize];
    ["Offset of field: tagARRAYDESC::tdescElem"]
        [::std::mem::offset_of!(tagARRAYDESC, tdescElem) - 0usize];
    ["Offset of field: tagARRAYDESC::cDims"][::std::mem::offset_of!(tagARRAYDESC, cDims) - 16usize];
    ["Offset of field: tagARRAYDESC::rgbounds"]
        [::std::mem::offset_of!(tagARRAYDESC, rgbounds) - 20usize];
};
pub type ARRAYDESC = tagARRAYDESC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagPARAMDESCEX {
    pub cBytes: ULONG,
    pub varDefaultValue: VARIANTARG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPARAMDESCEX"][::std::mem::size_of::<tagPARAMDESCEX>() - 32usize];
    ["Alignment of tagPARAMDESCEX"][::std::mem::align_of::<tagPARAMDESCEX>() - 8usize];
    ["Offset of field: tagPARAMDESCEX::cBytes"]
        [::std::mem::offset_of!(tagPARAMDESCEX, cBytes) - 0usize];
    ["Offset of field: tagPARAMDESCEX::varDefaultValue"]
        [::std::mem::offset_of!(tagPARAMDESCEX, varDefaultValue) - 8usize];
};
pub type PARAMDESCEX = tagPARAMDESCEX;
pub type LPPARAMDESCEX = *mut tagPARAMDESCEX;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPARAMDESC {
    pub pparamdescex: LPPARAMDESCEX,
    pub wParamFlags: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPARAMDESC"][::std::mem::size_of::<tagPARAMDESC>() - 16usize];
    ["Alignment of tagPARAMDESC"][::std::mem::align_of::<tagPARAMDESC>() - 8usize];
    ["Offset of field: tagPARAMDESC::pparamdescex"]
        [::std::mem::offset_of!(tagPARAMDESC, pparamdescex) - 0usize];
    ["Offset of field: tagPARAMDESC::wParamFlags"]
        [::std::mem::offset_of!(tagPARAMDESC, wParamFlags) - 8usize];
};
pub type PARAMDESC = tagPARAMDESC;
pub type LPPARAMDESC = *mut tagPARAMDESC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagIDLDESC {
    pub dwReserved: ULONG_PTR,
    pub wIDLFlags: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagIDLDESC"][::std::mem::size_of::<tagIDLDESC>() - 16usize];
    ["Alignment of tagIDLDESC"][::std::mem::align_of::<tagIDLDESC>() - 8usize];
    ["Offset of field: tagIDLDESC::dwReserved"]
        [::std::mem::offset_of!(tagIDLDESC, dwReserved) - 0usize];
    ["Offset of field: tagIDLDESC::wIDLFlags"]
        [::std::mem::offset_of!(tagIDLDESC, wIDLFlags) - 8usize];
};
pub type IDLDESC = tagIDLDESC;
pub type LPIDLDESC = *mut tagIDLDESC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagELEMDESC {
    pub tdesc: TYPEDESC,
    pub __bindgen_anon_1: tagELEMDESC__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagELEMDESC__bindgen_ty_1 {
    pub idldesc: IDLDESC,
    pub paramdesc: PARAMDESC,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagELEMDESC__bindgen_ty_1"]
        [::std::mem::size_of::<tagELEMDESC__bindgen_ty_1>() - 16usize];
    ["Alignment of tagELEMDESC__bindgen_ty_1"]
        [::std::mem::align_of::<tagELEMDESC__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagELEMDESC__bindgen_ty_1::idldesc"]
        [::std::mem::offset_of!(tagELEMDESC__bindgen_ty_1, idldesc) - 0usize];
    ["Offset of field: tagELEMDESC__bindgen_ty_1::paramdesc"]
        [::std::mem::offset_of!(tagELEMDESC__bindgen_ty_1, paramdesc) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagELEMDESC"][::std::mem::size_of::<tagELEMDESC>() - 32usize];
    ["Alignment of tagELEMDESC"][::std::mem::align_of::<tagELEMDESC>() - 8usize];
    ["Offset of field: tagELEMDESC::tdesc"][::std::mem::offset_of!(tagELEMDESC, tdesc) - 0usize];
};
pub type ELEMDESC = tagELEMDESC;
pub type LPELEMDESC = *mut tagELEMDESC;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagTYPEATTR {
    pub guid: GUID,
    pub lcid: LCID,
    pub dwReserved: DWORD,
    pub memidConstructor: MEMBERID,
    pub memidDestructor: MEMBERID,
    pub lpstrSchema: LPOLESTR,
    pub cbSizeInstance: ULONG,
    pub typekind: TYPEKIND,
    pub cFuncs: WORD,
    pub cVars: WORD,
    pub cImplTypes: WORD,
    pub cbSizeVft: WORD,
    pub cbAlignment: WORD,
    pub wTypeFlags: WORD,
    pub wMajorVerNum: WORD,
    pub wMinorVerNum: WORD,
    pub tdescAlias: TYPEDESC,
    pub idldescType: IDLDESC,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTYPEATTR"][::std::mem::size_of::<tagTYPEATTR>() - 96usize];
    ["Alignment of tagTYPEATTR"][::std::mem::align_of::<tagTYPEATTR>() - 8usize];
    ["Offset of field: tagTYPEATTR::guid"][::std::mem::offset_of!(tagTYPEATTR, guid) - 0usize];
    ["Offset of field: tagTYPEATTR::lcid"][::std::mem::offset_of!(tagTYPEATTR, lcid) - 16usize];
    ["Offset of field: tagTYPEATTR::dwReserved"]
        [::std::mem::offset_of!(tagTYPEATTR, dwReserved) - 20usize];
    ["Offset of field: tagTYPEATTR::memidConstructor"]
        [::std::mem::offset_of!(tagTYPEATTR, memidConstructor) - 24usize];
    ["Offset of field: tagTYPEATTR::memidDestructor"]
        [::std::mem::offset_of!(tagTYPEATTR, memidDestructor) - 28usize];
    ["Offset of field: tagTYPEATTR::lpstrSchema"]
        [::std::mem::offset_of!(tagTYPEATTR, lpstrSchema) - 32usize];
    ["Offset of field: tagTYPEATTR::cbSizeInstance"]
        [::std::mem::offset_of!(tagTYPEATTR, cbSizeInstance) - 40usize];
    ["Offset of field: tagTYPEATTR::typekind"]
        [::std::mem::offset_of!(tagTYPEATTR, typekind) - 44usize];
    ["Offset of field: tagTYPEATTR::cFuncs"][::std::mem::offset_of!(tagTYPEATTR, cFuncs) - 48usize];
    ["Offset of field: tagTYPEATTR::cVars"][::std::mem::offset_of!(tagTYPEATTR, cVars) - 50usize];
    ["Offset of field: tagTYPEATTR::cImplTypes"]
        [::std::mem::offset_of!(tagTYPEATTR, cImplTypes) - 52usize];
    ["Offset of field: tagTYPEATTR::cbSizeVft"]
        [::std::mem::offset_of!(tagTYPEATTR, cbSizeVft) - 54usize];
    ["Offset of field: tagTYPEATTR::cbAlignment"]
        [::std::mem::offset_of!(tagTYPEATTR, cbAlignment) - 56usize];
    ["Offset of field: tagTYPEATTR::wTypeFlags"]
        [::std::mem::offset_of!(tagTYPEATTR, wTypeFlags) - 58usize];
    ["Offset of field: tagTYPEATTR::wMajorVerNum"]
        [::std::mem::offset_of!(tagTYPEATTR, wMajorVerNum) - 60usize];
    ["Offset of field: tagTYPEATTR::wMinorVerNum"]
        [::std::mem::offset_of!(tagTYPEATTR, wMinorVerNum) - 62usize];
    ["Offset of field: tagTYPEATTR::tdescAlias"]
        [::std::mem::offset_of!(tagTYPEATTR, tdescAlias) - 64usize];
    ["Offset of field: tagTYPEATTR::idldescType"]
        [::std::mem::offset_of!(tagTYPEATTR, idldescType) - 80usize];
};
pub type TYPEATTR = tagTYPEATTR;
pub type LPTYPEATTR = *mut tagTYPEATTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDISPPARAMS {
    pub rgvarg: *mut VARIANTARG,
    pub rgdispidNamedArgs: *mut DISPID,
    pub cArgs: UINT,
    pub cNamedArgs: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDISPPARAMS"][::std::mem::size_of::<tagDISPPARAMS>() - 24usize];
    ["Alignment of tagDISPPARAMS"][::std::mem::align_of::<tagDISPPARAMS>() - 8usize];
    ["Offset of field: tagDISPPARAMS::rgvarg"]
        [::std::mem::offset_of!(tagDISPPARAMS, rgvarg) - 0usize];
    ["Offset of field: tagDISPPARAMS::rgdispidNamedArgs"]
        [::std::mem::offset_of!(tagDISPPARAMS, rgdispidNamedArgs) - 8usize];
    ["Offset of field: tagDISPPARAMS::cArgs"]
        [::std::mem::offset_of!(tagDISPPARAMS, cArgs) - 16usize];
    ["Offset of field: tagDISPPARAMS::cNamedArgs"]
        [::std::mem::offset_of!(tagDISPPARAMS, cNamedArgs) - 20usize];
};
pub type DISPPARAMS = tagDISPPARAMS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagEXCEPINFO {
    pub wCode: WORD,
    pub wReserved: WORD,
    pub bstrSource: BSTR,
    pub bstrDescription: BSTR,
    pub bstrHelpFile: BSTR,
    pub dwHelpContext: DWORD,
    pub pvReserved: PVOID,
    pub pfnDeferredFillIn:
        ::std::option::Option<unsafe extern "C" fn(arg1: *mut tagEXCEPINFO) -> HRESULT>,
    pub scode: SCODE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagEXCEPINFO"][::std::mem::size_of::<tagEXCEPINFO>() - 64usize];
    ["Alignment of tagEXCEPINFO"][::std::mem::align_of::<tagEXCEPINFO>() - 8usize];
    ["Offset of field: tagEXCEPINFO::wCode"][::std::mem::offset_of!(tagEXCEPINFO, wCode) - 0usize];
    ["Offset of field: tagEXCEPINFO::wReserved"]
        [::std::mem::offset_of!(tagEXCEPINFO, wReserved) - 2usize];
    ["Offset of field: tagEXCEPINFO::bstrSource"]
        [::std::mem::offset_of!(tagEXCEPINFO, bstrSource) - 8usize];
    ["Offset of field: tagEXCEPINFO::bstrDescription"]
        [::std::mem::offset_of!(tagEXCEPINFO, bstrDescription) - 16usize];
    ["Offset of field: tagEXCEPINFO::bstrHelpFile"]
        [::std::mem::offset_of!(tagEXCEPINFO, bstrHelpFile) - 24usize];
    ["Offset of field: tagEXCEPINFO::dwHelpContext"]
        [::std::mem::offset_of!(tagEXCEPINFO, dwHelpContext) - 32usize];
    ["Offset of field: tagEXCEPINFO::pvReserved"]
        [::std::mem::offset_of!(tagEXCEPINFO, pvReserved) - 40usize];
    ["Offset of field: tagEXCEPINFO::pfnDeferredFillIn"]
        [::std::mem::offset_of!(tagEXCEPINFO, pfnDeferredFillIn) - 48usize];
    ["Offset of field: tagEXCEPINFO::scode"][::std::mem::offset_of!(tagEXCEPINFO, scode) - 56usize];
};
pub type EXCEPINFO = tagEXCEPINFO;
pub type LPEXCEPINFO = *mut tagEXCEPINFO;
pub const tagCALLCONV_CC_FASTCALL: tagCALLCONV = 0;
pub const tagCALLCONV_CC_CDECL: tagCALLCONV = 1;
pub const tagCALLCONV_CC_MSCPASCAL: tagCALLCONV = 2;
pub const tagCALLCONV_CC_PASCAL: tagCALLCONV = 2;
pub const tagCALLCONV_CC_MACPASCAL: tagCALLCONV = 3;
pub const tagCALLCONV_CC_STDCALL: tagCALLCONV = 4;
pub const tagCALLCONV_CC_FPFASTCALL: tagCALLCONV = 5;
pub const tagCALLCONV_CC_SYSCALL: tagCALLCONV = 6;
pub const tagCALLCONV_CC_MPWCDECL: tagCALLCONV = 7;
pub const tagCALLCONV_CC_MPWPASCAL: tagCALLCONV = 8;
pub const tagCALLCONV_CC_MAX: tagCALLCONV = 9;
pub type tagCALLCONV = ::std::os::raw::c_int;
pub use self::tagCALLCONV as CALLCONV;
pub const tagFUNCKIND_FUNC_VIRTUAL: tagFUNCKIND = 0;
pub const tagFUNCKIND_FUNC_PUREVIRTUAL: tagFUNCKIND = 1;
pub const tagFUNCKIND_FUNC_NONVIRTUAL: tagFUNCKIND = 2;
pub const tagFUNCKIND_FUNC_STATIC: tagFUNCKIND = 3;
pub const tagFUNCKIND_FUNC_DISPATCH: tagFUNCKIND = 4;
pub type tagFUNCKIND = ::std::os::raw::c_int;
pub use self::tagFUNCKIND as FUNCKIND;
pub const tagINVOKEKIND_INVOKE_FUNC: tagINVOKEKIND = 1;
pub const tagINVOKEKIND_INVOKE_PROPERTYGET: tagINVOKEKIND = 2;
pub const tagINVOKEKIND_INVOKE_PROPERTYPUT: tagINVOKEKIND = 4;
pub const tagINVOKEKIND_INVOKE_PROPERTYPUTREF: tagINVOKEKIND = 8;
pub type tagINVOKEKIND = ::std::os::raw::c_int;
pub use self::tagINVOKEKIND as INVOKEKIND;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagFUNCDESC {
    pub memid: MEMBERID,
    pub lprgscode: *mut SCODE,
    pub lprgelemdescParam: *mut ELEMDESC,
    pub funckind: FUNCKIND,
    pub invkind: INVOKEKIND,
    pub callconv: CALLCONV,
    pub cParams: SHORT,
    pub cParamsOpt: SHORT,
    pub oVft: SHORT,
    pub cScodes: SHORT,
    pub elemdescFunc: ELEMDESC,
    pub wFuncFlags: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFUNCDESC"][::std::mem::size_of::<tagFUNCDESC>() - 88usize];
    ["Alignment of tagFUNCDESC"][::std::mem::align_of::<tagFUNCDESC>() - 8usize];
    ["Offset of field: tagFUNCDESC::memid"][::std::mem::offset_of!(tagFUNCDESC, memid) - 0usize];
    ["Offset of field: tagFUNCDESC::lprgscode"]
        [::std::mem::offset_of!(tagFUNCDESC, lprgscode) - 8usize];
    ["Offset of field: tagFUNCDESC::lprgelemdescParam"]
        [::std::mem::offset_of!(tagFUNCDESC, lprgelemdescParam) - 16usize];
    ["Offset of field: tagFUNCDESC::funckind"]
        [::std::mem::offset_of!(tagFUNCDESC, funckind) - 24usize];
    ["Offset of field: tagFUNCDESC::invkind"]
        [::std::mem::offset_of!(tagFUNCDESC, invkind) - 28usize];
    ["Offset of field: tagFUNCDESC::callconv"]
        [::std::mem::offset_of!(tagFUNCDESC, callconv) - 32usize];
    ["Offset of field: tagFUNCDESC::cParams"]
        [::std::mem::offset_of!(tagFUNCDESC, cParams) - 36usize];
    ["Offset of field: tagFUNCDESC::cParamsOpt"]
        [::std::mem::offset_of!(tagFUNCDESC, cParamsOpt) - 38usize];
    ["Offset of field: tagFUNCDESC::oVft"][::std::mem::offset_of!(tagFUNCDESC, oVft) - 40usize];
    ["Offset of field: tagFUNCDESC::cScodes"]
        [::std::mem::offset_of!(tagFUNCDESC, cScodes) - 42usize];
    ["Offset of field: tagFUNCDESC::elemdescFunc"]
        [::std::mem::offset_of!(tagFUNCDESC, elemdescFunc) - 48usize];
    ["Offset of field: tagFUNCDESC::wFuncFlags"]
        [::std::mem::offset_of!(tagFUNCDESC, wFuncFlags) - 80usize];
};
pub type FUNCDESC = tagFUNCDESC;
pub type LPFUNCDESC = *mut tagFUNCDESC;
pub const tagVARKIND_VAR_PERINSTANCE: tagVARKIND = 0;
pub const tagVARKIND_VAR_STATIC: tagVARKIND = 1;
pub const tagVARKIND_VAR_CONST: tagVARKIND = 2;
pub const tagVARKIND_VAR_DISPATCH: tagVARKIND = 3;
pub type tagVARKIND = ::std::os::raw::c_int;
pub use self::tagVARKIND as VARKIND;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagVARDESC {
    pub memid: MEMBERID,
    pub lpstrSchema: LPOLESTR,
    pub __bindgen_anon_1: tagVARDESC__bindgen_ty_1,
    pub elemdescVar: ELEMDESC,
    pub wVarFlags: WORD,
    pub varkind: VARKIND,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagVARDESC__bindgen_ty_1 {
    pub oInst: ULONG,
    pub lpvarValue: *mut VARIANT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARDESC__bindgen_ty_1"]
        [::std::mem::size_of::<tagVARDESC__bindgen_ty_1>() - 8usize];
    ["Alignment of tagVARDESC__bindgen_ty_1"]
        [::std::mem::align_of::<tagVARDESC__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagVARDESC__bindgen_ty_1::oInst"]
        [::std::mem::offset_of!(tagVARDESC__bindgen_ty_1, oInst) - 0usize];
    ["Offset of field: tagVARDESC__bindgen_ty_1::lpvarValue"]
        [::std::mem::offset_of!(tagVARDESC__bindgen_ty_1, lpvarValue) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVARDESC"][::std::mem::size_of::<tagVARDESC>() - 64usize];
    ["Alignment of tagVARDESC"][::std::mem::align_of::<tagVARDESC>() - 8usize];
    ["Offset of field: tagVARDESC::memid"][::std::mem::offset_of!(tagVARDESC, memid) - 0usize];
    ["Offset of field: tagVARDESC::lpstrSchema"]
        [::std::mem::offset_of!(tagVARDESC, lpstrSchema) - 8usize];
    ["Offset of field: tagVARDESC::elemdescVar"]
        [::std::mem::offset_of!(tagVARDESC, elemdescVar) - 24usize];
    ["Offset of field: tagVARDESC::wVarFlags"]
        [::std::mem::offset_of!(tagVARDESC, wVarFlags) - 56usize];
    ["Offset of field: tagVARDESC::varkind"][::std::mem::offset_of!(tagVARDESC, varkind) - 60usize];
};
pub type VARDESC = tagVARDESC;
pub type LPVARDESC = *mut tagVARDESC;
pub const tagTYPEFLAGS_TYPEFLAG_FAPPOBJECT: tagTYPEFLAGS = 1;
pub const tagTYPEFLAGS_TYPEFLAG_FCANCREATE: tagTYPEFLAGS = 2;
pub const tagTYPEFLAGS_TYPEFLAG_FLICENSED: tagTYPEFLAGS = 4;
pub const tagTYPEFLAGS_TYPEFLAG_FPREDECLID: tagTYPEFLAGS = 8;
pub const tagTYPEFLAGS_TYPEFLAG_FHIDDEN: tagTYPEFLAGS = 16;
pub const tagTYPEFLAGS_TYPEFLAG_FCONTROL: tagTYPEFLAGS = 32;
pub const tagTYPEFLAGS_TYPEFLAG_FDUAL: tagTYPEFLAGS = 64;
pub const tagTYPEFLAGS_TYPEFLAG_FNONEXTENSIBLE: tagTYPEFLAGS = 128;
pub const tagTYPEFLAGS_TYPEFLAG_FOLEAUTOMATION: tagTYPEFLAGS = 256;
pub const tagTYPEFLAGS_TYPEFLAG_FRESTRICTED: tagTYPEFLAGS = 512;
pub const tagTYPEFLAGS_TYPEFLAG_FAGGREGATABLE: tagTYPEFLAGS = 1024;
pub const tagTYPEFLAGS_TYPEFLAG_FREPLACEABLE: tagTYPEFLAGS = 2048;
pub const tagTYPEFLAGS_TYPEFLAG_FDISPATCHABLE: tagTYPEFLAGS = 4096;
pub const tagTYPEFLAGS_TYPEFLAG_FREVERSEBIND: tagTYPEFLAGS = 8192;
pub const tagTYPEFLAGS_TYPEFLAG_FPROXY: tagTYPEFLAGS = 16384;
pub type tagTYPEFLAGS = ::std::os::raw::c_int;
pub use self::tagTYPEFLAGS as TYPEFLAGS;
pub const tagFUNCFLAGS_FUNCFLAG_FRESTRICTED: tagFUNCFLAGS = 1;
pub const tagFUNCFLAGS_FUNCFLAG_FSOURCE: tagFUNCFLAGS = 2;
pub const tagFUNCFLAGS_FUNCFLAG_FBINDABLE: tagFUNCFLAGS = 4;
pub const tagFUNCFLAGS_FUNCFLAG_FREQUESTEDIT: tagFUNCFLAGS = 8;
pub const tagFUNCFLAGS_FUNCFLAG_FDISPLAYBIND: tagFUNCFLAGS = 16;
pub const tagFUNCFLAGS_FUNCFLAG_FDEFAULTBIND: tagFUNCFLAGS = 32;
pub const tagFUNCFLAGS_FUNCFLAG_FHIDDEN: tagFUNCFLAGS = 64;
pub const tagFUNCFLAGS_FUNCFLAG_FUSESGETLASTERROR: tagFUNCFLAGS = 128;
pub const tagFUNCFLAGS_FUNCFLAG_FDEFAULTCOLLELEM: tagFUNCFLAGS = 256;
pub const tagFUNCFLAGS_FUNCFLAG_FUIDEFAULT: tagFUNCFLAGS = 512;
pub const tagFUNCFLAGS_FUNCFLAG_FNONBROWSABLE: tagFUNCFLAGS = 1024;
pub const tagFUNCFLAGS_FUNCFLAG_FREPLACEABLE: tagFUNCFLAGS = 2048;
pub const tagFUNCFLAGS_FUNCFLAG_FIMMEDIATEBIND: tagFUNCFLAGS = 4096;
pub type tagFUNCFLAGS = ::std::os::raw::c_int;
pub use self::tagFUNCFLAGS as FUNCFLAGS;
pub const tagVARFLAGS_VARFLAG_FREADONLY: tagVARFLAGS = 1;
pub const tagVARFLAGS_VARFLAG_FSOURCE: tagVARFLAGS = 2;
pub const tagVARFLAGS_VARFLAG_FBINDABLE: tagVARFLAGS = 4;
pub const tagVARFLAGS_VARFLAG_FREQUESTEDIT: tagVARFLAGS = 8;
pub const tagVARFLAGS_VARFLAG_FDISPLAYBIND: tagVARFLAGS = 16;
pub const tagVARFLAGS_VARFLAG_FDEFAULTBIND: tagVARFLAGS = 32;
pub const tagVARFLAGS_VARFLAG_FHIDDEN: tagVARFLAGS = 64;
pub const tagVARFLAGS_VARFLAG_FRESTRICTED: tagVARFLAGS = 128;
pub const tagVARFLAGS_VARFLAG_FDEFAULTCOLLELEM: tagVARFLAGS = 256;
pub const tagVARFLAGS_VARFLAG_FUIDEFAULT: tagVARFLAGS = 512;
pub const tagVARFLAGS_VARFLAG_FNONBROWSABLE: tagVARFLAGS = 1024;
pub const tagVARFLAGS_VARFLAG_FREPLACEABLE: tagVARFLAGS = 2048;
pub const tagVARFLAGS_VARFLAG_FIMMEDIATEBIND: tagVARFLAGS = 4096;
pub type tagVARFLAGS = ::std::os::raw::c_int;
pub use self::tagVARFLAGS as VARFLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCLEANLOCALSTORAGE {
    pub pInterface: *mut IUnknown,
    pub pStorage: PVOID,
    pub flags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCLEANLOCALSTORAGE"][::std::mem::size_of::<tagCLEANLOCALSTORAGE>() - 24usize];
    ["Alignment of tagCLEANLOCALSTORAGE"][::std::mem::align_of::<tagCLEANLOCALSTORAGE>() - 8usize];
    ["Offset of field: tagCLEANLOCALSTORAGE::pInterface"]
        [::std::mem::offset_of!(tagCLEANLOCALSTORAGE, pInterface) - 0usize];
    ["Offset of field: tagCLEANLOCALSTORAGE::pStorage"]
        [::std::mem::offset_of!(tagCLEANLOCALSTORAGE, pStorage) - 8usize];
    ["Offset of field: tagCLEANLOCALSTORAGE::flags"]
        [::std::mem::offset_of!(tagCLEANLOCALSTORAGE, flags) - 16usize];
};
pub type CLEANLOCALSTORAGE = tagCLEANLOCALSTORAGE;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagCUSTDATAITEM {
    pub guid: GUID,
    pub varValue: VARIANTARG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCUSTDATAITEM"][::std::mem::size_of::<tagCUSTDATAITEM>() - 40usize];
    ["Alignment of tagCUSTDATAITEM"][::std::mem::align_of::<tagCUSTDATAITEM>() - 8usize];
    ["Offset of field: tagCUSTDATAITEM::guid"]
        [::std::mem::offset_of!(tagCUSTDATAITEM, guid) - 0usize];
    ["Offset of field: tagCUSTDATAITEM::varValue"]
        [::std::mem::offset_of!(tagCUSTDATAITEM, varValue) - 16usize];
};
pub type CUSTDATAITEM = tagCUSTDATAITEM;
pub type LPCUSTDATAITEM = *mut tagCUSTDATAITEM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCUSTDATA {
    pub cCustData: DWORD,
    pub prgCustData: LPCUSTDATAITEM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCUSTDATA"][::std::mem::size_of::<tagCUSTDATA>() - 16usize];
    ["Alignment of tagCUSTDATA"][::std::mem::align_of::<tagCUSTDATA>() - 8usize];
    ["Offset of field: tagCUSTDATA::cCustData"]
        [::std::mem::offset_of!(tagCUSTDATA, cCustData) - 0usize];
    ["Offset of field: tagCUSTDATA::prgCustData"]
        [::std::mem::offset_of!(tagCUSTDATA, prgCustData) - 8usize];
};
pub type CUSTDATA = tagCUSTDATA;
pub type LPCUSTDATA = *mut tagCUSTDATA;
unsafe extern "C" {
    pub static mut IOleAutomationTypes_v1_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut IOleAutomationTypes_v1_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPCREATETYPEINFO = *mut ICreateTypeInfo;
unsafe extern "C" {
    pub static IID_ICreateTypeInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo) -> ULONG>,
    pub SetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, guid: *const GUID) -> HRESULT,
    >,
    pub SetTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, uTypeFlags: UINT) -> HRESULT,
    >,
    pub SetDocString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, pStrDoc: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, dwHelpContext: DWORD) -> HRESULT,
    >,
    pub SetVersion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            wMajorVerNum: WORD,
            wMinorVerNum: WORD,
        ) -> HRESULT,
    >,
    pub AddRefTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            pTInfo: *mut ITypeInfo,
            phRefType: *mut HREFTYPE,
        ) -> HRESULT,
    >,
    pub AddFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            pFuncDesc: *mut FUNCDESC,
        ) -> HRESULT,
    >,
    pub AddImplType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            hRefType: HREFTYPE,
        ) -> HRESULT,
    >,
    pub SetImplTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            implTypeFlags: INT,
        ) -> HRESULT,
    >,
    pub SetAlignment: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, cbAlignment: WORD) -> HRESULT,
    >,
    pub SetSchema: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, pStrSchema: LPOLESTR) -> HRESULT,
    >,
    pub AddVarDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            pVarDesc: *mut VARDESC,
        ) -> HRESULT,
    >,
    pub SetFuncAndParamNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
        ) -> HRESULT,
    >,
    pub SetVarName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, index: UINT, szName: LPOLESTR) -> HRESULT,
    >,
    pub SetTypeDescAlias: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, pTDescAlias: *mut TYPEDESC) -> HRESULT,
    >,
    pub DefineFuncAsDllEntry: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            szDllName: LPOLESTR,
            szProcName: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetFuncDocString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            szDocString: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetVarDocString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            szDocString: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetFuncHelpContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            dwHelpContext: DWORD,
        ) -> HRESULT,
    >,
    pub SetVarHelpContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo,
            index: UINT,
            dwHelpContext: DWORD,
        ) -> HRESULT,
    >,
    pub SetMops: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, index: UINT, bstrMops: BSTR) -> HRESULT,
    >,
    pub SetTypeIdldesc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo, pIdlDesc: *mut IDLDESC) -> HRESULT,
    >,
    pub LayOut: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeInfoVtbl"][::std::mem::size_of::<ICreateTypeInfoVtbl>() - 208usize];
    ["Alignment of ICreateTypeInfoVtbl"][::std::mem::align_of::<ICreateTypeInfoVtbl>() - 8usize];
    ["Offset of field: ICreateTypeInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICreateTypeInfoVtbl::AddRef"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, AddRef) - 8usize];
    ["Offset of field: ICreateTypeInfoVtbl::Release"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, Release) - 16usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetGuid"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetGuid) - 24usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetTypeFlags"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetTypeFlags) - 32usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetDocString"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetDocString) - 40usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetHelpContext) - 48usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetVersion"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetVersion) - 56usize];
    ["Offset of field: ICreateTypeInfoVtbl::AddRefTypeInfo"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, AddRefTypeInfo) - 64usize];
    ["Offset of field: ICreateTypeInfoVtbl::AddFuncDesc"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, AddFuncDesc) - 72usize];
    ["Offset of field: ICreateTypeInfoVtbl::AddImplType"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, AddImplType) - 80usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetImplTypeFlags"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetImplTypeFlags) - 88usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetAlignment"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetAlignment) - 96usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetSchema"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetSchema) - 104usize];
    ["Offset of field: ICreateTypeInfoVtbl::AddVarDesc"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, AddVarDesc) - 112usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetFuncAndParamNames"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetFuncAndParamNames) - 120usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetVarName"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetVarName) - 128usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetTypeDescAlias"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetTypeDescAlias) - 136usize];
    ["Offset of field: ICreateTypeInfoVtbl::DefineFuncAsDllEntry"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, DefineFuncAsDllEntry) - 144usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetFuncDocString"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetFuncDocString) - 152usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetVarDocString"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetVarDocString) - 160usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetFuncHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetFuncHelpContext) - 168usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetVarHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetVarHelpContext) - 176usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetMops"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetMops) - 184usize];
    ["Offset of field: ICreateTypeInfoVtbl::SetTypeIdldesc"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, SetTypeIdldesc) - 192usize];
    ["Offset of field: ICreateTypeInfoVtbl::LayOut"]
        [::std::mem::offset_of!(ICreateTypeInfoVtbl, LayOut) - 200usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeInfo {
    pub lpVtbl: *mut ICreateTypeInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeInfo"][::std::mem::size_of::<ICreateTypeInfo>() - 8usize];
    ["Alignment of ICreateTypeInfo"][::std::mem::align_of::<ICreateTypeInfo>() - 8usize];
    ["Offset of field: ICreateTypeInfo::lpVtbl"]
        [::std::mem::offset_of!(ICreateTypeInfo, lpVtbl) - 0usize];
};
pub type LPCREATETYPEINFO2 = *mut ICreateTypeInfo2;
unsafe extern "C" {
    pub static IID_ICreateTypeInfo2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeInfo2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo2) -> ULONG>,
    pub SetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, guid: *const GUID) -> HRESULT,
    >,
    pub SetTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, uTypeFlags: UINT) -> HRESULT,
    >,
    pub SetDocString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, pStrDoc: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, dwHelpContext: DWORD) -> HRESULT,
    >,
    pub SetVersion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            wMajorVerNum: WORD,
            wMinorVerNum: WORD,
        ) -> HRESULT,
    >,
    pub AddRefTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            pTInfo: *mut ITypeInfo,
            phRefType: *mut HREFTYPE,
        ) -> HRESULT,
    >,
    pub AddFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            pFuncDesc: *mut FUNCDESC,
        ) -> HRESULT,
    >,
    pub AddImplType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            hRefType: HREFTYPE,
        ) -> HRESULT,
    >,
    pub SetImplTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            implTypeFlags: INT,
        ) -> HRESULT,
    >,
    pub SetAlignment: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, cbAlignment: WORD) -> HRESULT,
    >,
    pub SetSchema: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, pStrSchema: LPOLESTR) -> HRESULT,
    >,
    pub AddVarDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            pVarDesc: *mut VARDESC,
        ) -> HRESULT,
    >,
    pub SetFuncAndParamNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
        ) -> HRESULT,
    >,
    pub SetVarName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, index: UINT, szName: LPOLESTR) -> HRESULT,
    >,
    pub SetTypeDescAlias: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, pTDescAlias: *mut TYPEDESC) -> HRESULT,
    >,
    pub DefineFuncAsDllEntry: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            szDllName: LPOLESTR,
            szProcName: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetFuncDocString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            szDocString: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetVarDocString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            szDocString: LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetFuncHelpContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            dwHelpContext: DWORD,
        ) -> HRESULT,
    >,
    pub SetVarHelpContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            dwHelpContext: DWORD,
        ) -> HRESULT,
    >,
    pub SetMops: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, index: UINT, bstrMops: BSTR) -> HRESULT,
    >,
    pub SetTypeIdldesc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, pIdlDesc: *mut IDLDESC) -> HRESULT,
    >,
    pub LayOut: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo2) -> HRESULT>,
    pub DeleteFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, index: UINT) -> HRESULT,
    >,
    pub DeleteFuncDescByMemId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            memid: MEMBERID,
            invKind: INVOKEKIND,
        ) -> HRESULT,
    >,
    pub DeleteVarDesc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, index: UINT) -> HRESULT,
    >,
    pub DeleteVarDescByMemId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, memid: MEMBERID) -> HRESULT,
    >,
    pub DeleteImplType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, index: UINT) -> HRESULT,
    >,
    pub SetCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetFuncCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetParamCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            indexFunc: UINT,
            indexParam: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetVarCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetImplTypeCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetHelpStringContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, dwHelpStringContext: ULONG) -> HRESULT,
    >,
    pub SetFuncHelpStringContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            dwHelpStringContext: ULONG,
        ) -> HRESULT,
    >,
    pub SetVarHelpStringContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeInfo2,
            index: UINT,
            dwHelpStringContext: ULONG,
        ) -> HRESULT,
    >,
    pub Invalidate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeInfo2) -> HRESULT>,
    pub SetName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeInfo2, szName: LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeInfo2Vtbl"][::std::mem::size_of::<ICreateTypeInfo2Vtbl>() - 328usize];
    ["Alignment of ICreateTypeInfo2Vtbl"][::std::mem::align_of::<ICreateTypeInfo2Vtbl>() - 8usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::AddRef"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, AddRef) - 8usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::Release"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, Release) - 16usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetGuid"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetGuid) - 24usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetTypeFlags"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetTypeFlags) - 32usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetDocString"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetDocString) - 40usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetHelpContext) - 48usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVersion"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVersion) - 56usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::AddRefTypeInfo"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, AddRefTypeInfo) - 64usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::AddFuncDesc"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, AddFuncDesc) - 72usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::AddImplType"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, AddImplType) - 80usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetImplTypeFlags"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetImplTypeFlags) - 88usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetAlignment"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetAlignment) - 96usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetSchema"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetSchema) - 104usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::AddVarDesc"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, AddVarDesc) - 112usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetFuncAndParamNames"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetFuncAndParamNames) - 120usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVarName"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVarName) - 128usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetTypeDescAlias"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetTypeDescAlias) - 136usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DefineFuncAsDllEntry"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DefineFuncAsDllEntry) - 144usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetFuncDocString"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetFuncDocString) - 152usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVarDocString"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVarDocString) - 160usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetFuncHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetFuncHelpContext) - 168usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVarHelpContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVarHelpContext) - 176usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetMops"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetMops) - 184usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetTypeIdldesc"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetTypeIdldesc) - 192usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::LayOut"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, LayOut) - 200usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DeleteFuncDesc"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DeleteFuncDesc) - 208usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DeleteFuncDescByMemId"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DeleteFuncDescByMemId) - 216usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DeleteVarDesc"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DeleteVarDesc) - 224usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DeleteVarDescByMemId"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DeleteVarDescByMemId) - 232usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::DeleteImplType"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, DeleteImplType) - 240usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetCustData"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetCustData) - 248usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetFuncCustData"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetFuncCustData) - 256usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetParamCustData"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetParamCustData) - 264usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVarCustData"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVarCustData) - 272usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetImplTypeCustData"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetImplTypeCustData) - 280usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetHelpStringContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetHelpStringContext) - 288usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetFuncHelpStringContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetFuncHelpStringContext) - 296usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetVarHelpStringContext"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetVarHelpStringContext) - 304usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::Invalidate"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, Invalidate) - 312usize];
    ["Offset of field: ICreateTypeInfo2Vtbl::SetName"]
        [::std::mem::offset_of!(ICreateTypeInfo2Vtbl, SetName) - 320usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeInfo2 {
    pub lpVtbl: *mut ICreateTypeInfo2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeInfo2"][::std::mem::size_of::<ICreateTypeInfo2>() - 8usize];
    ["Alignment of ICreateTypeInfo2"][::std::mem::align_of::<ICreateTypeInfo2>() - 8usize];
    ["Offset of field: ICreateTypeInfo2::lpVtbl"]
        [::std::mem::offset_of!(ICreateTypeInfo2, lpVtbl) - 0usize];
};
pub type LPCREATETYPELIB = *mut ICreateTypeLib;
unsafe extern "C" {
    pub static IID_ICreateTypeLib: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeLibVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib) -> ULONG>,
    pub CreateTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib,
            szName: LPOLESTR,
            tkind: TYPEKIND,
            ppCTInfo: *mut *mut ICreateTypeInfo,
        ) -> HRESULT,
    >,
    pub SetName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, szName: LPOLESTR) -> HRESULT,
    >,
    pub SetVersion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib,
            wMajorVerNum: WORD,
            wMinorVerNum: WORD,
        ) -> HRESULT,
    >,
    pub SetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, guid: *const GUID) -> HRESULT,
    >,
    pub SetDocString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, szDoc: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpFileName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, szHelpFileName: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, dwHelpContext: DWORD) -> HRESULT,
    >,
    pub SetLcid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, lcid: LCID) -> HRESULT,
    >,
    pub SetLibFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib, uLibFlags: UINT) -> HRESULT,
    >,
    pub SaveAllChanges:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeLibVtbl"][::std::mem::size_of::<ICreateTypeLibVtbl>() - 104usize];
    ["Alignment of ICreateTypeLibVtbl"][::std::mem::align_of::<ICreateTypeLibVtbl>() - 8usize];
    ["Offset of field: ICreateTypeLibVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICreateTypeLibVtbl::AddRef"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, AddRef) - 8usize];
    ["Offset of field: ICreateTypeLibVtbl::Release"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, Release) - 16usize];
    ["Offset of field: ICreateTypeLibVtbl::CreateTypeInfo"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, CreateTypeInfo) - 24usize];
    ["Offset of field: ICreateTypeLibVtbl::SetName"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetName) - 32usize];
    ["Offset of field: ICreateTypeLibVtbl::SetVersion"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetVersion) - 40usize];
    ["Offset of field: ICreateTypeLibVtbl::SetGuid"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetGuid) - 48usize];
    ["Offset of field: ICreateTypeLibVtbl::SetDocString"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetDocString) - 56usize];
    ["Offset of field: ICreateTypeLibVtbl::SetHelpFileName"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetHelpFileName) - 64usize];
    ["Offset of field: ICreateTypeLibVtbl::SetHelpContext"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetHelpContext) - 72usize];
    ["Offset of field: ICreateTypeLibVtbl::SetLcid"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetLcid) - 80usize];
    ["Offset of field: ICreateTypeLibVtbl::SetLibFlags"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SetLibFlags) - 88usize];
    ["Offset of field: ICreateTypeLibVtbl::SaveAllChanges"]
        [::std::mem::offset_of!(ICreateTypeLibVtbl, SaveAllChanges) - 96usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeLib {
    pub lpVtbl: *mut ICreateTypeLibVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeLib"][::std::mem::size_of::<ICreateTypeLib>() - 8usize];
    ["Alignment of ICreateTypeLib"][::std::mem::align_of::<ICreateTypeLib>() - 8usize];
    ["Offset of field: ICreateTypeLib::lpVtbl"]
        [::std::mem::offset_of!(ICreateTypeLib, lpVtbl) - 0usize];
};
pub type LPCREATETYPELIB2 = *mut ICreateTypeLib2;
unsafe extern "C" {
    pub static IID_ICreateTypeLib2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeLib2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib2) -> ULONG>,
    pub CreateTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib2,
            szName: LPOLESTR,
            tkind: TYPEKIND,
            ppCTInfo: *mut *mut ICreateTypeInfo,
        ) -> HRESULT,
    >,
    pub SetName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, szName: LPOLESTR) -> HRESULT,
    >,
    pub SetVersion: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib2,
            wMajorVerNum: WORD,
            wMinorVerNum: WORD,
        ) -> HRESULT,
    >,
    pub SetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, guid: *const GUID) -> HRESULT,
    >,
    pub SetDocString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, szDoc: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpFileName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, szHelpFileName: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, dwHelpContext: DWORD) -> HRESULT,
    >,
    pub SetLcid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, lcid: LCID) -> HRESULT,
    >,
    pub SetLibFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, uLibFlags: UINT) -> HRESULT,
    >,
    pub SaveAllChanges:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateTypeLib2) -> HRESULT>,
    pub DeleteTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, szName: LPOLESTR) -> HRESULT,
    >,
    pub SetCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateTypeLib2,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub SetHelpStringContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, dwHelpStringContext: ULONG) -> HRESULT,
    >,
    pub SetHelpStringDll: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateTypeLib2, szFileName: LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeLib2Vtbl"][::std::mem::size_of::<ICreateTypeLib2Vtbl>() - 136usize];
    ["Alignment of ICreateTypeLib2Vtbl"][::std::mem::align_of::<ICreateTypeLib2Vtbl>() - 8usize];
    ["Offset of field: ICreateTypeLib2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: ICreateTypeLib2Vtbl::AddRef"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, AddRef) - 8usize];
    ["Offset of field: ICreateTypeLib2Vtbl::Release"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, Release) - 16usize];
    ["Offset of field: ICreateTypeLib2Vtbl::CreateTypeInfo"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, CreateTypeInfo) - 24usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetName"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetName) - 32usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetVersion"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetVersion) - 40usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetGuid"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetGuid) - 48usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetDocString"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetDocString) - 56usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetHelpFileName"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetHelpFileName) - 64usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetHelpContext"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetHelpContext) - 72usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetLcid"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetLcid) - 80usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetLibFlags"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetLibFlags) - 88usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SaveAllChanges"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SaveAllChanges) - 96usize];
    ["Offset of field: ICreateTypeLib2Vtbl::DeleteTypeInfo"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, DeleteTypeInfo) - 104usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetCustData"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetCustData) - 112usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetHelpStringContext"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetHelpStringContext) - 120usize];
    ["Offset of field: ICreateTypeLib2Vtbl::SetHelpStringDll"]
        [::std::mem::offset_of!(ICreateTypeLib2Vtbl, SetHelpStringDll) - 128usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateTypeLib2 {
    pub lpVtbl: *mut ICreateTypeLib2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateTypeLib2"][::std::mem::size_of::<ICreateTypeLib2>() - 8usize];
    ["Alignment of ICreateTypeLib2"][::std::mem::align_of::<ICreateTypeLib2>() - 8usize];
    ["Offset of field: ICreateTypeLib2::lpVtbl"]
        [::std::mem::offset_of!(ICreateTypeLib2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0005_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0005_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPDISPATCH = *mut IDispatch;
unsafe extern "C" {
    pub static IID_IDispatch: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDispatchVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDispatch,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDispatch) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDispatch) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDispatch, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDispatch,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDispatch,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDispatch,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDispatchVtbl"][::std::mem::size_of::<IDispatchVtbl>() - 56usize];
    ["Alignment of IDispatchVtbl"][::std::mem::align_of::<IDispatchVtbl>() - 8usize];
    ["Offset of field: IDispatchVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDispatchVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDispatchVtbl::AddRef"]
        [::std::mem::offset_of!(IDispatchVtbl, AddRef) - 8usize];
    ["Offset of field: IDispatchVtbl::Release"]
        [::std::mem::offset_of!(IDispatchVtbl, Release) - 16usize];
    ["Offset of field: IDispatchVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IDispatchVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IDispatchVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IDispatchVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IDispatchVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IDispatchVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IDispatchVtbl::Invoke"]
        [::std::mem::offset_of!(IDispatchVtbl, Invoke) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDispatch {
    pub lpVtbl: *mut IDispatchVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDispatch"][::std::mem::size_of::<IDispatch>() - 8usize];
    ["Alignment of IDispatch"][::std::mem::align_of::<IDispatch>() - 8usize];
    ["Offset of field: IDispatch::lpVtbl"][::std::mem::offset_of!(IDispatch, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IDispatch_RemoteInvoke_Proxy(
        This: *mut IDispatch,
        dispIdMember: DISPID,
        riid: *const IID,
        lcid: LCID,
        dwFlags: DWORD,
        pDispParams: *mut DISPPARAMS,
        pVarResult: *mut VARIANT,
        pExcepInfo: *mut EXCEPINFO,
        pArgErr: *mut UINT,
        cVarRef: UINT,
        rgVarRefIdx: *mut UINT,
        rgVarRef: *mut VARIANTARG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDispatch_RemoteInvoke_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMVARIANT = *mut IEnumVARIANT;
unsafe extern "C" {
    pub static IID_IEnumVARIANT: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumVARIANTVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumVARIANT,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumVARIANT) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumVARIANT) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumVARIANT,
            celt: ULONG,
            rgVar: *mut VARIANT,
            pCeltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumVARIANT, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumVARIANT) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumVARIANT, ppEnum: *mut *mut IEnumVARIANT) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumVARIANTVtbl"][::std::mem::size_of::<IEnumVARIANTVtbl>() - 56usize];
    ["Alignment of IEnumVARIANTVtbl"][::std::mem::align_of::<IEnumVARIANTVtbl>() - 8usize];
    ["Offset of field: IEnumVARIANTVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumVARIANTVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumVARIANTVtbl::Release"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, Release) - 16usize];
    ["Offset of field: IEnumVARIANTVtbl::Next"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, Next) - 24usize];
    ["Offset of field: IEnumVARIANTVtbl::Skip"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, Skip) - 32usize];
    ["Offset of field: IEnumVARIANTVtbl::Reset"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, Reset) - 40usize];
    ["Offset of field: IEnumVARIANTVtbl::Clone"]
        [::std::mem::offset_of!(IEnumVARIANTVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumVARIANT {
    pub lpVtbl: *mut IEnumVARIANTVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumVARIANT"][::std::mem::size_of::<IEnumVARIANT>() - 8usize];
    ["Alignment of IEnumVARIANT"][::std::mem::align_of::<IEnumVARIANT>() - 8usize];
    ["Offset of field: IEnumVARIANT::lpVtbl"]
        [::std::mem::offset_of!(IEnumVARIANT, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumVARIANT_RemoteNext_Proxy(
        This: *mut IEnumVARIANT,
        celt: ULONG,
        rgVar: *mut VARIANT,
        pCeltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumVARIANT_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPTYPECOMP = *mut ITypeComp;
pub const tagDESCKIND_DESCKIND_NONE: tagDESCKIND = 0;
pub const tagDESCKIND_DESCKIND_FUNCDESC: tagDESCKIND = 1;
pub const tagDESCKIND_DESCKIND_VARDESC: tagDESCKIND = 2;
pub const tagDESCKIND_DESCKIND_TYPECOMP: tagDESCKIND = 3;
pub const tagDESCKIND_DESCKIND_IMPLICITAPPOBJ: tagDESCKIND = 4;
pub const tagDESCKIND_DESCKIND_MAX: tagDESCKIND = 5;
pub type tagDESCKIND = ::std::os::raw::c_int;
pub use self::tagDESCKIND as DESCKIND;
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagBINDPTR {
    pub lpfuncdesc: *mut FUNCDESC,
    pub lpvardesc: *mut VARDESC,
    pub lptcomp: *mut ITypeComp,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagBINDPTR"][::std::mem::size_of::<tagBINDPTR>() - 8usize];
    ["Alignment of tagBINDPTR"][::std::mem::align_of::<tagBINDPTR>() - 8usize];
    ["Offset of field: tagBINDPTR::lpfuncdesc"]
        [::std::mem::offset_of!(tagBINDPTR, lpfuncdesc) - 0usize];
    ["Offset of field: tagBINDPTR::lpvardesc"]
        [::std::mem::offset_of!(tagBINDPTR, lpvardesc) - 0usize];
    ["Offset of field: tagBINDPTR::lptcomp"][::std::mem::offset_of!(tagBINDPTR, lptcomp) - 0usize];
};
pub type BINDPTR = tagBINDPTR;
pub type LPBINDPTR = *mut tagBINDPTR;
unsafe extern "C" {
    pub static IID_ITypeComp: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeCompVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeComp,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeComp) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeComp) -> ULONG>,
    pub Bind: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeComp,
            szName: LPOLESTR,
            lHashVal: ULONG,
            wFlags: WORD,
            ppTInfo: *mut *mut ITypeInfo,
            pDescKind: *mut DESCKIND,
            pBindPtr: *mut BINDPTR,
        ) -> HRESULT,
    >,
    pub BindType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeComp,
            szName: LPOLESTR,
            lHashVal: ULONG,
            ppTInfo: *mut *mut ITypeInfo,
            ppTComp: *mut *mut ITypeComp,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeCompVtbl"][::std::mem::size_of::<ITypeCompVtbl>() - 40usize];
    ["Alignment of ITypeCompVtbl"][::std::mem::align_of::<ITypeCompVtbl>() - 8usize];
    ["Offset of field: ITypeCompVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeCompVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeCompVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeCompVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeCompVtbl::Release"]
        [::std::mem::offset_of!(ITypeCompVtbl, Release) - 16usize];
    ["Offset of field: ITypeCompVtbl::Bind"][::std::mem::offset_of!(ITypeCompVtbl, Bind) - 24usize];
    ["Offset of field: ITypeCompVtbl::BindType"]
        [::std::mem::offset_of!(ITypeCompVtbl, BindType) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeComp {
    pub lpVtbl: *mut ITypeCompVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeComp"][::std::mem::size_of::<ITypeComp>() - 8usize];
    ["Alignment of ITypeComp"][::std::mem::align_of::<ITypeComp>() - 8usize];
    ["Offset of field: ITypeComp::lpVtbl"][::std::mem::offset_of!(ITypeComp, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ITypeComp_RemoteBind_Proxy(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        wFlags: WORD,
        ppTInfo: *mut *mut ITypeInfo,
        pDescKind: *mut DESCKIND,
        ppFuncDesc: *mut LPFUNCDESC,
        ppVarDesc: *mut LPVARDESC,
        ppTypeComp: *mut *mut ITypeComp,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_RemoteBind_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeComp_RemoteBindType_Proxy(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_RemoteBindType_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0008_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0008_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPTYPEINFO = *mut ITypeInfo;
unsafe extern "C" {
    pub static IID_ITypeInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo) -> ULONG>,
    pub GetTypeAttr: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo, ppTypeAttr: *mut *mut TYPEATTR) -> HRESULT,
    >,
    pub GetTypeComp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo, ppTComp: *mut *mut ITypeComp) -> HRESULT,
    >,
    pub GetFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            index: UINT,
            ppFuncDesc: *mut *mut FUNCDESC,
        ) -> HRESULT,
    >,
    pub GetVarDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            index: UINT,
            ppVarDesc: *mut *mut VARDESC,
        ) -> HRESULT,
    >,
    pub GetNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            memid: MEMBERID,
            rgBstrNames: *mut BSTR,
            cMaxNames: UINT,
            pcNames: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetRefTypeOfImplType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo, index: UINT, pRefType: *mut HREFTYPE) -> HRESULT,
    >,
    pub GetImplTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            index: UINT,
            pImplTypeFlags: *mut INT,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            pMemId: *mut MEMBERID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            pvInstance: PVOID,
            memid: MEMBERID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetDocumentation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            memid: MEMBERID,
            pBstrName: *mut BSTR,
            pBstrDocString: *mut BSTR,
            pdwHelpContext: *mut DWORD,
            pBstrHelpFile: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetDllEntry: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            memid: MEMBERID,
            invKind: INVOKEKIND,
            pBstrDllName: *mut BSTR,
            pBstrName: *mut BSTR,
            pwOrdinal: *mut WORD,
        ) -> HRESULT,
    >,
    pub GetRefTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            hRefType: HREFTYPE,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub AddressOfMember: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            memid: MEMBERID,
            invKind: INVOKEKIND,
            ppv: *mut PVOID,
        ) -> HRESULT,
    >,
    pub CreateInstance: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            pUnkOuter: *mut IUnknown,
            riid: *const IID,
            ppvObj: *mut PVOID,
        ) -> HRESULT,
    >,
    pub GetMops: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            memid: MEMBERID,
            pBstrMops: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetContainingTypeLib: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo,
            ppTLib: *mut *mut ITypeLib,
            pIndex: *mut UINT,
        ) -> HRESULT,
    >,
    pub ReleaseTypeAttr:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo, pTypeAttr: *mut TYPEATTR)>,
    pub ReleaseFuncDesc:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo, pFuncDesc: *mut FUNCDESC)>,
    pub ReleaseVarDesc:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo, pVarDesc: *mut VARDESC)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeInfoVtbl"][::std::mem::size_of::<ITypeInfoVtbl>() - 176usize];
    ["Alignment of ITypeInfoVtbl"][::std::mem::align_of::<ITypeInfoVtbl>() - 8usize];
    ["Offset of field: ITypeInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeInfoVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeInfoVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeInfoVtbl::Release"]
        [::std::mem::offset_of!(ITypeInfoVtbl, Release) - 16usize];
    ["Offset of field: ITypeInfoVtbl::GetTypeAttr"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetTypeAttr) - 24usize];
    ["Offset of field: ITypeInfoVtbl::GetTypeComp"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetTypeComp) - 32usize];
    ["Offset of field: ITypeInfoVtbl::GetFuncDesc"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetFuncDesc) - 40usize];
    ["Offset of field: ITypeInfoVtbl::GetVarDesc"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetVarDesc) - 48usize];
    ["Offset of field: ITypeInfoVtbl::GetNames"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetNames) - 56usize];
    ["Offset of field: ITypeInfoVtbl::GetRefTypeOfImplType"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetRefTypeOfImplType) - 64usize];
    ["Offset of field: ITypeInfoVtbl::GetImplTypeFlags"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetImplTypeFlags) - 72usize];
    ["Offset of field: ITypeInfoVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetIDsOfNames) - 80usize];
    ["Offset of field: ITypeInfoVtbl::Invoke"]
        [::std::mem::offset_of!(ITypeInfoVtbl, Invoke) - 88usize];
    ["Offset of field: ITypeInfoVtbl::GetDocumentation"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetDocumentation) - 96usize];
    ["Offset of field: ITypeInfoVtbl::GetDllEntry"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetDllEntry) - 104usize];
    ["Offset of field: ITypeInfoVtbl::GetRefTypeInfo"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetRefTypeInfo) - 112usize];
    ["Offset of field: ITypeInfoVtbl::AddressOfMember"]
        [::std::mem::offset_of!(ITypeInfoVtbl, AddressOfMember) - 120usize];
    ["Offset of field: ITypeInfoVtbl::CreateInstance"]
        [::std::mem::offset_of!(ITypeInfoVtbl, CreateInstance) - 128usize];
    ["Offset of field: ITypeInfoVtbl::GetMops"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetMops) - 136usize];
    ["Offset of field: ITypeInfoVtbl::GetContainingTypeLib"]
        [::std::mem::offset_of!(ITypeInfoVtbl, GetContainingTypeLib) - 144usize];
    ["Offset of field: ITypeInfoVtbl::ReleaseTypeAttr"]
        [::std::mem::offset_of!(ITypeInfoVtbl, ReleaseTypeAttr) - 152usize];
    ["Offset of field: ITypeInfoVtbl::ReleaseFuncDesc"]
        [::std::mem::offset_of!(ITypeInfoVtbl, ReleaseFuncDesc) - 160usize];
    ["Offset of field: ITypeInfoVtbl::ReleaseVarDesc"]
        [::std::mem::offset_of!(ITypeInfoVtbl, ReleaseVarDesc) - 168usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeInfo {
    pub lpVtbl: *mut ITypeInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeInfo"][::std::mem::size_of::<ITypeInfo>() - 8usize];
    ["Alignment of ITypeInfo"][::std::mem::align_of::<ITypeInfo>() - 8usize];
    ["Offset of field: ITypeInfo::lpVtbl"][::std::mem::offset_of!(ITypeInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetTypeAttr_Proxy(
        This: *mut ITypeInfo,
        ppTypeAttr: *mut LPTYPEATTR,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetTypeAttr_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetFuncDesc_Proxy(
        This: *mut ITypeInfo,
        index: UINT,
        ppFuncDesc: *mut LPFUNCDESC,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetFuncDesc_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetVarDesc_Proxy(
        This: *mut ITypeInfo,
        index: UINT,
        ppVarDesc: *mut LPVARDESC,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetVarDesc_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetNames_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        rgBstrNames: *mut BSTR,
        cMaxNames: UINT,
        pcNames: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetNames_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalGetIDsOfNames_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalGetIDsOfNames_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalInvoke_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalInvoke_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetDocumentation_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        refPtrFlags: DWORD,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetDocumentation_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetDllEntry_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        invKind: INVOKEKIND,
        refPtrFlags: DWORD,
        pBstrDllName: *mut BSTR,
        pBstrName: *mut BSTR,
        pwOrdinal: *mut WORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetDllEntry_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalAddressOfMember_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalAddressOfMember_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteCreateInstance_Proxy(
        This: *mut ITypeInfo,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteCreateInstance_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetContainingTypeLib_Proxy(
        This: *mut ITypeInfo,
        ppTLib: *mut *mut ITypeLib,
        pIndex: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_RemoteGetContainingTypeLib_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseTypeAttr_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseTypeAttr_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseFuncDesc_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseFuncDesc_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseVarDesc_Proxy(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_LocalReleaseVarDesc_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPTYPEINFO2 = *mut ITypeInfo2;
unsafe extern "C" {
    pub static IID_ITypeInfo2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeInfo2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo2) -> ULONG>,
    pub GetTypeAttr: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, ppTypeAttr: *mut *mut TYPEATTR) -> HRESULT,
    >,
    pub GetTypeComp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, ppTComp: *mut *mut ITypeComp) -> HRESULT,
    >,
    pub GetFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            ppFuncDesc: *mut *mut FUNCDESC,
        ) -> HRESULT,
    >,
    pub GetVarDesc: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            ppVarDesc: *mut *mut VARDESC,
        ) -> HRESULT,
    >,
    pub GetNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            rgBstrNames: *mut BSTR,
            cMaxNames: UINT,
            pcNames: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetRefTypeOfImplType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            pRefType: *mut HREFTYPE,
        ) -> HRESULT,
    >,
    pub GetImplTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            pImplTypeFlags: *mut INT,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            pMemId: *mut MEMBERID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            pvInstance: PVOID,
            memid: MEMBERID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetDocumentation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            pBstrName: *mut BSTR,
            pBstrDocString: *mut BSTR,
            pdwHelpContext: *mut DWORD,
            pBstrHelpFile: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetDllEntry: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            invKind: INVOKEKIND,
            pBstrDllName: *mut BSTR,
            pBstrName: *mut BSTR,
            pwOrdinal: *mut WORD,
        ) -> HRESULT,
    >,
    pub GetRefTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            hRefType: HREFTYPE,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub AddressOfMember: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            invKind: INVOKEKIND,
            ppv: *mut PVOID,
        ) -> HRESULT,
    >,
    pub CreateInstance: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            pUnkOuter: *mut IUnknown,
            riid: *const IID,
            ppvObj: *mut PVOID,
        ) -> HRESULT,
    >,
    pub GetMops: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            pBstrMops: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetContainingTypeLib: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            ppTLib: *mut *mut ITypeLib,
            pIndex: *mut UINT,
        ) -> HRESULT,
    >,
    pub ReleaseTypeAttr: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, pTypeAttr: *mut TYPEATTR),
    >,
    pub ReleaseFuncDesc: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, pFuncDesc: *mut FUNCDESC),
    >,
    pub ReleaseVarDesc:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeInfo2, pVarDesc: *mut VARDESC)>,
    pub GetTypeKind: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, pTypeKind: *mut TYPEKIND) -> HRESULT,
    >,
    pub GetTypeFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, pTypeFlags: *mut ULONG) -> HRESULT,
    >,
    pub GetFuncIndexOfMemId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            invKind: INVOKEKIND,
            pFuncIndex: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetVarIndexOfMemId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            pVarIndex: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetFuncCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetParamCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            indexFunc: UINT,
            indexParam: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetVarCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetImplTypeCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetDocumentation2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            memid: MEMBERID,
            lcid: LCID,
            pbstrHelpString: *mut BSTR,
            pdwHelpStringContext: *mut DWORD,
            pbstrHelpStringDll: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetAllCustData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeInfo2, pCustData: *mut CUSTDATA) -> HRESULT,
    >,
    pub GetAllFuncCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            pCustData: *mut CUSTDATA,
        ) -> HRESULT,
    >,
    pub GetAllParamCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            indexFunc: UINT,
            indexParam: UINT,
            pCustData: *mut CUSTDATA,
        ) -> HRESULT,
    >,
    pub GetAllVarCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            pCustData: *mut CUSTDATA,
        ) -> HRESULT,
    >,
    pub GetAllImplTypeCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeInfo2,
            index: UINT,
            pCustData: *mut CUSTDATA,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeInfo2Vtbl"][::std::mem::size_of::<ITypeInfo2Vtbl>() - 296usize];
    ["Alignment of ITypeInfo2Vtbl"][::std::mem::align_of::<ITypeInfo2Vtbl>() - 8usize];
    ["Offset of field: ITypeInfo2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeInfo2Vtbl::AddRef"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, AddRef) - 8usize];
    ["Offset of field: ITypeInfo2Vtbl::Release"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, Release) - 16usize];
    ["Offset of field: ITypeInfo2Vtbl::GetTypeAttr"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetTypeAttr) - 24usize];
    ["Offset of field: ITypeInfo2Vtbl::GetTypeComp"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetTypeComp) - 32usize];
    ["Offset of field: ITypeInfo2Vtbl::GetFuncDesc"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetFuncDesc) - 40usize];
    ["Offset of field: ITypeInfo2Vtbl::GetVarDesc"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetVarDesc) - 48usize];
    ["Offset of field: ITypeInfo2Vtbl::GetNames"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetNames) - 56usize];
    ["Offset of field: ITypeInfo2Vtbl::GetRefTypeOfImplType"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetRefTypeOfImplType) - 64usize];
    ["Offset of field: ITypeInfo2Vtbl::GetImplTypeFlags"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetImplTypeFlags) - 72usize];
    ["Offset of field: ITypeInfo2Vtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetIDsOfNames) - 80usize];
    ["Offset of field: ITypeInfo2Vtbl::Invoke"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, Invoke) - 88usize];
    ["Offset of field: ITypeInfo2Vtbl::GetDocumentation"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetDocumentation) - 96usize];
    ["Offset of field: ITypeInfo2Vtbl::GetDllEntry"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetDllEntry) - 104usize];
    ["Offset of field: ITypeInfo2Vtbl::GetRefTypeInfo"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetRefTypeInfo) - 112usize];
    ["Offset of field: ITypeInfo2Vtbl::AddressOfMember"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, AddressOfMember) - 120usize];
    ["Offset of field: ITypeInfo2Vtbl::CreateInstance"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, CreateInstance) - 128usize];
    ["Offset of field: ITypeInfo2Vtbl::GetMops"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetMops) - 136usize];
    ["Offset of field: ITypeInfo2Vtbl::GetContainingTypeLib"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetContainingTypeLib) - 144usize];
    ["Offset of field: ITypeInfo2Vtbl::ReleaseTypeAttr"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, ReleaseTypeAttr) - 152usize];
    ["Offset of field: ITypeInfo2Vtbl::ReleaseFuncDesc"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, ReleaseFuncDesc) - 160usize];
    ["Offset of field: ITypeInfo2Vtbl::ReleaseVarDesc"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, ReleaseVarDesc) - 168usize];
    ["Offset of field: ITypeInfo2Vtbl::GetTypeKind"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetTypeKind) - 176usize];
    ["Offset of field: ITypeInfo2Vtbl::GetTypeFlags"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetTypeFlags) - 184usize];
    ["Offset of field: ITypeInfo2Vtbl::GetFuncIndexOfMemId"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetFuncIndexOfMemId) - 192usize];
    ["Offset of field: ITypeInfo2Vtbl::GetVarIndexOfMemId"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetVarIndexOfMemId) - 200usize];
    ["Offset of field: ITypeInfo2Vtbl::GetCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetCustData) - 208usize];
    ["Offset of field: ITypeInfo2Vtbl::GetFuncCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetFuncCustData) - 216usize];
    ["Offset of field: ITypeInfo2Vtbl::GetParamCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetParamCustData) - 224usize];
    ["Offset of field: ITypeInfo2Vtbl::GetVarCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetVarCustData) - 232usize];
    ["Offset of field: ITypeInfo2Vtbl::GetImplTypeCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetImplTypeCustData) - 240usize];
    ["Offset of field: ITypeInfo2Vtbl::GetDocumentation2"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetDocumentation2) - 248usize];
    ["Offset of field: ITypeInfo2Vtbl::GetAllCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetAllCustData) - 256usize];
    ["Offset of field: ITypeInfo2Vtbl::GetAllFuncCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetAllFuncCustData) - 264usize];
    ["Offset of field: ITypeInfo2Vtbl::GetAllParamCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetAllParamCustData) - 272usize];
    ["Offset of field: ITypeInfo2Vtbl::GetAllVarCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetAllVarCustData) - 280usize];
    ["Offset of field: ITypeInfo2Vtbl::GetAllImplTypeCustData"]
        [::std::mem::offset_of!(ITypeInfo2Vtbl, GetAllImplTypeCustData) - 288usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeInfo2 {
    pub lpVtbl: *mut ITypeInfo2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeInfo2"][::std::mem::size_of::<ITypeInfo2>() - 8usize];
    ["Alignment of ITypeInfo2"][::std::mem::align_of::<ITypeInfo2>() - 8usize];
    ["Offset of field: ITypeInfo2::lpVtbl"][::std::mem::offset_of!(ITypeInfo2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ITypeInfo2_RemoteGetDocumentation2_Proxy(
        This: *mut ITypeInfo2,
        memid: MEMBERID,
        lcid: LCID,
        refPtrFlags: DWORD,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo2_RemoteGetDocumentation2_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0010_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0010_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub const tagSYSKIND_SYS_WIN16: tagSYSKIND = 0;
pub const tagSYSKIND_SYS_WIN32: tagSYSKIND = 1;
pub const tagSYSKIND_SYS_MAC: tagSYSKIND = 2;
pub const tagSYSKIND_SYS_WIN64: tagSYSKIND = 3;
pub type tagSYSKIND = ::std::os::raw::c_int;
pub use self::tagSYSKIND as SYSKIND;
pub const tagLIBFLAGS_LIBFLAG_FRESTRICTED: tagLIBFLAGS = 1;
pub const tagLIBFLAGS_LIBFLAG_FCONTROL: tagLIBFLAGS = 2;
pub const tagLIBFLAGS_LIBFLAG_FHIDDEN: tagLIBFLAGS = 4;
pub const tagLIBFLAGS_LIBFLAG_FHASDISKIMAGE: tagLIBFLAGS = 8;
pub type tagLIBFLAGS = ::std::os::raw::c_int;
pub use self::tagLIBFLAGS as LIBFLAGS;
pub type LPTYPELIB = *mut ITypeLib;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagTLIBATTR {
    pub guid: GUID,
    pub lcid: LCID,
    pub syskind: SYSKIND,
    pub wMajorVerNum: WORD,
    pub wMinorVerNum: WORD,
    pub wLibFlags: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagTLIBATTR"][::std::mem::size_of::<tagTLIBATTR>() - 32usize];
    ["Alignment of tagTLIBATTR"][::std::mem::align_of::<tagTLIBATTR>() - 4usize];
    ["Offset of field: tagTLIBATTR::guid"][::std::mem::offset_of!(tagTLIBATTR, guid) - 0usize];
    ["Offset of field: tagTLIBATTR::lcid"][::std::mem::offset_of!(tagTLIBATTR, lcid) - 16usize];
    ["Offset of field: tagTLIBATTR::syskind"]
        [::std::mem::offset_of!(tagTLIBATTR, syskind) - 20usize];
    ["Offset of field: tagTLIBATTR::wMajorVerNum"]
        [::std::mem::offset_of!(tagTLIBATTR, wMajorVerNum) - 24usize];
    ["Offset of field: tagTLIBATTR::wMinorVerNum"]
        [::std::mem::offset_of!(tagTLIBATTR, wMinorVerNum) - 26usize];
    ["Offset of field: tagTLIBATTR::wLibFlags"]
        [::std::mem::offset_of!(tagTLIBATTR, wLibFlags) - 28usize];
};
pub type TLIBATTR = tagTLIBATTR;
pub type LPTLIBATTR = *mut tagTLIBATTR;
unsafe extern "C" {
    pub static IID_ITypeLib: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLibVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib) -> UINT>,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            index: UINT,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetTypeInfoType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib, index: UINT, pTKind: *mut TYPEKIND) -> HRESULT,
    >,
    pub GetTypeInfoOfGuid: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            guid: *const GUID,
            ppTinfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetLibAttr: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib, ppTLibAttr: *mut *mut TLIBATTR) -> HRESULT,
    >,
    pub GetTypeComp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib, ppTComp: *mut *mut ITypeComp) -> HRESULT,
    >,
    pub GetDocumentation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            index: INT,
            pBstrName: *mut BSTR,
            pBstrDocString: *mut BSTR,
            pdwHelpContext: *mut DWORD,
            pBstrHelpFile: *mut BSTR,
        ) -> HRESULT,
    >,
    pub IsName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            szNameBuf: LPOLESTR,
            lHashVal: ULONG,
            pfName: *mut BOOL,
        ) -> HRESULT,
    >,
    pub FindName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib,
            szNameBuf: LPOLESTR,
            lHashVal: ULONG,
            ppTInfo: *mut *mut ITypeInfo,
            rgMemId: *mut MEMBERID,
            pcFound: *mut USHORT,
        ) -> HRESULT,
    >,
    pub ReleaseTLibAttr:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib, pTLibAttr: *mut TLIBATTR)>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLibVtbl"][::std::mem::size_of::<ITypeLibVtbl>() - 104usize];
    ["Alignment of ITypeLibVtbl"][::std::mem::align_of::<ITypeLibVtbl>() - 8usize];
    ["Offset of field: ITypeLibVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeLibVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeLibVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeLibVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeLibVtbl::Release"]
        [::std::mem::offset_of!(ITypeLibVtbl, Release) - 16usize];
    ["Offset of field: ITypeLibVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: ITypeLibVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: ITypeLibVtbl::GetTypeInfoType"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetTypeInfoType) - 40usize];
    ["Offset of field: ITypeLibVtbl::GetTypeInfoOfGuid"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetTypeInfoOfGuid) - 48usize];
    ["Offset of field: ITypeLibVtbl::GetLibAttr"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetLibAttr) - 56usize];
    ["Offset of field: ITypeLibVtbl::GetTypeComp"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetTypeComp) - 64usize];
    ["Offset of field: ITypeLibVtbl::GetDocumentation"]
        [::std::mem::offset_of!(ITypeLibVtbl, GetDocumentation) - 72usize];
    ["Offset of field: ITypeLibVtbl::IsName"]
        [::std::mem::offset_of!(ITypeLibVtbl, IsName) - 80usize];
    ["Offset of field: ITypeLibVtbl::FindName"]
        [::std::mem::offset_of!(ITypeLibVtbl, FindName) - 88usize];
    ["Offset of field: ITypeLibVtbl::ReleaseTLibAttr"]
        [::std::mem::offset_of!(ITypeLibVtbl, ReleaseTLibAttr) - 96usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLib {
    pub lpVtbl: *mut ITypeLibVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLib"][::std::mem::size_of::<ITypeLib>() - 8usize];
    ["Alignment of ITypeLib"][::std::mem::align_of::<ITypeLib>() - 8usize];
    ["Offset of field: ITypeLib::lpVtbl"][::std::mem::offset_of!(ITypeLib, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetTypeInfoCount_Proxy(
        This: *mut ITypeLib,
        pcTInfo: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetTypeInfoCount_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetLibAttr_Proxy(
        This: *mut ITypeLib,
        ppTLibAttr: *mut LPTLIBATTR,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetLibAttr_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetDocumentation_Proxy(
        This: *mut ITypeLib,
        index: INT,
        refPtrFlags: DWORD,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteGetDocumentation_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteIsName_Proxy(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        pfName: *mut BOOL,
        pBstrLibName: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteIsName_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteFindName_Proxy(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
        rgMemId: *mut MEMBERID,
        pcFound: *mut USHORT,
        pBstrLibName: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_RemoteFindName_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib_LocalReleaseTLibAttr_Proxy(This: *mut ITypeLib) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_LocalReleaseTLibAttr_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0011_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0011_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPTYPELIB2 = *mut ITypeLib2;
unsafe extern "C" {
    pub static IID_ITypeLib2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLib2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib2) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib2) -> UINT>,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            index: UINT,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetTypeInfoType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib2, index: UINT, pTKind: *mut TYPEKIND) -> HRESULT,
    >,
    pub GetTypeInfoOfGuid: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            guid: *const GUID,
            ppTinfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetLibAttr: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib2, ppTLibAttr: *mut *mut TLIBATTR) -> HRESULT,
    >,
    pub GetTypeComp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib2, ppTComp: *mut *mut ITypeComp) -> HRESULT,
    >,
    pub GetDocumentation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            index: INT,
            pBstrName: *mut BSTR,
            pBstrDocString: *mut BSTR,
            pdwHelpContext: *mut DWORD,
            pBstrHelpFile: *mut BSTR,
        ) -> HRESULT,
    >,
    pub IsName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            szNameBuf: LPOLESTR,
            lHashVal: ULONG,
            pfName: *mut BOOL,
        ) -> HRESULT,
    >,
    pub FindName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            szNameBuf: LPOLESTR,
            lHashVal: ULONG,
            ppTInfo: *mut *mut ITypeInfo,
            rgMemId: *mut MEMBERID,
            pcFound: *mut USHORT,
        ) -> HRESULT,
    >,
    pub ReleaseTLibAttr:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLib2, pTLibAttr: *mut TLIBATTR)>,
    pub GetCustData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            guid: *const GUID,
            pVarVal: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetLibStatistics: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            pcUniqueNames: *mut ULONG,
            pcchUniqueNames: *mut ULONG,
        ) -> HRESULT,
    >,
    pub GetDocumentation2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLib2,
            index: INT,
            lcid: LCID,
            pbstrHelpString: *mut BSTR,
            pdwHelpStringContext: *mut DWORD,
            pbstrHelpStringDll: *mut BSTR,
        ) -> HRESULT,
    >,
    pub GetAllCustData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLib2, pCustData: *mut CUSTDATA) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLib2Vtbl"][::std::mem::size_of::<ITypeLib2Vtbl>() - 136usize];
    ["Alignment of ITypeLib2Vtbl"][::std::mem::align_of::<ITypeLib2Vtbl>() - 8usize];
    ["Offset of field: ITypeLib2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeLib2Vtbl::AddRef"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, AddRef) - 8usize];
    ["Offset of field: ITypeLib2Vtbl::Release"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, Release) - 16usize];
    ["Offset of field: ITypeLib2Vtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: ITypeLib2Vtbl::GetTypeInfo"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetTypeInfo) - 32usize];
    ["Offset of field: ITypeLib2Vtbl::GetTypeInfoType"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetTypeInfoType) - 40usize];
    ["Offset of field: ITypeLib2Vtbl::GetTypeInfoOfGuid"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetTypeInfoOfGuid) - 48usize];
    ["Offset of field: ITypeLib2Vtbl::GetLibAttr"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetLibAttr) - 56usize];
    ["Offset of field: ITypeLib2Vtbl::GetTypeComp"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetTypeComp) - 64usize];
    ["Offset of field: ITypeLib2Vtbl::GetDocumentation"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetDocumentation) - 72usize];
    ["Offset of field: ITypeLib2Vtbl::IsName"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, IsName) - 80usize];
    ["Offset of field: ITypeLib2Vtbl::FindName"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, FindName) - 88usize];
    ["Offset of field: ITypeLib2Vtbl::ReleaseTLibAttr"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, ReleaseTLibAttr) - 96usize];
    ["Offset of field: ITypeLib2Vtbl::GetCustData"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetCustData) - 104usize];
    ["Offset of field: ITypeLib2Vtbl::GetLibStatistics"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetLibStatistics) - 112usize];
    ["Offset of field: ITypeLib2Vtbl::GetDocumentation2"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetDocumentation2) - 120usize];
    ["Offset of field: ITypeLib2Vtbl::GetAllCustData"]
        [::std::mem::offset_of!(ITypeLib2Vtbl, GetAllCustData) - 128usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLib2 {
    pub lpVtbl: *mut ITypeLib2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLib2"][::std::mem::size_of::<ITypeLib2>() - 8usize];
    ["Alignment of ITypeLib2"][::std::mem::align_of::<ITypeLib2>() - 8usize];
    ["Offset of field: ITypeLib2::lpVtbl"][::std::mem::offset_of!(ITypeLib2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn ITypeLib2_RemoteGetLibStatistics_Proxy(
        This: *mut ITypeLib2,
        pcUniqueNames: *mut ULONG,
        pcchUniqueNames: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_RemoteGetLibStatistics_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn ITypeLib2_RemoteGetDocumentation2_Proxy(
        This: *mut ITypeLib2,
        index: INT,
        lcid: LCID,
        refPtrFlags: DWORD,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_RemoteGetDocumentation2_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPTYPECHANGEEVENTS = *mut ITypeChangeEvents;
pub const tagCHANGEKIND_CHANGEKIND_ADDMEMBER: tagCHANGEKIND = 0;
pub const tagCHANGEKIND_CHANGEKIND_DELETEMEMBER: tagCHANGEKIND = 1;
pub const tagCHANGEKIND_CHANGEKIND_SETNAMES: tagCHANGEKIND = 2;
pub const tagCHANGEKIND_CHANGEKIND_SETDOCUMENTATION: tagCHANGEKIND = 3;
pub const tagCHANGEKIND_CHANGEKIND_GENERAL: tagCHANGEKIND = 4;
pub const tagCHANGEKIND_CHANGEKIND_INVALIDATE: tagCHANGEKIND = 5;
pub const tagCHANGEKIND_CHANGEKIND_CHANGEFAILED: tagCHANGEKIND = 6;
pub const tagCHANGEKIND_CHANGEKIND_MAX: tagCHANGEKIND = 7;
pub type tagCHANGEKIND = ::std::os::raw::c_int;
pub use self::tagCHANGEKIND as CHANGEKIND;
unsafe extern "C" {
    pub static IID_ITypeChangeEvents: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeChangeEventsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeChangeEvents,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeChangeEvents) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeChangeEvents) -> ULONG>,
    pub RequestTypeChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeChangeEvents,
            changeKind: CHANGEKIND,
            pTInfoBefore: *mut ITypeInfo,
            pStrName: LPOLESTR,
            pfCancel: *mut INT,
        ) -> HRESULT,
    >,
    pub AfterTypeChange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeChangeEvents,
            changeKind: CHANGEKIND,
            pTInfoAfter: *mut ITypeInfo,
            pStrName: LPOLESTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeChangeEventsVtbl"][::std::mem::size_of::<ITypeChangeEventsVtbl>() - 40usize];
    ["Alignment of ITypeChangeEventsVtbl"]
        [::std::mem::align_of::<ITypeChangeEventsVtbl>() - 8usize];
    ["Offset of field: ITypeChangeEventsVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeChangeEventsVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeChangeEventsVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeChangeEventsVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeChangeEventsVtbl::Release"]
        [::std::mem::offset_of!(ITypeChangeEventsVtbl, Release) - 16usize];
    ["Offset of field: ITypeChangeEventsVtbl::RequestTypeChange"]
        [::std::mem::offset_of!(ITypeChangeEventsVtbl, RequestTypeChange) - 24usize];
    ["Offset of field: ITypeChangeEventsVtbl::AfterTypeChange"]
        [::std::mem::offset_of!(ITypeChangeEventsVtbl, AfterTypeChange) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeChangeEvents {
    pub lpVtbl: *mut ITypeChangeEventsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeChangeEvents"][::std::mem::size_of::<ITypeChangeEvents>() - 8usize];
    ["Alignment of ITypeChangeEvents"][::std::mem::align_of::<ITypeChangeEvents>() - 8usize];
    ["Offset of field: ITypeChangeEvents::lpVtbl"]
        [::std::mem::offset_of!(ITypeChangeEvents, lpVtbl) - 0usize];
};
pub type LPERRORINFO = *mut IErrorInfo;
unsafe extern "C" {
    pub static IID_IErrorInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IErrorInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IErrorInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IErrorInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IErrorInfo) -> ULONG>,
    pub GetGUID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IErrorInfo, pGUID: *mut GUID) -> HRESULT,
    >,
    pub GetSource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IErrorInfo, pBstrSource: *mut BSTR) -> HRESULT,
    >,
    pub GetDescription: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IErrorInfo, pBstrDescription: *mut BSTR) -> HRESULT,
    >,
    pub GetHelpFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IErrorInfo, pBstrHelpFile: *mut BSTR) -> HRESULT,
    >,
    pub GetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IErrorInfo, pdwHelpContext: *mut DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IErrorInfoVtbl"][::std::mem::size_of::<IErrorInfoVtbl>() - 64usize];
    ["Alignment of IErrorInfoVtbl"][::std::mem::align_of::<IErrorInfoVtbl>() - 8usize];
    ["Offset of field: IErrorInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IErrorInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IErrorInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IErrorInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IErrorInfoVtbl::Release"]
        [::std::mem::offset_of!(IErrorInfoVtbl, Release) - 16usize];
    ["Offset of field: IErrorInfoVtbl::GetGUID"]
        [::std::mem::offset_of!(IErrorInfoVtbl, GetGUID) - 24usize];
    ["Offset of field: IErrorInfoVtbl::GetSource"]
        [::std::mem::offset_of!(IErrorInfoVtbl, GetSource) - 32usize];
    ["Offset of field: IErrorInfoVtbl::GetDescription"]
        [::std::mem::offset_of!(IErrorInfoVtbl, GetDescription) - 40usize];
    ["Offset of field: IErrorInfoVtbl::GetHelpFile"]
        [::std::mem::offset_of!(IErrorInfoVtbl, GetHelpFile) - 48usize];
    ["Offset of field: IErrorInfoVtbl::GetHelpContext"]
        [::std::mem::offset_of!(IErrorInfoVtbl, GetHelpContext) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IErrorInfo {
    pub lpVtbl: *mut IErrorInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IErrorInfo"][::std::mem::size_of::<IErrorInfo>() - 8usize];
    ["Alignment of IErrorInfo"][::std::mem::align_of::<IErrorInfo>() - 8usize];
    ["Offset of field: IErrorInfo::lpVtbl"][::std::mem::offset_of!(IErrorInfo, lpVtbl) - 0usize];
};
pub type LPCREATEERRORINFO = *mut ICreateErrorInfo;
unsafe extern "C" {
    pub static IID_ICreateErrorInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateErrorInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICreateErrorInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateErrorInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICreateErrorInfo) -> ULONG>,
    pub SetGUID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateErrorInfo, rguid: *const GUID) -> HRESULT,
    >,
    pub SetSource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateErrorInfo, szSource: LPOLESTR) -> HRESULT,
    >,
    pub SetDescription: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateErrorInfo, szDescription: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateErrorInfo, szHelpFile: LPOLESTR) -> HRESULT,
    >,
    pub SetHelpContext: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICreateErrorInfo, dwHelpContext: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateErrorInfoVtbl"][::std::mem::size_of::<ICreateErrorInfoVtbl>() - 64usize];
    ["Alignment of ICreateErrorInfoVtbl"][::std::mem::align_of::<ICreateErrorInfoVtbl>() - 8usize];
    ["Offset of field: ICreateErrorInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICreateErrorInfoVtbl::AddRef"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, AddRef) - 8usize];
    ["Offset of field: ICreateErrorInfoVtbl::Release"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, Release) - 16usize];
    ["Offset of field: ICreateErrorInfoVtbl::SetGUID"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, SetGUID) - 24usize];
    ["Offset of field: ICreateErrorInfoVtbl::SetSource"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, SetSource) - 32usize];
    ["Offset of field: ICreateErrorInfoVtbl::SetDescription"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, SetDescription) - 40usize];
    ["Offset of field: ICreateErrorInfoVtbl::SetHelpFile"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, SetHelpFile) - 48usize];
    ["Offset of field: ICreateErrorInfoVtbl::SetHelpContext"]
        [::std::mem::offset_of!(ICreateErrorInfoVtbl, SetHelpContext) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICreateErrorInfo {
    pub lpVtbl: *mut ICreateErrorInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICreateErrorInfo"][::std::mem::size_of::<ICreateErrorInfo>() - 8usize];
    ["Alignment of ICreateErrorInfo"][::std::mem::align_of::<ICreateErrorInfo>() - 8usize];
    ["Offset of field: ICreateErrorInfo::lpVtbl"]
        [::std::mem::offset_of!(ICreateErrorInfo, lpVtbl) - 0usize];
};
pub type LPSUPPORTERRORINFO = *mut ISupportErrorInfo;
unsafe extern "C" {
    pub static IID_ISupportErrorInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISupportErrorInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISupportErrorInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISupportErrorInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISupportErrorInfo) -> ULONG>,
    pub InterfaceSupportsErrorInfo: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ISupportErrorInfo, riid: *const IID) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISupportErrorInfoVtbl"][::std::mem::size_of::<ISupportErrorInfoVtbl>() - 32usize];
    ["Alignment of ISupportErrorInfoVtbl"]
        [::std::mem::align_of::<ISupportErrorInfoVtbl>() - 8usize];
    ["Offset of field: ISupportErrorInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISupportErrorInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISupportErrorInfoVtbl::AddRef"]
        [::std::mem::offset_of!(ISupportErrorInfoVtbl, AddRef) - 8usize];
    ["Offset of field: ISupportErrorInfoVtbl::Release"]
        [::std::mem::offset_of!(ISupportErrorInfoVtbl, Release) - 16usize];
    ["Offset of field: ISupportErrorInfoVtbl::InterfaceSupportsErrorInfo"]
        [::std::mem::offset_of!(ISupportErrorInfoVtbl, InterfaceSupportsErrorInfo) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISupportErrorInfo {
    pub lpVtbl: *mut ISupportErrorInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISupportErrorInfo"][::std::mem::size_of::<ISupportErrorInfo>() - 8usize];
    ["Alignment of ISupportErrorInfo"][::std::mem::align_of::<ISupportErrorInfo>() - 8usize];
    ["Offset of field: ISupportErrorInfo::lpVtbl"]
        [::std::mem::offset_of!(ISupportErrorInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ITypeFactory: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeFactoryVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeFactory,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeFactory) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeFactory) -> ULONG>,
    pub CreateFromTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeFactory,
            pTypeInfo: *mut ITypeInfo,
            riid: *const IID,
            ppv: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeFactoryVtbl"][::std::mem::size_of::<ITypeFactoryVtbl>() - 32usize];
    ["Alignment of ITypeFactoryVtbl"][::std::mem::align_of::<ITypeFactoryVtbl>() - 8usize];
    ["Offset of field: ITypeFactoryVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeFactoryVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeFactoryVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeFactoryVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeFactoryVtbl::Release"]
        [::std::mem::offset_of!(ITypeFactoryVtbl, Release) - 16usize];
    ["Offset of field: ITypeFactoryVtbl::CreateFromTypeInfo"]
        [::std::mem::offset_of!(ITypeFactoryVtbl, CreateFromTypeInfo) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeFactory {
    pub lpVtbl: *mut ITypeFactoryVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeFactory"][::std::mem::size_of::<ITypeFactory>() - 8usize];
    ["Alignment of ITypeFactory"][::std::mem::align_of::<ITypeFactory>() - 8usize];
    ["Offset of field: ITypeFactory::lpVtbl"]
        [::std::mem::offset_of!(ITypeFactory, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ITypeMarshal: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeMarshalVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeMarshal,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeMarshal) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeMarshal) -> ULONG>,
    pub Size: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeMarshal,
            pvType: PVOID,
            dwDestContext: DWORD,
            pvDestContext: PVOID,
            pSize: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Marshal: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeMarshal,
            pvType: PVOID,
            dwDestContext: DWORD,
            pvDestContext: PVOID,
            cbBufferLength: ULONG,
            pBuffer: *mut BYTE,
            pcbWritten: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Unmarshal: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeMarshal,
            pvType: PVOID,
            dwFlags: DWORD,
            cbBufferLength: ULONG,
            pBuffer: *mut BYTE,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Free: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeMarshal, pvType: PVOID) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeMarshalVtbl"][::std::mem::size_of::<ITypeMarshalVtbl>() - 56usize];
    ["Alignment of ITypeMarshalVtbl"][::std::mem::align_of::<ITypeMarshalVtbl>() - 8usize];
    ["Offset of field: ITypeMarshalVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeMarshalVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeMarshalVtbl::Release"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, Release) - 16usize];
    ["Offset of field: ITypeMarshalVtbl::Size"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, Size) - 24usize];
    ["Offset of field: ITypeMarshalVtbl::Marshal"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, Marshal) - 32usize];
    ["Offset of field: ITypeMarshalVtbl::Unmarshal"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, Unmarshal) - 40usize];
    ["Offset of field: ITypeMarshalVtbl::Free"]
        [::std::mem::offset_of!(ITypeMarshalVtbl, Free) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeMarshal {
    pub lpVtbl: *mut ITypeMarshalVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeMarshal"][::std::mem::size_of::<ITypeMarshal>() - 8usize];
    ["Alignment of ITypeMarshal"][::std::mem::align_of::<ITypeMarshal>() - 8usize];
    ["Offset of field: ITypeMarshal::lpVtbl"]
        [::std::mem::offset_of!(ITypeMarshal, lpVtbl) - 0usize];
};
pub type LPRECORDINFO = *mut IRecordInfo;
unsafe extern "C" {
    pub static IID_IRecordInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRecordInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IRecordInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IRecordInfo) -> ULONG>,
    pub RecordInit: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pvNew: PVOID) -> HRESULT,
    >,
    pub RecordClear: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pvExisting: PVOID) -> HRESULT,
    >,
    pub RecordCopy: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pvExisting: PVOID, pvNew: PVOID) -> HRESULT,
    >,
    pub GetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pguid: *mut GUID) -> HRESULT,
    >,
    pub GetName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pbstrName: *mut BSTR) -> HRESULT,
    >,
    pub GetSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pcbSize: *mut ULONG) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, ppTypeInfo: *mut *mut ITypeInfo) -> HRESULT,
    >,
    pub GetField: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            pvData: PVOID,
            szFieldName: LPCOLESTR,
            pvarField: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetFieldNoCopy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            pvData: PVOID,
            szFieldName: LPCOLESTR,
            pvarField: *mut VARIANT,
            ppvDataCArray: *mut PVOID,
        ) -> HRESULT,
    >,
    pub PutField: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            wFlags: ULONG,
            pvData: PVOID,
            szFieldName: LPCOLESTR,
            pvarField: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub PutFieldNoCopy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            wFlags: ULONG,
            pvData: PVOID,
            szFieldName: LPCOLESTR,
            pvarField: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub GetFieldNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            pcNames: *mut ULONG,
            rgBstrNames: *mut BSTR,
        ) -> HRESULT,
    >,
    pub IsMatchingType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pRecordInfo: *mut IRecordInfo) -> BOOL,
    >,
    pub RecordCreate: ::std::option::Option<unsafe extern "C" fn(This: *mut IRecordInfo) -> PVOID>,
    pub RecordCreateCopy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IRecordInfo,
            pvSource: PVOID,
            ppvDest: *mut PVOID,
        ) -> HRESULT,
    >,
    pub RecordDestroy: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IRecordInfo, pvRecord: PVOID) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRecordInfoVtbl"][::std::mem::size_of::<IRecordInfoVtbl>() - 152usize];
    ["Alignment of IRecordInfoVtbl"][::std::mem::align_of::<IRecordInfoVtbl>() - 8usize];
    ["Offset of field: IRecordInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IRecordInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IRecordInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IRecordInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IRecordInfoVtbl::Release"]
        [::std::mem::offset_of!(IRecordInfoVtbl, Release) - 16usize];
    ["Offset of field: IRecordInfoVtbl::RecordInit"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordInit) - 24usize];
    ["Offset of field: IRecordInfoVtbl::RecordClear"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordClear) - 32usize];
    ["Offset of field: IRecordInfoVtbl::RecordCopy"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordCopy) - 40usize];
    ["Offset of field: IRecordInfoVtbl::GetGuid"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetGuid) - 48usize];
    ["Offset of field: IRecordInfoVtbl::GetName"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetName) - 56usize];
    ["Offset of field: IRecordInfoVtbl::GetSize"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetSize) - 64usize];
    ["Offset of field: IRecordInfoVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetTypeInfo) - 72usize];
    ["Offset of field: IRecordInfoVtbl::GetField"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetField) - 80usize];
    ["Offset of field: IRecordInfoVtbl::GetFieldNoCopy"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetFieldNoCopy) - 88usize];
    ["Offset of field: IRecordInfoVtbl::PutField"]
        [::std::mem::offset_of!(IRecordInfoVtbl, PutField) - 96usize];
    ["Offset of field: IRecordInfoVtbl::PutFieldNoCopy"]
        [::std::mem::offset_of!(IRecordInfoVtbl, PutFieldNoCopy) - 104usize];
    ["Offset of field: IRecordInfoVtbl::GetFieldNames"]
        [::std::mem::offset_of!(IRecordInfoVtbl, GetFieldNames) - 112usize];
    ["Offset of field: IRecordInfoVtbl::IsMatchingType"]
        [::std::mem::offset_of!(IRecordInfoVtbl, IsMatchingType) - 120usize];
    ["Offset of field: IRecordInfoVtbl::RecordCreate"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordCreate) - 128usize];
    ["Offset of field: IRecordInfoVtbl::RecordCreateCopy"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordCreateCopy) - 136usize];
    ["Offset of field: IRecordInfoVtbl::RecordDestroy"]
        [::std::mem::offset_of!(IRecordInfoVtbl, RecordDestroy) - 144usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IRecordInfo {
    pub lpVtbl: *mut IRecordInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IRecordInfo"][::std::mem::size_of::<IRecordInfo>() - 8usize];
    ["Alignment of IRecordInfo"][::std::mem::align_of::<IRecordInfo>() - 8usize];
    ["Offset of field: IRecordInfo::lpVtbl"][::std::mem::offset_of!(IRecordInfo, lpVtbl) - 0usize];
};
pub type LPERRORLOG = *mut IErrorLog;
unsafe extern "C" {
    pub static IID_IErrorLog: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IErrorLogVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IErrorLog,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IErrorLog) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IErrorLog) -> ULONG>,
    pub AddError: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IErrorLog,
            pszPropName: LPCOLESTR,
            pExcepInfo: *mut EXCEPINFO,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IErrorLogVtbl"][::std::mem::size_of::<IErrorLogVtbl>() - 32usize];
    ["Alignment of IErrorLogVtbl"][::std::mem::align_of::<IErrorLogVtbl>() - 8usize];
    ["Offset of field: IErrorLogVtbl::QueryInterface"]
        [::std::mem::offset_of!(IErrorLogVtbl, QueryInterface) - 0usize];
    ["Offset of field: IErrorLogVtbl::AddRef"]
        [::std::mem::offset_of!(IErrorLogVtbl, AddRef) - 8usize];
    ["Offset of field: IErrorLogVtbl::Release"]
        [::std::mem::offset_of!(IErrorLogVtbl, Release) - 16usize];
    ["Offset of field: IErrorLogVtbl::AddError"]
        [::std::mem::offset_of!(IErrorLogVtbl, AddError) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IErrorLog {
    pub lpVtbl: *mut IErrorLogVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IErrorLog"][::std::mem::size_of::<IErrorLog>() - 8usize];
    ["Alignment of IErrorLog"][::std::mem::align_of::<IErrorLog>() - 8usize];
    ["Offset of field: IErrorLog::lpVtbl"][::std::mem::offset_of!(IErrorLog, lpVtbl) - 0usize];
};
pub type LPPROPERTYBAG = *mut IPropertyBag;
unsafe extern "C" {
    pub static IID_IPropertyBag: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertyBagVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyBag,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertyBag) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertyBag) -> ULONG>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyBag,
            pszPropName: LPCOLESTR,
            pVar: *mut VARIANT,
            pErrorLog: *mut IErrorLog,
        ) -> HRESULT,
    >,
    pub Write: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyBag,
            pszPropName: LPCOLESTR,
            pVar: *mut VARIANT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertyBagVtbl"][::std::mem::size_of::<IPropertyBagVtbl>() - 40usize];
    ["Alignment of IPropertyBagVtbl"][::std::mem::align_of::<IPropertyBagVtbl>() - 8usize];
    ["Offset of field: IPropertyBagVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPropertyBagVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPropertyBagVtbl::AddRef"]
        [::std::mem::offset_of!(IPropertyBagVtbl, AddRef) - 8usize];
    ["Offset of field: IPropertyBagVtbl::Release"]
        [::std::mem::offset_of!(IPropertyBagVtbl, Release) - 16usize];
    ["Offset of field: IPropertyBagVtbl::Read"]
        [::std::mem::offset_of!(IPropertyBagVtbl, Read) - 24usize];
    ["Offset of field: IPropertyBagVtbl::Write"]
        [::std::mem::offset_of!(IPropertyBagVtbl, Write) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertyBag {
    pub lpVtbl: *mut IPropertyBagVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertyBag"][::std::mem::size_of::<IPropertyBag>() - 8usize];
    ["Alignment of IPropertyBag"][::std::mem::align_of::<IPropertyBag>() - 8usize];
    ["Offset of field: IPropertyBag::lpVtbl"]
        [::std::mem::offset_of!(IPropertyBag, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IPropertyBag_RemoteRead_Proxy(
        This: *mut IPropertyBag,
        pszPropName: LPCOLESTR,
        pVar: *mut VARIANT,
        pErrorLog: *mut IErrorLog,
        varType: DWORD,
        pUnkObj: *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IPropertyBag_RemoteRead_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static IID_ITypeLibRegistrationReader: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLibRegistrationReaderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLibRegistrationReader,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLibRegistrationReader) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLibRegistrationReader) -> ULONG>,
    pub EnumTypeLibRegistrations: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLibRegistrationReader,
            ppEnumUnknown: *mut *mut IEnumUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLibRegistrationReaderVtbl"]
        [::std::mem::size_of::<ITypeLibRegistrationReaderVtbl>() - 32usize];
    ["Alignment of ITypeLibRegistrationReaderVtbl"]
        [::std::mem::align_of::<ITypeLibRegistrationReaderVtbl>() - 8usize];
    ["Offset of field: ITypeLibRegistrationReaderVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeLibRegistrationReaderVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeLibRegistrationReaderVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeLibRegistrationReaderVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeLibRegistrationReaderVtbl::Release"]
        [::std::mem::offset_of!(ITypeLibRegistrationReaderVtbl, Release) - 16usize];
    ["Offset of field: ITypeLibRegistrationReaderVtbl::EnumTypeLibRegistrations"][::std::mem::offset_of!(
        ITypeLibRegistrationReaderVtbl,
        EnumTypeLibRegistrations
    ) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLibRegistrationReader {
    pub lpVtbl: *mut ITypeLibRegistrationReaderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLibRegistrationReader"]
        [::std::mem::size_of::<ITypeLibRegistrationReader>() - 8usize];
    ["Alignment of ITypeLibRegistrationReader"]
        [::std::mem::align_of::<ITypeLibRegistrationReader>() - 8usize];
    ["Offset of field: ITypeLibRegistrationReader::lpVtbl"]
        [::std::mem::offset_of!(ITypeLibRegistrationReader, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_ITypeLibRegistration: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLibRegistrationVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ITypeLibRegistration,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLibRegistration) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut ITypeLibRegistration) -> ULONG>,
    pub GetGuid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pGuid: *mut GUID) -> HRESULT,
    >,
    pub GetVersion: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pVersion: *mut BSTR) -> HRESULT,
    >,
    pub GetLcid: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pLcid: *mut LCID) -> HRESULT,
    >,
    pub GetWin32Path: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pWin32Path: *mut BSTR) -> HRESULT,
    >,
    pub GetWin64Path: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pWin64Path: *mut BSTR) -> HRESULT,
    >,
    pub GetDisplayName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pDisplayName: *mut BSTR) -> HRESULT,
    >,
    pub GetFlags: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pFlags: *mut DWORD) -> HRESULT,
    >,
    pub GetHelpDir: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ITypeLibRegistration, pHelpDir: *mut BSTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLibRegistrationVtbl"]
        [::std::mem::size_of::<ITypeLibRegistrationVtbl>() - 88usize];
    ["Alignment of ITypeLibRegistrationVtbl"]
        [::std::mem::align_of::<ITypeLibRegistrationVtbl>() - 8usize];
    ["Offset of field: ITypeLibRegistrationVtbl::QueryInterface"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, QueryInterface) - 0usize];
    ["Offset of field: ITypeLibRegistrationVtbl::AddRef"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, AddRef) - 8usize];
    ["Offset of field: ITypeLibRegistrationVtbl::Release"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, Release) - 16usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetGuid"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetGuid) - 24usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetVersion"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetVersion) - 32usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetLcid"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetLcid) - 40usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetWin32Path"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetWin32Path) - 48usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetWin64Path"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetWin64Path) - 56usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetDisplayName"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetDisplayName) - 64usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetFlags"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetFlags) - 72usize];
    ["Offset of field: ITypeLibRegistrationVtbl::GetHelpDir"]
        [::std::mem::offset_of!(ITypeLibRegistrationVtbl, GetHelpDir) - 80usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ITypeLibRegistration {
    pub lpVtbl: *mut ITypeLibRegistrationVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ITypeLibRegistration"][::std::mem::size_of::<ITypeLibRegistration>() - 8usize];
    ["Alignment of ITypeLibRegistration"][::std::mem::align_of::<ITypeLibRegistration>() - 8usize];
    ["Offset of field: ITypeLibRegistration::lpVtbl"]
        [::std::mem::offset_of!(ITypeLibRegistration, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_TypeLibRegistrationReader: CLSID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0023_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oaidl_0000_0023_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn BSTR_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut BSTR,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn BSTR_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut BSTR,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn BSTR_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut BSTR,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn BSTR_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut BSTR);
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserFree(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut CLEANLOCALSTORAGE,
    );
}
unsafe extern "C" {
    pub fn VARIANT_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut VARIANT,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn VARIANT_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut VARIANT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn VARIANT_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut VARIANT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn VARIANT_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut VARIANT);
}
unsafe extern "C" {
    pub fn BSTR_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut BSTR,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn BSTR_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut BSTR,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn BSTR_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut BSTR,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn BSTR_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut BSTR);
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut CLEANLOCALSTORAGE,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn CLEANLOCALSTORAGE_UserFree64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut CLEANLOCALSTORAGE,
    );
}
unsafe extern "C" {
    pub fn VARIANT_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut VARIANT,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn VARIANT_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut VARIANT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn VARIANT_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut VARIANT,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn VARIANT_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut VARIANT);
}
unsafe extern "C" {
    pub fn IDispatch_Invoke_Proxy(
        This: *mut IDispatch,
        dispIdMember: DISPID,
        riid: *const IID,
        lcid: LCID,
        wFlags: WORD,
        pDispParams: *mut DISPPARAMS,
        pVarResult: *mut VARIANT,
        pExcepInfo: *mut EXCEPINFO,
        puArgErr: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IDispatch_Invoke_Stub(
        This: *mut IDispatch,
        dispIdMember: DISPID,
        riid: *const IID,
        lcid: LCID,
        dwFlags: DWORD,
        pDispParams: *mut DISPPARAMS,
        pVarResult: *mut VARIANT,
        pExcepInfo: *mut EXCEPINFO,
        pArgErr: *mut UINT,
        cVarRef: UINT,
        rgVarRefIdx: *mut UINT,
        rgVarRef: *mut VARIANTARG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumVARIANT_Next_Proxy(
        This: *mut IEnumVARIANT,
        celt: ULONG,
        rgVar: *mut VARIANT,
        pCeltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumVARIANT_Next_Stub(
        This: *mut IEnumVARIANT,
        celt: ULONG,
        rgVar: *mut VARIANT,
        pCeltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_Bind_Proxy(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        wFlags: WORD,
        ppTInfo: *mut *mut ITypeInfo,
        pDescKind: *mut DESCKIND,
        pBindPtr: *mut BINDPTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_Bind_Stub(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        wFlags: WORD,
        ppTInfo: *mut *mut ITypeInfo,
        pDescKind: *mut DESCKIND,
        ppFuncDesc: *mut LPFUNCDESC,
        ppVarDesc: *mut LPVARDESC,
        ppTypeComp: *mut *mut ITypeComp,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_BindType_Proxy(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
        ppTComp: *mut *mut ITypeComp,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeComp_BindType_Stub(
        This: *mut ITypeComp,
        szName: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetTypeAttr_Proxy(
        This: *mut ITypeInfo,
        ppTypeAttr: *mut *mut TYPEATTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetTypeAttr_Stub(
        This: *mut ITypeInfo,
        ppTypeAttr: *mut LPTYPEATTR,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetFuncDesc_Proxy(
        This: *mut ITypeInfo,
        index: UINT,
        ppFuncDesc: *mut *mut FUNCDESC,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetFuncDesc_Stub(
        This: *mut ITypeInfo,
        index: UINT,
        ppFuncDesc: *mut LPFUNCDESC,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetVarDesc_Proxy(
        This: *mut ITypeInfo,
        index: UINT,
        ppVarDesc: *mut *mut VARDESC,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetVarDesc_Stub(
        This: *mut ITypeInfo,
        index: UINT,
        ppVarDesc: *mut LPVARDESC,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetNames_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        rgBstrNames: *mut BSTR,
        cMaxNames: UINT,
        pcNames: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetNames_Stub(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        rgBstrNames: *mut BSTR,
        cMaxNames: UINT,
        pcNames: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetIDsOfNames_Proxy(
        This: *mut ITypeInfo,
        rgszNames: *mut LPOLESTR,
        cNames: UINT,
        pMemId: *mut MEMBERID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetIDsOfNames_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_Invoke_Proxy(
        This: *mut ITypeInfo,
        pvInstance: PVOID,
        memid: MEMBERID,
        wFlags: WORD,
        pDispParams: *mut DISPPARAMS,
        pVarResult: *mut VARIANT,
        pExcepInfo: *mut EXCEPINFO,
        puArgErr: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_Invoke_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetDocumentation_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetDocumentation_Stub(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        refPtrFlags: DWORD,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetDllEntry_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        invKind: INVOKEKIND,
        pBstrDllName: *mut BSTR,
        pBstrName: *mut BSTR,
        pwOrdinal: *mut WORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetDllEntry_Stub(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        invKind: INVOKEKIND,
        refPtrFlags: DWORD,
        pBstrDllName: *mut BSTR,
        pBstrName: *mut BSTR,
        pwOrdinal: *mut WORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_AddressOfMember_Proxy(
        This: *mut ITypeInfo,
        memid: MEMBERID,
        invKind: INVOKEKIND,
        ppv: *mut PVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_AddressOfMember_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_CreateInstance_Proxy(
        This: *mut ITypeInfo,
        pUnkOuter: *mut IUnknown,
        riid: *const IID,
        ppvObj: *mut PVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_CreateInstance_Stub(
        This: *mut ITypeInfo,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetContainingTypeLib_Proxy(
        This: *mut ITypeInfo,
        ppTLib: *mut *mut ITypeLib,
        pIndex: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_GetContainingTypeLib_Stub(
        This: *mut ITypeInfo,
        ppTLib: *mut *mut ITypeLib,
        pIndex: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseTypeAttr_Proxy(This: *mut ITypeInfo, pTypeAttr: *mut TYPEATTR);
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseTypeAttr_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseFuncDesc_Proxy(This: *mut ITypeInfo, pFuncDesc: *mut FUNCDESC);
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseFuncDesc_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseVarDesc_Proxy(This: *mut ITypeInfo, pVarDesc: *mut VARDESC);
}
unsafe extern "C" {
    pub fn ITypeInfo_ReleaseVarDesc_Stub(This: *mut ITypeInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo2_GetDocumentation2_Proxy(
        This: *mut ITypeInfo2,
        memid: MEMBERID,
        lcid: LCID,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeInfo2_GetDocumentation2_Stub(
        This: *mut ITypeInfo2,
        memid: MEMBERID,
        lcid: LCID,
        refPtrFlags: DWORD,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetTypeInfoCount_Proxy(This: *mut ITypeLib) -> UINT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetTypeInfoCount_Stub(This: *mut ITypeLib, pcTInfo: *mut UINT) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetLibAttr_Proxy(
        This: *mut ITypeLib,
        ppTLibAttr: *mut *mut TLIBATTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetLibAttr_Stub(
        This: *mut ITypeLib,
        ppTLibAttr: *mut LPTLIBATTR,
        pDummy: *mut CLEANLOCALSTORAGE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetDocumentation_Proxy(
        This: *mut ITypeLib,
        index: INT,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_GetDocumentation_Stub(
        This: *mut ITypeLib,
        index: INT,
        refPtrFlags: DWORD,
        pBstrName: *mut BSTR,
        pBstrDocString: *mut BSTR,
        pdwHelpContext: *mut DWORD,
        pBstrHelpFile: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_IsName_Proxy(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        pfName: *mut BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_IsName_Stub(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        pfName: *mut BOOL,
        pBstrLibName: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_FindName_Proxy(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
        rgMemId: *mut MEMBERID,
        pcFound: *mut USHORT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_FindName_Stub(
        This: *mut ITypeLib,
        szNameBuf: LPOLESTR,
        lHashVal: ULONG,
        ppTInfo: *mut *mut ITypeInfo,
        rgMemId: *mut MEMBERID,
        pcFound: *mut USHORT,
        pBstrLibName: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib_ReleaseTLibAttr_Proxy(This: *mut ITypeLib, pTLibAttr: *mut TLIBATTR);
}
unsafe extern "C" {
    pub fn ITypeLib_ReleaseTLibAttr_Stub(This: *mut ITypeLib) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_GetLibStatistics_Proxy(
        This: *mut ITypeLib2,
        pcUniqueNames: *mut ULONG,
        pcchUniqueNames: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_GetLibStatistics_Stub(
        This: *mut ITypeLib2,
        pcUniqueNames: *mut ULONG,
        pcchUniqueNames: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_GetDocumentation2_Proxy(
        This: *mut ITypeLib2,
        index: INT,
        lcid: LCID,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ITypeLib2_GetDocumentation2_Stub(
        This: *mut ITypeLib2,
        index: INT,
        lcid: LCID,
        refPtrFlags: DWORD,
        pbstrHelpString: *mut BSTR,
        pdwHelpStringContext: *mut DWORD,
        pbstrHelpStringDll: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IPropertyBag_Read_Proxy(
        This: *mut IPropertyBag,
        pszPropName: LPCOLESTR,
        pVar: *mut VARIANT,
        pErrorLog: *mut IErrorLog,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IPropertyBag_Read_Stub(
        This: *mut IPropertyBag,
        pszPropName: LPCOLESTR,
        pVar: *mut VARIANT,
        pErrorLog: *mut IErrorLog,
        varType: DWORD,
        pUnkObj: *mut IUnknown,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagVersionedStream {
    pub guidVersion: GUID,
    pub pStream: *mut IStream,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagVersionedStream"][::std::mem::size_of::<tagVersionedStream>() - 24usize];
    ["Alignment of tagVersionedStream"][::std::mem::align_of::<tagVersionedStream>() - 8usize];
    ["Offset of field: tagVersionedStream::guidVersion"]
        [::std::mem::offset_of!(tagVersionedStream, guidVersion) - 0usize];
    ["Offset of field: tagVersionedStream::pStream"]
        [::std::mem::offset_of!(tagVersionedStream, pStream) - 16usize];
};
pub type VERSIONEDSTREAM = tagVersionedStream;
pub type LPVERSIONEDSTREAM = *mut tagVersionedStream;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAC {
    pub cElems: ULONG,
    pub pElems: *mut CHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAC"][::std::mem::size_of::<tagCAC>() - 16usize];
    ["Alignment of tagCAC"][::std::mem::align_of::<tagCAC>() - 8usize];
    ["Offset of field: tagCAC::cElems"][::std::mem::offset_of!(tagCAC, cElems) - 0usize];
    ["Offset of field: tagCAC::pElems"][::std::mem::offset_of!(tagCAC, pElems) - 8usize];
};
pub type CAC = tagCAC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAUB {
    pub cElems: ULONG,
    pub pElems: *mut UCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAUB"][::std::mem::size_of::<tagCAUB>() - 16usize];
    ["Alignment of tagCAUB"][::std::mem::align_of::<tagCAUB>() - 8usize];
    ["Offset of field: tagCAUB::cElems"][::std::mem::offset_of!(tagCAUB, cElems) - 0usize];
    ["Offset of field: tagCAUB::pElems"][::std::mem::offset_of!(tagCAUB, pElems) - 8usize];
};
pub type CAUB = tagCAUB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAI {
    pub cElems: ULONG,
    pub pElems: *mut SHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAI"][::std::mem::size_of::<tagCAI>() - 16usize];
    ["Alignment of tagCAI"][::std::mem::align_of::<tagCAI>() - 8usize];
    ["Offset of field: tagCAI::cElems"][::std::mem::offset_of!(tagCAI, cElems) - 0usize];
    ["Offset of field: tagCAI::pElems"][::std::mem::offset_of!(tagCAI, pElems) - 8usize];
};
pub type CAI = tagCAI;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAUI {
    pub cElems: ULONG,
    pub pElems: *mut USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAUI"][::std::mem::size_of::<tagCAUI>() - 16usize];
    ["Alignment of tagCAUI"][::std::mem::align_of::<tagCAUI>() - 8usize];
    ["Offset of field: tagCAUI::cElems"][::std::mem::offset_of!(tagCAUI, cElems) - 0usize];
    ["Offset of field: tagCAUI::pElems"][::std::mem::offset_of!(tagCAUI, pElems) - 8usize];
};
pub type CAUI = tagCAUI;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAL {
    pub cElems: ULONG,
    pub pElems: *mut LONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAL"][::std::mem::size_of::<tagCAL>() - 16usize];
    ["Alignment of tagCAL"][::std::mem::align_of::<tagCAL>() - 8usize];
    ["Offset of field: tagCAL::cElems"][::std::mem::offset_of!(tagCAL, cElems) - 0usize];
    ["Offset of field: tagCAL::pElems"][::std::mem::offset_of!(tagCAL, pElems) - 8usize];
};
pub type CAL = tagCAL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAUL {
    pub cElems: ULONG,
    pub pElems: *mut ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAUL"][::std::mem::size_of::<tagCAUL>() - 16usize];
    ["Alignment of tagCAUL"][::std::mem::align_of::<tagCAUL>() - 8usize];
    ["Offset of field: tagCAUL::cElems"][::std::mem::offset_of!(tagCAUL, cElems) - 0usize];
    ["Offset of field: tagCAUL::pElems"][::std::mem::offset_of!(tagCAUL, pElems) - 8usize];
};
pub type CAUL = tagCAUL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAFLT {
    pub cElems: ULONG,
    pub pElems: *mut FLOAT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAFLT"][::std::mem::size_of::<tagCAFLT>() - 16usize];
    ["Alignment of tagCAFLT"][::std::mem::align_of::<tagCAFLT>() - 8usize];
    ["Offset of field: tagCAFLT::cElems"][::std::mem::offset_of!(tagCAFLT, cElems) - 0usize];
    ["Offset of field: tagCAFLT::pElems"][::std::mem::offset_of!(tagCAFLT, pElems) - 8usize];
};
pub type CAFLT = tagCAFLT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCADBL {
    pub cElems: ULONG,
    pub pElems: *mut DOUBLE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCADBL"][::std::mem::size_of::<tagCADBL>() - 16usize];
    ["Alignment of tagCADBL"][::std::mem::align_of::<tagCADBL>() - 8usize];
    ["Offset of field: tagCADBL::cElems"][::std::mem::offset_of!(tagCADBL, cElems) - 0usize];
    ["Offset of field: tagCADBL::pElems"][::std::mem::offset_of!(tagCADBL, pElems) - 8usize];
};
pub type CADBL = tagCADBL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCACY {
    pub cElems: ULONG,
    pub pElems: *mut CY,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCACY"][::std::mem::size_of::<tagCACY>() - 16usize];
    ["Alignment of tagCACY"][::std::mem::align_of::<tagCACY>() - 8usize];
    ["Offset of field: tagCACY::cElems"][::std::mem::offset_of!(tagCACY, cElems) - 0usize];
    ["Offset of field: tagCACY::pElems"][::std::mem::offset_of!(tagCACY, pElems) - 8usize];
};
pub type CACY = tagCACY;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCADATE {
    pub cElems: ULONG,
    pub pElems: *mut DATE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCADATE"][::std::mem::size_of::<tagCADATE>() - 16usize];
    ["Alignment of tagCADATE"][::std::mem::align_of::<tagCADATE>() - 8usize];
    ["Offset of field: tagCADATE::cElems"][::std::mem::offset_of!(tagCADATE, cElems) - 0usize];
    ["Offset of field: tagCADATE::pElems"][::std::mem::offset_of!(tagCADATE, pElems) - 8usize];
};
pub type CADATE = tagCADATE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCABSTR {
    pub cElems: ULONG,
    pub pElems: *mut BSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCABSTR"][::std::mem::size_of::<tagCABSTR>() - 16usize];
    ["Alignment of tagCABSTR"][::std::mem::align_of::<tagCABSTR>() - 8usize];
    ["Offset of field: tagCABSTR::cElems"][::std::mem::offset_of!(tagCABSTR, cElems) - 0usize];
    ["Offset of field: tagCABSTR::pElems"][::std::mem::offset_of!(tagCABSTR, pElems) - 8usize];
};
pub type CABSTR = tagCABSTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCABSTRBLOB {
    pub cElems: ULONG,
    pub pElems: *mut BSTRBLOB,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCABSTRBLOB"][::std::mem::size_of::<tagCABSTRBLOB>() - 16usize];
    ["Alignment of tagCABSTRBLOB"][::std::mem::align_of::<tagCABSTRBLOB>() - 8usize];
    ["Offset of field: tagCABSTRBLOB::cElems"]
        [::std::mem::offset_of!(tagCABSTRBLOB, cElems) - 0usize];
    ["Offset of field: tagCABSTRBLOB::pElems"]
        [::std::mem::offset_of!(tagCABSTRBLOB, pElems) - 8usize];
};
pub type CABSTRBLOB = tagCABSTRBLOB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCABOOL {
    pub cElems: ULONG,
    pub pElems: *mut VARIANT_BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCABOOL"][::std::mem::size_of::<tagCABOOL>() - 16usize];
    ["Alignment of tagCABOOL"][::std::mem::align_of::<tagCABOOL>() - 8usize];
    ["Offset of field: tagCABOOL::cElems"][::std::mem::offset_of!(tagCABOOL, cElems) - 0usize];
    ["Offset of field: tagCABOOL::pElems"][::std::mem::offset_of!(tagCABOOL, pElems) - 8usize];
};
pub type CABOOL = tagCABOOL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCASCODE {
    pub cElems: ULONG,
    pub pElems: *mut SCODE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCASCODE"][::std::mem::size_of::<tagCASCODE>() - 16usize];
    ["Alignment of tagCASCODE"][::std::mem::align_of::<tagCASCODE>() - 8usize];
    ["Offset of field: tagCASCODE::cElems"][::std::mem::offset_of!(tagCASCODE, cElems) - 0usize];
    ["Offset of field: tagCASCODE::pElems"][::std::mem::offset_of!(tagCASCODE, pElems) - 8usize];
};
pub type CASCODE = tagCASCODE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAPROPVARIANT {
    pub cElems: ULONG,
    pub pElems: *mut PROPVARIANT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAPROPVARIANT"][::std::mem::size_of::<tagCAPROPVARIANT>() - 16usize];
    ["Alignment of tagCAPROPVARIANT"][::std::mem::align_of::<tagCAPROPVARIANT>() - 8usize];
    ["Offset of field: tagCAPROPVARIANT::cElems"]
        [::std::mem::offset_of!(tagCAPROPVARIANT, cElems) - 0usize];
    ["Offset of field: tagCAPROPVARIANT::pElems"]
        [::std::mem::offset_of!(tagCAPROPVARIANT, pElems) - 8usize];
};
pub type CAPROPVARIANT = tagCAPROPVARIANT;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAH {
    pub cElems: ULONG,
    pub pElems: *mut LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAH"][::std::mem::size_of::<tagCAH>() - 16usize];
    ["Alignment of tagCAH"][::std::mem::align_of::<tagCAH>() - 8usize];
    ["Offset of field: tagCAH::cElems"][::std::mem::offset_of!(tagCAH, cElems) - 0usize];
    ["Offset of field: tagCAH::pElems"][::std::mem::offset_of!(tagCAH, pElems) - 8usize];
};
pub type CAH = tagCAH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAUH {
    pub cElems: ULONG,
    pub pElems: *mut ULARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAUH"][::std::mem::size_of::<tagCAUH>() - 16usize];
    ["Alignment of tagCAUH"][::std::mem::align_of::<tagCAUH>() - 8usize];
    ["Offset of field: tagCAUH::cElems"][::std::mem::offset_of!(tagCAUH, cElems) - 0usize];
    ["Offset of field: tagCAUH::pElems"][::std::mem::offset_of!(tagCAUH, pElems) - 8usize];
};
pub type CAUH = tagCAUH;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCALPSTR {
    pub cElems: ULONG,
    pub pElems: *mut LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCALPSTR"][::std::mem::size_of::<tagCALPSTR>() - 16usize];
    ["Alignment of tagCALPSTR"][::std::mem::align_of::<tagCALPSTR>() - 8usize];
    ["Offset of field: tagCALPSTR::cElems"][::std::mem::offset_of!(tagCALPSTR, cElems) - 0usize];
    ["Offset of field: tagCALPSTR::pElems"][::std::mem::offset_of!(tagCALPSTR, pElems) - 8usize];
};
pub type CALPSTR = tagCALPSTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCALPWSTR {
    pub cElems: ULONG,
    pub pElems: *mut LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCALPWSTR"][::std::mem::size_of::<tagCALPWSTR>() - 16usize];
    ["Alignment of tagCALPWSTR"][::std::mem::align_of::<tagCALPWSTR>() - 8usize];
    ["Offset of field: tagCALPWSTR::cElems"][::std::mem::offset_of!(tagCALPWSTR, cElems) - 0usize];
    ["Offset of field: tagCALPWSTR::pElems"][::std::mem::offset_of!(tagCALPWSTR, pElems) - 8usize];
};
pub type CALPWSTR = tagCALPWSTR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCAFILETIME {
    pub cElems: ULONG,
    pub pElems: *mut FILETIME,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCAFILETIME"][::std::mem::size_of::<tagCAFILETIME>() - 16usize];
    ["Alignment of tagCAFILETIME"][::std::mem::align_of::<tagCAFILETIME>() - 8usize];
    ["Offset of field: tagCAFILETIME::cElems"]
        [::std::mem::offset_of!(tagCAFILETIME, cElems) - 0usize];
    ["Offset of field: tagCAFILETIME::pElems"]
        [::std::mem::offset_of!(tagCAFILETIME, pElems) - 8usize];
};
pub type CAFILETIME = tagCAFILETIME;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCACLIPDATA {
    pub cElems: ULONG,
    pub pElems: *mut CLIPDATA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCACLIPDATA"][::std::mem::size_of::<tagCACLIPDATA>() - 16usize];
    ["Alignment of tagCACLIPDATA"][::std::mem::align_of::<tagCACLIPDATA>() - 8usize];
    ["Offset of field: tagCACLIPDATA::cElems"]
        [::std::mem::offset_of!(tagCACLIPDATA, cElems) - 0usize];
    ["Offset of field: tagCACLIPDATA::pElems"]
        [::std::mem::offset_of!(tagCACLIPDATA, pElems) - 8usize];
};
pub type CACLIPDATA = tagCACLIPDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCACLSID {
    pub cElems: ULONG,
    pub pElems: *mut CLSID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCACLSID"][::std::mem::size_of::<tagCACLSID>() - 16usize];
    ["Alignment of tagCACLSID"][::std::mem::align_of::<tagCACLSID>() - 8usize];
    ["Offset of field: tagCACLSID::cElems"][::std::mem::offset_of!(tagCACLSID, cElems) - 0usize];
    ["Offset of field: tagCACLSID::pElems"][::std::mem::offset_of!(tagCACLSID, pElems) - 8usize];
};
pub type CACLSID = tagCACLSID;
pub type PROPVAR_PAD1 = WORD;
pub type PROPVAR_PAD2 = WORD;
pub type PROPVAR_PAD3 = WORD;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagPROPVARIANT {
    pub __bindgen_anon_1: tagPROPVARIANT__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagPROPVARIANT__bindgen_ty_1 {
    pub __bindgen_anon_1: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1,
    pub decVal: DECIMAL,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1 {
    pub vt: VARTYPE,
    pub wReserved1: PROPVAR_PAD1,
    pub wReserved2: PROPVAR_PAD2,
    pub wReserved3: PROPVAR_PAD3,
    pub __bindgen_anon_1: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 {
    pub cVal: CHAR,
    pub bVal: UCHAR,
    pub iVal: SHORT,
    pub uiVal: USHORT,
    pub lVal: LONG,
    pub ulVal: ULONG,
    pub intVal: INT,
    pub uintVal: UINT,
    pub hVal: LARGE_INTEGER,
    pub uhVal: ULARGE_INTEGER,
    pub fltVal: FLOAT,
    pub dblVal: DOUBLE,
    pub boolVal: VARIANT_BOOL,
    pub __OBSOLETE__VARIANT_BOOL: VARIANT_BOOL,
    pub scode: SCODE,
    pub cyVal: CY,
    pub date: DATE,
    pub filetime: FILETIME,
    pub puuid: *mut CLSID,
    pub pclipdata: *mut CLIPDATA,
    pub bstrVal: BSTR,
    pub bstrblobVal: BSTRBLOB,
    pub blob: BLOB,
    pub pszVal: LPSTR,
    pub pwszVal: LPWSTR,
    pub punkVal: *mut IUnknown,
    pub pdispVal: *mut IDispatch,
    pub pStream: *mut IStream,
    pub pStorage: *mut IStorage,
    pub pVersionedStream: LPVERSIONEDSTREAM,
    pub parray: LPSAFEARRAY,
    pub cac: CAC,
    pub caub: CAUB,
    pub cai: CAI,
    pub caui: CAUI,
    pub cal: CAL,
    pub caul: CAUL,
    pub cah: CAH,
    pub cauh: CAUH,
    pub caflt: CAFLT,
    pub cadbl: CADBL,
    pub cabool: CABOOL,
    pub cascode: CASCODE,
    pub cacy: CACY,
    pub cadate: CADATE,
    pub cafiletime: CAFILETIME,
    pub cauuid: CACLSID,
    pub caclipdata: CACLIPDATA,
    pub cabstr: CABSTR,
    pub cabstrblob: CABSTRBLOB,
    pub calpstr: CALPSTR,
    pub calpwstr: CALPWSTR,
    pub capropvar: CAPROPVARIANT,
    pub pcVal: *mut CHAR,
    pub pbVal: *mut UCHAR,
    pub piVal: *mut SHORT,
    pub puiVal: *mut USHORT,
    pub plVal: *mut LONG,
    pub pulVal: *mut ULONG,
    pub pintVal: *mut INT,
    pub puintVal: *mut UINT,
    pub pfltVal: *mut FLOAT,
    pub pdblVal: *mut DOUBLE,
    pub pboolVal: *mut VARIANT_BOOL,
    pub pdecVal: *mut DECIMAL,
    pub pscode: *mut SCODE,
    pub pcyVal: *mut CY,
    pub pdate: *mut DATE,
    pub pbstrVal: *mut BSTR,
    pub ppunkVal: *mut *mut IUnknown,
    pub ppdispVal: *mut *mut IDispatch,
    pub pparray: *mut LPSAFEARRAY,
    pub pvarVal: *mut PROPVARIANT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"][::std::mem::size_of::<
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    >() - 16usize];
    ["Alignment of tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1"][::std::mem::align_of::<
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
    >() - 8usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cVal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::bVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        bVal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::iVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        iVal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::uiVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        uiVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::lVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        lVal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ulVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ulVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::intVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        intVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::uintVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        uintVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::hVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        hVal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::uhVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        uhVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::fltVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        fltVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::dblVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        dblVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::boolVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        boolVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::__OBSOLETE__VARIANT_BOOL"] [:: std :: mem :: offset_of ! (tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , __OBSOLETE__VARIANT_BOOL) - 0usize] ;
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::scode"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        scode
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cyVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cyVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::date"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        date
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::filetime"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        filetime
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::puuid"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        puuid
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pclipdata"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pclipdata
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::bstrVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        bstrVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::bstrblobVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        bstrblobVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::blob"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        blob
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pszVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pszVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pwszVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pwszVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::punkVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        punkVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdispVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdispVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pStream"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pStream
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pStorage"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pStorage
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pVersionedStream"] [:: std :: mem :: offset_of ! (tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1 , pVersionedStream) - 0usize] ;
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::parray"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        parray
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cac"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cac
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::caub"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        caub
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cai"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cai
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::caui"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        caui
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cal
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::caul"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        caul
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cah"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cah
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cauh"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cauh
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::caflt"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        caflt
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cadbl"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cadbl
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cabool"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cabool
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cascode"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cascode
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cacy"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cacy
    ) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cadate"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cadate
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cafiletime"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cafiletime
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cauuid"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cauuid
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::caclipdata"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        caclipdata
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cabstr"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cabstr
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::cabstrblob"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        cabstrblob
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::calpstr"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        calpstr
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::calpwstr"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        calpwstr
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::capropvar"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        capropvar
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pcVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pcVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pbVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pbVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::piVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        piVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::puiVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        puiVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::plVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        plVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pulVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pulVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pintVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pintVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::puintVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        puintVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pfltVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pfltVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdblVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdblVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pboolVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pboolVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdecVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdecVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pscode"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pscode
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pcyVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pcyVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pdate"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pdate
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pbstrVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pbstrVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ppunkVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ppunkVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::ppdispVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        ppdispVal
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pparray"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pparray
    )
        - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1::pvarVal"][::std::mem::offset_of!(
        tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1__bindgen_ty_1,
        pvarVal
    )
        - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1>() - 24usize];
    ["Alignment of tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1::vt"]
        [::std::mem::offset_of!(tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1, vt) - 0usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved1"]
        [::std::mem::offset_of!(tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved1) - 2usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved2"]
        [::std::mem::offset_of!(tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved2) - 4usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1::wReserved3"]
        [::std::mem::offset_of!(tagPROPVARIANT__bindgen_ty_1__bindgen_ty_1, wReserved3) - 6usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPVARIANT__bindgen_ty_1"]
        [::std::mem::size_of::<tagPROPVARIANT__bindgen_ty_1>() - 24usize];
    ["Alignment of tagPROPVARIANT__bindgen_ty_1"]
        [::std::mem::align_of::<tagPROPVARIANT__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagPROPVARIANT__bindgen_ty_1::decVal"]
        [::std::mem::offset_of!(tagPROPVARIANT__bindgen_ty_1, decVal) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPVARIANT"][::std::mem::size_of::<tagPROPVARIANT>() - 24usize];
    ["Alignment of tagPROPVARIANT"][::std::mem::align_of::<tagPROPVARIANT>() - 8usize];
};
pub type LPPROPVARIANT = *mut tagPROPVARIANT;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tagPROPSPEC {
    pub ulKind: ULONG,
    pub __bindgen_anon_1: tagPROPSPEC__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tagPROPSPEC__bindgen_ty_1 {
    pub propid: PROPID,
    pub lpwstr: LPOLESTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPSPEC__bindgen_ty_1"]
        [::std::mem::size_of::<tagPROPSPEC__bindgen_ty_1>() - 8usize];
    ["Alignment of tagPROPSPEC__bindgen_ty_1"]
        [::std::mem::align_of::<tagPROPSPEC__bindgen_ty_1>() - 8usize];
    ["Offset of field: tagPROPSPEC__bindgen_ty_1::propid"]
        [::std::mem::offset_of!(tagPROPSPEC__bindgen_ty_1, propid) - 0usize];
    ["Offset of field: tagPROPSPEC__bindgen_ty_1::lpwstr"]
        [::std::mem::offset_of!(tagPROPSPEC__bindgen_ty_1, lpwstr) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPROPSPEC"][::std::mem::size_of::<tagPROPSPEC>() - 16usize];
    ["Alignment of tagPROPSPEC"][::std::mem::align_of::<tagPROPSPEC>() - 8usize];
    ["Offset of field: tagPROPSPEC::ulKind"][::std::mem::offset_of!(tagPROPSPEC, ulKind) - 0usize];
};
pub type PROPSPEC = tagPROPSPEC;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTATPROPSTG {
    pub lpwstrName: LPOLESTR,
    pub propid: PROPID,
    pub vt: VARTYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTATPROPSTG"][::std::mem::size_of::<tagSTATPROPSTG>() - 16usize];
    ["Alignment of tagSTATPROPSTG"][::std::mem::align_of::<tagSTATPROPSTG>() - 8usize];
    ["Offset of field: tagSTATPROPSTG::lpwstrName"]
        [::std::mem::offset_of!(tagSTATPROPSTG, lpwstrName) - 0usize];
    ["Offset of field: tagSTATPROPSTG::propid"]
        [::std::mem::offset_of!(tagSTATPROPSTG, propid) - 8usize];
    ["Offset of field: tagSTATPROPSTG::vt"][::std::mem::offset_of!(tagSTATPROPSTG, vt) - 12usize];
};
pub type STATPROPSTG = tagSTATPROPSTG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTATPROPSETSTG {
    pub fmtid: FMTID,
    pub clsid: CLSID,
    pub grfFlags: DWORD,
    pub mtime: FILETIME,
    pub ctime: FILETIME,
    pub atime: FILETIME,
    pub dwOSVersion: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTATPROPSETSTG"][::std::mem::size_of::<tagSTATPROPSETSTG>() - 64usize];
    ["Alignment of tagSTATPROPSETSTG"][::std::mem::align_of::<tagSTATPROPSETSTG>() - 4usize];
    ["Offset of field: tagSTATPROPSETSTG::fmtid"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, fmtid) - 0usize];
    ["Offset of field: tagSTATPROPSETSTG::clsid"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, clsid) - 16usize];
    ["Offset of field: tagSTATPROPSETSTG::grfFlags"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, grfFlags) - 32usize];
    ["Offset of field: tagSTATPROPSETSTG::mtime"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, mtime) - 36usize];
    ["Offset of field: tagSTATPROPSETSTG::ctime"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, ctime) - 44usize];
    ["Offset of field: tagSTATPROPSETSTG::atime"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, atime) - 52usize];
    ["Offset of field: tagSTATPROPSETSTG::dwOSVersion"]
        [::std::mem::offset_of!(tagSTATPROPSETSTG, dwOSVersion) - 60usize];
};
pub type STATPROPSETSTG = tagSTATPROPSETSTG;
unsafe extern "C" {
    pub static mut __MIDL_itf_propidlbase_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_propidlbase_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IPropertyStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertyStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertyStorage) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertyStorage) -> ULONG>,
    pub ReadMultiple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpspec: ULONG,
            rgpspec: *const PROPSPEC,
            rgpropvar: *mut PROPVARIANT,
        ) -> HRESULT,
    >,
    pub WriteMultiple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpspec: ULONG,
            rgpspec: *const PROPSPEC,
            rgpropvar: *const PROPVARIANT,
            propidNameFirst: PROPID,
        ) -> HRESULT,
    >,
    pub DeleteMultiple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpspec: ULONG,
            rgpspec: *const PROPSPEC,
        ) -> HRESULT,
    >,
    pub ReadPropertyNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpropid: ULONG,
            rgpropid: *const PROPID,
            rglpwstrName: *mut LPOLESTR,
        ) -> HRESULT,
    >,
    pub WritePropertyNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpropid: ULONG,
            rgpropid: *const PROPID,
            rglpwstrName: *const LPOLESTR,
        ) -> HRESULT,
    >,
    pub DeletePropertyNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            cpropid: ULONG,
            rgpropid: *const PROPID,
        ) -> HRESULT,
    >,
    pub Commit: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPropertyStorage, grfCommitFlags: DWORD) -> HRESULT,
    >,
    pub Revert: ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertyStorage) -> HRESULT>,
    pub Enum: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            ppenum: *mut *mut IEnumSTATPROPSTG,
        ) -> HRESULT,
    >,
    pub SetTimes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            pctime: *const FILETIME,
            patime: *const FILETIME,
            pmtime: *const FILETIME,
        ) -> HRESULT,
    >,
    pub SetClass: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPropertyStorage, clsid: *const IID) -> HRESULT,
    >,
    pub Stat: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertyStorage,
            pstatpsstg: *mut STATPROPSETSTG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertyStorageVtbl"][::std::mem::size_of::<IPropertyStorageVtbl>() - 120usize];
    ["Alignment of IPropertyStorageVtbl"][::std::mem::align_of::<IPropertyStorageVtbl>() - 8usize];
    ["Offset of field: IPropertyStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPropertyStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IPropertyStorageVtbl::Release"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, Release) - 16usize];
    ["Offset of field: IPropertyStorageVtbl::ReadMultiple"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, ReadMultiple) - 24usize];
    ["Offset of field: IPropertyStorageVtbl::WriteMultiple"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, WriteMultiple) - 32usize];
    ["Offset of field: IPropertyStorageVtbl::DeleteMultiple"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, DeleteMultiple) - 40usize];
    ["Offset of field: IPropertyStorageVtbl::ReadPropertyNames"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, ReadPropertyNames) - 48usize];
    ["Offset of field: IPropertyStorageVtbl::WritePropertyNames"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, WritePropertyNames) - 56usize];
    ["Offset of field: IPropertyStorageVtbl::DeletePropertyNames"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, DeletePropertyNames) - 64usize];
    ["Offset of field: IPropertyStorageVtbl::Commit"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, Commit) - 72usize];
    ["Offset of field: IPropertyStorageVtbl::Revert"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, Revert) - 80usize];
    ["Offset of field: IPropertyStorageVtbl::Enum"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, Enum) - 88usize];
    ["Offset of field: IPropertyStorageVtbl::SetTimes"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, SetTimes) - 96usize];
    ["Offset of field: IPropertyStorageVtbl::SetClass"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, SetClass) - 104usize];
    ["Offset of field: IPropertyStorageVtbl::Stat"]
        [::std::mem::offset_of!(IPropertyStorageVtbl, Stat) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertyStorage {
    pub lpVtbl: *mut IPropertyStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertyStorage"][::std::mem::size_of::<IPropertyStorage>() - 8usize];
    ["Alignment of IPropertyStorage"][::std::mem::align_of::<IPropertyStorage>() - 8usize];
    ["Offset of field: IPropertyStorage::lpVtbl"]
        [::std::mem::offset_of!(IPropertyStorage, lpVtbl) - 0usize];
};
pub type LPPROPERTYSETSTORAGE = *mut IPropertySetStorage;
unsafe extern "C" {
    pub static IID_IPropertySetStorage: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertySetStorageVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertySetStorage,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertySetStorage) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPropertySetStorage) -> ULONG>,
    pub Create: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertySetStorage,
            rfmtid: *const IID,
            pclsid: *const CLSID,
            grfFlags: DWORD,
            grfMode: DWORD,
            ppprstg: *mut *mut IPropertyStorage,
        ) -> HRESULT,
    >,
    pub Open: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertySetStorage,
            rfmtid: *const IID,
            grfMode: DWORD,
            ppprstg: *mut *mut IPropertyStorage,
        ) -> HRESULT,
    >,
    pub Delete: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPropertySetStorage, rfmtid: *const IID) -> HRESULT,
    >,
    pub Enum: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPropertySetStorage,
            ppenum: *mut *mut IEnumSTATPROPSETSTG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertySetStorageVtbl"][::std::mem::size_of::<IPropertySetStorageVtbl>() - 56usize];
    ["Alignment of IPropertySetStorageVtbl"]
        [::std::mem::align_of::<IPropertySetStorageVtbl>() - 8usize];
    ["Offset of field: IPropertySetStorageVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPropertySetStorageVtbl::AddRef"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, AddRef) - 8usize];
    ["Offset of field: IPropertySetStorageVtbl::Release"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, Release) - 16usize];
    ["Offset of field: IPropertySetStorageVtbl::Create"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, Create) - 24usize];
    ["Offset of field: IPropertySetStorageVtbl::Open"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, Open) - 32usize];
    ["Offset of field: IPropertySetStorageVtbl::Delete"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, Delete) - 40usize];
    ["Offset of field: IPropertySetStorageVtbl::Enum"]
        [::std::mem::offset_of!(IPropertySetStorageVtbl, Enum) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPropertySetStorage {
    pub lpVtbl: *mut IPropertySetStorageVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPropertySetStorage"][::std::mem::size_of::<IPropertySetStorage>() - 8usize];
    ["Alignment of IPropertySetStorage"][::std::mem::align_of::<IPropertySetStorage>() - 8usize];
    ["Offset of field: IPropertySetStorage::lpVtbl"]
        [::std::mem::offset_of!(IPropertySetStorage, lpVtbl) - 0usize];
};
pub type LPENUMSTATPROPSTG = *mut IEnumSTATPROPSTG;
unsafe extern "C" {
    pub static IID_IEnumSTATPROPSTG: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATPROPSTGVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSTG,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSTG) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSTG) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSTG,
            celt: ULONG,
            rgelt: *mut STATPROPSTG,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATPROPSTG, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSTG) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSTG,
            ppenum: *mut *mut IEnumSTATPROPSTG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATPROPSTGVtbl"][::std::mem::size_of::<IEnumSTATPROPSTGVtbl>() - 56usize];
    ["Alignment of IEnumSTATPROPSTGVtbl"][::std::mem::align_of::<IEnumSTATPROPSTGVtbl>() - 8usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::Release"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, Release) - 16usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::Next"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, Next) - 24usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::Skip"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, Skip) - 32usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::Reset"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, Reset) - 40usize];
    ["Offset of field: IEnumSTATPROPSTGVtbl::Clone"]
        [::std::mem::offset_of!(IEnumSTATPROPSTGVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATPROPSTG {
    pub lpVtbl: *mut IEnumSTATPROPSTGVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATPROPSTG"][::std::mem::size_of::<IEnumSTATPROPSTG>() - 8usize];
    ["Alignment of IEnumSTATPROPSTG"][::std::mem::align_of::<IEnumSTATPROPSTG>() - 8usize];
    ["Offset of field: IEnumSTATPROPSTG::lpVtbl"]
        [::std::mem::offset_of!(IEnumSTATPROPSTG, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumSTATPROPSTG_RemoteNext_Proxy(
        This: *mut IEnumSTATPROPSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSTG_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPENUMSTATPROPSETSTG = *mut IEnumSTATPROPSETSTG;
unsafe extern "C" {
    pub static IID_IEnumSTATPROPSETSTG: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATPROPSETSTGVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSETSTG,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSETSTG) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSETSTG) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSETSTG,
            celt: ULONG,
            rgelt: *mut STATPROPSETSTG,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumSTATPROPSETSTG, celt: ULONG) -> HRESULT,
    >,
    pub Reset:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumSTATPROPSETSTG) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumSTATPROPSETSTG,
            ppenum: *mut *mut IEnumSTATPROPSETSTG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATPROPSETSTGVtbl"][::std::mem::size_of::<IEnumSTATPROPSETSTGVtbl>() - 56usize];
    ["Alignment of IEnumSTATPROPSETSTGVtbl"]
        [::std::mem::align_of::<IEnumSTATPROPSETSTGVtbl>() - 8usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::Release"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, Release) - 16usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::Next"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, Next) - 24usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::Skip"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, Skip) - 32usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::Reset"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, Reset) - 40usize];
    ["Offset of field: IEnumSTATPROPSETSTGVtbl::Clone"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTGVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumSTATPROPSETSTG {
    pub lpVtbl: *mut IEnumSTATPROPSETSTGVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumSTATPROPSETSTG"][::std::mem::size_of::<IEnumSTATPROPSETSTG>() - 8usize];
    ["Alignment of IEnumSTATPROPSETSTG"][::std::mem::align_of::<IEnumSTATPROPSETSTG>() - 8usize];
    ["Offset of field: IEnumSTATPROPSETSTG::lpVtbl"]
        [::std::mem::offset_of!(IEnumSTATPROPSETSTG, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumSTATPROPSETSTG_RemoteNext_Proxy(
        This: *mut IEnumSTATPROPSETSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSETSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSETSTG_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPPROPERTYSTORAGE = *mut IPropertyStorage;
unsafe extern "C" {
    pub static mut __MIDL_itf_propidlbase_0000_0004_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_propidlbase_0000_0004_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut LPSAFEARRAY,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut LPSAFEARRAY,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut LPSAFEARRAY,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut LPSAFEARRAY);
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut LPSAFEARRAY,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut LPSAFEARRAY,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut LPSAFEARRAY,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn LPSAFEARRAY_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut LPSAFEARRAY);
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSTG_Next_Proxy(
        This: *mut IEnumSTATPROPSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSTG_Next_Stub(
        This: *mut IEnumSTATPROPSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSETSTG_Next_Proxy(
        This: *mut IEnumSTATPROPSETSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSETSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumSTATPROPSETSTG_Next_Stub(
        This: *mut IEnumSTATPROPSETSTG,
        celt: ULONG,
        rgelt: *mut STATPROPSETSTG,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
pub type STGFMT = DWORD;
unsafe extern "C" {
    pub fn StgCreateDocfile(
        pwcsName: *const WCHAR,
        grfMode: DWORD,
        reserved: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgCreateDocfileOnILockBytes(
        plkbyt: *mut ILockBytes,
        grfMode: DWORD,
        reserved: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenStorage(
        pwcsName: *const WCHAR,
        pstgPriority: *mut IStorage,
        grfMode: DWORD,
        snbExclude: SNB,
        reserved: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenStorageOnILockBytes(
        plkbyt: *mut ILockBytes,
        pstgPriority: *mut IStorage,
        grfMode: DWORD,
        snbExclude: SNB,
        reserved: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgIsStorageFile(pwcsName: *const WCHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgIsStorageILockBytes(plkbyt: *mut ILockBytes) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgSetTimes(
        lpszName: *const WCHAR,
        pctime: *const FILETIME,
        patime: *const FILETIME,
        pmtime: *const FILETIME,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTGOPTIONS {
    pub usVersion: USHORT,
    pub reserved: USHORT,
    pub ulSectorSize: ULONG,
    pub pwcsTemplateFile: *const WCHAR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTGOPTIONS"][::std::mem::size_of::<tagSTGOPTIONS>() - 16usize];
    ["Alignment of tagSTGOPTIONS"][::std::mem::align_of::<tagSTGOPTIONS>() - 8usize];
    ["Offset of field: tagSTGOPTIONS::usVersion"]
        [::std::mem::offset_of!(tagSTGOPTIONS, usVersion) - 0usize];
    ["Offset of field: tagSTGOPTIONS::reserved"]
        [::std::mem::offset_of!(tagSTGOPTIONS, reserved) - 2usize];
    ["Offset of field: tagSTGOPTIONS::ulSectorSize"]
        [::std::mem::offset_of!(tagSTGOPTIONS, ulSectorSize) - 4usize];
    ["Offset of field: tagSTGOPTIONS::pwcsTemplateFile"]
        [::std::mem::offset_of!(tagSTGOPTIONS, pwcsTemplateFile) - 8usize];
};
pub type STGOPTIONS = tagSTGOPTIONS;
unsafe extern "C" {
    pub fn StgCreateStorageEx(
        pwcsName: *const WCHAR,
        grfMode: DWORD,
        stgfmt: DWORD,
        grfAttrs: DWORD,
        pStgOptions: *mut STGOPTIONS,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        riid: *const IID,
        ppObjectOpen: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenStorageEx(
        pwcsName: *const WCHAR,
        grfMode: DWORD,
        stgfmt: DWORD,
        grfAttrs: DWORD,
        pStgOptions: *mut STGOPTIONS,
        pSecurityDescriptor: PSECURITY_DESCRIPTOR,
        riid: *const IID,
        ppObjectOpen: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgCreatePropStg(
        pUnk: *mut IUnknown,
        fmtid: *const IID,
        pclsid: *const CLSID,
        grfFlags: DWORD,
        dwReserved: DWORD,
        ppPropStg: *mut *mut IPropertyStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenPropStg(
        pUnk: *mut IUnknown,
        fmtid: *const IID,
        grfFlags: DWORD,
        dwReserved: DWORD,
        ppPropStg: *mut *mut IPropertyStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgCreatePropSetStg(
        pStorage: *mut IStorage,
        dwReserved: DWORD,
        ppPropSetStg: *mut *mut IPropertySetStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn FmtIdToPropStgName(pfmtid: *const FMTID, oszName: LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn PropStgNameToFmtId(oszName: LPOLESTR, pfmtid: *mut FMTID) -> HRESULT;
}
unsafe extern "C" {
    pub fn ReadClassStg(pStg: LPSTORAGE, pclsid: *mut CLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn WriteClassStg(pStg: LPSTORAGE, rclsid: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn ReadClassStm(pStm: LPSTREAM, pclsid: *mut CLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn WriteClassStm(pStm: LPSTREAM, rclsid: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetHGlobalFromILockBytes(plkbyt: LPLOCKBYTES, phglobal: *mut HGLOBAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateILockBytesOnHGlobal(
        hGlobal: HGLOBAL,
        fDeleteOnRelease: BOOL,
        pplkbyt: *mut LPLOCKBYTES,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetConvertStg(pStg: LPSTORAGE) -> HRESULT;
}
pub const tagCOINIT_COINIT_APARTMENTTHREADED: tagCOINIT = 2;
pub const tagCOINIT_COINIT_MULTITHREADED: tagCOINIT = 0;
pub const tagCOINIT_COINIT_DISABLE_OLE1DDE: tagCOINIT = 4;
pub const tagCOINIT_COINIT_SPEED_OVER_MEMORY: tagCOINIT = 8;
pub type tagCOINIT = ::std::os::raw::c_int;
pub use self::tagCOINIT as COINIT;
unsafe extern "C" {
    pub fn CoBuildVersion() -> DWORD;
}
unsafe extern "C" {
    pub fn CoInitialize(pvReserved: LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterMallocSpy(pMallocSpy: LPMALLOCSPY) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRevokeMallocSpy() -> HRESULT;
}
unsafe extern "C" {
    pub fn CoCreateStandardMalloc(memctx: DWORD, ppMalloc: *mut *mut IMalloc) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterInitializeSpy(
        pSpy: *mut IInitializeSpy,
        puliCookie: *mut ULARGE_INTEGER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRevokeInitializeSpy(uliCookie: ULARGE_INTEGER) -> HRESULT;
}
pub const tagCOMSD_SD_LAUNCHPERMISSIONS: tagCOMSD = 0;
pub const tagCOMSD_SD_ACCESSPERMISSIONS: tagCOMSD = 1;
pub const tagCOMSD_SD_LAUNCHRESTRICTIONS: tagCOMSD = 2;
pub const tagCOMSD_SD_ACCESSRESTRICTIONS: tagCOMSD = 3;
pub type tagCOMSD = ::std::os::raw::c_int;
pub use self::tagCOMSD as COMSD;
unsafe extern "C" {
    pub fn CoGetSystemSecurityPermissions(
        comSDType: COMSD,
        ppSD: *mut PSECURITY_DESCRIPTOR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoLoadLibrary(lpszLibName: LPOLESTR, bAutoFree: BOOL) -> HINSTANCE;
}
unsafe extern "C" {
    pub fn CoFreeLibrary(hInst: HINSTANCE);
}
unsafe extern "C" {
    pub fn CoFreeAllLibraries();
}
unsafe extern "C" {
    pub fn CoGetInstanceFromFile(
        pServerInfo: *mut COSERVERINFO,
        pClsid: *mut CLSID,
        punkOuter: *mut IUnknown,
        dwClsCtx: DWORD,
        grfMode: DWORD,
        pwszName: *mut OLECHAR,
        dwCount: DWORD,
        pResults: *mut MULTI_QI,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetInstanceFromIStorage(
        pServerInfo: *mut COSERVERINFO,
        pClsid: *mut CLSID,
        punkOuter: *mut IUnknown,
        dwClsCtx: DWORD,
        pstg: *mut IStorage,
        dwCount: DWORD,
        pResults: *mut MULTI_QI,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoAllowSetForegroundWindow(pUnk: *mut IUnknown, lpvReserved: LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn DcomChannelSetHResult(
        pvReserved: LPVOID,
        pulReserved: *mut ULONG,
        appsHR: HRESULT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoIsOle1Class(rclsid: *const IID) -> BOOL;
}
unsafe extern "C" {
    pub fn CoFileTimeToDosDateTime(
        lpFileTime: *mut FILETIME,
        lpDosDate: LPWORD,
        lpDosTime: LPWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CoDosDateTimeToFileTime(
        nDosDate: WORD,
        nDosTime: WORD,
        lpFileTime: *mut FILETIME,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CoRegisterMessageFilter(
        lpMessageFilter: LPMESSAGEFILTER,
        lplpMessageFilter: *mut LPMESSAGEFILTER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoRegisterChannelHook(
        ExtensionUuid: *const GUID,
        pChannelHook: *mut IChannelHook,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoTreatAsClass(clsidOld: *const IID, clsidNew: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateDataAdviseHolder(ppDAHolder: *mut LPDATAADVISEHOLDER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateDataCache(
        pUnkOuter: LPUNKNOWN,
        rclsid: *const IID,
        iid: *const IID,
        ppv: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenAsyncDocfileOnIFillLockBytes(
        pflb: *mut IFillLockBytes,
        grfMode: DWORD,
        asyncFlags: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgGetIFillLockBytesOnILockBytes(
        pilb: *mut ILockBytes,
        ppflb: *mut *mut IFillLockBytes,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgGetIFillLockBytesOnFile(
        pwcsName: *const OLECHAR,
        ppflb: *mut *mut IFillLockBytes,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn StgOpenLayoutDocfile(
        pwcsDfName: *const OLECHAR,
        grfMode: DWORD,
        reserved: DWORD,
        ppstgOpen: *mut *mut IStorage,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInstall(
        pbc: *mut IBindCtx,
        dwFlags: DWORD,
        pClassSpec: *mut uCLSSPEC,
        pQuery: *mut QUERYCONTEXT,
        pszCodeBase: LPWSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn BindMoniker(
        pmk: LPMONIKER,
        grfOpt: DWORD,
        iidResult: *const IID,
        ppvResult: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetObject(
        pszName: LPCWSTR,
        pBindOptions: *mut BIND_OPTS,
        riid: *const IID,
        ppv: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn MkParseDisplayName(
        pbc: LPBC,
        szUserName: LPCOLESTR,
        pchEaten: *mut ULONG,
        ppmk: *mut LPMONIKER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn MonikerRelativePathTo(
        pmkSrc: LPMONIKER,
        pmkDest: LPMONIKER,
        ppmkRelPath: *mut LPMONIKER,
        dwReserved: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn MonikerCommonPrefixWith(
        pmkThis: LPMONIKER,
        pmkOther: LPMONIKER,
        ppmkCommon: *mut LPMONIKER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateBindCtx(reserved: DWORD, ppbc: *mut LPBC) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateGenericComposite(
        pmkFirst: LPMONIKER,
        pmkRest: LPMONIKER,
        ppmkComposite: *mut LPMONIKER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetClassFile(szFilename: LPCOLESTR, pclsid: *mut CLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateClassMoniker(rclsid: *const IID, ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateFileMoniker(lpszPathName: LPCOLESTR, ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateItemMoniker(
        lpszDelim: LPCOLESTR,
        lpszItem: LPCOLESTR,
        ppmk: *mut LPMONIKER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateAntiMoniker(ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreatePointerMoniker(punk: LPUNKNOWN, ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateObjrefMoniker(punk: LPUNKNOWN, ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetRunningObjectTable(reserved: DWORD, pprot: *mut LPRUNNINGOBJECTTABLE) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPOLEADVISEHOLDER = *mut IOleAdviseHolder;
unsafe extern "C" {
    pub static IID_IOleAdviseHolder: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleAdviseHolderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleAdviseHolder,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleAdviseHolder) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleAdviseHolder) -> ULONG>,
    pub Advise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleAdviseHolder,
            pAdvise: *mut IAdviseSink,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Unadvise: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleAdviseHolder, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleAdviseHolder,
            ppenumAdvise: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
    pub SendOnRename: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleAdviseHolder, pmk: *mut IMoniker) -> HRESULT,
    >,
    pub SendOnSave:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleAdviseHolder) -> HRESULT>,
    pub SendOnClose:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleAdviseHolder) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleAdviseHolderVtbl"][::std::mem::size_of::<IOleAdviseHolderVtbl>() - 72usize];
    ["Alignment of IOleAdviseHolderVtbl"][::std::mem::align_of::<IOleAdviseHolderVtbl>() - 8usize];
    ["Offset of field: IOleAdviseHolderVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleAdviseHolderVtbl::AddRef"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, AddRef) - 8usize];
    ["Offset of field: IOleAdviseHolderVtbl::Release"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, Release) - 16usize];
    ["Offset of field: IOleAdviseHolderVtbl::Advise"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, Advise) - 24usize];
    ["Offset of field: IOleAdviseHolderVtbl::Unadvise"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, Unadvise) - 32usize];
    ["Offset of field: IOleAdviseHolderVtbl::EnumAdvise"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, EnumAdvise) - 40usize];
    ["Offset of field: IOleAdviseHolderVtbl::SendOnRename"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, SendOnRename) - 48usize];
    ["Offset of field: IOleAdviseHolderVtbl::SendOnSave"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, SendOnSave) - 56usize];
    ["Offset of field: IOleAdviseHolderVtbl::SendOnClose"]
        [::std::mem::offset_of!(IOleAdviseHolderVtbl, SendOnClose) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleAdviseHolder {
    pub lpVtbl: *mut IOleAdviseHolderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleAdviseHolder"][::std::mem::size_of::<IOleAdviseHolder>() - 8usize];
    ["Alignment of IOleAdviseHolder"][::std::mem::align_of::<IOleAdviseHolder>() - 8usize];
    ["Offset of field: IOleAdviseHolder::lpVtbl"]
        [::std::mem::offset_of!(IOleAdviseHolder, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPOLECACHE = *mut IOleCache;
unsafe extern "C" {
    pub static IID_IOleCache: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCacheVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCache) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCache) -> ULONG>,
    pub Cache: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache,
            pformatetc: *mut FORMATETC,
            advf: DWORD,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Uncache: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCache, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumCache: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache,
            ppenumSTATDATA: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
    pub InitCache: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCache, pDataObject: *mut IDataObject) -> HRESULT,
    >,
    pub SetData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache,
            pformatetc: *mut FORMATETC,
            pmedium: *mut STGMEDIUM,
            fRelease: BOOL,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCacheVtbl"][::std::mem::size_of::<IOleCacheVtbl>() - 64usize];
    ["Alignment of IOleCacheVtbl"][::std::mem::align_of::<IOleCacheVtbl>() - 8usize];
    ["Offset of field: IOleCacheVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleCacheVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleCacheVtbl::AddRef"]
        [::std::mem::offset_of!(IOleCacheVtbl, AddRef) - 8usize];
    ["Offset of field: IOleCacheVtbl::Release"]
        [::std::mem::offset_of!(IOleCacheVtbl, Release) - 16usize];
    ["Offset of field: IOleCacheVtbl::Cache"]
        [::std::mem::offset_of!(IOleCacheVtbl, Cache) - 24usize];
    ["Offset of field: IOleCacheVtbl::Uncache"]
        [::std::mem::offset_of!(IOleCacheVtbl, Uncache) - 32usize];
    ["Offset of field: IOleCacheVtbl::EnumCache"]
        [::std::mem::offset_of!(IOleCacheVtbl, EnumCache) - 40usize];
    ["Offset of field: IOleCacheVtbl::InitCache"]
        [::std::mem::offset_of!(IOleCacheVtbl, InitCache) - 48usize];
    ["Offset of field: IOleCacheVtbl::SetData"]
        [::std::mem::offset_of!(IOleCacheVtbl, SetData) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCache {
    pub lpVtbl: *mut IOleCacheVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCache"][::std::mem::size_of::<IOleCache>() - 8usize];
    ["Alignment of IOleCache"][::std::mem::align_of::<IOleCache>() - 8usize];
    ["Offset of field: IOleCache::lpVtbl"][::std::mem::offset_of!(IOleCache, lpVtbl) - 0usize];
};
pub type LPOLECACHE2 = *mut IOleCache2;
pub const tagDISCARDCACHE_DISCARDCACHE_SAVEIFDIRTY: tagDISCARDCACHE = 0;
pub const tagDISCARDCACHE_DISCARDCACHE_NOSAVE: tagDISCARDCACHE = 1;
pub type tagDISCARDCACHE = ::std::os::raw::c_int;
pub use self::tagDISCARDCACHE as DISCARDCACHE;
unsafe extern "C" {
    pub static IID_IOleCache2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCache2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCache2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCache2) -> ULONG>,
    pub Cache: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache2,
            pformatetc: *mut FORMATETC,
            advf: DWORD,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Uncache: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCache2, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumCache: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache2,
            ppenumSTATDATA: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
    pub InitCache: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCache2, pDataObject: *mut IDataObject) -> HRESULT,
    >,
    pub SetData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache2,
            pformatetc: *mut FORMATETC,
            pmedium: *mut STGMEDIUM,
            fRelease: BOOL,
        ) -> HRESULT,
    >,
    pub UpdateCache: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCache2,
            pDataObject: LPDATAOBJECT,
            grfUpdf: DWORD,
            pReserved: LPVOID,
        ) -> HRESULT,
    >,
    pub DiscardCache: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCache2, dwDiscardOptions: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCache2Vtbl"][::std::mem::size_of::<IOleCache2Vtbl>() - 80usize];
    ["Alignment of IOleCache2Vtbl"][::std::mem::align_of::<IOleCache2Vtbl>() - 8usize];
    ["Offset of field: IOleCache2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleCache2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleCache2Vtbl::AddRef"]
        [::std::mem::offset_of!(IOleCache2Vtbl, AddRef) - 8usize];
    ["Offset of field: IOleCache2Vtbl::Release"]
        [::std::mem::offset_of!(IOleCache2Vtbl, Release) - 16usize];
    ["Offset of field: IOleCache2Vtbl::Cache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, Cache) - 24usize];
    ["Offset of field: IOleCache2Vtbl::Uncache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, Uncache) - 32usize];
    ["Offset of field: IOleCache2Vtbl::EnumCache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, EnumCache) - 40usize];
    ["Offset of field: IOleCache2Vtbl::InitCache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, InitCache) - 48usize];
    ["Offset of field: IOleCache2Vtbl::SetData"]
        [::std::mem::offset_of!(IOleCache2Vtbl, SetData) - 56usize];
    ["Offset of field: IOleCache2Vtbl::UpdateCache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, UpdateCache) - 64usize];
    ["Offset of field: IOleCache2Vtbl::DiscardCache"]
        [::std::mem::offset_of!(IOleCache2Vtbl, DiscardCache) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCache2 {
    pub lpVtbl: *mut IOleCache2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCache2"][::std::mem::size_of::<IOleCache2>() - 8usize];
    ["Alignment of IOleCache2"][::std::mem::align_of::<IOleCache2>() - 8usize];
    ["Offset of field: IOleCache2::lpVtbl"][::std::mem::offset_of!(IOleCache2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IOleCache2_RemoteUpdateCache_Proxy(
        This: *mut IOleCache2,
        pDataObject: LPDATAOBJECT,
        grfUpdf: DWORD,
        pReserved: LONG_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleCache2_RemoteUpdateCache_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0003_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0003_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPOLECACHECONTROL = *mut IOleCacheControl;
unsafe extern "C" {
    pub static IID_IOleCacheControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCacheControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleCacheControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCacheControl) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCacheControl) -> ULONG>,
    pub OnRun: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleCacheControl, pDataObject: LPDATAOBJECT) -> HRESULT,
    >,
    pub OnStop: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleCacheControl) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCacheControlVtbl"][::std::mem::size_of::<IOleCacheControlVtbl>() - 40usize];
    ["Alignment of IOleCacheControlVtbl"][::std::mem::align_of::<IOleCacheControlVtbl>() - 8usize];
    ["Offset of field: IOleCacheControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleCacheControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleCacheControlVtbl::AddRef"]
        [::std::mem::offset_of!(IOleCacheControlVtbl, AddRef) - 8usize];
    ["Offset of field: IOleCacheControlVtbl::Release"]
        [::std::mem::offset_of!(IOleCacheControlVtbl, Release) - 16usize];
    ["Offset of field: IOleCacheControlVtbl::OnRun"]
        [::std::mem::offset_of!(IOleCacheControlVtbl, OnRun) - 24usize];
    ["Offset of field: IOleCacheControlVtbl::OnStop"]
        [::std::mem::offset_of!(IOleCacheControlVtbl, OnStop) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleCacheControl {
    pub lpVtbl: *mut IOleCacheControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleCacheControl"][::std::mem::size_of::<IOleCacheControl>() - 8usize];
    ["Alignment of IOleCacheControl"][::std::mem::align_of::<IOleCacheControl>() - 8usize];
    ["Offset of field: IOleCacheControl::lpVtbl"]
        [::std::mem::offset_of!(IOleCacheControl, lpVtbl) - 0usize];
};
pub type LPPARSEDISPLAYNAME = *mut IParseDisplayName;
unsafe extern "C" {
    pub static IID_IParseDisplayName: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IParseDisplayNameVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IParseDisplayName,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IParseDisplayName) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IParseDisplayName) -> ULONG>,
    pub ParseDisplayName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IParseDisplayName,
            pbc: *mut IBindCtx,
            pszDisplayName: LPOLESTR,
            pchEaten: *mut ULONG,
            ppmkOut: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IParseDisplayNameVtbl"][::std::mem::size_of::<IParseDisplayNameVtbl>() - 32usize];
    ["Alignment of IParseDisplayNameVtbl"]
        [::std::mem::align_of::<IParseDisplayNameVtbl>() - 8usize];
    ["Offset of field: IParseDisplayNameVtbl::QueryInterface"]
        [::std::mem::offset_of!(IParseDisplayNameVtbl, QueryInterface) - 0usize];
    ["Offset of field: IParseDisplayNameVtbl::AddRef"]
        [::std::mem::offset_of!(IParseDisplayNameVtbl, AddRef) - 8usize];
    ["Offset of field: IParseDisplayNameVtbl::Release"]
        [::std::mem::offset_of!(IParseDisplayNameVtbl, Release) - 16usize];
    ["Offset of field: IParseDisplayNameVtbl::ParseDisplayName"]
        [::std::mem::offset_of!(IParseDisplayNameVtbl, ParseDisplayName) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IParseDisplayName {
    pub lpVtbl: *mut IParseDisplayNameVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IParseDisplayName"][::std::mem::size_of::<IParseDisplayName>() - 8usize];
    ["Alignment of IParseDisplayName"][::std::mem::align_of::<IParseDisplayName>() - 8usize];
    ["Offset of field: IParseDisplayName::lpVtbl"]
        [::std::mem::offset_of!(IParseDisplayName, lpVtbl) - 0usize];
};
pub type LPOLECONTAINER = *mut IOleContainer;
unsafe extern "C" {
    pub static IID_IOleContainer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleContainerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleContainer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleContainer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleContainer) -> ULONG>,
    pub ParseDisplayName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleContainer,
            pbc: *mut IBindCtx,
            pszDisplayName: LPOLESTR,
            pchEaten: *mut ULONG,
            ppmkOut: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub EnumObjects: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleContainer,
            grfFlags: DWORD,
            ppenum: *mut *mut IEnumUnknown,
        ) -> HRESULT,
    >,
    pub LockContainer: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleContainer, fLock: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleContainerVtbl"][::std::mem::size_of::<IOleContainerVtbl>() - 48usize];
    ["Alignment of IOleContainerVtbl"][::std::mem::align_of::<IOleContainerVtbl>() - 8usize];
    ["Offset of field: IOleContainerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleContainerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleContainerVtbl::AddRef"]
        [::std::mem::offset_of!(IOleContainerVtbl, AddRef) - 8usize];
    ["Offset of field: IOleContainerVtbl::Release"]
        [::std::mem::offset_of!(IOleContainerVtbl, Release) - 16usize];
    ["Offset of field: IOleContainerVtbl::ParseDisplayName"]
        [::std::mem::offset_of!(IOleContainerVtbl, ParseDisplayName) - 24usize];
    ["Offset of field: IOleContainerVtbl::EnumObjects"]
        [::std::mem::offset_of!(IOleContainerVtbl, EnumObjects) - 32usize];
    ["Offset of field: IOleContainerVtbl::LockContainer"]
        [::std::mem::offset_of!(IOleContainerVtbl, LockContainer) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleContainer {
    pub lpVtbl: *mut IOleContainerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleContainer"][::std::mem::size_of::<IOleContainer>() - 8usize];
    ["Alignment of IOleContainer"][::std::mem::align_of::<IOleContainer>() - 8usize];
    ["Offset of field: IOleContainer::lpVtbl"]
        [::std::mem::offset_of!(IOleContainer, lpVtbl) - 0usize];
};
pub type LPOLECLIENTSITE = *mut IOleClientSite;
unsafe extern "C" {
    pub static IID_IOleClientSite: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleClientSiteVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleClientSite,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleClientSite) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleClientSite) -> ULONG>,
    pub SaveObject:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleClientSite) -> HRESULT>,
    pub GetMoniker: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleClientSite,
            dwAssign: DWORD,
            dwWhichMoniker: DWORD,
            ppmk: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub GetContainer: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleClientSite,
            ppContainer: *mut *mut IOleContainer,
        ) -> HRESULT,
    >,
    pub ShowObject:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleClientSite) -> HRESULT>,
    pub OnShowWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleClientSite, fShow: BOOL) -> HRESULT,
    >,
    pub RequestNewObjectLayout:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleClientSite) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleClientSiteVtbl"][::std::mem::size_of::<IOleClientSiteVtbl>() - 72usize];
    ["Alignment of IOleClientSiteVtbl"][::std::mem::align_of::<IOleClientSiteVtbl>() - 8usize];
    ["Offset of field: IOleClientSiteVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleClientSiteVtbl::AddRef"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, AddRef) - 8usize];
    ["Offset of field: IOleClientSiteVtbl::Release"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, Release) - 16usize];
    ["Offset of field: IOleClientSiteVtbl::SaveObject"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, SaveObject) - 24usize];
    ["Offset of field: IOleClientSiteVtbl::GetMoniker"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, GetMoniker) - 32usize];
    ["Offset of field: IOleClientSiteVtbl::GetContainer"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, GetContainer) - 40usize];
    ["Offset of field: IOleClientSiteVtbl::ShowObject"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, ShowObject) - 48usize];
    ["Offset of field: IOleClientSiteVtbl::OnShowWindow"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, OnShowWindow) - 56usize];
    ["Offset of field: IOleClientSiteVtbl::RequestNewObjectLayout"]
        [::std::mem::offset_of!(IOleClientSiteVtbl, RequestNewObjectLayout) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleClientSite {
    pub lpVtbl: *mut IOleClientSiteVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleClientSite"][::std::mem::size_of::<IOleClientSite>() - 8usize];
    ["Alignment of IOleClientSite"][::std::mem::align_of::<IOleClientSite>() - 8usize];
    ["Offset of field: IOleClientSite::lpVtbl"]
        [::std::mem::offset_of!(IOleClientSite, lpVtbl) - 0usize];
};
pub type LPOLEOBJECT = *mut IOleObject;
pub const tagOLEGETMONIKER_OLEGETMONIKER_ONLYIFTHERE: tagOLEGETMONIKER = 1;
pub const tagOLEGETMONIKER_OLEGETMONIKER_FORCEASSIGN: tagOLEGETMONIKER = 2;
pub const tagOLEGETMONIKER_OLEGETMONIKER_UNASSIGN: tagOLEGETMONIKER = 3;
pub const tagOLEGETMONIKER_OLEGETMONIKER_TEMPFORUSER: tagOLEGETMONIKER = 4;
pub type tagOLEGETMONIKER = ::std::os::raw::c_int;
pub use self::tagOLEGETMONIKER as OLEGETMONIKER;
pub const tagOLEWHICHMK_OLEWHICHMK_CONTAINER: tagOLEWHICHMK = 1;
pub const tagOLEWHICHMK_OLEWHICHMK_OBJREL: tagOLEWHICHMK = 2;
pub const tagOLEWHICHMK_OLEWHICHMK_OBJFULL: tagOLEWHICHMK = 3;
pub type tagOLEWHICHMK = ::std::os::raw::c_int;
pub use self::tagOLEWHICHMK as OLEWHICHMK;
pub const tagUSERCLASSTYPE_USERCLASSTYPE_FULL: tagUSERCLASSTYPE = 1;
pub const tagUSERCLASSTYPE_USERCLASSTYPE_SHORT: tagUSERCLASSTYPE = 2;
pub const tagUSERCLASSTYPE_USERCLASSTYPE_APPNAME: tagUSERCLASSTYPE = 3;
pub type tagUSERCLASSTYPE = ::std::os::raw::c_int;
pub use self::tagUSERCLASSTYPE as USERCLASSTYPE;
pub const tagOLEMISC_OLEMISC_RECOMPOSEONRESIZE: tagOLEMISC = 1;
pub const tagOLEMISC_OLEMISC_ONLYICONIC: tagOLEMISC = 2;
pub const tagOLEMISC_OLEMISC_INSERTNOTREPLACE: tagOLEMISC = 4;
pub const tagOLEMISC_OLEMISC_STATIC: tagOLEMISC = 8;
pub const tagOLEMISC_OLEMISC_CANTLINKINSIDE: tagOLEMISC = 16;
pub const tagOLEMISC_OLEMISC_CANLINKBYOLE1: tagOLEMISC = 32;
pub const tagOLEMISC_OLEMISC_ISLINKOBJECT: tagOLEMISC = 64;
pub const tagOLEMISC_OLEMISC_INSIDEOUT: tagOLEMISC = 128;
pub const tagOLEMISC_OLEMISC_ACTIVATEWHENVISIBLE: tagOLEMISC = 256;
pub const tagOLEMISC_OLEMISC_RENDERINGISDEVICEINDEPENDENT: tagOLEMISC = 512;
pub const tagOLEMISC_OLEMISC_INVISIBLEATRUNTIME: tagOLEMISC = 1024;
pub const tagOLEMISC_OLEMISC_ALWAYSRUN: tagOLEMISC = 2048;
pub const tagOLEMISC_OLEMISC_ACTSLIKEBUTTON: tagOLEMISC = 4096;
pub const tagOLEMISC_OLEMISC_ACTSLIKELABEL: tagOLEMISC = 8192;
pub const tagOLEMISC_OLEMISC_NOUIACTIVATE: tagOLEMISC = 16384;
pub const tagOLEMISC_OLEMISC_ALIGNABLE: tagOLEMISC = 32768;
pub const tagOLEMISC_OLEMISC_SIMPLEFRAME: tagOLEMISC = 65536;
pub const tagOLEMISC_OLEMISC_SETCLIENTSITEFIRST: tagOLEMISC = 131072;
pub const tagOLEMISC_OLEMISC_IMEMODE: tagOLEMISC = 262144;
pub const tagOLEMISC_OLEMISC_IGNOREACTIVATEWHENVISIBLE: tagOLEMISC = 524288;
pub const tagOLEMISC_OLEMISC_WANTSTOMENUMERGE: tagOLEMISC = 1048576;
pub const tagOLEMISC_OLEMISC_SUPPORTSMULTILEVELUNDO: tagOLEMISC = 2097152;
pub type tagOLEMISC = ::std::os::raw::c_int;
pub use self::tagOLEMISC as OLEMISC;
pub const tagOLECLOSE_OLECLOSE_SAVEIFDIRTY: tagOLECLOSE = 0;
pub const tagOLECLOSE_OLECLOSE_NOSAVE: tagOLECLOSE = 1;
pub const tagOLECLOSE_OLECLOSE_PROMPTSAVE: tagOLECLOSE = 2;
pub type tagOLECLOSE = ::std::os::raw::c_int;
pub use self::tagOLECLOSE as OLECLOSE;
unsafe extern "C" {
    pub static IID_IOleObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleObject) -> ULONG>,
    pub SetClientSite: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleObject, pClientSite: *mut IOleClientSite) -> HRESULT,
    >,
    pub GetClientSite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            ppClientSite: *mut *mut IOleClientSite,
        ) -> HRESULT,
    >,
    pub SetHostNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            szContainerApp: LPCOLESTR,
            szContainerObj: LPCOLESTR,
        ) -> HRESULT,
    >,
    pub Close: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleObject, dwSaveOption: DWORD) -> HRESULT,
    >,
    pub SetMoniker: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwWhichMoniker: DWORD,
            pmk: *mut IMoniker,
        ) -> HRESULT,
    >,
    pub GetMoniker: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwAssign: DWORD,
            dwWhichMoniker: DWORD,
            ppmk: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub InitFromData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            pDataObject: *mut IDataObject,
            fCreation: BOOL,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub GetClipboardData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwReserved: DWORD,
            ppDataObject: *mut *mut IDataObject,
        ) -> HRESULT,
    >,
    pub DoVerb: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            iVerb: LONG,
            lpmsg: LPMSG,
            pActiveSite: *mut IOleClientSite,
            lindex: LONG,
            hwndParent: HWND,
            lprcPosRect: LPCRECT,
        ) -> HRESULT,
    >,
    pub EnumVerbs: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            ppEnumOleVerb: *mut *mut IEnumOLEVERB,
        ) -> HRESULT,
    >,
    pub Update: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleObject) -> HRESULT>,
    pub IsUpToDate: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleObject) -> HRESULT>,
    pub GetUserClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleObject, pClsid: *mut CLSID) -> HRESULT,
    >,
    pub GetUserType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwFormOfType: DWORD,
            pszUserType: *mut LPOLESTR,
        ) -> HRESULT,
    >,
    pub SetExtent: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwDrawAspect: DWORD,
            psizel: *mut SIZEL,
        ) -> HRESULT,
    >,
    pub GetExtent: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwDrawAspect: DWORD,
            psizel: *mut SIZEL,
        ) -> HRESULT,
    >,
    pub Advise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            pAdvSink: *mut IAdviseSink,
            pdwConnection: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Unadvise: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleObject, dwConnection: DWORD) -> HRESULT,
    >,
    pub EnumAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            ppenumAdvise: *mut *mut IEnumSTATDATA,
        ) -> HRESULT,
    >,
    pub GetMiscStatus: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleObject,
            dwAspect: DWORD,
            pdwStatus: *mut DWORD,
        ) -> HRESULT,
    >,
    pub SetColorScheme: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleObject, pLogpal: *mut LOGPALETTE) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleObjectVtbl"][::std::mem::size_of::<IOleObjectVtbl>() - 192usize];
    ["Alignment of IOleObjectVtbl"][::std::mem::align_of::<IOleObjectVtbl>() - 8usize];
    ["Offset of field: IOleObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IOleObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IOleObjectVtbl::Release"]
        [::std::mem::offset_of!(IOleObjectVtbl, Release) - 16usize];
    ["Offset of field: IOleObjectVtbl::SetClientSite"]
        [::std::mem::offset_of!(IOleObjectVtbl, SetClientSite) - 24usize];
    ["Offset of field: IOleObjectVtbl::GetClientSite"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetClientSite) - 32usize];
    ["Offset of field: IOleObjectVtbl::SetHostNames"]
        [::std::mem::offset_of!(IOleObjectVtbl, SetHostNames) - 40usize];
    ["Offset of field: IOleObjectVtbl::Close"]
        [::std::mem::offset_of!(IOleObjectVtbl, Close) - 48usize];
    ["Offset of field: IOleObjectVtbl::SetMoniker"]
        [::std::mem::offset_of!(IOleObjectVtbl, SetMoniker) - 56usize];
    ["Offset of field: IOleObjectVtbl::GetMoniker"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetMoniker) - 64usize];
    ["Offset of field: IOleObjectVtbl::InitFromData"]
        [::std::mem::offset_of!(IOleObjectVtbl, InitFromData) - 72usize];
    ["Offset of field: IOleObjectVtbl::GetClipboardData"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetClipboardData) - 80usize];
    ["Offset of field: IOleObjectVtbl::DoVerb"]
        [::std::mem::offset_of!(IOleObjectVtbl, DoVerb) - 88usize];
    ["Offset of field: IOleObjectVtbl::EnumVerbs"]
        [::std::mem::offset_of!(IOleObjectVtbl, EnumVerbs) - 96usize];
    ["Offset of field: IOleObjectVtbl::Update"]
        [::std::mem::offset_of!(IOleObjectVtbl, Update) - 104usize];
    ["Offset of field: IOleObjectVtbl::IsUpToDate"]
        [::std::mem::offset_of!(IOleObjectVtbl, IsUpToDate) - 112usize];
    ["Offset of field: IOleObjectVtbl::GetUserClassID"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetUserClassID) - 120usize];
    ["Offset of field: IOleObjectVtbl::GetUserType"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetUserType) - 128usize];
    ["Offset of field: IOleObjectVtbl::SetExtent"]
        [::std::mem::offset_of!(IOleObjectVtbl, SetExtent) - 136usize];
    ["Offset of field: IOleObjectVtbl::GetExtent"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetExtent) - 144usize];
    ["Offset of field: IOleObjectVtbl::Advise"]
        [::std::mem::offset_of!(IOleObjectVtbl, Advise) - 152usize];
    ["Offset of field: IOleObjectVtbl::Unadvise"]
        [::std::mem::offset_of!(IOleObjectVtbl, Unadvise) - 160usize];
    ["Offset of field: IOleObjectVtbl::EnumAdvise"]
        [::std::mem::offset_of!(IOleObjectVtbl, EnumAdvise) - 168usize];
    ["Offset of field: IOleObjectVtbl::GetMiscStatus"]
        [::std::mem::offset_of!(IOleObjectVtbl, GetMiscStatus) - 176usize];
    ["Offset of field: IOleObjectVtbl::SetColorScheme"]
        [::std::mem::offset_of!(IOleObjectVtbl, SetColorScheme) - 184usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleObject {
    pub lpVtbl: *mut IOleObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleObject"][::std::mem::size_of::<IOleObject>() - 8usize];
    ["Alignment of IOleObject"][::std::mem::align_of::<IOleObject>() - 8usize];
    ["Offset of field: IOleObject::lpVtbl"][::std::mem::offset_of!(IOleObject, lpVtbl) - 0usize];
};
pub const tagOLERENDER_OLERENDER_NONE: tagOLERENDER = 0;
pub const tagOLERENDER_OLERENDER_DRAW: tagOLERENDER = 1;
pub const tagOLERENDER_OLERENDER_FORMAT: tagOLERENDER = 2;
pub const tagOLERENDER_OLERENDER_ASIS: tagOLERENDER = 3;
pub type tagOLERENDER = ::std::os::raw::c_int;
pub use self::tagOLERENDER as OLERENDER;
pub type LPOLERENDER = *mut OLERENDER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOBJECTDESCRIPTOR {
    pub cbSize: ULONG,
    pub clsid: CLSID,
    pub dwDrawAspect: DWORD,
    pub sizel: SIZEL,
    pub pointl: POINTL,
    pub dwStatus: DWORD,
    pub dwFullUserTypeName: DWORD,
    pub dwSrcOfCopy: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOBJECTDESCRIPTOR"][::std::mem::size_of::<tagOBJECTDESCRIPTOR>() - 52usize];
    ["Alignment of tagOBJECTDESCRIPTOR"][::std::mem::align_of::<tagOBJECTDESCRIPTOR>() - 4usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::cbSize"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, cbSize) - 0usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::clsid"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, clsid) - 4usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::dwDrawAspect"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, dwDrawAspect) - 20usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::sizel"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, sizel) - 24usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::pointl"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, pointl) - 32usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::dwStatus"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, dwStatus) - 40usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::dwFullUserTypeName"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, dwFullUserTypeName) - 44usize];
    ["Offset of field: tagOBJECTDESCRIPTOR::dwSrcOfCopy"]
        [::std::mem::offset_of!(tagOBJECTDESCRIPTOR, dwSrcOfCopy) - 48usize];
};
pub type OBJECTDESCRIPTOR = tagOBJECTDESCRIPTOR;
pub type POBJECTDESCRIPTOR = *mut tagOBJECTDESCRIPTOR;
pub type LPOBJECTDESCRIPTOR = *mut tagOBJECTDESCRIPTOR;
pub type LINKSRCDESCRIPTOR = tagOBJECTDESCRIPTOR;
pub type PLINKSRCDESCRIPTOR = *mut tagOBJECTDESCRIPTOR;
pub type LPLINKSRCDESCRIPTOR = *mut tagOBJECTDESCRIPTOR;
unsafe extern "C" {
    pub static mut IOLETypes_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut IOLETypes_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPOLEWINDOW = *mut IOleWindow;
unsafe extern "C" {
    pub static IID_IOleWindow: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleWindowVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleWindow,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleWindow) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleWindow) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleWindow, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleWindow, fEnterMode: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleWindowVtbl"][::std::mem::size_of::<IOleWindowVtbl>() - 40usize];
    ["Alignment of IOleWindowVtbl"][::std::mem::align_of::<IOleWindowVtbl>() - 8usize];
    ["Offset of field: IOleWindowVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleWindowVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleWindowVtbl::AddRef"]
        [::std::mem::offset_of!(IOleWindowVtbl, AddRef) - 8usize];
    ["Offset of field: IOleWindowVtbl::Release"]
        [::std::mem::offset_of!(IOleWindowVtbl, Release) - 16usize];
    ["Offset of field: IOleWindowVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleWindowVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleWindowVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleWindowVtbl, ContextSensitiveHelp) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleWindow {
    pub lpVtbl: *mut IOleWindowVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleWindow"][::std::mem::size_of::<IOleWindow>() - 8usize];
    ["Alignment of IOleWindow"][::std::mem::align_of::<IOleWindow>() - 8usize];
    ["Offset of field: IOleWindow::lpVtbl"][::std::mem::offset_of!(IOleWindow, lpVtbl) - 0usize];
};
pub type LPOLELINK = *mut IOleLink;
pub const tagOLEUPDATE_OLEUPDATE_ALWAYS: tagOLEUPDATE = 1;
pub const tagOLEUPDATE_OLEUPDATE_ONCALL: tagOLEUPDATE = 3;
pub type tagOLEUPDATE = ::std::os::raw::c_int;
pub use self::tagOLEUPDATE as OLEUPDATE;
pub type LPOLEUPDATE = *mut OLEUPDATE;
pub type POLEUPDATE = *mut OLEUPDATE;
pub const tagOLELINKBIND_OLELINKBIND_EVENIFCLASSDIFF: tagOLELINKBIND = 1;
pub type tagOLELINKBIND = ::std::os::raw::c_int;
pub use self::tagOLELINKBIND as OLELINKBIND;
unsafe extern "C" {
    pub static IID_IOleLink: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleLinkVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleLink,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleLink) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleLink) -> ULONG>,
    pub SetUpdateOptions: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, dwUpdateOpt: DWORD) -> HRESULT,
    >,
    pub GetUpdateOptions: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, pdwUpdateOpt: *mut DWORD) -> HRESULT,
    >,
    pub SetSourceMoniker: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleLink,
            pmk: *mut IMoniker,
            rclsid: *const IID,
        ) -> HRESULT,
    >,
    pub GetSourceMoniker: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, ppmk: *mut *mut IMoniker) -> HRESULT,
    >,
    pub SetSourceDisplayName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, pszStatusText: LPCOLESTR) -> HRESULT,
    >,
    pub GetSourceDisplayName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, ppszDisplayName: *mut LPOLESTR) -> HRESULT,
    >,
    pub BindToSource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, bindflags: DWORD, pbc: *mut IBindCtx) -> HRESULT,
    >,
    pub BindIfRunning: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleLink) -> HRESULT>,
    pub GetBoundSource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, ppunk: *mut *mut IUnknown) -> HRESULT,
    >,
    pub UnbindSource: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleLink) -> HRESULT>,
    pub Update: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleLink, pbc: *mut IBindCtx) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleLinkVtbl"][::std::mem::size_of::<IOleLinkVtbl>() - 112usize];
    ["Alignment of IOleLinkVtbl"][::std::mem::align_of::<IOleLinkVtbl>() - 8usize];
    ["Offset of field: IOleLinkVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleLinkVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleLinkVtbl::AddRef"]
        [::std::mem::offset_of!(IOleLinkVtbl, AddRef) - 8usize];
    ["Offset of field: IOleLinkVtbl::Release"]
        [::std::mem::offset_of!(IOleLinkVtbl, Release) - 16usize];
    ["Offset of field: IOleLinkVtbl::SetUpdateOptions"]
        [::std::mem::offset_of!(IOleLinkVtbl, SetUpdateOptions) - 24usize];
    ["Offset of field: IOleLinkVtbl::GetUpdateOptions"]
        [::std::mem::offset_of!(IOleLinkVtbl, GetUpdateOptions) - 32usize];
    ["Offset of field: IOleLinkVtbl::SetSourceMoniker"]
        [::std::mem::offset_of!(IOleLinkVtbl, SetSourceMoniker) - 40usize];
    ["Offset of field: IOleLinkVtbl::GetSourceMoniker"]
        [::std::mem::offset_of!(IOleLinkVtbl, GetSourceMoniker) - 48usize];
    ["Offset of field: IOleLinkVtbl::SetSourceDisplayName"]
        [::std::mem::offset_of!(IOleLinkVtbl, SetSourceDisplayName) - 56usize];
    ["Offset of field: IOleLinkVtbl::GetSourceDisplayName"]
        [::std::mem::offset_of!(IOleLinkVtbl, GetSourceDisplayName) - 64usize];
    ["Offset of field: IOleLinkVtbl::BindToSource"]
        [::std::mem::offset_of!(IOleLinkVtbl, BindToSource) - 72usize];
    ["Offset of field: IOleLinkVtbl::BindIfRunning"]
        [::std::mem::offset_of!(IOleLinkVtbl, BindIfRunning) - 80usize];
    ["Offset of field: IOleLinkVtbl::GetBoundSource"]
        [::std::mem::offset_of!(IOleLinkVtbl, GetBoundSource) - 88usize];
    ["Offset of field: IOleLinkVtbl::UnbindSource"]
        [::std::mem::offset_of!(IOleLinkVtbl, UnbindSource) - 96usize];
    ["Offset of field: IOleLinkVtbl::Update"]
        [::std::mem::offset_of!(IOleLinkVtbl, Update) - 104usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleLink {
    pub lpVtbl: *mut IOleLinkVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleLink"][::std::mem::size_of::<IOleLink>() - 8usize];
    ["Alignment of IOleLink"][::std::mem::align_of::<IOleLink>() - 8usize];
    ["Offset of field: IOleLink::lpVtbl"][::std::mem::offset_of!(IOleLink, lpVtbl) - 0usize];
};
pub type LPOLEITEMCONTAINER = *mut IOleItemContainer;
pub const tagBINDSPEED_BINDSPEED_INDEFINITE: tagBINDSPEED = 1;
pub const tagBINDSPEED_BINDSPEED_MODERATE: tagBINDSPEED = 2;
pub const tagBINDSPEED_BINDSPEED_IMMEDIATE: tagBINDSPEED = 3;
pub type tagBINDSPEED = ::std::os::raw::c_int;
pub use self::tagBINDSPEED as BINDSPEED;
pub const tagOLECONTF_OLECONTF_EMBEDDINGS: tagOLECONTF = 1;
pub const tagOLECONTF_OLECONTF_LINKS: tagOLECONTF = 2;
pub const tagOLECONTF_OLECONTF_OTHERS: tagOLECONTF = 4;
pub const tagOLECONTF_OLECONTF_ONLYUSER: tagOLECONTF = 8;
pub const tagOLECONTF_OLECONTF_ONLYIFRUNNING: tagOLECONTF = 16;
pub type tagOLECONTF = ::std::os::raw::c_int;
pub use self::tagOLECONTF as OLECONTF;
unsafe extern "C" {
    pub static IID_IOleItemContainer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleItemContainerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleItemContainer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleItemContainer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleItemContainer) -> ULONG>,
    pub ParseDisplayName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleItemContainer,
            pbc: *mut IBindCtx,
            pszDisplayName: LPOLESTR,
            pchEaten: *mut ULONG,
            ppmkOut: *mut *mut IMoniker,
        ) -> HRESULT,
    >,
    pub EnumObjects: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleItemContainer,
            grfFlags: DWORD,
            ppenum: *mut *mut IEnumUnknown,
        ) -> HRESULT,
    >,
    pub LockContainer: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleItemContainer, fLock: BOOL) -> HRESULT,
    >,
    pub GetObjectA: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleItemContainer,
            pszItem: LPOLESTR,
            dwSpeedNeeded: DWORD,
            pbc: *mut IBindCtx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub GetObjectStorage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleItemContainer,
            pszItem: LPOLESTR,
            pbc: *mut IBindCtx,
            riid: *const IID,
            ppvStorage: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub IsRunning: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleItemContainer, pszItem: LPOLESTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleItemContainerVtbl"][::std::mem::size_of::<IOleItemContainerVtbl>() - 72usize];
    ["Alignment of IOleItemContainerVtbl"]
        [::std::mem::align_of::<IOleItemContainerVtbl>() - 8usize];
    ["Offset of field: IOleItemContainerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleItemContainerVtbl::AddRef"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, AddRef) - 8usize];
    ["Offset of field: IOleItemContainerVtbl::Release"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, Release) - 16usize];
    ["Offset of field: IOleItemContainerVtbl::ParseDisplayName"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, ParseDisplayName) - 24usize];
    ["Offset of field: IOleItemContainerVtbl::EnumObjects"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, EnumObjects) - 32usize];
    ["Offset of field: IOleItemContainerVtbl::LockContainer"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, LockContainer) - 40usize];
    ["Offset of field: IOleItemContainerVtbl::GetObjectA"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, GetObjectA) - 48usize];
    ["Offset of field: IOleItemContainerVtbl::GetObjectStorage"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, GetObjectStorage) - 56usize];
    ["Offset of field: IOleItemContainerVtbl::IsRunning"]
        [::std::mem::offset_of!(IOleItemContainerVtbl, IsRunning) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleItemContainer {
    pub lpVtbl: *mut IOleItemContainerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleItemContainer"][::std::mem::size_of::<IOleItemContainer>() - 8usize];
    ["Alignment of IOleItemContainer"][::std::mem::align_of::<IOleItemContainer>() - 8usize];
    ["Offset of field: IOleItemContainer::lpVtbl"]
        [::std::mem::offset_of!(IOleItemContainer, lpVtbl) - 0usize];
};
pub type LPOLEINPLACEUIWINDOW = *mut IOleInPlaceUIWindow;
pub type BORDERWIDTHS = RECT;
pub type LPBORDERWIDTHS = LPRECT;
pub type LPCBORDERWIDTHS = LPCRECT;
unsafe extern "C" {
    pub static IID_IOleInPlaceUIWindow: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceUIWindowVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceUIWindow,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceUIWindow) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceUIWindow) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceUIWindow, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceUIWindow, fEnterMode: BOOL) -> HRESULT,
    >,
    pub GetBorder: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceUIWindow, lprectBorder: LPRECT) -> HRESULT,
    >,
    pub RequestBorderSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceUIWindow,
            pborderwidths: LPCBORDERWIDTHS,
        ) -> HRESULT,
    >,
    pub SetBorderSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceUIWindow,
            pborderwidths: LPCBORDERWIDTHS,
        ) -> HRESULT,
    >,
    pub SetActiveObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceUIWindow,
            pActiveObject: *mut IOleInPlaceActiveObject,
            pszObjName: LPCOLESTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceUIWindowVtbl"][::std::mem::size_of::<IOleInPlaceUIWindowVtbl>() - 72usize];
    ["Alignment of IOleInPlaceUIWindowVtbl"]
        [::std::mem::align_of::<IOleInPlaceUIWindowVtbl>() - 8usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::AddRef"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, AddRef) - 8usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::Release"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, Release) - 16usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, ContextSensitiveHelp) - 32usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::GetBorder"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, GetBorder) - 40usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::RequestBorderSpace"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, RequestBorderSpace) - 48usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::SetBorderSpace"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, SetBorderSpace) - 56usize];
    ["Offset of field: IOleInPlaceUIWindowVtbl::SetActiveObject"]
        [::std::mem::offset_of!(IOleInPlaceUIWindowVtbl, SetActiveObject) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceUIWindow {
    pub lpVtbl: *mut IOleInPlaceUIWindowVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceUIWindow"][::std::mem::size_of::<IOleInPlaceUIWindow>() - 8usize];
    ["Alignment of IOleInPlaceUIWindow"][::std::mem::align_of::<IOleInPlaceUIWindow>() - 8usize];
    ["Offset of field: IOleInPlaceUIWindow::lpVtbl"]
        [::std::mem::offset_of!(IOleInPlaceUIWindow, lpVtbl) - 0usize];
};
pub type LPOLEINPLACEACTIVEOBJECT = *mut IOleInPlaceActiveObject;
unsafe extern "C" {
    pub static IID_IOleInPlaceActiveObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceActiveObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceActiveObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, fEnterMode: BOOL) -> HRESULT,
    >,
    pub TranslateAcceleratorA: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, lpmsg: LPMSG) -> HRESULT,
    >,
    pub OnFrameWindowActivate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, fActivate: BOOL) -> HRESULT,
    >,
    pub OnDocWindowActivate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, fActivate: BOOL) -> HRESULT,
    >,
    pub ResizeBorder: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceActiveObject,
            prcBorder: LPCRECT,
            pUIWindow: *mut IOleInPlaceUIWindow,
            fFrameWindow: BOOL,
        ) -> HRESULT,
    >,
    pub EnableModeless: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceActiveObject, fEnable: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceActiveObjectVtbl"]
        [::std::mem::size_of::<IOleInPlaceActiveObjectVtbl>() - 80usize];
    ["Alignment of IOleInPlaceActiveObjectVtbl"]
        [::std::mem::align_of::<IOleInPlaceActiveObjectVtbl>() - 8usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::Release"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, Release) - 16usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, ContextSensitiveHelp) - 32usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::TranslateAcceleratorA"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, TranslateAcceleratorA) - 40usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::OnFrameWindowActivate"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, OnFrameWindowActivate) - 48usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::OnDocWindowActivate"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, OnDocWindowActivate) - 56usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::ResizeBorder"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, ResizeBorder) - 64usize];
    ["Offset of field: IOleInPlaceActiveObjectVtbl::EnableModeless"]
        [::std::mem::offset_of!(IOleInPlaceActiveObjectVtbl, EnableModeless) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceActiveObject {
    pub lpVtbl: *mut IOleInPlaceActiveObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceActiveObject"][::std::mem::size_of::<IOleInPlaceActiveObject>() - 8usize];
    ["Alignment of IOleInPlaceActiveObject"]
        [::std::mem::align_of::<IOleInPlaceActiveObject>() - 8usize];
    ["Offset of field: IOleInPlaceActiveObject::lpVtbl"]
        [::std::mem::offset_of!(IOleInPlaceActiveObject, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_RemoteTranslateAccelerator_Proxy(
        This: *mut IOleInPlaceActiveObject,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_RemoteTranslateAccelerator_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_RemoteResizeBorder_Proxy(
        This: *mut IOleInPlaceActiveObject,
        prcBorder: LPCRECT,
        riid: *const IID,
        pUIWindow: *mut IOleInPlaceUIWindow,
        fFrameWindow: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_RemoteResizeBorder_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPOLEINPLACEFRAME = *mut IOleInPlaceFrame;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOIFI {
    pub cb: UINT,
    pub fMDIApp: BOOL,
    pub hwndFrame: HWND,
    pub haccel: HACCEL,
    pub cAccelEntries: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOIFI"][::std::mem::size_of::<tagOIFI>() - 32usize];
    ["Alignment of tagOIFI"][::std::mem::align_of::<tagOIFI>() - 8usize];
    ["Offset of field: tagOIFI::cb"][::std::mem::offset_of!(tagOIFI, cb) - 0usize];
    ["Offset of field: tagOIFI::fMDIApp"][::std::mem::offset_of!(tagOIFI, fMDIApp) - 4usize];
    ["Offset of field: tagOIFI::hwndFrame"][::std::mem::offset_of!(tagOIFI, hwndFrame) - 8usize];
    ["Offset of field: tagOIFI::haccel"][::std::mem::offset_of!(tagOIFI, haccel) - 16usize];
    ["Offset of field: tagOIFI::cAccelEntries"]
        [::std::mem::offset_of!(tagOIFI, cAccelEntries) - 24usize];
};
pub type OLEINPLACEFRAMEINFO = tagOIFI;
pub type LPOLEINPLACEFRAMEINFO = *mut tagOIFI;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOleMenuGroupWidths {
    pub width: [LONG; 6usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOleMenuGroupWidths"][::std::mem::size_of::<tagOleMenuGroupWidths>() - 24usize];
    ["Alignment of tagOleMenuGroupWidths"]
        [::std::mem::align_of::<tagOleMenuGroupWidths>() - 4usize];
    ["Offset of field: tagOleMenuGroupWidths::width"]
        [::std::mem::offset_of!(tagOleMenuGroupWidths, width) - 0usize];
};
pub type OLEMENUGROUPWIDTHS = tagOleMenuGroupWidths;
pub type LPOLEMENUGROUPWIDTHS = *mut tagOleMenuGroupWidths;
pub type HOLEMENU = HGLOBAL;
unsafe extern "C" {
    pub static IID_IOleInPlaceFrame: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceFrameVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceFrame) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceFrame) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, fEnterMode: BOOL) -> HRESULT,
    >,
    pub GetBorder: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, lprectBorder: LPRECT) -> HRESULT,
    >,
    pub RequestBorderSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            pborderwidths: LPCBORDERWIDTHS,
        ) -> HRESULT,
    >,
    pub SetBorderSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            pborderwidths: LPCBORDERWIDTHS,
        ) -> HRESULT,
    >,
    pub SetActiveObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            pActiveObject: *mut IOleInPlaceActiveObject,
            pszObjName: LPCOLESTR,
        ) -> HRESULT,
    >,
    pub InsertMenus: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            hmenuShared: HMENU,
            lpMenuWidths: LPOLEMENUGROUPWIDTHS,
        ) -> HRESULT,
    >,
    pub SetMenu: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceFrame,
            hmenuShared: HMENU,
            holemenu: HOLEMENU,
            hwndActiveObject: HWND,
        ) -> HRESULT,
    >,
    pub RemoveMenus: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, hmenuShared: HMENU) -> HRESULT,
    >,
    pub SetStatusText: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, pszStatusText: LPCOLESTR) -> HRESULT,
    >,
    pub EnableModeless: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, fEnable: BOOL) -> HRESULT,
    >,
    pub TranslateAcceleratorA: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceFrame, lpmsg: LPMSG, wID: WORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceFrameVtbl"][::std::mem::size_of::<IOleInPlaceFrameVtbl>() - 120usize];
    ["Alignment of IOleInPlaceFrameVtbl"][::std::mem::align_of::<IOleInPlaceFrameVtbl>() - 8usize];
    ["Offset of field: IOleInPlaceFrameVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleInPlaceFrameVtbl::AddRef"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, AddRef) - 8usize];
    ["Offset of field: IOleInPlaceFrameVtbl::Release"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, Release) - 16usize];
    ["Offset of field: IOleInPlaceFrameVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleInPlaceFrameVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, ContextSensitiveHelp) - 32usize];
    ["Offset of field: IOleInPlaceFrameVtbl::GetBorder"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, GetBorder) - 40usize];
    ["Offset of field: IOleInPlaceFrameVtbl::RequestBorderSpace"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, RequestBorderSpace) - 48usize];
    ["Offset of field: IOleInPlaceFrameVtbl::SetBorderSpace"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, SetBorderSpace) - 56usize];
    ["Offset of field: IOleInPlaceFrameVtbl::SetActiveObject"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, SetActiveObject) - 64usize];
    ["Offset of field: IOleInPlaceFrameVtbl::InsertMenus"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, InsertMenus) - 72usize];
    ["Offset of field: IOleInPlaceFrameVtbl::SetMenu"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, SetMenu) - 80usize];
    ["Offset of field: IOleInPlaceFrameVtbl::RemoveMenus"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, RemoveMenus) - 88usize];
    ["Offset of field: IOleInPlaceFrameVtbl::SetStatusText"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, SetStatusText) - 96usize];
    ["Offset of field: IOleInPlaceFrameVtbl::EnableModeless"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, EnableModeless) - 104usize];
    ["Offset of field: IOleInPlaceFrameVtbl::TranslateAcceleratorA"]
        [::std::mem::offset_of!(IOleInPlaceFrameVtbl, TranslateAcceleratorA) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceFrame {
    pub lpVtbl: *mut IOleInPlaceFrameVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceFrame"][::std::mem::size_of::<IOleInPlaceFrame>() - 8usize];
    ["Alignment of IOleInPlaceFrame"][::std::mem::align_of::<IOleInPlaceFrame>() - 8usize];
    ["Offset of field: IOleInPlaceFrame::lpVtbl"]
        [::std::mem::offset_of!(IOleInPlaceFrame, lpVtbl) - 0usize];
};
pub type LPOLEINPLACEOBJECT = *mut IOleInPlaceObject;
unsafe extern "C" {
    pub static IID_IOleInPlaceObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceObject) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceObject, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceObject, fEnterMode: BOOL) -> HRESULT,
    >,
    pub InPlaceDeactivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceObject) -> HRESULT>,
    pub UIDeactivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceObject) -> HRESULT>,
    pub SetObjectRects: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceObject,
            lprcPosRect: LPCRECT,
            lprcClipRect: LPCRECT,
        ) -> HRESULT,
    >,
    pub ReactivateAndUndo:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceObject) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceObjectVtbl"][::std::mem::size_of::<IOleInPlaceObjectVtbl>() - 72usize];
    ["Alignment of IOleInPlaceObjectVtbl"]
        [::std::mem::align_of::<IOleInPlaceObjectVtbl>() - 8usize];
    ["Offset of field: IOleInPlaceObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleInPlaceObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IOleInPlaceObjectVtbl::Release"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, Release) - 16usize];
    ["Offset of field: IOleInPlaceObjectVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleInPlaceObjectVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, ContextSensitiveHelp) - 32usize];
    ["Offset of field: IOleInPlaceObjectVtbl::InPlaceDeactivate"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, InPlaceDeactivate) - 40usize];
    ["Offset of field: IOleInPlaceObjectVtbl::UIDeactivate"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, UIDeactivate) - 48usize];
    ["Offset of field: IOleInPlaceObjectVtbl::SetObjectRects"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, SetObjectRects) - 56usize];
    ["Offset of field: IOleInPlaceObjectVtbl::ReactivateAndUndo"]
        [::std::mem::offset_of!(IOleInPlaceObjectVtbl, ReactivateAndUndo) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceObject {
    pub lpVtbl: *mut IOleInPlaceObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceObject"][::std::mem::size_of::<IOleInPlaceObject>() - 8usize];
    ["Alignment of IOleInPlaceObject"][::std::mem::align_of::<IOleInPlaceObject>() - 8usize];
    ["Offset of field: IOleInPlaceObject::lpVtbl"]
        [::std::mem::offset_of!(IOleInPlaceObject, lpVtbl) - 0usize];
};
pub type LPOLEINPLACESITE = *mut IOleInPlaceSite;
unsafe extern "C" {
    pub static IID_IOleInPlaceSite: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceSiteVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceSite,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceSite, phwnd: *mut HWND) -> HRESULT,
    >,
    pub ContextSensitiveHelp: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceSite, fEnterMode: BOOL) -> HRESULT,
    >,
    pub CanInPlaceActivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub OnInPlaceActivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub OnUIActivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub GetWindowContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IOleInPlaceSite,
            ppFrame: *mut *mut IOleInPlaceFrame,
            ppDoc: *mut *mut IOleInPlaceUIWindow,
            lprcPosRect: LPRECT,
            lprcClipRect: LPRECT,
            lpFrameInfo: LPOLEINPLACEFRAMEINFO,
        ) -> HRESULT,
    >,
    pub Scroll: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceSite, scrollExtant: SIZE) -> HRESULT,
    >,
    pub OnUIDeactivate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceSite, fUndoable: BOOL) -> HRESULT,
    >,
    pub OnInPlaceDeactivate:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub DiscardUndoState:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub DeactivateAndUndo:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IOleInPlaceSite) -> HRESULT>,
    pub OnPosRectChange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IOleInPlaceSite, lprcPosRect: LPCRECT) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceSiteVtbl"][::std::mem::size_of::<IOleInPlaceSiteVtbl>() - 120usize];
    ["Alignment of IOleInPlaceSiteVtbl"][::std::mem::align_of::<IOleInPlaceSiteVtbl>() - 8usize];
    ["Offset of field: IOleInPlaceSiteVtbl::QueryInterface"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, QueryInterface) - 0usize];
    ["Offset of field: IOleInPlaceSiteVtbl::AddRef"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, AddRef) - 8usize];
    ["Offset of field: IOleInPlaceSiteVtbl::Release"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, Release) - 16usize];
    ["Offset of field: IOleInPlaceSiteVtbl::GetWindow"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, GetWindow) - 24usize];
    ["Offset of field: IOleInPlaceSiteVtbl::ContextSensitiveHelp"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, ContextSensitiveHelp) - 32usize];
    ["Offset of field: IOleInPlaceSiteVtbl::CanInPlaceActivate"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, CanInPlaceActivate) - 40usize];
    ["Offset of field: IOleInPlaceSiteVtbl::OnInPlaceActivate"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, OnInPlaceActivate) - 48usize];
    ["Offset of field: IOleInPlaceSiteVtbl::OnUIActivate"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, OnUIActivate) - 56usize];
    ["Offset of field: IOleInPlaceSiteVtbl::GetWindowContext"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, GetWindowContext) - 64usize];
    ["Offset of field: IOleInPlaceSiteVtbl::Scroll"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, Scroll) - 72usize];
    ["Offset of field: IOleInPlaceSiteVtbl::OnUIDeactivate"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, OnUIDeactivate) - 80usize];
    ["Offset of field: IOleInPlaceSiteVtbl::OnInPlaceDeactivate"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, OnInPlaceDeactivate) - 88usize];
    ["Offset of field: IOleInPlaceSiteVtbl::DiscardUndoState"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, DiscardUndoState) - 96usize];
    ["Offset of field: IOleInPlaceSiteVtbl::DeactivateAndUndo"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, DeactivateAndUndo) - 104usize];
    ["Offset of field: IOleInPlaceSiteVtbl::OnPosRectChange"]
        [::std::mem::offset_of!(IOleInPlaceSiteVtbl, OnPosRectChange) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IOleInPlaceSite {
    pub lpVtbl: *mut IOleInPlaceSiteVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IOleInPlaceSite"][::std::mem::size_of::<IOleInPlaceSite>() - 8usize];
    ["Alignment of IOleInPlaceSite"][::std::mem::align_of::<IOleInPlaceSite>() - 8usize];
    ["Offset of field: IOleInPlaceSite::lpVtbl"]
        [::std::mem::offset_of!(IOleInPlaceSite, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IContinue: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IContinueVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IContinue,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IContinue) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IContinue) -> ULONG>,
    pub FContinue: ::std::option::Option<unsafe extern "C" fn(This: *mut IContinue) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IContinueVtbl"][::std::mem::size_of::<IContinueVtbl>() - 32usize];
    ["Alignment of IContinueVtbl"][::std::mem::align_of::<IContinueVtbl>() - 8usize];
    ["Offset of field: IContinueVtbl::QueryInterface"]
        [::std::mem::offset_of!(IContinueVtbl, QueryInterface) - 0usize];
    ["Offset of field: IContinueVtbl::AddRef"]
        [::std::mem::offset_of!(IContinueVtbl, AddRef) - 8usize];
    ["Offset of field: IContinueVtbl::Release"]
        [::std::mem::offset_of!(IContinueVtbl, Release) - 16usize];
    ["Offset of field: IContinueVtbl::FContinue"]
        [::std::mem::offset_of!(IContinueVtbl, FContinue) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IContinue {
    pub lpVtbl: *mut IContinueVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IContinue"][::std::mem::size_of::<IContinue>() - 8usize];
    ["Alignment of IContinue"][::std::mem::align_of::<IContinue>() - 8usize];
    ["Offset of field: IContinue::lpVtbl"][::std::mem::offset_of!(IContinue, lpVtbl) - 0usize];
};
pub type LPVIEWOBJECT = *mut IViewObject;
unsafe extern "C" {
    pub static IID_IViewObject: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IViewObjectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IViewObject) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IViewObject) -> ULONG>,
    pub Draw: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            ptd: *mut DVTARGETDEVICE,
            hdcTargetDev: HDC,
            hdcDraw: HDC,
            lprcBounds: LPCRECTL,
            lprcWBounds: LPCRECTL,
            pfnContinue: ::std::option::Option<unsafe extern "C" fn(dwContinue: ULONG_PTR) -> BOOL>,
            dwContinue: ULONG_PTR,
        ) -> HRESULT,
    >,
    pub GetColorSet: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            ptd: *mut DVTARGETDEVICE,
            hicTargetDev: HDC,
            ppColorSet: *mut *mut LOGPALETTE,
        ) -> HRESULT,
    >,
    pub Freeze: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            pdwFreeze: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Unfreeze: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IViewObject, dwFreeze: DWORD) -> HRESULT,
    >,
    pub SetAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            aspects: DWORD,
            advf: DWORD,
            pAdvSink: *mut IAdviseSink,
        ) -> HRESULT,
    >,
    pub GetAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject,
            pAspects: *mut DWORD,
            pAdvf: *mut DWORD,
            ppAdvSink: *mut *mut IAdviseSink,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IViewObjectVtbl"][::std::mem::size_of::<IViewObjectVtbl>() - 72usize];
    ["Alignment of IViewObjectVtbl"][::std::mem::align_of::<IViewObjectVtbl>() - 8usize];
    ["Offset of field: IViewObjectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IViewObjectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IViewObjectVtbl::AddRef"]
        [::std::mem::offset_of!(IViewObjectVtbl, AddRef) - 8usize];
    ["Offset of field: IViewObjectVtbl::Release"]
        [::std::mem::offset_of!(IViewObjectVtbl, Release) - 16usize];
    ["Offset of field: IViewObjectVtbl::Draw"]
        [::std::mem::offset_of!(IViewObjectVtbl, Draw) - 24usize];
    ["Offset of field: IViewObjectVtbl::GetColorSet"]
        [::std::mem::offset_of!(IViewObjectVtbl, GetColorSet) - 32usize];
    ["Offset of field: IViewObjectVtbl::Freeze"]
        [::std::mem::offset_of!(IViewObjectVtbl, Freeze) - 40usize];
    ["Offset of field: IViewObjectVtbl::Unfreeze"]
        [::std::mem::offset_of!(IViewObjectVtbl, Unfreeze) - 48usize];
    ["Offset of field: IViewObjectVtbl::SetAdvise"]
        [::std::mem::offset_of!(IViewObjectVtbl, SetAdvise) - 56usize];
    ["Offset of field: IViewObjectVtbl::GetAdvise"]
        [::std::mem::offset_of!(IViewObjectVtbl, GetAdvise) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IViewObject {
    pub lpVtbl: *mut IViewObjectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IViewObject"][::std::mem::size_of::<IViewObject>() - 8usize];
    ["Alignment of IViewObject"][::std::mem::align_of::<IViewObject>() - 8usize];
    ["Offset of field: IViewObject::lpVtbl"][::std::mem::offset_of!(IViewObject, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IViewObject_RemoteDraw_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        ptd: *mut DVTARGETDEVICE,
        hdcTargetDev: HDC,
        hdcDraw: HDC,
        lprcBounds: LPCRECTL,
        lprcWBounds: LPCRECTL,
        pContinue: *mut IContinue,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_RemoteDraw_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IViewObject_RemoteGetColorSet_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        ptd: *mut DVTARGETDEVICE,
        hicTargetDev: ULONG_PTR,
        ppColorSet: *mut *mut LOGPALETTE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_RemoteGetColorSet_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IViewObject_RemoteFreeze_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        pdwFreeze: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_RemoteFreeze_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IViewObject_RemoteGetAdvise_Proxy(
        This: *mut IViewObject,
        pAspects: *mut DWORD,
        pAdvf: *mut DWORD,
        ppAdvSink: *mut *mut IAdviseSink,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_RemoteGetAdvise_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
pub type LPVIEWOBJECT2 = *mut IViewObject2;
unsafe extern "C" {
    pub static IID_IViewObject2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IViewObject2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IViewObject2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IViewObject2) -> ULONG>,
    pub Draw: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            ptd: *mut DVTARGETDEVICE,
            hdcTargetDev: HDC,
            hdcDraw: HDC,
            lprcBounds: LPCRECTL,
            lprcWBounds: LPCRECTL,
            pfnContinue: ::std::option::Option<unsafe extern "C" fn(dwContinue: ULONG_PTR) -> BOOL>,
            dwContinue: ULONG_PTR,
        ) -> HRESULT,
    >,
    pub GetColorSet: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            ptd: *mut DVTARGETDEVICE,
            hicTargetDev: HDC,
            ppColorSet: *mut *mut LOGPALETTE,
        ) -> HRESULT,
    >,
    pub Freeze: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            dwDrawAspect: DWORD,
            lindex: LONG,
            pvAspect: *mut ::std::os::raw::c_void,
            pdwFreeze: *mut DWORD,
        ) -> HRESULT,
    >,
    pub Unfreeze: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IViewObject2, dwFreeze: DWORD) -> HRESULT,
    >,
    pub SetAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            aspects: DWORD,
            advf: DWORD,
            pAdvSink: *mut IAdviseSink,
        ) -> HRESULT,
    >,
    pub GetAdvise: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            pAspects: *mut DWORD,
            pAdvf: *mut DWORD,
            ppAdvSink: *mut *mut IAdviseSink,
        ) -> HRESULT,
    >,
    pub GetExtent: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IViewObject2,
            dwDrawAspect: DWORD,
            lindex: LONG,
            ptd: *mut DVTARGETDEVICE,
            lpsizel: LPSIZEL,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IViewObject2Vtbl"][::std::mem::size_of::<IViewObject2Vtbl>() - 80usize];
    ["Alignment of IViewObject2Vtbl"][::std::mem::align_of::<IViewObject2Vtbl>() - 8usize];
    ["Offset of field: IViewObject2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IViewObject2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IViewObject2Vtbl::AddRef"]
        [::std::mem::offset_of!(IViewObject2Vtbl, AddRef) - 8usize];
    ["Offset of field: IViewObject2Vtbl::Release"]
        [::std::mem::offset_of!(IViewObject2Vtbl, Release) - 16usize];
    ["Offset of field: IViewObject2Vtbl::Draw"]
        [::std::mem::offset_of!(IViewObject2Vtbl, Draw) - 24usize];
    ["Offset of field: IViewObject2Vtbl::GetColorSet"]
        [::std::mem::offset_of!(IViewObject2Vtbl, GetColorSet) - 32usize];
    ["Offset of field: IViewObject2Vtbl::Freeze"]
        [::std::mem::offset_of!(IViewObject2Vtbl, Freeze) - 40usize];
    ["Offset of field: IViewObject2Vtbl::Unfreeze"]
        [::std::mem::offset_of!(IViewObject2Vtbl, Unfreeze) - 48usize];
    ["Offset of field: IViewObject2Vtbl::SetAdvise"]
        [::std::mem::offset_of!(IViewObject2Vtbl, SetAdvise) - 56usize];
    ["Offset of field: IViewObject2Vtbl::GetAdvise"]
        [::std::mem::offset_of!(IViewObject2Vtbl, GetAdvise) - 64usize];
    ["Offset of field: IViewObject2Vtbl::GetExtent"]
        [::std::mem::offset_of!(IViewObject2Vtbl, GetExtent) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IViewObject2 {
    pub lpVtbl: *mut IViewObject2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IViewObject2"][::std::mem::size_of::<IViewObject2>() - 8usize];
    ["Alignment of IViewObject2"][::std::mem::align_of::<IViewObject2>() - 8usize];
    ["Offset of field: IViewObject2::lpVtbl"]
        [::std::mem::offset_of!(IViewObject2, lpVtbl) - 0usize];
};
pub type LPDROPSOURCE = *mut IDropSource;
unsafe extern "C" {
    pub static IID_IDropSource: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropSourceVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropSource,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropSource) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropSource) -> ULONG>,
    pub QueryContinueDrag: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropSource,
            fEscapePressed: BOOL,
            grfKeyState: DWORD,
        ) -> HRESULT,
    >,
    pub GiveFeedback: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDropSource, dwEffect: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropSourceVtbl"][::std::mem::size_of::<IDropSourceVtbl>() - 40usize];
    ["Alignment of IDropSourceVtbl"][::std::mem::align_of::<IDropSourceVtbl>() - 8usize];
    ["Offset of field: IDropSourceVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDropSourceVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDropSourceVtbl::AddRef"]
        [::std::mem::offset_of!(IDropSourceVtbl, AddRef) - 8usize];
    ["Offset of field: IDropSourceVtbl::Release"]
        [::std::mem::offset_of!(IDropSourceVtbl, Release) - 16usize];
    ["Offset of field: IDropSourceVtbl::QueryContinueDrag"]
        [::std::mem::offset_of!(IDropSourceVtbl, QueryContinueDrag) - 24usize];
    ["Offset of field: IDropSourceVtbl::GiveFeedback"]
        [::std::mem::offset_of!(IDropSourceVtbl, GiveFeedback) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropSource {
    pub lpVtbl: *mut IDropSourceVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropSource"][::std::mem::size_of::<IDropSource>() - 8usize];
    ["Alignment of IDropSource"][::std::mem::align_of::<IDropSource>() - 8usize];
    ["Offset of field: IDropSource::lpVtbl"][::std::mem::offset_of!(IDropSource, lpVtbl) - 0usize];
};
pub type LPDROPTARGET = *mut IDropTarget;
unsafe extern "C" {
    pub static IID_IDropTarget: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropTargetVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropTarget,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropTarget) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropTarget) -> ULONG>,
    pub DragEnter: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropTarget,
            pDataObj: *mut IDataObject,
            grfKeyState: DWORD,
            pt: POINTL,
            pdwEffect: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DragOver: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropTarget,
            grfKeyState: DWORD,
            pt: POINTL,
            pdwEffect: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DragLeave: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropTarget) -> HRESULT>,
    pub Drop: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropTarget,
            pDataObj: *mut IDataObject,
            grfKeyState: DWORD,
            pt: POINTL,
            pdwEffect: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropTargetVtbl"][::std::mem::size_of::<IDropTargetVtbl>() - 56usize];
    ["Alignment of IDropTargetVtbl"][::std::mem::align_of::<IDropTargetVtbl>() - 8usize];
    ["Offset of field: IDropTargetVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDropTargetVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDropTargetVtbl::AddRef"]
        [::std::mem::offset_of!(IDropTargetVtbl, AddRef) - 8usize];
    ["Offset of field: IDropTargetVtbl::Release"]
        [::std::mem::offset_of!(IDropTargetVtbl, Release) - 16usize];
    ["Offset of field: IDropTargetVtbl::DragEnter"]
        [::std::mem::offset_of!(IDropTargetVtbl, DragEnter) - 24usize];
    ["Offset of field: IDropTargetVtbl::DragOver"]
        [::std::mem::offset_of!(IDropTargetVtbl, DragOver) - 32usize];
    ["Offset of field: IDropTargetVtbl::DragLeave"]
        [::std::mem::offset_of!(IDropTargetVtbl, DragLeave) - 40usize];
    ["Offset of field: IDropTargetVtbl::Drop"]
        [::std::mem::offset_of!(IDropTargetVtbl, Drop) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropTarget {
    pub lpVtbl: *mut IDropTargetVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropTarget"][::std::mem::size_of::<IDropTarget>() - 8usize];
    ["Alignment of IDropTarget"][::std::mem::align_of::<IDropTarget>() - 8usize];
    ["Offset of field: IDropTarget::lpVtbl"][::std::mem::offset_of!(IDropTarget, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IDropSourceNotify: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropSourceNotifyVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDropSourceNotify,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropSourceNotify) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDropSourceNotify) -> ULONG>,
    pub DragEnterTarget: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDropSourceNotify, hwndTarget: HWND) -> HRESULT,
    >,
    pub DragLeaveTarget:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IDropSourceNotify) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropSourceNotifyVtbl"][::std::mem::size_of::<IDropSourceNotifyVtbl>() - 40usize];
    ["Alignment of IDropSourceNotifyVtbl"]
        [::std::mem::align_of::<IDropSourceNotifyVtbl>() - 8usize];
    ["Offset of field: IDropSourceNotifyVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDropSourceNotifyVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDropSourceNotifyVtbl::AddRef"]
        [::std::mem::offset_of!(IDropSourceNotifyVtbl, AddRef) - 8usize];
    ["Offset of field: IDropSourceNotifyVtbl::Release"]
        [::std::mem::offset_of!(IDropSourceNotifyVtbl, Release) - 16usize];
    ["Offset of field: IDropSourceNotifyVtbl::DragEnterTarget"]
        [::std::mem::offset_of!(IDropSourceNotifyVtbl, DragEnterTarget) - 24usize];
    ["Offset of field: IDropSourceNotifyVtbl::DragLeaveTarget"]
        [::std::mem::offset_of!(IDropSourceNotifyVtbl, DragLeaveTarget) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDropSourceNotify {
    pub lpVtbl: *mut IDropSourceNotifyVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDropSourceNotify"][::std::mem::size_of::<IDropSourceNotify>() - 8usize];
    ["Alignment of IDropSourceNotify"][::std::mem::align_of::<IDropSourceNotify>() - 8usize];
    ["Offset of field: IDropSourceNotify::lpVtbl"]
        [::std::mem::offset_of!(IDropSourceNotify, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IEnterpriseDropTarget: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnterpriseDropTargetVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnterpriseDropTarget,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnterpriseDropTarget) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEnterpriseDropTarget) -> ULONG>,
    pub SetDropSourceEnterpriseId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnterpriseDropTarget, identity: LPCWSTR) -> HRESULT,
    >,
    pub IsEvaluatingEdpPolicy: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnterpriseDropTarget, value: *mut BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnterpriseDropTargetVtbl"]
        [::std::mem::size_of::<IEnterpriseDropTargetVtbl>() - 40usize];
    ["Alignment of IEnterpriseDropTargetVtbl"]
        [::std::mem::align_of::<IEnterpriseDropTargetVtbl>() - 8usize];
    ["Offset of field: IEnterpriseDropTargetVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnterpriseDropTargetVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnterpriseDropTargetVtbl::AddRef"]
        [::std::mem::offset_of!(IEnterpriseDropTargetVtbl, AddRef) - 8usize];
    ["Offset of field: IEnterpriseDropTargetVtbl::Release"]
        [::std::mem::offset_of!(IEnterpriseDropTargetVtbl, Release) - 16usize];
    ["Offset of field: IEnterpriseDropTargetVtbl::SetDropSourceEnterpriseId"]
        [::std::mem::offset_of!(IEnterpriseDropTargetVtbl, SetDropSourceEnterpriseId) - 24usize];
    ["Offset of field: IEnterpriseDropTargetVtbl::IsEvaluatingEdpPolicy"]
        [::std::mem::offset_of!(IEnterpriseDropTargetVtbl, IsEvaluatingEdpPolicy) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnterpriseDropTarget {
    pub lpVtbl: *mut IEnterpriseDropTargetVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnterpriseDropTarget"][::std::mem::size_of::<IEnterpriseDropTarget>() - 8usize];
    ["Alignment of IEnterpriseDropTarget"]
        [::std::mem::align_of::<IEnterpriseDropTarget>() - 8usize];
    ["Offset of field: IEnterpriseDropTarget::lpVtbl"]
        [::std::mem::offset_of!(IEnterpriseDropTarget, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0024_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0024_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPENUMOLEVERB = *mut IEnumOLEVERB;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOLEVERB {
    pub lVerb: LONG,
    pub lpszVerbName: LPOLESTR,
    pub fuFlags: DWORD,
    pub grfAttribs: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOLEVERB"][::std::mem::size_of::<tagOLEVERB>() - 24usize];
    ["Alignment of tagOLEVERB"][::std::mem::align_of::<tagOLEVERB>() - 8usize];
    ["Offset of field: tagOLEVERB::lVerb"][::std::mem::offset_of!(tagOLEVERB, lVerb) - 0usize];
    ["Offset of field: tagOLEVERB::lpszVerbName"]
        [::std::mem::offset_of!(tagOLEVERB, lpszVerbName) - 8usize];
    ["Offset of field: tagOLEVERB::fuFlags"][::std::mem::offset_of!(tagOLEVERB, fuFlags) - 16usize];
    ["Offset of field: tagOLEVERB::grfAttribs"]
        [::std::mem::offset_of!(tagOLEVERB, grfAttribs) - 20usize];
};
pub type OLEVERB = tagOLEVERB;
pub type LPOLEVERB = *mut tagOLEVERB;
pub const tagOLEVERBATTRIB_OLEVERBATTRIB_NEVERDIRTIES: tagOLEVERBATTRIB = 1;
pub const tagOLEVERBATTRIB_OLEVERBATTRIB_ONCONTAINERMENU: tagOLEVERBATTRIB = 2;
pub type tagOLEVERBATTRIB = ::std::os::raw::c_int;
pub use self::tagOLEVERBATTRIB as OLEVERBATTRIB;
unsafe extern "C" {
    pub static IID_IEnumOLEVERB: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumOLEVERBVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumOLEVERB,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumOLEVERB) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumOLEVERB) -> ULONG>,
    pub Next: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEnumOLEVERB,
            celt: ULONG,
            rgelt: LPOLEVERB,
            pceltFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Skip: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumOLEVERB, celt: ULONG) -> HRESULT,
    >,
    pub Reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IEnumOLEVERB) -> HRESULT>,
    pub Clone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IEnumOLEVERB, ppenum: *mut *mut IEnumOLEVERB) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumOLEVERBVtbl"][::std::mem::size_of::<IEnumOLEVERBVtbl>() - 56usize];
    ["Alignment of IEnumOLEVERBVtbl"][::std::mem::align_of::<IEnumOLEVERBVtbl>() - 8usize];
    ["Offset of field: IEnumOLEVERBVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEnumOLEVERBVtbl::AddRef"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, AddRef) - 8usize];
    ["Offset of field: IEnumOLEVERBVtbl::Release"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, Release) - 16usize];
    ["Offset of field: IEnumOLEVERBVtbl::Next"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, Next) - 24usize];
    ["Offset of field: IEnumOLEVERBVtbl::Skip"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, Skip) - 32usize];
    ["Offset of field: IEnumOLEVERBVtbl::Reset"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, Reset) - 40usize];
    ["Offset of field: IEnumOLEVERBVtbl::Clone"]
        [::std::mem::offset_of!(IEnumOLEVERBVtbl, Clone) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEnumOLEVERB {
    pub lpVtbl: *mut IEnumOLEVERBVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEnumOLEVERB"][::std::mem::size_of::<IEnumOLEVERB>() - 8usize];
    ["Alignment of IEnumOLEVERB"][::std::mem::align_of::<IEnumOLEVERB>() - 8usize];
    ["Offset of field: IEnumOLEVERB::lpVtbl"]
        [::std::mem::offset_of!(IEnumOLEVERB, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IEnumOLEVERB_RemoteNext_Proxy(
        This: *mut IEnumOLEVERB,
        celt: ULONG,
        rgelt: LPOLEVERB,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumOLEVERB_RemoteNext_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0025_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_oleidl_0000_0025_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn HACCEL_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HACCEL,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HACCEL_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HACCEL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HACCEL_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HACCEL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HACCEL_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HACCEL);
}
unsafe extern "C" {
    pub fn HGLOBAL_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HGLOBAL,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HGLOBAL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HGLOBAL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HGLOBAL);
}
unsafe extern "C" {
    pub fn HMENU_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HMENU,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HMENU_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HMENU,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HMENU_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HMENU,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HMENU_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HMENU);
}
unsafe extern "C" {
    pub fn HWND_UserSize(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HWND,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HWND_UserMarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HWND,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HWND_UserUnmarshal(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HWND,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HWND_UserFree(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HWND);
}
unsafe extern "C" {
    pub fn HACCEL_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HACCEL,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HACCEL_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HACCEL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HACCEL_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HACCEL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HACCEL_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HACCEL);
}
unsafe extern "C" {
    pub fn HGLOBAL_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HGLOBAL,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HGLOBAL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HGLOBAL,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HGLOBAL_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HGLOBAL);
}
unsafe extern "C" {
    pub fn HMENU_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HMENU,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HMENU_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HMENU,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HMENU_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HMENU,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HMENU_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HMENU);
}
unsafe extern "C" {
    pub fn HWND_UserSize64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: ::std::os::raw::c_ulong,
        arg3: *mut HWND,
    ) -> ::std::os::raw::c_ulong;
}
unsafe extern "C" {
    pub fn HWND_UserMarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HWND,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HWND_UserUnmarshal64(
        arg1: *mut ::std::os::raw::c_ulong,
        arg2: *mut ::std::os::raw::c_uchar,
        arg3: *mut HWND,
    ) -> *mut ::std::os::raw::c_uchar;
}
unsafe extern "C" {
    pub fn HWND_UserFree64(arg1: *mut ::std::os::raw::c_ulong, arg2: *mut HWND);
}
unsafe extern "C" {
    pub fn IOleCache2_UpdateCache_Proxy(
        This: *mut IOleCache2,
        pDataObject: LPDATAOBJECT,
        grfUpdf: DWORD,
        pReserved: LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleCache2_UpdateCache_Stub(
        This: *mut IOleCache2,
        pDataObject: LPDATAOBJECT,
        grfUpdf: DWORD,
        pReserved: LONG_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_TranslateAccelerator_Proxy(
        This: *mut IOleInPlaceActiveObject,
        lpmsg: LPMSG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_TranslateAccelerator_Stub(
        This: *mut IOleInPlaceActiveObject,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_ResizeBorder_Proxy(
        This: *mut IOleInPlaceActiveObject,
        prcBorder: LPCRECT,
        pUIWindow: *mut IOleInPlaceUIWindow,
        fFrameWindow: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IOleInPlaceActiveObject_ResizeBorder_Stub(
        This: *mut IOleInPlaceActiveObject,
        prcBorder: LPCRECT,
        riid: *const IID,
        pUIWindow: *mut IOleInPlaceUIWindow,
        fFrameWindow: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_Draw_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: *mut ::std::os::raw::c_void,
        ptd: *mut DVTARGETDEVICE,
        hdcTargetDev: HDC,
        hdcDraw: HDC,
        lprcBounds: LPCRECTL,
        lprcWBounds: LPCRECTL,
        pfnContinue: ::std::option::Option<unsafe extern "C" fn(dwContinue: ULONG_PTR) -> BOOL>,
        dwContinue: ULONG_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_Draw_Stub(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        ptd: *mut DVTARGETDEVICE,
        hdcTargetDev: HDC,
        hdcDraw: HDC,
        lprcBounds: LPCRECTL,
        lprcWBounds: LPCRECTL,
        pContinue: *mut IContinue,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_GetColorSet_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: *mut ::std::os::raw::c_void,
        ptd: *mut DVTARGETDEVICE,
        hicTargetDev: HDC,
        ppColorSet: *mut *mut LOGPALETTE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_GetColorSet_Stub(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        ptd: *mut DVTARGETDEVICE,
        hicTargetDev: ULONG_PTR,
        ppColorSet: *mut *mut LOGPALETTE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_Freeze_Proxy(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: *mut ::std::os::raw::c_void,
        pdwFreeze: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_Freeze_Stub(
        This: *mut IViewObject,
        dwDrawAspect: DWORD,
        lindex: LONG,
        pvAspect: ULONG_PTR,
        pdwFreeze: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_GetAdvise_Proxy(
        This: *mut IViewObject,
        pAspects: *mut DWORD,
        pAdvf: *mut DWORD,
        ppAdvSink: *mut *mut IAdviseSink,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IViewObject_GetAdvise_Stub(
        This: *mut IViewObject,
        pAspects: *mut DWORD,
        pAdvf: *mut DWORD,
        ppAdvSink: *mut *mut IAdviseSink,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumOLEVERB_Next_Proxy(
        This: *mut IEnumOLEVERB,
        celt: ULONG,
        rgelt: LPOLEVERB,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEnumOLEVERB_Next_Stub(
        This: *mut IEnumOLEVERB,
        celt: ULONG,
        rgelt: LPOLEVERB,
        pceltFetched: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_servprov_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_servprov_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPSERVICEPROVIDER = *mut IServiceProvider;
unsafe extern "C" {
    pub static IID_IServiceProvider: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IServiceProviderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IServiceProvider,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IServiceProvider) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IServiceProvider) -> ULONG>,
    pub QueryService: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IServiceProvider,
            guidService: *const GUID,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IServiceProviderVtbl"][::std::mem::size_of::<IServiceProviderVtbl>() - 32usize];
    ["Alignment of IServiceProviderVtbl"][::std::mem::align_of::<IServiceProviderVtbl>() - 8usize];
    ["Offset of field: IServiceProviderVtbl::QueryInterface"]
        [::std::mem::offset_of!(IServiceProviderVtbl, QueryInterface) - 0usize];
    ["Offset of field: IServiceProviderVtbl::AddRef"]
        [::std::mem::offset_of!(IServiceProviderVtbl, AddRef) - 8usize];
    ["Offset of field: IServiceProviderVtbl::Release"]
        [::std::mem::offset_of!(IServiceProviderVtbl, Release) - 16usize];
    ["Offset of field: IServiceProviderVtbl::QueryService"]
        [::std::mem::offset_of!(IServiceProviderVtbl, QueryService) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IServiceProvider {
    pub lpVtbl: *mut IServiceProviderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IServiceProvider"][::std::mem::size_of::<IServiceProvider>() - 8usize];
    ["Alignment of IServiceProvider"][::std::mem::align_of::<IServiceProvider>() - 8usize];
    ["Offset of field: IServiceProvider::lpVtbl"]
        [::std::mem::offset_of!(IServiceProvider, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IServiceProvider_RemoteQueryService_Proxy(
        This: *mut IServiceProvider,
        guidService: *const GUID,
        riid: *const IID,
        ppvObject: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IServiceProvider_RemoteQueryService_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_servprov_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_servprov_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn IServiceProvider_QueryService_Proxy(
        This: *mut IServiceProvider,
        guidService: *const GUID,
        riid: *const IID,
        ppvObject: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IServiceProvider_QueryService_Stub(
        This: *mut IServiceProvider,
        guidService: *const GUID,
        riid: *const IID,
        ppvObject: *mut *mut IUnknown,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DOMDocument {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct DOMFreeThreadedDocument {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct XMLHTTPRequest {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct XMLDSOControl {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct XMLDocument {
    _unused: [u8; 0],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _xml_error {
    pub _nLine: ::std::os::raw::c_uint,
    pub _pchBuf: BSTR,
    pub _cchBuf: ::std::os::raw::c_uint,
    pub _ich: ::std::os::raw::c_uint,
    pub _pszFound: BSTR,
    pub _pszExpected: BSTR,
    pub _reserved1: DWORD,
    pub _reserved2: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _xml_error"][::std::mem::size_of::<_xml_error>() - 48usize];
    ["Alignment of _xml_error"][::std::mem::align_of::<_xml_error>() - 8usize];
    ["Offset of field: _xml_error::_nLine"][::std::mem::offset_of!(_xml_error, _nLine) - 0usize];
    ["Offset of field: _xml_error::_pchBuf"][::std::mem::offset_of!(_xml_error, _pchBuf) - 8usize];
    ["Offset of field: _xml_error::_cchBuf"][::std::mem::offset_of!(_xml_error, _cchBuf) - 16usize];
    ["Offset of field: _xml_error::_ich"][::std::mem::offset_of!(_xml_error, _ich) - 20usize];
    ["Offset of field: _xml_error::_pszFound"]
        [::std::mem::offset_of!(_xml_error, _pszFound) - 24usize];
    ["Offset of field: _xml_error::_pszExpected"]
        [::std::mem::offset_of!(_xml_error, _pszExpected) - 32usize];
    ["Offset of field: _xml_error::_reserved1"]
        [::std::mem::offset_of!(_xml_error, _reserved1) - 40usize];
    ["Offset of field: _xml_error::_reserved2"]
        [::std::mem::offset_of!(_xml_error, _reserved2) - 44usize];
};
pub type XML_ERROR = _xml_error;
unsafe extern "C" {
    pub static mut __MIDL_itf_msxml_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_msxml_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub const tagDOMNodeType_NODE_INVALID: tagDOMNodeType = 0;
pub const tagDOMNodeType_NODE_ELEMENT: tagDOMNodeType = 1;
pub const tagDOMNodeType_NODE_ATTRIBUTE: tagDOMNodeType = 2;
pub const tagDOMNodeType_NODE_TEXT: tagDOMNodeType = 3;
pub const tagDOMNodeType_NODE_CDATA_SECTION: tagDOMNodeType = 4;
pub const tagDOMNodeType_NODE_ENTITY_REFERENCE: tagDOMNodeType = 5;
pub const tagDOMNodeType_NODE_ENTITY: tagDOMNodeType = 6;
pub const tagDOMNodeType_NODE_PROCESSING_INSTRUCTION: tagDOMNodeType = 7;
pub const tagDOMNodeType_NODE_COMMENT: tagDOMNodeType = 8;
pub const tagDOMNodeType_NODE_DOCUMENT: tagDOMNodeType = 9;
pub const tagDOMNodeType_NODE_DOCUMENT_TYPE: tagDOMNodeType = 10;
pub const tagDOMNodeType_NODE_DOCUMENT_FRAGMENT: tagDOMNodeType = 11;
pub const tagDOMNodeType_NODE_NOTATION: tagDOMNodeType = 12;
pub type tagDOMNodeType = ::std::os::raw::c_int;
pub use self::tagDOMNodeType as DOMNodeType;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_ELEMENT: tagXMLEMEM_TYPE = 0;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_TEXT: tagXMLEMEM_TYPE = 1;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_COMMENT: tagXMLEMEM_TYPE = 2;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_DOCUMENT: tagXMLEMEM_TYPE = 3;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_DTD: tagXMLEMEM_TYPE = 4;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_PI: tagXMLEMEM_TYPE = 5;
pub const tagXMLEMEM_TYPE_XMLELEMTYPE_OTHER: tagXMLEMEM_TYPE = 6;
pub type tagXMLEMEM_TYPE = ::std::os::raw::c_int;
pub use self::tagXMLEMEM_TYPE as XMLELEM_TYPE;
unsafe extern "C" {
    pub static LIBID_MSXML: IID;
}
unsafe extern "C" {
    pub static IID_IXMLDOMImplementation: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMImplementationVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMImplementation,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMImplementation) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMImplementation) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMImplementation, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMImplementation,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMImplementation,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMImplementation,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub hasFeature: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMImplementation,
            feature: BSTR,
            version: BSTR,
            hasFeature: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMImplementationVtbl"]
        [::std::mem::size_of::<IXMLDOMImplementationVtbl>() - 64usize];
    ["Alignment of IXMLDOMImplementationVtbl"]
        [::std::mem::align_of::<IXMLDOMImplementationVtbl>() - 8usize];
    ["Offset of field: IXMLDOMImplementationVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMImplementationVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMImplementationVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMImplementationVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMImplementationVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMImplementationVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMImplementationVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMImplementationVtbl::hasFeature"]
        [::std::mem::offset_of!(IXMLDOMImplementationVtbl, hasFeature) - 56usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMImplementation {
    pub lpVtbl: *mut IXMLDOMImplementationVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMImplementation"][::std::mem::size_of::<IXMLDOMImplementation>() - 8usize];
    ["Alignment of IXMLDOMImplementation"]
        [::std::mem::align_of::<IXMLDOMImplementation>() - 8usize];
    ["Offset of field: IXMLDOMImplementation::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMImplementation, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMNode: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNodeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNode) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNode) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, firstChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, lastChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, nextSibling: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNode, text: BSTR) -> HRESULT>,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNode, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNode,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNodeVtbl"][::std::mem::size_of::<IXMLDOMNodeVtbl>() - 344usize];
    ["Alignment of IXMLDOMNodeVtbl"][::std::mem::align_of::<IXMLDOMNodeVtbl>() - 8usize];
    ["Offset of field: IXMLDOMNodeVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMNodeVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMNodeVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMNodeVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMNodeVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMNodeVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMNodeVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMNodeVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMNodeVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMNodeVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMNodeVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMNodeVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMNodeVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMNodeVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMNodeVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMNodeVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMNodeVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMNodeVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMNodeVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMNodeVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMNodeVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMNodeVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMNodeVtbl, transformNodeToObject) - 336usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNode {
    pub lpVtbl: *mut IXMLDOMNodeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNode"][::std::mem::size_of::<IXMLDOMNode>() - 8usize];
    ["Alignment of IXMLDOMNode"][::std::mem::align_of::<IXMLDOMNode>() - 8usize];
    ["Offset of field: IXMLDOMNode::lpVtbl"][::std::mem::offset_of!(IXMLDOMNode, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMDocumentFragment: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocumentFragmentVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            type_: *mut DOMNodeType,
        ) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            typedValue: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            dataTypeName: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            namespaceURI: *mut BSTR,
        ) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            prefixString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentFragment, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentFragment,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocumentFragmentVtbl"]
        [::std::mem::size_of::<IXMLDOMDocumentFragmentVtbl>() - 344usize];
    ["Alignment of IXMLDOMDocumentFragmentVtbl"]
        [::std::mem::align_of::<IXMLDOMDocumentFragmentVtbl>() - 8usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMDocumentFragmentVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragmentVtbl, transformNodeToObject) - 336usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocumentFragment {
    pub lpVtbl: *mut IXMLDOMDocumentFragmentVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocumentFragment"][::std::mem::size_of::<IXMLDOMDocumentFragment>() - 8usize];
    ["Alignment of IXMLDOMDocumentFragment"]
        [::std::mem::align_of::<IXMLDOMDocumentFragment>() - 8usize];
    ["Offset of field: IXMLDOMDocumentFragment::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMDocumentFragment, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMDocument: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocumentVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocument) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocument) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_doctype: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            documentType: *mut *mut IXMLDOMDocumentType,
        ) -> HRESULT,
    >,
    pub get_implementation: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            impl_: *mut *mut IXMLDOMImplementation,
        ) -> HRESULT,
    >,
    pub get_documentElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            DOMElement: *mut *mut IXMLDOMElement,
        ) -> HRESULT,
    >,
    pub putref_documentElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            DOMElement: *mut IXMLDOMElement,
        ) -> HRESULT,
    >,
    pub createElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            tagName: BSTR,
            element: *mut *mut IXMLDOMElement,
        ) -> HRESULT,
    >,
    pub createDocumentFragment: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            docFrag: *mut *mut IXMLDOMDocumentFragment,
        ) -> HRESULT,
    >,
    pub createTextNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            data: BSTR,
            text: *mut *mut IXMLDOMText,
        ) -> HRESULT,
    >,
    pub createComment: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            data: BSTR,
            comment: *mut *mut IXMLDOMComment,
        ) -> HRESULT,
    >,
    pub createCDATASection: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            data: BSTR,
            cdata: *mut *mut IXMLDOMCDATASection,
        ) -> HRESULT,
    >,
    pub createProcessingInstruction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            target: BSTR,
            data: BSTR,
            pi: *mut *mut IXMLDOMProcessingInstruction,
        ) -> HRESULT,
    >,
    pub createAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            name: BSTR,
            attribute: *mut *mut IXMLDOMAttribute,
        ) -> HRESULT,
    >,
    pub createEntityReference: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            name: BSTR,
            entityRef: *mut *mut IXMLDOMEntityReference,
        ) -> HRESULT,
    >,
    pub getElementsByTagName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            tagName: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub createNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            Type: VARIANT,
            name: BSTR,
            namespaceURI: BSTR,
            node: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub nodeFromID: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            idString: BSTR,
            node: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub load: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            xmlSource: VARIANT,
            isSuccessful: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_readyState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            value: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_parseError: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            errorObj: *mut *mut IXMLDOMParseError,
        ) -> HRESULT,
    >,
    pub get_url: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, urlString: *mut BSTR) -> HRESULT,
    >,
    pub get_async: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isAsync: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub put_async: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isAsync: VARIANT_BOOL) -> HRESULT,
    >,
    pub abort: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocument) -> HRESULT>,
    pub loadXML: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            bstrXML: BSTR,
            isSuccessful: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub save: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, destination: VARIANT) -> HRESULT,
    >,
    pub get_validateOnParse: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            isValidating: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub put_validateOnParse: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isValidating: VARIANT_BOOL) -> HRESULT,
    >,
    pub get_resolveExternals: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isResolving: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub put_resolveExternals: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isResolving: VARIANT_BOOL) -> HRESULT,
    >,
    pub get_preserveWhiteSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocument,
            isPreserving: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub put_preserveWhiteSpace: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, isPreserving: VARIANT_BOOL) -> HRESULT,
    >,
    pub put_onreadystatechange: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, readystatechangeSink: VARIANT) -> HRESULT,
    >,
    pub put_ondataavailable: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, ondataavailableSink: VARIANT) -> HRESULT,
    >,
    pub put_ontransformnode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocument, ontransformnodeSink: VARIANT) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocumentVtbl"][::std::mem::size_of::<IXMLDOMDocumentVtbl>() - 608usize];
    ["Alignment of IXMLDOMDocumentVtbl"][::std::mem::align_of::<IXMLDOMDocumentVtbl>() - 8usize];
    ["Offset of field: IXMLDOMDocumentVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMDocumentVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMDocumentVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMDocumentVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMDocumentVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMDocumentVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMDocumentVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMDocumentVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMDocumentVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMDocumentVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMDocumentVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMDocumentVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMDocumentVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMDocumentVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMDocumentVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMDocumentVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMDocumentVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_doctype"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_doctype) - 344usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_implementation"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_implementation) - 352usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_documentElement"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_documentElement) - 360usize];
    ["Offset of field: IXMLDOMDocumentVtbl::putref_documentElement"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, putref_documentElement) - 368usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createElement"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createElement) - 376usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createDocumentFragment"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createDocumentFragment) - 384usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createTextNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createTextNode) - 392usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createComment"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createComment) - 400usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createCDATASection"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createCDATASection) - 408usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createProcessingInstruction"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createProcessingInstruction) - 416usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createAttribute"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createAttribute) - 424usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createEntityReference"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createEntityReference) - 432usize];
    ["Offset of field: IXMLDOMDocumentVtbl::getElementsByTagName"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, getElementsByTagName) - 440usize];
    ["Offset of field: IXMLDOMDocumentVtbl::createNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, createNode) - 448usize];
    ["Offset of field: IXMLDOMDocumentVtbl::nodeFromID"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, nodeFromID) - 456usize];
    ["Offset of field: IXMLDOMDocumentVtbl::load"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, load) - 464usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_readyState"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_readyState) - 472usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_parseError"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_parseError) - 480usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_url"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_url) - 488usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_async"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_async) - 496usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_async"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_async) - 504usize];
    ["Offset of field: IXMLDOMDocumentVtbl::abort"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, abort) - 512usize];
    ["Offset of field: IXMLDOMDocumentVtbl::loadXML"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, loadXML) - 520usize];
    ["Offset of field: IXMLDOMDocumentVtbl::save"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, save) - 528usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_validateOnParse"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_validateOnParse) - 536usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_validateOnParse"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_validateOnParse) - 544usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_resolveExternals"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_resolveExternals) - 552usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_resolveExternals"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_resolveExternals) - 560usize];
    ["Offset of field: IXMLDOMDocumentVtbl::get_preserveWhiteSpace"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, get_preserveWhiteSpace) - 568usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_preserveWhiteSpace"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_preserveWhiteSpace) - 576usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_onreadystatechange"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_onreadystatechange) - 584usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_ondataavailable"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_ondataavailable) - 592usize];
    ["Offset of field: IXMLDOMDocumentVtbl::put_ontransformnode"]
        [::std::mem::offset_of!(IXMLDOMDocumentVtbl, put_ontransformnode) - 600usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocument {
    pub lpVtbl: *mut IXMLDOMDocumentVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocument"][::std::mem::size_of::<IXMLDOMDocument>() - 8usize];
    ["Alignment of IXMLDOMDocument"][::std::mem::align_of::<IXMLDOMDocument>() - 8usize];
    ["Offset of field: IXMLDOMDocument::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMDocument, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMNodeList: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNodeListVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNodeList) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNodeList) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNodeList, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_item: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            index: ::std::os::raw::c_long,
            listItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            listLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub nextNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNodeList,
            nextItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub reset: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNodeList) -> HRESULT>,
    pub get__newEnum: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNodeList, ppUnk: *mut *mut IUnknown) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNodeListVtbl"][::std::mem::size_of::<IXMLDOMNodeListVtbl>() - 96usize];
    ["Alignment of IXMLDOMNodeListVtbl"][::std::mem::align_of::<IXMLDOMNodeListVtbl>() - 8usize];
    ["Offset of field: IXMLDOMNodeListVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMNodeListVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMNodeListVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMNodeListVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMNodeListVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMNodeListVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMNodeListVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMNodeListVtbl::get_item"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, get_item) - 56usize];
    ["Offset of field: IXMLDOMNodeListVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, get_length) - 64usize];
    ["Offset of field: IXMLDOMNodeListVtbl::nextNode"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, nextNode) - 72usize];
    ["Offset of field: IXMLDOMNodeListVtbl::reset"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, reset) - 80usize];
    ["Offset of field: IXMLDOMNodeListVtbl::get__newEnum"]
        [::std::mem::offset_of!(IXMLDOMNodeListVtbl, get__newEnum) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNodeList {
    pub lpVtbl: *mut IXMLDOMNodeListVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNodeList"][::std::mem::size_of::<IXMLDOMNodeList>() - 8usize];
    ["Alignment of IXMLDOMNodeList"][::std::mem::align_of::<IXMLDOMNodeList>() - 8usize];
    ["Offset of field: IXMLDOMNodeList::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMNodeList, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMNamedNodeMap: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNamedNodeMapVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNamedNodeMap) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNamedNodeMap) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNamedNodeMap, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub getNamedItem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            name: BSTR,
            namedItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub setNamedItem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            newItem: *mut IXMLDOMNode,
            nameItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeNamedItem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            name: BSTR,
            namedItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_item: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            index: ::std::os::raw::c_long,
            listItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            listLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub getQualifiedItem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            baseName: BSTR,
            namespaceURI: BSTR,
            qualifiedItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeQualifiedItem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            baseName: BSTR,
            namespaceURI: BSTR,
            qualifiedItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub nextNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNamedNodeMap,
            nextItem: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub reset:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNamedNodeMap) -> HRESULT>,
    pub get__newEnum: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNamedNodeMap, ppUnk: *mut *mut IUnknown) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNamedNodeMapVtbl"]
        [::std::mem::size_of::<IXMLDOMNamedNodeMapVtbl>() - 136usize];
    ["Alignment of IXMLDOMNamedNodeMapVtbl"]
        [::std::mem::align_of::<IXMLDOMNamedNodeMapVtbl>() - 8usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::getNamedItem"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, getNamedItem) - 56usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::setNamedItem"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, setNamedItem) - 64usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::removeNamedItem"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, removeNamedItem) - 72usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::get_item"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, get_item) - 80usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, get_length) - 88usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::getQualifiedItem"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, getQualifiedItem) - 96usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::removeQualifiedItem"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, removeQualifiedItem) - 104usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::nextNode"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, nextNode) - 112usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::reset"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, reset) - 120usize];
    ["Offset of field: IXMLDOMNamedNodeMapVtbl::get__newEnum"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMapVtbl, get__newEnum) - 128usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNamedNodeMap {
    pub lpVtbl: *mut IXMLDOMNamedNodeMapVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNamedNodeMap"][::std::mem::size_of::<IXMLDOMNamedNodeMap>() - 8usize];
    ["Alignment of IXMLDOMNamedNodeMap"][::std::mem::align_of::<IXMLDOMNamedNodeMap>() - 8usize];
    ["Offset of field: IXMLDOMNamedNodeMap::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMNamedNodeMap, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMCharacterData: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMCharacterDataVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMCharacterData) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMCharacterData) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            dataTypeName: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, data: *mut BSTR) -> HRESULT,
    >,
    pub put_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, data: BSTR) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            dataLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub substringData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: *mut BSTR,
        ) -> HRESULT,
    >,
    pub appendData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCharacterData, data: BSTR) -> HRESULT,
    >,
    pub insertData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            offset: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub deleteData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub replaceData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCharacterData,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMCharacterDataVtbl"]
        [::std::mem::size_of::<IXMLDOMCharacterDataVtbl>() - 408usize];
    ["Alignment of IXMLDOMCharacterDataVtbl"]
        [::std::mem::align_of::<IXMLDOMCharacterDataVtbl>() - 8usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_data"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_data) - 344usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::put_data"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, put_data) - 352usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, get_length) - 360usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::substringData"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, substringData) - 368usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::appendData"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, appendData) - 376usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::insertData"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, insertData) - 384usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::deleteData"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, deleteData) - 392usize];
    ["Offset of field: IXMLDOMCharacterDataVtbl::replaceData"]
        [::std::mem::offset_of!(IXMLDOMCharacterDataVtbl, replaceData) - 400usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMCharacterData {
    pub lpVtbl: *mut IXMLDOMCharacterDataVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMCharacterData"][::std::mem::size_of::<IXMLDOMCharacterData>() - 8usize];
    ["Alignment of IXMLDOMCharacterData"][::std::mem::align_of::<IXMLDOMCharacterData>() - 8usize];
    ["Offset of field: IXMLDOMCharacterData::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMCharacterData, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMAttribute: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMAttributeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMAttribute) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMAttribute) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMAttribute,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_name: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, attributeName: *mut BSTR) -> HRESULT,
    >,
    pub get_value: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, attributeValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_value: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMAttribute, attributeValue: VARIANT) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMAttributeVtbl"][::std::mem::size_of::<IXMLDOMAttributeVtbl>() - 368usize];
    ["Alignment of IXMLDOMAttributeVtbl"][::std::mem::align_of::<IXMLDOMAttributeVtbl>() - 8usize];
    ["Offset of field: IXMLDOMAttributeVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMAttributeVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMAttributeVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMAttributeVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMAttributeVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMAttributeVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMAttributeVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMAttributeVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMAttributeVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMAttributeVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMAttributeVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMAttributeVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMAttributeVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMAttributeVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMAttributeVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMAttributeVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMAttributeVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMAttributeVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMAttributeVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMAttributeVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMAttributeVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_name"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_name) - 344usize];
    ["Offset of field: IXMLDOMAttributeVtbl::get_value"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, get_value) - 352usize];
    ["Offset of field: IXMLDOMAttributeVtbl::put_value"]
        [::std::mem::offset_of!(IXMLDOMAttributeVtbl, put_value) - 360usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMAttribute {
    pub lpVtbl: *mut IXMLDOMAttributeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMAttribute"][::std::mem::size_of::<IXMLDOMAttribute>() - 8usize];
    ["Alignment of IXMLDOMAttribute"][::std::mem::align_of::<IXMLDOMAttribute>() - 8usize];
    ["Offset of field: IXMLDOMAttribute::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMAttribute, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMElement: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMElementVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMElement) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMElement) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_tagName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, tagName: *mut BSTR) -> HRESULT,
    >,
    pub getAttribute: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, name: BSTR, value: *mut VARIANT) -> HRESULT,
    >,
    pub setAttribute: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, name: BSTR, value: VARIANT) -> HRESULT,
    >,
    pub removeAttribute: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMElement, name: BSTR) -> HRESULT,
    >,
    pub getAttributeNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            name: BSTR,
            attributeNode: *mut *mut IXMLDOMAttribute,
        ) -> HRESULT,
    >,
    pub setAttributeNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            DOMAttribute: *mut IXMLDOMAttribute,
            attributeNode: *mut *mut IXMLDOMAttribute,
        ) -> HRESULT,
    >,
    pub removeAttributeNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            DOMAttribute: *mut IXMLDOMAttribute,
            attributeNode: *mut *mut IXMLDOMAttribute,
        ) -> HRESULT,
    >,
    pub getElementsByTagName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMElement,
            tagName: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub normalize:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMElement) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMElementVtbl"][::std::mem::size_of::<IXMLDOMElementVtbl>() - 416usize];
    ["Alignment of IXMLDOMElementVtbl"][::std::mem::align_of::<IXMLDOMElementVtbl>() - 8usize];
    ["Offset of field: IXMLDOMElementVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMElementVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMElementVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMElementVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMElementVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMElementVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMElementVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMElementVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMElementVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMElementVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMElementVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMElementVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMElementVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMElementVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMElementVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMElementVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMElementVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMElementVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMElementVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMElementVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMElementVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMElementVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMElementVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMElementVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMElementVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMElementVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMElementVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMElementVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMElementVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMElementVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMElementVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMElementVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMElementVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMElementVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMElementVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMElementVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMElementVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMElementVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMElementVtbl::get_tagName"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, get_tagName) - 344usize];
    ["Offset of field: IXMLDOMElementVtbl::getAttribute"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, getAttribute) - 352usize];
    ["Offset of field: IXMLDOMElementVtbl::setAttribute"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, setAttribute) - 360usize];
    ["Offset of field: IXMLDOMElementVtbl::removeAttribute"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, removeAttribute) - 368usize];
    ["Offset of field: IXMLDOMElementVtbl::getAttributeNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, getAttributeNode) - 376usize];
    ["Offset of field: IXMLDOMElementVtbl::setAttributeNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, setAttributeNode) - 384usize];
    ["Offset of field: IXMLDOMElementVtbl::removeAttributeNode"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, removeAttributeNode) - 392usize];
    ["Offset of field: IXMLDOMElementVtbl::getElementsByTagName"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, getElementsByTagName) - 400usize];
    ["Offset of field: IXMLDOMElementVtbl::normalize"]
        [::std::mem::offset_of!(IXMLDOMElementVtbl, normalize) - 408usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMElement {
    pub lpVtbl: *mut IXMLDOMElementVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMElement"][::std::mem::size_of::<IXMLDOMElement>() - 8usize];
    ["Alignment of IXMLDOMElement"][::std::mem::align_of::<IXMLDOMElement>() - 8usize];
    ["Offset of field: IXMLDOMElement::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMElement, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMText: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMTextVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMText) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMText) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, firstChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, lastChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, nextSibling: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMText, text: BSTR) -> HRESULT>,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMText, data: *mut BSTR) -> HRESULT,
    >,
    pub put_data:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMText, data: BSTR) -> HRESULT>,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            dataLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub substringData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: *mut BSTR,
        ) -> HRESULT,
    >,
    pub appendData:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMText, data: BSTR) -> HRESULT>,
    pub insertData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            offset: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub deleteData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub replaceData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub splitText: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMText,
            offset: ::std::os::raw::c_long,
            rightHandTextNode: *mut *mut IXMLDOMText,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMTextVtbl"][::std::mem::size_of::<IXMLDOMTextVtbl>() - 416usize];
    ["Alignment of IXMLDOMTextVtbl"][::std::mem::align_of::<IXMLDOMTextVtbl>() - 8usize];
    ["Offset of field: IXMLDOMTextVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMTextVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMTextVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMTextVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMTextVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMTextVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMTextVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMTextVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMTextVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMTextVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMTextVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMTextVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMTextVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMTextVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMTextVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMTextVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMTextVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMTextVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMTextVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMTextVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMTextVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMTextVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMTextVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMTextVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMTextVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMTextVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMTextVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMTextVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMTextVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMTextVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMTextVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMTextVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMTextVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMTextVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMTextVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMTextVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMTextVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMTextVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMTextVtbl::get_data"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_data) - 344usize];
    ["Offset of field: IXMLDOMTextVtbl::put_data"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, put_data) - 352usize];
    ["Offset of field: IXMLDOMTextVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, get_length) - 360usize];
    ["Offset of field: IXMLDOMTextVtbl::substringData"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, substringData) - 368usize];
    ["Offset of field: IXMLDOMTextVtbl::appendData"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, appendData) - 376usize];
    ["Offset of field: IXMLDOMTextVtbl::insertData"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, insertData) - 384usize];
    ["Offset of field: IXMLDOMTextVtbl::deleteData"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, deleteData) - 392usize];
    ["Offset of field: IXMLDOMTextVtbl::replaceData"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, replaceData) - 400usize];
    ["Offset of field: IXMLDOMTextVtbl::splitText"]
        [::std::mem::offset_of!(IXMLDOMTextVtbl, splitText) - 408usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMText {
    pub lpVtbl: *mut IXMLDOMTextVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMText"][::std::mem::size_of::<IXMLDOMText>() - 8usize];
    ["Alignment of IXMLDOMText"][::std::mem::align_of::<IXMLDOMText>() - 8usize];
    ["Offset of field: IXMLDOMText::lpVtbl"][::std::mem::offset_of!(IXMLDOMText, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMComment: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMCommentVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMComment) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMComment) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, data: *mut BSTR) -> HRESULT,
    >,
    pub put_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, data: BSTR) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            dataLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub substringData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: *mut BSTR,
        ) -> HRESULT,
    >,
    pub appendData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMComment, data: BSTR) -> HRESULT,
    >,
    pub insertData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            offset: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub deleteData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub replaceData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMComment,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMCommentVtbl"][::std::mem::size_of::<IXMLDOMCommentVtbl>() - 408usize];
    ["Alignment of IXMLDOMCommentVtbl"][::std::mem::align_of::<IXMLDOMCommentVtbl>() - 8usize];
    ["Offset of field: IXMLDOMCommentVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMCommentVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMCommentVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMCommentVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMCommentVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMCommentVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMCommentVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMCommentVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMCommentVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMCommentVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMCommentVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMCommentVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMCommentVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMCommentVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMCommentVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMCommentVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMCommentVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMCommentVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMCommentVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMCommentVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMCommentVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_data"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_data) - 344usize];
    ["Offset of field: IXMLDOMCommentVtbl::put_data"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, put_data) - 352usize];
    ["Offset of field: IXMLDOMCommentVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, get_length) - 360usize];
    ["Offset of field: IXMLDOMCommentVtbl::substringData"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, substringData) - 368usize];
    ["Offset of field: IXMLDOMCommentVtbl::appendData"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, appendData) - 376usize];
    ["Offset of field: IXMLDOMCommentVtbl::insertData"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, insertData) - 384usize];
    ["Offset of field: IXMLDOMCommentVtbl::deleteData"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, deleteData) - 392usize];
    ["Offset of field: IXMLDOMCommentVtbl::replaceData"]
        [::std::mem::offset_of!(IXMLDOMCommentVtbl, replaceData) - 400usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMComment {
    pub lpVtbl: *mut IXMLDOMCommentVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMComment"][::std::mem::size_of::<IXMLDOMComment>() - 8usize];
    ["Alignment of IXMLDOMComment"][::std::mem::align_of::<IXMLDOMComment>() - 8usize];
    ["Offset of field: IXMLDOMComment::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMComment, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMProcessingInstruction: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMProcessingInstructionVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction) -> ULONG,
    >,
    pub Release: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction) -> ULONG,
    >,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            pctinfo: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            value: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            type_: *mut DOMNodeType,
        ) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            nodeType: *mut BSTR,
        ) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            typedValue: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            typedValue: VARIANT,
        ) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            dataTypeName: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            dataTypeName: BSTR,
        ) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            namespaceURI: *mut BSTR,
        ) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            prefixString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            nameString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMProcessingInstruction,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_target: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, name: *mut BSTR) -> HRESULT,
    >,
    pub get_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, value: *mut BSTR) -> HRESULT,
    >,
    pub put_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMProcessingInstruction, value: BSTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMProcessingInstructionVtbl"]
        [::std::mem::size_of::<IXMLDOMProcessingInstructionVtbl>() - 368usize];
    ["Alignment of IXMLDOMProcessingInstructionVtbl"]
        [::std::mem::align_of::<IXMLDOMProcessingInstructionVtbl>() - 8usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::transformNodeToObject"][::std::mem::offset_of!(
        IXMLDOMProcessingInstructionVtbl,
        transformNodeToObject
    ) - 336usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_target"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_target) - 344usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::get_data"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, get_data) - 352usize];
    ["Offset of field: IXMLDOMProcessingInstructionVtbl::put_data"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstructionVtbl, put_data) - 360usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMProcessingInstruction {
    pub lpVtbl: *mut IXMLDOMProcessingInstructionVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMProcessingInstruction"]
        [::std::mem::size_of::<IXMLDOMProcessingInstruction>() - 8usize];
    ["Alignment of IXMLDOMProcessingInstruction"]
        [::std::mem::align_of::<IXMLDOMProcessingInstruction>() - 8usize];
    ["Offset of field: IXMLDOMProcessingInstruction::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMProcessingInstruction, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMCDATASection: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMCDATASectionVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMCDATASection) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMCDATASection) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, data: *mut BSTR) -> HRESULT,
    >,
    pub put_data: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, data: BSTR) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            dataLength: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub substringData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: *mut BSTR,
        ) -> HRESULT,
    >,
    pub appendData: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMCDATASection, data: BSTR) -> HRESULT,
    >,
    pub insertData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            offset: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub deleteData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub replaceData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            offset: ::std::os::raw::c_long,
            count: ::std::os::raw::c_long,
            data: BSTR,
        ) -> HRESULT,
    >,
    pub splitText: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMCDATASection,
            offset: ::std::os::raw::c_long,
            rightHandTextNode: *mut *mut IXMLDOMText,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMCDATASectionVtbl"]
        [::std::mem::size_of::<IXMLDOMCDATASectionVtbl>() - 416usize];
    ["Alignment of IXMLDOMCDATASectionVtbl"]
        [::std::mem::align_of::<IXMLDOMCDATASectionVtbl>() - 8usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_data"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_data) - 344usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::put_data"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, put_data) - 352usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::get_length"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, get_length) - 360usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::substringData"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, substringData) - 368usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::appendData"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, appendData) - 376usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::insertData"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, insertData) - 384usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::deleteData"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, deleteData) - 392usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::replaceData"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, replaceData) - 400usize];
    ["Offset of field: IXMLDOMCDATASectionVtbl::splitText"]
        [::std::mem::offset_of!(IXMLDOMCDATASectionVtbl, splitText) - 408usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMCDATASection {
    pub lpVtbl: *mut IXMLDOMCDATASectionVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMCDATASection"][::std::mem::size_of::<IXMLDOMCDATASection>() - 8usize];
    ["Alignment of IXMLDOMCDATASection"][::std::mem::align_of::<IXMLDOMCDATASection>() - 8usize];
    ["Offset of field: IXMLDOMCDATASection::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMCDATASection, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMDocumentType: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocumentTypeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocumentType) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMDocumentType) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_name: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMDocumentType, rootName: *mut BSTR) -> HRESULT,
    >,
    pub get_entities: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            entityMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub get_notations: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMDocumentType,
            notationMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocumentTypeVtbl"]
        [::std::mem::size_of::<IXMLDOMDocumentTypeVtbl>() - 368usize];
    ["Alignment of IXMLDOMDocumentTypeVtbl"]
        [::std::mem::align_of::<IXMLDOMDocumentTypeVtbl>() - 8usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_name"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_name) - 344usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_entities"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_entities) - 352usize];
    ["Offset of field: IXMLDOMDocumentTypeVtbl::get_notations"]
        [::std::mem::offset_of!(IXMLDOMDocumentTypeVtbl, get_notations) - 360usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMDocumentType {
    pub lpVtbl: *mut IXMLDOMDocumentTypeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMDocumentType"][::std::mem::size_of::<IXMLDOMDocumentType>() - 8usize];
    ["Alignment of IXMLDOMDocumentType"][::std::mem::align_of::<IXMLDOMDocumentType>() - 8usize];
    ["Offset of field: IXMLDOMDocumentType::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMDocumentType, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMNotation: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNotationVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNotation) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMNotation) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMNotation,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_publicId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, publicID: *mut VARIANT) -> HRESULT,
    >,
    pub get_systemId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMNotation, systemID: *mut VARIANT) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNotationVtbl"][::std::mem::size_of::<IXMLDOMNotationVtbl>() - 360usize];
    ["Alignment of IXMLDOMNotationVtbl"][::std::mem::align_of::<IXMLDOMNotationVtbl>() - 8usize];
    ["Offset of field: IXMLDOMNotationVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMNotationVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMNotationVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMNotationVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMNotationVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMNotationVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMNotationVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMNotationVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMNotationVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMNotationVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMNotationVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMNotationVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMNotationVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMNotationVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMNotationVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMNotationVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMNotationVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMNotationVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMNotationVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMNotationVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMNotationVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_publicId"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_publicId) - 344usize];
    ["Offset of field: IXMLDOMNotationVtbl::get_systemId"]
        [::std::mem::offset_of!(IXMLDOMNotationVtbl, get_systemId) - 352usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMNotation {
    pub lpVtbl: *mut IXMLDOMNotationVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMNotation"][::std::mem::size_of::<IXMLDOMNotation>() - 8usize];
    ["Alignment of IXMLDOMNotation"][::std::mem::align_of::<IXMLDOMNotation>() - 8usize];
    ["Offset of field: IXMLDOMNotation::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMNotation, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMEntity: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMEntityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMEntity) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMEntity) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, lastChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntity,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub get_publicId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, publicID: *mut VARIANT) -> HRESULT,
    >,
    pub get_systemId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, systemID: *mut VARIANT) -> HRESULT,
    >,
    pub get_notationName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntity, name: *mut BSTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMEntityVtbl"][::std::mem::size_of::<IXMLDOMEntityVtbl>() - 368usize];
    ["Alignment of IXMLDOMEntityVtbl"][::std::mem::align_of::<IXMLDOMEntityVtbl>() - 8usize];
    ["Offset of field: IXMLDOMEntityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMEntityVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMEntityVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMEntityVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMEntityVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMEntityVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMEntityVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMEntityVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMEntityVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMEntityVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMEntityVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMEntityVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMEntityVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMEntityVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMEntityVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMEntityVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMEntityVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMEntityVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMEntityVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMEntityVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMEntityVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_publicId"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_publicId) - 344usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_systemId"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_systemId) - 352usize];
    ["Offset of field: IXMLDOMEntityVtbl::get_notationName"]
        [::std::mem::offset_of!(IXMLDOMEntityVtbl, get_notationName) - 360usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMEntity {
    pub lpVtbl: *mut IXMLDOMEntityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMEntity"][::std::mem::size_of::<IXMLDOMEntity>() - 8usize];
    ["Alignment of IXMLDOMEntity"][::std::mem::align_of::<IXMLDOMEntity>() - 8usize];
    ["Offset of field: IXMLDOMEntity::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMEntity, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMEntityReference: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMEntityReferenceVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMEntityReference) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMEntityReference) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            parent: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            firstChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            lastChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            nextSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            hasChild: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, text: BSTR) -> HRESULT,
    >,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            isSpecified: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            typedValue: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            dataTypeName: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            isParsed: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMEntityReference, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMEntityReference,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMEntityReferenceVtbl"]
        [::std::mem::size_of::<IXMLDOMEntityReferenceVtbl>() - 344usize];
    ["Alignment of IXMLDOMEntityReferenceVtbl"]
        [::std::mem::align_of::<IXMLDOMEntityReferenceVtbl>() - 8usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_attributes) - 136usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::insertBefore"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, insertBefore) - 144usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::replaceChild"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, replaceChild) - 152usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, removeChild) - 160usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::appendChild"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, appendChild) - 168usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::cloneNode"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, cloneNode) - 192usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_text"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_text) - 208usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::put_text"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, put_text) - 216usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_specified"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_specified) - 224usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_definition"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_definition) - 232usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_dataType"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_dataType) - 256usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::put_dataType"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, put_dataType) - 264usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_xml"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_xml) - 272usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::transformNode"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, transformNode) - 280usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::selectNodes"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, selectNodes) - 288usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_parsed"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_parsed) - 304usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_prefix"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_prefix) - 320usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::get_baseName"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, get_baseName) - 328usize];
    ["Offset of field: IXMLDOMEntityReferenceVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXMLDOMEntityReferenceVtbl, transformNodeToObject) - 336usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMEntityReference {
    pub lpVtbl: *mut IXMLDOMEntityReferenceVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMEntityReference"][::std::mem::size_of::<IXMLDOMEntityReference>() - 8usize];
    ["Alignment of IXMLDOMEntityReference"]
        [::std::mem::align_of::<IXMLDOMEntityReference>() - 8usize];
    ["Offset of field: IXMLDOMEntityReference::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMEntityReference, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDOMParseError: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMParseErrorVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMParseError) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDOMParseError) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMParseError, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_errorCode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            errorCode: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_url: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMParseError, urlString: *mut BSTR) -> HRESULT,
    >,
    pub get_reason: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMParseError, reasonString: *mut BSTR) -> HRESULT,
    >,
    pub get_srcText: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDOMParseError, sourceString: *mut BSTR) -> HRESULT,
    >,
    pub get_line: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            lineNumber: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_linepos: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            linePosition: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_filepos: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDOMParseError,
            filePosition: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMParseErrorVtbl"][::std::mem::size_of::<IXMLDOMParseErrorVtbl>() - 112usize];
    ["Alignment of IXMLDOMParseErrorVtbl"]
        [::std::mem::align_of::<IXMLDOMParseErrorVtbl>() - 8usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::Release"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, Release) - 16usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_errorCode"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_errorCode) - 56usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_url"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_url) - 64usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_reason"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_reason) - 72usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_srcText"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_srcText) - 80usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_line"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_line) - 88usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_linepos"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_linepos) - 96usize];
    ["Offset of field: IXMLDOMParseErrorVtbl::get_filepos"]
        [::std::mem::offset_of!(IXMLDOMParseErrorVtbl, get_filepos) - 104usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDOMParseError {
    pub lpVtbl: *mut IXMLDOMParseErrorVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDOMParseError"][::std::mem::size_of::<IXMLDOMParseError>() - 8usize];
    ["Alignment of IXMLDOMParseError"][::std::mem::align_of::<IXMLDOMParseError>() - 8usize];
    ["Offset of field: IXMLDOMParseError::lpVtbl"]
        [::std::mem::offset_of!(IXMLDOMParseError, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXTLRuntime: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXTLRuntimeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXTLRuntime) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXTLRuntime) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_nodeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, name: *mut BSTR) -> HRESULT,
    >,
    pub get_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, value: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, value: VARIANT) -> HRESULT,
    >,
    pub get_nodeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, type_: *mut DOMNodeType) -> HRESULT,
    >,
    pub get_parentNode: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, parent: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_childNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            childList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub get_firstChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, firstChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_lastChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, lastChild: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_previousSibling: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            previousSibling: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nextSibling: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, nextSibling: *mut *mut IXMLDOMNode) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            attributeMap: *mut *mut IXMLDOMNamedNodeMap,
        ) -> HRESULT,
    >,
    pub insertBefore: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            newChild: *mut IXMLDOMNode,
            refChild: VARIANT,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub replaceChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            newChild: *mut IXMLDOMNode,
            oldChild: *mut IXMLDOMNode,
            outOldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            childNode: *mut IXMLDOMNode,
            oldChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub appendChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            newChild: *mut IXMLDOMNode,
            outNewChild: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub hasChildNodes: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, hasChild: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_ownerDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            XMLDOMDocument: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub cloneNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            deep: VARIANT_BOOL,
            cloneRoot: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypeString: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, nodeType: *mut BSTR) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, text: *mut BSTR) -> HRESULT,
    >,
    pub put_text:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXTLRuntime, text: BSTR) -> HRESULT>,
    pub get_specified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, isSpecified: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_definition: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            definitionNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, typedValue: *mut VARIANT) -> HRESULT,
    >,
    pub put_nodeTypedValue: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, typedValue: VARIANT) -> HRESULT,
    >,
    pub get_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, dataTypeName: *mut VARIANT) -> HRESULT,
    >,
    pub put_dataType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, dataTypeName: BSTR) -> HRESULT,
    >,
    pub get_xml: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, xmlString: *mut BSTR) -> HRESULT,
    >,
    pub transformNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            stylesheet: *mut IXMLDOMNode,
            xmlString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub selectNodes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            queryString: BSTR,
            resultList: *mut *mut IXMLDOMNodeList,
        ) -> HRESULT,
    >,
    pub selectSingleNode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            queryString: BSTR,
            resultNode: *mut *mut IXMLDOMNode,
        ) -> HRESULT,
    >,
    pub get_parsed: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, isParsed: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub get_namespaceURI: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, namespaceURI: *mut BSTR) -> HRESULT,
    >,
    pub get_prefix: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, prefixString: *mut BSTR) -> HRESULT,
    >,
    pub get_baseName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXTLRuntime, nameString: *mut BSTR) -> HRESULT,
    >,
    pub transformNodeToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            stylesheet: *mut IXMLDOMNode,
            outputObject: VARIANT,
        ) -> HRESULT,
    >,
    pub uniqueID: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            pNode: *mut IXMLDOMNode,
            pID: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub depth: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            pNode: *mut IXMLDOMNode,
            pDepth: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub childNumber: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            pNode: *mut IXMLDOMNode,
            pNumber: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub ancestorChildNumber: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            bstrNodeName: BSTR,
            pNode: *mut IXMLDOMNode,
            pNumber: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub absoluteChildNumber: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            pNode: *mut IXMLDOMNode,
            pNumber: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub formatIndex: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            lIndex: ::std::os::raw::c_long,
            bstrFormat: BSTR,
            pbstrFormattedString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub formatNumber: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            dblNumber: f64,
            bstrFormat: BSTR,
            pbstrFormattedString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub formatDate: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            varDate: VARIANT,
            bstrFormat: BSTR,
            varDestLocale: VARIANT,
            pbstrFormattedString: *mut BSTR,
        ) -> HRESULT,
    >,
    pub formatTime: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXTLRuntime,
            varTime: VARIANT,
            bstrFormat: BSTR,
            varDestLocale: VARIANT,
            pbstrFormattedString: *mut BSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXTLRuntimeVtbl"][::std::mem::size_of::<IXTLRuntimeVtbl>() - 416usize];
    ["Alignment of IXTLRuntimeVtbl"][::std::mem::align_of::<IXTLRuntimeVtbl>() - 8usize];
    ["Offset of field: IXTLRuntimeVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXTLRuntimeVtbl::AddRef"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, AddRef) - 8usize];
    ["Offset of field: IXTLRuntimeVtbl::Release"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, Release) - 16usize];
    ["Offset of field: IXTLRuntimeVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXTLRuntimeVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXTLRuntimeVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXTLRuntimeVtbl::Invoke"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, Invoke) - 48usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nodeName"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nodeName) - 56usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nodeValue"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nodeValue) - 64usize];
    ["Offset of field: IXTLRuntimeVtbl::put_nodeValue"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, put_nodeValue) - 72usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nodeType"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nodeType) - 80usize];
    ["Offset of field: IXTLRuntimeVtbl::get_parentNode"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_parentNode) - 88usize];
    ["Offset of field: IXTLRuntimeVtbl::get_childNodes"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_childNodes) - 96usize];
    ["Offset of field: IXTLRuntimeVtbl::get_firstChild"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_firstChild) - 104usize];
    ["Offset of field: IXTLRuntimeVtbl::get_lastChild"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_lastChild) - 112usize];
    ["Offset of field: IXTLRuntimeVtbl::get_previousSibling"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_previousSibling) - 120usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nextSibling"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nextSibling) - 128usize];
    ["Offset of field: IXTLRuntimeVtbl::get_attributes"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_attributes) - 136usize];
    ["Offset of field: IXTLRuntimeVtbl::insertBefore"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, insertBefore) - 144usize];
    ["Offset of field: IXTLRuntimeVtbl::replaceChild"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, replaceChild) - 152usize];
    ["Offset of field: IXTLRuntimeVtbl::removeChild"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, removeChild) - 160usize];
    ["Offset of field: IXTLRuntimeVtbl::appendChild"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, appendChild) - 168usize];
    ["Offset of field: IXTLRuntimeVtbl::hasChildNodes"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, hasChildNodes) - 176usize];
    ["Offset of field: IXTLRuntimeVtbl::get_ownerDocument"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_ownerDocument) - 184usize];
    ["Offset of field: IXTLRuntimeVtbl::cloneNode"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, cloneNode) - 192usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nodeTypeString"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nodeTypeString) - 200usize];
    ["Offset of field: IXTLRuntimeVtbl::get_text"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_text) - 208usize];
    ["Offset of field: IXTLRuntimeVtbl::put_text"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, put_text) - 216usize];
    ["Offset of field: IXTLRuntimeVtbl::get_specified"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_specified) - 224usize];
    ["Offset of field: IXTLRuntimeVtbl::get_definition"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_definition) - 232usize];
    ["Offset of field: IXTLRuntimeVtbl::get_nodeTypedValue"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_nodeTypedValue) - 240usize];
    ["Offset of field: IXTLRuntimeVtbl::put_nodeTypedValue"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, put_nodeTypedValue) - 248usize];
    ["Offset of field: IXTLRuntimeVtbl::get_dataType"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_dataType) - 256usize];
    ["Offset of field: IXTLRuntimeVtbl::put_dataType"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, put_dataType) - 264usize];
    ["Offset of field: IXTLRuntimeVtbl::get_xml"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_xml) - 272usize];
    ["Offset of field: IXTLRuntimeVtbl::transformNode"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, transformNode) - 280usize];
    ["Offset of field: IXTLRuntimeVtbl::selectNodes"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, selectNodes) - 288usize];
    ["Offset of field: IXTLRuntimeVtbl::selectSingleNode"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, selectSingleNode) - 296usize];
    ["Offset of field: IXTLRuntimeVtbl::get_parsed"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_parsed) - 304usize];
    ["Offset of field: IXTLRuntimeVtbl::get_namespaceURI"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_namespaceURI) - 312usize];
    ["Offset of field: IXTLRuntimeVtbl::get_prefix"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_prefix) - 320usize];
    ["Offset of field: IXTLRuntimeVtbl::get_baseName"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, get_baseName) - 328usize];
    ["Offset of field: IXTLRuntimeVtbl::transformNodeToObject"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, transformNodeToObject) - 336usize];
    ["Offset of field: IXTLRuntimeVtbl::uniqueID"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, uniqueID) - 344usize];
    ["Offset of field: IXTLRuntimeVtbl::depth"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, depth) - 352usize];
    ["Offset of field: IXTLRuntimeVtbl::childNumber"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, childNumber) - 360usize];
    ["Offset of field: IXTLRuntimeVtbl::ancestorChildNumber"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, ancestorChildNumber) - 368usize];
    ["Offset of field: IXTLRuntimeVtbl::absoluteChildNumber"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, absoluteChildNumber) - 376usize];
    ["Offset of field: IXTLRuntimeVtbl::formatIndex"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, formatIndex) - 384usize];
    ["Offset of field: IXTLRuntimeVtbl::formatNumber"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, formatNumber) - 392usize];
    ["Offset of field: IXTLRuntimeVtbl::formatDate"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, formatDate) - 400usize];
    ["Offset of field: IXTLRuntimeVtbl::formatTime"]
        [::std::mem::offset_of!(IXTLRuntimeVtbl, formatTime) - 408usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXTLRuntime {
    pub lpVtbl: *mut IXTLRuntimeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXTLRuntime"][::std::mem::size_of::<IXTLRuntime>() - 8usize];
    ["Alignment of IXTLRuntime"][::std::mem::align_of::<IXTLRuntime>() - 8usize];
    ["Offset of field: IXTLRuntime::lpVtbl"][::std::mem::offset_of!(IXTLRuntime, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static DIID_XMLDOMDocumentEvents: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct XMLDOMDocumentEventsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut XMLDOMDocumentEvents,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut XMLDOMDocumentEvents) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut XMLDOMDocumentEvents) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut XMLDOMDocumentEvents, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut XMLDOMDocumentEvents,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut XMLDOMDocumentEvents,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut XMLDOMDocumentEvents,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of XMLDOMDocumentEventsVtbl"]
        [::std::mem::size_of::<XMLDOMDocumentEventsVtbl>() - 56usize];
    ["Alignment of XMLDOMDocumentEventsVtbl"]
        [::std::mem::align_of::<XMLDOMDocumentEventsVtbl>() - 8usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::QueryInterface"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, QueryInterface) - 0usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::AddRef"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, AddRef) - 8usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::Release"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, Release) - 16usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: XMLDOMDocumentEventsVtbl::Invoke"]
        [::std::mem::offset_of!(XMLDOMDocumentEventsVtbl, Invoke) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct XMLDOMDocumentEvents {
    pub lpVtbl: *mut XMLDOMDocumentEventsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of XMLDOMDocumentEvents"][::std::mem::size_of::<XMLDOMDocumentEvents>() - 8usize];
    ["Alignment of XMLDOMDocumentEvents"][::std::mem::align_of::<XMLDOMDocumentEvents>() - 8usize];
    ["Offset of field: XMLDOMDocumentEvents::lpVtbl"]
        [::std::mem::offset_of!(XMLDOMDocumentEvents, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_DOMDocument: CLSID;
}
unsafe extern "C" {
    pub static CLSID_DOMFreeThreadedDocument: CLSID;
}
unsafe extern "C" {
    pub static IID_IXMLHttpRequest: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLHttpRequestVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLHttpRequest) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLHttpRequest) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub open: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            bstrMethod: BSTR,
            bstrUrl: BSTR,
            varAsync: VARIANT,
            bstrUser: VARIANT,
            bstrPassword: VARIANT,
        ) -> HRESULT,
    >,
    pub setRequestHeader: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            bstrHeader: BSTR,
            bstrValue: BSTR,
        ) -> HRESULT,
    >,
    pub getResponseHeader: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            bstrHeader: BSTR,
            pbstrValue: *mut BSTR,
        ) -> HRESULT,
    >,
    pub getAllResponseHeaders: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pbstrHeaders: *mut BSTR) -> HRESULT,
    >,
    pub send: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, varBody: VARIANT) -> HRESULT,
    >,
    pub abort: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLHttpRequest) -> HRESULT>,
    pub get_status: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            plStatus: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_statusText: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pbstrStatus: *mut BSTR) -> HRESULT,
    >,
    pub get_responseXML: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, ppBody: *mut *mut IDispatch) -> HRESULT,
    >,
    pub get_responseText: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pbstrBody: *mut BSTR) -> HRESULT,
    >,
    pub get_responseBody: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pvarBody: *mut VARIANT) -> HRESULT,
    >,
    pub get_responseStream: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLHttpRequest, pvarBody: *mut VARIANT) -> HRESULT,
    >,
    pub get_readyState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            plState: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub put_onreadystatechange: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLHttpRequest,
            pReadyStateSink: *mut IDispatch,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLHttpRequestVtbl"][::std::mem::size_of::<IXMLHttpRequestVtbl>() - 168usize];
    ["Alignment of IXMLHttpRequestVtbl"][::std::mem::align_of::<IXMLHttpRequestVtbl>() - 8usize];
    ["Offset of field: IXMLHttpRequestVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLHttpRequestVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLHttpRequestVtbl::Release"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, Release) - 16usize];
    ["Offset of field: IXMLHttpRequestVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLHttpRequestVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLHttpRequestVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLHttpRequestVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLHttpRequestVtbl::open"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, open) - 56usize];
    ["Offset of field: IXMLHttpRequestVtbl::setRequestHeader"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, setRequestHeader) - 64usize];
    ["Offset of field: IXMLHttpRequestVtbl::getResponseHeader"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, getResponseHeader) - 72usize];
    ["Offset of field: IXMLHttpRequestVtbl::getAllResponseHeaders"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, getAllResponseHeaders) - 80usize];
    ["Offset of field: IXMLHttpRequestVtbl::send"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, send) - 88usize];
    ["Offset of field: IXMLHttpRequestVtbl::abort"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, abort) - 96usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_status"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_status) - 104usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_statusText"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_statusText) - 112usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_responseXML"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_responseXML) - 120usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_responseText"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_responseText) - 128usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_responseBody"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_responseBody) - 136usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_responseStream"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_responseStream) - 144usize];
    ["Offset of field: IXMLHttpRequestVtbl::get_readyState"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, get_readyState) - 152usize];
    ["Offset of field: IXMLHttpRequestVtbl::put_onreadystatechange"]
        [::std::mem::offset_of!(IXMLHttpRequestVtbl, put_onreadystatechange) - 160usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLHttpRequest {
    pub lpVtbl: *mut IXMLHttpRequestVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLHttpRequest"][::std::mem::size_of::<IXMLHttpRequest>() - 8usize];
    ["Alignment of IXMLHttpRequest"][::std::mem::align_of::<IXMLHttpRequest>() - 8usize];
    ["Offset of field: IXMLHttpRequest::lpVtbl"]
        [::std::mem::offset_of!(IXMLHttpRequest, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_XMLHTTPRequest: CLSID;
}
unsafe extern "C" {
    pub static IID_IXMLDSOControl: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDSOControlVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDSOControl) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDSOControl) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDSOControl, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_XMLDocument: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            ppDoc: *mut *mut IXMLDOMDocument,
        ) -> HRESULT,
    >,
    pub put_XMLDocument: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDSOControl, ppDoc: *mut IXMLDOMDocument) -> HRESULT,
    >,
    pub get_JavaDSOCompatible: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDSOControl, fJavaDSOCompatible: *mut BOOL) -> HRESULT,
    >,
    pub put_JavaDSOCompatible: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDSOControl, fJavaDSOCompatible: BOOL) -> HRESULT,
    >,
    pub get_readyState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDSOControl,
            state: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDSOControlVtbl"][::std::mem::size_of::<IXMLDSOControlVtbl>() - 96usize];
    ["Alignment of IXMLDSOControlVtbl"][::std::mem::align_of::<IXMLDSOControlVtbl>() - 8usize];
    ["Offset of field: IXMLDSOControlVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDSOControlVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDSOControlVtbl::Release"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, Release) - 16usize];
    ["Offset of field: IXMLDSOControlVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDSOControlVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDSOControlVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDSOControlVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDSOControlVtbl::get_XMLDocument"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, get_XMLDocument) - 56usize];
    ["Offset of field: IXMLDSOControlVtbl::put_XMLDocument"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, put_XMLDocument) - 64usize];
    ["Offset of field: IXMLDSOControlVtbl::get_JavaDSOCompatible"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, get_JavaDSOCompatible) - 72usize];
    ["Offset of field: IXMLDSOControlVtbl::put_JavaDSOCompatible"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, put_JavaDSOCompatible) - 80usize];
    ["Offset of field: IXMLDSOControlVtbl::get_readyState"]
        [::std::mem::offset_of!(IXMLDSOControlVtbl, get_readyState) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDSOControl {
    pub lpVtbl: *mut IXMLDSOControlVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDSOControl"][::std::mem::size_of::<IXMLDSOControl>() - 8usize];
    ["Alignment of IXMLDSOControl"][::std::mem::align_of::<IXMLDSOControl>() - 8usize];
    ["Offset of field: IXMLDSOControl::lpVtbl"]
        [::std::mem::offset_of!(IXMLDSOControl, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_XMLDSOControl: CLSID;
}
unsafe extern "C" {
    pub static IID_IXMLElementCollection: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElementCollectionVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElementCollection) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElementCollection) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElementCollection, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub put_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            v: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_length: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            p: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get__newEnum: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            ppUnk: *mut *mut IUnknown,
        ) -> HRESULT,
    >,
    pub item: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElementCollection,
            var1: VARIANT,
            var2: VARIANT,
            ppDisp: *mut *mut IDispatch,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElementCollectionVtbl"]
        [::std::mem::size_of::<IXMLElementCollectionVtbl>() - 88usize];
    ["Alignment of IXMLElementCollectionVtbl"]
        [::std::mem::align_of::<IXMLElementCollectionVtbl>() - 8usize];
    ["Offset of field: IXMLElementCollectionVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLElementCollectionVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLElementCollectionVtbl::Release"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, Release) - 16usize];
    ["Offset of field: IXMLElementCollectionVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLElementCollectionVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLElementCollectionVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLElementCollectionVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLElementCollectionVtbl::put_length"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, put_length) - 56usize];
    ["Offset of field: IXMLElementCollectionVtbl::get_length"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, get_length) - 64usize];
    ["Offset of field: IXMLElementCollectionVtbl::get__newEnum"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, get__newEnum) - 72usize];
    ["Offset of field: IXMLElementCollectionVtbl::item"]
        [::std::mem::offset_of!(IXMLElementCollectionVtbl, item) - 80usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElementCollection {
    pub lpVtbl: *mut IXMLElementCollectionVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElementCollection"][::std::mem::size_of::<IXMLElementCollection>() - 8usize];
    ["Alignment of IXMLElementCollection"]
        [::std::mem::align_of::<IXMLElementCollection>() - 8usize];
    ["Offset of field: IXMLElementCollection::lpVtbl"]
        [::std::mem::offset_of!(IXMLElementCollection, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDocument: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDocumentVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_root: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut *mut IXMLElement) -> HRESULT,
    >,
    pub get_fileSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_fileModifiedDate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_fileUpdatedDate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_URL: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub put_URL:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument, p: BSTR) -> HRESULT>,
    pub get_mimeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_readyState: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, pl: *mut ::std::os::raw::c_long) -> HRESULT,
    >,
    pub get_charset: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub put_charset:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument, p: BSTR) -> HRESULT>,
    pub get_version: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_doctype: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub get_dtdURL: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument, p: *mut BSTR) -> HRESULT,
    >,
    pub createElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument,
            vType: VARIANT,
            var1: VARIANT,
            ppElem: *mut *mut IXMLElement,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDocumentVtbl"][::std::mem::size_of::<IXMLDocumentVtbl>() - 168usize];
    ["Alignment of IXMLDocumentVtbl"][::std::mem::align_of::<IXMLDocumentVtbl>() - 8usize];
    ["Offset of field: IXMLDocumentVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDocumentVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDocumentVtbl::Release"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, Release) - 16usize];
    ["Offset of field: IXMLDocumentVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDocumentVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDocumentVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDocumentVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDocumentVtbl::get_root"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_root) - 56usize];
    ["Offset of field: IXMLDocumentVtbl::get_fileSize"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_fileSize) - 64usize];
    ["Offset of field: IXMLDocumentVtbl::get_fileModifiedDate"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_fileModifiedDate) - 72usize];
    ["Offset of field: IXMLDocumentVtbl::get_fileUpdatedDate"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_fileUpdatedDate) - 80usize];
    ["Offset of field: IXMLDocumentVtbl::get_URL"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_URL) - 88usize];
    ["Offset of field: IXMLDocumentVtbl::put_URL"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, put_URL) - 96usize];
    ["Offset of field: IXMLDocumentVtbl::get_mimeType"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_mimeType) - 104usize];
    ["Offset of field: IXMLDocumentVtbl::get_readyState"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_readyState) - 112usize];
    ["Offset of field: IXMLDocumentVtbl::get_charset"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_charset) - 120usize];
    ["Offset of field: IXMLDocumentVtbl::put_charset"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, put_charset) - 128usize];
    ["Offset of field: IXMLDocumentVtbl::get_version"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_version) - 136usize];
    ["Offset of field: IXMLDocumentVtbl::get_doctype"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_doctype) - 144usize];
    ["Offset of field: IXMLDocumentVtbl::get_dtdURL"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, get_dtdURL) - 152usize];
    ["Offset of field: IXMLDocumentVtbl::createElement"]
        [::std::mem::offset_of!(IXMLDocumentVtbl, createElement) - 160usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDocument {
    pub lpVtbl: *mut IXMLDocumentVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDocument"][::std::mem::size_of::<IXMLDocument>() - 8usize];
    ["Alignment of IXMLDocument"][::std::mem::align_of::<IXMLDocument>() - 8usize];
    ["Offset of field: IXMLDocument::lpVtbl"]
        [::std::mem::offset_of!(IXMLDocument, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLDocument2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDocument2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument2) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument2,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument2,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument2,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_root: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut *mut IXMLElement2) -> HRESULT,
    >,
    pub get_fileSize: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_fileModifiedDate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_fileUpdatedDate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_URL: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub put_URL:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument2, p: BSTR) -> HRESULT>,
    pub get_mimeType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_readyState: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, pl: *mut ::std::os::raw::c_long) -> HRESULT,
    >,
    pub get_charset: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub put_charset:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLDocument2, p: BSTR) -> HRESULT>,
    pub get_version: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_doctype: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub get_dtdURL: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, p: *mut BSTR) -> HRESULT,
    >,
    pub createElement: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLDocument2,
            vType: VARIANT,
            var1: VARIANT,
            ppElem: *mut *mut IXMLElement2,
        ) -> HRESULT,
    >,
    pub get_async: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, pf: *mut VARIANT_BOOL) -> HRESULT,
    >,
    pub put_async: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLDocument2, f: VARIANT_BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDocument2Vtbl"][::std::mem::size_of::<IXMLDocument2Vtbl>() - 184usize];
    ["Alignment of IXMLDocument2Vtbl"][::std::mem::align_of::<IXMLDocument2Vtbl>() - 8usize];
    ["Offset of field: IXMLDocument2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLDocument2Vtbl::AddRef"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, AddRef) - 8usize];
    ["Offset of field: IXMLDocument2Vtbl::Release"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, Release) - 16usize];
    ["Offset of field: IXMLDocument2Vtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLDocument2Vtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLDocument2Vtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLDocument2Vtbl::Invoke"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, Invoke) - 48usize];
    ["Offset of field: IXMLDocument2Vtbl::get_root"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_root) - 56usize];
    ["Offset of field: IXMLDocument2Vtbl::get_fileSize"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_fileSize) - 64usize];
    ["Offset of field: IXMLDocument2Vtbl::get_fileModifiedDate"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_fileModifiedDate) - 72usize];
    ["Offset of field: IXMLDocument2Vtbl::get_fileUpdatedDate"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_fileUpdatedDate) - 80usize];
    ["Offset of field: IXMLDocument2Vtbl::get_URL"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_URL) - 88usize];
    ["Offset of field: IXMLDocument2Vtbl::put_URL"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, put_URL) - 96usize];
    ["Offset of field: IXMLDocument2Vtbl::get_mimeType"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_mimeType) - 104usize];
    ["Offset of field: IXMLDocument2Vtbl::get_readyState"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_readyState) - 112usize];
    ["Offset of field: IXMLDocument2Vtbl::get_charset"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_charset) - 120usize];
    ["Offset of field: IXMLDocument2Vtbl::put_charset"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, put_charset) - 128usize];
    ["Offset of field: IXMLDocument2Vtbl::get_version"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_version) - 136usize];
    ["Offset of field: IXMLDocument2Vtbl::get_doctype"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_doctype) - 144usize];
    ["Offset of field: IXMLDocument2Vtbl::get_dtdURL"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_dtdURL) - 152usize];
    ["Offset of field: IXMLDocument2Vtbl::createElement"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, createElement) - 160usize];
    ["Offset of field: IXMLDocument2Vtbl::get_async"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, get_async) - 168usize];
    ["Offset of field: IXMLDocument2Vtbl::put_async"]
        [::std::mem::offset_of!(IXMLDocument2Vtbl, put_async) - 176usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLDocument2 {
    pub lpVtbl: *mut IXMLDocument2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLDocument2"][::std::mem::size_of::<IXMLDocument2>() - 8usize];
    ["Alignment of IXMLDocument2"][::std::mem::align_of::<IXMLDocument2>() - 8usize];
    ["Offset of field: IXMLDocument2::lpVtbl"]
        [::std::mem::offset_of!(IXMLDocument2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLElement: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElementVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_tagName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, p: *mut BSTR) -> HRESULT,
    >,
    pub put_tagName:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement, p: BSTR) -> HRESULT>,
    pub get_parent: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, ppParent: *mut *mut IXMLElement) -> HRESULT,
    >,
    pub setAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            strPropertyName: BSTR,
            PropertyValue: VARIANT,
        ) -> HRESULT,
    >,
    pub getAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            strPropertyName: BSTR,
            PropertyValue: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub removeAttribute: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, strPropertyName: BSTR) -> HRESULT,
    >,
    pub get_children: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            pp: *mut *mut IXMLElementCollection,
        ) -> HRESULT,
    >,
    pub get_type: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            plType: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, p: *mut BSTR) -> HRESULT,
    >,
    pub put_text:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement, p: BSTR) -> HRESULT>,
    pub addChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement,
            pChildElem: *mut IXMLElement,
            lIndex: ::std::os::raw::c_long,
            lReserved: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement, pChildElem: *mut IXMLElement) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElementVtbl"][::std::mem::size_of::<IXMLElementVtbl>() - 152usize];
    ["Alignment of IXMLElementVtbl"][::std::mem::align_of::<IXMLElementVtbl>() - 8usize];
    ["Offset of field: IXMLElementVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLElementVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLElementVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLElementVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLElementVtbl::Release"]
        [::std::mem::offset_of!(IXMLElementVtbl, Release) - 16usize];
    ["Offset of field: IXMLElementVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLElementVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLElementVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLElementVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLElementVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLElementVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLElementVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLElementVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLElementVtbl::get_tagName"]
        [::std::mem::offset_of!(IXMLElementVtbl, get_tagName) - 56usize];
    ["Offset of field: IXMLElementVtbl::put_tagName"]
        [::std::mem::offset_of!(IXMLElementVtbl, put_tagName) - 64usize];
    ["Offset of field: IXMLElementVtbl::get_parent"]
        [::std::mem::offset_of!(IXMLElementVtbl, get_parent) - 72usize];
    ["Offset of field: IXMLElementVtbl::setAttribute"]
        [::std::mem::offset_of!(IXMLElementVtbl, setAttribute) - 80usize];
    ["Offset of field: IXMLElementVtbl::getAttribute"]
        [::std::mem::offset_of!(IXMLElementVtbl, getAttribute) - 88usize];
    ["Offset of field: IXMLElementVtbl::removeAttribute"]
        [::std::mem::offset_of!(IXMLElementVtbl, removeAttribute) - 96usize];
    ["Offset of field: IXMLElementVtbl::get_children"]
        [::std::mem::offset_of!(IXMLElementVtbl, get_children) - 104usize];
    ["Offset of field: IXMLElementVtbl::get_type"]
        [::std::mem::offset_of!(IXMLElementVtbl, get_type) - 112usize];
    ["Offset of field: IXMLElementVtbl::get_text"]
        [::std::mem::offset_of!(IXMLElementVtbl, get_text) - 120usize];
    ["Offset of field: IXMLElementVtbl::put_text"]
        [::std::mem::offset_of!(IXMLElementVtbl, put_text) - 128usize];
    ["Offset of field: IXMLElementVtbl::addChild"]
        [::std::mem::offset_of!(IXMLElementVtbl, addChild) - 136usize];
    ["Offset of field: IXMLElementVtbl::removeChild"]
        [::std::mem::offset_of!(IXMLElementVtbl, removeChild) - 144usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElement {
    pub lpVtbl: *mut IXMLElementVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElement"][::std::mem::size_of::<IXMLElement>() - 8usize];
    ["Alignment of IXMLElement"][::std::mem::align_of::<IXMLElement>() - 8usize];
    ["Offset of field: IXMLElement::lpVtbl"][::std::mem::offset_of!(IXMLElement, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLElement2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElement2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement2) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_tagName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, p: *mut BSTR) -> HRESULT,
    >,
    pub put_tagName:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement2, p: BSTR) -> HRESULT>,
    pub get_parent: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, ppParent: *mut *mut IXMLElement2) -> HRESULT,
    >,
    pub setAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            strPropertyName: BSTR,
            PropertyValue: VARIANT,
        ) -> HRESULT,
    >,
    pub getAttribute: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            strPropertyName: BSTR,
            PropertyValue: *mut VARIANT,
        ) -> HRESULT,
    >,
    pub removeAttribute: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, strPropertyName: BSTR) -> HRESULT,
    >,
    pub get_children: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            pp: *mut *mut IXMLElementCollection,
        ) -> HRESULT,
    >,
    pub get_type: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            plType: *mut ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub get_text: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, p: *mut BSTR) -> HRESULT,
    >,
    pub put_text:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLElement2, p: BSTR) -> HRESULT>,
    pub addChild: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            pChildElem: *mut IXMLElement2,
            lIndex: ::std::os::raw::c_long,
            lReserved: ::std::os::raw::c_long,
        ) -> HRESULT,
    >,
    pub removeChild: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLElement2, pChildElem: *mut IXMLElement2) -> HRESULT,
    >,
    pub get_attributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLElement2,
            pp: *mut *mut IXMLElementCollection,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElement2Vtbl"][::std::mem::size_of::<IXMLElement2Vtbl>() - 160usize];
    ["Alignment of IXMLElement2Vtbl"][::std::mem::align_of::<IXMLElement2Vtbl>() - 8usize];
    ["Offset of field: IXMLElement2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLElement2Vtbl::AddRef"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, AddRef) - 8usize];
    ["Offset of field: IXMLElement2Vtbl::Release"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, Release) - 16usize];
    ["Offset of field: IXMLElement2Vtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLElement2Vtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLElement2Vtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLElement2Vtbl::Invoke"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, Invoke) - 48usize];
    ["Offset of field: IXMLElement2Vtbl::get_tagName"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_tagName) - 56usize];
    ["Offset of field: IXMLElement2Vtbl::put_tagName"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, put_tagName) - 64usize];
    ["Offset of field: IXMLElement2Vtbl::get_parent"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_parent) - 72usize];
    ["Offset of field: IXMLElement2Vtbl::setAttribute"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, setAttribute) - 80usize];
    ["Offset of field: IXMLElement2Vtbl::getAttribute"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, getAttribute) - 88usize];
    ["Offset of field: IXMLElement2Vtbl::removeAttribute"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, removeAttribute) - 96usize];
    ["Offset of field: IXMLElement2Vtbl::get_children"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_children) - 104usize];
    ["Offset of field: IXMLElement2Vtbl::get_type"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_type) - 112usize];
    ["Offset of field: IXMLElement2Vtbl::get_text"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_text) - 120usize];
    ["Offset of field: IXMLElement2Vtbl::put_text"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, put_text) - 128usize];
    ["Offset of field: IXMLElement2Vtbl::addChild"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, addChild) - 136usize];
    ["Offset of field: IXMLElement2Vtbl::removeChild"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, removeChild) - 144usize];
    ["Offset of field: IXMLElement2Vtbl::get_attributes"]
        [::std::mem::offset_of!(IXMLElement2Vtbl, get_attributes) - 152usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLElement2 {
    pub lpVtbl: *mut IXMLElement2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLElement2"][::std::mem::size_of::<IXMLElement2>() - 8usize];
    ["Alignment of IXMLElement2"][::std::mem::align_of::<IXMLElement2>() - 8usize];
    ["Offset of field: IXMLElement2::lpVtbl"]
        [::std::mem::offset_of!(IXMLElement2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLAttribute: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLAttributeVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLAttribute,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLAttribute) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLAttribute) -> ULONG>,
    pub GetTypeInfoCount: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLAttribute, pctinfo: *mut UINT) -> HRESULT,
    >,
    pub GetTypeInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLAttribute,
            iTInfo: UINT,
            lcid: LCID,
            ppTInfo: *mut *mut ITypeInfo,
        ) -> HRESULT,
    >,
    pub GetIDsOfNames: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLAttribute,
            riid: *const IID,
            rgszNames: *mut LPOLESTR,
            cNames: UINT,
            lcid: LCID,
            rgDispId: *mut DISPID,
        ) -> HRESULT,
    >,
    pub Invoke: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLAttribute,
            dispIdMember: DISPID,
            riid: *const IID,
            lcid: LCID,
            wFlags: WORD,
            pDispParams: *mut DISPPARAMS,
            pVarResult: *mut VARIANT,
            pExcepInfo: *mut EXCEPINFO,
            puArgErr: *mut UINT,
        ) -> HRESULT,
    >,
    pub get_name: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLAttribute, n: *mut BSTR) -> HRESULT,
    >,
    pub get_value: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLAttribute, v: *mut BSTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLAttributeVtbl"][::std::mem::size_of::<IXMLAttributeVtbl>() - 72usize];
    ["Alignment of IXMLAttributeVtbl"][::std::mem::align_of::<IXMLAttributeVtbl>() - 8usize];
    ["Offset of field: IXMLAttributeVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLAttributeVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLAttributeVtbl::Release"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, Release) - 16usize];
    ["Offset of field: IXMLAttributeVtbl::GetTypeInfoCount"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, GetTypeInfoCount) - 24usize];
    ["Offset of field: IXMLAttributeVtbl::GetTypeInfo"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, GetTypeInfo) - 32usize];
    ["Offset of field: IXMLAttributeVtbl::GetIDsOfNames"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, GetIDsOfNames) - 40usize];
    ["Offset of field: IXMLAttributeVtbl::Invoke"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, Invoke) - 48usize];
    ["Offset of field: IXMLAttributeVtbl::get_name"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, get_name) - 56usize];
    ["Offset of field: IXMLAttributeVtbl::get_value"]
        [::std::mem::offset_of!(IXMLAttributeVtbl, get_value) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLAttribute {
    pub lpVtbl: *mut IXMLAttributeVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLAttribute"][::std::mem::size_of::<IXMLAttribute>() - 8usize];
    ["Alignment of IXMLAttribute"][::std::mem::align_of::<IXMLAttribute>() - 8usize];
    ["Offset of field: IXMLAttribute::lpVtbl"]
        [::std::mem::offset_of!(IXMLAttribute, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IXMLError: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLErrorVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IXMLError,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLError) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IXMLError) -> ULONG>,
    pub GetErrorInfo: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IXMLError, pErrorReturn: *mut XML_ERROR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLErrorVtbl"][::std::mem::size_of::<IXMLErrorVtbl>() - 32usize];
    ["Alignment of IXMLErrorVtbl"][::std::mem::align_of::<IXMLErrorVtbl>() - 8usize];
    ["Offset of field: IXMLErrorVtbl::QueryInterface"]
        [::std::mem::offset_of!(IXMLErrorVtbl, QueryInterface) - 0usize];
    ["Offset of field: IXMLErrorVtbl::AddRef"]
        [::std::mem::offset_of!(IXMLErrorVtbl, AddRef) - 8usize];
    ["Offset of field: IXMLErrorVtbl::Release"]
        [::std::mem::offset_of!(IXMLErrorVtbl, Release) - 16usize];
    ["Offset of field: IXMLErrorVtbl::GetErrorInfo"]
        [::std::mem::offset_of!(IXMLErrorVtbl, GetErrorInfo) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IXMLError {
    pub lpVtbl: *mut IXMLErrorVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IXMLError"][::std::mem::size_of::<IXMLError>() - 8usize];
    ["Alignment of IXMLError"][::std::mem::align_of::<IXMLError>() - 8usize];
    ["Offset of field: IXMLError::lpVtbl"][::std::mem::offset_of!(IXMLError, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_XMLDocument: CLSID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_msxml_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_msxml_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static CLSID_SBS_StdURLMoniker: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_HttpProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_FtpProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_GopherProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_HttpSProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_FileProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_MkProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_UrlMkBindCtx: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_SoftDistExt: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_CdlProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_ClassInstallFilter: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_InternetSecurityManager: IID;
}
unsafe extern "C" {
    pub static CLSID_SBS_InternetZoneManager: IID;
}
unsafe extern "C" {
    pub static IID_IAsyncMoniker: IID;
}
unsafe extern "C" {
    pub static CLSID_StdURLMoniker: IID;
}
unsafe extern "C" {
    pub static CLSID_HttpProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_FtpProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_GopherProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_HttpSProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_FileProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_ResProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_AboutProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_JSProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_MailtoProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_IE4_PROTOCOLS: IID;
}
unsafe extern "C" {
    pub static CLSID_MkProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_StdURLProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_TBAuthProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_UrlMkBindCtx: IID;
}
unsafe extern "C" {
    pub static CLSID_CdlProtocol: IID;
}
unsafe extern "C" {
    pub static CLSID_ClassInstallFilter: IID;
}
unsafe extern "C" {
    pub static IID_IAsyncBindCtx: IID;
}
unsafe extern "C" {
    pub fn CreateURLMoniker(pMkCtx: LPMONIKER, szURL: LPCWSTR, ppmk: *mut LPMONIKER) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateURLMonikerEx(
        pMkCtx: LPMONIKER,
        szURL: LPCWSTR,
        ppmk: *mut LPMONIKER,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetClassURL(szURL: LPCWSTR, pClsID: *mut CLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateAsyncBindCtx(
        reserved: DWORD,
        pBSCb: *mut IBindStatusCallback,
        pEFetc: *mut IEnumFORMATETC,
        ppBC: *mut *mut IBindCtx,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateURLMonikerEx2(
        pMkCtx: LPMONIKER,
        pUri: *mut IUri,
        ppmk: *mut LPMONIKER,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateAsyncBindCtxEx(
        pbc: *mut IBindCtx,
        dwOptions: DWORD,
        pBSCb: *mut IBindStatusCallback,
        pEnum: *mut IEnumFORMATETC,
        ppBC: *mut *mut IBindCtx,
        reserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn MkParseDisplayNameEx(
        pbc: *mut IBindCtx,
        szDisplayName: LPCWSTR,
        pchEaten: *mut ULONG,
        ppmk: *mut LPMONIKER,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterBindStatusCallback(
        pBC: LPBC,
        pBSCb: *mut IBindStatusCallback,
        ppBSCBPrev: *mut *mut IBindStatusCallback,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RevokeBindStatusCallback(pBC: LPBC, pBSCb: *mut IBindStatusCallback) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetClassFileOrMime(
        pBC: LPBC,
        szFilename: LPCWSTR,
        pBuffer: LPVOID,
        cbSize: DWORD,
        szMime: LPCWSTR,
        dwReserved: DWORD,
        pclsid: *mut CLSID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IsValidURL(pBC: LPBC, szURL: LPCWSTR, dwReserved: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoGetClassObjectFromURL(
        rCLASSID: *const IID,
        szCODE: LPCWSTR,
        dwFileVersionMS: DWORD,
        dwFileVersionLS: DWORD,
        szTYPE: LPCWSTR,
        pBindCtx: LPBINDCTX,
        dwClsContext: DWORD,
        pvReserved: LPVOID,
        riid: *const IID,
        ppv: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IEInstallScope(pdwScope: LPDWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn FaultInIEFeature(
        hWnd: HWND,
        pClassSpec: *mut uCLSSPEC,
        pQuery: *mut QUERYCONTEXT,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetComponentIDFromCLSSPEC(
        pClassspec: *mut uCLSSPEC,
        ppszComponentID: *mut LPSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IsAsyncMoniker(pmk: *mut IMoniker) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateURLBinding(
        lpszUrl: LPCWSTR,
        pbc: *mut IBindCtx,
        ppBdg: *mut *mut IBinding,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterMediaTypes(
        ctypes: UINT,
        rgszTypes: *const LPCSTR,
        rgcfTypes: *mut CLIPFORMAT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn FindMediaType(rgszTypes: LPCSTR, rgcfTypes: *mut CLIPFORMAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateFormatEnumerator(
        cfmtetc: UINT,
        rgfmtetc: *mut FORMATETC,
        ppenumfmtetc: *mut *mut IEnumFORMATETC,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterFormatEnumerator(
        pBC: LPBC,
        pEFetc: *mut IEnumFORMATETC,
        reserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RevokeFormatEnumerator(pBC: LPBC, pEFetc: *mut IEnumFORMATETC) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterMediaTypeClass(
        pBC: LPBC,
        ctypes: UINT,
        rgszTypes: *const LPCSTR,
        rgclsID: *mut CLSID,
        reserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn FindMediaTypeClass(
        pBC: LPBC,
        szType: LPCSTR,
        pclsID: *mut CLSID,
        reserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UrlMkSetSessionOption(
        dwOption: DWORD,
        pBuffer: LPVOID,
        dwBufferLength: DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UrlMkGetSessionOption(
        dwOption: DWORD,
        pBuffer: LPVOID,
        dwBufferLength: DWORD,
        pdwBufferLengthOut: *mut DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn FindMimeFromData(
        pBC: LPBC,
        pwzUrl: LPCWSTR,
        pBuffer: LPVOID,
        cbSize: DWORD,
        pwzMimeProposed: LPCWSTR,
        dwMimeFlags: DWORD,
        ppwzMimeOut: *mut LPWSTR,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn ObtainUserAgentString(dwOption: DWORD, pszUAOut: LPSTR, cbSize: *mut DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CompareSecurityIds(
        pbSecurityId1: *mut BYTE,
        dwLen1: DWORD,
        pbSecurityId2: *mut BYTE,
        dwLen2: DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CompatFlagsFromClsid(
        pclsid: *mut CLSID,
        pdwCompatFlags: LPDWORD,
        pdwMiscStatusFlags: LPDWORD,
    ) -> HRESULT;
}
pub const IEObjectType_IE_EPM_OBJECT_EVENT: IEObjectType = 0;
pub const IEObjectType_IE_EPM_OBJECT_MUTEX: IEObjectType = 1;
pub const IEObjectType_IE_EPM_OBJECT_SEMAPHORE: IEObjectType = 2;
pub const IEObjectType_IE_EPM_OBJECT_SHARED_MEMORY: IEObjectType = 3;
pub const IEObjectType_IE_EPM_OBJECT_WAITABLE_TIMER: IEObjectType = 4;
pub const IEObjectType_IE_EPM_OBJECT_FILE: IEObjectType = 5;
pub const IEObjectType_IE_EPM_OBJECT_NAMED_PIPE: IEObjectType = 6;
pub const IEObjectType_IE_EPM_OBJECT_REGISTRY: IEObjectType = 7;
pub type IEObjectType = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn SetAccessForIEAppContainer(
        hObject: HANDLE,
        ieObjectType: IEObjectType,
        dwAccessMask: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0000_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0000_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPPERSISTMONIKER = *mut IPersistMoniker;
unsafe extern "C" {
    pub static IID_IPersistMoniker: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistMonikerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistMoniker,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistMoniker) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistMoniker) -> ULONG>,
    pub GetClassID: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistMoniker, pClassID: *mut CLSID) -> HRESULT,
    >,
    pub IsDirty: ::std::option::Option<unsafe extern "C" fn(This: *mut IPersistMoniker) -> HRESULT>,
    pub Load: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistMoniker,
            fFullyAvailable: BOOL,
            pimkName: *mut IMoniker,
            pibc: LPBC,
            grfMode: DWORD,
        ) -> HRESULT,
    >,
    pub Save: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistMoniker,
            pimkName: *mut IMoniker,
            pbc: LPBC,
            fRemember: BOOL,
        ) -> HRESULT,
    >,
    pub SaveCompleted: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPersistMoniker,
            pimkName: *mut IMoniker,
            pibc: LPBC,
        ) -> HRESULT,
    >,
    pub GetCurMoniker: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IPersistMoniker, ppimkName: *mut *mut IMoniker) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistMonikerVtbl"][::std::mem::size_of::<IPersistMonikerVtbl>() - 72usize];
    ["Alignment of IPersistMonikerVtbl"][::std::mem::align_of::<IPersistMonikerVtbl>() - 8usize];
    ["Offset of field: IPersistMonikerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPersistMonikerVtbl::AddRef"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, AddRef) - 8usize];
    ["Offset of field: IPersistMonikerVtbl::Release"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, Release) - 16usize];
    ["Offset of field: IPersistMonikerVtbl::GetClassID"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, GetClassID) - 24usize];
    ["Offset of field: IPersistMonikerVtbl::IsDirty"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, IsDirty) - 32usize];
    ["Offset of field: IPersistMonikerVtbl::Load"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, Load) - 40usize];
    ["Offset of field: IPersistMonikerVtbl::Save"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, Save) - 48usize];
    ["Offset of field: IPersistMonikerVtbl::SaveCompleted"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, SaveCompleted) - 56usize];
    ["Offset of field: IPersistMonikerVtbl::GetCurMoniker"]
        [::std::mem::offset_of!(IPersistMonikerVtbl, GetCurMoniker) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPersistMoniker {
    pub lpVtbl: *mut IPersistMonikerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPersistMoniker"][::std::mem::size_of::<IPersistMoniker>() - 8usize];
    ["Alignment of IPersistMoniker"][::std::mem::align_of::<IPersistMoniker>() - 8usize];
    ["Offset of field: IPersistMoniker::lpVtbl"]
        [::std::mem::offset_of!(IPersistMoniker, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0001_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0001_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPMONIKERPROP = *mut IMonikerProp;
pub const __MIDL_IMonikerProp_0001_MIMETYPEPROP: __MIDL_IMonikerProp_0001 = 0;
pub const __MIDL_IMonikerProp_0001_USE_SRC_URL: __MIDL_IMonikerProp_0001 = 1;
pub const __MIDL_IMonikerProp_0001_CLASSIDPROP: __MIDL_IMonikerProp_0001 = 2;
pub const __MIDL_IMonikerProp_0001_TRUSTEDDOWNLOADPROP: __MIDL_IMonikerProp_0001 = 3;
pub const __MIDL_IMonikerProp_0001_POPUPLEVELPROP: __MIDL_IMonikerProp_0001 = 4;
pub type __MIDL_IMonikerProp_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IMonikerProp_0001 as MONIKERPROPERTY;
unsafe extern "C" {
    pub static IID_IMonikerProp: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMonikerPropVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMonikerProp,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IMonikerProp) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IMonikerProp) -> ULONG>,
    pub PutProperty: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IMonikerProp,
            mkp: MONIKERPROPERTY,
            val: LPCWSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMonikerPropVtbl"][::std::mem::size_of::<IMonikerPropVtbl>() - 32usize];
    ["Alignment of IMonikerPropVtbl"][::std::mem::align_of::<IMonikerPropVtbl>() - 8usize];
    ["Offset of field: IMonikerPropVtbl::QueryInterface"]
        [::std::mem::offset_of!(IMonikerPropVtbl, QueryInterface) - 0usize];
    ["Offset of field: IMonikerPropVtbl::AddRef"]
        [::std::mem::offset_of!(IMonikerPropVtbl, AddRef) - 8usize];
    ["Offset of field: IMonikerPropVtbl::Release"]
        [::std::mem::offset_of!(IMonikerPropVtbl, Release) - 16usize];
    ["Offset of field: IMonikerPropVtbl::PutProperty"]
        [::std::mem::offset_of!(IMonikerPropVtbl, PutProperty) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IMonikerProp {
    pub lpVtbl: *mut IMonikerPropVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IMonikerProp"][::std::mem::size_of::<IMonikerProp>() - 8usize];
    ["Alignment of IMonikerProp"][::std::mem::align_of::<IMonikerProp>() - 8usize];
    ["Offset of field: IMonikerProp::lpVtbl"]
        [::std::mem::offset_of!(IMonikerProp, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0002_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0002_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDPROTOCOL = *mut IBindProtocol;
unsafe extern "C" {
    pub static IID_IBindProtocol: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindProtocolVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindProtocol,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindProtocol) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindProtocol) -> ULONG>,
    pub CreateBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindProtocol,
            szUrl: LPCWSTR,
            pbc: *mut IBindCtx,
            ppb: *mut *mut IBinding,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindProtocolVtbl"][::std::mem::size_of::<IBindProtocolVtbl>() - 32usize];
    ["Alignment of IBindProtocolVtbl"][::std::mem::align_of::<IBindProtocolVtbl>() - 8usize];
    ["Offset of field: IBindProtocolVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindProtocolVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindProtocolVtbl::AddRef"]
        [::std::mem::offset_of!(IBindProtocolVtbl, AddRef) - 8usize];
    ["Offset of field: IBindProtocolVtbl::Release"]
        [::std::mem::offset_of!(IBindProtocolVtbl, Release) - 16usize];
    ["Offset of field: IBindProtocolVtbl::CreateBinding"]
        [::std::mem::offset_of!(IBindProtocolVtbl, CreateBinding) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindProtocol {
    pub lpVtbl: *mut IBindProtocolVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindProtocol"][::std::mem::size_of::<IBindProtocol>() - 8usize];
    ["Alignment of IBindProtocol"][::std::mem::align_of::<IBindProtocol>() - 8usize];
    ["Offset of field: IBindProtocol::lpVtbl"]
        [::std::mem::offset_of!(IBindProtocol, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0003_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0003_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDING = *mut IBinding;
unsafe extern "C" {
    pub static IID_IBinding: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindingVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBinding,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBinding) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBinding) -> ULONG>,
    pub Abort: ::std::option::Option<unsafe extern "C" fn(This: *mut IBinding) -> HRESULT>,
    pub Suspend: ::std::option::Option<unsafe extern "C" fn(This: *mut IBinding) -> HRESULT>,
    pub Resume: ::std::option::Option<unsafe extern "C" fn(This: *mut IBinding) -> HRESULT>,
    pub SetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBinding, nPriority: LONG) -> HRESULT,
    >,
    pub GetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBinding, pnPriority: *mut LONG) -> HRESULT,
    >,
    pub GetBindResult: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBinding,
            pclsidProtocol: *mut CLSID,
            pdwResult: *mut DWORD,
            pszResult: *mut LPOLESTR,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindingVtbl"][::std::mem::size_of::<IBindingVtbl>() - 72usize];
    ["Alignment of IBindingVtbl"][::std::mem::align_of::<IBindingVtbl>() - 8usize];
    ["Offset of field: IBindingVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindingVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindingVtbl::AddRef"]
        [::std::mem::offset_of!(IBindingVtbl, AddRef) - 8usize];
    ["Offset of field: IBindingVtbl::Release"]
        [::std::mem::offset_of!(IBindingVtbl, Release) - 16usize];
    ["Offset of field: IBindingVtbl::Abort"][::std::mem::offset_of!(IBindingVtbl, Abort) - 24usize];
    ["Offset of field: IBindingVtbl::Suspend"]
        [::std::mem::offset_of!(IBindingVtbl, Suspend) - 32usize];
    ["Offset of field: IBindingVtbl::Resume"]
        [::std::mem::offset_of!(IBindingVtbl, Resume) - 40usize];
    ["Offset of field: IBindingVtbl::SetPriority"]
        [::std::mem::offset_of!(IBindingVtbl, SetPriority) - 48usize];
    ["Offset of field: IBindingVtbl::GetPriority"]
        [::std::mem::offset_of!(IBindingVtbl, GetPriority) - 56usize];
    ["Offset of field: IBindingVtbl::GetBindResult"]
        [::std::mem::offset_of!(IBindingVtbl, GetBindResult) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBinding {
    pub lpVtbl: *mut IBindingVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBinding"][::std::mem::size_of::<IBinding>() - 8usize];
    ["Alignment of IBinding"][::std::mem::align_of::<IBinding>() - 8usize];
    ["Offset of field: IBinding::lpVtbl"][::std::mem::offset_of!(IBinding, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IBinding_RemoteGetBindResult_Proxy(
        This: *mut IBinding,
        pclsidProtocol: *mut CLSID,
        pdwResult: *mut DWORD,
        pszResult: *mut LPOLESTR,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBinding_RemoteGetBindResult_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0004_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0004_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDSTATUSCALLBACK = *mut IBindStatusCallback;
pub const __MIDL_IBindStatusCallback_0001_BINDVERB_GET: __MIDL_IBindStatusCallback_0001 = 0;
pub const __MIDL_IBindStatusCallback_0001_BINDVERB_POST: __MIDL_IBindStatusCallback_0001 = 1;
pub const __MIDL_IBindStatusCallback_0001_BINDVERB_PUT: __MIDL_IBindStatusCallback_0001 = 2;
pub const __MIDL_IBindStatusCallback_0001_BINDVERB_CUSTOM: __MIDL_IBindStatusCallback_0001 = 3;
pub const __MIDL_IBindStatusCallback_0001_BINDVERB_RESERVED1: __MIDL_IBindStatusCallback_0001 = 4;
pub type __MIDL_IBindStatusCallback_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0001 as BINDVERB;
pub const __MIDL_IBindStatusCallback_0002_BINDINFOF_URLENCODESTGMEDDATA:
    __MIDL_IBindStatusCallback_0002 = 1;
pub const __MIDL_IBindStatusCallback_0002_BINDINFOF_URLENCODEDEXTRAINFO:
    __MIDL_IBindStatusCallback_0002 = 2;
pub type __MIDL_IBindStatusCallback_0002 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0002 as BINDINFOF;
pub const __MIDL_IBindStatusCallback_0003_BINDF_ASYNCHRONOUS: __MIDL_IBindStatusCallback_0003 = 1;
pub const __MIDL_IBindStatusCallback_0003_BINDF_ASYNCSTORAGE: __MIDL_IBindStatusCallback_0003 = 2;
pub const __MIDL_IBindStatusCallback_0003_BINDF_NOPROGRESSIVERENDERING:
    __MIDL_IBindStatusCallback_0003 = 4;
pub const __MIDL_IBindStatusCallback_0003_BINDF_OFFLINEOPERATION: __MIDL_IBindStatusCallback_0003 =
    8;
pub const __MIDL_IBindStatusCallback_0003_BINDF_GETNEWESTVERSION: __MIDL_IBindStatusCallback_0003 =
    16;
pub const __MIDL_IBindStatusCallback_0003_BINDF_NOWRITECACHE: __MIDL_IBindStatusCallback_0003 = 32;
pub const __MIDL_IBindStatusCallback_0003_BINDF_NEEDFILE: __MIDL_IBindStatusCallback_0003 = 64;
pub const __MIDL_IBindStatusCallback_0003_BINDF_PULLDATA: __MIDL_IBindStatusCallback_0003 = 128;
pub const __MIDL_IBindStatusCallback_0003_BINDF_IGNORESECURITYPROBLEM:
    __MIDL_IBindStatusCallback_0003 = 256;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESYNCHRONIZE: __MIDL_IBindStatusCallback_0003 =
    512;
pub const __MIDL_IBindStatusCallback_0003_BINDF_HYPERLINK: __MIDL_IBindStatusCallback_0003 = 1024;
pub const __MIDL_IBindStatusCallback_0003_BINDF_NO_UI: __MIDL_IBindStatusCallback_0003 = 2048;
pub const __MIDL_IBindStatusCallback_0003_BINDF_SILENTOPERATION: __MIDL_IBindStatusCallback_0003 =
    4096;
pub const __MIDL_IBindStatusCallback_0003_BINDF_PRAGMA_NO_CACHE: __MIDL_IBindStatusCallback_0003 =
    8192;
pub const __MIDL_IBindStatusCallback_0003_BINDF_GETCLASSOBJECT: __MIDL_IBindStatusCallback_0003 =
    16384;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_1: __MIDL_IBindStatusCallback_0003 = 32768;
pub const __MIDL_IBindStatusCallback_0003_BINDF_FREE_THREADED: __MIDL_IBindStatusCallback_0003 =
    65536;
pub const __MIDL_IBindStatusCallback_0003_BINDF_DIRECT_READ: __MIDL_IBindStatusCallback_0003 =
    131072;
pub const __MIDL_IBindStatusCallback_0003_BINDF_FORMS_SUBMIT: __MIDL_IBindStatusCallback_0003 =
    262144;
pub const __MIDL_IBindStatusCallback_0003_BINDF_GETFROMCACHE_IF_NET_FAIL:
    __MIDL_IBindStatusCallback_0003 = 524288;
pub const __MIDL_IBindStatusCallback_0003_BINDF_FROMURLMON: __MIDL_IBindStatusCallback_0003 =
    1048576;
pub const __MIDL_IBindStatusCallback_0003_BINDF_FWD_BACK: __MIDL_IBindStatusCallback_0003 = 2097152;
pub const __MIDL_IBindStatusCallback_0003_BINDF_PREFERDEFAULTHANDLER:
    __MIDL_IBindStatusCallback_0003 = 4194304;
pub const __MIDL_IBindStatusCallback_0003_BINDF_ENFORCERESTRICTED: __MIDL_IBindStatusCallback_0003 =
    8388608;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_2: __MIDL_IBindStatusCallback_0003 =
    -2147483648;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_3: __MIDL_IBindStatusCallback_0003 =
    16777216;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_4: __MIDL_IBindStatusCallback_0003 =
    33554432;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_5: __MIDL_IBindStatusCallback_0003 =
    67108864;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_6: __MIDL_IBindStatusCallback_0003 =
    134217728;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_7: __MIDL_IBindStatusCallback_0003 =
    1073741824;
pub const __MIDL_IBindStatusCallback_0003_BINDF_RESERVED_8: __MIDL_IBindStatusCallback_0003 =
    536870912;
pub type __MIDL_IBindStatusCallback_0003 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0003 as BINDF;
pub const __MIDL_IBindStatusCallback_0004_URL_ENCODING_NONE: __MIDL_IBindStatusCallback_0004 = 0;
pub const __MIDL_IBindStatusCallback_0004_URL_ENCODING_ENABLE_UTF8:
    __MIDL_IBindStatusCallback_0004 = 268435456;
pub const __MIDL_IBindStatusCallback_0004_URL_ENCODING_DISABLE_UTF8:
    __MIDL_IBindStatusCallback_0004 = 536870912;
pub type __MIDL_IBindStatusCallback_0004 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0004 as URL_ENCODING;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _tagBINDINFO {
    pub cbSize: ULONG,
    pub szExtraInfo: LPWSTR,
    pub stgmedData: STGMEDIUM,
    pub grfBindInfoF: DWORD,
    pub dwBindVerb: DWORD,
    pub szCustomVerb: LPWSTR,
    pub cbstgmedData: DWORD,
    pub dwOptions: DWORD,
    pub dwOptionsFlags: DWORD,
    pub dwCodePage: DWORD,
    pub securityAttributes: SECURITY_ATTRIBUTES,
    pub iid: IID,
    pub pUnk: *mut IUnknown,
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagBINDINFO"][::std::mem::size_of::<_tagBINDINFO>() - 128usize];
    ["Alignment of _tagBINDINFO"][::std::mem::align_of::<_tagBINDINFO>() - 8usize];
    ["Offset of field: _tagBINDINFO::cbSize"]
        [::std::mem::offset_of!(_tagBINDINFO, cbSize) - 0usize];
    ["Offset of field: _tagBINDINFO::szExtraInfo"]
        [::std::mem::offset_of!(_tagBINDINFO, szExtraInfo) - 8usize];
    ["Offset of field: _tagBINDINFO::stgmedData"]
        [::std::mem::offset_of!(_tagBINDINFO, stgmedData) - 16usize];
    ["Offset of field: _tagBINDINFO::grfBindInfoF"]
        [::std::mem::offset_of!(_tagBINDINFO, grfBindInfoF) - 40usize];
    ["Offset of field: _tagBINDINFO::dwBindVerb"]
        [::std::mem::offset_of!(_tagBINDINFO, dwBindVerb) - 44usize];
    ["Offset of field: _tagBINDINFO::szCustomVerb"]
        [::std::mem::offset_of!(_tagBINDINFO, szCustomVerb) - 48usize];
    ["Offset of field: _tagBINDINFO::cbstgmedData"]
        [::std::mem::offset_of!(_tagBINDINFO, cbstgmedData) - 56usize];
    ["Offset of field: _tagBINDINFO::dwOptions"]
        [::std::mem::offset_of!(_tagBINDINFO, dwOptions) - 60usize];
    ["Offset of field: _tagBINDINFO::dwOptionsFlags"]
        [::std::mem::offset_of!(_tagBINDINFO, dwOptionsFlags) - 64usize];
    ["Offset of field: _tagBINDINFO::dwCodePage"]
        [::std::mem::offset_of!(_tagBINDINFO, dwCodePage) - 68usize];
    ["Offset of field: _tagBINDINFO::securityAttributes"]
        [::std::mem::offset_of!(_tagBINDINFO, securityAttributes) - 72usize];
    ["Offset of field: _tagBINDINFO::iid"][::std::mem::offset_of!(_tagBINDINFO, iid) - 96usize];
    ["Offset of field: _tagBINDINFO::pUnk"][::std::mem::offset_of!(_tagBINDINFO, pUnk) - 112usize];
    ["Offset of field: _tagBINDINFO::dwReserved"]
        [::std::mem::offset_of!(_tagBINDINFO, dwReserved) - 120usize];
};
pub type BINDINFO = _tagBINDINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _REMSECURITY_ATTRIBUTES {
    pub nLength: DWORD,
    pub lpSecurityDescriptor: DWORD,
    pub bInheritHandle: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _REMSECURITY_ATTRIBUTES"][::std::mem::size_of::<_REMSECURITY_ATTRIBUTES>() - 12usize];
    ["Alignment of _REMSECURITY_ATTRIBUTES"]
        [::std::mem::align_of::<_REMSECURITY_ATTRIBUTES>() - 4usize];
    ["Offset of field: _REMSECURITY_ATTRIBUTES::nLength"]
        [::std::mem::offset_of!(_REMSECURITY_ATTRIBUTES, nLength) - 0usize];
    ["Offset of field: _REMSECURITY_ATTRIBUTES::lpSecurityDescriptor"]
        [::std::mem::offset_of!(_REMSECURITY_ATTRIBUTES, lpSecurityDescriptor) - 4usize];
    ["Offset of field: _REMSECURITY_ATTRIBUTES::bInheritHandle"]
        [::std::mem::offset_of!(_REMSECURITY_ATTRIBUTES, bInheritHandle) - 8usize];
};
pub type REMSECURITY_ATTRIBUTES = _REMSECURITY_ATTRIBUTES;
pub type PREMSECURITY_ATTRIBUTES = *mut _REMSECURITY_ATTRIBUTES;
pub type LPREMSECURITY_ATTRIBUTES = *mut _REMSECURITY_ATTRIBUTES;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagRemBINDINFO {
    pub cbSize: ULONG,
    pub szExtraInfo: LPWSTR,
    pub grfBindInfoF: DWORD,
    pub dwBindVerb: DWORD,
    pub szCustomVerb: LPWSTR,
    pub cbstgmedData: DWORD,
    pub dwOptions: DWORD,
    pub dwOptionsFlags: DWORD,
    pub dwCodePage: DWORD,
    pub securityAttributes: REMSECURITY_ATTRIBUTES,
    pub iid: IID,
    pub pUnk: *mut IUnknown,
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagRemBINDINFO"][::std::mem::size_of::<_tagRemBINDINFO>() - 96usize];
    ["Alignment of _tagRemBINDINFO"][::std::mem::align_of::<_tagRemBINDINFO>() - 8usize];
    ["Offset of field: _tagRemBINDINFO::cbSize"]
        [::std::mem::offset_of!(_tagRemBINDINFO, cbSize) - 0usize];
    ["Offset of field: _tagRemBINDINFO::szExtraInfo"]
        [::std::mem::offset_of!(_tagRemBINDINFO, szExtraInfo) - 8usize];
    ["Offset of field: _tagRemBINDINFO::grfBindInfoF"]
        [::std::mem::offset_of!(_tagRemBINDINFO, grfBindInfoF) - 16usize];
    ["Offset of field: _tagRemBINDINFO::dwBindVerb"]
        [::std::mem::offset_of!(_tagRemBINDINFO, dwBindVerb) - 20usize];
    ["Offset of field: _tagRemBINDINFO::szCustomVerb"]
        [::std::mem::offset_of!(_tagRemBINDINFO, szCustomVerb) - 24usize];
    ["Offset of field: _tagRemBINDINFO::cbstgmedData"]
        [::std::mem::offset_of!(_tagRemBINDINFO, cbstgmedData) - 32usize];
    ["Offset of field: _tagRemBINDINFO::dwOptions"]
        [::std::mem::offset_of!(_tagRemBINDINFO, dwOptions) - 36usize];
    ["Offset of field: _tagRemBINDINFO::dwOptionsFlags"]
        [::std::mem::offset_of!(_tagRemBINDINFO, dwOptionsFlags) - 40usize];
    ["Offset of field: _tagRemBINDINFO::dwCodePage"]
        [::std::mem::offset_of!(_tagRemBINDINFO, dwCodePage) - 44usize];
    ["Offset of field: _tagRemBINDINFO::securityAttributes"]
        [::std::mem::offset_of!(_tagRemBINDINFO, securityAttributes) - 48usize];
    ["Offset of field: _tagRemBINDINFO::iid"]
        [::std::mem::offset_of!(_tagRemBINDINFO, iid) - 60usize];
    ["Offset of field: _tagRemBINDINFO::pUnk"]
        [::std::mem::offset_of!(_tagRemBINDINFO, pUnk) - 80usize];
    ["Offset of field: _tagRemBINDINFO::dwReserved"]
        [::std::mem::offset_of!(_tagRemBINDINFO, dwReserved) - 88usize];
};
pub type RemBINDINFO = _tagRemBINDINFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRemFORMATETC {
    pub cfFormat: DWORD,
    pub ptd: DWORD,
    pub dwAspect: DWORD,
    pub lindex: LONG,
    pub tymed: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRemFORMATETC"][::std::mem::size_of::<tagRemFORMATETC>() - 20usize];
    ["Alignment of tagRemFORMATETC"][::std::mem::align_of::<tagRemFORMATETC>() - 4usize];
    ["Offset of field: tagRemFORMATETC::cfFormat"]
        [::std::mem::offset_of!(tagRemFORMATETC, cfFormat) - 0usize];
    ["Offset of field: tagRemFORMATETC::ptd"]
        [::std::mem::offset_of!(tagRemFORMATETC, ptd) - 4usize];
    ["Offset of field: tagRemFORMATETC::dwAspect"]
        [::std::mem::offset_of!(tagRemFORMATETC, dwAspect) - 8usize];
    ["Offset of field: tagRemFORMATETC::lindex"]
        [::std::mem::offset_of!(tagRemFORMATETC, lindex) - 12usize];
    ["Offset of field: tagRemFORMATETC::tymed"]
        [::std::mem::offset_of!(tagRemFORMATETC, tymed) - 16usize];
};
pub type RemFORMATETC = tagRemFORMATETC;
pub type LPREMFORMATETC = *mut tagRemFORMATETC;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_WININETFLAG:
    __MIDL_IBindStatusCallback_0005 = 65536;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_ENABLE_UTF8:
    __MIDL_IBindStatusCallback_0005 = 131072;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_DISABLE_UTF8:
    __MIDL_IBindStatusCallback_0005 = 262144;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_USE_IE_ENCODING:
    __MIDL_IBindStatusCallback_0005 = 524288;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_BINDTOOBJECT:
    __MIDL_IBindStatusCallback_0005 = 1048576;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_SECURITYOPTOUT:
    __MIDL_IBindStatusCallback_0005 = 2097152;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_IGNOREMIMETEXTPLAIN:
    __MIDL_IBindStatusCallback_0005 = 4194304;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_USEBINDSTRINGCREDS:
    __MIDL_IBindStatusCallback_0005 = 8388608;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_IGNOREHTTPHTTPSREDIRECTS:
    __MIDL_IBindStatusCallback_0005 = 16777216;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_IGNORE_SSLERRORS_ONCE:
    __MIDL_IBindStatusCallback_0005 = 33554432;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_WPC_DOWNLOADBLOCKED:
    __MIDL_IBindStatusCallback_0005 = 134217728;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_WPC_LOGGING_ENABLED:
    __MIDL_IBindStatusCallback_0005 = 268435456;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_ALLOWCONNECTDATA:
    __MIDL_IBindStatusCallback_0005 = 536870912;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_DISABLEAUTOREDIRECTS:
    __MIDL_IBindStatusCallback_0005 = 1073741824;
pub const __MIDL_IBindStatusCallback_0005_BINDINFO_OPTIONS_SHDOCVW_NAVIGATE:
    __MIDL_IBindStatusCallback_0005 = -2147483648;
pub type __MIDL_IBindStatusCallback_0005 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0005 as BINDINFO_OPTIONS;
pub const __MIDL_IBindStatusCallback_0006_BSCF_FIRSTDATANOTIFICATION:
    __MIDL_IBindStatusCallback_0006 = 1;
pub const __MIDL_IBindStatusCallback_0006_BSCF_INTERMEDIATEDATANOTIFICATION:
    __MIDL_IBindStatusCallback_0006 = 2;
pub const __MIDL_IBindStatusCallback_0006_BSCF_LASTDATANOTIFICATION:
    __MIDL_IBindStatusCallback_0006 = 4;
pub const __MIDL_IBindStatusCallback_0006_BSCF_DATAFULLYAVAILABLE: __MIDL_IBindStatusCallback_0006 =
    8;
pub const __MIDL_IBindStatusCallback_0006_BSCF_AVAILABLEDATASIZEUNKNOWN:
    __MIDL_IBindStatusCallback_0006 = 16;
pub const __MIDL_IBindStatusCallback_0006_BSCF_SKIPDRAINDATAFORFILEURLS:
    __MIDL_IBindStatusCallback_0006 = 32;
pub const __MIDL_IBindStatusCallback_0006_BSCF_64BITLENGTHDOWNLOAD:
    __MIDL_IBindStatusCallback_0006 = 64;
pub type __MIDL_IBindStatusCallback_0006 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallback_0006 as BSCF;
pub const tagBINDSTATUS_BINDSTATUS_FINDINGRESOURCE: tagBINDSTATUS = 1;
pub const tagBINDSTATUS_BINDSTATUS_CONNECTING: tagBINDSTATUS = 2;
pub const tagBINDSTATUS_BINDSTATUS_REDIRECTING: tagBINDSTATUS = 3;
pub const tagBINDSTATUS_BINDSTATUS_BEGINDOWNLOADDATA: tagBINDSTATUS = 4;
pub const tagBINDSTATUS_BINDSTATUS_DOWNLOADINGDATA: tagBINDSTATUS = 5;
pub const tagBINDSTATUS_BINDSTATUS_ENDDOWNLOADDATA: tagBINDSTATUS = 6;
pub const tagBINDSTATUS_BINDSTATUS_BEGINDOWNLOADCOMPONENTS: tagBINDSTATUS = 7;
pub const tagBINDSTATUS_BINDSTATUS_INSTALLINGCOMPONENTS: tagBINDSTATUS = 8;
pub const tagBINDSTATUS_BINDSTATUS_ENDDOWNLOADCOMPONENTS: tagBINDSTATUS = 9;
pub const tagBINDSTATUS_BINDSTATUS_USINGCACHEDCOPY: tagBINDSTATUS = 10;
pub const tagBINDSTATUS_BINDSTATUS_SENDINGREQUEST: tagBINDSTATUS = 11;
pub const tagBINDSTATUS_BINDSTATUS_CLASSIDAVAILABLE: tagBINDSTATUS = 12;
pub const tagBINDSTATUS_BINDSTATUS_MIMETYPEAVAILABLE: tagBINDSTATUS = 13;
pub const tagBINDSTATUS_BINDSTATUS_CACHEFILENAMEAVAILABLE: tagBINDSTATUS = 14;
pub const tagBINDSTATUS_BINDSTATUS_BEGINSYNCOPERATION: tagBINDSTATUS = 15;
pub const tagBINDSTATUS_BINDSTATUS_ENDSYNCOPERATION: tagBINDSTATUS = 16;
pub const tagBINDSTATUS_BINDSTATUS_BEGINUPLOADDATA: tagBINDSTATUS = 17;
pub const tagBINDSTATUS_BINDSTATUS_UPLOADINGDATA: tagBINDSTATUS = 18;
pub const tagBINDSTATUS_BINDSTATUS_ENDUPLOADDATA: tagBINDSTATUS = 19;
pub const tagBINDSTATUS_BINDSTATUS_PROTOCOLCLASSID: tagBINDSTATUS = 20;
pub const tagBINDSTATUS_BINDSTATUS_ENCODING: tagBINDSTATUS = 21;
pub const tagBINDSTATUS_BINDSTATUS_VERIFIEDMIMETYPEAVAILABLE: tagBINDSTATUS = 22;
pub const tagBINDSTATUS_BINDSTATUS_CLASSINSTALLLOCATION: tagBINDSTATUS = 23;
pub const tagBINDSTATUS_BINDSTATUS_DECODING: tagBINDSTATUS = 24;
pub const tagBINDSTATUS_BINDSTATUS_LOADINGMIMEHANDLER: tagBINDSTATUS = 25;
pub const tagBINDSTATUS_BINDSTATUS_CONTENTDISPOSITIONATTACH: tagBINDSTATUS = 26;
pub const tagBINDSTATUS_BINDSTATUS_FILTERREPORTMIMETYPE: tagBINDSTATUS = 27;
pub const tagBINDSTATUS_BINDSTATUS_CLSIDCANINSTANTIATE: tagBINDSTATUS = 28;
pub const tagBINDSTATUS_BINDSTATUS_IUNKNOWNAVAILABLE: tagBINDSTATUS = 29;
pub const tagBINDSTATUS_BINDSTATUS_DIRECTBIND: tagBINDSTATUS = 30;
pub const tagBINDSTATUS_BINDSTATUS_RAWMIMETYPE: tagBINDSTATUS = 31;
pub const tagBINDSTATUS_BINDSTATUS_PROXYDETECTING: tagBINDSTATUS = 32;
pub const tagBINDSTATUS_BINDSTATUS_ACCEPTRANGES: tagBINDSTATUS = 33;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_SENT: tagBINDSTATUS = 34;
pub const tagBINDSTATUS_BINDSTATUS_COMPACT_POLICY_RECEIVED: tagBINDSTATUS = 35;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_SUPPRESSED: tagBINDSTATUS = 36;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_UNKNOWN: tagBINDSTATUS = 37;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_ACCEPT: tagBINDSTATUS = 38;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_REJECT: tagBINDSTATUS = 39;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_PROMPT: tagBINDSTATUS = 40;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_LEASH: tagBINDSTATUS = 41;
pub const tagBINDSTATUS_BINDSTATUS_COOKIE_STATE_DOWNGRADE: tagBINDSTATUS = 42;
pub const tagBINDSTATUS_BINDSTATUS_POLICY_HREF: tagBINDSTATUS = 43;
pub const tagBINDSTATUS_BINDSTATUS_P3P_HEADER: tagBINDSTATUS = 44;
pub const tagBINDSTATUS_BINDSTATUS_SESSION_COOKIE_RECEIVED: tagBINDSTATUS = 45;
pub const tagBINDSTATUS_BINDSTATUS_PERSISTENT_COOKIE_RECEIVED: tagBINDSTATUS = 46;
pub const tagBINDSTATUS_BINDSTATUS_SESSION_COOKIES_ALLOWED: tagBINDSTATUS = 47;
pub const tagBINDSTATUS_BINDSTATUS_CACHECONTROL: tagBINDSTATUS = 48;
pub const tagBINDSTATUS_BINDSTATUS_CONTENTDISPOSITIONFILENAME: tagBINDSTATUS = 49;
pub const tagBINDSTATUS_BINDSTATUS_MIMETEXTPLAINMISMATCH: tagBINDSTATUS = 50;
pub const tagBINDSTATUS_BINDSTATUS_PUBLISHERAVAILABLE: tagBINDSTATUS = 51;
pub const tagBINDSTATUS_BINDSTATUS_DISPLAYNAMEAVAILABLE: tagBINDSTATUS = 52;
pub const tagBINDSTATUS_BINDSTATUS_SSLUX_NAVBLOCKED: tagBINDSTATUS = 53;
pub const tagBINDSTATUS_BINDSTATUS_SERVER_MIMETYPEAVAILABLE: tagBINDSTATUS = 54;
pub const tagBINDSTATUS_BINDSTATUS_SNIFFED_CLASSIDAVAILABLE: tagBINDSTATUS = 55;
pub const tagBINDSTATUS_BINDSTATUS_64BIT_PROGRESS: tagBINDSTATUS = 56;
pub const tagBINDSTATUS_BINDSTATUS_LAST: tagBINDSTATUS = 56;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_0: tagBINDSTATUS = 57;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_1: tagBINDSTATUS = 58;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_2: tagBINDSTATUS = 59;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_3: tagBINDSTATUS = 60;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_4: tagBINDSTATUS = 61;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_5: tagBINDSTATUS = 62;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_6: tagBINDSTATUS = 63;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_7: tagBINDSTATUS = 64;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_8: tagBINDSTATUS = 65;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_9: tagBINDSTATUS = 66;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_A: tagBINDSTATUS = 67;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_B: tagBINDSTATUS = 68;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_C: tagBINDSTATUS = 69;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_D: tagBINDSTATUS = 70;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_E: tagBINDSTATUS = 71;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_F: tagBINDSTATUS = 72;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_10: tagBINDSTATUS = 73;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_11: tagBINDSTATUS = 74;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_12: tagBINDSTATUS = 75;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_13: tagBINDSTATUS = 76;
pub const tagBINDSTATUS_BINDSTATUS_RESERVED_14: tagBINDSTATUS = 77;
pub const tagBINDSTATUS_BINDSTATUS_LAST_PRIVATE: tagBINDSTATUS = 77;
pub type tagBINDSTATUS = ::std::os::raw::c_int;
pub use self::tagBINDSTATUS as BINDSTATUS;
unsafe extern "C" {
    pub static IID_IBindStatusCallback: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindStatusCallbackVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindStatusCallback) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindStatusCallback) -> ULONG>,
    pub OnStartBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            dwReserved: DWORD,
            pib: *mut IBinding,
        ) -> HRESULT,
    >,
    pub GetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindStatusCallback, pnPriority: *mut LONG) -> HRESULT,
    >,
    pub OnLowResource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindStatusCallback, reserved: DWORD) -> HRESULT,
    >,
    pub OnProgress: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            ulProgress: ULONG,
            ulProgressMax: ULONG,
            ulStatusCode: ULONG,
            szStatusText: LPCWSTR,
        ) -> HRESULT,
    >,
    pub OnStopBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            hresult: HRESULT,
            szError: LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetBindInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
        ) -> HRESULT,
    >,
    pub OnDataAvailable: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            grfBSCF: DWORD,
            dwSize: DWORD,
            pformatetc: *mut FORMATETC,
            pstgmed: *mut STGMEDIUM,
        ) -> HRESULT,
    >,
    pub OnObjectAvailable: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallback,
            riid: *const IID,
            punk: *mut IUnknown,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindStatusCallbackVtbl"][::std::mem::size_of::<IBindStatusCallbackVtbl>() - 88usize];
    ["Alignment of IBindStatusCallbackVtbl"]
        [::std::mem::align_of::<IBindStatusCallbackVtbl>() - 8usize];
    ["Offset of field: IBindStatusCallbackVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindStatusCallbackVtbl::AddRef"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, AddRef) - 8usize];
    ["Offset of field: IBindStatusCallbackVtbl::Release"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, Release) - 16usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnStartBinding"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnStartBinding) - 24usize];
    ["Offset of field: IBindStatusCallbackVtbl::GetPriority"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, GetPriority) - 32usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnLowResource"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnLowResource) - 40usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnProgress"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnProgress) - 48usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnStopBinding"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnStopBinding) - 56usize];
    ["Offset of field: IBindStatusCallbackVtbl::GetBindInfo"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, GetBindInfo) - 64usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnDataAvailable"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnDataAvailable) - 72usize];
    ["Offset of field: IBindStatusCallbackVtbl::OnObjectAvailable"]
        [::std::mem::offset_of!(IBindStatusCallbackVtbl, OnObjectAvailable) - 80usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindStatusCallback {
    pub lpVtbl: *mut IBindStatusCallbackVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindStatusCallback"][::std::mem::size_of::<IBindStatusCallback>() - 8usize];
    ["Alignment of IBindStatusCallback"][::std::mem::align_of::<IBindStatusCallback>() - 8usize];
    ["Offset of field: IBindStatusCallback::lpVtbl"]
        [::std::mem::offset_of!(IBindStatusCallback, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IBindStatusCallback_RemoteGetBindInfo_Proxy(
        This: *mut IBindStatusCallback,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut RemBINDINFO,
        pstgmed: *mut RemSTGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_RemoteGetBindInfo_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IBindStatusCallback_RemoteOnDataAvailable_Proxy(
        This: *mut IBindStatusCallback,
        grfBSCF: DWORD,
        dwSize: DWORD,
        pformatetc: *mut RemFORMATETC,
        pstgmed: *mut RemSTGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_RemoteOnDataAvailable_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0005_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0005_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDSTATUSCALLBACKEX = *mut IBindStatusCallbackEx;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_DISABLEBASICOVERHTTP:
    __MIDL_IBindStatusCallbackEx_0001 = 1;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_DISABLEAUTOCOOKIEHANDLING:
    __MIDL_IBindStatusCallbackEx_0001 = 2;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_READ_DATA_GREATER_THAN_4GB:
    __MIDL_IBindStatusCallbackEx_0001 = 4;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_DISABLE_HTTP_REDIRECT_XSECURITYID:
    __MIDL_IBindStatusCallbackEx_0001 = 8;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_SETDOWNLOADMODE:
    __MIDL_IBindStatusCallbackEx_0001 = 32;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_DISABLE_HTTP_REDIRECT_CACHING:
    __MIDL_IBindStatusCallbackEx_0001 = 64;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_KEEP_CALLBACK_MODULE_LOADED:
    __MIDL_IBindStatusCallbackEx_0001 = 128;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_ALLOW_PROXY_CRED_PROMPT:
    __MIDL_IBindStatusCallbackEx_0001 = 256;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_17: __MIDL_IBindStatusCallbackEx_0001 =
    512;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_16: __MIDL_IBindStatusCallbackEx_0001 =
    1024;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_15: __MIDL_IBindStatusCallbackEx_0001 =
    2048;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_14: __MIDL_IBindStatusCallbackEx_0001 =
    4096;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_13: __MIDL_IBindStatusCallbackEx_0001 =
    8192;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_12: __MIDL_IBindStatusCallbackEx_0001 =
    16384;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_11: __MIDL_IBindStatusCallbackEx_0001 =
    32768;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_10: __MIDL_IBindStatusCallbackEx_0001 =
    65536;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_F: __MIDL_IBindStatusCallbackEx_0001 =
    131072;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_E: __MIDL_IBindStatusCallbackEx_0001 =
    262144;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_D: __MIDL_IBindStatusCallbackEx_0001 =
    524288;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_C: __MIDL_IBindStatusCallbackEx_0001 =
    1048576;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_B: __MIDL_IBindStatusCallbackEx_0001 =
    2097152;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_A: __MIDL_IBindStatusCallbackEx_0001 =
    4194304;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_9: __MIDL_IBindStatusCallbackEx_0001 =
    8388608;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_8: __MIDL_IBindStatusCallbackEx_0001 =
    16777216;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_7: __MIDL_IBindStatusCallbackEx_0001 =
    33554432;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_6: __MIDL_IBindStatusCallbackEx_0001 =
    67108864;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_5: __MIDL_IBindStatusCallbackEx_0001 =
    134217728;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_4: __MIDL_IBindStatusCallbackEx_0001 =
    268435456;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_3: __MIDL_IBindStatusCallbackEx_0001 =
    536870912;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_2: __MIDL_IBindStatusCallbackEx_0001 =
    1073741824;
pub const __MIDL_IBindStatusCallbackEx_0001_BINDF2_RESERVED_1: __MIDL_IBindStatusCallbackEx_0001 =
    -2147483648;
pub type __MIDL_IBindStatusCallbackEx_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IBindStatusCallbackEx_0001 as BINDF2;
unsafe extern "C" {
    pub static IID_IBindStatusCallbackEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindStatusCallbackExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindStatusCallbackEx) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindStatusCallbackEx) -> ULONG>,
    pub OnStartBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            dwReserved: DWORD,
            pib: *mut IBinding,
        ) -> HRESULT,
    >,
    pub GetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindStatusCallbackEx, pnPriority: *mut LONG) -> HRESULT,
    >,
    pub OnLowResource: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IBindStatusCallbackEx, reserved: DWORD) -> HRESULT,
    >,
    pub OnProgress: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            ulProgress: ULONG,
            ulProgressMax: ULONG,
            ulStatusCode: ULONG,
            szStatusText: LPCWSTR,
        ) -> HRESULT,
    >,
    pub OnStopBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            hresult: HRESULT,
            szError: LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetBindInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
        ) -> HRESULT,
    >,
    pub OnDataAvailable: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            grfBSCF: DWORD,
            dwSize: DWORD,
            pformatetc: *mut FORMATETC,
            pstgmed: *mut STGMEDIUM,
        ) -> HRESULT,
    >,
    pub OnObjectAvailable: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            riid: *const IID,
            punk: *mut IUnknown,
        ) -> HRESULT,
    >,
    pub GetBindInfoEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindStatusCallbackEx,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
            grfBINDF2: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindStatusCallbackExVtbl"]
        [::std::mem::size_of::<IBindStatusCallbackExVtbl>() - 96usize];
    ["Alignment of IBindStatusCallbackExVtbl"]
        [::std::mem::align_of::<IBindStatusCallbackExVtbl>() - 8usize];
    ["Offset of field: IBindStatusCallbackExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindStatusCallbackExVtbl::AddRef"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, AddRef) - 8usize];
    ["Offset of field: IBindStatusCallbackExVtbl::Release"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, Release) - 16usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnStartBinding"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnStartBinding) - 24usize];
    ["Offset of field: IBindStatusCallbackExVtbl::GetPriority"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, GetPriority) - 32usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnLowResource"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnLowResource) - 40usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnProgress"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnProgress) - 48usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnStopBinding"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnStopBinding) - 56usize];
    ["Offset of field: IBindStatusCallbackExVtbl::GetBindInfo"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, GetBindInfo) - 64usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnDataAvailable"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnDataAvailable) - 72usize];
    ["Offset of field: IBindStatusCallbackExVtbl::OnObjectAvailable"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, OnObjectAvailable) - 80usize];
    ["Offset of field: IBindStatusCallbackExVtbl::GetBindInfoEx"]
        [::std::mem::offset_of!(IBindStatusCallbackExVtbl, GetBindInfoEx) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindStatusCallbackEx {
    pub lpVtbl: *mut IBindStatusCallbackExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindStatusCallbackEx"][::std::mem::size_of::<IBindStatusCallbackEx>() - 8usize];
    ["Alignment of IBindStatusCallbackEx"]
        [::std::mem::align_of::<IBindStatusCallbackEx>() - 8usize];
    ["Offset of field: IBindStatusCallbackEx::lpVtbl"]
        [::std::mem::offset_of!(IBindStatusCallbackEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IBindStatusCallbackEx_RemoteGetBindInfoEx_Proxy(
        This: *mut IBindStatusCallbackEx,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut RemBINDINFO,
        pstgmed: *mut RemSTGMEDIUM,
        grfBINDF2: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallbackEx_RemoteGetBindInfoEx_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0006_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0006_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPAUTHENTICATION = *mut IAuthenticate;
unsafe extern "C" {
    pub static IID_IAuthenticate: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAuthenticateVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAuthenticate,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAuthenticate) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAuthenticate) -> ULONG>,
    pub Authenticate: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAuthenticate,
            phwnd: *mut HWND,
            pszUsername: *mut LPWSTR,
            pszPassword: *mut LPWSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAuthenticateVtbl"][::std::mem::size_of::<IAuthenticateVtbl>() - 32usize];
    ["Alignment of IAuthenticateVtbl"][::std::mem::align_of::<IAuthenticateVtbl>() - 8usize];
    ["Offset of field: IAuthenticateVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAuthenticateVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAuthenticateVtbl::AddRef"]
        [::std::mem::offset_of!(IAuthenticateVtbl, AddRef) - 8usize];
    ["Offset of field: IAuthenticateVtbl::Release"]
        [::std::mem::offset_of!(IAuthenticateVtbl, Release) - 16usize];
    ["Offset of field: IAuthenticateVtbl::Authenticate"]
        [::std::mem::offset_of!(IAuthenticateVtbl, Authenticate) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAuthenticate {
    pub lpVtbl: *mut IAuthenticateVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAuthenticate"][::std::mem::size_of::<IAuthenticate>() - 8usize];
    ["Alignment of IAuthenticate"][::std::mem::align_of::<IAuthenticate>() - 8usize];
    ["Offset of field: IAuthenticate::lpVtbl"]
        [::std::mem::offset_of!(IAuthenticate, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0007_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0007_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPAUTHENTICATIONEX = *mut IAuthenticateEx;
pub const __MIDL_IAuthenticateEx_0001_AUTHENTICATEF_PROXY: __MIDL_IAuthenticateEx_0001 = 1;
pub const __MIDL_IAuthenticateEx_0001_AUTHENTICATEF_BASIC: __MIDL_IAuthenticateEx_0001 = 2;
pub const __MIDL_IAuthenticateEx_0001_AUTHENTICATEF_HTTP: __MIDL_IAuthenticateEx_0001 = 4;
pub type __MIDL_IAuthenticateEx_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IAuthenticateEx_0001 as AUTHENTICATEF;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagAUTHENTICATEINFO {
    pub dwFlags: DWORD,
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagAUTHENTICATEINFO"][::std::mem::size_of::<_tagAUTHENTICATEINFO>() - 8usize];
    ["Alignment of _tagAUTHENTICATEINFO"][::std::mem::align_of::<_tagAUTHENTICATEINFO>() - 4usize];
    ["Offset of field: _tagAUTHENTICATEINFO::dwFlags"]
        [::std::mem::offset_of!(_tagAUTHENTICATEINFO, dwFlags) - 0usize];
    ["Offset of field: _tagAUTHENTICATEINFO::dwReserved"]
        [::std::mem::offset_of!(_tagAUTHENTICATEINFO, dwReserved) - 4usize];
};
pub type AUTHENTICATEINFO = _tagAUTHENTICATEINFO;
unsafe extern "C" {
    pub static IID_IAuthenticateEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAuthenticateExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAuthenticateEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IAuthenticateEx) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IAuthenticateEx) -> ULONG>,
    pub Authenticate: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAuthenticateEx,
            phwnd: *mut HWND,
            pszUsername: *mut LPWSTR,
            pszPassword: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub AuthenticateEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IAuthenticateEx,
            phwnd: *mut HWND,
            pszUsername: *mut LPWSTR,
            pszPassword: *mut LPWSTR,
            pauthinfo: *mut AUTHENTICATEINFO,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAuthenticateExVtbl"][::std::mem::size_of::<IAuthenticateExVtbl>() - 40usize];
    ["Alignment of IAuthenticateExVtbl"][::std::mem::align_of::<IAuthenticateExVtbl>() - 8usize];
    ["Offset of field: IAuthenticateExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IAuthenticateExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IAuthenticateExVtbl::AddRef"]
        [::std::mem::offset_of!(IAuthenticateExVtbl, AddRef) - 8usize];
    ["Offset of field: IAuthenticateExVtbl::Release"]
        [::std::mem::offset_of!(IAuthenticateExVtbl, Release) - 16usize];
    ["Offset of field: IAuthenticateExVtbl::Authenticate"]
        [::std::mem::offset_of!(IAuthenticateExVtbl, Authenticate) - 24usize];
    ["Offset of field: IAuthenticateExVtbl::AuthenticateEx"]
        [::std::mem::offset_of!(IAuthenticateExVtbl, AuthenticateEx) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IAuthenticateEx {
    pub lpVtbl: *mut IAuthenticateExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IAuthenticateEx"][::std::mem::size_of::<IAuthenticateEx>() - 8usize];
    ["Alignment of IAuthenticateEx"][::std::mem::align_of::<IAuthenticateEx>() - 8usize];
    ["Offset of field: IAuthenticateEx::lpVtbl"]
        [::std::mem::offset_of!(IAuthenticateEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0008_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0008_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPHTTPNEGOTIATE = *mut IHttpNegotiate;
unsafe extern "C" {
    pub static IID_IHttpNegotiate: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiateVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate) -> ULONG>,
    pub BeginningTransaction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate,
            szURL: LPCWSTR,
            szHeaders: LPCWSTR,
            dwReserved: DWORD,
            pszAdditionalHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub OnResponse: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate,
            dwResponseCode: DWORD,
            szResponseHeaders: LPCWSTR,
            szRequestHeaders: LPCWSTR,
            pszAdditionalRequestHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiateVtbl"][::std::mem::size_of::<IHttpNegotiateVtbl>() - 40usize];
    ["Alignment of IHttpNegotiateVtbl"][::std::mem::align_of::<IHttpNegotiateVtbl>() - 8usize];
    ["Offset of field: IHttpNegotiateVtbl::QueryInterface"]
        [::std::mem::offset_of!(IHttpNegotiateVtbl, QueryInterface) - 0usize];
    ["Offset of field: IHttpNegotiateVtbl::AddRef"]
        [::std::mem::offset_of!(IHttpNegotiateVtbl, AddRef) - 8usize];
    ["Offset of field: IHttpNegotiateVtbl::Release"]
        [::std::mem::offset_of!(IHttpNegotiateVtbl, Release) - 16usize];
    ["Offset of field: IHttpNegotiateVtbl::BeginningTransaction"]
        [::std::mem::offset_of!(IHttpNegotiateVtbl, BeginningTransaction) - 24usize];
    ["Offset of field: IHttpNegotiateVtbl::OnResponse"]
        [::std::mem::offset_of!(IHttpNegotiateVtbl, OnResponse) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiate {
    pub lpVtbl: *mut IHttpNegotiateVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiate"][::std::mem::size_of::<IHttpNegotiate>() - 8usize];
    ["Alignment of IHttpNegotiate"][::std::mem::align_of::<IHttpNegotiate>() - 8usize];
    ["Offset of field: IHttpNegotiate::lpVtbl"]
        [::std::mem::offset_of!(IHttpNegotiate, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0009_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0009_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPHTTPNEGOTIATE2 = *mut IHttpNegotiate2;
unsafe extern "C" {
    pub static IID_IHttpNegotiate2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiate2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate2) -> ULONG>,
    pub BeginningTransaction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate2,
            szURL: LPCWSTR,
            szHeaders: LPCWSTR,
            dwReserved: DWORD,
            pszAdditionalHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub OnResponse: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate2,
            dwResponseCode: DWORD,
            szResponseHeaders: LPCWSTR,
            szRequestHeaders: LPCWSTR,
            pszAdditionalRequestHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub GetRootSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate2,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiate2Vtbl"][::std::mem::size_of::<IHttpNegotiate2Vtbl>() - 48usize];
    ["Alignment of IHttpNegotiate2Vtbl"][::std::mem::align_of::<IHttpNegotiate2Vtbl>() - 8usize];
    ["Offset of field: IHttpNegotiate2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IHttpNegotiate2Vtbl::AddRef"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, AddRef) - 8usize];
    ["Offset of field: IHttpNegotiate2Vtbl::Release"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, Release) - 16usize];
    ["Offset of field: IHttpNegotiate2Vtbl::BeginningTransaction"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, BeginningTransaction) - 24usize];
    ["Offset of field: IHttpNegotiate2Vtbl::OnResponse"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, OnResponse) - 32usize];
    ["Offset of field: IHttpNegotiate2Vtbl::GetRootSecurityId"]
        [::std::mem::offset_of!(IHttpNegotiate2Vtbl, GetRootSecurityId) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiate2 {
    pub lpVtbl: *mut IHttpNegotiate2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiate2"][::std::mem::size_of::<IHttpNegotiate2>() - 8usize];
    ["Alignment of IHttpNegotiate2"][::std::mem::align_of::<IHttpNegotiate2>() - 8usize];
    ["Offset of field: IHttpNegotiate2::lpVtbl"]
        [::std::mem::offset_of!(IHttpNegotiate2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0010_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0010_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPHTTPNEGOTIATE3 = *mut IHttpNegotiate3;
unsafe extern "C" {
    pub static IID_IHttpNegotiate3: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiate3Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate3,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate3) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpNegotiate3) -> ULONG>,
    pub BeginningTransaction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate3,
            szURL: LPCWSTR,
            szHeaders: LPCWSTR,
            dwReserved: DWORD,
            pszAdditionalHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub OnResponse: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate3,
            dwResponseCode: DWORD,
            szResponseHeaders: LPCWSTR,
            szRequestHeaders: LPCWSTR,
            pszAdditionalRequestHeaders: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub GetRootSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate3,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub GetSerializedClientCertContext: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpNegotiate3,
            ppbCert: *mut *mut BYTE,
            pcbCert: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiate3Vtbl"][::std::mem::size_of::<IHttpNegotiate3Vtbl>() - 56usize];
    ["Alignment of IHttpNegotiate3Vtbl"][::std::mem::align_of::<IHttpNegotiate3Vtbl>() - 8usize];
    ["Offset of field: IHttpNegotiate3Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IHttpNegotiate3Vtbl::AddRef"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, AddRef) - 8usize];
    ["Offset of field: IHttpNegotiate3Vtbl::Release"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, Release) - 16usize];
    ["Offset of field: IHttpNegotiate3Vtbl::BeginningTransaction"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, BeginningTransaction) - 24usize];
    ["Offset of field: IHttpNegotiate3Vtbl::OnResponse"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, OnResponse) - 32usize];
    ["Offset of field: IHttpNegotiate3Vtbl::GetRootSecurityId"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, GetRootSecurityId) - 40usize];
    ["Offset of field: IHttpNegotiate3Vtbl::GetSerializedClientCertContext"]
        [::std::mem::offset_of!(IHttpNegotiate3Vtbl, GetSerializedClientCertContext) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpNegotiate3 {
    pub lpVtbl: *mut IHttpNegotiate3Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpNegotiate3"][::std::mem::size_of::<IHttpNegotiate3>() - 8usize];
    ["Alignment of IHttpNegotiate3"][::std::mem::align_of::<IHttpNegotiate3>() - 8usize];
    ["Offset of field: IHttpNegotiate3::lpVtbl"]
        [::std::mem::offset_of!(IHttpNegotiate3, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0011_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0011_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWININETFILESTREAM = *mut IWinInetFileStream;
unsafe extern "C" {
    pub static IID_IWinInetFileStream: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetFileStreamVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetFileStream,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetFileStream) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetFileStream) -> ULONG>,
    pub SetHandleForUnlock: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetFileStream,
            hWinInetLockHandle: DWORD_PTR,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub SetDeleteFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IWinInetFileStream, dwReserved: DWORD_PTR) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetFileStreamVtbl"][::std::mem::size_of::<IWinInetFileStreamVtbl>() - 40usize];
    ["Alignment of IWinInetFileStreamVtbl"]
        [::std::mem::align_of::<IWinInetFileStreamVtbl>() - 8usize];
    ["Offset of field: IWinInetFileStreamVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetFileStreamVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetFileStreamVtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetFileStreamVtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetFileStreamVtbl::Release"]
        [::std::mem::offset_of!(IWinInetFileStreamVtbl, Release) - 16usize];
    ["Offset of field: IWinInetFileStreamVtbl::SetHandleForUnlock"]
        [::std::mem::offset_of!(IWinInetFileStreamVtbl, SetHandleForUnlock) - 24usize];
    ["Offset of field: IWinInetFileStreamVtbl::SetDeleteFile"]
        [::std::mem::offset_of!(IWinInetFileStreamVtbl, SetDeleteFile) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetFileStream {
    pub lpVtbl: *mut IWinInetFileStreamVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetFileStream"][::std::mem::size_of::<IWinInetFileStream>() - 8usize];
    ["Alignment of IWinInetFileStream"][::std::mem::align_of::<IWinInetFileStream>() - 8usize];
    ["Offset of field: IWinInetFileStream::lpVtbl"]
        [::std::mem::offset_of!(IWinInetFileStream, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0012_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0012_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWINDOWFORBINDINGUI = *mut IWindowForBindingUI;
unsafe extern "C" {
    pub static IID_IWindowForBindingUI: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWindowForBindingUIVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWindowForBindingUI,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWindowForBindingUI) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWindowForBindingUI) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWindowForBindingUI,
            rguidReason: *const GUID,
            phwnd: *mut HWND,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWindowForBindingUIVtbl"][::std::mem::size_of::<IWindowForBindingUIVtbl>() - 32usize];
    ["Alignment of IWindowForBindingUIVtbl"]
        [::std::mem::align_of::<IWindowForBindingUIVtbl>() - 8usize];
    ["Offset of field: IWindowForBindingUIVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWindowForBindingUIVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWindowForBindingUIVtbl::AddRef"]
        [::std::mem::offset_of!(IWindowForBindingUIVtbl, AddRef) - 8usize];
    ["Offset of field: IWindowForBindingUIVtbl::Release"]
        [::std::mem::offset_of!(IWindowForBindingUIVtbl, Release) - 16usize];
    ["Offset of field: IWindowForBindingUIVtbl::GetWindow"]
        [::std::mem::offset_of!(IWindowForBindingUIVtbl, GetWindow) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWindowForBindingUI {
    pub lpVtbl: *mut IWindowForBindingUIVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWindowForBindingUI"][::std::mem::size_of::<IWindowForBindingUI>() - 8usize];
    ["Alignment of IWindowForBindingUI"][::std::mem::align_of::<IWindowForBindingUI>() - 8usize];
    ["Offset of field: IWindowForBindingUI::lpVtbl"]
        [::std::mem::offset_of!(IWindowForBindingUI, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0013_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0013_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPCODEINSTALL = *mut ICodeInstall;
pub const __MIDL_ICodeInstall_0001_CIP_DISK_FULL: __MIDL_ICodeInstall_0001 = 0;
pub const __MIDL_ICodeInstall_0001_CIP_ACCESS_DENIED: __MIDL_ICodeInstall_0001 = 1;
pub const __MIDL_ICodeInstall_0001_CIP_NEWER_VERSION_EXISTS: __MIDL_ICodeInstall_0001 = 2;
pub const __MIDL_ICodeInstall_0001_CIP_OLDER_VERSION_EXISTS: __MIDL_ICodeInstall_0001 = 3;
pub const __MIDL_ICodeInstall_0001_CIP_NAME_CONFLICT: __MIDL_ICodeInstall_0001 = 4;
pub const __MIDL_ICodeInstall_0001_CIP_TRUST_VERIFICATION_COMPONENT_MISSING:
    __MIDL_ICodeInstall_0001 = 5;
pub const __MIDL_ICodeInstall_0001_CIP_EXE_SELF_REGISTERATION_TIMEOUT: __MIDL_ICodeInstall_0001 = 6;
pub const __MIDL_ICodeInstall_0001_CIP_UNSAFE_TO_ABORT: __MIDL_ICodeInstall_0001 = 7;
pub const __MIDL_ICodeInstall_0001_CIP_NEED_REBOOT: __MIDL_ICodeInstall_0001 = 8;
pub const __MIDL_ICodeInstall_0001_CIP_NEED_REBOOT_UI_PERMISSION: __MIDL_ICodeInstall_0001 = 9;
pub type __MIDL_ICodeInstall_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_ICodeInstall_0001 as CIP_STATUS;
unsafe extern "C" {
    pub static IID_ICodeInstall: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICodeInstallVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICodeInstall,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICodeInstall) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICodeInstall) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICodeInstall,
            rguidReason: *const GUID,
            phwnd: *mut HWND,
        ) -> HRESULT,
    >,
    pub OnCodeInstallProblem: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICodeInstall,
            ulStatusCode: ULONG,
            szDestination: LPCWSTR,
            szSource: LPCWSTR,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICodeInstallVtbl"][::std::mem::size_of::<ICodeInstallVtbl>() - 40usize];
    ["Alignment of ICodeInstallVtbl"][::std::mem::align_of::<ICodeInstallVtbl>() - 8usize];
    ["Offset of field: ICodeInstallVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICodeInstallVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICodeInstallVtbl::AddRef"]
        [::std::mem::offset_of!(ICodeInstallVtbl, AddRef) - 8usize];
    ["Offset of field: ICodeInstallVtbl::Release"]
        [::std::mem::offset_of!(ICodeInstallVtbl, Release) - 16usize];
    ["Offset of field: ICodeInstallVtbl::GetWindow"]
        [::std::mem::offset_of!(ICodeInstallVtbl, GetWindow) - 24usize];
    ["Offset of field: ICodeInstallVtbl::OnCodeInstallProblem"]
        [::std::mem::offset_of!(ICodeInstallVtbl, OnCodeInstallProblem) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICodeInstall {
    pub lpVtbl: *mut ICodeInstallVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICodeInstall"][::std::mem::size_of::<ICodeInstall>() - 8usize];
    ["Alignment of ICodeInstall"][::std::mem::align_of::<ICodeInstall>() - 8usize];
    ["Offset of field: ICodeInstall::lpVtbl"]
        [::std::mem::offset_of!(ICodeInstall, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0014_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0014_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub const __MIDL_IUri_0001_Uri_PROPERTY_ABSOLUTE_URI: __MIDL_IUri_0001 = 0;
pub const __MIDL_IUri_0001_Uri_PROPERTY_STRING_START: __MIDL_IUri_0001 = 0;
pub const __MIDL_IUri_0001_Uri_PROPERTY_AUTHORITY: __MIDL_IUri_0001 = 1;
pub const __MIDL_IUri_0001_Uri_PROPERTY_DISPLAY_URI: __MIDL_IUri_0001 = 2;
pub const __MIDL_IUri_0001_Uri_PROPERTY_DOMAIN: __MIDL_IUri_0001 = 3;
pub const __MIDL_IUri_0001_Uri_PROPERTY_EXTENSION: __MIDL_IUri_0001 = 4;
pub const __MIDL_IUri_0001_Uri_PROPERTY_FRAGMENT: __MIDL_IUri_0001 = 5;
pub const __MIDL_IUri_0001_Uri_PROPERTY_HOST: __MIDL_IUri_0001 = 6;
pub const __MIDL_IUri_0001_Uri_PROPERTY_PASSWORD: __MIDL_IUri_0001 = 7;
pub const __MIDL_IUri_0001_Uri_PROPERTY_PATH: __MIDL_IUri_0001 = 8;
pub const __MIDL_IUri_0001_Uri_PROPERTY_PATH_AND_QUERY: __MIDL_IUri_0001 = 9;
pub const __MIDL_IUri_0001_Uri_PROPERTY_QUERY: __MIDL_IUri_0001 = 10;
pub const __MIDL_IUri_0001_Uri_PROPERTY_RAW_URI: __MIDL_IUri_0001 = 11;
pub const __MIDL_IUri_0001_Uri_PROPERTY_SCHEME_NAME: __MIDL_IUri_0001 = 12;
pub const __MIDL_IUri_0001_Uri_PROPERTY_USER_INFO: __MIDL_IUri_0001 = 13;
pub const __MIDL_IUri_0001_Uri_PROPERTY_USER_NAME: __MIDL_IUri_0001 = 14;
pub const __MIDL_IUri_0001_Uri_PROPERTY_STRING_LAST: __MIDL_IUri_0001 = 14;
pub const __MIDL_IUri_0001_Uri_PROPERTY_HOST_TYPE: __MIDL_IUri_0001 = 15;
pub const __MIDL_IUri_0001_Uri_PROPERTY_DWORD_START: __MIDL_IUri_0001 = 15;
pub const __MIDL_IUri_0001_Uri_PROPERTY_PORT: __MIDL_IUri_0001 = 16;
pub const __MIDL_IUri_0001_Uri_PROPERTY_SCHEME: __MIDL_IUri_0001 = 17;
pub const __MIDL_IUri_0001_Uri_PROPERTY_ZONE: __MIDL_IUri_0001 = 18;
pub const __MIDL_IUri_0001_Uri_PROPERTY_DWORD_LAST: __MIDL_IUri_0001 = 18;
pub type __MIDL_IUri_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IUri_0001 as Uri_PROPERTY;
pub const __MIDL_IUri_0002_Uri_HOST_UNKNOWN: __MIDL_IUri_0002 = 0;
pub const __MIDL_IUri_0002_Uri_HOST_DNS: __MIDL_IUri_0002 = 1;
pub const __MIDL_IUri_0002_Uri_HOST_IPV4: __MIDL_IUri_0002 = 2;
pub const __MIDL_IUri_0002_Uri_HOST_IPV6: __MIDL_IUri_0002 = 3;
pub const __MIDL_IUri_0002_Uri_HOST_IDN: __MIDL_IUri_0002 = 4;
pub type __MIDL_IUri_0002 = ::std::os::raw::c_int;
pub use self::__MIDL_IUri_0002 as Uri_HOST_TYPE;
unsafe extern "C" {
    pub static IID_IUri: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUri,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUri) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IUri) -> ULONG>,
    pub GetPropertyBSTR: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUri,
            uriProp: Uri_PROPERTY,
            pbstrProperty: *mut BSTR,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetPropertyLength: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUri,
            uriProp: Uri_PROPERTY,
            pcchProperty: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetPropertyDWORD: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUri,
            uriProp: Uri_PROPERTY,
            pdwProperty: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub HasProperty: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUri,
            uriProp: Uri_PROPERTY,
            pfHasProperty: *mut BOOL,
        ) -> HRESULT,
    >,
    pub GetAbsoluteUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrAbsoluteUri: *mut BSTR) -> HRESULT,
    >,
    pub GetAuthority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrAuthority: *mut BSTR) -> HRESULT,
    >,
    pub GetDisplayUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrDisplayString: *mut BSTR) -> HRESULT,
    >,
    pub GetDomain: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrDomain: *mut BSTR) -> HRESULT,
    >,
    pub GetExtension: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrExtension: *mut BSTR) -> HRESULT,
    >,
    pub GetFragment: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrFragment: *mut BSTR) -> HRESULT,
    >,
    pub GetHost: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrHost: *mut BSTR) -> HRESULT,
    >,
    pub GetPassword: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrPassword: *mut BSTR) -> HRESULT,
    >,
    pub GetPath: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrPath: *mut BSTR) -> HRESULT,
    >,
    pub GetPathAndQuery: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrPathAndQuery: *mut BSTR) -> HRESULT,
    >,
    pub GetQuery: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrQuery: *mut BSTR) -> HRESULT,
    >,
    pub GetRawUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrRawUri: *mut BSTR) -> HRESULT,
    >,
    pub GetSchemeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrSchemeName: *mut BSTR) -> HRESULT,
    >,
    pub GetUserInfo: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrUserInfo: *mut BSTR) -> HRESULT,
    >,
    pub GetUserNameA: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pbstrUserName: *mut BSTR) -> HRESULT,
    >,
    pub GetHostType: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pdwHostType: *mut DWORD) -> HRESULT,
    >,
    pub GetPort: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pdwPort: *mut DWORD) -> HRESULT,
    >,
    pub GetScheme: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pdwScheme: *mut DWORD) -> HRESULT,
    >,
    pub GetZone: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pdwZone: *mut DWORD) -> HRESULT,
    >,
    pub GetProperties:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IUri, pdwFlags: LPDWORD) -> HRESULT>,
    pub IsEqual: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUri, pUri: *mut IUri, pfEqual: *mut BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriVtbl"][::std::mem::size_of::<IUriVtbl>() - 224usize];
    ["Alignment of IUriVtbl"][::std::mem::align_of::<IUriVtbl>() - 8usize];
    ["Offset of field: IUriVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUriVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUriVtbl::AddRef"][::std::mem::offset_of!(IUriVtbl, AddRef) - 8usize];
    ["Offset of field: IUriVtbl::Release"][::std::mem::offset_of!(IUriVtbl, Release) - 16usize];
    ["Offset of field: IUriVtbl::GetPropertyBSTR"]
        [::std::mem::offset_of!(IUriVtbl, GetPropertyBSTR) - 24usize];
    ["Offset of field: IUriVtbl::GetPropertyLength"]
        [::std::mem::offset_of!(IUriVtbl, GetPropertyLength) - 32usize];
    ["Offset of field: IUriVtbl::GetPropertyDWORD"]
        [::std::mem::offset_of!(IUriVtbl, GetPropertyDWORD) - 40usize];
    ["Offset of field: IUriVtbl::HasProperty"]
        [::std::mem::offset_of!(IUriVtbl, HasProperty) - 48usize];
    ["Offset of field: IUriVtbl::GetAbsoluteUri"]
        [::std::mem::offset_of!(IUriVtbl, GetAbsoluteUri) - 56usize];
    ["Offset of field: IUriVtbl::GetAuthority"]
        [::std::mem::offset_of!(IUriVtbl, GetAuthority) - 64usize];
    ["Offset of field: IUriVtbl::GetDisplayUri"]
        [::std::mem::offset_of!(IUriVtbl, GetDisplayUri) - 72usize];
    ["Offset of field: IUriVtbl::GetDomain"][::std::mem::offset_of!(IUriVtbl, GetDomain) - 80usize];
    ["Offset of field: IUriVtbl::GetExtension"]
        [::std::mem::offset_of!(IUriVtbl, GetExtension) - 88usize];
    ["Offset of field: IUriVtbl::GetFragment"]
        [::std::mem::offset_of!(IUriVtbl, GetFragment) - 96usize];
    ["Offset of field: IUriVtbl::GetHost"][::std::mem::offset_of!(IUriVtbl, GetHost) - 104usize];
    ["Offset of field: IUriVtbl::GetPassword"]
        [::std::mem::offset_of!(IUriVtbl, GetPassword) - 112usize];
    ["Offset of field: IUriVtbl::GetPath"][::std::mem::offset_of!(IUriVtbl, GetPath) - 120usize];
    ["Offset of field: IUriVtbl::GetPathAndQuery"]
        [::std::mem::offset_of!(IUriVtbl, GetPathAndQuery) - 128usize];
    ["Offset of field: IUriVtbl::GetQuery"][::std::mem::offset_of!(IUriVtbl, GetQuery) - 136usize];
    ["Offset of field: IUriVtbl::GetRawUri"]
        [::std::mem::offset_of!(IUriVtbl, GetRawUri) - 144usize];
    ["Offset of field: IUriVtbl::GetSchemeName"]
        [::std::mem::offset_of!(IUriVtbl, GetSchemeName) - 152usize];
    ["Offset of field: IUriVtbl::GetUserInfo"]
        [::std::mem::offset_of!(IUriVtbl, GetUserInfo) - 160usize];
    ["Offset of field: IUriVtbl::GetUserNameA"]
        [::std::mem::offset_of!(IUriVtbl, GetUserNameA) - 168usize];
    ["Offset of field: IUriVtbl::GetHostType"]
        [::std::mem::offset_of!(IUriVtbl, GetHostType) - 176usize];
    ["Offset of field: IUriVtbl::GetPort"][::std::mem::offset_of!(IUriVtbl, GetPort) - 184usize];
    ["Offset of field: IUriVtbl::GetScheme"]
        [::std::mem::offset_of!(IUriVtbl, GetScheme) - 192usize];
    ["Offset of field: IUriVtbl::GetZone"][::std::mem::offset_of!(IUriVtbl, GetZone) - 200usize];
    ["Offset of field: IUriVtbl::GetProperties"]
        [::std::mem::offset_of!(IUriVtbl, GetProperties) - 208usize];
    ["Offset of field: IUriVtbl::IsEqual"][::std::mem::offset_of!(IUriVtbl, IsEqual) - 216usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUri {
    pub lpVtbl: *mut IUriVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUri"][::std::mem::size_of::<IUri>() - 8usize];
    ["Alignment of IUri"][::std::mem::align_of::<IUri>() - 8usize];
    ["Offset of field: IUri::lpVtbl"][::std::mem::offset_of!(IUri, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn CreateUri(
        pwzURI: LPCWSTR,
        dwFlags: DWORD,
        dwReserved: DWORD_PTR,
        ppURI: *mut *mut IUri,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateUriWithFragment(
        pwzURI: LPCWSTR,
        pwzFragment: LPCWSTR,
        dwFlags: DWORD,
        dwReserved: DWORD_PTR,
        ppURI: *mut *mut IUri,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateUriFromMultiByteString(
        pszANSIInputUri: LPCSTR,
        dwEncodingFlags: DWORD,
        dwCodePage: DWORD,
        dwCreateFlags: DWORD,
        dwReserved: DWORD_PTR,
        ppUri: *mut *mut IUri,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0015_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0015_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IUriContainer: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriContainerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriContainer,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUriContainer) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IUriContainer) -> ULONG>,
    pub GetIUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriContainer, ppIUri: *mut *mut IUri) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriContainerVtbl"][::std::mem::size_of::<IUriContainerVtbl>() - 32usize];
    ["Alignment of IUriContainerVtbl"][::std::mem::align_of::<IUriContainerVtbl>() - 8usize];
    ["Offset of field: IUriContainerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUriContainerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUriContainerVtbl::AddRef"]
        [::std::mem::offset_of!(IUriContainerVtbl, AddRef) - 8usize];
    ["Offset of field: IUriContainerVtbl::Release"]
        [::std::mem::offset_of!(IUriContainerVtbl, Release) - 16usize];
    ["Offset of field: IUriContainerVtbl::GetIUri"]
        [::std::mem::offset_of!(IUriContainerVtbl, GetIUri) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriContainer {
    pub lpVtbl: *mut IUriContainerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriContainer"][::std::mem::size_of::<IUriContainer>() - 8usize];
    ["Alignment of IUriContainer"][::std::mem::align_of::<IUriContainer>() - 8usize];
    ["Offset of field: IUriContainer::lpVtbl"]
        [::std::mem::offset_of!(IUriContainer, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IUriBuilder: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriBuilderVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUriBuilder) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IUriBuilder) -> ULONG>,
    pub CreateUriSimple: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            dwAllowEncodingPropertyMask: DWORD,
            dwReserved: DWORD_PTR,
            ppIUri: *mut *mut IUri,
        ) -> HRESULT,
    >,
    pub CreateUri: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            dwCreateFlags: DWORD,
            dwAllowEncodingPropertyMask: DWORD,
            dwReserved: DWORD_PTR,
            ppIUri: *mut *mut IUri,
        ) -> HRESULT,
    >,
    pub CreateUriWithFlags: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            dwCreateFlags: DWORD,
            dwUriBuilderFlags: DWORD,
            dwAllowEncodingPropertyMask: DWORD,
            dwReserved: DWORD_PTR,
            ppIUri: *mut *mut IUri,
        ) -> HRESULT,
    >,
    pub GetIUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, ppIUri: *mut *mut IUri) -> HRESULT,
    >,
    pub SetIUri: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pIUri: *mut IUri) -> HRESULT,
    >,
    pub GetFragment: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchFragment: *mut DWORD,
            ppwzFragment: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetHost: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchHost: *mut DWORD,
            ppwzHost: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetPassword: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchPassword: *mut DWORD,
            ppwzPassword: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetPath: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchPath: *mut DWORD,
            ppwzPath: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetPort: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pfHasPort: *mut BOOL,
            pdwPort: *mut DWORD,
        ) -> HRESULT,
    >,
    pub GetQuery: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchQuery: *mut DWORD,
            ppwzQuery: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetSchemeName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchSchemeName: *mut DWORD,
            ppwzSchemeName: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub GetUserNameA: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilder,
            pcchUserName: *mut DWORD,
            ppwzUserName: *mut LPCWSTR,
        ) -> HRESULT,
    >,
    pub SetFragment: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetHost: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetPassword: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetPath: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetPortA: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, fHasPort: BOOL, dwNewValue: DWORD) -> HRESULT,
    >,
    pub SetQuery: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetSchemeName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub SetUserName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pwzNewValue: LPCWSTR) -> HRESULT,
    >,
    pub RemoveProperties: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, dwPropertyMask: DWORD) -> HRESULT,
    >,
    pub HasBeenModified: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IUriBuilder, pfModified: *mut BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriBuilderVtbl"][::std::mem::size_of::<IUriBuilderVtbl>() - 208usize];
    ["Alignment of IUriBuilderVtbl"][::std::mem::align_of::<IUriBuilderVtbl>() - 8usize];
    ["Offset of field: IUriBuilderVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUriBuilderVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUriBuilderVtbl::AddRef"]
        [::std::mem::offset_of!(IUriBuilderVtbl, AddRef) - 8usize];
    ["Offset of field: IUriBuilderVtbl::Release"]
        [::std::mem::offset_of!(IUriBuilderVtbl, Release) - 16usize];
    ["Offset of field: IUriBuilderVtbl::CreateUriSimple"]
        [::std::mem::offset_of!(IUriBuilderVtbl, CreateUriSimple) - 24usize];
    ["Offset of field: IUriBuilderVtbl::CreateUri"]
        [::std::mem::offset_of!(IUriBuilderVtbl, CreateUri) - 32usize];
    ["Offset of field: IUriBuilderVtbl::CreateUriWithFlags"]
        [::std::mem::offset_of!(IUriBuilderVtbl, CreateUriWithFlags) - 40usize];
    ["Offset of field: IUriBuilderVtbl::GetIUri"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetIUri) - 48usize];
    ["Offset of field: IUriBuilderVtbl::SetIUri"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetIUri) - 56usize];
    ["Offset of field: IUriBuilderVtbl::GetFragment"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetFragment) - 64usize];
    ["Offset of field: IUriBuilderVtbl::GetHost"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetHost) - 72usize];
    ["Offset of field: IUriBuilderVtbl::GetPassword"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetPassword) - 80usize];
    ["Offset of field: IUriBuilderVtbl::GetPath"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetPath) - 88usize];
    ["Offset of field: IUriBuilderVtbl::GetPort"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetPort) - 96usize];
    ["Offset of field: IUriBuilderVtbl::GetQuery"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetQuery) - 104usize];
    ["Offset of field: IUriBuilderVtbl::GetSchemeName"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetSchemeName) - 112usize];
    ["Offset of field: IUriBuilderVtbl::GetUserNameA"]
        [::std::mem::offset_of!(IUriBuilderVtbl, GetUserNameA) - 120usize];
    ["Offset of field: IUriBuilderVtbl::SetFragment"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetFragment) - 128usize];
    ["Offset of field: IUriBuilderVtbl::SetHost"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetHost) - 136usize];
    ["Offset of field: IUriBuilderVtbl::SetPassword"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetPassword) - 144usize];
    ["Offset of field: IUriBuilderVtbl::SetPath"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetPath) - 152usize];
    ["Offset of field: IUriBuilderVtbl::SetPortA"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetPortA) - 160usize];
    ["Offset of field: IUriBuilderVtbl::SetQuery"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetQuery) - 168usize];
    ["Offset of field: IUriBuilderVtbl::SetSchemeName"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetSchemeName) - 176usize];
    ["Offset of field: IUriBuilderVtbl::SetUserName"]
        [::std::mem::offset_of!(IUriBuilderVtbl, SetUserName) - 184usize];
    ["Offset of field: IUriBuilderVtbl::RemoveProperties"]
        [::std::mem::offset_of!(IUriBuilderVtbl, RemoveProperties) - 192usize];
    ["Offset of field: IUriBuilderVtbl::HasBeenModified"]
        [::std::mem::offset_of!(IUriBuilderVtbl, HasBeenModified) - 200usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriBuilder {
    pub lpVtbl: *mut IUriBuilderVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriBuilder"][::std::mem::size_of::<IUriBuilder>() - 8usize];
    ["Alignment of IUriBuilder"][::std::mem::align_of::<IUriBuilder>() - 8usize];
    ["Offset of field: IUriBuilder::lpVtbl"][::std::mem::offset_of!(IUriBuilder, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static IID_IUriBuilderFactory: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriBuilderFactoryVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilderFactory,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IUriBuilderFactory) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IUriBuilderFactory) -> ULONG>,
    pub CreateIUriBuilder: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilderFactory,
            dwFlags: DWORD,
            dwReserved: DWORD_PTR,
            ppIUriBuilder: *mut *mut IUriBuilder,
        ) -> HRESULT,
    >,
    pub CreateInitializedIUriBuilder: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IUriBuilderFactory,
            dwFlags: DWORD,
            dwReserved: DWORD_PTR,
            ppIUriBuilder: *mut *mut IUriBuilder,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriBuilderFactoryVtbl"][::std::mem::size_of::<IUriBuilderFactoryVtbl>() - 40usize];
    ["Alignment of IUriBuilderFactoryVtbl"]
        [::std::mem::align_of::<IUriBuilderFactoryVtbl>() - 8usize];
    ["Offset of field: IUriBuilderFactoryVtbl::QueryInterface"]
        [::std::mem::offset_of!(IUriBuilderFactoryVtbl, QueryInterface) - 0usize];
    ["Offset of field: IUriBuilderFactoryVtbl::AddRef"]
        [::std::mem::offset_of!(IUriBuilderFactoryVtbl, AddRef) - 8usize];
    ["Offset of field: IUriBuilderFactoryVtbl::Release"]
        [::std::mem::offset_of!(IUriBuilderFactoryVtbl, Release) - 16usize];
    ["Offset of field: IUriBuilderFactoryVtbl::CreateIUriBuilder"]
        [::std::mem::offset_of!(IUriBuilderFactoryVtbl, CreateIUriBuilder) - 24usize];
    ["Offset of field: IUriBuilderFactoryVtbl::CreateInitializedIUriBuilder"]
        [::std::mem::offset_of!(IUriBuilderFactoryVtbl, CreateInitializedIUriBuilder) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IUriBuilderFactory {
    pub lpVtbl: *mut IUriBuilderFactoryVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IUriBuilderFactory"][::std::mem::size_of::<IUriBuilderFactory>() - 8usize];
    ["Alignment of IUriBuilderFactory"][::std::mem::align_of::<IUriBuilderFactory>() - 8usize];
    ["Offset of field: IUriBuilderFactory::lpVtbl"]
        [::std::mem::offset_of!(IUriBuilderFactory, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn CreateIUriBuilder(
        pIUri: *mut IUri,
        dwFlags: DWORD,
        dwReserved: DWORD_PTR,
        ppIUriBuilder: *mut *mut IUriBuilder,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0018_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0018_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWININETINFO = *mut IWinInetInfo;
unsafe extern "C" {
    pub static IID_IWinInetInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetInfo) -> ULONG>,
    pub QueryOption: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetInfo,
            dwOption: DWORD,
            pBuffer: LPVOID,
            pcbBuf: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetInfoVtbl"][::std::mem::size_of::<IWinInetInfoVtbl>() - 32usize];
    ["Alignment of IWinInetInfoVtbl"][::std::mem::align_of::<IWinInetInfoVtbl>() - 8usize];
    ["Offset of field: IWinInetInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetInfoVtbl::Release"]
        [::std::mem::offset_of!(IWinInetInfoVtbl, Release) - 16usize];
    ["Offset of field: IWinInetInfoVtbl::QueryOption"]
        [::std::mem::offset_of!(IWinInetInfoVtbl, QueryOption) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetInfo {
    pub lpVtbl: *mut IWinInetInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetInfo"][::std::mem::size_of::<IWinInetInfo>() - 8usize];
    ["Alignment of IWinInetInfo"][::std::mem::align_of::<IWinInetInfo>() - 8usize];
    ["Offset of field: IWinInetInfo::lpVtbl"]
        [::std::mem::offset_of!(IWinInetInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IWinInetInfo_RemoteQueryOption_Proxy(
        This: *mut IWinInetInfo,
        dwOption: DWORD,
        pBuffer: *mut BYTE,
        pcbBuf: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetInfo_RemoteQueryOption_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0019_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0019_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPHTTPSECURITY = *mut IHttpSecurity;
unsafe extern "C" {
    pub static IID_IHttpSecurity: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpSecurityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpSecurity,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpSecurity) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IHttpSecurity) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IHttpSecurity,
            rguidReason: *const GUID,
            phwnd: *mut HWND,
        ) -> HRESULT,
    >,
    pub OnSecurityProblem: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IHttpSecurity, dwProblem: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpSecurityVtbl"][::std::mem::size_of::<IHttpSecurityVtbl>() - 40usize];
    ["Alignment of IHttpSecurityVtbl"][::std::mem::align_of::<IHttpSecurityVtbl>() - 8usize];
    ["Offset of field: IHttpSecurityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IHttpSecurityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IHttpSecurityVtbl::AddRef"]
        [::std::mem::offset_of!(IHttpSecurityVtbl, AddRef) - 8usize];
    ["Offset of field: IHttpSecurityVtbl::Release"]
        [::std::mem::offset_of!(IHttpSecurityVtbl, Release) - 16usize];
    ["Offset of field: IHttpSecurityVtbl::GetWindow"]
        [::std::mem::offset_of!(IHttpSecurityVtbl, GetWindow) - 24usize];
    ["Offset of field: IHttpSecurityVtbl::OnSecurityProblem"]
        [::std::mem::offset_of!(IHttpSecurityVtbl, OnSecurityProblem) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IHttpSecurity {
    pub lpVtbl: *mut IHttpSecurityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IHttpSecurity"][::std::mem::size_of::<IHttpSecurity>() - 8usize];
    ["Alignment of IHttpSecurity"][::std::mem::align_of::<IHttpSecurity>() - 8usize];
    ["Offset of field: IHttpSecurity::lpVtbl"]
        [::std::mem::offset_of!(IHttpSecurity, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0020_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0020_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWININETHTTPINFO = *mut IWinInetHttpInfo;
unsafe extern "C" {
    pub static IID_IWinInetHttpInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetHttpInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetHttpInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetHttpInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetHttpInfo) -> ULONG>,
    pub QueryOption: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetHttpInfo,
            dwOption: DWORD,
            pBuffer: LPVOID,
            pcbBuf: *mut DWORD,
        ) -> HRESULT,
    >,
    pub QueryInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetHttpInfo,
            dwOption: DWORD,
            pBuffer: LPVOID,
            pcbBuf: *mut DWORD,
            pdwFlags: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetHttpInfoVtbl"][::std::mem::size_of::<IWinInetHttpInfoVtbl>() - 40usize];
    ["Alignment of IWinInetHttpInfoVtbl"][::std::mem::align_of::<IWinInetHttpInfoVtbl>() - 8usize];
    ["Offset of field: IWinInetHttpInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetHttpInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetHttpInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetHttpInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetHttpInfoVtbl::Release"]
        [::std::mem::offset_of!(IWinInetHttpInfoVtbl, Release) - 16usize];
    ["Offset of field: IWinInetHttpInfoVtbl::QueryOption"]
        [::std::mem::offset_of!(IWinInetHttpInfoVtbl, QueryOption) - 24usize];
    ["Offset of field: IWinInetHttpInfoVtbl::QueryInfo"]
        [::std::mem::offset_of!(IWinInetHttpInfoVtbl, QueryInfo) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetHttpInfo {
    pub lpVtbl: *mut IWinInetHttpInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetHttpInfo"][::std::mem::size_of::<IWinInetHttpInfo>() - 8usize];
    ["Alignment of IWinInetHttpInfo"][::std::mem::align_of::<IWinInetHttpInfo>() - 8usize];
    ["Offset of field: IWinInetHttpInfo::lpVtbl"]
        [::std::mem::offset_of!(IWinInetHttpInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IWinInetHttpInfo_RemoteQueryInfo_Proxy(
        This: *mut IWinInetHttpInfo,
        dwOption: DWORD,
        pBuffer: *mut BYTE,
        pcbBuf: *mut DWORD,
        pdwFlags: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetHttpInfo_RemoteQueryInfo_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0021_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0021_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IWinInetHttpTimeouts: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetHttpTimeoutsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetHttpTimeouts,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetHttpTimeouts) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetHttpTimeouts) -> ULONG>,
    pub GetRequestTimeouts: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetHttpTimeouts,
            pdwConnectTimeout: *mut DWORD,
            pdwSendTimeout: *mut DWORD,
            pdwReceiveTimeout: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetHttpTimeoutsVtbl"]
        [::std::mem::size_of::<IWinInetHttpTimeoutsVtbl>() - 32usize];
    ["Alignment of IWinInetHttpTimeoutsVtbl"]
        [::std::mem::align_of::<IWinInetHttpTimeoutsVtbl>() - 8usize];
    ["Offset of field: IWinInetHttpTimeoutsVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetHttpTimeoutsVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetHttpTimeoutsVtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetHttpTimeoutsVtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetHttpTimeoutsVtbl::Release"]
        [::std::mem::offset_of!(IWinInetHttpTimeoutsVtbl, Release) - 16usize];
    ["Offset of field: IWinInetHttpTimeoutsVtbl::GetRequestTimeouts"]
        [::std::mem::offset_of!(IWinInetHttpTimeoutsVtbl, GetRequestTimeouts) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetHttpTimeouts {
    pub lpVtbl: *mut IWinInetHttpTimeoutsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetHttpTimeouts"][::std::mem::size_of::<IWinInetHttpTimeouts>() - 8usize];
    ["Alignment of IWinInetHttpTimeouts"][::std::mem::align_of::<IWinInetHttpTimeouts>() - 8usize];
    ["Offset of field: IWinInetHttpTimeouts::lpVtbl"]
        [::std::mem::offset_of!(IWinInetHttpTimeouts, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0022_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0022_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWININETCACHEHINTS = *mut IWinInetCacheHints;
unsafe extern "C" {
    pub static IID_IWinInetCacheHints: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetCacheHintsVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetCacheHints,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetCacheHints) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetCacheHints) -> ULONG>,
    pub SetCacheExtension: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetCacheHints,
            pwzExt: LPCWSTR,
            pszCacheFile: LPVOID,
            pcbCacheFile: *mut DWORD,
            pdwWinInetError: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetCacheHintsVtbl"][::std::mem::size_of::<IWinInetCacheHintsVtbl>() - 32usize];
    ["Alignment of IWinInetCacheHintsVtbl"]
        [::std::mem::align_of::<IWinInetCacheHintsVtbl>() - 8usize];
    ["Offset of field: IWinInetCacheHintsVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetCacheHintsVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetCacheHintsVtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetCacheHintsVtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetCacheHintsVtbl::Release"]
        [::std::mem::offset_of!(IWinInetCacheHintsVtbl, Release) - 16usize];
    ["Offset of field: IWinInetCacheHintsVtbl::SetCacheExtension"]
        [::std::mem::offset_of!(IWinInetCacheHintsVtbl, SetCacheExtension) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetCacheHints {
    pub lpVtbl: *mut IWinInetCacheHintsVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetCacheHints"][::std::mem::size_of::<IWinInetCacheHints>() - 8usize];
    ["Alignment of IWinInetCacheHints"][::std::mem::align_of::<IWinInetCacheHints>() - 8usize];
    ["Offset of field: IWinInetCacheHints::lpVtbl"]
        [::std::mem::offset_of!(IWinInetCacheHints, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0023_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0023_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPWININETCACHEHINTS2 = *mut IWinInetCacheHints2;
unsafe extern "C" {
    pub static IID_IWinInetCacheHints2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetCacheHints2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetCacheHints2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetCacheHints2) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IWinInetCacheHints2) -> ULONG>,
    pub SetCacheExtension: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetCacheHints2,
            pwzExt: LPCWSTR,
            pszCacheFile: LPVOID,
            pcbCacheFile: *mut DWORD,
            pdwWinInetError: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
    pub SetCacheExtension2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWinInetCacheHints2,
            pwzExt: LPCWSTR,
            pwzCacheFile: *mut WCHAR,
            pcchCacheFile: *mut DWORD,
            pdwWinInetError: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetCacheHints2Vtbl"][::std::mem::size_of::<IWinInetCacheHints2Vtbl>() - 40usize];
    ["Alignment of IWinInetCacheHints2Vtbl"]
        [::std::mem::align_of::<IWinInetCacheHints2Vtbl>() - 8usize];
    ["Offset of field: IWinInetCacheHints2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IWinInetCacheHints2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IWinInetCacheHints2Vtbl::AddRef"]
        [::std::mem::offset_of!(IWinInetCacheHints2Vtbl, AddRef) - 8usize];
    ["Offset of field: IWinInetCacheHints2Vtbl::Release"]
        [::std::mem::offset_of!(IWinInetCacheHints2Vtbl, Release) - 16usize];
    ["Offset of field: IWinInetCacheHints2Vtbl::SetCacheExtension"]
        [::std::mem::offset_of!(IWinInetCacheHints2Vtbl, SetCacheExtension) - 24usize];
    ["Offset of field: IWinInetCacheHints2Vtbl::SetCacheExtension2"]
        [::std::mem::offset_of!(IWinInetCacheHints2Vtbl, SetCacheExtension2) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWinInetCacheHints2 {
    pub lpVtbl: *mut IWinInetCacheHints2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWinInetCacheHints2"][::std::mem::size_of::<IWinInetCacheHints2>() - 8usize];
    ["Alignment of IWinInetCacheHints2"][::std::mem::align_of::<IWinInetCacheHints2>() - 8usize];
    ["Offset of field: IWinInetCacheHints2::lpVtbl"]
        [::std::mem::offset_of!(IWinInetCacheHints2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static SID_BindHost: GUID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0024_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0024_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDHOST = *mut IBindHost;
unsafe extern "C" {
    pub static IID_IBindHost: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindHostVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHost,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindHost) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindHost) -> ULONG>,
    pub CreateMoniker: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHost,
            szName: LPOLESTR,
            pBC: *mut IBindCtx,
            ppmk: *mut *mut IMoniker,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub MonikerBindToStorage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHost,
            pMk: *mut IMoniker,
            pBC: *mut IBindCtx,
            pBSC: *mut IBindStatusCallback,
            riid: *const IID,
            ppvObj: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub MonikerBindToObject: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHost,
            pMk: *mut IMoniker,
            pBC: *mut IBindCtx,
            pBSC: *mut IBindStatusCallback,
            riid: *const IID,
            ppvObj: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindHostVtbl"][::std::mem::size_of::<IBindHostVtbl>() - 48usize];
    ["Alignment of IBindHostVtbl"][::std::mem::align_of::<IBindHostVtbl>() - 8usize];
    ["Offset of field: IBindHostVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindHostVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindHostVtbl::AddRef"]
        [::std::mem::offset_of!(IBindHostVtbl, AddRef) - 8usize];
    ["Offset of field: IBindHostVtbl::Release"]
        [::std::mem::offset_of!(IBindHostVtbl, Release) - 16usize];
    ["Offset of field: IBindHostVtbl::CreateMoniker"]
        [::std::mem::offset_of!(IBindHostVtbl, CreateMoniker) - 24usize];
    ["Offset of field: IBindHostVtbl::MonikerBindToStorage"]
        [::std::mem::offset_of!(IBindHostVtbl, MonikerBindToStorage) - 32usize];
    ["Offset of field: IBindHostVtbl::MonikerBindToObject"]
        [::std::mem::offset_of!(IBindHostVtbl, MonikerBindToObject) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindHost {
    pub lpVtbl: *mut IBindHostVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindHost"][::std::mem::size_of::<IBindHost>() - 8usize];
    ["Alignment of IBindHost"][::std::mem::align_of::<IBindHost>() - 8usize];
    ["Offset of field: IBindHost::lpVtbl"][::std::mem::offset_of!(IBindHost, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IBindHost_RemoteMonikerBindToStorage_Proxy(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_RemoteMonikerBindToStorage_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn IBindHost_RemoteMonikerBindToObject_Proxy(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_RemoteMonikerBindToObject_Stub(
        This: *mut IRpcStubBuffer,
        _pRpcChannelBuffer: *mut IRpcChannelBuffer,
        _pRpcMessage: PRPC_MESSAGE,
        _pdwStubPhase: *mut DWORD,
    );
}
unsafe extern "C" {
    pub fn HlinkSimpleNavigateToString(
        szTarget: LPCWSTR,
        szLocation: LPCWSTR,
        szTargetFrameName: LPCWSTR,
        pUnk: *mut IUnknown,
        pbc: *mut IBindCtx,
        arg1: *mut IBindStatusCallback,
        grfHLNF: DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn HlinkSimpleNavigateToMoniker(
        pmkTarget: *mut IMoniker,
        szLocation: LPCWSTR,
        szTargetFrameName: LPCWSTR,
        pUnk: *mut IUnknown,
        pbc: *mut IBindCtx,
        arg1: *mut IBindStatusCallback,
        grfHLNF: DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenStreamA(
        arg1: LPUNKNOWN,
        arg2: LPCSTR,
        arg3: DWORD,
        arg4: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenStreamW(
        arg1: LPUNKNOWN,
        arg2: LPCWSTR,
        arg3: DWORD,
        arg4: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenPullStreamA(
        arg1: LPUNKNOWN,
        arg2: LPCSTR,
        arg3: DWORD,
        arg4: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenPullStreamW(
        arg1: LPUNKNOWN,
        arg2: LPCWSTR,
        arg3: DWORD,
        arg4: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLDownloadToFileA(
        arg1: LPUNKNOWN,
        arg2: LPCSTR,
        arg3: LPCSTR,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLDownloadToFileW(
        arg1: LPUNKNOWN,
        arg2: LPCWSTR,
        arg3: LPCWSTR,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLDownloadToCacheFileA(
        arg1: LPUNKNOWN,
        arg2: LPCSTR,
        arg3: LPSTR,
        cchFileName: DWORD,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLDownloadToCacheFileW(
        arg1: LPUNKNOWN,
        arg2: LPCWSTR,
        arg3: LPWSTR,
        cchFileName: DWORD,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenBlockingStreamA(
        arg1: LPUNKNOWN,
        arg2: LPCSTR,
        arg3: *mut LPSTREAM,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn URLOpenBlockingStreamW(
        arg1: LPUNKNOWN,
        arg2: LPCWSTR,
        arg3: *mut LPSTREAM,
        arg4: DWORD,
        arg5: LPBINDSTATUSCALLBACK,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn HlinkGoBack(pUnk: *mut IUnknown) -> HRESULT;
}
unsafe extern "C" {
    pub fn HlinkGoForward(pUnk: *mut IUnknown) -> HRESULT;
}
unsafe extern "C" {
    pub fn HlinkNavigateString(pUnk: *mut IUnknown, szTarget: LPCWSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn HlinkNavigateMoniker(pUnk: *mut IUnknown, pmkTarget: *mut IMoniker) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0025_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0025_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNET = *mut IInternet;
unsafe extern "C" {
    pub static IID_IInternet: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternet,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternet) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternet) -> ULONG>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetVtbl"][::std::mem::size_of::<IInternetVtbl>() - 24usize];
    ["Alignment of IInternetVtbl"][::std::mem::align_of::<IInternetVtbl>() - 8usize];
    ["Offset of field: IInternetVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetVtbl::Release"]
        [::std::mem::offset_of!(IInternetVtbl, Release) - 16usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternet {
    pub lpVtbl: *mut IInternetVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternet"][::std::mem::size_of::<IInternet>() - 8usize];
    ["Alignment of IInternet"][::std::mem::align_of::<IInternet>() - 8usize];
    ["Offset of field: IInternet::lpVtbl"][::std::mem::offset_of!(IInternet, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0026_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0026_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETBINDINFO = *mut IInternetBindInfo;
pub const tagBINDSTRING_BINDSTRING_HEADERS: tagBINDSTRING = 1;
pub const tagBINDSTRING_BINDSTRING_ACCEPT_MIMES: tagBINDSTRING = 2;
pub const tagBINDSTRING_BINDSTRING_EXTRA_URL: tagBINDSTRING = 3;
pub const tagBINDSTRING_BINDSTRING_LANGUAGE: tagBINDSTRING = 4;
pub const tagBINDSTRING_BINDSTRING_USERNAME: tagBINDSTRING = 5;
pub const tagBINDSTRING_BINDSTRING_PASSWORD: tagBINDSTRING = 6;
pub const tagBINDSTRING_BINDSTRING_UA_PIXELS: tagBINDSTRING = 7;
pub const tagBINDSTRING_BINDSTRING_UA_COLOR: tagBINDSTRING = 8;
pub const tagBINDSTRING_BINDSTRING_OS: tagBINDSTRING = 9;
pub const tagBINDSTRING_BINDSTRING_USER_AGENT: tagBINDSTRING = 10;
pub const tagBINDSTRING_BINDSTRING_ACCEPT_ENCODINGS: tagBINDSTRING = 11;
pub const tagBINDSTRING_BINDSTRING_POST_COOKIE: tagBINDSTRING = 12;
pub const tagBINDSTRING_BINDSTRING_POST_DATA_MIME: tagBINDSTRING = 13;
pub const tagBINDSTRING_BINDSTRING_URL: tagBINDSTRING = 14;
pub const tagBINDSTRING_BINDSTRING_IID: tagBINDSTRING = 15;
pub const tagBINDSTRING_BINDSTRING_FLAG_BIND_TO_OBJECT: tagBINDSTRING = 16;
pub const tagBINDSTRING_BINDSTRING_PTR_BIND_CONTEXT: tagBINDSTRING = 17;
pub const tagBINDSTRING_BINDSTRING_XDR_ORIGIN: tagBINDSTRING = 18;
pub const tagBINDSTRING_BINDSTRING_DOWNLOADPATH: tagBINDSTRING = 19;
pub const tagBINDSTRING_BINDSTRING_ROOTDOC_URL: tagBINDSTRING = 20;
pub const tagBINDSTRING_BINDSTRING_INITIAL_FILENAME: tagBINDSTRING = 21;
pub const tagBINDSTRING_BINDSTRING_PROXY_USERNAME: tagBINDSTRING = 22;
pub const tagBINDSTRING_BINDSTRING_PROXY_PASSWORD: tagBINDSTRING = 23;
pub const tagBINDSTRING_BINDSTRING_ENTERPRISE_ID: tagBINDSTRING = 24;
pub const tagBINDSTRING_BINDSTRING_DOC_URL: tagBINDSTRING = 25;
pub const tagBINDSTRING_BINDSTRING_SAMESITE_COOKIE_LEVEL: tagBINDSTRING = 26;
pub type tagBINDSTRING = ::std::os::raw::c_int;
pub use self::tagBINDSTRING as BINDSTRING;
unsafe extern "C" {
    pub static IID_IInternetBindInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetBindInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetBindInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetBindInfo) -> ULONG>,
    pub GetBindInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfo,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
        ) -> HRESULT,
    >,
    pub GetBindString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfo,
            ulStringType: ULONG,
            ppwzStr: *mut LPOLESTR,
            cEl: ULONG,
            pcElFetched: *mut ULONG,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetBindInfoVtbl"][::std::mem::size_of::<IInternetBindInfoVtbl>() - 40usize];
    ["Alignment of IInternetBindInfoVtbl"]
        [::std::mem::align_of::<IInternetBindInfoVtbl>() - 8usize];
    ["Offset of field: IInternetBindInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetBindInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetBindInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetBindInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetBindInfoVtbl::Release"]
        [::std::mem::offset_of!(IInternetBindInfoVtbl, Release) - 16usize];
    ["Offset of field: IInternetBindInfoVtbl::GetBindInfo"]
        [::std::mem::offset_of!(IInternetBindInfoVtbl, GetBindInfo) - 24usize];
    ["Offset of field: IInternetBindInfoVtbl::GetBindString"]
        [::std::mem::offset_of!(IInternetBindInfoVtbl, GetBindString) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetBindInfo {
    pub lpVtbl: *mut IInternetBindInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetBindInfo"][::std::mem::size_of::<IInternetBindInfo>() - 8usize];
    ["Alignment of IInternetBindInfo"][::std::mem::align_of::<IInternetBindInfo>() - 8usize];
    ["Offset of field: IInternetBindInfo::lpVtbl"]
        [::std::mem::offset_of!(IInternetBindInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0027_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0027_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETBINDINFOEX = *mut IInternetBindInfoEx;
unsafe extern "C" {
    pub static IID_IInternetBindInfoEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetBindInfoExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfoEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetBindInfoEx) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetBindInfoEx) -> ULONG>,
    pub GetBindInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfoEx,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
        ) -> HRESULT,
    >,
    pub GetBindString: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfoEx,
            ulStringType: ULONG,
            ppwzStr: *mut LPOLESTR,
            cEl: ULONG,
            pcElFetched: *mut ULONG,
        ) -> HRESULT,
    >,
    pub GetBindInfoEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetBindInfoEx,
            grfBINDF: *mut DWORD,
            pbindinfo: *mut BINDINFO,
            grfBINDF2: *mut DWORD,
            pdwReserved: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetBindInfoExVtbl"][::std::mem::size_of::<IInternetBindInfoExVtbl>() - 48usize];
    ["Alignment of IInternetBindInfoExVtbl"]
        [::std::mem::align_of::<IInternetBindInfoExVtbl>() - 8usize];
    ["Offset of field: IInternetBindInfoExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetBindInfoExVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetBindInfoExVtbl::Release"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, Release) - 16usize];
    ["Offset of field: IInternetBindInfoExVtbl::GetBindInfo"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, GetBindInfo) - 24usize];
    ["Offset of field: IInternetBindInfoExVtbl::GetBindString"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, GetBindString) - 32usize];
    ["Offset of field: IInternetBindInfoExVtbl::GetBindInfoEx"]
        [::std::mem::offset_of!(IInternetBindInfoExVtbl, GetBindInfoEx) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetBindInfoEx {
    pub lpVtbl: *mut IInternetBindInfoExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetBindInfoEx"][::std::mem::size_of::<IInternetBindInfoEx>() - 8usize];
    ["Alignment of IInternetBindInfoEx"][::std::mem::align_of::<IInternetBindInfoEx>() - 8usize];
    ["Offset of field: IInternetBindInfoEx::lpVtbl"]
        [::std::mem::offset_of!(IInternetBindInfoEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0028_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0028_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPROTOCOLROOT = *mut IInternetProtocolRoot;
pub const _tagPI_FLAGS_PI_PARSE_URL: _tagPI_FLAGS = 1;
pub const _tagPI_FLAGS_PI_FILTER_MODE: _tagPI_FLAGS = 2;
pub const _tagPI_FLAGS_PI_FORCE_ASYNC: _tagPI_FLAGS = 4;
pub const _tagPI_FLAGS_PI_USE_WORKERTHREAD: _tagPI_FLAGS = 8;
pub const _tagPI_FLAGS_PI_MIMEVERIFICATION: _tagPI_FLAGS = 16;
pub const _tagPI_FLAGS_PI_CLSIDLOOKUP: _tagPI_FLAGS = 32;
pub const _tagPI_FLAGS_PI_DATAPROGRESS: _tagPI_FLAGS = 64;
pub const _tagPI_FLAGS_PI_SYNCHRONOUS: _tagPI_FLAGS = 128;
pub const _tagPI_FLAGS_PI_APARTMENTTHREADED: _tagPI_FLAGS = 256;
pub const _tagPI_FLAGS_PI_CLASSINSTALL: _tagPI_FLAGS = 512;
pub const _tagPI_FLAGS_PI_PASSONBINDCTX: _tagPI_FLAGS = 8192;
pub const _tagPI_FLAGS_PI_NOMIMEHANDLER: _tagPI_FLAGS = 32768;
pub const _tagPI_FLAGS_PI_LOADAPPDIRECT: _tagPI_FLAGS = 16384;
pub const _tagPI_FLAGS_PD_FORCE_SWITCH: _tagPI_FLAGS = 65536;
pub const _tagPI_FLAGS_PI_PREFERDEFAULTHANDLER: _tagPI_FLAGS = 131072;
pub type _tagPI_FLAGS = ::std::os::raw::c_int;
pub use self::_tagPI_FLAGS as PI_FLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagPROTOCOLDATA {
    pub grfFlags: DWORD,
    pub dwState: DWORD,
    pub pData: LPVOID,
    pub cbData: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagPROTOCOLDATA"][::std::mem::size_of::<_tagPROTOCOLDATA>() - 24usize];
    ["Alignment of _tagPROTOCOLDATA"][::std::mem::align_of::<_tagPROTOCOLDATA>() - 8usize];
    ["Offset of field: _tagPROTOCOLDATA::grfFlags"]
        [::std::mem::offset_of!(_tagPROTOCOLDATA, grfFlags) - 0usize];
    ["Offset of field: _tagPROTOCOLDATA::dwState"]
        [::std::mem::offset_of!(_tagPROTOCOLDATA, dwState) - 4usize];
    ["Offset of field: _tagPROTOCOLDATA::pData"]
        [::std::mem::offset_of!(_tagPROTOCOLDATA, pData) - 8usize];
    ["Offset of field: _tagPROTOCOLDATA::cbData"]
        [::std::mem::offset_of!(_tagPROTOCOLDATA, cbData) - 16usize];
};
pub type PROTOCOLDATA = _tagPROTOCOLDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagStartParam {
    pub iid: IID,
    pub pIBindCtx: *mut IBindCtx,
    pub pItf: *mut IUnknown,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagStartParam"][::std::mem::size_of::<_tagStartParam>() - 32usize];
    ["Alignment of _tagStartParam"][::std::mem::align_of::<_tagStartParam>() - 8usize];
    ["Offset of field: _tagStartParam::iid"][::std::mem::offset_of!(_tagStartParam, iid) - 0usize];
    ["Offset of field: _tagStartParam::pIBindCtx"]
        [::std::mem::offset_of!(_tagStartParam, pIBindCtx) - 16usize];
    ["Offset of field: _tagStartParam::pItf"]
        [::std::mem::offset_of!(_tagStartParam, pItf) - 24usize];
};
pub type StartParam = _tagStartParam;
unsafe extern "C" {
    pub static IID_IInternetProtocolRoot: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolRootVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolRoot,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolRoot) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolRoot) -> ULONG>,
    pub Start: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolRoot,
            szUrl: LPCWSTR,
            pOIProtSink: *mut IInternetProtocolSink,
            pOIBindInfo: *mut IInternetBindInfo,
            grfPI: DWORD,
            dwReserved: HANDLE_PTR,
        ) -> HRESULT,
    >,
    pub Continue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolRoot,
            pProtocolData: *mut PROTOCOLDATA,
        ) -> HRESULT,
    >,
    pub Abort: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolRoot,
            hrReason: HRESULT,
            dwOptions: DWORD,
        ) -> HRESULT,
    >,
    pub Terminate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolRoot, dwOptions: DWORD) -> HRESULT,
    >,
    pub Suspend:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolRoot) -> HRESULT>,
    pub Resume:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolRoot) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolRootVtbl"]
        [::std::mem::size_of::<IInternetProtocolRootVtbl>() - 72usize];
    ["Alignment of IInternetProtocolRootVtbl"]
        [::std::mem::align_of::<IInternetProtocolRootVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolRootVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolRootVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolRootVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolRootVtbl::Start"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Start) - 24usize];
    ["Offset of field: IInternetProtocolRootVtbl::Continue"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Continue) - 32usize];
    ["Offset of field: IInternetProtocolRootVtbl::Abort"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Abort) - 40usize];
    ["Offset of field: IInternetProtocolRootVtbl::Terminate"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Terminate) - 48usize];
    ["Offset of field: IInternetProtocolRootVtbl::Suspend"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Suspend) - 56usize];
    ["Offset of field: IInternetProtocolRootVtbl::Resume"]
        [::std::mem::offset_of!(IInternetProtocolRootVtbl, Resume) - 64usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolRoot {
    pub lpVtbl: *mut IInternetProtocolRootVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolRoot"][::std::mem::size_of::<IInternetProtocolRoot>() - 8usize];
    ["Alignment of IInternetProtocolRoot"]
        [::std::mem::align_of::<IInternetProtocolRoot>() - 8usize];
    ["Offset of field: IInternetProtocolRoot::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocolRoot, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0029_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0029_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPROTOCOL = *mut IInternetProtocol;
unsafe extern "C" {
    pub static IID_IInternetProtocol: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocol) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocol) -> ULONG>,
    pub Start: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            szUrl: LPCWSTR,
            pOIProtSink: *mut IInternetProtocolSink,
            pOIBindInfo: *mut IInternetBindInfo,
            grfPI: DWORD,
            dwReserved: HANDLE_PTR,
        ) -> HRESULT,
    >,
    pub Continue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            pProtocolData: *mut PROTOCOLDATA,
        ) -> HRESULT,
    >,
    pub Abort: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            hrReason: HRESULT,
            dwOptions: DWORD,
        ) -> HRESULT,
    >,
    pub Terminate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocol, dwOptions: DWORD) -> HRESULT,
    >,
    pub Suspend:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocol) -> HRESULT>,
    pub Resume:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocol) -> HRESULT>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Seek: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocol,
            dlibMove: LARGE_INTEGER,
            dwOrigin: DWORD,
            plibNewPosition: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub LockRequest: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocol, dwOptions: DWORD) -> HRESULT,
    >,
    pub UnlockRequest:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocol) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolVtbl"][::std::mem::size_of::<IInternetProtocolVtbl>() - 104usize];
    ["Alignment of IInternetProtocolVtbl"]
        [::std::mem::align_of::<IInternetProtocolVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolVtbl::Start"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Start) - 24usize];
    ["Offset of field: IInternetProtocolVtbl::Continue"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Continue) - 32usize];
    ["Offset of field: IInternetProtocolVtbl::Abort"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Abort) - 40usize];
    ["Offset of field: IInternetProtocolVtbl::Terminate"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Terminate) - 48usize];
    ["Offset of field: IInternetProtocolVtbl::Suspend"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Suspend) - 56usize];
    ["Offset of field: IInternetProtocolVtbl::Resume"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Resume) - 64usize];
    ["Offset of field: IInternetProtocolVtbl::Read"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Read) - 72usize];
    ["Offset of field: IInternetProtocolVtbl::Seek"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, Seek) - 80usize];
    ["Offset of field: IInternetProtocolVtbl::LockRequest"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, LockRequest) - 88usize];
    ["Offset of field: IInternetProtocolVtbl::UnlockRequest"]
        [::std::mem::offset_of!(IInternetProtocolVtbl, UnlockRequest) - 96usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocol {
    pub lpVtbl: *mut IInternetProtocolVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocol"][::std::mem::size_of::<IInternetProtocol>() - 8usize];
    ["Alignment of IInternetProtocol"][::std::mem::align_of::<IInternetProtocol>() - 8usize];
    ["Offset of field: IInternetProtocol::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocol, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0030_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0030_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetProtocolEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolEx) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolEx) -> ULONG>,
    pub Start: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            szUrl: LPCWSTR,
            pOIProtSink: *mut IInternetProtocolSink,
            pOIBindInfo: *mut IInternetBindInfo,
            grfPI: DWORD,
            dwReserved: HANDLE_PTR,
        ) -> HRESULT,
    >,
    pub Continue: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            pProtocolData: *mut PROTOCOLDATA,
        ) -> HRESULT,
    >,
    pub Abort: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            hrReason: HRESULT,
            dwOptions: DWORD,
        ) -> HRESULT,
    >,
    pub Terminate: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolEx, dwOptions: DWORD) -> HRESULT,
    >,
    pub Suspend:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolEx) -> HRESULT>,
    pub Resume:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolEx) -> HRESULT>,
    pub Read: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            pv: *mut ::std::os::raw::c_void,
            cb: ULONG,
            pcbRead: *mut ULONG,
        ) -> HRESULT,
    >,
    pub Seek: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            dlibMove: LARGE_INTEGER,
            dwOrigin: DWORD,
            plibNewPosition: *mut ULARGE_INTEGER,
        ) -> HRESULT,
    >,
    pub LockRequest: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolEx, dwOptions: DWORD) -> HRESULT,
    >,
    pub UnlockRequest:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolEx) -> HRESULT>,
    pub StartEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolEx,
            pUri: *mut IUri,
            pOIProtSink: *mut IInternetProtocolSink,
            pOIBindInfo: *mut IInternetBindInfo,
            grfPI: DWORD,
            dwReserved: HANDLE_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolExVtbl"]
        [::std::mem::size_of::<IInternetProtocolExVtbl>() - 112usize];
    ["Alignment of IInternetProtocolExVtbl"]
        [::std::mem::align_of::<IInternetProtocolExVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolExVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolExVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolExVtbl::Start"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Start) - 24usize];
    ["Offset of field: IInternetProtocolExVtbl::Continue"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Continue) - 32usize];
    ["Offset of field: IInternetProtocolExVtbl::Abort"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Abort) - 40usize];
    ["Offset of field: IInternetProtocolExVtbl::Terminate"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Terminate) - 48usize];
    ["Offset of field: IInternetProtocolExVtbl::Suspend"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Suspend) - 56usize];
    ["Offset of field: IInternetProtocolExVtbl::Resume"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Resume) - 64usize];
    ["Offset of field: IInternetProtocolExVtbl::Read"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Read) - 72usize];
    ["Offset of field: IInternetProtocolExVtbl::Seek"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, Seek) - 80usize];
    ["Offset of field: IInternetProtocolExVtbl::LockRequest"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, LockRequest) - 88usize];
    ["Offset of field: IInternetProtocolExVtbl::UnlockRequest"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, UnlockRequest) - 96usize];
    ["Offset of field: IInternetProtocolExVtbl::StartEx"]
        [::std::mem::offset_of!(IInternetProtocolExVtbl, StartEx) - 104usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolEx {
    pub lpVtbl: *mut IInternetProtocolExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolEx"][::std::mem::size_of::<IInternetProtocolEx>() - 8usize];
    ["Alignment of IInternetProtocolEx"][::std::mem::align_of::<IInternetProtocolEx>() - 8usize];
    ["Offset of field: IInternetProtocolEx::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocolEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0031_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0031_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPROTOCOLSINK = *mut IInternetProtocolSink;
unsafe extern "C" {
    pub static IID_IInternetProtocolSink: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolSinkVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSink,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolSink) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolSink) -> ULONG>,
    pub Switch: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSink,
            pProtocolData: *mut PROTOCOLDATA,
        ) -> HRESULT,
    >,
    pub ReportProgress: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSink,
            ulStatusCode: ULONG,
            szStatusText: LPCWSTR,
        ) -> HRESULT,
    >,
    pub ReportData: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSink,
            grfBSCF: DWORD,
            ulProgress: ULONG,
            ulProgressMax: ULONG,
        ) -> HRESULT,
    >,
    pub ReportResult: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSink,
            hrResult: HRESULT,
            dwError: DWORD,
            szResult: LPCWSTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolSinkVtbl"]
        [::std::mem::size_of::<IInternetProtocolSinkVtbl>() - 56usize];
    ["Alignment of IInternetProtocolSinkVtbl"]
        [::std::mem::align_of::<IInternetProtocolSinkVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolSinkVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolSinkVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolSinkVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolSinkVtbl::Switch"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, Switch) - 24usize];
    ["Offset of field: IInternetProtocolSinkVtbl::ReportProgress"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, ReportProgress) - 32usize];
    ["Offset of field: IInternetProtocolSinkVtbl::ReportData"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, ReportData) - 40usize];
    ["Offset of field: IInternetProtocolSinkVtbl::ReportResult"]
        [::std::mem::offset_of!(IInternetProtocolSinkVtbl, ReportResult) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolSink {
    pub lpVtbl: *mut IInternetProtocolSinkVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolSink"][::std::mem::size_of::<IInternetProtocolSink>() - 8usize];
    ["Alignment of IInternetProtocolSink"]
        [::std::mem::align_of::<IInternetProtocolSink>() - 8usize];
    ["Offset of field: IInternetProtocolSink::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocolSink, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0032_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0032_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPROTOCOLSINKStackable = *mut IInternetProtocolSinkStackable;
unsafe extern "C" {
    pub static IID_IInternetProtocolSinkStackable: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolSinkStackableVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSinkStackable,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolSinkStackable) -> ULONG,
    >,
    pub Release: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolSinkStackable) -> ULONG,
    >,
    pub SwitchSink: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolSinkStackable,
            pOIProtSink: *mut IInternetProtocolSink,
        ) -> HRESULT,
    >,
    pub CommitSwitch: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolSinkStackable) -> HRESULT,
    >,
    pub RollbackSwitch: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetProtocolSinkStackable) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolSinkStackableVtbl"]
        [::std::mem::size_of::<IInternetProtocolSinkStackableVtbl>() - 48usize];
    ["Alignment of IInternetProtocolSinkStackableVtbl"]
        [::std::mem::align_of::<IInternetProtocolSinkStackableVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::SwitchSink"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, SwitchSink) - 24usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::CommitSwitch"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, CommitSwitch) - 32usize];
    ["Offset of field: IInternetProtocolSinkStackableVtbl::RollbackSwitch"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackableVtbl, RollbackSwitch) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolSinkStackable {
    pub lpVtbl: *mut IInternetProtocolSinkStackableVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolSinkStackable"]
        [::std::mem::size_of::<IInternetProtocolSinkStackable>() - 8usize];
    ["Alignment of IInternetProtocolSinkStackable"]
        [::std::mem::align_of::<IInternetProtocolSinkStackable>() - 8usize];
    ["Offset of field: IInternetProtocolSinkStackable::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocolSinkStackable, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0033_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0033_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETSESSION = *mut IInternetSession;
pub const _tagOIBDG_FLAGS_OIBDG_APARTMENTTHREADED: _tagOIBDG_FLAGS = 256;
pub const _tagOIBDG_FLAGS_OIBDG_DATAONLY: _tagOIBDG_FLAGS = 4096;
pub type _tagOIBDG_FLAGS = ::std::os::raw::c_int;
pub use self::_tagOIBDG_FLAGS as OIBDG_FLAGS;
unsafe extern "C" {
    pub static IID_IInternetSession: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSessionVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSession) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSession) -> ULONG>,
    pub RegisterNameSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            pCF: *mut IClassFactory,
            rclsid: *const IID,
            pwzProtocol: LPCWSTR,
            cPatterns: ULONG,
            ppwzPatterns: *const LPCWSTR,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub UnregisterNameSpace: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            pCF: *mut IClassFactory,
            pszProtocol: LPCWSTR,
        ) -> HRESULT,
    >,
    pub RegisterMimeFilter: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            pCF: *mut IClassFactory,
            rclsid: *const IID,
            pwzType: LPCWSTR,
        ) -> HRESULT,
    >,
    pub UnregisterMimeFilter: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            pCF: *mut IClassFactory,
            pwzType: LPCWSTR,
        ) -> HRESULT,
    >,
    pub CreateBinding: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            pBC: LPBC,
            szUrl: LPCWSTR,
            pUnkOuter: *mut IUnknown,
            ppUnk: *mut *mut IUnknown,
            ppOInetProt: *mut *mut IInternetProtocol,
            dwOption: DWORD,
        ) -> HRESULT,
    >,
    pub SetSessionOption: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            dwOption: DWORD,
            pBuffer: LPVOID,
            dwBufferLength: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub GetSessionOption: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSession,
            dwOption: DWORD,
            pBuffer: LPVOID,
            pdwBufferLength: *mut DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSessionVtbl"][::std::mem::size_of::<IInternetSessionVtbl>() - 80usize];
    ["Alignment of IInternetSessionVtbl"][::std::mem::align_of::<IInternetSessionVtbl>() - 8usize];
    ["Offset of field: IInternetSessionVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetSessionVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetSessionVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetSessionVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetSessionVtbl::Release"]
        [::std::mem::offset_of!(IInternetSessionVtbl, Release) - 16usize];
    ["Offset of field: IInternetSessionVtbl::RegisterNameSpace"]
        [::std::mem::offset_of!(IInternetSessionVtbl, RegisterNameSpace) - 24usize];
    ["Offset of field: IInternetSessionVtbl::UnregisterNameSpace"]
        [::std::mem::offset_of!(IInternetSessionVtbl, UnregisterNameSpace) - 32usize];
    ["Offset of field: IInternetSessionVtbl::RegisterMimeFilter"]
        [::std::mem::offset_of!(IInternetSessionVtbl, RegisterMimeFilter) - 40usize];
    ["Offset of field: IInternetSessionVtbl::UnregisterMimeFilter"]
        [::std::mem::offset_of!(IInternetSessionVtbl, UnregisterMimeFilter) - 48usize];
    ["Offset of field: IInternetSessionVtbl::CreateBinding"]
        [::std::mem::offset_of!(IInternetSessionVtbl, CreateBinding) - 56usize];
    ["Offset of field: IInternetSessionVtbl::SetSessionOption"]
        [::std::mem::offset_of!(IInternetSessionVtbl, SetSessionOption) - 64usize];
    ["Offset of field: IInternetSessionVtbl::GetSessionOption"]
        [::std::mem::offset_of!(IInternetSessionVtbl, GetSessionOption) - 72usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSession {
    pub lpVtbl: *mut IInternetSessionVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSession"][::std::mem::size_of::<IInternetSession>() - 8usize];
    ["Alignment of IInternetSession"][::std::mem::align_of::<IInternetSession>() - 8usize];
    ["Offset of field: IInternetSession::lpVtbl"]
        [::std::mem::offset_of!(IInternetSession, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0034_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0034_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETTHREADSWITCH = *mut IInternetThreadSwitch;
unsafe extern "C" {
    pub static IID_IInternetThreadSwitch: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetThreadSwitchVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetThreadSwitch,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetThreadSwitch) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetThreadSwitch) -> ULONG>,
    pub Prepare:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetThreadSwitch) -> HRESULT>,
    pub Continue:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetThreadSwitch) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetThreadSwitchVtbl"]
        [::std::mem::size_of::<IInternetThreadSwitchVtbl>() - 40usize];
    ["Alignment of IInternetThreadSwitchVtbl"]
        [::std::mem::align_of::<IInternetThreadSwitchVtbl>() - 8usize];
    ["Offset of field: IInternetThreadSwitchVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetThreadSwitchVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetThreadSwitchVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetThreadSwitchVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetThreadSwitchVtbl::Release"]
        [::std::mem::offset_of!(IInternetThreadSwitchVtbl, Release) - 16usize];
    ["Offset of field: IInternetThreadSwitchVtbl::Prepare"]
        [::std::mem::offset_of!(IInternetThreadSwitchVtbl, Prepare) - 24usize];
    ["Offset of field: IInternetThreadSwitchVtbl::Continue"]
        [::std::mem::offset_of!(IInternetThreadSwitchVtbl, Continue) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetThreadSwitch {
    pub lpVtbl: *mut IInternetThreadSwitchVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetThreadSwitch"][::std::mem::size_of::<IInternetThreadSwitch>() - 8usize];
    ["Alignment of IInternetThreadSwitch"]
        [::std::mem::align_of::<IInternetThreadSwitch>() - 8usize];
    ["Offset of field: IInternetThreadSwitch::lpVtbl"]
        [::std::mem::offset_of!(IInternetThreadSwitch, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0035_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0035_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPRIORITY = *mut IInternetPriority;
unsafe extern "C" {
    pub static IID_IInternetPriority: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetPriorityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetPriority,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetPriority) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetPriority) -> ULONG>,
    pub SetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetPriority, nPriority: LONG) -> HRESULT,
    >,
    pub GetPriority: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetPriority, pnPriority: *mut LONG) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetPriorityVtbl"][::std::mem::size_of::<IInternetPriorityVtbl>() - 40usize];
    ["Alignment of IInternetPriorityVtbl"]
        [::std::mem::align_of::<IInternetPriorityVtbl>() - 8usize];
    ["Offset of field: IInternetPriorityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetPriorityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetPriorityVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetPriorityVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetPriorityVtbl::Release"]
        [::std::mem::offset_of!(IInternetPriorityVtbl, Release) - 16usize];
    ["Offset of field: IInternetPriorityVtbl::SetPriority"]
        [::std::mem::offset_of!(IInternetPriorityVtbl, SetPriority) - 24usize];
    ["Offset of field: IInternetPriorityVtbl::GetPriority"]
        [::std::mem::offset_of!(IInternetPriorityVtbl, GetPriority) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetPriority {
    pub lpVtbl: *mut IInternetPriorityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetPriority"][::std::mem::size_of::<IInternetPriority>() - 8usize];
    ["Alignment of IInternetPriority"][::std::mem::align_of::<IInternetPriority>() - 8usize];
    ["Offset of field: IInternetPriority::lpVtbl"]
        [::std::mem::offset_of!(IInternetPriority, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0036_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0036_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIINTERNETPROTOCOLINFO = *mut IInternetProtocolInfo;
pub const _tagPARSEACTION_PARSE_CANONICALIZE: _tagPARSEACTION = 1;
pub const _tagPARSEACTION_PARSE_FRIENDLY: _tagPARSEACTION = 2;
pub const _tagPARSEACTION_PARSE_SECURITY_URL: _tagPARSEACTION = 3;
pub const _tagPARSEACTION_PARSE_ROOTDOCUMENT: _tagPARSEACTION = 4;
pub const _tagPARSEACTION_PARSE_DOCUMENT: _tagPARSEACTION = 5;
pub const _tagPARSEACTION_PARSE_ANCHOR: _tagPARSEACTION = 6;
pub const _tagPARSEACTION_PARSE_ENCODE_IS_UNESCAPE: _tagPARSEACTION = 7;
pub const _tagPARSEACTION_PARSE_DECODE_IS_ESCAPE: _tagPARSEACTION = 8;
pub const _tagPARSEACTION_PARSE_PATH_FROM_URL: _tagPARSEACTION = 9;
pub const _tagPARSEACTION_PARSE_URL_FROM_PATH: _tagPARSEACTION = 10;
pub const _tagPARSEACTION_PARSE_MIME: _tagPARSEACTION = 11;
pub const _tagPARSEACTION_PARSE_SERVER: _tagPARSEACTION = 12;
pub const _tagPARSEACTION_PARSE_SCHEMA: _tagPARSEACTION = 13;
pub const _tagPARSEACTION_PARSE_SITE: _tagPARSEACTION = 14;
pub const _tagPARSEACTION_PARSE_DOMAIN: _tagPARSEACTION = 15;
pub const _tagPARSEACTION_PARSE_LOCATION: _tagPARSEACTION = 16;
pub const _tagPARSEACTION_PARSE_SECURITY_DOMAIN: _tagPARSEACTION = 17;
pub const _tagPARSEACTION_PARSE_ESCAPE: _tagPARSEACTION = 18;
pub const _tagPARSEACTION_PARSE_UNESCAPE: _tagPARSEACTION = 19;
pub type _tagPARSEACTION = ::std::os::raw::c_int;
pub use self::_tagPARSEACTION as PARSEACTION;
pub const _tagPSUACTION_PSU_DEFAULT: _tagPSUACTION = 1;
pub const _tagPSUACTION_PSU_SECURITY_URL_ONLY: _tagPSUACTION = 2;
pub type _tagPSUACTION = ::std::os::raw::c_int;
pub use self::_tagPSUACTION as PSUACTION;
pub const _tagQUERYOPTION_QUERY_EXPIRATION_DATE: _tagQUERYOPTION = 1;
pub const _tagQUERYOPTION_QUERY_TIME_OF_LAST_CHANGE: _tagQUERYOPTION = 2;
pub const _tagQUERYOPTION_QUERY_CONTENT_ENCODING: _tagQUERYOPTION = 3;
pub const _tagQUERYOPTION_QUERY_CONTENT_TYPE: _tagQUERYOPTION = 4;
pub const _tagQUERYOPTION_QUERY_REFRESH: _tagQUERYOPTION = 5;
pub const _tagQUERYOPTION_QUERY_RECOMBINE: _tagQUERYOPTION = 6;
pub const _tagQUERYOPTION_QUERY_CAN_NAVIGATE: _tagQUERYOPTION = 7;
pub const _tagQUERYOPTION_QUERY_USES_NETWORK: _tagQUERYOPTION = 8;
pub const _tagQUERYOPTION_QUERY_IS_CACHED: _tagQUERYOPTION = 9;
pub const _tagQUERYOPTION_QUERY_IS_INSTALLEDENTRY: _tagQUERYOPTION = 10;
pub const _tagQUERYOPTION_QUERY_IS_CACHED_OR_MAPPED: _tagQUERYOPTION = 11;
pub const _tagQUERYOPTION_QUERY_USES_CACHE: _tagQUERYOPTION = 12;
pub const _tagQUERYOPTION_QUERY_IS_SECURE: _tagQUERYOPTION = 13;
pub const _tagQUERYOPTION_QUERY_IS_SAFE: _tagQUERYOPTION = 14;
pub const _tagQUERYOPTION_QUERY_USES_HISTORYFOLDER: _tagQUERYOPTION = 15;
pub const _tagQUERYOPTION_QUERY_IS_CACHED_AND_USABLE_OFFLINE: _tagQUERYOPTION = 16;
pub type _tagQUERYOPTION = ::std::os::raw::c_int;
pub use self::_tagQUERYOPTION as QUERYOPTION;
unsafe extern "C" {
    pub static IID_IInternetProtocolInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolInfo) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetProtocolInfo) -> ULONG>,
    pub ParseUrl: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolInfo,
            pwzUrl: LPCWSTR,
            ParseAction: PARSEACTION,
            dwParseFlags: DWORD,
            pwzResult: LPWSTR,
            cchResult: DWORD,
            pcchResult: *mut DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub CombineUrl: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolInfo,
            pwzBaseUrl: LPCWSTR,
            pwzRelativeUrl: LPCWSTR,
            dwCombineFlags: DWORD,
            pwzResult: LPWSTR,
            cchResult: DWORD,
            pcchResult: *mut DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub CompareUrl: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolInfo,
            pwzUrl1: LPCWSTR,
            pwzUrl2: LPCWSTR,
            dwCompareFlags: DWORD,
        ) -> HRESULT,
    >,
    pub QueryInfo: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetProtocolInfo,
            pwzUrl: LPCWSTR,
            OueryOption: QUERYOPTION,
            dwQueryFlags: DWORD,
            pBuffer: LPVOID,
            cbBuffer: DWORD,
            pcbBuf: *mut DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolInfoVtbl"]
        [::std::mem::size_of::<IInternetProtocolInfoVtbl>() - 56usize];
    ["Alignment of IInternetProtocolInfoVtbl"]
        [::std::mem::align_of::<IInternetProtocolInfoVtbl>() - 8usize];
    ["Offset of field: IInternetProtocolInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetProtocolInfoVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetProtocolInfoVtbl::Release"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, Release) - 16usize];
    ["Offset of field: IInternetProtocolInfoVtbl::ParseUrl"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, ParseUrl) - 24usize];
    ["Offset of field: IInternetProtocolInfoVtbl::CombineUrl"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, CombineUrl) - 32usize];
    ["Offset of field: IInternetProtocolInfoVtbl::CompareUrl"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, CompareUrl) - 40usize];
    ["Offset of field: IInternetProtocolInfoVtbl::QueryInfo"]
        [::std::mem::offset_of!(IInternetProtocolInfoVtbl, QueryInfo) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetProtocolInfo {
    pub lpVtbl: *mut IInternetProtocolInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetProtocolInfo"][::std::mem::size_of::<IInternetProtocolInfo>() - 8usize];
    ["Alignment of IInternetProtocolInfo"]
        [::std::mem::align_of::<IInternetProtocolInfo>() - 8usize];
    ["Offset of field: IInternetProtocolInfo::lpVtbl"]
        [::std::mem::offset_of!(IInternetProtocolInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn CoInternetParseUrl(
        pwzUrl: LPCWSTR,
        ParseAction: PARSEACTION,
        dwFlags: DWORD,
        pszResult: LPWSTR,
        cchResult: DWORD,
        pcchResult: *mut DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetParseIUri(
        pIUri: *mut IUri,
        ParseAction: PARSEACTION,
        dwFlags: DWORD,
        pwzResult: LPWSTR,
        cchResult: DWORD,
        pcchResult: *mut DWORD,
        dwReserved: DWORD_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetCombineUrl(
        pwzBaseUrl: LPCWSTR,
        pwzRelativeUrl: LPCWSTR,
        dwCombineFlags: DWORD,
        pszResult: LPWSTR,
        cchResult: DWORD,
        pcchResult: *mut DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetCombineUrlEx(
        pBaseUri: *mut IUri,
        pwzRelativeUrl: LPCWSTR,
        dwCombineFlags: DWORD,
        ppCombinedUri: *mut *mut IUri,
        dwReserved: DWORD_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetCombineIUri(
        pBaseUri: *mut IUri,
        pRelativeUri: *mut IUri,
        dwCombineFlags: DWORD,
        ppCombinedUri: *mut *mut IUri,
        dwReserved: DWORD_PTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetCompareUrl(pwzUrl1: LPCWSTR, pwzUrl2: LPCWSTR, dwFlags: DWORD) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetGetProtocolFlags(
        pwzUrl: LPCWSTR,
        pdwFlags: *mut DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetQueryInfo(
        pwzUrl: LPCWSTR,
        QueryOptions: QUERYOPTION,
        dwQueryFlags: DWORD,
        pvBuffer: LPVOID,
        cbBuffer: DWORD,
        pcbBuffer: *mut DWORD,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetGetSession(
        dwSessionMode: DWORD,
        ppIInternetSession: *mut *mut IInternetSession,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetGetSecurityUrl(
        pwszUrl: LPCWSTR,
        ppwszSecUrl: *mut LPWSTR,
        psuAction: PSUACTION,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn AsyncInstallDistributionUnit(
        szDistUnit: LPCWSTR,
        szTYPE: LPCWSTR,
        szExt: LPCWSTR,
        dwFileVersionMS: DWORD,
        dwFileVersionLS: DWORD,
        szURL: LPCWSTR,
        pbc: *mut IBindCtx,
        pvReserved: LPVOID,
        flags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetGetSecurityUrlEx(
        pUri: *mut IUri,
        ppSecUri: *mut *mut IUri,
        psuAction: PSUACTION,
        dwReserved: DWORD_PTR,
    ) -> HRESULT;
}
pub const _tagINTERNETFEATURELIST_FEATURE_OBJECT_CACHING: _tagINTERNETFEATURELIST = 0;
pub const _tagINTERNETFEATURELIST_FEATURE_ZONE_ELEVATION: _tagINTERNETFEATURELIST = 1;
pub const _tagINTERNETFEATURELIST_FEATURE_MIME_HANDLING: _tagINTERNETFEATURELIST = 2;
pub const _tagINTERNETFEATURELIST_FEATURE_MIME_SNIFFING: _tagINTERNETFEATURELIST = 3;
pub const _tagINTERNETFEATURELIST_FEATURE_WINDOW_RESTRICTIONS: _tagINTERNETFEATURELIST = 4;
pub const _tagINTERNETFEATURELIST_FEATURE_WEBOC_POPUPMANAGEMENT: _tagINTERNETFEATURELIST = 5;
pub const _tagINTERNETFEATURELIST_FEATURE_BEHAVIORS: _tagINTERNETFEATURELIST = 6;
pub const _tagINTERNETFEATURELIST_FEATURE_DISABLE_MK_PROTOCOL: _tagINTERNETFEATURELIST = 7;
pub const _tagINTERNETFEATURELIST_FEATURE_LOCALMACHINE_LOCKDOWN: _tagINTERNETFEATURELIST = 8;
pub const _tagINTERNETFEATURELIST_FEATURE_SECURITYBAND: _tagINTERNETFEATURELIST = 9;
pub const _tagINTERNETFEATURELIST_FEATURE_RESTRICT_ACTIVEXINSTALL: _tagINTERNETFEATURELIST = 10;
pub const _tagINTERNETFEATURELIST_FEATURE_VALIDATE_NAVIGATE_URL: _tagINTERNETFEATURELIST = 11;
pub const _tagINTERNETFEATURELIST_FEATURE_RESTRICT_FILEDOWNLOAD: _tagINTERNETFEATURELIST = 12;
pub const _tagINTERNETFEATURELIST_FEATURE_ADDON_MANAGEMENT: _tagINTERNETFEATURELIST = 13;
pub const _tagINTERNETFEATURELIST_FEATURE_PROTOCOL_LOCKDOWN: _tagINTERNETFEATURELIST = 14;
pub const _tagINTERNETFEATURELIST_FEATURE_HTTP_USERNAME_PASSWORD_DISABLE: _tagINTERNETFEATURELIST =
    15;
pub const _tagINTERNETFEATURELIST_FEATURE_SAFE_BINDTOOBJECT: _tagINTERNETFEATURELIST = 16;
pub const _tagINTERNETFEATURELIST_FEATURE_UNC_SAVEDFILECHECK: _tagINTERNETFEATURELIST = 17;
pub const _tagINTERNETFEATURELIST_FEATURE_GET_URL_DOM_FILEPATH_UNENCODED: _tagINTERNETFEATURELIST =
    18;
pub const _tagINTERNETFEATURELIST_FEATURE_TABBED_BROWSING: _tagINTERNETFEATURELIST = 19;
pub const _tagINTERNETFEATURELIST_FEATURE_SSLUX: _tagINTERNETFEATURELIST = 20;
pub const _tagINTERNETFEATURELIST_FEATURE_DISABLE_NAVIGATION_SOUNDS: _tagINTERNETFEATURELIST = 21;
pub const _tagINTERNETFEATURELIST_FEATURE_DISABLE_LEGACY_COMPRESSION: _tagINTERNETFEATURELIST = 22;
pub const _tagINTERNETFEATURELIST_FEATURE_FORCE_ADDR_AND_STATUS: _tagINTERNETFEATURELIST = 23;
pub const _tagINTERNETFEATURELIST_FEATURE_XMLHTTP: _tagINTERNETFEATURELIST = 24;
pub const _tagINTERNETFEATURELIST_FEATURE_DISABLE_TELNET_PROTOCOL: _tagINTERNETFEATURELIST = 25;
pub const _tagINTERNETFEATURELIST_FEATURE_FEEDS: _tagINTERNETFEATURELIST = 26;
pub const _tagINTERNETFEATURELIST_FEATURE_BLOCK_INPUT_PROMPTS: _tagINTERNETFEATURELIST = 27;
pub const _tagINTERNETFEATURELIST_FEATURE_ENTRY_COUNT: _tagINTERNETFEATURELIST = 28;
pub type _tagINTERNETFEATURELIST = ::std::os::raw::c_int;
pub use self::_tagINTERNETFEATURELIST as INTERNETFEATURELIST;
unsafe extern "C" {
    pub fn CoInternetSetFeatureEnabled(
        FeatureEntry: INTERNETFEATURELIST,
        dwFlags: DWORD,
        fEnable: BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetIsFeatureEnabled(FeatureEntry: INTERNETFEATURELIST, dwFlags: DWORD)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetIsFeatureEnabledForUrl(
        FeatureEntry: INTERNETFEATURELIST,
        dwFlags: DWORD,
        szURL: LPCWSTR,
        pSecMgr: *mut IInternetSecurityManager,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetIsFeatureEnabledForIUri(
        FeatureEntry: INTERNETFEATURELIST,
        dwFlags: DWORD,
        pIUri: *mut IUri,
        pSecMgr: *mut IInternetSecurityManagerEx2,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetIsFeatureZoneElevationEnabled(
        szFromURL: LPCWSTR,
        szToURL: LPCWSTR,
        pSecMgr: *mut IInternetSecurityManager,
        dwFlags: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CopyStgMedium(pcstgmedSrc: *const STGMEDIUM, pstgmedDest: *mut STGMEDIUM) -> HRESULT;
}
unsafe extern "C" {
    pub fn CopyBindInfo(pcbiSrc: *const BINDINFO, pbiDest: *mut BINDINFO) -> HRESULT;
}
unsafe extern "C" {
    pub fn ReleaseBindInfo(pbindinfo: *mut BINDINFO);
}
unsafe extern "C" {
    pub fn IEGetUserPrivateNamespaceName() -> PWSTR;
}
unsafe extern "C" {
    pub fn CoInternetCreateSecurityManager(
        pSP: *mut IServiceProvider,
        ppSM: *mut *mut IInternetSecurityManager,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CoInternetCreateZoneManager(
        pSP: *mut IServiceProvider,
        ppZM: *mut *mut IInternetZoneManager,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static CLSID_InternetSecurityManager: IID;
}
unsafe extern "C" {
    pub static CLSID_InternetZoneManager: IID;
}
unsafe extern "C" {
    pub static CLSID_PersistentZoneIdentifier: IID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0037_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0037_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetSecurityMgrSite: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityMgrSiteVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityMgrSite,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityMgrSite) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityMgrSite) -> ULONG>,
    pub GetWindow: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetSecurityMgrSite, phwnd: *mut HWND) -> HRESULT,
    >,
    pub EnableModeless: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetSecurityMgrSite, fEnable: BOOL) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityMgrSiteVtbl"]
        [::std::mem::size_of::<IInternetSecurityMgrSiteVtbl>() - 40usize];
    ["Alignment of IInternetSecurityMgrSiteVtbl"]
        [::std::mem::align_of::<IInternetSecurityMgrSiteVtbl>() - 8usize];
    ["Offset of field: IInternetSecurityMgrSiteVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetSecurityMgrSiteVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetSecurityMgrSiteVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetSecurityMgrSiteVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetSecurityMgrSiteVtbl::Release"]
        [::std::mem::offset_of!(IInternetSecurityMgrSiteVtbl, Release) - 16usize];
    ["Offset of field: IInternetSecurityMgrSiteVtbl::GetWindow"]
        [::std::mem::offset_of!(IInternetSecurityMgrSiteVtbl, GetWindow) - 24usize];
    ["Offset of field: IInternetSecurityMgrSiteVtbl::EnableModeless"]
        [::std::mem::offset_of!(IInternetSecurityMgrSiteVtbl, EnableModeless) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityMgrSite {
    pub lpVtbl: *mut IInternetSecurityMgrSiteVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityMgrSite"]
        [::std::mem::size_of::<IInternetSecurityMgrSite>() - 8usize];
    ["Alignment of IInternetSecurityMgrSite"]
        [::std::mem::align_of::<IInternetSecurityMgrSite>() - 8usize];
    ["Offset of field: IInternetSecurityMgrSite::lpVtbl"]
        [::std::mem::offset_of!(IInternetSecurityMgrSite, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0038_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0038_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub const __MIDL_IInternetSecurityManager_0001_PUAF_DEFAULT: __MIDL_IInternetSecurityManager_0001 =
    0;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_NOUI: __MIDL_IInternetSecurityManager_0001 = 1;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_ISFILE: __MIDL_IInternetSecurityManager_0001 =
    2;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_WARN_IF_DENIED:
    __MIDL_IInternetSecurityManager_0001 = 4;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_FORCEUI_FOREGROUND:
    __MIDL_IInternetSecurityManager_0001 = 8;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_CHECK_TIFS:
    __MIDL_IInternetSecurityManager_0001 = 16;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_DONTCHECKBOXINDIALOG:
    __MIDL_IInternetSecurityManager_0001 = 32;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_TRUSTED: __MIDL_IInternetSecurityManager_0001 =
    64;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_ACCEPT_WILDCARD_SCHEME:
    __MIDL_IInternetSecurityManager_0001 = 128;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_ENFORCERESTRICTED:
    __MIDL_IInternetSecurityManager_0001 = 256;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_NOSAVEDFILECHECK:
    __MIDL_IInternetSecurityManager_0001 = 512;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_REQUIRESAVEDFILECHECK:
    __MIDL_IInternetSecurityManager_0001 = 1024;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_DONT_USE_CACHE:
    __MIDL_IInternetSecurityManager_0001 = 4096;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_RESERVED1:
    __MIDL_IInternetSecurityManager_0001 = 8192;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_RESERVED2:
    __MIDL_IInternetSecurityManager_0001 = 16384;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_LMZ_UNLOCKED:
    __MIDL_IInternetSecurityManager_0001 = 65536;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_LMZ_LOCKED:
    __MIDL_IInternetSecurityManager_0001 = 131072;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_DEFAULTZONEPOL:
    __MIDL_IInternetSecurityManager_0001 = 262144;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_NPL_USE_LOCKED_IF_RESTRICTED:
    __MIDL_IInternetSecurityManager_0001 = 524288;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_NOUIIFLOCKED:
    __MIDL_IInternetSecurityManager_0001 = 1048576;
pub const __MIDL_IInternetSecurityManager_0001_PUAF_DRAGPROTOCOLCHECK:
    __MIDL_IInternetSecurityManager_0001 = 2097152;
pub type __MIDL_IInternetSecurityManager_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IInternetSecurityManager_0001 as PUAF;
pub const __MIDL_IInternetSecurityManager_0002_PUAFOUT_DEFAULT:
    __MIDL_IInternetSecurityManager_0002 = 0;
pub const __MIDL_IInternetSecurityManager_0002_PUAFOUT_ISLOCKZONEPOLICY:
    __MIDL_IInternetSecurityManager_0002 = 1;
pub type __MIDL_IInternetSecurityManager_0002 = ::std::os::raw::c_int;
pub use self::__MIDL_IInternetSecurityManager_0002 as PUAFOUT;
pub const __MIDL_IInternetSecurityManager_0003_SZM_CREATE: __MIDL_IInternetSecurityManager_0003 = 0;
pub const __MIDL_IInternetSecurityManager_0003_SZM_DELETE: __MIDL_IInternetSecurityManager_0003 = 1;
pub type __MIDL_IInternetSecurityManager_0003 = ::std::os::raw::c_int;
pub use self::__MIDL_IInternetSecurityManager_0003 as SZM_FLAGS;
unsafe extern "C" {
    pub static IID_IInternetSecurityManager: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManagerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityManager) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityManager) -> ULONG>,
    pub SetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            pSite: *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub GetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            ppSite: *mut *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub MapUrlToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            pwszUrl: LPCWSTR,
            pdwZone: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            pwszUrl: LPCWSTR,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub ProcessUrlAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            pwszUrl: LPCWSTR,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub QueryCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            pwszUrl: LPCWSTR,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub SetZoneMapping: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            dwZone: DWORD,
            lpszPattern: LPCWSTR,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneMappings: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManager,
            dwZone: DWORD,
            ppenumString: *mut *mut IEnumString,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManagerVtbl"]
        [::std::mem::size_of::<IInternetSecurityManagerVtbl>() - 88usize];
    ["Alignment of IInternetSecurityManagerVtbl"]
        [::std::mem::align_of::<IInternetSecurityManagerVtbl>() - 8usize];
    ["Offset of field: IInternetSecurityManagerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetSecurityManagerVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetSecurityManagerVtbl::Release"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, Release) - 16usize];
    ["Offset of field: IInternetSecurityManagerVtbl::SetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, SetSecuritySite) - 24usize];
    ["Offset of field: IInternetSecurityManagerVtbl::GetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, GetSecuritySite) - 32usize];
    ["Offset of field: IInternetSecurityManagerVtbl::MapUrlToZone"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, MapUrlToZone) - 40usize];
    ["Offset of field: IInternetSecurityManagerVtbl::GetSecurityId"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, GetSecurityId) - 48usize];
    ["Offset of field: IInternetSecurityManagerVtbl::ProcessUrlAction"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, ProcessUrlAction) - 56usize];
    ["Offset of field: IInternetSecurityManagerVtbl::QueryCustomPolicy"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, QueryCustomPolicy) - 64usize];
    ["Offset of field: IInternetSecurityManagerVtbl::SetZoneMapping"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, SetZoneMapping) - 72usize];
    ["Offset of field: IInternetSecurityManagerVtbl::GetZoneMappings"]
        [::std::mem::offset_of!(IInternetSecurityManagerVtbl, GetZoneMappings) - 80usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManager {
    pub lpVtbl: *mut IInternetSecurityManagerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManager"]
        [::std::mem::size_of::<IInternetSecurityManager>() - 8usize];
    ["Alignment of IInternetSecurityManager"]
        [::std::mem::align_of::<IInternetSecurityManager>() - 8usize];
    ["Offset of field: IInternetSecurityManager::lpVtbl"]
        [::std::mem::offset_of!(IInternetSecurityManager, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0039_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0039_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetSecurityManagerEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManagerExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityManagerEx) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetSecurityManagerEx) -> ULONG>,
    pub SetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pSite: *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub GetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            ppSite: *mut *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub MapUrlToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pwszUrl: LPCWSTR,
            pdwZone: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pwszUrl: LPCWSTR,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub ProcessUrlAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pwszUrl: LPCWSTR,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub QueryCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pwszUrl: LPCWSTR,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub SetZoneMapping: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            dwZone: DWORD,
            lpszPattern: LPCWSTR,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneMappings: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            dwZone: DWORD,
            ppenumString: *mut *mut IEnumString,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub ProcessUrlActionEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx,
            pwszUrl: LPCWSTR,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
            pdwOutFlags: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManagerExVtbl"]
        [::std::mem::size_of::<IInternetSecurityManagerExVtbl>() - 96usize];
    ["Alignment of IInternetSecurityManagerExVtbl"]
        [::std::mem::align_of::<IInternetSecurityManagerExVtbl>() - 8usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::Release"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, Release) - 16usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::SetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, SetSecuritySite) - 24usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::GetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, GetSecuritySite) - 32usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::MapUrlToZone"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, MapUrlToZone) - 40usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::GetSecurityId"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, GetSecurityId) - 48usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::ProcessUrlAction"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, ProcessUrlAction) - 56usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::QueryCustomPolicy"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, QueryCustomPolicy) - 64usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::SetZoneMapping"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, SetZoneMapping) - 72usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::GetZoneMappings"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, GetZoneMappings) - 80usize];
    ["Offset of field: IInternetSecurityManagerExVtbl::ProcessUrlActionEx"]
        [::std::mem::offset_of!(IInternetSecurityManagerExVtbl, ProcessUrlActionEx) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManagerEx {
    pub lpVtbl: *mut IInternetSecurityManagerExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManagerEx"]
        [::std::mem::size_of::<IInternetSecurityManagerEx>() - 8usize];
    ["Alignment of IInternetSecurityManagerEx"]
        [::std::mem::align_of::<IInternetSecurityManagerEx>() - 8usize];
    ["Offset of field: IInternetSecurityManagerEx::lpVtbl"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0040_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0040_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetSecurityManagerEx2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManagerEx2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetSecurityManagerEx2) -> ULONG,
    >,
    pub Release: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetSecurityManagerEx2) -> ULONG,
    >,
    pub SetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pSite: *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub GetSecuritySite: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            ppSite: *mut *mut IInternetSecurityMgrSite,
        ) -> HRESULT,
    >,
    pub MapUrlToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pwszUrl: LPCWSTR,
            pdwZone: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pwszUrl: LPCWSTR,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub ProcessUrlAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pwszUrl: LPCWSTR,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub QueryCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pwszUrl: LPCWSTR,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub SetZoneMapping: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            dwZone: DWORD,
            lpszPattern: LPCWSTR,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneMappings: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            dwZone: DWORD,
            ppenumString: *mut *mut IEnumString,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub ProcessUrlActionEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pwszUrl: LPCWSTR,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
            pdwOutFlags: *mut DWORD,
        ) -> HRESULT,
    >,
    pub MapUrlToZoneEx2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pUri: *mut IUri,
            pdwZone: *mut DWORD,
            dwFlags: DWORD,
            ppwszMappedUrl: *mut LPWSTR,
            pdwOutFlags: *mut DWORD,
        ) -> HRESULT,
    >,
    pub ProcessUrlActionEx2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pUri: *mut IUri,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD_PTR,
            pdwOutFlags: *mut DWORD,
        ) -> HRESULT,
    >,
    pub GetSecurityIdEx2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pUri: *mut IUri,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub QueryCustomPolicyEx2: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetSecurityManagerEx2,
            pUri: *mut IUri,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManagerEx2Vtbl"]
        [::std::mem::size_of::<IInternetSecurityManagerEx2Vtbl>() - 128usize];
    ["Alignment of IInternetSecurityManagerEx2Vtbl"]
        [::std::mem::align_of::<IInternetSecurityManagerEx2Vtbl>() - 8usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::AddRef"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, AddRef) - 8usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::Release"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, Release) - 16usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::SetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, SetSecuritySite) - 24usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::GetSecuritySite"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, GetSecuritySite) - 32usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::MapUrlToZone"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, MapUrlToZone) - 40usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::GetSecurityId"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, GetSecurityId) - 48usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::ProcessUrlAction"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, ProcessUrlAction) - 56usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::QueryCustomPolicy"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, QueryCustomPolicy) - 64usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::SetZoneMapping"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, SetZoneMapping) - 72usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::GetZoneMappings"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, GetZoneMappings) - 80usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::ProcessUrlActionEx"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, ProcessUrlActionEx) - 88usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::MapUrlToZoneEx2"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, MapUrlToZoneEx2) - 96usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::ProcessUrlActionEx2"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, ProcessUrlActionEx2) - 104usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::GetSecurityIdEx2"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, GetSecurityIdEx2) - 112usize];
    ["Offset of field: IInternetSecurityManagerEx2Vtbl::QueryCustomPolicyEx2"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2Vtbl, QueryCustomPolicyEx2) - 120usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetSecurityManagerEx2 {
    pub lpVtbl: *mut IInternetSecurityManagerEx2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetSecurityManagerEx2"]
        [::std::mem::size_of::<IInternetSecurityManagerEx2>() - 8usize];
    ["Alignment of IInternetSecurityManagerEx2"]
        [::std::mem::align_of::<IInternetSecurityManagerEx2>() - 8usize];
    ["Offset of field: IInternetSecurityManagerEx2::lpVtbl"]
        [::std::mem::offset_of!(IInternetSecurityManagerEx2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0041_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0041_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IZoneIdentifier: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IZoneIdentifierVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IZoneIdentifier,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier) -> ULONG>,
    pub GetId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier, pdwZone: *mut DWORD) -> HRESULT,
    >,
    pub SetId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier, dwZone: DWORD) -> HRESULT,
    >,
    pub Remove: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IZoneIdentifierVtbl"][::std::mem::size_of::<IZoneIdentifierVtbl>() - 48usize];
    ["Alignment of IZoneIdentifierVtbl"][::std::mem::align_of::<IZoneIdentifierVtbl>() - 8usize];
    ["Offset of field: IZoneIdentifierVtbl::QueryInterface"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, QueryInterface) - 0usize];
    ["Offset of field: IZoneIdentifierVtbl::AddRef"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, AddRef) - 8usize];
    ["Offset of field: IZoneIdentifierVtbl::Release"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, Release) - 16usize];
    ["Offset of field: IZoneIdentifierVtbl::GetId"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, GetId) - 24usize];
    ["Offset of field: IZoneIdentifierVtbl::SetId"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, SetId) - 32usize];
    ["Offset of field: IZoneIdentifierVtbl::Remove"]
        [::std::mem::offset_of!(IZoneIdentifierVtbl, Remove) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IZoneIdentifier {
    pub lpVtbl: *mut IZoneIdentifierVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IZoneIdentifier"][::std::mem::size_of::<IZoneIdentifier>() - 8usize];
    ["Alignment of IZoneIdentifier"][::std::mem::align_of::<IZoneIdentifier>() - 8usize];
    ["Offset of field: IZoneIdentifier::lpVtbl"]
        [::std::mem::offset_of!(IZoneIdentifier, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0042_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0042_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IZoneIdentifier2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IZoneIdentifier2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IZoneIdentifier2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier2) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier2) -> ULONG>,
    pub GetId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier2, pdwZone: *mut DWORD) -> HRESULT,
    >,
    pub SetId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier2, dwZone: DWORD) -> HRESULT,
    >,
    pub Remove: ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier2) -> HRESULT>,
    pub GetLastWriterPackageFamilyName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IZoneIdentifier2,
            packageFamilyName: *mut LPWSTR,
        ) -> HRESULT,
    >,
    pub SetLastWriterPackageFamilyName: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier2, packageFamilyName: LPCWSTR) -> HRESULT,
    >,
    pub RemoveLastWriterPackageFamilyName:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier2) -> HRESULT>,
    pub GetAppZoneId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier2, zone: *mut DWORD) -> HRESULT,
    >,
    pub SetAppZoneId: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IZoneIdentifier2, zone: DWORD) -> HRESULT,
    >,
    pub RemoveAppZoneId:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IZoneIdentifier2) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IZoneIdentifier2Vtbl"][::std::mem::size_of::<IZoneIdentifier2Vtbl>() - 96usize];
    ["Alignment of IZoneIdentifier2Vtbl"][::std::mem::align_of::<IZoneIdentifier2Vtbl>() - 8usize];
    ["Offset of field: IZoneIdentifier2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IZoneIdentifier2Vtbl::AddRef"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, AddRef) - 8usize];
    ["Offset of field: IZoneIdentifier2Vtbl::Release"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, Release) - 16usize];
    ["Offset of field: IZoneIdentifier2Vtbl::GetId"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, GetId) - 24usize];
    ["Offset of field: IZoneIdentifier2Vtbl::SetId"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, SetId) - 32usize];
    ["Offset of field: IZoneIdentifier2Vtbl::Remove"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, Remove) - 40usize];
    ["Offset of field: IZoneIdentifier2Vtbl::GetLastWriterPackageFamilyName"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, GetLastWriterPackageFamilyName) - 48usize];
    ["Offset of field: IZoneIdentifier2Vtbl::SetLastWriterPackageFamilyName"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, SetLastWriterPackageFamilyName) - 56usize];
    ["Offset of field: IZoneIdentifier2Vtbl::RemoveLastWriterPackageFamilyName"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, RemoveLastWriterPackageFamilyName) - 64usize];
    ["Offset of field: IZoneIdentifier2Vtbl::GetAppZoneId"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, GetAppZoneId) - 72usize];
    ["Offset of field: IZoneIdentifier2Vtbl::SetAppZoneId"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, SetAppZoneId) - 80usize];
    ["Offset of field: IZoneIdentifier2Vtbl::RemoveAppZoneId"]
        [::std::mem::offset_of!(IZoneIdentifier2Vtbl, RemoveAppZoneId) - 88usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IZoneIdentifier2 {
    pub lpVtbl: *mut IZoneIdentifier2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IZoneIdentifier2"][::std::mem::size_of::<IZoneIdentifier2>() - 8usize];
    ["Alignment of IZoneIdentifier2"][::std::mem::align_of::<IZoneIdentifier2>() - 8usize];
    ["Offset of field: IZoneIdentifier2::lpVtbl"]
        [::std::mem::offset_of!(IZoneIdentifier2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0043_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0043_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetHostSecurityManager: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetHostSecurityManagerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetHostSecurityManager,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetHostSecurityManager) -> ULONG,
    >,
    pub Release: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetHostSecurityManager) -> ULONG,
    >,
    pub GetSecurityId: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetHostSecurityManager,
            pbSecurityId: *mut BYTE,
            pcbSecurityId: *mut DWORD,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
    pub ProcessUrlAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetHostSecurityManager,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwFlags: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub QueryCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetHostSecurityManager,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            pContext: *mut BYTE,
            cbContext: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetHostSecurityManagerVtbl"]
        [::std::mem::size_of::<IInternetHostSecurityManagerVtbl>() - 48usize];
    ["Alignment of IInternetHostSecurityManagerVtbl"]
        [::std::mem::align_of::<IInternetHostSecurityManagerVtbl>() - 8usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::Release"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, Release) - 16usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::GetSecurityId"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, GetSecurityId) - 24usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::ProcessUrlAction"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, ProcessUrlAction) - 32usize];
    ["Offset of field: IInternetHostSecurityManagerVtbl::QueryCustomPolicy"]
        [::std::mem::offset_of!(IInternetHostSecurityManagerVtbl, QueryCustomPolicy) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetHostSecurityManager {
    pub lpVtbl: *mut IInternetHostSecurityManagerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetHostSecurityManager"]
        [::std::mem::size_of::<IInternetHostSecurityManager>() - 8usize];
    ["Alignment of IInternetHostSecurityManager"]
        [::std::mem::align_of::<IInternetHostSecurityManager>() - 8usize];
    ["Offset of field: IInternetHostSecurityManager::lpVtbl"]
        [::std::mem::offset_of!(IInternetHostSecurityManager, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static GUID_CUSTOM_LOCALMACHINEZONEUNLOCKED: GUID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0044_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0044_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPURLZONEMANAGER = *mut IInternetZoneManager;
pub const tagURLZONE_URLZONE_INVALID: tagURLZONE = -1;
pub const tagURLZONE_URLZONE_PREDEFINED_MIN: tagURLZONE = 0;
pub const tagURLZONE_URLZONE_LOCAL_MACHINE: tagURLZONE = 0;
pub const tagURLZONE_URLZONE_INTRANET: tagURLZONE = 1;
pub const tagURLZONE_URLZONE_TRUSTED: tagURLZONE = 2;
pub const tagURLZONE_URLZONE_INTERNET: tagURLZONE = 3;
pub const tagURLZONE_URLZONE_UNTRUSTED: tagURLZONE = 4;
pub const tagURLZONE_URLZONE_PREDEFINED_MAX: tagURLZONE = 999;
pub const tagURLZONE_URLZONE_USER_MIN: tagURLZONE = 1000;
pub const tagURLZONE_URLZONE_USER_MAX: tagURLZONE = 10000;
pub type tagURLZONE = ::std::os::raw::c_int;
pub use self::tagURLZONE as URLZONE;
pub const tagURLTEMPLATE_URLTEMPLATE_CUSTOM: tagURLTEMPLATE = 0;
pub const tagURLTEMPLATE_URLTEMPLATE_PREDEFINED_MIN: tagURLTEMPLATE = 65536;
pub const tagURLTEMPLATE_URLTEMPLATE_LOW: tagURLTEMPLATE = 65536;
pub const tagURLTEMPLATE_URLTEMPLATE_MEDLOW: tagURLTEMPLATE = 66816;
pub const tagURLTEMPLATE_URLTEMPLATE_MEDIUM: tagURLTEMPLATE = 69632;
pub const tagURLTEMPLATE_URLTEMPLATE_MEDHIGH: tagURLTEMPLATE = 70912;
pub const tagURLTEMPLATE_URLTEMPLATE_HIGH: tagURLTEMPLATE = 73728;
pub const tagURLTEMPLATE_URLTEMPLATE_PREDEFINED_MAX: tagURLTEMPLATE = 131072;
pub type tagURLTEMPLATE = ::std::os::raw::c_int;
pub use self::tagURLTEMPLATE as URLTEMPLATE;
pub const __MIDL_IInternetZoneManager_0001_MAX_ZONE_PATH: __MIDL_IInternetZoneManager_0001 = 260;
pub const __MIDL_IInternetZoneManager_0001_MAX_ZONE_DESCRIPTION: __MIDL_IInternetZoneManager_0001 =
    200;
pub type __MIDL_IInternetZoneManager_0001 = ::std::os::raw::c_int;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_CUSTOM_EDIT: __MIDL_IInternetZoneManager_0002 =
    1;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_ADD_SITES: __MIDL_IInternetZoneManager_0002 = 2;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_REQUIRE_VERIFICATION:
    __MIDL_IInternetZoneManager_0002 = 4;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_INCLUDE_PROXY_OVERRIDE:
    __MIDL_IInternetZoneManager_0002 = 8;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_INCLUDE_INTRANET_SITES:
    __MIDL_IInternetZoneManager_0002 = 16;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_NO_UI: __MIDL_IInternetZoneManager_0002 = 32;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_SUPPORTS_VERIFICATION:
    __MIDL_IInternetZoneManager_0002 = 64;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_UNC_AS_INTRANET:
    __MIDL_IInternetZoneManager_0002 = 128;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_DETECT_INTRANET:
    __MIDL_IInternetZoneManager_0002 = 256;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_USE_LOCKED_ZONES:
    __MIDL_IInternetZoneManager_0002 = 65536;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_VERIFY_TEMPLATE_SETTINGS:
    __MIDL_IInternetZoneManager_0002 = 131072;
pub const __MIDL_IInternetZoneManager_0002_ZAFLAGS_NO_CACHE: __MIDL_IInternetZoneManager_0002 =
    262144;
pub type __MIDL_IInternetZoneManager_0002 = ::std::os::raw::c_int;
pub use self::__MIDL_IInternetZoneManager_0002 as ZAFLAGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ZONEATTRIBUTES {
    pub cbSize: ULONG,
    pub szDisplayName: [WCHAR; 260usize],
    pub szDescription: [WCHAR; 200usize],
    pub szIconPath: [WCHAR; 260usize],
    pub dwTemplateMinLevel: DWORD,
    pub dwTemplateRecommended: DWORD,
    pub dwTemplateCurrentLevel: DWORD,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ZONEATTRIBUTES"][::std::mem::size_of::<_ZONEATTRIBUTES>() - 1460usize];
    ["Alignment of _ZONEATTRIBUTES"][::std::mem::align_of::<_ZONEATTRIBUTES>() - 4usize];
    ["Offset of field: _ZONEATTRIBUTES::cbSize"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, cbSize) - 0usize];
    ["Offset of field: _ZONEATTRIBUTES::szDisplayName"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, szDisplayName) - 4usize];
    ["Offset of field: _ZONEATTRIBUTES::szDescription"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, szDescription) - 524usize];
    ["Offset of field: _ZONEATTRIBUTES::szIconPath"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, szIconPath) - 924usize];
    ["Offset of field: _ZONEATTRIBUTES::dwTemplateMinLevel"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, dwTemplateMinLevel) - 1444usize];
    ["Offset of field: _ZONEATTRIBUTES::dwTemplateRecommended"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, dwTemplateRecommended) - 1448usize];
    ["Offset of field: _ZONEATTRIBUTES::dwTemplateCurrentLevel"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, dwTemplateCurrentLevel) - 1452usize];
    ["Offset of field: _ZONEATTRIBUTES::dwFlags"]
        [::std::mem::offset_of!(_ZONEATTRIBUTES, dwFlags) - 1456usize];
};
pub type ZONEATTRIBUTES = _ZONEATTRIBUTES;
pub type LPZONEATTRIBUTES = *mut _ZONEATTRIBUTES;
pub const _URLZONEREG_URLZONEREG_DEFAULT: _URLZONEREG = 0;
pub const _URLZONEREG_URLZONEREG_HKLM: _URLZONEREG = 1;
pub const _URLZONEREG_URLZONEREG_HKCU: _URLZONEREG = 2;
pub type _URLZONEREG = ::std::os::raw::c_int;
pub use self::_URLZONEREG as URLZONEREG;
unsafe extern "C" {
    pub static IID_IInternetZoneManager: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManagerVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManager) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManager) -> ULONG>,
    pub GetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub SetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub GetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            guidKey: *const GUID,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub GetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub PromptAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwAction: DWORD,
            hwndParent: HWND,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwPromptFlags: DWORD,
        ) -> HRESULT,
    >,
    pub LogAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwAction: DWORD,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwLogFlags: DWORD,
        ) -> HRESULT,
    >,
    pub CreateZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            pdwEnum: *mut DWORD,
            pdwCount: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwEnum: DWORD,
            dwIndex: DWORD,
            pdwZone: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DestroyZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetZoneManager, dwEnum: DWORD) -> HRESULT,
    >,
    pub CopyTemplatePoliciesToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManager,
            dwTemplate: DWORD,
            dwZone: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManagerVtbl"]
        [::std::mem::size_of::<IInternetZoneManagerVtbl>() - 120usize];
    ["Alignment of IInternetZoneManagerVtbl"]
        [::std::mem::align_of::<IInternetZoneManagerVtbl>() - 8usize];
    ["Offset of field: IInternetZoneManagerVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetZoneManagerVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetZoneManagerVtbl::Release"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, Release) - 16usize];
    ["Offset of field: IInternetZoneManagerVtbl::GetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, GetZoneAttributes) - 24usize];
    ["Offset of field: IInternetZoneManagerVtbl::SetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, SetZoneAttributes) - 32usize];
    ["Offset of field: IInternetZoneManagerVtbl::GetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, GetZoneCustomPolicy) - 40usize];
    ["Offset of field: IInternetZoneManagerVtbl::SetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, SetZoneCustomPolicy) - 48usize];
    ["Offset of field: IInternetZoneManagerVtbl::GetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, GetZoneActionPolicy) - 56usize];
    ["Offset of field: IInternetZoneManagerVtbl::SetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, SetZoneActionPolicy) - 64usize];
    ["Offset of field: IInternetZoneManagerVtbl::PromptAction"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, PromptAction) - 72usize];
    ["Offset of field: IInternetZoneManagerVtbl::LogAction"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, LogAction) - 80usize];
    ["Offset of field: IInternetZoneManagerVtbl::CreateZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, CreateZoneEnumerator) - 88usize];
    ["Offset of field: IInternetZoneManagerVtbl::GetZoneAt"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, GetZoneAt) - 96usize];
    ["Offset of field: IInternetZoneManagerVtbl::DestroyZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, DestroyZoneEnumerator) - 104usize];
    ["Offset of field: IInternetZoneManagerVtbl::CopyTemplatePoliciesToZone"]
        [::std::mem::offset_of!(IInternetZoneManagerVtbl, CopyTemplatePoliciesToZone) - 112usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManager {
    pub lpVtbl: *mut IInternetZoneManagerVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManager"][::std::mem::size_of::<IInternetZoneManager>() - 8usize];
    ["Alignment of IInternetZoneManager"][::std::mem::align_of::<IInternetZoneManager>() - 8usize];
    ["Offset of field: IInternetZoneManager::lpVtbl"]
        [::std::mem::offset_of!(IInternetZoneManager, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0045_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0045_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetZoneManagerEx: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManagerExVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManagerEx) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManagerEx) -> ULONG>,
    pub GetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub SetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub GetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            guidKey: *const GUID,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub GetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub PromptAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwAction: DWORD,
            hwndParent: HWND,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwPromptFlags: DWORD,
        ) -> HRESULT,
    >,
    pub LogAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwAction: DWORD,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwLogFlags: DWORD,
        ) -> HRESULT,
    >,
    pub CreateZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            pdwEnum: *mut DWORD,
            pdwCount: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwEnum: DWORD,
            dwIndex: DWORD,
            pdwZone: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DestroyZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetZoneManagerEx, dwEnum: DWORD) -> HRESULT,
    >,
    pub CopyTemplatePoliciesToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwTemplate: DWORD,
            dwZone: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneActionPolicyEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub SetZoneActionPolicyEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManagerExVtbl"]
        [::std::mem::size_of::<IInternetZoneManagerExVtbl>() - 136usize];
    ["Alignment of IInternetZoneManagerExVtbl"]
        [::std::mem::align_of::<IInternetZoneManagerExVtbl>() - 8usize];
    ["Offset of field: IInternetZoneManagerExVtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetZoneManagerExVtbl::AddRef"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, AddRef) - 8usize];
    ["Offset of field: IInternetZoneManagerExVtbl::Release"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, Release) - 16usize];
    ["Offset of field: IInternetZoneManagerExVtbl::GetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, GetZoneAttributes) - 24usize];
    ["Offset of field: IInternetZoneManagerExVtbl::SetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, SetZoneAttributes) - 32usize];
    ["Offset of field: IInternetZoneManagerExVtbl::GetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, GetZoneCustomPolicy) - 40usize];
    ["Offset of field: IInternetZoneManagerExVtbl::SetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, SetZoneCustomPolicy) - 48usize];
    ["Offset of field: IInternetZoneManagerExVtbl::GetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, GetZoneActionPolicy) - 56usize];
    ["Offset of field: IInternetZoneManagerExVtbl::SetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, SetZoneActionPolicy) - 64usize];
    ["Offset of field: IInternetZoneManagerExVtbl::PromptAction"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, PromptAction) - 72usize];
    ["Offset of field: IInternetZoneManagerExVtbl::LogAction"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, LogAction) - 80usize];
    ["Offset of field: IInternetZoneManagerExVtbl::CreateZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, CreateZoneEnumerator) - 88usize];
    ["Offset of field: IInternetZoneManagerExVtbl::GetZoneAt"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, GetZoneAt) - 96usize];
    ["Offset of field: IInternetZoneManagerExVtbl::DestroyZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, DestroyZoneEnumerator) - 104usize];
    ["Offset of field: IInternetZoneManagerExVtbl::CopyTemplatePoliciesToZone"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, CopyTemplatePoliciesToZone) - 112usize];
    ["Offset of field: IInternetZoneManagerExVtbl::GetZoneActionPolicyEx"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, GetZoneActionPolicyEx) - 120usize];
    ["Offset of field: IInternetZoneManagerExVtbl::SetZoneActionPolicyEx"]
        [::std::mem::offset_of!(IInternetZoneManagerExVtbl, SetZoneActionPolicyEx) - 128usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManagerEx {
    pub lpVtbl: *mut IInternetZoneManagerExVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManagerEx"][::std::mem::size_of::<IInternetZoneManagerEx>() - 8usize];
    ["Alignment of IInternetZoneManagerEx"]
        [::std::mem::align_of::<IInternetZoneManagerEx>() - 8usize];
    ["Offset of field: IInternetZoneManagerEx::lpVtbl"]
        [::std::mem::offset_of!(IInternetZoneManagerEx, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0046_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0046_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IInternetZoneManagerEx2: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManagerEx2Vtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManagerEx2) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManagerEx2) -> ULONG>,
    pub GetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub SetZoneAttributes: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
        ) -> HRESULT,
    >,
    pub GetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            guidKey: *const GUID,
            ppPolicy: *mut *mut BYTE,
            pcbPolicy: *mut DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneCustomPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            guidKey: *const GUID,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub GetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub SetZoneActionPolicy: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
        ) -> HRESULT,
    >,
    pub PromptAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwAction: DWORD,
            hwndParent: HWND,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwPromptFlags: DWORD,
        ) -> HRESULT,
    >,
    pub LogAction: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwAction: DWORD,
            pwszUrl: LPCWSTR,
            pwszText: LPCWSTR,
            dwLogFlags: DWORD,
        ) -> HRESULT,
    >,
    pub CreateZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            pdwEnum: *mut DWORD,
            pdwCount: *mut DWORD,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneAt: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwEnum: DWORD,
            dwIndex: DWORD,
            pdwZone: *mut DWORD,
        ) -> HRESULT,
    >,
    pub DestroyZoneEnumerator: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IInternetZoneManagerEx2, dwEnum: DWORD) -> HRESULT,
    >,
    pub CopyTemplatePoliciesToZone: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwTemplate: DWORD,
            dwZone: DWORD,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneActionPolicyEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub SetZoneActionPolicyEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            dwAction: DWORD,
            pPolicy: *mut BYTE,
            cbPolicy: DWORD,
            urlZoneReg: URLZONEREG,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneAttributesEx: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZone: DWORD,
            pZoneAttributes: *mut ZONEATTRIBUTES,
            dwFlags: DWORD,
        ) -> HRESULT,
    >,
    pub GetZoneSecurityState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            dwZoneIndex: DWORD,
            fRespectPolicy: BOOL,
            pdwState: LPDWORD,
            pfPolicyEncountered: *mut BOOL,
        ) -> HRESULT,
    >,
    pub GetIESecurityState: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IInternetZoneManagerEx2,
            fRespectPolicy: BOOL,
            pdwState: LPDWORD,
            pfPolicyEncountered: *mut BOOL,
            fNoCache: BOOL,
        ) -> HRESULT,
    >,
    pub FixUnsecureSettings:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IInternetZoneManagerEx2) -> HRESULT>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManagerEx2Vtbl"]
        [::std::mem::size_of::<IInternetZoneManagerEx2Vtbl>() - 168usize];
    ["Alignment of IInternetZoneManagerEx2Vtbl"]
        [::std::mem::align_of::<IInternetZoneManagerEx2Vtbl>() - 8usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::QueryInterface"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, QueryInterface) - 0usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::AddRef"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, AddRef) - 8usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::Release"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, Release) - 16usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneAttributes) - 24usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::SetZoneAttributes"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, SetZoneAttributes) - 32usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneCustomPolicy) - 40usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::SetZoneCustomPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, SetZoneCustomPolicy) - 48usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneActionPolicy) - 56usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::SetZoneActionPolicy"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, SetZoneActionPolicy) - 64usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::PromptAction"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, PromptAction) - 72usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::LogAction"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, LogAction) - 80usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::CreateZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, CreateZoneEnumerator) - 88usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneAt"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneAt) - 96usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::DestroyZoneEnumerator"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, DestroyZoneEnumerator) - 104usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::CopyTemplatePoliciesToZone"][::std::mem::offset_of!(
        IInternetZoneManagerEx2Vtbl,
        CopyTemplatePoliciesToZone
    ) - 112usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneActionPolicyEx"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneActionPolicyEx) - 120usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::SetZoneActionPolicyEx"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, SetZoneActionPolicyEx) - 128usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneAttributesEx"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneAttributesEx) - 136usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetZoneSecurityState"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetZoneSecurityState) - 144usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::GetIESecurityState"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, GetIESecurityState) - 152usize];
    ["Offset of field: IInternetZoneManagerEx2Vtbl::FixUnsecureSettings"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2Vtbl, FixUnsecureSettings) - 160usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IInternetZoneManagerEx2 {
    pub lpVtbl: *mut IInternetZoneManagerEx2Vtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IInternetZoneManagerEx2"][::std::mem::size_of::<IInternetZoneManagerEx2>() - 8usize];
    ["Alignment of IInternetZoneManagerEx2"]
        [::std::mem::align_of::<IInternetZoneManagerEx2>() - 8usize];
    ["Offset of field: IInternetZoneManagerEx2::lpVtbl"]
        [::std::mem::offset_of!(IInternetZoneManagerEx2, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static CLSID_SoftDistExt: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagCODEBASEHOLD {
    pub cbSize: ULONG,
    pub szDistUnit: LPWSTR,
    pub szCodeBase: LPWSTR,
    pub dwVersionMS: DWORD,
    pub dwVersionLS: DWORD,
    pub dwStyle: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagCODEBASEHOLD"][::std::mem::size_of::<_tagCODEBASEHOLD>() - 40usize];
    ["Alignment of _tagCODEBASEHOLD"][::std::mem::align_of::<_tagCODEBASEHOLD>() - 8usize];
    ["Offset of field: _tagCODEBASEHOLD::cbSize"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, cbSize) - 0usize];
    ["Offset of field: _tagCODEBASEHOLD::szDistUnit"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, szDistUnit) - 8usize];
    ["Offset of field: _tagCODEBASEHOLD::szCodeBase"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, szCodeBase) - 16usize];
    ["Offset of field: _tagCODEBASEHOLD::dwVersionMS"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, dwVersionMS) - 24usize];
    ["Offset of field: _tagCODEBASEHOLD::dwVersionLS"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, dwVersionLS) - 28usize];
    ["Offset of field: _tagCODEBASEHOLD::dwStyle"]
        [::std::mem::offset_of!(_tagCODEBASEHOLD, dwStyle) - 32usize];
};
pub type CODEBASEHOLD = _tagCODEBASEHOLD;
pub type LPCODEBASEHOLD = *mut _tagCODEBASEHOLD;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagSOFTDISTINFO {
    pub cbSize: ULONG,
    pub dwFlags: DWORD,
    pub dwAdState: DWORD,
    pub szTitle: LPWSTR,
    pub szAbstract: LPWSTR,
    pub szHREF: LPWSTR,
    pub dwInstalledVersionMS: DWORD,
    pub dwInstalledVersionLS: DWORD,
    pub dwUpdateVersionMS: DWORD,
    pub dwUpdateVersionLS: DWORD,
    pub dwAdvertisedVersionMS: DWORD,
    pub dwAdvertisedVersionLS: DWORD,
    pub dwReserved: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagSOFTDISTINFO"][::std::mem::size_of::<_tagSOFTDISTINFO>() - 72usize];
    ["Alignment of _tagSOFTDISTINFO"][::std::mem::align_of::<_tagSOFTDISTINFO>() - 8usize];
    ["Offset of field: _tagSOFTDISTINFO::cbSize"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, cbSize) - 0usize];
    ["Offset of field: _tagSOFTDISTINFO::dwFlags"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwFlags) - 4usize];
    ["Offset of field: _tagSOFTDISTINFO::dwAdState"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwAdState) - 8usize];
    ["Offset of field: _tagSOFTDISTINFO::szTitle"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, szTitle) - 16usize];
    ["Offset of field: _tagSOFTDISTINFO::szAbstract"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, szAbstract) - 24usize];
    ["Offset of field: _tagSOFTDISTINFO::szHREF"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, szHREF) - 32usize];
    ["Offset of field: _tagSOFTDISTINFO::dwInstalledVersionMS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwInstalledVersionMS) - 40usize];
    ["Offset of field: _tagSOFTDISTINFO::dwInstalledVersionLS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwInstalledVersionLS) - 44usize];
    ["Offset of field: _tagSOFTDISTINFO::dwUpdateVersionMS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwUpdateVersionMS) - 48usize];
    ["Offset of field: _tagSOFTDISTINFO::dwUpdateVersionLS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwUpdateVersionLS) - 52usize];
    ["Offset of field: _tagSOFTDISTINFO::dwAdvertisedVersionMS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwAdvertisedVersionMS) - 56usize];
    ["Offset of field: _tagSOFTDISTINFO::dwAdvertisedVersionLS"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwAdvertisedVersionLS) - 60usize];
    ["Offset of field: _tagSOFTDISTINFO::dwReserved"]
        [::std::mem::offset_of!(_tagSOFTDISTINFO, dwReserved) - 64usize];
};
pub type SOFTDISTINFO = _tagSOFTDISTINFO;
pub type LPSOFTDISTINFO = *mut _tagSOFTDISTINFO;
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0047_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0047_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_ISoftDistExt: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISoftDistExtVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISoftDistExt,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ISoftDistExt) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ISoftDistExt) -> ULONG>,
    pub ProcessSoftDist: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISoftDistExt,
            szCDFURL: LPCWSTR,
            pSoftDistElement: *mut IXMLElement,
            lpsdi: LPSOFTDISTINFO,
        ) -> HRESULT,
    >,
    pub GetFirstCodeBase: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISoftDistExt,
            szCodeBase: *mut LPWSTR,
            dwMaxSize: LPDWORD,
        ) -> HRESULT,
    >,
    pub GetNextCodeBase: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISoftDistExt,
            szCodeBase: *mut LPWSTR,
            dwMaxSize: LPDWORD,
        ) -> HRESULT,
    >,
    pub AsyncInstallDistributionUnit: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ISoftDistExt,
            pbc: *mut IBindCtx,
            pvReserved: LPVOID,
            flags: DWORD,
            lpcbh: LPCODEBASEHOLD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISoftDistExtVtbl"][::std::mem::size_of::<ISoftDistExtVtbl>() - 56usize];
    ["Alignment of ISoftDistExtVtbl"][::std::mem::align_of::<ISoftDistExtVtbl>() - 8usize];
    ["Offset of field: ISoftDistExtVtbl::QueryInterface"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, QueryInterface) - 0usize];
    ["Offset of field: ISoftDistExtVtbl::AddRef"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, AddRef) - 8usize];
    ["Offset of field: ISoftDistExtVtbl::Release"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, Release) - 16usize];
    ["Offset of field: ISoftDistExtVtbl::ProcessSoftDist"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, ProcessSoftDist) - 24usize];
    ["Offset of field: ISoftDistExtVtbl::GetFirstCodeBase"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, GetFirstCodeBase) - 32usize];
    ["Offset of field: ISoftDistExtVtbl::GetNextCodeBase"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, GetNextCodeBase) - 40usize];
    ["Offset of field: ISoftDistExtVtbl::AsyncInstallDistributionUnit"]
        [::std::mem::offset_of!(ISoftDistExtVtbl, AsyncInstallDistributionUnit) - 48usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ISoftDistExt {
    pub lpVtbl: *mut ISoftDistExtVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ISoftDistExt"][::std::mem::size_of::<ISoftDistExt>() - 8usize];
    ["Alignment of ISoftDistExt"][::std::mem::align_of::<ISoftDistExt>() - 8usize];
    ["Offset of field: ISoftDistExt::lpVtbl"]
        [::std::mem::offset_of!(ISoftDistExt, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn GetSoftwareUpdateInfo(szDistUnit: LPCWSTR, psdi: LPSOFTDISTINFO) -> HRESULT;
}
unsafe extern "C" {
    pub fn SetSoftwareUpdateAdvertisementState(
        szDistUnit: LPCWSTR,
        dwAdState: DWORD,
        dwAdvertisedVersionMS: DWORD,
        dwAdvertisedVersionLS: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0048_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0048_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPCATALOGFILEINFO = *mut ICatalogFileInfo;
unsafe extern "C" {
    pub static IID_ICatalogFileInfo: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICatalogFileInfoVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICatalogFileInfo,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut ICatalogFileInfo) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut ICatalogFileInfo) -> ULONG>,
    pub GetCatalogFile: ::std::option::Option<
        unsafe extern "C" fn(This: *mut ICatalogFileInfo, ppszCatalogFile: *mut LPSTR) -> HRESULT,
    >,
    pub GetJavaTrust: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut ICatalogFileInfo,
            ppJavaTrust: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICatalogFileInfoVtbl"][::std::mem::size_of::<ICatalogFileInfoVtbl>() - 40usize];
    ["Alignment of ICatalogFileInfoVtbl"][::std::mem::align_of::<ICatalogFileInfoVtbl>() - 8usize];
    ["Offset of field: ICatalogFileInfoVtbl::QueryInterface"]
        [::std::mem::offset_of!(ICatalogFileInfoVtbl, QueryInterface) - 0usize];
    ["Offset of field: ICatalogFileInfoVtbl::AddRef"]
        [::std::mem::offset_of!(ICatalogFileInfoVtbl, AddRef) - 8usize];
    ["Offset of field: ICatalogFileInfoVtbl::Release"]
        [::std::mem::offset_of!(ICatalogFileInfoVtbl, Release) - 16usize];
    ["Offset of field: ICatalogFileInfoVtbl::GetCatalogFile"]
        [::std::mem::offset_of!(ICatalogFileInfoVtbl, GetCatalogFile) - 24usize];
    ["Offset of field: ICatalogFileInfoVtbl::GetJavaTrust"]
        [::std::mem::offset_of!(ICatalogFileInfoVtbl, GetJavaTrust) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct ICatalogFileInfo {
    pub lpVtbl: *mut ICatalogFileInfoVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of ICatalogFileInfo"][::std::mem::size_of::<ICatalogFileInfo>() - 8usize];
    ["Alignment of ICatalogFileInfo"][::std::mem::align_of::<ICatalogFileInfo>() - 8usize];
    ["Offset of field: ICatalogFileInfo::lpVtbl"]
        [::std::mem::offset_of!(ICatalogFileInfo, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0049_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0049_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPDATAFILTER = *mut IDataFilter;
unsafe extern "C" {
    pub static IID_IDataFilter: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataFilterVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataFilter,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataFilter) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IDataFilter) -> ULONG>,
    pub DoEncode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataFilter,
            dwFlags: DWORD,
            lInBufferSize: LONG,
            pbInBuffer: *mut BYTE,
            lOutBufferSize: LONG,
            pbOutBuffer: *mut BYTE,
            lInBytesAvailable: LONG,
            plInBytesRead: *mut LONG,
            plOutBytesWritten: *mut LONG,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub DoDecode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IDataFilter,
            dwFlags: DWORD,
            lInBufferSize: LONG,
            pbInBuffer: *mut BYTE,
            lOutBufferSize: LONG,
            pbOutBuffer: *mut BYTE,
            lInBytesAvailable: LONG,
            plInBytesRead: *mut LONG,
            plOutBytesWritten: *mut LONG,
            dwReserved: DWORD,
        ) -> HRESULT,
    >,
    pub SetEncodingLevel: ::std::option::Option<
        unsafe extern "C" fn(This: *mut IDataFilter, dwEncLevel: DWORD) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataFilterVtbl"][::std::mem::size_of::<IDataFilterVtbl>() - 48usize];
    ["Alignment of IDataFilterVtbl"][::std::mem::align_of::<IDataFilterVtbl>() - 8usize];
    ["Offset of field: IDataFilterVtbl::QueryInterface"]
        [::std::mem::offset_of!(IDataFilterVtbl, QueryInterface) - 0usize];
    ["Offset of field: IDataFilterVtbl::AddRef"]
        [::std::mem::offset_of!(IDataFilterVtbl, AddRef) - 8usize];
    ["Offset of field: IDataFilterVtbl::Release"]
        [::std::mem::offset_of!(IDataFilterVtbl, Release) - 16usize];
    ["Offset of field: IDataFilterVtbl::DoEncode"]
        [::std::mem::offset_of!(IDataFilterVtbl, DoEncode) - 24usize];
    ["Offset of field: IDataFilterVtbl::DoDecode"]
        [::std::mem::offset_of!(IDataFilterVtbl, DoDecode) - 32usize];
    ["Offset of field: IDataFilterVtbl::SetEncodingLevel"]
        [::std::mem::offset_of!(IDataFilterVtbl, SetEncodingLevel) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IDataFilter {
    pub lpVtbl: *mut IDataFilterVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IDataFilter"][::std::mem::size_of::<IDataFilter>() - 8usize];
    ["Alignment of IDataFilter"][::std::mem::align_of::<IDataFilter>() - 8usize];
    ["Offset of field: IDataFilter::lpVtbl"][::std::mem::offset_of!(IDataFilter, lpVtbl) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagPROTOCOLFILTERDATA {
    pub cbSize: DWORD,
    pub pProtocolSink: *mut IInternetProtocolSink,
    pub pProtocol: *mut IInternetProtocol,
    pub pUnk: *mut IUnknown,
    pub dwFilterFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagPROTOCOLFILTERDATA"][::std::mem::size_of::<_tagPROTOCOLFILTERDATA>() - 40usize];
    ["Alignment of _tagPROTOCOLFILTERDATA"]
        [::std::mem::align_of::<_tagPROTOCOLFILTERDATA>() - 8usize];
    ["Offset of field: _tagPROTOCOLFILTERDATA::cbSize"]
        [::std::mem::offset_of!(_tagPROTOCOLFILTERDATA, cbSize) - 0usize];
    ["Offset of field: _tagPROTOCOLFILTERDATA::pProtocolSink"]
        [::std::mem::offset_of!(_tagPROTOCOLFILTERDATA, pProtocolSink) - 8usize];
    ["Offset of field: _tagPROTOCOLFILTERDATA::pProtocol"]
        [::std::mem::offset_of!(_tagPROTOCOLFILTERDATA, pProtocol) - 16usize];
    ["Offset of field: _tagPROTOCOLFILTERDATA::pUnk"]
        [::std::mem::offset_of!(_tagPROTOCOLFILTERDATA, pUnk) - 24usize];
    ["Offset of field: _tagPROTOCOLFILTERDATA::dwFilterFlags"]
        [::std::mem::offset_of!(_tagPROTOCOLFILTERDATA, dwFilterFlags) - 32usize];
};
pub type PROTOCOLFILTERDATA = _tagPROTOCOLFILTERDATA;
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0050_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0050_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPENCODINGFILTERFACTORY = *mut IEncodingFilterFactory;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagDATAINFO {
    pub ulTotalSize: ULONG,
    pub ulavrPacketSize: ULONG,
    pub ulConnectSpeed: ULONG,
    pub ulProcessorSpeed: ULONG,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagDATAINFO"][::std::mem::size_of::<_tagDATAINFO>() - 16usize];
    ["Alignment of _tagDATAINFO"][::std::mem::align_of::<_tagDATAINFO>() - 4usize];
    ["Offset of field: _tagDATAINFO::ulTotalSize"]
        [::std::mem::offset_of!(_tagDATAINFO, ulTotalSize) - 0usize];
    ["Offset of field: _tagDATAINFO::ulavrPacketSize"]
        [::std::mem::offset_of!(_tagDATAINFO, ulavrPacketSize) - 4usize];
    ["Offset of field: _tagDATAINFO::ulConnectSpeed"]
        [::std::mem::offset_of!(_tagDATAINFO, ulConnectSpeed) - 8usize];
    ["Offset of field: _tagDATAINFO::ulProcessorSpeed"]
        [::std::mem::offset_of!(_tagDATAINFO, ulProcessorSpeed) - 12usize];
};
pub type DATAINFO = _tagDATAINFO;
unsafe extern "C" {
    pub static IID_IEncodingFilterFactory: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEncodingFilterFactoryVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEncodingFilterFactory,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEncodingFilterFactory) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IEncodingFilterFactory) -> ULONG>,
    pub FindBestFilter: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEncodingFilterFactory,
            pwzCodeIn: LPCWSTR,
            pwzCodeOut: LPCWSTR,
            info: DATAINFO,
            ppDF: *mut *mut IDataFilter,
        ) -> HRESULT,
    >,
    pub GetDefaultFilter: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IEncodingFilterFactory,
            pwzCodeIn: LPCWSTR,
            pwzCodeOut: LPCWSTR,
            ppDF: *mut *mut IDataFilter,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEncodingFilterFactoryVtbl"]
        [::std::mem::size_of::<IEncodingFilterFactoryVtbl>() - 40usize];
    ["Alignment of IEncodingFilterFactoryVtbl"]
        [::std::mem::align_of::<IEncodingFilterFactoryVtbl>() - 8usize];
    ["Offset of field: IEncodingFilterFactoryVtbl::QueryInterface"]
        [::std::mem::offset_of!(IEncodingFilterFactoryVtbl, QueryInterface) - 0usize];
    ["Offset of field: IEncodingFilterFactoryVtbl::AddRef"]
        [::std::mem::offset_of!(IEncodingFilterFactoryVtbl, AddRef) - 8usize];
    ["Offset of field: IEncodingFilterFactoryVtbl::Release"]
        [::std::mem::offset_of!(IEncodingFilterFactoryVtbl, Release) - 16usize];
    ["Offset of field: IEncodingFilterFactoryVtbl::FindBestFilter"]
        [::std::mem::offset_of!(IEncodingFilterFactoryVtbl, FindBestFilter) - 24usize];
    ["Offset of field: IEncodingFilterFactoryVtbl::GetDefaultFilter"]
        [::std::mem::offset_of!(IEncodingFilterFactoryVtbl, GetDefaultFilter) - 32usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IEncodingFilterFactory {
    pub lpVtbl: *mut IEncodingFilterFactoryVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IEncodingFilterFactory"][::std::mem::size_of::<IEncodingFilterFactory>() - 8usize];
    ["Alignment of IEncodingFilterFactory"]
        [::std::mem::align_of::<IEncodingFilterFactory>() - 8usize];
    ["Offset of field: IEncodingFilterFactory::lpVtbl"]
        [::std::mem::offset_of!(IEncodingFilterFactory, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub fn IsLoggingEnabledA(pszUrl: LPCSTR) -> BOOL;
}
unsafe extern "C" {
    pub fn IsLoggingEnabledW(pwszUrl: LPCWSTR) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagHIT_LOGGING_INFO {
    pub dwStructSize: DWORD,
    pub lpszLoggedUrlName: LPSTR,
    pub StartTime: SYSTEMTIME,
    pub EndTime: SYSTEMTIME,
    pub lpszExtendedInfo: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagHIT_LOGGING_INFO"][::std::mem::size_of::<_tagHIT_LOGGING_INFO>() - 56usize];
    ["Alignment of _tagHIT_LOGGING_INFO"][::std::mem::align_of::<_tagHIT_LOGGING_INFO>() - 8usize];
    ["Offset of field: _tagHIT_LOGGING_INFO::dwStructSize"]
        [::std::mem::offset_of!(_tagHIT_LOGGING_INFO, dwStructSize) - 0usize];
    ["Offset of field: _tagHIT_LOGGING_INFO::lpszLoggedUrlName"]
        [::std::mem::offset_of!(_tagHIT_LOGGING_INFO, lpszLoggedUrlName) - 8usize];
    ["Offset of field: _tagHIT_LOGGING_INFO::StartTime"]
        [::std::mem::offset_of!(_tagHIT_LOGGING_INFO, StartTime) - 16usize];
    ["Offset of field: _tagHIT_LOGGING_INFO::EndTime"]
        [::std::mem::offset_of!(_tagHIT_LOGGING_INFO, EndTime) - 32usize];
    ["Offset of field: _tagHIT_LOGGING_INFO::lpszExtendedInfo"]
        [::std::mem::offset_of!(_tagHIT_LOGGING_INFO, lpszExtendedInfo) - 48usize];
};
pub type HIT_LOGGING_INFO = _tagHIT_LOGGING_INFO;
pub type LPHIT_LOGGING_INFO = *mut _tagHIT_LOGGING_INFO;
unsafe extern "C" {
    pub fn WriteHitLogging(lpLogginginfo: LPHIT_LOGGING_INFO) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct CONFIRMSAFETY {
    pub clsid: CLSID,
    pub pUnk: *mut IUnknown,
    pub dwFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of CONFIRMSAFETY"][::std::mem::size_of::<CONFIRMSAFETY>() - 32usize];
    ["Alignment of CONFIRMSAFETY"][::std::mem::align_of::<CONFIRMSAFETY>() - 8usize];
    ["Offset of field: CONFIRMSAFETY::clsid"]
        [::std::mem::offset_of!(CONFIRMSAFETY, clsid) - 0usize];
    ["Offset of field: CONFIRMSAFETY::pUnk"][::std::mem::offset_of!(CONFIRMSAFETY, pUnk) - 16usize];
    ["Offset of field: CONFIRMSAFETY::dwFlags"]
        [::std::mem::offset_of!(CONFIRMSAFETY, dwFlags) - 24usize];
};
unsafe extern "C" {
    pub static GUID_CUSTOM_CONFIRMOBJECTSAFETY: GUID;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0051_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0051_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPIWRAPPEDPROTOCOL = *mut IWrappedProtocol;
unsafe extern "C" {
    pub static IID_IWrappedProtocol: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWrappedProtocolVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWrappedProtocol,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IWrappedProtocol) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IWrappedProtocol) -> ULONG>,
    pub GetWrapperCode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IWrappedProtocol,
            pnCode: *mut LONG,
            dwReserved: DWORD_PTR,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWrappedProtocolVtbl"][::std::mem::size_of::<IWrappedProtocolVtbl>() - 32usize];
    ["Alignment of IWrappedProtocolVtbl"][::std::mem::align_of::<IWrappedProtocolVtbl>() - 8usize];
    ["Offset of field: IWrappedProtocolVtbl::QueryInterface"]
        [::std::mem::offset_of!(IWrappedProtocolVtbl, QueryInterface) - 0usize];
    ["Offset of field: IWrappedProtocolVtbl::AddRef"]
        [::std::mem::offset_of!(IWrappedProtocolVtbl, AddRef) - 8usize];
    ["Offset of field: IWrappedProtocolVtbl::Release"]
        [::std::mem::offset_of!(IWrappedProtocolVtbl, Release) - 16usize];
    ["Offset of field: IWrappedProtocolVtbl::GetWrapperCode"]
        [::std::mem::offset_of!(IWrappedProtocolVtbl, GetWrapperCode) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IWrappedProtocol {
    pub lpVtbl: *mut IWrappedProtocolVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IWrappedProtocol"][::std::mem::size_of::<IWrappedProtocol>() - 8usize];
    ["Alignment of IWrappedProtocol"][::std::mem::align_of::<IWrappedProtocol>() - 8usize];
    ["Offset of field: IWrappedProtocol::lpVtbl"]
        [::std::mem::offset_of!(IWrappedProtocol, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0052_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0052_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPGETBINDHANDLE = *mut IGetBindHandle;
pub const __MIDL_IGetBindHandle_0001_BINDHANDLETYPES_APPCACHE: __MIDL_IGetBindHandle_0001 = 0;
pub const __MIDL_IGetBindHandle_0001_BINDHANDLETYPES_DEPENDENCY: __MIDL_IGetBindHandle_0001 = 1;
pub const __MIDL_IGetBindHandle_0001_BINDHANDLETYPES_COUNT: __MIDL_IGetBindHandle_0001 = 2;
pub type __MIDL_IGetBindHandle_0001 = ::std::os::raw::c_int;
pub use self::__MIDL_IGetBindHandle_0001 as BINDHANDLETYPES;
unsafe extern "C" {
    pub static IID_IGetBindHandle: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGetBindHandleVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGetBindHandle,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IGetBindHandle) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IGetBindHandle) -> ULONG>,
    pub GetBindHandle: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IGetBindHandle,
            enumRequestedHandle: BINDHANDLETYPES,
            pRetHandle: *mut HANDLE,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGetBindHandleVtbl"][::std::mem::size_of::<IGetBindHandleVtbl>() - 32usize];
    ["Alignment of IGetBindHandleVtbl"][::std::mem::align_of::<IGetBindHandleVtbl>() - 8usize];
    ["Offset of field: IGetBindHandleVtbl::QueryInterface"]
        [::std::mem::offset_of!(IGetBindHandleVtbl, QueryInterface) - 0usize];
    ["Offset of field: IGetBindHandleVtbl::AddRef"]
        [::std::mem::offset_of!(IGetBindHandleVtbl, AddRef) - 8usize];
    ["Offset of field: IGetBindHandleVtbl::Release"]
        [::std::mem::offset_of!(IGetBindHandleVtbl, Release) - 16usize];
    ["Offset of field: IGetBindHandleVtbl::GetBindHandle"]
        [::std::mem::offset_of!(IGetBindHandleVtbl, GetBindHandle) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IGetBindHandle {
    pub lpVtbl: *mut IGetBindHandleVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IGetBindHandle"][::std::mem::size_of::<IGetBindHandle>() - 8usize];
    ["Alignment of IGetBindHandle"][::std::mem::align_of::<IGetBindHandle>() - 8usize];
    ["Offset of field: IGetBindHandle::lpVtbl"]
        [::std::mem::offset_of!(IGetBindHandle, lpVtbl) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _tagPROTOCOL_ARGUMENT {
    pub szMethod: LPCWSTR,
    pub szTargetUrl: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _tagPROTOCOL_ARGUMENT"][::std::mem::size_of::<_tagPROTOCOL_ARGUMENT>() - 16usize];
    ["Alignment of _tagPROTOCOL_ARGUMENT"]
        [::std::mem::align_of::<_tagPROTOCOL_ARGUMENT>() - 8usize];
    ["Offset of field: _tagPROTOCOL_ARGUMENT::szMethod"]
        [::std::mem::offset_of!(_tagPROTOCOL_ARGUMENT, szMethod) - 0usize];
    ["Offset of field: _tagPROTOCOL_ARGUMENT::szTargetUrl"]
        [::std::mem::offset_of!(_tagPROTOCOL_ARGUMENT, szTargetUrl) - 8usize];
};
pub type PROTOCOL_ARGUMENT = _tagPROTOCOL_ARGUMENT;
pub type LPPROTOCOL_ARGUMENT = *mut _tagPROTOCOL_ARGUMENT;
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0053_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0053_v0_0_s_ifspec: RPC_IF_HANDLE;
}
pub type LPBINDCALLBACKREDIRECT = *mut IBindCallbackRedirect;
unsafe extern "C" {
    pub static IID_IBindCallbackRedirect: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindCallbackRedirectVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindCallbackRedirect,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindCallbackRedirect) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IBindCallbackRedirect) -> ULONG>,
    pub Redirect: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindCallbackRedirect,
            lpcUrl: LPCWSTR,
            vbCancel: *mut VARIANT_BOOL,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindCallbackRedirectVtbl"]
        [::std::mem::size_of::<IBindCallbackRedirectVtbl>() - 32usize];
    ["Alignment of IBindCallbackRedirectVtbl"]
        [::std::mem::align_of::<IBindCallbackRedirectVtbl>() - 8usize];
    ["Offset of field: IBindCallbackRedirectVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindCallbackRedirectVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindCallbackRedirectVtbl::AddRef"]
        [::std::mem::offset_of!(IBindCallbackRedirectVtbl, AddRef) - 8usize];
    ["Offset of field: IBindCallbackRedirectVtbl::Release"]
        [::std::mem::offset_of!(IBindCallbackRedirectVtbl, Release) - 16usize];
    ["Offset of field: IBindCallbackRedirectVtbl::Redirect"]
        [::std::mem::offset_of!(IBindCallbackRedirectVtbl, Redirect) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindCallbackRedirect {
    pub lpVtbl: *mut IBindCallbackRedirectVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindCallbackRedirect"][::std::mem::size_of::<IBindCallbackRedirect>() - 8usize];
    ["Alignment of IBindCallbackRedirect"]
        [::std::mem::align_of::<IBindCallbackRedirect>() - 8usize];
    ["Offset of field: IBindCallbackRedirect::lpVtbl"]
        [::std::mem::offset_of!(IBindCallbackRedirect, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0054_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0054_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static IID_IBindHttpSecurity: IID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindHttpSecurityVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHttpSecurity,
            riid: *const IID,
            ppvObject: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindHttpSecurity) -> ULONG>,
    pub Release: ::std::option::Option<unsafe extern "C" fn(This: *mut IBindHttpSecurity) -> ULONG>,
    pub GetIgnoreCertMask: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IBindHttpSecurity,
            pdwIgnoreCertMask: *mut DWORD,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindHttpSecurityVtbl"][::std::mem::size_of::<IBindHttpSecurityVtbl>() - 32usize];
    ["Alignment of IBindHttpSecurityVtbl"]
        [::std::mem::align_of::<IBindHttpSecurityVtbl>() - 8usize];
    ["Offset of field: IBindHttpSecurityVtbl::QueryInterface"]
        [::std::mem::offset_of!(IBindHttpSecurityVtbl, QueryInterface) - 0usize];
    ["Offset of field: IBindHttpSecurityVtbl::AddRef"]
        [::std::mem::offset_of!(IBindHttpSecurityVtbl, AddRef) - 8usize];
    ["Offset of field: IBindHttpSecurityVtbl::Release"]
        [::std::mem::offset_of!(IBindHttpSecurityVtbl, Release) - 16usize];
    ["Offset of field: IBindHttpSecurityVtbl::GetIgnoreCertMask"]
        [::std::mem::offset_of!(IBindHttpSecurityVtbl, GetIgnoreCertMask) - 24usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IBindHttpSecurity {
    pub lpVtbl: *mut IBindHttpSecurityVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IBindHttpSecurity"][::std::mem::size_of::<IBindHttpSecurity>() - 8usize];
    ["Alignment of IBindHttpSecurity"][::std::mem::align_of::<IBindHttpSecurity>() - 8usize];
    ["Offset of field: IBindHttpSecurity::lpVtbl"]
        [::std::mem::offset_of!(IBindHttpSecurity, lpVtbl) - 0usize];
};
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0055_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_urlmon_0000_0055_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn IBinding_GetBindResult_Proxy(
        This: *mut IBinding,
        pclsidProtocol: *mut CLSID,
        pdwResult: *mut DWORD,
        pszResult: *mut LPOLESTR,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBinding_GetBindResult_Stub(
        This: *mut IBinding,
        pclsidProtocol: *mut CLSID,
        pdwResult: *mut DWORD,
        pszResult: *mut LPOLESTR,
        dwReserved: DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_GetBindInfo_Proxy(
        This: *mut IBindStatusCallback,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut BINDINFO,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_GetBindInfo_Stub(
        This: *mut IBindStatusCallback,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut RemBINDINFO,
        pstgmed: *mut RemSTGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_OnDataAvailable_Proxy(
        This: *mut IBindStatusCallback,
        grfBSCF: DWORD,
        dwSize: DWORD,
        pformatetc: *mut FORMATETC,
        pstgmed: *mut STGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallback_OnDataAvailable_Stub(
        This: *mut IBindStatusCallback,
        grfBSCF: DWORD,
        dwSize: DWORD,
        pformatetc: *mut RemFORMATETC,
        pstgmed: *mut RemSTGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallbackEx_GetBindInfoEx_Proxy(
        This: *mut IBindStatusCallbackEx,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut BINDINFO,
        grfBINDF2: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindStatusCallbackEx_GetBindInfoEx_Stub(
        This: *mut IBindStatusCallbackEx,
        grfBINDF: *mut DWORD,
        pbindinfo: *mut RemBINDINFO,
        pstgmed: *mut RemSTGMEDIUM,
        grfBINDF2: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetInfo_QueryOption_Proxy(
        This: *mut IWinInetInfo,
        dwOption: DWORD,
        pBuffer: LPVOID,
        pcbBuf: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetInfo_QueryOption_Stub(
        This: *mut IWinInetInfo,
        dwOption: DWORD,
        pBuffer: *mut BYTE,
        pcbBuf: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetHttpInfo_QueryInfo_Proxy(
        This: *mut IWinInetHttpInfo,
        dwOption: DWORD,
        pBuffer: LPVOID,
        pcbBuf: *mut DWORD,
        pdwFlags: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IWinInetHttpInfo_QueryInfo_Stub(
        This: *mut IWinInetHttpInfo,
        dwOption: DWORD,
        pBuffer: *mut BYTE,
        pcbBuf: *mut DWORD,
        pdwFlags: *mut DWORD,
        pdwReserved: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_MonikerBindToStorage_Proxy(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_MonikerBindToStorage_Stub(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_MonikerBindToObject_Proxy(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IBindHost_MonikerBindToObject_Stub(
        This: *mut IBindHost,
        pMk: *mut IMoniker,
        pBC: *mut IBindCtx,
        pBSC: *mut IBindStatusCallback,
        riid: *const IID,
        ppvObj: *mut *mut IUnknown,
    ) -> HRESULT;
}
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_NORMAL: PIDMSI_STATUS_VALUE = 0;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_NEW: PIDMSI_STATUS_VALUE = 1;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_PRELIM: PIDMSI_STATUS_VALUE = 2;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_DRAFT: PIDMSI_STATUS_VALUE = 3;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_INPROGRESS: PIDMSI_STATUS_VALUE = 4;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_EDIT: PIDMSI_STATUS_VALUE = 5;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_REVIEW: PIDMSI_STATUS_VALUE = 6;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_PROOF: PIDMSI_STATUS_VALUE = 7;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_FINAL: PIDMSI_STATUS_VALUE = 8;
pub const PIDMSI_STATUS_VALUE_PIDMSI_STATUS_OTHER: PIDMSI_STATUS_VALUE = 32767;
pub type PIDMSI_STATUS_VALUE = ::std::os::raw::c_int;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSERIALIZEDPROPERTYVALUE {
    pub dwType: DWORD,
    pub rgb: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSERIALIZEDPROPERTYVALUE"]
        [::std::mem::size_of::<tagSERIALIZEDPROPERTYVALUE>() - 8usize];
    ["Alignment of tagSERIALIZEDPROPERTYVALUE"]
        [::std::mem::align_of::<tagSERIALIZEDPROPERTYVALUE>() - 4usize];
    ["Offset of field: tagSERIALIZEDPROPERTYVALUE::dwType"]
        [::std::mem::offset_of!(tagSERIALIZEDPROPERTYVALUE, dwType) - 0usize];
    ["Offset of field: tagSERIALIZEDPROPERTYVALUE::rgb"]
        [::std::mem::offset_of!(tagSERIALIZEDPROPERTYVALUE, rgb) - 4usize];
};
pub type SERIALIZEDPROPERTYVALUE = tagSERIALIZEDPROPERTYVALUE;
unsafe extern "C" {
    pub fn StgConvertVariantToProperty(
        pvar: *const PROPVARIANT,
        CodePage: USHORT,
        pprop: *mut SERIALIZEDPROPERTYVALUE,
        pcb: *mut ULONG,
        pid: PROPID,
        fReserved: BOOLEAN,
        pcIndirect: *mut ULONG,
    ) -> *mut SERIALIZEDPROPERTYVALUE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_propidl_0000_0004_v0_0_c_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub static mut __MIDL_itf_propidl_0000_0004_v0_0_s_ifspec: RPC_IF_HANDLE;
}
unsafe extern "C" {
    pub fn CreateStdProgressIndicator(
        hwndParent: HWND,
        pszTitle: LPCOLESTR,
        pIbscCaller: *mut IBindStatusCallback,
        ppIbsc: *mut *mut IBindStatusCallback,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static IID_StdOle: IID;
}
unsafe extern "C" {
    pub fn SysAllocString(psz: *const OLECHAR) -> BSTR;
}
unsafe extern "C" {
    pub fn SysReAllocString(pbstr: *mut BSTR, psz: *const OLECHAR) -> INT;
}
unsafe extern "C" {
    pub fn SysAllocStringLen(strIn: *const OLECHAR, ui: UINT) -> BSTR;
}
unsafe extern "C" {
    pub fn SysReAllocStringLen(
        pbstr: *mut BSTR,
        psz: *const OLECHAR,
        len: ::std::os::raw::c_uint,
    ) -> INT;
}
unsafe extern "C" {
    pub fn SysAddRefString(bstrString: BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn SysReleaseString(bstrString: BSTR);
}
unsafe extern "C" {
    pub fn SysFreeString(bstrString: BSTR);
}
unsafe extern "C" {
    pub fn SysStringLen(pbstr: BSTR) -> UINT;
}
unsafe extern "C" {
    pub fn SysStringByteLen(bstr: BSTR) -> UINT;
}
unsafe extern "C" {
    pub fn SysAllocStringByteLen(psz: LPCSTR, len: UINT) -> BSTR;
}
unsafe extern "C" {
    pub fn DosDateTimeToVariantTime(wDosDate: USHORT, wDosTime: USHORT, pvtime: *mut DOUBLE)
        -> INT;
}
unsafe extern "C" {
    pub fn VariantTimeToDosDateTime(
        vtime: DOUBLE,
        pwDosDate: *mut USHORT,
        pwDosTime: *mut USHORT,
    ) -> INT;
}
unsafe extern "C" {
    pub fn SystemTimeToVariantTime(lpSystemTime: LPSYSTEMTIME, pvtime: *mut DOUBLE) -> INT;
}
unsafe extern "C" {
    pub fn VariantTimeToSystemTime(vtime: DOUBLE, lpSystemTime: LPSYSTEMTIME) -> INT;
}
unsafe extern "C" {
    pub fn SafeArrayAllocDescriptor(cDims: UINT, ppsaOut: *mut *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayAllocDescriptorEx(
        vt: VARTYPE,
        cDims: UINT,
        ppsaOut: *mut *mut SAFEARRAY,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayAllocData(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayCreate(
        vt: VARTYPE,
        cDims: UINT,
        rgsabound: *mut SAFEARRAYBOUND,
    ) -> *mut SAFEARRAY;
}
unsafe extern "C" {
    pub fn SafeArrayCreateEx(
        vt: VARTYPE,
        cDims: UINT,
        rgsabound: *mut SAFEARRAYBOUND,
        pvExtra: PVOID,
    ) -> *mut SAFEARRAY;
}
unsafe extern "C" {
    pub fn SafeArrayCopyData(psaSource: *mut SAFEARRAY, psaTarget: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayReleaseDescriptor(psa: *mut SAFEARRAY);
}
unsafe extern "C" {
    pub fn SafeArrayDestroyDescriptor(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayReleaseData(pData: PVOID);
}
unsafe extern "C" {
    pub fn SafeArrayDestroyData(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayAddRef(psa: *mut SAFEARRAY, ppDataToRelease: *mut PVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayDestroy(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayRedim(psa: *mut SAFEARRAY, psaboundNew: *mut SAFEARRAYBOUND) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetDim(psa: *mut SAFEARRAY) -> UINT;
}
unsafe extern "C" {
    pub fn SafeArrayGetElemsize(psa: *mut SAFEARRAY) -> UINT;
}
unsafe extern "C" {
    pub fn SafeArrayGetUBound(psa: *mut SAFEARRAY, nDim: UINT, plUbound: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetLBound(psa: *mut SAFEARRAY, nDim: UINT, plLbound: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayLock(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayUnlock(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayAccessData(
        psa: *mut SAFEARRAY,
        ppvData: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayUnaccessData(psa: *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetElement(
        psa: *mut SAFEARRAY,
        rgIndices: *mut LONG,
        pv: *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayPutElement(
        psa: *mut SAFEARRAY,
        rgIndices: *mut LONG,
        pv: *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayCopy(psa: *mut SAFEARRAY, ppsaOut: *mut *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayPtrOfIndex(
        psa: *mut SAFEARRAY,
        rgIndices: *mut LONG,
        ppvData: *mut *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArraySetRecordInfo(psa: *mut SAFEARRAY, prinfo: *mut IRecordInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetRecordInfo(psa: *mut SAFEARRAY, prinfo: *mut *mut IRecordInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArraySetIID(psa: *mut SAFEARRAY, guid: *const GUID) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetIID(psa: *mut SAFEARRAY, pguid: *mut GUID) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayGetVartype(psa: *mut SAFEARRAY, pvt: *mut VARTYPE) -> HRESULT;
}
unsafe extern "C" {
    pub fn SafeArrayCreateVector(vt: VARTYPE, lLbound: LONG, cElements: ULONG) -> *mut SAFEARRAY;
}
unsafe extern "C" {
    pub fn SafeArrayCreateVectorEx(
        vt: VARTYPE,
        lLbound: LONG,
        cElements: ULONG,
        pvExtra: PVOID,
    ) -> *mut SAFEARRAY;
}
unsafe extern "C" {
    pub fn VariantInit(pvarg: *mut VARIANTARG);
}
unsafe extern "C" {
    pub fn VariantClear(pvarg: *mut VARIANTARG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VariantCopy(pvargDest: *mut VARIANTARG, pvargSrc: *const VARIANTARG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VariantCopyInd(pvarDest: *mut VARIANT, pvargSrc: *const VARIANTARG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VariantChangeType(
        pvargDest: *mut VARIANTARG,
        pvarSrc: *const VARIANTARG,
        wFlags: USHORT,
        vt: VARTYPE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VariantChangeTypeEx(
        pvargDest: *mut VARIANTARG,
        pvarSrc: *const VARIANTARG,
        lcid: LCID,
        wFlags: USHORT,
        vt: VARTYPE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VectorFromBstr(bstr: BSTR, ppsa: *mut *mut SAFEARRAY) -> HRESULT;
}
unsafe extern "C" {
    pub fn BstrFromVector(psa: *mut SAFEARRAY, pbstr: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromI2(sIn: SHORT, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromI4(lIn: LONG, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromI8(i64In: LONG64, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromR4(fltIn: FLOAT, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromR8(dblIn: DOUBLE, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromCy(cyIn: CY, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromDate(dateIn: DATE, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromStr(strIn: LPCOLESTR, lcid: LCID, dwFlags: ULONG, pbOut: *mut BYTE)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromBool(boolIn: VARIANT_BOOL, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromI1(cIn: CHAR, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromUI2(uiIn: USHORT, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromUI4(ulIn: ULONG, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromUI8(ui64In: ULONG64, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI1FromDec(pdecIn: *const DECIMAL, pbOut: *mut BYTE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromUI1(bIn: BYTE, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromI4(lIn: LONG, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromI8(i64In: LONG64, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromR4(fltIn: FLOAT, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromR8(dblIn: DOUBLE, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromCy(cyIn: CY, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromDate(dateIn: DATE, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromStr(strIn: LPCOLESTR, lcid: LCID, dwFlags: ULONG, psOut: *mut SHORT)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromDisp(pdispIn: *mut IDispatch, lcid: LCID, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromBool(boolIn: VARIANT_BOOL, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromI1(cIn: CHAR, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromUI2(uiIn: USHORT, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromUI4(ulIn: ULONG, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromUI8(ui64In: ULONG64, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI2FromDec(pdecIn: *const DECIMAL, psOut: *mut SHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromUI1(bIn: BYTE, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromI2(sIn: SHORT, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromI8(i64In: LONG64, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromR4(fltIn: FLOAT, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromR8(dblIn: DOUBLE, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromCy(cyIn: CY, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromDate(dateIn: DATE, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromStr(strIn: LPCOLESTR, lcid: LCID, dwFlags: ULONG, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromDisp(pdispIn: *mut IDispatch, lcid: LCID, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromBool(boolIn: VARIANT_BOOL, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromI1(cIn: CHAR, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromUI2(uiIn: USHORT, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromUI4(ulIn: ULONG, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromUI8(ui64In: ULONG64, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI4FromDec(pdecIn: *const DECIMAL, plOut: *mut LONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromUI1(bIn: BYTE, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromI2(sIn: SHORT, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromR4(fltIn: FLOAT, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromR8(dblIn: DOUBLE, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromCy(cyIn: CY, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromDate(dateIn: DATE, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pi64Out: *mut LONG64,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromBool(boolIn: VARIANT_BOOL, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromI1(cIn: CHAR, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromUI2(uiIn: USHORT, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromUI4(ulIn: ULONG, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromUI8(ui64In: ULONG64, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI8FromDec(pdecIn: *const DECIMAL, pi64Out: *mut LONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromUI1(bIn: BYTE, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromI2(sIn: SHORT, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromI4(lIn: LONG, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromI8(i64In: LONG64, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromR8(dblIn: DOUBLE, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromCy(cyIn: CY, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromDate(dateIn: DATE, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pfltOut: *mut FLOAT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromBool(boolIn: VARIANT_BOOL, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromI1(cIn: CHAR, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromUI2(uiIn: USHORT, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromUI4(ulIn: ULONG, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromUI8(ui64In: ULONG64, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4FromDec(pdecIn: *const DECIMAL, pfltOut: *mut FLOAT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromUI1(bIn: BYTE, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromI2(sIn: SHORT, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromI4(lIn: LONG, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromI8(i64In: LONG64, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromR4(fltIn: FLOAT, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromCy(cyIn: CY, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromDate(dateIn: DATE, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pdblOut: *mut DOUBLE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromBool(boolIn: VARIANT_BOOL, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromI1(cIn: CHAR, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromUI2(uiIn: USHORT, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromUI4(ulIn: ULONG, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromUI8(ui64In: ULONG64, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8FromDec(pdecIn: *const DECIMAL, pdblOut: *mut DOUBLE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromUI1(bIn: BYTE, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromI2(sIn: SHORT, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromI4(lIn: LONG, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromI8(i64In: LONG64, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromR4(fltIn: FLOAT, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromR8(dblIn: DOUBLE, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromCy(cyIn: CY, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pdateOut: *mut DATE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromDisp(pdispIn: *mut IDispatch, lcid: LCID, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromBool(boolIn: VARIANT_BOOL, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromI1(cIn: CHAR, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromUI2(uiIn: USHORT, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromUI4(ulIn: ULONG, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromUI8(ui64In: ULONG64, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromDec(pdecIn: *const DECIMAL, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromUI1(bIn: BYTE, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromI2(sIn: SHORT, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromI4(lIn: LONG, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromI8(i64In: LONG64, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromR4(fltIn: FLOAT, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromR8(dblIn: DOUBLE, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromDate(dateIn: DATE, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromStr(strIn: LPCOLESTR, lcid: LCID, dwFlags: ULONG, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromDisp(pdispIn: *mut IDispatch, lcid: LCID, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromBool(boolIn: VARIANT_BOOL, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromI1(cIn: CHAR, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromUI2(uiIn: USHORT, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromUI4(ulIn: ULONG, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromUI8(ui64In: ULONG64, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFromDec(pdecIn: *const DECIMAL, pcyOut: *mut CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromUI1(bVal: BYTE, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromI2(iVal: SHORT, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromI4(lIn: LONG, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromI8(i64In: LONG64, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromR4(fltIn: FLOAT, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromR8(dblIn: DOUBLE, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromCy(cyIn: CY, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromDate(
        dateIn: DATE,
        lcid: LCID,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromDisp(
        pdispIn: *mut IDispatch,
        lcid: LCID,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromBool(
        boolIn: VARIANT_BOOL,
        lcid: LCID,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromI1(cIn: CHAR, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromUI2(uiIn: USHORT, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromUI4(ulIn: ULONG, lcid: LCID, dwFlags: ULONG, pbstrOut: *mut BSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromUI8(
        ui64In: ULONG64,
        lcid: LCID,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrFromDec(
        pdecIn: *const DECIMAL,
        lcid: LCID,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromUI1(bIn: BYTE, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromI2(sIn: SHORT, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromI4(lIn: LONG, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromI8(i64In: LONG64, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromR4(fltIn: FLOAT, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromR8(dblIn: DOUBLE, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromDate(dateIn: DATE, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromCy(cyIn: CY, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pboolOut: *mut VARIANT_BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromDisp(
        pdispIn: *mut IDispatch,
        lcid: LCID,
        pboolOut: *mut VARIANT_BOOL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromI1(cIn: CHAR, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromUI2(uiIn: USHORT, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromUI4(ulIn: ULONG, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromUI8(i64In: ULONG64, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBoolFromDec(pdecIn: *const DECIMAL, pboolOut: *mut VARIANT_BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromUI1(bIn: BYTE, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromI2(uiIn: SHORT, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromI4(lIn: LONG, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromI8(i64In: LONG64, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromR4(fltIn: FLOAT, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromR8(dblIn: DOUBLE, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromDate(dateIn: DATE, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromCy(cyIn: CY, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromStr(strIn: LPCOLESTR, lcid: LCID, dwFlags: ULONG, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromBool(boolIn: VARIANT_BOOL, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromUI2(uiIn: USHORT, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromUI4(ulIn: ULONG, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromUI8(i64In: ULONG64, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarI1FromDec(pdecIn: *const DECIMAL, pcOut: *mut CHAR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromUI1(bIn: BYTE, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromI2(uiIn: SHORT, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromI4(lIn: LONG, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromI8(i64In: LONG64, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromR4(fltIn: FLOAT, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromR8(dblIn: DOUBLE, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromDate(dateIn: DATE, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromCy(cyIn: CY, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        puiOut: *mut USHORT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromDisp(pdispIn: *mut IDispatch, lcid: LCID, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromBool(boolIn: VARIANT_BOOL, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromI1(cIn: CHAR, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromUI4(ulIn: ULONG, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromUI8(i64In: ULONG64, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI2FromDec(pdecIn: *const DECIMAL, puiOut: *mut USHORT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromUI1(bIn: BYTE, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromI2(uiIn: SHORT, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromI4(lIn: LONG, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromI8(i64In: LONG64, plOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromR4(fltIn: FLOAT, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromR8(dblIn: DOUBLE, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromDate(dateIn: DATE, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromCy(cyIn: CY, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pulOut: *mut ULONG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromBool(boolIn: VARIANT_BOOL, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromI1(cIn: CHAR, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromUI2(uiIn: USHORT, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromUI8(ui64In: ULONG64, plOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI4FromDec(pdecIn: *const DECIMAL, pulOut: *mut ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromUI1(bIn: BYTE, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromI2(sIn: SHORT, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromI4(lIn: LONG, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromI8(ui64In: LONG64, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromR4(fltIn: FLOAT, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromR8(dblIn: DOUBLE, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromCy(cyIn: CY, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromDate(dateIn: DATE, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pi64Out: *mut ULONG64,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromDisp(pdispIn: *mut IDispatch, lcid: LCID, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromBool(boolIn: VARIANT_BOOL, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromI1(cIn: CHAR, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromUI2(uiIn: USHORT, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromUI4(ulIn: ULONG, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUI8FromDec(pdecIn: *const DECIMAL, pi64Out: *mut ULONG64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromUI1(bIn: BYTE, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromI2(uiIn: SHORT, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromI4(lIn: LONG, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromI8(i64In: LONG64, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromR4(fltIn: FLOAT, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromR8(dblIn: DOUBLE, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromDate(dateIn: DATE, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromCy(cyIn: CY, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pdecOut: *mut DECIMAL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromDisp(pdispIn: *mut IDispatch, lcid: LCID, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromBool(boolIn: VARIANT_BOOL, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromI1(cIn: CHAR, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromUI2(uiIn: USHORT, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromUI4(ulIn: ULONG, pdecOut: *mut DECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFromUI8(ui64In: ULONG64, pdecOut: *mut DECIMAL) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NUMPARSE {
    pub cDig: INT,
    pub dwInFlags: ULONG,
    pub dwOutFlags: ULONG,
    pub cchUsed: INT,
    pub nBaseShift: INT,
    pub nPwr10: INT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of NUMPARSE"][::std::mem::size_of::<NUMPARSE>() - 24usize];
    ["Alignment of NUMPARSE"][::std::mem::align_of::<NUMPARSE>() - 4usize];
    ["Offset of field: NUMPARSE::cDig"][::std::mem::offset_of!(NUMPARSE, cDig) - 0usize];
    ["Offset of field: NUMPARSE::dwInFlags"][::std::mem::offset_of!(NUMPARSE, dwInFlags) - 4usize];
    ["Offset of field: NUMPARSE::dwOutFlags"]
        [::std::mem::offset_of!(NUMPARSE, dwOutFlags) - 8usize];
    ["Offset of field: NUMPARSE::cchUsed"][::std::mem::offset_of!(NUMPARSE, cchUsed) - 12usize];
    ["Offset of field: NUMPARSE::nBaseShift"]
        [::std::mem::offset_of!(NUMPARSE, nBaseShift) - 16usize];
    ["Offset of field: NUMPARSE::nPwr10"][::std::mem::offset_of!(NUMPARSE, nPwr10) - 20usize];
};
unsafe extern "C" {
    pub fn VarParseNumFromStr(
        strIn: LPCOLESTR,
        lcid: LCID,
        dwFlags: ULONG,
        pnumprs: *mut NUMPARSE,
        rgbDig: *mut BYTE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarNumFromParseNum(
        pnumprs: *mut NUMPARSE,
        rgbDig: *mut BYTE,
        dwVtBits: ULONG,
        pvar: *mut VARIANT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarAdd(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarAnd(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCat(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDiv(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarEqv(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarIdiv(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarImp(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarMod(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarMul(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarOr(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarPow(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarSub(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarXor(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarAbs(pvarIn: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFix(pvarIn: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarInt(pvarIn: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarNeg(pvarIn: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarNot(pvarIn: LPVARIANT, pvarResult: LPVARIANT) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarRound(
        pvarIn: LPVARIANT,
        cDecimals: ::std::os::raw::c_int,
        pvarResult: LPVARIANT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCmp(pvarLeft: LPVARIANT, pvarRight: LPVARIANT, lcid: LCID, dwFlags: ULONG)
        -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecAdd(pdecLeft: LPDECIMAL, pdecRight: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecDiv(pdecLeft: LPDECIMAL, pdecRight: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecMul(pdecLeft: LPDECIMAL, pdecRight: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecSub(pdecLeft: LPDECIMAL, pdecRight: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecAbs(pdecIn: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecFix(pdecIn: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecInt(pdecIn: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecNeg(pdecIn: LPDECIMAL, pdecResult: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecRound(
        pdecIn: LPDECIMAL,
        cDecimals: ::std::os::raw::c_int,
        pdecResult: LPDECIMAL,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecCmp(pdecLeft: LPDECIMAL, pdecRight: LPDECIMAL) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDecCmpR8(pdecLeft: LPDECIMAL, dblRight: f64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyAdd(cyLeft: CY, cyRight: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyMul(cyLeft: CY, cyRight: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyMulI4(cyLeft: CY, lRight: LONG, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyMulI8(cyLeft: CY, lRight: LONG64, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCySub(cyLeft: CY, cyRight: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyAbs(cyIn: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyFix(cyIn: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyInt(cyIn: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyNeg(cyIn: CY, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyRound(cyIn: CY, cDecimals: ::std::os::raw::c_int, pcyResult: LPCY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyCmp(cyLeft: CY, cyRight: CY) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarCyCmpR8(cyLeft: CY, dblRight: f64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrCat(bstrLeft: BSTR, bstrRight: BSTR, pbstrResult: LPBSTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarBstrCmp(bstrLeft: BSTR, bstrRight: BSTR, lcid: LCID, dwFlags: ULONG) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8Pow(dblLeft: f64, dblRight: f64, pdblResult: *mut f64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR4CmpR8(fltLeft: f32, dblRight: f64) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarR8Round(
        dblIn: f64,
        cDecimals: ::std::os::raw::c_int,
        pdblResult: *mut f64,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct UDATE {
    pub st: SYSTEMTIME,
    pub wDayOfYear: USHORT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of UDATE"][::std::mem::size_of::<UDATE>() - 18usize];
    ["Alignment of UDATE"][::std::mem::align_of::<UDATE>() - 2usize];
    ["Offset of field: UDATE::st"][::std::mem::offset_of!(UDATE, st) - 0usize];
    ["Offset of field: UDATE::wDayOfYear"][::std::mem::offset_of!(UDATE, wDayOfYear) - 16usize];
};
unsafe extern "C" {
    pub fn VarDateFromUdate(pudateIn: *mut UDATE, dwFlags: ULONG, pdateOut: *mut DATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarDateFromUdateEx(
        pudateIn: *mut UDATE,
        lcid: LCID,
        dwFlags: ULONG,
        pdateOut: *mut DATE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarUdateFromDate(dateIn: DATE, dwFlags: ULONG, pudateOut: *mut UDATE) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetAltMonthNames(lcid: LCID, prgp: *mut *mut LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormat(
        pvarIn: LPVARIANT,
        pstrFormat: LPOLESTR,
        iFirstDay: ::std::os::raw::c_int,
        iFirstWeek: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormatDateTime(
        pvarIn: LPVARIANT,
        iNamedFormat: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormatNumber(
        pvarIn: LPVARIANT,
        iNumDig: ::std::os::raw::c_int,
        iIncLead: ::std::os::raw::c_int,
        iUseParens: ::std::os::raw::c_int,
        iGroup: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormatPercent(
        pvarIn: LPVARIANT,
        iNumDig: ::std::os::raw::c_int,
        iIncLead: ::std::os::raw::c_int,
        iUseParens: ::std::os::raw::c_int,
        iGroup: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormatCurrency(
        pvarIn: LPVARIANT,
        iNumDig: ::std::os::raw::c_int,
        iIncLead: ::std::os::raw::c_int,
        iUseParens: ::std::os::raw::c_int,
        iGroup: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarWeekdayName(
        iWeekday: ::std::os::raw::c_int,
        fAbbrev: ::std::os::raw::c_int,
        iFirstDay: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarMonthName(
        iMonth: ::std::os::raw::c_int,
        fAbbrev: ::std::os::raw::c_int,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarFormatFromTokens(
        pvarIn: LPVARIANT,
        pstrFormat: LPOLESTR,
        pbTokCur: LPBYTE,
        dwFlags: ULONG,
        pbstrOut: *mut BSTR,
        lcid: LCID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn VarTokenizeFormatString(
        pstrFormat: LPOLESTR,
        rgbTok: LPBYTE,
        cbTok: ::std::os::raw::c_int,
        iFirstDay: ::std::os::raw::c_int,
        iFirstWeek: ::std::os::raw::c_int,
        lcid: LCID,
        pcbActual: *mut ::std::os::raw::c_int,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn LHashValOfNameSysA(syskind: SYSKIND, lcid: LCID, szName: LPCSTR) -> ULONG;
}
unsafe extern "C" {
    pub fn LHashValOfNameSys(syskind: SYSKIND, lcid: LCID, szName: *const OLECHAR) -> ULONG;
}
unsafe extern "C" {
    pub fn LoadTypeLib(szFile: LPCOLESTR, pptlib: *mut *mut ITypeLib) -> HRESULT;
}
pub const tagREGKIND_REGKIND_DEFAULT: tagREGKIND = 0;
pub const tagREGKIND_REGKIND_REGISTER: tagREGKIND = 1;
pub const tagREGKIND_REGKIND_NONE: tagREGKIND = 2;
pub type tagREGKIND = ::std::os::raw::c_int;
pub use self::tagREGKIND as REGKIND;
unsafe extern "C" {
    pub fn LoadTypeLibEx(
        szFile: LPCOLESTR,
        regkind: REGKIND,
        pptlib: *mut *mut ITypeLib,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn LoadRegTypeLib(
        rguid: *const GUID,
        wVerMajor: WORD,
        wVerMinor: WORD,
        lcid: LCID,
        pptlib: *mut *mut ITypeLib,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn QueryPathOfRegTypeLib(
        guid: *const GUID,
        wMaj: USHORT,
        wMin: USHORT,
        lcid: LCID,
        lpbstrPathName: LPBSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterTypeLib(
        ptlib: *mut ITypeLib,
        szFullPath: LPCOLESTR,
        szHelpDir: LPCOLESTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UnRegisterTypeLib(
        libID: *const GUID,
        wVerMajor: WORD,
        wVerMinor: WORD,
        lcid: LCID,
        syskind: SYSKIND,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterTypeLibForUser(
        ptlib: *mut ITypeLib,
        szFullPath: *mut OLECHAR,
        szHelpDir: *mut OLECHAR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn UnRegisterTypeLibForUser(
        libID: *const GUID,
        wMajorVerNum: WORD,
        wMinorVerNum: WORD,
        lcid: LCID,
        syskind: SYSKIND,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateTypeLib(
        syskind: SYSKIND,
        szFile: LPCOLESTR,
        ppctlib: *mut *mut ICreateTypeLib,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateTypeLib2(
        syskind: SYSKIND,
        szFile: LPCOLESTR,
        ppctlib: *mut *mut ICreateTypeLib2,
    ) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPARAMDATA {
    pub szName: *mut OLECHAR,
    pub vt: VARTYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPARAMDATA"][::std::mem::size_of::<tagPARAMDATA>() - 16usize];
    ["Alignment of tagPARAMDATA"][::std::mem::align_of::<tagPARAMDATA>() - 8usize];
    ["Offset of field: tagPARAMDATA::szName"]
        [::std::mem::offset_of!(tagPARAMDATA, szName) - 0usize];
    ["Offset of field: tagPARAMDATA::vt"][::std::mem::offset_of!(tagPARAMDATA, vt) - 8usize];
};
pub type PARAMDATA = tagPARAMDATA;
pub type LPPARAMDATA = *mut tagPARAMDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagMETHODDATA {
    pub szName: *mut OLECHAR,
    pub ppdata: *mut PARAMDATA,
    pub dispid: DISPID,
    pub iMeth: UINT,
    pub cc: CALLCONV,
    pub cArgs: UINT,
    pub wFlags: WORD,
    pub vtReturn: VARTYPE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagMETHODDATA"][::std::mem::size_of::<tagMETHODDATA>() - 40usize];
    ["Alignment of tagMETHODDATA"][::std::mem::align_of::<tagMETHODDATA>() - 8usize];
    ["Offset of field: tagMETHODDATA::szName"]
        [::std::mem::offset_of!(tagMETHODDATA, szName) - 0usize];
    ["Offset of field: tagMETHODDATA::ppdata"]
        [::std::mem::offset_of!(tagMETHODDATA, ppdata) - 8usize];
    ["Offset of field: tagMETHODDATA::dispid"]
        [::std::mem::offset_of!(tagMETHODDATA, dispid) - 16usize];
    ["Offset of field: tagMETHODDATA::iMeth"]
        [::std::mem::offset_of!(tagMETHODDATA, iMeth) - 20usize];
    ["Offset of field: tagMETHODDATA::cc"][::std::mem::offset_of!(tagMETHODDATA, cc) - 24usize];
    ["Offset of field: tagMETHODDATA::cArgs"]
        [::std::mem::offset_of!(tagMETHODDATA, cArgs) - 28usize];
    ["Offset of field: tagMETHODDATA::wFlags"]
        [::std::mem::offset_of!(tagMETHODDATA, wFlags) - 32usize];
    ["Offset of field: tagMETHODDATA::vtReturn"]
        [::std::mem::offset_of!(tagMETHODDATA, vtReturn) - 34usize];
};
pub type METHODDATA = tagMETHODDATA;
pub type LPMETHODDATA = *mut tagMETHODDATA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagINTERFACEDATA {
    pub pmethdata: *mut METHODDATA,
    pub cMembers: UINT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagINTERFACEDATA"][::std::mem::size_of::<tagINTERFACEDATA>() - 16usize];
    ["Alignment of tagINTERFACEDATA"][::std::mem::align_of::<tagINTERFACEDATA>() - 8usize];
    ["Offset of field: tagINTERFACEDATA::pmethdata"]
        [::std::mem::offset_of!(tagINTERFACEDATA, pmethdata) - 0usize];
    ["Offset of field: tagINTERFACEDATA::cMembers"]
        [::std::mem::offset_of!(tagINTERFACEDATA, cMembers) - 8usize];
};
pub type INTERFACEDATA = tagINTERFACEDATA;
pub type LPINTERFACEDATA = *mut tagINTERFACEDATA;
unsafe extern "C" {
    pub fn DispGetParam(
        pdispparams: *mut DISPPARAMS,
        position: UINT,
        vtTarg: VARTYPE,
        pvarResult: *mut VARIANT,
        puArgErr: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DispGetIDsOfNames(
        ptinfo: *mut ITypeInfo,
        rgszNames: *mut LPOLESTR,
        cNames: UINT,
        rgdispid: *mut DISPID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DispInvoke(
        _this: *mut ::std::os::raw::c_void,
        ptinfo: *mut ITypeInfo,
        dispidMember: DISPID,
        wFlags: WORD,
        pparams: *mut DISPPARAMS,
        pvarResult: *mut VARIANT,
        pexcepinfo: *mut EXCEPINFO,
        puArgErr: *mut UINT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateDispTypeInfo(
        pidata: *mut INTERFACEDATA,
        lcid: LCID,
        pptinfo: *mut *mut ITypeInfo,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateStdDispatch(
        punkOuter: *mut IUnknown,
        pvThis: *mut ::std::os::raw::c_void,
        ptinfo: *mut ITypeInfo,
        ppunkStdDisp: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn DispCallFunc(
        pvInstance: *mut ::std::os::raw::c_void,
        oVft: ULONG_PTR,
        cc: CALLCONV,
        vtReturn: VARTYPE,
        cActuals: UINT,
        prgvt: *mut VARTYPE,
        prgpvarg: *mut *mut VARIANTARG,
        pvargResult: *mut VARIANT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterActiveObject(
        punk: *mut IUnknown,
        rclsid: *const IID,
        dwFlags: DWORD,
        pdwRegister: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn RevokeActiveObject(
        dwRegister: DWORD,
        pvReserved: *mut ::std::os::raw::c_void,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetActiveObject(
        rclsid: *const IID,
        pvReserved: *mut ::std::os::raw::c_void,
        ppunk: *mut *mut IUnknown,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn SetErrorInfo(dwReserved: ULONG, perrinfo: *mut IErrorInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetErrorInfo(dwReserved: ULONG, pperrinfo: *mut *mut IErrorInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn CreateErrorInfo(pperrinfo: *mut *mut ICreateErrorInfo) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetRecordInfoFromTypeInfo(
        pTypeInfo: *mut ITypeInfo,
        ppRecInfo: *mut *mut IRecordInfo,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn GetRecordInfoFromGuids(
        rGuidTypeLib: *const GUID,
        uVerMajor: ULONG,
        uVerMinor: ULONG,
        lcid: LCID,
        rGuidTypeInfo: *const GUID,
        ppRecInfo: *mut *mut IRecordInfo,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OaBuildVersion() -> ULONG;
}
unsafe extern "C" {
    pub fn ClearCustData(pCustData: LPCUSTDATA);
}
unsafe extern "C" {
    pub fn OaEnablePerUserTLibRegistration();
}
unsafe extern "C" {
    pub fn OleBuildVersion() -> DWORD;
}
unsafe extern "C" {
    pub fn WriteFmtUserTypeStg(pstg: LPSTORAGE, cf: CLIPFORMAT, lpszUserType: LPOLESTR) -> HRESULT;
}
unsafe extern "C" {
    pub fn ReadFmtUserTypeStg(
        pstg: LPSTORAGE,
        pcf: *mut CLIPFORMAT,
        lplpszUserType: *mut LPOLESTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleInitialize(pvReserved: LPVOID) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleUninitialize();
}
unsafe extern "C" {
    pub fn OleQueryLinkFromData(pSrcDataObject: LPDATAOBJECT) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleQueryCreateFromData(pSrcDataObject: LPDATAOBJECT) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreate(
        rclsid: *const IID,
        riid: *const IID,
        renderopt: DWORD,
        pFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateEx(
        rclsid: *const IID,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateFromData(
        pSrcDataObj: LPDATAOBJECT,
        riid: *const IID,
        renderopt: DWORD,
        pFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateFromDataEx(
        pSrcDataObj: LPDATAOBJECT,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLinkFromData(
        pSrcDataObj: LPDATAOBJECT,
        riid: *const IID,
        renderopt: DWORD,
        pFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLinkFromDataEx(
        pSrcDataObj: LPDATAOBJECT,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateStaticFromData(
        pSrcDataObj: LPDATAOBJECT,
        iid: *const IID,
        renderopt: DWORD,
        pFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLink(
        pmkLinkSrc: LPMONIKER,
        riid: *const IID,
        renderopt: DWORD,
        lpFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLinkEx(
        pmkLinkSrc: LPMONIKER,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLinkToFile(
        lpszFileName: LPCOLESTR,
        riid: *const IID,
        renderopt: DWORD,
        lpFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateLinkToFileEx(
        lpszFileName: LPCOLESTR,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateFromFile(
        rclsid: *const IID,
        lpszFileName: LPCOLESTR,
        riid: *const IID,
        renderopt: DWORD,
        lpFormatEtc: LPFORMATETC,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateFromFileEx(
        rclsid: *const IID,
        lpszFileName: LPCOLESTR,
        riid: *const IID,
        dwFlags: DWORD,
        renderopt: DWORD,
        cFormats: ULONG,
        rgAdvf: *mut DWORD,
        rgFormatEtc: LPFORMATETC,
        lpAdviseSink: *mut IAdviseSink,
        rgdwConnection: *mut DWORD,
        pClientSite: LPOLECLIENTSITE,
        pStg: LPSTORAGE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleLoad(
        pStg: LPSTORAGE,
        riid: *const IID,
        pClientSite: LPOLECLIENTSITE,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleSave(pPS: LPPERSISTSTORAGE, pStg: LPSTORAGE, fSameAsLoad: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleLoadFromStream(
        pStm: LPSTREAM,
        iidInterface: *const IID,
        ppvObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleSaveToStream(pPStm: LPPERSISTSTREAM, pStm: LPSTREAM) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleSetContainedObject(pUnknown: LPUNKNOWN, fContained: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleNoteObjectVisible(pUnknown: LPUNKNOWN, fVisible: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn RegisterDragDrop(hwnd: HWND, pDropTarget: LPDROPTARGET) -> HRESULT;
}
unsafe extern "C" {
    pub fn RevokeDragDrop(hwnd: HWND) -> HRESULT;
}
unsafe extern "C" {
    pub fn DoDragDrop(
        pDataObj: LPDATAOBJECT,
        pDropSource: LPDROPSOURCE,
        dwOKEffects: DWORD,
        pdwEffect: LPDWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleSetClipboard(pDataObj: LPDATAOBJECT) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleGetClipboard(ppDataObj: *mut LPDATAOBJECT) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleGetClipboardWithEnterpriseInfo(
        dataObject: *mut *mut IDataObject,
        dataEnterpriseId: *mut PWSTR,
        sourceDescription: *mut PWSTR,
        targetDescription: *mut PWSTR,
        dataDescription: *mut PWSTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleFlushClipboard() -> HRESULT;
}
unsafe extern "C" {
    pub fn OleIsCurrentClipboard(pDataObj: LPDATAOBJECT) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateMenuDescriptor(
        hmenuCombined: HMENU,
        lpMenuWidths: LPOLEMENUGROUPWIDTHS,
    ) -> HOLEMENU;
}
unsafe extern "C" {
    pub fn OleSetMenuDescriptor(
        holemenu: HOLEMENU,
        hwndFrame: HWND,
        hwndActiveObject: HWND,
        lpFrame: LPOLEINPLACEFRAME,
        lpActiveObj: LPOLEINPLACEACTIVEOBJECT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleDestroyMenuDescriptor(holemenu: HOLEMENU) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleTranslateAccelerator(
        lpFrame: LPOLEINPLACEFRAME,
        lpFrameInfo: LPOLEINPLACEFRAMEINFO,
        lpmsg: LPMSG,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleDuplicateData(hSrc: HANDLE, cfFormat: CLIPFORMAT, uiFlags: UINT) -> HANDLE;
}
unsafe extern "C" {
    pub fn OleDraw(
        pUnknown: LPUNKNOWN,
        dwAspect: DWORD,
        hdcDraw: HDC,
        lprcBounds: LPCRECT,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleRun(pUnknown: LPUNKNOWN) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleIsRunning(pObject: LPOLEOBJECT) -> BOOL;
}
unsafe extern "C" {
    pub fn OleLockRunning(pUnknown: LPUNKNOWN, fLock: BOOL, fLastUnlockCloses: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn ReleaseStgMedium(arg1: LPSTGMEDIUM);
}
unsafe extern "C" {
    pub fn CreateOleAdviseHolder(ppOAHolder: *mut LPOLEADVISEHOLDER) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateDefaultHandler(
        clsid: *const IID,
        pUnkOuter: LPUNKNOWN,
        riid: *const IID,
        lplpObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleCreateEmbeddingHelper(
        clsid: *const IID,
        pUnkOuter: LPUNKNOWN,
        flags: DWORD,
        pCF: LPCLASSFACTORY,
        riid: *const IID,
        lplpObj: *mut LPVOID,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn IsAccelerator(
        hAccel: HACCEL,
        cAccelEntries: ::std::os::raw::c_int,
        lpMsg: LPMSG,
        lpwCmd: *mut WORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn OleGetIconOfFile(lpszPath: LPOLESTR, fUseFileAsLabel: BOOL) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn OleGetIconOfClass(
        rclsid: *const IID,
        lpszLabel: LPOLESTR,
        fUseTypeAsLabel: BOOL,
    ) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn OleMetafilePictFromIconAndLabel(
        hIcon: HICON,
        lpszLabel: LPOLESTR,
        lpszSourceFile: LPOLESTR,
        iIconIndex: UINT,
    ) -> HGLOBAL;
}
unsafe extern "C" {
    pub fn OleRegGetUserType(
        clsid: *const IID,
        dwFormOfType: DWORD,
        pszUserType: *mut LPOLESTR,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleRegGetMiscStatus(
        clsid: *const IID,
        dwAspect: DWORD,
        pdwStatus: *mut DWORD,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleRegEnumFormatEtc(
        clsid: *const IID,
        dwDirection: DWORD,
        ppenum: *mut LPENUMFORMATETC,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleRegEnumVerbs(clsid: *const IID, ppenum: *mut LPENUMOLEVERB) -> HRESULT;
}
pub type LPOLESTREAM = *mut _OLESTREAM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OLESTREAMVTBL {
    pub Get: ::std::option::Option<
        unsafe extern "C" fn(
            arg1: LPOLESTREAM,
            arg2: *mut ::std::os::raw::c_void,
            arg3: DWORD,
        ) -> DWORD,
    >,
    pub Put: ::std::option::Option<
        unsafe extern "C" fn(
            arg1: LPOLESTREAM,
            arg2: *const ::std::os::raw::c_void,
            arg3: DWORD,
        ) -> DWORD,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OLESTREAMVTBL"][::std::mem::size_of::<_OLESTREAMVTBL>() - 16usize];
    ["Alignment of _OLESTREAMVTBL"][::std::mem::align_of::<_OLESTREAMVTBL>() - 8usize];
    ["Offset of field: _OLESTREAMVTBL::Get"][::std::mem::offset_of!(_OLESTREAMVTBL, Get) - 0usize];
    ["Offset of field: _OLESTREAMVTBL::Put"][::std::mem::offset_of!(_OLESTREAMVTBL, Put) - 8usize];
};
pub type OLESTREAMVTBL = _OLESTREAMVTBL;
pub type LPOLESTREAMVTBL = *mut OLESTREAMVTBL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OLESTREAM {
    pub lpstbl: LPOLESTREAMVTBL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OLESTREAM"][::std::mem::size_of::<_OLESTREAM>() - 8usize];
    ["Alignment of _OLESTREAM"][::std::mem::align_of::<_OLESTREAM>() - 8usize];
    ["Offset of field: _OLESTREAM::lpstbl"][::std::mem::offset_of!(_OLESTREAM, lpstbl) - 0usize];
};
pub type OLESTREAM = _OLESTREAM;
unsafe extern "C" {
    pub fn OleConvertOLESTREAMToIStorage(
        lpolestream: LPOLESTREAM,
        pstg: LPSTORAGE,
        ptd: *const DVTARGETDEVICE,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleConvertIStorageToOLESTREAM(pstg: LPSTORAGE, lpolestream: LPOLESTREAM) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleDoAutoConvert(pStg: LPSTORAGE, pClsidNew: LPCLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleGetAutoConvert(clsidOld: *const IID, pClsidNew: LPCLSID) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleSetAutoConvert(clsidOld: *const IID, clsidNew: *const IID) -> HRESULT;
}
unsafe extern "C" {
    pub fn SetConvertStg(pStg: LPSTORAGE, fConvert: BOOL) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleConvertIStorageToOLESTREAMEx(
        pstg: LPSTORAGE,
        cfFormat: CLIPFORMAT,
        lWidth: LONG,
        lHeight: LONG,
        dwSize: DWORD,
        pmedium: LPSTGMEDIUM,
        polestm: LPOLESTREAM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub fn OleConvertOLESTREAMToIStorageEx(
        polestm: LPOLESTREAM,
        pstg: LPSTORAGE,
        pcfFormat: *mut CLIPFORMAT,
        plwWidth: *mut LONG,
        plHeight: *mut LONG,
        pdwSize: *mut DWORD,
        pmedium: LPSTGMEDIUM,
    ) -> HRESULT;
}
unsafe extern "C" {
    pub static IID_IPrintDialogCallback: GUID;
}
unsafe extern "C" {
    pub static IID_IPrintDialogServices: GUID;
}
pub type LPOFNHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOFN_NT4A {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpstrFilter: LPCSTR,
    pub lpstrCustomFilter: LPSTR,
    pub nMaxCustFilter: DWORD,
    pub nFilterIndex: DWORD,
    pub lpstrFile: LPSTR,
    pub nMaxFile: DWORD,
    pub lpstrFileTitle: LPSTR,
    pub nMaxFileTitle: DWORD,
    pub lpstrInitialDir: LPCSTR,
    pub lpstrTitle: LPCSTR,
    pub Flags: DWORD,
    pub nFileOffset: WORD,
    pub nFileExtension: WORD,
    pub lpstrDefExt: LPCSTR,
    pub lCustData: LPARAM,
    pub lpfnHook: LPOFNHOOKPROC,
    pub lpTemplateName: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOFN_NT4A"][::std::mem::size_of::<tagOFN_NT4A>() - 136usize];
    ["Alignment of tagOFN_NT4A"][::std::mem::align_of::<tagOFN_NT4A>() - 8usize];
    ["Offset of field: tagOFN_NT4A::lStructSize"]
        [::std::mem::offset_of!(tagOFN_NT4A, lStructSize) - 0usize];
    ["Offset of field: tagOFN_NT4A::hwndOwner"]
        [::std::mem::offset_of!(tagOFN_NT4A, hwndOwner) - 8usize];
    ["Offset of field: tagOFN_NT4A::hInstance"]
        [::std::mem::offset_of!(tagOFN_NT4A, hInstance) - 16usize];
    ["Offset of field: tagOFN_NT4A::lpstrFilter"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrFilter) - 24usize];
    ["Offset of field: tagOFN_NT4A::lpstrCustomFilter"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrCustomFilter) - 32usize];
    ["Offset of field: tagOFN_NT4A::nMaxCustFilter"]
        [::std::mem::offset_of!(tagOFN_NT4A, nMaxCustFilter) - 40usize];
    ["Offset of field: tagOFN_NT4A::nFilterIndex"]
        [::std::mem::offset_of!(tagOFN_NT4A, nFilterIndex) - 44usize];
    ["Offset of field: tagOFN_NT4A::lpstrFile"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrFile) - 48usize];
    ["Offset of field: tagOFN_NT4A::nMaxFile"]
        [::std::mem::offset_of!(tagOFN_NT4A, nMaxFile) - 56usize];
    ["Offset of field: tagOFN_NT4A::lpstrFileTitle"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrFileTitle) - 64usize];
    ["Offset of field: tagOFN_NT4A::nMaxFileTitle"]
        [::std::mem::offset_of!(tagOFN_NT4A, nMaxFileTitle) - 72usize];
    ["Offset of field: tagOFN_NT4A::lpstrInitialDir"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrInitialDir) - 80usize];
    ["Offset of field: tagOFN_NT4A::lpstrTitle"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrTitle) - 88usize];
    ["Offset of field: tagOFN_NT4A::Flags"][::std::mem::offset_of!(tagOFN_NT4A, Flags) - 96usize];
    ["Offset of field: tagOFN_NT4A::nFileOffset"]
        [::std::mem::offset_of!(tagOFN_NT4A, nFileOffset) - 100usize];
    ["Offset of field: tagOFN_NT4A::nFileExtension"]
        [::std::mem::offset_of!(tagOFN_NT4A, nFileExtension) - 102usize];
    ["Offset of field: tagOFN_NT4A::lpstrDefExt"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpstrDefExt) - 104usize];
    ["Offset of field: tagOFN_NT4A::lCustData"]
        [::std::mem::offset_of!(tagOFN_NT4A, lCustData) - 112usize];
    ["Offset of field: tagOFN_NT4A::lpfnHook"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpfnHook) - 120usize];
    ["Offset of field: tagOFN_NT4A::lpTemplateName"]
        [::std::mem::offset_of!(tagOFN_NT4A, lpTemplateName) - 128usize];
};
pub type OPENFILENAME_NT4A = tagOFN_NT4A;
pub type LPOPENFILENAME_NT4A = *mut tagOFN_NT4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOFN_NT4W {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpstrFilter: LPCWSTR,
    pub lpstrCustomFilter: LPWSTR,
    pub nMaxCustFilter: DWORD,
    pub nFilterIndex: DWORD,
    pub lpstrFile: LPWSTR,
    pub nMaxFile: DWORD,
    pub lpstrFileTitle: LPWSTR,
    pub nMaxFileTitle: DWORD,
    pub lpstrInitialDir: LPCWSTR,
    pub lpstrTitle: LPCWSTR,
    pub Flags: DWORD,
    pub nFileOffset: WORD,
    pub nFileExtension: WORD,
    pub lpstrDefExt: LPCWSTR,
    pub lCustData: LPARAM,
    pub lpfnHook: LPOFNHOOKPROC,
    pub lpTemplateName: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOFN_NT4W"][::std::mem::size_of::<tagOFN_NT4W>() - 136usize];
    ["Alignment of tagOFN_NT4W"][::std::mem::align_of::<tagOFN_NT4W>() - 8usize];
    ["Offset of field: tagOFN_NT4W::lStructSize"]
        [::std::mem::offset_of!(tagOFN_NT4W, lStructSize) - 0usize];
    ["Offset of field: tagOFN_NT4W::hwndOwner"]
        [::std::mem::offset_of!(tagOFN_NT4W, hwndOwner) - 8usize];
    ["Offset of field: tagOFN_NT4W::hInstance"]
        [::std::mem::offset_of!(tagOFN_NT4W, hInstance) - 16usize];
    ["Offset of field: tagOFN_NT4W::lpstrFilter"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrFilter) - 24usize];
    ["Offset of field: tagOFN_NT4W::lpstrCustomFilter"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrCustomFilter) - 32usize];
    ["Offset of field: tagOFN_NT4W::nMaxCustFilter"]
        [::std::mem::offset_of!(tagOFN_NT4W, nMaxCustFilter) - 40usize];
    ["Offset of field: tagOFN_NT4W::nFilterIndex"]
        [::std::mem::offset_of!(tagOFN_NT4W, nFilterIndex) - 44usize];
    ["Offset of field: tagOFN_NT4W::lpstrFile"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrFile) - 48usize];
    ["Offset of field: tagOFN_NT4W::nMaxFile"]
        [::std::mem::offset_of!(tagOFN_NT4W, nMaxFile) - 56usize];
    ["Offset of field: tagOFN_NT4W::lpstrFileTitle"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrFileTitle) - 64usize];
    ["Offset of field: tagOFN_NT4W::nMaxFileTitle"]
        [::std::mem::offset_of!(tagOFN_NT4W, nMaxFileTitle) - 72usize];
    ["Offset of field: tagOFN_NT4W::lpstrInitialDir"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrInitialDir) - 80usize];
    ["Offset of field: tagOFN_NT4W::lpstrTitle"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrTitle) - 88usize];
    ["Offset of field: tagOFN_NT4W::Flags"][::std::mem::offset_of!(tagOFN_NT4W, Flags) - 96usize];
    ["Offset of field: tagOFN_NT4W::nFileOffset"]
        [::std::mem::offset_of!(tagOFN_NT4W, nFileOffset) - 100usize];
    ["Offset of field: tagOFN_NT4W::nFileExtension"]
        [::std::mem::offset_of!(tagOFN_NT4W, nFileExtension) - 102usize];
    ["Offset of field: tagOFN_NT4W::lpstrDefExt"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpstrDefExt) - 104usize];
    ["Offset of field: tagOFN_NT4W::lCustData"]
        [::std::mem::offset_of!(tagOFN_NT4W, lCustData) - 112usize];
    ["Offset of field: tagOFN_NT4W::lpfnHook"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpfnHook) - 120usize];
    ["Offset of field: tagOFN_NT4W::lpTemplateName"]
        [::std::mem::offset_of!(tagOFN_NT4W, lpTemplateName) - 128usize];
};
pub type OPENFILENAME_NT4W = tagOFN_NT4W;
pub type LPOPENFILENAME_NT4W = *mut tagOFN_NT4W;
pub type OPENFILENAME_NT4 = OPENFILENAME_NT4A;
pub type LPOPENFILENAME_NT4 = LPOPENFILENAME_NT4A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOFNA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpstrFilter: LPCSTR,
    pub lpstrCustomFilter: LPSTR,
    pub nMaxCustFilter: DWORD,
    pub nFilterIndex: DWORD,
    pub lpstrFile: LPSTR,
    pub nMaxFile: DWORD,
    pub lpstrFileTitle: LPSTR,
    pub nMaxFileTitle: DWORD,
    pub lpstrInitialDir: LPCSTR,
    pub lpstrTitle: LPCSTR,
    pub Flags: DWORD,
    pub nFileOffset: WORD,
    pub nFileExtension: WORD,
    pub lpstrDefExt: LPCSTR,
    pub lCustData: LPARAM,
    pub lpfnHook: LPOFNHOOKPROC,
    pub lpTemplateName: LPCSTR,
    pub pvReserved: *mut ::std::os::raw::c_void,
    pub dwReserved: DWORD,
    pub FlagsEx: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOFNA"][::std::mem::size_of::<tagOFNA>() - 152usize];
    ["Alignment of tagOFNA"][::std::mem::align_of::<tagOFNA>() - 8usize];
    ["Offset of field: tagOFNA::lStructSize"]
        [::std::mem::offset_of!(tagOFNA, lStructSize) - 0usize];
    ["Offset of field: tagOFNA::hwndOwner"][::std::mem::offset_of!(tagOFNA, hwndOwner) - 8usize];
    ["Offset of field: tagOFNA::hInstance"][::std::mem::offset_of!(tagOFNA, hInstance) - 16usize];
    ["Offset of field: tagOFNA::lpstrFilter"]
        [::std::mem::offset_of!(tagOFNA, lpstrFilter) - 24usize];
    ["Offset of field: tagOFNA::lpstrCustomFilter"]
        [::std::mem::offset_of!(tagOFNA, lpstrCustomFilter) - 32usize];
    ["Offset of field: tagOFNA::nMaxCustFilter"]
        [::std::mem::offset_of!(tagOFNA, nMaxCustFilter) - 40usize];
    ["Offset of field: tagOFNA::nFilterIndex"]
        [::std::mem::offset_of!(tagOFNA, nFilterIndex) - 44usize];
    ["Offset of field: tagOFNA::lpstrFile"][::std::mem::offset_of!(tagOFNA, lpstrFile) - 48usize];
    ["Offset of field: tagOFNA::nMaxFile"][::std::mem::offset_of!(tagOFNA, nMaxFile) - 56usize];
    ["Offset of field: tagOFNA::lpstrFileTitle"]
        [::std::mem::offset_of!(tagOFNA, lpstrFileTitle) - 64usize];
    ["Offset of field: tagOFNA::nMaxFileTitle"]
        [::std::mem::offset_of!(tagOFNA, nMaxFileTitle) - 72usize];
    ["Offset of field: tagOFNA::lpstrInitialDir"]
        [::std::mem::offset_of!(tagOFNA, lpstrInitialDir) - 80usize];
    ["Offset of field: tagOFNA::lpstrTitle"][::std::mem::offset_of!(tagOFNA, lpstrTitle) - 88usize];
    ["Offset of field: tagOFNA::Flags"][::std::mem::offset_of!(tagOFNA, Flags) - 96usize];
    ["Offset of field: tagOFNA::nFileOffset"]
        [::std::mem::offset_of!(tagOFNA, nFileOffset) - 100usize];
    ["Offset of field: tagOFNA::nFileExtension"]
        [::std::mem::offset_of!(tagOFNA, nFileExtension) - 102usize];
    ["Offset of field: tagOFNA::lpstrDefExt"]
        [::std::mem::offset_of!(tagOFNA, lpstrDefExt) - 104usize];
    ["Offset of field: tagOFNA::lCustData"][::std::mem::offset_of!(tagOFNA, lCustData) - 112usize];
    ["Offset of field: tagOFNA::lpfnHook"][::std::mem::offset_of!(tagOFNA, lpfnHook) - 120usize];
    ["Offset of field: tagOFNA::lpTemplateName"]
        [::std::mem::offset_of!(tagOFNA, lpTemplateName) - 128usize];
    ["Offset of field: tagOFNA::pvReserved"]
        [::std::mem::offset_of!(tagOFNA, pvReserved) - 136usize];
    ["Offset of field: tagOFNA::dwReserved"]
        [::std::mem::offset_of!(tagOFNA, dwReserved) - 144usize];
    ["Offset of field: tagOFNA::FlagsEx"][::std::mem::offset_of!(tagOFNA, FlagsEx) - 148usize];
};
pub type OPENFILENAMEA = tagOFNA;
pub type LPOPENFILENAMEA = *mut tagOFNA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagOFNW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub lpstrFilter: LPCWSTR,
    pub lpstrCustomFilter: LPWSTR,
    pub nMaxCustFilter: DWORD,
    pub nFilterIndex: DWORD,
    pub lpstrFile: LPWSTR,
    pub nMaxFile: DWORD,
    pub lpstrFileTitle: LPWSTR,
    pub nMaxFileTitle: DWORD,
    pub lpstrInitialDir: LPCWSTR,
    pub lpstrTitle: LPCWSTR,
    pub Flags: DWORD,
    pub nFileOffset: WORD,
    pub nFileExtension: WORD,
    pub lpstrDefExt: LPCWSTR,
    pub lCustData: LPARAM,
    pub lpfnHook: LPOFNHOOKPROC,
    pub lpTemplateName: LPCWSTR,
    pub pvReserved: *mut ::std::os::raw::c_void,
    pub dwReserved: DWORD,
    pub FlagsEx: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagOFNW"][::std::mem::size_of::<tagOFNW>() - 152usize];
    ["Alignment of tagOFNW"][::std::mem::align_of::<tagOFNW>() - 8usize];
    ["Offset of field: tagOFNW::lStructSize"]
        [::std::mem::offset_of!(tagOFNW, lStructSize) - 0usize];
    ["Offset of field: tagOFNW::hwndOwner"][::std::mem::offset_of!(tagOFNW, hwndOwner) - 8usize];
    ["Offset of field: tagOFNW::hInstance"][::std::mem::offset_of!(tagOFNW, hInstance) - 16usize];
    ["Offset of field: tagOFNW::lpstrFilter"]
        [::std::mem::offset_of!(tagOFNW, lpstrFilter) - 24usize];
    ["Offset of field: tagOFNW::lpstrCustomFilter"]
        [::std::mem::offset_of!(tagOFNW, lpstrCustomFilter) - 32usize];
    ["Offset of field: tagOFNW::nMaxCustFilter"]
        [::std::mem::offset_of!(tagOFNW, nMaxCustFilter) - 40usize];
    ["Offset of field: tagOFNW::nFilterIndex"]
        [::std::mem::offset_of!(tagOFNW, nFilterIndex) - 44usize];
    ["Offset of field: tagOFNW::lpstrFile"][::std::mem::offset_of!(tagOFNW, lpstrFile) - 48usize];
    ["Offset of field: tagOFNW::nMaxFile"][::std::mem::offset_of!(tagOFNW, nMaxFile) - 56usize];
    ["Offset of field: tagOFNW::lpstrFileTitle"]
        [::std::mem::offset_of!(tagOFNW, lpstrFileTitle) - 64usize];
    ["Offset of field: tagOFNW::nMaxFileTitle"]
        [::std::mem::offset_of!(tagOFNW, nMaxFileTitle) - 72usize];
    ["Offset of field: tagOFNW::lpstrInitialDir"]
        [::std::mem::offset_of!(tagOFNW, lpstrInitialDir) - 80usize];
    ["Offset of field: tagOFNW::lpstrTitle"][::std::mem::offset_of!(tagOFNW, lpstrTitle) - 88usize];
    ["Offset of field: tagOFNW::Flags"][::std::mem::offset_of!(tagOFNW, Flags) - 96usize];
    ["Offset of field: tagOFNW::nFileOffset"]
        [::std::mem::offset_of!(tagOFNW, nFileOffset) - 100usize];
    ["Offset of field: tagOFNW::nFileExtension"]
        [::std::mem::offset_of!(tagOFNW, nFileExtension) - 102usize];
    ["Offset of field: tagOFNW::lpstrDefExt"]
        [::std::mem::offset_of!(tagOFNW, lpstrDefExt) - 104usize];
    ["Offset of field: tagOFNW::lCustData"][::std::mem::offset_of!(tagOFNW, lCustData) - 112usize];
    ["Offset of field: tagOFNW::lpfnHook"][::std::mem::offset_of!(tagOFNW, lpfnHook) - 120usize];
    ["Offset of field: tagOFNW::lpTemplateName"]
        [::std::mem::offset_of!(tagOFNW, lpTemplateName) - 128usize];
    ["Offset of field: tagOFNW::pvReserved"]
        [::std::mem::offset_of!(tagOFNW, pvReserved) - 136usize];
    ["Offset of field: tagOFNW::dwReserved"]
        [::std::mem::offset_of!(tagOFNW, dwReserved) - 144usize];
    ["Offset of field: tagOFNW::FlagsEx"][::std::mem::offset_of!(tagOFNW, FlagsEx) - 148usize];
};
pub type OPENFILENAMEW = tagOFNW;
pub type LPOPENFILENAMEW = *mut tagOFNW;
pub type OPENFILENAME = OPENFILENAMEA;
pub type LPOPENFILENAME = LPOPENFILENAMEA;
unsafe extern "C" {
    pub fn GetOpenFileNameA(arg1: LPOPENFILENAMEA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetOpenFileNameW(arg1: LPOPENFILENAMEW) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSaveFileNameA(arg1: LPOPENFILENAMEA) -> BOOL;
}
unsafe extern "C" {
    pub fn GetSaveFileNameW(arg1: LPOPENFILENAMEW) -> BOOL;
}
unsafe extern "C" {
    pub fn GetFileTitleA(arg1: LPCSTR, Buf: LPSTR, cchSize: WORD) -> ::std::os::raw::c_short;
}
unsafe extern "C" {
    pub fn GetFileTitleW(arg1: LPCWSTR, Buf: LPWSTR, cchSize: WORD) -> ::std::os::raw::c_short;
}
pub type LPCCHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OFNOTIFYA {
    pub hdr: NMHDR,
    pub lpOFN: LPOPENFILENAMEA,
    pub pszFile: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OFNOTIFYA"][::std::mem::size_of::<_OFNOTIFYA>() - 40usize];
    ["Alignment of _OFNOTIFYA"][::std::mem::align_of::<_OFNOTIFYA>() - 8usize];
    ["Offset of field: _OFNOTIFYA::hdr"][::std::mem::offset_of!(_OFNOTIFYA, hdr) - 0usize];
    ["Offset of field: _OFNOTIFYA::lpOFN"][::std::mem::offset_of!(_OFNOTIFYA, lpOFN) - 24usize];
    ["Offset of field: _OFNOTIFYA::pszFile"][::std::mem::offset_of!(_OFNOTIFYA, pszFile) - 32usize];
};
pub type OFNOTIFYA = _OFNOTIFYA;
pub type LPOFNOTIFYA = *mut _OFNOTIFYA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OFNOTIFYW {
    pub hdr: NMHDR,
    pub lpOFN: LPOPENFILENAMEW,
    pub pszFile: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OFNOTIFYW"][::std::mem::size_of::<_OFNOTIFYW>() - 40usize];
    ["Alignment of _OFNOTIFYW"][::std::mem::align_of::<_OFNOTIFYW>() - 8usize];
    ["Offset of field: _OFNOTIFYW::hdr"][::std::mem::offset_of!(_OFNOTIFYW, hdr) - 0usize];
    ["Offset of field: _OFNOTIFYW::lpOFN"][::std::mem::offset_of!(_OFNOTIFYW, lpOFN) - 24usize];
    ["Offset of field: _OFNOTIFYW::pszFile"][::std::mem::offset_of!(_OFNOTIFYW, pszFile) - 32usize];
};
pub type OFNOTIFYW = _OFNOTIFYW;
pub type LPOFNOTIFYW = *mut _OFNOTIFYW;
pub type OFNOTIFY = OFNOTIFYA;
pub type LPOFNOTIFY = LPOFNOTIFYA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OFNOTIFYEXA {
    pub hdr: NMHDR,
    pub lpOFN: LPOPENFILENAMEA,
    pub psf: LPVOID,
    pub pidl: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OFNOTIFYEXA"][::std::mem::size_of::<_OFNOTIFYEXA>() - 48usize];
    ["Alignment of _OFNOTIFYEXA"][::std::mem::align_of::<_OFNOTIFYEXA>() - 8usize];
    ["Offset of field: _OFNOTIFYEXA::hdr"][::std::mem::offset_of!(_OFNOTIFYEXA, hdr) - 0usize];
    ["Offset of field: _OFNOTIFYEXA::lpOFN"][::std::mem::offset_of!(_OFNOTIFYEXA, lpOFN) - 24usize];
    ["Offset of field: _OFNOTIFYEXA::psf"][::std::mem::offset_of!(_OFNOTIFYEXA, psf) - 32usize];
    ["Offset of field: _OFNOTIFYEXA::pidl"][::std::mem::offset_of!(_OFNOTIFYEXA, pidl) - 40usize];
};
pub type OFNOTIFYEXA = _OFNOTIFYEXA;
pub type LPOFNOTIFYEXA = *mut _OFNOTIFYEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _OFNOTIFYEXW {
    pub hdr: NMHDR,
    pub lpOFN: LPOPENFILENAMEW,
    pub psf: LPVOID,
    pub pidl: LPVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _OFNOTIFYEXW"][::std::mem::size_of::<_OFNOTIFYEXW>() - 48usize];
    ["Alignment of _OFNOTIFYEXW"][::std::mem::align_of::<_OFNOTIFYEXW>() - 8usize];
    ["Offset of field: _OFNOTIFYEXW::hdr"][::std::mem::offset_of!(_OFNOTIFYEXW, hdr) - 0usize];
    ["Offset of field: _OFNOTIFYEXW::lpOFN"][::std::mem::offset_of!(_OFNOTIFYEXW, lpOFN) - 24usize];
    ["Offset of field: _OFNOTIFYEXW::psf"][::std::mem::offset_of!(_OFNOTIFYEXW, psf) - 32usize];
    ["Offset of field: _OFNOTIFYEXW::pidl"][::std::mem::offset_of!(_OFNOTIFYEXW, pidl) - 40usize];
};
pub type OFNOTIFYEXW = _OFNOTIFYEXW;
pub type LPOFNOTIFYEXW = *mut _OFNOTIFYEXW;
pub type OFNOTIFYEX = OFNOTIFYEXA;
pub type LPOFNOTIFYEX = LPOFNOTIFYEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHOOSECOLORA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HWND,
    pub rgbResult: COLORREF,
    pub lpCustColors: *mut COLORREF,
    pub Flags: DWORD,
    pub lCustData: LPARAM,
    pub lpfnHook: LPCCHOOKPROC,
    pub lpTemplateName: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHOOSECOLORA"][::std::mem::size_of::<tagCHOOSECOLORA>() - 72usize];
    ["Alignment of tagCHOOSECOLORA"][::std::mem::align_of::<tagCHOOSECOLORA>() - 8usize];
    ["Offset of field: tagCHOOSECOLORA::lStructSize"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, lStructSize) - 0usize];
    ["Offset of field: tagCHOOSECOLORA::hwndOwner"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, hwndOwner) - 8usize];
    ["Offset of field: tagCHOOSECOLORA::hInstance"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, hInstance) - 16usize];
    ["Offset of field: tagCHOOSECOLORA::rgbResult"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, rgbResult) - 24usize];
    ["Offset of field: tagCHOOSECOLORA::lpCustColors"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, lpCustColors) - 32usize];
    ["Offset of field: tagCHOOSECOLORA::Flags"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, Flags) - 40usize];
    ["Offset of field: tagCHOOSECOLORA::lCustData"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, lCustData) - 48usize];
    ["Offset of field: tagCHOOSECOLORA::lpfnHook"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, lpfnHook) - 56usize];
    ["Offset of field: tagCHOOSECOLORA::lpTemplateName"]
        [::std::mem::offset_of!(tagCHOOSECOLORA, lpTemplateName) - 64usize];
};
pub type CHOOSECOLORA = tagCHOOSECOLORA;
pub type LPCHOOSECOLORA = *mut tagCHOOSECOLORA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHOOSECOLORW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HWND,
    pub rgbResult: COLORREF,
    pub lpCustColors: *mut COLORREF,
    pub Flags: DWORD,
    pub lCustData: LPARAM,
    pub lpfnHook: LPCCHOOKPROC,
    pub lpTemplateName: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHOOSECOLORW"][::std::mem::size_of::<tagCHOOSECOLORW>() - 72usize];
    ["Alignment of tagCHOOSECOLORW"][::std::mem::align_of::<tagCHOOSECOLORW>() - 8usize];
    ["Offset of field: tagCHOOSECOLORW::lStructSize"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, lStructSize) - 0usize];
    ["Offset of field: tagCHOOSECOLORW::hwndOwner"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, hwndOwner) - 8usize];
    ["Offset of field: tagCHOOSECOLORW::hInstance"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, hInstance) - 16usize];
    ["Offset of field: tagCHOOSECOLORW::rgbResult"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, rgbResult) - 24usize];
    ["Offset of field: tagCHOOSECOLORW::lpCustColors"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, lpCustColors) - 32usize];
    ["Offset of field: tagCHOOSECOLORW::Flags"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, Flags) - 40usize];
    ["Offset of field: tagCHOOSECOLORW::lCustData"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, lCustData) - 48usize];
    ["Offset of field: tagCHOOSECOLORW::lpfnHook"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, lpfnHook) - 56usize];
    ["Offset of field: tagCHOOSECOLORW::lpTemplateName"]
        [::std::mem::offset_of!(tagCHOOSECOLORW, lpTemplateName) - 64usize];
};
pub type CHOOSECOLORW = tagCHOOSECOLORW;
pub type LPCHOOSECOLORW = *mut tagCHOOSECOLORW;
pub type CHOOSECOLOR = CHOOSECOLORA;
pub type LPCHOOSECOLOR = LPCHOOSECOLORA;
unsafe extern "C" {
    pub fn ChooseColorA(arg1: LPCHOOSECOLORA) -> BOOL;
}
unsafe extern "C" {
    pub fn ChooseColorW(arg1: LPCHOOSECOLORW) -> BOOL;
}
pub type LPFRHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagFINDREPLACEA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub Flags: DWORD,
    pub lpstrFindWhat: LPSTR,
    pub lpstrReplaceWith: LPSTR,
    pub wFindWhatLen: WORD,
    pub wReplaceWithLen: WORD,
    pub lCustData: LPARAM,
    pub lpfnHook: LPFRHOOKPROC,
    pub lpTemplateName: LPCSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFINDREPLACEA"][::std::mem::size_of::<tagFINDREPLACEA>() - 80usize];
    ["Alignment of tagFINDREPLACEA"][::std::mem::align_of::<tagFINDREPLACEA>() - 8usize];
    ["Offset of field: tagFINDREPLACEA::lStructSize"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lStructSize) - 0usize];
    ["Offset of field: tagFINDREPLACEA::hwndOwner"]
        [::std::mem::offset_of!(tagFINDREPLACEA, hwndOwner) - 8usize];
    ["Offset of field: tagFINDREPLACEA::hInstance"]
        [::std::mem::offset_of!(tagFINDREPLACEA, hInstance) - 16usize];
    ["Offset of field: tagFINDREPLACEA::Flags"]
        [::std::mem::offset_of!(tagFINDREPLACEA, Flags) - 24usize];
    ["Offset of field: tagFINDREPLACEA::lpstrFindWhat"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lpstrFindWhat) - 32usize];
    ["Offset of field: tagFINDREPLACEA::lpstrReplaceWith"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lpstrReplaceWith) - 40usize];
    ["Offset of field: tagFINDREPLACEA::wFindWhatLen"]
        [::std::mem::offset_of!(tagFINDREPLACEA, wFindWhatLen) - 48usize];
    ["Offset of field: tagFINDREPLACEA::wReplaceWithLen"]
        [::std::mem::offset_of!(tagFINDREPLACEA, wReplaceWithLen) - 50usize];
    ["Offset of field: tagFINDREPLACEA::lCustData"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lCustData) - 56usize];
    ["Offset of field: tagFINDREPLACEA::lpfnHook"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lpfnHook) - 64usize];
    ["Offset of field: tagFINDREPLACEA::lpTemplateName"]
        [::std::mem::offset_of!(tagFINDREPLACEA, lpTemplateName) - 72usize];
};
pub type FINDREPLACEA = tagFINDREPLACEA;
pub type LPFINDREPLACEA = *mut tagFINDREPLACEA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagFINDREPLACEW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hInstance: HINSTANCE,
    pub Flags: DWORD,
    pub lpstrFindWhat: LPWSTR,
    pub lpstrReplaceWith: LPWSTR,
    pub wFindWhatLen: WORD,
    pub wReplaceWithLen: WORD,
    pub lCustData: LPARAM,
    pub lpfnHook: LPFRHOOKPROC,
    pub lpTemplateName: LPCWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagFINDREPLACEW"][::std::mem::size_of::<tagFINDREPLACEW>() - 80usize];
    ["Alignment of tagFINDREPLACEW"][::std::mem::align_of::<tagFINDREPLACEW>() - 8usize];
    ["Offset of field: tagFINDREPLACEW::lStructSize"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lStructSize) - 0usize];
    ["Offset of field: tagFINDREPLACEW::hwndOwner"]
        [::std::mem::offset_of!(tagFINDREPLACEW, hwndOwner) - 8usize];
    ["Offset of field: tagFINDREPLACEW::hInstance"]
        [::std::mem::offset_of!(tagFINDREPLACEW, hInstance) - 16usize];
    ["Offset of field: tagFINDREPLACEW::Flags"]
        [::std::mem::offset_of!(tagFINDREPLACEW, Flags) - 24usize];
    ["Offset of field: tagFINDREPLACEW::lpstrFindWhat"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lpstrFindWhat) - 32usize];
    ["Offset of field: tagFINDREPLACEW::lpstrReplaceWith"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lpstrReplaceWith) - 40usize];
    ["Offset of field: tagFINDREPLACEW::wFindWhatLen"]
        [::std::mem::offset_of!(tagFINDREPLACEW, wFindWhatLen) - 48usize];
    ["Offset of field: tagFINDREPLACEW::wReplaceWithLen"]
        [::std::mem::offset_of!(tagFINDREPLACEW, wReplaceWithLen) - 50usize];
    ["Offset of field: tagFINDREPLACEW::lCustData"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lCustData) - 56usize];
    ["Offset of field: tagFINDREPLACEW::lpfnHook"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lpfnHook) - 64usize];
    ["Offset of field: tagFINDREPLACEW::lpTemplateName"]
        [::std::mem::offset_of!(tagFINDREPLACEW, lpTemplateName) - 72usize];
};
pub type FINDREPLACEW = tagFINDREPLACEW;
pub type LPFINDREPLACEW = *mut tagFINDREPLACEW;
pub type FINDREPLACE = FINDREPLACEA;
pub type LPFINDREPLACE = LPFINDREPLACEA;
unsafe extern "C" {
    pub fn FindTextA(arg1: LPFINDREPLACEA) -> HWND;
}
unsafe extern "C" {
    pub fn FindTextW(arg1: LPFINDREPLACEW) -> HWND;
}
unsafe extern "C" {
    pub fn ReplaceTextA(arg1: LPFINDREPLACEA) -> HWND;
}
unsafe extern "C" {
    pub fn ReplaceTextW(arg1: LPFINDREPLACEW) -> HWND;
}
pub type LPCFHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHOOSEFONTA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDC: HDC,
    pub lpLogFont: LPLOGFONTA,
    pub iPointSize: INT,
    pub Flags: DWORD,
    pub rgbColors: COLORREF,
    pub lCustData: LPARAM,
    pub lpfnHook: LPCFHOOKPROC,
    pub lpTemplateName: LPCSTR,
    pub hInstance: HINSTANCE,
    pub lpszStyle: LPSTR,
    pub nFontType: WORD,
    pub ___MISSING_ALIGNMENT__: WORD,
    pub nSizeMin: INT,
    pub nSizeMax: INT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHOOSEFONTA"][::std::mem::size_of::<tagCHOOSEFONTA>() - 104usize];
    ["Alignment of tagCHOOSEFONTA"][::std::mem::align_of::<tagCHOOSEFONTA>() - 8usize];
    ["Offset of field: tagCHOOSEFONTA::lStructSize"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lStructSize) - 0usize];
    ["Offset of field: tagCHOOSEFONTA::hwndOwner"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, hwndOwner) - 8usize];
    ["Offset of field: tagCHOOSEFONTA::hDC"][::std::mem::offset_of!(tagCHOOSEFONTA, hDC) - 16usize];
    ["Offset of field: tagCHOOSEFONTA::lpLogFont"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lpLogFont) - 24usize];
    ["Offset of field: tagCHOOSEFONTA::iPointSize"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, iPointSize) - 32usize];
    ["Offset of field: tagCHOOSEFONTA::Flags"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, Flags) - 36usize];
    ["Offset of field: tagCHOOSEFONTA::rgbColors"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, rgbColors) - 40usize];
    ["Offset of field: tagCHOOSEFONTA::lCustData"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lCustData) - 48usize];
    ["Offset of field: tagCHOOSEFONTA::lpfnHook"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lpfnHook) - 56usize];
    ["Offset of field: tagCHOOSEFONTA::lpTemplateName"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lpTemplateName) - 64usize];
    ["Offset of field: tagCHOOSEFONTA::hInstance"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, hInstance) - 72usize];
    ["Offset of field: tagCHOOSEFONTA::lpszStyle"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, lpszStyle) - 80usize];
    ["Offset of field: tagCHOOSEFONTA::nFontType"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, nFontType) - 88usize];
    ["Offset of field: tagCHOOSEFONTA::___MISSING_ALIGNMENT__"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, ___MISSING_ALIGNMENT__) - 90usize];
    ["Offset of field: tagCHOOSEFONTA::nSizeMin"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, nSizeMin) - 92usize];
    ["Offset of field: tagCHOOSEFONTA::nSizeMax"]
        [::std::mem::offset_of!(tagCHOOSEFONTA, nSizeMax) - 96usize];
};
pub type CHOOSEFONTA = tagCHOOSEFONTA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCHOOSEFONTW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDC: HDC,
    pub lpLogFont: LPLOGFONTW,
    pub iPointSize: INT,
    pub Flags: DWORD,
    pub rgbColors: COLORREF,
    pub lCustData: LPARAM,
    pub lpfnHook: LPCFHOOKPROC,
    pub lpTemplateName: LPCWSTR,
    pub hInstance: HINSTANCE,
    pub lpszStyle: LPWSTR,
    pub nFontType: WORD,
    pub ___MISSING_ALIGNMENT__: WORD,
    pub nSizeMin: INT,
    pub nSizeMax: INT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCHOOSEFONTW"][::std::mem::size_of::<tagCHOOSEFONTW>() - 104usize];
    ["Alignment of tagCHOOSEFONTW"][::std::mem::align_of::<tagCHOOSEFONTW>() - 8usize];
    ["Offset of field: tagCHOOSEFONTW::lStructSize"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lStructSize) - 0usize];
    ["Offset of field: tagCHOOSEFONTW::hwndOwner"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, hwndOwner) - 8usize];
    ["Offset of field: tagCHOOSEFONTW::hDC"][::std::mem::offset_of!(tagCHOOSEFONTW, hDC) - 16usize];
    ["Offset of field: tagCHOOSEFONTW::lpLogFont"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lpLogFont) - 24usize];
    ["Offset of field: tagCHOOSEFONTW::iPointSize"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, iPointSize) - 32usize];
    ["Offset of field: tagCHOOSEFONTW::Flags"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, Flags) - 36usize];
    ["Offset of field: tagCHOOSEFONTW::rgbColors"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, rgbColors) - 40usize];
    ["Offset of field: tagCHOOSEFONTW::lCustData"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lCustData) - 48usize];
    ["Offset of field: tagCHOOSEFONTW::lpfnHook"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lpfnHook) - 56usize];
    ["Offset of field: tagCHOOSEFONTW::lpTemplateName"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lpTemplateName) - 64usize];
    ["Offset of field: tagCHOOSEFONTW::hInstance"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, hInstance) - 72usize];
    ["Offset of field: tagCHOOSEFONTW::lpszStyle"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, lpszStyle) - 80usize];
    ["Offset of field: tagCHOOSEFONTW::nFontType"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, nFontType) - 88usize];
    ["Offset of field: tagCHOOSEFONTW::___MISSING_ALIGNMENT__"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, ___MISSING_ALIGNMENT__) - 90usize];
    ["Offset of field: tagCHOOSEFONTW::nSizeMin"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, nSizeMin) - 92usize];
    ["Offset of field: tagCHOOSEFONTW::nSizeMax"]
        [::std::mem::offset_of!(tagCHOOSEFONTW, nSizeMax) - 96usize];
};
pub type CHOOSEFONTW = tagCHOOSEFONTW;
pub type CHOOSEFONT = CHOOSEFONTA;
pub type LPCHOOSEFONTA = *mut CHOOSEFONTA;
pub type LPCHOOSEFONTW = *mut CHOOSEFONTW;
pub type LPCHOOSEFONT = LPCHOOSEFONTA;
pub type PCCHOOSEFONTA = *const CHOOSEFONTA;
pub type PCCHOOSEFONTW = *const CHOOSEFONTW;
pub type PCCHOOSEFONT = PCCHOOSEFONTA;
unsafe extern "C" {
    pub fn ChooseFontA(arg1: LPCHOOSEFONTA) -> BOOL;
}
unsafe extern "C" {
    pub fn ChooseFontW(arg1: LPCHOOSEFONTW) -> BOOL;
}
pub type LPPRINTHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
pub type LPSETUPHOOKPROC = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPDA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub hDC: HDC,
    pub Flags: DWORD,
    pub nFromPage: WORD,
    pub nToPage: WORD,
    pub nMinPage: WORD,
    pub nMaxPage: WORD,
    pub nCopies: WORD,
    pub hInstance: HINSTANCE,
    pub lCustData: LPARAM,
    pub lpfnPrintHook: LPPRINTHOOKPROC,
    pub lpfnSetupHook: LPSETUPHOOKPROC,
    pub lpPrintTemplateName: LPCSTR,
    pub lpSetupTemplateName: LPCSTR,
    pub hPrintTemplate: HGLOBAL,
    pub hSetupTemplate: HGLOBAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPDA"][::std::mem::size_of::<tagPDA>() - 120usize];
    ["Alignment of tagPDA"][::std::mem::align_of::<tagPDA>() - 8usize];
    ["Offset of field: tagPDA::lStructSize"][::std::mem::offset_of!(tagPDA, lStructSize) - 0usize];
    ["Offset of field: tagPDA::hwndOwner"][::std::mem::offset_of!(tagPDA, hwndOwner) - 8usize];
    ["Offset of field: tagPDA::hDevMode"][::std::mem::offset_of!(tagPDA, hDevMode) - 16usize];
    ["Offset of field: tagPDA::hDevNames"][::std::mem::offset_of!(tagPDA, hDevNames) - 24usize];
    ["Offset of field: tagPDA::hDC"][::std::mem::offset_of!(tagPDA, hDC) - 32usize];
    ["Offset of field: tagPDA::Flags"][::std::mem::offset_of!(tagPDA, Flags) - 40usize];
    ["Offset of field: tagPDA::nFromPage"][::std::mem::offset_of!(tagPDA, nFromPage) - 44usize];
    ["Offset of field: tagPDA::nToPage"][::std::mem::offset_of!(tagPDA, nToPage) - 46usize];
    ["Offset of field: tagPDA::nMinPage"][::std::mem::offset_of!(tagPDA, nMinPage) - 48usize];
    ["Offset of field: tagPDA::nMaxPage"][::std::mem::offset_of!(tagPDA, nMaxPage) - 50usize];
    ["Offset of field: tagPDA::nCopies"][::std::mem::offset_of!(tagPDA, nCopies) - 52usize];
    ["Offset of field: tagPDA::hInstance"][::std::mem::offset_of!(tagPDA, hInstance) - 56usize];
    ["Offset of field: tagPDA::lCustData"][::std::mem::offset_of!(tagPDA, lCustData) - 64usize];
    ["Offset of field: tagPDA::lpfnPrintHook"]
        [::std::mem::offset_of!(tagPDA, lpfnPrintHook) - 72usize];
    ["Offset of field: tagPDA::lpfnSetupHook"]
        [::std::mem::offset_of!(tagPDA, lpfnSetupHook) - 80usize];
    ["Offset of field: tagPDA::lpPrintTemplateName"]
        [::std::mem::offset_of!(tagPDA, lpPrintTemplateName) - 88usize];
    ["Offset of field: tagPDA::lpSetupTemplateName"]
        [::std::mem::offset_of!(tagPDA, lpSetupTemplateName) - 96usize];
    ["Offset of field: tagPDA::hPrintTemplate"]
        [::std::mem::offset_of!(tagPDA, hPrintTemplate) - 104usize];
    ["Offset of field: tagPDA::hSetupTemplate"]
        [::std::mem::offset_of!(tagPDA, hSetupTemplate) - 112usize];
};
pub type PRINTDLGA = tagPDA;
pub type LPPRINTDLGA = *mut tagPDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPDW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub hDC: HDC,
    pub Flags: DWORD,
    pub nFromPage: WORD,
    pub nToPage: WORD,
    pub nMinPage: WORD,
    pub nMaxPage: WORD,
    pub nCopies: WORD,
    pub hInstance: HINSTANCE,
    pub lCustData: LPARAM,
    pub lpfnPrintHook: LPPRINTHOOKPROC,
    pub lpfnSetupHook: LPSETUPHOOKPROC,
    pub lpPrintTemplateName: LPCWSTR,
    pub lpSetupTemplateName: LPCWSTR,
    pub hPrintTemplate: HGLOBAL,
    pub hSetupTemplate: HGLOBAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPDW"][::std::mem::size_of::<tagPDW>() - 120usize];
    ["Alignment of tagPDW"][::std::mem::align_of::<tagPDW>() - 8usize];
    ["Offset of field: tagPDW::lStructSize"][::std::mem::offset_of!(tagPDW, lStructSize) - 0usize];
    ["Offset of field: tagPDW::hwndOwner"][::std::mem::offset_of!(tagPDW, hwndOwner) - 8usize];
    ["Offset of field: tagPDW::hDevMode"][::std::mem::offset_of!(tagPDW, hDevMode) - 16usize];
    ["Offset of field: tagPDW::hDevNames"][::std::mem::offset_of!(tagPDW, hDevNames) - 24usize];
    ["Offset of field: tagPDW::hDC"][::std::mem::offset_of!(tagPDW, hDC) - 32usize];
    ["Offset of field: tagPDW::Flags"][::std::mem::offset_of!(tagPDW, Flags) - 40usize];
    ["Offset of field: tagPDW::nFromPage"][::std::mem::offset_of!(tagPDW, nFromPage) - 44usize];
    ["Offset of field: tagPDW::nToPage"][::std::mem::offset_of!(tagPDW, nToPage) - 46usize];
    ["Offset of field: tagPDW::nMinPage"][::std::mem::offset_of!(tagPDW, nMinPage) - 48usize];
    ["Offset of field: tagPDW::nMaxPage"][::std::mem::offset_of!(tagPDW, nMaxPage) - 50usize];
    ["Offset of field: tagPDW::nCopies"][::std::mem::offset_of!(tagPDW, nCopies) - 52usize];
    ["Offset of field: tagPDW::hInstance"][::std::mem::offset_of!(tagPDW, hInstance) - 56usize];
    ["Offset of field: tagPDW::lCustData"][::std::mem::offset_of!(tagPDW, lCustData) - 64usize];
    ["Offset of field: tagPDW::lpfnPrintHook"]
        [::std::mem::offset_of!(tagPDW, lpfnPrintHook) - 72usize];
    ["Offset of field: tagPDW::lpfnSetupHook"]
        [::std::mem::offset_of!(tagPDW, lpfnSetupHook) - 80usize];
    ["Offset of field: tagPDW::lpPrintTemplateName"]
        [::std::mem::offset_of!(tagPDW, lpPrintTemplateName) - 88usize];
    ["Offset of field: tagPDW::lpSetupTemplateName"]
        [::std::mem::offset_of!(tagPDW, lpSetupTemplateName) - 96usize];
    ["Offset of field: tagPDW::hPrintTemplate"]
        [::std::mem::offset_of!(tagPDW, hPrintTemplate) - 104usize];
    ["Offset of field: tagPDW::hSetupTemplate"]
        [::std::mem::offset_of!(tagPDW, hSetupTemplate) - 112usize];
};
pub type PRINTDLGW = tagPDW;
pub type LPPRINTDLGW = *mut tagPDW;
pub type PRINTDLG = PRINTDLGA;
pub type LPPRINTDLG = LPPRINTDLGA;
unsafe extern "C" {
    pub fn PrintDlgA(pPD: LPPRINTDLGA) -> BOOL;
}
unsafe extern "C" {
    pub fn PrintDlgW(pPD: LPPRINTDLGW) -> BOOL;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPrintDialogCallback {
    pub lpVtbl: *mut IPrintDialogCallbackVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPrintDialogCallback"][::std::mem::size_of::<IPrintDialogCallback>() - 8usize];
    ["Alignment of IPrintDialogCallback"][::std::mem::align_of::<IPrintDialogCallback>() - 8usize];
    ["Offset of field: IPrintDialogCallback::lpVtbl"]
        [::std::mem::offset_of!(IPrintDialogCallback, lpVtbl) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPrintDialogCallbackVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogCallback,
            riid: *const IID,
            ppvObj: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogCallback) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogCallback) -> ULONG>,
    pub InitDone:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogCallback) -> HRESULT>,
    pub SelectionChange:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogCallback) -> HRESULT>,
    pub HandleMessage: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogCallback,
            hDlg: HWND,
            uMsg: UINT,
            wParam: WPARAM,
            lParam: LPARAM,
            pResult: *mut LRESULT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPrintDialogCallbackVtbl"]
        [::std::mem::size_of::<IPrintDialogCallbackVtbl>() - 48usize];
    ["Alignment of IPrintDialogCallbackVtbl"]
        [::std::mem::align_of::<IPrintDialogCallbackVtbl>() - 8usize];
    ["Offset of field: IPrintDialogCallbackVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPrintDialogCallbackVtbl::AddRef"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, AddRef) - 8usize];
    ["Offset of field: IPrintDialogCallbackVtbl::Release"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, Release) - 16usize];
    ["Offset of field: IPrintDialogCallbackVtbl::InitDone"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, InitDone) - 24usize];
    ["Offset of field: IPrintDialogCallbackVtbl::SelectionChange"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, SelectionChange) - 32usize];
    ["Offset of field: IPrintDialogCallbackVtbl::HandleMessage"]
        [::std::mem::offset_of!(IPrintDialogCallbackVtbl, HandleMessage) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPrintDialogServices {
    pub lpVtbl: *mut IPrintDialogServicesVtbl,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPrintDialogServices"][::std::mem::size_of::<IPrintDialogServices>() - 8usize];
    ["Alignment of IPrintDialogServices"][::std::mem::align_of::<IPrintDialogServices>() - 8usize];
    ["Offset of field: IPrintDialogServices::lpVtbl"]
        [::std::mem::offset_of!(IPrintDialogServices, lpVtbl) - 0usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct IPrintDialogServicesVtbl {
    pub QueryInterface: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogServices,
            riid: *const IID,
            ppvObj: *mut *mut ::std::os::raw::c_void,
        ) -> HRESULT,
    >,
    pub AddRef:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogServices) -> ULONG>,
    pub Release:
        ::std::option::Option<unsafe extern "C" fn(This: *mut IPrintDialogServices) -> ULONG>,
    pub GetCurrentDevMode: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogServices,
            pDevMode: LPDEVMODE,
            pcbSize: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetCurrentPrinterName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogServices,
            pPrinterName: LPWSTR,
            pcchSize: *mut UINT,
        ) -> HRESULT,
    >,
    pub GetCurrentPortName: ::std::option::Option<
        unsafe extern "C" fn(
            This: *mut IPrintDialogServices,
            pPortName: LPWSTR,
            pcchSize: *mut UINT,
        ) -> HRESULT,
    >,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of IPrintDialogServicesVtbl"]
        [::std::mem::size_of::<IPrintDialogServicesVtbl>() - 48usize];
    ["Alignment of IPrintDialogServicesVtbl"]
        [::std::mem::align_of::<IPrintDialogServicesVtbl>() - 8usize];
    ["Offset of field: IPrintDialogServicesVtbl::QueryInterface"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, QueryInterface) - 0usize];
    ["Offset of field: IPrintDialogServicesVtbl::AddRef"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, AddRef) - 8usize];
    ["Offset of field: IPrintDialogServicesVtbl::Release"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, Release) - 16usize];
    ["Offset of field: IPrintDialogServicesVtbl::GetCurrentDevMode"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, GetCurrentDevMode) - 24usize];
    ["Offset of field: IPrintDialogServicesVtbl::GetCurrentPrinterName"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, GetCurrentPrinterName) - 32usize];
    ["Offset of field: IPrintDialogServicesVtbl::GetCurrentPortName"]
        [::std::mem::offset_of!(IPrintDialogServicesVtbl, GetCurrentPortName) - 40usize];
};
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPRINTPAGERANGE {
    pub nFromPage: DWORD,
    pub nToPage: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPRINTPAGERANGE"][::std::mem::size_of::<tagPRINTPAGERANGE>() - 8usize];
    ["Alignment of tagPRINTPAGERANGE"][::std::mem::align_of::<tagPRINTPAGERANGE>() - 4usize];
    ["Offset of field: tagPRINTPAGERANGE::nFromPage"]
        [::std::mem::offset_of!(tagPRINTPAGERANGE, nFromPage) - 0usize];
    ["Offset of field: tagPRINTPAGERANGE::nToPage"]
        [::std::mem::offset_of!(tagPRINTPAGERANGE, nToPage) - 4usize];
};
pub type PRINTPAGERANGE = tagPRINTPAGERANGE;
pub type LPPRINTPAGERANGE = *mut PRINTPAGERANGE;
pub type PCPRINTPAGERANGE = *const PRINTPAGERANGE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPDEXA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub hDC: HDC,
    pub Flags: DWORD,
    pub Flags2: DWORD,
    pub ExclusionFlags: DWORD,
    pub nPageRanges: DWORD,
    pub nMaxPageRanges: DWORD,
    pub lpPageRanges: LPPRINTPAGERANGE,
    pub nMinPage: DWORD,
    pub nMaxPage: DWORD,
    pub nCopies: DWORD,
    pub hInstance: HINSTANCE,
    pub lpPrintTemplateName: LPCSTR,
    pub lpCallback: LPUNKNOWN,
    pub nPropertyPages: DWORD,
    pub lphPropertyPages: *mut HPROPSHEETPAGE,
    pub nStartPage: DWORD,
    pub dwResultAction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPDEXA"][::std::mem::size_of::<tagPDEXA>() - 136usize];
    ["Alignment of tagPDEXA"][::std::mem::align_of::<tagPDEXA>() - 8usize];
    ["Offset of field: tagPDEXA::lStructSize"]
        [::std::mem::offset_of!(tagPDEXA, lStructSize) - 0usize];
    ["Offset of field: tagPDEXA::hwndOwner"][::std::mem::offset_of!(tagPDEXA, hwndOwner) - 8usize];
    ["Offset of field: tagPDEXA::hDevMode"][::std::mem::offset_of!(tagPDEXA, hDevMode) - 16usize];
    ["Offset of field: tagPDEXA::hDevNames"][::std::mem::offset_of!(tagPDEXA, hDevNames) - 24usize];
    ["Offset of field: tagPDEXA::hDC"][::std::mem::offset_of!(tagPDEXA, hDC) - 32usize];
    ["Offset of field: tagPDEXA::Flags"][::std::mem::offset_of!(tagPDEXA, Flags) - 40usize];
    ["Offset of field: tagPDEXA::Flags2"][::std::mem::offset_of!(tagPDEXA, Flags2) - 44usize];
    ["Offset of field: tagPDEXA::ExclusionFlags"]
        [::std::mem::offset_of!(tagPDEXA, ExclusionFlags) - 48usize];
    ["Offset of field: tagPDEXA::nPageRanges"]
        [::std::mem::offset_of!(tagPDEXA, nPageRanges) - 52usize];
    ["Offset of field: tagPDEXA::nMaxPageRanges"]
        [::std::mem::offset_of!(tagPDEXA, nMaxPageRanges) - 56usize];
    ["Offset of field: tagPDEXA::lpPageRanges"]
        [::std::mem::offset_of!(tagPDEXA, lpPageRanges) - 64usize];
    ["Offset of field: tagPDEXA::nMinPage"][::std::mem::offset_of!(tagPDEXA, nMinPage) - 72usize];
    ["Offset of field: tagPDEXA::nMaxPage"][::std::mem::offset_of!(tagPDEXA, nMaxPage) - 76usize];
    ["Offset of field: tagPDEXA::nCopies"][::std::mem::offset_of!(tagPDEXA, nCopies) - 80usize];
    ["Offset of field: tagPDEXA::hInstance"][::std::mem::offset_of!(tagPDEXA, hInstance) - 88usize];
    ["Offset of field: tagPDEXA::lpPrintTemplateName"]
        [::std::mem::offset_of!(tagPDEXA, lpPrintTemplateName) - 96usize];
    ["Offset of field: tagPDEXA::lpCallback"]
        [::std::mem::offset_of!(tagPDEXA, lpCallback) - 104usize];
    ["Offset of field: tagPDEXA::nPropertyPages"]
        [::std::mem::offset_of!(tagPDEXA, nPropertyPages) - 112usize];
    ["Offset of field: tagPDEXA::lphPropertyPages"]
        [::std::mem::offset_of!(tagPDEXA, lphPropertyPages) - 120usize];
    ["Offset of field: tagPDEXA::nStartPage"]
        [::std::mem::offset_of!(tagPDEXA, nStartPage) - 128usize];
    ["Offset of field: tagPDEXA::dwResultAction"]
        [::std::mem::offset_of!(tagPDEXA, dwResultAction) - 132usize];
};
pub type PRINTDLGEXA = tagPDEXA;
pub type LPPRINTDLGEXA = *mut tagPDEXA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPDEXW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub hDC: HDC,
    pub Flags: DWORD,
    pub Flags2: DWORD,
    pub ExclusionFlags: DWORD,
    pub nPageRanges: DWORD,
    pub nMaxPageRanges: DWORD,
    pub lpPageRanges: LPPRINTPAGERANGE,
    pub nMinPage: DWORD,
    pub nMaxPage: DWORD,
    pub nCopies: DWORD,
    pub hInstance: HINSTANCE,
    pub lpPrintTemplateName: LPCWSTR,
    pub lpCallback: LPUNKNOWN,
    pub nPropertyPages: DWORD,
    pub lphPropertyPages: *mut HPROPSHEETPAGE,
    pub nStartPage: DWORD,
    pub dwResultAction: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPDEXW"][::std::mem::size_of::<tagPDEXW>() - 136usize];
    ["Alignment of tagPDEXW"][::std::mem::align_of::<tagPDEXW>() - 8usize];
    ["Offset of field: tagPDEXW::lStructSize"]
        [::std::mem::offset_of!(tagPDEXW, lStructSize) - 0usize];
    ["Offset of field: tagPDEXW::hwndOwner"][::std::mem::offset_of!(tagPDEXW, hwndOwner) - 8usize];
    ["Offset of field: tagPDEXW::hDevMode"][::std::mem::offset_of!(tagPDEXW, hDevMode) - 16usize];
    ["Offset of field: tagPDEXW::hDevNames"][::std::mem::offset_of!(tagPDEXW, hDevNames) - 24usize];
    ["Offset of field: tagPDEXW::hDC"][::std::mem::offset_of!(tagPDEXW, hDC) - 32usize];
    ["Offset of field: tagPDEXW::Flags"][::std::mem::offset_of!(tagPDEXW, Flags) - 40usize];
    ["Offset of field: tagPDEXW::Flags2"][::std::mem::offset_of!(tagPDEXW, Flags2) - 44usize];
    ["Offset of field: tagPDEXW::ExclusionFlags"]
        [::std::mem::offset_of!(tagPDEXW, ExclusionFlags) - 48usize];
    ["Offset of field: tagPDEXW::nPageRanges"]
        [::std::mem::offset_of!(tagPDEXW, nPageRanges) - 52usize];
    ["Offset of field: tagPDEXW::nMaxPageRanges"]
        [::std::mem::offset_of!(tagPDEXW, nMaxPageRanges) - 56usize];
    ["Offset of field: tagPDEXW::lpPageRanges"]
        [::std::mem::offset_of!(tagPDEXW, lpPageRanges) - 64usize];
    ["Offset of field: tagPDEXW::nMinPage"][::std::mem::offset_of!(tagPDEXW, nMinPage) - 72usize];
    ["Offset of field: tagPDEXW::nMaxPage"][::std::mem::offset_of!(tagPDEXW, nMaxPage) - 76usize];
    ["Offset of field: tagPDEXW::nCopies"][::std::mem::offset_of!(tagPDEXW, nCopies) - 80usize];
    ["Offset of field: tagPDEXW::hInstance"][::std::mem::offset_of!(tagPDEXW, hInstance) - 88usize];
    ["Offset of field: tagPDEXW::lpPrintTemplateName"]
        [::std::mem::offset_of!(tagPDEXW, lpPrintTemplateName) - 96usize];
    ["Offset of field: tagPDEXW::lpCallback"]
        [::std::mem::offset_of!(tagPDEXW, lpCallback) - 104usize];
    ["Offset of field: tagPDEXW::nPropertyPages"]
        [::std::mem::offset_of!(tagPDEXW, nPropertyPages) - 112usize];
    ["Offset of field: tagPDEXW::lphPropertyPages"]
        [::std::mem::offset_of!(tagPDEXW, lphPropertyPages) - 120usize];
    ["Offset of field: tagPDEXW::nStartPage"]
        [::std::mem::offset_of!(tagPDEXW, nStartPage) - 128usize];
    ["Offset of field: tagPDEXW::dwResultAction"]
        [::std::mem::offset_of!(tagPDEXW, dwResultAction) - 132usize];
};
pub type PRINTDLGEXW = tagPDEXW;
pub type LPPRINTDLGEXW = *mut tagPDEXW;
pub type PRINTDLGEX = PRINTDLGEXA;
pub type LPPRINTDLGEX = LPPRINTDLGEXA;
unsafe extern "C" {
    pub fn PrintDlgExA(pPD: LPPRINTDLGEXA) -> HRESULT;
}
unsafe extern "C" {
    pub fn PrintDlgExW(pPD: LPPRINTDLGEXW) -> HRESULT;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagDEVNAMES {
    pub wDriverOffset: WORD,
    pub wDeviceOffset: WORD,
    pub wOutputOffset: WORD,
    pub wDefault: WORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagDEVNAMES"][::std::mem::size_of::<tagDEVNAMES>() - 8usize];
    ["Alignment of tagDEVNAMES"][::std::mem::align_of::<tagDEVNAMES>() - 2usize];
    ["Offset of field: tagDEVNAMES::wDriverOffset"]
        [::std::mem::offset_of!(tagDEVNAMES, wDriverOffset) - 0usize];
    ["Offset of field: tagDEVNAMES::wDeviceOffset"]
        [::std::mem::offset_of!(tagDEVNAMES, wDeviceOffset) - 2usize];
    ["Offset of field: tagDEVNAMES::wOutputOffset"]
        [::std::mem::offset_of!(tagDEVNAMES, wOutputOffset) - 4usize];
    ["Offset of field: tagDEVNAMES::wDefault"]
        [::std::mem::offset_of!(tagDEVNAMES, wDefault) - 6usize];
};
pub type DEVNAMES = tagDEVNAMES;
pub type LPDEVNAMES = *mut DEVNAMES;
pub type PCDEVNAMES = *const DEVNAMES;
unsafe extern "C" {
    pub fn CommDlgExtendedError() -> DWORD;
}
pub type LPPAGEPAINTHOOK = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
pub type LPPAGESETUPHOOK = ::std::option::Option<
    unsafe extern "C" fn(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> UINT_PTR,
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPSDA {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub Flags: DWORD,
    pub ptPaperSize: POINT,
    pub rtMinMargin: RECT,
    pub rtMargin: RECT,
    pub hInstance: HINSTANCE,
    pub lCustData: LPARAM,
    pub lpfnPageSetupHook: LPPAGESETUPHOOK,
    pub lpfnPagePaintHook: LPPAGEPAINTHOOK,
    pub lpPageSetupTemplateName: LPCSTR,
    pub hPageSetupTemplate: HGLOBAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPSDA"][::std::mem::size_of::<tagPSDA>() - 128usize];
    ["Alignment of tagPSDA"][::std::mem::align_of::<tagPSDA>() - 8usize];
    ["Offset of field: tagPSDA::lStructSize"]
        [::std::mem::offset_of!(tagPSDA, lStructSize) - 0usize];
    ["Offset of field: tagPSDA::hwndOwner"][::std::mem::offset_of!(tagPSDA, hwndOwner) - 8usize];
    ["Offset of field: tagPSDA::hDevMode"][::std::mem::offset_of!(tagPSDA, hDevMode) - 16usize];
    ["Offset of field: tagPSDA::hDevNames"][::std::mem::offset_of!(tagPSDA, hDevNames) - 24usize];
    ["Offset of field: tagPSDA::Flags"][::std::mem::offset_of!(tagPSDA, Flags) - 32usize];
    ["Offset of field: tagPSDA::ptPaperSize"]
        [::std::mem::offset_of!(tagPSDA, ptPaperSize) - 36usize];
    ["Offset of field: tagPSDA::rtMinMargin"]
        [::std::mem::offset_of!(tagPSDA, rtMinMargin) - 44usize];
    ["Offset of field: tagPSDA::rtMargin"][::std::mem::offset_of!(tagPSDA, rtMargin) - 60usize];
    ["Offset of field: tagPSDA::hInstance"][::std::mem::offset_of!(tagPSDA, hInstance) - 80usize];
    ["Offset of field: tagPSDA::lCustData"][::std::mem::offset_of!(tagPSDA, lCustData) - 88usize];
    ["Offset of field: tagPSDA::lpfnPageSetupHook"]
        [::std::mem::offset_of!(tagPSDA, lpfnPageSetupHook) - 96usize];
    ["Offset of field: tagPSDA::lpfnPagePaintHook"]
        [::std::mem::offset_of!(tagPSDA, lpfnPagePaintHook) - 104usize];
    ["Offset of field: tagPSDA::lpPageSetupTemplateName"]
        [::std::mem::offset_of!(tagPSDA, lpPageSetupTemplateName) - 112usize];
    ["Offset of field: tagPSDA::hPageSetupTemplate"]
        [::std::mem::offset_of!(tagPSDA, hPageSetupTemplate) - 120usize];
};
pub type PAGESETUPDLGA = tagPSDA;
pub type LPPAGESETUPDLGA = *mut tagPSDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagPSDW {
    pub lStructSize: DWORD,
    pub hwndOwner: HWND,
    pub hDevMode: HGLOBAL,
    pub hDevNames: HGLOBAL,
    pub Flags: DWORD,
    pub ptPaperSize: POINT,
    pub rtMinMargin: RECT,
    pub rtMargin: RECT,
    pub hInstance: HINSTANCE,
    pub lCustData: LPARAM,
    pub lpfnPageSetupHook: LPPAGESETUPHOOK,
    pub lpfnPagePaintHook: LPPAGEPAINTHOOK,
    pub lpPageSetupTemplateName: LPCWSTR,
    pub hPageSetupTemplate: HGLOBAL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagPSDW"][::std::mem::size_of::<tagPSDW>() - 128usize];
    ["Alignment of tagPSDW"][::std::mem::align_of::<tagPSDW>() - 8usize];
    ["Offset of field: tagPSDW::lStructSize"]
        [::std::mem::offset_of!(tagPSDW, lStructSize) - 0usize];
    ["Offset of field: tagPSDW::hwndOwner"][::std::mem::offset_of!(tagPSDW, hwndOwner) - 8usize];
    ["Offset of field: tagPSDW::hDevMode"][::std::mem::offset_of!(tagPSDW, hDevMode) - 16usize];
    ["Offset of field: tagPSDW::hDevNames"][::std::mem::offset_of!(tagPSDW, hDevNames) - 24usize];
    ["Offset of field: tagPSDW::Flags"][::std::mem::offset_of!(tagPSDW, Flags) - 32usize];
    ["Offset of field: tagPSDW::ptPaperSize"]
        [::std::mem::offset_of!(tagPSDW, ptPaperSize) - 36usize];
    ["Offset of field: tagPSDW::rtMinMargin"]
        [::std::mem::offset_of!(tagPSDW, rtMinMargin) - 44usize];
    ["Offset of field: tagPSDW::rtMargin"][::std::mem::offset_of!(tagPSDW, rtMargin) - 60usize];
    ["Offset of field: tagPSDW::hInstance"][::std::mem::offset_of!(tagPSDW, hInstance) - 80usize];
    ["Offset of field: tagPSDW::lCustData"][::std::mem::offset_of!(tagPSDW, lCustData) - 88usize];
    ["Offset of field: tagPSDW::lpfnPageSetupHook"]
        [::std::mem::offset_of!(tagPSDW, lpfnPageSetupHook) - 96usize];
    ["Offset of field: tagPSDW::lpfnPagePaintHook"]
        [::std::mem::offset_of!(tagPSDW, lpfnPagePaintHook) - 104usize];
    ["Offset of field: tagPSDW::lpPageSetupTemplateName"]
        [::std::mem::offset_of!(tagPSDW, lpPageSetupTemplateName) - 112usize];
    ["Offset of field: tagPSDW::hPageSetupTemplate"]
        [::std::mem::offset_of!(tagPSDW, hPageSetupTemplate) - 120usize];
};
pub type PAGESETUPDLGW = tagPSDW;
pub type LPPAGESETUPDLGW = *mut tagPSDW;
pub type PAGESETUPDLG = PAGESETUPDLGA;
pub type LPPAGESETUPDLG = LPPAGESETUPDLGA;
unsafe extern "C" {
    pub fn PageSetupDlgA(arg1: LPPAGESETUPDLGA) -> BOOL;
}
unsafe extern "C" {
    pub fn PageSetupDlgW(arg1: LPPAGESETUPDLGW) -> BOOL;
}
unsafe extern "C" {
    pub fn uaw_CharUpperW(String: LPUWSTR) -> LPUWSTR;
}
unsafe extern "C" {
    pub fn uaw_lstrcmpW(String1: PCUWSTR, String2: PCUWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn uaw_lstrcmpiW(String1: PCUWSTR, String2: PCUWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn uaw_lstrlenW(String: LPCUWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn uaw_wcschr(String: PCUWSTR, Character: WCHAR) -> PUWSTR;
}
unsafe extern "C" {
    pub fn uaw_wcscpy(Destination: PUWSTR, Source: PCUWSTR) -> PUWSTR;
}
unsafe extern "C" {
    pub fn uaw_wcsicmp(String1: PCUWSTR, String2: PCUWSTR) -> ::std::os::raw::c_int;
}
unsafe extern "C" {
    pub fn uaw_wcslen(String: PCUWSTR) -> usize;
}
unsafe extern "C" {
    pub fn uaw_wcsrchr(String: PCUWSTR, Character: WCHAR) -> PUWSTR;
}
pub type PUWSTR_C = *mut WCHAR;
unsafe extern "C" {
    pub static NETWORK_MANAGER_FIRST_IP_ADDRESS_ARRIVAL_GUID: GUID;
}
unsafe extern "C" {
    pub static NETWORK_MANAGER_LAST_IP_ADDRESS_REMOVAL_GUID: GUID;
}
unsafe extern "C" {
    pub static DOMAIN_JOIN_GUID: GUID;
}
unsafe extern "C" {
    pub static DOMAIN_LEAVE_GUID: GUID;
}
unsafe extern "C" {
    pub static FIREWALL_PORT_OPEN_GUID: GUID;
}
unsafe extern "C" {
    pub static FIREWALL_PORT_CLOSE_GUID: GUID;
}
unsafe extern "C" {
    pub static MACHINE_POLICY_PRESENT_GUID: GUID;
}
unsafe extern "C" {
    pub static USER_POLICY_PRESENT_GUID: GUID;
}
unsafe extern "C" {
    pub static RPC_INTERFACE_EVENT_GUID: GUID;
}
unsafe extern "C" {
    pub static NAMED_PIPE_EVENT_GUID: GUID;
}
unsafe extern "C" {
    pub static CUSTOM_SYSTEM_STATE_CHANGE_EVENT_GUID: GUID;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SERVICE_TRIGGER_CUSTOM_STATE_ID {
    pub Data: [DWORD; 2usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SERVICE_TRIGGER_CUSTOM_STATE_ID"]
        [::std::mem::size_of::<SERVICE_TRIGGER_CUSTOM_STATE_ID>() - 8usize];
    ["Alignment of SERVICE_TRIGGER_CUSTOM_STATE_ID"]
        [::std::mem::align_of::<SERVICE_TRIGGER_CUSTOM_STATE_ID>() - 4usize];
    ["Offset of field: SERVICE_TRIGGER_CUSTOM_STATE_ID::Data"]
        [::std::mem::offset_of!(SERVICE_TRIGGER_CUSTOM_STATE_ID, Data) - 0usize];
};
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM {
    pub u: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1 {
    pub CustomStateId: SERVICE_TRIGGER_CUSTOM_STATE_ID,
    pub s: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1 {
    pub DataOffset: DWORD,
    pub Data: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::size_of::<
            _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1,
        >() - 8usize];
    ["Alignment of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1"]
        [::std::mem::align_of::<
            _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1,
        >() - 4usize];
    ["Offset of field: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1::DataOffset"] [:: std :: mem :: offset_of ! (_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1 , DataOffset) - 0usize] ;
    ["Offset of field: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1::Data"] [:: std :: mem :: offset_of ! (_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1__bindgen_ty_1 , Data) - 4usize] ;
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1"][::std::mem::size_of::<
        _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1,
    >() - 8usize];
    ["Alignment of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1"]
        [::std::mem::align_of::<_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1>()
            - 4usize];
    ["Offset of field: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1::CustomStateId"] [:: std :: mem :: offset_of ! (_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1 , CustomStateId) - 0usize] ;
    ["Offset of field: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1::s"][::std::mem::offset_of!(
        _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM__bindgen_ty_1,
        s
    ) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM"]
        [::std::mem::size_of::<_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM>() - 8usize];
    ["Alignment of _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM"]
        [::std::mem::align_of::<_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM>() - 4usize];
    ["Offset of field: _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM::u"]
        [::std::mem::offset_of!(_SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM, u) - 0usize];
};
pub type SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM =
    _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM;
pub type LPSERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM =
    *mut _SERVICE_CUSTOM_SYSTEM_STATE_CHANGE_DATA_ITEM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_DESCRIPTIONA {
    pub lpDescription: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_DESCRIPTIONA"][::std::mem::size_of::<_SERVICE_DESCRIPTIONA>() - 8usize];
    ["Alignment of _SERVICE_DESCRIPTIONA"]
        [::std::mem::align_of::<_SERVICE_DESCRIPTIONA>() - 8usize];
    ["Offset of field: _SERVICE_DESCRIPTIONA::lpDescription"]
        [::std::mem::offset_of!(_SERVICE_DESCRIPTIONA, lpDescription) - 0usize];
};
pub type SERVICE_DESCRIPTIONA = _SERVICE_DESCRIPTIONA;
pub type LPSERVICE_DESCRIPTIONA = *mut _SERVICE_DESCRIPTIONA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_DESCRIPTIONW {
    pub lpDescription: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_DESCRIPTIONW"][::std::mem::size_of::<_SERVICE_DESCRIPTIONW>() - 8usize];
    ["Alignment of _SERVICE_DESCRIPTIONW"]
        [::std::mem::align_of::<_SERVICE_DESCRIPTIONW>() - 8usize];
    ["Offset of field: _SERVICE_DESCRIPTIONW::lpDescription"]
        [::std::mem::offset_of!(_SERVICE_DESCRIPTIONW, lpDescription) - 0usize];
};
pub type SERVICE_DESCRIPTIONW = _SERVICE_DESCRIPTIONW;
pub type LPSERVICE_DESCRIPTIONW = *mut _SERVICE_DESCRIPTIONW;
pub type SERVICE_DESCRIPTION = SERVICE_DESCRIPTIONA;
pub type LPSERVICE_DESCRIPTION = LPSERVICE_DESCRIPTIONA;
pub const _SC_ACTION_TYPE_SC_ACTION_NONE: _SC_ACTION_TYPE = 0;
pub const _SC_ACTION_TYPE_SC_ACTION_RESTART: _SC_ACTION_TYPE = 1;
pub const _SC_ACTION_TYPE_SC_ACTION_REBOOT: _SC_ACTION_TYPE = 2;
pub const _SC_ACTION_TYPE_SC_ACTION_RUN_COMMAND: _SC_ACTION_TYPE = 3;
pub const _SC_ACTION_TYPE_SC_ACTION_OWN_RESTART: _SC_ACTION_TYPE = 4;
pub type _SC_ACTION_TYPE = ::std::os::raw::c_int;
pub use self::_SC_ACTION_TYPE as SC_ACTION_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SC_ACTION {
    pub Type: SC_ACTION_TYPE,
    pub Delay: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SC_ACTION"][::std::mem::size_of::<_SC_ACTION>() - 8usize];
    ["Alignment of _SC_ACTION"][::std::mem::align_of::<_SC_ACTION>() - 4usize];
    ["Offset of field: _SC_ACTION::Type"][::std::mem::offset_of!(_SC_ACTION, Type) - 0usize];
    ["Offset of field: _SC_ACTION::Delay"][::std::mem::offset_of!(_SC_ACTION, Delay) - 4usize];
};
pub type SC_ACTION = _SC_ACTION;
pub type LPSC_ACTION = *mut _SC_ACTION;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_FAILURE_ACTIONSA {
    pub dwResetPeriod: DWORD,
    pub lpRebootMsg: LPSTR,
    pub lpCommand: LPSTR,
    pub cActions: DWORD,
    pub lpsaActions: *mut SC_ACTION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_FAILURE_ACTIONSA"]
        [::std::mem::size_of::<_SERVICE_FAILURE_ACTIONSA>() - 40usize];
    ["Alignment of _SERVICE_FAILURE_ACTIONSA"]
        [::std::mem::align_of::<_SERVICE_FAILURE_ACTIONSA>() - 8usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSA::dwResetPeriod"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSA, dwResetPeriod) - 0usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSA::lpRebootMsg"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSA, lpRebootMsg) - 8usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSA::lpCommand"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSA, lpCommand) - 16usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSA::cActions"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSA, cActions) - 24usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSA::lpsaActions"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSA, lpsaActions) - 32usize];
};
pub type SERVICE_FAILURE_ACTIONSA = _SERVICE_FAILURE_ACTIONSA;
pub type LPSERVICE_FAILURE_ACTIONSA = *mut _SERVICE_FAILURE_ACTIONSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_FAILURE_ACTIONSW {
    pub dwResetPeriod: DWORD,
    pub lpRebootMsg: LPWSTR,
    pub lpCommand: LPWSTR,
    pub cActions: DWORD,
    pub lpsaActions: *mut SC_ACTION,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_FAILURE_ACTIONSW"]
        [::std::mem::size_of::<_SERVICE_FAILURE_ACTIONSW>() - 40usize];
    ["Alignment of _SERVICE_FAILURE_ACTIONSW"]
        [::std::mem::align_of::<_SERVICE_FAILURE_ACTIONSW>() - 8usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSW::dwResetPeriod"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSW, dwResetPeriod) - 0usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSW::lpRebootMsg"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSW, lpRebootMsg) - 8usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSW::lpCommand"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSW, lpCommand) - 16usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSW::cActions"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSW, cActions) - 24usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONSW::lpsaActions"]
        [::std::mem::offset_of!(_SERVICE_FAILURE_ACTIONSW, lpsaActions) - 32usize];
};
pub type SERVICE_FAILURE_ACTIONSW = _SERVICE_FAILURE_ACTIONSW;
pub type LPSERVICE_FAILURE_ACTIONSW = *mut _SERVICE_FAILURE_ACTIONSW;
pub type SERVICE_FAILURE_ACTIONS = SERVICE_FAILURE_ACTIONSA;
pub type LPSERVICE_FAILURE_ACTIONS = LPSERVICE_FAILURE_ACTIONSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_DELAYED_AUTO_START_INFO {
    pub fDelayedAutostart: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_DELAYED_AUTO_START_INFO"]
        [::std::mem::size_of::<_SERVICE_DELAYED_AUTO_START_INFO>() - 4usize];
    ["Alignment of _SERVICE_DELAYED_AUTO_START_INFO"]
        [::std::mem::align_of::<_SERVICE_DELAYED_AUTO_START_INFO>() - 4usize];
    ["Offset of field: _SERVICE_DELAYED_AUTO_START_INFO::fDelayedAutostart"]
        [::std::mem::offset_of!(_SERVICE_DELAYED_AUTO_START_INFO, fDelayedAutostart) - 0usize];
};
pub type SERVICE_DELAYED_AUTO_START_INFO = _SERVICE_DELAYED_AUTO_START_INFO;
pub type LPSERVICE_DELAYED_AUTO_START_INFO = *mut _SERVICE_DELAYED_AUTO_START_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_FAILURE_ACTIONS_FLAG {
    pub fFailureActionsOnNonCrashFailures: BOOL,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_FAILURE_ACTIONS_FLAG"]
        [::std::mem::size_of::<_SERVICE_FAILURE_ACTIONS_FLAG>() - 4usize];
    ["Alignment of _SERVICE_FAILURE_ACTIONS_FLAG"]
        [::std::mem::align_of::<_SERVICE_FAILURE_ACTIONS_FLAG>() - 4usize];
    ["Offset of field: _SERVICE_FAILURE_ACTIONS_FLAG::fFailureActionsOnNonCrashFailures"][::std::mem::offset_of!(
        _SERVICE_FAILURE_ACTIONS_FLAG,
        fFailureActionsOnNonCrashFailures
    )
        - 0usize];
};
pub type SERVICE_FAILURE_ACTIONS_FLAG = _SERVICE_FAILURE_ACTIONS_FLAG;
pub type LPSERVICE_FAILURE_ACTIONS_FLAG = *mut _SERVICE_FAILURE_ACTIONS_FLAG;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_SID_INFO {
    pub dwServiceSidType: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_SID_INFO"][::std::mem::size_of::<_SERVICE_SID_INFO>() - 4usize];
    ["Alignment of _SERVICE_SID_INFO"][::std::mem::align_of::<_SERVICE_SID_INFO>() - 4usize];
    ["Offset of field: _SERVICE_SID_INFO::dwServiceSidType"]
        [::std::mem::offset_of!(_SERVICE_SID_INFO, dwServiceSidType) - 0usize];
};
pub type SERVICE_SID_INFO = _SERVICE_SID_INFO;
pub type LPSERVICE_SID_INFO = *mut _SERVICE_SID_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_REQUIRED_PRIVILEGES_INFOA {
    pub pmszRequiredPrivileges: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_REQUIRED_PRIVILEGES_INFOA"]
        [::std::mem::size_of::<_SERVICE_REQUIRED_PRIVILEGES_INFOA>() - 8usize];
    ["Alignment of _SERVICE_REQUIRED_PRIVILEGES_INFOA"]
        [::std::mem::align_of::<_SERVICE_REQUIRED_PRIVILEGES_INFOA>() - 8usize];
    ["Offset of field: _SERVICE_REQUIRED_PRIVILEGES_INFOA::pmszRequiredPrivileges"][::std::mem::offset_of!(
        _SERVICE_REQUIRED_PRIVILEGES_INFOA,
        pmszRequiredPrivileges
    ) - 0usize];
};
pub type SERVICE_REQUIRED_PRIVILEGES_INFOA = _SERVICE_REQUIRED_PRIVILEGES_INFOA;
pub type LPSERVICE_REQUIRED_PRIVILEGES_INFOA = *mut _SERVICE_REQUIRED_PRIVILEGES_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_REQUIRED_PRIVILEGES_INFOW {
    pub pmszRequiredPrivileges: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_REQUIRED_PRIVILEGES_INFOW"]
        [::std::mem::size_of::<_SERVICE_REQUIRED_PRIVILEGES_INFOW>() - 8usize];
    ["Alignment of _SERVICE_REQUIRED_PRIVILEGES_INFOW"]
        [::std::mem::align_of::<_SERVICE_REQUIRED_PRIVILEGES_INFOW>() - 8usize];
    ["Offset of field: _SERVICE_REQUIRED_PRIVILEGES_INFOW::pmszRequiredPrivileges"][::std::mem::offset_of!(
        _SERVICE_REQUIRED_PRIVILEGES_INFOW,
        pmszRequiredPrivileges
    ) - 0usize];
};
pub type SERVICE_REQUIRED_PRIVILEGES_INFOW = _SERVICE_REQUIRED_PRIVILEGES_INFOW;
pub type LPSERVICE_REQUIRED_PRIVILEGES_INFOW = *mut _SERVICE_REQUIRED_PRIVILEGES_INFOW;
pub type SERVICE_REQUIRED_PRIVILEGES_INFO = SERVICE_REQUIRED_PRIVILEGES_INFOA;
pub type LPSERVICE_REQUIRED_PRIVILEGES_INFO = LPSERVICE_REQUIRED_PRIVILEGES_INFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_PRESHUTDOWN_INFO {
    pub dwPreshutdownTimeout: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_PRESHUTDOWN_INFO"]
        [::std::mem::size_of::<_SERVICE_PRESHUTDOWN_INFO>() - 4usize];
    ["Alignment of _SERVICE_PRESHUTDOWN_INFO"]
        [::std::mem::align_of::<_SERVICE_PRESHUTDOWN_INFO>() - 4usize];
    ["Offset of field: _SERVICE_PRESHUTDOWN_INFO::dwPreshutdownTimeout"]
        [::std::mem::offset_of!(_SERVICE_PRESHUTDOWN_INFO, dwPreshutdownTimeout) - 0usize];
};
pub type SERVICE_PRESHUTDOWN_INFO = _SERVICE_PRESHUTDOWN_INFO;
pub type LPSERVICE_PRESHUTDOWN_INFO = *mut _SERVICE_PRESHUTDOWN_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM {
    pub dwDataType: DWORD,
    pub cbData: DWORD,
    pub pData: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM"]
        [::std::mem::size_of::<_SERVICE_TRIGGER_SPECIFIC_DATA_ITEM>() - 16usize];
    ["Alignment of _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM"]
        [::std::mem::align_of::<_SERVICE_TRIGGER_SPECIFIC_DATA_ITEM>() - 8usize];
    ["Offset of field: _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM::dwDataType"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_SPECIFIC_DATA_ITEM, dwDataType) - 0usize];
    ["Offset of field: _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM::cbData"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_SPECIFIC_DATA_ITEM, cbData) - 4usize];
    ["Offset of field: _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM::pData"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_SPECIFIC_DATA_ITEM, pData) - 8usize];
};
pub type SERVICE_TRIGGER_SPECIFIC_DATA_ITEM = _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM;
pub type PSERVICE_TRIGGER_SPECIFIC_DATA_ITEM = *mut _SERVICE_TRIGGER_SPECIFIC_DATA_ITEM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_TRIGGER {
    pub dwTriggerType: DWORD,
    pub dwAction: DWORD,
    pub pTriggerSubtype: *mut GUID,
    pub cDataItems: DWORD,
    pub pDataItems: PSERVICE_TRIGGER_SPECIFIC_DATA_ITEM,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TRIGGER"][::std::mem::size_of::<_SERVICE_TRIGGER>() - 32usize];
    ["Alignment of _SERVICE_TRIGGER"][::std::mem::align_of::<_SERVICE_TRIGGER>() - 8usize];
    ["Offset of field: _SERVICE_TRIGGER::dwTriggerType"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER, dwTriggerType) - 0usize];
    ["Offset of field: _SERVICE_TRIGGER::dwAction"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER, dwAction) - 4usize];
    ["Offset of field: _SERVICE_TRIGGER::pTriggerSubtype"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER, pTriggerSubtype) - 8usize];
    ["Offset of field: _SERVICE_TRIGGER::cDataItems"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER, cDataItems) - 16usize];
    ["Offset of field: _SERVICE_TRIGGER::pDataItems"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER, pDataItems) - 24usize];
};
pub type SERVICE_TRIGGER = _SERVICE_TRIGGER;
pub type PSERVICE_TRIGGER = *mut _SERVICE_TRIGGER;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_TRIGGER_INFO {
    pub cTriggers: DWORD,
    pub pTriggers: PSERVICE_TRIGGER,
    pub pReserved: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TRIGGER_INFO"][::std::mem::size_of::<_SERVICE_TRIGGER_INFO>() - 24usize];
    ["Alignment of _SERVICE_TRIGGER_INFO"]
        [::std::mem::align_of::<_SERVICE_TRIGGER_INFO>() - 8usize];
    ["Offset of field: _SERVICE_TRIGGER_INFO::cTriggers"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_INFO, cTriggers) - 0usize];
    ["Offset of field: _SERVICE_TRIGGER_INFO::pTriggers"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_INFO, pTriggers) - 8usize];
    ["Offset of field: _SERVICE_TRIGGER_INFO::pReserved"]
        [::std::mem::offset_of!(_SERVICE_TRIGGER_INFO, pReserved) - 16usize];
};
pub type SERVICE_TRIGGER_INFO = _SERVICE_TRIGGER_INFO;
pub type PSERVICE_TRIGGER_INFO = *mut _SERVICE_TRIGGER_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_PREFERRED_NODE_INFO {
    pub usPreferredNode: USHORT,
    pub fDelete: BOOLEAN,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_PREFERRED_NODE_INFO"]
        [::std::mem::size_of::<_SERVICE_PREFERRED_NODE_INFO>() - 4usize];
    ["Alignment of _SERVICE_PREFERRED_NODE_INFO"]
        [::std::mem::align_of::<_SERVICE_PREFERRED_NODE_INFO>() - 2usize];
    ["Offset of field: _SERVICE_PREFERRED_NODE_INFO::usPreferredNode"]
        [::std::mem::offset_of!(_SERVICE_PREFERRED_NODE_INFO, usPreferredNode) - 0usize];
    ["Offset of field: _SERVICE_PREFERRED_NODE_INFO::fDelete"]
        [::std::mem::offset_of!(_SERVICE_PREFERRED_NODE_INFO, fDelete) - 2usize];
};
pub type SERVICE_PREFERRED_NODE_INFO = _SERVICE_PREFERRED_NODE_INFO;
pub type LPSERVICE_PREFERRED_NODE_INFO = *mut _SERVICE_PREFERRED_NODE_INFO;
#[repr(C)]
#[derive(Copy, Clone)]
pub struct _SERVICE_TIMECHANGE_INFO {
    pub liNewTime: LARGE_INTEGER,
    pub liOldTime: LARGE_INTEGER,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TIMECHANGE_INFO"]
        [::std::mem::size_of::<_SERVICE_TIMECHANGE_INFO>() - 16usize];
    ["Alignment of _SERVICE_TIMECHANGE_INFO"]
        [::std::mem::align_of::<_SERVICE_TIMECHANGE_INFO>() - 8usize];
    ["Offset of field: _SERVICE_TIMECHANGE_INFO::liNewTime"]
        [::std::mem::offset_of!(_SERVICE_TIMECHANGE_INFO, liNewTime) - 0usize];
    ["Offset of field: _SERVICE_TIMECHANGE_INFO::liOldTime"]
        [::std::mem::offset_of!(_SERVICE_TIMECHANGE_INFO, liOldTime) - 8usize];
};
pub type SERVICE_TIMECHANGE_INFO = _SERVICE_TIMECHANGE_INFO;
pub type PSERVICE_TIMECHANGE_INFO = *mut _SERVICE_TIMECHANGE_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_LAUNCH_PROTECTED_INFO {
    pub dwLaunchProtected: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_LAUNCH_PROTECTED_INFO"]
        [::std::mem::size_of::<_SERVICE_LAUNCH_PROTECTED_INFO>() - 4usize];
    ["Alignment of _SERVICE_LAUNCH_PROTECTED_INFO"]
        [::std::mem::align_of::<_SERVICE_LAUNCH_PROTECTED_INFO>() - 4usize];
    ["Offset of field: _SERVICE_LAUNCH_PROTECTED_INFO::dwLaunchProtected"]
        [::std::mem::offset_of!(_SERVICE_LAUNCH_PROTECTED_INFO, dwLaunchProtected) - 0usize];
};
pub type SERVICE_LAUNCH_PROTECTED_INFO = _SERVICE_LAUNCH_PROTECTED_INFO;
pub type PSERVICE_LAUNCH_PROTECTED_INFO = *mut _SERVICE_LAUNCH_PROTECTED_INFO;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SC_HANDLE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SC_HANDLE__"][::std::mem::size_of::<SC_HANDLE__>() - 4usize];
    ["Alignment of SC_HANDLE__"][::std::mem::align_of::<SC_HANDLE__>() - 4usize];
    ["Offset of field: SC_HANDLE__::unused"][::std::mem::offset_of!(SC_HANDLE__, unused) - 0usize];
};
pub type SC_HANDLE = *mut SC_HANDLE__;
pub type LPSC_HANDLE = *mut SC_HANDLE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct SERVICE_STATUS_HANDLE__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of SERVICE_STATUS_HANDLE__"][::std::mem::size_of::<SERVICE_STATUS_HANDLE__>() - 4usize];
    ["Alignment of SERVICE_STATUS_HANDLE__"]
        [::std::mem::align_of::<SERVICE_STATUS_HANDLE__>() - 4usize];
    ["Offset of field: SERVICE_STATUS_HANDLE__::unused"]
        [::std::mem::offset_of!(SERVICE_STATUS_HANDLE__, unused) - 0usize];
};
pub type SERVICE_STATUS_HANDLE = *mut SERVICE_STATUS_HANDLE__;
pub const _SC_STATUS_TYPE_SC_STATUS_PROCESS_INFO: _SC_STATUS_TYPE = 0;
pub type _SC_STATUS_TYPE = ::std::os::raw::c_int;
pub use self::_SC_STATUS_TYPE as SC_STATUS_TYPE;
pub const _SC_ENUM_TYPE_SC_ENUM_PROCESS_INFO: _SC_ENUM_TYPE = 0;
pub type _SC_ENUM_TYPE = ::std::os::raw::c_int;
pub use self::_SC_ENUM_TYPE as SC_ENUM_TYPE;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_STATUS {
    pub dwServiceType: DWORD,
    pub dwCurrentState: DWORD,
    pub dwControlsAccepted: DWORD,
    pub dwWin32ExitCode: DWORD,
    pub dwServiceSpecificExitCode: DWORD,
    pub dwCheckPoint: DWORD,
    pub dwWaitHint: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_STATUS"][::std::mem::size_of::<_SERVICE_STATUS>() - 28usize];
    ["Alignment of _SERVICE_STATUS"][::std::mem::align_of::<_SERVICE_STATUS>() - 4usize];
    ["Offset of field: _SERVICE_STATUS::dwServiceType"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwServiceType) - 0usize];
    ["Offset of field: _SERVICE_STATUS::dwCurrentState"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwCurrentState) - 4usize];
    ["Offset of field: _SERVICE_STATUS::dwControlsAccepted"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwControlsAccepted) - 8usize];
    ["Offset of field: _SERVICE_STATUS::dwWin32ExitCode"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwWin32ExitCode) - 12usize];
    ["Offset of field: _SERVICE_STATUS::dwServiceSpecificExitCode"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwServiceSpecificExitCode) - 16usize];
    ["Offset of field: _SERVICE_STATUS::dwCheckPoint"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwCheckPoint) - 20usize];
    ["Offset of field: _SERVICE_STATUS::dwWaitHint"]
        [::std::mem::offset_of!(_SERVICE_STATUS, dwWaitHint) - 24usize];
};
pub type SERVICE_STATUS = _SERVICE_STATUS;
pub type LPSERVICE_STATUS = *mut _SERVICE_STATUS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_STATUS_PROCESS {
    pub dwServiceType: DWORD,
    pub dwCurrentState: DWORD,
    pub dwControlsAccepted: DWORD,
    pub dwWin32ExitCode: DWORD,
    pub dwServiceSpecificExitCode: DWORD,
    pub dwCheckPoint: DWORD,
    pub dwWaitHint: DWORD,
    pub dwProcessId: DWORD,
    pub dwServiceFlags: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_STATUS_PROCESS"][::std::mem::size_of::<_SERVICE_STATUS_PROCESS>() - 36usize];
    ["Alignment of _SERVICE_STATUS_PROCESS"]
        [::std::mem::align_of::<_SERVICE_STATUS_PROCESS>() - 4usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwServiceType"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwServiceType) - 0usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwCurrentState"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwCurrentState) - 4usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwControlsAccepted"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwControlsAccepted) - 8usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwWin32ExitCode"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwWin32ExitCode) - 12usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwServiceSpecificExitCode"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwServiceSpecificExitCode) - 16usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwCheckPoint"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwCheckPoint) - 20usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwWaitHint"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwWaitHint) - 24usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwProcessId"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwProcessId) - 28usize];
    ["Offset of field: _SERVICE_STATUS_PROCESS::dwServiceFlags"]
        [::std::mem::offset_of!(_SERVICE_STATUS_PROCESS, dwServiceFlags) - 32usize];
};
pub type SERVICE_STATUS_PROCESS = _SERVICE_STATUS_PROCESS;
pub type LPSERVICE_STATUS_PROCESS = *mut _SERVICE_STATUS_PROCESS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENUM_SERVICE_STATUSA {
    pub lpServiceName: LPSTR,
    pub lpDisplayName: LPSTR,
    pub ServiceStatus: SERVICE_STATUS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENUM_SERVICE_STATUSA"][::std::mem::size_of::<_ENUM_SERVICE_STATUSA>() - 48usize];
    ["Alignment of _ENUM_SERVICE_STATUSA"]
        [::std::mem::align_of::<_ENUM_SERVICE_STATUSA>() - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUSA::lpServiceName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSA, lpServiceName) - 0usize];
    ["Offset of field: _ENUM_SERVICE_STATUSA::lpDisplayName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSA, lpDisplayName) - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUSA::ServiceStatus"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSA, ServiceStatus) - 16usize];
};
pub type ENUM_SERVICE_STATUSA = _ENUM_SERVICE_STATUSA;
pub type LPENUM_SERVICE_STATUSA = *mut _ENUM_SERVICE_STATUSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENUM_SERVICE_STATUSW {
    pub lpServiceName: LPWSTR,
    pub lpDisplayName: LPWSTR,
    pub ServiceStatus: SERVICE_STATUS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENUM_SERVICE_STATUSW"][::std::mem::size_of::<_ENUM_SERVICE_STATUSW>() - 48usize];
    ["Alignment of _ENUM_SERVICE_STATUSW"]
        [::std::mem::align_of::<_ENUM_SERVICE_STATUSW>() - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUSW::lpServiceName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSW, lpServiceName) - 0usize];
    ["Offset of field: _ENUM_SERVICE_STATUSW::lpDisplayName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSW, lpDisplayName) - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUSW::ServiceStatus"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUSW, ServiceStatus) - 16usize];
};
pub type ENUM_SERVICE_STATUSW = _ENUM_SERVICE_STATUSW;
pub type LPENUM_SERVICE_STATUSW = *mut _ENUM_SERVICE_STATUSW;
pub type ENUM_SERVICE_STATUS = ENUM_SERVICE_STATUSA;
pub type LPENUM_SERVICE_STATUS = LPENUM_SERVICE_STATUSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENUM_SERVICE_STATUS_PROCESSA {
    pub lpServiceName: LPSTR,
    pub lpDisplayName: LPSTR,
    pub ServiceStatusProcess: SERVICE_STATUS_PROCESS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENUM_SERVICE_STATUS_PROCESSA"]
        [::std::mem::size_of::<_ENUM_SERVICE_STATUS_PROCESSA>() - 56usize];
    ["Alignment of _ENUM_SERVICE_STATUS_PROCESSA"]
        [::std::mem::align_of::<_ENUM_SERVICE_STATUS_PROCESSA>() - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSA::lpServiceName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSA, lpServiceName) - 0usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSA::lpDisplayName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSA, lpDisplayName) - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSA::ServiceStatusProcess"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSA, ServiceStatusProcess) - 16usize];
};
pub type ENUM_SERVICE_STATUS_PROCESSA = _ENUM_SERVICE_STATUS_PROCESSA;
pub type LPENUM_SERVICE_STATUS_PROCESSA = *mut _ENUM_SERVICE_STATUS_PROCESSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ENUM_SERVICE_STATUS_PROCESSW {
    pub lpServiceName: LPWSTR,
    pub lpDisplayName: LPWSTR,
    pub ServiceStatusProcess: SERVICE_STATUS_PROCESS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _ENUM_SERVICE_STATUS_PROCESSW"]
        [::std::mem::size_of::<_ENUM_SERVICE_STATUS_PROCESSW>() - 56usize];
    ["Alignment of _ENUM_SERVICE_STATUS_PROCESSW"]
        [::std::mem::align_of::<_ENUM_SERVICE_STATUS_PROCESSW>() - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSW::lpServiceName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSW, lpServiceName) - 0usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSW::lpDisplayName"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSW, lpDisplayName) - 8usize];
    ["Offset of field: _ENUM_SERVICE_STATUS_PROCESSW::ServiceStatusProcess"]
        [::std::mem::offset_of!(_ENUM_SERVICE_STATUS_PROCESSW, ServiceStatusProcess) - 16usize];
};
pub type ENUM_SERVICE_STATUS_PROCESSW = _ENUM_SERVICE_STATUS_PROCESSW;
pub type LPENUM_SERVICE_STATUS_PROCESSW = *mut _ENUM_SERVICE_STATUS_PROCESSW;
pub type ENUM_SERVICE_STATUS_PROCESS = ENUM_SERVICE_STATUS_PROCESSA;
pub type LPENUM_SERVICE_STATUS_PROCESS = LPENUM_SERVICE_STATUS_PROCESSA;
pub type SC_LOCK = LPVOID;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_SERVICE_LOCK_STATUSA {
    pub fIsLocked: DWORD,
    pub lpLockOwner: LPSTR,
    pub dwLockDuration: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_SERVICE_LOCK_STATUSA"]
        [::std::mem::size_of::<_QUERY_SERVICE_LOCK_STATUSA>() - 24usize];
    ["Alignment of _QUERY_SERVICE_LOCK_STATUSA"]
        [::std::mem::align_of::<_QUERY_SERVICE_LOCK_STATUSA>() - 8usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSA::fIsLocked"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSA, fIsLocked) - 0usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSA::lpLockOwner"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSA, lpLockOwner) - 8usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSA::dwLockDuration"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSA, dwLockDuration) - 16usize];
};
pub type QUERY_SERVICE_LOCK_STATUSA = _QUERY_SERVICE_LOCK_STATUSA;
pub type LPQUERY_SERVICE_LOCK_STATUSA = *mut _QUERY_SERVICE_LOCK_STATUSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_SERVICE_LOCK_STATUSW {
    pub fIsLocked: DWORD,
    pub lpLockOwner: LPWSTR,
    pub dwLockDuration: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_SERVICE_LOCK_STATUSW"]
        [::std::mem::size_of::<_QUERY_SERVICE_LOCK_STATUSW>() - 24usize];
    ["Alignment of _QUERY_SERVICE_LOCK_STATUSW"]
        [::std::mem::align_of::<_QUERY_SERVICE_LOCK_STATUSW>() - 8usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSW::fIsLocked"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSW, fIsLocked) - 0usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSW::lpLockOwner"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSW, lpLockOwner) - 8usize];
    ["Offset of field: _QUERY_SERVICE_LOCK_STATUSW::dwLockDuration"]
        [::std::mem::offset_of!(_QUERY_SERVICE_LOCK_STATUSW, dwLockDuration) - 16usize];
};
pub type QUERY_SERVICE_LOCK_STATUSW = _QUERY_SERVICE_LOCK_STATUSW;
pub type LPQUERY_SERVICE_LOCK_STATUSW = *mut _QUERY_SERVICE_LOCK_STATUSW;
pub type QUERY_SERVICE_LOCK_STATUS = QUERY_SERVICE_LOCK_STATUSA;
pub type LPQUERY_SERVICE_LOCK_STATUS = LPQUERY_SERVICE_LOCK_STATUSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_SERVICE_CONFIGA {
    pub dwServiceType: DWORD,
    pub dwStartType: DWORD,
    pub dwErrorControl: DWORD,
    pub lpBinaryPathName: LPSTR,
    pub lpLoadOrderGroup: LPSTR,
    pub dwTagId: DWORD,
    pub lpDependencies: LPSTR,
    pub lpServiceStartName: LPSTR,
    pub lpDisplayName: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_SERVICE_CONFIGA"][::std::mem::size_of::<_QUERY_SERVICE_CONFIGA>() - 64usize];
    ["Alignment of _QUERY_SERVICE_CONFIGA"]
        [::std::mem::align_of::<_QUERY_SERVICE_CONFIGA>() - 8usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::dwServiceType"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, dwServiceType) - 0usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::dwStartType"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, dwStartType) - 4usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::dwErrorControl"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, dwErrorControl) - 8usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::lpBinaryPathName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, lpBinaryPathName) - 16usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::lpLoadOrderGroup"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, lpLoadOrderGroup) - 24usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::dwTagId"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, dwTagId) - 32usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::lpDependencies"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, lpDependencies) - 40usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::lpServiceStartName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, lpServiceStartName) - 48usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGA::lpDisplayName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGA, lpDisplayName) - 56usize];
};
pub type QUERY_SERVICE_CONFIGA = _QUERY_SERVICE_CONFIGA;
pub type LPQUERY_SERVICE_CONFIGA = *mut _QUERY_SERVICE_CONFIGA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _QUERY_SERVICE_CONFIGW {
    pub dwServiceType: DWORD,
    pub dwStartType: DWORD,
    pub dwErrorControl: DWORD,
    pub lpBinaryPathName: LPWSTR,
    pub lpLoadOrderGroup: LPWSTR,
    pub dwTagId: DWORD,
    pub lpDependencies: LPWSTR,
    pub lpServiceStartName: LPWSTR,
    pub lpDisplayName: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _QUERY_SERVICE_CONFIGW"][::std::mem::size_of::<_QUERY_SERVICE_CONFIGW>() - 64usize];
    ["Alignment of _QUERY_SERVICE_CONFIGW"]
        [::std::mem::align_of::<_QUERY_SERVICE_CONFIGW>() - 8usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::dwServiceType"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, dwServiceType) - 0usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::dwStartType"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, dwStartType) - 4usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::dwErrorControl"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, dwErrorControl) - 8usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::lpBinaryPathName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, lpBinaryPathName) - 16usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::lpLoadOrderGroup"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, lpLoadOrderGroup) - 24usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::dwTagId"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, dwTagId) - 32usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::lpDependencies"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, lpDependencies) - 40usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::lpServiceStartName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, lpServiceStartName) - 48usize];
    ["Offset of field: _QUERY_SERVICE_CONFIGW::lpDisplayName"]
        [::std::mem::offset_of!(_QUERY_SERVICE_CONFIGW, lpDisplayName) - 56usize];
};
pub type QUERY_SERVICE_CONFIGW = _QUERY_SERVICE_CONFIGW;
pub type LPQUERY_SERVICE_CONFIGW = *mut _QUERY_SERVICE_CONFIGW;
pub type QUERY_SERVICE_CONFIG = QUERY_SERVICE_CONFIGA;
pub type LPQUERY_SERVICE_CONFIG = LPQUERY_SERVICE_CONFIGA;
pub type LPSERVICE_MAIN_FUNCTIONW = ::std::option::Option<
    unsafe extern "C" fn(dwNumServicesArgs: DWORD, lpServiceArgVectors: *mut LPWSTR),
>;
pub type LPSERVICE_MAIN_FUNCTIONA = ::std::option::Option<
    unsafe extern "C" fn(dwNumServicesArgs: DWORD, lpServiceArgVectors: *mut LPSTR),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_TABLE_ENTRYA {
    pub lpServiceName: LPSTR,
    pub lpServiceProc: LPSERVICE_MAIN_FUNCTIONA,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TABLE_ENTRYA"][::std::mem::size_of::<_SERVICE_TABLE_ENTRYA>() - 16usize];
    ["Alignment of _SERVICE_TABLE_ENTRYA"]
        [::std::mem::align_of::<_SERVICE_TABLE_ENTRYA>() - 8usize];
    ["Offset of field: _SERVICE_TABLE_ENTRYA::lpServiceName"]
        [::std::mem::offset_of!(_SERVICE_TABLE_ENTRYA, lpServiceName) - 0usize];
    ["Offset of field: _SERVICE_TABLE_ENTRYA::lpServiceProc"]
        [::std::mem::offset_of!(_SERVICE_TABLE_ENTRYA, lpServiceProc) - 8usize];
};
pub type SERVICE_TABLE_ENTRYA = _SERVICE_TABLE_ENTRYA;
pub type LPSERVICE_TABLE_ENTRYA = *mut _SERVICE_TABLE_ENTRYA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_TABLE_ENTRYW {
    pub lpServiceName: LPWSTR,
    pub lpServiceProc: LPSERVICE_MAIN_FUNCTIONW,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_TABLE_ENTRYW"][::std::mem::size_of::<_SERVICE_TABLE_ENTRYW>() - 16usize];
    ["Alignment of _SERVICE_TABLE_ENTRYW"]
        [::std::mem::align_of::<_SERVICE_TABLE_ENTRYW>() - 8usize];
    ["Offset of field: _SERVICE_TABLE_ENTRYW::lpServiceName"]
        [::std::mem::offset_of!(_SERVICE_TABLE_ENTRYW, lpServiceName) - 0usize];
    ["Offset of field: _SERVICE_TABLE_ENTRYW::lpServiceProc"]
        [::std::mem::offset_of!(_SERVICE_TABLE_ENTRYW, lpServiceProc) - 8usize];
};
pub type SERVICE_TABLE_ENTRYW = _SERVICE_TABLE_ENTRYW;
pub type LPSERVICE_TABLE_ENTRYW = *mut _SERVICE_TABLE_ENTRYW;
pub type SERVICE_TABLE_ENTRY = SERVICE_TABLE_ENTRYA;
pub type LPSERVICE_TABLE_ENTRY = LPSERVICE_TABLE_ENTRYA;
pub type LPHANDLER_FUNCTION = ::std::option::Option<unsafe extern "C" fn(dwControl: DWORD)>;
pub type LPHANDLER_FUNCTION_EX = ::std::option::Option<
    unsafe extern "C" fn(
        dwControl: DWORD,
        dwEventType: DWORD,
        lpEventData: LPVOID,
        lpContext: LPVOID,
    ) -> DWORD,
>;
pub type PFN_SC_NOTIFY_CALLBACK = ::std::option::Option<unsafe extern "C" fn(pParameter: PVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_NOTIFY_1 {
    pub dwVersion: DWORD,
    pub pfnNotifyCallback: PFN_SC_NOTIFY_CALLBACK,
    pub pContext: PVOID,
    pub dwNotificationStatus: DWORD,
    pub ServiceStatus: SERVICE_STATUS_PROCESS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_NOTIFY_1"][::std::mem::size_of::<_SERVICE_NOTIFY_1>() - 64usize];
    ["Alignment of _SERVICE_NOTIFY_1"][::std::mem::align_of::<_SERVICE_NOTIFY_1>() - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_1::dwVersion"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_1, dwVersion) - 0usize];
    ["Offset of field: _SERVICE_NOTIFY_1::pfnNotifyCallback"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_1, pfnNotifyCallback) - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_1::pContext"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_1, pContext) - 16usize];
    ["Offset of field: _SERVICE_NOTIFY_1::dwNotificationStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_1, dwNotificationStatus) - 24usize];
    ["Offset of field: _SERVICE_NOTIFY_1::ServiceStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_1, ServiceStatus) - 28usize];
};
pub type SERVICE_NOTIFY_1 = _SERVICE_NOTIFY_1;
pub type PSERVICE_NOTIFY_1 = *mut _SERVICE_NOTIFY_1;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_NOTIFY_2A {
    pub dwVersion: DWORD,
    pub pfnNotifyCallback: PFN_SC_NOTIFY_CALLBACK,
    pub pContext: PVOID,
    pub dwNotificationStatus: DWORD,
    pub ServiceStatus: SERVICE_STATUS_PROCESS,
    pub dwNotificationTriggered: DWORD,
    pub pszServiceNames: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_NOTIFY_2A"][::std::mem::size_of::<_SERVICE_NOTIFY_2A>() - 80usize];
    ["Alignment of _SERVICE_NOTIFY_2A"][::std::mem::align_of::<_SERVICE_NOTIFY_2A>() - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::dwVersion"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, dwVersion) - 0usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::pfnNotifyCallback"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, pfnNotifyCallback) - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::pContext"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, pContext) - 16usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::dwNotificationStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, dwNotificationStatus) - 24usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::ServiceStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, ServiceStatus) - 28usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::dwNotificationTriggered"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, dwNotificationTriggered) - 64usize];
    ["Offset of field: _SERVICE_NOTIFY_2A::pszServiceNames"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2A, pszServiceNames) - 72usize];
};
pub type SERVICE_NOTIFY_2A = _SERVICE_NOTIFY_2A;
pub type PSERVICE_NOTIFY_2A = *mut _SERVICE_NOTIFY_2A;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_NOTIFY_2W {
    pub dwVersion: DWORD,
    pub pfnNotifyCallback: PFN_SC_NOTIFY_CALLBACK,
    pub pContext: PVOID,
    pub dwNotificationStatus: DWORD,
    pub ServiceStatus: SERVICE_STATUS_PROCESS,
    pub dwNotificationTriggered: DWORD,
    pub pszServiceNames: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_NOTIFY_2W"][::std::mem::size_of::<_SERVICE_NOTIFY_2W>() - 80usize];
    ["Alignment of _SERVICE_NOTIFY_2W"][::std::mem::align_of::<_SERVICE_NOTIFY_2W>() - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::dwVersion"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, dwVersion) - 0usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::pfnNotifyCallback"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, pfnNotifyCallback) - 8usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::pContext"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, pContext) - 16usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::dwNotificationStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, dwNotificationStatus) - 24usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::ServiceStatus"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, ServiceStatus) - 28usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::dwNotificationTriggered"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, dwNotificationTriggered) - 64usize];
    ["Offset of field: _SERVICE_NOTIFY_2W::pszServiceNames"]
        [::std::mem::offset_of!(_SERVICE_NOTIFY_2W, pszServiceNames) - 72usize];
};
pub type SERVICE_NOTIFY_2W = _SERVICE_NOTIFY_2W;
pub type PSERVICE_NOTIFY_2W = *mut _SERVICE_NOTIFY_2W;
pub type SERVICE_NOTIFY_2 = SERVICE_NOTIFY_2A;
pub type PSERVICE_NOTIFY_2 = PSERVICE_NOTIFY_2A;
pub type SERVICE_NOTIFYA = SERVICE_NOTIFY_2A;
pub type PSERVICE_NOTIFYA = *mut SERVICE_NOTIFY_2A;
pub type SERVICE_NOTIFYW = SERVICE_NOTIFY_2W;
pub type PSERVICE_NOTIFYW = *mut SERVICE_NOTIFY_2W;
pub type SERVICE_NOTIFY = SERVICE_NOTIFYA;
pub type PSERVICE_NOTIFY = PSERVICE_NOTIFYA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_CONTROL_STATUS_REASON_PARAMSA {
    pub dwReason: DWORD,
    pub pszComment: LPSTR,
    pub ServiceStatus: SERVICE_STATUS_PROCESS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_CONTROL_STATUS_REASON_PARAMSA"]
        [::std::mem::size_of::<_SERVICE_CONTROL_STATUS_REASON_PARAMSA>() - 56usize];
    ["Alignment of _SERVICE_CONTROL_STATUS_REASON_PARAMSA"]
        [::std::mem::align_of::<_SERVICE_CONTROL_STATUS_REASON_PARAMSA>() - 8usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSA::dwReason"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSA, dwReason) - 0usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSA::pszComment"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSA, pszComment) - 8usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSA::ServiceStatus"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSA, ServiceStatus) - 16usize];
};
pub type SERVICE_CONTROL_STATUS_REASON_PARAMSA = _SERVICE_CONTROL_STATUS_REASON_PARAMSA;
pub type PSERVICE_CONTROL_STATUS_REASON_PARAMSA = *mut _SERVICE_CONTROL_STATUS_REASON_PARAMSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_CONTROL_STATUS_REASON_PARAMSW {
    pub dwReason: DWORD,
    pub pszComment: LPWSTR,
    pub ServiceStatus: SERVICE_STATUS_PROCESS,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_CONTROL_STATUS_REASON_PARAMSW"]
        [::std::mem::size_of::<_SERVICE_CONTROL_STATUS_REASON_PARAMSW>() - 56usize];
    ["Alignment of _SERVICE_CONTROL_STATUS_REASON_PARAMSW"]
        [::std::mem::align_of::<_SERVICE_CONTROL_STATUS_REASON_PARAMSW>() - 8usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSW::dwReason"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSW, dwReason) - 0usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSW::pszComment"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSW, pszComment) - 8usize];
    ["Offset of field: _SERVICE_CONTROL_STATUS_REASON_PARAMSW::ServiceStatus"]
        [::std::mem::offset_of!(_SERVICE_CONTROL_STATUS_REASON_PARAMSW, ServiceStatus) - 16usize];
};
pub type SERVICE_CONTROL_STATUS_REASON_PARAMSW = _SERVICE_CONTROL_STATUS_REASON_PARAMSW;
pub type PSERVICE_CONTROL_STATUS_REASON_PARAMSW = *mut _SERVICE_CONTROL_STATUS_REASON_PARAMSW;
pub type SERVICE_CONTROL_STATUS_REASON_PARAMS = SERVICE_CONTROL_STATUS_REASON_PARAMSA;
pub type PSERVICE_CONTROL_STATUS_REASON_PARAMS = PSERVICE_CONTROL_STATUS_REASON_PARAMSA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SERVICE_START_REASON {
    pub dwReason: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _SERVICE_START_REASON"][::std::mem::size_of::<_SERVICE_START_REASON>() - 4usize];
    ["Alignment of _SERVICE_START_REASON"]
        [::std::mem::align_of::<_SERVICE_START_REASON>() - 4usize];
    ["Offset of field: _SERVICE_START_REASON::dwReason"]
        [::std::mem::offset_of!(_SERVICE_START_REASON, dwReason) - 0usize];
};
pub type SERVICE_START_REASON = _SERVICE_START_REASON;
pub type PSERVICE_START_REASON = *mut _SERVICE_START_REASON;
unsafe extern "C" {
    pub fn ChangeServiceConfigA(
        hService: SC_HANDLE,
        dwServiceType: DWORD,
        dwStartType: DWORD,
        dwErrorControl: DWORD,
        lpBinaryPathName: LPCSTR,
        lpLoadOrderGroup: LPCSTR,
        lpdwTagId: LPDWORD,
        lpDependencies: LPCSTR,
        lpServiceStartName: LPCSTR,
        lpPassword: LPCSTR,
        lpDisplayName: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeServiceConfigW(
        hService: SC_HANDLE,
        dwServiceType: DWORD,
        dwStartType: DWORD,
        dwErrorControl: DWORD,
        lpBinaryPathName: LPCWSTR,
        lpLoadOrderGroup: LPCWSTR,
        lpdwTagId: LPDWORD,
        lpDependencies: LPCWSTR,
        lpServiceStartName: LPCWSTR,
        lpPassword: LPCWSTR,
        lpDisplayName: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeServiceConfig2A(hService: SC_HANDLE, dwInfoLevel: DWORD, lpInfo: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn ChangeServiceConfig2W(hService: SC_HANDLE, dwInfoLevel: DWORD, lpInfo: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn CloseServiceHandle(hSCObject: SC_HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn ControlService(
        hService: SC_HANDLE,
        dwControl: DWORD,
        lpServiceStatus: LPSERVICE_STATUS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn CreateServiceA(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCSTR,
        lpDisplayName: LPCSTR,
        dwDesiredAccess: DWORD,
        dwServiceType: DWORD,
        dwStartType: DWORD,
        dwErrorControl: DWORD,
        lpBinaryPathName: LPCSTR,
        lpLoadOrderGroup: LPCSTR,
        lpdwTagId: LPDWORD,
        lpDependencies: LPCSTR,
        lpServiceStartName: LPCSTR,
        lpPassword: LPCSTR,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn CreateServiceW(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCWSTR,
        lpDisplayName: LPCWSTR,
        dwDesiredAccess: DWORD,
        dwServiceType: DWORD,
        dwStartType: DWORD,
        dwErrorControl: DWORD,
        lpBinaryPathName: LPCWSTR,
        lpLoadOrderGroup: LPCWSTR,
        lpdwTagId: LPDWORD,
        lpDependencies: LPCWSTR,
        lpServiceStartName: LPCWSTR,
        lpPassword: LPCWSTR,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn DeleteService(hService: SC_HANDLE) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDependentServicesA(
        hService: SC_HANDLE,
        dwServiceState: DWORD,
        lpServices: LPENUM_SERVICE_STATUSA,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumDependentServicesW(
        hService: SC_HANDLE,
        dwServiceState: DWORD,
        lpServices: LPENUM_SERVICE_STATUSW,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumServicesStatusA(
        hSCManager: SC_HANDLE,
        dwServiceType: DWORD,
        dwServiceState: DWORD,
        lpServices: LPENUM_SERVICE_STATUSA,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
        lpResumeHandle: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumServicesStatusW(
        hSCManager: SC_HANDLE,
        dwServiceType: DWORD,
        dwServiceState: DWORD,
        lpServices: LPENUM_SERVICE_STATUSW,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
        lpResumeHandle: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumServicesStatusExA(
        hSCManager: SC_HANDLE,
        InfoLevel: SC_ENUM_TYPE,
        dwServiceType: DWORD,
        dwServiceState: DWORD,
        lpServices: LPBYTE,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
        lpResumeHandle: LPDWORD,
        pszGroupName: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn EnumServicesStatusExW(
        hSCManager: SC_HANDLE,
        InfoLevel: SC_ENUM_TYPE,
        dwServiceType: DWORD,
        dwServiceState: DWORD,
        lpServices: LPBYTE,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
        lpServicesReturned: LPDWORD,
        lpResumeHandle: LPDWORD,
        pszGroupName: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetServiceKeyNameA(
        hSCManager: SC_HANDLE,
        lpDisplayName: LPCSTR,
        lpServiceName: LPSTR,
        lpcchBuffer: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetServiceKeyNameW(
        hSCManager: SC_HANDLE,
        lpDisplayName: LPCWSTR,
        lpServiceName: LPWSTR,
        lpcchBuffer: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetServiceDisplayNameA(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCSTR,
        lpDisplayName: LPSTR,
        lpcchBuffer: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn GetServiceDisplayNameW(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCWSTR,
        lpDisplayName: LPWSTR,
        lpcchBuffer: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LockServiceDatabase(hSCManager: SC_HANDLE) -> SC_LOCK;
}
unsafe extern "C" {
    pub fn NotifyBootConfigStatus(BootAcceptable: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn OpenSCManagerA(
        lpMachineName: LPCSTR,
        lpDatabaseName: LPCSTR,
        dwDesiredAccess: DWORD,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn OpenSCManagerW(
        lpMachineName: LPCWSTR,
        lpDatabaseName: LPCWSTR,
        dwDesiredAccess: DWORD,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn OpenServiceA(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCSTR,
        dwDesiredAccess: DWORD,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn OpenServiceW(
        hSCManager: SC_HANDLE,
        lpServiceName: LPCWSTR,
        dwDesiredAccess: DWORD,
    ) -> SC_HANDLE;
}
unsafe extern "C" {
    pub fn QueryServiceConfigA(
        hService: SC_HANDLE,
        lpServiceConfig: LPQUERY_SERVICE_CONFIGA,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceConfigW(
        hService: SC_HANDLE,
        lpServiceConfig: LPQUERY_SERVICE_CONFIGW,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceConfig2A(
        hService: SC_HANDLE,
        dwInfoLevel: DWORD,
        lpBuffer: LPBYTE,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceConfig2W(
        hService: SC_HANDLE,
        dwInfoLevel: DWORD,
        lpBuffer: LPBYTE,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceLockStatusA(
        hSCManager: SC_HANDLE,
        lpLockStatus: LPQUERY_SERVICE_LOCK_STATUSA,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceLockStatusW(
        hSCManager: SC_HANDLE,
        lpLockStatus: LPQUERY_SERVICE_LOCK_STATUSW,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceObjectSecurity(
        hService: SC_HANDLE,
        dwSecurityInformation: SECURITY_INFORMATION,
        lpSecurityDescriptor: PSECURITY_DESCRIPTOR,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceStatus(hService: SC_HANDLE, lpServiceStatus: LPSERVICE_STATUS) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceStatusEx(
        hService: SC_HANDLE,
        InfoLevel: SC_STATUS_TYPE,
        lpBuffer: LPBYTE,
        cbBufSize: DWORD,
        pcbBytesNeeded: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn RegisterServiceCtrlHandlerA(
        lpServiceName: LPCSTR,
        lpHandlerProc: LPHANDLER_FUNCTION,
    ) -> SERVICE_STATUS_HANDLE;
}
unsafe extern "C" {
    pub fn RegisterServiceCtrlHandlerW(
        lpServiceName: LPCWSTR,
        lpHandlerProc: LPHANDLER_FUNCTION,
    ) -> SERVICE_STATUS_HANDLE;
}
unsafe extern "C" {
    pub fn RegisterServiceCtrlHandlerExA(
        lpServiceName: LPCSTR,
        lpHandlerProc: LPHANDLER_FUNCTION_EX,
        lpContext: LPVOID,
    ) -> SERVICE_STATUS_HANDLE;
}
unsafe extern "C" {
    pub fn RegisterServiceCtrlHandlerExW(
        lpServiceName: LPCWSTR,
        lpHandlerProc: LPHANDLER_FUNCTION_EX,
        lpContext: LPVOID,
    ) -> SERVICE_STATUS_HANDLE;
}
unsafe extern "C" {
    pub fn SetServiceObjectSecurity(
        hService: SC_HANDLE,
        dwSecurityInformation: SECURITY_INFORMATION,
        lpSecurityDescriptor: PSECURITY_DESCRIPTOR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn SetServiceStatus(
        hServiceStatus: SERVICE_STATUS_HANDLE,
        lpServiceStatus: LPSERVICE_STATUS,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn StartServiceCtrlDispatcherA(lpServiceStartTable: *const SERVICE_TABLE_ENTRYA) -> BOOL;
}
unsafe extern "C" {
    pub fn StartServiceCtrlDispatcherW(lpServiceStartTable: *const SERVICE_TABLE_ENTRYW) -> BOOL;
}
unsafe extern "C" {
    pub fn StartServiceA(
        hService: SC_HANDLE,
        dwNumServiceArgs: DWORD,
        lpServiceArgVectors: *mut LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn StartServiceW(
        hService: SC_HANDLE,
        dwNumServiceArgs: DWORD,
        lpServiceArgVectors: *mut LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn UnlockServiceDatabase(ScLock: SC_LOCK) -> BOOL;
}
unsafe extern "C" {
    pub fn NotifyServiceStatusChangeA(
        hService: SC_HANDLE,
        dwNotifyMask: DWORD,
        pNotifyBuffer: PSERVICE_NOTIFYA,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn NotifyServiceStatusChangeW(
        hService: SC_HANDLE,
        dwNotifyMask: DWORD,
        pNotifyBuffer: PSERVICE_NOTIFYW,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ControlServiceExA(
        hService: SC_HANDLE,
        dwControl: DWORD,
        dwInfoLevel: DWORD,
        pControlParams: PVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ControlServiceExW(
        hService: SC_HANDLE,
        dwControl: DWORD,
        dwInfoLevel: DWORD,
        pControlParams: PVOID,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn QueryServiceDynamicInformation(
        hServiceStatus: SERVICE_STATUS_HANDLE,
        dwInfoLevel: DWORD,
        ppDynamicInfo: *mut PVOID,
    ) -> BOOL;
}
pub const _SC_EVENT_TYPE_SC_EVENT_DATABASE_CHANGE: _SC_EVENT_TYPE = 0;
pub const _SC_EVENT_TYPE_SC_EVENT_PROPERTY_CHANGE: _SC_EVENT_TYPE = 1;
pub const _SC_EVENT_TYPE_SC_EVENT_STATUS_CHANGE: _SC_EVENT_TYPE = 2;
pub type _SC_EVENT_TYPE = ::std::os::raw::c_int;
pub use self::_SC_EVENT_TYPE as SC_EVENT_TYPE;
pub type PSC_EVENT_TYPE = *mut _SC_EVENT_TYPE;
pub type PSC_NOTIFICATION_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(arg1: DWORD, arg2: PVOID)>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _SC_NOTIFICATION_REGISTRATION {
    _unused: [u8; 0],
}
pub type PSC_NOTIFICATION_REGISTRATION = *mut _SC_NOTIFICATION_REGISTRATION;
unsafe extern "C" {
    pub fn SubscribeServiceChangeNotifications(
        hService: SC_HANDLE,
        eEventType: SC_EVENT_TYPE,
        pCallback: PSC_NOTIFICATION_CALLBACK,
        pCallbackContext: PVOID,
        pSubscription: *mut PSC_NOTIFICATION_REGISTRATION,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn UnsubscribeServiceChangeNotifications(pSubscription: PSC_NOTIFICATION_REGISTRATION);
}
unsafe extern "C" {
    pub fn WaitServiceState(
        hService: SC_HANDLE,
        dwNotify: DWORD,
        dwTimeout: DWORD,
        hCancelEvent: HANDLE,
    ) -> DWORD;
}
pub const SERVICE_REGISTRY_STATE_TYPE_ServiceRegistryStateParameters: SERVICE_REGISTRY_STATE_TYPE =
    0;
pub const SERVICE_REGISTRY_STATE_TYPE_ServiceRegistryStatePersistent: SERVICE_REGISTRY_STATE_TYPE =
    1;
pub const SERVICE_REGISTRY_STATE_TYPE_MaxServiceRegistryStateType: SERVICE_REGISTRY_STATE_TYPE = 2;
pub type SERVICE_REGISTRY_STATE_TYPE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn GetServiceRegistryStateKey(
        ServiceStatusHandle: SERVICE_STATUS_HANDLE,
        StateType: SERVICE_REGISTRY_STATE_TYPE,
        AccessMask: DWORD,
        ServiceStateKey: *mut HKEY,
    ) -> DWORD;
}
pub const SERVICE_DIRECTORY_TYPE_ServiceDirectoryPersistentState: SERVICE_DIRECTORY_TYPE = 0;
pub const SERVICE_DIRECTORY_TYPE_ServiceDirectoryTypeMax: SERVICE_DIRECTORY_TYPE = 1;
pub type SERVICE_DIRECTORY_TYPE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn GetServiceDirectory(
        hServiceStatus: SERVICE_STATUS_HANDLE,
        eDirectoryType: SERVICE_DIRECTORY_TYPE,
        lpPathBuffer: PWCHAR,
        cchPathBufferLength: DWORD,
        lpcchRequiredBufferLength: *mut DWORD,
    ) -> DWORD;
}
pub const SERVICE_SHARED_REGISTRY_STATE_TYPE_ServiceSharedRegistryPersistentState:
    SERVICE_SHARED_REGISTRY_STATE_TYPE = 0;
pub type SERVICE_SHARED_REGISTRY_STATE_TYPE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn GetSharedServiceRegistryStateKey(
        ServiceHandle: SC_HANDLE,
        StateType: SERVICE_SHARED_REGISTRY_STATE_TYPE,
        AccessMask: DWORD,
        ServiceStateKey: *mut HKEY,
    ) -> DWORD;
}
pub const SERVICE_SHARED_DIRECTORY_TYPE_ServiceSharedDirectoryPersistentState:
    SERVICE_SHARED_DIRECTORY_TYPE = 0;
pub type SERVICE_SHARED_DIRECTORY_TYPE = ::std::os::raw::c_int;
unsafe extern "C" {
    pub fn GetSharedServiceDirectory(
        ServiceHandle: SC_HANDLE,
        DirectoryType: SERVICE_SHARED_DIRECTORY_TYPE,
        PathBuffer: PWCHAR,
        PathBufferLength: DWORD,
        RequiredBufferLength: *mut DWORD,
    ) -> DWORD;
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MODEMDEVCAPS {
    pub dwActualSize: DWORD,
    pub dwRequiredSize: DWORD,
    pub dwDevSpecificOffset: DWORD,
    pub dwDevSpecificSize: DWORD,
    pub dwModemProviderVersion: DWORD,
    pub dwModemManufacturerOffset: DWORD,
    pub dwModemManufacturerSize: DWORD,
    pub dwModemModelOffset: DWORD,
    pub dwModemModelSize: DWORD,
    pub dwModemVersionOffset: DWORD,
    pub dwModemVersionSize: DWORD,
    pub dwDialOptions: DWORD,
    pub dwCallSetupFailTimer: DWORD,
    pub dwInactivityTimeout: DWORD,
    pub dwSpeakerVolume: DWORD,
    pub dwSpeakerMode: DWORD,
    pub dwModemOptions: DWORD,
    pub dwMaxDTERate: DWORD,
    pub dwMaxDCERate: DWORD,
    pub abVariablePortion: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MODEMDEVCAPS"][::std::mem::size_of::<_MODEMDEVCAPS>() - 80usize];
    ["Alignment of _MODEMDEVCAPS"][::std::mem::align_of::<_MODEMDEVCAPS>() - 4usize];
    ["Offset of field: _MODEMDEVCAPS::dwActualSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwActualSize) - 0usize];
    ["Offset of field: _MODEMDEVCAPS::dwRequiredSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwRequiredSize) - 4usize];
    ["Offset of field: _MODEMDEVCAPS::dwDevSpecificOffset"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwDevSpecificOffset) - 8usize];
    ["Offset of field: _MODEMDEVCAPS::dwDevSpecificSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwDevSpecificSize) - 12usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemProviderVersion"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemProviderVersion) - 16usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemManufacturerOffset"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemManufacturerOffset) - 20usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemManufacturerSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemManufacturerSize) - 24usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemModelOffset"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemModelOffset) - 28usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemModelSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemModelSize) - 32usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemVersionOffset"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemVersionOffset) - 36usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemVersionSize"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemVersionSize) - 40usize];
    ["Offset of field: _MODEMDEVCAPS::dwDialOptions"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwDialOptions) - 44usize];
    ["Offset of field: _MODEMDEVCAPS::dwCallSetupFailTimer"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwCallSetupFailTimer) - 48usize];
    ["Offset of field: _MODEMDEVCAPS::dwInactivityTimeout"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwInactivityTimeout) - 52usize];
    ["Offset of field: _MODEMDEVCAPS::dwSpeakerVolume"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwSpeakerVolume) - 56usize];
    ["Offset of field: _MODEMDEVCAPS::dwSpeakerMode"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwSpeakerMode) - 60usize];
    ["Offset of field: _MODEMDEVCAPS::dwModemOptions"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwModemOptions) - 64usize];
    ["Offset of field: _MODEMDEVCAPS::dwMaxDTERate"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwMaxDTERate) - 68usize];
    ["Offset of field: _MODEMDEVCAPS::dwMaxDCERate"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, dwMaxDCERate) - 72usize];
    ["Offset of field: _MODEMDEVCAPS::abVariablePortion"]
        [::std::mem::offset_of!(_MODEMDEVCAPS, abVariablePortion) - 76usize];
};
pub type MODEMDEVCAPS = _MODEMDEVCAPS;
pub type PMODEMDEVCAPS = *mut _MODEMDEVCAPS;
pub type LPMODEMDEVCAPS = *mut _MODEMDEVCAPS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _MODEMSETTINGS {
    pub dwActualSize: DWORD,
    pub dwRequiredSize: DWORD,
    pub dwDevSpecificOffset: DWORD,
    pub dwDevSpecificSize: DWORD,
    pub dwCallSetupFailTimer: DWORD,
    pub dwInactivityTimeout: DWORD,
    pub dwSpeakerVolume: DWORD,
    pub dwSpeakerMode: DWORD,
    pub dwPreferredModemOptions: DWORD,
    pub dwNegotiatedModemOptions: DWORD,
    pub dwNegotiatedDCERate: DWORD,
    pub abVariablePortion: [BYTE; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of _MODEMSETTINGS"][::std::mem::size_of::<_MODEMSETTINGS>() - 48usize];
    ["Alignment of _MODEMSETTINGS"][::std::mem::align_of::<_MODEMSETTINGS>() - 4usize];
    ["Offset of field: _MODEMSETTINGS::dwActualSize"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwActualSize) - 0usize];
    ["Offset of field: _MODEMSETTINGS::dwRequiredSize"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwRequiredSize) - 4usize];
    ["Offset of field: _MODEMSETTINGS::dwDevSpecificOffset"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwDevSpecificOffset) - 8usize];
    ["Offset of field: _MODEMSETTINGS::dwDevSpecificSize"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwDevSpecificSize) - 12usize];
    ["Offset of field: _MODEMSETTINGS::dwCallSetupFailTimer"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwCallSetupFailTimer) - 16usize];
    ["Offset of field: _MODEMSETTINGS::dwInactivityTimeout"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwInactivityTimeout) - 20usize];
    ["Offset of field: _MODEMSETTINGS::dwSpeakerVolume"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwSpeakerVolume) - 24usize];
    ["Offset of field: _MODEMSETTINGS::dwSpeakerMode"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwSpeakerMode) - 28usize];
    ["Offset of field: _MODEMSETTINGS::dwPreferredModemOptions"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwPreferredModemOptions) - 32usize];
    ["Offset of field: _MODEMSETTINGS::dwNegotiatedModemOptions"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwNegotiatedModemOptions) - 36usize];
    ["Offset of field: _MODEMSETTINGS::dwNegotiatedDCERate"]
        [::std::mem::offset_of!(_MODEMSETTINGS, dwNegotiatedDCERate) - 40usize];
    ["Offset of field: _MODEMSETTINGS::abVariablePortion"]
        [::std::mem::offset_of!(_MODEMSETTINGS, abVariablePortion) - 44usize];
};
pub type MODEMSETTINGS = _MODEMSETTINGS;
pub type PMODEMSETTINGS = *mut _MODEMSETTINGS;
pub type LPMODEMSETTINGS = *mut _MODEMSETTINGS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HIMC__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HIMC__"][::std::mem::size_of::<HIMC__>() - 4usize];
    ["Alignment of HIMC__"][::std::mem::align_of::<HIMC__>() - 4usize];
    ["Offset of field: HIMC__::unused"][::std::mem::offset_of!(HIMC__, unused) - 0usize];
};
pub type HIMC = *mut HIMC__;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct HIMCC__ {
    pub unused: ::std::os::raw::c_int,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of HIMCC__"][::std::mem::size_of::<HIMCC__>() - 4usize];
    ["Alignment of HIMCC__"][::std::mem::align_of::<HIMCC__>() - 4usize];
    ["Offset of field: HIMCC__::unused"][::std::mem::offset_of!(HIMCC__, unused) - 0usize];
};
pub type HIMCC = *mut HIMCC__;
pub type LPHKL = *mut HKL;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCOMPOSITIONFORM {
    pub dwStyle: DWORD,
    pub ptCurrentPos: POINT,
    pub rcArea: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCOMPOSITIONFORM"][::std::mem::size_of::<tagCOMPOSITIONFORM>() - 28usize];
    ["Alignment of tagCOMPOSITIONFORM"][::std::mem::align_of::<tagCOMPOSITIONFORM>() - 4usize];
    ["Offset of field: tagCOMPOSITIONFORM::dwStyle"]
        [::std::mem::offset_of!(tagCOMPOSITIONFORM, dwStyle) - 0usize];
    ["Offset of field: tagCOMPOSITIONFORM::ptCurrentPos"]
        [::std::mem::offset_of!(tagCOMPOSITIONFORM, ptCurrentPos) - 4usize];
    ["Offset of field: tagCOMPOSITIONFORM::rcArea"]
        [::std::mem::offset_of!(tagCOMPOSITIONFORM, rcArea) - 12usize];
};
pub type COMPOSITIONFORM = tagCOMPOSITIONFORM;
pub type PCOMPOSITIONFORM = *mut tagCOMPOSITIONFORM;
pub type NPCOMPOSITIONFORM = *mut tagCOMPOSITIONFORM;
pub type LPCOMPOSITIONFORM = *mut tagCOMPOSITIONFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCANDIDATEFORM {
    pub dwIndex: DWORD,
    pub dwStyle: DWORD,
    pub ptCurrentPos: POINT,
    pub rcArea: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCANDIDATEFORM"][::std::mem::size_of::<tagCANDIDATEFORM>() - 32usize];
    ["Alignment of tagCANDIDATEFORM"][::std::mem::align_of::<tagCANDIDATEFORM>() - 4usize];
    ["Offset of field: tagCANDIDATEFORM::dwIndex"]
        [::std::mem::offset_of!(tagCANDIDATEFORM, dwIndex) - 0usize];
    ["Offset of field: tagCANDIDATEFORM::dwStyle"]
        [::std::mem::offset_of!(tagCANDIDATEFORM, dwStyle) - 4usize];
    ["Offset of field: tagCANDIDATEFORM::ptCurrentPos"]
        [::std::mem::offset_of!(tagCANDIDATEFORM, ptCurrentPos) - 8usize];
    ["Offset of field: tagCANDIDATEFORM::rcArea"]
        [::std::mem::offset_of!(tagCANDIDATEFORM, rcArea) - 16usize];
};
pub type CANDIDATEFORM = tagCANDIDATEFORM;
pub type PCANDIDATEFORM = *mut tagCANDIDATEFORM;
pub type NPCANDIDATEFORM = *mut tagCANDIDATEFORM;
pub type LPCANDIDATEFORM = *mut tagCANDIDATEFORM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagCANDIDATELIST {
    pub dwSize: DWORD,
    pub dwStyle: DWORD,
    pub dwCount: DWORD,
    pub dwSelection: DWORD,
    pub dwPageStart: DWORD,
    pub dwPageSize: DWORD,
    pub dwOffset: [DWORD; 1usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagCANDIDATELIST"][::std::mem::size_of::<tagCANDIDATELIST>() - 28usize];
    ["Alignment of tagCANDIDATELIST"][::std::mem::align_of::<tagCANDIDATELIST>() - 4usize];
    ["Offset of field: tagCANDIDATELIST::dwSize"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwSize) - 0usize];
    ["Offset of field: tagCANDIDATELIST::dwStyle"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwStyle) - 4usize];
    ["Offset of field: tagCANDIDATELIST::dwCount"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwCount) - 8usize];
    ["Offset of field: tagCANDIDATELIST::dwSelection"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwSelection) - 12usize];
    ["Offset of field: tagCANDIDATELIST::dwPageStart"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwPageStart) - 16usize];
    ["Offset of field: tagCANDIDATELIST::dwPageSize"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwPageSize) - 20usize];
    ["Offset of field: tagCANDIDATELIST::dwOffset"]
        [::std::mem::offset_of!(tagCANDIDATELIST, dwOffset) - 24usize];
};
pub type CANDIDATELIST = tagCANDIDATELIST;
pub type PCANDIDATELIST = *mut tagCANDIDATELIST;
pub type NPCANDIDATELIST = *mut tagCANDIDATELIST;
pub type LPCANDIDATELIST = *mut tagCANDIDATELIST;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagREGISTERWORDA {
    pub lpReading: LPSTR,
    pub lpWord: LPSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagREGISTERWORDA"][::std::mem::size_of::<tagREGISTERWORDA>() - 16usize];
    ["Alignment of tagREGISTERWORDA"][::std::mem::align_of::<tagREGISTERWORDA>() - 8usize];
    ["Offset of field: tagREGISTERWORDA::lpReading"]
        [::std::mem::offset_of!(tagREGISTERWORDA, lpReading) - 0usize];
    ["Offset of field: tagREGISTERWORDA::lpWord"]
        [::std::mem::offset_of!(tagREGISTERWORDA, lpWord) - 8usize];
};
pub type REGISTERWORDA = tagREGISTERWORDA;
pub type PREGISTERWORDA = *mut tagREGISTERWORDA;
pub type NPREGISTERWORDA = *mut tagREGISTERWORDA;
pub type LPREGISTERWORDA = *mut tagREGISTERWORDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagREGISTERWORDW {
    pub lpReading: LPWSTR,
    pub lpWord: LPWSTR,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagREGISTERWORDW"][::std::mem::size_of::<tagREGISTERWORDW>() - 16usize];
    ["Alignment of tagREGISTERWORDW"][::std::mem::align_of::<tagREGISTERWORDW>() - 8usize];
    ["Offset of field: tagREGISTERWORDW::lpReading"]
        [::std::mem::offset_of!(tagREGISTERWORDW, lpReading) - 0usize];
    ["Offset of field: tagREGISTERWORDW::lpWord"]
        [::std::mem::offset_of!(tagREGISTERWORDW, lpWord) - 8usize];
};
pub type REGISTERWORDW = tagREGISTERWORDW;
pub type PREGISTERWORDW = *mut tagREGISTERWORDW;
pub type NPREGISTERWORDW = *mut tagREGISTERWORDW;
pub type LPREGISTERWORDW = *mut tagREGISTERWORDW;
pub type REGISTERWORD = REGISTERWORDA;
pub type PREGISTERWORD = PREGISTERWORDA;
pub type NPREGISTERWORD = NPREGISTERWORDA;
pub type LPREGISTERWORD = LPREGISTERWORDA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagRECONVERTSTRING {
    pub dwSize: DWORD,
    pub dwVersion: DWORD,
    pub dwStrLen: DWORD,
    pub dwStrOffset: DWORD,
    pub dwCompStrLen: DWORD,
    pub dwCompStrOffset: DWORD,
    pub dwTargetStrLen: DWORD,
    pub dwTargetStrOffset: DWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagRECONVERTSTRING"][::std::mem::size_of::<tagRECONVERTSTRING>() - 32usize];
    ["Alignment of tagRECONVERTSTRING"][::std::mem::align_of::<tagRECONVERTSTRING>() - 4usize];
    ["Offset of field: tagRECONVERTSTRING::dwSize"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwSize) - 0usize];
    ["Offset of field: tagRECONVERTSTRING::dwVersion"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwVersion) - 4usize];
    ["Offset of field: tagRECONVERTSTRING::dwStrLen"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwStrLen) - 8usize];
    ["Offset of field: tagRECONVERTSTRING::dwStrOffset"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwStrOffset) - 12usize];
    ["Offset of field: tagRECONVERTSTRING::dwCompStrLen"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwCompStrLen) - 16usize];
    ["Offset of field: tagRECONVERTSTRING::dwCompStrOffset"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwCompStrOffset) - 20usize];
    ["Offset of field: tagRECONVERTSTRING::dwTargetStrLen"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwTargetStrLen) - 24usize];
    ["Offset of field: tagRECONVERTSTRING::dwTargetStrOffset"]
        [::std::mem::offset_of!(tagRECONVERTSTRING, dwTargetStrOffset) - 28usize];
};
pub type RECONVERTSTRING = tagRECONVERTSTRING;
pub type PRECONVERTSTRING = *mut tagRECONVERTSTRING;
pub type NPRECONVERTSTRING = *mut tagRECONVERTSTRING;
pub type LPRECONVERTSTRING = *mut tagRECONVERTSTRING;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTYLEBUFA {
    pub dwStyle: DWORD,
    pub szDescription: [CHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTYLEBUFA"][::std::mem::size_of::<tagSTYLEBUFA>() - 36usize];
    ["Alignment of tagSTYLEBUFA"][::std::mem::align_of::<tagSTYLEBUFA>() - 4usize];
    ["Offset of field: tagSTYLEBUFA::dwStyle"]
        [::std::mem::offset_of!(tagSTYLEBUFA, dwStyle) - 0usize];
    ["Offset of field: tagSTYLEBUFA::szDescription"]
        [::std::mem::offset_of!(tagSTYLEBUFA, szDescription) - 4usize];
};
pub type STYLEBUFA = tagSTYLEBUFA;
pub type PSTYLEBUFA = *mut tagSTYLEBUFA;
pub type NPSTYLEBUFA = *mut tagSTYLEBUFA;
pub type LPSTYLEBUFA = *mut tagSTYLEBUFA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagSTYLEBUFW {
    pub dwStyle: DWORD,
    pub szDescription: [WCHAR; 32usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagSTYLEBUFW"][::std::mem::size_of::<tagSTYLEBUFW>() - 68usize];
    ["Alignment of tagSTYLEBUFW"][::std::mem::align_of::<tagSTYLEBUFW>() - 4usize];
    ["Offset of field: tagSTYLEBUFW::dwStyle"]
        [::std::mem::offset_of!(tagSTYLEBUFW, dwStyle) - 0usize];
    ["Offset of field: tagSTYLEBUFW::szDescription"]
        [::std::mem::offset_of!(tagSTYLEBUFW, szDescription) - 4usize];
};
pub type STYLEBUFW = tagSTYLEBUFW;
pub type PSTYLEBUFW = *mut tagSTYLEBUFW;
pub type NPSTYLEBUFW = *mut tagSTYLEBUFW;
pub type LPSTYLEBUFW = *mut tagSTYLEBUFW;
pub type STYLEBUF = STYLEBUFA;
pub type PSTYLEBUF = PSTYLEBUFA;
pub type NPSTYLEBUF = NPSTYLEBUFA;
pub type LPSTYLEBUF = LPSTYLEBUFA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagIMEMENUITEMINFOA {
    pub cbSize: UINT,
    pub fType: UINT,
    pub fState: UINT,
    pub wID: UINT,
    pub hbmpChecked: HBITMAP,
    pub hbmpUnchecked: HBITMAP,
    pub dwItemData: DWORD,
    pub szString: [CHAR; 80usize],
    pub hbmpItem: HBITMAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagIMEMENUITEMINFOA"][::std::mem::size_of::<tagIMEMENUITEMINFOA>() - 128usize];
    ["Alignment of tagIMEMENUITEMINFOA"][::std::mem::align_of::<tagIMEMENUITEMINFOA>() - 8usize];
    ["Offset of field: tagIMEMENUITEMINFOA::cbSize"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, cbSize) - 0usize];
    ["Offset of field: tagIMEMENUITEMINFOA::fType"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, fType) - 4usize];
    ["Offset of field: tagIMEMENUITEMINFOA::fState"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, fState) - 8usize];
    ["Offset of field: tagIMEMENUITEMINFOA::wID"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, wID) - 12usize];
    ["Offset of field: tagIMEMENUITEMINFOA::hbmpChecked"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, hbmpChecked) - 16usize];
    ["Offset of field: tagIMEMENUITEMINFOA::hbmpUnchecked"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, hbmpUnchecked) - 24usize];
    ["Offset of field: tagIMEMENUITEMINFOA::dwItemData"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, dwItemData) - 32usize];
    ["Offset of field: tagIMEMENUITEMINFOA::szString"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, szString) - 36usize];
    ["Offset of field: tagIMEMENUITEMINFOA::hbmpItem"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOA, hbmpItem) - 120usize];
};
pub type IMEMENUITEMINFOA = tagIMEMENUITEMINFOA;
pub type PIMEMENUITEMINFOA = *mut tagIMEMENUITEMINFOA;
pub type NPIMEMENUITEMINFOA = *mut tagIMEMENUITEMINFOA;
pub type LPIMEMENUITEMINFOA = *mut tagIMEMENUITEMINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagIMEMENUITEMINFOW {
    pub cbSize: UINT,
    pub fType: UINT,
    pub fState: UINT,
    pub wID: UINT,
    pub hbmpChecked: HBITMAP,
    pub hbmpUnchecked: HBITMAP,
    pub dwItemData: DWORD,
    pub szString: [WCHAR; 80usize],
    pub hbmpItem: HBITMAP,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagIMEMENUITEMINFOW"][::std::mem::size_of::<tagIMEMENUITEMINFOW>() - 208usize];
    ["Alignment of tagIMEMENUITEMINFOW"][::std::mem::align_of::<tagIMEMENUITEMINFOW>() - 8usize];
    ["Offset of field: tagIMEMENUITEMINFOW::cbSize"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, cbSize) - 0usize];
    ["Offset of field: tagIMEMENUITEMINFOW::fType"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, fType) - 4usize];
    ["Offset of field: tagIMEMENUITEMINFOW::fState"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, fState) - 8usize];
    ["Offset of field: tagIMEMENUITEMINFOW::wID"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, wID) - 12usize];
    ["Offset of field: tagIMEMENUITEMINFOW::hbmpChecked"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, hbmpChecked) - 16usize];
    ["Offset of field: tagIMEMENUITEMINFOW::hbmpUnchecked"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, hbmpUnchecked) - 24usize];
    ["Offset of field: tagIMEMENUITEMINFOW::dwItemData"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, dwItemData) - 32usize];
    ["Offset of field: tagIMEMENUITEMINFOW::szString"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, szString) - 36usize];
    ["Offset of field: tagIMEMENUITEMINFOW::hbmpItem"]
        [::std::mem::offset_of!(tagIMEMENUITEMINFOW, hbmpItem) - 200usize];
};
pub type IMEMENUITEMINFOW = tagIMEMENUITEMINFOW;
pub type PIMEMENUITEMINFOW = *mut tagIMEMENUITEMINFOW;
pub type NPIMEMENUITEMINFOW = *mut tagIMEMENUITEMINFOW;
pub type LPIMEMENUITEMINFOW = *mut tagIMEMENUITEMINFOW;
pub type IMEMENUITEMINFO = IMEMENUITEMINFOA;
pub type PIMEMENUITEMINFO = PIMEMENUITEMINFOA;
pub type NPIMEMENUITEMINFO = NPIMEMENUITEMINFOA;
pub type LPIMEMENUITEMINFO = LPIMEMENUITEMINFOA;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tagIMECHARPOSITION {
    pub dwSize: DWORD,
    pub dwCharPos: DWORD,
    pub pt: POINT,
    pub cLineHeight: UINT,
    pub rcDocument: RECT,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tagIMECHARPOSITION"][::std::mem::size_of::<tagIMECHARPOSITION>() - 36usize];
    ["Alignment of tagIMECHARPOSITION"][::std::mem::align_of::<tagIMECHARPOSITION>() - 4usize];
    ["Offset of field: tagIMECHARPOSITION::dwSize"]
        [::std::mem::offset_of!(tagIMECHARPOSITION, dwSize) - 0usize];
    ["Offset of field: tagIMECHARPOSITION::dwCharPos"]
        [::std::mem::offset_of!(tagIMECHARPOSITION, dwCharPos) - 4usize];
    ["Offset of field: tagIMECHARPOSITION::pt"]
        [::std::mem::offset_of!(tagIMECHARPOSITION, pt) - 8usize];
    ["Offset of field: tagIMECHARPOSITION::cLineHeight"]
        [::std::mem::offset_of!(tagIMECHARPOSITION, cLineHeight) - 16usize];
    ["Offset of field: tagIMECHARPOSITION::rcDocument"]
        [::std::mem::offset_of!(tagIMECHARPOSITION, rcDocument) - 20usize];
};
pub type IMECHARPOSITION = tagIMECHARPOSITION;
pub type PIMECHARPOSITION = *mut tagIMECHARPOSITION;
pub type NPIMECHARPOSITION = *mut tagIMECHARPOSITION;
pub type LPIMECHARPOSITION = *mut tagIMECHARPOSITION;
pub type IMCENUMPROC =
    ::std::option::Option<unsafe extern "C" fn(arg1: HIMC, arg2: LPARAM) -> BOOL>;
unsafe extern "C" {
    pub fn ImmInstallIMEA(lpszIMEFileName: LPCSTR, lpszLayoutText: LPCSTR) -> HKL;
}
unsafe extern "C" {
    pub fn ImmInstallIMEW(lpszIMEFileName: LPCWSTR, lpszLayoutText: LPCWSTR) -> HKL;
}
unsafe extern "C" {
    pub fn ImmGetDefaultIMEWnd(arg1: HWND) -> HWND;
}
unsafe extern "C" {
    pub fn ImmGetDescriptionA(arg1: HKL, lpszDescription: LPSTR, uBufLen: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn ImmGetDescriptionW(arg1: HKL, lpszDescription: LPWSTR, uBufLen: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn ImmGetIMEFileNameA(arg1: HKL, lpszFileName: LPSTR, uBufLen: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn ImmGetIMEFileNameW(arg1: HKL, lpszFileName: LPWSTR, uBufLen: UINT) -> UINT;
}
unsafe extern "C" {
    pub fn ImmGetProperty(arg1: HKL, arg2: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmIsIME(arg1: HKL) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSimulateHotKey(arg1: HWND, arg2: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmCreateContext() -> HIMC;
}
unsafe extern "C" {
    pub fn ImmDestroyContext(arg1: HIMC) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetContext(arg1: HWND) -> HIMC;
}
unsafe extern "C" {
    pub fn ImmReleaseContext(arg1: HWND, arg2: HIMC) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmAssociateContext(arg1: HWND, arg2: HIMC) -> HIMC;
}
unsafe extern "C" {
    pub fn ImmAssociateContextEx(arg1: HWND, arg2: HIMC, arg3: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCompositionStringA(
        arg1: HIMC,
        arg2: DWORD,
        lpBuf: LPVOID,
        dwBufLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn ImmGetCompositionStringW(
        arg1: HIMC,
        arg2: DWORD,
        lpBuf: LPVOID,
        dwBufLen: DWORD,
    ) -> LONG;
}
unsafe extern "C" {
    pub fn ImmSetCompositionStringA(
        arg1: HIMC,
        dwIndex: DWORD,
        lpComp: LPVOID,
        dwCompLen: DWORD,
        lpRead: LPVOID,
        dwReadLen: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetCompositionStringW(
        arg1: HIMC,
        dwIndex: DWORD,
        lpComp: LPVOID,
        dwCompLen: DWORD,
        lpRead: LPVOID,
        dwReadLen: DWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCandidateListCountA(arg1: HIMC, lpdwListCount: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetCandidateListCountW(arg1: HIMC, lpdwListCount: LPDWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetCandidateListA(
        arg1: HIMC,
        deIndex: DWORD,
        lpCandList: LPCANDIDATELIST,
        dwBufLen: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetCandidateListW(
        arg1: HIMC,
        deIndex: DWORD,
        lpCandList: LPCANDIDATELIST,
        dwBufLen: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetGuideLineA(arg1: HIMC, dwIndex: DWORD, lpBuf: LPSTR, dwBufLen: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetGuideLineW(arg1: HIMC, dwIndex: DWORD, lpBuf: LPWSTR, dwBufLen: DWORD) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetConversionStatus(
        arg1: HIMC,
        lpfdwConversion: LPDWORD,
        lpfdwSentence: LPDWORD,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetConversionStatus(arg1: HIMC, arg2: DWORD, arg3: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetOpenStatus(arg1: HIMC) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetOpenStatus(arg1: HIMC, arg2: BOOL) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCompositionFontA(arg1: HIMC, lplf: LPLOGFONTA) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCompositionFontW(arg1: HIMC, lplf: LPLOGFONTW) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetCompositionFontA(arg1: HIMC, lplf: LPLOGFONTA) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetCompositionFontW(arg1: HIMC, lplf: LPLOGFONTW) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmConfigureIMEA(arg1: HKL, arg2: HWND, arg3: DWORD, arg4: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmConfigureIMEW(arg1: HKL, arg2: HWND, arg3: DWORD, arg4: LPVOID) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmEscapeA(arg1: HKL, arg2: HIMC, arg3: UINT, arg4: LPVOID) -> LRESULT;
}
unsafe extern "C" {
    pub fn ImmEscapeW(arg1: HKL, arg2: HIMC, arg3: UINT, arg4: LPVOID) -> LRESULT;
}
unsafe extern "C" {
    pub fn ImmGetConversionListA(
        arg1: HKL,
        arg2: HIMC,
        lpSrc: LPCSTR,
        lpDst: LPCANDIDATELIST,
        dwBufLen: DWORD,
        uFlag: UINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetConversionListW(
        arg1: HKL,
        arg2: HIMC,
        lpSrc: LPCWSTR,
        lpDst: LPCANDIDATELIST,
        dwBufLen: DWORD,
        uFlag: UINT,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmNotifyIME(arg1: HIMC, dwAction: DWORD, dwIndex: DWORD, dwValue: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetStatusWindowPos(arg1: HIMC, lpptPos: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetStatusWindowPos(arg1: HIMC, lpptPos: LPPOINT) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCompositionWindow(arg1: HIMC, lpCompForm: LPCOMPOSITIONFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetCompositionWindow(arg1: HIMC, lpCompForm: LPCOMPOSITIONFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetCandidateWindow(arg1: HIMC, arg2: DWORD, lpCandidate: LPCANDIDATEFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmSetCandidateWindow(arg1: HIMC, lpCandidate: LPCANDIDATEFORM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmIsUIMessageA(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmIsUIMessageW(arg1: HWND, arg2: UINT, arg3: WPARAM, arg4: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetVirtualKey(arg1: HWND) -> UINT;
}
pub type REGISTERWORDENUMPROCA = ::std::option::Option<
    unsafe extern "C" fn(
        lpszReading: LPCSTR,
        arg1: DWORD,
        lpszString: LPCSTR,
        arg2: LPVOID,
    ) -> ::std::os::raw::c_int,
>;
pub type REGISTERWORDENUMPROCW = ::std::option::Option<
    unsafe extern "C" fn(
        lpszReading: LPCWSTR,
        arg1: DWORD,
        lpszString: LPCWSTR,
        arg2: LPVOID,
    ) -> ::std::os::raw::c_int,
>;
unsafe extern "C" {
    pub fn ImmRegisterWordA(
        arg1: HKL,
        lpszReading: LPCSTR,
        arg2: DWORD,
        lpszRegister: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmRegisterWordW(
        arg1: HKL,
        lpszReading: LPCWSTR,
        arg2: DWORD,
        lpszRegister: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmUnregisterWordA(
        arg1: HKL,
        lpszReading: LPCSTR,
        arg2: DWORD,
        lpszUnregister: LPCSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmUnregisterWordW(
        arg1: HKL,
        lpszReading: LPCWSTR,
        arg2: DWORD,
        lpszUnregister: LPCWSTR,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetRegisterWordStyleA(arg1: HKL, nItem: UINT, lpStyleBuf: LPSTYLEBUFA) -> UINT;
}
unsafe extern "C" {
    pub fn ImmGetRegisterWordStyleW(arg1: HKL, nItem: UINT, lpStyleBuf: LPSTYLEBUFW) -> UINT;
}
unsafe extern "C" {
    pub fn ImmEnumRegisterWordA(
        arg1: HKL,
        arg2: REGISTERWORDENUMPROCA,
        lpszReading: LPCSTR,
        arg3: DWORD,
        lpszRegister: LPCSTR,
        arg4: LPVOID,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn ImmEnumRegisterWordW(
        arg1: HKL,
        arg2: REGISTERWORDENUMPROCW,
        lpszReading: LPCWSTR,
        arg3: DWORD,
        lpszRegister: LPCWSTR,
        arg4: LPVOID,
    ) -> UINT;
}
unsafe extern "C" {
    pub fn ImmDisableIME(arg1: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmEnumInputContext(idThread: DWORD, lpfn: IMCENUMPROC, lParam: LPARAM) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmGetImeMenuItemsA(
        arg1: HIMC,
        arg2: DWORD,
        arg3: DWORD,
        lpImeParentMenu: LPIMEMENUITEMINFOA,
        lpImeMenu: LPIMEMENUITEMINFOA,
        dwSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmGetImeMenuItemsW(
        arg1: HIMC,
        arg2: DWORD,
        arg3: DWORD,
        lpImeParentMenu: LPIMEMENUITEMINFOW,
        lpImeMenu: LPIMEMENUITEMINFOW,
        dwSize: DWORD,
    ) -> DWORD;
}
unsafe extern "C" {
    pub fn ImmDisableTextFrameService(idThread: DWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn ImmDisableLegacyIME() -> BOOL;
}
pub type QWORD = ::std::os::raw::c_ulonglong;
pub type PQWORD = *mut ::std::os::raw::c_ulonglong;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct LC_CONFIG {
    pub dwVersion: DWORD,
    pub dwPrintfVerbosity: DWORD,
    pub szDevice: [CHAR; 260usize],
    pub szRemote: [CHAR; 260usize],
    pub pfn_printf_opt: ::std::option::Option<
        unsafe extern "C" fn(_Format: *const ::std::os::raw::c_char, ...) -> ::std::os::raw::c_int,
    >,
    pub paMax: QWORD,
    pub fVolatile: BOOL,
    pub fWritable: BOOL,
    pub fRemote: BOOL,
    pub fRemoteDisableCompress: BOOL,
    pub szDeviceName: [CHAR; 260usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of LC_CONFIG"][::std::mem::size_of::<LC_CONFIG>() - 824usize];
    ["Alignment of LC_CONFIG"][::std::mem::align_of::<LC_CONFIG>() - 8usize];
    ["Offset of field: LC_CONFIG::dwVersion"]
        [::std::mem::offset_of!(LC_CONFIG, dwVersion) - 0usize];
    ["Offset of field: LC_CONFIG::dwPrintfVerbosity"]
        [::std::mem::offset_of!(LC_CONFIG, dwPrintfVerbosity) - 4usize];
    ["Offset of field: LC_CONFIG::szDevice"][::std::mem::offset_of!(LC_CONFIG, szDevice) - 8usize];
    ["Offset of field: LC_CONFIG::szRemote"]
        [::std::mem::offset_of!(LC_CONFIG, szRemote) - 268usize];
    ["Offset of field: LC_CONFIG::pfn_printf_opt"]
        [::std::mem::offset_of!(LC_CONFIG, pfn_printf_opt) - 528usize];
    ["Offset of field: LC_CONFIG::paMax"][::std::mem::offset_of!(LC_CONFIG, paMax) - 536usize];
    ["Offset of field: LC_CONFIG::fVolatile"]
        [::std::mem::offset_of!(LC_CONFIG, fVolatile) - 544usize];
    ["Offset of field: LC_CONFIG::fWritable"]
        [::std::mem::offset_of!(LC_CONFIG, fWritable) - 548usize];
    ["Offset of field: LC_CONFIG::fRemote"][::std::mem::offset_of!(LC_CONFIG, fRemote) - 552usize];
    ["Offset of field: LC_CONFIG::fRemoteDisableCompress"]
        [::std::mem::offset_of!(LC_CONFIG, fRemoteDisableCompress) - 556usize];
    ["Offset of field: LC_CONFIG::szDeviceName"]
        [::std::mem::offset_of!(LC_CONFIG, szDeviceName) - 560usize];
};
pub type PLC_CONFIG = *mut LC_CONFIG;
#[repr(C)]
#[derive(Debug)]
pub struct tdLC_CONFIG_ERRORINFO {
    pub dwVersion: DWORD,
    pub cbStruct: DWORD,
    pub _FutureUse: [DWORD; 16usize],
    pub fUserInputRequest: BOOL,
    pub cwszUserText: DWORD,
    pub wszUserText: __IncompleteArrayField<WCHAR>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_CONFIG_ERRORINFO"][::std::mem::size_of::<tdLC_CONFIG_ERRORINFO>() - 80usize];
    ["Alignment of tdLC_CONFIG_ERRORINFO"]
        [::std::mem::align_of::<tdLC_CONFIG_ERRORINFO>() - 4usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::dwVersion"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, dwVersion) - 0usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::cbStruct"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, cbStruct) - 4usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::_FutureUse"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, _FutureUse) - 8usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::fUserInputRequest"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, fUserInputRequest) - 72usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::cwszUserText"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, cwszUserText) - 76usize];
    ["Offset of field: tdLC_CONFIG_ERRORINFO::wszUserText"]
        [::std::mem::offset_of!(tdLC_CONFIG_ERRORINFO, wszUserText) - 80usize];
};
pub type LC_CONFIG_ERRORINFO = tdLC_CONFIG_ERRORINFO;
pub type PLC_CONFIG_ERRORINFO = *mut tdLC_CONFIG_ERRORINFO;
pub type PPLC_CONFIG_ERRORINFO = *mut *mut tdLC_CONFIG_ERRORINFO;
unsafe extern "C" {
    pub fn LcCreate(pLcCreateConfig: PLC_CONFIG) -> HANDLE;
}
unsafe extern "C" {
    pub fn LcCreateEx(
        pLcCreateConfig: PLC_CONFIG,
        ppLcCreateErrorInfo: PPLC_CONFIG_ERRORINFO,
    ) -> HANDLE;
}
unsafe extern "C" {
    pub fn LcClose(hLC: HANDLE);
}
#[repr(C)]
#[derive(Copy, Clone)]
pub struct tdMEM_SCATTER {
    pub version: DWORD,
    pub f: BOOL,
    pub qwA: QWORD,
    pub __bindgen_anon_1: tdMEM_SCATTER__bindgen_ty_1,
    pub cb: DWORD,
    pub iStack: DWORD,
    pub vStack: [QWORD; 12usize],
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tdMEM_SCATTER__bindgen_ty_1 {
    pub pb: PBYTE,
    pub _Filler: QWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdMEM_SCATTER__bindgen_ty_1"]
        [::std::mem::size_of::<tdMEM_SCATTER__bindgen_ty_1>() - 8usize];
    ["Alignment of tdMEM_SCATTER__bindgen_ty_1"]
        [::std::mem::align_of::<tdMEM_SCATTER__bindgen_ty_1>() - 8usize];
    ["Offset of field: tdMEM_SCATTER__bindgen_ty_1::pb"]
        [::std::mem::offset_of!(tdMEM_SCATTER__bindgen_ty_1, pb) - 0usize];
    ["Offset of field: tdMEM_SCATTER__bindgen_ty_1::_Filler"]
        [::std::mem::offset_of!(tdMEM_SCATTER__bindgen_ty_1, _Filler) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdMEM_SCATTER"][::std::mem::size_of::<tdMEM_SCATTER>() - 128usize];
    ["Alignment of tdMEM_SCATTER"][::std::mem::align_of::<tdMEM_SCATTER>() - 8usize];
    ["Offset of field: tdMEM_SCATTER::version"]
        [::std::mem::offset_of!(tdMEM_SCATTER, version) - 0usize];
    ["Offset of field: tdMEM_SCATTER::f"][::std::mem::offset_of!(tdMEM_SCATTER, f) - 4usize];
    ["Offset of field: tdMEM_SCATTER::qwA"][::std::mem::offset_of!(tdMEM_SCATTER, qwA) - 8usize];
    ["Offset of field: tdMEM_SCATTER::cb"][::std::mem::offset_of!(tdMEM_SCATTER, cb) - 24usize];
    ["Offset of field: tdMEM_SCATTER::iStack"]
        [::std::mem::offset_of!(tdMEM_SCATTER, iStack) - 28usize];
    ["Offset of field: tdMEM_SCATTER::vStack"]
        [::std::mem::offset_of!(tdMEM_SCATTER, vStack) - 32usize];
};
pub type MEM_SCATTER = tdMEM_SCATTER;
pub type PMEM_SCATTER = *mut tdMEM_SCATTER;
pub type PPMEM_SCATTER = *mut *mut tdMEM_SCATTER;
unsafe extern "C" {
    pub fn LcMemFree(pv: PVOID);
}
unsafe extern "C" {
    pub fn LcAllocScatter1(cMEMs: DWORD, pppMEMs: *mut PPMEM_SCATTER) -> BOOL;
}
unsafe extern "C" {
    pub fn LcAllocScatter2(
        cbData: DWORD,
        pbData: PBYTE,
        cMEMs: DWORD,
        pppMEMs: *mut PPMEM_SCATTER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LcAllocScatter3(
        pbDataFirstPage: PBYTE,
        pbDataLastPage: PBYTE,
        cbData: DWORD,
        pbData: PBYTE,
        cMEMs: DWORD,
        pppMEMs: *mut PPMEM_SCATTER,
    ) -> BOOL;
}
unsafe extern "C" {
    pub fn LcReadScatter(hLC: HANDLE, cMEMs: DWORD, ppMEMs: PPMEM_SCATTER);
}
unsafe extern "C" {
    pub fn LcRead(hLC: HANDLE, pa: QWORD, cb: DWORD, pb: PBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn LcWriteScatter(hLC: HANDLE, cMEMs: DWORD, ppMEMs: PPMEM_SCATTER);
}
unsafe extern "C" {
    pub fn LcWrite(hLC: HANDLE, pa: QWORD, cb: DWORD, pb: PBYTE) -> BOOL;
}
unsafe extern "C" {
    pub fn LcGetOption(hLC: HANDLE, fOption: QWORD, pqwValue: PQWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn LcSetOption(hLC: HANDLE, fOption: QWORD, qwValue: QWORD) -> BOOL;
}
unsafe extern "C" {
    pub fn LcCommand(
        hLC: HANDLE,
        fCommand: QWORD,
        cbDataIn: DWORD,
        pbDataIn: PBYTE,
        ppbDataOut: *mut PBYTE,
        pcbDataOut: PDWORD,
    ) -> BOOL;
}
#[repr(C)]
pub struct tdLC_CMD_AGENT_VFS_REQ {
    pub dwVersion: DWORD,
    pub _FutureUse: DWORD,
    pub uszPathFile: [CHAR; 520usize],
    pub __bindgen_anon_1: tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1,
    pub dwLength: DWORD,
    pub cb: DWORD,
    pub pb: __IncompleteArrayField<BYTE>,
}
#[repr(C)]
#[derive(Copy, Clone)]
pub union tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1 {
    pub qwOffset: QWORD,
    pub fOption: QWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1"]
        [::std::mem::size_of::<tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1>() - 8usize];
    ["Alignment of tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1"]
        [::std::mem::align_of::<tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1>() - 8usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1::qwOffset"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1, qwOffset) - 0usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1::fOption"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ__bindgen_ty_1, fOption) - 0usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_CMD_AGENT_VFS_REQ"][::std::mem::size_of::<tdLC_CMD_AGENT_VFS_REQ>() - 544usize];
    ["Alignment of tdLC_CMD_AGENT_VFS_REQ"]
        [::std::mem::align_of::<tdLC_CMD_AGENT_VFS_REQ>() - 8usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::dwVersion"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, dwVersion) - 0usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::_FutureUse"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, _FutureUse) - 4usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::uszPathFile"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, uszPathFile) - 8usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::dwLength"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, dwLength) - 536usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::cb"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, cb) - 540usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_REQ::pb"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_REQ, pb) - 544usize];
};
pub type LC_CMD_AGENT_VFS_REQ = tdLC_CMD_AGENT_VFS_REQ;
pub type PLC_CMD_AGENT_VFS_REQ = *mut tdLC_CMD_AGENT_VFS_REQ;
#[repr(C)]
#[derive(Debug)]
pub struct tdLC_CMD_AGENT_VFS_RSP {
    pub dwVersion: DWORD,
    pub dwStatus: DWORD,
    pub cbReadWrite: DWORD,
    pub _FutureUse: [DWORD; 2usize],
    pub cb: DWORD,
    pub pb: __IncompleteArrayField<BYTE>,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_CMD_AGENT_VFS_RSP"][::std::mem::size_of::<tdLC_CMD_AGENT_VFS_RSP>() - 24usize];
    ["Alignment of tdLC_CMD_AGENT_VFS_RSP"]
        [::std::mem::align_of::<tdLC_CMD_AGENT_VFS_RSP>() - 4usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::dwVersion"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, dwVersion) - 0usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::dwStatus"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, dwStatus) - 4usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::cbReadWrite"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, cbReadWrite) - 8usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::_FutureUse"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, _FutureUse) - 12usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::cb"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, cb) - 20usize];
    ["Offset of field: tdLC_CMD_AGENT_VFS_RSP::pb"]
        [::std::mem::offset_of!(tdLC_CMD_AGENT_VFS_RSP, pb) - 24usize];
};
pub type LC_CMD_AGENT_VFS_RSP = tdLC_CMD_AGENT_VFS_RSP;
pub type PLC_CMD_AGENT_VFS_RSP = *mut tdLC_CMD_AGENT_VFS_RSP;
unsafe extern "C" {
    pub static mut LC_STATISTICS_NAME: [LPCSTR; 8usize];
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_STATISTICS {
    pub dwVersion: DWORD,
    pub _Reserved: DWORD,
    pub qwFreq: QWORD,
    pub Call: [tdLC_STATISTICS__bindgen_ty_1; 8usize],
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_STATISTICS__bindgen_ty_1 {
    pub c: QWORD,
    pub tm: QWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_STATISTICS__bindgen_ty_1"]
        [::std::mem::size_of::<tdLC_STATISTICS__bindgen_ty_1>() - 16usize];
    ["Alignment of tdLC_STATISTICS__bindgen_ty_1"]
        [::std::mem::align_of::<tdLC_STATISTICS__bindgen_ty_1>() - 8usize];
    ["Offset of field: tdLC_STATISTICS__bindgen_ty_1::c"]
        [::std::mem::offset_of!(tdLC_STATISTICS__bindgen_ty_1, c) - 0usize];
    ["Offset of field: tdLC_STATISTICS__bindgen_ty_1::tm"]
        [::std::mem::offset_of!(tdLC_STATISTICS__bindgen_ty_1, tm) - 8usize];
};
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_STATISTICS"][::std::mem::size_of::<tdLC_STATISTICS>() - 144usize];
    ["Alignment of tdLC_STATISTICS"][::std::mem::align_of::<tdLC_STATISTICS>() - 8usize];
    ["Offset of field: tdLC_STATISTICS::dwVersion"]
        [::std::mem::offset_of!(tdLC_STATISTICS, dwVersion) - 0usize];
    ["Offset of field: tdLC_STATISTICS::_Reserved"]
        [::std::mem::offset_of!(tdLC_STATISTICS, _Reserved) - 4usize];
    ["Offset of field: tdLC_STATISTICS::qwFreq"]
        [::std::mem::offset_of!(tdLC_STATISTICS, qwFreq) - 8usize];
    ["Offset of field: tdLC_STATISTICS::Call"]
        [::std::mem::offset_of!(tdLC_STATISTICS, Call) - 16usize];
};
pub type LC_STATISTICS = tdLC_STATISTICS;
pub type PLC_STATISTICS = *mut tdLC_STATISTICS;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_MEMMAP_ENTRY {
    pub pa: QWORD,
    pub cb: QWORD,
    pub paRemap: QWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_MEMMAP_ENTRY"][::std::mem::size_of::<tdLC_MEMMAP_ENTRY>() - 24usize];
    ["Alignment of tdLC_MEMMAP_ENTRY"][::std::mem::align_of::<tdLC_MEMMAP_ENTRY>() - 8usize];
    ["Offset of field: tdLC_MEMMAP_ENTRY::pa"]
        [::std::mem::offset_of!(tdLC_MEMMAP_ENTRY, pa) - 0usize];
    ["Offset of field: tdLC_MEMMAP_ENTRY::cb"]
        [::std::mem::offset_of!(tdLC_MEMMAP_ENTRY, cb) - 8usize];
    ["Offset of field: tdLC_MEMMAP_ENTRY::paRemap"]
        [::std::mem::offset_of!(tdLC_MEMMAP_ENTRY, paRemap) - 16usize];
};
pub type LC_MEMMAP_ENTRY = tdLC_MEMMAP_ENTRY;
pub type PLC_MEMMAP_ENTRY = *mut tdLC_MEMMAP_ENTRY;
pub const tdLC_ARCH_TP_LC_ARCH_NA: tdLC_ARCH_TP = 0;
pub const tdLC_ARCH_TP_LC_ARCH_X86: tdLC_ARCH_TP = 1;
pub const tdLC_ARCH_TP_LC_ARCH_X86PAE: tdLC_ARCH_TP = 2;
pub const tdLC_ARCH_TP_LC_ARCH_X64: tdLC_ARCH_TP = 3;
pub const tdLC_ARCH_TP_LC_ARCH_ARM64: tdLC_ARCH_TP = 4;
pub type tdLC_ARCH_TP = ::std::os::raw::c_int;
pub use self::tdLC_ARCH_TP as LC_ARCH_TP;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_TLP {
    pub cb: DWORD,
    pub _Reserved1: DWORD,
    pub pb: PBYTE,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_TLP"][::std::mem::size_of::<tdLC_TLP>() - 16usize];
    ["Alignment of tdLC_TLP"][::std::mem::align_of::<tdLC_TLP>() - 8usize];
    ["Offset of field: tdLC_TLP::cb"][::std::mem::offset_of!(tdLC_TLP, cb) - 0usize];
    ["Offset of field: tdLC_TLP::_Reserved1"]
        [::std::mem::offset_of!(tdLC_TLP, _Reserved1) - 4usize];
    ["Offset of field: tdLC_TLP::pb"][::std::mem::offset_of!(tdLC_TLP, pb) - 8usize];
};
pub type LC_TLP = tdLC_TLP;
pub type PLC_TLP = *mut tdLC_TLP;
pub type PLC_TLP_FUNCTION_CALLBACK = ::std::option::Option<
    unsafe extern "C" fn(ctx: PVOID, cbTlp: DWORD, pbTlp: PBYTE, cbInfo: DWORD, szInfo: LPSTR),
>;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_VMM {
    pub dwVersion: DWORD,
    pub hVMM: HANDLE,
    pub hVMMVM: HANDLE,
    pub pfnVMMDLL_ConfigGet: PVOID,
    pub pfnVMMDLL_VmMemReadScatter: PVOID,
    pub pfnVMMDLL_VmMemWriteScatter: PVOID,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_VMM"][::std::mem::size_of::<tdLC_VMM>() - 48usize];
    ["Alignment of tdLC_VMM"][::std::mem::align_of::<tdLC_VMM>() - 8usize];
    ["Offset of field: tdLC_VMM::dwVersion"][::std::mem::offset_of!(tdLC_VMM, dwVersion) - 0usize];
    ["Offset of field: tdLC_VMM::hVMM"][::std::mem::offset_of!(tdLC_VMM, hVMM) - 8usize];
    ["Offset of field: tdLC_VMM::hVMMVM"][::std::mem::offset_of!(tdLC_VMM, hVMMVM) - 16usize];
    ["Offset of field: tdLC_VMM::pfnVMMDLL_ConfigGet"]
        [::std::mem::offset_of!(tdLC_VMM, pfnVMMDLL_ConfigGet) - 24usize];
    ["Offset of field: tdLC_VMM::pfnVMMDLL_VmMemReadScatter"]
        [::std::mem::offset_of!(tdLC_VMM, pfnVMMDLL_VmMemReadScatter) - 32usize];
    ["Offset of field: tdLC_VMM::pfnVMMDLL_VmMemWriteScatter"]
        [::std::mem::offset_of!(tdLC_VMM, pfnVMMDLL_VmMemWriteScatter) - 40usize];
};
pub type LC_VMM = tdLC_VMM;
pub type PLC_VMM = *mut tdLC_VMM;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_BAR {
    pub fValid: BOOL,
    pub fIO: BOOL,
    pub f64Bit: BOOL,
    pub fPrefetchable: BOOL,
    pub _Filler: [DWORD; 3usize],
    pub iBar: DWORD,
    pub pa: QWORD,
    pub cb: QWORD,
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_BAR"][::std::mem::size_of::<tdLC_BAR>() - 48usize];
    ["Alignment of tdLC_BAR"][::std::mem::align_of::<tdLC_BAR>() - 8usize];
    ["Offset of field: tdLC_BAR::fValid"][::std::mem::offset_of!(tdLC_BAR, fValid) - 0usize];
    ["Offset of field: tdLC_BAR::fIO"][::std::mem::offset_of!(tdLC_BAR, fIO) - 4usize];
    ["Offset of field: tdLC_BAR::f64Bit"][::std::mem::offset_of!(tdLC_BAR, f64Bit) - 8usize];
    ["Offset of field: tdLC_BAR::fPrefetchable"]
        [::std::mem::offset_of!(tdLC_BAR, fPrefetchable) - 12usize];
    ["Offset of field: tdLC_BAR::_Filler"][::std::mem::offset_of!(tdLC_BAR, _Filler) - 16usize];
    ["Offset of field: tdLC_BAR::iBar"][::std::mem::offset_of!(tdLC_BAR, iBar) - 28usize];
    ["Offset of field: tdLC_BAR::pa"][::std::mem::offset_of!(tdLC_BAR, pa) - 32usize];
    ["Offset of field: tdLC_BAR::cb"][::std::mem::offset_of!(tdLC_BAR, cb) - 40usize];
};
pub type LC_BAR = tdLC_BAR;
pub type PLC_BAR = *mut tdLC_BAR;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct tdLC_BAR_REQUEST {
    pub ctx: PVOID,
    pub pBar: PLC_BAR,
    pub bTag: BYTE,
    pub bFirstBE: BYTE,
    pub bLastBE: BYTE,
    pub _Filler: BYTE,
    pub f64_: BOOL,
    pub fRead: BOOL,
    pub fReadReply: BOOL,
    pub fWrite: BOOL,
    pub cbData: DWORD,
    pub oData: QWORD,
    pub pbData: [BYTE; 4096usize],
}
#[allow(clippy::unnecessary_operation, clippy::identity_op)]
const _: () = {
    ["Size of tdLC_BAR_REQUEST"][::std::mem::size_of::<tdLC_BAR_REQUEST>() - 4144usize];
    ["Alignment of tdLC_BAR_REQUEST"][::std::mem::align_of::<tdLC_BAR_REQUEST>() - 8usize];
    ["Offset of field: tdLC_BAR_REQUEST::ctx"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, ctx) - 0usize];
    ["Offset of field: tdLC_BAR_REQUEST::pBar"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, pBar) - 8usize];
    ["Offset of field: tdLC_BAR_REQUEST::bTag"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, bTag) - 16usize];
    ["Offset of field: tdLC_BAR_REQUEST::bFirstBE"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, bFirstBE) - 17usize];
    ["Offset of field: tdLC_BAR_REQUEST::bLastBE"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, bLastBE) - 18usize];
    ["Offset of field: tdLC_BAR_REQUEST::_Filler"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, _Filler) - 19usize];
    ["Offset of field: tdLC_BAR_REQUEST::f64_"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, f64_) - 20usize];
    ["Offset of field: tdLC_BAR_REQUEST::fRead"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, fRead) - 24usize];
    ["Offset of field: tdLC_BAR_REQUEST::fReadReply"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, fReadReply) - 28usize];
    ["Offset of field: tdLC_BAR_REQUEST::fWrite"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, fWrite) - 32usize];
    ["Offset of field: tdLC_BAR_REQUEST::cbData"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, cbData) - 36usize];
    ["Offset of field: tdLC_BAR_REQUEST::oData"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, oData) - 40usize];
    ["Offset of field: tdLC_BAR_REQUEST::pbData"]
        [::std::mem::offset_of!(tdLC_BAR_REQUEST, pbData) - 48usize];
};
pub type LC_BAR_REQUEST = tdLC_BAR_REQUEST;
pub type PLC_BAR_REQUEST = *mut tdLC_BAR_REQUEST;
pub type PLC_BAR_FUNCTION_CALLBACK =
    ::std::option::Option<unsafe extern "C" fn(pBarRequest: PLC_BAR_REQUEST)>;
pub type __builtin_va_list = *mut ::std::os::raw::c_char;
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __crt_locale_data {
    pub _address: u8,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct __crt_multibyte_data {
    pub _address: u8,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct _ACTIVATION_CONTEXT {
    pub _address: u8,
}
#[repr(C)]
#[derive(Debug, Copy, Clone)]
pub struct NET_ADDRESS_INFO_ {
    pub _address: u8,
}
